-- MySQL dump 10.13  Distrib 5.7.28, for Linux (x86_64)
--
-- Host: localhost    Database: crossmatch_catalogues
-- ------------------------------------------------------
-- Server version	5.7.28

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `tcs_cat_ned_d_v13_1_0`
--

DROP TABLE IF EXISTS `tcs_cat_ned_d_v13_1_0`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `tcs_cat_ned_d_v13_1_0` (
  `primaryId` bigint(20) NOT NULL AUTO_INCREMENT COMMENT 'An internal counter',
  `Method` varchar(150) DEFAULT NULL,
  `dateCreated` datetime DEFAULT CURRENT_TIMESTAMP,
  `dateLastModified` datetime DEFAULT CURRENT_TIMESTAMP,
  `updated` varchar(45) DEFAULT '0',
  `dist_derived_from_sn` varchar(150) DEFAULT NULL,
  `dist_in_ned_flag` varchar(10) DEFAULT NULL,
  `dist_index_id` mediumint(9) DEFAULT NULL,
  `dist_mod` double DEFAULT NULL,
  `dist_mod_err` double DEFAULT NULL,
  `dist_mpc` double DEFAULT NULL,
  `galaxy_index_id` mediumint(9) DEFAULT NULL,
  `hubble_const` double DEFAULT NULL,
  `lmc_mod` double DEFAULT NULL,
  `notes` varchar(500) DEFAULT NULL,
  `primary_ned_id` varchar(150) DEFAULT NULL,
  `redshift` double DEFAULT NULL,
  `ref` varchar(150) DEFAULT NULL,
  `ref_date` int(11) DEFAULT NULL,
  `master_row` tinyint(4) DEFAULT '0',
  `major_diameter_arcmin` double DEFAULT NULL,
  `ned_notes` varchar(700) DEFAULT NULL,
  `object_type` varchar(100) DEFAULT NULL,
  `redshift_err` double DEFAULT NULL,
  `redshift_quality` varchar(100) DEFAULT NULL,
  `magnitude_filter` varchar(10) DEFAULT NULL,
  `minor_diameter_arcmin` double DEFAULT NULL,
  `morphology` varchar(50) DEFAULT NULL,
  `hierarchy` varchar(50) DEFAULT NULL,
  `galaxy_morphology` varchar(50) DEFAULT NULL,
  `radio_morphology` varchar(50) DEFAULT NULL,
  `activity_type` varchar(50) DEFAULT NULL,
  `in_ned` tinyint(4) DEFAULT NULL,
  `raDeg` double DEFAULT NULL,
  `decDeg` double DEFAULT NULL,
  `eb_v` double DEFAULT NULL,
  `sdss_coverage` tinyint(4) DEFAULT NULL,
  `htm16ID` bigint(20) DEFAULT NULL,
  `htm13ID` int(11) DEFAULT NULL,
  `htm10ID` int(11) DEFAULT NULL,
  `magnitude` double DEFAULT NULL,
  PRIMARY KEY (`primaryId`),
  UNIQUE KEY `galaxy_index_id_dist_index_id` (`galaxy_index_id`,`dist_index_id`),
  KEY `idx_htm10ID` (`htm10ID`),
  KEY `idx_htm13ID` (`htm13ID`),
  KEY `idx_htm16ID` (`htm16ID`),
  KEY `idx_dist` (`dist_mpc`),
  KEY `idx_redshift` (`redshift`),
  KEY `idx_major_diameter` (`major_diameter_arcmin`),
  KEY `idx_master_name` (`master_row`),
  KEY `idx_magnitude` (`magnitude`),
  KEY `idx_in_ned` (`in_ned`),
  KEY `idx_type` (`object_type`),
  KEY `idx_dist_from_sn` (`dist_derived_from_sn`)
) ENGINE=MyISAM AUTO_INCREMENT=166025 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tcs_cat_ned_d_v13_1_0`
--

LOCK TABLES `tcs_cat_ned_d_v13_1_0` WRITE;
/*!40000 ALTER TABLE `tcs_cat_ned_d_v13_1_0` DISABLE KEYS */;
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (1,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 13651','RN',1,41.64,0.17,1700,1,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13651',0.249917,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 13651','RN',2,42.1,0.21,2110,1,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13651',0.249917,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,3,34.16,0.4,68,2,NULL,NULL,'mean','UGC 12889',NULL,'2007A&A...465...71T',2007,1,2.1,NULL,'G',0.00003,NULL,'13.4',1.8,'SB(rs)b','in a pair',NULL,NULL,NULL,1,0.00695833333333,47.27478,0.481,NULL,65768857836,1027638403,16056850,13.4),(4,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,4,34.66,0.45,85.6,2,NULL,NULL,'K','UGC 12889',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,5,34.68,0.47,86.1,2,NULL,NULL,'H','UGC 12889',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,6,34.7,0.46,86.9,2,NULL,NULL,'J','UGC 12889',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,7,33.52,0.2,50.6,3,74.4,NULL,NULL,'KUG 2357+228',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000007,NULL,'16:',0.2,'Spiral',NULL,NULL,NULL,NULL,1,0.014625,23.08753,0.149,NULL,67176111066,1049626735,16400417,16),(8,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,8,33.73,0.37,55.8,3,NULL,NULL,NULL,'KUG 2357+228',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,9,34.11,0.31,66.3,3,NULL,NULL,'Malmquist cor.','KUG 2357+228',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,10,35.65,0.2,135,4,74.4,NULL,NULL,'KUG 2357+257',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000013,NULL,'16  :',0.3,'Spiral',NULL,NULL,NULL,NULL,1,0.0150833333333,26.01378,0.129,NULL,67186262239,1049785347,16402896,16),(11,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 14480',NULL,11,40.19,0.3,1090,5,70,NULL,'SN photometric redshift distance, z photo =0.298 +/- 0.054','SDSS-II SN 14480',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','22.3g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,0.0175417,0.02294,0.105,NULL,66571993739,1040187402,16252928,22.3),(12,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 14480','R',12,41.2,0.33,1300,5,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14480',0.330796,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 14480','R',13,41.3,0.32,1370,5,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14480',0.330796,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 14480',NULL,14,41.07,0.22,1640,5,70,NULL,'SALT 2','SDSS-II SN 14480',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 14480',NULL,15,41.11,0.22,1670,5,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14480',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',16,34.91,0.46,96.1,6,70,NULL,NULL,'ARK 590',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000107,NULL,'15.6',0.2,'E','Pair member (points to parent)',NULL,NULL,NULL,1,0.0185,-0.08336,0.105,NULL,34359752829,536871137,8388611,15.6),(17,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',17,38.12,0.46,420,7,70,NULL,NULL,'2MASX J00000735+1354360',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000142,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,0.030625,13.91017,0.129,NULL,66725093145,1042579580,16290305,18.3),(18,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',18,34.63,0.49,84.3,8,75,NULL,'IR','MCG -01-01-016',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000027,NULL,'14',0.3,'Sa pec?',NULL,NULL,NULL,NULL,1,0.036,-6.374,0.086,NULL,34385298716,537270292,8394848,14),(19,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',19,37.31,0.33,289,9,70,NULL,NULL,'2MASX J00001412-1028463',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000094,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,0.0587083,-10.47942,0.091,NULL,34377107298,537142301,8392848,17.1),(20,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,20,34.09,0.43,65.8,10,75,NULL,'3.6 micron, color + selection bias corrected','2MFGC 00003',NULL,'2014MNRAS.444..527S',2014,1,0.89,NULL,'G',NULL,NULL,'11.9K',0.11,'Spiral LSB',NULL,NULL,NULL,NULL,1,0.05975,70.033,NULL,NULL,65567476511,1024491820,16007684,11.9),(21,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,21,36.21,0.65,175,11,70,NULL,NULL,'2MASX J00001440-7652248',NULL,'2014MNRAS.445.2677S',2014,1,0.81,NULL,'G',0.00015,NULL,'17.0b',0.24,NULL,NULL,NULL,NULL,NULL,1,0.0598333333333,-76.87364,0.217,NULL,35586991773,556046746,8688230,17),(22,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 03872','RN',22,43.11,0.34,2950,12,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 03872',0.416837,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 03872','RN',23,44.58,0.49,5820,12,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 03872',0.416837,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 03706','RN',24,43.55,0.28,3560,13,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03706',0.440239,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 03706','RN',25,43.64,0.36,3720,13,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03706',0.440239,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,26,35.6,0.48,132,14,70,NULL,NULL,'2MASX J00002213-0137463',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'16.69',0.2,NULL,NULL,NULL,NULL,NULL,1,0.0922917,-1.62947,0.069,NULL,34361334334,536895848,8388997,16.69),(27,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,27,29.64,NULL,8.47,15,NULL,NULL,NULL,'UGC 12894',NULL,'2013AJ....145..101K',2013,1,0.9,NULL,'G',0.000013,NULL,'17.',0.9,'Im',NULL,NULL,NULL,NULL,1,0.0939583,39.49542,0.433,NULL,67113068615,1048641697,16385026,17),(28,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,28,35.86,0.54,149,16,70,NULL,NULL,'MCG -01-01-018',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.0001,NULL,'14.5',0.3,NULL,NULL,NULL,NULL,NULL,1,0.0979583333333,-6.93625,0.103,NULL,34388583470,537321616,8395650,14.5),(29,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,29,36.2,0.53,174,17,70,NULL,NULL,'2MFGC 00007',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.28',0.2,'S',NULL,NULL,NULL,NULL,1,0.1045417,-26.0445,0.047,NULL,34769089693,543267026,8488547,16.28),(30,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',30,37.58,0.46,328,18,70,NULL,NULL,'SDSS J000027.97-002653.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000078,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,0.116583,-0.44819,0.093,NULL,34359868155,536872939,8388639,17.9),(31,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',31,37.9,0.46,380,19,70,NULL,NULL,'2MASX J00003098+1535090',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,0.1289583,15.58594,0.069,NULL,66731704173,1042682877,16291919,17.6),(32,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',32,37.23,0.46,279,20,70,NULL,NULL,'2MASX J00003136-0927563',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000077,NULL,'17.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,0.1307083,-9.46558,0.101,NULL,34379094679,537173354,8393333,17.2),(33,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,33,35.43,0.58,122,21,70,NULL,NULL,'CGCG 382-017',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000033,NULL,'15.3',0.45,'poss. LINER?',NULL,NULL,NULL,NULL,1,0.1485,-1.76317,0.069,NULL,34361418120,536897158,8389018,15.3),(34,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,34,36.88,0.77,238,22,70,NULL,NULL,'ESO 293-IG 028 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.28,NULL,'G',0.00015,NULL,'16.98',0.12,NULL,NULL,NULL,NULL,NULL,1,0.1489583,-40.57561,NULL,NULL,34636889595,541201399,8456271,16.98),(35,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,35,34.34,0.2,73.8,23,74.4,NULL,NULL,'UGC 12898',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000033,NULL,'16.5',0.4,'Scd:',NULL,NULL,NULL,NULL,1,0.156,33.60128,0.169,NULL,67209538004,1050149031,16408578,16.5),(36,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,36,34.61,0.47,83.5,23,NULL,NULL,NULL,'UGC 12898',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,37,34.62,0.47,84.1,23,NULL,NULL,'Malmquist cor.','UGC 12898',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38,'IRAS','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,38,35.3,0.8,115,24,75,NULL,'W91PP, r','UGC 12897',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.00003,NULL,'14.84',0.4,'Sab','in a triple',NULL,NULL,NULL,1,0.158083333333,28.38456,0.145,NULL,67213941110,1050217829,16409653,14.84),(39,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,39,35.42,0.38,121,24,75,NULL,'W91PP, r, raw','UGC 12897',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,40,35.49,0.4,125,24,NULL,NULL,'mean','UGC 12897',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,41,35.51,0.46,127,24,NULL,NULL,'J','UGC 12897',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,42,35.53,0.47,128,24,NULL,NULL,'H','UGC 12897',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,43,35.58,0.45,131,24,NULL,NULL,'K','UGC 12897',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,44,35.6,0.38,132,24,75,NULL,'W91PP, r, cor','UGC 12897',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,45,35.74,0.38,141,24,75,NULL,'W91PP, r, inv','UGC 12897',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',46,36.16,0.46,171,25,70,NULL,NULL,'2MASX J00003983-1109277',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000083,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,0.166083,-11.15769,0.107,NULL,34594630489,540541101,8445954,16.8),(47,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',47,37.92,0.46,384,26,70,NULL,NULL,'2MASX J00004004+1433070',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000211,NULL,'16.1g',0.41,'BrClG',NULL,NULL,NULL,NULL,1,0.166833,14.55214,0.081,NULL,66732611915,1042697061,16292141,16.1),(48,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',48,38.33,0.33,464,27,70,NULL,NULL,'SDSS J000040.27+005634.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000076,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,0.167833,0.94281,0.101,NULL,66572752478,1040199257,16253113,18.3),(49,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',49,36.45,0.46,195,28,70,NULL,NULL,'2MASX J00004214+0001357',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,0.175625,0.02664,0.093,NULL,66572050820,1040188294,16252942,17.4),(50,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,50,36.07,0.56,164,29,70,NULL,NULL,'2MASX J00004283-7217148',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.2b',0.33,NULL,NULL,NULL,NULL,NULL,1,0.178333,-72.28742,0.117,NULL,35572536865,555820888,8684701,16.2),(51,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',51,37.88,0.33,376,30,70,NULL,NULL,'2MASX J00004518+0004329',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,0.18825,0.07586,0.093,NULL,66572021859,1040187841,16252935,18.1),(52,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,52,36.3,0.6,182,31,70,NULL,NULL,'AM 2358-821 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.6b',0.22,NULL,NULL,NULL,NULL,NULL,1,0.191667,-81.96753,0.393,NULL,35473428272,554272316,8660504,16.6),(53,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',53,37.88,0.33,376,32,70,NULL,NULL,'2MASX J00004634+0003548',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000081,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,0.193,0.06525,0.093,NULL,66572020548,1040187821,16252934,17.3),(54,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',54,38.33,0.33,464,33,70,NULL,NULL,'2MASX J00005154+0053239',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000075,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,0.214833333333,0.88997,0.101,NULL,66572771048,1040199547,16253117,17.6),(55,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,55,36.79,0.57,228,34,70,NULL,NULL,'QP 085',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'14.2R',0.33,NULL,NULL,NULL,NULL,NULL,1,0.218041666667,-35.84367,NULL,NULL,34663634604,541619290,8462801,14.2),(56,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,56,36.39,0.54,190,35,70,NULL,NULL,'QP 086',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'14.5R',0.32,NULL,NULL,NULL,NULL,NULL,1,0.221625,-35.98631,NULL,NULL,34662971414,541608928,8462639,14.5),(57,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',57,37.19,0.46,274,36,70,NULL,NULL,'2MASX J00005350-0106551',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000074,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,0.2229583,-1.11528,0.085,NULL,34360032581,536875509,8388679,17.3),(58,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',58,38.98,0.46,624,37,70,NULL,NULL,'SDSS J000055.69+140106.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,0.232083,14.01842,0.153,NULL,66736675101,1042760548,16293133,18.1),(59,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,59,36.48,0.51,198,38,70,NULL,NULL,'2MASX J00005579-2554210',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'16.39',0.4,NULL,NULL,NULL,NULL,NULL,1,0.232375,-25.90581,0.047,NULL,34769657513,543275898,8488685,16.39),(60,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',60,34.76,0.49,89.4,39,75,NULL,'IR','UGC 12900',NULL,'2011yCatp016004901K',2011,1,2.02,NULL,'G',0.000009,NULL,'15.50',0.17,'Sc',NULL,NULL,NULL,NULL,1,0.2334583,20.338,0.249,NULL,66708168629,1042315134,16286173,15.5),(61,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,61,34.82,NULL,92.1,39,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12900',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,62,34.83,NULL,92.5,39,NULL,NULL,'Dipole + Quadrupole','UGC 12900',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,63,34.83,NULL,92.6,39,NULL,NULL,'Dipole','UGC 12900',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,64,34.87,NULL,94.4,39,NULL,NULL,NULL,'UGC 12900',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,65,35.23,0.42,111,39,NULL,NULL,'Malmquist cor.','UGC 12900',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,66,35.35,0.2,117,39,74.4,NULL,NULL,'UGC 12900',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,67,35.43,0.39,122,39,NULL,NULL,NULL,'UGC 12900',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',68,37.98,0.46,394,40,70,NULL,NULL,'2MASX J00005758+1516420',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000145,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,0.239875,15.27825,0.049,NULL,66735075126,1042735548,16292742,18.2),(69,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,69,32.89,1.28,37.8,41,NULL,NULL,'Malmquist cor.','ESO 349- G 017',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000033,NULL,'13.8R',0.65,'Sc','in a pair',NULL,NULL,NULL,1,0.244083333333,-33.61194,NULL,NULL,34846331036,544473922,8507405,13.8),(70,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,70,33.1,1.16,41.7,41,NULL,NULL,NULL,'ESO 349- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71,'IRAS','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,71,34.81,0.8,91.4,42,75,NULL,'W91PP, r','UGC 12901',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.60',0.6,'SBb',NULL,NULL,NULL,NULL,1,0.2455,28.91172,0.201,NULL,67214338741,1050224042,16409750,14.6),(72,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,72,34.55,0.38,81.4,42,75,NULL,'W91PP, r, raw','UGC 12901',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,73,34.74,0.38,88.7,42,75,NULL,'W91PP, r, inv','UGC 12901',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,74,34.76,0.38,89.4,42,75,NULL,'W91PP, r, cor','UGC 12901',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,75,34.8,0.45,91,42,NULL,NULL,'Malmquist cor.','UGC 12901',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,76,34.83,0.45,92.3,42,NULL,NULL,NULL,'UGC 12901',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,77,34.95,0.2,97.7,42,74.4,NULL,NULL,'UGC 12901',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,78,34.99,0.4,99.5,42,NULL,NULL,'mean','UGC 12901',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,79,35.18,0.47,108,42,NULL,NULL,'H','UGC 12901',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,80,35.29,0.46,114,42,NULL,NULL,'J','UGC 12901',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,81,36.28,0.61,180,43,70,NULL,NULL,'2MASX J00010098-4345156',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'16.43',0.28,NULL,NULL,NULL,NULL,NULL,1,0.254125,-43.75431,NULL,NULL,34628749003,541074203,8454284,16.43),(82,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,82,37.58,0.72,328,44,70,NULL,NULL,'2MASX J00010107-4351356',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.53',0.43,NULL,NULL,NULL,NULL,NULL,1,0.254417,-43.85992,NULL,NULL,34628938009,541077156,8454330,16.53),(83,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 17527',NULL,83,39.71,1.31,874,45,70,NULL,'SN photometric redshift distance, z photo =0.230 +/- 0.250','SDSS-II SN 17527',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,0.270541666667,-0.17442,0.093,NULL,34359961624,536874400,8388662,NULL),(84,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 13647','RN',84,40.33,0.24,933,46,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13647',0.247602,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 13647','RN',85,40.64,0.24,1070,46,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13647',0.247602,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,86,35.43,0.47,122,47,70,NULL,NULL,'ESO 149- GA011',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000103,NULL,'14.52',1.3,'SAB(s)b:',NULL,NULL,NULL,NULL,1,359.8455,-56.33286,0,NULL,48737827021,761528547,11898883,14.52),(87,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 19787','R',87,39.81,0.2,766,48,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19787',0.197292,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,0.281125,-0.09814,0.093,NULL,34359966568,536874477,8388663,NULL),(88,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 19787','R',88,39.94,0.26,811,48,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19787',0.197292,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 07383','RN',89,43.78,0.26,3760,49,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 07383',0.517065,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',90,36.27,0.49,179,50,75,NULL,'IR','UGC 12903',NULL,'2011yCatp016004901K',2011,1,1,'The position in 1998PNAOJ...5...75M is -18 arcsec in error.','G',NULL,NULL,'15.56',0.2,'Sbc',NULL,NULL,NULL,NULL,1,0.2844583,6.33717,0.149,NULL,66610351031,1040786734,16262292,15.56),(91,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 06225','R',91,41.55,0.27,1530,51,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06225',0.337597,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,0.2875,-1.00039,0.081,NULL,34360246114,536878845,8388731,NULL),(92,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 06225','R',92,41.82,0.21,1730,51,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06225',0.337597,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 19323','R',93,39.06,0.12,596,52,70,NULL,'SDSS CAND. SNIb; MLCS2K2; SN 2007nc','SN 2007nc',0.086794,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ib?',NULL,NULL,NULL,NULL,1,0.28875,1.06847,0.093,NULL,66572552573,1040196133,16253064,NULL),(94,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 19323','R',94,39.34,0.21,680,52,70,NULL,'SDSS CAND. SNIb; SALT 2; SN 2007nc','SN 2007nc',0.086794,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',95,37.62,0.46,333,53,70,NULL,NULL,'2MASX J00010974-1032350',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000071,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,0.2905,-10.54303,0.091,NULL,34377386079,537146657,8392916,17.6),(96,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',96,38.55,0.46,512,54,70,NULL,NULL,'SDSS J000112.64-011341.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000077,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,0.302666666667,-1.22831,0.085,NULL,34363451702,536928932,8389514,18.5),(97,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 13087','RN',97,42.56,0.15,2450,55,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13087',0.328875,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 13087','RN',98,42.57,0.2,2460,55,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13087',0.328875,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',99,38.56,0.46,515,56,70,NULL,NULL,'SDSS J000114.39+150701.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000162,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,0.309958333333,15.11714,0.049,NULL,66733164519,1042705695,16292276,18.6),(100,'IRAS','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,100,34.08,0.8,65.4,57,75,NULL,'W91PP, r','IC 5376',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000013,NULL,'14.59',0.3,'Sab','Group member',NULL,NULL,NULL,1,0.332375,34.52572,0.209,NULL,67126260905,1048847826,16388247,14.59),(101,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,101,34.19,0.38,68.8,57,75,NULL,'W91PP, r, raw','IC 5376',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,102,34.2,0.4,69.1,57,NULL,NULL,'mean','IC 5376',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,103,34.32,0.47,73.2,57,NULL,NULL,'H','IC 5376',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,104,34.36,0.45,74.4,57,NULL,NULL,'K','IC 5376',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,105,34.36,0.46,74.5,57,NULL,NULL,'J','IC 5376',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,106,34.37,0.38,74.9,57,75,NULL,'W91PP, r, inv','IC 5376',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,107,34.37,0.38,74.9,57,75,NULL,'W91PP, r, cor','IC 5376',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',108,38.02,0.46,402,58,70,NULL,NULL,'2MASX J00012634-0012327',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000092,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,0.359833,-0.20919,0.093,NULL,34359910673,536873604,8388650,17.1),(109,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 15756','R',109,42.1,0.28,1890,59,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006nf','SDSS J000129.96+001633.5',0.39,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,0.374833333333,0.27597,0.081,NULL,66572076371,1040188693,16252948,NULL),(110,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 15756','R',110,42.65,0.33,2440,59,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006nf','SDSS J000129.96+001633.5',0.39,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2006nf',NULL,111,42.04,0.19,2560,59,70,NULL,'SALT 2','SDSS J000129.96+001633.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2006nf',NULL,112,42.1,0.19,2630,59,70,NULL,'SALT 2, Malmquist cor.','SDSS J000129.96+001633.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,113,34.04,0.4,64.2,60,NULL,NULL,'mean','NGC 7806',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000023,NULL,'14.31',0.8,'SA(rs)bc? pec','Pair member (points to parent)',NULL,NULL,NULL,1,0.3752083,31.44186,0.161,NULL,67211459616,1050179056,16409047,14.31),(114,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,114,34.16,0.47,67.9,60,NULL,NULL,'H','NGC 7806',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,115,34.16,0.45,68.1,60,NULL,NULL,'K','NGC 7806',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,116,34.25,0.46,70.9,60,NULL,NULL,'J','NGC 7806',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',117,38.26,0.46,448,61,70,NULL,NULL,'2MASX J00013148-1028548',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000087,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,0.381167,-10.48181,0.091,NULL,34377501447,537148460,8392944,18),(118,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',118,38.3,0.46,457,62,70,NULL,NULL,'2MASX J00013224+1411079',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000204,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,0.384375,14.18553,0.229,NULL,66732533521,1042695836,16292122,17.6),(119,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,119,35.31,0.53,116,63,70,NULL,NULL,'2MASX J00013295-0726099',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.00015,NULL,'16.15',0.61,NULL,NULL,NULL,NULL,NULL,1,0.38725,-7.43619,0.167,NULL,34386970097,537296407,8395256,16.15),(120,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,120,35.61,0.49,132,64,70,NULL,NULL,'6dF J0001340-361900',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,0.39225,-36.31675,NULL,NULL,34662796728,541606198,8462596,14.3),(121,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',121,35.65,0.46,135,65,70,NULL,NULL,'2MASX J00013460+0016281',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000087,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,0.3942917,0.27444,0.081,NULL,66572078099,1040188720,16252948,16.4),(122,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 05705','RN',122,41.22,0.12,1400,66,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 05705',0.245801,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 05705','RN',123,41.71,0.19,1760,66,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05705',0.245801,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',124,37.54,0.46,322,67,70,NULL,NULL,'2MASX J00013555+1439339',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000121,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,0.398333,14.65939,0.085,NULL,66733447883,1042710123,16292345,18.2),(125,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 01127','RN',125,38.42,0.1,447,68,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 01127',0.077374,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 01127','RN',126,39.62,0.24,779,68,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 01127',0.077374,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,127,36.08,0.51,165,69,70,NULL,NULL,'MCG -03-01-014',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.0001,NULL,'15.30',0.7,NULL,NULL,NULL,NULL,NULL,1,0.40025,-14.74875,0.053,NULL,34467692948,538557702,8414964,15.3),(128,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',128,34.33,0.49,73.6,70,75,NULL,'IR','UGC 12913',NULL,'2011yCatp016004901K',2011,1,1.34,NULL,'G',0.000013,NULL,'16.0',0.17,'Sbc',NULL,NULL,NULL,NULL,1,0.402917,3.50558,0.085,NULL,66582236628,1040347447,16255428,16),(129,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,129,34.5,NULL,79.4,70,NULL,NULL,'Dipole','UGC 12913',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,130,34.5,NULL,79.5,70,NULL,NULL,'Dipole + Quadrupole','UGC 12913',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,131,34.5,NULL,79.6,70,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12913',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,132,34.56,0.2,81.7,70,74.4,NULL,NULL,'UGC 12913',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,133,34.61,0.44,83.6,70,NULL,NULL,'Malmquist cor.','UGC 12913',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,134,34.63,0.44,84.1,70,NULL,NULL,NULL,'UGC 12913',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,135,34.79,NULL,90.8,70,NULL,NULL,NULL,'UGC 12913',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136,'Ring Diameter','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,136,32.3,0.84,29,71,NULL,NULL,'Published at H = 100 km/s/Mpc','UGC 12914',NULL,'1981ApJS...45..541P',1981,1,2.3,NULL,'G',0.000027,NULL,'13.07',1.3,'(R)S(r)cd: pec LINER','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,0.409667,23.48364,0.145,NULL,67176719875,1049636248,16400566,13.07),(137,'Sosies','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,137,33.57,0.2,51.8,71,NULL,NULL,NULL,'UGC 12914',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,138,33.66,0.47,53.9,71,NULL,NULL,'H','UGC 12914',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,139,33.68,0.45,54.5,71,NULL,NULL,'K','UGC 12914',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,140,33.73,0.46,55.6,71,NULL,NULL,'J','UGC 12914',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,141,33.89,0.4,60,71,NULL,NULL,'mean','UGC 12914',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,142,33.88,0.4,59.7,72,NULL,NULL,'mean','UGC 12915',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000023,NULL,'13.95',0.5,'Sc             LINER','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,0.4247083,23.49589,0.145,NULL,67176651731,1049635183,16400549,13.95),(143,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,143,34.7,0.45,87.2,72,NULL,NULL,'K','UGC 12915',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,144,34.72,0.47,87.9,72,NULL,NULL,'H','UGC 12915',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,145,34.81,0.46,91.6,72,NULL,NULL,'J','UGC 12915',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',146,36.99,0.46,250,73,70,NULL,NULL,'2MASX J00014440+1512150',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000179,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,0.4350417,15.20419,0.049,NULL,66735292090,1042738938,16292795,17.2),(147,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',147,37.52,0.46,319,74,70,NULL,NULL,'2MASX J00014456+1453510',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,0.4357083,14.89764,0.049,NULL,66733131336,1042705177,16292268,17.1),(148,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 19550','RN',148,42.38,0.2,2050,75,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 19550',0.460945,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,149,36.37,0.54,188,76,70,NULL,NULL,'MCG -01-01-022',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16',0.5,'Sab',NULL,NULL,NULL,NULL,1,0.4387083,-4.34694,0.135,NULL,34364639801,536947496,8389804,16),(150,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 16551','RN',150,40.64,0.27,1030,77,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16551',0.300106,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 16551','RN',151,40.85,0.24,1140,77,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16551',0.300106,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 16551','N',152,40.46,0.19,1240,77,70,NULL,'SALT 2','SDSS-II SN 16551',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 16551','N',153,40.49,0.19,1250,77,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16551',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',154,37.28,0.46,286,78,70,NULL,NULL,'2MASX J00014957-0941379',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000089,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,0.4565417,-9.69383,0.085,NULL,34380158874,537189982,8393593,16.6),(155,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',155,37.55,0.46,324,79,70,NULL,NULL,'2MASX J00014953+0034011',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000129,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,0.4565417,0.56694,0.093,NULL,66573020339,1040203442,16253178,16.2),(156,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',156,38.41,0.46,481,80,70,NULL,NULL,'2MASX J00014976+1430480',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000171,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,0.457417,14.51333,0.093,NULL,66733420756,1042709699,16292339,17.7),(157,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 10963','RN',157,38.99,0.11,577,81,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10963',0.086122,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 10963','RN',158,39.53,0.21,743,81,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10963',0.086122,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',159,37.54,0.46,322,82,70,NULL,NULL,'2MASX J00015033+0101551',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000095,NULL,'16.0g',0.39,'E0',NULL,NULL,NULL,NULL,1,0.459667,1.03203,0.085,NULL,66575513409,1040242397,16253787,16),(160,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,160,35.54,0.32,128,83,NULL,NULL,'Malmquist cor.','ESO 409- G 004',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.4r',0.5,'SA(s)bc',NULL,NULL,NULL,NULL,1,0.48875,-27.99933,0.041,NULL,34821361317,544083770,8501308,14.4),(161,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,161,35.6,0.31,132,83,NULL,NULL,NULL,'ESO 409- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,162,35.64,0.2,134,83,74.4,NULL,NULL,'ESO 409- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163,'Brightest Stars','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,163,24.65,0.46,0.85,84,NULL,NULL,'WLM 15','WLM',NULL,'2003AJ....126.1326V',2003,1,11.5,'Position is for superposed star close to center.','G',0.000007,NULL,'11.03',4,'IB(s)m','Group member',NULL,NULL,NULL,1,0.492333,-15.46092,0.093,0,34468116869,538564326,8415067,11.03),(164,'Brightest Stars','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,164,24.77,NULL,0.9,84,NULL,NULL,'WLM 31','WLM',NULL,'2003AJ....126.1326V',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165,'Brightest Stars','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,165,25.54,NULL,1.28,84,NULL,NULL,'Photographic','WLM',NULL,'1982ApJ...256..339S',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(166,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,166,24.8,0.06,0.912,84,NULL,18.47,'15, B, Photographic','WLM',NULL,'1987SAAOC..11..125W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(167,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,167,24.81,0.04,0.916,84,NULL,18.52,NULL,'WLM',NULL,'2011A&A...531A.134T',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(168,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,168,24.84,0.14,0.929,84,NULL,NULL,'4','WLM',NULL,'2007A&A...466..501V',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(169,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,169,24.85,0.11,0.933,84,NULL,NULL,'29, JHKs, GAL PL','WLM',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(170,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,170,24.88,0.08,0.946,84,NULL,NULL,'29, JHKs, LMC PL','WLM',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(171,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',171,24.89,0.07,0.951,84,NULL,NULL,'4.5 micron','WLM',NULL,'2009AIPC.1170...37N',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(172,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,172,24.9,0.18,0.955,84,NULL,NULL,'JK(W)','WLM',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(173,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,173,24.92,0.05,0.96,84,74.4,NULL,NULL,'WLM',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(174,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,174,24.92,0.07,0.964,84,NULL,NULL,'29, JHKs, GAL+LMC PL','WLM',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(175,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,175,24.92,NULL,0.964,84,NULL,NULL,NULL,'WLM',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(176,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,176,24.92,0.21,0.964,84,NULL,NULL,'LMC VIHJK','WLM',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(177,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,177,24.92,0.04,0.966,84,NULL,NULL,'31, VIJK','WLM',NULL,'2008ApJ...683..611G',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(178,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,178,24.93,NULL,0.968,84,NULL,NULL,'15, B','WLM',NULL,'1985AJ.....90.1464S',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(179,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',179,24.97,0.1,0.986,84,NULL,NULL,'3.6 micron','WLM',NULL,'2009AIPC.1170...37N',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(180,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,180,25.01,0.04,1.01,84,NULL,NULL,'V','WLM',NULL,'2008ApJ...683..611G',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(181,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,181,25.08,0.11,1.04,84,NULL,NULL,'VI(W)','WLM',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(182,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,182,25.1,0.15,1.05,84,NULL,NULL,'I','WLM',NULL,'1991PASP..103..933M',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(183,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,183,25.14,0.03,1.07,84,NULL,NULL,'60, VI(W)','WLM',NULL,'2007AJ....134..594P',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(184,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',184,25.14,0.03,1.07,84,NULL,NULL,'60, VI(W)','WLM',NULL,'2009RMxAC..35..309G',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(185,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,185,25.15,NULL,1.07,84,NULL,NULL,'Photographic, APPARENT BLUE m-M','WLM',NULL,'1988PASP..100..935S',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(186,'CMD','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,186,24.73,0.07,0.883,84,NULL,NULL,NULL,'WLM',NULL,'1999ApJ...521..577H',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(187,'CMD','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,187,24.88,0.09,0.946,84,NULL,NULL,NULL,'WLM',NULL,'2000ApJ...531..804D',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(188,'CMD','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,188,24.89,NULL,0.951,84,NULL,NULL,NULL,'WLM',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(189,'CMD','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,189,24.89,NULL,0.951,84,NULL,NULL,NULL,'WLM',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(190,'CMD','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,190,24.95,0.13,0.977,84,NULL,NULL,NULL,'WLM',NULL,'2000AJ....120..801R',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(191,'FGLR','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,191,24.99,0.1,0.995,84,NULL,NULL,'Flux-Weighted Grav.-Luminosity','WLM',NULL,'2008ApJ...684..118U',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(192,'PNLF','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,192,27.9,0.42,3.8,84,NULL,NULL,NULL,'WLM',NULL,'1981AJ.....86..185J',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(193,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,193,24.75,0.1,0.891,84,NULL,NULL,'I','WLM',NULL,'1997AJ....114..147M',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(194,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,194,24.77,0.09,0.899,84,NULL,NULL,NULL,'WLM',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(195,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,195,24.8,0.05,0.91,84,NULL,NULL,NULL,'WLM',NULL,'1996ApJ...467L..13M',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(196,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,196,24.81,0.1,0.916,84,NULL,NULL,'I','WLM',NULL,'1993ApJ...417..553L',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(197,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,197,24.82,0.1,0.92,84,NULL,NULL,NULL,'WLM',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(198,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,198,24.84,0.12,0.929,84,NULL,NULL,'HST KP Calibrated','WLM',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(199,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,199,24.85,0.08,0.932,84,NULL,NULL,NULL,'WLM',NULL,'2005MNRAS.356..979M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(200,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',200,24.85,0.12,0.933,84,NULL,NULL,NULL,'WLM',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(201,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',201,24.89,0.25,0.951,84,NULL,NULL,'K','WLM',NULL,'2011ASPC..445..547T',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(202,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,202,24.92,0.05,0.96,84,74.4,NULL,NULL,'WLM',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(203,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,203,24.93,0.04,0.968,84,NULL,NULL,'I','WLM',NULL,'2007ApJ...661..815R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(204,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,204,24.95,0.09,0.977,84,NULL,NULL,'I','WLM',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(205,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,205,24.97,NULL,0.986,84,NULL,NULL,NULL,'WLM',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(206,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,206,24.97,NULL,0.986,84,NULL,NULL,'DA90','WLM',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(207,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,207,24.99,NULL,0.995,84,NULL,NULL,'theory','WLM',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(208,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,208,25.03,NULL,1.01,84,NULL,NULL,'Yale','WLM',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(209,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,209,25.08,NULL,1.04,84,NULL,NULL,'K97','WLM',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(210,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,210,25.12,0.08,1.06,84,NULL,NULL,'K','WLM',NULL,'2011AJ....141..194G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(211,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,211,25.14,0.09,1.07,84,NULL,NULL,'J','WLM',NULL,'2011AJ....141..194G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(212,'Tully est','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,212,25,0.8,1,84,75,NULL,'B','WLM',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(213,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',213,25.88,NULL,1.5,84,NULL,NULL,'LEDA [April 2006]','WLM',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(214,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',214,37.23,0.46,280,85,70,NULL,NULL,'2MASX J00015894-1033259',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000083,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,0.4957083,-10.55719,0.082,NULL,34376605956,537134468,8392726,17.4),(215,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','PTF10ubm','N',215,37.24,0.02,262,86,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10ubm',0.0701,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(216,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,216,33.94,NULL,61.3,87,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12905',NULL,'2010Ap&SS.325..163P',2010,1,1.1,NULL,'G',NULL,NULL,'16.5',0.1,'Scd:',NULL,NULL,NULL,NULL,1,0.501667,80.64222,0.925,NULL,65517548075,1023711688,15995495,16.5),(217,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,217,33.95,NULL,61.6,87,NULL,NULL,'Dipole + Quadrupole','UGC 12905',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(218,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,218,33.96,NULL,61.8,87,NULL,NULL,'Dipole','UGC 12905',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(219,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,219,34.15,NULL,67.6,87,NULL,NULL,NULL,'UGC 12905',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(220,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',220,35.62,0.46,133,88,70,NULL,NULL,'2MASX J00020084+1501320',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000182,NULL,'16.1g',0.32,'S0',NULL,NULL,NULL,NULL,1,0.5034583,15.02564,0.049,NULL,66735151451,1042736741,16292761,16.1),(221,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',221,38.57,0.46,518,89,70,NULL,NULL,'2MASX J00020156-0057403',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.99',0.23,NULL,NULL,NULL,NULL,NULL,1,0.5065417,-0.96131,0.077,NULL,34363566964,536930733,8389542,17.99),(222,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 04211','RN',222,41.99,0.32,2000,90,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 04211',0.250225,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(223,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 04211','RN',223,42.37,0.42,2390,90,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 04211',0.250225,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(224,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',224,37.56,0.23,325,91,70,NULL,NULL,'2MASX J00020361+0037549',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000093,NULL,'15.93',0.24,NULL,NULL,NULL,NULL,NULL,1,0.5150417,0.63186,0.093,NULL,66572806323,1040200098,16253126,15.93),(225,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 03475','RN',225,40.66,0.32,1040,92,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03475',0.301106,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(226,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 03475','RN',226,41.15,0.3,1300,92,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03475',0.301106,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(227,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',227,36.4,0.46,190,93,70,NULL,NULL,'2MASX J00021021+1408106',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000177,NULL,'16.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,0.5425,14.13622,0.229,NULL,66732547821,1042696059,16292125,16.6),(228,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,228,25.42,0.08,1.21,94,NULL,NULL,NULL,'Andromeda XVIII',NULL,'2012ApJ...758...11C',2012,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,0.560417,45.08889,0.445,0,67645954387,1056968037,16515125,NULL),(229,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,229,25.59,0.1,1.31,94,74.4,NULL,NULL,'Andromeda XVIII',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(230,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,230,25.66,0.13,1.36,94,NULL,NULL,'I','Andromeda XVIII',NULL,'2008ApJ...688.1009M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(231,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 04343','RN',231,42.76,0.96,3250,95,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04343',0.094565,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(232,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,232,36.96,0.63,246,96,70,NULL,NULL,'2MASX J00021772-4345168',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'17.39',0.18,NULL,NULL,NULL,NULL,NULL,1,0.573833333333,-43.75467,NULL,NULL,34628860921,541075951,8454311,17.39),(233,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',233,37.56,0.23,325,97,70,NULL,NULL,'2MASX J00021889+0025270',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,0.5787083,0.42428,0.093,NULL,66573008380,1040203255,16253175,16.9),(234,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,234,37.25,0.8,282,98,70,NULL,NULL,'2MASX J00021977-4352198',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.91',0.28,NULL,NULL,NULL,NULL,NULL,1,0.5825,-43.87211,NULL,NULL,34628873716,541076151,8454314,16.91),(235,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',235,37.8,0.46,363,99,70,NULL,NULL,'2MASX J00022235+0039400',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000081,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,0.593125,0.66108,0.105,NULL,66572787521,1040199805,16253121,18.1),(236,'IRAS','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,236,35.02,0.8,101,100,75,NULL,'W91PP, r','UGC 12920',NULL,'1997ApJS..109..333W',1997,1,1.68,NULL,'G',0.000003,NULL,'15.48',0.19,'Sbc',NULL,NULL,NULL,NULL,1,0.59625,27.21067,0.117,NULL,67185397648,1049771838,16402684,15.48),(237,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,237,34.29,NULL,72,100,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12920',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(238,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,238,34.3,NULL,72.3,100,NULL,NULL,'Dipole','UGC 12920',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(239,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,239,34.3,NULL,72.5,100,NULL,NULL,'Dipole + Quadrupole','UGC 12920',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(240,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,240,34.48,NULL,78.6,100,NULL,NULL,NULL,'UGC 12920',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(241,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,241,34.56,0.38,81.7,100,75,NULL,'W91PP, r, raw','UGC 12920',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(242,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,242,34.6,0.38,83.1,100,75,NULL,'W91PP, r, inv','UGC 12920',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(243,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,243,34.68,0.2,86.3,100,74.4,NULL,NULL,'UGC 12920',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(244,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',244,34.74,0.49,88.8,100,75,NULL,'IR','UGC 12920',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(245,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,245,34.77,0.38,89.8,100,75,NULL,'W91PP, r, cor','UGC 12920',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(246,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,246,34.81,0.46,91.6,100,NULL,NULL,NULL,'UGC 12920',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(247,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,247,34.81,0.46,91.7,100,NULL,NULL,'Malmquist cor.','UGC 12920',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(248,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,248,36.71,0.61,220,101,70,NULL,NULL,'2MASX J00022478-5445592',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.60',0.33,NULL,NULL,NULL,NULL,NULL,1,0.6032083,-54.76653,0,NULL,35989504604,562336009,8786500,16.6),(249,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 15239',NULL,249,40.38,0.12,1190,102,70,NULL,'SN photometric redshift distance, z photo =0.331 +/- 0.023','SDSS-II SN 15239',NULL,'2011ApJ...738..162S',2011,1,0.1,NULL,'G',NULL,'PHOT','20.6g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,0.60625,-0.91847,0.073,NULL,34363601628,536931275,8389551,20.6),(250,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 15239','R',250,41.1,0.28,1240,102,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15239',0.334228,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(251,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 15239','R',251,41.27,0.33,1340,102,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15239',0.334228,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(252,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 17900','RN',252,44.18,0.3,4900,103,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 17900',0.398526,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(253,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',253,37.53,0.46,320,104,70,NULL,NULL,'2MASX J00023441+1358006',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,0.6435,13.96692,0.253,NULL,66736812781,1042762699,16293167,18.3),(254,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,254,34.81,0.4,91.6,105,NULL,NULL,'mean','MCG -01-01-024',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000033,NULL,'14.49',0.8,'SB(s)bc?       HII',NULL,NULL,NULL,NULL,1,0.645041666667,-3.71072,0.133,NULL,34367528567,536992633,8390509,14.49),(255,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,255,34.83,0.41,92.4,105,NULL,NULL,'Malmquist cor.','MCG -01-01-024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(256,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,256,35.03,0.38,101,105,NULL,NULL,NULL,'MCG -01-01-024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(257,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,257,35.07,0.2,103,105,74.4,NULL,NULL,'MCG -01-01-024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(258,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,258,35.11,0.47,105,105,NULL,NULL,'H','MCG -01-01-024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(259,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,259,35.2,0.46,109,105,NULL,NULL,'J','MCG -01-01-024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(260,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',260,38.04,0.33,405,106,70,NULL,NULL,'2MASX J00023624+0025165',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000094,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,0.650833,0.42119,0.105,NULL,66572815153,1040200236,16253128,17.5),(261,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 01761','RN',261,40.84,0.18,1140,107,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01761',0.291061,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(262,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',262,37.56,0.23,325,108,70,NULL,NULL,'2MASX J00023637+0029445',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00008,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,0.6515,0.49572,0.105,NULL,66572817879,1040200279,16253129,18.1),(263,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 11382','RN',263,40.46,0.31,1110,109,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 11382',0.113498,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(264,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 11382','RN',264,40.57,0.27,1170,109,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 11382',0.113498,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(265,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',265,38.04,0.33,405,110,70,NULL,NULL,'2MASX J00023871+0023105',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000094,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,0.66125,0.38608,0.105,NULL,66572992799,1040203012,16253172,17),(266,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,266,36.93,0.71,243,111,70,NULL,NULL,'LCRS B000005.7-390310',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00012,NULL,'17.00',0.25,NULL,NULL,NULL,NULL,NULL,1,0.6630417,-38.77414,NULL,NULL,34666879270,541669988,8463593,17),(267,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,267,34.26,0.2,71.1,112,74.4,NULL,NULL,'CGCG 408-013',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000834,NULL,'15.83',0.1,'S?',NULL,NULL,NULL,NULL,1,0.66625,8.737,0.213,NULL,66607545527,1040742898,16261607,15.83),(268,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',268,34.34,0.49,73.7,112,75,NULL,'IR','CGCG 408-013',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(269,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,269,34.39,0.41,75.3,112,NULL,NULL,NULL,'CGCG 408-013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(270,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,270,34.4,0.4,76,112,NULL,NULL,'Malmquist cor.','CGCG 408-013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(271,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 15850','R',271,40.48,0.21,996,113,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15850 HOST',0.2502,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,0.6675,-1.16522,0.069,NULL,34363504302,536929754,8389527,NULL),(272,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 15850','R',272,40.76,0.17,1130,113,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15850 HOST',0.2502,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(273,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 15850',NULL,273,40.38,0.12,1190,113,70,NULL,'SALT 2','SDSS-II SN 15850 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(274,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 15850',NULL,274,40.4,0.12,1200,113,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15850 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(275,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,275,35.81,0.46,145,114,NULL,NULL,NULL,'2MASX J00024069+0846251',NULL,'2009ApJS..182..474S',2009,1,0.38,NULL,'G',NULL,NULL,'16.9',0.17,NULL,NULL,NULL,NULL,NULL,1,0.669541666667,8.77367,0.213,NULL,66607531329,1040742677,16261604,16.9),(276,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,276,35.91,0.2,152,114,74.4,NULL,NULL,'2MASX J00024069+0846251',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(277,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,277,36.06,0.41,163,114,NULL,NULL,'Malmquist cor.','2MASX J00024069+0846251',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(278,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',278,37.56,0.23,325,115,70,NULL,NULL,'2MASX J00024310+0034195',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000089,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,0.6795417,0.572,0.105,NULL,66572791107,1040199861,16253122,17.3),(279,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',279,37.29,0.46,287,116,70,NULL,NULL,'2MASX J00024327-1043148',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000078,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,0.680333,-10.72092,0.082,NULL,34594762207,540543159,8445986,17.4),(280,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,280,35.99,0.52,158,117,70,NULL,NULL,'FAIRALL 0626',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.31',0.38,'S0',NULL,NULL,NULL,NULL,1,0.6837917,-43.96717,NULL,NULL,34628990127,541077970,8454343,16.31),(281,'Tully est','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,281,31.84,0.8,23.4,118,75,NULL,NULL,'ESO 012- G 014',NULL,'1988NBGC.C....0000T',1988,1,2.3,NULL,'G',0.000013,NULL,'14.83',1.1,'SB(s)m',NULL,NULL,NULL,NULL,1,0.684083,-80.34653,0.329,NULL,35468662707,554197854,8659341,14.83),(282,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,282,36.32,0.51,184,119,70,NULL,NULL,'2MASX J00024429-5344549',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.52',0.6,'(RL)SB0/a',NULL,NULL,NULL,NULL,1,0.6845,-53.74858,0,NULL,35989373697,562333964,8786468,15.52),(283,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,283,34.89,0.41,95.1,120,NULL,NULL,'Malmquist cor.','UGC 00003',NULL,'2009ApJS..182..474S',2009,1,1.6,NULL,'G',0.000017,NULL,'14.37',0.9,'SBa','Parent (of companion) galaxy',NULL,NULL,NULL,1,0.6932083,18.88622,0.077,NULL,66713409210,1042397018,16287453,14.37),(284,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,284,35.04,0.38,102,120,NULL,NULL,NULL,'UGC 00003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(285,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,285,35.3,0.4,115,120,NULL,NULL,'mean','UGC 00003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(286,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,286,35.32,0.2,116,120,74.4,NULL,NULL,'UGC 00003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(287,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,287,35.44,0.47,122,120,NULL,NULL,'H','UGC 00003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(288,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,288,35.56,0.46,129,120,NULL,NULL,'J','UGC 00003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(289,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,289,35.58,0.45,131,120,NULL,NULL,'K','UGC 00003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(290,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',290,37.58,0.46,327,121,70,NULL,NULL,'2MASX J00024890+0028345',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000103,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,0.703667,0.47617,0.105,NULL,66572346907,1040192920,16253014,17.2),(291,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2005ed',NULL,291,37.28,0.12,263,122,74.2,NULL,'SALT 2','2MASX J00024910+0045055',0.087,'2010ApJ...716..712A',2010,1,0.33,NULL,'G',0.000171,NULL,'17.2g',0.26,'E int          BLAGN',NULL,NULL,NULL,'Sy 1',1,0.7044583,0.75133,0.081,NULL,66575927560,1040248868,16253888,17.2),(292,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2005ed',NULL,292,37.98,0.13,363,122,70,NULL,'SALT 2','2MASX J00024910+0045055',0.087,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(293,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 00722','R',293,38.34,0.11,428,122,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ed','2MASX J00024910+0045055',0.086341,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(294,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 04069','R',294,38.48,0.08,457,122,70,NULL,'SDSS CAND. Variable; MLCS2K2; SN 2005ed','2MASX J00024910+0045055',0.086497,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(295,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 04069','R',295,39.1,0.18,609,122,70,NULL,'SDSS CAND. Variable; SALT 2; SN 2005ed','2MASX J00024910+0045055',0.086497,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(296,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 09378','RN',296,39.14,0.14,619,123,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 09378',0.086525,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(297,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 09378','RN',297,39.95,0.28,899,123,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 09378',0.086525,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(298,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 14343',NULL,298,40.25,0.17,1120,124,70,NULL,'SN photometric redshift distance, z photo =0.307 +/- 0.031','SDSS-II SN 14343',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,0.707083,-0.95408,0.069,NULL,34363696351,536932755,8389574,NULL),(299,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 14343','R',299,40.98,0.22,1170,124,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14343',0.343052,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(300,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 14343','R',300,41.04,0.14,1200,124,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14343',0.343052,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(301,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 14343',NULL,301,40.87,0.12,1490,124,70,NULL,'SALT 2','SDSS-II SN 14343',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(302,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 14343',NULL,302,40.91,0.12,1520,124,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14343',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(303,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',303,37.32,0.46,291,125,70,NULL,NULL,'2MASX J00025126+1604227',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,0.7135,16.07306,0.097,NULL,66732240242,1042691253,16292050,17.3),(304,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 07786','RN',304,39.65,0.2,769,126,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 07786',0.106978,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(305,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 07786','RN',305,40.42,0.26,1090,126,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07786',0.106978,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(306,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 20115','RN',306,42.19,0.39,2540,127,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 20115',0.079858,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(307,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 20115','RN',307,42.98,0.45,3650,127,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 20115',0.079858,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(308,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',308,36.96,0.46,246,128,70,NULL,NULL,'2MASX J00025265+0000303',NULL,'2015arXiv151105856S',2015,1,0.11,NULL,'G',0.000075,NULL,'17.4g',0.08,NULL,NULL,NULL,NULL,NULL,1,0.719541666667,0.00833,0.057,NULL,66572387242,1040193550,16253024,17.4),(309,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 15370',NULL,309,38.26,2.63,449,129,70,NULL,'SN photometric redshift distance, z photo =0.111 +/- 0.333','SDSS-II SN 15370',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','22.6g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,0.72075,-0.50181,0.065,NULL,34360431550,536881742,8388777,22.6),(310,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 15370','R',310,42.33,0.32,1930,129,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15370',0.519708,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(311,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 15370',NULL,311,42.26,0.23,2830,129,70,NULL,'SALT 2','SDSS-II SN 15370',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(312,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 15370',NULL,312,42.42,0.23,3050,129,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15370',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(313,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 20896','R',313,41.53,0.26,1490,130,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J000254.37+005623.0',0.361,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,NULL,'20.6g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,0.726583,0.93975,0.081,NULL,66575964743,1040249449,16253897,20.6),(314,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 20896','R',314,41.66,0.21,1580,130,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J000254.37+005623.0',0.361,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(315,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 20896',NULL,315,41.46,0.15,1960,130,70,NULL,'SALT 2','SDSS J000254.37+005623.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(316,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 20896',NULL,316,41.51,0.15,2000,130,70,NULL,'SALT 2, Malmquist cor.','SDSS J000254.37+005623.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(317,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,317,34.61,0.47,83.7,131,NULL,NULL,'H','NGC 7812',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000103,NULL,'13.86',0.7,'SAB(rs)ab      HII',NULL,NULL,NULL,NULL,1,0.7269583,-34.23564,NULL,NULL,34662748804,541605450,8462585,13.86),(318,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,318,34.76,0.4,89.3,131,NULL,NULL,'mean','NGC 7812',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(319,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,319,34.76,0.46,89.7,131,NULL,NULL,'J','NGC 7812',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(320,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,320,34.78,0.45,90.3,131,NULL,NULL,'K','NGC 7812',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(321,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,321,36.65,0.55,214,132,70,NULL,NULL,'QP 094',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'15.0V',0.4,'E2',NULL,NULL,NULL,NULL,1,0.72775,-35.72208,NULL,NULL,34663787492,541621679,8462838,15),(322,'CMD','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'N',322,18.41,0.19,0.048,133,NULL,NULL,'If object = GC, ID = DES J2038_4609','Indus II',NULL,'2015ApJ...813..109D',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(323,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',323,37.92,0.46,384,134,70,NULL,NULL,'2MASX J00025663+0046215',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000077,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,0.7359583,0.77264,0.081,NULL,66575939542,1040249055,16253891,17.8),(324,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,324,35.29,0.54,114,135,NULL,NULL,'Malmquist cor.','UGC 00004',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000073,NULL,'15.11',0.7,'Sbc',NULL,NULL,NULL,NULL,1,0.737416666667,4.20872,0.077,NULL,66583856097,1040372751,16255824,15.11),(325,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,325,35.49,0.49,125,135,NULL,NULL,NULL,'UGC 00004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(326,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,326,35.52,0.2,127,135,74.4,NULL,NULL,'UGC 00004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(327,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 13134','RN',327,39.95,0.17,641,136,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13134',0.522054,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(328,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 03560',NULL,328,41.3,0.12,1820,137,70,NULL,'SN photometric redshift distance, z photo =0.573 +/- 0.046','SDSS-II SN 03560',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,0.768625,0.79722,0.081,NULL,66575936344,1040249005,16253890,NULL),(329,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 03560',NULL,329,42.27,0.26,2840,137,70,NULL,'SALT 2','SDSS-II SN 03560',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(330,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 03560',NULL,330,42.43,0.26,3060,137,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 03560',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(331,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,331,36,0.58,159,138,70,NULL,NULL,'2MASX J00030547-5402112',NULL,'2014MNRAS.445.2677S',2014,1,0.32,NULL,'G',0.00015,NULL,'17.25',0.28,NULL,NULL,NULL,NULL,NULL,1,0.772875,-54.03642,0,NULL,35989390416,562334225,8786472,17.25),(332,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,332,34.34,0.69,73.8,139,100,NULL,'mid-IR','UGC 00005',NULL,'2013ApJ...771...88L',2013,1,1.8,'HOLM 827B is a star.','G',0.00002,NULL,'13.97',0.9,'SABbc          HII','Pair member (points to parent)',NULL,NULL,NULL,1,0.773583,-1.91381,0.154,NULL,34361235253,536894300,8388973,13.97),(333,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,333,34.71,0.47,87.5,139,NULL,NULL,'H','UGC 00005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(334,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,334,34.77,0.46,89.9,139,NULL,NULL,'J','UGC 00005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(335,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,335,34.8,0.45,91,139,NULL,NULL,'K','UGC 00005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(336,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,336,34.95,0.4,97.5,139,NULL,NULL,'mean','UGC 00005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(337,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,337,35.04,0.4,102,139,NULL,NULL,'Malmquist cor.','UGC 00005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(338,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,338,35.11,0.2,105,139,74.4,NULL,NULL,'UGC 00005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(339,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,339,35.29,0.35,114,139,NULL,NULL,NULL,'UGC 00005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(340,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 15320','R',340,38.75,0.07,530,140,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2006kv','SDSS J000306.66+005449.6',0.062,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,0.77775,0.91378,0.097,NULL,66575971105,1040249548,16253899,NULL),(341,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 15320','R',341,39.81,0.38,863,140,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2006kv','SDSS J000306.66+005449.6',0.062,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(342,'SNII optical','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2006kv',NULL,342,37,0.09,236,140,NULL,NULL,'SCM 55 SNII','SDSS J000306.66+005449.6',0.062,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(343,'SNII optical','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2006kv',NULL,343,37.4,0.11,284,140,NULL,NULL,'SCM 15 SDSS SNII','SDSS J000306.66+005449.6',0.062,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(344,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,344,34.92,0.45,96.2,141,NULL,NULL,'K','UGC 00006',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000003,NULL,'14.38',0.7,'Pec;HII        Sy1.8',NULL,NULL,NULL,'Sy 1.8',1,0.790083333333,21.96017,0.117,NULL,67445335639,1053833369,16466146,14.38),(345,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,345,34.92,0.4,96.6,141,NULL,NULL,'mean','UGC 00006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(346,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,346,35.13,0.47,106,141,NULL,NULL,'H','UGC 00006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(347,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,347,35.35,0.46,117,141,NULL,NULL,'J','UGC 00006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(348,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',348,38.45,0.46,491,142,70,NULL,NULL,'2MASX J00030963+0106574',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000097,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,0.790166666667,1.11597,0.101,NULL,66576085620,1040251337,16253927,17.9),(349,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',349,36.93,0.46,243,143,70,NULL,NULL,'2MASX J00031103+1346393',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,0.7959583,13.77764,0.253,NULL,66737502742,1042773480,16293335,17.8),(350,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,350,36.02,0.4,160,144,NULL,NULL,'mean','IC 5381',NULL,'2007A&A...465...71T',2007,1,1.19,NULL,'G',0.000033,NULL,'14.7g',0.43,'Sab? sp',NULL,NULL,NULL,NULL,1,0.796958333333,15.96572,0.097,NULL,66731993457,1042687397,16291990,14.7),(351,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,351,36.03,0.47,161,144,NULL,NULL,'H','IC 5381',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(352,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,352,36.13,0.45,169,144,NULL,NULL,'K','IC 5381',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(353,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,353,36.21,0.46,175,144,NULL,NULL,'J','IC 5381',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(354,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,354,36.57,0.2,206,144,74.4,NULL,NULL,'IC 5381',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(355,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 21387','RN',355,43.97,0.28,4200,145,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 21387',0.481873,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(356,'SBF','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,356,30.44,0.14,12.2,146,NULL,NULL,'I','NGC 7814',NULL,'2003ApJ...583..712J',2003,1,5.5,'Multiple SDSS entries describe this object.','G',0.000013,NULL,'11.56',2.3,'SA(s)ab: sp    LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,0.812041666667,16.14542,0.097,NULL,66765325937,1043208217,16300128,11.56),(357,'SBF','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,357,30.6,0.14,13.2,146,NULL,NULL,'I','NGC 7814',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(358,'SBF','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,358,30.68,0.12,13.7,146,74.4,NULL,NULL,'NGC 7814',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(359,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,359,30.8,0.1,14.4,146,NULL,NULL,'I','NGC 7814',NULL,'2011ApJS..195...18R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(360,'Sosies','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,360,31.26,0.13,17.9,146,NULL,NULL,NULL,'NGC 7814',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(361,'Tully est','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,361,30.9,0.8,15.1,146,75,NULL,NULL,'NGC 7814',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(362,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,362,30.13,0.69,10.6,146,100,NULL,'mid-IR','NGC 7814',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(363,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,363,30.68,0.12,13.7,146,74.4,NULL,NULL,'NGC 7814',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(364,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,364,30.95,0.4,15.5,146,73,NULL,'opt','NGC 7814',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(365,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,365,31.2,0.43,17.4,146,75,NULL,'3.6 micron, color corrected','NGC 7814',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(366,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,366,31.29,0.36,18.1,146,NULL,NULL,NULL,'NGC 7814',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(367,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,367,31.42,0.43,19.2,146,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7814',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(368,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,368,31.69,0.4,21.8,146,NULL,NULL,NULL,'NGC 7814',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(369,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,369,31.71,0.4,21.9,146,NULL,NULL,'Malmquist cor.','NGC 7814',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(370,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',370,32.7,NULL,34.7,146,NULL,NULL,'LEDA [April 2006]','NGC 7814',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(371,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',371,38.18,0.46,433,147,70,NULL,NULL,'SDSS J000317.79-085232.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000065,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,0.824125,-8.87578,0.077,NULL,34379318470,537176851,8393388,18.7),(372,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,372,34.49,0.58,79.2,148,NULL,NULL,'Malmquist cor.','UGC 00010',NULL,'2009ApJS..182..474S',2009,1,1.9,NULL,'G',0.000133,NULL,'15.5',1.7,'Scd:','Parent of attached companion galaxy',NULL,NULL,NULL,1,0.83525,8.61878,0.229,NULL,66607040126,1040735001,16261484,15.5),(373,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,373,34.79,0.51,90.6,148,NULL,NULL,NULL,'UGC 00010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(374,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,374,34.83,0.2,92.5,148,74.4,NULL,NULL,'UGC 00010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(375,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,375,36.58,0.65,207,149,70,NULL,NULL,'GALEXASC J000321.24-355623.8',NULL,'2014MNRAS.445.2677S',2014,1,0.23,NULL,'G',0.00015,NULL,'15.4R',0.21,NULL,NULL,NULL,NULL,NULL,1,0.838833,-35.93947,NULL,NULL,34663710253,541620472,8462819,15.4),(376,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,376,36.06,0.49,163,150,70,NULL,NULL,'FAIRALL 0627',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.00015,NULL,'15.98',0.27,'S0','Group member',NULL,NULL,NULL,1,0.8389583,-50.0805,NULL,NULL,35975587299,562118551,8783102,15.98),(377,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',377,37.12,0.46,265,151,70,NULL,NULL,'MCG -02-01-011',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000095,NULL,'16.0g',0.42,'E0',NULL,NULL,NULL,NULL,1,0.840125,-9.98328,0.089,NULL,34376907935,537139186,8392799,16),(378,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',378,37.66,0.27,340,152,70,NULL,NULL,'2MASX J00032250+0103284',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000122,NULL,'16.1g',0.14,'E',NULL,NULL,NULL,NULL,1,0.843708333333,1.05789,0.097,NULL,66576077549,1040251211,16253925,16.1),(379,'Quasar spectrum','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,379,42.99,NULL,3970,153,NULL,NULL,NULL,'[HB89] 0000-263',NULL,'2002A&A...381L..57D',2002,1,NULL,'Incorrectly called 0000-260 in Hewitt&Burbidge 1989ApJS...69....1H.','QSO',0.008,NULL,'18.',NULL,'DLyA',NULL,NULL,NULL,'QSO',1,0.8454583,-26.05467,0,NULL,34769340651,543270947,8488608,18),(380,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 11619','RN',380,40.8,0.22,1150,154,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 11619',0.260834,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(381,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 11619','RN',381,40.93,0.36,1220,154,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 11619',0.260834,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(382,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',382,37.66,0.27,340,155,70,NULL,NULL,'SDSS J000327.49+010551.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000088,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,0.864583,1.09775,0.097,NULL,66576105831,1040251653,16253932,18.4),(383,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',383,35.63,0.49,134,156,75,NULL,'IR','ESO 193- G 012',NULL,'2011yCatp016004901K',2011,1,0.93,NULL,'G',0.000033,NULL,'14.00',0.23,'Sb:','Group member',NULL,NULL,NULL,1,0.88125,-50.93561,NULL,NULL,36029182058,562955969,8796187,14),(384,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2006sr',NULL,384,32.68,0.2,33.5,157,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','UGC 00014',0.02414,'2011A&A...526A..81B',2011,1,0.97,NULL,'G',0.00003,NULL,'13.79',0.67,'Sc+','in a triple',NULL,NULL,NULL,1,0.895916666667,23.20078,0.173,NULL,67176316675,1049629948,16400467,13.79),(385,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2006sr',NULL,385,34.34,0.18,72.1,157,74.2,NULL,'SALT 2','UGC 00014',0.02414,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(386,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2006sr',NULL,386,34.82,0.08,92,157,74.4,NULL,NULL,'UGC 00014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(387,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2006sr',NULL,387,35.03,0.02,99,157,72,NULL,'SALT2','UGC 00014',0.02414,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(388,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2006sr',NULL,388,35.07,0.17,101,157,70,NULL,'SALT 2','UGC 00014',0.02414,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(389,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2006sr',NULL,389,35.1,0.16,102,157,73.8,NULL,'SALT 2 (SNANA)','UGC 00014',0.0242,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(390,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2006sr',NULL,390,35.24,0.2,109,157,65,NULL,'SALT2','UGC 00014',0.02414,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(391,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2006sr',NULL,391,35.27,0.19,111,157,65,NULL,'SALT','UGC 00014',0.02414,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(392,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2006sr',NULL,392,35.28,0.18,111,157,65,NULL,'MLCS17','UGC 00014',0.02414,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(393,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2006sr',NULL,393,35.28,0.19,111,157,65,NULL,'MLCS31','UGC 00014',0.02414,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(394,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2006sr','R',394,35.28,0.07,114,157,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 00014',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(395,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2006sr','R',395,35.32,0.07,116,157,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 00014',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(396,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2006sr',NULL,396,35.61,0.03,129,157,70,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','UGC 00014',0.02414,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(397,'IRAS','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,397,34.91,0.8,95.8,157,75,NULL,'MAT, I','UGC 00014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(398,'IRAS','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,398,34.91,0.8,96,157,75,NULL,'W91PP, r','UGC 00014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(399,'IRAS','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,399,34.92,0.8,96.3,157,75,NULL,'CF, r','UGC 00014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(400,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,400,34.08,0.38,65.6,157,75,NULL,'W91PP, r, raw','UGC 00014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(401,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,401,34.25,0.38,70.7,157,75,NULL,'W91PP, r, inv','UGC 00014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(402,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,402,34.25,0.38,70.9,157,75,NULL,'CF, r, raw','UGC 00014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(403,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,403,34.26,0.43,71.1,157,75,NULL,'MAT, I, raw','UGC 00014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(404,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,404,34.29,0.69,72.1,157,100,NULL,'mid-IR','UGC 00014',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(405,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,405,34.3,0.38,72.5,157,75,NULL,'W91PP, r, cor','UGC 00014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(406,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,406,34.33,0.4,73.5,157,75,NULL,'HOSTS SN 2006sr','UGC 00014',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(407,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,407,34.4,0.38,76,157,75,NULL,'CF, r, inv','UGC 00014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(408,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,408,34.43,0.36,76.8,157,NULL,NULL,NULL,'UGC 00014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(409,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,409,34.44,0.36,77.1,157,NULL,NULL,'Malmquist cor.','UGC 00014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(410,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,410,34.46,0.38,78,157,75,NULL,'CF, r, cor','UGC 00014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(411,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,411,34.49,0.43,79,157,75,NULL,'MAT, I, inv','UGC 00014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(412,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,412,34.51,0.43,79.9,157,75,NULL,'MAT, I, cor','UGC 00014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(413,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,413,34.52,0.32,80,157,85,NULL,'I, raw','UGC 00014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(414,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,414,34.58,0.32,82.3,157,85,NULL,'I, inv','UGC 00014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(415,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,415,34.82,0.08,92,157,74.4,NULL,NULL,'UGC 00014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(416,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,416,35.11,0.4,105,157,NULL,NULL,'mean','UGC 00014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(417,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,417,35.17,0.47,108,157,NULL,NULL,'H','UGC 00014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(418,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,418,35.33,0.45,116,157,NULL,NULL,'K','UGC 00014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(419,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',419,37.85,0.33,371,158,70,NULL,NULL,'2MASX J00033834+1358228',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000152,NULL,'17.3g',0.22,'BrClG',NULL,NULL,NULL,NULL,1,0.909625,13.97306,0.273,NULL,66737217265,1042769019,16293265,17.3),(420,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 20530','RN',420,38.97,0.2,586,159,70,NULL,'SDSS CAND. SNII; SALT 2','SDSS-II SN 20530',0.061112,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(421,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 20530','RN',421,39.08,0.07,617,159,70,NULL,'SDSS CAND. SNII; MLCS2K2','SDSS-II SN 20530',0.061112,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(422,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,422,30.57,0.4,13,160,75,NULL,'B','UGC 00017',NULL,'1988NBGC.C....0000T',1988,1,2.5,NULL,'G',0.00002,NULL,'14.8',1.7,'Sm:','Group member',NULL,NULL,NULL,1,0.930417,15.21833,0.121,NULL,66735352704,1042739886,16292810,14.8),(423,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,423,31.2,0.43,17.4,160,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00017',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(424,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,424,31.43,0.43,19.3,160,75,NULL,'3.6 micron, color corrected','UGC 00017',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(425,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,425,31.54,0.2,20.3,160,74.4,NULL,NULL,'UGC 00017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(426,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,426,35.19,0.2,109,161,74.4,NULL,NULL,'CGCG 456-027',NULL,'2013AJ....146...86T',2013,1,0.59,NULL,'G',0.000033,NULL,'15.6g',0.33,'Sab',NULL,NULL,NULL,NULL,1,0.934667,16.18686,0.093,NULL,66765377600,1043209025,16300141,15.6),(427,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',427,35.93,0.49,153,162,75,NULL,'IR','UGC 00015',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',NULL,NULL,'16.0',0.2,'Sab',NULL,NULL,NULL,NULL,1,0.936583,4.29811,0.069,NULL,66581069088,1040329204,16255143,16),(428,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',428,37.85,0.33,371,163,70,NULL,NULL,'SDSS J000344.99+135725.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000156,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,0.9374583,13.95714,0.273,NULL,66737270255,1042769847,16293278,18.7),(429,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,429,35.15,0.52,107,164,70,NULL,NULL,'2MASX J00034674-5514189',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'16.07',0.3,'S',NULL,NULL,NULL,NULL,1,0.9447917,-55.23861,0,NULL,35987809170,562309518,8786086,16.07),(430,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 18709','R',430,40.24,0.2,1010,165,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2007nx','SDSS J000348.32+002134.5',0.099536,'2014arXiv1401.3317S',2014,1,0.19,NULL,'G',0.00012,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,0.951375,0.35961,0.049,NULL,66572363004,1040193171,16253018,18.5),(431,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 18709','R',431,40.26,0.09,1030,165,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2007nx','SDSS J000348.32+002134.5',0.099536,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(432,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,432,35.61,0.56,133,166,70,NULL,NULL,'AM 0001-435',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00015,NULL,'15.47',0.63,'SB(r)ab',NULL,NULL,NULL,NULL,1,0.9529583,-43.61831,NULL,NULL,34631707542,541120430,8455006,15.47),(433,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',433,37.66,0.27,340,167,70,NULL,NULL,'2MASX J00034960+0059294',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000083,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,0.9567083,0.99147,0.097,NULL,66576127917,1040251998,16253937,17.7),(434,'BCG','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,434,38.32,0.35,420,168,60,NULL,'ABELL 2700, BCG','2MASX J00034964+0203594',0.0978,'1980ApJ...241..486H',1980,1,0.64,NULL,'G',0.0001,NULL,'16.17',0.37,'cD','Brightest group member',NULL,NULL,NULL,1,0.956917,2.06664,0.069,NULL,66586057936,1040407155,16256361,16.17),(435,'BCG','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,435,38.32,0.35,420,169,60,NULL,NULL,'ABELL 2700',0.0978,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II:    [BM]',NULL,NULL,NULL,NULL,1,0.960833,2.06333,0.069,NULL,66586055958,1040407124,16256361,NULL),(436,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',436,36.92,0.33,242,170,70,NULL,NULL,'2MASX J00035107-1048382',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000077,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,0.962875,-10.81078,0.079,NULL,34595667728,540557308,8446207,17.2),(437,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,437,35.33,0.5,116,171,NULL,NULL,NULL,'AGC 400737',NULL,'2009ApJS..182..474S',2009,1,0.77,NULL,'G',0.000033,NULL,'16.21',0.25,'Sbc','Group member',NULL,NULL,NULL,1,0.964916666667,-50.76686,NULL,NULL,36029280971,562957515,8796211,16.21),(438,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,438,35.37,0.2,119,171,74.4,NULL,NULL,'AGC 400737',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(439,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,439,35.54,0.46,128,171,NULL,NULL,'Malmquist cor.','AGC 400737',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(440,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,440,35.24,0.84,112,172,NULL,NULL,'Malmquist cor.','AGC 101122',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',NULL,NULL,'15.8I',0.1,NULL,NULL,NULL,NULL,NULL,1,0.965417,10.99111,0.185,NULL,66790997792,1043609340,16306395,15.8),(441,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,441,35.32,0.81,116,172,NULL,NULL,NULL,'AGC 101122',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(442,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,442,35.93,0.53,153,173,70,NULL,NULL,'2MASX J00035182-1206094',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.50',0.34,NULL,NULL,NULL,NULL,NULL,1,0.966,-12.10253,0.056,NULL,34464376509,538505882,8414154,16.5),(443,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',443,38.59,0.46,522,174,70,NULL,NULL,'2MASX J00035579+0022394',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00012,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,0.9825,0.37756,0.065,NULL,66572356282,1040193066,16253016,17.8),(444,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 08883','RN',444,39.46,5.67,710,175,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08883',0.099873,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(445,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,445,36.3,0.61,182,176,70,NULL,NULL,'2MASX J00035710-6146566',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'16.17',0.46,NULL,NULL,NULL,NULL,NULL,1,0.988125,-61.78247,0,NULL,36075321392,563676896,8807451,16.17),(446,'IRAS','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,446,32.29,0.8,28.7,177,75,NULL,'A82, H','NGC 7817',NULL,'1997ApJS..109..333W',1997,1,3.5,NULL,'G',0.000013,NULL,'12.56',0.9,'SAbc: sp','Pair member, wide',NULL,NULL,NULL,1,0.9954583,20.75233,0.133,NULL,66710389477,1042349835,16286716,12.56),(447,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,447,31.57,0.4,20.6,177,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 7817',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(448,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,448,31.58,0.47,20.7,177,NULL,NULL,'H','NGC 7817',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(449,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,449,31.58,0.46,20.7,177,NULL,NULL,'J','NGC 7817',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(450,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,450,31.63,0.45,21.2,177,NULL,NULL,'K','NGC 7817',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(451,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,451,31.86,0.47,23.5,177,75,NULL,'A82, H, raw','NGC 7817',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(452,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,452,31.89,0.4,23.9,177,NULL,NULL,'mean','NGC 7817',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(453,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,453,31.98,0.47,24.9,177,75,NULL,'A82, H, inv','NGC 7817',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(454,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',454,32.01,0.4,25.3,177,75,NULL,NULL,'NGC 7817',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(455,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,455,32.02,0.4,25.3,177,73,NULL,'IR','NGC 7817',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(456,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,456,32.1,0.38,26.3,177,NULL,NULL,NULL,'NGC 7817',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(457,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',457,32.16,0.49,27.1,177,75,NULL,'IR','NGC 7817',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(458,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,458,32.2,0.47,27.5,177,75,NULL,'A82, H, cor','NGC 7817',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(459,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,459,32.21,0.39,27.7,177,73,NULL,'opt','NGC 7817',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(460,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,460,32.28,0.48,28.6,177,NULL,NULL,'Malmquist cor.','NGC 7817',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(461,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,461,32.31,0.43,29,177,75,NULL,'3.6 micron, color corrected','NGC 7817',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(462,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,462,32.33,0.2,29.2,177,74.4,NULL,NULL,'NGC 7817',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(463,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,463,32.36,0.43,29.7,177,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7817',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(464,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,464,32.49,0.44,31.4,177,NULL,NULL,NULL,'NGC 7817',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(465,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,465,32.49,0.4,31.5,177,75,NULL,'B','NGC 7817',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(466,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,466,35.14,0.53,107,178,NULL,NULL,NULL,'ESO 193- G 013',NULL,'2009ApJS..182..474S',2009,1,1.23,NULL,'G',0.000033,NULL,'15.17',0.33,'SA:(r)c',NULL,NULL,NULL,NULL,1,1.005167,-51.39408,NULL,NULL,35996413275,562443957,8788186,15.17),(467,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,467,35.18,0.2,109,178,74.4,NULL,NULL,'ESO 193- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(468,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,468,35.24,0.51,112,178,NULL,NULL,'Malmquist cor.','ESO 193- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(469,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2008hj',NULL,469,36.12,0.21,161,179,73.8,NULL,'SALT 2 (SNANA)','MCG -02-01-014',0.0366,'2014ApJ...795...44R',2014,1,1.1,NULL,'G',0.00013,NULL,'14.5',0.9,'SB(rs)c:',NULL,NULL,NULL,NULL,1,1.006375,-11.17428,0.079,NULL,34595063945,540547874,8446060,14.5),(470,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2008hj','R',470,36.08,0.09,164,179,NULL,NULL,'MLCS2k2, R(V) = 1.8','MCG -02-01-014',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(471,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2008hj','R',471,36.13,0.09,168,179,NULL,NULL,'MLCS2k2, R(V) = 3.1','MCG -02-01-014',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(472,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',472,36.92,0.33,242,180,70,NULL,NULL,'2MASX J00040165-1049485',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000096,NULL,'16.2g',0.38,'S0',NULL,NULL,NULL,NULL,1,1.00675,-10.83022,0.079,NULL,34595623985,540556624,8446197,16.2),(473,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',473,37.82,0.27,367,181,70,NULL,NULL,'2MASX J00040186+0029375',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,1.007875,0.49375,0.065,NULL,66575815958,1040247124,16253861,16.8),(474,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',474,37.82,0.27,367,182,70,NULL,NULL,'2MASX J00040259+0028345',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000103,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,1.01091666667,0.47636,0.065,NULL,66575825177,1040247268,16253863,17.4),(475,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,475,32.7,NULL,34.7,183,NULL,NULL,NULL,'FGC 0001',NULL,'2000BSAO...50....5K',2000,1,0.78,NULL,'G',0.00002,NULL,'16.7',0.11,'Sm',NULL,NULL,NULL,NULL,1,1.0125,-6.97917,0.178,NULL,34388213652,537315838,8395559,16.7),(476,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,476,33.19,NULL,43.5,183,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(477,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,477,33.21,NULL,43.9,183,NULL,NULL,'Dipole + Quadrupole','FGC 0001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(478,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,478,33.24,NULL,44.5,183,NULL,NULL,'Dipole','FGC 0001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(479,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,479,36.62,0.66,210,184,70,NULL,NULL,'2MASX J00040601-5134568',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,1.025167,-51.5825,NULL,NULL,35996327788,562442621,8788165,17.1),(480,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',480,37.82,0.27,367,185,70,NULL,NULL,'2MASX J00040639+0033035',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000089,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,1.02675,0.551,0.097,NULL,66575843767,1040247558,16253868,17),(481,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 19749','RN',481,43.45,0.25,3330,186,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19749',0.471736,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(482,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',482,37.52,0.46,320,187,70,NULL,NULL,'2MASX J00041012+0040125',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000088,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,1.04216666667,0.67019,0.097,NULL,66575830497,1040247351,16253864,17.5),(483,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 05104','RN',483,41.06,0.26,1340,188,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 05104',0.213758,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(484,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 05104','RN',484,41.83,0.31,1910,188,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 05104',0.213758,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(485,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,485,35.13,0.52,106,189,70,NULL,NULL,'MCG -03-01-017',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.13',0.2,NULL,NULL,NULL,NULL,NULL,1,1.0502917,-14.52367,0.059,NULL,34467842022,538560031,8415000,15.13),(486,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 11858',NULL,486,39.88,0.54,947,190,70,NULL,'SN photometric redshift distance, z photo =0.252 +/- 0.087','SDSS-II SN 11858',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','20.4g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,1.052083,0.3595,0.065,NULL,66575810617,1040247040,16253860,20.4),(487,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 11858','R',487,41.27,0.36,1390,190,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 11858',0.291263,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(488,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 11858','R',488,41.29,0.48,1400,190,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 11858',0.291263,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(489,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,489,34.77,0.41,89.9,191,NULL,NULL,'Malmquist cor.','UGC 00023',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.0001,NULL,'14.73',0.9,'SB(rs)b',NULL,NULL,NULL,NULL,1,1.054333,10.79017,0.185,NULL,66791121617,1043611275,16306426,14.73),(490,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,490,35.09,0.35,104,191,NULL,NULL,NULL,'UGC 00023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(491,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,491,35.14,0.2,107,191,74.4,NULL,NULL,'UGC 00023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(492,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 17436','RN',492,40.44,0.12,1080,192,70,NULL,'SDSS CAND. SNII; MLCS2K2','SDSS-II SN 17436',0.138,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(493,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 17436','RN',493,40.95,0.22,1360,192,70,NULL,'SDSS CAND. SNII; SALT 2','SDSS-II SN 17436',0.138,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(494,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',494,37.59,0.46,330,193,70,NULL,NULL,'2MASX J00041358+0046465',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000087,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,1.056667,0.77958,0.097,NULL,66576025827,1040250403,16253912,17),(495,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,495,35.92,0.58,153,194,NULL,NULL,NULL,'2MASX J00041398-5113247',NULL,'2009ApJS..182..474S',2009,1,0.43,NULL,'G',0.000033,NULL,'17.05',0.2,'S0','Group member',NULL,NULL,NULL,1,1.058333,-51.22347,NULL,NULL,35996375572,562443368,8788177,17.05),(496,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,496,35.96,0.2,156,194,74.4,NULL,NULL,'2MASX J00041398-5113247',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(497,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,497,36.05,0.54,162,194,NULL,NULL,'Malmquist cor.','2MASX J00041398-5113247',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(498,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,498,33.41,0.2,48.1,195,74.4,NULL,NULL,'UGC 00024',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000067,NULL,'15.18',0.6,'SBcd:',NULL,NULL,NULL,NULL,1,1.06125,22.58861,0.201,NULL,67445054890,1053828982,16466077,15.18),(499,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,499,33.7,0.39,55,195,NULL,NULL,NULL,'UGC 00024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(500,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,500,34.15,0.32,67.5,195,NULL,NULL,'Malmquist cor.','UGC 00024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(501,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,501,35.8,0.39,144,196,NULL,NULL,'Malmquist cor.','ESO 193- G 014',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000033,NULL,'15.08',0.6,'SAB(rs)b','Group member',NULL,NULL,NULL,1,1.062625,-50.64603,NULL,NULL,36029257944,562957155,8796205,15.08),(502,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,502,36.08,0.35,164,196,NULL,NULL,NULL,'ESO 193- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(503,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,503,36.12,0.2,167,196,74.4,NULL,NULL,'ESO 193- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(504,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 04267','RN',504,41.34,0.18,1430,197,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 04267',0.300355,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(505,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 04267','RN',505,41.71,0.29,1690,197,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04267',0.300355,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(506,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,506,37.3,0.67,288,198,70,NULL,NULL,'2MASX J00041814-2506060',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.30',0.18,'S',NULL,NULL,NULL,NULL,1,1.075625,-25.10175,0.038,NULL,34778080217,543407503,8490742,16.3),(507,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',507,36.54,0.46,203,199,70,NULL,NULL,'2MASX J00042184+0105215',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000089,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,1.0909583,1.08917,0.101,NULL,66575338694,1040239667,16253744,16.4),(508,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,508,33.12,0.2,42.1,200,74.4,NULL,NULL,'NGC 7819',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.00002,NULL,'14.18',1.2,'SB(s)b         HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,1.10225,31.47206,0.161,NULL,67210953604,1050171150,16408924,14.18),(509,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,509,34.48,0.2,78.7,201,74.4,NULL,NULL,'UGC 00025',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',NULL,NULL,'16.0',0.2,'Scd:',NULL,NULL,NULL,NULL,1,1.10429166667,6.17767,0.165,NULL,66613616375,1040837755,16263089,16),(510,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,510,34.51,0.42,79.9,201,NULL,NULL,'Malmquist cor.','UGC 00025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(511,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,511,34.53,0.41,80.5,201,NULL,NULL,NULL,'UGC 00025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(512,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',512,34.56,0.49,81.5,201,75,NULL,'IR','UGC 00025',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(513,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',513,37.84,0.33,370,202,70,NULL,NULL,'SDSS J000426.54+145554.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000152,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,1.11058333333,14.93192,0.133,NULL,66735511849,1042742372,16292849,18.5),(514,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,514,36.57,0.63,206,203,70,NULL,NULL,'2MASX J00042841-5254136',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'17.14',0.24,NULL,NULL,NULL,NULL,NULL,1,1.118333,-52.90386,NULL,NULL,35997568053,562462000,8788468,17.14),(515,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,515,33.24,0.2,44.5,204,74.4,NULL,NULL,'UGC 00027',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.000003,NULL,'14.70',1,'Scd:',NULL,NULL,NULL,NULL,1,1.120125,5.84711,0.165,NULL,66610033174,1040781768,16262215,14.7),(516,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,516,33.31,0.54,45.8,204,NULL,NULL,NULL,'UGC 00027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(517,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,517,33.46,0.5,49.2,204,NULL,NULL,'Malmquist cor.','UGC 00027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(518,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',518,33.98,0.49,62.6,204,75,NULL,'IR','UGC 00027',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(519,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',519,38.05,0.46,407,205,70,NULL,NULL,'2MASX J00043403+1426288',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000173,NULL,'17.7g',0.19,'BrClG',NULL,NULL,NULL,NULL,1,1.141667,14.44122,0.217,NULL,66734556153,1042727439,16292616,17.7),(520,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',520,38.4,0.27,479,206,70,NULL,NULL,'2MASX J00043571+0059549',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000088,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,1.14875,0.99853,0.101,NULL,66575317747,1040239339,16253739,17.7),(521,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',521,37.3,0.46,289,207,70,NULL,NULL,'2MASX J00043680-1022336',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000069,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,1.1532917,-10.37606,0.083,NULL,34595395565,540553055,8446141,17.6),(522,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',522,36.88,0.46,237,208,70,NULL,NULL,'2MASX J00044046+0035019',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000097,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,1.1685,0.58408,0.097,NULL,66575869525,1040247961,16253874,16.8),(523,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 02673','RN',523,40.32,0.11,1050,209,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02673 HOST',0.107515,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(524,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 03677','RN',524,40.35,0.11,1060,209,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02673 HOST',0.107515,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(525,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 03677','RN',525,40.35,0.21,1060,209,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02673 HOST',0.107515,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(526,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 02673','RN',526,40.39,0.21,1080,209,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02673 HOST',0.107515,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(527,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 13166','RN',527,39.23,0.47,559,210,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13166',0.257293,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(528,'D-Sigma','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,528,33.91,0.4,60.7,211,75,NULL,'Edat, raw','ESO 409- G 012',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000077,NULL,'14.48',0.9,'E?',NULL,NULL,NULL,NULL,1,1.17595833333,-30.48364,NULL,NULL,34793698937,543651545,8494555,14.48),(529,'D-Sigma','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,529,34.25,0.4,70.8,211,75,NULL,'Edat, cor','ESO 409- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(530,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,530,35.09,0.45,104,211,70,NULL,NULL,'ESO 409- G 012',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(531,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,531,35.12,0.45,106,211,NULL,NULL,'K','ESO 409- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(532,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,532,35.12,0.4,106,211,NULL,NULL,'mean','ESO 409- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(533,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',533,38.4,0.27,479,212,70,NULL,NULL,'2MASX J00044891+0057039',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.0001,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,1.20391666667,0.95114,0.101,NULL,66575308148,1040239189,16253737,16.5),(534,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',534,38.23,0.46,442,213,70,NULL,NULL,'2MASX J00044920+0028009',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00009,NULL,'17.6g',0.2,'BrClG',NULL,NULL,NULL,NULL,1,1.20495833333,0.46697,0.077,NULL,66575915594,1040248681,16253885,17.6),(535,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,535,35.73,0.47,140,214,70,NULL,NULL,'ESO 149- G 016',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00008,NULL,'14.70',0.6,'(R)SA0/a:',NULL,NULL,NULL,NULL,1,1.2154583,-54.48731,0,NULL,35990073038,562344891,8786638,14.7),(536,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',536,37.44,0.33,308,215,70,NULL,NULL,'SDSS J000451.99+002040.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,1.216625,0.34472,0.077,NULL,66575704153,1040245377,16253834,18),(537,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',537,37.84,0.33,370,216,70,NULL,NULL,'SDSS J000453.37+145558.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000178,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,1.222417,14.93294,0.145,NULL,66735504615,1042742259,16292847,17.8),(538,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,538,35.54,0.49,128,217,70,NULL,NULL,'FAIRALL 0154',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'15.71',0.55,'S0',NULL,NULL,NULL,NULL,1,1.242583,-60.02625,0,NULL,36078116186,563720565,8808133,15.71),(539,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',539,37.15,0.46,269,218,70,NULL,NULL,'2MASX J00045858+0057435',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000084,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,1.244125,0.96208,0.061,NULL,66575333589,1040239587,16253743,16.8),(540,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 09639','RN',540,45.48,1.99,11400,219,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 09639',0.095111,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(541,'GRB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',541,39.44,NULL,772,220,70,NULL,'Pseudo z = 0.2','GRB 030824',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,1.258333,19.91667,0.105,NULL,66707580113,1042305939,16286030,NULL),(542,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',542,37.58,0.46,329,221,70,NULL,NULL,'2MASX J00050279+1444181',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000139,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,1.2615,14.73839,0.133,NULL,66734617362,1042728396,16292631,18.2),(543,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 04019','R',543,39.7,0.19,738,222,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J000502.85+010847.0',0.181307,'2014arXiv1401.3317S',2014,1,0.16,NULL,'G',0.000078,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,1.261875,1.14639,0.061,NULL,66575357405,1040239959,16253749,18.5),(544,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 04019','R',544,39.72,0.11,742,222,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J000502.85+010847.0',0.181307,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(545,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 04019',NULL,545,39.57,0.08,820,222,70,NULL,'SALT 2','SDSS J000502.85+010847.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(546,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 04019',NULL,546,39.58,0.08,824,222,70,NULL,'SALT 2, Malmquist cor.','SDSS J000502.85+010847.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(547,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,547,36.01,0.59,159,223,70,NULL,NULL,'2MASX J00050371-5520325',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.03',0.53,'S0',NULL,NULL,NULL,NULL,1,1.2654583,-55.34236,0,NULL,35990605204,562353206,8786768,16.03),(548,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',548,37.37,0.46,298,224,70,NULL,NULL,'SDSS J000504.09+002354.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000051,NULL,'18.2g',0.13,'NLAGN',NULL,NULL,NULL,NULL,1,1.26708333333,0.3985,0.077,NULL,66575903294,1040248488,16253882,18.2),(549,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,549,36.83,0.58,233,225,70,NULL,NULL,'2MASX J00050534-5333071',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.97',0.25,NULL,NULL,NULL,NULL,NULL,1,1.272375,-53.552,NULL,NULL,36000924923,562514451,8789288,16.97),(550,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,550,33.38,0.47,47.4,226,NULL,NULL,'H','IC 1528',NULL,'2007A&A...465...71T',2007,1,2.4,'MCG RA is -0.5 minutes in error.','G',0.00001,NULL,'13.50',1.1,'SB(r)b:        HII',NULL,NULL,NULL,NULL,1,1.272375,-7.09342,0.172,NULL,34386220374,537284693,8395073,13.5),(551,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,551,33.41,0.46,48.1,226,NULL,NULL,'J','IC 1528',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(552,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,552,33.44,0.45,48.9,226,NULL,NULL,'K','IC 1528',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(553,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,553,33.45,0.4,49.1,226,NULL,NULL,'mean','IC 1528',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(554,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 11877','RN',554,40.51,0.45,1000,227,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 11877',0.261404,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(555,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 11877','RN',555,40.89,0.3,1200,227,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 11877',0.261404,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(556,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,556,34.51,0.34,79.7,228,NULL,NULL,'Malmquist cor.','NGC 7824',NULL,'2009ApJS..182..474S',2009,1,1.6,NULL,'G',0.00015,NULL,'14.07',1.2,'Sab','in a pair',NULL,NULL,NULL,1,1.2759583,6.92011,0.165,NULL,66612939493,1040827179,16262924,14.07),(557,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,557,34.72,0.31,87.9,228,NULL,NULL,NULL,'NGC 7824',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(558,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,558,35.12,0.2,106,228,74.4,NULL,NULL,'NGC 7824',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(559,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,559,36.67,0.54,215,229,70,NULL,NULL,'2MASX J00050967-5358015',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.70',0.39,NULL,NULL,NULL,NULL,NULL,1,1.29016666667,-53.96706,0,NULL,36000825451,562512897,8789264,16.7),(560,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',560,37.44,0.33,308,230,70,NULL,NULL,'2MASX J00051032+0028055',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000107,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,1.2930417,0.46811,0.077,NULL,66575771260,1040246425,16253850,16.4),(561,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 03423','RN',561,38.43,0.27,447,231,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03423',0.085019,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(562,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',562,37.06,0.46,258,232,70,NULL,NULL,'2MASX J00051061-1029273',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000112,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,1.29429166667,-10.49108,0.081,NULL,34595330804,540552043,8446125,17.3),(563,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,563,35.07,0.47,103,233,70,NULL,NULL,'2MASX J00051125-5020531',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'15.75',0.37,'E','Group member',NULL,NULL,NULL,1,1.296833,-50.34808,NULL,NULL,35974949729,562108589,8782946,15.75),(564,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',564,38.4,0.27,479,234,70,NULL,NULL,'SDSS J000512.26+005749.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,1.301083,0.96378,0.061,NULL,66575332423,1040239569,16253743,18.5),(565,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',565,36.63,0.46,212,235,70,NULL,NULL,'2MASX J00051388-1105583',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000069,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,1.30783333333,-11.09958,0.081,NULL,34594903018,540545359,8446021,17.4),(566,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,566,34.64,0.44,84.8,236,NULL,NULL,'Malmquist cor.','UGC 00036',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000043,NULL,'14.45',0.6,'SA(r)a:','in a pair',NULL,NULL,NULL,1,1.307875,6.772,0.165,NULL,66613115335,1040829927,16262967,14.45),(567,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,567,34.68,0.4,86.5,236,NULL,NULL,'mean','UGC 00036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(568,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,568,34.81,0.45,91.7,236,NULL,NULL,'K','UGC 00036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(569,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,569,34.82,0.47,92,236,NULL,NULL,'H','UGC 00036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(570,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,570,34.84,0.4,92.8,236,NULL,NULL,NULL,'UGC 00036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(571,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,571,34.88,0.2,94.6,236,74.4,NULL,NULL,'UGC 00036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(572,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,572,34.88,0.46,94.7,236,NULL,NULL,'J','UGC 00036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(573,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 13687','RN',573,42.85,0.31,2820,237,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13687',0.318451,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(574,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,574,34.68,0.47,86.3,238,NULL,NULL,'H','NGC 7821',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000033,NULL,'13.77',0.5,'Scd pec sp',NULL,NULL,NULL,NULL,1,1.31966666667,-16.47692,0.047,NULL,34481759473,538777491,8418398,13.77),(575,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,575,34.75,0.45,89.1,238,NULL,NULL,'K','NGC 7821',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(576,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,576,34.76,0.46,89.4,238,NULL,NULL,'J','NGC 7821',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(577,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,577,34.91,0.4,95.8,238,NULL,NULL,'mean','NGC 7821',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(578,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,578,35.01,0.2,100,238,74.4,NULL,NULL,'NGC 7821',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(579,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 14383','RN',579,43.86,0.27,3670,239,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 14383',0.614416,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(580,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 21858','R',580,40.78,0.39,1130,240,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21858',0.265672,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1.337083,1.06161,0.073,NULL,66575354812,1040239918,16253748,NULL),(581,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 21858','R',581,40.92,0.3,1210,240,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 21858',0.265672,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(582,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,582,36.36,0.62,187,241,70,NULL,NULL,'2MASX J00052708-1331368',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.84',0.18,NULL,NULL,NULL,NULL,NULL,1,1.362917,-13.52697,0.063,NULL,34475416470,538678382,8416849,16.84),(583,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,583,36.44,0.51,194,242,70,NULL,NULL,'2MASX J00052781-5034551',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'15.80',0.53,'E','Group member',NULL,NULL,NULL,1,1.3660417,-50.58194,NULL,NULL,36029934323,562967723,8796370,15.8),(584,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,584,35.08,1.31,104,243,NULL,NULL,'Malmquist cor.','ESO 193- G 019',NULL,'2009ApJS..182..474S',2009,1,1.9,'ESO-LV gives v= 9800+/-10 km/sec.','G',0.000033,NULL,'14.33',1.1,'SB(r)c','Group member',NULL,NULL,NULL,1,1.370917,-50.27031,NULL,NULL,35974988905,562109201,8782956,14.33),(585,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,585,36.02,0.85,160,243,NULL,NULL,NULL,'ESO 193- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(586,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,586,36.06,0.2,163,243,74.4,NULL,NULL,'ESO 193- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(587,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,587,35.67,0.32,136,244,NULL,NULL,'Malmquist cor.','ESO 193- G 018',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000033,NULL,'14.70',0.6,'SAB(s)ab:',NULL,NULL,NULL,NULL,1,1.37191666667,-49.62031,NULL,NULL,35978542735,562164730,8783823,14.7),(588,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,588,35.75,0.31,141,244,NULL,NULL,NULL,'ESO 193- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(589,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,589,35.79,0.2,144,244,74.4,NULL,NULL,'ESO 193- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(590,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',590,38.3,0.46,458,245,70,NULL,NULL,'2MASX J00053002+1415411',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000192,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,1.37525,14.26144,0.217,NULL,66734533271,1042727082,16292610,18),(591,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 18892','R',591,40.75,0.13,1240,246,70,NULL,'SDSS CAND. SNII; MLCS2K2','SN 2007nv',0.138,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'II-P',NULL,NULL,NULL,NULL,1,1.376417,-1.20456,0.057,NULL,34362912732,536920511,8389382,NULL),(592,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 18892','R',592,41.25,0.23,1560,246,70,NULL,'SDSS CAND. SNII; SALT 2','SN 2007nv',0.138,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(593,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,593,29.7,0.1,8.71,247,74.4,NULL,NULL,'ESO 409-IG 015',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'GPair',0.00002,NULL,NULL,NULL,'Double? system',NULL,NULL,NULL,NULL,1,1.3827083,-28.09817,0.086,NULL,34821630678,544087979,8501374,NULL),(594,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,594,29.43,NULL,7.69,247,NULL,NULL,NULL,'ESO 409-IG 015',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(595,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,595,34.89,0.69,95.1,248,100,NULL,'mid-IR','UGC 00039',NULL,'2013ApJ...771...88L',2013,1,1.2,'abs(b) < 10 degrees.','G',0.000023,NULL,'17.',0.6,'Scd:',NULL,NULL,NULL,NULL,1,1.392917,53.63133,NULL,NULL,65815907941,1028373561,16068336,17),(596,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,596,35.77,0.2,143,248,74.4,NULL,NULL,'UGC 00039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(597,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,597,36.71,0.52,220,249,70,NULL,NULL,'2MASX J00053994-5349010',NULL,'2014MNRAS.445.2677S',2014,1,1.8,'The APMUKS position is 11.5 arcsec southeast of the nucleus.','G',0.00008,NULL,'15.53',1.1,'SA(r)0-:',NULL,NULL,NULL,NULL,1,1.4164583,-53.81692,NULL,NULL,36001733701,562527089,8789485,15.53),(598,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,598,33.92,NULL,60.8,250,NULL,NULL,'Dipole + Quadrupole + Octopole','FGCE 0006',NULL,'2010Ap&SS.325..163P',2010,1,0.94,NULL,'G',NULL,NULL,'17.2',0.1,'Scd',NULL,NULL,NULL,NULL,1,1.42116666667,-48.98019,NULL,NULL,35977356050,562146188,8783534,17.2),(599,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,599,33.94,NULL,61.3,250,NULL,NULL,'Dipole + Quadrupole','FGCE 0006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(600,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,600,33.95,NULL,61.6,250,NULL,NULL,'Dipole','FGCE 0006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(601,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,601,34.04,NULL,64.4,250,NULL,NULL,NULL,'FGCE 0006',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(602,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,602,36.22,0.52,175,251,70,NULL,NULL,'2MASX J00054453-1836506',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.000103,NULL,'16.17',0.35,NULL,NULL,NULL,NULL,NULL,1,1.4354583,-18.61431,0.028,NULL,34441048263,538141379,8408459,16.17),(603,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2003it',NULL,603,32.76,0.2,34.8,252,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','UGC 00040',0.025121,'2011A&A...526A..81B',2011,1,1.1,NULL,'G',0.000003,NULL,'14.92',0.7,'SB?',NULL,NULL,NULL,NULL,1,1.4517083,27.44942,0.121,NULL,67230966382,1050483849,16413810,14.92),(604,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2003it',NULL,604,34.44,0.19,75.4,252,74.2,NULL,'SALT 2','UGC 00040',0.025121,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(605,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2003it',NULL,605,35.02,0.02,98.5,252,72,NULL,'MLCS31','UGC 00040',0.025121,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(606,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2003it',NULL,606,35.08,0.08,104,252,74.4,NULL,NULL,'UGC 00040',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(607,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2003it',NULL,607,35.13,0.17,104,252,73.8,NULL,'SALT 2 (SNANA)','UGC 00040',0.0243,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(608,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2003it',NULL,608,35.25,0.19,109,252,65,NULL,'MLCS31','UGC 00040',0.025121,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(609,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2003it',NULL,609,35.28,0.19,111,252,65,NULL,'MLCS17','UGC 00040',0.025121,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(610,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2003it',NULL,610,35.36,0.19,115,252,65,NULL,'SALT','UGC 00040',0.025121,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(611,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2003it',NULL,611,35.38,0.21,116,252,65,NULL,'SALT2','UGC 00040',0.025121,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(612,'IRAS','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,612,35,0.8,100,252,75,NULL,'W91PP, r','UGC 00040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(613,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,613,34.41,0.69,76,252,100,NULL,'mid-IR','UGC 00040',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(614,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,614,34.97,0.42,98.5,252,NULL,NULL,'Malmquist cor.','UGC 00040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(615,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,615,35,0.38,100,252,75,NULL,'W91PP, r, raw','UGC 00040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(616,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,616,35.03,0.41,101,252,NULL,NULL,NULL,'UGC 00040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(617,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,617,35.08,0.08,104,252,74.4,NULL,NULL,'UGC 00040',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(618,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,618,35.17,0.38,108,252,75,NULL,'W91PP, r, cor','UGC 00040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(619,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,619,35.18,0.4,109,252,NULL,NULL,'mean','UGC 00040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(620,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,620,35.2,0.38,110,252,75,NULL,'W91PP, r, inv','UGC 00040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(621,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,621,35.26,0.4,113,252,75,NULL,'HOSTS SN 2003it','UGC 00040',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(622,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,622,35.43,0.47,122,252,NULL,NULL,'H','UGC 00040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(623,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,623,35.51,0.45,127,252,NULL,NULL,'K','UGC 00040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(624,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 07835','RN',624,41.29,0.29,1560,253,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07835',0.156922,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(625,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 07835','RN',625,41.35,0.37,1610,253,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07835',0.156922,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(626,'IRAS','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,626,34.7,0.8,86.9,254,75,NULL,'W91PP, r','UGC 00041',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000033,NULL,'16.0',0.3,'SBcd:',NULL,NULL,NULL,NULL,1,1.48375,22.49258,0.133,NULL,67444977070,1053827766,16466058,16),(627,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,627,34.68,0.2,86.3,254,74.4,NULL,NULL,'UGC 00041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(628,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,628,34.7,0.44,87,254,NULL,NULL,NULL,'UGC 00041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(629,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,629,34.71,0.44,87.5,254,NULL,NULL,'Malmquist cor.','UGC 00041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(630,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,630,34.78,0.38,90.5,254,75,NULL,'W91PP, r, raw','UGC 00041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(631,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,631,34.8,0.38,91,254,75,NULL,'W91PP, r, inv','UGC 00041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(632,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',632,34.81,0.49,91.8,254,75,NULL,'IR','UGC 00041',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(633,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,633,34.92,0.38,96.3,254,75,NULL,'W91PP, r, cor','UGC 00041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(634,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,634,34.72,0.63,88.1,255,70,NULL,NULL,'MCG -02-01-023',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000073,NULL,'15.7b',0.2,NULL,NULL,NULL,NULL,NULL,1,1.4870417,-13.99575,0.065,NULL,34476402377,538693787,8417090,15.7),(635,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 17208','R',635,39.45,0.21,680,256,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ic','SDSS J000557.98+010611.1',0.14,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,':',NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1.49158333333,1.10308,0.081,NULL,66573333001,1040208328,16253255,NULL),(636,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 17208','R',636,39.7,0.12,763,256,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ic','SDSS J000557.98+010611.1',0.14,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(637,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,637,35.59,0.6,131,257,70,NULL,NULL,'2MASX J00055956-5316358',NULL,'2014MNRAS.445.2677S',2014,1,0.87,'The APMUKS position is 12 arcsec southeast of the nucleus.','G',0.00015,NULL,'15.12',0.57,'S0',NULL,NULL,NULL,NULL,1,1.49825,-53.27661,NULL,NULL,36001359352,562521239,8789394,15.12),(638,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,638,35.49,0.49,125,258,70,NULL,NULL,'ESO 193- G 022',NULL,'2014MNRAS.445.2677S',2014,1,0.97,NULL,'G',0.000067,NULL,'14.32',0.57,'SA0-:','Pair member (points to parent)',NULL,NULL,NULL,1,1.514875,-52.21881,NULL,NULL,35999690706,562495167,8788986,14.32),(639,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',639,36.78,0.46,227,259,70,NULL,NULL,'2MASX J00060574+1358440',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000184,NULL,'16.4g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,1.523875,13.97883,0.205,NULL,66739248174,1042800752,16293761,16.4),(640,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',640,36.85,0.46,234,260,70,NULL,NULL,'2MASX J00060707-0856222',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000088,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,1.529375,-8.9395,0.085,NULL,34377953833,537155528,8393055,16.8),(641,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,641,35.96,0.49,156,261,70,NULL,NULL,'ESO 193- G 023',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.05',0.3,'S0','Group member',NULL,NULL,NULL,1,1.5347083,-50.64753,NULL,NULL,36029963877,562968185,8796377,15.05),(642,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 11798','RN',642,41.39,0.23,1430,262,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 11798',0.327498,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(643,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 11798','RN',643,41.48,0.36,1490,262,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 11798',0.327498,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(644,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2000dg',NULL,644,36.02,0.18,154,263,70,NULL,'SALT 2','CGCG 408-029',0.03849,'2013MNRAS.433.2240G',2013,1,1.1,NULL,'G',NULL,NULL,'15.40',0.4,'S?',NULL,NULL,NULL,NULL,1,1.5595417,8.88781,0.273,NULL,66608351976,1040755499,16261804,15.4),(645,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 02552','RN',645,39.52,0.09,735,264,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02552',0.08979,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(646,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 02552','RN',646,40.04,0.2,936,264,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02552',0.08979,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(647,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,647,35.68,0.49,137,265,70,NULL,NULL,'2MASX J00061530-5246408',NULL,'2014MNRAS.445.2677S',2014,1,1.7,'The APMUKS image includes a superposed star.','G',0.000133,NULL,'15.0b',1.1,'(R\')SA0^0^:',NULL,NULL,NULL,NULL,1,1.5637083,-52.77803,NULL,NULL,35996948574,562452321,8788317,15),(648,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',648,37.92,0.46,384,266,70,NULL,NULL,'SDSS J000616.19+143438.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000144,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,1.56745833333,14.57739,0.137,NULL,66734187723,1042721683,16292526,18.6),(649,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',649,36.79,0.46,228,267,70,NULL,NULL,'2MASX J00061735+0027407',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000099,NULL,'17.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,1.5722917,0.46139,0.061,NULL,66573752400,1040214881,16253357,17),(650,'AGN time lag','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,650,35.82,0.24,146,268,NULL,NULL,NULL,'MRK 0335',NULL,'2014ApJ...784L..11Y',2014,1,0.3,NULL,'G',0.000063,NULL,'14.0B',0.3,'S0/a           Sy1.2',NULL,NULL,NULL,'Sy 1',1,1.581333,20.20292,0.101,NULL,66708991033,1042327984,16286374,14),(651,'AGN time lag','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,651,36.7,0.47,219,268,44,NULL,NULL,'MRK 0335',NULL,'2007MNRAS.380..669C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(652,'Black Hole','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,652,34.67,0.58,85.9,268,NULL,NULL,NULL,'MRK 0335',NULL,'2014ApJ...793..108W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(653,'Tully est','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,653,31.31,0.8,18.3,269,75,NULL,NULL,'ESO 293-IG 034',NULL,'1988NBGC.C....0000T',1988,1,3.2,NULL,'G',0.000019,NULL,'13.70',1,'SB(s)cd pec sp','Pair member (points to parent)',NULL,NULL,NULL,1,1.5829583,-41.49992,NULL,NULL,34642566690,541290104,8457657,13.7),(654,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',654,31.6,0.4,20.9,269,75,NULL,NULL,'ESO 293-IG 034',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(655,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,655,31.6,0.4,20.9,269,73,NULL,'IR','ESO 293-IG 034',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(656,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,656,31.6,0.4,20.9,269,73,NULL,'opt','ESO 293-IG 034',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(657,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',657,32.48,0.49,31.3,269,75,NULL,'IR','ESO 293-IG 034',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(658,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',658,37.73,0.33,351,270,70,NULL,NULL,'2MASX J00062078+1352259',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000185,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,1.5867917,13.87378,0.161,NULL,66739304212,1042801628,16293775,17.3),(659,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,659,36.04,0.55,161,271,NULL,NULL,'Malmquist cor.','2MASX J00062236-5010027',NULL,'2009ApJS..182..474S',2009,1,0.54,NULL,'G',0.000033,NULL,'16.56',0.19,'S','Group member',NULL,NULL,NULL,1,1.59325,-50.16747,NULL,NULL,35975069692,562110463,8782975,16.56),(660,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,660,36.14,0.53,169,271,NULL,NULL,NULL,'2MASX J00062236-5010027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(661,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,661,36.18,0.2,172,271,74.4,NULL,NULL,'2MASX J00062236-5010027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(662,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 19078','R',662,41.45,0.24,1390,272,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19078',0.400479,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,'PHOT','21.8g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,1.5954583,1.05142,0.081,NULL,66573521119,1040211267,16253301,21.8),(663,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 19078','R',663,41.5,0.28,1420,272,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19078',0.400479,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(664,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 19078',NULL,664,41.24,0.22,1770,272,70,NULL,'SN photometric redshift distance, z photo =0.553 +/- 0.087','SDSS-II SN 19078',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(665,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 19078',NULL,665,41.42,0.18,1920,272,70,NULL,'SALT 2','SDSS-II SN 19078',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(666,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 19078',NULL,666,41.49,0.18,1990,272,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19078',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(667,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 13168',NULL,667,40.02,0.29,1010,273,70,NULL,'SN photometric redshift distance, z photo =0.271 +/- 0.046','SDSS-II SN 13168',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,1.601583,0.62139,0.061,NULL,66573883324,1040216926,16253389,NULL),(668,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 13101','RN',668,41.19,0.35,1270,274,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13101',0.368376,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(669,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 13101','RN',669,41.21,0.31,1270,274,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13101',0.368376,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(670,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 13101','N',670,41.08,0.25,1640,274,70,NULL,'SALT 2','SDSS-II SN 13101',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(671,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 13101','N',671,41.13,0.25,1680,274,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13101',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(672,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 19338',NULL,672,39.93,0.34,966,275,70,NULL,'SN photometric redshift distance, z photo =0.258 +/- 0.052','SDSS-II SN 19338',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,1.6044583,0.36878,0.061,NULL,66573738308,1040214661,16253354,NULL),(673,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',673,37.94,0.33,388,276,70,NULL,NULL,'2MASX J00062620-0111111',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000092,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,1.60925,-1.18636,0.097,NULL,34362388103,536912314,8389254,17.6),(674,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,674,34.57,0.4,82.2,277,NULL,NULL,'mean','NGC 7828',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.00005,NULL,'14.4',0.5,'Im pec (Ring B)',NULL,NULL,NULL,NULL,1,1.6127917,-13.41611,0.063,NULL,34477055234,538703988,8417249,14.4),(675,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,675,34.75,0.47,89.3,277,NULL,NULL,'H','NGC 7828',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(676,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,676,34.8,0.45,91.2,277,NULL,NULL,'K','NGC 7828',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(677,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,677,34.33,0.46,73.4,278,70,NULL,NULL,'NGC 7832',NULL,'2014MNRAS.445.2677S',2014,1,1.9,NULL,'G',0.00004,NULL,'13.89',1,'E+       poss. LINER',NULL,NULL,NULL,NULL,1,1.61858333333,-3.71614,0.133,NULL,34365762898,536965045,8390078,13.89),(678,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',678,37.52,0.46,320,279,70,NULL,NULL,'2MASX J00062852-0947496',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000077,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,1.618833,-9.79731,0.091,NULL,34597038466,540578726,8446542,17.9),(679,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,679,35.86,0.52,148,280,70,NULL,NULL,'2MASX J00062878-5349382',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'13.23',0.24,NULL,NULL,NULL,NULL,NULL,1,1.61995833333,-53.82731,NULL,NULL,36001699407,562526553,8789477,13.23),(680,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 14877','RN',680,40.2,0.28,1050,281,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 14877',0.044242,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(681,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 14877','RN',681,40.96,0.34,1490,281,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 14877',0.044242,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(682,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',682,37.94,0.33,388,282,70,NULL,NULL,'2MASX J00062940-0112141',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000078,NULL,'18.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,1.6225417,-1.20386,0.097,NULL,34373669555,537088586,8392009,18),(683,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',683,37.73,0.33,351,283,70,NULL,NULL,'2MASX J00063015+1351546',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000143,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,1.625625,13.86503,0.161,NULL,66739305205,1042801643,16293775,17.4),(684,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,684,36.11,0.63,167,284,70,NULL,NULL,'2MASX J00063171-1228514',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,1.632125,-12.48094,0.08,NULL,34463082461,538485663,8413838,16.7),(685,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,685,36.37,0.73,188,285,70,NULL,NULL,'2MASX J00063271-5210412',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.00015,NULL,'16.84',0.17,NULL,NULL,NULL,NULL,NULL,1,1.63629166667,-52.17808,NULL,NULL,35999669533,562494836,8788981,16.84),(686,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,686,28.97,0.1,6.23,286,74.4,NULL,NULL,'AGC 748778',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000027,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1.642917,15.51083,0.093,NULL,66766515882,1043226810,16300418,NULL),(687,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,687,29.05,0.05,6.46,286,NULL,NULL,'I','AGC 748778',NULL,'2014ApJ...785....3M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(688,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',688,37.51,0.46,318,287,70,NULL,NULL,'2MASX J00063625-0028231',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',NULL,NULL,'16.42',0.29,NULL,NULL,NULL,NULL,NULL,1,1.651125,-0.47308,0.053,NULL,34362661673,536916588,8389321,16.42),(689,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,689,36.79,0.74,228,288,70,NULL,NULL,'2MASX J00063790-5311542',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.66',0.42,NULL,NULL,NULL,NULL,NULL,1,1.6580417,-53.19842,NULL,NULL,35996987226,562452925,8788326,16.66),(690,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 04110',NULL,690,40.08,0.47,1040,289,70,NULL,'SN photometric redshift distance, z photo =0.280 +/- 0.083','SDSS-II SN 04110',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.7g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,1.6582083,-1.19653,0.097,NULL,34373672159,537088627,8392009,21.7),(691,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 04110','R',691,41.72,0.29,1610,289,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 04110',0.373667,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(692,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 04110','R',692,41.89,0.28,1730,289,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 04110',0.373667,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(693,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 04110',NULL,693,41.67,0.18,2160,289,70,NULL,'SALT 2','SDSS-II SN 04110',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(694,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 04110',NULL,694,41.73,0.18,2220,289,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 04110',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(695,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,695,31.63,NULL,21.2,290,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00047',NULL,'2010Ap&SS.325..163P',2010,1,1.14,NULL,'G',0.000013,NULL,'17.',0.15,'Sdm',NULL,NULL,NULL,NULL,1,1.659833,17.28428,0.057,NULL,66712202962,1042378171,16287158,17),(696,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,696,31.65,NULL,21.4,290,NULL,NULL,'Dipole + Quadrupole','UGC 00047',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(697,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,697,31.69,NULL,21.8,290,NULL,NULL,'Dipole','UGC 00047',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(698,'IRAS','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,698,35.01,0.8,100,291,75,NULL,'W91PP, r','UGC 00050',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000023,NULL,'14.97',0.3,'Sab            LINER',NULL,NULL,NULL,NULL,1,1.6672917,26.15453,0.129,NULL,67187582056,1049805969,16403218,14.97),(699,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,699,34.89,0.38,95,291,75,NULL,'W91PP, r, raw','UGC 00050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(700,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,700,35.06,0.38,103,291,75,NULL,'W91PP, r, inv','UGC 00050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(701,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,701,35.06,0.38,103,291,75,NULL,'W91PP, r, cor','UGC 00050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(702,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,702,35.08,0.2,104,291,74.4,NULL,NULL,'UGC 00050',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(703,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,703,35.18,0.4,109,291,NULL,NULL,'mean','UGC 00050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(704,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,704,35.46,0.47,124,291,NULL,NULL,'H','UGC 00050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(705,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,705,33.53,0.69,50.8,292,100,NULL,'mid-IR','UGC 00051',NULL,'2013ApJ...771...88L',2013,1,0.9,NULL,'G',0.000017,NULL,'15.02',0.6,'SBbc',NULL,NULL,NULL,NULL,1,1.6682083,5.11347,0.165,NULL,66630178010,1041096531,16267133,15.02),(706,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,706,34.84,0.45,92.9,292,NULL,NULL,'Malmquist cor.','UGC 00051',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(707,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,707,34.91,0.2,95.9,292,74.4,NULL,NULL,'UGC 00051',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(708,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,708,35.03,0.41,101,292,NULL,NULL,NULL,'UGC 00051',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(709,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',709,37.98,0.46,395,293,70,NULL,NULL,'2MASX J00064112-0037000',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00009,NULL,'17.1g',0.08,NULL,NULL,NULL,NULL,NULL,1,1.671417,-0.61672,0.057,NULL,34362650627,536916416,8389319,17.1),(710,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 13451','RN',710,42.59,0.27,2460,294,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 13451',0.338519,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(711,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 13451','RN',711,42.83,0.37,2750,294,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 13451',0.338519,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(712,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,712,36.15,0.58,170,295,70,NULL,NULL,'2MASX J00064296-6043467',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.51',0.24,NULL,NULL,NULL,NULL,NULL,1,1.679167,-60.72956,0,NULL,36079355493,563739929,8808436,16.51),(713,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',713,37.74,0.46,353,296,70,NULL,NULL,'2MASX J00064512-0020180',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000093,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,1.688083,-0.33828,0.053,NULL,34362296497,536910882,8389232,17.3),(714,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2006jh',NULL,714,38.67,0.05,542,297,70,NULL,'Hubble residual 0.17 for z0.12490','SDSS-II SN 13894 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1.690583,-0.03675,0.053,NULL,34362133597,536908337,8389192,NULL),(715,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 13894','R',715,39.1,0.08,589,297,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006jh','SDSS-II SN 13894 HOST',0.121,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(716,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 13894','R',716,39.11,0.21,591,297,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006jh','SDSS-II SN 13894 HOST',0.121,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(717,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,717,34.45,0.2,77.6,298,74.4,NULL,NULL,'CGCG 408-033',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000043,NULL,'15.6',0.3,NULL,NULL,NULL,NULL,NULL,1,1.699333,4.93706,0.165,NULL,66630011828,1041093934,16267092,15.6),(718,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,718,34.54,0.42,80.8,298,NULL,NULL,'Malmquist cor.','CGCG 408-033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(719,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,719,34.57,0.41,82,298,NULL,NULL,NULL,'CGCG 408-033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(720,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,720,36.05,0.6,162,299,70,NULL,NULL,'2MASX J00064837-5106122',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.38',0.32,'S0','Group member',NULL,NULL,NULL,1,1.7015,-51.10347,NULL,NULL,36029498544,562960914,8796264,16.38),(721,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2002hw',NULL,721,33.7,0.21,54,300,74.2,NULL,'SALT 2','UGC 00052',0.017535,'2010ApJ...716..712A',2010,1,1.8,NULL,'G',0.000007,NULL,'14.1B',1.7,'SAc',NULL,NULL,NULL,NULL,1,1.70616666667,8.6285,0.273,NULL,66608403511,1040756304,16261817,14.1),(722,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2002hw',NULL,722,34.04,0.22,63.1,300,65,NULL,'MLCS31','UGC 00052',0.017535,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(723,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2002hw',NULL,723,34.2,0.04,68,300,72,NULL,'MLCS31','UGC 00052',0.017535,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(724,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2002hw',NULL,724,34.25,0.2,69.4,300,70,NULL,'SALT 2','UGC 00052',0.017535,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(725,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2002hw',NULL,725,34.27,0.09,71.5,300,74.4,NULL,NULL,'UGC 00052',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(726,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2002hw',NULL,726,34.33,0.21,72.2,300,65,NULL,'MLCS17','UGC 00052',0.017535,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(727,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2002hw',NULL,727,34.57,0.25,80.8,300,65,NULL,'SALT2','UGC 00052',0.017535,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(728,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2002hw',NULL,728,34.59,0.22,81.4,300,65,NULL,'SALT','UGC 00052',0.017535,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(729,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 18399','RN',729,39.94,0.14,838,301,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18399',0.158629,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(730,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 18399','RN',730,40.26,0.28,974,301,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18399',0.158629,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(731,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,731,34.96,0.49,98,302,NULL,NULL,'Malmquist cor.','UGC 00053',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000017,NULL,'15.12',0.7,'SABbc',NULL,NULL,NULL,NULL,1,1.709833,19.32192,0.097,NULL,66722181159,1042534080,16289595,15.12),(732,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,732,35.13,0.45,106,302,NULL,NULL,NULL,'UGC 00053',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(733,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,733,35.17,0.2,108,302,74.4,NULL,NULL,'UGC 00053',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(734,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,734,35.74,0.49,141,303,70,NULL,NULL,'ESO 193- G 026',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'14.23',0.9,'SA0-','Group member',NULL,NULL,NULL,1,1.719625,-50.41511,NULL,NULL,36029695470,562963991,8796312,14.23),(735,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,735,35.15,0.56,107,303,NULL,NULL,NULL,'ESO 193- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(736,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,736,35.19,0.2,109,303,74.4,NULL,NULL,'ESO 193- G 026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(737,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,737,35.43,0.49,122,303,NULL,NULL,'Malmquist cor.','ESO 193- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(738,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,738,34.25,NULL,70.9,304,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00054',NULL,'2010Ap&SS.325..163P',2010,1,1.49,NULL,'G',NULL,NULL,'17.',0.15,'Scd',NULL,NULL,NULL,NULL,1,1.724417,41.74036,0.369,NULL,67123897860,1048810904,16387670,17),(739,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,739,34.26,NULL,71.2,304,NULL,NULL,'Dipole','UGC 00054',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(740,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,740,34.27,NULL,71.3,304,NULL,NULL,'Dipole + Quadrupole','UGC 00054',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(741,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,741,34.32,0.43,73.1,304,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00054',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(742,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,742,34.32,NULL,73.2,304,NULL,NULL,NULL,'UGC 00054',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(743,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',743,37.83,0.46,369,305,70,NULL,NULL,'2MASX J00065746-0109280',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000079,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,1.7395417,-1.15772,0.097,NULL,34373678270,537088722,8392011,17.9),(744,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',744,37.82,0.46,366,306,70,NULL,NULL,'2MASX J00070059+0054104',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000112,NULL,'16.5g',0.34,'AGN',NULL,NULL,NULL,NULL,1,1.7522917,0.90294,0.085,NULL,66573525943,1040211342,16253302,16.5),(745,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,745,34.61,0.2,83.6,307,74.4,NULL,NULL,'UGC 00056',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.000193,NULL,'15.7g',0.49,'Scd:',NULL,NULL,NULL,NULL,1,1.756667,14.10658,0.225,NULL,66735880258,1042748129,16292939,15.7),(746,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',746,37.4,0.46,301,308,70,NULL,NULL,'2MASX J00070371+1400380',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,1.765417,14.01067,0.225,NULL,66735884181,1042748190,16292940,17.2),(747,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',747,37.91,0.46,383,309,70,NULL,NULL,'2MASX J00070914-0959096',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000083,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,1.788167,-9.98614,0.086,NULL,34598250446,540597663,8446838,17.7),(748,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',748,35.34,0.49,117,310,75,NULL,'IR','ESO 538- G 022',NULL,'2011yCatp016004901K',2011,1,1.9,NULL,'G',0.00006,NULL,'14.84',0.2,'(R\'_2)SB(s)ab',NULL,NULL,NULL,NULL,1,1.792667,-21.78656,0.059,NULL,35303248122,551613251,8618957,14.84),(749,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,749,34.08,0.2,65.5,311,74.4,NULL,NULL,'KUG 0004+134',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',NULL,NULL,'15.7',0.2,'Spiral',NULL,NULL,NULL,NULL,1,1.798667,13.76819,0.181,NULL,66739455534,1042803992,16293812,15.7),(750,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,750,34.35,0.43,74.3,311,NULL,NULL,NULL,'KUG 0004+134',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(751,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,751,34.44,0.41,77.1,311,NULL,NULL,'Malmquist cor.','KUG 0004+134',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(752,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2005ih',NULL,752,39.87,0.13,748,312,74.2,NULL,'SALT 2','SDSS J000713.55+002056.9',0.26,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1.8064583,0.34914,0.049,NULL,66573928716,1040217636,16253400,NULL),(753,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2005ih',NULL,753,40.56,0.15,1030,312,70,NULL,'SDSS-II SN 06108, SALT 2','SDSS J000713.55+002056.9',0.26,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(754,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2005ih',NULL,754,40.59,0.12,1040,312,65,NULL,'SALT2','SDSS J000713.55+002056.9',0.26,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(755,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 06108','R',755,40.63,0.2,1060,312,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ih','SDSS J000713.55+002056.9',0.26,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(756,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 06108','R',756,40.68,0.13,1090,312,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ih','SDSS J000713.55+002056.9',0.26,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(757,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2005ih',NULL,757,40.69,0.14,1090,312,65,NULL,'MLCS2k2','SDSS J000713.55+002056.9',0.26,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(758,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2005ih',NULL,758,40.85,0.04,1180,312,70,NULL,'SDSS-II SN 06108','SDSS J000713.55+002056.9',0.26,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(759,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 17262','RN',759,40.29,0.27,953,313,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 17262',0.201409,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(760,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 17262','RN',760,40.35,0.24,978,313,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 17262',0.201409,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(761,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',761,37.41,0.46,303,314,70,NULL,NULL,'2MASX J00071466-0038310',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000085,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,1.811,-0.64194,0.057,NULL,34362853068,536919579,8389368,16.9),(762,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 19551','RN',762,41.33,0.18,1460,315,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 19551',0.259027,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(763,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 19551','RN',763,41.96,0.22,1960,315,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 19551',0.259027,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(764,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',764,37.93,0.46,386,316,70,NULL,NULL,'2MASX J00071566+0022254',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000097,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,1.81516666667,0.37367,0.049,NULL,66574058913,1040219670,16253432,17.2),(765,'IRAS','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,765,33.77,0.8,56.8,317,75,NULL,'W91PP, r','NGC 0001',NULL,'1997ApJS..109..333W',1997,1,1.6,'The UZC has V = 2216 +- 65 km/sec.','G',0.000002,NULL,'13.65',1.2,'SA(s)b:','Pair member (points to parent)',NULL,NULL,NULL,1,1.816,27.70808,0.169,NULL,67233979106,1050530923,16414545,13.65),(766,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,766,33.64,0.47,53.5,317,NULL,NULL,'H','NGC 0001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(767,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,767,33.65,0.45,53.7,317,NULL,NULL,'K','NGC 0001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(768,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,768,33.66,0.38,53.9,317,75,NULL,'W91PP, r, raw','NGC 0001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(769,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,769,33.76,0.46,56.5,317,NULL,NULL,'J','NGC 0001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(770,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,770,33.85,0.38,58.8,317,75,NULL,'W91PP, r, inv','NGC 0001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(771,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,771,33.93,0.38,61,317,75,NULL,'W91PP, r, cor','NGC 0001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(772,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,772,33.96,0.4,62.1,317,NULL,NULL,'mean','NGC 0001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(773,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,773,34.31,0.34,72.8,317,NULL,NULL,NULL,'NGC 0001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(774,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,774,34.35,0.2,74.1,317,74.4,NULL,NULL,'NGC 0001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(775,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,775,34.4,0.33,75.9,317,NULL,NULL,'Malmquist cor.','NGC 0001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(776,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 14634','RN',776,41.69,0.28,1580,318,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 14634',0.381116,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(777,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 14634','RN',777,43.33,0.18,3350,318,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 14634',0.381116,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(778,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',778,37.77,0.33,358,319,70,NULL,NULL,'2MASX J00071613+0035524',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000072,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,1.81725,0.59783,0.049,NULL,66574056633,1040219634,16253431,17.7),(779,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 15535','R',779,40.07,0.21,860,320,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15535',0.200792,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,'PHOT','21.2g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,1.81779166667,-0.30375,0.053,NULL,34362771819,536918309,8389348,21.2),(780,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 15535','R',780,40.24,0.16,932,320,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15535',0.200792,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(781,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 15535',NULL,781,39.91,0.11,959,320,70,NULL,'SALT 2','SDSS-II SN 15535',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(782,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 15535',NULL,782,39.92,0.11,964,320,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15535',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(783,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 15535',NULL,783,40.17,0.19,1080,320,70,NULL,'SN photometric redshift distance, z photo =0.295 +/- 0.033','SDSS-II SN 15535',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(784,'IRAS','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,784,35,0.8,100,321,75,NULL,'W91PP, r','NGC 0002',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000007,NULL,'14.96',0.6,'Sab','Pair member (points to parent)',NULL,NULL,NULL,1,1.8212917,27.67836,0.169,NULL,67233978399,1050530912,16414545,14.96),(785,'IRAS','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,785,35,0.8,100,321,75,NULL,'HMCL, I','NGC 0002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(786,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,786,34.42,0.69,76.4,321,100,NULL,'mid-IR','NGC 0002',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(787,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,787,34.51,0.4,79.9,321,NULL,NULL,NULL,'NGC 0002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(788,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,788,34.54,0.39,80.8,321,NULL,NULL,'Malmquist cor.','NGC 0002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(789,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,789,34.73,0.4,88.3,321,75,NULL,'HMCL, I, raw','NGC 0002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(790,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,790,34.73,0.2,88.3,321,74.4,NULL,NULL,'NGC 0002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(791,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,791,34.8,0.38,91.2,321,75,NULL,'W91PP, r, raw','NGC 0002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(792,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,792,34.92,0.4,96.3,321,75,NULL,'HMCL, I, inv','NGC 0002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(793,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,793,34.94,0.4,97.3,321,75,NULL,'HMCL, I, cor','NGC 0002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(794,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,794,34.97,0.38,98.7,321,75,NULL,'W91PP, r, inv','NGC 0002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(795,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,795,34.99,0.38,99.4,321,75,NULL,'W91PP, r, cor','NGC 0002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(796,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,796,35.19,0.4,109,321,NULL,NULL,'mean','NGC 0002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(797,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,797,35.43,0.47,122,321,NULL,NULL,'H','NGC 0002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(798,'IRAS','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,798,34.1,0.8,66,322,75,NULL,'W91PP, r','NGC 7831',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'13.60',0.4,'Sb: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,1.831375,32.60925,0.141,NULL,67347415409,1052303365,16442240,13.6),(799,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,799,33.96,0.47,62,322,NULL,NULL,'H','NGC 7831',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(800,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,800,34.02,0.46,63.6,322,NULL,NULL,'J','NGC 7831',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(801,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,801,34.02,0.38,63.6,322,75,NULL,'W91PP, r, raw','NGC 7831',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(802,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,802,34.03,0.45,64,322,NULL,NULL,'K','NGC 7831',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(803,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',803,34.16,0.49,68,322,75,NULL,'IR','NGC 7831',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(804,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,804,34.21,0.4,69.6,322,NULL,NULL,'mean','NGC 7831',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(805,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,805,34.22,0.38,69.8,322,75,NULL,'W91PP, r, cor','NGC 7831',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(806,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,806,34.24,0.38,70.5,322,75,NULL,'W91PP, r, inv','NGC 7831',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(807,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,807,34.38,0.2,75.2,322,74.4,NULL,NULL,'NGC 7831',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(808,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,808,34.42,0.28,76.7,322,NULL,NULL,'Malmquist cor.','NGC 7831',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(809,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,809,34.45,0.27,77.6,322,NULL,NULL,NULL,'NGC 7831',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(810,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',810,37.77,0.33,358,323,70,NULL,NULL,'2MASX J00072021+0029335',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'13.43',0.2,'BrClG',NULL,NULL,NULL,NULL,1,1.83420833333,0.49258,0.049,NULL,66574077165,1040219955,16253436,13.43),(811,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 18014','RN',811,43,0.24,2730,324,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 18014',0.456746,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(812,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',812,37.77,0.46,359,325,70,NULL,NULL,'2MASX J00072700+0055125',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000109,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,1.8625,0.92014,0.085,NULL,66573462677,1040210354,16253286,16.4),(813,'FP','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,'R',813,37.14,0.46,268,326,70,NULL,NULL,'2MASX J00072847+0046375',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,'PHOT','17.6g',0.17,'Candidate      QSO',NULL,NULL,NULL,NULL,1,1.8685417,0.77706,0.057,NULL,66573491110,1040210798,16253293,17.6),(814,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:31','1','SDSS-II SN 20313','RN',814,43.22,0.36,3270,327,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20313',0.344305,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(815,'FP','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,815,35.25,0.53,112,328,70,NULL,NULL,'2MASX J00073031-6109257',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00015,NULL,'15.80',0.38,'S',NULL,NULL,NULL,NULL,1,1.87620833333,-61.15708,0,NULL,36075544919,563680389,8807506,15.8),(816,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:31','1','SDSS-II SN 12915','RN',816,39.67,0.14,725,329,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 12915',0.183618,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(817,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:31','1','SDSS-II SN 12915','RN',817,39.81,0.22,775,329,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 12915',0.183618,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(818,'FP','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,'R',818,36.94,0.46,244,330,70,NULL,NULL,'PKS 0004-010',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00015,NULL,'16.0',0.48,'Elliptical',NULL,NULL,NULL,NULL,1,1.8774583,-0.80436,0.057,NULL,34362490465,536913913,8389279,16),(819,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,819,24.35,0.16,0.741,331,NULL,NULL,NULL,'Andromeda XX',NULL,'2012ApJ...758...11C',2012,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1.877917,35.13233,0.265,1,67126971679,1048858932,16388420,NULL),(820,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,820,24.52,0.74,0.802,331,NULL,NULL,'I','Andromeda XX',NULL,'2008ApJ...688.1009M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(821,'FP','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,821,36.49,0.58,199,332,70,NULL,NULL,'2MASX J00073247-5331390',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.86',0.33,NULL,NULL,NULL,NULL,NULL,1,1.88520833333,-53.52756,NULL,NULL,36001366592,562521353,8789396,16.86),(822,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:31','1','SDSS-II SN 09194','R',822,39.92,0.26,897,333,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 09194',0.073431,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,1.88733333333,-0.79697,0.061,NULL,34362490428,536913912,8389279,NULL),(823,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:31','1','SDSS-II SN 09194','R',823,40.44,0.32,1140,333,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 09194',0.073431,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(824,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:31','1','SDSS-II SN 09194',NULL,824,41.2,0.14,1740,333,70,NULL,'SN photometric redshift distance, z photo =0.537 +/- 0.053','SDSS-II SN 09194',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(825,'FP','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,'R',825,37.52,0.33,320,334,70,NULL,NULL,'2MASX J00073381+1344293',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000201,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,1.891,13.74147,0.181,NULL,66735931672,1042748932,16292952,18),(826,'FP','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,'R',826,37.32,0.46,292,335,70,NULL,NULL,'2MASX J00073629-0013551',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.0001,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,1.901167,-0.23203,0.069,NULL,34362781667,536918463,8389350,16.5),(827,'FP','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,'R',827,37.85,0.46,372,336,70,NULL,NULL,'SDSS J000736.99+135805.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,1.904167,13.96808,0.181,NULL,66736051986,1042750812,16292981,18.7),(828,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:31','1','SDSS-II SN 04236','R',828,40.8,0.17,1080,337,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J000737.45-010106.8',0.3432,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',0.0005,NULL,'21.3g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,1.906083,-1.01856,0.057,NULL,34373787483,537090429,8392037,21.3),(829,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:31','1','SDSS-II SN 04236','R',829,40.89,0.23,1120,337,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J000737.45-010106.8',0.3432,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(830,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:31','1','SDSS-II SN 04236',NULL,830,40.76,0.13,1420,337,70,NULL,'SALT 2','SDSS J000737.45-010106.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(831,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:31','1','SDSS-II SN 04236',NULL,831,40.81,0.13,1450,337,70,NULL,'SALT 2, Malmquist cor.','SDSS J000737.45-010106.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(832,'FP','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,'R',832,37.52,0.33,320,338,70,NULL,NULL,'SDSS J000737.80+134907.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000134,NULL,'18.6g',0.09,NULL,NULL,NULL,NULL,NULL,1,1.90754166667,13.81878,0.181,NULL,66736077530,1042751211,16292987,18.6),(833,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:31','1','SDSS-II SN 13452','R',833,41.8,0.33,1570,339,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13452',0.455383,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,'PHOT','22.2g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,1.9207917,-0.35125,0.069,NULL,34362773650,536918338,8389349,22.2),(834,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:31','1','SDSS-II SN 13452',NULL,834,41.06,0.26,1630,339,70,NULL,'SN photometric redshift distance, z photo =0.494 +/- 0.089','SDSS-II SN 13452',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(835,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:31','1','SDSS-II SN 13452',NULL,835,42.07,0.24,2590,339,70,NULL,'SALT 2','SDSS-II SN 13452',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(836,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:31','1','SDSS-II SN 13452',NULL,836,42.17,0.24,2720,339,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13452',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(837,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,837,29.91,NULL,9.59,340,NULL,NULL,NULL,'UGC 00064',NULL,'2013AJ....145..101K',2013,1,1.4,NULL,'G',0.000057,NULL,'15.5',1.1,'KNOTS','Isolated galaxy',NULL,NULL,NULL,1,1.93341666667,40.87544,0.349,NULL,67116242876,1048691294,16385801,15.5),(838,'FP','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,838,36.09,0.59,166,341,70,NULL,NULL,'2MASX J00074464-0156451',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.55',0.32,NULL,NULL,NULL,NULL,NULL,1,1.935917,-1.94586,0.119,NULL,34376294432,537129600,8392650,16.55),(839,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:31','1','SDSS-II SN 08022','RN',839,43.57,0.26,3330,342,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 08022',0.552232,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(840,'FP','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,840,35.01,0.5,101,343,70,NULL,NULL,'2MASX J00074860-5446297',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.12',0.53,'S0',NULL,NULL,NULL,NULL,1,1.9525417,-54.77486,0,NULL,35990388912,562349826,8786716,16.12),(841,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:31','1','SDSS-II SN 01155','RN',841,41.54,0.23,1510,344,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01155',0.345122,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(842,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:31','1','SDSS-II SN 01155','RN',842,42.19,0.37,2030,344,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01155',0.345122,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(843,'FP','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,'R',843,38,0.46,398,345,70,NULL,NULL,'2MASX J00075078-0040296',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000074,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,1.96154166667,-0.67497,0.061,NULL,34362741176,536917830,8389341,17.5),(844,'FP','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,844,35.66,0.53,135,346,70,NULL,NULL,'2MASX J00075267-4847599',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'16.63',0.22,NULL,NULL,NULL,NULL,NULL,1,1.969375,-48.80006,NULL,NULL,35977226804,562144168,8783502,16.63),(845,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,'R',845,35.24,0.49,111,347,75,NULL,'IR','CGCG 456-032',NULL,'2011yCatp016004901K',2011,1,0.6,NULL,'G',0.000033,NULL,'15.5',0.2,'Sa','Isolated galaxy',NULL,NULL,NULL,1,1.976417,20.41236,0.081,NULL,66709309781,1042332965,16286452,15.5),(846,'FP','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,'R',846,37.39,0.46,300,348,70,NULL,NULL,'2MASX J00075511-0013405',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000106,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,1.979625,-0.22808,0.081,NULL,34362818065,536919032,8389359,16.4),(847,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:31','1','SN 2005fi',NULL,847,39.71,0.04,693,349,70,NULL,'SDSS-II SN 02422','SDSS J000758.69+003816.7',0.26,'2011ApJS..192....1C',2011,1,0.04,NULL,'G',0.005,NULL,'22.0g',0.03,NULL,NULL,NULL,NULL,NULL,1,1.994583,0.63797,0.069,NULL,66574018952,1040219046,16253422,22),(848,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:31','1','SN 2005fi',NULL,848,40.06,0.13,816,349,74.2,NULL,'SALT 2','SDSS J000758.69+003816.7',0.26,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(849,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:31','1','SN 2005fi',NULL,849,40.18,0.12,1090,349,70,NULL,'Hubble residual 0.21 for z0.26500','SDSS J000758.69+003816.7',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(850,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:31','1','SN 2005fi',NULL,850,40.79,0.09,1140,349,65,NULL,'SALT2','SDSS J000758.69+003816.7',0.26,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(851,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:31','1','SN 2005fi',NULL,851,40.88,0.15,1190,349,70,NULL,'SDSS-II SN 02422, SALT 2','SDSS J000758.69+003816.7',0.26,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(852,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:31','1','SDSS-II SN 02422','R',852,40.9,0.21,1200,349,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fi','SDSS J000758.69+003816.7',0.265,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(853,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:31','1','SN 2005fi',NULL,853,40.94,0.08,1220,349,65,NULL,'MLCS2k2','SDSS J000758.69+003816.7',0.26,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(854,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:31','1','SDSS-II SN 02422','R',854,41.1,0.13,1310,349,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fi','SDSS J000758.69+003816.7',0.265,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(855,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,855,34,0.8,63.2,350,75,NULL,'W91PP, r','NGC 7836',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'14.4',0.5,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,2.00683333333,33.07078,0.121,NULL,67347596687,1052306198,16442284,14.4),(856,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,856,33.99,0.47,62.8,350,NULL,NULL,'H','NGC 7836',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(857,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,857,34,0.45,63,350,NULL,NULL,'K','NGC 7836',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(858,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,858,34.09,0.46,65.7,350,NULL,NULL,'J','NGC 7836',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(859,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,859,34.14,0.4,67.3,350,NULL,NULL,'mean','NGC 7836',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(860,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,860,34.5,0.42,79.5,350,NULL,NULL,NULL,'NGC 7836',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(861,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,861,34.53,0.41,80.7,350,NULL,NULL,'Malmquist cor.','NGC 7836',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(862,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,862,34.54,0.2,80.9,350,74.4,NULL,NULL,'NGC 7836',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(863,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,863,34.91,0.38,96.1,350,75,NULL,'W91PP, r, raw','NGC 7836',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(864,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,864,35.14,0.38,107,350,75,NULL,'W91PP, r, cor','NGC 7836',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(865,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,865,35.18,0.38,109,350,75,NULL,'W91PP, r, inv','NGC 7836',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(866,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,866,34.79,0.4,90.8,351,NULL,NULL,'mean','UGC 00066',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000053,NULL,'14.46',1,'SABb',NULL,NULL,NULL,NULL,1,2.0285,9.71786,0.229,NULL,66791851791,1043622684,16306604,14.46),(867,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,867,35.02,0.47,101,351,NULL,NULL,'H','UGC 00066',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(868,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,868,35.02,0.45,101,351,NULL,NULL,'K','UGC 00066',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(869,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,869,35.09,0.46,104,351,NULL,NULL,'J','UGC 00066',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(870,'FP','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,'R',870,37.54,0.46,322,352,70,NULL,NULL,'SDSS J000808.03+003950.4',NULL,'2015arXiv151105856S',2015,1,0.17,'Classified as a galaxy in [VCV96], Table 4.','G',0.000078,NULL,'18.4g',0.08,NULL,NULL,NULL,NULL,NULL,1,2.03345833333,0.66403,0.069,NULL,66573973864,1040218341,16253411,18.4),(871,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,871,35.32,0.8,116,353,75,NULL,'W91PP, r','UGC 00068',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.00012,NULL,'14.36',0.8,'SB?','Isolated galaxy',NULL,NULL,NULL,1,2.04279166667,27.00425,0.141,NULL,67234187710,1050534182,16414596,14.36),(872,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,872,34.35,0.52,74,353,NULL,NULL,NULL,'UGC 00068',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(873,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,873,34.39,0.2,75.5,353,74.4,NULL,NULL,'UGC 00068',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(874,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,874,34.57,0.47,82.1,353,NULL,NULL,'Malmquist cor.','UGC 00068',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(875,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,875,34.95,0.38,97.7,353,75,NULL,'W91PP, r, raw','UGC 00068',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(876,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,876,35.13,0.38,106,353,75,NULL,'W91PP, r, cor','UGC 00068',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(877,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,877,35.13,0.38,106,353,75,NULL,'W91PP, r, inv','UGC 00068',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(878,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,878,33.82,0.8,58.2,354,75,NULL,'W91PP, r','UGC 00069',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000002,NULL,'14.49',0.8,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,2.045625,27.52814,0.145,NULL,67234452613,1050538322,16414661,14.49),(879,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,879,33.22,0.2,44.1,354,74.4,NULL,NULL,'UGC 00069',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(880,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,880,33.36,0.38,47.1,354,75,NULL,'W91PP, r, inv','UGC 00069',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(881,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,881,33.38,0.38,47.3,354,75,NULL,'W91PP, r, raw','UGC 00069',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(882,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,882,33.44,0.45,48.8,354,NULL,NULL,NULL,'UGC 00069',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(883,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,883,33.73,0.38,55.7,354,75,NULL,'W91PP, r, cor','UGC 00069',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(884,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,884,33.95,0.35,61.7,354,NULL,NULL,'Malmquist cor.','UGC 00069',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(885,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:31','1','SDSS-II SN 16241','RN',885,39.52,0.19,731,355,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16241',0.097566,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(886,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:31','1','SDSS-II SN 16241','RN',886,39.87,0.1,860,355,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16241',0.097566,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(887,'CMD','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,887,27.54,NULL,3.22,356,NULL,NULL,NULL,'ESO 349- G 031',NULL,'2013A&A...549A..47L',2013,1,1.1,NULL,'G',0.000007,NULL,'15.4B',0.9,'IBm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,2.05566666667,-34.57833,NULL,NULL,34664211080,541628298,8462942,15.4),(888,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,888,27.45,0.1,3.09,356,NULL,NULL,NULL,'ESO 349- G 031',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(889,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,889,27.51,0.06,3.2,356,NULL,NULL,'I','ESO 349- G 031',NULL,'2013A&A...549A..47L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(890,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,890,27.53,0.04,3.21,356,NULL,NULL,'I','ESO 349- G 031',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(891,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,891,27.53,NULL,3.21,356,NULL,NULL,NULL,'ESO 349- G 031',NULL,'2006AJ....131.1361K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(892,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,892,27.53,0.1,3.21,356,74.4,NULL,NULL,'ESO 349- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(893,'Tully est','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,893,26.87,0.8,2.4,356,75,NULL,NULL,'ESO 349- G 031',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(894,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,894,28.06,NULL,4.1,356,NULL,NULL,NULL,'ESO 349- G 031',NULL,'2003A&A...404...93K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(895,'FP','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,'R',895,37.88,0.46,377,357,70,NULL,NULL,'SDSS J000818.64-001031.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000077,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,2.0777083,-0.17544,0.081,NULL,34362761824,536918153,8389346,18.4),(896,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,896,34.99,0.8,99.5,358,75,NULL,'MAT, I','ESO 111- G 014',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000025,NULL,'14.39',1.1,'SA(rs)cd',NULL,NULL,NULL,NULL,1,2.07808333333,-59.51561,0,NULL,36086630178,563853596,8810212,14.39),(897,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,897,34.33,0.43,73.3,358,75,NULL,'MAT, I, raw','ESO 111- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(898,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,898,34.4,0.32,75.9,358,85,NULL,'I, raw','ESO 111- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(899,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,899,34.45,0.32,77.7,358,85,NULL,'I, inv','ESO 111- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(900,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,900,34.54,0.43,81,358,75,NULL,'MAT, I, inv','ESO 111- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(901,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,901,34.74,0.43,88.6,358,75,NULL,'MAT, I, cor','ESO 111- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(902,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,902,31.43,0.8,19.3,359,75,NULL,'MAT, I','NGC 0007',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000007,NULL,'13.47',0.5,'SB(s)c? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,2.08733333333,-29.915,NULL,NULL,34795649195,543682018,8495031,13.47),(903,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,903,31.16,0.32,17.1,359,85,NULL,'I, inv','NGC 0007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(904,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,904,31.2,0.32,17.4,359,85,NULL,'I, raw','NGC 0007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(905,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,905,31.38,0.43,18.8,359,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0007',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(906,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,906,31.4,0.43,19,359,75,NULL,'3.6 micron, color corrected','NGC 0007',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(907,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,907,31.45,0.2,19.5,359,74.4,NULL,NULL,'NGC 0007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(908,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,908,31.57,0.43,20.6,359,75,NULL,'MAT, I, inv','NGC 0007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(909,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,909,31.62,0.43,21.1,359,75,NULL,'MAT, I, raw','NGC 0007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(910,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,910,31.78,0.39,22.7,359,73,NULL,'opt','NGC 0007',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(911,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,911,31.79,0.43,22.9,359,75,NULL,'MAT, I, cor','NGC 0007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(912,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,912,31.81,0.4,23,359,NULL,NULL,NULL,'NGC 0007',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(913,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,913,31.81,0.49,23,359,NULL,NULL,NULL,'NGC 0007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(914,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,914,31.87,0.47,23.6,359,NULL,NULL,'Malmquist cor.','NGC 0007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(915,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:31','1','SDSS-II SN 18376','RN',915,41.99,0.23,1990,360,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18376',0.256786,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(916,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:31','1','SDSS-II SN 18376','RN',916,42.37,0.24,2370,360,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18376',0.256786,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(917,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,917,33.95,NULL,61.8,361,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0008',NULL,'2010Ap&SS.325..163P',2010,1,1.14,NULL,'G',NULL,NULL,'17.08',0.11,'Scd',NULL,NULL,NULL,NULL,1,2.1004583,33.02883,0.121,NULL,67347588587,1052306071,16442282,17.08),(918,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,918,33.96,NULL,62,361,NULL,NULL,'Dipole','FGC 0008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(919,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,919,33.96,NULL,62,361,NULL,NULL,'Dipole + Quadrupole','FGC 0008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(920,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,920,34.35,0.43,74,361,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0008',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(921,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,921,34.37,0.43,74.9,361,75,NULL,'3.6 micron, color corrected','FGC 0008',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(922,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:31','1',NULL,NULL,922,34.39,0.2,75.5,361,74.4,NULL,NULL,'FGC 0008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(923,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,923,34.56,0.44,81.5,361,NULL,NULL,NULL,'FGC 0008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(924,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,924,34.57,0.43,82.2,361,NULL,NULL,'Malmquist cor.','FGC 0008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(925,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,925,36.82,0.79,231,362,70,NULL,NULL,'2MASX J00082488-0513044',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.55',0.4,NULL,NULL,NULL,NULL,NULL,1,2.10375,-5.21797,0.096,NULL,34420210503,537815789,8403371,16.55),(926,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,926,37.01,0.65,252,363,70,NULL,NULL,'2MASX J00082585-0036314',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.000071,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,2.107833,-0.60867,0.069,NULL,34362693660,536917088,8389329,16.6),(927,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 01680','RN',927,41.81,0.14,1830,364,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01680',0.257604,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(928,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 01680','RN',928,41.99,0.2,1990,364,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01680',0.257604,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(929,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',929,38.03,0.46,404,365,70,NULL,NULL,'2MASX J00083371+0001275',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000114,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,2.14054166667,0.02439,0.077,NULL,66573176802,1040205887,16253216,17.3),(930,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 21574','RN',930,43.02,0.45,3000,366,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 21574',0.337051,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(931,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 18304',NULL,931,38.09,0.76,415,367,70,NULL,'SN photometric redshift distance, z photo =0.102 +/- 0.046','SDSS-II SN 18304',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','20.4g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,2.142,0.80431,0.073,NULL,66587536531,1040430258,16256722,20.4),(932,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 18304','R',932,40.4,0.24,955,367,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18304',0.258847,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(933,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 18304','R',933,40.47,0.19,988,367,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18304',0.258847,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(934,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 18304',NULL,934,40.25,0.14,1120,367,70,NULL,'SALT 2','SDSS-II SN 18304',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(935,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 18304',NULL,935,40.27,0.14,1130,367,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18304',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(936,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,936,35.86,0.62,148,368,70,NULL,NULL,'MCG -02-01-028',NULL,'2014MNRAS.445.2677S',2014,1,1.02,NULL,'G',0.000027,NULL,'14.8g',0.81,'SB(r)a',NULL,NULL,NULL,NULL,1,2.142917,-10.94931,0.095,NULL,34596359645,540568119,8446376,14.8),(937,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,937,34.69,0.8,86.7,369,75,NULL,'MAT, I','NGC 0010',NULL,'1997ApJS..109..333W',1997,1,2.4,NULL,'G',0.000033,NULL,'13.3',1.2,'SAB(rs)bc      HII',NULL,NULL,NULL,NULL,1,2.143917,-33.85833,NULL,NULL,34847890820,544498294,8507785,13.3),(938,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,938,34.07,0.69,65.2,369,100,NULL,'mid-IR','NGC 0010',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(939,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,939,34.3,0.43,72.4,369,75,NULL,'MAT, I, raw','NGC 0010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(940,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,940,34.31,0.47,72.7,369,NULL,NULL,'H','NGC 0010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(941,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,941,34.33,0.46,73.6,369,NULL,NULL,'J','NGC 0010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(942,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,942,34.38,0.45,75.3,369,NULL,NULL,'K','NGC 0010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(943,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,943,34.5,0.32,79.5,369,85,NULL,'I, raw','NGC 0010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(944,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',944,34.51,NULL,79.8,369,NULL,NULL,'B','NGC 0010',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(945,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',945,34.59,NULL,82.8,369,NULL,NULL,'I','NGC 0010',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(946,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,946,34.6,0.32,83,369,85,NULL,'I, inv','NGC 0010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(947,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,947,34.66,0.43,85.6,369,75,NULL,'MAT, I, cor','NGC 0010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(948,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,948,34.67,0.43,85.8,369,75,NULL,'MAT, I, inv','NGC 0010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(949,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,949,34.75,0.4,89.2,369,NULL,NULL,'mean','NGC 0010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(950,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,950,35.13,0.2,106,369,74.4,NULL,NULL,'NGC 0010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(951,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,951,35.17,0.29,108,369,NULL,NULL,NULL,'NGC 0010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(952,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,952,35.25,0.28,112,369,NULL,NULL,'Malmquist cor.','NGC 0010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(953,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,953,36.74,0.63,222,370,70,NULL,NULL,'2MASX J00083620-5848043',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.83',0.23,NULL,NULL,NULL,NULL,NULL,1,2.151,-58.80117,0,NULL,36072541889,563633467,8806772,16.83),(954,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',954,37.53,0.46,320,371,70,NULL,NULL,'SDSS J000839.78-092755.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000068,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,2.16575,-9.46553,0.094,NULL,34597652752,540588324,8446692,18.2),(955,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 07851',NULL,955,40.29,0.14,1140,372,70,NULL,'SN photometric redshift distance, z photo =0.315 +/- 0.026','SDSS-II SN 07851',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,2.16575,0.70125,0.073,NULL,66586806739,1040418855,16256544,NULL),(956,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 07851','R',956,42.55,0.38,2060,372,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 07851',0.571324,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(957,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,957,35.2,0.47,110,373,NULL,NULL,NULL,'ESO 193- G 030',NULL,'2009ApJS..182..474S',2009,1,0.91,NULL,'G',0.000033,NULL,'15.00',0.21,'S','Group member',NULL,NULL,NULL,1,2.1672083,-50.61939,NULL,NULL,36029819411,562965928,8796342,15),(958,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,958,35.24,0.2,112,373,74.4,NULL,NULL,'ESO 193- G 030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(959,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,959,35.35,0.43,117,373,NULL,NULL,'Malmquist cor.','ESO 193- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(960,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,960,33.55,0.45,51.3,374,NULL,NULL,'K','NGC 0011',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000067,NULL,'14.59',0.3,'Sa',NULL,NULL,NULL,NULL,1,2.177083,37.44792,0.297,NULL,67136971485,1049015179,16390862,14.59),(961,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,961,33.59,0.47,52.3,374,NULL,NULL,'H','NGC 0011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(962,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,962,33.73,0.46,55.7,374,NULL,NULL,'J','NGC 0011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(963,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,963,33.87,0.4,59.5,374,NULL,NULL,'mean','NGC 0011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(964,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',964,34.05,0.49,64.6,374,75,NULL,'IR','NGC 0011',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(965,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 10641','RN',965,44.1,0.23,4160,375,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 10641',0.586446,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(966,'Ring Diameter','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,966,33.4,0.84,47,376,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 0012',NULL,'1981ApJS...45..541P',1981,1,1.7,NULL,'G',0.000013,NULL,'13.8',1.5,'SAB(rs)c:',NULL,NULL,NULL,NULL,1,2.1864583,4.61253,0.101,NULL,66629761623,1041090025,16267031,13.8),(967,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,967,28.79,0.2,5.73,377,74.4,NULL,NULL,'NGC 0014',NULL,'2013AJ....146...86T',2013,1,2.8,'Two MCG entries for one object, via MCG notes.','G',0.000003,NULL,'12.71',2.1,'(R)IB(s)m pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,2.193333,15.81556,0.117,NULL,66768955904,1043264936,16301014,12.71),(968,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,968,30.54,0.4,12.8,377,75,NULL,'B','NGC 0014',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(969,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,969,35.85,0.5,148,378,70,NULL,NULL,'2MASX J00084665-5659002',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'16.09',0.48,'S0',NULL,NULL,NULL,NULL,1,2.194333,-56.98333,0,NULL,36205718120,565714345,8839286,16.09),(970,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',970,37.96,0.46,391,379,70,NULL,NULL,'SDSS J000847.00+141647.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000134,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,2.195833,14.27978,0.181,NULL,66734333850,1042723966,16292561,18.6),(971,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,971,33.95,0.8,61.6,380,75,NULL,'W91PP, r','NGC 0013',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.00003,NULL,'14.01',0.6,'(R)Sab:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,2.198833,33.43333,0.137,NULL,67347236424,1052300569,16442196,14.01),(972,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,972,33.72,0.38,55.6,380,75,NULL,'W91PP, r, raw','NGC 0013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(973,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,973,33.84,0.46,58.7,380,NULL,NULL,NULL,'NGC 0013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(974,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,974,33.87,0.2,59.4,380,74.4,NULL,NULL,'NGC 0013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(975,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',975,33.91,0.49,60.4,380,75,NULL,'IR','NGC 0013',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(976,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,976,33.94,0.38,61.4,380,75,NULL,'W91PP, r, inv','NGC 0013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(977,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,977,33.95,0.47,61.8,380,NULL,NULL,'H','NGC 0013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(978,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,978,33.95,0.46,61.8,380,NULL,NULL,'J','NGC 0013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(979,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,979,34.01,0.38,63.4,380,75,NULL,'W91PP, r, cor','NGC 0013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(980,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,980,34.01,0.45,63.5,380,NULL,NULL,'K','NGC 0013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(981,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,981,34.08,0.42,65.5,380,NULL,NULL,'Malmquist cor.','NGC 0013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(982,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,982,34.09,0.4,65.7,380,NULL,NULL,'mean','NGC 0013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(983,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,983,34.08,0.2,65.5,381,74.4,NULL,NULL,'UGC 00076',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000033,NULL,'16.0',0.3,'S?',NULL,NULL,NULL,NULL,1,2.2050417,24.54033,0.153,NULL,67192661378,1049885334,16404458,16),(984,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,984,34.37,0.44,74.9,381,NULL,NULL,NULL,'UGC 00076',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(985,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,985,34.52,0.42,80.1,381,NULL,NULL,'Malmquist cor.','UGC 00076',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(986,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 07055','RN',986,42.28,0.35,1890,382,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 07055',0.506895,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(987,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',987,37.93,0.46,386,383,70,NULL,NULL,'2MASX J00085116-0019441',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000083,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,2.21320833333,-0.32883,0.077,NULL,34362047399,536906990,8389171,18.6),(988,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',988,37.63,0.46,335,384,70,NULL,NULL,'2MASX J00085269-0025071',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000082,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,2.21945833333,-0.41872,0.077,NULL,34362016896,536906514,8389164,18.2),(989,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,989,33.75,0.8,56.2,385,75,NULL,'W91PP, r','NGC 0009',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.35',0.7,'Sb: pec        HII','Isolated galaxy',NULL,NULL,NULL,1,2.227917,23.81697,0.201,NULL,67191286481,1049863851,16404122,14.35),(990,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,990,32.74,0.38,35.4,385,75,NULL,'W91PP, r, inv','NGC 0009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(991,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,991,32.85,0.38,37.2,385,75,NULL,'W91PP, r, raw','NGC 0009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(992,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,992,33.28,0.38,45.3,385,75,NULL,'W91PP, r, cor','NGC 0009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(993,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',993,37.42,0.46,305,386,70,NULL,NULL,'SDSS J000855.93-101243.9',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.00007,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,2.2330417,-10.21219,0.151,NULL,34597965816,540593215,8446768,18.8),(994,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,994,36.09,0.52,165,387,70,NULL,NULL,'2MASX J00085654-5349360',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.64',0.35,NULL,NULL,NULL,NULL,NULL,1,2.23566666667,-53.82672,NULL,NULL,36001600511,562525007,8789453,16.64),(995,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,995,36.67,0.68,216,388,70,NULL,NULL,'2MASX J00090044-0422301',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.76',0.31,NULL,NULL,NULL,NULL,NULL,1,2.251917,-4.37511,0.083,NULL,34421721750,537839402,8403740,16.76),(996,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,996,36.31,0.5,182,389,70,NULL,NULL,'2MASX J00090207-7949591',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'16.3b',0.29,NULL,NULL,NULL,NULL,NULL,1,2.258625,-79.83303,0.309,NULL,35467857417,554185272,8659144,16.3),(997,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,997,34.79,0.4,91,390,NULL,NULL,'mean','NGC 0015',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000033,NULL,'14.67',0.6,'Sa',NULL,NULL,NULL,NULL,1,2.26029166667,21.62453,0.113,NULL,67448429343,1053881708,16466901,14.67),(998,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,998,35.45,0.47,123,390,NULL,NULL,'H','NGC 0015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(999,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,999,35.46,0.45,124,390,NULL,NULL,'K','NGC 0015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1000,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1000,35.53,0.46,127,390,NULL,NULL,'J','NGC 0015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1001,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1001,36.53,0.46,203,391,70,NULL,NULL,'2MASX J00090270-0047381',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000066,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,2.26125,-0.79411,0.081,NULL,34374351245,537099238,8392175,16.8),(1002,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1002,34.69,0.8,86.9,392,75,NULL,'MAT, I','ESO 349- G 033',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00003,NULL,'13.7r',0.3,'Sb',NULL,NULL,NULL,NULL,1,2.2642917,-32.91414,NULL,NULL,34849858709,544529042,8508266,13.7),(1003,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1003,34.54,0.43,81.1,392,75,NULL,'MAT, I, raw','ESO 349- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1004,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1004,34.61,0.32,83.7,392,85,NULL,'I, raw','ESO 349- G 033',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1005,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1005,34.67,0.32,85.9,392,85,NULL,'I, inv','ESO 349- G 033',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1006,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1006,34.78,0.4,90.2,392,NULL,NULL,'mean','ESO 349- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1007,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1007,34.79,0.43,90.8,392,75,NULL,'MAT, I, inv','ESO 349- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1008,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1008,34.86,0.49,93.7,392,75,NULL,'IR','ESO 349- G 033',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1009,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1009,34.88,0.43,94.4,392,75,NULL,'MAT, I, cor','ESO 349- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1010,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1010,34.94,0.47,97.1,392,NULL,NULL,'H','ESO 349- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1011,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1011,35.08,0.34,104,392,NULL,NULL,NULL,'ESO 349- G 033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1012,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1012,35.1,0.45,105,392,NULL,NULL,'K','ESO 349- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1013,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1013,35.12,0.2,106,392,74.4,NULL,NULL,'ESO 349- G 033',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1014,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1014,35.23,0.32,111,392,NULL,NULL,'Malmquist cor.','ESO 349- G 033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1015,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1015,35.37,0.49,119,393,75,NULL,'IR','UGC 00081',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',NULL,NULL,'15.29',0.4,'Sb',NULL,NULL,NULL,NULL,1,2.267583,10.91889,0.189,NULL,66793194774,1043643668,16306932,15.29),(1016,'Faber-Jackson','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1016,31.73,1,22.2,394,95,NULL,'de Vaucouleurs','NGC 0016',NULL,'1984ApJS...56...91D',1984,1,1.8,NULL,'G',0.000057,NULL,'13.00',1,'SAB0-','Isolated galaxy (6 Mpc isolation)',NULL,NULL,NULL,1,2.267875,27.72942,0.173,NULL,67234588504,1050540445,16414694,13),(1017,'Faber-Jackson','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1017,32.37,0.55,29.8,394,95,NULL,'Weighted Mean','NGC 0016',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1018,'Faber-Jackson','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1018,34.24,0.81,70.5,394,55,NULL,'Visvanathan & Sandage 1979','NGC 0016',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1019,'Tertiary','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1019,32.62,0.5,33.4,394,95,NULL,NULL,'NGC 0016',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1020,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1020,32.55,0.45,32.3,394,NULL,NULL,'K','NGC 0016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1021,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1021,32.8,0.4,36.3,394,NULL,NULL,'mean','NGC 0016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1022,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1022,34.15,0.2,67.6,395,74.4,NULL,NULL,'UGC 00079',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.000007,NULL,'15.1',1.1,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,2.268375,25.61861,0.105,NULL,67188973992,1049827718,16403558,15.1),(1023,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1023,34.34,0.43,73.9,395,NULL,NULL,NULL,'UGC 00079',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1024,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1024,34.5,0.4,79.4,395,NULL,NULL,'Malmquist cor.','UGC 00079',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1025,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1025,38.01,0.46,401,396,70,NULL,NULL,'2MASX J00091048+0005512',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00009,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,2.293625,0.0975,0.069,NULL,66573194447,1040206163,16253221,17.4),(1026,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1026,36.59,0.46,208,397,70,NULL,NULL,'2MASX J00091166+0039222',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000086,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,2.2985417,0.65622,0.081,NULL,66586861279,1040419707,16256557,16.8),(1027,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1027,37.16,0.33,271,398,70,NULL,NULL,'2MASX J00091369-0015041',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00015,NULL,'16.63',0.32,NULL,NULL,NULL,NULL,NULL,1,2.307167,-0.25119,0.069,NULL,34362093729,536907714,8389183,16.63),(1028,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 11622','RN',1028,39.08,0.23,591,399,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 11622',0.105247,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1029,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 11622','RN',1029,40.78,6.58,1290,399,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 11622',0.105247,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1030,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1030,37.16,0.33,271,400,70,NULL,NULL,'2MASX J00091814-0019316',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00007,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,2.3255417,-0.32561,0.077,NULL,34362057407,536907146,8389174,17.6),(1031,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1031,37.81,0.46,365,401,70,NULL,NULL,'2MASX J00091853+1423308',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,2.32725,14.39186,0.141,NULL,66733646999,1042713234,16292394,17.6),(1032,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 14327','RN',1032,42.16,0.31,1900,402,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14327',0.420803,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1033,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 14327','RN',1033,42.35,0.31,2080,402,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14327',0.420803,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1034,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 14327','N',1034,42.15,0.2,2690,402,70,NULL,'SALT 2','SDSS-II SN 14327',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1035,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 14327','N',1035,42.22,0.2,2780,402,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14327',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1036,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 07056','R',1036,40.05,0.18,790,403,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07056',0.294304,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,'PHOT','21.0g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,2.3460417,0.13656,0.061,NULL,66573266500,1040207289,16253238,21),(1037,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 07056','R',1037,40.33,0.28,897,403,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07056',0.294304,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1038,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 07056',NULL,1038,39.84,0.27,927,403,70,NULL,'SN photometric redshift distance, z photo =0.246 +/- 0.038','SDSS-II SN 07056',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1039,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1039,37.92,0.33,384,404,70,NULL,NULL,'2MASX J00092397-1005097',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000073,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,2.34983333333,-10.08608,0.104,NULL,34597970052,540593282,8446770,17.4),(1040,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1040,36.4,0.53,190,405,70,NULL,NULL,'6dF J0009263-350825',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,2.3597917,-35.14019,NULL,NULL,34664448903,541632014,8463000,15),(1041,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2005hw',NULL,1041,41.13,0.21,1190,406,74.2,NULL,'SALT 2','SDSS J000928.38+010916.0',0.41,'2010ApJ...716..712A',2010,1,0.05,NULL,'G',NULL,NULL,'22.4g',0.03,NULL,NULL,NULL,NULL,NULL,1,2.3682917,1.15447,0.057,NULL,66587026475,1040422288,16256598,22.4),(1042,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 05588','R',1042,41.8,0.31,1630,406,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005hw','SDSS J000928.38+010916.0',0.41,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1043,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2005hw',NULL,1043,41.97,0.23,1760,406,70,NULL,'SALT 2','SDSS J000928.38+010916.0',0.41,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1044,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 05588','R',1044,41.98,0.33,1770,406,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005hw','SDSS J000928.38+010916.0',0.41,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1045,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2005hw',NULL,1045,41.73,0.22,2220,406,70,NULL,'SALT 2','SDSS J000928.38+010916.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1046,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2005hw',NULL,1046,41.8,0.22,2290,406,70,NULL,'SALT 2, Malmquist cor.','SDSS J000928.38+010916.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1047,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1047,36.88,0.46,238,407,70,NULL,NULL,'2MASX J00093338-0105086',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000091,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,2.389125,-1.08581,0.106,NULL,34374175897,537096498,8392132,16.7),(1048,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1048,34.69,0.45,86.8,408,NULL,NULL,'K','IC 1531',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000083,NULL,'13.80',1.4,'SAB0- pec:',NULL,NULL,NULL,NULL,1,2.39825,-32.277,NULL,NULL,34848799035,544512484,8508007,13.8),(1049,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1049,35,0.4,100,408,NULL,NULL,'mean','IC 1531',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1050,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1050,37.93,0.33,386,409,70,NULL,NULL,'2MASX J00093969-1030568',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000086,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,2.41529166667,-10.51567,0.085,NULL,34596058644,540563416,8446303,17.3),(1051,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1051,37.92,0.33,384,410,70,NULL,NULL,'2MASXi J0009409-100815',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000063,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,2.4207917,-10.13817,0.094,NULL,34598024962,540594140,8446783,17.6),(1052,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1052,37.73,0.46,352,411,70,NULL,NULL,'2MASX J00094539-0846057',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000091,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,2.43925,-8.76819,0.103,NULL,34377790785,537152981,8393015,17.2),(1053,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 21370','RN',1053,43.28,0.34,2840,412,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 21370',0.592218,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1054,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1054,37.93,0.33,386,413,70,NULL,NULL,'2MASX J00094795-1028367',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000091,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,2.449875,-10.47681,0.092,NULL,34596047872,540563248,8446300,17.2),(1055,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1055,35.06,0.47,103,414,NULL,NULL,'Malmquist cor.','NGC 0022',NULL,'2009ApJS..182..474S',2009,1,1.7,NULL,'G',0.000003,NULL,'14.43',1.3,'Sb','in a pair',NULL,NULL,NULL,1,2.45079166667,27.83231,0.125,NULL,67234052276,1050532066,16414563,14.43),(1056,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1056,35.25,0.2,112,414,74.4,NULL,NULL,'NGC 0022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1057,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1057,35.28,0.42,114,414,NULL,NULL,NULL,'NGC 0022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1058,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1058,35.42,0.4,121,414,NULL,NULL,'mean','NGC 0022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1059,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1059,35.49,0.47,125,414,NULL,NULL,'H','NGC 0022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1060,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1060,35.62,0.45,133,414,NULL,NULL,'K','NGC 0022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1061,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1061,35.64,0.46,134,414,NULL,NULL,'J','NGC 0022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1062,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1062,36.6,0.56,209,415,70,NULL,NULL,'6dF J0009517-351849',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,2.46529166667,-35.31372,NULL,NULL,34675882541,541810664,8465791,15.3),(1063,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1063,31.87,0.8,23.7,416,75,NULL,'MAT, I','IC 1532',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'14.78',0.4,'Sb',NULL,NULL,NULL,NULL,1,2.47,-64.37208,0,NULL,36047388463,563240444,8800631,14.78),(1064,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1064,31.53,0.32,20.2,416,85,NULL,'I, inv','IC 1532',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1065,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1065,31.57,0.32,20.6,416,85,NULL,'I, raw','IC 1532',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1066,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1066,31.94,0.43,24.4,416,75,NULL,'MAT, I, inv','IC 1532',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1067,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1067,32,0.43,25.2,416,75,NULL,'MAT, I, raw','IC 1532',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1068,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1068,32.28,0.43,28.6,416,75,NULL,'MAT, I, cor','IC 1532',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1069,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1069,32.67,0.77,34.2,416,NULL,NULL,NULL,'IC 1532',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1070,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1070,32.7,0.39,34.6,416,73,NULL,'opt','IC 1532',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1071,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1071,32.71,0.2,34.8,416,74.4,NULL,NULL,'IC 1532',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1072,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1072,32.79,0.73,36.1,416,NULL,NULL,'Malmquist cor.','IC 1532',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1073,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1073,37.08,0.46,260,417,70,NULL,NULL,'2MASX J00095297-0924167',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00009,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,2.47058333333,-9.40481,0.093,NULL,34597738031,540589656,8446713,16.5),(1074,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 07654',NULL,1074,40.74,0.29,1410,418,70,NULL,'SN photometric redshift distance, z photo =0.406 +/- 0.076','SDSS-II SN 07654',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,2.472375,0.96447,0.069,NULL,66587621419,1040431584,16256743,NULL),(1075,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 07654',NULL,1075,41.8,0.17,2290,418,70,NULL,'SALT 2','SDSS-II SN 07654',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1076,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 07654',NULL,1076,41.87,0.17,2370,418,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 07654',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1077,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1077,33.77,0.8,56.8,419,75,NULL,'W91PP, r','NGC 0023',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000007,NULL,'12.85',1.3,'SB(s)a;HII;LIRGSbrst','Pair member, S + S',NULL,NULL,'Starburst',1,2.4725417,25.92378,0.145,NULL,67187340999,1049802203,16403159,12.85),(1078,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1078,33.1,0.69,41.6,419,100,NULL,'mid-IR','NGC 0023',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1079,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1079,33.54,0.43,51.1,419,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0023',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1080,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1080,33.56,0.43,51.6,419,75,NULL,'3.6 micron, color corrected','NGC 0023',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1081,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1081,33.63,0.58,53.3,419,NULL,NULL,NULL,'NGC 0023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1082,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1082,33.65,0.2,53.7,419,74.4,NULL,NULL,'NGC 0023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1083,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1083,33.72,0.45,55.5,419,NULL,NULL,'K','NGC 0023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1084,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1084,33.75,0.38,56.2,419,75,NULL,'W91PP, r, raw','NGC 0023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1085,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1085,33.78,0.47,57,419,NULL,NULL,'H','NGC 0023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1086,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1086,33.84,0.46,58.7,419,NULL,NULL,'J','NGC 0023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1087,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1087,33.95,0.5,61.6,419,NULL,NULL,'Malmquist cor.','NGC 0023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1088,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1088,33.98,0.4,62.4,419,NULL,NULL,'mean','NGC 0023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1089,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1089,33.98,0.38,62.6,419,75,NULL,'W91PP, r, cor','NGC 0023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1090,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1090,34.06,0.38,65,419,75,NULL,'W91PP, r, inv','NGC 0023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1091,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1091,29.42,0.09,7.67,420,74.4,NULL,NULL,'NGC 0024',NULL,'2013AJ....146...86T',2013,1,5.8,NULL,'G',0.000007,NULL,'12.38',1.3,'SA(s)c         HII','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,2.485583,-24.96314,0.057,NULL,34775630060,543369219,8490144,12.38),(1092,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1092,29.31,0.8,7.29,420,75,NULL,'MAT, I','NGC 0024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1093,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1093,29.37,0.8,7.49,420,75,NULL,'A82, H','NGC 0024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1094,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1094,24.97,0.52,0.986,420,NULL,NULL,NULL,'NGC 0024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1095,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1095,24.97,0.52,0.986,420,NULL,NULL,'Malmquist cor.','NGC 0024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1096,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1096,28.82,0.32,5.83,420,85,NULL,'I, inv','NGC 0024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1097,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1097,28.85,0.32,5.89,420,85,NULL,'I, raw','NGC 0024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1098,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1098,29.17,0.4,6.8,420,75,NULL,'B','NGC 0024',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1099,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1099,29.19,0.4,6.9,420,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 0024',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1100,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1100,29.2,0.43,6.92,420,75,NULL,'MAT, I, inv','NGC 0024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1101,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1101,29.23,0.43,7.01,420,75,NULL,'MAT, I, raw','NGC 0024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1102,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1102,29.42,0.09,7.67,420,74.4,NULL,NULL,'NGC 0024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1103,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1103,29.52,0.43,8.03,420,75,NULL,'MAT, I, cor','NGC 0024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1104,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1104,29.65,0.47,8.49,420,75,NULL,'A82, H, inv','NGC 0024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1105,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1105,29.74,0.47,8.88,420,75,NULL,'A82, H, raw','NGC 0024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1106,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1106,29.79,0.35,9.08,420,NULL,NULL,NULL,'NGC 0024',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1107,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1107,29.8,0.39,9.1,420,73,NULL,'opt','NGC 0024',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1108,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1108,29.91,0.43,9.6,420,75,NULL,'3.6 micron, color corrected','NGC 0024',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1109,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1109,29.96,0.43,9.8,420,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0024',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1110,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1110,29.98,NULL,9.91,420,NULL,NULL,NULL,'NGC 0024',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1111,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1111,30.15,0.47,10.7,420,75,NULL,'A82, H, cor','NGC 0024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1112,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1112,30.19,0.6,10.9,420,53.9,NULL,'NGC 0024/NGC 0045 pair','NGC 0024',NULL,'1984A&A...132..253R',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1113,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1113,38.33,0.46,463,421,70,NULL,NULL,'2MASX J00095672+0009586',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.41',0.18,'AGN',NULL,NULL,NULL,NULL,1,2.48625,0.16622,0.061,NULL,66573091671,1040204557,16253196,18.41),(1114,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1114,30.51,0.67,12.6,422,NULL,NULL,NULL,'UGC 00092',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.00003,NULL,'14.50',0.9,'Sb',NULL,NULL,NULL,NULL,1,2.5082917,28.21014,0.121,NULL,67233035566,1050516180,16414315,14.5),(1115,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1115,30.91,0.56,15.2,422,NULL,NULL,'Malmquist cor.','UGC 00092',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1116,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1116,35.18,0.8,109,423,75,NULL,'W91PP, r','UGC 00091',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'15.57',0.3,'S?',NULL,NULL,NULL,NULL,1,2.512583,28.15031,0.121,NULL,67233058486,1050516538,16414320,15.57),(1117,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1117,34.89,0.49,94.9,423,75,NULL,'IR','UGC 00091',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1118,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1118,35.22,0.38,111,423,75,NULL,'W91PP, r, raw','UGC 00091',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1119,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1119,35.39,0.38,120,423,75,NULL,'W91PP, r, cor','UGC 00091',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1120,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1120,35.4,0.38,120,423,75,NULL,'W91PP, r, inv','UGC 00091',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1121,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 19582',NULL,1121,40.54,0.36,1280,424,70,NULL,'SN photometric redshift distance, z photo =0.361 +/- 0.084','SDSS-II SN 19582',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,2.52004166667,0.79469,0.069,NULL,66587634289,1040431785,16256746,NULL),(1122,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 02554','RN',1122,42.85,0.14,2760,425,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 02554',0.341977,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1123,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1123,37.51,0.46,318,426,70,NULL,NULL,'2MASX J00101424-1008456',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000095,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,2.55929166667,-10.14597,0.094,NULL,34597812095,540590813,8446731,16.9),(1124,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 03877','RN',1124,39.83,0.1,839,427,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03877',0.102197,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1125,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 03877','RN',1125,41.14,0.21,1530,427,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03877',0.102197,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1126,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 18374',NULL,1126,40.12,0.17,1060,428,70,NULL,'SN photometric redshift distance, z photo =0.286 +/- 0.028','SDSS-II SN 18374',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,2.5647917,-0.17714,0.061,NULL,34361873592,536904274,8389129,NULL),(1127,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 18374','R',1127,41.05,0.24,1230,428,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18374',0.319838,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1128,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 18374','R',1128,41.22,0.19,1330,428,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18374',0.319838,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1129,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 18374',NULL,1129,40.98,0.15,1570,428,70,NULL,'SALT 2','SDSS-II SN 18374',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1130,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 18374',NULL,1130,41.02,0.15,1600,428,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18374',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1131,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1131,36.19,0.56,173,429,70,NULL,NULL,'2MASX J00101607-0043501',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'17.00',0.31,NULL,NULL,NULL,NULL,NULL,1,2.5669583,-0.73056,0.077,NULL,34374247752,537097621,8392150,17),(1132,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1132,35.04,0.61,102,430,70,NULL,NULL,'6dF J0010162-365148',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,2.56795833333,-36.86325,NULL,NULL,34674946364,541796036,8465563,15.1),(1133,'Tully est','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1133,31.43,0.8,19.3,431,75,NULL,NULL,'UGCA 003',NULL,'1988NBGC.C....0000T',1988,1,1.4,NULL,'G',0.00001,NULL,'15.08',1.2,'IB(s)m',NULL,NULL,NULL,NULL,1,2.5740417,-18.26408,0.05,NULL,34440137489,538127148,8408236,15.08),(1134,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1134,36.14,0.6,169,432,70,NULL,NULL,'2MASX J00101852-5706369',NULL,'2014MNRAS.445.2677S',2014,1,0.88,NULL,'G',0.00015,NULL,'15.36',0.68,'SB(r)a',NULL,NULL,NULL,NULL,1,2.577083,-57.11022,0,NULL,36205545553,565711649,8839244,15.36),(1135,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1135,35.12,0.2,106,433,74.4,NULL,NULL,'AGC 101063',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000242,NULL,'17.46',0.1,NULL,NULL,NULL,NULL,NULL,1,2.578417,29.13811,0.133,NULL,67215690085,1050245157,16410080,17.46),(1136,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1136,35.23,0.57,111,433,NULL,NULL,NULL,'AGC 101063',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1137,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1137,35.26,0.57,113,433,NULL,NULL,'Malmquist cor.','AGC 101063',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1138,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1138,34.4,0.8,75.7,434,75,NULL,'MAT, I','ESO 241- G 021',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000033,NULL,'14.29',0.5,'(R\')SB(s)b','Pair member (points to parent)',NULL,NULL,NULL,1,2.58325,-46.41942,NULL,NULL,35972959011,562077484,8782460,14.29),(1139,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1139,33.7,0.47,54.8,434,NULL,NULL,'H','ESO 241- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1140,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1140,33.72,0.45,55.4,434,NULL,NULL,'K','ESO 241- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1141,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1141,33.84,0.46,58.7,434,NULL,NULL,'J','ESO 241- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1142,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1142,34.07,0.43,65.3,434,75,NULL,'MAT, I, raw','ESO 241- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1143,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1143,34.09,0.49,65.8,434,75,NULL,'IR','ESO 241- G 021',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1144,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1144,34.22,0.32,69.8,434,85,NULL,'I, raw','ESO 241- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1145,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1145,34.29,0.32,72.2,434,85,NULL,'I, inv','ESO 241- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1146,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1146,34.34,0.4,73.7,434,NULL,NULL,'mean','ESO 241- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1147,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1147,34.37,0.43,74.7,434,75,NULL,'MAT, I, inv','ESO 241- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1148,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1148,34.45,0.43,77.5,434,75,NULL,'MAT, I, cor','ESO 241- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1149,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1149,34.65,0.47,84.9,434,NULL,NULL,NULL,'ESO 241- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1150,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1150,34.69,0.2,86.7,434,74.4,NULL,NULL,'ESO 241- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1151,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1151,34.74,0.45,88.7,434,NULL,NULL,'Malmquist cor.','ESO 241- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1152,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 03565','R',1152,41.07,0.23,1270,435,70,NULL,'SDSS CAND. zSNIa; SALT 2','2MASX J00102166+0042360',0.2897,'2014arXiv1401.3317S',2014,1,0.16,NULL,'G',0.0002,NULL,'18.9g',0.11,NULL,NULL,NULL,NULL,NULL,1,2.590375,0.70994,0.057,NULL,66587630901,1040431732,16256745,18.9),(1153,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 03565','R',1153,41.4,0.2,1480,435,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','2MASX J00102166+0042360',0.2897,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1154,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 03565',NULL,1154,40.95,0.14,1550,435,70,NULL,'SALT 2','2MASX J00102166+0042360',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1155,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 03565',NULL,1155,40.97,0.14,1560,435,70,NULL,'SALT 2, Malmquist cor.','2MASX J00102166+0042360',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1156,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1156,34.46,0.47,78.2,436,70,NULL,NULL,'MCG -01-01-044',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000143,NULL,'14.84',0.4,NULL,NULL,NULL,NULL,NULL,1,2.597583,-7.08444,0.116,NULL,34392534166,537383346,8396614,14.84),(1157,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1157,37.42,0.33,304,437,70,NULL,NULL,'2MASX J00102565-1102129',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000075,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,2.606917,-11.03706,0.071,NULL,34595880879,540560638,8446259,17),(1158,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1158,33.8,0.8,57.5,438,75,NULL,'W91PP, r','NGC 0026',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000007,NULL,'13.62',1.4,'SA(rs)ab','Pair member, S + S',NULL,NULL,NULL,1,2.6077917,25.83183,0.121,NULL,67186645154,1049791330,16402989,13.62),(1159,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1159,33.78,0.38,57.1,438,75,NULL,'W91PP, r, raw','NGC 0026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1160,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1160,33.93,0.38,61,438,75,NULL,'W91PP, r, inv','NGC 0026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1161,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1161,33.99,0.4,62.8,438,NULL,NULL,'mean','NGC 0026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1162,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1162,34.01,0.38,63.4,438,75,NULL,'W91PP, r, cor','NGC 0026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1163,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1163,34.03,0.34,63.9,438,NULL,NULL,NULL,'NGC 0026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1164,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1164,34.18,0.2,68.6,438,74.4,NULL,NULL,'NGC 0026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1165,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1165,34.27,0.31,71.5,438,NULL,NULL,'Malmquist cor.','NGC 0026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1166,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1166,34.41,0.47,76.2,438,NULL,NULL,'H','NGC 0026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1167,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1167,34.46,0.45,78,438,NULL,NULL,'K','NGC 0026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1168,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1168,34.5,0.46,79.6,438,NULL,NULL,'J','NGC 0026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1169,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1169,35.09,0.8,104,439,75,NULL,'W91PP, r','UGC 00095',NULL,'1997ApJS..109..333W',1997,1,1.98,NULL,'G',0.00002,NULL,'15.52',0.16,'Sc','Pair member (points to parent)',NULL,NULL,NULL,1,2.609917,28.98794,0.133,NULL,67214861137,1050232205,16409878,15.52),(1170,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1170,35.11,NULL,105,439,NULL,NULL,'Dipole','UGC 00095',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1171,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1171,35.11,NULL,105,439,NULL,NULL,'Dipole + Quadrupole','UGC 00095',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1172,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1172,35.11,NULL,105,439,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00095',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1173,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1173,35.13,0.49,106,439,75,NULL,'IR','UGC 00095',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1174,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1174,35.23,NULL,111,439,NULL,NULL,NULL,'UGC 00095',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1175,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1175,35.53,0.38,128,439,75,NULL,'W91PP, r, raw','UGC 00095',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1176,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1176,35.63,0.38,134,439,NULL,NULL,'Malmquist cor.','UGC 00095',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1177,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1177,35.72,0.38,139,439,75,NULL,'W91PP, r, cor','UGC 00095',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1178,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1178,35.73,0.38,140,439,75,NULL,'W91PP, r, inv','UGC 00095',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1179,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1179,35.81,0.2,145,439,74.4,NULL,NULL,'UGC 00095',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1180,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1180,35.96,0.33,155,439,NULL,NULL,NULL,'UGC 00095',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1181,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1181,37.84,0.46,369,440,70,NULL,NULL,'2MASX J00102892+0103010',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000088,NULL,'17.7g',0.19,'NLAGN',NULL,NULL,NULL,'Sy 2',1,2.620375,1.05036,0.061,NULL,66587108234,1040423566,16256618,17.7),(1182,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 14531',NULL,1182,40.77,0.44,1420,441,70,NULL,'SN photometric redshift distance, z photo =0.413 +/- 0.127','SDSS-II SN 14531',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,2.62425,0.48453,0.069,NULL,66586926482,1040420726,16256573,NULL),(1183,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1183,38.35,0.46,468,442,70,NULL,NULL,'2MASX J00103012+1401301',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,2.6255417,14.02511,0.153,NULL,66735807038,1042746984,16292921,17.1),(1184,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1184,34.86,0.8,93.6,443,75,NULL,'W91PP, r','NGC 0027',NULL,'1997ApJS..109..333W',1997,1,1.2,'Springob et al. (2005ApJS..160..149S) give v= 7849 km/sec.','G',0.000033,NULL,'14.45',0.5,'S?','Pair member (points to parent)',NULL,NULL,NULL,1,2.63654166667,28.99625,0.133,NULL,67214893868,1050232716,16409886,14.45),(1185,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1185,34.86,0.8,93.6,443,75,NULL,'HMCL, I','NGC 0027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1186,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1186,34.57,0.4,82.2,443,75,NULL,'HMCL, I, raw','NGC 0027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1187,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1187,34.65,0.38,85.1,443,75,NULL,'W91PP, r, raw','NGC 0027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1188,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1188,34.79,0.4,90.7,443,75,NULL,'HMCL, I, cor','NGC 0027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1189,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1189,34.8,0.4,91.2,443,75,NULL,'HMCL, I, inv','NGC 0027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1190,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1190,34.84,0.38,92.8,443,75,NULL,'W91PP, r, cor','NGC 0027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1191,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1191,34.87,0.43,94.1,443,NULL,NULL,'Malmquist cor.','NGC 0027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1192,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1192,34.87,0.38,94.3,443,75,NULL,'W91PP, r, inv','NGC 0027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1193,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1193,34.91,0.47,95.9,443,NULL,NULL,'H','NGC 0027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1194,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1194,34.97,0.41,98.5,443,NULL,NULL,NULL,'NGC 0027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1195,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1195,35.01,0.2,100,443,74.4,NULL,NULL,'NGC 0027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1196,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1196,35.02,0.45,101,443,NULL,NULL,'K','NGC 0027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1197,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1197,35.06,0.46,103,443,NULL,NULL,'J','NGC 0027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1198,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1198,35.06,0.4,103,443,NULL,NULL,'mean','NGC 0027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1199,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1199,36.29,0.33,181,444,NULL,NULL,'Malmquist cor.','2MASX J00103444+0611590',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',NULL,NULL,'14.2I',0.2,NULL,NULL,NULL,NULL,NULL,1,2.6434583,6.19975,0.161,NULL,66618217080,1040909641,16264213,14.2),(1200,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1200,36.34,0.32,185,444,NULL,NULL,NULL,'2MASX J00103444+0611590',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1201,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1201,36.53,0.2,202,444,74.4,NULL,NULL,'2MASX J00103444+0611590',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1202,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 1992au',NULL,1202,36.33,0.17,174,445,74.2,NULL,'SALT 2','2dFGRS S839Z607',0.061,'2010ApJ...716..712A',2010,1,0.31,NULL,'G',0.000213,':','17.62',0.26,'E1',NULL,NULL,NULL,NULL,1,2.659125,-49.94783,NULL,NULL,35976342451,562130350,8783286,17.62),(1203,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 1992au',NULL,1203,36.92,0.08,228,445,70,NULL,'SALT','2dFGRS S839Z607',0.061,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1204,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 1992au',NULL,1204,37.03,0.09,255,445,74.4,NULL,NULL,'2dFGRS S839Z607',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1205,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 1992au',NULL,1205,37.38,0.22,266,445,65,NULL,'MLCS2k2','2dFGRS S839Z607',0.061,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1206,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 1992au',NULL,1206,37.15,0.12,269,445,70.8,NULL,NULL,'2dFGRS S839Z607',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1207,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 1992au',NULL,1207,37.3,0.04,271,445,72,NULL,NULL,'2dFGRS S839Z607',0.061,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1208,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 1992au',NULL,1208,37.3,0.22,272,445,65,NULL,NULL,'2dFGRS S839Z607',0.061,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1209,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 1992au',NULL,1209,37.41,0.14,303,445,60,NULL,NULL,'2dFGRS S839Z607',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1210,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 1992au',NULL,1210,37.52,0.16,319,445,60,NULL,'M(V) = -19.47 mag','2dFGRS S839Z607',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1211,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 1992au',NULL,1211,37.54,0.21,322,445,60,NULL,'M(B) = -19.48 mag','2dFGRS S839Z607',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1212,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 1992au',NULL,1212,37.71,0.15,348,445,60,NULL,'M(I) = -19.19 mag','2dFGRS S839Z607',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1213,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1213,35.49,0.51,125,446,70,NULL,NULL,'ESO 149- G 021',NULL,'2014MNRAS.445.2677S',2014,1,1.11,NULL,'G',0.00015,NULL,'15.02',0.52,'(R\'_2)SB(rs)a',NULL,NULL,NULL,NULL,1,2.6635417,-56.80347,0,NULL,36205617120,565712767,8839261,15.02),(1214,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1214,37.7,0.46,347,447,70,NULL,NULL,'SDSS J001039.39-001342.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000078,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,2.664125,-0.22853,0.077,NULL,34373428677,537084823,8391950,18.4),(1215,'Tully est','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1215,31.87,0.8,23.7,448,75,NULL,NULL,'UGC 00099',NULL,'1988NBGC.C....0000T',1988,1,2.5,NULL,'G',0.000003,NULL,'16.0',2.5,'Sm',NULL,NULL,NULL,NULL,1,2.670417,13.70917,0.153,NULL,66736452848,1042757075,16293079,16),(1216,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1216,33.94,0.8,61.3,449,75,NULL,'W91PP, r','NGC 0019',NULL,'1997ApJS..109..333W',1997,1,1.2,'Often incorrectly called NGC 0021.','G',0.00001,NULL,'13.99',0.6,'SB(r)bc        LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,2.6702917,32.98308,0.145,NULL,67347768602,1052308884,16442326,13.99),(1217,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1217,33.18,0.69,43.2,449,100,NULL,'mid-IR','NGC 0019',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1218,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1218,33.77,0.38,56.8,449,75,NULL,'W91PP, r, raw','NGC 0019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1219,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1219,33.88,0.38,59.7,449,75,NULL,'W91PP, r, inv','NGC 0019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1220,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1220,34.01,0.2,63.4,449,74.4,NULL,NULL,'NGC 0019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1221,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1221,34.04,0.38,64.2,449,75,NULL,'W91PP, r, cor','NGC 0019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1222,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1222,34.08,0.4,65.3,449,NULL,NULL,'mean','NGC 0019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1223,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1223,34.1,0.31,66,449,NULL,NULL,NULL,'NGC 0019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1224,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1224,34.23,0.47,70,449,NULL,NULL,'H','NGC 0019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1225,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1225,34.25,0.46,70.7,449,NULL,NULL,'J','NGC 0019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1226,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1226,34.28,0.45,71.8,449,NULL,NULL,'K','NGC 0019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1227,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1227,34.3,0.28,72.6,449,NULL,NULL,'Malmquist cor.','NGC 0019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1228,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1228,35.96,0.55,156,450,70,NULL,NULL,'2MASX J00104185-0427551',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.33',0.43,NULL,NULL,NULL,NULL,NULL,1,2.67429166667,-4.46536,0.107,NULL,34419828639,537809822,8403278,16.33),(1229,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1229,36.84,0.54,234,451,70,NULL,NULL,'2MASX J00104278-2019288',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.49',0.53,'S0',NULL,NULL,NULL,NULL,1,2.678333,-20.32456,0.03,NULL,35301467115,551585423,8618522,16.49),(1230,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2006lj','R',1230,40.66,0.22,1090,452,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006lj; SDSS-II SN 14481','GALEXASC J001043.61+001207.6',0.243538,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,2.6814583,0.20186,0.069,NULL,66586727755,1040417621,16256525,NULL),(1231,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2006lj',NULL,1231,40.21,0.13,1100,452,70,NULL,'Hubble residual 0.39 for z0.24390; SDSS-II SN 14481','GALEXASC J001043.61+001207.6',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1232,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2006lj','R',1232,40.98,0.17,1260,452,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006lj; SDSS-II SN 14481','GALEXASC J001043.61+001207.6',0.243538,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1233,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2006lj',NULL,1233,40.56,0.12,1290,452,70,NULL,'SALT 2; SDSS-II SN 14481','GALEXASC J001043.61+001207.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1234,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2006lj',NULL,1234,40.58,0.12,1310,452,70,NULL,'SALT 2, Malmquist cor.; SDSS-II SN 14481','GALEXASC J001043.61+001207.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1235,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 19516','RN',1235,42.92,0.25,2550,453,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19516',0.502432,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1236,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1236,37.6,0.46,331,454,70,NULL,NULL,'2MASX J00104422+1535281',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000148,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,2.68425,15.59131,0.125,NULL,66768124741,1043251949,16300811,17.5),(1237,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1237,33.94,0.8,61.4,455,75,NULL,'W91PP, r','NGC 0021',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000013,NULL,'13.51',0.8,'SAB(s)bc:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,2.695417,33.35283,0.137,NULL,67347817880,1052309654,16442338,13.51),(1238,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1238,34.04,0.38,64.2,455,75,NULL,'W91PP, r, raw','NGC 0021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1239,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1239,34.07,0.4,65.1,455,NULL,NULL,'mean','NGC 0021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1240,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1240,34.21,0.38,69.6,455,75,NULL,'W91PP, r, inv','NGC 0021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1241,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1241,34.23,0.46,70.2,455,NULL,NULL,'J','NGC 0021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1242,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1242,34.23,0.38,70.3,455,75,NULL,'W91PP, r, cor','NGC 0021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1243,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1243,34.23,0.47,70.3,455,NULL,NULL,'H','NGC 0021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1244,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1244,34.26,0.45,71.2,455,NULL,NULL,'K','NGC 0021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1245,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1245,34.41,0.43,76.3,455,75,NULL,'3.6 micron, color corrected','NGC 0021',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1246,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1246,34.45,0.2,77.6,455,74.4,NULL,NULL,'NGC 0021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1247,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1247,34.52,0.43,80.2,455,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0021',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1248,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1248,34.56,0.37,81.7,455,NULL,NULL,'Malmquist cor.','NGC 0021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1249,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1249,34.59,0.37,82.9,455,NULL,NULL,NULL,'NGC 0021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1250,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1250,37.42,0.33,304,456,70,NULL,NULL,'2MASX J00104969-1108130',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000094,NULL,'16.2g',0.36,'FR II          AGN',NULL,NULL,NULL,NULL,1,2.707083,-11.13694,0.033,NULL,34595917607,540561212,8446268,16.2),(1251,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 13896',NULL,1251,38.96,0.31,620,457,70,NULL,'SN photometric redshift distance, z photo =0.157 +/- 0.027','SDSS-II SN 13896',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,2.7127917,-0.06992,0.069,NULL,34361849817,536903903,8389123,NULL),(1252,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 13896','R',1252,40.03,0.2,878,457,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13896',0.157317,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1253,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 13896',NULL,1253,39.75,0.09,891,457,70,NULL,'SALT 2','SDSS-II SN 13896',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1254,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 13896',NULL,1254,39.76,0.09,895,457,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13896',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1255,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 13896','R',1255,40.14,0.12,923,457,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13896',0.157317,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1256,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1256,37.39,0.46,300,458,70,NULL,NULL,'2MASX J00105343-1042070',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000089,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,2.7224583,-10.70194,0.085,NULL,34596645098,540572579,8446446,17.7),(1257,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1257,37.52,0.46,319,459,70,NULL,NULL,'SDSS J001054.59+134653.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000175,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,2.7274583,13.7815,0.153,NULL,66735746889,1042746045,16292906,18.6),(1258,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1258,37.57,0.46,327,460,70,NULL,NULL,'2MASX J00105602+1504401',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,2.73341666667,15.07775,0.141,NULL,66766925541,1043233211,16300518,18),(1259,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1259,35.66,0.8,135,461,75,NULL,'W91PP, r','UGC 00101',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000067,NULL,'15.11',0.6,'SB(s)a',NULL,NULL,NULL,NULL,1,2.7375,25.55989,0.121,NULL,67188681526,1049823148,16403486,15.11),(1260,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1260,35.35,0.38,117,461,75,NULL,'W91PP, r, raw','UGC 00101',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1261,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1261,35.52,0.38,127,461,75,NULL,'W91PP, r, cor','UGC 00101',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1262,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1262,35.57,0.38,130,461,75,NULL,'W91PP, r, inv','UGC 00101',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1263,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1263,35.97,0.2,156,461,74.4,NULL,NULL,'UGC 00101',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1264,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1264,34.99,0.4,99.5,462,NULL,NULL,'mean','UGC 00102',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00003,NULL,'14.39',1.3,'SABa',NULL,NULL,NULL,NULL,1,2.754417,30.05211,0.129,NULL,67225975790,1050405871,16412591,14.39),(1265,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1265,35.24,0.45,112,462,NULL,NULL,'K','UGC 00102',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1266,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1266,35.29,0.47,114,462,NULL,NULL,'H','UGC 00102',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1267,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1267,35.32,0.46,116,462,NULL,NULL,'J','UGC 00102',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1268,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 12989','RN',1268,37.92,0.23,358,463,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 12989',0.072755,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1269,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 12989','RN',1269,38.1,0.34,389,463,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 12989',0.072755,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1270,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 20481','RN',1270,43.99,0.29,4220,464,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20481',0.486018,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1271,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1271,37.22,0.46,278,465,70,NULL,NULL,'2MASX J00110408+1454321',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000191,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,2.76704166667,14.90897,0.141,NULL,66766954117,1043233658,16300525,16.8),(1272,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1272,34.14,0.5,67.3,466,70,NULL,NULL,'ESO 349- G 038',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000033,NULL,'13.87',0.6,'(R\')SA:(r)b',NULL,NULL,NULL,NULL,1,2.8024583,-33.57856,NULL,NULL,34848118422,544501850,8507841,13.87),(1273,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1273,34.88,0.46,94.6,466,NULL,NULL,'J','ESO 349- G 038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1274,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1274,34.91,0.47,95.8,466,NULL,NULL,'H','ESO 349- G 038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1275,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1275,35,0.45,99.8,466,NULL,NULL,'K','ESO 349- G 038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1276,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1276,35.03,0.4,101,466,NULL,NULL,'mean','ESO 349- G 038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1277,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1277,35.07,0.36,103,466,NULL,NULL,NULL,'ESO 349- G 038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1278,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1278,35.17,0.34,108,466,NULL,NULL,'Malmquist cor.','ESO 349- G 038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1279,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1279,35.26,0.2,113,466,74.4,NULL,NULL,'ESO 349- G 038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1280,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1280,34.6,0.73,83,467,NULL,NULL,NULL,'UGC 00105',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.00003,NULL,'14.65',1.2,'(R\')SAB(s)0+',NULL,NULL,NULL,NULL,1,2.809333,28.90647,0.097,NULL,67214878977,1050232484,16409882,14.65),(1281,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1281,34.64,0.2,84.7,467,74.4,NULL,NULL,'UGC 00105',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1282,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1282,34.74,0.68,88.6,467,NULL,NULL,'Malmquist cor.','UGC 00105',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1283,'Magnitude','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1283,36.25,0.13,178,468,100,NULL,NULL,'ABELL 2734',NULL,'1998A&A...337...31R',1998,1,NULL,'Katgert (1996,A&A,310,8) identifies multiple redshift systems in this cluster.','GClstr',NULL,NULL,NULL,NULL,'III    [BM];R  [A]',NULL,NULL,NULL,NULL,1,2.83625,-28.855,0.032,NULL,34789876649,543591822,8493622,NULL),(1284,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 03635','RN',1284,40.25,0.28,1080,469,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03635',0.038801,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1285,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 03635','RN',1285,40.42,0.4,1170,469,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03635',0.038801,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1286,'Magnitude','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1286,36.25,0.13,178,470,100,NULL,NULL,'ESO 409- G 025',NULL,'1998A&A...337...31R',1998,1,1.4,'6dF DR1 has z = 0.062297.','G',0.000097,NULL,'13.9V',0.9,'cD;E+4;BrClG','Pair member (points to parent)',NULL,NULL,NULL,1,2.8402083,-28.85433,0.032,NULL,34789876728,543591823,8493622,13.9),(1287,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1287,33.92,0.69,60.9,471,100,NULL,'mid-IR','NGC 0036',NULL,'2013ApJ...771...88L',2013,1,2.2,NULL,'G',0.000013,NULL,'13.95',1.3,'SAB(rs)b','Isolated galaxy (6 Mpc isolation)',NULL,NULL,NULL,1,2.842917,6.38936,0.165,NULL,66618523957,1040914436,16264288,13.95),(1288,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1288,34.15,0.39,67.6,471,NULL,NULL,'Malmquist cor.','NGC 0036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1289,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1289,34.15,0.39,67.7,471,NULL,NULL,NULL,'NGC 0036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1290,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1290,34.22,0.2,69.8,471,74.4,NULL,NULL,'NGC 0036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1291,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1291,34.29,0.45,72.2,471,NULL,NULL,'K','NGC 0036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1292,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1292,34.32,0.47,73.1,471,NULL,NULL,'H','NGC 0036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1293,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1293,34.37,0.46,74.7,471,NULL,NULL,'J','NGC 0036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1294,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1294,34.58,0.4,82.3,471,NULL,NULL,'mean','NGC 0036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1295,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1295,36.09,0.5,165,472,70,NULL,NULL,'NGC 0037',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000083,NULL,'14.66',0.7,'(RL)SAB0^0',NULL,NULL,NULL,NULL,1,2.8455417,-56.95733,0,NULL,36209052766,565766449,8840100,14.66),(1296,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 15222','R',1296,39.77,0.2,751,473,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006jz','SDSS J001124.57+004207.2',0.199466,'2014arXiv1401.3317S',2014,1,0.21,NULL,'G',0.000104,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,2.852417,0.70203,0.061,NULL,66579137050,1040299016,16254672,18.8),(1297,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 15222','R',1297,39.95,0.11,814,473,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006jz','SDSS J001124.57+004207.2',0.199466,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1298,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2006jz',NULL,1298,39.56,0.11,817,473,70,NULL,'SALT 2','SDSS J001124.57+004207.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1299,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2006jz',NULL,1299,39.58,0.11,824,473,70,NULL,'SALT 2, Malmquist cor.','SDSS J001124.57+004207.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1300,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1300,31.39,0.8,19,474,75,NULL,'MAT, I','ESO 293- G 045',NULL,'1997ApJS..109..333W',1997,1,1.9,'The APM image includes a superposed star.','G',0.000021,NULL,'15.08',0.5,'SB(s)dm?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,2.8534583,-41.39822,NULL,NULL,34644750276,541324223,8458190,15.08),(1301,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1301,31.85,0.32,23.4,474,85,NULL,'I, inv','ESO 293- G 045',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1302,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1302,31.9,0.32,24,474,85,NULL,'I, raw','ESO 293- G 045',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1303,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1303,32.17,0.4,27.2,474,NULL,NULL,NULL,'ESO 293- G 045',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1304,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1304,32.17,0.39,27.2,474,73,NULL,'opt','ESO 293- G 045',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1305,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1305,32.31,0.43,28.9,474,75,NULL,'MAT, I, inv','ESO 293- G 045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1306,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1306,32.42,0.43,30.5,474,75,NULL,'MAT, I, raw','ESO 293- G 045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1307,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1307,32.64,0.43,33.8,474,75,NULL,'MAT, I, cor','ESO 293- G 045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1308,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1308,37.46,0.62,310,475,70,NULL,NULL,'2MASX J00112685-0328255',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'16.74',0.58,NULL,NULL,NULL,NULL,NULL,1,2.862125,-3.47375,0.186,NULL,34422722260,537855035,8403984,16.74),(1309,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1309,35.4,0.49,120,476,NULL,NULL,'Malmquist cor.','KUG 0008+275',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.00001,NULL,'16  :',0.1,'Spiral',NULL,NULL,NULL,NULL,1,2.866125,27.79039,0.117,NULL,67233290924,1050520170,16414377,16),(1310,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1310,35.57,0.2,130,476,74.4,NULL,NULL,'KUG 0008+275',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1311,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1311,35.58,0.45,131,476,NULL,NULL,NULL,'KUG 0008+275',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1312,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1312,33.72,NULL,55.4,477,NULL,NULL,'Dipole + Quadrupole + Octopole','AM 0008-324 NED02',NULL,'2010Ap&SS.325..163P',2010,1,1.18,NULL,'G',0.000053,NULL,'16.8',0.11,'Sd',NULL,NULL,NULL,NULL,1,2.867083,-32.43389,NULL,NULL,34849213965,544518968,8508108,16.8),(1313,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1313,33.76,NULL,56.4,477,NULL,NULL,'Dipole + Quadrupole','AM 0008-324 NED02',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1314,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1314,33.76,NULL,56.5,477,NULL,NULL,'Dipole','AM 0008-324 NED02',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1315,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1315,37.07,0.46,259,478,70,NULL,NULL,'2MASX J00113132-0114235',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000099,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,2.880625,-1.23994,0.105,NULL,34369448870,537022638,8390978,16.2),(1316,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1316,34.98,0.8,98.9,479,75,NULL,'HMCL, I','UGC 00107',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000008,NULL,'16.0',0.2,'S?',NULL,NULL,NULL,NULL,1,2.908875,27.94792,0.117,NULL,67233627837,1050525434,16414459,16),(1317,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1317,35.1,0.49,105,479,75,NULL,'IR','UGC 00107',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1318,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1318,35.14,0.4,107,479,75,NULL,'HMCL, I, raw','UGC 00107',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1319,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1319,35.31,0.4,115,479,75,NULL,'HMCL, I, inv','UGC 00107',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1320,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1320,35.34,0.4,117,479,75,NULL,'HMCL, I, cor','UGC 00107',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1321,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1321,37.81,0.46,365,480,70,NULL,NULL,'2MASX J00113850-0933255',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000076,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,2.9105417,-9.55708,0.073,NULL,34608546474,540758538,8449352,18.1),(1322,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1322,37.29,0.46,287,481,70,NULL,NULL,'2MASX J00113888-1035295',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00008,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,2.912125,-10.59164,0.091,NULL,34609890020,540779531,8449680,17.4),(1323,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 18734','R',1323,38.96,0.06,586,482,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2007lx','CGCG 382-031',0.05715,'2014arXiv1401.3317S',2014,1,0.58,'Multiple SDSS entries describe this object.','G',0.00015,NULL,'14.6R',NULL,'BLLAC',NULL,NULL,NULL,'BL Lac',1,2.915625,-0.47456,0.077,NULL,34369306074,537020407,8390943,14.6),(1324,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 18734','R',1324,39.61,0.2,790,482,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2007lx','CGCG 382-031',0.05715,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1325,'SNII optical','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2007lx',NULL,1325,36.96,0.09,233,482,NULL,NULL,'SCM 55 SNII','CGCG 382-031',0.057151,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1326,'SNII optical','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2007lx',NULL,1326,37.31,0.11,274,482,NULL,NULL,'SCM 15 SDSS SNII','CGCG 382-031',0.057151,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1327,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 08555','R',1327,40.22,0.2,924,483,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J001139.74-002454.1',0.1977,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',0.0001,NULL,'20.4g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,2.915625,-0.41506,0.077,NULL,34369285033,537020078,8390938,20.4),(1328,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 08555','R',1328,40.27,0.14,944,483,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J001139.74-002454.1',0.1977,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1329,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 08555',NULL,1329,40.01,0.1,1000,483,70,NULL,'SALT 2','SDSS J001139.74-002454.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1330,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 08555',NULL,1330,40.02,0.1,1010,483,70,NULL,'SALT 2, Malmquist cor.','SDSS J001139.74-002454.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1331,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1331,36.75,0.46,224,484,70,NULL,NULL,'2MASX J00114114-0940165',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000088,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,2.921583,-9.67128,0.073,NULL,34608553670,540758651,8449353,17.3),(1332,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1332,36.15,0.5,170,485,70,NULL,NULL,'2MASX J00114159-5655469',NULL,'2014MNRAS.445.2677S',2014,1,0.93,NULL,'G',0.00015,NULL,'16.10',0.27,'S',NULL,NULL,NULL,NULL,1,2.923375,-56.92969,0,NULL,36209065460,565766647,8840103,16.1),(1333,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1333,37.02,0.61,253,486,70,NULL,NULL,'2MASX J00114362-1831032',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'17.02',0.23,NULL,NULL,NULL,NULL,NULL,1,2.9317083,-18.51756,0.039,NULL,34441796576,538153071,8408641,17.02),(1334,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1334,35.13,0.8,106,487,75,NULL,'W91PP, r','UGC 00108',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.00001,NULL,'14.80',0.5,'SBb:',NULL,NULL,NULL,NULL,1,2.937917,28.499,0.097,NULL,67232709223,1050511081,16414235,14.8),(1335,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1335,35.49,0.39,126,487,NULL,NULL,'Malmquist cor.','UGC 00108',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1336,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1336,35.71,0.35,139,487,NULL,NULL,NULL,'UGC 00108',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1337,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1337,35.75,0.2,141,487,74.4,NULL,NULL,'UGC 00108',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1338,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1338,35.88,0.38,150,487,75,NULL,'W91PP, r, raw','UGC 00108',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1339,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1339,36.09,0.38,165,487,75,NULL,'W91PP, r, cor','UGC 00108',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1340,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1340,36.14,0.38,169,487,75,NULL,'W91PP, r, inv','UGC 00108',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1341,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1341,37.33,0.46,293,488,70,NULL,NULL,'SDSS J001147.24-100421.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00008,NULL,'18.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,2.946875,-10.07272,0.096,NULL,34609884914,540779451,8449678,18.5),(1342,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2007ju',NULL,1342,37.13,0.1,266,489,70,NULL,'Hubble residual 0.02 for z0.06360','SDSS J001150.46-002021.6',NULL,'2011ApJ...740...92G',2011,1,0.13,NULL,'G',0.0005,NULL,'19.3g',0.1,NULL,NULL,NULL,NULL,NULL,1,2.96025,-0.33936,0.061,NULL,34369409695,537022026,8390969,19.3),(1343,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 17745','R',1343,37.27,0.19,267,489,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ju','SDSS J001150.46-002021.6',0.0636,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1344,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 17745','R',1344,37.5,0.07,297,489,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ju','SDSS J001150.46-002021.6',0.0636,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1345,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1345,38.5,0.33,501,490,70,NULL,NULL,'2MASX J00115194-1048093',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000073,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,2.96641666667,-10.80275,0.085,NULL,34609489459,540773272,8449582,17.8),(1346,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1346,38.33,0.46,463,491,70,NULL,NULL,'SDSS J001153.88+145523.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,2.9745,14.92333,0.141,NULL,66770766114,1043293220,16301456,18.3),(1347,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1347,38.45,0.46,491,492,70,NULL,NULL,'SDSS J001154.05-111358.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000084,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,2.97525,-11.23281,0.075,NULL,34609315669,540770557,8449539,18.4),(1348,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1348,37.2,0.46,275,493,70,NULL,NULL,'2MASX J00115445-1054083',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000085,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,2.97683333333,-10.90231,0.102,NULL,34609448328,540772630,8449572,17.1),(1349,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1349,38.5,0.33,501,494,70,NULL,NULL,'SDSS J001156.72-104934.7',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000094,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,2.986333,-10.82633,0.085,NULL,34609459317,540772801,8449575,18.1),(1350,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1350,37.81,0.27,365,495,70,NULL,NULL,'2MASX J00115939+0022157',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000085,NULL,'17.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,2.997417,0.37092,0.033,NULL,66578457470,1040288397,16254506,17.4),(1351,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1351,36.82,0.52,231,496,70,NULL,NULL,'2MASX J00115959-1931227',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.32',0.4,'E',NULL,NULL,NULL,NULL,1,2.9982917,-19.52292,0.018,NULL,34441545502,538149148,8408580,16.32),(1352,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1352,33.74,0.8,56,497,75,NULL,'W91PP, r','UGC 00110',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.00001,NULL,'14.98',0.7,'SA(s)cd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,3.005417,26.39389,0.121,NULL,67231633034,1050494266,16413972,14.98),(1353,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1353,33.58,0.38,52,497,75,NULL,'W91PP, r, inv','UGC 00110',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1354,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1354,33.66,0.38,53.9,497,75,NULL,'W91PP, r, raw','UGC 00110',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1355,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1355,33.7,0.2,55,497,74.4,NULL,NULL,'UGC 00110',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1356,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1356,33.92,0.38,60.7,497,75,NULL,'W91PP, r, cor','UGC 00110',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1357,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1357,37.83,0.46,367,498,70,NULL,NULL,'2MASX J00120272+0020007',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000068,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,3.0112083,0.33358,0.033,NULL,66578486153,1040288846,16254513,18.1),(1358,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 20171','R',1358,40.61,0.13,1070,499,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20171 HOST',0.24,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,3.01304166667,0.21358,0.065,NULL,66578534331,1040289598,16254524,NULL),(1359,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 20171','R',1359,40.69,0.22,1110,499,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20171 HOST',0.24,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1360,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 20171',NULL,1360,41.4,0.11,1910,499,70,NULL,'SALT 2','SDSS-II SN 20171 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1361,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 20171',NULL,1361,41.45,0.11,1950,499,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20171 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1362,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1362,36.17,0.2,171,500,74.4,NULL,NULL,'KUG 0009+247',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000033,NULL,'15.7',0.5,'Spiral',NULL,NULL,NULL,NULL,1,3.025,24.98833,0.125,NULL,67189175718,1049830870,16403607,15.7),(1363,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1363,34.23,0.48,70.2,501,70,NULL,NULL,'IC 0003',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000074,NULL,'14.7g',0.3,'E0',NULL,NULL,NULL,NULL,1,3.025375,-0.41522,0.061,NULL,34369270441,537019850,8390935,14.7),(1364,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1364,34.29,0.46,72.1,501,70,NULL,NULL,'IC 0003',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1365,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1365,37.51,0.46,318,502,70,NULL,NULL,'2MASX J00120630+1601367',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,3.026125,16.02692,0.089,NULL,66769544691,1043274135,16301158,18.1),(1366,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 01408','RN',1366,42.09,0.19,1850,503,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01408',0.413717,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1367,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 01408','RN',1367,42.15,0.13,1900,503,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01408',0.413717,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1368,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1368,34.63,0.8,84.3,504,75,NULL,'CF, r','UGC 00111',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'15.14',0.4,'Scd:','Isolated galaxy',NULL,NULL,NULL,1,3.037875,12.04497,0.193,NULL,66730140908,1042658451,16291538,15.14),(1369,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1369,34.07,0.2,65.2,504,74.4,NULL,NULL,'UGC 00111',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1370,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1370,34.2,0.47,69.2,504,NULL,NULL,NULL,'UGC 00111',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1371,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1371,34.23,0.38,70.3,504,75,NULL,'CF, r, raw','UGC 00111',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1372,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1372,34.26,0.38,71.1,504,75,NULL,'CF, r, inv','UGC 00111',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1373,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1373,34.32,0.45,73,504,NULL,NULL,'Malmquist cor.','UGC 00111',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1374,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1374,34.32,0.38,73,504,75,NULL,'CF, r, cor','UGC 00111',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1375,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1375,34.99,0.8,99.5,505,75,NULL,'HMCL, I','KUG 0009+276A',NULL,'1997ApJS..109..333W',1997,1,0.7,NULL,'G',0.00002,NULL,'15.40',0.2,'S?',NULL,NULL,NULL,NULL,1,3.03904166667,27.91036,0.117,NULL,67233494700,1050523354,16414427,15.4),(1376,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1376,35.27,0.2,113,505,74.4,NULL,NULL,'KUG 0009+276A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1377,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1377,36.41,0.4,191,505,75,NULL,'HMCL, I, raw','KUG 0009+276A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1378,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1378,36.65,0.4,213,505,75,NULL,'HMCL, I, inv','KUG 0009+276A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1379,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1379,36.66,0.4,215,505,75,NULL,'HMCL, I, cor','KUG 0009+276A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1380,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1380,34.96,0.8,98.3,506,75,NULL,'HMCL, I','CGCG 499-075',NULL,'1997ApJS..109..333W',1997,1,NULL,NULL,'GPair',0.000033,NULL,NULL,NULL,'S?',NULL,NULL,NULL,NULL,1,3.044167,29.31944,0.137,NULL,67223062571,1050360352,16411880,NULL),(1381,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1381,34.5,0.4,79.5,506,75,NULL,'HMCL, I, inv','CGCG 499-075',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1382,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1382,34.57,0.4,82.2,506,75,NULL,'HMCL, I, raw','CGCG 499-075',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1383,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1383,34.78,0.4,90.5,506,75,NULL,'HMCL, I, cor','CGCG 499-075',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1384,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1384,36.67,0.53,216,507,70,NULL,NULL,'2MASX J00121084-1929386',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000133,NULL,'16.72',0.52,'E',NULL,NULL,NULL,NULL,1,3.04525,-19.49403,0.018,NULL,34441544360,538149130,8408580,16.72),(1385,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1385,34.82,0.46,92.1,508,70,NULL,NULL,'2MASX J00121162-1055413',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000092,NULL,'15.2g',0.37,'S0',NULL,NULL,NULL,NULL,1,3.04841666667,-10.92814,0.102,NULL,34609528181,540773877,8449591,15.2),(1386,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1386,34.95,0.52,97.6,508,70,NULL,NULL,'2MASX J00121162-1055413',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1387,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1387,37.76,0.33,357,509,70,NULL,NULL,'2MASX J00121443-0100274',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000086,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,3.0600417,-1.00758,0.098,NULL,34369678087,537026220,8391034,17.8),(1388,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1388,35.19,0.5,109,510,70,NULL,NULL,'ESO 472- G 018',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000103,NULL,'14.83',0.7,'S0(r)',NULL,NULL,NULL,NULL,1,3.060417,-27.18992,0.043,NULL,34824289951,544129530,8502023,14.83),(1389,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1389,37.81,0.27,365,511,70,NULL,NULL,'SDSS J001214.81+002234.7',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000105,NULL,'16.2g',0.3,'E0',NULL,NULL,NULL,NULL,1,3.06175,0.37631,0.033,NULL,66578462556,1040288477,16254507,16.2),(1390,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1390,37.76,0.33,357,512,70,NULL,NULL,'2MASX J00121523-0058494',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00009,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,3.0635417,-0.98039,0.105,NULL,34369684639,537026322,8391036,17.5),(1391,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 20185',NULL,1391,38.78,0.79,569,513,70,NULL,'SN photometric redshift distance, z photo =0.143 +/- 0.070','SDSS-II SN 20185',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','20.7g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,3.065375,1.24914,0.049,NULL,66579395773,1040303058,16254735,20.7),(1392,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 20185','R',1392,41.27,0.31,1430,513,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20185',0.254845,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1393,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 20185','R',1393,41.32,0.24,1470,513,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20185',0.254845,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1394,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1394,35.02,0.8,101,514,75,NULL,'W91PP, r','UGC 00113',NULL,'1997ApJS..109..333W',1997,1,1.1,'MCG data for MCG +04-01-037 and -038 are interchanged.','G',0.000067,NULL,'14.85',0.4,'Sa',NULL,NULL,NULL,NULL,1,3.06554166667,22.32181,0.101,NULL,67446645731,1053853839,16466466,14.85),(1395,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1395,35.01,0.4,101,514,NULL,NULL,'Malmquist cor.','UGC 00113',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1396,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1396,35.19,0.37,109,514,NULL,NULL,NULL,'UGC 00113',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1397,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1397,35.22,0.4,111,514,NULL,NULL,'mean','UGC 00113',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1398,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1398,35.25,0.38,112,514,75,NULL,'W91PP, r, raw','UGC 00113',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1399,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1399,35.29,0.47,114,514,NULL,NULL,'H','UGC 00113',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1400,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1400,35.33,0.45,116,514,NULL,NULL,'K','UGC 00113',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1401,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1401,35.41,0.46,121,514,NULL,NULL,'J','UGC 00113',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1402,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1402,35.43,0.38,122,514,75,NULL,'W91PP, r, cor','UGC 00113',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1403,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1403,35.52,0.38,127,514,75,NULL,'W91PP, r, inv','UGC 00113',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1404,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1404,35.58,0.2,131,514,74.4,NULL,NULL,'UGC 00113',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1405,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2007mu',NULL,1405,40.64,0.21,1350,515,70,NULL,'Hubble residual -0.08 for z0.40309','SDSS J001218.65-000439.5',NULL,'2011ApJ...740...92G',2011,1,0.08,NULL,'G',0.00018,NULL,'20.9g',0.06,NULL,NULL,NULL,NULL,NULL,1,3.07775,-0.07767,0.049,NULL,34369210402,537018912,8390920,20.9),(1406,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 18721','R',1406,41.67,0.31,1540,515,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007mu','SDSS J001218.65-000439.5',0.40309,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1407,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 18721','R',1407,41.75,0.3,1590,515,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007mu','SDSS J001218.65-000439.5',0.40309,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1408,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1408,36.67,0.57,216,516,70,NULL,NULL,'6dF J0012187-370444',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,3.078,-37.07875,NULL,NULL,34667093893,541673342,8463645,14.7),(1409,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 11624','RN',1409,39.98,0.19,834,517,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 11624',0.190403,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1410,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 11624','RN',1410,40.32,0.32,975,517,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 11624',0.190403,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1411,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 07696','RN',1411,43.66,0.52,3610,518,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 07696',0.499266,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1412,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1412,36.94,0.46,244,519,70,NULL,NULL,'2MASX J00122364-0940289',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000088,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,3.0984583,-9.67472,0.095,NULL,34608541463,540758460,8449350,16.9),(1413,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1413,37.81,0.27,365,520,70,NULL,NULL,'SDSS J001225.20+002355.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000083,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,3.105,0.39878,0.033,NULL,66578450069,1040288282,16254504,18.3),(1414,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 20294','RN',1414,43.67,0.28,3810,521,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 20294',0.418128,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1415,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 20294','RN',1415,43.7,0.38,3880,521,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 20294',0.418128,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1416,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2006nv',NULL,1416,40.05,0.13,1020,522,70,NULL,'Hubble residual -0.07 for z0.28670; SDSS-II SN 16072','SDSS-II SN 16072 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,3.1245417,-0.97783,0.105,NULL,34369681891,537026279,8391035,NULL),(1417,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2006nv','R',1417,40.77,0.24,1110,522,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006nv; SDSS-II SN 16072','SDSS-II SN 16072 HOST',0.285857,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1418,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2006nv','R',1418,40.83,0.16,1140,522,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006nv; SDSS-II SN 16072','SDSS-II SN 16072 HOST',0.285857,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1419,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 21388','N',1419,42.74,0.37,3530,523,70,NULL,'SALT 2','SDSS-II SN 21388',NULL,'2013ApJ...763...88C',2013,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1420,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 21388','N',1420,42.97,0.37,3930,523,70,NULL,'SALT 2, Malmquist cor. ','SDSS-II SN 21388',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1421,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1421,35.71,0.64,139,524,70,NULL,NULL,'2MASX J00123369-0002547',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.000096,NULL,'15.3g',0.65,'S0^-',NULL,NULL,NULL,NULL,1,3.14041666667,-0.04847,0.049,NULL,34369392396,537021756,8390964,15.3),(1422,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 14463',NULL,1422,38.78,0.25,569,525,70,NULL,'SN photometric redshift distance, z photo =0.143 +/- 0.019','SDSS-II SN 14463',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,3.14525,-0.35053,0.049,NULL,34369372290,537021442,8390960,NULL),(1423,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 09051','RN',1423,39.46,0.19,663,526,70,NULL,'SDSS CAND. Variable; SALT 2; SN 2006nv ','SDSS-II SN 09051',0.173348,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1424,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 09051','RN',1424,39.48,0.12,670,526,70,NULL,'SDSS CAND. Variable; MLCS2K2; SN 2006nv ','SDSS-II SN 09051',0.173348,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1425,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1425,34.91,0.49,95.9,527,75,NULL,'IR','UGC 00116',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000033,NULL,'15.25',0.3,'Sc','Isolated galaxy',NULL,NULL,NULL,1,3.15925,5.50536,0.161,NULL,66623414803,1040990856,16265482,15.25),(1426,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 13936','R',1426,40.74,0.08,1150,528,70,NULL,'SDSS CAND. AGN; MLCS2K2; SN 2006hz','SN 2006hz',0.227629,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'II',NULL,NULL,NULL,NULL,1,3.170833,-0.53547,0.049,NULL,34370183402,537034115,8391158,NULL),(1427,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 13936','R',1427,40.93,0.18,1250,528,70,NULL,'SDSS CAND. AGN; SALT 2; SN 2006hz','SN 2006hz',0.227629,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1428,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 17433',NULL,1428,40.01,0.28,1000,529,70,NULL,'SN photometric redshift distance, z photo =0.270 +/- 0.044','SDSS-II SN 17433',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.8g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,3.18525,-0.03433,0.049,NULL,34369326672,537020729,8390948,22.8),(1429,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 17433','R',1429,40.76,0.2,1100,529,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17433',0.288012,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1430,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 17433','R',1430,40.8,0.28,1120,529,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17433',0.288012,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1431,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 17219','RN',1431,39.75,0.21,746,530,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17219',0.194292,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1432,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 17219','RN',1432,39.95,0.18,820,530,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17219',0.194292,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1433,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1433,34.47,0.8,78.5,531,75,NULL,'HMCL, I','NGC 0041',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'14.63',0.5,'Sd             LINER','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,3.199875,22.02339,0.125,NULL,67447105059,1053861016,16466578,14.63),(1434,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1434,33.85,0.69,59,531,100,NULL,'mid-IR','NGC 0041',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1435,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1435,34.4,0.4,75.9,531,75,NULL,'HMCL, I, raw','NGC 0041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1436,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1436,34.57,0.4,82.1,531,75,NULL,'HMCL, I, inv','NGC 0041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1437,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1437,34.59,0.4,82.8,531,75,NULL,'HMCL, I, cor','NGC 0041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1438,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1438,34.72,0.2,87.9,531,74.4,NULL,NULL,'NGC 0041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1439,'GRB','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1439,37.75,NULL,354,532,65,NULL,'L = 10e57 photons/s','GRB 791116',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,3.2000417,-15.70144,0.029,NULL,34490331036,538911422,8420490,NULL),(1440,'GRB','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1440,38.09,NULL,416,532,75,NULL,NULL,'GRB 791116',NULL,'1995ApJ...453..583W',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1441,'GRB','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1441,40.59,NULL,1310,532,65,NULL,'L = 2 x 10e58 photons/s','GRB 791116',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1442,'GRB','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1442,42.66,NULL,3400,532,NULL,NULL,NULL,'GRB 791116',NULL,'1992grbo.book..107S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1443,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1443,38,0.46,398,533,70,NULL,NULL,'2MASX J00125011+1535147',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000169,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,3.2087917,15.58733,0.089,NULL,66769412396,1043272068,16301126,18),(1444,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1444,38.86,0.46,592,534,70,NULL,NULL,'2MASX J00125264-0008040',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00009,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,3.219417,-0.13444,0.049,NULL,34369359249,537021238,8390956,18.4),(1445,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1445,36.62,0.6,211,535,70,NULL,NULL,'2MASX J00125928-0646232',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.44',0.29,NULL,NULL,NULL,NULL,NULL,1,3.247125,-6.77322,0.114,NULL,34384083273,537251301,8394551,16.44),(1446,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1446,37.58,0.33,328,536,70,NULL,NULL,'2MASX J00125949+1445089',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000171,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,3.2479583,14.75247,0.217,NULL,66771089976,1043298280,16301535,18),(1447,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2005hx',NULL,1447,38.04,0.11,362,537,74.2,NULL,'SALT 2','SDSS J001259.96+001454.8',0.12,'2010ApJ...716..712A',2010,1,0.07,NULL,'G',NULL,NULL,'20.9g',0.06,NULL,NULL,NULL,NULL,NULL,1,3.249875,0.24856,0.025,NULL,66578379962,1040287186,16254487,20.9),(1448,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2005hx',NULL,1448,38.75,0.12,501,537,72,NULL,'SDSS 5549','SDSS J001259.96+001454.8',0.12,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1449,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2005hx',NULL,1449,38.75,0.12,503,537,70,NULL,'SDSS 5549, SALT 2','SDSS J001259.96+001454.8',0.12,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1450,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 05549','R',1450,38.77,0.18,508,537,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005hx','SDSS J001259.96+001454.8',0.12,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1451,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2005hx',NULL,1451,38.78,0.06,509,537,65,NULL,'SALT2','SDSS J001259.96+001454.8',0.12,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1452,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2005hx',NULL,1452,38.79,NULL,511,537,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 05549, SN 2005hx','SDSS J001259.96+001454.8',0.12,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1453,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2005hx',NULL,1453,38.67,0.06,542,537,70,NULL,'SALT 2','SDSS J001259.96+001454.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1454,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2005hx',NULL,1454,38.68,0.06,545,537,70,NULL,'SALT 2, Malmquist cor.','SDSS J001259.96+001454.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1455,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2005hx',NULL,1455,38.94,0.03,548,537,70,NULL,'SDSS 5549','SDSS J001259.96+001454.8',0.12,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1456,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 05549','R',1456,38.97,0.06,555,537,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005hx','SDSS J001259.96+001454.8',0.12,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1457,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2005hx',NULL,1457,39.03,0.07,571,537,65,NULL,'MLCS2k2','SDSS J001259.96+001454.8',0.12,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1458,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 14415','RN',1458,41.13,0.2,1450,538,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14415',0.159431,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1459,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 14415','RN',1459,41.33,0.23,1590,538,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 14415',0.159431,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1460,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1460,36.25,0.54,178,539,70,NULL,NULL,'MCG -01-01-050',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.5',0.4,NULL,NULL,NULL,NULL,NULL,1,3.2652083,-5.72539,0.118,NULL,34381919083,537217485,8394023,15.5),(1461,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2005ii',NULL,1461,40.2,0.14,843,540,74.2,NULL,'SALT 2','SDSS J001303.74-003712.9',0.3,'2010ApJ...716..712A',2010,1,0.07,NULL,'G',NULL,NULL,'20.9g',0.05,NULL,NULL,NULL,NULL,NULL,1,3.265583,-0.62025,0.085,NULL,34370008212,537031378,8391115,20.9),(1462,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2005ii',NULL,1462,40.85,0.16,1140,540,70,NULL,'SDSS-II SN 06249, SALT 2','SDSS J001303.74-003712.9',0.3,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1463,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2005ii',NULL,1463,40.9,0.12,1170,540,65,NULL,'SALT2','SDSS J001303.74-003712.9',0.3,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1464,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 06249','R',1464,40.91,0.23,1170,540,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ii','SDSS J001303.74-003712.9',0.3,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1465,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 06249','R',1465,40.91,0.15,1170,540,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ii','SDSS J001303.74-003712.9',0.3,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1466,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2005ii',NULL,1466,40.99,0.12,1210,540,65,NULL,'MLCS2k2','SDSS J001303.74-003712.9',0.3,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1467,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2005ii',NULL,1467,41.11,0.05,1280,540,70,NULL,'SDSS-II SN 06249','SDSS J001303.74-003712.9',0.3,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1468,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2005ii',NULL,1468,40.79,0.12,1440,540,70,NULL,'SALT 2','SDSS J001303.74-003712.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1469,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2005ii',NULL,1469,40.82,0.12,1460,540,70,NULL,'SALT 2, Malmquist cor.','SDSS J001303.74-003712.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1470,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 03716','RN',1470,42.9,0.23,2570,541,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03716',0.477479,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1471,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 18898','RN',1471,39.02,0.06,594,542,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18898',0.0714,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1472,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 18898','RN',1472,40.01,0.2,936,542,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18898',0.0714,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1473,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 12896','RN',1473,38.61,0.1,491,543,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 12896',0.072341,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1474,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 12896','RN',1474,38.69,0.2,511,543,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 12896',0.072341,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1475,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2005mm',NULL,1475,40.95,0.22,1120,544,74.2,NULL,'SALT 2','SDSS J001309.55+010844.6',0.382,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,3.2897917,1.14572,0.041,NULL,66579593519,1040306148,16254783,NULL),(1476,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 11206','R',1476,41.61,0.31,1520,544,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005mm','SDSS J001309.55+010844.6',0.38338,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1477,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2005mm',NULL,1477,41.62,0.26,1530,544,70,NULL,'SALT 2','SDSS J001309.55+010844.6',0.382,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1478,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 11206','R',1478,42.07,0.39,1880,544,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005mm','SDSS J001309.55+010844.6',0.38338,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1479,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1479,35.79,0.46,144,545,70,NULL,NULL,'2MASX J00131220+0044345',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000101,NULL,'15.5g',0.5,'E0',NULL,NULL,NULL,NULL,1,3.300833,0.74294,0.049,NULL,66578977034,1040296516,16254633,15.5),(1480,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1480,35.13,0.53,106,546,70,NULL,NULL,'ESO 193- G 036',NULL,'2014MNRAS.445.2677S',2014,1,0.91,NULL,'G',0.00015,NULL,'14.93',0.56,'SA(rs)b','Line-of-sight pair member',NULL,NULL,NULL,1,3.314333,-49.34081,NULL,NULL,35976001849,562125028,8783203,14.93),(1481,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1481,30.21,NULL,11,547,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00122',NULL,'2010Ap&SS.325..163P',2010,1,2.4,NULL,'G',0.000006,NULL,'15.2',0.31,'Sdm','Group member',NULL,NULL,NULL,1,3.322083,17.03,0.113,NULL,66716716968,1042448702,16288260,15.2),(1482,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1482,30.25,NULL,11.2,547,NULL,NULL,'Dipole + Quadrupole','UGC 00122',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1483,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1483,30.27,NULL,11.3,547,NULL,NULL,'Dipole','UGC 00122',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1484,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1484,30.38,NULL,11.9,547,NULL,NULL,NULL,'UGC 00122',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1485,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1485,30.51,0.4,12.7,547,75,NULL,'B','UGC 00122',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1486,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1486,36.38,0.5,189,548,70,NULL,NULL,'MCG -06-01-035',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000073,NULL,'15.45',1,'SAB0-',NULL,NULL,NULL,NULL,1,3.331875,-37.5145,NULL,NULL,34684904888,541951638,8467994,15.45),(1487,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1487,35.14,0.51,107,549,70,NULL,NULL,'2MASX J00132078-0955213',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.000092,NULL,'15.6g',0.36,'S0/a',NULL,NULL,NULL,NULL,1,3.3364583,-9.92269,0.1,NULL,34609973288,540780832,8449700,15.6),(1488,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1488,35.35,0.46,117,549,70,NULL,NULL,'2MASX J00132078-0955213',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1489,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1489,37.9,0.46,381,550,70,NULL,NULL,'2MASX J00132334-0001524',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000083,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,3.3474583,-0.03111,0.049,NULL,34369311210,537020487,8390945,18.1),(1490,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1490,37.58,0.33,328,551,70,NULL,NULL,'2MASX J00132362+1456599',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000136,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,3.348375,14.94986,0.217,NULL,66770864207,1043294753,16301480,17.2),(1491,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1491,35.71,0.65,139,552,70,NULL,NULL,'2MASX J00132422-1450251',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.58',0.46,NULL,NULL,NULL,NULL,NULL,1,3.35091666667,-14.84036,0.011,NULL,34492858924,538950920,8421108,16.58),(1492,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 10964','RN',1492,39.55,0.43,787,553,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10964',0.032167,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1493,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 10964','RN',1493,40.21,0.39,1070,553,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10964',0.032167,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1494,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1494,37.36,0.46,297,554,70,NULL,NULL,'2MASX J00132907+0040245',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000082,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,3.37125,0.67353,0.029,NULL,66579128942,1040298889,16254670,17.4),(1495,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1495,34.21,0.55,69.6,555,70,NULL,NULL,'MCG -01-01-051',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00012,NULL,'15.26',0.25,NULL,NULL,NULL,NULL,NULL,1,3.3712917,-6.79558,0.114,NULL,34384113687,537251776,8394559,15.26),(1496,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1496,36.14,0.54,169,556,70,NULL,NULL,'AM 0011-415 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.000133,NULL,'15.74',0.45,'INTERACTING','in an interacting pair',NULL,NULL,NULL,1,3.39175,-41.60614,NULL,NULL,34644389422,541318584,8458102,15.74),(1497,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1497,33.51,0.69,50.4,557,100,NULL,'mid-IR','MCG -01-01-052',NULL,'2013ApJ...771...88L',2013,1,1.2,NULL,'G',0.000037,NULL,'14.11',0.7,'SA(rs)b pec?   HII',NULL,NULL,NULL,NULL,1,3.393333,-5.09311,0.119,NULL,34423775617,537871494,8404242,14.11),(1498,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1498,34.39,0.4,75.6,557,NULL,NULL,'mean','MCG -01-01-052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1499,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1499,34.54,0.47,81,557,NULL,NULL,'H','MCG -01-01-052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1500,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1500,34.63,0.46,84.4,557,NULL,NULL,'J','MCG -01-01-052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1501,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 14659','RN',1501,40.7,0.43,1210,558,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 14659',0.139252,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1502,'Magnitude','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1502,37.18,0.13,273,559,100,NULL,NULL,'ABELL 0013',NULL,'1998A&A...337...31R',1998,1,NULL,'Katgert (1996,A&A,310,8) identify multiple redshift systems in this cluster.','GClstr',NULL,NULL,NULL,NULL,'II:    [BM]',NULL,NULL,NULL,NULL,1,3.409583,-19.50222,0.028,NULL,35308732923,551698951,8620296,NULL),(1503,'Magnitude','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1503,37.18,0.13,273,560,100,NULL,NULL,'2MASX J00133853-1930007',NULL,'1998A&A...337...31R',1998,1,0.73,NULL,'G',0.000217,NULL,'16.76',0.27,'BrClG',NULL,NULL,NULL,NULL,1,3.410583,-19.50017,0.028,NULL,35308732840,551698950,8620296,16.76),(1504,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2007kx',NULL,1504,39.06,0.08,649,561,70,NULL,'Hubble residual 0.13 for z0.15460','SDSS J001342.87+003908.4',NULL,'2011ApJ...740...92G',2011,1,0.07,NULL,'G',0.0005,NULL,'21.0g',0.04,NULL,NULL,NULL,NULL,NULL,1,3.428667,0.65236,0.029,NULL,66579076398,1040298068,16254657,21),(1505,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 18323','R',1505,39.49,0.18,684,561,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007kx','SDSS J001342.87+003908.4',0.1546,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1506,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 18323','R',1506,39.81,0.12,795,561,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007kx','SDSS J001342.87+003908.4',0.1546,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1507,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1507,38.13,0.46,423,562,70,NULL,NULL,'2MASX J00134415-1051573',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000081,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,3.434,-10.86586,0.101,NULL,34601070214,540641722,8447526,17.8),(1508,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1508,34.9,0.8,95.3,563,75,NULL,'HMCL, I','CGCG 499-081',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'14.74',0.5,'S?',NULL,NULL,NULL,NULL,1,3.43679166667,30.19525,0.153,NULL,67223744282,1050371004,16412046,14.74),(1509,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1509,34.29,0.69,72,563,100,NULL,'mid-IR','CGCG 499-081',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1510,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1510,35.12,0.4,105,563,NULL,NULL,'mean','CGCG 499-081',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1511,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1511,35.34,0.4,117,563,75,NULL,'HMCL, I, raw','CGCG 499-081',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1512,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1512,35.35,0.47,117,563,NULL,NULL,'H','CGCG 499-081',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1513,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1513,35.48,0.2,125,563,74.4,NULL,NULL,'CGCG 499-081',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1514,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1514,35.5,0.45,126,563,NULL,NULL,'K','CGCG 499-081',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1515,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1515,35.55,0.46,129,563,NULL,NULL,'J','CGCG 499-081',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1516,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1516,35.56,0.4,129,563,75,NULL,'HMCL, I, cor','CGCG 499-081',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1517,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1517,35.58,0.4,131,563,75,NULL,'HMCL, I, inv','CGCG 499-081',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1518,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1518,37.42,0.46,304,564,70,NULL,NULL,'2MASX J00134480+1447313',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000195,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,3.43679166667,14.79192,0.217,NULL,66771198983,1043299984,16301562,16.4),(1519,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 03771','RN',1519,42.09,0.21,2050,565,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03771',0.273959,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1520,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 03771','RN',1520,42.1,0.24,2060,565,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03771',0.273959,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1521,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1521,35.13,NULL,106,566,NULL,NULL,NULL,'FGC 0023',NULL,'2000BSAO...50....5K',2000,1,1.51,NULL,'G',NULL,NULL,'15.8',0.17,'Sdm',NULL,NULL,NULL,NULL,1,3.448917,43.31956,0.365,NULL,67646976086,1056984001,16515375,15.8),(1522,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1522,35.52,0.49,127,567,70,NULL,NULL,'MCG -01-01-053',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000097,NULL,'15.03',0.4,'Sa',NULL,NULL,NULL,NULL,1,3.449125,-4.47511,0.126,NULL,34424551818,537883622,8404431,15.03),(1523,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1523,37.72,0.46,349,568,70,NULL,NULL,'2MASX J00135197-0105413',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000081,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,3.46658333333,-1.09486,0.141,NULL,34371472853,537054263,8391472,17.7),(1524,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1524,37.4,0.46,302,569,70,NULL,NULL,'2MASX J00135243-0023483',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000097,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,3.4685417,-0.39672,0.049,NULL,34370193671,537034276,8391160,16.3),(1525,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1525,35.5,0.52,126,570,70,NULL,NULL,'2MASX J00135307-1246455',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.65',0.41,NULL,NULL,NULL,NULL,NULL,1,3.47116666667,-12.77931,0.073,NULL,34471567555,538618243,8415910,16.65),(1526,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1526,33.85,0.8,59,571,75,NULL,'W91PP, r','UGC 00127',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000002,NULL,'16.5',0.4,'SBcd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,3.485417,26.9675,0.093,NULL,67239472174,1050616752,16415886,16.5),(1527,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1527,34.19,0.38,68.9,571,75,NULL,'W91PP, r, inv','UGC 00127',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1528,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1528,34.27,0.38,71.4,571,75,NULL,'W91PP, r, raw','UGC 00127',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1529,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1529,34.47,0.38,78.5,571,75,NULL,'W91PP, r, cor','UGC 00127',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1530,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1530,31.56,0.43,20.5,572,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00132',NULL,'2014MNRAS.444..527S',2014,1,1.6,NULL,'G',0.000044,NULL,'14.88',0.6,'SABdm','Group member',NULL,NULL,NULL,1,3.50375,12.96278,0.153,NULL,66729071481,1042641741,16291277,14.88),(1531,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1531,37.8,0.46,363,573,70,NULL,NULL,'SDSS J001401.19+143904.3',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000138,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,3.50495833333,14.65122,0.165,NULL,66771209071,1043300141,16301564,18.7),(1532,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1532,37.88,0.46,376,574,70,NULL,NULL,'2MASX J00140154-1009344',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00008,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,3.5065,-10.15964,0.124,NULL,34610151410,540783615,8449743,17.8),(1533,'Sosies','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1533,33.92,0.2,60.8,575,NULL,NULL,NULL,'NGC 0048',NULL,'2002A&A...393...57T',2002,1,1.4,'Gregory, et al. (2000AJ....119..545G) give v = 5252 km/sec.','G',0.000027,NULL,'14.4',0.9,'SABbc pec:     HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,3.509125,48.23486,0.585,NULL,65782848024,1027857000,16060265,14.4),(1534,'Tully est','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1534,32.11,0.8,26.4,575,75,NULL,'B','NGC 0048',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1535,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1535,29.1,0.08,6.61,576,NULL,NULL,'I','NGC 0045',NULL,'2009AJ....138..332J',2009,1,8.5,'Extended HIPASS source','G',0.000001,NULL,'11.55',5.9,'SA(s)dm','Possible group member',NULL,NULL,NULL,1,3.516625,-23.18208,0.053,NULL,34772078564,543313727,8489276,11.55),(1536,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1536,29.11,0.1,6.64,576,74.4,NULL,NULL,'NGC 0045',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1537,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1537,29.09,0.8,6.59,576,75,NULL,'A82, H','NGC 0045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1538,'Sosies','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1538,30.13,0.35,10.6,576,NULL,NULL,NULL,'NGC 0045',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1539,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1539,28.85,0.4,5.9,576,75,NULL,'B','NGC 0045',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1540,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1540,29.51,NULL,7.98,576,NULL,NULL,'LEDA [April 2006]','NGC 0045',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1541,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1541,29.54,0.4,8.1,576,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 0045',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1542,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1542,29.82,NULL,9.2,576,NULL,NULL,NULL,'NGC 0045',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1543,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1543,30.19,0.6,10.9,576,53.9,NULL,'NGC 0024/NGC 0045 pair','NGC 0045',NULL,'1984A&A...132..253R',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1544,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1544,30.26,0.47,11.3,576,75,NULL,'A82, H, inv','NGC 0045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1545,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1545,30.3,0.47,11.5,576,75,NULL,'A82, H, raw','NGC 0045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1546,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1546,30.72,0.47,13.9,576,75,NULL,'A82, H, cor','NGC 0045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1547,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1547,38.02,0.46,402,577,70,NULL,NULL,'SDSS J001409.43+145514.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,3.539333,14.92058,0.165,NULL,66770838228,1043294347,16301474,18.3),(1548,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1548,34.25,0.49,70.7,578,75,NULL,'IR','UGC 00135',NULL,'2011yCatp016004901K',2011,1,1.01,NULL,'G',0.000012,NULL,'17.2',0.11,'Scd',NULL,NULL,NULL,NULL,1,3.553333,7.41128,0.173,NULL,66616000721,1040875011,16263672,17.2),(1549,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1549,34.34,0.2,73.8,578,74.4,NULL,NULL,'UGC 00135',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1550,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1550,34.53,NULL,80.4,578,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00135',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1551,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1551,34.54,NULL,81,578,NULL,NULL,'Dipole + Quadrupole','UGC 00135',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1552,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1552,34.56,NULL,81.5,578,NULL,NULL,'Dipole','UGC 00135',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1553,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1553,34.56,NULL,81.5,578,NULL,NULL,NULL,'UGC 00135',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1554,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 21389',NULL,1554,41.17,0.27,1710,579,70,NULL,'SN photometric redshift distance, z photo =0.528 +/- 0.102','SDSS-II SN 21389',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,3.564,0.02808,0.029,NULL,66578679144,1040291861,16254560,NULL),(1555,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1555,36.26,0.33,179,580,70,NULL,NULL,'2MASX J00141748+0104049',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000094,NULL,'15.9g',0.45,'E0',NULL,NULL,NULL,NULL,1,3.572875,1.06811,0.041,NULL,66580203280,1040315676,16254932,15.9),(1556,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN HFF14Tom',NULL,1556,44.18,0.18,2918,581,70,NULL,'SALT 2, with ABELL 2744 magnification','ABELL 2744:[BML2002] 0428',1.3457,'2015ApJ...811...70R',2015,1,NULL,NULL,'G',NULL,NULL,'22.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,3.575125,-30.39967,NULL,NULL,34786096412,543532756,8492699,22.3),(1557,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN HFF14Tom',NULL,1557,44.21,0.12,2956,581,70,NULL,'MLCS2k2, with ABELL 2744 magnification','ABELL 2744:[BML2002] 0428',1.3457,'2015ApJ...811...70R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1558,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN HFF14Tom',NULL,1558,44.92,0.06,4109,581,70,NULL,'SALT 2, without ABELL 2744 magnification','ABELL 2744:[BML2002] 0428',1.3457,'2015ApJ...811...70R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1559,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN HFF14Tom',NULL,1559,44.97,0.06,4205,581,70,NULL,'MLCS2k2, without ABELL 2744 magnification','ABELL 2744:[BML2002] 0428',1.3457,'2015ApJ...811...70R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1560,'G Lens','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1560,43.1,0.02,4160,582,70,NULL,'z = 7.36+/-1.14','ABELL 2744:[LBW2014] 14.1',NULL,'2014ApJ...797...98L',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1561,'Magnitude','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1561,43.06,0.02,4090,582,70,NULL,'z = 5.61+/-0.65','ABELL 2744:[LBW2014] 14.1',NULL,'2014ApJ...797...98L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1562,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1562,35.43,0.63,122,583,70,NULL,NULL,'VIII Zw 009',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.11',0.44,NULL,NULL,NULL,NULL,NULL,1,3.5772917,-6.9835,0.119,NULL,34384776177,537262127,8394720,16.11),(1563,'G Lens','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1563,43.12,0.01,4200,584,70,NULL,'z = 9.01+/-1.20','ABELL 2744:[LBW2014] 21.1',NULL,'2014ApJ...797...98L',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1564,'Magnitude','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1564,43.09,0.02,4150,584,70,NULL,'z = 6.97+/-0.78','ABELL 2744:[LBW2014] 21.1',NULL,'2014ApJ...797...98L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1565,'G Lens','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1565,42.94,0.01,3880,585,70,NULL,'z = 3.49+/-0.11','ABELL 2744:[LBW2014] 4.1.1',NULL,'2014ApJ...797...98L',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1566,'Magnitude','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1566,42.94,0.05,3870,585,70,NULL,'z = 3.47+/-0.44','ABELL 2744:[LBW2014] 4.1.1',NULL,'2014ApJ...797...98L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1567,'G Lens','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1567,42.74,0.01,3530,586,70,NULL,'z = 2.22+/-0.04','ABELL 2744:[LBW2014] 2.1.1',NULL,'2014ApJ...797...98L',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1568,'Magnitude','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1568,42.62,0.44,3350,586,70,NULL,'z = 1.86+/-0.73','ABELL 2744:[LBW2014] 2.1.1',NULL,'2014ApJ...797...98L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1569,'G Lens','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1569,42.85,NULL,3720,587,70,NULL,'z = 2.77+/-0.01','ABELL 2744:[LBW2014] 7.1',NULL,'2014ApJ...797...98L',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1570,'Magnitude','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1570,42.89,0.06,3780,587,70,NULL,'z = 3.00+/-0.39','ABELL 2744:[LBW2014] 7.1',NULL,'2014ApJ...797...98L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1571,'G Lens','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1571,42.98,NULL,3950,588,70,NULL,'z = 3.98+/-0.04','ABELL 2744:[LBW2014] 5.1',NULL,'2014ApJ...797...98L',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1572,'Magnitude','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1572,42.98,0.07,3940,588,70,NULL,'z = 3.90+/-0.76','ABELL 2744:[LBW2014] 5.1',NULL,'2014ApJ...797...98L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1573,'G Lens','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1573,43.03,0.02,4030,589,70,NULL,'z = 4.73+/-0.34','ABELL 2744:[LBW2014] 22.1',NULL,'2014ApJ...797...98L',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1574,'Magnitude','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1574,43.02,0.03,4030,589,70,NULL,'z = 4.70+/-0.56','ABELL 2744:[LBW2014] 22.1',NULL,'2014ApJ...797...98L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1575,'G Lens','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1575,42.72,0.01,3500,590,70,NULL,'z = 2.16+/-0.02','ABELL 2744:[LBW2014] 6.1',NULL,'2014ApJ...797...98L',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1576,'Magnitude','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1576,42.77,0.1,3580,590,70,NULL,'z = 2.34+/-0.35','ABELL 2744:[LBW2014] 6.1',NULL,'2014ApJ...797...98L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1577,'Magnitude','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1577,42.58,1.86,3280,591,70,NULL,'z = 1.74+/-1.34','ABELL 2744:[LBW2014] 9.1',NULL,'2014ApJ...797...98L',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1578,'G Lens','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1578,42.85,NULL,3720,592,70,NULL,'z = 2.76+/-0.02','ABELL 2744:[LBW2014] 10.1',NULL,'2014ApJ...797...98L',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1579,'Magnitude','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1579,42.87,0.07,3740,592,70,NULL,'z = 2.85+/-0.39','ABELL 2744:[LBW2014] 10.1',NULL,'2014ApJ...797...98L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1580,'G Lens','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1580,43,0.02,3980,593,70,NULL,'z = 4.19+/-0.27','ABELL 2744:[LBW2014] 3.1.1',NULL,'2014ApJ...797...98L',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1581,'Magnitude','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1581,42.99,0.04,3970,593,70,NULL,'z = 4.11+/-0.50','ABELL 2744:[LBW2014] 3.1.1',NULL,'2014ApJ...797...98L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1582,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1582,36.7,0.64,219,594,70,NULL,NULL,'2MASX J00142140-8354434',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,3.590125,-83.912,0.489,NULL,35472221637,554253463,8660210,16.6),(1583,'G Lens','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1583,42.85,NULL,3720,595,70,NULL,'z = 2.76+/-0.02','ABELL 2744:[LBW2014] 11.1',NULL,'2014ApJ...797...98L',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1584,'Magnitude','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1584,42.87,0.13,3750,595,70,NULL,'z = 2.88+/-0.64','ABELL 2744:[LBW2014] 11.1',NULL,'2014ApJ...797...98L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1585,'Magnitude','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1585,43.12,NULL,4210,596,70,NULL,'z = 9.83+/-0.22','ABELL 2744:[LBW2014] 19.1',NULL,'2014ApJ...797...98L',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1586,'G Lens','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1586,43.07,0.02,4110,597,70,NULL,'z = 6.04+/-0.77','ABELL 2744:[LBW2014] 18.1',NULL,'2014ApJ...797...98L',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1587,'Magnitude','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1587,43.09,0.02,4150,597,70,NULL,'z = 7.07+/-0.78','ABELL 2744:[LBW2014] 18.1',NULL,'2014ApJ...797...98L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1588,'G Lens','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1588,42.44,0.01,3080,598,70,NULL,'z = 1.47+/-0.01','ABELL 2744:[LBW2014] 13.1',NULL,'2014ApJ...797...98L',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1589,'Magnitude','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1589,42.39,0.18,3010,598,70,NULL,'z = 1.39+/-0.23','ABELL 2744:[LBW2014] 13.1',NULL,'2014ApJ...797...98L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1590,'G Lens','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1590,42.71,0.06,3480,599,70,NULL,'z = 2.10+/-0.19','ABELL 2744:[LBW2014] 12.1',NULL,'2014ApJ...797...98L',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1591,'Magnitude','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1591,42.85,0.15,3720,599,70,NULL,'z = 2.77+/-0.69','ABELL 2744:[LBW2014] 12.1',NULL,'2014ApJ...797...98L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1592,'G Lens','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1592,43.03,0.01,4040,600,70,NULL,'z = 4.86+/-0.21','ABELL 2744:[LBW2014] 15.1',NULL,'2014ApJ...797...98L',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1593,'Magnitude','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1593,43.02,0.04,4020,600,70,NULL,'z = 4.62+/-0.74','ABELL 2744:[LBW2014] 15.1',NULL,'2014ApJ...797...98L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1594,'G Lens','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1594,43.11,0.01,4190,601,70,NULL,'z = 8.72+/-0.98','ABELL 2744:[LBW2014] 20.1',NULL,'2014ApJ...797...98L',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1595,'Magnitude','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1595,42.93,0.05,3860,601,70,NULL,'z = 3.38+/-0.43','ABELL 2744:[LBW2014] 20.1',NULL,'2014ApJ...797...98L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1596,'G Lens','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1596,42.71,0.41,3480,602,70,NULL,'z = 2.11+/-0.85','ABELL 2744:[LBW2014] 23.1',NULL,'2014ApJ...797...98L',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1597,'Magnitude','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1597,42.61,0.13,3320,602,70,NULL,'z = 1.81+/-0.28','ABELL 2744:[LBW2014] 23.1',NULL,'2014ApJ...797...98L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1598,'G Lens','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1598,43.04,0.01,4050,603,70,NULL,'z = 4.96+/-0.24','ABELL 2744:[LBW2014] 16.1',NULL,'2014ApJ...797...98L',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1599,'Magnitude','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1599,43,0.1,3990,603,70,NULL,'z = 4.31+/-1.16','ABELL 2744:[LBW2014] 16.1',NULL,'2014ApJ...797...98L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1600,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1600,37.76,0.46,356,604,70,NULL,NULL,'2MASX J00142324+0016329',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000085,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,3.59675,0.27597,0.029,NULL,66578744535,1040292883,16254576,17.7),(1601,'G Lens','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1601,42.58,0.01,3280,605,70,NULL,'z = 1.75+/-0.02','ABELL 2744:[LBW2014] 1.1.1',NULL,'2014ApJ...797...98L',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1602,'Magnitude','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1602,42.6,0.12,3310,605,70,NULL,'z = 1.80+/-0.26','ABELL 2744:[LBW2014] 1.1.1',NULL,'2014ApJ...797...98L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1603,'G Lens','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1603,43.06,0.01,4080,606,70,NULL,'z = 5.49+/-0.28','ABELL 2744:[LBW2014] 17.1',NULL,'2014ApJ...797...98L',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1604,'Magnitude','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1604,43.08,0.02,4140,606,70,NULL,'z = 6.65+/-0.75','ABELL 2744:[LBW2014] 17.1',NULL,'2014ApJ...797...98L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1605,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2005hy',NULL,1605,38.6,0.03,464,607,70,NULL,'SDSS-II SN 05550','SDSS J001423.62+001959.6',0.13,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,3.598417,0.33322,0.029,NULL,66578746236,1040292909,16254576,NULL),(1606,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2005hy',NULL,1606,38.63,0.11,471,607,74.2,NULL,'SALT 2','SDSS J001423.62+001959.6',0.13,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1607,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2005hy',NULL,1607,39.42,0.08,678,607,65,NULL,'SALT2','SDSS J001423.62+001959.6',0.13,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1608,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 05550','R',1608,39.43,0.18,679,607,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005hy','SDSS J001423.62+001959.6',0.13,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1609,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 05550','R',1609,39.58,0.07,730,607,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005hy','SDSS J001423.62+001959.6',0.13,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1610,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2005hy',NULL,1610,39.62,0.06,743,607,65,NULL,'MLCS2k2','SDSS J001423.62+001959.6',0.13,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1611,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2005hy',NULL,1611,39.4,0.07,759,607,70,NULL,'SALT 2','SDSS J001423.62+001959.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1612,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 2005hy',NULL,1612,39.4,0.07,759,607,70,NULL,'SALT 2, Malmquist cor.','SDSS J001423.62+001959.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1613,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 1988U',NULL,1613,40.8,0.35,1440,608,67,NULL,NULL,'LEDA 138142',NULL,'1996ApJ...457..500H',1996,1,NULL,'Braglia et al. give z=0.2649+/-0.001. Owers et al. give v = 53+/-291 km/sec.','G',0.00033,NULL,'16.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,3.599875,-30.42947,NULL,NULL,34786095916,543532748,8492699,16.8),(1614,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1614,36.58,0.46,207,609,70,NULL,NULL,'2MASX J00142548+1612195',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000158,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,3.60620833333,16.20533,0.125,NULL,66770042384,1043281912,16301279,16.6),(1615,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1615,36.26,0.33,179,610,70,NULL,NULL,'SDSS J001426.23+010350.8',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000108,NULL,'15.8g',0.39,'E0',NULL,NULL,NULL,NULL,1,3.6092917,1.06414,0.041,NULL,66580207657,1040315744,16254933,15.8),(1616,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 20588','RN',1616,42.15,0.32,2090,611,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20588',0.28667,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1617,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 20588','RN',1617,42.37,0.41,2310,611,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20588',0.28667,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1618,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1618,36.88,0.16,238,612,70,NULL,NULL,'MCG +00-01-042',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00012,NULL,'15.5g',0.37,'E0',NULL,NULL,NULL,NULL,1,3.632875,0.00828,0.029,NULL,66578684406,1040291943,16254561,15.5),(1619,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 1998dk',NULL,1619,32.64,0.28,33.3,613,74.2,NULL,'SALT 2','UGC 00139',0.01322,'2010ApJ...716..712A',2010,1,2.03,'Host galaxy of UM 217.','G',0.000013,NULL,'14.3g',0.66,'SAB(s)c?       HII','Isolated galaxy',NULL,NULL,NULL,1,3.6327083,-0.73756,0.126,NULL,34372136880,537064638,8391634,14.3),(1620,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 1998dk',NULL,1620,33.42,0.08,48.3,613,74.4,NULL,NULL,'UGC 00139',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1621,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 1998dk',NULL,1621,33.45,0.05,48.4,613,72,NULL,NULL,'UGC 00139',0.01322,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1622,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 1998dk',NULL,1622,33.55,0.17,51.3,613,70.8,NULL,NULL,'UGC 00139',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1623,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 1998dk',NULL,1623,33.64,0.2,52.8,613,70,NULL,'SALT','UGC 00139',0.01322,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1624,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 1998dk',NULL,1624,33.8,0.22,56.1,613,65,NULL,'MLCS2k2','UGC 00139',0.01322,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1625,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SN 1998dk',NULL,1625,33.85,0.14,58.9,613,60,NULL,NULL,'UGC 00139',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1626,'IRAS','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1626,33.39,0.8,47.7,613,75,NULL,'MAT, I','UGC 00139',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1627,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1627,33.42,0.08,48.3,613,74.4,NULL,NULL,'UGC 00139',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1628,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1628,33.79,0.43,57.3,613,75,NULL,'MAT, I, raw','UGC 00139',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1629,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1629,33.8,0.32,57.6,613,85,NULL,'I, raw','UGC 00139',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1630,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1630,33.83,0.43,58.3,613,75,NULL,'3.6 micron, color corrected','UGC 00139',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1631,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1631,33.83,0.43,58.4,613,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00139',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1632,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1632,33.84,0.32,58.5,613,85,NULL,'I, inv','UGC 00139',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1633,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1633,33.88,0.4,59.7,613,75,NULL,'HOSTS SN 1998dk','UGC 00139',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1634,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1634,33.95,0.43,61.6,613,75,NULL,'MAT, I, inv','UGC 00139',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1635,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1635,33.96,0.47,61.9,613,NULL,NULL,NULL,'UGC 00139',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1636,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1636,34.12,0.43,66.8,613,75,NULL,'MAT, I, cor','UGC 00139',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1637,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1637,34.16,0.42,68,613,NULL,NULL,'Malmquist cor.','UGC 00139',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1638,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1638,37.27,0.46,285,614,70,NULL,NULL,'2MASX J00143275+0055119',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000094,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,3.636375,0.92011,0.041,NULL,66580295281,1040317113,16254954,17.8),(1639,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 05680','RN',1639,39.73,1.11,830,615,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05680',0.064647,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1640,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1640,36.88,0.16,238,616,70,NULL,NULL,'MCG +00-01-044',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00012,NULL,'16.0g',0.41,'E0',NULL,NULL,NULL,NULL,1,3.644583,-0.0125,0.029,NULL,34369777375,537027771,8391058,16),(1641,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1641,37.41,0.46,303,617,70,NULL,NULL,'2MASX J00143853-1056158',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00008,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,3.6605417,-10.93775,0.085,NULL,34601782055,540652844,8447700,17.2),(1642,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1642,37.78,0.46,360,618,70,NULL,NULL,'2MASX J00143967-0052289',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000094,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,3.66529166667,-0.87467,0.141,NULL,34372174564,537065227,8391644,17.4),(1643,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1643,34.06,0.45,64.9,619,NULL,NULL,'K','NGC 0052',NULL,'2007A&A...465...71T',2007,1,2.1,NULL,'G',0.000017,NULL,'14.34',0.4,'S?',NULL,NULL,NULL,NULL,1,3.667125,18.58203,0.101,NULL,66716446175,1042444471,16288194,14.34),(1644,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1644,34.06,0.47,64.9,619,NULL,NULL,'H','NGC 0052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1645,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1645,34.12,0.46,66.8,619,NULL,NULL,'J','NGC 0052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1646,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1646,34.22,0.4,69.8,619,NULL,NULL,'mean','NGC 0052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1647,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1647,34.46,0.49,78.1,619,75,NULL,'IR','NGC 0052',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1648,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1648,34.66,0.34,85.5,619,NULL,NULL,'Malmquist cor.','NGC 0052',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1649,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1649,34.73,0.33,88.1,619,NULL,NULL,NULL,'NGC 0052',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1650,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1650,34.77,0.2,90,619,74.4,NULL,NULL,'NGC 0052',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1651,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 18279','RN',1651,42.71,0.24,2350,620,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 18279',0.47798,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1652,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1652,38.23,0.33,442,621,70,NULL,NULL,'2MASX J00144282-1010243',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000079,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,3.678375,-10.1735,0.099,NULL,34609659736,540775933,8449623,17.2),(1653,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1653,34.3,0.53,72.3,622,70,NULL,NULL,'NGC 0053',NULL,'2014MNRAS.445.2677S',2014,1,2,NULL,'G',0.000087,NULL,'13.33',1.4,'(R\')SB(r)ab',NULL,NULL,NULL,NULL,1,3.6785417,-60.32875,0,NULL,36084150915,563814858,8809607,13.33),(1654,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1654,34.12,0.47,66.8,623,70,NULL,NULL,'NGC 0050',NULL,'2014MNRAS.445.2677S',2014,1,2.3,NULL,'G',0.00003,NULL,'13.30',1.7,'S0- pec',NULL,NULL,NULL,NULL,1,3.6857083,-7.34508,0.123,NULL,34383282145,537238783,8394355,13.3),(1655,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1655,36.79,0.46,228,624,70,NULL,NULL,'2MASX J00144473-0940353',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000082,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,3.6862917,-9.67647,0.101,NULL,34611320911,540801889,8450029,16.9),(1656,'Brightest Stars','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'N',1656,26.18,NULL,1.72,625,NULL,NULL,NULL,'Pisces A',NULL,'2015ApJ...798L..21T',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1657,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 12877','RN',1657,39.11,0.14,621,626,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 12877',0.065987,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1658,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 12877','RN',1658,39.68,0.4,809,626,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 12877',0.065987,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1659,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 16282','RN',1659,38.8,0.16,529,627,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 16282',0.086602,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1660,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 16282','RN',1660,38.92,0.21,559,627,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 16282',0.086602,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1661,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1661,37.41,0.46,303,628,70,NULL,NULL,'2MASX J00144947+0041053',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000095,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,3.70616666667,0.68494,0.037,NULL,66579779754,1040309058,16254829,16.7),(1662,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 20992','RN',1662,42.59,0.37,2300,629,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 20992',0.434665,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1663,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 20992','RN',1663,43.16,0.41,2990,629,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20992',0.434665,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1664,'Brightest Stars','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1664,26,NULL,1.58,630,NULL,NULL,NULL,'NGC 0055',NULL,'1998ApJ...497..650D',1998,1,32.4,NULL,'G',0.000007,NULL,'8.84',5.6,'SB(s)m: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,3.723333,-39.19664,NULL,0,34684149908,541939842,8467810,8.84),(1665,'Carbon Stars','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1665,25.66,0.13,1.34,630,NULL,NULL,NULL,'NGC 0055',NULL,'1987ApJ...323...79P',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1666,'Cepheids','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1666,26.34,0.09,1.85,630,NULL,NULL,'36, JHKs, GAL PL','NGC 0055',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1667,'Cepheids','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1667,26.35,0.06,1.86,630,NULL,NULL,'36, JHKs, LMC PL','NGC 0055',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1668,'Cepheids','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1668,26.37,0.06,1.88,630,NULL,NULL,'36, JHKs, GAL+LMC PL','NGC 0055',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1669,'Cepheids','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1669,26.4,0.05,1.91,630,NULL,NULL,'133, VI(W)','NGC 0055',NULL,'2006AJ....132.2556P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1670,'Cepheids','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1670,26.41,0.28,1.91,630,NULL,NULL,'JK(W)','NGC 0055',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1671,'Cepheids','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1671,26.43,0.04,1.94,630,NULL,NULL,'40, JK','NGC 0055',NULL,'2008ApJ...672..266G',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1672,'Cepheids','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1672,26.49,0.06,1.99,630,74.4,NULL,NULL,'NGC 0055',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1673,'Cepheids','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1673,26.52,0.38,2.01,630,NULL,NULL,'VI(W)','NGC 0055',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1674,'PNLF','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1674,26.81,0.31,2.3,630,NULL,NULL,'21 PNe','NGC 0055',NULL,'2006A&A...455..891V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1675,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1675,25.8,0.5,1.45,630,NULL,NULL,'Photographic, V','NGC 0055',NULL,'1982ApJ...252..474G',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1676,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1676,26.49,0.06,1.99,630,74.4,NULL,NULL,'NGC 0055',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1677,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1677,26.5,NULL,2,630,NULL,NULL,NULL,'NGC 0055',NULL,'2005ApJ...622..279D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1678,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1678,26.59,0.03,2.08,630,NULL,NULL,'I','NGC 0055',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1679,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1679,26.6,0.02,2.09,630,NULL,NULL,'I','NGC 0055',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1680,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1680,26.58,0.11,2.1,630,NULL,NULL,'I','NGC 0055',NULL,'2011ApJ...738..150T',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1681,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1681,26.62,0.03,2.11,630,NULL,NULL,'I','NGC 0055',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1682,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1682,26.62,0.03,2.11,630,NULL,NULL,'I','NGC 0055',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1683,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1683,26.64,0.1,2.12,630,NULL,NULL,'VI','NGC 0055',NULL,'2005A&A...431..127T',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1684,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1684,26.63,0.03,2.12,630,NULL,NULL,'disk','NGC 0055',NULL,'2005AJ....129.1331S',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1685,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1685,26.63,0.04,2.12,630,NULL,NULL,'I','NGC 0055',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1686,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1686,26.68,0.03,2.17,630,NULL,NULL,NULL,'NGC 0055',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1687,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1687,24.91,NULL,0.959,630,NULL,NULL,'LEDA [April 2006]','NGC 0055',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1688,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1688,25.63,0.4,1.3,630,75,NULL,'B','NGC 0055',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1689,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1689,25.98,0.36,1.57,630,NULL,NULL,NULL,'NGC 0055',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1690,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1690,26.28,NULL,1.8,630,NULL,NULL,NULL,'NGC 0055',NULL,'2003A&A...404...93K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1691,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1691,26.49,0.06,1.99,630,74.4,NULL,NULL,'NGC 0055',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1692,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1692,26.9,0.4,2.4,630,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 3 galaxy group','NGC 0055',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1693,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1693,37.7,0.46,347,631,70,NULL,NULL,'2MASX J00145949+0017514',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000083,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,3.7479583,0.2975,0.033,NULL,66578781920,1040293467,16254585,17),(1694,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 15961','RN',1694,40.7,0.32,1070,632,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15961',0.285281,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1695,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 15961','RN',1695,40.74,0.38,1100,632,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15961',0.285281,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1696,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 00952','RN',1696,42.01,0.18,1720,633,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00952',0.46156,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1697,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 17316','RN',1697,38.28,0.19,411,634,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 17316',0.104112,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1698,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 17316','RN',1698,38.62,0.24,479,634,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 17316',0.104112,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1699,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1699,35.98,0.46,157,635,70,NULL,NULL,'2MASX J00150414+1608387',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000164,NULL,'16.4g',0.3,'E0',NULL,NULL,NULL,NULL,1,3.76720833333,16.14397,0.125,NULL,66769720275,1043276879,16301201,16.4),(1700,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 04020','RN',1700,43.03,0.23,2440,636,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04020',0.655342,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1701,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1701,36.88,0.16,238,637,70,NULL,NULL,'2MASX J00150985-0001528',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000068,NULL,'17.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,3.791,-0.03144,0.033,NULL,34369799523,537028117,8391064,17),(1702,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1702,37.62,0.46,334,638,70,NULL,NULL,'2MASX J00151055-0104338',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,3.7939583,-1.07614,0.094,NULL,34372208594,537065759,8391652,17.4),(1703,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1703,37.57,0.21,327,639,70,NULL,NULL,'SDSS J001510.60+144050.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000138,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,3.794167,14.68078,0.153,NULL,66770562280,1043290035,16301406,18.7),(1704,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1704,37.18,0.58,273,640,70,NULL,NULL,'2MASX J00151200-4328236',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'15.4R',0.11,NULL,NULL,NULL,NULL,NULL,1,3.80008333333,-43.47325,NULL,NULL,38120143665,595627244,9306675,15.4),(1705,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1705,38.24,0.46,444,641,70,NULL,NULL,'2MASX J00151313+1504248',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,3.80475,15.07369,0.153,NULL,66773160995,1043330640,16302041,18),(1706,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1706,35.08,0.48,104,642,70,NULL,NULL,'ESO 111- G 022',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000087,NULL,'15.10',0.7,'(R)SA(r)b',NULL,NULL,NULL,NULL,1,3.818375,-57.24467,0,NULL,36206961449,565733772,8839590,15.1),(1707,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1707,35.97,0.52,157,643,70,NULL,NULL,'2MASX J00151909-6144405',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00009,NULL,'16.65',0.28,'S',NULL,NULL,NULL,NULL,1,3.829417,-61.74461,0,NULL,36094377723,563974651,8812103,16.65),(1708,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1708,37.57,0.21,327,644,70,NULL,NULL,'SDSS J001521.77+143635.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00016,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,3.84075,14.60994,0.153,NULL,66770553632,1043289900,16301404,18.4),(1709,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1709,37.52,0.46,319,645,70,NULL,NULL,'2MASX J00152331+1556349',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,3.847167,15.943,0.105,NULL,66769859742,1043279058,16301235,18.1),(1710,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1710,36.88,0.16,238,646,70,NULL,NULL,'2MASX J00152393-0024087',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000087,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,3.84975,-0.40239,0.053,NULL,34371898711,537060917,8391576,16.5),(1711,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1711,38.23,0.33,442,647,70,NULL,NULL,'2MASX J00152413-1009099',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000094,NULL,'18.3g',0.1,NULL,NULL,NULL,NULL,NULL,1,3.8504583,-10.15272,0.099,NULL,34609814588,540778352,8449661,18.3),(1712,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1712,36.88,0.16,238,648,70,NULL,NULL,'SDSS J001524.52-002547.4',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000064,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,3.85220833333,-0.42986,0.073,NULL,34371898196,537060909,8391576,18.6),(1713,'SBF','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1713,28.21,0.07,4.39,649,NULL,NULL,NULL,'NGC 0059',NULL,'1998AJ....116.2873J',1998,1,2.6,'APMBGC position is 10 arcsec northwest of the nucleus.','G',0.000033,NULL,'12.9B',1.3,'SA(rs)0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,3.8547083,-21.44439,0.057,NULL,35315066681,551797916,8621842,12.9),(1714,'SBF','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1714,28.62,NULL,5.3,649,NULL,NULL,NULL,'NGC 0059',NULL,'2004AJ....127.2031K',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1715,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1715,28.45,0.1,4.89,649,74.4,NULL,NULL,'NGC 0059',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1716,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1716,34.33,0.49,73.4,650,75,NULL,'IR','UGC 00144',NULL,'2011yCatp016004901K',2011,1,1.12,NULL,'G',0.000067,NULL,'15.8g',0.25,'Sb-c',NULL,NULL,NULL,NULL,1,3.861875,16.23528,0.105,NULL,66762193875,1043159279,16299363,15.8),(1717,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1717,34.23,0.4,70.1,651,NULL,NULL,'mean','NGC 0057',NULL,'2007A&A...465...71T',2007,1,2.2,NULL,'G',0.000073,NULL,'12.67',1.9,'E','Brightest group member',NULL,NULL,NULL,1,3.878625,17.32853,0.141,NULL,66717169004,1042455765,16288371,12.67),(1718,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1718,34.63,0.45,84.2,651,NULL,NULL,'K','NGC 0057',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1719,'Red Clump','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1719,26.05,NULL,1.62,652,NULL,NULL,'V, M RC(V) = +0.73 mag','ESO 410- G 005',NULL,'2010AJ....140.1038P',2010,1,1.3,'The 2dF redshift applies to a superposed star.','G',0.000007,NULL,'14.85',1,'E3:',NULL,NULL,NULL,NULL,1,3.8815,-32.17994,NULL,0,34860341667,544692838,8510825,14.85),(1720,'Red Clump','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1720,26.44,NULL,1.94,652,NULL,NULL,'I, M RC(I) = -0.50 mag','ESO 410- G 005',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1721,'RR Lyrae','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1721,26.33,0.07,1.85,652,NULL,NULL,NULL,'ESO 410- G 005',NULL,'2014ApJ...784...76Y',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1722,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1722,26.38,NULL,1.89,652,NULL,NULL,NULL,'ESO 410- G 005',NULL,'2014ApJ...784...76Y',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1723,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1723,26.4,0.15,1.9,652,NULL,NULL,NULL,'ESO 410- G 005',NULL,'2000ApJ...542..128K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1724,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1724,26.42,NULL,1.92,652,NULL,NULL,NULL,'ESO 410- G 005',NULL,'2000A&AS..145..415K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1725,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1725,26.42,0.04,1.92,652,NULL,NULL,'I','ESO 410- G 005',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1726,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1726,26.43,NULL,1.93,652,NULL,NULL,'I, M TRGB(I) = -4.05 mag','ESO 410- G 005',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1727,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1727,26.44,0.05,1.94,652,NULL,NULL,NULL,'ESO 410- G 005',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1728,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1728,26.45,0.05,1.95,652,NULL,NULL,NULL,'ESO 410- G 005',NULL,'2013A&A...550A...7L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1729,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1729,26.46,0.08,1.96,652,74.4,NULL,NULL,'ESO 410- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1730,'TRGB','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1730,26.51,0.09,2.01,652,NULL,NULL,'I','ESO 410- G 005',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1731,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 08338','RN',1731,36.82,0.1,201,653,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 08338',0.151602,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1732,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 08338','RN',1732,40.05,0.42,889,653,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08338',0.151602,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1733,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 16468','RN',1733,40.03,0.27,828,654,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16468',0.226581,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1734,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 16468','RN',1734,40.08,0.23,846,654,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16468',0.226581,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1735,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1735,37.57,0.21,327,655,70,NULL,NULL,'SDSS J001532.44+143935.4',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.8g',0.29,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,3.88520833333,14.65986,0.153,NULL,66770557900,1043289967,16301405,16.8),(1736,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1736,36.05,0.8,162,656,70,NULL,NULL,'2MASX J00153409-0303380',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'17.46',0.2,NULL,NULL,NULL,NULL,NULL,1,3.892,-3.06061,0.161,NULL,34423220082,537862813,8404106,17.46),(1737,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1737,37.7,0.46,346,657,70,NULL,NULL,'SDSS J001536.54+143524.8',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000156,NULL,'18.8g',0.09,NULL,NULL,NULL,NULL,NULL,1,3.90225,14.59022,0.153,NULL,66770544900,1043289764,16301402,18.8),(1738,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 17746','R',1738,40.52,0.26,1100,658,70,NULL,'SDSS CAND. Unknown; SALT 2; SN 2007jv','SN 2007jv',0.157,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia?',NULL,NULL,NULL,NULL,1,3.9037917,-0.38933,0.053,NULL,34372029689,537062963,8391608,NULL),(1739,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 17746','R',1739,40.62,0.26,1150,658,70,NULL,'SDSS CAND. Unknown; MLCS2K2; SN 2007jv','SN 2007jv',0.157,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1740,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1740,37.57,0.21,327,659,70,NULL,NULL,'2MASX J00153695+1439382',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,3.90408333333,14.66064,0.137,NULL,66770540144,1043289689,16301401,17),(1741,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 20709','R',1741,41.23,0.33,1270,660,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20709',0.390557,'2014arXiv1401.3317S',2014,1,0.09,NULL,'G',NULL,'PHOT','21.3g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,3.91275,-0.16703,0.033,NULL,34369752622,537027384,8391052,21.3),(1742,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 20709','R',1742,41.27,0.36,1290,660,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20709',0.390557,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1743,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 20709',NULL,1743,40.78,0.41,1430,660,70,NULL,'SN photometric redshift distance, z photo =0.416 +/- 0.119','SDSS-II SN 20709',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1744,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 20709',NULL,1744,41.05,0.25,1620,660,70,NULL,'SALT 2','SDSS-II SN 20709',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1745,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 20709',NULL,1745,41.11,0.25,1670,660,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20709',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1746,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 03720','RN',1746,40.4,0.1,1040,661,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03720',0.153455,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1747,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 03720','RN',1747,40.96,0.19,1350,661,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03720',0.153455,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1748,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1748,37.57,0.21,327,662,70,NULL,NULL,'2MASX J00154349+1445232',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,3.93125,14.75644,0.137,NULL,66772463531,1043319742,16301870,16.7),(1749,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1749,34.49,0.48,79.2,663,70,NULL,NULL,'6dF J0015440-330150',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,3.9332917,-33.03064,NULL,NULL,34861702584,544714102,8511157,13.3),(1750,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 17372','RN',1750,41.46,0.37,1710,664,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17372',0.146134,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1751,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 17372','RN',1751,41.54,0.4,1770,664,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17372',0.146134,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1752,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1752,35.28,0.47,114,665,70,NULL,NULL,'2MASX J00154647-5913412',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00009,NULL,'15.35',0.63,'S0',NULL,NULL,NULL,NULL,1,3.94375,-59.22808,0,NULL,36086937244,563858394,8810287,15.35),(1753,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1753,33.33,0.51,46.3,666,NULL,NULL,NULL,'UGC 00148',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000017,NULL,'15.2B',0.3,'S?             LLIRG','Group member',NULL,NULL,NULL,1,3.963667,16.08978,0.105,NULL,66769755518,1043277429,16301209,15.2),(1754,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1754,33.33,0.2,46.3,666,74.4,NULL,NULL,'UGC 00148',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1755,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1755,33.4,0.5,47.9,666,NULL,NULL,'Malmquist cor.','UGC 00148',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1756,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1756,33.47,0.49,49.5,666,75,NULL,'IR','UGC 00148',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1757,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1757,33.66,0.47,54,666,NULL,NULL,'H','UGC 00148',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1758,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1758,33.74,0.4,55.9,666,NULL,NULL,'mean','UGC 00148',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1759,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1759,33.77,0.45,56.8,666,NULL,NULL,'K','UGC 00148',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1760,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1760,33.8,0.46,57.5,666,NULL,NULL,'J','UGC 00148',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1761,'SGRB','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1761,42.6,NULL,3310,667,70,NULL,'Photometric Distance, Host A, M(R) = -20 mag and spectral slope Beta = 1.0 ','GRB 081105',NULL,'2012A&A...545A..77R',2012,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,3.9522083,3.47014,0.057,NULL,66638661210,1041229081,16269204,NULL),(1762,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1762,37.28,0.46,286,668,70,NULL,NULL,'2MASX J00155566+1614581',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000211,NULL,'15.8g',0.48,'E0',NULL,NULL,NULL,NULL,1,3.98204166667,16.24942,0.105,NULL,66762235264,1043159926,16299373,15.8),(1763,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1763,34.61,0.2,83.6,669,74.4,NULL,NULL,'UGC 00149',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000033,NULL,'16.6g',0.23,'Sb','Isolated galaxy',NULL,NULL,NULL,1,3.98983333333,14.07556,0.149,NULL,66759280542,1043113758,16298652,16.6),(1764,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1764,34.62,0.35,84.1,669,NULL,NULL,'Malmquist cor.','UGC 00149',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1765,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1765,34.64,0.35,84.6,669,NULL,NULL,NULL,'UGC 00149',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1766,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1766,35.89,0.2,151,670,74.4,NULL,NULL,'2MASX J00160121+1601331',NULL,'2013AJ....146...86T',2013,1,0.47,'Springob et al. (2005ApJS..160..149S) give v= 8362 km/sec.','G',0.000156,NULL,'16.5g',0.32,'S0^-',NULL,NULL,NULL,NULL,1,4.00495833333,16.02594,0.105,NULL,66769762956,1043277546,16301211,16.5),(1767,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1767,35.89,0.67,151,670,NULL,NULL,'Malmquist cor.','2MASX J00160121+1601331',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1768,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1768,35.93,0.66,154,670,NULL,NULL,NULL,'2MASX J00160121+1601331',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1769,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 15987',NULL,1769,41.29,0.17,1810,671,70,NULL,'SN photometric redshift distance, z photo =0.569 +/- 0.068','SDSS-II SN 15987',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.6g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,4.009375,0.11169,0.029,NULL,66578608579,1040290759,16254543,21.6),(1770,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 15987','R',1770,42.23,0.33,1940,671,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15987',0.44093,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1771,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 15987','R',1771,42.3,0.34,2000,671,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15987',0.44093,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1772,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 15987',NULL,1772,42.28,0.23,2860,671,70,NULL,'SALT 2','SDSS-II SN 15987',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1773,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 15987',NULL,1773,42.37,0.23,2980,671,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15987',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1774,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 13689','R',1774,40.64,0.19,1070,672,70,NULL,'SDSS CAND. SNIa; SALT 2','SDSS J001603.66+004830.0',0.252,'2014arXiv1401.3317S',2014,1,0.1,NULL,'G',NULL,NULL,'19.5g',0.09,NULL,NULL,NULL,NULL,NULL,1,4.01525,0.80836,0.041,NULL,66580182013,1040315343,16254927,19.5),(1775,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 13689','R',1775,40.86,0.12,1190,672,70,NULL,'SDSS CAND. SNIa; MLCS2K2','SDSS J001603.66+004830.0',0.252,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1776,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 13689',NULL,1776,40.61,0.09,1320,672,70,NULL,'SALT 2','SDSS J001603.66+004830.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1777,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 13689',NULL,1777,40.63,0.09,1340,672,70,NULL,'SALT 2, Malmquist cor.','SDSS J001603.66+004830.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1778,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 13689',NULL,1778,39.99,0.2,995,673,70,NULL,NULL,'SDSS-II SN 13689',NULL,'2013MNRAS.434.1443X',2013,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,4.016,0.80747,0.041,NULL,66580182013,1040315343,16254927,NULL),(1779,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 21803','RN',1779,40.47,0.56,1090,674,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 21803',0.139356,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1780,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1780,37.37,0.46,298,675,70,NULL,NULL,'2MASXi J0016043-011118',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,4.0182917,-1.18875,0.094,NULL,34371783832,537059122,8391548,17.9),(1781,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1781,37.17,0.46,271,676,70,NULL,NULL,'2MASX J00160497-0922367',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000073,NULL,'17.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,4.02079166667,-9.37675,0.105,NULL,34611187379,540799802,8449996,17.7),(1782,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 03521','RN',1782,42.97,0.24,2770,677,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03521',0.416233,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1783,'SNIa SDSS','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 03521','RN',1783,43,0.21,2800,677,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03521',0.416233,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1784,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1784,37.28,0.46,286,678,70,NULL,NULL,'2MASX J00160744-0956026',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000082,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,4.031125,-9.93408,0.098,NULL,34610646528,540791352,8449864,17.1),(1785,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1785,38.98,0.46,626,679,70,NULL,NULL,'SDSS J001607.51+155222.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,4.03129166667,15.87286,0.105,NULL,66769889314,1043279520,16301242,18.6),(1786,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1786,35.21,NULL,110,680,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 350- G 005',NULL,'2010Ap&SS.325..163P',2010,1,1.12,'Matthews (2000A&AS..143..421M) detects another feature at v=3689 km/sec.','G',0.000037,NULL,'16.70',0.12,'Sd',NULL,NULL,NULL,NULL,1,4.0665417,-34.50872,NULL,NULL,34671390825,541740481,8464695,16.7),(1787,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1787,35.22,NULL,111,680,NULL,NULL,'Dipole + Quadrupole','ESO 350- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1788,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1788,35.24,NULL,112,680,NULL,NULL,'Dipole','ESO 350- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1789,'Tully-Fisher','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,NULL,1789,35.26,NULL,113,680,NULL,NULL,NULL,'ESO 350- G 005',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1790,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1790,37.2,0.46,275,681,70,NULL,NULL,'2MASX J00161764-0006054',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000087,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,4.073583,-0.10172,0.029,NULL,34369711201,537026737,8391042,17.4),(1791,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1791,35.83,0.27,147,682,70,NULL,NULL,'MRK 0942',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000077,NULL,'16.3g',0.3,'Compact',NULL,NULL,NULL,NULL,1,4.08875,0.78861,0.041,NULL,66580132361,1040314568,16254915,16.3),(1792,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1792,36.88,0.16,238,683,70,NULL,NULL,'2MASX J00162168-0034284',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00015,NULL,'16.99',0.31,NULL,NULL,NULL,NULL,NULL,1,4.090417,-0.57456,0.137,NULL,34371992588,537062384,8391599,16.99),(1793,'SNIa','2016-12-15 15:13:31','2016-12-16 11:18:32','1','SDSS-II SN 02651',NULL,1793,40.81,0.16,1450,684,70,NULL,'SN photometric redshift distance, z photo =0.423 +/- 0.043','SDSS-II SN 02651',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,4.093083,0.71614,0.041,NULL,66580129431,1040314522,16254914,NULL),(1794,'FP','2016-12-15 15:13:31','2016-12-16 11:18:32','1',NULL,'R',1794,38.25,0.33,448,685,70,NULL,NULL,'2MASXi J0016268-090337',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,4.111917,-9.06042,0.11,NULL,34611073630,540798025,8449969,18.2),(1795,'FP','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,'R',1795,38.25,0.33,448,686,70,NULL,NULL,'2MASX J00162698-0905486',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000076,NULL,'18.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,4.112125,-9.09689,0.11,NULL,34611048420,540797631,8449962,18.5),(1796,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1796,33.97,0.8,62.3,687,75,NULL,'W91PP, r','UGC 00152',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'15.38',0.4,'Scd:',NULL,NULL,NULL,NULL,1,4.118417,29.92394,0.133,NULL,67221213764,1050331465,16411429,15.38),(1797,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1797,33.92,0.38,60.7,687,75,NULL,'W91PP, r, inv','UGC 00152',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1798,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1798,33.95,0.38,61.7,687,75,NULL,'W91PP, r, raw','UGC 00152',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1799,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1799,34.1,0.2,66.1,687,74.4,NULL,NULL,'UGC 00152',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1800,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,'R',1800,34.12,0.49,66.6,687,75,NULL,'IR','UGC 00152',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1801,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1801,34.17,0.38,68.1,687,75,NULL,'W91PP, r, cor','UGC 00152',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1802,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1802,34.19,0.36,68.8,687,NULL,NULL,NULL,'UGC 00152',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1803,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1803,34.38,0.33,75.1,687,NULL,NULL,'Malmquist cor.','UGC 00152',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1804,'FP','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,'R',1804,36.88,0.16,238,688,70,NULL,NULL,'2MASX J00162902-0036265',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000102,NULL,'16.0g',0.43,'S0',NULL,NULL,NULL,NULL,1,4.120917,-0.60739,0.137,NULL,34371989666,537062338,8391599,16),(1805,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:32','1','SDSS-II SN 13135','R',1805,38.37,0.18,427,689,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006fz','2MASX J00164188-0025300',0.104743,'2014arXiv1401.3317S',2014,1,0.29,NULL,'G',0.000087,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,4.174375,-0.42517,0.071,NULL,34371945846,537061653,8391588,17.9),(1806,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:32','1','SN 2006fz',NULL,1806,38.23,0.07,443,689,70,NULL,'SALT 2','2MASX J00164188-0025300',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1807,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:32','1','SN 2006fz',NULL,1807,38.23,0.07,443,689,70,NULL,'SALT 2, Malmquist cor.','2MASX J00164188-0025300',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1808,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:32','1','SDSS-II SN 13135','R',1808,38.56,0.05,466,689,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006fz','2MASX J00164188-0025300',0.104743,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1809,'FP','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,'R',1809,38.05,0.46,407,690,70,NULL,NULL,'SDSS J001641.91-010014.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00007,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,4.17466666667,-1.00394,0.093,NULL,34371648749,537057011,8391515,18.6),(1810,'FP','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,'R',1810,36.88,0.16,238,691,70,NULL,NULL,'2MASX J00164255-0026430',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00015,NULL,'16.43',0.35,'BrClG',NULL,NULL,NULL,NULL,1,4.1772917,-0.44544,0.071,NULL,34371958072,537061844,8391591,16.43),(1811,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1811,33.47,0.47,49.4,692,NULL,NULL,'H','UGC 00155',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000003,NULL,'13.4B',0.4,'S?',NULL,NULL,NULL,NULL,1,4.184083,7.07608,0.109,NULL,66615522423,1040867537,16263555,13.4),(1812,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1812,33.49,0.45,50,692,NULL,NULL,'K','UGC 00155',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1813,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1813,33.52,0.46,50.6,692,NULL,NULL,'J','UGC 00155',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1814,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1814,33.53,0.4,50.9,692,NULL,NULL,'mean','UGC 00155',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1815,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1815,33.84,0.2,58.6,692,74.4,NULL,NULL,'UGC 00155',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1816,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1816,33.88,0.41,59.7,692,NULL,NULL,NULL,'UGC 00155',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1817,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1817,33.95,0.4,61.8,692,NULL,NULL,'Malmquist cor.','UGC 00155',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1818,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,'R',1818,33.99,0.49,62.7,692,75,NULL,'IR','UGC 00155',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1819,'FP','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1819,36.3,0.54,182,693,70,NULL,NULL,'LCRS B001415.6-421522',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00008,NULL,'16.56',0.37,NULL,NULL,NULL,NULL,NULL,1,4.19,-41.97844,NULL,NULL,34635056446,541172756,8455824,16.56),(1820,'FP','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1820,36.68,0.67,216,694,70,NULL,NULL,'2MASX J00164573-0823503',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.62',0.36,NULL,NULL,NULL,NULL,NULL,1,4.190625,-8.39731,0.127,NULL,34604380869,540693451,8448335,16.62),(1821,'FP','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,'R',1821,36.38,0.46,189,695,70,NULL,NULL,'2MASX J00164632+0112373',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.0001,NULL,'16.33',0.4,NULL,NULL,NULL,NULL,NULL,1,4.192917,1.21031,0.049,NULL,66579898137,1040310908,16254857,16.33),(1822,'FP','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,'R',1822,35.83,0.27,147,696,70,NULL,NULL,'CGCG 382-040',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000097,NULL,'15.0g',0.58,'E0',NULL,NULL,NULL,NULL,1,4.195875,0.70428,0.041,NULL,66580120137,1040314377,16254912,15),(1823,'FP','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,'R',1823,37.39,0.46,300,697,70,NULL,NULL,'SDSS J001647.76+151002.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,4.199,15.16747,0.113,NULL,66772703293,1043323488,16301929,18.5),(1824,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:32','1','SDSS-II SN 13784',NULL,1824,39.93,0.27,969,698,70,NULL,'SN photometric redshift distance, z photo =0.259 +/- 0.041','SDSS-II SN 13784',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,4.2004583,-0.81767,0.093,NULL,34371610503,537056414,8391506,NULL),(1825,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1825,31,0.4,15.9,699,75,NULL,'B','UGC 00156',NULL,'1988NBGC.C....0000T',1988,1,2.5,NULL,'G',0.000003,NULL,'14.5',1.6,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,4.200417,12.34806,0.205,NULL,66731028614,1042672322,16291755,14.5),(1826,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:32','1','SDSS-II SN 02926','RN',1826,41.05,0.25,1240,700,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02926',0.304287,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1827,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:32','1','SDSS-II SN 02926','RN',1827,41.19,0.21,1330,700,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 02926',0.304287,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1828,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:32','1','SDSS-II SN 02926','N',1828,40.94,0.15,1540,700,70,NULL,'SALT 2','SDSS-II SN 02926',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1829,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:32','1','SDSS-II SN 02926','N',1829,40.97,0.15,1560,700,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 02926',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1830,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:32','1','SDSS-II SN 16761','RN',1830,41.34,0.34,1300,701,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16761',0.42174,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1831,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:32','1','SDSS-II SN 16761','RN',1831,41.36,0.35,1320,701,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16761',0.42174,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1832,'FP','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1832,34.78,0.55,90.4,702,70,NULL,NULL,'MCG -02-01-042',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.000078,NULL,'15.4g',0.3,'S0/a',NULL,NULL,NULL,NULL,1,4.2620417,-9.67967,0.112,NULL,34610641102,540791267,8449863,15.4),(1833,'GRB','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,'RN',1833,42.32,NULL,2910,703,70,NULL,'Pseudo z = 1.29','GRB 031109a',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1834,'GRB','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,'R',1834,42.39,NULL,3010,704,70,NULL,'Pseudo z = 1.39','GRB 031109b',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,4.2625,-7.15,0.122,NULL,34604594287,540696785,8448387,NULL),(1835,'FP','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1835,35.56,0.54,129,705,70,NULL,NULL,'2MFGC 00204',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'15.0R',0.12,NULL,NULL,NULL,NULL,NULL,1,4.264875,-43.62422,NULL,NULL,38131543688,595805370,9309458,15),(1836,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:32','1','SDSS-II SN 06251','RN',1836,39.41,0.14,713,706,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06251',0.067155,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1837,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:32','1','SDSS-II SN 06251','RN',1837,40.52,0.24,1190,706,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06251',0.067155,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1838,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1838,34.36,0.36,74.6,707,NULL,NULL,'Malmquist cor.','UGC 00158',NULL,'2009ApJS..182..474S',2009,1,1.6,NULL,'G',0.000033,NULL,'15.21',0.4,'Sb',NULL,NULL,NULL,NULL,1,4.27108333333,42.16136,0.389,NULL,67118428182,1048725440,16386335,15.21),(1839,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1839,34.4,0.2,75.9,707,74.4,NULL,NULL,'UGC 00158',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1840,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1840,34.53,0.33,80.4,707,NULL,NULL,NULL,'UGC 00158',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1841,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,'R',1841,34.86,0.49,93.9,707,75,NULL,'IR','UGC 00158',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1842,'FP','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1842,34.22,0.49,69.7,708,70,NULL,NULL,'NGC 0062',NULL,'2014MNRAS.445.2677S',2014,1,1,'HOLM 005B is a star.','G',0.00013,NULL,'14.08',0.8,'(R)SB(r)a:','Erroneous pair member',NULL,NULL,NULL,1,4.272583,-13.48711,0.057,NULL,34478891930,538732686,8417698,14.08),(1843,'FP','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1843,34.34,0.46,73.6,709,70,NULL,NULL,'MCG -01-01-066',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000113,NULL,'14.96',0.4,'S0+: sp',NULL,NULL,NULL,NULL,1,4.27625,-4.61031,0.126,NULL,34413317442,537708085,8401688,14.96),(1844,'FP','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1844,35.59,0.47,131,710,70,NULL,NULL,'GALEXASC J001707.08-343101.2',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,4.279625,-34.51675,NULL,NULL,34671346989,541739796,8464684,14.6),(1845,'FP','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1845,36.16,0.53,171,711,70,NULL,NULL,'FAIRALL 0005',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'16.14',0.39,NULL,NULL,NULL,NULL,NULL,1,4.281417,-59.66106,0,NULL,36087772332,563871442,8810491,16.14),(1846,'FP','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,'R',1846,38.09,0.46,415,712,70,NULL,NULL,'2MASX J00170934+1401421',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000177,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,4.2889583,14.02839,0.141,NULL,66759213533,1043112711,16298636,17.9),(1847,'FP','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1847,35.37,0.47,119,713,70,NULL,NULL,'MCG -01-01-067',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00011,NULL,'15.19',0.6,NULL,NULL,NULL,NULL,NULL,1,4.2905,-3.71367,0.107,NULL,34425432351,537897380,8404646,15.19),(1848,'FP','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,'R',1848,36.63,0.46,212,714,70,NULL,NULL,'2MASX J00170987-0007179',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000086,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,4.29120833333,-0.12183,0.021,NULL,34368449303,537007020,8390734,16.7),(1849,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1849,32.99,0.8,39.5,715,75,NULL,'MAT, I','ESO 539- G 005',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00002,NULL,'13.51',1.1,'SAB(rs)c?      HII',NULL,NULL,NULL,NULL,1,4.2925,-19.30147,0.056,NULL,35309508436,551711069,8620485,13.51),(1850,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1850,33.04,0.32,40.5,715,85,NULL,'I, raw','ESO 539- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1851,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1851,33.04,0.43,40.6,715,75,NULL,'MAT, I, raw','ESO 539- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1852,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1852,33.07,0.32,41.2,715,85,NULL,'I, inv','ESO 539- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1853,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1853,33.08,0.4,41.4,715,NULL,NULL,'mean','ESO 539- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1854,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1854,33.09,0.45,41.5,715,NULL,NULL,'K','ESO 539- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1855,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1855,33.1,0.46,41.7,715,NULL,NULL,'J','ESO 539- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1856,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1856,33.12,0.47,42,715,NULL,NULL,'H','ESO 539- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1857,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1857,33.2,0.2,43.7,715,74.4,NULL,NULL,'ESO 539- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1858,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1858,33.21,0.43,43.9,715,75,NULL,'MAT, I, inv','ESO 539- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1859,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1859,33.32,0.43,46.1,715,75,NULL,'MAT, I, cor','ESO 539- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1860,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1860,33.32,0.41,46.1,715,NULL,NULL,'Malmquist cor.','ESO 539- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1861,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1861,33.33,0.4,46.3,715,NULL,NULL,NULL,'ESO 539- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1862,'FP','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,'R',1862,37.58,0.46,328,716,70,NULL,NULL,'2MASX J00171375-1045117',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000087,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,4.307375,-10.75325,0.097,NULL,34601253476,540644585,8447571,17.3),(1863,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1863,34.62,0.8,84.1,717,75,NULL,'HMCL, I','CGCG 499-099',NULL,'1997ApJS..109..333W',1997,1,0.5,NULL,'G',0.000033,NULL,'15.32',0.4,'S?','Group member',NULL,NULL,NULL,1,4.3224583,30.20917,0.137,NULL,67219765577,1050308837,16411075,15.32),(1864,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1864,36,0.4,158,717,75,NULL,'HMCL, I, raw','CGCG 499-099',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1865,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1865,36.23,0.4,176,717,75,NULL,'HMCL, I, inv','CGCG 499-099',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1866,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1866,36.25,0.4,178,717,75,NULL,'HMCL, I, cor','CGCG 499-099',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1867,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:32','1','SN 2005ji',NULL,1867,39.49,0.12,648,718,74.2,NULL,'SALT 2','SDSS J001718.30-001524.1',0.22,'2010ApJ...716..712A',2010,1,0.04,NULL,'G',NULL,NULL,'22.3g',0.02,NULL,NULL,NULL,NULL,NULL,1,4.32625,-0.25669,0.053,NULL,34368627798,537009809,8390778,22.3),(1868,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:32','1','SDSS-II SN 07473','R',1868,40.18,0.2,890,718,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ji','SDSS J001718.30-001524.1',0.22,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1869,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:32','1','SN 2005ji',NULL,1869,40.23,0.13,910,718,70,NULL,'SALT 2','SDSS J001718.30-001524.1',0.22,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1870,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:32','1','SN 2005ji',NULL,1870,40.23,0.08,911,718,65,NULL,'SALT2','SDSS J001718.30-001524.1',0.22,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1871,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:32','1','SN 2005ji',NULL,1871,40.45,0.1,1010,718,65,NULL,'MLCS2k2','SDSS J001718.30-001524.1',0.22,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1872,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:32','1','SDSS-II SN 07473','R',1872,40.46,0.11,1010,718,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ji','SDSS J001718.30-001524.1',0.22,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1873,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1873,34.72,0.5,88,719,NULL,NULL,'Malmquist cor.','UGC 00163',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000013,NULL,'15.07',0.6,'SB(s)cd:',NULL,NULL,NULL,NULL,1,4.330833,6.72306,0.109,NULL,66614216699,1040847135,16263236,15.07),(1874,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1874,34.86,0.2,93.8,719,74.4,NULL,NULL,'UGC 00163',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1875,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1875,34.98,0.45,98.9,719,NULL,NULL,NULL,'UGC 00163',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1876,'FP','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,'R',1876,37.69,0.46,345,720,70,NULL,NULL,'2MASX J00172182-1014357',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000089,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,4.341,-10.24331,0.073,NULL,34601469949,540647967,8447624,17.2),(1877,'FP','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1877,36.16,0.63,170,721,70,NULL,NULL,'2MASX J00172304-6251043',NULL,'2014MNRAS.445.2677S',2014,1,0.65,'CSRG +3 arcmin Dec error.','G',0.00015,NULL,'15.72',0.55,'SB(r)a',NULL,NULL,NULL,NULL,1,4.346167,-62.85128,0,NULL,36095760900,563996264,8812441,15.72),(1878,'FP','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,NULL,1878,35.2,0.56,110,722,70,NULL,NULL,'MCG -02-01-045',NULL,'2014MNRAS.445.2677S',2014,1,0.12,NULL,'G',0.00003,NULL,'16.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,4.361083,-9.53275,0.094,NULL,34607877444,540748085,8449188,16.6),(1879,'FP','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,'R',1879,37.92,0.33,383,723,70,NULL,NULL,'SDSS J001726.69+004608.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000079,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,4.36125,0.76903,0.041,NULL,66576576430,1040259006,16254046,18.6),(1880,'FP','2016-12-15 15:13:32','2016-12-16 11:18:32','1',NULL,'R',1880,36.42,0.46,192,724,70,NULL,NULL,'2MASX J00172685-1050366',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000106,NULL,'15.7g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,4.36175,-10.84347,0.114,NULL,34601246752,540644480,8447570,15.7),(1881,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1881,34.65,0.48,85.1,725,NULL,NULL,'Malmquist cor.','NGC 0064',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.00003,NULL,'14.14',1.1,'SB(s)bc        HII',NULL,NULL,NULL,NULL,1,4.3765417,-6.82461,0.117,NULL,34381299099,537207798,8393871,14.14),(1882,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1882,34.97,0.47,98.4,725,NULL,NULL,'H','NGC 0064',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1883,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1883,35.01,0.4,100,725,NULL,NULL,'mean','NGC 0064',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1884,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1884,35.04,0.45,102,725,NULL,NULL,'K','NGC 0064',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1885,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1885,35.06,0.39,103,725,NULL,NULL,NULL,'NGC 0064',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1886,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1886,35.1,0.46,105,725,NULL,NULL,'J','NGC 0064',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1887,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1887,35.17,0.2,108,725,74.4,NULL,NULL,'NGC 0064',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1888,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 12922','RN',1888,39.61,0.09,767,726,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 12922',0.089742,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1889,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 12922','RN',1889,39.71,0.2,804,726,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 12922',0.089742,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1890,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1890,35.89,0.67,151,727,70,NULL,NULL,'2MASX J00173165-6352503',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'17.21',0.2,NULL,NULL,NULL,NULL,NULL,1,4.382125,-63.88058,0,NULL,36048975578,563265243,8801019,17.21),(1891,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',1891,37.92,0.33,383,728,70,NULL,NULL,'2MASX J00173419+0046386',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.13',0.18,NULL,NULL,NULL,NULL,NULL,1,4.392417,0.77736,0.041,NULL,66576573622,1040258962,16254046,18.13),(1892,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',1892,35.83,0.27,147,729,70,NULL,NULL,'2MASX J00173445+0044346',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000118,NULL,'15.8g',0.43,'E0',NULL,NULL,NULL,NULL,1,4.393625,0.74306,0.041,NULL,66576572721,1040258948,16254046,15.8),(1893,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1893,36.82,0.55,231,730,70,NULL,NULL,'2MASX J00173479-0420161',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'17.22',0.24,NULL,NULL,NULL,NULL,NULL,1,4.39504166667,-4.33781,0.124,NULL,34413280221,537707503,8401679,17.22),(1894,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',1894,34.29,0.33,72.3,731,70,NULL,NULL,'IC 0005',NULL,'2015arXiv151105856S',2015,1,0.98,NULL,'G',0.000077,NULL,'14.3g',0.69,'E0',NULL,NULL,NULL,NULL,1,4.3955417,-9.54336,0.094,NULL,34607943128,540749111,8449204,14.3),(1895,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 16459','RN',1895,39.71,0.44,665,732,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16459',0.316534,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1896,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1896,33.95,0.8,61.8,733,75,NULL,'CF, r','UGC 00166',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'14.90',0.9,'Scd:','Group member',NULL,NULL,NULL,1,4.3994583,30.20497,0.157,NULL,67219630047,1050306719,16411042,14.9),(1897,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1897,33.95,0.8,61.8,733,75,NULL,'W91PP, r','UGC 00166',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1898,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1898,33.84,0.2,58.6,733,74.4,NULL,NULL,'UGC 00166',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1899,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1899,33.87,0.33,59.5,733,NULL,NULL,NULL,'UGC 00166',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1900,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1900,33.91,0.38,60.5,733,75,NULL,'W91PP, r, raw','UGC 00166',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1901,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1901,33.95,0.38,61.6,733,75,NULL,'W91PP, r, inv','UGC 00166',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1902,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1902,34.13,0.38,67,733,75,NULL,'W91PP, r, cor','UGC 00166',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1903,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1903,34.2,0.28,69.3,733,NULL,NULL,'Malmquist cor.','UGC 00166',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1904,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1904,34.28,0.38,71.6,733,75,NULL,'CF, r, raw','UGC 00166',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1905,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1905,34.36,0.38,74.4,733,75,NULL,'CF, r, inv','UGC 00166',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1906,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1906,34.46,0.38,78,733,75,NULL,'CF, r, cor','UGC 00166',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1907,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',1907,37.59,0.46,329,734,70,NULL,NULL,'SDSS J001737.60+155800.1',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000149,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,4.406667,15.96669,0.073,NULL,66762064917,1043157264,16299332,17.1),(1908,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1908,34.5,0.8,79.5,735,75,NULL,'HMCL, I','UGC 00165',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000067,NULL,'15.44',0.2,'Sab',NULL,NULL,NULL,NULL,1,4.424083,24.66722,0.029,NULL,67181995605,1049718681,16401854,15.44),(1909,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1909,34.52,0.8,80.1,735,75,NULL,'W91PP, r','UGC 00165',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1910,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1910,34.43,0.4,76.8,735,75,NULL,'HMCL, I, raw','UGC 00165',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1911,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1911,34.49,0.38,78.9,735,75,NULL,'W91PP, r, raw','UGC 00165',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1912,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1912,34.55,0.4,81.3,735,75,NULL,'HMCL, I, inv','UGC 00165',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1913,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1913,34.57,0.38,82.1,735,75,NULL,'W91PP, r, inv','UGC 00165',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1914,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',1914,34.61,0.49,83.5,735,75,NULL,'IR','UGC 00165',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1915,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1915,34.63,0.41,84.2,735,NULL,NULL,NULL,'UGC 00165',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1916,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1916,34.63,0.2,84.3,735,74.4,NULL,NULL,'UGC 00165',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1917,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1917,34.64,0.4,84.8,735,75,NULL,'HMCL, I, cor','UGC 00165',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1918,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1918,34.66,0.41,85.6,735,NULL,NULL,'Malmquist cor.','UGC 00165',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1919,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1919,34.67,0.38,86,735,75,NULL,'W91PP, r, cor','UGC 00165',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1920,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 17753','RN',1920,40.64,0.13,1100,736,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 17753',0.227787,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1921,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 17753','RN',1921,41.01,0.2,1300,736,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 17753',0.227787,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1922,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',1922,37.5,0.46,317,737,70,NULL,NULL,'2MASX J00174502-0946454',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000087,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,4.4374583,-9.77919,0.104,NULL,34607731822,540745809,8449153,17.1),(1923,'SBF','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1923,31.35,0.12,18.6,738,74.4,NULL,NULL,'NGC 0063',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.000003,NULL,'12.63',1.1,'S pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,4.43966666667,11.45033,0.213,NULL,66727722870,1042620669,16290947,12.63),(1924,'SBF','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1924,31.36,0.33,18.7,738,NULL,NULL,'I','NGC 0063',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1925,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1925,31.35,0.12,18.6,738,74.4,NULL,NULL,'NGC 0063',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1926,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1926,31.36,0.56,18.7,738,NULL,NULL,'Malmquist cor.','NGC 0063',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1927,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1927,31.39,0.55,19,738,NULL,NULL,NULL,'NGC 0063',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1928,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',1928,37.33,0.46,292,739,70,NULL,NULL,'2MASX J00175178+1516331',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000177,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,4.465917,15.27589,0.069,NULL,66772566062,1043321344,16301896,17.3),(1929,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',1929,37.78,0.46,360,740,70,NULL,NULL,'2MASX J00175297+1506000',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,4.4705417,15.10022,0.089,NULL,66771587107,1043306048,16301657,18),(1930,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1930,36.82,0.64,231,741,70,NULL,NULL,'2MASX J00175373-0839124',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.000103,NULL,'16.81',0.24,NULL,NULL,NULL,NULL,NULL,1,4.473917,-8.65344,0.054,NULL,34607517469,540742460,8449100,16.81),(1931,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',1931,34.29,0.33,72.3,742,70,NULL,NULL,'MCG -02-01-048',NULL,'2015arXiv151105856S',2015,1,0.86,NULL,'G',0.00007,NULL,'14.7g',0.53,'S0-a',NULL,NULL,NULL,NULL,1,4.497417,-9.27217,0.103,NULL,34607914343,540748661,8449197,14.7),(1932,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1932,34.96,0.49,98.2,742,70,NULL,NULL,'MCG -02-01-048',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1933,'SNII optical','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2004dh',NULL,1933,34.86,0.3,90.2,743,NULL,NULL,'SEAM','CGCG 478-052',0.019327,'2009ApJ...694.1067P',2009,1,0.9,NULL,'G',0.000033,NULL,'14.71',0.7,'S?',NULL,NULL,NULL,NULL,1,4.499333,24.56303,0.029,NULL,67181955894,1049718060,16401844,14.71),(1934,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1934,34.42,0.8,76.7,743,75,NULL,'HMCL, I','CGCG 478-052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1935,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1935,34.46,0.2,78,743,74.4,NULL,NULL,'CGCG 478-052',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1936,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1936,34.53,0.4,80.6,743,75,NULL,'HMCL, I, raw','CGCG 478-052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1937,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1937,34.64,0.45,84.9,743,NULL,NULL,NULL,'CGCG 478-052',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1938,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1938,34.66,0.4,85.6,743,75,NULL,'HMCL, I, inv','CGCG 478-052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1939,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1939,34.68,0.44,86.4,743,NULL,NULL,'Malmquist cor.','CGCG 478-052',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1940,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1940,34.73,0.4,88.5,743,75,NULL,'HMCL, I, cor','CGCG 478-052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1941,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1941,34.74,0.47,88.6,744,70,NULL,NULL,'6dF J0018046-335229',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,4.519583,-33.87461,NULL,NULL,34852754984,544574296,8508973,13.2),(1942,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 16925','RN',1942,42.39,0.34,2520,745,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 16925',0.193613,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1943,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',1943,36.78,0.46,227,746,70,NULL,NULL,'SDSS J001808.29-002235.2',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000087,NULL,'17.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,4.5345417,-0.37644,0.07,NULL,34368471727,537007370,8390740,17),(1944,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 18767',NULL,1944,40.08,0.31,1040,747,70,NULL,NULL,'SDSS-II SN 18767',NULL,'2013MNRAS.434.1443X',2013,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,4.53458333333,0.80869,0.041,NULL,66576661272,1040260332,16254067,NULL),(1945,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 18767','R',1945,40.89,0.29,1130,747,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18767',0.330161,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1946,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 18767','R',1946,41.07,0.28,1230,747,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18767',0.330161,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1947,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',1947,34.87,0.49,94.3,748,75,NULL,'IR','UGC 00168',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'16.0',0.3,'Sa',NULL,NULL,NULL,NULL,1,4.544083,18.29217,0.105,NULL,66718278588,1042473102,16288642,16),(1948,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',1948,37.64,0.46,338,749,70,NULL,NULL,'2MASX J00181740-1104068',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000092,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,4.5724583,-11.06869,0.106,NULL,34602245864,540660091,8447813,17.1),(1949,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',1949,36.28,0.46,180,750,70,NULL,NULL,'2MASX J00181835-1113178',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000087,NULL,'16.1g',0.4,'S0',NULL,NULL,NULL,NULL,1,4.576625,-11.22172,0.099,NULL,34599392193,540615503,8447117,16.1),(1950,'Faber-Jackson','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1950,34.15,0.44,67.6,751,95,NULL,'Weighted Mean','NGC 0068',NULL,'1984ApJS...56...91D',1984,1,1.2,NULL,'G',0.000073,NULL,'14.5',1.1,'SA0-','Group member',NULL,NULL,NULL,1,4.57704166667,30.07175,0.157,NULL,67221662157,1050338471,16411538,14.5),(1951,'Faber-Jackson','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1951,34.6,0.46,83.2,751,95,NULL,'Michard 1979a','NGC 0068',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1952,'Faber-Jackson','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1952,34.9,0.63,95.5,751,95,NULL,'Michard 1979b, c','NGC 0068',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1953,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1953,34.7,0.16,87.1,751,70,NULL,'0016+2947B Group','NGC 0068',NULL,'1992ApJ...396..453H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1954,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 14532','RN',1954,39.85,0.24,768,752,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 14532',0.215785,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1955,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 14532','RN',1955,39.9,0.2,787,752,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 14532',0.215785,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1956,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 20231',NULL,1956,40.62,0.18,1330,753,70,NULL,'SN photometric redshift distance, z photo =0.378 +/- 0.043','SDSS-II SN 20231',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,4.588875,-0.03239,0.041,NULL,34368540331,537008442,8390756,NULL),(1957,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 20231','R',1957,41.57,0.21,1500,753,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20231',0.376684,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1958,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 20231','R',1958,41.62,0.29,1530,753,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20231',0.376684,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1959,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 20231',NULL,1959,41.57,0.16,2060,753,70,NULL,'SALT 2','SDSS-II SN 20231',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1960,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 20231',NULL,1960,41.62,0.16,2110,753,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20231',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1961,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 15860',NULL,1961,39.8,0.44,911,754,70,NULL,'SN photometric redshift distance, z photo =0.241 +/- 0.065','SDSS-II SN 15860',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,4.597333,0.18303,0.037,NULL,66576798151,1040262471,16254101,NULL),(1962,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 15860',NULL,1962,41.5,0.14,2000,754,70,NULL,'SALT 2','SDSS-II SN 15860',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1963,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 15860',NULL,1963,41.59,0.14,2080,754,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15860',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1964,'Faber-Jackson','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1964,34.37,0.44,74.8,755,95,NULL,'Weighted Mean','NGC 0071',NULL,'1984ApJS...56...91D',1984,1,1.5,NULL,'G',0.000077,NULL,'14.8',1.2,'SA0- pec:','Group member, 3rd ranked galaxy',NULL,NULL,'Sy 2',1,4.59825,30.06325,0.157,NULL,67221706335,1050339161,16411549,14.8),(1965,'Faber-Jackson','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1965,34.83,0.46,92.5,755,95,NULL,'Michard 1979a','NGC 0071',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1966,'Faber-Jackson','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1966,35.16,0.63,108,755,95,NULL,'Michard 1979b, c','NGC 0071',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1967,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1967,35.71,0.76,139,756,70,NULL,NULL,'2MASX J00182364-0518220',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.00015,NULL,'15.98',0.42,NULL,NULL,NULL,NULL,NULL,1,4.598583,-5.30619,0.12,NULL,34413494492,537710851,8401732,15.98),(1968,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1968,33.91,0.2,60.5,757,74.4,NULL,NULL,'CGCG 456-055',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000017,NULL,'15.3',0.5,NULL,NULL,NULL,NULL,NULL,1,4.60475,18.51453,0.105,NULL,67452024292,1053937879,16467779,15.3),(1969,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1969,34.28,0.47,71.8,757,NULL,NULL,NULL,'CGCG 456-055',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1970,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1970,34.51,0.42,79.7,757,NULL,NULL,'Malmquist cor.','CGCG 456-055',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1971,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 13952',NULL,1971,39.61,0.45,837,758,70,NULL,'SN photometric redshift distance, z photo =0.219 +/- 0.059','SDSS-II SN 13952',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,4.634417,0.7885,0.037,NULL,66576626109,1040259782,16254059,NULL),(1972,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 13952','R',1972,41.48,0.29,1490,758,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13952',0.32941,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1973,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 13952',NULL,1973,41.02,0.37,1600,758,70,NULL,NULL,'SDSS-II SN 13952',NULL,'2013MNRAS.434.1443X',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1974,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 13952','R',1974,41.87,0.38,1780,758,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13952',0.32941,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1975,'SZ effect','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1975,40.43,0.36,1220,759,NULL,NULL,'Isotherm., r < 100 kpc','CL 0016+1609',NULL,'2006ApJ...647...25B',2006,1,NULL,'Sometimes incorrectly referred to as 0016.5+1654.','GClstr',0.003,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,4.641,16.43794,0.093,NULL,66764537461,1043195897,16299935,NULL),(1976,'SZ effect','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1976,40.57,0.32,1300,759,NULL,NULL,'Isotherm.','CL 0016+1609',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1977,'SZ effect','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1977,40.7,0.32,1380,759,NULL,NULL,'Hydrost. Eq.','CL 0016+1609',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1978,'SZ effect','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1978,41.06,NULL,1630,759,NULL,NULL,'3.1 (red) calibration','CL 0016+1609',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1979,'SZ effect','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1979,41.07,NULL,1640,759,NULL,NULL,NULL,'CL 0016+1609',NULL,'2005ApJ...625..108D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1980,'SZ effect','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1980,41.2,NULL,1740,759,NULL,NULL,'4.2 (black) calibration','CL 0016+1609',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1981,'SZ effect','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1981,41.35,NULL,1860,759,NULL,NULL,'4.1 (blue) calibration','CL 0016+1609',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1982,'SZ effect','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1982,41.55,NULL,2040,759,NULL,NULL,NULL,'CL 0016+1609',NULL,'2002ApJ...581...53R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1983,'SZ effect','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1983,41.55,0.49,2040,759,NULL,NULL,NULL,'CL 0016+1609',NULL,'2000ApJ...533...38R',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1984,'SZ effect','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1984,42.06,NULL,2590,759,NULL,NULL,NULL,'CL 0016+1609',NULL,'1998ApJ...501....1H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1985,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1985,34.76,0.48,89.6,760,70,NULL,NULL,'NGC 0073',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000033,NULL,'14.17',1.1,'SAB(rs)bc:',NULL,NULL,NULL,NULL,1,4.6625417,-15.32225,0.035,NULL,34491356696,538927448,8420741,14.17),(1986,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1986,34.45,0.69,77.7,760,100,NULL,'mid-IR','NGC 0073',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1987,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1987,35.15,0.4,107,760,NULL,NULL,'mean','NGC 0073',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1988,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1988,35.17,0.47,108,760,NULL,NULL,'H','NGC 0073',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1989,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1989,35.19,0.45,109,760,NULL,NULL,'K','NGC 0073',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1990,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1990,35.24,0.46,112,760,NULL,NULL,'J','NGC 0073',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1991,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1991,35.62,0.54,133,761,70,NULL,NULL,'2MASX J00183901-5425163',NULL,'2014MNRAS.445.2677S',2014,1,1.15,NULL,'G',0.00015,NULL,'15.27',0.38,NULL,NULL,NULL,NULL,NULL,1,4.66258333333,-54.42119,NULL,NULL,36002320855,562536263,8789629,15.27),(1992,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 13633','R',1992,41.89,0.27,1720,762,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J001839.68+000019.6',0.387896,'2014arXiv1401.3317S',2014,1,0.12,NULL,'G',0.000144,NULL,'18.40',0.06,NULL,NULL,NULL,NULL,NULL,1,4.665375,0.00544,0.037,NULL,66576816362,1040262755,16254105,18.4),(1993,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 13633','R',1993,42.02,0.2,1820,762,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J001839.68+000019.6',0.387896,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1994,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 13633',NULL,1994,41.81,0.16,2300,762,70,NULL,'SALT 2','SDSS J001839.68+000019.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1995,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 13633',NULL,1995,41.87,0.16,2370,762,70,NULL,'SALT 2, Malmquist cor.','SDSS J001839.68+000019.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(1996,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',1996,35.61,0.46,133,763,70,NULL,NULL,'2MASX J00184264+1511424',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000175,NULL,'15.9g',0.33,'S0^-',NULL,NULL,NULL,NULL,1,4.677833,15.19517,0.093,NULL,66771732374,1043308318,16301692,15.9),(1997,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',1997,37.47,0.46,312,764,70,NULL,NULL,'2MASX J00184413-0107070',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00007,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,4.684,-1.11861,0.081,NULL,34414750596,537730478,8402038,17.5),(1998,'Tully est','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1998,32.04,0.8,25.6,765,75,NULL,NULL,'UGCA 005',NULL,'1988NBGC.C....0000T',1988,1,1.5,'RC3 gives v = 2060 +/- 17 km/sec.','G',0.000022,NULL,'14.83',1.3,'SAB(s)m','Possible group member',NULL,NULL,NULL,1,4.701333,-19.00772,0.05,NULL,35311448682,551741385,8620959,14.83),(1999,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,1999,36.24,0.59,177,766,70,NULL,NULL,'2MASX J00184850-1514500',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'15.89',0.57,NULL,NULL,NULL,NULL,NULL,1,4.702083,-15.24714,0.035,NULL,34491572925,538930826,8420794,15.89),(2000,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 19552','RN',2000,42.1,0.32,1830,767,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19552',0.438975,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2001,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 19552','RN',2001,42.13,0.33,1860,767,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19552',0.438975,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2002,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 19552','N',2002,42.13,0.22,2670,767,70,NULL,'SALT 2','SDSS-II SN 19552',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2003,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 19552','N',2003,42.22,0.22,2780,767,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19552',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2004,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2004,34.8,0.48,91.1,768,70,NULL,NULL,'MCG -02-01-050',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000103,NULL,'14.61',1,'(R\')SB(r)0/a?',NULL,NULL,NULL,NULL,1,4.711125,-8.45875,0.115,NULL,34605862642,540716603,8448696,14.61),(2005,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2005,36.38,0.55,189,769,70,NULL,NULL,'2MASX J00185248-3740239',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'16.34',0.28,'E',NULL,NULL,NULL,NULL,1,4.71866666667,-37.67339,NULL,NULL,34694002933,542093795,8470215,16.34),(2006,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 03500','RN',2006,42.85,0.24,2750,770,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03500',0.352449,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2007,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 03500','RN',2007,42.92,0.18,2840,770,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03500',0.352449,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2008,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2008,34.86,0.47,93.7,771,70,NULL,NULL,'IC 0006',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000103,NULL,'14.57',0.5,NULL,NULL,NULL,NULL,NULL,1,4.729333,-3.27608,0.136,NULL,34425795041,537903047,8404735,14.57),(2009,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2009,37.61,0.46,333,772,70,NULL,NULL,'2MASX J00185846-0958034',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000086,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,4.7435417,-9.96747,0.121,NULL,34602107547,540657930,8447780,17.4),(2010,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2010,33.69,0.8,54.8,773,75,NULL,'CF, r','UGC 00179',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.00006,NULL,'14.98',0.7,'Scd:',NULL,NULL,NULL,NULL,1,4.752375,23.47653,0.117,NULL,67183813003,1049747078,16402298,14.98),(2011,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2011,33.71,0.8,55.2,773,75,NULL,'W91PP, r','UGC 00179',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2012,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2012,33.84,0.2,58.6,773,74.4,NULL,NULL,'UGC 00179',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2013,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2013,34.03,0.4,63.9,773,NULL,NULL,NULL,'UGC 00179',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2014,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2014,34.2,0.38,69.3,773,75,NULL,'W91PP, r, inv','UGC 00179',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2015,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2015,34.21,0.38,69.5,773,75,NULL,'W91PP, r, raw','UGC 00179',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2016,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2016,34.31,0.38,72.7,773,75,NULL,'CF, r, raw','UGC 00179',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2017,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2017,34.31,0.35,72.9,773,NULL,NULL,'Malmquist cor.','UGC 00179',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2018,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2018,34.34,0.38,73.9,773,75,NULL,'CF, r, inv','UGC 00179',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2019,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2019,34.39,0.38,75.6,773,75,NULL,'W91PP, r, cor','UGC 00179',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2020,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2020,34.49,0.38,79.1,773,75,NULL,'CF, r, cor','UGC 00179',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2021,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2005jn',NULL,2021,40.32,0.04,879,774,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 07475, SN 2005jn','SDSS J001901.00-001641.5',0.32,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,4.754167,-0.27819,0.069,NULL,34369095769,537017121,8390892,NULL),(2022,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2005jn',NULL,2022,40.39,0.14,907,774,74.2,NULL,'SALT 2','SDSS J001901.00-001641.5',0.32,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2023,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2005jn',NULL,2023,41.09,0.15,1250,774,70,NULL,'SALT 2','SDSS J001901.00-001641.5',0.32,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2024,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2005jn',NULL,2024,41.1,0.12,1250,774,65,NULL,'SALT2','SDSS J001901.00-001641.5',0.32,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2025,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2005jn',NULL,2025,41.17,NULL,1300,774,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 07475, SN 2005jn','SDSS J001901.00-001641.5',0.32,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2026,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 07475','R',2026,41.18,0.22,1300,774,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005jn','SDSS J001901.00-001641.5',0.32,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2027,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2005jn',NULL,2027,41.3,0.09,1380,774,65,NULL,'MLCS2k2','SDSS J001901.00-001641.5',0.32,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2028,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 07475','R',2028,41.47,0.14,1490,774,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005jn','SDSS J001901.00-001641.5',0.32,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2029,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2029,37.7,0.46,347,775,70,NULL,NULL,'2MASX J00190248-1059509',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000104,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,4.760167,-10.99742,0.106,NULL,34602320682,540661260,8447832,16.9),(2030,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 09585','RN',2030,39.65,0.11,792,776,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 09585',0.072518,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2031,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 09585','RN',2031,39.79,0.23,846,776,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 09585',0.072518,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2032,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2032,34.68,0.51,86.4,777,NULL,NULL,NULL,'NGC 0066',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.21',0.48,'SB(r)b pec     HII',NULL,NULL,NULL,NULL,1,4.77058333333,-22.93639,0,NULL,35305868165,551654190,8619596,14.21),(2033,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2033,34.72,0.2,87.9,777,74.4,NULL,NULL,'NGC 0066',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2034,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2034,34.73,0.47,88.4,777,NULL,NULL,'H','NGC 0066',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2035,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2035,34.88,0.45,94.6,777,NULL,NULL,'K','NGC 0066',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2036,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2036,34.9,0.46,95.4,777,NULL,NULL,'J','NGC 0066',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2037,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2037,34.93,0.46,96.7,777,NULL,NULL,'Malmquist cor.','NGC 0066',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2038,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2038,34.98,0.4,99,777,NULL,NULL,'mean','NGC 0066',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2039,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2039,38.12,0.46,421,778,70,NULL,NULL,'2MASX J00190542+1608216',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,4.772583,16.13925,0.093,NULL,66764761225,1043199394,16299990,17.3),(2040,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2040,36.79,0.56,228,779,70,NULL,NULL,'2MASX J00190813-2211201',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.82',0.43,'E',NULL,NULL,NULL,NULL,1,4.78379166667,-22.18897,0.055,NULL,35306270502,551660476,8619694,16.82),(2041,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2041,35.62,0.49,133,780,75,NULL,'IR','UGC 00180',NULL,'2011yCatp016004901K',2011,1,1.31,NULL,'G',0.0001,NULL,'14.9g',0.35,'Sab',NULL,NULL,NULL,NULL,1,4.78433333333,15.74933,0.105,NULL,66764127828,1043189497,16299835,14.9),(2042,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2042,38.24,0.46,445,781,70,NULL,NULL,'2MASX J00190877+0109284',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,4.78654166667,1.15797,0.053,NULL,66631441631,1041116275,16267441,17.9),(2043,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2043,35.29,0.35,114,782,NULL,NULL,NULL,'ESO 473- G 011',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.43',0.5,'Sc',NULL,NULL,NULL,NULL,1,4.78904166667,-24.52308,0.087,NULL,34774196345,543346817,8489794,14.43),(2044,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2044,35.33,0.2,116,782,74.4,NULL,NULL,'ESO 473- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2045,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2045,35.39,0.33,120,782,NULL,NULL,'Malmquist cor.','ESO 473- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2046,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2046,38.04,0.46,406,783,70,NULL,NULL,'SDSS J001914.06-100043.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000088,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,4.808583,-10.01203,0.121,NULL,34602117740,540658089,8447782,18.7),(2047,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2006kr',NULL,2047,39.75,0.09,893,784,70,NULL,'Hubble residual 0.07 for z0.22680; SDSS-II SN 15229','SDSS-II SN 15229 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,4.8320417,1.09064,0.053,NULL,66631448006,1041116375,16267443,NULL),(2048,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2006kr','R',2048,40.34,0.2,957,784,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006kr; SDSS-II SN 15229','SDSS-II SN 15229 HOST',0.224,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2049,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2006kr','R',2049,40.5,0.11,1030,784,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006kr; SDSS-II SN 15229','SDSS-II SN 15229 HOST',0.224,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2050,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2050,37.54,0.46,323,785,70,NULL,NULL,'2MASX J00192072+0016534',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000079,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,4.83641666667,0.28161,0.037,NULL,66577068165,1040266690,16254167,17.6),(2051,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2051,38.05,0.46,407,786,70,NULL,NULL,'2MASX J00192163-0024566',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000079,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,4.840083,-0.41583,0.073,NULL,34369112908,537017389,8390896,17.6),(2052,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 05709','RN',2052,39.63,0.19,789,787,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05709',0.069288,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2053,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 05709','RN',2053,41.11,0.25,1560,787,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 05709',0.069288,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2054,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 02928','R',2054,40.11,0.13,914,788,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 02928',0.150203,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,4.8525,-0.58911,0.073,NULL,34369039280,537016238,8390878,NULL),(2055,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 02928','R',2055,40.2,0.23,955,788,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 02928',0.150203,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2056,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2056,37.52,0.46,318,789,70,NULL,NULL,'2MASX J00192578+0057524',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000087,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,4.8575,0.96447,0.053,NULL,66631329974,1041114530,16267414,17.5),(2057,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2057,35.53,0.53,128,790,70,NULL,NULL,'2MASX J00192835-5221370',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'14.89',0.7,'S0',NULL,NULL,NULL,NULL,1,4.8682917,-52.36022,NULL,NULL,36030352040,562974250,8796472,14.89),(2058,'RR Lyrae','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2058,24.52,0.23,0.802,791,NULL,18.52,NULL,'Andromeda XIX',NULL,'2013ApJ...779....7C',2013,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,4.88375,35.04364,0.193,1,67133380470,1048959069,16389985,NULL),(2059,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2059,24.57,0.43,0.821,791,NULL,NULL,NULL,'Andromeda XIX',NULL,'2012ApJ...758...11C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2060,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2060,24.85,0.13,0.933,791,NULL,NULL,'I','Andromeda XIX',NULL,'2008ApJ...688.1009M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2061,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2061,35.84,0.46,147,792,70,NULL,NULL,'2MASX J00193455+1612148',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000177,NULL,'15.9g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,4.894,16.20417,0.093,NULL,66764905859,1043201654,16300025,15.9),(2062,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2062,36.53,0.46,202,793,70,NULL,NULL,'2MASX J00193492+0012023',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000097,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,4.8955,0.20053,0.037,NULL,66577097100,1040267142,16254174,16.4),(2063,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2063,37.48,0.27,313,794,70,NULL,NULL,'2MASX J00193506-0943225',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000082,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,4.8962083,-9.72289,0.122,NULL,34600331547,540630180,8447346,17.7),(2064,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2064,34.19,0.8,68.8,795,75,NULL,'CF, r','UGC 00183',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000063,NULL,'13.7',0.7,'Sab','in a pair',NULL,NULL,NULL,1,4.896333,47.24103,0.405,NULL,67655211447,1057112678,16517385,13.7),(2065,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2065,34.34,0.4,73.7,795,NULL,NULL,'mean','UGC 00183',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2066,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2066,34.66,0.38,85.3,795,75,NULL,'CF, r, raw','UGC 00183',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2067,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2067,34.68,0.47,86.3,795,NULL,NULL,'H','UGC 00183',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2068,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2068,34.72,0.46,87.8,795,NULL,NULL,'J','UGC 00183',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2069,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2069,34.73,0.38,88.3,795,75,NULL,'CF, r, cor','UGC 00183',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2070,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2070,34.74,0.45,88.5,795,NULL,NULL,'K','UGC 00183',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2071,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2071,34.88,0.38,94.5,795,75,NULL,'CF, r, inv','UGC 00183',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2072,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2072,33.48,NULL,49.6,796,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0031',NULL,'2010Ap&SS.325..163P',2010,1,1.12,NULL,'G',0.000007,NULL,'16.0',0.09,'Sdm',NULL,NULL,NULL,NULL,1,4.899167,18.66194,0.105,NULL,67452245959,1053941343,16467833,16),(2073,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2073,33.5,NULL,50.2,796,NULL,NULL,'Dipole + Quadrupole','FGC 0031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2074,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2074,33.52,NULL,50.5,796,NULL,NULL,'Dipole','FGC 0031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2075,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2075,33.57,NULL,51.9,796,NULL,NULL,NULL,'FGC 0031',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2076,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2076,35.72,0.52,139,797,70,NULL,NULL,'6dF J0019365-614127',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,4.901917,-61.69092,0,NULL,36095033179,563984893,8812263,14.5),(2077,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2077,35.03,0.17,101,798,70,NULL,'UGCl 004 Cluster','NGC 0076',NULL,'1992ApJ...396..453H',1990,1,1,NULL,'G',0.000067,NULL,'13.99',0.9,'S?','in a radial-velocity based grouping',NULL,NULL,'Flat-Spectrum Radio Source',1,4.9074583,29.93386,0.177,NULL,67221837090,1050341204,16411581,13.99),(2078,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2078,38.18,0.46,433,799,70,NULL,NULL,'2MASX J00193880-0901185',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000096,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,4.91154166667,-9.02197,0.109,NULL,34608075478,540751179,8449237,17.7),(2079,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2079,37.48,0.27,313,800,70,NULL,NULL,'MCG -02-01-055',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.00013,NULL,'15.9g',0.38,'poss. LINER?',NULL,NULL,NULL,NULL,1,4.9122083,-9.67392,0.122,NULL,34600334275,540630223,8447347,15.9),(2080,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2080,36.27,0.46,179,801,70,NULL,NULL,'2MASX J00194037+1554108',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000188,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,4.9182083,15.90306,0.093,NULL,66763967230,1043186987,16299796,16.5),(2081,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2081,37.14,0.53,268,802,70,NULL,NULL,'LCRS B001713.6-420519',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.000133,NULL,'16.13',0.4,'E',NULL,NULL,NULL,NULL,1,4.927583,-41.811,NULL,NULL,34635472353,541179255,8455925,16.13),(2082,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2082,37.87,0.33,375,803,70,NULL,NULL,'2MASX J00194279+0006093',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.91',0.19,NULL,NULL,NULL,NULL,NULL,1,4.92820833333,0.10264,0.037,NULL,66576327845,1040255122,16253986,17.91),(2083,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 18030','R',2083,39.53,0.19,697,804,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007kq','SN 2007kq',0.156528,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,4.9329583,-0.40014,0.073,NULL,34368292569,537004571,8390696,NULL),(2084,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 18030','R',2084,39.68,0.12,747,804,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007kq','SN 2007kq',0.156528,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2085,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2085,37.9,0.46,380,805,70,NULL,NULL,'2MASX J00194427+1610548',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,4.934583,16.18178,0.117,NULL,66764904346,1043201630,16300025,17.5),(2086,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2086,34.93,0.49,96.8,806,75,NULL,'IR','UGC 00187',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.00013,NULL,'16.5',0.3,'S?',NULL,NULL,NULL,NULL,1,4.9472917,9.16692,0.201,NULL,66803602570,1043806290,16309473,16.5),(2087,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2087,34.89,0.49,95.2,807,70,NULL,NULL,'2MASX J00194744-5115098',NULL,'2014MNRAS.445.2677S',2014,1,0.88,NULL,'G',0.00015,NULL,'15.17',0.35,'S0            LLAGN?','Pair member (points to parent)',NULL,NULL,NULL,1,4.9477083,-51.25267,NULL,NULL,36033531118,563023923,8797248,15.17),(2088,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2088,37.87,0.33,375,808,70,NULL,NULL,'SDSS J001948.27+000153.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,4.951167,0.03161,0.037,NULL,66576322501,1040255039,16253984,18.6),(2089,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2089,34.44,0.8,77.3,809,75,NULL,'W91PP, r','IC 1540',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000067,NULL,'14.91',0.4,'SBb',NULL,NULL,NULL,NULL,1,4.953125,23.77261,0.097,NULL,67180824413,1049700381,16401568,14.91),(2090,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2090,34.49,0.38,78.9,809,75,NULL,'W91PP, r, raw','IC 1540',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2091,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2091,34.51,0.4,79.7,809,NULL,NULL,'mean','IC 1540',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2092,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2092,34.64,0.38,84.9,809,75,NULL,'W91PP, r, inv','IC 1540',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2093,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2093,34.66,0.38,85.7,809,75,NULL,'W91PP, r, cor','IC 1540',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2094,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2094,34.69,0.47,86.7,809,NULL,NULL,'H','IC 1540',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2095,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2095,34.77,0.46,89.8,809,NULL,NULL,'J','IC 1540',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2096,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2096,34.77,0.45,90,809,NULL,NULL,'K','IC 1540',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2097,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2097,37.48,0.27,313,810,70,NULL,NULL,'2MASX J00195265-0941135',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000071,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,4.96925,-9.68714,0.122,NULL,34600334371,540630224,8447347,18),(2098,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2098,34.92,0.2,96.4,811,74.4,NULL,NULL,'UGC 00189',NULL,'2013AJ....146...86T',2013,1,0.59,NULL,'G',0.00017,NULL,'16.1g',0.45,'Sd:',NULL,NULL,NULL,NULL,1,4.98975,15.09225,0.113,NULL,66771676887,1043307451,16301678,16.1),(2099,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2099,34.93,0.49,96.6,812,75,NULL,'IR','CGCG 456-060',NULL,'2011yCatp016004901K',2011,1,0.75,NULL,'G',0.000033,NULL,'15.6',0.15,NULL,NULL,NULL,NULL,NULL,1,4.993125,19.40236,0.117,NULL,67451951727,1053936745,16467761,15.6),(2100,'Tully est','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2100,31.66,0.8,21.4,813,75,NULL,NULL,'ESO 028- G 014',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.000013,NULL,'15.83',0.8,'SB(s)d',NULL,NULL,NULL,NULL,1,4.993583,-77.09081,0.217,NULL,35587146405,556049162,8688268,15.83),(2101,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2101,37.95,0.46,389,814,70,NULL,NULL,'2MASX J00195942-0957355',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000093,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,4.99775,-9.95969,0.153,NULL,34602091730,540657683,8447776,17.6),(2102,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 12782','R',2102,37.96,0.04,366,815,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2006fq','SN 2006fq',0.068004,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'IIP',NULL,NULL,NULL,NULL,1,5.003375,-0.62497,0.071,NULL,34414331922,537723936,8401936,NULL),(2103,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 12782','R',2103,38.57,0.19,484,815,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2006fq','SN 2006fq',0.068004,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2104,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 1999cw',NULL,2104,32.25,0.31,27.9,816,74.2,NULL,'SALT 2','MCG -01-02-001',0.0113,'2010ApJ...716..712A',2010,1,1.5,NULL,'G',0.000013,NULL,'14.42',0.7,'SB(s)ab pec?',NULL,NULL,NULL,NULL,1,5.0002083,-6.33392,0.11,NULL,34603074368,540673037,8448016,14.42),(2105,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 1999cw',NULL,2105,33.12,0.34,41.6,816,70,NULL,'SALT','MCG -01-02-001',0.0113,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2106,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 1999cw',NULL,2106,33.24,0.08,44.5,816,74.4,NULL,NULL,'MCG -01-02-001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2107,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 1999cw',NULL,2107,33.36,0.14,46,816,65,NULL,'MLCS2k2','MCG -01-02-001',0.0113,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2108,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 1999cw',NULL,2108,33.35,0.12,46.2,816,72,NULL,NULL,'MCG -01-02-001',0.0113,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2109,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2109,33.24,0.08,44.5,816,74.4,NULL,NULL,'MCG -01-02-001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2110,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2110,33.86,0.4,59.2,816,75,NULL,'HOSTS SN 1999cw','MCG -01-02-001',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2111,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2111,36.65,0.63,214,817,70,NULL,NULL,'MCG -01-02-002',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.44',0.8,NULL,NULL,NULL,NULL,NULL,1,5.01183333333,-4.05172,0.123,NULL,34411960019,537686875,8401357,15.44),(2112,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2112,37.35,0.27,295,818,70,NULL,NULL,'2MASX J00200475-0012052',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000099,NULL,'16.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,5.019875,-0.20161,0.071,NULL,34368214479,537003351,8390677,16.5),(2113,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2113,31,0.4,15.9,819,75,NULL,'B','UGC 00191',NULL,'1988NBGC.C....0000T',1988,1,1.6,'Two MCG numbers for this galaxy.','G',0.000003,NULL,'13.87',1.2,'Sm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,5.021667,10.88,0.209,NULL,66798873443,1043732397,16308318,13.87),(2114,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2114,35.43,0.47,122,820,NULL,NULL,'Malmquist cor.','ESO 150- G 001',NULL,'2009ApJS..182..474S',2009,1,0.97,NULL,'G',0.000033,NULL,'14.19',0.59,'SA(s)c',NULL,NULL,NULL,NULL,1,5.026,-54.52317,NULL,NULL,36002225642,562534775,8789605,14.19),(2115,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2115,35.6,0.43,132,820,NULL,NULL,NULL,'ESO 150- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2116,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2116,35.64,0.2,134,820,74.4,NULL,NULL,'ESO 150- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2117,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 09817','R',2117,39.94,0.18,794,821,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 09817',0.224795,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,5.038,0.59822,0.053,NULL,66630851506,1041107054,16267297,NULL),(2118,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 09817','R',2118,40.13,0.26,866,821,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 09817',0.224795,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2119,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2119,35.63,0.5,133,822,70,NULL,NULL,'2MASX J00201118-0324022',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000147,NULL,'15.33',0.9,NULL,NULL,NULL,NULL,NULL,1,5.0465417,-3.40056,0.131,NULL,34424887854,537888872,8404513,15.33),(2120,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2120,36.49,0.51,198,823,70,NULL,NULL,'2MASX J00201281-4940326',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.00015,NULL,'16.13',0.35,'S',NULL,NULL,NULL,NULL,1,5.0532917,-49.67567,NULL,NULL,35980857531,562200898,8784389,16.13),(2121,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 01374','RN',2121,40.33,0.15,965,824,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01374',0.206134,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2122,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 01374','RN',2122,41.19,0.23,1430,824,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01374',0.206134,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2123,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2123,34.66,0.4,85.7,825,NULL,NULL,'mean','IC 0012',NULL,'2007A&A...465...71T',2007,1,0.7,NULL,'G',0.000037,NULL,'14.97',0.25,'Sab            HII',NULL,NULL,NULL,NULL,1,5.0627083,-2.65311,0.143,NULL,34417219306,537769051,8402641,14.97),(2124,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2124,34.87,0.47,94.1,825,NULL,NULL,'H','IC 0012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2125,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 17846','RN',2125,41.27,0.14,1480,826,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 17846',0.212629,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2126,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 17846','RN',2126,41.93,0.2,2010,826,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 17846',0.212629,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2127,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2127,38.52,0.46,505,827,70,NULL,NULL,'2MASX J00201706-0901293',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000113,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,5.071125,-9.02489,0.117,NULL,34607371049,540740172,8449065,17.1),(2128,'Brightest Stars','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2128,23.86,0.12,0.592,828,NULL,NULL,'4, red supergiants','IC 0010',NULL,'2000A&A...363..130B',2000,1,6.8,'The 2MASX position refers to the center of the IR isophotes.','G',0.000003,NULL,'11.8B',5.9,'dIrr IV/BCD','Group member',NULL,NULL,NULL,1,5.07225,59.30378,NULL,0,65932718802,1030198731,16096855,11.8),(2129,'Brightest Stars','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2129,24,0.13,0.631,828,NULL,NULL,NULL,'IC 0010',NULL,'1999IAUS..193..762G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2130,'Brightest Stars','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2130,24.3,0.3,0.724,828,NULL,NULL,NULL,'IC 0010',NULL,'2005ARBl...20...85O',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2131,'Brightest Stars','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2131,24.56,NULL,0.817,828,NULL,NULL,'Blue','IC 0010',NULL,'1997AstL...23..644G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2132,'Brightest Stars','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2132,24.9,NULL,0.95,828,NULL,18.4,'blue, LMC ZP','IC 0010',NULL,'1995AJ....109.2470M',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2133,'Brightest Stars','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2133,25.08,NULL,1.04,828,NULL,NULL,'3B + 3R mean','IC 0010',NULL,'1993A&AS..100..227K',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2134,'Brightest Stars','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2134,25.23,NULL,1.11,828,NULL,NULL,'Red + Blue','IC 0010',NULL,'1997AstL...23..644G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2135,'Brightest Stars','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2135,25.46,NULL,1.24,828,NULL,NULL,'Red','IC 0010',NULL,'1997AstL...23..644G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2136,'Carbon Stars','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2136,24.35,0.11,0.741,828,NULL,NULL,NULL,'IC 0010',NULL,'2004A&A...424..125D',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2137,'Cepheids','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2137,24.1,0.19,0.661,828,NULL,NULL,'HST KP Calibrated','IC 0010',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2138,'Cepheids','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2138,24.1,0.19,0.661,828,NULL,NULL,'VIJHK','IC 0010',NULL,'1999ApJ...511..671S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2139,'Cepheids','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2139,24.34,0.06,0.74,828,74.4,NULL,NULL,'IC 0010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2140,'Cepheids','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2140,24.4,NULL,0.76,828,NULL,NULL,NULL,'IC 0010',NULL,'2005ASSL..329P..87Z',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2141,'Cepheids','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2141,24.57,0.21,0.82,828,NULL,NULL,'JHK','IC 0010',NULL,'1996AJ....111.1106W',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2142,'Cepheids','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2142,24.59,0.3,0.83,828,NULL,NULL,'4','IC 0010',NULL,'1996AJ....111..197S',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2143,'Cepheids','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2143,24.6,NULL,0.832,828,NULL,NULL,NULL,'IC 0010',NULL,'2001PhDT........82Z',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2144,'CMD','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2144,24.44,NULL,0.773,828,NULL,NULL,NULL,'IC 0010',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2145,'PNLF','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2145,24.1,0.25,0.661,828,NULL,NULL,'35','IC 0010',NULL,'2012MNRAS.425.2557G',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2146,'PNLF','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2146,24.3,0.18,0.725,828,NULL,NULL,'2','IC 0010',NULL,'2008MNRAS.384.1045K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2147,'PNLF','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2147,26.3,0.56,1.8,828,NULL,NULL,NULL,'IC 0010',NULL,'1981AJ.....86..185J',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2148,'PNLF','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2148,26.28,NULL,1.8,828,NULL,NULL,'maximum D','IC 0010',NULL,'2003A&A...407...51M',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2149,'RR Lyrae','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2149,24.56,0.08,0.817,828,NULL,NULL,NULL,'IC 0010',NULL,'2008ApJ...688L..69S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2150,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2150,23.51,0.19,0.501,828,NULL,NULL,NULL,'IC 0010',NULL,'1999ApJ...511..671S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2151,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2151,23.52,0.12,0.506,828,NULL,NULL,'I','IC 0010',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2152,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2152,23.8,0.1,0.575,828,NULL,NULL,NULL,'IC 0010',NULL,'1999IAUS..192..244T',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2153,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2153,24.17,0.39,0.682,828,NULL,NULL,'HST KP Calibrated','IC 0010',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2154,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2154,24.27,0.03,0.715,828,NULL,NULL,'K','IC 0010',NULL,'2009ApJ...703..816K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2155,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2155,24.3,0.25,0.724,828,NULL,NULL,NULL,'IC 0010',NULL,'2015MNRAS.454.1000G',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2156,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2156,24.34,0.06,0.74,828,74.4,NULL,NULL,'IC 0010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2157,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2157,24.4,NULL,0.759,828,NULL,NULL,NULL,'IC 0010',NULL,'2001PhDT........82Z',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2158,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2158,24.47,0.11,0.783,828,NULL,NULL,NULL,'IC 0010',NULL,'2009AstL...35..748T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2159,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2159,24.48,0.08,0.787,828,NULL,NULL,NULL,'IC 0010',NULL,'2007ApJ...662..272V',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2160,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2160,24.51,0.08,0.798,828,NULL,NULL,'I','IC 0010',NULL,'2008ApJ...688L..69S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2161,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2161,24.53,0.13,0.805,828,NULL,NULL,NULL,'IC 0010',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2162,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2162,24.6,0.15,0.832,828,NULL,NULL,'I, Z','IC 0010',NULL,'2008ApJ...688L..69S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2163,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2163,24.67,NULL,0.859,828,NULL,NULL,'I','IC 0010',NULL,'2009MmSAI..80...79S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2164,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2164,24.75,0.1,0.891,828,NULL,NULL,NULL,'IC 0010',NULL,'2008MmSAI..79..747S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2165,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2165,24.95,0.2,0.977,828,NULL,NULL,'I','IC 0010',NULL,'2001ApJ...559..225H',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2166,'Wolf-Rayet','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2166,24.7,NULL,0.87,828,NULL,18.3,NULL,'IC 0010',NULL,'1994AAS...185.7618M',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2167,'Wolf-Rayet','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2167,24.9,NULL,0.95,828,NULL,18.4,'3 brightest, LMC ZP','IC 0010',NULL,'1995AJ....109.2470M',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2168,'Wolf-Rayet','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2168,25.88,0.34,1.5,828,NULL,NULL,NULL,'IC 0010',NULL,'1992AJ....103.1159M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2169,'Statistical','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2169,24.6,0.12,0.832,828,NULL,NULL,NULL,'IC 0010',NULL,'2000glg..book.....V',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2170,'Proper Motion','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2170,24.4,NULL,0.76,828,NULL,NULL,NULL,'IC 0010',NULL,'2011arXiv1105.5596P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2171,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2171,24.23,0.4,0.7,828,75,NULL,'B','IC 0010',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2172,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2172,25.52,NULL,1.27,828,NULL,NULL,'LEDA [April 2006]','IC 0010',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2173,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2173,37.35,0.27,295,829,70,NULL,NULL,'2MASX J00201882-0004292',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000073,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,5.078333,-0.07464,0.061,NULL,34368248802,537003887,8390685,17.3),(2174,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2174,34.39,0.8,75.6,830,75,NULL,'CF, r','IC 0013',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000007,NULL,'14.73',0.5,'Sbc',NULL,NULL,NULL,NULL,1,5.0837083,7.7005,0.145,NULL,66798040985,1043719390,16308115,14.73),(2175,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2175,33.91,0.38,60.5,830,75,NULL,'CF, r, raw','IC 0013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2176,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2176,33.95,0.38,61.7,830,75,NULL,'CF, r, inv','IC 0013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2177,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2177,34.09,0.38,65.7,830,75,NULL,'CF, r, cor','IC 0013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2178,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2178,34.14,0.4,67.3,830,NULL,NULL,NULL,'IC 0013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2179,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2179,34.15,0.2,67.6,830,74.4,NULL,NULL,'IC 0013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2180,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2180,34.25,0.38,70.9,830,NULL,NULL,'Malmquist cor.','IC 0013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2181,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2181,34.3,0.49,72.4,830,75,NULL,'IR','IC 0013',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2182,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2182,37.35,0.27,295,831,70,NULL,NULL,'2MASX J00202235-0002592',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000085,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,5.093,-0.04992,0.061,NULL,34368248120,537003876,8390685,17),(2183,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2183,37.8,0.46,364,832,70,NULL,NULL,'2MASX J00202347+0059180',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000096,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,5.09779166667,0.98833,0.061,NULL,66631739477,1041120929,16267514,16.4),(2184,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2184,38.31,0.46,459,833,70,NULL,NULL,'2MASX J00202602+1613513',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000178,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,5.108375,16.231,0.117,NULL,66764734275,1043198973,16299983,17.5),(2185,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2185,36.75,0.59,224,834,70,NULL,NULL,'2MASX J00202649-0206429',NULL,'2014MNRAS.445.2677S',2014,1,0.27,NULL,'G',0.00015,NULL,'17.41',0.24,NULL,NULL,NULL,NULL,NULL,1,5.11045833333,-2.11189,0.09,NULL,34416693271,537760832,8402513,17.41),(2186,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 03882','RN',2186,40.77,0.16,1170,835,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03882',0.21435,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2187,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 03882','RN',2187,41.25,0.23,1460,835,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03882',0.21435,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2188,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2188,35.53,0.61,128,836,70,NULL,NULL,'FAIRALL 0644',NULL,'2014MNRAS.445.2677S',2014,1,0.67,'1984MNRAS.210...69F has V = 11100: +- 200 km/s.','G',0.00015,NULL,'16.10',0.38,'S0',NULL,NULL,NULL,NULL,1,5.116875,-49.94222,NULL,NULL,36025987531,562906055,8795407,16.1),(2189,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2189,37.61,0.46,332,837,70,NULL,NULL,'2MASX J00202955-0035399',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000077,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,5.12304166667,-0.59439,0.071,NULL,34414391872,537724873,8401951,17.8),(2190,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 04356','RN',2190,42.7,0.21,2520,838,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 04356',0.37241,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2191,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 04356','RN',2191,42.93,0.23,2810,838,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04356',0.37241,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2192,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2192,37.88,0.46,377,839,70,NULL,NULL,'2MASX J00203064+1531333',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000226,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,5.127667,15.52592,0.101,NULL,66763551320,1043180489,16299695,16.5),(2193,'BCG','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2193,37.81,0.35,333,840,60,NULL,NULL,'ABELL 0021',0.0948,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I:     [BM]',NULL,NULL,NULL,NULL,1,5.128333,28.62739,0.129,NULL,67227931432,1050436428,16413069,NULL),(2194,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2194,38.22,0.46,440,841,70,NULL,NULL,'2MASX J00203221+0045519',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000106,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,5.13416666667,0.76456,0.057,NULL,66631594391,1041118662,16267479,17.4),(2195,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2195,36.97,0.46,247,842,70,NULL,NULL,'2MASX J00203295-0008469',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000132,NULL,'15.5g',0.43,'E0',NULL,NULL,NULL,NULL,1,5.13729166667,-0.14639,0.071,NULL,34368361178,537005643,8390713,15.5),(2196,'Magnitude','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2196,36.19,0.13,173,843,100,NULL,NULL,'ABELL 2764',NULL,'1998A&A...337...31R',1998,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II     [BM];R  [A]',NULL,NULL,NULL,NULL,1,5.142083,-49.22778,NULL,NULL,35981739462,562214679,8784604,NULL),(2197,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2197,33.74,0.43,56,844,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00196',NULL,'2014MNRAS.444..527S',2014,1,1.5,NULL,'G',0.00003,NULL,'13.9',1.1,'SB(s)c','in a pair',NULL,NULL,NULL,1,5.142375,47.43458,0.405,NULL,65773090406,1027704537,16057883,13.9),(2198,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2198,34.32,0.47,73.1,844,NULL,NULL,'H','UGC 00196',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2199,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2199,34.33,0.4,73.5,844,NULL,NULL,'mean','UGC 00196',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2200,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2200,34.52,0.46,80.1,844,NULL,NULL,'J','UGC 00196',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2201,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2201,34.53,0.45,80.4,844,NULL,NULL,'K','UGC 00196',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2202,'Magnitude','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2202,36.19,0.13,173,845,100,NULL,NULL,'ESO 194- G 006',NULL,'1998A&A...337...31R',1998,1,0.7,NULL,'G',0.00015,NULL,'15.71',0.62,'S0:',NULL,NULL,NULL,NULL,1,5.148583,-49.21306,NULL,NULL,35981739183,562214674,8784604,15.71),(2203,'BCG','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2203,37.81,0.35,333,846,60,NULL,'ABELL 0021, BCG','2MASX J00203715+2839334',0.0948,'1980ApJ...241..486H',1980,1,NULL,NULL,'G',0.000267,NULL,'16.1',NULL,'cD','Component of a central pair in a cluster',NULL,NULL,NULL,1,5.1547083,28.65944,0.129,NULL,67227889362,1050435771,16413058,16.1),(2204,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2204,37.01,0.77,253,847,70,NULL,NULL,'2MASX J00203733-1317189',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.43',0.3,NULL,NULL,NULL,NULL,NULL,1,5.155625,-13.28875,0.039,NULL,34481268421,538769819,8418278,16.43),(2205,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 08888','R',2205,41.3,0.29,1300,848,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J002039.77+001917.1',0.3985,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',0.0002,NULL,'21.1g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,5.16575,0.32144,0.041,NULL,66576424029,1040256625,16254009,21.1),(2206,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 08888','R',2206,41.46,0.31,1400,848,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J002039.77+001917.1',0.3985,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2207,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 08888',NULL,2207,41.31,0.22,1830,848,70,NULL,'SALT 2','SDSS J002039.77+001917.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2208,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 08888',NULL,2208,41.38,0.22,1890,848,70,NULL,'SALT 2, Malmquist cor.','SDSS J002039.77+001917.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2209,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2209,34.62,0.49,83.9,849,70,NULL,NULL,'MCG -01-02-005',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00011,NULL,'14.75',0.5,'SA0^0^?',NULL,NULL,NULL,NULL,1,5.17466666667,-4.43306,0.112,NULL,34413993384,537718646,8401853,14.75),(2210,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 07390','RN',2210,43.77,0.3,4150,850,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 07390',0.370926,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2211,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 07390','RN',2211,43.8,0.35,4200,850,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 07390',0.370926,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2212,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 15236',NULL,2212,39.27,0.96,713,851,70,NULL,'SN photometric redshift distance, z photo =0.183 +/- 0.120','SDSS-II SN 15236',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','21.0g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,5.18375,-0.97153,0.035,NULL,34415297564,537739024,8402172,21),(2213,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 15236','R',2213,40.63,0.19,967,851,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 15236',0.382734,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2214,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 15236','R',2214,41.34,0.32,1340,851,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 15236',0.382734,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2215,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2215,33.45,0.23,49,852,74.4,NULL,NULL,'CGCG 457-008',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000027,NULL,'15.3',0.7,'S0',NULL,NULL,NULL,NULL,1,5.215667,21.5365,0.089,NULL,67455633342,1053994270,16468660,15.3),(2216,'Tully est','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2216,31.58,0.8,20.7,853,75,NULL,NULL,'ESO 078- G 022',NULL,'1988NBGC.C....0000T',1988,1,2,NULL,'G',0.00002,NULL,'14.52',0.3,'Sb: sp',NULL,NULL,NULL,NULL,1,5.23675,-63.85736,0,NULL,36048031467,563250491,8800788,14.52),(2217,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2217,37.12,0.46,266,854,70,NULL,NULL,'2MASXi J0020597-003430',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.61',0.15,NULL,NULL,NULL,NULL,NULL,1,5.249167,-0.57508,0.08,NULL,34414354053,537724282,8401941,18.61),(2218,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2218,35.91,NULL,152,855,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00201',NULL,'2010Ap&SS.325..163P',2010,1,1.23,NULL,'G',0.000016,NULL,'16.5',0.11,'Sc',NULL,NULL,NULL,NULL,1,5.249833,7.62214,0.141,NULL,66796022048,1043687844,16307622,16.5),(2219,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2219,35.91,NULL,152,855,NULL,NULL,'Dipole + Quadrupole','UGC 00201',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2220,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2220,35.92,NULL,153,855,NULL,NULL,'Dipole','UGC 00201',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2221,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2221,35.96,0.49,155,855,75,NULL,'IR','UGC 00201',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2222,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2222,36.02,NULL,160,855,NULL,NULL,NULL,'UGC 00201',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2223,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2223,34.61,0.23,83.6,856,74.4,NULL,NULL,'NGC 0079',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.00008,NULL,'14.9',0.3,'E',NULL,NULL,NULL,NULL,1,5.261875,22.56658,0.129,NULL,67456671078,1054010485,16468913,14.9),(2224,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 19132','R',2224,40.98,0.36,1140,857,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19132',0.380703,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',NULL,'PHOT','22.6g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,5.278667,-0.74861,0.08,NULL,34415132928,537736452,8402132,22.6),(2225,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 19132','R',2225,41.07,0.36,1180,857,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19132',0.380703,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2226,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 19132',NULL,2226,40.91,0.51,1520,857,70,NULL,'SN photometric redshift distance, z photo =0.450 +/- 0.173','SDSS-II SN 19132',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2227,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 19132',NULL,2227,40.98,0.26,1570,857,70,NULL,'SALT 2','SDSS-II SN 19132',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2228,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 19132',NULL,2228,41.04,0.26,1610,857,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19132',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2229,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2229,38.13,0.14,422,858,70,NULL,NULL,'2MASX J00210759-0055314',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000108,NULL,'16.5g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,5.28175,-0.92542,0.035,NULL,34415160835,537736888,8402138,16.5),(2230,'D-Sigma','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2230,34.71,0.4,87.6,859,75,NULL,'Edat, raw','NGC 0080',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000073,NULL,'13.1',1.7,'SA0-:','in a radial-velocity based grouping',NULL,NULL,NULL,1,5.2952083,22.35719,0.129,NULL,67456961916,1054015029,16468984,13.1),(2231,'D-Sigma','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2231,35.02,0.4,101,859,75,NULL,'Edat, cor','NGC 0080',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2232,'Faber-Jackson','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2232,33.57,0.55,51.8,859,95,NULL,'de Vaucouleurs','NGC 0080',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2233,'Faber-Jackson','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2233,33.96,0.34,61.9,859,95,NULL,'Weighted Mean','NGC 0080',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2234,'Faber-Jackson','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2234,34.37,0.46,74.8,859,95,NULL,'Michard 1979a','NGC 0080',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2235,'Faber-Jackson','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2235,35.43,0.63,122,859,95,NULL,'Michard 1979b, c','NGC 0080',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2236,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2236,34.41,0.23,76.2,859,74.4,NULL,NULL,'NGC 0080',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2237,'Tertiary','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2237,33.97,0.5,62.2,859,95,NULL,NULL,'NGC 0080',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2238,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2238,34.49,0.4,79.1,859,NULL,NULL,'mean','NGC 0080',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2239,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2239,34.59,0.45,82.9,859,NULL,NULL,'K','NGC 0080',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2240,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2240,38.13,0.14,422,860,70,NULL,NULL,'2MASX J00211166-0057394',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000101,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,5.298583,-0.961,0.035,NULL,34415162575,537736915,8402139,18.1),(2241,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2241,38.13,0.14,422,861,70,NULL,NULL,'2MASX J00211246-0054284',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000074,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,5.301917,-0.90778,0.035,NULL,34415160969,537736890,8402138,18.3),(2242,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2242,38.13,0.14,422,862,70,NULL,NULL,'2MASX J00211659-0050123',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.18',0.18,NULL,NULL,NULL,NULL,NULL,1,5.3192917,-0.83669,0.035,NULL,34415140360,537736568,8402133,18.18),(2243,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2243,34.39,0.8,75.6,863,75,NULL,'HMCL, I','IC 1544',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.00003,NULL,'14.42',0.8,'SAB(s)c',NULL,NULL,NULL,NULL,1,5.322917,23.09086,0.073,NULL,67453273088,1053957392,16468084,14.42),(2244,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2244,34.03,0.4,63.8,863,75,NULL,'HMCL, I, raw','IC 1544',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2245,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2245,34.15,0.4,67.7,863,75,NULL,'HMCL, I, inv','IC 1544',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2246,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2246,34.23,0.2,70.2,863,74.4,NULL,NULL,'IC 1544',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2247,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2247,34.24,0.4,70.3,863,75,NULL,'HMCL, I, cor','IC 1544',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2248,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2248,34.24,0.41,70.5,863,NULL,NULL,NULL,'IC 1544',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2249,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2249,34.44,0.37,77.4,863,NULL,NULL,'Malmquist cor.','IC 1544',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2250,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 19604','R',2250,40.98,0.23,1210,864,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007oi','SDSS J002118.25+010425.7',0.296,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',0.005,NULL,'22.0g',0.06,NULL,NULL,NULL,NULL,NULL,1,5.3260417,1.07381,0.041,NULL,66631173787,1041112090,16267376,22),(2251,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2007oi',NULL,2251,40.57,0.22,1300,864,70,NULL,'Hubble residual 0.39 for z0.29600','SDSS J002118.25+010425.7',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2252,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 19604','R',2252,41.15,0.31,1310,864,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007oi','SDSS J002118.25+010425.7',0.296,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2253,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2253,33.5,0.54,50.1,865,NULL,NULL,NULL,'UGC 00205 NED01',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000033,NULL,'15.36',0.4,'SBcd?',NULL,NULL,NULL,NULL,1,5.33375,17.34083,0.145,NULL,66714765663,1042418213,16287784,15.36),(2254,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2254,33.68,0.5,54.4,865,NULL,NULL,'Malmquist cor.','UGC 00205 NED01',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2255,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2255,33.77,0.2,56.8,866,74.4,NULL,NULL,'UGC 00205',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'GPair',NULL,NULL,NULL,NULL,'SB?',NULL,NULL,NULL,NULL,1,5.334167,17.34667,0.145,NULL,66714765823,1042418215,16287784,NULL),(2256,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2256,38.13,0.46,424,867,70,NULL,NULL,'2MASX J00212018+1401181',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000174,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,5.33420833333,14.02181,0.133,NULL,66758565727,1043102589,16298477,18.1),(2257,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2257,37.94,0.46,387,868,70,NULL,NULL,'SDSS J002120.49+143038.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,5.335375,14.51056,0.133,NULL,66771434878,1043303669,16301619,18.6),(2258,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2258,35.1,0.23,105,869,74.4,NULL,NULL,'IC 1545',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.00009,NULL,'16.67',NULL,'S0',NULL,NULL,NULL,NULL,1,5.337125,21.98344,0.125,NULL,67456906545,1054014164,16468971,16.67),(2259,'D-Sigma','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2259,34.43,0.17,77,870,72,NULL,'WBL 009 = 7S21 cluster, 7 galaxies','NGC 0083',NULL,'2002AJ....123.2159B',2002,1,1.5,NULL,'G',0.000087,NULL,'13.58',1.5,'E','Group member, 2nd ranked galaxy',NULL,NULL,NULL,1,5.343333,22.43361,0.129,NULL,67456632756,1054009886,16468904,13.58),(2260,'D-Sigma','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2260,34.71,0.4,87.6,870,75,NULL,'Edat, raw','NGC 0083',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2261,'D-Sigma','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2261,35.02,0.4,101,870,75,NULL,'Edat, cor','NGC 0083',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2262,'Faber-Jackson','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2262,33.34,0.67,46.6,870,95,NULL,'de Vaucouleurs','NGC 0083',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2263,'Faber-Jackson','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2263,33.86,0.37,59.2,870,95,NULL,'Weighted Mean','NGC 0083',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2264,'Faber-Jackson','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2264,34.54,0.46,80.9,870,95,NULL,'Michard 1979a','NGC 0083',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2265,'Faber-Jackson','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2265,34.8,0.63,91.2,870,95,NULL,'Michard 1979b, c','NGC 0083',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2266,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2266,34.3,0.16,72.6,870,75,NULL,'WBL 009 = 7S21 cluster, 7 galaxies','NGC 0083',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2267,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2267,34.3,0.16,72.6,870,75,NULL,'WBL 009 = 7S21 cluster, 7 galaxies','NGC 0083',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2268,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2268,34.6,0.23,83.2,870,74.4,NULL,NULL,'NGC 0083',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2269,'Tertiary','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2269,33.97,0.5,62.2,870,95,NULL,NULL,'NGC 0083',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2270,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2270,34.73,0.16,88.3,870,70,NULL,'WBL 009 Cluster','NGC 0083',NULL,'1992ApJ...396..453H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2271,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2271,34.81,0.4,91.8,870,NULL,NULL,'mean','NGC 0083',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2272,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2272,34.88,0.45,94.5,870,NULL,NULL,'K','NGC 0083',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2273,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2273,36.64,0.46,213,871,70,NULL,NULL,'2MASX J00212267-0112343',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00015,NULL,'16.91',0.3,NULL,NULL,NULL,NULL,NULL,1,5.3444583,-1.20939,0.067,NULL,34415046513,537735101,8402110,16.91),(2274,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2274,38.31,0.46,459,872,70,NULL,NULL,'2MASX J00212456-0917560',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000113,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,5.352333,-9.29881,0.125,NULL,34600815404,540637740,8447464,17.2),(2275,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2275,33.75,0.23,56.2,873,74.4,NULL,NULL,'NGC 0085',NULL,'2013AJ....146...86T',2013,1,0.45,'1994AJ....107..427D has V = 5515 +- 36 km/sec.','G',0.00008,NULL,'15.7',0.45,'S0',NULL,NULL,NULL,NULL,1,5.356375,22.51178,0.129,NULL,67456643147,1054010049,16468907,15.7),(2276,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 03779','RN',2276,43.13,0.25,3190,874,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03779',0.326632,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2277,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 03779','RN',2277,43.3,0.25,3450,874,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03779',0.326632,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2278,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2278,34.72,0.8,87.8,875,75,NULL,'HMCL, I','NGC 0086',NULL,'1997ApJS..109..333W',1997,1,0.55,NULL,'G',0.000077,NULL,'14.9',0.2,'Sbc',NULL,NULL,NULL,NULL,1,5.3690417,22.55642,0.129,NULL,67456648695,1054010135,16468908,14.9),(2279,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2279,34.62,0.4,84.1,875,75,NULL,'HMCL, I, raw','NGC 0086',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2280,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2280,34.8,0.4,91.4,875,75,NULL,'HMCL, I, inv','NGC 0086',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2281,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2281,34.82,0.4,92,875,75,NULL,'HMCL, I, cor','NGC 0086',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2282,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2282,34.43,0.8,76.9,876,75,NULL,'HMCL, I','NGC 0085B',NULL,'1997ApJS..109..333W',1997,1,0.9,'Called \'NGC 0085B\' in MCG.','G',0.000013,NULL,'15.59',0.2,'S?             HII',NULL,NULL,NULL,NULL,1,5.37095833333,22.50586,0.129,NULL,67456643287,1054010051,16468907,15.59),(2283,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2283,34.48,0.4,78.6,876,75,NULL,'HMCL, I, raw','NGC 0085B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2284,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2284,34.63,0.49,84.2,876,75,NULL,'IR','NGC 0085B',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2285,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2285,34.63,0.4,84.4,876,75,NULL,'HMCL, I, inv','NGC 0085B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2286,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2286,34.67,0.4,85.8,876,75,NULL,'HMCL, I, cor','NGC 0085B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2287,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2287,34.71,0.44,87.5,876,NULL,NULL,NULL,'NGC 0085B',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2288,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2288,34.74,0.43,88.8,876,NULL,NULL,'Malmquist cor.','NGC 0085B',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2289,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2289,34.75,0.2,89.1,876,74.4,NULL,NULL,'NGC 0085B',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2290,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 21152',NULL,2290,40.21,1.38,1100,877,70,NULL,'SN photometric redshift distance, z photo =0.301 +/- 0.397','SDSS-II SN 21152',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.4g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,5.37125,0.67514,0.041,NULL,66630809009,1041106390,16267287,21.4),(2291,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 21152','R',2291,41.48,0.36,1460,877,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 21152',0.359687,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2292,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 21152','R',2292,41.51,0.38,1480,877,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21152',0.359687,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2293,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 21152',NULL,2293,41.4,0.26,1910,877,70,NULL,'SALT 2','SDSS-II SN 21152',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2294,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 21152',NULL,2294,41.44,0.26,1940,877,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 21152',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2295,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2295,38.13,0.14,422,878,70,NULL,NULL,'SDSS J002130.65-003124.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000077,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,5.37775,-0.5235,0.08,NULL,34414520561,537726883,8401982,18.2),(2296,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2296,34.87,0.8,94.1,879,75,NULL,'W91PP, r','UGC 00207',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'15.52',0.3,'Sb','Group member',NULL,NULL,NULL,1,5.3797083,29.66219,0.193,NULL,67218294130,1050285845,16410716,15.52),(2297,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2297,34.87,0.8,94.1,879,75,NULL,'HMCL, I','UGC 00207',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2298,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2298,34.57,0.4,82,879,75,NULL,'HMCL, I, raw','UGC 00207',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2299,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2299,34.66,0.38,85.5,879,75,NULL,'W91PP, r, raw','UGC 00207',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2300,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2300,34.68,0.4,86.4,879,75,NULL,'HMCL, I, inv','UGC 00207',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2301,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2301,34.72,0.38,88.1,879,75,NULL,'W91PP, r, inv','UGC 00207',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2302,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2302,34.75,0.4,89.2,879,75,NULL,'HMCL, I, cor','UGC 00207',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2303,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2303,34.8,0.45,91.1,879,NULL,NULL,'Malmquist cor.','UGC 00207',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2304,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2304,34.82,0.38,92.2,879,75,NULL,'W91PP, r, cor','UGC 00207',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2305,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2305,34.87,0.44,94.1,879,NULL,NULL,NULL,'UGC 00207',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2306,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2306,34.91,0.2,95.9,879,74.4,NULL,NULL,'UGC 00207',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2307,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2307,34.96,0.43,98.3,880,NULL,NULL,'Malmquist cor.','MCG +04-02-010',NULL,'2009ApJS..182..474S',2009,1,0.75,NULL,'G',0.000073,NULL,'17',0.25,'S              Sbrst',NULL,NULL,NULL,NULL,1,5.3895417,22.59197,0.129,NULL,67456660570,1054010321,16468911,17),(2308,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2308,35.1,0.41,104,880,NULL,NULL,NULL,'MCG +04-02-010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2309,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2309,35.14,0.2,107,880,74.4,NULL,NULL,'MCG +04-02-010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2310,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2310,38.13,0.14,422,881,70,NULL,NULL,'2MASX J00213381-0033303',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000104,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,5.390875,-0.55833,0.08,NULL,34414468950,537726077,8401969,17.1),(2311,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2311,36.88,0.57,237,882,70,NULL,NULL,'2MASX J00213472-0407193',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.26',0.35,NULL,NULL,NULL,NULL,NULL,1,5.394583,-4.12197,0.102,NULL,34411870612,537685478,8401335,16.26),(2312,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 08987','RN',2312,39.47,0.29,771,883,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08987',0.018232,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2313,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 08987','RN',2313,40.08,0.21,1020,883,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 08987',0.018232,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2314,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 01740','R',2314,39.46,0.18,669,884,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J002137.05-005251.3',0.167,'2014arXiv1401.3317S',2014,1,0.11,NULL,'G',NULL,NULL,'19.7g',0.08,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,5.40441666667,-0.88092,0.067,NULL,34415171887,537737060,8402141,19.7),(2315,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 01740',NULL,2315,39.2,0.08,692,884,70,NULL,'SALT 2','SDSS J002137.05-005251.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2316,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 01740',NULL,2316,39.21,0.08,695,884,70,NULL,'SALT 2, Malmquist cor.','SDSS J002137.05-005251.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2317,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 01740','R',2317,39.61,0.1,715,884,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J002137.05-005251.3',0.167,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(166024,'SNIa','2016-12-16 11:18:33','2016-12-16 11:18:33','0','SDSS-II SN 12781','RN',2318,37.89,0.1,350,885,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006er','SDSS-II SN 12781 HOST = 2MASX J00213789-0100383',0.084359,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2319,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2006er',NULL,2319,37.86,0.11,372,885,70,NULL,'Hubble residual 0.16 for z0.08431','SDSS-II SN 12781 HOST',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2320,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 12781','R',2320,38.08,0.19,381,885,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006er','SDSS-II SN 12781 HOST',0.084359,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2321,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'RN',2321,37.58,0.46,327,885,70,NULL,NULL,'SDSS-II SN 12781 HOST = 2MASX J00213789-0100383',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2322,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2322,38.97,0.46,623,886,70,NULL,NULL,'SDSS J002140.07+010339.0',NULL,'2015arXiv151105856S',2015,1,0.07,NULL,'G',0.000087,NULL,'18.4g',0.06,NULL,NULL,NULL,NULL,NULL,1,5.4169583,1.06086,0.017,NULL,66631176709,1041112136,16267377,18.4),(2323,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 00730','RN',2323,40.13,0.19,811,887,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00730',0.308315,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2324,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2324,38.13,0.14,422,888,70,NULL,NULL,'2MASX J00214235-0052323',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000101,NULL,'16.7g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,5.426583,-0.87556,0.067,NULL,34415170303,537737035,8402141,16.7),(2325,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 15231','RN',2325,40.73,0.25,1210,889,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15231',0.159988,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2326,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 15231','RN',2326,41.38,0.29,1630,889,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15231',0.159988,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2327,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2005is',NULL,2327,38.76,0.12,482,890,74.2,NULL,'SALT 2','APMUKS(BJ) B001911.19-003608.1',0.172,'2010ApJ...716..712A',2010,1,0.11,NULL,'G',NULL,NULL,'19.94',0.09,NULL,NULL,NULL,NULL,NULL,1,5.437083,-0.32494,0.079,NULL,34414285157,537723205,8401925,19.94),(2328,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2005is',NULL,2328,39.43,0.13,656,890,70,NULL,'SDSS-II SN 05916, SALT 2','APMUKS(BJ) B001911.19-003608.1',0.172,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2329,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 05916','R',2329,39.46,0.18,666,890,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2005is','APMUKS(BJ) B001911.19-003608.1',0.17,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2330,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 05916','R',2330,39.63,0.1,721,890,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2005is','APMUKS(BJ) B001911.19-003608.1',0.17,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2331,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2005is',NULL,2331,39.31,0.07,728,890,70,NULL,'SALT 2','APMUKS(BJ) B001911.19-003608.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2332,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2005is',NULL,2332,39.32,0.07,731,890,70,NULL,'SALT 2, Malmquist cor.','APMUKS(BJ) B001911.19-003608.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2333,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2005is',NULL,2333,39.8,0.03,779,890,70,NULL,'SDSS-II SN 05916','APMUKS(BJ) B001911.19-003608.1',0.172,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2334,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2334,37.22,0.58,278,891,70,NULL,NULL,'2MASX J00214625-1144111',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.58',0.41,NULL,NULL,NULL,NULL,NULL,1,5.4427083,-11.73653,0.114,NULL,34469005954,538578218,8415284,16.58),(2335,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 15690','RN',2335,41.73,0.48,1710,892,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15690',0.301222,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2336,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 16469','RN',2336,38.78,0.08,498,893,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 16469',0.142699,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2337,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 16469','RN',2337,38.96,0.2,542,893,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 16469',0.142699,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2338,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2338,34.46,0.2,78,894,74.4,NULL,NULL,'CGCG 479-014B',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000053,NULL,'0.81',0.4,'Sc',NULL,NULL,NULL,NULL,1,5.449,22.02653,0.125,NULL,67456909346,1054014208,16468972,0.81),(2339,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2339,35.54,0.61,128,895,70,NULL,NULL,'2MASX J00215117-0135273',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'16.23',0.35,NULL,NULL,NULL,NULL,NULL,1,5.463375,-1.59078,0.081,NULL,34416648194,537760128,8402502,16.23),(2340,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2340,34.25,0.4,70.7,896,NULL,NULL,'mean','NGC 0090',NULL,'2007A&A...465...71T',2007,1,1.9,'NGC 0091 is a star 2 arcmin south of NGC 0090.','G',0.000023,NULL,'14.54',0.8,'SAB(s)c pec',NULL,NULL,NULL,NULL,1,5.464167,22.4,0.109,NULL,67456754303,1054011785,16468934,14.54),(2341,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2341,35.63,0.47,134,896,NULL,NULL,'H','NGC 0090',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2342,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2342,35.97,0.79,156,897,70,NULL,NULL,'2MASX J00215303-1926257',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'16.84',0.35,NULL,NULL,NULL,NULL,NULL,1,5.4709583,-19.4405,0.049,NULL,35310542075,551727219,8620737,16.84),(2343,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2343,34.01,0.23,63.4,898,74.4,NULL,NULL,'IC 1548',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.00007,NULL,'15.6',0.7,'S0',NULL,NULL,NULL,NULL,1,5.479833,22.00631,0.125,NULL,67456881108,1054013767,16468965,15.6),(2344,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2344,34.44,0.8,77.3,898,75,NULL,'HMCL, I','IC 1548',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2345,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2345,34.83,0.4,92.6,898,75,NULL,'HMCL, I, raw','IC 1548',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2346,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2346,34.92,0.4,96.6,898,75,NULL,'HMCL, I, inv','IC 1548',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2347,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2347,35.04,0.4,102,898,75,NULL,'HMCL, I, cor','IC 1548',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2348,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 00893','N',2348,39.59,0.11,828,899,70,NULL,'SALT 2','SDSS-II SN 00893',NULL,'2013ApJ...763...88C',2013,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2349,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 00893','N',2349,39.6,0.11,832,899,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 00893',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2350,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 00893','RN',2350,39.88,0.21,853,899,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 00893',0.110133,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2351,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 00893','RN',2351,40.15,0.18,966,899,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 00893',0.110133,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2352,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 04117',NULL,2352,40.32,0.24,1160,900,70,NULL,'SN photometric redshift distance, z photo =0.320 +/- 0.047','SDSS-II SN 04117',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.0g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,5.49975,-1.24372,0.067,NULL,34414841149,537731892,8402060,21),(2353,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2353,34.31,0.47,72.7,901,NULL,NULL,'H','CGCG 549-038',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.00003,NULL,'14.8',0.5,'S              HII',NULL,NULL,NULL,NULL,1,5.505167,49.13344,0.577,NULL,65772759764,1027699371,16057802,14.8),(2354,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2354,34.36,0.4,74.4,901,NULL,NULL,'mean','CGCG 549-038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2355,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2355,34.45,0.45,77.6,901,NULL,NULL,'K','CGCG 549-038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2356,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2356,37.97,0.46,393,902,70,NULL,NULL,'2MASX J00220300-1027032',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000089,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,5.5125,-10.45078,0.136,NULL,34599310947,540614233,8447097,17),(2357,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2357,34.37,0.8,74.8,903,75,NULL,'HMCL, I','NGC 0093',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.34',0.6,'S?',NULL,NULL,NULL,NULL,1,5.5134583,22.40808,0.109,NULL,67456733531,1054011461,16468929,14.34),(2358,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2358,34.38,0.8,75.3,903,75,NULL,'W91PP, r','NGC 0093',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2359,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2359,33.42,0.47,48.3,903,NULL,NULL,'H','NGC 0093',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2360,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2360,33.5,0.45,50.1,903,NULL,NULL,'K','NGC 0093',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2361,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2361,33.59,0.46,52.1,903,NULL,NULL,'J','NGC 0093',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2362,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2362,34.41,0.4,76.1,903,NULL,NULL,'mean','NGC 0093',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2363,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2363,34.61,0.38,83.7,903,75,NULL,'W91PP, r, raw','NGC 0093',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2364,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2364,34.79,0.38,90.7,903,75,NULL,'W91PP, r, cor','NGC 0093',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2365,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2365,34.9,0.4,95.6,903,75,NULL,'HMCL, I, raw','NGC 0093',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2366,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2366,34.91,0.38,95.9,903,75,NULL,'W91PP, r, inv','NGC 0093',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2367,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2367,35.06,0.4,103,903,75,NULL,'HMCL, I, cor','NGC 0093',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2368,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2368,35.2,0.4,110,903,75,NULL,'HMCL, I, inv','NGC 0093',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2369,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','PTF10wnm',NULL,2369,37.26,0.02,266,904,70,NULL,'SiFTO+SALT2, SN PTF10wnm','PTF10wnm',0.0645,'2012MNRAS.426.2359M',2012,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,3.446917,27.04056,0.093,NULL,67239417119,1050615892,16415873,NULL),(2370,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','PTF10wnm',NULL,2370,37.15,0.02,270,904,NULL,NULL,'J','PTF10wnm',NULL,'2012MNRAS.425.1007B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2371,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','PTF10wnm',NULL,2371,37.37,0.02,280,904,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10wnm',0.0645,'2014MNRAS.438.1391P',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2372,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','PTF10wnm',NULL,2372,37.29,0.02,287,904,72,NULL,'M(H) = -18.317 mag','PTF10wnm',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2373,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','PTF10wnm',NULL,2373,37.3,0.04,289,904,NULL,NULL,'H','PTF10wnm',NULL,'2012MNRAS.425.1007B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2374,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2374,38.13,0.14,422,905,70,NULL,NULL,'2MASX J00220370-0050289',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000082,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,5.5152083,-0.84139,0.067,NULL,34414861757,537732214,8402065,17.6),(2375,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2375,33.7,0.8,55.1,906,75,NULL,'MAT, I','UGC 00210',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'14.89',0.5,'Sb',NULL,NULL,NULL,NULL,1,5.5212083,23.73697,0.093,NULL,67181175394,1049705865,16401654,14.89),(2376,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2376,33.72,0.8,55.5,906,75,NULL,'CF, r','UGC 00210',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2377,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2377,33.72,0.8,55.5,906,75,NULL,'W91PP, r','UGC 00210',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2378,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2378,33.54,0.32,51,906,85,NULL,'I, inv','UGC 00210',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2379,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2379,33.54,0.32,51.1,906,85,NULL,'I, raw','UGC 00210',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2380,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2380,33.82,0.43,58.1,906,75,NULL,'MAT, I, raw','UGC 00210',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2381,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2381,33.86,0.43,59.2,906,75,NULL,'MAT, I, inv','UGC 00210',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2382,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2382,34.1,0.43,65.9,906,75,NULL,'MAT, I, cor','UGC 00210',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2383,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2383,34.16,0.38,68.1,906,75,NULL,'CF, r, raw','UGC 00210',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2384,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2384,34.19,0.38,68.9,906,75,NULL,'CF, r, inv','UGC 00210',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2385,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2385,34.27,0.2,71.5,906,74.4,NULL,NULL,'UGC 00210',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2386,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2386,34.27,0.39,71.6,906,NULL,NULL,NULL,'UGC 00210',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2387,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2387,34.31,0.38,72.8,906,75,NULL,'W91PP, r, raw','UGC 00210',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2388,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2388,34.33,0.38,73.3,906,75,NULL,'W91PP, r, inv','UGC 00210',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2389,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2389,34.34,0.38,74,906,75,NULL,'CF, r, cor','UGC 00210',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2390,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2390,34.45,0.36,77.6,906,NULL,NULL,'Malmquist cor.','UGC 00210',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2391,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2391,34.49,0.38,79,906,75,NULL,'W91PP, r, cor','UGC 00210',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2392,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 15734','R',2392,41.53,0.2,1460,907,70,NULL,'SDSS CAND. zSNIa; MLCS2K2; SN 2006ng','SN 2006ng',0.385,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,5.5302917,-0.09564,0.079,NULL,34414270489,537722976,8401921,NULL),(2393,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 15734','R',2393,41.96,0.32,1780,907,70,NULL,'SDSS CAND. zSNIa; SALT 2; SN 2006ng','SN 2006ng',0.385,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2394,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2394,34.45,NULL,77.6,908,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0036',NULL,'2010Ap&SS.325..163P',2010,1,0.9,NULL,'G',0.000011,':','16.83',0.11,'Sd',NULL,NULL,NULL,NULL,1,5.535417,10.38,0.185,NULL,66799238421,1043738100,16308407,16.83),(2395,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2395,34.47,NULL,78.2,908,NULL,NULL,'Dipole + Quadrupole','FGC 0036',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2396,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2396,34.48,NULL,78.8,908,NULL,NULL,'Dipole','FGC 0036',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2397,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 03780','RN',2397,41.82,0.3,1700,909,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03780',0.361973,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2398,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 03780','RN',2398,42.16,0.41,1980,909,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03780',0.361973,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2399,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2399,38.23,0.46,443,910,70,NULL,NULL,'2MASX J00221335+0008373',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000113,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,5.555583,0.14369,0.045,NULL,66630726635,1041105103,16267267,17.3),(2400,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2400,33.55,0.69,51.3,911,100,NULL,'mid-IR','NGC 0095',NULL,'2013ApJ...771...88L',2013,1,1.9,NULL,'G',0.000017,NULL,'13.19',1.1,'SAB(rs)c pec',NULL,NULL,NULL,NULL,1,5.556417,10.49158,0.185,NULL,66799268044,1043738563,16308415,13.19),(2401,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2401,33.64,0.45,53.5,911,NULL,NULL,'K','NGC 0095',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2402,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2402,33.66,0.47,53.9,911,NULL,NULL,'H','NGC 0095',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2403,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2403,33.68,0.46,54.5,911,NULL,NULL,'J','NGC 0095',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2404,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2404,33.84,0.52,58.5,911,NULL,NULL,NULL,'NGC 0095',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2405,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2405,33.84,0.52,58.5,911,NULL,NULL,'Malmquist cor.','NGC 0095',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2406,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2406,33.88,0.2,59.7,911,74.4,NULL,NULL,'NGC 0095',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2407,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2407,34.24,0.4,70.5,911,NULL,NULL,'mean','NGC 0095',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2408,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2408,34.15,NULL,67.6,912,NULL,NULL,NULL,'UGC 00211',NULL,'2000BSAO...50....5K',2000,1,1.04,NULL,'G',0.000008,NULL,'17.',0.14,'Sc',NULL,NULL,NULL,NULL,1,5.563667,20.60775,0.109,NULL,67457084449,1054016944,16469014,17),(2409,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2409,34.42,NULL,76.6,912,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00211',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2410,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2410,34.43,NULL,77.1,912,NULL,NULL,'Dipole + Quadrupole','UGC 00211',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2411,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2411,34.45,NULL,77.6,912,NULL,NULL,'Dipole','UGC 00211',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2412,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2412,38.13,0.14,422,913,70,NULL,NULL,'2MASX J00221730-0058078',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000099,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,5.572083,-0.96875,0.061,NULL,34414892431,537732694,8402073,17.1),(2413,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2413,38.51,0.27,503,914,70,NULL,NULL,'SDSS J002219.73-090244.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000087,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,5.5822083,-9.04558,0.126,NULL,34600116570,540626821,8447294,18.7),(2414,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2414,36.36,0.63,187,915,70,NULL,NULL,'2MASX J00222069-7609509',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.00015,NULL,'15.7R',0.13,NULL,NULL,NULL,NULL,NULL,1,5.586625,-76.16403,0.201,NULL,35598853142,556232080,8691126,15.7),(2415,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2415,38.13,0.14,422,916,70,NULL,NULL,'2MASX J00222435-0055113',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000097,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,5.6014583,-0.91981,0.067,NULL,34414891479,537732679,8402073,17.6),(2416,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2416,37.46,0.46,310,917,70,NULL,NULL,'SDSS J002224.84-011350.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000072,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,5.6035417,-1.23058,0.061,NULL,34414813736,537731464,8402054,18.1),(2417,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2417,38.13,0.14,422,918,70,NULL,NULL,'SDSS J002225.23-005539.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,5.60516666667,-0.92769,0.061,NULL,34414894744,537732730,8402073,18.4),(2418,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2418,31.34,0.8,18.6,919,75,NULL,'MAT, I','ESO 150- G 005',NULL,'1997ApJS..109..333W',1997,1,2.7,NULL,'G',0.00001,NULL,'13.99',1.9,'SA(s)dm',NULL,NULL,NULL,NULL,1,5.6065,-53.6475,NULL,NULL,35992812712,562387698,8787307,13.99),(2419,'Tully est','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2419,31.09,0.8,16.5,919,75,NULL,NULL,'ESO 150- G 005',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2420,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2420,30.34,0.32,11.7,919,85,NULL,'I, inv','ESO 150- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2421,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2421,30.4,0.32,12,919,85,NULL,'I, raw','ESO 150- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2422,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2422,30.54,0.43,12.8,919,75,NULL,'MAT, I, inv','ESO 150- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2423,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2423,30.68,0.43,13.7,919,75,NULL,'MAT, I, raw','ESO 150- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2424,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2424,30.68,0.4,13.7,919,NULL,NULL,NULL,'ESO 150- G 005',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2425,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2425,30.68,0.39,13.7,919,73,NULL,'opt','ESO 150- G 005',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2426,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2426,30.96,0.43,15.6,919,75,NULL,'MAT, I, cor','ESO 150- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2427,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2427,34.28,0.69,71.8,920,100,NULL,'mid-IR','UGC 00215',NULL,'2013ApJ...771...88L',2013,1,1.2,NULL,'G',0.000033,NULL,'14.65',0.8,'SBab           Sy2',NULL,NULL,NULL,NULL,1,5.610375,29.50428,0.193,NULL,67218739106,1050292798,16410824,14.65),(2428,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2428,34.48,0.38,78.7,920,NULL,NULL,NULL,'UGC 00215',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2429,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2429,34.49,0.38,78.9,920,NULL,NULL,'Malmquist cor.','UGC 00215',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2430,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2430,34.8,0.2,91.2,920,74.4,NULL,NULL,'UGC 00215',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2431,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2431,35.1,0.4,105,920,NULL,NULL,'mean','UGC 00215',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2432,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2432,35.29,0.47,114,920,NULL,NULL,'H','UGC 00215',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2433,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2433,35.3,0.45,115,920,NULL,NULL,'K','UGC 00215',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2434,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2434,35.39,0.46,120,920,NULL,NULL,'J','UGC 00215',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2435,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2435,34.16,0.4,68,921,NULL,NULL,'mean','NGC 0097',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000043,NULL,'13.29',1.3,'E:','in a radial-velocity based grouping',NULL,NULL,NULL,1,5.625,29.74536,0.193,NULL,67218399843,1050287497,16410742,13.29),(2436,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2436,34.34,0.45,73.9,921,NULL,NULL,'K','NGC 0097',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2437,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2437,38.51,0.27,503,922,70,NULL,NULL,'2MASX J00223338-0905059',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000081,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,5.6389583,-9.08508,0.126,NULL,34600046044,540625719,8447276,17.2),(2438,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2438,34.35,0.54,74,923,70,NULL,NULL,'MCG -02-02-007',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.00015,NULL,'14.89',0.4,'(R)S0+? sp',NULL,NULL,NULL,NULL,1,5.64116666667,-8.48639,0.09,NULL,34605116827,540704950,8448514,14.89),(2439,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2439,35.02,0.49,101,923,75,NULL,'IR','MCG -02-02-007',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2440,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2440,36.86,0.61,235,924,70,NULL,NULL,'2MASX J00223541-0620269',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.31',0.32,NULL,NULL,NULL,NULL,NULL,1,5.6475417,-6.34086,0.115,NULL,34603141885,540674091,8448032,16.31),(2441,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 17993','RN',2441,41.95,0.41,1920,925,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 17993',0.278298,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2442,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 17993','RN',2442,42.97,0.41,3070,925,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 17993',0.278298,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2443,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2443,37.86,0.46,373,926,70,NULL,NULL,'SDSS J002236.35+011113.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000075,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,5.6514583,1.18703,0.029,NULL,66597711579,1040589243,16259206,18.2),(2444,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 08343','RN',2444,42.38,0.6,2710,927,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08343',0.103244,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2445,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2445,37.65,0.46,339,928,70,NULL,NULL,'2MASX J00223947-1031369',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000077,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,5.664583,-10.527,0.148,NULL,34599256758,540613386,8447084,18.2),(2446,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 16652','RN',2446,40.85,0.26,1190,929,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16652',0.23934,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2447,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 16652','RN',2447,40.97,0.18,1260,929,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16652',0.23934,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2448,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 16652','N',2448,40.78,0.14,1430,929,70,NULL,'SALT 2','SDSS-II SN 16652',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2449,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 16652','N',2449,40.8,0.14,1450,929,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16652',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2450,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 20625','R',2450,38.56,0.18,465,930,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007px','SDSS J002243.95-002845.8',0.108147,'2014arXiv1401.3317S',2014,1,0.23,NULL,'G',0.00011,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,5.683125,-0.47942,0.116,NULL,34397608234,537462628,8397853,17.8),(2451,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2007px',NULL,2451,38.45,0.06,490,930,70,NULL,'SALT 2','SDSS J002243.95-002845.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2452,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2007px',NULL,2452,38.46,0.06,492,930,70,NULL,'SALT 2, Malmquist cor.','SDSS J002243.95-002845.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2453,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 20625','R',2453,38.71,0.08,498,930,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007px','SDSS J002243.95-002845.8',0.108147,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2454,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 11434','RN',2454,38.79,0.3,529,931,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 11434',0.083769,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2455,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 11434','RN',2455,39.27,0.38,658,931,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 11434',0.083769,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2456,'SNII optical','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 1990ae',NULL,2456,35.3,0.6,115,932,NULL,NULL,NULL,'CGCG 409-007',NULL,'1994ApJ...432...42S',1994,1,1,NULL,'G',0.00003,NULL,'15.3',0.3,NULL,NULL,NULL,NULL,NULL,1,5.70725,6.81706,0.081,NULL,66794587368,1043665427,16307272,15.3),(2457,'SNII optical','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 1990ae',NULL,2457,35.34,0.43,117,932,NULL,NULL,'EPM','CGCG 409-007',NULL,'1992ApJ...395..366S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2458,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2458,35.27,0.2,113,932,74.4,NULL,NULL,'CGCG 409-007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2459,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2459,35.22,0.2,111,933,74.4,NULL,NULL,'CGCG 479-018',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000033,NULL,'15.4',0.5,'Sc',NULL,NULL,NULL,NULL,1,5.708375,24.15231,0.053,NULL,67235341965,1050552218,16414878,15.4),(2460,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2460,37.38,0.46,300,934,70,NULL,NULL,'2MASX J00225002+0046156',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,5.70841666667,0.77106,0.025,NULL,66597761698,1040590026,16259219,16.4),(2461,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 03572','RN',2461,43.29,0.25,3170,935,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03572',0.434285,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2462,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 03572','RN',2462,43.91,0.27,4210,935,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03572',0.434285,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2463,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2463,36.96,0.72,247,936,70,NULL,NULL,'2MASX J00225090-4245084',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.17',0.42,NULL,NULL,NULL,NULL,NULL,1,5.7120417,-42.75242,NULL,NULL,38128278878,595754357,9308661,16.17),(2464,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2464,34.93,0.49,96.8,937,70,NULL,NULL,'MCG -03-02-009',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000083,NULL,'15.20',0.6,NULL,NULL,NULL,NULL,NULL,1,5.7207083,-14.53433,0.051,NULL,34486645265,538853832,8419591,15.2),(2465,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2465,38.51,0.27,503,938,70,NULL,NULL,'2MASX J00225330-0859569',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000113,NULL,'16.9g',0.32,'Candidate      BLAGN',NULL,NULL,NULL,NULL,1,5.7220417,-8.99906,0.126,NULL,34600025335,540625395,8447271,16.9),(2466,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 18751','R',2466,37.67,0.21,319,939,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ly','APMUKS(BJ) B002019.53+002955.2',0.0713,'2014arXiv1401.3317S',2014,1,0.12,NULL,'G',0.0005,NULL,'19.42',0.11,NULL,NULL,NULL,NULL,NULL,1,5.722417,0.77594,0.025,NULL,66597753930,1040589905,16259217,19.42),(2467,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2007ly',NULL,2467,37.57,0.21,326,939,70,NULL,'Hubble residual 0.22 for z0.07130','APMUKS(BJ) B002019.53+002955.2',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2468,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 18751','R',2468,37.85,0.09,347,939,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ly','APMUKS(BJ) B002019.53+002955.2',0.0713,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2469,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 14548',NULL,2469,40,0.16,1000,940,70,NULL,'SN photometric redshift distance, z photo =0.269 +/- 0.025','SDSS-II SN 14548',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','21.0g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,5.724583,0.83286,0.025,NULL,66597810741,1040590792,16259231,21),(2470,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 14548','R',2470,41.14,0.21,1260,940,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14548',0.34028,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2471,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 14548','R',2471,41.2,0.13,1300,940,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14548',0.34028,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2472,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 14548',NULL,2472,41.05,0.12,1620,940,70,NULL,'SALT 2','SDSS-II SN 14548',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2473,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 14548',NULL,2473,41.09,0.12,1650,940,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14548',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2474,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2474,34.72,0.2,87.9,941,74.4,NULL,NULL,'UGC 00219',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000013,NULL,'15.5g',0.34,'Sdm:',NULL,NULL,NULL,NULL,1,5.737917,16.25311,0.077,NULL,66761349212,1043146081,16299157,15.5),(2475,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2475,35.13,0.4,106,942,NULL,NULL,NULL,'ESO 539- G 012',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15',0.5,'Sb',NULL,NULL,NULL,NULL,1,5.739,-22.11861,0.054,NULL,35307304483,551676632,8619947,15),(2476,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2476,35.17,0.2,108,942,74.4,NULL,NULL,'ESO 539- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2477,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2477,35.39,0.35,120,942,NULL,NULL,'Malmquist cor.','ESO 539- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2478,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2478,36.63,0.2,212,943,74.4,NULL,NULL,'CGCG 479-019',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000033,NULL,'15.6',0.5,'Sab',NULL,NULL,NULL,NULL,1,5.739375,25.21242,0.037,NULL,67238745383,1050605396,16415709,15.6),(2479,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2479,34.9,NULL,95.6,944,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 350- G 012',NULL,'2010Ap&SS.325..163P',2010,1,0.9,NULL,'G',0.00004,NULL,'17.17',0.11,'Sd',NULL,NULL,NULL,NULL,1,5.740125,-35.81717,NULL,NULL,34670654081,541728970,8464515,17.17),(2480,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2480,34.93,NULL,96.7,944,NULL,NULL,'Dipole + Quadrupole','ESO 350- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2481,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2481,34.94,NULL,97.4,944,NULL,NULL,'Dipole','ESO 350- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2482,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2482,34.97,NULL,98.8,944,NULL,NULL,NULL,'ESO 350- G 012',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2483,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2483,37.56,0.62,325,945,70,NULL,NULL,'2MASX J00225812-4232045',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.63',0.38,NULL,NULL,NULL,NULL,NULL,1,5.74225,-42.53458,NULL,NULL,38128075900,595751185,9308612,16.63),(2484,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 19434','R',2484,39.63,0.15,727,946,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19434',0.157646,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,5.751583,0.03664,0.069,NULL,66597166834,1040580731,16259073,NULL),(2485,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 19434','R',2485,39.75,0.22,770,946,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19434',0.157646,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2486,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2486,35.58,0.46,130,947,70,NULL,NULL,'2MASX J00230153-5650048',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000133,NULL,'15.2',1.2,'SA(s)0-',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,5.756333,-56.83475,0,NULL,36219188060,565924813,8842575,15.2),(2487,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2487,35.89,0.65,150,948,70,NULL,NULL,'2MASX J00230166-6350000',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.84',0.28,NULL,NULL,NULL,NULL,NULL,1,5.7567917,-63.83331,0,NULL,36048182126,563252845,8800825,16.84),(2488,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 06253','RN',2488,43.64,0.36,3150,949,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 06253',0.698404,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2489,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2489,38.01,0.46,399,950,70,NULL,NULL,'2MASX J00230279-0014581',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000086,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,5.76158333333,-0.24953,0.077,NULL,34397727900,537464498,8397882,17.6),(2490,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2490,34.67,NULL,86,951,NULL,NULL,NULL,'FGC 0040',NULL,'2000BSAO...50....5K',2000,1,0.71,NULL,'G',0.000019,NULL,'16.5',0.1,'Sdm',NULL,NULL,NULL,NULL,1,5.776667,20.97167,0.129,NULL,67455773470,1053996460,16468694,16.5),(2491,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2491,34.78,NULL,90.4,951,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0040',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2492,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2492,34.79,NULL,90.6,951,NULL,NULL,'Dipole + Quadrupole','FGC 0040',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2493,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2493,34.79,NULL,90.8,951,NULL,NULL,'Dipole','FGC 0040',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2494,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2494,35.56,0.47,129,952,70,NULL,NULL,'AM 0020-571',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'15.73',0.58,'S0',NULL,NULL,NULL,NULL,1,5.778125,-57.013,0,NULL,36220975999,565952749,8843011,15.73),(2495,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 18909','R',2495,40.49,0.19,1020,953,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2007lq','SDSS J002307.97+005900.1',0.23,'2014arXiv1401.3317S',2014,1,0.11,NULL,'G',NULL,NULL,'19.7g',0.09,NULL,NULL,NULL,NULL,NULL,1,5.78325,0.98336,0.029,NULL,66597925832,1040592591,16259259,19.7),(2496,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 18909','R',2496,40.61,0.11,1080,953,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2007lq','SDSS J002307.97+005900.1',0.23,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2497,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2007lq',NULL,2497,40.42,0.08,1210,953,70,NULL,'SALT 2','SDSS J002307.97+005900.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2498,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2007lq',NULL,2498,40.44,0.08,1220,953,70,NULL,'SALT 2, Malmquist cor.','SDSS J002307.97+005900.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2499,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2499,34.69,NULL,86.7,954,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00222',NULL,'2010Ap&SS.325..163P',2010,1,0.76,NULL,'G',0.00004,NULL,'18.0',0.1,'Scd',NULL,NULL,NULL,NULL,1,5.783417,35.14733,0.205,NULL,67130629208,1048916081,16389313,18),(2500,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2500,34.7,NULL,87.1,954,NULL,NULL,'Dipole + Quadrupole','UGC 00222',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2501,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2501,34.71,NULL,87.3,954,NULL,NULL,'Dipole','UGC 00222',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2502,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2502,34.76,NULL,89.6,954,NULL,NULL,NULL,'UGC 00222',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2503,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 16206','R',2503,39.13,0.2,578,955,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006pe','SDSS J002309.19-000312.8',0.16,'2014arXiv1401.3317S',2014,1,0.13,NULL,'G',NULL,NULL,'19.74',0.1,NULL,NULL,NULL,NULL,NULL,1,5.7882917,-0.05356,0.072,NULL,34397543903,537461623,8397837,19.74),(2504,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2006pe',NULL,2504,38.97,0.09,622,955,70,NULL,'SALT 2','SDSS J002309.19-000312.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2505,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2006pe',NULL,2505,38.98,0.09,625,955,70,NULL,'SALT 2, Malmquist cor.','SDSS J002309.19-000312.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2506,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 16206','R',2506,39.43,0.12,662,955,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006pe','SDSS J002309.19-000312.8',0.16,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2507,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2507,37.9,0.46,380,956,70,NULL,NULL,'2MASX J00230973-0036141',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000078,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,5.79054166667,-0.60394,0.074,NULL,34398415857,537475247,8398050,17.9),(2508,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 04229',NULL,2508,40.26,0.34,1130,957,70,NULL,'SN photometric redshift distance, z photo =0.309 +/- 0.066','SDSS-II SN 04229',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','23.1g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,5.793875,0.31372,0.025,NULL,66597383472,1040584116,16259126,23.1),(2509,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 01414','RN',2509,41.58,0.09,1460,958,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01414',0.421985,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2510,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 01414','RN',2510,41.59,0.18,1460,958,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01414',0.421985,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2511,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2511,37.45,0.15,309,959,70,NULL,NULL,'2MASX J00231268-0059121',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.10',0.19,NULL,NULL,NULL,NULL,NULL,1,5.8027917,-0.98675,0.064,NULL,34397967612,537468243,8397941,18.1),(2512,'SGRB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2512,42.51,1.7,3180,960,70,NULL,'Amati relation','GRB 050922B',NULL,'2012A&A...545A..77R',2012,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,5.80570833333,-5.60464,0.122,NULL,34582052309,540344567,8442883,NULL),(2513,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 05747',NULL,2513,41,0.32,1590,961,70,NULL,'SN photometric redshift distance, z photo =0.476 +/- 0.108','SDSS-II SN 05747',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,5.81925,0.67894,0.021,NULL,66598065092,1040594767,16259293,NULL),(2514,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 05747',NULL,2514,41.32,0.27,1840,961,70,NULL,'SALT 2','SDSS-II SN 05747',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2515,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 05747',NULL,2515,41.41,0.27,1910,961,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 05747',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2516,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 15947','RN',2516,41.73,0.32,1840,962,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15947',0.202286,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2517,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 15947','RN',2517,42.01,0.2,2100,962,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15947',0.202286,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2518,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 04452','RN',2518,42.31,0.27,2160,963,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 04452',0.341589,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2519,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 04452','RN',2519,42.64,0.28,2520,963,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04452',0.341589,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2520,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 01375','RN',2520,44.16,0.29,4420,964,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01375',0.533692,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2521,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2521,37.13,0.61,266,965,70,NULL,NULL,'2MASX J00232812-0414539',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,5.867167,-4.24836,0.104,NULL,34402243266,537535051,8398985,15.7),(2522,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 17517','RN',2522,42.13,0.14,2000,966,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 17517',0.33466,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2523,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 17517','RN',2523,42.13,0.22,2000,966,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17517',0.33466,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2524,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2524,37.45,0.46,309,967,70,NULL,NULL,'2MASX J00233544+0007594',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00006,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,5.89766666667,0.13317,0.057,NULL,66597400861,1040584388,16259131,17.6),(2525,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2525,37.69,0.33,346,968,70,NULL,NULL,'SDSS J002337.47-000859.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000081,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,5.90616666667,-0.14992,0.077,NULL,34397713320,537464270,8397879,18.3),(2526,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2526,37.45,0.15,309,969,70,NULL,NULL,'2MASX J00233797-0047029',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000088,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,5.9082917,-0.78417,0.064,NULL,34397947088,537467923,8397936,16.4),(2527,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2527,37.45,0.15,309,970,70,NULL,NULL,'2MASX J00233930-0047329',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.08',0.2,NULL,NULL,NULL,NULL,NULL,1,5.913667,-0.79242,0.064,NULL,34397946998,537467921,8397936,18.08),(2528,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 04048','RN',2528,42.39,0.25,2090,971,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 04048',0.434924,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2529,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 04048','RN',2529,42.39,0.3,2090,971,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 04048',0.434924,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2530,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2530,37.69,0.33,346,972,70,NULL,NULL,'MCG +00-02-017',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000106,NULL,'15.6g',0.57,'E0',NULL,NULL,NULL,NULL,1,5.916167,-0.12086,0.124,NULL,34397716439,537464319,8397879,15.6),(2531,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2531,37.95,0.46,389,973,70,NULL,NULL,'2MASX J00234216+1505236',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000169,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,5.925583,15.08981,0.121,NULL,66763234464,1043175538,16299617,17.6),(2532,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2532,37.45,0.15,309,974,70,NULL,NULL,'2MASX J00234310-0048549',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000099,NULL,'16.9g',0.25,'NLAGN',NULL,NULL,NULL,NULL,1,5.929583,-0.81514,0.064,NULL,34397961410,537468147,8397939,16.9),(2533,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2533,36.73,0.59,222,975,70,NULL,NULL,'2MASX J00234364-2100579',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.34',0.33,NULL,NULL,NULL,NULL,NULL,1,5.931875,-21.01608,0.014,NULL,35305491138,551648299,8619504,16.34),(2534,'Horizontal Branch','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2534,24.41,0.12,0.762,976,NULL,NULL,NULL,'Andromeda XXVI',NULL,'2011ApJ...732...76R',2011,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,5.94,47.91611,0.481,0,65773444338,1027710067,16057969,NULL),(2535,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2535,24.39,0.55,0.754,976,NULL,NULL,NULL,'Andromeda XXVI',NULL,'2012ApJ...758...11C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2536,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2536,25.21,NULL,1.1,976,NULL,NULL,NULL,'Andromeda XXVI',NULL,'2013ApJ...768..172C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2537,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2537,35.27,0.46,113,977,70,NULL,NULL,'2MASX J00234783+1539576',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'16.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,5.949417,15.66606,0.093,NULL,66764145653,1043189775,16299840,16.4),(2538,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2538,34.05,0.2,64.6,978,74.4,NULL,NULL,'UGC 00226',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.00001,NULL,'14.81',0.6,'Sb',NULL,NULL,NULL,NULL,1,5.95075,14.68408,0.129,NULL,66745164815,1042893200,16295206,14.81),(2539,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 13106','RN',2539,39.68,0.13,782,979,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13106',0.106187,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2540,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 13106','RN',2540,39.91,0.23,868,979,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13106',0.106187,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2541,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 16219','RN',2541,40.6,0.25,1050,980,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16219',0.258864,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2542,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 16219','RN',2542,40.84,0.2,1170,980,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16219',0.258864,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2543,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 17067','RN',2543,42.53,0.41,2330,981,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 17067',0.374316,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2544,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 17067','RN',2544,42.92,0.31,2790,981,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 17067',0.374316,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2545,'CMD','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2545,28.22,NULL,4.41,982,NULL,NULL,NULL,'LEDA 3097727',NULL,'2012ApJ...748...47M',2012,1,0.9,NULL,'G',NULL,NULL,'16.94',0.7,'dE',NULL,NULL,NULL,NULL,1,5.965417,-24.705,0.083,NULL,34820401412,544068772,8501074,16.94),(2546,'SBF','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2546,27.13,0.12,2.67,982,NULL,NULL,NULL,'LEDA 3097727',NULL,'1998AJ....116.2873J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2547,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2547,28.11,NULL,4.19,982,NULL,NULL,NULL,'LEDA 3097727',NULL,'2010ApJ...724.1030G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2548,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2548,28.11,0.05,4.19,982,NULL,NULL,'I','LEDA 3097727',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2549,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2549,28.12,NULL,4.21,982,NULL,NULL,NULL,'LEDA 3097727',NULL,'2003A&A...404...93K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2550,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2550,28.13,0.06,4.23,982,NULL,NULL,NULL,'LEDA 3097727',NULL,'2013A&A...550A...7L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2551,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2551,28.17,0.12,4.3,982,NULL,NULL,'GC 1','LEDA 3097727',NULL,'2009AJ....137.4361D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2552,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2552,37.12,0.57,266,983,70,NULL,NULL,'2MASX J00235272-1241042',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'17.05',0.34,NULL,NULL,NULL,NULL,NULL,1,5.969625,-12.68475,0.033,NULL,34448093779,538251465,8410179,17.05),(2553,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2553,34.91,0.8,96.1,984,75,NULL,'HMCL, I','UGC 00229',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000013,NULL,'15.16',0.5,'Sb','Isolated galaxy',NULL,NULL,NULL,1,5.97266666667,28.33306,0.121,NULL,67226640123,1050416251,16412753,15.16),(2554,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2554,34.91,0.8,96.1,984,75,NULL,'W91PP, r','UGC 00229',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2555,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2555,34.92,0.8,96.3,984,75,NULL,'CF, r','UGC 00229',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2556,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2556,34.91,0.38,95.9,984,75,NULL,'CF, r, raw','UGC 00229',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2557,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2557,34.96,0.38,98.3,984,75,NULL,'CF, r, inv','UGC 00229',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2558,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2558,35.05,0.38,102,984,75,NULL,'W91PP, r, raw','UGC 00229',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2559,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2559,35.09,0.38,104,984,75,NULL,'CF, r, cor','UGC 00229',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2560,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2560,35.11,0.38,105,984,75,NULL,'W91PP, r, inv','UGC 00229',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2561,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2561,35.13,0.4,106,984,75,NULL,'HMCL, I, raw','UGC 00229',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2562,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2562,35.24,0.38,112,984,75,NULL,'W91PP, r, cor','UGC 00229',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2563,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2563,35.25,0.4,112,984,75,NULL,'HMCL, I, inv','UGC 00229',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2564,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2564,35.35,0.4,118,984,75,NULL,'HMCL, I, cor','UGC 00229',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2565,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2565,37.45,0.15,309,985,70,NULL,NULL,'2MASX J00235423-0043291',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000106,NULL,'15.9g',0.41,'BrClG',NULL,NULL,NULL,NULL,1,5.975833,-0.72486,0.053,NULL,34397946054,537467907,8397936,15.9),(2566,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 14845',NULL,2566,40.31,0.19,1150,986,70,NULL,'SN photometric redshift distance, z photo =0.318 +/- 0.035','SDSS-II SN 14845',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','21.2g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,5.976875,0.08239,0.057,NULL,66597389348,1040584208,16259128,21.2),(2567,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 14845','R',2567,41.12,0.32,1230,986,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14845',0.358926,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2568,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 14845','R',2568,41.26,0.36,1320,986,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14845',0.358926,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2569,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2569,37.71,0.46,349,987,70,NULL,NULL,'SDSS J002355.72+141024.4',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000155,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,5.98220833333,14.17344,0.137,NULL,66750253838,1042972716,16296448,18.7),(2570,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2570,34.39,0.8,75.4,988,75,NULL,'W91PP, r','UGC 00228',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000033,NULL,'14.68',0.6,'Sbc',NULL,NULL,NULL,NULL,1,5.986333,24.30569,0.053,NULL,67235717212,1050558081,16414970,14.68),(2571,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2571,34.47,0.38,78.3,988,75,NULL,'W91PP, r, raw','UGC 00228',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2572,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2572,34.59,0.38,82.7,988,75,NULL,'W91PP, r, inv','UGC 00228',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2573,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2573,34.65,0.38,85.1,988,75,NULL,'W91PP, r, cor','UGC 00228',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2574,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2574,34.66,0.2,85.5,988,74.4,NULL,NULL,'UGC 00228',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2575,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2575,34.74,0.41,88.9,988,NULL,NULL,'Malmquist cor.','UGC 00228',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2576,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2576,34.76,0.4,89.5,988,NULL,NULL,NULL,'UGC 00228',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2577,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 19339',NULL,2577,37.66,2.94,341,989,70,NULL,'SN photometric redshift distance, z photo =0.083 +/- 0.293','SDSS-II SN 19339',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,5.9942917,0.31236,0.021,NULL,66597241215,1040581893,16259092,NULL),(2578,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2578,35.84,0.69,147,990,70,NULL,NULL,'2MASX J00240028-0802064',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.000103,NULL,'16.50',0.37,NULL,NULL,NULL,NULL,NULL,1,6.0012083,-8.03519,0.091,NULL,34612704037,540823500,8450367,16.5),(2579,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2579,35.22,0.2,111,991,74.4,NULL,NULL,'CGCG 479-024 NED01',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00003,NULL,'15.5',0.4,NULL,NULL,NULL,NULL,NULL,1,6.009625,25.66247,0.065,NULL,67236757486,1050574335,16415223,15.5),(2580,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2580,30.43,0.8,12.2,992,75,NULL,'A82, H','NGC 0100',NULL,'1997ApJS..109..333W',1997,1,6.16,'HOLM 009B is a star.','G',0.000003,NULL,'13.91',0.64,'Sc','Erroneous pair member',NULL,NULL,NULL,1,6.01183333333,16.48639,0.089,NULL,66744036888,1042875576,16294930,13.91),(2581,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2581,30.49,0.4,12.5,992,75,NULL,'B','NGC 0100',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2582,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2582,30.76,NULL,14.2,992,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 0100',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2583,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2583,30.77,NULL,14.2,992,NULL,NULL,'Dipole','NGC 0100',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2584,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2584,30.77,NULL,14.3,992,NULL,NULL,'Dipole + Quadrupole','NGC 0100',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2585,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2585,30.87,NULL,14.9,992,NULL,NULL,NULL,'NGC 0100',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2586,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2586,31.19,0.47,17.3,992,75,NULL,'A82, H, inv','NGC 0100',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2587,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2587,31.21,0.35,17.5,992,NULL,NULL,NULL,'NGC 0100',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2588,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2588,31.27,0.47,17.9,992,75,NULL,'A82, H, raw','NGC 0100',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2589,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2589,31.33,0.2,18.5,992,74.4,NULL,NULL,'NGC 0100',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2590,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2590,31.4,0.43,19.1,992,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0100',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2591,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2591,31.42,0.43,19.2,992,75,NULL,'3.6 micron, color corrected','NGC 0100',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2592,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2592,31.47,0.39,19.7,992,73,NULL,'opt','NGC 0100',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2593,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2593,31.51,0.52,20,992,NULL,NULL,NULL,'NGC 0100',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2594,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2594,31.57,0.51,20.6,992,NULL,NULL,'Malmquist cor.','NGC 0100',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2595,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2595,31.62,0.47,21.1,992,75,NULL,'A82, H, cor','NGC 0100',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2596,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 05917','R',2596,40.72,0.21,1070,993,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05917',0.296412,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,6.036833,-0.25514,0.124,NULL,34397666009,537463531,8397867,NULL),(2597,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 05917',NULL,2597,40.26,0.19,1130,993,70,NULL,'SN photometric redshift distance, z photo =0.309 +/- 0.034','SDSS-II SN 05917',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2598,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 05917','R',2598,40.85,0.13,1140,993,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 05917',0.296412,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2599,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 05917',NULL,2599,40.63,0.1,1340,993,70,NULL,'SALT 2','SDSS-II SN 05917',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2600,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 05917',NULL,2600,40.66,0.1,1360,993,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 05917',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2601,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 18771','R',2601,41.58,0.15,1650,994,70,NULL,'SDSS CAND. SNII; MLCS2K2','SN 2007oe',0.251,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'IIn',NULL,NULL,NULL,NULL,1,6.043083,0.77506,0.009,NULL,66597863094,1040591610,16259243,NULL),(2602,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 18771','R',2602,41.92,0.22,1940,994,70,NULL,'SDSS CAND. SNII; SALT 2','SN 2007oe',0.251,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2603,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2603,37.45,0.15,309,995,70,NULL,NULL,'2MASX J00241084-0101131',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'16.94',0.26,'poss. LINER',NULL,NULL,NULL,NULL,1,6.04525,-1.02033,0.061,NULL,34401308086,537520438,8398756,16.94),(2604,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 07348','RN',2604,42.21,0.23,1680,996,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 07348',0.64194,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2605,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2006hp',NULL,2605,39.85,0.08,933,997,70,NULL,'Hubble residual 0.00 for z0.24770','SDSS J002414.24-001457.2',NULL,'2011ApJ...740...92G',2011,1,0.12,NULL,'G',0.0005,NULL,'19.7g',0.08,NULL,NULL,NULL,NULL,NULL,1,6.059375,-0.24925,0.124,NULL,34397666215,537463534,8397867,19.7),(2606,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 13835','R',2606,40.42,0.19,971,997,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006hp','SDSS J002414.24-001457.2',0.2477,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2607,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2006hp',NULL,2607,40.64,0.16,1070,997,72,NULL,'SDSS 13835','SDSS J002414.24-001457.2',0.25,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2608,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 13835','R',2608,40.64,0.11,1080,997,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006hp','SDSS J002414.24-001457.2',0.2477,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2609,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2006hp',NULL,2609,40.37,0.08,1190,997,70,NULL,'SALT 2','SDSS J002414.24-001457.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2610,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2006hp',NULL,2610,40.38,0.08,1190,997,70,NULL,'SALT 2, Malmquist cor.','SDSS J002414.24-001457.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2611,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 19501','RN',2611,39.63,0.18,736,998,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19501',0.143658,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2612,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 19501','RN',2612,39.77,0.22,787,998,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19501',0.143658,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2613,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2613,35.08,0.48,104,999,70,NULL,NULL,'MCG -02-02-010',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.000107,NULL,'15.18',0.3,NULL,NULL,NULL,NULL,NULL,1,6.084917,-14.23225,0.056,NULL,34456215008,538378359,8412161,15.18),(2614,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2614,34.46,0.4,77.9,1000,NULL,NULL,'mean','ESO 242- G 007',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00002,NULL,'14.94',0.2,'S...',NULL,NULL,NULL,NULL,1,6.0912917,-45.5075,NULL,NULL,38134054516,595844601,9310071,14.94),(2615,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2615,34.78,0.49,90.4,1000,75,NULL,'IR','ESO 242- G 007',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2616,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2616,34.85,0.47,93.2,1000,NULL,NULL,'H','ESO 242- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2617,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2617,37.45,0.15,309,1001,70,NULL,NULL,'2MASX J00242351-0100337',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000075,NULL,'16.9g',0.38,NULL,NULL,NULL,NULL,NULL,1,6.09808333333,-1.00944,0.057,NULL,34401320887,537520638,8398759,16.9),(2618,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 15232','RN',2618,42.4,0.49,1780,1002,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 15232',0.694397,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2619,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2619,36,0.52,159,1003,70,NULL,NULL,'2MASX J00242524-1414569',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'17.36',0.19,NULL,NULL,NULL,NULL,NULL,1,6.10525,-14.24906,0.056,NULL,34454118629,538345603,8411650,17.36),(2620,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 01415','R',2620,39.8,0.14,754,1004,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J002425.55+003556.5',0.211988,'2014arXiv1401.3317S',2014,1,0.19,NULL,'G',0.000115,NULL,'18.9g',0.11,NULL,NULL,NULL,NULL,NULL,1,6.1065,0.59903,0.009,NULL,66597968702,1040593260,16259269,18.9),(2621,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 01415','R',2621,39.94,0.22,801,1004,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J002425.55+003556.5',0.211988,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2622,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 01415',NULL,2622,39.77,0.11,899,1004,70,NULL,'SALT 2','SDSS J002425.55+003556.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2623,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 01415',NULL,2623,39.79,0.11,908,1004,70,NULL,'SALT 2, Malmquist cor.','SDSS J002425.55+003556.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2624,'GRB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2624,38.97,0.62,622,1005,71,NULL,'pseudo-redshift z = 0.16 +/- 0.06','GRB 041219',NULL,'2011MNRAS.413.2173G',2011,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'INTEGRAL',NULL,NULL,NULL,NULL,1,6.1142917,62.839,NULL,NULL,65962463900,1030663498,16104117,NULL),(2625,'GRB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2625,40.23,1.59,1110,1005,71,NULL,'pseudo-redshift z = 0.31 +0.54 -0.26','GRB 041219',NULL,'2011MNRAS.413.2173G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2626,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 18893',NULL,2626,39.37,0.48,748,1006,70,NULL,'SN photometric redshift distance, z photo =0.193 +/- 0.055','SDSS-II SN 18893',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,6.1194583,-1.13997,0.061,NULL,34401412381,537522068,8398782,NULL),(2627,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2627,37.45,0.15,309,1007,70,NULL,NULL,'2MASX J00242957-0055497',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.0001,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,6.123375,-0.93044,0.053,NULL,34401316394,537520568,8398758,16.9),(2628,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2628,37.21,0.46,276,1008,70,NULL,NULL,'2MASX J00243069+1457551',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,6.1277917,14.96533,0.113,NULL,66745655449,1042900866,16295326,17.4),(2629,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2629,35.78,0.46,143,1009,70,NULL,NULL,'2MASX J00243117-0055227',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000069,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,6.129875,-0.92286,0.053,NULL,34401313258,537520519,8398758,16.3),(2630,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2630,37.45,0.15,309,1010,70,NULL,NULL,'SDSS J002431.33-005955.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000086,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,6.130583,-0.99864,0.057,NULL,34401317491,537520585,8398759,18.3),(2631,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 13136','R',2631,41.8,0.28,1670,1011,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006go','SN 2006go',0.372057,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,6.140667,-0.27908,0.07,NULL,34398367897,537474498,8398039,NULL),(2632,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 13136','R',2632,41.91,0.23,1760,1011,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006go','SN 2006go',0.372057,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2633,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 20683','RN',2633,44.22,0.35,5080,1012,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 20683',0.37483,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2634,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 20683','RN',2634,44.38,0.47,5470,1012,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 20683',0.37483,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2635,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2635,37.05,0.62,257,1013,70,NULL,NULL,'MCG -02-02-012',NULL,'2014MNRAS.445.2677S',2014,1,1.7,'Maurogordato et al. (1991A&A...246...39M) give v = 5210 +/- 100 km/sec.','G',0.00015,NULL,'16',0.4,'Sbc',NULL,NULL,NULL,NULL,1,6.1520417,-11.49669,0.101,NULL,34448033734,538250527,8410164,16),(2636,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2636,35.09,0.47,104,1014,70,NULL,NULL,'NGC 0102',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000073,NULL,'14.00',0.9,'S0-a',NULL,NULL,NULL,NULL,1,6.1522083,-13.95636,0.056,NULL,34448896692,538264010,8410375,14),(2637,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 05691','R',2637,40.18,0.22,843,1015,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 05691',0.285848,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',NULL,'PHOT','20.4g',0.07,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,6.1522917,-0.16831,0.124,NULL,34397671441,537463616,8397869,20.4),(2638,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 05691','R',2638,40.42,0.29,944,1015,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05691',0.285848,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2639,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 05691',NULL,2639,39.98,0.59,992,1015,70,NULL,'SN photometric redshift distance, z photo =0.266 +/- 0.102','SDSS-II SN 05691',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2640,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 13897',NULL,2640,39.77,0.17,901,1016,70,NULL,'SN photometric redshift distance, z photo =0.238 +/- 0.023','SDSS-II SN 13897',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','19.7g',0.08,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,6.156375,-0.02606,0.124,NULL,34397622719,537462854,8397857,19.7),(2641,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 13897','R',2641,40.41,0.22,979,1016,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13897',0.231818,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2642,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 13897','R',2642,40.42,0.15,987,1016,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13897',0.231818,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2643,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2643,34.15,0.4,67.6,1017,NULL,NULL,'mean','UGC 00232',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.00003,NULL,'14.55',0.8,'SB(r)a',NULL,NULL,NULL,NULL,1,6.16120833333,33.25617,0.165,NULL,67355357245,1052427456,16444179,14.55),(2644,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2644,34.34,0.47,73.7,1017,NULL,NULL,'H','UGC 00232',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2645,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2645,34.43,0.45,77,1017,NULL,NULL,'K','UGC 00232',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2646,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2646,34.49,0.46,79,1017,NULL,NULL,'J','UGC 00232',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2647,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2647,36.02,0.46,160,1018,70,NULL,NULL,'KUG 0022-007',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000061,NULL,'16.6g',0.37,NULL,NULL,NULL,NULL,NULL,1,6.169667,-0.50556,0.07,NULL,34398512065,537476751,8398074,16.6),(2648,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2648,33.93,0.48,61.1,1019,70,NULL,NULL,'NGC 0106',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00014,NULL,'14.48',0.6,'Sa? pec',NULL,NULL,NULL,NULL,1,6.1822917,-5.14875,0.134,NULL,34582192525,540346758,8442918,14.48),(2649,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 15950','R',2649,39.96,0.22,803,1020,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J002445.30+005902.6',0.2204,'2014arXiv1401.3317S',2014,1,0.23,NULL,'G',0.0001,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,6.18879166667,0.98406,0.037,NULL,66600682867,1040635669,16259932,18.1),(2650,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 15950','R',2650,40.07,0.17,848,1020,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J002445.30+005902.6',0.2204,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2651,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 15950',NULL,2651,39.71,0.12,875,1020,70,NULL,'SALT 2','SDSS J002445.30+005902.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2652,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 15950',NULL,2652,39.72,0.12,879,1020,70,NULL,'SALT 2, Malmquist cor.','SDSS J002445.30+005902.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2653,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2653,33.85,0.8,58.8,1021,75,NULL,'W91PP, r','UGC 00234',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'15.34',0.5,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,6.193917,29.56053,0.221,NULL,67348073018,1052313640,16442400,15.34),(2654,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2654,33.84,0.2,58.6,1021,74.4,NULL,NULL,'UGC 00234',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2655,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2655,33.95,0.3,61.7,1021,NULL,NULL,NULL,'UGC 00234',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2656,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2656,34.11,0.38,66.3,1021,75,NULL,'W91PP, r, inv','UGC 00234',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2657,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2657,34.14,0.38,67.3,1021,75,NULL,'W91PP, r, raw','UGC 00234',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2658,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2658,34.25,0.26,70.7,1021,NULL,NULL,'Malmquist cor.','UGC 00234',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2659,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2659,34.32,0.38,73.2,1021,75,NULL,'W91PP, r, cor','UGC 00234',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2660,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2660,36.87,0.65,236,1022,70,NULL,NULL,'ESO 539- G 013 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'16.32',0.35,'E','in a pair',NULL,NULL,NULL,1,6.1962917,-20.73208,0.023,NULL,35304660782,551635324,8619301,16.32),(2661,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2661,38.87,0.46,594,1023,70,NULL,NULL,'2MASX J00245142+1412371',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000167,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,6.21433333333,14.21028,0.141,NULL,66752395742,1043006183,16296971,18.7),(2662,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2662,37.96,0.46,390,1024,70,NULL,NULL,'2MASX J00245471+0003393',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000107,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,6.227833,0.061,0.084,NULL,66597239474,1040581866,16259091,17),(2663,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2663,37.11,0.46,265,1025,70,NULL,NULL,'2MASX J00245541+1608148',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000789,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,6.2310417,16.1375,0.101,NULL,66744391989,1042881124,16295017,17.7),(2664,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2664,36.89,0.6,239,1026,70,NULL,NULL,'ESO 539- G 013 NED03',NULL,'2014MNRAS.445.2677S',2014,1,0.1,NULL,'G',0.00015,NULL,'16',0.1,'E','in a pair',NULL,NULL,NULL,1,6.2332083,-20.73128,0.023,NULL,35304658221,551635284,8619301,16),(2665,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 09239',NULL,2665,40.89,0.29,1510,1027,70,NULL,'SN photometric redshift distance, z photo =0.445 +/- 0.086','SDSS-II SN 09239',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,6.233625,-1.052,0.057,NULL,34401331069,537520797,8398762,NULL),(2666,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 07699',NULL,2666,39.18,1.47,685,1028,70,NULL,'SN photometric redshift distance, z photo =0.175 +/- 0.209','SDSS-II SN 07699',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,6.238667,-1.21578,0.057,NULL,34401244963,537519452,8398741,NULL),(2667,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 07699','R',2667,42,0.26,1780,1028,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07699',0.406559,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2668,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 07699','R',2668,42.12,0.21,1880,1028,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07699',0.406559,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2669,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 07699',NULL,2669,41.94,0.15,2440,1028,70,NULL,'SALT 2','SDSS-II SN 07699',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2670,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 07699',NULL,2670,42.01,0.15,2520,1028,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 07699',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2671,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2671,36.24,0.63,177,1029,70,NULL,NULL,'AM 0022-422',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'14.81',0.26,'INTERACTING',NULL,NULL,NULL,NULL,1,6.249125,-42.20928,NULL,NULL,38129993063,595781141,9309080,14.81),(2672,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 15988','RN',2672,41.29,0.25,1330,1030,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15988',0.361309,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2673,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 15988','RN',2673,41.6,0.36,1530,1030,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15988',0.361309,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2674,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 15988','N',2674,41.51,0.22,2000,1030,70,NULL,'SALT 2','SDSS-II SN 15988',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2675,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 15988','N',2675,41.56,0.22,2050,1030,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15988',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2676,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2676,34.8,0.8,91.1,1031,75,NULL,'W91PP, r','UGC 00238',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000043,NULL,'14.27',0.5,'Sc             LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,6.2639583,31.34478,0.181,NULL,67349810546,1052340789,16442824,14.27),(2677,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2677,34.8,0.8,91.1,1031,75,NULL,'HMCL, I','UGC 00238',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2678,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2678,34.13,0.4,67.1,1031,75,NULL,'HMCL, I, raw','UGC 00238',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2679,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2679,34.14,0.38,67.4,1031,75,NULL,'W91PP, r, raw','UGC 00238',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2680,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2680,34.23,0.2,70.2,1031,74.4,NULL,NULL,'UGC 00238',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2681,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2681,34.28,0.29,71.8,1031,NULL,NULL,NULL,'UGC 00238',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2682,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2682,34.31,0.38,72.6,1031,75,NULL,'W91PP, r, inv','UGC 00238',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2683,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2683,34.31,0.4,72.9,1031,75,NULL,'HMCL, I, inv','UGC 00238',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2684,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2684,34.32,0.29,73.1,1031,NULL,NULL,'Malmquist cor.','UGC 00238',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2685,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2685,34.32,0.38,73.1,1031,75,NULL,'W91PP, r, cor','UGC 00238',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2686,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2686,34.33,0.4,73.4,1031,75,NULL,'HMCL, I, cor','UGC 00238',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2687,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2687,34.73,0.47,88.1,1031,NULL,NULL,'H','UGC 00238',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2688,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2688,34.83,0.45,92.5,1031,NULL,NULL,'K','UGC 00238',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2689,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2689,34.87,0.46,94.2,1031,NULL,NULL,'J','UGC 00238',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2690,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2690,35,0.4,99.9,1031,NULL,NULL,'mean','UGC 00238',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2691,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2691,37.24,0.46,281,1032,70,NULL,NULL,'2MASX J00250704+0114211',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000092,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,6.279375,1.23933,0.025,NULL,66600753593,1040636774,16259949,16.5),(2692,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2692,34.57,0.38,82.1,1033,NULL,NULL,'Malmquist cor.','UGC 00240',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.00008,NULL,'14.33',0.5,'SAB(rs)b',NULL,NULL,NULL,NULL,1,6.292125,6.49089,0.065,NULL,66824313972,1044129905,16314529,14.33),(2693,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2693,34.67,0.69,85.9,1033,100,NULL,'mid-IR','UGC 00240',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2694,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2694,34.75,0.35,89.2,1033,NULL,NULL,NULL,'UGC 00240',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2695,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2695,34.91,0.2,95.9,1033,74.4,NULL,NULL,'UGC 00240',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2696,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2696,35.91,0.46,152,1034,70,NULL,NULL,'2MASX J00251366+1554208',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000146,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,6.3069583,15.90578,0.105,NULL,66744429370,1042881708,16295026,17.3),(2697,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 18049','R',2697,40.95,0.19,1200,1035,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J002514.54-002203.0',0.2886,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,'PHOT','21.4g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,6.310625,-0.36753,0.07,NULL,34398503078,537476610,8398072,21.4),(2698,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 18049','R',2698,40.99,0.26,1220,1035,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J002514.54-002203.0',0.2886,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2699,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 18049',NULL,2699,40.97,0.16,1560,1035,70,NULL,'SALT 2','SDSS J002514.54-002203.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2700,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 18049',NULL,2700,41,0.16,1580,1035,70,NULL,'SALT 2, Malmquist cor.','SDSS J002514.54-002203.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2701,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 1997cw',NULL,2701,33.42,0.25,47.5,1036,74.2,NULL,'SALT 2','NGC 0105',0.01765,'2010ApJ...716..712A',2010,1,NULL,NULL,'GPair',0.000087,NULL,NULL,NULL,'Sab:',NULL,NULL,NULL,NULL,1,6.31916666667,12.88944,0.169,NULL,66750626896,1042978545,16296539,NULL),(2702,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 1997cw',NULL,2702,33.82,0.09,58.1,1036,74.4,NULL,NULL,'NGC 0105',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2703,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 1997cw',NULL,2703,33.86,0.06,58.2,1036,72,NULL,NULL,'NGC 0105',0.01765,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2704,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 1997cw',NULL,2704,34.08,0.15,63.1,1036,65,NULL,'MLCS2k2','NGC 0105',0.01765,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2705,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 1997cw',NULL,2705,34.04,0.3,64.3,1036,60,NULL,NULL,'NGC 0105',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2706,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2007A',NULL,2706,34.33,0.16,71.1,1036,72,NULL,NULL,'NGC 0105',0.01648,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2707,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2007A',NULL,2707,34.27,0.05,71.6,1036,72,NULL,'M(H) = -18.317 mag','NGC 0105',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2708,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 1997cw',NULL,2708,34.39,0.17,75.5,1036,70.8,NULL,NULL,'NGC 0105',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2709,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 1997cw',NULL,2709,34.46,0.14,76.6,1036,70,NULL,'SALT','NGC 0105',0.01765,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2710,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2007A',NULL,2710,34.54,0.24,79.6,1036,73.8,NULL,'SALT 2 (SNANA)','NGC 0105',0.0166,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2711,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2007A',NULL,2711,34.58,0.31,80.9,1036,73.8,NULL,'SALT 2 (SNANA)','NGC 0105',0.0167,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2712,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2712,36.81,0.57,230,1037,70,NULL,NULL,'2MASX J00251747-1610102',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.33',0.23,NULL,NULL,NULL,NULL,NULL,1,6.323,-16.16953,0.046,NULL,34452909454,538326710,8411354,16.33),(2713,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 04272','RN',2713,43.76,0.25,3360,1038,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04272',0.682547,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2714,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2714,34.73,1.24,88.2,1039,NULL,NULL,'Malmquist cor.','CGCG 409-012',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',NULL,NULL,'15.7',0.25,NULL,NULL,NULL,NULL,NULL,1,6.354,6.70642,0.065,NULL,66827155959,1044174311,16315223,15.7),(2715,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2715,34.74,1.24,88.9,1039,NULL,NULL,NULL,'CGCG 409-012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2716,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2716,34.78,0.2,90.4,1039,74.4,NULL,NULL,'CGCG 409-012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2717,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2717,35.18,0.4,108,1040,NULL,NULL,NULL,'ESO 294- G 009',NULL,'2009ApJS..182..474S',2009,1,1.02,NULL,'G',0.000033,NULL,'16.30',0.23,'S...',NULL,NULL,NULL,NULL,1,6.35475,-41.60242,NULL,NULL,38126491092,595726423,9308225,16.3),(2718,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2718,35.22,0.2,111,1040,74.4,NULL,NULL,'ESO 294- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2719,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2719,35.28,0.39,114,1040,NULL,NULL,'Malmquist cor.','ESO 294- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2720,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2007kr',NULL,2720,40,0.13,999,1041,70,NULL,'Hubble residual -0.09 for z0.28200','SDSS J002527.58-005021.6',NULL,'2011ApJ...740...92G',2011,1,0.07,NULL,'G',0.005,NULL,'21.4g',0.04,NULL,NULL,NULL,NULL,NULL,1,6.3649583,-0.83933,0.036,NULL,34401423716,537522245,8398785,21.4),(2721,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 17809','R',2721,40.81,0.13,1130,1041,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007kr','SDSS J002527.58-005021.6',0.282,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2722,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 17809','R',2722,40.87,0.22,1160,1041,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007kr','SDSS J002527.58-005021.6',0.282,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2723,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2007kr',NULL,2723,40.76,0.11,1420,1041,70,NULL,'SALT 2','SDSS J002527.58-005021.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2724,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SN 2007kr',NULL,2724,40.79,0.11,1440,1041,70,NULL,'SALT 2, Malmquist cor.','SDSS J002527.58-005021.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2725,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2725,33.75,0.47,56.3,1042,NULL,NULL,'H','UGC 00242',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000017,NULL,'13.85',1.4,'SABd',NULL,NULL,NULL,NULL,1,6.36975,20.23775,0.113,NULL,67499998048,1054687469,16479491,13.85),(2726,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2726,33.79,0.46,57.3,1042,NULL,NULL,'J','UGC 00242',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2727,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2727,33.81,0.45,57.8,1042,NULL,NULL,'K','UGC 00242',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2728,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2728,33.87,0.4,59.4,1042,NULL,NULL,'mean','UGC 00242',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2729,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2729,34.33,0.4,73.4,1043,NULL,NULL,'mean','UGC 00243',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000073,NULL,'14.68',0.5,'Sb',NULL,NULL,NULL,NULL,1,6.37475,45.92172,0.321,NULL,67659903106,1057185986,16518531,14.68),(2730,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2730,34.34,0.45,74,1043,NULL,NULL,'K','UGC 00243',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2731,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2731,34.36,0.47,74.3,1043,NULL,NULL,'H','UGC 00243',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2732,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2732,34.46,0.46,77.9,1043,NULL,NULL,'J','UGC 00243',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2733,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2733,34.54,0.49,81,1043,75,NULL,'IR','UGC 00243',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2734,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2734,33.76,0.8,56.6,1044,75,NULL,'W91PP, r','UGC 00244',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000083,NULL,'14.85',0.5,'SBbc?',NULL,NULL,NULL,NULL,1,6.37516666667,24.81133,0.033,NULL,67238428037,1050600438,16415631,14.85),(2735,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2735,33.72,0.2,55.5,1044,74.4,NULL,NULL,'UGC 00244',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2736,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2736,33.87,0.35,59.3,1044,NULL,NULL,NULL,'UGC 00244',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2737,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2737,34.03,0.38,63.9,1044,75,NULL,'W91PP, r, raw','UGC 00244',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2738,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2738,34.04,0.38,64.4,1044,75,NULL,'W91PP, r, inv','UGC 00244',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2739,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2739,34.2,0.3,69.2,1044,NULL,NULL,'Malmquist cor.','UGC 00244',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2740,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2740,34.21,0.38,69.5,1044,75,NULL,'W91PP, r, cor','UGC 00244',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2741,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 18324','R',2741,40.56,0.26,1020,1045,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18324',0.266984,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,6.381,0.79375,0.005,NULL,66601106944,1040642296,16260035,NULL),(2742,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 18324',NULL,2742,40.1,0.28,1050,1045,70,NULL,'SN photometric redshift distance, z photo =0.283 +/- 0.047','SDSS-II SN 18324',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2743,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 18324','R',2743,40.71,0.24,1090,1045,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18324',0.266984,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2744,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 18324',NULL,2744,40.42,0.17,1210,1045,70,NULL,'SALT 2','SDSS-II SN 18324',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2745,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 18324',NULL,2745,40.44,0.17,1220,1045,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18324',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2746,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2746,35.43,0.52,122,1046,70,NULL,NULL,'2MASX J00253231-6216080',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.000133,NULL,'15.14',0.67,'E',NULL,NULL,NULL,NULL,1,6.38458333333,-62.26889,0,NULL,36094840614,563981884,8812216,15.14),(2747,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 15757','RN',2747,38.79,0.08,534,1047,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 15757',0.070652,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2748,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 15757','RN',2748,39.31,0.2,680,1047,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 15757',0.070652,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2749,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2749,36.81,0.46,230,1048,70,NULL,NULL,'2MASX J00253728-0914470',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000083,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,6.405333,-9.24631,0.159,NULL,34618484535,540913820,8451778,17.2),(2750,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2750,36.16,0.46,170,1049,70,NULL,NULL,'2MASX J00253771+0002119',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000201,NULL,'15.3g',0.49,'E0',NULL,NULL,NULL,NULL,1,6.407083,0.03675,0.084,NULL,66597566922,1040586983,16259171,15.3),(2751,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2751,37.92,0.46,384,1050,70,NULL,NULL,'2MASX J00253911-0017140',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000085,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,6.4130417,-0.28714,0.059,NULL,34398210904,537472045,8398000,17.3),(2752,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2752,37.06,0.46,258,1051,70,NULL,NULL,'2MASX J00254144-0022290',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000068,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,6.42266666667,-0.37481,0.059,NULL,34398185358,537471646,8397994,17.1),(2753,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 02666','RN',2753,39.34,0.21,698,1052,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 02666',0.058135,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2754,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 02666','RN',2754,39.95,0.31,924,1052,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 02666',0.058135,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2755,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2755,33.83,0.49,58.3,1053,75,NULL,'IR','MCG -01-02-011',NULL,'2011yCatp016004901K',2011,1,2.46,NULL,'G',0.00002,NULL,'15.03',0.22,'Sbc pec sp     HII',NULL,NULL,NULL,NULL,1,6.449,-2.28478,0.132,NULL,34406790371,537606099,8400095,15.03),(2756,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2756,34.07,0.47,65.2,1053,NULL,NULL,'H','MCG -01-02-011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2757,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2757,34.11,0.45,66.3,1053,NULL,NULL,'K','MCG -01-02-011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2758,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2758,34.23,0.2,70.2,1053,74.4,NULL,NULL,'MCG -01-02-011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2759,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2759,34.29,0.46,72,1053,NULL,NULL,'J','MCG -01-02-011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2760,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2760,34.36,NULL,74.3,1053,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -01-02-011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2761,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2761,34.36,0.4,74.5,1053,NULL,NULL,'mean','MCG -01-02-011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2762,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2762,34.36,NULL,74.5,1053,NULL,NULL,'Dipole','MCG -01-02-011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2763,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2763,34.36,NULL,74.6,1053,NULL,NULL,'Dipole + Quadrupole','MCG -01-02-011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2764,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2764,34.39,0.38,75.6,1053,NULL,NULL,'Malmquist cor.','MCG -01-02-011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2765,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2765,34.42,0.37,76.4,1053,NULL,NULL,NULL,'MCG -01-02-011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2766,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2766,36.41,0.64,192,1054,70,NULL,NULL,'2MASX J00255160-2040386',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.71',0.42,'E',NULL,NULL,NULL,NULL,1,6.46491666667,-20.67733,0.047,NULL,35360196459,552503069,8632860,16.71),(2767,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2767,34.01,0.48,63.4,1055,70,NULL,NULL,'MCG -02-02-009',NULL,'2014MNRAS.445.2677S',2014,1,0.93,NULL,'G',0.000083,NULL,'14.5g',0.35,'Sa',NULL,NULL,NULL,NULL,1,6.4687083,-9.66178,0.134,NULL,34619199377,540924990,8451952,14.5),(2768,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 19764','R',2768,41.22,0.29,1250,1056,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19764',0.405473,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',NULL,'PHOT','21.3g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,6.47725,1.19181,0.037,NULL,66601277960,1040644968,16260077,21.3),(2769,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 19764',NULL,2769,40.95,0.62,1550,1056,70,NULL,'SN photometric redshift distance, z photo =0.461 +/- 0.230','SDSS-II SN 19764',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2770,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 19764','R',2770,41.79,0.39,1620,1056,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19764',0.405473,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2771,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 19764',NULL,2771,41.79,0.26,2280,1056,70,NULL,'SALT 2','SDSS-II SN 19764',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2772,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 19764',NULL,2772,41.86,0.26,2360,1056,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19764',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2773,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 01376','RN',2773,41.34,0.18,1530,1057,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 01376',0.217061,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2774,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 01376','RN',2774,41.69,0.26,1790,1057,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 01376',0.217061,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2775,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2775,36.15,0.46,170,1058,70,NULL,NULL,'2MASX J00255884+1355451',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000157,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,6.495375,13.92936,0.133,NULL,66752556395,1043008693,16297010,16.4),(2776,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2776,35.71,0.49,138,1059,75,NULL,'IR','UGC 00247',NULL,'2011yCatp016004901K',2011,1,0.98,NULL,'G',0.000198,NULL,'16.2g',0.21,'Scd:',NULL,NULL,NULL,NULL,1,6.49575,14.34794,0.105,NULL,66745078818,1042891856,16295185,16.2),(2777,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2777,35.97,0.2,156,1059,74.4,NULL,NULL,'UGC 00247',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2778,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2778,36.16,0.46,171,1060,70,NULL,NULL,'2MASX J00260179-0931577',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000102,NULL,'16.0g',0.29,'E0',NULL,NULL,NULL,NULL,1,6.507375,-9.53278,0.134,NULL,34619168932,540924514,8451945,16),(2779,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2779,36.17,0.46,171,1061,70,NULL,NULL,'2MASX J00260195+1539181',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000165,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,6.50825,15.65508,0.105,NULL,66747785724,1042934151,16295846,16.8),(2780,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2780,34.34,0.8,73.9,1062,75,NULL,'HMCL, I','CGCG 479-028',NULL,'1997ApJS..109..333W',1997,1,0.6,NULL,'G',0.000053,NULL,'15.7',0.5,'Sd','Pair member (points to parent)',NULL,NULL,NULL,1,6.51125,21.79533,0.105,NULL,67499211647,1054675181,16479299,15.7),(2781,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2781,33.22,0.4,44,1062,75,NULL,'HMCL, I, inv','CGCG 479-028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2782,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2782,33.23,0.4,44.2,1062,75,NULL,'HMCL, I, raw','CGCG 479-028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2783,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2783,33.63,0.4,53.3,1062,75,NULL,'HMCL, I, cor','CGCG 479-028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2784,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2784,33.01,NULL,40,1063,NULL,NULL,NULL,'FGC 0045',NULL,'2000BSAO...50....5K',2000,1,1.06,NULL,'G',0.000083,NULL,'16.5',0.11,'Sm',NULL,NULL,NULL,NULL,1,6.512083,49.48389,0.657,NULL,65772484776,1027695074,16057735,16.5),(2785,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2785,33.62,NULL,52.9,1063,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0045',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2786,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2786,33.63,NULL,53.2,1063,NULL,NULL,'Dipole + Quadrupole','FGC 0045',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2787,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2787,33.63,NULL,53.3,1063,NULL,NULL,'Dipole','FGC 0045',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2788,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2788,37.23,0.46,280,1064,70,NULL,NULL,'2MASX J00260314+1527061',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,6.513083,15.45167,0.125,NULL,66747887050,1042935735,16295870,17.7),(2789,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2789,36.02,0.62,160,1065,70,NULL,NULL,'2MASX J00260321-0720047',NULL,'2014MNRAS.445.2677S',2014,1,0.84,NULL,'G',0.000103,NULL,'16.54',0.57,NULL,NULL,NULL,NULL,NULL,1,6.513333,-7.33469,0.123,NULL,34612805279,540825082,8450391,16.54),(2790,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 07701','R',2790,41.27,0.21,1320,1066,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J002604.13-011344.9',0.3613,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',0.0005,NULL,'20.8g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,6.51725,-1.22914,0.053,NULL,34401509415,537523584,8398806,20.8),(2791,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 07701','R',2791,41.3,0.26,1340,1066,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J002604.13-011344.9',0.3613,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2792,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 07701',NULL,2792,41.18,0.16,1720,1066,70,NULL,'SALT 2','SDSS J002604.13-011344.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2793,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 07701',NULL,2793,41.23,0.16,1760,1066,70,NULL,'SALT 2, Malmquist cor.','SDSS J002604.13-011344.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2794,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2794,36.82,0.71,232,1067,70,NULL,NULL,'2MASX J00260930-0945457',NULL,'2014MNRAS.445.2677S',2014,1,0.74,NULL,'G',0.00009,NULL,'16.3g',0.22,'Sb(f)',NULL,NULL,NULL,NULL,1,6.53875,-9.76264,0.134,NULL,34619563290,540930676,8452041,16.3),(2795,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 09718','RN',2795,39.87,0.52,780,1068,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 09718',0.205593,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2796,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 09718','RN',2796,40.39,0.57,992,1068,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 09718',0.205593,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2797,'CMD','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2797,24.39,NULL,0.755,1069,NULL,NULL,NULL,'Cetus Dwarf Spheroidal',NULL,'2014ApJ...789..147W',2014,1,5,NULL,'G',NULL,NULL,'14.4',4.3,'dSph','Brightest group member',NULL,NULL,NULL,1,6.5459583,-11.04433,0.113,1,34569621251,540150332,8439848,14.4),(2798,'RR Lyrae','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2798,24.37,0.09,0.748,1069,NULL,NULL,'V','Cetus Dwarf Spheroidal',NULL,'2013MNRAS.435.3206D',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2799,'RR Lyrae','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2799,24.46,0.12,0.78,1069,NULL,NULL,NULL,'Cetus Dwarf Spheroidal',NULL,'2009ApJ...699.1742B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2800,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2800,24.39,0.07,0.755,1069,NULL,NULL,NULL,'Cetus Dwarf Spheroidal',NULL,'2005MNRAS.356..979M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2801,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2801,24.44,0.11,0.773,1069,NULL,NULL,NULL,'Cetus Dwarf Spheroidal',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2802,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2802,24.45,0.15,0.775,1069,NULL,NULL,NULL,'Cetus Dwarf Spheroidal',NULL,'1999AJ....118.2767W',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2803,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2803,24.46,0.14,0.78,1069,NULL,NULL,NULL,'Cetus Dwarf Spheroidal',NULL,'2002ApJ...567..915S',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2804,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2804,24.45,NULL,0.78,1069,NULL,NULL,NULL,'Cetus Dwarf Spheroidal',NULL,'2003A&A...404...93K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2805,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2805,24.87,1.2,0.942,1069,NULL,NULL,'I','Cetus Dwarf Spheroidal',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2806,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 00734','RN',2806,41.66,0.1,1560,1070,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 00734',0.372361,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2807,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 00734','RN',2807,41.7,0.19,1590,1070,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00734',0.372361,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2808,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2808,37.02,0.46,254,1071,70,NULL,NULL,'2MASXi J0026142-005556',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.29',0.16,NULL,NULL,NULL,NULL,NULL,1,6.559625,-0.93231,0.036,NULL,34401680441,537526256,8398847,18.29),(2809,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2809,33.91,0.47,60.5,1072,NULL,NULL,'H','NGC 0109',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000063,NULL,'14.7',1,'SB(r)a','Pair member (points to parent)',NULL,NULL,NULL,1,6.561,21.80731,0.101,NULL,67499204547,1054675071,16479297,14.7),(2810,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2810,34.07,0.46,65.1,1072,NULL,NULL,'J','NGC 0109',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2811,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2811,34.1,0.45,66.1,1072,NULL,NULL,'K','NGC 0109',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2812,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2812,34.34,0.4,73.7,1072,NULL,NULL,'mean','NGC 0109',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2813,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2813,37.66,0.46,341,1073,70,NULL,NULL,'2MASX J00261603-1026176',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000082,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,6.5669583,-10.43839,0.138,NULL,34616031329,540875489,8451179,17.4),(2814,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2814,33.39,0.8,47.7,1074,75,NULL,'MAT, I','MCG -01-02-014',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000027,NULL,'14.50',0.4,'SB(s)a pec:    HII',NULL,NULL,NULL,NULL,1,6.57275,-4.49236,0.14,NULL,34402201774,537534402,8398975,14.5),(2815,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2815,33.13,0.32,42.2,1074,85,NULL,'I, raw','MCG -01-02-014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2816,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2816,33.16,0.32,42.8,1074,85,NULL,'I, inv','MCG -01-02-014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2817,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2817,33.24,0.43,44.4,1074,75,NULL,'MAT, I, raw','MCG -01-02-014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2818,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2818,33.4,0.43,47.9,1074,75,NULL,'MAT, I, inv','MCG -01-02-014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2819,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,NULL,2819,33.61,0.43,52.7,1074,75,NULL,'MAT, I, cor','MCG -01-02-014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2820,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 09954','R',2820,40.46,0.19,1010,1075,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 09954 HOST',0.228429,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,6.584125,-0.42544,0.045,NULL,34398173176,537471455,8397991,NULL),(2821,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 09954','R',2821,40.63,0.12,1090,1075,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 09954 HOST',0.228429,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2822,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 09954',NULL,2822,40.33,0.09,1160,1075,70,NULL,'SALT 2','SDSS-II SN 09954 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2823,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 09954',NULL,2823,40.35,0.09,1170,1075,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 09954 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2824,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2824,37.6,0.46,331,1076,70,NULL,NULL,'2MASX J00262573+0056333',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000087,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,6.60716666667,0.94256,0.053,NULL,66601342375,1040645974,16260093,17.5),(2825,'FP','2016-12-15 15:13:32','2016-12-16 11:18:33','1',NULL,'R',2825,37.41,0.46,303,1077,70,NULL,NULL,'2MASX J00262852+0044253',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000086,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,6.61870833333,0.74028,0.017,NULL,66601110722,1040642355,16260036,17.2),(2826,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 19435','RN',2826,40.6,0.17,1090,1078,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 19435',0.213066,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2827,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 19435','RN',2827,41.08,0.23,1350,1078,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 19435',0.213066,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2828,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 08797','RN',2828,42.62,0.31,2540,1079,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 08797',0.311296,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2829,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 08797','RN',2829,43.08,0.37,3150,1079,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 08797',0.311296,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2830,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 08798','RN',2830,41.07,0.22,1280,1080,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 08798',0.276825,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2831,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 08798','RN',2831,41.79,0.36,1790,1080,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08798',0.276825,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2832,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:33','1','SDSS-II SN 03178','RN',2832,42.27,0.31,2350,1081,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03178',0.213006,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2833,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:34','1','SDSS-II SN 03178','RN',2833,42.91,0.29,3140,1081,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03178',0.213006,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2834,'FP','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,'R',2834,37.34,0.46,294,1082,70,NULL,NULL,'2MASX J00263304+0030143',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,6.63766666667,0.50389,0.017,NULL,66600981887,1040640341,16260005,16.4),(2835,'Red Clump','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,NULL,2835,26.19,NULL,1.73,1083,NULL,NULL,'V, M RC(V) = +0.73 mag','ESO 294- G 010',NULL,'2010AJ....140.1038P',2010,1,1.1,'Cote, et al. (1997AJ....114.1313C) give v = 4450 +/- 10 km/sec.','G',0.000017,NULL,'15.5B',0.7,'dS0/Im',NULL,NULL,NULL,NULL,1,6.63904166667,-41.85531,NULL,0,38130106838,595782919,9309108,15.5),(2836,'Red Clump','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,NULL,2836,26.62,NULL,2.11,1083,NULL,NULL,'I, M RC(I) = -0.50 mag','ESO 294- G 010',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2837,'RR Lyrae','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,NULL,2837,26.4,0.07,1.91,1083,NULL,NULL,NULL,'ESO 294- G 010',NULL,'2014ApJ...784...76Y',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2838,'SBF','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,NULL,2838,26.17,0.08,1.71,1083,NULL,NULL,NULL,'ESO 294- G 010',NULL,'1998AJ....116.2873J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2839,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,NULL,2839,26.37,NULL,1.88,1083,NULL,NULL,NULL,'ESO 294- G 010',NULL,'2014ApJ...784...76Y',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2840,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,NULL,2840,26.42,0.1,1.92,1083,NULL,NULL,NULL,'ESO 294- G 010',NULL,'2002A&A...389..812K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2841,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,NULL,2841,26.43,0.05,1.93,1083,NULL,NULL,NULL,'ESO 294- G 010',NULL,'2013A&A...550A...7L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2842,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,NULL,2842,26.43,NULL,1.94,1083,NULL,NULL,NULL,'ESO 294- G 010',NULL,'2010ApJ...724.1030G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2843,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,NULL,2843,26.43,0.02,1.94,1083,NULL,NULL,'I','ESO 294- G 010',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2844,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,NULL,2844,26.45,0.05,1.95,1083,NULL,NULL,'I','ESO 294- G 010',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2845,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,NULL,2845,26.46,0.08,1.96,1083,NULL,NULL,NULL,'ESO 294- G 010',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2846,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,NULL,2846,26.5,0.08,2,1083,74.4,NULL,NULL,'ESO 294- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2847,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,NULL,2847,26.52,NULL,2.01,1083,NULL,NULL,'I, M TRGB(I) = -4.05 mag','ESO 294- G 010',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2848,'TRGB','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,'R',2848,26.58,NULL,2.07,1083,NULL,NULL,'I','ESO 294- G 010',NULL,'2006ARep...50..517T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2849,'FP','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,'R',2849,36.82,0.46,231,1084,70,NULL,NULL,'2MASX J00263360-0041483',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000087,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,6.639917,-0.69675,0.031,NULL,34400979438,537515303,8398676,16.8),(2850,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:34','1','SDSS-II SN 17464','R',2850,40.02,0.24,811,1085,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007jb','SN 2007jb',0.247,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,6.64079166667,0.04197,0.057,NULL,66597634572,1040588040,16259188,NULL),(2851,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:34','1','SDSS-II SN 17464','R',2851,40.17,0.19,866,1085,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007jb','SN 2007jb',0.247,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2852,'FP','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,'R',2852,36.51,0.46,200,1086,70,NULL,NULL,'2MASX J00263491+1519244',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000176,NULL,'16.2g',0.34,'E0',NULL,NULL,NULL,NULL,1,6.6454583,15.32358,0.141,NULL,66747828674,1042934823,16295856,16.2),(2853,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:34','1','SDSS-II SN 12971',NULL,2853,39.69,0.2,867,1087,70,NULL,NULL,'SDSS J002635.42-001811.8',NULL,'2013MNRAS.434.1443X',2013,1,0.17,NULL,'G',0.000105,NULL,'19.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,6.647625,-0.30328,0.045,NULL,34398225706,537472276,8398004,19.1),(2854,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:34','1','SDSS-II SN 12971','R',2854,40.29,0.22,924,1087,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ff','SDSS J002635.42-001811.8',0.235409,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2855,'SNIa','2016-12-15 15:13:32','2016-12-16 11:18:34','1','SDSS-II SN 12971','R',2855,40.49,0.17,1010,1087,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ff','SDSS J002635.42-001811.8',0.235409,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2856,'FP','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,'R',2856,37.45,0.46,309,1088,70,NULL,NULL,'2MASX J00263712+1613274',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000175,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,6.654667,16.22428,0.133,NULL,66744867433,1042888553,16295133,17),(2857,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:34','1','SDSS-II SN 10928','R',2857,38.64,0.2,494,1089,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 10928',0.081883,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,6.6772083,-0.80383,0.031,NULL,34401645602,537525712,8398839,NULL),(2858,'SNIa SDSS','2016-12-15 15:13:32','2016-12-16 11:18:34','1','SDSS-II SN 10928','R',2858,39.01,0.11,585,1089,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 10928',0.081883,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2859,'FP','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,'R',2859,38.03,0.46,403,1090,70,NULL,NULL,'2MASXi J0026463-105049',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000072,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,6.693125,-10.84692,0.111,NULL,34570368285,540162004,8440031,18.1),(2860,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,NULL,2860,31.88,0.8,23.7,1091,75,NULL,'MAT, I','NGC 0115',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000019,NULL,'13.71',0.9,'SB(s)bc:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,6.692833,-33.67708,NULL,NULL,34854301988,544598468,8509351,13.71),(2861,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,NULL,2861,31.98,0.32,24.9,1091,85,NULL,'I, inv','NGC 0115',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2862,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,NULL,2862,31.99,0.32,25,1091,85,NULL,'I, raw','NGC 0115',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2863,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,NULL,2863,32.16,0.4,27,1091,NULL,NULL,NULL,'NGC 0115',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2864,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,NULL,2864,32.16,0.4,27,1091,73,NULL,'opt','NGC 0115',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2865,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,NULL,2865,32.29,0.2,28.7,1091,74.4,NULL,NULL,'NGC 0115',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2866,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,NULL,2866,32.31,0.43,29,1091,75,NULL,'MAT, I, raw','NGC 0115',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2867,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,NULL,2867,32.34,0.43,29.4,1091,75,NULL,'3.6 micron, color corrected','NGC 0115',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2868,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,NULL,2868,32.35,0.43,29.5,1091,75,NULL,'MAT, I, inv','NGC 0115',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2869,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,NULL,2869,32.45,0.43,30.9,1091,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0115',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2870,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,NULL,2870,32.55,0.43,32.3,1091,75,NULL,'MAT, I, cor','NGC 0115',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2871,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,NULL,2871,32.57,0.33,32.7,1091,NULL,NULL,NULL,'NGC 0115',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2872,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,NULL,2872,32.96,0.4,39,1091,73,NULL,'opt','NGC 0115',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2873,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,NULL,2873,33.04,0.27,40.6,1091,NULL,NULL,'Malmquist cor.','NGC 0115',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2874,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,NULL,2874,34.63,0.8,84.5,1092,75,NULL,'W91PP, r','NGC 0112',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'14.49',0.5,'Sc','in a radial-velocity based grouping',NULL,NULL,NULL,1,6.70304166667,31.70331,0.225,NULL,67349223442,1052331616,16442681,14.49),(2875,'IRAS','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,NULL,2875,34.63,0.8,84.5,1092,75,NULL,'HMCL, I','NGC 0112',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2876,'Tully-Fisher','2016-12-15 15:13:32','2016-12-16 11:18:34','1',NULL,NULL,2876,34.42,0.38,76.6,1092,75,NULL,'W91PP, r, raw','NGC 0112',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2877,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2877,34.46,0.4,78,1092,75,NULL,'HMCL, I, raw','NGC 0112',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2878,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2878,34.5,0.41,79.4,1092,NULL,NULL,'Malmquist cor.','NGC 0112',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2879,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2879,34.56,0.38,81.8,1092,75,NULL,'W91PP, r, cor','NGC 0112',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2880,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2880,34.57,0.38,82.1,1092,75,NULL,'W91PP, r, inv','NGC 0112',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2881,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2881,34.59,0.39,82.8,1092,NULL,NULL,NULL,'NGC 0112',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2882,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2882,34.62,0.4,84,1092,75,NULL,'HMCL, I, cor','NGC 0112',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2883,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2883,34.64,0.4,84.6,1092,75,NULL,'HMCL, I, inv','NGC 0112',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2884,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2884,34.69,0.2,86.7,1092,74.4,NULL,NULL,'NGC 0112',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2885,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2885,34.81,0.4,91.7,1092,NULL,NULL,'mean','NGC 0112',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2886,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2886,34.99,0.47,99.7,1092,NULL,NULL,'H','NGC 0112',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2887,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2887,35.09,0.45,104,1092,NULL,NULL,'K','NGC 0112',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2888,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2888,35.09,0.46,104,1092,NULL,NULL,'J','NGC 0112',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2889,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2889,39.64,0.11,849,1093,NULL,NULL,NULL,'2MASX J00264878-0016100',NULL,'2015MNRAS.453..868O',2015,1,0.15,NULL,'G',0.000138,NULL,'19.0g',0.12,'BrClG',NULL,NULL,NULL,NULL,1,6.70325,-0.26936,0.042,NULL,34398047051,537469485,8397960,19),(2890,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',2890,35.72,0.46,140,1094,70,NULL,NULL,'2MASX J00264907+0002174',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000087,NULL,'16.1g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,6.704375,0.03814,0.057,NULL,66597457850,1040585278,16259144,16.1),(2891,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 20842',NULL,2891,38.22,0.82,442,1095,70,NULL,'SN photometric redshift distance, z photo =0.109 +/- 0.055','SDSS-II SN 20842',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,6.718875,-1.19447,0.051,NULL,34400833910,537513029,8398641,NULL),(2892,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 20842','R',2892,41.14,0.23,1230,1095,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20842',0.368422,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2893,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 20842','R',2893,41.16,0.28,1240,1095,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20842',0.368422,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2894,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 20842',NULL,2894,41,0.19,1580,1095,70,NULL,'SALT 2','SDSS-II SN 20842',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2895,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 20842',NULL,2895,41.05,0.19,1620,1095,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20842',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2896,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2896,33.74,0.48,55.9,1096,70,NULL,NULL,'NGC 0113',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000063,NULL,'14.14',1,'SA0-:',NULL,NULL,NULL,NULL,1,6.727667,-2.50089,0.156,NULL,34406338184,537599034,8399984,14.14),(2897,'GRB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',2897,46.48,1.8,4370,1097,73,NULL,'H const./H=100','GRB 021004',2.3,'2006astro.ph..9262M',2006,1,NULL,NULL,'G',NULL,NULL,'24.6B',NULL,'AGN',NULL,NULL,NULL,NULL,1,6.727875,18.92814,0.145,NULL,67505581622,1054774712,16480854,24.6),(2898,'GRB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',2898,46.34,0.53,5620,1097,72,NULL,NULL,'GRB 021004',2.3,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2899,'GRB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2899,46.45,0.52,5910,1097,70,NULL,NULL,'GRB 021004',2.3,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2900,'GRB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',2900,46.56,0.59,6210,1097,NULL,NULL,NULL,'GRB 021004',2.3,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2901,'GRB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2901,46.6,0.48,6330,1097,69.7,NULL,'Calibrated','GRB 021004',2.3,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2902,'GRB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',2902,46.63,1.73,6420,1097,100,NULL,NULL,'GRB 021004',2.3,'2009EPJC...63..139W',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2903,'GRB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',2903,46.75,1.69,6780,1097,73,NULL,'H const./H=100','GRB 021004',2.3,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2904,'GRB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2904,46.81,0.52,6970,1097,69.7,NULL,'Fiducial','GRB 021004',2.3,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2905,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',2905,38.15,0.46,427,1098,70,NULL,NULL,'2MASX J00265547+1535321',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,6.731,15.59228,0.105,NULL,66747892897,1042935826,16295872,17.5),(2906,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2906,33.28,0.43,45.3,1099,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00256',NULL,'2014MNRAS.444..527S',2014,1,1.6,NULL,'G',0.000037,NULL,'15.0',0.3,'Sbc',NULL,NULL,NULL,NULL,1,6.735625,50.03075,0.757,NULL,65828330685,1028567666,16071369,15),(2907,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2907,33.49,0.43,49.8,1099,75,NULL,'3.6 micron, color corrected','UGC 00256',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2908,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2908,33.63,0.2,53.2,1099,74.4,NULL,NULL,'UGC 00256',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2909,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2909,34,0.47,63.2,1099,NULL,NULL,'H','UGC 00256',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2910,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2910,34.06,0.45,65,1099,NULL,NULL,'K','UGC 00256',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2911,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2911,34.35,0.46,74.2,1099,NULL,NULL,'J','UGC 00256',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2912,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2912,34.4,0.4,75.9,1099,NULL,NULL,'mean','UGC 00256',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2913,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2913,34.1,0.49,66.1,1100,70,NULL,NULL,'NGC 0114',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'14.73',0.7,'SB(rs)0:','Group member',NULL,NULL,NULL,1,6.742625,-1.78625,0.107,NULL,34406631746,537603621,8400056,14.73),(2914,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2005ln',NULL,2914,38.34,0.13,406,1101,74.2,NULL,'SALT 2','SDSS J002700.27-003511.8',0.147,'2010ApJ...716..712A',2010,1,0.11,NULL,'G',NULL,NULL,'20.40',0.09,NULL,NULL,NULL,NULL,NULL,1,6.751167,-0.58661,0.031,NULL,34401107859,537517310,8398707,20.4),(2915,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2005ln',NULL,2915,38.95,0.14,537,1101,70,NULL,'SDSS-II SN 11300, SALT 2','SDSS J002700.27-003511.8',0.147,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2916,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 11300','R',2916,38.97,0.2,546,1101,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ln','SDSS J002700.27-003511.8',0.14,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2917,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 11300','R',2917,39.11,0.15,582,1101,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ln','SDSS J002700.27-003511.8',0.14,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2918,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2005ln',NULL,2918,40.06,0.03,896,1101,70,NULL,'SDSS-II SN 11300','SDSS J002700.27-003511.8',0.147,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2919,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',2919,37.44,0.46,307,1102,70,NULL,NULL,'SDSS J002702.45-011228.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000106,NULL,'18.2g',0.11,'NLAGN',NULL,NULL,NULL,NULL,1,6.7602083,-1.20781,0.051,NULL,34400890039,537513906,8398654,18.2),(2920,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',2920,31.84,0.4,23.4,1103,75,NULL,NULL,'UGC 00260',NULL,'2008Ap.....51..336K',2008,1,3.14,NULL,'G',0.000017,NULL,'13.71',0.34,'Sc','Pair member (points to parent)',NULL,NULL,NULL,1,6.762167,11.58381,0.145,NULL,66748596856,1042946825,16296044,13.71),(2921,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2921,31.85,0.4,23.4,1103,73,NULL,'IR','UGC 00260',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2922,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2922,32.06,0.4,25.8,1103,73,NULL,'opt','UGC 00260',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2923,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2923,32.13,0.43,26.7,1103,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00260',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2924,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2924,32.24,0.43,28,1103,75,NULL,'3.6 micron, color corrected','UGC 00260',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2925,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2925,32.26,0.4,28.3,1103,75,NULL,'B','UGC 00260',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2926,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2926,32.27,0.4,28.4,1103,NULL,NULL,NULL,'UGC 00260',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2927,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2927,32.32,0.2,29.1,1103,74.4,NULL,NULL,'UGC 00260',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2928,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2928,32.38,0.4,30,1103,NULL,NULL,'mean','UGC 00260',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2929,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2929,32.46,0.51,31.1,1103,NULL,NULL,NULL,'UGC 00260',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2930,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',2930,32.48,0.49,31.3,1103,75,NULL,'IR','UGC 00260',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2931,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2931,32.51,0.39,31.7,1103,73,NULL,'opt','UGC 00260',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2932,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2932,32.6,0.48,33.1,1103,NULL,NULL,'Malmquist cor.','UGC 00260',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2933,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2933,32.6,NULL,33.1,1103,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00260',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2934,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2934,32.6,0.47,33.2,1103,NULL,NULL,'H','UGC 00260',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2935,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2935,32.61,NULL,33.2,1103,NULL,NULL,'Dipole + Quadrupole','UGC 00260',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2936,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2936,32.61,NULL,33.3,1103,NULL,NULL,'Dipole','UGC 00260',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2937,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2937,32.66,0.46,34.1,1103,NULL,NULL,'J','UGC 00260',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2938,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2938,32.7,NULL,34.7,1103,NULL,NULL,NULL,'UGC 00260',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2939,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2939,32.71,0.45,34.8,1103,NULL,NULL,'K','UGC 00260',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2940,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 14329','RN',2940,40.85,0.14,1270,1104,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14329',0.162408,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2941,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 14329','RN',2941,41.48,0.21,1700,1104,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 14329',0.162408,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2942,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2006lp',NULL,2942,39.34,0.22,738,1105,70,NULL,'SDSS-II SN 15354','SDSS-II SN 15354 HOST',NULL,'2013MNRAS.434.1443X',2013,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,6.77425,-0.12597,0.057,NULL,34398074168,537469908,8397967,NULL),(2943,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2006lp',NULL,2943,39.46,0.14,781,1105,70,NULL,'Hubble residual -0.18 for z0.22210; SDSS-II SN 15354','SDSS-II SN 15354 HOST',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2944,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2006lp','R',2944,39.91,0.23,785,1105,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006lp; SDSS-II SN 15354','SDSS-II SN 15354 HOST',0.2221,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2945,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2006lp','R',2945,40.18,0.15,887,1105,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006lp; SDSS-II SN 15354','SDSS-II SN 15354 HOST',0.2221,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2946,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',2946,38.28,0.46,452,1106,70,NULL,NULL,'2MASX J00270624-0946099',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000091,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,6.7760417,-9.76944,0.144,NULL,34619432344,540928630,8452009,17.1),(2947,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2947,39.61,0.11,837,1107,NULL,NULL,NULL,'SDSS J002709.42+001413.8',NULL,'2015MNRAS.453..868O',2015,1,0.2,NULL,'G',NULL,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,6.7892917,0.23719,0.037,NULL,66597447532,1040585117,16259142,18.7),(2948,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2948,37.37,0.67,298,1108,70,NULL,NULL,'2MASX J00270998-0702129',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'17.29',0.31,NULL,NULL,NULL,NULL,NULL,1,6.791667,-7.03694,0.126,NULL,34614704282,540854754,8450855,17.29),(2949,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2005fp',NULL,2949,39.84,0.16,768,1109,74.2,NULL,'SALT 2','SDSS J002713.75+010715.0',0.21,'2010ApJ...716..712A',2010,1,0.06,NULL,'G',0.0005,NULL,'21.3g',0.04,NULL,NULL,NULL,NULL,NULL,1,6.807333,1.12083,0.045,NULL,66600561080,1040633766,16259902,21.3),(2950,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2005fp',NULL,2950,39.86,0.16,937,1109,70,NULL,'Hubble residual 0.30 for z0.21320','SDSS J002713.75+010715.0',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2951,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2005fp',NULL,2951,40.42,0.19,1000,1109,65,NULL,'SALT2','SDSS J002713.75+010715.0',0.21,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2952,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2005fp',NULL,2952,40.43,0.18,1010,1109,70,NULL,'SALT 2','SDSS J002713.75+010715.0',0.21,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2953,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 02330','R',2953,40.47,0.25,1020,1109,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fp','SDSS J002713.75+010715.0',0.2132,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2954,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2005fp',NULL,2954,40.21,0.14,1100,1109,70,NULL,'SALT 2','SDSS J002713.75+010715.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2955,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2005fp',NULL,2955,40.22,0.14,1110,1109,70,NULL,'SALT 2, Malmquist cor.','SDSS J002713.75+010715.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2956,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2005fp',NULL,2956,40.68,0.16,1130,1109,65,NULL,'MLCS2k2','SDSS J002713.75+010715.0',0.21,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2957,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 02330','R',2957,40.72,0.19,1150,1109,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fp','SDSS J002713.75+010715.0',0.2132,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2958,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 19100','RN',2958,41.17,0.2,1410,1110,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19100',0.214505,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2959,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 19100','RN',2959,41.92,0.34,1990,1110,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19100',0.214505,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2960,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2960,35.51,0.62,127,1111,70,NULL,NULL,'LCRS B002449.0-421253',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.86',0.3,NULL,NULL,NULL,NULL,NULL,1,6.81670833333,-41.93797,NULL,NULL,38130054699,595782104,9309095,14.86),(2961,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2961,35.15,0.4,107,1112,NULL,NULL,'mean','UGC 00261',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000093,NULL,'14.53',0.9,'S?',NULL,NULL,NULL,NULL,1,6.8217917,24.16925,0.057,NULL,67201780113,1050027814,16406684,14.53),(2962,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2962,35.29,0.47,114,1112,NULL,NULL,'H','UGC 00261',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2963,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 13008','RN',2963,41.86,0.19,1710,1113,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13008',0.377481,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2964,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 13008','RN',2964,42.13,0.1,1940,1113,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13008',0.377481,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2965,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',2965,36.27,0.46,179,1114,70,NULL,NULL,'2MASX J00271944-0848212',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00009,NULL,'16.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,6.830917,-8.80594,0.126,NULL,34618432713,540913011,8451765,16.2),(2966,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 15196','RN',2966,40.68,0.26,1200,1115,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15196',0.13631,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2967,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 15196','RN',2967,41.12,0.26,1470,1115,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15196',0.13631,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2968,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 13695','RN',2968,43.45,0.25,3630,1116,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 13695',0.350616,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2969,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 13695','RN',2969,43.56,0.24,3820,1116,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 13695',0.350616,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2970,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',2970,36.28,0.46,181,1117,70,NULL,NULL,'2MASX J00272534+0011349',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,6.8554583,0.19292,0.033,NULL,66600865893,1040638529,16259977,16.5),(2971,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 13904','R',2971,40.37,0.2,974,1118,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J002726.34+001700.9',0.217646,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,'PHOT','21.5g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,6.8597917,0.28361,0.029,NULL,66600879247,1040638738,16259980,21.5),(2972,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 13904','R',2972,40.43,0.12,1000,1118,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J002726.34+001700.9',0.217646,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2973,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 13904',NULL,2973,40.31,0.09,1150,1118,70,NULL,'SALT 2','SDSS J002726.34+001700.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2974,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 13904',NULL,2974,40.32,0.09,1160,1118,70,NULL,'SALT 2, Malmquist cor.','SDSS J002726.34+001700.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2975,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2975,33.75,0.48,56.3,1119,70,NULL,NULL,'NGC 0120',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00004,NULL,'14.42',0.6,'SB0^0^:','Group member',NULL,NULL,NULL,1,6.875333,-1.51347,0.049,NULL,34398808168,537481377,8398146,14.42),(2976,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 13151','RN',2976,48.52,0.24,36500,1120,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13151',0.388351,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2977,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 13151','RN',2977,50.59,0.46,94300,1120,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13151',0.388351,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2978,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',2978,38.24,0.46,444,1121,70,NULL,NULL,'2MASX J00273398+1552407',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,6.8917083,15.87794,0.117,NULL,66744685141,1042885705,16295089,17.7),(2979,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 07349','RN',2979,44.65,0.44,5980,1122,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 07349',0.419329,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2980,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 13836','RN',2980,40.9,0.15,1100,1123,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13836',0.374341,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2981,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 13836','RN',2981,41.19,0.24,1260,1123,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13836',0.374341,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2982,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 20590',NULL,2982,38.09,0.8,415,1124,70,NULL,'SN photometric redshift distance, z photo =0.102 +/- 0.049','SDSS-II SN 20590',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,6.91641666667,0.21214,0.033,NULL,66600891126,1040638923,16259983,NULL),(2983,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 14397','R',2983,41.77,0.26,1630,1125,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006kk','SDSS J002739.86+003858.2',0.3857,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,6.915625,0.64933,0.033,NULL,66600954335,1040639911,16259998,NULL),(2984,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2006kk',NULL,2984,41.13,0.24,1680,1125,70,NULL,'Hubble residual 0.48 for z0.38570','SDSS J002739.86+003858.2',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2985,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 14397','R',2985,42.3,0.26,2080,1125,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006kk','SDSS J002739.86+003858.2',0.3857,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2986,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 20677','R',2986,38.77,0.12,525,1126,70,NULL,'SDSS CAND. SNIc; MLCS2K2; SN 2007qx','SN 2007qx',0.080778,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ib',NULL,NULL,NULL,NULL,1,6.924083,1.23325,0.037,NULL,66600348126,1040630439,16259850,NULL),(2987,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 20677','R',2987,38.89,0.2,554,1126,70,NULL,'SDSS CAND. SNIc; SALT 2; SN 2007qx','SN 2007qx',0.080778,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2988,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',2988,37.49,0.46,315,1127,70,NULL,NULL,'2MASX J00274440-0852462',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000088,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,6.934917,-8.87961,0.126,NULL,34618757029,540918078,8451844,17.5),(2989,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2989,36.44,0.56,194,1128,70,NULL,NULL,'2MASX J00274641-1015462',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00013,NULL,'15.9g',0.3,'AGN',NULL,NULL,NULL,NULL,1,6.9432917,-10.26297,0.122,NULL,34615899580,540873430,8451147,15.9),(2990,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2005hk',NULL,2990,33.69,0.1,54,1129,72,NULL,NULL,'UGC 00272',0.012993,'2008ApJ...689..377W',2008,1,1.37,NULL,'G',0.000041,NULL,'15.0g',0.54,'SAB(s)d:',NULL,NULL,NULL,NULL,1,6.95725,-1.2,0.036,NULL,34400662047,537510344,8398599,15),(2991,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 08151','R',2991,34.05,0.05,63.9,1129,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005hk','UGC 00272',0.012993,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2992,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 08151','R',2992,34.53,0.29,79.5,1129,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005hk','UGC 00272',0.012993,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2993,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2993,33.37,0.8,47.3,1129,75,NULL,'CF, r','UGC 00272',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2994,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2994,33.77,0.41,56.7,1129,NULL,NULL,NULL,'UGC 00272',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2995,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2995,33.77,0.2,56.8,1129,74.4,NULL,NULL,'UGC 00272',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2996,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2996,33.86,0.38,59.2,1129,75,NULL,'CF, r, raw','UGC 00272',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2997,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2997,33.88,0.38,59.8,1129,75,NULL,'CF, r, inv','UGC 00272',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2998,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2998,33.98,0.43,62.5,1129,75,NULL,'3.6 micron, color corrected','UGC 00272',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2999,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,2999,34.04,0.36,64.3,1129,NULL,NULL,'Malmquist cor.','UGC 00272',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3000,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3000,34.09,0.38,65.8,1129,75,NULL,'CF, r, cor','UGC 00272',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3001,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3001,34.17,0.43,68.4,1129,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00272',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3002,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 21442','RN',3002,40.14,0.24,880,1130,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 21442',0.212454,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3003,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 21442','RN',3003,40.26,0.19,930,1130,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 21442',0.212454,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3004,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3004,31.49,0.4,19.9,1131,73,NULL,'opt','UM 038',NULL,'2011A&A...532A.104N',2011,1,0.5,NULL,'G',0.000043,NULL,'15.5',0.3,'Sc             HII',NULL,NULL,NULL,NULL,1,6.96466666667,3.48975,0.041,NULL,66596181320,1040565333,16258833,15.5),(3005,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3005,32.05,0.77,25.7,1131,NULL,NULL,NULL,'UM 038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3006,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3006,32.09,0.2,26.2,1131,74.4,NULL,NULL,'UM 038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3007,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3007,32.2,0.72,27.6,1131,NULL,NULL,'Malmquist cor.','UM 038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3008,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3008,33.26,0.2,44.9,1132,74.4,NULL,NULL,'NGC 0124',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.00002,NULL,'13.2B',0.9,'SA(s)c','Group member',NULL,NULL,NULL,1,6.968167,-1.81019,0.075,NULL,34406616120,537603376,8400052,13.2),(3009,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3009,33.69,0.4,54.6,1132,NULL,NULL,'mean','NGC 0124',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3010,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3010,33.93,0.47,61.2,1132,NULL,NULL,'H','NGC 0124',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3011,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3011,33.94,0.46,61.3,1132,NULL,NULL,'J','NGC 0124',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3012,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3012,37.61,0.46,333,1133,70,NULL,NULL,'2MASX J00275384+0112168',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000087,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,6.974417,1.20464,0.037,NULL,66600350701,1040630479,16259851,17.1),(3013,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3013,33.13,0.2,42.3,1134,74.4,NULL,NULL,'UGC 00275',NULL,'2013AJ....146...86T',2013,1,1.8,'UGC and MCG misidentify this as \'IC 0017\'. NED follows CGCG.','G',0.00002,NULL,'14.40',0.9,'SAB(rs)b pec?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,6.9942917,2.5075,0.077,NULL,66602094530,1040657727,16260276,14.4),(3014,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3014,33.34,0.61,46.6,1134,NULL,NULL,NULL,'UGC 00275',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3015,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3015,33.64,0.53,53.5,1134,NULL,NULL,'Malmquist cor.','UGC 00275',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3016,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3016,34.65,0.8,85.1,1135,75,NULL,'W91PP, r','UGC 00276',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000033,NULL,'15.60',0.2,'Sab',NULL,NULL,NULL,NULL,1,6.9982083,30.76483,0.201,NULL,67349744019,1052339750,16442808,15.6),(3017,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3017,34.65,0.8,85.1,1135,75,NULL,'HMCL, I','UGC 00276',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3018,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3018,34.03,0.49,63.9,1135,75,NULL,'IR','UGC 00276',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3019,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3019,34.82,0.4,92,1135,NULL,NULL,'mean','UGC 00276',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3020,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3020,34.99,0.47,99.7,1135,NULL,NULL,'H','UGC 00276',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3021,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3021,35.26,0.38,113,1135,75,NULL,'W91PP, r, raw','UGC 00276',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3022,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3022,35.31,0.4,116,1135,75,NULL,'HMCL, I, raw','UGC 00276',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3023,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3023,35.47,0.38,124,1135,75,NULL,'W91PP, r, inv','UGC 00276',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3024,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3024,35.5,0.38,126,1135,75,NULL,'W91PP, r, cor','UGC 00276',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3025,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3025,35.53,0.4,127,1135,75,NULL,'HMCL, I, inv','UGC 00276',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3026,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3026,35.59,0.4,131,1135,75,NULL,'HMCL, I, cor','UGC 00276',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3027,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 06556','RN',3027,40.09,0.22,829,1136,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06556',0.258234,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3028,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 06556','RN',3028,40.2,0.15,871,1136,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06556',0.258234,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3029,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 06556','N',3029,39.91,0.11,959,1136,70,NULL,'SALT 2','SDSS-II SN 06556',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3030,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 06556','N',3030,39.93,0.11,968,1136,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 06556',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3031,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3031,37.8,0.46,363,1137,70,NULL,NULL,'2MASX J00281015-0047334',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00008,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,7.04216666667,-0.79272,0.035,NULL,34400253965,537503968,8398499,17.5),(3032,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 13152','R',3032,39.84,0.18,772,1138,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006gg','SDSS J002812.51+000704.8',0.2,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,7.052125,0.118,0.033,NULL,66598743673,1040605369,16259458,NULL),(3033,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 13152','R',3033,39.96,0.09,817,1138,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006gg','SDSS J002812.51+000704.8',0.2,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3034,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2006gg',NULL,3034,39.64,0.07,847,1138,70,NULL,'SALT 2','SDSS J002812.51+000704.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3035,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2006gg',NULL,3035,39.65,0.07,851,1138,70,NULL,'SALT 2, Malmquist cor.','SDSS J002812.51+000704.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3036,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3036,37.69,0.33,344,1139,70,NULL,NULL,'2MASX J00281271-0104532',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000087,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,7.05304166667,-1.08153,0.036,NULL,34400142224,537502222,8398472,17.4),(3037,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3037,37.69,0.33,344,1140,70,NULL,NULL,'2MASX J00281424-0104422',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'16.99',0.3,NULL,NULL,NULL,NULL,NULL,1,7.0595417,-1.07833,0.036,NULL,34400142129,537502220,8398472,16.99),(3038,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3038,34.63,0.8,84.4,1141,75,NULL,'HMCL, I','UGC 00279',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000037,NULL,'14.22',0.5,'SB?','Group member',NULL,NULL,NULL,1,7.0622083,30.80325,0.201,NULL,67349610915,1052337670,16442776,14.22),(3039,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3039,34.63,0.8,84.4,1141,75,NULL,'W91PP, r','UGC 00279',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3040,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3040,34.23,0.49,70,1141,75,NULL,'IR','UGC 00279',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3041,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3041,34.41,0.38,76.3,1141,75,NULL,'W91PP, r, raw','UGC 00279',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3042,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3042,34.45,0.4,77.6,1141,75,NULL,'HMCL, I, raw','UGC 00279',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3043,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3043,34.53,0.4,80.4,1141,NULL,NULL,'Malmquist cor.','UGC 00279',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3044,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3044,34.55,0.38,81.4,1141,75,NULL,'W91PP, r, cor','UGC 00279',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3045,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3045,34.59,0.39,82.8,1141,NULL,NULL,NULL,'UGC 00279',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3046,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3046,34.61,0.4,83.5,1141,75,NULL,'HMCL, I, cor','UGC 00279',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3047,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3047,34.61,0.38,83.7,1141,75,NULL,'W91PP, r, inv','UGC 00279',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3048,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3048,34.63,0.2,84.3,1141,74.4,NULL,NULL,'UGC 00279',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3049,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3049,34.66,0.4,85.4,1141,75,NULL,'HMCL, I, inv','UGC 00279',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3050,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3050,35.9,0.53,151,1142,70,NULL,NULL,'ESO 194-IG 019 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.96',0.23,NULL,NULL,NULL,NULL,NULL,1,7.064833,-48.66742,NULL,NULL,35979083573,562173180,8783955,16.96),(3051,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 14635',NULL,3051,40.3,0.16,1150,1143,70,NULL,'SN photometric redshift distance, z photo =0.317 +/- 0.029','SDSS-II SN 14635',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,7.06516666667,1.07661,0.061,NULL,66598486392,1040601349,16259396,NULL),(3052,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3052,36.95,0.12,245,1144,70,NULL,NULL,'2MASX J00281930-0014472',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000129,NULL,'15.7g',0.48,'E0',NULL,NULL,NULL,NULL,1,7.0804583,-0.24633,0.043,NULL,34399878330,537498098,8398407,15.7),(3053,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 20232',NULL,3053,39.35,0.2,741,1145,70,NULL,NULL,'SDSS-II SN 20232',NULL,'2013MNRAS.434.1443X',2013,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,7.08329166667,-0.05822,0.043,NULL,34399861849,537497841,8398403,NULL),(3054,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 20232','R',3054,39.93,0.21,797,1145,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20232',0.217716,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3055,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 20232','R',3055,40.14,0.13,877,1145,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20232',0.217716,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3056,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 20232',NULL,3056,39.82,0.1,920,1146,70,NULL,'SALT 2','SDSS J002820.00-000329.0',NULL,'2013ApJ...763...88C',2013,1,0.09,NULL,'G',0.0005,NULL,'19.8g',0.08,NULL,NULL,NULL,NULL,NULL,1,7.083375,-0.05808,0.043,NULL,34399861849,537497841,8398403,19.8),(3057,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 20232',NULL,3057,39.83,0.1,925,1146,70,NULL,'SALT 2, Malmquist cor.','SDSS J002820.00-000329.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3058,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3058,36.92,0.46,242,1147,70,NULL,NULL,'2MASX J00282066-1013443',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000099,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,7.086083,-10.22892,0.112,NULL,34570005811,540156340,8439942,16.9),(3059,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3059,35.52,0.8,127,1148,75,NULL,'W91PP, r','UGC 00278',NULL,'1997ApJS..109..333W',1997,1,1.5,'The 2MASX position refers to the northeastern arm.','G',0.000008,NULL,'15.12',0.3,'SBbc',NULL,NULL,NULL,NULL,1,7.089583,27.373,0.117,NULL,67200642764,1050010043,16406406,15.12),(3060,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3060,35.36,0.38,118,1148,75,NULL,'W91PP, r, raw','UGC 00278',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3061,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3061,35.41,0.43,121,1148,NULL,NULL,'Malmquist cor.','UGC 00278',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3062,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3062,35.53,0.38,128,1148,75,NULL,'W91PP, r, inv','UGC 00278',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3063,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3063,35.58,0.2,131,1148,74.4,NULL,NULL,'UGC 00278',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3064,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3064,35.58,0.38,131,1148,75,NULL,'W91PP, r, cor','UGC 00278',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3065,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3065,35.67,0.38,136,1148,NULL,NULL,NULL,'UGC 00278',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3066,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3066,34.03,0.2,64,1149,74.4,NULL,NULL,'UGC 00281',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',NULL,NULL,'15.32',0.5,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,7.092333,2.52725,0.069,NULL,66604780062,1040699688,16260932,15.32),(3067,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3067,34.09,0.41,65.7,1149,NULL,NULL,NULL,'UGC 00281',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3068,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3068,34.23,0.39,70.2,1149,NULL,NULL,'Malmquist cor.','UGC 00281',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3069,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3069,37.08,0.79,261,1150,70,NULL,NULL,'2MASX J00282675-2115109',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'17.02',0.35,NULL,NULL,NULL,NULL,NULL,1,7.1115417,-21.25319,0.088,NULL,35361576074,552524626,8633197,17.02),(3070,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 03180','RN',3070,40.08,0.2,830,1151,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03180',0.246952,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3071,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 03180','RN',3071,40.09,0.24,837,1151,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03180',0.246952,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3072,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3072,37.25,0.46,282,1152,70,NULL,NULL,'2MASX J00282891+1504366',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000075,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,7.12066666667,15.07678,0.153,NULL,66748066883,1042938545,16295914,17.7),(3073,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 14330','RN',3073,40.11,0.23,841,1153,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14330',0.252791,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3074,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 14330','RN',3074,40.13,0.19,847,1153,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14330',0.252791,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3075,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3075,33.89,0.8,60,1154,75,NULL,'W91PP, r','UGC 00284',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.71',1,'SAB(s)c',NULL,NULL,NULL,NULL,1,7.1432083,33.27231,0.221,NULL,67354499578,1052414055,16443969,14.71),(3076,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3076,33.95,0.38,61.7,1154,75,NULL,'W91PP, r, raw','UGC 00284',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3077,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3077,33.99,0.38,62.8,1154,75,NULL,'W91PP, r, inv','UGC 00284',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3078,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3078,34.16,0.38,67.9,1154,75,NULL,'W91PP, r, cor','UGC 00284',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3079,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3079,34.42,0.2,76.6,1154,74.4,NULL,NULL,'UGC 00284',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3080,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3080,34.57,0.46,81.9,1154,NULL,NULL,'Malmquist cor.','UGC 00284',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3081,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3081,34.61,0.45,83.5,1154,NULL,NULL,NULL,'UGC 00284',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3082,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3082,34.56,0.8,81.6,1155,75,NULL,'HMCL, I','MRK 0340',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.00003,NULL,'15.6',0.3,'Sc',NULL,NULL,NULL,NULL,1,7.144667,31.1555,0.201,NULL,67366882987,1052607546,16446992,15.6),(3083,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3083,34.21,0.37,69.6,1155,NULL,NULL,NULL,'MRK 0340',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3084,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3084,34.36,0.34,74.6,1155,NULL,NULL,'Malmquist cor.','MRK 0340',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3085,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3085,34.41,0.2,76.2,1155,74.4,NULL,NULL,'MRK 0340',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3086,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3086,34.52,0.4,80.3,1155,75,NULL,'HMCL, I, raw','MRK 0340',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3087,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3087,34.61,0.4,83.4,1155,75,NULL,'HMCL, I, inv','MRK 0340',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3088,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3088,34.68,0.4,86.2,1155,75,NULL,'HMCL, I, cor','MRK 0340',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3089,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 14346',NULL,3089,38.61,0.65,528,1156,70,NULL,'SN photometric redshift distance, z photo =0.132 +/- 0.051','SDSS-II SN 14346',NULL,'2011ApJ...738..162S',2011,1,0.03,NULL,'G',NULL,'PHOT','22.2g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,7.148917,-1.00372,0.035,NULL,34400337069,537505266,8398519,22.2),(3090,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 14346','R',3090,40.96,0.2,1280,1156,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14346',0.213291,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3091,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 14346','R',3091,41.12,0.3,1380,1156,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14346',0.213291,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3092,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 14465','RN',3092,39.29,0.28,681,1157,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 14465',0.059157,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3093,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 14465','RN',3093,41,0.53,1500,1157,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 14465',0.059157,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3094,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 13554',NULL,3094,40.5,0.14,1260,1158,70,NULL,'SN photometric redshift distance, z photo =0.353 +/- 0.029','SDSS-II SN 13554',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,7.156833,0.87183,0.033,NULL,66598586340,1040602911,16259420,NULL),(3095,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3095,33.7,0.49,55.1,1159,75,NULL,'IR','UGC 00286 NOTES01',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000057,NULL,'14.5',0.2,'Sbc: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,7.15925,2.95431,0.057,NULL,66595650843,1040557044,16258703,14.5),(3096,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 18741','RN',3096,41.22,0.35,1340,1160,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18741',0.311984,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3097,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 18741','RN',3097,41.41,0.34,1460,1160,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18741',0.311984,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3098,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 18741','N',3098,41.09,0.25,1650,1160,70,NULL,'SALT 2','SDSS-II SN 18741',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3099,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 18741','N',3099,41.12,0.25,1670,1160,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18741',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3100,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3100,35.27,0.48,113,1161,70,NULL,NULL,'IC 0019',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.0',0.4,'E',NULL,NULL,NULL,NULL,1,7.1645,-11.64078,0.076,NULL,34451288048,538301375,8410958,15),(3101,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3101,35.15,0.46,107,1162,70,NULL,NULL,'IC 0020',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00004,NULL,'15.6',0.6,NULL,NULL,NULL,NULL,NULL,1,7.165333,-13.01031,0.029,NULL,34449183721,538268495,8410445,15.6),(3102,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 12978',NULL,3102,39.12,0.16,667,1163,70,NULL,'SN photometric redshift distance, z photo =0.170 +/- 0.014','SDSS-II SN 12978',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,7.167167,0.14792,0.048,NULL,66598784186,1040606002,16259468,NULL),(3103,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 12978',NULL,3103,39.87,0.07,942,1163,70,NULL,'SALT 2','SDSS-II SN 12978',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3104,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 12978',NULL,3104,39.89,0.07,951,1163,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 12978',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3105,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3105,36.16,0.46,171,1164,70,NULL,NULL,'2MASX J00284034+1539147',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000092,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,7.16804166667,15.65406,0.153,NULL,66747386637,1042927916,16295748,16.9),(3106,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3106,39.64,0.08,848,1165,NULL,NULL,NULL,'2MASX J00284426-0005470',NULL,'2015MNRAS.453..868O',2015,1,0.15,NULL,'G',0.000102,NULL,'18.8g',0.11,'BrClG          AGN',NULL,NULL,NULL,NULL,1,7.1845,-0.09639,0.043,NULL,34399910821,537498606,8398415,18.8),(3107,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3107,39.61,0.04,837,1166,NULL,NULL,NULL,'WHL J002844.3-000547',NULL,'2015MNRAS.453..868O',2015,1,NULL,NULL,'GClstr',NULL,'PHOT',NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,7.184583,-0.09639,0.043,NULL,34399910821,537498606,8398415,NULL),(3108,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3108,37.31,0.46,290,1167,70,NULL,NULL,'2MASX J00284481+1444357',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000081,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,7.18679166667,14.74325,0.149,NULL,66747366777,1042927605,16295743,17.2),(3109,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3109,37.6,0.33,332,1168,70,NULL,NULL,'SDSS J002846.42+160730.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000083,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,7.19341666667,16.12517,0.153,NULL,67470061988,1054219718,16472183,18.3),(3110,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 02925','RN',3110,42.13,0.2,1930,1169,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02925',0.379753,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3111,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 02925','RN',3111,42.18,0.13,1980,1169,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 02925',0.379753,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3112,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3112,37.97,0.46,392,1170,70,NULL,NULL,'SDSS J002846.82-084530.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000077,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,7.195125,-8.75853,0.118,NULL,34618790888,540918607,8451853,18.5),(3113,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3113,37.73,0.46,352,1171,70,NULL,NULL,'SDSS J002848.38+151504.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000078,NULL,'18.8g',0.09,NULL,NULL,NULL,NULL,NULL,1,7.201583,15.25122,0.153,NULL,66747545931,1042930405,16295787,18.8),(3114,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3114,37.98,0.46,394,1172,70,NULL,NULL,'2MASX J00284929+1458446',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000086,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,7.205625,14.97906,0.149,NULL,66748063024,1042938484,16295913,17.7),(3115,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3115,37.6,0.33,332,1173,70,NULL,NULL,'2MASX J00285127+1607216',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000089,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,7.213625,16.12269,0.153,NULL,67470061789,1054219715,16472183,17.3),(3116,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 07479','R',3116,39.66,0.2,696,1174,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J002854.20-002434.0',0.2272,'2014arXiv1401.3317S',2014,1,0.21,NULL,'G',0.0001,NULL,'18.8g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,7.225833,-0.40947,0.037,NULL,34399934443,537498975,8398421,18.8),(3117,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 07479','R',3117,39.66,0.12,698,1174,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J002854.20-002434.0',0.2272,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3118,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 07479',NULL,3118,39.47,0.09,783,1174,70,NULL,'SALT 2','SDSS J002854.20-002434.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3119,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 07479',NULL,3119,39.48,0.09,787,1174,70,NULL,'SALT 2, Malmquist cor.','SDSS J002854.20-002434.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3120,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 21596','RN',3120,38.06,0.25,384,1175,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 21596',0.063318,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3121,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 21596','RN',3121,38.66,0.12,506,1175,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 21596',0.063318,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3122,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3122,39.58,0.09,826,1176,NULL,NULL,NULL,'2MASX J00285937+0020010',NULL,'2015MNRAS.453..868O',2015,1,0.18,NULL,'G',0.000117,NULL,'18.5g',0.14,'AGN',NULL,NULL,NULL,NULL,1,7.2472917,0.33353,0.048,NULL,66598933302,1040608332,16259505,18.5),(3123,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 07480','RN',3123,42.14,0.22,1930,1177,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 07480',0.385725,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3124,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 07480','RN',3124,42.63,0.25,2420,1177,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 07480',0.385725,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3125,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3125,38.21,0.33,439,1178,70,NULL,NULL,'SDSS J002900.49-011342.8',NULL,'2015arXiv151105856S',2015,1,0.28,'Companion to the galaxy PKS 0026-014.','G',0.000089,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,7.2520417,-1.22858,0.049,NULL,34408272301,537629254,8400457,17.7),(3126,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3126,35.33,0.48,116,1179,70,NULL,NULL,'MCG -02-02-025',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000103,NULL,'15.45',0.3,NULL,NULL,NULL,NULL,NULL,1,7.252583,-8.31844,0.112,NULL,34627428222,541053565,8453961,15.45),(3127,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 07702','RN',3127,37.42,0.13,281,1180,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 07702',0.082817,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3128,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3128,38.21,0.33,439,1181,70,NULL,NULL,'PKS 0026-014',NULL,'2015arXiv151105856S',2015,1,0.59,'2dF final data release has z = 0.08300 +- 0.00021.','G',0.000146,NULL,'16.69',0.41,'Sy?',NULL,NULL,NULL,'Sy ?',1,7.254125,-1.22828,0.049,NULL,34408272335,537629255,8400457,16.69),(3129,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3129,37.09,0.33,262,1182,70,NULL,NULL,'2MASX J00290143+0045490',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000064,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,7.255875,0.76369,0.041,NULL,66598564334,1040602567,16259415,17.9),(3130,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3130,36.24,0.46,177,1183,70,NULL,NULL,'2MASX J00290150+0021030',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000108,NULL,'15.8g',0.48,'NLAGN',NULL,NULL,NULL,NULL,1,7.256167,0.35083,0.033,NULL,66598935810,1040608372,16259505,15.8),(3131,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3131,37.25,0.46,282,1184,70,NULL,NULL,'2MASX J00290164+1550467',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000103,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,7.25670833333,15.84644,0.153,NULL,66744541680,1042883463,16295054,16.5),(3132,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3132,37.09,0.33,262,1185,70,NULL,NULL,'2MASX J00290210+0039280',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,7.2587917,0.65786,0.041,NULL,66599049479,1040610148,16259533,17.1),(3133,'Brightest Stars','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3133,29.14,0.4,6.73,1186,NULL,NULL,'3B + 3R mean','UGC 00288',NULL,'1997AstL...23..514G',1997,1,1.3,NULL,'G',0.000002,NULL,'16.0',0.8,'Im','Dwarf, field object',NULL,NULL,NULL,1,7.265,43.43167,0.333,NULL,67651368545,1057052633,16516447,16),(3134,'Brightest Stars','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3134,29.68,NULL,8.63,1186,NULL,NULL,'LF','UGC 00288',NULL,'1997AstL...23..514G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3135,'TRGB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3135,29.17,0.1,6.82,1186,74.4,NULL,NULL,'UGC 00288',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3136,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 1995aq','R',3136,41.82,NULL,1590,1187,65,NULL,'SALT','[PDG95a] J002904.30+075121.4',0.453,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,7.267917,7.85594,0.097,NULL,66839970907,1044374545,16318352,NULL),(3137,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 1995aq',NULL,3137,42.12,0.53,1830,1187,74.2,NULL,'SALT 2','[PDG95a] J002904.30+075121.4',0.453,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3138,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 1995aq',NULL,3138,42.69,0.39,2380,1187,70,NULL,'SALT','[PDG95a] J002904.30+075121.4',0.453,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3139,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 1995aq',NULL,3139,42.89,0.37,2600,1187,65,NULL,'SALT','[PDG95a] J002904.30+075121.4',0.453,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3140,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 03983',NULL,3140,40.07,0.27,1030,1188,70,NULL,'SN photometric redshift distance, z photo =0.279 +/- 0.044','SDSS-II SN 03983',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,7.275833,-0.25664,0.037,NULL,34400105326,537501645,8398463,NULL),(3141,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 03983','R',3141,41.09,0.27,1260,1188,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03983',0.308008,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3142,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 03983','R',3142,41.18,0.22,1320,1188,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03983',0.308008,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3143,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 03983',NULL,3143,41.03,0.17,1610,1188,70,NULL,'SALT 2','SDSS-II SN 03983',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3144,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 03983',NULL,3144,41.06,0.17,1630,1188,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 03983',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3145,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3145,34.57,0.8,82,1189,75,NULL,'HMCL, I','CGCG 500-032',NULL,'1997ApJS..109..333W',1997,1,0.8,NULL,'G',0.000033,NULL,'15.0',0.4,'SBab',NULL,NULL,NULL,NULL,1,7.279667,31.00278,0.205,NULL,67367735926,1052620873,16447201,15),(3146,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3146,34.42,0.4,76.6,1189,75,NULL,'HMCL, I, raw','CGCG 500-032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3147,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3147,34.58,0.4,82.3,1189,75,NULL,'HMCL, I, cor','CGCG 500-032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3148,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3148,34.58,0.4,82.6,1189,75,NULL,'HMCL, I, inv','CGCG 500-032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3149,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3149,29.73,NULL,8.81,1190,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00290',NULL,'2010Ap&SS.325..163P',2010,1,1.42,NULL,'G',0.000005,NULL,'16.7g',0.19,'Sdm',NULL,NULL,NULL,NULL,1,7.284875,15.89911,0.153,NULL,67469873427,1054216772,16472137,16.7),(3150,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3150,29.74,NULL,8.87,1190,NULL,NULL,NULL,'UGC 00290',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3151,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3151,29.77,NULL,8.99,1190,NULL,NULL,'Dipole + Quadrupole','UGC 00290',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3152,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3152,29.81,NULL,9.17,1190,NULL,NULL,'Dipole','UGC 00290',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3153,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3153,30.53,0.2,12.8,1190,74.4,NULL,NULL,'UGC 00290',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3154,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 15990','RN',3154,41.71,0.27,1790,1191,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15990',0.230159,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3155,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 15990','RN',3155,42.46,0.46,2520,1191,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15990',0.230159,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3156,'Faber-Jackson','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3156,34.26,0.44,71.1,1192,95,NULL,'Weighted Mean','NGC 0127',NULL,'1984ApJS...56...91D',1984,1,0.8,NULL,'G',0.00005,NULL,'15',0.6,'SA0^0^:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,7.30154166667,2.87269,0.057,NULL,66595616390,1040556506,16258695,15),(3157,'Faber-Jackson','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3157,34.74,0.63,88.7,1192,95,NULL,'Michard 1979b, c','NGC 0127',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3158,'Faber-Jackson','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3158,34.9,0.46,95.5,1192,95,NULL,'Michard 1979a','NGC 0127',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3159,'Tertiary','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3159,33.3,0.5,45.7,1192,95,NULL,NULL,'NGC 0127',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3160,'Black Hole','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3160,39.6,0.39,830,1193,NULL,NULL,NULL,'PG 0026+129',NULL,'2014ApJ...793..108W',2014,1,NULL,NULL,'QSO',NULL,NULL,'15.4V',NULL,'RQQ            Sy1',NULL,NULL,NULL,NULL,1,7.307083,13.26778,0.133,NULL,66752841548,1043013149,16297080,15.4),(3161,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3161,36.95,0.12,245,1194,70,NULL,NULL,'2MASX J00291390-0013070',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.10',0.18,NULL,NULL,NULL,NULL,NULL,1,7.30783333333,-0.21872,0.037,NULL,34400103441,537501616,8398462,18.1),(3162,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3162,37.56,0.46,325,1195,70,NULL,NULL,'2MASX J00291417-0101100',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000091,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,7.309167,-1.01933,0.049,NULL,34400351807,537505496,8398523,16.6),(3163,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3163,36.95,0.12,245,1196,70,NULL,NULL,'2MASX J00291470-0011180',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000091,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,7.3112917,-0.1885,0.058,NULL,34400102347,537501599,8398462,16.2),(3164,'Faber-Jackson','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3164,32.72,0.37,35,1197,95,NULL,'Weighted Mean','NGC 0128',NULL,'1984ApJS...56...91D',1984,1,3,NULL,'G',0.000053,NULL,'12.77',0.9,'S0 pec sp      LINER','in a pair',NULL,NULL,NULL,1,7.31275,2.86406,0.057,NULL,66595616558,1040556508,16258695,12.77),(3165,'Faber-Jackson','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3165,32.73,0.46,35.2,1197,95,NULL,'Michard 1979a','NGC 0128',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3166,'Faber-Jackson','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3166,33.14,0.63,42.5,1197,95,NULL,'Michard 1979b, c','NGC 0128',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3167,'Faber-Jackson','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3167,34.93,0.81,96.8,1197,55,NULL,'Visvanathan & Sandage 1979','NGC 0128',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3168,'Tertiary','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3168,33.3,0.5,45.7,1197,95,NULL,NULL,'NGC 0128',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3169,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3169,32.2,0.45,27.5,1197,NULL,NULL,'K','NGC 0128',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3170,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3170,33.81,0.4,57.8,1197,NULL,NULL,'mean','NGC 0128',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3171,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 11515','RN',3171,40.88,0.24,1190,1198,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 11515',0.253991,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3172,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 11515','RN',3172,41.05,0.37,1290,1198,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 11515',0.253991,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3173,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3173,36.95,0.12,245,1199,70,NULL,NULL,'2MASX J00291736-0000150',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000089,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,7.3222917,-0.00417,0.058,NULL,34399880819,537498137,8398408,16.8),(3174,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3174,36.95,0.12,245,1200,70,NULL,NULL,'2MASX J00292216-0008200',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000102,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,7.342375,-0.13906,0.058,NULL,34400070684,537501104,8398454,17.1),(3175,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3175,34.65,0.8,85.3,1201,75,NULL,'HMCL, I','UGC 00294',NULL,'1997ApJS..109..333W',1997,1,1.12,NULL,'G',0.000027,NULL,'15.57',0.09,'Sd',NULL,NULL,NULL,NULL,1,7.349667,31.38106,0.185,NULL,67367064064,1052610376,16447037,15.57),(3176,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3176,34.61,NULL,83.5,1201,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00294',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3177,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3177,34.62,NULL,83.9,1201,NULL,NULL,'Dipole + Quadrupole','UGC 00294',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3178,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3178,34.64,NULL,84.7,1201,NULL,NULL,'Dipole','UGC 00294',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3179,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3179,34.67,0.4,85.9,1201,75,NULL,'HMCL, I, raw','UGC 00294',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3180,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3180,34.7,NULL,87.3,1201,NULL,NULL,NULL,'UGC 00294',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3181,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3181,34.74,0.4,88.5,1201,75,NULL,'HMCL, I, inv','UGC 00294',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3182,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3182,34.83,0.4,92.7,1201,75,NULL,'HMCL, I, cor','UGC 00294',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3183,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3183,34.85,0.53,93.5,1201,NULL,NULL,'Malmquist cor.','UGC 00294',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3184,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3184,34.95,0.2,97.7,1201,74.4,NULL,NULL,'UGC 00294',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3185,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3185,35.01,0.5,100,1201,NULL,NULL,NULL,'UGC 00294',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3186,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 21510','R',3186,39.09,0.18,571,1202,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007sh','SDSS J002924.56+004952.0',0.149566,'2014arXiv1401.3317S',2014,1,0.16,NULL,'G',NULL,NULL,'18.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,7.352375,0.83111,0.045,NULL,66598680894,1040604388,16259443,18.6),(3187,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 21510','R',3187,39.43,0.14,670,1202,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007sh','SDSS J002924.56+004952.0',0.149566,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3188,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 18039','RN',3188,41.85,0.2,1770,1203,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 18039',0.326819,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3189,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 18039','RN',3189,42.36,0.24,2240,1203,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 18039',0.326819,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3190,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3190,38.23,0.33,442,1204,70,NULL,NULL,'SDSS J002928.21-004259.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000077,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,7.36758333333,-0.71656,0,NULL,34400273315,537504270,8398504,18.6),(3191,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3191,36.95,0.12,245,1205,70,NULL,NULL,'MCG +00-02-054',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000122,NULL,'15.5g',0.53,'BrClG',NULL,NULL,NULL,NULL,1,7.368417,-0.21261,0.048,NULL,34400047933,537500748,8398449,15.5),(3192,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3192,38.34,0.46,465,1206,70,NULL,NULL,'2MASX J00292916+0002569',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000091,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,7.37170833333,0.04906,0.058,NULL,66598964948,1040608827,16259512,17.7),(3193,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3193,37.63,0.46,336,1207,70,NULL,NULL,'2MASX J00292938-0100170',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.12',0.19,NULL,NULL,NULL,NULL,NULL,1,7.3725,-1.00489,0.049,NULL,34400339920,537505311,8398520,18.12),(3194,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 07868','RN',3194,42.75,0.24,2840,1208,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 07868',0.252852,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3195,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 07868','RN',3195,42.98,0.23,3160,1208,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 07868',0.252852,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3196,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3196,36.01,0.54,159,1209,70,NULL,NULL,'MCG -02-02-026',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000047,NULL,'15.9',0.4,NULL,NULL,NULL,NULL,NULL,1,7.38241666667,-13.99347,0.063,NULL,34456488536,538382633,8412228,15.9),(3197,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3197,36.95,0.12,245,1210,70,NULL,NULL,'2MASX J00293244-0033560',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000081,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,7.3850417,-0.56558,0,NULL,34400391917,537506123,8398533,16.3),(3198,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3198,36.95,0.12,245,1211,70,NULL,NULL,'MCG +00-02-055',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000102,NULL,'15.9g',0.44,'E0',NULL,NULL,NULL,NULL,1,7.3982917,-0.23517,0.048,NULL,34400020453,537500319,8398442,15.9),(3199,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3199,32.85,0.2,37.2,1212,74.4,NULL,NULL,'KUG 0027+001',NULL,'2013AJ....146...86T',2013,1,0.78,'The APM position is centered 6.5 arcsec south of the nucleus.','G',0.000051,NULL,'15.2g',0.49,'Spiral',NULL,NULL,NULL,NULL,1,7.409917,0.41036,0.045,NULL,66599225938,1040612905,16259576,15.2),(3200,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3200,38.23,0.33,442,1213,70,NULL,NULL,'SDSS J002939.11-004823.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00008,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,7.413,-0.80647,0,NULL,34400197392,537503084,8398485,17.9),(3201,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3201,33.21,0.74,43.9,1214,NULL,NULL,NULL,'CGCG 434-016',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000093,NULL,'15.5',0.4,NULL,NULL,NULL,NULL,NULL,1,7.414875,11.60153,0.149,NULL,66749790454,1042965475,16296335,15.5),(3202,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3202,33.25,0.2,44.7,1214,74.4,NULL,NULL,'CGCG 434-016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3203,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3203,33.38,0.69,47.4,1214,NULL,NULL,'Malmquist cor.','CGCG 434-016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3204,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3204,33.69,0.48,54.6,1215,70,NULL,NULL,'ESO 194- G 021',NULL,'2014MNRAS.445.2677S',2014,1,1.5,'ESO-LV gives v= 2300+/-10 km/sec.','G',0.000077,NULL,'12.15',1.3,'SB(rl)0^0',NULL,NULL,NULL,NULL,1,7.4235417,-51.52067,NULL,NULL,36035693991,563057718,8797776,12.15),(3205,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3205,34.35,0.8,74.3,1216,75,NULL,'HMCL, I','IC 1552',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.00003,NULL,'15.33',0.2,'Sc','Isolated galaxy',NULL,NULL,NULL,1,7.432125,21.47683,0.057,NULL,67502907491,1054732929,16480202,15.33),(3206,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3206,34.42,0.49,76.5,1216,75,NULL,'IR','IC 1552',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3207,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3207,34.59,0.4,82.7,1216,75,NULL,'HMCL, I, raw','IC 1552',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3208,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3208,34.76,0.4,89.3,1216,75,NULL,'HMCL, I, inv','IC 1552',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3209,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3209,34.82,0.4,92,1216,75,NULL,'HMCL, I, cor','IC 1552',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3210,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3210,36.95,0.12,245,1217,70,NULL,NULL,'2MASX J00294531-0011485',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000097,NULL,'17.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,7.438833,-0.19681,0.048,NULL,34400021278,537500332,8398442,17.5),(3211,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 12879','R',3211,41.38,0.28,1380,1218,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 12879',0.364989,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',NULL,'PHOT','22.1g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,7.44920833333,-0.162,0.048,NULL,34400028327,537500442,8398444,22.1),(3212,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 12879',NULL,3212,40.83,0.31,1470,1218,70,NULL,'SN photometric redshift distance, z photo =0.429 +/- 0.090','SDSS-II SN 12879',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3213,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 12879','R',3213,41.52,0.25,1480,1218,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 12879',0.364989,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3214,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 12879',NULL,3214,41.78,0.23,2270,1218,70,NULL,'SALT 2','SDSS-II SN 12879',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3215,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 12879',NULL,3215,41.83,0.23,2320,1218,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 12879',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3216,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 01135','RN',3216,40,0.1,815,1219,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01135',0.229893,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3217,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 01135','RN',3217,40.74,0.19,1140,1219,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01135',0.229893,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3218,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3218,37.14,0.46,268,1220,70,NULL,NULL,'2MASX J00294935-0114055',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000113,NULL,'15.8g',0.41,'E0',NULL,NULL,NULL,NULL,1,7.455625,-1.23492,0.048,NULL,34408482412,537632537,8400508,15.8),(3219,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3219,37.54,0.61,323,1220,70,NULL,NULL,'2MASX J00294935-0114055',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3220,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3220,34.64,0.8,84.8,1221,75,NULL,'CF, r','UGC 00299',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.00003,NULL,'14.96',0.7,'Sc',NULL,NULL,NULL,NULL,1,7.4725417,31.39336,0.185,NULL,67367070757,1052610480,16447038,14.96),(3221,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3221,34.64,0.8,84.9,1221,75,NULL,'W91PP, r','UGC 00299',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3222,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3222,34.64,0.8,84.9,1221,75,NULL,'HMCL, I','UGC 00299',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3223,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3223,35.07,0.4,103,1221,75,NULL,'HMCL, I, raw','UGC 00299',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3224,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3224,35.14,0.38,107,1221,75,NULL,'W91PP, r, raw','UGC 00299',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3225,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3225,35.24,0.4,112,1221,75,NULL,'HMCL, I, inv','UGC 00299',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3226,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3226,35.25,0.46,112,1221,NULL,NULL,'Malmquist cor.','UGC 00299',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3227,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3227,35.3,0.38,115,1221,75,NULL,'W91PP, r, inv','UGC 00299',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3228,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3228,35.32,0.4,116,1221,75,NULL,'HMCL, I, cor','UGC 00299',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3229,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3229,35.36,0.38,118,1221,75,NULL,'CF, r, raw','UGC 00299',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3230,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3230,35.38,0.38,119,1221,75,NULL,'W91PP, r, cor','UGC 00299',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3231,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3231,35.43,0.2,122,1221,74.4,NULL,NULL,'UGC 00299',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3232,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3232,35.45,0.42,123,1221,NULL,NULL,NULL,'UGC 00299',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3233,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3233,35.52,0.38,127,1221,75,NULL,'CF, r, inv','UGC 00299',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3234,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3234,35.62,0.38,133,1221,75,NULL,'CF, r, cor','UGC 00299',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3235,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 03888','RN',3235,39.91,0.12,860,1222,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 03888',0.118243,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3236,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 03888','RN',3236,39.98,0.23,885,1222,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 03888',0.118243,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3237,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3237,34.77,0.52,90.1,1223,70,NULL,NULL,'2MASX J00295739-0517375',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.21',NULL,NULL,NULL,NULL,NULL,NULL,1,7.489167,-5.29394,0.157,NULL,34585805797,540403215,8443800,15.21),(3238,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 19796','RN',3238,41.25,0.28,1460,1224,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19796',0.223033,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3239,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 19796','RN',3239,42.13,0.3,2180,1224,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19796',0.223033,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3240,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3240,37.59,0.46,330,1225,70,NULL,NULL,'2MASX J00295880-0932421',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.0001,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,7.495,-9.545,0.111,NULL,34617424912,540897264,8451519,16.7),(3241,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 06431','R',3241,40.64,0.26,1070,1226,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06431',0.255354,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,7.50845833333,-0.70386,0,NULL,34400475541,537507430,8398553,NULL),(3242,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 06431','R',3242,40.98,0.23,1250,1226,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06431',0.255354,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3243,'Tully est','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3243,31.26,0.8,17.8,1227,75,NULL,NULL,'UGC 00300',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000013,NULL,'18.',1.3,'Im:',NULL,NULL,NULL,NULL,1,7.51708333333,3.51306,0.033,NULL,66596009892,1040562654,16258791,18),(3244,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 20960','RN',3244,41.23,0.75,1450,1228,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20960',0.214824,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3245,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 20960','RN',3245,41.89,0.45,1960,1228,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 20960',0.214824,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3246,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3246,33.08,0.47,41.3,1229,NULL,NULL,'H','MCG -02-02-030',NULL,'2007A&A...465...71T',2007,1,1.62,NULL,'G',0.00002,NULL,'13.5g',0.76,'(R)SB(r)a','in a pair',NULL,NULL,NULL,1,7.53045833333,-11.11364,0.103,NULL,34573147233,540205425,8440709,13.5),(3247,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3247,33.08,0.45,41.4,1229,NULL,NULL,'K','MCG -02-02-030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3248,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3248,33.11,0.46,41.8,1229,NULL,NULL,'J','MCG -02-02-030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3249,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3249,33.28,0.4,45.2,1229,NULL,NULL,'mean','MCG -02-02-030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3250,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 20265','R',3250,41.67,0.44,1570,1230,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20265',0.375684,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',NULL,'PHOT','21.4g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,7.536125,-0.11128,0.048,NULL,34400039491,537500617,8398447,21.4),(3251,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 20265',NULL,3251,40.99,0.46,1580,1230,70,NULL,'SN photometric redshift distance, z photo =0.471 +/- 0.162','SDSS-II SN 20265',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3252,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 20265',NULL,3252,41.47,0.31,1970,1230,70,NULL,'SALT 2','SDSS-II SN 20265',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3253,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 20265',NULL,3253,41.53,0.31,2020,1230,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20265',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3254,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3254,38.17,0.46,430,1231,70,NULL,NULL,'SDSS J003008.88+144931.9',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000068,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,7.537,14.82556,0.137,NULL,66746723063,1042917547,16295586,18.8),(3255,'Horizontal Branch','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3255,24.55,0.12,0.812,1232,NULL,NULL,NULL,'Andromeda XXV',NULL,'2011ApJ...732...76R',2011,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,7.537083,46.85194,0.305,0,67658313501,1057161148,16518142,NULL),(3256,'TRGB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3256,24.33,0.21,0.736,1232,NULL,NULL,NULL,'Andromeda XXV',NULL,'2012ApJ...758...11C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3257,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 20331','R',3257,39.71,0.27,738,1233,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20331',0.184513,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,7.5394583,1.24603,0.069,NULL,66603147857,1040674185,16260534,NULL),(3258,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 20331','R',3258,39.81,0.18,774,1233,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20331',0.184513,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3259,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3259,36.95,0.12,245,1234,70,NULL,NULL,'2MASX J00301042+0001488',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00009,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,7.5435417,0.03031,0.048,NULL,66598851582,1040607055,16259485,16.9),(3260,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3260,34.34,0.4,73.8,1235,NULL,NULL,'mean','NGC 0132',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000026,NULL,'13.45',1.4,'SAB(s)bc',NULL,NULL,NULL,NULL,1,7.544625,2.09344,0.029,NULL,66605444952,1040710077,16261094,13.45),(3261,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3261,34.39,0.45,75.6,1235,NULL,NULL,'K','NGC 0132',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3262,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3262,34.44,0.47,77.4,1235,NULL,NULL,'H','NGC 0132',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3263,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3263,34.45,0.46,77.7,1235,NULL,NULL,'J','NGC 0132',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3264,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 08799','RN',3264,42.84,0.27,2620,1236,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 08799',0.41039,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3265,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 08799','RN',3265,43.15,0.29,3030,1236,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 08799',0.41039,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3266,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 07350','R',3266,40.24,0.36,965,1237,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07350',0.156223,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,7.5635417,-0.78711,0.043,NULL,34400233705,537503651,8398494,NULL),(3267,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 07350','R',3267,40.39,0.46,1040,1237,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07350',0.156223,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3268,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3268,36.95,0.12,245,1238,70,NULL,NULL,'2MASX J00301688-0026081',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.54',0.21,NULL,NULL,NULL,NULL,NULL,1,7.570375,-0.43564,0.063,NULL,34400579623,537509056,8398579,17.54),(3269,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 04386','RN',3269,38.42,0.82,431,1239,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04386',0.120361,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3270,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3270,36.95,0.12,245,1240,70,NULL,NULL,'2MASX J00302142-0031211',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000088,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,7.5892917,-0.52269,0.063,NULL,34400457663,537507150,8398549,17.2),(3271,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3271,39.65,0.08,852,1241,NULL,NULL,NULL,'2MASX J00302168-0027061',NULL,'2015MNRAS.453..868O',2015,1,0.27,NULL,'G',0.000164,NULL,'18.3g',0.15,'BLAGN',NULL,NULL,NULL,'Sy 1',1,7.5902083,-0.45158,0.063,NULL,34400578247,537509035,8398578,18.3),(3272,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3272,31.56,0.8,20.5,1242,75,NULL,'A82, H','NGC 0134',NULL,'1997ApJS..109..333W',1997,1,8.5,'Extended HIPASS source','G',0.00001,NULL,'11.40',2,'SAB(s)bc       HII','in a pair',NULL,NULL,NULL,1,7.59154166667,-33.24403,NULL,NULL,34883298808,545051543,8516430,11.4),(3273,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3273,31.57,0.8,20.7,1242,75,NULL,'MAT, I','NGC 0134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3274,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3274,30.87,0.4,14.9,1242,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 0134',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3275,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3275,31.14,0.4,16.9,1242,73,NULL,'opt','NGC 0134',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3276,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3276,31.15,0.47,17,1242,75,NULL,'A82, H, raw','NGC 0134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3277,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3277,31.18,0.43,17.2,1242,75,NULL,'MAT, I, raw','NGC 0134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3278,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3278,31.23,0.35,17.6,1242,NULL,NULL,NULL,'NGC 0134',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3279,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3279,31.23,0.39,17.6,1242,NULL,NULL,'Malmquist cor.','NGC 0134',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3280,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3280,31.26,0.43,17.9,1242,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0134',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3281,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3281,31.27,0.43,18,1242,75,NULL,'3.6 micron, color corrected','NGC 0134',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3282,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3282,31.31,0.32,18.3,1242,85,NULL,'I, raw','NGC 0134',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3283,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3283,31.37,0.47,18.8,1242,75,NULL,'A82, H, inv','NGC 0134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3284,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3284,31.38,0.32,18.9,1242,85,NULL,'I, inv','NGC 0134',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3285,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3285,31.39,0.4,19,1242,75,NULL,'B','NGC 0134',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3286,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3286,31.41,0.43,19.1,1242,75,NULL,'MAT, I, cor','NGC 0134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3287,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3287,31.42,0.47,19.3,1242,75,NULL,'A82, H, cor','NGC 0134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3288,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3288,31.47,0.43,19.7,1242,75,NULL,'MAT, I, inv','NGC 0134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3289,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3289,31.5,0.2,20,1242,74.4,NULL,NULL,'NGC 0134',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3290,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3290,31.91,0.29,24.1,1242,NULL,NULL,NULL,'NGC 0134',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3291,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3291,36.95,0.12,245,1243,70,NULL,NULL,'2MASX J00302467+0009205',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000084,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,7.60295833333,0.15567,0.048,NULL,66599068416,1040610444,16259538,17.5),(3292,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 13873','RN',3292,42.1,0.19,2040,1244,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13873',0.287844,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3293,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 13873','RN',3293,42.44,0.31,2390,1244,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13873',0.287844,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3294,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 21872','R',3294,39.93,0.26,789,1245,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 21872',0.228469,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,7.6132917,-0.59139,0.063,NULL,34400500804,537507825,8398559,NULL),(3295,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 21872','R',3295,39.99,0.3,809,1245,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21872',0.228469,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3296,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3296,36.24,0.58,177,1246,70,NULL,NULL,'FAIRALL 0656',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'16.14',0.31,NULL,NULL,NULL,NULL,NULL,1,7.622375,-43.09031,NULL,NULL,38128702597,595760978,9308765,16.14),(3297,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3297,34.1,0.49,66.2,1247,75,NULL,'IR','MCG -02-02-033',NULL,'2011yCatp016004901K',2011,1,1.36,NULL,'G',0.000085,NULL,'14.6g',0.43,'SB?(s?)b: II-III:',NULL,NULL,NULL,NULL,1,7.6242917,-8.78331,0.131,NULL,34617077589,540891837,8451434,14.6),(3298,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3298,36.38,0.46,189,1248,70,NULL,NULL,'2MASX J00303293+1456357',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00009,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,7.63725,14.94317,0.137,NULL,66746896801,1042920262,16295629,16.5),(3299,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2006jn',NULL,3299,39.69,0.09,865,1249,70,NULL,'Hubble residual 0.02 for z0.22470','SDSS J003039.02+000831.2',NULL,'2011ApJ...740...92G',2011,1,0.11,NULL,'G',0.0005,NULL,'19.3g',0.09,NULL,NULL,NULL,NULL,NULL,1,7.662625,0.142,0.048,NULL,66599072559,1040610508,16259539,19.3),(3300,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 14846','R',3300,40.31,0.19,942,1249,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006jn','SDSS J003039.02+000831.2',0.2247,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3301,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 14846','R',3301,40.36,0.12,962,1249,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006jn','SDSS J003039.02+000831.2',0.2247,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3302,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2006jn',NULL,3302,40.23,0.09,1110,1249,70,NULL,'SALT 2','SDSS J003039.02+000831.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3303,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2006jn',NULL,3303,40.24,0.09,1120,1249,70,NULL,'SALT 2, Malmquist cor.','SDSS J003039.02+000831.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3304,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 03889',NULL,3304,39.61,0.28,837,1250,70,NULL,'SN photometric redshift distance, z photo =0.219 +/- 0.035','SDSS-II SN 03889',NULL,'2011ApJ...738..162S',2011,1,0.11,NULL,'G',NULL,'PHOT','20.8g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,7.688875,-0.43806,0.063,NULL,34400453931,537507092,8398548,20.8),(3305,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 03889','R',3305,40.39,0.18,972,1250,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03889',0.229297,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3306,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 03889','R',3306,40.51,0.26,1030,1250,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03889',0.229297,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3307,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3307,35.1,0.2,105,1251,74.4,NULL,NULL,'ESO 410- G 016',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000023,NULL,'14.73',0.5,'Sb','Field galaxy',NULL,NULL,NULL,1,7.69133333333,-29.34292,NULL,NULL,34889115712,545142433,8517850,14.73),(3308,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3308,35.31,0.44,115,1251,NULL,NULL,NULL,'ESO 410- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3309,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3309,35.33,0.44,117,1251,NULL,NULL,'Malmquist cor.','ESO 410- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3310,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3310,36.24,0.59,177,1252,70,NULL,NULL,'2MASX J00304937-5728258',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'16.53',0.33,NULL,NULL,NULL,NULL,NULL,1,7.705833,-57.47386,0,NULL,36221398121,565959345,8843114,16.53),(3311,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3311,36.95,0.12,245,1253,70,NULL,NULL,'2MASX J00305072+0009170',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.0001,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,7.711333,0.15467,0.048,NULL,66599067266,1040610426,16259537,16.7),(3312,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2005kp',NULL,3312,37.97,0.11,354,1254,74.2,NULL,'SALT 2','APMUKS(BJ) B002819.57-005941.4',0.11,'2010ApJ...716..712A',2010,1,0.1,NULL,'G',0.0005,NULL,'20.44',0.07,NULL,NULL,NULL,NULL,NULL,1,7.721875,-0.71867,0.047,NULL,34400174253,537502722,8398480,20.44),(3313,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2005kp',NULL,3313,38.43,0.03,437,1254,70,NULL,'SDSS-II SN 08719','APMUKS(BJ) B002819.57-005941.4',0.11,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3314,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 08719','R',3314,38.68,0.18,488,1254,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005kp','APMUKS(BJ) B002819.57-005941.4',0.1178,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3315,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2005kp',NULL,3315,38.45,0.06,490,1254,70,NULL,'Hubble residual 0.07 for z0.11780','APMUKS(BJ) B002819.57-005941.4',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3316,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2005kp',NULL,3316,38.72,0.12,500,1254,70,NULL,'SDSS-II SN 08719, SALT 2','APMUKS(BJ) B002819.57-005941.4',0.11,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3317,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2005kp',NULL,3317,38.72,0.1,500,1254,65,NULL,'SALT2','APMUKS(BJ) B002819.57-005941.4',0.11,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3318,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 08719','R',3318,38.83,0.09,522,1254,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005kp','APMUKS(BJ) B002819.57-005941.4',0.1178,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3319,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2005kp',NULL,3319,38.62,0.06,530,1254,70,NULL,'SALT 2','APMUKS(BJ) B002819.57-005941.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3320,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2005kp',NULL,3320,38.63,0.06,532,1254,70,NULL,'SALT 2, Malmquist cor.','APMUKS(BJ) B002819.57-005941.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3321,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2005kp',NULL,3321,38.95,0.11,556,1254,65,NULL,'MLCS2k2','APMUKS(BJ) B002819.57-005941.4',0.11,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3322,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 15917','RN',3322,40.06,0.19,921,1255,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 15917',0.114245,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3323,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 15917','RN',3323,40.49,0.28,1120,1255,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 15917',0.114245,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3324,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3324,39.55,0.09,811,1256,NULL,NULL,NULL,'2MASX J00305682-0010072',NULL,'2015MNRAS.453..868O',2015,1,0.18,NULL,'G',0.0001,NULL,'18.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,7.73675,-0.16861,0.053,NULL,34399653926,537494592,8398353,18.6),(3325,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3325,35.86,0.63,149,1257,70,NULL,NULL,'MCG -02-02-036',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00012,NULL,'15.32',0.4,'Sb',NULL,NULL,NULL,NULL,1,7.742375,-9.404,0.131,NULL,34617294611,540895228,8451487,15.32),(3326,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 15489',NULL,3326,40.47,0.25,1240,1258,70,NULL,'SN photometric redshift distance, z photo =0.347 +/- 0.054','SDSS-II SN 15489',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,7.752583,-0.07103,0.053,NULL,34399664260,537494754,8398355,NULL),(3327,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 15489',NULL,3327,41.22,0.17,1750,1258,70,NULL,'SALT 2','SDSS-II SN 15489',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3328,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 15489',NULL,3328,41.28,0.17,1800,1258,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15489',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3329,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 07656','R',3329,41.73,0.31,1600,1259,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07656',0.387152,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,7.7547917,1.01067,0.053,NULL,66603290133,1040676408,16260568,NULL),(3330,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 07656','R',3330,42.23,0.34,2010,1259,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07656',0.387152,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3331,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 07656',NULL,3331,41.59,0.01,2080,1259,70,NULL,'SN photometric redshift distance, z photo =0.697 +/- 0.003','SDSS-II SN 07656',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3332,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3332,38.52,0.46,505,1260,70,NULL,NULL,'2MASX J00310831+0022034',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000087,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,7.784875,0.36744,0.089,NULL,66598291129,1040598298,16259348,18.1),(3333,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3333,35.13,0.5,106,1261,70,NULL,NULL,'2MASX J00311062-5629557',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.05',0.48,'S0',NULL,NULL,NULL,NULL,1,7.79425,-56.49892,0,NULL,36219452243,565928941,8842639,16.05),(3334,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 13477','R',3334,41.61,0.24,1530,1262,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13477',0.365325,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,7.80525,-0.70839,0.047,NULL,34408892802,537638950,8400608,NULL),(3335,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 13477','R',3335,41.79,0.3,1670,1262,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13477',0.365325,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3336,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3336,34.64,0.48,84.6,1263,70,NULL,NULL,'6dF J0031140-365114',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,7.808333,-36.85389,NULL,NULL,34651053051,541422703,8459729,13.8),(3337,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3337,34.67,0.4,85.8,1264,NULL,NULL,'mean','MCG -01-02-025',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00015,NULL,'14.5',0.7,'SA(r)b:',NULL,NULL,NULL,NULL,1,7.80875,-7.84078,0.16,NULL,34627921615,541061275,8454082,14.5),(3338,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3338,34.71,0.35,87.5,1264,NULL,NULL,'Malmquist cor.','MCG -01-02-025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3339,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3339,34.88,0.47,94.4,1264,NULL,NULL,'H','MCG -01-02-025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3340,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3340,34.89,0.2,95.1,1264,74.4,NULL,NULL,'MCG -01-02-025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3341,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3341,34.98,0.46,98.9,1264,NULL,NULL,'J','MCG -01-02-025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3342,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3342,35.01,0.45,100,1264,NULL,NULL,'K','MCG -01-02-025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3343,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3343,35.02,0.31,101,1264,NULL,NULL,NULL,'MCG -01-02-025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3344,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3344,35.21,0.4,110,1265,NULL,NULL,'mean','NGC 0143',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000033,NULL,'15.21',0.2,'SB(r)b? sp',NULL,NULL,NULL,NULL,1,7.81508333333,-22.55994,0.083,NULL,35325164456,551955694,8624307,15.21),(3345,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3345,35.29,0.49,114,1265,75,NULL,'IR','NGC 0143',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3346,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3346,35.4,0.47,120,1265,NULL,NULL,'H','NGC 0143',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3347,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3347,35.46,0.42,124,1265,NULL,NULL,'Malmquist cor.','NGC 0143',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3348,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3348,35.54,0.4,128,1265,NULL,NULL,NULL,'NGC 0143',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3349,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3349,35.58,0.2,131,1265,74.4,NULL,NULL,'NGC 0143',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3350,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3350,33.84,0.8,58.6,1266,75,NULL,'CF, r','UGC 00310',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000007,NULL,'14.81',0.3,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,7.82375,28.99375,0.141,NULL,67319432536,1051866133,16435408,14.81),(3351,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3351,33.84,0.8,58.7,1266,75,NULL,'W91PP, r','UGC 00310',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3352,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3352,33.37,0.38,47.3,1266,75,NULL,'CF, r, inv','UGC 00310',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3353,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3353,33.41,0.38,48.1,1266,75,NULL,'CF, r, raw','UGC 00310',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3354,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3354,33.51,0.2,50.4,1266,74.4,NULL,NULL,'UGC 00310',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3355,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3355,33.7,0.33,54.8,1266,NULL,NULL,NULL,'UGC 00310',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3356,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3356,33.73,0.38,55.8,1266,75,NULL,'W91PP, r, inv','UGC 00310',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3357,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3357,33.78,0.38,56.9,1266,75,NULL,'W91PP, r, raw','UGC 00310',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3358,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3358,33.79,0.38,57.3,1266,75,NULL,'CF, r, cor','UGC 00310',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3359,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3359,34.02,0.38,63.7,1266,75,NULL,'W91PP, r, cor','UGC 00310',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3360,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3360,34.16,0.27,67.8,1266,NULL,NULL,'Malmquist cor.','UGC 00310',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3361,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3361,29.98,NULL,9.91,1267,NULL,NULL,NULL,'ESO 473- G 024',NULL,'2013AJ....145..101K',2013,1,1.1,NULL,'G',0.000003,NULL,'16.1B',0.6,'IB(s)m',NULL,NULL,NULL,NULL,1,7.84379166667,-22.76597,0.08,NULL,35325243420,551956928,8624327,16.1),(3362,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 18713','R',3362,40.24,0.11,1020,1268,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2007lz','SDSS J003123.16+001910.2',0.094606,'2014arXiv1401.3317S',2014,1,0.12,NULL,'G',NULL,NULL,'20.0g',0.07,NULL,NULL,NULL,NULL,NULL,1,7.8465417,0.3195,0.089,NULL,66598418195,1040600284,16259379,20),(3363,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 18713','R',3363,40.4,0.22,1100,1268,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2007lz','SDSS J003123.16+001910.2',0.094606,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3364,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3364,33.65,0.2,53.7,1269,74.4,NULL,NULL,'UGC 00312',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.00001,NULL,'13.88',0.7,'SBd','in a pair',NULL,NULL,NULL,1,7.849625,8.46683,0.141,NULL,66836689062,1044323266,16317551,13.88),(3365,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3365,33.69,0.43,54.6,1269,75,NULL,'3.6 micron, color corrected','UGC 00312',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3366,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3366,33.78,0.43,57.1,1269,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00312',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3367,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 15563','RN',3367,40.22,0.11,965,1270,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15563',0.148662,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3368,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 15563','RN',3368,41.01,0.2,1390,1270,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15563',0.148662,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3369,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 08891','RN',3369,39.1,0.35,624,1271,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08891',0.060461,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3370,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 08891','RN',3370,39.74,0.28,835,1271,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 08891',0.060461,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3371,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3371,38.01,0.46,400,1272,70,NULL,NULL,'2MASX J00312744+1605021',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000085,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,7.86425,16.08389,0.125,NULL,67473444558,1054272571,16473008,17.5),(3372,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3372,34.79,0.8,91,1273,75,NULL,'MAT, I','ESO 539- G 014',NULL,'1997ApJS..109..333W',1997,1,1.81,NULL,'G',0.00002,NULL,'15.60',0.13,'Sd',NULL,NULL,NULL,NULL,1,7.867375,-19.76131,0.071,NULL,35365982461,552593475,8634273,15.6),(3373,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3373,34.57,0.43,82,1273,75,NULL,'MAT, I, raw','ESO 539- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3374,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3374,34.59,NULL,82.6,1273,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 539- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3375,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3375,34.59,NULL,82.9,1273,NULL,NULL,'Dipole + Quadrupole','ESO 539- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3376,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3376,34.6,NULL,83.3,1273,NULL,NULL,'Dipole','ESO 539- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3377,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3377,34.61,0.49,83.5,1273,75,NULL,'IR','ESO 539- G 014',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3378,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3378,34.65,0.32,85,1273,85,NULL,'I, raw','ESO 539- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3379,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3379,34.67,0.42,85.9,1273,NULL,NULL,NULL,'ESO 539- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3380,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3380,34.68,0.32,86.2,1273,85,NULL,'I, inv','ESO 539- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3381,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3381,34.73,0.43,88.3,1273,75,NULL,'MAT, I, inv','ESO 539- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3382,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3382,34.88,0.43,94.7,1273,75,NULL,'MAT, I, cor','ESO 539- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3383,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3383,34.9,0.38,95.6,1273,NULL,NULL,'Malmquist cor.','ESO 539- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3384,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3384,34.95,0.2,97.7,1273,74.4,NULL,NULL,'ESO 539- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3385,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3385,33.13,0.2,42.3,1274,74.4,NULL,NULL,'UGC 00314',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000007,NULL,'15.00',0.9,'SBc','Group member',NULL,NULL,NULL,1,7.872375,8.40061,0.121,NULL,66836683697,1044323182,16317549,15),(3386,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2006kl',NULL,3386,39.77,0.09,898,1275,70,NULL,'Hubble residual 0.13 for z0.22110; SDSS-II SN 14331','SDSS-II SN 14331 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,7.88908333333,-0.13553,0.053,NULL,34399702861,537495357,8398364,NULL),(3387,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2006kl','R',3387,40.35,0.2,961,1275,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006kl; SDSS-II SN 14331','SDSS-II SN 14331 HOST',0.221159,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3388,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2006kl','R',3388,40.47,0.13,1010,1275,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006kl; SDSS-II SN 14331','SDSS-II SN 14331 HOST',0.221159,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3389,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2006kl',NULL,3389,40.46,0.09,1240,1275,70,NULL,'SALT 2; SDSS-II SN 14331','SDSS-II SN 14331 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3390,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2006kl',NULL,3390,40.48,0.09,1250,1275,70,NULL,'SALT 2, Malmquist cor.; SDSS-II SN 14331','SDSS-II SN 14331 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3391,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3391,33.13,0.8,42.2,1276,75,NULL,'MAT, I','MCG -02-02-040',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000019,NULL,'14.26',0.4,'SB(r)bc? sp',NULL,NULL,NULL,NULL,1,7.898833,-10.50631,0.095,NULL,34573475713,540210558,8440789,14.26),(3392,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3392,33.3,0.4,45.7,1276,NULL,NULL,'mean','MCG -02-02-040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3393,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3393,33.32,0.32,46.2,1276,85,NULL,'I, raw','MCG -02-02-040',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3394,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3394,33.34,0.49,46.6,1276,NULL,NULL,NULL,'MCG -02-02-040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3395,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3395,33.35,0.32,46.8,1276,85,NULL,'I, inv','MCG -02-02-040',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3396,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3396,33.38,0.2,47.4,1276,74.4,NULL,NULL,'MCG -02-02-040',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3397,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3397,33.44,0.45,48.8,1276,NULL,NULL,'K','MCG -02-02-040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3398,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3398,33.45,0.49,48.9,1276,75,NULL,'IR','MCG -02-02-040',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3399,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3399,33.47,0.47,49.4,1276,NULL,NULL,'H','MCG -02-02-040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3400,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3400,33.56,0.43,51.5,1276,75,NULL,'MAT, I, raw','MCG -02-02-040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3401,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3401,33.59,0.46,52.2,1276,NULL,NULL,'J','MCG -02-02-040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3402,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3402,33.59,0.44,52.2,1276,NULL,NULL,'Malmquist cor.','MCG -02-02-040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3403,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3403,33.71,0.43,55.2,1276,75,NULL,'MAT, I, inv','MCG -02-02-040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3404,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3404,33.93,0.43,61.1,1276,75,NULL,'MAT, I, cor','MCG -02-02-040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3405,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3405,35.76,0.49,142,1277,75,NULL,'IR','UGC 00316',NULL,'2011yCatp016004901K',2011,1,1.4,'Bright star superposed.','G',0.000032,NULL,'15.53',0.13,'Sd(f)',NULL,NULL,NULL,NULL,1,7.899417,14.61228,0.141,NULL,66746954995,1042921171,16295643,15.53),(3406,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3406,35.84,NULL,147,1277,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00316',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3407,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3407,35.86,NULL,149,1277,NULL,NULL,'Dipole + Quadrupole','UGC 00316',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3408,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3408,35.87,NULL,149,1277,NULL,NULL,'Dipole','UGC 00316',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3409,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3409,35.88,NULL,150,1277,NULL,NULL,NULL,'UGC 00316',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3410,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3410,36.27,0.2,179,1277,74.4,NULL,NULL,'UGC 00316',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3411,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3411,34.29,0.46,72,1278,70,NULL,NULL,'MCG -02-02-037',NULL,'2015arXiv151105856S',2015,1,0.76,'MCG position is -0.4 minutes and -2 arcmin in error.','G',0.000083,NULL,'14.7g',0.47,'S0',NULL,NULL,NULL,NULL,1,7.90233333333,-10.88819,0.112,NULL,34571165269,540174457,8440225,14.7),(3412,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3412,36.25,0.46,178,1279,70,NULL,NULL,'2MASX J00314301+1429112',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000077,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,7.929375,14.48644,0.133,NULL,66746674728,1042916792,16295574,16.6),(3413,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3413,30.4,0.82,12,1280,NULL,NULL,NULL,'NGC 0145',NULL,'2009ApJS..182..474S',2009,1,1.8,NULL,'G',0.000018,NULL,'13.17',1.3,'SB(s)dm',NULL,NULL,NULL,NULL,1,7.940583,-5.15264,0.147,NULL,34583893124,540373330,8443333,13.17),(3414,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3414,30.88,0.66,15,1280,NULL,NULL,'Malmquist cor.','NGC 0145',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3415,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3415,33.53,0.47,50.8,1281,NULL,NULL,'H','ESO 473- G 025',NULL,'2007A&A...465...71T',2007,1,3.47,NULL,'G',0.00004,NULL,'14.64',0.36,'Sb',NULL,NULL,NULL,NULL,1,7.95575,-26.72053,0.083,NULL,34807593778,543868652,8497947,14.64),(3416,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3416,33.73,0.45,55.7,1281,NULL,NULL,'K','ESO 473- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3417,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3417,33.92,0.46,60.9,1281,NULL,NULL,'J','ESO 473- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3418,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3418,34.8,0.4,91.3,1281,NULL,NULL,'mean','ESO 473- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3419,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 16470','RN',3419,41.62,0.29,1720,1282,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 16470',0.225262,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3420,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 16470','RN',3420,42.37,0.44,2430,1282,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 16470',0.225262,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3421,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2006ft',NULL,3421,40.07,0.14,1030,1283,70,NULL,'Hubble residual 0.12 for z0.26080','SDSS J003150.06-002258.7',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,7.95858333333,-0.38297,0.039,NULL,34399738521,537495914,8398373,NULL),(3422,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 12972','R',3422,40.69,0.23,1090,1283,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ft','SDSS J003150.06-002258.7',0.2608,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3423,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 12972','R',3423,40.85,0.17,1170,1283,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ft','SDSS J003150.06-002258.7',0.2608,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3424,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 00735','RN',3424,39.61,0.27,700,1284,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 00735',0.190858,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3425,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 00735','RN',3425,39.9,0.17,800,1284,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 00735',0.190858,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3426,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3426,35.1,0.49,105,1285,75,NULL,'IR','2MFGC 00370',NULL,'2011yCatp016004901K',2011,1,0.76,NULL,'G',0.000529,NULL,'15.88',0.12,NULL,NULL,NULL,NULL,NULL,1,7.971333,29.70394,0.153,NULL,67365057546,1052579024,16446547,15.88),(3427,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 19101','R',3427,39.7,0.2,735,1286,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ml','SN 2007ml',0.187,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,7.97275,0.13831,0.063,NULL,66598432628,1040600509,16259382,NULL),(3428,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 19101','R',3428,39.8,0.1,767,1286,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ml','SN 2007ml',0.187,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3429,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3429,35.77,0.49,143,1287,75,NULL,'IR','2MFGC 00371',NULL,'2011yCatp016004901K',2011,1,0.71,NULL,'G',0.000017,NULL,'16.3g',0.19,'Sc(f)',NULL,NULL,NULL,NULL,1,7.98679166667,-10.25239,0.099,NULL,34573557173,540211830,8440809,16.3),(3430,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3430,36.6,0.39,209,1287,NULL,NULL,NULL,'2MFGC 00371',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3431,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3431,36.64,0.2,213,1287,74.4,NULL,NULL,'2MFGC 00371',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3432,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3432,36.71,0.37,220,1287,NULL,NULL,'Malmquist cor.','2MFGC 00371',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3433,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 18714','RN',3433,40.96,0.13,1270,1288,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 18714',0.2207,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3434,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 18714','RN',3434,41.2,0.2,1420,1288,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 18714',0.2207,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3435,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3435,37.4,0.46,303,1289,70,NULL,NULL,'2MASX J00315933+1504532',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000096,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,7.997167,15.0815,0.145,NULL,66746509565,1042914211,16295534,17.5),(3436,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3436,32.67,0.8,34.3,1290,75,NULL,'MAT, I','ESO 079- G 003',NULL,'1997ApJS..109..333W',1997,1,2.7,NULL,'G',0.000033,NULL,'12.59',0.4,'SBb? sp','Pair member (points to parent)',NULL,NULL,NULL,1,8.0090417,-64.25339,0,NULL,36098507973,564039187,8813112,12.59),(3437,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3437,32.6,0.39,33.1,1290,73,NULL,'opt','ESO 079- G 003',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3438,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3438,32.6,0.4,33.2,1290,75,NULL,NULL,'ESO 079- G 003',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3439,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3439,32.61,0.39,33.2,1290,73,NULL,'IR','ESO 079- G 003',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3440,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3440,32.78,0.4,36,1290,NULL,NULL,'mean','ESO 079- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3441,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3441,32.8,0.45,36.3,1290,NULL,NULL,'K','ESO 079- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3442,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3442,32.84,0.47,36.9,1290,NULL,NULL,'H','ESO 079- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3443,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3443,32.9,0.46,38,1290,NULL,NULL,'J','ESO 079- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3444,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3444,33,0.32,39.8,1290,85,NULL,'I, raw','ESO 079- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3445,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3445,33.02,0.43,40.3,1290,75,NULL,'MAT, I, raw','ESO 079- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3446,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3446,33.05,0.32,40.8,1290,85,NULL,'I, inv','ESO 079- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3447,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3447,33.14,0.49,42.5,1290,75,NULL,'IR','ESO 079- G 003',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3448,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3448,33.26,0.43,44.9,1290,75,NULL,'MAT, I, cor','ESO 079- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3449,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3449,33.26,0.43,44.9,1290,75,NULL,'MAT, I, inv','ESO 079- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3450,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 14044','RN',3450,42.6,0.23,2620,1291,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14044',0.260699,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3451,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 14044','RN',3451,43.24,0.25,3530,1291,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 14044',0.260699,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3452,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3452,37.24,0.66,280,1292,70,NULL,NULL,'2MASX J00320679-1303226',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'16.86',0.33,NULL,NULL,NULL,NULL,NULL,1,8.0282917,-13.05628,0.097,NULL,34460325841,538442591,8413165,16.86),(3453,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3453,34.59,0.8,82.7,1293,75,NULL,'HMCL, I','CGCG 500-040',NULL,'1997ApJS..109..333W',1997,1,0.8,NULL,'G',0.000033,NULL,'15.7',0.2,'S',NULL,NULL,NULL,NULL,1,8.05058333333,31.41642,0.213,NULL,67376157621,1052752462,16449257,15.7),(3454,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3454,33.9,0.4,60.2,1293,75,NULL,'HMCL, I, raw','CGCG 500-040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3455,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3455,33.98,0.4,62.4,1293,75,NULL,'HMCL, I, inv','CGCG 500-040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3456,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3456,34.14,0.4,67.2,1293,75,NULL,'HMCL, I, cor','CGCG 500-040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3457,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3457,34.37,0.49,74.9,1293,75,NULL,'IR','CGCG 500-040',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3458,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3458,34.66,0.8,85.5,1294,75,NULL,'W91PP, r','UGC 00319',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.72',0.9,'Sbc',NULL,NULL,NULL,NULL,1,8.0502917,31.68164,0.213,NULL,67375372301,1052740192,16449065,14.72),(3459,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3459,34.66,0.8,85.5,1294,75,NULL,'HMCL, I','UGC 00319',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3460,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3460,34.27,0.4,71.6,1294,75,NULL,'HMCL, I, raw','UGC 00319',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3461,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3461,34.37,0.38,75,1294,75,NULL,'W91PP, r, raw','UGC 00319',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3462,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3462,34.38,0.36,75.1,1294,NULL,NULL,NULL,'UGC 00319',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3463,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3463,34.39,0.4,75.5,1294,75,NULL,'HMCL, I, inv','UGC 00319',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3464,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3464,34.42,0.2,76.6,1294,74.4,NULL,NULL,'UGC 00319',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3465,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3465,34.42,0.36,76.6,1294,NULL,NULL,'Malmquist cor.','UGC 00319',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3466,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3466,34.43,0.4,76.9,1294,75,NULL,'HMCL, I, cor','UGC 00319',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3467,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3467,34.44,0.38,77.3,1294,75,NULL,'W91PP, r, inv','UGC 00319',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3468,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3468,34.5,0.38,79.5,1294,75,NULL,'W91PP, r, cor','UGC 00319',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3469,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3469,36.51,0.46,201,1295,70,NULL,NULL,'2MASX J00321409+1456012',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000089,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,8.058583,14.93364,0.145,NULL,66746980050,1042921563,16295649,16.9),(3470,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3470,37.39,0.46,301,1296,70,NULL,NULL,'2MASXi J0032144-110652',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000079,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,8.0602917,-11.11469,0.084,NULL,34571390782,540177980,8440280,17.8),(3471,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 15853','RN',3471,41.5,0.25,1620,1297,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 15853',0.232427,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3472,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 15853','RN',3472,42.09,0.25,2120,1297,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 15853',0.232427,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3473,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3473,34.55,0.47,81.2,1298,NULL,NULL,'H','ESO 294- G 021',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000033,NULL,'14.25',0.6,'SAB(rs)b',NULL,NULL,NULL,NULL,1,8.06191666667,-41.38389,NULL,NULL,38126356515,595724320,9308192,14.25),(3474,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3474,34.61,0.45,83.4,1298,NULL,NULL,'K','ESO 294- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3475,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3475,34.67,0.46,85.8,1298,NULL,NULL,'J','ESO 294- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3476,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3476,34.95,0.4,97.6,1298,NULL,NULL,'mean','ESO 294- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3477,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3477,35.07,0.33,103,1298,NULL,NULL,'Malmquist cor.','ESO 294- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3478,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3478,35.2,0.31,110,1298,NULL,NULL,NULL,'ESO 294- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3479,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3479,35.24,0.2,112,1298,74.4,NULL,NULL,'ESO 294- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3480,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 15496',NULL,3480,39.83,0.22,924,1299,70,NULL,'SN photometric redshift distance, z photo =0.245 +/- 0.030','SDSS-II SN 15496',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,8.07391666667,0.27447,0.071,NULL,66598450422,1040600787,16259387,NULL),(3481,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 15496','R',3481,40.43,0.19,989,1299,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15496',0.23441,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3482,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 15496','R',3482,40.63,0.11,1080,1299,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15496',0.23441,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3483,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3483,35.08,0.57,104,1300,70,NULL,NULL,'ESO 294- G 022',NULL,'2014MNRAS.445.2677S',2014,1,0.86,NULL,'G',0.000087,NULL,'14.97',0.67,'(R\')SAB(rs)b',NULL,NULL,NULL,NULL,1,8.097917,-42.17344,NULL,NULL,38126799143,595731236,9308300,14.97),(3484,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2006of',NULL,3484,39.02,0.05,637,1301,70,NULL,'Hubble residual 0.11 for z0.15310; SDSS-II SN 16073','GALEXASC J003225.86-010314.1',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,8.107667,-1.05392,0.035,NULL,34408579114,537634048,8400532,NULL),(3485,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2006of','R',3485,39.55,0.18,704,1301,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006of; SDSS-II SN 16073','GALEXASC J003225.86-010314.1',0.154716,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3486,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2006of','R',3486,39.65,0.07,738,1301,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006of; SDSS-II SN 16073','GALEXASC J003225.86-010314.1',0.154716,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3487,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2006of',NULL,3487,39.44,0.06,773,1301,70,NULL,'SALT 2; SDSS-II SN 16073','GALEXASC J003225.86-010314.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3488,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2006of',NULL,3488,39.45,0.06,776,1301,70,NULL,'SALT 2, Malmquist cor.; SDSS-II SN 16073','GALEXASC J003225.86-010314.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3489,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3489,38.32,0.46,462,1302,70,NULL,NULL,'2MASX J00322714-1114240',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000093,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,8.1130417,-11.24008,0.09,NULL,34571408741,540178261,8440285,17.7),(3490,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3490,35.8,0.49,144,1303,70,NULL,NULL,'LCRS B003003.7-424400',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000103,NULL,'16.06',0.35,'S',NULL,NULL,NULL,NULL,1,8.12175,-42.45733,NULL,NULL,38129638806,595775606,9308993,16.06),(3491,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3491,32.87,NULL,37.5,1304,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00320',NULL,'2010Ap&SS.325..163P',2010,1,1.34,NULL,'G',0.000018,NULL,'16.5',0.19,'Sd',NULL,NULL,NULL,NULL,1,8.128875,2.57417,0.045,NULL,66603657123,1040682142,16260658,16.5),(3492,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3492,32.89,NULL,37.9,1304,NULL,NULL,'Dipole + Quadrupole','UGC 00320',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3493,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3493,32.9,NULL,38.1,1304,NULL,NULL,'Dipole','UGC 00320',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3494,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3494,32.98,NULL,39.4,1304,NULL,NULL,NULL,'UGC 00320',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3495,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3495,33,0.2,39.8,1304,74.4,NULL,NULL,'UGC 00320',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3496,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3496,33.08,0.43,41.3,1304,75,NULL,'3.6 micron, color corrected','UGC 00320',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3497,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3497,33.08,0.43,41.4,1304,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00320',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3498,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3498,33.14,0.71,42.4,1304,NULL,NULL,NULL,'UGC 00320',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3499,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3499,33.48,0.61,49.7,1304,NULL,NULL,'Malmquist cor.','UGC 00320',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3500,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3500,37.88,0.46,377,1305,70,NULL,NULL,'2MASX J00323091-0024397',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000105,NULL,'17.6g',0.15,'NLAGN',NULL,NULL,NULL,NULL,1,8.12875,-0.41114,0.047,NULL,34408217330,537628395,8400443,17.6),(3501,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3501,38.05,0.46,407,1306,70,NULL,NULL,'2MASX J00323204-0058317',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.03',0.18,NULL,NULL,NULL,NULL,NULL,1,8.133625,-0.97544,0.051,NULL,34408860221,537638440,8400600,18.03),(3502,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3502,33.84,0.8,58.7,1307,75,NULL,'MAT, I','UGC 00321',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000007,NULL,'15.29',0.3,'SBcd?',NULL,NULL,NULL,NULL,1,8.13520833333,23.39508,0.041,NULL,67482693981,1054417093,16475267,15.29),(3503,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3503,33.85,0.8,58.8,1307,75,NULL,'W91PP, r','UGC 00321',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3504,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3504,33.37,0.32,47.3,1307,85,NULL,'I, inv','UGC 00321',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3505,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3505,33.39,0.32,47.7,1307,85,NULL,'I, raw','UGC 00321',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3506,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3506,33.75,0.43,56.4,1307,75,NULL,'MAT, I, raw','UGC 00321',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3507,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3507,33.76,0.43,56.5,1307,75,NULL,'MAT, I, inv','UGC 00321',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3508,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3508,33.85,0.2,58.9,1307,74.4,NULL,NULL,'UGC 00321',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3509,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3509,33.86,0.38,59.2,1307,75,NULL,'W91PP, r, inv','UGC 00321',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3510,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3510,33.92,0.38,60.7,1307,75,NULL,'W91PP, r, raw','UGC 00321',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3511,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3511,34.03,0.41,64.1,1307,NULL,NULL,NULL,'UGC 00321',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3512,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3512,34.03,0.43,64.1,1307,75,NULL,'MAT, I, cor','UGC 00321',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3513,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3513,34.1,0.38,66.2,1307,75,NULL,'W91PP, r, cor','UGC 00321',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3514,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3514,34.31,0.36,72.9,1307,NULL,NULL,'Malmquist cor.','UGC 00321',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3515,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 08128','R',3515,41.5,0.27,1390,1308,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 08128',0.439722,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',NULL,'PHOT','21.6g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,8.15925,-0.82308,0.051,NULL,34408876426,537638694,8400604,21.6),(3516,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 08128',NULL,3516,41.02,0.2,1600,1308,70,NULL,'SN photometric redshift distance, z photo =0.482 +/- 0.066','SDSS-II SN 08128',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3517,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 08128','R',3517,41.82,0.34,1600,1308,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 08128',0.439722,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3518,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 08128',NULL,3518,41.75,0.21,2240,1308,70,NULL,'SALT 2','SDSS-II SN 08128',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3519,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 08128',NULL,3519,41.84,0.21,2330,1308,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 08128',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3520,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 03063','RN',3520,39.28,0.11,657,1309,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 03063',0.091725,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3521,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3521,34.54,0.47,81,1310,70,NULL,NULL,'2MASX J00323979-0254566',NULL,'2014MNRAS.445.2677S',2014,1,0.71,NULL,'G',0.000133,NULL,'14.63',0.57,NULL,NULL,NULL,NULL,NULL,1,8.16575,-2.91567,0.155,NULL,34402761987,537543156,8399111,14.63),(3522,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3522,31.76,0.49,22.5,1311,75,NULL,'IR','IC 1553',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000033,NULL,'15.12',0.3,'SA0            HII',NULL,NULL,NULL,NULL,1,8.167167,-25.60753,0.071,NULL,34809373250,543896457,8498382,15.12),(3523,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3523,32.38,0.43,29.9,1311,75,NULL,'3.6 micron, color + selection bias corrected','IC 1553',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3524,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3524,32.48,0.47,31.4,1311,NULL,NULL,'H','IC 1553',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3525,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3525,32.58,0.45,32.8,1311,NULL,NULL,'K','IC 1553',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3526,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3526,32.65,0.43,33.9,1311,75,NULL,'3.6 micron, color corrected','IC 1553',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3527,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3527,32.69,0.4,34.5,1311,NULL,NULL,'mean','IC 1553',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3528,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3528,32.71,0.46,34.9,1311,NULL,NULL,'J','IC 1553',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3529,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3529,32.93,0.2,38.6,1311,74.4,NULL,NULL,'IC 1553',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3530,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3530,35.58,0.62,131,1312,70,NULL,NULL,'MCG -03-02-020',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'16',0.3,NULL,NULL,NULL,NULL,NULL,1,8.1692083,-16.63314,0.038,NULL,35340758013,552199343,8628114,16),(3531,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3531,36.63,0.65,212,1313,70,NULL,NULL,'2MASX J00324174-8223088',NULL,'2014MNRAS.445.2677S',2014,1,0.24,NULL,'G',0.000183,NULL,'17.3b',0.18,NULL,NULL,NULL,NULL,NULL,1,8.174333,-82.38578,0.489,NULL,35482199021,554409359,8662646,17.3),(3532,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 16637','RN',3532,40.37,0.23,955,1314,70,NULL,'SDSS CAND. SNIa; SALT 2','SDSS-II SN 16637',0.242928,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3533,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 16637','RN',3533,40.42,0.18,975,1314,70,NULL,'SDSS CAND. SNIa; MLCS2K2','SDSS-II SN 16637',0.242928,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3534,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3534,33.44,0.8,48.8,1315,75,NULL,'MAT, I','MCG -02-02-049',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'14.48',0.3,'Sc: sp',NULL,NULL,NULL,NULL,1,8.1777083,-11.31814,0.077,NULL,34570645050,540166328,8440098,14.48),(3535,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3535,33.74,0.4,55.9,1315,NULL,NULL,'mean','MCG -02-02-049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3536,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3536,33.87,0.47,59.4,1315,NULL,NULL,'H','MCG -02-02-049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3537,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3537,33.89,0.2,60,1315,74.4,NULL,NULL,'MCG -02-02-049',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3538,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3538,33.9,0.45,60.1,1315,NULL,NULL,'K','MCG -02-02-049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3539,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3539,33.93,0.46,61,1315,NULL,NULL,'J','MCG -02-02-049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3540,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3540,34.01,0.49,63.5,1315,75,NULL,'IR','MCG -02-02-049',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3541,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3541,34.1,0.43,66.2,1315,75,NULL,'MAT, I, raw','MCG -02-02-049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3542,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3542,34.12,0.32,66.8,1315,85,NULL,'I, raw','MCG -02-02-049',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3543,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3543,34.18,0.32,68.5,1315,85,NULL,'I, inv','MCG -02-02-049',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3544,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3544,34.34,0.43,73.9,1315,75,NULL,'MAT, I, inv','MCG -02-02-049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3545,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3545,34.4,0.43,76,1315,75,NULL,'MAT, I, cor','MCG -02-02-049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3546,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 14549',NULL,3546,39.67,0.33,857,1316,70,NULL,'SN photometric redshift distance, z photo =0.225 +/- 0.043','SDSS-II SN 14549',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,8.1810417,0.96333,0.037,NULL,66603349215,1040677331,16260583,NULL),(3547,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 14549','R',3547,40.47,0.18,978,1316,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14549',0.268413,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3548,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 14549','R',3548,40.6,0.26,1040,1316,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14549',0.268413,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3549,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3549,34.58,0.8,82.4,1317,75,NULL,'HMCL, I','CGCG 500-042',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.00003,NULL,'15.00',0.5,'S?',NULL,NULL,NULL,NULL,1,8.1850417,30.75069,0.173,NULL,67367538955,1052617796,16447153,15),(3550,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3550,34.6,0.4,83.3,1317,75,NULL,'HMCL, I, raw','CGCG 500-042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3551,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3551,34.61,0.42,83.5,1317,NULL,NULL,'Malmquist cor.','CGCG 500-042',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3552,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3552,34.69,0.4,86.7,1317,NULL,NULL,NULL,'CGCG 500-042',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3553,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3553,34.69,0.2,86.7,1317,74.4,NULL,NULL,'CGCG 500-042',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3554,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3554,34.75,0.4,89.1,1317,75,NULL,'HMCL, I, inv','CGCG 500-042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3555,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3555,34.75,0.4,89.2,1317,75,NULL,'HMCL, I, cor','CGCG 500-042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3556,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3556,35.11,0.46,105,1318,70,NULL,NULL,'MCG -02-02-047',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000089,NULL,'15.5g',0.45,'E0',NULL,NULL,NULL,NULL,1,8.18845833333,-10.451,0.084,NULL,34572781768,540199715,8440620,15.5),(3557,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3557,36.77,0.6,225,1319,70,NULL,NULL,'LCRS B003023.4-423339',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.99',0.37,'S',NULL,NULL,NULL,NULL,1,8.2039583,-42.28514,NULL,NULL,38126807365,595731365,9308302,15.99);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (3558,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3558,33.87,0.2,59.4,1320,74.4,NULL,NULL,'UGC 00323',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.00005,NULL,'15.21',0.3,'S?',NULL,NULL,NULL,NULL,1,8.21025,11.73686,0.189,NULL,66749411725,1042959558,16296243,15.21),(3559,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3559,33.89,0.49,59.9,1320,NULL,NULL,NULL,'UGC 00323',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3560,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3560,34.02,0.46,63.7,1320,NULL,NULL,'Malmquist cor.','UGC 00323',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3561,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3561,34.03,0.49,64,1320,75,NULL,'IR','UGC 00323',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3562,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3562,34.03,0.31,64,1321,NULL,NULL,NULL,'CGCG 500-043',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000073,NULL,'15.1',0.32,NULL,NULL,NULL,NULL,NULL,1,8.220667,30.65097,0.173,NULL,67367493555,1052617086,16447141,15.1),(3563,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3563,34.05,0.2,64.6,1321,74.4,NULL,NULL,'CGCG 500-043',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3564,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3564,34.3,0.27,72.3,1321,NULL,NULL,'Malmquist cor.','CGCG 500-043',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3565,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 20448','RN',3565,41.79,0.23,1710,1322,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 20448',0.334672,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3566,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 20448','RN',3566,42.5,0.29,2370,1322,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20448',0.334672,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3567,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3567,37.17,0.53,271,1323,70,NULL,NULL,'2MASX J00325778-1812453',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.55',0.34,NULL,NULL,NULL,NULL,NULL,1,8.240875,-18.21253,0.05,NULL,35356540341,552445942,8631967,16.55),(3568,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3568,36.48,0.53,198,1324,70,NULL,NULL,'2MASX J00330152-6728343',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'15.8b',0.3,'(R)SB(s)0^+',NULL,NULL,NULL,NULL,1,8.2564583,-67.47628,0,NULL,36319651725,567494558,8867102,15.8),(3569,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3569,37.09,0.46,262,1325,70,NULL,NULL,'2MASX J00330203-0016326',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000084,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,8.25845833333,-0.27561,0.053,NULL,34407994388,537624912,8400389,17.5),(3570,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3570,38.24,0.46,445,1326,70,NULL,NULL,'2MASX J00330942+1612562',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00009,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,8.28925,16.21547,0.117,NULL,67473671815,1054276122,16473064,17.9),(3571,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3571,34.84,0.8,93,1327,75,NULL,'MAT, I','MCG -02-02-051',NULL,'1997ApJS..109..333W',1997,1,1.2,'Mathewson et al. (1992ApJS...81..413M) give v = 7112 +/- 10 km/sec.','G',0.00002,NULL,'14.74',0.6,'(R\')SB(rs)bc',NULL,NULL,NULL,NULL,1,8.292833,-13.14619,0.077,NULL,34459555002,538430546,8412977,14.74),(3572,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3572,33.72,0.32,55.5,1327,85,NULL,'I, raw','MCG -02-02-051',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3573,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3573,33.74,0.32,56,1327,85,NULL,'I, inv','MCG -02-02-051',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3574,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3574,33.96,0.43,62,1327,75,NULL,'MAT, I, raw','MCG -02-02-051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3575,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3575,34.1,0.43,65.9,1327,75,NULL,'MAT, I, inv','MCG -02-02-051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3576,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3576,34.32,0.43,73.2,1327,75,NULL,'MAT, I, cor','MCG -02-02-051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3577,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3577,34.54,0.39,80.8,1327,NULL,NULL,NULL,'MCG -02-02-051',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3578,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3578,34.54,0.2,80.9,1327,74.4,NULL,NULL,'MCG -02-02-051',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3579,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3579,34.66,0.37,85.3,1327,NULL,NULL,'Malmquist cor.','MCG -02-02-051',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3580,'CMD','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3580,24.41,NULL,0.762,1328,NULL,NULL,NULL,'NGC 0147',NULL,'2014ApJ...789..147W',2014,1,13.2,NULL,'G',0.00001,NULL,'10.47',7.8,'dSph/dE5','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,8.3005,48.50875,0.705,0,67654205089,1057096954,16517139,10.47),(3581,'Horizontal Branch','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3581,24.38,0.01,0.752,1328,NULL,NULL,NULL,'NGC 0147',NULL,'2005AJ....129.2217B',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3582,'Miras','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3582,24.34,0.22,0.738,1328,NULL,NULL,NULL,'NGC 0147',NULL,'2012dgkg.book..169L',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3583,'Miras','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3583,24.38,NULL,0.752,1328,NULL,NULL,'all','NGC 0147',NULL,'2011A&A...532A..78L',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3584,'Miras','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3584,24.38,NULL,0.752,1328,NULL,NULL,'O-rich','NGC 0147',NULL,'2011A&A...532A..78L',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3585,'Red Clump','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3585,24.67,NULL,0.86,1328,NULL,NULL,'V, M RC(V) = +0.73 mag','NGC 0147',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3586,'Red Clump','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3586,24.86,NULL,0.938,1328,NULL,NULL,'I, M RC(I) = -0.50 mag','NGC 0147',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3587,'RR Lyrae','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3587,23.85,0.22,0.589,1328,NULL,NULL,'9','NGC 0147',NULL,'1987AJ.....94.1556S',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3588,'RR Lyrae','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3588,23.92,0.25,0.608,1328,NULL,NULL,NULL,'NGC 0147',NULL,'1990AJ....100..108S',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3589,'RR Lyrae','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3589,23.96,0.62,0.619,1328,NULL,18.19,NULL,'NGC 0147',NULL,'1992MmSAI..63..409C',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3590,'RR Lyrae','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3590,24,NULL,0.631,1328,NULL,NULL,NULL,'NGC 0147',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3591,'RR Lyrae','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3591,24,0.16,0.631,1328,NULL,NULL,'V','NGC 0147',NULL,'2013MNRAS.435.3206D',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3592,'RR Lyrae','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3592,24.13,NULL,0.67,1328,NULL,NULL,'Fe/H = -1.5','NGC 0147',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3593,'RR Lyrae','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3593,24.16,0.16,0.679,1328,NULL,NULL,NULL,'NGC 0147',NULL,'2010ApJ...708..293Y',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3594,'RR Lyrae','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3594,24.17,NULL,0.682,1328,NULL,NULL,NULL,'NGC 0147',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3595,'RR Lyrae','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3595,24.2,NULL,0.692,1328,NULL,NULL,NULL,'NGC 0147',NULL,'2008ApJ...679...52T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3596,'RR Lyrae','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3596,24.28,NULL,0.718,1328,NULL,NULL,'Fe/H = -1.5','NGC 0147',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3597,'SBF','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3597,24.32,0.07,0.73,1328,74.4,NULL,NULL,'NGC 0147',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3598,'SBF','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3598,24.44,0.16,0.773,1328,NULL,NULL,'I','NGC 0147',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3599,'TRGB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3599,23.87,0.11,0.594,1328,NULL,NULL,'JHK, Bolometric','NGC 0147',NULL,'2007JASS...24..203K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3600,'TRGB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3600,24,0.15,0.63,1328,NULL,NULL,'I','NGC 0147',NULL,'1983ApJ...270..471M',1983,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3601,'TRGB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3601,24,0.15,0.631,1328,NULL,NULL,'JHK, Bolometric','NGC 0147',NULL,'1992IAUS..149..169F',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3602,'TRGB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3602,24.13,0.1,0.67,1328,NULL,NULL,'I','NGC 0147',NULL,'1993ApJ...417..553L',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3603,'TRGB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3603,24.14,NULL,0.673,1328,NULL,NULL,'theory','NGC 0147',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3604,'TRGB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3604,24.15,0.09,0.675,1328,NULL,NULL,NULL,'NGC 0147',NULL,'2005MNRAS.356..979M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3605,'TRGB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3605,24.18,0.19,0.685,1328,NULL,NULL,'I','NGC 0147',NULL,'2009ApJ...694.1331M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3606,'TRGB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3606,24.26,0.06,0.712,1328,NULL,NULL,NULL,'NGC 0147',NULL,'2012ApJ...758...11C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3607,'TRGB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3607,24.27,NULL,0.714,1328,NULL,NULL,'DA90','NGC 0147',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3608,'TRGB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3608,24.28,NULL,0.718,1328,NULL,NULL,NULL,'NGC 0147',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3609,'TRGB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3609,24.28,0.13,0.718,1328,NULL,NULL,NULL,'NGC 0147',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3610,'TRGB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3610,24.29,NULL,0.721,1328,NULL,NULL,'K97','NGC 0147',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3611,'TRGB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3611,24.29,NULL,0.721,1328,NULL,NULL,'Yale','NGC 0147',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3612,'TRGB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3612,24.3,NULL,0.724,1328,NULL,NULL,NULL,'NGC 0147',NULL,'1994AJ....108.2123D',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3613,'TRGB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3613,24.3,0.05,0.724,1328,NULL,NULL,NULL,'NGC 0147',NULL,'2015ApJ...811..114G',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3614,'TRGB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3614,24.32,0.07,0.73,1328,74.4,NULL,NULL,'NGC 0147',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3615,'TRGB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3615,24.32,0.15,0.731,1328,NULL,NULL,'I','NGC 0147',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3616,'TRGB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3616,24.39,NULL,0.755,1328,NULL,NULL,NULL,'NGC 0147',NULL,'1997AJ....113.1001H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3617,'TRGB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3617,24.44,NULL,0.773,1328,NULL,NULL,NULL,'NGC 0147',NULL,'2003A&A...403...93N',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3618,'TRGB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3618,24.48,0.01,0.787,1328,NULL,NULL,'I','NGC 0147',NULL,'2005AJ....129.2217B',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3619,'TRGB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3619,24.72,NULL,0.879,1328,NULL,NULL,'I, M TRGB(I) = -4.05 mag','NGC 0147',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3620,'Statistical','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3620,24.32,0.14,0.731,1328,NULL,NULL,NULL,'NGC 0147',NULL,'2000glg..book.....V',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3621,'Faber-Jackson','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3621,24.05,NULL,0.646,1328,NULL,NULL,'LEDA [April 2006]','NGC 0147',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3622,'Faber-Jackson','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3622,25.63,0.81,1.34,1328,55,NULL,'Visvanathan & Sandage 1979','NGC 0147',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3623,'Faber-Jackson','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3623,25.66,0.65,1.36,1328,95,NULL,'Weighted Mean','NGC 0147',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3624,'Tully est','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3624,24.23,0.8,0.7,1328,75,NULL,'B','NGC 0147',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3625,'SNII optical','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2003ip',NULL,3625,33.67,0.54,54.2,1329,NULL,NULL,'SCM, I','UGC 00327',NULL,'2010ApJ...715..833O',2010,1,1.1,'RC3 gives v = 13527 +/- 57 km/sec.','G',0.000009,NULL,'15.36',0.4,'Sbc','Pair member (points to parent)',NULL,NULL,NULL,1,8.314333,7.90506,0.129,NULL,66837121795,1044330028,16317656,15.36),(3626,'SNII optical','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2003ip',NULL,3626,33.74,0.1,56,1329,NULL,NULL,'I, photospheric magnitude method','UGC 00327',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3627,'SNII optical','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2003ip',NULL,3627,33.75,0.54,56.2,1329,NULL,NULL,'SCM, V','UGC 00327',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3628,'SNII optical','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2003ip',NULL,3628,33.76,0.28,56.5,1329,NULL,NULL,'SCM, BVI','UGC 00327',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3629,'SNII optical','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2003ip',NULL,3629,33.79,0.17,57.3,1329,NULL,NULL,'V, photospheric magnitude method','UGC 00327',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3630,'SNII optical','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 2003ip',NULL,3630,33.81,0.41,57.8,1329,NULL,NULL,'SCM, B','UGC 00327',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3631,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3631,34.45,0.37,77.7,1329,NULL,NULL,'Malmquist cor.','UGC 00327',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3632,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3632,34.5,0.2,79.4,1329,74.4,NULL,NULL,'UGC 00327',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3633,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3633,34.6,0.34,83.1,1329,NULL,NULL,NULL,'UGC 00327',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3634,'Tully est','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3634,32.03,0.8,25.5,1330,75,NULL,NULL,'UGC 00328',NULL,'1988NBGC.C....0000T',1988,1,0.72,NULL,'G',0.000019,NULL,'16.2g',0.47,'SB(rs)dm',NULL,NULL,NULL,NULL,1,8.3420417,-1.12136,0.07,NULL,34408742068,537636594,8400571,16.2),(3635,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 08750','RN',3635,38.64,0.18,497,1331,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 08750',0.077114,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3636,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 08750','RN',3636,39.23,0.06,652,1331,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 08750',0.077114,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3637,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3637,33.82,0.49,58,1332,75,NULL,'IR','CGCG 479-039',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.000033,NULL,'15.69',0.2,'Sb','Isolated galaxy',NULL,NULL,NULL,1,8.3784583,22.90286,0.053,NULL,67485651196,1054463299,16475989,15.69),(3638,'BL Lac Luminosity','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3638,40.95,NULL,1550,1333,71,NULL,'Min. z = 0.47','2MASS J00333438-1921331',NULL,'2014A&A...565A..12P',2013,1,NULL,NULL,'QSO',NULL,NULL,'18.0R',NULL,'BLLAC',NULL,NULL,NULL,'BL Lac',1,8.3925,-19.35925,0.057,NULL,35366368204,552599503,8634367,18),(3639,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3639,34.5,0.2,79.4,1334,74.4,NULL,NULL,'CGCG 479-040',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000033,NULL,'15.34',0.3,'S?',NULL,NULL,NULL,NULL,1,8.399625,23.39781,0.033,NULL,67484521563,1054445649,16475713,15.34),(3640,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3640,34.63,0.43,84.1,1334,NULL,NULL,NULL,'CGCG 479-040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3641,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3641,34.68,0.41,86.4,1334,NULL,NULL,'Malmquist cor.','CGCG 479-040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3642,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3642,33.63,0.2,53.2,1335,74.4,NULL,NULL,'UGC 00329',NULL,'2013AJ....146...86T',2013,1,1.9,NULL,'G',0.000024,NULL,'14.9',1.3,'SAB(s)cd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,8.400667,2.68106,0.013,NULL,66603506812,1040679793,16260621,14.9),(3643,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3643,33.78,0.45,56.9,1335,NULL,NULL,NULL,'UGC 00329',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3644,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3644,34.09,0.39,65.7,1335,NULL,NULL,'Malmquist cor.','UGC 00329',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3645,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3645,35.73,0.49,140,1336,70,NULL,NULL,'AM 0031-530',NULL,'2014MNRAS.445.2677S',2014,1,0.95,NULL,'G',0.000107,NULL,'14.76',0.65,'SAB(s)b',NULL,NULL,NULL,NULL,1,8.4037083,-52.80203,NULL,NULL,36023999359,562874989,8794921,14.76),(3646,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 11518','R',3646,40.39,0.3,985,1337,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 11518',0.212107,'2014arXiv1401.3317S',2014,1,0.11,NULL,'G',NULL,'PHOT','19.9g',0.09,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,8.4102083,0.53875,0.062,NULL,66602521289,1040664395,16260381,19.9),(3647,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 11518','R',3647,40.51,0.36,1040,1337,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 11518',0.212107,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3648,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 11518',NULL,3648,40.3,0.33,1150,1337,70,NULL,'SN photometric redshift distance, z photo =0.316 +/- 0.065','SDSS-II SN 11518',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3649,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3649,38.09,0.46,415,1338,70,NULL,NULL,'2MASX J00334243+1550573',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000094,NULL,'17.0g',0.36,'BrClG',NULL,NULL,NULL,NULL,1,8.4267917,15.84925,0.117,NULL,67472911450,1054264241,16472878,17),(3650,'GRB','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3650,42.43,NULL,3060,1339,70,NULL,'Pseudo z = 1.45','GRB 021016',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,8.433333,46.78333,0.477,NULL,67657576038,1057149625,16517962,NULL),(3651,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 16451','RN',3651,39.76,0.14,753,1340,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16451',0.191029,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3652,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 16451','RN',3652,40.11,0.25,882,1340,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16451',0.191029,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3653,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 20626','R',3653,41.29,0.22,1420,1341,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 20626',0.276349,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,8.47575,-0.59308,0.057,NULL,34394420850,537412825,8397075,NULL),(3654,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 20626','R',3654,41.65,0.31,1680,1341,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20626',0.276349,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3655,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3655,37.74,0.46,352,1342,70,NULL,NULL,'2MASX J00335430-1003184',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000079,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,8.47625,-10.05517,0.108,NULL,34572627036,540197297,8440582,17.8),(3656,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 19751','RN',3656,41.65,0.2,1340,1343,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19751',0.592948,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3657,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 12944','RN',3657,42.69,0.21,2510,1344,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 12944',0.374504,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3658,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 12944','RN',3658,43.15,0.15,3100,1344,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 12944',0.374504,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3659,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3659,37.63,0.46,336,1345,70,NULL,NULL,'2MASX J00335620-1020504',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000066,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,8.484125,-10.34736,0.081,NULL,34570795925,540168686,8440135,17.8),(3660,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3660,37.01,0.46,252,1346,70,NULL,NULL,'2MASX J00335710-0016398',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000067,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,8.48783333333,-0.27772,0.048,NULL,34394359146,537411861,8397060,17.9),(3661,'CMD','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'RN',3661,19.7,NULL,0.0871,1347,NULL,NULL,NULL,'DES 1',NULL,'2016MNRAS.458..603L',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3662,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3662,36.3,0.55,182,1348,70,NULL,NULL,'2MASX J00340149-4308482',NULL,'2014MNRAS.445.2677S',2014,1,0.27,NULL,'G',0.000103,NULL,'14.7R',0.18,NULL,NULL,NULL,NULL,NULL,1,8.506083,-43.14681,NULL,NULL,38174045584,596469462,9319835,14.7),(3663,'Ring Diameter','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3663,31.5,0.84,20,1349,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 0151',NULL,'1981ApJS...45..541P',1981,1,2.6,NULL,'G',0.000017,NULL,'12.8g',1.12,'SB(r)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,8.511625,-9.70533,0.108,NULL,34572328705,540192636,8440509,12.8),(3664,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3664,33.27,0.8,45.1,1349,75,NULL,'MAT, I','NGC 0151',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3665,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3665,33.27,0.8,45.1,1349,75,NULL,'A82, H','NGC 0151',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3666,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3666,32.91,0.43,38.1,1349,75,NULL,'MAT, I, raw','NGC 0151',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3667,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3667,32.93,0.47,38.6,1349,75,NULL,'A82, H, raw','NGC 0151',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3668,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3668,33.04,0.32,40.6,1349,85,NULL,'I, raw','NGC 0151',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3669,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3669,33.12,0.32,42,1349,85,NULL,'I, inv','NGC 0151',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3670,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3670,33.15,0.47,42.7,1349,75,NULL,'A82, H, inv','NGC 0151',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3671,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3671,33.21,0.43,43.9,1349,75,NULL,'MAT, I, inv','NGC 0151',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3672,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3672,33.23,0.46,44.2,1349,NULL,NULL,'J','NGC 0151',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3673,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3673,33.27,0.47,45,1349,NULL,NULL,'H','NGC 0151',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3674,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3674,33.32,0.45,46.2,1349,NULL,NULL,'K','NGC 0151',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3675,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3675,33.35,0.43,46.7,1349,75,NULL,'MAT, I, cor','NGC 0151',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3676,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3676,33.44,0.47,48.7,1349,75,NULL,'A82, H, cor','NGC 0151',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3677,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3677,33.52,0.4,50.6,1349,NULL,NULL,'mean','NGC 0151',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3678,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3678,33.77,0.52,56.7,1349,NULL,NULL,'Malmquist cor.','NGC 0151',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3679,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3679,33.85,0.5,58.9,1349,NULL,NULL,NULL,'NGC 0151',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3680,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3680,33.89,0.2,60,1349,74.4,NULL,NULL,'NGC 0151',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3681,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3681,31.39,0.4,19,1350,75,NULL,'B','UGCA 006',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.00001,NULL,'14.08',1.7,'SAB(s)m:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,8.5467083,-30.77361,NULL,NULL,34889571514,545149554,8517961,14.08),(3682,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3682,38.17,0.46,430,1351,70,NULL,NULL,'SDSS J003414.59-004423.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000064,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,8.5607917,-0.73994,0.057,NULL,34394746823,537417919,8397154,18.5),(3683,'Ring Diameter','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3683,31,0.76,16,1352,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 0150',NULL,'1981ApJS...45..541P',1981,1,3.9,NULL,'G',0.000013,NULL,'12.00',1.9,'SB(rs)bc       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,8.5645,-27.80358,0.083,NULL,34837117143,544329955,8505155,12),(3684,'Ring Diameter','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3684,31.2,0.6,17,1352,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 0150',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3685,'SNII optical','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 1990K',NULL,3685,31.51,0.5,20,1352,NULL,NULL,NULL,'NGC 0150',NULL,'1994ApJ...432...42S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3686,'SNII optical','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SN 1990K',NULL,3686,31.62,0.75,20.9,1352,NULL,NULL,'SEAM','NGC 0150',0.005284,'2009ApJ...694.1067P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3687,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3687,31.55,0.8,20.4,1352,75,NULL,'MAT, I','NGC 0150',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3688,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3688,31.57,0.8,20.7,1352,75,NULL,'A82, H','NGC 0150',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3689,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3689,30.75,0.4,14.1,1352,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 0150',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3690,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3690,31.06,0.69,16.3,1352,100,NULL,'mid-IR','NGC 0150',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3691,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3691,31.2,0.3,17.4,1352,NULL,18.45,'SN 1990K host','NGC 0150',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3692,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3692,31.39,0.47,19,1352,75,NULL,'A82, H, raw','NGC 0150',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3693,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3693,31.42,0.4,19.2,1352,75,NULL,'B','NGC 0150',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3694,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3694,31.49,0.47,19.8,1352,75,NULL,'A82, H, inv','NGC 0150',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3695,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3695,31.52,0.39,20.1,1352,73,NULL,'opt','NGC 0150',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3696,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3696,31.55,0.38,20.4,1352,NULL,NULL,NULL,'NGC 0150',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3697,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3697,31.61,0.47,21,1352,75,NULL,'A82, H, cor','NGC 0150',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3698,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3698,31.63,0.86,21.2,1352,NULL,NULL,'Malmquist cor.','NGC 0150',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3699,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3699,31.67,0.43,21.6,1352,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0150',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3700,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3700,31.77,0.43,22.6,1352,75,NULL,'3.6 micron, color corrected','NGC 0150',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3701,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3701,31.9,0.43,24,1352,75,NULL,'MAT, I, raw','NGC 0150',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3702,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3702,31.92,0.2,24.2,1352,74.4,NULL,NULL,'NGC 0150',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3703,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3703,32,0.32,25.1,1352,85,NULL,'I, raw','NGC 0150',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3704,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3704,32.04,0.43,25.6,1352,75,NULL,'MAT, I, cor','NGC 0150',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3705,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3705,32.05,0.32,25.7,1352,85,NULL,'I, inv','NGC 0150',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3706,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3706,32.1,0.7,26.3,1352,NULL,NULL,NULL,'NGC 0150',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3707,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3707,32.12,0.43,26.6,1352,75,NULL,'MAT, I, inv','NGC 0150',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3708,'Faber-Jackson','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3708,31.32,0.65,18.4,1353,95,NULL,'Weighted Mean','NGC 0148',NULL,'1984ApJS...56...91D',1984,1,2,NULL,'G',0.000033,NULL,'13.28',0.8,'S0^0^: sp','in a pair',NULL,NULL,NULL,1,8.564583,-31.786,NULL,NULL,34893980392,545218443,8519038,13.28),(3709,'Faber-Jackson','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3709,33.11,0.81,41.9,1353,55,NULL,'Visvanathan & Sandage 1979','NGC 0148',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3710,'Tully est','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3710,31.32,0.8,18.4,1353,75,NULL,'B','NGC 0148',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3711,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3711,35.44,0.53,123,1354,70,NULL,NULL,'AM 0031-380',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.000103,NULL,'16.02',0.5,'E',NULL,NULL,NULL,NULL,1,8.56766666667,-37.88708,NULL,NULL,34656352986,541505515,8461023,16.02),(3712,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 16085','RN',3712,39.59,0.27,677,1355,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 16085',0.224285,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3713,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 16085','RN',3713,39.71,0.29,715,1355,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 16085',0.224285,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3714,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 08280','R',3714,40.27,0.17,956,1356,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 08280',0.184833,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,8.573625,0.79594,0.017,NULL,66591518984,1040492484,16257695,NULL),(3715,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 08280','R',3715,40.56,0.25,1090,1356,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 08280',0.184833,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3716,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3716,34.99,0.46,99.6,1357,70,NULL,NULL,'NGC 0154',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000053,NULL,'14.51',1.2,'E1 or SB0-',NULL,NULL,NULL,NULL,1,8.581125,-12.65631,0.082,NULL,34459088278,538423254,8412863,14.51),(3717,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3717,35.4,0.4,120,1357,NULL,NULL,'mean','NGC 0154',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3718,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3718,35.9,0.45,152,1357,NULL,NULL,'K','NGC 0154',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3719,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3719,33.58,0.69,52,1358,100,NULL,'mid-IR','UGC 00339 NED01',NULL,'2013ApJ...771...88L',2013,1,1,NULL,'G',NULL,NULL,'10.3K',0.5,NULL,NULL,NULL,NULL,NULL,1,8.5922083,10.205,0.169,NULL,66780192318,1043440504,16303757,10.3),(3720,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3720,37.93,0.46,385,1359,70,NULL,NULL,'2MASX J00342385+1555456',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000101,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,8.599417,15.92936,0.121,NULL,67472948902,1054264826,16472887,17.8),(3721,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3721,35.44,0.49,122,1360,75,NULL,'IR','IC 0031',NULL,'2011yCatp016004901K',2011,1,1.6,NULL,'G',0.00007,NULL,'15.23',0.3,'Sa',NULL,NULL,NULL,NULL,1,8.602625,12.26817,0.185,NULL,66754376578,1043037134,16297455,15.23),(3722,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3722,34.97,0.2,98.6,1361,74.4,NULL,NULL,'CGCG 409-039',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',NULL,NULL,'15.7',0.4,NULL,NULL,NULL,NULL,NULL,1,8.62066666667,8.45069,0.129,NULL,66836289065,1044317016,16317453,15.7),(3723,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3723,37.23,0.46,279,1362,70,NULL,NULL,'2MASX J00342919-1101052',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000076,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,8.62175,-11.01819,0.071,NULL,34570620049,540165938,8440092,17.7),(3724,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3724,31.52,0.8,20.1,1363,75,NULL,'MAT, I','IC 1555',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000017,NULL,'14.35',0.9,'SA(s)d         HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,8.636,-30.01786,NULL,NULL,34891439944,545178749,8518417,14.35),(3725,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3725,31.2,0.43,17.4,1363,75,NULL,'3.6 micron, color + selection bias corrected','IC 1555',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3726,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3726,31.28,0.43,18,1363,75,NULL,'3.6 micron, color corrected','IC 1555',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3727,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3727,31.28,0.2,18,1363,74.4,NULL,NULL,'IC 1555',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3728,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3728,31.35,0.32,18.6,1363,85,NULL,'I, inv','IC 1555',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3729,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3729,31.38,0.32,18.9,1363,85,NULL,'I, raw','IC 1555',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3730,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3730,31.8,0.4,22.9,1363,NULL,NULL,NULL,'IC 1555',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3731,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3731,31.8,0.43,22.9,1363,75,NULL,'MAT, I, inv','IC 1555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3732,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3732,31.8,0.4,22.9,1363,73,NULL,'opt','IC 1555',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3733,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3733,31.9,0.43,23.9,1363,75,NULL,'MAT, I, raw','IC 1555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3734,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3734,32.04,0.43,25.6,1363,75,NULL,'MAT, I, cor','IC 1555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3735,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3735,37.92,0.46,384,1364,70,NULL,NULL,'2MASX J00343398-0112577',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000095,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,8.641667,-1.216,0.063,NULL,34394628189,537416065,8397126,17.3),(3736,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 10645','RN',3736,38.27,0.17,419,1365,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10645',0.072753,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3737,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 10645','RN',3737,39.72,0.19,821,1365,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10645',0.072753,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3738,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3738,35.47,0.07,124,1366,NULL,NULL,NULL,'NGC 0159',NULL,'2009ApJS..182..474S',2009,1,1.29,NULL,'G',0.000043,NULL,'14.81',0.45,'(R)SB(r)0/a',NULL,NULL,NULL,NULL,1,8.6480417,-55.78997,0,NULL,36217656358,565900880,8842201,14.81),(3739,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3739,36.62,0.46,211,1367,70,NULL,NULL,'2MASX J00343565-0043567',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000078,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,8.6484583,-0.73261,0.05,NULL,34394775358,537418364,8397161,16.8),(3740,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3740,39.02,0.46,635,1368,70,NULL,NULL,'SDSS J003437.24-000242.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000073,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,8.655167,-0.04517,0.057,NULL,34394379521,537412180,8397065,18.5),(3741,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3741,36.4,0.69,191,1369,70,NULL,NULL,'2MASX J00343923-1812407',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'15.4R',0.22,NULL,NULL,NULL,NULL,NULL,1,8.663583,-18.21131,0.028,NULL,35365255463,552582116,8634095,15.4),(3742,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3742,37.2,0.46,275,1370,70,NULL,NULL,'2MASX J00343938-0024467',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000088,NULL,'15.57',0.31,NULL,NULL,NULL,NULL,NULL,1,8.6639583,-0.41297,0.05,NULL,34394439030,537413109,8397079,15.57),(3743,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3743,34.07,0.46,65.3,1371,70,NULL,NULL,'NGC 0155',NULL,'2015arXiv151105856S',2015,1,1.38,NULL,'G',0.00006,NULL,'13.6g',1.06,'S0^0^ pec',NULL,NULL,NULL,NULL,1,8.667,-10.7665,0.045,NULL,34571421181,540178455,8440288,13.6),(3744,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3744,34.13,0.45,67.1,1371,NULL,NULL,'K','NGC 0155',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3745,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3745,34.65,0.4,85.2,1371,NULL,NULL,'mean','NGC 0155',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3746,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 03195','R',3746,40.94,0.27,1180,1372,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03195',0.3,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,8.6682917,0.24422,0.057,NULL,66591129181,1040486393,16257599,NULL),(3747,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 03195','R',3747,41.38,0.2,1450,1372,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03195',0.3,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3748,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3748,35.36,0.47,118,1373,70,NULL,NULL,'2MASX J00344197-1812027',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'15.69',0.32,NULL,NULL,NULL,NULL,NULL,1,8.674875,-18.20072,0.028,NULL,35365247685,552581995,8634093,15.69),(3749,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3749,37.75,0.46,354,1374,70,NULL,NULL,'2MASX J00344392+0029362',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000068,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,8.682917,0.49336,0.052,NULL,66591747961,1040496061,16257750,17.9),(3750,'HII region diameter','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3750,31.95,0.13,24.6,1375,NULL,NULL,NULL,'NGC 0157',NULL,'2005JKAS...38....7I',2005,1,4.2,'Extended HIPASS source','G',0.000017,NULL,'11.00',2.7,'SAB(rs)bc      HII',NULL,NULL,NULL,NULL,1,8.694833,-8.39644,0.126,NULL,34621935710,540967745,8452621,11),(3751,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3751,31.62,0.8,21.1,1375,75,NULL,'MAT, I','NGC 0157',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3752,'Sosies','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3752,32.32,0.19,29.1,1375,NULL,NULL,NULL,'NGC 0157',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3753,'Tully est','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3753,31.6,0.8,20.9,1375,75,NULL,'B','NGC 0157',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3754,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3754,30.37,0.49,11.8,1375,NULL,NULL,NULL,'NGC 0157',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3755,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3755,30.41,0.2,12.1,1375,74.4,NULL,NULL,'NGC 0157',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3756,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3756,30.43,0.39,12.2,1375,73,NULL,'opt','NGC 0157',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3757,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3757,30.51,0.46,12.6,1375,NULL,NULL,'Malmquist cor.','NGC 0157',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3758,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3758,31.07,0.69,16.4,1375,100,NULL,'mid-IR','NGC 0157',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3759,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3759,31.32,NULL,18.4,1375,NULL,NULL,'LEDA [April 2006]','NGC 0157',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3760,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3760,31.37,0.43,18.8,1375,75,NULL,'MAT, I, raw','NGC 0157',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3761,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3761,31.41,0.32,19.1,1375,85,NULL,'I, raw','NGC 0157',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3762,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3762,31.46,0.32,19.6,1375,85,NULL,'I, inv','NGC 0157',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3763,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3763,31.58,0.43,20.7,1375,75,NULL,'MAT, I, cor','NGC 0157',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3764,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3764,31.61,0.43,21,1375,75,NULL,'MAT, I, inv','NGC 0157',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3765,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 02423','RN',3765,40.56,0.11,1090,1376,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 02423',0.188652,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3766,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 02423','RN',3766,41.3,0.19,1530,1376,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 02423',0.188652,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3767,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3767,33.52,0.8,50.5,1377,75,NULL,'W91PP, r','UGC 00345',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000023,NULL,'15.56',0.2,'SBcd?','Isolated galaxy',NULL,NULL,NULL,1,8.704583,28.4105,0.113,NULL,67322514661,1051914291,16436160,15.56),(3768,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3768,33.4,0.38,47.8,1377,75,NULL,'W91PP, r, inv','UGC 00345',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3769,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3769,33.52,0.38,50.7,1377,75,NULL,'W91PP, r, raw','UGC 00345',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3770,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3770,33.62,0.2,53,1377,74.4,NULL,NULL,'UGC 00345',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3771,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3771,33.86,0.38,59.1,1377,75,NULL,'W91PP, r, cor','UGC 00345',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3772,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 14399','RN',3772,41.37,0.21,1330,1378,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 14399',0.409077,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3773,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:34','1','SDSS-II SN 14399','RN',3773,41.88,0.25,1690,1378,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 14399',0.409077,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3774,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3774,34.53,0.5,80.6,1379,NULL,NULL,'Malmquist cor.','UGC 00344',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000037,NULL,'15.09',0.7,'SAB(s)cd',NULL,NULL,NULL,NULL,1,8.71258333333,39.54511,0.161,NULL,67147632827,1049181762,16393465,15.09),(3775,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3775,34.75,0.2,89.1,1379,74.4,NULL,NULL,'UGC 00344',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3776,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3776,34.81,0.44,91.6,1379,NULL,NULL,NULL,'UGC 00344',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3777,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3777,37.07,0.6,260,1380,70,NULL,NULL,'2MASX J00345135-5221453',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'17.0b',0.17,NULL,NULL,NULL,NULL,NULL,1,8.713917,-52.36256,NULL,NULL,36022190582,562846727,8794480,17),(3778,'FP','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,'R',3778,37.83,0.46,368,1381,70,NULL,NULL,'SDSS J003454.51+000302.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000065,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,8.72716666667,0.05083,0.057,NULL,66590885547,1040482586,16257540,18.5),(3779,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3779,34.49,0.8,79.2,1382,75,NULL,'W91PP, r','UGC 00346',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.00003,NULL,'14.78',0.5,'Sbc',NULL,NULL,NULL,NULL,1,8.7330417,31.94878,0.209,NULL,67375754061,1052746157,16449158,14.78),(3780,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3780,34.52,0.8,80.1,1382,75,NULL,'CF, r','UGC 00346',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3781,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3781,34.33,0.32,73.3,1382,NULL,NULL,NULL,'UGC 00346',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3782,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3782,34.38,0.38,75.1,1382,75,NULL,'CF, r, raw','UGC 00346',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3783,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3783,34.39,0.31,75.6,1382,NULL,NULL,'Malmquist cor.','UGC 00346',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3784,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:34','1',NULL,NULL,3784,34.44,0.2,77.3,1382,74.4,NULL,NULL,'UGC 00346',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3785,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3785,34.45,0.38,77.8,1382,75,NULL,'CF, r, inv','UGC 00346',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3786,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3786,34.5,0.38,79.3,1382,75,NULL,'CF, r, cor','UGC 00346',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3787,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3787,34.65,0.38,85.2,1382,75,NULL,'W91PP, r, raw','UGC 00346',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3788,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3788,34.76,0.38,89.4,1382,75,NULL,'W91PP, r, inv','UGC 00346',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3789,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3789,34.78,0.38,90.4,1382,75,NULL,'W91PP, r, cor','UGC 00346',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3790,'FP','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,'R',3790,34.84,0.46,93.1,1383,70,NULL,NULL,'MCG -02-02-059',NULL,'2015arXiv151105856S',2015,1,0.88,NULL,'G',0.000037,NULL,'14.5g',0.69,'S0/a',NULL,NULL,NULL,NULL,1,8.7415417,-9.34222,0.118,NULL,34574044379,540219443,8440928,14.5),(3791,'FP','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,'R',3791,38.13,0.46,423,1384,70,NULL,NULL,'2MASX J00345985-1037583',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000081,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,8.74925,-10.63294,0.045,NULL,34575295633,540238994,8441234,17.8),(3792,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3792,33.94,NULL,61.5,1385,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00347',NULL,'2010Ap&SS.325..163P',2010,1,1.18,NULL,'G',0.000053,':','16.5',0.16,'Sd',NULL,NULL,NULL,NULL,1,8.775875,45.52914,0.329,NULL,67701445344,1057835083,16528673,16.5),(3793,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3793,33.95,NULL,61.6,1385,NULL,NULL,'Dipole','UGC 00347',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3794,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3794,33.95,NULL,61.6,1385,NULL,NULL,'Dipole + Quadrupole','UGC 00347',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3795,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3795,33.97,NULL,62.3,1385,NULL,NULL,NULL,'UGC 00347',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3796,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 07707','RN',3796,41.32,0.25,1510,1386,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07707',0.21167,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3797,'FP','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3797,34.8,0.62,91.3,1387,70,NULL,NULL,'ESO 242- G 016',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000127,NULL,'15',0.4,'(R_1)SB0^+     Sbrst','in a pair',NULL,NULL,NULL,1,8.7970417,-43.98522,NULL,NULL,38173560873,596461888,9319717,15),(3798,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 20267','R',3798,41.3,0.27,1300,1388,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20267',0.401202,'2014arXiv1401.3317S',2014,1,0.09,NULL,'G',NULL,'PHOT','20.5g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,8.803833,-0.11953,0.043,NULL,34394496402,537414006,8397093,20.5),(3799,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 20267','R',3799,41.52,0.26,1440,1388,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20267',0.401202,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3800,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 20267',NULL,3800,40.83,0.39,1460,1388,70,NULL,'SN photometric redshift distance, z photo =0.428 +/- 0.117','SDSS-II SN 20267',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3801,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 20267',NULL,3801,41.14,0.18,1690,1388,70,NULL,'SALT 2','SDSS-II SN 20267',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3802,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 20267',NULL,3802,41.21,0.18,1750,1388,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20267',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3803,'FP','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3803,34.67,0.49,85.8,1389,70,NULL,NULL,'ESO 294- G 023',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000087,NULL,'14.79',0.9,'(R_1)SB(r)a',NULL,NULL,NULL,NULL,1,8.80466666667,-37.558,NULL,NULL,34658466020,541538531,8461539,14.79),(3804,'FP','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3804,37.24,0.89,281,1390,70,NULL,NULL,'2MASX J00351317-6049228',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'15.51',0.57,'S',NULL,NULL,NULL,NULL,1,8.804833,-60.82297,0,NULL,36081802830,563778169,8809033,15.51),(3805,'FP','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3805,35.27,0.48,113,1391,70,NULL,NULL,'2MASX J00351758-0239084',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.04',0.39,NULL,NULL,NULL,NULL,NULL,1,8.8232917,-2.65231,0.101,NULL,34578931724,540295808,8442122,16.04),(3806,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 01385',NULL,3806,40.12,0.31,1060,1392,70,NULL,'SN photometric redshift distance, z photo =0.287 +/- 0.053','SDSS-II SN 01385',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.2g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,8.82725,0.07564,0.057,NULL,66590979756,1040484058,16257563,21.2),(3807,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 01385','R',3807,41.28,0.33,1350,1392,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01385',0.336879,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3808,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 01385','R',3808,41.44,0.25,1450,1392,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01385',0.336879,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3809,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,'R',3809,34.28,0.49,71.9,1393,75,NULL,'IR','UGC 00349',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',NULL,NULL,'15.24',0.5,'SAB(s)bc',NULL,NULL,NULL,NULL,1,8.851125,3.39639,0.037,NULL,66821399425,1044084366,16313818,15.24),(3810,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 07483','RN',3810,41.68,0.21,1930,1394,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 07483',0.119998,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3811,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 07483','RN',3811,41.83,0.32,2080,1394,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 07483',0.119998,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3812,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 13456','RN',3812,44.07,0.27,4370,1395,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13456',0.491978,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3813,'FP','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,'R',3813,36.64,0.46,213,1396,70,NULL,NULL,'2MASX J00353105+1542247',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000083,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,8.87933333333,15.70692,0.153,NULL,67470948347,1054233567,16472399,17.4),(3814,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 15992','RN',3814,41.56,0.27,1510,1397,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15992',0.364455,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3815,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 15992','RN',3815,41.81,0.34,1690,1397,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15992',0.364455,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3816,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 15992','N',3816,41.72,0.22,2210,1397,70,NULL,'SALT 2','SDSS-II SN 15992',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3817,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 15992','N',3817,41.77,0.22,2260,1397,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15992',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3818,'CMD','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3818,24.3,NULL,0.724,1398,NULL,NULL,NULL,'Andromeda III',NULL,'2014ApJ...789..147W',2014,1,4.5,NULL,'G',0.00003,NULL,'15.0',3,'dSph','Group member',NULL,NULL,NULL,1,8.89075,36.49775,0.193,1,67153689792,1049276403,16394943,15),(3819,'CMD','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3819,24.4,0.2,0.759,1398,NULL,NULL,NULL,'Andromeda III',NULL,'1993AJ....106..986A',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3820,'Horizontal Branch','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,'R',3820,24.29,0.15,0.721,1398,NULL,NULL,NULL,'Andromeda III',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3821,'Horizontal Branch','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3821,24.38,0.06,0.752,1398,NULL,NULL,NULL,'Andromeda III',NULL,'2002AJ....124..332D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3822,'RR Lyrae','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3822,24.18,0.11,0.685,1398,NULL,NULL,'V','Andromeda III',NULL,'2013MNRAS.435.3206D',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3823,'RR Lyrae','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3823,24.36,NULL,0.745,1398,NULL,NULL,NULL,'Andromeda III',NULL,'2008ApJ...679...52T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3824,'RR Lyrae','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3824,24.38,0.06,0.751,1398,NULL,NULL,NULL,'Andromeda III',NULL,'2005AJ....129.2232P',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3825,'TRGB','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3825,24.3,0.07,0.723,1398,NULL,NULL,NULL,'Andromeda III',NULL,'2012ApJ...758...11C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3826,'TRGB','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3826,24.33,0.08,0.74,1398,74.4,NULL,NULL,'Andromeda III',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3827,'TRGB','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3827,24.37,0.07,0.748,1398,NULL,NULL,NULL,'Andromeda III',NULL,'2005MNRAS.356..979M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3828,'FP','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3828,34.29,0.53,72,1399,70,NULL,NULL,'NGC 0161',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000143,NULL,'14.45',0.8,'S0^0^:',NULL,NULL,NULL,NULL,1,8.89141666667,-2.84869,0.154,NULL,34592672735,540510511,8445476,14.45),(3829,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 06288','RN',3829,41.17,0.16,1420,1400,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 06288',0.209155,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3830,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 06288','RN',3830,41.98,0.25,2060,1400,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 06288',0.209155,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3831,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3831,33.72,0.2,55.5,1401,74.4,NULL,NULL,'MCG -01-02-038',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.00007,NULL,'14.97',0.4,'Sbc pec?',NULL,NULL,NULL,NULL,1,8.90079166667,-4.73322,0.162,NULL,34591319199,540489362,8445146,14.97),(3832,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3832,34.24,0.4,70.3,1401,NULL,NULL,'mean','MCG -01-02-038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3833,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3833,34.62,0.47,83.8,1401,NULL,NULL,'H','MCG -01-02-038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3834,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3834,34.25,0.4,70.6,1402,NULL,NULL,'mean','IC 0034',NULL,'2007A&A...465...71T',2007,1,2.8,NULL,'G',0.000023,NULL,'13.50',1,'SB(r)a',NULL,NULL,NULL,NULL,1,8.90175,9.12425,0.145,NULL,66786811971,1043543937,16305374,13.5),(3835,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3835,34.37,0.29,74.7,1402,NULL,NULL,'Malmquist cor.','IC 0034',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3836,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3836,34.47,0.47,78.3,1402,NULL,NULL,'H','IC 0034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3837,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3837,34.48,0.46,78.8,1402,NULL,NULL,'J','IC 0034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3838,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3838,34.51,0.45,79.6,1402,NULL,NULL,'K','IC 0034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3839,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3839,34.56,0.26,81.5,1402,NULL,NULL,NULL,'IC 0034',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3840,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3840,34.85,0.2,93.3,1402,74.4,NULL,NULL,'IC 0034',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3841,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SN 2007ot',NULL,3841,39.52,0.08,800,1403,70,NULL,'Hubble residual 0.08 for z0.20000','SDSS J003536.78-001357.6',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,'22.7g',NULL,NULL,NULL,NULL,NULL,NULL,1,8.9032917,-0.23267,0.043,NULL,34394511778,537414246,8397097,22.7),(3842,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 19658','R',3842,40.04,0.2,849,1403,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ot','SDSS J003536.78-001357.6',0.2,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3843,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 19658','R',3843,40.2,0.11,912,1403,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ot','SDSS J003536.78-001357.6',0.2,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3844,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SN 2007mv',NULL,3844,40,0.21,1000,1404,70,NULL,'SDSS-II SN 18325','SDSS J003537.64+002210.2',NULL,'2013MNRAS.434.1443X',2013,1,0.14,NULL,'G',NULL,NULL,'19.4g',0.09,NULL,NULL,NULL,NULL,NULL,1,8.906875,0.3695,0.065,NULL,66591857020,1040497765,16257777,19.4),(3845,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 18325','R',3845,40.64,0.21,1060,1404,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007mv','SDSS J003537.64+002210.2',0.26,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3846,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 18325','R',3846,40.76,0.16,1130,1404,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007mv','SDSS J003537.64+002210.2',0.26,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3847,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SN 2007mv',NULL,3847,40.54,0.11,1280,1404,70,NULL,'SALT 2','SDSS J003537.64+002210.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3848,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SN 2007mv',NULL,3848,40.57,0.11,1300,1404,70,NULL,'SALT 2, Malmquist cor.','SDSS J003537.64+002210.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3849,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3849,33.51,0.4,50.5,1405,NULL,NULL,'mean','ESO 540- G 003',NULL,'2007A&A...465...71T',2007,1,2,NULL,'G',0.000007,NULL,'13.65',0.8,'SA(r)b','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,8.9145,-20.12533,0.115,NULL,35364099805,552564059,8633813,13.65),(3850,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3850,33.84,0.46,58.7,1405,NULL,NULL,'J','ESO 540- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3851,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3851,33.85,0.47,58.9,1405,NULL,NULL,'H','ESO 540- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3852,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3852,33.96,0.45,62,1405,NULL,NULL,'K','ESO 540- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3853,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3853,34.44,0.36,77.4,1406,NULL,NULL,'Malmquist cor.','UGC 00353',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.00001,NULL,'15.25',0.4,'Scd:',NULL,NULL,NULL,NULL,1,8.91475,8.99758,0.145,NULL,66786079014,1043532484,16305195,15.25),(3854,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3854,34.49,0.2,79.1,1406,74.4,NULL,NULL,'UGC 00353',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3855,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3855,34.62,0.33,84.1,1406,NULL,NULL,NULL,'UGC 00353',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3856,'FP','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3856,36.15,0.57,170,1407,70,NULL,NULL,'2MASX J00354069-0910103',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.000097,NULL,'15.9g',0.32,'S0/a',NULL,NULL,NULL,NULL,1,8.919625,-9.16953,0.118,NULL,34574619929,540228436,8441069,15.9),(3857,'FP','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,'R',3857,36,0.46,159,1408,70,NULL,NULL,'2MASX J00354352-0903423',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000098,NULL,'15.6g',0.47,'S0^-',NULL,NULL,NULL,NULL,1,8.93133333333,-9.06178,0.121,NULL,34573739719,540214683,8440854,15.6),(3858,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 02653','RN',3858,39.5,0.48,732,1409,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02653',0.0873,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3859,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 02653','RN',3859,39.63,0.7,774,1409,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02653',0.0873,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3860,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3860,34.15,0.8,67.6,1410,75,NULL,'W91PP, r','UGC 00352',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000047,NULL,'16.5',0.8,'I?',NULL,NULL,NULL,NULL,1,8.94445833333,24.23725,0.093,NULL,67203109532,1050048586,16407009,16.5),(3861,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3861,34.36,0.2,74.5,1410,74.4,NULL,NULL,'UGC 00352',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3862,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3862,34.54,0.38,80.9,1410,75,NULL,'W91PP, r, inv','UGC 00352',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3863,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3863,34.57,0.38,82.1,1410,75,NULL,'W91PP, r, raw','UGC 00352',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3864,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3864,34.78,0.38,90.5,1410,75,NULL,'W91PP, r, cor','UGC 00352',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3865,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3865,31.51,0.8,20.1,1411,75,NULL,'MAT, I','IC 1558',NULL,'1997ApJS..109..333W',1997,1,3.4,NULL,'G',0.00001,NULL,'12.61',2.5,'SAB(s)m',NULL,NULL,NULL,NULL,1,8.946125,-25.37442,0.046,NULL,34812718324,543948723,8499198,12.61),(3866,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3866,29.6,0.32,8.25,1411,85,NULL,'I, inv','IC 1558',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3867,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3867,29.65,0.32,8.48,1411,85,NULL,'I, raw','IC 1558',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3868,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3868,29.77,0.43,9,1411,75,NULL,'3.6 micron, color + selection bias corrected','IC 1558',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3869,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3869,29.84,0.2,9.29,1411,74.4,NULL,NULL,'IC 1558',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3870,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3870,29.84,0.43,9.3,1411,75,NULL,'3.6 micron, color corrected','IC 1558',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3871,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3871,29.96,0.43,9.83,1411,75,NULL,'MAT, I, inv','IC 1558',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3872,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3872,30.09,0.4,10.4,1411,NULL,NULL,NULL,'IC 1558',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3873,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3873,30.09,0.4,10.4,1411,73,NULL,'opt','IC 1558',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3874,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3874,30.11,0.43,10.5,1411,75,NULL,'MAT, I, raw','IC 1558',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3875,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3875,30.46,0.43,12.4,1411,75,NULL,'MAT, I, cor','IC 1558',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3876,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3876,31.37,0.4,18.8,1411,75,NULL,'B','IC 1558',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3877,'FP','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3877,37.19,0.62,274,1412,70,NULL,NULL,'6dF J0035479-454021',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,8.94966666667,-45.67253,NULL,NULL,38179578908,596555920,9321186,16),(3878,'FP','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3878,35.05,0.47,102,1413,70,NULL,NULL,'ESO 112- GA008',NULL,'2014MNRAS.445.2677S',2014,1,3.8,NULL,'G',0.000053,NULL,'14.0',2,'SA(s)0/a',NULL,NULL,NULL,NULL,1,8.961833,-59.69383,0,NULL,36083109864,563798591,8809352,14),(3879,'FP','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,'R',3879,37.05,0.46,257,1414,70,NULL,NULL,'2MASX J00355179-0029014',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000089,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,8.965875,-0.48369,0.039,NULL,34395375158,537427736,8397308,17.4),(3880,'GeV TeV ratio','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3880,40.43,0.37,1220,1415,70,NULL,'z = 0.34 +/- 0.08','WISE J003552.62+595004.3',NULL,'2015MNRAS.446..217A',2015,1,NULL,NULL,'QSO',NULL,'TENT','19.5',NULL,'BLLAC',NULL,NULL,NULL,'BL Lac',1,8.969333,59.83461,NULL,NULL,65925396757,1030084324,16095067,19.5),(3881,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 16213',NULL,3881,39.96,0.21,982,1416,70,NULL,NULL,'SDSS J003553.05+001530.3',NULL,'2013MNRAS.434.1443X',2013,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,8.9710417,0.25842,0.065,NULL,66591840316,1040497504,16257773,NULL),(3882,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 16213','R',3882,40.57,0.21,1090,1416,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006oi','SDSS J003553.05+001530.3',0.2,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3883,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 16213','R',3883,40.73,0.12,1170,1416,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006oi','SDSS J003553.05+001530.3',0.2,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3884,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3884,34.67,0.8,85.9,1417,75,NULL,'W91PP, r','UGC 00355',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'14.59',0.4,'SBab','Group member',NULL,NULL,NULL,1,8.977,31.87331,0.209,NULL,67375734887,1052745857,16449154,14.59),(3885,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,'R',3885,34.28,0.49,71.7,1417,75,NULL,'IR','UGC 00355',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3886,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3886,34.69,0.38,86.8,1417,75,NULL,'W91PP, r, raw','UGC 00355',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3887,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3887,34.83,0.38,92.4,1417,75,NULL,'W91PP, r, cor','UGC 00355',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3888,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3888,34.89,0.38,94.9,1417,75,NULL,'W91PP, r, inv','UGC 00355',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3889,'FP','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3889,36.03,0.49,161,1418,70,NULL,NULL,'2MASX J00355823-4229462',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.000103,NULL,'15.94',0.43,'S0',NULL,NULL,NULL,NULL,1,8.992625,-42.49617,NULL,NULL,38176291447,596504553,9320383,15.94),(3890,'FP','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,'R',3890,37.17,0.46,271,1419,70,NULL,NULL,'2MASX J00355885-1057513',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000072,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,8.995375,-10.96408,0.069,NULL,34574958126,540233720,8441151,17.9),(3891,'TRGB','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,'N',3891,24.45,0.14,0.772,1420,NULL,NULL,NULL,'Andromeda XXXII',NULL,'2013ApJ...772...15M',2013,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3892,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 15951','RN',3892,40.26,0.2,980,1421,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 15951',0.152672,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3893,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 15951','RN',3893,40.84,0.27,1270,1421,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 15951',0.152672,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3894,'Faber-Jackson','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3894,33.5,0.44,50.1,1422,95,NULL,'Weighted Mean','NGC 0163',NULL,'1984ApJS...56...91D',1984,1,1.19,NULL,'G',0.000047,NULL,'13.6g',1.11,'E0','in a pair',NULL,NULL,NULL,1,8.99929166667,-10.12169,0.091,NULL,34575439920,540241248,8441269,13.6),(3895,'Faber-Jackson','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3895,33.91,0.46,60.5,1422,95,NULL,'Michard 1979a','NGC 0163',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3896,'Faber-Jackson','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3896,34.13,0.63,67,1422,95,NULL,'Michard 1979b, c','NGC 0163',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3897,'FP','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,'R',3897,35.06,0.46,103,1422,70,NULL,NULL,'NGC 0163',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3898,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3898,34.59,0.4,82.9,1422,NULL,NULL,'mean','NGC 0163',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3899,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3899,34.77,0.45,90,1422,NULL,NULL,'K','NGC 0163',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3900,'FP','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,'R',3900,36.76,0.27,225,1423,70,NULL,NULL,'2MASX J00355987-1056003',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000106,NULL,'15.9g',0.39,'E0',NULL,NULL,NULL,NULL,1,8.9995,-10.93333,0.077,NULL,34574953458,540233647,8441150,15.9),(3901,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3901,33.89,0.8,60,1424,75,NULL,'MAT, I','VV 548',NULL,'1997ApJS..109..333W',1997,1,1.11,NULL,'G',0.00001,NULL,'14.6g',0.76,'SB(s)c pec:    HII',NULL,NULL,NULL,NULL,1,9.0082917,-9.88853,0.098,NULL,34577369810,540271403,8441740,14.6),(3902,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3902,32.62,0.2,33.4,1424,74.4,NULL,NULL,'VV 548',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3903,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3903,33.16,0.32,42.8,1424,85,NULL,'I, inv','VV 548',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3904,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3904,33.16,0.32,42.9,1424,85,NULL,'I, raw','VV 548',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3905,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3905,33.78,0.43,56.9,1424,75,NULL,'MAT, I, raw','VV 548',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3906,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3906,33.85,0.43,59,1424,75,NULL,'MAT, I, inv','VV 548',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3907,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3907,34.12,0.43,66.7,1424,75,NULL,'MAT, I, cor','VV 548',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3908,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 02929','R',3908,40.44,0.08,1090,1425,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 02929',0.120282,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,9.012,-0.835,0.04,NULL,34394681047,537416891,8397138,NULL),(3909,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 02929','R',3909,40.45,0.19,1100,1425,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 02929',0.120282,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3910,'Faber-Jackson','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3910,33.72,0.44,55.5,1426,95,NULL,'Weighted Mean','NGC 0160',NULL,'1984ApJS...56...91D',1984,1,3,NULL,'G',0.000017,NULL,'13.6',1.7,'(R)SA0+ pec','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,9.01691666667,23.95789,0.093,NULL,67203171871,1050049560,16407024,13.6),(3911,'Faber-Jackson','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3911,34.16,0.46,67.9,1426,95,NULL,'Michard 1979a','NGC 0160',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3912,'Faber-Jackson','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3912,34.38,0.63,75.2,1426,95,NULL,'Michard 1979b, c','NGC 0160',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3913,'IRAS','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3913,34.2,0.8,69.3,1426,75,NULL,'W91PP, r','NGC 0160',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3914,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3914,33.4,0.69,47.8,1426,100,NULL,'mid-IR','NGC 0160',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3915,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3915,34.24,0.3,70.5,1426,NULL,NULL,NULL,'NGC 0160',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3916,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3916,34.28,0.29,71.7,1426,NULL,NULL,'Malmquist cor.','NGC 0160',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3917,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3917,34.39,0.38,75.7,1426,75,NULL,'W91PP, r, raw','NGC 0160',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3918,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3918,34.58,0.38,82.3,1426,75,NULL,'W91PP, r, cor','NGC 0160',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3919,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3919,34.59,0.2,82.8,1426,74.4,NULL,NULL,'NGC 0160',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3920,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3920,34.72,0.38,87.8,1426,75,NULL,'W91PP, r, inv','NGC 0160',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3921,'FP','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3921,36.1,0.67,166,1427,70,NULL,NULL,'2MASX J00360522-0340138',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.70',0.23,NULL,NULL,NULL,NULL,NULL,1,9.0217917,-3.67056,0.158,NULL,34592905092,540514142,8445533,16.7),(3922,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3922,33.89,0.4,60,1428,NULL,NULL,'mean','ESO 350- G 037',NULL,'2007A&A...465...71T',2007,1,0.87,NULL,'G',0.00001,NULL,'14.4B',0.59,'Sa','in a triple',NULL,NULL,NULL,1,9.0275,-32.60322,NULL,NULL,34883113354,545048646,8516385,14.4),(3923,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3923,33.96,0.47,62,1428,NULL,NULL,'H','ESO 350- G 037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3924,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,'R',3924,31.89,0.49,23.9,1429,75,NULL,'IR','FGCE 0062',NULL,'2011yCatp016004901K',2011,1,0.81,NULL,'G',0.00009,NULL,'17.2',0.11,'Sd',NULL,NULL,NULL,NULL,1,9.02891666667,-36.62178,NULL,NULL,34650669950,541416717,8459636,17.2),(3925,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3925,32.34,NULL,29.4,1429,NULL,NULL,'Dipole + Quadrupole + Octopole','FGCE 0062',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3926,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3926,32.4,NULL,30.2,1429,NULL,NULL,'Dipole + Quadrupole','FGCE 0062',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3927,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3927,32.44,NULL,30.7,1429,NULL,NULL,'Dipole','FGCE 0062',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3928,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3928,32.45,NULL,30.9,1429,NULL,NULL,NULL,'FGCE 0062',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3929,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 20899','RN',3929,41.44,0.29,1640,1430,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 20899',0.18497,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3930,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 20899','RN',3930,42.3,0.46,2440,1430,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20899',0.18497,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3931,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3931,35.08,0.44,104,1431,NULL,NULL,'Malmquist cor.','UGC 00357',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000017,NULL,'15.18',0.6,'Sbc',NULL,NULL,NULL,NULL,1,9.041917,21.46456,0.061,NULL,67484242509,1054441289,16475645,15.18),(3932,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3932,35.29,0.4,114,1431,NULL,NULL,NULL,'UGC 00357',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3933,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3933,35.34,0.2,117,1431,74.4,NULL,NULL,'UGC 00357',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3934,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3934,32.85,0.61,37.2,1432,NULL,NULL,'Malmquist cor.','UGC 00359',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000043,NULL,'15.5',0.4,'S              HII',NULL,NULL,NULL,NULL,1,9.0440417,4.63522,0.021,NULL,66820461292,1044069707,16313589,15.5),(3935,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3935,32.88,0.6,37.6,1432,NULL,NULL,NULL,'UGC 00359',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3936,'Tully-Fisher','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3936,32.92,0.2,38.4,1432,74.4,NULL,NULL,'UGC 00359',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3937,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 16626','RN',3937,40.7,0.35,1080,1433,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16626',0.281567,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3938,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 16626','RN',3938,41.38,0.28,1480,1433,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16626',0.281567,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3939,'FP','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,NULL,3939,35.09,0.51,104,1434,70,NULL,NULL,'MCG -02-02-068',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000043,NULL,'14.72',0.7,'SAB(r)a:',NULL,NULL,NULL,NULL,1,9.0524583,-12.2585,0.021,NULL,34445108655,538204822,8409450,14.72),(3940,'FP','2016-12-15 15:13:33','2016-12-16 11:18:35','1',NULL,'R',3940,36.83,0.46,232,1435,70,NULL,NULL,'2MASX J00361474-0959223',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000076,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,9.061375,-9.98956,0.098,NULL,34577338315,540270911,8441732,16.7),(3941,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 14551','RN',3941,42.59,0.3,2640,1436,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14551',0.248754,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3942,'SNIa SDSS','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SDSS-II SN 14551','RN',3942,42.7,0.33,2780,1436,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 14551',0.248754,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3943,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SN 1996bl',NULL,3943,35.09,0.17,101,1437,74.2,NULL,'SALT 2','2MASX J00361813+1123354',0.036,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'SBc',NULL,NULL,NULL,NULL,1,9.0757083,11.39297,0.197,NULL,66774417173,1043350268,16302347,NULL),(3944,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SN 1996bl',NULL,3944,35.76,0.15,137,1437,70,NULL,'SALT 2','2MASX J00361813+1123354',0.036,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3945,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SN 1996bl',NULL,3945,35.71,0.08,139,1437,74.4,NULL,NULL,'2MASX J00361813+1123354',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3946,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SN 1996bl',NULL,3946,35.73,0.07,140,1437,60,NULL,'M(I) = -19.19 mag','2MASX J00361813+1123354',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3947,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SN 1996bl',NULL,3947,35.82,0.07,141,1437,65,NULL,'SALT2','2MASX J00361813+1123354',0.036,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3948,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SN 1996bl',NULL,3948,35.82,0.19,141,1437,72,NULL,NULL,'2MASX J00361813+1123354',0.036,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3949,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SN 1996bl',NULL,3949,35.83,0.17,141,1437,70,NULL,'SALT','2MASX J00361813+1123354',0.036,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3950,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SN 1996bl',NULL,3950,35.82,0.15,141,1437,73.8,NULL,'SALT 2 (SNANA)','2MASX J00361813+1123354',0.0349,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3951,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SN 1996bl',NULL,3951,35.84,0.07,142,1437,70,NULL,NULL,'2MASX J00361813+1123354',0.036,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3952,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SN 1996bl',NULL,3952,35.79,0.06,144,1437,60,NULL,'M(V) = -19.47 mag','2MASX J00361813+1123354',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3953,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SN 1996bl',NULL,3953,35.9,0.04,146,1437,72,NULL,NULL,'2MASX J00361813+1123354',0.036,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3954,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SN 1996bl',NULL,3954,35.84,0.07,147,1437,60,NULL,'M(B) = -19.48 mag','2MASX J00361813+1123354',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3955,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SN 1996bl',NULL,3955,35.94,0.04,148,1437,70,NULL,'SALT 2','2MASX J00361813+1123354',0.036,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3956,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SN 1996bl',NULL,3956,35.96,0.18,150,1437,65,NULL,'SALT2','2MASX J00361813+1123354',0.036,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3957,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SN 1996bl',NULL,3957,36,0.17,153,1437,65,NULL,'SALT','2MASX J00361813+1123354',0.036,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3958,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SN 1996bl',NULL,3958,36.1,0.11,154,1437,65,NULL,'MLCS2k2','2MASX J00361813+1123354',0.036,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3959,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SN 1996bl',NULL,3959,35.95,0.17,155,1437,70.8,NULL,NULL,'2MASX J00361813+1123354',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3960,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SN 1996bl',NULL,3960,36.06,0.08,157,1437,65,NULL,'MLCS2k2','2MASX J00361813+1123354',0.036,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3961,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SN 1996bl',NULL,3961,36.06,0.16,157,1437,65,NULL,'MLCS31','2MASX J00361813+1123354',0.036,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3962,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SN 1996bl',NULL,3962,36.08,0.15,158,1437,65,NULL,'MLCS17','2MASX J00361813+1123354',0.036,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3963,'SNIa','2016-12-15 15:13:33','2016-12-16 11:18:35','1','SN 1996bl',NULL,3963,36.09,0.12,159,1437,65,NULL,'MLCS2k2','2MASX J00361813+1123354',0.036,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3964,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SN 1996bl',NULL,3964,36.14,0.02,163,1437,65,NULL,'SALT','2MASX J00361813+1123354',0.036,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3965,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SN 1996bl',NULL,3965,36.17,0.19,165,1437,65,NULL,NULL,'2MASX J00361813+1123354',0.036,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3966,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SN 1996bl',NULL,3966,36.13,0.14,168,1437,60,NULL,NULL,'2MASX J00361813+1123354',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3967,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',3967,36.76,0.27,225,1438,70,NULL,NULL,'2MASX J00362174-1051073',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000105,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,9.0905417,-10.85214,0.077,NULL,34574906968,540232921,8441139,16.8),(3968,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,3968,35.11,NULL,105,1439,NULL,NULL,'Dipole + Quadrupole + Octopole','FGCE 0066',NULL,'2010Ap&SS.325..163P',2010,1,1.1,NULL,'G',0.000033,NULL,'16.22',0.19,'Scd',NULL,NULL,NULL,NULL,1,9.10629166667,-57.00842,0,NULL,36218280033,565910625,8842353,16.22),(3969,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',3969,35.11,0.49,105,1439,75,NULL,'IR','FGCE 0066',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3970,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,3970,35.12,NULL,106,1439,NULL,NULL,'Dipole + Quadrupole','FGCE 0066',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3971,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,3971,35.14,NULL,106,1439,NULL,NULL,'Dipole','FGCE 0066',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3972,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,3972,35.28,0.46,114,1439,NULL,NULL,NULL,'FGCE 0066',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3973,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,3973,35.32,0.2,116,1439,74.4,NULL,NULL,'FGCE 0066',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3974,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,3974,35.32,0.45,116,1439,NULL,NULL,'Malmquist cor.','FGCE 0066',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3975,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,3975,34.49,0.47,79,1440,NULL,NULL,'H','NGC 0165',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.00003,NULL,'14.0g',1.06,'SB(rs)bc','in a pair',NULL,NULL,NULL,1,9.1205,-10.10617,0.091,NULL,34575383477,540240366,8441255,14),(3976,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,3976,34.56,0.4,81.8,1440,NULL,NULL,'mean','NGC 0165',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3977,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,3977,34.62,0.45,84,1440,NULL,NULL,'K','NGC 0165',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3978,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,3978,34.63,0.46,84.5,1440,NULL,NULL,'J','NGC 0165',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3979,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',3979,35.76,0.46,142,1441,70,NULL,NULL,'2MASX J00362924-0043433',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000085,NULL,'15.9g',0.27,'S0^-',NULL,NULL,NULL,NULL,1,9.121875,-0.72853,0.038,NULL,34394669924,537416717,8397136,15.9),(3980,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,3980,35.96,0.6,155,1441,70,NULL,NULL,'2MASX J00362924-0043433',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3981,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',3981,38.09,0.46,415,1442,70,NULL,NULL,'2MASX J00363418-0104463',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000077,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,9.142375,-1.07961,0.045,NULL,34396520535,537445633,8397588,17.5),(3982,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,3982,24.17,0.1,0.681,1443,NULL,NULL,NULL,'Andromeda XXX',NULL,'2012ApJ...758...11C',2012,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,9.145417,49.64667,0.813,0,65826386045,1028537281,16070895,NULL),(3983,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 07402','RN',3983,39.93,0.22,753,1444,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 07402',0.286,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3984,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 07402','RN',3984,40.33,0.13,904,1444,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 07402',0.286,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3985,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,3985,35.05,0.35,102,1445,NULL,NULL,'Malmquist cor.','UGC 00364',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000017,NULL,'14.47',0.4,'S?',NULL,NULL,NULL,NULL,1,9.1877083,21.56606,0.061,NULL,67484221106,1054440954,16475639,14.47),(3986,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',3986,35.25,0.49,112,1445,75,NULL,'IR','UGC 00364',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3987,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,3987,35.28,0.32,114,1445,NULL,NULL,NULL,'UGC 00364',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3988,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,3988,35.37,0.47,119,1445,NULL,NULL,'H','UGC 00364',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3989,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,3989,35.42,0.45,121,1445,NULL,NULL,'K','UGC 00364',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3990,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,3990,35.47,0.46,124,1445,NULL,NULL,'J','UGC 00364',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3991,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,3991,35.49,0.4,125,1445,NULL,NULL,'mean','UGC 00364',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3992,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,3992,35.49,0.2,125,1445,74.4,NULL,NULL,'UGC 00364',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3993,'IRAS','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,3993,34.82,0.8,92.1,1446,75,NULL,'MAT, I','ESO 410- G 027',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.00003,NULL,'14.44',0.8,'SB(s)c:','Field galaxy',NULL,NULL,NULL,1,9.214167,-28.36622,0.061,NULL,34837737009,544339640,8505306,14.44),(3994,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,3994,33.55,0.32,51.3,1446,85,NULL,'I, raw','ESO 410- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3995,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,3995,33.57,0.32,51.8,1446,85,NULL,'I, inv','ESO 410- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3996,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,3996,33.75,0.43,56.3,1446,75,NULL,'MAT, I, raw','ESO 410- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3997,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,3997,33.9,0.43,60.1,1446,75,NULL,'MAT, I, inv','ESO 410- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3998,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,3998,34.17,0.43,68.3,1446,75,NULL,'MAT, I, cor','ESO 410- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3999,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,3999,34.28,0.2,71.8,1446,74.4,NULL,NULL,'ESO 410- G 027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4000,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4000,34.47,0.61,78.3,1446,NULL,NULL,NULL,'ESO 410- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4001,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4001,34.52,0.59,80.2,1446,NULL,NULL,'Malmquist cor.','ESO 410- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4002,'IRAS','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4002,33.81,0.8,57.7,1447,75,NULL,'W91PP, r','NGC 0169',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.00003,NULL,'13.3',0.7,'SA(s)ab: sp','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,9.215,23.99092,0.053,NULL,67202304903,1050036014,16406812,13.3),(4003,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4003,33.98,0.4,62.4,1447,NULL,NULL,'mean','NGC 0169',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4004,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4004,34.17,0.47,68.2,1447,NULL,NULL,'H','NGC 0169',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4005,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4005,34.18,0.45,68.5,1447,NULL,NULL,'K','NGC 0169',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4006,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4006,34.24,0.46,70.5,1447,NULL,NULL,'J','NGC 0169',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4007,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4007,34.4,0.38,75.7,1447,75,NULL,'W91PP, r, raw','NGC 0169',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4008,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4008,34.58,0.38,82.4,1447,75,NULL,'W91PP, r, cor','NGC 0169',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4009,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4009,34.7,0.38,87.1,1447,75,NULL,'W91PP, r, inv','NGC 0169',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4010,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4010,34.95,0.2,97.7,1447,74.4,NULL,NULL,'NGC 0169',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4011,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 02362','RN',4011,42.18,0.14,1950,1448,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 02362',0.398761,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4012,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 02362','RN',4012,42.68,0.2,2460,1448,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02362',0.398761,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4013,'SZ effect','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4013,38.53,NULL,509,1449,NULL,NULL,'3.1 (red) calibration','ABELL 0068',NULL,'2010ApJ...721..653R',2010,1,NULL,'Ebeling et al. estimates 0.1889 redshift from 10th brightest galaxy.','GClstr',NULL,NULL,NULL,NULL,'II-III [BM]',NULL,NULL,NULL,NULL,1,9.272083,9.15306,0.185,NULL,66786742079,1043542844,16305356,NULL),(4014,'SZ effect','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4014,38.66,0.74,540,1449,NULL,NULL,'Isotherm.','ABELL 0068',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4015,'SZ effect','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4015,39,0.6,630,1449,NULL,NULL,'Hydrost. Eq.','ABELL 0068',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4016,'SZ effect','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4016,39.16,0.79,680,1449,NULL,NULL,'Isotherm., r < 100 kpc','ABELL 0068',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4017,'SZ effect','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4017,39.17,NULL,681,1449,NULL,NULL,'4.2 (black) calibration','ABELL 0068',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4018,'SZ effect','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4018,39.58,NULL,825,1449,NULL,NULL,'4.1 (blue) calibration','ABELL 0068',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4019,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4019,36.76,0.27,225,1450,70,NULL,NULL,'2MASX J00370036-1041432',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000097,NULL,'15.8g',0.41,'BrClG',NULL,NULL,NULL,NULL,1,9.251625,-10.69539,0.086,NULL,34575662336,540244724,8441323,15.8),(4020,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4020,37.02,0.75,254,1451,70,NULL,NULL,'2MASX J00370106-2147242',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'17.17',0.15,NULL,NULL,NULL,NULL,NULL,1,9.2544583,-21.79014,0.061,NULL,35327223558,551987868,8624810,17.17),(4021,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4021,37.24,0.46,280,1452,70,NULL,NULL,'SDSS J003703.44+141256.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000078,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,9.264333,14.21575,0.149,NULL,67463324795,1054114449,16470538,17.9),(4022,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4022,37.58,0.33,328,1453,70,NULL,NULL,'3C 015',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00015,NULL,'15.2r',0.39,'E1;BrClG       NLRG',NULL,NULL,'FR II',NULL,1,9.26729166667,-1.15225,0.036,NULL,34397420108,537459689,8397807,15.2),(4023,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4023,35.76,0.4,142,1454,NULL,NULL,'mean','UGC 00367',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.00005,NULL,'14.89',0.1,'E?',NULL,NULL,'radio jet',NULL,1,9.272833,25.699,0.065,NULL,67208220276,1050128441,16408256,14.89),(4024,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4024,36,0.45,159,1454,NULL,NULL,'K','UGC 00367',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4025,'IRAS','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4025,33.3,0.8,45.6,1455,75,NULL,'MAT, I','ESO 242- G 018',NULL,'1997ApJS..109..333W',1997,1,1.9,'Confused HIPASS source','G',0.000024,NULL,'13.97',0.9,'SAB(rs)cd','in a pair',NULL,NULL,NULL,1,9.27575,-46.64408,NULL,NULL,38180000333,596562505,9321289,13.97),(4026,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4026,32.6,0.32,33.1,1455,85,NULL,'I, raw','ESO 242- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4027,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4027,32.6,0.32,33.1,1455,85,NULL,'I, inv','ESO 242- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4028,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4028,32.99,0.43,39.6,1455,75,NULL,'MAT, I, raw','ESO 242- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4029,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4029,33.06,0.43,40.8,1455,75,NULL,'MAT, I, inv','ESO 242- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4030,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4030,33.24,0.4,44.5,1455,NULL,NULL,'Malmquist cor.','ESO 242- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4031,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4031,33.3,0.43,45.8,1455,75,NULL,'MAT, I, cor','ESO 242- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4032,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4032,33.36,0.38,47.1,1455,NULL,NULL,NULL,'ESO 242- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4033,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4033,33.4,0.2,47.9,1455,74.4,NULL,NULL,'ESO 242- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4034,'Horizontal Branch','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4034,24.36,0.06,0.724,1456,NULL,NULL,NULL,'Andromeda XVII',NULL,'2011ApJ...729...23B',2011,1,NULL,NULL,'G',NULL,NULL,'16.0V',NULL,'dSph',NULL,NULL,NULL,NULL,1,9.279167,44.32222,0.293,0,67708762746,1057949417,16530459,16),(4035,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4035,24.31,0.11,0.727,1456,NULL,NULL,NULL,'Andromeda XVII',NULL,'2012ApJ...758...11C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4036,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4036,24.5,0.1,0.794,1456,NULL,NULL,NULL,'Andromeda XVII',NULL,'2008ApJ...676L..17I',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4037,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4037,32.38,0.49,29.9,1457,75,NULL,'IR','CGCG 500-052',NULL,'2011yCatp016004901K',2011,1,0.7,NULL,'G',0.000033,NULL,'15.0',0.3,'Sab',NULL,NULL,NULL,NULL,1,9.28175,28.83167,0.137,NULL,67321048889,1051891388,16435802,15),(4038,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4038,36.85,0.46,234,1458,70,NULL,NULL,'2MASX J00370799+1431485',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000103,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,9.28345833333,14.53022,0.149,NULL,67475067796,1054297934,16473405,16.9),(4039,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 13532','RN',4039,42.42,0.34,2410,1459,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13532',0.264942,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4040,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 13532','RN',4040,42.86,0.46,2950,1459,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13532',0.264942,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4041,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SN 2005lo',NULL,4041,40.06,0.2,791,1460,74.2,NULL,'SALT 2','SDSS J003709.59-011222.4',0.299,'2010ApJ...716..712A',2010,1,0.12,NULL,'G',0.000082,NULL,'19.9g',0.07,NULL,NULL,NULL,NULL,NULL,1,9.29,-1.20625,0.036,NULL,34397416557,537459633,8397806,19.9),(4042,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 11452','R',4042,41.11,0.23,1270,1460,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005lo','SDSS J003709.59-011222.4',0.310279,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4043,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SN 2005lo',NULL,4043,41.11,0.24,1280,1460,70,NULL,'SALT 2','SDSS J003709.59-011222.4',0.299,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4044,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 11452','R',4044,41.16,0.35,1300,1460,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005lo','SDSS J003709.59-011222.4',0.310279,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4045,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4045,37.93,0.46,386,1461,70,NULL,NULL,'2MASX J00370985+0055310',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000087,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,9.291125,0.92533,0.017,NULL,66592903743,1040514120,16258033,17.7),(4046,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4046,37.58,0.33,328,1462,70,NULL,NULL,'2MASX J00371009-0106201',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000077,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,9.292125,-1.10556,0.036,NULL,34397408804,537459512,8397804,18.1),(4047,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4047,36.27,0.46,180,1463,70,NULL,NULL,'2MASX J00371110+1515535',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00008,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,9.296167,15.26489,0.153,NULL,67475550314,1054305473,16473523,16.5),(4048,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4048,33.89,0.4,60.1,1464,NULL,NULL,'mean','NGC 0173',NULL,'2007A&A...465...71T',2007,1,3.2,NULL,'G',0.000017,NULL,'13.7B',2.6,'SA(rs)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,9.3019583,1.94225,0,NULL,66590462213,1040475972,16257437,13.7),(4049,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4049,34.35,0.46,74,1464,NULL,NULL,'J','NGC 0173',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4050,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4050,34.38,0.45,75.2,1464,NULL,NULL,'K','NGC 0173',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4051,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4051,34.42,0.47,76.7,1464,NULL,NULL,'H','NGC 0173',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4052,'IRAS','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4052,32.89,0.8,37.9,1465,75,NULL,'MAT, I','NGC 0172',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.00001,NULL,'15.09',0.3,'SB(r)bc? sp    HII','in a triple',NULL,NULL,NULL,1,9.30670833333,-22.58703,0.085,NULL,35325848216,551966378,8624474,15.09),(4053,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4053,32.71,0.32,34.8,1465,85,NULL,'I, raw','NGC 0172',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4054,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4054,32.71,0.32,34.9,1465,85,NULL,'I, inv','NGC 0172',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4055,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4055,32.91,0.43,38.3,1465,75,NULL,'MAT, I, raw','NGC 0172',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4056,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4056,32.98,0.43,39.5,1465,75,NULL,'MAT, I, inv','NGC 0172',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4057,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4057,33.18,0.43,43.3,1465,75,NULL,'MAT, I, cor','NGC 0172',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4058,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4058,33.33,0.2,46.3,1465,74.4,NULL,NULL,'NGC 0172',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4059,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4059,33.34,0.49,46.5,1465,75,NULL,'IR','NGC 0172',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4060,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4060,33.42,0.37,48.4,1465,NULL,NULL,'Malmquist cor.','NGC 0172',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4061,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4061,33.47,0.36,49.5,1465,NULL,NULL,NULL,'NGC 0172',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4062,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4062,38.17,0.27,430,1466,70,NULL,NULL,'2MASX J00371494-0927129',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000077,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,9.3122083,-9.45372,0.111,NULL,34577456930,540272764,8441761,18.3),(4063,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4063,35.22,0.09,111,1467,NULL,NULL,NULL,'2MASX J00371583-5636583',NULL,'2009ApJS..182..474S',2009,1,0.63,NULL,'G',0.000027,NULL,'16.37',0.25,'Sb',NULL,NULL,NULL,NULL,1,9.316,-56.61625,0,NULL,36216493481,565882710,8841917,16.37),(4064,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 16788','RN',4064,40.48,0.31,997,1468,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16788',0.24986,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4065,'IRAS','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4065,34.22,0.8,70,1469,75,NULL,'W91PP, r','UGC 00371',NULL,'1997ApJS..109..333W',1997,1,2.24,NULL,'G',0.000009,NULL,'15.07',0.17,'Scd',NULL,NULL,NULL,NULL,1,9.338375,29.14933,0.137,NULL,67321096272,1051892129,16435814,15.07),(4066,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4066,33.8,0.49,57.6,1469,75,NULL,'IR','UGC 00371',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4067,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4067,34.19,NULL,68.9,1469,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00371',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4068,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4068,34.2,NULL,69,1469,NULL,NULL,'Dipole','UGC 00371',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4069,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4069,34.2,NULL,69.3,1469,NULL,NULL,'Dipole + Quadrupole','UGC 00371',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4070,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4070,34.26,NULL,71.3,1469,NULL,NULL,NULL,'UGC 00371',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4071,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4071,34.34,0.38,73.7,1469,75,NULL,'W91PP, r, raw','UGC 00371',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4072,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4072,34.35,0.2,74.1,1469,74.4,NULL,NULL,'UGC 00371',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4073,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4073,34.42,0.38,76.5,1469,75,NULL,'W91PP, r, inv','UGC 00371',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4074,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4074,34.46,0.38,78,1469,75,NULL,'W91PP, r, cor','UGC 00371',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4075,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4075,36.39,0.46,190,1470,70,NULL,NULL,'2MASX J00372126+1500472',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000081,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,9.33866666667,15.01322,0.165,NULL,67475716014,1054308062,16473563,17.2),(4076,'Ring Diameter','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4076,32.8,0.84,37,1471,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 0171',NULL,'1981ApJS...45..541P',1981,1,2.1,NULL,'G',0.000022,NULL,'12.90',1.9,'SB(r)ab        HII?','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,9.33970833333,-19.93425,0.103,NULL,35363350897,552552357,8633630,12.9),(4077,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4077,33.8,0.51,57.6,1471,70,NULL,NULL,'NGC 0171',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4078,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 01386','RN',4078,40.6,0.18,1050,1472,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01386',0.251728,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4079,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 02871','RN',4079,40.95,0.29,1200,1473,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02871',0.292252,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4080,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 02871','RN',4080,41.15,0.25,1310,1473,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 02871',0.292252,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4081,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 02871','N',4081,40.76,0.19,1420,1473,70,NULL,'SALT 2','SDSS-II SN 02871',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4082,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 02871','N',4082,40.79,0.19,1440,1473,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 02871',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4083,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 01166',NULL,4083,40.55,0.2,932,1474,74.2,NULL,'SALT 2','SDSS J003725.26+005826.2',0.3824,'2010ApJ...716..712A',2010,1,0.06,NULL,'G',0.0005,NULL,'22.1g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,9.3552917,0.97394,0.009,NULL,66592953784,1040514902,16258045,22.1),(4084,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 01166',NULL,4084,40.31,0.22,1150,1474,70,NULL,'Hubble residual -0.33 for z0.38240','SDSS J003725.26+005826.2',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4085,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 01166',NULL,4085,40.4,0.31,1200,1474,70,NULL,NULL,'SDSS J003725.26+005826.2',NULL,'2013MNRAS.434.1443X',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4086,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 01166',NULL,4086,41.22,0.23,1270,1474,70,NULL,'SALT 2','SDSS J003725.26+005826.2',0.3824,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4087,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 01166','R',4087,41.23,0.24,1280,1474,70,NULL,'SDSS CAND. SNIa; MLCS2K2','SDSS J003725.26+005826.2',0.3824,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4088,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 01166',NULL,4088,41.24,0.25,1280,1474,65,NULL,'SALT2','SDSS J003725.26+005826.2',0.3824,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4089,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 01166','R',4089,41.39,0.31,1370,1474,70,NULL,'SDSS CAND. SNIa; SALT 2','SDSS J003725.26+005826.2',0.3824,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4090,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 01166',NULL,4090,41.5,0.18,1440,1474,65,NULL,'MLCS2k2','SDSS J003725.26+005826.2',0.3824,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4091,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 01166',NULL,4091,41.29,0.2,1810,1474,70,NULL,'SALT 2','SDSS J003725.26+005826.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4092,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 01166',NULL,4092,41.35,0.2,1860,1474,70,NULL,'SALT 2, Malmquist cor.','SDSS J003725.26+005826.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4093,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4093,36.79,0.57,228,1475,70,NULL,NULL,'MCG +00-02-093',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16',0.4,NULL,NULL,NULL,NULL,NULL,1,9.355417,-1.68661,0.043,NULL,34395908986,537436077,8397438,16),(4094,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4094,38.17,0.27,430,1476,70,NULL,NULL,'2MASXi J0037262-092721',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000084,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,9.359125,-9.45625,0.111,NULL,34577462247,540272847,8441763,18.2),(4095,'Horizontal Branch','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4095,24.59,0.12,0.757,1477,NULL,NULL,NULL,'Andromeda XXVII',NULL,'2011ApJ...732...76R',2011,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,9.3625,45.38694,0.345,0,67701394915,1057834295,16528660,NULL),(4096,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4096,25.49,1.03,1.26,1477,NULL,NULL,NULL,'Andromeda XXVII',NULL,'2012ApJ...758...11C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4097,'Magnitude','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4097,36.51,0.13,200,1478,100,NULL,NULL,'2MASX J00372753-3907467',NULL,'1998A&A...337...31R',1998,1,0.63,NULL,'G',0.000087,NULL,'16.06',0.47,'E',NULL,NULL,NULL,NULL,1,9.36475,-39.12958,NULL,NULL,34653831873,541466123,8460408,16.06),(4098,'Magnitude','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4098,36.51,0.13,200,1479,100,NULL,NULL,'ABELL 2799',NULL,'1998A&A...337...31R',1998,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I-II   [BM];RI [A]',NULL,NULL,NULL,NULL,1,9.3672917,-39.14972,NULL,NULL,34653833488,541466148,8460408,NULL),(4099,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4099,37.11,0.33,264,1480,70,NULL,NULL,'2MASX J00372825+1537342',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000096,NULL,'15.9g',0.48,'BrClG',NULL,NULL,NULL,NULL,1,9.3677917,15.62628,0.157,NULL,67477467680,1054335432,16473991,15.9),(4100,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 15366','RN',4100,40.9,0.25,1170,1481,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 15366',0.297058,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4101,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 15366','RN',4101,41.21,0.22,1350,1481,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 15366',0.297058,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4102,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4102,35.75,0.49,141,1482,75,NULL,'IR','UGC 00373',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000147,NULL,'16.0',0.5,'S?',NULL,NULL,NULL,NULL,1,9.392083,9.55683,0.193,NULL,66789403273,1043584426,16306006,16),(4103,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4103,33.75,0.4,56.1,1483,NULL,NULL,'mean','NGC 0177',NULL,'2007A&A...465...71T',2007,1,2.2,NULL,'G',0.000013,NULL,'14.10',0.5,'SAB(r)b        LLAGN','in a triple',NULL,NULL,NULL,1,9.393083,-22.54925,0.085,NULL,35325975753,551968371,8624505,14.1),(4104,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4104,33.93,0.47,61.2,1483,NULL,NULL,'H','NGC 0177',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4105,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4105,33.94,0.46,61.4,1483,NULL,NULL,'J','NGC 0177',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4106,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4106,34.01,0.49,63.4,1483,75,NULL,'IR','NGC 0177',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4107,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4107,34.02,0.45,63.8,1483,NULL,NULL,'K','NGC 0177',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4108,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4108,37.11,0.33,264,1484,70,NULL,NULL,'2MASX J00373808+1539392',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000096,NULL,'16.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,9.4087083,15.66089,0.157,NULL,67477459751,1054335308,16473989,16.6),(4109,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 19517','RN',4109,40.33,0.32,991,1485,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19517',0.173583,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4110,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 19517','RN',4110,40.33,0.26,993,1485,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19517',0.173583,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4111,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4111,36.18,0.51,173,1486,70,NULL,NULL,'MCG -02-02-071',NULL,'2014MNRAS.445.2677S',2014,1,0.7,'MCG RA is -0.5 minutes in error.','G',0.00015,NULL,'15',0.2,NULL,NULL,NULL,NULL,NULL,1,9.4264583,-14.17958,0.062,NULL,35334099493,552095304,8626489,15),(4112,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 13172','RN',4112,42.28,0.28,2350,1487,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13172',0.214541,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4113,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 13172','RN',4113,42.3,0.37,2370,1487,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13172',0.214541,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4114,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4114,38.17,0.27,430,1488,70,NULL,NULL,'2MASX J00374443-0925362',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000076,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,9.435125,-9.42678,0.111,NULL,34577458791,540272793,8441762,18),(4115,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4115,37.43,0.46,306,1489,70,NULL,NULL,'2MASX J00374586+1422507',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000084,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,9.441,14.38064,0.161,NULL,67474923015,1054295672,16473369,17.9),(4116,'D-Sigma','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4116,34.54,0.4,80.9,1490,75,NULL,'Edat, raw','NGC 0179',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.00003,NULL,'14.30',0.8,'SAB0-',NULL,NULL,NULL,NULL,1,9.442833,-17.84947,0.08,NULL,35350760781,552355637,8630556,14.3),(4117,'D-Sigma','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4117,34.88,0.4,94.4,1490,75,NULL,'Edat, cor','NGC 0179',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4118,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4118,34.87,0.46,94,1490,70,NULL,NULL,'NGC 0179',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4119,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4119,37.7,0.46,346,1491,70,NULL,NULL,'SDSS J003747.69+002416.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000065,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,9.44875,0.40458,0.038,NULL,66592327991,1040505124,16257892,18.3),(4120,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4120,37.85,0.46,371,1492,70,NULL,NULL,'SDSS J003752.17+150057.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00007,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,9.467375,15.01594,0.185,NULL,67475634216,1054306784,16473543,18.6),(4121,'IRAS','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4121,33.94,0.8,61.4,1493,75,NULL,'W91PP, r','UGC 00376',NULL,'1997ApJS..109..333W',1997,1,1.57,NULL,'G',0.000033,NULL,'16.0',0.15,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,9.47533333333,32.68919,0.213,NULL,67363449960,1052553905,16446154,16),(4122,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4122,33.74,NULL,56,1493,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00376',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4123,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4123,33.75,NULL,56.4,1493,NULL,NULL,'Dipole','UGC 00376',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4124,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4124,33.76,NULL,56.5,1493,NULL,NULL,'Dipole + Quadrupole','UGC 00376',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4125,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4125,33.96,0.49,62,1493,75,NULL,'IR','UGC 00376',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4126,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4126,34.02,NULL,63.6,1493,NULL,NULL,NULL,'UGC 00376',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4127,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4127,34.13,0.38,67.1,1493,75,NULL,'W91PP, r, inv','UGC 00376',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4128,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4128,34.2,0.38,69.3,1493,75,NULL,'W91PP, r, raw','UGC 00376',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4129,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4129,34.34,0.38,73.7,1493,75,NULL,'W91PP, r, cor','UGC 00376',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4130,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4130,34.37,0.2,74.8,1493,74.4,NULL,NULL,'UGC 00376',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4131,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4131,34.49,0.39,79,1493,NULL,NULL,NULL,'UGC 00376',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4132,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4132,34.5,0.39,79.6,1493,NULL,NULL,'Malmquist cor.','UGC 00376',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4133,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 20961','R',4133,40.59,0.22,990,1494,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20961',0.323731,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,'PHOT','21.5g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,9.477917,-0.32094,0.023,NULL,34395082411,537423162,8397236,21.5),(4134,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 20961',NULL,4134,40.07,0.25,1030,1494,70,NULL,'SN photometric redshift distance, z photo =0.279 +/- 0.041','SDSS-II SN 20961',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4135,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 20961','R',4135,41.06,0.33,1230,1494,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20961',0.323731,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4136,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4136,35.32,0.49,116,1495,75,NULL,'IR','CGCG 409-049',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000027,NULL,'15.42',0.2,'S?',NULL,NULL,NULL,NULL,1,9.481875,4.91144,0.049,NULL,66812564987,1043946327,16311661,15.42),(4137,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4137,34.43,0.25,76.9,1496,74.4,NULL,NULL,'2MASX J00375699-5603427',NULL,'2013AJ....146...86T',2013,1,0.58,NULL,'G',0.000019,NULL,'16.22',0.53,'S0',NULL,NULL,NULL,NULL,1,9.48741666667,-56.06183,0,NULL,36217744954,565902264,8842222,16.22),(4138,'Magnitude','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4138,36.4,0.13,191,1497,100,NULL,NULL,'2MASX J00375761-2504254',NULL,'1998A&A...337...31R',1998,1,0.5,NULL,'G',0.00018,NULL,'16.06',0.45,'E',NULL,NULL,NULL,NULL,1,9.490125,-25.07375,0.09,NULL,34811775219,543933987,8498968,16.06),(4139,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4139,33.92,0.2,60.8,1498,74.4,NULL,NULL,'NGC 0180',NULL,'2013AJ....146...86T',2013,1,2.4,NULL,'G',0.000003,NULL,'13.70',1.9,'SB(rs)bc',NULL,NULL,NULL,NULL,1,9.490417,8.63519,0.173,NULL,66786311457,1043536116,16305251,13.7),(4140,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4140,34.05,0.47,64.7,1498,NULL,NULL,'H','NGC 0180',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4141,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4141,34.07,0.45,65.3,1498,NULL,NULL,'K','NGC 0180',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4142,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4142,34.12,0.46,66.6,1498,NULL,NULL,'J','NGC 0180',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4143,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4143,34.24,0.4,70.5,1498,NULL,NULL,'mean','NGC 0180',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4144,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4144,33.77,NULL,56.9,1499,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00379',NULL,'2010Ap&SS.325..163P',2010,1,1.34,NULL,'G',0.000007,NULL,'16.0',0.16,'Sc',NULL,NULL,NULL,NULL,1,9.491,5.14786,0.053,NULL,66813125055,1043955078,16311798,16),(4145,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4145,33.79,NULL,57.3,1499,NULL,NULL,'Dipole + Quadrupole','UGC 00379',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4146,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4146,33.8,NULL,57.4,1499,NULL,NULL,'Dipole','UGC 00379',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4147,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4147,33.82,NULL,58.2,1499,NULL,NULL,NULL,'UGC 00379',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4148,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4148,33.92,0.2,60.8,1499,74.4,NULL,NULL,'UGC 00379',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4149,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4149,34.05,0.4,64.7,1499,NULL,NULL,NULL,'UGC 00379',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4150,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4150,34.29,0.36,72,1499,NULL,NULL,'Malmquist cor.','UGC 00379',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4151,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 04280','RN',4151,43.76,0.27,3780,1500,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04280',0.493663,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4152,'Magnitude','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4152,36.4,0.13,191,1501,100,NULL,NULL,'ABELL 2800',NULL,'1998A&A...337...31R',1998,1,NULL,'Katgert (1996,A&A,310,8) identifies multiple redshift systems in this cluster.','GClstr',NULL,NULL,NULL,NULL,'III    [BM];I  [A]',NULL,NULL,NULL,NULL,1,9.49470833333,-25.09178,0.09,NULL,34811918556,543936227,8499003,NULL),(4153,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4153,36.72,0.61,220,1502,70,NULL,NULL,'2MASX J00375872-3403455',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.000103,NULL,'16.93',0.28,NULL,NULL,NULL,NULL,NULL,1,9.4947917,-34.06269,NULL,NULL,34875432736,544928636,8514509,16.93),(4154,'IRAS','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4154,33.18,0.8,43.3,1503,75,NULL,'MAT, I','ESO 242- G 020',NULL,'1997ApJS..109..333W',1997,1,1.6,'Confused HIPASS source','G',0.000019,NULL,'14.16',1.1,'SB(s)d','in a pair',NULL,NULL,NULL,1,9.510083,-46.51758,NULL,NULL,38180175917,596565248,9321332,14.16),(4155,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4155,32.53,0.32,32,1503,85,NULL,'I, raw','ESO 242- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4156,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4156,32.53,0.32,32,1503,85,NULL,'I, inv','ESO 242- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4157,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4157,32.92,0.43,38.3,1503,75,NULL,'MAT, I, raw','ESO 242- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4158,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4158,32.97,0.43,39.2,1503,75,NULL,'MAT, I, inv','ESO 242- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4159,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4159,33.24,0.43,44.4,1503,75,NULL,'MAT, I, cor','ESO 242- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4160,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4160,35.04,0.49,102,1504,75,NULL,'IR','ESO 150- G 016',NULL,'2011yCatp016004901K',2011,1,1.05,NULL,'G',0.000033,NULL,'15.0',0.22,'S...',NULL,NULL,NULL,NULL,1,9.51079166667,-53.62983,NULL,NULL,36021517000,562836203,8794315,15),(4161,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4161,35.43,0.39,122,1504,NULL,NULL,'Malmquist cor.','ESO 150- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4162,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4162,35.55,0.36,129,1504,NULL,NULL,NULL,'ESO 150- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4163,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4163,35.59,0.2,131,1504,74.4,NULL,NULL,'ESO 150- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4164,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4164,36.21,0.46,175,1505,70,NULL,NULL,'2MASX J00380259-0911246',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000086,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,9.51091666667,-9.19011,0.159,NULL,34574318021,540223719,8440995,17),(4165,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4165,36.36,0.55,187,1506,70,NULL,NULL,'2MASX J00380337-1442168',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00015,NULL,'16.41',0.46,NULL,NULL,NULL,NULL,NULL,1,9.51408333333,-14.70461,0.035,NULL,35348370399,552318287,8629973,16.41),(4166,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4166,35.51,NULL,126,1507,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0068',NULL,'2010Ap&SS.325..163P',2010,1,1.09,NULL,'G',0.000014,NULL,'16.6',0.11,'Scd',NULL,NULL,NULL,NULL,1,9.540833,11.25044,0.209,NULL,66775278054,1043363719,16302558,16.6),(4167,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4167,35.51,NULL,127,1507,NULL,NULL,'Dipole + Quadrupole','FGC 0068',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4168,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4168,35.51,NULL,127,1507,NULL,NULL,'Dipole','FGC 0068',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4169,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4169,35.62,NULL,133,1507,NULL,NULL,NULL,'FGC 0068',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4170,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4170,37.94,0.46,387,1508,70,NULL,NULL,'2MASX J00381102+1528577',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000083,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,9.545833,15.48267,0.165,NULL,67477546993,1054336671,16474010,18.2),(4171,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4171,34.31,0.4,72.8,1509,NULL,NULL,'mean','NGC 0182',NULL,'2007A&A...465...71T',2007,1,2,NULL,'G',0.00002,NULL,'13.27',1.7,'(R\')SAB(rs)a pec:','in a radial-velocity based grouping',NULL,NULL,NULL,1,9.55158333333,2.72856,0.021,NULL,66809731470,1043902054,16310969,13.27),(4172,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4172,34.81,0.47,91.5,1509,NULL,NULL,'H','NGC 0182',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4173,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4173,34.84,0.45,93.1,1509,NULL,NULL,'K','NGC 0182',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4174,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4174,34.87,0.46,94.2,1509,NULL,NULL,'J','NGC 0182',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4175,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 19449',NULL,4175,38.42,0.72,483,1510,70,NULL,'SN photometric redshift distance, z photo =0.120 +/- 0.052','SDSS-II SN 19449',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.9g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,9.55275,0.59164,0.019,NULL,66592391090,1040506110,16257907,21.9),(4176,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 19449','R',4176,41.48,0.21,1490,1510,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19449',0.330917,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4177,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 19449','R',4177,41.65,0.33,1610,1510,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19449',0.330917,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4178,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 19449',NULL,4178,41.31,0.16,1830,1510,70,NULL,'SALT 2','SDSS-II SN 19449',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4179,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 19449',NULL,4179,41.35,0.16,1860,1510,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19449',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4180,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4180,37.9,0.46,380,1511,70,NULL,NULL,'2MASX J00381305+1551197',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000084,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,9.5542917,15.85556,0.165,NULL,67477599629,1054337494,16474023,17.4),(4181,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4181,36.02,0.46,160,1512,70,NULL,NULL,'2MASX J00381462+0012379',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000061,NULL,'16.4g',0.29,'NLAGN',NULL,NULL,NULL,NULL,1,9.5610417,0.21042,0.038,NULL,66591159056,1040486860,16257607,16.4),(4182,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 02793','RN',4182,38.35,0.07,448,1513,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 02793',0.044411,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4183,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 02793','RN',4183,39.19,0.23,659,1513,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 02793',0.044411,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4184,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4184,36.96,0.46,247,1514,70,NULL,NULL,'2MASX J00381550-0943486',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000092,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,9.56466666667,-9.73011,0.116,NULL,34577688966,540276390,8441818,17.3),(4185,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4185,36.83,0.53,232,1515,70,NULL,NULL,'2MASX J00381620-1703182',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.52',0.28,NULL,NULL,NULL,NULL,NULL,1,9.5675417,-17.05514,0.054,NULL,35343335529,552239617,8628744,16.52),(4186,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 12820','R',4186,38.55,0.2,491,1516,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2006fg','SN 2006fg',0.044643,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'II',NULL,NULL,NULL,NULL,1,9.5835,-0.29497,0.023,NULL,34396981862,537452841,8397700,NULL),(4187,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4187,34.43,0.4,76.9,1517,NULL,NULL,'mean','NGC 0181',NULL,'2007A&A...465...71T',2007,1,0.5,NULL,'G',0.000033,NULL,'15.4',0.2,'S?','Group member',NULL,NULL,NULL,1,9.59670833333,29.47258,0.157,NULL,67366643234,1052603800,16446934,15.4),(4188,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4188,35,0.47,100,1517,NULL,NULL,'H','NGC 0181',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4189,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4189,35.01,0.49,101,1517,75,NULL,'IR','NGC 0181',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4190,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4190,32.94,0.2,38.7,1518,74.4,NULL,NULL,'UGC 00386',NULL,'2013AJ....146...86T',2013,1,1.11,NULL,'G',0.000079,NULL,'14.7g',0.62,'S0',NULL,NULL,NULL,NULL,1,9.59883333333,15.03956,0.193,NULL,67475664023,1054307250,16473550,14.7),(4191,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4191,33.56,0.69,51.4,1518,100,NULL,'mid-IR','UGC 00386',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4192,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4192,34.29,0.2,72.1,1519,74.4,NULL,NULL,'CGCG 500-058',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000067,NULL,'15.19',0.3,'S?','Group member',NULL,NULL,NULL,1,9.617625,29.62514,0.157,NULL,67366716292,1052604942,16446952,15.19),(4193,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4193,34.43,0.38,76.9,1519,NULL,NULL,NULL,'CGCG 500-058',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4194,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4194,34.49,0.37,79,1519,NULL,NULL,'Malmquist cor.','CGCG 500-058',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4195,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 21420','R',4195,41.31,0.25,1330,1520,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 21420',0.378479,'2014arXiv1401.3317S',2014,1,0.09,NULL,'G',NULL,'PHOT','20.6g',0.08,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,9.62808333333,1.05292,0,NULL,66592614092,1040509595,16257962,20.6),(4196,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 21420','R',4196,41.65,0.32,1550,1520,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21420',0.378479,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4197,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 21420',NULL,4197,41.39,0.2,1900,1520,70,NULL,'SN photometric redshift distance, z photo =0.609 +/- 0.091','SDSS-II SN 21420',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4198,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 21420',NULL,4198,41.61,0.21,2100,1520,70,NULL,'SALT 2','SDSS-II SN 21420',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4199,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 21420',NULL,4199,41.67,0.21,2160,1520,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 21420',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4200,'IRAS','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4200,34.29,0.8,72.2,1521,75,NULL,'W91PP, r','UGC 00388',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'16.0',0.6,'Scd:',NULL,NULL,NULL,NULL,1,9.63241666667,30.28992,0.193,NULL,67373712722,1052714261,16448660,16),(4201,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4201,34.57,0.2,82,1521,74.4,NULL,NULL,'UGC 00388',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4202,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4202,34.58,0.41,82.3,1521,NULL,NULL,'Malmquist cor.','UGC 00388',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4203,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4203,34.6,0.41,83.1,1521,NULL,NULL,NULL,'UGC 00388',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4204,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4204,34.63,0.38,84.2,1521,75,NULL,'W91PP, r, raw','UGC 00388',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4205,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4205,34.67,0.38,85.8,1521,75,NULL,'W91PP, r, inv','UGC 00388',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4206,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4206,34.75,0.38,89,1521,75,NULL,'W91PP, r, cor','UGC 00388',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4207,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4207,33.8,0.46,57.4,1522,70,NULL,NULL,'VIII Zw 032',NULL,'2015arXiv151105856S',2015,1,0.49,'Coziol, et al. (1994AJ....108..405C) give v=3700 km/sec.','G',0.000067,NULL,'15.1g',0.46,'S0^-',NULL,NULL,NULL,NULL,1,9.642667,-9.11286,0.134,NULL,34577158955,540268108,8441689,15.1),(4208,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4208,35.22,0.08,111,1523,NULL,NULL,NULL,'2MASX J00383446-5528017',NULL,'2009ApJS..182..474S',2009,1,0.82,NULL,'G',0.00004,NULL,'15.45',0.65,'Sc',NULL,NULL,NULL,NULL,1,9.64375,-55.46714,0,NULL,36214414468,565850226,8841409,15.45),(4209,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4209,37.62,0.27,334,1524,70,NULL,NULL,'2MASX J00383455-0000097',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000084,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,9.64408333333,-0.00272,0.023,NULL,34394891137,537420174,8397190,17.4),(4210,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 07404','RN',4210,42.42,0.23,2370,1525,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 07404',0.289015,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4211,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 07404','RN',4211,42.61,0.35,2580,1525,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 07404',0.289015,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4212,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4212,36.62,0.7,210,1526,70,NULL,NULL,'LCRS B003611.7-442101',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.67',0.3,NULL,NULL,NULL,NULL,NULL,1,9.6459583,-44.07597,NULL,NULL,38181601356,596587521,9321680,16.67),(4213,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4213,35.09,0.45,104,1527,NULL,NULL,'Malmquist cor.','UGC 00393',NULL,'2009ApJS..182..474S',2009,1,2.1,NULL,'G',0.000023,NULL,'16.5',0.4,'Sdm:',NULL,NULL,NULL,NULL,1,9.666375,17.40267,0.097,NULL,67466579608,1054165306,16471332,16.5),(4214,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4214,35.4,0.39,120,1527,NULL,NULL,NULL,'UGC 00393',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4215,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4215,35.49,0.2,125,1527,74.4,NULL,NULL,'UGC 00393',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4216,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4216,35.04,0.47,102,1528,NULL,NULL,'Malmquist cor.','2MFGC 00459',NULL,'2009ApJS..182..474S',2009,1,0.67,NULL,'G',NULL,NULL,'15.96',0.18,NULL,NULL,NULL,NULL,NULL,1,9.6690417,29.58653,0.157,NULL,67365962420,1052593162,16446768,15.96),(4217,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4217,35.27,0.42,113,1528,NULL,NULL,NULL,'2MFGC 00459',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4218,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4218,35.39,0.2,120,1528,74.4,NULL,NULL,'2MFGC 00459',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4219,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4219,35.71,0.57,139,1529,70,NULL,NULL,'2MASX J00384117-7718167',NULL,'2014MNRAS.445.2677S',2014,1,0.27,NULL,'G',0.00015,NULL,'15.3R',0.16,NULL,NULL,NULL,NULL,NULL,1,9.672083,-77.30464,0.261,NULL,35599850512,556247664,8691369,15.3),(4220,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4220,34.09,0.4,65.8,1530,NULL,NULL,'mean','KHG 1-01',NULL,'2007A&A...465...71T',2007,1,0.65,NULL,'G',NULL,NULL,NULL,0.55,'S',NULL,NULL,NULL,NULL,1,9.6760417,60.28697,NULL,NULL,65922236144,1030034939,16094295,NULL),(4221,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4221,34.22,0.47,69.7,1530,NULL,NULL,'H','KHG 1-01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4222,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4222,34.35,0.45,74.1,1530,NULL,NULL,'K','KHG 1-01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4223,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4223,37.77,0.46,359,1531,70,NULL,NULL,'2MASX J00384336+0033272',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000089,NULL,'17.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,9.68054166667,0.55744,0.011,NULL,66592293460,1040504585,16257884,17.6),(4224,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 11962','RN',4224,40.05,0.54,925,1532,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 11962',0.108976,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4225,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4225,37.62,0.27,334,1533,70,NULL,NULL,'2MASX J00384451-0006133',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000075,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,9.685583,-0.10369,0.023,NULL,34394876915,537419951,8397186,18),(4226,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4226,34.7,0.2,87.1,1534,74.4,NULL,NULL,'CGCG 479-050',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000033,NULL,'15.6',0.3,'Sb','Group member',NULL,NULL,NULL,1,9.70008333333,25.71789,0.113,NULL,67208316420,1050129944,16408280,15.6),(4227,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 17220','R',4227,39.39,0.09,642,1535,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ji','SN 2007ji',0.179029,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,9.7015,-0.17931,0,NULL,34397020897,537453451,8397710,NULL),(4228,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 17220','R',4228,39.61,0.19,708,1535,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ji','SN 2007ji',0.179029,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4229,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4229,37.44,0.59,307,1536,70,NULL,NULL,'2MASX J00384984-0302293',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'16.86',0.31,NULL,NULL,NULL,NULL,NULL,1,9.707625,-3.04139,0.21,NULL,34593084202,540516940,8445577,16.86),(4230,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 12259','RN',4230,40.71,0.28,1160,1537,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 12259',0.200675,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4231,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 11965','RN',4231,41.59,0.32,1650,1538,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 11965',0.265313,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4232,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 11965','RN',4232,41.77,0.55,1780,1538,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 11965',0.265313,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4233,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4233,37.09,0.46,262,1539,70,NULL,NULL,'2MASX J00385151+1604506',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000105,NULL,'16.3g',0.32,'E0',NULL,NULL,NULL,NULL,1,9.714625,16.08072,0.081,NULL,67474563783,1054290059,16473282,16.3),(4234,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4234,35.12,0.07,106,1540,NULL,NULL,NULL,'AGC 400704',NULL,'2009ApJS..182..474S',2009,1,0.77,NULL,'G',0.000027,NULL,'16.28',0.3,'Sc',NULL,NULL,NULL,NULL,1,9.71954166667,-55.48883,0,NULL,36214411970,565850187,8841409,16.28),(4235,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4235,34.82,0.74,92.1,1541,NULL,NULL,'Malmquist cor.','AGC 101112',NULL,'2009ApJS..182..474S',2009,1,0.42,NULL,'G',NULL,NULL,'16.0',0.11,NULL,'Group member',NULL,NULL,NULL,1,9.727083,7.45778,0.137,NULL,66829650325,1044213286,16315832,16),(4236,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4236,34.96,0.2,98.2,1541,74.4,NULL,NULL,'AGC 101112',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4237,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4237,35.1,0.65,105,1541,NULL,NULL,NULL,'AGC 101112',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4238,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4238,35.63,0.25,134,1542,74.4,NULL,NULL,'NGC 0190 NED01',NULL,'2013AJ....146...86T',2013,1,0.81,NULL,'G',0.000047,NULL,'15.08',0.81,'Sab','Group member',NULL,NULL,NULL,1,9.727833,7.06269,0.089,NULL,66831759583,1044246243,16316347,15.08),(4239,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4239,35.81,0.33,145,1542,70,NULL,NULL,'NGC 0190 NED01',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4240,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4240,34.03,0.2,64,1543,74.4,NULL,NULL,'2MFGC 00465',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000005,NULL,'13.0K',0.1,'Sc',NULL,NULL,NULL,NULL,1,9.733917,26.96397,0.177,NULL,67319808124,1051872001,16435500,13),(4241,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4241,34.05,0.35,64.6,1543,NULL,NULL,NULL,'2MFGC 00465',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4242,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4242,34.32,0.31,73.1,1543,NULL,NULL,'Malmquist cor.','2MFGC 00465',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4243,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4243,34.34,0.49,73.9,1543,75,NULL,'IR','2MFGC 00465',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4244,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4244,35.47,0.46,124,1544,70,NULL,NULL,'2MASX J00385656+0017569',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000073,NULL,'16.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,9.7357917,0.29925,0.011,NULL,66592200387,1040503131,16257861,16.2),(4245,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 16546','RN',4245,41.95,0.33,1800,1545,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16546',0.366312,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4246,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4246,34,0.4,63.1,1546,NULL,NULL,'mean','UGC 00398',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000007,NULL,'14.32',1,'SA(r)a','in a radial-velocity based grouping',NULL,NULL,NULL,1,9.73975,25.63861,0.093,NULL,67208037432,1050125584,16408212,14.32),(4247,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4247,34.26,0.47,71.1,1546,NULL,NULL,'H','UGC 00398',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4248,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4248,24.09,NULL,0.658,1547,NULL,NULL,NULL,'NGC 0185',NULL,'2014ApJ...789..147W',2014,1,11.7,NULL,'G',0.00001,NULL,'10.10',10,'dSph/dE3;LINER Sy2','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,9.7415417,48.33739,0.777,0,67700463253,1057819738,16528433,10.1),(4249,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4249,24.09,NULL,0.658,1547,NULL,NULL,NULL,'NGC 0185',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4250,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4250,24.09,NULL,0.658,1547,NULL,NULL,NULL,'NGC 0185',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4251,'Horizontal Branch','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4251,24.09,0.07,0.658,1547,NULL,NULL,NULL,'NGC 0185',NULL,'2005AJ....129.2217B',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4252,'Miras','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4252,23.34,0.22,0.466,1547,NULL,NULL,NULL,'NGC 0185',NULL,'2012dgkg.book..169L',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4253,'Miras','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4253,24.05,NULL,0.646,1547,NULL,NULL,'all','NGC 0185',NULL,'2011A&A...532A..78L',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4254,'Miras','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4254,24.05,NULL,0.646,1547,NULL,NULL,'O-rich','NGC 0185',NULL,'2011A&A...532A..78L',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4255,'Miras','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4255,24.3,NULL,0.724,1547,NULL,18.4,'using Ita et al. 2004 PL relation','NGC 0185',NULL,'2011A&A...532A..78L',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4256,'PNLF','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4256,24.3,0.15,0.724,1547,NULL,NULL,NULL,'NGC 0185',NULL,'1989ApJ...339...53C',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4257,'Red Clump','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4257,24.51,NULL,0.797,1547,NULL,NULL,'V, M RC(V) = +0.73 mag','NGC 0185',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4258,'Red Clump','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4258,24.64,NULL,0.846,1547,NULL,NULL,'I, M RC(I) = -0.50 mag','NGC 0185',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4259,'RR Lyrae','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4259,23.77,NULL,0.568,1547,NULL,NULL,'Saha pvt. comm.','NGC 0185',NULL,'1988ASPC....4...59P',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4260,'RR Lyrae','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4260,23.79,0.25,0.573,1547,NULL,NULL,'151','NGC 0185',NULL,'1990AJ.....99...97S',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4261,'RR Lyrae','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4261,23.85,0.59,0.589,1547,NULL,18.19,NULL,'NGC 0185',NULL,'1992MmSAI..63..409C',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4262,'RR Lyrae','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4262,23.93,NULL,0.611,1547,NULL,NULL,NULL,'NGC 0185',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4263,'RR Lyrae','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4263,24.01,NULL,0.634,1547,NULL,NULL,'Fe/H = -1.5','NGC 0185',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4264,'RR Lyrae','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4264,24.06,NULL,0.649,1547,NULL,NULL,NULL,'NGC 0185',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4265,'RR Lyrae','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4265,24.13,NULL,0.67,1547,NULL,NULL,NULL,'NGC 0185',NULL,'2008ApJ...679...52T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4266,'RR Lyrae','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4266,24.15,NULL,0.676,1547,NULL,NULL,'Fe/H = -1.5','NGC 0185',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4267,'SBF','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4267,24,0.07,0.63,1547,74.4,NULL,NULL,'NGC 0185',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4268,'SBF','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4268,24.02,0.16,0.637,1547,NULL,NULL,'I','NGC 0185',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4269,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4269,23.62,0.12,0.53,1547,NULL,NULL,'JHK','NGC 0185',NULL,'2008JASS...25..245S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4270,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4270,23.9,0.2,0.603,1547,NULL,NULL,'JHK','NGC 0185',NULL,'1992IAUS..149..169F',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4271,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4271,23.94,0.12,0.614,1547,NULL,NULL,NULL,'NGC 0185',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4272,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4272,23.94,0.1,0.614,1547,NULL,NULL,'I','NGC 0185',NULL,'1993ApJ...417..553L',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4273,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4273,23.95,0.09,0.616,1547,NULL,NULL,NULL,'NGC 0185',NULL,'2005MNRAS.356..979M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4274,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4274,23.95,0.1,0.617,1547,NULL,NULL,NULL,'NGC 0185',NULL,'1998AJ....115.1462M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4275,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4275,23.96,0.21,0.62,1547,NULL,NULL,NULL,'NGC 0185',NULL,'1993AJ....106..964L',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4276,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4276,23.96,0.07,0.62,1547,NULL,NULL,NULL,'NGC 0185',NULL,'2012ApJ...758...11C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4277,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4277,24,0.07,0.63,1547,74.4,NULL,NULL,'NGC 0185',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4278,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4278,24.01,0.04,0.634,1547,NULL,NULL,'I','NGC 0185',NULL,'2007ApJ...661..815R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4279,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4279,24.02,0.08,0.636,1547,NULL,NULL,NULL,'NGC 0185',NULL,'2015ApJ...811..114G',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4280,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4280,24.04,NULL,0.643,1547,NULL,NULL,NULL,'NGC 0185',NULL,'2003A&A...403...93N',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4281,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4281,24.04,0.03,0.643,1547,NULL,NULL,'I','NGC 0185',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4282,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4282,24.05,NULL,0.646,1547,NULL,NULL,'theory','NGC 0185',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4283,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4283,24.08,0.02,0.655,1547,NULL,NULL,'I','NGC 0185',NULL,'2005AJ....129.2217B',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4284,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4284,24.11,NULL,0.664,1547,NULL,NULL,NULL,'NGC 0185',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4285,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4285,24.12,NULL,0.667,1547,NULL,NULL,'DA90','NGC 0185',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4286,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4286,24.15,NULL,0.676,1547,NULL,NULL,'K97','NGC 0185',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4287,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4287,24.15,NULL,0.676,1547,NULL,NULL,'Yale','NGC 0185',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4288,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4288,24.45,NULL,0.776,1547,NULL,NULL,'I, M TRGB(I) = -4.05 mag','NGC 0185',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4289,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4289,24.5,0.2,0.794,1547,NULL,NULL,NULL,'NGC 0185',NULL,'1999IAUS..192..231G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4290,'Statistical','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4290,23.96,0.1,0.619,1547,NULL,NULL,NULL,'NGC 0185',NULL,'2000glg..book.....V',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4291,'Faber-Jackson','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4291,23.3,NULL,0.457,1547,NULL,NULL,'LEDA [April 2006]','NGC 0185',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4292,'Faber-Jackson','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4292,26.27,0.65,1.79,1547,95,NULL,'Weighted Mean','NGC 0185',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4293,'Faber-Jackson','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4293,26.38,0.81,1.89,1547,55,NULL,'Visvanathan & Sandage 1979','NGC 0185',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4294,'Tully est','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4294,24.23,0.8,0.7,1547,75,NULL,'B','NGC 0185',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4295,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 15952','RN',4295,43.56,0.27,3650,1548,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 15952',0.413469,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4296,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 15952','RN',4296,43.61,0.29,3730,1548,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 15952',0.413469,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4297,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4297,37.62,0.27,334,1549,70,NULL,NULL,'2MASX J00385949+0006069',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000088,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,9.7477083,0.10189,0.023,NULL,66592187615,1040502931,16257858,17.2),(4298,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SN 2006ej',NULL,4298,34,0.19,61.8,1550,74.2,NULL,'SALT 2','NGC 0191A',0.020452,'2010ApJ...716..712A',2010,1,0.83,'Beers et al (1991AJ....102.1581B) quote V = 13652 +- 141 km/sec from ZCAT.','G',0.000096,NULL,'14.9g',0.43,'S0 pec sp','Pair member (points to parent)',NULL,NULL,NULL,1,9.751,-9.01458,0.134,NULL,34577157974,540268093,8441688,14.9),(4299,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SN 2006ej',NULL,4299,34.57,0.04,80.4,1550,72,NULL,'MLCS17','NGC 0191A',0.020452,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4300,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SN 2006ej',NULL,4300,34.59,0.09,82.8,1550,74.4,NULL,NULL,'NGC 0191A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4301,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SN 2006ej',NULL,4301,34.68,0.16,83.1,1550,72,NULL,NULL,'NGC 0191A',0.01935,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4302,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SN 2006ej',NULL,4302,34.68,0.18,84.7,1550,70,NULL,'SALT 2','NGC 0191A',0.020452,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4303,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SN 2006ej',NULL,4303,34.69,0.15,84.9,1550,73.8,NULL,'SALT 2 (SNANA)','NGC 0191A',0.0204,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4304,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SN 2006ej',NULL,4304,34.71,0.07,87.7,1550,72,NULL,'M(H) = -18.317 mag','NGC 0191A',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4305,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SN 2006ej',NULL,4305,34.86,0.2,91.8,1550,65,NULL,'MLCS17','NGC 0191A',0.020452,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4306,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SN 2006ej',NULL,4306,34.86,0.11,91.9,1550,72,NULL,'MLCS2k2, R(V) = 1.7','NGC 0191A',0.020452,'2010ApJ...721.1608B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4307,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SN 2006ej',NULL,4307,34.91,0.23,94,1550,65,NULL,'SALT2','NGC 0191A',0.020452,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4308,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SN 2006ej',NULL,4308,34.96,0.2,96.3,1550,65,NULL,'SALT','NGC 0191A',0.020452,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4309,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SN 2006ej',NULL,4309,34.97,0.1,96.7,1550,72,NULL,'MLCS2k2, R(V) = 3.1','NGC 0191A',0.020452,'2010ApJ...721.1608B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4310,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SN 2006ej',NULL,4310,34.97,0.2,96.8,1550,65,NULL,'MLCS31','NGC 0191A',0.020452,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4311,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SN 2006ej',NULL,4311,35.28,0.03,111,1550,70,NULL,'SALT 2','NGC 0191A',0.020452,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4312,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4312,35.55,0.53,129,1551,70,NULL,NULL,'2MASX J00390161-1606152',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.38',0.31,NULL,NULL,NULL,NULL,NULL,1,9.75670833333,-16.10428,0.042,NULL,35346245884,552285091,8629454,16.38),(4313,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4313,36.45,0.46,195,1552,70,NULL,NULL,'2MASX J00390266+1405205',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000097,NULL,'16.1g',0.35,'S0',NULL,NULL,NULL,NULL,1,9.7612083,14.08886,0.169,NULL,67464197296,1054128082,16470751,16.1),(4314,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4314,35.63,0.25,134,1553,74.4,NULL,NULL,'CGCG 409-054',NULL,'2013AJ....146...86T',2013,1,1.8,NULL,'G',0.0001,NULL,'13.97',0.6,'E/S0','Group member',NULL,NULL,NULL,1,9.769083,7.49267,0.137,NULL,66784100703,1043501573,16304712,13.97),(4315,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4315,35.81,0.33,145,1553,70,NULL,NULL,'CGCG 409-054',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4316,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4316,33.12,0.2,42.1,1554,74.4,NULL,NULL,'IC 1564',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.00001,NULL,'14.68',0.5,'SABbc:','Group member',NULL,NULL,NULL,1,9.771375,6.02106,0.077,NULL,66831301164,1044239080,16316235,14.68),(4317,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4317,33.43,0.64,48.5,1554,NULL,NULL,NULL,'IC 1564',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4318,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4318,33.73,0.56,55.6,1554,NULL,NULL,'Malmquist cor.','IC 1564',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4319,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4319,36.1,0.33,166,1555,70,NULL,NULL,'2MASX J00390680-0847589',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000059,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,9.7782083,-8.79956,0.109,NULL,34574213528,540222086,8440970,16.4),(4320,'Tully est','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4320,31.33,0.8,18.4,1556,75,NULL,'B','NGC 0178',NULL,'1988NBGC.C....0000T',1988,1,2,NULL,'G',0.00001,NULL,'13.1',1,'SB(s)m','Group member',NULL,NULL,NULL,1,9.785,-14.17283,0.073,NULL,35334842443,552106913,8626670,13.1),(4321,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 20877',NULL,4321,40.13,0.24,1060,1557,70,NULL,'SN photometric redshift distance, z photo =0.288 +/- 0.040','SDSS-II SN 20877',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,9.78675,0.51417,0.011,NULL,66592282533,1040504414,16257881,NULL),(4322,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4322,36.15,0.46,170,1558,70,NULL,NULL,'2MASX J00391247-0045096',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000099,NULL,'16.0g',0.36,'E0',NULL,NULL,NULL,NULL,1,9.8020417,-0.75267,0.03,NULL,34397227291,537456676,8397760,16),(4323,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4323,36.43,0.53,193,1558,70,NULL,NULL,'2MASX J00391247-0045096',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4324,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 17748','R',4324,40.05,0.22,869,1559,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17748',0.179573,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,9.807083,-0.27714,0,NULL,34397010283,537453285,8397707,NULL),(4325,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 17748','R',4325,40.13,0.17,901,1559,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17748',0.179573,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4326,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4326,35.4,0.62,120,1560,70,NULL,NULL,'2MASX J00391411-5307103',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'15.99',0.4,'S0',NULL,NULL,NULL,NULL,1,9.808875,-53.11961,NULL,NULL,36024411452,562881428,8795022,15.99),(4327,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4327,35.47,0.25,124,1561,74.4,NULL,NULL,'2MASX J00391571+0641188',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000039,NULL,'16.4',0.5,'E','Group member',NULL,NULL,NULL,1,9.8154583,6.6885,0.057,NULL,66831686583,1044245102,16316329,16.4),(4328,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 16192','R',4328,38.78,0.21,528,1562,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2006ny','SN 2006ny',0.07852,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'IIp',NULL,NULL,NULL,NULL,1,9.822125,0.08392,0.023,NULL,66592179592,1040502806,16257856,NULL),(4329,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 16192','R',4329,38.84,0.1,544,1562,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2006ny','SN 2006ny',0.07852,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4330,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4330,33.83,0.4,58.3,1563,NULL,NULL,'mean','NGC 0196',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.00008,NULL,'13.80',0.8,'SB0 pec:','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,9.824333,0.91275,0,NULL,66592629141,1040509830,16257966,13.8),(4331,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4331,34.31,0.45,72.9,1563,NULL,NULL,'K','NGC 0196',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4332,'IRAS','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4332,34.73,0.8,88.5,1564,75,NULL,'MAT, I','ESO 411- G 003',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.69',0.5,'SA(rs)b:',NULL,NULL,NULL,NULL,1,9.82608333333,-27.34925,0.045,NULL,34836688474,544323257,8505050,14.69),(4333,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4333,34.45,0.43,77.6,1564,75,NULL,'MAT, I, raw','ESO 411- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4334,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4334,34.47,0.32,78.3,1564,85,NULL,'I, raw','ESO 411- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4335,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4335,34.53,0.32,80.4,1564,85,NULL,'I, inv','ESO 411- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4336,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4336,34.67,0.47,85.8,1564,NULL,NULL,'H','ESO 411- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4337,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4337,34.69,0.45,86.8,1564,NULL,NULL,'K','ESO 411- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4338,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4338,34.7,0.43,87.2,1564,75,NULL,'MAT, I, inv','ESO 411- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4339,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4339,34.7,0.4,87.3,1564,NULL,NULL,'mean','ESO 411- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4340,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4340,34.76,0.43,89.7,1564,75,NULL,'MAT, I, cor','ESO 411- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4341,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4341,34.86,0.46,93.7,1564,NULL,NULL,'J','ESO 411- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4342,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4342,34.89,0.47,95,1564,NULL,NULL,NULL,'ESO 411- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4343,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4343,34.9,0.47,95.3,1564,NULL,NULL,'Malmquist cor.','ESO 411- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4344,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4344,34.93,0.2,96.8,1564,74.4,NULL,NULL,'ESO 411- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4345,'D-Sigma','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4345,33.33,0.4,46.4,1565,75,NULL,'Edat, raw','NGC 0194',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000037,NULL,'13.15',1.4,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,9.82675,3.03744,0.005,NULL,66822664235,1044104128,16314127,13.15),(4346,'D-Sigma','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4346,33.67,0.4,54.2,1565,75,NULL,'Edat, cor','NGC 0194',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4347,'Faber-Jackson','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4347,33.5,0.44,50.1,1565,95,NULL,'Weighted Mean','NGC 0194',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4348,'Faber-Jackson','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4348,33.75,0.46,56.2,1565,95,NULL,'Michard 1979a','NGC 0194',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4349,'Faber-Jackson','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4349,34.39,0.63,75.5,1565,95,NULL,'Michard 1979b, c','NGC 0194',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4350,'Tertiary','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4350,33.3,0.5,45.7,1565,95,NULL,NULL,'NGC 0194',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4351,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4351,34.25,0.45,71,1565,NULL,NULL,'K','NGC 0194',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4352,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4352,34.29,0.4,72.2,1565,NULL,NULL,'mean','NGC 0194',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4353,'Faber-Jackson','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4353,33.08,0.44,41.3,1566,95,NULL,'Weighted Mean','NGC 0193',NULL,'1984ApJS...56...91D',1984,1,1.4,NULL,'G',0.00005,NULL,'13.25',1.2,'SAB(s)0-:','Group member',NULL,NULL,NULL,1,9.8274583,3.33111,0.061,NULL,66822711089,1044104860,16314138,13.25),(4354,'Faber-Jackson','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4354,33.52,0.46,50.6,1566,95,NULL,'Michard 1979a','NGC 0193',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4355,'Faber-Jackson','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4355,33.55,0.63,51.3,1566,95,NULL,'Michard 1979b, c','NGC 0193',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4356,'Tertiary','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4356,33.3,0.5,45.7,1566,95,NULL,NULL,'NGC 0193',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4357,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4357,37.44,0.46,308,1567,70,NULL,NULL,'2MASX J00391900-0045146',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000101,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,9.82920833333,-0.754,0.03,NULL,34396770049,537449532,8397648,17.1),(4358,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 04125','RN',4358,40.69,0.59,1260,1568,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04125',0.090062,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4359,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 13154','RN',4359,43.88,0.55,3530,1569,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13154',0.691462,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4360,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4360,35.97,NULL,156,1570,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0069',NULL,'2010Ap&SS.325..163P',2010,1,0.73,NULL,'G',NULL,NULL,'16.9',0.09,'Scd',NULL,NULL,NULL,NULL,1,9.840125,45.12133,0.381,NULL,67709239538,1057956867,16530576,16.9),(4361,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4361,35.99,NULL,158,1570,NULL,NULL,'Dipole + Quadrupole','FGC 0069',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4362,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4362,36,NULL,159,1570,NULL,NULL,NULL,'FGC 0069',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4363,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4363,36.01,NULL,159,1570,NULL,NULL,'Dipole','FGC 0069',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4364,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4364,35.66,0.46,136,1571,70,NULL,NULL,'2MASX J00392168+1428109',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000071,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,9.8402917,14.46986,0.177,NULL,67475271948,1054301124,16473455,16.8),(4365,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4365,37.26,0.33,284,1572,70,NULL,NULL,'2MASX J00392180+0011005',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00009,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,9.840917,0.18369,0.025,NULL,66592202807,1040503168,16257862,16.3),(4366,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4366,35.17,0.11,108,1573,NULL,NULL,NULL,'2MASX J00392547-5559041',NULL,'2009ApJS..182..474S',2009,1,0.78,NULL,'G',0.000023,NULL,'16.58',0.2,'Sc',NULL,NULL,NULL,NULL,1,9.856333,-55.9845,0,NULL,36217232710,565894261,8842097,16.58),(4367,'BCG','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4367,36.48,0.35,191,1574,60,NULL,'ABELL 0076, BCG','IC 1565',0.0377,'1980ApJ...241..486H',1980,1,1.5,'The identification as IC 1567 is not certain.','G',0.000047,NULL,'14.31',1.5,'cD;E','Group member',NULL,NULL,NULL,1,9.8594583,6.73425,0.057,NULL,66831690309,1044245161,16316330,14.31),(4368,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4368,35.8,0.23,145,1574,74.4,NULL,NULL,'IC 1565',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4369,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4369,35.81,0.33,145,1574,70,NULL,NULL,'IC 1565',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4370,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 13953',NULL,4370,40.42,0.29,1220,1575,70,NULL,'SN photometric redshift distance, z photo =0.339 +/- 0.061','SDSS-II SN 13953',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.4g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,9.861375,0.74594,0.029,NULL,66589101338,1040454708,16257104,21.4),(4371,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 13953','R',4371,41.19,0.22,1370,1575,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13953',0.262438,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4372,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 13953','R',4372,41.51,0.31,1590,1575,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13953',0.262438,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4373,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 13108','R',4373,40.07,0.17,856,1576,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13108',0.205986,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,9.87075,-1.20039,0.047,NULL,34393854635,537403978,8396937,NULL),(4374,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 13108','R',4374,40.18,0.24,901,1576,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13108',0.205986,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4375,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 13108',NULL,4375,39.79,0.29,907,1576,70,NULL,'SN photometric redshift distance, z photo =0.240 +/- 0.040','SDSS-II SN 13108',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4376,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4376,37.26,0.33,284,1577,70,NULL,NULL,'2MASX J00393033+0010115',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,9.8765,0.16992,0.025,NULL,66589348447,1040458569,16257165,16.7),(4377,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 20039','R',4377,40.44,0.22,982,1578,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007qh','SN 2007qh',0.247,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,9.878583,1.02433,0,NULL,66589131545,1040455180,16257112,NULL),(4378,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 20039','R',4378,40.44,0.13,984,1578,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007qh','SN 2007qh',0.247,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4379,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4379,37.1,0.46,263,1579,70,NULL,NULL,'2MASX J00393319+0035505',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000106,NULL,'15.8g',0.4,'E0',NULL,NULL,NULL,NULL,1,9.88841666667,0.59747,0.021,NULL,66589440804,1040460012,16257187,15.8),(4380,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4380,35.75,0.25,141,1580,74.4,NULL,NULL,'IC 1566',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000039,NULL,'15.4',0.5,'E/S0','Group member, 2nd ranked galaxy',NULL,NULL,NULL,1,9.889,6.81514,0.061,NULL,66831736972,1044245890,16316342,15.4),(4381,'IRAS','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4381,34.57,0.8,82,1581,75,NULL,'MAT, I','ESO 351- G 001',NULL,'1997ApJS..109..333W',1997,1,1.37,NULL,'G',0.000033,NULL,'16.18',0.17,'SB(s)c: sp',NULL,NULL,NULL,NULL,1,9.8895,-35.80336,NULL,NULL,34651972088,541437063,8459954,16.18),(4382,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4382,34.11,0.32,66.3,1581,85,NULL,'I, inv','ESO 351- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4383,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4383,34.12,0.32,66.8,1581,85,NULL,'I, raw','ESO 351- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4384,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4384,34.22,NULL,69.9,1581,NULL,NULL,NULL,'ESO 351- G 001',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4385,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4385,34.34,0.43,73.8,1581,75,NULL,'MAT, I, raw','ESO 351- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4386,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4386,34.35,0.43,74.2,1581,75,NULL,'MAT, I, inv','ESO 351- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4387,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4387,34.48,NULL,78.6,1581,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 351- G 001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4388,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4388,34.49,NULL,79.2,1581,NULL,NULL,'Dipole + Quadrupole','ESO 351- G 001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4389,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4389,34.51,NULL,79.6,1581,NULL,NULL,'Dipole','ESO 351- G 001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4390,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4390,34.67,0.43,85.9,1581,75,NULL,'MAT, I, cor','ESO 351- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4391,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4391,34.79,0.2,90.8,1581,74.4,NULL,NULL,'ESO 351- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4392,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4392,34.97,0.41,98.4,1581,NULL,NULL,NULL,'ESO 351- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4393,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4393,35.09,0.39,104,1581,NULL,NULL,'Malmquist cor.','ESO 351- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4394,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4394,36.69,0.57,217,1582,70,NULL,NULL,'2MASX J00393383-0221301',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'17.00',0.3,NULL,NULL,NULL,NULL,NULL,1,9.890917,-2.35844,0.151,NULL,34579258682,540300916,8442201,17),(4395,'IRAS','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4395,33.44,0.8,48.7,1583,75,NULL,'MAT, I','ESO 540- G 010',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'15.54',0.7,'SB(s)cd','Field galaxy',NULL,NULL,NULL,1,9.893125,-20.38353,0.103,NULL,35321332414,551895818,8623372,15.54),(4396,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4396,33.57,0.43,51.9,1583,75,NULL,'MAT, I, inv','ESO 540- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4397,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4397,33.58,0.32,52.1,1583,85,NULL,'I, inv','ESO 540- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4398,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4398,33.6,0.32,52.5,1583,85,NULL,'I, raw','ESO 540- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4399,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4399,33.6,0.43,52.6,1583,75,NULL,'MAT, I, raw','ESO 540- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4400,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4400,34.14,0.43,67.3,1583,75,NULL,'MAT, I, cor','ESO 540- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4401,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4401,33.01,0.69,40.1,1584,100,NULL,'mid-IR','NGC 0201',NULL,'2013ApJ...771...88L',2013,1,1.75,NULL,'G',0.000062,NULL,'13.8g',1.15,'SAB(r)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,9.895083,0.85989,0,NULL,66589151610,1040455493,16257117,13.8),(4402,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4402,33.9,0.47,60.2,1584,NULL,NULL,'H','NGC 0201',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4403,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4403,33.91,0.4,60.6,1584,NULL,NULL,'mean','NGC 0201',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4404,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4404,33.95,0.46,61.6,1584,NULL,NULL,'J','NGC 0201',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4405,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4405,33.96,0.45,61.9,1584,NULL,NULL,'K','NGC 0201',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4406,'IRAS','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4406,34.09,0.8,65.7,1585,75,NULL,'A82, H','NGC 0200',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000027,NULL,'13.48',1,'SB(s)bc','in a radial-velocity based grouping',NULL,NULL,NULL,1,9.895333,2.88744,0.037,NULL,66822603428,1044103178,16314112,13.48),(4407,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4407,33.59,0.33,52.3,1585,91,NULL,'H','NGC 0200',NULL,'1984ApJ...278..475B',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4408,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4408,34.09,0.47,65.7,1585,NULL,NULL,'H','NGC 0200',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4409,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4409,34.12,0.45,66.6,1585,NULL,NULL,'K','NGC 0200',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4410,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4410,34.13,0.47,67,1585,75,NULL,'A82, H, raw','NGC 0200',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4411,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4411,34.13,0.46,67,1585,NULL,NULL,'J','NGC 0200',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4412,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4412,34.2,0.2,69.2,1585,74.4,NULL,NULL,'NGC 0200',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4413,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4413,34.25,0.37,70.8,1585,NULL,NULL,NULL,'NGC 0200',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4414,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4414,34.25,0.36,70.9,1585,NULL,NULL,'Malmquist cor.','NGC 0200',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4415,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4415,34.27,0.4,71.3,1585,NULL,NULL,'mean','NGC 0200',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4416,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4416,34.31,0.47,72.6,1585,75,NULL,'A82, H, cor','NGC 0200',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4417,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4417,34.33,0.47,73.5,1585,75,NULL,'A82, H, inv','NGC 0200',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4418,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4418,36.42,0.46,192,1586,70,NULL,NULL,'2MASX J00393571-0914300',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000069,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,9.898667,-9.24178,0.123,NULL,34577233697,540269276,8441707,16.8),(4419,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4419,33.97,0.47,62.3,1587,NULL,NULL,'H','NGC 0195',NULL,'2007A&A...465...71T',2007,1,1.21,NULL,'G',0.000023,NULL,'14.2g',0.69,'(R)SB(r)a:     HII',NULL,NULL,NULL,NULL,1,9.899125,-9.19453,0.123,NULL,34577259435,540269678,8441713,14.2),(4420,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4420,34.02,0.45,63.7,1587,NULL,NULL,'K','NGC 0195',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4421,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4421,34.11,0.46,66.4,1587,NULL,NULL,'J','NGC 0195',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4422,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4422,34.17,0.4,68.1,1587,NULL,NULL,'mean','NGC 0195',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4423,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4423,35.72,0.25,139,1588,74.4,NULL,NULL,'2MASX J00393603+0639511',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000022,NULL,'15',0.6,'E','Group member',NULL,NULL,NULL,1,9.9002083,6.66419,0.061,NULL,66831702351,1044245349,16316333,15),(4424,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4424,33.95,0.4,61.8,1589,NULL,NULL,'mean','UGC 00418',NULL,'2007A&A...465...71T',2007,1,1.97,NULL,'G',0.000007,NULL,'14.94',0.28,'Sb','Pair member (points to parent)',NULL,NULL,NULL,1,9.90695833333,8.96542,0.177,NULL,66789793181,1043590518,16306101,14.94),(4425,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4425,34.07,0.47,65.3,1589,NULL,NULL,'H','UGC 00418',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4426,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4426,34.09,0.45,65.9,1589,NULL,NULL,'K','UGC 00418',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4427,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4427,34.11,0.49,66.4,1589,75,NULL,'IR','UGC 00418',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4428,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4428,34.21,0.2,69.5,1589,74.4,NULL,NULL,'UGC 00418',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4429,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4429,34.25,NULL,70.9,1589,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00418',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4430,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4430,34.26,NULL,71.1,1589,NULL,NULL,'Dipole + Quadrupole','UGC 00418',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4431,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4431,34.27,NULL,71.3,1589,NULL,NULL,'Dipole','UGC 00418',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4432,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4432,34.27,0.46,71.5,1589,NULL,NULL,'J','UGC 00418',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4433,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4433,34.31,NULL,72.9,1589,NULL,NULL,NULL,'UGC 00418',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4434,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4434,34.32,0.3,73,1589,NULL,NULL,NULL,'UGC 00418',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4435,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4435,34.32,0.3,73.2,1589,NULL,NULL,'Malmquist cor.','UGC 00418',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4436,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 13838','RN',4436,41.32,0.19,1740,1590,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 13838',0.055286,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4437,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 13838','RN',4437,42.25,0.3,2670,1590,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 13838',0.055286,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4438,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 16220',NULL,4438,38.92,1.52,609,1591,70,NULL,'SN photometric redshift distance, z photo =0.154 +/- 0.189','SDSS-II SN 16220',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,9.92570833333,0.68008,0.021,NULL,66589559481,1040461866,16257216,NULL),(4439,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4439,36.74,0.46,223,1592,70,NULL,NULL,'2MASX J00394287-1000500',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000087,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,9.9287917,-10.01392,0.1,NULL,34576832668,540263010,8441609,16.8),(4440,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4440,34.87,1.27,94.4,1593,NULL,NULL,'Malmquist cor.','UGC 00422',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.00003,NULL,'14.60',0.9,'SB?','Pair member (points to parent)',NULL,NULL,NULL,1,9.9297917,9.00525,0.177,NULL,66789821893,1043590967,16306108,14.6),(4441,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4441,35.81,0.82,145,1593,NULL,NULL,NULL,'UGC 00422',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4442,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4442,38.8,0.46,575,1594,70,NULL,NULL,'2MASX J00394334-0055031',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000098,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,9.93045833333,-0.91742,0.03,NULL,34393977826,537405903,8396967,17.3),(4443,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4443,35.45,0.5,123,1595,70,NULL,NULL,'2MASX J00394510-5603559',NULL,'2014MNRAS.445.2677S',2014,1,0.88,NULL,'G',0.00015,NULL,'15.82',0.43,'S',NULL,NULL,NULL,NULL,1,9.938,-56.0655,0,NULL,36217180440,565893444,8842085,15.82),(4444,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4444,37.48,0.46,314,1596,70,NULL,NULL,'2MASX J00394594+1359093',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00008,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,9.94133333333,13.98592,0.157,NULL,67464312850,1054129888,16470779,18.5),(4445,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4445,38.5,0.46,501,1597,70,NULL,NULL,'2MASX J00394625+1521543',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000107,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,9.942625,15.36517,0.173,NULL,67477807747,1054340746,16474074,18),(4446,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4446,35.96,0.5,156,1598,70,NULL,NULL,'2MASX J00394958-1621333',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.36',0.26,NULL,NULL,NULL,NULL,NULL,1,9.9567083,-16.35933,0.036,NULL,35345841192,552278768,8629355,16.36),(4447,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4447,37.55,0.46,324,1599,70,NULL,NULL,'2MASX J00395280+1545513',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000073,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,9.9699583,15.76417,0.141,NULL,67477712879,1054339263,16474050,18.2),(4448,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4448,37.64,0.46,338,1600,70,NULL,NULL,'2MASX J00395353-0849059',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000082,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,9.973,-8.81831,0.12,NULL,34577114771,540267418,8441678,17.7),(4449,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4449,38.07,0.33,411,1601,70,NULL,NULL,'SDSS J003953.63+000454.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,9.9735,0.08189,0.025,NULL,66589354539,1040458664,16257166,18.6),(4450,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4450,35.81,0.33,145,1602,70,NULL,NULL,'IC 1568',NULL,'2001MNRAS.321..277C',2001,1,1.1,NULL,'G',0.000039,NULL,'13.93',0.9,'S0','Group member',NULL,NULL,NULL,1,9.983167,6.84858,0.061,NULL,66831729971,1044245780,16316340,13.93),(4451,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4451,36.14,0.23,169,1602,74.4,NULL,NULL,'IC 1568',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4452,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4452,36.29,0.4,181,1602,NULL,NULL,'mean','IC 1568',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4453,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4453,36.48,0.45,198,1602,NULL,NULL,'K','IC 1568',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4454,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4454,36.1,0.33,166,1603,70,NULL,NULL,'2MASX J00395602-0844039',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000081,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,9.9835,-8.7345,0.097,NULL,34574180694,540221573,8440962,16.7),(4455,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4455,36.61,0.46,210,1604,70,NULL,NULL,'2MASX J00395984+0103545',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000111,NULL,'15.5g',0.45,'E0',NULL,NULL,NULL,NULL,1,9.9994583,1.06522,0.005,NULL,66589053670,1040453963,16257093,15.5),(4456,'BCG','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4456,36.48,0.35,191,1605,60,NULL,NULL,'ABELL 0076',0.0377,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III [BM]',NULL,NULL,NULL,NULL,1,10.002083,6.81806,0.061,NULL,66831731021,1044245797,16316340,NULL),(4457,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4457,36.79,0.46,228,1606,70,NULL,NULL,'2MASX J00400170-0952527',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.0001,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,10.0070416667,-9.88122,0.1,NULL,34576843243,540263175,8441612,16.3),(4458,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4458,37.14,0.46,268,1607,70,NULL,NULL,'2MASX J00400189-0040467',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000108,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,10.007917,-0.67961,0.034,NULL,34394087093,537407610,8396993,16.7),(4459,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4459,38,0.46,399,1608,70,NULL,NULL,'SDSS J004002.70+141344.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000071,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,10.0112917,14.22914,0.177,NULL,67463925397,1054123834,16470684,18.6),(4460,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4460,37.83,0.46,368,1609,70,NULL,NULL,'2MASX J00400422-0034127',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000113,NULL,'18.1g',0.13,'NLAGN',NULL,NULL,NULL,NULL,1,10.0175,-0.57025,0.027,NULL,34394088154,537407627,8396994,18.1),(4461,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4461,35.26,0.25,113,1610,74.4,NULL,NULL,'2MASX J00400423-5610499',NULL,'2013AJ....146...86T',2013,1,0.72,NULL,'G',0.000014,NULL,'15.42',0.57,'E','Group member, 3rd ranked galaxy',NULL,NULL,NULL,1,10.017667,-56.1805,0,NULL,36217184739,565893511,8842086,15.42),(4462,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4462,35.59,0.49,131,1610,70,NULL,NULL,'2MASX J00400423-5610499',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4463,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4463,37.11,0.46,264,1611,70,NULL,NULL,'2MASX J00400482-0911447',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00008,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,10.0200833333,-9.19567,0.123,NULL,34577251405,540269553,8441711,16.6),(4464,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4464,37.1,0.08,263,1612,70,NULL,NULL,'2MASX J00400488-0903027',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000093,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,10.020375,-9.05072,0.12,NULL,34577278454,540269975,8441718,16.5),(4465,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4465,35.39,0.1,120,1613,70,NULL,NULL,'ABELL 2806',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I-II   [BM];RI [A]',NULL,NULL,NULL,NULL,1,10.027083,-56.11667,0,NULL,36217191757,565893621,8842087,NULL),(4466,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 02685','RN',4466,38.39,0.27,442,1614,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02685',0.076196,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4467,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 02685','RN',4467,39.6,0.24,772,1614,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02685',0.076196,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4468,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4468,38.8,0.46,575,1615,70,NULL,NULL,'2MASX J00400902+1406323',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000111,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,10.03775,14.10886,0.177,NULL,67463903467,1054123491,16470679,17.3),(4469,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4469,38.07,0.33,411,1616,70,NULL,NULL,'2MASX J00401322+0006492',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000088,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,10.055167,0.11381,0.028,NULL,66589319083,1040458110,16257157,17.5),(4470,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4470,35.48,0.25,125,1617,74.4,NULL,NULL,'NGC 0212',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000028,NULL,'14.39',1,'SA0-;D','Group member, 2nd ranked galaxy',NULL,NULL,NULL,1,10.0555417,-56.15303,0,NULL,36217185755,565893527,8842086,14.39),(4471,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4471,35.15,0.45,107,1617,NULL,NULL,'K','NGC 0212',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4472,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4472,35.3,0.4,115,1617,NULL,NULL,'mean','NGC 0212',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4473,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4473,35.39,0.1,120,1617,70,NULL,'ABELL 2806, BGC','NGC 0212',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4474,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4474,36.09,0.67,165,1618,70,NULL,NULL,'2MASX J00401476-1528148',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'17.74',0.2,'S0',NULL,NULL,NULL,NULL,1,10.0615416667,-15.47072,0.034,NULL,35349579541,552337180,8630268,17.74),(4475,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 13787','RN',4475,43.14,0.34,2720,1619,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13787',0.564901,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4476,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SN 2007nd',NULL,4476,40.13,0.12,1060,1620,70,NULL,'Hubble residual 0.16 for z0.26330','SDSS J004018.68-010220.8',NULL,'2011ApJ...740...92G',2011,1,0.08,NULL,'G',0.0005,NULL,'21.0g',0.05,NULL,NULL,NULL,NULL,NULL,1,10.077875,-1.03914,0.038,NULL,34394058496,537407164,8396986,21),(4477,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 18945','R',4477,40.85,0.22,1170,1620,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007nd','SDSS J004018.68-010220.8',0.2633,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4478,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 18945','R',4478,40.99,0.15,1250,1620,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007nd','SDSS J004018.68-010220.8',0.2633,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4479,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4479,38.17,0.46,430,1621,70,NULL,NULL,'SDSS J004019.73-000534.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00009,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,10.08225,-0.09278,0.028,NULL,34393597320,537399958,8396874,18.2),(4480,'Carbon Stars','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4480,24.5,0.4,0.794,1622,NULL,NULL,NULL,'MESSIER 110',NULL,'1984ApJ...287..138R',1984,1,21.9,NULL,'G',0.00001,NULL,'8.92',11,'E5 pec','in a triple',NULL,NULL,NULL,1,10.092,41.68531,0.289,0,67708146590,1057939790,16530309,8.92),(4481,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4481,24.38,NULL,0.752,1622,NULL,NULL,NULL,'MESSIER 110',NULL,'2006MNRAS.372.1259S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4482,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4482,24.54,NULL,0.809,1622,NULL,NULL,NULL,'MESSIER 110',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4483,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4483,24.54,NULL,0.809,1622,NULL,NULL,NULL,'MESSIER 110',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4484,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4484,24.54,NULL,0.809,1622,NULL,NULL,NULL,'MESSIER 110',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4485,'PNLF','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4485,24.65,0.21,0.851,1622,NULL,NULL,NULL,'MESSIER 110',NULL,'2005A&A...431..555C',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4486,'PNLF','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4486,24.68,0.51,0.863,1622,NULL,NULL,'HST KP Calibrated','MESSIER 110',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4487,'PNLF','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4487,24.68,0.35,0.863,1622,NULL,NULL,NULL,'MESSIER 110',NULL,'1989ApJ...339...53C',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4488,'PAGB Stars','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4488,24.55,NULL,0.813,1622,NULL,NULL,NULL,'MESSIER 110',NULL,'2001ASSL..265...77B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4489,'RR Lyrae','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4489,24.31,0.73,0.728,1622,NULL,18.19,NULL,'MESSIER 110',NULL,'1992MmSAI..63..409C',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4490,'RR Lyrae','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4490,24.59,NULL,0.828,1622,NULL,NULL,NULL,'MESSIER 110',NULL,'1995ApJ...446...39v',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4491,'RR Lyrae','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4491,24.65,0.25,0.851,1622,NULL,NULL,NULL,'MESSIER 110',NULL,'1992AJ....103...84S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4492,'RR Lyrae','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4492,24.65,NULL,0.851,1622,NULL,NULL,NULL,'MESSIER 110',NULL,'2008ApJ...679...52T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4493,'RR Lyrae','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4493,24.68,NULL,0.863,1622,NULL,NULL,NULL,'MESSIER 110',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4494,'RR Lyrae','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4494,24.82,NULL,0.92,1622,NULL,NULL,'Fe/H = -1.5','MESSIER 110',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4495,'RR Lyrae','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4495,24.9,NULL,0.955,1622,NULL,NULL,NULL,'MESSIER 110',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4496,'RR Lyrae','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4496,25.01,NULL,1,1622,NULL,NULL,'Fe/H = -1.5','MESSIER 110',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4497,'SBF','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4497,24.52,0.12,0.8,1622,NULL,NULL,'I','MESSIER 110',NULL,'1991ApJ...373L...1T',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4498,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4498,24.08,0.12,0.655,1622,NULL,NULL,'H','MESSIER 110',NULL,'2009JASS...26..417J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4499,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4499,24.1,0.08,0.661,1622,NULL,NULL,'J','MESSIER 110',NULL,'2009JASS...26..417J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4500,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4500,24.14,0.14,0.673,1622,NULL,NULL,'Ks','MESSIER 110',NULL,'2009JASS...26..417J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4501,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4501,24.3,0.2,0.724,1622,NULL,NULL,'I','MESSIER 110',NULL,'1984ApJ...278..575M',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4502,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4502,24.3,0.2,0.724,1622,NULL,NULL,'I','MESSIER 110',NULL,'1992IAUS..149..169F',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4503,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4503,24.3,0.21,0.724,1622,NULL,NULL,'HST KP Calibrated','MESSIER 110',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4504,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4504,24.37,NULL,0.75,1622,NULL,NULL,'I','MESSIER 110',NULL,'1992IAUS..149..444L',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4505,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4505,24.42,0.1,0.766,1622,NULL,NULL,'I','MESSIER 110',NULL,'1993ApJ...417..553L',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4506,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4506,24.45,0.14,0.776,1622,NULL,NULL,NULL,'MESSIER 110',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4507,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4507,24.46,NULL,0.78,1622,NULL,NULL,'theory','MESSIER 110',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4508,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4508,24.49,0.02,0.791,1622,NULL,NULL,'I','MESSIER 110',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4509,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4509,24.54,NULL,0.809,1622,NULL,NULL,'DA90','MESSIER 110',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4510,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4510,24.54,0.08,0.81,1622,74.4,NULL,NULL,'MESSIER 110',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4511,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4511,24.56,NULL,0.817,1622,NULL,NULL,NULL,'MESSIER 110',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4512,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4512,24.58,0.07,0.824,1622,NULL,NULL,NULL,'MESSIER 110',NULL,'2005MNRAS.356..979M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4513,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4513,24.6,0.3,0.83,1622,NULL,NULL,NULL,'MESSIER 110',NULL,'1996AJ....112.1438L',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4514,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4514,24.61,NULL,0.836,1622,NULL,NULL,'K97','MESSIER 110',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4515,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4515,24.62,NULL,0.839,1622,NULL,NULL,'Yale','MESSIER 110',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4516,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4516,24.7,0.2,0.871,1622,NULL,NULL,NULL,'MESSIER 110',NULL,'1999IAUS..192..231G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4517,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4517,24.76,0.01,0.895,1622,NULL,NULL,'I','MESSIER 110',NULL,'2005AJ....129.2217B',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4518,'Faber-Jackson','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4518,22.91,NULL,0.382,1622,NULL,NULL,'LEDA [April 2006]','MESSIER 110',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4519,'Orbital Mech.','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4519,24.5,NULL,0.794,1622,NULL,NULL,NULL,'MESSIER 110',NULL,'2008ApJ...683..722H',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4520,'Tully est','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4520,24.23,0.8,0.7,1622,75,NULL,'B','MESSIER 110',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4521,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4521,37.91,0.46,383,1623,70,NULL,NULL,'2MASX J00402217-1040397',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000089,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,10.092333,-10.67769,0.099,NULL,34563872585,540060509,8438445,17.7),(4522,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4522,34.83,0.25,92.5,1624,74.4,NULL,NULL,'2MASX J00402438-5613183',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.000014,NULL,'15.70',0.4,'E',NULL,NULL,NULL,NULL,1,10.1017083,-56.22175,0,NULL,36216085638,565876338,8841817,15.7),(4523,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4523,35.14,0.08,107,1625,NULL,NULL,NULL,'2MASX J00402459-5616503',NULL,'2009ApJS..182..474S',2009,1,0.68,NULL,'G',0.000023,NULL,'16.41',0.28,'Sc',NULL,NULL,NULL,NULL,1,10.102375,-56.28064,0,NULL,36216109398,565876709,8841823,16.41),(4524,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4524,37.1,0.08,263,1626,70,NULL,NULL,'2MASX J00402754-0943125',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000073,NULL,'16.8g',0.33,NULL,NULL,NULL,NULL,NULL,1,10.1147083333,-9.72011,0.116,NULL,34577025509,540266023,8441656,16.8),(4525,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4525,35.81,0.33,145,1627,70,NULL,NULL,'IC 1569',NULL,'2001MNRAS.321..277C',2001,1,0.15,NULL,'G',0.000033,NULL,'14.21',0.15,'S0','Group member',NULL,NULL,NULL,1,10.11675,6.71969,0.069,NULL,66828208891,1044190763,16315480,14.21),(4526,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4526,35.89,0.23,151,1627,74.4,NULL,NULL,'IC 1569',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4527,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4527,35.63,0.25,134,1628,74.4,NULL,NULL,'UGC 00429',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.00011,NULL,'14.92',1,'S0:','Group member',NULL,NULL,NULL,1,10.1274583,6.91747,0.097,NULL,66828134853,1044189607,16315462,14.92),(4528,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4528,35.81,0.33,145,1628,70,NULL,NULL,'UGC 00429',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4529,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4529,36.29,0.4,181,1628,NULL,NULL,'mean','UGC 00429',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4530,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4530,36.98,0.45,249,1628,NULL,NULL,'K','UGC 00429',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4531,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 18362',NULL,4531,39.59,0.38,827,1629,70,NULL,'SN photometric redshift distance, z photo =0.216 +/- 0.048','SDSS-II SN 18362',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,10.1365416667,-0.18208,0.03,NULL,34393810544,537403289,8396926,NULL),(4532,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 18362',NULL,4532,39.7,0.22,871,1629,70,NULL,NULL,'SDSS-II SN 18362',NULL,'2013MNRAS.434.1443X',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4533,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 18362','R',4533,40.29,0.22,925,1629,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18362',0.236261,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4534,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 18362','R',4534,40.39,0.18,968,1629,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18362',0.236261,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4535,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 18362',NULL,4535,40.08,0.13,1040,1629,70,NULL,'SALT 2','SDSS-II SN 18362',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4536,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 18362',NULL,4536,40.1,0.13,1050,1629,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18362',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4537,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4537,37.1,0.08,263,1630,70,NULL,NULL,'2MASX J00403438-0850055',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000094,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,10.143167,-8.83489,0.12,NULL,34576033352,540250521,8441414,17.4),(4538,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4538,37.38,0.64,299,1631,70,NULL,NULL,'2MASX J00403450-0131191',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000103,NULL,'16.81',0.35,NULL,NULL,NULL,NULL,NULL,1,10.14375,-1.52203,0.047,NULL,34581739613,540339681,8442807,16.81),(4539,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4539,32.16,0.4,27,1632,75,NULL,NULL,'UGC 00392',NULL,'2008Ap.....51..336K',2008,1,1.8,NULL,'G',0.000017,NULL,'14.8',0.25,'S',NULL,NULL,NULL,NULL,1,10.145083,83.22225,0.661,NULL,65526651215,1023853925,15997717,14.8),(4540,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4540,32.57,0.49,32.7,1632,75,NULL,'IR','UGC 00392',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4541,'Tully est','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4541,31.54,0.8,20.3,1633,75,NULL,'B','NGC 0210',NULL,'1988NBGC.C....0000T',1988,1,5,NULL,'G',0.00001,NULL,'12.53',3.3,'SAB(s)b','Brightest group member',NULL,NULL,NULL,1,10.1459166667,-13.87281,0.04,NULL,35334691585,552104556,8626633,12.53),(4542,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4542,31.36,0.43,18.7,1633,75,NULL,'3.6 micron, color corrected','NGC 0210',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4543,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4543,31.37,0.43,18.8,1633,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0210',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4544,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4544,31.4,0.4,19.1,1633,NULL,NULL,NULL,'NGC 0210',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4545,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4545,31.41,0.39,19.1,1633,73,NULL,'opt','NGC 0210',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4546,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4546,31.42,0.2,19.2,1633,74.4,NULL,NULL,'NGC 0210',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4547,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4547,31.53,0.4,20.3,1633,NULL,NULL,'mean','NGC 0210',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4548,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4548,31.68,0.47,21.7,1633,NULL,NULL,'H','NGC 0210',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4549,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4549,31.73,0.45,22.2,1633,NULL,NULL,'K','NGC 0210',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4550,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4550,31.75,0.46,22.3,1633,NULL,NULL,'J','NGC 0210',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4551,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4551,35.06,0.46,103,1634,NULL,NULL,NULL,'ESO 474- G 011',NULL,'2009ApJS..182..474S',2009,1,1,'ESO-LV gives V = 1771 +- 39 km/sec.','G',0.000033,NULL,'16.42',0.3,'S...',NULL,NULL,NULL,NULL,1,10.148417,-25.442,0.039,NULL,34798677044,543729328,8495770,16.42),(4552,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4552,35.1,0.2,105,1634,74.4,NULL,NULL,'ESO 474- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4553,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4553,35.26,0.42,113,1634,NULL,NULL,'Malmquist cor.','ESO 474- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4554,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4554,34.72,0.49,87.8,1635,75,NULL,'IR','FGC 0072',NULL,'2011yCatp016004901K',2011,1,0.76,NULL,'G',0.000035,NULL,'17.15',0.08,'Scd',NULL,NULL,NULL,NULL,1,10.156417,5.73064,0.089,NULL,66828377579,1044193399,16315521,17.15),(4555,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4555,35.22,NULL,111,1635,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0072',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4556,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4556,35.24,NULL,112,1635,NULL,NULL,'Dipole + Quadrupole','FGC 0072',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4557,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4557,35.26,NULL,113,1635,NULL,NULL,'Dipole','FGC 0072',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4558,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 12881','R',4558,40.3,0.21,926,1636,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006gu','SDSS J004038.96-000424.9',0.24,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,10.162333,-0.07358,0.028,NULL,34393771239,537402675,8396916,NULL),(4559,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 12881','R',4559,40.37,0.15,956,1636,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006gu','SDSS J004038.96-000424.9',0.24,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4560,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SN 2006gu',NULL,4560,40.24,0.13,1120,1636,70,NULL,'SALT 2','SDSS J004038.96-000424.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4561,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SN 2006gu',NULL,4561,40.26,0.13,1130,1636,70,NULL,'SALT 2, Malmquist cor.','SDSS J004038.96-000424.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4562,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4562,36.78,0.69,227,1637,70,NULL,NULL,'ESO 012- G 022',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.42',0.5,'SAB(rs)c',NULL,NULL,NULL,NULL,1,10.173667,-81.56672,0.337,NULL,35482776391,554418381,8662787,15.42),(4563,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4563,36.16,0.46,170,1638,70,NULL,NULL,'2MASX J00404221-0928405',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000078,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,10.175875,-9.47811,0.116,NULL,34576404719,540256323,8441505,16.9),(4564,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4564,34.87,0.25,94.2,1639,74.4,NULL,NULL,'2MASX J00404323-5555454',NULL,'2013AJ....146...86T',2013,1,0.62,NULL,'G',0.000019,NULL,'16.09',0.57,'S0',NULL,NULL,NULL,NULL,1,10.18025,-55.92928,0,NULL,36217266904,565894795,8842106,16.09),(4565,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4565,37.1,0.08,263,1640,70,NULL,NULL,'2MASX J00404355-0857275',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000087,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,10.181417,-8.95758,0.12,NULL,34576106004,540251656,8441432,17.4),(4566,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4566,38.26,0.7,449,1641,70,NULL,NULL,'2MASX J00404400-8502282',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,10.182917,-85.04119,0.457,NULL,35488409912,554506404,8664162,17),(4567,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4567,37.1,0.08,263,1642,70,NULL,NULL,'2MASX J00404403-0923585',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000087,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,10.1835833333,-9.39969,0.117,NULL,34576414799,540256481,8441507,16.9),(4568,'IRAS','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4568,31.77,0.8,22.5,1643,75,NULL,'MAT, I','ESO 079- G 005',NULL,'1997ApJS..109..333W',1997,1,2.2,'2MASX position is for a superposed star.','G',0.000018,NULL,'13.72',1.1,'(PR?)SB(r)cd:',NULL,NULL,NULL,NULL,1,10.181375,-63.44186,0,NULL,36101955987,564093062,8813954,13.72),(4569,'Tully est','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4569,31.51,0.8,20.1,1643,75,NULL,NULL,'ESO 079- G 005',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4570,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4570,31.26,0.43,17.9,1643,75,NULL,'3.6 micron, color + selection bias corrected','ESO 079- G 005',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4571,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4571,31.32,0.43,18.3,1643,75,NULL,'3.6 micron, color corrected','ESO 079- G 005',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4572,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4572,31.32,0.2,18.4,1643,74.4,NULL,NULL,'ESO 079- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4573,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4573,31.35,0.32,18.6,1643,85,NULL,'I, inv','ESO 079- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4574,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4574,31.38,0.32,18.9,1643,85,NULL,'I, raw','ESO 079- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4575,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4575,31.63,0.4,21.2,1643,NULL,NULL,NULL,'ESO 079- G 005',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4576,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4576,31.63,0.39,21.2,1643,73,NULL,'opt','ESO 079- G 005',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4577,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4577,31.94,0.43,24.4,1643,75,NULL,'MAT, I, inv','ESO 079- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4578,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4578,31.97,0.43,24.7,1643,75,NULL,'MAT, I, raw','ESO 079- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4579,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4579,32.08,0.49,26,1643,75,NULL,'IR','ESO 079- G 005',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4580,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4580,32.23,0.43,28,1643,75,NULL,'MAT, I, cor','ESO 079- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4581,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4581,35.81,0.33,145,1644,70,NULL,NULL,'GIN 007',NULL,'2001MNRAS.321..277C',2001,1,0.5,NULL,'G',NULL,NULL,'14.63',0.5,'SBa','Group member',NULL,NULL,NULL,1,10.185917,6.55908,0.069,NULL,66828238682,1044191229,16315487,14.63),(4582,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4582,37.43,0.64,307,1645,70,NULL,NULL,'2MASX J00404599-0624065',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'17.14',0.29,NULL,NULL,NULL,NULL,NULL,1,10.191625,-6.40178,0.186,NULL,34620578839,540946544,8452289,17.14),(4583,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4583,37.1,0.08,263,1646,70,NULL,NULL,'2MASX J00404645-0850055',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000098,NULL,'16.1g',0.38,'S0',NULL,NULL,NULL,NULL,1,10.193625,-8.83475,0.127,NULL,34576039544,540250617,8441415,16.1),(4584,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4584,37.24,0.67,281,1646,70,NULL,NULL,'2MASX J00404645-0850055',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4585,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 04417',NULL,4585,35.36,2,118,1647,70,NULL,'SN photometric redshift distance, z photo =0.028 +/- 0.044','SDSS-II SN 04417',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','22.5g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,10.1976666667,-0.42886,0.03,NULL,34394114154,537408033,8397000,22.5),(4586,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 04417','R',4586,41.65,0.33,1570,1647,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 04417',0.362084,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4587,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 04417','R',4587,41.7,0.31,1610,1647,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 04417',0.362084,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4588,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 04417',NULL,4588,41.6,0.22,2090,1647,70,NULL,'SALT 2','SDSS-II SN 04417',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4589,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 04417',NULL,4589,41.65,0.22,2140,1647,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 04417',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4590,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4590,34.79,0.47,90.6,1648,70,NULL,NULL,'NGC 0215',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000019,NULL,'14.05',0.9,'SA0-','Brightest group member',NULL,NULL,NULL,1,10.203625,-56.21406,0,NULL,36216093856,565876466,8841819,14.05),(4591,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4591,35.18,0.25,109,1648,74.4,NULL,NULL,'NGC 0215',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4592,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4592,35.38,0.4,119,1648,NULL,NULL,'mean','NGC 0215',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4593,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4593,35.5,0.45,126,1648,NULL,NULL,'K','NGC 0215',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4594,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4594,37.54,0.46,322,1649,70,NULL,NULL,'2MASX J00405038+1346340',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000081,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,10.209917,13.77611,0.173,NULL,67464128779,1054127012,16470734,17.7),(4595,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 13597',NULL,4595,41.25,0.21,1780,1650,70,NULL,'SN photometric redshift distance, z photo =0.555 +/- 0.081','SDSS-II SN 13597',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'G',0.0003,NULL,'21.1r',NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,10.2152083,-0.42006,0.03,NULL,34394294182,537410846,8397044,21.1),(4596,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 13597','R',4596,42.68,0.33,2200,1650,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13597',0.5625,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4597,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4597,34.52,0.49,80.2,1651,75,NULL,'IR','CGCG 383-067',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',NULL,NULL,'15.7',0.13,'Spiral',NULL,NULL,NULL,NULL,1,10.2152916667,2.84175,0.049,NULL,66808219496,1043878429,16310600,15.7),(4598,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4598,34.12,0.2,66.7,1652,74.4,NULL,NULL,'MCG -02-02-082',NULL,'2013AJ....146...86T',2013,1,0.8,'HOLM 014B is a star.','G',0.000013,NULL,'14.5',0.5,'SBab           HII','Erroneous pair member',NULL,NULL,NULL,1,10.229667,-13.77558,0.04,NULL,35334663508,552104117,8626626,14.5),(4599,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4599,34.19,0.55,68.8,1652,NULL,NULL,NULL,'MCG -02-02-082',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4600,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4600,34.5,0.47,79.6,1652,NULL,NULL,'Malmquist cor.','MCG -02-02-082',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4601,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4601,37.6,0.46,332,1653,70,NULL,NULL,'2MASX J00405933+1551031',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000083,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,10.247375,15.85097,0.129,NULL,67477420068,1054334688,16473979,17.3),(4602,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4602,36.3,0.62,182,1654,70,NULL,NULL,'2MASX J00405978-6015451',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.20',0.38,'S0',NULL,NULL,NULL,NULL,1,10.24925,-60.26261,0,NULL,36080423674,563756619,8808697,16.2),(4603,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4603,35.27,0.53,113,1655,70,NULL,NULL,'2MASX J00410037-5556213',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.63',0.29,NULL,NULL,NULL,NULL,NULL,1,10.251583,-55.93919,0,NULL,36217049976,565891405,8842053,16.63),(4604,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4604,37.56,0.46,325,1656,70,NULL,NULL,'2MASXi J0041005+160700',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000066,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,10.2522083,16.11678,0.089,NULL,67474510617,1054289228,16473269,18),(4605,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 13526','RN',4605,42.46,0.22,1980,1657,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13526',0.569228,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4606,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4606,37.1,0.08,263,1658,70,NULL,NULL,'SDSS J004101.87-091233.1',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000111,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,10.257833,-9.20919,0.124,NULL,34576079073,540251235,8441425,16.4),(4607,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 04240','RN',4607,43.48,0.5,3380,1659,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 04240',0.467156,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4608,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4608,37.95,0.46,389,1660,70,NULL,NULL,'SDSS J004102.97+134520.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000079,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,10.262417,13.75564,0.173,NULL,67464075912,1054126186,16470721,18.7),(4609,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4609,37.62,0.46,335,1661,70,NULL,NULL,'2MASX J00410357-0946104',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000077,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,10.264917,-9.76958,0.105,NULL,34576324650,540255072,8441485,17.8),(4610,'IRAS','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4610,33.84,0.8,58.5,1662,75,NULL,'W91PP, r','UGC 00433',NULL,'1997ApJS..109..333W',1997,1,2.12,NULL,'G',0.000011,NULL,'14.59',0.25,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,10.2652083,31.73269,0.221,NULL,67375150436,1052736725,16449011,14.59),(4611,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4611,34,0.47,63.2,1662,NULL,NULL,'H','UGC 00433',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4612,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4612,34.03,0.45,63.9,1662,NULL,NULL,'K','UGC 00433',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4613,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4613,34.11,0.4,66.3,1662,NULL,NULL,'mean','UGC 00433',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4614,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4614,34.15,0.46,67.6,1662,NULL,NULL,'J','UGC 00433',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4615,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4615,34.15,0.49,67.7,1662,75,NULL,'IR','UGC 00433',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4616,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4616,34.28,0.38,71.8,1662,75,NULL,'W91PP, r, raw','UGC 00433',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4617,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4617,34.33,NULL,73.3,1662,NULL,NULL,NULL,'UGC 00433',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4618,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4618,34.37,NULL,74.7,1662,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00433',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4619,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4619,34.39,NULL,75.4,1662,NULL,NULL,'Dipole + Quadrupole','UGC 00433',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4620,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4620,34.39,0.38,75.5,1662,75,NULL,'W91PP, r, cor','UGC 00433',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4621,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4621,34.4,NULL,75.7,1662,NULL,NULL,'Dipole','UGC 00433',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4622,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4622,34.42,0.2,76.6,1662,74.4,NULL,NULL,'UGC 00433',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4623,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4623,34.45,0.38,77.7,1662,75,NULL,'W91PP, r, inv','UGC 00433',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4624,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4624,34.51,0.37,79.9,1662,NULL,NULL,'Malmquist cor.','UGC 00433',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4625,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4625,34.62,0.35,83.9,1662,NULL,NULL,NULL,'UGC 00433',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4626,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 13140','RN',4626,43.06,0.24,3080,1663,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13140',0.324644,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4627,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 13140','RN',4627,43.09,0.25,3140,1663,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13140',0.324644,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4628,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4628,36.02,0.63,160,1664,70,NULL,NULL,'IC 0042',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.28',0.4,'SBbc           HII',NULL,NULL,NULL,NULL,1,10.274333,-15.42808,0.024,NULL,35349446135,552335095,8630235,15.28),(4629,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4629,36.21,0.55,175,1665,70,NULL,NULL,'2MASX J00410650-3701488',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'16.86',0.3,NULL,NULL,NULL,NULL,NULL,1,10.277125,-37.03014,NULL,NULL,34661570356,541587036,8462297,16.86),(4630,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4630,37.1,0.08,263,1666,70,NULL,NULL,'SDSS J004107.09-092653.3',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000088,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,10.279583,-9.44817,0.117,NULL,34576463169,540257237,8441519,18.5),(4631,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 17519','RN',4631,42.56,0.22,2010,1667,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17519',0.615157,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4632,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4632,34.28,0.4,71.6,1668,NULL,NULL,'mean','NGC 0213',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000033,NULL,'14.23',1.4,'SB(rs)a',NULL,NULL,NULL,NULL,1,10.291667,16.46939,0.089,NULL,67466844973,1054169452,16471397,14.23),(4633,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4633,34.32,0.45,73.1,1668,NULL,NULL,'K','NGC 0213',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4634,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4634,34.34,0.47,74,1668,NULL,NULL,'H','NGC 0213',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4635,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4635,34.41,0.46,76.1,1668,NULL,NULL,'J','NGC 0213',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4636,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4636,35.56,0.49,129,1669,75,NULL,'IR','FGC 0076',NULL,'2011yCatp016004901K',2011,1,1.05,NULL,'G',0.000153,NULL,'16.86',0.11,'Sbc',NULL,NULL,NULL,NULL,1,10.2921666667,25.58564,0.101,NULL,67194741371,1049917833,16404966,16.86),(4637,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4637,35.57,NULL,130,1669,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0076',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4638,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4638,35.59,NULL,131,1669,NULL,NULL,'Dipole + Quadrupole','FGC 0076',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4639,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4639,35.6,NULL,132,1669,NULL,NULL,'Dipole','FGC 0076',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4640,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4640,35.6,NULL,132,1669,NULL,NULL,NULL,'FGC 0076',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4641,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 06244','RN',4641,43.24,0.2,2660,1670,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 06244',0.669505,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4642,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4642,34.83,0.49,92.6,1671,75,NULL,'IR','FGC 0077',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000013,NULL,'16.89',0.12,'Sc(f)',NULL,NULL,NULL,NULL,1,10.298333,15.05272,0.205,NULL,67477002594,1054328165,16473877,16.89),(4643,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4643,34.95,0.2,97.7,1671,74.4,NULL,NULL,'FGC 0077',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4644,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4644,35.29,NULL,114,1671,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0077',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4645,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4645,35.3,NULL,115,1671,NULL,NULL,'Dipole','FGC 0077',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4646,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4646,35.3,NULL,115,1671,NULL,NULL,'Dipole + Quadrupole','FGC 0077',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4647,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4647,35.51,NULL,127,1671,NULL,NULL,NULL,'FGC 0077',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4648,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4648,37.1,0.08,263,1672,70,NULL,NULL,'MENeaCS ABELL0085_11_19_0 HOST',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000088,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,10.3037917,-9.15011,0.124,NULL,34576077802,540251215,8441425,16.9),(4649,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4649,37.1,0.08,263,1673,70,NULL,NULL,'SDSS J004112.93-090217.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,10.303875,-9.03814,0.131,NULL,34576124528,540251945,8441436,17.7),(4650,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 20555','RN',4650,41.83,0.21,1880,1674,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 20555',0.238827,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4651,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 20555','RN',4651,42.22,0.25,2240,1674,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20555',0.238827,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4652,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 07841','R',4652,41.58,0.3,1450,1675,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J004114.84-000304.7',0.428635,'2014arXiv1401.3317S',2014,1,0.11,NULL,'G',NULL,'PHOT','20.5g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,10.311875,-0.05133,0.027,NULL,34393713141,537401767,8396902,20.5),(4653,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 07841','R',4653,41.79,0.34,1600,1675,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J004114.84-000304.7',0.428635,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4654,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 07841',NULL,4654,41.68,0.22,2170,1675,70,NULL,'SALT 2','SDSS J004114.84-000304.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4655,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 07841',NULL,4655,41.76,0.22,2250,1675,70,NULL,'SALT 2, Malmquist cor.','SDSS J004114.84-000304.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4656,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4656,37.1,0.08,263,1676,70,NULL,NULL,'SDSS J004118.34-084514.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000088,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,10.3264583,-8.75417,0.127,NULL,34576048310,540250754,8441418,18.1),(4657,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4657,37.1,0.08,263,1677,70,NULL,NULL,'SDSS J004118.39-092911.7',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000081,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,10.326667,-9.48658,0.117,NULL,34576450379,540257037,8441516,17.6),(4658,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4658,37.1,0.08,263,1678,70,NULL,NULL,'2MASX J00411959-0925084',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000092,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,10.3314583,-9.41908,0.117,NULL,34576450678,540257041,8441516,17.2),(4659,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4659,35.54,0.74,128,1679,70,NULL,NULL,'LCRS B003858.5-442623',NULL,'2014MNRAS.445.2677S',2014,1,0.26,NULL,'G',0.00015,NULL,'14.84',0.16,NULL,NULL,NULL,NULL,NULL,1,10.3384583,-44.16539,NULL,NULL,38181484644,596585697,9321651,14.84),(4660,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4660,37.27,0.25,284,1680,74.4,NULL,NULL,'GIN 012',NULL,'2013AJ....146...86T',2013,1,0.61,NULL,'G',0.000103,NULL,'15.8g',0.53,'S',NULL,NULL,NULL,NULL,1,10.3419583,-9.87803,0.105,NULL,34562384827,540037262,8438082,15.8),(4661,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4661,37.54,0.23,322,1680,70,NULL,NULL,'GIN 012',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4662,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4662,37.78,0.46,359,1681,70,NULL,NULL,'SDSS J004122.94+004804.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000079,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,10.345625,0.80119,0.021,NULL,66589225706,1040456651,16257135,18.4),(4663,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SN 2007sb',NULL,4663,39.48,0.08,787,1682,70,NULL,'Hubble residual -0.07 for z0.21230','SDSS J004123.68+002442.4',NULL,'2011ApJ...740...92G',2011,1,0.11,NULL,'G',0.0005,NULL,'20.2g',0.08,NULL,NULL,NULL,NULL,NULL,1,10.348667,0.41181,0.04,NULL,66589810673,1040465791,16257277,20.2),(4664,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 18940','R',4664,39.98,0.18,816,1682,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007sb','SDSS J004123.68+002442.4',0.2123,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4665,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 18940','R',4665,40.07,0.1,853,1682,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007sb','SDSS J004123.68+002442.4',0.2123,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4666,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SN 2007sb',NULL,4666,39.83,0.08,925,1682,70,NULL,'SALT 2','SDSS J004123.68+002442.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4667,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SN 2007sb',NULL,4667,39.85,0.08,933,1682,70,NULL,'SALT 2, Malmquist cor.','SDSS J004123.68+002442.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4668,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4668,37.1,0.08,263,1683,70,NULL,NULL,'2MASX J00412436-0842023',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000067,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,10.3514583,-8.70064,0.127,NULL,34576051306,540250801,8441418,17.2),(4669,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 16477','RN',4669,41.67,0.31,1540,1684,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16477',0.401058,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4670,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 16477','RN',4670,41.71,0.32,1570,1684,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16477',0.401058,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4671,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 16477','N',4671,41.69,0.21,2180,1684,70,NULL,'SALT 2','SDSS-II SN 16477',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4672,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:35','1','SDSS-II SN 16477','N',4672,41.75,0.21,2240,1684,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16477',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4673,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4673,37.1,0.08,263,1685,70,NULL,NULL,'2MASX J00412544-0946189',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000091,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,10.356125,-9.77189,0.105,NULL,34576327721,540255120,8441486,18),(4674,'FP','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,'R',4674,37.85,0.46,371,1686,70,NULL,NULL,'2MASXi J0041262+142420',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000087,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,10.3594583,14.40564,0.181,NULL,67463814084,1054122095,16470657,17.8),(4675,'Tully est','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4675,31.41,0.8,19.1,1687,75,NULL,'B','NGC 0216',NULL,'1988NBGC.C....0000T',1988,1,2,'Da Costa, et al. (1998,AJ,116,1) give v = 24002 +/- 70 km/sec.','G',0.00002,NULL,'12.9r',0.7,'S0^0^? sp      HII','Pair member (points to parent)',NULL,NULL,NULL,1,10.363125,-21.04544,0.062,NULL,35329428611,552022322,8625348,12.9),(4676,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:35','1',NULL,NULL,4676,30.3,0.4,11.5,1687,73,NULL,'IR','NGC 0216',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4677,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4677,30.31,0.4,11.5,1687,75,NULL,NULL,'NGC 0216',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4678,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4678,31.37,0.49,18.8,1687,75,NULL,'IR','NGC 0216',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4679,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4679,33.61,0.45,52.8,1688,NULL,NULL,'K','NGC 0214',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000013,NULL,'12.97',1.4,'SAB(r)c','in a radial-velocity based grouping',NULL,NULL,NULL,1,10.3667916667,25.49944,0.077,NULL,67194734610,1049917728,16404964,12.97),(4680,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4680,33.69,0.46,54.7,1688,NULL,NULL,'J','NGC 0214',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4681,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4681,33.72,0.47,55.5,1688,NULL,NULL,'H','NGC 0214',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4682,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4682,33.79,0.43,57.4,1688,75,NULL,'3.6 micron, color corrected','NGC 0214',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4683,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4683,33.82,0.43,58.1,1688,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0214',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4684,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4684,33.89,0.2,60,1688,74.4,NULL,NULL,'NGC 0214',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4685,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4685,33.96,0.4,61.9,1688,NULL,NULL,'mean','NGC 0214',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4686,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4686,34,0.31,63.2,1688,NULL,NULL,NULL,'NGC 0214',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4687,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4687,34.17,0.28,68.4,1688,NULL,NULL,'Malmquist cor.','NGC 0214',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4688,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4688,38.35,0.46,469,1689,70,NULL,NULL,'2MASX J00412962+1555235',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000098,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,10.373333,15.92311,0.093,NULL,67477206609,1054331353,16473927,18.1),(4689,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4689,35.78,0.49,143,1690,75,NULL,'IR','FGC 0078',NULL,'2011yCatp016004901K',2011,1,1.01,NULL,'G',0.000013,NULL,'17.19',0.08,'Scd',NULL,NULL,NULL,NULL,1,10.3769583333,10.89006,0.189,NULL,66777107873,1043392310,16303004,17.19),(4690,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4690,35.97,NULL,156,1690,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0078',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4691,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4691,35.98,NULL,157,1690,NULL,NULL,'Dipole + Quadrupole','FGC 0078',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4692,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4692,35.98,NULL,157,1690,NULL,NULL,'Dipole','FGC 0078',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4693,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4693,36.03,NULL,160,1690,NULL,NULL,NULL,'FGC 0078',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4694,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4694,37.1,0.08,263,1691,70,NULL,NULL,'2MASX J00413073-0902149',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000088,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,10.3780833333,-9.03747,0.131,NULL,34576105012,540251640,8441431,16.9),(4695,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4695,37.1,0.08,263,1692,70,NULL,NULL,'2MASX J00413126-0941509',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000075,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,10.3802083,-9.69753,0.111,NULL,34576293639,540254588,8441477,16.7),(4696,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4696,37.62,0.71,335,1693,70,NULL,NULL,'6dF J0041334-142148',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,10.3890833333,-14.36328,0.038,NULL,35334143739,552095995,8626499,15.3),(4697,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4697,37.1,0.08,263,1694,70,NULL,NULL,'2MASX J00413343-0909239',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000093,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,10.3892083,-9.1565,0.131,NULL,34576587430,540259178,8441549,16.6),(4698,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4698,33.55,0.49,51.3,1695,75,NULL,'IR','NGC 0217',NULL,'2011yCatp016004901K',2011,1,2.05,NULL,'G',0.000033,NULL,'13.0g',0.68,'S0/a: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,10.3912083,-10.02142,0.097,NULL,34562401198,540037518,8438086,13),(4699,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4699,33.72,0.36,55.4,1695,NULL,NULL,'Malmquist cor.','NGC 0217',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4700,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4700,33.74,0.36,55.9,1695,NULL,NULL,NULL,'NGC 0217',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4701,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4701,33.78,0.2,57,1695,74.4,NULL,NULL,'NGC 0217',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4702,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4702,36.31,0.33,183,1696,70,NULL,NULL,'2MASX J00413451-1053099',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000077,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,10.393583,-10.88631,0.101,NULL,34564656692,540072760,8438636,17.7),(4703,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:36','1','SDSS-II SN 02872','RN',4703,38.71,0.22,511,1697,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02872',0.080995,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4704,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:36','1','SDSS-II SN 02872','RN',4704,38.84,0.27,541,1697,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02872',0.080995,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4705,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4705,37.03,0.46,255,1698,70,NULL,NULL,'2MASX J00413555-0105314',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000101,NULL,'16.9g',0.24,'NLAGN',NULL,NULL,NULL,NULL,1,10.39825,-1.092,0.043,NULL,34578305530,540286023,8441969,16.9),(4706,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4706,35.11,0.46,105,1699,70,NULL,NULL,'2MASX J00413607-1044279',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000087,NULL,'15.3g',0.47,'E0',NULL,NULL,NULL,NULL,1,10.400375,-10.74128,0.101,NULL,34565152820,540080512,8438758,15.3),(4707,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4707,37.1,0.08,263,1700,70,NULL,NULL,'2MASX J00413620-0919299',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000099,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,10.400875,-9.32508,0.117,NULL,34576440274,540256879,8441513,17.3),(4708,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4708,34.44,0.46,77.4,1701,70,NULL,NULL,'MCG -07-02-014',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000087,NULL,'14.39',0.6,'S0',NULL,NULL,NULL,NULL,1,10.4159583333,-42.32097,NULL,NULL,38175899759,596498433,9320288,14.39),(4709,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4709,37.58,0.46,327,1702,70,NULL,NULL,'2MASX J00413998+1520155',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000078,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,10.4167083,15.33767,0.121,NULL,67477836432,1054341194,16474081,17.7),(4710,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4710,37.14,0.46,267,1703,70,NULL,NULL,'2MASX J00414374+0005272',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000088,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,10.43225,0.091,0.027,NULL,66589366901,1040458857,16257169,16.9),(4711,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:36','1','SDSS-II SN 16124','RN',4711,38.46,0.23,455,1704,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 16124',0.080565,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4712,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4712,32.06,0.43,25.8,1705,75,NULL,'3.6 micron, color + selection bias corrected','KUG 0039-171B',NULL,'2014MNRAS.444..527S',2014,1,1.6,'Huchra, et al. (1993AJ....105.1637H) give v = 16239 +/- 36 km/sec.','G',0.000007,NULL,'14.47',1.1,'SB(s)d',NULL,NULL,NULL,NULL,1,10.4397917,-16.86083,0.048,NULL,35344141164,552252205,8628940,14.47),(4713,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4713,37.1,0.08,263,1706,70,NULL,NULL,'2MASX J00414585-0909449',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000086,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,10.4410417,-9.16242,0.131,NULL,34576581996,540259093,8441548,17.1),(4714,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4714,36.68,0.46,217,1707,70,NULL,NULL,'2MASX J00414759+1509331',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000085,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,10.448333,15.15906,0.193,NULL,67476986403,1054327912,16473873,16.8),(4715,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4715,37.1,0.08,263,1708,70,NULL,NULL,'2MASX J00414822-0917029',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000119,NULL,'16.3g',0.32,'AGN','in a pair',NULL,'NAT',NULL,1,10.4509583333,-9.28422,0.096,NULL,34576562071,540258782,8441543,16.3),(4716,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4716,34.13,0.5,67,1709,70,NULL,NULL,'CGCG 383-072',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000073,NULL,'15.3',0.54,NULL,NULL,NULL,NULL,NULL,1,10.4518333333,-1.73858,0.062,NULL,34581823772,540340996,8442828,15.3),(4717,'BCG','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4717,36.97,0.35,235,1710,60,NULL,NULL,'ABELL 0085',0.0556,'1980ApJ...241..486H',1980,1,NULL,'Mazure (1996,A&A,310,31) identifies multiple redshift systems in this cluster.','GClstr',0.00034,NULL,NULL,NULL,'I      [BM]',NULL,NULL,NULL,NULL,1,10.45875,-9.30194,0.096,NULL,34576550825,540258606,8441540,NULL),(4718,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4718,37.1,0.08,263,1711,70,NULL,NULL,'GIN 009',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000117,NULL,'15.8g',0.46,'E',NULL,NULL,'NAT',NULL,1,10.4590416667,-9.42986,0.117,NULL,34576481675,540257526,8441523,15.8),(4719,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4719,37.28,0.25,286,1711,74.4,NULL,NULL,'GIN 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4720,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4720,37.54,0.23,322,1711,70,NULL,NULL,'GIN 009',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4721,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:36','1','SN 2003ic',NULL,4721,35.88,0.17,142,1712,74.2,NULL,'SALT 2','MCG -02-02-086',0.055672,'2010ApJ...716..712A',2010,1,1.3,'The position in 1998A&AS..129..281D is 6 arcsec northwest of the nucleus.','G',0.00008,NULL,'14.7B',1.2,'cD;BrClG','in a pair',NULL,'radio jet',NULL,1,10.4602917,-9.30314,0.096,NULL,34576550835,540258606,8441540,14.7),(4722,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:36','1','SN 2003ic',NULL,4722,36.54,0.17,193,1712,73.8,NULL,'SALT 2 (SNANA)','MCG -02-02-086',0.0538,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4723,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:36','1','SN 2003ic',NULL,4723,36.56,0.09,205,1712,74.4,NULL,NULL,'MCG -02-02-086',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4724,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:36','1','SN 2003ic',NULL,4724,36.69,0.16,206,1712,65,NULL,'SALT','MCG -02-02-086',0.055672,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4725,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:36','1','SN 2003ic',NULL,4725,36.76,0.17,213,1712,65,NULL,'MLCS31','MCG -02-02-086',0.055672,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4726,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:36','1','SN 2003ic',NULL,4726,36.77,0.18,214,1712,65,NULL,'SALT2','MCG -02-02-086',0.055672,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4727,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:36','1','SN 2003ic',NULL,4727,36.78,0.16,215,1712,65,NULL,'MLCS17','MCG -02-02-086',0.055672,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4728,'BCG','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4728,36.97,0.35,235,1712,60,NULL,'ABELL 0085, BCG','MCG -02-02-086',0.0556,'1980ApJ...241..486H',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4729,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4729,36.56,0.09,205,1712,74.4,NULL,NULL,'MCG -02-02-086',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4730,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4730,37.54,0.23,322,1712,70,NULL,NULL,'MCG -02-02-086',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4731,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4731,34.11,0.12,66.5,1713,NULL,NULL,NULL,'UGC 00442',NULL,'2009ApJS..182..474S',2009,1,1.7,NULL,'G',0.000023,NULL,'14.92',0.8,'SA(rs)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,10.465375,32.99131,0.257,NULL,67333200810,1052081262,16438769,14.92),(4732,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4732,34.52,0.2,80.2,1713,74.4,NULL,NULL,'UGC 00442',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4733,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4733,36.28,0.51,180,1714,70,NULL,NULL,'MCG -02-02-090',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.000063,NULL,'15.3g',0.53,'S0^-',NULL,NULL,NULL,NULL,1,10.472083,-10.83275,0.101,NULL,34564650165,540072658,8438635,15.3),(4734,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4734,36.31,0.33,183,1714,70,NULL,NULL,'MCG -02-02-090',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4735,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4735,35.99,NULL,158,1715,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0079',NULL,'2010Ap&SS.325..163P',2010,1,0.9,NULL,'G',NULL,NULL,'16.82',0.11,'Sc',NULL,NULL,NULL,NULL,1,10.4765,41.95411,0.261,NULL,67706188383,1057909193,16529831,16.82),(4736,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4736,36.02,NULL,160,1715,NULL,NULL,'Dipole + Quadrupole','FGC 0079',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4737,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4737,36.02,NULL,160,1715,NULL,NULL,NULL,'FGC 0079',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4738,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4738,36.03,NULL,161,1715,NULL,NULL,'Dipole','FGC 0079',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4739,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4739,36.45,0.49,195,1715,75,NULL,'IR','FGC 0079',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4740,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:36','1','SDSS-II SN 02700','RN',4740,42.49,0.23,2080,1716,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02700',0.510759,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4741,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:36','1','SDSS-II SN 05729','RN',4741,37.11,0.3,245,1717,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05729',0.08078,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4742,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4742,37.1,0.08,263,1718,70,NULL,NULL,'2MASX J00420326-0928161',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000093,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,10.513625,-9.47106,0.117,NULL,34576474919,540257420,8441522,16.8),(4743,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4743,37.54,0.13,322,1719,70,NULL,NULL,'2MASX J00420438+1512321',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000073,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,10.518167,15.20872,0.193,NULL,67477832232,1054341128,16474080,18),(4744,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4744,37.22,0.52,278,1720,70,NULL,NULL,'LCRS B003941.4-422625',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'16.18',0.48,'E',NULL,NULL,NULL,NULL,1,10.5189583,-42.16631,NULL,NULL,38174798406,596481225,9320019,16.18),(4745,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4745,34.1,0.4,66,1721,NULL,NULL,'mean','UGC 00444',NULL,'2007A&A...465...71T',2007,1,1.1,'1993AJ....105.1251W has V = 4397 km/sec.  RC3 has V = 10693 +- 52 km/sec.','G',0.00002,NULL,'13.99',0.8,'S?','in a pair',NULL,NULL,NULL,1,10.519333,36.80503,0.165,NULL,67158231472,1049347366,16396052,13.99),(4746,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4746,35.41,0.45,121,1721,NULL,NULL,'K','UGC 00444',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4747,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4747,35.46,0.47,123,1721,NULL,NULL,'H','UGC 00444',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4748,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4748,35.54,0.46,128,1721,NULL,NULL,'J','UGC 00444',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4749,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4749,35.77,0.38,143,1721,NULL,NULL,'Malmquist cor.','UGC 00444',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4750,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4750,35.99,0.34,157,1721,NULL,NULL,NULL,'UGC 00444',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4751,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4751,36.03,0.2,161,1721,74.4,NULL,NULL,'UGC 00444',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4752,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4752,37.54,0.13,322,1722,70,NULL,NULL,'2MASX J00420465+1515471',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000081,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,10.519417,15.26311,0.193,NULL,67477309792,1054332965,16473952,18),(4753,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4753,37.28,0.46,286,1723,70,NULL,NULL,'SDSS J004207.10-094955.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000075,NULL,'17.9g',0.15,'Se',NULL,NULL,NULL,NULL,1,10.529625,-9.83208,0.111,NULL,34562417630,540037775,8438090,17.9),(4754,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4754,33.61,0.2,52.7,1724,74.4,NULL,NULL,'UGC 00443',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.00003,NULL,'15.43',0.3,'Scd:',NULL,NULL,NULL,NULL,1,10.5323333333,33.40675,0.257,NULL,67332677693,1052073088,16438642,15.43),(4755,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4755,33.84,0.4,58.7,1724,NULL,NULL,NULL,'UGC 00443',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4756,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4756,34.21,0.34,69.5,1724,NULL,NULL,'Malmquist cor.','UGC 00443',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4757,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:36','1','SDSS-II SN 02934','RN',4757,40.54,0.11,1110,1725,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02934',0.151917,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4758,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:36','1','SDSS-II SN 02934','RN',4758,40.9,0.2,1310,1725,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02934',0.151917,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4759,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4759,34.96,0.46,98.3,1726,70,NULL,NULL,'NGC 0219',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000082,NULL,'15.0g',0.59,'cE?',NULL,NULL,NULL,NULL,1,10.547125,0.90456,0,NULL,66807488699,1043867010,16310422,15),(4760,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4760,34.99,0.73,99.4,1727,NULL,NULL,'Malmquist cor.','AGC 100917',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000027,NULL,'14.7I',NULL,NULL,NULL,NULL,NULL,NULL,1,10.548333,37.01556,0.193,NULL,67158213692,1049347088,16396048,14.7),(4761,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4761,35.33,0.63,116,1727,NULL,NULL,NULL,'AGC 100917',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4762,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4762,35.37,0.2,119,1727,74.4,NULL,NULL,'AGC 100917',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4763,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:36','1','PTF09foz',NULL,4763,36.74,0.1,211,1728,70,NULL,'SiFTO+SALT2, SN PTF09foz','PTF09foz',0.05331,'2012MNRAS.426.2359M',2012,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,10.548875,-9.88131,0.101,NULL,34562613721,540040839,8438138,NULL),(4764,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:36','1','PTF09foz',NULL,4764,36.77,0.09,215,1728,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF09foz',0.05331,'2014MNRAS.438.1391P',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4765,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4765,37.8,0.46,363,1729,70,NULL,NULL,'2MASX J00421239-0941431',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000087,NULL,'17.3g',0.17,'S0',NULL,NULL,NULL,NULL,1,10.5517917,-9.69517,0.111,NULL,34562589021,540040453,8438132,17.3),(4766,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4766,37.18,0.46,273,1730,70,NULL,NULL,'2MASX J00421299-0917511',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000093,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,10.5540833333,-9.29742,0.096,NULL,34576630782,540259855,8441560,16.7),(4767,'IRAS','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4767,31.5,0.8,20,1731,75,NULL,'MAT, I','ESO 540- G 016',NULL,'1997ApJS..109..333W',1997,1,3.36,NULL,'G',0.000013,NULL,'13.5r',0.3,'SB(s)cd? sp',NULL,NULL,NULL,NULL,1,10.5612083,-18.16175,0.053,NULL,35353477032,552398078,8631219,13.5),(4768,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4768,31.64,0.4,21.3,1731,73,NULL,'opt','ESO 540- G 016',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4769,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4769,31.73,0.77,22.2,1731,NULL,NULL,'Malmquist cor.','ESO 540- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4770,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4770,31.73,0.32,22.2,1731,85,NULL,'I, inv','ESO 540- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4771,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4771,31.76,0.32,22.5,1731,85,NULL,'I, raw','ESO 540- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4772,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4772,31.89,NULL,23.8,1731,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 540- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4773,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4773,31.9,NULL,23.9,1731,NULL,NULL,'Dipole + Quadrupole','ESO 540- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4774,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4774,31.9,NULL,24,1731,NULL,NULL,'Dipole','ESO 540- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4775,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4775,31.96,0.4,24.7,1731,NULL,NULL,NULL,'ESO 540- G 016',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4776,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4776,31.96,0.39,24.7,1731,73,NULL,'opt','ESO 540- G 016',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4777,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4777,31.98,0.2,24.9,1731,74.4,NULL,NULL,'ESO 540- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4778,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4778,31.98,0.43,24.9,1731,75,NULL,'MAT, I, inv','ESO 540- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4779,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4779,32,0.43,25.1,1731,75,NULL,'MAT, I, raw','ESO 540- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4780,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4780,32.08,0.43,26,1731,75,NULL,'MAT, I, cor','ESO 540- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4781,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4781,32.1,0.65,26.3,1731,NULL,NULL,NULL,'ESO 540- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4782,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4782,32.34,0.43,29.3,1731,75,NULL,'3.6 micron, color corrected','ESO 540- G 016',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4783,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4783,32.62,0.43,33.4,1731,75,NULL,'3.6 micron, color + selection bias corrected','ESO 540- G 016',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4784,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4784,34.6,0.56,83.2,1732,70,NULL,NULL,'MCG -02-02-092',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.0001,NULL,'14.79',0.8,'SA(rs)0-:',NULL,NULL,NULL,NULL,1,10.561625,-11.47158,0.135,NULL,34443919849,538186247,8409160,14.79),(4785,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4785,34.95,0.2,97.7,1733,74.4,NULL,NULL,'NGC 0223',NULL,'2013AJ....146...86T',2013,1,0.42,NULL,'G',0.000071,NULL,'14.0g',0.29,'(R\')SB(r)0/a:','Group member',NULL,NULL,NULL,1,10.5661666667,0.8455,0.025,NULL,66807734589,1043870852,16310482,14),(4786,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4786,37.1,0.08,263,1734,70,NULL,NULL,'2MASX J00421590-0932521',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000099,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,10.5662917,-9.54781,0.111,NULL,34576377299,540255895,8441498,16.6),(4787,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4787,35.52,0.48,127,1735,70,NULL,NULL,'FAIRALL 0662',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'15.38',0.7,'SA(rs)0/a',NULL,NULL,NULL,NULL,1,10.569,-50.50928,NULL,NULL,36011974831,562687106,8791986,15.38),(4788,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4788,37.1,0.08,263,1736,70,NULL,NULL,'2MASX J00421873-0915281',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000104,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,10.5781666667,-9.25792,0.096,NULL,34576632096,540259876,8441560,16.6),(4789,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4789,37.1,0.08,263,1737,70,NULL,NULL,'2MASX J00421995-0921191',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00009,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,10.5832083333,-9.35522,0.096,NULL,34576365037,540255703,8441495,17.6),(4790,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4790,34.08,NULL,65.4,1738,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0083',NULL,'2010Ap&SS.325..163P',2010,1,1.23,NULL,'G',0.000017,NULL,'16.6',0.09,'Sd',NULL,NULL,NULL,NULL,1,10.584167,-15.99,0.029,NULL,35345663638,552275994,8629312,16.6),(4791,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4791,34.08,NULL,65.6,1738,NULL,NULL,'Dipole + Quadrupole','FGC 0083',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4792,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4792,34.09,NULL,65.8,1738,NULL,NULL,'Dipole','FGC 0083',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4793,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4793,34.09,NULL,65.9,1738,NULL,NULL,NULL,'FGC 0083',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4794,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4794,36.5,0.46,200,1739,70,NULL,NULL,'2MASX J00422154+1415158',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000085,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,10.589667,14.25436,0.177,NULL,67464342003,1054130343,16470786,16.9),(4795,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4795,37.52,0.68,319,1740,70,NULL,NULL,'2MASX J00422229-1336254',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00015,NULL,'16.68',0.37,NULL,NULL,NULL,NULL,NULL,1,10.5927083,-13.60711,0.019,NULL,35336874471,552138663,8627166,16.68),(4796,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4796,33.93,0.49,61,1741,75,NULL,'IR','UGC 00449',NULL,'2011yCatp016004901K',2011,1,0.9,'This is not IC 0045; that is a pair of Galactic stars.','G',0.000033,NULL,'15.35',0.2,'S?',NULL,NULL,NULL,NULL,1,10.59325,29.6985,0.169,NULL,67371157497,1052674335,16448036,15.35),(4797,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:36','1','SDSS-II SN 13807','RN',4797,42.2,0.4,1820,1742,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13807',0.513851,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4798,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:36','1','SDSS-II SN 13807','N',4798,42.13,0.26,2670,1742,70,NULL,'SALT 2','SDSS-II SN 13807',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4799,'SNIa','2016-12-15 15:13:34','2016-12-16 11:18:36','1','SDSS-II SN 13807','N',4799,42.28,0.26,2860,1742,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13807',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4800,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4800,37.1,0.08,263,1743,70,NULL,NULL,'2MASX J00422448-0952252',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000073,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,10.602,-9.87364,0.101,NULL,34562616160,540040877,8438138,17.6),(4801,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4801,37.1,0.08,263,1744,70,NULL,NULL,'2MASX J00422769-0845512',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000123,NULL,'16.0g',0.32,'S0^-',NULL,NULL,NULL,NULL,1,10.6154583333,-8.76411,0.133,NULL,34576193728,540253027,8441453,16),(4802,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4802,29,0.5,6.3,1745,NULL,NULL,NULL,'Andromeda IV',NULL,'2000AJ....120..821F',2000,1,1.3,'Found to be a galaxy by Ferguson,2000,AJ,120,821.See also Jones,1993,AJ,105,933','G',0.00003,NULL,'16.6B',1,'Dwarf irregular','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,10.6345833333,40.57186,0.309,NULL,67674481885,1057413779,16522090,16.6),(4803,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4803,29.28,0.1,7.17,1745,74.4,NULL,NULL,'Andromeda IV',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4804,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4804,29.28,0.09,7.17,1745,NULL,NULL,NULL,'Andromeda IV',NULL,'2016AN....337..306K',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4805,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4805,37.1,0.08,263,1746,70,NULL,NULL,'2MASX J00423402-0954422',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00009,NULL,'16.1g',0.45,'E',NULL,NULL,NULL,NULL,1,10.641625,-9.91172,0.101,NULL,34562611835,540040809,8438137,16.1),(4806,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4806,37.54,0.13,322,1747,70,NULL,NULL,'2MASX J00423447+1522389',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000075,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,10.643583,15.37739,0.169,NULL,67476250583,1054316415,16473693,17.7),(4807,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:36','1','SDSS-II SN 13808','RN',4807,42.33,0.22,2310,1748,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13808',0.268349,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4808,'SNIa SDSS','2016-12-15 15:13:34','2016-12-16 11:18:36','1','SDSS-II SN 13808','RN',4808,42.99,0.31,3130,1748,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13808',0.268349,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4809,'D-Sigma','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4809,33.75,0.4,56.2,1749,75,NULL,'Edat, raw','NGC 0227',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000093,NULL,'13.11',1.3,'S0- pec:','in a radial-velocity based grouping',NULL,NULL,NULL,1,10.6534583333,-1.52878,0.093,NULL,34581321566,540333149,8442705,13.11),(4810,'D-Sigma','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4810,34.08,0.4,65.6,1749,75,NULL,'Edat, cor','NGC 0227',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4811,'Faber-Jackson','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4811,32.22,0.65,27.8,1749,95,NULL,'Weighted Mean','NGC 0227',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4812,'Faber-Jackson','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4812,33.73,0.81,55.7,1749,55,NULL,'Visvanathan & Sandage 1979','NGC 0227',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4813,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4813,34.27,0.46,71.4,1749,70,NULL,NULL,'NGC 0227',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4814,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4814,34.37,0.4,75,1749,NULL,NULL,'mean','NGC 0227',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4815,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4815,34.41,0.45,76.1,1749,NULL,NULL,'K','NGC 0227',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4816,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4816,37.54,0.13,322,1750,70,NULL,NULL,'2MASX J00423869+1521089',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000085,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,10.661333,15.35258,0.169,NULL,67476247898,1054316373,16473693,17.3),(4817,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4817,38.66,0.46,539,1751,70,NULL,NULL,'2MASX J00423914+0007113',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000067,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,10.663125,0.11975,0,NULL,66588966874,1040452607,16257071,18.4),(4818,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4818,34.92,0.49,96.2,1752,75,NULL,'IR','CGCG 383-077',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',NULL,NULL,'15.6',0.4,NULL,NULL,NULL,NULL,NULL,1,10.6637083,2.73731,0.049,NULL,66808846956,1043888233,16310753,15.6),(4819,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4819,37.1,0.08,263,1753,70,NULL,NULL,'2MASX J00423957-0930532',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000103,NULL,'17.0g',0.26,'AGN',NULL,NULL,NULL,NULL,1,10.66475,-9.51494,0.113,NULL,34576375433,540255866,8441497,17),(4820,'IRAS','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4820,33.96,0.8,62,1754,75,NULL,'W91PP, r','UGC 00453',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'16.5',0.2,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,10.665125,29.87583,0.209,NULL,67371149517,1052674211,16448034,16.5),(4821,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4821,34.09,0.38,65.6,1754,75,NULL,'W91PP, r, inv','UGC 00453',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4822,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4822,34.21,0.2,69.5,1754,74.4,NULL,NULL,'UGC 00453',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4823,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4823,34.21,0.38,69.7,1754,75,NULL,'W91PP, r, raw','UGC 00453',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4824,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4824,34.33,0.38,73.5,1754,75,NULL,'W91PP, r, cor','UGC 00453',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4825,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4825,24.31,0.14,0.728,1755,NULL,NULL,'HST KP Calibrated, K\'','MESSIER 032',NULL,'2000ApJ...529..745F',2000,1,8.7,NULL,'G',0.00002,NULL,'9.03',6.5,'cE2            AGN','in a triple',NULL,NULL,NULL,1,10.6742916667,40.86528,0.309,0,67674524075,1057414438,16522100,9.03),(4826,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4826,24.59,NULL,0.828,1755,NULL,NULL,NULL,'MESSIER 032',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4827,'Horizontal Branch','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4827,24.33,0.21,0.735,1755,NULL,NULL,NULL,'MESSIER 032',NULL,'2012A&A...539A.138F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4828,'PNLF','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4828,24.58,0.6,0.824,1755,NULL,NULL,NULL,'MESSIER 032',NULL,'1989ApJ...339...53C',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4829,'PNLF','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4829,24.83,1.1,0.925,1755,NULL,NULL,'HST KP Calibrated','MESSIER 032',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4830,'Red Clump','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4830,24.46,NULL,0.78,1755,NULL,NULL,'10 kpc behind Messier 031','MESSIER 032',NULL,'2004PASP..116..295W',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4831,'Red Clump','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4831,24.53,0.12,0.805,1755,NULL,NULL,NULL,'MESSIER 032',NULL,'2011ApJ...727...55M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4832,'RR Lyrae','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4832,24.26,0.12,0.711,1755,NULL,NULL,'V','MESSIER 032',NULL,'2013MNRAS.435.3206D',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4833,'RR Lyrae','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4833,24.33,0.47,0.735,1755,NULL,NULL,NULL,'MESSIER 032',NULL,'2012A&A...539A.138F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4834,'RR Lyrae','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4834,24.42,0.12,0.766,1755,NULL,NULL,NULL,'MESSIER 032',NULL,'2012MNRAS.425.1459S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4835,'RR Lyrae','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4835,24.49,0.19,0.791,1755,NULL,NULL,'Field 2','MESSIER 032',NULL,'2009AIPC.1170..216F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4836,'RR Lyrae','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4836,24.53,0.21,0.805,1755,NULL,NULL,'Field 1','MESSIER 032',NULL,'2009AIPC.1170..216F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4837,'RR Lyrae','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4837,24.53,0.21,0.805,1755,NULL,NULL,'17, E(B-V) 0.08','MESSIER 032',NULL,'2010ApJ...708..817F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4838,'RR Lyrae','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4838,24.56,0.21,0.817,1755,NULL,NULL,'17, E(B-V) 0.07','MESSIER 032',NULL,'2010ApJ...708..817F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4839,'RR Lyrae','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4839,24.72,0.21,0.879,1755,NULL,NULL,'17, E(B-V) 0.02','MESSIER 032',NULL,'2010ApJ...708..817F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4840,'SBF','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4840,24.17,0.14,0.682,1755,NULL,NULL,'K','MESSIER 032',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4841,'SBF','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4841,24.23,0.1,0.7,1755,NULL,NULL,'I','MESSIER 032',NULL,'1990AJ....100.1416T',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4842,'SBF','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4842,24.3,NULL,0.7,1755,NULL,NULL,'I','MESSIER 032',NULL,'1989ApJ...346L..57T',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4843,'SBF','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4843,24.25,0.2,0.71,1755,NULL,NULL,'I','MESSIER 032',NULL,'1998MmSAI..69..155B',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4844,'SBF','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4844,24.35,0.2,0.74,1755,NULL,NULL,'I','MESSIER 032',NULL,'1993A&A...275..433B',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4845,'SBF','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4845,24.38,0.11,0.75,1755,NULL,NULL,'I','MESSIER 032',NULL,'1991ApJ...373L...1T',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4846,'SBF','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4846,24.39,0.08,0.755,1755,NULL,NULL,'I','MESSIER 032',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4847,'SBF','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4847,24.45,0.08,0.78,1755,74.4,NULL,NULL,'MESSIER 032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4848,'SBF','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4848,24.47,0.05,0.783,1755,NULL,NULL,'I','MESSIER 032',NULL,'1997AJ....114..626A',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4849,'SBF','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4849,24.48,0.05,0.787,1755,NULL,NULL,'I','MESSIER 032',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4850,'SBF','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4850,24.51,0.09,0.798,1755,NULL,NULL,'K','MESSIER 032',NULL,'1994ApJ...433..567P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4851,'SBF','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4851,24.55,0.17,0.813,1755,NULL,NULL,'HST KP Calibrated, I','MESSIER 032',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4852,'SBF','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4852,24.55,0.08,0.813,1755,NULL,NULL,'I','MESSIER 032',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4853,'SBF','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4853,24.56,0.17,0.817,1755,NULL,NULL,'HST KP Calibrated, F814W','MESSIER 032',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4854,'SBF','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4854,24.6,NULL,0.83,1755,NULL,NULL,'I','MESSIER 032',NULL,'1988AJ.....96..807T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4855,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4855,24.11,0.2,0.664,1755,NULL,NULL,'I, m(I) = 20.15 mag','MESSIER 032',NULL,'1989AJ.....98.1285F',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4856,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4856,24.2,0.3,0.692,1755,NULL,NULL,'I, m(I) = 20.15 mag','MESSIER 032',NULL,'1992IAUS..149..169F',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4857,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4857,24.28,0.43,0.718,1755,NULL,NULL,'I','MESSIER 032',NULL,'2009ApJ...694.1331M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4858,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4858,24.3,0.2,0.724,1755,NULL,NULL,'I, m(I) = 20.50 mag','MESSIER 032',NULL,'1989AJ.....98.1285F',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4859,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4859,24.45,NULL,0.78,1755,NULL,NULL,NULL,'MESSIER 032',NULL,'1996AJ....112.1975G',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4860,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4860,24.45,0.08,0.78,1755,74.4,NULL,NULL,'MESSIER 032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4861,'TRGB','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4861,24.47,0.15,0.783,1755,NULL,NULL,NULL,'MESSIER 032',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4862,'Type II Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4862,24.33,NULL,0.735,1755,NULL,NULL,NULL,'MESSIER 032',NULL,'2012A&A...539A.138F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4863,'Statistical','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4863,24,NULL,0.631,1755,NULL,NULL,NULL,'MESSIER 032',NULL,'2000glg..book.....V',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4864,'Statistical','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4864,24.46,0.06,0.781,1755,NULL,NULL,NULL,'MESSIER 032',NULL,'2013MNRAS.430..971W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4865,'Tully est','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4865,24.23,0.8,0.7,1755,75,NULL,NULL,'MESSIER 032',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4866,'Tully-Fisher','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4866,25.6,NULL,1.32,1755,NULL,NULL,'LEDA [April 2006]','MESSIER 032',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4867,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4867,37.29,0.23,287,1756,70,NULL,NULL,'2MASX J00424193-0917312',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000095,NULL,'16.0g',0.45,'S0^-',NULL,NULL,NULL,NULL,1,10.674875,-9.292,0.096,NULL,34576637275,540259957,8441561,16),(4868,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4868,37.1,0.08,263,1757,70,NULL,NULL,'2MASX J00424226-0855282',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000081,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,10.676083,-8.92447,0.133,NULL,34576686745,540260730,8441573,16.6),(4869,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4869,37.54,0.13,322,1758,70,NULL,NULL,'2MASX J00424296+1515275',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000101,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,10.6789583,15.25764,0.165,NULL,67476200680,1054315635,16473681,16.5),(4870,'FP','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4870,37.1,0.08,263,1759,70,NULL,NULL,'2MASX J00424404-1000112',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000086,NULL,'17.5g',0.19,'E',NULL,NULL,NULL,NULL,1,10.6836666667,-10.00306,0.101,NULL,34562480825,540038762,8438105,17.5),(4871,'Carbon Stars','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4871,24.36,0.03,0.745,1760,NULL,NULL,'C-stars','MESSIER 031',NULL,'1995AJ....109.2480B',1995,1,190,NULL,'G',0.000013,NULL,'4.36',60,'SA(s)b         LINER','in a triple',NULL,NULL,NULL,1,10.6847917,41.26906,0.301,0,67673303333,1057395364,16521802,4.36),(4872,'Carbon Stars','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4872,24.45,0.15,0.78,1760,NULL,18.45,'LMC ZP','MESSIER 031',NULL,'1990ApJ...355..448R',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4873,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4873,23.93,0.24,0.611,1760,NULL,18.45,'LMC ZP','MESSIER 031',NULL,'2009AcA....59..403M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4874,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4874,24.05,0.15,0.646,1760,NULL,NULL,'34, VI','MESSIER 031',NULL,'1998AJ....115.1016K',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4875,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4875,24.15,0.2,0.676,1760,NULL,NULL,'V2, PL02, Z = 0.02','MESSIER 031',NULL,'2011ApJ...743...19C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4876,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4876,24.16,0.25,0.679,1760,NULL,NULL,'BV(W)','MESSIER 031',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4877,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4877,24.17,0.08,0.682,1760,NULL,18.47,'14, V, Photographic','MESSIER 031',NULL,'1987SAAOC..11..125W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4878,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4878,24.17,0.08,0.682,1760,NULL,18.47,'17, V, PLC, Photographic','MESSIER 031',NULL,'1987SAAOC..11..125W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4879,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4879,24.18,0.08,0.685,1760,NULL,18.47,'17, B, Photographic','MESSIER 031',NULL,'1987SAAOC..11..125W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4880,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4880,24.2,0.14,0.692,1760,NULL,NULL,'sixth spiral arm, south of nucleus, 20, BV','MESSIER 031',NULL,'1963AJ.....68..435B',1963,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4881,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4881,24.21,0.25,0.695,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'1984Ap&SS.107..167C',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4882,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4882,24.24,0.1,0.705,1760,NULL,NULL,'V2, Wes, Z = 0.008','MESSIER 031',NULL,'2011ApJ...743...19C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4883,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4883,24.26,0.08,0.711,1760,NULL,NULL,'7, H','MESSIER 031',NULL,'1986ApJ...305..583W',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4884,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4884,24.26,0.08,0.711,1760,NULL,18.46,'7, H','MESSIER 031',NULL,'1986PhDT........22W',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4885,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4885,24.26,0.14,0.711,1760,NULL,NULL,'20, BV','MESSIER 031',NULL,'1963AJ.....68..435B',1963,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4886,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4886,24.3,0.76,0.724,1760,NULL,NULL,'2, VI, Ultra Long Period Cepheids','MESSIER 031',NULL,'2015AJ....149...66N',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4887,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4887,24.3,0.03,0.724,1760,NULL,NULL,'30, BVRI','MESSIER 031',NULL,'1997ApJ...491...13K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4888,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4888,24.32,0.12,0.731,1760,NULL,NULL,'68, BV','MESSIER 031',NULL,'2010hsa5.conf..365V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4889,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4889,24.32,0.12,0.731,1760,NULL,NULL,'416, BV','MESSIER 031',NULL,'2007A&A...473..847V',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4890,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4890,24.32,0.09,0.731,1760,NULL,18.486,'174, BI, LMC PL Fouque et al. (2007)','MESSIER 031',NULL,'2015MNRAS.451..724W',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4891,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4891,24.33,0.12,0.735,1760,NULL,NULL,'BVRI, Baade\'s Field I','MESSIER 031',NULL,'1990ApJ...365..186F',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4892,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4892,24.34,0.1,0.738,1760,NULL,18.5,'174, BI, GAL PL Fouque et al. (2007)','MESSIER 031',NULL,'2015MNRAS.451..724W',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4893,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4893,24.34,NULL,0.738,1760,NULL,NULL,'Photographic, 17, V','MESSIER 031',NULL,'1985IzPul.201..104M',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4894,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4894,24.37,0.2,0.748,1760,NULL,NULL,'V5, PL, Z = 0.008','MESSIER 031',NULL,'2011ApJ...743...19C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4895,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4895,24.37,0.07,0.75,1760,NULL,NULL,'LMC W01','MESSIER 031',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4896,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4896,24.38,0.05,0.75,1760,NULL,NULL,'37, VI, KEY PROJECT','MESSIER 031',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4897,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4897,24.38,0.2,0.752,1760,NULL,NULL,'V5, PL02, Z = 0.02','MESSIER 031',NULL,'2011ApJ...743...19C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4898,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4898,24.38,0.05,0.752,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'1995AJ....109.2480B',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4899,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4899,24.38,0.05,0.752,1760,NULL,NULL,'LMC VIHJK','MESSIER 031',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4900,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4900,24.38,0.06,0.752,1760,NULL,NULL,'68, NIR, +/- 0.03 syst.','MESSIER 031',NULL,'2012ApJ...745..156R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4901,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4901,24.41,0.09,0.762,1760,NULL,NULL,'BVRI, Baade\'s Field III','MESSIER 031',NULL,'1990ApJ...365..186F',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4902,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4902,24.41,0.21,0.762,1760,NULL,NULL,'55, R','MESSIER 031',NULL,'2010A&A...512A..66J',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4903,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4903,24.41,0.2,0.762,1760,NULL,NULL,'V4, PL02, Z = 0.02','MESSIER 031',NULL,'2011ApJ...743...19C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4904,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4904,24.42,0.2,0.766,1760,NULL,NULL,'440, JHKs, GAL PL','MESSIER 031',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4905,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4905,24.42,0.2,0.766,1760,NULL,NULL,'V2, PL, Z = 0.008','MESSIER 031',NULL,'2011ApJ...743...19C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4906,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4906,24.42,0.1,0.766,1760,NULL,NULL,'V3, Wes, Z = 0.008','MESSIER 031',NULL,'2011ApJ...743...19C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4907,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4907,24.42,0.1,0.766,1760,NULL,NULL,'V2, Wes02, Z = 0.02','MESSIER 031',NULL,'2011ApJ...743...19C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4908,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4908,24.44,0.1,0.77,1760,NULL,NULL,'BVRI','MESSIER 031',NULL,'1991PASP..103..933M',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4909,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4909,24.42,0.06,0.77,1760,74.4,NULL,NULL,'MESSIER 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4910,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4910,24.44,NULL,0.773,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4911,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4911,24.44,0.1,0.773,1760,NULL,NULL,'HST KP Calibrated','MESSIER 031',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4912,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4912,24.44,NULL,0.773,1760,NULL,NULL,'BVRI','MESSIER 031',NULL,'1995A&A...301..776S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4913,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4913,24.44,0.07,0.773,1760,NULL,NULL,'MW HIPP','MESSIER 031',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4914,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4914,24.46,0.2,0.78,1760,NULL,NULL,'440, JHKs, mean of GAL PL and LMC PL','MESSIER 031',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4915,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4915,24.46,0.2,0.78,1760,NULL,NULL,'V5, OGLE HST','MESSIER 031',NULL,'2011ApJ...743...19C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4916,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4916,24.46,NULL,0.78,1760,NULL,NULL,'1, R','MESSIER 031',NULL,'2011AsUAI...4...20C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4917,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4917,24.47,0.05,0.783,1760,NULL,NULL,'30, BVRI +Z','MESSIER 031',NULL,'1997ApJ...491...13K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4918,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4918,24.47,0.23,0.783,1760,NULL,NULL,'MW P02','MESSIER 031',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4919,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4919,24.48,0.05,0.79,1760,NULL,NULL,'37, VI, +Z, KEY PROJECT','MESSIER 031',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4920,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4920,24.49,0.11,0.791,1760,NULL,NULL,'13, RI','MESSIER 031',NULL,'2003A&A...402..113J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4921,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4921,24.5,0.1,0.794,1760,NULL,NULL,'BV','MESSIER 031',NULL,'1991MNRAS.250..438M',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4922,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4922,24.5,0.08,0.794,1760,NULL,NULL,'MW GFG','MESSIER 031',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4923,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4923,24.5,0.1,0.794,1760,NULL,NULL,'V5, Wes, Z = 0.008','MESSIER 031',NULL,'2011ApJ...743...19C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4924,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4924,24.5,0.08,0.794,1760,NULL,NULL,'106, VI','MESSIER 031',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4925,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4925,24.5,0.19,0.794,1760,NULL,NULL,'440, JHKs, LMC PL','MESSIER 031',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4926,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4926,24.51,0.08,0.798,1760,NULL,18.486,'174, NIR, NGC 4258 PL Fouque et al. (2007)','MESSIER 031',NULL,'2015MNRAS.451..724W',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4927,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4927,24.52,0.2,0.802,1760,NULL,NULL,'V2, OGLE HST','MESSIER 031',NULL,'2011ApJ...743...19C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4928,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4928,24.54,0.07,0.809,1760,NULL,18.54,'LMC ZP','MESSIER 031',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4929,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4929,24.54,0.08,0.809,1760,NULL,NULL,'9, H','MESSIER 031',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4930,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4930,24.54,0.2,0.809,1760,NULL,NULL,'V4, PL, Z = 0.008','MESSIER 031',NULL,'2011ApJ...743...19C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4931,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4931,24.54,0.2,0.809,1760,NULL,NULL,'V3, PL02, Z = 0.02','MESSIER 031',NULL,'2011ApJ...743...19C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4932,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4932,24.54,0.08,0.809,1760,NULL,NULL,'9, H','MESSIER 031',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4933,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4933,24.56,0.07,0.817,1760,NULL,NULL,'Crowding, median','MESSIER 031',NULL,'2000AJ....120..810M',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4934,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4934,24.56,0.14,0.817,1760,NULL,NULL,'HST KP Calibrated, K\'','MESSIER 031',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4935,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4935,24.56,0.2,0.817,1760,NULL,NULL,'V3, PL, Z = 0.008','MESSIER 031',NULL,'2011ApJ...743...19C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4936,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4936,24.56,NULL,0.817,1760,NULL,NULL,'BVRI +Z','MESSIER 031',NULL,'1995A&A...301..776S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4937,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4937,24.57,0.05,0.82,1760,NULL,NULL,'Z','MESSIER 031',NULL,'1994ApJ...426..542G',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4938,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4938,24.58,0.12,0.824,1760,NULL,NULL,'BVRI, Baade\'s Field IV','MESSIER 031',NULL,'1990ApJ...365..186F',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4939,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4939,24.59,0.02,0.828,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'1997AJ....113...13B',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4940,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4940,24.6,0.2,0.832,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'1998A&A...339..671P',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4941,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4941,24.62,0.1,0.839,1760,NULL,NULL,'V3, Wes02, Z = 0.02','MESSIER 031',NULL,'2011ApJ...743...19C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4942,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4942,24.62,0.07,0.839,1760,NULL,NULL,'Crowding, mean','MESSIER 031',NULL,'2000AJ....120..810M',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4943,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4943,24.63,0.2,0.843,1760,NULL,NULL,'V4, OGLE HST','MESSIER 031',NULL,'2011ApJ...743...19C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4944,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4944,24.65,0.2,0.851,1760,NULL,NULL,'V3, OGLE HST','MESSIER 031',NULL,'2011ApJ...743...19C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4945,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4945,24.7,0.1,0.871,1760,NULL,NULL,'V5, Wes02, Z = 0.02','MESSIER 031',NULL,'2011ApJ...743...19C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4946,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4946,24.73,0.1,0.883,1760,NULL,NULL,'V4, Wes, Z = 0.008','MESSIER 031',NULL,'2011ApJ...743...19C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4947,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4947,24.77,0.11,0.899,1760,NULL,NULL,'Hipparcos','MESSIER 031',NULL,'1997MNRAS.286L...1F',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4948,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4948,24.8,0.04,0.912,1760,73,NULL,'Cepheids magnitudes Gaussian, Data 3','MESSIER 031',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4949,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4949,24.84,0.03,0.929,1760,NULL,NULL,'BVRI','MESSIER 031',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4950,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4950,24.9,0.03,0.955,1760,NULL,NULL,'BVRI+','MESSIER 031',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4951,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4951,24.91,0.05,0.959,1760,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian, Data 3','MESSIER 031',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4952,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4952,24.92,0.1,0.964,1760,NULL,NULL,'V4, Wes02, Z = 0.02','MESSIER 031',NULL,'2011ApJ...743...19C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4953,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4953,24.94,0.09,0.973,1760,NULL,NULL,'9, I','MESSIER 031',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4954,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4954,24.94,0.09,0.973,1760,NULL,NULL,'9, I','MESSIER 031',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4955,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4955,24.95,NULL,0.977,1760,NULL,NULL,'Photographic, APPARENT BLUE m-M','MESSIER 031',NULL,'1988PASP..100..935S',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4956,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4956,24.95,0.08,0.977,1760,73,NULL,'Cepheids periods Gaussian, Data 3','MESSIER 031',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4957,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4957,25.16,0.22,1.08,1760,73,NULL,'Cepheids periods Gaussian, Data 1 ','MESSIER 031',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4958,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4958,25.2,0.6,1.1,1760,NULL,NULL,'1, V','MESSIER 031',NULL,'2004ASPC..310...95B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4959,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4959,25.23,0.17,1.11,1760,NULL,NULL,'9, V','MESSIER 031',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4960,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4960,25.23,0.17,1.11,1760,NULL,NULL,'9, V','MESSIER 031',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4961,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4961,25.27,0.15,1.13,1760,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian, Data 1 ','MESSIER 031',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4962,'Cepheids','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',4962,25.39,0.05,1.2,1760,73,NULL,'Cepheids magnitudes Gaussian, Data 1 ','MESSIER 031',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4963,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4963,23.91,0.06,0.605,1760,NULL,NULL,'2MASXi J0050424+325459, NPM1G +32.0027, [MII2006] GC 1, MGC1, Bol 520','MESSIER 031',NULL,'2010MNRAS.401..533M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4964,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4964,24,0.06,0.631,1760,NULL,NULL,'2MASXi J0050424+325459, NPM1G +32.0027, [MII2006] GC 1, MGC1, Bol 520','MESSIER 031',NULL,'2010MNRAS.401..533M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4965,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4965,24.13,0.13,0.67,1760,NULL,NULL,'MESSIER 031:[MHF2007] GC07, M31 m-M = 24.47','MESSIER 031',NULL,'2007ApJ...655L..85M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4966,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4966,24.2,0.13,0.692,1760,NULL,18.51,'Bol 338, fitted parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4967,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4967,24.2,0.1,0.692,1760,NULL,18.54,'MCGC7-H14','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4968,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4968,24.22,0.14,0.698,1760,NULL,NULL,'MESSIER 031:[MHF2007] GC09, M31 m-M = 24.47','MESSIER 031',NULL,'2007ApJ...655L..85M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4969,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4969,24.25,0.2,0.708,1760,NULL,NULL,'SKHV 062, Bol 010','MESSIER 031',NULL,'2009A&A...507.1375P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4970,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4970,24.25,0.1,0.708,1760,NULL,18.54,'Bol 379','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4971,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4971,24.25,0.1,0.708,1760,NULL,18.54,'MCGC9-H24','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4972,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4972,24.26,NULL,0.711,1760,NULL,18.54,'Bol 023','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4973,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4973,24.3,0.1,0.724,1760,NULL,18.54,'Bol 010','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4974,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4974,24.3,0.1,0.724,1760,NULL,18.54,'MCGC2-H4','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4975,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4975,24.3,0.13,0.724,1760,NULL,18.51,'Bol 386, fitted parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4976,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4976,24.3,0.18,0.724,1760,NULL,18.51,'Bol 311, fixed parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4977,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4977,24.3,0.18,0.724,1760,NULL,18.51,'Bol 012, fixed parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4978,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4978,24.31,0.14,0.728,1760,NULL,NULL,'MESSIER 031:[MHF2006a] EC04','MESSIER 031',NULL,'2006ApJ...653L.105M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4979,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4979,24.31,0.1,0.728,1760,NULL,18.54,'Bol 012','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4980,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4980,24.31,0.1,0.728,1760,NULL,18.54,'Bol 311','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4981,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4981,24.32,0.1,0.731,1760,NULL,18.54,'Bol 338','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4982,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4982,24.32,0.14,0.731,1760,NULL,NULL,'MESSIER 031:[MHF2007] GC02, M31 m-M = 24.47','MESSIER 031',NULL,'2007ApJ...655L..85M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4983,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4983,24.33,0.1,0.735,1760,NULL,18.54,'B531','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4984,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4984,24.33,0.1,0.735,1760,NULL,18.54,'MCEC4-HEC12','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4985,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4985,24.34,0.1,0.738,1760,NULL,18.54,'Bol 240','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4986,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4986,24.35,0.1,0.741,1760,NULL,18.54,'Bol 058','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4987,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4987,24.35,0.1,0.741,1760,NULL,18.54,'Bol 407','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4988,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4988,24.35,0.1,0.741,1760,NULL,18.54,'MCGC3-H5','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4989,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4989,24.35,0.14,0.741,1760,NULL,NULL,'Bol 514, M31 m-M = 24.47','MESSIER 031',NULL,'2007ApJ...655L..85M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4990,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4990,24.35,0.13,0.741,1760,NULL,18.51,'Bol 058, fitted parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4991,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4991,24.35,0.18,0.741,1760,NULL,18.51,'Bol 338, fixed parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4992,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4992,24.35,0.18,0.741,1760,NULL,18.51,'Bol 058, fixed parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4993,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4993,24.36,0.13,0.745,1760,NULL,18.51,'Bol 233, fitted parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4994,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4994,24.37,0.15,0.748,1760,NULL,NULL,'MESSIER 031:[MHF2007] GC03, M31 m-M = 24.47','MESSIER 031',NULL,'2007ApJ...655L..85M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4995,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4995,24.38,0.1,0.752,1760,NULL,18.54,'Bol D255','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4996,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4996,24.39,0.2,0.755,1760,NULL,NULL,'SKHV 291, Bol 366','MESSIER 031',NULL,'2009A&A...507.1375P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4997,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4997,24.39,0.14,0.755,1760,NULL,NULL,'MESSIER 031:[MHF2006a] EC02','MESSIER 031',NULL,'2006ApJ...653L.105M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4998,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4998,24.4,0.13,0.759,1760,NULL,18.51,'Bol 012, fitted parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4999,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,4999,24.4,0.18,0.759,1760,NULL,18.51,'Bol 240, fixed parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5000,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5000,24.4,0.18,0.759,1760,NULL,18.51,'Bol 225, fixed parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5001,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5001,24.4,0.2,0.759,1760,NULL,NULL,'SKHV 275, Bol 220','MESSIER 031',NULL,'2009A&A...507.1375P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5002,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5002,24.4,0.2,0.759,1760,NULL,NULL,'SKHV 280, Bol 225','MESSIER 031',NULL,'2009A&A...507.1375P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5003,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5003,24.4,0.2,0.759,1760,NULL,NULL,'Bol D255','MESSIER 031',NULL,'2009A&A...507.1375P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5004,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5004,24.4,0.2,0.759,1760,NULL,NULL,'MAYALL V, Bol 407','MESSIER 031',NULL,'2009A&A...507.1375P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5005,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5005,24.4,0.1,0.759,1760,NULL,18.54,'Bol 337','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5006,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5006,24.41,0.2,0.762,1760,NULL,NULL,'2MASXi J0042210+413214, Bol 088','MESSIER 031',NULL,'2009A&A...507.1375P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5007,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5007,24.41,0.14,0.762,1760,NULL,NULL,'Bol 515, M31 m-M = 24.47','MESSIER 031',NULL,'2007ApJ...655L..85M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5008,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5008,24.42,0.2,0.765,1760,NULL,NULL,'avg of 11 GCs','MESSIER 031',NULL,'2009A&A...507.1375P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5009,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5009,24.42,0.18,0.766,1760,NULL,18.51,'Bol 233, fixed parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5010,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5010,24.42,0.15,0.766,1760,NULL,NULL,'MESSIER 031:[MHF2006a] EC01','MESSIER 031',NULL,'2006ApJ...653L.105M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5011,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5011,24.42,0.14,0.766,1760,NULL,NULL,'MESSIER 031:[MHF2007] GC10, M31 m-M = 24.47','MESSIER 031',NULL,'2007ApJ...655L..85M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5012,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5012,24.42,NULL,0.766,1760,NULL,18.54,'Bol 158','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5013,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5013,24.42,0.1,0.766,1760,NULL,18.54,'MCEC3-HEC4','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5014,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5014,24.42,NULL,0.766,1760,NULL,18.54,'MEAN OF 48 Globular Clusters','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5015,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5015,24.43,0.2,0.769,1760,NULL,NULL,'SKHV 213, Bol 158','MESSIER 031',NULL,'2009A&A...507.1375P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5016,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5016,24.43,0.1,0.769,1760,NULL,18.54,'Bol 233','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5017,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5017,24.43,NULL,0.769,1760,NULL,NULL,'Bol 351','MESSIER 031',NULL,'2011A&A...531A.155P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5018,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5018,24.43,NULL,0.769,1760,NULL,NULL,'SKHV 010, Bol 292','MESSIER 031',NULL,'2011A&A...531A.155P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5019,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5019,24.43,NULL,0.769,1760,NULL,NULL,'SKHV 068, Bol 337','MESSIER 031',NULL,'2011A&A...531A.155P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5020,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5020,24.43,0.14,0.769,1760,NULL,NULL,'MESSIER 031:[MHF2007] GC08, M31 m-M = 24.47','MESSIER 031',NULL,'2007ApJ...655L..85M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5021,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5021,24.43,0.13,0.769,1760,NULL,18.51,'Bol 384, fitted parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5022,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,'R',5022,24.44,0.1,0.773,1760,NULL,NULL,'SKHV 312, Bol 379','MESSIER 031',NULL,'2013IAUS..289..398M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5023,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5023,24.44,0.18,0.773,1760,NULL,18.51,'Bol 379, fixed parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5024,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5024,24.44,0.19,0.773,1760,NULL,18.51,'19 GCs avg.','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5025,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5025,24.44,0.1,0.773,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'2010PASP..122.1164M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5026,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5026,24.44,0.1,0.773,1760,NULL,18.54,'Bol 088','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5027,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5027,24.44,0.1,0.773,1760,NULL,18.54,'Bol 293','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5028,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5028,24.45,0.1,0.776,1760,NULL,18.54,'Bol 008','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5029,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5029,24.45,NULL,0.776,1760,NULL,18.54,'Bol 224','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5030,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5030,24.45,0.1,0.776,1760,NULL,18.54,'Bol 350','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5031,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5031,24.45,0.1,0.776,1760,NULL,18.54,'Bol 468','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5032,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5032,24.45,0.1,0.776,1760,NULL,18.54,'MCGC1-B520','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5033,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5033,24.45,NULL,0.776,1760,NULL,NULL,'SKHV 162, Bol 350','MESSIER 031',NULL,'2011A&A...531A.155P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5034,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5034,24.45,NULL,0.776,1760,NULL,NULL,'SKHV 067, Bol 336','MESSIER 031',NULL,'2011A&A...531A.155P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5035,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5035,24.45,0.15,0.776,1760,NULL,NULL,'MESSIER 031:[MHF2007] GC05, M31 m-M = 24.47','MESSIER 031',NULL,'2007ApJ...655L..85M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5036,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5036,24.46,0.1,0.78,1760,NULL,NULL,'SKHV 011, Bol 293','MESSIER 031',NULL,'2013ApJ...765...71C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5037,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5037,24.46,0.13,0.78,1760,NULL,18.51,'Bol 030, fitted parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5038,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5038,24.46,0.1,0.78,1760,NULL,18.54,'Bol 384','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5039,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5039,24.46,0.1,0.78,1760,NULL,18.54,'Bol 386','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5040,'CMD','2016-12-15 15:13:34','2016-12-16 11:18:36','1',NULL,NULL,5040,24.47,0.2,0.783,1760,NULL,NULL,'SKHV 060, Bol 008','MESSIER 031',NULL,'2009A&A...507.1375P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5041,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5041,24.47,0.2,0.783,1760,NULL,NULL,'SKHV 279, Bol 224','MESSIER 031',NULL,'2009A&A...507.1375P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5042,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5042,24.47,0.07,0.783,1760,NULL,NULL,'GC PAndAS-7, fiducial isochrone','MESSIER 031',NULL,'2013MNRAS.429..281M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5043,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5043,24.47,0.1,0.783,1760,NULL,18.51,'14 GCs avg.','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5044,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5044,24.47,0.14,0.783,1760,NULL,NULL,'MESSIER 031:[MHF2006a] EC03','MESSIER 031',NULL,'2006ApJ...653L.105M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5045,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5045,24.47,0.03,0.783,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'2003AJ....126.1312W',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5046,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5046,24.48,0.1,0.787,1760,NULL,18.54,'Bol 220','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5047,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5047,24.48,0.1,0.787,1760,NULL,18.54,'Bol 514','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5048,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5048,24.48,0.1,0.787,1760,NULL,18.54,'MCEC1-HEC5','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5049,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5049,24.48,0.13,0.787,1760,NULL,18.51,'Bol 468, fitted parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5050,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5050,24.48,0.18,0.787,1760,NULL,18.51,'Bol 293, fixed parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5051,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5051,24.49,0.15,0.791,1760,NULL,NULL,'SKHV 021, Bol 298, M31 m-M = 24.47','MESSIER 031',NULL,'2007ApJ...655L..85M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5052,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5052,24.49,0.1,0.791,1760,NULL,18.54,'Bol 298','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5053,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5053,24.5,0.1,0.794,1760,NULL,18.54,'Bol 292','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5054,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5054,24.5,0.1,0.794,1760,NULL,18.54,'Bol 336','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5055,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5055,24.5,0.1,0.794,1760,NULL,18.54,'MCGC5-H10','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5056,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5056,24.5,0.1,0.794,1760,NULL,18.54,'MCGC10-H27','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5057,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5057,24.5,0.18,0.794,1760,NULL,18.51,'Bol 386, fixed parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5058,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5058,24.5,0.18,0.794,1760,NULL,18.51,'Bol 468, fixed parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5059,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5059,24.51,0.1,0.798,1760,NULL,18.54,'MCEC2-HEC7','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5060,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5060,24.52,0.13,0.802,1760,NULL,18.51,'Bol 293, fitted parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5061,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5061,24.52,0.13,0.802,1760,NULL,18.51,'Bol 358, fitted parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5062,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5062,24.52,NULL,0.802,1760,NULL,18.54,'Bol 027','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5063,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5063,24.53,0.1,0.805,1760,NULL,18.54,'Bol 366','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5064,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5064,24.53,0.1,0.805,1760,NULL,18.54,'MCGC8-H23','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5065,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5065,24.53,0.13,0.805,1760,NULL,18.51,'Bol 311, fitted parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5066,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5066,24.53,0.13,0.805,1760,NULL,18.51,'Bol 379, fitted parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5067,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5067,24.53,0.13,0.805,1760,NULL,18.51,'Bol 225, fitted parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5068,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5068,24.55,0.1,0.813,1760,NULL,NULL,'Messier 031 East Cloud GC Messier 092','MESSIER 031',NULL,'2016MNRAS.456..405M',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5069,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5069,24.55,0.1,0.813,1760,NULL,NULL,'Messier 031 East Cloud GC Palomar 12','MESSIER 031',NULL,'2016MNRAS.456..405M',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5070,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5070,24.55,0.05,0.813,1760,NULL,NULL,'Messier 031 East Cloud mean of 4 GCs','MESSIER 031',NULL,'2016MNRAS.456..405M',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5071,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5071,24.55,0.13,0.813,1760,NULL,18.51,'Bol 027, fitted parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5072,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5072,24.55,0.13,0.813,1760,NULL,18.51,'Bol 045, fitted parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5073,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5073,24.55,0.18,0.813,1760,NULL,18.51,'Bol 027, fixed parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5074,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5074,24.55,0.18,0.813,1760,NULL,18.51,'Bol 384, fixed parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5075,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5075,24.55,0.18,0.813,1760,NULL,18.51,'Bol 030, fixed parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5076,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5076,24.55,0.18,0.813,1760,NULL,18.51,'Bol 045, fixed parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5077,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5077,24.55,0.1,0.813,1760,NULL,18.54,'Bol 045','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5078,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5078,24.55,NULL,0.813,1760,NULL,18.54,'Bol 225','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5079,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5079,24.56,0.18,0.817,1760,NULL,18.51,'Bol 006, fixed parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5080,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5080,24.56,0.1,0.817,1760,NULL,18.54,'Bol 006','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5081,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5081,24.56,0.1,0.817,1760,NULL,18.54,'MAYALL II','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5082,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5082,24.57,0.2,0.82,1760,NULL,NULL,'2MASXi J0041011+411346, Bol 023','MESSIER 031',NULL,'2009A&A...507.1375P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5083,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5083,24.57,0.13,0.82,1760,NULL,18.51,'Bol 006, fitted parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5084,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5084,24.58,0.07,0.824,1760,NULL,NULL,'GC PAndAS-8, fiducial isochrone','MESSIER 031',NULL,'2013MNRAS.429..281M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5085,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5085,24.58,0.18,0.824,1760,NULL,18.51,'Bol 358, fixed parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5086,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5086,24.6,0.1,0.832,1760,NULL,NULL,'Messier 031 East Cloud GC Terzan 7','MESSIER 031',NULL,'2016MNRAS.456..405M',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5087,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5087,24.6,0.13,0.832,1760,NULL,18.51,'Bol 240, fitted parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5088,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5088,24.6,0.1,0.832,1760,NULL,18.54,'Bol 405','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5089,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5089,24.61,0.1,0.836,1760,NULL,18.54,'Bol 343','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5090,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5090,24.62,0.1,0.839,1760,NULL,18.54,'Bol 358','MESSIER 031',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5091,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5091,24.63,0.1,0.843,1760,NULL,NULL,'Messier 031 East Cloud GC Messier 053','MESSIER 031',NULL,'2016MNRAS.456..405M',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5092,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5092,24.68,0.13,0.863,1760,NULL,18.51,'Bol 343, fitted parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5093,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5093,24.68,0.18,0.863,1760,NULL,18.51,'Bol 343, fixed parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5094,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5094,24.68,0.18,0.863,1760,NULL,18.51,'Bol 405, fixed parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5095,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5095,24.7,NULL,0.871,1760,NULL,NULL,'GC PAndAS-7, 2.0 Gyr isochrone','MESSIER 031',NULL,'2013MNRAS.429..281M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5096,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5096,24.73,0.13,0.883,1760,NULL,18.51,'Bol 405, fitted parameters','MESSIER 031',NULL,'2005AJ....129.2670R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5097,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5097,24.8,NULL,0.912,1760,NULL,NULL,'GC PAndAS-8, 2.0 Gyr isochrone','MESSIER 031',NULL,'2013MNRAS.429..281M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5098,'FGLR','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5098,24.47,NULL,0.783,1760,NULL,18.45,NULL,'MESSIER 031',NULL,'2008ApJ...681..269K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5099,'GCLF','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5099,24.03,0.23,0.64,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'1997ApJ...487..667O',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5100,'GCLF','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5100,24.27,0.15,0.714,1760,NULL,NULL,'TOM(V) = -7.29 mag, t5 function','MESSIER 031',NULL,'1992AJ....104.1472S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5101,'GCLF','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5101,24.34,0.3,0.738,1760,NULL,NULL,'HST KP Calibrated, V','MESSIER 031',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5102,'GCLF','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5102,24.6,0.15,0.832,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'1994AJ....107..555R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5103,'GC SBF','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5103,24.56,0.12,0.817,1760,NULL,NULL,'GC SBF','MESSIER 031',NULL,'1996AJ....111.1110A',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5104,'GC SBF','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5104,24.6,0.12,0.832,1760,NULL,NULL,'MRK 0959, SKHV 219, Bol 358, GC SBF, V','MESSIER 031',NULL,'1996AJ....111.1110A',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5105,'Horizontal Branch','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5105,24.2,0.09,0.692,1760,NULL,NULL,'V','MESSIER 031',NULL,'2013MNRAS.435.3206D',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5106,'Horizontal Branch','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5106,24.4,0.6,0.759,1760,NULL,NULL,'M(V)HB = +0.6 mag','MESSIER 031',NULL,'1995AJ....109.2050C',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5107,'Horizontal Branch','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5107,24.43,0.16,0.769,1760,NULL,NULL,'Blue HB','MESSIER 031',NULL,'1998MNRAS.296..739G',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5108,'Horizontal Branch','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5108,24.51,0.14,0.798,1760,NULL,NULL,'Red HB','MESSIER 031',NULL,'1998MNRAS.296..739G',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5109,'Novae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5109,24,0.15,0.631,1760,NULL,NULL,'Photographic','MESSIER 031',NULL,'1993ApJ...415...10d',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5110,'Novae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5110,24.27,0.2,0.714,1760,NULL,NULL,'40','MESSIER 031',NULL,'1989AJ.....97.1622C',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5111,'Novae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5111,24.35,0.2,0.741,1760,NULL,NULL,'40','MESSIER 031',NULL,'1985ApJ...292...90C',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5112,'PNLF','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5112,24.14,0.2,0.673,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'1992ApJ...389...27D',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5113,'PNLF','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5113,24.3,0.15,0.724,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'1989ApJ...339...53C',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5114,'PNLF','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5114,24.36,0.13,0.745,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5115,'PNLF','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5115,24.45,0.13,0.776,1760,NULL,NULL,'HST KP Calibrated','MESSIER 031',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5116,'PNLF','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5116,24.46,0.06,0.78,1760,NULL,NULL,'I','MESSIER 031',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5117,'PAGB Stars','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5117,24.2,NULL,0.692,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'2001ASSL..265...77B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5118,'Red Clump','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5118,24.45,0.14,0.776,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'2011ApJ...727...55M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5119,'Red Clump','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5119,24.45,0.06,0.776,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'2005ApJ...622L.109F',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5120,'Red Clump','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5120,24.47,0.04,0.784,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'1998ApJ...503L.131S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5121,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5121,24.2,NULL,0.692,1760,NULL,18.45,'7','MESSIER 031',NULL,'1986gddu.work...35P',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5122,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5122,24.23,0.15,0.701,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'1988ApJ...331..135P',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5123,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5123,24.23,NULL,0.701,1760,NULL,18.45,NULL,'MESSIER 031',NULL,'1987ARA&A..25..345F',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5124,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5124,24.24,0.08,0.705,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'1989A&A...209..154C',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5125,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5125,24.24,0.09,0.705,1760,NULL,NULL,'V','MESSIER 031',NULL,'2013MNRAS.435.3206D',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5126,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5126,24.25,0.71,0.708,1760,NULL,18.19,NULL,'MESSIER 031',NULL,'1992MmSAI..63..409C',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5127,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5127,24.3,0.3,0.724,1760,NULL,NULL,'K','MESSIER 031',NULL,'1991ASPC...14..115C',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5128,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5128,24.31,NULL,0.728,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5129,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5129,24.32,0.12,0.731,1760,NULL,NULL,'V','MESSIER 031',NULL,'2013MNRAS.435.3206D',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5130,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5130,24.35,0.15,0.74,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'1987ApJ...316..517P',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5131,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5131,24.36,0.4,0.745,1760,NULL,NULL,'halo 21','MESSIER 031',NULL,'2011AJ....141..171J',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5132,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5132,24.38,0.27,0.752,1760,NULL,NULL,'halo 35b','MESSIER 031',NULL,'2011AJ....141..171J',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5133,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5133,24.41,0.12,0.762,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'2012MNRAS.425.1459S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5134,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5134,24.44,NULL,0.773,1760,NULL,NULL,'RR','MESSIER 031',NULL,'1992MmSAI..63..331L',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5135,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5135,24.45,NULL,0.776,1760,NULL,NULL,'Fe/H = -1.5','MESSIER 031',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5136,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5136,24.46,0.11,0.78,1760,NULL,NULL,'555 RRab, 126 RRc','MESSIER 031',NULL,'2009AJ....138..184S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5137,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5137,24.48,0.11,0.787,1760,NULL,NULL,'RRab','MESSIER 031',NULL,'2004AJ....127.2738B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5138,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5138,24.48,0.15,0.787,1760,NULL,NULL,'halo 11','MESSIER 031',NULL,'2011AJ....141..171J',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5139,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5139,24.49,0.17,0.791,1760,NULL,NULL,'disk','MESSIER 031',NULL,'2011AJ....141..171J',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5140,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5140,24.49,0.19,0.791,1760,NULL,NULL,'14, E(B-V) 0.08','MESSIER 031',NULL,'2010ApJ...708..817F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5141,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5141,24.5,0.1,0.794,1760,NULL,NULL,'RRab + RRc avg.','MESSIER 031',NULL,'2004AJ....127.2738B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5142,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5142,24.51,0.11,0.798,1760,NULL,NULL,'RRc','MESSIER 031',NULL,'2004AJ....127.2738B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5143,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5143,24.52,0.19,0.802,1760,NULL,NULL,'stream','MESSIER 031',NULL,'2011AJ....141..171J',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5144,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5144,24.52,0.08,0.802,1760,NULL,18.52,'2MASX J00310983+3753596, Bol 514, 89','MESSIER 031',NULL,'2009ApJ...704L.103C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5145,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5145,24.54,0.07,0.809,1760,NULL,NULL,'Z','MESSIER 031',NULL,'1994ApJ...426..542G',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5146,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5146,24.56,NULL,0.817,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5147,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5147,24.59,0.19,0.828,1760,NULL,NULL,'14, E(B-V) 0.02','MESSIER 031',NULL,'2010ApJ...708..817F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5148,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5148,24.6,NULL,0.832,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'2008ApJ...679...52T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5149,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5149,24.64,0.19,0.847,1760,NULL,NULL,'14, E(B-V) 0.03','MESSIER 031',NULL,'2010ApJ...708..817F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5150,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5150,24.67,NULL,0.859,1760,NULL,NULL,'Fe/H = -1.5','MESSIER 031',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5151,'S Doradus Stars','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5151,24.4,NULL,0.759,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'1989A&A...217...87W',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5152,'SBF','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5152,24.24,0.08,0.705,1760,NULL,NULL,'I','MESSIER 031',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5153,'SBF','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5153,24.38,0.05,0.752,1760,NULL,NULL,'I','MESSIER 031',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5154,'SBF','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5154,24.39,0.05,0.755,1760,NULL,NULL,'I','MESSIER 031',NULL,'1997AJ....114..626A',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5155,'SBF','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5155,24.4,0.08,0.759,1760,NULL,NULL,'I','MESSIER 031',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5156,'SBF','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5156,24.43,0.14,0.769,1760,NULL,NULL,'K','MESSIER 031',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5157,'SBF','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5157,24.43,0.1,0.769,1760,NULL,NULL,'K','MESSIER 031',NULL,'1996ApJ...468..519J',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5158,'SBF','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5158,24.43,0.08,0.77,1760,NULL,NULL,'I','MESSIER 031',NULL,'1997ApJ...475..399T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5159,'SBF','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5159,24.42,0.06,0.77,1760,74.4,NULL,NULL,'MESSIER 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5160,'SBF','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5160,24.44,0.09,0.773,1760,NULL,NULL,'K','MESSIER 031',NULL,'1994ApJ...433..567P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5161,'SBF','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5161,24.46,0.14,0.78,1760,NULL,NULL,'HST KP Calibrated, I','MESSIER 031',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5162,'SBF','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5162,24.46,0.12,0.78,1760,NULL,NULL,'I','MESSIER 031',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5163,'SBF','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5163,24.46,0.08,0.78,1760,NULL,NULL,'I','MESSIER 031',NULL,'1991ApJ...373L...1T',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5164,'SBF','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5164,24.84,0.15,0.929,1760,NULL,NULL,'HST KP Calibrated, F814W','MESSIER 031',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5165,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5165,23.98,0.17,0.625,1760,NULL,NULL,'MAYALL VI, SKHV 327','MESSIER 031',NULL,'1998AJ....115.1916H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5166,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5166,24,0.2,0.63,1760,NULL,NULL,'2MASXi J0050424+325459, NPM1G +32.0027, [MII2006] GC 1, MGC1, Bol 520','MESSIER 031',NULL,'2006MNRAS.371.1983M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5167,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5167,24.18,0.11,0.685,1760,NULL,NULL,'MRK 0959, SKHV 219, Bol 358','MESSIER 031',NULL,'1998AJ....115.1916H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5168,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5168,24.23,0.1,0.701,1760,NULL,NULL,'SKHV 302, Bol 240','MESSIER 031',NULL,'1998AJ....115.1916H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5169,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5169,24.3,0.2,0.724,1760,NULL,NULL,'TRGB(Sobel)','MESSIER 031',NULL,'1994MNRAS.271..852M',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5170,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5170,24.31,0.12,0.728,1760,NULL,NULL,'SKHV 323, Bol 387','MESSIER 031',NULL,'1998AJ....115.1916H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5171,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5171,24.34,0.15,0.737,1760,NULL,NULL,'North to South Field 4','MESSIER 031',NULL,'2014MNRAS.437.3362B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5172,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5172,24.35,0.32,0.741,1760,NULL,NULL,'SKHV 105, Bol 343','MESSIER 031',NULL,'1998AJ....115.1916H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5173,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5173,24.36,0.08,0.745,1760,NULL,NULL,'Field B23','MESSIER 031',NULL,'2014AJ....148....7W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5174,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5174,24.37,0.08,0.748,1760,NULL,NULL,'I','MESSIER 031',NULL,'2007ApJ...661..815R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5175,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5175,24.39,0.09,0.755,1760,NULL,NULL,'SKHV 058, Bol 006','MESSIER 031',NULL,'1998AJ....115.1916H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5176,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5176,24.4,0.1,0.758,1760,NULL,NULL,'North to South Field 1','MESSIER 031',NULL,'2014MNRAS.437.3362B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5177,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5177,24.4,0.08,0.759,1760,NULL,NULL,'Field B01','MESSIER 031',NULL,'2014AJ....148....7W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5178,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5178,24.4,0.08,0.759,1760,NULL,NULL,'Field B05','MESSIER 031',NULL,'2014AJ....148....7W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5179,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5179,24.4,0.08,0.759,1760,NULL,NULL,'Field B09','MESSIER 031',NULL,'2014AJ....148....7W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5180,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5180,24.4,0.08,0.759,1760,NULL,NULL,'Field B13','MESSIER 031',NULL,'2014AJ....148....7W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5181,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5181,24.4,0.08,0.759,1760,NULL,NULL,'Field B19','MESSIER 031',NULL,'2014AJ....148....7W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5182,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5182,24.4,0.25,0.759,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'1986ApJ...305..591M',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5183,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5183,24.4,0.57,0.759,1760,NULL,NULL,'SKHV 108, Bol 045','MESSIER 031',NULL,'1998AJ....115.1916H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5184,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5184,24.4,0.15,0.76,1760,NULL,NULL,'And NE','MESSIER 031',NULL,'2004ApJ...612L.117Z',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5185,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5185,24.42,0.22,0.766,1760,NULL,NULL,'SKHV 312, Bol 379','MESSIER 031',NULL,'1998AJ....115.1916H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5186,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5186,24.42,0.06,0.77,1760,74.4,NULL,NULL,'MESSIER 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5187,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5187,24.44,0.1,0.773,1760,NULL,NULL,'I','MESSIER 031',NULL,'1993ApJ...417..553L',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5188,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5188,24.45,0.06,0.775,1760,NULL,NULL,'SE quarter','MESSIER 031',NULL,'2012ApJ...758...11C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5189,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5189,24.45,0.2,0.776,1760,NULL,NULL,'I, Z','MESSIER 031',NULL,'1995AJ....109.2050C',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5190,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5190,24.45,0.19,0.776,1760,NULL,NULL,'HST KP Calibrated','MESSIER 031',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5191,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5191,24.46,0.05,0.779,1760,NULL,NULL,'M31 center','MESSIER 031',NULL,'2012ApJ...758...11C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5192,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5192,24.46,0.05,0.781,1760,NULL,NULL,'SW quarter','MESSIER 031',NULL,'2012ApJ...758...11C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5193,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5193,24.47,0.05,0.782,1760,NULL,NULL,'NE quarter','MESSIER 031',NULL,'2012ApJ...758...11C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5194,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5194,24.47,0.05,0.782,1760,NULL,NULL,'NW quarter','MESSIER 031',NULL,'2012ApJ...758...11C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5195,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5195,24.47,0.12,0.783,1760,NULL,NULL,'I','MESSIER 031',NULL,'2001AJ....121.2557D',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5196,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5196,24.47,0.11,0.783,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5197,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5197,24.44,NULL,0.783,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'2010ApJ...708.1168T',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5198,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5198,24.44,NULL,0.783,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'2010ApJ...708.1168T',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5199,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5199,24.47,0.07,0.783,1760,NULL,NULL,'M31 GCs','MESSIER 031',NULL,'1998AJ....115.1916H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5200,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5200,24.47,NULL,0.783,1760,NULL,NULL,'theory','MESSIER 031',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5201,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5201,24.47,0.07,0.785,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'2005MNRAS.356..979M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5202,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5202,24.49,0.23,0.791,1760,NULL,NULL,'SKHV 319, Bol 384','MESSIER 031',NULL,'1998AJ....115.1916H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5203,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5203,24.5,0.12,0.793,1760,NULL,NULL,'4 Field avg.','MESSIER 031',NULL,'2014MNRAS.437.3362B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5204,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5204,24.5,0.2,0.794,1760,NULL,NULL,'I, Z','MESSIER 031',NULL,'1995AJ....109.2050C',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5205,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5205,24.5,0.2,0.794,1760,NULL,NULL,'TRGB(LF)','MESSIER 031',NULL,'1994MNRAS.271..852M',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5206,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5206,24.51,0.11,0.798,1760,NULL,NULL,'W-shelf, M31, M31 + 15 kpc','MESSIER 031',NULL,'2010ApJ...708.1168T',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5207,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5207,24.51,0.25,0.799,1760,NULL,NULL,'North to South Field 3','MESSIER 031',NULL,'2014MNRAS.437.3362B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5208,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5208,24.53,0.09,0.805,1760,NULL,NULL,'MAYALL II, MESSIER 031:[MSJ2001] G1','MESSIER 031',NULL,'1998AJ....115.1916H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5209,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5209,24.55,0.2,0.812,1760,NULL,NULL,'North to South Field 2','MESSIER 031',NULL,'2014MNRAS.437.3362B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5210,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5210,24.55,0.2,0.813,1760,NULL,NULL,'I','MESSIER 031',NULL,'1995AJ....109.2050C',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5211,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5211,24.56,NULL,0.817,1760,NULL,NULL,'DA90','MESSIER 031',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5212,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5212,24.58,NULL,0.824,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5213,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5213,24.6,0.2,0.832,1760,NULL,NULL,'I','MESSIER 031',NULL,'1995AJ....109.2050C',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5214,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5214,24.62,NULL,0.839,1760,NULL,NULL,'K97','MESSIER 031',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5215,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5215,24.62,NULL,0.839,1760,NULL,NULL,'Yale','MESSIER 031',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5216,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5216,24.64,0.19,0.847,1760,NULL,NULL,'MAYALL V, SKHV 352, Bol 407','MESSIER 031',NULL,'1998AJ....115.1916H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5217,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5217,24.73,0.11,0.883,1760,NULL,NULL,'Giant Southern Stream, M31 + 100 kpc','MESSIER 031',NULL,'2010ApJ...708.1168T',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5218,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5218,24.8,0.13,0.912,1760,NULL,NULL,'SKHV 011, Bol 293','MESSIER 031',NULL,'1998AJ....115.1916H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5219,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5219,24.86,0.11,0.938,1760,NULL,NULL,'SKHV 280, Bol 225','MESSIER 031',NULL,'1998AJ....115.1916H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5220,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5220,25.01,0.17,1,1760,NULL,NULL,'2MASXi J0049398+413529, SKHV 351, Bol 405','MESSIER 031',NULL,'1998AJ....115.1916H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5221,'Type II Cepheids','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5221,23.93,0.24,0.611,1760,NULL,18.45,'LMC ZP','MESSIER 031',NULL,'2009AcA....59..403M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5222,'Statistical','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5222,24.46,0.1,0.78,1760,NULL,NULL,'117 estimates','MESSIER 031',NULL,'2014AJ....148...17D',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5223,'Eclipsing Binary','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5223,24.17,0.45,0.682,1760,NULL,NULL,'Method II','MESSIER 031',NULL,'1974AcC.....2...13D',1974,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5224,'Eclipsing Binary','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5224,24.3,0.11,0.724,1760,NULL,NULL,'EB 2','MESSIER 031',NULL,'2010A&A...509A..70V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5225,'Eclipsing Binary','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5225,24.36,0.08,0.745,1760,NULL,NULL,'EB 1 + 2 mean','MESSIER 031',NULL,'2010A&A...509A..70V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5226,'Eclipsing Binary','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5226,24.36,0.08,0.745,1760,NULL,18.45,NULL,'MESSIER 031',NULL,'2009PhDT.........2V',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5227,'Eclipsing Binary','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5227,24.44,0.12,0.772,1760,NULL,NULL,'M31V J00443799+4129236','MESSIER 031',NULL,'2005ApJ...635L..37R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5228,'Eclipsing Binary','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5228,24.44,0.12,0.773,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'2010hsa5.conf..365V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5229,'Eclipsing Binary','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5229,24.46,0.19,0.78,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'2010hsa5.conf..365V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5230,'HII region diameter','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5230,23.22,0.11,0.44,1760,NULL,NULL,'Photographic, HII region plus \'dark cloud\' diameters','MESSIER 031',NULL,'1985Ap&SS.113..317I',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5231,'HII region diameter','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5231,24.31,0.18,0.728,1760,NULL,NULL,'Photographic, 372 \'dark cloud\' diameters','MESSIER 031',NULL,'1982AN....303..329O',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5232,'HII region diameter','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5232,24.4,NULL,0.76,1760,NULL,NULL,'Photographic','MESSIER 031',NULL,'1981AN....302..251I',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5233,'GC K vs. (J-K)','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5233,24.19,NULL,0.689,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'1984ApJ...286..209S',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5234,'GC FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5234,23.59,NULL,0.522,1760,NULL,NULL,'SKHV 199, Bol 147','MESSIER 031',NULL,'1992A&A...254...93P',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5235,'GC FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5235,23.92,NULL,0.608,1760,NULL,NULL,'2MASX J00434551+4136578, Bol 193','MESSIER 031',NULL,'1992A&A...254...93P',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5236,'GC FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5236,24.12,0.45,0.667,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'1999MNRAS.302..587D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5237,'GC FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5237,24.4,0.2,0.759,1760,NULL,NULL,'Avg. of 6 GCs','MESSIER 031',NULL,'1992A&A...254...93P',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5238,'GC FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5238,24.54,NULL,0.809,1760,NULL,NULL,'SKHV 073, Bol 020','MESSIER 031',NULL,'1992A&A...254...93P',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5239,'GC FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5239,24.57,0.05,0.82,1760,NULL,NULL,'Hipparcos','MESSIER 031',NULL,'2009AJ....138..547S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5240,'GC FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5240,24.74,NULL,0.887,1760,NULL,NULL,'SKHV 072, Bol 019','MESSIER 031',NULL,'1992A&A...254...93P',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5241,'GC FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5241,24.81,NULL,0.916,1760,NULL,NULL,'SKHV 222, Bol 171','MESSIER 031',NULL,'1992A&A...254...93P',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5242,'GC FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5242,25.04,NULL,1.02,1760,NULL,NULL,'SKHV 217, Bol 163','MESSIER 031',NULL,'1992A&A...254...93P',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5243,'IRAS','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5243,27.24,0.8,2.8,1760,75,NULL,'A82, H','MESSIER 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5244,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5244,24.16,NULL,0.679,1760,NULL,NULL,'B','MESSIER 031',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5245,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5245,24.23,0.4,0.7,1760,75,NULL,'B','MESSIER 031',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5246,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5246,24.26,NULL,0.711,1760,NULL,NULL,'I','MESSIER 031',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5247,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5247,24.32,0.16,0.731,1760,NULL,NULL,'B','MESSIER 031',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5248,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5248,24.43,NULL,0.77,1760,75,NULL,'CO','MESSIER 031',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5249,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5249,24.46,NULL,0.78,1760,75,NULL,'HI','MESSIER 031',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5250,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5250,24.49,0.35,0.791,1760,NULL,NULL,NULL,'MESSIER 031',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5251,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5251,24.5,0.3,0.794,1760,NULL,18.45,'SN 1885A host','MESSIER 031',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5252,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5252,24.59,0.11,0.828,1760,NULL,NULL,'I','MESSIER 031',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5253,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5253,24.79,0.47,0.907,1760,75,NULL,'A82, H, raw','MESSIER 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5254,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5254,24.92,NULL,0.964,1760,NULL,NULL,'LEDA [April 2006]','MESSIER 031',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5255,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5255,25.03,0.47,1.01,1760,75,NULL,'A82, H, inv','MESSIER 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5256,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5256,25.14,0.47,1.07,1760,75,NULL,'A82, H, cor','MESSIER 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5257,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 20748','RN',5257,43.27,0.54,3170,1761,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20748',0.421593,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5258,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5258,37.1,0.08,263,1762,70,NULL,NULL,'2MASX J00424470-0933162',NULL,'2015arXiv151105856S',2015,1,0.46,'The APM image includes a neighboring star.','G',0.000104,NULL,'16.2g',0.32,'E',NULL,NULL,NULL,NULL,1,10.686167,-9.55453,0.113,NULL,34562535416,540039615,8438118,16.2),(5259,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5259,36.61,0.46,210,1763,70,NULL,NULL,'2MASX J00424540+0058372',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000089,NULL,'16.0g',0.36,'E0',NULL,NULL,NULL,NULL,1,10.689125,0.977,0,NULL,66807896675,1043873385,16310521,16),(5260,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SN 2006et',NULL,5260,34.11,0.18,64.9,1764,74.2,NULL,'SALT 2','NGC 0232',0.022172,'2010ApJ...716..712A',2010,1,1,NULL,'G',0.00015,NULL,'14.46',0.8,'SB(r)a? pec;HIILIRG',NULL,NULL,NULL,NULL,1,10.690917,-23.56136,0.054,NULL,35318208803,551847012,8622609,14.46),(5261,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SN 2006et',NULL,5261,34.6,0.03,81.4,1764,72,NULL,'MLCS31','NGC 0232',0.022172,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5262,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SN 2006et',NULL,5262,34.61,0.02,83.4,1764,72,NULL,'M(H) = -18.317 mag','NGC 0232',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5263,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SN 2006et',NULL,5263,34.66,0.09,85.5,1764,74.4,NULL,NULL,'NGC 0232',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5264,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SN 2006et',NULL,5264,34.68,0.01,86.3,1764,72,NULL,'SALT2','NGC 0232',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5265,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SN 2006et',NULL,5265,34.74,0.21,86.6,1764,73.8,NULL,'SALT 2 (SNANA)','NGC 0232',0.0225,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5266,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SN 2006et',NULL,5266,34.74,0.23,86.8,1764,73.8,NULL,'SALT 2 (SNANA)','NGC 0232',0.0225,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5267,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SN 2006et',NULL,5267,34.79,0.12,87.1,1764,72,NULL,NULL,'NGC 0232',0.02119,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5268,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SN 2006et',NULL,5268,34.78,0.18,88.4,1764,70,NULL,'SALT 2','NGC 0232',0.022172,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5269,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SN 2006et','R',5269,34.83,0.12,92.5,1764,NULL,NULL,'MLCS2k2, R(V) = 3.1','NGC 0232',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5270,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SN 2006et',NULL,5270,34.95,0.21,95.6,1764,65,NULL,'SALT2','NGC 0232',0.022172,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5271,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SN 2006et','R',5271,34.92,0.1,96.4,1764,NULL,NULL,'MLCS2k2, R(V) = 1.8','NGC 0232',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5272,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SN 2006et',NULL,5272,35.03,0.22,99.3,1764,65,NULL,'MLCS31','NGC 0232',0.022172,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5273,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SN 2006et',NULL,5273,35.07,0.19,101,1764,65,NULL,'MLCS17','NGC 0232',0.022172,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5274,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SN 2006et',NULL,5274,35.13,0.19,104,1764,65,NULL,'SALT','NGC 0232',0.022172,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5275,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SN 2006et',NULL,5275,35.58,0.03,128,1764,70,NULL,'SALT 2','NGC 0232',0.022172,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5276,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 07661','RN',5276,41.88,0.27,1890,1765,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 07661',0.257467,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5277,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 07661','RN',5277,42.49,0.37,2500,1765,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 07661',0.257467,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5278,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5278,35.17,0.65,108,1766,70,NULL,NULL,'MCG -01-02-046',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.36',0.6,NULL,NULL,NULL,NULL,NULL,1,10.6985417,-3.82919,0.224,NULL,34588226727,540441042,8444391,15.36),(5279,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 20345','R',5279,40.5,0.22,996,1767,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007qp','SN 2007qp',0.265,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,10.7017917,0.37975,0.043,NULL,66588885577,1040451337,16257052,NULL),(5280,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 20345','R',5280,40.79,0.16,1140,1767,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007qp','SN 2007qp',0.265,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5281,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5281,37.12,0.46,265,1768,70,NULL,NULL,'2MASX J00424950-0017569',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000072,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,10.7062917,-0.29919,0.032,NULL,34393495330,537398364,8396849,17),(5282,'BCG','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5282,38.63,0.35,480,1769,60,NULL,'ABELL 0088, BCG','2MASX J00425078-2604447',0.1086,'1980ApJ...241..486H',1980,1,0.38,NULL,'G',0.000077,NULL,'17.2',0.26,NULL,'Brightest group member',NULL,NULL,NULL,1,10.7115416667,-26.07911,0.044,NULL,34830701682,544229713,8503589,17.2),(5283,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 19798','RN',5283,42.18,0.29,2160,1770,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19798',0.267184,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5284,'BCG','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5284,38.63,0.35,480,1771,60,NULL,NULL,'ABELL 0088',0.1086,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,10.715917,-26.04281,0.036,NULL,34830707637,544229806,8503590,NULL),(5285,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5285,37.54,0.13,322,1772,70,NULL,NULL,'2MASX J00425208+1516535',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000118,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,10.7169583,15.2815,0.165,NULL,67476253024,1054316453,16473694,17.8),(5286,'IRAS','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5286,34.64,0.8,84.8,1773,75,NULL,'W91PP, r','UGC 00457',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.00003,NULL,'15.51',0.2,'Sbc',NULL,NULL,NULL,NULL,1,10.7228333333,33.52272,0.257,NULL,67332502248,1052070347,16438599,15.51),(5287,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5287,34.02,0.49,63.8,1773,75,NULL,'IR','UGC 00457',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5288,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5288,34.15,0.38,67.7,1773,75,NULL,'W91PP, r, raw','UGC 00457',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5289,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5289,34.2,0.38,69.1,1773,75,NULL,'W91PP, r, inv','UGC 00457',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5290,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5290,34.29,0.38,72,1773,75,NULL,'W91PP, r, cor','UGC 00457',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5291,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5291,34.38,0.35,75.1,1773,NULL,NULL,NULL,'UGC 00457',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5292,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5292,34.43,0.2,76.9,1773,74.4,NULL,NULL,'UGC 00457',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5293,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5293,34.45,0.34,77.5,1773,NULL,NULL,'Malmquist cor.','UGC 00457',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5294,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5294,37.29,0.23,287,1774,70,NULL,NULL,'GIN 010',NULL,'2015arXiv151105856S',2015,1,0.79,'Beers, et al. (1991,AJ,102,1581) give v=5230 +/- 59 km/sec.','G',0.000099,NULL,'15.5g',0.5,'E/S0;BrClG     LINER',NULL,NULL,NULL,NULL,1,10.727875,-9.23042,0.096,NULL,34576652892,540260201,8441565,15.5),(5295,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5295,37.54,0.23,322,1774,70,NULL,NULL,'GIN 010',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5296,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5296,37.54,0.13,322,1775,70,NULL,NULL,'SDSS J004257.22+151709.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000088,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,10.7384583333,15.28592,0.165,NULL,67476254694,1054316479,16473694,18.5),(5297,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5297,37.29,0.23,287,1776,70,NULL,NULL,'2MASX J00425925-0924023',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000088,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,10.7469583333,-9.40072,0.113,NULL,34576347433,540255428,8441491,17.8),(5298,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5298,37.29,0.23,287,1777,70,NULL,NULL,'2MASX J00430067-0913463',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000099,NULL,'16.4g',0.35,'AGN            LINER',NULL,NULL,NULL,NULL,1,10.752625,-9.22956,0.096,NULL,34576651571,540260180,8441565,16.4),(5299,'Magnitude','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5299,35.24,0.13,112,1778,100,NULL,NULL,'ABELL 0087',NULL,'1998A&A...337...31R',1998,1,NULL,'Katgert (1996,A&A,310,8) identify multiple redshift systems in this cluster.','GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,10.7568333333,-9.79283,0.101,NULL,34562584558,540040383,8438130,NULL),(5300,'Magnitude','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5300,35.24,0.13,112,1779,100,NULL,NULL,'GALEXASC J004301.72-094733.8',NULL,'1998A&A...337...31R',1998,1,NULL,NULL,'G',0.000073,NULL,'17.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,10.757125,-9.79286,0.101,NULL,34562584558,540040383,8438130,17.4),(5301,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5301,28.37,0.1,4.72,1780,NULL,NULL,NULL,'IC 1574',NULL,'2012A&A...540A..49M',2012,1,2.1,NULL,'G',0.000003,NULL,'14.3B',0.8,'IB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,10.765917,-22.24689,0.062,NULL,35330044153,552031939,8625499,14.3),(5302,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5302,28.45,0.13,4.9,1780,NULL,NULL,'I','IC 1574',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5303,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5303,28.46,0.26,4.92,1780,NULL,NULL,NULL,'IC 1574',NULL,'2003A&A...404...93K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5304,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5304,28.46,0.1,4.92,1780,74.4,NULL,NULL,'IC 1574',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5305,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5305,28.67,NULL,5.42,1780,NULL,NULL,'I','IC 1574',NULL,'2006ARep...50..517T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5306,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5306,28.24,0.4,4.5,1780,75,NULL,'B','IC 1574',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5307,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5307,36.56,0.58,205,1781,70,NULL,NULL,'2MASX J00430810-4621541',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'15.88',0.57,'S0',NULL,NULL,NULL,NULL,1,10.783875,-46.36511,NULL,NULL,38179878592,596560603,9321259,15.88),(5308,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5308,37.22,0.46,279,1782,70,NULL,NULL,'2MASX J00430819+1558156',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000087,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,10.7841666667,15.97092,0.097,NULL,67468010835,1054187669,16471682,16.4),(5309,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5309,36.87,0.57,236,1783,70,NULL,NULL,'MCG -02-02-094',NULL,'2014MNRAS.445.2677S',2014,1,0.63,'Superposed star 8\\\" SW.','G',0.00015,NULL,'15.5g',0.49,NULL,NULL,NULL,NULL,NULL,1,10.7847083,-11.12769,0.106,NULL,34561790864,540027982,8437937,15.5),(5310,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5310,37.1,0.08,263,1784,70,NULL,NULL,'GIN 011',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000023,NULL,'15.3g',0.62,'E/S0',NULL,NULL,NULL,NULL,1,10.7921666667,-9.86147,0.101,NULL,34562493357,540038958,8438108,15.3),(5311,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5311,37.25,0.25,282,1784,74.4,NULL,NULL,'GIN 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5312,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5312,37.54,0.23,322,1784,70,NULL,NULL,'GIN 011',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5313,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5313,37.54,0.13,322,1785,70,NULL,NULL,'2MASX J00431185+1516026',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000108,NULL,'16.5g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,10.79925,15.26728,0.165,NULL,67476221021,1054315953,16473686,16.5),(5314,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5314,38.08,0.46,412,1786,70,NULL,NULL,'2MASX J00431771-1101013',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000079,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,10.8238333333,-11.01711,0.097,NULL,34561770798,540027668,8437932,18),(5315,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 21391','RN',5315,41.49,0.41,1390,1787,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21391',0.432962,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5316,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 21391','RN',5316,41.56,0.37,1430,1787,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 21391',0.432962,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5317,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 21391','N',5317,41.35,0.27,1860,1787,70,NULL,'SALT 2','SDSS-II SN 21391',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5318,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 21391','N',5318,41.43,0.27,1930,1787,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 21391',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5319,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5319,37.54,0.13,322,1788,70,NULL,NULL,'2MASX J00432040+1512164',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000074,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,10.8350417,15.20461,0.157,NULL,67476691585,1054323306,16473801,17.2),(5320,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5320,37.47,0.46,312,1789,70,NULL,NULL,'2MASXi J0043208+150025',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000079,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,10.8367917,15.00719,0.157,NULL,67476681147,1054323142,16473799,17.9),(5321,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5321,35.27,0.06,113,1790,NULL,NULL,NULL,'ESO 150- G 020',NULL,'2009ApJS..182..474S',2009,1,1.7,'Star 0.8 arcminutes north-following.','G',0.000023,NULL,'14.43',0.7,'(R\':)SA(r)bc',NULL,NULL,NULL,NULL,1,10.8375416667,-55.32692,0,NULL,36222406103,565975095,8843360,14.43),(5322,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5322,35.33,0.4,117,1790,NULL,NULL,'mean','ESO 150- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5323,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5323,35.34,0.47,117,1790,NULL,NULL,'H','ESO 150- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5324,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5324,35.46,0.46,124,1790,NULL,NULL,'J','ESO 150- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5325,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5325,35.51,0.45,127,1790,NULL,NULL,'K','ESO 150- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5326,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 21585','RN',5326,44.6,0.43,5480,1791,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 21585',0.519617,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5327,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5327,37.98,0.46,394,1792,70,NULL,NULL,'2MASX J00432323+1405164',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000073,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,10.8467917,14.08781,0.181,NULL,67462726575,1054105102,16470392,18),(5328,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5328,33.53,0.69,50.7,1793,100,NULL,'mid-IR','UGC 00460',NULL,'2013ApJ...771...88L',2013,1,1.1,NULL,'G',0.000033,NULL,'14.0',0.7,'Scd:',NULL,NULL,NULL,NULL,1,10.848375,50.67672,1.089,NULL,65795403607,1028053181,16063330,14),(5329,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 15216','RN',5329,41.19,0.74,1560,1794,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 15216',0.108798,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5330,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5330,37.54,0.46,323,1795,70,NULL,NULL,'2MASX J00432406-0950554',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.0001,NULL,'17.1g',0.18,'E',NULL,NULL,NULL,NULL,1,10.8502083,-9.84869,0.106,NULL,34562468246,540038566,8438102,17.1),(5331,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5331,36.03,0.75,161,1796,70,NULL,NULL,'2MASX J00432409-1115214',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.75',0.34,NULL,NULL,NULL,NULL,NULL,1,10.850375,-11.25608,0.106,NULL,34561678524,540026226,8437909,16.75),(5332,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5332,37.94,0.46,388,1797,70,NULL,NULL,'SDSS J004324.51-090119.4',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000085,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,10.852125,-9.02206,0.103,NULL,34576617346,540259646,8441556,17.4),(5333,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5333,38.32,0.46,461,1798,70,NULL,NULL,'2MASX J00432509-0926314',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000099,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,10.854667,-9.44217,0.113,NULL,34562516263,540039316,8438114,17.5),(5334,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5334,37.54,0.13,322,1799,70,NULL,NULL,'2MASX J00432523+1512524',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000097,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,10.855125,15.21458,0.157,NULL,67476691130,1054323298,16473801,17.2),(5335,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5335,37.54,0.13,322,1800,70,NULL,NULL,'2MASX J00432544+1508014',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000094,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,10.856125,15.13356,0.157,NULL,67476695095,1054323360,16473802,17.6),(5336,'IRAS','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5336,33.5,0.8,50,1801,75,NULL,'MAT, I','NGC 0237',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.00002,NULL,'13.7',0.9,'SAB(rs)cd;Sy?  LINER','Isolated galaxy',NULL,NULL,'Sy ?',1,10.866,-0.12492,0.016,NULL,34393531693,537398932,8396858,13.7),(5337,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5337,32.89,0.69,37.9,1801,100,NULL,'mid-IR','NGC 0237',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5338,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5338,33.27,0.32,45.1,1801,85,NULL,'I, raw','NGC 0237',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5339,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5339,33.31,0.32,45.9,1801,85,NULL,'I, inv','NGC 0237',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5340,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5340,33.44,0.43,48.7,1801,75,NULL,'MAT, I, raw','NGC 0237',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5341,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5341,33.61,0.47,52.6,1801,NULL,NULL,'H','NGC 0237',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5342,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5342,33.63,0.43,53.3,1801,75,NULL,'MAT, I, inv','NGC 0237',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5343,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5343,33.65,0.45,53.8,1801,NULL,NULL,'K','NGC 0237',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5344,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5344,33.66,0.46,53.9,1801,NULL,NULL,'J','NGC 0237',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5345,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5345,33.76,0.2,56.5,1801,74.4,NULL,NULL,'NGC 0237',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5346,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5346,33.78,0.43,56.9,1801,75,NULL,'MAT, I, cor','NGC 0237',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5347,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5347,33.81,0.4,57.8,1801,NULL,NULL,'mean','NGC 0237',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5348,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5348,33.94,0.37,61.5,1801,NULL,NULL,NULL,'NGC 0237',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5349,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5349,34.1,0.34,66.2,1801,NULL,NULL,'Malmquist cor.','NGC 0237',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5350,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5350,33.42,0.51,48.3,1802,70,NULL,NULL,'MCG -01-02-049',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.000133,NULL,'14.74',0.3,'Sbc',NULL,NULL,NULL,NULL,1,10.8685833333,-6.34875,0.19,NULL,34619922481,540936288,8452129,14.74),(5351,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5351,36.65,0.46,214,1803,70,NULL,NULL,'2MASX J00432859-1004514',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000091,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,10.869167,-10.08106,0.095,NULL,34565064202,540079128,8438736,16.6),(5352,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5352,37.46,0.46,311,1804,70,NULL,NULL,'2MASX J00433202+1403154',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000074,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,10.883625,14.05444,0.189,NULL,67462598454,1054103100,16470360,17.8),(5353,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5353,34.43,0.53,77,1805,70,NULL,NULL,'IC 1575',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'14.18',0.7,'S0+ pec',NULL,NULL,NULL,NULL,1,10.889,-4.11783,0.227,NULL,34587988814,540437325,8444333,14.18),(5354,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5354,34.61,0.4,83.5,1806,NULL,NULL,'mean','IC 0048',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000067,NULL,'13.98',0.8,'SAB(rs)0^0^ pec?',NULL,NULL,NULL,NULL,1,10.893625,-8.1865,0.144,NULL,34568160831,540127512,8439492,13.98),(5355,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5355,34.86,0.45,93.7,1806,NULL,NULL,'K','IC 0048',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5356,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 18041',NULL,5356,40.92,0.18,1520,1807,70,NULL,'SN photometric redshift distance, z photo =0.451 +/- 0.053','SDSS-II SN 18041',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,10.8952083,-0.69872,0.055,NULL,34577924883,540280076,8441876,NULL),(5357,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5357,37.54,0.13,322,1808,70,NULL,NULL,'SDSS J004335.93+151124.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000119,NULL,'18.3g',0.15,'NLAGN',NULL,NULL,NULL,'Sy 2',1,10.89975,15.19003,0.157,NULL,67476699663,1054323432,16473803,18.3),(5358,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 02288','RN',5358,40.51,0.32,1140,1809,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02288',0.108875,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5359,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 02288','RN',5359,40.61,0.18,1200,1809,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02288',0.108875,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5360,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5360,37.9,0.46,381,1810,70,NULL,NULL,'2MASX J00433595+0014555',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'QSO',0.000078,NULL,'17.8g',NULL,'BLAGN',NULL,NULL,NULL,'Sy 1',1,10.899875,0.24886,0.016,NULL,66589009082,1040453266,16257082,17.8),(5361,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5361,35.17,0.49,108,1811,75,NULL,'IR','2MFGC 00532',NULL,'2011yCatp016004901K',2011,1,0.81,NULL,'G',0.000023,NULL,'16.35',0.22,'Sc',NULL,NULL,NULL,NULL,1,10.902667,-56.48744,0,NULL,36216173581,565877712,8841839,16.35),(5362,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5362,35.22,0.11,111,1811,NULL,NULL,NULL,'2MFGC 00532',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5363,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 08670','RN',5363,43.32,0.31,3630,1812,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 08670',0.269153,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5364,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 08670','RN',5364,43.96,0.46,4870,1812,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 08670',0.269153,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5365,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 18363',NULL,5365,39.98,0.39,989,1813,70,NULL,'SN photometric redshift distance, z photo =0.265 +/- 0.063','SDSS-II SN 18363',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.3g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,10.9101666667,-0.15739,0.016,NULL,34393313475,537395523,8396805,21.3),(5366,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 18363','R',5366,41.23,0.31,1350,1813,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18363',0.308529,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5367,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 18363','R',5367,41.29,0.29,1380,1813,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18363',0.308529,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5368,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 18363',NULL,5368,41.1,0.22,1660,1813,70,NULL,'SALT 2','SDSS-II SN 18363',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5369,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 18363',NULL,5369,41.13,0.22,1680,1813,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18363',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5370,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5370,37.46,0.46,310,1814,70,NULL,NULL,'2MASX J00434376-0009583',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'18.01',0.17,NULL,NULL,NULL,NULL,NULL,1,10.9322083333,-0.16636,0.016,NULL,34393342864,537395982,8396812,18.01),(5371,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 19640','RN',5371,40.13,0.11,955,1815,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19640',0.10967,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5372,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 19640','RN',5372,40.17,0.21,974,1815,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19640',0.10967,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5373,'IRAS','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5373,34.7,0.8,87,1816,75,NULL,'MAT, I','ESO 474- G 019',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'15.79',0.7,'Sc',NULL,NULL,NULL,NULL,1,10.936625,-24.42136,0.019,NULL,34799952362,543749255,8496082,15.79),(5374,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5374,34.65,0.2,85.1,1816,74.4,NULL,NULL,'ESO 474- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5375,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5375,34.75,0.32,89.2,1816,85,NULL,'I, raw','ESO 474- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5376,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5376,34.75,0.43,89.3,1816,75,NULL,'MAT, I, raw','ESO 474- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5377,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5377,34.77,0.32,89.8,1816,85,NULL,'I, inv','ESO 474- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5378,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5378,34.83,0.56,92.6,1816,NULL,NULL,NULL,'ESO 474- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5379,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5379,34.84,0.43,92.9,1816,75,NULL,'MAT, I, inv','ESO 474- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5380,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5380,35,0.43,99.8,1816,75,NULL,'MAT, I, cor','ESO 474- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5381,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5381,35.16,0.48,108,1816,NULL,NULL,'Malmquist cor.','ESO 474- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5382,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5382,39.01,0.46,635,1817,70,NULL,NULL,'SDSS J004346.19+010015.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000088,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,10.9425,1.00442,0.013,NULL,66807809702,1043872026,16310500,18.6),(5383,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 03887','RN',5383,40.57,0.37,1000,1818,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03887',0.298629,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5384,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 03887','N',5384,40.42,0.26,1210,1818,70,NULL,'SALT 2','SDSS-II SN 03887',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5385,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 03887','N',5385,40.44,0.26,1220,1818,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 03887',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5386,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 03887','RN',5386,41.13,0.34,1300,1818,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03887',0.298629,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5387,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 20268',NULL,5387,40.67,0.56,1360,1819,70,NULL,'SN photometric redshift distance, z photo =0.390 +/- 0.160','SDSS-II SN 20268',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.9g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,10.945833,-0.07575,0.016,NULL,34393325010,537395703,8396807,21.9),(5388,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 20268','R',5388,41.76,0.32,1560,1819,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20268',0.441176,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5389,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 20268','R',5389,41.81,0.34,1600,1819,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20268',0.441176,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5390,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 20268',NULL,5390,41.64,0.24,2130,1819,70,NULL,'SALT 2','SDSS-II SN 20268',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5391,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 20268',NULL,5391,41.73,0.24,2220,1819,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20268',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5392,'IRAS','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5392,33.91,0.8,60.5,1820,75,NULL,'W91PP, r','UGC 00465',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00002,NULL,'14.42',0.4,'SBa','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,10.9615416667,32.85339,0.273,NULL,67339685808,1052182590,16440352,14.42),(5393,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5393,33.97,0.38,62.2,1820,75,NULL,'W91PP, r, raw','UGC 00465',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5394,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5394,34.13,0.47,67.1,1820,NULL,NULL,'H','UGC 00465',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5395,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5395,34.14,0.38,67.4,1820,75,NULL,'W91PP, r, inv','UGC 00465',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5396,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5396,34.15,0.38,67.7,1820,75,NULL,'W91PP, r, cor','UGC 00465',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5397,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5397,34.16,0.45,67.9,1820,NULL,NULL,'K','UGC 00465',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5398,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5398,34.16,0.4,68.1,1820,NULL,NULL,'mean','UGC 00465',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5399,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5399,34.19,0.46,68.8,1820,NULL,NULL,'J','UGC 00465',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5400,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5400,33.63,0.2,53.2,1821,74.4,NULL,NULL,'UGC 00466',NULL,'2013AJ....146...86T',2013,1,1.28,NULL,'G',0.000072,NULL,'14.8g',0.48,'SB(s)a pec?',NULL,NULL,NULL,NULL,1,10.966125,0.80197,0.019,NULL,66807836928,1043872452,16310507,14.8),(5401,'IRAS','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5401,34.78,0.8,90.5,1822,75,NULL,'MAT, I','MCG -01-03-005',NULL,'1997ApJS..109..333W',1997,1,1.46,NULL,'G',0.000032,NULL,'14.44',0.39,'(R\')Sc:',NULL,NULL,NULL,NULL,1,10.9764583,-4.24542,0.194,NULL,34587967210,540436987,8444327,14.44),(5402,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5402,34.62,0.32,83.8,1822,85,NULL,'I, raw','MCG -01-03-005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5403,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5403,34.65,0.2,85.1,1822,74.4,NULL,NULL,'MCG -01-03-005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5404,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5404,34.66,0.43,85.6,1822,75,NULL,'MAT, I, raw','MCG -01-03-005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5405,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5405,34.66,0.32,85.6,1822,85,NULL,'I, inv','MCG -01-03-005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5406,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5406,34.79,0.43,91,1822,75,NULL,'MAT, I, cor','MCG -01-03-005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5407,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5407,34.87,0.43,94.2,1822,75,NULL,'MAT, I, inv','MCG -01-03-005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5408,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5408,36.25,0.55,178,1823,70,NULL,NULL,'2MASX J00435537-4529198',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'16.12',0.33,NULL,NULL,NULL,NULL,NULL,1,10.98075,-45.48878,NULL,NULL,38181015267,596578363,9321536,16.12),(5409,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5409,36.63,0.46,212,1824,70,NULL,NULL,'2MASX J00435821-1011085',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000063,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,10.992417,-10.18553,0.095,NULL,34564859213,540075925,8438686,17.2),(5410,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5410,36.57,0.56,206,1825,70,NULL,NULL,'MCG -02-03-003',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.9b',0.15,NULL,NULL,NULL,NULL,NULL,1,10.998125,-11.30572,0.106,NULL,34561928642,540030135,8437970,15.9),(5411,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5411,34.57,0.52,82.1,1826,70,NULL,NULL,'ESO 029- G 007',NULL,'2014MNRAS.445.2677S',2014,1,1.3,'RC3 gives v = 7850 +/- 63 km/sec.','G',0.000097,NULL,'13.1R',0.9,'(R\'_2)SB(r)ab',NULL,NULL,NULL,NULL,1,10.99875,-76.59086,0.221,NULL,35597797962,556215593,8690868,13.1),(5412,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5412,37.84,0.33,370,1827,70,NULL,NULL,'2MASX J00440203-0030063',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00007,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,11.0084583333,-0.50186,0.017,NULL,34578100819,540282825,8441919,18.2),(5413,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 16460',NULL,5413,39.47,0.66,783,1828,70,NULL,'SN photometric redshift distance, z photo =0.203 +/- 0.085','SDSS-II SN 16460',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,11.009625,-0.23003,0.016,NULL,34393332527,537395820,8396809,NULL),(5414,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 16460','R',5414,40.85,0.16,1150,1828,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16460',0.281988,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5415,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 16460','R',5415,40.92,0.3,1190,1828,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16460',0.281988,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5416,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 16460',NULL,5416,40.95,0.21,1550,1828,70,NULL,'SALT 2','SDSS-II SN 16460',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5417,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 16460',NULL,5417,40.98,0.21,1570,1828,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16460',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5418,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 04028',NULL,5418,40.3,0.15,1150,1829,70,NULL,'SN photometric redshift distance, z photo =0.317 +/- 0.027','SDSS-II SN 04028',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,11.013833,1.24247,0.013,NULL,66807388253,1043865441,16310397,NULL),(5419,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 04028','R',5419,41.43,0.31,1430,1829,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 04028',0.345246,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5420,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 04028','R',5420,41.46,0.28,1460,1829,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 04028',0.345246,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5421,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 04028',NULL,5421,41.3,0.21,1820,1829,70,NULL,'SALT 2','SDSS-II SN 04028',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5422,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 04028',NULL,5422,41.34,0.21,1850,1829,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 04028',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5423,'IRAS','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5423,35.63,0.8,133,1830,75,NULL,'W91PP, r','UGC 00469',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000023,NULL,'15.14',0.3,'S?',NULL,NULL,NULL,NULL,1,11.016,26.20697,0.109,NULL,67313157613,1051768087,16433876,15.14),(5424,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5424,35.54,0.38,128,1830,75,NULL,'W91PP, r, raw','UGC 00469',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5425,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5425,35.55,0.49,129,1830,75,NULL,'IR','UGC 00469',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5426,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5426,35.76,0.38,142,1830,75,NULL,'W91PP, r, cor','UGC 00469',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5427,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5427,35.81,0.38,145,1830,75,NULL,'W91PP, r, inv','UGC 00469',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5428,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5428,38.11,0.46,419,1831,70,NULL,NULL,'SDSS J004408.79+011109.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,11.036625,1.18586,0.013,NULL,66807395009,1043865547,16310399,18.1),(5429,'IRAS','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5429,34.18,0.8,68.6,1832,75,NULL,'W91PP, r','UGC 00470',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000003,NULL,'14.82',0.4,'Im:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,11.0527917,26.84508,0.177,NULL,67324248427,1051941381,16436584,14.82),(5430,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5430,34.02,0.38,63.5,1832,75,NULL,'W91PP, r, raw','UGC 00470',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5431,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5431,34.04,0.38,64.1,1832,75,NULL,'W91PP, r, inv','UGC 00470',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5432,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5432,34.17,0.38,68.4,1832,75,NULL,'W91PP, r, cor','UGC 00470',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5433,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 13859',NULL,5433,40.32,0.12,1160,1833,70,NULL,'SN photometric redshift distance, z photo =0.320 +/- 0.022','SDSS-II SN 13859',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,11.062125,0.96697,0.013,NULL,66807307364,1043864177,16310377,NULL),(5434,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 05963','R',5434,40.2,0.2,886,1834,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J004419.42+002846.9',0.2356,'2014arXiv1401.3317S',2014,1,0.11,NULL,'G',0.0005,NULL,'20.6g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,11.0809583,0.47969,0.052,NULL,66807126471,1043861351,16310333,20.6),(5435,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 05963','R',5435,40.31,0.12,934,1834,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J004419.42+002846.9',0.2356,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5436,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 05963',NULL,5436,40.04,0.09,1020,1834,70,NULL,'SALT 2','SDSS J004419.42+002846.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5437,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 05963',NULL,5437,40.06,0.09,1030,1834,70,NULL,'SALT 2, Malmquist cor.','SDSS J004419.42+002846.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5438,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5438,36.26,0.72,178,1835,70,NULL,NULL,'MCG -01-03-006',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.5',0.3,NULL,NULL,NULL,NULL,NULL,1,11.0835417,-6.99372,0.205,NULL,34565964961,540093202,8438956,15.5),(5439,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5439,37.15,0.65,269,1836,70,NULL,NULL,'2MASX J00442302-0250402',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.000097,NULL,'16.00',0.39,NULL,NULL,NULL,NULL,NULL,1,11.0959583333,-2.84456,0.158,NULL,34579986603,540312290,8442379,16),(5440,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5440,36.58,0.86,207,1837,70,NULL,NULL,'2MFGC 00542',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'15.3r',0.11,NULL,NULL,NULL,NULL,NULL,1,11.0992083,-68.79317,0,NULL,36322559511,567539992,8867812,15.3),(5441,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 17508',NULL,5441,40.23,0.25,1110,1838,70,NULL,'SN photometric redshift distance, z photo =0.304 +/- 0.045','SDSS-II SN 17508',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','20.8g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,11.102,0.66783,0.052,NULL,66807000631,1043859384,16310302,20.8),(5442,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 17508','R',5442,41.55,0.35,1520,1838,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17508',0.339506,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5443,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 17508','R',5443,41.68,0.32,1620,1838,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17508',0.339506,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5444,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5444,35.65,0.49,135,1839,70,NULL,NULL,'2MASX J00442808-4750356',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'16.21',0.27,'S',NULL,NULL,NULL,NULL,1,11.117125,-47.84328,NULL,NULL,38176854296,596513348,9320521,16.21),(5445,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 19518',NULL,5445,39.81,1.06,917,1840,70,NULL,'SN photometric redshift distance, z photo =0.243 +/- 0.197','SDSS-II SN 19518',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'G',NULL,'PHOT','23.2g',NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,11.1175833333,-0.1035,0,NULL,34393304223,537395378,8396802,23.2),(5446,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 19518',NULL,5446,41.51,0.23,2000,1840,70,NULL,'SALT 2','SDSS-II SN 19518',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5447,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 19518',NULL,5447,41.57,0.23,2060,1840,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19518',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5448,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5448,37.84,0.33,370,1841,70,NULL,NULL,'2MASX J00442863-0024242',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'15.9R',0.28,NULL,NULL,NULL,NULL,NULL,1,11.119167,-0.40686,0.017,NULL,34578060784,540282199,8441909,15.9),(5449,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 08675','R',5449,41.58,0.32,1380,1842,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 08675',0.496475,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,'PHOT','20.8g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,11.1225417,0.42122,0.026,NULL,66807116113,1043861189,16310331,20.8),(5450,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 08675',NULL,5450,41.33,0.23,1850,1842,70,NULL,'SALT 2','SDSS-II SN 08675',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5451,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 08675',NULL,5451,41.35,0.14,1860,1842,70,NULL,'SN photometric redshift distance, z photo =0.593 +/- 0.060','SDSS-II SN 08675',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5452,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 08675',NULL,5452,41.47,0.23,1970,1842,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 08675',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5453,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5453,35.59,0.47,131,1843,70,NULL,NULL,'2MASX J00443129-0301012',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'15.46',0.49,NULL,NULL,NULL,NULL,NULL,1,11.130375,-3.01708,0.158,NULL,34591529673,540492651,8445197,15.46),(5454,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5454,36.61,0.81,210,1844,70,NULL,NULL,'ESO 194- G 034',NULL,'2014MNRAS.445.2677S',2014,1,1.43,NULL,'G',0.00015,NULL,'16.19',0.2,'Sbc',NULL,NULL,NULL,NULL,1,11.133875,-48.84756,NULL,NULL,38143828573,595997321,9312458,16.19),(5455,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5455,37.57,0.46,327,1845,70,NULL,NULL,'2MASX J00443545-1020387',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000085,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,11.1478333333,-10.34417,0.109,NULL,34564992551,540078008,8438718,17.4),(5456,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5456,33.67,0.4,54.3,1846,NULL,NULL,'mean','NGC 0239',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000103,NULL,'14.21',0.5,'(R\')Sab        HII',NULL,NULL,NULL,NULL,1,11.1562917,-3.75925,0.217,NULL,34588187033,540440422,8444381,14.21),(5457,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5457,34.35,0.45,74.2,1846,NULL,NULL,'K','NGC 0239',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5458,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5458,34.37,0.46,74.8,1846,NULL,NULL,'J','NGC 0239',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5459,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5459,34.38,0.47,75,1846,NULL,NULL,'H','NGC 0239',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5460,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5460,36.41,0.55,191,1847,70,NULL,NULL,'2MASX J00443767-4849412',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.83',0.29,NULL,NULL,NULL,NULL,NULL,1,11.156875,-48.82814,NULL,NULL,38143836520,595997445,9312460,16.83),(5461,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5461,34.49,NULL,79.1,1848,NULL,NULL,NULL,'FGC 0084',NULL,'2000BSAO...50....5K',2000,1,0.92,NULL,'G',0.000048,NULL,'17.4g',0.12,'Sc(f)',NULL,NULL,NULL,NULL,1,11.159917,-11.18878,0.102,NULL,34561945803,540030403,8437975,17.4),(5462,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5462,35.5,NULL,126,1848,NULL,NULL,'Dipole','FGC 0084',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5463,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5463,35.51,NULL,126,1848,NULL,NULL,'Dipole + Quadrupole','FGC 0084',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5464,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5464,35.51,NULL,127,1848,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0084',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5465,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 15758','RN',5465,43.83,0.28,4110,1849,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15758',0.417141,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5466,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 15758','RN',5466,44.07,0.38,4600,1849,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15758',0.417141,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5467,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5467,36.59,0.46,208,1850,70,NULL,NULL,'2MASX J00444139-0935557',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000068,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,11.172375,-9.59881,0.111,NULL,34563141735,540049089,8438267,17.1),(5468,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5468,37.18,0.46,273,1851,70,NULL,NULL,'2MASX J00444173-0054468',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000089,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,11.1739583,-0.91303,0.037,NULL,34578491533,540288930,8442014,17.1),(5469,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 04282','RN',5469,40.45,0.15,1090,1852,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04282',0.125099,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5470,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 04282','RN',5470,40.99,0.22,1400,1852,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04282',0.125099,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5471,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5471,37.93,0.46,385,1853,70,NULL,NULL,'2MASX J00444307-0927457',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000085,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,11.1794583,-9.46281,0.111,NULL,34563109868,540048591,8438259,18.1),(5472,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5472,36.49,0.87,198,1854,70,NULL,NULL,'2MASX J00444361-2351175',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'16.25',0.38,'E',NULL,NULL,NULL,NULL,1,11.181667,-23.85489,0,NULL,34797543145,543711611,8495493,16.25),(5473,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5473,37.6,0.46,332,1855,70,NULL,NULL,'2MASX J00444380-1035207',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00011,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,11.1824583,-10.58903,0.123,NULL,34561448823,540022637,8437853,17.9),(5474,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 18947','R',5474,41.59,0.28,1530,1856,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J004444.84-005214.2',0.362111,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',NULL,'PHOT','21.2g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,11.186833,-0.87064,0.024,NULL,34578437541,540288086,8442001,21.2),(5475,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 18947','R',5475,41.82,0.25,1700,1856,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J004444.84-005214.2',0.362111,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5476,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 18947',NULL,5476,41.49,0.19,1990,1856,70,NULL,'SALT 2','SDSS J004444.84-005214.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5477,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 18947',NULL,5477,41.54,0.19,2030,1856,70,NULL,'SALT 2, Malmquist cor.','SDSS J004444.84-005214.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5478,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5478,36.33,0.46,184,1857,70,NULL,NULL,'2MASX J00444533-0033028',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000081,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,11.1887083,-0.55072,0.024,NULL,34578031705,540281745,8441902,16.7),(5479,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5479,36.81,0.33,230,1858,70,NULL,NULL,'2MASX J00444753-0025378',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000109,NULL,'16.1g',0.43,'E0',NULL,NULL,NULL,NULL,1,11.197917,-0.42739,0.008,NULL,34577990797,540281106,8441892,16.1),(5480,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 18697','R',5480,38.46,0.18,443,1859,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ma','APMUKS(BJ) B004220.26-011613.2',0.11,'2014arXiv1401.3317S',2014,1,0.2,NULL,'G',NULL,NULL,'19.19',0.1,NULL,NULL,NULL,NULL,NULL,1,11.2242083333,-0.99686,0.037,NULL,34578477739,540288714,8442011,19.19),(5481,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SN 2007ma',NULL,5481,38.35,0.06,468,1859,70,NULL,'SALT 2','APMUKS(BJ) B004220.26-011613.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5482,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SN 2007ma',NULL,5482,38.36,0.06,470,1859,70,NULL,'SALT 2, Malmquist cor.','APMUKS(BJ) B004220.26-011613.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5483,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 18697','R',5483,38.63,0.06,480,1859,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ma','APMUKS(BJ) B004220.26-011613.2',0.11,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5484,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 08742','R',5484,40.72,0.16,1150,1860,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J004457.45+002613.4',0.214,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',NULL,NULL,'20.6g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,11.239417,0.43708,0.026,NULL,66806973899,1043858967,16310296,20.6),(5485,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 08742','R',5485,40.91,0.23,1250,1860,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J004457.45+002613.4',0.214,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5486,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 08742',NULL,5486,40.57,0.13,1300,1860,70,NULL,'SALT 2','SDSS J004457.45+002613.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5487,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 08742',NULL,5487,40.59,0.13,1310,1860,70,NULL,'SALT 2, Malmquist cor.','SDSS J004457.45+002613.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5488,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 02614','RN',5488,40.25,0.11,913,1861,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 02614',0.22822,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5489,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 02614','RN',5489,40.75,0.19,1150,1861,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02614',0.22822,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5490,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5490,36.88,0.46,237,1862,70,NULL,NULL,'2MASX J00445954+1515150',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000103,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,11.2482083,15.25408,0.177,NULL,67476789416,1054324834,16473825,16.8),(5491,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5491,34.01,0.2,63.4,1863,74.4,NULL,NULL,'6dF J0045091-093755',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.00015,NULL,'17.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,11.2877917,-9.63186,0.111,NULL,34562998597,540046853,8438232,17.9),(5492,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5492,33.97,0.4,62.2,1864,NULL,NULL,NULL,'MCG -02-03-006',NULL,'2009ApJS..182..474S',2009,1,0.97,NULL,'G',0.00002,NULL,'15.1g',0.47,'Scd',NULL,NULL,NULL,NULL,1,11.2877917,-9.63172,0.111,NULL,34562998597,540046853,8438232,15.1),(5493,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5493,34.34,0.34,73.8,1864,NULL,NULL,'Malmquist cor.','MCG -02-03-006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5494,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5494,36.08,0.56,164,1865,70,NULL,NULL,'2MASX J00451141-1716107',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.09',0.34,NULL,NULL,NULL,NULL,NULL,1,11.2974166667,-17.26958,0.049,NULL,35341953226,552218019,8628406,16.09),(5495,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5495,35.78,NULL,143,1866,NULL,NULL,NULL,'UGC 00474',NULL,'2000BSAO...50....5K',2000,1,1.12,NULL,'G',0.000008,NULL,'16.0',0.13,'Sc',NULL,NULL,NULL,NULL,1,11.306667,10.5025,0.213,NULL,66774066770,1043344793,16302262,16),(5496,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5496,35.8,NULL,145,1866,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00474',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5497,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5497,35.83,NULL,146,1866,NULL,NULL,'Dipole + Quadrupole','UGC 00474',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5498,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5498,35.84,NULL,147,1866,NULL,NULL,'Dipole','UGC 00474',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5499,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5499,36.07,0.49,164,1866,75,NULL,'IR','UGC 00474',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5500,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 18952','R',5500,40.47,0.28,959,1867,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18952',0.295891,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,11.3068333333,0.82778,0.025,NULL,66673257602,1041769650,16277650,NULL),(5501,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 18952','R',5501,40.67,0.43,1050,1867,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18952',0.295891,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5502,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 18952',NULL,5502,40.3,0.16,1150,1867,70,NULL,'SN photometric redshift distance, z photo =0.317 +/- 0.030','SDSS-II SN 18952',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5503,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5503,38.83,0.46,583,1868,70,NULL,NULL,'2MASX J00451520-0112409',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.89',0.13,NULL,NULL,NULL,NULL,NULL,1,11.3132917,-1.2115,0.042,NULL,34511033018,539234890,8425545,18.89),(5504,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 15909','R',5504,39.99,0.2,817,1869,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J004515.55+004749.1',0.218,'2014arXiv1401.3317S',2014,1,0.12,NULL,'G',NULL,NULL,'20.01',0.1,NULL,NULL,NULL,NULL,NULL,1,11.3147917,0.79722,0.025,NULL,66673260237,1041769691,16277651,20.01),(5505,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 15909','R',5505,40.15,0.14,880,1869,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J004515.55+004749.1',0.218,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5506,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 15909',NULL,5506,39.79,0.11,908,1869,70,NULL,'SALT 2','SDSS J004515.55+004749.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5507,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 15909',NULL,5507,39.8,0.11,912,1869,70,NULL,'SALT 2, Malmquist cor.','SDSS J004515.55+004749.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5508,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5508,38.38,0.46,475,1870,70,NULL,NULL,'2MASX J00451627+1547525',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000107,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,11.3178333333,15.79808,0.097,NULL,67468178945,1054190296,16471723,17.6),(5509,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 13809','RN',5509,42.01,0.22,1990,1871,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13809',0.272337,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5510,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 13809','RN',5510,42.49,0.24,2470,1871,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13809',0.272337,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5511,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 05731',NULL,5511,40.59,0.18,1310,1872,70,NULL,'SN photometric redshift distance, z photo =0.373 +/- 0.040','SDSS-II SN 05731',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,11.3385,-0.5445,0.005,NULL,34510809183,539231393,8425490,NULL),(5512,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5512,36.73,0.95,222,1873,70,NULL,NULL,'2MASX J00452132-2537117',NULL,'2014MNRAS.445.2677S',2014,1,0.41,'6dF DR1 has z = 0.023962.','G',0.00015,NULL,'17.2',0.22,NULL,NULL,NULL,NULL,NULL,1,11.338875,-25.61989,0.037,NULL,34831310171,544239221,8503737,17.2),(5513,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5513,38.18,0.27,432,1874,70,NULL,NULL,'2MASX J00452213-0059139',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00007,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,11.342333,-0.98719,0.037,NULL,34511144403,539236631,8425572,17.8),(5514,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5514,36.17,0.56,171,1875,70,NULL,NULL,'MCG -02-03-007',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'16.0b',0.2,NULL,NULL,NULL,NULL,NULL,1,11.3501666667,-12.53614,0.095,NULL,35333848803,552091387,8626427,16),(5515,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SN 2005jc',NULL,5515,39.26,0.12,588,1876,74.2,NULL,'SALT 2','SDSS J004524.26+010435.6',0.21,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,11.3510833333,1.07656,0,NULL,66673198711,1041768729,16277636,NULL),(5516,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SN 2005jc',NULL,5516,39.97,0.12,814,1876,70,NULL,'SALT 2','SDSS J004524.26+010435.6',0.21,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5517,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 06933','R',5517,39.98,0.2,820,1876,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005jc','SDSS J004524.26+010435.6',0.21,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5518,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SN 2005jc',NULL,5518,39.98,0.08,820,1876,65,NULL,'SALT2','SDSS J004524.26+010435.6',0.21,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5519,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SN 2005jc',NULL,5519,40.02,NULL,834,1876,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 06933, SN 2005jc','SDSS J004524.26+010435.6',0.21,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5520,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SN 2005jc',NULL,5520,40.06,0.03,848,1876,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 06933, SN 2005jc','SDSS J004524.26+010435.6',0.21,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5521,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 06933','R',5521,40.14,0.1,883,1876,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005jc','SDSS J004524.26+010435.6',0.21,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5522,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SN 2005jc',NULL,5522,40.17,0.09,894,1876,65,NULL,'MLCS2k2','SDSS J004524.26+010435.6',0.21,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5523,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5523,38.07,0.46,411,1877,70,NULL,NULL,'SDSS J004532.82-010516.0',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000091,NULL,'17.9g',0.17,'NLAGN',NULL,NULL,NULL,'Sy 2',1,11.38675,-1.08781,0.037,NULL,34511037532,539234961,8425546,17.9),(5524,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5524,36.25,0.65,178,1878,70,NULL,NULL,'2MASX J00453439-2019489',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.00015,NULL,'15.66',0.36,NULL,'Field galaxy',NULL,NULL,NULL,1,11.393333,-20.33031,0.041,NULL,35323410691,551928292,8623879,15.66),(5525,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5525,36.81,0.33,230,1879,70,NULL,NULL,'2MASX J00453545-0025079',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000087,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,11.39775,-0.41881,0.005,NULL,34510849688,539232026,8425500,16.8),(5526,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 13905','RN',5526,38.61,0.26,472,1880,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13905',0.116389,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5527,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 13905','RN',5527,39.19,0.28,616,1880,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13905',0.116389,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5528,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5528,24.49,NULL,0.791,1881,NULL,NULL,NULL,'Andromeda I',NULL,'2014ApJ...789..147W',2014,1,2.5,NULL,'G',0.000037,NULL,'13.6',2.5,'dSph;E3 pec?','Group member',NULL,NULL,NULL,1,11.415833,38.04111,0.201,1,67671986217,1057374784,16521481,13.6),(5529,'Horizontal Branch','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5529,24.42,0.16,0.766,1881,NULL,NULL,NULL,'Andromeda I',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5530,'Horizontal Branch','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5530,24.55,0.08,0.81,1881,NULL,NULL,NULL,'Andromeda I',NULL,'1996AJ....112.2576D',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5531,'Horizontal Branch','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5531,24.55,0.08,0.813,1881,NULL,NULL,NULL,'Andromeda I',NULL,'2004MNRAS.350..243M',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5532,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5532,24.23,0.11,0.701,1881,NULL,NULL,'V','Andromeda I',NULL,'2013MNRAS.435.3206D',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5533,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5533,24.44,NULL,0.773,1881,NULL,NULL,NULL,'Andromeda I',NULL,'2008ApJ...679...52T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5534,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5534,24.49,0.06,0.791,1881,NULL,NULL,NULL,'Andromeda I',NULL,'2005AJ....129.2232P',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5535,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5535,24.31,0.05,0.727,1881,NULL,NULL,NULL,'Andromeda I',NULL,'2012ApJ...758...11C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5536,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5536,24.32,0.01,0.731,1881,NULL,NULL,NULL,'Andromeda I',NULL,'2011ApJ...740...69C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5537,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5537,24.33,0.07,0.735,1881,NULL,NULL,NULL,'Andromeda I',NULL,'2004MNRAS.350..243M',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5538,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5538,24.36,0.07,0.745,1881,NULL,NULL,NULL,'Andromeda I',NULL,'2005MNRAS.356..979M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5539,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5539,24.38,0.08,0.75,1881,74.4,NULL,NULL,'Andromeda I',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5540,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5540,24.5,0.15,0.79,1881,NULL,NULL,NULL,'Andromeda I',NULL,'1990ApJ...354..438M',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5541,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5541,24.5,0.15,0.794,1881,NULL,NULL,NULL,'Andromeda I',NULL,'2004MNRAS.350..243M',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5542,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5542,38.18,0.27,432,1882,70,NULL,NULL,'2MASX J00454048-0052162',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000102,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,11.418583,-0.87125,0.037,NULL,34511179661,539237182,8425580,17.4),(5543,'Tully est','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5543,30.33,0.8,11.6,1883,75,NULL,'B','NGC 0244',NULL,'1988NBGC.C....0000T',1988,1,1.2,'MCG notes this galaxy as possibly interacting.','G',0.000021,NULL,'13.83',1,'S0 pec?',NULL,NULL,NULL,NULL,1,11.4434583,-15.59689,0.021,NULL,35343189647,552237338,8628708,13.83),(5544,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5544,36.38,0.46,189,1884,70,NULL,NULL,'2MASX J00454812+0033023',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00007,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,11.4505,0.55067,0.054,NULL,66673565845,1041774466,16277726,17.1),(5545,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 20866','RN',5545,40.98,0.37,1150,1885,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 20866',0.368403,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5546,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 20866','RN',5546,40.99,0.41,1160,1885,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 20866',0.368403,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5547,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 20497',NULL,5547,40.6,0.09,1320,1886,70,NULL,'SN photometric redshift distance, z photo =0.374 +/- 0.021','SDSS-II SN 20497',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,11.458,-1.18681,0.06,NULL,34511054758,539235230,8425550,NULL),(5548,'IRAS','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5548,34.33,0.8,73.5,1887,75,NULL,'MAT, I','ESO 411- G 010',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000027,NULL,'14.49',0.9,'SB(r)bc',NULL,NULL,NULL,NULL,1,11.4650417,-31.19908,NULL,NULL,34887129664,545111401,8517365,14.49),(5549,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5549,33.73,0.32,55.6,1887,85,NULL,'I, raw','ESO 411- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5550,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5550,33.75,0.32,56.2,1887,85,NULL,'I, inv','ESO 411- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5551,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5551,34.14,NULL,67.3,1887,NULL,NULL,'I','ESO 411- G 010',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5552,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5552,34.21,0.43,69.7,1887,75,NULL,'MAT, I, raw','ESO 411- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5553,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5553,34.31,0.65,72.9,1887,NULL,NULL,NULL,'ESO 411- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5554,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5554,34.35,0.2,74.1,1887,74.4,NULL,NULL,'ESO 411- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5555,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5555,34.38,0.43,75.3,1887,75,NULL,'MAT, I, inv','ESO 411- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5556,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5556,34.49,0.6,79,1887,NULL,NULL,'Malmquist cor.','ESO 411- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5557,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5557,34.5,NULL,79.4,1887,NULL,NULL,'B','ESO 411- G 010',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5558,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5558,34.52,0.43,80.2,1887,75,NULL,'MAT, I, cor','ESO 411- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5559,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5559,35.7,0.52,138,1888,70,NULL,NULL,'2MASX J00455178-4951075',NULL,'2014MNRAS.445.2677S',2014,1,0.24,NULL,'G',0.00015,NULL,'16.5b',0.16,NULL,NULL,NULL,NULL,NULL,1,11.4657917,-49.85203,NULL,NULL,36008679480,562635616,8791181,16.5),(5560,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 08138','R',5560,42.09,0.28,1880,1889,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 08138',0.397867,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,11.4665833333,0.37806,0.054,NULL,66672832140,1041763002,16277546,NULL),(5561,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 08138','R',5561,42.34,0.24,2110,1889,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 08138',0.397867,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5562,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 11370',NULL,5562,41.2,0.26,1740,1890,70,NULL,'SN photometric redshift distance, z photo =0.539 +/- 0.102','SDSS-II SN 11370',NULL,'2011ApJ...738..162S',2011,1,0.03,NULL,'G',0.0003,NULL,'22.3g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,11.4675,-0.71436,0.005,NULL,34511675501,539244929,8425702,22.3),(5563,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5563,38.05,0.46,407,1891,70,NULL,NULL,'2MASX J00455337+1401588',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000078,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,11.472375,14.03311,0.181,NULL,67463279070,1054113735,16470527,18.1),(5564,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5564,37.91,0.46,382,1892,70,NULL,NULL,'2MASX J00455786-0911139',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000115,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,11.491,-9.18711,0.093,NULL,34562310011,540036093,8438063,16.6),(5565,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5565,34.18,0.47,68.5,1893,NULL,NULL,'H','MCG -01-03-010',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00009,NULL,'13.86',0.6,'HII',NULL,NULL,NULL,NULL,1,11.4932083,-7.28222,0.208,NULL,34567632563,540119258,8439363,13.86),(5566,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5566,34.25,0.46,70.7,1893,NULL,NULL,'J','MCG -01-03-010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5567,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5567,34.26,0.45,71.1,1893,NULL,NULL,'K','MCG -01-03-010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5568,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5568,34.55,0.4,81.1,1893,NULL,NULL,'mean','MCG -01-03-010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5569,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5569,37.77,0.46,358,1894,70,NULL,NULL,'2MASX J00460065+1348288',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000071,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,11.5028333333,13.80808,0.209,NULL,67463038781,1054109980,16470468,18.1),(5570,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5570,38.02,0.46,402,1895,70,NULL,NULL,'2MASX J00460158+0058293',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,11.5065833333,0.97486,0.013,NULL,66673441488,1041772523,16277695,17.8),(5571,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5571,37.23,0.46,279,1896,70,NULL,NULL,'2MASX J00460266+0028593',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000074,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,11.5109583333,0.48325,0.054,NULL,66673534738,1041773980,16277718,17.3),(5572,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5572,31.53,0.4,20.2,1897,75,NULL,'B','DDO 005',NULL,'1988NBGC.C....0000T',1988,1,2,'Confused HIPASS source','G',0.00001,NULL,'14.18',1.7,'SAB(s)m',NULL,NULL,NULL,NULL,1,11.514167,-11.50556,0.112,NULL,34443682346,538182536,8409102,14.18),(5573,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SN 2007lg',NULL,5573,38.07,0.05,411,1898,70,NULL,'Hubble residual -0.18 for z0.11040','SDSS J004603.93-000038.4',NULL,'2011ApJ...740...92G',2011,1,0.11,NULL,'G',0.0005,NULL,'18.9g',0.1,NULL,NULL,NULL,NULL,NULL,1,11.516375,-0.01069,0,NULL,34510767329,539230739,8425480,18.9),(5574,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SN 2007lg',NULL,5574,38.08,0.18,413,1898,70,NULL,'SDSS-II SN 18375','SDSS J004603.93-000038.4',NULL,'2013MNRAS.434.1443X',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5575,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 18375','R',5575,38.38,0.06,427,1898,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007lg','SDSS J004603.93-000038.4',0.1104,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5576,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SN 2007lg',NULL,5576,38.18,0.06,433,1898,70,NULL,'SALT 2','SDSS J004603.93-000038.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5577,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SN 2007lg',NULL,5577,38.19,0.06,435,1898,70,NULL,'SALT 2, Malmquist cor.','SDSS J004603.93-000038.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5578,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 18375','R',5578,38.43,0.18,437,1898,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007lg','SDSS J004603.93-000038.4',0.1104,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5579,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5579,36.94,0.52,244,1899,70,NULL,NULL,'2MASX J00460464-4812475',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.20',0.27,'S',NULL,NULL,NULL,NULL,1,11.519417,-48.21322,NULL,NULL,38143558472,595993101,9312392,16.2),(5580,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 18704','R',5580,41.12,0.23,1260,1900,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18704',0.331981,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,11.5218333333,-0.52672,0.005,NULL,34511689552,539245149,8425705,NULL),(5581,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 18704','R',5581,41.18,0.13,1290,1900,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18704',0.331981,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5582,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 18704',NULL,5582,40.71,0.15,1390,1900,70,NULL,'SN photometric redshift distance, z photo =0.399 +/- 0.036','SDSS-II SN 18704',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5583,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5583,34.92,0.46,96.2,1901,70,NULL,NULL,'IC 0050',NULL,'2015arXiv151105856S',2015,1,0.87,NULL,'G',0.000077,NULL,'14.4g',0.74,'E0',NULL,NULL,NULL,NULL,1,11.5237917,-9.503,0.116,NULL,34562764831,540043200,8438175,14.4),(5584,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 02876','RN',5584,38.97,0.4,551,1902,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02876',0.130432,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5585,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 02876','RN',5585,40.5,0.28,1120,1902,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02876',0.130432,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5586,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5586,34.4,NULL,75.9,1903,NULL,NULL,'B','ESO 243- G 001',NULL,'2005Ap&SS.298..577R',2005,1,0.76,NULL,'G',0.000033,NULL,'15.36',0.61,'Sb:',NULL,NULL,NULL,NULL,1,11.5257916667,-42.52981,NULL,NULL,38174597210,596478081,9319970,15.36),(5587,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5587,34.4,NULL,75.9,1903,NULL,NULL,'I','ESO 243- G 001',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5588,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5588,34.85,0.55,93.4,1903,NULL,NULL,NULL,'ESO 243- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5589,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5589,34.89,0.2,95.1,1903,74.4,NULL,NULL,'ESO 243- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5590,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5590,35.06,0.5,103,1903,NULL,NULL,'Malmquist cor.','ESO 243- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5591,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5591,35.28,0.07,114,1904,NULL,NULL,NULL,'ESO 150- G 022',NULL,'2009ApJS..182..474S',2009,1,1.42,NULL,'G',0.000023,NULL,'14.70',0.4,'(R\':)SAB(rs)bc',NULL,NULL,NULL,'H_alpha Emission-Line Galaxy',1,11.537625,-55.56847,0,NULL,36222355114,565974298,8843348,14.7),(5592,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5592,37.9,0.46,380,1905,70,NULL,NULL,'2MASX J00461269-0101134',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000098,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,11.552833,-1.02053,0.048,NULL,34511235603,539238056,8425594,17.4),(5593,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5593,38.02,0.46,402,1906,70,NULL,NULL,'2MASX J00461296-0018544',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000078,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,11.5540833333,-0.31503,0.013,NULL,34510943589,539233493,8425523,17.7),(5594,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5594,32.19,0.4,27.5,1907,75,NULL,NULL,'UGC 00477',NULL,'2008Ap.....51..336K',2008,1,3.2,NULL,'G',0.000017,NULL,'14.70',0.6,'Sdm:','Pair member (points to parent)',NULL,NULL,NULL,1,11.5547083333,19.48992,0.089,NULL,67490330018,1054536406,16477131,14.7),(5595,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5595,32.2,0.4,27.5,1907,73,NULL,'IR','UGC 00477',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5596,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5596,32.73,0.2,35.2,1907,74.4,NULL,NULL,'UGC 00477',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5597,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5597,32.75,0.4,35.5,1907,75,NULL,'B','UGC 00477',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5598,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5598,32.79,0.4,36.1,1907,NULL,NULL,NULL,'UGC 00477',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5599,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5599,32.95,0.43,38.9,1907,75,NULL,'3.6 micron, color corrected','UGC 00477',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5600,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5600,33.15,0.43,42.7,1907,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00477',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5601,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5601,33.17,0.49,43.1,1907,75,NULL,'IR','UGC 00477',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5602,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 03894','RN',5602,42.74,0.35,2430,1908,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03894',0.4531,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5603,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5603,35.44,0.49,122,1909,75,NULL,'IR','IC 1582',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000033,NULL,'15.46',0.3,'Sb-c',NULL,NULL,NULL,NULL,1,11.570083,-24.27933,0.044,NULL,34799772484,543746445,8496038,15.46),(5604,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5604,35.81,0.38,145,1909,NULL,NULL,'Malmquist cor.','IC 1582',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5605,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5605,36.09,0.34,165,1909,NULL,NULL,NULL,'IC 1582',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5606,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5606,36.13,0.2,168,1909,74.4,NULL,NULL,'IC 1582',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5607,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5607,38.74,0.33,561,1910,70,NULL,NULL,'SDSS J004618.43+010131.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000067,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,11.576833,1.0255,0.013,NULL,66673409927,1041772030,16277687,18.2),(5608,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 18766','RN',5608,44.22,0.51,4920,1911,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 18766',0.419242,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5609,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 18766','RN',5609,45.08,0.5,7310,1911,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 18766',0.419242,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5610,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5610,33.94,0.2,61.4,1912,74.4,NULL,NULL,'UGC 00475',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.000033,NULL,'14.1',0.7,'Scd:',NULL,NULL,NULL,NULL,1,11.58075,51.21744,1.105,NULL,65794712097,1028042376,16063162,14.1),(5611,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5611,34.53,0.4,80.5,1912,NULL,NULL,'mean','UGC 00475',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5612,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5612,34.61,0.47,83.4,1912,NULL,NULL,'H','UGC 00475',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5613,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5613,34.73,0.45,88.2,1912,NULL,NULL,'K','UGC 00475',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5614,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5614,38.18,0.27,432,1913,70,NULL,NULL,'2MASX J00461996-0049594',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000085,NULL,'16.49',0.19,NULL,NULL,NULL,NULL,NULL,1,11.583125,-0.83319,0.028,NULL,34511208310,539237629,8425587,16.49),(5615,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5615,24.35,NULL,0.741,1914,NULL,NULL,NULL,'ANDROMEDA XI',NULL,'2014ApJ...789..147W',2014,1,NULL,NULL,'G',0.000015,NULL,NULL,NULL,'dSph',NULL,NULL,NULL,NULL,1,11.583333,33.80139,0.241,1,67342028361,1052219193,16440924,NULL),(5616,'Horizontal Branch','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5616,24.5,NULL,0.79,1914,NULL,NULL,NULL,'ANDROMEDA XI',NULL,'2010MNRAS.407.2411C',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5617,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5617,24.17,0.09,0.682,1914,NULL,NULL,'V','ANDROMEDA XI',NULL,'2013MNRAS.435.3206D',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5618,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5618,24.33,0.05,0.734,1914,NULL,NULL,NULL,'ANDROMEDA XI',NULL,'2012MNRAS.419.1362Y',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5619,'RR Lyrae','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5619,24.54,NULL,0.809,1914,NULL,NULL,NULL,'ANDROMEDA XI',NULL,'2011PhDT........32Y',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5620,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5620,24.4,0.4,0.76,1914,NULL,NULL,NULL,'ANDROMEDA XI',NULL,'2010MNRAS.407.2411C',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5621,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5621,24.41,0.32,0.763,1914,NULL,NULL,NULL,'ANDROMEDA XI',NULL,'2012ApJ...758...11C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5622,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5622,24.7,0.2,0.87,1914,NULL,NULL,NULL,'ANDROMEDA XI',NULL,'2006MNRAS.371.1983M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5623,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 05552','RN',5623,42,0.21,1760,1915,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 05552',0.42508,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5624,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 05552','RN',5624,42.87,0.21,2630,1915,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 05552',0.42508,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5625,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,'R',5625,37.61,0.46,333,1916,70,NULL,NULL,'2MASX J00462382-0054074',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000093,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,11.599167,-0.90219,0.028,NULL,34511245811,539238215,8425597,17.6),(5626,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 12979','R',5626,39.04,0.18,577,1917,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2006gf','SN 2006gf',0.116541,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'IIP',NULL,NULL,NULL,NULL,1,11.6014583,0.00347,0,NULL,66672885766,1041763840,16277560,NULL),(5627,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:36','1','SDSS-II SN 12979','R',5627,39.25,0.22,635,1917,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2006gf','SN 2006gf',0.116541,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5628,'FP','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5628,36.85,0.64,234,1918,70,NULL,NULL,'LCRS B004402.8-422453',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.000103,NULL,'16.84',0.37,NULL,NULL,NULL,NULL,NULL,1,11.6027083,-42.14178,NULL,NULL,38174663815,596479122,9319986,16.84),(5629,'IRAS','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5629,34.06,0.8,64.7,1919,75,NULL,'W91PP, r','UGC 00478',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.62',0.3,'Sa','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,11.6072917,30.23828,0.201,NULL,67373038950,1052703733,16448495,14.62),(5630,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:36','1',NULL,NULL,5630,34.1,0.38,65.9,1919,75,NULL,'W91PP, r, raw','UGC 00478',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5631,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5631,34.22,0.4,69.8,1919,NULL,NULL,'mean','UGC 00478',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5632,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5632,34.23,0.38,70.2,1919,75,NULL,'W91PP, r, cor','UGC 00478',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5633,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5633,34.24,0.49,70.6,1919,75,NULL,'IR','UGC 00478',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5634,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5634,34.28,0.38,71.7,1919,75,NULL,'W91PP, r, inv','UGC 00478',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5635,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5635,34.34,0.47,73.9,1919,NULL,NULL,'H','UGC 00478',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5636,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5636,34.39,0.46,75.4,1919,NULL,NULL,'J','UGC 00478',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5637,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5637,34.47,0.45,78.5,1919,NULL,NULL,'K','UGC 00478',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5638,'IRAS','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5638,34.64,0.8,84.8,1920,75,NULL,'W91PP, r','UGC 00479',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.00003,NULL,'15.03',0.7,'(R)SB(s)ab',NULL,NULL,NULL,NULL,1,11.617375,31.80903,0.237,NULL,67337546337,1052149161,16439830,15.03),(5639,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5639,34.07,0.69,65.2,1920,100,NULL,'mid-IR','UGC 00479',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5640,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5640,34.78,0.4,90.3,1920,NULL,NULL,'mean','UGC 00479',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5641,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5641,34.87,0.38,94.1,1920,75,NULL,'W91PP, r, raw','UGC 00479',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5642,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5642,35.06,0.38,103,1920,75,NULL,'W91PP, r, inv','UGC 00479',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5643,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5643,35.07,0.38,103,1920,75,NULL,'W91PP, r, cor','UGC 00479',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5644,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5644,35.23,0.47,111,1920,NULL,NULL,'H','UGC 00479',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5645,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5645,38.49,0.46,499,1921,70,NULL,NULL,'2MASX J00462876-0013304',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000087,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,11.6199166667,-0.225,0,NULL,34510906912,539232920,8425514,17.4),(5646,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5646,37.03,0.46,255,1922,70,NULL,NULL,'2MASX J00462882+0006215',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.0001,NULL,'16.6g',0.31,'NLAGN',NULL,NULL,NULL,'Sy 2',1,11.6202083,0.106,0.018,NULL,66672764913,1041761951,16277530,16.6),(5647,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 04350','RN',5647,43.87,0.31,3950,1923,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04350',0.501415,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5648,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 14536',NULL,5648,40.46,0.25,1240,1924,70,NULL,'SN photometric redshift distance, z photo =0.346 +/- 0.053','SDSS-II SN 14536',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','22.5g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,11.6332083333,0.54472,0.014,NULL,66673676491,1041776195,16277753,22.5),(5649,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 14536','R',5649,41.73,0.37,1510,1924,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 14536',0.474318,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5650,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 14536',NULL,5650,41.6,0.28,2090,1924,70,NULL,'SALT 2','SDSS-II SN 14536',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5651,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 14536',NULL,5651,41.72,0.28,2210,1924,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14536',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5652,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 2005hz',NULL,5652,38.14,0.11,379,1925,74.2,NULL,'SALT 2','APMUKS(BJ) B004358.28+003354.5',0.12,'2010ApJ...716..712A',2010,1,0.16,NULL,'G',NULL,NULL,'19.68',0.09,NULL,NULL,NULL,NULL,NULL,1,11.6341666667,0.83814,0.019,NULL,66673354337,1041771161,16277674,19.68),(5653,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 2005hz',NULL,5653,38.83,0.12,520,1925,70,NULL,'SDSS-II SN 05751, SALT 2','APMUKS(BJ) B004358.28+003354.5',0.12,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5654,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 2005hz',NULL,5654,38.86,0.06,528,1925,65,NULL,'SALT2','APMUKS(BJ) B004358.28+003354.5',0.12,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5655,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 05751','R',5655,38.91,0.17,540,1925,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005hz','APMUKS(BJ) B004358.28+003354.5',0.12,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5656,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 2005hz',NULL,5656,38.97,0.06,556,1925,65,NULL,'MLCS2k2','APMUKS(BJ) B004358.28+003354.5',0.12,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5657,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 05751','R',5657,39.02,0.06,569,1925,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005hz','APMUKS(BJ) B004358.28+003354.5',0.12,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5658,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 2005hz',NULL,5658,38.79,0.06,573,1925,70,NULL,'SALT 2','APMUKS(BJ) B004358.28+003354.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5659,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 2005hz',NULL,5659,38.8,0.06,575,1925,70,NULL,'SALT 2, Malmquist cor.','APMUKS(BJ) B004358.28+003354.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5660,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 2005hz',NULL,5660,39.85,0.03,834,1925,70,NULL,'SDSS-II SN 05751','APMUKS(BJ) B004358.28+003354.5',0.12,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5661,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5661,36.69,0.46,218,1926,70,NULL,NULL,'2MASX J00463292-0915178',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000078,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,11.6372083,-9.255,0.119,NULL,34529677215,539526206,8430096,17.1),(5662,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5662,36.87,0.58,237,1927,70,NULL,NULL,'2MASX J00463448-4843170',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'15.93',0.57,'S0',NULL,NULL,NULL,NULL,1,11.643583,-48.72142,NULL,NULL,38143656393,595994631,9312416,15.93),(5663,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5663,37.1,0.57,264,1928,70,NULL,NULL,'2MASX J00463679-1418556',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'17.18',0.34,NULL,NULL,NULL,NULL,NULL,1,11.653333,-14.31536,0,NULL,35335115694,552111182,8626737,17.18),(5664,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5664,38.74,0.33,561,1929,70,NULL,NULL,'2MASX J00463858+0109099',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000089,NULL,'16.9g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,11.660833,1.15269,0.025,NULL,66676307049,1041817297,16278395,16.9),(5665,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 14090','R',5665,41.05,0.49,1190,1930,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 14090',0.357151,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,'PHOT','22.4g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,11.661083,-0.73458,0.028,NULL,34511080819,539235637,8425556,22.4),(5666,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 14090',NULL,5666,41.08,0.51,1640,1930,70,NULL,'SN photometric redshift distance, z photo =0.498 +/- 0.202','SDSS-II SN 14090',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5667,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 2006mo',NULL,5667,35.41,0.17,116,1931,74.2,NULL,'SALT 2','VV 527 NED02',0.037002,'2010ApJ...716..712A',2010,1,0.8,NULL,'G',0.000163,NULL,'15.45',0.4,'S?','Pair member (points to parent)',NULL,NULL,NULL,1,11.66125,36.33136,0.169,NULL,67145622158,1049150346,16392974,15.45),(5668,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 2006mo',NULL,5668,36,0.09,158,1931,74.4,NULL,NULL,'VV 527 NED02',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5669,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 2006mo',NULL,5669,36.11,0.16,161,1931,70,NULL,'SALT 2','VV 527 NED02',0.037002,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5670,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 2006mo',NULL,5670,36.12,0.16,162,1931,73.8,NULL,'SALT 2 (SNANA)','VV 527 NED02',0.037,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5671,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 2006mo',NULL,5671,36.13,0.16,162,1931,65,NULL,'MLCS17','VV 527 NED02',0.037002,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5672,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 2006mo',NULL,5672,36.18,0.17,166,1931,65,NULL,'MLCS31','VV 527 NED02',0.037002,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5673,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 2006mo',NULL,5673,36.31,0.16,176,1931,65,NULL,'SALT','VV 527 NED02',0.037002,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5674,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 2006mo',NULL,5674,36.32,0.2,177,1931,65,NULL,'SALT2','VV 527 NED02',0.037002,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5675,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 2006mo',NULL,5675,37.24,0.04,270,1931,70,NULL,'SALT 2','VV 527 NED02',0.037002,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5676,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 07713',NULL,5676,40.35,0.2,1170,1932,70,NULL,'SN photometric redshift distance, z photo =0.325 +/- 0.039','SDSS-II SN 07713',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,11.661625,-1.256,0.06,NULL,34514641041,539291266,8426426,NULL),(5677,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5677,35.44,0.58,123,1933,70,NULL,NULL,'2MASX J00464029-5206380',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.00015,NULL,'16.19',0.22,'Sb','in a triple',NULL,NULL,NULL,1,11.667875,-52.11061,NULL,NULL,36017432134,562772377,8793318,16.19),(5678,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5678,33.97,0.58,62.4,1934,NULL,NULL,NULL,'ESO 351- G 005',NULL,'2009ApJS..182..474S',2009,1,1,'1991ApJS...75..935d gives V = 6135 +- 50 km/sec.','G',0.000033,NULL,'15.19',0.8,'S?',NULL,NULL,NULL,NULL,1,11.6795,-35.79714,NULL,NULL,34646426827,541350419,8458600,15.19),(5679,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5679,34.02,0.2,63.7,1934,74.4,NULL,NULL,'ESO 351- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5680,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5680,34.28,0.51,71.9,1934,NULL,NULL,'Malmquist cor.','ESO 351- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5681,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 2006pb',NULL,5681,39.04,0.1,644,1935,70,NULL,'Hubble residual -0.13 for z0.17470; SDSS-II SN 15897','SDSS J004643.58-010156.9',NULL,'2011ApJ...740...92G',2011,1,0.08,NULL,'G',0.0005,NULL,'20.1g',0.08,NULL,NULL,NULL,NULL,NULL,1,11.6815833333,-1.0325,0.048,NULL,34511094031,539235844,8425560,20.1),(5682,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 2006pb',NULL,5682,39.1,0.2,661,1935,70,NULL,'SDSS-II SN 15897','SDSS J004643.58-010156.9',NULL,'2013MNRAS.434.1443X',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5683,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 2006pb','R',5683,39.54,0.8,688,1935,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006pb; SDSS-II SN 15897','SDSS J004643.58-010156.9',0.174885,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5684,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 2006pb',NULL,5684,39.32,0.09,731,1935,70,NULL,'SALT 2; SDSS-II SN 15897','SDSS J004643.58-010156.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5685,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 2006pb',NULL,5685,39.33,0.09,735,1935,70,NULL,'SALT 2, Malmquist cor.; SDSS-II SN 15897','SDSS J004643.58-010156.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5686,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 2006pb','R',5686,39.79,0.1,774,1935,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006pb; SDSS-II SN 15897','SDSS J004643.58-010156.9',0.174885,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5687,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5687,34.72,0.47,88,1936,70,NULL,NULL,'MCG -01-03-011',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00012,NULL,'15.12',0.3,NULL,NULL,NULL,NULL,NULL,1,11.703875,-6.53106,0.221,NULL,34536337490,539630273,8431723,15.12),(5688,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5688,37.08,0.46,261,1937,70,NULL,NULL,'2MASX J00464964+1355522',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000079,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,11.7069583333,13.93111,0.161,NULL,67463149514,1054111711,16470495,17.1),(5689,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5689,35.79,0.46,144,1938,70,NULL,NULL,'2MASX J00464980+0041469',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000092,NULL,'16.1g',0.38,'S0',NULL,NULL,NULL,NULL,1,11.7075416667,0.69631,0.014,NULL,66673462127,1041772845,16277700,16.1),(5690,'IRAS','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5690,34.04,0.8,64.2,1939,75,NULL,'W91PP, r','UGC 00483',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.00001,NULL,'15.47',0.4,'Im?','Isolated galaxy',NULL,NULL,NULL,1,11.7100417,26.4755,0.113,NULL,67312877238,1051763706,16433807,15.47),(5691,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5691,34.35,0.38,74,1939,NULL,NULL,NULL,'UGC 00483',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5692,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5692,34.44,0.2,77.3,1939,74.4,NULL,NULL,'UGC 00483',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5693,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5693,34.44,0.37,77.4,1939,NULL,NULL,'Malmquist cor.','UGC 00483',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5694,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5694,34.66,0.38,85.6,1939,75,NULL,'W91PP, r, inv','UGC 00483',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5695,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5695,34.66,0.38,85.7,1939,75,NULL,'W91PP, r, raw','UGC 00483',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5696,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5696,34.88,0.38,94.7,1939,75,NULL,'W91PP, r, cor','UGC 00483',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5697,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5697,37.38,0.23,300,1940,70,NULL,NULL,'2MASX J00465129+1518152',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000079,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,11.71375,15.30428,0.177,NULL,67467641123,1054181892,16471592,17),(5698,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5698,36.98,0.46,249,1941,70,NULL,NULL,'2MASX J00465195-0044565',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000087,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,11.7165417,-0.74917,0.028,NULL,34511091309,539235801,8425559,17.3),(5699,'IRAS','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5699,33.96,0.8,62,1942,75,NULL,'W91PP, r','UGC 00484',NULL,'1997ApJS..109..333W',1997,1,2.4,NULL,'G',0.00003,NULL,'13.86',0.8,'(R\')SB(s)b     HII','Pair member (points to parent)',NULL,NULL,NULL,1,11.733333,32.67533,0.189,NULL,67340372373,1052193318,16440520,13.86),(5700,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5700,33.83,0.38,58.4,1942,75,NULL,'W91PP, r, raw','UGC 00484',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5701,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5701,33.97,0.2,62.2,1942,74.4,NULL,NULL,'UGC 00484',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5702,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5702,34.02,0.38,63.7,1942,75,NULL,'W91PP, r, inv','UGC 00484',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5703,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5703,34.06,0.38,64.8,1942,75,NULL,'W91PP, r, cor','UGC 00484',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5704,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5704,34.21,0.4,69.6,1942,NULL,NULL,'mean','UGC 00484',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5705,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5705,34.22,0.49,69.9,1942,75,NULL,'IR','UGC 00484',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5706,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5706,34.3,0.47,72.4,1942,NULL,NULL,'H','UGC 00484',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5707,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5707,34.31,0.45,72.6,1942,NULL,NULL,'K','UGC 00484',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5708,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5708,34.32,0.46,73.2,1942,NULL,NULL,'J','UGC 00484',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5709,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5709,34.78,0.4,90.3,1943,NULL,NULL,NULL,'ESO 540- G 021',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000033,NULL,'14.80',0.5,'S?             HII','Field galaxy',NULL,NULL,NULL,1,11.736,-21.8475,0.061,NULL,35317497955,551835905,8622436,14.8),(5710,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5710,34.82,0.2,92,1943,74.4,NULL,NULL,'ESO 540- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5711,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5711,34.88,0.39,94.7,1943,NULL,NULL,'Malmquist cor.','ESO 540- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5712,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 14498','R',5712,40.93,0.23,1140,1944,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14498',0.3465,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',NULL,'PHOT','22.1g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,11.7639166667,-1.22478,0.048,NULL,34514663867,539291622,8426431,22.1),(5713,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 14498',NULL,5713,40.29,0.13,1140,1944,70,NULL,'SN photometric redshift distance, z photo =0.314 +/- 0.024','SDSS-II SN 14498',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5714,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 14498','R',5714,41.02,0.27,1190,1944,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14498',0.3465,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5715,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5715,37.38,0.23,300,1945,70,NULL,NULL,'2MASX J00470477+1523542',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000088,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,11.769917,15.39853,0.137,NULL,67468429351,1054194208,16471784,17.1),(5716,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5716,37.38,0.23,300,1946,70,NULL,NULL,'2MASX J00470561+1530432',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000088,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,11.7735,15.51206,0.137,NULL,67468484636,1054195072,16471798,17.5),(5717,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5717,35.34,0.61,117,1947,70,NULL,NULL,'NGC 0331',NULL,'2014MNRAS.445.2677S',2014,1,0.8,'NGC identification is very uncertain.','G',0.000013,NULL,'15.19',0.5,'Sc',NULL,NULL,NULL,NULL,1,11.778583,-2.73114,0.167,NULL,34525655687,539463370,8429115,15.19),(5718,'IRAS','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5718,34.21,0.8,69.5,1948,75,NULL,'W91PP, r','UGC 00485',NULL,'1997ApJS..109..333W',1997,1,2.5,'Position in 1997AJ....113...22G refers to a star.','G',0.000008,NULL,'14.77',0.21,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,11.7845,30.34092,0.205,NULL,67373098385,1052704662,16448510,14.77),(5719,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5719,33.61,0.49,52.6,1948,75,NULL,'IR','UGC 00485',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5720,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5720,33.85,0.2,58.9,1948,74.4,NULL,NULL,'UGC 00485',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5721,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5721,33.94,NULL,61.5,1948,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00485',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5722,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5722,33.95,NULL,61.6,1948,NULL,NULL,'Dipole','UGC 00485',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5723,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5723,33.95,NULL,61.7,1948,NULL,NULL,'Dipole + Quadrupole','UGC 00485',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5724,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5724,33.96,0.43,62,1948,75,NULL,'3.6 micron, color corrected','UGC 00485',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5725,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5725,33.96,0.43,62.1,1948,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00485',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5726,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5726,34.04,NULL,64.3,1948,NULL,NULL,NULL,'UGC 00485',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5727,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5727,34.08,0.38,65.3,1948,75,NULL,'W91PP, r, raw','UGC 00485',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5728,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5728,34.19,0.38,68.9,1948,75,NULL,'W91PP, r, inv','UGC 00485',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5729,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5729,34.22,0.38,69.7,1948,75,NULL,'W91PP, r, cor','UGC 00485',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5730,'Cepheids','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5730,27.57,0.12,3.27,1949,NULL,NULL,'10, JHKs, GAL PL','NGC 0247',NULL,'2016AJ....151...88B',2015,1,21.4,NULL,'G',0.000007,NULL,'9.86',6.9,'SAB(s)d        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,11.785625,-20.76039,0.067,NULL,35331172862,552049575,8625774,9.86),(5731,'Cepheids','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5731,27.58,0.09,3.28,1949,NULL,NULL,'10, JHKs, LMC PL','NGC 0247',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5732,'Cepheids','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5732,27.6,0.09,3.31,1949,NULL,NULL,'10, JHKs, GAL+LMC PL','NGC 0247',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5733,'Cepheids','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5733,27.64,0.04,3.38,1949,NULL,NULL,'10, JKVI','NGC 0247',NULL,'2009ApJ...700.1141G',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5734,'Cepheids','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5734,27.68,0.2,3.44,1949,NULL,NULL,'JK(W)','NGC 0247',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5735,'Cepheids','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5735,27.73,0.06,3.52,1949,74.4,NULL,NULL,'NGC 0247',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5736,'Cepheids','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5736,27.8,0.09,3.63,1949,NULL,NULL,'23, VI(W)','NGC 0247',NULL,'2008AJ....136.1770G',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5737,'Cepheids','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5737,27.8,0.09,3.63,1949,NULL,NULL,'24, VI(W)','NGC 0247',NULL,'2009RMxAC..35..309G',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5738,'Cepheids','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5738,27.81,0.1,3.65,1949,NULL,NULL,'9, VRI','NGC 0247',NULL,'2009ApJ...694.1237M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5739,'Cepheids','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5739,27.85,0.35,3.72,1949,NULL,NULL,'VI(W)','NGC 0247',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5740,'Cepheids','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5740,27.85,0.09,3.72,1949,NULL,NULL,'20, VI','NGC 0247',NULL,'2009ApJ...694.1237M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5741,'Cepheids','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5741,28.04,0.06,4.06,1949,NULL,NULL,'23, I','NGC 0247',NULL,'2008AJ....136.1770G',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5742,'Cepheids','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5742,28.2,0.05,4.37,1949,NULL,NULL,'23, V','NGC 0247',NULL,'2008AJ....136.1770G',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5743,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5743,27.72,0.08,3.5,1949,NULL,NULL,'I','NGC 0247',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5744,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5744,27.73,0.06,3.52,1949,74.4,NULL,NULL,'NGC 0247',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5745,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5745,27.75,0.07,3.54,1949,NULL,NULL,'I','NGC 0247',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5746,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5746,27.81,NULL,3.65,1949,NULL,NULL,NULL,'NGC 0247',NULL,'2006AJ....131.1361K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5747,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5747,27.82,0.1,3.67,1949,NULL,NULL,NULL,'NGC 0247',NULL,'2016MNRAS.457.1419M',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5748,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5748,27.88,0.03,3.77,1949,NULL,NULL,'I','NGC 0247',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5749,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5749,27.9,0.1,3.8,1949,NULL,NULL,NULL,'NGC 0247',NULL,'2006ApJ...641..822D',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5750,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5750,28.12,NULL,4.21,1949,NULL,NULL,'I','NGC 0247',NULL,'2008ApJ...686L..75M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5751,'IRAS','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5751,27.87,0.8,3.75,1949,75,NULL,'A82, H','NGC 0247',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5752,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5752,26.64,0.4,2.1,1949,75,NULL,'B','NGC 0247',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5753,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5753,27.24,0.4,2.8,1949,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 0247',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5754,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5754,27.43,NULL,3.06,1949,NULL,NULL,'LEDA [April 2006]','NGC 0247',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5755,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5755,27.52,0.47,3.19,1949,75,NULL,'A82, H, inv','NGC 0247',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5756,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5756,27.53,NULL,3.21,1949,NULL,NULL,'IR','NGC 0247',NULL,'1980ApJ...237..655A',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5757,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5757,27.61,0.47,3.33,1949,75,NULL,'A82, H, raw','NGC 0247',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5758,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5758,27.62,0.35,3.34,1949,NULL,NULL,NULL,'NGC 0247',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5759,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5759,27.94,0.47,3.88,1949,75,NULL,'A82, H, cor','NGC 0247',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5760,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5760,28.06,NULL,4.09,1949,NULL,NULL,NULL,'NGC 0247',NULL,'2003A&A...404...93K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5761,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 05690','RN',5761,41.99,0.4,2040,1950,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 05690',0.222458,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5762,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 05690','RN',5762,42.02,0.39,2080,1950,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05690',0.222458,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5763,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5763,37.25,0.73,282,1951,70,NULL,NULL,'2MASX J00471390-4816034',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.20',0.37,'S',NULL,NULL,NULL,NULL,1,11.807875,-48.26758,NULL,NULL,38146645842,596041341,9313145,16.2),(5764,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5764,37.05,0.46,257,1952,70,NULL,NULL,'2MASX J00471577+1511053',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000087,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,11.815625,15.18497,0.177,NULL,67467689586,1054182649,16471603,17.2),(5765,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5765,37.31,0.46,289,1953,70,NULL,NULL,'2MASX J00471602+0100296',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00011,NULL,'17.1g',0.22,'BrClG',NULL,NULL,NULL,NULL,1,11.816667,1.00811,0.017,NULL,66676180544,1041815321,16278364,17.1),(5766,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5766,33.37,0.2,47.2,1954,74.4,NULL,NULL,'NGC 0250',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000093,NULL,'14.63',0.6,'S0/a',NULL,NULL,NULL,NULL,1,11.8167083333,7.91003,0.125,NULL,66662266794,1041597918,16274967,14.63),(5767,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 06939','RN',5767,41.41,0.24,1420,1955,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 06939',0.349534,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5768,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 06939','RN',5768,41.65,0.2,1580,1955,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 06939',0.349534,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5769,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5769,35.27,0.69,113,1956,100,NULL,'mid-IR','UGC 00488',NULL,'2013ApJ...771...88L',2013,1,0.81,NULL,'G',0.00003,NULL,'15.1g',0.51,'Sab            Sy1',NULL,NULL,NULL,'Sy 1.0',1,11.830875,14.70353,0.169,NULL,67475926161,1054311346,16473614,15.1),(5770,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5770,36.2,0.2,174,1956,74.4,NULL,NULL,'UGC 00488',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5771,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5771,38.01,0.27,401,1957,70,NULL,NULL,'2MASX J00472129+0052396',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000082,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,11.838625,0.87767,0.033,NULL,66676138931,1041814670,16278354,17.3),(5772,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5772,36.98,0.46,249,1958,70,NULL,NULL,'2MASX J00472232-1103540',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000091,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,11.8430417,-11.06497,0.102,NULL,34527731265,539495801,8429621,17.4),(5773,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5773,38.01,0.27,401,1959,70,NULL,NULL,'SDSS J004723.69+005200.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,11.8487083,0.86675,0.033,NULL,66676138487,1041814663,16278354,18.1),(5774,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 09243','RN',5774,43.36,0.45,3370,1960,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 09243',0.394855,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5775,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5775,34.48,0.49,78.7,1961,75,NULL,'IR','MCG -02-03-014',NULL,'2011yCatp016004901K',2011,1,0.85,NULL,'G',0.00002,NULL,'16.0g',0.2,'Sc(f)',NULL,NULL,NULL,NULL,1,11.8562083333,-9.85275,0.113,NULL,34530955575,539546180,8430409,16),(5776,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5776,34.52,0.41,80.1,1961,NULL,NULL,'Malmquist cor.','MCG -02-03-014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5777,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5777,34.61,0.4,83.6,1961,NULL,NULL,NULL,'MCG -02-03-014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5778,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5778,34.65,0.2,85.1,1961,74.4,NULL,NULL,'MCG -02-03-014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5779,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5779,24.44,NULL,0.773,1962,NULL,NULL,NULL,'ANDROMEDA XII',NULL,'2014ApJ...789..147W',2014,1,NULL,NULL,'G',0.000011,NULL,NULL,NULL,'dSph',NULL,NULL,NULL,NULL,1,11.8625,34.37472,0.253,1,67342504759,1052226636,16441041,NULL),(5780,'Horizontal Branch','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5780,24.7,NULL,0.87,1962,NULL,NULL,NULL,'ANDROMEDA XII',NULL,'2010MNRAS.407.2411C',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5781,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5781,24.6,0.12,0.83,1962,NULL,NULL,NULL,'ANDROMEDA XII',NULL,'2007ApJ...662L..79C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5782,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5782,24.7,0.2,0.87,1962,NULL,NULL,NULL,'ANDROMEDA XII',NULL,'2006MNRAS.371.1983M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5783,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5783,24.77,0.23,0.9,1962,NULL,NULL,NULL,'ANDROMEDA XII',NULL,'2010MNRAS.407.2411C',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5784,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5784,24.84,0.34,0.928,1962,NULL,NULL,NULL,'ANDROMEDA XII',NULL,'2012ApJ...758...11C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5785,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5785,38.01,0.27,401,1963,70,NULL,NULL,'2MASX J00472716+0050586',NULL,'2015arXiv151105856S',2015,1,0.1,NULL,'G',0.000086,NULL,'17.7g',0.08,NULL,NULL,NULL,NULL,NULL,1,11.8632083,0.84956,0.031,NULL,66676139566,1041814680,16278354,17.7),(5786,'Tully est','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5786,31.16,0.8,17.1,1964,75,NULL,'B','NGC 0254',NULL,'1988NBGC.C....0000T',1988,1,2.5,'The APMBGC position is 17 arcsec east-southeast of the nucleus.','G',0.000053,NULL,'12.62',1.5,'(R)SA(rl)0^+','Group member',NULL,NULL,NULL,1,11.8650417,-31.42175,NULL,NULL,34868941108,544827204,8512925,12.62),(5787,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5787,34.51,0.4,80,1965,NULL,NULL,'mean','UGC 00486',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000023,NULL,'14.33',0.9,'SAB(s)b',NULL,NULL,NULL,NULL,1,11.866917,50.88361,1.105,NULL,65795216514,1028050258,16063285,14.33),(5788,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5788,35.07,0.45,103,1965,NULL,NULL,'K','UGC 00486',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5789,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5789,35.08,0.46,104,1965,NULL,NULL,'J','UGC 00486',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5790,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5790,35.09,0.47,104,1965,NULL,NULL,'H','UGC 00486',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5791,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5791,37.38,0.23,300,1966,70,NULL,NULL,'2MASX J00472859+1531054',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000083,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,11.8692917,15.51825,0.137,NULL,67468423222,1054194112,16471783,17),(5792,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5792,37.74,0.46,353,1967,70,NULL,NULL,'SDSS J004730.18-091434.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000082,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,11.8757917,-9.24292,0.133,NULL,34530552027,539539875,8430310,18.6),(5793,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5793,35.78,0.2,143,1968,74.4,NULL,NULL,'CGCG 435-004',NULL,'2013AJ....146...86T',2013,1,0.71,NULL,'G',0.000089,NULL,'15.4g',0.48,'Sb',NULL,NULL,NULL,NULL,1,11.876417,15.69706,0.137,NULL,67467905972,1054186030,16471656,15.4),(5794,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5794,34.41,0.2,76.2,1969,74.4,NULL,NULL,'CGCG 500-095',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000033,NULL,'15.43',0.6,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,11.8815,31.65647,0.237,NULL,67338433768,1052163027,16440047,15.43),(5795,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 19784','R',5795,40.62,0.25,1090,1970,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19784',0.220567,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',NULL,'PHOT','20.7g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,11.8845,-0.41717,0.018,NULL,34511751806,539246121,8425720,20.7),(5796,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 19784','R',5796,41.04,0.32,1320,1970,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19784',0.220567,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5797,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 19784',NULL,5797,41.13,0.46,1680,1970,70,NULL,'SN photometric redshift distance, z photo =0.514 +/- 0.184','SDSS-II SN 19784',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5798,'Brightest Stars','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5798,26.8,NULL,2.29,1971,NULL,NULL,NULL,'NGC 0253',NULL,'1990AJ....100..102D',1990,1,27.5,'Extended HIPASS source','G',0.000007,NULL,'7.09B',6.8,'SAB(s)c;Sbrst;Sy2HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,11.888,-25.28822,0.047,0,34833234106,544269282,8504207,7.09),(5799,'Brightest Stars','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5799,27,NULL,2.51,1971,NULL,NULL,'Red Supergiants, M ~ -8 mag(V)','NGC 0253',NULL,'1991ApJ...370..559D',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5800,'GCLF','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5800,27.3,0.34,2.88,1971,NULL,NULL,NULL,'NGC 0253',NULL,'1986A&A...154..321B',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5801,'PNLF','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5801,27.62,0.26,3.34,1971,NULL,NULL,NULL,'NGC 0253',NULL,'2005MNRAS.361..330R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5802,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5802,27.1,NULL,2.63,1971,NULL,NULL,'I, M = -3.6 mag(I)','NGC 0253',NULL,'1990AJ....100..102D',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5803,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5803,27.59,0.06,3.3,1971,NULL,NULL,NULL,'NGC 0253',NULL,'2005ApJ...633..810M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5804,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5804,27.66,0.05,3.4,1971,NULL,NULL,'I','NGC 0253',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5805,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5805,27.7,0.04,3.46,1971,NULL,NULL,'I','NGC 0253',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5806,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5806,27.7,0.14,3.47,1971,NULL,NULL,'I','NGC 0253',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5807,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5807,27.7,0.07,3.5,1971,NULL,NULL,'I','NGC 0253',NULL,'2011ApJS..195...18R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5808,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5808,27.76,0.08,3.56,1971,74.4,NULL,NULL,'NGC 0253',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5809,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5809,27.82,0.03,3.66,1971,NULL,NULL,'I','NGC 0253',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5810,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5810,27.98,NULL,3.94,1971,NULL,NULL,NULL,'NGC 0253',NULL,'2003A&A...404...93K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5811,'CO ring diameter','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5811,27.39,NULL,3,1971,NULL,NULL,NULL,'NGC 0253',NULL,'1991PASJ...43..671S',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5812,'HII region diameter','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5812,26.57,NULL,2.06,1971,NULL,NULL,'Photographic, 256 \'dark cloud\' diameters','NGC 0253',NULL,'1982AN....303..127I',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5813,'IRAS','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5813,28.15,0.8,4.27,1971,75,NULL,'A82, H','NGC 0253',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5814,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5814,27.36,0.4,3,1971,75,NULL,'B','NGC 0253',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5815,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5815,27.39,0.4,3,1971,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 0253',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5816,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5816,27.39,NULL,3.01,1971,NULL,NULL,'IR','NGC 0253',NULL,'1980ApJ...237..655A',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5817,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5817,27.42,0.35,3.05,1971,NULL,NULL,NULL,'NGC 0253',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5818,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5818,27.42,0.47,3.05,1971,75,NULL,'A82, H, raw','NGC 0253',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5819,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5819,27.58,0.47,3.28,1971,75,NULL,'A82, H, inv','NGC 0253',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5820,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5820,27.76,0.47,3.56,1971,75,NULL,'A82, H, cor','NGC 0253',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5821,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5821,27.76,0.08,3.56,1971,74.4,NULL,NULL,'NGC 0253',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5822,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5822,27.86,NULL,3.73,1971,NULL,NULL,'LEDA [April 2006]','NGC 0253',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5823,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5823,28.13,0.47,4.23,1971,53.9,NULL,'Sculptor Group','NGC 0253',NULL,'1984A&A...132..253R',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5824,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 02615','RN',5824,39.67,0.12,815,1972,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 02615',0.056538,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5825,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 02615','RN',5825,40.18,0.25,1030,1972,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 02615',0.056538,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5826,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5826,38.08,0.46,413,1973,70,NULL,NULL,'2MASX J00473470+0040226',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00008,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,11.89475,0.67292,0.031,NULL,66673457415,1041772772,16277699,18.2),(5827,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5827,27.7,0.3,3.47,1974,NULL,NULL,'halo','Scl-MM-Dw1',NULL,'2014ApJ...793L...7S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,11.8955417,-26.38881,0.03,NULL,34832700048,544260938,8504077,NULL),(5828,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5828,27.98,0.32,3.94,1974,NULL,NULL,NULL,'Scl-MM-Dw1',NULL,'2014ApJ...793L...7S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5829,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5829,34.85,0.2,93.3,1975,74.4,NULL,NULL,'CGCG 435-005',NULL,'2013AJ....146...86T',2013,1,0.71,NULL,'G',0.000054,NULL,'15.6g',0.36,'Sc',NULL,NULL,NULL,NULL,1,11.896375,14.15511,0.193,NULL,67462388679,1054099823,16470309,15.6),(5830,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 12892','RN',5830,40.61,0.13,1170,1976,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 12892',0.133448,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5831,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 12892','RN',5831,40.82,0.22,1290,1976,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 12892',0.133448,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5832,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 01423','RN',5832,42.16,0.2,2010,1977,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 01423',0.341782,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5833,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 01423','RN',5833,42.31,0.29,2160,1977,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 01423',0.341782,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5834,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 15994','R',5834,39.71,0.25,760,1978,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 15994',0.152901,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,11.932375,0.10036,0.022,NULL,66673589086,1041774829,16277731,NULL),(5835,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 15994','R',5835,39.96,0.27,852,1978,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 15994',0.152901,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5836,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 15994',NULL,5836,40,0.36,1000,1978,70,NULL,'SN photometric redshift distance, z photo =0.269 +/- 0.058','SDSS-II SN 15994',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5837,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 08793','R',5837,41.55,0.3,1420,1979,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J004745.05-003352.6',0.43623,'2014arXiv1401.3317S',2014,1,0.04,NULL,'G',NULL,'PHOT','22.0g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,11.93775,-0.56461,0.017,NULL,34511577796,539243403,8425678,22),(5838,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 08793','R',5838,41.84,0.33,1630,1979,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J004745.05-003352.6',0.43623,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5839,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 08793',NULL,5839,41.73,0.23,2220,1979,70,NULL,'SALT 2','SDSS J004745.05-003352.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5840,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 08793',NULL,5840,41.81,0.23,2300,1979,70,NULL,'SALT 2, Malmquist cor.','SDSS J004745.05-003352.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5841,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 15564','RN',5841,42.05,0.23,1850,1980,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15564',0.392503,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5842,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 15564','RN',5842,42.56,0.25,2330,1980,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15564',0.392503,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5843,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5843,34.09,0.48,65.7,1981,70,NULL,NULL,'MCG -02-03-015',NULL,'2014MNRAS.445.2677S',2014,1,2.08,NULL,'G',0.000033,NULL,'14.2g',0.43,'(R\')SBb:','Line-of-sight pair member',NULL,NULL,NULL,1,11.9435,-9.83506,0.128,NULL,34530962234,539546284,8430410,14.2),(5844,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5844,34.29,0.47,72.2,1981,NULL,NULL,'H','MCG -02-03-015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5845,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5845,34.34,0.33,73.6,1981,NULL,NULL,NULL,'MCG -02-03-015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5846,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5846,34.36,0.46,74.3,1981,NULL,NULL,'J','MCG -02-03-015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5847,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5847,34.37,0.45,74.8,1981,NULL,NULL,'K','MCG -02-03-015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5848,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5848,34.38,0.32,75.1,1981,NULL,NULL,'Malmquist cor.','MCG -02-03-015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5849,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5849,34.38,0.2,75.2,1981,74.4,NULL,NULL,'MCG -02-03-015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5850,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5850,34.44,0.49,77.2,1981,75,NULL,'IR','MCG -02-03-015',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5851,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5851,34.51,0.4,79.7,1981,NULL,NULL,'mean','MCG -02-03-015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5852,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5852,31.51,0.4,20,1982,75,NULL,'B','NGC 0255',NULL,'1988NBGC.C....0000T',1988,1,3,'Confused HIPASS source','G',0.000013,NULL,'12.36',2.5,'SAB(rs)bc',NULL,NULL,NULL,NULL,1,11.947125,-11.46869,0.097,NULL,35248955744,550764933,8605702,12.36),(5853,'Tully est','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5853,31.13,0.8,16.8,1983,75,NULL,NULL,'UGCA 014',NULL,'1988NBGC.C....0000T',1988,1,3.51,NULL,'G',0.000009,NULL,'14.6g',0.37,'SBd pec sp','Line-of-sight pair member',NULL,NULL,NULL,1,11.948083,-9.89953,0.128,NULL,34530970891,539546420,8430412,14.6),(5854,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5854,30.88,0.4,15,1983,73,NULL,'opt','UGCA 014',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5855,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5855,30.99,NULL,15.8,1983,NULL,NULL,NULL,'UGCA 014',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5856,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5856,31.02,NULL,16,1983,NULL,NULL,'Dipole + Quadrupole + Octopole','UGCA 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5857,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5857,31.04,NULL,16.1,1983,NULL,NULL,'Dipole + Quadrupole','UGCA 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5858,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5858,31.05,NULL,16.2,1983,NULL,NULL,'Dipole','UGCA 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5859,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5859,31.1,0.2,16.6,1983,74.4,NULL,NULL,'UGCA 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5860,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5860,31.13,0.59,16.8,1983,NULL,NULL,'Malmquist cor.','UGCA 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5861,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5861,31.15,0.59,17,1983,NULL,NULL,NULL,'UGCA 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5862,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5862,31.28,0.43,18.1,1983,75,NULL,'3.6 micron, color corrected','UGCA 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5863,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5863,31.31,0.43,18.2,1983,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5864,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5864,36.68,0.6,217,1984,70,NULL,NULL,'2MASX J00474753-1237282',NULL,'2014MNRAS.445.2677S',2014,1,NULL,'The APM image includes a superposed star.','G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,11.948083,-12.62461,0.084,NULL,35366852827,552607075,8634485,16.3),(5865,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5865,32.95,0.69,38.8,1985,100,NULL,'mid-IR','MCG -02-03-018',NULL,'2013ApJ...771...88L',2013,1,1,NULL,'G',0.000027,NULL,'14.16',0.5,'Sd',NULL,NULL,NULL,NULL,1,11.9515,-9.37875,0.132,NULL,34530070428,539532350,8430192,14.16),(5866,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5866,38.51,0.46,504,1986,70,NULL,NULL,'2MASX J00475089+0059304',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000082,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,11.9620417,0.99164,0.005,NULL,66676160090,1041815001,16278359,17.6),(5867,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5867,36.05,0.73,162,1987,70,NULL,NULL,'2MASX J00475177-4813539',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'16.99',0.29,NULL,NULL,NULL,NULL,NULL,1,11.96575,-48.23169,NULL,NULL,38146667373,596041677,9313151,16.99),(5868,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5868,35.04,0.81,102,1988,NULL,NULL,'Malmquist cor.','SDSS J004752.07-093847.3',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000023,NULL,'16.0g',0.42,'Scd',NULL,NULL,NULL,NULL,1,11.9669583,-9.6465,0.12,NULL,34530102966,539532858,8430200,16),(5869,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5869,35.33,0.71,117,1988,NULL,NULL,NULL,'SDSS J004752.07-093847.3',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5870,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 20867',NULL,5870,36.6,1.51,209,1989,70,NULL,'SN photometric redshift distance, z photo =0.050 +/- 0.053','SDSS-II SN 20867',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,11.971875,-0.67233,0.017,NULL,34511523353,539242552,8425664,NULL),(5871,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5871,33.75,0.2,56.2,1990,74.4,NULL,NULL,'NGC 0251',NULL,'2013AJ....146...86T',2013,1,2.4,NULL,'G',0.000017,NULL,'13.90',1.9,'Sc','Pair member (points to parent)',NULL,NULL,NULL,1,11.975125,19.59683,0.057,NULL,67490110719,1054532979,16477077,13.9),(5872,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5872,33.87,0.61,59.4,1990,NULL,NULL,NULL,'NGC 0251',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5873,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5873,33.92,0.4,60.9,1990,NULL,NULL,'mean','NGC 0251',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5874,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5874,34.06,0.46,65,1990,NULL,NULL,'J','NGC 0251',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5875,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5875,34.07,0.47,65.2,1990,NULL,NULL,'H','NGC 0251',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5876,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5876,34.07,0.45,65.2,1990,NULL,NULL,'K','NGC 0251',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5877,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5877,34.12,0.55,66.7,1990,NULL,NULL,'Malmquist cor.','NGC 0251',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5878,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5878,37.77,0.46,359,1991,70,NULL,NULL,'SDSS J004755.65-101404.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000075,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,11.981917,-10.23458,0.131,NULL,34528289644,539504525,8429758,18.6),(5879,'IRAS','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5879,34.19,0.8,68.9,1992,75,NULL,'A82, H','NGC 0257',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000007,NULL,'13.3',1.3,'Scd:',NULL,NULL,NULL,NULL,1,12.0062917,8.29708,0.181,NULL,66670804478,1041731319,16277051,13.3),(5880,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5880,33.48,0.69,49.7,1992,100,NULL,'mid-IR','NGC 0257',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5881,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5881,33.88,0.33,59.9,1992,91,NULL,'H','NGC 0257',NULL,'1984ApJ...278..475B',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5882,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5882,34.14,0.2,67.3,1992,74.4,NULL,NULL,'NGC 0257',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5883,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5883,34.15,0.29,67.7,1992,NULL,NULL,NULL,'NGC 0257',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5884,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5884,34.21,0.28,69.5,1992,NULL,NULL,'Malmquist cor.','NGC 0257',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5885,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5885,34.24,0.45,70.3,1992,NULL,NULL,'K','NGC 0257',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5886,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5886,34.26,0.47,71,1992,NULL,NULL,'H','NGC 0257',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5887,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5887,34.28,0.4,71.7,1992,NULL,NULL,'mean','NGC 0257',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5888,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5888,34.28,0.46,71.7,1992,NULL,NULL,'J','NGC 0257',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5889,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5889,34.31,0.47,72.8,1992,75,NULL,'A82, H, raw','NGC 0257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5890,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5890,34.5,0.47,79.5,1992,75,NULL,'A82, H, cor','NGC 0257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5891,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5891,34.55,0.47,81.3,1992,75,NULL,'A82, H, inv','NGC 0257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5892,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 1998de',NULL,5892,34.1,0.09,66.1,1993,74.4,NULL,NULL,'NGC 0252',NULL,'2013AJ....146...86T',2013,1,1.5,'HOLM 023A,E are stars.','G',0.000043,NULL,'12.9B',1.1,'(R)SA(r)0+:','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,12.00625,27.62364,0.177,NULL,67326331139,1051973924,16437092,12.9),(5893,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 1998de',NULL,5893,34.15,0.24,66.5,1993,72,NULL,NULL,'NGC 0252',0.01665,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5894,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 1998de',NULL,5894,34.4,0.08,73.4,1993,65,NULL,'MLCS2k2','NGC 0252',0.01665,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5895,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 1998de',NULL,5895,34.45,0.21,76.3,1993,65,NULL,'MLCS31','NGC 0252',0.01665,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5896,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 1998de',NULL,5896,34.46,0.21,76.8,1993,65,NULL,'MLCS17','NGC 0252',0.01665,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5897,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 1998de',NULL,5897,34.87,0.3,92.6,1993,70,NULL,'SALT','NGC 0252',0.01665,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5898,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 17202','RN',5898,38.09,0.44,376,1994,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 17202',0.104594,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5899,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 17202','RN',5899,38.52,0.25,458,1994,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 17202',0.104594,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5900,'IRAS','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5900,33.42,0.8,48.2,1995,75,NULL,'MAT, I','NGC 0259',NULL,'1997ApJS..109..333W',1997,1,2.8,'HOLM 022B is a star.','G',0.000021,NULL,'13.56',0.6,'Sbc: sp        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,12.0137083,-2.77533,0.168,NULL,34525484342,539460692,8429073,13.56),(5901,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5901,33.06,0.47,40.8,1995,NULL,NULL,'H','NGC 0259',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5902,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5902,33.06,0.46,40.9,1995,NULL,NULL,'J','NGC 0259',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5903,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5903,33.11,0.45,41.8,1995,NULL,NULL,'K','NGC 0259',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5904,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5904,33.18,0.43,43.3,1995,75,NULL,'MAT, I, raw','NGC 0259',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5905,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5905,33.27,0.2,45.1,1995,74.4,NULL,NULL,'NGC 0259',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5906,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5906,33.31,0.49,46,1995,75,NULL,'IR','NGC 0259',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5907,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5907,33.33,0.32,46.3,1995,85,NULL,'I, raw','NGC 0259',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5908,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5908,33.39,0.32,47.6,1995,85,NULL,'I, inv','NGC 0259',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5909,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5909,33.44,0.43,48.8,1995,75,NULL,'MAT, I, inv','NGC 0259',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5910,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5910,33.49,0.47,49.8,1995,NULL,NULL,NULL,'NGC 0259',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5911,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5911,33.55,0.45,51.3,1995,NULL,NULL,'Malmquist cor.','NGC 0259',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5912,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5912,33.59,0.43,52.3,1995,75,NULL,'MAT, I, cor','NGC 0259',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5913,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5913,33.78,0.4,57,1995,NULL,NULL,'mean','NGC 0259',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5914,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5914,33.98,0.47,62.4,1996,70,NULL,NULL,'UGC 00492',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000073,NULL,'14.28',0.7,'E+: sp',NULL,NULL,NULL,NULL,1,12.0212083,-1.56583,0.077,NULL,34512117051,539251828,8425809,14.28),(5915,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 10506',NULL,5915,34.94,3.34,97.4,1997,70,NULL,'SN photometric redshift distance, z photo =0.023 +/- 0.089','SDSS-II SN 10506',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,12.0265417,0.50017,0.075,NULL,66673045195,1041766331,16277598,NULL),(5916,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 21081',NULL,5916,38.79,0.95,573,1998,70,NULL,'SN photometric redshift distance, z photo =0.144 +/- 0.090','SDSS-II SN 21081',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,12.0314583,-0.55572,0.036,NULL,34511399919,539240623,8425634,NULL),(5917,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 05856','RN',5917,40.89,0.12,1160,1999,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 05856',0.303469,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5918,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 05856','RN',5918,41.44,0.21,1490,1999,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 05856',0.303469,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5919,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5919,35.93,0.5,153,2000,70,NULL,NULL,'2MASX J00481792-6454263',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'16.39',0.32,NULL,NULL,NULL,NULL,NULL,1,12.074667,-64.90731,0,NULL,36096857696,564013401,8812709,16.39),(5920,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5920,37.93,0.46,385,2001,70,NULL,NULL,'2MASX J00481870-0911547',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00008,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,12.0780833333,-9.1985,0.133,NULL,34530614226,539540847,8430325,17.5),(5921,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 06260','RN',5921,40.88,0.17,1330,2002,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 06260',0.130051,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5922,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 06260','RN',5922,41.58,0.35,1840,2002,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 06260',0.130051,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5923,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 08351','RN',5923,41.53,0.27,1460,2003,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 08351',0.381125,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5924,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 08351','RN',5924,41.54,0.24,1470,2003,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 08351',0.381125,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5925,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 08351','N',5925,41.42,0.17,1920,2003,70,NULL,'SALT 2','SDSS-II SN 08351',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5926,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 08351','N',5926,41.48,0.17,1980,2003,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 08351',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5927,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 07842','RN',5927,41.73,0.25,1790,2004,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 07842',0.237814,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5928,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 07842','RN',5928,42.39,0.37,2430,2004,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 07842',0.237814,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5929,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5929,36.69,0.46,218,2005,70,NULL,NULL,'2MASX J00483047-1017427',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000106,NULL,'16.2g',0.37,'E0',NULL,NULL,NULL,NULL,1,12.1269166667,-10.29536,0.121,NULL,34528323491,539505054,8429766,16.2),(5930,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5930,32.93,NULL,38.6,2006,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 295- G 007',NULL,'2010Ap&SS.325..163P',2010,1,1.78,NULL,'G',0.000027,NULL,'15.51',0.24,'Scd',NULL,NULL,NULL,NULL,1,12.1352083333,-40.17369,NULL,NULL,38164503678,596320369,9317505,15.51),(5931,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5931,32.96,NULL,39.1,2006,NULL,NULL,'Dipole + Quadrupole','ESO 295- G 007',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5932,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5932,32.97,NULL,39.3,2006,NULL,NULL,NULL,'ESO 295- G 007',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5933,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5933,32.99,NULL,39.7,2006,NULL,NULL,'Dipole','ESO 295- G 007',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5934,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5934,37.36,0.33,297,2007,70,NULL,NULL,'2MASX J00483345+1542235',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00008,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,12.1394166667,15.70653,0.165,NULL,67467888309,1054185754,16471652,17.5),(5935,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5935,37.36,0.33,297,2008,70,NULL,NULL,'2MASX J00483718+1535054',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000068,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,12.154917,15.58475,0.165,NULL,67467898508,1054185914,16471654,17.7),(5936,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 19104','RN',5936,42.1,0.62,1790,2009,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19104',0.468259,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5937,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5937,37.13,0.46,267,2010,70,NULL,NULL,'SDSS J004847.01+154232.1',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.1g',0.35,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,12.1959166667,15.70894,0.165,NULL,67588685951,1056073217,16501144,16.1),(5938,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 03903','RN',5938,40.52,0.32,1220,2011,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 03903',0.04424,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5939,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5939,36.92,0.46,242,2012,70,NULL,NULL,'2MASX J00484998-0952116',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000065,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,12.208375,-9.86989,0.14,NULL,34531033744,539547402,8430428,17.3),(5940,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 19804','R',5940,41.14,0.18,1390,2013,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19804',0.217599,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,12.2157083333,-0.216,0.019,NULL,34511518405,539242475,8425663,NULL),(5941,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 19804','R',5941,41.43,0.29,1590,2013,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19804',0.217599,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5942,'GRB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5942,43.22,1.37,2410,2014,72,NULL,NULL,'GRB 050824',0.828,'2008JCAP...07..004M',2008,1,NULL,NULL,'VisS',0.005,NULL,'23.6R',NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,12.2342083,22.60919,0.081,NULL,67481534832,1054398981,16474984,23.6),(5943,'GRB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5943,43.35,1.29,2560,2014,70,NULL,NULL,'GRB 050824',0.828,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5944,'GRB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5944,44.07,1.19,3560,2014,69.7,NULL,'Calibrated','GRB 050824',0.828,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5945,'GRB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5945,44.65,1.19,4660,2014,69.7,NULL,'Fiducial','GRB 050824',0.828,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5946,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5946,36.66,0.46,215,2015,70,NULL,NULL,'2MASX J00485688-0055178',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000056,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,12.2372083,-0.92169,0.076,NULL,34514925483,539295710,8426495,17.1),(5947,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 2005gu',NULL,5947,40.51,0.16,951,2016,74.2,NULL,'SALT 2','SDSS J004857.03-005419.6',0.33,'2010ApJ...716..712A',2010,1,0.03,NULL,'G',0.0005,NULL,'23.0g',0.03,NULL,NULL,NULL,NULL,NULL,1,12.237625,-0.90547,0.031,NULL,34514913498,539295523,8426492,23),(5948,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 2005gu',NULL,5948,40.46,0.16,1230,2016,70,NULL,'Hubble residual 0.07 for z0.33200','SDSS J004857.03-005419.6',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5949,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 04241','R',5949,41.22,0.26,1320,2016,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005gu','SDSS J004857.03-005419.6',0.332,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5950,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 2005gu',NULL,5950,41.24,0.16,1330,2016,65,NULL,'SALT2','SDSS J004857.03-005419.6',0.33,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5951,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 04241','R',5951,41.3,0.2,1370,2016,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005gu','SDSS J004857.03-005419.6',0.332,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5952,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 2005gu',NULL,5952,41.32,0.18,1380,2016,70,NULL,'SALT 2','SDSS J004857.03-005419.6',0.33,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5953,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 2005gu',NULL,5953,41.45,0.15,1470,2016,65,NULL,'MLCS2k2','SDSS J004857.03-005419.6',0.33,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5954,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 16953','R',5954,41.62,0.32,1570,2017,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006pp','SN 2006pp',0.339207,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,12.243625,0.47694,0.04,NULL,66676487932,1041820123,16278439,NULL),(5955,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 16953','R',5955,41.79,0.31,1710,2017,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006pp','SN 2006pp',0.339207,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5956,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 18903','R',5956,39.16,0.1,587,2018,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2007lr','SN 2007lr',0.15627,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,12.2514166667,-0.324,0.046,NULL,34511484240,539241941,8425655,NULL),(5957,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 18903','R',5957,39.32,0.19,633,2018,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2007lr','SN 2007lr',0.15627,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5958,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 17473','RN',5958,40.27,0.28,967,2019,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17473',0.170417,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5959,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 17473','RN',5959,40.46,0.23,1060,2019,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17473',0.170417,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5960,'IRAS','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5960,34.12,0.8,66.7,2020,75,NULL,'W91PP, r','UGC 00501',NULL,'1997ApJS..109..333W',1997,1,1.95,NULL,'G',0.000018,NULL,'15.17',0.22,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,12.25875,28.21806,0.193,NULL,67317572152,1051837064,16434954,15.17),(5961,'IRAS','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5961,34.12,0.8,66.8,2020,75,NULL,'HMCL, I','UGC 00501',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5962,'IRAS','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5962,34.13,0.8,66.9,2020,75,NULL,'W91CL, r','UGC 00501',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5963,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5963,34.1,0.49,65.9,2020,75,NULL,'IR','UGC 00501',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5964,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5964,34.15,0.13,67.7,2020,NULL,NULL,NULL,'UGC 00501',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5965,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5965,34.19,0.4,68.8,2020,75,NULL,'HMCL, I, raw','UGC 00501',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5966,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5966,34.22,0.43,69.8,2020,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00501',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5967,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5967,34.23,0.4,70.1,2020,NULL,NULL,'mean','UGC 00501',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5968,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5968,34.26,0.38,71.2,2020,75,NULL,'W91PP, r, raw','UGC 00501',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5969,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5969,34.27,0.43,71.4,2020,75,NULL,'3.6 micron, color corrected','UGC 00501',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5970,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5970,34.3,0.38,72.5,2020,75,NULL,'W91CL, r, raw','UGC 00501',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5971,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5971,34.32,0.4,73.1,2020,75,NULL,'HMCL, I, cor','UGC 00501',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5972,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5972,34.34,0.2,73.8,2020,74.4,NULL,NULL,'UGC 00501',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5973,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5973,34.36,0.4,74.4,2020,75,NULL,'HMCL, I, inv','UGC 00501',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5974,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5974,34.37,0.38,74.7,2020,75,NULL,'W91PP, r, cor','UGC 00501',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5975,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5975,34.39,0.38,75.3,2020,75,NULL,'W91CL, r, cor','UGC 00501',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5976,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5976,34.4,0.38,75.7,2020,75,NULL,'W91PP, r, inv','UGC 00501',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5977,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5977,34.42,NULL,76.6,2020,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00501',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5978,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5978,34.43,NULL,76.8,2020,NULL,NULL,'Dipole + Quadrupole','UGC 00501',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5979,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5979,34.43,0.38,76.8,2020,75,NULL,'W91CL, r, inv','UGC 00501',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5980,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5980,34.43,NULL,77,2020,NULL,NULL,'Dipole','UGC 00501',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5981,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5981,34.44,0.47,77.3,2020,NULL,NULL,'H','UGC 00501',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5982,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5982,34.48,NULL,78.6,2020,NULL,NULL,NULL,'UGC 00501',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5983,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5983,34.48,0.45,78.9,2020,NULL,NULL,'K','UGC 00501',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5984,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 2007lc',NULL,5984,38.15,0.06,426,2021,70,NULL,'Hubble residual -0.19 for z0.11504','2MASX J00490912+0035472',NULL,'2011ApJ...740...92G',2011,1,0.25,NULL,'G',0.000073,NULL,'17.9g',0.17,'NLAGN',NULL,NULL,NULL,NULL,1,12.288,0.59661,0.03,NULL,66676501951,1041820342,16278442,17.9),(5985,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 18612','R',5985,38.47,0.18,442,2021,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007lc','2MASX J00490912+0035472',0.115027,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5986,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 2007lc',NULL,5986,38.36,0.06,470,2021,70,NULL,'SALT 2','2MASX J00490912+0035472',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5987,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SN 2007lc',NULL,5987,38.37,0.06,472,2021,70,NULL,'SALT 2, Malmquist cor.','2MASX J00490912+0035472',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5988,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 18612','R',5988,38.62,0.07,476,2021,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007lc','2MASX J00490912+0035472',0.115027,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5989,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','PTF10wnq','N',5989,37.72,0.03,327,2022,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10wnq',0.0691,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5990,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5990,38.12,0.23,420,2023,70,NULL,NULL,'SDSS J004910.71+005755.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000072,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,12.294625,0.96533,0.033,NULL,66676796175,1041824940,16278514,18.6),(5991,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 16552','RN',5991,38.43,0.17,437,2024,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16552',0.110034,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5992,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5992,36.36,0.72,187,2025,70,NULL,NULL,'2MASX J00491474-4750379',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'17.31',0.17,NULL,NULL,NULL,NULL,NULL,1,12.3115,-47.84392,NULL,NULL,38145469110,596022954,9312858,17.31),(5993,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',5993,36.69,0.46,217,2026,70,NULL,NULL,'2MASX J00491853+1452591',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000105,NULL,'17.4g',0.19,'NLAGN',NULL,NULL,NULL,NULL,1,12.327167,14.88314,0.141,NULL,67588318711,1056067479,16501054,17.4),(5994,'CMD','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5994,27.76,NULL,3.56,2027,NULL,NULL,NULL,'ESO 540- G 030',NULL,'2012ApJ...748...47M',2012,1,2.8,NULL,'G',0.00001,NULL,'16.3B',2.2,'IABm','Brightest group member',NULL,NULL,NULL,1,12.3373333333,-18.07542,0.065,NULL,35320453876,551882091,8623157,16.3),(5995,'SBF','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5995,27.52,0.08,3.19,2027,NULL,NULL,NULL,'ESO 540- G 030',NULL,'1998AJ....116.2873J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5996,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5996,27.61,0.02,3.33,2027,NULL,NULL,'I','ESO 540- G 030',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5997,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5997,27.66,0.22,3.4,2027,NULL,NULL,NULL,'ESO 540- G 030',NULL,'2003A&A...404...93K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5998,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5998,27.68,0.06,3.44,2027,NULL,NULL,NULL,'ESO 540- G 030',NULL,'2013A&A...550A...7L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5999,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,5999,27.71,0.08,3.48,2027,74.4,NULL,NULL,'ESO 540- G 030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6000,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6000,27.75,0.04,3.55,2027,NULL,NULL,'I','ESO 540- G 030',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6001,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 16417',NULL,6001,40.02,0.35,1010,2028,70,NULL,'SN photometric redshift distance, z photo =0.272 +/- 0.057','SDSS-II SN 16417',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','20.7g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,12.345375,1.21467,0.017,NULL,66675891513,1041810804,16278293,20.7),(6002,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 16417','R',6002,40.92,0.18,1180,2028,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16417',0.292421,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6003,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 16417','R',6003,41.03,0.28,1250,2028,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16417',0.292421,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6004,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 16417',NULL,6004,40.82,0.15,1460,2028,70,NULL,'SALT 2','SDSS-II SN 16417',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6005,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 16417',NULL,6005,40.84,0.15,1470,2028,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16417',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6006,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 13010','RN',6006,38.11,2.27,377,2029,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13010',0.109681,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6007,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 13010','RN',6007,38.45,0.12,442,2029,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13010',0.109681,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6008,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 15737',NULL,6008,40.34,1.25,1170,2030,70,NULL,'SN photometric redshift distance, z photo =0.323 +/- 0.377','SDSS-II SN 15737',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.4g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,12.368417,-0.06017,0.038,NULL,34511290347,539238911,8425607,21.4),(6009,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 15737','R',6009,41.21,0.36,1310,2030,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15737',0.332983,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6010,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 15737','R',6010,41.22,0.33,1310,2030,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15737',0.332983,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6011,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 15737',NULL,6011,40.66,0.23,1360,2030,70,NULL,'SALT 2','SDSS-II SN 15737',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6012,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 15737',NULL,6012,40.7,0.23,1380,2030,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15737',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6013,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 10932','RN',6013,40.16,0.72,1020,2031,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10932',0.053486,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6014,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 05553','RN',6014,41.89,0.14,1920,2032,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 05553',0.244248,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6015,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 05553','RN',6015,42.27,0.2,2280,2032,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 05553',0.244248,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6016,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 16125','R',6016,39.13,0.14,600,2033,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 16125',0.116275,'2014arXiv1401.3317S',2014,1,0.17,NULL,'G',NULL,'PHOT','19.4g',0.07,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,12.37375,0.05531,0.038,NULL,66672967104,1041765111,16277579,19.4),(6017,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 16125','R',6017,39.48,0.21,704,2033,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 16125',0.116275,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6018,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 16125',NULL,6018,41.53,0.04,2020,2033,70,NULL,'SN photometric redshift distance, z photo =0.671 +/- 0.017','SDSS-II SN 16125',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6019,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 02290','R',6019,41.28,0.29,1350,2034,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J004930.64+001555.4',0.331,'2014arXiv1401.3317S',2014,1,0.09,NULL,'G',0.01,NULL,'19.9g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,12.3777083,0.26542,0.04,NULL,66672948668,1041764822,16277575,19.9),(6020,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 02290','R',6020,41.62,0.28,1580,2034,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J004930.64+001555.4',0.331,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6021,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 02290',NULL,6021,41.11,0.21,1670,2034,70,NULL,'SALT 2','SDSS J004930.64+001555.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6022,'SNIa','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 02290',NULL,6022,41.15,0.21,1700,2034,70,NULL,'SALT 2, Malmquist cor.','SDSS J004930.64+001555.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6023,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 03203','RN',6023,43.88,0.64,3510,2035,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03203',0.697542,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6024,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6024,36.95,0.53,246,2036,70,NULL,NULL,'2MASX J00493274-0412505',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.00011,NULL,'16.38',0.41,NULL,NULL,NULL,NULL,NULL,1,12.38675,-4.214,0.326,NULL,34518757388,539355584,8427431,16.38),(6025,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6025,34.21,0.47,69.4,2037,NULL,NULL,'H','UGC 00507',NULL,'2007A&A...465...71T',2007,1,2.37,NULL,'G',0.000073,NULL,'14.7g',0.34,'Sd(f)',NULL,NULL,NULL,NULL,1,12.398875,1.11525,0.017,NULL,66676013627,1041812712,16278323,14.7),(6026,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',6026,34.25,0.49,70.8,2037,75,NULL,'IR','UGC 00507',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6027,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6027,34.25,0.45,70.9,2037,NULL,NULL,'K','UGC 00507',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6028,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6028,34.34,0.4,73.7,2037,NULL,NULL,'mean','UGC 00507',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6029,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6029,34.42,0.36,76.5,2037,NULL,NULL,'Malmquist cor.','UGC 00507',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6030,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6030,34.43,0.46,77,2037,NULL,NULL,'J','UGC 00507',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6031,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6031,34.54,0.2,80.9,2037,74.4,NULL,NULL,'UGC 00507',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6032,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6032,34.55,0.34,81.1,2037,NULL,NULL,NULL,'UGC 00507',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6033,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6033,34.59,NULL,82.7,2037,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00507',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6034,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6034,34.59,NULL,82.8,2037,NULL,NULL,'Dipole + Quadrupole','UGC 00507',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6035,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6035,34.6,NULL,83.2,2037,NULL,NULL,'Dipole','UGC 00507',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6036,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6036,34.64,NULL,84.8,2037,NULL,NULL,NULL,'UGC 00507',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6037,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6037,37.32,0.62,291,2038,70,NULL,NULL,'2MASX J00493575-0254245',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.000103,NULL,'17.38',0.23,NULL,NULL,NULL,NULL,NULL,1,12.398875,-2.90683,0.199,NULL,34517779252,539340300,8427192,17.38),(6038,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6038,36.03,0.62,160,2039,70,NULL,NULL,'2MASX J00493650-4725028',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.54',0.28,NULL,NULL,NULL,NULL,NULL,1,12.4020417,-47.41736,NULL,NULL,38145534160,596023971,9312874,16.54),(6039,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',6039,36.39,0.46,189,2040,70,NULL,NULL,'2MASX J00494136-0840339',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000085,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,12.422375,-8.67608,0.123,NULL,34530252645,539535197,8430237,17.2),(6040,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',6040,36.92,0.46,243,2041,70,NULL,NULL,'2MASX J00494242+0046447',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00007,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,12.42675,0.77917,0.03,NULL,66676692363,1041823318,16278489,17.3),(6041,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',6041,38.12,0.23,420,2042,70,NULL,NULL,'2MASX J00494288+0100207',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000097,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,12.428625,1.00586,0.017,NULL,66675967045,1041811985,16278312,16.4),(6042,'BL Lac Luminosity','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6042,41.81,NULL,2300,2043,70,NULL,'nucleus-to-host flux ratio, z > 0.82','PKS 0047+023',NULL,'2006AJ....132....1S',2006,1,NULL,NULL,'QSO',NULL,'PHOT','18.0',NULL,'BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,12.430167,2.61772,0.045,NULL,66687018761,1041984668,16281010,18),(6043,'IRAS','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6043,34.15,0.8,67.5,2044,75,NULL,'W91PP, r','UGC 00509',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'15.95',0.5,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,12.4392917,31.60033,0.213,NULL,67338249250,1052160144,16440002,15.95),(6044,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6044,33.76,NULL,56.5,2044,NULL,NULL,'I','UGC 00509',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6045,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6045,34.16,0.2,67.9,2044,74.4,NULL,NULL,'UGC 00509',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6046,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6046,34.21,0.11,69.6,2044,NULL,NULL,NULL,'UGC 00509',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6047,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6047,34.23,0.38,70.1,2044,75,NULL,'W91PP, r, inv','UGC 00509',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6048,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6048,34.25,0.43,70.9,2044,75,NULL,'3.6 micron, color corrected','UGC 00509',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6049,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6049,34.26,0.38,71.2,2044,75,NULL,'W91PP, r, raw','UGC 00509',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6050,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6050,34.36,0.38,74.4,2044,75,NULL,'W91PP, r, cor','UGC 00509',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6051,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6051,34.36,0.43,74.4,2044,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00509',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6052,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',6052,37.23,0.46,279,2045,70,NULL,NULL,'2MASX J00494671-0847323',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000078,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,12.4447083333,-8.79247,0.123,NULL,34530218267,539534660,8430229,16.8),(6053,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6053,36.14,0.5,169,2046,70,NULL,NULL,'2MASX J00494722-6139127',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.75',0.23,NULL,NULL,NULL,NULL,NULL,1,12.4467916667,-61.65361,0,NULL,36091211997,563925187,8811331,16.75),(6054,'BCG','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6054,38.03,0.35,373,2047,60,NULL,NULL,'ABELL 0104',0.0822,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III:[BM]',NULL,NULL,NULL,NULL,1,12.452083,24.44111,0.101,NULL,67192816722,1049887761,16404496,NULL),(6055,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 13557','RN',6055,36.94,0.16,221,2048,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13557',0.103822,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6056,'SNIa SDSS','2016-12-15 15:13:35','2016-12-16 11:18:37','1','SDSS-II SN 13557','RN',6056,40.82,0.35,1320,2048,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13557',0.103822,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6057,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',6057,38.12,0.23,420,2049,70,NULL,NULL,'2MASX J00494855+0059057',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000094,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,12.4522083,0.98486,0.017,NULL,66675972227,1041812066,16278313,16.7),(6058,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6058,27.53,0.1,3.21,2050,NULL,NULL,NULL,'UGCA 015',NULL,'2012A&A...540A..49M',2012,1,1.7,NULL,'G',0.000001,NULL,'15.1B',0.7,'IB(s)m:','Possible group member',NULL,NULL,NULL,1,12.455,-21.015,0.06,NULL,35330766007,552043218,8625675,15.1),(6059,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6059,27.6,0.04,3.31,2050,NULL,NULL,'I','UGCA 015',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6060,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6060,27.62,0.16,3.34,2050,NULL,NULL,NULL,'UGCA 015',NULL,'2003A&A...404...93K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6061,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6061,27.65,0.08,3.39,2050,74.4,NULL,NULL,'UGCA 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6062,'TRGB','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6062,27.67,0.1,3.42,2050,NULL,NULL,'I','UGCA 015',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6063,'Tully est','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6063,27.87,0.8,3.7,2050,75,NULL,NULL,'UGCA 015',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6064,'BCG','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6064,38.03,0.35,373,2051,60,NULL,'ABELL 0104, BCG','2MASX J00494980+2427021',0.0822,'1980ApJ...241..486H',1980,1,NULL,NULL,'G',0.000127,NULL,'17.4O',NULL,'AGN:','Brightest group member',NULL,NULL,NULL,1,12.4575416667,24.45058,0.101,NULL,67192817458,1049887772,16404496,17.4),(6065,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',6065,36.41,0.46,191,2052,70,NULL,NULL,'2MASX J00494990+1533587',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000071,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,12.457917,15.56636,0.161,NULL,67588838628,1056075603,16501181,17.1),(6066,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6066,34.21,0.37,69.5,2053,NULL,NULL,NULL,'CGCG 384-011',NULL,'2009ApJS..182..474S',2009,1,0.8,'SDSS position (and spectrum?) refers to SE corner of CGCG 384-011.','G',0.000042,NULL,'17.37',0.3,NULL,NULL,NULL,NULL,NULL,1,12.46725,0.96319,0.025,NULL,66675972902,1041812076,16278313,17.37),(6067,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6067,34.22,0.2,69.8,2053,74.4,NULL,NULL,'CGCG 384-011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6068,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6068,34.32,0.35,73.3,2053,NULL,NULL,'Malmquist cor.','CGCG 384-011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6069,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',6069,34.37,0.49,74.7,2053,75,NULL,'IR','CGCG 384-011',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6070,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',6070,37.88,0.33,377,2054,70,NULL,NULL,'SDSS J004954.16-010347.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000072,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,12.4757083333,-1.06325,0.076,NULL,34513967469,539280741,8426261,18.5),(6071,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',6071,37.69,0.46,346,2055,70,NULL,NULL,'2MASX J00495782+0034107',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000083,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,12.490917,0.56975,0.059,NULL,66676413395,1041818959,16278421,17.2),(6072,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',6072,38.12,0.23,420,2056,70,NULL,NULL,'SDSS J004957.94+010020.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,12.4914583,1.00572,0.025,NULL,66675979164,1041812174,16278315,18.7),(6073,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6073,33.67,0.2,54.2,2057,74.4,NULL,NULL,'UGC 00510',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000033,NULL,'15.08',0.3,'Scd:',NULL,NULL,NULL,NULL,1,12.492583,21.71764,0.065,NULL,67481101138,1054392205,16474878,15.08),(6074,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6074,33.79,0.42,57.4,2057,NULL,NULL,NULL,'UGC 00510',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6075,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',6075,34,0.49,63,2057,75,NULL,'IR','UGC 00510',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6076,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6076,34.24,0.34,70.5,2057,NULL,NULL,'Malmquist cor.','UGC 00510',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6077,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6077,37.36,0.7,296,2058,70,NULL,NULL,'2MASX J00495987-0359556',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00008,NULL,'17.39',0.21,NULL,NULL,NULL,NULL,NULL,1,12.499583,-3.99881,0.271,NULL,34518809105,539356392,8427443,17.39),(6078,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6078,37.35,0.63,295,2059,70,NULL,NULL,'2MASX J00500038-0539176',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'15.72',0.45,NULL,NULL,NULL,NULL,NULL,1,12.501667,-5.65492,0.207,NULL,34544712087,539761126,8433767,15.72),(6079,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',6079,37.88,0.33,377,2060,70,NULL,NULL,'2MASX J00500042-0106116',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000087,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,12.501875,-1.10317,0.087,NULL,34514129816,539283278,8426301,17.1),(6080,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6080,36.14,0.47,169,2061,70,NULL,NULL,'MCG -03-03-004',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.12',0.5,NULL,NULL,NULL,NULL,NULL,1,12.503833,-14.68247,0.01,NULL,35372825500,552700398,8635943,15.12),(6081,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6081,34.25,0.34,70.8,2062,NULL,NULL,NULL,'UGC 00512',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000007,NULL,'14.78',0.6,'Sdm:',NULL,NULL,NULL,NULL,1,12.5114583,7.91881,0.185,NULL,66671502744,1041742230,16277222,14.78),(6082,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6082,34.28,0.34,71.8,2062,NULL,NULL,'Malmquist cor.','UGC 00512',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6083,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6083,34.41,0.2,76.2,2062,74.4,NULL,NULL,'UGC 00512',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6084,'IRAS','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6084,31.7,0.8,21.8,2063,75,NULL,'MAT, I','ESO 079- G 007',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000024,NULL,'13.70',1.3,'SA0^0^ pec',NULL,NULL,NULL,NULL,1,12.515667,-66.55328,0,NULL,36314791025,567418609,8865915,13.7),(6085,'Tully est','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6085,31.45,0.8,19.5,2063,75,NULL,NULL,'ESO 079- G 007',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6086,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6086,31.95,0.32,24.6,2063,85,NULL,'I, inv','ESO 079- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6087,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6087,31.96,0.32,24.7,2063,85,NULL,'I, raw','ESO 079- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6088,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6088,32.17,0.43,27.1,2063,75,NULL,'MAT, I, raw','ESO 079- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6089,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6089,32.17,0.43,27.2,2063,75,NULL,'MAT, I, inv','ESO 079- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6090,'Tully-Fisher','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,NULL,6090,32.42,0.43,30.5,2063,75,NULL,'MAT, I, cor','ESO 079- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6091,'FP','2016-12-15 15:13:35','2016-12-16 11:18:37','1',NULL,'R',6091,37.34,0.46,293,2064,70,NULL,NULL,'2MASXi J0050059-110251',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000071,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,12.5247083333,-11.04778,0.114,NULL,35249800196,550778128,8605908,17.8),(6092,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6092,36.67,0.58,216,2065,70,NULL,NULL,'2MASX J00500829-0422596',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.43',0.27,NULL,NULL,NULL,NULL,NULL,1,12.5345,-4.38317,0.279,NULL,34515218989,539300296,8426567,16.43),(6093,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6093,34.4,0.4,76,2066,NULL,NULL,'mean','NGC 0268',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000013,NULL,'13.41',1.1,'SB(s)bc:       HII',NULL,NULL,NULL,NULL,1,12.539833,-5.19372,0.2,NULL,34545124284,539767566,8433868,13.41),(6094,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6094,35.28,NULL,114,2066,NULL,NULL,'B','NGC 0268',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6095,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6095,35.99,0.46,158,2066,NULL,NULL,'J','NGC 0268',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6096,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6096,36.02,0.45,160,2066,NULL,NULL,'K','NGC 0268',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6097,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6097,36.07,0.47,164,2066,NULL,NULL,'H','NGC 0268',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6098,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6098,36.17,NULL,171,2066,NULL,NULL,'I','NGC 0268',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6099,'IRAS','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6099,33.79,0.8,57.3,2067,75,NULL,'W91PP, r','UGC 00511',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'15.29',0.4,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,12.540583,31.73125,0.213,NULL,67338115607,1052158056,16439969,15.29),(6100,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6100,33.59,NULL,52.2,2067,NULL,NULL,'B','UGC 00511',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6101,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6101,34,0.13,63.2,2067,NULL,NULL,NULL,'UGC 00511',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6102,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6102,34.27,0.2,71.5,2067,74.4,NULL,NULL,'UGC 00511',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6103,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6103,34.28,NULL,71.8,2067,NULL,NULL,'I','UGC 00511',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6104,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6104,34.33,0.38,73.5,2067,75,NULL,'W91PP, r, raw','UGC 00511',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6105,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6105,34.37,0.38,74.7,2067,75,NULL,'W91PP, r, inv','UGC 00511',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6106,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6106,34.39,0.43,75.4,2067,75,NULL,'3.6 micron, color corrected','UGC 00511',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6107,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6107,34.42,0.38,76.4,2067,75,NULL,'W91PP, r, cor','UGC 00511',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6108,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6108,34.52,0.49,80,2067,75,NULL,'IR','UGC 00511',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6109,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6109,34.55,0.43,81.3,2067,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00511',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6110,'SNIa','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SN 2007mb',NULL,6110,39.23,0.11,701,2068,70,NULL,'Hubble residual -0.10 for z0.18940','SDSS J005011.17+004032.5',NULL,'2011ApJ...740...92G',2011,1,0.11,NULL,'G',0.0005,NULL,'19.2g',0.1,NULL,NULL,NULL,NULL,NULL,1,12.546583,0.67572,0.059,NULL,66676449799,1041819528,16278430,19.2),(6111,'SNIa','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 18749','R',6111,39.76,0.2,752,2068,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007mb','SDSS J005011.17+004032.5',0.1894,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6112,'SNIa','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 18749','R',6112,39.9,0.12,802,2068,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007mb','SDSS J005011.17+004032.5',0.1894,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6113,'SNIa','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SN 2007mb',NULL,6113,39.55,0.08,813,2068,70,NULL,'SALT 2','SDSS J005011.17+004032.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6114,'SNIa','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SN 2007mb',NULL,6114,39.56,0.08,817,2068,70,NULL,'SALT 2, Malmquist cor.','SDSS J005011.17+004032.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6115,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6115,37.4,0.46,302,2069,70,NULL,NULL,'2MASX J00501658+1607056',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00007,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,12.5689583,16.11831,0.113,NULL,67590719371,1056104990,16501640,18),(6116,'TRGB','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'N',6116,27.47,0.2,3.12,2070,NULL,NULL,NULL,'NGC 0253 Scl-MM-Dw2',NULL,'2016ApJ...816L...5T',2016,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6117,'TRGB','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'N',6117,27.7,0.1,3.5,2070,NULL,NULL,NULL,'NGC 0253 Dwarf 2',NULL,'2016MNRAS.457L.103R',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6118,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6118,37.32,0.46,291,2071,70,NULL,NULL,'2MASX J00501951-1002457',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000078,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,12.5812083333,-10.04608,0.136,NULL,34527875636,539498056,8429657,17.6),(6119,'SNIa','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 05702',NULL,6119,39.8,0.22,914,2072,70,NULL,'SN photometric redshift distance, z photo =0.242 +/- 0.030','SDSS-II SN 05702',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,12.58325,-0.91914,0.091,NULL,34514006915,539281358,8426271,NULL),(6120,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6120,34.63,NULL,84.3,2073,NULL,NULL,'B','ESO 295- G 012',NULL,'2005Ap&SS.298..577R',2005,1,0.95,NULL,'G',0.000033,NULL,'14.58',0.6,'Sb-c',NULL,NULL,NULL,NULL,1,12.5865833333,-41.24325,NULL,NULL,38164141785,596314715,9317417,14.58),(6121,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6121,34.63,NULL,84.3,2073,NULL,NULL,'I','ESO 295- G 012',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6122,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6122,34.85,0.4,93.4,2073,NULL,NULL,'mean','ESO 295- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6123,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6123,35.15,0.44,107,2073,NULL,NULL,'Malmquist cor.','ESO 295- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6124,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6124,35.2,0.47,110,2073,NULL,NULL,'H','ESO 295- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6125,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6125,35.22,0.43,111,2073,NULL,NULL,NULL,'ESO 295- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6126,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6126,35.26,0.2,113,2073,74.4,NULL,NULL,'ESO 295- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6127,'SBF','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6127,26.72,0.13,2.21,2074,NULL,NULL,NULL,'ESO 540- G 032',NULL,'1998AJ....116.2873J',1998,1,1.7,NULL,'G',0.000003,NULL,'16.4B',1,'IAB(s)m pec:',NULL,NULL,NULL,NULL,1,12.601333,-19.90672,0.114,0,35322736764,551917761,8623715,16.4),(6128,'TRGB','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6128,27.64,0.14,3.4,2074,NULL,NULL,NULL,'ESO 540- G 032',NULL,'2001A&A...371..487J',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6129,'TRGB','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6129,27.67,NULL,3.42,2074,NULL,NULL,NULL,'ESO 540- G 032',NULL,'2003A&A...404...93K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6130,'TRGB','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6130,27.72,0.06,3.5,2074,NULL,NULL,NULL,'ESO 540- G 032',NULL,'2013A&A...550A...7L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6131,'TRGB','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6131,27.74,NULL,3.54,2074,NULL,NULL,NULL,'ESO 540- G 032',NULL,'2010ApJ...724.1030G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6132,'TRGB','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6132,27.74,0.04,3.54,2074,NULL,NULL,'I','ESO 540- G 032',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6133,'TRGB','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6133,27.78,0.08,3.6,2074,74.4,NULL,NULL,'ESO 540- G 032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6134,'TRGB','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6134,27.79,0.03,3.61,2074,NULL,NULL,'I','ESO 540- G 032',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6135,'TRGB','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6135,27.84,0.11,3.7,2074,NULL,NULL,NULL,'ESO 540- G 032',NULL,'2008glv..book..123C',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6136,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6136,35.93,NULL,153,2075,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0093',NULL,'2010Ap&SS.325..163P',2010,1,0.73,NULL,'G',0.000022,NULL,'17.45',0.09,'Sc',NULL,NULL,NULL,NULL,1,12.6120417,5.05594,0.089,NULL,66690260199,1042035315,16281801,17.45),(6137,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6137,35.93,NULL,153,2075,NULL,NULL,NULL,'FGC 0093',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6138,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6138,35.96,NULL,156,2075,NULL,NULL,'Dipole + Quadrupole','FGC 0093',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6139,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6139,35.98,NULL,157,2075,NULL,NULL,'Dipole','FGC 0093',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6140,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6140,34.7,0.46,87.2,2076,70,NULL,NULL,'MCG -01-03-018',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000033,NULL,'14.23',1.5,'(R\')SA(r)0-?',NULL,NULL,NULL,NULL,1,12.614625,-5.85847,0.207,NULL,34536475571,539632430,8431756,14.23),(6141,'SNIa','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 21129','RN',6141,42.4,0.31,2160,2077,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21129',0.402047,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6142,'SNIa','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 21129','RN',6142,42.87,0.37,2680,2077,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 21129',0.402047,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6143,'SNIa SDSS','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 11981','RN',6143,39.52,0.89,727,2078,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 11981',0.103355,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6144,'SNIa SDSS','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 11981','RN',6144,39.78,0.67,820,2078,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 11981',0.103355,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6145,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6145,33.17,0.51,43,2079,70,NULL,NULL,'NGC 0270',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000073,NULL,'13.97',1.5,'S0+',NULL,NULL,NULL,NULL,1,12.6355,-8.65164,0.181,NULL,34530361674,539536901,8430264,13.97),(6146,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6146,34.39,NULL,75.5,2080,NULL,NULL,'B','ESO 243- G 003',NULL,'2005Ap&SS.298..577R',2005,1,1,NULL,'G',0.000033,NULL,'15.93',0.6,'Sb-c',NULL,NULL,NULL,NULL,1,12.642417,-43.06386,NULL,NULL,38182992689,596609260,9322019,15.93),(6147,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6147,34.39,NULL,75.5,2080,NULL,NULL,'I','ESO 243- G 003',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6148,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6148,35.45,0.64,123,2080,NULL,NULL,'Malmquist cor.','ESO 243- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6149,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6149,35.6,0.6,132,2080,NULL,NULL,NULL,'ESO 243- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6150,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6150,35.64,0.2,134,2080,74.4,NULL,NULL,'ESO 243- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6151,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6151,35.2,NULL,110,2081,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0094',NULL,'2010Ap&SS.325..163P',2010,1,0.82,NULL,'G',0.000023,NULL,'17.2g',0.13,'Scd(f)',NULL,NULL,NULL,NULL,1,12.651167,14.43317,0.161,NULL,67592438641,1056131853,16502060,17.2),(6152,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6152,35.22,NULL,111,2081,NULL,NULL,'Dipole + Quadrupole','FGC 0094',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6153,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6153,35.24,NULL,111,2081,NULL,NULL,'Dipole','FGC 0094',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6154,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6154,35.27,NULL,113,2081,NULL,NULL,NULL,'FGC 0094',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6155,'SNIa SDSS','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 17979','RN',6155,39.31,0.11,686,2082,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 17979',0.06132,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6156,'SNIa SDSS','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 17979','RN',6156,40.12,0.24,996,2082,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 17979',0.06132,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6157,'SNIa','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 19772','R',6157,39.18,0.12,584,2083,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS J005039.91-010231.2',0.1747,'2014arXiv1401.3317S',2014,1,0.11,NULL,'G',0.0005,NULL,'19.4g',0.08,NULL,NULL,NULL,NULL,NULL,1,12.6662917,-1.042,0.118,NULL,34513981378,539280959,8426264,19.4),(6158,'SNIa','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 19772','R',6158,39.24,0.19,600,2083,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS J005039.91-010231.2',0.1747,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6159,'SNIa','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 19772',NULL,6159,39.03,0.08,640,2083,70,NULL,'SALT 2','SDSS J005039.91-010231.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6160,'SNIa','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 19772',NULL,6160,39.04,0.08,643,2083,70,NULL,'SALT 2, Malmquist cor.','SDSS J005039.91-010231.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6161,'BL Lac Luminosity','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6161,40.2,NULL,1100,2084,70,NULL,'nucleus-to-host flux ratio, z > 0.30','FBQS J0050-0929',NULL,'2006AJ....132....1S',2006,1,NULL,'Redshift may be 0.216 or 0.634 or higher. See 2001AJ....122..565R.','QSO',0,NULL,'17.44',NULL,'Opt.var.       BLLAC',NULL,NULL,NULL,'BL Lac',1,12.672167,-9.48478,0.15,NULL,34531650882,539557045,8430578,17.44),(6162,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6162,34.99,0.49,99.7,2085,70,NULL,NULL,'2MASX J00504184-5213116',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000093,NULL,'14.49',1,'(R)SB(rl)0^0',NULL,NULL,NULL,NULL,1,12.674417,-52.21994,NULL,NULL,36020321189,562817518,8794023,14.49),(6163,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6163,33.84,0.4,58.6,2086,NULL,NULL,'mean','NGC 0271',NULL,'2007A&A...465...71T',2007,1,2.1,NULL,'G',0.000047,NULL,'12.91',1.7,'(R\')SB(rs)ab','in a radial-velocity based grouping',NULL,NULL,NULL,1,12.674417,-1.91025,0.155,NULL,34526101493,539470335,8429223,12.91),(6164,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6164,34.13,0.47,66.9,2086,NULL,NULL,'H','NGC 0271',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6165,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6165,34.13,0.46,66.9,2086,NULL,NULL,'J','NGC 0271',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6166,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6166,34.15,0.45,67.6,2086,NULL,NULL,'K','NGC 0271',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6167,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6167,36.74,0.46,223,2087,70,NULL,NULL,'2MASX J00504388+0101378',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000095,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,12.68275,1.02728,0.029,NULL,66675951998,1041811749,16278308,16.4),(6168,'SGRB','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6168,42.33,0.66,2930,2088,70,NULL,'pseudo z = 1.31 +/- 0.46','GRB 111117A',NULL,'2013ApJ...766...41S',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,12.6939583,23.011,0.105,NULL,67478687467,1054354491,16474288,NULL),(6169,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6169,34.73,0.49,88.5,2089,75,NULL,'IR','ESO 150- G 024',NULL,'2011yCatp016004901K',2011,1,2.91,NULL,'G',0.000023,NULL,'15.37',0.25,'Sab? pec sp',NULL,NULL,NULL,NULL,1,12.6965416667,-55.60744,0,NULL,36222694552,565979602,8843431,15.37),(6170,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6170,34.84,NULL,93,2089,NULL,NULL,'Dipole','ESO 150- G 024',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6171,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6171,34.84,NULL,93,2089,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 150- G 024',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6172,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6172,34.86,NULL,93.8,2089,NULL,NULL,'Dipole + Quadrupole','ESO 150- G 024',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6173,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6173,35.38,0.4,119,2089,NULL,NULL,'mean','ESO 150- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6174,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6174,35.41,0.07,121,2089,NULL,NULL,NULL,'ESO 150- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6175,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6175,35.63,0.47,134,2089,NULL,NULL,'H','ESO 150- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6176,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6176,34.15,0.47,67.6,2090,70,NULL,NULL,'NGC 0273',NULL,'2014MNRAS.445.2677S',2014,1,2.2,NULL,'G',0.00007,NULL,'14.07',0.7,'S0','in a triple',NULL,NULL,NULL,1,12.701875,-6.88569,0.214,NULL,34539296631,539676509,8432445,14.07),(6177,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6177,37.59,0.21,329,2091,70,NULL,NULL,'2MASX J00504914+1559334',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000063,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,12.70475,15.99269,0.137,NULL,67590910739,1056107980,16501687,17.6),(6178,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6178,37.59,0.21,329,2092,70,NULL,NULL,'SDSS J005050.17+155547.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000072,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,12.709125,15.92975,0.161,NULL,67590933187,1056108331,16501692,18.2),(6179,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6179,34.18,1.03,68.5,2093,NULL,NULL,NULL,'ESO 474- G 032',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.57',0.3,'Sc',NULL,NULL,NULL,NULL,1,12.7102083,-26.49169,0.042,NULL,34832191511,544252992,8503953,16.57),(6180,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6180,34.22,0.2,69.8,2093,74.4,NULL,NULL,'ESO 474- G 032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6181,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6181,34.63,0.84,84.2,2093,NULL,NULL,'Malmquist cor.','ESO 474- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6182,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6182,33.2,0.43,43.6,2094,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 501-024',NULL,'2014MNRAS.444..527S',2014,1,0.8,NULL,'G',0.000033,NULL,'15.6',0.2,'S','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,12.7117083333,28.70089,0.173,NULL,67318348024,1051849187,16435143,15.6),(6183,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6183,33.94,0.49,61.4,2094,75,NULL,'IR','CGCG 501-024',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6184,'SNIa SDSS','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 10367','R',6184,36.71,0.06,217,2095,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2005kb','FGC 0096',0.015265,'2014arXiv1401.3317S',2014,1,0.46,NULL,'G',0.000053,NULL,'16.6g',0.05,'Sd(f)',NULL,NULL,NULL,NULL,1,12.7150417,0.85119,0.033,NULL,66674041478,1041781898,16277842,16.6),(6185,'SNIa SDSS','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 10367','R',6185,37.13,0.32,262,2095,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2005kb','FGC 0096',0.015265,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6186,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6186,34.2,NULL,69.2,2095,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0096',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6187,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6187,34.22,NULL,69.9,2095,NULL,NULL,'Dipole + Quadrupole','FGC 0096',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6188,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6188,34.23,NULL,70.2,2095,NULL,NULL,'Dipole','FGC 0096',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6189,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6189,34.29,NULL,72.1,2095,NULL,NULL,NULL,'FGC 0096',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6190,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6190,34.31,0.2,72.8,2095,74.4,NULL,NULL,'FGC 0096',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6191,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6191,35.06,0.54,103,2096,70,NULL,NULL,'ESO 150- G 025',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.19',0.52,'(R\'_2)SB(rs)a',NULL,NULL,NULL,NULL,1,12.719667,-55.49019,0,NULL,36222762605,565980665,8843447,15.19),(6192,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6192,36.89,0.37,239,2097,NULL,NULL,'Malmquist cor.','2MASX J00505356-2153577',NULL,'2009ApJS..182..474S',2009,1,0.92,NULL,'G',0.000023,NULL,'15.65',0.23,'Sb             HII','Field galaxy',NULL,NULL,NULL,1,12.72325,-21.89942,0.026,NULL,35317699561,551839055,8622485,15.65),(6193,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6193,37.01,0.35,252,2097,NULL,NULL,NULL,'2MASX J00505356-2153577',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6194,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6194,37.05,0.2,257,2097,74.4,NULL,NULL,'2MASX J00505356-2153577',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6195,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6195,37.31,0.46,290,2098,70,NULL,NULL,'2MASX J00505562+0039028',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000096,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,12.731917,0.65075,0.023,NULL,66674362715,1041786917,16277920,16.6),(6196,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6196,37.21,0.46,277,2099,70,NULL,NULL,'2MASX J00505603-0858587',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000074,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,12.7335417,-8.98289,0.135,NULL,34530888690,539545135,8430392,17.8),(6197,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6197,37.59,0.21,329,2100,70,NULL,NULL,'SDSS J005059.42+155323.5',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000104,NULL,'16.2g',0.38,'E0',NULL,NULL,NULL,NULL,1,12.747625,15.88989,0.161,NULL,67590946709,1056108542,16501695,16.2),(6198,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6198,37.59,0.21,329,2101,70,NULL,NULL,'SDSS J005101.20+155217.0',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000066,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,12.755,15.87139,0.161,NULL,67590946086,1056108532,16501695,18),(6199,'SBF','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6199,31.44,0.14,19.4,2102,74.4,NULL,NULL,'NGC 0274',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000033,NULL,'12.80',1.5,'SAB(r)0- pec','Pair member (points to parent)',NULL,NULL,NULL,1,12.75775,-7.05694,0.211,NULL,34539088236,539673253,8432394,12.8),(6200,'SBF','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6200,31.45,0.47,19.5,2102,NULL,NULL,'I','NGC 0274',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6201,'Faber-Jackson','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6201,32.17,0.65,27.2,2102,95,NULL,'Weighted Mean','NGC 0274',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6202,'Faber-Jackson','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6202,33.66,0.81,54,2102,55,NULL,'Visvanathan & Sandage 1979','NGC 0274',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6203,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6203,32.92,0.63,38.3,2102,70,NULL,NULL,'NGC 0274',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6204,'Tully est','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6204,31.7,0.8,21.9,2102,75,NULL,'B','NGC 0274',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6205,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6205,31.34,0.45,18.6,2102,NULL,NULL,'K','NGC 0274',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6206,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6206,31.64,0.4,21.3,2102,NULL,NULL,'mean','NGC 0274',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6207,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6207,37.94,0.46,387,2103,70,NULL,NULL,'2MASX J00510219-0014484',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.21',0.18,NULL,NULL,NULL,NULL,NULL,1,12.759,-0.24675,0.077,NULL,34513115316,539267426,8426053,18.21),(6208,'SNIa SDSS','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 02405','RN',6208,40.34,0.16,1030,2104,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 02405',0.133583,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6209,'SNIa SDSS','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 02405','RN',6209,40.6,0.22,1160,2104,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 02405',0.133583,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6210,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6210,31.7,0.4,21.9,2105,75,NULL,'B','NGC 0275',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.000014,NULL,'13.16',1.1,'SB(rs)cd pec','Pair member (points to parent)',NULL,NULL,NULL,1,12.7675,-7.06667,0.211,NULL,34539088777,539673262,8432394,13.16),(6211,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6211,36.14,0.46,169,2106,70,NULL,NULL,'2MASX J00510432-0008044',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000073,NULL,'16.2g',0.37,'E0',NULL,NULL,NULL,NULL,1,12.768125,-0.13456,0.02,NULL,34513155718,539268058,8426063,16.2),(6212,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6212,37.03,0.57,255,2106,70,NULL,NULL,'2MASX J00510432-0008044',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6213,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6213,37.47,0.46,312,2107,70,NULL,NULL,'2MASX J00510576+0105540',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000077,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,12.7740417,1.09828,0.029,NULL,66673998674,1041781229,16277831,17.6),(6214,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6214,37.59,0.21,329,2108,70,NULL,NULL,'2MASX J00510640+1552534',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000084,NULL,'17.0g',0.3,'BLAGN',NULL,NULL,NULL,'Sy 1',1,12.776625,15.88133,0.161,NULL,67590943511,1056108492,16501695,17),(6215,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6215,34.77,0.56,90.1,2109,70,NULL,NULL,'2MASX J00510924-4606335',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.000083,NULL,'15.79',0.45,'E',NULL,NULL,NULL,NULL,1,12.7885,-46.10939,NULL,NULL,38181947150,596592924,9321764,15.79),(6216,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6216,36.43,0.62,193,2110,70,NULL,NULL,'2MASX J00510936-4637566',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.44',0.22,'S',NULL,NULL,NULL,NULL,1,12.788917,-46.63242,NULL,NULL,38177826219,596528534,9320758,16.44),(6217,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6217,32.59,0.43,33,2111,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00521',NULL,'2014MNRAS.444..527S',2014,1,1,NULL,'G',0.000013,NULL,'15.03',0.7,'Im',NULL,NULL,NULL,NULL,1,12.80075,12.02525,0.153,NULL,67578993688,1055921776,16498777,15.03),(6218,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6218,37.18,0.46,273,2112,70,NULL,NULL,'2MASX J00511651-0907304',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00008,NULL,'16.3g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,12.8187083333,-9.12503,0.161,NULL,34530914177,539545534,8430398,16.3),(6219,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6219,36.79,0.37,229,2113,NULL,NULL,NULL,'2MASX J00511665-2156048',NULL,'2009ApJS..182..474S',2009,1,0.45,NULL,'G',0.000023,NULL,'15.92',0.16,'Sc',NULL,NULL,NULL,NULL,1,12.819417,-21.93475,0.026,NULL,35317849031,551841391,8622521,15.92),(6220,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6220,36.81,0.37,230,2113,NULL,NULL,'Malmquist cor.','2MASX J00511665-2156048',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6221,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6221,36.84,0.2,233,2113,74.4,NULL,NULL,'2MASX J00511665-2156048',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6222,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6222,33.98,0.4,62.6,2114,NULL,NULL,'mean','NGC 0277',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.00005,NULL,'14.31',1.2,'S0-',NULL,NULL,NULL,NULL,1,12.8217917,-8.59683,0.181,NULL,34541442038,539710031,8432969,14.31),(6223,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6223,34.79,0.45,91,2114,NULL,NULL,'K','NGC 0277',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6224,'SNIa','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 14250',NULL,6224,40.69,0.1,1380,2115,70,NULL,'SN photometric redshift distance, z photo =0.395 +/- 0.023','SDSS-II SN 14250',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.8g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,12.822333,-0.60503,0.111,NULL,34513628320,539275442,8426178,21.8),(6225,'SNIa','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 14250','R',6225,41.44,0.18,1420,2115,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14250',0.36718,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6226,'SNIa','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 14250','R',6226,41.65,0.26,1570,2115,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14250',0.36718,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6227,'SNIa','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 14250',NULL,6227,41.61,0.15,2100,2115,70,NULL,'SALT 2','SDSS-II SN 14250',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6228,'SNIa','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 14250',NULL,6228,41.66,0.15,2150,2115,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14250',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6229,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6229,36.96,0.46,247,2116,70,NULL,NULL,'2MASX J00511900+1540423',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000077,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,12.82925,15.67833,0.161,NULL,67590800681,1056106260,16501660,17.5),(6230,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6230,36.69,0.43,218,2117,NULL,NULL,'Malmquist cor.','2MASX J00512231-2132578',NULL,'2009ApJS..182..474S',2009,1,0.35,NULL,'G',0.000023,NULL,'15.80',0.14,'Sc',NULL,NULL,NULL,NULL,1,12.843,-21.54933,0.025,NULL,35317943827,551842872,8622544,15.8),(6231,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6231,36.7,0.43,219,2117,NULL,NULL,NULL,'2MASX J00512231-2132578',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6232,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6232,36.74,0.2,223,2117,74.4,NULL,NULL,'2MASX J00512231-2132578',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6233,'SNIa SDSS','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 12893','RN',6233,42.3,0.12,2380,2118,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 12893 HOST',0.210925,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6234,'SNIa SDSS','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 16846','RN',6234,42.33,0.12,2410,2118,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 12893 HOST',0.211001,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6235,'SNIa SDSS','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 12893','RN',6235,42.49,0.19,2600,2118,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 12893 HOST',0.210925,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6236,'SNIa SDSS','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 16846','RN',6236,42.49,0.19,2600,2118,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 12893 HOST',0.211001,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6237,'BL Lac Luminosity','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6237,40.2,NULL,1100,2119,NULL,NULL,'Min. z = 0.3','1FGL J0051.4-6242',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,12.873,-62.707,0,NULL,36090128625,563908259,8811066,NULL),(6238,'Tully est','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6238,31.26,0.8,17.9,2120,75,NULL,'B','ARK 016',NULL,'1988NBGC.C....0000T',1988,1,0.3,'1975Afz....11..377A has V = 1500 km/sec.','G',0.000077,NULL,'15.4',0.2,NULL,NULL,NULL,NULL,NULL,1,12.8752917,-1.25311,0.123,NULL,34513412135,539272064,8426126,15.4),(6239,'SNIa','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SN 2007ix',NULL,6239,39.56,0.1,817,2121,70,NULL,'Hubble residual 0.00 for z0.21320; SDSS-II SN 17811','SDSS-II SN 17811 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,12.880667,-0.94619,0.118,NULL,34513610416,539275162,8426174,NULL),(6240,'SNIa','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SN 2007ix','R',6240,40.01,0.21,838,2121,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ix; SDSS-II SN 17811','SDSS-II SN 17811 HOST',0.2,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6241,'SNIa','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SN 2007ix','R',6241,40.2,0.11,913,2121,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ix; SDSS-II SN 17811','SDSS-II SN 17811 HOST',0.2,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6242,'IRAS','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6242,34.01,0.8,63.4,2122,75,NULL,'W91PP, r','UGC 00525',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00002,NULL,'15.13',0.7,'SB?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,12.8937917,29.71647,0.189,NULL,67369529070,1052648891,16447638,15.13),(6243,'IRAS','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6243,34.02,0.8,63.5,2122,75,NULL,'HMCL, I','UGC 00525',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6244,'IRAS','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6244,34.02,0.8,63.7,2122,75,NULL,'W91CL, r','UGC 00525',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6245,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6245,32.88,0.43,37.6,2122,75,NULL,'3.6 micron, color corrected','UGC 00525',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6246,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6246,32.89,0.43,37.9,2122,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00525',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6247,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6247,33.36,0.38,47,2122,75,NULL,'W91PP, r, inv','UGC 00525',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6248,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6248,33.41,0.38,48,2122,75,NULL,'W91PP, r, raw','UGC 00525',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6249,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6249,33.53,0.38,50.9,2122,75,NULL,'W91CL, r, raw','UGC 00525',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6250,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6250,33.55,0.38,51.2,2122,75,NULL,'W91CL, r, inv','UGC 00525',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6251,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6251,33.78,0.4,57.1,2122,75,NULL,'HMCL, I, raw','UGC 00525',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6252,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6252,33.79,0.49,57.3,2122,75,NULL,'IR','UGC 00525',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6253,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6253,33.81,0.38,57.9,2122,75,NULL,'W91PP, r, cor','UGC 00525',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6254,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6254,33.86,0.4,59.1,2122,75,NULL,'HMCL, I, inv','UGC 00525',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6255,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6255,33.87,0.38,59.6,2122,75,NULL,'W91CL, r, cor','UGC 00525',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6256,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6256,33.91,0.11,60.7,2122,NULL,NULL,NULL,'UGC 00525',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6257,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6257,34.04,0.4,64.2,2122,75,NULL,'HMCL, I, cor','UGC 00525',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6258,'TRGB','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6258,24.33,0.33,0.735,2123,NULL,NULL,NULL,'Andromeda XIV',NULL,'2007ApJ...670L...9M',2007,1,NULL,NULL,'G',0.000004,NULL,NULL,NULL,'dSph',NULL,NULL,NULL,NULL,1,12.895833,29.69694,0.189,1,67369528667,1052648885,16447638,NULL),(6259,'TRGB','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6259,24.5,0.56,0.793,2123,NULL,NULL,NULL,'Andromeda XIV',NULL,'2012ApJ...758...11C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6260,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6260,37.04,0.57,256,2124,NULL,NULL,'Malmquist cor.','AGC 400674',NULL,'2009ApJS..182..474S',2009,1,0.42,NULL,'G',0.000027,NULL,'17.24',0.09,'Sc',NULL,NULL,NULL,NULL,1,12.9037083,-21.46867,0.025,NULL,35385314207,552895534,8638992,17.24),(6261,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6261,37.05,0.57,257,2124,NULL,NULL,NULL,'AGC 400674',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6262,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6262,37.09,0.2,262,2124,74.4,NULL,NULL,'AGC 400674',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6263,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6263,35.28,0.49,114,2125,75,NULL,'IR','CGCG 480-016',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000033,NULL,'15.89',0.1,'Sc',NULL,NULL,NULL,NULL,1,12.92725,22.51353,0.081,NULL,67478546477,1054352288,16474254,15.89),(6264,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6264,37.53,0.46,320,2126,70,NULL,NULL,'2MASX J00514513+1353152',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000078,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,12.938083,13.8875,0.181,NULL,67593179550,1056143430,16502241,17.3),(6265,'CMD','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6265,24.57,NULL,0.82,2127,NULL,NULL,NULL,'ANDROMEDA XIII',NULL,'2014ApJ...789..147W',2014,1,NULL,NULL,'G',0.000025,NULL,NULL,NULL,'dSph',NULL,NULL,NULL,NULL,1,12.9625,33.00444,0.193,1,67341397119,1052209329,16440770,NULL),(6266,'Horizontal Branch','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6266,24.8,NULL,0.91,2127,NULL,NULL,NULL,'ANDROMEDA XIII',NULL,'2010MNRAS.407.2411C',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6267,'RR Lyrae','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6267,24.46,0.09,0.78,2127,NULL,NULL,'V','ANDROMEDA XIII',NULL,'2013MNRAS.435.3206D',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6268,'RR Lyrae','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6268,24.62,0.05,0.84,2127,NULL,NULL,NULL,'ANDROMEDA XIII',NULL,'2012MNRAS.419.1362Y',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6269,'RR Lyrae','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6269,24.71,NULL,0.875,2127,NULL,NULL,NULL,'ANDROMEDA XIII',NULL,'2011PhDT........32Y',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6270,'TRGB','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6270,24.4,0.49,0.76,2127,NULL,NULL,NULL,'ANDROMEDA XIII',NULL,'2012ApJ...758...11C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6271,'TRGB','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6271,24.7,0.2,0.87,2127,NULL,NULL,NULL,'ANDROMEDA XIII',NULL,'2006MNRAS.371.1983M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6272,'TRGB','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6272,24.8,0.35,0.91,2127,NULL,NULL,NULL,'ANDROMEDA XIII',NULL,'2010MNRAS.407.2411C',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6273,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6273,36.65,0.56,214,2128,70,NULL,NULL,'2MASX J00515380-0302512',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.000103,NULL,'16.81',0.27,NULL,NULL,NULL,NULL,NULL,1,12.9742083333,-3.04747,0.211,NULL,34516455501,539319617,8426869,16.81),(6274,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6274,37.12,0.46,265,2129,70,NULL,NULL,'2MASX J00515724+1433482',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.0001,NULL,'16.2g',0.35,'E0',NULL,NULL,NULL,NULL,1,12.988667,14.56344,0.165,NULL,67592863739,1056138495,16502163,16.2),(6275,'SNIa','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 04129',NULL,6275,40.88,0.27,1500,2130,70,NULL,'SN photometric redshift distance, z photo =0.441 +/- 0.080','SDSS-II SN 04129',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,12.995083,-1.21803,0.123,NULL,34524672460,539448007,8428875,NULL),(6276,'SNIa','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 04129',NULL,6276,41.7,0.26,2190,2130,70,NULL,'SALT 2','SDSS-II SN 04129',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6277,'SNIa','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 04129',NULL,6277,41.75,0.26,2240,2130,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 04129',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6278,'Tully est','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6278,31.68,0.8,21.6,2131,75,NULL,'B','ARK 018',NULL,'1988NBGC.C....0000T',1988,1,0.66,NULL,'G',0.000013,NULL,'15.1g',0.41,'Sb;HII;WR?     Sbrst',NULL,NULL,NULL,NULL,1,12.998417,-0.48672,0.136,NULL,34513659383,539275927,8426186,15.1),(6279,'SNIa SDSS','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 02582','RN',6279,42.16,0.34,2530,2132,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 02582',0.070483,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6280,'SNIa SDSS','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 02582','RN',6280,42.29,0.27,2680,2132,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 02582',0.070483,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6281,'SNIa SDSS','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 05964','RN',6281,41.13,0.31,1510,2133,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 05964',0.114316,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6282,'SNIa SDSS','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 05964','RN',6282,41.26,0.26,1600,2133,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05964',0.114316,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6283,'SNIa','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 20844','R',6283,41.72,0.35,1520,2134,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20844',0.454329,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,13.00875,-1.1215,0.158,NULL,34524663297,539447864,8428872,NULL),(6284,'SNIa','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 20844',NULL,6284,41.03,0.36,1610,2134,70,NULL,'SN photometric redshift distance, z photo =0.484 +/- 0.124','SDSS-II SN 20844',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6285,'SNIa','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 20844',NULL,6285,41.62,0.23,2110,2134,70,NULL,'SALT 2','SDSS-II SN 20844',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6286,'SNIa','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 20844',NULL,6286,41.72,0.23,2210,2134,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20844',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6287,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6287,30.37,0.4,11.8,2135,75,NULL,'B','NGC 0278',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.000003,NULL,'11.47',2,'SAB(rs)b       HII',NULL,NULL,NULL,NULL,1,13.0179583333,47.5505,0.725,NULL,67685573928,1057587092,16524798,11.47),(6288,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6288,37.25,0.46,282,2136,70,NULL,NULL,'2MASX J00520541+1407052',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000076,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,13.0225,14.11797,0.181,NULL,67593300840,1056145325,16502270,17.2),(6289,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6289,37.27,0.46,284,2137,70,NULL,NULL,'2MASX J00520672+0101167',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000088,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,13.0279583,1.02131,0.037,NULL,66674182943,1041784108,16277876,16.9),(6290,'SNIa SDSS','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 17625','RN',6290,41.14,0.17,1580,2138,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 17625',0.071739,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6291,'SNIa SDSS','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 17625','RN',6291,41.58,0.27,1930,2138,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 17625',0.071739,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6292,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6292,37.42,0.46,304,2139,70,NULL,NULL,'2MASX J00520727-0929288',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000094,NULL,'16.3g',0.37,'AGN',NULL,NULL,NULL,NULL,1,13.03025,-9.49128,0.166,NULL,34531254970,539550858,8430482,16.3),(6293,'SNIa','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 15363',NULL,6293,40.04,0.38,1020,2140,70,NULL,'SN photometric redshift distance, z photo =0.274 +/- 0.064','SDSS-II SN 15363',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,13.033125,0.66131,0.073,NULL,66674526672,1041789479,16277960,NULL),(6294,'SNIa','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 15363','R',6294,40.81,0.23,1230,2140,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15363',0.178667,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6295,'SNIa','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 15363','R',6295,41.15,0.32,1440,2140,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15363',0.178667,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6296,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6296,35.09,NULL,104,2141,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0099',NULL,'2010Ap&SS.325..163P',2010,1,0.82,NULL,'G',0.000009,NULL,'17.6g',0.1,'Sd(f)',NULL,NULL,NULL,NULL,1,13.03675,14.5035,0.165,NULL,67592853208,1056138331,16502161,17.6),(6297,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6297,35.1,NULL,105,2141,NULL,NULL,'Dipole + Quadrupole','FGC 0099',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6298,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6298,35.11,NULL,105,2141,NULL,NULL,'Dipole','FGC 0099',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6299,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6299,35.2,NULL,110,2141,NULL,NULL,NULL,'FGC 0099',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6300,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6300,35.67,0.2,136,2141,74.4,NULL,NULL,'FGC 0099',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6301,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6301,35.71,0.34,139,2141,NULL,NULL,NULL,'FGC 0099',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6302,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6302,36.12,0.28,167,2141,NULL,NULL,'Malmquist cor.','FGC 0099',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6303,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6303,32.41,0.43,30.4,2142,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-03-027',NULL,'2014MNRAS.444..527S',2014,1,1.5,'Huchra, et al. (1993,AJ,105,1637) incorrrectly give v = 5378 +/- 34 km/sec.','G',0.000007,NULL,'13.5',0.5,'Sd?',NULL,NULL,NULL,NULL,1,13.0717917,-3.96661,0.218,NULL,34516532050,539320813,8426887,13.5),(6304,'SNIa SDSS','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 15224','RN',6304,40.68,0.31,1100,2143,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 15224',0.236003,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6305,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6305,36.4,0.56,191,2144,NULL,NULL,'Malmquist cor.','2MASX J00521819-2149496',NULL,'2009ApJS..182..474S',2009,1,0.44,NULL,'G',0.000023,NULL,'15.94',0.29,'Sa','Field galaxy',NULL,NULL,NULL,1,13.075875,-21.83064,0.046,NULL,35385731012,552902047,8639094,15.94),(6306,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6306,36.59,0.52,208,2144,NULL,NULL,NULL,'2MASX J00521819-2149496',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6307,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6307,36.63,0.2,212,2144,74.4,NULL,NULL,'2MASX J00521819-2149496',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6308,'SNIa SDSS','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 15738','RN',6308,44.03,0.44,3790,2145,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 15738',0.686233,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6309,'SNIa SDSS','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 09504','RN',6309,39.76,0.85,730,2146,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 09504',0.223431,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6310,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6310,36.9,0.63,240,2147,70,NULL,NULL,'2MASX J00522168-0320404',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.000107,NULL,'16.75',0.33,NULL,NULL,NULL,NULL,NULL,1,13.0905417,-3.34469,0.21,NULL,34516811633,539325181,8426955,16.75),(6311,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6311,36.76,0.33,225,2148,70,NULL,NULL,'2MASX J00522292+0040027',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00008,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,13.095625,0.66739,0.073,NULL,66674640563,1041791258,16277988,16.9),(6312,'IRAS','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6312,34.3,0.8,72.5,2149,75,NULL,'CF, r','UGC 00533',NULL,'1997ApJS..109..333W',1997,1,1.26,NULL,'G',0.000076,NULL,'15.4g',0.42,'Scd:',NULL,NULL,NULL,NULL,1,13.1164583,14.51817,0.157,NULL,67592912300,1056139254,16502175,15.4),(6313,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6313,34.22,0.2,69.8,2149,74.4,NULL,NULL,'UGC 00533',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6314,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6314,34.23,0.6,70.3,2149,NULL,NULL,'Malmquist cor.','UGC 00533',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6315,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6315,34.24,0.6,70.6,2149,NULL,NULL,NULL,'UGC 00533',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6316,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6316,34.56,0.38,81.8,2149,75,NULL,'CF, r, raw','UGC 00533',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6317,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6317,34.63,0.38,84.2,2149,75,NULL,'CF, r, inv','UGC 00533',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6318,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6318,34.78,0.38,90.6,2149,75,NULL,'CF, r, cor','UGC 00533',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6319,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6319,37.41,0.46,304,2150,70,NULL,NULL,'2MASX J00522812-0840035',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000079,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,13.1170417,-8.66772,0.201,NULL,34528832203,539513003,8429890,17),(6320,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6320,36.36,0.59,187,2151,70,NULL,NULL,'2MASX J00522819-0158442',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00008,NULL,'17.08',NULL,NULL,NULL,NULL,NULL,NULL,1,13.1175416667,-1.979,0.16,NULL,34527470321,539491723,8429558,17.08),(6321,'IRAS','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6321,35.64,0.8,134,2152,75,NULL,'MAT, I','NGC 0280',NULL,'1997ApJS..109..333W',1997,1,1.7,'The UZC position includes the superposed companion UGC 00534 NOTES01.','G',0.000033,NULL,'14.23',1.1,'SB?',NULL,NULL,NULL,NULL,1,13.1260833333,24.35058,0.117,NULL,67310300779,1051723449,16433178,14.23),(6322,'IRAS','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6322,35.65,0.8,135,2152,75,NULL,'W91PP, r','NGC 0280',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6323,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6323,34.99,0.43,99.7,2152,75,NULL,'MAT, I, raw','NGC 0280',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6324,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6324,35.15,0.4,107,2152,NULL,NULL,'Malmquist cor.','NGC 0280',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6325,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6325,35.34,0.32,117,2152,85,NULL,'I, raw','NGC 0280',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6326,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6326,35.34,0.43,117,2152,75,NULL,'MAT, I, inv','NGC 0280',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6327,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6327,35.39,0.43,119,2152,75,NULL,'MAT, I, cor','NGC 0280',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6328,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6328,35.43,0.32,122,2152,85,NULL,'I, inv','NGC 0280',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6329,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6329,35.43,0.38,122,2152,75,NULL,'W91PP, r, raw','NGC 0280',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6330,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6330,35.5,0.34,126,2152,NULL,NULL,NULL,'NGC 0280',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6331,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6331,35.67,0.38,136,2152,75,NULL,'W91PP, r, cor','NGC 0280',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6332,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6332,35.78,0.38,143,2152,75,NULL,'W91PP, r, inv','NGC 0280',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6333,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6333,35.96,0.2,156,2152,74.4,NULL,NULL,'NGC 0280',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6334,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6334,36.76,0.33,225,2153,70,NULL,NULL,'SDSS J005230.43+004121.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000069,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,13.1267917,0.68925,0.073,NULL,66674652555,1041791446,16277991,17.9),(6335,'SNIa SDSS','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 03584','RN',6335,42.86,0.22,2770,2154,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03584',0.348076,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6336,'SNIa SDSS','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 03584','RN',6336,42.88,0.16,2800,2154,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03584',0.348076,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6337,'SNIa SDSS','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 17493','RN',6337,42.72,0.23,2690,2155,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17493',0.300246,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6338,'SNIa SDSS','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 17493','RN',6338,43.25,0.2,3440,2155,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 17493',0.300246,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6339,'SNIa SDSS','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 03805','RN',6339,41.51,0.17,1610,2156,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 03805',0.24832,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6340,'SNIa SDSS','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 03805','RN',6340,42.11,0.22,2120,2156,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 03805',0.24832,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6341,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6341,33.86,0.1,59.3,2157,NULL,NULL,NULL,'UGC 00536',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000033,NULL,'16.5',0.5,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,13.1461666667,29.20728,0.189,NULL,67315321502,1051801898,16434404,16.5),(6342,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6342,34.18,0.2,68.6,2157,74.4,NULL,NULL,'UGC 00536',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6343,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6343,34.38,0.43,75.2,2157,75,NULL,'3.6 micron, color corrected','UGC 00536',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6344,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6344,34.62,0.43,84,2157,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00536',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6345,'SNIa SDSS','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 02228','RN',6345,43.61,0.26,3600,2158,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02228',0.45935,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6346,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6346,37.91,0.33,382,2159,70,NULL,NULL,'SDSS J005238.10-104831.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000103,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,13.1587917,-10.80869,0.202,NULL,35249718158,550776846,8605888,17.9),(6347,'FP','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6347,36.6,0.46,209,2160,70,NULL,NULL,'2MASX J00524143+1546343',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000089,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,13.1726666667,15.77614,0.173,NULL,67591188120,1056112314,16501754,16.6),(6348,'Sosies','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6348,32.19,0.5,27.4,2161,NULL,NULL,NULL,'NGC 0289',NULL,'2002A&A...393...57T',2002,1,5.1,'Extended HIPASS source','G',0.000007,NULL,'11.72',3.6,'SAB(rs)bc','Group member',NULL,NULL,NULL,1,13.1765,-31.20583,NULL,NULL,34871210020,544862656,8513479,11.72),(6349,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6349,30.68,NULL,13.7,2161,75,NULL,NULL,'NGC 0289',NULL,'1997AJ....113.1591W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6350,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6350,31.37,0.43,18.8,2161,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0289',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6351,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6351,31.44,0.4,19.4,2161,75,NULL,'B','NGC 0289',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6352,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6352,31.65,0.43,21.4,2161,75,NULL,'3.6 micron, color corrected','NGC 0289',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6353,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6353,31.66,0.4,21.5,2161,NULL,NULL,NULL,'NGC 0289',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6354,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6354,31.66,0.4,21.5,2161,73,NULL,'opt','NGC 0289',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6355,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6355,31.97,0.2,24.8,2161,74.4,NULL,NULL,'NGC 0289',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6356,'Tully-Fisher','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6356,32.31,NULL,29,2161,NULL,NULL,'LEDA [April 2006]','NGC 0289',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6357,'SNIa SDSS','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 17814','RN',6357,39.98,0.12,894,2162,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 17814',0.106813,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6358,'SNIa SDSS','2016-12-15 15:13:36','2016-12-16 11:18:37','1','SDSS-II SN 17814','RN',6358,40.35,0.22,1060,2162,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 17814',0.106813,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6359,'Blue Supergiant','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6359,19,0.5,0.063,2163,NULL,NULL,NULL,'SMC',NULL,'2003LNP...635..149B',2003,1,320,NULL,'G',0.000013,NULL,'2.7',185,'SB(s)m pec','Group member',NULL,NULL,NULL,1,13.186583,-72.82861,0.169,0,35624171005,556627671,8697307,2.7),(6360,'Brightest Stars','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6360,18.4,NULL,0.0479,2163,NULL,NULL,'Photographic, A and B supergiants, 4 vs. Milky Way','SMC',NULL,'1982Msngr..30...28D',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6361,'Brightest Stars','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6361,18.6,NULL,0.0525,2163,NULL,NULL,'Photographic, A and B supergiants, 8 vs.LMC','SMC',NULL,'1982Msngr..30...28D',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6362,'Brightest Stars','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6362,19,0.1,0.0631,2163,NULL,NULL,NULL,'SMC',NULL,'1983ApJ...269..335H',1983,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6363,'Brightest Stars','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6363,19.33,0.31,0.0735,2163,NULL,NULL,NULL,'SMC',NULL,'1991A&A...246..341A',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6364,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6364,18.07,0.09,0.0411,2163,NULL,NULL,'HV 1345, 1, VK(W)','SMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6365,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6365,18.19,0.09,0.0434,2163,NULL,NULL,'HV 1335, 1, VK(W)','SMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6366,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6366,18.3,NULL,0.0457,2163,NULL,NULL,'Z','SMC',NULL,'2011ApJ...741L..36M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6367,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6367,18.48,0.06,0.0496,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4906, RA-DEC 01:35:52.7-73:53:21.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6368,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6368,18.54,0.06,0.051,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4830, RA-DEC 01:12:48.4-74:22:19.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6369,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6369,18.54,0.06,0.0512,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0494, RA-DEC 00:42:58.1-73:20:05.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6370,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6370,18.57,0.06,0.0518,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2545, RA-DEC 00:56:28.2-72:26:29.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6371,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6371,18.58,0.06,0.0519,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4762, RA-DEC 01:00:06.6-75:12:40.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6372,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6372,18.6,0.06,0.0526,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4821, RA-DEC 01:10:47.6-74:20:32.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6373,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6373,18.61,0.06,0.0528,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4764, RA-DEC 01:00:42.8-74:30:36.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6374,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6374,18.62,0.06,0.0529,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4523, RA-DEC 01:16:34.1-72:07:05.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6375,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6375,18.62,0.06,0.0529,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4039, RA-DEC 01:08:27.5-73:51:45.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6376,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6376,18.62,0.06,0.0529,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1148, RA-DEC 00:48:21.5-73:07:17.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6377,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6377,18.62,0.06,0.053,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1615, RA-DEC 00:51:08.1-72:51:19.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6378,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6378,18.62,0.06,0.053,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3498, RA-DEC 01:03:25.1-72:39:15.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6379,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6379,18.62,0.06,0.053,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4630, RA-DEC 01:27:04.4-73:49:08.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6380,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6380,18.62,0.06,0.0531,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4765, RA-DEC 01:00:56.3-74:56:12.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6381,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6381,18.62,0.06,0.0531,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1991, RA-DEC 00:53:03.5-73:32:32.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6382,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6382,18.63,0.06,0.0532,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3038, RA-DEC 00:59:48.0-72:10:58.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6383,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6383,18.63,0.06,0.0532,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3020, RA-DEC 00:59:37.1-72:33:05.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6384,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6384,18.63,0.06,0.0532,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4918, RA-DEC 01:39:22.4-70:50:02.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6385,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6385,18.64,0.06,0.0534,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4226, RA-DEC 01:10:47.6-72:39:44.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6386,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6386,18.64,0.06,0.0535,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4785, RA-DEC 01:04:28.7-74:27:33.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6387,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6387,18.64,0.06,0.0535,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3245, RA-DEC 01:01:18.4-72:13:45.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6388,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6388,18.64,0.06,0.0535,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3419, RA-DEC 01:02:44.3-73:18:29.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6389,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6389,18.65,0.06,0.0536,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4615, RA-DEC 01:22:51.7-72:57:03.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6390,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6390,18.65,0.06,0.0537,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3392, RA-DEC 01:02:30.4-73:26:41.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6391,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6391,18.65,0.06,0.0537,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4700, RA-DEC 00:41:21.9-70:37:06.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6392,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6392,18.65,0.06,0.0537,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3221, RA-DEC 01:01:08.3-72:59:18.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6393,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6393,18.65,0.06,0.0538,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3044, RA-DEC 00:59:49.3-73:57:25.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6394,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6394,18.65,0.06,0.0538,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0952, RA-DEC 00:47:08.1-73:23:55.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6395,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6395,18.65,0.06,0.0538,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4462, RA-DEC 01:14:52.0-72:48:59.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6396,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6396,18.65,0.06,0.0538,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3882, RA-DEC 01:06:51.9-73:52:42.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6397,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6397,18.65,0.06,0.0538,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2529, RA-DEC 00:56:18.3-72:38:34.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6398,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6398,18.66,0.06,0.0538,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4598, RA-DEC 01:20:51.2-72:30:21.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6399,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6399,18.66,0.06,0.0539,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1298, RA-DEC 00:49:17.8-72:01:47.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6400,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6400,18.66,0.06,0.054,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3778, RA-DEC 01:05:50.0-72:24:58.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6401,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6401,18.66,0.06,0.054,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3824, RA-DEC 01:06:15.8-74:00:39.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6402,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6402,18.66,0.06,0.054,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2451, RA-DEC 00:55:49.7-72:45:03.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6403,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6403,18.66,0.06,0.0541,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2049, RA-DEC 00:53:23.0-72:19:24.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6404,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6404,18.66,0.06,0.0541,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3788, RA-DEC 01:05:55.8-72:26:23.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6405,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6405,18.67,0.06,0.0541,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4888, RA-DEC 01:29:41.4-73:43:15.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6406,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6406,18.67,0.06,0.0541,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4856, RA-DEC 01:20:24.3-74:19:12.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6407,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6407,18.67,0.06,0.0541,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4322, RA-DEC 01:12:06.1-72:25:48.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6408,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6408,18.67,0.06,0.0541,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3907, RA-DEC 01:07:04.7-72:13:19.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6409,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6409,18.67,0.06,0.0542,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3264, RA-DEC 01:01:30.3-71:31:56.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6410,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6410,18.67,0.06,0.0542,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3716, RA-DEC 01:05:16.7-72:23:59.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6411,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6411,18.67,0.06,0.0542,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3994, RA-DEC 01:07:57.3-72:16:53.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6412,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6412,18.67,0.06,0.0543,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3777, RA-DEC 01:05:49.8-72:23:52.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6413,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6413,18.67,0.06,0.0543,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3565, RA-DEC 01:04:00.3-72:13:59.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6414,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6414,18.67,0.06,0.0543,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4713, RA-DEC 00:46:04.4-72:02:21.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6415,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6415,18.68,0.06,0.0544,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3763, RA-DEC 01:05:43.1-73:03:05.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6416,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6416,18.68,0.06,0.0544,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2361, RA-DEC 00:55:14.2-73:11:03.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6417,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6417,18.68,0.06,0.0544,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4411, RA-DEC 01:13:42.6-73:28:57.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6418,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6418,18.68,0.06,0.0544,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3649, RA-DEC 01:04:35.3-71:44:42.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6419,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6419,18.68,0.06,0.0544,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4216, RA-DEC 01:10:34.6-72:39:53.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6420,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6420,18.68,0.06,0.0544,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4842, RA-DEC 01:15:11.9-74:28:32.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6421,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6421,18.68,0.06,0.0545,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3987, RA-DEC 01:07:53.4-73:32:05.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6422,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6422,18.68,0.06,0.0545,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4595, RA-DEC 01:20:27.7-73:26:46.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6423,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6423,18.68,0.06,0.0545,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4291, RA-DEC 01:11:39.5-71:41:28.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6424,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6424,18.68,0.06,0.0545,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3428, RA-DEC 01:02:46.7-72:05:54.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6425,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6425,18.68,0.06,0.0545,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3755, RA-DEC 01:05:39.1-73:40:07.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6426,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6426,18.68,0.06,0.0545,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4891, RA-DEC 01:29:51.0-73:31:39.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6427,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6427,18.68,0.06,0.0546,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1516, RA-DEC 00:50:34.6-72:39:16.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6428,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6428,18.68,0.06,0.0546,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4923, RA-DEC 01:41:05.1-73:15:18.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6429,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6429,18.69,0.06,0.0546,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2681, RA-DEC 00:57:24.9-72:35:32.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6430,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6430,18.69,0.06,0.0546,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3929, RA-DEC 01:07:18.4-73:20:44.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6431,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6431,18.69,0.06,0.0547,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3949, RA-DEC 01:07:27.7-74:02:17.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6432,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6432,18.69,0.06,0.0547,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4125, RA-DEC 01:09:24.8-72:33:31.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6433,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6433,18.69,0.06,0.0547,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4557, RA-DEC 01:17:58.1-72:20:28.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6434,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6434,18.69,0.06,0.0547,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3125, RA-DEC 01:00:26.9-73:43:21.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6435,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6435,18.69,0.06,0.0548,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2596, RA-DEC 00:56:46.8-72:07:57.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6436,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6436,18.69,0.06,0.0548,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4478, RA-DEC 01:15:18.8-72:41:44.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6437,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6437,18.69,0.06,0.0548,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4584, RA-DEC 01:19:36.4-73:41:48.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6438,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6438,18.69,0.06,0.0548,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4883, RA-DEC 01:28:17.7-70:56:09.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6439,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6439,18.69,0.06,0.0548,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2266, RA-DEC 00:54:41.2-72:27:54.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6440,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6440,18.7,0.06,0.0548,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3298, RA-DEC 01:01:45.5-72:49:54.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6441,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6441,18.7,0.06,0.0548,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2518, RA-DEC 00:56:12.8-72:18:24.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6442,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6442,18.7,0.06,0.0549,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2617, RA-DEC 00:56:57.7-73:18:43.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6443,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6443,18.7,0.06,0.0549,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4320, RA-DEC 01:12:04.3-73:50:30.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6444,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6444,18.7,0.06,0.0549,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4453, RA-DEC 01:14:39.8-72:29:54.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6445,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6445,18.7,0.06,0.0549,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4475, RA-DEC 01:15:11.4-74:06:30.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6446,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6446,18.7,0.06,0.0549,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4607, RA-DEC 01:22:01.3-72:47:06.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6447,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6447,18.7,0.06,0.0549,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4941, RA-DEC 01:49:40.8-73:33:48.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6448,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6448,18.7,0.06,0.0549,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4339, RA-DEC 01:12:25.0-72:37:47.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6449,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6449,18.7,0.06,0.0549,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4024, RA-DEC 01:08:15.8-72:11:01.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6450,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6450,18.7,0.06,0.0549,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4592, RA-DEC 01:20:09.3-72:46:34.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6451,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6451,18.7,0.06,0.055,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4334, RA-DEC 01:12:17.7-73:44:24.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6452,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6452,18.7,0.06,0.055,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4577, RA-DEC 01:19:07.9-72:04:32.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6453,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6453,18.7,0.06,0.055,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3770, RA-DEC 01:05:46.1-71:42:45.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6454,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6454,18.7,0.18,0.055,2163,NULL,NULL,'HV 1345, 1, V-R (BW)','SMC',NULL,'1999ASPC..167..320S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6455,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6455,18.7,0.15,0.055,2163,NULL,NULL,'HV 1328, 1, VK(W)','SMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6456,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6456,18.7,0.06,0.055,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4938, RA-DEC 01:48:18.3-73:03:30.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6457,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6457,18.7,0.06,0.055,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4443, RA-DEC 01:14:23.5-71:57:45.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6458,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6458,18.7,0.06,0.055,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3388, RA-DEC 01:02:28.3-72:55:39.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6459,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6459,18.7,0.06,0.0551,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2263, RA-DEC 00:54:40.2-73:55:39.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6460,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6460,18.71,0.06,0.0551,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3920, RA-DEC 01:07:12.4-72:35:48.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6461,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6461,18.71,0.06,0.0552,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2702, RA-DEC 00:57:32.7-72:13:37.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6462,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6462,18.71,0.06,0.0552,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4587, RA-DEC 01:19:55.9-74:06:26.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6463,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6463,18.71,0.06,0.0552,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4846, RA-DEC 01:16:43.5-75:00:05.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6464,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6464,18.71,0.06,0.0552,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4933, RA-DEC 01:45:07.9-72:31:59.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6465,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6465,18.71,0.06,0.0552,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4012, RA-DEC 01:08:08.5-72:23:17.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6466,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6466,18.71,0.06,0.0552,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0092, RA-DEC 00:28:27.2-70:51:07.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6467,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6467,18.71,0.06,0.0552,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4935, RA-DEC 01:46:18.2-74:33:37.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6468,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6468,18.71,0.06,0.0552,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4599, RA-DEC 01:21:05.9-73:22:48.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6469,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6469,18.71,0.06,0.0552,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0798, RA-DEC 00:45:57.7-72:55:17.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6470,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6470,18.71,0.06,0.0553,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4625, RA-DEC 01:24:25.8-72:56:09.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6471,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6471,18.71,0.06,0.0553,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1362, RA-DEC 00:49:39.7-73:25:50.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6472,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6472,18.71,0.06,0.0553,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4290, RA-DEC 01:11:39.1-73:31:32.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6473,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6473,18.71,0.06,0.0553,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3541, RA-DEC 01:03:46.8-72:27:52.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6474,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6474,18.71,0.06,0.0553,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3681, RA-DEC 01:04:54.6-72:32:26.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6475,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6475,18.71,0.06,0.0553,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4858, RA-DEC 01:22:19.4-74:48:46.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6476,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6476,18.71,0.06,0.0553,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2898, RA-DEC 00:58:52.0-72:42:09.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6477,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6477,18.71,0.06,0.0553,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3374, RA-DEC 01:02:22.7-73:07:50.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6478,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6478,18.72,0.06,0.0553,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3823, RA-DEC 01:06:15.1-73:29:50.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6479,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6479,18.72,0.06,0.0554,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4583, RA-DEC 01:19:31.4-72:36:16.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6480,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6480,18.72,0.06,0.0554,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1938, RA-DEC 00:52:42.3-72:42:40.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6481,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6481,18.72,0.06,0.0554,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4553, RA-DEC 01:17:49.0-74:01:46.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6482,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6482,18.72,0.06,0.0554,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1931, RA-DEC 00:52:39.0-72:57:03.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6483,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6483,18.72,0.06,0.0554,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3163, RA-DEC 01:00:42.1-72:49:41.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6484,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6484,18.72,0.06,0.0554,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4908, RA-DEC 01:36:13.9-73:46:43.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6485,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6485,18.72,0.06,0.0554,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4926, RA-DEC 01:41:48.6-73:03:06.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6486,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6486,18.72,0.06,0.0554,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4428, RA-DEC 01:14:02.3-73:10:37.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6487,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6487,18.72,0.06,0.0554,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4850, RA-DEC 01:17:49.8-76:33:55.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6488,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6488,18.72,0.06,0.0554,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4943, RA-DEC 01:50:06.1-72:41:58.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6489,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6489,18.72,0.06,0.0555,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4899, RA-DEC 01:33:54.6-74:39:44.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6490,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6490,18.72,0.06,0.0555,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4031, RA-DEC 01:08:18.5-72:40:35.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6491,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6491,18.72,NULL,0.0555,2163,NULL,NULL,'NGC 0330, 18, VI, overshoot','SMC',NULL,'1994AJ....108..932S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6492,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6492,18.72,0.06,0.0555,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1703, RA-DEC 00:51:32.0-73:36:22.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6493,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6493,18.72,0.06,0.0555,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3186, RA-DEC 01:00:50.8-72:02:30.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6494,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6494,18.72,0.06,0.0555,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4026, RA-DEC 01:08:16.7-73:24:03.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6495,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6495,18.72,0.06,0.0555,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3650, RA-DEC 01:04:35.8-72:19:20.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6496,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6496,18.72,0.06,0.0555,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4588, RA-DEC 01:20:06.2-72:31:42.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6497,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6497,18.72,0.06,0.0555,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4866, RA-DEC 01:24:23.8-71:30:43.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6498,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6498,18.72,0.06,0.0555,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3725, RA-DEC 01:05:20.6-74:13:14.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6499,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6499,18.72,0.06,0.0556,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3854, RA-DEC 01:06:33.2-72:12:10.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6500,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6500,18.72,0.06,0.0556,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3787, RA-DEC 01:05:54.4-73:52:55.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6501,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6501,18.73,0.06,0.0556,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2678, RA-DEC 00:57:24.5-71:44:52.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6502,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6502,18.73,0.06,0.0556,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3735, RA-DEC 01:05:25.0-72:14:51.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6503,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6503,18.73,0.06,0.0556,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4819, RA-DEC 01:10:20.2-74:32:07.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6504,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6504,18.73,0.06,0.0557,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4490, RA-DEC 01:15:40.7-72:18:36.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6505,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6505,18.73,0.06,0.0557,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3807, RA-DEC 01:06:06.0-72:23:09.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6506,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6506,18.73,0.06,0.0557,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4878, RA-DEC 01:26:32.2-70:57:22.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6507,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6507,18.73,0.06,0.0557,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3514, RA-DEC 01:03:31.7-74:02:00.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6508,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6508,18.73,0.06,0.0557,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4072, RA-DEC 01:08:53.9-72:10:58.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6509,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6509,18.73,NULL,0.0557,2163,NULL,NULL,'SMC-LMC 0.31 mag','SMC',NULL,'1988ASPC....4....9F',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6510,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6510,18.73,0.05,0.0557,2163,NULL,18.22,'LMC ZP','SMC',NULL,'1999AcA....49..201U',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6511,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,NULL,6511,18.73,0.06,0.0557,2163,NULL,NULL,'6, K, Baade-Wesselink','SMC',NULL,'2013A&A...550A..70G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6512,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6512,18.73,0.06,0.0557,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2439, RA-DEC 00:55:46.1-73:24:34.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6513,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6513,18.73,0.06,0.0557,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3895, RA-DEC 01:07:00.4-71:34:22.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6514,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6514,18.73,0.06,0.0557,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2562, RA-DEC 00:56:33.5-72:11:36.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6515,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6515,18.73,0.06,0.0558,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3326, RA-DEC 01:01:57.5-71:33:55.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6516,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6516,18.73,0.06,0.0558,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2697, RA-DEC 00:57:31.1-73:13:06.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6517,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6517,18.73,0.06,0.0558,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3135, RA-DEC 01:00:30.2-74:06:56.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6518,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6518,18.73,0.06,0.0558,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2249, RA-DEC 00:54:35.9-72:13:53.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6519,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6519,18.73,0.06,0.0558,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2676, RA-DEC 00:57:22.1-71:54:04.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6520,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6520,18.73,0.06,0.0558,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4021, RA-DEC 01:08:12.9-71:40:08.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6521,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6521,18.73,0.06,0.0558,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4340, RA-DEC 01:12:25.6-72:23:47.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6522,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6522,18.73,0.06,0.0558,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4467, RA-DEC 01:15:00.6-72:25:52.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6523,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6523,18.73,0.06,0.0558,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4506, RA-DEC 01:16:04.4-73:29:50.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6524,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6524,18.73,0.06,0.0558,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4537, RA-DEC 01:17:08.0-72:20:05.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6525,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6525,18.73,0.06,0.0558,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4763, RA-DEC 01:00:27.4-74:19:47.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6526,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6526,18.74,0.06,0.0559,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2414, RA-DEC 00:55:36.8-73:00:33.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6527,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6527,18.74,0.06,0.0559,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4271, RA-DEC 01:11:25.7-72:53:07.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6528,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6528,18.74,0.06,0.0559,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0361, RA-DEC 00:40:30.2-73:04:54.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6529,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6529,18.74,0.06,0.0559,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4154, RA-DEC 01:09:47.0-72:32:35.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6530,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6530,18.74,0.06,0.0559,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3196, RA-DEC 01:00:56.8-72:56:39.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6531,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6531,18.74,0.06,0.0559,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4207, RA-DEC 01:10:27.9-72:11:17.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6532,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6532,18.74,0.06,0.0559,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0457, RA-DEC 00:42:19.9-74:02:09.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6533,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6533,18.74,0.06,0.0559,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4062, RA-DEC 01:08:44.7-72:53:40.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6534,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6534,18.74,0.06,0.056,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1556, RA-DEC 00:50:52.6-72:10:28.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6535,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6535,18.74,0.06,0.056,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3925, RA-DEC 01:07:16.4-72:26:12.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6536,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6536,18.74,0.06,0.056,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4816, RA-DEC 01:09:59.0-69:56:16.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6537,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6537,18.74,0.06,0.056,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2458, RA-DEC 00:55:52.8-72:35:04.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6538,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6538,18.74,0.06,0.056,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3908, RA-DEC 01:07:05.0-72:12:31.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6539,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6539,18.74,0.06,0.056,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4379, RA-DEC 01:13:14.1-72:05:16.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6540,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6540,18.74,0.06,0.056,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2428, RA-DEC 00:55:40.8-72:28:29.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6541,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6541,18.74,0.06,0.056,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2751, RA-DEC 00:57:53.3-72:24:46.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6542,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6542,18.74,0.06,0.056,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2807, RA-DEC 00:58:17.6-73:49:56.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6543,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6543,18.74,0.06,0.056,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4164, RA-DEC 01:09:53.4-73:07:13.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6544,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6544,18.74,0.06,0.056,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4797, RA-DEC 01:06:43.0-71:13:18.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6545,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6545,18.74,0.06,0.056,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4928, RA-DEC 01:42:25.3-72:38:19.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6546,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6546,18.74,0.06,0.0561,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4308, RA-DEC 01:11:51.9-74:02:54.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6547,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6547,18.74,0.06,0.0561,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3843, RA-DEC 01:06:25.7-72:51:49.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6548,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6548,18.74,0.06,0.0561,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3597, RA-DEC 01:04:10.0-72:22:29.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6549,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6549,18.74,0.06,0.0561,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4794, RA-DEC 01:06:20.4-74:24:26.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6550,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6550,18.75,0.06,0.0561,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1611, RA-DEC 00:51:06.6-72:56:33.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6551,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6551,18.75,0.06,0.0561,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4380, RA-DEC 01:13:15.5-72:33:06.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6552,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6552,18.75,0.06,0.0561,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4200, RA-DEC 01:10:17.5-72:38:54.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6553,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6553,18.75,0.06,0.0561,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4915, RA-DEC 01:38:37.4-73:04:32.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6554,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6554,18.75,0.06,0.0561,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2577, RA-DEC 00:56:37.9-72:54:30.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6555,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6555,18.75,0.06,0.0561,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4377, RA-DEC 01:13:12.1-72:52:31.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6556,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6556,18.75,0.06,0.0561,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4623, RA-DEC 01:24:19.4-72:58:01.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6557,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6557,18.75,0.06,0.0562,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3997, RA-DEC 01:07:57.8-72:49:11.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6558,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6558,18.75,0.06,0.0562,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4224, RA-DEC 01:10:43.3-71:34:09.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6559,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6559,18.75,0.06,0.0562,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4423, RA-DEC 01:13:53.8-72:46:04.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6560,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6560,18.75,0.06,0.0562,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3859, RA-DEC 01:06:35.2-72:58:46.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6561,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6561,18.75,0.06,0.0562,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3536, RA-DEC 01:03:43.5-72:20:30.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6562,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6562,18.75,0.06,0.0562,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2396, RA-DEC 00:55:30.2-72:45:34.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6563,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6563,18.75,0.06,0.0562,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3801, RA-DEC 01:06:02.4-72:35:13.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6564,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6564,18.75,0.06,0.0562,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4697, RA-DEC 00:39:16.5-72:01:58.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6565,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6565,18.75,0.06,0.0562,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4127, RA-DEC 01:09:25.4-73:17:48.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6566,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6566,18.75,0.06,0.0562,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4779, RA-DEC 01:03:20.7-74:41:49.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6567,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6567,18.75,0.06,0.0563,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1918, RA-DEC 00:52:35.6-72:59:20.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6568,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6568,18.75,0.06,0.0563,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4254, RA-DEC 01:11:11.1-72:04:48.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6569,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6569,18.75,0.06,0.0563,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4571, RA-DEC 01:18:33.1-72:27:44.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6570,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6570,18.75,0.06,0.0563,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4067, RA-DEC 01:08:51.8-73:38:20.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6571,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6571,18.75,0.06,0.0563,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3052, RA-DEC 00:59:51.5-71:44:50.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6572,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6572,18.75,0.06,0.0563,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4574, RA-DEC 01:18:49.8-72:27:47.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6573,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6573,18.75,0.06,0.0563,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4932, RA-DEC 01:44:44.7-72:37:17.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6574,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6574,18.75,0.06,0.0563,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1431, RA-DEC 00:50:02.3-73:23:09.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6575,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6575,18.75,0.06,0.0563,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1878, RA-DEC 00:52:22.2-72:25:17.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6576,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6576,18.75,0.06,0.0563,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3884, RA-DEC 01:06:53.2-72:35:04.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6577,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6577,18.75,0.06,0.0563,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3894, RA-DEC 01:07:00.1-73:38:18.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6578,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6578,18.75,0.06,0.0563,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3993, RA-DEC 01:07:56.7-72:20:29.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6579,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6579,18.75,0.06,0.0563,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4378, RA-DEC 01:13:12.1-72:47:44.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6580,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6580,18.75,0.06,0.0563,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4828, RA-DEC 01:12:16.2-74:14:14.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6581,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6581,18.75,0.06,0.0563,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3313, RA-DEC 01:01:49.8-72:29:56.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6582,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6582,18.75,0.06,0.0563,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4848, RA-DEC 01:17:33.1-74:20:52.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6583,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6583,18.75,0.06,0.0564,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4316, RA-DEC 01:11:57.6-71:58:04.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6584,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6584,18.75,0.06,0.0564,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2353, RA-DEC 00:55:11.4-72:42:24.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6585,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6585,18.76,0.06,0.0564,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4135, RA-DEC 01:09:33.8-73:09:00.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6586,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:37','1',NULL,'R',6586,18.76,0.06,0.0564,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3644, RA-DEC 01:04:30.3-72:30:25.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6587,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6587,18.76,0.06,0.0564,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4260, RA-DEC 01:11:16.9-71:31:33.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6588,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6588,18.76,0.06,0.0564,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4266, RA-DEC 01:11:21.0-72:46:18.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6589,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6589,18.76,0.06,0.0564,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4778, RA-DEC 01:03:19.5-70:56:03.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6590,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6590,18.76,0.06,0.0564,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3010, RA-DEC 00:59:35.4-73:03:18.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6591,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6591,18.76,0.06,0.0564,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3359, RA-DEC 01:02:14.7-73:21:02.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6592,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6592,18.76,0.06,0.0564,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4482, RA-DEC 01:15:25.8-73:12:56.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6593,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6593,18.75,0.12,0.0564,2163,NULL,NULL,'HV 837, 1, VK(W)','SMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6594,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6594,18.76,0.06,0.0564,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4629, RA-DEC 01:26:13.0-74:08:04.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6595,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6595,18.76,0.06,0.0565,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4691, RA-DEC 00:35:38.2-71:55:02.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6596,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6596,18.76,0.06,0.0565,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4499, RA-DEC 01:15:50.6-73:05:25.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6597,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6597,18.76,0.06,0.0565,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4092, RA-DEC 01:09:05.2-73:18:26.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6598,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6598,18.76,0.06,0.0565,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3411, RA-DEC 01:02:41.7-72:17:11.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6599,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6599,18.76,0.06,0.0565,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4725, RA-DEC 00:49:39.5-76:04:35.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6600,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6600,18.76,0.06,0.0566,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3130, RA-DEC 01:00:28.4-72:13:08.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6601,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6601,18.76,0.06,0.0566,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3235, RA-DEC 01:01:15.5-73:11:05.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6602,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6602,18.76,0.06,0.0566,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3495, RA-DEC 01:03:23.3-72:06:29.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6603,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6603,18.76,0.06,0.0566,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3911, RA-DEC 01:07:05.5-72:38:01.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6604,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6604,18.76,0.06,0.0566,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4568, RA-DEC 01:18:30.0-73:45:24.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6605,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6605,18.76,0.06,0.0566,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4009, RA-DEC 01:08:07.3-73:03:26.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6606,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6606,18.77,0.06,0.0566,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4332, RA-DEC 01:12:16.9-73:55:02.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6607,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6607,18.77,0.06,0.0566,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4492, RA-DEC 01:15:43.8-73:39:58.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6608,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6608,18.77,0.06,0.0566,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4752, RA-DEC 00:57:19.5-74:15:07.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6609,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6609,18.77,0.06,0.0567,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3274, RA-DEC 01:01:33.5-73:13:08.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6610,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6610,18.77,0.06,0.0567,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4925, RA-DEC 01:41:42.4-73:57:05.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6611,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6611,18.77,0.06,0.0567,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2544, RA-DEC 00:56:27.9-73:23:42.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6612,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6612,18.77,0.06,0.0567,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4916, RA-DEC 01:38:38.6-73:53:23.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6613,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6613,18.77,0.06,0.0567,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4060, RA-DEC 01:08:44.4-72:37:04.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6614,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6614,18.77,0.06,0.0567,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4455, RA-DEC 01:14:41.9-73:11:43.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6615,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6615,18.77,0.06,0.0567,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3619, RA-DEC 01:04:19.5-73:26:18.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6616,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6616,18.77,0.06,0.0568,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3012, RA-DEC 00:59:35.4-71:17:44.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6617,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6617,18.77,0.06,0.0568,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3126, RA-DEC 01:00:27.1-73:05:27.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6618,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6618,18.77,0.06,0.0568,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4624, RA-DEC 01:24:24.4-74:11:33.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6619,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,NULL,6619,18.77,NULL,0.0568,2163,NULL,NULL,NULL,'SMC',NULL,'1987AJ.....93.1090C',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6620,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6620,18.77,0.06,0.0568,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3809, RA-DEC 01:06:07.2-71:44:39.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6621,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6621,18.77,0.06,0.0568,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4368, RA-DEC 01:12:57.7-73:05:00.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6622,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6622,18.77,0.06,0.0568,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2002, RA-DEC 00:53:08.4-72:28:10.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6623,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6623,18.77,0.06,0.0568,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4211, RA-DEC 01:10:30.8-72:54:38.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6624,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6624,18.77,0.06,0.0569,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4381, RA-DEC 01:13:16.0-73:24:08.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6625,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6625,18.77,0.06,0.0569,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2200, RA-DEC 00:54:16.0-71:56:05.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6626,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6626,18.77,0.06,0.0569,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4558, RA-DEC 01:17:59.6-72:58:39.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6627,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6627,18.78,0.06,0.0569,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4094, RA-DEC 01:09:07.5-72:55:05.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6628,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6628,18.78,0.06,0.0569,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3013, RA-DEC 00:59:35.5-72:33:57.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6629,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6629,18.78,0.06,0.0569,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3526, RA-DEC 01:03:37.6-73:42:47.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6630,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6630,18.78,0.06,0.0569,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4289, RA-DEC 01:11:38.7-72:54:30.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6631,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6631,18.78,0.06,0.0569,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4408, RA-DEC 01:13:42.0-73:33:18.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6632,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6632,18.78,0.06,0.0569,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2971, RA-DEC 00:59:19.1-72:58:19.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6633,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6633,18.78,0.06,0.0569,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2991, RA-DEC 00:59:27.6-73:25:46.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6634,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6634,18.78,0.06,0.0569,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2420, RA-DEC 00:55:38.1-72:26:55.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6635,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6635,18.78,0.06,0.0569,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2819, RA-DEC 00:58:21.9-72:11:53.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6636,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6636,18.78,0.06,0.0569,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4319, RA-DEC 01:12:04.1-72:02:28.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6637,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6637,18.78,0.06,0.0569,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4140, RA-DEC 01:09:38.5-71:49:52.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6638,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6638,18.78,0.06,0.0569,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4439, RA-DEC 01:14:18.8-72:45:48.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6639,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6639,18.78,0.06,0.057,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4409, RA-DEC 01:13:42.1-73:54:39.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6640,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6640,18.78,0.06,0.057,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3483, RA-DEC 01:03:17.7-72:33:04.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6641,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6641,18.78,0.06,0.057,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4241, RA-DEC 01:11:00.0-72:00:17.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6642,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6642,18.78,0.06,0.057,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2342, RA-DEC 00:55:07.3-73:13:21.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6643,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6643,18.78,0.06,0.057,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4562, RA-DEC 01:18:16.2-71:41:28.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6644,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6644,18.78,0.06,0.057,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4299, RA-DEC 01:11:46.0-72:12:53.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6645,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6645,18.77,0.07,0.057,2163,NULL,NULL,'VI(WI)','SMC',NULL,'2000AcA....50..279U',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6646,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,NULL,6646,18.78,NULL,0.057,2163,NULL,18.45,NULL,'SMC',NULL,'1987ARA&A..25..345F',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6647,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,NULL,6647,18.78,0.07,0.057,2163,NULL,NULL,'HV 11211, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6648,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6648,18.78,0.06,0.057,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3934, RA-DEC 01:07:21.5-71:45:45.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6649,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6649,18.78,0.06,0.057,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4023, RA-DEC 01:08:15.7-72:04:07.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6650,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6650,18.78,0.06,0.057,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4052, RA-DEC 01:08:40.1-72:35:26.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6651,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6651,18.78,0.06,0.0571,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2079, RA-DEC 00:53:34.5-71:23:03.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6652,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6652,18.78,0.06,0.0571,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4147, RA-DEC 01:09:42.4-72:17:36.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6653,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6653,18.78,0.06,0.0571,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4788, RA-DEC 01:04:57.0-70:44:12.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6654,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6654,18.78,0.06,0.0571,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3746, RA-DEC 01:05:30.5-72:23:56.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6655,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6655,18.78,0.06,0.0571,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4586, RA-DEC 01:19:51.0-74:01:14.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6656,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6656,18.78,0.06,0.0571,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4937, RA-DEC 01:47:15.1-72:45:28.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6657,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6657,18.78,0.06,0.0571,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3599, RA-DEC 01:04:11.1-73:43:18.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6658,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6658,18.78,0.06,0.0571,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1626, RA-DEC 00:51:10.7-74:14:55.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6659,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6659,18.78,0.06,0.0571,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3040, RA-DEC 00:59:48.1-72:20:10.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6660,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6660,18.78,0.06,0.0571,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4436, RA-DEC 01:14:16.8-72:43:01.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6661,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6661,18.78,0.06,0.0571,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4323, RA-DEC 01:12:06.2-72:40:15.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6662,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6662,18.78,0.06,0.0571,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2463, RA-DEC 00:55:54.0-73:20:53.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6663,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6663,18.78,0.06,0.0571,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4238, RA-DEC 01:10:57.5-72:30:07.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6664,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6664,18.78,0.06,0.0571,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4601, RA-DEC 01:21:20.0-73:57:25.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6665,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6665,18.78,0.06,0.0571,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4589, RA-DEC 01:20:07.5-73:03:24.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6666,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6666,18.78,0.06,0.0571,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0581, RA-DEC 00:43:55.4-72:59:45.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6667,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6667,18.79,0.06,0.0572,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2912, RA-DEC 00:58:58.9-72:28:47.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6668,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6668,18.79,0.06,0.0572,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4004, RA-DEC 01:08:05.3-73:12:41.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6669,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6669,18.79,0.06,0.0572,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4155, RA-DEC 01:09:47.2-73:01:27.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6670,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6670,18.79,0.06,0.0572,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4940, RA-DEC 01:48:26.3-74:44:01.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6671,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6671,18.79,0.06,0.0572,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2224, RA-DEC 00:54:24.8-73:16:44.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6672,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6672,18.79,0.06,0.0572,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4394, RA-DEC 01:13:28.4-73:35:22.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6673,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6673,18.79,0.06,0.0572,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4710, RA-DEC 00:44:20.8-76:11:43.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6674,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6674,18.79,0.06,0.0572,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2598, RA-DEC 00:56:48.9-73:11:14.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6675,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6675,18.79,0.06,0.0572,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0103, RA-DEC 00:29:08.9-72:53:09.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6676,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6676,18.79,0.06,0.0572,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3880, RA-DEC 01:06:49.9-72:29:54.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6677,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6677,18.79,0.06,0.0572,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4304, RA-DEC 01:11:48.2-71:55:51.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6678,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6678,18.79,0.06,0.0572,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3258, RA-DEC 01:01:24.6-72:27:23.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6679,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6679,18.79,0.06,0.0572,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4069, RA-DEC 01:08:52.0-72:07:20.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6680,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6680,18.79,0.06,0.0572,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4479, RA-DEC 01:15:19.5-71:54:14.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6681,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6681,18.79,0.06,0.0572,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0291, RA-DEC 00:38:38.0-74:27:29.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6682,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6682,18.79,0.06,0.0572,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2722, RA-DEC 00:57:40.3-72:32:44.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6683,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6683,18.79,0.06,0.0572,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3616, RA-DEC 01:04:18.4-73:13:55.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6684,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6684,18.79,0.06,0.0572,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3976, RA-DEC 01:07:44.3-71:47:26.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6685,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6685,18.79,0.06,0.0573,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1581, RA-DEC 00:50:58.1-72:04:26.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6686,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6686,18.79,0.06,0.0573,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2324, RA-DEC 00:55:00.0-72:49:30.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6687,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6687,18.79,0.06,0.0573,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4213, RA-DEC 01:10:33.0-71:57:34.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6688,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6688,18.79,0.06,0.0573,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4071, RA-DEC 01:08:53.3-73:12:40.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6689,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6689,18.79,0.06,0.0573,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2069, RA-DEC 00:53:30.6-72:12:31.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6690,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6690,18.79,0.06,0.0573,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3438, RA-DEC 01:02:53.5-72:04:21.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6691,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6691,18.79,0.06,0.0573,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4611, RA-DEC 01:22:39.2-73:12:40.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6692,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,NULL,6692,18.79,NULL,0.0573,2163,NULL,NULL,NULL,'SMC',NULL,'1985PASAu...6..140V',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6693,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6693,18.79,0.06,0.0573,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2061, RA-DEC 00:53:27.8-73:25:01.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6694,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6694,18.79,0.06,0.0573,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3971, RA-DEC 01:07:40.2-72:23:38.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6695,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6695,18.79,0.06,0.0573,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4049, RA-DEC 01:08:36.6-72:34:50.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6696,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6696,18.79,0.06,0.0573,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4277, RA-DEC 01:11:29.0-72:38:42.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6697,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6697,18.79,0.06,0.0573,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3714, RA-DEC 01:05:14.9-73:23:40.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6698,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6698,18.79,0.06,0.0573,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4234, RA-DEC 01:10:52.0-72:11:42.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6699,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6699,18.79,0.06,0.0573,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4351, RA-DEC 01:12:42.3-72:19:32.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6700,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6700,18.79,0.06,0.0573,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3887, RA-DEC 01:06:56.3-72:18:04.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6701,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6701,18.79,0.06,0.0573,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4905, RA-DEC 01:35:44.0-73:04:31.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6702,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6702,18.79,0.06,0.0574,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2254, RA-DEC 00:54:37.2-72:03:05.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6703,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6703,18.79,0.06,0.0574,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3200, RA-DEC 01:00:57.4-73:35:56.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6704,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6704,18.79,0.06,0.0574,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4182, RA-DEC 01:10:05.9-72:05:28.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6705,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6705,18.79,0.06,0.0574,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4141, RA-DEC 01:09:40.0-73:25:00.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6706,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6706,18.79,0.06,0.0574,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1799, RA-DEC 00:52:00.9-73:10:32.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6707,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6707,18.79,0.06,0.0574,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2959, RA-DEC 00:59:13.4-71:34:46.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6708,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6708,18.79,0.06,0.0574,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3841, RA-DEC 01:06:24.6-72:33:49.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6709,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6709,18.79,0.06,0.0574,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3931, RA-DEC 01:07:19.7-71:57:29.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6710,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6710,18.79,0.06,0.0574,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4309, RA-DEC 01:11:52.1-72:39:50.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6711,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6711,18.79,0.06,0.0574,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2764, RA-DEC 00:58:01.0-73:44:12.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6712,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6712,18.79,0.06,0.0574,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3829, RA-DEC 01:06:18.0-71:53:29.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6713,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6713,18.8,0.06,0.0574,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4871, RA-DEC 01:25:33.0-72:23:14.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6714,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6714,18.8,0.06,0.0574,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2763, RA-DEC 00:57:59.2-72:14:06.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6715,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6715,18.8,0.06,0.0574,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3485, RA-DEC 01:03:17.8-73:24:03.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6716,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6716,18.8,0.06,0.0575,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2877, RA-DEC 00:58:45.9-73:03:34.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6717,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6717,18.8,0.06,0.0575,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2214, RA-DEC 00:54:21.5-74:13:00.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6718,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6718,18.8,0.06,0.0575,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3817, RA-DEC 01:06:12.2-72:51:18.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6719,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6719,18.8,0.06,0.0575,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3818, RA-DEC 01:06:12.2-73:52:15.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6720,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6720,18.8,0.06,0.0575,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3533, RA-DEC 01:03:42.7-71:52:24.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6721,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,NULL,6721,18.8,0.06,0.0575,2163,NULL,NULL,NULL,'SMC',NULL,'1988ApJ...329..712S',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6722,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6722,18.8,0.06,0.0575,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4396, RA-DEC 01:13:29.4-73:30:58.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6723,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6723,18.8,0.06,0.0575,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4314, RA-DEC 01:11:56.7-73:42:47.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6724,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6724,18.8,0.06,0.0575,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1842, RA-DEC 00:52:12.8-72:34:36.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6725,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6725,18.8,0.06,0.0575,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2313, RA-DEC 00:54:58.2-73:03:55.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6726,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6726,18.8,0.06,0.0575,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3713, RA-DEC 01:05:13.9-72:25:46.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6727,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6727,18.8,0.06,0.0575,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4076, RA-DEC 01:08:57.3-72:03:37.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6728,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6728,18.8,0.06,0.0575,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4268, RA-DEC 01:11:24.0-72:27:02.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6729,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6729,18.8,0.06,0.0575,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4886, RA-DEC 01:29:14.6-71:51:53.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6730,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6730,18.8,0.06,0.0576,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3673, RA-DEC 01:04:50.4-71:39:34.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6731,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6731,18.8,0.06,0.0576,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3572, RA-DEC 01:04:02.9-72:05:51.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6732,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6732,18.8,0.06,0.0576,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1543, RA-DEC 00:50:47.1-72:48:12.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6733,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6733,18.8,0.06,0.0576,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3688, RA-DEC 01:04:58.6-71:38:19.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6734,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6734,18.8,0.06,0.0576,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4705, RA-DEC 00:42:21.8-72:11:53.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6735,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6735,18.8,0.06,0.0576,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1656, RA-DEC 00:51:20.1-71:50:07.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6736,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6736,18.8,0.06,0.0576,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3440, RA-DEC 01:02:55.3-72:12:34.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6737,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6737,18.8,0.06,0.0577,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2791, RA-DEC 00:58:10.6-72:14:18.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6738,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6738,18.8,0.06,0.0577,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3386, RA-DEC 01:02:28.0-72:03:27.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6739,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6739,18.8,0.06,0.0577,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4236, RA-DEC 01:10:55.2-73:14:39.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6740,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6740,18.8,0.06,0.0577,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2871, RA-DEC 00:58:43.6-71:21:58.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6741,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6741,18.8,0.06,0.0577,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4034, RA-DEC 01:08:21.4-73:12:27.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6742,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6742,18.81,0.06,0.0577,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4437, RA-DEC 01:14:17.9-73:07:23.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6743,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6743,18.81,0.06,0.0577,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2201, RA-DEC 00:54:16.3-72:28:20.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6744,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6744,18.81,0.06,0.0577,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2615, RA-DEC 00:56:57.5-72:24:00.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6745,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6745,18.81,0.06,0.0577,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4068, RA-DEC 01:08:51.8-72:54:54.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6746,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6746,18.81,0.06,0.0577,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4421, RA-DEC 01:13:50.9-72:03:45.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6747,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6747,18.81,0.06,0.0577,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4757, RA-DEC 00:58:25.7-74:44:59.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6748,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,NULL,6748,18.81,0.07,0.0577,2163,NULL,NULL,'HV 02233, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6749,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6749,18.81,0.06,0.0577,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3289, RA-DEC 01:01:43.3-73:31:56.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6750,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6750,18.81,0.06,0.0577,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4327, RA-DEC 01:12:11.3-72:52:39.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6751,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6751,18.81,0.06,0.0577,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2447, RA-DEC 00:55:48.3-72:31:27.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6752,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6752,18.81,0.06,0.0577,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3903, RA-DEC 01:07:03.4-74:00:21.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6753,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6753,18.81,0.06,0.0577,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4949, RA-DEC 01:53:50.7-70:31:08.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6754,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6754,18.81,0.06,0.0577,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4282, RA-DEC 01:11:35.1-73:34:10.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6755,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6755,18.81,0.06,0.0577,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4505, RA-DEC 01:15:59.4-71:20:45.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6756,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6756,18.81,0.06,0.0578,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2741, RA-DEC 00:57:47.2-72:18:03.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6757,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6757,18.81,0.06,0.0578,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2858, RA-DEC 00:58:37.7-73:28:21.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6758,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6758,18.81,0.06,0.0578,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3991, RA-DEC 01:07:56.3-73:47:14.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6759,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6759,18.81,0.06,0.0578,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4400, RA-DEC 01:13:32.1-72:30:02.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6760,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6760,18.81,0.06,0.0578,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4461, RA-DEC 01:14:52.0-73:24:20.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6761,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6761,18.81,0.06,0.0578,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4017, RA-DEC 01:08:11.6-72:31:18.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6762,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6762,18.81,0.06,0.0578,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4875, RA-DEC 01:26:19.7-74:50:09.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6763,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6763,18.81,0.06,0.0578,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4018, RA-DEC 01:08:11.6-72:35:59.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6764,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6764,18.81,NULL,0.0578,2163,NULL,NULL,'SMC-LMC 0.31 mag','SMC',NULL,'1988ASPC....4....9F',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6765,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,NULL,6765,18.81,0.06,0.0578,2163,NULL,NULL,'6, K, Baade-Wesselink, Storm et al. method','SMC',NULL,'2013A&A...550A..70G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6766,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6766,18.81,0.06,0.0578,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4746, RA-DEC 00:56:53.7-74:19:25.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6767,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6767,18.81,0.06,0.0578,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4902, RA-DEC 01:34:52.7-73:18:03.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6768,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6768,18.81,0.06,0.0578,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3992, RA-DEC 01:07:56.5-73:12:45.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6769,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6769,18.81,0.06,0.0578,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2812, RA-DEC 00:58:20.1-72:11:48.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6770,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6770,18.81,0.06,0.0578,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2645, RA-DEC 00:57:08.6-71:49:39.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6771,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6771,18.81,0.06,0.0579,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3140, RA-DEC 01:00:34.6-74:10:23.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6772,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6772,18.81,0.06,0.0579,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3354, RA-DEC 01:02:12.0-72:43:20.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6773,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6773,18.81,0.06,0.0579,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4129, RA-DEC 01:09:28.4-73:05:31.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6774,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6774,18.81,0.06,0.0579,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4199, RA-DEC 01:10:17.3-73:11:03.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6775,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6775,18.81,0.06,0.0579,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4580, RA-DEC 01:19:21.1-73:41:09.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6776,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6776,18.81,0.06,0.0579,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4189, RA-DEC 01:10:09.7-73:42:48.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6777,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6777,18.81,0.06,0.0579,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4415, RA-DEC 01:13:46.5-72:11:43.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6778,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6778,18.81,0.06,0.0579,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4565, RA-DEC 01:18:24.8-72:35:48.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6779,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6779,18.81,0.06,0.0579,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4924, RA-DEC 01:41:12.6-72:00:17.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6780,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6780,18.81,0.06,0.0579,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3132, RA-DEC 01:00:29.5-72:03:42.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6781,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6781,18.81,0.06,0.0579,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4001, RA-DEC 01:08:00.3-72:07:17.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6782,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6782,18.81,0.06,0.0579,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4065, RA-DEC 01:08:49.6-72:25:17.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6783,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6783,18.81,0.06,0.0579,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4252, RA-DEC 01:11:09.3-72:37:35.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6784,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6784,18.81,0.06,0.0579,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4366, RA-DEC 01:12:57.4-72:20:30.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6785,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6785,18.81,0.06,0.0579,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4255, RA-DEC 01:11:11.4-72:24:44.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6786,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6786,18.81,0.06,0.0579,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4868, RA-DEC 01:24:25.4-74:16:50.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6787,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6787,18.81,0.06,0.0579,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4185, RA-DEC 01:10:06.6-73:39:04.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6788,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6788,18.81,0.06,0.0579,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3439, RA-DEC 01:02:54.3-72:58:49.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6789,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6789,18.82,0.06,0.058,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1011, RA-DEC 00:47:37.0-72:11:14.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6790,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6790,18.82,0.06,0.058,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3588, RA-DEC 01:04:09.0-72:29:39.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6791,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6791,18.82,0.06,0.058,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4367, RA-DEC 01:12:57.6-72:27:47.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6792,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6792,18.82,0.06,0.058,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2083, RA-DEC 00:53:37.4-73:16:33.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6793,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6793,18.82,0.06,0.058,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3764, RA-DEC 01:05:43.2-72:11:16.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6794,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6794,18.82,0.06,0.058,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3941, RA-DEC 01:07:24.2-72:42:41.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6795,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6795,18.82,0.06,0.058,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4606, RA-DEC 01:21:48.0-72:38:00.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6796,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6796,18.82,0.06,0.058,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3958, RA-DEC 01:07:32.9-71:44:45.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6797,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6797,18.82,0.06,0.058,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4375, RA-DEC 01:13:11.4-72:30:51.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6798,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6798,18.82,0.06,0.058,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2901, RA-DEC 00:58:52.9-74:08:02.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6799,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6799,18.82,0.06,0.058,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3654, RA-DEC 01:04:38.2-71:40:08.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6800,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6800,18.82,0.06,0.058,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4169, RA-DEC 01:09:57.7-71:56:09.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6801,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6801,18.82,0.06,0.058,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4823, RA-DEC 01:10:59.4-75:27:53.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6802,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6802,18.82,0.06,0.058,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3084, RA-DEC 01:00:09.5-72:13:47.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6803,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6803,18.82,0.06,0.058,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4811, RA-DEC 01:08:15.1-74:24:56.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6804,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6804,18.82,0.06,0.058,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2694, RA-DEC 00:57:29.8-71:59:39.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6805,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,NULL,6805,18.83,0.05,0.058,2163,NULL,NULL,'78, UBVRIJHK +Z','SMC',NULL,'1997ApJ...491...13K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6806,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,NULL,6806,18.8,NULL,0.058,2163,NULL,NULL,'6, BVIK','SMC',NULL,'2004A&A...420..655G',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6807,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,NULL,6807,18.82,NULL,0.058,2163,NULL,NULL,NULL,'SMC',NULL,'1988ApJ...333..617M',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6808,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6808,18.82,0.06,0.058,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2110, RA-DEC 00:53:45.4-72:16:19.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6809,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6809,18.82,0.06,0.058,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2477, RA-DEC 00:55:59.2-71:54:09.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6810,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6810,18.82,0.06,0.058,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3659, RA-DEC 01:04:42.0-73:26:00.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6811,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6811,18.82,0.06,0.058,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4292, RA-DEC 01:11:39.7-72:34:19.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6812,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6812,18.82,0.06,0.058,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4770, RA-DEC 01:02:22.0-71:10:08.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6813,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6813,18.82,0.06,0.058,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4210, RA-DEC 01:10:29.4-73:16:19.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6814,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6814,18.82,0.06,0.058,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4887, RA-DEC 01:29:38.6-70:26:28.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6815,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6815,18.82,0.06,0.058,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3310, RA-DEC 01:01:48.9-72:25:02.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6816,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6816,18.82,0.06,0.058,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3944, RA-DEC 01:07:25.4-72:34:02.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6817,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6817,18.82,0.06,0.058,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1858, RA-DEC 00:52:17.4-73:26:22.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6818,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6818,18.82,0.06,0.0581,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2326, RA-DEC 00:55:01.1-72:49:14.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6819,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6819,18.82,0.06,0.0581,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4303, RA-DEC 01:11:47.8-73:48:22.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6820,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6820,18.82,0.06,0.0581,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4569, RA-DEC 01:18:32.2-72:50:08.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6821,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6821,18.82,0.06,0.0581,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1407, RA-DEC 00:49:54.2-72:40:54.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6822,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6822,18.82,0.06,0.0581,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4120, RA-DEC 01:09:21.0-73:37:31.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6823,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6823,18.82,0.06,0.0581,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3926, RA-DEC 01:07:17.2-71:57:01.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6824,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6824,18.82,0.06,0.0581,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4616, RA-DEC 01:23:20.3-73:16:13.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6825,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6825,18.82,0.06,0.0581,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2602, RA-DEC 00:56:50.3-73:23:27.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6826,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6826,18.82,0.06,0.0581,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3773, RA-DEC 01:05:47.5-73:12:44.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6827,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6827,18.82,0.06,0.0581,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2330, RA-DEC 00:55:02.8-72:08:47.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6828,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6828,18.82,0.06,0.0582,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1730, RA-DEC 00:51:41.2-72:43:18.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6829,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6829,18.82,0.06,0.0582,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3955, RA-DEC 01:07:30.5-72:22:29.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6830,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6830,18.82,0.06,0.0582,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1857, RA-DEC 00:52:17.2-72:25:32.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6831,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6831,18.82,0.06,0.0582,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3952, RA-DEC 01:07:30.0-73:11:51.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6832,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6832,18.82,0.06,0.0582,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3962, RA-DEC 01:07:34.7-71:54:39.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6833,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6833,18.82,0.06,0.0582,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4341, RA-DEC 01:12:27.7-72:10:02.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6834,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6834,18.82,0.06,0.0582,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4343, RA-DEC 01:12:33.4-73:35:25.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6835,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6835,18.82,0.06,0.0582,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4726, RA-DEC 00:49:54.0-70:31:30.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6836,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6836,18.82,0.06,0.0582,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0533, RA-DEC 00:43:26.2-73:15:15.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6837,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6837,18.82,0.06,0.0582,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4030, RA-DEC 01:08:18.0-73:50:33.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6838,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6838,18.82,0.06,0.0582,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4272, RA-DEC 01:11:26.4-73:20:46.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6839,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6839,18.82,0.06,0.0582,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4452, RA-DEC 01:14:39.6-72:37:39.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6840,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6840,18.82,0.06,0.0582,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4892, RA-DEC 01:29:52.7-74:23:11.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6841,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6841,18.82,0.06,0.0582,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3476, RA-DEC 01:03:14.9-71:44:53.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6842,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6842,18.82,0.06,0.0582,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4275, RA-DEC 01:11:27.9-72:10:05.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6843,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6843,18.82,0.06,0.0582,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4542, RA-DEC 01:17:14.8-73:04:51.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6844,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6844,18.82,0.06,0.0582,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4063, RA-DEC 01:08:46.7-72:22:21.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6845,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6845,18.82,0.06,0.0582,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4418, RA-DEC 01:13:49.1-73:22:52.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6846,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6846,18.82,0.06,0.0582,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2701, RA-DEC 00:57:32.7-72:30:06.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6847,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6847,18.82,0.06,0.0582,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4944, RA-DEC 01:50:25.7-72:08:42.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6848,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,NULL,6848,18.82,0.07,0.0582,2163,NULL,NULL,'HV 02230, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6849,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6849,18.82,0.06,0.0582,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2942, RA-DEC 00:59:07.3-73:34:02.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6850,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6850,18.82,0.06,0.0582,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4166, RA-DEC 01:09:54.9-73:16:10.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6851,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6851,18.83,0.06,0.0582,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2827, RA-DEC 00:58:24.1-73:22:58.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6852,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6852,18.83,0.06,0.0582,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3050, RA-DEC 00:59:51.1-72:12:14.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6853,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6853,18.83,0.06,0.0582,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4401, RA-DEC 01:13:33.4-72:20:25.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6854,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6854,18.83,0.06,0.0582,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4626, RA-DEC 01:24:39.0-73:02:44.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6855,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6855,18.83,0.06,0.0582,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4882, RA-DEC 01:27:46.4-74:04:50.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6856,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6856,18.83,0.06,0.0582,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3314, RA-DEC 01:01:52.8-71:34:44.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6857,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6857,18.83,0.06,0.0582,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3657, RA-DEC 01:04:40.0-72:19:10.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6858,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6858,18.83,0.06,0.0582,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4448, RA-DEC 01:14:34.1-72:13:59.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6859,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6859,18.83,0.06,0.0582,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4738, RA-DEC 00:53:45.1-74:52:12.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6860,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6860,18.83,0.06,0.0583,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4186, RA-DEC 01:10:06.9-72:56:53.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6861,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6861,18.83,0.06,0.0583,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4208, RA-DEC 01:10:27.9-72:26:43.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6862,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6862,18.83,0.06,0.0583,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4477, RA-DEC 01:15:13.7-72:41:26.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6863,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6863,18.83,0.06,0.0583,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2347, RA-DEC 00:55:08.3-73:58:12.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6864,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6864,18.83,0.06,0.0583,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4566, RA-DEC 01:18:26.3-72:51:01.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6865,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6865,18.83,0.06,0.0583,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2228, RA-DEC 00:54:27.8-72:14:31.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6866,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6866,18.83,0.06,0.0583,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3730, RA-DEC 01:05:22.5-72:02:09.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6867,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,NULL,6867,18.83,0.04,0.0583,2163,NULL,NULL,NULL,'SMC',NULL,'1989ApJ...346..629V',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6868,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,NULL,6868,18.83,0.07,0.0583,2163,NULL,NULL,'HV 02209, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6869,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,NULL,6869,18.83,0.07,0.0583,2163,NULL,NULL,'HV 00863, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6870,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6870,18.83,0.06,0.0583,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3144, RA-DEC 01:00:36.1-72:15:10.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6871,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6871,18.83,0.06,0.0583,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3329, RA-DEC 01:01:57.9-72:11:49.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6872,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6872,18.83,0.06,0.0583,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2100, RA-DEC 00:53:42.9-73:27:07.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6873,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6873,18.83,0.06,0.0583,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4298, RA-DEC 01:11:45.2-73:39:31.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6874,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6874,18.83,0.06,0.0583,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4837, RA-DEC 01:14:20.9-74:21:52.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6875,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6875,18.83,0.06,0.0583,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1929, RA-DEC 00:52:38.1-72:21:55.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6876,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6876,18.83,0.06,0.0583,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2650, RA-DEC 00:57:10.3-71:53:33.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6877,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6877,18.83,0.06,0.0583,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3180, RA-DEC 01:00:48.8-73:34:26.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6878,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6878,18.83,0.06,0.0583,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3938, RA-DEC 01:07:23.6-72:13:32.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6879,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6879,18.83,0.06,0.0584,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3003, RA-DEC 00:59:31.3-72:54:50.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6880,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6880,18.83,0.06,0.0584,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4326, RA-DEC 01:12:08.7-72:45:31.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6881,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6881,18.83,0.06,0.0584,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4209, RA-DEC 01:10:29.0-73:55:19.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6882,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6882,18.83,0.06,0.0584,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4771, RA-DEC 01:02:38.1-74:16:35.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6883,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6883,18.83,0.06,0.0584,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4877, RA-DEC 01:26:28.0-71:45:15.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6884,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6884,18.83,0.06,0.0584,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4074, RA-DEC 01:08:55.5-71:37:19.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6885,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6885,18.83,0.06,0.0584,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4627, RA-DEC 01:24:48.9-72:35:57.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6886,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6886,18.83,0.06,0.0584,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1296, RA-DEC 00:49:16.9-73:33:58.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6887,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6887,18.83,0.06,0.0584,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2925, RA-DEC 00:59:02.9-71:30:49.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6888,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6888,18.83,0.06,0.0584,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3747, RA-DEC 01:05:32.7-71:34:30.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6889,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6889,18.83,0.06,0.0584,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2202, RA-DEC 00:54:16.8-72:36:58.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6890,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6890,18.83,0.06,0.0584,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3111, RA-DEC 01:00:19.5-73:40:26.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6891,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6891,18.83,0.06,0.0584,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4010, RA-DEC 01:08:07.5-73:24:45.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6892,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6892,18.83,0.06,0.0584,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4520, RA-DEC 01:16:31.1-72:52:54.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6893,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6893,18.83,0.06,0.0584,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4517, RA-DEC 01:16:24.7-73:14:59.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6894,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6894,18.83,0.06,0.0585,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1746, RA-DEC 00:51:48.4-73:00:34.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6895,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6895,18.83,0.06,0.0585,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2160, RA-DEC 00:54:01.0-73:04:51.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6896,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6896,18.83,0.06,0.0585,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2937, RA-DEC 00:59:05.5-72:03:44.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6897,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6897,18.83,0.06,0.0585,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3896, RA-DEC 01:07:00.5-72:03:53.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6898,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6898,18.83,0.06,0.0585,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3700, RA-DEC 01:05:06.0-73:32:03.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6899,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6899,18.83,0.06,0.0585,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3748, RA-DEC 01:05:34.0-72:42:28.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6900,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6900,18.83,0.06,0.0585,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4472, RA-DEC 01:15:05.5-72:46:13.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6901,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6901,18.83,0.06,0.0585,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2932, RA-DEC 00:59:04.3-72:00:49.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6902,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6902,18.83,0.06,0.0585,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3978, RA-DEC 01:07:45.5-73:44:30.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6903,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6903,18.84,0.06,0.0585,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2927, RA-DEC 00:59:03.2-73:22:28.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6904,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6904,18.84,0.06,0.0585,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3776, RA-DEC 01:05:49.7-71:46:56.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6905,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6905,18.84,0.06,0.0585,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3590, RA-DEC 01:04:09.3-72:34:59.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6906,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6906,18.84,0.06,0.0585,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4484, RA-DEC 01:15:31.9-72:20:30.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6907,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6907,18.84,0.06,0.0585,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2103, RA-DEC 00:53:43.5-72:43:51.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6908,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6908,18.84,0.06,0.0585,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3493, RA-DEC 01:03:23.1-73:18:40.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6909,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,NULL,6909,18.84,0.07,0.0585,2163,NULL,NULL,'HV 00823, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6910,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6910,18.84,0.06,0.0585,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3623, RA-DEC 01:04:20.6-71:40:38.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6911,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6911,18.84,0.06,0.0585,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3881, RA-DEC 01:06:51.5-73:18:45.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6912,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6912,18.84,0.06,0.0585,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4342, RA-DEC 01:12:33.1-71:59:36.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6913,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6913,18.84,0.06,0.0585,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4841, RA-DEC 01:15:05.9-75:46:04.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6914,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6914,18.84,0.06,0.0585,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4609, RA-DEC 01:22:08.0-72:57:53.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6915,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6915,18.84,0.06,0.0585,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3519, RA-DEC 01:03:35.1-73:15:41.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6916,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6916,18.84,0.06,0.0585,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4578, RA-DEC 01:19:12.8-73:23:11.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6917,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6917,18.84,0.06,0.0585,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0659, RA-DEC 00:44:30.7-73:54:05.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6918,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6918,18.84,0.06,0.0586,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3060, RA-DEC 00:59:54.5-71:44:42.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6919,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6919,18.84,0.06,0.0586,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3724, RA-DEC 01:05:20.2-73:02:00.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6920,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6920,18.84,0.06,0.0586,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4073, RA-DEC 01:08:55.3-73:38:23.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6921,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6921,18.84,0.06,0.0586,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4552, RA-DEC 01:17:46.7-73:28:05.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6922,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6922,18.84,0.06,0.0586,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4128, RA-DEC 01:09:26.7-73:36:14.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6923,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6923,18.84,0.06,0.0586,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2936, RA-DEC 00:59:04.8-72:04:41.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6924,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6924,18.84,0.06,0.0586,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2963, RA-DEC 00:59:15.1-72:25:49.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6925,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6925,18.84,0.06,0.0586,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3082, RA-DEC 01:00:08.4-73:18:46.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6926,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6926,18.84,0.06,0.0586,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3943, RA-DEC 01:07:24.7-72:31:20.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6927,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6927,18.84,0.06,0.0586,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4469, RA-DEC 01:15:04.3-72:34:35.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6928,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6928,18.84,0.06,0.0586,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2375, RA-DEC 00:55:21.0-72:40:30.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6929,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6929,18.84,0.06,0.0586,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3549, RA-DEC 01:03:52.2-72:09:14.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6930,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6930,18.84,0.06,0.0586,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4057, RA-DEC 01:08:43.9-72:30:42.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6931,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,NULL,6931,18.84,0.16,0.0586,2163,NULL,NULL,NULL,'SMC',NULL,'1983ApJ...274...20S',1983,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6932,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6932,18.84,0.06,0.0586,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3027, RA-DEC 00:59:40.7-73:27:55.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6933,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6933,18.84,0.06,0.0586,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3112, RA-DEC 01:00:19.7-72:38:38.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6934,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6934,18.84,0.06,0.0586,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3427, RA-DEC 01:02:46.5-71:59:15.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6935,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6935,18.84,0.06,0.0586,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3718, RA-DEC 01:05:17.0-73:19:16.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6936,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6936,18.84,0.06,0.0586,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4113, RA-DEC 01:09:18.2-72:26:10.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6937,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6937,18.84,0.06,0.0586,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4753, RA-DEC 00:57:26.9-74:16:48.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6938,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6938,18.84,0.06,0.0586,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1779, RA-DEC 00:51:57.8-72:32:08.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6939,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6939,18.84,0.06,0.0586,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4440, RA-DEC 01:14:21.3-73:17:18.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6940,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6940,18.84,0.06,0.0586,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4860, RA-DEC 01:23:00.6-74:22:16.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6941,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6941,18.84,0.06,0.0587,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1062, RA-DEC 00:47:53.6-72:39:30.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6942,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6942,18.84,0.06,0.0587,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3662, RA-DEC 01:04:43.4-71:19:05.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6943,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6943,18.84,0.06,0.0587,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3998, RA-DEC 01:07:58.0-71:54:55.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6944,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6944,18.84,0.06,0.0587,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3479, RA-DEC 01:03:16.3-72:01:51.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6945,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6945,18.84,0.06,0.0587,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4466, RA-DEC 01:14:59.1-73:13:15.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6946,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6946,18.84,0.06,0.0587,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3631, RA-DEC 01:04:24.0-72:37:21.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6947,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6947,18.84,0.06,0.0587,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3610, RA-DEC 01:04:15.2-72:07:41.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6948,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6948,18.84,0.06,0.0587,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3628, RA-DEC 01:04:23.2-72:24:50.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6949,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,NULL,6949,18.85,0.07,0.0587,2163,NULL,NULL,'HV 01560, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6950,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,NULL,6950,18.84,0.07,0.0587,2163,NULL,NULL,'HV 01954, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6951,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6951,18.84,0.06,0.0587,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2196, RA-DEC 00:54:15.3-72:31:11.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6952,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6952,18.84,0.06,0.0587,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2422, RA-DEC 00:55:38.8-72:12:21.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6953,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6953,18.84,0.06,0.0587,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2924, RA-DEC 00:59:02.6-72:07:17.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6954,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6954,18.84,0.06,0.0587,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3191, RA-DEC 01:00:54.2-73:21:39.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6955,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6955,18.84,0.06,0.0587,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1282, RA-DEC 00:49:12.8-73:22:31.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6956,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6956,18.84,0.06,0.0587,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1557, RA-DEC 00:50:52.8-74:07:55.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6957,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6957,18.84,0.06,0.0587,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2132, RA-DEC 00:53:53.0-72:52:34.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6958,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6958,18.84,0.06,0.0587,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4202, RA-DEC 01:10:19.8-73:13:04.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6959,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6959,18.84,0.06,0.0587,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1311, RA-DEC 00:49:21.3-73:03:48.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6960,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6960,18.84,0.06,0.0587,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2369, RA-DEC 00:55:18.8-72:48:47.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6961,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6961,18.84,0.06,0.0587,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3678, RA-DEC 01:04:53.2-71:39:05.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6962,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6962,18.85,0.06,0.0588,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0668, RA-DEC 00:44:37.9-73:08:12.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6963,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6963,18.85,0.06,0.0588,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1789, RA-DEC 00:51:59.4-74:08:42.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6964,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6964,18.85,0.06,0.0588,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1887, RA-DEC 00:52:26.2-73:45:16.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6965,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6965,18.85,0.06,0.0588,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4184, RA-DEC 01:10:06.0-73:04:16.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6966,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6966,18.85,0.06,0.0588,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3265, RA-DEC 01:01:30.3-74:13:21.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6967,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6967,18.85,0.06,0.0588,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4256, RA-DEC 01:11:13.1-71:51:02.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6968,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6968,18.85,0.06,0.0588,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1441, RA-DEC 00:50:05.6-72:44:49.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6969,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6969,18.85,0.06,0.0588,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3072, RA-DEC 01:00:00.0-72:07:33.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6970,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6970,18.85,0.06,0.0588,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3491, RA-DEC 01:03:20.5-72:19:07.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6971,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6971,18.85,0.06,0.0588,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3900, RA-DEC 01:07:02.5-71:53:27.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6972,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6972,18.85,0.06,0.0588,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4743, RA-DEC 00:55:33.6-74:30:27.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6973,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6973,18.85,0.06,0.0588,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2309, RA-DEC 00:54:57.9-72:27:09.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6974,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6974,18.85,0.06,0.0588,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2968, RA-DEC 00:59:18.5-72:51:20.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6975,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6975,18.85,0.06,0.0588,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4139, RA-DEC 01:09:38.2-72:52:47.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6976,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6976,18.85,0.06,0.0588,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4556, RA-DEC 01:17:56.6-72:32:16.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6977,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6977,18.85,0.06,0.0589,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3331, RA-DEC 01:01:58.7-72:38:21.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6978,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6978,18.85,0.06,0.0589,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3530, RA-DEC 01:03:40.7-72:38:25.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6979,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6979,18.85,0.06,0.0589,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4221, RA-DEC 01:10:40.1-72:24:32.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6980,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6980,18.85,0.06,0.0589,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2066, RA-DEC 00:53:29.9-73:20:33.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6981,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6981,18.85,0.06,0.0589,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2260, RA-DEC 00:54:39.6-71:55:33.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6982,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6982,18.85,0.06,0.0589,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2677, RA-DEC 00:57:22.4-72:59:51.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6983,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6983,18.85,0.06,0.0589,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2933, RA-DEC 00:59:04.3-73:15:05.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6984,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6984,18.85,0.06,0.0589,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4502, RA-DEC 01:15:55.2-72:13:23.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6985,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6985,18.85,0.06,0.0589,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4596, RA-DEC 01:20:33.3-72:32:32.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6986,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6986,18.85,0.06,0.0589,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3175, RA-DEC 01:00:47.2-73:31:48.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6987,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6987,18.85,0.06,0.0589,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3480, RA-DEC 01:03:16.4-73:27:00.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6988,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6988,18.85,0.06,0.0589,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4521, RA-DEC 01:16:31.6-72:01:49.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6989,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,NULL,6989,18.85,0.07,0.0589,2163,NULL,NULL,'HV 02202, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6990,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6990,18.85,0.06,0.0589,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1254, RA-DEC 00:49:04.0-73:05:38.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6991,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6991,18.85,0.06,0.0589,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3291, RA-DEC 01:01:43.4-71:25:33.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6992,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6992,18.85,0.06,0.0589,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4880, RA-DEC 01:26:56.1-68:43:52.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6993,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6993,18.85,0.06,0.0589,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3433, RA-DEC 01:02:50.3-73:30:36.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6994,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6994,18.85,0.06,0.0589,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3457, RA-DEC 01:03:03.3-72:48:20.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6995,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6995,18.85,0.06,0.0589,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4134, RA-DEC 01:09:31.9-72:45:10.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6996,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6996,18.85,0.06,0.0589,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4500, RA-DEC 01:15:51.3-71:42:14.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6997,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6997,18.85,0.06,0.0589,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4346, RA-DEC 01:12:37.2-71:29:29.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6998,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6998,18.85,0.06,0.0589,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4390, RA-DEC 01:13:25.8-73:37:39.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6999,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',6999,18.85,0.06,0.059,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1980, RA-DEC 00:52:58.1-73:09:52.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7000,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7000,18.85,0.06,0.059,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3267, RA-DEC 01:01:30.8-73:25:03.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7001,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7001,18.85,0.06,0.059,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3648, RA-DEC 01:04:32.9-71:41:24.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7002,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7002,18.85,0.06,0.059,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4832, RA-DEC 01:13:17.3-69:47:06.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7003,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7003,18.85,0.06,0.059,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3460, RA-DEC 01:03:06.4-73:53:16.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7004,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7004,18.85,0.06,0.059,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4028, RA-DEC 01:08:17.2-72:53:07.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7005,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7005,18.85,0.06,0.059,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4512, RA-DEC 01:16:14.4-73:38:33.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7006,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7006,18.85,0.06,0.059,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4910, RA-DEC 01:36:26.6-75:07:31.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7007,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7007,18.85,0.06,0.059,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2283, RA-DEC 00:54:49.6-73:15:35.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7008,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7008,18.85,0.06,0.059,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3535, RA-DEC 01:03:43.4-72:45:32.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7009,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7009,18.85,0.06,0.059,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4755, RA-DEC 00:58:09.0-74:57:13.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7010,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,NULL,7010,18.85,NULL,0.059,2163,NULL,NULL,'161, B, V, NIR','SMC',NULL,'1986ApJ...301..664M',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7011,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,NULL,7011,18.84,0.1,0.059,2163,NULL,NULL,NULL,'SMC',NULL,'1997AJ....113...13B',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7012,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7012,18.85,0.06,0.059,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4936, RA-DEC 01:46:29.1-73:28:29.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7013,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7013,18.85,0.06,0.059,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2277, RA-DEC 00:54:46.7-73:23:52.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7014,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7014,18.85,0.06,0.059,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4591, RA-DEC 01:20:09.3-72:50:56.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7015,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7015,18.86,0.06,0.059,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4204, RA-DEC 01:10:24.3-72:34:30.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7016,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7016,18.86,0.06,0.059,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4879, RA-DEC 01:26:50.0-72:41:03.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7017,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7017,18.86,0.06,0.059,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4446, RA-DEC 01:14:32.2-72:32:13.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7018,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7018,18.86,0.06,0.059,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4864, RA-DEC 01:24:08.2-72:21:11.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7019,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7019,18.86,0.06,0.0591,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4930, RA-DEC 01:43:45.5-73:53:58.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7020,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7020,18.86,0.06,0.0591,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2300, RA-DEC 00:54:53.9-72:03:28.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7021,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7021,18.86,0.06,0.0591,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4005, RA-DEC 01:08:05.7-73:44:00.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7022,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7022,18.86,0.06,0.0591,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1612, RA-DEC 00:51:07.2-74:17:13.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7023,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7023,18.86,0.06,0.0591,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2363, RA-DEC 00:55:14.9-72:01:27.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7024,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7024,18.86,0.06,0.0591,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3585, RA-DEC 01:04:07.1-72:19:50.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7025,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7025,18.86,0.06,0.0591,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3847, RA-DEC 01:06:28.4-72:07:40.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7026,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7026,18.86,0.06,0.0591,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2364, RA-DEC 00:55:14.9-72:01:33.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7027,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7027,18.86,0.06,0.0591,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4749, RA-DEC 00:57:07.8-71:15:25.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7028,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7028,18.86,0.06,0.0591,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4783, RA-DEC 01:04:10.1-70:57:22.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7029,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,NULL,7029,18.86,0.07,0.0591,2163,NULL,NULL,'HV 02052, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7030,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7030,18.86,0.06,0.0591,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3422, RA-DEC 01:02:44.9-73:42:05.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7031,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7031,18.86,0.06,0.0591,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3663, RA-DEC 01:04:44.0-72:20:47.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7032,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7032,18.86,0.06,0.0591,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4782, RA-DEC 01:04:00.9-74:45:51.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7033,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7033,18.86,0.06,0.0591,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3292, RA-DEC 01:01:43.9-72:29:17.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7034,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7034,18.86,0.06,0.0591,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4441, RA-DEC 01:14:22.5-73:55:57.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7035,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7035,18.86,0.06,0.0591,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4867, RA-DEC 01:24:24.2-71:54:11.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7036,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7036,18.86,0.06,0.0591,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2475, RA-DEC 00:55:57.3-72:45:08.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7037,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7037,18.86,0.06,0.0592,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2190, RA-DEC 00:54:11.4-71:50:21.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7038,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7038,18.86,0.06,0.0592,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2470, RA-DEC 00:55:56.1-71:59:02.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7039,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7039,18.86,0.06,0.0592,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1589, RA-DEC 00:51:00.2-72:18:45.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7040,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7040,18.86,0.06,0.0592,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2355, RA-DEC 00:55:11.6-72:11:13.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7041,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7041,18.86,0.06,0.0592,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3481, RA-DEC 01:03:16.8-72:24:25.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7042,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7042,18.86,0.06,0.0592,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2692, RA-DEC 00:57:29.4-73:05:59.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7043,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7043,18.86,0.06,0.0592,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4714, RA-DEC 00:46:05.7-72:22:48.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7044,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7044,18.86,0.06,0.0592,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2799, RA-DEC 00:58:13.4-71:26:54.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7045,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7045,18.86,0.06,0.0592,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3211, RA-DEC 01:01:02.7-72:14:35.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7046,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7046,18.86,0.06,0.0592,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3810, RA-DEC 01:06:08.2-73:44:32.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7047,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7047,18.86,0.06,0.0592,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4567, RA-DEC 01:18:27.6-72:48:16.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7048,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7048,18.86,0.06,0.0592,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2863, RA-DEC 00:58:38.8-72:13:27.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7049,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7049,18.86,0.06,0.0592,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3517, RA-DEC 01:03:34.1-73:19:17.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7050,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7050,18.86,0.06,0.0592,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4896, RA-DEC 01:32:18.0-73:28:11.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7051,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7051,18.86,0.06,0.0592,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2708, RA-DEC 00:57:34.2-73:58:48.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7052,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7052,18.86,0.06,0.0592,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2846, RA-DEC 00:58:34.3-72:09:03.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7053,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7053,18.86,0.06,0.0592,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3922, RA-DEC 01:07:15.4-73:37:25.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7054,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,NULL,7054,18.86,0.07,0.0592,2163,NULL,NULL,'HV 00865, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7055,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7055,18.86,0.06,0.0592,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3290, RA-DEC 01:01:43.3-72:34:23.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7056,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7056,18.86,0.06,0.0592,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4434, RA-DEC 01:14:16.1-71:27:01.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7057,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7057,18.86,0.06,0.0592,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4838, RA-DEC 01:14:37.5-74:18:54.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7058,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7058,18.86,0.06,0.0593,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3682, RA-DEC 01:04:55.1-74:12:29.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7059,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7059,18.86,0.06,0.0593,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2205, RA-DEC 00:54:17.7-71:17:31.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7060,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7060,18.86,0.06,0.0593,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3236, RA-DEC 01:01:16.4-73:37:47.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7061,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7061,18.86,0.06,0.0593,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2953, RA-DEC 00:59:12.2-72:27:59.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7062,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7062,18.86,0.06,0.0593,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2524, RA-DEC 00:56:16.4-72:21:16.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7063,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7063,18.86,0.06,0.0593,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3276, RA-DEC 01:01:34.1-71:48:54.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7064,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7064,18.87,0.06,0.0593,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3233, RA-DEC 01:01:15.1-71:51:33.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7065,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,'R',7065,18.87,0.06,0.0593,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3671, RA-DEC 01:04:49.1-74:04:23.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7066,'Cepheids','2016-12-15 15:13:36','2016-12-16 11:18:38','1',NULL,NULL,7066,18.87,0.07,0.0593,2163,NULL,NULL,'HV 02227, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7067,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7067,18.87,0.07,0.0593,2163,NULL,NULL,'HV 02231, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7068,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7068,18.87,0.06,0.0593,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3815, RA-DEC 01:06:08.9-72:30:52.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7069,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7069,18.87,0.06,0.0593,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3883, RA-DEC 01:06:52.3-73:24:40.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7070,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7070,18.87,0.06,0.0593,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4097, RA-DEC 01:09:09.2-71:19:34.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7071,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7071,18.87,0.06,0.0593,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1835, RA-DEC 00:52:09.3-72:50:25.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7072,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7072,18.87,0.06,0.0593,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2189, RA-DEC 00:54:11.0-71:53:29.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7073,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7073,18.87,0.06,0.0593,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3990, RA-DEC 01:07:56.1-72:22:10.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7074,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7074,18.87,0.06,0.0593,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4544, RA-DEC 01:17:17.3-72:56:45.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7075,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7075,18.87,0.06,0.0594,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4527, RA-DEC 01:16:48.8-72:30:08.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7076,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7076,18.87,0.06,0.0594,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4225, RA-DEC 01:10:44.5-71:57:14.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7077,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7077,18.87,0.06,0.0594,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0413, RA-DEC 00:41:40.1-74:07:23.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7078,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7078,18.87,0.06,0.0594,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1957, RA-DEC 00:52:50.8-73:59:17.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7079,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7079,18.87,0.06,0.0594,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3464, RA-DEC 01:03:10.9-72:59:35.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7080,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7080,18.87,0.06,0.0594,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4911, RA-DEC 01:36:28.6-73:08:31.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7081,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7081,18.87,0.06,0.0594,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1933, RA-DEC 00:52:40.7-73:07:21.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7082,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7082,18.87,0.07,0.0594,2163,NULL,NULL,'HV 02017, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7083,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7083,18.87,0.06,0.0594,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3121, RA-DEC 01:00:25.7-72:13:30.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (7084,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7084,18.87,0.06,0.0594,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4604, RA-DEC 01:21:29.0-72:59:06.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7085,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7085,18.87,0.06,0.0594,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3826, RA-DEC 01:06:17.2-73:10:00.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7086,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7086,18.87,0.08,0.0594,2163,NULL,NULL,'91, H, PL','SMC',NULL,'1987ApJ...321..162W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7087,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7087,18.87,0.06,0.0594,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4245, RA-DEC 01:11:02.6-73:06:28.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7088,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7088,18.87,0.06,0.0594,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3737, RA-DEC 01:05:26.1-73:52:07.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7089,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7089,18.87,0.06,0.0595,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4066, RA-DEC 01:08:50.3-71:22:33.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7090,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7090,18.87,0.06,0.0595,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4410, RA-DEC 01:13:42.4-71:41:39.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7091,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7091,18.87,0.06,0.0595,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2378, RA-DEC 00:55:21.4-73:32:27.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7092,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7092,18.87,0.06,0.0595,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3373, RA-DEC 01:02:22.0-73:26:07.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7093,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7093,18.87,0.06,0.0595,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3579, RA-DEC 01:04:05.6-73:22:10.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7094,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7094,18.87,0.06,0.0595,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4310, RA-DEC 01:11:52.1-73:46:34.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7095,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7095,18.87,0.06,0.0595,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4412, RA-DEC 01:13:42.6-74:11:45.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7096,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7096,18.87,0.07,0.0595,2163,NULL,NULL,'HV 01451, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7097,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7097,18.87,0.06,0.0595,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2445, RA-DEC 00:55:48.0-71:33:33.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7098,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7098,18.87,0.06,0.0595,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3863, RA-DEC 01:06:39.7-73:02:18.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7099,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7099,18.87,0.06,0.0595,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3309, RA-DEC 01:01:48.6-73:17:53.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7100,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7100,18.87,0.06,0.0595,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3600, RA-DEC 01:04:11.7-72:16:00.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7101,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7101,18.87,0.06,0.0595,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3685, RA-DEC 01:04:57.3-73:24:49.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7102,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7102,18.87,0.06,0.0595,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1936, RA-DEC 00:52:41.9-73:11:01.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7103,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7103,18.87,0.06,0.0595,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2656, RA-DEC 00:57:14.0-73:28:04.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7104,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7104,18.87,0.06,0.0595,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3230, RA-DEC 01:01:11.6-72:09:40.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7105,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7105,18.87,0.06,0.0596,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3328, RA-DEC 01:01:57.9-73:29:56.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7106,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7106,18.87,0.06,0.0596,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4897, RA-DEC 01:32:59.7-66:29:52.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7107,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7107,18.87,0.06,0.0596,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3921, RA-DEC 01:07:14.4-71:55:10.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7108,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7108,18.88,0.06,0.0596,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2517, RA-DEC 00:56:12.7-71:53:33.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7109,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7109,18.88,0.06,0.0596,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3702, RA-DEC 01:05:07.6-71:44:33.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7110,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7110,18.88,0.06,0.0596,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4131, RA-DEC 01:09:30.4-71:48:23.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7111,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7111,18.88,0.06,0.0596,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4220, RA-DEC 01:10:39.0-72:48:09.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7112,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7112,18.88,0.06,0.0596,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4894, RA-DEC 01:30:49.8-73:57:23.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7113,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7113,18.88,0.06,0.0596,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3045, RA-DEC 00:59:49.5-72:51:51.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7114,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7114,18.88,0.06,0.0596,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3612, RA-DEC 01:04:15.6-71:19:04.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7115,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7115,18.88,0.06,0.0596,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1864, RA-DEC 00:52:18.9-74:27:57.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7116,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7116,18.88,0.06,0.0596,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3830, RA-DEC 01:06:18.4-71:41:43.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7117,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7117,18.88,0.06,0.0596,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0235, RA-DEC 00:36:18.1-73:46:24.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7118,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7118,18.88,0.06,0.0596,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3723, RA-DEC 01:05:20.2-72:02:12.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7119,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7119,18.88,0.07,0.0596,2163,NULL,NULL,'HV 02225, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7120,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7120,18.88,0.07,0.0596,2163,NULL,NULL,'HV 02195, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7121,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7121,18.88,0.06,0.0596,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1399, RA-DEC 00:49:51.1-73:02:02.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7122,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7122,18.88,0.06,0.0596,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3802, RA-DEC 01:06:03.0-71:51:52.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7123,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7123,18.88,0.06,0.0596,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3901, RA-DEC 01:07:03.2-72:29:04.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7124,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7124,18.88,0.06,0.0596,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3475, RA-DEC 01:03:14.5-71:56:56.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7125,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7125,18.88,0.06,0.0596,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0152, RA-DEC 00:32:54.9-73:49:19.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7126,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7126,18.88,0.06,0.0597,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3898, RA-DEC 01:07:01.5-72:16:42.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7127,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7127,18.88,0.06,0.0597,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3972, RA-DEC 01:07:40.4-73:16:29.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7128,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7128,18.88,0.06,0.0597,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4494, RA-DEC 01:15:45.0-73:20:58.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7129,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7129,18.88,0.06,0.0597,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4741, RA-DEC 00:55:24.2-71:07:40.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7130,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7130,18.88,0.06,0.0597,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1492, RA-DEC 00:50:25.7-72:27:42.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7131,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7131,18.88,0.06,0.0597,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1943, RA-DEC 00:52:44.5-72:46:39.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7132,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7132,18.88,0.06,0.0597,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2360, RA-DEC 00:55:13.7-72:51:04.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7133,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7133,18.88,0.06,0.0597,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4112, RA-DEC 01:09:18.2-72:20:58.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7134,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7134,18.88,0.06,0.0597,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4531, RA-DEC 01:16:52.6-72:50:00.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7135,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7135,18.88,0.06,0.0597,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2318, RA-DEC 00:54:59.2-73:08:36.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7136,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7136,18.88,0.06,0.0597,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2553, RA-DEC 00:56:30.4-71:58:39.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7137,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7137,18.88,0.06,0.0597,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2756, RA-DEC 00:57:55.9-73:20:06.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7138,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7138,18.88,0.06,0.0597,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3831, RA-DEC 01:06:18.8-74:06:46.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7139,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7139,18.88,0.07,0.0597,2163,NULL,NULL,'HV 02063, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7140,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7140,18.88,0.07,0.0597,2163,NULL,NULL,'HV 02205, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7141,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7141,18.88,0.06,0.0597,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3768, RA-DEC 01:05:45.9-73:23:59.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7142,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7142,18.88,0.06,0.0597,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4011, RA-DEC 01:08:08.5-71:38:37.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7143,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7143,18.88,0.06,0.0597,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4318, RA-DEC 01:11:59.0-72:13:12.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7144,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7144,18.88,0.06,0.0597,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3947, RA-DEC 01:07:27.4-73:06:46.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7145,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7145,18.88,0.06,0.0597,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3712, RA-DEC 01:05:13.9-72:02:31.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7146,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7146,18.88,0.06,0.0597,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3739, RA-DEC 01:05:26.6-73:08:13.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7147,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7147,18.88,0.06,0.0597,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4874, RA-DEC 01:26:04.5-74:56:25.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7148,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7148,18.88,0.06,0.0597,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2193, RA-DEC 00:54:13.1-73:40:10.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7149,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7149,18.88,0.06,0.0597,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2376, RA-DEC 00:55:21.2-73:15:29.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7150,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7150,18.88,0.06,0.0598,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0979, RA-DEC 00:47:20.8-73:35:08.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7151,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7151,18.88,0.06,0.0598,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1448, RA-DEC 00:50:08.3-73:39:19.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7152,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7152,18.88,0.06,0.0598,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4110, RA-DEC 01:09:17.9-71:53:04.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7153,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7153,18.88,0.06,0.0598,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4426, RA-DEC 01:14:00.1-73:42:01.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7154,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7154,18.88,0.06,0.0598,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4605, RA-DEC 01:21:32.2-74:12:03.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7155,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7155,18.88,0.06,0.0598,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3754, RA-DEC 01:05:39.0-72:26:26.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7156,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7156,18.88,0.06,0.0598,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3103, RA-DEC 01:00:17.1-73:26:37.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7157,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7157,18.88,0.06,0.0598,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4382, RA-DEC 01:13:16.3-71:32:18.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7158,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7158,18.88,0.06,0.0598,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2454, RA-DEC 00:55:51.9-72:22:34.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7159,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7159,18.88,0.06,0.0598,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3771, RA-DEC 01:05:46.5-73:16:27.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7160,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7160,18.88,0.06,0.0598,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3838, RA-DEC 01:06:23.2-73:41:15.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7161,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7161,18.88,0.06,0.0598,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0100, RA-DEC 00:28:52.3-73:39:55.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7162,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7162,18.88,0.06,0.0598,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2868, RA-DEC 00:58:41.5-72:10:57.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7163,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7163,18.88,0.06,0.0598,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4335, RA-DEC 01:12:18.9-71:34:50.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7164,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7164,18.88,0.06,0.0598,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0838, RA-DEC 00:46:12.8-72:46:56.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7165,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7165,18.88,0.06,0.0598,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3885, RA-DEC 01:06:53.3-71:37:05.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7166,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7166,18.88,0.06,0.0598,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4183, RA-DEC 01:10:06.0-72:54:28.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7167,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7167,18.88,0.06,0.0598,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3691, RA-DEC 01:05:00.8-73:04:20.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7168,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7168,18.88,0.06,0.0598,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4196, RA-DEC 01:10:13.8-72:43:28.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7169,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7169,18.89,0.06,0.0599,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2721, RA-DEC 00:57:40.3-72:55:16.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7170,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7170,18.89,0.06,0.0599,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4178, RA-DEC 01:10:02.2-71:59:42.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7171,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7171,18.89,0.06,0.0599,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1158, RA-DEC 00:48:24.8-72:52:53.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7172,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7172,18.89,0.06,0.0599,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4328, RA-DEC 01:12:12.9-71:25:03.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7173,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7173,18.89,0.06,0.0599,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4006, RA-DEC 01:08:06.1-71:49:41.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7174,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7174,18.89,0.06,0.0599,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3138, RA-DEC 01:00:32.3-73:22:45.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7175,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7175,18.89,0.06,0.0599,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3490, RA-DEC 01:03:19.7-72:00:15.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7176,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7176,18.89,0.06,0.0599,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3753, RA-DEC 01:05:37.8-71:50:36.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7177,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7177,18.89,0.06,0.0599,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4133, RA-DEC 01:09:31.8-73:55:52.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7178,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7178,18.89,0.06,0.0599,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4450, RA-DEC 01:14:37.7-72:48:20.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7179,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7179,18.89,0.06,0.0599,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3145, RA-DEC 01:00:36.5-72:30:36.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7180,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7180,18.89,0.06,0.0599,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3586, RA-DEC 01:04:07.1-72:29:28.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7181,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7181,18.89,0.06,0.0599,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3643, RA-DEC 01:04:30.1-72:13:46.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7182,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7182,18.89,0.06,0.0599,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1410, RA-DEC 00:49:55.3-73:09:16.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7183,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7183,18.89,0.06,0.0599,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4514, RA-DEC 01:16:21.7-71:26:59.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7184,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7184,18.89,0.06,0.0599,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3350, RA-DEC 01:02:09.2-72:07:39.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7185,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7185,18.89,0.06,0.0599,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3690, RA-DEC 01:05:00.4-71:48:29.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7186,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7186,18.89,0.06,0.0599,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3720, RA-DEC 01:05:17.8-72:02:44.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7187,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7187,18.89,0.06,0.0599,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4036, RA-DEC 01:08:25.0-73:33:04.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7188,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7188,18.89,0.06,0.0599,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4730, RA-DEC 00:50:55.9-71:03:06.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7189,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7189,18.89,0.06,0.0599,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1549, RA-DEC 00:50:49.4-73:16:41.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7190,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7190,18.89,0.06,0.0599,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1984, RA-DEC 00:52:59.9-72:25:31.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7191,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7191,18.89,0.06,0.0599,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2404, RA-DEC 00:55:33.1-72:50:53.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7192,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7192,18.89,0.06,0.0599,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3832, RA-DEC 01:06:19.3-74:11:50.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7193,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7193,18.89,0.06,0.0599,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4232, RA-DEC 01:10:50.2-73:01:04.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7194,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7194,18.89,0.06,0.0599,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4914, RA-DEC 01:38:29.2-71:07:45.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7195,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7195,18.89,0.06,0.06,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3928, RA-DEC 01:07:18.2-73:22:32.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7196,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7196,18.89,0.06,0.06,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2504, RA-DEC 00:56:09.0-72:55:18.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7197,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7197,18.89,0.06,0.06,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3086, RA-DEC 01:00:10.7-72:07:32.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7198,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7198,18.89,0.06,0.06,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3241, RA-DEC 01:01:17.3-72:14:58.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7199,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7199,18.89,0.06,0.06,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3872, RA-DEC 01:06:46.5-72:17:17.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7200,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7200,18.89,0.06,0.06,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3892, RA-DEC 01:06:59.4-72:13:58.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7201,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7201,18.89,0.06,0.06,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4061, RA-DEC 01:08:44.4-72:33:08.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7202,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7202,18.89,0.06,0.06,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3924, RA-DEC 01:07:15.7-71:42:51.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7203,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7203,18.89,0.06,0.06,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4370, RA-DEC 01:13:06.2-73:01:52.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7204,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7204,18.89,0.06,0.06,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0986, RA-DEC 00:47:24.6-73:20:14.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7205,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7205,18.89,0.06,0.06,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4181, RA-DEC 01:10:05.1-72:02:03.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7206,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7206,18.89,0.06,0.06,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4362, RA-DEC 01:12:53.5-73:33:03.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7207,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7207,18.89,0.06,0.06,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0755, RA-DEC 00:45:26.7-72:27:11.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7208,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7208,18.89,0.06,0.06,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2958, RA-DEC 00:59:13.0-72:07:26.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7209,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7209,18.89,0.05,0.06,2163,NULL,18.46,'NIR, Ks or K, Z corr.','SMC',NULL,'2011MNRAS.413..223M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7210,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7210,18.89,0.05,0.06,2163,NULL,18.46,'I or W(VI), Z corr.','SMC',NULL,'2011MNRAS.413..223M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7211,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7211,18.9,0.07,0.06,2163,NULL,NULL,'HV 00822, 1, V-R (BW)','SMC',NULL,'1999ASPC..167..320S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7212,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7212,18.9,0.07,0.06,2163,NULL,NULL,'V-R','SMC',NULL,'2000ASPC..203..145S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7213,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7213,18.88,0.01,0.06,2163,NULL,NULL,'FM','SMC',NULL,'2003AJ....125.1261D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7214,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7214,18.88,0.01,0.06,2163,NULL,NULL,'FO','SMC',NULL,'2003AJ....125.1261D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7215,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7215,18.88,0.12,0.06,2163,NULL,NULL,'5, BVRIJK','SMC',NULL,'2004A&A...415..531S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7216,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7216,18.9,0.06,0.06,2163,74.4,NULL,NULL,'SMC',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7217,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7217,18.89,0.06,0.06,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4321, RA-DEC 01:12:05.1-72:53:10.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7218,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7218,18.89,0.06,0.06,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3251, RA-DEC 01:01:21.1-73:27:35.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7219,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7219,18.89,0.06,0.06,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3732, RA-DEC 01:05:23.6-73:51:07.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7220,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7220,18.89,0.06,0.06,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2460, RA-DEC 00:55:52.9-72:30:10.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7221,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7221,18.89,0.06,0.0601,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1536, RA-DEC 00:50:44.0-72:44:42.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7222,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7222,18.89,0.06,0.0601,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2194, RA-DEC 00:54:14.5-73:04:20.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7223,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7223,18.89,0.06,0.0601,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3999, RA-DEC 01:07:58.1-73:50:43.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7224,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7224,18.89,0.06,0.0601,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1772, RA-DEC 00:51:55.6-72:57:53.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7225,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7225,18.89,0.06,0.0601,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2748, RA-DEC 00:57:51.2-72:24:23.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7226,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7226,18.89,0.06,0.0601,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2730, RA-DEC 00:57:44.0-72:29:11.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7227,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7227,18.89,0.06,0.0601,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2964, RA-DEC 00:59:15.4-73:23:50.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7228,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7228,18.89,0.06,0.0601,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3301, RA-DEC 01:01:46.8-73:23:40.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7229,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7229,18.89,0.06,0.0601,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4947, RA-DEC 01:52:26.6-75:14:37.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7230,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7230,18.89,0.06,0.0601,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3794, RA-DEC 01:05:57.6-73:35:05.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7231,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7231,18.89,0.06,0.0601,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4699, RA-DEC 00:41:19.8-71:38:15.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7232,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7232,18.89,0.06,0.0601,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3601, RA-DEC 01:04:11.8-73:45:30.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7233,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7233,18.89,0.06,0.0601,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3858, RA-DEC 01:06:35.1-73:23:06.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7234,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7234,18.9,0.06,0.0601,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3299, RA-DEC 01:01:45.6-73:43:08.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7235,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7235,18.9,0.06,0.0601,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3658, RA-DEC 01:04:41.0-73:25:06.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7236,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7236,18.9,0.06,0.0601,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4215, RA-DEC 01:10:33.5-71:59:00.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7237,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7237,18.9,0.06,0.0601,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4118, RA-DEC 01:09:20.6-73:04:20.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7238,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7238,18.9,0.06,0.0602,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1491, RA-DEC 00:50:25.6-72:49:12.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7239,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7239,18.9,0.06,0.0602,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4194, RA-DEC 01:10:13.3-71:20:03.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7240,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7240,18.9,0.06,0.0602,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4212, RA-DEC 01:10:32.5-71:26:36.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7241,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7241,18.9,0.06,0.0602,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4834, RA-DEC 01:13:45.6-71:15:07.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7242,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7242,18.9,0.06,0.0602,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3689, RA-DEC 01:04:59.2-72:24:58.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7243,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7243,18.9,0.06,0.0602,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3095, RA-DEC 01:00:14.6-73:17:44.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7244,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7244,18.9,0.06,0.0602,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4388, RA-DEC 01:13:22.7-73:02:25.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7245,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7245,18.9,0.06,0.0602,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0892, RA-DEC 00:46:36.6-72:25:30.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7246,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7246,18.9,0.06,0.0602,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3703, RA-DEC 01:05:08.3-72:21:37.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7247,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7247,18.9,0.06,0.0602,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4510, RA-DEC 01:16:13.7-71:41:10.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7248,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7248,18.9,0.06,0.0602,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4513, RA-DEC 01:16:18.8-72:35:50.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7249,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7249,18.9,0.06,0.0602,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2542, RA-DEC 00:56:27.1-72:56:53.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7250,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7250,18.9,0.06,0.0602,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2828, RA-DEC 00:58:24.7-73:28:24.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7251,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7251,18.9,0.06,0.0602,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4515, RA-DEC 01:16:23.1-72:34:30.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7252,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7252,18.9,0.06,0.0602,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1937, RA-DEC 00:52:42.2-73:00:19.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7253,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7253,18.9,0.06,0.0602,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3085, RA-DEC 01:00:09.6-72:23:42.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7254,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7254,18.9,0.06,0.0602,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4179, RA-DEC 01:10:02.8-72:32:07.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7255,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7255,18.9,0.07,0.0602,2163,NULL,NULL,'HV 00817, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7256,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7256,18.9,0.06,0.0602,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3295, RA-DEC 01:01:45.3-73:40:44.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7257,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7257,18.9,0.06,0.0602,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3320, RA-DEC 01:01:55.5-73:26:06.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7258,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7258,18.9,0.06,0.0602,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4070, RA-DEC 01:08:52.2-71:27:49.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7259,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7259,18.9,0.06,0.0602,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1960, RA-DEC 00:52:52.5-73:00:46.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7260,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7260,18.9,0.06,0.0602,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4193, RA-DEC 01:10:12.6-72:29:23.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7261,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7261,18.9,0.06,0.0602,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2122, RA-DEC 00:53:49.8-72:37:05.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7262,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7262,18.9,0.06,0.0602,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3341, RA-DEC 01:02:06.0-71:57:19.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7263,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7263,18.9,0.06,0.0602,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4312, RA-DEC 01:11:55.4-71:25:11.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7264,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7264,18.9,0.06,0.0602,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4934, RA-DEC 01:45:47.2-73:32:04.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7265,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7265,18.9,0.06,0.0602,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0165, RA-DEC 00:33:28.7-73:10:32.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7266,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7266,18.9,0.06,0.0602,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3446, RA-DEC 01:02:57.8-73:19:51.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7267,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7267,18.9,0.06,0.0602,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4192, RA-DEC 01:10:11.4-73:10:36.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7268,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7268,18.9,0.06,0.0602,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4315, RA-DEC 01:11:57.5-73:21:08.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7269,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7269,18.9,0.06,0.0603,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4709, RA-DEC 00:44:19.2-73:58:29.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7270,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7270,18.9,0.06,0.0603,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4791, RA-DEC 01:05:44.0-74:59:59.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7271,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7271,18.9,0.06,0.0603,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3379, RA-DEC 01:02:26.2-73:43:15.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7272,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7272,18.9,0.06,0.0603,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3792, RA-DEC 01:05:56.3-71:21:20.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7273,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7273,18.9,0.06,0.0603,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4836, RA-DEC 01:14:10.9-70:59:20.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7274,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7274,18.9,0.06,0.0603,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4920, RA-DEC 01:40:37.9-73:44:19.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7275,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7275,18.9,0.06,0.0603,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2421, RA-DEC 00:55:38.1-72:43:15.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7276,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7276,18.9,0.06,0.0603,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4825, RA-DEC 01:11:17.4-71:09:29.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7277,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7277,18.9,0.06,0.0603,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4560, RA-DEC 01:18:08.9-72:31:25.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7278,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7278,18.9,0.06,0.0603,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4820, RA-DEC 01:10:20.5-71:08:46.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7279,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7279,18.9,0.06,0.0603,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4839, RA-DEC 01:14:44.5-75:07:38.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7280,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7280,18.9,0.06,0.0603,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4136, RA-DEC 01:09:35.2-73:20:29.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7281,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7281,18.9,0.06,0.0603,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4273, RA-DEC 01:11:27.6-71:24:37.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7282,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7282,18.9,0.06,0.0603,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4777, RA-DEC 01:03:05.3-74:44:46.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7283,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7283,18.9,NULL,0.0603,2163,NULL,NULL,NULL,'SMC',NULL,'2011ApJ...741L..36M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7284,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7284,18.9,0.06,0.0603,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2423, RA-DEC 00:55:39.2-71:51:42.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7285,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7285,18.9,0.06,0.0603,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3513, RA-DEC 01:03:31.2-73:35:31.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7286,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7286,18.9,0.06,0.0603,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2531, RA-DEC 00:56:18.9-72:40:57.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7287,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7287,18.9,0.06,0.0603,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2758, RA-DEC 00:57:56.7-72:27:48.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7288,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7288,18.9,0.06,0.0603,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3666, RA-DEC 01:04:46.3-72:15:50.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7289,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7289,18.9,0.06,0.0603,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0704, RA-DEC 00:45:03.5-73:15:17.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7290,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7290,18.9,0.06,0.0603,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3414, RA-DEC 01:02:42.2-72:23:59.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7291,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7291,18.9,0.06,0.0604,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2039, RA-DEC 00:53:21.1-71:54:29.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7292,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7292,18.9,0.06,0.0604,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2437, RA-DEC 00:55:45.7-72:50:14.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7293,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7293,18.9,0.06,0.0604,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4168, RA-DEC 01:09:57.3-71:58:54.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7294,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7294,18.9,0.06,0.0604,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3049, RA-DEC 00:59:51.1-72:11:53.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7295,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7295,18.9,0.06,0.0604,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4481, RA-DEC 01:15:25.3-72:40:38.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7296,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7296,18.9,0.06,0.0604,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0474, RA-DEC 00:42:41.5-72:38:55.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7297,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7297,18.9,0.06,0.0604,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2287, RA-DEC 00:54:50.3-73:24:24.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7298,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7298,18.91,0.06,0.0604,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1480, RA-DEC 00:50:21.4-73:05:54.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7299,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7299,18.91,0.06,0.0604,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2606, RA-DEC 00:56:52.4-72:56:09.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7300,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7300,18.91,0.06,0.0604,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2990, RA-DEC 00:59:26.9-73:53:13.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7301,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7301,18.91,0.06,0.0604,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4188, RA-DEC 01:10:08.3-73:47:44.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7302,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7302,18.91,0.06,0.0604,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1273, RA-DEC 00:49:11.1-73:09:35.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7303,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7303,18.91,0.06,0.0604,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3538, RA-DEC 01:03:45.2-71:25:08.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7304,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7304,18.91,0.06,0.0604,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1911, RA-DEC 00:52:33.9-72:53:38.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7305,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7305,18.91,0.06,0.0604,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2000, RA-DEC 00:53:07.8-72:47:18.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7306,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7306,18.91,0.06,0.0604,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3094, RA-DEC 01:00:14.1-72:45:19.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7307,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7307,18.91,0.06,0.0604,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3432, RA-DEC 01:02:50.3-72:13:27.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7308,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7308,18.91,0.06,0.0604,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3594, RA-DEC 01:04:09.8-73:05:55.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7309,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7309,18.91,0.06,0.0604,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4758, RA-DEC 00:58:52.1-74:20:15.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7310,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7310,18.91,0.06,0.0604,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2269, RA-DEC 00:54:41.6-73:07:43.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7311,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7311,18.91,0.06,0.0604,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3545, RA-DEC 01:03:50.9-72:55:11.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7312,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7312,18.91,0.06,0.0604,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4077, RA-DEC 01:08:57.3-71:15:54.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7313,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7313,18.91,0.06,0.0604,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3496, RA-DEC 01:03:24.0-73:19:27.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7314,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7314,18.91,0.06,0.0604,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3761, RA-DEC 01:05:41.6-72:07:38.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7315,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7315,18.91,0.06,0.0604,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4939, RA-DEC 01:48:23.2-72:24:42.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7316,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7316,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1538, RA-DEC 00:50:45.1-72:38:59.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7317,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7317,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2255, RA-DEC 00:54:37.4-72:56:58.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7318,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7318,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3389, RA-DEC 01:02:28.9-71:19:52.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7319,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7319,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3740, RA-DEC 01:05:27.6-72:22:31.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7320,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7320,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4285, RA-DEC 01:11:37.5-71:46:08.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7321,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7321,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2119, RA-DEC 00:53:49.1-73:37:43.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7322,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7322,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3223, RA-DEC 01:01:08.6-73:01:38.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7323,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7323,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3927, RA-DEC 01:07:17.6-73:13:26.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7324,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7324,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1019, RA-DEC 00:47:39.6-73:29:13.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7325,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7325,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2583, RA-DEC 00:56:40.0-73:46:17.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7326,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7326,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3413, RA-DEC 01:02:41.9-73:16:23.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7327,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7327,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3948, RA-DEC 01:07:27.7-73:22:23.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7328,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7328,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4132, RA-DEC 01:09:30.6-72:12:30.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7329,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7329,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1967, RA-DEC 00:52:53.9-72:31:23.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7330,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7330,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3680, RA-DEC 01:04:54.2-72:55:41.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7331,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7331,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4064, RA-DEC 01:08:47.1-74:09:25.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7332,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7332,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4348, RA-DEC 01:12:38.7-71:19:18.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7333,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7333,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1977, RA-DEC 00:52:56.8-71:55:03.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7334,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7334,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2952, RA-DEC 00:59:12.0-73:29:54.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7335,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7335,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3482, RA-DEC 01:03:17.3-72:47:50.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7336,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7336,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3503, RA-DEC 01:03:26.6-73:36:48.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7337,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7337,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3891, RA-DEC 01:06:59.1-71:41:06.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7338,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7338,18.91,0.2,0.0605,2163,NULL,NULL,'JK(W)','SMC',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7339,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7339,18.91,0.06,0.0605,2163,NULL,18.43,NULL,'SMC',NULL,'2011rrls.conf..170F',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7340,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7340,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4324, RA-DEC 01:12:07.1-71:21:53.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7341,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7341,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1853, RA-DEC 00:52:16.4-73:29:13.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7342,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7342,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2588, RA-DEC 00:56:43.1-72:14:11.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7343,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7343,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1222, RA-DEC 00:48:50.4-73:14:43.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7344,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7344,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3006, RA-DEC 00:59:31.5-73:35:56.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7345,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7345,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3904, RA-DEC 01:07:03.5-71:39:15.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7346,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7346,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4384, RA-DEC 01:13:17.9-72:50:19.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7347,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7347,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4493, RA-DEC 01:15:44.9-71:22:55.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7348,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7348,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3182, RA-DEC 01:00:49.4-72:06:53.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7349,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7349,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3937, RA-DEC 01:07:22.5-74:01:22.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7350,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7350,18.91,0.06,0.0605,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4447, RA-DEC 01:14:34.1-71:44:37.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7351,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7351,18.91,0.06,0.0606,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3102, RA-DEC 01:00:17.0-73:13:50.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7352,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7352,18.91,0.06,0.0606,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3502, RA-DEC 01:03:26.5-72:03:41.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7353,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7353,18.91,0.06,0.0606,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4040, RA-DEC 01:08:28.1-71:37:44.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7354,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7354,18.91,0.06,0.0606,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4524, RA-DEC 01:16:39.4-73:47:46.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7355,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7355,18.91,0.06,0.0606,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3551, RA-DEC 01:03:52.7-73:02:37.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7356,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7356,18.91,0.06,0.0606,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4594, RA-DEC 01:20:25.6-73:21:30.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7357,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7357,18.91,0.06,0.0606,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4812, RA-DEC 01:08:20.2-71:13:55.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7358,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7358,18.91,0.06,0.0606,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4420, RA-DEC 01:13:50.9-71:32:02.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7359,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7359,18.91,0.06,0.0606,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3361, RA-DEC 01:02:16.1-73:53:54.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7360,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7360,18.91,0.06,0.0606,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4840, RA-DEC 01:14:50.1-74:51:06.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7361,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7361,18.91,0.06,0.0606,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4909, RA-DEC 01:36:24.9-70:25:04.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7362,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7362,18.91,0.07,0.0606,2163,NULL,NULL,'HV 00840, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7363,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7363,18.91,0.06,0.0606,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2890, RA-DEC 00:58:49.1-72:41:04.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7364,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7364,18.91,0.06,0.0606,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3206, RA-DEC 01:00:59.6-71:48:11.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7365,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7365,18.91,0.06,0.0606,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3950, RA-DEC 01:07:28.4-73:10:12.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7366,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7366,18.91,0.06,0.0606,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1326, RA-DEC 00:49:24.9-72:53:40.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7367,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7367,18.91,0.06,0.0607,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0115, RA-DEC 00:29:40.6-73:29:44.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7368,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7368,18.91,0.06,0.0607,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2134, RA-DEC 00:53:53.9-72:27:08.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7369,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7369,18.91,0.06,0.0607,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4585, RA-DEC 01:19:41.5-72:00:00.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7370,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7370,18.92,0.06,0.0607,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0412, RA-DEC 00:41:39.0-73:00:55.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7371,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7371,18.92,0.06,0.0607,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3030, RA-DEC 00:59:42.6-72:14:50.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7372,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7372,18.92,0.06,0.0607,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4274, RA-DEC 01:11:27.7-71:57:24.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7373,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7373,18.92,0.06,0.0607,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2944, RA-DEC 00:59:09.7-72:00:35.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7374,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7374,18.92,0.06,0.0607,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3940, RA-DEC 01:07:24.2-72:29:38.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7375,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7375,18.92,0.06,0.0607,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3238, RA-DEC 01:01:16.7-71:48:41.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7376,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7376,18.92,0.06,0.0607,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3347, RA-DEC 01:02:08.0-72:39:49.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7377,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7377,18.92,0.06,0.0607,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3352, RA-DEC 01:02:10.8-72:47:02.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7378,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7378,18.92,0.06,0.0607,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2736, RA-DEC 00:57:44.8-72:16:24.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7379,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7379,18.92,0.06,0.0607,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0753, RA-DEC 00:45:25.1-73:08:52.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7380,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7380,18.92,0.06,0.0608,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3444, RA-DEC 01:02:57.3-73:46:01.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7381,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7381,18.92,0.06,0.0608,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3507, RA-DEC 01:03:28.7-73:23:52.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7382,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7382,18.92,0.06,0.0608,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0803, RA-DEC 00:45:59.0-73:10:18.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7383,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7383,18.92,0.06,0.0608,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0817, RA-DEC 00:46:04.2-73:27:13.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7384,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7384,18.92,0.06,0.0608,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0842, RA-DEC 00:46:15.6-73:14:25.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7385,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7385,18.92,0.06,0.0608,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2235, RA-DEC 00:54:31.7-72:45:27.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7386,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7386,18.92,0.06,0.0608,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2574, RA-DEC 00:56:37.6-72:17:09.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7387,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7387,18.92,0.06,0.0608,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3253, RA-DEC 01:01:22.8-71:18:31.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7388,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7388,18.92,0.06,0.0608,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2547, RA-DEC 00:56:28.4-71:59:26.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7389,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7389,18.92,0.06,0.0608,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3596, RA-DEC 01:04:10.0-71:40:22.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7390,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7390,18.92,0.06,0.0608,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2767, RA-DEC 00:58:01.3-72:17:05.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7391,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7391,18.92,0.06,0.0608,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4393, RA-DEC 01:13:27.7-72:28:22.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7392,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7392,18.92,0.06,0.0608,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4403, RA-DEC 01:13:36.7-72:28:00.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7393,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7393,18.92,0.06,0.0608,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4744, RA-DEC 00:56:00.1-71:04:12.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7394,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7394,18.92,0.02,0.0608,2163,NULL,NULL,'92, 4.5 micron','SMC',NULL,'2016ApJ...816...49S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7395,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7395,18.92,NULL,0.0608,2163,NULL,NULL,'NGC 0330, 18, VI','SMC',NULL,'1994AJ....108..932S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7396,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7396,18.92,0.07,0.0608,2163,NULL,NULL,'HV 01787, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7397,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7397,18.92,0.07,0.0608,2163,NULL,NULL,'HV 01884, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7398,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7398,18.92,0.14,0.0608,2163,NULL,NULL,'IRSB','SMC',NULL,'2011A&A...534A..94S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7399,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7399,18.92,0.06,0.0608,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2444, RA-DEC 00:55:47.8-74:13:24.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7400,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7400,18.92,0.06,0.0608,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3463, RA-DEC 01:03:08.9-72:11:44.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7401,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7401,18.92,0.06,0.0608,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4293, RA-DEC 01:11:40.9-71:27:13.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7402,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7402,18.92,0.06,0.0608,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4717, RA-DEC 00:47:11.8-74:49:32.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7403,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7403,18.92,0.06,0.0608,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1910, RA-DEC 00:52:33.1-71:54:18.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7404,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7404,18.92,0.06,0.0608,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4104, RA-DEC 01:09:12.9-72:14:26.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7405,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7405,18.92,0.06,0.0608,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2698, RA-DEC 00:57:31.6-73:06:20.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7406,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7406,18.92,0.06,0.0608,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2960, RA-DEC 00:59:13.4-72:38:49.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7407,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7407,18.92,0.06,0.0608,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3418, RA-DEC 01:02:43.4-72:15:38.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7408,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7408,18.92,0.06,0.0608,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3692, RA-DEC 01:05:01.6-71:43:38.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7409,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7409,18.92,0.06,0.0608,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3868, RA-DEC 01:06:44.3-71:42:12.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7410,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7410,18.92,0.06,0.0609,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2496, RA-DEC 00:56:06.4-72:16:18.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7411,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7411,18.92,0.06,0.0609,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2541, RA-DEC 00:56:26.7-73:14:11.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7412,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7412,18.92,0.06,0.0609,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4100, RA-DEC 01:09:10.4-71:30:30.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7413,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7413,18.92,0.06,0.0609,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2653, RA-DEC 00:57:12.4-72:16:56.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7414,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7414,18.92,0.06,0.0609,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2994, RA-DEC 00:59:28.8-71:27:21.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7415,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7415,18.92,0.06,0.0609,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0881, RA-DEC 00:46:32.2-73:12:33.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7416,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7416,18.92,0.06,0.0609,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2443, RA-DEC 00:55:47.0-72:36:05.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7417,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7417,18.92,0.06,0.0609,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3312, RA-DEC 01:01:49.5-72:10:46.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7418,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7418,18.92,0.06,0.0609,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4114, RA-DEC 01:09:18.6-71:42:41.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7419,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7419,18.92,0.06,0.0609,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2078, RA-DEC 00:53:34.2-72:17:29.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7420,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7420,18.92,0.06,0.0609,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2750, RA-DEC 00:57:52.1-71:41:15.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7421,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7421,18.92,0.06,0.0609,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2816, RA-DEC 00:58:21.5-72:25:25.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7422,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7422,18.92,0.06,0.0609,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3160, RA-DEC 01:00:41.3-73:06:38.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7423,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7423,18.92,0.06,0.0609,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3529, RA-DEC 01:03:40.3-72:55:55.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7424,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7424,18.92,0.06,0.0609,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2594, RA-DEC 00:56:46.4-71:43:35.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7425,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7425,18.92,0.06,0.0609,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3416, RA-DEC 01:02:43.0-71:19:30.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7426,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7426,18.92,0.06,0.0609,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3839, RA-DEC 01:06:23.4-73:41:40.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7427,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7427,18.92,0.06,0.0609,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4736, RA-DEC 00:53:11.8-70:51:24.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7428,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7428,18.92,0.07,0.0609,2163,NULL,NULL,'HV 01877, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7429,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7429,18.92,0.06,0.0609,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0700, RA-DEC 00:45:01.4-73:12:31.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7430,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7430,18.92,0.06,0.0609,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1016, RA-DEC 00:47:38.5-73:09:05.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7431,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7431,18.92,0.06,0.0609,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2225, RA-DEC 00:54:24.9-73:15:53.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7432,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7432,18.92,0.06,0.0609,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3563, RA-DEC 01:03:59.6-72:40:40.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7433,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7433,18.92,0.06,0.0609,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4284, RA-DEC 01:11:37.1-72:53:48.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7434,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7434,18.92,0.06,0.0609,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3571, RA-DEC 01:04:02.1-73:05:53.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7435,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7435,18.92,0.06,0.0609,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3966, RA-DEC 01:07:36.1-73:41:33.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7436,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7436,18.92,0.06,0.0609,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4087, RA-DEC 01:09:03.3-72:06:57.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7437,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7437,18.92,0.06,0.0609,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4422, RA-DEC 01:13:53.4-71:29:34.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7438,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7438,18.92,0.06,0.061,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4789, RA-DEC 01:05:19.7-72:33:03.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7439,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7439,18.93,0.06,0.061,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1278, RA-DEC 00:49:12.1-72:35:46.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7440,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7440,18.93,0.06,0.061,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4364, RA-DEC 01:12:55.8-73:16:35.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7441,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7441,18.93,0.06,0.061,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4509, RA-DEC 01:16:13.1-73:36:50.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7442,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7442,18.93,0.06,0.061,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2221, RA-DEC 00:54:24.1-72:16:01.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7443,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7443,18.93,0.06,0.061,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2540, RA-DEC 00:56:26.0-73:36:29.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7444,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7444,18.93,0.06,0.061,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4016, RA-DEC 01:08:11.1-73:04:19.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7445,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7445,18.93,0.06,0.061,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1033, RA-DEC 00:47:46.5-73:28:21.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7446,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7446,18.93,0.06,0.061,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2867, RA-DEC 00:58:41.4-72:22:47.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7447,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7447,18.93,0.06,0.061,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3888, RA-DEC 01:06:56.6-74:07:32.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7448,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7448,18.93,0.06,0.061,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3812, RA-DEC 01:06:08.5-71:49:17.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7449,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7449,18.93,0.06,0.061,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2579, RA-DEC 00:56:38.7-72:31:57.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7450,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7450,18.93,0.06,0.061,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2949, RA-DEC 00:59:11.6-72:59:20.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7451,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7451,18.93,0.06,0.061,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4389, RA-DEC 01:13:25.1-71:48:01.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7452,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7452,18.9,0.2,0.061,2163,NULL,NULL,'HV 00829','SMC',NULL,'1993ApJ...405L..51B',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7453,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7453,18.94,0.04,0.061,2163,NULL,NULL,'VHJK','SMC',NULL,'1994MNRAS.266..441L',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7454,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7454,18.93,NULL,0.061,2163,NULL,NULL,'V +Z','SMC',NULL,'1999ApJ...522..250S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7455,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7455,18.94,NULL,0.061,2163,NULL,NULL,'B +Z','SMC',NULL,'1999ApJ...522..250S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7456,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7456,18.91,0.04,0.061,2163,NULL,NULL,NULL,'SMC',NULL,'2003AJ....125.1261D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7457,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7457,18.93,0.07,0.061,2163,NULL,NULL,'HV 01744, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7458,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7458,18.93,0.07,0.061,2163,NULL,NULL,'HV 00843, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7459,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7459,18.93,0.06,0.061,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1664, RA-DEC 00:51:21.3-73:04:16.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7460,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7460,18.93,0.06,0.061,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4547, RA-DEC 01:17:38.5-71:45:47.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7461,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7461,18.93,0.06,0.061,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2728, RA-DEC 00:57:42.8-73:16:00.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7462,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7462,18.93,0.06,0.061,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4089, RA-DEC 01:09:04.5-71:26:04.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7463,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7463,18.93,0.06,0.061,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3302, RA-DEC 01:01:46.9-73:05:33.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7464,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7464,18.93,0.06,0.061,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4000, RA-DEC 01:07:58.5-74:13:35.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7465,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7465,18.93,0.06,0.061,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0429, RA-DEC 00:41:53.2-73:09:45.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7466,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7466,18.93,0.06,0.061,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2331, RA-DEC 00:55:02.9-73:19:46.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7467,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7467,18.93,0.06,0.061,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2559, RA-DEC 00:56:31.2-72:50:20.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7468,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7468,18.93,0.06,0.061,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4295, RA-DEC 01:11:42.2-71:26:14.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7469,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7469,18.93,0.06,0.061,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4554, RA-DEC 01:17:51.7-72:31:22.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7470,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7470,18.93,0.06,0.0611,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1152, RA-DEC 00:48:23.1-73:30:58.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7471,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7471,18.93,0.06,0.0611,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3448, RA-DEC 01:02:59.0-72:22:21.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7472,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7472,18.93,0.06,0.0611,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4831, RA-DEC 01:13:09.3-74:22:35.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7473,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7473,18.93,0.06,0.0611,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2088, RA-DEC 00:53:39.0-72:12:00.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7474,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7474,18.93,0.06,0.0611,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4297, RA-DEC 01:11:44.6-71:21:40.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7475,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7475,18.93,0.06,0.0611,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2004, RA-DEC 00:53:08.8-72:15:47.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7476,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7476,18.93,0.06,0.0611,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3793, RA-DEC 01:05:56.5-71:59:02.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7477,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7477,18.93,0.06,0.0611,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1869, RA-DEC 00:52:19.8-71:50:38.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7478,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7478,18.93,0.06,0.0611,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3376, RA-DEC 01:02:23.6-71:41:37.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7479,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7479,18.93,0.06,0.0611,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4085, RA-DEC 01:09:02.0-71:58:45.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7480,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7480,18.93,0.06,0.0611,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4383, RA-DEC 01:13:17.6-72:27:46.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7481,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7481,18.93,0.02,0.0611,2163,NULL,NULL,'4150, W(VIHJKs), +/- 0.10 mag syst.','SMC',NULL,'2013ApJ...764...84I',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7482,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7482,18.93,0.05,0.0611,2163,NULL,NULL,'91, JHK, PL+PLC','SMC',NULL,'1987ApJ...321..162W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7483,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7483,18.93,NULL,0.0611,2163,NULL,NULL,'SMC-LMC 0.31 mag','SMC',NULL,'1988ASPC....4....9F',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7484,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7484,18.93,0.1,0.0611,2163,NULL,18.45,'LMC ZP','SMC',NULL,'2009AcA....59..403M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7485,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7485,18.93,0.02,0.0611,2163,NULL,NULL,'9, VR','SMC',NULL,'2006ApJ...642..834K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7486,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7486,18.93,0.14,0.0611,2163,NULL,NULL,'VI','SMC',NULL,'2008MNRAS.390.1539M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7487,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7487,18.93,0.06,0.0611,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0808, RA-DEC 00:46:00.9-73:16:16.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7488,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7488,18.93,0.06,0.0611,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3167, RA-DEC 01:00:43.5-72:09:33.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7489,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7489,18.93,0.06,0.0611,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4538, RA-DEC 01:17:10.8-71:20:10.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7490,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7490,18.93,0.06,0.0611,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3078, RA-DEC 01:00:06.3-72:30:05.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7491,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7491,18.93,0.06,0.0611,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3174, RA-DEC 01:00:46.4-72:03:36.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7492,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7492,18.93,0.06,0.0611,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2894, RA-DEC 00:58:50.1-72:01:26.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7493,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7493,18.93,0.06,0.0611,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1860, RA-DEC 00:52:17.9-71:42:14.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7494,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7494,18.93,0.06,0.0611,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2244, RA-DEC 00:54:33.0-72:17:31.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7495,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7495,18.93,0.06,0.0611,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3961, RA-DEC 01:07:34.7-72:53:02.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7496,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7496,18.93,0.06,0.0612,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1782, RA-DEC 00:51:58.3-73:31:50.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7497,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7497,18.93,0.06,0.0612,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2591, RA-DEC 00:56:45.5-73:03:39.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7498,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7498,18.93,0.06,0.0612,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3492, RA-DEC 01:03:20.7-72:48:56.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7499,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7499,18.93,0.06,0.0612,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2747, RA-DEC 00:57:50.2-72:47:47.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7500,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7500,18.93,0.06,0.0612,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0542, RA-DEC 00:43:30.3-72:37:00.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7501,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7501,18.93,0.06,0.0612,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2845, RA-DEC 00:58:33.6-71:34:46.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7502,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7502,18.93,0.06,0.0612,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3750, RA-DEC 01:05:34.8-72:07:22.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7503,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7503,18.93,0.06,0.0612,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4300, RA-DEC 01:11:46.3-71:37:27.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7504,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7504,18.93,0.06,0.0612,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1017, RA-DEC 00:47:38.8-73:12:50.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7505,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7505,18.93,0.06,0.0612,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0867, RA-DEC 00:46:27.0-73:13:04.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7506,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7506,18.93,0.06,0.0612,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0922, RA-DEC 00:46:53.3-72:54:02.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7507,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7507,18.93,0.06,0.0612,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2652, RA-DEC 00:57:10.7-73:07:19.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7508,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7508,18.93,0.06,0.0612,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2883, RA-DEC 00:58:46.7-71:55:02.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7509,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,NULL,7509,18.94,0.07,0.0612,2163,NULL,NULL,'HV 00827, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7510,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7510,18.93,0.06,0.0612,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0584, RA-DEC 00:43:57.3-73:11:29.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7511,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7511,18.93,0.06,0.0612,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4518, RA-DEC 01:16:25.0-71:19:38.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7512,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7512,18.93,0.06,0.0612,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4901, RA-DEC 01:34:30.5-72:41:01.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7513,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7513,18.93,0.06,0.0612,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1567, RA-DEC 00:50:55.5-72:34:42.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7514,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7514,18.93,0.06,0.0612,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4126, RA-DEC 01:09:25.0-71:18:10.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7515,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7515,18.93,0.06,0.0612,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0404, RA-DEC 00:41:24.0-73:21:40.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7516,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7516,18.93,0.06,0.0612,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0543, RA-DEC 00:43:33.2-73:16:37.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7517,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7517,18.93,0.06,0.0612,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2388, RA-DEC 00:55:24.5-71:40:28.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7518,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7518,18.93,0.06,0.0612,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2455, RA-DEC 00:55:52.5-73:34:33.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7519,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7519,18.93,0.06,0.0612,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3113, RA-DEC 01:00:20.8-73:25:20.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7520,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7520,18.93,0.06,0.0612,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3278, RA-DEC 01:01:35.7-71:57:29.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7521,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7521,18.93,0.06,0.0612,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3906, RA-DEC 01:07:04.2-72:02:03.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7522,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7522,18.93,0.06,0.0612,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4572, RA-DEC 01:18:43.7-73:41:42.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7523,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7523,18.93,0.06,0.0612,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4720, RA-DEC 00:49:02.3-70:08:16.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7524,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7524,18.94,0.06,0.0613,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2879, RA-DEC 00:58:46.6-72:55:04.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7525,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7525,18.94,0.06,0.0613,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4430, RA-DEC 01:14:06.5-71:52:34.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7526,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7526,18.94,0.06,0.0613,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0903, RA-DEC 00:46:41.6-73:15:57.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7527,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7527,18.94,0.06,0.0613,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1569, RA-DEC 00:50:55.7-73:12:11.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7528,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:38','1',NULL,'R',7528,18.94,0.06,0.0613,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2771, RA-DEC 00:58:02.7-72:40:23.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7529,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7529,18.94,0.06,0.0613,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3562, RA-DEC 01:03:59.1-73:33:20.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7530,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7530,18.94,0.06,0.0613,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4305, RA-DEC 01:11:48.2-73:14:32.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7531,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7531,18.94,0.06,0.0613,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4526, RA-DEC 01:16:48.4-71:33:45.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7532,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7532,18.94,0.06,0.0613,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3123, RA-DEC 01:00:26.5-71:55:38.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7533,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7533,18.94,0.06,0.0613,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4617, RA-DEC 01:23:21.0-72:08:53.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7534,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7534,18.94,0.06,0.0613,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3717, RA-DEC 01:05:16.8-71:56:56.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7535,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7535,18.94,0.06,0.0613,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3796, RA-DEC 01:06:00.0-73:10:07.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7536,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7536,18.94,0.06,0.0613,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4504, RA-DEC 01:15:58.6-73:00:34.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7537,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,7537,18.94,0.07,0.0613,2163,NULL,NULL,'HV 11157, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7538,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,7538,18.94,0.08,0.0613,2163,NULL,NULL,NULL,'SMC',NULL,'2013ApJ...772..130M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7539,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7539,18.94,0.06,0.0613,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1066, RA-DEC 00:47:55.7-73:02:01.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7540,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7540,18.94,0.06,0.0613,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1461, RA-DEC 00:50:12.2-74:35:29.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7541,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7541,18.94,0.06,0.0613,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1784, RA-DEC 00:51:58.7-73:57:26.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7542,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7542,18.94,0.06,0.0613,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3338, RA-DEC 01:02:02.7-73:09:47.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7543,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7543,18.94,0.06,0.0613,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4116, RA-DEC 01:09:19.9-71:29:23.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7544,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7544,18.94,0.06,0.0613,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4801, RA-DEC 01:07:22.8-70:53:14.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7545,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7545,18.94,0.06,0.0613,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1608, RA-DEC 00:51:06.0-71:59:09.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7546,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7546,18.94,0.06,0.0613,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3995, RA-DEC 01:07:57.3-72:42:55.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7547,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7547,18.94,0.06,0.0613,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4201, RA-DEC 01:10:18.4-73:17:11.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7548,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7548,18.94,0.06,0.0614,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2957, RA-DEC 00:59:12.9-72:49:00.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7549,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7549,18.94,0.06,0.0614,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2969, RA-DEC 00:59:18.7-72:09:11.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7550,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7550,18.94,0.06,0.0614,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0611, RA-DEC 00:44:09.5-73:00:47.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7551,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7551,18.94,0.06,0.0614,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1101, RA-DEC 00:48:04.9-73:32:55.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7552,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7552,18.94,0.06,0.0614,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4808, RA-DEC 01:07:57.5-71:05:23.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7553,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7553,18.94,0.06,0.0614,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2897, RA-DEC 00:58:51.4-71:54:21.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7554,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7554,18.94,0.06,0.0614,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3539, RA-DEC 01:03:45.5-72:12:47.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7555,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,7555,18.94,0.07,0.0614,2163,NULL,NULL,'91, K, PL','SMC',NULL,'1987ApJ...321..162W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7556,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7556,18.94,0.06,0.0614,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1913, RA-DEC 00:52:34.5-72:58:12.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7557,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7557,18.94,0.06,0.0614,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2335, RA-DEC 00:55:03.9-73:00:56.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7558,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7558,18.94,0.06,0.0614,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2354, RA-DEC 00:55:11.4-72:38:19.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7559,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7559,18.94,0.06,0.0614,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1172, RA-DEC 00:48:31.4-73:16:00.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7560,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7560,18.94,0.06,0.0614,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1363, RA-DEC 00:49:40.0-73:06:07.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7561,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7561,18.94,0.06,0.0614,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2549, RA-DEC 00:56:28.9-72:26:18.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7562,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7562,18.94,0.06,0.0614,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3942, RA-DEC 01:07:24.7-71:46:32.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7563,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7563,18.94,0.06,0.0614,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1401, RA-DEC 00:49:51.6-72:59:47.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7564,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7564,18.94,0.06,0.0614,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1720, RA-DEC 00:51:38.9-73:32:39.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7565,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7565,18.94,0.06,0.0614,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1788, RA-DEC 00:51:59.3-72:38:35.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7566,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7566,18.94,0.06,0.0614,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2133, RA-DEC 00:53:53.6-71:53:19.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7567,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7567,18.94,0.06,0.0614,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3244, RA-DEC 01:01:18.3-73:03:46.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7568,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7568,18.94,0.06,0.0614,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3281, RA-DEC 01:01:37.2-73:36:31.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7569,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7569,18.94,0.06,0.0614,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3779, RA-DEC 01:05:50.3-72:29:35.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7570,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7570,18.94,0.06,0.0614,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4059, RA-DEC 01:08:44.3-71:35:57.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7571,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7571,18.94,0.06,0.0614,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4301, RA-DEC 01:11:46.4-71:18:16.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7572,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7572,18.94,0.01,0.0614,2163,NULL,NULL,'4150, JHK, IRSB, +/- 0.10 mag syst.','SMC',NULL,'2013IAUS..289..116B',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7573,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,7573,18.94,0.01,0.0614,2163,NULL,18.46,'NIR, Ks or K','SMC',NULL,'2011MNRAS.413..223M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7574,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,7574,18.94,0.01,0.0614,2163,NULL,18.46,'I or W(VI)','SMC',NULL,'2011MNRAS.413..223M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7575,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,7575,18.94,0.07,0.0614,2163,NULL,NULL,'HV 11182, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7576,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7576,18.94,0.06,0.0614,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0620, RA-DEC 00:44:14.8-73:20:55.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7577,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7577,18.94,0.06,0.0614,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1377, RA-DEC 00:49:42.8-72:29:45.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7578,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7578,18.94,0.06,0.0614,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1639, RA-DEC 00:51:13.8-73:14:04.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7579,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7579,18.94,0.06,0.0614,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2905, RA-DEC 00:58:55.1-72:33:07.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7580,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7580,18.94,0.06,0.0614,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1769, RA-DEC 00:51:55.4-74:15:28.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7581,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7581,18.94,0.06,0.0614,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2563, RA-DEC 00:56:33.6-72:13:55.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7582,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7582,18.94,0.06,0.0614,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3139, RA-DEC 01:00:33.4-72:47:21.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7583,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7583,18.94,0.06,0.0614,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3676, RA-DEC 01:04:52.5-73:34:13.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7584,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7584,18.94,0.06,0.0615,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2170, RA-DEC 00:54:04.9-73:05:51.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7585,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7585,18.94,0.06,0.0615,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2321, RA-DEC 00:54:59.7-73:10:06.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7586,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7586,18.94,0.06,0.0615,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2370, RA-DEC 00:55:19.2-73:24:40.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7587,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7587,18.94,0.06,0.0615,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4115, RA-DEC 01:09:18.6-71:37:12.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7588,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7588,18.94,0.06,0.0615,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1708, RA-DEC 00:51:33.6-73:26:56.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7589,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7589,18.94,0.06,0.0615,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2560, RA-DEC 00:56:31.6-73:06:45.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7590,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7590,18.94,0.06,0.0615,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3546, RA-DEC 01:03:51.1-71:42:02.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7591,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7591,18.94,0.06,0.0615,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0116, RA-DEC 00:29:44.8-73:46:14.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7592,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7592,18.94,0.06,0.0615,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2727, RA-DEC 00:57:42.8-72:03:06.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7593,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7593,18.94,0.06,0.0615,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4151, RA-DEC 01:09:45.4-71:34:16.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7594,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7594,18.94,0.06,0.0615,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0563, RA-DEC 00:43:42.3-74:10:48.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7595,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7595,18.94,0.06,0.0615,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2410, RA-DEC 00:55:35.5-72:23:57.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7596,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7596,18.94,0.06,0.0615,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3487, RA-DEC 01:03:19.3-73:24:00.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7597,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,7597,18.94,0.07,0.0615,2163,NULL,NULL,'HV 01610, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7598,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7598,18.94,0.06,0.0615,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3349, RA-DEC 01:02:09.1-73:17:42.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7599,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7599,18.94,0.06,0.0615,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3651, RA-DEC 01:04:37.5-72:49:33.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7600,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7600,18.94,0.06,0.0615,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4374, RA-DEC 01:13:08.7-71:52:41.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7601,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7601,18.95,0.06,0.0615,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3626, RA-DEC 01:04:22.2-74:00:39.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7602,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7602,18.95,0.06,0.0615,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4152, RA-DEC 01:09:45.9-71:34:46.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7603,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7603,18.95,0.06,0.0615,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4661, RA-DEC 00:18:18.0-74:50:15.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7604,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7604,18.95,0.06,0.0615,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2654, RA-DEC 00:57:12.6-72:22:43.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7605,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7605,18.95,0.06,0.0615,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4022, RA-DEC 01:08:15.2-72:30:11.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7606,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7606,18.95,0.06,0.0615,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2796, RA-DEC 00:58:12.3-73:12:34.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7607,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7607,18.95,0.06,0.0615,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3317, RA-DEC 01:01:54.4-73:08:55.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7608,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7608,18.95,0.06,0.0615,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3522, RA-DEC 01:03:36.4-72:38:59.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7609,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7609,18.95,0.06,0.0615,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3939, RA-DEC 01:07:23.7-73:05:25.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7610,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7610,18.95,0.06,0.0616,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1097, RA-DEC 00:48:03.4-73:00:07.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7611,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7611,18.95,0.06,0.0616,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3066, RA-DEC 00:59:58.0-72:35:33.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7612,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7612,18.95,0.06,0.0616,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4033, RA-DEC 01:08:21.2-73:56:24.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7613,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7613,18.95,0.06,0.0616,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1904, RA-DEC 00:52:31.4-73:08:56.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7614,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7614,18.95,0.06,0.0616,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1161, RA-DEC 00:48:25.8-72:56:23.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7615,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7615,18.95,0.06,0.0616,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2097, RA-DEC 00:53:42.2-72:55:58.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7616,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7616,18.95,0.06,0.0616,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2685, RA-DEC 00:57:26.7-71:44:29.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7617,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7617,18.95,0.06,0.0616,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2910, RA-DEC 00:58:56.9-73:25:17.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7618,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7618,18.95,0.06,0.0616,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4489, RA-DEC 01:15:40.3-71:41:31.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7619,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7619,18.95,0.06,0.0616,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1680, RA-DEC 00:51:24.4-73:00:17.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7620,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7620,18.95,0.06,0.0616,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4108, RA-DEC 01:09:17.2-71:26:11.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7621,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7621,18.95,0.06,0.0616,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4792, RA-DEC 01:06:16.6-74:55:58.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7622,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,7622,18.95,0.07,0.0616,2163,NULL,NULL,'HV 00854, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7623,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7623,18.95,0.06,0.0616,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1902, RA-DEC 00:52:30.6-73:15:17.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7624,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7624,18.95,0.06,0.0616,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3385, RA-DEC 01:02:27.5-73:28:10.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7625,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7625,18.95,0.06,0.0616,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2899, RA-DEC 00:58:52.2-71:58:37.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7626,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7626,18.95,0.06,0.0616,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3974, RA-DEC 01:07:43.8-73:30:38.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7627,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7627,18.95,0.06,0.0616,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2384, RA-DEC 00:55:22.7-72:42:15.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7628,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7628,18.95,0.06,0.0616,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3534, RA-DEC 01:03:43.1-72:09:20.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7629,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7629,18.95,0.06,0.0616,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0818, RA-DEC 00:46:04.4-73:27:42.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7630,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7630,18.95,0.06,0.0616,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1827, RA-DEC 00:52:07.9-73:24:44.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7631,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7631,18.95,0.06,0.0616,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2607, RA-DEC 00:56:52.8-72:52:12.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7632,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7632,18.95,0.06,0.0616,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4929, RA-DEC 01:43:31.5-77:33:03.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7633,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7633,18.95,0.06,0.0617,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0216, RA-DEC 00:35:34.6-73:09:22.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7634,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7634,18.95,0.06,0.0617,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1323, RA-DEC 00:49:23.6-72:56:24.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7635,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7635,18.95,0.06,0.0617,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2891, RA-DEC 00:58:49.1-72:57:32.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7636,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7636,18.95,0.06,0.0617,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3575, RA-DEC 01:04:04.8-73:24:25.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7637,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7637,18.95,0.06,0.0617,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4851, RA-DEC 01:18:57.4-70:19:21.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7638,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7638,18.95,0.06,0.0617,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0736, RA-DEC 00:45:15.4-73:22:36.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7639,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7639,18.95,0.06,0.0617,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1596, RA-DEC 00:51:01.1-73:26:25.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7640,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7640,18.95,0.06,0.0617,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1958, RA-DEC 00:52:51.7-72:43:12.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7641,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7641,18.95,0.06,0.0617,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3124, RA-DEC 01:00:26.8-72:42:35.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7642,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7642,18.95,0.06,0.0617,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3304, RA-DEC 01:01:47.1-73:07:25.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7643,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7643,18.95,0.06,0.0617,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4433, RA-DEC 01:14:15.9-72:31:06.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7644,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7644,18.95,0.06,0.0617,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1812, RA-DEC 00:52:03.7-72:35:12.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7645,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7645,18.95,0.06,0.0617,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3560, RA-DEC 01:03:58.4-73:09:44.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7646,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7646,18.95,0.06,0.0617,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4704, RA-DEC 00:42:10.9-75:21:33.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7647,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7647,18.95,0.06,0.0617,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4769, RA-DEC 01:01:58.9-71:04:15.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7648,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7648,18.95,0.06,0.0617,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3188, RA-DEC 01:00:52.2-71:58:02.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7649,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7649,18.95,0.06,0.0617,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2453, RA-DEC 00:55:51.4-73:58:02.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7650,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7650,18.95,0.06,0.0617,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3372, RA-DEC 01:02:21.6-71:29:48.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7651,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7651,18.95,0.06,0.0617,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4143, RA-DEC 01:09:40.7-73:43:05.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7652,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7652,18.95,0.06,0.0617,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4361, RA-DEC 01:12:50.2-71:35:57.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7653,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7653,18.95,0.06,0.0617,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4742, RA-DEC 00:55:30.0-74:34:58.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7654,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7654,18.95,0.06,0.0617,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2580, RA-DEC 00:56:38.9-71:55:02.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7655,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7655,18.95,0.06,0.0617,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3215, RA-DEC 01:01:03.7-73:21:41.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7656,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,7656,18.95,0.12,0.0617,2163,NULL,NULL,'VI(W)','SMC',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7657,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,7657,18.95,0.02,0.0617,2163,NULL,NULL,'IRAC 3.6 micron, Mean of 53','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7658,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,7658,18.95,0.07,0.0617,2163,NULL,NULL,'HV 00822, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7659,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7659,18.95,0.06,0.0617,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1314, RA-DEC 00:49:22.1-73:45:05.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7660,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7660,18.95,0.06,0.0617,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2635, RA-DEC 00:57:05.1-72:36:27.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7661,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7661,18.95,0.06,0.0617,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2693, RA-DEC 00:57:29.6-72:08:43.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7662,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7662,18.95,0.06,0.0617,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4222, RA-DEC 01:10:41.0-72:46:06.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7663,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7663,18.95,0.06,0.0617,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1497, RA-DEC 00:50:27.0-72:58:48.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7664,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7664,18.95,0.06,0.0617,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1764, RA-DEC 00:51:54.8-73:12:07.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7665,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7665,18.95,0.06,0.0617,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4451, RA-DEC 01:14:38.9-72:54:49.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7666,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7666,18.95,0.06,0.0617,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2673, RA-DEC 00:57:20.5-71:38:41.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7667,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7667,18.95,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3471, RA-DEC 01:03:12.3-71:50:47.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7668,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7668,18.95,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3478, RA-DEC 01:03:15.4-72:56:38.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7669,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7669,18.95,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4197, RA-DEC 01:10:14.8-72:27:45.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7670,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7670,18.95,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3873, RA-DEC 01:06:47.0-73:29:19.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7671,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7671,18.95,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1482, RA-DEC 00:50:21.6-73:15:10.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7672,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7672,18.95,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3577, RA-DEC 01:04:05.4-71:18:53.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7673,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7673,18.95,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4345, RA-DEC 01:12:36.7-73:46:06.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7674,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7674,18.95,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1485, RA-DEC 00:50:23.1-73:02:34.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7675,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7675,18.95,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2038, RA-DEC 00:53:19.9-72:17:38.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7676,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7676,18.95,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2400, RA-DEC 00:55:31.9-72:09:12.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7677,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7677,18.95,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3453, RA-DEC 01:03:02.2-73:29:58.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7678,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7678,18.95,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4229, RA-DEC 01:10:48.9-71:22:43.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7679,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7679,18.95,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4815, RA-DEC 01:09:51.6-71:01:46.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7680,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7680,18.95,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2934, RA-DEC 00:59:04.6-72:11:08.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7681,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7681,18.95,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3192, RA-DEC 01:00:54.3-71:44:43.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7682,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7682,18.95,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3305, RA-DEC 01:01:47.1-72:29:10.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7683,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7683,18.95,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3532, RA-DEC 01:03:41.6-72:18:07.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7684,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7684,18.95,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2167, RA-DEC 00:54:02.9-72:53:22.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7685,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7685,18.95,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3591, RA-DEC 01:04:09.4-73:29:54.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7686,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7686,18.95,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4546, RA-DEC 01:17:32.9-71:40:14.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7687,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,7687,18.96,0.07,0.0618,2163,NULL,NULL,'HV 02088, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7688,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7688,18.96,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2805, RA-DEC 00:58:17.2-71:51:54.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7689,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7689,18.96,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4796, RA-DEC 01:06:34.3-71:06:15.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7690,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7690,18.96,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2462, RA-DEC 00:55:53.8-71:32:12.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7691,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7691,18.96,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2582, RA-DEC 00:56:39.2-72:33:54.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7692,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7692,18.96,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3185, RA-DEC 01:00:50.5-72:04:43.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7693,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7693,18.96,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3800, RA-DEC 01:06:02.2-71:41:03.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7694,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7694,18.96,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4263, RA-DEC 01:11:19.6-72:45:52.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7695,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7695,18.96,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1979, RA-DEC 00:52:57.9-73:48:03.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7696,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7696,18.96,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3194, RA-DEC 01:00:55.5-72:57:42.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7697,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7697,18.96,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3228, RA-DEC 01:01:11.3-73:51:08.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7698,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7698,18.96,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4530, RA-DEC 01:16:49.7-71:26:04.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7699,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7699,18.96,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2008, RA-DEC 00:53:10.5-72:51:31.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7700,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7700,18.96,0.06,0.0618,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2824, RA-DEC 00:58:23.2-72:54:24.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7701,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7701,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3442, RA-DEC 01:02:56.3-73:34:51.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7702,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7702,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1047, RA-DEC 00:47:50.6-73:13:56.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7703,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7703,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3445, RA-DEC 01:02:57.4-72:53:01.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7704,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7704,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3574, RA-DEC 01:04:03.3-72:38:16.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7705,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7705,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3699, RA-DEC 01:05:05.9-73:47:43.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7706,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7706,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4373, RA-DEC 01:13:08.4-73:48:29.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7707,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7707,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4854, RA-DEC 01:20:07.9-74:16:07.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7708,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7708,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0075, RA-DEC 00:27:04.1-73:51:36.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7709,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7709,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1629, RA-DEC 00:51:11.1-73:33:18.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7710,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7710,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2019, RA-DEC 00:53:15.2-73:06:26.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7711,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7711,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2425, RA-DEC 00:55:39.7-73:02:57.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7712,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7712,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3022, RA-DEC 00:59:38.4-72:01:29.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7713,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7713,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3979, RA-DEC 01:07:46.5-72:22:26.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7714,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7714,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2341, RA-DEC 00:55:07.2-73:17:07.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7715,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7715,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3173, RA-DEC 01:00:45.7-71:50:02.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7716,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7716,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3365, RA-DEC 01:02:17.5-72:25:57.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7717,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7717,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4170, RA-DEC 01:09:58.4-73:41:46.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7718,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7718,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0660, RA-DEC 00:44:30.9-72:26:52.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7719,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7719,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2003, RA-DEC 00:53:08.6-73:20:49.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7720,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7720,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2091, RA-DEC 00:53:39.4-73:09:21.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7721,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7721,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2472, RA-DEC 00:55:57.1-71:29:23.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7722,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7722,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2619, RA-DEC 00:56:58.1-71:35:05.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7723,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7723,18.96,NULL,0.0619,2163,NULL,NULL,'JHKV','SMC',NULL,'1999ASSL..237..125W',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7724,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,7724,18.96,NULL,0.0619,2163,NULL,NULL,'16, W, Period-Wesenheit, Z2','SMC',NULL,'2007A&A...476..863F',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7725,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7725,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0106, RA-DEC 00:29:20.6-73:49:47.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7726,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7726,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3097, RA-DEC 01:00:14.9-73:36:24.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7727,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7727,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4417, RA-DEC 01:13:48.5-72:24:35.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7728,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7728,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4486, RA-DEC 01:15:38.5-73:04:37.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7729,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7729,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4550, RA-DEC 01:17:41.7-72:23:14.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7730,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7730,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2703, RA-DEC 00:57:33.2-71:53:17.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7731,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7731,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3527, RA-DEC 01:03:37.7-74:00:23.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7732,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7732,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4497, RA-DEC 01:15:49.1-72:14:03.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7733,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7733,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1406, RA-DEC 00:49:54.2-73:12:20.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7734,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7734,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1798, RA-DEC 00:52:00.8-72:23:43.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7735,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7735,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4162, RA-DEC 01:09:51.7-71:23:57.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7736,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7736,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0446, RA-DEC 00:42:08.2-72:57:08.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7737,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7737,18.96,0.06,0.0619,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2239, RA-DEC 00:54:32.2-72:51:48.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7738,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,7738,18.96,0.08,0.0619,2163,NULL,NULL,'602, JHKs, GAL PL','SMC',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7739,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7739,18.96,0.06,0.062,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1170, RA-DEC 00:48:30.9-72:34:55.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7740,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7740,18.96,0.06,0.062,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3932, RA-DEC 01:07:19.8-72:35:43.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7741,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7741,18.96,0.06,0.062,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4287, RA-DEC 01:11:37.9-73:24:58.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7742,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7742,18.96,0.06,0.062,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3324, RA-DEC 01:01:56.4-73:48:06.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7743,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7743,18.96,0.06,0.062,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1521, RA-DEC 00:50:36.1-73:31:05.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7744,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7744,18.96,0.06,0.062,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2999, RA-DEC 00:59:29.6-71:18:18.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7745,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7745,18.96,0.06,0.062,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4231, RA-DEC 01:10:49.8-73:17:22.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7746,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7746,18.96,0.06,0.062,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2786, RA-DEC 00:58:08.7-71:30:12.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7747,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7747,18.96,0.06,0.062,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4239, RA-DEC 01:10:58.4-72:32:03.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7748,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7748,18.96,0.06,0.062,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0512, RA-DEC 00:43:05.2-73:33:59.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7749,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7749,18.96,0.06,0.062,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1081, RA-DEC 00:47:59.9-73:00:18.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7750,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7750,18.96,0.06,0.062,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2808, RA-DEC 00:58:17.7-71:37:57.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7751,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7751,18.96,0.06,0.062,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3405, RA-DEC 01:02:37.3-72:05:07.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7752,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7752,18.96,0.06,0.062,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4058, RA-DEC 01:08:44.1-72:41:33.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7753,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7753,18.96,0.06,0.062,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3394, RA-DEC 01:02:31.9-73:36:59.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7754,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,7754,18.96,0.01,0.062,2163,NULL,NULL,'92, BVRIJHK, 3.6 and 4.5 micron, mean of 9 wavelengths, syst. +/- 0.03 mag','SMC',NULL,'2016ApJ...816...49S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7755,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,7755,18.96,NULL,0.062,2163,NULL,NULL,'I +Z','SMC',NULL,'1999ApJ...522..250S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7756,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,7756,18.96,0.07,0.062,2163,NULL,NULL,'HV 02064, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7757,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7757,18.96,0.06,0.062,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2152, RA-DEC 00:53:58.5-72:23:47.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7758,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7758,18.96,0.06,0.062,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3984, RA-DEC 01:07:50.7-71:45:51.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7759,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7759,18.96,0.06,0.062,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4519, RA-DEC 01:16:31.0-72:24:06.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7760,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7760,18.96,0.06,0.062,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2280, RA-DEC 00:54:47.9-72:26:31.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7761,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7761,18.96,0.06,0.062,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3319, RA-DEC 01:01:55.1-73:00:59.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7762,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7762,18.96,0.06,0.062,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3544, RA-DEC 01:03:49.9-71:24:40.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7763,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7763,18.96,0.06,0.062,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3855, RA-DEC 01:06:33.7-72:09:16.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7764,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7764,18.96,0.06,0.062,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3923, RA-DEC 01:07:15.6-73:22:38.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7765,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7765,18.96,0.06,0.062,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4084, RA-DEC 01:09:00.7-71:28:04.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7766,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7766,18.96,0.06,0.062,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4159, RA-DEC 01:09:50.6-71:16:56.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7767,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7767,18.96,0.06,0.062,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4822, RA-DEC 01:10:50.1-71:08:14.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7768,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7768,18.96,0.06,0.062,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0359, RA-DEC 00:40:29.9-73:24:04.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7769,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7769,18.96,0.06,0.062,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1814, RA-DEC 00:52:04.3-72:31:17.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7770,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7770,18.96,0.06,0.062,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3576, RA-DEC 01:04:05.3-71:57:45.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7771,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7771,18.96,0.06,0.062,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4449, RA-DEC 01:14:37.2-71:30:00.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7772,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7772,18.96,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3617, RA-DEC 01:04:19.1-71:38:55.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7773,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7773,18.96,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3625, RA-DEC 01:04:21.8-71:46:03.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7774,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7774,18.96,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4395, RA-DEC 01:13:28.8-72:39:42.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7775,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7775,18.96,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4861, RA-DEC 01:23:08.8-74:50:53.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7776,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7776,18.96,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4881, RA-DEC 01:27:41.4-69:23:46.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7777,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7777,18.96,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0984, RA-DEC 00:47:23.2-72:32:58.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7778,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7778,18.96,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1039, RA-DEC 00:47:48.0-72:45:34.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7779,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7779,18.96,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2278, RA-DEC 00:54:47.0-72:45:36.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7780,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7780,18.96,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3743, RA-DEC 01:05:28.3-73:37:38.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7781,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7781,18.96,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4228, RA-DEC 01:10:48.7-72:40:42.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7782,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7782,18.96,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2474, RA-DEC 00:55:57.2-73:18:17.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7783,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7783,18.96,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3231, RA-DEC 01:01:12.8-73:02:21.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7784,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7784,18.96,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3905, RA-DEC 01:07:04.0-72:28:30.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7785,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7785,18.97,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0228, RA-DEC 00:35:58.6-73:28:57.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7786,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7786,18.97,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0859, RA-DEC 00:46:22.0-71:49:55.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7787,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7787,18.97,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2829, RA-DEC 00:58:24.7-71:42:38.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7788,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7788,18.97,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3325, RA-DEC 01:01:56.7-71:16:31.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7789,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7789,18.97,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3559, RA-DEC 01:03:57.9-73:26:53.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7790,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7790,18.97,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4814, RA-DEC 01:09:22.6-71:14:38.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7791,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7791,18.97,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2157, RA-DEC 00:53:59.8-72:55:35.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7792,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7792,18.97,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2986, RA-DEC 00:59:24.6-73:04:38.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7793,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7793,18.97,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4249, RA-DEC 01:11:06.0-72:25:12.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7794,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,7794,18.96,0.07,0.0621,2163,NULL,NULL,'HV 01442, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7795,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7795,18.97,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1971, RA-DEC 00:52:54.4-72:54:53.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7796,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7796,18.97,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2023, RA-DEC 00:53:16.3-73:21:14.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7797,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7797,18.97,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1449, RA-DEC 00:50:08.5-72:45:19.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7798,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7798,18.97,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2489, RA-DEC 00:56:05.8-73:05:43.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7799,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7799,18.97,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2712, RA-DEC 00:57:34.9-72:57:44.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7800,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7800,18.97,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2972, RA-DEC 00:59:19.7-72:21:39.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7801,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7801,18.97,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4496, RA-DEC 01:15:47.0-73:04:37.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7802,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7802,18.97,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4525, RA-DEC 01:16:43.8-72:15:47.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7803,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7803,18.97,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2916, RA-DEC 00:58:59.6-71:54:30.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7804,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7804,18.97,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1143, RA-DEC 00:48:18.7-72:34:47.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7805,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7805,18.97,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2426, RA-DEC 00:55:39.9-72:53:00.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7806,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7806,18.97,0.06,0.0621,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3137, RA-DEC 01:00:32.0-73:53:52.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7807,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7807,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4098, RA-DEC 01:09:10.3-72:38:42.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7808,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7808,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1684, RA-DEC 00:51:25.7-72:56:34.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7809,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7809,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1981, RA-DEC 00:52:58.5-72:53:27.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7810,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7810,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2832, RA-DEC 00:58:26.8-71:33:57.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7811,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7811,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3187, RA-DEC 01:00:51.6-73:13:29.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7812,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7812,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3706, RA-DEC 01:05:09.0-72:40:07.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7813,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7813,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3845, RA-DEC 01:06:27.1-73:44:58.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7814,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7814,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4198, RA-DEC 01:10:15.0-73:08:48.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7815,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7815,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0155, RA-DEC 00:33:05.8-72:55:23.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7816,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7816,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0163, RA-DEC 00:33:23.0-73:23:05.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7817,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7817,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0652, RA-DEC 00:44:28.4-72:47:25.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7818,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7818,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3397, RA-DEC 01:02:33.8-74:12:04.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7819,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7819,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4046, RA-DEC 01:08:32.9-71:29:13.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7820,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7820,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1540, RA-DEC 00:50:46.0-72:40:58.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7821,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7821,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2684, RA-DEC 00:57:25.7-73:22:30.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7822,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7822,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1034, RA-DEC 00:47:46.7-73:58:06.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7823,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7823,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3936, RA-DEC 01:07:21.7-71:47:03.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7824,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7824,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0917, RA-DEC 00:46:51.3-73:06:27.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7825,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7825,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1195, RA-DEC 00:48:39.3-72:57:20.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7826,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7826,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2436, RA-DEC 00:55:45.1-72:07:41.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7827,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7827,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2680, RA-DEC 00:57:24.8-73:04:57.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7828,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7828,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4146, RA-DEC 01:09:41.7-71:20:04.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7829,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,7829,18.97,0.07,0.0622,2163,NULL,NULL,'63, IR','SMC',NULL,'1986MNRAS.218..223C',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7830,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7830,18.97,0.05,0.0622,2163,NULL,18.46,'90, JHK','SMC',NULL,'1986PhDT........22W',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7831,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7831,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0766, RA-DEC 00:45:38.3-73:02:32.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7832,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7832,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0826, RA-DEC 00:46:09.0-73:24:42.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7833,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7833,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4080, RA-DEC 01:08:59.8-71:34:14.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7834,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7834,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4460, RA-DEC 01:14:50.3-71:33:08.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7835,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7835,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0452, RA-DEC 00:42:12.8-73:21:29.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7836,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7836,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1570, RA-DEC 00:50:55.7-72:16:03.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7837,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7837,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3701, RA-DEC 01:05:06.9-73:44:30.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7838,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7838,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3791, RA-DEC 01:05:56.2-72:47:56.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7839,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7839,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1212, RA-DEC 00:48:47.6-73:07:30.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7840,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7840,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1354, RA-DEC 00:49:35.3-72:40:46.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7841,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7841,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1563, RA-DEC 00:50:54.7-72:48:01.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7842,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7842,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2506, RA-DEC 00:56:09.2-74:13:57.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7843,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7843,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4835, RA-DEC 01:14:00.1-70:33:44.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7844,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,7844,18.97,0.02,0.0622,2163,NULL,18.49,'2626, VI','SMC',NULL,'2015ApJ...808...67N',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7845,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7845,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0752, RA-DEC 00:45:25.1-73:11:46.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7846,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7846,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3630, RA-DEC 01:04:23.8-73:25:44.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7847,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7847,18.97,0.06,0.0622,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4597, RA-DEC 01:20:45.5-73:41:44.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7848,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7848,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2289, RA-DEC 00:54:50.6-72:42:00.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7849,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7849,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2528, RA-DEC 00:56:17.8-72:32:57.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7850,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7850,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3056, RA-DEC 00:59:53.2-72:38:25.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7851,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7851,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3155, RA-DEC 01:00:39.8-72:44:03.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7852,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7852,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3270, RA-DEC 01:01:31.9-72:19:20.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7853,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7853,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3715, RA-DEC 01:05:15.7-73:55:22.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7854,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7854,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1970, RA-DEC 00:52:54.3-73:32:35.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7855,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7855,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0431, RA-DEC 00:41:55.5-73:32:23.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7856,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7856,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0926, RA-DEC 00:46:53.9-72:56:01.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7857,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7857,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3043, RA-DEC 00:59:49.2-73:16:49.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7858,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7858,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3665, RA-DEC 01:04:45.8-73:31:08.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7859,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7859,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1271, RA-DEC 00:49:10.9-72:45:25.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7860,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7860,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1935, RA-DEC 00:52:41.3-72:11:46.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7861,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7861,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2058, RA-DEC 00:53:26.5-71:39:28.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7862,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7862,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2713, RA-DEC 00:57:36.5-72:40:31.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7863,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7863,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3036, RA-DEC 00:59:47.0-72:45:51.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7864,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7864,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3099, RA-DEC 01:00:16.1-71:39:25.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7865,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7865,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3340, RA-DEC 01:02:03.2-71:43:10.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7866,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7866,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3592, RA-DEC 01:04:09.5-72:56:30.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7867,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7867,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4307, RA-DEC 01:11:51.8-73:14:47.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7868,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,7868,18.97,0.07,0.0623,2163,NULL,NULL,'HV 00819, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7869,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7869,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1566, RA-DEC 00:50:55.5-72:52:54.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7870,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7870,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2938, RA-DEC 00:59:05.8-72:05:48.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7871,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7871,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4025, RA-DEC 01:08:16.3-71:50:13.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7872,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7872,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4043, RA-DEC 01:08:29.4-74:03:04.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7873,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7873,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4945, RA-DEC 01:51:17.0-75:13:54.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7874,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7874,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2900, RA-DEC 00:58:52.3-72:48:01.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7875,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7875,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3983, RA-DEC 01:07:50.5-71:33:03.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7876,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7876,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0789, RA-DEC 00:45:52.8-74:08:17.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7877,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7877,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1113, RA-DEC 00:48:07.7-72:25:59.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7878,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7878,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3683, RA-DEC 01:04:57.0-72:29:48.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7879,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7879,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4171, RA-DEC 01:09:59.0-72:43:40.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7880,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7880,18.97,0.06,0.0623,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4885, RA-DEC 01:29:02.3-73:28:48.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7881,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7881,18.97,0.06,0.0624,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1237, RA-DEC 00:48:55.4-72:49:37.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7882,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7882,18.97,0.06,0.0624,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3202, RA-DEC 01:00:58.9-72:04:04.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7883,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7883,18.97,0.06,0.0624,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0856, RA-DEC 00:46:20.6-71:56:55.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7884,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7884,18.97,0.06,0.0624,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1693, RA-DEC 00:51:27.4-72:51:35.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7885,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7885,18.97,0.06,0.0624,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2950, RA-DEC 00:59:11.9-72:55:18.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7886,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7886,18.97,0.06,0.0624,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3675, RA-DEC 01:04:52.4-73:01:38.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7887,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7887,18.97,0.06,0.0624,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4614, RA-DEC 01:22:49.3-72:24:59.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7888,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7888,18.98,0.06,0.0624,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1293, RA-DEC 00:49:16.3-73:05:27.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7889,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7889,18.98,0.06,0.0624,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1385, RA-DEC 00:49:44.6-73:08:23.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7890,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7890,18.98,0.06,0.0624,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2175, RA-DEC 00:54:06.4-73:24:58.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7891,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7891,18.98,0.06,0.0624,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3134, RA-DEC 01:00:30.1-73:19:17.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7892,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7892,18.98,0.06,0.0624,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3334, RA-DEC 01:02:00.9-72:32:40.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7893,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7893,18.98,0.06,0.0624,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3865, RA-DEC 01:06:41.5-73:54:22.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7894,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7894,18.98,0.06,0.0624,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4109, RA-DEC 01:09:17.6-71:33:38.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7895,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7895,18.98,0.06,0.0624,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1130, RA-DEC 00:48:14.5-72:47:39.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7896,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7896,18.98,0.06,0.0624,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1624, RA-DEC 00:51:10.5-73:13:04.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7897,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7897,18.98,0.06,0.0624,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3652, RA-DEC 01:04:38.1-71:27:56.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7898,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7898,18.98,0.06,0.0624,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0915, RA-DEC 00:46:50.4-72:32:36.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7899,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7899,18.98,0.06,0.0624,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3273, RA-DEC 01:01:32.6-73:59:26.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7900,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7900,18.98,0.06,0.0624,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1142, RA-DEC 00:48:17.6-72:49:39.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7901,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7901,18.98,0.06,0.0624,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1213, RA-DEC 00:48:47.9-73:33:22.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7902,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7902,18.98,0.06,0.0624,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2956, RA-DEC 00:59:12.9-71:48:13.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7903,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7903,18.98,0.06,0.0624,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3510, RA-DEC 01:03:30.4-72:51:09.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7904,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7904,18.98,0.06,0.0624,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2270, RA-DEC 00:54:42.0-73:04:14.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7905,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7905,18.98,0.06,0.0624,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4731, RA-DEC 00:52:14.6-71:32:43.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7906,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7906,18.98,0.06,0.0624,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1541, RA-DEC 00:50:47.0-73:29:10.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7907,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7907,18.98,0.06,0.0624,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1770, RA-DEC 00:51:55.4-72:42:46.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7908,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7908,18.98,0.06,0.0624,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2770, RA-DEC 00:58:02.5-71:24:57.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7909,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7909,18.98,0.06,0.0624,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3669, RA-DEC 01:04:48.0-74:10:22.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7910,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7910,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0353, RA-DEC 00:40:27.3-72:59:51.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7911,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7911,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1214, RA-DEC 00:48:47.9-73:16:37.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7912,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7912,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3143, RA-DEC 01:00:36.1-71:47:29.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7913,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7913,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4425, RA-DEC 01:13:57.8-73:21:26.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7914,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7914,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1602, RA-DEC 00:51:04.7-74:06:04.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7915,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7915,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2366, RA-DEC 00:55:16.0-71:46:09.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7916,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7916,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2746, RA-DEC 00:57:49.7-72:12:41.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7917,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7917,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3982, RA-DEC 01:07:50.5-72:50:52.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7918,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7918,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4302, RA-DEC 01:11:46.9-72:44:48.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7919,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7919,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1042, RA-DEC 00:47:48.2-73:25:13.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7920,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7920,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1562, RA-DEC 00:50:54.5-72:18:37.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7921,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7921,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2333, RA-DEC 00:55:03.5-72:14:49.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7922,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7922,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2374, RA-DEC 00:55:20.8-71:38:00.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7923,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7923,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2432, RA-DEC 00:55:43.8-72:20:55.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7924,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7924,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3224, RA-DEC 01:01:10.1-71:16:46.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7925,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7925,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4251, RA-DEC 01:11:08.2-71:36:10.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7926,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7926,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4804, RA-DEC 01:07:40.2-71:02:46.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7927,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7927,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1290, RA-DEC 00:49:15.0-73:11:01.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7928,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7928,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1837, RA-DEC 00:52:10.3-73:13:20.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7929,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7929,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2137, RA-DEC 00:53:55.5-72:16:28.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7930,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7930,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4516, RA-DEC 01:16:24.5-72:02:03.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7931,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7931,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4810, RA-DEC 01:08:07.4-71:11:42.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7932,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7932,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1389, RA-DEC 00:49:46.4-73:01:49.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7933,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7933,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1836, RA-DEC 00:52:09.6-73:05:30.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7934,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7934,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3622, RA-DEC 01:04:20.3-72:43:45.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7935,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7935,18.98,0.28,0.0625,2163,NULL,NULL,'PL(V)','SMC',NULL,'1999ASPC..167..275M',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7936,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,7936,18.98,0.08,0.0625,2163,NULL,NULL,'5, W, ISB, Z','SMC',NULL,'2007A&A...476..863F',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7937,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,7937,18.98,0.07,0.0625,2163,NULL,NULL,'HV 00847, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7938,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7938,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0672, RA-DEC 00:44:39.7-73:15:47.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7939,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7939,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1299, RA-DEC 00:49:18.2-72:28:03.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7940,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7940,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2139, RA-DEC 00:53:55.9-73:15:45.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7941,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7941,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3409, RA-DEC 01:02:38.9-73:33:10.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7942,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7942,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4138, RA-DEC 01:09:38.1-72:51:30.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7943,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7943,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4142, RA-DEC 01:09:40.6-73:03:50.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7944,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,7944,18.98,0.09,0.0625,2163,NULL,NULL,'91, J, PL','SMC',NULL,'1987ApJ...321..162W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7945,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7945,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3063, RA-DEC 00:59:56.3-72:55:23.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7946,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7946,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3204, RA-DEC 01:00:59.1-73:36:07.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7947,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7947,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3390, RA-DEC 01:02:29.2-71:20:45.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7948,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7948,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4086, RA-DEC 01:09:03.3-73:36:00.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7949,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7949,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2250, RA-DEC 00:54:36.0-72:45:26.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7950,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7950,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3719, RA-DEC 01:05:17.2-71:51:44.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7951,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7951,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4336, RA-DEC 01:12:19.7-71:34:56.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7952,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7952,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2115, RA-DEC 00:53:47.7-72:55:45.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7953,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7953,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2566, RA-DEC 00:56:34.4-72:31:16.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7954,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7954,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3108, RA-DEC 01:00:18.8-72:13:16.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7955,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7955,18.98,0.06,0.0625,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3398, RA-DEC 01:02:33.9-72:12:41.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7956,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7956,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2055, RA-DEC 00:53:25.3-72:48:35.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7957,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7957,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3401, RA-DEC 01:02:35.7-71:50:34.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7958,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7958,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0603, RA-DEC 00:44:04.1-72:35:22.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7959,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7959,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1417, RA-DEC 00:49:57.2-73:09:41.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7960,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7960,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2372, RA-DEC 00:55:19.3-71:38:52.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7961,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7961,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0849, RA-DEC 00:46:17.3-73:07:33.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7962,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7962,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1128, RA-DEC 00:48:14.1-73:05:02.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7963,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7963,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1748, RA-DEC 00:51:49.0-73:34:55.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7964,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7964,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3351, RA-DEC 01:02:10.2-72:36:15.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7965,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7965,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1196, RA-DEC 00:48:39.3-73:29:23.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7966,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7966,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1642, RA-DEC 00:51:14.7-72:20:48.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7967,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7967,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2623, RA-DEC 00:57:02.1-72:27:54.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7968,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7968,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4190, RA-DEC 01:10:10.0-71:23:07.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7969,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7969,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4570, RA-DEC 01:18:32.5-72:00:37.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7970,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7970,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1361, RA-DEC 00:49:39.5-72:18:12.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7971,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7971,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2198, RA-DEC 00:54:15.5-71:56:14.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7972,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7972,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3606, RA-DEC 01:04:13.8-72:46:45.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7973,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7973,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4344, RA-DEC 01:12:34.7-72:48:12.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7974,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7974,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0528, RA-DEC 00:43:23.1-73:22:46.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7975,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7975,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2149, RA-DEC 00:53:58.1-72:42:14.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7976,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7976,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3177, RA-DEC 01:00:48.0-71:27:25.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7977,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7977,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3642, RA-DEC 01:04:30.1-73:13:08.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7978,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7978,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1190, RA-DEC 00:48:36.4-72:22:24.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7979,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7979,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3860, RA-DEC 01:06:36.5-72:06:39.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7980,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7980,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0456, RA-DEC 00:42:18.8-73:29:01.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7981,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7981,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3902, RA-DEC 01:07:03.3-72:59:06.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7982,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7982,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4590, RA-DEC 01:20:07.7-72:54:18.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7983,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7983,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0491, RA-DEC 00:42:56.4-72:45:24.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7984,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7984,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1087, RA-DEC 00:48:00.5-73:29:04.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7985,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7985,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1618, RA-DEC 00:51:09.2-72:19:52.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7986,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7986,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2539, RA-DEC 00:56:25.1-71:46:30.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7987,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7987,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3694, RA-DEC 01:05:02.6-73:24:59.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7988,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7988,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3799, RA-DEC 01:06:00.8-71:41:38.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7989,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7989,18.98,0.06,0.0626,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4533, RA-DEC 01:16:58.2-73:43:10.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7990,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7990,18.98,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0888, RA-DEC 00:46:34.8-73:14:21.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7991,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7991,18.98,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2025, RA-DEC 00:53:16.7-72:28:10.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7992,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7992,18.98,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4707, RA-DEC 00:43:57.4-72:03:22.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7993,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7993,18.98,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0996, RA-DEC 00:47:31.4-72:45:51.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7994,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7994,18.98,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1325, RA-DEC 00:49:24.9-73:32:44.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7995,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7995,18.98,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1484, RA-DEC 00:50:22.9-72:34:06.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7996,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7996,18.98,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1582, RA-DEC 00:50:58.4-73:31:09.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7997,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7997,18.98,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1975, RA-DEC 00:52:55.6-72:17:47.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7998,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7998,18.98,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2538, RA-DEC 00:56:23.8-72:50:32.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7999,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',7999,18.98,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4843, RA-DEC 01:15:49.3-70:32:44.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8000,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8000,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2075, RA-DEC 00:53:33.2-72:15:02.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8001,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8001,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4784, RA-DEC 01:04:27.4-72:08:34.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8002,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8002,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1552, RA-DEC 00:50:51.2-73:58:22.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8003,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8003,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1579, RA-DEC 00:50:57.9-73:35:08.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8004,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8004,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2159, RA-DEC 00:54:00.8-71:42:10.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8005,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8005,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3218, RA-DEC 01:01:07.2-73:23:55.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8006,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8006,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2232, RA-DEC 00:54:30.0-73:15:20.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8007,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8007,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3871, RA-DEC 01:06:45.7-73:16:23.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8008,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8008,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4728, RA-DEC 00:50:24.3-72:20:12.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8009,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8009,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1879, RA-DEC 00:52:22.3-72:15:26.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8010,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8010,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2781, RA-DEC 00:58:06.4-73:17:06.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8011,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8011,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4833, RA-DEC 01:13:20.5-75:22:37.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8012,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,8012,18.99,0.07,0.0627,2163,NULL,NULL,'HV 01328, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8013,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8013,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1106, RA-DEC 00:48:06.2-72:49:40.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8014,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8014,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3168, RA-DEC 01:00:43.7-72:50:05.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8015,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8015,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4165, RA-DEC 01:09:53.6-73:11:34.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8016,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8016,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4559, RA-DEC 01:18:01.9-72:06:13.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8017,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8017,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1532, RA-DEC 00:50:42.7-73:15:47.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8018,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8018,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3131, RA-DEC 01:00:29.3-72:03:22.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8019,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8019,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4405, RA-DEC 01:13:38.0-73:58:51.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8020,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8020,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4457, RA-DEC 01:14:44.8-72:50:21.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8021,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8021,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4790, RA-DEC 01:05:33.3-71:00:43.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8022,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8022,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0535, RA-DEC 00:43:27.1-73:18:28.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8023,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8023,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0929, RA-DEC 00:46:55.4-72:44:43.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8024,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8024,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1171, RA-DEC 00:48:31.2-72:42:07.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8025,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8025,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1388, RA-DEC 00:49:45.8-72:26:49.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8026,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8026,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2601, RA-DEC 00:56:49.6-72:40:46.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8027,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8027,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3368, RA-DEC 01:02:17.8-71:16:53.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8028,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8028,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3744, RA-DEC 01:05:29.8-73:25:03.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8029,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8029,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3889, RA-DEC 01:06:58.7-73:51:25.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8030,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8030,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4281, RA-DEC 01:11:34.7-72:41:01.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8031,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8031,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1076, RA-DEC 00:47:58.1-72:42:41.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8032,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8032,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1655, RA-DEC 00:51:20.0-72:34:14.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8033,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8033,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3899, RA-DEC 01:07:02.4-72:51:19.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8034,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8034,18.99,0.06,0.0627,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4230, RA-DEC 01:10:49.3-72:47:33.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8035,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8035,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0187, RA-DEC 00:34:37.0-73:38:16.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8036,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8036,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0733, RA-DEC 00:45:14.5-73:12:37.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8037,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8037,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2794, RA-DEC 00:58:12.0-71:47:05.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8038,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8038,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3001, RA-DEC 00:59:30.2-72:38:56.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8039,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8039,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3919, RA-DEC 01:07:11.6-74:11:32.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8040,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8040,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0396, RA-DEC 00:41:15.1-73:05:22.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8041,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8041,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1183, RA-DEC 00:48:33.7-72:43:29.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8042,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8042,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2017, RA-DEC 00:53:14.1-73:01:47.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8043,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8043,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2382, RA-DEC 00:55:22.1-72:55:38.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8044,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8044,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4633, RA-DEC 23:51:19.5-72:41:29.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8045,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8045,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2060, RA-DEC 00:53:27.2-73:06:42.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8046,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8046,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4130, RA-DEC 01:09:28.6-73:59:12.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8047,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8047,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2575, RA-DEC 00:56:37.6-71:40:14.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8048,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8048,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2592, RA-DEC 00:56:45.8-71:48:11.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8049,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8049,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2848, RA-DEC 00:58:35.0-73:26:33.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8050,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8050,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1632, RA-DEC 00:51:11.3-72:53:01.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8051,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8051,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1774, RA-DEC 00:51:55.9-72:57:11.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8052,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8052,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2922, RA-DEC 00:59:01.3-71:45:07.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8053,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8053,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3017, RA-DEC 00:59:36.9-71:55:21.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8054,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8054,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3488, RA-DEC 01:03:19.3-73:22:06.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8055,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8055,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4014, RA-DEC 01:08:09.9-72:25:48.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8056,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8056,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4424, RA-DEC 01:13:54.7-71:37:18.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8057,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8057,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1660, RA-DEC 00:51:20.9-73:40:36.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8058,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8058,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2497, RA-DEC 00:56:06.4-72:27:12.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8059,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8059,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3091, RA-DEC 01:00:12.0-72:30:52.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8060,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8060,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3101, RA-DEC 01:00:16.4-72:38:28.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8061,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8061,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3697, RA-DEC 01:05:03.8-72:51:53.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8062,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,8062,18.99,0.03,0.0628,2163,NULL,NULL,'92, K','SMC',NULL,'2016ApJ...816...49S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8063,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,8063,18.99,0.02,0.0628,2163,NULL,NULL,'92, 3.6 micron','SMC',NULL,'2016ApJ...816...49S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8064,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,8064,18.99,0.07,0.0628,2163,NULL,NULL,'HV 02189, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8065,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,8065,18.99,0.05,0.0628,2163,NULL,NULL,'HST KP Calibrated','SMC',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8066,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8066,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0138, RA-DEC 00:31:28.3-72:45:19.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8067,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8067,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1640, RA-DEC 00:51:13.8-73:06:12.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8068,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8068,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1725, RA-DEC 00:51:39.7-73:31:15.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8069,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8069,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2467, RA-DEC 00:55:55.2-72:37:05.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8070,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8070,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3548, RA-DEC 01:03:51.7-71:40:35.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8071,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8071,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4055, RA-DEC 01:08:42.0-72:51:21.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8072,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8072,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0287, RA-DEC 00:38:32.4-73:07:04.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8073,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8073,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0823, RA-DEC 00:46:07.3-72:54:00.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8074,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8074,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3029, RA-DEC 00:59:41.9-72:55:03.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8075,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8075,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3766, RA-DEC 01:05:44.8-72:53:48.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8076,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8076,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1383, RA-DEC 00:49:44.3-73:13:06.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8077,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8077,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2121, RA-DEC 00:53:49.2-73:10:02.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8078,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8078,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2533, RA-DEC 00:56:20.9-73:23:14.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8079,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8079,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2962, RA-DEC 00:59:14.8-73:05:03.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8080,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8080,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3189, RA-DEC 01:00:52.4-73:08:33.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8081,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8081,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3946, RA-DEC 01:07:25.6-73:16:37.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8082,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8082,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2144, RA-DEC 00:53:57.1-73:16:40.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8083,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8083,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2970, RA-DEC 00:59:19.0-72:55:40.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8084,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8084,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3459, RA-DEC 01:03:05.3-71:57:24.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8085,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8085,18.99,0.06,0.0628,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4082, RA-DEC 01:09:00.0-71:52:13.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8086,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8086,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0776, RA-DEC 00:45:43.7-73:23:55.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8087,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8087,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1844, RA-DEC 00:52:13.9-71:41:41.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8088,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8088,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2514, RA-DEC 00:56:11.6-73:09:47.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8089,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8089,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4223, RA-DEC 01:10:41.8-71:28:59.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8090,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8090,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0954, RA-DEC 00:47:09.0-72:43:34.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8091,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8091,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1819, RA-DEC 00:52:05.3-73:02:46.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8092,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8092,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3381, RA-DEC 01:02:26.8-71:44:29.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8093,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8093,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3523, RA-DEC 01:03:36.7-71:51:46.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8094,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8094,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4157, RA-DEC 01:09:49.5-71:20:02.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8095,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8095,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4167, RA-DEC 01:09:57.2-71:25:59.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8096,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8096,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4476, RA-DEC 01:15:12.1-72:34:38.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8097,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8097,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4507, RA-DEC 01:16:05.5-72:20:50.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8098,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8098,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1635, RA-DEC 00:51:11.7-73:11:29.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8099,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8099,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2761, RA-DEC 00:57:58.0-73:43:17.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8100,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8100,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3783, RA-DEC 01:05:51.7-72:53:33.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8101,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8101,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4438, RA-DEC 01:14:18.1-72:18:26.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8102,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8102,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0908, RA-DEC 00:46:46.4-72:20:34.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8103,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8103,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1205, RA-DEC 00:48:45.5-72:50:32.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8104,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8104,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1773, RA-DEC 00:51:55.7-73:15:34.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8105,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8105,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3047, RA-DEC 00:59:49.5-73:26:40.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8106,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8106,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3449, RA-DEC 01:02:59.9-73:56:07.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8107,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8107,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4205, RA-DEC 01:10:26.3-71:31:10.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8108,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8108,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4468, RA-DEC 01:15:03.3-72:41:20.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8109,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8109,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4495, RA-DEC 01:15:45.4-71:43:26.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8110,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8110,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4889, RA-DEC 01:29:46.7-71:09:55.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8111,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8111,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1495, RA-DEC 00:50:26.9-73:25:00.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8112,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8112,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2118, RA-DEC 00:53:48.8-73:01:06.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8113,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8113,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2815, RA-DEC 00:58:21.2-72:02:39.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8114,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8114,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3751, RA-DEC 01:05:35.4-72:46:12.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8115,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8115,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1051, RA-DEC 00:47:51.4-73:12:54.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8116,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8116,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1173, RA-DEC 00:48:31.5-72:33:26.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8117,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8117,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1962, RA-DEC 00:52:52.7-72:26:07.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8118,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8118,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3104, RA-DEC 01:00:17.8-72:08:07.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8119,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8119,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2586, RA-DEC 00:56:42.5-73:21:39.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8120,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8120,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2688, RA-DEC 00:57:27.1-73:04:39.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8121,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8121,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2762, RA-DEC 00:57:58.7-71:36:36.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8122,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8122,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2259, RA-DEC 00:54:39.4-71:42:15.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8123,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8123,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3975, RA-DEC 01:07:44.0-72:19:22.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8124,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8124,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4079, RA-DEC 01:08:57.7-72:51:05.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8125,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8125,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1873, RA-DEC 00:52:20.9-73:27:19.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8126,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8126,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3877, RA-DEC 01:06:49.0-71:29:22.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8127,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8127,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0571, RA-DEC 00:43:47.5-73:20:07.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8128,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8128,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1810, RA-DEC 00:52:03.5-72:47:00.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8129,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8129,18.99,0.06,0.0629,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2218, RA-DEC 00:54:22.7-73:07:44.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8130,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8130,18.99,0.06,0.063,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0832, RA-DEC 00:46:11.8-73:07:48.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8131,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8131,18.99,0.06,0.063,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1319, RA-DEC 00:49:23.0-73:02:35.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8132,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8132,18.99,0.06,0.063,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1880, RA-DEC 00:52:22.8-72:14:55.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8133,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8133,18.99,0.06,0.063,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2005, RA-DEC 00:53:09.7-71:46:40.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8134,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8134,19,0.06,0.063,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2094, RA-DEC 00:53:41.1-72:09:33.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8135,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8135,19,0.06,0.063,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2874, RA-DEC 00:58:45.4-72:08:01.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8136,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8136,19,0.06,0.063,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4397, RA-DEC 01:13:29.9-71:39:52.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8137,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8137,19,0.06,0.063,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0891, RA-DEC 00:46:36.1-72:32:54.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8138,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8138,19,0.06,0.063,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3780, RA-DEC 01:05:50.4-71:22:49.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8139,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8139,19,0.06,0.063,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3981, RA-DEC 01:07:48.3-71:30:26.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8140,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8140,19,0.06,0.063,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4261, RA-DEC 01:11:17.0-73:51:49.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8141,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8141,19,0.06,0.063,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0824, RA-DEC 00:46:07.6-73:35:22.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8142,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8142,19,0.06,0.063,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1108, RA-DEC 00:48:06.5-73:03:34.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8143,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8143,19,0.06,0.063,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1315, RA-DEC 00:49:22.4-72:52:54.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8144,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8144,19,0.06,0.063,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3116, RA-DEC 01:00:21.3-73:21:44.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8145,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8145,19,0.06,0.063,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3294, RA-DEC 01:01:44.2-71:39:24.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8146,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8146,19,0.06,0.063,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4262, RA-DEC 01:11:17.1-71:32:57.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8147,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,8147,19,0.03,0.063,2163,NULL,NULL,'VK(BW)','SMC',NULL,'1997ApJ...486...60D',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8148,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,8148,19,0.03,0.063,2163,NULL,NULL,'VI(BW)','SMC',NULL,'1997ApJ...486...60D',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8149,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,8149,18.98,0.02,0.063,2163,NULL,NULL,'78, UBVRIJHK','SMC',NULL,'1997ApJ...491...13K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8150,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,'R',8150,19,0.03,0.063,2163,NULL,NULL,'BVRI+','SMC',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8151,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,8151,18.98,0.28,0.063,2163,NULL,NULL,'V, PL','SMC',NULL,'1999ApJ...512..711B',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8152,'Cepheids','2016-12-15 15:13:37','2016-12-16 11:18:39','1',NULL,NULL,8152,18.99,0.05,0.063,2163,NULL,NULL,'91, JHK','SMC',NULL,'2000ApJS..128..431F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8153,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,NULL,8153,19.01,0.13,0.063,2163,NULL,NULL,'VI','SMC',NULL,'2002ApJ...574L..33B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8154,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,NULL,8154,18.99,0.05,0.063,2163,NULL,NULL,'LMC VIHJK','SMC',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8155,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,NULL,8155,19,0.07,0.063,2163,NULL,NULL,'HV 01482, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8156,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8156,19,0.06,0.063,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0376, RA-DEC 00:40:46.8-73:57:49.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8157,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8157,19,0.06,0.063,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0459, RA-DEC 00:42:20.7-73:09:28.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8158,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8158,19,0.06,0.063,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1804, RA-DEC 00:52:01.9-72:09:38.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8159,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8159,19,0.06,0.063,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1834, RA-DEC 00:52:09.2-72:12:03.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8160,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8160,19,0.06,0.063,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2154, RA-DEC 00:53:58.9-71:42:33.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8161,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8161,19,0.06,0.063,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2282, RA-DEC 00:54:48.9-73:15:37.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8162,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8162,19,0.06,0.063,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4137, RA-DEC 01:09:37.0-72:57:41.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8163,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8163,19,0.06,0.063,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4844, RA-DEC 01:16:03.3-70:54:47.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8164,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8164,19,0.06,0.063,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1513, RA-DEC 00:50:33.2-73:39:29.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8165,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8165,19,0.06,0.063,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2312, RA-DEC 00:54:58.0-71:52:28.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8166,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8166,19,0.06,0.063,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4313, RA-DEC 01:11:55.7-72:43:18.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8167,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8167,19,0.06,0.063,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0924, RA-DEC 00:46:53.8-72:47:49.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8168,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8168,19,0.06,0.063,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1430, RA-DEC 00:50:01.6-72:44:29.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8169,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8169,19,0.06,0.063,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3090, RA-DEC 01:00:11.8-71:50:50.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8170,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8170,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3213, RA-DEC 01:01:03.0-72:58:53.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8171,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8171,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1465, RA-DEC 00:50:14.1-73:32:39.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8172,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8172,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2503, RA-DEC 00:56:08.8-72:21:16.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8173,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8173,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3335, RA-DEC 01:02:01.5-72:58:58.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8174,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8174,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0392, RA-DEC 00:41:10.4-72:33:17.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8175,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8175,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1661, RA-DEC 00:51:20.9-72:58:04.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8176,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8176,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2595, RA-DEC 00:56:46.6-72:33:40.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8177,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8177,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3098, RA-DEC 01:00:15.4-71:39:35.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8178,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8178,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3564, RA-DEC 01:04:00.0-73:21:42.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8179,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8179,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0665, RA-DEC 00:44:33.8-72:45:22.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8180,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8180,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0904, RA-DEC 00:46:44.0-72:46:42.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8181,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8181,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1509, RA-DEC 00:50:31.1-73:26:49.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8182,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8182,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4053, RA-DEC 01:08:40.8-73:13:03.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8183,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,NULL,8183,19,0.05,0.0631,2163,NULL,NULL,'602, JHKs, LMC PL','SMC',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8184,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8184,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1136, RA-DEC 00:48:15.3-72:38:05.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8185,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8185,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2082, RA-DEC 00:53:36.6-72:38:01.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8186,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8186,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2291, RA-DEC 00:54:51.4-73:10:37.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8187,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8187,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3046, RA-DEC 00:59:49.5-73:12:22.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8188,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8188,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3272, RA-DEC 01:01:32.5-72:50:55.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8189,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8189,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4620, RA-DEC 01:23:56.9-72:43:31.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8190,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,NULL,8190,19,0.03,0.0631,2163,NULL,NULL,'92, H','SMC',NULL,'2016ApJ...816...49S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8191,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,NULL,8191,19,NULL,0.0631,2163,NULL,NULL,NULL,'SMC',NULL,'1988ApJ...326..691F',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8192,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,NULL,8192,19,0.1,0.0631,2163,NULL,NULL,'2522, VI, individual dereddening, Sandage et al. 2004 PL','SMC',NULL,'2012AJ....144..107H',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8193,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8193,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0893, RA-DEC 00:46:37.4-73:12:14.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8194,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8194,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2230, RA-DEC 00:54:28.8-72:24:39.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8195,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8195,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3861, RA-DEC 01:06:37.4-72:04:04.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8196,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8196,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4173, RA-DEC 01:10:00.3-73:12:28.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8197,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8197,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0901, RA-DEC 00:46:40.8-72:45:34.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8198,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8198,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1125, RA-DEC 00:48:13.5-73:11:38.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8199,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8199,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3474, RA-DEC 01:03:13.8-71:25:04.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8200,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8200,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4581, RA-DEC 01:19:23.0-73:55:02.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8201,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8201,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1952, RA-DEC 00:52:49.1-72:39:42.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8202,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8202,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2188, RA-DEC 00:54:10.8-71:23:22.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8203,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8203,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2639, RA-DEC 00:57:07.1-73:28:37.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8204,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8204,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2839, RA-DEC 00:58:29.7-73:30:45.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8205,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8205,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3285, RA-DEC 01:01:41.8-73:16:50.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8206,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8206,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1111, RA-DEC 00:48:07.4-73:04:53.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8207,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8207,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2191, RA-DEC 00:54:11.9-72:27:06.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8208,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8208,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2570, RA-DEC 00:56:36.0-73:22:03.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8209,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8209,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3609, RA-DEC 01:04:15.2-71:27:32.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8210,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8210,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4013, RA-DEC 01:08:08.7-71:17:24.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8211,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8211,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4180, RA-DEC 01:10:04.6-74:02:48.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8212,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8212,19,0.06,0.0631,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4733, RA-DEC 00:52:34.9-74:50:26.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8213,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8213,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1330, RA-DEC 00:49:27.1-72:41:23.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8214,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8214,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1423, RA-DEC 00:50:00.1-72:37:42.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8215,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8215,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1535, RA-DEC 00:50:43.3-74:31:15.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8216,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8216,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2501, RA-DEC 00:56:07.0-72:04:47.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8217,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8217,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3602, RA-DEC 01:04:11.9-72:58:42.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8218,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8218,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3637, RA-DEC 01:04:27.4-73:21:33.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8219,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8219,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4612, RA-DEC 01:22:42.9-72:13:48.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8220,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8220,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2982, RA-DEC 00:59:23.8-73:32:16.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8221,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8221,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4435, RA-DEC 01:14:16.1-71:30:52.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8222,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8222,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4522, RA-DEC 01:16:32.8-72:05:17.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8223,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8223,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0487, RA-DEC 00:42:55.4-73:21:08.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8224,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8224,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0632, RA-DEC 00:44:21.3-72:32:34.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8225,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8225,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1926, RA-DEC 00:52:37.1-72:49:37.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8226,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8226,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0433, RA-DEC 00:41:56.3-72:56:39.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8227,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8227,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0768, RA-DEC 00:45:38.9-72:55:50.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8228,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8228,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3316, RA-DEC 01:01:52.8-72:56:16.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8229,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8229,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3461, RA-DEC 01:03:07.7-71:26:34.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8230,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8230,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0635, RA-DEC 00:44:23.5-73:28:57.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8231,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8231,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2027, RA-DEC 00:53:16.9-71:50:53.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8232,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8232,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2284, RA-DEC 00:54:49.9-73:15:00.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8233,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8233,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3595, RA-DEC 01:04:09.8-71:23:51.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8234,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8234,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3879, RA-DEC 01:06:49.7-72:29:30.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8235,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8235,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0758, RA-DEC 00:45:30.8-73:15:52.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8236,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8236,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2655, RA-DEC 00:57:13.3-72:42:34.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8237,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8237,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2716, RA-DEC 00:57:38.2-71:16:13.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8238,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8238,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2835, RA-DEC 00:58:28.8-72:19:57.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8239,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8239,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1393, RA-DEC 00:49:47.6-74:27:12.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8240,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8240,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2203, RA-DEC 00:54:16.8-72:31:39.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8241,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8241,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2658, RA-DEC 00:57:15.1-71:49:26.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8242,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8242,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0117, RA-DEC 00:29:46.0-73:57:24.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8243,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8243,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0519, RA-DEC 00:43:12.5-73:19:40.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8244,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8244,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1397, RA-DEC 00:49:49.0-72:51:17.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8245,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8245,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3554, RA-DEC 01:03:54.6-71:58:23.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8246,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8246,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4265, RA-DEC 01:11:20.1-72:01:29.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8247,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8247,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0782, RA-DEC 00:45:50.8-73:27:27.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8248,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8248,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0819, RA-DEC 00:46:04.8-73:14:23.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8249,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8249,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1186, RA-DEC 00:48:35.2-74:11:11.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8250,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8250,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2663, RA-DEC 00:57:15.9-71:50:32.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8251,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8251,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3093, RA-DEC 01:00:13.2-73:15:42.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8252,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8252,19,0.06,0.0632,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3844, RA-DEC 01:06:27.1-73:17:32.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8253,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8253,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1184, RA-DEC 00:48:34.6-73:09:20.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8254,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8254,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1621, RA-DEC 00:51:09.5-73:01:48.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8255,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8255,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2106, RA-DEC 00:53:44.4-73:27:54.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8256,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8256,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2980, RA-DEC 00:59:22.8-73:51:21.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8257,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8257,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1637, RA-DEC 00:51:13.5-73:09:29.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8258,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8258,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2872, RA-DEC 00:58:43.6-73:22:10.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8259,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8259,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3286, RA-DEC 01:01:42.5-72:55:13.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8260,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8260,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0304, RA-DEC 00:39:08.8-72:58:39.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8261,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8261,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1545, RA-DEC 00:50:48.0-72:42:29.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8262,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8262,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3201, RA-DEC 01:00:58.0-71:52:35.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8263,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8263,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3355, RA-DEC 01:02:12.7-73:20:49.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8264,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8264,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3850, RA-DEC 01:06:30.7-73:15:56.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8265,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8265,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2873, RA-DEC 00:58:45.3-71:40:34.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8266,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8266,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3183, RA-DEC 01:00:49.6-73:15:43.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8267,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8267,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3210, RA-DEC 01:01:02.0-72:16:16.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8268,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8268,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3953, RA-DEC 01:07:30.0-72:38:22.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8269,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8269,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0711, RA-DEC 00:45:04.9-72:56:11.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8270,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8270,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1297, RA-DEC 00:49:16.9-72:23:41.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8271,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8271,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1649, RA-DEC 00:51:17.0-72:50:42.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8272,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8272,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3393, RA-DEC 01:02:30.7-72:55:59.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8273,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8273,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3550, RA-DEC 01:03:52.4-72:05:28.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8274,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8274,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4267, RA-DEC 01:11:22.8-71:35:47.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8275,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8275,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1932, RA-DEC 00:52:39.1-73:10:53.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8276,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8276,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2395, RA-DEC 00:55:29.4-73:04:10.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8277,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8277,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2483, RA-DEC 00:56:02.4-73:36:59.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8278,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8278,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3727, RA-DEC 01:05:21.3-73:42:28.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8279,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8279,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0019, RA-DEC 00:23:10.0-73:31:26.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8280,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8280,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4387, RA-DEC 01:13:21.8-71:38:37.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8281,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8281,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0876, RA-DEC 00:46:30.8-72:49:43.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8282,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8282,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2043, RA-DEC 00:53:21.8-72:44:51.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8283,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8283,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2288, RA-DEC 00:54:50.5-72:36:59.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8284,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8284,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2636, RA-DEC 00:57:05.3-72:08:59.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8285,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8285,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3176, RA-DEC 01:00:47.4-72:20:45.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8286,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8286,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4431, RA-DEC 01:14:09.9-71:40:24.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8287,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8287,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4845, RA-DEC 01:16:33.4-75:44:54.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8288,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8288,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0090, RA-DEC 00:28:24.7-72:28:37.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8289,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8289,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1854, RA-DEC 00:52:16.4-73:07:42.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8290,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8290,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2561, RA-DEC 00:56:32.6-73:01:03.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8291,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8291,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3007, RA-DEC 00:59:32.5-71:39:56.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8292,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8292,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3069, RA-DEC 00:59:58.6-72:02:33.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8293,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8293,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3774, RA-DEC 01:05:48.5-72:20:58.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8294,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8294,19.01,0.06,0.0633,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4349, RA-DEC 01:12:40.3-72:35:52.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8295,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8295,19.01,0.06,0.0634,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0846, RA-DEC 00:46:16.7-72:47:38.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8296,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8296,19.01,0.06,0.0634,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1189, RA-DEC 00:48:35.9-72:38:09.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8297,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8297,19.01,0.06,0.0634,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1519, RA-DEC 00:50:35.4-72:39:12.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8298,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8298,19.01,0.06,0.0634,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4119, RA-DEC 01:09:20.8-72:47:13.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8299,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8299,19.01,0.06,0.0634,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1226, RA-DEC 00:48:52.0-72:37:55.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8300,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8300,19.01,0.06,0.0634,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1287, RA-DEC 00:49:13.8-73:23:49.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8301,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8301,19.01,0.06,0.0634,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3693, RA-DEC 01:05:02.1-72:42:44.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8302,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8302,19.01,0.06,0.0634,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2059, RA-DEC 00:53:27.2-72:31:29.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8303,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8303,19.01,0.06,0.0634,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2096, RA-DEC 00:53:41.5-72:17:04.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8304,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8304,19.01,0.06,0.0634,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2911, RA-DEC 00:58:57.8-74:05:33.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8305,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8305,19.01,0.06,0.0634,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4350, RA-DEC 01:12:41.2-71:29:05.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8306,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8306,19.01,0.06,0.0634,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0254, RA-DEC 00:37:26.5-73:56:08.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8307,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8307,19.01,0.06,0.0634,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1181, RA-DEC 00:48:33.3-73:16:28.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8308,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8308,19.01,0.06,0.0634,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1525, RA-DEC 00:50:38.8-72:20:24.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8309,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8309,19.01,0.06,0.0634,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2522, RA-DEC 00:56:15.9-71:49:50.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8310,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8310,19.01,0.06,0.0634,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3710, RA-DEC 01:05:11.1-72:26:31.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8311,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8311,19.01,0.06,0.0634,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1099, RA-DEC 00:48:03.9-72:39:01.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8312,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8312,19.01,0.06,0.0634,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1794, RA-DEC 00:52:00.0-73:08:08.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8313,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8313,19.01,0.06,0.0634,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2913, RA-DEC 00:58:59.3-72:39:00.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8314,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8314,19.01,0.06,0.0634,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2989, RA-DEC 00:59:26.6-72:26:49.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8315,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8315,19.01,0.06,0.0634,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3300, RA-DEC 01:01:46.6-73:02:47.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8316,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,NULL,8316,19.01,0.03,0.0634,2163,NULL,NULL,'92, J','SMC',NULL,'2016ApJ...816...49S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8317,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8317,19.01,NULL,0.0634,2163,NULL,NULL,'assuming E(B-V) = 0.10 mag','SMC',NULL,'1982PhDT........42M',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8318,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8318,19.01,0.06,0.0634,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1074, RA-DEC 00:47:58.0-72:34:59.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8319,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8319,19.01,0.06,0.0634,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1851, RA-DEC 00:52:16.0-73:35:15.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8320,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8320,19.01,0.06,0.0634,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3583, RA-DEC 01:04:06.3-73:20:03.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8321,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8321,19.01,0.06,0.0634,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4355, RA-DEC 01:12:43.9-73:54:59.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8322,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8322,19.01,0.06,0.0634,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1368, RA-DEC 00:49:41.4-72:35:28.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8323,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8323,19.01,0.06,0.0634,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3728, RA-DEC 01:05:21.4-72:05:36.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8324,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8324,19.01,0.06,0.0634,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1657, RA-DEC 00:51:20.5-72:15:14.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8325,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8325,19.01,0.06,0.0634,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2293, RA-DEC 00:54:52.3-72:32:00.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8326,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8326,19.01,0.06,0.0634,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2837, RA-DEC 00:58:28.9-72:26:39.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8327,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8327,19.01,0.06,0.0634,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4054, RA-DEC 01:08:41.8-72:47:59.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8328,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8328,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0514, RA-DEC 00:43:05.9-73:04:56.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8329,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8329,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0844, RA-DEC 00:46:15.9-72:47:27.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8330,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8330,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2550, RA-DEC 00:56:29.0-73:10:45.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8331,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8331,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3025, RA-DEC 00:59:40.1-73:22:14.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8332,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8332,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1365, RA-DEC 00:49:40.9-73:14:07.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8333,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8333,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2546, RA-DEC 00:56:28.3-72:14:32.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8334,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8334,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3709, RA-DEC 01:05:10.7-73:30:53.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8335,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8335,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4107, RA-DEC 01:09:16.9-71:33:35.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8336,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8336,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2600, RA-DEC 00:56:49.5-71:34:25.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8337,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8337,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2691, RA-DEC 00:57:29.1-72:29:38.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8338,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8338,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3825, RA-DEC 01:06:17.0-71:43:47.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8339,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8339,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4491, RA-DEC 01:15:42.4-73:48:24.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8340,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8340,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0626, RA-DEC 00:44:18.6-73:35:22.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8341,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8341,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1892, RA-DEC 00:52:28.2-72:53:10.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8342,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8342,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2682, RA-DEC 00:57:25.0-72:41:22.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8343,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8343,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0790, RA-DEC 00:45:53.6-72:49:45.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8344,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8344,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1262, RA-DEC 00:49:05.6-72:45:35.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8345,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8345,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2482, RA-DEC 00:56:02.1-72:17:38.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8346,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8346,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2979, RA-DEC 00:59:22.6-72:16:48.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8347,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8347,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3255, RA-DEC 01:01:24.0-72:07:00.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8348,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8348,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0558, RA-DEC 00:43:39.2-72:52:29.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8349,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8349,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1830, RA-DEC 00:52:08.9-73:48:20.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8350,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8350,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2219, RA-DEC 00:54:22.7-73:00:13.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8351,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8351,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2627, RA-DEC 00:57:03.5-73:05:45.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8352,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8352,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4149, RA-DEC 01:09:42.8-71:49:29.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8353,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8353,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1647, RA-DEC 00:51:16.5-72:21:33.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8354,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8354,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3127, RA-DEC 01:00:27.5-73:22:41.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8355,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8355,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1053, RA-DEC 00:47:51.4-72:57:15.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8356,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8356,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1236, RA-DEC 00:48:55.3-73:11:38.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8357,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8357,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2948, RA-DEC 00:59:11.5-73:11:18.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8358,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8358,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3234, RA-DEC 01:01:15.4-73:46:36.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8359,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8359,19.01,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3853, RA-DEC 01:06:32.5-71:55:16.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8360,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8360,19.02,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2498, RA-DEC 00:56:07.0-72:07:18.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8361,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8361,19.02,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3960, RA-DEC 01:07:34.0-73:07:15.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8362,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8362,19.02,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4008, RA-DEC 01:08:07.2-72:55:39.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8363,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8363,19.02,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4048, RA-DEC 01:08:34.8-72:36:02.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8364,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8364,19.02,0.06,0.0635,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4809, RA-DEC 01:07:58.9-74:17:46.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8365,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8365,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0864, RA-DEC 00:46:24.1-73:07:51.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8366,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8366,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1534, RA-DEC 00:50:43.2-73:02:48.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8367,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8367,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2034, RA-DEC 00:53:18.9-71:52:09.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8368,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8368,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3749, RA-DEC 01:05:34.1-72:09:53.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8369,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8369,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4872, RA-DEC 01:25:33.0-70:45:34.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8370,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8370,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0278, RA-DEC 00:38:15.0-72:55:33.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8371,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8371,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2056, RA-DEC 00:53:25.9-72:37:40.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8372,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8372,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2644, RA-DEC 00:57:08.6-71:40:05.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8373,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8373,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4051, RA-DEC 01:08:39.1-72:28:29.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8374,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8374,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4579, RA-DEC 01:19:18.5-73:38:12.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8375,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8375,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1963, RA-DEC 00:52:52.9-72:32:46.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8376,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8376,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2031, RA-DEC 00:53:18.3-73:06:54.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8377,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8377,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2406, RA-DEC 00:55:33.5-71:45:44.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8378,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8378,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4640, RA-DEC 00:10:24.1-75:10:37.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8379,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8379,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4795, RA-DEC 01:06:30.0-71:08:04.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8380,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8380,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2090, RA-DEC 00:53:39.3-72:54:35.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8381,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8381,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3088, RA-DEC 01:00:11.2-72:55:17.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8382,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8382,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4278, RA-DEC 01:11:29.6-71:40:38.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8383,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8383,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4735, RA-DEC 00:53:00.0-75:00:10.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8384,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8384,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2308, RA-DEC 00:54:57.1-72:40:38.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8385,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8385,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3216, RA-DEC 01:01:04.6-72:41:49.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8386,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8386,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0622, RA-DEC 00:44:15.9-73:23:55.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8387,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8387,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1059, RA-DEC 00:47:53.2-73:14:11.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8388,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8388,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1304, RA-DEC 00:49:19.2-73:25:25.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8389,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8389,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1917, RA-DEC 00:52:35.2-73:17:11.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8390,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8390,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4917, RA-DEC 01:38:57.7-71:45:14.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8391,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,NULL,8391,19.02,0.07,0.0636,2163,NULL,NULL,'HV 06320, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8392,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8392,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0724, RA-DEC 00:45:12.4-72:57:36.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8393,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8393,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0770, RA-DEC 00:45:40.2-73:34:16.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8394,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8394,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1260, RA-DEC 00:49:05.4-73:29:01.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8395,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8395,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1833, RA-DEC 00:52:09.2-72:45:57.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8396,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8396,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2621, RA-DEC 00:56:59.9-72:02:05.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8397,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8397,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4158, RA-DEC 01:09:49.8-71:48:33.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8398,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8398,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1709, RA-DEC 00:51:33.9-72:58:46.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8399,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8399,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1923, RA-DEC 00:52:36.5-73:28:47.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8400,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8400,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0673, RA-DEC 00:44:41.0-73:21:48.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8401,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8401,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1049, RA-DEC 00:47:50.8-72:53:51.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8402,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8402,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1518, RA-DEC 00:50:35.0-73:32:08.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8403,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8403,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1610, RA-DEC 00:51:06.1-72:52:30.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8404,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8404,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1820, RA-DEC 00:52:05.9-72:12:02.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8405,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8405,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2077, RA-DEC 00:53:33.9-73:07:28.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8406,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8406,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2864, RA-DEC 00:58:39.4-72:53:48.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8407,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8407,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3011, RA-DEC 00:59:35.4-72:38:24.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8408,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8408,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0572, RA-DEC 00:43:47.7-73:01:57.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8409,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8409,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0857, RA-DEC 00:46:21.2-73:31:03.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8410,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8410,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1029, RA-DEC 00:47:42.9-73:00:46.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8411,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8411,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1134, RA-DEC 00:48:14.9-73:04:18.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8412,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8412,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1674, RA-DEC 00:51:23.4-72:34:41.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8413,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8413,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2182, RA-DEC 00:54:08.6-72:56:34.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8414,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8414,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2391, RA-DEC 00:55:26.5-74:13:33.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8415,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8415,19.02,0.06,0.0636,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3327, RA-DEC 01:01:57.8-72:51:34.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8416,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8416,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2689, RA-DEC 00:57:27.2-73:03:27.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8417,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8417,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2836, RA-DEC 00:58:28.9-72:35:49.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8418,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8418,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4160, RA-DEC 01:09:51.0-72:53:34.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8419,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8419,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4545, RA-DEC 01:17:25.7-73:09:27.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8420,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8420,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0320, RA-DEC 00:39:33.8-73:44:54.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8421,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8421,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1140, RA-DEC 00:48:16.8-73:29:56.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8422,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8422,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1697, RA-DEC 00:51:28.7-73:35:30.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8423,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8423,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2442, RA-DEC 00:55:46.9-73:18:19.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8424,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8424,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3756, RA-DEC 01:05:39.4-71:29:13.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8425,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8425,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1084, RA-DEC 00:48:00.2-72:33:47.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8426,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8426,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1264, RA-DEC 00:49:05.9-73:10:25.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8427,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8427,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2830, RA-DEC 00:58:26.2-73:22:40.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8428,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8428,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0372, RA-DEC 00:40:43.1-73:23:06.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8429,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8429,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0757, RA-DEC 00:45:30.4-73:06:49.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8430,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8430,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0906, RA-DEC 00:46:44.7-72:57:35.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8431,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8431,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0961, RA-DEC 00:47:12.4-72:31:18.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8432,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8432,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2187, RA-DEC 00:54:10.5-73:35:19.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8433,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8433,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2554, RA-DEC 00:56:30.4-71:43:19.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8434,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8434,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2581, RA-DEC 00:56:39.1-72:36:30.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8435,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8435,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2633, RA-DEC 00:57:05.0-72:21:38.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8436,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8436,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2849, RA-DEC 00:58:35.1-72:58:25.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8437,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8437,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4124, RA-DEC 01:09:22.5-71:43:33.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8438,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8438,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0185, RA-DEC 00:34:35.2-73:21:26.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8439,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8439,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0473, RA-DEC 00:42:41.2-73:12:07.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8440,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8440,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1329, RA-DEC 00:49:26.3-72:56:47.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8441,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8441,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2975, RA-DEC 00:59:20.4-73:21:41.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8442,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8442,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3146, RA-DEC 01:00:36.7-73:27:05.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8443,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8443,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3912, RA-DEC 01:07:07.1-72:37:19.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8444,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8444,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1266, RA-DEC 00:49:08.0-72:59:52.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8445,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8445,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1350, RA-DEC 00:49:34.6-73:15:08.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8446,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8446,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2521, RA-DEC 00:56:15.9-71:43:24.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8447,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8447,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3128, RA-DEC 01:00:27.6-72:58:09.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8448,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8448,19.02,0.06,0.0637,2163,NULL,18.493,'2626, VI(W), fundamental-mode','SMC',NULL,'2015MmSAI..86..262I',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8449,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8449,19.02,0.07,0.0637,2163,NULL,18.493,'1644, VI(W), first-overtone','SMC',NULL,'2015MmSAI..86..262I',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8450,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,NULL,8450,19.02,0.22,0.0637,2163,NULL,NULL,'VJ','SMC',NULL,'2008MNRAS.390.1539M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8451,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8451,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1100, RA-DEC 00:48:04.3-72:48:31.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8452,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8452,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1395, RA-DEC 00:49:48.0-73:33:55.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8453,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8453,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1806, RA-DEC 00:52:02.7-73:13:39.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8454,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8454,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3321, RA-DEC 01:01:55.7-73:23:05.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8455,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8455,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3641, RA-DEC 01:04:30.0-72:34:43.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8456,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8456,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3914, RA-DEC 01:07:07.7-71:48:24.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8457,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8457,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4549, RA-DEC 01:17:41.4-73:14:53.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8458,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8458,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1168, RA-DEC 00:48:29.8-73:12:44.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8459,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8459,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1719, RA-DEC 00:51:38.6-73:02:40.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8460,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8460,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2209, RA-DEC 00:54:18.7-72:33:17.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8461,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8461,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0454, RA-DEC 00:42:14.7-73:04:04.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8462,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8462,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1246, RA-DEC 00:49:01.3-73:28:17.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8463,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8463,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1724, RA-DEC 00:51:39.4-73:12:02.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8464,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8464,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2700, RA-DEC 00:57:32.0-72:45:17.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8465,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8465,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3497, RA-DEC 01:03:24.8-72:57:08.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8466,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8466,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0458, RA-DEC 00:42:20.2-72:36:07.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8467,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8467,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0698, RA-DEC 00:45:00.3-73:15:03.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8468,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8468,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2062, RA-DEC 00:53:27.8-73:11:01.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8469,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8469,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2723, RA-DEC 00:57:41.1-72:15:09.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8470,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8470,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3856, RA-DEC 01:06:34.8-72:41:04.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8471,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8471,19.02,0.06,0.0637,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4470, RA-DEC 01:15:04.5-71:37:48.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8472,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8472,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3323, RA-DEC 01:01:56.3-71:19:05.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8473,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8473,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0336, RA-DEC 00:39:56.9-73:01:18.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8474,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8474,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0526, RA-DEC 00:43:21.1-73:08:43.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8475,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8475,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2398, RA-DEC 00:55:31.1-72:51:01.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8476,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8476,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2686, RA-DEC 00:57:26.8-72:25:53.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8477,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8477,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4206, RA-DEC 01:10:26.6-73:29:15.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8478,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8478,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1607, RA-DEC 00:51:05.7-72:28:09.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8479,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8479,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2768, RA-DEC 00:58:01.6-71:44:06.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8480,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8480,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3268, RA-DEC 01:01:31.2-73:12:50.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8481,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8481,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0509, RA-DEC 00:43:04.4-72:48:51.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8482,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8482,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0794, RA-DEC 00:45:56.0-73:09:45.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8483,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8483,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1180, RA-DEC 00:48:33.0-72:25:09.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8484,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8484,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1580, RA-DEC 00:50:58.0-73:10:20.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8485,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8485,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3614, RA-DEC 01:04:16.3-71:45:42.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8486,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8486,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1372, RA-DEC 00:49:42.1-73:09:16.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8487,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8487,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2125, RA-DEC 00:53:50.6-72:54:36.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8488,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8488,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3151, RA-DEC 01:00:38.1-73:36:23.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8489,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8489,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4123, RA-DEC 01:09:21.8-71:47:59.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8490,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8490,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4442, RA-DEC 01:14:22.5-71:46:20.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8491,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8491,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1132, RA-DEC 00:48:14.6-73:31:39.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8492,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8492,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2512, RA-DEC 00:56:11.1-72:52:06.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8493,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8493,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3508, RA-DEC 01:03:29.3-73:08:29.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8494,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8494,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3803, RA-DEC 01:06:04.1-71:30:49.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8495,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8495,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4177, RA-DEC 01:10:02.2-72:23:24.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8496,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8496,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4474, RA-DEC 01:15:07.7-71:52:51.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8497,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8497,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4483, RA-DEC 01:15:31.8-74:05:55.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8498,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8498,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1412, RA-DEC 00:49:55.8-73:31:13.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8499,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8499,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3515, RA-DEC 01:03:32.2-72:48:32.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8500,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:39','1',NULL,'R',8500,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1010, RA-DEC 00:47:36.9-72:25:36.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8501,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8501,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1504, RA-DEC 00:50:29.5-72:42:32.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8502,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8502,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1855, RA-DEC 00:52:16.6-72:35:57.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8503,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8503,19.02,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4798, RA-DEC 01:07:02.9-71:11:42.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8504,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8504,19.03,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0670, RA-DEC 00:44:38.1-73:02:47.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8505,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8505,19.03,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1681, RA-DEC 00:51:24.7-72:56:43.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8506,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8506,19.03,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3916, RA-DEC 01:07:10.7-72:33:27.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8507,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8507,19.03,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4701, RA-DEC 00:41:45.3-72:22:26.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8508,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8508,19.03,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0357, RA-DEC 00:40:28.9-72:52:40.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8509,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8509,19.03,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0889, RA-DEC 00:46:35.0-73:06:44.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8510,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8510,19.03,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3058, RA-DEC 00:59:53.6-72:30:40.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8511,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8511,19.03,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3645, RA-DEC 01:04:30.5-73:41:41.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8512,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8512,19.03,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4456, RA-DEC 01:14:42.7-71:44:19.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8513,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8513,19.03,0.06,0.0638,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4895, RA-DEC 01:31:54.9-69:21:32.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8514,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8514,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1694, RA-DEC 00:51:27.7-72:47:02.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8515,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8515,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3172, RA-DEC 01:00:45.7-72:25:42.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8516,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8516,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3336, RA-DEC 01:02:02.1-72:59:52.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8517,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8517,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4041, RA-DEC 01:08:28.8-71:48:41.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8518,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8518,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0324, RA-DEC 00:39:37.0-74:04:40.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8519,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8519,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0812, RA-DEC 00:46:03.4-73:31:09.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8520,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8520,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1671, RA-DEC 00:51:22.3-73:26:21.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8521,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8521,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3647, RA-DEC 01:04:31.8-72:40:18.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8522,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8522,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4766, RA-DEC 01:00:59.8-71:12:59.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8523,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8523,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0599, RA-DEC 00:44:03.6-73:06:13.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8524,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8524,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1718, RA-DEC 00:51:38.4-72:35:03.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8525,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8525,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1885, RA-DEC 00:52:24.1-73:31:11.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8526,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8526,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4529, RA-DEC 01:16:49.6-72:25:03.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8527,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8527,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0142, RA-DEC 00:31:35.7-73:35:55.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8528,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8528,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0637, RA-DEC 00:44:23.7-72:47:02.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8529,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8529,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3450, RA-DEC 01:03:00.7-73:18:17.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8530,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8530,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3970, RA-DEC 01:07:39.6-73:34:02.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8531,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8531,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0828, RA-DEC 00:46:10.4-73:00:56.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8532,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8532,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3070, RA-DEC 00:59:59.1-72:56:08.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8533,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8533,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4463, RA-DEC 01:14:52.3-71:32:54.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8534,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,NULL,8534,19.03,0.07,0.0639,2163,NULL,NULL,'HV 01873, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8535,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,NULL,8535,19.03,0.07,0.0639,2163,NULL,NULL,'HV 01543, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8536,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8536,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1146, RA-DEC 00:48:20.6-73:30:43.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8537,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8537,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3878, RA-DEC 01:06:49.4-73:27:38.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8538,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8538,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1291, RA-DEC 00:49:15.5-73:23:08.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8539,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8539,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1876, RA-DEC 00:52:21.4-73:14:50.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8540,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8540,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3537, RA-DEC 01:03:43.6-73:04:11.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8541,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8541,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1346, RA-DEC 00:49:33.3-73:06:33.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8542,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8542,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2394, RA-DEC 00:55:28.8-73:29:56.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8543,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8543,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1013, RA-DEC 00:47:37.5-73:04:33.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8544,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8544,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1753, RA-DEC 00:51:50.5-73:02:30.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8545,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8545,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2367, RA-DEC 00:55:18.5-72:43:12.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8546,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8546,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3677, RA-DEC 01:04:52.9-73:27:39.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8547,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8547,19.03,0.06,0.0639,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4498, RA-DEC 01:15:50.1-72:32:21.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8548,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8548,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0436, RA-DEC 00:41:58.9-73:28:42.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8549,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8549,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2865, RA-DEC 00:58:40.3-73:17:08.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8550,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8550,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3333, RA-DEC 01:02:00.8-71:51:15.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8551,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8551,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0350, RA-DEC 00:40:22.0-73:27:41.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8552,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8552,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0398, RA-DEC 00:41:15.8-72:34:45.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8553,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8553,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1079, RA-DEC 00:47:59.7-73:01:11.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8554,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8554,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1700, RA-DEC 00:51:29.9-72:44:58.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8555,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8555,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2408, RA-DEC 00:55:35.0-72:46:46.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8556,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8556,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2850, RA-DEC 00:58:35.1-73:47:05.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8557,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8557,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2997, RA-DEC 00:59:29.5-72:51:24.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8558,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8558,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3377, RA-DEC 01:02:24.1-73:04:04.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8559,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8559,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0813, RA-DEC 00:46:03.7-73:05:25.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8560,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8560,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3603, RA-DEC 01:04:12.2-73:42:58.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8561,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,NULL,8561,19.03,0.05,0.064,2163,NULL,NULL,'602, JHKs, GAL+LMC PL','SMC',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8562,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8562,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0560, RA-DEC 00:43:40.4-73:19:10.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8563,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8563,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1359, RA-DEC 00:49:38.3-72:55:04.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8564,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8564,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1761, RA-DEC 00:51:53.6-73:06:01.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8565,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8565,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2946, RA-DEC 00:59:10.8-73:35:53.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8566,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8566,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4356, RA-DEC 01:12:46.4-71:42:03.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8567,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8567,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0746, RA-DEC 00:45:23.3-73:13:13.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8568,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8568,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0994, RA-DEC 00:47:30.7-72:53:14.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8569,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8569,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1112, RA-DEC 00:48:07.5-72:47:20.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8570,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8570,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1716, RA-DEC 00:51:37.4-72:41:34.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8571,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8571,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2490, RA-DEC 00:56:05.9-71:37:24.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8572,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8572,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4353, RA-DEC 01:12:43.6-71:44:38.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8573,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8573,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1422, RA-DEC 00:50:00.0-73:27:06.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8574,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8574,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1442, RA-DEC 00:50:05.8-73:29:07.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8575,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8575,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2884, RA-DEC 00:58:47.1-72:55:57.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8576,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8576,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3587, RA-DEC 01:04:07.2-72:54:14.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8577,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8577,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4768, RA-DEC 01:01:30.5-71:06:57.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8578,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8578,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4776, RA-DEC 01:03:04.3-71:06:23.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8579,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,NULL,8579,19.03,0.06,0.064,2163,NULL,NULL,'23, JHK, PLC','SMC',NULL,'1986MNRAS.222..449L',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8580,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8580,19.02,0.03,0.064,2163,NULL,NULL,'BVRI','SMC',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8581,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8581,19.03,0.11,0.064,2163,NULL,NULL,'HV 1333, 1, V-R (BW)','SMC',NULL,'1999ASPC..167..320S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8582,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,NULL,8582,19.04,0.17,0.064,2163,NULL,NULL,'K','SMC',NULL,'2000A&A...363..901G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8583,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,NULL,8583,19.04,0.11,0.064,2163,NULL,NULL,'VI','SMC',NULL,'2002ApJ...574L..33B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8584,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,NULL,8584,19.03,0.07,0.064,2163,NULL,NULL,'HV 01522, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8585,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8585,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0339, RA-DEC 00:40:00.0-73:29:56.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8586,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8586,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1472, RA-DEC 00:50:17.3-72:36:33.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8587,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8587,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1533, RA-DEC 00:50:43.0-73:16:05.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8588,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8588,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2067, RA-DEC 00:53:30.4-73:07:02.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8589,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8589,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2842, RA-DEC 00:58:31.2-72:47:01.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8590,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8590,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2935, RA-DEC 00:59:04.8-72:57:08.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8591,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8591,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3696, RA-DEC 01:05:03.4-72:20:37.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8592,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8592,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4740, RA-DEC 00:55:12.9-71:11:21.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8593,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8593,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0980, RA-DEC 00:47:20.9-73:31:26.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8594,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8594,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1067, RA-DEC 00:47:55.7-72:56:28.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8595,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8595,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1230, RA-DEC 00:48:53.0-72:52:16.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8596,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8596,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2010, RA-DEC 00:53:11.3-72:56:21.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8597,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8597,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2117, RA-DEC 00:53:48.6-73:15:35.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8598,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8598,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3857, RA-DEC 01:06:34.9-72:57:02.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8599,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8599,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0597, RA-DEC 00:44:03.2-73:12:29.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8600,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8600,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1243, RA-DEC 00:48:59.1-72:44:01.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8601,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8601,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1244, RA-DEC 00:49:01.1-72:14:46.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8602,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8602,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2641, RA-DEC 00:57:07.2-72:42:31.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8603,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8603,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3964, RA-DEC 01:07:36.1-71:24:46.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8604,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8604,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0362, RA-DEC 00:40:30.3-72:50:38.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8605,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8605,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0409, RA-DEC 00:41:28.9-73:08:05.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8606,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8606,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0508, RA-DEC 00:43:03.9-73:25:19.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8607,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8607,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1248, RA-DEC 00:49:02.9-72:47:29.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8608,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8608,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2248, RA-DEC 00:54:35.8-71:56:36.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8609,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8609,19.03,0.06,0.064,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3142, RA-DEC 01:00:35.4-72:43:52.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8610,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8610,19.03,0.06,0.0641,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0319, RA-DEC 00:39:33.7-73:01:27.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8611,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8611,19.03,0.06,0.0641,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1420, RA-DEC 00:49:59.2-73:02:48.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8612,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8612,19.03,0.06,0.0641,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1522, RA-DEC 00:50:36.4-73:14:31.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8613,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8613,19.03,0.06,0.0641,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1944, RA-DEC 00:52:44.6-72:39:43.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8614,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8614,19.03,0.06,0.0641,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2295, RA-DEC 00:54:53.0-72:35:07.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8615,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8615,19.03,0.06,0.0641,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3505, RA-DEC 01:03:28.2-71:55:11.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8616,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8616,19.03,0.06,0.0641,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0868, RA-DEC 00:46:27.6-72:53:57.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8617,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8617,19.03,0.06,0.0641,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2743, RA-DEC 00:57:48.0-71:52:42.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8618,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8618,19.03,0.06,0.0641,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3552, RA-DEC 01:03:53.9-72:35:01.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8619,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8619,19.03,0.06,0.0641,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4007, RA-DEC 01:08:06.8-73:31:35.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8620,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8620,19.03,0.06,0.0641,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0644, RA-DEC 00:44:26.7-73:22:46.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8621,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8621,19.03,0.06,0.0641,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2909, RA-DEC 00:58:56.7-72:56:28.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8622,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8622,19.03,0.06,0.0641,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4780, RA-DEC 01:03:41.5-75:19:25.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8623,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8623,19.03,0.06,0.0641,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2409, RA-DEC 00:55:35.1-73:28:49.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8624,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8624,19.03,0.06,0.0641,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2841, RA-DEC 00:58:30.9-72:27:02.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8625,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8625,19.03,0.06,0.0641,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3062, RA-DEC 00:59:56.1-72:22:18.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8626,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8626,19.03,0.06,0.0641,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1550, RA-DEC 00:50:50.8-73:12:24.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8627,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8627,19.03,0.06,0.0641,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3053, RA-DEC 00:59:51.8-72:42:07.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8628,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8628,19.03,0.06,0.0641,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1083, RA-DEC 00:48:00.0-73:31:50.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8629,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8629,19.03,0.06,0.0641,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1698, RA-DEC 00:51:29.5-72:46:45.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8630,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8630,19.03,0.06,0.0641,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3024, RA-DEC 00:59:38.8-74:01:51.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8631,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8631,19.04,0.06,0.0641,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0490, RA-DEC 00:42:56.4-72:50:52.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8632,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8632,19.04,0.06,0.0641,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0511, RA-DEC 00:43:05.2-72:45:37.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8633,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8633,19.04,0.06,0.0641,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2022, RA-DEC 00:53:16.0-72:31:32.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8634,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8634,19.04,0.06,0.0641,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4600, RA-DEC 01:21:18.4-71:49:48.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8635,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8635,19.04,0.06,0.0641,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4294, RA-DEC 01:11:41.4-71:50:41.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8636,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8636,19.04,0.06,0.0641,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4454, RA-DEC 01:14:40.7-71:47:24.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8637,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8637,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0657, RA-DEC 00:44:29.7-73:00:07.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8638,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8638,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2634, RA-DEC 00:57:05.1-72:24:51.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8639,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8639,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2904, RA-DEC 00:58:54.1-73:07:36.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8640,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8640,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2996, RA-DEC 00:59:29.4-73:45:59.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8641,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8641,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1382, RA-DEC 00:49:44.1-73:27:55.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8642,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8642,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4325, RA-DEC 01:12:08.7-71:47:11.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8643,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8643,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4781, RA-DEC 01:03:44.3-70:54:01.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8644,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8644,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1045, RA-DEC 00:47:48.5-73:29:33.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8645,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8645,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3738, RA-DEC 01:05:26.1-72:45:39.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8646,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8646,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1339, RA-DEC 00:49:30.4-73:33:32.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8647,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8647,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2020, RA-DEC 00:53:15.3-73:34:01.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8648,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8648,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2166, RA-DEC 00:54:02.5-73:14:30.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8649,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8649,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2256, RA-DEC 00:54:37.7-72:43:39.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8650,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8650,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2920, RA-DEC 00:59:00.4-73:06:08.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8651,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8651,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3862, RA-DEC 01:06:39.0-73:11:59.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8652,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8652,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4161, RA-DEC 01:09:51.6-71:25:55.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8653,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8653,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0011, RA-DEC 00:22:30.5-73:07:35.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8654,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8654,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0349, RA-DEC 00:40:20.0-73:00:52.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8655,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8655,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2593, RA-DEC 00:56:46.0-71:41:35.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8656,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8656,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3005, RA-DEC 00:59:31.5-71:51:40.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8657,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8657,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3759, RA-DEC 01:05:41.1-73:15:37.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8658,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8658,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3874, RA-DEC 01:06:47.3-71:36:56.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8659,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8659,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4050, RA-DEC 01:08:37.3-73:42:11.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8660,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8660,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4091, RA-DEC 01:09:04.8-72:20:15.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8661,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8661,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2995, RA-DEC 00:59:29.3-72:33:21.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8662,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8662,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3618, RA-DEC 01:04:19.4-72:24:14.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8663,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,NULL,8663,19.04,0.07,0.0642,2163,NULL,NULL,'HV 00856, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8664,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,NULL,8664,19.04,0.07,0.0642,2163,NULL,NULL,'HV 01342, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8665,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8665,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0321, RA-DEC 00:39:35.1-73:13:01.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8666,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8666,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1378, RA-DEC 00:49:42.8-72:10:59.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8667,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8667,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1453, RA-DEC 00:50:09.4-72:51:36.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8668,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8668,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2046, RA-DEC 00:53:22.7-72:35:21.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8669,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8669,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2926, RA-DEC 00:59:02.9-73:27:09.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8670,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8670,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3767, RA-DEC 01:05:45.1-73:06:19.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8671,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8671,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0363, RA-DEC 00:40:31.9-73:13:40.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8672,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8672,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1752, RA-DEC 00:51:49.6-73:02:31.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8673,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8673,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2033, RA-DEC 00:53:18.7-73:03:42.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8674,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8674,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2092, RA-DEC 00:53:39.5-73:07:38.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8675,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8675,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4402, RA-DEC 01:13:33.7-73:08:37.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8676,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8676,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0288, RA-DEC 00:38:32.8-73:44:04.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8677,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8677,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0497, RA-DEC 00:42:59.0-73:10:04.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8678,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8678,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1203, RA-DEC 00:48:44.2-72:49:01.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8679,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8679,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3195, RA-DEC 01:00:56.6-73:31:17.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8680,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8680,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4724, RA-DEC 00:49:31.4-69:42:53.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8681,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8681,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0530, RA-DEC 00:43:24.2-73:13:08.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8682,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8682,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1743, RA-DEC 00:51:47.7-73:30:37.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8683,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8683,19.04,0.06,0.0642,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1776, RA-DEC 00:51:57.2-73:30:24.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8684,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8684,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0140, RA-DEC 00:31:35.0-73:52:42.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8685,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8685,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0576, RA-DEC 00:43:51.2-73:19:58.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8686,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8686,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3259, RA-DEC 01:01:27.8-72:23:08.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8687,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8687,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4250, RA-DEC 01:11:07.0-73:18:33.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8688,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8688,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0793, RA-DEC 00:45:55.5-73:30:23.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8689,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8689,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1418, RA-DEC 00:49:58.9-73:03:32.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8690,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8690,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4536, RA-DEC 01:17:01.6-71:38:29.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8691,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8691,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0905, RA-DEC 00:46:44.2-72:17:17.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8692,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8692,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1316, RA-DEC 00:49:22.5-72:59:29.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8693,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8693,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4942, RA-DEC 01:49:59.2-71:13:58.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8694,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8694,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0375, RA-DEC 00:40:46.3-73:35:09.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8695,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8695,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3263, RA-DEC 01:01:29.9-72:18:09.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8696,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8696,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3455, RA-DEC 01:03:02.6-72:00:08.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8697,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8697,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0834, RA-DEC 00:46:12.1-73:02:01.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8698,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8698,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2495, RA-DEC 00:56:06.2-72:36:18.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8699,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8699,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3484, RA-DEC 01:03:17.8-73:18:46.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8700,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8700,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0271, RA-DEC 00:37:57.5-74:02:51.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8701,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8701,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1440, RA-DEC 00:50:05.1-72:57:38.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8702,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8702,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2668, RA-DEC 00:57:18.4-72:54:49.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8703,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,NULL,8703,19.04,0.06,0.0643,2163,NULL,NULL,'23, JHK, PL','SMC',NULL,'1986MNRAS.222..449L',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8704,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,NULL,8704,19.04,0.07,0.0643,2163,NULL,NULL,'HV 01326, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8705,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8705,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0612, RA-DEC 00:44:10.4-72:48:12.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8706,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8706,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2195, RA-DEC 00:54:15.0-73:31:05.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8707,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8707,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3707, RA-DEC 01:05:09.3-71:58:10.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8708,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8708,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4358, RA-DEC 01:12:47.1-73:14:53.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8709,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8709,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0706, RA-DEC 00:45:04.2-73:10:12.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8710,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8710,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1279, RA-DEC 00:49:12.2-72:55:59.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8711,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8711,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1759, RA-DEC 00:51:53.4-72:57:12.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8712,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8712,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2878, RA-DEC 00:58:46.0-73:05:04.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8713,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8713,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4631, RA-DEC 23:33:17.4-67:46:01.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8714,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8714,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2006, RA-DEC 00:53:10.0-72:28:15.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8715,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8715,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2165, RA-DEC 00:54:01.9-73:30:18.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8716,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8716,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2268, RA-DEC 00:54:41.3-73:31:45.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8717,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8717,19.04,0.06,0.0643,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3668, RA-DEC 01:04:47.9-71:57:50.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8718,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8718,19.04,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1057, RA-DEC 00:47:52.4-72:53:15.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8719,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8719,19.04,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1428, RA-DEC 00:50:01.5-73:25:05.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8720,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8720,19.04,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1510, RA-DEC 00:50:31.4-72:26:38.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8721,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8721,19.04,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3346, RA-DEC 01:02:07.9-72:48:28.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8722,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8722,19.04,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0255, RA-DEC 00:37:29.0-73:58:00.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8723,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8723,19.04,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1371, RA-DEC 00:49:42.1-72:55:47.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8724,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8724,19.04,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2417, RA-DEC 00:55:37.2-72:09:12.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8725,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8725,19.04,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2831, RA-DEC 00:58:26.5-72:42:49.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8726,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8726,19.04,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2917, RA-DEC 00:58:59.8-72:31:29.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8727,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8727,19.04,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3886, RA-DEC 01:06:55.0-71:58:40.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8728,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8728,19.04,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3977, RA-DEC 01:07:44.7-73:11:24.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8729,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8729,19.04,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0931, RA-DEC 00:46:57.8-73:17:11.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8730,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8730,19.04,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1343, RA-DEC 00:49:31.7-73:07:56.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8731,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8731,19.04,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1667, RA-DEC 00:51:21.6-73:33:31.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8732,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8732,19.04,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2227, RA-DEC 00:54:27.5-73:12:14.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8733,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8733,19.04,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2452, RA-DEC 00:55:50.2-72:31:18.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8734,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8734,19.04,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0492, RA-DEC 00:42:56.8-73:07:20.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8735,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8735,19.04,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1443, RA-DEC 00:50:06.8-72:24:07.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8736,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8736,19.04,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1683, RA-DEC 00:51:25.2-73:14:27.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8737,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8737,19.04,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2543, RA-DEC 00:56:27.5-73:41:04.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8738,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8738,19.04,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1425, RA-DEC 00:50:00.4-72:41:58.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8739,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8739,19.04,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3279, RA-DEC 01:01:36.3-73:18:26.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8740,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8740,19.04,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1116, RA-DEC 00:48:08.2-72:51:08.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8741,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8741,19.04,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2057, RA-DEC 00:53:26.0-72:30:24.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8742,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8742,19.04,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2589, RA-DEC 00:56:43.9-73:39:17.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8743,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8743,19.04,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4729, RA-DEC 00:50:47.3-71:14:58.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8744,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8744,19.04,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1560, RA-DEC 00:50:54.2-72:59:00.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8745,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8745,19.04,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1670, RA-DEC 00:51:22.2-72:36:53.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8746,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8746,19.04,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3566, RA-DEC 01:04:00.6-72:46:13.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8747,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8747,19.05,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0877, RA-DEC 00:46:31.1-73:07:09.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8748,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8748,19.05,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1218, RA-DEC 00:48:49.0-73:19:45.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8749,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8749,19.05,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3261, RA-DEC 01:01:28.7-72:18:17.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8750,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8750,19.05,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4459, RA-DEC 01:14:48.3-71:29:53.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8751,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8751,19.05,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1351, RA-DEC 00:49:34.8-72:33:56.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8752,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8752,19.05,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1438, RA-DEC 00:50:04.7-72:43:05.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8753,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8753,19.05,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2174, RA-DEC 00:54:06.3-73:34:07.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8754,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8754,19.05,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2211, RA-DEC 00:54:19.6-72:45:16.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8755,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8755,19.05,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4045, RA-DEC 01:08:30.4-72:54:07.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8756,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8756,19.05,0.06,0.0644,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0840, RA-DEC 00:46:13.2-72:57:55.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8757,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8757,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1027, RA-DEC 00:47:41.7-73:08:22.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8758,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8758,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2478, RA-DEC 00:55:59.6-72:58:21.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8759,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8759,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2826, RA-DEC 00:58:24.0-73:05:37.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8760,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8760,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3561, RA-DEC 01:03:58.8-73:19:12.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8761,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8761,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3679, RA-DEC 01:04:54.0-73:34:28.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8762,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8762,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4279, RA-DEC 01:11:33.2-72:52:09.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8763,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8763,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2176, RA-DEC 00:54:06.8-72:48:18.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8764,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8764,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2880, RA-DEC 00:58:46.6-71:15:53.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8765,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8765,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3004, RA-DEC 00:59:31.5-72:39:58.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8766,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8766,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3917, RA-DEC 01:07:11.2-72:59:58.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8767,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8767,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4708, RA-DEC 00:44:12.3-72:08:44.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8768,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8768,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0276, RA-DEC 00:38:11.5-73:25:00.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8769,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8769,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1102, RA-DEC 00:48:05.1-72:37:17.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8770,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8770,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1348, RA-DEC 00:49:34.3-72:47:18.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8771,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8771,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0050, RA-DEC 00:25:22.8-73:10:52.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8772,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8772,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0507, RA-DEC 00:43:03.4-73:10:19.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8773,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8773,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1281, RA-DEC 00:49:12.8-73:30:47.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8774,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8774,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1300, RA-DEC 00:49:18.5-72:39:33.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8775,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8775,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2640, RA-DEC 00:57:07.1-71:57:24.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8776,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8776,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3504, RA-DEC 01:03:28.0-72:46:14.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8777,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8777,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3573, RA-DEC 01:04:03.2-72:14:48.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8778,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8778,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3849, RA-DEC 01:06:30.0-72:01:14.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8779,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8779,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0552, RA-DEC 00:43:37.7-72:50:54.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8780,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8780,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3804, RA-DEC 01:06:04.2-73:18:50.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8781,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8781,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1665, RA-DEC 00:51:21.5-73:36:10.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8782,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8782,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0646, RA-DEC 00:44:26.7-73:05:29.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8783,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8783,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1035, RA-DEC 00:47:46.8-73:01:05.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8784,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8784,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1585, RA-DEC 00:50:58.7-72:25:17.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8785,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8785,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2352, RA-DEC 00:55:11.0-73:22:15.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8786,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8786,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3184, RA-DEC 01:00:50.1-72:26:50.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8787,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8787,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1061, RA-DEC 00:47:53.6-73:28:45.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8788,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8788,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1444, RA-DEC 00:50:07.5-73:40:38.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8789,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8789,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1682, RA-DEC 00:51:24.8-73:23:25.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8790,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8790,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2356, RA-DEC 00:55:11.7-72:44:53.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8791,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8791,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3028, RA-DEC 00:59:41.7-72:47:32.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8792,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8792,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3148, RA-DEC 01:00:37.5-72:44:57.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8793,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8793,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4145, RA-DEC 01:09:41.3-71:17:10.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8794,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8794,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0305, RA-DEC 00:39:09.6-73:35:43.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8795,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8795,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1127, RA-DEC 00:48:14.1-72:34:26.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8796,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8796,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1403, RA-DEC 00:49:52.9-73:14:41.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8797,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8797,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1863, RA-DEC 00:52:18.6-73:14:12.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8798,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8798,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2086, RA-DEC 00:53:38.2-72:29:36.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8799,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8799,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3851, RA-DEC 01:06:31.1-72:39:46.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8800,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8800,19.05,0.06,0.0645,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4102, RA-DEC 01:09:11.2-72:41:47.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8801,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8801,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3156, RA-DEC 01:00:39.9-73:23:48.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8802,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8802,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3345, RA-DEC 01:02:07.7-73:21:42.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8803,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8803,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1494, RA-DEC 00:50:26.3-73:18:45.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8804,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8804,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1551, RA-DEC 00:50:51.1-72:50:53.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8805,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8805,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2622, RA-DEC 00:57:00.8-72:07:41.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8806,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8806,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2675, RA-DEC 00:57:21.3-73:34:51.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8807,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8807,19.05,0.04,0.0646,2163,NULL,18.5,'4172, YJK','SMC',NULL,'2016arXiv160209005R',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8808,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8808,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0239, RA-DEC 00:36:32.3-72:35:30.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8809,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8809,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2108, RA-DEC 00:53:44.5-73:03:42.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8810,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8810,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3021, RA-DEC 00:59:37.9-72:52:27.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8811,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8811,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4471, RA-DEC 01:15:04.7-71:17:11.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8812,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8812,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4706, RA-DEC 00:42:44.1-70:16:27.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8813,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8813,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0123, RA-DEC 00:30:16.2-73:25:11.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8814,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8814,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0208, RA-DEC 00:35:11.7-73:43:18.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8815,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8815,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0911, RA-DEC 00:46:47.8-73:17:18.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8816,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8816,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1695, RA-DEC 00:51:28.0-73:25:42.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8817,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8817,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1707, RA-DEC 00:51:33.2-73:03:50.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8818,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8818,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0628, RA-DEC 00:44:19.1-73:08:19.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8819,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8819,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0960, RA-DEC 00:47:12.0-73:28:54.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8820,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8820,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1119, RA-DEC 00:48:09.3-73:36:05.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8821,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8821,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1154, RA-DEC 00:48:23.9-73:28:58.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8822,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8822,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1735, RA-DEC 00:51:44.3-73:04:35.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8823,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8823,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2114, RA-DEC 00:53:45.9-72:32:18.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8824,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8824,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2825, RA-DEC 00:58:23.9-73:24:47.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8825,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8825,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0039, RA-DEC 00:24:34.6-73:18:27.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8826,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8826,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0822, RA-DEC 00:46:07.0-73:10:22.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8827,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8827,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2647, RA-DEC 00:57:09.2-73:36:59.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8828,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8828,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3913, RA-DEC 01:07:07.5-72:48:58.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8829,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8829,19.05,0.16,0.0646,2163,NULL,NULL,'4654, VI, OGLE mean','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8830,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,NULL,8830,19.05,0.07,0.0646,2163,NULL,NULL,'HV 01925, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8831,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8831,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1839, RA-DEC 00:52:11.1-72:45:51.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8832,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8832,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2213, RA-DEC 00:54:20.1-73:02:33.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8833,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8833,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2253, RA-DEC 00:54:36.6-73:23:39.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8834,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8834,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4862, RA-DEC 01:23:21.1-70:34:39.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8835,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8835,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1219, RA-DEC 00:48:49.0-72:43:09.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8836,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8836,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1800, RA-DEC 00:52:01.0-72:36:01.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8837,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8837,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2037, RA-DEC 00:53:19.5-73:24:20.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8838,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8838,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3219, RA-DEC 01:01:07.2-72:58:22.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8839,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8839,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1786, RA-DEC 00:51:58.7-72:51:43.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8840,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8840,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2923, RA-DEC 00:59:02.4-72:43:36.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8841,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8841,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3820, RA-DEC 01:06:14.0-73:09:00.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8842,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8842,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0927, RA-DEC 00:46:54.2-73:15:23.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8843,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8843,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1832, RA-DEC 00:52:09.1-73:18:14.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8844,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8844,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2523, RA-DEC 00:56:16.2-72:05:32.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8845,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8845,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2860, RA-DEC 00:58:38.2-72:20:14.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8846,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8846,19.05,0.06,0.0646,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4191, RA-DEC 01:10:11.2-73:22:24.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8847,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8847,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1908, RA-DEC 00:52:32.5-72:19:47.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8848,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8848,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2412, RA-DEC 00:55:35.7-72:37:43.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8849,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8849,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4117, RA-DEC 01:09:20.1-71:22:40.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8850,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8850,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4317, RA-DEC 01:11:58.2-72:07:51.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8851,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8851,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0289, RA-DEC 00:38:35.8-73:57:24.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8852,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8852,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1785, RA-DEC 00:51:58.7-73:02:24.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8853,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8853,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2155, RA-DEC 00:53:59.1-73:29:55.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8854,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8854,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2281, RA-DEC 00:54:48.9-72:51:11.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8855,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8855,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2629, RA-DEC 00:57:04.3-72:40:33.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8856,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8856,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2840, RA-DEC 00:58:30.4-72:32:34.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8857,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8857,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3620, RA-DEC 01:04:19.5-73:33:02.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8858,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8858,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4111, RA-DEC 01:09:18.1-73:01:42.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8859,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8859,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0466, RA-DEC 00:42:32.8-73:00:33.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8860,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8860,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0775, RA-DEC 00:45:43.2-72:57:35.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8861,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8861,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1384, RA-DEC 00:49:44.3-73:03:27.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8862,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8862,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1488, RA-DEC 00:50:25.0-73:22:24.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8863,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8863,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1524, RA-DEC 00:50:38.6-72:57:33.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8864,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8864,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1954, RA-DEC 00:52:49.3-73:09:11.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8865,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8865,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2555, RA-DEC 00:56:30.5-72:44:11.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8866,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8866,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2739, RA-DEC 00:57:45.6-73:40:33.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8867,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8867,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2797, RA-DEC 00:58:12.8-73:38:58.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8868,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8868,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3570, RA-DEC 01:04:02.1-73:09:13.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8869,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8869,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4773, RA-DEC 01:02:42.7-71:08:21.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8870,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8870,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0017, RA-DEC 00:23:03.6-73:19:26.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8871,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8871,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0356, RA-DEC 00:40:28.4-72:49:08.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8872,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8872,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1514, RA-DEC 00:50:33.3-73:23:22.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8873,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8873,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2337, RA-DEC 00:55:05.8-73:19:22.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8874,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8874,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2456, RA-DEC 00:55:52.7-73:06:45.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8875,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8875,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2520, RA-DEC 00:56:15.7-72:20:17.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8876,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8876,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2628, RA-DEC 00:57:03.8-73:10:26.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8877,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8877,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3686, RA-DEC 01:04:57.6-71:27:08.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8878,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8878,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0642, RA-DEC 00:44:26.1-73:15:48.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8879,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8879,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0923, RA-DEC 00:46:53.4-73:28:06.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8880,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8880,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1031, RA-DEC 00:47:44.9-72:50:56.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8881,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8881,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4354, RA-DEC 01:12:43.9-71:39:43.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8882,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8882,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4826, RA-DEC 01:11:22.8-73:07:21.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8883,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8883,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1309, RA-DEC 00:49:21.2-73:07:34.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8884,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8884,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2145, RA-DEC 00:53:57.2-72:10:14.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8885,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8885,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3580, RA-DEC 01:04:05.9-72:05:48.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8886,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8886,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0407, RA-DEC 00:41:27.9-73:13:17.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8887,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8887,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0685, RA-DEC 00:44:47.8-73:13:06.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8888,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8888,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2480, RA-DEC 00:56:00.9-73:24:03.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8889,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8889,19.05,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3733, RA-DEC 01:05:24.1-71:37:20.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8890,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8890,19.06,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0430, RA-DEC 00:41:53.5-73:12:05.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8891,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8891,19.06,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0585, RA-DEC 00:43:58.1-73:03:52.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8892,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8892,19.06,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0587, RA-DEC 00:43:59.0-73:02:14.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8893,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8893,19.06,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2076, RA-DEC 00:53:33.4-72:39:47.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8894,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8894,19.06,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2571, RA-DEC 00:56:37.0-72:42:23.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8895,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8895,19.06,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3303, RA-DEC 01:01:47.0-73:17:41.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8896,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8896,19.06,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3967, RA-DEC 01:07:37.4-72:45:51.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8897,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8897,19.06,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0579, RA-DEC 00:43:53.7-73:14:01.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8898,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8898,19.06,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1322, RA-DEC 00:49:23.2-72:58:06.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8899,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8899,19.06,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2383, RA-DEC 00:55:22.4-73:37:30.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8900,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8900,19.06,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2704, RA-DEC 00:57:33.6-72:26:49.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8901,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8901,19.06,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0303, RA-DEC 00:39:05.2-72:47:12.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8902,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8902,19.06,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2021, RA-DEC 00:53:15.4-72:46:12.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8903,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8903,19.06,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2142, RA-DEC 00:53:57.0-73:45:12.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8904,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8904,19.06,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3424, RA-DEC 01:02:45.7-73:21:39.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8905,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8905,19.06,0.06,0.0647,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3584, RA-DEC 01:04:06.9-73:00:23.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8906,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8906,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1692, RA-DEC 00:51:27.3-72:44:15.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8907,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8907,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3171, RA-DEC 01:00:45.3-72:45:33.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8908,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8908,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4099, RA-DEC 01:09:10.4-73:25:30.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8909,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8909,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4774, RA-DEC 01:02:45.3-71:05:26.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8910,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8910,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1380, RA-DEC 00:49:43.9-72:43:21.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8911,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8911,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1496, RA-DEC 00:50:26.9-72:23:42.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8912,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8912,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1783, RA-DEC 00:51:58.5-73:45:18.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8913,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8913,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2415, RA-DEC 00:55:37.0-73:06:22.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8914,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8914,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3986, RA-DEC 01:07:51.5-72:57:27.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8915,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8915,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3988, RA-DEC 01:07:53.8-71:50:17.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8916,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8916,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4237, RA-DEC 01:10:57.5-71:50:53.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8917,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8917,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4385, RA-DEC 01:13:18.2-72:59:53.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8918,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8918,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1095, RA-DEC 00:48:02.9-72:57:11.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8919,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8919,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2247, RA-DEC 00:54:34.8-73:23:33.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8920,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8920,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2402, RA-DEC 00:55:32.6-73:01:23.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8921,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8921,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2793, RA-DEC 00:58:11.4-72:56:37.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8922,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8922,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3237, RA-DEC 01:01:16.5-71:17:21.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8923,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8923,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4655, RA-DEC 00:17:56.1-73:15:16.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8924,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8924,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0916, RA-DEC 00:46:50.8-73:35:17.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8925,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8925,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1065, RA-DEC 00:47:55.3-73:18:36.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8926,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8926,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1272, RA-DEC 00:49:11.0-72:24:36.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8927,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8927,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3257, RA-DEC 01:01:24.2-72:17:42.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8928,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8928,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4286, RA-DEC 01:11:37.9-72:58:02.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8929,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8929,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0609, RA-DEC 00:44:05.8-73:10:41.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8930,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8930,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0781, RA-DEC 00:45:49.5-73:23:45.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8931,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8931,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1381, RA-DEC 00:49:44.0-72:32:42.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8932,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8932,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0607, RA-DEC 00:44:04.8-73:05:09.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8933,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8933,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2138, RA-DEC 00:53:55.7-73:30:35.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8934,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8934,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2164, RA-DEC 00:54:01.8-72:53:32.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8935,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8935,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4144, RA-DEC 01:09:41.1-71:44:19.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8936,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8936,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0283, RA-DEC 00:38:18.9-73:31:32.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8937,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8937,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0444, RA-DEC 00:42:06.2-73:17:57.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8938,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8938,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1245, RA-DEC 00:49:01.2-73:19:38.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8939,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8939,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1726, RA-DEC 00:51:39.7-73:01:53.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8940,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8940,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2431, RA-DEC 00:55:43.2-73:18:05.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8941,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8941,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3041, RA-DEC 00:59:48.6-73:03:12.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8942,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8942,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0713, RA-DEC 00:45:05.9-73:15:51.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8943,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8943,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0717, RA-DEC 00:45:08.8-72:58:02.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8944,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8944,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0795, RA-DEC 00:45:56.3-73:10:01.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8945,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8945,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3227, RA-DEC 01:01:10.7-73:01:37.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8946,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8946,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3417, RA-DEC 01:02:43.0-72:59:20.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8947,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8947,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4352, RA-DEC 01:12:42.7-72:46:45.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8948,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8948,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0434, RA-DEC 00:41:57.3-73:31:24.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8949,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8949,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1583, RA-DEC 00:50:58.4-73:33:31.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8950,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8950,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2532, RA-DEC 00:56:19.1-72:11:35.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8951,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8951,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1758, RA-DEC 00:51:52.9-73:28:55.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8952,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8952,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2987, RA-DEC 00:59:24.8-73:19:17.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8953,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8953,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3065, RA-DEC 00:59:57.7-72:51:45.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8954,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8954,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3159, RA-DEC 01:00:41.0-72:27:55.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8955,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8955,19.06,0.06,0.0648,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3543, RA-DEC 01:03:48.3-71:31:07.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8956,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8956,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1192, RA-DEC 00:48:37.2-73:27:40.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8957,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8957,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2178, RA-DEC 00:54:07.3-73:36:24.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8958,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8958,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2921, RA-DEC 00:59:00.5-72:10:06.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8959,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8959,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3250, RA-DEC 01:01:20.2-73:24:19.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8960,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8960,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3486, RA-DEC 01:03:18.4-72:44:22.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8961,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8961,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4337, RA-DEC 01:12:21.7-72:44:34.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8962,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8962,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0241, RA-DEC 00:36:40.9-74:02:53.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8963,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8963,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1616, RA-DEC 00:51:08.2-73:08:14.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8964,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8964,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1838, RA-DEC 00:52:10.7-72:55:29.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8965,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8965,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2240, RA-DEC 00:54:32.2-72:47:19.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8966,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8966,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3511, RA-DEC 01:03:30.6-71:54:32.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8967,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8967,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3758, RA-DEC 01:05:41.0-73:23:09.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8968,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8968,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3897, RA-DEC 01:07:00.9-74:06:07.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8969,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8969,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0447, RA-DEC 00:42:09.4-72:55:17.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8970,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8970,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0502, RA-DEC 00:43:00.6-72:58:10.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8971,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8971,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0852, RA-DEC 00:46:18.7-72:57:43.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8972,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8972,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0968, RA-DEC 00:47:17.4-72:52:28.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8973,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8973,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4338, RA-DEC 01:12:23.7-71:49:44.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8974,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8974,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0647, RA-DEC 00:44:26.8-72:51:03.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8975,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8975,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2237, RA-DEC 00:54:31.9-72:20:34.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8976,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8976,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0521, RA-DEC 00:43:14.2-73:36:06.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8977,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8977,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0545, RA-DEC 00:43:34.5-73:14:09.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8978,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8978,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2156, RA-DEC 00:53:59.2-72:15:24.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8979,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8979,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4818, RA-DEC 01:10:14.0-71:12:41.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8980,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,NULL,8980,19.06,0.08,0.0649,2163,NULL,NULL,NULL,'SMC',NULL,'2011AJ....142..110M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8981,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8981,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1559, RA-DEC 00:50:53.5-73:38:56.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8982,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8982,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3452, RA-DEC 01:03:01.5-72:46:19.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8983,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8983,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4247, RA-DEC 01:11:02.8-72:54:10.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8984,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8984,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2161, RA-DEC 00:54:01.4-72:44:35.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8985,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8985,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2399, RA-DEC 00:55:31.4-73:02:13.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8986,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8986,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2438, RA-DEC 00:55:45.7-73:33:25.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8987,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8987,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2754, RA-DEC 00:57:54.6-71:40:51.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8988,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8988,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0863, RA-DEC 00:46:24.0-73:29:16.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8989,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8989,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1349, RA-DEC 00:49:34.6-72:35:47.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8990,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8990,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4122, RA-DEC 01:09:21.4-72:19:18.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8991,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8991,19.06,0.06,0.0649,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3120, RA-DEC 01:00:24.0-73:38:29.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8992,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8992,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0025, RA-DEC 00:23:41.1-73:26:18.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8993,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8993,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1424, RA-DEC 00:50:00.2-73:09:53.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8994,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8994,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3079, RA-DEC 01:00:07.1-73:06:44.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8995,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8995,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4610, RA-DEC 01:22:13.5-72:47:46.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8996,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8996,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0427, RA-DEC 00:41:52.5-73:25:25.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8997,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8997,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0465, RA-DEC 00:42:29.6-73:49:47.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8998,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8998,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0624, RA-DEC 00:44:17.1-74:13:56.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8999,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',8999,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0878, RA-DEC 00:46:31.3-73:18:37.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9000,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9000,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0963, RA-DEC 00:47:15.1-73:20:19.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9001,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9001,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1025, RA-DEC 00:47:41.4-73:02:04.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9002,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9002,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2481, RA-DEC 00:56:01.4-72:43:51.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9003,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9003,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3695, RA-DEC 01:05:02.8-73:04:11.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9004,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9004,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3705, RA-DEC 01:05:08.5-72:40:04.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9005,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9005,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0953, RA-DEC 00:47:08.9-72:48:34.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9006,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9006,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1861, RA-DEC 00:52:18.1-73:01:55.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9007,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9007,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4485, RA-DEC 01:15:33.1-71:35:58.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9008,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9008,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0290, RA-DEC 00:38:37.7-73:25:11.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9009,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9009,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1795, RA-DEC 00:52:00.1-73:19:26.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9010,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9010,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1889, RA-DEC 00:52:27.0-73:06:07.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9011,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9011,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1755, RA-DEC 00:51:51.4-73:29:45.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9012,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9012,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2216, RA-DEC 00:54:21.9-72:27:02.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9013,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9013,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2939, RA-DEC 00:59:06.0-73:18:57.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9014,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9014,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4019, RA-DEC 01:08:11.7-73:39:52.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9015,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9015,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1122, RA-DEC 00:48:12.1-72:47:33.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9016,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9016,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1135, RA-DEC 00:48:15.1-73:28:00.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9017,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9017,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1294, RA-DEC 00:49:16.6-72:56:23.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9018,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9018,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1723, RA-DEC 00:51:39.3-73:01:30.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9019,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,NULL,9019,19.05,0.13,0.065,2163,NULL,NULL,'DMC','SMC',NULL,'2000A&A...360L...1K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9020,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9020,19.07,0.12,0.065,2163,NULL,NULL,'Hipp','SMC',NULL,'2004Ap.....47...18A',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9021,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9021,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0355, RA-DEC 00:40:27.7-73:12:15.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9022,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9022,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0684, RA-DEC 00:44:46.8-73:07:59.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9023,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9023,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0783, RA-DEC 00:45:50.9-73:31:40.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9024,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9024,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2124, RA-DEC 00:53:50.6-73:03:23.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9025,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9025,19.06,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2186, RA-DEC 00:54:09.7-72:43:38.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9026,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9026,19.07,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0570, RA-DEC 00:43:47.3-73:14:26.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9027,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9027,19.07,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1548, RA-DEC 00:50:49.0-72:39:14.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9028,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9028,19.07,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2536, RA-DEC 00:56:22.4-73:21:32.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9029,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9029,19.07,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2427, RA-DEC 00:55:40.8-73:20:48.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9030,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9030,19.07,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3269, RA-DEC 01:01:31.8-73:43:57.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9031,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9031,19.07,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1103, RA-DEC 00:48:05.3-72:43:42.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9032,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9032,19.07,0.06,0.065,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3726, RA-DEC 01:05:21.0-71:35:37.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9033,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9033,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1026, RA-DEC 00:47:41.6-73:11:16.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9034,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9034,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2197, RA-DEC 00:54:15.3-73:32:47.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9035,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9035,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2784, RA-DEC 00:58:07.6-72:57:55.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9036,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9036,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3786, RA-DEC 01:05:54.1-73:26:02.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9037,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9037,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0464, RA-DEC 00:42:26.5-72:56:11.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9038,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9038,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0797, RA-DEC 00:45:57.1-73:34:48.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9039,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9039,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1859, RA-DEC 00:52:17.5-72:40:57.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9040,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9040,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1890, RA-DEC 00:52:27.2-73:10:59.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9041,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9041,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1898, RA-DEC 00:52:29.9-73:24:18.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9042,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9042,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2358, RA-DEC 00:55:12.8-72:31:28.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9043,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9043,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4907, RA-DEC 01:36:05.8-71:33:41.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9044,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9044,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0909, RA-DEC 00:46:46.7-72:58:37.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9045,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9045,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1261, RA-DEC 00:49:05.4-73:04:11.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9046,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9046,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0351, RA-DEC 00:40:23.6-73:40:24.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9047,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9047,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1619, RA-DEC 00:51:09.3-72:28:00.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9048,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9048,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1622, RA-DEC 00:51:09.8-73:36:49.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9049,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9049,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2373, RA-DEC 00:55:20.4-72:42:05.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9050,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9050,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2773, RA-DEC 00:58:03.1-73:13:11.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9051,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9051,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0087, RA-DEC 00:28:14.3-73:51:56.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9052,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9052,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1749, RA-DEC 00:51:49.0-73:27:33.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9053,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9053,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3875, RA-DEC 01:06:48.0-73:12:27.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9054,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9054,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3909, RA-DEC 01:07:05.1-72:31:10.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9055,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9055,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4093, RA-DEC 01:09:07.2-72:56:05.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9056,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9056,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1972, RA-DEC 00:52:54.5-73:00:14.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9057,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9057,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2131, RA-DEC 00:53:52.4-73:17:01.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9058,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9058,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2525, RA-DEC 00:56:16.9-72:37:46.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9059,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9059,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2918, RA-DEC 00:59:00.3-72:41:33.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9060,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9060,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0422, RA-DEC 00:41:48.7-73:07:03.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9061,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9061,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0651, RA-DEC 00:44:28.4-73:27:24.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9062,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9062,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1054, RA-DEC 00:47:51.9-72:41:14.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9063,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9063,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1604, RA-DEC 00:51:05.2-73:14:51.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9064,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9064,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2276, RA-DEC 00:54:46.2-73:30:19.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9065,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9065,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1679, RA-DEC 00:51:24.4-73:27:52.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9066,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9066,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2599, RA-DEC 00:56:49.0-71:38:34.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9067,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9067,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2886, RA-DEC 00:58:48.2-73:09:42.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9068,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9068,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3757, RA-DEC 01:05:39.7-73:09:32.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9069,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9069,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4807, RA-DEC 01:07:52.7-71:14:13.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9070,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9070,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0739, RA-DEC 00:45:18.0-73:08:13.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9071,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9071,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0920, RA-DEC 00:46:52.1-73:20:35.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9072,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9072,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2016, RA-DEC 00:53:13.9-72:52:43.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9073,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9073,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2151, RA-DEC 00:53:58.4-73:36:16.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9074,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9074,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2737, RA-DEC 00:57:44.9-73:41:42.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9075,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9075,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4042, RA-DEC 01:08:28.9-71:24:55.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9076,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9076,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0559, RA-DEC 00:43:39.5-72:58:09.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9077,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9077,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0613, RA-DEC 00:44:10.5-73:28:32.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9078,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9078,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1366, RA-DEC 00:49:41.1-72:39:38.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9079,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9079,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1421, RA-DEC 00:49:59.3-73:14:36.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9080,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9080,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1678, RA-DEC 00:51:24.0-73:26:14.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9081,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9081,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2530, RA-DEC 00:56:18.4-73:03:47.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9082,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9082,19.07,0.06,0.0651,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3105, RA-DEC 01:00:17.7-72:34:07.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9083,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9083,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1473, RA-DEC 00:50:17.6-72:49:08.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9084,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9084,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2564, RA-DEC 00:56:33.7-72:49:30.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9085,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9085,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2613, RA-DEC 00:56:56.8-73:28:11.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9086,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9086,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4172, RA-DEC 01:09:59.7-71:38:03.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9087,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9087,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0408, RA-DEC 00:41:28.9-73:23:00.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9088,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9088,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1056, RA-DEC 00:47:52.2-73:00:39.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9089,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9089,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2390, RA-DEC 00:55:26.1-71:44:55.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9090,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9090,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2851, RA-DEC 00:58:35.2-73:25:38.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9091,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9091,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3828, RA-DEC 01:06:17.7-72:24:43.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9092,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9092,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4248, RA-DEC 01:11:04.3-72:44:25.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9093,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9093,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0887, RA-DEC 00:46:34.5-73:02:02.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9094,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9094,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1912, RA-DEC 00:52:33.9-72:42:59.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9095,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9095,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2143, RA-DEC 00:53:57.1-73:01:15.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9096,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9096,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2296, RA-DEC 00:54:53.1-73:35:29.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9097,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9097,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2973, RA-DEC 00:59:20.0-72:41:23.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9098,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9098,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3166, RA-DEC 01:00:43.4-72:33:29.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9099,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9099,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4105, RA-DEC 01:09:14.6-71:49:09.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9100,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9100,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1201, RA-DEC 00:48:42.9-72:54:10.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9101,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9101,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1564, RA-DEC 00:50:55.0-72:47:21.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9102,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9102,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4015, RA-DEC 01:08:11.1-73:00:30.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9103,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9103,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2294, RA-DEC 00:54:52.7-72:07:46.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9104,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9104,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3039, RA-DEC 00:59:48.0-73:25:21.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9105,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9105,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0604, RA-DEC 00:44:04.5-73:15:37.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9106,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9106,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0815, RA-DEC 00:46:04.0-72:47:27.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9107,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9107,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1402, RA-DEC 00:49:51.9-73:29:51.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9108,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9108,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3037, RA-DEC 00:59:47.3-72:45:31.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9109,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9109,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3558, RA-DEC 01:03:57.9-73:03:42.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9110,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,NULL,9110,19.07,0.04,0.0652,2163,NULL,NULL,'92, R','SMC',NULL,'2016ApJ...816...49S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9111,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9111,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0810, RA-DEC 00:46:02.3-73:06:55.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9112,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9112,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2220, RA-DEC 00:54:22.9-73:17:59.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9113,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9113,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0191, RA-DEC 00:34:42.0-74:01:36.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9114,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9114,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1373, RA-DEC 00:49:42.1-72:42:50.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9115,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9115,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3567, RA-DEC 01:04:00.7-73:27:16.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9116,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9116,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3790, RA-DEC 01:05:56.1-71:55:28.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9117,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9117,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4853, RA-DEC 01:19:18.9-70:51:37.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9118,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9118,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1597, RA-DEC 00:51:01.5-72:43:54.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9119,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9119,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2279, RA-DEC 00:54:47.4-73:00:09.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9120,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9120,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2392, RA-DEC 00:55:27.5-72:35:27.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9121,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9121,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2966, RA-DEC 00:59:16.9-73:30:53.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9122,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9122,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1663, RA-DEC 00:51:21.2-73:21:54.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9123,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9123,19.07,0.06,0.0652,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4153, RA-DEC 01:09:46.8-73:34:34.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9124,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9124,19.07,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1267, RA-DEC 00:49:08.4-72:33:31.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9125,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9125,19.07,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2310, RA-DEC 00:54:58.0-72:32:44.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9126,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9126,19.07,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0616, RA-DEC 00:44:12.0-74:21:46.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9127,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9127,19.07,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1818, RA-DEC 00:52:04.8-72:58:05.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9128,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9128,19.07,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0481, RA-DEC 00:42:50.5-73:14:25.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9129,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9129,19.07,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0720, RA-DEC 00:45:10.0-73:18:58.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9130,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9130,19.07,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1474, RA-DEC 00:50:18.3-72:56:15.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9131,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9131,19.07,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1906, RA-DEC 00:52:31.9-73:01:12.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9132,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9132,19.07,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2271, RA-DEC 00:54:42.1-72:50:23.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9133,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9133,19.07,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2488, RA-DEC 00:56:04.6-73:26:45.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9134,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9134,19.07,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3318, RA-DEC 01:01:54.5-73:30:22.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9135,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9135,19.07,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0272, RA-DEC 00:37:58.8-73:10:24.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9136,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9136,19.07,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0442, RA-DEC 00:42:05.8-73:02:31.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9137,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9137,19.07,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0899, RA-DEC 00:46:39.9-73:03:32.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9138,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9138,19.07,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3033, RA-DEC 00:59:44.7-73:18:04.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9139,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9139,19.07,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4827, RA-DEC 01:11:54.1-74:19:32.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9140,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,NULL,9140,19.07,0.07,0.0653,2163,NULL,NULL,'HV 01430, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9141,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9141,19.07,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0286, RA-DEC 00:38:31.6-73:11:57.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9142,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9142,19.07,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1469, RA-DEC 00:50:16.8-72:36:17.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9143,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9143,19.07,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1613, RA-DEC 00:51:07.7-72:53:47.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9144,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9144,19.07,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1987, RA-DEC 00:53:02.5-73:00:34.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9145,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9145,19.07,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3499, RA-DEC 01:03:25.8-73:01:06.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9146,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9146,19.08,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0522, RA-DEC 00:43:15.4-72:45:55.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9147,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9147,19.08,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0956, RA-DEC 00:47:09.3-73:17:16.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9148,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9148,19.08,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1283, RA-DEC 00:49:12.9-72:57:09.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9149,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9149,19.08,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1729, RA-DEC 00:51:40.7-73:21:44.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9150,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9150,19.08,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1792, RA-DEC 00:51:59.8-73:16:07.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9151,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9151,19.08,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2379, RA-DEC 00:55:21.6-73:35:38.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9152,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9152,19.08,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2486, RA-DEC 00:56:03.7-73:13:44.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9153,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9153,19.08,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3729, RA-DEC 01:05:22.0-71:47:04.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9154,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9154,19.08,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4541, RA-DEC 01:17:12.5-73:03:46.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9155,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9155,19.08,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3866, RA-DEC 01:06:42.1-73:08:50.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9156,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9156,19.08,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2012, RA-DEC 00:53:11.8-73:36:49.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9157,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9157,19.08,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2251, RA-DEC 00:54:36.0-73:07:56.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9158,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9158,19.08,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4095, RA-DEC 01:09:08.4-73:19:09.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9159,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9159,19.08,0.06,0.0653,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4803, RA-DEC 01:07:33.8-71:05:16.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9160,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9160,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0600, RA-DEC 00:44:03.7-72:39:33.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9161,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9161,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0744, RA-DEC 00:45:20.6-72:38:44.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9162,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9162,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1452, RA-DEC 00:50:09.4-72:56:37.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9163,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9163,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1974, RA-DEC 00:52:55.4-72:59:18.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9164,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9164,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3434, RA-DEC 01:02:50.8-71:43:45.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9165,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9165,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0281, RA-DEC 00:38:16.8-73:21:58.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9166,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9166,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1712, RA-DEC 00:51:36.2-73:06:15.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9167,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9167,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0432, RA-DEC 00:41:55.6-73:08:05.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9168,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9168,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1123, RA-DEC 00:48:12.6-73:00:53.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9169,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9169,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1408, RA-DEC 00:49:54.5-73:13:23.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9170,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9170,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1436, RA-DEC 00:50:04.1-73:07:59.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9171,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9171,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1498, RA-DEC 00:50:27.2-73:01:29.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9172,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9172,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4406, RA-DEC 01:13:40.0-71:27:26.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9173,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9173,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0858, RA-DEC 00:46:21.7-72:54:08.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9174,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9174,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0998, RA-DEC 00:47:32.1-73:11:52.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9175,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9175,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2881, RA-DEC 00:58:46.7-72:03:55.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9176,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9176,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4044, RA-DEC 01:08:29.7-72:40:38.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9177,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9177,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4723, RA-DEC 00:49:22.6-69:30:29.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9178,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9178,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0939, RA-DEC 00:47:03.4-73:02:04.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9179,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9179,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3260, RA-DEC 01:01:28.3-73:25:26.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9180,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9180,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3741, RA-DEC 01:05:27.9-71:40:11.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9181,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9181,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1653, RA-DEC 00:51:18.5-73:41:50.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9182,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9182,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2744, RA-DEC 00:57:48.6-72:11:03.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9183,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9183,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3469, RA-DEC 01:03:12.2-73:09:04.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9184,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,NULL,9184,19.08,0.07,0.0654,2163,NULL,NULL,'HV 01335, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9185,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9185,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0630, RA-DEC 00:44:20.8-73:11:58.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9186,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9186,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4534, RA-DEC 01:16:58.7-71:56:08.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9187,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9187,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2348, RA-DEC 00:55:08.3-73:00:45.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9188,'Cepheids','2016-12-15 15:13:38','2016-12-16 11:18:40','1',NULL,'R',9188,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0804, RA-DEC 00:45:59.5-73:58:52.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9189,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9189,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2687, RA-DEC 00:57:27.0-73:14:06.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9190,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9190,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2875, RA-DEC 00:58:45.4-72:44:26.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9191,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9191,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2951, RA-DEC 00:59:11.9-73:25:29.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9192,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9192,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2961, RA-DEC 00:59:14.4-73:15:50.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9193,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9193,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1501, RA-DEC 00:50:28.4-73:27:51.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9194,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9194,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3243, RA-DEC 01:01:18.2-72:52:56.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9195,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9195,19.08,0.06,0.0654,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4540, RA-DEC 01:17:11.7-71:31:08.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9196,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9196,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1391, RA-DEC 00:49:47.2-73:01:49.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9197,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9197,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2013, RA-DEC 00:53:11.9-72:43:40.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9198,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9198,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2906, RA-DEC 00:58:55.2-71:39:03.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9199,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9199,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0541, RA-DEC 00:43:29.7-73:00:09.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9200,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9200,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1517, RA-DEC 00:50:34.9-73:01:39.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9201,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9201,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3220, RA-DEC 01:01:08.0-72:53:36.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9202,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9202,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3933, RA-DEC 01:07:20.8-73:12:43.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9203,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9203,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4175, RA-DEC 01:10:01.2-72:38:53.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9204,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9204,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0489, RA-DEC 00:42:56.1-73:09:35.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9205,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9205,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0625, RA-DEC 00:44:17.8-73:12:09.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9206,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9206,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1318, RA-DEC 00:49:22.9-73:42:10.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9207,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9207,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2405, RA-DEC 00:55:33.3-73:25:54.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9208,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9208,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2660, RA-DEC 00:57:15.7-72:54:23.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9209,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9209,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3190, RA-DEC 01:00:52.4-72:07:16.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9210,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9210,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4637, RA-DEC 00:00:00.0-75:11:41.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9211,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9211,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0762, RA-DEC 00:45:35.1-73:25:29.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9212,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9212,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0935, RA-DEC 00:47:00.2-72:31:52.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9213,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9213,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2163, RA-DEC 00:54:01.6-72:48:12.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9214,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9214,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2316, RA-DEC 00:54:59.2-72:28:39.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9215,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9215,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3075, RA-DEC 01:00:04.5-72:47:36.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9216,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9216,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4642, RA-DEC 00:12:46.0-74:30:43.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9217,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9217,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0141, RA-DEC 00:31:35.6-73:52:55.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9218,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9218,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1292, RA-DEC 00:49:15.9-72:52:46.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9219,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9219,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1578, RA-DEC 00:50:57.8-73:12:26.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9220,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9220,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2112, RA-DEC 00:53:45.6-73:15:30.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9221,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9221,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1317, RA-DEC 00:49:22.6-73:05:38.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9222,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9222,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1328, RA-DEC 00:49:25.8-73:14:08.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9223,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9223,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3407, RA-DEC 01:02:38.7-73:14:12.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9224,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9224,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3819, RA-DEC 01:06:13.5-72:47:45.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9225,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9225,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0648, RA-DEC 00:44:27.1-72:53:38.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9226,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9226,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0701, RA-DEC 00:45:01.9-74:00:25.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9227,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9227,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1187, RA-DEC 00:48:35.5-73:20:57.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9228,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9228,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1711, RA-DEC 00:51:35.7-72:16:22.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9229,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9229,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3000, RA-DEC 00:59:29.9-73:23:53.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9230,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9230,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3364, RA-DEC 01:02:17.5-73:06:03.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9231,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9231,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0551, RA-DEC 00:43:37.1-73:07:44.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9232,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9232,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0791, RA-DEC 00:45:53.7-73:09:15.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9233,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9233,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2572, RA-DEC 00:56:37.2-72:59:54.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9234,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9234,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2788, RA-DEC 00:58:09.8-71:57:03.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9235,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9235,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0395, RA-DEC 00:41:14.4-73:32:34.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9236,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9236,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0520, RA-DEC 00:43:12.7-72:51:26.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9237,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9237,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0681, RA-DEC 00:44:44.9-73:19:52.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9238,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9238,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1303, RA-DEC 00:49:19.0-72:16:06.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9239,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9239,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2844, RA-DEC 00:58:33.2-73:05:20.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9240,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9240,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2510, RA-DEC 00:56:10.6-72:34:11.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9241,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9241,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3008, RA-DEC 00:59:32.8-73:11:06.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9242,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9242,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3296, RA-DEC 01:01:45.4-72:45:09.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9243,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9243,19.08,0.06,0.0655,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3437, RA-DEC 01:02:52.7-73:04:19.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9244,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9244,19.08,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1506, RA-DEC 00:50:30.2-73:33:20.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9245,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9245,19.08,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3465, RA-DEC 01:03:11.0-72:55:45.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9246,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9246,19.08,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1080, RA-DEC 00:47:59.7-72:55:12.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9247,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9247,19.08,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1690, RA-DEC 00:51:27.1-72:51:45.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9248,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9248,19.08,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0382, RA-DEC 00:40:54.6-73:29:10.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9249,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9249,19.08,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2940, RA-DEC 00:59:06.8-72:17:43.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9250,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9250,19.08,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4331, RA-DEC 01:12:16.8-72:46:10.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9251,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9251,19.08,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4360, RA-DEC 01:12:49.4-72:00:51.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9252,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9252,19.08,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4855, RA-DEC 01:20:16.9-74:18:22.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9253,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9253,19.08,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0666, RA-DEC 00:44:34.4-73:16:37.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9254,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9254,19.08,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1530, RA-DEC 00:50:40.5-72:55:07.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9255,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9255,19.08,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1568, RA-DEC 00:50:55.6-73:01:29.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9256,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9256,19.08,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1793, RA-DEC 00:51:59.8-73:06:20.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9257,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9257,19.08,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2236, RA-DEC 00:54:31.8-71:50:43.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9258,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9258,19.08,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2833, RA-DEC 00:58:26.8-73:10:40.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9259,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9259,19.08,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3297, RA-DEC 01:01:45.5-71:43:00.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9260,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9260,19.08,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2441, RA-DEC 00:55:46.8-72:02:55.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9261,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9261,19.08,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3307, RA-DEC 01:01:47.9-72:16:38.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9262,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9262,19.08,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1338, RA-DEC 00:49:30.0-73:09:17.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9263,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9263,19.08,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1370, RA-DEC 00:49:41.8-72:38:03.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9264,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9264,19.08,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1907, RA-DEC 00:52:32.2-72:33:31.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9265,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9265,19.08,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3556, RA-DEC 01:03:57.2-72:44:08.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9266,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9266,19.08,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0038, RA-DEC 00:24:33.8-73:02:24.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9267,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9267,19.08,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0177, RA-DEC 00:34:11.3-73:25:52.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9268,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9268,19.08,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2407, RA-DEC 00:55:34.0-72:06:36.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9269,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9269,19.08,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3470, RA-DEC 01:03:12.2-73:19:14.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9270,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9270,19.09,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0981, RA-DEC 00:47:21.6-72:58:13.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9271,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9271,19.09,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2325, RA-DEC 00:55:00.5-72:46:21.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9272,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9272,19.09,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2774, RA-DEC 00:58:03.9-72:52:26.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9273,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9273,19.09,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3122, RA-DEC 01:00:26.5-73:05:31.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9274,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9274,19.09,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0402, RA-DEC 00:41:21.1-73:15:23.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9275,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9275,19.09,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0829, RA-DEC 00:46:11.0-72:46:10.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9276,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9276,19.09,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1927, RA-DEC 00:52:37.2-72:27:09.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9277,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9277,19.09,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2433, RA-DEC 00:55:44.3-73:20:28.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9278,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9278,19.09,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2618, RA-DEC 00:56:57.8-72:43:21.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9279,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9279,19.09,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0737, RA-DEC 00:45:16.3-72:53:20.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9280,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9280,19.09,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1342, RA-DEC 00:49:31.7-72:56:54.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9281,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9281,19.09,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1865, RA-DEC 00:52:18.9-73:22:44.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9282,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9282,19.09,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1997, RA-DEC 00:53:06.5-74:01:18.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9283,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9283,19.09,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3429, RA-DEC 01:02:48.6-73:26:01.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9284,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9284,19.09,0.06,0.0656,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4813, RA-DEC 01:08:52.5-71:14:41.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9285,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9285,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3157, RA-DEC 01:00:40.0-73:18:07.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9286,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9286,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3553, RA-DEC 01:03:54.1-73:05:58.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9287,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9287,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3607, RA-DEC 01:04:13.9-72:32:32.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9288,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9288,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0302, RA-DEC 00:39:04.3-73:16:52.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9289,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9289,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1151, RA-DEC 00:48:22.6-73:23:51.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9290,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9290,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1561, RA-DEC 00:50:54.3-72:41:18.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9291,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9291,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0721, RA-DEC 00:45:11.6-73:14:03.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9292,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9292,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0938, RA-DEC 00:47:03.0-72:56:03.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9293,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9293,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1012, RA-DEC 00:47:37.1-73:03:00.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9294,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9294,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2087, RA-DEC 00:53:39.0-71:45:38.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9295,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9295,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2853, RA-DEC 00:58:36.5-73:24:05.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9296,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9296,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3512, RA-DEC 01:03:30.8-71:29:56.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9297,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9297,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3915, RA-DEC 01:07:10.0-71:24:24.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9298,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9298,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0801, RA-DEC 00:45:58.9-73:23:08.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9299,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9299,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2817, RA-DEC 00:58:21.5-72:58:50.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9300,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9300,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2870, RA-DEC 00:58:42.9-72:56:22.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9301,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9301,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0689, RA-DEC 00:44:51.7-73:33:57.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9302,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9302,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1206, RA-DEC 00:48:46.0-74:07:29.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9303,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9303,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0588, RA-DEC 00:43:59.4-73:19:51.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9304,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9304,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1750, RA-DEC 00:51:49.1-73:21:55.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9305,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9305,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3306, RA-DEC 01:01:47.4-71:47:05.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9306,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9306,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0060, RA-DEC 00:25:57.5-74:14:41.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9307,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9307,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0312, RA-DEC 00:39:25.7-74:16:10.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9308,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9308,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2603, RA-DEC 00:56:50.3-72:56:51.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9309,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9309,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3425, RA-DEC 01:02:46.1-71:32:19.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9310,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9310,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0443, RA-DEC 00:42:06.0-73:03:41.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9311,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9311,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1781, RA-DEC 00:51:58.0-72:40:39.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9312,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9312,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4473, RA-DEC 01:15:06.6-71:41:39.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9313,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9313,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1644, RA-DEC 00:51:15.9-72:43:36.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9314,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9314,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1737, RA-DEC 00:51:45.5-72:31:04.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9315,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9315,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2811, RA-DEC 00:58:19.6-73:07:06.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9316,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9316,19.09,0.06,0.0657,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4176, RA-DEC 01:10:02.1-72:41:37.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9317,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9317,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0437, RA-DEC 00:41:59.5-73:04:46.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9318,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9318,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2646, RA-DEC 00:57:09.1-73:21:42.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9319,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9319,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3403, RA-DEC 01:02:37.1-72:49:30.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9320,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9320,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1447, RA-DEC 00:50:08.0-72:38:24.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9321,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9321,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2558, RA-DEC 00:56:31.1-72:45:56.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9322,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9322,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0389, RA-DEC 00:41:06.2-72:42:59.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9323,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9323,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0523, RA-DEC 00:43:17.3-73:05:01.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9324,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9324,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1014, RA-DEC 00:47:37.9-73:22:42.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9325,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9325,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1500, RA-DEC 00:50:28.0-72:17:45.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9326,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9326,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2780, RA-DEC 00:58:06.3-73:18:24.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9327,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9327,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0055, RA-DEC 00:25:31.4-73:32:47.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9328,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9328,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0747, RA-DEC 00:45:23.4-73:02:13.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9329,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9329,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1072, RA-DEC 00:47:56.6-73:29:21.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9330,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9330,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2285, RA-DEC 00:54:50.1-73:05:47.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9331,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9331,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2715, RA-DEC 00:57:37.9-72:55:39.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9332,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9332,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3154, RA-DEC 01:00:39.1-72:36:11.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9333,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9333,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0073, RA-DEC 00:26:44.2-72:46:35.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9334,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9334,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1093, RA-DEC 00:48:02.5-72:51:27.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9335,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9335,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1669, RA-DEC 00:51:22.0-73:00:42.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9336,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9336,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1728, RA-DEC 00:51:39.9-73:10:45.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9337,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9337,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0184, RA-DEC 00:34:35.0-73:10:49.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9338,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9338,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0435, RA-DEC 00:41:58.6-74:09:14.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9339,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9339,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0772, RA-DEC 00:45:41.8-72:49:32.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9340,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9340,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1063, RA-DEC 00:47:53.9-72:24:11.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9341,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9341,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1164, RA-DEC 00:48:28.0-73:35:51.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9342,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9342,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1310, RA-DEC 00:49:21.3-73:47:55.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9343,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,NULL,9343,19.09,0.03,0.0658,2163,NULL,NULL,'92, I','SMC',NULL,'2016ApJ...816...49S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9344,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9344,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0230, RA-DEC 00:36:03.5-73:55:58.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9345,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9345,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0565, RA-DEC 00:43:43.1-72:47:50.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9346,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9346,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0769, RA-DEC 00:45:39.8-72:52:53.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9347,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9347,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0805, RA-DEC 00:45:59.7-72:51:20.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9348,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9348,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1553, RA-DEC 00:50:51.5-73:14:01.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9349,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9349,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1591, RA-DEC 00:51:00.3-72:03:18.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9350,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9350,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1630, RA-DEC 00:51:11.1-72:59:45.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9351,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9351,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1699, RA-DEC 00:51:29.9-73:42:51.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9352,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9352,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1757, RA-DEC 00:51:52.5-72:35:44.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9353,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9353,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1948, RA-DEC 00:52:48.0-72:12:18.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9354,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9354,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3096, RA-DEC 01:00:14.8-73:17:59.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9355,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9355,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0841, RA-DEC 00:46:14.6-73:10:09.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9356,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9356,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1376, RA-DEC 00:49:42.7-73:05:29.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9357,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9357,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1658, RA-DEC 00:51:20.6-73:01:48.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9358,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9358,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2403, RA-DEC 00:55:33.0-72:54:30.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9359,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9359,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4564, RA-DEC 01:18:20.7-74:04:24.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9360,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9360,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0709, RA-DEC 00:45:04.7-72:59:04.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9361,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9361,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1043, RA-DEC 00:47:48.3-73:14:17.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9362,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9362,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1527, RA-DEC 00:50:39.1-73:03:21.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9363,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9363,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1685, RA-DEC 00:51:26.0-72:50:46.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9364,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9364,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1905, RA-DEC 00:52:31.4-73:15:34.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9365,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9365,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2753, RA-DEC 00:57:54.5-73:30:51.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9366,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9366,19.09,0.06,0.0658,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3640, RA-DEC 01:04:29.9-71:29:36.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9367,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9367,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0557, RA-DEC 00:43:39.2-73:06:23.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9368,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9368,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1702, RA-DEC 00:51:31.1-73:48:33.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9369,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9369,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3589, RA-DEC 01:04:09.2-73:35:48.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9370,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9370,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0449, RA-DEC 00:42:11.3-73:15:19.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9371,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9371,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2317, RA-DEC 00:54:59.2-72:47:15.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9372,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9372,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2759, RA-DEC 00:57:57.6-72:38:08.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9373,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9373,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4187, RA-DEC 01:10:07.0-72:15:33.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9374,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9374,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4480, RA-DEC 01:15:24.2-72:42:07.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9375,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9375,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1005, RA-DEC 00:47:34.9-73:29:37.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9376,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9376,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1104, RA-DEC 00:48:05.4-73:09:54.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9377,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9377,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1652, RA-DEC 00:51:18.5-73:12:19.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9378,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9378,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1922, RA-DEC 00:52:36.5-73:42:29.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9379,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9379,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0041, RA-DEC 00:24:59.3-73:21:35.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9380,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9380,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0285, RA-DEC 00:38:31.2-73:49:20.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9381,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9381,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0300, RA-DEC 00:38:58.7-72:45:36.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9382,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9382,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0421, RA-DEC 00:41:48.5-73:17:41.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9383,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9383,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1040, RA-DEC 00:47:48.0-73:12:49.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9384,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9384,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1088, RA-DEC 00:48:00.7-72:54:20.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9385,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9385,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1234, RA-DEC 00:48:54.1-72:58:35.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9386,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9386,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1445, RA-DEC 00:50:07.5-72:38:13.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9387,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9387,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1520, RA-DEC 00:50:35.7-73:17:54.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9388,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9388,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2307, RA-DEC 00:54:56.9-72:55:23.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9389,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9389,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2332, RA-DEC 00:55:03.0-73:13:59.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9390,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9390,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2789, RA-DEC 00:58:10.1-73:10:40.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9391,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9391,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3198, RA-DEC 01:00:57.2-73:09:06.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9392,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9392,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3380, RA-DEC 01:02:26.6-74:01:38.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9393,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9393,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0147, RA-DEC 00:32:00.1-73:54:37.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9394,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9394,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0387, RA-DEC 00:41:03.9-73:31:39.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9395,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9395,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1276, RA-DEC 00:49:11.8-72:57:35.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9396,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9396,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1353, RA-DEC 00:49:35.2-72:43:19.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9397,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9397,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2648, RA-DEC 00:57:10.0-73:06:06.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9398,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9398,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4156, RA-DEC 01:09:48.1-73:03:04.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9399,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9399,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0836, RA-DEC 00:46:12.3-73:23:42.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9400,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9400,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2565, RA-DEC 00:56:34.0-73:31:25.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9401,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9401,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3399, RA-DEC 01:02:35.2-73:12:12.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9402,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9402,19.09,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4689, RA-DEC 00:33:32.8-75:22:29.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9403,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9403,19.1,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0674, RA-DEC 00:44:41.4-73:08:02.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9404,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9404,19.1,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1953, RA-DEC 00:52:49.3-73:22:18.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9405,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9405,19.1,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3621, RA-DEC 01:04:19.9-72:50:13.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9406,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9406,19.1,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0463, RA-DEC 00:42:22.9-73:22:10.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9407,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9407,19.1,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3378, RA-DEC 01:02:25.4-73:42:23.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9408,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9408,19.1,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3638, RA-DEC 01:04:27.5-71:29:41.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9409,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9409,19.1,0.06,0.0659,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2340, RA-DEC 00:55:06.1-72:32:55.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9410,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9410,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0618, RA-DEC 00:44:12.8-73:05:56.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9411,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9411,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3197, RA-DEC 01:00:57.2-73:32:34.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9412,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9412,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0026, RA-DEC 00:23:44.0-73:22:56.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9413,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9413,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0029, RA-DEC 00:24:07.2-73:56:26.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9414,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9414,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3133, RA-DEC 01:00:29.6-73:31:01.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9415,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9415,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1228, RA-DEC 00:48:52.5-73:18:15.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9416,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9416,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2424, RA-DEC 00:55:39.5-72:56:33.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9417,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9417,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3034, RA-DEC 00:59:45.5-72:30:59.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9418,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9418,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0531, RA-DEC 00:43:25.1-72:50:42.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9419,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9419,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0890, RA-DEC 00:46:35.1-73:10:27.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9420,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9420,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0910, RA-DEC 00:46:46.9-73:24:26.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9421,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9421,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1696, RA-DEC 00:51:28.5-73:30:07.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9422,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9422,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1924, RA-DEC 00:52:36.6-72:36:41.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9423,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9423,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2724, RA-DEC 00:57:41.5-73:16:02.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9424,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9424,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3277, RA-DEC 01:01:35.6-72:45:09.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9425,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9425,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0143, RA-DEC 00:31:39.7-72:40:34.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9426,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9426,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0146, RA-DEC 00:31:57.8-73:37:33.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9427,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9427,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2466, RA-DEC 00:55:55.0-73:35:32.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9428,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9428,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3506, RA-DEC 01:03:28.5-71:46:29.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9429,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9429,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3555, RA-DEC 01:03:55.7-72:46:33.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9430,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9430,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3785, RA-DEC 01:05:53.5-72:50:41.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9431,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9431,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4413, RA-DEC 01:13:43.6-71:25:18.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9432,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9432,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1870, RA-DEC 00:52:19.9-73:25:42.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9433,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9433,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3935, RA-DEC 01:07:21.6-72:38:58.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9434,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9434,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4347, RA-DEC 01:12:38.4-73:01:51.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9435,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9435,19.1,0.09,0.066,2163,NULL,NULL,'HV 1333, 1, VK(W)','SMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9436,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,NULL,9436,19.09,0.02,0.066,2163,NULL,NULL,'V, V-K','SMC',NULL,'1995ApJ...452..195D',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9437,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9437,19.09,0.23,0.066,2163,NULL,NULL,'HV 1335, 1, V-R (BW)','SMC',NULL,'1999ASPC..167..320S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9438,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9438,19.1,NULL,0.066,2163,NULL,NULL,'PCL','SMC',NULL,'1999IAUS..190..557M',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9439,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,NULL,9439,19.11,0.11,0.066,2163,NULL,NULL,'W','SMC',NULL,'2000A&A...363..901G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9440,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9440,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1197, RA-DEC 00:48:39.5-72:50:02.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9441,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9441,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2136, RA-DEC 00:53:55.2-73:24:03.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9442,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9442,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0418, RA-DEC 00:41:44.7-73:14:33.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9443,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9443,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0605, RA-DEC 00:44:04.5-73:22:40.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9444,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9444,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0851, RA-DEC 00:46:18.7-73:07:16.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9445,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9445,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0944, RA-DEC 00:47:05.1-73:01:46.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9446,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9446,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1594, RA-DEC 00:51:00.8-73:10:27.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9447,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9447,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1847, RA-DEC 00:52:14.9-73:01:02.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9448,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9448,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0233, RA-DEC 00:36:11.2-73:45:02.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9449,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9449,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1464, RA-DEC 00:50:13.9-72:53:03.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9450,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9450,19.1,0.06,0.066,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2007, RA-DEC 00:53:10.3-73:19:21.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9451,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9451,19.1,0.06,0.0661,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0788, RA-DEC 00:45:52.8-72:53:34.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9452,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9452,19.1,0.06,0.0661,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0933, RA-DEC 00:46:58.8-73:14:44.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9453,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9453,19.1,0.06,0.0661,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2226, RA-DEC 00:54:26.5-73:16:06.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9454,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9454,19.1,0.06,0.0661,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2804, RA-DEC 00:58:16.6-72:24:01.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9455,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9455,19.1,0.06,0.0661,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1356, RA-DEC 00:49:36.2-73:24:00.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9456,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9456,19.1,0.06,0.0661,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1427, RA-DEC 00:50:01.1-73:14:42.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9457,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9457,19.1,0.06,0.0661,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1713, RA-DEC 00:51:36.2-72:30:10.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9458,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9458,19.1,0.06,0.0661,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3954, RA-DEC 01:07:30.0-72:39:30.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9459,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9459,19.1,0.06,0.0661,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1601, RA-DEC 00:51:03.3-73:34:31.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9460,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9460,19.1,0.06,0.0661,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3395, RA-DEC 01:02:32.1-71:44:00.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9461,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9461,19.1,0.06,0.0661,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3646, RA-DEC 01:04:31.5-72:37:09.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9462,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9462,19.1,0.06,0.0661,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0582, RA-DEC 00:43:55.5-73:08:24.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9463,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9463,19.1,0.06,0.0661,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0748, RA-DEC 00:45:23.6-72:59:08.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9464,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9464,19.1,0.06,0.0661,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2345, RA-DEC 00:55:07.7-72:39:32.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9465,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9465,19.1,0.06,0.0661,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1531, RA-DEC 00:50:41.4-73:47:32.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9466,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9466,19.1,0.06,0.0661,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0471, RA-DEC 00:42:39.6-72:45:14.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9467,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,'R',9467,19.1,0.06,0.0661,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2717, RA-DEC 00:57:38.5-73:13:19.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9468,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,NULL,9468,19.1,NULL,0.0661,2163,NULL,NULL,NULL,'SMC',NULL,'2012ApJ...745..104N',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9469,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:40','1',NULL,NULL,9469,19.1,0.02,0.0661,2163,NULL,NULL,'HV 00824, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9470,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9470,19.1,0.06,0.0661,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1791, RA-DEC 00:51:59.5-73:40:54.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9471,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9471,19.1,0.06,0.0661,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2931, RA-DEC 00:59:04.0-73:27:46.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9472,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9472,19.1,0.06,0.0661,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1098, RA-DEC 00:48:03.8-72:56:22.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9473,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9473,19.1,0.06,0.0661,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2941, RA-DEC 00:59:06.9-72:38:39.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9474,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9474,19.1,0.06,0.0661,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3106, RA-DEC 01:00:18.1-73:27:34.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9475,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9475,19.1,0.06,0.0661,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3178, RA-DEC 01:00:48.1-73:07:15.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9476,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9476,19.1,0.06,0.0661,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0708, RA-DEC 00:45:04.6-73:00:11.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9477,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9477,19.1,0.06,0.0661,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2499, RA-DEC 00:56:07.0-72:55:06.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9478,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9478,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3240, RA-DEC 01:01:17.2-73:36:17.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9479,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9479,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0364, RA-DEC 00:40:34.9-73:30:04.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9480,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9480,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2847, RA-DEC 00:58:34.9-73:55:14.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9481,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9481,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3965, RA-DEC 01:07:36.1-72:46:43.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9482,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9482,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1467, RA-DEC 00:50:15.7-72:49:50.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9483,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9483,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1672, RA-DEC 00:51:23.1-72:46:23.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9484,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9484,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1920, RA-DEC 00:52:36.0-72:39:18.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9485,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9485,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1930, RA-DEC 00:52:38.6-72:42:30.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9486,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9486,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2661, RA-DEC 00:57:15.7-72:58:36.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9487,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9487,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3147, RA-DEC 01:00:37.5-72:11:44.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9488,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9488,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4357, RA-DEC 01:12:46.7-72:25:37.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9489,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9489,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0974, RA-DEC 00:47:19.6-72:50:48.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9490,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9490,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1302, RA-DEC 00:49:19.0-72:35:59.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9491,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9491,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3816, RA-DEC 01:06:11.1-73:09:22.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9492,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9492,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0301, RA-DEC 00:39:03.6-73:28:05.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9493,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9493,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0973, RA-DEC 00:47:19.1-73:19:15.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9494,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9494,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1714, RA-DEC 00:51:36.3-73:44:02.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9495,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9495,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2795, RA-DEC 00:58:12.2-71:42:57.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9496,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9496,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4532, RA-DEC 01:16:56.1-73:22:45.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9497,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9497,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0374, RA-DEC 00:40:46.1-73:43:01.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9498,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9498,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0759, RA-DEC 00:45:31.3-72:59:26.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9499,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9499,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0806, RA-DEC 00:46:00.2-72:55:33.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9500,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9500,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2346, RA-DEC 00:55:08.1-73:05:49.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9501,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9501,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0034, RA-DEC 00:24:18.5-73:00:55.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9502,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9502,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1194, RA-DEC 00:48:37.7-73:03:42.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9503,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9503,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2072, RA-DEC 00:53:31.3-73:12:22.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9504,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9504,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2336, RA-DEC 00:55:05.0-73:07:19.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9505,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9505,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2902, RA-DEC 00:58:53.7-71:49:27.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9506,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9506,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4088, RA-DEC 01:09:04.2-73:18:25.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9507,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9507,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4404, RA-DEC 01:13:37.4-72:52:03.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9508,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9508,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0139, RA-DEC 00:31:34.5-72:52:26.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9509,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9509,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1992, RA-DEC 00:53:03.6-73:22:16.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9510,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9510,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2111, RA-DEC 00:53:45.6-72:34:04.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9511,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9511,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2882, RA-DEC 00:58:46.7-73:08:21.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9512,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9512,19.1,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3209, RA-DEC 01:01:02.0-72:56:55.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9513,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9513,19.11,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0074, RA-DEC 00:26:46.6-73:06:41.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9514,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9514,19.11,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1435, RA-DEC 00:50:04.0-73:24:55.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9515,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9515,19.11,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3118, RA-DEC 01:00:22.5-72:50:51.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9516,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9516,19.11,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3387, RA-DEC 01:02:28.2-72:39:39.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9517,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9517,19.11,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0194, RA-DEC 00:34:46.0-73:05:45.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9518,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9518,19.11,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0218, RA-DEC 00:35:41.4-73:40:15.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9519,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9519,19.11,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0568, RA-DEC 00:43:44.9-73:39:06.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9520,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9520,19.11,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0947, RA-DEC 00:47:06.2-73:35:02.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9521,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9521,19.11,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1897, RA-DEC 00:52:29.9-72:42:38.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9522,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9522,19.11,0.06,0.0662,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2127, RA-DEC 00:53:51.5-73:55:24.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9523,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9523,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0157, RA-DEC 00:33:08.5-73:52:04.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9524,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9524,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3569, RA-DEC 01:04:02.1-73:12:51.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9525,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9525,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0814, RA-DEC 00:46:03.7-73:03:56.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9526,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9526,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2234, RA-DEC 00:54:31.4-72:30:43.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9527,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9527,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2818, RA-DEC 00:58:21.8-72:17:18.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9528,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9528,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0215, RA-DEC 00:35:33.1-73:31:12.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9529,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9529,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0745, RA-DEC 00:45:21.7-73:18:27.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9530,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9530,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1489, RA-DEC 00:50:25.1-72:43:20.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9531,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9531,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1638, RA-DEC 00:51:13.5-73:17:09.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9532,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9532,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1872, RA-DEC 00:52:20.7-72:44:46.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9533,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9533,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2011, RA-DEC 00:53:11.5-73:26:26.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9534,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9534,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2757, RA-DEC 00:57:56.4-72:54:27.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9535,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9535,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4217, RA-DEC 01:10:35.9-72:55:56.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9536,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9536,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0848, RA-DEC 00:46:17.0-73:19:30.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9537,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9537,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0862, RA-DEC 00:46:23.4-73:18:57.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9538,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9538,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0934, RA-DEC 00:46:59.7-73:29:20.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9539,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9539,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2430, RA-DEC 00:55:41.8-73:21:30.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9540,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9540,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2534, RA-DEC 00:56:20.9-73:18:22.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9541,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9541,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1999, RA-DEC 00:53:07.5-73:14:16.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9542,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9542,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2339, RA-DEC 00:55:05.9-73:13:28.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9543,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9543,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3447, RA-DEC 01:02:58.3-72:45:39.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9544,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9544,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4398, RA-DEC 01:13:30.0-72:14:30.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9545,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9545,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0282, RA-DEC 00:38:17.0-73:48:52.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9546,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9546,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0384, RA-DEC 00:41:00.3-73:52:52.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9547,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9547,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0959, RA-DEC 00:47:10.5-72:58:44.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9548,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9548,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2252, RA-DEC 00:54:36.6-73:43:14.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9549,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9549,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2319, RA-DEC 00:54:59.3-73:14:24.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9550,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9550,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2585, RA-DEC 00:56:41.6-72:54:31.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9551,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9551,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3412, RA-DEC 01:02:41.8-73:23:11.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9552,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9552,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0058, RA-DEC 00:25:35.1-73:37:17.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9553,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9553,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0898, RA-DEC 00:46:39.8-72:56:12.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9554,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9554,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1253, RA-DEC 00:49:04.0-73:10:30.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9555,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9555,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1270, RA-DEC 00:49:09.3-73:34:55.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9556,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9556,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1973, RA-DEC 00:52:55.2-73:36:37.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9557,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9557,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2735, RA-DEC 00:57:44.4-72:47:00.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9558,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9558,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2779, RA-DEC 00:58:05.9-73:24:01.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9559,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9559,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2885, RA-DEC 00:58:47.2-72:34:27.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9560,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9560,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0726, RA-DEC 00:45:12.6-73:11:47.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9561,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9561,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0860, RA-DEC 00:46:22.7-72:56:09.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9562,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9562,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1875, RA-DEC 00:52:21.4-73:03:03.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9563,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9563,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2104, RA-DEC 00:53:43.8-73:28:25.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9564,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9564,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2515, RA-DEC 00:56:11.7-72:34:52.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9565,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9565,19.11,0.06,0.0663,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4047, RA-DEC 01:08:33.5-73:02:40.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9566,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9566,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0627, RA-DEC 00:44:18.8-73:12:48.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9567,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9567,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2128, RA-DEC 00:53:51.8-72:53:11.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9568,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9568,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2769, RA-DEC 00:58:02.4-72:42:10.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9569,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9569,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1990, RA-DEC 00:53:03.3-72:44:56.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9570,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9570,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2537, RA-DEC 00:56:22.6-72:57:34.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9571,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9571,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2985, RA-DEC 00:59:24.3-72:52:33.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9572,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9572,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3708, RA-DEC 01:05:10.0-72:49:22.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9573,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9573,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3797, RA-DEC 01:06:00.0-73:34:39.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9574,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9574,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1466, RA-DEC 00:50:15.3-72:34:26.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9575,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9575,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2776, RA-DEC 00:58:04.3-73:27:50.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9576,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9576,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3664, RA-DEC 01:04:45.3-73:04:45.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9577,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9577,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0322, RA-DEC 00:39:36.5-73:39:04.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9578,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9578,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0965, RA-DEC 00:47:15.4-73:12:50.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9579,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9579,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1160, RA-DEC 00:48:25.2-73:17:44.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9580,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9580,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1555, RA-DEC 00:50:52.5-73:22:42.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9581,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9581,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3081, RA-DEC 01:00:08.1-72:59:11.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9582,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9582,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0662, RA-DEC 00:44:32.9-72:48:39.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9583,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9583,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2050, RA-DEC 00:53:23.1-72:33:45.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9584,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9584,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2245, RA-DEC 00:54:34.0-73:03:23.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9585,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9585,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3821, RA-DEC 01:06:14.4-73:07:58.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9586,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9586,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0015, RA-DEC 00:22:49.2-74:13:23.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9587,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9587,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0150, RA-DEC 00:32:14.5-73:56:58.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9588,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9588,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0207, RA-DEC 00:35:10.4-73:55:12.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9589,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9589,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0634, RA-DEC 00:44:21.5-73:24:18.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9590,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9590,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0678, RA-DEC 00:44:43.7-73:24:21.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9591,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9591,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2258, RA-DEC 00:54:39.4-73:01:00.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9592,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9592,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2457, RA-DEC 00:55:52.7-73:11:59.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9593,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9593,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3890, RA-DEC 01:06:59.0-73:02:10.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9594,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9594,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3985, RA-DEC 01:07:51.1-71:31:16.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9595,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9595,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4528, RA-DEC 01:16:49.3-72:53:15.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9596,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,NULL,9596,19.11,0.08,0.0664,2163,NULL,NULL,'second overtone Cepheids','SMC',NULL,'2001MNRAS.325.1353B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9597,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,NULL,9597,19.11,0.07,0.0664,2163,NULL,NULL,'13, IV, V','SMC',NULL,'1985ApJ...288..182V',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9598,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9598,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0641, RA-DEC 00:44:25.6-72:46:00.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9599,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9599,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0743, RA-DEC 00:45:20.3-74:11:13.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9600,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9600,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1249, RA-DEC 00:49:02.9-73:15:51.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9601,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9601,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2126, RA-DEC 00:53:50.9-73:52:02.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9602,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9602,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2967, RA-DEC 00:59:18.4-73:13:51.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9603,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9603,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4257, RA-DEC 01:11:13.7-72:42:59.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9604,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9604,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0127, RA-DEC 00:30:34.9-72:59:09.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9605,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9605,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2093, RA-DEC 00:53:40.6-73:33:52.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9606,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9606,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2947, RA-DEC 00:59:10.9-73:02:00.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9607,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9607,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3711, RA-DEC 01:05:11.9-73:06:21.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9608,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9608,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0013, RA-DEC 00:22:40.4-73:31:00.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9609,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9609,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0078, RA-DEC 00:27:24.6-73:15:56.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9610,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9610,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0831, RA-DEC 00:46:11.4-73:26:55.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9611,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9611,19.11,0.06,0.0664,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2671, RA-DEC 00:57:19.8-72:35:12.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9612,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9612,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0012, RA-DEC 00:22:30.7-73:25:27.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9613,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9613,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0486, RA-DEC 00:42:53.2-72:29:32.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9614,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9614,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0749, RA-DEC 00:45:24.0-73:26:15.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9615,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9615,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1614, RA-DEC 00:51:08.1-73:41:43.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9616,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9616,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1903, RA-DEC 00:52:31.3-72:38:12.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9617,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9617,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2036, RA-DEC 00:53:19.2-73:43:41.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9618,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9618,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2609, RA-DEC 00:56:53.2-72:48:49.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9619,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9619,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3110, RA-DEC 01:00:19.5-72:13:24.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9620,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9620,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4876, RA-DEC 01:26:27.8-64:52:31.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9621,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9621,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1503, RA-DEC 00:50:29.4-72:31:47.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9622,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9622,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1511, RA-DEC 00:50:31.6-72:28:40.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9623,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9623,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0368, RA-DEC 00:40:38.6-73:13:14.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9624,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9624,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0669, RA-DEC 00:44:38.1-73:28:00.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9625,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9625,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1312, RA-DEC 00:49:21.8-72:59:46.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9626,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9626,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2009, RA-DEC 00:53:10.6-72:38:24.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9627,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9627,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2614, RA-DEC 00:56:57.1-73:11:38.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9628,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9628,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3141, RA-DEC 01:00:35.3-72:43:21.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9629,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9629,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0784, RA-DEC 00:45:51.0-73:06:56.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9630,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9630,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1416, RA-DEC 00:49:57.2-73:09:51.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9631,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9631,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1609, RA-DEC 00:51:06.1-73:44:03.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9632,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9632,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3734, RA-DEC 01:05:24.6-72:16:05.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9633,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9633,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1584, RA-DEC 00:50:58.4-72:52:57.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9634,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9634,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1909, RA-DEC 00:52:32.7-72:19:35.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9635,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9635,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2273, RA-DEC 00:54:43.4-73:03:02.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9636,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9636,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2551, RA-DEC 00:56:29.9-72:30:28.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9637,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9637,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1238, RA-DEC 00:48:57.5-73:40:08.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9638,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9638,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1736, RA-DEC 00:51:44.4-72:57:58.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9639,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9639,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0244, RA-DEC 00:36:51.2-73:14:42.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9640,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9640,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0420, RA-DEC 00:41:46.1-73:14:14.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9641,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9641,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2734, RA-DEC 00:57:44.4-72:46:16.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9642,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9642,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3358, RA-DEC 01:02:13.8-72:53:32.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9643,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9643,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3615, RA-DEC 01:04:17.2-73:13:00.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9644,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9644,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3795, RA-DEC 01:05:58.4-73:15:16.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9645,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9645,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3968, RA-DEC 01:07:37.7-72:48:08.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9646,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9646,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0879, RA-DEC 00:46:31.4-73:18:59.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9647,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9647,19.11,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2869, RA-DEC 00:58:42.5-72:53:34.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9648,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9648,19.12,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2866, RA-DEC 00:58:40.4-72:45:14.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9649,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9649,19.12,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3343, RA-DEC 01:02:07.3-73:22:57.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9650,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9650,19.12,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4619, RA-DEC 01:23:33.2-73:40:58.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9651,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9651,19.12,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2054, RA-DEC 00:53:25.2-73:14:05.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9652,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9652,19.12,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2887, RA-DEC 00:58:48.7-72:53:07.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9653,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9653,19.12,0.06,0.0665,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3042, RA-DEC 00:59:48.7-73:29:12.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9654,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9654,19.12,0.06,0.0666,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0118, RA-DEC 00:29:49.2-74:05:30.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9655,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9655,19.12,0.06,0.0666,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1745, RA-DEC 00:51:48.1-73:35:25.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9656,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9656,19.12,0.06,0.0666,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0544, RA-DEC 00:43:34.4-73:08:21.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9657,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9657,19.12,0.06,0.0666,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1398, RA-DEC 00:49:50.5-72:32:53.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9658,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9658,19.12,0.06,0.0666,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2806, RA-DEC 00:58:17.2-73:21:10.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9659,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9659,19.12,0.06,0.0666,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3836, RA-DEC 01:06:21.7-73:26:42.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9660,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9660,19.12,0.06,0.0666,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2783, RA-DEC 00:58:07.4-73:08:52.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9661,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9661,19.12,0.06,0.0666,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0638, RA-DEC 00:44:24.0-73:16:31.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9662,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9662,19.12,0.06,0.0666,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0778, RA-DEC 00:45:47.6-72:53:19.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9663,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9663,19.12,0.06,0.0666,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2955, RA-DEC 00:59:12.7-72:34:53.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9664,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9664,19.12,0.06,0.0666,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3500, RA-DEC 01:03:26.1-73:21:37.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9665,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9665,19.12,0.06,0.0666,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4235, RA-DEC 01:10:53.7-72:54:13.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9666,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9666,19.12,0.06,0.0666,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1429, RA-DEC 00:50:01.6-73:26:32.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9667,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9667,19.12,0.06,0.0666,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0679, RA-DEC 00:44:43.7-73:10:33.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9668,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9668,19.12,0.06,0.0666,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1092, RA-DEC 00:48:02.0-73:38:15.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9669,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9669,19.12,0.06,0.0666,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2080, RA-DEC 00:53:34.8-72:40:31.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9670,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9670,19.12,0.06,0.0666,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2854, RA-DEC 00:58:36.7-73:13:49.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9671,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9671,19.12,0.06,0.0666,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4464, RA-DEC 01:14:53.6-72:47:14.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9672,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9672,19.12,0.06,0.0666,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1118, RA-DEC 00:48:08.6-72:40:25.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9673,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9673,19.12,0.06,0.0666,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1396, RA-DEC 00:49:48.7-73:04:09.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9674,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9674,19.12,0.06,0.0666,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1515, RA-DEC 00:50:34.4-73:01:37.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9675,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9675,19.12,0.06,0.0666,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3162, RA-DEC 01:00:42.1-72:51:35.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9676,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9676,19.12,0.06,0.0666,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2459, RA-DEC 00:55:52.9-73:20:33.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9677,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9677,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0503, RA-DEC 00:43:00.6-73:05:28.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9678,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9678,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2393, RA-DEC 00:55:27.7-72:29:41.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9679,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9679,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2465, RA-DEC 00:55:54.6-72:32:30.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9680,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9680,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4679, RA-DEC 00:21:14.8-73:35:57.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9681,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9681,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1643, RA-DEC 00:51:15.8-73:10:47.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9682,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9682,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2141, RA-DEC 00:53:56.7-72:44:14.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9683,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9683,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4270, RA-DEC 01:11:25.3-72:46:50.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9684,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9684,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0245, RA-DEC 00:36:53.7-73:13:33.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9685,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9685,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0945, RA-DEC 00:47:05.5-73:15:17.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9686,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9686,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1862, RA-DEC 00:52:18.2-72:55:56.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9687,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9687,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2821, RA-DEC 00:58:22.6-73:30:03.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9688,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9688,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4174, RA-DEC 01:10:00.5-72:34:23.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9689,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9689,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4684, RA-DEC 00:22:41.4-74:53:14.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9690,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9690,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0056, RA-DEC 00:25:31.6-73:34:58.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9691,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9691,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1460, RA-DEC 00:50:12.0-73:37:51.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9692,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9692,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2976, RA-DEC 00:59:20.7-72:44:08.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9693,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9693,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0477, RA-DEC 00:42:44.5-73:16:19.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9694,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9694,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2172, RA-DEC 00:54:05.3-73:50:08.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9695,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9695,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2729, RA-DEC 00:57:43.2-72:53:44.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9696,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9696,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3980, RA-DEC 01:07:48.2-73:26:24.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9697,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9697,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0113, RA-DEC 00:29:35.0-73:43:16.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9698,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9698,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0590, RA-DEC 00:44:01.1-73:05:43.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9699,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9699,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1369, RA-DEC 00:49:41.4-72:59:17.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9700,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9700,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1829, RA-DEC 00:52:08.4-72:38:45.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9701,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9701,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3114, RA-DEC 01:00:21.0-72:32:31.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9702,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9702,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0385, RA-DEC 00:41:00.5-73:07:04.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9703,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9703,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1959, RA-DEC 00:52:51.8-73:24:19.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9704,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9704,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2311, RA-DEC 00:54:58.0-73:32:44.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9705,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9705,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2350, RA-DEC 00:55:09.5-72:39:16.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9706,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9706,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4793, RA-DEC 01:06:19.7-71:04:55.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9707,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9707,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0750, RA-DEC 00:45:24.5-73:02:58.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9708,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9708,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1722, RA-DEC 00:51:39.2-73:08:52.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9709,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9709,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3254, RA-DEC 01:01:23.5-73:10:05.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9710,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9710,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1341, RA-DEC 00:49:30.6-73:23:11.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9711,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9711,19.12,0.06,0.0667,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3605, RA-DEC 01:04:13.3-73:11:55.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9712,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9712,19.12,0.06,0.0668,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2930, RA-DEC 00:59:04.0-72:53:32.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9713,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9713,19.12,0.06,0.0668,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4802, RA-DEC 01:07:33.1-71:00:02.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9714,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9714,19.12,0.06,0.0668,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3032, RA-DEC 00:59:44.0-72:29:09.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9715,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9715,19.12,0.06,0.0668,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3342, RA-DEC 01:02:06.2-73:29:24.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9716,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9716,19.12,0.06,0.0668,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0663, RA-DEC 00:44:32.9-73:19:33.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9717,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9717,19.12,0.06,0.0668,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2631, RA-DEC 00:57:04.8-73:08:26.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9718,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9718,19.12,0.06,0.0668,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4692, RA-DEC 00:35:50.1-72:00:59.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9719,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9719,19.12,0.06,0.0668,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4805, RA-DEC 01:07:43.4-71:13:21.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9720,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9720,19.12,0.06,0.0668,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1928, RA-DEC 00:52:37.7-73:14:51.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9721,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9721,19.12,0.06,0.0668,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2267, RA-DEC 00:54:41.3-73:08:58.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9722,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9722,19.12,0.06,0.0668,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0105, RA-DEC 00:29:19.6-74:03:01.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9723,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9723,19.12,0.06,0.0668,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0251, RA-DEC 00:37:13.4-73:38:00.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9724,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9724,19.12,0.06,0.0668,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1250, RA-DEC 00:49:03.2-73:05:43.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9725,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9725,19.12,0.06,0.0668,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2611, RA-DEC 00:56:55.5-73:20:21.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9726,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9726,19.12,0.06,0.0668,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3918, RA-DEC 01:07:11.4-72:28:10.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9727,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9727,19.12,0.06,0.0668,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4106, RA-DEC 01:09:14.9-73:16:49.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9728,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9728,19.12,0.06,0.0668,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0399, RA-DEC 00:41:15.9-72:49:54.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9729,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9729,19.12,0.06,0.0668,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0918, RA-DEC 00:46:51.5-73:10:16.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9730,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9730,19.13,0.06,0.0668,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0653, RA-DEC 00:44:28.5-73:28:30.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9731,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9731,19.13,0.06,0.0668,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3421, RA-DEC 01:02:44.9-73:01:21.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9732,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9732,19.13,0.06,0.0668,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3870, RA-DEC 01:06:45.6-73:21:03.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9733,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9733,19.13,0.06,0.0669,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3080, RA-DEC 01:00:07.8-72:17:46.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9734,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9734,19.13,0.06,0.0669,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1605, RA-DEC 00:51:05.5-73:04:01.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9735,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9735,19.13,0.06,0.0669,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1677, RA-DEC 00:51:24.0-73:12:40.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9736,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9736,19.13,0.06,0.0669,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2446, RA-DEC 00:55:48.2-72:38:37.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9737,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9737,19.13,0.06,0.0669,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0196, RA-DEC 00:34:49.5-73:06:13.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9738,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9738,19.13,0.06,0.0669,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0596, RA-DEC 00:44:03.1-73:16:37.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9739,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9739,19.13,0.06,0.0669,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1916, RA-DEC 00:52:35.1-72:57:09.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9740,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9740,19.13,0.06,0.0669,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2243, RA-DEC 00:54:32.9-72:30:27.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9741,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9741,19.13,0.06,0.0669,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3382, RA-DEC 01:02:26.8-73:34:02.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9742,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9742,19.13,0.06,0.0669,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3834, RA-DEC 01:06:20.4-73:38:42.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9743,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9743,19.13,0.06,0.0669,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1320, RA-DEC 00:49:23.1-72:19:39.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9744,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9744,19.13,0.06,0.0669,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0145, RA-DEC 00:31:54.4-72:56:24.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9745,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9745,19.13,0.06,0.0669,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0787, RA-DEC 00:45:52.8-72:59:36.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9746,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9746,19.13,0.06,0.0669,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1008, RA-DEC 00:47:35.9-72:43:07.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9747,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9747,19.13,0.06,0.0669,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2590, RA-DEC 00:56:44.9-72:44:47.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9748,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9748,19.13,0.06,0.0669,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1289, RA-DEC 00:49:14.7-73:02:55.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9749,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9749,19.13,0.06,0.0669,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1741, RA-DEC 00:51:47.1-72:15:16.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9750,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9750,19.13,0.06,0.0669,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2365, RA-DEC 00:55:15.8-72:57:16.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9751,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9751,19.13,0.06,0.0669,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1571, RA-DEC 00:50:55.8-73:00:13.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9752,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9752,19.13,0.06,0.0669,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3217, RA-DEC 01:01:06.9-73:21:10.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9753,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9753,19.13,0.06,0.0669,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0820, RA-DEC 00:46:04.9-73:19:14.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9754,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9754,19.13,0.06,0.0669,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2695, RA-DEC 00:57:30.1-73:28:19.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9755,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9755,19.13,0.06,0.0669,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0425, RA-DEC 00:41:50.7-73:10:19.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9756,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9756,19.13,0.06,0.0669,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0448, RA-DEC 00:42:10.7-73:21:07.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9757,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9757,19.13,0.06,0.0669,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1269, RA-DEC 00:49:08.5-72:09:51.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9758,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9758,19.13,0.06,0.0669,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1333, RA-DEC 00:49:27.4-73:18:02.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9759,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9759,19.13,0.06,0.0669,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2306, RA-DEC 00:54:56.6-72:37:40.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9760,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9760,19.13,0.06,0.0669,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0562, RA-DEC 00:43:41.3-73:10:12.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9761,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9761,19.13,0.06,0.0669,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1021, RA-DEC 00:47:39.8-72:58:53.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9762,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9762,19.13,0.06,0.0669,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2473, RA-DEC 00:55:57.1-72:40:13.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9763,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9763,19.13,0.06,0.0669,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3064, RA-DEC 00:59:56.8-72:57:28.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9764,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9764,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0633, RA-DEC 00:44:21.3-73:04:42.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9765,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9765,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0907, RA-DEC 00:46:45.2-73:13:31.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9766,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9766,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0991, RA-DEC 00:47:27.3-73:34:01.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9767,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9767,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1588, RA-DEC 00:50:59.2-72:33:41.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9768,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9768,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1964, RA-DEC 00:52:52.9-73:45:28.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9769,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9769,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3656, RA-DEC 01:04:39.6-71:47:16.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9770,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9770,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3833, RA-DEC 01:06:19.8-72:13:39.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9771,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9771,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0369, RA-DEC 00:40:39.7-74:17:52.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9772,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9772,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3528, RA-DEC 01:03:38.7-72:44:05.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9773,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9773,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0046, RA-DEC 00:25:16.9-74:07:57.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9774,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9774,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1252, RA-DEC 00:49:03.4-73:17:26.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9775,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9775,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2302, RA-DEC 00:54:55.5-72:32:56.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9776,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9776,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0729, RA-DEC 00:45:13.4-72:48:39.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9777,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9777,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2487, RA-DEC 00:56:04.2-73:13:02.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9778,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9778,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2484, RA-DEC 00:56:03.5-73:03:02.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9779,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9779,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3736, RA-DEC 01:05:25.2-71:30:23.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9780,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9780,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4056, RA-DEC 01:08:42.6-72:43:37.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9781,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9781,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1217, RA-DEC 00:48:48.9-73:10:41.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9782,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9782,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1374, RA-DEC 00:49:42.4-72:59:46.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9783,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9783,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1888, RA-DEC 00:52:26.5-73:41:05.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9784,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,NULL,9784,19.14,0.15,0.067,2163,NULL,NULL,'K, PL','SMC',NULL,'1999ApJ...512..711B',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9785,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9785,19.14,0.1,0.067,2163,NULL,NULL,'8, V','SMC',NULL,'2004ASPC..310...95B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9786,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9786,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0370, RA-DEC 00:40:41.0-73:56:42.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9787,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9787,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0718, RA-DEC 00:45:09.2-73:15:09.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9788,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9788,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0082, RA-DEC 00:27:36.6-73:45:41.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9789,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9789,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0885, RA-DEC 00:46:33.2-72:57:13.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9790,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9790,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0756, RA-DEC 00:45:28.4-73:03:50.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9791,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9791,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0975, RA-DEC 00:47:19.8-73:26:33.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9792,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9792,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1182, RA-DEC 00:48:33.6-72:56:26.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9793,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9793,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2719, RA-DEC 00:57:39.7-73:16:37.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9794,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9794,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4258, RA-DEC 01:11:14.3-72:54:09.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9795,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9795,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0505, RA-DEC 00:43:02.4-73:08:56.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9796,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9796,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1586, RA-DEC 00:50:59.1-72:52:20.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9797,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9797,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2315, RA-DEC 00:54:59.1-72:42:17.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9798,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9798,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2733, RA-DEC 00:57:44.3-73:05:23.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9799,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9799,19.13,0.06,0.067,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3876, RA-DEC 01:06:48.2-73:25:44.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9800,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9800,19.13,0.06,0.0671,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3016, RA-DEC 00:59:36.2-73:07:54.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9801,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9801,19.13,0.06,0.0671,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3073, RA-DEC 01:00:01.7-72:01:22.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9802,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9802,19.13,0.06,0.0671,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0201, RA-DEC 00:34:56.8-74:00:28.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9803,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9803,19.13,0.06,0.0671,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3199, RA-DEC 01:00:57.3-73:09:14.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9804,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9804,19.13,0.06,0.0671,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0410, RA-DEC 00:41:32.6-73:36:57.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9805,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9805,19.13,0.06,0.0671,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1807, RA-DEC 00:52:02.8-73:05:59.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9806,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9806,19.13,0.06,0.0671,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2569, RA-DEC 00:56:35.9-72:51:24.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9807,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9807,19.13,0.06,0.0671,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1138, RA-DEC 00:48:16.2-73:03:05.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9808,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9808,19.13,0.06,0.0671,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2135, RA-DEC 00:53:54.3-73:21:20.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9809,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9809,19.13,0.06,0.0671,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3074, RA-DEC 01:00:03.1-72:57:58.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9810,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9810,19.13,0.06,0.0671,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0680, RA-DEC 00:44:44.7-72:58:25.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9811,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9811,19.13,0.06,0.0671,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1232, RA-DEC 00:48:53.7-73:15:43.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9812,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9812,19.13,0.06,0.0671,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1993, RA-DEC 00:53:03.7-72:06:28.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9813,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9813,19.13,0.06,0.0671,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3501, RA-DEC 01:03:26.3-72:43:31.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9814,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9814,19.13,0.06,0.0671,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0439, RA-DEC 00:42:00.1-73:20:19.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9815,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9815,19.13,0.06,0.0671,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0483, RA-DEC 00:42:50.7-73:30:18.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9816,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9816,19.13,0.06,0.0671,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0764, RA-DEC 00:45:36.8-73:55:39.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9817,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9817,19.13,0.06,0.0671,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0871, RA-DEC 00:46:29.0-72:39:58.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9818,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9818,19.13,0.06,0.0671,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1573, RA-DEC 00:50:56.3-73:23:11.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9819,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9819,19.13,0.06,0.0671,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2809, RA-DEC 00:58:17.7-73:53:05.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9820,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9820,19.13,0.06,0.0671,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3222, RA-DEC 01:01:08.4-73:42:38.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9821,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9821,19.13,0.06,0.0671,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0014, RA-DEC 00:22:49.0-73:50:25.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9822,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9822,19.13,0.06,0.0671,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4392, RA-DEC 01:13:27.3-72:36:38.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9823,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9823,19.13,0.06,0.0671,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0051, RA-DEC 00:25:25.6-74:10:04.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9824,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9824,19.13,0.06,0.0671,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0360, RA-DEC 00:40:29.9-73:11:33.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9825,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9825,19.13,0.06,0.0671,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0608, RA-DEC 00:44:05.6-73:02:39.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9826,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9826,19.13,0.06,0.0671,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2732, RA-DEC 00:57:44.2-72:29:26.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9827,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9827,19.13,0.06,0.0671,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3963, RA-DEC 01:07:35.4-72:43:44.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9828,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9828,19.13,0.06,0.0671,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4913, RA-DEC 01:38:26.8-72:25:42.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9829,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9829,19.13,0.06,0.0671,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2015, RA-DEC 00:53:12.9-73:01:44.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9830,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9830,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1204, RA-DEC 00:48:45.2-73:09:42.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9831,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9831,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1256, RA-DEC 00:49:04.3-73:16:16.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9832,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9832,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1364, RA-DEC 00:49:40.4-73:11:53.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9833,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9833,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1426, RA-DEC 00:50:00.5-73:34:24.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9834,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9834,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1940, RA-DEC 00:52:43.5-72:41:32.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9835,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9835,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2500, RA-DEC 00:56:07.0-73:01:07.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9836,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9836,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3356, RA-DEC 01:02:13.1-73:10:22.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9837,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9837,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3402, RA-DEC 01:02:36.2-73:42:09.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9838,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9838,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3930, RA-DEC 01:07:19.1-73:14:33.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9839,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9839,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1247, RA-DEC 00:49:01.6-73:12:44.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9840,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9840,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1411, RA-DEC 00:49:55.7-73:37:35.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9841,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9841,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1457, RA-DEC 00:50:11.4-72:40:26.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9842,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9842,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1717, RA-DEC 00:51:38.3-73:04:43.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9843,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9843,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1766, RA-DEC 00:51:55.0-73:19:16.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9844,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9844,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3179, RA-DEC 01:00:48.6-72:24:55.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9845,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9845,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3568, RA-DEC 01:04:01.5-72:45:04.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9846,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9846,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1200, RA-DEC 00:48:42.2-73:15:47.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9847,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9847,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3248, RA-DEC 01:01:20.0-73:13:55.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9848,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9848,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0048, RA-DEC 00:25:17.2-74:03:57.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9849,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9849,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1687, RA-DEC 00:51:26.1-72:53:12.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9850,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9850,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1710, RA-DEC 00:51:35.1-73:06:07.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9851,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9851,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1961, RA-DEC 00:52:52.6-72:43:04.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9852,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9852,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2429, RA-DEC 00:55:41.3-73:12:15.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9853,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9853,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2696, RA-DEC 00:57:31.0-73:05:43.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9854,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9854,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2978, RA-DEC 00:59:21.9-72:58:15.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9855,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9855,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3344, RA-DEC 01:02:07.6-73:02:14.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9856,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9856,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0661, RA-DEC 00:44:30.9-72:49:34.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9857,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9857,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2349, RA-DEC 00:55:09.5-73:24:22.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9858,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9858,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2664, RA-DEC 00:57:16.8-73:36:51.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9859,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9859,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1877, RA-DEC 00:52:21.9-72:58:12.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9860,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9860,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1651, RA-DEC 00:51:18.2-72:33:39.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9861,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9861,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1733, RA-DEC 00:51:42.9-72:56:50.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9862,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9862,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3670, RA-DEC 01:04:48.8-73:21:03.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9863,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9863,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4702, RA-DEC 00:41:47.5-72:19:14.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9864,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9864,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1041, RA-DEC 00:47:48.2-73:05:58.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9865,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9865,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1185, RA-DEC 00:48:35.0-73:41:36.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9866,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9866,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4650, RA-DEC 00:15:46.8-73:55:57.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9867,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9867,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4863, RA-DEC 01:24:02.6-70:35:33.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9868,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9868,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4927, RA-DEC 01:42:05.7-70:33:36.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9869,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9869,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0619, RA-DEC 00:44:14.3-73:07:33.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9870,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9870,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1332, RA-DEC 00:49:27.4-72:59:36.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9871,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9871,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1968, RA-DEC 00:52:54.1-72:47:42.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9872,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9872,19.14,0.06,0.0672,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2726, RA-DEC 00:57:42.4-72:45:55.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9873,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9873,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0032, RA-DEC 00:24:10.5-73:26:31.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9874,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9874,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0204, RA-DEC 00:35:05.5-73:06:21.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9875,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9875,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0493, RA-DEC 00:42:57.0-73:25:16.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9876,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9876,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0928, RA-DEC 00:46:54.3-73:52:05.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9877,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9877,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3608, RA-DEC 01:04:14.3-72:13:15.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9878,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9878,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3632, RA-DEC 01:04:24.4-73:12:46.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9879,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9879,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0488, RA-DEC 00:42:56.0-73:18:25.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9880,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9880,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0942, RA-DEC 00:47:04.1-73:12:43.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9881,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9881,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1841, RA-DEC 00:52:12.5-72:29:19.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9882,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9882,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2148, RA-DEC 00:53:57.8-73:03:07.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9883,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9883,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0129, RA-DEC 00:30:44.3-73:28:10.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9884,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9884,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0712, RA-DEC 00:45:05.7-73:19:27.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9885,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9885,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1220, RA-DEC 00:48:49.4-73:03:12.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9886,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9886,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3161, RA-DEC 01:00:41.7-73:12:36.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9887,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9887,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3322, RA-DEC 01:01:56.2-71:29:19.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9888,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9888,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4535, RA-DEC 01:17:01.2-73:19:25.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9889,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9889,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0816, RA-DEC 00:46:04.2-73:08:48.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9890,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9890,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1064, RA-DEC 00:47:54.8-73:25:44.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9891,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9891,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1760, RA-DEC 00:51:53.5-72:35:30.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9892,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9892,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2052, RA-DEC 00:53:23.5-73:01:23.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9893,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9893,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1198, RA-DEC 00:48:40.2-73:05:36.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9894,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9894,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1280, RA-DEC 00:49:12.3-73:30:08.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9895,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9895,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1512, RA-DEC 00:50:32.7-73:05:51.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9896,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9896,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2803, RA-DEC 00:58:15.6-72:33:20.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9897,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9897,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0498, RA-DEC 00:42:59.1-73:38:53.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9898,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9898,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0686, RA-DEC 00:44:49.1-73:03:55.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9899,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9899,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0695, RA-DEC 00:44:54.0-73:26:16.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9900,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9900,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2029, RA-DEC 00:53:17.3-72:53:41.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9901,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9901,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4767, RA-DEC 01:01:16.4-71:12:42.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9902,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9902,19.14,0.15,0.0673,2163,NULL,NULL,'PL(K)','SMC',NULL,'1999ASPC..167..275M',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9903,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9903,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0564, RA-DEC 00:43:42.6-73:11:47.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9904,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9904,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0941, RA-DEC 00:47:03.5-74:02:01.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9905,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9905,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2552, RA-DEC 00:56:29.9-73:24:35.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9906,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9906,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2597, RA-DEC 00:56:47.9-72:27:50.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9907,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9907,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3384, RA-DEC 01:02:27.2-73:32:37.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9908,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9908,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3769, RA-DEC 01:05:45.9-71:32:10.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9909,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9909,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1856, RA-DEC 00:52:17.1-72:55:05.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9910,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9910,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3458, RA-DEC 01:03:03.5-73:30:14.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9911,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9911,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0623, RA-DEC 00:44:17.1-73:56:52.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9912,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9912,19.14,0.06,0.0673,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2766, RA-DEC 00:58:01.2-73:39:15.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9913,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9913,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0169, RA-DEC 00:33:34.1-72:45:45.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9914,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9914,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0428, RA-DEC 00:41:52.8-72:44:31.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9915,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9915,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1544, RA-DEC 00:50:47.3-73:26:42.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9916,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9916,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4306, RA-DEC 01:11:48.5-72:50:29.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9917,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9917,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0615, RA-DEC 00:44:11.2-73:37:37.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9918,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9918,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1816, RA-DEC 00:52:04.6-72:50:36.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9919,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9919,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3811, RA-DEC 01:06:08.4-73:10:52.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9920,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9920,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0985, RA-DEC 00:47:24.6-72:40:50.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9921,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9921,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2264, RA-DEC 00:54:40.4-73:01:18.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9922,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9922,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4698, RA-DEC 00:40:09.4-68:55:08.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9923,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9923,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0203, RA-DEC 00:35:02.8-73:26:26.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9924,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9924,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1843, RA-DEC 00:52:13.0-73:56:36.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9925,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9925,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3275, RA-DEC 01:01:34.0-73:19:15.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9926,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9926,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1009, RA-DEC 00:47:36.4-73:32:53.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9927,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9927,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1392, RA-DEC 00:49:47.3-72:30:24.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9928,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9928,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1631, RA-DEC 00:51:11.2-73:24:46.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9929,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9929,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1882, RA-DEC 00:52:23.3-73:25:07.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9930,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9930,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3636, RA-DEC 01:04:26.0-73:21:23.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9931,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9931,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3864, RA-DEC 01:06:40.4-73:22:31.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9932,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9932,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4416, RA-DEC 01:13:46.6-73:21:17.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9933,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9933,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0176, RA-DEC 00:34:09.8-73:09:49.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9934,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9934,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0225, RA-DEC 00:35:51.6-74:03:43.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9935,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9935,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0595, RA-DEC 00:44:03.1-72:55:13.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9936,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9936,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1179, RA-DEC 00:48:33.0-73:29:46.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9937,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9937,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2638, RA-DEC 00:57:06.2-73:29:18.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9938,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9938,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3454, RA-DEC 01:03:02.5-73:12:34.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9939,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9939,19.14,0.08,0.0674,2163,NULL,NULL,'HV 822, 1, VK(W)','SMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9940,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9940,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1895, RA-DEC 00:52:28.8-73:03:14.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9941,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9941,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1415, RA-DEC 00:49:57.1-73:02:40.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9942,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9942,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0496, RA-DEC 00:42:58.5-73:07:23.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9943,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9943,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1321, RA-DEC 00:49:23.1-73:13:47.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9944,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9944,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2212, RA-DEC 00:54:19.7-72:05:19.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9945,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9945,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4233, RA-DEC 01:10:51.7-73:07:27.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9946,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9946,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0342, RA-DEC 00:40:03.5-72:49:26.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9947,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9947,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0691, RA-DEC 00:44:52.6-72:47:07.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9948,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9948,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0993, RA-DEC 00:47:29.7-72:54:02.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9949,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9949,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1654, RA-DEC 00:51:19.2-74:02:50.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9950,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9950,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2813, RA-DEC 00:58:20.3-72:37:07.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9951,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9951,19.14,0.06,0.0674,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3494, RA-DEC 01:03:23.2-73:10:22.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9952,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9952,19.14,0.06,0.0675,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0182, RA-DEC 00:34:32.8-73:12:04.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9953,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9953,19.14,0.06,0.0675,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1068, RA-DEC 00:47:55.8-74:06:29.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9954,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9954,19.14,0.06,0.0675,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3242, RA-DEC 01:01:17.6-73:19:04.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9955,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9955,19.15,0.06,0.0675,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0258, RA-DEC 00:37:32.5-73:38:13.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9956,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9956,19.15,0.06,0.0675,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0809, RA-DEC 00:46:02.0-73:15:29.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9957,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9957,19.15,0.06,0.0675,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1286, RA-DEC 00:49:13.8-73:05:43.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9958,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9958,19.15,0.06,0.0675,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3252, RA-DEC 01:01:22.1-73:10:28.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9959,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9959,19.15,0.06,0.0675,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0692, RA-DEC 00:44:53.0-73:16:02.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9960,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9960,19.15,0.06,0.0675,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0866, RA-DEC 00:46:26.9-73:04:07.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9961,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9961,19.15,0.06,0.0675,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1537, RA-DEC 00:50:44.1-72:53:07.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9962,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9962,19.15,0.06,0.0675,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3165, RA-DEC 01:00:43.1-73:38:59.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9963,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9963,19.15,0.06,0.0675,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3371, RA-DEC 01:02:19.8-72:51:50.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9964,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9964,19.15,0.06,0.0675,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0940, RA-DEC 00:47:03.4-72:40:21.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9965,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9965,19.15,0.06,0.0675,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4890, RA-DEC 01:29:50.9-72:48:01.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9966,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9966,19.15,0.06,0.0675,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0380, RA-DEC 00:40:51.6-73:15:20.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9967,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9967,19.15,0.06,0.0675,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4218, RA-DEC 01:10:36.2-72:55:13.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9968,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9968,19.15,0.06,0.0675,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1367, RA-DEC 00:49:41.2-73:18:36.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9969,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9969,19.15,0.06,0.0675,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1459, RA-DEC 00:50:11.9-72:26:28.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9970,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9970,19.15,0.06,0.0675,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0740, RA-DEC 00:45:18.6-73:29:22.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9971,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9971,19.15,0.06,0.0675,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3435, RA-DEC 01:02:51.2-73:38:43.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9972,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9972,19.15,0.06,0.0675,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0002, RA-DEC 00:20:41.4-74:30:58.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9973,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9973,19.15,0.06,0.0675,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0137, RA-DEC 00:31:18.1-72:47:14.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9974,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9974,19.15,0.06,0.0675,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0424, RA-DEC 00:41:49.9-73:14:50.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9975,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9975,19.15,0.06,0.0675,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2731, RA-DEC 00:57:44.1-71:42:17.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9976,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9976,19.15,0.06,0.0675,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0598, RA-DEC 00:44:03.4-73:15:55.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9977,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9977,19.15,0.06,0.0675,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0694, RA-DEC 00:44:53.6-73:17:24.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9978,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9978,19.15,0.06,0.0675,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1229, RA-DEC 00:48:52.5-74:05:51.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9979,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9979,19.15,0.06,0.0675,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1914, RA-DEC 00:52:34.7-73:06:05.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9980,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9980,19.15,0.06,0.0675,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2026, RA-DEC 00:53:16.8-73:04:44.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9981,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9981,19.15,0.06,0.0675,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3415, RA-DEC 01:02:43.0-73:03:02.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9982,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9982,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3842, RA-DEC 01:06:25.2-73:18:12.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9983,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9983,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4893, RA-DEC 01:30:12.3-72:39:16.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9984,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9984,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0539, RA-DEC 00:43:28.2-73:08:38.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9985,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9985,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1306, RA-DEC 00:49:19.7-72:51:50.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9986,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9986,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1744, RA-DEC 00:51:47.8-72:47:21.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9987,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9987,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2314, RA-DEC 00:54:59.0-73:09:18.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9988,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9988,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2856, RA-DEC 00:58:37.3-73:12:47.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9989,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9989,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1848, RA-DEC 00:52:14.9-73:28:03.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9990,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9990,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3002, RA-DEC 00:59:30.3-72:12:06.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9991,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9991,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0827, RA-DEC 00:46:09.1-72:29:06.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9992,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9992,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2184, RA-DEC 00:54:08.8-73:28:53.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9993,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9993,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3772, RA-DEC 01:05:46.6-73:07:27.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9994,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9994,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3375, RA-DEC 01:02:23.0-73:00:31.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9995,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9995,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1462, RA-DEC 00:50:12.2-73:41:46.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9996,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9996,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1603, RA-DEC 00:51:05.0-74:11:24.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9997,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9997,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2888, RA-DEC 00:58:48.9-72:55:32.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9998,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',9998,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3420, RA-DEC 01:02:44.6-73:20:13.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9999,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,NULL,9999,19.15,0.07,0.0676,2163,NULL,NULL,'HV 01636, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10000,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10000,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1285, RA-DEC 00:49:13.7-73:21:08.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10001,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10001,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2903, RA-DEC 00:58:54.0-73:03:37.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10002,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10002,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3731, RA-DEC 01:05:22.7-73:00:56.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10003,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10003,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4372, RA-DEC 01:13:07.6-72:19:12.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10004,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10004,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1175, RA-DEC 00:48:32.1-73:18:02.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10005,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10005,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1345, RA-DEC 00:49:32.2-73:45:28.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10006,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10006,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1598, RA-DEC 00:51:02.2-73:00:37.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10007,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10007,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1901, RA-DEC 00:52:30.3-72:46:57.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10008,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10008,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2297, RA-DEC 00:54:53.2-72:52:20.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10009,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10009,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3687, RA-DEC 01:04:58.1-72:44:01.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10010,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10010,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0086, RA-DEC 00:28:05.3-73:33:17.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10011,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10011,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1231, RA-DEC 00:48:53.2-72:43:17.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10012,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10012,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1358, RA-DEC 00:49:37.4-72:56:30.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10013,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10013,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1808, RA-DEC 00:52:03.1-73:11:30.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10014,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10014,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3348, RA-DEC 01:02:08.6-73:04:06.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10015,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10015,19.15,0.06,0.0676,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3023, RA-DEC 00:59:38.5-72:43:04.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10016,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10016,19.15,0.06,0.0677,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0525, RA-DEC 00:43:19.9-73:12:16.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10017,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10017,19.15,0.06,0.0677,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1077, RA-DEC 00:47:58.9-73:30:01.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10018,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10018,19.15,0.06,0.0677,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2608, RA-DEC 00:56:53.0-73:31:55.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10019,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10019,19.15,0.06,0.0677,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4330, RA-DEC 01:12:15.7-73:03:56.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10020,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10020,19.15,0.06,0.0677,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2810, RA-DEC 00:58:18.1-73:11:24.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10021,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10021,19.15,0.06,0.0677,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3035, RA-DEC 00:59:45.6-72:24:28.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10022,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10022,19.15,0.06,0.0677,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0132, RA-DEC 00:30:46.6-73:37:53.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10023,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10023,19.15,0.06,0.0677,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1763, RA-DEC 00:51:54.6-73:19:54.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10024,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10024,19.15,0.06,0.0677,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2241, RA-DEC 00:54:32.3-72:28:33.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10025,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10025,19.15,0.06,0.0677,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0821, RA-DEC 00:46:06.7-72:40:55.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10026,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10026,19.15,0.06,0.0677,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2573, RA-DEC 00:56:37.3-72:34:44.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10027,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10027,19.15,0.06,0.0677,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2800, RA-DEC 00:58:14.7-74:12:38.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10028,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10028,19.15,0.06,0.0677,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4329, RA-DEC 01:12:13.9-71:24:28.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10029,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10029,19.15,0.06,0.0677,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0983, RA-DEC 00:47:22.1-73:52:44.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10030,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10030,19.15,0.06,0.0677,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1666, RA-DEC 00:51:21.6-73:35:49.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10031,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10031,19.15,0.06,0.0677,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4667, RA-DEC 00:19:37.9-73:20:11.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10032,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10032,19.15,0.06,0.0677,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2109, RA-DEC 00:53:44.6-73:12:53.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10033,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10033,19.15,0.06,0.0677,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2147, RA-DEC 00:53:57.7-73:07:02.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10034,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10034,19.15,0.06,0.0677,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2204, RA-DEC 00:54:17.6-73:18:40.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10035,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10035,19.15,0.06,0.0677,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3581, RA-DEC 01:04:05.9-73:04:03.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10036,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10036,19.15,0.06,0.0677,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4075, RA-DEC 01:08:57.2-73:13:29.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10037,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10037,19.15,0.06,0.0677,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0298, RA-DEC 00:38:58.4-73:59:42.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10038,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10038,19.15,0.06,0.0677,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2107, RA-DEC 00:53:44.4-72:48:11.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10039,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10039,19.15,0.06,0.0677,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2208, RA-DEC 00:54:18.6-73:22:07.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10040,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10040,19.15,0.06,0.0677,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0513, RA-DEC 00:43:05.3-73:12:03.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10041,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10041,19.15,0.06,0.0677,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1775, RA-DEC 00:51:56.8-73:37:33.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10042,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10042,19.15,0.06,0.0677,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2401, RA-DEC 00:55:32.4-72:46:57.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10043,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10043,19.15,0.06,0.0677,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3391, RA-DEC 01:02:29.3-73:43:17.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10044,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10044,19.15,0.06,0.0677,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2044, RA-DEC 00:53:22.1-73:19:59.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10045,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10045,19.15,0.06,0.0678,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0655, RA-DEC 00:44:29.2-73:33:43.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10046,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10046,19.15,0.06,0.0678,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2217, RA-DEC 00:54:21.9-73:22:29.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10047,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10047,19.15,0.06,0.0678,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3367, RA-DEC 01:02:17.7-72:58:46.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10048,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10048,19.15,0.06,0.0678,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1227, RA-DEC 00:48:52.3-73:24:35.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10049,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10049,19.15,0.06,0.0678,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1307, RA-DEC 00:49:20.1-72:57:29.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10050,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10050,19.15,0.06,0.0678,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2040, RA-DEC 00:53:21.3-73:58:39.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10051,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10051,19.15,0.06,0.0678,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2120, RA-DEC 00:53:49.1-71:41:50.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10052,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10052,19.15,0.06,0.0678,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3462, RA-DEC 01:03:08.5-72:42:24.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10053,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10053,19.16,0.06,0.0678,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0690, RA-DEC 00:44:52.5-73:11:11.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10054,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10054,19.16,0.06,0.0678,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0999, RA-DEC 00:47:32.4-73:13:35.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10055,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10055,19.16,0.06,0.0678,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1434, RA-DEC 00:50:03.8-73:25:23.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10056,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10056,19.16,0.06,0.0678,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1600, RA-DEC 00:51:03.2-73:36:20.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10057,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10057,19.16,0.06,0.0678,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2158, RA-DEC 00:54:00.6-73:37:09.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10058,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10058,19.16,0.06,0.0678,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2895, RA-DEC 00:58:50.1-72:31:41.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10059,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10059,19.16,0.06,0.0678,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0256, RA-DEC 00:37:31.1-73:45:54.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10060,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10060,19.16,0.06,0.0678,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2709, RA-DEC 00:57:34.3-73:26:32.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10061,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10061,19.16,0.06,0.0678,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0843, RA-DEC 00:46:15.9-73:51:08.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10062,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10062,19.16,0.06,0.0678,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1947, RA-DEC 00:52:47.5-72:08:04.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10063,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10063,19.16,0.06,0.0678,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4371, RA-DEC 01:13:07.0-72:46:05.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10064,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10064,19.16,0.06,0.0678,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2275, RA-DEC 00:54:45.8-73:34:19.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10065,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10065,19.16,0.06,0.0678,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2351, RA-DEC 00:55:09.6-73:47:11.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10066,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10066,19.16,0.06,0.0678,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4103, RA-DEC 01:09:12.2-73:27:50.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10067,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10067,19.16,0.06,0.0678,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0381, RA-DEC 00:40:54.4-74:13:49.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10068,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10068,19.16,0.06,0.0678,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0501, RA-DEC 00:43:00.2-73:10:28.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10069,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10069,19.16,0.06,0.0678,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1539, RA-DEC 00:50:45.2-73:12:22.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10070,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10070,19.16,0.06,0.0678,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2185, RA-DEC 00:54:09.1-73:39:59.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10071,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10071,19.16,0.06,0.0678,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0549, RA-DEC 00:43:36.4-73:14:22.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10072,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10072,19.16,0.06,0.0678,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3869, RA-DEC 01:06:45.2-73:04:07.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10073,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10073,19.16,0.06,0.0679,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0027, RA-DEC 00:23:53.0-74:06:50.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10074,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10074,19.16,0.06,0.0679,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1479, RA-DEC 00:50:21.4-73:01:06.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10075,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10075,19.16,0.06,0.0679,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3400, RA-DEC 01:02:35.3-73:18:57.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10076,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10076,19.16,0.06,0.0679,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0033, RA-DEC 00:24:15.0-73:59:04.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10077,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10077,19.16,0.06,0.0679,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0958, RA-DEC 00:47:10.4-72:57:37.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10078,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10078,19.16,0.06,0.0679,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1347, RA-DEC 00:49:33.4-73:41:02.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10079,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10079,19.16,0.06,0.0679,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1751, RA-DEC 00:51:49.4-73:38:45.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10080,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10080,19.16,0.06,0.0679,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2505, RA-DEC 00:56:09.1-72:26:15.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10081,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10081,19.16,0.06,0.0679,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2649, RA-DEC 00:57:10.1-73:22:51.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10082,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10082,19.16,0.06,0.0679,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3246, RA-DEC 01:01:19.0-72:47:32.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10083,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10083,19.16,0.06,0.0679,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0101, RA-DEC 00:28:54.0-74:04:38.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10084,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10084,19.16,0.06,0.0679,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0951, RA-DEC 00:47:07.7-72:42:10.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10085,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10085,19.16,0.06,0.0679,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2440, RA-DEC 00:55:46.4-73:35:49.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10086,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10086,19.16,0.06,0.0679,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3087, RA-DEC 01:00:10.9-72:28:36.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10087,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10087,19.16,0.06,0.0679,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0667, RA-DEC 00:44:35.0-72:54:01.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10088,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10088,19.16,0.06,0.0679,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0969, RA-DEC 00:47:17.8-73:09:04.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10089,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10089,19.16,0.06,0.0679,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1978, RA-DEC 00:52:57.3-73:07:42.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10090,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10090,19.16,0.06,0.0679,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0295, RA-DEC 00:38:55.0-73:12:22.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10091,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10091,19.16,0.06,0.0679,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0594, RA-DEC 00:44:01.8-73:08:25.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10092,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10092,19.16,0.06,0.0679,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2461, RA-DEC 00:55:53.0-73:19:57.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10093,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10093,19.16,0.06,0.0679,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3752, RA-DEC 01:05:35.9-73:21:15.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10094,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10094,19.16,0.06,0.0679,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4751, RA-DEC 00:57:12.6-74:33:58.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10095,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10095,19.16,0.06,0.0679,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3083, RA-DEC 01:00:08.6-73:17:02.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10096,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10096,19.16,0.06,0.0679,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3629, RA-DEC 01:04:23.8-73:05:59.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10097,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,NULL,10097,19.16,0.19,0.0679,2163,NULL,NULL,'first overtone Cepheids','SMC',NULL,'2001MNRAS.325.1353B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10098,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10098,19.16,0.06,0.0679,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4414, RA-DEC 01:13:45.1-72:09:37.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10099,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10099,19.16,0.06,0.0679,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0897, RA-DEC 00:46:39.5-73:40:04.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10100,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10100,19.16,0.06,0.0679,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2229, RA-DEC 00:54:28.7-72:44:37.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10101,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10101,19.16,0.06,0.0679,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0658, RA-DEC 00:44:30.6-73:58:19.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10102,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10102,19.16,0.06,0.0679,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0306, RA-DEC 00:39:10.5-72:42:55.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10103,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10103,19.16,0.06,0.0679,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1002, RA-DEC 00:47:34.1-72:51:55.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10104,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10104,19.16,0.06,0.0679,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4651, RA-DEC 00:15:56.6-73:00:29.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10105,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10105,19.16,0.06,0.068,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3466, RA-DEC 01:03:11.6-73:40:50.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10106,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10106,19.16,0.06,0.068,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4296, RA-DEC 01:11:42.3-72:36:24.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10107,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10107,19.16,0.06,0.068,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4407, RA-DEC 01:13:41.1-73:06:25.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10108,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10108,19.16,0.06,0.068,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0811, RA-DEC 00:46:03.1-73:40:50.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10109,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10109,19.16,0.06,0.068,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1475, RA-DEC 00:50:18.4-72:56:11.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10110,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10110,19.16,0.06,0.068,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1883, RA-DEC 00:52:23.3-72:43:53.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10111,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10111,19.16,0.06,0.068,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4662, RA-DEC 00:18:22.2-74:21:06.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10112,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10112,19.16,0.06,0.068,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0097, RA-DEC 00:28:40.6-73:36:00.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10113,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10113,19.16,0.06,0.068,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0767, RA-DEC 00:45:38.5-73:14:53.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10114,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10114,19.16,0.06,0.068,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0064, RA-DEC 00:26:07.6-73:57:04.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10115,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10115,19.16,0.06,0.068,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1255, RA-DEC 00:49:04.2-73:02:23.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10116,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10116,19.16,0.06,0.068,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1335, RA-DEC 00:49:28.6-73:39:04.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10117,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10117,19.16,0.06,0.068,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2101, RA-DEC 00:53:43.1-73:05:37.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10118,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10118,19.16,0.06,0.068,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0696, RA-DEC 00:44:54.3-72:55:49.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10119,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10119,19.16,0.06,0.068,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2047, RA-DEC 00:53:22.8-73:21:50.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10120,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10120,19.16,0.06,0.068,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2892, RA-DEC 00:58:49.6-73:00:52.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10121,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,NULL,10121,19.16,NULL,0.068,2163,NULL,NULL,'BVI','SMC',NULL,'1999ApJ...525..784C',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10122,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10122,19.16,0.06,0.068,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1942, RA-DEC 00:52:43.6-73:01:13.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10123,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10123,19.16,0.06,0.068,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4002, RA-DEC 01:08:03.2-73:19:11.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10124,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10124,19.16,0.06,0.068,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4244, RA-DEC 01:11:02.6-73:01:49.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10125,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10125,19.16,0.06,0.068,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0825, RA-DEC 00:46:07.6-73:27:36.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10126,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10126,19.16,0.06,0.068,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1379, RA-DEC 00:49:42.9-73:37:02.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10127,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10127,19.16,0.06,0.068,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1731, RA-DEC 00:51:41.6-73:31:57.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10128,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10128,19.16,0.06,0.068,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3288, RA-DEC 01:01:42.6-71:51:00.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10129,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10129,19.16,0.06,0.068,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1003, RA-DEC 00:47:34.3-73:15:21.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10130,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10130,19.16,0.06,0.068,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1721, RA-DEC 00:51:38.9-73:29:56.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10131,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10131,19.16,0.06,0.068,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2146, RA-DEC 00:53:57.4-72:52:26.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10132,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10132,19.16,0.06,0.068,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3893, RA-DEC 01:06:59.7-71:48:37.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10133,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10133,19.16,0.06,0.068,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0007, RA-DEC 00:22:04.3-73:26:55.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10134,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10134,19.16,0.06,0.068,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1433, RA-DEC 00:50:02.7-72:52:02.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10135,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10135,19.16,0.06,0.068,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2977, RA-DEC 00:59:21.0-73:03:54.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10136,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10136,19.16,0.06,0.068,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4081, RA-DEC 01:08:59.9-72:47:11.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10137,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10137,19.16,0.06,0.0681,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0314, RA-DEC 00:39:29.4-73:13:22.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10138,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10138,19.16,0.06,0.0681,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1499, RA-DEC 00:50:27.6-73:05:54.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10139,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10139,19.16,0.06,0.0681,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3808, RA-DEC 01:06:06.9-72:52:53.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10140,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10140,19.16,0.06,0.0681,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4658, RA-DEC 00:18:14.6-73:35:25.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10141,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10141,19.17,0.06,0.0681,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1822, RA-DEC 00:52:06.8-72:53:09.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10142,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10142,19.17,0.06,0.0681,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1107, RA-DEC 00:48:06.2-72:52:26.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10143,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,NULL,10143,19.17,0.12,0.0681,2163,NULL,NULL,'2522, VI, area-averaged dereddening, Sandage et al. 2004 PL','SMC',NULL,'2012AJ....144..107H',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10144,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10144,19.17,0.06,0.0681,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1572, RA-DEC 00:50:56.1-73:05:41.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10145,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10145,19.17,0.06,0.0681,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1871, RA-DEC 00:52:20.1-72:54:18.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10146,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10146,19.17,0.06,0.0681,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0462, RA-DEC 00:42:22.5-73:03:25.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10147,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10147,19.17,0.06,0.0681,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1969, RA-DEC 00:52:54.1-72:37:15.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10148,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10148,19.17,0.06,0.0681,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2567, RA-DEC 00:56:34.7-73:22:30.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10149,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10149,19.17,0.06,0.0681,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0547, RA-DEC 00:43:36.0-73:19:53.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10150,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10150,19.17,0.06,0.0681,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0683, RA-DEC 00:44:46.1-73:13:41.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10151,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10151,19.17,0.06,0.0681,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2102, RA-DEC 00:53:43.5-73:26:32.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10152,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10152,19.17,0.06,0.0681,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2299, RA-DEC 00:54:53.6-73:29:32.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10153,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10153,19.17,0.06,0.0681,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2662, RA-DEC 00:57:15.7-73:42:49.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10154,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10154,19.17,0.06,0.0681,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4674, RA-DEC 00:20:38.3-73:42:59.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10155,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10155,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1091, RA-DEC 00:48:01.1-72:59:45.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10156,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10156,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1177, RA-DEC 00:48:32.8-72:26:22.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10157,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10157,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2116, RA-DEC 00:53:48.2-73:42:44.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10158,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10158,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2919, RA-DEC 00:59:00.4-73:11:43.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10159,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10159,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1811, RA-DEC 00:52:03.5-73:09:55.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10160,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10160,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0154, RA-DEC 00:33:05.6-73:32:23.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10161,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10161,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2787, RA-DEC 00:58:08.9-71:40:16.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10162,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10162,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3282, RA-DEC 01:01:37.9-73:29:22.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10163,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10163,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3578, RA-DEC 01:04:05.5-73:00:41.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10164,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10164,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0972, RA-DEC 00:47:18.8-73:17:16.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10165,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10165,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1141, RA-DEC 00:48:17.1-72:59:21.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10166,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10166,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1451, RA-DEC 00:50:09.0-73:14:07.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10167,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10167,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1620, RA-DEC 00:51:09.4-73:13:11.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10168,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10168,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3667, RA-DEC 01:04:47.9-73:19:50.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10169,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10169,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2843, RA-DEC 00:58:32.5-72:17:48.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10170,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10170,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3026, RA-DEC 00:59:40.3-72:24:58.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10171,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10171,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0246, RA-DEC 00:36:55.7-73:56:28.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10172,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10172,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0774, RA-DEC 00:45:42.6-72:52:40.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10173,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10173,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1006, RA-DEC 00:47:35.1-73:14:57.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10174,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10174,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1528, RA-DEC 00:50:39.7-73:09:39.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10175,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10175,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2418, RA-DEC 00:55:38.0-72:46:49.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10176,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10176,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0018, RA-DEC 00:23:06.1-74:37:06.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10177,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10177,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1000, RA-DEC 00:47:32.8-72:55:08.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10178,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10178,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2257, RA-DEC 00:54:38.8-73:06:56.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10179,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10179,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0088, RA-DEC 00:28:15.9-73:44:17.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10180,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10180,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0248, RA-DEC 00:36:56.5-73:23:53.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10181,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10181,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0094, RA-DEC 00:28:29.8-74:38:59.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10182,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10182,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0715, RA-DEC 00:45:06.2-73:09:11.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10183,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10183,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1001, RA-DEC 00:47:34.0-72:34:26.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10184,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10184,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1689, RA-DEC 00:51:26.9-73:10:01.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10185,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10185,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3205, RA-DEC 01:00:59.3-72:37:19.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10186,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10186,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3765, RA-DEC 01:05:44.0-73:03:21.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10187,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10187,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0197, RA-DEC 00:34:50.1-73:03:51.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10188,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10188,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0742, RA-DEC 00:45:19.9-73:33:55.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10189,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10189,19.17,0.06,0.0682,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1995, RA-DEC 00:53:05.6-73:04:21.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10190,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10190,19.17,0.06,0.0683,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1352, RA-DEC 00:49:35.2-73:10:53.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10191,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10191,19.17,0.06,0.0683,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1575, RA-DEC 00:50:57.2-72:58:52.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10192,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10192,19.17,0.06,0.0683,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2556, RA-DEC 00:56:30.9-73:15:59.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10193,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10193,19.17,0.06,0.0683,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4359, RA-DEC 01:12:48.0-73:18:03.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10194,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10194,19.17,0.06,0.0683,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4678, RA-DEC 00:21:03.9-73:43:30.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10195,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10195,19.17,0.06,0.0683,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0593, RA-DEC 00:44:01.8-73:27:55.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10196,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10196,19.17,0.06,0.0683,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0716, RA-DEC 00:45:06.7-72:54:50.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10197,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10197,19.17,0.06,0.0683,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2610, RA-DEC 00:56:54.1-72:30:45.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10198,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10198,19.17,0.06,0.0683,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4163, RA-DEC 01:09:52.1-73:31:29.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10199,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10199,19.17,0.06,0.0683,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0210, RA-DEC 00:35:18.4-73:22:11.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10200,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10200,19.17,0.06,0.0683,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1771, RA-DEC 00:51:55.6-72:56:53.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10201,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10201,19.17,0.06,0.0683,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2334, RA-DEC 00:55:03.8-72:55:19.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10202,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10202,19.17,0.06,0.0683,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4020, RA-DEC 01:08:12.2-72:32:22.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10203,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10203,19.17,0.06,0.0683,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3353, RA-DEC 01:02:10.8-72:57:55.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10204,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10204,19.17,0.06,0.0683,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0213, RA-DEC 00:35:20.3-73:04:38.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10205,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10205,19.17,0.06,0.0683,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1094, RA-DEC 00:48:02.5-73:04:14.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10206,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10206,19.17,0.06,0.0683,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2053, RA-DEC 00:53:23.6-73:49:24.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10207,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10207,19.17,0.06,0.0683,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0062, RA-DEC 00:26:06.1-73:53:59.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10208,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10208,19.17,0.06,0.0683,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0250, RA-DEC 00:37:05.5-73:15:09.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10209,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10209,19.17,0.06,0.0683,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2765, RA-DEC 00:58:01.2-72:48:17.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10210,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10210,19.17,0.06,0.0683,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3266, RA-DEC 01:01:30.7-73:10:37.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10211,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10211,19.17,0.06,0.0683,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0853, RA-DEC 00:46:18.8-73:21:59.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10212,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10212,19.17,0.06,0.0683,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1324, RA-DEC 00:49:24.6-73:22:12.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10213,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10213,19.17,0.06,0.0683,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1577, RA-DEC 00:50:57.9-73:29:38.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10214,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10214,19.17,0.06,0.0683,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2389, RA-DEC 00:55:24.9-73:32:38.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10215,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10215,19.17,0.06,0.0683,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0569, RA-DEC 00:43:46.1-73:07:03.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10216,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10216,19.17,0.06,0.0683,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1765, RA-DEC 00:51:55.0-73:22:04.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10217,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10217,19.17,0.06,0.0683,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4712, RA-DEC 00:45:32.2-72:04:07.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10218,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10218,19.17,0.06,0.0684,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0102, RA-DEC 00:29:07.0-73:56:17.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10219,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10219,19.17,0.06,0.0684,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1007, RA-DEC 00:47:35.9-73:13:47.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10220,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10220,19.17,0.06,0.0684,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1153, RA-DEC 00:48:23.3-73:07:14.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10221,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10221,19.17,0.06,0.0684,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1240, RA-DEC 00:48:58.1-73:06:08.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10222,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10222,19.17,0.06,0.0684,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2068, RA-DEC 00:53:30.6-73:17:38.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10223,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10223,19.17,0.06,0.0684,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4682, RA-DEC 00:22:02.7-69:33:46.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10224,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10224,19.17,0.06,0.0684,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0195, RA-DEC 00:34:48.1-73:28:15.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10225,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10225,19.17,0.06,0.0684,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0334, RA-DEC 00:39:50.1-73:29:57.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10226,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10226,19.17,0.06,0.0684,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0861, RA-DEC 00:46:22.9-73:21:35.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10227,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10227,19.17,0.06,0.0684,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1070, RA-DEC 00:47:56.3-73:24:45.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10228,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10228,19.17,0.06,0.0684,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1493, RA-DEC 00:50:25.8-73:07:18.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10229,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10229,19.17,0.06,0.0684,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2274, RA-DEC 00:54:44.5-73:35:14.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10230,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10230,19.17,0.06,0.0684,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0161, RA-DEC 00:33:17.8-72:44:36.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10231,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10231,19.17,0.06,0.0684,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0714, RA-DEC 00:45:06.0-73:17:18.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10232,'Cepheids','2016-12-15 15:13:39','2016-12-16 11:18:41','1',NULL,'R',10232,19.17,0.06,0.0684,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0731, RA-DEC 00:45:14.0-73:22:32.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10233,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10233,19.17,0.06,0.0684,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0930, RA-DEC 00:46:57.7-73:21:50.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10234,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10234,19.17,0.06,0.0684,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2778, RA-DEC 00:58:05.9-72:55:54.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10235,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10235,19.17,0.06,0.0684,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3410, RA-DEC 01:02:41.4-73:34:21.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10236,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10236,19.17,0.06,0.0684,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3436, RA-DEC 01:02:51.8-73:18:20.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10237,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10237,19.17,0.06,0.0684,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0873, RA-DEC 00:46:29.9-73:02:04.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10238,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10238,19.17,0.06,0.0684,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2988, RA-DEC 00:59:26.1-72:53:55.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10239,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10239,19.18,0.06,0.0684,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0193, RA-DEC 00:34:44.4-73:04:31.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10240,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10240,19.18,0.06,0.0684,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0192, RA-DEC 00:34:43.9-72:50:27.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10241,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10241,19.18,0.06,0.0684,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0995, RA-DEC 00:47:31.0-73:11:18.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10242,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10242,19.18,0.06,0.0684,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1394, RA-DEC 00:49:47.9-73:23:46.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10243,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10243,19.18,0.06,0.0684,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2992, RA-DEC 00:59:28.0-74:00:02.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10244,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10244,19.18,0.06,0.0685,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2785, RA-DEC 00:58:08.1-73:34:29.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10245,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10245,19.18,0.06,0.0685,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0212, RA-DEC 00:35:19.9-73:56:18.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10246,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10246,19.18,0.06,0.0685,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2929, RA-DEC 00:59:03.5-73:33:38.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10247,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10247,19.18,0.06,0.0685,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0936, RA-DEC 00:47:00.8-73:09:02.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10248,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10248,19.18,0.06,0.0685,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3214, RA-DEC 01:01:03.1-73:08:51.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10249,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10249,19.18,0.06,0.0685,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0964, RA-DEC 00:47:15.3-73:31:22.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10250,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10250,19.18,0.06,0.0685,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1163, RA-DEC 00:48:28.0-73:08:50.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10251,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10251,19.18,0.06,0.0685,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4649, RA-DEC 00:15:12.5-74:00:16.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10252,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10252,19.18,0.06,0.0685,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0865, RA-DEC 00:46:25.1-73:39:49.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10253,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10253,19.18,0.06,0.0685,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1257, RA-DEC 00:49:04.3-73:01:58.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10254,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10254,19.18,0.06,0.0685,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2557, RA-DEC 00:56:31.0-72:40:07.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10255,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10255,19.18,0.06,0.0685,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1265, RA-DEC 00:49:06.5-73:36:52.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10256,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10256,19.18,0.22,0.0685,2163,NULL,NULL,NULL,'SMC',NULL,'1984Ap&SS.107..167C',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10257,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,NULL,10257,19.18,NULL,0.0685,2163,NULL,NULL,'16, W, Period-Wesenheit, Z1','SMC',NULL,'2007A&A...476..863F',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10258,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10258,19.18,0.06,0.0685,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1223, RA-DEC 00:48:51.0-73:34:14.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10259,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10259,19.18,0.06,0.0685,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1805, RA-DEC 00:52:02.1-72:26:08.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10260,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10260,19.18,0.06,0.0685,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1840, RA-DEC 00:52:11.4-72:53:41.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10261,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10261,19.18,0.06,0.0685,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4690, RA-DEC 00:35:09.8-71:58:07.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10262,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10262,19.18,0.06,0.0685,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0583, RA-DEC 00:43:56.2-73:28:48.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10263,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10263,19.18,0.06,0.0685,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0575, RA-DEC 00:43:49.2-73:18:04.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10264,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10264,19.18,0.06,0.0685,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3048, RA-DEC 00:59:50.6-73:14:53.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10265,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10265,19.18,0.06,0.0686,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3423, RA-DEC 01:02:45.5-72:49:57.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10266,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10266,19.18,0.06,0.0686,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3518, RA-DEC 01:03:34.1-73:27:43.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10267,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10267,19.18,0.06,0.0686,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2469, RA-DEC 00:55:55.6-72:46:20.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10268,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10268,19.18,0.06,0.0686,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3068, RA-DEC 00:59:58.1-72:42:15.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10269,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10269,19.18,0.06,0.0686,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1024, RA-DEC 00:47:41.4-73:37:29.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10270,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10270,19.18,0.06,0.0686,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1284, RA-DEC 00:49:13.5-73:21:03.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10271,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10271,19.18,0.06,0.0686,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0760, RA-DEC 00:45:31.5-73:05:37.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10272,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10272,19.18,0.06,0.0686,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1646, RA-DEC 00:51:16.4-73:51:57.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10273,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10273,19.18,0.06,0.0686,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0450, RA-DEC 00:42:11.8-73:06:59.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10274,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10274,19.18,0.06,0.0686,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1199, RA-DEC 00:48:40.6-73:29:59.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10275,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10275,19.18,0.06,0.0686,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3624, RA-DEC 01:04:21.7-72:36:25.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10276,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10276,19.18,0.06,0.0686,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0259, RA-DEC 00:37:33.0-73:43:46.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10277,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10277,19.18,0.06,0.0686,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0548, RA-DEC 00:43:36.3-73:38:52.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10278,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10278,19.18,0.06,0.0686,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0555, RA-DEC 00:43:39.0-73:02:17.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10279,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10279,19.18,0.06,0.0686,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0837, RA-DEC 00:46:12.6-73:06:14.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10280,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10280,19.18,0.06,0.0686,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1481, RA-DEC 00:50:21.6-72:59:01.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10281,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10281,19.18,0.06,0.0686,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1941, RA-DEC 00:52:43.5-73:55:39.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10282,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10282,19.18,0.06,0.0686,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0847, RA-DEC 00:46:16.9-73:42:51.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10283,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10283,19.18,0.06,0.0686,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1547, RA-DEC 00:50:48.9-73:18:46.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10284,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10284,19.18,0.06,0.0686,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1821, RA-DEC 00:52:05.9-73:41:40.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10285,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10285,19.18,0.06,0.0687,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0518, RA-DEC 00:43:12.3-73:19:31.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10286,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10286,19.18,0.06,0.0687,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3283, RA-DEC 01:01:38.9-73:17:33.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10287,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10287,19.18,0.06,0.0687,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0040, RA-DEC 00:24:54.7-73:59:38.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10288,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10288,19.18,0.06,0.0687,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1627, RA-DEC 00:51:10.9-73:27:55.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10289,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10289,19.18,0.06,0.0687,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0970, RA-DEC 00:47:17.9-72:51:19.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10290,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10290,19.18,0.06,0.0687,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1468, RA-DEC 00:50:16.6-72:40:42.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10291,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10291,19.18,0.06,0.0687,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2301, RA-DEC 00:54:54.2-73:25:11.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10292,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10292,19.18,0.06,0.0687,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3762, RA-DEC 01:05:42.1-72:04:09.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10293,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10293,19.18,0.06,0.0687,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4090, RA-DEC 01:09:04.5-73:04:06.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10294,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10294,19.18,0.06,0.0687,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4573, RA-DEC 01:18:45.0-73:06:24.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10295,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10295,19.18,0.06,0.0687,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4703, RA-DEC 00:41:59.6-71:58:52.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10296,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10296,19.18,0.06,0.0687,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1288, RA-DEC 00:49:13.9-73:18:48.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10297,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10297,19.18,0.06,0.0687,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4664, RA-DEC 00:18:58.4-73:38:04.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10298,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10298,19.19,0.06,0.0687,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0467, RA-DEC 00:42:33.0-72:55:47.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10299,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10299,19.19,0.06,0.0687,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1454, RA-DEC 00:50:09.5-73:11:53.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10300,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10300,19.19,0.06,0.0687,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2322, RA-DEC 00:54:59.7-73:28:12.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10301,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10301,19.19,0.06,0.0687,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0403, RA-DEC 00:41:22.9-74:04:14.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10302,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10302,19.19,0.06,0.0687,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1032, RA-DEC 00:47:45.4-73:32:42.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10303,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10303,19.19,0.06,0.0687,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1165, RA-DEC 00:48:28.1-73:13:39.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10304,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10304,19.19,0.06,0.0687,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0566, RA-DEC 00:43:43.7-73:05:24.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10305,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10305,19.19,0.06,0.0687,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1277, RA-DEC 00:49:11.8-73:20:35.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10306,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10306,19.19,0.06,0.0687,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3181, RA-DEC 01:00:49.1-73:02:03.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10307,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10307,19.19,0.06,0.0688,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0971, RA-DEC 00:47:17.9-72:59:42.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10308,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10308,19.19,0.06,0.0688,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1344, RA-DEC 00:49:32.0-73:37:00.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10309,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10309,19.19,0.06,0.0688,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2674, RA-DEC 00:57:21.2-73:24:49.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10310,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10310,19.19,0.06,0.0688,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3467, RA-DEC 01:03:11.6-73:08:29.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10311,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10311,19.19,0.06,0.0688,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3225, RA-DEC 01:01:10.3-73:54:53.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10312,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10312,19.19,0.06,0.0688,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0955, RA-DEC 00:47:09.3-73:06:47.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10313,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10313,19.19,0.06,0.0688,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1313, RA-DEC 00:49:22.0-73:03:08.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10314,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10314,19.19,0.06,0.0688,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1976, RA-DEC 00:52:55.7-72:39:25.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10315,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10315,19.19,0.06,0.0688,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2063, RA-DEC 00:53:28.4-73:23:25.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10316,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10316,19.19,0.06,0.0688,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3775, RA-DEC 01:05:48.5-72:42:19.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10317,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10317,19.19,0.06,0.0688,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0059, RA-DEC 00:25:48.5-73:11:30.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10318,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10318,19.19,0.06,0.0688,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0649, RA-DEC 00:44:27.2-73:16:47.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10319,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10319,19.19,0.06,0.0688,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1121, RA-DEC 00:48:10.7-73:27:51.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10320,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10320,19.19,0.06,0.0688,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1387, RA-DEC 00:49:45.4-72:59:07.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10321,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10321,19.19,0.06,0.0688,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3639, RA-DEC 01:04:29.9-73:25:32.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10322,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10322,19.19,0.06,0.0688,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4029, RA-DEC 01:08:17.8-72:44:18.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10323,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10323,19.19,0.06,0.0688,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0114, RA-DEC 00:29:38.5-73:28:02.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10324,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10324,19.19,0.06,0.0688,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0728, RA-DEC 00:45:13.2-73:15:01.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10325,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10325,19.19,0.06,0.0688,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1086, RA-DEC 00:48:00.3-73:40:27.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10326,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10326,19.19,0.06,0.0688,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1641, RA-DEC 00:51:14.0-73:44:32.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10327,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10327,19.19,0.06,0.0688,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2945, RA-DEC 00:59:09.9-72:27:01.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10328,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10328,19.19,0.06,0.0688,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0631, RA-DEC 00:44:20.9-73:45:24.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10329,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10329,19.19,0.06,0.0688,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1242, RA-DEC 00:48:58.3-73:13:07.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10330,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10330,19.19,0.06,0.0688,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1738, RA-DEC 00:51:46.0-73:26:46.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10331,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10331,19.19,0.06,0.0688,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2368, RA-DEC 00:55:18.5-72:36:38.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10332,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10332,19.19,0.06,0.0688,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0330, RA-DEC 00:39:45.4-74:13:27.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10333,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10333,19.19,0.06,0.0688,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1849, RA-DEC 00:52:15.2-74:07:22.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10334,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10334,19.19,0.06,0.0688,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2385, RA-DEC 00:55:23.0-73:24:04.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10335,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10335,19.19,0.06,0.0688,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4734, RA-DEC 00:52:35.0-75:57:31.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10336,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10336,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2914, RA-DEC 00:58:59.4-73:05:00.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10337,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10337,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4363, RA-DEC 01:12:54.4-72:18:53.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10338,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10338,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0240, RA-DEC 00:36:32.3-74:04:30.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10339,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10339,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3910, RA-DEC 01:07:05.5-71:36:24.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10340,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10340,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2413, RA-DEC 00:55:35.9-73:46:36.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10341,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10341,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3363, RA-DEC 01:02:16.7-73:05:05.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10342,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10342,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4276, RA-DEC 01:11:28.4-73:08:40.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10343,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10343,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0479, RA-DEC 00:42:46.4-73:00:45.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10344,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10344,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1115, RA-DEC 00:48:08.1-73:14:19.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10345,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10345,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4399, RA-DEC 01:13:30.2-73:38:36.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10346,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10346,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0411, RA-DEC 00:41:34.7-72:51:21.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10347,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10347,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0516, RA-DEC 00:43:08.7-73:42:01.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10348,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10348,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0554, RA-DEC 00:43:38.0-73:05:01.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10349,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10349,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1574, RA-DEC 00:50:56.4-73:49:08.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10350,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10350,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1742, RA-DEC 00:51:47.2-73:36:53.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10351,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10351,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2206, RA-DEC 00:54:18.1-73:48:47.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10352,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10352,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2411, RA-DEC 00:55:35.6-72:24:14.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10353,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10353,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2576, RA-DEC 00:56:37.9-74:09:29.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10354,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10354,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3054, RA-DEC 00:59:52.0-72:17:13.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10355,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10355,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1166, RA-DEC 00:48:28.1-73:10:02.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10356,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10356,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4648, RA-DEC 00:15:04.0-73:30:13.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10357,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10357,19.19,0.17,0.0689,2163,NULL,NULL,'PLC(V)','SMC',NULL,'1999ASPC..167..275M',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10358,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10358,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0484, RA-DEC 00:42:51.8-73:03:12.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10359,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10359,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1145, RA-DEC 00:48:20.3-73:20:22.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10360,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10360,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2018, RA-DEC 00:53:14.5-73:20:42.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10361,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10361,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3782, RA-DEC 01:05:51.0-73:07:12.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10362,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10362,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0650, RA-DEC 00:44:27.5-72:53:45.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10363,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10363,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1139, RA-DEC 00:48:16.3-72:56:37.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10364,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10364,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2419, RA-DEC 00:55:38.0-72:51:43.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10365,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10365,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2738, RA-DEC 00:57:45.2-72:36:52.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10366,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10366,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0179, RA-DEC 00:34:19.1-73:33:16.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10367,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10367,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0534, RA-DEC 00:43:26.8-73:05:32.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10368,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10368,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0606, RA-DEC 00:44:04.6-72:56:04.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10369,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10369,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2742, RA-DEC 00:57:48.0-73:12:14.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10370,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10370,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2981, RA-DEC 00:59:23.2-73:21:47.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10371,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10371,19.19,0.06,0.0689,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4653, RA-DEC 00:17:33.4-73:04:00.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10372,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10372,19.19,0.06,0.069,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3262, RA-DEC 01:01:29.1-73:19:30.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10373,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10373,19.19,0.06,0.069,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4035, RA-DEC 01:08:23.6-72:42:11.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10374,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10374,19.19,0.06,0.069,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1704, RA-DEC 00:51:32.1-73:32:24.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10375,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10375,19.19,0.06,0.069,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2327, RA-DEC 00:55:01.1-73:02:03.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10376,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10376,19.19,0.06,0.069,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4747, RA-DEC 00:56:56.6-74:14:29.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10377,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10377,19.19,0.06,0.069,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4759, RA-DEC 00:59:00.9-71:09:52.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10378,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10378,19.19,0.06,0.069,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1505, RA-DEC 00:50:29.8-72:57:30.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10379,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10379,19.19,0.06,0.069,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2508, RA-DEC 00:56:09.3-72:50:15.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10380,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10380,19.19,0.06,0.069,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0419, RA-DEC 00:41:45.4-72:59:58.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10381,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10381,19.19,0.06,0.069,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0654, RA-DEC 00:44:29.0-73:23:05.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10382,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10382,19.19,0.06,0.069,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1634, RA-DEC 00:51:11.7-73:16:50.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10383,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10383,19.19,0.06,0.069,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0159, RA-DEC 00:33:16.2-73:24:05.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10384,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10384,19.19,0.06,0.069,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1050, RA-DEC 00:47:50.9-73:38:13.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10385,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10385,19.19,0.06,0.069,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1756, RA-DEC 00:51:52.0-72:37:41.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10386,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10386,19.19,0.06,0.069,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1020, RA-DEC 00:47:39.6-73:22:32.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10387,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,NULL,10387,19.19,0.17,0.069,2163,NULL,NULL,'V, PLC','SMC',NULL,'1999ApJ...512..711B',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10388,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10388,19.19,0.12,0.069,2163,NULL,NULL,'V-K','SMC',NULL,'2000ASPC..203..145S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10389,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10389,19.19,0.06,0.069,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0405, RA-DEC 00:41:25.0-73:40:33.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10390,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10390,19.2,0.06,0.069,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1155, RA-DEC 00:48:24.0-72:55:27.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10391,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10391,19.2,0.06,0.069,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2357, RA-DEC 00:55:12.0-73:02:01.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10392,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10392,19.2,0.06,0.069,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1846, RA-DEC 00:52:14.5-73:43:33.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10393,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10393,19.2,0.06,0.0691,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3634, RA-DEC 01:04:25.3-72:53:18.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10394,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10394,19.2,0.06,0.0691,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1030, RA-DEC 00:47:44.6-73:17:45.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10395,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10395,19.2,0.06,0.0691,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1437, RA-DEC 00:50:04.4-72:53:17.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10396,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10396,19.2,0.06,0.0691,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0151, RA-DEC 00:32:14.8-73:59:03.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10397,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10397,19.2,0.06,0.0691,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1915, RA-DEC 00:52:34.8-73:42:02.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10398,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10398,19.2,0.06,0.0691,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3547, RA-DEC 01:03:51.3-73:05:59.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10399,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10399,19.2,0.06,0.0691,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4672, RA-DEC 00:20:17.0-74:05:12.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10400,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10400,19.2,0.06,0.0691,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1595, RA-DEC 00:51:00.9-72:51:01.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10401,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10401,19.2,0.06,0.0691,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4722, RA-DEC 00:49:06.8-74:41:10.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10402,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10402,19.2,0.06,0.0691,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1046, RA-DEC 00:47:48.7-74:03:56.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10403,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10403,19.2,0.06,0.0691,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1558, RA-DEC 00:50:53.2-72:54:14.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10404,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10404,19.2,0.06,0.0691,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3477, RA-DEC 01:03:15.4-73:18:42.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10405,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10405,19.2,0.06,0.0691,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0067, RA-DEC 00:26:11.5-73:37:30.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10406,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10406,19.2,0.06,0.0691,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2616, RA-DEC 00:56:57.6-73:11:46.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10407,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10407,19.2,0.06,0.0691,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2993, RA-DEC 00:59:28.3-72:38:20.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10408,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10408,19.2,0.06,0.0691,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0453, RA-DEC 00:42:13.3-73:13:10.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10409,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10409,19.2,0.06,0.0691,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0267, RA-DEC 00:37:41.5-74:33:08.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10410,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10410,19.2,0.06,0.0691,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3760, RA-DEC 01:05:41.4-72:53:01.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10411,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10411,19.2,0.06,0.0691,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0391, RA-DEC 00:41:10.0-74:28:25.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (10412,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10412,19.2,0.06,0.0691,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2380, RA-DEC 00:55:21.7-73:28:46.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10413,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10413,19.2,0.06,0.0691,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2479, RA-DEC 00:56:00.2-73:30:09.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10414,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10414,19.2,0.06,0.0691,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1360, RA-DEC 00:49:39.5-73:27:31.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10415,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10415,19.2,0.06,0.0691,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1951, RA-DEC 00:52:48.5-73:14:41.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10416,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10416,19.2,0.06,0.0691,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2173, RA-DEC 00:54:06.1-72:21:12.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10417,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10417,19.2,0.06,0.0691,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2857, RA-DEC 00:58:37.6-72:59:22.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10418,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10418,19.2,0.06,0.0691,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3059, RA-DEC 00:59:54.3-72:55:29.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10419,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10419,19.2,0.06,0.0692,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0761, RA-DEC 00:45:33.9-73:43:26.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10420,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10420,19.2,0.06,0.0692,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1739, RA-DEC 00:51:46.4-72:56:42.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10421,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10421,19.2,0.06,0.0692,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2449, RA-DEC 00:55:48.9-72:53:02.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10422,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10422,19.2,0.06,0.0692,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2568, RA-DEC 00:56:35.4-72:53:07.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10423,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10423,19.2,0.06,0.0692,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3170, RA-DEC 01:00:44.4-71:49:51.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10424,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10424,19.2,0.06,0.0692,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3426, RA-DEC 01:02:46.4-73:36:25.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10425,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10425,19.2,0.06,0.0692,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3531, RA-DEC 01:03:40.9-72:41:06.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10426,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10426,19.2,0.06,0.0692,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3852, RA-DEC 01:06:31.6-73:00:54.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10427,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10427,19.2,0.06,0.0692,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1071, RA-DEC 00:47:56.3-72:55:27.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10428,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10428,19.2,0.06,0.0692,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3330, RA-DEC 01:01:58.2-73:22:18.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10429,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10429,19.2,0.06,0.0692,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1645, RA-DEC 00:51:16.3-74:12:11.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10430,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10430,19.2,0.06,0.0692,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2612, RA-DEC 00:56:56.2-73:27:06.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10431,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10431,19.2,0.06,0.0692,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1340, RA-DEC 00:49:30.4-73:19:06.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10432,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10432,19.2,0.06,0.0692,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3441, RA-DEC 01:02:55.6-73:16:13.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10433,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,NULL,10433,19.2,0.04,0.0692,2163,NULL,NULL,'92, V','SMC',NULL,'2016ApJ...816...49S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10434,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:41','1',NULL,'R',10434,19.2,0.06,0.0692,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1996, RA-DEC 00:53:05.7-73:23:33.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10435,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10435,19.2,0.06,0.0692,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1787, RA-DEC 00:51:58.8-73:36:24.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10436,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10436,19.2,0.06,0.0692,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1809, RA-DEC 00:52:03.4-73:09:35.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10437,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10437,19.2,0.06,0.0692,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2448, RA-DEC 00:55:48.8-73:31:35.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10438,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10438,19.2,0.06,0.0692,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3009, RA-DEC 00:59:33.8-72:15:00.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10439,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10439,19.2,0.06,0.0692,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3203, RA-DEC 01:00:58.9-72:01:50.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10440,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10440,19.2,0.06,0.0692,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3337, RA-DEC 01:02:02.1-73:34:04.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10441,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10441,19.2,0.06,0.0692,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4563, RA-DEC 01:18:17.2-72:08:20.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10442,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10442,19.2,0.06,0.0692,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0031, RA-DEC 00:24:07.8-73:54:45.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10443,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10443,19.2,0.06,0.0692,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1565, RA-DEC 00:50:55.3-73:22:25.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10444,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10444,19.2,0.06,0.0692,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2098, RA-DEC 00:53:42.3-72:39:28.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10445,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10445,19.2,0.06,0.0692,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4445, RA-DEC 01:14:28.3-73:24:34.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10446,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10446,19.2,0.06,0.0692,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1919, RA-DEC 00:52:35.9-73:23:53.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10447,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10447,19.2,0.06,0.0692,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2491, RA-DEC 00:56:05.9-73:44:17.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10448,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10448,19.2,0.06,0.0693,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0047, RA-DEC 00:25:17.0-74:35:09.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10449,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10449,19.2,0.06,0.0693,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0495, RA-DEC 00:42:58.3-73:05:30.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10450,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10450,19.2,0.06,0.0693,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1233, RA-DEC 00:48:53.9-73:37:58.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10451,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10451,19.2,0.06,0.0693,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2718, RA-DEC 00:57:39.3-73:35:04.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10452,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10452,19.2,0.06,0.0693,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4376, RA-DEC 01:13:12.0-73:43:41.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10453,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10453,19.2,0.06,0.0693,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0096, RA-DEC 00:28:38.9-74:07:29.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10454,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10454,19.2,0.06,0.0693,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3406, RA-DEC 01:02:38.6-73:23:34.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10455,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10455,19.2,0.06,0.0693,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0886, RA-DEC 00:46:34.0-73:06:00.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10456,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10456,19.2,0.06,0.0693,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1044, RA-DEC 00:47:48.4-74:31:09.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10457,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10457,19.2,0.06,0.0693,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1868, RA-DEC 00:52:19.6-73:14:03.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10458,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10458,19.2,0.06,0.0693,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2509, RA-DEC 00:56:09.7-72:42:36.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10459,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10459,19.2,0.06,0.0693,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4681, RA-DEC 00:21:46.3-73:20:29.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10460,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10460,19.2,0.06,0.0693,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0296, RA-DEC 00:38:55.2-73:27:54.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10461,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10461,19.2,0.06,0.0693,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3989, RA-DEC 01:07:55.8-72:14:03.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10462,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10462,19.2,0.06,0.0693,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0166, RA-DEC 00:33:31.2-73:38:13.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10463,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10463,19.2,0.06,0.0693,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0205, RA-DEC 00:35:07.2-73:14:40.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10464,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10464,19.2,0.06,0.0693,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0397, RA-DEC 00:41:15.6-74:40:26.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10465,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10465,19.2,0.06,0.0693,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0738, RA-DEC 00:45:17.8-73:20:59.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10466,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10466,19.2,0.06,0.0693,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3742, RA-DEC 01:05:28.0-72:40:38.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10467,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10467,19.2,0.06,0.0693,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0478, RA-DEC 00:42:45.0-72:59:49.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10468,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10468,19.2,0.06,0.0693,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0914, RA-DEC 00:46:50.3-72:55:33.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10469,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10469,19.2,0.06,0.0693,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2548, RA-DEC 00:56:28.7-73:34:59.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10470,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10470,19.2,0.06,0.0693,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3951, RA-DEC 01:07:29.1-71:54:25.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10471,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10471,19.21,0.06,0.0694,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0394, RA-DEC 00:41:11.0-73:49:43.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10472,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10472,19.21,0.06,0.0694,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2802, RA-DEC 00:58:15.6-73:18:30.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10473,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10473,19.21,0.06,0.0694,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4666, RA-DEC 00:19:30.8-73:31:47.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10474,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10474,19.21,0.06,0.0694,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0028, RA-DEC 00:24:01.1-73:35:52.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10475,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10475,19.21,0.06,0.0694,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1593, RA-DEC 00:51:00.6-72:59:40.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10476,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10476,19.21,0.06,0.0694,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2450, RA-DEC 00:55:49.3-73:42:18.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10477,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10477,19.21,0.06,0.0694,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1767, RA-DEC 00:51:55.3-73:04:11.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10478,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10478,19.21,0.06,0.0694,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3789, RA-DEC 01:05:56.0-72:18:46.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10479,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10479,19.21,0.06,0.0694,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0263, RA-DEC 00:37:35.6-74:34:43.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10480,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10480,19.21,0.06,0.0694,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0445, RA-DEC 00:42:06.4-73:47:37.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10481,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10481,19.21,0.06,0.0694,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1801, RA-DEC 00:52:01.5-73:20:25.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10482,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10482,19.21,0.06,0.0694,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0722, RA-DEC 00:45:11.7-73:27:07.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10483,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10483,19.21,0.06,0.0694,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0771, RA-DEC 00:45:41.5-73:12:55.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10484,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10484,19.21,0.06,0.0694,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1089, RA-DEC 00:48:00.9-73:10:13.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10485,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10485,19.21,0.06,0.0694,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3973, RA-DEC 01:07:42.2-71:42:56.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10486,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10486,19.21,0.06,0.0694,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0214, RA-DEC 00:35:24.6-73:44:45.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10487,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10487,19.21,0.06,0.0694,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0236, RA-DEC 00:36:26.8-73:43:36.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10488,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10488,19.21,0.06,0.0694,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1334, RA-DEC 00:49:28.6-73:24:15.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10489,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10489,19.21,0.06,0.0694,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2215, RA-DEC 00:54:21.7-72:44:15.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10490,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10490,19.21,0.06,0.0694,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3107, RA-DEC 01:00:18.6-74:10:58.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10491,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10491,19.21,0.06,0.0694,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3308, RA-DEC 01:01:47.9-73:19:39.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10492,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10492,19.21,0.06,0.0694,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0001, RA-DEC 00:20:07.9-74:32:54.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10493,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10493,19.21,0.06,0.0694,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2014, RA-DEC 00:53:12.4-73:20:40.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10494,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10494,19.21,0.06,0.0694,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3332, RA-DEC 01:01:59.6-73:10:04.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10495,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10495,19.21,0.06,0.0695,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0202, RA-DEC 00:35:00.4-73:34:44.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10496,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10496,19.21,0.06,0.0695,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2605, RA-DEC 00:56:52.1-73:41:18.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10497,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10497,19.21,0.06,0.0695,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2861, RA-DEC 00:58:38.3-73:31:57.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10498,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10498,19.21,0.06,0.0695,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0292, RA-DEC 00:38:44.7-72:47:12.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10499,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10499,19.21,0.06,0.0695,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0754, RA-DEC 00:45:25.5-73:12:25.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10500,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10500,19.21,0.06,0.0695,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1925, RA-DEC 00:52:36.9-73:03:58.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10501,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10501,19.21,0.06,0.0695,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2153, RA-DEC 00:53:58.7-72:58:50.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10502,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10502,19.21,0.06,0.0695,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0227, RA-DEC 00:35:57.9-72:58:13.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10503,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10503,19.21,0.06,0.0695,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0318, RA-DEC 00:39:33.0-73:42:58.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10504,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10504,19.21,0.06,0.0695,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0121, RA-DEC 00:30:09.0-73:24:11.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10505,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10505,19.21,0.06,0.0695,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0348, RA-DEC 00:40:15.9-72:44:31.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10506,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10506,19.21,0.06,0.0695,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3055, RA-DEC 00:59:53.1-73:32:11.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10507,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10507,19.21,0.06,0.0695,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3208, RA-DEC 01:01:00.7-73:30:13.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10508,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10508,19.21,0.06,0.0695,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0992, RA-DEC 00:47:29.3-73:30:27.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10509,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10509,19.21,0.06,0.0695,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1734, RA-DEC 00:51:44.3-73:17:14.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10510,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10510,19.21,0.06,0.0695,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3827, RA-DEC 01:06:17.3-72:22:02.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10511,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10511,19.21,0.06,0.0695,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2048, RA-DEC 00:53:23.0-72:54:20.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10512,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10512,19.21,0.06,0.0695,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2464, RA-DEC 00:55:54.1-72:46:11.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10513,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10513,19.21,0.06,0.0695,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2915, RA-DEC 00:58:59.4-72:42:56.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10514,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10514,19.21,0.06,0.0696,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1529, RA-DEC 00:50:40.3-73:01:38.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10515,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10515,19.21,0.06,0.0696,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2657, RA-DEC 00:57:14.6-73:35:50.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10516,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10516,19.21,0.06,0.0696,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3996, RA-DEC 01:07:57.7-73:18:32.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10517,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10517,19.21,0.06,0.0696,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1188, RA-DEC 00:48:35.9-74:27:19.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10518,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10518,19.21,0.06,0.0696,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3360, RA-DEC 01:02:14.9-73:00:15.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10519,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10519,19.21,0.06,0.0696,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4227, RA-DEC 01:10:48.0-72:51:33.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10520,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10520,19.21,0.06,0.0696,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0732, RA-DEC 00:45:14.5-73:29:26.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10521,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10521,19.21,0.06,0.0696,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3158, RA-DEC 01:00:40.1-73:44:33.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10522,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10522,19.21,0.06,0.0696,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0902, RA-DEC 00:46:40.8-73:24:35.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10523,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10523,19.21,0.06,0.0696,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1659, RA-DEC 00:51:20.7-72:54:05.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10524,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10524,19.21,0.06,0.0696,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4675, RA-DEC 00:20:42.7-72:56:07.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10525,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10525,19.21,0.06,0.0696,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0042, RA-DEC 00:25:07.8-73:19:13.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10526,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10526,19.21,0.06,0.0696,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1413, RA-DEC 00:49:56.2-73:21:05.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10527,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10527,19.21,0.06,0.0696,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4269, RA-DEC 01:11:24.8-73:11:51.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10528,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10528,19.21,0.06,0.0696,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0682, RA-DEC 00:44:45.6-72:45:24.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10529,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10529,19.21,0.06,0.0696,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2323, RA-DEC 00:54:59.7-73:17:23.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10530,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10530,19.22,0.06,0.0697,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0553, RA-DEC 00:43:37.8-72:59:33.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10531,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10531,19.22,0.06,0.0697,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2386, RA-DEC 00:55:23.3-73:37:36.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10532,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10532,19.22,0.06,0.0697,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0591, RA-DEC 00:44:01.6-73:21:13.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10533,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10533,19.22,0.06,0.0697,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1149, RA-DEC 00:48:21.6-72:26:26.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10534,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10534,19.22,0.06,0.0697,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1308, RA-DEC 00:49:21.0-73:50:08.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10535,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10535,19.22,0.06,0.0697,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1405, RA-DEC 00:49:53.3-73:21:57.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10536,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10536,19.22,0.06,0.0697,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3207, RA-DEC 01:01:00.6-73:28:57.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10537,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10537,19.22,0.06,0.0697,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0785, RA-DEC 00:45:51.7-73:23:56.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10538,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10538,19.22,0.06,0.0697,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2238, RA-DEC 00:54:32.2-73:16:55.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10539,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10539,19.22,0.06,0.0697,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2624, RA-DEC 00:57:02.3-72:24:18.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10540,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10540,19.22,0.06,0.0697,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1487, RA-DEC 00:50:24.9-73:07:31.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10541,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10541,19.22,0.06,0.0698,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0524, RA-DEC 00:43:18.8-73:20:19.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10542,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10542,19.22,0.06,0.0698,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0577, RA-DEC 00:43:52.7-73:18:11.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10543,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10543,19.22,0.06,0.0698,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1599, RA-DEC 00:51:03.0-73:12:30.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10544,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10544,19.22,0.06,0.0698,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1894, RA-DEC 00:52:28.8-73:15:28.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10545,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10545,19.22,0.06,0.0698,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2637, RA-DEC 00:57:05.8-73:54:11.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10546,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10546,19.22,0.06,0.0698,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0800, RA-DEC 00:45:58.2-73:42:10.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10547,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10547,19.22,0.06,0.0698,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1224, RA-DEC 00:48:51.1-73:10:55.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10548,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10548,19.22,0.06,0.0698,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2041, RA-DEC 00:53:21.8-72:34:17.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10549,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10549,19.22,0.06,0.0698,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3848, RA-DEC 01:06:29.5-73:31:35.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10550,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10550,19.22,0.06,0.0698,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2035, RA-DEC 00:53:19.0-73:12:57.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10551,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10551,19.22,0.06,0.0698,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2896, RA-DEC 00:58:50.6-73:05:22.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10552,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10552,19.22,0.06,0.0698,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1259, RA-DEC 00:49:05.4-72:51:16.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10553,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10553,19.22,0.06,0.0698,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1705, RA-DEC 00:51:32.2-73:22:11.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10554,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10554,19.22,0.06,0.0698,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3370, RA-DEC 01:02:19.2-73:22:21.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10555,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10555,19.22,0.06,0.0698,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0217, RA-DEC 00:35:36.6-73:36:05.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10556,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10556,19.22,0.06,0.0698,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2667, RA-DEC 00:57:18.3-73:24:28.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10557,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10557,19.22,0.06,0.0698,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4427, RA-DEC 01:14:02.2-72:57:17.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10558,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10558,19.22,0.06,0.0698,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0098, RA-DEC 00:28:48.0-73:20:02.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10559,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10559,19.22,0.06,0.0698,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1866, RA-DEC 00:52:19.4-72:31:18.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10560,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10560,19.22,0.06,0.0698,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0294, RA-DEC 00:38:51.5-74:00:53.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10561,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10561,19.22,0.06,0.0698,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0912, RA-DEC 00:46:47.8-73:55:12.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10562,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10562,19.22,0.06,0.0698,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2123, RA-DEC 00:53:50.4-74:01:36.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10563,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10563,19.22,0.06,0.0698,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2359, RA-DEC 00:55:12.8-73:59:08.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10564,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10564,19.22,0.06,0.0698,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3627, RA-DEC 01:04:22.3-73:16:10.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10565,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10565,19.22,0.06,0.0698,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2775, RA-DEC 00:58:04.3-73:01:02.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10566,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10566,19.22,0.06,0.0699,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0052, RA-DEC 00:25:26.5-73:51:14.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10567,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10567,19.22,0.06,0.0699,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0095, RA-DEC 00:28:30.3-74:23:02.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10568,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10568,19.22,0.06,0.0699,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2711, RA-DEC 00:57:34.9-73:13:05.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10569,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10569,19.22,0.06,0.0699,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0988, RA-DEC 00:47:25.4-74:19:58.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10570,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10570,19.22,0.06,0.0699,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3837, RA-DEC 01:06:22.7-72:31:55.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10571,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10571,19.22,0.06,0.0699,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1458, RA-DEC 00:50:11.8-73:02:33.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10572,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10572,19.22,0.06,0.0699,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0158, RA-DEC 00:33:14.6-73:12:01.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10573,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10573,19.22,0.06,0.0699,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0913, RA-DEC 00:46:48.5-73:24:39.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10574,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10574,19.22,0.06,0.0699,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0084, RA-DEC 00:28:01.3-74:04:53.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10575,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10575,19.22,0.06,0.0699,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1337, RA-DEC 00:49:29.8-73:09:05.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10576,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10576,19.22,0.06,0.0699,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1617, RA-DEC 00:51:08.4-72:59:39.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10577,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10577,19.22,0.06,0.0699,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1625, RA-DEC 00:51:10.6-73:01:08.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10578,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10578,19.22,0.06,0.0699,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3613, RA-DEC 01:04:15.8-73:18:40.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10579,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10579,19.22,0.06,0.07,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0085, RA-DEC 00:28:01.7-73:24:35.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10580,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10580,19.22,0.06,0.07,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1881, RA-DEC 00:52:22.9-73:19:55.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10581,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10581,19.22,0.06,0.07,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3822, RA-DEC 01:06:14.9-72:28:31.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10582,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10582,19.22,0.06,0.07,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1891, RA-DEC 00:52:28.0-73:28:38.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10583,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10583,19.22,0.06,0.07,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1950, RA-DEC 00:52:48.2-73:22:41.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10584,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10584,19.22,0.06,0.07,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0707, RA-DEC 00:45:04.3-72:44:50.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10585,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10585,19.22,0.06,0.07,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0719, RA-DEC 00:45:09.3-73:13:09.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10586,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10586,19.22,0.06,0.07,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0602, RA-DEC 00:44:03.8-72:57:07.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10587,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10587,19.22,0.06,0.07,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4737, RA-DEC 00:53:17.2-72:28:49.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10588,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10588,19.23,0.06,0.07,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1446, RA-DEC 00:50:07.6-72:58:04.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10589,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10589,19.23,0.06,0.07,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2140, RA-DEC 00:53:56.3-72:31:23.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10590,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10590,19.23,0.06,0.07,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3249, RA-DEC 01:01:20.1-73:16:16.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10591,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10591,19.23,0.06,0.07,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4665, RA-DEC 00:19:22.3-73:43:45.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10592,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10592,19.23,0.06,0.07,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4280, RA-DEC 01:11:33.7-72:11:05.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10593,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10593,19.23,0.06,0.07,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4503, RA-DEC 01:15:58.4-72:17:58.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10594,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10594,19.23,0.06,0.07,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1483, RA-DEC 00:50:22.2-73:19:35.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10595,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10595,19.23,0.06,0.07,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1327, RA-DEC 00:49:25.7-72:47:17.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10596,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10596,19.23,0.06,0.0701,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2578, RA-DEC 00:56:38.2-71:57:13.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10597,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10597,19.23,0.06,0.0701,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2777, RA-DEC 00:58:04.7-72:59:45.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10598,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10598,19.23,0.06,0.0701,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2672, RA-DEC 00:57:20.0-73:52:54.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10599,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10599,19.23,0.06,0.0701,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3653, RA-DEC 01:04:38.1-73:20:22.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10600,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10600,19.23,0.06,0.0701,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1740, RA-DEC 00:51:46.5-73:25:40.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10601,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10601,19.23,0.06,0.0701,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1850, RA-DEC 00:52:15.3-73:10:07.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10602,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10602,19.23,0.06,0.0701,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0515, RA-DEC 00:43:08.2-73:03:41.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10603,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10603,19.23,0.06,0.0701,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1989, RA-DEC 00:53:03.2-73:21:20.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10604,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10604,19.23,0.06,0.0701,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1331, RA-DEC 00:49:27.2-73:17:17.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10605,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,10605,19.23,0.23,0.0701,2163,NULL,NULL,'BV(W)','SMC',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10606,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10606,19.23,0.06,0.0701,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0049, RA-DEC 00:25:20.5-73:35:39.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10607,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10607,19.23,0.06,0.0701,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3604, RA-DEC 01:04:12.9-73:02:15.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10608,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10608,19.23,0.06,0.0701,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1542, RA-DEC 00:50:47.0-74:11:53.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10609,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10609,19.23,0.06,0.0701,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1966, RA-DEC 00:52:53.6-73:18:51.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10610,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10610,19.23,0.06,0.0701,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4669, RA-DEC 00:19:52.7-74:05:56.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10611,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10611,19.23,0.06,0.0701,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2032, RA-DEC 00:53:18.7-73:17:48.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10612,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10612,19.23,0.06,0.0701,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3722, RA-DEC 01:05:19.9-72:41:17.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10613,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10613,19.23,0.06,0.0701,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4641, RA-DEC 00:12:31.2-73:54:14.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10614,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10614,19.23,0.06,0.0702,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1576, RA-DEC 00:50:57.4-73:26:39.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10615,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10615,19.23,0.06,0.0702,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1802, RA-DEC 00:52:01.6-73:19:31.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10616,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10616,19.23,0.06,0.0702,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2435, RA-DEC 00:55:44.9-73:34:27.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10617,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10617,19.23,0.06,0.0702,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0997, RA-DEC 00:47:31.8-73:21:09.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10618,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10618,19.23,0.06,0.0702,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2983, RA-DEC 00:59:23.9-72:36:53.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10619,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10619,19.23,0.06,0.0702,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4656, RA-DEC 00:17:57.6-73:16:18.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10620,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10620,19.23,0.06,0.0702,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3271, RA-DEC 01:01:32.3-73:39:34.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10621,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10621,19.23,0.06,0.0702,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0485, RA-DEC 00:42:51.8-73:51:41.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10622,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10622,19.23,0.06,0.0702,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2943, RA-DEC 00:59:08.4-73:30:11.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10623,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10623,19.23,0.06,0.0702,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2387, RA-DEC 00:55:24.5-73:00:30.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10624,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10624,19.23,0.06,0.0702,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2998, RA-DEC 00:59:29.6-72:55:49.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10625,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10625,19.23,0.06,0.0702,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3704, RA-DEC 01:05:08.4-73:13:13.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10626,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10626,19.23,0.06,0.0702,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0875, RA-DEC 00:46:30.4-73:19:22.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10627,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10627,19.23,0.06,0.0702,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2838, RA-DEC 00:58:29.3-72:58:32.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10628,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10628,19.23,0.06,0.0702,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0293, RA-DEC 00:38:48.2-73:16:05.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10629,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10629,19.23,0.06,0.0702,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2814, RA-DEC 00:58:21.0-72:25:12.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10630,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10630,19.23,0.06,0.0702,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0134, RA-DEC 00:31:10.9-73:05:29.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10631,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10631,19.23,0.06,0.0702,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4654, RA-DEC 00:17:55.7-73:21:07.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10632,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10632,19.23,0.06,0.0702,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1486, RA-DEC 00:50:24.3-74:03:29.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10633,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10633,19.23,0.06,0.0702,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4264, RA-DEC 01:11:19.7-73:43:37.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10634,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10634,19.23,0.06,0.0703,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0592, RA-DEC 00:44:01.6-73:23:49.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10635,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10635,19.23,0.06,0.0703,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1176, RA-DEC 00:48:32.7-73:30:34.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10636,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10636,19.23,0.06,0.0703,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1409, RA-DEC 00:49:55.1-72:59:15.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10637,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10637,19.23,0.06,0.0703,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0313, RA-DEC 00:39:29.1-73:41:56.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10638,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10638,19.23,0.06,0.0703,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3468, RA-DEC 01:03:11.7-71:52:13.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10639,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10639,19.23,0.06,0.0703,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4240, RA-DEC 01:10:58.4-73:09:26.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10640,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10640,19.23,0.06,0.0703,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0332, RA-DEC 00:39:48.3-73:54:55.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10641,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10641,19.23,0.06,0.0703,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2129, RA-DEC 00:53:51.8-73:48:44.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10642,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10642,19.23,0.06,0.0703,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3247, RA-DEC 01:01:19.9-74:08:43.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10643,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10643,19.23,0.06,0.0703,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4652, RA-DEC 00:16:31.9-74:15:00.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10644,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10644,19.24,0.06,0.0703,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1706, RA-DEC 00:51:32.4-73:20:12.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10645,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10645,19.24,0.06,0.0703,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0880, RA-DEC 00:46:31.9-72:55:33.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10646,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10646,19.24,0.06,0.0704,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1225, RA-DEC 00:48:51.8-72:59:14.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10647,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10647,19.24,0.06,0.0704,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4727, RA-DEC 00:50:06.6-73:46:25.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10648,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10648,19.24,0.06,0.0704,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0297, RA-DEC 00:38:57.1-73:48:47.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10649,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10649,19.24,0.06,0.0704,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1817, RA-DEC 00:52:04.7-72:24:26.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10650,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10650,19.24,0.06,0.0704,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0016, RA-DEC 00:22:57.9-73:37:46.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10651,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10651,19.24,0.06,0.0704,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0043, RA-DEC 00:25:11.9-73:39:31.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10652,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10652,19.24,0.06,0.0704,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0079, RA-DEC 00:27:25.2-73:26:33.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10653,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10653,19.24,0.06,0.0704,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0153, RA-DEC 00:32:59.4-73:24:51.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10654,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10654,19.24,0.06,0.0704,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1295, RA-DEC 00:49:16.8-73:29:21.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10655,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10655,19.24,0.06,0.0704,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3593, RA-DEC 01:04:09.7-73:20:15.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10656,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10656,19.24,0.06,0.0704,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0777, RA-DEC 00:45:45.8-73:32:15.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10657,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10657,19.24,0.06,0.0704,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3315, RA-DEC 01:01:52.8-72:56:42.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10658,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10658,19.24,0.06,0.0704,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4646, RA-DEC 00:14:20.8-73:49:53.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10659,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10659,19.24,0.06,0.0704,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0329, RA-DEC 00:39:43.9-74:20:44.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10660,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10660,19.24,0.06,0.0704,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2065, RA-DEC 00:53:28.9-72:46:33.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10661,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10661,19.24,0.06,0.0704,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1988, RA-DEC 00:53:02.8-73:15:39.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10662,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10662,19.24,0.06,0.0705,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1018, RA-DEC 00:47:38.9-73:53:18.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10663,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10663,19.24,0.06,0.0705,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1732, RA-DEC 00:51:42.6-72:57:59.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10664,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10664,19.24,0.06,0.0705,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3524, RA-DEC 01:03:36.7-72:59:15.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10665,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10665,19.24,0.06,0.0705,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4817, RA-DEC 01:10:04.7-70:54:48.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10666,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10666,19.24,0.06,0.0705,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3806, RA-DEC 01:06:05.1-72:52:58.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10667,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10667,19.24,0.06,0.0705,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0589, RA-DEC 00:44:00.2-73:59:30.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10668,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10668,19.24,0.06,0.0705,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0136, RA-DEC 00:31:17.0-74:14:49.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10669,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10669,19.24,0.06,0.0705,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0567, RA-DEC 00:43:44.7-74:05:52.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10670,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10670,19.24,0.06,0.0705,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0621, RA-DEC 00:44:15.4-73:11:37.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10671,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10671,19.24,0.06,0.0705,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1215, RA-DEC 00:48:47.9-72:52:59.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10672,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10672,19.24,0.06,0.0705,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4870, RA-DEC 01:24:52.0-65:26:18.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10673,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,10673,19.24,0.05,0.0705,2163,NULL,NULL,'92, B','SMC',NULL,'2016ApJ...816...49S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10674,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10674,19.24,0.06,0.0705,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0024, RA-DEC 00:23:41.0-73:45:50.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10675,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10675,19.24,0.06,0.0705,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1169, RA-DEC 00:48:30.6-73:06:52.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10676,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10676,19.24,0.06,0.0705,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3117, RA-DEC 01:00:22.3-72:47:10.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10677,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10677,19.24,0.06,0.0705,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0932, RA-DEC 00:46:58.6-73:42:44.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10678,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10678,19.24,0.06,0.0706,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0441, RA-DEC 00:42:05.0-73:38:29.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10679,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10679,19.24,0.06,0.0706,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0967, RA-DEC 00:47:16.8-73:19:45.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10680,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10680,19.24,0.06,0.0706,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1258, RA-DEC 00:49:04.6-73:19:00.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10681,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10681,19.24,0.06,0.0706,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2233, RA-DEC 00:54:31.3-72:51:50.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10682,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10682,19.24,0.06,0.0706,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0247, RA-DEC 00:36:56.0-73:04:23.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10683,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10683,19.24,0.06,0.0706,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0307, RA-DEC 00:39:15.4-74:01:12.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10684,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10684,19.24,0.06,0.0706,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0546, RA-DEC 00:43:35.8-74:00:34.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10685,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10685,19.24,0.06,0.0706,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1105, RA-DEC 00:48:06.1-73:15:19.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10686,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10686,19.24,0.06,0.0706,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3684, RA-DEC 01:04:57.1-72:04:26.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10687,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10687,19.24,0.06,0.0706,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4754, RA-DEC 00:57:51.1-74:26:44.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10688,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10688,19.24,0.06,0.0706,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0367, RA-DEC 00:40:38.2-74:03:08.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10689,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10689,19.25,0.06,0.0707,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1439, RA-DEC 00:50:04.9-73:12:59.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10690,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10690,19.25,0.06,0.0707,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4865, RA-DEC 01:24:17.7-71:29:19.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10691,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10691,19.25,0.06,0.0707,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0799, RA-DEC 00:45:57.9-73:46:46.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10692,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10692,19.25,0.06,0.0707,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0845, RA-DEC 00:46:16.2-73:14:16.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10693,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10693,19.25,0.06,0.0707,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2223, RA-DEC 00:54:24.8-72:14:07.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10694,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10694,19.25,0.06,0.0707,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4543, RA-DEC 01:17:15.4-73:39:21.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10695,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10695,19.25,0.06,0.0707,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1221, RA-DEC 00:48:49.8-73:04:48.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10696,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10696,19.25,0.06,0.0707,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2074, RA-DEC 00:53:32.9-71:34:15.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10697,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10697,19.25,0.06,0.0707,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0109, RA-DEC 00:29:23.5-73:19:25.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10698,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10698,19.25,0.06,0.0707,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1126, RA-DEC 00:48:14.0-73:50:56.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10699,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10699,19.25,0.06,0.0707,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1156, RA-DEC 00:48:24.2-73:43:55.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10700,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10700,19.25,0.06,0.0707,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3152, RA-DEC 01:00:38.6-73:58:49.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10701,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10701,19.25,0.06,0.0707,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0309, RA-DEC 00:39:17.0-73:30:27.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10702,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10702,19.25,0.06,0.0707,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2889, RA-DEC 00:58:49.0-72:49:01.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10703,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10703,19.25,0.06,0.0708,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2584, RA-DEC 00:56:41.1-74:01:39.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10704,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10704,19.25,0.06,0.0708,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0687, RA-DEC 00:44:49.8-73:13:58.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10705,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10705,19.25,0.06,0.0708,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1762, RA-DEC 00:51:54.1-73:34:37.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10706,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10706,19.25,0.06,0.0708,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0009, RA-DEC 00:22:25.6-73:47:03.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10707,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10707,19.25,0.06,0.0708,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3229, RA-DEC 01:01:11.4-73:45:19.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10708,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10708,19.25,0.06,0.0708,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0044, RA-DEC 00:25:12.4-73:50:08.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10709,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10709,19.25,0.06,0.0708,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0200, RA-DEC 00:34:56.7-74:18:35.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10710,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10710,19.25,0.06,0.0708,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4634, RA-DEC 23:56:08.9-73:38:59.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10711,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10711,19.25,0.06,0.0708,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1507, RA-DEC 00:50:30.4-73:30:28.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10712,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10712,19.25,0.06,0.0708,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3015, RA-DEC 00:59:35.7-73:04:54.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10713,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10713,19.25,0.06,0.0708,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0855, RA-DEC 00:46:19.9-73:17:00.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10714,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10714,19.25,0.06,0.0709,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0104, RA-DEC 00:29:18.0-74:19:44.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10715,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10715,19.25,0.06,0.0709,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0242, RA-DEC 00:36:42.7-73:29:08.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10716,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10716,19.25,0.06,0.0709,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0468, RA-DEC 00:42:34.8-73:25:38.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10717,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10717,19.25,0.06,0.0709,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0308, RA-DEC 00:39:16.2-73:32:08.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10718,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10718,19.25,0.06,0.0709,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3672, RA-DEC 01:04:49.6-73:09:14.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10719,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10719,19.25,0.06,0.0709,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1852, RA-DEC 00:52:16.3-72:02:07.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10720,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10720,19.25,0.06,0.0709,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2192, RA-DEC 00:54:12.8-73:21:17.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10721,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10721,19.25,0.06,0.0709,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4696, RA-DEC 00:38:19.2-74:58:59.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10722,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10722,19.25,0.06,0.0709,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0388, RA-DEC 00:41:05.9-73:24:54.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10723,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10723,19.25,0.06,0.0709,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0780, RA-DEC 00:45:48.8-74:19:09.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10724,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10724,19.25,0.06,0.0709,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2974, RA-DEC 00:59:20.3-72:18:49.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10725,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10725,19.25,0.06,0.0709,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3129, RA-DEC 01:00:27.7-72:21:55.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10726,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10726,19.25,0.06,0.0709,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1831, RA-DEC 00:52:08.9-73:32:43.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10727,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10727,19.25,0.06,0.071,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0365, RA-DEC 00:40:35.7-73:43:41.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10728,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10728,19.26,0.06,0.071,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0190, RA-DEC 00:34:42.0-73:44:17.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10729,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10729,19.26,0.06,0.071,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0352, RA-DEC 00:40:24.5-73:52:43.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10730,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10730,19.26,0.06,0.071,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2707, RA-DEC 00:57:34.1-72:45:10.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10731,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10731,19.26,0.06,0.071,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3582, RA-DEC 01:04:06.2-73:24:09.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10732,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10732,19.26,0.06,0.071,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4694, RA-DEC 00:37:15.6-67:02:28.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10733,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10733,19.26,0.06,0.071,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0703, RA-DEC 00:45:02.4-73:35:02.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10734,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10734,19.26,0.06,0.071,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1159, RA-DEC 00:48:25.2-73:56:08.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10735,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10735,19.26,0.06,0.071,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1662, RA-DEC 00:51:20.9-73:53:22.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10736,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10736,19.26,0.06,0.071,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1208, RA-DEC 00:48:46.3-72:10:10.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10737,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10737,19.26,0.06,0.071,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2513, RA-DEC 00:56:11.4-73:28:07.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10738,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10738,19.26,0.06,0.071,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0054, RA-DEC 00:25:27.8-73:32:18.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10739,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10739,19.26,0.06,0.071,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1117, RA-DEC 00:48:08.2-73:17:46.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10740,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10740,19.26,0.06,0.071,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1508, RA-DEC 00:50:30.4-73:09:23.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10741,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10741,19.26,0.06,0.071,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1986, RA-DEC 00:53:00.1-73:10:41.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10742,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10742,19.26,0.06,0.071,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1274, RA-DEC 00:49:11.3-74:19:58.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10743,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10743,19.26,0.06,0.071,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4663, RA-DEC 00:18:52.4-74:12:40.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10744,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10744,19.26,0.06,0.0711,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4857, RA-DEC 01:21:16.9-76:49:20.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10745,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10745,19.26,0.06,0.0711,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3473, RA-DEC 01:03:12.8-73:19:27.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10746,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10746,19.26,0.06,0.0711,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0773, RA-DEC 00:45:42.3-73:18:15.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10747,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10747,19.26,0.06,0.0711,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0130, RA-DEC 00:30:44.8-73:14:20.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10748,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10748,19.26,0.06,0.0711,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3846, RA-DEC 01:06:28.4-72:54:10.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10749,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10749,19.26,0.06,0.0711,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4799, RA-DEC 01:07:10.9-74:20:15.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10750,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10750,19.26,0.06,0.0711,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1400, RA-DEC 00:49:51.6-72:51:42.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10751,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10751,19.26,0.06,0.0711,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0645, RA-DEC 00:44:26.7-73:33:47.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10752,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10752,19.26,0.06,0.0712,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1305, RA-DEC 00:49:19.7-73:52:44.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10753,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10753,19.26,0.06,0.0712,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3193, RA-DEC 01:00:54.8-73:38:46.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10754,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10754,19.26,0.06,0.0712,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4259, RA-DEC 01:11:15.8-72:55:01.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10755,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10755,19.26,0.06,0.0712,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0093, RA-DEC 00:28:27.8-74:47:46.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10756,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10756,19.26,0.06,0.0712,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0510, RA-DEC 00:43:04.9-73:42:43.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10757,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10757,19.26,0.06,0.0712,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2643, RA-DEC 00:57:08.5-73:04:56.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10758,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10758,19.26,0.06,0.0712,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0423, RA-DEC 00:41:49.1-73:43:42.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10759,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10759,19.26,0.06,0.0712,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3280, RA-DEC 01:01:36.7-73:28:36.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10760,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10760,19.26,0.06,0.0712,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1073, RA-DEC 00:47:57.4-73:03:31.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10761,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10761,19.26,0.06,0.0712,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1207, RA-DEC 00:48:46.1-72:31:57.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10762,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10762,19.26,0.06,0.0712,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1144, RA-DEC 00:48:19.5-73:09:34.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10763,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10763,19.26,0.06,0.0712,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3057, RA-DEC 00:59:53.4-73:11:31.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10764,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10764,19.26,0.06,0.0712,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2179, RA-DEC 00:54:07.4-73:12:16.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10765,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10765,19.26,0.06,0.0712,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4677, RA-DEC 00:21:02.9-73:43:17.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10766,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10766,19.26,0.06,0.0713,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4458, RA-DEC 01:14:45.3-73:22:49.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10767,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10767,19.26,0.06,0.0713,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1210, RA-DEC 00:48:47.3-73:43:31.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10768,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10768,19.27,0.06,0.0713,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2199, RA-DEC 00:54:16.0-71:54:22.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10769,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10769,19.27,0.06,0.0713,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0978, RA-DEC 00:47:20.7-73:37:35.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10770,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10770,19.27,0.06,0.0713,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2651, RA-DEC 00:57:10.5-73:21:28.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10771,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10771,19.27,0.06,0.0713,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4695, RA-DEC 00:38:18.5-72:15:39.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10772,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10772,19.27,0.06,0.0714,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3014, RA-DEC 00:59:35.6-73:38:27.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10773,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10773,19.27,0.06,0.0714,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4787, RA-DEC 01:04:54.4-67:07:39.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10774,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10774,19.27,0.06,0.0714,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4419, RA-DEC 01:13:49.4-73:06:11.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10775,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10775,19.27,0.06,0.0714,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1004, RA-DEC 00:47:34.5-72:50:59.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10776,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10776,19.27,0.06,0.0714,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1432, RA-DEC 00:50:02.5-73:08:53.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10777,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10777,19.27,0.06,0.0714,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0035, RA-DEC 00:24:20.3-73:55:27.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10778,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10778,19.27,0.06,0.0714,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1162, RA-DEC 00:48:26.4-73:02:12.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10779,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10779,19.27,0.06,0.0714,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3959, RA-DEC 01:07:34.0-72:43:19.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10780,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10780,19.27,0.06,0.0714,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0371, RA-DEC 00:40:41.6-73:20:26.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10781,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10781,19.27,0.06,0.0714,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0455, RA-DEC 00:42:15.2-73:42:43.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10782,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10782,19.27,0.06,0.0714,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0741, RA-DEC 00:45:19.4-73:13:30.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10783,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10783,19.27,0.06,0.0714,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3109, RA-DEC 01:00:18.9-73:16:14.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10784,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10784,19.27,0.06,0.0714,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4687, RA-DEC 00:27:57.3-76:14:49.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10785,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10785,19.27,0.06,0.0715,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0556, RA-DEC 00:43:39.1-73:59:02.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10786,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10786,19.27,0.06,0.0715,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0173, RA-DEC 00:33:54.9-73:46:44.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10787,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10787,19.27,0.06,0.0715,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1668, RA-DEC 00:51:21.6-73:19:27.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10788,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10788,19.27,0.06,0.0715,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1803, RA-DEC 00:52:01.7-73:18:37.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10789,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10789,19.27,0.06,0.0715,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2725, RA-DEC 00:57:41.6-72:43:43.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10790,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10790,19.27,0.06,0.0715,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4904, RA-DEC 01:35:41.1-75:55:10.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10791,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10791,19.27,0.06,0.0715,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0119, RA-DEC 00:29:54.6-73:29:00.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10792,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10792,19.27,0.06,0.0715,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2397, RA-DEC 00:55:30.9-73:43:13.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10793,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10793,19.27,0.06,0.0715,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0870, RA-DEC 00:46:28.7-73:23:06.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10794,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10794,19.27,0.06,0.0716,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0639, RA-DEC 00:44:24.7-73:19:06.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10795,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10795,19.27,0.06,0.0716,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0895, RA-DEC 00:46:38.7-72:59:17.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10796,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10796,19.27,0.06,0.0716,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2908, RA-DEC 00:58:56.3-73:15:04.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10797,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10797,19.27,0.06,0.0716,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4686, RA-DEC 00:23:30.4-74:54:34.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10798,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10798,19.27,0.06,0.0716,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4603, RA-DEC 01:21:25.3-72:58:02.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10799,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10799,19.28,0.06,0.0716,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0705, RA-DEC 00:45:03.6-73:18:28.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10800,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10800,19.28,0.06,0.0716,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2246, RA-DEC 00:54:34.2-73:31:19.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10801,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10801,19.28,0.06,0.0716,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4038, RA-DEC 01:08:26.1-72:44:21.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10802,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10802,19.28,0.06,0.0716,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0126, RA-DEC 00:30:27.6-73:27:26.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10803,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10803,19.28,0.06,0.0717,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0315, RA-DEC 00:39:30.3-73:44:41.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10804,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10804,19.28,0.06,0.0717,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1546, RA-DEC 00:50:48.5-73:24:57.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10805,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10805,19.28,0.06,0.0717,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0189, RA-DEC 00:34:40.1-74:17:22.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10806,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10806,19.28,0.06,0.0717,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2130, RA-DEC 00:53:52.0-73:57:49.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10807,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10807,19.28,0.06,0.0717,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0081, RA-DEC 00:27:27.5-73:55:59.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10808,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10808,19.28,0.06,0.0717,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0676, RA-DEC 00:44:42.8-73:17:20.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10809,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10809,19.28,0.06,0.0717,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1886, RA-DEC 00:52:24.6-73:04:46.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10810,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10810,19.28,0.06,0.0717,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2344, RA-DEC 00:55:07.6-73:15:39.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10811,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10811,19.28,0.06,0.0717,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4432, RA-DEC 01:14:10.1-72:10:13.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10812,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10812,19.28,0.06,0.0717,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1109, RA-DEC 00:48:07.1-74:02:00.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10813,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10813,19.28,0.06,0.0717,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3256, RA-DEC 01:01:24.0-73:32:03.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10814,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10814,19.28,0.06,0.0718,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4748, RA-DEC 00:57:04.0-74:05:01.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10815,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10815,19.28,0.06,0.0718,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4657, RA-DEC 00:18:04.8-73:44:30.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10816,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10816,19.28,0.06,0.0718,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3284, RA-DEC 01:01:39.2-73:10:21.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10817,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10817,19.28,0.06,0.0718,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0277, RA-DEC 00:38:13.9-73:43:56.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10818,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10818,19.28,0.06,0.0718,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0976, RA-DEC 00:47:19.8-73:19:15.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10819,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10819,19.28,0.06,0.0718,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0469, RA-DEC 00:42:35.1-73:55:27.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10820,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10820,19.28,0.17,0.0718,2163,NULL,NULL,'PLC(K)','SMC',NULL,'1999ASPC..167..275M',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10821,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10821,19.28,0.06,0.0718,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2670, RA-DEC 00:57:19.2-73:03:08.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10822,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10822,19.28,0.06,0.0718,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0206, RA-DEC 00:35:09.6-73:49:03.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10823,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10823,19.28,0.06,0.0718,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2745, RA-DEC 00:57:48.9-73:18:24.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10824,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10824,19.28,0.06,0.0718,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0010, RA-DEC 00:22:29.3-73:54:16.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10825,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10825,19.28,0.06,0.0718,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2305, RA-DEC 00:54:56.4-73:22:03.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10826,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10826,19.28,0.06,0.0718,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2434, RA-DEC 00:55:44.7-73:21:54.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10827,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10827,19.28,0.06,0.0718,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0344, RA-DEC 00:40:09.3-74:21:15.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10828,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10828,19.28,0.06,0.0718,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4644, RA-DEC 00:14:05.0-73:54:18.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10829,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10829,19.28,0.06,0.0719,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0053, RA-DEC 00:25:27.6-73:48:31.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10830,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10830,19.28,0.06,0.0719,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1955, RA-DEC 00:52:49.5-72:54:10.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10831,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10831,19.28,0.06,0.0719,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4643, RA-DEC 00:13:56.4-73:44:15.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10832,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10832,19.28,0.06,0.0719,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0198, RA-DEC 00:34:52.0-72:45:10.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10833,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10833,19.28,0.06,0.0719,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0949, RA-DEC 00:47:06.3-73:10:09.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10834,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10834,19.28,0.06,0.0719,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0835, RA-DEC 00:46:12.2-72:44:09.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10835,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10835,19.28,0.06,0.0719,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1390, RA-DEC 00:49:47.2-73:27:24.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10836,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10836,19.29,0.06,0.072,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1022, RA-DEC 00:47:40.6-73:12:57.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10837,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10837,19.29,0.06,0.072,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1463, RA-DEC 00:50:13.7-72:59:21.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10838,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10838,19.29,0.06,0.072,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2222, RA-DEC 00:54:24.4-73:35:05.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10839,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10839,19.29,0.06,0.072,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1965, RA-DEC 00:52:53.6-73:11:43.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10840,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10840,19.29,0.06,0.072,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0480, RA-DEC 00:42:48.0-73:48:23.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10841,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,10841,19.28,0.17,0.072,2163,NULL,NULL,'K, PLC','SMC',NULL,'1999ApJ...512..711B',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10842,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10842,19.29,0.06,0.072,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4716, RA-DEC 00:46:59.9-74:43:24.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10843,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10843,19.29,0.06,0.072,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4659, RA-DEC 00:18:14.6-73:17:05.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10844,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10844,19.29,0.06,0.072,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0262, RA-DEC 00:37:35.4-74:07:59.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10845,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10845,19.29,0.06,0.072,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2113, RA-DEC 00:53:45.7-72:40:27.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10846,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10846,19.29,0.06,0.0721,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0234, RA-DEC 00:36:13.8-73:59:07.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10847,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10847,19.29,0.06,0.0721,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1884, RA-DEC 00:52:23.9-72:55:09.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10848,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10848,19.29,0.06,0.0721,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4673, RA-DEC 00:20:34.6-73:38:13.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10849,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10849,19.29,0.06,0.0721,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2792, RA-DEC 00:58:11.0-72:25:21.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10850,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10850,19.29,0.06,0.0721,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2705, RA-DEC 00:57:33.8-73:17:06.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10851,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10851,19.29,0.06,0.0721,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1554, RA-DEC 00:50:52.3-72:57:18.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10852,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10852,19.29,0.06,0.0721,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2642, RA-DEC 00:57:07.4-73:38:29.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10853,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10853,19.29,0.06,0.0721,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1648, RA-DEC 00:51:16.6-73:54:24.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10854,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10854,19.29,0.06,0.0722,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0005, RA-DEC 00:21:53.9-72:22:22.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10855,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10855,19.29,0.06,0.0722,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0099, RA-DEC 00:28:48.1-74:22:02.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10856,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10856,19.29,0.06,0.0722,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0133, RA-DEC 00:31:06.4-73:55:17.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10857,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10857,19.29,0.06,0.0722,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0188, RA-DEC 00:34:38.0-74:12:03.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10858,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10858,19.29,0.06,0.0722,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0872, RA-DEC 00:46:29.7-73:37:56.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10859,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10859,19.29,0.06,0.0722,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2679, RA-DEC 00:57:24.7-73:36:40.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10860,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10860,19.29,0.06,0.0722,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4027, RA-DEC 01:08:16.8-72:50:20.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10861,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10861,19.29,0.06,0.0722,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1058, RA-DEC 00:47:52.4-73:03:50.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10862,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10862,19.29,0.06,0.0722,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0006, RA-DEC 00:21:56.4-73:54:55.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10863,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10863,19.29,0.06,0.0723,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0702, RA-DEC 00:45:01.9-73:23:09.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10864,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10864,19.29,0.06,0.0723,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3031, RA-DEC 00:59:43.6-72:23:57.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10865,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10865,19.29,0.06,0.0723,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2632, RA-DEC 00:57:04.9-73:59:35.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10866,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10866,19.3,0.06,0.0723,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0125, RA-DEC 00:30:24.6-73:43:23.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10867,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10867,19.3,0.06,0.0723,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0253, RA-DEC 00:37:20.1-73:39:33.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10868,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10868,19.3,0.06,0.0723,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0438, RA-DEC 00:41:59.5-73:26:13.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10869,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10869,19.3,0.06,0.0723,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0937, RA-DEC 00:47:02.6-73:18:58.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10870,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10870,19.3,0.06,0.0723,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2755, RA-DEC 00:57:55.6-73:05:13.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10871,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10871,19.3,0.06,0.0723,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0149, RA-DEC 00:32:10.0-73:05:40.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10872,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10872,19.3,0.06,0.0723,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1211, RA-DEC 00:48:47.5-73:13:19.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10873,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10873,19.3,0.06,0.0724,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0057, RA-DEC 00:25:34.4-74:13:22.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10874,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10874,19.3,0.06,0.0724,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2150, RA-DEC 00:53:58.3-72:38:52.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10875,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10875,19.3,0.06,0.0724,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1193, RA-DEC 00:48:37.3-73:02:20.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10876,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10876,19.3,0.06,0.0724,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1587, RA-DEC 00:50:59.1-72:41:10.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10877,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10877,19.3,0.06,0.0724,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2042, RA-DEC 00:53:21.8-72:05:44.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10878,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10878,19.3,0.06,0.0725,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0636, RA-DEC 00:44:23.7-72:41:46.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10879,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10879,19.3,0.06,0.0725,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0037, RA-DEC 00:24:23.2-74:03:54.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10880,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10880,19.3,0.06,0.0725,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3635, RA-DEC 01:04:25.7-72:12:14.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10881,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10881,19.3,0.06,0.0725,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3798, RA-DEC 01:06:00.7-72:26:54.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10882,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10882,19.3,0.06,0.0725,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0178, RA-DEC 00:34:11.5-73:31:52.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10883,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10883,19.3,0.06,0.0725,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0529, RA-DEC 00:43:23.2-73:36:57.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10884,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10884,19.3,0.06,0.0725,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1673, RA-DEC 00:51:23.2-72:52:36.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10885,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10885,19.3,0.06,0.0725,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3805, RA-DEC 01:06:04.9-72:18:34.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10886,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10886,19.3,0.06,0.0725,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2051, RA-DEC 00:53:23.4-72:57:43.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10887,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10887,19.3,0.06,0.0726,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4670, RA-DEC 00:19:54.5-74:08:36.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10888,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10888,19.3,0.06,0.0726,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4680, RA-DEC 00:21:27.7-73:28:05.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10889,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10889,19.3,0.06,0.0726,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2749, RA-DEC 00:57:52.0-74:06:17.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10890,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10890,19.3,0.06,0.0726,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3383, RA-DEC 01:02:27.1-73:16:13.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10891,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10891,19.3,0.06,0.0726,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3089, RA-DEC 01:00:11.4-72:33:06.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10892,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10892,19.31,0.06,0.0726,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0199, RA-DEC 00:34:54.3-73:46:47.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10893,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10893,19.31,0.06,0.0726,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0156, RA-DEC 00:33:08.1-74:16:44.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10894,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10894,19.31,0.06,0.0727,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0833, RA-DEC 00:46:11.9-73:34:49.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10895,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10895,19.31,0.06,0.0727,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3969, RA-DEC 01:07:38.5-72:40:35.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10896,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10896,19.31,0.06,0.0727,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0107, RA-DEC 00:29:21.4-73:16:12.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10897,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10897,19.31,0.06,0.0727,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3451, RA-DEC 01:03:00.9-73:18:16.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10898,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10898,19.31,0.06,0.0727,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0089, RA-DEC 00:28:19.5-73:55:32.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10899,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10899,19.31,0.06,0.0727,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0077, RA-DEC 00:27:22.6-73:31:24.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10900,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10900,19.31,0.06,0.0727,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0221, RA-DEC 00:35:42.7-73:52:00.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10901,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10901,19.31,0.06,0.0727,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0110, RA-DEC 00:29:23.8-73:57:03.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10902,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10902,19.31,0.06,0.0727,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0640, RA-DEC 00:44:25.5-74:24:49.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10903,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10903,19.31,0.06,0.0727,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0894, RA-DEC 00:46:38.0-74:23:46.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10904,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10904,19.31,0.06,0.0727,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1110, RA-DEC 00:48:07.2-73:42:55.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10905,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10905,19.31,0.06,0.0727,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2772, RA-DEC 00:58:03.0-73:49:43.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10906,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10906,19.31,0.06,0.0727,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1037, RA-DEC 00:47:46.8-73:50:35.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10907,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10907,19.31,0.06,0.0727,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0164, RA-DEC 00:33:23.2-73:40:50.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10908,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10908,19.31,0.06,0.0727,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1675, RA-DEC 00:51:23.7-73:22:58.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10909,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10909,19.31,0.06,0.0727,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1796, RA-DEC 00:52:00.3-73:27:47.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10910,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10910,19.31,0.06,0.0727,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0390, RA-DEC 00:41:07.7-73:15:16.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10911,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10911,19.31,0.06,0.0727,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3813, RA-DEC 01:06:08.6-71:42:05.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10912,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10912,19.31,0.06,0.0728,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0763, RA-DEC 00:45:36.0-73:22:01.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10913,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10913,19.31,0.06,0.0728,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1239, RA-DEC 00:48:57.6-73:19:01.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10914,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10914,19.31,0.06,0.0728,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2620, RA-DEC 00:56:59.1-74:00:18.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10915,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10915,19.31,0.06,0.0728,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0751, RA-DEC 00:45:24.9-73:15:55.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10916,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10916,19.31,0.06,0.0728,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0730, RA-DEC 00:45:14.0-74:07:42.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10917,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10917,19.31,0.06,0.0728,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2876, RA-DEC 00:58:45.4-71:55:57.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10918,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10918,19.31,0.06,0.0729,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3598, RA-DEC 01:04:10.7-72:18:20.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10919,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10919,19.31,0.06,0.0729,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4750, RA-DEC 00:57:09.0-74:19:48.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10920,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10920,19.31,0.06,0.0729,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1419, RA-DEC 00:49:59.1-72:50:02.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10921,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10921,19.31,0.06,0.0729,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0135, RA-DEC 00:31:13.3-73:29:01.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10922,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10922,19.32,0.06,0.073,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0183, RA-DEC 00:34:33.4-74:00:35.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10923,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10923,19.32,0.06,0.073,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2242, RA-DEC 00:54:32.3-72:45:16.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10924,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10924,19.32,0.06,0.073,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2665, RA-DEC 00:57:18.1-72:55:54.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10925,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10925,19.32,0.06,0.073,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0506, RA-DEC 00:43:02.6-73:53:29.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10926,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10926,19.32,0.06,0.073,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0957, RA-DEC 00:47:09.9-73:10:09.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10927,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10927,19.32,0.06,0.073,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0280, RA-DEC 00:38:16.2-73:39:25.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10928,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10928,19.32,0.06,0.073,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0527, RA-DEC 00:43:21.8-74:02:59.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10929,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10929,19.32,0.06,0.0731,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2231, RA-DEC 00:54:29.7-74:06:33.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10930,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10930,19.32,0.06,0.0731,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4508, RA-DEC 01:16:12.7-72:40:53.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10931,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10931,19.32,0.06,0.0731,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4551, RA-DEC 01:17:44.2-73:25:08.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10932,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10932,19.32,0.06,0.0731,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0020, RA-DEC 00:23:15.5-73:13:58.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10933,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10933,19.32,0.06,0.0731,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0030, RA-DEC 00:24:07.8-74:06:27.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10934,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10934,19.32,0.06,0.0731,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2304, RA-DEC 00:54:56.1-74:09:49.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10935,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10935,19.32,0.06,0.0731,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0540, RA-DEC 00:43:29.4-74:37:26.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10936,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10936,19.32,0.06,0.0731,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0168, RA-DEC 00:33:31.8-73:38:00.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10937,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10937,19.32,0.06,0.0732,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0219, RA-DEC 00:35:42.2-74:06:53.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10938,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10938,19.32,0.06,0.0732,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2262, RA-DEC 00:54:39.8-72:49:32.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10939,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10939,19.32,0.06,0.0732,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3404, RA-DEC 01:02:37.1-72:59:44.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10940,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10940,19.32,0.06,0.0732,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0328, RA-DEC 00:39:43.6-73:50:14.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10941,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10941,19.32,0.06,0.0732,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0068, RA-DEC 00:26:15.8-73:57:41.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10942,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10942,19.32,0.06,0.0732,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0337, RA-DEC 00:39:59.5-74:43:01.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10943,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10943,19.32,0.06,0.0732,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1301, RA-DEC 00:49:18.6-72:33:24.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10944,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10944,19.32,0.06,0.0733,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0284, RA-DEC 00:38:24.4-73:52:55.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10945,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10945,19.32,0.06,0.0733,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0987, RA-DEC 00:47:25.3-73:32:38.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10946,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10946,19.33,0.06,0.0733,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0122, RA-DEC 00:30:11.9-73:44:07.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10947,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10947,19.33,0.06,0.0733,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4739, RA-DEC 00:54:06.2-70:05:54.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10948,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10948,19.33,0.06,0.0733,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1120, RA-DEC 00:48:09.9-73:56:29.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10949,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10949,19.33,0.06,0.0733,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3077, RA-DEC 01:00:05.5-73:45:54.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10950,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10950,19.33,0.06,0.0734,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4214, RA-DEC 01:10:33.3-74:12:28.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10951,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10951,19.33,0.06,0.0734,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1470, RA-DEC 00:50:17.2-73:15:25.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10952,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10952,19.33,0.06,0.0734,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4288, RA-DEC 01:11:38.4-72:23:33.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10953,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10953,19.33,0.06,0.0734,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3443, RA-DEC 01:02:56.5-73:25:01.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10954,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10954,19.33,0.06,0.0734,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4635, RA-DEC 23:57:35.5-75:07:57.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10955,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10955,19.33,0.06,0.0734,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0883, RA-DEC 00:46:32.7-73:50:56.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10956,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10956,19.33,0.06,0.0734,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2073, RA-DEC 00:53:32.4-72:59:14.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10957,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10957,19.33,0.06,0.0734,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2468, RA-DEC 00:55:55.6-73:51:34.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10958,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10958,19.33,0.06,0.0735,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0091, RA-DEC 00:28:25.1-74:08:42.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10959,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10959,19.33,0.06,0.0735,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4946, RA-DEC 01:51:57.8-69:59:13.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10960,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10960,19.33,0.06,0.0735,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0601, RA-DEC 00:44:03.8-74:10:09.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10961,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10961,19.33,0.06,0.0735,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0693, RA-DEC 00:44:53.0-74:18:16.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10962,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10962,19.33,0.06,0.0735,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1623, RA-DEC 00:51:10.5-73:41:59.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10963,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10963,19.33,0.06,0.0735,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0874, RA-DEC 00:46:29.9-73:22:57.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10964,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10964,19.33,0.06,0.0735,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0170, RA-DEC 00:33:37.9-73:31:39.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10965,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10965,19.33,0.06,0.0735,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0237, RA-DEC 00:36:29.6-73:06:44.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10966,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10966,19.33,0.06,0.0735,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0786, RA-DEC 00:45:52.4-73:54:34.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10967,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10967,19.33,0.06,0.0735,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0406, RA-DEC 00:41:26.5-73:04:36.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10968,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10968,19.33,0.06,0.0736,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0317, RA-DEC 00:39:31.9-74:22:56.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10969,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10969,19.33,0.06,0.0736,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1028, RA-DEC 00:47:42.1-72:34:32.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10970,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10970,19.33,0.06,0.0736,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3661, RA-DEC 01:04:42.7-73:00:48.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10971,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10971,19.33,0.06,0.0736,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0124, RA-DEC 00:30:19.4-74:29:39.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10972,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10972,19.33,0.06,0.0736,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0270, RA-DEC 00:37:44.4-74:14:48.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10973,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10973,19.33,0.06,0.0736,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0128, RA-DEC 00:30:38.1-73:50:02.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10974,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10974,19.33,0.06,0.0736,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1075, RA-DEC 00:47:58.0-73:23:10.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10975,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10975,19.34,0.06,0.0736,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0966, RA-DEC 00:47:15.9-74:26:51.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10976,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10976,19.34,0.06,0.0736,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1633, RA-DEC 00:51:11.6-72:27:51.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10977,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10977,19.34,0.06,0.0736,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2798, RA-DEC 00:58:12.8-74:13:39.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10978,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10978,19.34,0.06,0.0737,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0386, RA-DEC 00:41:01.3-73:55:56.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10979,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10979,19.34,0.06,0.0737,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0072, RA-DEC 00:26:43.6-73:32:36.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10980,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10980,19.34,0.06,0.0737,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4676, RA-DEC 00:20:55.3-73:33:13.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10981,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10981,19.34,0.06,0.0737,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0061, RA-DEC 00:26:02.1-73:55:27.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10982,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10982,19.34,0.06,0.0738,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0066, RA-DEC 00:26:09.0-73:55:43.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10983,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10983,19.34,0.06,0.0738,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2494, RA-DEC 00:56:06.1-73:01:33.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10984,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10984,19.34,0.06,0.0738,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0325, RA-DEC 00:39:39.6-72:39:14.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10985,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10985,19.34,0.06,0.0738,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2801, RA-DEC 00:58:15.2-73:59:41.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10986,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10986,19.34,0.06,0.0738,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2823, RA-DEC 00:58:23.2-73:10:16.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10987,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10987,19.34,0.06,0.0738,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0229, RA-DEC 00:36:02.3-73:23:12.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10988,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10988,19.34,0.06,0.0738,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1790, RA-DEC 00:51:59.5-74:26:05.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10989,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10989,19.34,0.06,0.0739,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1867, RA-DEC 00:52:19.5-74:00:29.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10990,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10990,19.34,0.06,0.0739,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3557, RA-DEC 01:03:57.5-73:08:55.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10991,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10991,19.34,0.06,0.0739,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0243, RA-DEC 00:36:46.5-74:01:07.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10992,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10992,19.34,0.06,0.0739,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0266, RA-DEC 00:37:41.0-73:43:05.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10993,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10993,19.34,0.06,0.0739,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0850, RA-DEC 00:46:18.6-73:42:22.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10994,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10994,19.34,0.06,0.074,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1780, RA-DEC 00:51:58.0-74:35:17.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10995,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10995,19.34,0.06,0.074,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4645, RA-DEC 00:14:07.9-73:47:57.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10996,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10996,19.35,0.06,0.074,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2105, RA-DEC 00:53:44.2-73:10:55.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10997,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10997,19.35,0.06,0.074,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4772, RA-DEC 01:02:41.9-77:40:01.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10998,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10998,19.35,0.06,0.074,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0264, RA-DEC 00:37:37.1-74:26:16.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10999,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',10999,19.35,0.06,0.074,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3067, RA-DEC 00:59:58.0-73:54:18.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11000,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11000,19.35,0.06,0.074,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4869, RA-DEC 01:24:36.4-71:04:15.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11001,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11001,19.35,0.06,0.074,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0175, RA-DEC 00:34:08.6-73:49:46.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11002,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11002,19.35,0.06,0.074,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0629, RA-DEC 00:44:20.7-73:50:59.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11003,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11003,19.35,0.06,0.074,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1874, RA-DEC 00:52:21.3-73:03:52.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11004,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11004,19.35,0.06,0.0741,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1023, RA-DEC 00:47:41.2-73:20:47.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11005,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11005,19.35,0.06,0.0741,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1450, RA-DEC 00:50:08.5-72:14:48.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11006,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11006,19.35,0.06,0.0741,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0470, RA-DEC 00:42:35.8-73:03:48.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11007,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11007,19.35,0.06,0.0741,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0311, RA-DEC 00:39:21.1-73:46:47.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11008,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11008,19.35,0.06,0.0741,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0131, RA-DEC 00:30:45.3-74:00:53.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11009,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11009,19.35,0.06,0.0741,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0274, RA-DEC 00:38:01.0-73:34:32.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11010,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11010,19.35,0.06,0.0741,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0643, RA-DEC 00:44:26.3-74:02:36.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11011,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11011,19.35,0.06,0.0741,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0180, RA-DEC 00:34:26.1-73:20:04.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11012,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11012,19.35,0.06,0.0742,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0249, RA-DEC 00:37:01.0-74:14:54.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11013,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11013,19.35,0.06,0.0742,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0257, RA-DEC 00:37:32.2-74:03:49.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11014,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11014,19.35,0.06,0.0742,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0869, RA-DEC 00:46:27.8-72:08:24.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11015,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11015,19.35,0.06,0.0743,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0003, RA-DEC 00:21:04.6-73:46:15.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11016,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11016,19.35,0.06,0.0743,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2292, RA-DEC 00:54:51.7-73:37:37.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11017,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11017,19.35,0.06,0.0743,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2502, RA-DEC 00:56:07.8-72:52:42.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11018,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11018,19.36,0.06,0.0743,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0830, RA-DEC 00:46:11.1-74:27:37.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11019,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11019,19.36,0.06,0.0744,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0162, RA-DEC 00:33:20.1-73:44:11.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11020,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11020,19.36,0.06,0.0744,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0982, RA-DEC 00:47:21.7-73:06:11.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11021,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11021,19.36,0.06,0.0744,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0238, RA-DEC 00:36:31.9-73:36:14.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11022,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11022,19.36,0.06,0.0744,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1137, RA-DEC 00:48:15.5-73:57:39.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11023,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11023,19.36,0.06,0.0744,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4688, RA-DEC 00:29:00.4-75:12:30.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11024,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11024,19.36,0.06,0.0744,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0069, RA-DEC 00:26:18.7-73:32:26.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11025,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11025,19.36,0.06,0.0744,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4671, RA-DEC 00:19:59.9-73:24:48.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11026,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11026,19.36,0.06,0.0744,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0461, RA-DEC 00:42:22.4-73:39:48.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11027,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11027,19.36,0.06,0.0744,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0377, RA-DEC 00:40:47.2-74:05:23.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11028,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11028,19.36,0.06,0.0745,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0482, RA-DEC 00:42:50.7-74:38:08.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11029,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11029,19.36,0.06,0.0745,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0796, RA-DEC 00:45:56.6-73:10:45.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11030,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11030,19.36,0.06,0.0745,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1813, RA-DEC 00:52:03.7-72:58:02.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11031,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11031,19.36,0.06,0.0746,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0070, RA-DEC 00:26:20.3-73:22:24.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11032,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11032,19.36,0.06,0.0746,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0260, RA-DEC 00:37:33.2-73:59:05.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11033,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11033,19.36,0.06,0.0746,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2328, RA-DEC 00:55:01.2-72:08:50.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11034,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11034,19.36,0.06,0.0746,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1478, RA-DEC 00:50:21.1-73:32:15.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11035,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11035,19.37,0.06,0.0747,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0076, RA-DEC 00:27:10.9-73:16:58.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11036,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11036,19.37,0.06,0.0747,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1921, RA-DEC 00:52:36.0-73:21:31.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11037,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11037,19.37,0.06,0.0747,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0802, RA-DEC 00:45:59.0-73:21:41.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11038,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11038,19.37,0.06,0.0747,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0335, RA-DEC 00:39:54.3-74:31:23.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11039,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11039,19.37,0.06,0.0747,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2181, RA-DEC 00:54:08.5-73:02:49.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11040,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11040,19.37,0.06,0.0747,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4756, RA-DEC 00:58:17.3-70:46:33.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11041,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11041,19.37,0.06,0.0748,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0023, RA-DEC 00:23:40.1-73:23:56.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11042,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11042,19.37,0.06,0.0748,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0499, RA-DEC 00:43:00.2-73:18:15.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11043,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11043,19.37,0.06,0.0749,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2030, RA-DEC 00:53:17.3-72:26:53.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11044,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11044,19.37,0.06,0.0749,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1934, RA-DEC 00:52:41.3-73:36:29.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11045,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11045,19.37,0.06,0.0749,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2045, RA-DEC 00:53:22.4-72:03:48.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11046,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11046,19.37,0.06,0.0749,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0675, RA-DEC 00:44:42.1-73:42:22.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11047,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11047,19.37,0.06,0.0749,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0323, RA-DEC 00:39:36.8-73:34:54.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11048,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11048,19.37,0.06,0.0749,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0779, RA-DEC 00:45:48.2-74:13:37.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11049,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11049,19.37,0.06,0.0749,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3362, RA-DEC 01:02:16.1-72:44:24.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11050,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11050,19.37,0.06,0.075,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0393, RA-DEC 00:41:10.8-73:48:48.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11051,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11051,19.37,0.06,0.075,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4429, RA-DEC 01:14:05.2-72:40:00.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11052,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11052,19.37,0.06,0.075,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0341, RA-DEC 00:40:03.5-74:10:16.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11053,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11053,19.38,0.06,0.075,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2070, RA-DEC 00:53:31.3-72:39:16.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11054,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11054,19.38,0.06,0.075,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0331, RA-DEC 00:39:45.5-73:45:19.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11055,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11055,19.38,0.06,0.075,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2371, RA-DEC 00:55:19.2-72:29:04.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11056,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11056,19.38,0.06,0.075,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1174, RA-DEC 00:48:31.9-73:53:00.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11057,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11057,19.38,0.06,0.075,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0299, RA-DEC 00:38:58.5-73:48:31.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11058,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11058,19.38,0.06,0.075,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0839, RA-DEC 00:46:13.2-73:59:08.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11059,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11059,19.38,0.06,0.0751,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0045, RA-DEC 00:25:13.8-73:13:53.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11060,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11060,19.38,0.06,0.0751,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1949, RA-DEC 00:52:48.1-73:28:28.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11061,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11061,19.38,0.06,0.0751,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0273, RA-DEC 00:38:01.0-74:09:42.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11062,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11062,19.38,0.06,0.0751,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1455, RA-DEC 00:50:09.6-73:20:48.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11063,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11063,19.38,0.06,0.0752,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0148, RA-DEC 00:32:06.1-73:45:18.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11064,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11064,19.38,0.06,0.0752,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2587, RA-DEC 00:56:42.8-73:54:42.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11065,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11065,19.38,0.06,0.0752,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3945, RA-DEC 01:07:25.4-73:02:28.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11066,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11066,19.38,0.06,0.0752,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0671, RA-DEC 00:44:38.1-74:01:21.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11067,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11067,19.38,0.06,0.0753,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0414, RA-DEC 00:41:41.5-74:12:09.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11068,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11068,19.38,0.06,0.0753,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1404, RA-DEC 00:49:52.9-73:09:09.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11069,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11069,19.39,0.06,0.0753,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3239, RA-DEC 01:01:16.8-73:12:15.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11070,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11070,19.39,0.06,0.0754,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1114, RA-DEC 00:48:08.0-73:04:28.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11071,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11071,19.39,0.06,0.0754,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4849, RA-DEC 01:17:37.9-74:26:36.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11072,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11072,19.39,0.06,0.0754,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0451, RA-DEC 00:42:12.5-74:08:48.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11073,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11073,19.39,0.06,0.0755,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2286, RA-DEC 00:54:50.1-72:31:28.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11074,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11074,19.39,0.06,0.0755,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0083, RA-DEC 00:27:44.5-74:04:55.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11075,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11075,19.39,0.06,0.0755,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1900, RA-DEC 00:52:30.1-73:16:40.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11076,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11076,19.39,0.06,0.0755,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0580, RA-DEC 00:43:54.4-73:45:05.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11077,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11077,19.39,0.06,0.0755,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0517, RA-DEC 00:43:09.4-73:44:54.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11078,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11078,19.39,0.06,0.0756,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0664, RA-DEC 00:44:33.7-73:33:13.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11079,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11079,19.39,0.06,0.0756,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0792, RA-DEC 00:45:54.5-73:51:22.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11080,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11080,19.39,0.06,0.0756,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3051, RA-DEC 00:59:51.4-73:06:54.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11081,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11081,19.39,0.06,0.0756,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1893, RA-DEC 00:52:28.7-73:12:50.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11082,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11082,19.39,0.06,0.0756,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0268, RA-DEC 00:37:41.7-74:45:31.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11083,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11083,19.39,0.06,0.0756,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2669, RA-DEC 00:57:19.0-74:01:32.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11084,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11084,19.39,0.06,0.0756,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3100, RA-DEC 01:00:16.1-73:08:18.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11085,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11085,19.39,0.06,0.0756,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4660, RA-DEC 00:18:16.3-74:28:39.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11086,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11086,19.39,0.06,0.0757,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0373, RA-DEC 00:40:45.2-74:06:16.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11087,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11087,19.39,0.06,0.0757,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0617, RA-DEC 00:44:12.5-73:29:42.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11088,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11088,19.4,0.06,0.0758,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2954, RA-DEC 00:59:12.7-72:51:30.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11089,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11089,19.4,0.06,0.0758,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1691, RA-DEC 00:51:27.1-73:40:54.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11090,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11090,19.4,0.06,0.0758,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0222, RA-DEC 00:35:44.6-73:13:47.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11091,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11091,19.4,0.06,0.0758,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0656, RA-DEC 00:44:29.2-73:40:09.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11092,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11092,19.4,0.06,0.0758,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0426, RA-DEC 00:41:52.3-73:58:42.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11093,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11093,19.4,0.06,0.0758,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2381, RA-DEC 00:55:21.9-72:52:36.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11094,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11094,19.4,0.06,0.0758,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4683, RA-DEC 00:22:22.6-68:28:35.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11095,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11095,19.4,0.06,0.0758,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0036, RA-DEC 00:24:22.0-73:09:43.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11096,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11096,19.4,0.06,0.0759,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4561, RA-DEC 01:18:15.0-72:43:31.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11097,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11097,19.4,0.06,0.0759,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0265, RA-DEC 00:37:40.7-74:12:23.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11098,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11098,19.4,0.06,0.0759,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2928, RA-DEC 00:59:03.4-72:20:20.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11099,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11099,19.4,0.06,0.0759,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1956, RA-DEC 00:52:49.8-73:26:54.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11100,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11100,19.4,0.06,0.0759,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3018, RA-DEC 00:59:37.0-73:26:13.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11101,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11101,19.4,0.06,0.076,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0725, RA-DEC 00:45:12.4-73:33:17.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11102,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11102,19.4,0.06,0.076,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1191, RA-DEC 00:48:36.5-73:39:04.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11103,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11103,19.4,0.06,0.076,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4715, RA-DEC 00:46:47.9-75:18:13.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11104,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11104,19.4,0.06,0.076,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1386, RA-DEC 00:49:45.2-73:31:09.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11105,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11105,19.41,0.06,0.0761,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0401, RA-DEC 00:41:20.0-74:00:35.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11106,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11106,19.41,0.06,0.0761,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0476, RA-DEC 00:42:43.0-73:45:21.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11107,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11107,19.41,0.06,0.0761,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2710, RA-DEC 00:57:34.7-73:59:45.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11108,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11108,19.41,0.06,0.0761,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4921, RA-DEC 01:40:39.7-74:32:43.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11109,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11109,19.41,0.06,0.0762,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4719, RA-DEC 00:48:05.9-75:47:16.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11110,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11110,19.41,0.06,0.0762,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0896, RA-DEC 00:46:39.3-73:03:45.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11111,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11111,19.41,0.06,0.0762,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0181, RA-DEC 00:34:28.6-74:02:45.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11112,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11112,19.41,0.06,0.0763,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2760, RA-DEC 00:57:57.7-72:25:51.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11113,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11113,19.41,0.06,0.0763,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0186, RA-DEC 00:34:37.0-73:01:21.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11114,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11114,19.41,0.06,0.0763,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4647, RA-DEC 00:14:51.2-74:25:38.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11115,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11115,19.41,0.06,0.0764,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2168, RA-DEC 00:54:04.1-73:19:25.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11116,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11116,19.42,0.06,0.0764,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1036, RA-DEC 00:47:46.8-73:03:26.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11117,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11117,19.42,0.06,0.0765,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0614, RA-DEC 00:44:10.7-72:44:42.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11118,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11118,19.42,0.06,0.0765,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0071, RA-DEC 00:26:33.6-74:20:52.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11119,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11119,19.42,0.06,0.0765,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0536, RA-DEC 00:43:27.4-73:31:53.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11120,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11120,19.42,0.06,0.0765,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1994, RA-DEC 00:53:04.2-74:15:31.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11121,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11121,19.42,0.06,0.0765,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2261, RA-DEC 00:54:39.6-72:28:51.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11122,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11122,19.42,0.06,0.0766,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1899, RA-DEC 00:52:30.0-73:52:24.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11123,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11123,19.42,0.06,0.0766,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2001, RA-DEC 00:53:08.1-74:36:03.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11124,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11124,19.42,0.06,0.0766,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4760, RA-DEC 00:59:40.8-76:00:24.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11125,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11125,19.42,0.06,0.0766,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0573, RA-DEC 00:43:48.3-72:39:56.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11126,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11126,19.42,0.06,0.0766,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0561, RA-DEC 00:43:41.3-73:36:52.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11127,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11127,19.42,0.06,0.0766,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3521, RA-DEC 01:03:35.5-72:57:08.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11128,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11128,19.42,0.06,0.0767,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1727, RA-DEC 00:51:39.8-73:53:55.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11129,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11129,19.43,0.06,0.0768,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0021, RA-DEC 00:23:21.0-73:36:10.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11130,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11130,19.43,0.06,0.0768,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1275, RA-DEC 00:49:11.4-74:19:08.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11131,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11131,19.43,0.06,0.0768,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3226, RA-DEC 01:01:10.4-73:17:41.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11132,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11132,19.43,0.06,0.0768,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4721, RA-DEC 00:49:05.8-74:49:48.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11133,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11133,19.43,0.06,0.0768,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0440, RA-DEC 00:42:03.6-73:17:32.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11134,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11134,19.43,0.06,0.0768,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4639, RA-DEC 00:04:47.0-72:53:05.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11135,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11135,19.43,0.06,0.0769,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0962, RA-DEC 00:47:14.8-72:36:33.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11136,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11136,19.43,0.06,0.0769,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1124, RA-DEC 00:48:12.6-73:13:19.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11137,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11137,19.43,0.06,0.077,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2516, RA-DEC 00:56:12.6-72:38:36.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11138,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11138,19.43,0.06,0.077,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0697, RA-DEC 00:44:57.2-73:54:41.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11139,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11139,19.43,0.06,0.077,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4693, RA-DEC 00:36:52.7-66:35:35.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11140,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11140,19.44,0.06,0.0771,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2162, RA-DEC 00:54:01.4-72:58:44.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11141,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11141,19.44,0.06,0.0771,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0537, RA-DEC 00:43:28.0-74:33:23.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11142,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11142,19.44,0.06,0.0772,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0316, RA-DEC 00:39:30.8-74:15:48.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11143,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11143,19.44,0.06,0.0772,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2625, RA-DEC 00:57:02.9-73:04:56.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11144,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11144,19.44,0.06,0.0772,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0261, RA-DEC 00:37:34.6-73:46:10.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11145,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11145,19.45,0.06,0.0775,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0610, RA-DEC 00:44:06.4-73:24:19.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11146,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11146,19.45,0.06,0.0776,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1590, RA-DEC 00:51:00.3-72:07:38.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11147,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11147,19.45,0.06,0.0778,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0710, RA-DEC 00:45:04.8-73:42:21.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11148,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11148,19.45,0.06,0.0778,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1592, RA-DEC 00:51:00.6-73:40:44.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11149,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11149,19.45,0.06,0.0778,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4685, RA-DEC 00:23:04.9-75:14:06.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11150,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11150,19.46,0.06,0.0778,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0346, RA-DEC 00:40:13.6-73:41:37.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11151,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11151,19.46,0.06,0.0779,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1052, RA-DEC 00:47:51.4-73:24:21.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11152,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11152,19.46,0.06,0.078,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0112, RA-DEC 00:29:29.2-74:03:40.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11153,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11153,19.46,0.06,0.0781,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2822, RA-DEC 00:58:23.0-73:34:45.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11154,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11154,19.46,0.06,0.0781,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0343, RA-DEC 00:40:08.6-72:41:30.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11155,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11155,19.46,0.06,0.0781,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2519, RA-DEC 00:56:14.7-73:27:18.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11156,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11156,19.47,0.06,0.0782,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0943, RA-DEC 00:47:04.2-74:04:48.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11157,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11157,19.47,0.06,0.0783,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0734, RA-DEC 00:45:14.7-73:35:17.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11158,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11158,19.47,0.06,0.0783,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0224, RA-DEC 00:35:50.1-73:06:09.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11159,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11159,19.47,0.06,0.0784,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1998, RA-DEC 00:53:06.9-73:14:45.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11160,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11160,19.47,0.06,0.0785,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2690, RA-DEC 00:57:27.8-72:33:49.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11161,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11161,19.48,0.06,0.0786,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1823, RA-DEC 00:52:07.0-73:15:52.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11162,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11162,19.48,0.06,0.0787,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0232, RA-DEC 00:36:10.3-73:56:40.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11163,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11163,19.48,0.06,0.0787,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1209, RA-DEC 00:48:47.1-73:05:36.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11164,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11164,19.48,0.06,0.0787,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4950, RA-DEC 01:55:50.6-73:29:00.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11165,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11165,19.48,0.02,0.0788,2163,NULL,NULL,'HV 01365, IRAC 3.6 micron','SMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11166,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11166,19.48,0.06,0.0788,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2511, RA-DEC 00:56:10.9-73:23:00.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11167,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11167,19.48,0.06,0.0788,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3745, RA-DEC 01:05:30.5-72:49:50.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11168,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11168,19.48,0.06,0.0789,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4150, RA-DEC 01:09:44.7-72:50:55.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11169,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11169,19.48,0.06,0.0789,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0416, RA-DEC 00:41:42.6-74:22:11.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11170,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11170,19.49,0.06,0.0789,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0120, RA-DEC 00:29:57.2-74:00:53.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11171,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11171,19.49,0.06,0.0789,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2666, RA-DEC 00:57:18.2-73:26:38.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11172,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11172,19.49,0.06,0.0789,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4761, RA-DEC 00:59:41.2-70:49:50.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11173,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11173,19.49,0.06,0.0792,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1946, RA-DEC 00:52:46.4-73:01:37.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11174,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11174,19.49,0.06,0.0793,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1096, RA-DEC 00:48:03.0-72:19:40.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11175,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11175,19.5,0.06,0.0793,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0578, RA-DEC 00:43:52.8-73:28:36.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11176,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11176,19.5,0.06,0.0793,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0727, RA-DEC 00:45:12.9-74:18:20.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11177,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11177,19.5,0.06,0.0793,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0977, RA-DEC 00:47:20.2-73:26:17.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11178,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11178,19.5,0.06,0.0794,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0735, RA-DEC 00:45:15.3-73:27:30.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11179,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11179,19.5,0.06,0.0795,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0990, RA-DEC 00:47:26.0-73:26:50.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11180,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11180,19.5,0.06,0.0795,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0065, RA-DEC 00:26:08.2-73:57:18.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11181,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11181,19.5,0.06,0.0795,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2064, RA-DEC 00:53:28.5-74:30:51.6','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11182,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11182,19.51,0.06,0.0797,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3357, RA-DEC 01:02:13.5-73:23:59.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11183,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11183,19.51,0.06,0.0798,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0209, RA-DEC 00:35:16.1-73:05:08.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11184,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11184,19.51,0.06,0.0798,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0460, RA-DEC 00:42:22.1-73:51:09.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11185,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11185,19.52,0.06,0.0801,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0327, RA-DEC 00:39:42.6-74:27:56.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11186,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11186,19.52,0.06,0.0802,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-0347, RA-DEC 00:40:14.3-74:06:38.1','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11187,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11187,19.52,0.06,0.0803,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1147, RA-DEC 00:48:21.5-73:18:43.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11188,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11188,19.53,0.06,0.0804,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4745, RA-DEC 00:56:48.7-74:55:32.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11189,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11189,19.53,0.06,0.0805,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4622, RA-DEC 01:24:17.3-73:16:09.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11190,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11190,19.53,0.06,0.0805,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1985, RA-DEC 00:53:00.1-74:07:08.2','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11191,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11191,19.54,0.06,0.0809,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4636, RA-DEC 23:58:27.9-68:45:59.5','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11192,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11192,19.54,0.06,0.0809,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4032, RA-DEC 01:08:19.4-72:52:47.7','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11193,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11193,19.55,0.06,0.0814,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1178, RA-DEC 00:48:32.9-73:20:39.0','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11194,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11194,19.55,0.06,0.0815,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-1216, RA-DEC 00:48:48.3-72:46:56.9','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11195,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11195,19.56,0.06,0.0815,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-4121, RA-DEC 01:09:21.2-72:30:21.8','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11196,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11196,19.56,0.06,0.0817,2163,73,NULL,'Cepheids periods Gaussian ','SMC',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11197,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11197,19.57,0.06,0.0819,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-2180, RA-DEC 00:54:07.6-73:37:36.4','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11198,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11198,19.57,0.06,0.082,2163,NULL,NULL,'1, VI, OGLE-SMC-CEP-3721, RA-DEC 01:05:17.9-74:03:10.3','SMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11199,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11199,19.7,0.04,0.0871,2163,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian ','SMC',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11200,'Cepheids','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11200,19.84,0.02,0.0929,2163,73,NULL,'Cepheids magnitudes Gaussian ','SMC',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11201,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11201,17.95,0.3,0.0389,2163,NULL,NULL,'SMC-LMC bridge star cluster BBDS 4 ','SMC',NULL,'2015MNRAS.453.3190B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11202,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11202,17.96,0.26,0.0392,2163,NULL,NULL,'SMC-LMC bridge star cluster NGC 0796, dusty template','SMC',NULL,'2015MNRAS.453.3190B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11203,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11203,18,0.3,0.0398,2163,NULL,NULL,'SMC-LMC bridge star cluster BS 216 ','SMC',NULL,'2015MNRAS.453.3190B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11204,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11204,18,0.3,0.0398,2163,NULL,NULL,'SMC-LMC bridge star cluster BS 225 ','SMC',NULL,'2015MNRAS.453.3190B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11205,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11205,18,0.2,0.0398,2163,NULL,NULL,'SMC-LMC bridge star cluster BS 226 ','SMC',NULL,'2015MNRAS.453.3190B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11206,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11206,18,0.25,0.0398,2163,NULL,NULL,'SMC-LMC bridge star cluster BS 233 ','SMC',NULL,'2015MNRAS.453.3190B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11207,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11207,18,0.3,0.0398,2163,NULL,NULL,'SMC-LMC bridge star cluster BS 239 ','SMC',NULL,'2015MNRAS.453.3190B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11208,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11208,18,0.3,0.0398,2163,NULL,NULL,'SMC-LMC bridge star cluster BS 240 ','SMC',NULL,'2015MNRAS.453.3190B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11209,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11209,18,0.3,0.0398,2163,NULL,NULL,'SMC-LMC bridge star cluster BS 245','SMC',NULL,'2015MNRAS.453.3190B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11210,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11210,18.01,0.26,0.0401,2163,NULL,NULL,'SMC-LMC bridge star cluster NGC 0796, template','SMC',NULL,'2015MNRAS.453.3190B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11211,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11211,18.04,0.28,0.0406,2163,NULL,NULL,'SMC-LMC bridge star cluster NGC 0796','SMC',NULL,'2015MNRAS.453.3190B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11212,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11212,18.2,0.3,0.0437,2163,NULL,NULL,'SMC-LMC bridge star cluster BS 232 ','SMC',NULL,'2015MNRAS.453.3190B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11213,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11213,18.2,0.3,0.0437,2163,NULL,NULL,'SMC-LMC bridge star cluster BS 235 ','SMC',NULL,'2015MNRAS.453.3190B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11214,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11214,18.2,0.3,0.0437,2163,NULL,NULL,'SMC-LMC bridge star cluster ICA 18 ','SMC',NULL,'2015MNRAS.453.3190B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11215,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11215,18.3,0.3,0.0457,2163,NULL,NULL,'SMC-LMC bridge star cluster WG8 ','SMC',NULL,'2015MNRAS.453.3190B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11216,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11216,18.4,0.25,0.0479,2163,NULL,NULL,'SMC-LMC bridge star cluster BS 223 ','SMC',NULL,'2015MNRAS.453.3190B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11217,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11217,18.4,0.3,0.0479,2163,NULL,NULL,'SMC-LMC bridge star cluster WG13 ','SMC',NULL,'2015MNRAS.453.3190B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11218,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11218,18.5,0.12,0.0502,2163,NULL,NULL,'NGC 0419','SMC',NULL,'2008AJ....136.1703G',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11219,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11219,18.64,0.14,0.0535,2163,NULL,NULL,'Lindsay 3 ','SMC',NULL,'2014A&A...561A.106D',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11220,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11220,18.65,0.07,0.0537,2163,NULL,NULL,'Tile 5_6 11, RA024.592099, DEC-71.245543','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11221,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11221,18.67,0.08,0.0542,2163,NULL,NULL,'Tile 5_6  1, RA027.267807, DEC-71.863483','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11222,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11222,18.67,0.08,0.0542,2163,NULL,NULL,'Tile 5_6  2, RA026.263977, DEC-71.948757','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11223,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11223,18.67,0.08,0.0542,2163,NULL,NULL,'Tile 5_6  9, RA026.779314, DEC-71.079524','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11224,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11224,18.67,0.08,0.0542,2163,NULL,NULL,'Tile 5_6 10, RA025.687649, DEC-71.173641','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11225,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11225,18.68,0.14,0.0545,2163,NULL,NULL,'Lindsay 2 ','SMC',NULL,'2014A&A...561A.106D',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11226,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11226,18.69,0.09,0.0547,2163,NULL,NULL,'Tile 5_6  3, RA025.108557, DEC-72.035679','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11227,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11227,18.69,0.09,0.0547,2163,NULL,NULL,'Tile 5_6 12, RA023.474552, DEC-71.314745','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11228,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11228,18.7,0.1,0.055,2163,NULL,NULL,'Tile 5_6  5, RA027.075805, DEC-71.478068','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11229,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11229,18.7,NULL,0.055,2163,NULL,NULL,NULL,'SMC',NULL,'1987AJ.....93.1070G',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11230,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11230,18.7,NULL,0.055,2163,NULL,NULL,'NGC 0602','SMC',NULL,'2009AJ....137.3668C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11231,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11231,18.72,0.12,0.0555,2163,NULL,NULL,'Tile 5_6  7, RA024.848131, DEC-71.639807','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11232,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11232,18.73,0.07,0.0557,2163,NULL,NULL,'Tile 6_5  5, RA021.995664, DEC-70.695168','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11233,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11233,18.73,0.09,0.0557,2163,NULL,NULL,'Tile 6_5  6, RA020.921916, DEC-70.752726','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11234,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11234,18.74,0.16,0.056,2163,NULL,NULL,'Tile 6_5 10, RA020.758280, DEC-70.357535','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11235,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11235,18.74,0.09,0.056,2163,NULL,NULL,'Tile 6_5 11, RA019.683425, DEC-70.400090','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11236,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11236,18.74,NULL,0.056,2163,NULL,NULL,NULL,'SMC',NULL,'2011AJ....142..103B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11237,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11237,18.75,0.17,0.0562,2163,NULL,NULL,'Tile 6_5  1, RA022.093202, DEC-71.087722','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11238,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11238,18.75,0.12,0.0562,2163,NULL,NULL,'Tile 6_5  9, RA021.809870, DEC-70.296246','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11239,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11239,18.76,0.17,0.0565,2163,NULL,NULL,'Tile 3_5  1, RA023.997664, DEC-74.313353','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11240,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11240,18.76,0.11,0.0565,2163,NULL,NULL,'Tile 3_5  9, RA023.573323, DEC-73.528697','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11241,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11241,18.76,0.17,0.0565,2163,NULL,NULL,'Tile 3_5 10, RA022.325932, DEC-73.582565','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11242,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11242,18.77,0.13,0.0568,2163,NULL,NULL,'Tile 3_5 11, RA021.037088, DEC-73.641828','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11243,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11243,18.77,0.11,0.0568,2163,NULL,NULL,'Tile 6_5  7, RA019.829018, DEC-70.800155','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11244,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11244,18.77,NULL,0.0568,2163,NULL,NULL,'SFH1, Bologna','SMC',NULL,'2012ApJ...754..130C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11245,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11245,18.78,0.12,0.057,2163,NULL,NULL,'Tile 3_5  7, RA021.243664, DEC-74.042596','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11246,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11246,18.78,0.11,0.057,2163,NULL,NULL,'Tile 3_5  8, RA019.937722, DEC-74.087702','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11247,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11247,18.78,0.03,0.057,2163,NULL,NULL,'Tile 5_6  6, RA025.968028, DEC-71.562959','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11248,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11248,18.78,0.11,0.057,2163,NULL,NULL,'Tile 6_5  2, RA021.091030, DEC-71.143914','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11249,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11249,18.79,0.16,0.0573,2163,NULL,NULL,'Tile 3_5  2, RA022.807817, DEC-74.378356','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11250,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11250,18.79,0.11,0.0573,2163,NULL,NULL,'Tile 3_5  4, RA020.129864, DEC-74.482833','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11251,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,'R',11251,18.8,0.3,0.0575,2163,NULL,NULL,'NGC 0371','SMC',NULL,'1990PhDT.........5L',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11252,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11252,18.8,NULL,0.0575,2163,NULL,NULL,'NGC 0411','SMC',NULL,'1986ApJ...305..214D',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11253,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11253,18.8,NULL,0.0575,2163,NULL,NULL,'SFH4, Bologna','SMC',NULL,'2012ApJ...754..130C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11254,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11254,18.8,NULL,0.0575,2163,NULL,NULL,'NGC 0419','SMC',NULL,'2014MNRAS.442.1897R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11255,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11255,18.8,0.15,0.0575,2163,NULL,NULL,'Tile 3_5  3, RA021.475381, DEC-74.437886','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11256,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11256,18.8,0.15,0.0575,2163,NULL,NULL,'Tile 3_5  5, RA023.840863, DEC-73.918110','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11257,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11257,18.8,0.15,0.0575,2163,NULL,NULL,'Tile 3_5  6, RA022.554634, DEC-73.986199','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11258,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11258,18.8,0.07,0.0575,2163,NULL,NULL,'Tile 4_5  9, RA022.896744, DEC-72.449679','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11259,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11259,18.8,0.03,0.0575,2163,NULL,NULL,'Tile 5_6  4, RA023.961884, DEC-72.099015','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11260,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11260,18.8,0.05,0.0575,2163,NULL,NULL,'Tile 5_6  8, RA023.720892, DEC-71.709690','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11261,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11261,18.8,0.12,0.0575,2163,NULL,NULL,'Tile 6_5 12, RA018.603359, DEC-70.440070','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11262,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11262,18.81,NULL,0.0578,2163,NULL,NULL,'SFH9 Wing, Bologna','SMC',NULL,'2013ApJ...775...83C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11263,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11263,18.82,0.13,0.0581,2163,NULL,NULL,'Tile 3_5 12, RA019.742355, DEC-73.687421','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11264,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11264,18.82,0.03,0.0581,2163,NULL,NULL,'NGC 0411','SMC',NULL,'2014ApJ...797...35G',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11265,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11265,18.83,NULL,0.0583,2163,NULL,NULL,'SFH1, Cole','SMC',NULL,'2012ApJ...754..130C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11266,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11266,18.83,NULL,0.0583,2163,NULL,NULL,'SFH10 Intermediate, Bologna','SMC',NULL,'2013ApJ...775...83C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11267,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11267,18.83,0.09,0.0583,2163,NULL,NULL,'Tile 4_5  5, RA023.146286, DEC-72.847360','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11268,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11268,18.84,0.16,0.0586,2163,NULL,NULL,'HW1 ','SMC',NULL,'2014A&A...561A.106D',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11269,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11269,18.84,0.09,0.0586,2163,NULL,NULL,'Tile 6_5  4, RA018.839488, DEC-71.253638','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11270,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11270,18.84,0.11,0.0586,2163,NULL,NULL,'Tile 6_5  8, RA018.728946, DEC-70.846367','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11271,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11271,18.85,0.03,0.0589,2163,NULL,NULL,'Tile 4_3  1, RA013.137099, DEC-73.500273','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11272,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11272,18.85,0.03,0.0589,2163,NULL,NULL,'Tile 4_3  5, RA013.227163, DEC-73.125518','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11273,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11273,18.85,0.1,0.0589,2163,NULL,NULL,'Tile 4_5  2, RA022.137472, DEC-73.307466','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11274,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11274,18.85,0.1,0.0589,2163,NULL,NULL,'Tile 4_5  6, RA021.912306, DEC-72.903725','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11275,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11275,18.85,0.1,0.0589,2163,NULL,NULL,'Tile 4_5 10, RA021.695778, DEC-72.516018','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11276,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11276,18.85,0.03,0.0589,2163,NULL,NULL,'NGC 0419','SMC',NULL,'2014ApJ...797...35G',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11277,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11277,18.85,NULL,0.0589,2163,NULL,NULL,'SFH4, Cole','SMC',NULL,'2012ApJ...754..130C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11278,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11278,18.85,NULL,0.0589,2163,NULL,NULL,'SFH5 Central, Bologna','SMC',NULL,'2013ApJ...775...83C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11279,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11279,18.85,NULL,0.0589,2163,NULL,NULL,'SFH8 Outer, Bologna','SMC',NULL,'2013ApJ...775...83C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11280,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11280,18.86,0.03,0.0592,2163,NULL,NULL,'Tile 4_3  2, RA011.984847, DEC-73.513337','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11281,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11281,18.86,0.09,0.0592,2163,NULL,NULL,'Tile 4_3  6, RA011.994916, DEC-73.128074','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11282,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11282,18.86,0.12,0.0592,2163,NULL,NULL,'Tile 4_4  2, RA017.059500, DEC-73.463864','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11283,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11283,18.86,0.11,0.0592,2163,NULL,NULL,'Tile 4_4  3, RA015.800926, DEC-73.488713','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11284,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11284,18.86,0.11,0.0592,2163,NULL,NULL,'Tile 4_4  6, RA016.963994, DEC-73.074933','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11285,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11285,18.86,0.11,0.0592,2163,NULL,NULL,'Tile 4_4  7, RA015.731938, DEC-73.101772','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11286,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11286,18.86,0.11,0.0592,2163,NULL,NULL,'Tile 4_4  8, RA014.496193, DEC-73.117267','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11287,'CMD','2016-12-15 15:13:40','2016-12-16 11:18:42','1',NULL,NULL,11287,18.86,0.11,0.0592,2163,NULL,NULL,'Tile 4_4 10, RA016.867758, DEC-72.685404','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11288,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11288,18.86,0.12,0.0592,2163,NULL,NULL,'Tile 4_4 11, RA015.667464, DEC-72.709123','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11289,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11289,18.86,0.11,0.0592,2163,NULL,NULL,'Tile 4_4 12, RA014.451193, DEC-72.725821','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11290,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11290,18.86,0.11,0.0592,2163,NULL,NULL,'Tile 4_5  1, RA023.250379, DEC-73.241311','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11291,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11291,18.86,0.11,0.0592,2163,NULL,NULL,'Tile 4_5  3, RA020.889845, DEC-73.349087','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11292,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11292,18.88,0.08,0.0592,2163,NULL,NULL,NULL,'SMC',NULL,'2001ApJ...562..303D',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11293,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11293,18.87,0.04,0.0594,2163,NULL,NULL,'Tile 4_3 10, RA012.015438, DEC-72.739256','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11294,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11294,18.87,0.12,0.0594,2163,NULL,NULL,'Tile 4_4  1, RA018.218515, DEC-73.429413','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11295,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11295,18.87,0.12,0.0594,2163,NULL,NULL,'Tile 4_4  4, RA014.539625, DEC-73.506099','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11296,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11296,18.87,0.12,0.0594,2163,NULL,NULL,'Tile 4_4  5, RA018.182213, DEC-73.041480','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11297,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11297,18.87,0.12,0.0594,2163,NULL,NULL,'Tile 4_4  9, RA018.060889, DEC-72.654660','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11298,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11298,18.87,0.1,0.0594,2163,NULL,NULL,'Tile 4_5 11, RA020.484189, DEC-72.566628','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11299,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11299,18.87,0.03,0.0594,2163,NULL,NULL,'Tile 6_5  3, RA019.967012, DEC-71.198553','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11300,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11300,18.87,0.01,0.0595,2163,NULL,NULL,'Kinematic center, mean of 108 tiles','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11301,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11301,18.84,0.04,0.0596,2163,NULL,NULL,'NGC 0419','SMC',NULL,'2010MNRAS.403.1156R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11302,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11302,18.88,0.05,0.0597,2163,NULL,NULL,'Tile 4_3  7, RA010.767647, DEC-73.123215','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11303,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11303,18.88,0.04,0.0597,2163,NULL,NULL,'Tile 4_3 11, RA010.809190, DEC-72.735680','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11304,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11304,18.89,0.06,0.06,2163,NULL,NULL,'Tile 4_5  4, RA019.597826, DEC-73.396495','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11305,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11305,18.89,0.07,0.06,2163,NULL,NULL,'Tile 4_5 12, RA019.272713, DEC-72.612501','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11306,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11306,18.89,0.03,0.06,2163,NULL,NULL,'Tile 5_4  8, RA014.405715, DEC-72.044707','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11307,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11307,18.89,0.04,0.06,2163,NULL,NULL,'Tile 5_4 10, RA016.651054, DEC-71.613224','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11308,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11308,18.89,0.07,0.06,2163,NULL,NULL,'Tile 6_3  5, RA013.174638, DEC-70.953770','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11309,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11309,18.89,NULL,0.06,2163,NULL,NULL,'SFH10 Intermediate, Cole','SMC',NULL,'2013ApJ...775...83C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11310,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11310,18.9,0.08,0.0603,2163,NULL,NULL,'Tile 3_3  2, RA011.943306, DEC-74.611372','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11311,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11311,18.9,0.03,0.0603,2163,NULL,NULL,'Tile 4_3  9, RA013.221587, DEC-72.734693','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11312,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11312,18.9,0.05,0.0603,2163,NULL,NULL,'Tile 4_5  7, RA020.666249, DEC-72.957900','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11313,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11313,18.9,0.05,0.0603,2163,NULL,NULL,'Tile 5_4  3, RA015.619562, DEC-72.412017','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11314,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11314,18.9,0.13,0.0603,2163,NULL,NULL,'Tile 5_4  9, RA017.771084, DEC-71.572367','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11315,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11315,18.9,0.1,0.0603,2163,NULL,NULL,'Tile 6_3  1, RA013.081099, DEC-71.361118','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11316,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11316,18.9,NULL,0.0603,2163,NULL,NULL,'SFH9 Wing, Cole','SMC',NULL,'2013ApJ...775...83C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11317,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11317,18.9,NULL,0.0603,2163,NULL,NULL,'ZAMS corrected','SMC',NULL,'1987AJ.....93.1070G',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11318,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11318,18.91,0.02,0.0605,2163,NULL,NULL,'Stellar density center, mean of 108 tiles','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11319,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11319,18.91,0.06,0.0605,2163,NULL,NULL,'Tile 4_3  8, RA009.539898, DEC-73.109714','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11320,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11320,18.91,0.04,0.0605,2163,NULL,NULL,'Tile 4_3 12, RA009.628528, DEC-72.728090','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11321,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11321,18.91,0.06,0.0605,2163,NULL,NULL,'Tile 4_5  8, RA019.433232, DEC-73.008586','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11322,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11322,18.91,0.06,0.0605,2163,NULL,NULL,'Tile 5_4  2, RA016.806137, DEC-72.392310','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11323,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11323,18.91,0.06,0.0605,2163,NULL,NULL,'Tile 5_4  5, RA017.864028, DEC-71.969133','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11324,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11324,18.91,0.04,0.0605,2163,NULL,NULL,'Tile 5_4 11, RA015.495351, DEC-71.631960','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11325,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11325,18.91,0.01,0.0605,2163,NULL,NULL,'Tile 5_4 12, RA014.375911, DEC-71.656536','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11326,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11326,18.92,0.1,0.0608,2163,NULL,NULL,'Tile 3_3  1, RA013.185297, DEC-74.594495','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11327,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11327,18.92,0.07,0.0608,2163,NULL,NULL,'Tile 4_3  3, RA010.720862, DEC-73.507790','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11328,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11328,18.92,0.05,0.0608,2163,NULL,NULL,'Tile 5_4  1, RA017.873969, DEC-72.356499','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11329,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11329,18.92,NULL,0.0608,2163,NULL,NULL,'Tile 5_4  7, RA015.563779, DEC-72.027492','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11330,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11330,18.93,0.08,0.0611,2163,NULL,NULL,'Tile 3_3  5, RA013.273205, DEC-74.204506','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11331,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11331,18.93,0.03,0.0611,2163,NULL,NULL,'Tile 5_4  6, RA016.703007, DEC-72.000185','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11332,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11332,18.93,0.1,0.0611,2163,NULL,NULL,'Tile 6_3  2, RA012.052363, DEC-71.366913','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11333,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11333,18.93,0.1,0.0611,2163,NULL,NULL,'Tile 6_3 10, RA012.064534, DEC-70.551182','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11334,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11334,18.93,0.09,0.0611,2163,NULL,NULL,'Tile 6_3 12, RA009.880499, DEC-70.526370','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11335,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11335,18.94,0.03,0.0614,2163,NULL,NULL,'Tile 3_3  9, RA013.250201, DEC-73.808250','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11336,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11336,18.94,0.04,0.0614,2163,NULL,NULL,'Tile 5_4  4, RA014.429708, DEC-72.424926','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11337,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11337,18.94,0.11,0.0614,2163,NULL,NULL,'Tile 6_3  8, RA009.826908, DEC-70.930352','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11338,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11338,18.94,0.09,0.0614,2163,NULL,NULL,'Tile 6_3  9, RA013.147395, DEC-70.549561','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11339,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11339,18.94,0.11,0.0614,2163,NULL,NULL,'Tile 6_3 11, RA010.973343, DEC-70.542530','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11340,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11340,18.95,0.05,0.0617,2163,NULL,NULL,'Tile 3_3 10, RA011.967426, DEC-73.810465','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11341,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11341,18.95,0.05,0.0617,2163,NULL,NULL,'Tile 6_3  6, RA012.056397, DEC-70.954615','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11342,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11342,18.95,0.1,0.0617,2163,NULL,NULL,'Tile 6_3  7, RA010.950131, DEC-70.946479','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11343,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11343,18.95,NULL,0.0617,2163,NULL,NULL,'SFH5 Central, Cole','SMC',NULL,'2013ApJ...775...83C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11344,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11344,18.95,NULL,0.0617,2163,NULL,NULL,'BS196','SMC',NULL,'2008MNRAS.391..915B',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11345,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11345,18.96,0.04,0.0619,2163,NULL,NULL,'NGC 0121','SMC',NULL,'2001ApJ...562..303D',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11346,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11346,18.96,NULL,0.0619,2163,NULL,NULL,'SFH8 Outer, Cole','SMC',NULL,'2013ApJ...775...83C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11347,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11347,18.96,0.14,0.0619,2163,NULL,NULL,'Tile 3_3 11, RA010.665122, DEC-73.802945','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11348,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11348,18.96,0.04,0.0619,2163,NULL,NULL,'Tile 4_3  4, RA009.465903, DEC-73.498637','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11349,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11349,18.96,0.08,0.0619,2163,NULL,NULL,'Tile 6_3  3, RA010.919945, DEC-71.358284','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11350,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11350,18.96,0.06,0.0619,2163,NULL,NULL,'Tile 6_3  4, RA009.776129, DEC-71.340049','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11351,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11351,18.97,0.1,0.0622,2163,NULL,NULL,'Tile 3_3  3, RA010.590622, DEC-74.600805','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11352,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11352,18.98,0.07,0.0625,2163,NULL,NULL,'Tile 3_3  6, RA011.954947, DEC-74.205454','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11353,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,'R',11353,18.99,0.1,0.0628,2163,NULL,NULL,'Lindsay 2','SMC',NULL,'2008arXiv0809.3775D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11354,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11354,18.99,0.16,0.0628,2163,NULL,NULL,'AM3 ','SMC',NULL,'2014A&A...561A.106D',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11355,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11355,18.99,0.04,0.0628,2163,NULL,NULL,'Tile 3_3 12, RA009.389756, DEC-73.790691','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11356,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11356,19,NULL,0.0631,2163,NULL,NULL,'IC 1624; 2MASX J01052189-7202333','SMC',NULL,'2014MNRAS.442.1897R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11357,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11357,19,0.05,0.0631,2163,NULL,NULL,'Tile 3_3  7, RA010.630308, DEC-74.197461','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11358,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11358,19,0.07,0.0631,2163,NULL,NULL,'Tile 3_3  8, RA009.307125, DEC-74.180693','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11359,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11359,19.02,0.08,0.0637,2163,NULL,NULL,'Tile 3_3  4, RA009.231355, DEC-74.586947','SMC',NULL,'2015MNRAS.449..639R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11360,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11360,19.08,0.14,0.0655,2163,NULL,NULL,'HW 40','SMC',NULL,'2014A&A...561A.106D',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11361,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11361,19.1,0.1,0.0661,2163,NULL,NULL,'SMC halo','SMC',NULL,'2013ApJ...763..110K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11362,'Delta Scuti','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11362,18.89,0.07,0.06,2163,NULL,NULL,'Z','SMC',NULL,'2011AJ....142..110M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11363,'Delta Scuti','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11363,18.99,0.07,0.0628,2163,NULL,NULL,NULL,'SMC',NULL,'2011AJ....142..110M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11364,'FGLR','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11364,19,NULL,0.0631,2163,NULL,NULL,NULL,'SMC',NULL,'2008ApJ...681..269K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11365,'Horizontal Branch','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11365,18.5,NULL,0.0501,2163,NULL,NULL,NULL,'SMC',NULL,'1991PASAu...9...80G',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11366,'Horizontal Branch','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11366,18.73,NULL,0.0557,2163,NULL,NULL,'4.5 kpc NE','SMC',NULL,'1991PASAu...9...80G',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11367,'Horizontal Branch','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11367,18.75,0.03,0.0562,2163,NULL,NULL,'Filed 51, western regions','SMC',NULL,'1991MNRAS.251..174G',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11368,'Horizontal Branch','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11368,18.76,0.04,0.0565,2163,NULL,NULL,'2 kpc NE','SMC',NULL,'1991PASAu...9...80G',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11369,'Horizontal Branch','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11369,18.82,0.05,0.0581,2163,NULL,NULL,'Field 50','SMC',NULL,'1991MNRAS.251..174G',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11370,'Horizontal Branch','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11370,19.04,0.05,0.0643,2163,NULL,NULL,'Field 51, all','SMC',NULL,'1991MNRAS.251..174G',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11371,'M Stars','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11371,18.95,0.02,0.0617,2163,NULL,18.46,NULL,'SMC',NULL,'2010MNRAS.409..777T',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11372,'M Stars','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11372,19.03,NULL,0.064,2163,NULL,NULL,NULL,'SMC',NULL,'2010ApJ...722..750S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11373,'Miras','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11373,18.59,NULL,0.0522,2163,NULL,NULL,'SMC-LMC = 0.38 mag','SMC',NULL,'2005A&A...443..143G',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11374,'Miras','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,'R',11374,18.78,NULL,0.057,2163,NULL,NULL,'SMC-LMC 0.30 mag','SMC',NULL,'1988ASPC....4....9F',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11375,'OB Stars','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11375,19.1,0.1,0.0661,2163,NULL,NULL,'ZAMS','SMC',NULL,'1987AJ.....93.1070G',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11376,'OB Stars','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11376,19.1,0.3,0.0661,2163,NULL,NULL,'Photographic','SMC',NULL,'1982PASP...94...31C',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11377,'PNLF','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11377,18.72,0.15,0.0555,2163,NULL,NULL,NULL,'SMC',NULL,'1992ApJ...389...27D',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11378,'PNLF','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,'R',11378,18.78,NULL,0.057,2163,NULL,NULL,'PNLF(CKS)','SMC',NULL,'1995A&AT....6..213A',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11379,'PNLF','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11379,18.8,0.3,0.0575,2163,NULL,NULL,NULL,'SMC',NULL,'2008ApJ...689..194S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11380,'PNLF','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11380,18.8,0.7,0.058,2163,NULL,NULL,NULL,'SMC',NULL,'1992A&AS...94..399C',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11381,'PNLF','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,'R',11381,18.89,0.6,0.06,2163,NULL,NULL,'PNLF(AGR)','SMC',NULL,'1995A&AT....6..213A',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11382,'PNLF','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11382,19.09,0.29,0.066,2163,NULL,NULL,NULL,'SMC',NULL,'1990ApJ...365..471J',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11383,'PNLF','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,'R',11383,19.15,0.29,0.0676,2163,NULL,NULL,'9','SMC',NULL,'1999ASSL..237..125W',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11384,'PNLF','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11384,19.29,0.31,0.0721,2163,NULL,NULL,'HST KP Calibrated','SMC',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11385,'PNLF','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11385,19.4,0.32,0.076,2163,NULL,NULL,NULL,'SMC',NULL,'1990ApJ...365..471J',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11386,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11386,18.28,0.08,0.0452,2163,NULL,NULL,'Kron 28, M(V)RC = 0.56 +/- 0.04 mag, reddening of SFD98','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11387,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11387,18.42,0.07,0.0484,2163,NULL,NULL,'Lindsay 113, M(V)RC = 0.57 +/- 0.07 mag, reddening of SFD98','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11388,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11388,18.43,0.16,0.0485,2163,NULL,NULL,'NGC 0411, M(V)RC = 0.63 +/- 0.16 mag, reddening of SFD98','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11389,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11389,18.43,0.05,0.0486,2163,NULL,NULL,'Lindsay 113, M(V)RC = 0.56 +/- 0.04 mag, reddening of SFD98','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11390,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:42','1',NULL,NULL,11390,18.49,0.07,0.0498,2163,NULL,NULL,'NGC 0361, M(V)RC = 0.64 +/- 0.04 mag, reddening of SFD98','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11391,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11391,18.5,0.07,0.0501,2163,NULL,NULL,'NGC 0411, M(V)RC = 0.56 +/- 0.04 mag, reddening of SFD98','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11392,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11392,18.52,0.07,0.0505,2163,NULL,NULL,'Lindsay 113, M(V)RC = 0.57 +/- 0.07 mag, reddening of BH82','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11393,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11393,18.53,0.05,0.0508,2163,NULL,NULL,'Lindsay 113, M(V)RC = 0.56 +/- 0.04 mag, reddening of BH82','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11394,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11394,18.56,0.03,0.0515,2163,NULL,NULL,NULL,'SMC',NULL,'1998AcA....48....1U',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11395,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11395,18.57,0.04,0.0517,2163,NULL,NULL,'Lindsay 1, M(V)RC = 0.68 +/- 0.03 mag, reddening of SFD98','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11396,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11396,18.57,0.07,0.0517,2163,NULL,NULL,'NGC 0361, M(V)RC = 0.56 +/- 0.04 mag, reddening of SFD98','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11397,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11397,18.58,0.07,0.0521,2163,NULL,NULL,'Kron 28, M(V)RC = 0.56 +/- 0.04 mag, reddening of BH82','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11398,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11398,18.63,0.07,0.0532,2163,NULL,NULL,NULL,'SMC',NULL,'1998AcA....48..113U',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11399,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11399,18.63,0.04,0.0532,2163,NULL,NULL,'Lindsay 1, M(V)RC = 0.68 +/- 0.03 mag, reddening of BH82','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11400,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11400,18.65,0.08,0.0537,2163,NULL,NULL,NULL,'SMC',NULL,'1998AcA....48..383U',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11401,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11401,18.69,0.05,0.0546,2163,NULL,NULL,'Lindsay 1, M(V)RC = 0.56 +/- 0.04 mag, reddening of SFD98','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11402,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11402,18.69,0.09,0.0547,2163,NULL,18.22,'LMC ZP','SMC',NULL,'1999AcA....49..201U',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11403,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11403,18.69,0.13,0.0548,2163,NULL,NULL,'Kron 28, M(V)RC = 0.27 +/- 0.12 mag, reddening of SFD98','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11404,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11404,18.7,NULL,0.055,2163,NULL,NULL,'I, M TRGB(I) = -4.05 mag','SMC',NULL,'1987ApJ...313..192S',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11405,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11405,18.71,0.07,0.055,2163,NULL,NULL,NULL,'SMC',NULL,'2000AcA....50..279U',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11406,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11406,18.71,0.16,0.0551,2163,NULL,NULL,'NGC 0411, M(V)RC = 0.63 +/- 0.16 mag, reddening of BH82','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11407,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11407,18.71,0.06,0.0552,2163,NULL,NULL,'Minimum mean D','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11408,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11408,18.73,0.23,0.0557,2163,NULL,NULL,'Z','SMC',NULL,'1998ApJ...500L.137C',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11409,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11409,18.73,0.07,0.0558,2163,NULL,NULL,'NGC 0361, M(V)RC = 0.64 +/- 0.04 mag, reddening of BH82','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11410,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11410,18.73,0.08,0.0558,2163,NULL,NULL,'NGC 0339, M(V)RC = 0.57 +/- 0.06 mag, reddening of SFD98','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11411,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11411,18.74,0.07,0.0559,2163,NULL,NULL,'Kron 3, M(V)RC = 0.62 +/- 0.05 mag, reddening of SFD98','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11412,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11412,18.74,0.06,0.0561,2163,NULL,NULL,'NGC 0339, M(V)RC = 0.56 +/- 0.04 mag, reddening of SFD98','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11413,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11413,18.75,0.04,0.0562,2163,NULL,NULL,'Lindsay 1, M(V)RC = 0.56 +/- 0.04 mag, reddening of BH82','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11414,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11414,18.77,0.07,0.0567,2163,NULL,NULL,'Kron 3, M(V)RC = 0.62 +/- 0.05 mag, reddening of BH82','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11415,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11415,18.77,0.08,0.0567,2163,NULL,NULL,'NGC 0416, M(V)RC = 0.60 +/- 0.05 mag, reddening of SFD98','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11416,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11416,18.77,0.08,0.0568,2163,NULL,NULL,NULL,'SMC',NULL,'2000ApJ...528L...9P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11417,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11417,18.78,0.04,0.0569,2163,NULL,NULL,'ESO 028-SC 008, Lindsay 1','SMC',NULL,'2008AJ....136.1703G',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11418,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11418,18.78,0.06,0.0569,2163,NULL,NULL,'NGC 0411, M(V)RC = 0.56 +/- 0.04 mag, reddening of BH82','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11419,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11419,18.8,NULL,0.0575,2163,NULL,NULL,'NGC 0411','SMC',NULL,'1987ApJ...313..192S',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11420,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11420,18.8,NULL,0.0575,2163,NULL,NULL,'Lindsay 113','SMC',NULL,'1987ApJ...313..192S',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11421,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11421,18.8,NULL,0.0575,2163,NULL,NULL,'Kron 3','SMC',NULL,'1987ApJ...313..192S',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11422,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11422,18.8,NULL,0.0575,2163,NULL,NULL,'NGC 0121','SMC',NULL,'1987ApJ...313..192S',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11423,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11423,18.8,0.08,0.0575,2163,NULL,NULL,'NGC 0339, M(V)RC = 0.57 +/- 0.06 mag, reddening of BH82','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11424,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11424,18.8,0.06,0.0575,2163,NULL,NULL,'Kron 3, M(V)RC = 0.56 +/- 0.04 mag, reddening of SFD98','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11425,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11425,18.8,0.08,0.0576,2163,NULL,NULL,'NGC 0339','SMC',NULL,'2008AJ....136.1703G',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11426,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11426,18.81,0.06,0.0577,2163,NULL,NULL,'NGC 0339, M(V)RC = 0.56 +/- 0.04 mag, reddening of BH82','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11427,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11427,18.81,0.07,0.0577,2163,NULL,NULL,'Kron 44, M(V)RC = 0.56 +/- 0.04 mag, reddening of SFD98','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11428,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11428,18.81,0.07,0.0578,2163,NULL,NULL,'NGC 0416, M(V)RC = 0.56 +/- 0.04 mag, reddening of SFD98','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11429,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11429,18.81,0.06,0.0579,2163,NULL,NULL,'NGC 0361, M(V)RC = 0.56 +/- 0.04 mag, reddening of BH82','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11430,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11430,18.82,0.05,0.0581,2163,NULL,NULL,'Maximum mean D','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11431,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11431,18.82,0.07,0.0581,2163,NULL,NULL,NULL,'SMC',NULL,'1998ApJ...500L.137C',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11432,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11432,18.83,0.06,0.0583,2163,NULL,NULL,'Kron 3, M(V)RC = 0.56 +/- 0.04 mag, reddening of BH82','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11433,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11433,18.85,0.06,0.0589,2163,NULL,NULL,NULL,'SMC',NULL,'2001MNRAS.323..109G',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11434,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11434,18.85,0.06,0.059,2163,NULL,NULL,NULL,'SMC',NULL,'2003AJ....125.1261D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11435,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11435,18.85,0.07,0.059,2163,NULL,NULL,'NGC 0152, M(V)RC = 0.56 +/- 0.04 mag, reddening of SFD98','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11436,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11436,18.87,0.13,0.0595,2163,NULL,NULL,'Kron 28, M(V)RC = 0.27 +/- 0.12 mag, reddening of BH82','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11437,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11437,18.88,0.06,0.0596,2163,NULL,NULL,'NGC 0121, M(V)RC = 0.73 +/- 0.04 mag, reddening of BH82','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11438,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11438,18.88,0.09,0.0596,2163,NULL,NULL,'Kron 44, M(V)RC = 0.49 +/- 0.08 mag, reddening of SFD98','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11439,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11439,18.9,0.06,0.0602,2163,NULL,NULL,'Kron 44, M(V)RC = 0.56 +/- 0.04 mag, reddening of BH82','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11440,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11440,18.9,NULL,0.0603,2163,NULL,NULL,NULL,'SMC',NULL,'2009AJ....137.3668C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11441,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11441,18.9,0.07,0.0604,2163,NULL,NULL,'NGC 0416','SMC',NULL,'2008AJ....136.1703G',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11442,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11442,18.91,0.06,0.0605,2163,NULL,NULL,'NGC 0121, M(V)RC = 0.73 +/- 0.04 mag, reddening of SFD98','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11443,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11443,18.91,0.18,0.0605,2163,NULL,NULL,NULL,'SMC',NULL,'1999AJ....117.1816T',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11444,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11444,18.91,0.04,0.0606,2163,NULL,NULL,'Kron 3','SMC',NULL,'2008AJ....136.1703G',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11445,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11445,18.92,0.07,0.0607,2163,NULL,NULL,'NGC 0152, M(V)RC = 0.56 +/- 0.04 mag, reddening of BH82','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11446,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11446,18.93,0.19,0.061,2163,NULL,NULL,'NGC 0152, M(V)RC = 0.49 +/- 0.19 mag, reddening of SFD98','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11447,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11447,18.94,0.07,0.0613,2163,NULL,NULL,'Lindsay 38, M(V)RC = 0.56 +/- 0.04 mag, reddening of BH82','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11448,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11448,18.94,0.06,0.0613,2163,NULL,NULL,'Lindsay 38, M(V)RC = 0.56 +/- 0.04 mag, reddening of SFD98','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11449,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11449,18.97,0.02,0.0621,2163,NULL,NULL,NULL,'SMC',NULL,'2003AJ....125.2494P',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11450,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11450,18.97,0.02,0.0621,2163,NULL,NULL,'K','SMC',NULL,'2003AJ....125.2494P',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11451,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11451,18.97,0.09,0.0622,2163,NULL,NULL,'Kron 44, M(V)RC = 0.49 +/- 0.08 mag, reddening of BH82','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11452,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11452,18.99,0.19,0.0627,2163,NULL,NULL,'NGC 0152, M(V)RC = 0.49 +/- 0.19 mag, reddening of BH82','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11453,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11453,18.99,0.06,0.0627,2163,NULL,NULL,'Lindsay 38, M(V)RC = 0.51 +/- 0.03 mag, reddening of BH82','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11454,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11454,18.99,0.06,0.0627,2163,NULL,NULL,'Lindsay 38, M(V)RC = 0.51 +/- 0.03 mag, reddening of SFD98','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11455,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11455,19.01,0.18,0.0634,2163,NULL,NULL,NULL,'SMC',NULL,'1999AJ....117.1816T',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11456,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11456,19.02,0.07,0.0636,2163,NULL,NULL,'NGC 0416, M(V)RC = 0.60 +/- 0.05 mag, reddening of BH82','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11457,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11457,19.04,0.06,0.0644,2163,NULL,NULL,'NGC 0121, M(V)RC = 0.56 +/- 0.04 mag, reddening of BH82','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11458,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11458,19.05,0.06,0.0647,2163,NULL,NULL,'NGC 0416, M(V)RC = 0.56 +/- 0.04 mag, reddening of BH82','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11459,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11459,19.06,0.03,0.0649,2163,NULL,NULL,'NGC 0121','SMC',NULL,'2008AJ....136.1703G',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11460,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11460,19.08,0.06,0.0654,2163,NULL,NULL,'NGC 0121, M(V)RC = 0.56 +/- 0.04 mag, reddening of SFD98','SMC',NULL,'2001AJ....122..220C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11461,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11461,19.12,0.05,0.0667,2163,NULL,NULL,'ESO 051-SC 003, Lindsay 38','SMC',NULL,'2008AJ....136.1703G',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11462,'RV Stars','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11462,18.91,0.05,0.0605,2163,NULL,18.46,'3200, I','SMC',NULL,'2004MNRAS.347L..83K',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11463,'RV Stars','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11463,18.92,0.05,0.0608,2163,NULL,18.46,'3200, J','SMC',NULL,'2004MNRAS.347L..83K',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11464,'RV Stars','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11464,18.94,0.05,0.0614,2163,NULL,18.46,'3200, IJHK(S)','SMC',NULL,'2004MNRAS.347L..83K',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11465,'RV Stars','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11465,18.95,0.05,0.0617,2163,NULL,18.46,'3200, H','SMC',NULL,'2004MNRAS.347L..83K',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11466,'RV Stars','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11466,18.96,0.05,0.0619,2163,NULL,18.46,'3200, K(S)','SMC',NULL,'2004MNRAS.347L..83K',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11467,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11467,18.6,0.2,0.0525,2163,NULL,NULL,'K','SMC',NULL,'1991ASPC...14..115C',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11468,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11468,18.66,0.05,0.054,2163,NULL,18.19,NULL,'SMC',NULL,'1992MmSAI..63..409C',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11469,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11469,18.66,0.16,0.054,2163,NULL,NULL,NULL,'SMC',NULL,'1998AcA....48..113U',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11470,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11470,18.72,0.09,0.0555,2163,NULL,NULL,'V, Ks','SMC',NULL,'2013MNRAS.435.3206D',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11471,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11471,18.73,0.08,0.0557,2163,NULL,18.22,'LMC ZP','SMC',NULL,'1999AcA....49..201U',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11472,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11472,18.76,0.06,0.0565,2163,NULL,18.43,NULL,'SMC',NULL,'2011rrls.conf..170F',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11473,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11473,18.76,0.07,0.057,2163,NULL,NULL,'V','SMC',NULL,'2000AcA....50..279U',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11474,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11474,18.78,0.15,0.057,2163,NULL,NULL,NULL,'SMC',NULL,'1986MNRAS.221..887R',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11475,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11475,18.79,0.06,0.0573,2163,NULL,18.43,'Z corr. = +0.03 mag','SMC',NULL,'2011rrls.conf..170F',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11476,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11476,18.8,0.16,0.0575,2163,NULL,NULL,NULL,'SMC',NULL,'1983ApJ...274...20S',1983,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11477,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11477,18.82,NULL,0.0581,2163,NULL,NULL,'Z','SMC',NULL,'1988ASPC....4....9F',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11478,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11478,18.83,0.01,0.0583,2163,NULL,NULL,'335 RRab, mean intensity','SMC',NULL,'2010MNRAS.402..691D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11479,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11479,18.84,0.01,0.0586,2163,NULL,NULL,'335 RRab, mean phase','SMC',NULL,'2010MNRAS.402..691D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11480,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11480,18.85,0.2,0.0589,2163,NULL,NULL,NULL,'SMC',NULL,'1989A&A...209..154C',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11481,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11481,18.85,NULL,0.0589,2163,NULL,NULL,'NGC 0121','SMC',NULL,'1985ApJ...298..544S',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11482,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11482,18.86,0.07,0.059,2163,NULL,NULL,NULL,'SMC',NULL,'2003AJ....125.1261D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11483,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11483,18.86,0.07,0.0592,2163,NULL,NULL,'NGC 0121','SMC',NULL,'1988AJ.....96..872W',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11484,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11484,18.86,NULL,0.0592,2163,NULL,NULL,NULL,'SMC',NULL,'1988ASPC....4....9F',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11485,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11485,18.86,0.01,0.0592,2163,NULL,NULL,'335 RRab, mean mag','SMC',NULL,'2010MNRAS.402..691D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11486,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11486,18.87,0.03,0.0594,2163,NULL,NULL,'352, mean intensity','SMC',NULL,'2010MNRAS.402..691D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11487,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11487,18.87,0.02,0.0594,2163,NULL,NULL,'352, mean phase','SMC',NULL,'2010MNRAS.402..691D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11488,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11488,18.89,0.01,0.06,2163,NULL,NULL,'352, mean mag','SMC',NULL,'2010MNRAS.402..691D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11489,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11489,18.89,0.04,0.06,2163,NULL,NULL,'17 RRc, mean intensity','SMC',NULL,'2010MNRAS.402..691D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11490,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11490,18.89,0.04,0.06,2163,NULL,NULL,'17 RRc, mean phase','SMC',NULL,'2010MNRAS.402..691D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11491,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11491,18.9,0.16,0.0603,2163,NULL,NULL,'NGC 0361, 22','SMC',NULL,'1992AJ....104.1430S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11492,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11492,18.91,0.08,0.0605,2163,NULL,18.44,NULL,'SMC',NULL,'2010JAVSO..38..100M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11493,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11493,18.92,0.04,0.0608,2163,NULL,NULL,'17 RRc. Mean mag','SMC',NULL,'2010MNRAS.402..691D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11494,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11494,18.93,0.24,0.061,2163,NULL,NULL,'45','SMC',NULL,'2004AJ....128..736W',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11495,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11495,18.94,0.11,0.0615,2163,NULL,NULL,'1494, V, individual dereddening','SMC',NULL,'2012AJ....144..107H',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11496,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11496,18.95,0.18,0.0615,2163,NULL,NULL,'34, J, Catelan et al. (2004)','SMC',NULL,'2009AJ....138.1661S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11497,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11497,18.97,0.16,0.0621,2163,NULL,NULL,'34, K, Sollima et al. (2008)','SMC',NULL,'2009AJ....138.1661S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11498,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11498,18.97,0.16,0.0621,2163,NULL,NULL,'34, K, Catelan et al. (2004)','SMC',NULL,'2009AJ....138.1661S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11499,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11499,18.97,0.03,0.0622,2163,NULL,NULL,'34','SMC',NULL,'2009AJ....138.1661S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11500,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11500,18.98,NULL,0.0625,2163,NULL,NULL,NULL,'SMC',NULL,'2008ApJ...679...52T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11501,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11501,19,0.17,0.0632,2163,NULL,NULL,'34, K, Bono et al. (2003)','SMC',NULL,'2009AJ....138.1661S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11502,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11502,19.04,0.07,0.0643,2163,NULL,NULL,'RR Lyrae c','SMC',NULL,'2011AJ....142..110M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11503,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11503,19.05,0.07,0.0646,2163,NULL,NULL,'RR Lyrae ab','SMC',NULL,'2011AJ....142..110M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11504,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11504,19.13,0.13,0.0668,2163,NULL,NULL,'1494, V, area-averaged dereddening','SMC',NULL,'2012AJ....144..107H',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11505,'RR Lyrae','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11505,19.13,0.19,0.067,2163,NULL,18.52,'454','SMC',NULL,'2012MNRAS.426.2063K',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11506,'TRGB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11506,18.74,0.08,0.056,2163,NULL,NULL,NULL,'SMC',NULL,'2000AcA....50..279U',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11507,'TRGB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11507,18.75,0.09,0.0562,2163,NULL,NULL,NULL,'SMC',NULL,'2008ApJ...688L..69S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11508,'TRGB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11508,18.88,0.04,0.06,2163,NULL,NULL,NULL,'SMC',NULL,'2003AJ....125.1261D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11509,'TRGB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11509,18.9,0.06,0.06,2163,74.4,NULL,NULL,'SMC',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11510,'TRGB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11510,18.99,0.08,0.063,2163,NULL,NULL,NULL,'SMC',NULL,'2000A&A...359..601C',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11511,'TRGB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11511,18.99,0.08,0.063,2163,NULL,NULL,NULL,'SMC',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11512,'Type II Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11512,18.85,0.11,0.0589,2163,NULL,18.45,'LMC ZP','SMC',NULL,'2009AcA....59..403M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11513,'Type II Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11513,18.85,0.07,0.0589,2163,NULL,18.45,'Ks','SMC',NULL,'2010AcA....60..233C',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11514,'Type II Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11514,18.85,0.09,0.0589,2163,NULL,18.45,'J','SMC',NULL,'2010AcA....60..233C',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11515,'Type II Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11515,18.85,0.05,0.0589,2163,NULL,18.46,'I or W(VI)','SMC',NULL,'2011MNRAS.413..223M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11516,'Type II Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11516,18.86,0.07,0.0592,2163,NULL,18.46,'NIR, Ks or K','SMC',NULL,'2011MNRAS.413..223M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11517,'Statistical','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11517,18.89,NULL,0.0598,2163,NULL,NULL,'33 estimates','SMC',NULL,'2014arXiv1410.7843C',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11518,'Statistical','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11518,18.93,0.01,0.0611,2163,NULL,NULL,NULL,'SMC',NULL,'2013ApJ...772..130M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11519,'Statistical','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11519,18.96,0.02,0.0619,2163,NULL,NULL,'Weighted mean of 304 estimates','SMC',NULL,'2015AJ....149..179D',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11520,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11520,18.29,NULL,0.0455,2163,NULL,NULL,'EB 10 110440','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11521,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11521,18.35,0.08,0.0468,2163,NULL,NULL,'EB 4 163552, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11522,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11522,18.36,0.08,0.047,2163,NULL,NULL,'EB 4 163552, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11523,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11523,18.4,NULL,0.0479,2163,NULL,NULL,'EB 04 110409','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11524,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11524,18.49,NULL,0.0499,2163,NULL,NULL,'EB 04 163552','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11525,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11525,18.52,0.06,0.0506,2163,NULL,NULL,'EB 4 175149, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11526,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11526,18.52,0.06,0.0506,2163,NULL,NULL,'EB 5 277080, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11527,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11527,18.52,NULL,0.0506,2163,NULL,NULL,'EB 05 300549','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11528,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11528,18.52,NULL,0.0506,2163,NULL,NULL,'EB 06 311225','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11529,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11529,18.54,0.05,0.0511,2163,NULL,NULL,'EB 4 175149, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11530,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11530,18.54,NULL,0.0511,2163,NULL,NULL,'EB 05 255984','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11531,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11531,18.6,0.5,0.0525,2163,NULL,NULL,NULL,'SMC',NULL,'1998MNRAS.297..278P',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11532,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11532,18.6,0.07,0.0525,2163,NULL,NULL,'EB 4 175333, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11533,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11533,18.61,0.07,0.0527,2163,NULL,NULL,'EB 4 175333, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11534,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11534,18.62,NULL,0.053,2163,NULL,NULL,'EB 05 140701','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11535,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11535,18.62,NULL,0.053,2163,NULL,NULL,'EB 08 209964','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11536,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11536,18.62,0.22,0.053,2163,NULL,NULL,'Method II','SMC',NULL,'1974AcC.....2...13D',1974,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11537,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11537,18.64,0.27,0.0535,2163,NULL,NULL,'HV 02226','SMC',NULL,'1991MNRAS.250..119B',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11538,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11538,18.64,NULL,0.0535,2163,NULL,NULL,'EB 06 152981','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11539,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11539,18.64,NULL,0.0535,2163,NULL,NULL,'EB 10 094559','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11540,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11540,18.65,NULL,0.0537,2163,NULL,NULL,'EB 04 103706','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11541,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11541,18.66,NULL,0.054,2163,NULL,NULL,'EB 04 056804','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11542,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11542,18.66,NULL,0.054,2163,NULL,NULL,'EB 05 311566','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11543,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11543,18.66,0.02,0.054,2163,NULL,NULL,'OGLE 6-215965, primary','SMC',NULL,'2010ASPC..435..381D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11544,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11544,18.67,0.04,0.054,2163,NULL,NULL,'OGLE 6-215965, primary + secondary','SMC',NULL,'2010ASPC..435..381D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11545,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11545,18.67,0.07,0.0541,2163,NULL,NULL,'OGLE 6-215965, secondary','SMC',NULL,'2010ASPC..435..381D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11546,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11546,18.69,NULL,0.0547,2163,NULL,NULL,'EB 06 251047','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11547,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11547,18.71,0.05,0.0552,2163,NULL,NULL,'EB 5 277080, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11548,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11548,18.71,NULL,0.0552,2163,NULL,NULL,'EB 11 030116','SMC',NULL,'2003MNRAS.339..157H',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11549,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11549,18.72,NULL,0.0555,2163,NULL,NULL,'EB 07 120044','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11550,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11550,18.73,NULL,0.0557,2163,NULL,NULL,'EB 06 077224','SMC',NULL,'2003MNRAS.339..157H',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11551,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11551,18.75,0.08,0.0562,2163,NULL,NULL,'EB 5 123390, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11552,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11552,18.75,NULL,0.0562,2163,NULL,NULL,'EB 09 064498','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11553,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11553,18.76,0.07,0.0565,2163,NULL,NULL,'EB 5 123390, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11554,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11554,18.76,NULL,0.0565,2163,NULL,NULL,'EB 10 108086','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11555,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11555,18.77,NULL,0.0568,2163,NULL,NULL,'EB 07 066175','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11556,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11556,18.77,NULL,0.0568,2163,NULL,NULL,'EB 06 158118','SMC',NULL,'2003MNRAS.339..157H',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11557,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11557,18.78,0.15,0.057,2163,NULL,NULL,'HV 02226','SMC',NULL,'1996ASPC...90..196G',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11558,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11558,18.78,NULL,0.057,2163,NULL,NULL,'EB 06 180084','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11559,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11559,18.79,0.03,0.0572,2163,NULL,NULL,'OGLE 5-38089, primary','SMC',NULL,'2010ASPC..435..381D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11560,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11560,18.79,NULL,0.0573,2163,NULL,NULL,'EB 05 026631','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11561,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11561,18.8,0.02,0.0575,2163,NULL,NULL,'OGLE 5-38089, primary + secondary','SMC',NULL,'2010ASPC..435..381D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11562,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11562,18.81,0.03,0.0577,2163,NULL,NULL,'OGLE 5-38089, secondary','SMC',NULL,'2010ASPC..435..381D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11563,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11563,18.82,NULL,0.0581,2163,NULL,NULL,'EB 07 142073','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11564,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11564,18.83,0.03,0.0583,2163,NULL,NULL,'EB 5 038089, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11565,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11565,18.83,NULL,0.0583,2163,NULL,NULL,'EB 06 215965','SMC',NULL,'2003MNRAS.339..157H',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11566,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11566,18.83,0.02,0.0583,2163,NULL,NULL,'OGLE SMC113.3 4007 (SC10 137844), +/- 0.05 (syst.)','SMC',NULL,'2012ApJ...750..144G',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11567,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11567,18.84,0.05,0.0586,2163,NULL,NULL,'EB 5 100485, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11568,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11568,18.84,NULL,0.0586,2163,NULL,NULL,'EB 09 175323','SMC',NULL,'2003MNRAS.339..157H',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11569,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11569,18.85,0.1,0.0589,2163,NULL,NULL,'Method I','SMC',NULL,'1974AcC.....2...13D',1974,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11570,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11570,18.86,0.05,0.0592,2163,NULL,NULL,'EB 5 111649, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11571,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11571,18.86,NULL,0.0592,2163,NULL,NULL,'EB 05 305884','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11572,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11572,18.87,0.05,0.0594,2163,NULL,NULL,'EB 5 100485, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11573,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11573,18.87,0.02,0.0594,2163,NULL,NULL,'SMC center, +/- 0.05 (syst.)','SMC',NULL,'2012ApJ...750..144G',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11574,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11574,18.87,0.07,0.0594,2163,NULL,NULL,'OGLE 11-30116, secondary','SMC',NULL,'2010ASPC..435..381D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11575,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11575,18.87,0.07,0.0595,2163,NULL,NULL,'OGLE 9-175323, primary','SMC',NULL,'2010ASPC..435..381D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11576,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11576,18.88,0.04,0.0597,2163,NULL,NULL,'EB 5 111649, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11577,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11577,18.88,0.04,0.0597,2163,NULL,NULL,'OGLE 9-175323, primary + secondary','SMC',NULL,'2010ASPC..435..381D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11578,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11578,18.88,0.04,0.0597,2163,NULL,NULL,'OGLE 11-30116, primary + secondary','SMC',NULL,'2010ASPC..435..381D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11579,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11579,18.89,0.04,0.06,2163,NULL,NULL,'EB 5 038089, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11580,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11580,18.89,0.04,0.06,2163,NULL,NULL,'10 Eclipsing Binaries avg','SMC',NULL,'2003MNRAS.339..157H',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11581,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11581,18.89,0.04,0.06,2163,NULL,NULL,'OGLE 9-175323, secondary','SMC',NULL,'2010ASPC..435..381D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11582,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11582,18.89,0.05,0.06,2163,NULL,NULL,'OGLE 11-30116, primary','SMC',NULL,'2010ASPC..435..381D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11583,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11583,18.9,NULL,0.0603,2163,NULL,NULL,'EB 05 316725','SMC',NULL,'2003MNRAS.339..157H',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11584,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11584,18.91,0.04,0.0606,2163,NULL,NULL,'50 Eclipsing Binaries avg','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11585,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11585,18.92,NULL,0.0608,2163,NULL,NULL,'EB 05 038089','SMC',NULL,'2003MNRAS.339..157H',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11586,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11586,18.92,NULL,0.0608,2163,NULL,NULL,'EB 11 057855','SMC',NULL,'2003MNRAS.339..157H',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11587,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11587,18.92,NULL,0.0608,2163,NULL,NULL,'SMC108.1.14904 + SMC113.3.4007 avg., NE SMC','SMC',NULL,'2013IAUS..289..222G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11588,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11588,18.95,0.07,0.0617,2163,NULL,NULL,'Eclipsing Binary + other indicators','SMC',NULL,'2014ApJ...780...59G',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11589,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11589,18.95,0.05,0.0617,2163,NULL,NULL,'EB 5 106039, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11590,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11590,18.95,0.04,0.0617,2163,NULL,NULL,'EB 5 106039, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11591,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11591,18.95,NULL,0.0617,2163,NULL,NULL,'EB 05 277080','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11592,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11592,18.95,NULL,0.0617,2163,NULL,NULL,'EB 07 255621','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11593,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11593,18.96,0.1,0.0619,2163,NULL,NULL,'EB 4 160094, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11594,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11594,18.97,0.03,0.0621,2163,NULL,NULL,'5, Syst. +/- 0.048 mag','SMC',NULL,'2014ApJ...780...59G',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11595,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11595,18.97,0.06,0.0622,2163,NULL,NULL,'EB 4 117831, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11596,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11596,18.97,0.1,0.0622,2163,NULL,NULL,'EB 4 160094, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11597,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11597,18.99,0.06,0.0628,2163,NULL,NULL,'EB 4 117831, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11598,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11598,18.99,0.08,0.0628,2163,NULL,NULL,'EB 4 113853, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11599,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11599,18.99,0.05,0.0628,2163,NULL,NULL,'4','SMC',NULL,'2014ApJ...780...59G',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11600,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11600,19,0.08,0.0631,2163,NULL,NULL,'EB 4 113853, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11601,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11601,19.02,0.04,0.0637,2163,NULL,NULL,'SMC108.1.14904, +/- 0.05 mag syst., NE SMC','SMC',NULL,'2013IAUS..289..222G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11602,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11602,19.05,0.04,0.0645,2163,NULL,NULL,'33 Eclipsing Binaries avg','SMC',NULL,'2009IAUS..256...57N',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11603,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11603,19.05,0.08,0.0646,2163,NULL,NULL,'EB 4 121461, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11604,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11604,19.05,NULL,0.0646,2163,NULL,NULL,'EB 05 180064','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11605,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11605,19.05,NULL,0.0646,2163,NULL,NULL,'EB 06 319960','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11606,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11606,19.06,0.06,0.0649,2163,NULL,NULL,'EB 4 110409, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11607,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11607,19.06,0.06,0.0649,2163,NULL,NULL,'EB 4 110409, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11608,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11608,19.07,0.05,0.0652,2163,NULL,NULL,'EB 5 283079, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11609,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11609,19.08,0.06,0.0655,2163,NULL,NULL,'EB 4 121110, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11610,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11610,19.08,0.05,0.0655,2163,NULL,NULL,'EB 4 121110, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11611,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11611,19.08,0.03,0.0656,2163,NULL,NULL,'OGLE 7-143913, secondary','SMC',NULL,'2010ASPC..435..381D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11612,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11612,19.09,0.08,0.0658,2163,NULL,NULL,'EB 4 121461, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11613,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11613,19.09,NULL,0.0658,2163,NULL,NULL,'EB 06 221543','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11614,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11614,19.09,0.03,0.0659,2163,NULL,NULL,'33, SMC centre','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11615,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11615,19.1,NULL,0.0661,2163,NULL,NULL,'EB 08 087175','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11616,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11616,19.1,NULL,0.0661,2163,NULL,NULL,'EB 07 243913','SMC',NULL,'2003MNRAS.339..157H',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11617,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11617,19.11,0.02,0.0663,2163,NULL,NULL,'OGLE 7-143913, primary + secondary','SMC',NULL,'2010ASPC..435..381D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11618,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11618,19.11,0.08,0.0664,2163,NULL,NULL,'EB 5 266131, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11619,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11619,19.11,0.05,0.0664,2163,NULL,NULL,'EB 5 283079, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11620,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11620,19.11,0.11,0.0664,2163,NULL,NULL,'EB 5 266513, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11621,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11621,19.11,NULL,0.0664,2163,NULL,NULL,'EB 10 037156','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11622,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11622,19.11,0.03,0.0664,2163,NULL,NULL,'33','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11623,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11623,19.12,0.06,0.0667,2163,NULL,NULL,'EB 5 185408, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11624,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11624,19.12,0.08,0.0667,2163,NULL,NULL,'EB 5 266131, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11625,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11625,19.12,NULL,0.0667,2163,NULL,NULL,'EB 09 047454','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11626,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11626,19.13,0.07,0.067,2163,NULL,NULL,'EB 5 016658, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11627,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11627,19.13,0.04,0.067,2163,NULL,NULL,'EB 5 026631, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11628,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11628,19.13,0.12,0.067,2163,NULL,NULL,'EB 5 266513, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11629,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11629,19.13,0.1,0.067,2163,NULL,NULL,'EB 5 180576, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11630,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11630,19.13,0.06,0.067,2163,NULL,NULL,'EB 5 185408, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11631,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11631,19.13,NULL,0.067,2163,NULL,NULL,'EB 08 104222','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11632,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11632,19.13,NULL,0.067,2163,NULL,NULL,'EB 05 202153','SMC',NULL,'2003MNRAS.339..157H',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11633,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11633,19.13,0.03,0.0671,2163,NULL,NULL,'OGLE 7-143913, primary','SMC',NULL,'2010ASPC..435..381D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11634,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11634,19.14,0.11,0.0673,2163,NULL,NULL,'EB 5 180576, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11635,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11635,19.15,0.07,0.0676,2163,NULL,NULL,'EB 5 016658, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11636,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11636,19.17,0.1,0.0682,2163,NULL,NULL,'EB 5 095337, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11637,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11637,19.17,0.03,0.0682,2163,NULL,NULL,'EB 5 026631, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11638,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11638,19.18,NULL,0.0685,2163,NULL,NULL,'EB 09 010098','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11639,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11639,19.19,0.04,0.0689,2163,NULL,NULL,'EB 5 032412, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11640,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11640,19.19,0.05,0.0689,2163,NULL,NULL,'EB 5 095557, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11641,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11641,19.2,0.05,0.0692,2163,NULL,NULL,'EB 5 095557, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11642,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11642,19.2,NULL,0.0692,2163,NULL,NULL,'EB 06 011141','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11643,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11643,19.21,0.09,0.0695,2163,NULL,NULL,'EB 5 095337, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11644,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11644,19.22,0.04,0.0698,2163,NULL,NULL,'EB 5 032412, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11645,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11645,19.22,NULL,0.0698,2163,NULL,NULL,'EB 05 060548','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11646,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11646,19.23,0.04,0.0701,2163,NULL,NULL,'EB 5 266015, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11647,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11647,19.25,0.05,0.0708,2163,NULL,NULL,'EB 5 265970, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11648,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11648,19.25,0.04,0.0708,2163,NULL,NULL,'EB 5 266015, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11649,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11649,19.27,0.05,0.0714,2163,NULL,NULL,'EB 4 121084, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11650,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11650,19.27,NULL,0.0714,2163,NULL,NULL,'EB 07 193779','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11651,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11651,19.28,0.05,0.0718,2163,NULL,NULL,'EB 4 121084, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11652,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11652,19.28,0.09,0.0718,2163,NULL,NULL,'EB 5 100731, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11653,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11653,19.28,0.05,0.0718,2163,NULL,NULL,'EB 5 265970, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11654,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11654,19.29,0.07,0.0721,2163,NULL,NULL,'EB 4 159928, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11655,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11655,19.29,0.06,0.0721,2163,NULL,NULL,'EB 5 261267, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11656,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11656,19.29,NULL,0.0721,2163,NULL,NULL,'EB 01 099121','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11657,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11657,19.29,NULL,0.0721,2163,NULL,NULL,'EB 05 095194','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11658,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11658,19.3,0.06,0.0724,2163,NULL,NULL,'EB 4 159928, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11659,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11659,19.31,0.07,0.0728,2163,NULL,NULL,'EB 5 180185, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11660,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11660,19.32,0.09,0.0731,2163,NULL,NULL,'EB 5 100731, I','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11661,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11661,19.33,NULL,0.0735,2163,NULL,NULL,'EB 05 243188','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11662,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11662,19.35,0.07,0.0741,2163,NULL,NULL,'EB 5 261267, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11663,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11663,19.36,0.17,0.0745,2163,NULL,NULL,'EB AzV73','SMC',NULL,'2001A&A...380..258O',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11664,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11664,19.38,NULL,0.0752,2163,NULL,NULL,'EB 07 189660','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11665,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11665,19.45,0.07,0.0776,2163,NULL,NULL,'EB 5 180185, V','SMC',NULL,'2010A&A...520A..74N',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11666,'Eclipsing Binary','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11666,19.48,NULL,0.0787,2163,NULL,NULL,'EB 05 208049','SMC',NULL,'2005MNRAS.357..304H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11667,'GC radius','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11667,19.96,NULL,0.098,2163,NULL,NULL,'69','SMC',NULL,'1989AN....310..195I',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11668,'HII region diameter','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11668,19.01,0.15,0.0634,2163,NULL,NULL,'Method 1','SMC',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11669,'HII region diameter','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11669,19.41,0.13,0.0762,2163,NULL,NULL,'Method 2','SMC',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11670,'HII region diameter','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11670,19.76,0.12,0.0897,2163,NULL,NULL,NULL,'SMC',NULL,'1986Ap&SS.125...43I',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11671,'Magnitude','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11671,19.36,0.11,0.0745,2163,NULL,NULL,NULL,'SMC',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11672,'Tully est','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11672,18.49,0.8,0.0499,2163,75,NULL,'B','SMC',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11673,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11673,19.66,NULL,0.086,2163,NULL,NULL,'LEDA [April 2006]','SMC',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11674,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11674,36.39,0.35,190,2164,NULL,NULL,'Malmquist cor.','2MFGC 00637',NULL,'2009ApJS..182..474S',2009,1,0.71,NULL,'G',0.000108,NULL,'16.7g',0.18,'Scd(f)',NULL,NULL,NULL,NULL,1,13.1832083,14.72931,0.157,NULL,67588473895,1056069904,16501092,16.7),(11675,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11675,36.47,0.34,197,2164,NULL,NULL,NULL,'2MFGC 00637',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11676,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11676,36.5,0.2,200,2164,74.4,NULL,NULL,'2MFGC 00637',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11677,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 07663','R',11677,41.91,0.46,1620,2165,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07663',0.488121,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,13.190833,0.92544,0.037,NULL,66674123161,1041783174,16277862,NULL),(11678,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 07663',NULL,11678,41.15,0.38,1700,2165,70,NULL,'SN photometric redshift distance, z photo =0.520 +/- 0.149','SDSS-II SN 07663',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11679,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 07663',NULL,11679,41.84,0.31,2330,2165,70,NULL,'SALT 2','SDSS-II SN 07663',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11680,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 07663',NULL,11680,41.97,0.31,2480,2165,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 07663',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11681,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 20088','R',11681,40.39,0.18,963,2166,70,NULL,'SDSS CAND. SNIa; SALT 2','SDSS J005249.28+003753.5',0.244,'2014arXiv1401.3317S',2014,1,0.13,NULL,'G',NULL,NULL,'19.3g',0.09,NULL,NULL,NULL,NULL,NULL,1,13.205375,0.63153,0.073,NULL,66674649099,1041791392,16277990,19.3),(11682,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 20088','R',11682,40.55,0.08,1040,2166,70,NULL,'SDSS CAND. SNIa; MLCS2K2','SDSS J005249.28+003753.5',0.244,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11683,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 20088',NULL,11683,40.32,0.07,1160,2166,70,NULL,'SALT 2','SDSS J005249.28+003753.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11684,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 20088',NULL,11684,40.34,0.07,1170,2166,70,NULL,'SALT 2, Malmquist cor.','SDSS J005249.28+003753.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11685,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11685,36.71,0.62,220,2167,70,NULL,NULL,'2MASX J00525070-0313491',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00008,NULL,'17.50',0.22,NULL,NULL,NULL,NULL,NULL,1,13.2112917,-3.23036,0.21,NULL,34516977771,539327777,8426996,17.5),(11686,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 09722','RN',11686,46.22,0.46,15700,2168,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 09722',0.115584,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11687,'Horizontal Branch','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11687,24.4,NULL,0.76,2169,NULL,NULL,NULL,'Andromeda IX',NULL,'2010MNRAS.407.2411C',2010,1,NULL,NULL,'G',0.000009,NULL,'16.1V',NULL,'dE','Brightest group member',NULL,NULL,NULL,1,13.220833,43.19583,0.405,1,67699060523,1057797820,16528090,16.1),(11688,'TRGB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11688,23.89,0.31,0.6,2169,NULL,NULL,NULL,'Andromeda IX',NULL,'2012ApJ...758...11C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11689,'TRGB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11689,24.33,0.1,0.735,2169,NULL,NULL,'I','Andromeda IX',NULL,'2005ApJ...623..159H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11690,'TRGB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11690,24.42,0.39,0.765,2169,NULL,NULL,NULL,'Andromeda IX',NULL,'2010MNRAS.407.2411C',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11691,'TRGB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11691,24.42,0.07,0.766,2169,NULL,NULL,NULL,'Andromeda IX',NULL,'2005MNRAS.356..979M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11692,'TRGB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11692,24.48,0.2,0.79,2169,NULL,NULL,'I','Andromeda IX',NULL,'2004ApJ...612L.121Z',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11693,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11693,35.27,NULL,113,2170,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0100',NULL,'2010Ap&SS.325..163P',2010,1,0.78,NULL,'G',0.00002,NULL,'17.50',0.08,'Sd',NULL,NULL,NULL,NULL,1,13.2225,31.63444,0.141,NULL,67339379601,1052177806,16440278,17.5),(11694,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11694,35.27,NULL,113,2170,NULL,NULL,'Dipole + Quadrupole','FGC 0100',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11695,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11695,35.29,NULL,114,2170,NULL,NULL,'Dipole','FGC 0100',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11696,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11696,35.31,NULL,116,2170,NULL,NULL,NULL,'FGC 0100',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11697,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11697,36.5,0.53,199,2171,NULL,NULL,'Malmquist cor.','2MASX J00525595-2150290',NULL,'2009ApJS..182..474S',2009,1,0.57,NULL,'G',0.000023,NULL,'16.18',0.32,'Sbc',NULL,NULL,NULL,NULL,1,13.2330833333,-21.84144,0.046,NULL,35385768934,552902639,8639103,16.18),(11698,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11698,36.66,0.49,215,2171,NULL,NULL,NULL,'2MASX J00525595-2150290',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11699,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11699,36.7,0.2,219,2171,74.4,NULL,NULL,'2MASX J00525595-2150290',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11700,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 13174','R',11700,40.19,0.2,882,2172,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2006ga','SDSS J005256.33+002652.3',0.24,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,13.2347083333,0.44786,0.06,NULL,66674700816,1041792200,16278003,NULL),(11701,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 13174','R',11701,40.51,0.13,1020,2172,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2006ga','SDSS J005256.33+002652.3',0.24,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11702,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SN 2006ga',NULL,11702,40.11,0.1,1050,2172,70,NULL,'SALT 2','SDSS J005256.33+002652.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11703,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SN 2006ga',NULL,11703,40.13,0.1,1060,2172,70,NULL,'SALT 2, Malmquist cor.','SDSS J005256.33+002652.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11704,'IRAS','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11704,34.05,0.8,64.5,2173,75,NULL,'W91PP, r','UGC 00540',NULL,'1997ApJS..109..333W',1997,1,0.8,NULL,'G',0.000023,NULL,'14.17',0.5,'Sb','in a radial-velocity based grouping',NULL,NULL,NULL,1,13.2429583333,29.03244,0.173,NULL,67315215931,1051800248,16434378,14.17),(11705,'IRAS','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11705,34.05,0.8,64.6,2173,75,NULL,'HMCL, I','UGC 00540',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11706,'IRAS','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11706,34.05,0.8,64.6,2173,75,NULL,'W91CL, r','UGC 00540',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11707,'IRAS','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11707,34.1,0.8,66.1,2173,75,NULL,'CF, r','UGC 00540',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11708,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11708,33.15,0.69,42.7,2173,100,NULL,'mid-IR','UGC 00540',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11709,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11709,33.4,0.38,47.9,2173,75,NULL,'CF, r, raw','UGC 00540',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11710,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11710,33.45,0.38,49,2173,75,NULL,'CF, r, inv','UGC 00540',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11711,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11711,33.72,0.38,55.5,2173,75,NULL,'W91CL, r, raw','UGC 00540',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11712,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11712,33.77,0.38,56.7,2173,75,NULL,'W91PP, r, raw','UGC 00540',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11713,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11713,33.77,0.2,56.8,2173,74.4,NULL,NULL,'UGC 00540',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11714,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11714,33.78,0.4,57,2173,75,NULL,'HMCL, I, raw','UGC 00540',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11715,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11715,33.79,0.38,57.3,2173,75,NULL,'W91CL, r, inv','UGC 00540',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11716,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11716,33.81,0.38,57.7,2173,75,NULL,'CF, r, cor','UGC 00540',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11717,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11717,33.84,0.38,58.6,2173,75,NULL,'W91PP, r, inv','UGC 00540',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11718,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11718,33.89,0.4,60,2173,75,NULL,'HMCL, I, inv','UGC 00540',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11719,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11719,33.97,0.38,62.4,2173,75,NULL,'W91CL, r, cor','UGC 00540',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11720,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11720,34.01,0.38,63.3,2173,75,NULL,'W91PP, r, cor','UGC 00540',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11721,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11721,34.03,0.4,64,2173,75,NULL,'HMCL, I, cor','UGC 00540',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11722,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11722,37.91,0.33,382,2174,70,NULL,NULL,'SDSS J005258.53-105159.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000066,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,13.243875,-10.86644,0.158,NULL,35252747293,550824176,8606627,18.3),(11723,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 18728','RN',11723,41.94,0.3,1820,2175,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 18728',0.344272,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11724,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 18728','RN',11724,42.27,0.26,2110,2175,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 18728',0.344272,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11725,'IRAS','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11725,34.92,0.8,96.2,2176,75,NULL,'MAT, I','UGC 00541',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000008,NULL,'16.0',0.13,'Sc',NULL,NULL,NULL,NULL,1,13.2890416667,21.92667,0.085,NULL,67613981514,1056468461,16507319,16),(11726,'IRAS','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11726,34.92,0.8,96.4,2176,75,NULL,'W91PP, r','UGC 00541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11727,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11727,34.08,0.32,65.5,2176,85,NULL,'I, inv','UGC 00541',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11728,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11728,34.09,0.32,65.7,2176,85,NULL,'I, raw','UGC 00541',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11729,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11729,34.29,0.43,72.2,2176,75,NULL,'MAT, I, raw','UGC 00541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11730,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11730,34.33,0.43,73.6,2176,75,NULL,'MAT, I, inv','UGC 00541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11731,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11731,34.58,0.43,82.3,2176,75,NULL,'MAT, I, cor','UGC 00541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11732,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11732,34.7,NULL,87.2,2176,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00541',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11733,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11733,34.72,NULL,87.8,2176,NULL,NULL,'Dipole + Quadrupole','UGC 00541',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11734,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11734,34.73,NULL,88.1,2176,NULL,NULL,NULL,'UGC 00541',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11735,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11735,34.73,NULL,88.1,2176,NULL,NULL,'Dipole','UGC 00541',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11736,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11736,34.79,0.2,90.8,2176,74.4,NULL,NULL,'UGC 00541',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11737,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11737,34.86,0.37,93.6,2176,NULL,NULL,'Malmquist cor.','UGC 00541',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11738,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11738,34.86,0.38,93.7,2176,75,NULL,'W91PP, r, raw','UGC 00541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11739,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11739,34.88,0.38,94.8,2176,75,NULL,'W91PP, r, inv','UGC 00541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11740,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11740,34.89,0.49,94.9,2176,75,NULL,'IR','UGC 00541',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11741,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11741,34.91,0.37,96,2176,NULL,NULL,NULL,'UGC 00541',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11742,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11742,35.15,0.38,107,2176,75,NULL,'W91PP, r, cor','UGC 00541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11743,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11743,36.1,0.4,166,2177,NULL,NULL,'mean','NGC 0283',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000033,NULL,'14.81',1,'Sc',NULL,NULL,NULL,NULL,1,13.3050417,-13.16389,0.02,NULL,35367687996,552620124,8634689,14.81),(11744,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11744,36.17,0.47,171,2177,NULL,NULL,'H','NGC 0283',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11745,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 14265','RN',11745,41.39,0.14,1520,2178,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 14265',0.249468,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11746,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 14265','RN',11746,41.63,0.21,1700,2178,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 14265',0.249468,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11747,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11747,35.72,0.55,139,2179,70,NULL,NULL,'2MASX J00531448-0337216',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.000087,NULL,'16.87',0.22,NULL,NULL,NULL,NULL,NULL,1,13.310375,-3.62272,0.215,NULL,34516624165,539322252,8426910,16.87),(11748,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 13011','R',11748,38.7,0.12,504,2180,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13011',0.0902,'2014arXiv1401.3317S',2014,1,0.18,NULL,'G',NULL,'PHOT','19.1g',0.13,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,13.3100417,0.42642,0.06,NULL,66674657344,1041791521,16277992,19.1),(11749,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 13011','R',11749,38.86,0.23,542,2180,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13011',0.0902,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11750,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 13011',NULL,11750,39.46,0.16,779,2180,70,NULL,'SN photometric redshift distance, z photo =0.202 +/- 0.017','SDSS-II SN 13011',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11751,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11751,36.19,0.8,173,2181,70,NULL,NULL,'2MASX J00531535-0333056',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.000097,NULL,'17.13',0.19,NULL,NULL,NULL,NULL,NULL,1,13.3140416667,-3.55158,0.215,NULL,34516868825,539326075,8426969,17.13),(11752,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 09725','RN',11752,41.16,0.24,1460,2182,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 09725',0.174409,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11753,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 09725','RN',11753,41.2,0.27,1480,2182,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 09725',0.174409,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11754,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11754,35.72,0.38,139,2183,NULL,NULL,'Malmquist cor.','ESO 474- G 038',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.5b',0.4,'Sb:',NULL,NULL,NULL,NULL,1,13.3282083,-26.79789,0.05,NULL,34843195233,544424925,8506639,15.5),(11755,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11755,35.87,0.35,149,2183,NULL,NULL,NULL,'ESO 474- G 038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11756,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11756,35.91,0.2,152,2183,74.4,NULL,NULL,'ESO 474- G 038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11757,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11757,36.42,0.63,192,2184,70,NULL,NULL,'2MASX J00531897-0356326',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00012,NULL,'16.70',0.38,NULL,NULL,NULL,NULL,NULL,1,13.329083,-3.94247,0.218,NULL,34546798778,539793730,8434277,16.7),(11758,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11758,36.3,0.55,182,2185,70,NULL,NULL,'2MASX J00532013-0117526',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000097,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,13.333875,-1.29794,0.134,NULL,34524752913,539449264,8428894,15.1),(11759,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11759,36.02,0.51,160,2186,70,NULL,NULL,'2MASX J00532155-0251216',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.000083,NULL,'17.12',0.49,NULL,NULL,NULL,NULL,NULL,1,13.3397917,-2.85619,0.214,NULL,34523914602,539436165,8428690,17.12),(11760,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11760,37.55,0.55,324,2187,NULL,NULL,'Malmquist cor.','2MASX J00532535-2151017',NULL,'2009ApJS..182..474S',2009,1,0.41,NULL,'G',0.000023,NULL,'16.27',0.14,'Sb:',NULL,NULL,NULL,NULL,1,13.355625,-21.85044,0.046,NULL,35385743590,552902243,8639097,16.27),(11761,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11761,37.73,0.5,351,2187,NULL,NULL,NULL,'2MASX J00532535-2151017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11762,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11762,37.77,0.2,358,2187,74.4,NULL,NULL,'2MASX J00532535-2151017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11763,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11763,36.92,0.14,242,2188,70,NULL,'ABELL 0114, BGC','2MASX J00532556-2144117',NULL,'1999AJ....118.1489D',1999,1,0.68,NULL,'G',0.0002,NULL,'14.5',0.4,'PEG','Field galaxy',NULL,NULL,NULL,1,13.3565,-21.73664,0.046,NULL,35385594737,552899917,8639061,14.5),(11764,'IRAS','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11764,33.74,0.8,55.9,2189,75,NULL,'W91PP, r','UGC 00542',NULL,'1997ApJS..109..333W',1997,1,3.14,NULL,'G',0.000006,NULL,'14.22',0.43,'Sb',NULL,NULL,NULL,NULL,1,13.3609583,29.27036,0.181,NULL,67315341246,1051802206,16434409,14.22),(11765,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11765,33.51,0.38,50.4,2189,75,NULL,'W91PP, r, raw','UGC 00542',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11766,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11766,33.57,NULL,51.8,2189,NULL,NULL,'Dipole','UGC 00542',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11767,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11767,33.58,NULL,51.9,2189,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00542',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11768,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11768,33.59,NULL,52.1,2189,NULL,NULL,'Dipole + Quadrupole','UGC 00542',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11769,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11769,33.62,0.2,53,2189,74.4,NULL,NULL,'UGC 00542',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11770,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11770,33.63,0.43,53.3,2189,75,NULL,'3.6 micron, color corrected','UGC 00542',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11771,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11771,33.64,0.38,53.5,2189,75,NULL,'W91PP, r, inv','UGC 00542',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11772,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11772,33.65,0.47,53.7,2189,NULL,NULL,'H','UGC 00542',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11773,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11773,33.71,NULL,55.3,2189,NULL,NULL,NULL,'UGC 00542',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11774,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11774,33.72,0.45,55.5,2189,NULL,NULL,'K','UGC 00542',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11775,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11775,33.72,0.43,55.5,2189,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00542',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11776,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11776,33.73,0.49,55.7,2189,75,NULL,'IR','UGC 00542',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11777,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11777,33.79,0.46,57.2,2189,NULL,NULL,'J','UGC 00542',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11778,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11778,33.87,0.38,59.3,2189,75,NULL,'W91PP, r, cor','UGC 00542',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11779,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11779,34,0.4,63,2189,NULL,NULL,'mean','UGC 00542',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11780,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11780,34.07,0.08,65.3,2189,NULL,NULL,NULL,'UGC 00542',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11781,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11781,36.88,0.36,238,2190,NULL,NULL,'Malmquist cor.','2MASX J00532866-2154407',NULL,'2009ApJS..182..474S',2009,1,0.55,NULL,'G',0.000023,NULL,'16.16',0.23,'Sab',NULL,NULL,NULL,NULL,1,13.369417,-21.91131,0.046,NULL,35385606656,552900104,8639064,16.16),(11782,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11782,37.01,0.34,252,2190,NULL,NULL,NULL,'2MASX J00532866-2154407',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11783,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11783,37.05,0.2,257,2190,74.4,NULL,NULL,'2MASX J00532866-2154407',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11784,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11784,37.56,0.76,325,2191,70,NULL,NULL,'2MASX J00532939-0040375',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00006,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,13.3725,-0.67731,0.113,NULL,34513686252,539276347,8426192,16.4),(11785,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11785,34.47,0.4,78.3,2192,NULL,NULL,'mean','NGC 0291',NULL,'2007A&A...465...71T',2007,1,1.22,NULL,'G',0.000014,NULL,'14.5g',0.49,'(R\')SB(r)a:;Sy2HII',NULL,NULL,NULL,'Sy 2',1,13.374667,-8.76781,0.218,NULL,34529042857,539516294,8429942,14.5),(11786,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11786,34.51,0.47,80,2192,NULL,NULL,'H','NGC 0291',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11787,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11787,34.64,0.45,84.9,2192,NULL,NULL,'K','NGC 0291',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11788,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11788,35.1,0.56,105,2193,70,NULL,NULL,'NGC 0286',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000127,NULL,'14.99',0.9,'SAB(s)0^0^ pec?',NULL,NULL,NULL,NULL,1,13.376583,-13.11278,0.02,NULL,35369526272,552648848,8635138,14.99),(11789,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11789,35.9,NULL,151,2194,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0104',NULL,'2010Ap&SS.325..163P',2010,1,1.1,'Haynes et al. (2011AJ....142..170H) give z = 0.0362.','G',0.000012,NULL,'17.46',0.09,'Scd',NULL,NULL,NULL,NULL,1,13.3780417,28.27706,0.169,NULL,67318010231,1051843909,16435061,17.46),(11790,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11790,35.91,NULL,152,2194,NULL,NULL,'Dipole + Quadrupole','FGC 0104',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11791,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11791,35.91,NULL,152,2194,NULL,NULL,'Dipole','FGC 0104',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11792,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11792,36.14,NULL,169,2194,NULL,NULL,NULL,'FGC 0104',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11793,'IRAS','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11793,34.4,0.8,75.8,2195,75,NULL,'MAT, I','IC 1597',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'14.96',0.3,'(R\')SB(rs)b:',NULL,NULL,NULL,NULL,1,13.3837083,-58.10714,0,NULL,36228940052,566077188,8844956,14.96),(11794,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11794,33.82,0.32,58.2,2195,85,NULL,'I, raw','IC 1597',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11795,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11795,33.84,0.32,58.7,2195,85,NULL,'I, inv','IC 1597',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11796,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11796,33.88,0.43,59.8,2195,75,NULL,'MAT, I, raw','IC 1597',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11797,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11797,34,0.43,63.2,2195,75,NULL,'MAT, I, inv','IC 1597',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11798,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11798,34.1,0.51,66,2195,NULL,NULL,NULL,'IC 1597',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11799,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11799,34.14,0.2,67.3,2195,74.4,NULL,NULL,'IC 1597',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11800,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11800,34.28,0.43,71.7,2195,75,NULL,'MAT, I, cor','IC 1597',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11801,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11801,34.35,0.45,74.1,2195,NULL,NULL,'Malmquist cor.','IC 1597',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11802,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11802,34.59,0.39,82.8,2196,NULL,NULL,'Malmquist cor.','UGC 00544',NULL,'2009ApJS..182..474S',2009,1,1.71,NULL,'G',NULL,NULL,'15.43',0.21,'Scd',NULL,NULL,NULL,NULL,1,13.386167,2.92431,0.085,NULL,66683746839,1041933544,16280211,15.43),(11803,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11803,34.64,0.2,84.7,2196,74.4,NULL,NULL,'UGC 00544',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11804,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11804,34.72,NULL,87.7,2196,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00544',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11805,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11805,34.72,NULL,88.1,2196,NULL,NULL,'Dipole + Quadrupole','UGC 00544',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11806,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11806,34.73,NULL,88.3,2196,NULL,NULL,'Dipole','UGC 00544',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11807,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11807,34.78,NULL,90.3,2196,NULL,NULL,NULL,'UGC 00544',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11808,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11808,34.79,0.35,91,2196,NULL,NULL,NULL,'UGC 00544',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11809,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 16221','RN',11809,44.19,0.41,4930,2197,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 16221',0.396585,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11810,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 16221','RN',11810,45.11,0.37,7550,2197,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 16221',0.396585,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11811,'HII LF','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'N',11811,45.77,1.58,2460,2198,71,NULL,NULL,'CDFa C01',3.11,'2005MNRAS.356.1117S',2005,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11812,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11812,35.43,0.46,122,2199,70,NULL,NULL,'2MASX J00533635-1014190',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000092,NULL,'15.9g',0.3,'E0',NULL,NULL,NULL,NULL,1,13.401417,-10.23867,0.22,NULL,35252556902,550821201,8606581,15.9),(11813,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11813,35.9,0.67,152,2200,70,NULL,NULL,'6dF J0053364-291429',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,13.40175,-29.24125,NULL,NULL,34838773535,544355836,8505559,15),(11814,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11814,36.92,0.14,242,2201,70,NULL,NULL,'ABELL 0114',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,13.415375,-21.67881,0.046,NULL,35385595785,552899934,8639061,NULL),(11815,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11815,36.28,0.63,180,2202,70,NULL,NULL,'2MASX J00534136-0155486',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00009,NULL,'17.17',0.28,NULL,NULL,NULL,NULL,NULL,1,13.4222917,-1.93017,0.161,NULL,34527276652,539488697,8429510,17.17),(11816,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 18692','RN',11816,38.98,0.3,550,2203,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 18692',0.135089,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11817,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 18692','RN',11817,39.27,0.36,628,2203,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 18692',0.135089,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11818,'IRAS','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11818,34.21,0.8,69.6,2204,75,NULL,'MAT, I','ESO 474- G 039',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.90',0.2,'SA(r)bc        HII',NULL,NULL,NULL,NULL,1,13.4310417,-27.04972,0.059,NULL,34838958929,544358733,8505605,14.9),(11819,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11819,33.82,0.32,58.2,2204,85,NULL,'I, raw','ESO 474- G 039',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11820,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11820,33.85,0.32,58.9,2204,85,NULL,'I, inv','ESO 474- G 039',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11821,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11821,33.93,0.43,61,2204,75,NULL,'MAT, I, raw','ESO 474- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11822,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11822,33.98,0.49,62.4,2204,75,NULL,'IR','ESO 474- G 039',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11823,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11823,34.01,0.2,63.4,2204,74.4,NULL,NULL,'ESO 474- G 039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11824,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11824,34.08,0.43,65.3,2204,75,NULL,'MAT, I, inv','ESO 474- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11825,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11825,34.08,0.48,65.5,2204,NULL,NULL,NULL,'ESO 474- G 039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11826,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11826,34.3,0.43,72.5,2204,75,NULL,'MAT, I, cor','ESO 474- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11827,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11827,34.36,0.42,74.5,2204,NULL,NULL,'Malmquist cor.','ESO 474- G 039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11828,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 02366','R',11828,40.56,0.14,1130,2205,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2005fq','SN 2005fq',0.147126,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia?',NULL,NULL,NULL,NULL,1,13.4335417,-0.56022,0.112,NULL,34512972462,539265194,8426018,NULL),(11829,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 02366','R',11829,41.02,0.22,1390,2205,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2005fq','SN 2005fq',0.147126,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11830,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11830,36.5,0.76,199,2206,70,NULL,NULL,'2MASX J00534514-0307006',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.000083,NULL,'17.08',0.31,NULL,NULL,NULL,NULL,NULL,1,13.4380417,-3.11689,0.201,NULL,34516932357,539327068,8426985,17.08),(11831,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11831,37.49,0.46,315,2207,70,NULL,NULL,'2MASX J00534671+1414587',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000086,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,13.444625,14.24964,0.157,NULL,67592934286,1056139598,16502181,17.4),(11832,'IRAS','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11832,34.87,0.8,94.1,2208,75,NULL,'MAT, I','IC 1595',NULL,'1997ApJS..109..333W',1997,1,1.37,NULL,'G',0.000033,NULL,'15.32',0.25,'Sbc',NULL,NULL,NULL,NULL,1,13.4460417,-45.18664,NULL,NULL,38171123868,596423810,9319122,15.32),(11833,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11833,34.05,NULL,64.6,2208,NULL,NULL,'B','IC 1595',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11834,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11834,34.05,NULL,64.6,2208,NULL,NULL,'I','IC 1595',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11835,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11835,34.19,0.43,68.9,2208,75,NULL,'MAT, I, raw','IC 1595',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11836,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11836,34.22,0.32,69.9,2208,85,NULL,'I, raw','IC 1595',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11837,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11837,34.26,0.32,71.1,2208,85,NULL,'I, inv','IC 1595',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11838,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11838,34.37,0.43,74.9,2208,75,NULL,'MAT, I, inv','IC 1595',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11839,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11839,34.54,NULL,80.9,2208,NULL,NULL,NULL,'IC 1595',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11840,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11840,34.63,NULL,84.4,2208,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 1595',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11841,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11841,34.64,0.43,84.7,2208,75,NULL,'MAT, I, cor','IC 1595',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11842,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11842,34.65,NULL,85.3,2208,NULL,NULL,'Dipole + Quadrupole','IC 1595',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11843,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11843,34.69,NULL,86.6,2208,NULL,NULL,'Dipole','IC 1595',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11844,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11844,34.98,0.32,98.9,2208,NULL,NULL,NULL,'IC 1595',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11845,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11845,35.02,0.2,101,2208,74.4,NULL,NULL,'IC 1595',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11846,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11846,35.04,0.31,102,2208,NULL,NULL,'Malmquist cor.','IC 1595',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11847,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11847,36.34,0.59,186,2209,70,NULL,NULL,'LCRS B005128.9-441518',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.000143,NULL,'16.43',0.28,'S0',NULL,NULL,NULL,NULL,1,13.4507916667,-43.98369,NULL,NULL,38171525588,596430087,9319220,16.43),(11848,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11848,37.41,0.46,303,2210,70,NULL,NULL,'2MASX J00534867-1030110',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000092,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,13.452833,-10.50303,0.166,NULL,35252423442,550819116,8606548,16.9),(11849,'IRAS','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11849,34.14,0.8,67.3,2211,75,NULL,'MAT, I','ESO 351- G 018',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'15.44',0.4,'Sb-c',NULL,NULL,NULL,NULL,1,13.453667,-33.29494,NULL,NULL,34864524808,544758200,8511846,15.44),(11850,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11850,33.89,0.32,60.1,2211,85,NULL,'I, raw','ESO 351- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11851,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11851,33.91,0.32,60.5,2211,85,NULL,'I, inv','ESO 351- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11852,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11852,34.08,0.43,65.5,2211,75,NULL,'MAT, I, raw','ESO 351- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11853,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11853,34.18,0.43,68.6,2211,75,NULL,'MAT, I, inv','ESO 351- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11854,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11854,34.39,0.43,75.4,2211,75,NULL,'MAT, I, cor','ESO 351- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11855,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11855,34.42,0.2,76.6,2211,74.4,NULL,NULL,'ESO 351- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11856,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11856,34.54,0.37,81.1,2211,NULL,NULL,NULL,'ESO 351- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11857,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11857,34.59,0.37,82.6,2211,NULL,NULL,'Malmquist cor.','ESO 351- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11858,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11858,36.52,0.57,201,2212,70,NULL,NULL,'2MASX J00535014-0308216',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.000107,NULL,'16.67',0.42,NULL,NULL,NULL,NULL,NULL,1,13.4589583,-3.13933,0.201,NULL,34516941243,539327206,8426987,16.67),(11859,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11859,34.67,0.64,85.7,2213,NULL,NULL,NULL,'ESO 243- G 009',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.43',0.5,'S...',NULL,NULL,NULL,NULL,1,13.469417,-46.97242,NULL,NULL,38145313766,596020527,9312820,16.43),(11860,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11860,34.71,0.2,87.5,2213,74.4,NULL,NULL,'ESO 243- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11861,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11861,35.04,0.54,102,2213,NULL,NULL,'Malmquist cor.','ESO 243- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11862,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11862,36.4,0.33,191,2214,70,NULL,NULL,'CGCG 384-023',NULL,'2015arXiv151105856S',2015,1,0.88,NULL,'G',0.000101,NULL,'14.9g',0.58,'E0',NULL,NULL,NULL,NULL,1,13.46975,0.97961,0.049,NULL,66688235444,1042003678,16281307,14.9),(11863,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11863,36.27,0.54,179,2215,NULL,NULL,'Malmquist cor.','MCG -04-03-025',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000023,NULL,'15.5',0.2,'Sbc:','Field galaxy',NULL,NULL,NULL,1,13.499083,-21.67725,0.066,NULL,35385633289,552900520,8639070,15.5),(11864,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11864,36.46,0.49,196,2215,NULL,NULL,NULL,'MCG -04-03-025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11865,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11865,36.5,0.2,200,2215,74.4,NULL,NULL,'MCG -04-03-025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11866,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11866,37.92,0.46,383,2216,70,NULL,NULL,'SDSS J005400.48+011106.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000063,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,13.502,1.18506,0.049,NULL,66688186230,1042002909,16281295,18.2),(11867,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 04612','RN',11867,41.73,0.34,1590,2217,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 04612',0.394945,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11868,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 04612','RN',11868,41.8,0.34,1650,2217,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 04612',0.394945,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11869,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 04612','N',11869,41.54,0.25,2030,2217,70,NULL,'SALT 2','SDSS-II SN 04612',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11870,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 04612','N',11870,41.6,0.25,2090,2217,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 04612',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11871,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SN 2007ne',NULL,11871,39.46,0.09,781,2218,70,NULL,'Hubble residual -0.04 for z0.20660','SDSS J005402.20+010408.0',NULL,'2011ApJ...740...92G',2011,1,0.09,NULL,'G',0.0005,NULL,'20.3g',0.07,NULL,NULL,NULL,NULL,NULL,1,13.5092083,1.06892,0.049,NULL,66688361642,1042005650,16281338,20.3),(11872,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 18965','R',11872,40.03,0.19,839,2218,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ne','SDSS J005402.20+010408.0',0.2066,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11873,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 18965','R',11873,40.25,0.1,929,2218,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ne','SDSS J005402.20+010408.0',0.2066,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11874,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SN 2007ne',NULL,11874,39.89,0.08,951,2218,70,NULL,'SALT 2','SDSS J005402.20+010408.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11875,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SN 2007ne',NULL,11875,39.9,0.08,955,2218,70,NULL,'SALT 2, Malmquist cor.','SDSS J005402.20+010408.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11876,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11876,33.09,0.43,41.6,2219,75,NULL,'3.6 micron, color + selection bias corrected','MCG +12-02-001',NULL,'2014MNRAS.444..527S',2014,1,NULL,NULL,'GPair',0.000073,NULL,NULL,NULL,'E?pec + E?pec  LIRG',NULL,NULL,NULL,NULL,1,13.5150417,73.08661,1.917,NULL,65627209671,1025425151,16022267,NULL),(11877,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11877,36.03,0.49,161,2220,70,NULL,NULL,'2MASX J00540361-4731557',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.80',0.29,NULL,NULL,NULL,NULL,NULL,1,13.5150833333,-47.53225,NULL,NULL,38145959392,596030615,9312978,16.8),(11878,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11878,34.53,0.2,80.5,2221,74.4,NULL,NULL,'CGCG 501-035',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000023,NULL,'15.30',0.3,'Sb','Isolated galaxy',NULL,NULL,NULL,1,13.520833,30.34572,0.265,NULL,67336230829,1052128606,16439509,15.3),(11879,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11879,34.63,0.43,84.3,2221,75,NULL,'3.6 micron, color corrected','CGCG 501-035',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11880,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11880,34.79,0.43,90.7,2221,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 501-035',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11881,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 03205',NULL,11881,37.85,0.78,372,2222,70,NULL,'SN photometric redshift distance, z photo =0.091 +/- 0.042','SDSS-II SN 03205',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.5g',0.02,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,13.522583,0.31333,0.073,NULL,66673912454,1041779882,16277810,21.5),(11882,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 03205',NULL,11882,39.93,0.1,968,2222,70,NULL,'SALT 2','SDSS-II SN 03205',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11883,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 03205',NULL,11883,39.94,0.1,973,2222,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 03205',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11884,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11884,35.68,0.48,137,2223,70,NULL,NULL,'2MASX J00540560-4636597',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.86',0.45,'S0',NULL,NULL,NULL,NULL,1,13.5234583,-46.61664,NULL,NULL,38147199682,596049995,9313281,15.86),(11885,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11885,36.95,0.6,246,2224,70,NULL,NULL,'2MASX J00540600-0602489',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'16.95',0.25,NULL,NULL,NULL,NULL,NULL,1,13.525,-6.04717,0.168,NULL,34538957438,539671209,8432362,16.95),(11886,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11886,38.6,0.46,524,2225,70,NULL,NULL,'2MASX J00541027+1437422',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000087,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,13.543,14.62833,0.145,NULL,67592789079,1056137329,16502145,18),(11887,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 03775','RN',11887,38.87,0.15,521,2226,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 03775',0.139201,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11888,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 03775','RN',11888,39.1,0.22,580,2226,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 03775',0.139201,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11889,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11889,35.92,0.73,153,2227,70,NULL,NULL,'CGCG 384-024',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.000097,NULL,'15.7',0.39,NULL,NULL,NULL,NULL,NULL,1,13.550625,-1.42839,0.13,NULL,34525027639,539453556,8428961,15.7),(11890,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11890,35.42,0.55,121,2228,70,NULL,NULL,'2MASX J00541225-1927505',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,13.551,-19.46417,0.068,NULL,35392972628,553015197,8640862,14.2),(11891,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11891,34.06,0.12,65,2229,NULL,NULL,NULL,'2MASX J00541293+3128346',NULL,'2009ApJS..182..474S',2009,1,0.51,NULL,'G',NULL,NULL,'15.80',0.21,NULL,NULL,NULL,NULL,NULL,1,13.5539583,31.47628,0.193,NULL,67339151559,1052174243,16440222,15.8),(11892,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11892,35.27,NULL,113,2230,NULL,NULL,'B','ESO 079- G 008',NULL,'2005Ap&SS.298..577R',2005,1,1.3,NULL,'G',0.000033,NULL,'14.58',0.8,'(R\')SAB(rs)bc',NULL,NULL,NULL,NULL,1,13.5577083,-62.45536,0,NULL,36060336321,563442755,8803793,14.58),(11893,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11893,35.54,NULL,128,2230,NULL,NULL,'I','ESO 079- G 008',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11894,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11894,35.68,0.38,137,2230,NULL,NULL,'Malmquist cor.','ESO 079- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11895,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11895,36.08,0.32,164,2230,NULL,NULL,NULL,'ESO 079- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11896,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11896,36.12,0.2,167,2230,74.4,NULL,NULL,'ESO 079- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11897,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11897,36.54,0.71,203,2231,70,NULL,NULL,'2MASX J00541574-1428116',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.000057,NULL,'17.20',0.37,'Sab',NULL,NULL,NULL,NULL,1,13.565875,-14.47006,0.021,NULL,35381340234,552833441,8638022,17.2),(11898,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11898,36.45,0.07,195,2232,70,NULL,NULL,'2MASX J00541589-0114220',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000082,NULL,'16.0g',0.5,'E/S0',NULL,NULL,NULL,NULL,1,13.566333,-1.23933,0.13,NULL,34525209367,539456396,8429006,16),(11899,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11899,36.89,0.56,239,2232,70,NULL,NULL,'2MASX J00541589-0114220',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11900,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11900,34.39,0.45,75.6,2233,70,NULL,NULL,'2MASX J00541843-6153345',NULL,'2014MNRAS.445.2677S',2014,1,0.85,NULL,'G',0.00006,NULL,'14.98',0.63,'S0',NULL,NULL,NULL,NULL,1,13.57675,-61.89286,0,NULL,36060039985,563438124,8803720,14.98),(11901,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 03206',NULL,11901,40.43,0.25,1220,2234,70,NULL,'SN photometric redshift distance, z photo =0.341 +/- 0.052','SDSS-II SN 03206',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,13.577417,0.41817,0.073,NULL,66673814143,1041778345,16277786,NULL),(11902,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 03206','R',11902,41.95,0.26,1730,2234,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03206',0.417071,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11903,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 03206','R',11903,42.04,0.27,1800,2234,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03206',0.417071,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11904,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 03206',NULL,11904,41.81,0.18,2300,2234,70,NULL,'SALT 2','SDSS-II SN 03206',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11905,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 03206',NULL,11905,41.89,0.18,2390,2234,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 03206',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11906,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11906,36.74,0.72,223,2235,70,NULL,NULL,'2MASX J00541944-0716129',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00015,NULL,'16.97',0.24,NULL,NULL,NULL,NULL,NULL,1,13.580917,-7.27028,0.234,NULL,34543907842,539748560,8433571,16.97),(11907,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11907,37.7,0.46,346,2236,70,NULL,NULL,'2MASX J00541975-0849359',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000091,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,13.58225,-8.82669,0.218,NULL,34529537713,539524026,8430062,17),(11908,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 04245',NULL,11908,38.75,2.37,562,2237,70,NULL,'SN photometric redshift distance, z photo =0.141 +/- 0.370','SDSS-II SN 04245',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','22.4g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,13.5907916667,-0.97997,0.111,NULL,34525410548,539459539,8429055,22.4),(11909,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11909,37.24,0.46,281,2238,70,NULL,NULL,'2MASX J00542266+1501243',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00007,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,13.5945,15.02342,0.161,NULL,67590183610,1056096618,16501509,18.1),(11910,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11910,36.14,0.51,169,2239,70,NULL,NULL,'2MASX J00542382-6551406',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'13.16',0.14,NULL,NULL,NULL,NULL,NULL,1,13.5992917,-65.86136,0.005,NULL,36041878868,563154357,8799286,13.16),(11911,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11911,37.04,0.46,256,2240,70,NULL,NULL,'2MASX J00542770-0951368',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000092,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,13.6155417,-9.86014,0.173,NULL,35251543829,550805372,8606333,16.7),(11912,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11912,36.43,0.55,193,2241,70,NULL,NULL,'ESO 079-IG 009 NED02',NULL,'2014MNRAS.445.2677S',2014,1,1.53,NULL,'G',0.00015,NULL,'15.27',0.38,'S0',NULL,NULL,NULL,NULL,1,13.620333,-65.85606,0.005,NULL,36041878936,563154358,8799286,15.27),(11913,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11913,36.91,0.62,241,2242,70,NULL,NULL,'2MASX J00543033-1550026',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'17.06',0.28,NULL,NULL,NULL,NULL,NULL,1,13.6265417,-15.83414,0.016,NULL,35374469312,552726083,8636345,17.06),(11914,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11914,35.04,0.38,102,2243,NULL,NULL,NULL,'ESO 195- G 014',NULL,'2009ApJS..182..474S',2009,1,1.14,NULL,'G',0.000033,NULL,'15.30',0.43,'S...',NULL,NULL,NULL,NULL,1,13.6375,-51.25864,NULL,NULL,36019587177,562806049,8793844,15.3),(11915,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11915,35.08,0.2,104,2243,74.4,NULL,NULL,'ESO 195- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11916,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11916,35.08,0.37,104,2243,NULL,NULL,'Malmquist cor.','ESO 195- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11917,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11917,36.76,0.46,225,2244,70,NULL,NULL,'2MASX J00543485-1021541',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00009,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,13.645167,-10.36506,0.159,NULL,35253024372,550828505,8606695,16.5),(11918,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11918,35.42,0.48,122,2245,70,NULL,NULL,'6dF J0054367-355106',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,13.6530416667,-35.85175,NULL,NULL,34645755367,541339927,8458436,14.1),(11919,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11919,36.32,0.46,183,2246,70,NULL,NULL,'2MASX J00543874-0839391',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000069,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,13.661375,-8.66106,0.243,NULL,34528955492,539514929,8429920,17.8),(11920,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 19504','RN',11920,41.02,0.25,1320,2247,70,NULL,'SDSS CAND. SNII; MLCS2K2','SDSS-II SN 19504',0.215,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11921,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 19504','RN',11921,41.05,0.33,1330,2247,70,NULL,'SDSS CAND. SNII; SALT 2','SDSS-II SN 19504',0.215,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11922,'IRAS','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11922,34.58,0.8,82.6,2248,75,NULL,'W91PP, r','UGC 00549',NULL,'1997ApJS..109..333W',1997,1,1.36,NULL,'G',0.000033,NULL,'15.79',0.13,'Scd','Isolated galaxy',NULL,NULL,NULL,1,13.675417,36.76517,0.185,NULL,67665947293,1057280426,16520006,15.79),(11923,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11923,34.26,NULL,71.2,2248,NULL,NULL,'Dipole','UGC 00549',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11924,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11924,34.27,NULL,71.3,2248,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00549',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11925,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11925,34.27,NULL,71.4,2248,NULL,NULL,'Dipole + Quadrupole','UGC 00549',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11926,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11926,34.29,0.43,72,2248,75,NULL,'3.6 micron, color corrected','UGC 00549',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11927,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11927,34.29,0.43,72.2,2248,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00549',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11928,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11928,34.33,0.2,73.5,2248,74.4,NULL,NULL,'UGC 00549',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11929,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11929,34.45,0.39,77.7,2248,NULL,NULL,'Malmquist cor.','UGC 00549',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11930,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11930,34.47,0.39,78.3,2248,NULL,NULL,NULL,'UGC 00549',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11931,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11931,34.52,NULL,80.1,2248,NULL,NULL,NULL,'UGC 00549',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11932,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11932,34.62,0.38,83.9,2248,75,NULL,'W91PP, r, raw','UGC 00549',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11933,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11933,34.63,0.38,84.3,2248,75,NULL,'W91PP, r, inv','UGC 00549',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11934,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11934,34.76,0.38,89.7,2248,75,NULL,'W91PP, r, cor','UGC 00549',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11935,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11935,36.45,0.38,195,2249,NULL,NULL,'Malmquist cor.','2MASX J00544214-0129214',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000027,NULL,'15',0.5,'Sb','Group member',NULL,NULL,NULL,1,13.675625,-1.48931,0.124,NULL,34527098142,539485908,8429467,15),(11936,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11936,36.68,0.34,217,2249,NULL,NULL,NULL,'2MASX J00544214-0129214',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11937,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11937,36.72,0.2,221,2249,74.4,NULL,NULL,'2MASX J00544214-0129214',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11938,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11938,37.83,0.46,368,2250,70,NULL,NULL,'2MASX J00544501-0926521',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000091,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,13.6874583,-9.44783,0.185,NULL,35251435915,550803686,8606307,17.2),(11939,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11939,37.87,0.46,375,2251,70,NULL,NULL,'2MASX J00544536-1055361',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000095,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,13.688875,-10.92664,0.171,NULL,35252695063,550823360,8606615,16.8),(11940,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11940,37.07,0.46,259,2252,70,NULL,NULL,'2MASX J00544689+0020109',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000088,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,13.695375,0.33653,0.068,NULL,66673938087,1041780282,16277816,16.9),(11941,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 12977','R',11941,40.34,0.21,937,2253,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006gh','SDSS J005446.94-001503.1',0.25,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,13.6955833333,-0.25086,0.078,NULL,34513050247,539266410,8426037,NULL),(11942,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 12977','R',11942,40.67,0.14,1090,2253,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006gh','SDSS J005446.94-001503.1',0.25,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11943,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SN 2006gh',NULL,11943,40.24,0.11,1120,2253,70,NULL,'SALT 2','SDSS J005446.94-001503.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11944,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SN 2006gh',NULL,11944,40.26,0.11,1130,2253,70,NULL,'SALT 2, Malmquist cor.','SDSS J005446.94-001503.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11945,'IRAS','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11945,33.72,0.8,55.5,2254,75,NULL,'HMCL, I','UGC 00557',NULL,'1997ApJS..109..333W',1997,1,1.1,'Cabanela, et al. (1999AJ....118...46C) give v = 6267 +/- 446 km/sec.','G',0.00002,NULL,'15.06',0.5,'SB?',NULL,NULL,NULL,NULL,1,13.695833,31.36597,0.193,NULL,67339135636,1052173994,16440218,15.06),(11946,'IRAS','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11946,33.73,0.8,55.6,2254,75,NULL,'W91PP, r','UGC 00557',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11947,'IRAS','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11947,33.73,0.8,55.7,2254,75,NULL,'W91CL, r','UGC 00557',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11948,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11948,33.84,0.1,58.7,2254,NULL,NULL,NULL,'UGC 00557',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11949,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11949,33.88,0.38,59.6,2254,75,NULL,'W91CL, r, raw','UGC 00557',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11950,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11950,33.91,0.38,60.4,2254,75,NULL,'W91CL, r, inv','UGC 00557',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11951,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11951,33.99,0.4,62.8,2254,75,NULL,'HMCL, I, raw','UGC 00557',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11952,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11952,34.07,0.38,65.1,2254,75,NULL,'W91CL, r, cor','UGC 00557',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11953,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11953,34.07,0.4,65.2,2254,75,NULL,'HMCL, I, inv','UGC 00557',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11954,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11954,34.13,0.38,67.1,2254,75,NULL,'W91PP, r, raw','UGC 00557',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11955,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11955,34.16,0.38,67.9,2254,75,NULL,'W91PP, r, inv','UGC 00557',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11956,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11956,34.16,0.4,68,2254,75,NULL,'HMCL, I, cor','UGC 00557',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11957,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11957,34.25,0.38,70.7,2254,75,NULL,'W91PP, r, cor','UGC 00557',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11958,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11958,34.29,0.2,72.1,2254,74.4,NULL,NULL,'UGC 00557',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11959,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11959,34.46,0.43,78.1,2254,75,NULL,'3.6 micron, color corrected','UGC 00557',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11960,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11960,34.69,0.43,86.6,2254,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00557',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11961,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 08353','RN',11961,35.64,0.13,126,2255,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 08353',0.063763,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11962,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 03811',NULL,11962,40.52,1.07,1270,2256,70,NULL,'SN photometric redshift distance, z photo =0.358 +/- 0.341','SDSS-II SN 03811',NULL,'2011ApJ...738..162S',2011,1,0.03,NULL,'G',NULL,'PHOT','22.2g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,13.7045417,0.42961,0.073,NULL,66687485263,1041991957,16281124,22.2),(11963,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 03811','R',11963,41.68,0.34,1530,2256,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03811',0.419444,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11964,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 03811','R',11964,41.7,0.41,1540,2256,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03811',0.419444,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11965,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 03811',NULL,11965,41.54,0.27,2030,2256,70,NULL,'SALT 2','SDSS-II SN 03811',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11966,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 03811',NULL,11966,41.61,0.27,2100,2256,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 03811',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11967,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11967,34.16,0.2,67.9,2257,74.4,NULL,NULL,'UGC 00552',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000037,NULL,'14.6',0.6,'Scd:',NULL,NULL,NULL,NULL,1,13.704917,52.48011,1.477,NULL,65798534072,1028102094,16064095,14.6),(11968,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 02878','RN',11968,41.05,0.18,1150,2258,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02878',0.412104,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11969,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 02878','RN',11969,41.53,0.08,1430,2258,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 02878',0.412104,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11970,'IRAS','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11970,33.8,0.8,57.7,2259,75,NULL,'CF, r','UGC 00556',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000017,NULL,'15.12',0.5,'S?;HII         LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,13.7095,29.24664,0.169,NULL,67314587159,1051790424,16434225,15.12),(11971,'IRAS','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11971,33.81,0.8,57.8,2259,75,NULL,'W91PP, r','UGC 00556',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11972,'IRAS','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11972,33.82,0.8,57.9,2259,75,NULL,'W91CL, r','UGC 00556',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11973,'IRAS','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11973,33.82,0.8,58,2259,75,NULL,'HMCL, I','UGC 00556',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11974,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11974,34.04,0.4,64.4,2259,NULL,NULL,'mean','UGC 00556',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11975,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11975,34.05,0.43,64.6,2259,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00556',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11976,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11976,34.11,0.07,66.5,2259,NULL,NULL,NULL,'UGC 00556',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11977,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11977,34.39,0.45,75.5,2259,NULL,NULL,'K','UGC 00556',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11978,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11978,34.52,0.47,80.1,2259,NULL,NULL,'H','UGC 00556',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11979,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11979,34.58,0.43,82.5,2259,75,NULL,'3.6 micron, color corrected','UGC 00556',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11980,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11980,34.73,0.46,88.3,2259,NULL,NULL,'J','UGC 00556',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11981,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11981,34.99,0.4,99.5,2259,75,NULL,'HMCL, I, raw','UGC 00556',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11982,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11982,35.01,0.38,100,2259,75,NULL,'W91CL, r, raw','UGC 00556',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11983,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11983,35.01,0.38,101,2259,75,NULL,'W91PP, r, raw','UGC 00556',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11984,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11984,35.05,0.38,102,2259,75,NULL,'CF, r, raw','UGC 00556',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11985,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11985,35.16,0.2,108,2259,74.4,NULL,NULL,'UGC 00556',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11986,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11986,35.18,0.38,109,2259,75,NULL,'W91CL, r, inv','UGC 00556',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11987,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11987,35.19,0.4,109,2259,75,NULL,'HMCL, I, inv','UGC 00556',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11988,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11988,35.22,0.38,111,2259,75,NULL,'CF, r, inv','UGC 00556',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11989,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11989,35.22,0.38,111,2259,75,NULL,'W91PP, r, inv','UGC 00556',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11990,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11990,35.3,0.4,115,2259,75,NULL,'HMCL, I, cor','UGC 00556',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11991,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11991,35.31,0.38,115,2259,75,NULL,'W91PP, r, cor','UGC 00556',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11992,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11992,35.31,0.38,115,2259,75,NULL,'W91CL, r, cor','UGC 00556',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11993,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11993,35.35,0.38,117,2259,75,NULL,'CF, r, cor','UGC 00556',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11994,'GRB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11994,43.07,NULL,4120,2260,NULL,NULL,NULL,'GRB 050904',NULL,'2011MNRAS.410.1611C',2011,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,13.711833,14.08592,0.105,NULL,67594994926,1056171795,16502684,NULL),(11995,'GRB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11995,48.86,0.52,8110,2260,69.7,NULL,'Fiducial','GRB 050904',6.29,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11996,'GRB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11996,49.27,0.55,9800,2260,72,NULL,NULL,'GRB 050904',6.29,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11997,'GRB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11997,49.27,0.47,9800,2260,69.7,NULL,'Calibrated','GRB 050904',6.29,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11998,'GRB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,11998,49.34,0.53,10100,2260,70,NULL,NULL,'GRB 050904',6.29,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11999,'GRB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',11999,49.74,0.68,12200,2260,NULL,NULL,NULL,'GRB 050904',6.29,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12000,'GRB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12000,49.96,1.66,13500,2260,100,NULL,NULL,'GRB 050904',6.29,'2009EPJC...63..139W',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12001,'GRB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12001,50.24,1.61,15300,2260,69.7,NULL,'Fiducial','GRB 050904',6.29,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12002,'Brightest Stars','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12002,26,NULL,1.58,2261,NULL,NULL,NULL,'NGC 0300',NULL,'1998ApJ...497..650D',1998,1,21.9,NULL,'G',0.000003,NULL,'8.95',15.5,'SA(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,13.7228333333,-37.68439,NULL,0,38155393068,596178016,9315281,8.95),(12003,'Brightest Stars','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12003,26.32,NULL,1.84,2261,NULL,NULL,'Photographic','NGC 0300',NULL,'1993ApJ...415...10d',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12004,'Carbon Stars','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12004,25.87,0.39,1.49,2261,NULL,18.45,'16, I, M(I) = -4.75 mag','NGC 0300',NULL,'1985ApJ...298..240R',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12005,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12005,25.72,0.1,1.39,2261,NULL,NULL,NULL,'NGC 0300',NULL,'1989ApJ...346..629V',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12006,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12006,25.9,NULL,1.51,2261,NULL,NULL,NULL,'NGC 0300',NULL,'1985PASAu...6..140V',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12007,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12007,25.94,0.07,1.54,2261,NULL,18.47,'15, B, Photographic','NGC 0300',NULL,'1987SAAOC..11..125W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12008,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12008,26.02,0.08,1.6,2261,NULL,18.47,'14,V, Photographic','NGC 0300',NULL,'1987SAAOC..11..125W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12009,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12009,26.09,0.2,1.65,2261,NULL,18.56,'Photographic, 18, VB','NGC 0300',NULL,'1984AJ.....89.1332G',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12010,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12010,26.26,0.1,1.79,2261,NULL,NULL,'15, JHKs, GAL PL','NGC 0300',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12011,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12011,26.28,0.07,1.8,2261,NULL,NULL,'15, JHKs, LMC PL','NGC 0300',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12012,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12012,26.29,0.07,1.81,2261,NULL,NULL,'15, JHKs, GAL+LMC PL','NGC 0300',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12013,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12013,26.35,0.25,1.86,2261,NULL,18.55,'2, H, LMC ZP','NGC 0300',NULL,'1987ApJ...320...26M',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12014,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12014,26.36,0.29,1.87,2261,NULL,NULL,'MW HIPP','NGC 0300',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12015,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12015,26.36,0.05,1.87,2261,NULL,NULL,'16, K','NGC 0300',NULL,'2005ApJ...628..695G',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12016,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12016,26.37,0.05,1.87,2261,NULL,NULL,'16, J','NGC 0300',NULL,'2005ApJ...628..695G',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12017,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12017,26.36,0.05,1.87,2261,NULL,NULL,'16, V','NGC 0300',NULL,'2005ApJ...628..695G',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12018,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12018,26.37,0.28,1.88,2261,NULL,NULL,'JK(W)','NGC 0300',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12019,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12019,26.37,0.05,1.88,2261,NULL,NULL,'16, VIJK','NGC 0300',NULL,'2005ApJ...628..695G',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12020,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12020,26.39,0.05,1.9,2261,NULL,NULL,'16, I','NGC 0300',NULL,'2005ApJ...628..695G',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12021,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12021,26.4,0.2,1.91,2261,NULL,NULL,'18, V','NGC 0300',NULL,'1988PASP..100..949W',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12022,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12022,26.43,0.04,1.93,2261,NULL,NULL,'58, VI(W)','NGC 0300',NULL,'2004AJ....128.1167G',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12023,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12023,26.43,0.07,1.93,2261,NULL,NULL,'16, V','NGC 0300',NULL,'2005ApJ...634.1020B',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12024,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12024,26.45,0.32,1.95,2261,NULL,NULL,'MW P02','NGC 0300',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12025,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12025,26.48,0.29,1.98,2261,NULL,NULL,'VI(W)','NGC 0300',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12026,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12026,26.48,0.03,1.98,2261,NULL,18.54,'LMC ZP','NGC 0300',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12027,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12027,26.48,0.06,1.98,2261,74.4,NULL,NULL,'NGC 0300',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12028,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12028,26.5,0.07,2,2261,NULL,NULL,'14, VI, +Z, KEY PROJECT','NGC 0300',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12029,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12029,26.52,0.03,2.01,2261,NULL,NULL,'13, BVRI','NGC 0300',NULL,'1997ApJ...491...13K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12030,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12030,26.53,0.07,2.02,2261,NULL,NULL,'14, VI, KEY PROJECT','NGC 0300',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12031,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12031,26.53,0.05,2.02,2261,NULL,NULL,'LMC VIHJK','NGC 0300',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12032,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12032,26.54,0.29,2.03,2261,NULL,NULL,'MW GFG','NGC 0300',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12033,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12033,26.54,0.29,2.03,2261,NULL,NULL,'4, VI','NGC 0300',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12034,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12034,26.55,0.12,2.04,2261,NULL,NULL,'LMC W01','NGC 0300',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12035,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12035,26.55,NULL,2.04,2261,NULL,NULL,'Photographic, APPARENT BLUE m-M','NGC 0300',NULL,'1988PASP..100..935S',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12036,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12036,26.64,0.32,2.13,2261,NULL,NULL,'BV(W)','NGC 0300',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12037,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12037,26.66,0.1,2.15,2261,NULL,NULL,'HST KP Calibrated','NGC 0300',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12038,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12038,26.66,0.1,2.15,2261,NULL,NULL,'16, BVRI','NGC 0300',NULL,'1992ApJ...396...80F',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12039,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12039,26.67,NULL,2.16,2261,NULL,NULL,'16, BVRI','NGC 0300',NULL,'1991PASP..103..933M',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12040,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12040,26.86,0.04,2.36,2261,NULL,NULL,'BVRI','NGC 0300',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12041,'Cepheids','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12041,27.2,0.04,2.75,2261,NULL,NULL,'BVRI+','NGC 0300',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12042,'CMD','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12042,26.55,NULL,2.04,2261,NULL,NULL,NULL,'NGC 0300',NULL,'2012ApJ...748...47M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12043,'GCLF','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12043,26.68,0.14,2.17,2261,NULL,NULL,'J M31 GCLF','NGC 0300',NULL,'2006AJ....131.1416N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12044,'GCLF','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12044,26.71,0.14,2.2,2261,NULL,NULL,'H M31 GCLF','NGC 0300',NULL,'2006AJ....131.1416N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12045,'GCLF','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12045,26.89,0.14,2.39,2261,NULL,NULL,'K M31 GCLF','NGC 0300',NULL,'2006AJ....131.1416N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12046,'PNLF','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12046,25.85,0.34,1.48,2261,NULL,NULL,NULL,'NGC 0300',NULL,'1983BAAS...15..907L',1983,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12047,'PNLF','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12047,26.29,0.22,1.81,2261,NULL,NULL,NULL,'NGC 0300',NULL,'2012A&A...547A..78P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12048,'PNLF','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12048,26.49,0.2,1.99,2261,NULL,NULL,'66, central','NGC 0300',NULL,'2011RMxAC..40..200R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12049,'PNLF','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12049,26.82,0.2,2.31,2261,NULL,NULL,'33, outer','NGC 0300',NULL,'2011RMxAC..40..200R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12050,'PNLF','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12050,26.9,0.4,2.4,2261,NULL,NULL,'34 PNe','NGC 0300',NULL,'1996A&A...306....9S',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12051,'PNLF','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12051,26.93,0.41,2.43,2261,NULL,NULL,'HST KP Calibrated','NGC 0300',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12052,'Red Clump','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12052,26.43,0.09,1.93,2261,NULL,NULL,NULL,'NGC 0300',NULL,'2010ApJ...712..858G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12053,'TRGB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12053,25.8,0.5,1.45,2261,NULL,NULL,'Photographic, V','NGC 0300',NULL,'1982ApJ...252..474G',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12054,'TRGB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12054,26.3,0.03,1.82,2261,NULL,NULL,'edge detection','NGC 0300',NULL,'2006ApJ...638..766R',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12055,'TRGB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12055,26.36,0.02,1.87,2261,NULL,NULL,'max likelihood','NGC 0300',NULL,'2006ApJ...638..766R',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12056,'TRGB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12056,26.42,0.03,1.92,2261,NULL,NULL,'I','NGC 0300',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12057,'TRGB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12057,26.44,0.03,1.94,2261,NULL,NULL,'I','NGC 0300',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12058,'TRGB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12058,26.48,0.04,1.98,2261,NULL,NULL,'I','NGC 0300',NULL,'2007ApJ...661..815R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12059,'TRGB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12059,26.49,0.08,1.98,2261,NULL,NULL,'I','NGC 0300',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12060,'TRGB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12060,26.48,0.06,1.98,2261,74.4,NULL,NULL,'NGC 0300',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12061,'TRGB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12061,26.5,0.15,2,2261,NULL,NULL,'VI','NGC 0300',NULL,'2005A&A...431..127T',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12062,'TRGB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12062,26.52,0.03,2.01,2261,NULL,NULL,'I','NGC 0300',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12063,'TRGB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12063,26.53,0.03,2.02,2261,NULL,NULL,'I','NGC 0300',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12064,'TRGB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12064,26.53,0.05,2.02,2261,NULL,NULL,'I','NGC 0300',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12065,'TRGB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12065,26.54,0.03,2.04,2261,NULL,NULL,NULL,'NGC 0300',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12066,'TRGB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12066,26.56,0.07,2.05,2261,NULL,NULL,NULL,'NGC 0300',NULL,'2004AJ....127.1472B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12067,'TRGB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12067,26.59,0.06,2.08,2261,NULL,NULL,'I','NGC 0300',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12068,'TRGB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12068,26.65,0.07,2.14,2261,NULL,NULL,NULL,'NGC 0300',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12069,'HII region diameter','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12069,27.13,NULL,2.67,2261,NULL,NULL,'Photographic','NGC 0300',NULL,'1981AN....302..251I',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12070,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12070,25.42,0.4,1.2,2261,75,NULL,'B','NGC 0300',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12071,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12071,26.81,0.31,2.3,2261,NULL,NULL,'I','NGC 0300',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12072,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12072,26.94,0.35,2.44,2261,NULL,NULL,NULL,'NGC 0300',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12073,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12073,27.04,NULL,2.56,2261,NULL,NULL,'LEDA [April 2006]','NGC 0300',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12074,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12074,27.12,0.62,2.65,2261,NULL,NULL,'B','NGC 0300',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12075,'GRB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12075,43.6,0.5,3070,2262,72,NULL,NULL,'XRGRB 041006',0.71,'2008JCAP...07..004M',2008,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,13.708333,1.12056,0.041,NULL,66688157192,1042002456,16281288,NULL),(12076,'GRB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12076,43.91,0.45,3540,2262,70,NULL,NULL,'XRGRB 041006',0.71,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12077,'GRB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12077,43.92,0.42,3560,2262,69.7,NULL,'Calibrated','XRGRB 041006',0.71,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12078,'GRB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12078,44.03,0.5,3740,2262,69.7,NULL,'Fiducial','XRGRB 041006',0.71,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12079,'GRB','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12079,44.32,0.88,4280,2262,72,NULL,NULL,'XRGRB 041006',0.71,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12080,'Quasar spectrum','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12080,42.73,NULL,3520,2263,NULL,NULL,NULL,'LBQS 0052-0058',NULL,'2002A&A...381L..57D',2002,1,NULL,NULL,'QSO',0.000283,NULL,'18.2g',NULL,'Candidate      QSO',NULL,NULL,NULL,'QSO',1,13.7285,-0.71225,0.118,NULL,34524446868,539444482,8428820,18.2),(12081,'BL Lac Luminosity','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12081,38.42,NULL,483,2264,NULL,NULL,'Min. z = 0.12','1FGL J0054.9-2455',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,13.734,-24.929,0.071,NULL,34712555516,542383679,8474744,NULL),(12082,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12082,36.86,0.63,236,2265,70,NULL,NULL,'NGC 0297',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'17.27',0.29,'cE3: pec?',NULL,NULL,NULL,NULL,1,13.7455833333,-7.34967,0.234,NULL,34543626222,539744159,8433502,17.27),(12083,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12083,32.18,0.43,27.3,2266,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0298',NULL,'2014MNRAS.444..527S',2014,1,1.7,NULL,'G',0.00001,NULL,'14.52',0.4,'Scd: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,13.7597917,-7.33308,0.234,NULL,34543625623,539744150,8433502,14.52),(12084,'IRAS','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12084,34.57,0.8,82.2,2267,75,NULL,'MAT, I','ESO 541- G 001',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.00002,NULL,'13.93',1.3,'SB(rs)bc       Sy2',NULL,NULL,NULL,NULL,1,13.7631666667,-19.00594,0.052,NULL,35394848063,553044500,8641320,13.93),(12085,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12085,33.96,0.32,61.9,2267,85,NULL,'I, raw','ESO 541- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12086,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12086,34.02,0.32,63.6,2267,85,NULL,'I, inv','ESO 541- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12087,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12087,34.09,0.43,65.7,2267,75,NULL,'MAT, I, raw','ESO 541- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12088,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12088,34.19,NULL,68.9,2267,NULL,NULL,'I','ESO 541- G 001',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12089,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12089,34.27,NULL,71.5,2267,NULL,NULL,'B','ESO 541- G 001',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12090,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12090,34.36,0.43,74.6,2267,75,NULL,'MAT, I, inv','ESO 541- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12091,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12091,34.4,0.47,75.8,2267,NULL,NULL,'H','ESO 541- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12092,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12092,34.45,0.46,77.5,2267,NULL,NULL,'J','ESO 541- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12093,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12093,34.45,0.43,77.5,2267,75,NULL,'MAT, I, cor','ESO 541- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12094,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12094,34.46,0.45,78.1,2267,NULL,NULL,'K','ESO 541- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12095,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12095,34.6,0.4,83.1,2267,NULL,NULL,'mean','ESO 541- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12096,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12096,34.66,0.2,85.5,2267,74.4,NULL,NULL,'ESO 541- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12097,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12097,34.7,0.28,87,2267,NULL,NULL,NULL,'ESO 541- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12098,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12098,34.71,0.28,87.3,2267,NULL,NULL,'Malmquist cor.','ESO 541- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12099,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12099,37.46,0.46,310,2268,70,NULL,NULL,'2MASX J00550441-1058404',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000075,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,13.7682917,-10.978,0.171,NULL,35252721096,550823767,8606621,17.3),(12100,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12100,36.4,0.33,191,2269,70,NULL,NULL,'2MASX J00550726+0057039',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000099,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,13.7802083,0.95111,0.069,NULL,66688277230,1042004331,16281317,17.3),(12101,'IRAS','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12101,34.33,0.8,73.4,2270,75,NULL,'HMCL, I','NGC 0296',NULL,'1997ApJS..109..333W',1997,1,2.2,'Misidentified as NGC 0295 in MCG, CGCG, and UGC.','G',0.000023,NULL,'13.39',1,'SBb:','Group member',NULL,NULL,NULL,1,13.7812916667,31.54228,0.193,NULL,67337123174,1052142549,16439727,13.39),(12102,'IRAS','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12102,34.33,0.8,73.4,2270,75,NULL,'W91PP, r','NGC 0296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12103,'IRAS','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12103,34.34,0.8,73.8,2270,75,NULL,'W91CL, r','NGC 0296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12104,'IRAS','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12104,34.34,0.8,73.9,2270,75,NULL,'CF, r','NGC 0296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12105,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12105,33.2,NULL,43.7,2270,NULL,NULL,'B','NGC 0296',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12106,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12106,33.27,0.38,45.1,2270,75,NULL,'W91CL, r, raw','NGC 0296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12107,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12107,33.3,0.38,45.8,2270,75,NULL,'W91PP, r, raw','NGC 0296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12108,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12108,33.31,NULL,45.9,2270,NULL,NULL,'B','NGC 0296',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12109,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12109,33.35,0.47,46.9,2270,NULL,NULL,'H','NGC 0296',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12110,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12110,33.35,0.45,46.9,2270,NULL,NULL,'K','NGC 0296',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12111,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12111,33.37,0.38,47.1,2270,75,NULL,'CF, r, raw','NGC 0296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12112,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12112,33.41,0.46,48,2270,NULL,NULL,'J','NGC 0296',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12113,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12113,33.44,NULL,48.8,2270,NULL,NULL,'I','NGC 0296',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12114,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12114,33.45,0.38,49,2270,75,NULL,'W91CL, r, inv','NGC 0296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12115,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12115,33.48,0.4,49.8,2270,75,NULL,'HMCL, I, raw','NGC 0296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12116,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12116,33.52,NULL,50.6,2270,NULL,NULL,'I','NGC 0296',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12117,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12117,33.53,0.38,50.7,2270,75,NULL,'W91PP, r, inv','NGC 0296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12118,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12118,33.54,0.38,51.1,2270,75,NULL,'CF, r, inv','NGC 0296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12119,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12119,33.67,0.43,54.1,2270,75,NULL,'3.6 micron, color corrected','NGC 0296',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12120,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12120,33.7,0.49,54.9,2270,75,NULL,'IR','NGC 0296',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12121,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12121,33.71,0.4,55.2,2270,75,NULL,'HMCL, I, inv','NGC 0296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12122,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12122,33.72,0.2,55.5,2270,74.4,NULL,NULL,'NGC 0296',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12123,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12123,33.72,0.43,55.5,2270,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0296',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12124,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12124,33.73,0.38,55.7,2270,75,NULL,'W91CL, r, cor','NGC 0296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12125,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12125,33.76,0.38,56.5,2270,75,NULL,'W91PP, r, cor','NGC 0296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12126,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12126,33.79,0.38,57.4,2270,75,NULL,'CF, r, cor','NGC 0296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12127,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12127,33.88,0.4,59.6,2270,75,NULL,'HMCL, I, cor','NGC 0296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12128,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12128,34.39,0.4,75.5,2270,NULL,NULL,'mean','NGC 0296',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12129,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12129,34.51,0.08,80,2270,NULL,NULL,NULL,'NGC 0296',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12130,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12130,36.45,0.07,195,2271,70,NULL,NULL,'UGC 00568',NULL,'2015arXiv151105856S',2015,1,1.3,NULL,'G',0.000053,NULL,'14.29',0.9,'Sd','Group member',NULL,NULL,NULL,1,13.787333,-1.04647,0.207,NULL,34524971748,539452683,8428948,14.29),(12131,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 10649','RN',12131,42.12,0.22,2540,2272,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10649',0.04571,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12132,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12132,37.78,0.46,360,2273,70,NULL,NULL,'2MASX J00550944+1512435',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000076,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,13.7892917,15.21211,0.169,NULL,67589828151,1056091064,16501422,18.2),(12133,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 18048','RN',12133,40.42,0.1,1090,2274,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18048',0.114897,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12134,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 18048','RN',12134,40.57,0.2,1170,2274,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18048',0.114897,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12135,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 03987','RN',12135,39.54,0.35,718,2275,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 03987',0.123949,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12136,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 03987','RN',12136,40.05,0.36,911,2275,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 03987',0.123949,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12137,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12137,36.08,0.42,165,2276,NULL,NULL,'Malmquist cor.','CGCG 384-029',NULL,'2009ApJS..182..474S',2009,1,0.83,NULL,'G',0.00005,NULL,'16.0g',0.24,'Sb(f)','Group member',NULL,NULL,NULL,1,13.80675,-1.07603,0.207,NULL,34525088046,539454500,8428976,16),(12138,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12138,36.17,0.4,171,2276,NULL,NULL,NULL,'CGCG 384-029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12139,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12139,36.21,0.2,175,2276,74.4,NULL,NULL,'CGCG 384-029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12140,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 01543','RN',12140,42.62,0.21,2290,2277,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01543',0.459079,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12141,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 12996','RN',12141,41.86,0.1,1750,2278,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 12996',0.345253,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12142,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 12996','RN',12142,41.95,0.19,1820,2278,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 12996',0.345253,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12143,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12143,36.45,0.07,195,2279,70,NULL,NULL,'2MASX J00551612+0005426',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000067,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,13.81725,0.09506,0.062,NULL,66673768569,1041777633,16277775,16.9),(12144,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 03900','RN',12144,39.2,0.21,662,2280,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03900',0.043401,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12145,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 03900','RN',12145,40.39,0.3,1150,2280,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03900',0.043401,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12146,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12146,36.14,0.54,169,2281,70,NULL,NULL,'MCG +00-03-027',NULL,'2014MNRAS.445.2677S',2014,1,1.01,NULL,'G',0.000078,NULL,'15.6g',0.24,'Sb(f)','Group member',NULL,NULL,NULL,1,13.820333,-0.91794,0.118,NULL,34525261944,539457217,8429019,15.6),(12147,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 04490','RN',12147,41.51,0.45,1340,2282,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 04490',0.496252,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12148,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 04490','N',12148,41.58,0.51,2070,2282,70,NULL,'SALT 2','SDSS-II SN 04490',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12149,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 04490','N',12149,41.71,0.51,2200,2282,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 04490',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12150,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12150,35.92,0.25,153,2283,74.4,NULL,NULL,'CGCG 384-028',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000067,NULL,'14.65',0.72,'E','Group member',NULL,NULL,NULL,1,13.8285417,-1.27714,0.207,NULL,34525113152,539454893,8428982,14.65),(12151,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12151,36.09,0.15,165,2283,70,NULL,NULL,'CGCG 384-028',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12152,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12152,35.9,0.25,151,2284,74.4,NULL,NULL,'GIN 024',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000053,NULL,'14.93',0.5,'S0/a','Group member',NULL,NULL,NULL,1,13.839083,-1.35233,0.073,NULL,34525103359,539454739,8428980,14.93),(12153,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12153,36.09,0.15,165,2284,70,NULL,NULL,'GIN 024',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12154,'IRAS','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12154,34.42,0.8,76.4,2285,75,NULL,'HMCL, I','UGC 00565',NULL,'1997ApJS..109..333W',1997,1,1.1,'Misidentified as NGC 0296 in CGCG and UGC.','G',0.000023,NULL,'15.7',0.3,'Scd:','Group member',NULL,NULL,NULL,1,13.8397917,31.67725,0.221,NULL,67337094301,1052142098,16439720,15.7),(12155,'IRAS','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12155,34.42,0.8,76.4,2285,75,NULL,'W91PP, r','UGC 00565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12156,'IRAS','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12156,34.43,0.8,76.7,2285,75,NULL,'W91CL, r','UGC 00565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12157,'IRAS','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12157,34.43,0.8,76.8,2285,75,NULL,'CF, r','UGC 00565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12158,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12158,33.43,0.43,48.5,2285,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00565',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12159,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12159,33.5,0.43,50.2,2285,75,NULL,'3.6 micron, color corrected','UGC 00565',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12160,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12160,33.56,0.38,51.4,2285,75,NULL,'W91PP, r, inv','UGC 00565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12161,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12161,33.56,0.2,51.5,2285,74.4,NULL,NULL,'UGC 00565',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12162,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12162,33.59,0.38,52.2,2285,75,NULL,'W91PP, r, raw','UGC 00565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12163,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12163,33.62,0.38,52.9,2285,75,NULL,'W91CL, r, raw','UGC 00565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12164,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12164,33.63,0.38,53.2,2285,75,NULL,'W91CL, r, inv','UGC 00565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12165,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12165,33.7,0.38,54.9,2285,75,NULL,'CF, r, raw','UGC 00565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12166,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12166,33.71,0.38,55.3,2285,75,NULL,'CF, r, inv','UGC 00565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12167,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12167,33.76,0.4,56.6,2285,75,NULL,'HMCL, I, raw','UGC 00565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12168,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12168,33.83,0.4,58.3,2285,75,NULL,'HMCL, I, inv','UGC 00565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12169,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12169,33.91,0.38,60.6,2285,75,NULL,'W91PP, r, cor','UGC 00565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12170,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12170,33.92,0.38,60.8,2285,75,NULL,'W91CL, r, cor','UGC 00565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12171,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12171,33.97,0.38,62.3,2285,75,NULL,'CF, r, cor','UGC 00565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12172,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12172,34.03,0.4,63.9,2285,75,NULL,'HMCL, I, cor','UGC 00565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12173,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12173,34.42,0.11,76.7,2285,NULL,NULL,NULL,'UGC 00565',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12174,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 18747',NULL,12174,41.48,0.11,1980,2286,70,NULL,'SN photometric redshift distance, z photo =0.649 +/- 0.051','SDSS-II SN 18747',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,13.8435417,0.23878,0.068,NULL,66687375865,1041990247,16281097,NULL),(12175,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 18747',NULL,12175,41.83,0.36,2320,2286,70,NULL,'SALT 2','SDSS-II SN 18747',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12176,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 18747',NULL,12176,41.97,0.36,2480,2286,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18747',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12177,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SN 2006nc',NULL,12177,38.42,0.17,483,2287,70,NULL,'SDSS-II SN 16021','SDSS J005522.52-002321.1',NULL,'2013MNRAS.434.1443X',2013,1,0.16,NULL,'G',NULL,NULL,'19.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,13.843875,-0.38922,0.085,NULL,34524606461,539446975,8428858,19.1),(12178,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 16021','R',12178,38.75,0.18,502,2287,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006nc','SDSS J005522.52-002321.1',0.12,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12179,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SN 2006nc',NULL,12179,38.65,0.06,537,2287,70,NULL,'SALT 2','SDSS J005522.52-002321.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12180,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SN 2006nc',NULL,12180,38.65,0.06,537,2287,70,NULL,'SALT 2, Malmquist cor.','SDSS J005522.52-002321.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12181,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 16021','R',12181,38.93,0.08,545,2287,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006nc','SDSS J005522.52-002321.1',0.12,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12182,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 15418',NULL,12182,40.55,0.16,1290,2288,70,NULL,'SN photometric redshift distance, z photo =0.365 +/- 0.035','SDSS-II SN 15418',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,13.846417,1.01281,0.049,NULL,66687777364,1041996521,16281195,NULL),(12183,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 15418',NULL,12183,41.2,0.17,1740,2288,70,NULL,'SALT 2','SDSS-II SN 15418',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12184,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 15418',NULL,12184,41.25,0.17,1780,2288,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15418',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12185,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12185,36.89,0.33,239,2289,70,NULL,NULL,'2MASX J00552573-1057024',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000089,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,13.8571666667,-10.95067,0.144,NULL,35252676011,550823062,8606610,16.5),(12186,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 10934','RN',12186,39.09,0.2,630,2290,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10934',0.044772,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12187,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 10934','RN',12187,40.52,0.27,1210,2290,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10934',0.044772,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12188,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12188,37.48,0.46,313,2291,70,NULL,NULL,'2MASX J00552621+0036212',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000091,NULL,'16.4g',0.4,NULL,NULL,NULL,NULL,NULL,1,13.859375,0.60594,0.118,NULL,66687425318,1041991020,16281109,16.4),(12189,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12189,37.49,0.46,315,2292,70,NULL,NULL,'SDSS J005526.99-102119.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00007,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,13.8625,-10.35531,0.159,NULL,35253034123,550828658,8606697,18.4),(12190,'SNIa','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 08576',NULL,12190,41.27,0.26,1800,2293,70,NULL,'SN photometric redshift distance, z photo =0.564 +/- 0.109','SDSS-II SN 08576',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'G',NULL,'PHOT','22.4g',NULL,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,13.86575,-0.16181,0.062,NULL,34512887112,539263861,8425997,22.4),(12191,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12191,36.89,0.33,239,2294,70,NULL,NULL,'MCG -02-03-044',NULL,'2015arXiv151105856S',2015,1,0.7,'6dF DR2 has z = -0.000139, probably for the superposed star.','G',0.000107,NULL,'15.4g',0.56,'BrClG',NULL,NULL,NULL,NULL,1,13.870583,-10.93858,0.144,NULL,35252680517,550823133,8606611,15.4),(12192,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12192,37.19,0.46,274,2295,70,NULL,NULL,'2MASX J00552898-0917344',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000118,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,13.870833,-9.29283,0.197,NULL,35251108496,550798570,8606227,16.4),(12193,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12193,37.42,0.58,305,2295,70,NULL,NULL,'2MASX J00552898-0917344',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12194,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12194,37.47,0.46,312,2296,70,NULL,NULL,'2MASX J00553046+1450397',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00007,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,13.8770416667,14.8445,0.169,NULL,67589685919,1056088842,16501388,17.8),(12195,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12195,36.45,0.07,195,2297,70,NULL,NULL,'ZwCl 0054.6-0127 07',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000097,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,13.882583,-0.53022,0.076,NULL,34524619465,539447179,8428862,16.5),(12196,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12196,36.95,0.12,245,2298,70,NULL,NULL,'2MASX J00553247-0956267',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000108,NULL,'16.2g',0.42,'AGN',NULL,NULL,'NAT',NULL,1,13.8852083333,-9.94069,0.14,NULL,35251826639,550809791,8606402,16.2),(12197,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12197,34.63,0.44,84.3,2299,NULL,NULL,'Malmquist cor.','CGCG 501-047',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000023,NULL,'15.7',0.35,'Sc',NULL,NULL,NULL,NULL,1,13.886417,30.39817,0.209,NULL,67336339043,1052130297,16439535,15.7),(12198,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12198,34.69,0.2,86.7,2299,74.4,NULL,NULL,'CGCG 501-047',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12199,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12199,34.73,0.43,88.5,2299,75,NULL,'3.6 micron, color corrected','CGCG 501-047',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12200,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12200,34.81,0.41,91.7,2299,NULL,NULL,NULL,'CGCG 501-047',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12201,'Tully-Fisher','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12201,34.84,0.43,93,2299,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 501-047',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12202,'Sosies','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12202,35.45,0.16,123,2300,NULL,NULL,NULL,'IC 1601',NULL,'2002A&A...393...57T',2002,1,0.9,'Theureau, et al. (1998,A&AS,130,333) give v = 3717 +/- 49 km/sec.','G',0.000107,NULL,'14.21',0.4,'S?',NULL,NULL,NULL,NULL,1,13.895167,-24.15339,0.042,NULL,34712975210,542390237,8474847,14.21),(12203,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12203,36.95,0.12,245,2301,70,NULL,NULL,'2MASX J00553565-0957198',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000094,NULL,'17.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,13.898667,-9.95547,0.14,NULL,35251823873,550809748,8606402,17.6),(12204,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12204,35.31,0.51,116,2302,70,NULL,NULL,'AM 0052-603 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000113,NULL,'15.45',0.58,'S0',NULL,NULL,NULL,NULL,1,13.898875,-60.30211,0,NULL,36180938652,565327166,8833236,15.45),(12205,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12205,35.65,0.61,135,2303,70,NULL,NULL,'2MASX J00553669-6344108',NULL,'2014MNRAS.445.2677S',2014,1,0.93,NULL,'G',0.00015,NULL,'16.27',0.23,'S',NULL,NULL,NULL,NULL,1,13.903167,-63.73631,0,NULL,36065642988,563525671,8805088,16.27),(12206,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 14553','RN',12206,42.39,0.4,2440,2304,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 14553',0.233133,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12207,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 14553','RN',12207,42.49,0.4,2550,2304,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 14553',0.233133,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12208,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12208,37.31,0.6,290,2305,70,NULL,NULL,'2MASX J00553821-0134467',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.000103,NULL,'16.67',0.39,'E','Group member',NULL,NULL,NULL,1,13.909167,-1.57961,0.124,NULL,34527042787,539485043,8429453,16.67),(12209,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12209,37.62,0.46,334,2306,70,NULL,NULL,'2MASX J00554056-0856438',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000074,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,13.919,-8.9455,0.191,NULL,34528760318,539511879,8429873,17.2),(12210,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12210,35.91,0.25,152,2307,74.4,NULL,NULL,'GIN 018',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.00004,NULL,'14.52',0.6,'Sa','Group member',NULL,NULL,NULL,1,13.9195,-1.31211,0.073,NULL,34524933539,539452086,8428938,14.52),(12211,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,NULL,12211,36.09,0.15,165,2307,70,NULL,NULL,'GIN 018',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12212,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12212,36.95,0.12,245,2308,70,NULL,NULL,'2MASX J00554114-0953498',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.0001,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,13.9214583,-9.89714,0.14,NULL,35251869670,550810463,8606413,17.6),(12213,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12213,38.32,0.46,462,2309,70,NULL,NULL,'2MASX J00554259+1503330',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000099,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,13.9274583,15.05919,0.169,NULL,67589890262,1056092035,16501438,17.4),(12214,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12214,36.95,0.12,245,2310,70,NULL,NULL,'2MASX J00554268-1017328',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000099,NULL,'16.2g',0.36,'E0',NULL,NULL,NULL,NULL,1,13.927917,-10.29256,0.159,NULL,35252167282,550815113,8606486,16.2),(12215,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 14879','RN',12215,39.46,0.26,680,2311,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 14879',0.145825,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12216,'SNIa SDSS','2016-12-15 15:13:41','2016-12-16 11:18:43','1','SDSS-II SN 14879','RN',12216,40.17,0.3,943,2311,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 14879',0.145825,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12217,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12217,37.54,0.19,322,2312,70,NULL,NULL,'2MASX J00554634+0038422',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000107,NULL,'16.63',0.7,'BrClG',NULL,NULL,NULL,NULL,1,13.9432917,0.64506,0.118,NULL,66687462578,1041991602,16281118,16.63),(12218,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12218,38.1,0.23,416,2313,70,NULL,NULL,'SDSS J005548.37-094335.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000082,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,13.9515417,-9.72661,0.175,NULL,35251857126,550810267,8606410,18.7),(12219,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12219,38.1,0.23,416,2314,70,NULL,NULL,'2MASX J00555095-0938388',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000077,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,13.9622917,-9.64406,0.175,NULL,35252040026,550813125,8606455,17.9),(12220,'FP','2016-12-15 15:13:41','2016-12-16 11:18:43','1',NULL,'R',12220,36.45,0.07,195,2315,70,NULL,NULL,'2MASX J00555116-0109527',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00006,NULL,'15.70',0.3,'Sa','Group member',NULL,NULL,NULL,1,13.9630417,-1.16472,0.207,NULL,34525131160,539455174,8428987,15.7),(12221,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12221,37.54,0.19,322,2316,70,NULL,NULL,'2MASX J00555139+0047083',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00014,NULL,'16.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,13.964167,0.78556,0.087,NULL,66688269635,1042004213,16281315,16.5),(12222,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12222,36.95,0.12,245,2317,70,NULL,NULL,'IC 1602',NULL,'2015arXiv151105856S',2015,1,0.99,NULL,'G',0.00003,NULL,'14.6g',0.79,'BrClG',NULL,NULL,NULL,NULL,1,13.9662083,-9.98567,0.14,NULL,35251820738,550809699,8606401,14.6),(12223,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12223,36.95,0.12,245,2318,70,NULL,NULL,'2MASX J00555190-1004278',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000112,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,13.966375,-10.07442,0.14,NULL,35251684750,550807574,8606368,16.4),(12224,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SDSS-II SN 03818','R',12224,39.54,0.2,770,2319,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2005gi','SN 2005gi',0.050534,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'II',NULL,NULL,NULL,NULL,1,13.9695,0.50494,0.085,NULL,66687446985,1041991359,16281114,NULL),(12225,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12225,36.95,0.12,245,2320,70,NULL,NULL,'2MASX J00555291-0948498',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00008,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,13.9705,-9.81392,0.14,NULL,35251865054,550810391,8606412,17),(12226,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12226,36.65,0.56,213,2321,70,NULL,NULL,'MCPS J00.931813-74.37646',NULL,'2014MNRAS.445.2677S',2014,1,NULL,'Within boundaries of SMC.','G',0.00015,NULL,'16.6b',NULL,'Background object',NULL,NULL,NULL,NULL,1,13.97725,-74.37664,0.069,NULL,35634781281,556793457,8699897,16.6),(12227,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12227,37.26,0.46,284,2322,70,NULL,NULL,'SDSS J005554.78+134916.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000064,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,13.9782917,13.82114,0.121,NULL,67595384982,1056177890,16502779,18.3),(12228,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12228,36.95,0.12,245,2323,70,NULL,NULL,'2MASX J00555691-0956128',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000073,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,13.9870417,-9.93697,0.14,NULL,35251822354,550809724,8606401,18),(12229,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12229,37.36,0.46,296,2324,70,NULL,NULL,'SDSS J005557.37+140101.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000043,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,13.9890417,14.01717,0.121,NULL,67595056130,1056172752,16502699,18.2),(12230,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12230,37.54,0.19,322,2325,70,NULL,NULL,'SDSS J005600.60+003442.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000064,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,14.0025417,0.57856,0.115,NULL,66687458311,1041991536,16281117,18.4),(12231,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12231,36.45,0.07,195,2326,70,NULL,NULL,'2MASX J00560187+0015133',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000084,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,14.0077083,0.25367,0.073,NULL,66687364006,1041990062,16281094,16.9),(12232,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12232,35.91,0.25,152,2327,74.4,NULL,NULL,'CGCG 384-032',NULL,'2013AJ....146...86T',2013,1,0.9,'Component of 4C -01.04, as identified by PKSCAT90 (version 1.01).','G',0.000047,NULL,'14.22',0.7,'E','Group member',NULL,'NAT',NULL,1,14.01125,-1.33431,0.073,NULL,34524951403,539452365,8428943,14.22),(12233,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12233,36.09,0.15,165,2327,70,NULL,NULL,'CGCG 384-032',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12234,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12234,35.89,0.75,151,2328,70,NULL,NULL,'MCG -02-03-048',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16',0.6,NULL,NULL,NULL,NULL,NULL,1,14.0165416667,-14.06053,0.011,NULL,35382451547,552850805,8638293,16),(12235,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12235,37.37,0.46,298,2329,70,NULL,NULL,'SDSS J005604.59-092446.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000075,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,14.019167,-9.41283,0.175,NULL,35251991196,550812362,8606443,18.2),(12236,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12236,37.53,0.23,321,2330,70,NULL,NULL,'2MASX J00560635+1508243',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,14.0267083,15.13997,0.149,NULL,67589814882,1056090857,16501419,18),(12237,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SDSS-II SN 20847','RN',12237,40.5,0.27,1080,2331,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 20847',0.166819,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12238,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SDSS-II SN 20847','RN',12238,41.35,0.27,1590,2331,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 20847',0.166819,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12239,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12239,38.27,0.27,451,2332,70,NULL,NULL,'2MASX J00560770-0036347',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000088,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,14.032167,-0.60967,0.076,NULL,34524501995,539445343,8428833,17.7),(12240,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12240,38.1,0.23,416,2333,70,NULL,NULL,'2MASX J00560777-0935549',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000099,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,14.032417,-9.59853,0.175,NULL,35252069777,550813590,8606462,17.7),(12241,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12241,37.54,0.19,322,2334,70,NULL,NULL,'2MASX J00560926+0041133',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000113,NULL,'17.12',0.39,NULL,NULL,NULL,NULL,NULL,1,14.038583,0.68703,0.087,NULL,66687403517,1041990679,16281104,17.12),(12242,'IRAS','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12242,33.84,0.8,58.5,2335,75,NULL,'HMCL, I','UGC 00575',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'15.6',0.1,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,14.039,31.07347,0.181,NULL,67339088053,1052173250,16440207,15.6),(12243,'IRAS','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12243,33.84,0.8,58.7,2335,75,NULL,'W91CL, r','UGC 00575',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12244,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12244,33.97,0.15,62.4,2335,NULL,NULL,NULL,'UGC 00575',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12245,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12245,34.05,0.4,64.5,2335,75,NULL,'HMCL, I, raw','UGC 00575',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12246,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12246,34.06,0.43,64.8,2335,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00575',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12247,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12247,34.11,0.49,66.4,2335,75,NULL,'IR','UGC 00575',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12248,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12248,34.13,0.38,66.9,2335,75,NULL,'W91CL, r, raw','UGC 00575',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12249,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12249,34.13,0.43,67.1,2335,75,NULL,'3.6 micron, color corrected','UGC 00575',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12250,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12250,34.15,0.4,67.5,2335,75,NULL,'HMCL, I, inv','UGC 00575',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12251,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12251,34.18,0.38,68.4,2335,75,NULL,'W91CL, r, inv','UGC 00575',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12252,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12252,34.2,0.4,69.2,2335,75,NULL,'HMCL, I, cor','UGC 00575',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12253,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12253,34.23,0.2,70.2,2335,74.4,NULL,NULL,'UGC 00575',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12254,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12254,34.24,0.38,70.4,2335,75,NULL,'W91CL, r, cor','UGC 00575',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12255,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SDSS-II SN 02881','RN',12255,38.29,0.34,435,2336,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02881',0.048266,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12256,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12256,36.45,0.07,195,2337,70,NULL,NULL,'CGCG 384-035',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000073,NULL,'15.6g',0.46,'S0/E','Group member',NULL,NULL,NULL,1,14.0444583,-1.11692,0.116,NULL,34525122447,539455038,8428984,15.6),(12257,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12257,36.61,0.53,210,2337,70,NULL,NULL,'CGCG 384-035',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12258,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12258,37.54,0.19,322,2338,70,NULL,NULL,'2MASX J00561153+0040553',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00009,NULL,'15.9g',0.42,'E0',NULL,NULL,NULL,NULL,1,14.048125,0.68197,0.087,NULL,66687405090,1041990704,16281104,15.9),(12259,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12259,36.45,0.07,195,2339,70,NULL,NULL,'2MASX J00561243-0034317',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000066,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,14.05175,-0.57544,0.087,NULL,34524500271,539445316,8428833,16.7),(12260,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12260,36.09,0.15,165,2340,70,NULL,NULL,'GIN 023',NULL,'2001MNRAS.321..277C',2001,1,0.47,'Emission line redshifts from SDSS and 1999MNRAS.305..259W are incorrect.','G',0.000063,NULL,'16.7g',0.36,'BrClG;E/S0',NULL,NULL,NULL,NULL,1,14.053,-0.59669,0.087,NULL,34524503906,539445373,8428833,16.7),(12261,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SDSS-II SN 00896','RN',12261,43.2,0.22,3060,2341,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 00896',0.425016,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12262,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SDSS-II SN 00896','RN',12262,43.87,0.2,4160,2341,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 00896',0.425016,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12263,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12263,36.95,0.12,245,2342,70,NULL,NULL,'2MASX J00561434-0954029',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000105,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,14.0597917,-9.90081,0.156,NULL,35251720376,550808130,8606377,16.7),(12264,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12264,35.37,0.47,119,2343,70,NULL,NULL,'ESO 243- G 012',NULL,'2014MNRAS.445.2677S',2014,1,1.12,'1984MNRAS.210...69F has V = 6300: +- 200 km/s.','G',0.00015,NULL,'14.90',0.51,'(R)SAB(rl)0^+',NULL,NULL,NULL,NULL,1,14.0625,-47.06436,NULL,NULL,38147404830,596053200,9313331,14.9),(12265,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12265,38.27,0.27,451,2344,70,NULL,NULL,'2MASX J00561550-0034557',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,14.064625,-0.58206,0.087,NULL,34524500736,539445324,8428833,18.2),(12266,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SDSS-II SN 18722',NULL,12266,40.83,0.18,1470,2345,70,NULL,'SN photometric redshift distance, z photo =0.429 +/- 0.048','SDSS-II SN 18722',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,14.0660417,-0.46392,0.087,NULL,34524525720,539445714,8428839,NULL),(12267,'D-Sigma','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12267,34.69,0.4,86.9,2346,75,NULL,'Edat, raw','NGC 0312',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000057,NULL,'13.42',1.1,'E+:',NULL,NULL,NULL,NULL,1,14.066375,-52.78269,NULL,NULL,36018437605,562788087,8793563,13.42),(12268,'D-Sigma','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12268,35.14,0.4,107,2346,75,NULL,'Edat, cor','NGC 0312',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12269,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12269,34.88,0.46,94.5,2346,70,NULL,NULL,'NGC 0312',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12270,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12270,34.91,0.45,95.9,2346,NULL,NULL,'K','NGC 0312',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12271,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12271,35.12,0.4,106,2346,NULL,NULL,'mean','NGC 0312',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12272,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12272,36.45,0.07,195,2347,70,NULL,NULL,'2MASX J00561604+0006362',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000091,NULL,'16.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,14.066833,0.11011,0.073,NULL,66687342658,1041989729,16281089,16.8),(12273,'BCG','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12273,36.75,0.35,214,2348,60,NULL,'ABELL 0119, BCG','UGC 00579',0.0446,'1980ApJ...241..486H',1980,1,1.4,NULL,'G',0.000067,NULL,'14.39',1.2,'cD;E;BrClG','Group member',NULL,NULL,NULL,1,14.067125,-1.25536,0.073,NULL,34524947974,539452312,8428942,14.39),(12274,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12274,35.91,0.25,152,2348,74.4,NULL,NULL,'UGC 00579',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12275,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12275,36.09,0.15,165,2348,70,NULL,NULL,'UGC 00579',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12276,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12276,36.45,0.07,195,2348,70,NULL,NULL,'UGC 00579',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12277,'Magnitude','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12277,35.28,0.13,114,2348,100,NULL,NULL,'UGC 00579',NULL,'1998A&A...337...31R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12278,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12278,36.02,0.45,160,2348,NULL,NULL,'K','UGC 00579',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12279,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12279,36.14,0.4,169,2348,NULL,NULL,'mean','UGC 00579',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12280,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12280,36.4,0.16,190,2348,70,NULL,'ABELL 0119, BGC','UGC 00579',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12281,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12281,36.78,0.68,227,2349,70,NULL,NULL,'2MASX J00561651-1000318',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.000103,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,14.0687916667,-10.00894,0.14,NULL,35251745001,550808515,8606383,16.4),(12282,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12282,36.95,0.12,245,2349,70,NULL,NULL,'2MASX J00561651-1000318',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12283,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SN 2006gt',NULL,12283,36.14,0.23,155,2350,72,NULL,NULL,'2MASX J00561810-0137327',0.04367,'2013ApJ...773...53F',2013,1,0.31,NULL,'G',0.00006,NULL,'17.93',0.22,NULL,NULL,NULL,NULL,NULL,1,14.075375,-1.62583,0.122,NULL,34523635427,539431803,8428621,17.93),(12284,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SN 2006gt',NULL,12284,36.44,0.13,186,2350,72,NULL,NULL,'2MASX J00561810-0137327',0.044771,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12285,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SN 2006gt',NULL,12285,36.49,0.02,190,2350,72,NULL,NULL,'2MASX J00561810-0137327',0.044771,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12286,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SN 2006gt',NULL,12286,36.45,0.09,195,2350,74.4,NULL,NULL,'2MASX J00561810-0137327',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12287,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SN 2006gt',NULL,12287,36.47,0.02,197,2350,72,NULL,NULL,'2MASX J00561810-0137327',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12288,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SN 2006gt',NULL,12288,36.54,0.25,204,2350,72,NULL,'M(H) = -18.317 mag','2MASX J00561810-0137327',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12289,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SN 2006gt',NULL,12289,36.73,0.17,212,2350,65,NULL,'MLCS17','2MASX J00561810-0137327',0.044771,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12290,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SN 2006gt',NULL,12290,36.8,0.18,219,2350,65,NULL,'MLCS31','2MASX J00561810-0137327',0.044771,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12291,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12291,36.45,0.07,195,2351,70,NULL,NULL,'ZwCl 0054.6-0127 18',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000097,NULL,'16.1g',0.31,'E','Group member',NULL,NULL,NULL,1,14.075583,-1.24189,0.073,NULL,34524917234,539451831,8428934,16.1),(12292,'BCG','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12292,36.75,0.35,214,2352,60,NULL,NULL,'ABELL 0119',0.0446,'1980ApJ...241..486H',1980,1,NULL,'Katgert (1996,A&A,310,8) identifies multiple redshift systems in this cluster.','GClstr',NULL,NULL,NULL,NULL,'II-III [BM]',NULL,NULL,NULL,NULL,1,14.07625,-1.21667,0.073,NULL,34524916978,539451827,8428934,NULL),(12293,'Magnitude','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12293,35.28,0.13,114,2352,100,NULL,NULL,'ABELL 0119',NULL,'1998A&A...337...31R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12294,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12294,36.4,0.16,190,2352,70,NULL,NULL,'ABELL 0119',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12295,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SDSS-II SN 03480','RN',12295,42.07,0.65,2200,2353,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03480',0.175025,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12296,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12296,37.76,0.46,357,2354,70,NULL,NULL,'2MASX J00561906-0928318',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000083,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,14.0795417,-9.47556,0.175,NULL,35252025732,550812902,8606451,18),(12297,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12297,37.42,0.46,305,2355,70,NULL,NULL,'2MASX J00561930+1535264',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000061,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,14.080375,15.59081,0.157,NULL,67589580676,1056087198,16501362,18),(12298,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12298,39.05,0.46,644,2356,70,NULL,NULL,'2MASX J00562003-1000018',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.0001,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,14.0834583333,-10.00064,0.14,NULL,35251745742,550808527,8606383,17.8),(12299,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12299,36.45,0.07,195,2357,70,NULL,NULL,'SDSS J005620.31-011433.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000177,NULL,'17.21',0.17,'E',NULL,NULL,NULL,NULL,1,14.084667,-1.24253,0.073,NULL,34524914335,539451786,8428934,17.21),(12300,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12300,36.45,0.07,195,2358,70,NULL,NULL,'2MASX J00562098-0110359',NULL,'2015arXiv151105856S',2015,1,0.59,'Katgert et al (1998A&AS..129..399K) have V = 12862 +- 45 km/sec.','G',0.00006,NULL,'15.8g',0.3,'S0','Group member',NULL,NULL,NULL,1,14.0875,-1.17664,0.138,NULL,34524919714,539451870,8428935,15.8),(12301,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12301,37.5,0.46,316,2359,70,NULL,NULL,'SDSS J005621.66-091201.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000073,NULL,'18.3g',0.14,'Cand.grav.lens',NULL,NULL,NULL,NULL,1,14.0902917,-9.20056,0.209,NULL,35251143200,550799112,8606236,18.3),(12302,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12302,38.1,0.23,416,2360,70,NULL,NULL,'2MASX J00562184-0937568',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000097,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,14.091167,-9.63231,0.175,NULL,35252074719,550813667,8606463,17.5),(12303,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12303,36.26,0.46,179,2361,70,NULL,NULL,'2MASX J00562257-0920238',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000098,NULL,'16.3g',0.32,'E0',NULL,NULL,NULL,NULL,1,14.0939166667,-9.34003,0.209,NULL,35251112922,550798639,8606228,16.3),(12304,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12304,36.61,0.77,210,2362,70,NULL,NULL,'2MASX J00562264-0020429',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.000076,NULL,'16.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,14.0945,-0.34517,0.078,NULL,34520400051,539381250,8427832,16.4),(12305,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12305,37.75,0.23,355,2363,70,NULL,NULL,'UGC 00582',NULL,'2015arXiv151105856S',2015,1,0.59,'SDSS has z = 0.082388 +- 0.000108.','G',0.000083,NULL,'16.0g',0.45,'S0?;BrClG',NULL,NULL,NULL,NULL,1,14.095875,13.87633,0.121,NULL,67595173709,1056174589,16502727,16),(12306,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12306,36.45,0.07,195,2364,70,NULL,NULL,'2MASX J00562351-0059129',NULL,'2015arXiv151105856S',2015,1,0.5,'Katgert et al (1998A&AS..129..399K) have V = 12259 +- 42 km/sec.','G',0.00007,NULL,'16.0g',0.34,'E/S0','Group member',NULL,NULL,NULL,1,14.098125,-0.98689,0.116,NULL,34525001732,539453152,8428955,16),(12307,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12307,36.53,0.57,203,2364,70,NULL,NULL,'2MASX J00562351-0059129',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12308,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12308,37.75,0.23,355,2365,70,NULL,NULL,'2MASX J00562390+1354055',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000073,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,14.0997083,13.90175,0.121,NULL,67595167105,1056174486,16502726,17.7),(12309,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12309,38.27,0.27,451,2366,70,NULL,NULL,'SDSS J005624.63-003303.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000069,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,14.102625,-0.55089,0.087,NULL,34520245221,539378831,8427794,18.3),(12310,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12310,35.89,0.25,151,2367,74.4,NULL,NULL,'UGC 00583',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.00005,NULL,'14.38',1.1,'E/S0','Group member, 2nd ranked galaxy',NULL,'NAT',NULL,1,14.106625,-1.26247,0.073,NULL,34524946470,539452288,8428942,14.38),(12311,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12311,36.09,0.15,165,2367,70,NULL,NULL,'UGC 00583',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12312,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12312,36.45,0.07,195,2368,70,NULL,NULL,'2MASX J00562627+0002381',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000095,NULL,'15.9g',0.43,'E0',NULL,NULL,NULL,NULL,1,14.109625,0.04383,0.073,NULL,66678962688,1041858792,16279043,15.9),(12313,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12313,37.54,0.19,322,2369,70,NULL,NULL,'2MASX J00562735+0037231',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000072,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,14.114,0.62303,0.115,NULL,66679094091,1041860845,16279075,18),(12314,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12314,36.45,0.07,195,2370,70,NULL,NULL,'2MASX J00562744-0047329',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00006,NULL,'16.8g',0.25,'E','Group member',NULL,NULL,NULL,1,14.1142917,-0.79242,0.116,NULL,34520578238,539384034,8427875,16.8),(12315,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SN 2006nz',NULL,12315,36,0.18,153,2371,65,NULL,'MLCS17','2MASX J00562918-0113319',0.038253,'2009ApJ...700.1097H',2009,1,NULL,NULL,'G',0.00019,NULL,'16.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,14.121667,-1.2255,0.138,NULL,34520470383,539382349,8427849,16.4),(12316,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SN 2006nz',NULL,12316,36.04,0.19,156,2371,65,NULL,'MLCS31','2MASX J00562918-0113319',0.038253,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12317,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SDSS-II SN 16280','R',12317,36.14,0.2,162,2371,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006nz','2MASX J00562918-0113319',0.044351,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12318,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SN 2006nz',NULL,12318,36.11,0.1,167,2371,74.4,NULL,NULL,'2MASX J00562918-0113319',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12319,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SDSS-II SN 16280','R',12319,36.28,0.05,173,2371,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006nz','2MASX J00562918-0113319',0.044351,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12320,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SN 2006nz',NULL,12320,36.27,0.16,173,2371,65,NULL,'SALT','2MASX J00562918-0113319',0.038253,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12321,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SN 2006nz',NULL,12321,36.42,0.22,185,2371,65,NULL,'SALT2','2MASX J00562918-0113319',0.038253,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12322,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12322,36.45,0.07,195,2372,70,NULL,NULL,'ZwCl 0054.6-0127 23',NULL,'2015arXiv151105856S',2015,1,0.45,'Katgert et al (1998A&AS..129..399K) have V = 13701 +- 48 km/sec.','G',0.000087,NULL,'16.2g',0.3,'S0','Group member',NULL,NULL,NULL,1,14.1279583333,-1.17292,0.138,NULL,34520472441,539382381,8427849,16.2),(12323,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12323,33.44,0.54,48.9,2373,70,NULL,NULL,'NGC 0307',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000073,NULL,'13.75',0.7,'S0^0^:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,14.13575,-1.77194,0.122,NULL,34521759872,539402498,8428164,13.75),(12324,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12324,33.83,0.4,58.4,2373,NULL,NULL,'mean','NGC 0307',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12325,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12325,34.47,0.45,78.4,2373,NULL,NULL,'K','NGC 0307',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12326,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12326,37.75,0.23,355,2374,70,NULL,NULL,'SDSS J005632.70+135417.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000078,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,14.13625,13.90478,0.117,NULL,67595169760,1056174527,16502726,18.6),(12327,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SDSS-II SN 09870','RN',12327,40.39,0.25,1110,2375,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 09870',0.079377,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12328,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SDSS-II SN 09870','RN',12328,40.42,0.28,1130,2375,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 09870',0.079377,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12329,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12329,37.75,0.23,355,2376,70,NULL,NULL,'2MASX J00563379+1354235',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000089,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,14.141,13.90672,0.117,NULL,67595169444,1056174522,16502726,18.1),(12330,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SDSS-II SN 14733','R',12330,42.04,0.34,1710,2377,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14733',0.498802,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,'PHOT','21.9g',0.02,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,14.1447917,0.23097,0.073,NULL,66678996731,1041859323,16279051,21.9),(12331,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SDSS-II SN 14733',NULL,12331,41.59,0.01,2080,2377,70,NULL,'SN photometric redshift distance, z photo =0.697 +/- 0.003','SDSS-II SN 14733',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12332,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12332,37.7,0.68,347,2378,70,NULL,NULL,'2MASX J00563584-0031519',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.000092,NULL,'15.9g',0.38,NULL,NULL,NULL,NULL,NULL,1,14.1495,-0.53111,0.087,NULL,34520290907,539379545,8427805,15.9),(12333,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12333,36.1,0.75,166,2379,70,NULL,NULL,'2MASX J00563888-0248409',NULL,'2014MNRAS.445.2677S',2014,1,0.27,NULL,'G',0.000077,NULL,'16.85',0.26,NULL,NULL,NULL,NULL,NULL,1,14.162,-2.81128,0.157,NULL,34523318258,539426847,8428544,16.85),(12334,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12334,36.74,0.46,223,2380,70,NULL,NULL,'2MASX J00563895+0028431',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000083,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,14.1621666667,0.47853,0.115,NULL,66679138201,1041861534,16279086,17.2),(12335,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12335,37.24,0.46,281,2381,70,NULL,NULL,'2MASX J00563914+0007011',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000177,NULL,'17.70',0.23,'AGN',NULL,NULL,NULL,NULL,1,14.163125,0.11697,0.073,NULL,66679009994,1041859531,16279055,17.7),(12336,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12336,36.28,0.55,180,2382,70,NULL,NULL,'2MASX J00564085-5231102',NULL,'2014MNRAS.445.2677S',2014,1,0.98,NULL,'G',0.00015,NULL,'15.22',0.55,'E',NULL,NULL,NULL,NULL,1,14.170167,-52.51961,NULL,NULL,36018387116,562787298,8793551,15.22),(12337,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12337,36.45,0.07,195,2383,70,NULL,NULL,'2MASX J00564092-0102039',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000073,NULL,'16.5g',0.1,'S0','Group member',NULL,NULL,NULL,1,14.170375,-1.03453,0.116,NULL,34520649613,539385150,8427892,16.5),(12338,'D-Sigma','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12338,34.69,0.4,86.9,2384,75,NULL,'Edat, raw','NGC 0323',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000103,NULL,'13.59',1,'E+',NULL,NULL,NULL,NULL,1,14.1735417,-52.97592,NULL,NULL,36018403534,562787555,8793555,13.59),(12339,'D-Sigma','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12339,35.14,0.4,107,2384,75,NULL,'Edat, cor','NGC 0323',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12340,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12340,35.15,0.4,107,2384,NULL,NULL,'mean','NGC 0323',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12341,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12341,35.65,0.45,135,2384,NULL,NULL,'K','NGC 0323',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12342,'Ring Diameter','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12342,33.5,0.84,51,2385,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 0309',NULL,'1981ApJS...45..541P',1981,1,1.94,'HOLM 027B is a star.','G',0.000017,NULL,'13.4g',1.34,'SAB(r)c        HII','Erroneous pair member',NULL,NULL,NULL,1,14.17775,-9.91386,0.156,NULL,35251726784,550808231,8606378,13.4),(12343,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12343,32.53,NULL,32.1,2385,NULL,NULL,'B','NGC 0309',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12344,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SDSS-II SN 13907','R',12344,39.8,0.19,761,2386,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13907 HOST',0.1978,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,14.1792917,0.23222,0.073,NULL,66678990649,1041859228,16279050,NULL),(12345,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SDSS-II SN 13907','R',12345,39.85,0.11,781,2386,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13907 HOST',0.1978,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12346,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SDSS-II SN 13907',NULL,12346,39.64,0.08,847,2386,70,NULL,'SALT 2','SDSS-II SN 13907 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12347,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SDSS-II SN 13907',NULL,12347,39.66,0.08,855,2386,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13907 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12348,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12348,36.23,0.77,176,2387,70,NULL,NULL,'2MASX J00564411-0803371',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'17.46',0.2,NULL,NULL,NULL,NULL,NULL,1,14.1837083,-8.06033,0.281,NULL,34543164262,539736941,8433389,17.46),(12349,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12349,36.41,0.36,191,2388,NULL,NULL,'Malmquist cor.','2MASX J00564659-0135469',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000027,NULL,'15.25',0.3,'Sb','Group member',NULL,NULL,NULL,1,14.1940833333,-1.59644,0.122,NULL,34521802376,539403162,8428174,15.25),(12350,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12350,36.53,0.34,203,2388,NULL,NULL,NULL,'2MASX J00564659-0135469',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12351,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12351,36.58,0.2,207,2388,74.4,NULL,NULL,'2MASX J00564659-0135469',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12352,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12352,34.6,0.45,83,2389,70,NULL,NULL,'ESO 151- G 012',NULL,'2014MNRAS.445.2677S',2014,1,1.18,NULL,'G',0.0001,NULL,'14.1b',0.47,'SAB(s)0/a      LLAGN',NULL,NULL,NULL,NULL,1,14.1967083,-53.09736,NULL,NULL,36013422559,562709727,8792339,14.1),(12353,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12353,37.53,0.23,321,2390,70,NULL,NULL,'2MASX J00564816+1515162',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000075,NULL,'16.8g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,14.200625,15.25442,0.133,NULL,67590147895,1056096060,16501500,16.8),(12354,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12354,37.01,0.64,253,2391,70,NULL,NULL,'2MASX J00564867-2155522',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'17.20',0.27,NULL,NULL,NULL,NULL,NULL,1,14.202875,-21.93108,0.053,NULL,35387311316,552926739,8639480,17.2),(12355,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12355,36.45,0.07,195,2392,70,NULL,NULL,'CGCG 384-043',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00009,NULL,'16.31',0.43,'S0^-',NULL,NULL,NULL,NULL,1,14.2162083,0.00583,0.054,NULL,66678952824,1041858637,16279041,16.31),(12356,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12356,37.53,0.23,321,2393,70,NULL,NULL,'SDSS J005652.68+151250.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000068,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,14.2195416667,15.21417,0.133,NULL,67590145907,1056096029,16501500,18.6),(12357,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12357,36.45,0.07,195,2394,70,NULL,NULL,'ZwCl 0054.6-0127 29',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00008,NULL,'16.5g',0.3,'S0/E','Group member',NULL,NULL,NULL,1,14.219625,-1.15919,0.138,NULL,34520482907,539382545,8427852,16.5),(12358,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SDSS-II SN 10650','RN',12358,35.38,0.11,114,2395,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10650',0.045772,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12359,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,'R',12359,37.53,0.23,321,2396,70,NULL,NULL,'2MASX J00565404+1512212',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000104,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,14.22525,15.20594,0.133,NULL,67590145222,1056096019,16501500,17.4),(12360,'FP','2016-12-15 15:13:42','2016-12-16 11:18:43','1',NULL,NULL,12360,36.57,0.52,207,2397,70,NULL,NULL,'AM 0054-471',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.18',0.45,'S0',NULL,NULL,NULL,NULL,1,14.229167,-46.97494,NULL,NULL,38147372737,596052699,9313323,16.18),(12361,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:43','1','SDSS-II SN 16638','RN',12361,40.69,0.28,1080,2398,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16638',0.272586,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12362,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 16638','RN',12362,40.93,0.23,1210,2398,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16638',0.272586,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12363,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12363,36.45,0.07,195,2399,70,NULL,NULL,'2MASX J00565652-0056366',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00009,NULL,'15.94',0.3,'S0','Group member',NULL,NULL,NULL,1,14.2355,-0.94364,0.116,NULL,34520657420,539385272,8427894,15.94),(12364,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12364,35.94,0.25,154,2400,74.4,NULL,NULL,'UGC 00587',NULL,'2013AJ....146...86T',2013,1,0.71,NULL,'G',0.000027,NULL,'15.2g',0.58,'Sbc            HII','Group member',NULL,NULL,NULL,1,14.237083,-1.21186,0.138,NULL,34520494363,539382724,8427855,15.2),(12365,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12365,36.09,0.15,165,2400,70,NULL,NULL,'UGC 00587',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12366,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12366,36.45,0.07,195,2401,70,NULL,NULL,'ZwCl 0054.6-0127 30',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000077,NULL,'17.0g',0.23,'E/S0','Group member',NULL,NULL,NULL,1,14.244,-1.25689,0.138,NULL,34520438274,539381848,8427841,17),(12367,'IRAS','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12367,35.04,0.8,102,2402,75,NULL,'MAT, I','IC 1603',NULL,'1997ApJS..109..333W',1997,1,1.19,NULL,'G',0.000033,NULL,'14.58',0.48,'Sc',NULL,NULL,NULL,NULL,1,14.248667,-45.41294,NULL,NULL,38171208699,596425135,9319142,14.58),(12368,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12368,34.29,NULL,72.1,2402,NULL,NULL,'B','IC 1603',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12369,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12369,34.29,NULL,72.1,2402,NULL,NULL,'I','IC 1603',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12370,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12370,34.33,0.32,73.4,2402,85,NULL,'I, raw','IC 1603',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12371,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12371,34.37,0.32,74.7,2402,85,NULL,'I, inv','IC 1603',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12372,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12372,34.43,0.43,76.9,2402,75,NULL,'MAT, I, raw','IC 1603',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12373,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12373,34.61,0.38,83.6,2402,NULL,NULL,NULL,'IC 1603',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12374,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12374,34.62,0.43,83.9,2402,75,NULL,'MAT, I, inv','IC 1603',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12375,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12375,34.65,0.2,85.1,2402,74.4,NULL,NULL,'IC 1603',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12376,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12376,34.84,0.43,93,2402,75,NULL,'MAT, I, cor','IC 1603',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12377,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12377,34.87,0.33,94.3,2402,NULL,NULL,'Malmquist cor.','IC 1603',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12378,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12378,36.45,0.07,195,2403,70,NULL,NULL,'2MASX J00570032-0049306',NULL,'2015arXiv151105856S',2015,1,0.19,'Katgert et al (1998A&AS..129..399K) give V = 11741 +- 48 km/sec.','G',0.000063,NULL,'16.0g',0.16,'S0','Group member',NULL,NULL,NULL,1,14.251375,-0.82525,0.074,NULL,34520627337,539384802,8427887,16),(12379,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 15856','RN',12379,39.81,0.15,872,2404,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15856',0.048788,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12380,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 15856','RN',12380,41.16,0.25,1630,2404,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15856',0.048788,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12381,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12381,36.44,0.2,194,2405,74.4,NULL,NULL,'UGC 00586',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',NULL,NULL,'16.78',0.1,'S',NULL,NULL,NULL,NULL,1,14.2560417,7.32925,0.161,NULL,66670046754,1041719480,16276866,16.78),(12382,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12382,36.45,0.07,195,2406,70,NULL,NULL,'ZwCl 0054.6-0127 31',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000087,NULL,'16',0.45,'E','Group member',NULL,NULL,NULL,1,14.258333,-0.87972,0.074,NULL,34520613844,539384591,8427884,16),(12383,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 00930','RN',12383,41.7,0.18,1700,2407,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00930',0.290116,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12384,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 00930','RN',12384,41.84,0.09,1810,2407,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 00930',0.290116,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12385,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12385,39.17,0.46,681,2408,70,NULL,NULL,'2MASX J00570336-0916134',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000129,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,14.264125,-9.27044,0.19,NULL,35251205304,550800082,8606251,17.4),(12386,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12386,36.45,0.07,195,2409,70,NULL,NULL,'2MASX J00570492-0055086',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.0001,NULL,'16.7g',0.21,'S0','Group member',NULL,NULL,NULL,1,14.2705,-0.91917,0.074,NULL,34520654680,539385229,8427894,16.7),(12387,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12387,36.98,0.2,249,2410,74.4,NULL,NULL,'UGC 00590',NULL,'2013AJ....146...86T',2013,1,0.68,NULL,'G',0.000076,NULL,'15.6g',0.38,'S?',NULL,NULL,NULL,NULL,1,14.271667,14.90858,0.133,NULL,67589727097,1056089485,16501398,15.6),(12388,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 20382','RN',12388,42.96,0.19,2870,2411,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 20382',0.361711,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12389,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 20382','RN',12389,42.98,0.22,2900,2411,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20382',0.361711,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12390,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12390,36.97,0.46,248,2412,70,NULL,NULL,'2MASX J00570614-0854084',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000082,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,14.2755417,-8.90239,0.226,NULL,35251056891,550797763,8606215,17),(12391,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 08898','RN',12391,37.47,0.62,282,2413,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 08898',0.102408,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12392,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 08898','RN',12392,40.07,6.32,935,2413,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08898',0.102408,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12393,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12393,36.69,0.65,217,2414,70,NULL,NULL,'2MASX J00570707-0228356',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.000103,NULL,'17.08',0.26,NULL,NULL,NULL,NULL,NULL,1,14.2794166667,-2.47658,0.153,NULL,34521446852,539397607,8428087,17.08),(12394,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12394,36.09,0.64,165,2415,70,NULL,NULL,'ABELL 0119:[D80] 029',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00006,NULL,'16.4',0.28,'S0','Group member',NULL,NULL,NULL,1,14.290375,-1.38033,0.129,NULL,34522273509,539410523,8428289,16.4),(12395,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12395,34.15,0.45,67.6,2416,70,NULL,NULL,'NGC 0322',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000103,NULL,'14.25',0.6,'(PR?)S0^0','in a pair',NULL,NULL,NULL,1,14.2917083,-43.72708,NULL,NULL,38171928168,596436377,9319318,14.25),(12396,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12396,36.45,0.07,195,2417,70,NULL,NULL,'2MASXi J0057101-002049',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000088,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,14.292417,-0.34694,0.079,NULL,34520375659,539380869,8427826,17.3),(12397,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12397,36.95,0.12,245,2418,70,NULL,NULL,'2MASX J00571024-1008134',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000087,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,14.2927916667,-10.13708,0.169,NULL,35252093724,550813964,8606468,16.5),(12398,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 20685',NULL,12398,40.65,0.26,1350,2419,70,NULL,'SN photometric redshift distance, z photo =0.385 +/- 0.064','SDSS-II SN 20685',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.9g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,14.2940417,1.24058,0.069,NULL,66679509223,1041867331,16279177,21.9),(12399,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 20685','R',12399,41.93,0.31,1710,2419,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20685',0.42204,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12400,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 20685','R',12400,42.03,0.37,1790,2419,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20685',0.42204,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12401,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 20685',NULL,12401,41.8,0.23,2290,2419,70,NULL,'SALT 2','SDSS-II SN 20685',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12402,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 20685',NULL,12402,41.88,0.23,2380,2419,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20685',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12403,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12403,36.45,0.07,195,2420,70,NULL,NULL,'2MASX J00571066-0101076',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00007,NULL,'15.46',0.3,'S0/a','Group member',NULL,NULL,NULL,1,14.2945,-1.01881,0.138,NULL,34520681886,539385654,8427900,15.46),(12404,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12404,35.92,0.25,153,2421,74.4,NULL,NULL,'ZwCl 0054.6-0127 36',NULL,'2013AJ....146...86T',2013,1,0.67,NULL,'G',0.000073,NULL,'15.4g',0.5,'S',NULL,NULL,NULL,NULL,1,14.3207083333,-0.6695,0.074,NULL,34521114902,539392420,8428006,15.4),(12405,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12405,36.09,0.15,165,2421,70,NULL,NULL,'ZwCl 0054.6-0127 36',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12406,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12406,36.45,0.07,195,2421,70,NULL,NULL,'ZwCl 0054.6-0127 36',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12407,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 14880','RN',12407,39.2,0.38,568,2422,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 14880',0.219759,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12408,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 14880','RN',12408,39.52,0.35,657,2422,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 14880',0.219759,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12409,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 07491','RN',12409,43.36,0.2,3010,2423,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 07491',0.561733,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12410,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12410,36.95,0.12,245,2424,70,NULL,NULL,'2MASX J00571789-1004454',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000086,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,14.324625,-10.07928,0.169,NULL,35251588503,550806070,8606344,17.1),(12411,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12411,38.05,0.33,407,2425,70,NULL,NULL,'2MASX J00571866+1450010',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000115,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,14.3279583333,14.83361,0.133,NULL,67589709730,1056089214,16501393,17.7),(12412,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12412,36.95,0.12,245,2426,70,NULL,NULL,'2MASX J00571891-1016324',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000101,NULL,'16.1g',0.4,'E0',NULL,NULL,NULL,NULL,1,14.328833,-10.27586,0.139,NULL,35252126225,550814472,8606476,16.1),(12413,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 06530','R',12413,39.86,0.2,785,2427,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J005718.99+000116.9',0.1934,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',0.0002,NULL,'21.2g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,14.329125,0.02136,0.054,NULL,66678967107,1041858861,16279044,21.2),(12414,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 06530',NULL,12414,39.66,0.1,855,2427,70,NULL,'SALT 2','SDSS J005718.99+000116.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12415,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 06530',NULL,12415,39.67,0.1,859,2427,70,NULL,'SALT 2, Malmquist cor.','SDSS J005718.99+000116.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12416,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 06530','R',12416,40.1,0.13,878,2427,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J005718.99+000116.9',0.1934,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12417,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12417,34.38,NULL,75.2,2428,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 243- G 016',NULL,'2010Ap&SS.325..163P',2010,1,1.29,NULL,'G',0.00004,'?','17.02',0.11,'Scd',NULL,NULL,NULL,NULL,1,14.335833,-42.67111,NULL,NULL,38162172154,596283939,9316936,17.02),(12418,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12418,34.41,NULL,76.1,2428,NULL,NULL,'Dipole + Quadrupole','ESO 243- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12419,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12419,34.41,NULL,76.2,2428,NULL,NULL,'Dipole','ESO 243- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12420,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12420,34.46,NULL,78,2428,NULL,NULL,NULL,'ESO 243- G 016',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12421,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12421,35.28,0.56,114,2429,70,NULL,NULL,'2MASX J00572059-6851143',NULL,'2014MNRAS.445.2677S',2014,1,0.31,NULL,'G',0.00015,NULL,'15.9b',0.22,NULL,NULL,NULL,NULL,NULL,1,14.336,-68.85406,0,NULL,36319350621,567489853,8867028,15.9),(12422,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 13013','RN',12422,39.28,0.19,649,2430,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13013',0.106924,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12423,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 13013','RN',12423,39.97,0.26,890,2430,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13013',0.106924,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12424,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12424,37.01,0.46,253,2431,70,NULL,NULL,'2MASX J00572485-0044248',NULL,'2015arXiv151105856S',2015,1,0.43,'Katgert, et al. (1998A&AS..129..399K) give v = 13129 +/- 48 km/sec.','G',0.000105,NULL,'16.3g',0.31,'S0','Group member',NULL,NULL,NULL,1,14.353417,-0.74019,0.074,NULL,34520611654,539384557,8427883,16.3),(12425,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12425,35.94,0.76,154,2432,70,NULL,NULL,'ZwCl 0054.6-0127 37',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00013,NULL,'15.8g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,14.3573333333,-0.51997,0.079,NULL,34521133259,539392707,8428011,15.8),(12426,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12426,37.87,0.46,375,2433,70,NULL,NULL,'2MASX J00572645-0905124',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000081,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,14.3602916667,-9.08689,0.226,NULL,35251251736,550800808,8606262,18),(12427,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12427,36.45,0.07,195,2434,70,NULL,NULL,'2MASX J00572732-0034058',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000085,NULL,'16.5g',0.33,'S0',NULL,NULL,NULL,NULL,1,14.363875,-0.56842,0.074,NULL,34521140377,539392818,8428012,16.5),(12428,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12428,36.45,0.07,195,2435,70,NULL,NULL,'2MASX J00572759-0027318',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00008,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,14.364833,-0.45889,0.079,NULL,34521135981,539392749,8428011,18),(12429,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12429,35.91,0.25,152,2436,74.4,NULL,NULL,'GIN 021',NULL,'2013AJ....146...86T',2013,1,1.25,NULL,'G',0.000073,NULL,'14.20',1.36,'E/S0',NULL,NULL,NULL,NULL,1,14.365083,-0.47158,0.079,NULL,34521135425,539392741,8428011,14.2),(12430,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12430,36.09,0.15,165,2436,70,NULL,NULL,'GIN 021',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12431,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12431,36.45,0.07,195,2436,70,NULL,NULL,'GIN 021',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12432,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12432,38.05,0.33,407,2437,70,NULL,NULL,'2MASX J00572990+1452451',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000083,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,14.37475,14.87922,0.117,NULL,67589974662,1056093354,16501458,18.1),(12433,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12433,37.35,0.46,295,2438,70,NULL,NULL,'2MASX J00573146+0045555',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000122,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,14.381167,0.76553,0.057,NULL,66679555722,1041868058,16279188,16.2),(12434,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12434,37.19,0.46,274,2439,70,NULL,NULL,'2MASX J00573256+1403071',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000076,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,14.3856666667,14.05197,0.117,NULL,67591542804,1056117856,16501841,17.4),(12435,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12435,34.24,0.4,70.4,2440,NULL,NULL,'mean','NGC 0311',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000047,NULL,'14.00',0.8,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,14.386375,30.28075,0.273,NULL,67264958703,1051014979,16422109,14),(12436,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12436,34.57,0.45,82,2440,NULL,NULL,'K','NGC 0311',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12437,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2007nq',NULL,12437,36.12,0.06,154,2441,72,NULL,NULL,'UGC 00595',0.04393,'2013ApJ...773...53F',2013,1,0.9,NULL,'G',0.000053,NULL,'14.56',0.8,'E;Radio galaxy LEG','Group member',NULL,'radio jet','LINER',1,14.3955,-1.39108,0.129,NULL,34522298003,539410906,8428295,14.56),(12438,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2007nq',NULL,12438,36.32,0.18,176,2441,73.8,NULL,'SALT 2 (SNANA)','UGC 00595',0.044,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12439,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2007nq',NULL,12439,36.33,0.14,184,2441,72,NULL,'M(H) = -18.317 mag','UGC 00595',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12440,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2007nq',NULL,12440,36.46,0.28,188,2441,73.8,NULL,'SALT 2 (SNANA)','UGC 00595',0.044,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12441,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12441,35.92,0.25,153,2441,74.4,NULL,NULL,'UGC 00595',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12442,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12442,36.09,0.15,165,2441,70,NULL,NULL,'UGC 00595',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12443,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12443,36.21,0.45,175,2441,NULL,NULL,'K','UGC 00595',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12444,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12444,36.28,0.4,180,2441,NULL,NULL,'mean','UGC 00595',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12445,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12445,33.41,0.2,48.1,2442,74.4,NULL,NULL,'MCG -01-03-041',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.00012,NULL,'14.72',0.6,'SB(rs)cd pec   HII','Pair member (points to parent)',NULL,NULL,NULL,1,14.3962083,-5.0025,0.214,NULL,34559834520,539997414,8437459,14.72),(12446,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12446,33.63,0.44,53.2,2442,NULL,NULL,NULL,'MCG -01-03-041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12447,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12447,34.03,0.36,64,2442,NULL,NULL,'Malmquist cor.','MCG -01-03-041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12448,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12448,35.84,0.46,147,2443,70,NULL,NULL,'2MASX J00573676-0914244',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000088,NULL,'15.9g',0.3,'S0/a',NULL,NULL,NULL,NULL,1,14.403083,-9.24019,0.2,NULL,35251223713,550800370,8606255,15.9),(12449,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12449,34.16,0.47,67.9,2444,70,NULL,NULL,'IC 1605',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000087,NULL,'13.71',1.3,'(R_1R\'_2)SB(r)b',NULL,NULL,NULL,NULL,1,14.406833,-48.90267,NULL,NULL,38149014393,596078349,9313724,13.71),(12450,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12450,34.43,0.4,77,2445,NULL,NULL,'mean','NGC 0317A',NULL,'2007A&A...465...71T',2007,1,1.4,'87GB source with large sky, narrow minor axis, or very bad confusion.','G',0.000193,NULL,'15',1.3,'S0','Pair member (points to parent)',NULL,NULL,NULL,1,14.4127083,43.80078,0.405,NULL,67700149596,1057814837,16528356,15),(12451,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12451,34.88,0.45,94.8,2445,NULL,NULL,'K','NGC 0317A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12452,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12452,36.45,0.07,195,2446,70,NULL,NULL,'ZwCl 0054.6-0127 38',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000083,NULL,'16.1g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,14.417417,-0.59128,0.091,NULL,34521111890,539392373,8428005,16.1),(12453,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12453,37.95,0.46,388,2447,70,NULL,NULL,'2MASX J00574026+1517391',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000084,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,14.4179583333,15.29414,0.117,NULL,67590080116,1056095001,16501484,17.4),(12454,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 02758','RN',12454,42.64,0.21,2330,2448,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02758',0.446976,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12455,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 02758','RN',12455,43.3,0.2,3160,2448,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 02758',0.446976,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12456,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12456,36.21,0.4,174,2449,NULL,NULL,'Malmquist cor.','2MASX J00574158-0118438',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000067,NULL,'16',0.3,NULL,'Group member',NULL,NULL,NULL,1,14.4232917,-1.31222,0.129,NULL,34522289872,539410779,8428293,16),(12457,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12457,36.22,0.4,176,2449,NULL,NULL,NULL,'2MASX J00574158-0118438',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12458,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12458,36.26,0.2,179,2449,74.4,NULL,NULL,'2MASX J00574158-0118438',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12459,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12459,34.19,0.09,69,2450,NULL,NULL,NULL,'ARK 023',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.00003,NULL,'15.23',0.3,'S?',NULL,NULL,NULL,NULL,1,14.423583,33.35144,0.189,NULL,67329496608,1052023384,16437865,15.23),(12460,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12460,33.8,0.2,57.5,2451,74.4,NULL,NULL,'CGCG 435-026',NULL,'2013AJ....146...86T',2013,1,0.72,NULL,'G',0.000051,NULL,'15.5',0.44,'Sc',NULL,NULL,NULL,NULL,1,14.4244583,15.06839,0.117,NULL,67589994930,1056093670,16501463,15.5),(12461,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 01545','R',12461,39.06,0.23,590,2452,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS J005742.51-004048.0',0.098491,'2014arXiv1401.3317S',2014,1,0.5,NULL,'G',0.00008,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,14.4271666667,-0.68,0.074,NULL,34521108223,539392315,8428004,17.3),(12462,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 01545',NULL,12462,39.02,0.12,637,2452,70,NULL,'SALT 2','SDSS J005742.51-004048.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12463,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 01545',NULL,12463,39.03,0.12,640,2452,70,NULL,'SALT 2, Malmquist cor.','SDSS J005742.51-004048.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12464,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 01545','R',12464,39.39,0.13,686,2452,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS J005742.51-004048.0',0.098491,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12465,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12465,36.63,0.69,212,2453,70,NULL,NULL,'2MASX J00574272-1017564',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00008,NULL,'15.8g',0.31,'Sab',NULL,NULL,NULL,NULL,1,14.4279583,-10.29894,0.139,NULL,35252132628,550814572,8606477,15.8),(12466,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12466,35.91,0.25,152,2454,74.4,NULL,NULL,'UGC 00599 NED01',NULL,'2013AJ....146...86T',2013,1,0.86,NULL,'G',0.000117,NULL,'14.5g',0.71,'E/S0; Southern comp.',NULL,NULL,NULL,NULL,1,14.437667,-0.41942,0.079,NULL,34521155160,539393049,8428016,14.5),(12467,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12467,36.09,0.15,165,2454,70,NULL,NULL,'UGC 00599 NED01',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12468,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12468,36.45,0.07,195,2454,70,NULL,NULL,'UGC 00599 NED01',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12469,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 07717','R',12469,41.59,0.29,1560,2455,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J005745.71-011356.3',0.332633,'2014arXiv1401.3317S',2014,1,0.1,NULL,'G',NULL,'PHOT','22.9g',0.02,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,14.4404583,-1.23233,0.129,NULL,34522312461,539411132,8428298,22.9),(12470,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 07717','R',12470,41.67,0.23,1620,2455,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J005745.71-011356.3',0.332633,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12471,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 07717',NULL,12471,41.55,0.18,2040,2455,70,NULL,'SALT 2','SDSS J005745.71-011356.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12472,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 07717',NULL,12472,41.59,0.18,2080,2455,70,NULL,'SALT 2, Malmquist cor.','SDSS J005745.71-011356.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12473,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12473,37.22,0.83,278,2456,70,NULL,NULL,'2MASX J00574586-1129204',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'17.06',0.3,NULL,NULL,NULL,NULL,NULL,1,14.4410417,-11.48903,0.046,NULL,35250131773,550783308,8605989,17.06),(12474,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12474,34.97,0.46,98.6,2457,70,NULL,NULL,'2MASX J00574642-0913084',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000096,NULL,'15.3g',0.32,'S0',NULL,NULL,NULL,NULL,1,14.443375,-9.21892,0.2,NULL,35251217905,550800279,8606254,15.3),(12475,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12475,35.17,0.49,108,2457,70,NULL,NULL,'2MASX J00574642-0913084',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12476,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12476,36.29,0.63,181,2458,70,NULL,NULL,'2MASX J00574648-0034565',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00008,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,14.443625,-0.58231,0.091,NULL,34521181752,539393464,8428022,16.4),(12477,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12477,36.45,0.07,195,2458,70,NULL,NULL,'2MASX J00574648-0034565',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12478,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12478,34.45,0.49,77.6,2459,75,NULL,'IR','NGC 0325',NULL,'2011yCatp016004901K',2011,1,1.57,NULL,'G',0.000013,NULL,'15',0.21,'Sb',NULL,NULL,NULL,NULL,1,14.4494583,-5.11208,0.214,NULL,34559155027,539986797,8437293,15),(12479,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12479,34.67,0.36,86,2459,NULL,NULL,'Malmquist cor.','NGC 0325',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12480,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12480,34.87,NULL,94,2459,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 0325',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12481,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12481,34.87,NULL,94.4,2459,NULL,NULL,'Dipole + Quadrupole','NGC 0325',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12482,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12482,34.88,NULL,94.7,2459,NULL,NULL,'Dipole','NGC 0325',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12483,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12483,35.04,0.31,102,2459,NULL,NULL,NULL,'NGC 0325',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12484,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12484,35.08,0.2,104,2459,74.4,NULL,NULL,'NGC 0325',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12485,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12485,36.45,0.07,195,2460,70,NULL,NULL,'2MASX J00574877-0100145',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000073,NULL,'16.9g',0.23,'S0','Group member',NULL,NULL,NULL,1,14.453083,-1.00406,0.115,NULL,34520663225,539385362,8427896,16.9),(12486,'D-Sigma','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12486,33.71,0.4,55.1,2461,75,NULL,'Edat, raw','NGC 0315',NULL,'1997ApJS..109..333W',1997,1,2.08,NULL,'G',0.00002,NULL,'12.2',1.54,'E+:;LINER;Sy3b Sy1','in a radial-velocity based grouping',NULL,'radio jet','Flat-Spectrum Radio Source',1,14.453667,30.35244,0.261,NULL,67264675547,1051010555,16422039,12.2),(12487,'D-Sigma','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12487,34.04,0.4,64.3,2461,75,NULL,'Edat, cor','NGC 0315',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12488,'Faber-Jackson','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12488,33.55,0.55,51.3,2461,95,NULL,'Weighted Mean','NGC 0315',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12489,'Faber-Jackson','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12489,33.55,0.55,51.3,2461,95,NULL,'de Vaucouleurs','NGC 0315',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12490,'Tertiary','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12490,33.54,0.5,51.1,2461,95,NULL,NULL,'NGC 0315',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12491,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12491,33.54,0.45,51,2461,NULL,NULL,'K','NGC 0315',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12492,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12492,34.16,0.4,68,2461,NULL,NULL,'mean','NGC 0315',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12493,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12493,37.45,0.61,309,2462,70,NULL,NULL,'2MASX J00574895-1624470',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.49',0.24,NULL,NULL,NULL,NULL,NULL,1,14.4539166667,-16.41306,0.021,NULL,35428687103,553573235,8649581,16.49),(12494,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12494,37.39,0.46,301,2463,70,NULL,NULL,'2MASX J00575330+0025496',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000086,NULL,'16.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,14.4719583333,0.43042,0.078,NULL,66679944843,1041874138,16279283,16.5),(12495,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12495,37.19,0.83,274,2464,70,NULL,NULL,'2MASX J00575352-0927143',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.000074,NULL,'16.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,14.4730417,-9.45417,0.2,NULL,35251882132,550810658,8606416,16.3),(12496,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12496,36.45,0.07,195,2465,70,NULL,NULL,'CGCG 384-050',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000087,NULL,'15.9g',0.42,'E','Group member',NULL,NULL,NULL,1,14.4737083333,-0.81472,0.074,NULL,34520521417,539383147,8427861,15.9),(12497,'IRAS','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12497,34.23,0.8,70,2466,75,NULL,'MAT, I','NGC 0327',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'14.5b',0.7,'SB(s)bc:','Pair member (points to parent)',NULL,NULL,NULL,1,14.480667,-5.13042,0.214,NULL,34559142781,539986605,8437290,14.5),(12498,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12498,34.41,0.4,76.1,2466,NULL,NULL,'mean','NGC 0327',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12499,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12499,34.43,0.31,76.9,2466,NULL,NULL,'Malmquist cor.','NGC 0327',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12500,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12500,34.46,0.46,78,2466,NULL,NULL,'J','NGC 0327',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12501,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12501,34.49,0.47,79,2466,NULL,NULL,'H','NGC 0327',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12502,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12502,34.5,0.3,79.3,2466,NULL,NULL,NULL,'NGC 0327',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12503,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12503,34.52,0.43,80.3,2466,75,NULL,'MAT, I, raw','NGC 0327',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12504,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12504,34.52,0.45,80.3,2466,NULL,NULL,'K','NGC 0327',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12505,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12505,34.54,0.2,80.9,2466,74.4,NULL,NULL,'NGC 0327',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12506,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12506,34.61,0.43,83.7,2466,75,NULL,'MAT, I, cor','NGC 0327',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12507,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12507,34.64,0.32,84.8,2466,85,NULL,'I, raw','NGC 0327',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12508,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12508,34.72,0.32,87.8,2466,85,NULL,'I, inv','NGC 0327',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12509,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12509,34.83,0.43,92.4,2466,75,NULL,'MAT, I, inv','NGC 0327',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12510,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12510,36.53,0.46,202,2467,70,NULL,NULL,'2MASX J00575650-0931303',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000077,NULL,'15.5g',0.5,'S0^-',NULL,NULL,NULL,NULL,1,14.4855,-9.52525,0.16,NULL,35251630835,550806731,8606355,15.5),(12511,'Quasar spectrum','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12511,42.96,NULL,3900,2468,NULL,NULL,NULL,'[HB89] 0055-269',NULL,'2002A&A...381L..57D',2002,1,NULL,NULL,'QSO',0.001,NULL,'17.1',NULL,NULL,NULL,NULL,NULL,'QSO',1,14.4913333333,-26.72058,0.073,NULL,34727661186,542619706,8478432,17.1),(12512,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 20870',NULL,12512,39.71,0.22,874,2469,70,NULL,'SN photometric redshift distance, z photo =0.230 +/- 0.029','SDSS-II SN 20870',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.3g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,14.4977917,-0.68633,0.091,NULL,34520993758,539390527,8427976,21.3),(12513,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 20870','R',12513,41.03,0.18,1270,2469,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20870',0.267532,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12514,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 20870','R',12514,41.1,0.27,1310,2469,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20870',0.267532,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12515,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 20870',NULL,12515,40.97,0.16,1560,2469,70,NULL,'SALT 2','SDSS-II SN 20870',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12516,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 20870',NULL,12516,41,0.16,1580,2469,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20870',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12517,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12517,36.45,0.4,195,2470,NULL,NULL,'Malmquist cor.','6dF J0057599-012509',NULL,'2009ApJS..182..474S',2009,1,0.49,NULL,'G',0.000023,NULL,'16.02',0.13,'Scd',NULL,NULL,NULL,NULL,1,14.4996666667,-1.41903,0.129,NULL,34522366920,539411983,8428312,16.02),(12518,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12518,36.69,0.36,218,2470,NULL,NULL,NULL,'6dF J0057599-012509',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12519,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12519,36.73,0.2,222,2470,74.4,NULL,NULL,'6dF J0057599-012509',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12520,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12520,38.02,0.46,402,2471,70,NULL,NULL,'SDSS J005800.10+141445.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000076,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,14.5004583,14.24583,0.129,NULL,67592030421,1056125475,16501960,18.5),(12521,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12521,36.45,0.07,195,2472,70,NULL,NULL,'2MASX J00580047-0017275',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000077,NULL,'15.8g',0.38,'NLAGN',NULL,NULL,NULL,'Sy 2',1,14.501917,-0.29089,0.079,NULL,34521040979,539391265,8427988,15.8),(12522,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12522,33.93,0.43,61.2,2473,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 501-055',NULL,'2014MNRAS.444..527S',2014,1,0.6,NULL,'G',0.00003,NULL,'15.4',0.3,'S','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,14.505417,30.70508,0.201,NULL,67264622873,1051009732,16422027,15.4),(12523,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12523,33.95,0.43,61.6,2473,75,NULL,'3.6 micron, color corrected','CGCG 501-055',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12524,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12524,33.96,0.2,61.9,2473,74.4,NULL,NULL,'CGCG 501-055',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12525,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12525,34.67,0.57,85.8,2474,70,NULL,NULL,'NGC 0329',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000033,NULL,'14.40',0.6,'Sb: sp         HII?','Pair member (points to parent)',NULL,NULL,NULL,1,14.506667,-5.07122,0.203,NULL,34559138357,539986536,8437289,14.4),(12526,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12526,34.53,0.29,80.6,2474,NULL,NULL,'Malmquist cor.','NGC 0329',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12527,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12527,34.74,0.26,88.6,2474,NULL,NULL,NULL,'NGC 0329',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12528,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12528,34.78,0.2,90.4,2474,74.4,NULL,NULL,'NGC 0329',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12529,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12529,36.02,0.59,160,2475,70,NULL,NULL,'2MASX J00580256-0202175',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.000093,NULL,'16.77',0.33,NULL,NULL,NULL,NULL,NULL,1,14.510667,-2.03828,0.151,NULL,34522212291,539409567,8428274,16.77),(12530,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12530,35.14,0.46,107,2476,70,NULL,NULL,'2MASX J00580316-4637020',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.000133,NULL,'15.58',0.52,'E',NULL,NULL,NULL,NULL,1,14.51325,-46.61725,NULL,NULL,38139932731,595936448,9311507,15.58),(12531,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 08421','RN',12531,41.87,0.36,1600,2477,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 08421',0.479268,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12532,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 08421','N',12532,41.74,0.25,2230,2477,70,NULL,'SALT 2','SDSS-II SN 08421',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12533,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 08421','N',12533,41.86,0.25,2360,2477,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 08421',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12534,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12534,37.03,0.58,255,2478,70,NULL,NULL,'2MASX J00580495-1642358',NULL,'2014MNRAS.445.2677S',2014,1,0.31,NULL,'G',0.00015,NULL,'17.06',0.28,NULL,NULL,NULL,NULL,NULL,1,14.520667,-16.70989,0.008,NULL,35429281245,553582519,8649726,17.06),(12535,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 20965','RN',12535,41.86,0.3,1690,2479,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20965',0.390807,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12536,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 20965','RN',12536,42.06,0.24,1860,2479,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20965',0.390807,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12537,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12537,37.13,0.46,267,2480,70,NULL,NULL,'2MASX J00580631+1431077',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000071,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,14.526417,14.51881,0.129,NULL,67592186771,1056127918,16501998,18.3),(12538,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12538,36.45,0.07,195,2481,70,NULL,NULL,'2MASX J00580662-0034344',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000078,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,14.5275,-0.57619,0.091,NULL,34521175351,539393364,8428021,16.9),(12539,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12539,36.95,0.12,245,2482,70,NULL,NULL,'MCG -02-03-051',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.00009,NULL,'14.9g',0.65,'E0',NULL,NULL,NULL,NULL,1,14.533667,-10.12069,0.169,NULL,35251562161,550805658,8606338,14.9),(12540,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12540,33.48,0.47,49.7,2483,70,NULL,NULL,'MCG -01-03-049',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000027,NULL,'14.33',1,'SAB(s)0-?',NULL,NULL,NULL,NULL,1,14.5455417,-8.217,0.301,NULL,34534030727,539594230,8431159,14.33),(12541,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12541,37.3,0.27,288,2484,70,NULL,NULL,'2MASX J00581440+1453148',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000096,NULL,'16.3g',0.38,'BrClG',NULL,NULL,NULL,NULL,1,14.5600417,14.88739,0.117,NULL,67589300180,1056082815,16501293,16.3),(12542,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12542,37.3,0.27,288,2485,70,NULL,NULL,'2MASX J00581488+1455398',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00006,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,14.562,14.92764,0.117,NULL,67589281484,1056082523,16501289,17.9),(12543,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12543,37.43,0.46,306,2486,70,NULL,NULL,'2MASX J00581652+1506478',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00008,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,14.5688333333,15.11331,0.117,NULL,67589194044,1056081156,16501268,17.9),(12544,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12544,37.82,0.46,366,2487,70,NULL,NULL,'SDSS J005817.73+003939.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000083,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,14.573875,0.66108,0.057,NULL,66679763424,1041871303,16279239,18.3),(12545,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12545,36.83,0.64,232,2488,70,NULL,NULL,'6dF J0058180-010856',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,14.574875,-1.14886,0.128,NULL,34522523506,539414429,8428350,16.9),(12546,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12546,36.77,0.46,226,2489,70,NULL,NULL,'ZwCl 0054.6-0127 41',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000177,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,14.574917,-1.14886,0.128,NULL,34522523506,539414429,8428350,16.5),(12547,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12547,34.81,0.49,91.7,2490,70,NULL,NULL,'MCG -03-03-010',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000029,NULL,'14.50',0.8,'(R)SB(r)ab:',NULL,NULL,NULL,NULL,1,14.582375,-15.39181,0.019,NULL,35371758792,552683731,8635683,14.5),(12548,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12548,34.49,0.4,78.9,2490,NULL,NULL,'mean','MCG -03-03-010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12549,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12549,34.72,0.47,87.8,2490,NULL,NULL,'H','MCG -03-03-010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12550,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12550,34.82,0.46,92.1,2490,NULL,NULL,'J','MCG -03-03-010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12551,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12551,34.87,0.45,94.2,2490,NULL,NULL,'K','MCG -03-03-010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12552,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 12916','RN',12552,41.78,0.17,1790,2491,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 12916',0.265343,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12553,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12553,35.66,0.62,136,2492,70,NULL,NULL,'MCG +00-03-044',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00009,NULL,'17.06',0.2,NULL,NULL,NULL,NULL,NULL,1,14.5857083,-1.93683,0.151,NULL,34522264301,539410379,8428287,17.06),(12554,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12554,36.91,0.56,241,2493,70,NULL,NULL,'2MASX J00582177-0600059',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.71',0.31,NULL,NULL,NULL,NULL,NULL,1,14.5907083,-6.00172,0.256,NULL,34533011521,539578305,8430911,16.71),(12555,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12555,35.94,0.65,154,2494,70,NULL,NULL,'2MFGC 00701',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'16.55',0.26,NULL,NULL,NULL,NULL,NULL,1,14.5918333333,-50.09553,NULL,NULL,38148472757,596069886,9313591,16.55),(12556,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12556,35.51,0.43,126,2495,NULL,NULL,'Malmquist cor.','ESO 351- G 025',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.12',0.7,'SB(s)b; Sy2    LINER',NULL,NULL,NULL,NULL,1,14.593,-36.66014,NULL,NULL,38152197304,596128082,9314501,15.12),(12557,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12557,35.65,0.4,135,2495,NULL,NULL,NULL,'ESO 351- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12558,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12558,35.7,0.2,138,2495,74.4,NULL,NULL,'ESO 351- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12559,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12559,38.04,0.46,405,2496,70,NULL,NULL,'2MASX J00582251-0940499',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000094,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,14.593625,-9.68061,0.16,NULL,35251651807,550807059,8606360,17.6),(12560,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12560,35.82,0.45,146,2497,70,NULL,NULL,'NGC 0326 NED01',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.00005,NULL,'14.1V',NULL,'cD',NULL,NULL,NULL,NULL,1,14.594333,26.86625,0.209,NULL,67286528042,1051352000,16427375,14.1),(12561,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12561,35.67,0.25,136,2498,74.4,NULL,NULL,'NGC 0326',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'GPair',0.0001,NULL,NULL,NULL,'E+ pec',NULL,NULL,'radio jet',NULL,1,14.594583,26.86528,0.209,NULL,67286528062,1051352000,16427375,NULL),(12562,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2005ef',NULL,12562,37.54,0.12,291,2499,74.2,NULL,'SALT 2','2MASX J00582300+0040456',0.108,'2010ApJ...716..712A',2010,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,14.595833,0.67942,0.057,NULL,66679762840,1041871294,16279238,17.8),(12563,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 00739','R',12563,38.32,0.18,416,2499,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ef','2MASX J00582300+0040456',0.11,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12564,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 00739','R',12564,38.58,0.12,469,2499,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ef','2MASX J00582300+0040456',0.11,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12565,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12565,34.48,0.47,78.5,2500,NULL,NULL,'H','UGC 00600',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000023,NULL,'14.0',1.1,'SAB(s)b',NULL,NULL,NULL,NULL,1,14.600417,48.662,0.885,NULL,67695313620,1057739275,16527176,14),(12566,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12566,34.8,0.4,91.2,2500,NULL,NULL,'mean','UGC 00600',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12567,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12567,34.83,0.45,92.3,2500,NULL,NULL,'K','UGC 00600',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12568,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12568,34.83,0.46,92.6,2500,NULL,NULL,'J','UGC 00600',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12569,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12569,38.39,0.46,476,2501,70,NULL,NULL,'2MASX J00582414+0019566',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,14.6005,0.33225,0.078,NULL,66679906943,1041873545,16279274,17.8),(12570,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12570,36.69,0.66,218,2502,70,NULL,NULL,'2MASX J00582468-0149387',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.0001,NULL,'17.02',0.31,NULL,NULL,NULL,NULL,NULL,1,14.602833,-1.82744,0.14,NULL,34522247081,539410110,8428282,17.02),(12571,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12571,37.25,0.77,281,2503,70,NULL,NULL,'2MASX J00582874-1623268',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.85',0.44,NULL,NULL,NULL,NULL,NULL,1,14.6197083,-16.39075,0.021,NULL,35429169920,553580780,8649699,15.85),(12572,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12572,36.45,0.07,195,2504,70,NULL,NULL,'2MASX J00583096-0025027',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000093,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,14.629125,-0.41733,0.085,NULL,34521191841,539393622,8428025,17.1),(12573,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12573,38.49,0.46,499,2505,70,NULL,NULL,'2MASXi J0058314+144339',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000081,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,14.630917,14.72778,0.129,NULL,67591282957,1056113796,16501778,18.2),(12574,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12574,34.22,NULL,69.7,2506,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00604',NULL,'2010Ap&SS.325..163P',2010,1,1.16,NULL,'G',0.000037,NULL,'18.',0.09,'Sd',NULL,NULL,NULL,NULL,1,14.6479583,45.00522,0.613,NULL,67697861911,1057779092,16527798,18),(12575,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12575,34.22,NULL,69.9,2506,NULL,NULL,'Dipole','UGC 00604',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12576,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12576,34.22,NULL,69.9,2506,NULL,NULL,'Dipole + Quadrupole','UGC 00604',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12577,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12577,34.22,NULL,70,2506,NULL,NULL,NULL,'UGC 00604',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12578,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12578,35.4,0.2,120,2506,74.4,NULL,NULL,'UGC 00604',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12579,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12579,35.52,0.72,127,2506,NULL,NULL,NULL,'UGC 00604',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12580,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12580,35.72,0.66,139,2506,NULL,NULL,'Malmquist cor.','UGC 00604',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12581,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12581,36.2,0.46,174,2507,70,NULL,NULL,'2MASX J00583972-0940239',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000076,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,14.6655416667,-9.67325,0.171,NULL,35262973324,550983958,8609124,16.4),(12582,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12582,37.54,0.46,322,2508,70,NULL,NULL,'2MASX J00584049-0011087',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.51',0.2,NULL,NULL,NULL,NULL,NULL,1,14.6688333333,-0.18592,0.073,NULL,34521082056,539391907,8427998,18.51),(12583,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12583,35.77,0.6,143,2509,70,NULL,NULL,'2MASX J00584068-1621272',NULL,'2014MNRAS.445.2677S',2014,1,0.71,NULL,'G',0.00015,NULL,'15.34',0.43,NULL,NULL,NULL,NULL,NULL,1,14.6695416667,-16.35756,0.021,NULL,35429157870,553580591,8649696,15.34),(12584,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12584,35.3,0.82,115,2510,70,NULL,NULL,'MCG +02-03-019',NULL,'2001MNRAS.321..277C',2001,1,0.4,NULL,'G',0.00012,NULL,'14.74',0.4,'E/S0',NULL,NULL,NULL,NULL,1,14.672167,12.69311,0.165,NULL,67594255604,1056160243,16502503,14.74),(12585,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12585,35.42,0.53,121,2511,70,NULL,NULL,'FAIRALL 1226',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'15.2R',0.25,NULL,NULL,NULL,NULL,NULL,1,14.682333,-76.79661,0.205,NULL,35591975949,556124624,8689447,15.2),(12586,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12586,35.21,0.69,110,2512,100,NULL,'mid-IR','IC 0062',NULL,'2013ApJ...771...88L',2013,1,1,NULL,'G',0.000107,NULL,'15.0',0.7,'S',NULL,NULL,NULL,NULL,1,14.6830833333,11.808,0.165,NULL,67579735543,1055933367,16498958,15),(12587,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1999ef',NULL,12587,35.53,0.22,123,2513,74.2,NULL,'SALT 2','UGC 00607',0.03914,'2010ApJ...716..712A',2010,1,1,NULL,'G',0.000143,NULL,'14.95',1,'Scd?',NULL,NULL,NULL,NULL,1,14.6871666667,12.74836,0.169,NULL,67593733870,1056152091,16502376,14.95),(12588,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1999ef',NULL,12588,36.05,0.17,162,2513,70.8,NULL,NULL,'UGC 00607',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12589,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1999ef',NULL,12589,36.22,0.08,175,2513,74.4,NULL,NULL,'UGC 00607',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12590,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1999ef',NULL,12590,36.31,0.16,176,2513,70,NULL,'SALT 2','UGC 00607',0.03914,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12591,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1999ef',NULL,12591,36.31,0.09,176,2513,70,NULL,'SALT','UGC 00607',0.03914,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12592,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1999ef',NULL,12592,36.42,0.04,185,2513,72,NULL,NULL,'UGC 00607',0.03914,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12593,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1999ef',NULL,12593,36.51,0.19,193,2513,65,NULL,'SALT2','UGC 00607',0.03914,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12594,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1999ef',NULL,12594,36.66,0.11,198,2513,65,NULL,'MLCS2k2','UGC 00607',0.03914,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12595,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1999ef',NULL,12595,36.6,0.16,201,2513,65,NULL,'MLCS17','UGC 00607',0.03914,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12596,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1999ef',NULL,12596,36.67,0.16,207,2513,65,NULL,'MLCS31','UGC 00607',0.03914,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12597,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1999ef',NULL,12597,36.67,0.18,208,2513,65,NULL,NULL,'UGC 00607',0.03914,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12598,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1999ef',NULL,12598,36.75,0.14,224,2513,60,NULL,NULL,'UGC 00607',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12599,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12599,37.3,0.27,288,2514,70,NULL,NULL,'2MASX J00584522+1453210',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000098,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,14.68825,14.88908,0.137,NULL,67589292766,1056082699,16501292,16.8),(12600,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12600,37.13,0.58,267,2515,70,NULL,NULL,'2MASX J00584540-1543392',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,14.689167,-15.72753,0.008,NULL,35428135929,553564623,8649447,14.3),(12601,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 14554','R',12601,42.08,0.48,2080,2516,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14554',0.250867,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,14.692083,0.88867,0.061,NULL,66680072622,1041876134,16279314,NULL),(12602,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 14554',NULL,12602,41.59,NULL,2080,2516,70,NULL,'SN photometric redshift distance, z photo =0.700 +/- 0.001','SDSS-II SN 14554',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12603,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12603,36.45,0.07,195,2517,70,NULL,NULL,'2MASX J00584679-0045067',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00011,NULL,'15.9g',0.35,'E0',NULL,NULL,NULL,NULL,1,14.694917,-0.75181,0.108,NULL,34520513310,539383020,8427859,15.9),(12604,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12604,36.72,0.56,220,2517,70,NULL,NULL,'2MASX J00584679-0045067',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12605,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12605,35.66,0.25,136,2518,74.4,NULL,NULL,'GIN 026',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000063,NULL,'14.8V',0.4,'E/S0',NULL,NULL,NULL,NULL,1,14.6975833333,26.97758,0.209,NULL,67286537042,1051352141,16427377,14.8),(12606,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12606,35.82,0.45,146,2518,70,NULL,NULL,'GIN 026',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12607,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12607,36.94,0.27,244,2519,70,NULL,NULL,'2MASX J00584829+0027197',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000091,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,14.701167,0.45544,0.078,NULL,66679780567,1041871571,16279243,17.2),(12608,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12608,35.3,0.82,115,2520,70,NULL,NULL,'GIN 035',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',NULL,NULL,'15.40',NULL,'S',NULL,NULL,NULL,NULL,1,14.701125,13.09931,0.141,NULL,67593799070,1056153110,16502392,15.4),(12609,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12609,34.95,0.48,97.7,2521,NULL,NULL,'Malmquist cor.','NGC 0334',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.47',0.6,'(R\')SB(s)b pec:',NULL,NULL,NULL,NULL,1,14.7075416667,-35.11603,NULL,NULL,34863096132,544735877,8511498,14.47),(12610,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12610,35.05,0.45,102,2521,NULL,NULL,NULL,'NGC 0334',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12611,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12611,35.09,0.2,104,2521,74.4,NULL,NULL,'NGC 0334',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12612,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12612,35.51,0.4,126,2521,NULL,NULL,'mean','NGC 0334',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12613,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12613,35.56,0.47,130,2521,NULL,NULL,'H','NGC 0334',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12614,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12614,35.15,0.25,107,2522,74.4,NULL,NULL,'UGC 00610',NULL,'2013AJ....146...86T',2013,1,1.8,NULL,'G',0.000087,NULL,'13.37',1.6,'E','Group member',NULL,NULL,NULL,1,14.713,12.97283,0.141,NULL,67593821992,1056153468,16502397,13.37),(12615,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12615,35.3,0.82,115,2522,70,NULL,NULL,'UGC 00610',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12616,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12616,35.32,0.45,116,2522,NULL,NULL,'K','UGC 00610',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12617,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12617,35.91,0.4,152,2522,NULL,NULL,'mean','UGC 00610',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12618,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12618,36.46,0.5,196,2523,70,NULL,NULL,'NGC 0333B',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000097,NULL,'15.6',1.63,'SB:(r:)0o',NULL,NULL,NULL,NULL,1,14.7137916667,-16.46919,0.021,NULL,35428360216,553568128,8649502,15.6),(12619,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12619,34.6,0.46,83.3,2524,70,NULL,NULL,'2MASX J00585315-0846309',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000023,NULL,'15.3g',0.4,'S0',NULL,NULL,NULL,NULL,1,14.7215,-8.77519,0.233,NULL,35262781754,550980964,8609077,15.3),(12620,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12620,34.9,0.54,95.5,2524,70,NULL,NULL,'2MASX J00585315-0846309',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12621,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12621,37.06,0.46,259,2525,70,NULL,NULL,'2MASX J00585348+1405310',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000085,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,14.723,14.09208,0.121,NULL,67592241004,1056128765,16502011,17.2),(12622,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12622,36.21,0.49,174,2526,70,NULL,NULL,'MCG -03-03-014',NULL,'2014MNRAS.445.2677S',2014,1,1.09,NULL,'G',0.000113,NULL,'14.89',0.46,NULL,NULL,NULL,NULL,NULL,1,14.7337917,-16.86875,0,NULL,35429147555,553580430,8649694,14.89),(12623,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 22168','RN',12623,41.4,0.3,1500,2527,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 22168',0.264849,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12624,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 18966','RN',12624,40.56,0.23,1070,2528,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 18966',0.212318,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12625,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 18966','RN',12625,41.3,0.25,1500,2528,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 18966',0.212318,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12626,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12626,37.6,0.5,331,2529,NULL,NULL,'Malmquist cor.','2MASX J00585745-0039197',NULL,'2009ApJS..182..474S',2009,1,0.53,NULL,'G',0.000023,NULL,'16.9g',0.21,'Sc',NULL,NULL,NULL,NULL,1,14.7393333333,-0.65556,0.091,NULL,34520973235,539390206,8427971,16.9),(12627,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12627,37.72,0.48,350,2529,NULL,NULL,NULL,'2MASX J00585745-0039197',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12628,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12628,37.76,0.2,356,2529,74.4,NULL,NULL,'2MASX J00585745-0039197',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12629,'IRAS','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12629,32.03,0.8,25.4,2530,75,NULL,'MAT, I','ESO 541- G 004',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.00001,NULL,'12.75',1.4,'SAB(rs)bc',NULL,NULL,NULL,NULL,1,14.741667,-18.74267,0.012,NULL,35394288118,553035751,8641183,12.75),(12630,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12630,31.52,0.69,20.1,2530,100,NULL,'mid-IR','ESO 541- G 004',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12631,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12631,32,0.4,25.1,2530,NULL,NULL,NULL,'ESO 541- G 004',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12632,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12632,32,0.39,25.1,2530,73,NULL,'opt','ESO 541- G 004',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12633,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12633,32.23,0.32,27.9,2530,85,NULL,'I, raw','ESO 541- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12634,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12634,32.25,0.32,28.2,2530,85,NULL,'I, inv','ESO 541- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12635,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12635,32.28,0.2,28.6,2530,74.4,NULL,NULL,'ESO 541- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12636,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12636,32.34,0.43,29.3,2530,75,NULL,'3.6 micron, color corrected','ESO 541- G 004',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12637,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12637,32.4,0.43,30.2,2530,75,NULL,'MAT, I, raw','ESO 541- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12638,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12638,32.43,0.43,30.7,2530,75,NULL,'3.6 micron, color + selection bias corrected','ESO 541- G 004',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12639,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12639,32.45,0.66,31,2530,NULL,NULL,NULL,'ESO 541- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12640,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12640,32.51,0.4,31.8,2530,73,NULL,'opt','ESO 541- G 004',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12641,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12641,32.54,0.43,32.2,2530,75,NULL,'MAT, I, cor','ESO 541- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12642,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12642,32.55,0.43,32.4,2530,75,NULL,'MAT, I, inv','ESO 541- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12643,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12643,32.58,0.4,32.8,2530,NULL,NULL,'mean','ESO 541- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12644,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12644,32.6,0.61,33.1,2530,NULL,NULL,'Malmquist cor.','ESO 541- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12645,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12645,32.86,0.46,37.3,2530,NULL,NULL,'J','ESO 541- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12646,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12646,32.91,0.47,38.2,2530,NULL,NULL,'H','ESO 541- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12647,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12647,33.01,0.45,40.1,2530,NULL,NULL,'K','ESO 541- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12648,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12648,37.75,0.5,354,2531,NULL,NULL,'Malmquist cor.','2MASX J00585904-0202377',NULL,'2009ApJS..182..474S',2009,1,0.49,NULL,'G',0.000127,NULL,'17.02',0.29,NULL,NULL,NULL,NULL,NULL,1,14.746125,-2.04381,0.151,NULL,34522198833,539409356,8428271,17.02),(12649,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12649,37.85,0.47,372,2531,NULL,NULL,NULL,'2MASX J00585904-0202377',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12650,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12650,37.89,0.2,378,2531,74.4,NULL,NULL,'2MASX J00585904-0202377',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12651,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12651,34.17,0.47,68.2,2532,NULL,NULL,'H','UGC 00612',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.00009,NULL,'14.63',0.4,'S?',NULL,NULL,NULL,NULL,1,14.753625,23.85286,0.117,NULL,67394655239,1053041488,16453773,14.63),(12652,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12652,34.17,0.4,68.4,2532,NULL,NULL,'mean','UGC 00612',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12653,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12653,34.28,0.45,71.7,2532,NULL,NULL,'K','UGC 00612',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12654,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12654,34.39,0.46,75.7,2532,NULL,NULL,'J','UGC 00612',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12655,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12655,36.94,0.27,244,2533,70,NULL,NULL,'2MASX J00590116+0025307',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000127,NULL,'15.23',0.35,'AGN',NULL,NULL,NULL,NULL,1,14.7549583333,0.42525,0.078,NULL,66679770971,1041871421,16279240,15.23),(12656,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12656,32.83,0.4,36.8,2534,NULL,NULL,NULL,'UGC 00608',NULL,'2009AJ....138..323T',2009,1,1.9,NULL,'G',0.000013,NULL,'14.9',0.9,'SABdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,14.759583,48.01869,0.769,NULL,67695354004,1057739906,16527186,14.9),(12657,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12657,32.95,0.4,38.9,2534,75,NULL,'B','UGC 00608',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12658,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 20557',NULL,12658,40.25,0.38,1120,2535,70,NULL,'SN photometric redshift distance, z photo =0.307 +/- 0.073','SDSS-II SN 20557',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','22.4g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,14.761625,-0.3095,0.085,NULL,34521056904,539391514,8427992,22.4),(12659,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 20557','R',12659,41.74,0.31,1550,2535,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20557',0.435745,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12660,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 20557','R',12660,41.76,0.29,1570,2535,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20557',0.435745,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12661,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 20557',NULL,12661,41.65,0.21,2140,2535,70,NULL,'SALT 2','SDSS-II SN 20557',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12662,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 20557',NULL,12662,41.73,0.21,2220,2535,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20557',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12663,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 15082','RN',12663,42.05,0.24,1980,2536,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 15082',0.30128,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12664,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 15082','RN',12664,42.58,0.26,2520,2536,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 15082',0.30128,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12665,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12665,36.8,0.46,229,2537,70,NULL,NULL,'2MASX J00590690-1056116',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000096,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,14.778667,-10.93664,0.088,NULL,35263742366,550995974,8609312,16.7),(12666,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 15497','RN',12666,41.38,0.24,1570,2538,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15497',0.203063,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12667,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 15497','RN',12667,42.48,0.3,2600,2538,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15497',0.203063,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12668,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12668,37.84,0.46,370,2539,70,NULL,NULL,'2MASXi J0059103-005653',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000092,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,14.7930417,-0.94833,0.108,NULL,34522439124,539413111,8428329,18.1),(12669,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12669,36.4,0.38,190,2540,NULL,NULL,'Malmquist cor.','2MASX J00591051-0153577',NULL,'2009ApJS..182..474S',2009,1,0.61,NULL,'G',0.000023,NULL,'16.79',0.24,NULL,NULL,NULL,NULL,NULL,1,14.7937917,-1.89936,0.151,NULL,34522168571,539408883,8428263,16.79),(12670,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12670,36.52,0.36,202,2540,NULL,NULL,NULL,'2MASX J00591051-0153577',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12671,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12671,36.57,0.2,206,2540,74.4,NULL,NULL,'2MASX J00591051-0153577',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12672,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12672,36.45,0.07,195,2541,70,NULL,NULL,'2MASX J00591510-0013303',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000104,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,14.812833,-0.22514,0.073,NULL,34520786232,539387284,8427926,17.1),(12673,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12673,38.02,0.33,402,2542,70,NULL,NULL,'SDSS J005915.38+141727.0',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000085,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,14.8140833333,14.29086,0.133,NULL,67592194469,1056128038,16502000,18.7),(12674,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 13175','RN',12674,43.18,0.23,3050,2543,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13175',0.418758,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12675,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 13175','RN',12675,43.35,0.25,3290,2543,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13175',0.418758,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12676,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12676,33.11,0.43,41.8,2544,75,NULL,'3.6 micron, color + selection bias corrected','ESO 541- G 005',NULL,'2014MNRAS.444..527S',2014,1,1.2,NULL,'G',0.000007,NULL,'15.77',0.6,'SB(rs)dm?',NULL,NULL,NULL,NULL,1,14.8254583,-20.57897,0.117,NULL,35398389719,553099839,8642184,15.77),(12677,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 21064','R',12677,39.28,0.09,667,2545,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2007qb','SN 2007qb',0.07897,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'II',NULL,NULL,NULL,NULL,1,14.8280417,-0.94706,0.108,NULL,34523145592,539424149,8428502,NULL),(12678,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 21064','R',12678,39.6,0.23,772,2545,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2007qb','SN 2007qb',0.07897,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12679,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12679,37.17,0.46,272,2546,70,NULL,NULL,'2MASX J00591941+1557197',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000072,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,14.831,15.95561,0.121,NULL,67635037743,1056797464,16512460,17.9),(12680,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12680,34.11,0.49,66.4,2547,75,NULL,'IR','NGC 0335',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'15.38',0.3,'Sbc? sp',NULL,NULL,NULL,NULL,1,14.8324166667,-18.23467,0.033,NULL,35394631886,553041123,8641267,15.38),(12681,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12681,36.16,0.5,171,2548,70,NULL,NULL,'LCRS B005702.6-443550',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.000103,NULL,'15.88',0.35,'S',NULL,NULL,NULL,NULL,1,14.8334583333,-44.32772,NULL,NULL,38171669036,596432328,9319255,15.88),(12682,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12682,35.85,0.51,148,2549,70,NULL,NULL,'2MASX J00592008-6329341',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.23',0.5,'S0',NULL,NULL,NULL,NULL,1,14.8337083,-63.49283,0,NULL,36064910724,563514230,8804909,16.23),(12683,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 07412','RN',12683,42.07,0.31,1890,2550,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 07412',0.374888,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12684,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 07412','RN',12684,42.64,0.48,2460,2550,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 07412',0.374888,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12685,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12685,36.94,0.27,244,2551,70,NULL,NULL,'SDSS J005922.25+002917.7',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000113,NULL,'16.92',0.36,'AGN',NULL,NULL,NULL,NULL,1,14.84275,0.48828,0.126,NULL,66679334613,1041864603,16279134,16.92),(12686,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12686,38.02,0.33,402,2552,70,NULL,NULL,'2MASX J00592247+1417447',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000086,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,14.8435417,14.29572,0.133,NULL,67592080977,1056126265,16501972,17),(12687,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12687,34.13,0.58,67.1,2553,70,NULL,NULL,'ARP 121 NED01',NULL,'2014MNRAS.445.2677S',2014,1,2.1,NULL,'G',0.000037,NULL,'14.5',0.6,'Sa pec sp',NULL,NULL,NULL,NULL,1,14.848667,-4.80319,0.184,NULL,34559976970,539999640,8437494,14.5),(12688,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12688,34.49,0.4,78.9,2553,NULL,NULL,'mean','ARP 121 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12689,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12689,34.52,0.47,80.1,2553,NULL,NULL,'H','ARP 121 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12690,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12690,34.56,0.45,81.7,2553,NULL,NULL,'K','ARP 121 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12691,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12691,34.63,0.46,84.2,2553,NULL,NULL,'J','ARP 121 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12692,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12692,34.76,0.49,89.7,2553,75,NULL,'IR','ARP 121 NED01',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12693,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2005ho',NULL,12693,36.43,0.12,182,2554,74.2,NULL,'SALT 2','SDSS J005924.11+000009.5',0.062814,'2010ApJ...716..712A',2010,1,0.23,NULL,'G',0.000032,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,14.8505,0.00267,0.044,NULL,66679342094,1041864720,16279136,17.5),(12694,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2005ho',NULL,12694,37.01,0.1,252,2554,74.4,NULL,NULL,'SDSS J005924.11+000009.5',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12695,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2005ho',NULL,12695,37.16,0.13,254,2554,70,NULL,'SDSS-II SN 03901, SALT 2','SDSS J005924.11+000009.5',0.062814,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12696,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2005ho',NULL,12696,37.16,0.08,254,2554,65,NULL,'SALT2','SDSS J005924.11+000009.5',0.062814,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12697,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 03901','R',12697,37.18,0.18,256,2554,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ho','SDSS J005924.11+000009.5',0.062814,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12698,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2005ho',NULL,12698,37.22,0.03,262,2554,70,NULL,'SDSS-II SN 03901','SDSS J005924.11+000009.5',0.062814,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12699,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2005ho',NULL,12699,37.14,0.08,268,2554,70,NULL,'SALT 2','SDSS J005924.11+000009.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12700,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2005ho',NULL,12700,37.15,0.08,269,2554,70,NULL,'SALT 2, Malmquist cor.','SDSS J005924.11+000009.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12701,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 03901','R',12701,37.43,0.04,288,2554,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ho','SDSS J005924.11+000009.5',0.062814,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12702,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2005ho',NULL,12702,37.46,0.06,292,2554,65,NULL,'MLCS2k2','SDSS J005924.11+000009.5',0.062814,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12703,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12703,35.66,0.25,136,2555,74.4,NULL,NULL,'IC 0064',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000077,NULL,'13.9V',1.1,'E/S0           AGN',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,14.85175,27.05906,0.249,NULL,67286578092,1051352782,16427387,13.9),(12704,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12704,35.82,0.45,146,2555,70,NULL,NULL,'IC 0064',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12705,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12705,36.89,0.8,239,2556,70,NULL,NULL,'2MASX J00592558-1353562',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'17.10',0.27,NULL,NULL,NULL,NULL,NULL,1,14.8567083,-13.89894,0.011,NULL,35379382355,552802849,8637544,17.1),(12706,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12706,34.82,0.56,92.1,2557,70,NULL,NULL,'ARP 121 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.6,'The APM image includes a superposed star.','G',0.000147,NULL,'15.35',0.6,'SA0o: pec',NULL,NULL,NULL,NULL,1,14.859,-4.7945,0.184,NULL,34559977069,539999641,8437494,15.35),(12707,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12707,37.62,0.46,334,2558,70,NULL,NULL,'2MASX J00592771-0856560',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000083,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,14.865625,-8.949,0.211,NULL,35262760013,550980625,8609072,17.9),(12708,'CMD','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12708,24.57,0.11,0.82,2559,NULL,NULL,NULL,'PAndAS-48',NULL,'2013ApJ...770L..17M',2013,1,NULL,NULL,'*Ass',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,14.867917,31.48628,0.213,1,67267160874,1051049388,16422646,NULL),(12709,'IRAS','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12709,33.22,0.8,44,2560,75,NULL,'MAT, I','ESO 351- G 028',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.53',0.6,'SB(s)c: pec',NULL,NULL,NULL,NULL,1,14.8724583,-36.18661,NULL,NULL,38152266890,596129170,9314518,14.53),(12710,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12710,32.48,0.32,31.4,2560,85,NULL,'I, inv','ESO 351- G 028',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12711,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12711,32.51,0.32,31.7,2560,85,NULL,'I, raw','ESO 351- G 028',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12712,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12712,32.82,0.43,36.7,2560,75,NULL,'MAT, I, inv','ESO 351- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12713,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12713,32.83,0.43,36.9,2560,75,NULL,'MAT, I, raw','ESO 351- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12714,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12714,33.22,0.43,44.1,2560,75,NULL,'MAT, I, cor','ESO 351- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12715,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12715,33.24,0.2,44.5,2560,74.4,NULL,NULL,'ESO 351- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12716,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12716,33.76,0.55,56.5,2560,NULL,NULL,NULL,'ESO 351- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12717,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12717,33.94,0.51,61.5,2560,NULL,NULL,'Malmquist cor.','ESO 351- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12718,'RR Lyrae','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12718,23.68,0.03,0.545,2561,NULL,NULL,'8, V, Clementini et al. (2003), MV = 0.438 mag, [Fe/H] _ -1.8 dex (Z _ 0.0003)','ANDROMEDA XVI',NULL,'2016ApJ...819..147M',2016,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'dSph',NULL,NULL,NULL,NULL,1,14.874167,32.37667,0.145,1,67274587952,1051165436,16424459,NULL),(12719,'RR Lyrae','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12719,23.7,0.03,0.55,2561,NULL,NULL,'8, V, Bono et al. (2003), MV = 0.360 mag, [Fe/H] _ -1.8 dex (Z _ 0.0003)','ANDROMEDA XVI',NULL,'2016ApJ...819..147M',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12720,'RR Lyrae','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12720,23.72,0.09,0.555,2561,NULL,NULL,'8, V, Clementini et al. (2003), MV = 0.438 mag','ANDROMEDA XVI',NULL,'2016ApJ...819..147M',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12721,'RR Lyrae','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12721,23.74,0.03,0.56,2561,NULL,NULL,'8, V, Clementini et al. (2003), MV = 0.438 mag, [Fe/H] _ -2.3 dex (Z _ 0.0001)','ANDROMEDA XVI',NULL,'2016ApJ...819..147M',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12722,'RR Lyrae','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12722,23.77,0.06,0.568,2561,NULL,NULL,'8, V, Bono et al. (2003), MV = 0.360 mag, [Fe/H] _ -2.3 dex (Z _ 0.0001)','ANDROMEDA XVI',NULL,'2016ApJ...819..147M',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12723,'RR Lyrae','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12723,23.79,0.08,0.573,2561,NULL,NULL,'8, V, Bono et al. (2003), MV = 0.360 mag','ANDROMEDA XVI',NULL,'2016ApJ...819..147M',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12724,'RR Lyrae','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12724,23.83,0.07,0.583,2561,NULL,NULL,'1, V, Caputo et al. (2000), [Fe/H]=_2','ANDROMEDA XVI',NULL,'2016ApJ...819..147M',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12725,'TRGB','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12725,23.39,0.19,0.476,2561,NULL,NULL,NULL,'ANDROMEDA XVI',NULL,'2012ApJ...758...11C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12726,'TRGB','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12726,23.6,0.2,0.525,2561,NULL,NULL,'I','ANDROMEDA XVI',NULL,'2009MNRAS.400.1472L',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12727,'TRGB','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12727,23.6,0.2,0.525,2561,NULL,NULL,'I','ANDROMEDA XVI',NULL,'2007ApJ...671.1591I',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12728,'TRGB','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12728,24.13,0.04,0.67,2561,NULL,NULL,'I, upper limit D','ANDROMEDA XVI',NULL,'2016ApJ...819..147M',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12729,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12729,36.28,0.33,180,2562,70,NULL,NULL,'2MASX J00593007-1054200',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000094,NULL,'15.7g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,14.875333,-10.90556,0.088,NULL,35264469003,551007328,8609489,15.7),(12730,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12730,37.11,0.46,264,2563,70,NULL,NULL,'2MASX J00593097-0026122',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000087,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,14.879083,-0.43681,0.085,NULL,34520869097,539388579,8427946,16.7),(12731,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 15433','R',12731,40.21,0.19,902,2564,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006mt','SDSS J005931.05-001524.2',0.22,'2014arXiv1401.3317S',2014,1,0.11,NULL,'G',NULL,NULL,'20.0g',0.07,NULL,NULL,NULL,NULL,NULL,1,14.879375,-0.25672,0.081,NULL,34520900759,539389074,8427954,20),(12732,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 15433','R',12732,40.37,0.11,974,2564,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006mt','SDSS J005931.05-001524.2',0.22,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12733,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2006mt',NULL,12733,40.1,0.08,1050,2564,70,NULL,'SALT 2','SDSS J005931.05-001524.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12734,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2006mt',NULL,12734,40.12,0.08,1060,2564,70,NULL,'SALT 2, Malmquist cor.','SDSS J005931.05-001524.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12735,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12735,38.75,0.46,563,2565,70,NULL,NULL,'2MASX J00593446-0855330',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000101,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,14.8935,-8.92586,0.211,NULL,35262739477,550980304,8609067,17.7),(12736,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12736,35.15,0.25,107,2566,74.4,NULL,NULL,'CGCG 435-033',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00011,NULL,'14.28',0.4,'E','Group member',NULL,NULL,NULL,1,14.9000417,12.98625,0.121,NULL,67593609549,1056150149,16502346,14.28),(12737,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12737,35.3,0.82,115,2566,70,NULL,NULL,'CGCG 435-033',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12738,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 07159','RN',12738,39.16,0.55,611,2567,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 07159',0.110213,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12739,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12739,38.16,0.46,428,2568,70,NULL,NULL,'2MASX J00593616-0005232',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'18.11',0.21,NULL,NULL,NULL,NULL,NULL,1,14.9005417,-0.08969,0.044,NULL,34520822272,539387848,8427935,18.11),(12740,'IRAS','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12740,32.32,0.8,29.1,2569,75,NULL,'W91PP, r','UGC 00614',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000017,NULL,'13.87',1,'SB(s)d',NULL,NULL,NULL,NULL,1,14.901,35.56033,0.149,NULL,67662576720,1057227761,16519183,13.87),(12741,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12741,32.71,0.2,34.8,2569,74.4,NULL,NULL,'UGC 00614',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12742,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12742,32.93,0.45,38.5,2569,NULL,NULL,NULL,'UGC 00614',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12743,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12743,33.09,0.38,41.6,2569,75,NULL,'W91PP, r, inv','UGC 00614',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12744,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12744,33.11,0.38,41.9,2569,75,NULL,'W91PP, r, raw','UGC 00614',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12745,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12745,33.28,0.38,45.3,2569,NULL,NULL,'Malmquist cor.','UGC 00614',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12746,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12746,33.61,0.38,52.6,2569,75,NULL,'W91PP, r, cor','UGC 00614',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12747,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12747,37.29,0.46,287,2570,70,NULL,NULL,'2MASX J00593646+1407086',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000072,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,14.9018333333,14.11911,0.129,NULL,67592125449,1056126960,16501983,17.8),(12748,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12748,38.13,0.46,422,2571,70,NULL,NULL,'SDSS J005936.82-085146.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00007,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,14.903417,-8.86292,0.211,NULL,35262738238,550980284,8609066,18.4),(12749,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12749,34.79,0.46,90.8,2572,70,NULL,NULL,'MCG -02-03-058',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000076,NULL,'15.1g',0.39,'S0',NULL,NULL,NULL,NULL,1,14.9055,-10.33247,0.113,NULL,35264352432,551005506,8609461,15.1),(12750,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12750,34.89,0.53,94.9,2572,70,NULL,NULL,'MCG -02-03-058',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12751,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12751,36.59,0.63,208,2573,70,NULL,NULL,'2MASX J00593772-1353153',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.57',0.25,NULL,NULL,NULL,NULL,NULL,1,14.907167,-13.88772,0.016,NULL,35379394095,552803032,8637547,16.57),(12752,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12752,36.09,0.46,165,2574,70,NULL,NULL,'2MASX J00593918-0852520',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000077,NULL,'15.5g',0.52,'E0',NULL,NULL,NULL,NULL,1,14.913417,-8.88122,0.211,NULL,35262737618,550980275,8609066,15.5),(12753,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12753,35.3,0.82,115,2575,70,NULL,NULL,'GIN 034',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',NULL,NULL,'15.28',NULL,'S',NULL,NULL,NULL,NULL,1,14.913625,12.95947,0.121,NULL,67593610970,1056150171,16502346,15.28),(12754,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 15957','RN',12754,42.83,0.31,2530,2576,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 15957',0.457327,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12755,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12755,36.28,0.33,180,2577,70,NULL,NULL,'2MASX J00593998-1052550',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000085,NULL,'16.0g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,14.9165833333,-10.88208,0.088,NULL,35264470116,551007345,8609489,16),(12756,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12756,33.68,0.69,54.3,2578,100,NULL,'mid-IR','UGC 00615',NULL,'2013ApJ...771...88L',2013,1,0.99,NULL,'G',0.00001,NULL,'14.4g',0.59,'SABab          BLAGN',NULL,NULL,NULL,'Sy 2',1,14.917125,15.33097,0.153,NULL,67634381514,1056787211,16512300,14.4),(12757,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12757,34.27,0.58,71.6,2578,NULL,NULL,NULL,'UGC 00615',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12758,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12758,34.29,0.57,72,2578,NULL,NULL,'Malmquist cor.','UGC 00615',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12759,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12759,34.51,0.2,79.8,2578,74.4,NULL,NULL,'UGC 00615',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12760,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 12981','RN',12760,42.16,0.21,1900,2579,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 12981',0.42413,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12761,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 12981','RN',12761,42.25,0.16,1980,2579,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 12981',0.42413,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12762,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12762,37.71,0.46,348,2580,70,NULL,NULL,'SDSS J005941.54+144150.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00009,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,14.9231666667,14.69739,0.133,NULL,67591440640,1056116260,16501816,18),(12763,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12763,34.58,0.47,82.5,2581,70,NULL,NULL,'IC 1609',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000073,NULL,'13.57',1.3,'SA(s)0^0',NULL,NULL,NULL,NULL,1,14.94425,-40.33356,NULL,NULL,38161244398,596269443,9316710,13.57),(12764,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12764,35.72,NULL,139,2582,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00619',NULL,'2010Ap&SS.325..163P',2010,1,0.93,NULL,'G',0.000014,NULL,'16.7g',0.18,'Scd(f)         NLAGN',NULL,NULL,NULL,NULL,1,14.9530416667,14.7235,0.133,NULL,67591228161,1056112940,16501764,16.7),(12765,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12765,35.72,0.49,140,2582,75,NULL,'IR','UGC 00619',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12766,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12766,35.74,NULL,141,2582,NULL,NULL,'Dipole + Quadrupole','UGC 00619',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12767,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12767,35.75,NULL,141,2582,NULL,NULL,'Dipole','UGC 00619',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12768,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12768,35.76,NULL,142,2582,NULL,NULL,NULL,'UGC 00619',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12769,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12769,36.32,0.36,184,2582,NULL,NULL,'Malmquist cor.','UGC 00619',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12770,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12770,36.41,0.34,192,2582,NULL,NULL,NULL,'UGC 00619',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12771,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12771,36.42,0.2,192,2582,74.4,NULL,NULL,'UGC 00619',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12772,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12772,31.27,0.43,18,2583,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0337',NULL,'2014MNRAS.444..527S',2014,1,2.9,NULL,'G',0.000007,NULL,'12.46',1.8,'SB(s)d         HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,14.9587083,-7.57797,0.316,NULL,34534809374,539606396,8431349,12.46),(12773,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12773,31.33,0.43,18.4,2583,75,NULL,'3.6 micron, color corrected','NGC 0337',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12774,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12774,31.34,0.4,18.5,2583,73,NULL,'opt','NGC 0337',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12775,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12775,31.38,0.2,18.9,2583,74.4,NULL,NULL,'NGC 0337',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12776,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12776,31.43,0.55,19.3,2583,NULL,NULL,'Malmquist cor.','NGC 0337',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12777,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12777,31.58,0.4,20.7,2583,75,NULL,'B','NGC 0337',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12778,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12778,31.6,0.51,20.9,2583,NULL,NULL,NULL,'NGC 0337',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12779,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12779,31.64,0.4,21.3,2583,NULL,NULL,'mean','NGC 0337',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12780,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12780,31.87,0.46,23.7,2583,NULL,NULL,'J','NGC 0337',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12781,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12781,31.94,0.47,24.5,2583,NULL,NULL,'H','NGC 0337',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12782,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12782,31.95,0.45,24.5,2583,NULL,NULL,'K','NGC 0337',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12783,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12783,37.54,0.65,323,2584,70,NULL,NULL,'2MASX J00595379-1414403',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000117,NULL,'15.0',0.41,'cD',NULL,NULL,NULL,NULL,1,14.9742916667,-14.24442,0.012,NULL,35379047585,552797618,8637462,15),(12784,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12784,38.3,0.27,457,2585,70,NULL,NULL,'2MASX J00595460+1533526',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000096,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,14.9777083,15.56467,0.153,NULL,67635184111,1056799751,16512496,18.2),(12785,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12785,37.79,0.46,362,2586,70,NULL,NULL,'2MASX J00595569+0015390',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000081,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,14.982125,0.26081,0.101,NULL,66679468902,1041866701,16279167,17.6),(12786,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12786,36.69,0.53,217,2587,70,NULL,NULL,'MCG -02-03-060',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000123,NULL,'15.20',0.5,'cD',NULL,NULL,NULL,NULL,1,14.99625,-13.99528,0.016,NULL,35379876812,552810575,8637665,15.2),(12787,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12787,34.87,0.51,94.2,2588,70,NULL,NULL,'MCG -02-03-061',NULL,'2014MNRAS.445.2677S',2014,1,1.37,'HOLM 032B is a star.','G',0.000093,NULL,'14.1g',0.97,'(R\')SAB(r)bc',NULL,NULL,NULL,NULL,1,15.0172083333,-11.08261,0.083,NULL,35263783811,550996622,8609322,14.1),(12788,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12788,33.5,0.69,50.1,2588,100,NULL,'mid-IR','MCG -02-03-061',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12789,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 17882','R',12789,40.39,0.23,944,2589,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17882',0.27,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,15.018375,1.24642,0.037,NULL,66680611669,1041884557,16279446,NULL),(12790,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 17882','R',12790,40.58,0.17,1030,2589,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17882',0.27,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12791,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12791,36.68,0.46,217,2590,70,NULL,NULL,'2MASX J01000558-0047527',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000074,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,15.023125,-0.798,0.058,NULL,34523168307,539424504,8428507,16.4),(12792,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12792,35.29,0.6,114,2591,NULL,NULL,'Malmquist cor.','ESO 541- G 008',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.14',0.8,'Sc',NULL,NULL,NULL,NULL,1,15.0382083,-18.62683,0.038,NULL,35396652516,553072695,8641760,14.14),(12793,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12793,35.43,0.56,122,2591,NULL,NULL,NULL,'ESO 541- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12794,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12794,35.47,0.2,124,2591,74.4,NULL,NULL,'ESO 541- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12795,'Carbon Stars','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12795,19.65,0.57,0.085,2592,NULL,NULL,'Carbon star S1, RA 014.9736, DEC -33.6418','Sculptor Dwarf Elliptical',NULL,'2015MNRAS.453.2653H',2015,1,39.8,NULL,'G',0.000005,NULL,'8.6 V',30.9,'E?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,15.039,-33.70903,NULL,0,34732308919,542692326,8479567,8.6),(12796,'Carbon Stars','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12796,19.75,0.57,0.089,2592,NULL,NULL,'Carbon star S2, RA 014.9956, DEC -33.4764','Sculptor Dwarf Elliptical',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12797,'CMD','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12797,19.15,0.05,0.0676,2592,NULL,NULL,NULL,'Sculptor Dwarf Elliptical',NULL,'1994AAS...184.4810G',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12798,'CMD','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12798,19.45,0.31,0.0776,2592,NULL,NULL,NULL,'Sculptor Dwarf Elliptical',NULL,'2002MNRAS.332...91D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12799,'CMD','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12799,19.56,NULL,0.0817,2592,NULL,NULL,NULL,'Sculptor Dwarf Elliptical',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12800,'CMD','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12800,19.56,NULL,0.0817,2592,NULL,NULL,NULL,'Sculptor Dwarf Elliptical',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12801,'Horizontal Branch','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12801,19.3,0.23,0.072,2592,NULL,NULL,NULL,'Sculptor Dwarf Elliptical',NULL,'1995MNRAS.277.1354I',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12802,'Horizontal Branch','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12802,19.46,NULL,0.078,2592,NULL,NULL,NULL,'Sculptor Dwarf Elliptical',NULL,'1985IAUS..113..541W',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12803,'Horizontal Branch','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12803,19.66,0.15,0.0855,2592,NULL,NULL,NULL,'Sculptor Dwarf Elliptical',NULL,'2008AJ....135.1993P',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12804,'Horizontal Branch','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12804,19.72,NULL,0.0879,2592,NULL,NULL,NULL,'Sculptor Dwarf Elliptical',NULL,'2013A&A...559A..57S',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12805,'Miras','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12805,19.19,NULL,0.0689,2592,NULL,18.39,'1 C Mira, P = 189 day','Sculptor Dwarf Elliptical',NULL,'2011MNRAS.414.3492M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12806,'Miras','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12806,19.57,NULL,0.082,2592,NULL,18.39,'1 C Mira, P = 554 day','Sculptor Dwarf Elliptical',NULL,'2011MNRAS.414.3492M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12807,'RR Lyrae','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12807,18.95,0.05,0.0617,2592,NULL,NULL,'Reddened, for IC 4499 m-M = 16.47','Sculptor Dwarf Elliptical',NULL,'2001A&A...371..579K',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12808,'RR Lyrae','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12808,19.36,0.05,0.0745,2592,NULL,NULL,NULL,'Sculptor Dwarf Elliptical',NULL,'1996ApJ...466L..17K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12809,'RR Lyrae','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12809,19.37,NULL,0.0748,2592,NULL,18.37,'K','Sculptor Dwarf Elliptical',NULL,'2011MNRAS.414.3492M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12810,'RR Lyrae','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12810,19.46,NULL,0.078,2592,NULL,18.38,'V','Sculptor Dwarf Elliptical',NULL,'2011MNRAS.414.3492M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12811,'RR Lyrae','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12811,19.47,0.1,0.0783,2592,NULL,NULL,'PHOTOGRAPHIC, TRUE','Sculptor Dwarf Elliptical',NULL,'1977ApJ...214...21K',1977,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12812,'RR Lyrae','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12812,19.58,0.04,0.0824,2592,NULL,NULL,'261, BV, RRab, full sample','Sculptor Dwarf Elliptical',NULL,'2015MNRAS.454.1509M',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12813,'RR Lyrae','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12813,19.59,0.05,0.0828,2592,NULL,NULL,'165, BV, RRab, clean sample','Sculptor Dwarf Elliptical',NULL,'2015MNRAS.454.1509M',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12814,'RR Lyrae','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12814,19.59,NULL,0.0828,2592,NULL,NULL,NULL,'Sculptor Dwarf Elliptical',NULL,'2008ApJ...679...52T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12815,'RR Lyrae','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12815,19.61,0.05,0.0836,2592,NULL,NULL,'279, BV, RRab + RRc, clean sample','Sculptor Dwarf Elliptical',NULL,'2015MNRAS.454.1509M',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12816,'RR Lyrae','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12816,19.61,0.04,0.0836,2592,NULL,NULL,'437, BV, RRab + RRc, full sample','Sculptor Dwarf Elliptical',NULL,'2015MNRAS.454.1509M',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12817,'RR Lyrae','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12817,19.62,0.04,0.0839,2592,NULL,NULL,'279, BV, mean of 3, clean sample','Sculptor Dwarf Elliptical',NULL,'2015MNRAS.454.1509M',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12818,'RR Lyrae','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12818,19.63,0.06,0.0843,2592,NULL,NULL,'437, BV, mean of 3, full sample','Sculptor Dwarf Elliptical',NULL,'2015MNRAS.454.1509M',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12819,'RR Lyrae','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12819,19.67,0.02,0.0859,2592,NULL,NULL,'78, JK','Sculptor Dwarf Elliptical',NULL,'2008AJ....135.1993P',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12820,'RR Lyrae','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12820,19.67,0.1,0.0859,2592,NULL,NULL,'116, BV, RRc, clean sample','Sculptor Dwarf Elliptical',NULL,'2015MNRAS.454.1509M',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12821,'RR Lyrae','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12821,19.68,0.08,0.0863,2592,NULL,NULL,'V','Sculptor Dwarf Elliptical',NULL,'2008AJ....135.1993P',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12822,'RR Lyrae','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12822,19.7,0.14,0.0871,2592,NULL,NULL,'178, BV, RRc, full sample','Sculptor Dwarf Elliptical',NULL,'2015MNRAS.454.1509M',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12823,'RR Lyrae','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12823,19.71,NULL,0.088,2592,NULL,NULL,'226, RR','Sculptor Dwarf Elliptical',NULL,'1995A&AS..112..407K',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12824,'TRGB','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12824,19.46,NULL,0.078,2592,NULL,18.39,'VI','Sculptor Dwarf Elliptical',NULL,'2011MNRAS.414.3492M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12825,'TRGB','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12825,19.6,0.08,0.08,2592,74.4,NULL,NULL,'Sculptor Dwarf Elliptical',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12826,'TRGB','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12826,19.64,0.04,0.0847,2592,NULL,NULL,'I','Sculptor Dwarf Elliptical',NULL,'2007ApJ...661..815R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12827,'TRGB','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12827,19.64,0.08,0.0847,2592,NULL,NULL,NULL,'Sculptor Dwarf Elliptical',NULL,'2008AJ....135.1993P',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12828,'TRGB','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12828,19.7,0.08,0.0871,2592,NULL,NULL,'K','Sculptor Dwarf Elliptical',NULL,'2011AJ....141..194G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12829,'TRGB','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12829,19.72,0.08,0.0879,2592,NULL,NULL,'J','Sculptor Dwarf Elliptical',NULL,'2011AJ....141..194G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12830,'TRGB','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12830,19.8,NULL,0.09,2592,NULL,NULL,NULL,'Sculptor Dwarf Elliptical',NULL,'2000glg..book.....V',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12831,'Tully est','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12831,20,0.8,0.1,2592,75,NULL,NULL,'Sculptor Dwarf Elliptical',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12832,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 07413',NULL,12832,40.59,0.15,1310,2593,70,NULL,'SN photometric redshift distance, z photo =0.372 +/- 0.035','SDSS-II SN 07413',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,15.0452083,0.47464,0.101,NULL,66680415625,1041881494,16279398,NULL),(12833,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12833,35.47,0.69,124,2594,100,NULL,'mid-IR','UGC 00621',NULL,'2013ApJ...771...88L',2013,1,1,NULL,'G',0.000033,NULL,'15.12',0.6,'S?',NULL,NULL,NULL,NULL,1,15.046917,18.28311,0.125,NULL,67617518119,1056523720,16508183,15.12),(12834,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 08679','R',12834,41.57,0.27,1600,2595,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2005jr','SN 2005jr',0.2944,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'IIn',NULL,NULL,NULL,NULL,1,15.0515416667,0.34081,0.101,NULL,66679453898,1041866467,16279163,NULL),(12835,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 08679','R',12835,41.62,0.17,1630,2595,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2005jr','SN 2005jr',0.2944,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12836,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12836,36.82,0.46,231,2596,70,NULL,NULL,'2MASX J01001489-1001597',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000066,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,15.0619166667,-10.03339,0.118,NULL,35264898865,551014044,8609594,17.1),(12837,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 03822','RN',12837,41.7,0.23,1680,2597,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03822',0.30119,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12838,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12838,35.82,0.45,146,2598,70,NULL,NULL,'GIN 030',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',NULL,NULL,'15.11',NULL,'E',NULL,NULL,NULL,NULL,1,15.0748333333,26.94939,0.249,NULL,67286394235,1051349909,16427342,15.11),(12839,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12839,36.21,0.53,175,2599,70,NULL,NULL,'2MASX J01002486-1408554',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.0001,NULL,'16.83',0.32,NULL,NULL,NULL,NULL,NULL,1,15.1035417,-14.14881,0.01,NULL,35379032650,552797385,8637459,16.83),(12840,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12840,37.93,0.46,386,2600,70,NULL,NULL,'2MASX J01002510-1020177',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000106,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,15.104667,-10.33833,0.093,NULL,35264315527,551004930,8609452,17),(12841,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12841,38.3,0.27,457,2601,70,NULL,NULL,'2MASX J01002597+1534567',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000067,NULL,'18.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,15.1082083333,15.58253,0.137,NULL,67635156314,1056799317,16512489,18.4),(12842,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12842,38.3,0.27,457,2602,70,NULL,NULL,'SDSS J010026.52+153614.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000072,NULL,'18.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,15.1105,15.60394,0.137,NULL,67635156158,1056799314,16512489,18.8),(12843,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12843,32.62,0.73,33.4,2603,NULL,NULL,'Malmquist cor.','UGC 00622',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000027,NULL,'14.2',0.7,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,15.1172083,47.99519,0.769,NULL,67695817185,1057747143,16527299,14.2),(12844,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12844,32.74,0.43,35.3,2603,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00622',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12845,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12845,32.9,0.43,38,2603,75,NULL,'3.6 micron, color corrected','UGC 00622',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12846,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12846,32.91,0.4,38.3,2603,NULL,NULL,'mean','UGC 00622',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12847,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12847,32.96,0.2,39.1,2603,74.4,NULL,NULL,'UGC 00622',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12848,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12848,32.96,0.63,39.1,2603,NULL,NULL,NULL,'UGC 00622',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12849,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12849,33.24,0.46,44.4,2603,NULL,NULL,'J','UGC 00622',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12850,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12850,33.25,0.45,44.6,2603,NULL,NULL,'K','UGC 00622',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12851,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12851,33.26,0.47,44.9,2603,NULL,NULL,'H','UGC 00622',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12852,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 08744','RN',12852,42.72,0.54,2500,2604,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 08744',0.395529,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12853,'IRAS','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12853,33.94,0.8,61.3,2605,75,NULL,'W91PP, r','IC 0066',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000033,NULL,'14.94',0.5,'Sa','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,15.135417,30.79722,0.181,NULL,67268142948,1051064733,16422886,14.94),(12854,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12854,34.14,0.4,67.2,2605,NULL,NULL,'mean','IC 0066',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12855,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12855,34.22,0.07,70,2605,NULL,NULL,NULL,'IC 0066',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12856,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12856,34.56,0.38,81.5,2605,75,NULL,'W91PP, r, raw','IC 0066',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12857,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12857,34.56,0.43,81.5,2605,75,NULL,'3.6 micron, color + selection bias corrected','IC 0066',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12858,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12858,34.56,0.43,81.8,2605,75,NULL,'3.6 micron, color corrected','IC 0066',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12859,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12859,34.57,0.45,81.9,2605,NULL,NULL,'K','IC 0066',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12860,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12860,34.6,0.47,83.2,2605,NULL,NULL,'H','IC 0066',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12861,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12861,34.65,0.46,84.9,2605,NULL,NULL,'J','IC 0066',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12862,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12862,34.65,0.2,85.1,2605,74.4,NULL,NULL,'IC 0066',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12863,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12863,34.66,0.38,85.4,2605,75,NULL,'W91PP, r, cor','IC 0066',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12864,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12864,34.71,0.38,87.6,2605,75,NULL,'W91PP, r, inv','IC 0066',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12865,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12865,34.59,0.47,82.9,2606,NULL,NULL,'H','NGC 0340',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000025,NULL,'14.51',0.3,'Sb             HII',NULL,NULL,NULL,NULL,1,15.145333,-6.86658,0.339,NULL,34535814958,539622108,8431595,14.51),(12866,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12866,34.63,0.4,84.4,2606,NULL,NULL,'mean','NGC 0340',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12867,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12867,34.79,0.46,91,2606,NULL,NULL,'J','NGC 0340',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12868,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12868,34.8,0.45,91.3,2606,NULL,NULL,'K','NGC 0340',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12869,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 16565',NULL,12869,39.99,0.37,995,2607,70,NULL,'SN photometric redshift distance, z photo =0.267 +/- 0.060','SDSS-II SN 16565',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.4g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,15.146833,-0.07736,0.054,NULL,34520726471,539386351,8427911,21.4),(12870,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 16565','R',12870,41.29,0.27,1320,2607,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16565',0.371812,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12871,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 16565','R',12871,41.36,0.22,1360,2607,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16565',0.371812,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12872,'IRAS','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12872,33.91,0.8,60.5,2608,75,NULL,'W91CL, r','NGC 0338',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000023,NULL,'13.67',0.6,'Sab','in a radial-velocity based grouping',NULL,NULL,NULL,1,15.1517083,30.66897,0.181,NULL,67268199222,1051065612,16422900,13.67),(12873,'IRAS','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12873,33.91,0.8,60.5,2608,75,NULL,'W91PP, r','NGC 0338',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12874,'IRAS','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12874,33.95,0.8,61.8,2608,75,NULL,'CF, r','NGC 0338',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12875,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12875,33.88,0.47,59.8,2608,NULL,NULL,'H','NGC 0338',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12876,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12876,33.9,0.45,60.2,2608,NULL,NULL,'K','NGC 0338',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12877,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12877,33.94,0.46,61.3,2608,NULL,NULL,'J','NGC 0338',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12878,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12878,33.95,0.38,61.8,2608,75,NULL,'W91PP, r, raw','NGC 0338',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12879,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12879,33.98,0.38,62.7,2608,75,NULL,'W91CL, r, raw','NGC 0338',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12880,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12880,34.06,NULL,64.9,2608,NULL,NULL,'I','NGC 0338',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12881,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12881,34.09,NULL,65.8,2608,NULL,NULL,'B','NGC 0338',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12882,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12882,34.12,0.38,66.6,2608,75,NULL,'W91PP, r, cor','NGC 0338',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12883,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12883,34.13,0.4,66.9,2608,NULL,NULL,'mean','NGC 0338',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12884,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12884,34.14,0.38,67.1,2608,75,NULL,'W91CL, r, cor','NGC 0338',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12885,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12885,34.21,0.38,69.5,2608,75,NULL,'W91CL, r, inv','NGC 0338',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12886,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12886,34.24,0.38,70.4,2608,75,NULL,'W91PP, r, inv','NGC 0338',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12887,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12887,34.29,0.38,72.2,2608,75,NULL,'CF, r, raw','NGC 0338',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12888,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12888,34.35,0.07,74.3,2608,NULL,NULL,NULL,'NGC 0338',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12889,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12889,34.37,0.38,74.9,2608,75,NULL,'CF, r, cor','NGC 0338',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12890,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12890,34.42,0.43,76.6,2608,75,NULL,'3.6 micron, color corrected','NGC 0338',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12891,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12891,34.47,0.2,78.3,2608,74.4,NULL,NULL,'NGC 0338',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12892,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12892,34.52,0.43,80.2,2608,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0338',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12893,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12893,34.53,0.38,80.6,2608,75,NULL,'CF, r, inv','NGC 0338',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12894,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12894,37.4,0.61,303,2609,70,NULL,NULL,'AM 0058-430 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.44',0.33,'S',NULL,NULL,NULL,NULL,1,15.1710833333,-42.75089,NULL,NULL,38160340226,596255316,9316489,16.44),(12895,'IRAS','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12895,33.95,0.8,61.6,2610,75,NULL,'MAT, I','ESO 002- G 012',NULL,'1997ApJS..109..333W',1997,1,2.24,NULL,'G',0.000033,NULL,'13.75',0.22,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,15.1912083,-85.52294,0.449,NULL,35442456936,553788389,8652943,13.75),(12896,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12896,33.4,0.49,47.9,2610,75,NULL,'IR','ESO 002- G 012',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12897,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12897,33.6,0.32,52.5,2610,85,NULL,'I, raw','ESO 002- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12898,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12898,33.61,0.32,52.8,2610,85,NULL,'I, inv','ESO 002- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12899,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12899,33.65,0.43,53.7,2610,75,NULL,'MAT, I, raw','ESO 002- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12900,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12900,33.75,0.43,56.1,2610,75,NULL,'MAT, I, inv','ESO 002- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12901,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12901,33.86,0.43,59.1,2610,75,NULL,'MAT, I, cor','ESO 002- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12902,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12902,34.03,NULL,64,2610,NULL,NULL,NULL,'ESO 002- G 012',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12903,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12903,34.11,NULL,66.4,2610,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 002- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12904,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12904,34.12,NULL,66.7,2610,NULL,NULL,'Dipole','ESO 002- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12905,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12905,34.12,NULL,66.8,2610,NULL,NULL,'Dipole + Quadrupole','ESO 002- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12906,'Magnitude','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12906,36.22,0.13,175,2611,100,NULL,NULL,'ESO 195-IG 022 NED02',NULL,'1998A&A...337...31R',1998,1,0.51,NULL,'G',0.00018,NULL,'16.72',0.36,'E int',NULL,NULL,NULL,NULL,1,15.200125,-50.54819,NULL,NULL,38136955586,595889931,9310780,16.72),(12907,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 04135','RN',12907,42.53,0.43,2410,2612,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04135',0.326407,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12908,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 04135','RN',12908,42.83,0.42,2780,2612,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04135',0.326407,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12909,'Magnitude','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12909,36.22,0.13,175,2613,100,NULL,NULL,'ABELL 2854',NULL,'1998A&A...337...31R',1998,1,NULL,'Previously reported value of z=0.0502 was an estimated value.','GClstr',NULL,NULL,NULL,NULL,'I-II   [BM];RI [A]',NULL,NULL,NULL,NULL,1,15.203125,-50.53092,NULL,NULL,38136955448,595889928,9310780,NULL),(12910,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12910,35.15,0.49,107,2614,70,NULL,NULL,'NGC 0342',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00009,NULL,'15.41',0.3,'E4/S0-',NULL,NULL,NULL,NULL,1,15.20775,-6.77256,0.272,NULL,34535846547,539622602,8431603,15.41),(12911,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12911,37.04,0.46,256,2615,70,NULL,NULL,'2MASX J01005102-0043006',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.0001,NULL,'17.42',0.33,NULL,NULL,NULL,NULL,NULL,1,15.2125,-0.71686,0.108,NULL,34522957376,539421209,8428456,17.42),(12912,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12912,34.66,0.43,85.7,2616,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00628',NULL,'2014MNRAS.444..527S',2014,1,1.5,NULL,'G',0.000013,NULL,'17.',1,'Sm:',NULL,NULL,NULL,NULL,1,15.2164583,19.47581,0.089,NULL,67628576990,1056696515,16510883,17),(12913,'IRAS','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12913,32.57,0.8,32.7,2617,75,NULL,'A82, H','IC 0065',NULL,'1997ApJS..109..333W',1997,1,3.9,NULL,'G',0.000027,NULL,'13.6',1.1,'SAB(s)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,15.2309166667,47.68197,0.725,NULL,67695730691,1057745792,16527278,13.6),(12914,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12914,31.58,0.4,20.7,2617,NULL,NULL,'Virgo cluster at 15.6 Mpc','IC 0065',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12915,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12915,31.87,0.47,23.7,2617,75,NULL,'A82, H, raw','IC 0065',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12916,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12916,31.95,0.47,24.5,2617,75,NULL,'A82, H, inv','IC 0065',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12917,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12917,32.21,0.38,27.7,2617,NULL,NULL,NULL,'IC 0065',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12918,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12918,32.24,0.47,28.1,2617,75,NULL,'A82, H, cor','IC 0065',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12919,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12919,32.35,0.41,29.5,2617,NULL,NULL,'Malmquist cor.','IC 0065',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12920,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12920,32.44,0.43,30.8,2617,75,NULL,'3.6 micron, color corrected','IC 0065',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12921,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12921,32.47,0.2,31.2,2617,74.4,NULL,NULL,'IC 0065',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12922,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12922,32.48,0.43,31.3,2617,75,NULL,'3.6 micron, color + selection bias corrected','IC 0065',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12923,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12923,32.63,0.4,33.5,2617,NULL,NULL,'mean','IC 0065',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12924,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12924,32.63,0.46,33.6,2617,NULL,NULL,'J','IC 0065',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12925,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12925,32.65,0.47,33.9,2617,NULL,NULL,'H','IC 0065',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12926,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12926,32.72,0.35,35,2617,NULL,NULL,NULL,'IC 0065',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12927,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12927,32.73,0.45,35.1,2617,NULL,NULL,'K','IC 0065',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12928,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12928,32.84,0.4,36.9,2617,75,NULL,'B','IC 0065',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12929,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 11771','R',12929,40.68,0.37,1090,2618,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J010055.45-003134.8',0.2575,'2014arXiv1401.3317S',2014,1,0.16,NULL,'G',0.01,NULL,'19.2g',0.1,NULL,NULL,NULL,NULL,NULL,1,15.231083,-0.52636,0.118,NULL,34523050198,539422659,8428479,19.2),(12930,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 11771','R',12930,40.73,0.29,1110,2618,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J010055.45-003134.8',0.2575,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12931,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 11771',NULL,12931,40.46,0.23,1240,2618,70,NULL,'SALT 2','SDSS J010055.45-003134.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12932,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 11771',NULL,12932,40.48,0.23,1250,2618,70,NULL,'SALT 2, Malmquist cor.','SDSS J010055.45-003134.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12933,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12933,35.82,0.45,146,2619,70,NULL,NULL,'GIN 029',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',NULL,NULL,'14.30',NULL,'E',NULL,NULL,NULL,NULL,1,15.234583,27.16489,0.257,NULL,67288409803,1051381403,16427834,14.3),(12934,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12934,36.04,0.31,161,2620,NULL,NULL,'Malmquist cor.','UGC 00627',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000103,NULL,'14.82',0.8,'S?',NULL,NULL,NULL,NULL,1,15.2522917,13.46833,0.105,NULL,67584173612,1056002712,16500042,14.82),(12935,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12935,36.1,0.3,166,2620,NULL,NULL,NULL,'UGC 00627',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12936,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12936,36.47,0.2,197,2620,74.4,NULL,NULL,'UGC 00627',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12937,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12937,37.5,0.46,316,2621,70,NULL,NULL,'2MASX J01010109-0024447',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000103,NULL,'17.55',0.24,'AGN',NULL,NULL,NULL,NULL,1,15.254667,-0.41233,0.118,NULL,34523032030,539422375,8428474,17.55),(12938,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12938,34.14,0.06,67.4,2622,NULL,NULL,NULL,'UGC 00629',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.00003,NULL,'14.59',1,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,15.257125,29.60172,0.213,NULL,67294050770,1051469543,16429211,14.59),(12939,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12939,34.47,0.46,78.5,2623,NULL,NULL,'Malmquist cor.','UGC 00631',NULL,'2009ApJS..182..474S',2009,1,1.68,NULL,'G',0.000007,NULL,'16.0',0.15,'Sdm',NULL,NULL,NULL,NULL,1,15.2607083,9.72483,0.113,NULL,67560917938,1055639342,16494364,16),(12940,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12940,34.54,NULL,81,2623,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00631',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12941,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12941,34.55,NULL,81.4,2623,NULL,NULL,'Dipole + Quadrupole','UGC 00631',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12942,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12942,34.55,NULL,81.5,2623,NULL,NULL,'Dipole','UGC 00631',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12943,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12943,34.58,0.49,82.4,2623,75,NULL,'IR','UGC 00631',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12944,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12944,34.6,NULL,83.1,2623,NULL,NULL,NULL,'UGC 00631',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12945,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12945,34.81,0.2,91.6,2623,74.4,NULL,NULL,'UGC 00631',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12946,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12946,34.83,0.39,92.3,2623,NULL,NULL,NULL,'UGC 00631',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12947,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12947,38.93,0.46,611,2624,70,NULL,NULL,'SDSS J010103.48-092056.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000108,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,15.2645417,-9.34908,0.175,NULL,35263361665,550990026,8609219,18.3),(12948,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12948,34.96,0.6,98.3,2625,70,NULL,NULL,'MCG -01-03-061',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000077,NULL,'15.7b',0.3,NULL,NULL,NULL,NULL,NULL,1,15.2759583,-4.60522,0.138,NULL,34559458742,539991542,8437367,15.7),(12949,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12949,37.13,0.46,267,2626,70,NULL,NULL,'2MASX J01010721+0113442',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000096,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,15.2801666667,1.22906,0.033,NULL,66680781391,1041887209,16279487,17),(12950,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12950,36.8,0.46,229,2627,70,NULL,NULL,'SDSS J010108.76+000221.3',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.0001,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,15.2865,0.03925,0.054,NULL,66679263722,1041863495,16279117,16.4),(12951,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12951,36.49,0.46,199,2628,70,NULL,NULL,'2MASX J01010976-0058269',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000084,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,15.290667,-0.97425,0.125,NULL,34522623120,539415986,8428374,16.9),(12952,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12952,36.13,0.46,169,2629,70,NULL,NULL,'2MASX J01011070-0109589',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000083,NULL,'17.14',0.37,NULL,NULL,NULL,NULL,NULL,1,15.294625,-1.16644,0.17,NULL,34522788366,539418568,8428415,17.14),(12953,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12953,35.05,0.4,102,2630,NULL,NULL,'mean','UGC 00632',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.00003,NULL,'14.81',0.5,'SBab','Group member',NULL,NULL,NULL,1,15.297375,30.13075,0.221,NULL,67267882749,1051060667,16422822,14.81),(12954,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12954,35.1,0.47,105,2630,NULL,NULL,'H','UGC 00632',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12955,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12955,35.23,0.45,111,2630,NULL,NULL,'K','UGC 00632',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12956,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12956,35.25,0.46,112,2630,NULL,NULL,'J','UGC 00632',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12957,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 14708',NULL,12957,40.28,0.26,1140,2631,70,NULL,'SN photometric redshift distance, z photo =0.313 +/- 0.050','SDSS-II SN 14708',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,15.3145,-0.46494,0.118,NULL,34523015285,539422113,8428470,NULL),(12958,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 14708','R',12958,41.73,0.26,1560,2631,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14708',0.419382,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12959,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 14708','R',12959,41.96,0.25,1730,2631,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14708',0.419382,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12960,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 14708',NULL,12960,41.6,0.17,2090,2631,70,NULL,'SALT 2','SDSS-II SN 14708',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12961,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 14708',NULL,12961,41.68,0.17,2170,2631,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14708',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12962,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12962,37.23,0.56,280,2632,70,NULL,NULL,'2MASX J01011608-1903118',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'17.00',0.23,NULL,NULL,NULL,NULL,NULL,1,15.3169583,-19.05333,0.035,NULL,35396540939,553070952,8641733,17),(12963,'SNII optical','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 0210',NULL,12963,37.09,0.54,262,2633,NULL,NULL,'SCM, I','MCG +00-03-054',NULL,'2010ApJ...715..833O',2010,1,0.65,NULL,'G',0.000081,NULL,'15.6g',0.46,'Sbc',NULL,NULL,NULL,NULL,1,15.320083,-1.09775,0.17,NULL,34522779726,539418433,8428413,15.6),(12964,'SNII optical','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 0210',NULL,12964,37.27,0.57,284,2633,NULL,NULL,'SCM, V','MCG +00-03-054',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12965,'SNII optical','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 0210',NULL,12965,37.31,0.31,290,2633,NULL,NULL,'SCM, BVI','MCG +00-03-054',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12966,'SNII optical','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 0210',NULL,12966,37.52,0.5,319,2633,NULL,NULL,'SCM, B','MCG +00-03-054',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12967,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12967,37.7,0.46,347,2634,70,NULL,NULL,'SDSS J010117.03+002928.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000102,NULL,'18.8g',0.13,'NLAGN',NULL,NULL,NULL,'Sy 2',1,15.3209583333,0.49111,0.168,NULL,66680495670,1041882744,16279417,18.8),(12968,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12968,37.3,0.46,288,2635,70,NULL,NULL,'2MASX J01011830-0110059',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000102,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,15.3262917,-1.16842,0.17,NULL,34522789996,539418593,8428415,16.9),(12969,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 02886','RN',12969,37.28,0.51,267,2636,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02886',0.069748,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12970,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 02886','RN',12970,38.4,0.23,447,2636,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02886',0.069748,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12971,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12971,34.11,0.4,66.4,2637,NULL,NULL,'mean','MCG -02-03-066',NULL,'2007A&A...465...71T',2007,1,0.8,NULL,'G',0.000027,NULL,'14.5g',0.57,'Sc',NULL,NULL,NULL,NULL,1,15.331167,-9.84528,0.124,NULL,35264859257,551013425,8609584,14.5),(12972,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12972,34.22,0.47,69.9,2637,NULL,NULL,'H','MCG -02-03-066',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12973,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 15225','RN',12973,42.41,0.19,2530,2638,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 15225',0.199396,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12974,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 15225','RN',12974,42.52,0.2,2660,2638,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 15225',0.199396,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12975,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1995ar',NULL,12975,41.09,0.61,1130,2639,74.2,NULL,'SALT 2','[PDG95a] J010120.60+041834.3',0.465,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,'Sa',NULL,NULL,NULL,NULL,1,15.335833,4.30953,0.065,NULL,66705703802,1042276621,16285572,NULL),(12976,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1995ar',NULL,12976,41.84,0.68,1590,2639,70,NULL,'SALT','[PDG95a] J010120.60+041834.3',0.465,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12977,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1995ar',NULL,12977,41.89,0.65,1630,2639,65,NULL,'SALT','[PDG95a] J010120.60+041834.3',0.465,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12978,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1995ar','R',12978,42.03,NULL,1740,2639,65,NULL,'SALT','[PDG95a] J010120.60+041834.3',0.465,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12979,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1995ar',NULL,12979,42.81,0.22,2490,2639,65,NULL,NULL,'[PDG95a] J010120.60+041834.3',0.465,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12980,'IRAS','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12980,34.39,0.8,75.4,2640,75,NULL,'W91PP, r','UGC 00633',NULL,'1997ApJS..109..333W',1997,1,1.6,'HOLM 034B is a star.','G',0.000023,NULL,'14.81',0.3,'Sb',NULL,NULL,NULL,NULL,1,15.338375,31.50772,0.185,NULL,67266766967,1051043233,16422550,14.81),(12981,'IRAS','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12981,34.39,0.8,75.4,2640,75,NULL,'HMCL, I','UGC 00633',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12982,'IRAS','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12982,34.39,0.8,75.5,2640,75,NULL,'W91CL, r','UGC 00633',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12983,'IRAS','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12983,34.4,0.8,75.9,2640,75,NULL,'CF, r','UGC 00633',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12984,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12984,34.11,0.38,66.3,2640,75,NULL,'CF, r, raw','UGC 00633',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12985,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12985,34.22,0.38,69.7,2640,75,NULL,'CF, r, inv','UGC 00633',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12986,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12986,34.23,0.38,70,2640,75,NULL,'CF, r, cor','UGC 00633',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12987,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12987,34.29,0.38,71.9,2640,75,NULL,'W91PP, r, raw','UGC 00633',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12988,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12988,34.29,0.38,72,2640,75,NULL,'W91CL, r, raw','UGC 00633',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12989,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12989,34.3,0.4,72.3,2640,75,NULL,'HMCL, I, raw','UGC 00633',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12990,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12990,34.3,0.1,72.6,2640,NULL,NULL,NULL,'UGC 00633',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12991,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12991,34.37,0.38,74.8,2640,75,NULL,'W91PP, r, cor','UGC 00633',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12992,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12992,34.37,0.38,74.9,2640,75,NULL,'W91CL, r, cor','UGC 00633',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12993,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12993,34.4,0.4,75.8,2640,75,NULL,'HMCL, I, cor','UGC 00633',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12994,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12994,34.42,0.38,76.6,2640,75,NULL,'W91CL, r, inv','UGC 00633',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12995,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12995,34.42,0.4,76.7,2640,NULL,NULL,'mean','UGC 00633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12996,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12996,34.43,0.38,77,2640,75,NULL,'W91PP, r, inv','UGC 00633',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12997,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12997,34.47,0.4,78.4,2640,75,NULL,'HMCL, I, inv','UGC 00633',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12998,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',12998,34.58,0.49,82.4,2640,75,NULL,'IR','UGC 00633',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12999,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,12999,34.7,0.2,87.1,2640,74.4,NULL,NULL,'UGC 00633',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13000,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13000,34.74,0.43,88.9,2640,75,NULL,'3.6 micron, color corrected','UGC 00633',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13001,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13001,34.81,0.47,91.5,2640,NULL,NULL,'H','UGC 00633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13002,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13002,34.88,0.43,94.8,2640,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00633',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13003,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 02621',NULL,13003,40.34,0.16,1170,2641,70,NULL,'SN photometric redshift distance, z photo =0.324 +/- 0.030','SDSS-II SN 02621',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,15.3439166667,-1.12917,0.17,NULL,34522765033,539418203,8428409,NULL),(13004,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13004,34.23,0.4,70.2,2642,NULL,NULL,'mean','IC 0069',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000033,NULL,'14.56',0.9,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,15.348583,31.04083,0.185,NULL,67267272976,1051051140,16422674,14.56),(13005,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13005,34.29,0.47,72,2642,NULL,NULL,'H','IC 0069',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13006,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13006,37.3,0.97,289,2643,70,NULL,NULL,'2MASX J01012376-0057099',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.000091,NULL,'16.1g',0.31,'S0',NULL,NULL,NULL,NULL,1,15.3489583,-0.95289,0.108,NULL,34522654484,539416476,8428382,16.1),(13007,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13007,38.1,0.46,417,2644,70,NULL,NULL,'2MASX J01012456+0022544',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.79',0.17,'AGN',NULL,NULL,NULL,NULL,1,15.352375,0.38192,0.098,NULL,66680499328,1041882802,16279418,18.79),(13008,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13008,32.1,0.2,26.3,2645,74.4,NULL,NULL,'UGC 00634',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.000003,NULL,'14.98',1.1,'SABm:',NULL,NULL,NULL,NULL,1,15.354583,7.62639,0.149,NULL,66665953648,1041655525,16275867,14.98),(13009,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13009,32.14,0.43,26.8,2645,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00634',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13010,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13010,32.15,0.43,27,2645,75,NULL,'3.6 micron, color corrected','UGC 00634',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13011,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13011,32.29,0.4,28.7,2645,75,NULL,'B','UGC 00634',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13012,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13012,38.28,0.33,453,2646,70,NULL,NULL,'2MASX J01012662-0003489',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.0001,NULL,'17.16',0.39,NULL,NULL,NULL,NULL,NULL,1,15.360917,-0.06342,0.054,NULL,34520710983,539386109,8427907,17.16),(13013,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13013,38.28,0.33,453,2647,70,NULL,NULL,'2MASX J01012782+0000450',NULL,'2015arXiv151105856S',2015,1,0.11,NULL,'G',0.000109,NULL,'17.8g',0.06,'AGN',NULL,NULL,NULL,NULL,1,15.365833,0.01258,0.054,NULL,66679219307,1041862801,16279106,17.8),(13014,'Tully est','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13014,30.68,0.8,13.7,2648,75,NULL,NULL,'NGC 0337A',NULL,'1988NBGC.C....0000T',1988,1,5.9,'Da Costa, et al. (1998,AJ,116,1) give v = 413 +/- 83 km/sec.','G',0.000007,NULL,'12.7B',4.5,'SAB(s)dm',NULL,NULL,NULL,NULL,1,15.39125,-7.58825,0.328,NULL,34534214676,539597104,8431204,12.7),(13015,'IRAS','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13015,35.18,0.8,109,2649,75,NULL,'MAT, I','ESO 113- G 006',NULL,'1997ApJS..109..333W',1997,1,1.29,NULL,'G',0.000033,NULL,'16.17',0.21,'Sbc',NULL,NULL,NULL,NULL,1,15.3959166667,-59.74153,0,NULL,36183483424,565366928,8833858,16.17),(13016,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13016,34.86,NULL,94,2649,NULL,NULL,'Dipole','ESO 113- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13017,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13017,34.88,NULL,94.4,2649,NULL,NULL,'Dipole + Quadrupole','ESO 113- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13018,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13018,34.88,NULL,94.5,2649,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 113- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13019,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13019,35.01,0.49,100,2649,75,NULL,'IR','ESO 113- G 006',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13020,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13020,35.04,0.43,102,2649,75,NULL,'MAT, I, raw','ESO 113- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13021,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13021,35.06,NULL,103,2649,NULL,NULL,NULL,'ESO 113- G 006',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13022,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13022,35.12,0.32,106,2649,85,NULL,'I, raw','ESO 113- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13023,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13023,35.16,0.32,108,2649,85,NULL,'I, inv','ESO 113- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13024,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13024,35.22,0.43,111,2649,75,NULL,'MAT, I, inv','ESO 113- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13025,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13025,35.31,0.48,115,2649,NULL,NULL,'Malmquist cor.','ESO 113- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13026,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13026,35.3,0.48,115,2649,NULL,NULL,NULL,'ESO 113- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13027,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13027,35.34,0.2,117,2649,74.4,NULL,NULL,'ESO 113- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13028,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13028,35.35,0.43,117,2649,75,NULL,'MAT, I, cor','ESO 113- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13029,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1995as',NULL,13029,42.27,0.65,1900,2650,74.2,NULL,'SALT 2','[PDG95a] J010135.35+042614.1',0.498,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,'S/Irr',NULL,NULL,NULL,NULL,1,15.3972917,4.43725,0.065,NULL,66703640466,1042244382,16285068,NULL),(13030,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1995as','R',13030,42.37,NULL,1980,2650,65,NULL,'SALT','[PDG95a] J010135.35+042614.1',0.498,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13031,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1995as',NULL,13031,43.03,0.45,2690,2650,70,NULL,'SALT','[PDG95a] J010135.35+042614.1',0.498,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13032,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1995as',NULL,13032,43.2,0.42,2910,2650,65,NULL,'SALT','[PDG95a] J010135.35+042614.1',0.498,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13033,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1995as',NULL,13033,43.21,0.24,2930,2650,65,NULL,NULL,'[PDG95a] J010135.35+042614.1',0.498,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13034,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2000dr',NULL,13034,34.49,0.19,77.8,2651,70,NULL,'SALT 2','IC 1610',0.018796,'2013MNRAS.433.2240G',2013,1,1.4,NULL,'G',0.000063,NULL,'13.6B',1,'(R\')SAB0+:',NULL,NULL,NULL,NULL,1,15.4274166667,-15.56778,0.016,NULL,35429682546,553588789,8649824,13.6),(13035,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13035,34.24,0.46,70.4,2651,70,NULL,NULL,'IC 1610',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13036,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13036,39.14,0.46,673,2652,70,NULL,NULL,'SDSS J010145.90+000641.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000089,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,15.4412917,0.11164,0.061,NULL,66680273808,1041879278,16279363,18.7),(13037,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13037,33.88,0.2,59.7,2653,74.4,NULL,NULL,'UGC 00637',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000067,NULL,'16.0',0.5,'SBcd:',NULL,NULL,NULL,NULL,1,15.442,3.08203,0.033,NULL,66705478312,1042273098,16285517,16),(13038,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13038,33.94,0.4,61.5,2653,NULL,NULL,NULL,'UGC 00637',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13039,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13039,34.28,0.34,71.9,2653,NULL,NULL,'Malmquist cor.','UGC 00637',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13040,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 02162','R',13040,39.5,0.19,678,2654,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02162',0.1727,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,15.442417,-0.13367,0.054,NULL,34522801504,539418773,8428418,NULL),(13041,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 02162','R',13041,39.87,0.1,802,2654,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 02162',0.1727,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13042,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13042,37.72,0.33,350,2655,70,NULL,NULL,'2MASX J01014950+1433080',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000075,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,15.456417,14.55225,0.113,NULL,67583906235,1055998534,16499977,18.1),(13043,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13043,39.06,0.46,650,2656,70,NULL,NULL,'2MASX J01015284+0034302',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000137,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,15.47025,0.575,0.102,NULL,66680332974,1041880202,16279378,17.6),(13044,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13044,37.72,0.33,350,2657,70,NULL,NULL,'2MASX J01015322+1434260',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.57',0.28,NULL,NULL,NULL,NULL,NULL,1,15.4717916667,14.57389,0.113,NULL,67639468271,1056866691,16513542,16.57),(13045,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13045,36.04,0.54,162,2658,70,NULL,NULL,'2MASX J01015385-2033438',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'15.97',0.33,NULL,NULL,NULL,NULL,NULL,1,15.474375,-20.56214,0.068,NULL,35398729740,553105152,8642268,15.97),(13046,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13046,36.65,0.51,214,2659,70,NULL,NULL,'AM 0059-374 NED03',NULL,'2014MNRAS.445.2677S',2014,1,0.53,'6dF DR2 has z = 0.030426.','G',0.000133,NULL,'16.0',0.47,'E',NULL,NULL,NULL,NULL,1,15.4752917,-37.50853,NULL,NULL,38153762170,596152533,9314883,16),(13047,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13047,37.27,0.46,285,2660,70,NULL,NULL,'2MASX J01015516-0034314',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000094,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,15.4795417,-0.57536,0.077,NULL,34522927790,539420746,8428449,17.4),(13048,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13048,36.09,0.56,165,2661,70,NULL,NULL,'2MASX J01015664-1443240',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.76',0.37,NULL,NULL,NULL,NULL,NULL,1,15.4859583,-14.72333,0.013,NULL,35422006565,553468852,8647950,16.76),(13049,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13049,37.74,0.46,352,2662,70,NULL,NULL,'2MASX J01015811+0026122',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000076,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,15.4920417,0.43689,0.113,NULL,66677524712,1041836323,16278692,17.8),(13050,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 17862','R',13050,40.87,0.14,1310,2663,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2007nr','SDSS J010159.73+004058.2',0.14,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,NULL,'21.9g',0.03,NULL,NULL,NULL,NULL,NULL,1,15.498917,0.68286,0.102,NULL,66677506515,1041836039,16278688,21.9),(13051,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 17862','R',13051,41.16,0.28,1500,2663,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2007nr','SDSS J010159.73+004058.2',0.14,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13052,'SNII optical','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2007nr',NULL,13052,39,0.09,554,2663,NULL,NULL,'SCM 55 SNII','SDSS J010159.73+004058.2',0.14,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13053,'SNII optical','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2007nr',NULL,13053,39.34,0.11,648,2663,NULL,NULL,'SCM 15 SDSS SNII','SDSS J010159.73+004058.2',0.14,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13054,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13054,36.63,0.46,212,2664,70,NULL,NULL,'2MASX J01020438+0023242',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000076,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,15.518375,0.39006,0.113,NULL,66677526353,1041836349,16278692,16.9),(13055,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13055,35.67,0.25,136,2665,74.4,NULL,NULL,'UGC 00638',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000113,NULL,'13.79',0.9,'cD',NULL,NULL,NULL,NULL,1,15.522417,26.95181,0.265,NULL,67287698540,1051370289,16427660,13.79),(13056,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13056,35.82,0.45,146,2665,70,NULL,NULL,'UGC 00638',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13057,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13057,38.03,0.33,403,2666,70,NULL,NULL,'2MASX J01020752-0947234',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000122,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,15.531333,-9.78981,0.149,NULL,35265649247,551025769,8609777,16.9),(13058,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2005eg',NULL,13058,39.22,0.12,587,2667,74.2,NULL,'SALT 2','SDSS J010208.65-005246.8',0.19,'2010ApJ...716..712A',2010,1,0.14,NULL,'G',NULL,NULL,'18.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,15.5360417,-0.87967,0.128,NULL,34519835628,539372431,8427694,18.8),(13059,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2005eg',NULL,13059,39.75,0.03,750,2667,70,NULL,'SDSS-II SN 00762','SDSS J010208.65-005246.8',0.19,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13060,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2005eg',NULL,13060,39.89,0.13,800,2667,70,NULL,'SDSS-II SN 00762, SALT 2','SDSS J010208.65-005246.8',0.19,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13061,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2005eg',NULL,13061,39.92,0.09,810,2667,65,NULL,'SALT2','SDSS J010208.65-005246.8',0.19,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13062,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 00762','R',13062,40.04,0.19,855,2667,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005eg','SDSS J010208.65-005246.8',0.19,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13063,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2005eg',NULL,13063,40.06,0.1,863,2667,65,NULL,'MLCS2k2','SDSS J010208.65-005246.8',0.19,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13064,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 00762','R',13064,40.06,0.11,865,2667,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005eg','SDSS J010208.65-005246.8',0.19,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13065,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2005eg',NULL,13065,39.9,0.08,955,2667,70,NULL,'SALT 2','SDSS J010208.65-005246.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13066,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2005eg',NULL,13066,39.91,0.08,959,2667,70,NULL,'SALT 2, Malmquist cor.','SDSS J010208.65-005246.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13067,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13067,33.89,0.46,60,2668,NULL,NULL,'J','NGC 0352',NULL,'2007A&A...465...71T',2007,1,2.4,NULL,'G',0.00005,NULL,'13.39',0.9,'(R\')SB(rs)b?',NULL,NULL,NULL,NULL,1,15.538375,-4.24547,0.162,NULL,34560333629,540005212,8437581,13.39),(13068,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13068,33.9,0.47,60.3,2668,NULL,NULL,'H','NGC 0352',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13069,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13069,33.94,0.45,61.4,2668,NULL,NULL,'K','NGC 0352',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13070,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13070,34.17,0.49,68.2,2668,75,NULL,'IR','NGC 0352',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13071,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13071,34.33,0.4,73.5,2668,NULL,NULL,'mean','NGC 0352',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13072,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13072,36.86,0.57,236,2669,70,NULL,NULL,'2MASX J01020967-5119121',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'16.19',0.4,'E',NULL,NULL,NULL,NULL,1,15.540333,-51.32011,NULL,NULL,36005996577,562593696,8790526,16.19),(13073,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13073,34.63,0.25,84.3,2670,74.4,NULL,NULL,'CGCG 501-070',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000073,NULL,'15.1',0.4,'E',NULL,NULL,NULL,NULL,1,15.542667,32.45189,0.181,NULL,67275142306,1051174098,16424595,15.1),(13074,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13074,37.79,0.46,362,2671,70,NULL,NULL,'2MASX J01021207-0834404',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000085,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,15.550333,-8.57781,0.277,NULL,35258783704,550918495,8608101,17.9),(13075,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 15417',NULL,13075,40.06,0.21,1030,2672,70,NULL,'SN photometric redshift distance, z photo =0.277 +/- 0.033','SDSS-II SN 15417',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,15.557875,0.46189,0.113,NULL,66677532786,1041836449,16278694,NULL),(13076,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 11217','RN',13076,39.09,0.2,574,2673,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 11217',0.144844,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13077,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 11217','RN',13077,39.43,0.15,672,2673,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 11217',0.144844,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13078,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13078,38.53,0.46,508,2674,70,NULL,NULL,'2MASX J01021997+0021333',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000095,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,15.5832916667,0.35922,0.113,NULL,66677528672,1041836385,16278693,17.9),(13079,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13079,33.55,0.38,51.2,2675,NULL,NULL,NULL,'NGC 0353',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000027,NULL,'14.55',0.4,'SBa pec:       HII',NULL,NULL,NULL,NULL,1,15.6022083333,-1.95886,0.139,NULL,34556468887,539944826,8436637,14.55),(13080,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13080,33.7,0.2,55,2675,74.4,NULL,NULL,'NGC 0353',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13081,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13081,33.88,0.33,59.7,2675,NULL,NULL,'Malmquist cor.','NGC 0353',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13082,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13082,36.99,0.46,250,2676,70,NULL,NULL,'2MASX J01022618-0020155',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000081,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,15.609125,-0.33758,0.088,NULL,34519620408,539369068,8427641,16.9),(13083,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 07417','RN',13083,41.76,0.14,1660,2677,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 07417',0.355927,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13084,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 07417','RN',13084,42.03,0.21,1880,2677,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 07417',0.355927,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13085,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13085,38.03,0.33,403,2678,70,NULL,NULL,'SDSS J010228.39-095708.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000137,NULL,'18.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,15.618333,-9.95244,0.112,NULL,35265635858,551025560,8609774,18.1),(13086,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13086,37.92,0.46,383,2679,70,NULL,NULL,'SDSS J010230.32-105449.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000077,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,15.626375,-10.91378,0.065,NULL,35255816089,550872126,8607376,18.5),(13087,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 02146','RN',13087,43,0.25,2920,2680,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02146',0.365878,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13088,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 02146','RN',13088,43.03,0.21,2960,2680,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 02146',0.365878,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13089,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 15520','RN',13089,39.41,0.13,686,2681,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15520',0.110252,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13090,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 15520','RN',13090,39.58,0.22,743,2681,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15520',0.110252,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13091,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13091,36.08,0.46,165,2682,70,NULL,NULL,'2MASX J01023828+1510068',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000076,NULL,'16.5g',0.28,'E0',NULL,NULL,NULL,NULL,1,15.659583,15.1685,0.117,NULL,67641738416,1056902162,16514096,16.5),(13092,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 08354','RN',13092,38.47,0.32,431,2683,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 08354',0.143951,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13093,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 08354','RN',13093,40.41,0.22,1060,2683,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08354',0.143951,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13094,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13094,37.94,0.46,387,2684,70,NULL,NULL,'2MASX J01024339+0043132',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000109,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,15.6807083,0.72028,0.085,NULL,66677202972,1041831296,16278614,16.9),(13095,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13095,36.83,0.7,232,2685,70,NULL,NULL,'2MASX J01024347-1939137',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'16.10',0.48,'E',NULL,NULL,NULL,NULL,1,15.6812917,-19.65381,0.058,NULL,35399179340,553112177,8642377,16.1),(13096,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 02230','RN',13096,36.84,0.12,209,2686,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 02230',0.113323,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13097,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 02230','RN',13097,39.57,0.18,736,2686,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 02230',0.113323,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13098,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13098,36.85,0.46,235,2687,70,NULL,NULL,'2MASX J01024680-0019165',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000072,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,15.6950416667,-0.32136,0.081,NULL,34519589401,539368584,8427634,17.4),(13099,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 17077','RN',13099,39.74,0.32,792,2688,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 17077',0.121007,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13100,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 17077','RN',13100,40.66,0.44,1210,2688,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 17077',0.121007,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13101,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13101,34.31,0.49,72.7,2689,75,NULL,'IR','CGCG 384-060',NULL,'2011yCatp016004901K',2011,1,0.7,'Contains the line-emission regions UM 300.','G',0.000017,NULL,'15.0',0.2,NULL,NULL,NULL,NULL,NULL,1,15.7009583333,-1.47372,0.154,NULL,34556400371,539943755,8436621,15),(13102,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13102,34.44,0.36,77.1,2689,NULL,NULL,'Malmquist cor.','CGCG 384-060',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13103,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13103,34.48,0.36,78.8,2689,NULL,NULL,NULL,'CGCG 384-060',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13104,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13104,34.52,0.2,80.2,2689,74.4,NULL,NULL,'CGCG 384-060',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13105,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13105,34.34,0.49,73.8,2690,75,NULL,'IR','MCG -01-03-075',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000033,NULL,'15',0.15,NULL,NULL,NULL,NULL,NULL,1,15.701125,-6.41158,0.245,NULL,34535522104,539617532,8431523,15),(13106,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13106,34.43,0.32,77,2690,NULL,NULL,NULL,'MCG -01-03-075',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13107,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13107,34.47,0.2,78.3,2690,74.4,NULL,NULL,'MCG -01-03-075',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13108,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13108,34.48,0.31,78.6,2690,NULL,NULL,'Malmquist cor.','MCG -01-03-075',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13109,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 05987','RN',13109,42.56,0.32,1980,2691,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 05987',0.639016,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13110,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 15772','RN',13110,41.74,0.23,1790,2692,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15772',0.240884,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13111,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 15772','RN',13111,41.86,0.28,1900,2692,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15772',0.240884,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13112,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13112,37.77,0.46,357,2693,70,NULL,NULL,'2MASX J01025000-0007375',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000076,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,15.7084583,-0.12714,0.081,NULL,34519603711,539368807,8427637,17.9),(13113,'IRAS','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13113,32.42,0.8,30.5,2694,75,NULL,'MAT, I','NGC 0360',NULL,'1997ApJS..109..333W',1997,1,4.03,NULL,'G',0.000027,NULL,'13.40',0.52,'Scd',NULL,NULL,NULL,NULL,1,15.714375,-65.60997,0,NULL,36062727154,563480111,8804376,13.4),(13114,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13114,31.91,0.4,24.1,2694,75,NULL,NULL,'NGC 0360',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13115,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13115,31.91,0.39,24.1,2694,73,NULL,'IR','NGC 0360',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13116,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13116,32.12,0.39,26.6,2694,73,NULL,'opt','NGC 0360',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13117,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13117,32.19,0.46,27.4,2694,NULL,NULL,'J','NGC 0360',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13118,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13118,32.22,0.47,27.8,2694,NULL,NULL,'H','NGC 0360',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13119,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13119,32.25,0.43,28.2,2694,75,NULL,'MAT, I, raw','NGC 0360',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13120,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13120,32.32,0.32,29.1,2694,85,NULL,'I, raw','NGC 0360',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13121,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13121,32.33,0.45,29.2,2694,NULL,NULL,'K','NGC 0360',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13122,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13122,32.33,0.4,29.3,2694,NULL,NULL,'mean','NGC 0360',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13123,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13123,32.34,0.4,29.4,2694,NULL,NULL,NULL,'NGC 0360',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13124,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13124,32.36,0.32,29.7,2694,85,NULL,'I, inv','NGC 0360',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13125,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13125,32.37,0.49,29.8,2694,75,NULL,'IR','NGC 0360',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13126,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13126,32.44,0.2,30.8,2694,74.4,NULL,NULL,'NGC 0360',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13127,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13127,32.45,0.43,30.8,2694,75,NULL,'MAT, I, inv','NGC 0360',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13128,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13128,32.46,0.43,31,2694,75,NULL,'3.6 micron, color corrected','NGC 0360',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13129,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13129,32.49,0.43,31.5,2694,75,NULL,'MAT, I, cor','NGC 0360',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13130,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13130,32.52,0.43,32,2694,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0360',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13131,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13131,33,NULL,39.8,2694,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 0360',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13132,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13132,33.01,NULL,40,2694,NULL,NULL,'Dipole + Quadrupole','NGC 0360',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13133,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13133,33.03,NULL,40.3,2694,NULL,NULL,'Dipole','NGC 0360',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13134,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13134,33.1,NULL,41.7,2694,NULL,NULL,NULL,'NGC 0360',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13135,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13135,36.45,0.36,195,2695,NULL,NULL,NULL,'2MASX J01025568-0624422',NULL,'2009ApJS..182..474S',2009,1,0.58,NULL,'G',0.000027,NULL,'16.73',0.3,NULL,NULL,NULL,NULL,NULL,1,15.7320416667,-6.41178,0.245,NULL,34535520970,539617515,8431523,16.73),(13136,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13136,36.49,0.2,199,2695,74.4,NULL,NULL,'2MASX J01025568-0624422',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13137,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13137,36.55,0.35,204,2695,NULL,NULL,'Malmquist cor.','2MASX J01025568-0624422',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13138,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2006jy',NULL,13138,39.48,0.08,786,2696,70,NULL,'Hubble residual 0.00 for z0.20430; SDSS-II SN 15203','SDSS-II SN 15203 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,15.73475,0.18303,0.095,NULL,66677621765,1041837840,16278716,NULL),(13139,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2006jy','R',13139,40.09,0.19,865,2696,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006jy; SDSS-II SN 15203','SDSS-II SN 15203 HOST',0.204439,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13140,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2006jy','R',13140,40.16,0.1,895,2696,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006jy; SDSS-II SN 15203','SDSS-II SN 15203 HOST',0.204439,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13141,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2006jy',NULL,13141,39.98,0.08,991,2696,70,NULL,'SALT 2; SDSS-II SN 15203','SDSS-II SN 15203 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13142,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2006jy',NULL,13142,39.99,0.08,995,2696,70,NULL,'SALT 2, Malmquist cor.; SDSS-II SN 15203','SDSS-II SN 15203 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13143,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13143,34.72,0.27,87.8,2697,70,NULL,NULL,'CGCG 384-061',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000068,NULL,'15.3g',0.56,'S0',NULL,NULL,NULL,NULL,1,15.7572083,-1.11094,0.157,NULL,34519677728,539369964,8427655,15.3),(13144,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 18948',NULL,13144,39.92,0.46,963,2698,70,NULL,'SN photometric redshift distance, z photo =0.257 +/- 0.073','SDSS-II SN 18948',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','21.6g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,15.759167,-0.85253,0.085,NULL,34519850002,539372656,8427697,21.6),(13145,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 18948','R',13145,40.66,0.28,1070,2698,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18948',0.263077,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13146,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 18948','R',13146,40.75,0.34,1120,2698,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18948',0.263077,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13147,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13147,38.37,0.46,472,2699,70,NULL,NULL,'2MASX J01030251+1330439',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000067,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,15.760583,13.51225,0.137,NULL,67584719217,1056011237,16500175,18.4),(13148,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13148,37.18,0.46,273,2700,70,NULL,NULL,'2MASX J01030565-0906512',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00008,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,15.773583,-9.11433,0.207,NULL,35265427224,551022300,8609723,17.2),(13149,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 12982','RN',13149,42.29,0.22,2270,2701,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 12982',0.267131,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13150,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 12982','RN',13150,42.44,0.23,2430,2701,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 12982',0.267131,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13151,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 15033','R',13151,40.11,0.25,865,2702,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15033',0.216974,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,15.778375,-0.15672,0.081,NULL,34519607944,539368874,8427638,NULL),(13152,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 15033','R',13152,40.28,0.19,937,2702,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15033',0.216974,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13153,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13153,35.86,0.46,149,2703,70,NULL,NULL,'2MASX J01031191+1348390',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000077,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,15.7997083,13.81081,0.137,NULL,67584762636,1056011916,16500186,17),(13154,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13154,35.84,0.48,147,2704,70,NULL,NULL,'ESO 541- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15',0.2,'S0-a',NULL,NULL,NULL,NULL,1,15.8035833333,-20.99569,0.095,NULL,35384216105,552878376,8638724,15),(13155,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13155,37.63,0.33,335,2705,70,NULL,NULL,'2MASX J01031336+0030381',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000059,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,15.805625,0.51042,0.108,NULL,66677661561,1041838461,16278725,17.7),(13156,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13156,33.92,NULL,60.8,2706,NULL,NULL,'B','ESO 243- G 020',NULL,'2005Ap&SS.298..577R',2005,1,0.87,NULL,'G',0.000033,NULL,'16.02',0.28,'S...',NULL,NULL,NULL,NULL,1,15.810125,-43.01133,NULL,NULL,38160394311,596256161,9316502,16.02),(13157,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13157,33.92,NULL,60.8,2706,NULL,NULL,'I','ESO 243- G 020',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13158,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13158,34.79,0.37,90.9,2706,NULL,NULL,NULL,'ESO 243- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13159,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13159,34.83,0.2,92.5,2706,74.4,NULL,NULL,'ESO 243- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13160,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13160,34.98,0.34,99.2,2706,NULL,NULL,'Malmquist cor.','ESO 243- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13161,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 01151','RN',13161,41.18,0.29,1260,2707,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 01151',0.36284,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13162,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 01151','RN',13162,41.24,0.33,1300,2707,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 01151',0.36284,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13163,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13163,37.16,0.57,270,2708,70,NULL,NULL,'2MASX J01031574-0132566',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000093,NULL,'17.08',0.7,NULL,NULL,NULL,NULL,NULL,1,15.8157083333,-1.54897,0.154,NULL,34556574040,539946469,8436663,17.08),(13164,'IRAS','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13164,33.86,0.8,59.1,2709,75,NULL,'MAT, I','NGC 0354',NULL,'1997ApJS..109..333W',1997,1,0.8,NULL,'G',0.00003,NULL,'14.39',0.4,'SB pec         Sbrst',NULL,NULL,NULL,'Starburst',1,15.8182916667,22.34267,0.133,NULL,67395503365,1053054740,16453980,14.39),(13165,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13165,32.32,0.55,29.1,2709,NULL,NULL,'Malmquist cor.','NGC 0354',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13166,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13166,32.32,0.32,29.1,2709,85,NULL,'I, raw','NGC 0354',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13167,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13167,32.32,0.32,29.1,2709,85,NULL,'I, inv','NGC 0354',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13168,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13168,32.46,0.52,31,2709,NULL,NULL,NULL,'NGC 0354',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13169,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13169,32.88,0.43,37.6,2709,75,NULL,'MAT, I, raw','NGC 0354',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13170,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13170,32.96,0.43,39.1,2709,75,NULL,'MAT, I, inv','NGC 0354',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13171,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13171,33.08,0.69,41.2,2709,100,NULL,'mid-IR','NGC 0354',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13172,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13172,33.29,0.43,45.5,2709,75,NULL,'MAT, I, cor','NGC 0354',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13173,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13173,33.33,0.47,46.3,2709,NULL,NULL,'H','NGC 0354',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13174,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13174,33.46,0.45,49.3,2709,NULL,NULL,'K','NGC 0354',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13175,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13175,33.56,0.46,51.5,2709,NULL,NULL,'J','NGC 0354',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13176,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13176,33.96,0.4,62,2709,NULL,NULL,'mean','NGC 0354',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13177,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 03508','R',13177,41.81,0.27,1540,2710,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03508',0.4967,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,15.8237916667,-0.179,0.081,NULL,34519605259,539368832,8427638,NULL),(13178,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13178,35.79,0.2,144,2711,74.4,NULL,NULL,'UGC 00644',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000133,NULL,'15.3g',0.32,'S-Irr','Pair member (points to parent)',NULL,NULL,NULL,1,15.8255417,14.03767,0.137,NULL,67584011821,1056000184,16500002,15.3),(13179,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13179,36.28,0.61,180,2712,70,NULL,NULL,'2MASX J01032021-0147256',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.000097,NULL,'16.96',0.36,NULL,NULL,NULL,NULL,NULL,1,15.8342917,-1.79036,0.143,NULL,34556545928,539946030,8436656,16.96),(13180,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13180,36.5,0.85,199,2713,70,NULL,NULL,'2MASX J01032027-0507476',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'16.52',0.24,NULL,NULL,NULL,NULL,NULL,1,15.8344166667,-5.12994,0.153,NULL,34552082953,539876296,8435567,16.52),(13181,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13181,36.86,0.19,236,2714,70,NULL,NULL,'2MASX J01032159-0028496',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.69',0.27,NULL,NULL,NULL,NULL,NULL,1,15.840125,-0.48044,0.093,NULL,34519950945,539374233,8427722,17.69),(13182,'Tully est','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13182,32.53,0.8,32.1,2715,75,NULL,'B','NGC 0357',NULL,'1988NBGC.C....0000T',1988,1,2.4,NULL,'G',0.000053,NULL,'13.14',1.7,'SB(r)0/a:','Brightest group member',NULL,NULL,NULL,1,15.841167,-6.33922,0.245,NULL,34532045456,539563210,8430675,13.14),(13183,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13183,36.86,0.19,236,2716,70,NULL,NULL,'2MASX J01032259-0027426',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00015,NULL,'17.72',0.22,NULL,NULL,NULL,NULL,NULL,1,15.844125,-0.46169,0.093,NULL,34520127603,539376993,8427765,17.72),(13184,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13184,38.13,0.46,423,2717,70,NULL,NULL,'SDSS J010323.01-001832.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,15.845917,-0.30917,0.093,NULL,34519551466,539367991,8427624,17.9),(13185,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 19441','RN',13185,40.13,0.13,974,2718,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 19441',0.090585,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13186,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 19441','RN',13186,40.28,0.25,1040,2718,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19441',0.090585,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13187,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13187,37.63,0.33,335,2719,70,NULL,NULL,'SDSS J010325.37+002948.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000082,NULL,'18.5g',0.09,NULL,NULL,NULL,NULL,NULL,1,15.8557083,0.49692,0.108,NULL,66677875071,1041841797,16278778,18.5),(13188,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 09819','RN',13188,41.3,0.5,1670,2720,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 09819',0.093451,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13189,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1998ef',NULL,13189,33.28,0.25,44.5,2721,74.2,NULL,'SALT 2','UGC 00646',0.01774,'2010ApJ...716..712A',2010,1,1.2,NULL,'G',0.00003,NULL,'13.8B',0.5,'SB?',NULL,NULL,NULL,NULL,1,15.8599583,32.23736,0.165,NULL,67275269494,1051176085,16424626,13.8),(13190,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1998ef',NULL,13190,33.82,0.19,57.2,2721,70,NULL,'SALT 2','UGC 00646',0.01774,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13191,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1998ef',NULL,13191,33.85,0.08,58.9,2721,74.4,NULL,NULL,'UGC 00646',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13192,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1998ef',NULL,13192,33.89,0.29,58.9,2721,70,NULL,'SALT','UGC 00646',0.01774,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13193,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1998ef',NULL,13193,33.98,0.04,61.4,2721,70,NULL,'SALT 2','UGC 00646',0.01774,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13194,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1998ef',NULL,13194,33.98,0.11,61.4,2721,72,NULL,NULL,'UGC 00646',0.01774,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13195,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1998ef',NULL,13195,34.04,0.32,63.1,2721,65,NULL,'SALT','UGC 00646',0.01774,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13196,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1998ef',NULL,13196,34.08,0.18,64.4,2721,73.8,NULL,'SALT 2 (SNANA)','UGC 00646',0.0177,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13197,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1998ef',NULL,13197,34.09,0.21,64.7,2721,65,NULL,'MLCS17','UGC 00646',0.01774,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13198,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1998ef',NULL,13198,34.14,0.11,65,2721,65,NULL,'MLCS2k2','UGC 00646',0.01774,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13199,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1998ef',NULL,13199,34.11,0.02,65.3,2721,65,NULL,'SALT','UGC 00646',0.01774,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13200,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1998ef',NULL,13200,34.12,0.24,65.4,2721,65,NULL,'SALT2','UGC 00646',0.01774,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13201,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1998ef',NULL,13201,34.16,0.11,66.9,2721,65,NULL,'MLCS2k2','UGC 00646',0.01774,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13202,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1998ef',NULL,13202,34.17,0.21,67,2721,65,NULL,'MLCS31','UGC 00646',0.01774,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13203,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1998ef',NULL,13203,34.18,0.23,67.4,2721,65,NULL,NULL,'UGC 00646',0.01774,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13204,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1998ef',NULL,13204,34.27,0.17,71.4,2721,70.8,NULL,NULL,'UGC 00646',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13205,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 1998ef',NULL,13205,34.52,0.14,80.2,2721,60,NULL,NULL,'UGC 00646',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13206,'IRAS','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13206,34.26,0.8,71.2,2721,75,NULL,'W91PP, r','UGC 00646',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13207,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13207,33.85,0.08,58.9,2721,74.4,NULL,NULL,'UGC 00646',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13208,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13208,33.99,0.4,62.8,2721,75,NULL,'HOSTS SN 1998ef','UGC 00646',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13209,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13209,34.08,0.43,65.3,2721,75,NULL,'3.6 micron, color corrected','UGC 00646',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13210,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13210,34.1,0.42,66.1,2721,NULL,18.48,'3.6 micron','UGC 00646',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13211,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13211,34.23,0.43,70.3,2721,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00646',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13212,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13212,34.3,0.08,72.6,2721,NULL,NULL,NULL,'UGC 00646',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13213,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13213,34.34,0.4,73.7,2721,NULL,NULL,'mean','UGC 00646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13214,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13214,34.34,0.38,74,2721,75,NULL,'W91PP, r, raw','UGC 00646',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13215,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13215,34.36,0.47,74.5,2721,NULL,NULL,'H','UGC 00646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13216,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13216,34.43,0.38,77,2721,75,NULL,'W91PP, r, cor','UGC 00646',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13217,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13217,34.44,0.46,77.2,2721,NULL,NULL,'J','UGC 00646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13218,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13218,34.45,0.45,77.7,2721,NULL,NULL,'K','UGC 00646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13219,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13219,34.55,0.38,81.2,2721,75,NULL,'W91PP, r, inv','UGC 00646',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13220,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2007nf',NULL,13220,39.55,0.14,814,2722,70,NULL,'Hubble residual -0.14 for z0.22800','SDSS J010326.60+001953.7',NULL,'2011ApJ...740...92G',2011,1,0.09,NULL,'G',0.005,NULL,'20.3g',0.05,NULL,NULL,NULL,NULL,NULL,1,15.860833,0.33161,0.095,NULL,66677735812,1041839622,16278744,20.3),(13221,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2007nf',NULL,13221,39.65,0.21,851,2722,70,NULL,'SDSS-II SN 19341','SDSS J010326.60+001953.7',NULL,'2013MNRAS.434.1443X',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13222,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 19341','R',13222,40.25,0.21,914,2722,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007nf','SDSS J010326.60+001953.7',0.228,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13223,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 19341','R',13223,40.49,0.14,1020,2722,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007nf','SDSS J010326.60+001953.7',0.228,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13224,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2007nf',NULL,13224,40.07,0.11,1030,2722,70,NULL,'SALT 2','SDSS J010326.60+001953.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13225,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SN 2007nf',NULL,13225,40.09,0.11,1040,2722,70,NULL,'SALT 2, Malmquist cor.','SDSS J010326.60+001953.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13226,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 02947','RN',13226,40.94,0.12,1230,2723,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 02947',0.255823,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13227,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 02947','RN',13227,41.17,0.2,1370,2723,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02947',0.255823,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13228,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13228,36.77,0.59,226,2724,70,NULL,NULL,'2MASX J01033924-1356507',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.89',0.18,NULL,NULL,NULL,NULL,NULL,1,15.9135,-13.94753,0.013,NULL,35377790441,552777975,8637155,16.89),(13229,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 13908','R',13229,40.56,0.22,1040,2725,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J010339.82+001742.5',0.24,'2014arXiv1401.3317S',2014,1,0.1,NULL,'G',NULL,NULL,'19.9g',0.08,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,15.915917,0.29517,0.101,NULL,66677737351,1041839646,16278744,19.9),(13230,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 13908','R',13230,40.66,0.15,1090,2725,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J010339.82+001742.5',0.24,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13231,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 13908',NULL,13231,40.35,0.11,1170,2725,70,NULL,'SALT 2','SDSS J010339.82+001742.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13232,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 13908',NULL,13232,40.36,0.11,1180,2725,70,NULL,'SALT 2, Malmquist cor.','SDSS J010339.82+001742.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13233,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13233,35.81,0.46,145,2726,70,NULL,NULL,'2MASX J01034002+1553115',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000089,NULL,'15.6g',0.39,'S0',NULL,NULL,NULL,NULL,1,15.916667,15.88669,0.105,NULL,67642214465,1056909601,16514212,15.6),(13234,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 14961','R',13234,41.11,0.29,1220,2727,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J010340.65+005552.7',0.37,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,NULL,'21.4g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,15.919417,0.93131,0.041,NULL,66677273332,1041832395,16278631,21.4),(13235,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 14961','R',13235,41.4,0.27,1390,2727,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J010340.65+005552.7',0.37,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13236,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 14961',NULL,13236,41.01,0.19,1590,2727,70,NULL,'SALT 2','SDSS J010340.65+005552.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13237,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 14961',NULL,13237,41.06,0.19,1630,2727,70,NULL,'SALT 2, Malmquist cor.','SDSS J010340.65+005552.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13238,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13238,36.55,0.51,204,2728,70,NULL,NULL,'2MASX J01034096-1345487',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'16.37',0.38,NULL,NULL,NULL,NULL,NULL,1,15.9209166667,-13.76361,0.02,NULL,35377805125,552778205,8637159,16.37),(13239,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13239,38.06,0.62,410,2729,NULL,NULL,'Malmquist cor.','2MASX J01034126-0220153',NULL,'2009ApJS..182..474S',2009,1,0.66,NULL,'G',0.0001,NULL,'17.23',0.23,NULL,NULL,NULL,NULL,NULL,1,15.921875,-2.33764,0.131,NULL,34556071941,539938624,8436541,17.23),(13240,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13240,38.17,0.59,430,2729,NULL,NULL,NULL,'2MASX J01034126-0220153',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13241,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13241,38.21,0.2,439,2729,74.4,NULL,NULL,'2MASX J01034126-0220153',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13242,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13242,37.28,0.46,285,2730,70,NULL,NULL,'2MASX J01034490-0110363',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00009,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,15.937125,-1.17678,0.138,NULL,34553156688,539893073,8435829,16.7),(13243,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13243,35.6,0.54,132,2731,70,NULL,NULL,'2MASX J01034778-0857472',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.000102,NULL,'15.5g',0.46,'E0',NULL,NULL,NULL,NULL,1,15.94925,-8.96306,0.219,NULL,35265247609,551019493,8609679,15.5),(13244,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13244,35.77,0.46,142,2731,70,NULL,NULL,'2MASX J01034778-0857472',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13245,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13245,34.88,NULL,94.4,2732,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00653',NULL,'2010Ap&SS.325..163P',2010,1,1.01,NULL,'G',0.000023,NULL,'16.5',0.12,'Sc',NULL,NULL,NULL,NULL,1,15.953583,31.19769,0.161,NULL,67274811390,1051168927,16424514,16.5),(13246,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13246,34.89,NULL,95,2732,NULL,NULL,'Dipole + Quadrupole','UGC 00653',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13247,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13247,34.9,NULL,95.7,2732,NULL,NULL,'Dipole','UGC 00653',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13248,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13248,34.93,NULL,96.7,2732,NULL,NULL,NULL,'UGC 00653',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13249,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13249,34.96,0.67,98,2733,NULL,NULL,'Malmquist cor.','UGC 00652',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'17.',0.7,'SBcd?',NULL,NULL,NULL,NULL,1,15.96,22.02778,0.141,NULL,67396061271,1053063457,16454116,17),(13250,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13250,35.07,0.63,103,2733,NULL,NULL,NULL,'UGC 00652',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13251,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13251,35.12,0.2,106,2733,74.4,NULL,NULL,'UGC 00652',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13252,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13252,36.54,0.62,204,2734,70,NULL,NULL,'2MASX J01035245-2023298',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.0001,NULL,'16.15',0.33,NULL,NULL,NULL,NULL,NULL,1,15.968375,-20.39167,0.058,NULL,35397899273,553092176,8642065,16.15),(13253,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 18990',NULL,13253,40.8,0.33,1450,2735,70,NULL,'SN photometric redshift distance, z photo =0.422 +/- 0.093','SDSS-II SN 18990',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,15.9726666667,-0.59233,0.072,NULL,34520016435,539375256,8427738,NULL),(13254,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13254,35.48,0.52,125,2736,70,NULL,NULL,'2MASX J01035375-4922139',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'15.60',0.68,'E',NULL,NULL,NULL,NULL,1,15.973917,-49.37061,NULL,NULL,38148752249,596074253,9313660,15.6),(13255,'Brightest Stars','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13255,24.2,NULL,0.692,2737,NULL,NULL,'1R','LGS 3',NULL,'1996AN....317..179T',1996,1,2,NULL,'G',0.000001,NULL,'14.2',2,'dIrr/dSph','Brightest group member',NULL,NULL,NULL,1,15.979167,21.885,0.141,1,67396106016,1053064156,16454127,14.2),(13256,'Brightest Stars','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13256,24.7,NULL,0.871,2737,NULL,NULL,'1B','LGS 3',NULL,'1996AN....317..179T',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13257,'Brightest Stars','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13257,29.4,NULL,7.59,2737,NULL,NULL,NULL,'LGS 3',NULL,'1980ApJ...242...63S',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13258,'CMD','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13258,21.7,NULL,0.219,2737,NULL,NULL,NULL,'LGS 3',NULL,'1980ApJ...242...63S',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13259,'CMD','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13259,23.93,0.07,0.61,2737,NULL,NULL,NULL,'LGS 3',NULL,'2001ApJ...562..713M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13260,'CMD','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13260,23.96,NULL,0.619,2737,NULL,NULL,NULL,'LGS 3',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13261,'Horizontal Branch','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13261,23.92,0.15,0.608,2737,NULL,NULL,NULL,'LGS 3',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13262,'Horizontal Branch','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13262,23.98,0.1,0.625,2737,NULL,NULL,NULL,'LGS 3',NULL,'2001ApJ...562..713M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13263,'Red Clump','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13263,23.96,0.12,0.62,2737,NULL,NULL,NULL,'LGS 3',NULL,'2001ApJ...562..713M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13264,'RR Lyrae','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13264,24.07,0.15,0.65,2737,NULL,NULL,NULL,'LGS 3',NULL,'2011ApJ...730...14H',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13265,'TRGB','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13265,23.9,NULL,0.603,2737,NULL,NULL,NULL,'LGS 3',NULL,'1996AN....317..179T',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13266,'TRGB','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13266,24.05,0.06,0.65,2737,74.4,NULL,NULL,'LGS 3',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13267,'TRGB','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13267,24.08,0.3,0.655,2737,NULL,NULL,NULL,'LGS 3',NULL,'2001ApJ...562..713M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13268,'TRGB','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13268,24.43,0.07,0.769,2737,NULL,NULL,NULL,'LGS 3',NULL,'2005MNRAS.356..979M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13269,'TRGB','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13269,24.43,0.08,0.77,2737,NULL,NULL,'I','LGS 3',NULL,'1997AJ....114..680A',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13270,'TRGB','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13270,24.54,0.21,0.81,2737,NULL,NULL,'I','LGS 3',NULL,'1995AJ....110.1129L',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13271,'TRGB','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13271,24.55,0.4,0.813,2737,NULL,NULL,'I','LGS 3',NULL,'1997PASP..109..125M',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13272,'TRGB','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13272,24.58,0.21,0.824,2737,NULL,NULL,'HST KP Calibrated','LGS 3',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13273,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13273,36.91,0.54,242,2738,70,NULL,NULL,'2MASX J01035516-5121359',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.69',0.27,NULL,NULL,NULL,NULL,NULL,1,15.979833,-51.35989,NULL,NULL,36005970853,562593294,8790520,16.69),(13274,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13274,36.33,0.4,185,2739,NULL,NULL,'Malmquist cor.','MCG -01-03-083',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000013,NULL,'15.5b',0.3,NULL,NULL,NULL,NULL,NULL,1,15.9845,-2.26233,0.131,NULL,34555909972,539936093,8436501,15.5),(13275,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13275,36.58,0.35,207,2739,NULL,NULL,NULL,'MCG -01-03-083',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13276,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13276,36.62,0.2,211,2739,74.4,NULL,NULL,'MCG -01-03-083',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13277,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 09558','R',13277,41.54,0.38,1460,2740,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 09558',0.390578,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,15.9849583,0.38133,0.101,NULL,66677870984,1041841734,16278777,NULL),(13278,'SNIa','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 09558','R',13278,41.57,0.38,1480,2740,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 09558',0.390578,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13279,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 15958','RN',13279,42.69,0.28,2460,2741,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15958',0.40021,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13280,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 15958','RN',13280,43.12,0.43,3010,2741,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15958',0.40021,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13281,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13281,35.4,0.46,120,2742,70,NULL,NULL,'2MASX J01035875+1514505',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000093,NULL,'16.0g',0.35,'SF',NULL,NULL,NULL,NULL,1,15.9947917,15.24725,0.093,NULL,67642550841,1056914856,16514294,16),(13282,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 12957','RN',13282,41.63,0.09,1660,2743,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 12957',0.280103,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13283,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 12957','RN',13283,41.76,0.17,1760,2743,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 12957',0.280103,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13284,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 04461','RN',13284,41.1,0.17,1350,2744,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04461',0.227398,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13285,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 04461','RN',13285,41.97,0.2,2020,2744,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04461',0.227398,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13286,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13286,37.91,0.46,382,2745,70,NULL,NULL,'2MASX J01040128+1348101',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000074,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,16.0055416667,13.80269,0.101,NULL,67584519724,1056008120,16500126,18.2),(13287,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13287,37.07,0.16,260,2746,70,NULL,NULL,'2MASX J01040176-0048473',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000101,NULL,'15.9g',0.4,'E0',NULL,NULL,NULL,NULL,1,16.00725,-0.81306,0.072,NULL,34519774132,539371470,8427679,15.9),(13288,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 08137','RN',13288,38.75,0.13,528,2747,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 08137',0.066422,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13289,'SNIa SDSS','2016-12-15 15:13:42','2016-12-16 11:18:44','1','SDSS-II SN 08137','RN',13289,39.1,0.28,619,2747,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08137',0.066422,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13290,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13290,36.37,0.53,188,2748,70,NULL,NULL,'MCG -02-03-069',NULL,'2014MNRAS.445.2677S',2014,1,0.15,NULL,'G',0.00015,NULL,'15',0.15,NULL,NULL,NULL,NULL,NULL,1,16.010667,-11.64214,0.065,NULL,35255647526,550869492,8607335,15),(13291,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13291,37.73,0.46,351,2749,70,NULL,NULL,'2MASX J01040254+1511255',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000083,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,16.010667,15.19047,0.093,NULL,67642481119,1056913767,16514277,17.9),(13292,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13292,38.03,0.46,404,2750,70,NULL,NULL,'2MASX J01040291+0052311',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000093,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,16.0122083,0.87525,0.033,NULL,66677302017,1041832844,16278638,17.6),(13293,'FP','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13293,37.07,0.16,260,2751,70,NULL,NULL,'2MASX J01040403-0052232',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000086,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,16.016875,-0.87311,0.136,NULL,34519765371,539371333,8427677,17.3),(13294,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,'R',13294,34.75,0.49,89.3,2752,75,NULL,'IR','ESO 243- G 021',NULL,'2011yCatp016004901K',2011,1,1.15,NULL,'G',0.000033,NULL,'16.01',0.26,'Sc','Group member',NULL,NULL,NULL,1,16.017917,-46.22617,NULL,NULL,38142120566,595970633,9312041,16.01),(13295,'Tully-Fisher','2016-12-15 15:13:42','2016-12-16 11:18:44','1',NULL,NULL,13295,35.01,0.14,101,2752,NULL,NULL,NULL,'ESO 243- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13296,'FP','2016-12-15 15:13:43','2016-12-16 11:18:44','1',NULL,'R',13296,37.07,0.16,260,2753,70,NULL,NULL,'2MASX J01040450-0057332',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00008,NULL,'17.2g',0.22,'NLAGN',NULL,NULL,NULL,NULL,1,16.018833,-0.95919,0.136,NULL,34553097604,539892150,8435814,17.2),(13297,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:44','1',NULL,NULL,13297,34.74,0.47,88.9,2754,NULL,NULL,'H','IC 1615',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000033,NULL,'14.25',0.6,'SB(r)bc','in a pair',NULL,NULL,NULL,1,16.029333,-51.13306,NULL,NULL,36005549367,562586708,8790417,14.25),(13298,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:44','1',NULL,NULL,13298,34.87,0.46,94.4,2754,NULL,NULL,'J','IC 1615',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13299,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:44','1',NULL,NULL,13299,34.9,0.45,95.3,2754,NULL,NULL,'K','IC 1615',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13300,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:44','1',NULL,NULL,13300,34.94,0.35,97.3,2754,NULL,NULL,'Malmquist cor.','IC 1615',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13301,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:44','1',NULL,NULL,13301,34.98,0.35,99.2,2754,NULL,NULL,NULL,'IC 1615',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13302,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:44','1',NULL,NULL,13302,35.02,0.2,101,2754,74.4,NULL,NULL,'IC 1615',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13303,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:44','1',NULL,NULL,13303,35.03,0.4,102,2754,NULL,NULL,'mean','IC 1615',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13304,'FP','2016-12-15 15:13:43','2016-12-16 11:18:44','1',NULL,'R',13304,36.86,0.19,236,2755,70,NULL,NULL,'2MASX J01040703-0025182',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000097,NULL,'16.0g',0.3,'S0',NULL,NULL,NULL,NULL,1,16.029333,-0.42183,0.101,NULL,34520111016,539376734,8427761,16),(13305,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:44','1','SDSS-II SN 19987',NULL,13305,40.7,0.12,1380,2756,70,NULL,'SN photometric redshift distance, z photo =0.396 +/- 0.030','SDSS-II SN 19987',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,16.0447917,-0.32653,0.101,NULL,34520081133,539376267,8427754,NULL),(13306,'FP','2016-12-15 15:13:43','2016-12-16 11:18:44','1',NULL,'R',13306,36.86,0.19,236,2757,70,NULL,NULL,'2MASX J01041357-0030122',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000088,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,16.056417,-0.50325,0.072,NULL,34519994928,539374920,8427733,16.6),(13307,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:44','1','SDSS-II SN 04864','RN',13307,40.92,0.24,1340,2758,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 04864',0.137086,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13308,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:44','1','SDSS-II SN 04864','RN',13308,41.27,0.27,1580,2758,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 04864',0.137086,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13309,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:44','1',NULL,NULL,13309,34.23,0.09,70.3,2759,NULL,NULL,NULL,'CGCG 384-064',NULL,'2009ApJS..182..474S',2009,1,0.67,NULL,'G',0.00005,NULL,'15.6g',0.37,'Sb',NULL,NULL,NULL,NULL,1,16.06325,-1.11431,0.138,NULL,34553142870,539892857,8435825,15.6),(13310,'FP','2016-12-15 15:13:43','2016-12-16 11:18:44','1',NULL,'R',13310,34.72,0.27,87.8,2760,70,NULL,NULL,'NGC 0359',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.000087,NULL,'14.3g',0.78,'S0-:',NULL,NULL,NULL,NULL,1,16.070667,-0.76492,0.072,NULL,34519724545,539370696,8427667,14.3),(13311,'FP','2016-12-15 15:13:43','2016-12-16 11:18:44','1',NULL,NULL,13311,36.66,0.55,215,2761,70,NULL,NULL,'2MASX J01041695-1506175',NULL,'2014MNRAS.445.2677S',2014,1,0.79,NULL,'G',0.00015,NULL,'16.80',0.25,NULL,NULL,NULL,NULL,NULL,1,16.070833,-15.10497,0,NULL,35430183661,553596619,8649947,16.8),(13312,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:44','1',NULL,NULL,13312,35.04,0.51,102,2762,NULL,NULL,'Malmquist cor.','NGC 0365',NULL,'2009ApJS..182..474S',2009,1,0.93,NULL,'G',0.000033,NULL,'14.21',0.56,'SB(r)bc pec:',NULL,NULL,NULL,NULL,1,16.078,-35.12142,NULL,NULL,38269827657,597966057,9343219,14.21),(13313,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:44','1',NULL,NULL,13313,35.14,0.49,107,2762,NULL,NULL,NULL,'NGC 0365',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13314,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:44','1',NULL,NULL,13314,35.18,0.2,109,2762,74.4,NULL,NULL,'NGC 0365',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13315,'FP','2016-12-15 15:13:43','2016-12-16 11:18:44','1',NULL,'R',13315,38.04,0.46,405,2763,70,NULL,NULL,'SDSS J010419.90+004050.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000063,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,16.0829583,0.68058,0.085,NULL,66677776230,1041840253,16278753,18.6),(13316,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:44','1',NULL,NULL,13316,34.17,0.11,68.4,2764,NULL,NULL,NULL,'AGC 410519',NULL,'2009ApJS..182..474S',2009,1,0.52,NULL,'G',0.000017,NULL,'18.33',0.12,NULL,NULL,NULL,NULL,NULL,1,16.090833,-1.53289,0.171,NULL,34556488276,539945129,8436642,18.33),(13317,'FP','2016-12-15 15:13:43','2016-12-16 11:18:44','1',NULL,'R',13317,37.95,0.46,389,2765,70,NULL,NULL,'SDSS J010423.97+154803.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000076,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,16.099917,15.80089,0.101,NULL,67645069210,1056954206,16514909,18.3),(13318,'FP','2016-12-15 15:13:43','2016-12-16 11:18:44','1',NULL,NULL,13318,35.11,0.47,105,2766,70,NULL,NULL,'AM 0102-464',NULL,'2014MNRAS.445.2677S',2014,1,0.85,NULL,'G',0.00008,NULL,'15.26',0.58,'S0','Group member',NULL,NULL,NULL,1,16.103625,-46.50206,NULL,NULL,38142206687,595971979,9312062,15.26),(13319,'FP','2016-12-15 15:13:43','2016-12-16 11:18:44','1',NULL,'R',13319,36.86,0.19,236,2767,70,NULL,NULL,'UGC 00663',NULL,'2015arXiv151105856S',2015,1,0.86,NULL,'G',0.0001,NULL,'15.3g',0.47,'E',NULL,NULL,NULL,NULL,1,16.1053333333,-0.18742,0.101,NULL,34520093870,539376466,8427757,15.3),(13320,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:44','1',NULL,NULL,13320,34.58,0.41,82.3,2768,NULL,NULL,NULL,'ESO 195- G 029',NULL,'2009ApJS..182..474S',2009,1,1.33,NULL,'G',0.000033,NULL,'15.00',0.43,'SAB(rs)c',NULL,NULL,NULL,NULL,1,16.1240417,-51.46047,NULL,NULL,36005657035,562588391,8790443,15),(13321,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:44','1',NULL,NULL,13321,34.62,0.2,84,2768,74.4,NULL,NULL,'ESO 195- G 029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13322,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:44','1',NULL,NULL,13322,34.78,0.37,90.2,2768,NULL,NULL,'Malmquist cor.','ESO 195- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13323,'FP','2016-12-15 15:13:43','2016-12-16 11:18:44','1',NULL,'R',13323,36.37,0.46,188,2769,70,NULL,NULL,'2MASX J01043012+1430140',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000086,NULL,'16.2g',0.34,'E0',NULL,NULL,NULL,NULL,1,16.1255417,14.50392,0.093,NULL,67640324866,1056880076,16513751,16.2),(13324,'FP','2016-12-15 15:13:43','2016-12-16 11:18:44','1',NULL,'R',13324,37.07,0.16,260,2770,70,NULL,NULL,'2MASX J01043024-0052192',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000078,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,16.1260417,-0.87211,0.136,NULL,34553082700,539891917,8435811,17.4),(13325,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13325,38.26,0.46,449,2771,70,NULL,NULL,'2MASX J01043029+0034318',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000092,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,16.126333,0.57553,0.118,NULL,66677824710,1041841011,16278765,16.8),(13326,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 17820',NULL,13326,40.18,0.19,1090,2772,70,NULL,'SN photometric redshift distance, z photo =0.296 +/- 0.033','SDSS-II SN 17820',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,16.1395417,-0.46653,0.107,NULL,34520005831,539375091,8427735,NULL),(13327,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 17820',NULL,13327,40.3,0.26,1150,2772,70,NULL,NULL,'SDSS-II SN 17820',NULL,'2013MNRAS.434.1443X',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13328,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 17820','R',13328,41.14,0.25,1260,2772,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17820',0.340709,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13329,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 17820','R',13329,41.32,0.22,1370,2772,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17820',0.340709,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13330,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13330,36.86,0.19,236,2773,70,NULL,NULL,'2MASX J01043352-0019115',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000103,NULL,'16.1g',0.37,'E0',NULL,NULL,NULL,NULL,1,16.139625,-0.32011,0.101,NULL,34520074807,539376168,8427752,16.1),(13331,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13331,37.66,0.6,341,2773,70,NULL,NULL,'2MASX J01043352-0019115',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13332,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13332,37.8,0.46,363,2774,70,NULL,NULL,'2MASX J01043614-0900302',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000069,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,16.1507083333,-9.00833,0.219,NULL,35261793532,550965523,8608836,17.5),(13333,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13333,36.42,0.79,193,2775,70,NULL,NULL,'2MASX J01043881-0415295',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.000093,NULL,'16.53',0.23,NULL,NULL,NULL,NULL,NULL,1,16.16175,-4.25811,0.138,NULL,34549904102,539842251,8435035,16.53),(13334,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13334,34.72,0.27,87.8,2776,70,NULL,NULL,'NGC 0364',NULL,'2015arXiv151105856S',2015,1,1.31,'UGC misprints dec as -01d30\'. UGC galactic coordinates are correct.','G',0.000073,NULL,'13.8g',0.93,'(R)SB(s)0^0^:',NULL,NULL,NULL,NULL,1,16.170125,-0.80275,0.136,NULL,34553072190,539891752,8435808,13.8),(13335,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13335,35.33,0.48,116,2776,70,NULL,NULL,'NGC 0364',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13336,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13336,34.45,0.11,77.8,2777,NULL,NULL,NULL,'2MFGC 00773',NULL,'2009ApJS..182..474S',2009,1,0.98,NULL,'G',0.000013,NULL,'15.7g',0.32,'Sc(f)',NULL,NULL,NULL,NULL,1,16.1731666667,-0.95592,0.136,NULL,34553110129,539892345,8435817,15.7),(13337,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 02855',NULL,13337,39.84,0.23,929,2778,70,NULL,NULL,'SDSS-II SN 02855',NULL,'2013MNRAS.434.1443X',2013,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,16.175167,-0.35642,0.101,NULL,34520072350,539376130,8427752,NULL),(13338,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 02855','R',13338,40.45,0.23,990,2778,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02855',0.245075,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13339,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 02855',NULL,13339,40.02,0.26,1010,2778,70,NULL,'SN photometric redshift distance, z photo =0.271 +/- 0.041','SDSS-II SN 02855',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13340,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 02855','R',13340,40.58,0.18,1050,2778,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 02855',0.245075,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13341,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 02855',NULL,13341,40.34,0.13,1170,2778,70,NULL,'SALT 2','SDSS-II SN 02855',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13342,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 02855',NULL,13342,40.36,0.13,1180,2778,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 02855',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13343,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13343,35.9,0.46,151,2779,70,NULL,NULL,'2MASX J01044468-1104232',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000084,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,16.1862083333,-11.07303,0.063,NULL,35256021015,550875328,8607427,16.5),(13344,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2005mp',NULL,13344,40.75,0.25,1110,2780,70,NULL,'SALT 2','SDSS J010445.68+000320.3',0.27,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,16.190333,0.05564,0.101,NULL,66676984616,1041827884,16278560,NULL),(13345,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2005it',NULL,13345,40.19,0.18,833,2781,74.2,NULL,'SALT 2','SDSS J010445.73+003047.7',0.31,'2010ApJ...716..712A',2010,1,0.08,NULL,'G',NULL,NULL,'20.5g',0.07,NULL,NULL,NULL,NULL,NULL,1,16.190583,0.51328,0.118,NULL,66677805637,1041840713,16278761,20.5),(13346,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2005it',NULL,13346,40.88,0.21,1150,2781,65,NULL,'SALT2','SDSS J010445.73+003047.7',0.31,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13347,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2005it',NULL,13347,40.93,0.21,1170,2781,70,NULL,'SDSS-II SN 05966, SALT 2','SDSS J010445.73+003047.7',0.31,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13348,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 05966','R',13348,40.96,0.28,1190,2781,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005it','SDSS J010445.73+003047.7',0.31,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13349,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2005it',NULL,13349,40.99,0.07,1200,2781,70,NULL,'SDSS-II SN 05966','SDSS J010445.73+003047.7',0.31,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13350,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 05966','R',13350,41.05,0.21,1240,2781,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005it','SDSS J010445.73+003047.7',0.31,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13351,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2005it',NULL,13351,41.19,0.17,1320,2781,65,NULL,'MLCS2k2','SDSS J010445.73+003047.7',0.31,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13352,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2005it',NULL,13352,40.8,0.17,1450,2781,70,NULL,'SALT 2','SDSS J010445.73+003047.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13353,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2005it',NULL,13353,40.83,0.17,1470,2781,70,NULL,'SALT 2, Malmquist cor.','SDSS J010445.73+003047.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13354,'Brightest Stars','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13354,24.3,0.1,0.724,2782,NULL,NULL,NULL,'IC 1613',NULL,'1980ApJ...238...65H',1980,1,16.2,'Position is for the center of the bar.','G',0.000003,NULL,'9.88',14.5,'IB(s)m','Group member',NULL,NULL,NULL,1,16.199125,2.11778,0.021,0,66697640759,1042150636,16283603,9.88),(13355,'Brightest Stars','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13355,24.3,0.1,0.724,2782,NULL,NULL,NULL,'IC 1613',NULL,'1983ApJ...269..335H',1983,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13356,'Carbon Stars','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13356,24.3,NULL,0.724,2782,NULL,NULL,'I','IC 1613',NULL,'1988ASPC....4...75C',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13357,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13357,23.76,0.31,0.565,2782,NULL,NULL,'Z','IC 1613',NULL,'1994ApJ...426..542G',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13358,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13358,23.99,0.1,0.628,2782,NULL,NULL,'3.6 micron, inner, syst. +/- 0.15 mag','IC 1613',NULL,'2014A&A...572A..64M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13359,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13359,24.06,0.15,0.65,2782,NULL,NULL,'9, VI, +Z, KEY PROJECT','IC 1613',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13360,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13360,24.07,NULL,0.652,2782,NULL,18.47,'10, H, Photographic','IC 1613',NULL,'1987SAAOC..11..125W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13361,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13361,24.1,0.14,0.661,2782,NULL,NULL,'VI(W), inner, syst. +/- 0.40 mag','IC 1613',NULL,'2014A&A...572A..64M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13362,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13362,24.17,0.07,0.682,2782,NULL,NULL,'138, WI','IC 1613',NULL,'2001AcA....51..221U',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13363,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13363,24.19,0.11,0.689,2782,NULL,NULL,'MW HIPP','IC 1613',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13364,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13364,24.19,0.15,0.69,2782,NULL,NULL,'25, BRI, KEY PROJECT','IC 1613',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13365,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13365,24.2,0.2,0.692,2782,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian ','IC 1613',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13366,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13366,24.2,0.1,0.692,2782,NULL,NULL,'23, JHKs, GAL PL','IC 1613',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13367,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13367,24.2,0.02,0.692,2782,NULL,NULL,'138, VI, WI+','IC 1613',NULL,'2001AcA....51..221U',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13368,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13368,24.2,0.2,0.692,2782,NULL,NULL,'MW P02','IC 1613',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13369,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13369,24.21,0.19,0.695,2782,73,NULL,'Cepheids magnitudes Gaussian ','IC 1613',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13370,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13370,24.22,0.13,0.698,2782,NULL,NULL,'VI(W), PL 2','IC 1613',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13371,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13371,24.22,0.07,0.698,2782,NULL,NULL,'23, JHKs, LMC PL','IC 1613',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13372,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13372,24.23,0.19,0.701,2782,NULL,NULL,'MW GFG','IC 1613',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13373,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13373,24.23,0.2,0.701,2782,NULL,NULL,'MF91 PL','IC 1613',NULL,'2006A&A...445..901A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13374,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13374,24.23,0.19,0.701,2782,NULL,NULL,'12, VI','IC 1613',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13375,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13375,24.24,0.06,0.705,2782,NULL,NULL,'3.6 micron, outer, syst. +/- 0.23 mag','IC 1613',NULL,'2014A&A...572A..64M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13376,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13376,24.25,0.14,0.708,2782,NULL,NULL,'LMC VIHJK','IC 1613',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13377,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13377,24.26,0.07,0.711,2782,NULL,NULL,'23, JHKs, GAL+LMC PL','IC 1613',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13378,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13378,24.27,0.07,0.714,2782,NULL,NULL,'3.6 micron','IC 1613',NULL,'2009AIPC.1170...37N',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13379,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13379,24.27,0.02,0.715,2782,NULL,NULL,'5, BVRIJHK, 2 IRAC','IC 1613',NULL,'2009ApJ...695..996F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13380,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13380,24.28,0.22,0.718,2782,NULL,NULL,'JK(W), PL 2','IC 1613',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13381,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13381,24.29,0.14,0.72,2782,NULL,NULL,'LMC W01','IC 1613',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13382,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13382,24.29,0.04,0.721,2782,NULL,NULL,'39, JK','IC 1613',NULL,'2006ApJ...642..216P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13383,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13383,24.29,0.03,0.721,2782,NULL,NULL,'4.5 micron','IC 1613',NULL,'2009AIPC.1170...37N',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13384,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13384,24.29,0.03,0.721,2782,NULL,18.48,'Syst. +/- 0.03 mag','IC 1613',NULL,'2013ApJ...773..106S',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13385,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13385,24.29,0.22,0.721,2782,73,NULL,'Cepheids periods Gaussian ','IC 1613',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13386,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13386,24.3,0.1,0.724,2782,NULL,NULL,'11, BVRI','IC 1613',NULL,'1988ApJ...326..691F',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13387,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13387,24.3,NULL,0.724,2782,NULL,18.47,'?, B, Photographic','IC 1613',NULL,'1987SAAOC..11..125W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13388,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13388,24.31,0.07,0.728,2782,NULL,NULL,'3.6 micron, outermost, syst. +/- 0.30 mag','IC 1613',NULL,'2014A&A...572A..64M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13389,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13389,24.31,0.08,0.728,2782,NULL,NULL,'3.6 micron, SMC m-M = 18.90 PL','IC 1613',NULL,'2012Ap&SS.341..105N',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13390,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13390,24.31,0.12,0.728,2782,NULL,NULL,'10, H','IC 1613',NULL,'1984ApJ...276..487M',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13391,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13391,24.31,0.06,0.728,2782,NULL,NULL,'2, VI +3m','IC 1613',NULL,'2001ApJ...550..554D',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13392,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13392,24.31,0.06,0.73,2782,NULL,NULL,NULL,'IC 1613',NULL,'2001ApJ...550..554D',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13393,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13393,24.32,0.04,0.731,2782,NULL,NULL,'VI(W), outer, syst. +/- 0.23 mag','IC 1613',NULL,'2014A&A...572A..64M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13394,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13394,24.33,0.06,0.735,2782,NULL,NULL,'3.6 micron, LMC m-M = 18.50 PL','IC 1613',NULL,'2012Ap&SS.341..105N',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13395,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13395,24.33,0.05,0.735,2782,NULL,NULL,'4.5 micron, LMC m-M = 18.50 PL','IC 1613',NULL,'2012Ap&SS.341..105N',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13396,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13396,24.34,0.04,0.738,2782,NULL,NULL,'4.5 micron, SMC m-M = 18.90 PL','IC 1613',NULL,'2012Ap&SS.341..105N',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13397,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13397,24.36,0.05,0.74,2782,74.4,NULL,NULL,'IC 1613',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13398,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13398,24.35,0.09,0.741,2782,NULL,18.45,'LMC ZP','IC 1613',NULL,'2009AcA....59..403M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13399,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13399,24.36,0.02,0.745,2782,NULL,18.52,NULL,'IC 1613',NULL,'2011A&A...531A.134T',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13400,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13400,24.37,0.2,0.748,2782,NULL,NULL,'1, K','IC 1613',NULL,'2000RMxAA..36..151B',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13401,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13401,24.38,0.02,0.752,2782,NULL,NULL,'VI(W), outermost, syst. +/- 0.13 mag','IC 1613',NULL,'2014A&A...572A..64M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13402,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13402,24.38,0.08,0.752,2782,NULL,NULL,NULL,'IC 1613',NULL,'2003AJ....125.1261D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13403,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13403,24.39,0.14,0.755,2782,NULL,NULL,'11, VI(W)','IC 1613',NULL,'1988ApJ...326..691F',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13404,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13404,24.42,NULL,0.766,2782,NULL,NULL,NULL,'IC 1613',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13405,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13405,24.42,0.12,0.766,2782,NULL,NULL,'?, VI(W)','IC 1613',NULL,'2004Ap.....47..389A',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13406,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13406,24.42,0.13,0.766,2782,NULL,NULL,'HST KP Calibrated','IC 1613',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13407,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13407,24.42,0.12,0.766,2782,NULL,NULL,'FM','IC 1613',NULL,'2003AJ....125.1261D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13408,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13408,24.42,0.13,0.766,2782,NULL,NULL,'FO','IC 1613',NULL,'2003AJ....125.1261D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13409,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13409,24.43,0.08,0.769,2782,NULL,NULL,'4, H','IC 1613',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13410,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13410,24.43,0.13,0.769,2782,NULL,NULL,'VI(W), PL 1','IC 1613',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13411,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13411,24.43,0.08,0.769,2782,NULL,NULL,'4, H','IC 1613',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13412,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13412,24.42,0.13,0.77,2782,NULL,NULL,'BVRI','IC 1613',NULL,'1991PASP..103..933M',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13413,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13413,24.44,0.13,0.773,2782,NULL,NULL,'4, I','IC 1613',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13414,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13414,24.44,0.13,0.773,2782,NULL,NULL,'4, I','IC 1613',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13415,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13415,24.45,0.15,0.776,2782,NULL,NULL,'2, VI','IC 1613',NULL,'2001ApJ...550..554D',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13416,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13416,24.46,0.11,0.78,2782,NULL,18.515,'VI, PLC','IC 1613',NULL,'2010ApJ...712.1259B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13417,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13417,24.47,0.12,0.783,2782,NULL,18.515,'VI(W), FO Cepheids','IC 1613',NULL,'2010ApJ...712.1259B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13418,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13418,24.49,NULL,0.791,2782,NULL,NULL,'BVI','IC 1613',NULL,'1999ApJ...522..250S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13419,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13419,24.5,0.12,0.794,2782,NULL,18.54,'Sandage & Tammann PL','IC 1613',NULL,'2006A&A...445..901A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13420,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13420,24.5,0.11,0.794,2782,NULL,18.515,'VI(W), F Cepheids','IC 1613',NULL,'2010ApJ...712.1259B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13421,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13421,24.5,0.12,0.794,2782,NULL,18.44,NULL,'IC 1613',NULL,'2010JAVSO..38..100M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13422,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13422,24.53,0.05,0.805,2782,NULL,NULL,'BVRI','IC 1613',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13423,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13423,24.53,0.13,0.805,2782,NULL,NULL,'4, V','IC 1613',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13424,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13424,24.53,0.13,0.805,2782,NULL,NULL,'4, V','IC 1613',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13425,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13425,24.6,NULL,0.832,2782,NULL,NULL,'Photographic, APPARENT BLUE m-M','IC 1613',NULL,'1988PASP..100..935S',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13426,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13426,24.6,0.05,0.832,2782,NULL,NULL,'BVRI+','IC 1613',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13427,'Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13427,24.67,0.27,0.859,2782,NULL,NULL,'BV(W), PL 1','IC 1613',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13428,'CMD','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13428,24.25,0.03,0.708,2782,NULL,NULL,NULL,'IC 1613',NULL,'2003ApJ...596..253S',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13429,'CMD','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13429,24.28,NULL,0.718,2782,NULL,NULL,NULL,'IC 1613',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13430,'CMD','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13430,24.48,NULL,0.787,2782,NULL,NULL,NULL,'IC 1613',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13431,'Miras','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13431,23.47,0.08,0.75,2782,NULL,NULL,NULL,'IC 1613',NULL,'2015MNRAS.452..910M',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13432,'Red Clump','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13432,24.07,NULL,0.651,2782,NULL,NULL,'V, M RC(V) = +0.73 mag','IC 1613',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13433,'Red Clump','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13433,24.23,0.06,0.701,2782,NULL,NULL,NULL,'IC 1613',NULL,'2001AcA....51..221U',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13434,'Red Clump','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13434,24.27,0.08,0.714,2782,NULL,NULL,NULL,'IC 1613',NULL,'2003AJ....125.1261D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13435,'Red Clump','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13435,24.3,0.09,0.724,2782,NULL,NULL,NULL,'IC 1613',NULL,'2001ApJ...550..554D',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13436,'Red Clump','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13436,24.42,NULL,0.767,2782,NULL,NULL,'I, M RC(I) = -0.50 mag','IC 1613',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13437,'RR Lyrae','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13437,24.1,0.27,0.661,2782,NULL,NULL,'RR','IC 1613',NULL,'1992AJ....104.1072S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13438,'RR Lyrae','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13438,24.11,0.13,0.664,2782,NULL,NULL,NULL,'IC 1613',NULL,'1995AJ....110.2705H',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13439,'RR Lyrae','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13439,24.12,0.11,0.664,2782,NULL,NULL,NULL,'IC 1613',NULL,'1995ApJ...446...39v',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13440,'RR Lyrae','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13440,24.18,0.07,0.685,2782,NULL,NULL,'RR','IC 1613',NULL,'2001AcA....51..221U',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13441,'RR Lyrae','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13441,24.19,0.09,0.689,2782,NULL,NULL,'V','IC 1613',NULL,'2013MNRAS.435.3206D',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13442,'RR Lyrae','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13442,24.21,NULL,0.695,2782,NULL,NULL,NULL,'IC 1613',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13443,'RR Lyrae','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13443,24.27,NULL,0.714,2782,NULL,NULL,'Fe/H = -1.5','IC 1613',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13444,'RR Lyrae','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13444,24.3,0.05,0.724,2782,NULL,NULL,NULL,'IC 1613',NULL,'2003AJ....125.1261D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13445,'RR Lyrae','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13445,24.32,0.16,0.731,2782,NULL,NULL,NULL,'IC 1613',NULL,'2001ApJ...550..554D',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13446,'RR Lyrae','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13446,24.35,NULL,0.741,2782,NULL,NULL,NULL,'IC 1613',NULL,'2008ApJ...679...52T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13447,'RR Lyrae','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13447,24.4,0.12,0.759,2782,NULL,18.44,NULL,'IC 1613',NULL,'2010JAVSO..38..100M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13448,'RR Lyrae','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13448,24.4,0.11,0.759,2782,NULL,NULL,'Z','IC 1613',NULL,'1994ApJ...426..542G',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13449,'RR Lyrae','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13449,24.41,NULL,0.762,2782,NULL,NULL,NULL,'IC 1613',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13450,'RR Lyrae','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13450,24.44,0.1,0.773,2782,NULL,18.515,NULL,'IC 1613',NULL,'2010ApJ...712.1259B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13451,'RR Lyrae','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13451,24.46,NULL,0.78,2782,NULL,NULL,'Fe/H = -1.5','IC 1613',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13452,'RR Lyrae','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13452,24.47,0.12,0.783,2782,NULL,18.515,'Z','IC 1613',NULL,'2010ApJ...712.1259B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13453,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13453,24,0.52,0.631,2782,NULL,NULL,'Ks','IC 1613',NULL,'2009JASS...26..421J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13454,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13454,24.12,0.25,0.667,2782,NULL,NULL,'J','IC 1613',NULL,'2009JASS...26..421J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13455,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13455,24.2,0.2,0.692,2782,NULL,NULL,'I','IC 1613',NULL,'1988AJ.....96.1248F',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13456,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13456,24.2,NULL,0.692,2782,NULL,NULL,'I','IC 1613',NULL,'1988ASPC....4...75C',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13457,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13457,24.2,0.44,0.692,2782,NULL,NULL,'H','IC 1613',NULL,'2009JASS...26..421J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13458,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13458,24.2,0.07,0.692,2782,NULL,NULL,NULL,'IC 1613',NULL,'2001AcA....51..221U',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13459,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13459,24.24,0.08,0.705,2782,NULL,NULL,'K','IC 1613',NULL,'2011AJ....141..194G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13460,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13460,24.26,0.16,0.711,2782,NULL,NULL,'HST KP Calibrated','IC 1613',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13461,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13461,24.27,0.1,0.714,2782,NULL,NULL,'I','IC 1613',NULL,'1993ApJ...417..553L',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13462,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13462,24.28,0.05,0.718,2782,NULL,NULL,NULL,'IC 1613',NULL,'2003AJ....125.1261D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13463,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13463,24.29,0.12,0.721,2782,NULL,NULL,NULL,'IC 1613',NULL,'1999AJ....118.1657C',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13464,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13464,24.31,0.06,0.728,2782,NULL,NULL,NULL,'IC 1613',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13465,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13465,24.32,0.09,0.731,2782,NULL,NULL,NULL,'IC 1613',NULL,'2001ApJ...550..554D',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13466,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13466,24.36,0.05,0.74,2782,74.4,NULL,NULL,'IC 1613',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13467,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13467,24.36,NULL,0.745,2782,NULL,NULL,'theory','IC 1613',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13468,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13468,24.36,0.12,0.745,2782,NULL,NULL,NULL,'IC 1613',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13469,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13469,24.36,0.08,0.745,2782,NULL,NULL,'J','IC 1613',NULL,'2011AJ....141..194G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13470,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13470,24.37,0.05,0.748,2782,NULL,NULL,'I','IC 1613',NULL,'2007ApJ...661..815R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13471,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13471,24.38,0.07,0.752,2782,NULL,NULL,'I','IC 1613',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13472,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13472,24.42,NULL,0.766,2782,NULL,NULL,'I, M TRGB(I) = -4.05 mag','IC 1613',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13473,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13473,24.43,NULL,0.769,2782,NULL,NULL,'DA90','IC 1613',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13474,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13474,24.44,0.09,0.773,2782,NULL,18.515,'Rizzi et al. 2007 TRGB','IC 1613',NULL,'2013MNRAS.432.3047B',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13475,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13475,24.44,NULL,0.773,2782,NULL,NULL,NULL,'IC 1613',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13476,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13476,24.45,NULL,0.776,2782,NULL,NULL,'Yale','IC 1613',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13477,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13477,24.47,NULL,0.783,2782,NULL,NULL,'K97','IC 1613',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13478,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13478,24.49,0.09,0.791,2782,NULL,18.515,'Cassini & Salaris 2013 TRGB','IC 1613',NULL,'2013MNRAS.432.3047B',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13479,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13479,24.53,0.1,0.805,2782,NULL,NULL,NULL,'IC 1613',NULL,'2002A&A...394...33T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13480,'Type II Cepheids','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13480,24.52,0.16,0.802,2782,NULL,18.45,'LMC ZP','IC 1613',NULL,'2009AcA....59..403M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13481,'Statistical','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13481,24.3,0.05,0.724,2782,NULL,NULL,NULL,'IC 1613',NULL,'2000glg..book.....V',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13482,'HII region diameter','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13482,24.37,0.15,0.748,2782,NULL,NULL,'Method 1','IC 1613',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13483,'HII region diameter','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13483,24.39,0.13,0.755,2782,NULL,NULL,'Method 2','IC 1613',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13484,'Magnitude','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13484,24.15,0.11,0.676,2782,NULL,NULL,NULL,'IC 1613',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13485,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13485,24.23,0.4,0.7,2782,75,NULL,'B','IC 1613',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13486,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13486,26.04,NULL,1.61,2782,NULL,NULL,'LEDA [April 2006]','IC 1613',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13487,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13487,35.7,0.68,138,2783,70,NULL,NULL,'2MASX J01045071-1513177',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.08',0.39,NULL,NULL,NULL,NULL,NULL,1,16.2112917,-15.22153,0.056,NULL,35429976878,553593388,8649896,16.08),(13488,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 1995at','R',13488,41.47,NULL,1190,2784,65,NULL,'SALT','[PDG95a] J010450.96+043353.4',0.655,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,'Sa',NULL,NULL,NULL,NULL,1,16.212333,4.56483,0.037,NULL,66701941634,1042217838,16284653,NULL),(13489,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 1995at',NULL,13489,41.59,0.5,1260,2784,74.2,NULL,'SALT 2','[PDG95a] J010450.96+043353.4',0.655,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13490,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 1995at',NULL,13490,42.33,0.5,1770,2784,70,NULL,'SALT','[PDG95a] J010450.96+043353.4',0.655,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13491,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 1995at',NULL,13491,42.46,0.48,1870,2784,65,NULL,'SALT','[PDG95a] J010450.96+043353.4',0.655,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13492,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13492,34.22,0.1,70,2785,NULL,NULL,NULL,'SDSS J010451.89-003853.0',NULL,'2009ApJS..182..474S',2009,1,0.59,NULL,'G',0.000039,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,16.21625,-0.64806,0.107,NULL,34519255862,539363372,8427552,16.7),(13493,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 20070','RN',13493,39.22,0.3,589,2786,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 20070',0.185152,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13494,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 20070','RN',13494,40.59,0.41,1110,2786,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 20070',0.185152,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13495,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 21542','RN',13495,38.35,0.26,428,2787,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 21542',0.094759,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13496,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 21542','RN',13496,38.62,0.27,484,2787,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 21542',0.094759,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13497,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13497,37.71,0.46,348,2788,70,NULL,NULL,'2MASXi J0104590-000425',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000078,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,16.246125,-0.07383,0.107,NULL,34519200744,539362511,8427539,17.9),(13498,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 19059',NULL,13498,40.62,0.08,1330,2789,70,NULL,'SN photometric redshift distance, z photo =0.378 +/- 0.017','SDSS-II SN 19059',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,16.249167,0.42564,0.118,NULL,66676948763,1041827324,16278551,NULL),(13499,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13499,35.18,0.45,108,2790,70,NULL,NULL,'2MASX J01045986-4604332',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000097,NULL,'15.47',0.7,'SB(s)0-:','Group member',NULL,NULL,NULL,1,16.2495,-46.07583,NULL,NULL,38142944007,595983500,9312242,15.47),(13500,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 09132',NULL,13500,40.64,0.21,1340,2791,70,NULL,'SN photometric redshift distance, z photo =0.384 +/- 0.050','SDSS-II SN 09132',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,16.255167,0.54,0.118,NULL,66676921930,1041826905,16278545,NULL),(13501,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13501,38.88,0.46,596,2792,70,NULL,NULL,'2MASX J01050319+1341360',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000083,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,16.26325,13.69344,0.069,NULL,67584495499,1056007742,16500120,18.3),(13502,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13502,30.27,0.2,11.3,2793,74.4,NULL,NULL,'MCG -01-03-085',NULL,'2013AJ....146...86T',2013,1,4.2,NULL,'G',0.000001,NULL,'13.24',3.5,'SAB(rs)d',NULL,NULL,NULL,NULL,1,16.270333,-6.21239,0.244,NULL,34532749404,539574209,8430847,13.24),(13503,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13503,30.28,0.36,11.4,2793,NULL,NULL,NULL,'MCG -01-03-085',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13504,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13504,30.28,0.4,11.4,2793,73,NULL,'opt','MCG -01-03-085',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13505,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13505,30.32,0.43,11.6,2793,75,NULL,'3.6 micron, color corrected','MCG -01-03-085',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13506,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13506,30.34,0.43,11.7,2793,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-03-085',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13507,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13507,30.7,0.4,13.8,2793,75,NULL,'B','MCG -01-03-085',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13508,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13508,37.23,0.46,279,2794,70,NULL,NULL,'2MASX J01050839-0925045',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000082,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,16.2849166667,-9.41789,0.196,NULL,35262313201,550973643,8608963,16.8),(13509,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13509,38,0.46,398,2795,70,NULL,NULL,'2MASX J01050839+1333469',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000144,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,16.2849166667,13.56306,0.069,NULL,67584632317,1056009879,16500154,17.3),(13510,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 14333','R',13510,40.83,0.21,1150,2796,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14333',0.27009,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,16.28525,-0.01269,0.107,NULL,34519197354,539362458,8427538,NULL),(13511,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 14333','R',13511,41.06,0.16,1290,2796,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14333',0.27009,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13512,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13512,32.56,0.43,32.5,2797,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-03-088',NULL,'2014MNRAS.444..527S',2014,1,1.3,'The APM image includes a superposed star.','G',0.000028,NULL,'14.5',0.3,'SBm? sp',NULL,NULL,NULL,NULL,1,16.286,-6.27931,0.24,NULL,34532742055,539574094,8430845,14.5),(13513,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13513,36.16,0.61,171,2798,70,NULL,NULL,'2MASX J01051142-2018018',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'16.14',0.58,'S',NULL,NULL,NULL,NULL,1,16.29775,-20.30044,0,NULL,35389616977,552962765,8640043,16.14),(13514,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 09957','RN',13514,43.16,0.2,2580,2799,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 09957',0.662484,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13515,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13515,37.7,0.46,346,2800,70,NULL,NULL,'2MASX J01051459-0905395',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000078,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,16.3107083,-9.09433,0.192,NULL,35261981599,550968462,8608882,17.9),(13516,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13516,36.65,0.5,213,2801,70,NULL,NULL,'LCRS B010257.5-391343',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.03',0.5,'E',NULL,NULL,NULL,NULL,1,16.318,-38.96089,NULL,NULL,38337221736,599019089,9359673,16.03),(13517,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13517,33.99,NULL,62.8,2802,NULL,NULL,'B','ESO 243- G 025',NULL,'2005Ap&SS.298..577R',2005,1,0.87,NULL,'G',0.000033,NULL,'15.09',0.51,'Sb',NULL,NULL,NULL,NULL,1,16.320333,-42.9145,NULL,NULL,38160763014,596261922,9316592,15.09),(13518,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13518,33.99,NULL,62.8,2802,NULL,NULL,'I','ESO 243- G 025',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13519,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13519,35.12,0.49,106,2802,NULL,NULL,NULL,'ESO 243- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13520,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13520,35.15,0.48,107,2802,NULL,NULL,'Malmquist cor.','ESO 243- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13521,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13521,35.16,0.2,108,2802,74.4,NULL,NULL,'ESO 243- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13522,'IRAS','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13522,34.51,0.8,79.8,2803,75,NULL,'W91PP, r','UGC 00669',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'15.40',0.4,'Scd:',NULL,NULL,NULL,NULL,1,16.329083,31.68217,0.161,NULL,67276511711,1051195495,16424929,15.4),(13523,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13523,33.01,0.43,40.1,2803,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00669',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13524,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13524,33.34,0.43,46.6,2803,75,NULL,'3.6 micron, color corrected','UGC 00669',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13525,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13525,33.65,0.2,53.7,2803,74.4,NULL,NULL,'UGC 00669',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13526,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13526,33.66,0.38,54,2803,75,NULL,'W91PP, r, raw','UGC 00669',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13527,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13527,33.67,0.49,54.1,2803,75,NULL,'IR','UGC 00669',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13528,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13528,33.67,0.38,54.1,2803,75,NULL,'W91PP, r, inv','UGC 00669',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13529,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13529,33.95,0.38,61.5,2803,75,NULL,'W91PP, r, cor','UGC 00669',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13530,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13530,34.22,0.12,70,2803,NULL,NULL,NULL,'UGC 00669',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13531,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13531,35.15,0.61,107,2804,70,NULL,NULL,'MCG -02-03-071',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15',0.35,NULL,NULL,NULL,NULL,NULL,1,16.328917,-11.35819,0.07,NULL,35255584991,550868515,8607320,15),(13532,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13532,36.46,0.46,196,2805,70,NULL,NULL,'2MASX J01051987+1533297',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000079,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,16.332625,15.55819,0.101,NULL,67645355770,1056958683,16514979,16.8),(13533,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 19428','RN',13533,40.16,0.21,986,2806,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19428',0.0903,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13534,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 19428','RN',13534,40.42,0.13,1110,2806,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19428',0.0903,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13535,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13535,35.63,0.46,133,2807,70,NULL,NULL,'2MASX J01052241-0856436',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000087,NULL,'15.6g',0.42,'E0',NULL,NULL,NULL,NULL,1,16.3432917,-8.94533,0.213,NULL,35262035824,550969309,8608895,15.6),(13536,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13536,37.68,0.53,344,2808,NULL,NULL,'Malmquist cor.','2MASX J01052629-0048063',NULL,'2009ApJS..182..474S',2009,1,0.48,NULL,'G',0.000027,NULL,'17.5g',0.11,'NLAGN',NULL,NULL,NULL,'Sy 2',1,16.359667,-0.80183,0.093,NULL,34553649755,539900777,8435949,17.5),(13537,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13537,37.8,0.5,363,2808,NULL,NULL,NULL,'2MASX J01052629-0048063',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13538,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13538,37.84,0.2,370,2808,74.4,NULL,NULL,'2MASX J01052629-0048063',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13539,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 12788','RN',13539,37.55,0.1,303,2809,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 12788',0.06751,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13540,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 19342','RN',13540,40.24,0.18,920,2810,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 19342',0.212211,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13541,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 19342','RN',13541,40.28,0.24,937,2810,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19342',0.212211,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13542,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 01153','RN',13542,40.11,0.22,784,2811,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 01153',0.339869,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13543,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 04355','RN',13543,43.64,0.26,3490,2812,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 04355',0.527715,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13544,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13544,37.07,0.16,260,2813,70,NULL,NULL,'2MASX J01053400-0045052',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000097,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,16.3917916667,-0.7515,0.093,NULL,34553631072,539900485,8435945,16.4),(13545,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13545,33.79,0.23,57.3,2814,74.4,NULL,NULL,'CGCG 501-077',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000083,NULL,'15.7',0.7,'E',NULL,NULL,NULL,NULL,1,16.3925,32.42975,0.165,NULL,67275590525,1051181101,16424704,15.7),(13546,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13546,36.3,0.33,182,2815,70,NULL,NULL,'2MASX J01053482-0836126',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000092,NULL,'15.9g',0.4,'AGN',NULL,NULL,NULL,NULL,1,16.395,-8.60353,0.23,NULL,35259963891,550936935,8608389,15.9),(13547,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13547,36.36,0.75,187,2815,70,NULL,NULL,'2MASX J01053482-0836126',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13548,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13548,34.59,0.4,82.9,2816,NULL,NULL,'mean','ESO 243- G 026',NULL,'2007A&A...465...71T',2007,1,1.44,NULL,'G',0.000027,NULL,'15.43',0.22,'SBbc? sp','Group member',NULL,NULL,NULL,1,16.4082083,-47.07172,NULL,NULL,38141478604,595960603,9311884,15.43),(13549,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13549,34.94,0.49,97.2,2816,75,NULL,'IR','ESO 243- G 026',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13550,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13550,34.99,0.45,99.4,2816,NULL,NULL,'K','ESO 243- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13551,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13551,34.99,0.47,99.5,2816,NULL,NULL,'H','ESO 243- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13552,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13552,35.19,0.43,109,2816,NULL,NULL,'Malmquist cor.','ESO 243- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13553,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13553,35.37,0.4,118,2816,NULL,NULL,NULL,'ESO 243- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13554,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13554,35.41,0.2,121,2816,74.4,NULL,NULL,'ESO 243- G 026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13555,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 13909','R',13555,41.12,0.22,1290,2817,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J010540.86+001843.3',0.29329,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,'PHOT','21.5g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,16.42025,0.31203,0.092,NULL,66677085852,1041829466,16278585,21.5),(13556,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 13909','R',13556,41.27,0.14,1390,2817,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J010540.86+001843.3',0.29329,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13557,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 13909',NULL,13557,41.12,0.11,1670,2817,70,NULL,'SALT 2','SDSS J010540.86+001843.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13558,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 13909',NULL,13558,41.15,0.11,1700,2817,70,NULL,'SALT 2, Malmquist cor.','SDSS J010540.86+001843.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13559,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13559,36.81,0.83,230,2818,70,NULL,NULL,'2MASX J01054135-1332503',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'16.74',0.27,NULL,NULL,NULL,NULL,NULL,1,16.4222917,-13.54733,0.025,NULL,35377158724,552768105,8637001,16.74),(13560,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13560,37.07,0.16,260,2819,70,NULL,NULL,'2MASX J01054194-0058321',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000078,NULL,'16.3g',0.4,NULL,NULL,NULL,NULL,NULL,1,16.4247083,-0.97558,0.168,NULL,34553722656,539901916,8435967,16.3),(13561,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13561,36.11,0.2,167,2820,74.4,NULL,NULL,'CGCG 435-038',NULL,'2013AJ....146...86T',2013,1,0.66,NULL,'G',0.000075,NULL,'15.6g',0.4,'NLAGN',NULL,NULL,NULL,NULL,1,16.4253333333,14.73447,0.089,NULL,67640076829,1056876200,16513690,15.6),(13562,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 13601','RN',13562,40.56,0.27,1040,2821,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13601',0.243688,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13563,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 13601','RN',13563,40.82,0.27,1170,2821,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13601',0.243688,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13564,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13564,37.07,0.16,260,2822,70,NULL,NULL,'2MASX J01054573-0045201',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000147,NULL,'16.58',0.41,'E/S0;BrClG',NULL,NULL,NULL,NULL,1,16.440583,-0.75567,0.093,NULL,34553641468,539900647,8435947,16.58),(13565,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 18890','R',13565,37.32,0.06,273,2823,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007mm','2MASX J01054640-0045341',0.06643,'2014arXiv1401.3317S',2014,1,0.18,NULL,'G',0.00016,NULL,'18.85',0.17,NULL,NULL,NULL,NULL,NULL,1,16.443375,-0.75947,0.093,NULL,34553641343,539900645,8435947,18.85),(13566,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2007mm',NULL,13566,37.33,0.13,292,2823,70,NULL,'Hubble residual 0.13 for z0.06643','2MASX J01054640-0045341',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13567,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 18890','R',13567,37.64,0.2,316,2823,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007mm','2MASX J01054640-0045341',0.06643,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13568,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 02709','RN',13568,41.27,0.17,1420,2824,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 02709',0.263634,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13569,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 02709','RN',13569,41.71,0.24,1740,2824,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02709',0.263634,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13570,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13570,36.88,0.46,237,2825,70,NULL,NULL,'2MASX J01054810+0003338',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000082,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,16.450375,0.05944,0.105,NULL,66677000155,1041828127,16278564,17.4),(13571,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13571,35.39,0.67,119,2826,70,NULL,NULL,'FAIRALL 0678',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.00015,NULL,'15.19',0.68,'(R\')SB(rs)ab',NULL,NULL,NULL,NULL,1,16.4517917,-48.39839,NULL,NULL,38149952736,596093011,9313953,15.19),(13572,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 20663','R',13572,40.99,0.33,1210,2827,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20663',0.299569,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,16.45225,0.82061,0.029,NULL,66694502494,1042101601,16282837,NULL),(13573,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 20663',NULL,13573,40.43,0.18,1220,2827,70,NULL,'SN photometric redshift distance, z photo =0.341 +/- 0.036','SDSS-II SN 20663',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13574,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 20663','R',13574,41.02,0.21,1230,2827,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20663',0.299569,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13575,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 20663',NULL,13575,40.78,0.16,1430,2827,70,NULL,'SALT 2','SDSS-II SN 20663',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13576,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 20663',NULL,13576,40.81,0.16,1450,2827,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20663',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13577,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 02623','RN',13577,39.94,0.34,914,2828,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02623',0.064894,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13578,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13578,37.15,0.46,269,2829,70,NULL,NULL,'2MASX J01054895-0108571',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000093,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,16.4537917,-1.14931,0.241,NULL,34553495245,539898363,8435911,16.7),(13579,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 12983','R',13579,40.71,0.29,1090,2830,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006gl','SN 2006gl',0.26531,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,16.4587917,0.14481,0.105,NULL,66677076784,1041829324,16278583,NULL),(13580,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 12983','R',13580,40.98,0.24,1240,2830,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006gl','SN 2006gl',0.26531,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13581,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 20591',NULL,13581,38.79,1.87,573,2831,70,NULL,'SN photometric redshift distance, z photo =0.144 +/- 0.243','SDSS-II SN 20591',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,16.4606666667,0.11383,0.105,NULL,66677079618,1041829369,16278583,NULL),(13582,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 13458','R',13582,40.49,0.28,952,2832,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 13458',0.318989,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,16.463333,-0.25047,0.113,NULL,34519369803,539365153,8427580,NULL),(13583,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 13458','R',13583,40.55,0.36,975,2832,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 13458',0.318989,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13584,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13584,36.3,0.33,182,2833,70,NULL,NULL,'2MASXi J0105529-083657',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000069,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,16.4707083,-8.61608,0.24,NULL,35260186535,550940414,8608443,17.4),(13585,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13585,37.99,0.46,396,2834,70,NULL,NULL,'2MASX J01055332+1408263',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000075,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,16.472167,14.14072,0.081,NULL,67640275317,1056879301,16513739,17.5),(13586,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 04138','RN',13586,42.55,0.21,2260,2835,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04138',0.429125,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13587,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 04138','RN',13587,42.98,0.18,2760,2835,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 04138',0.429125,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13588,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13588,33.23,0.23,44.3,2836,74.4,NULL,NULL,'IC 1618',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000067,NULL,'15.24',0.5,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,16.48325,32.41217,0.165,NULL,67273759973,1051152499,16424257,15.24),(13589,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 13193',NULL,13589,37.71,1.02,349,2837,70,NULL,'SN photometric redshift distance, z photo =0.085 +/- 0.055','SDSS-II SN 13193',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.2g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,16.499875,0.90872,0.029,NULL,66694670784,1042104231,16282878,22.2),(13590,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 13193','R',13590,40.46,0.32,987,2837,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13193',0.252828,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13591,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 13193','R',13591,40.47,0.32,993,2837,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13193',0.252828,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13592,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13592,35.02,0.48,101,2838,70,NULL,NULL,'MCPS J01.100770-73.99763',NULL,'2014MNRAS.445.2677S',2014,1,0.69,NULL,'G',0.000063,NULL,'15.4b',0.46,'E',NULL,NULL,NULL,NULL,1,16.5110833333,-73.99789,0.097,NULL,35633022495,556765976,8699468,15.4),(13593,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 14820',NULL,13593,40.7,0.8,1380,2839,70,NULL,'SN photometric redshift distance, z photo =0.398 +/- 0.262','SDSS-II SN 14820',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','22.0g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,16.531,-0.37333,0.113,NULL,34552774910,539887107,8435736,22),(13594,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 14820','R',13594,42.89,0.6,2460,2839,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 14820',0.537555,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13595,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13595,36.52,0.46,201,2840,70,NULL,NULL,'2MASX J01060793-0108492',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00007,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,16.533125,-1.14697,0.168,NULL,34553367683,539896370,8435880,17.4),(13596,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13596,37.86,0.65,373,2841,70,NULL,NULL,'2MASX J01060823-1353343',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'16.73',0.41,NULL,NULL,NULL,NULL,NULL,1,16.53425,-13.89272,0.038,NULL,35422671729,553479245,8648113,16.73),(13597,'IRAS','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13597,34.65,0.8,85.1,2842,75,NULL,'HMCL, I','UGC 00673',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.00002,NULL,'15.70',0.5,'SAc?',NULL,NULL,NULL,NULL,1,16.5401666667,31.40578,0.197,NULL,67276049177,1051188268,16424816,15.7),(13598,'IRAS','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13598,34.65,0.8,85.2,2842,75,NULL,'CF, r','UGC 00673',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13599,'IRAS','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13599,34.65,0.8,85.2,2842,75,NULL,'W91PP, r','UGC 00673',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13600,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13600,34.58,0.4,82.5,2842,NULL,NULL,'Malmquist cor.','UGC 00673',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13601,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13601,34.59,0.4,82.9,2842,75,NULL,'HMCL, I, raw','UGC 00673',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13602,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13602,34.63,0.38,84.3,2842,75,NULL,'W91PP, r, raw','UGC 00673',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13603,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13603,34.67,0.38,85.9,2842,75,NULL,'W91PP, r, inv','UGC 00673',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13604,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13604,34.71,0.4,87.4,2842,75,NULL,'HMCL, I, inv','UGC 00673',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13605,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13605,34.74,0.4,88.9,2842,75,NULL,'HMCL, I, cor','UGC 00673',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13606,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13606,34.76,0.2,89.5,2842,74.4,NULL,NULL,'UGC 00673',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13607,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13607,34.76,0.38,89.7,2842,75,NULL,'W91PP, r, cor','UGC 00673',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13608,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13608,34.79,0.38,90.9,2842,75,NULL,'CF, r, raw','UGC 00673',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13609,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13609,34.81,0.36,91.7,2842,NULL,NULL,NULL,'UGC 00673',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13610,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13610,34.86,0.38,93.7,2842,75,NULL,'CF, r, inv','UGC 00673',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13611,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13611,34.89,0.43,95.2,2842,75,NULL,'3.6 micron, color corrected','UGC 00673',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13612,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13612,35,0.38,99.8,2842,75,NULL,'CF, r, cor','UGC 00673',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13613,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13613,35.1,0.43,105,2842,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00673',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13614,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13614,36.23,0.37,177,2843,NULL,NULL,'Malmquist cor.','UGC 00676',NULL,'2009ApJS..182..474S',2009,1,0.72,NULL,'G',0.000075,NULL,'15.5g',0.43,'S',NULL,NULL,NULL,NULL,1,16.541875,1.23311,0.029,NULL,66693979980,1042093437,16282709,15.5),(13615,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13615,36.41,0.34,192,2843,NULL,NULL,NULL,'UGC 00676',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13616,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13616,36.7,0.2,219,2843,74.4,NULL,NULL,'UGC 00676',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13617,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 18297','R',13617,39.39,0.07,702,2844,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2007ky','2MASX J01061153-0037012',0.073771,'2014arXiv1401.3317S',2014,1,0.25,NULL,'G',0.000063,NULL,'16.2g',0.12,'Sbc',NULL,NULL,NULL,NULL,1,16.5482083,-0.61697,0.13,NULL,34552764521,539886945,8435733,16.2),(13618,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 18297','R',13618,39.65,0.19,792,2844,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2007ky','2MASX J01061153-0037012',0.073771,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13619,'SNII optical','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2007ky',NULL,13619,37.32,0.09,271,2844,NULL,NULL,'SCM 55 SNII','2MASX J01061153-0037012',0.073771,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13620,'SNII optical','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2007ky',NULL,13620,37.64,0.11,314,2844,NULL,NULL,'SCM 15 SDSS SNII','2MASX J01061153-0037012',0.073771,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13621,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13621,34.04,0.49,64.4,2845,75,NULL,'IR','CGCG 480-041',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.00002,NULL,'15.59',0.2,'S?',NULL,NULL,NULL,NULL,1,16.5495,25.55158,0.241,NULL,67292689364,1051448271,16428879,15.59),(13622,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13622,37.07,0.16,260,2846,70,NULL,NULL,'2MASX J01061206-0047062',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000081,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,16.550167,-0.78494,0.093,NULL,34553661859,539900966,8435952,17.3),(13623,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13623,35.28,0.47,114,2847,NULL,NULL,'H','NGC 0378',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000033,NULL,'13.72',1.1,'SB(r)c:',NULL,NULL,NULL,NULL,1,16.550875,-30.17814,NULL,NULL,34740360751,542818136,8481533,13.72),(13624,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13624,35.36,0.45,118,2847,NULL,NULL,'K','NGC 0378',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13625,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13625,35.39,0.46,120,2847,NULL,NULL,'J','NGC 0378',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13626,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13626,35.51,0.4,126,2847,NULL,NULL,'mean','NGC 0378',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13627,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13627,37.13,0.46,267,2848,70,NULL,NULL,'2MASX J01061427-0930106',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000072,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,16.5595417,-9.50289,0.177,NULL,35262120541,550970633,8608916,17.7),(13628,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13628,35.12,0.45,105,2849,NULL,NULL,NULL,'ESO 243- G 027',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.00031,NULL,'15.0',0.7,'Sa:','Group member',NULL,NULL,NULL,1,16.561417,-46.50114,NULL,NULL,38142077454,595969960,9312030,15),(13629,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13629,35.12,0.45,106,2849,NULL,NULL,'Malmquist cor.','ESO 243- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13630,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13630,35.16,0.2,108,2849,74.4,NULL,NULL,'ESO 243- G 027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13631,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13631,36.45,0.6,195,2850,70,NULL,NULL,'2MASX J01061576-1803547',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'16.52',0.32,NULL,NULL,NULL,NULL,NULL,1,16.56575,-18.06522,0.01,NULL,35388988710,552952948,8639889,16.52),(13632,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13632,35.54,0.46,128,2851,70,NULL,NULL,'NGC 0363',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.000097,NULL,'15.35',0.25,'S0: pec?',NULL,NULL,NULL,NULL,1,16.5657917,-16.54275,0.009,NULL,35430704083,553604751,8650074,15.35),(13633,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 20907','RN',13633,41.54,0.28,1610,2852,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 20907',0.259426,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13634,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 20907','RN',13634,42.35,0.31,2340,2852,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20907',0.259426,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13635,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 12020','RN',13635,39.53,0.55,678,2853,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 12020',0.189531,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13636,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 12020','RN',13636,41.08,5.49,1380,2853,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 12020',0.189531,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13637,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13637,38.14,0.46,424,2854,70,NULL,NULL,'2MASX J01062140+1430497',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000094,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,16.589167,14.51389,0.081,NULL,67640170222,1056877659,16513713,17.5),(13638,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13638,37.75,0.46,355,2855,70,NULL,NULL,'SDSS J010624.69+003300.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,16.602875,0.55017,0.115,NULL,66693830304,1042091098,16282673,18.1),(13639,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 01425','RN',13639,39.6,1.13,761,2856,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 01425',0.094645,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13640,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13640,35.73,0.63,140,2857,70,NULL,NULL,'2MASX J01062986-1322243',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.83',0.17,NULL,NULL,NULL,NULL,NULL,1,16.6245,-13.37344,0.023,NULL,35422472047,553476125,8648064,16.83),(13641,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13641,37.13,0.92,266,2858,70,NULL,NULL,'2MASX J01063216-2037429',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,16.634083,-20.62872,0.049,NULL,35208258807,550129043,8595766,14.9),(13642,'Horizontal Branch','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13642,24.01,0.07,0.621,2859,NULL,NULL,NULL,'ANDROMEDA X',NULL,'2011ApJ...729...23B',2011,1,NULL,NULL,'G',NULL,NULL,'16.1V',NULL,'dSph',NULL,NULL,NULL,NULL,1,16.6404166667,44.80439,0.521,1,67688701915,1057635967,16525561,16.1),(13643,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13643,24.13,0.13,0.67,2859,NULL,NULL,NULL,'ANDROMEDA X',NULL,'2012ApJ...758...11C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13644,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13644,24.23,0.1,0.701,2859,NULL,NULL,NULL,'ANDROMEDA X',NULL,'2007ApJ...659L..21Z',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13645,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 09133','R',13645,40.64,0.3,1060,2860,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J010634.20+002738.0',0.2672,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',0.0001,NULL,'20.4g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,16.6425,0.46056,0.115,NULL,66693887136,1042091986,16282687,20.4),(13646,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 09133','R',13646,40.74,0.28,1110,2860,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J010634.20+002738.0',0.2672,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13647,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 09133',NULL,13647,40.48,0.21,1250,2860,70,NULL,'SALT 2','SDSS J010634.20+002738.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13648,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 09133',NULL,13648,40.5,0.21,1260,2860,70,NULL,'SALT 2, Malmquist cor.','SDSS J010634.20+002738.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13649,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 02331','RN',13649,40.66,0.24,1070,2861,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02331',0.262783,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13650,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 02331','RN',13650,40.92,0.21,1210,2861,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02331',0.262783,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13651,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 02331','N',13651,40.45,0.16,1230,2861,70,NULL,'SALT 2','SDSS-II SN 02331',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13652,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 02331','N',13652,40.48,0.16,1250,2861,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 02331',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13653,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 01402','RN',13653,41.99,0.18,2000,2862,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01402',0.249296,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13654,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 01402','RN',13654,42.01,0.09,2020,2862,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01402',0.249296,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13655,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13655,37.21,0.46,277,2863,70,NULL,NULL,'SDSS J010634.56+155751.0',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000089,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,16.644,15.96417,0.109,NULL,67645672950,1056963639,16515056,17.3),(13656,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13656,36.31,0.7,182,2864,70,NULL,NULL,'2MASX J01063495-1717355',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'14.8R',0.3,NULL,NULL,NULL,NULL,NULL,1,16.645625,-17.29325,0.023,NULL,35419702891,553432857,8647388,14.8),(13657,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 06491','R',13657,39.67,0.2,775,2865,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06491',0.110215,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',0.0002,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,16.64825,0.54075,0.115,NULL,66693834863,1042091169,16282674,NULL),(13658,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 06491','R',13658,39.73,0.12,796,2865,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06491',0.110215,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13659,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 14267','RN',13659,41.16,0.25,1340,2866,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 14267',0.270394,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13660,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 14267','RN',13660,41.27,0.34,1410,2866,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 14267',0.270394,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13661,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13661,34.72,0.2,87.9,2867,74.4,NULL,NULL,'AGC 111669',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',NULL,NULL,'15.8',0.2,NULL,'Group member',NULL,NULL,NULL,1,16.681667,2.82194,0.045,NULL,66694909713,1042107964,16282936,15.8),(13662,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13662,34.9,0.77,95.6,2867,NULL,NULL,'Malmquist cor.','AGC 111669',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13663,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13663,35.11,0.7,105,2867,NULL,NULL,NULL,'AGC 111669',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13664,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13664,37.71,0.46,348,2868,70,NULL,NULL,'SDSS J010645.11+004608.4',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',NULL,NULL,'18.6g',0.09,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,16.688,0.76903,0.021,NULL,66694600970,1042103140,16282861,18.6),(13665,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13665,38.04,0.46,405,2869,70,NULL,NULL,'SDSS J010647.26+002202.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000074,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,16.696917,0.36739,0.115,NULL,66693845190,1042091331,16282677,18),(13666,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13666,37.08,0.55,261,2870,70,NULL,NULL,'2MASX J01064783-2037459',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.28',0.4,'E',NULL,NULL,NULL,NULL,1,16.699417,-20.62939,0.049,NULL,35208258495,550129038,8595766,16.28),(13667,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 20687','R',13667,39.68,0.23,723,2871,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ri','SN 2007ri',0.191536,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,16.718125,1.15406,0.021,NULL,66694147321,1042096051,16282750,NULL),(13668,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 20687','R',13668,39.86,0.16,786,2871,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ri','SN 2007ri',0.191536,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13669,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13669,36.98,0.6,249,2872,70,NULL,NULL,'2MASX J01065314-5147458',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'16.21',0.45,'S0',NULL,NULL,NULL,NULL,1,16.721333,-51.796,NULL,NULL,36007673306,562619895,8790935,16.21),(13670,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13670,37.37,0.46,298,2873,70,NULL,NULL,'2MASX J01065349-0837098',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000089,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,16.723,-8.61947,0.24,NULL,35260066208,550938534,8608414,16.6),(13671,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13671,35.4,0.64,120,2874,70,NULL,NULL,'2MASX J01065454-1927404',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,16.72725,-19.46125,0.026,NULL,35390554832,552977419,8640272,14.8),(13672,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 04072','RN',13672,42.69,0.28,2510,2875,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04072',0.37826,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13673,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 04072','RN',13673,42.95,0.42,2820,2875,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04072',0.37826,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13674,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13674,33.99,0.25,62.8,2876,74.4,NULL,NULL,'NGC 0373',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000067,NULL,'16.6',NULL,'E',NULL,NULL,NULL,NULL,1,16.7425417,32.30847,0.173,NULL,67273990454,1051156100,16424314,16.6),(13675,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 03786','RN',13675,38.77,0.22,532,2877,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 03786',0.066308,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13676,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 03786','RN',13676,41.1,0.33,1560,2877,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 03786',0.066308,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13677,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13677,38.91,0.46,604,2878,70,NULL,NULL,'2MASX J01065889+0025561',NULL,'2015arXiv151105856S',2015,1,0.06,NULL,'G',0.000084,NULL,'18.7g',0.04,NULL,NULL,NULL,NULL,NULL,1,16.7455833333,0.43233,0.115,NULL,66693870512,1042091726,16282683,18.7),(13678,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13678,35.21,0.56,110,2879,70,NULL,NULL,'2MASX J01065908-1529554',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15',0.2,'S0','Group member',NULL,NULL,NULL,1,16.7462917,-15.49867,0.036,NULL,35432869443,553638585,8650602,15),(13679,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13679,37.47,0.19,312,2880,70,NULL,NULL,'2MASX J01065971+1410314',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000072,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,16.748833,14.17539,0.085,NULL,67640112439,1056876756,16513699,17.5),(13680,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13680,36.91,0.46,241,2881,70,NULL,NULL,'2MASX J01070142+0054351',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000112,NULL,'15.9g',0.4,'E0',NULL,NULL,NULL,NULL,1,16.7557916667,0.90983,0.029,NULL,66694075298,1042094926,16282733,15.9),(13681,'IRAS','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13681,34.1,0.8,66.2,2882,75,NULL,'HMCL, I','UGC 00679',NULL,'1997ApJS..109..333W',1997,1,1,'MCG incorrectly identifies this with NGC 0375.','G',0.000023,NULL,'16.61',0.3,'Sdm?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,16.764917,32.38953,0.173,NULL,67273973054,1051155828,16424309,16.61),(13682,'IRAS','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13682,34.12,0.8,66.5,2882,75,NULL,'W91CL, r','UGC 00679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13683,'IRAS','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13683,34.12,0.8,66.8,2882,75,NULL,'W91PP, r','UGC 00679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13684,'IRAS','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13684,34.16,0.8,67.8,2882,75,NULL,'CF, r','UGC 00679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13685,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13685,33.68,0.43,54.4,2882,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00679',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13686,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13686,33.69,0.2,54.7,2882,74.4,NULL,NULL,'UGC 00679',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13687,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13687,33.71,0.43,55.1,2882,75,NULL,'3.6 micron, color corrected','UGC 00679',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13688,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13688,33.73,0.38,55.7,2882,75,NULL,'W91CL, r, inv','UGC 00679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13689,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13689,33.75,0.4,56.2,2882,75,NULL,'HMCL, I, inv','UGC 00679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13690,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13690,33.77,0.4,56.7,2882,75,NULL,'HMCL, I, raw','UGC 00679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13691,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13691,33.8,0.38,57.6,2882,75,NULL,'W91CL, r, raw','UGC 00679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13692,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13692,33.94,0.38,61.5,2882,75,NULL,'W91PP, r, inv','UGC 00679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13693,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13693,34.02,0.38,63.7,2882,75,NULL,'W91CL, r, cor','UGC 00679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13694,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13694,34.03,0.4,63.9,2882,75,NULL,'HMCL, I, cor','UGC 00679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13695,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13695,34.07,0.38,65.2,2882,75,NULL,'W91PP, r, raw','UGC 00679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13696,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13696,34.21,0.38,69.5,2882,75,NULL,'W91PP, r, cor','UGC 00679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13697,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13697,34.22,0.13,70,2882,NULL,NULL,NULL,'UGC 00679',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13698,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13698,34.43,0.38,76.9,2882,75,NULL,'CF, r, inv','UGC 00679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13699,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13699,34.45,0.38,77.8,2882,75,NULL,'CF, r, raw','UGC 00679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13700,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13700,34.55,0.38,81.3,2882,75,NULL,'CF, r, cor','UGC 00679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13701,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13701,37.47,0.19,312,2883,70,NULL,NULL,'2MASX J01070431+1406484',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000095,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,16.768167,14.11333,0.085,NULL,67640099415,1056876553,16513696,17.9),(13702,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13702,35.81,0.54,145,2884,70,NULL,NULL,'ESO 541- G 020',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'15.80',0.4,'Sa',NULL,NULL,NULL,NULL,1,16.7705833333,-19.37475,0.026,NULL,35391419496,552990929,8640483,15.8),(13703,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 1999du',NULL,13703,40.11,0.21,833,2885,74.2,NULL,'SALT 2','SCP J010705.94-000753.8',0.263,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,16.77475,-0.13161,0.109,NULL,34552683145,539885674,8435713,NULL),(13704,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 1999du',NULL,13704,40.8,0.18,1150,2885,NULL,NULL,'M(B) = -19.31','SCP J010705.94-000753.8',0.263,'2008A&A...486..375A',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13705,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13705,34.75,0.23,89.1,2886,74.4,NULL,NULL,'NGC 0375',NULL,'2013AJ....146...86T',2013,1,1.4,'MCG incorrectly identifies NGC 0375 with MCG +05-03-049.','G',0.000067,NULL,'15.73',1.4,'E2:','Group member, 9th ranked galaxy',NULL,NULL,NULL,1,16.774667,32.34817,0.173,NULL,67273998467,1051156226,16424316,15.73),(13706,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13706,37.47,0.19,312,2887,70,NULL,NULL,'2MASX J01070628+1425044',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000081,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,16.77625,14.41808,0.085,NULL,67640130193,1056877034,16513703,17.3),(13707,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13707,35.71,0.5,138,2888,70,NULL,NULL,'2MASX J01070685-3728482',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.81',0.37,'S',NULL,NULL,NULL,NULL,1,16.7785417,-37.48,NULL,NULL,38339996819,599062450,9360350,15.81),(13708,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13708,35.8,0.53,145,2889,70,NULL,NULL,'2MASX J01070729-4703193',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'17.02',0.27,'S0','Group member',NULL,NULL,NULL,1,16.7804583333,-47.05533,NULL,NULL,38141685804,595963840,9311935,17.02),(13709,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13709,36.2,0.55,174,2890,70,NULL,NULL,'2MASX J01070747-5145128',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'16.25',0.25,'S',NULL,NULL,NULL,NULL,1,16.7809583333,-51.75367,NULL,NULL,36007662335,562619723,8790933,16.25),(13710,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13710,37.6,0.46,331,2891,70,NULL,NULL,'2MASX J01070747-0955248',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000098,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,16.7812916667,-9.92364,0.144,NULL,35254690500,550854539,8607102,16.5),(13711,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13711,38.34,0.46,465,2892,70,NULL,NULL,'2MASX J01070909+1422053',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000085,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,16.78775,14.36794,0.085,NULL,67640124685,1056876948,16513702,17.9),(13712,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13712,35.26,0.46,113,2893,70,NULL,NULL,'CGCG 384-076',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000093,NULL,'14.3g',0.31,'E0',NULL,NULL,NULL,NULL,1,16.788167,-0.62175,0.13,NULL,34552869628,539888587,8435759,14.3),(13713,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13713,36.31,0.68,183,2894,70,NULL,NULL,'2MASX J01071004-0646048',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'17.17',0.31,NULL,NULL,NULL,NULL,NULL,1,16.7920417,-6.76794,0.263,NULL,35258366552,550911977,8607999,17.17),(13714,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13714,34.54,NULL,80.9,2895,NULL,NULL,'B','ESO 243- G 030',NULL,'2005Ap&SS.298..577R',2005,1,0.96,NULL,'G',0.000033,NULL,'14.68',0.55,'SAB:(rs)c',NULL,NULL,NULL,NULL,1,16.7938333333,-42.39197,NULL,NULL,38160175207,596252737,9316449,14.68),(13715,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13715,34.54,NULL,80.9,2895,NULL,NULL,'I','ESO 243- G 030',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13716,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13716,34.85,0.38,93.3,2895,NULL,NULL,NULL,'ESO 243- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13717,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13717,34.89,0.2,95.1,2895,74.4,NULL,NULL,'ESO 243- G 030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13718,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13718,34.94,0.36,97.1,2895,NULL,NULL,'Malmquist cor.','ESO 243- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13719,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13719,35.23,0.47,111,2896,70,NULL,NULL,'ESO 295- G 038',NULL,'2014MNRAS.445.2677S',2014,1,1.2,'The declination in AM Catalogue is incorrect.','G',0.00015,NULL,'14.05',0.7,'SAB(s)0-','in a pair',NULL,NULL,NULL,1,16.7962916667,-41.91661,NULL,NULL,38340685946,599073217,9360519,14.05),(13720,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13720,36.03,0.46,161,2897,70,NULL,NULL,'2MASX J01071292-0858378',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000074,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,16.80375,-8.97733,0.199,NULL,35262485033,550976328,8609005,16.7),(13721,'D-Sigma','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13721,33.98,0.4,62.5,2898,75,NULL,'Edat, raw','NGC 0379',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000097,NULL,'13.92',0.8,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,16.815375,32.52036,0.173,NULL,67273900903,1051154701,16424292,13.92),(13722,'D-Sigma','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13722,34.08,0.4,65.6,2898,75,NULL,'Edat, cor','NGC 0379',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13723,'Faber-Jackson','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13723,33.08,0.44,41.3,2898,95,NULL,'Weighted Mean','NGC 0379',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13724,'Faber-Jackson','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13724,33.48,0.46,49.7,2898,95,NULL,'Michard 1979a','NGC 0379',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13725,'Faber-Jackson','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13725,33.6,0.63,52.5,2898,95,NULL,'Michard 1979b, c','NGC 0379',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13726,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13726,34.15,0.23,67.6,2898,74.4,NULL,NULL,'NGC 0379',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13727,'Tertiary','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13727,33.54,0.5,51.1,2898,95,NULL,NULL,'NGC 0379',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13728,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13728,34.33,0.45,73.5,2898,NULL,NULL,'K','NGC 0379',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13729,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13729,34.39,0.4,75.7,2898,NULL,NULL,'mean','NGC 0379',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13730,'D-Sigma','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13730,33.98,0.4,62.5,2899,75,NULL,'Edat, raw','NGC 0380',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000056,NULL,'13.60',1.2,'E2','in a radial-velocity based grouping',NULL,NULL,NULL,1,16.8232917,32.48292,0.173,NULL,67273968900,1051155764,16424308,13.6),(13731,'D-Sigma','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13731,34.08,0.4,65.6,2899,75,NULL,'Edat, cor','NGC 0380',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13732,'Faber-Jackson','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13732,33.61,0.44,52.7,2899,95,NULL,'Weighted Mean','NGC 0380',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13733,'Faber-Jackson','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13733,34.05,0.46,64.6,2899,95,NULL,'Michard 1979a','NGC 0380',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13734,'Faber-Jackson','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13734,34.22,0.63,69.8,2899,95,NULL,'Michard 1979b, c','NGC 0380',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13735,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13735,34.37,0.25,74.8,2899,74.4,NULL,NULL,'NGC 0380',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13736,'Tertiary','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13736,33.54,0.5,51.1,2899,95,NULL,NULL,'NGC 0380',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13737,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13737,34.01,0.4,63.2,2899,NULL,NULL,'mean','NGC 0380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13738,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13738,35.06,0.45,103,2899,NULL,NULL,'K','NGC 0380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13739,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13739,37.47,0.19,312,2900,70,NULL,NULL,'2MASXi J0107180+141742',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000073,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,16.825125,14.29536,0.081,NULL,67640594561,1056884290,16513817,18),(13740,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13740,37.14,0.6,268,2901,70,NULL,NULL,'2MASX J01071890-0046510',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.000107,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,16.828625,-0.78089,0.149,NULL,34553531003,539898921,8435920,16.4),(13741,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13741,35.57,0.49,130,2902,70,NULL,NULL,'2MASX J01072060-1636242',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'16.33',0.18,NULL,NULL,NULL,NULL,NULL,1,16.835917,-16.60667,0.018,NULL,35430639794,553603746,8650058,16.33),(13742,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 14403','R',13742,41.07,0.23,1270,2903,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J010721.17+003907.0',0.289816,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,'PHOT','22.0g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,16.8382083,0.65197,0.085,NULL,66693706497,1042089164,16282643,22),(13743,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 14403','R',13743,41.3,0.17,1410,2903,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J010721.17+003907.0',0.289816,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13744,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 14403',NULL,13744,40.94,0.13,1540,2903,70,NULL,'SALT 2','SDSS J010721.17+003907.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13745,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 14403',NULL,13745,40.97,0.13,1560,2903,70,NULL,'SALT 2, Malmquist cor.','SDSS J010721.17+003907.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13746,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13746,37.68,0.46,343,2904,70,NULL,NULL,'2MASX J01072175+0106141',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000061,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,16.8406666667,1.10383,0.029,NULL,66694105666,1042095401,16282740,17.6),(13747,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13747,36.95,0.62,246,2905,70,NULL,NULL,'MCG -02-03-073',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.1R',0.3,NULL,NULL,NULL,NULL,NULL,1,16.841583,-13.33683,0.029,NULL,35424576183,553509002,8648578,15.1),(13748,'Brightest Stars','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13748,28.7,1,5.5,2906,NULL,NULL,NULL,'UGC 00685',NULL,'1999A&AS..134..317H',1999,1,1.2,NULL,'G',0.000003,NULL,'14.23',0.9,'Im/BCD         HII','Isolated galaxy',NULL,NULL,NULL,1,16.8435,16.68456,0.105,NULL,67644192654,1056940510,16514695,14.23),(13749,'Brightest Stars','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13749,28.89,0.2,6,2906,NULL,NULL,NULL,'UGC 00685',NULL,'1998A&AS..133..181M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13750,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13750,28.36,0.1,4.7,2906,NULL,NULL,NULL,'UGC 00685',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13751,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13751,28.36,0.03,4.7,2906,NULL,NULL,NULL,'UGC 00685',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13752,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13752,28.36,0.08,4.71,2906,74.4,NULL,NULL,'UGC 00685',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13753,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13753,28.4,0.14,4.79,2906,NULL,NULL,NULL,'UGC 00685',NULL,'2002AJ....123.1307M',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13754,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13754,28.42,0.02,4.83,2906,NULL,NULL,'I','UGC 00685',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13755,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13755,36.57,0.33,206,2907,70,NULL,NULL,'2MASX J01072255+0042511',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000069,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,16.843833,0.71428,0.085,NULL,66693695300,1042088989,16282640,16.9),(13756,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13756,34.6,0.46,83.3,2908,70,NULL,NULL,'NGC 0391',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.000083,NULL,'14.1g',0.75,'(R\')SA0-:',NULL,NULL,NULL,NULL,1,16.844083,0.92594,0.029,NULL,66694081201,1042095018,16282734,14.1),(13757,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13757,36.57,0.33,206,2909,70,NULL,NULL,'2MASX J01072322+0040191',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000073,NULL,'16.3g',0.28,'S0^-',NULL,NULL,NULL,NULL,1,16.84675,0.67192,0.085,NULL,66693708917,1042089201,16282643,16.3),(13758,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2000dk',NULL,13758,30.53,0.2,12.5,2910,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','NGC 0382',0.01744,'2011A&A...526A..81B',2011,1,0.7,NULL,'G',0.000067,NULL,'14.22',0.7,'E:             HII','Pair member (points to parent)',NULL,NULL,NULL,1,16.8494583,32.40386,0.173,NULL,67273981690,1051155963,16424311,14.22),(13759,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2000dk',NULL,13759,33.45,0.25,48.1,2910,74.2,NULL,'SALT 2','NGC 0382',0.01744,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13760,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2000dk',NULL,13760,33.96,0.22,60.9,2910,72,NULL,NULL,'NGC 0382',0.01744,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13761,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2000dk',NULL,13761,34.08,0.08,65.5,2910,74.4,NULL,NULL,'NGC 0382',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13762,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2000dk',NULL,13762,34.13,0.13,65.9,2910,70,NULL,NULL,'NGC 0382',0.01744,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13763,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2000dk',NULL,13763,34.18,0.29,67.4,2910,70,NULL,'SALT','NGC 0382',0.01744,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13764,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2000dk',NULL,13764,34.22,0.19,68.5,2910,70,NULL,'SALT 2','NGC 0382',0.01744,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13765,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2000dk',NULL,13765,34.25,0.01,69.5,2910,72,NULL,NULL,'NGC 0382',0.01744,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13766,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2000dk',NULL,13766,34.21,0.12,69.5,2910,70.8,NULL,NULL,'NGC 0382',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13767,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2000dk',NULL,13767,34.27,0.18,70.2,2910,73.8,NULL,'SALT 2 (SNANA)','NGC 0382',0.0175,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13768,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2000dk',NULL,13768,34.33,0.33,72.2,2910,65,NULL,'SALT','NGC 0382',0.01744,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13769,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2000dk',NULL,13769,34.33,0.21,72.3,2910,65,NULL,'MLCS17','NGC 0382',0.01744,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13770,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2000dk',NULL,13770,34.37,0.08,73.5,2910,65,NULL,'MLCS2k2','NGC 0382',0.01744,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13771,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2000dk',NULL,13771,34.41,0.08,73.5,2910,65,NULL,'MLCS2k2','NGC 0382',0.01744,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13772,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2000dk',NULL,13772,34.38,0.2,73.7,2910,65,NULL,'MLCS31','NGC 0382',0.01744,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13773,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2000dk',NULL,13773,34.38,0.24,73.7,2910,65,NULL,'SALT2','NGC 0382',0.01744,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13774,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2000dk',NULL,13774,34.41,0.24,74.9,2910,65,NULL,NULL,'NGC 0382',0.01744,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13775,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2000dk',NULL,13775,34.42,0.01,75.1,2910,65,NULL,'SALT','NGC 0382',0.01744,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13776,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2000dk',NULL,13776,34.72,0.14,87.9,2910,60,NULL,NULL,'NGC 0382',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13777,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2000dk',NULL,13777,34.89,0.03,93.5,2910,70,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','NGC 0382',0.01744,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13778,'D-Sigma','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13778,33.98,0.4,62.5,2910,75,NULL,'Edat, raw','NGC 0382',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13779,'D-Sigma','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13779,34.08,0.4,65.6,2910,75,NULL,'Edat, cor','NGC 0382',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13780,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13780,34.08,0.08,65.5,2910,74.4,NULL,NULL,'NGC 0382',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13781,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13781,35.45,0.48,123,2911,NULL,NULL,'Malmquist cor.','2MFGC 00817',NULL,'2009ApJS..182..474S',2009,1,0.68,NULL,'G',0.000027,NULL,'16.84',0.16,'Sc','Group member',NULL,NULL,NULL,1,16.852083,-46.99322,NULL,NULL,38141631021,595962984,9311921,16.84),(13782,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13782,35.59,0.45,131,2911,NULL,NULL,NULL,'2MFGC 00817',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13783,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13783,35.63,0.2,134,2911,74.4,NULL,NULL,'2MFGC 00817',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13784,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13784,35.71,0.49,139,2911,75,NULL,'IR','2MFGC 00817',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13785,'D-Sigma','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13785,33.98,0.4,62.5,2912,75,NULL,'Edat, raw','NGC 0383',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000039,NULL,'13.38',1.4,'SA0-:;BrClG;Sy LERG','Pair member (points to parent)',NULL,'FR I','Flat-Spectrum Radio Source',1,16.854,32.41256,0.173,NULL,67273979546,1051155930,16424311,13.38),(13786,'D-Sigma','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13786,34.04,0.1,64.3,2912,72,NULL,'Pisces cluster, 21 galaxies','NGC 0383',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13787,'D-Sigma','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13787,34.08,0.4,65.6,2912,75,NULL,'Edat, cor','NGC 0383',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13788,'Faber-Jackson','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13788,32.91,0.44,38.2,2912,95,NULL,'Weighted Mean','NGC 0383',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13789,'Faber-Jackson','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13789,33.24,0.46,44.5,2912,95,NULL,'Michard 1979a','NGC 0383',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13790,'Faber-Jackson','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13790,33.51,0.63,50.4,2912,95,NULL,'Michard 1979b, c','NGC 0383',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13791,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13791,33.93,0.08,61.1,2912,75,NULL,'Pisces cluster, 25 galaxies','NGC 0383',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13792,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13792,33.93,0.08,61.1,2912,75,NULL,'Pisces cluster, 25 galaxies','NGC 0383',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13793,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13793,34.01,0.23,63.4,2912,74.4,NULL,NULL,'NGC 0383',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13794,'Tertiary','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13794,33.54,0.5,51.1,2912,95,NULL,NULL,'NGC 0383',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13795,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13795,33.8,0.16,57.5,2912,NULL,NULL,'Pisces cluster, avg. of 23 galaxies [for Virgo m-M = 31.10 mag, D = 16.6 Mpc]','NGC 0383',NULL,'1986A&A...164...17G',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13796,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13796,33.9,0.35,60.3,2912,77,NULL,'Pisces cluster, 53 galaxies','NGC 0383',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13797,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13797,33.9,NULL,60.3,2912,77,NULL,'BRIK, Pisces cluster, 53 galaxies','NGC 0383',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13798,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13798,34.02,0.08,63.7,2912,75,NULL,'Pisces CLUSTER','NGC 0383',NULL,'2012ApJ...749...78T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13799,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13799,34.03,0.45,63.8,2912,NULL,NULL,'K','NGC 0383',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13800,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13800,34.05,0.11,64.6,2912,75,NULL,'Pisces cluster, avg. of 23 spiral galaxies','NGC 0383',NULL,'2013ApJ...765...94S',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13801,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13801,34.1,0.13,66.1,2912,70,NULL,'Pisces Cluster','NGC 0383',NULL,'1992ApJ...396..453H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13802,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13802,34.1,0.09,66.1,2912,75,NULL,'Pisces cluster, avg. of 23 spiral galaxies','NGC 0383',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13803,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13803,34.12,NULL,66.6,2912,71,NULL,'NGC 0383, 32 galaxies','NGC 0383',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13804,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13804,34.12,0.09,66.7,2912,74.4,NULL,'Pisces CLUSTER, 59 galaxies, WISE I-band','NGC 0383',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13805,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13805,34.17,0.09,68.3,2912,74.4,NULL,'Pisces CLUSTER, 59 galaxies, WISE W1 (3.4 micro-meter), color corrected','NGC 0383',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13806,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13806,34.17,0.09,68.4,2912,74.4,NULL,'Pisces CLUSTER, 59 galaxies, WISE W2 (4.6 micro-meter), color corrected','NGC 0383',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13807,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13807,34.19,0.3,68.9,2912,NULL,NULL,'NGC 0383, 15 galaxies','NGC 0383',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13808,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13808,34.23,0.4,70.2,2912,NULL,NULL,'mean','NGC 0383',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13809,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13809,34.23,0.06,70.2,2912,74.4,NULL,'Pisces CLUSTER, 59 galaxies, WISE W1 (3.4 micro-meter), curved','NGC 0383',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13810,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13810,34.26,0.06,71.2,2912,74.4,NULL,'Pisces CLUSTER, 59 galaxies, WISE W2 (4.6 micro-meter), curved','NGC 0383',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13811,'IRAS','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13811,31.43,0.8,19.3,2913,75,NULL,'MAT, I','NGC 0406',NULL,'1997ApJS..109..333W',1997,1,3.3,NULL,'G',0.00001,NULL,'13.1',1.3,'SB:(s)c',NULL,NULL,NULL,NULL,1,16.854375,-69.87917,0.045,NULL,36311779132,567371548,8865180,13.1),(13812,'Tully est','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13812,31.2,0.8,17.3,2913,75,NULL,'B','NGC 0406',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13813,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13813,31.2,0.32,17.4,2913,85,NULL,'I, raw','NGC 0406',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13814,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13814,31.2,0.32,17.4,2913,85,NULL,'I, inv','NGC 0406',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13815,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13815,31.47,0.4,19.7,2913,NULL,NULL,NULL,'NGC 0406',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13816,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13816,31.47,0.39,19.7,2913,73,NULL,'opt','NGC 0406',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13817,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13817,31.57,0.43,20.6,2913,75,NULL,'MAT, I, raw','NGC 0406',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13818,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13818,31.62,0.43,21.1,2913,75,NULL,'MAT, I, inv','NGC 0406',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13819,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13819,31.64,0.2,21.3,2913,74.4,NULL,NULL,'NGC 0406',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13820,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13820,31.65,0.6,21.4,2913,NULL,NULL,NULL,'NGC 0406',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13821,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13821,31.7,0.43,21.9,2913,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0406',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13822,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13822,31.71,0.43,22,2913,75,NULL,'3.6 micron, color corrected','NGC 0406',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13823,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13823,31.76,0.43,22.5,2913,75,NULL,'MAT, I, cor','NGC 0406',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13824,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13824,31.81,0.56,23,2913,NULL,NULL,'Malmquist cor.','NGC 0406',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13825,'Faber-Jackson','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13825,33.4,0.44,47.9,2914,95,NULL,'Weighted Mean','NGC 0384',NULL,'1984ApJS...56...91D',1984,1,1.1,NULL,'G',0.000067,NULL,'14.05',0.9,'E3','in a radial-velocity based grouping',NULL,NULL,NULL,1,16.854583,32.29244,0.173,NULL,67274013288,1051156457,16424319,14.05),(13826,'Faber-Jackson','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13826,33.73,0.63,55.7,2914,95,NULL,'Michard 1979b, c','NGC 0384',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13827,'Faber-Jackson','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13827,33.99,0.46,62.8,2914,95,NULL,'Michard 1979a','NGC 0384',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13828,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13828,34.67,0.23,85.9,2914,74.4,NULL,NULL,'NGC 0384',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13829,'Tertiary','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13829,33.54,0.5,51.1,2914,95,NULL,NULL,'NGC 0384',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13830,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 18740','R',13830,39.2,0.18,601,2915,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007mc','SDSS J010725.69+010237.3',0.15,'2014arXiv1401.3317S',2014,1,0.16,NULL,'G',NULL,NULL,'19.1g',0.1,NULL,NULL,NULL,NULL,NULL,1,16.8570417,1.04372,0.029,NULL,66694052639,1042094572,16282727,19.1),(13831,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2007mc',NULL,13831,39.11,0.06,664,2915,70,NULL,'SALT 2','SDSS J010725.69+010237.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13832,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2007mc',NULL,13832,39.12,0.06,667,2915,70,NULL,'SALT 2, Malmquist cor.','SDSS J010725.69+010237.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13833,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 18740','R',13833,39.43,0.07,668,2915,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007mc','SDSS J010725.69+010237.3',0.15,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13834,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 17059','RN',13834,43.46,0.27,2990,2916,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17059',0.647866,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13835,'D-Sigma','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13835,33.98,0.4,62.5,2917,75,NULL,'Edat, raw','NGC 0385',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000067,NULL,'13.93',1,'SA0-:','in a radial-velocity based grouping',NULL,NULL,NULL,1,16.8635417,32.31953,0.173,NULL,67274012102,1051156439,16424319,13.93),(13836,'D-Sigma','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13836,34.08,0.4,65.6,2917,75,NULL,'Edat, cor','NGC 0385',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13837,'Faber-Jackson','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13837,33.2,0.44,43.7,2917,95,NULL,'Weighted Mean','NGC 0385',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13838,'Faber-Jackson','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13838,33.5,0.63,50.1,2917,95,NULL,'Michard 1979b, c','NGC 0385',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13839,'Faber-Jackson','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13839,33.76,0.46,56.5,2917,95,NULL,'Michard 1979a','NGC 0385',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13840,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13840,34.04,0.23,64.3,2917,74.4,NULL,NULL,'NGC 0385',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13841,'Tertiary','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13841,33.54,0.5,51.1,2917,95,NULL,NULL,'NGC 0385',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13842,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13842,34.23,0.4,70.2,2917,NULL,NULL,'mean','NGC 0385',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13843,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13843,34.61,0.45,83.5,2917,NULL,NULL,'K','NGC 0385',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13844,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2006ok',NULL,13844,38.09,0.19,414,2918,70,NULL,'Hubble residual 0.10 for z0.09700; SDSS-II SN 16185','SDSS-II SN 16185 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,16.868083,-0.26933,0.124,NULL,34552715393,539886178,8435721,NULL),(13845,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2006ok',NULL,13845,38.09,0.08,415,2918,70,NULL,'SALT 2; SDSS-II SN 16185','SDSS-II SN 16185 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13846,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2006ok',NULL,13846,38.09,0.08,415,2918,70,NULL,'SALT 2, Malmquist cor.; SDSS-II SN 16185','SDSS-II SN 16185 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13847,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2006ok','R',13847,38.33,0.19,421,2918,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ok; SDSS-II SN 16185','SDSS-II SN 16185 HOST',0.101366,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13848,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2006ok','R',13848,38.46,0.07,448,2918,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ok; SDSS-II SN 16185','SDSS-II SN 16185 HOST',0.101366,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13849,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13849,37.47,0.19,312,2919,70,NULL,NULL,'2MASX J01073020+1418009',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000102,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,16.875875,14.30022,0.081,NULL,67640596224,1056884316,16513817,17.3),(13850,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13850,34.7,0.59,87.1,2920,70,NULL,NULL,'FAIRALL 0679',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.000127,NULL,'16.04',0.22,'S0','Group member',NULL,NULL,NULL,1,16.8764583,-45.18067,NULL,NULL,38139619081,595931548,9311430,16.04),(13851,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13851,37.47,0.19,312,2921,70,NULL,NULL,'2MASX J01073046+1412219',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000098,NULL,'16.6g',0.3,'NLAGN',NULL,NULL,NULL,NULL,1,16.877,14.20606,0.081,NULL,67640568239,1056883878,16513810,16.6),(13852,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13852,33.89,0.25,60,2922,74.4,NULL,NULL,'NGC 0386',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000067,NULL,'15.33',0.8,'E3:','Group member',NULL,NULL,NULL,1,16.880375,32.362,0.173,NULL,67273976750,1051155886,16424310,15.33),(13853,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 14525','R',13853,39.58,0.1,712,2923,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14525',0.154365,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,16.88275,0.47711,0.087,NULL,66693733320,1042089583,16282649,NULL),(13854,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 14525','R',13854,39.58,0.19,714,2923,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14525',0.154365,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13855,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13855,28.15,NULL,4.26,2924,NULL,NULL,NULL,'kkh 005',NULL,'2003A&A...398..479K',2003,1,0.65,NULL,'G',0.000007,NULL,'17.1',0.4,'Ir?',NULL,NULL,NULL,NULL,1,16.8852916667,51.44044,1.205,NULL,65785850331,1027903911,16060998,17.1),(13856,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 08355','RN',13856,37.93,0.25,344,2925,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 08355',0.116589,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13857,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 08355','RN',13857,39.2,0.35,619,2925,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08355',0.116589,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13858,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13858,34.36,0.2,74.5,2926,74.4,NULL,NULL,'UGC 00690',NULL,'2013AJ....146...86T',2013,1,2.2,NULL,'G',0.00003,NULL,'13.42',1.9,'SBc','in a pair',NULL,NULL,NULL,1,16.8865,39.40014,0.209,NULL,67894450859,1060850794,16575793,13.42),(13859,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13859,34.36,0.36,74.5,2926,NULL,NULL,'Malmquist cor.','UGC 00690',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13860,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13860,34.44,0.35,77.1,2926,NULL,NULL,NULL,'UGC 00690',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13861,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13861,34.65,0.4,85,2926,NULL,NULL,'mean','UGC 00690',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13862,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13862,35.11,0.47,105,2926,NULL,NULL,'H','UGC 00690',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13863,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13863,35.13,0.46,106,2926,NULL,NULL,'J','UGC 00690',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13864,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13864,35.56,0.48,129,2927,70,NULL,NULL,'MCG -02-03-074',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'15.80',0.32,NULL,NULL,NULL,NULL,NULL,1,16.887083,-13.27128,0.029,NULL,35421217529,553456523,8647758,15.8),(13865,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13865,36.42,0.2,192,2928,74.4,NULL,NULL,'ESO 352- G 007',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.000023,NULL,'15.15',0.8,'(R\')SB(rs)a',NULL,NULL,NULL,NULL,1,16.8999583,-33.63789,NULL,NULL,34730429099,542662954,8479108,15.15),(13866,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13866,36.19,0.25,173,2929,74.4,NULL,NULL,'MCG +00-04-001',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000037,NULL,'15.1V',0.4,NULL,'Group member',NULL,NULL,NULL,1,16.92375,2.11961,0.017,NULL,66695281172,1042113768,16283027,15.1),(13867,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13867,36.4,0.16,191,2929,70,NULL,NULL,'MCG +00-04-001',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13868,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13868,36.4,0.61,191,2930,70,NULL,NULL,'2MASX J01074176-0256447',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.000093,NULL,'17.19',0.31,NULL,NULL,NULL,NULL,NULL,1,16.924083,-2.94569,0.12,NULL,34556884404,539951318,8436739,17.19),(13869,'D-Sigma','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13869,34.66,0.4,85.6,2931,75,NULL,'Edat, raw','IC 1625',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000077,NULL,'12.9',1.2,'SA(rs)0- pec:;D/cD','Group member',NULL,NULL,NULL,1,16.9275417,-46.90758,NULL,NULL,38141607490,595962617,9311915,12.9),(13870,'D-Sigma','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13870,35,0.4,99.9,2931,75,NULL,'Edat, cor','IC 1625',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13871,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13871,34.43,0.45,76.9,2931,NULL,NULL,'K','IC 1625',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13872,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13872,34.89,0.4,94.9,2931,NULL,NULL,'mean','IC 1625',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13873,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2005ga',NULL,13873,38.79,0.11,494,2932,74.2,NULL,'SALT 2','SDSS J010743.60-010222.1',0.16,'2010ApJ...716..712A',2010,1,0.14,NULL,'G',0.0005,NULL,'19.1g',0.07,NULL,NULL,NULL,NULL,NULL,1,16.931667,-1.03947,0.174,NULL,34498560724,539040011,8422500,19.1),(13874,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2005ga',NULL,13874,39.33,0.03,633,2932,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 03080, SN 2005ga','SDSS J010743.60-010222.1',0.16,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13875,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2005ga',NULL,13875,39.07,0.06,650,2932,70,NULL,'Hubble residual -0.11 for z0.17500','SDSS J010743.60-010222.1',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13876,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 03080','R',13876,39.5,0.18,676,2932,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ga','SDSS J010743.60-010222.1',0.175,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13877,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2005ga',NULL,13877,39.5,0.12,685,2932,70,NULL,'SALT 2','SDSS J010743.60-010222.1',0.16,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13878,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2005ga',NULL,13878,39.52,0.07,690,2932,65,NULL,'SALT2','SDSS J010743.60-010222.1',0.16,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13879,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2005ga',NULL,13879,39.57,NULL,707,2932,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 03080, SN 2005ga','SDSS J010743.60-010222.1',0.16,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13880,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2005ga',NULL,13880,39.72,0.09,759,2932,65,NULL,'MLCS2k2','SDSS J010743.60-010222.1',0.16,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13881,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2005ga',NULL,13881,39.41,0.06,762,2932,70,NULL,'SALT 2','SDSS J010743.60-010222.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13882,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2005ga',NULL,13882,39.42,0.06,766,2932,70,NULL,'SALT 2, Malmquist cor.','SDSS J010743.60-010222.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13883,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 03080','R',13883,39.78,0.09,769,2932,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ga','SDSS J010743.60-010222.1',0.175,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13884,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 18694','RN',13884,43.24,0.25,3360,2933,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 18694',0.322537,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13885,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 18694','RN',13885,43.44,0.25,3690,2933,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 18694',0.322537,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13886,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13886,33.99,0.23,62.8,2934,74.4,NULL,NULL,'NGC 0388',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000067,NULL,'15.42',0.8,'E3:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,16.9464583,32.30997,0.181,NULL,67274008933,1051156389,16424318,15.42),(13887,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13887,36.78,0.72,227,2935,70,NULL,NULL,'2MASX J01074752-2134376',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,16.948,-21.57711,0.071,NULL,35213038606,550203728,8596933,15),(13888,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13888,37.68,0.46,343,2936,70,NULL,NULL,'2MASX J01074769+1520599',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00008,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,16.948625,15.35006,0.125,NULL,67645324153,1056958189,16514971,17.3),(13889,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 13518','R',13889,41.14,0.2,1300,2937,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006mn','SN 2006mn',0.299,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,16.951625,-0.10986,0.107,NULL,34498209861,539034529,8422414,NULL),(13890,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 13518','R',13890,41.85,0.38,1800,2937,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006mn','SN 2006mn',0.299,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13891,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 15234','R',13891,39.36,0.18,660,2938,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006kd','SDSS J010749.93+004942.9',0.13,'2014arXiv1401.3317S',2014,1,0.13,NULL,'G',NULL,NULL,'18.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,16.9580833333,0.82858,0.037,NULL,66648091723,1041376433,16271506,18.8),(13892,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 15234','R',13892,39.41,0.08,674,2938,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006kd','SDSS J010749.93+004942.9',0.13,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13893,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2006kd',NULL,13893,39.24,0.07,705,2938,70,NULL,'SALT 2','SDSS J010749.93+004942.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13894,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2006kd',NULL,13894,39.24,0.07,705,2938,70,NULL,'SALT 2, Malmquist cor.','SDSS J010749.93+004942.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13895,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13895,36.38,0.46,189,2939,70,NULL,NULL,'2MASX J01075366+0019351',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000097,NULL,'16.0g',0.34,'E0',NULL,NULL,NULL,NULL,1,16.973625,0.32633,0.145,NULL,66647706344,1041370411,16271412,16),(13896,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 14347',NULL,13896,40.19,0.19,1090,2940,70,NULL,'SN photometric redshift distance, z photo =0.298 +/- 0.033','SDSS-II SN 14347',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,16.9807083,-1.01714,0.174,NULL,34498561651,539040025,8422500,NULL),(13897,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13897,37.19,0.46,274,2941,70,NULL,NULL,'2MASX J01075574-0024587',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000093,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,16.9822917,-0.41642,0.124,NULL,34498261456,539035335,8422427,16.6);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (13898,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13898,35.82,0.36,146,2942,NULL,NULL,'Malmquist cor.','UGC 00698',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000157,NULL,'15.21',0.4,'Sab',NULL,NULL,NULL,NULL,1,16.9835,2.54586,0.041,NULL,66694710219,1042104847,16282888,15.21),(13899,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13899,35.86,0.35,149,2942,NULL,NULL,NULL,'UGC 00698',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13900,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13900,35.9,0.2,151,2942,74.4,NULL,NULL,'UGC 00698',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13901,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13901,33.98,0.07,62.6,2943,NULL,NULL,NULL,'KUG 0105+330',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.00003,NULL,'15.16',0.7,'S?',NULL,NULL,NULL,NULL,1,16.9892083,33.30303,0.153,NULL,67262395714,1050974933,16421483,15.16),(13902,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13902,37.46,0.46,311,2944,70,NULL,NULL,'2MASX J01075785-0937308',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000089,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,16.9909583333,-9.62522,0.169,NULL,35255098589,550860915,8607201,17.5),(13903,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 20882',NULL,13903,40.58,0.26,1310,2945,70,NULL,NULL,'SDSS-II SN 20882',NULL,'2013MNRAS.434.1443X',2013,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,16.992375,0.46361,0.145,NULL,66647684271,1041370066,16271407,NULL),(13904,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 20882','R',13904,41.34,0.27,1410,2945,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20882',0.314419,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13905,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 20882','R',13905,41.43,0.19,1470,2945,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20882',0.314419,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13906,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 20882',NULL,13906,41.17,0.16,1710,2945,70,NULL,'SALT 2','SDSS-II SN 20882',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13907,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 20882',NULL,13907,41.2,0.16,1740,2945,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20882',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13908,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003jj',NULL,13908,41.68,0.29,1370,2946,74.2,NULL,'SALT 2','ESSENCE J010758.52+000301.9',0.583,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,16.9938333333,0.05053,0.107,NULL,66647496408,1041367131,16271361,NULL),(13909,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003jj','R',13909,42.1,NULL,1660,2946,65,NULL,'SN d058, SALT','ESSENCE J010758.52+000301.9',0.583,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13910,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003jj',NULL,13910,42.6,0.46,2090,2946,70,NULL,'SN d058, SALT','ESSENCE J010758.52+000301.9',0.583,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13911,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003jj',NULL,13911,42.7,0.47,2190,2946,65,NULL,'SN d058, SALT','ESSENCE J010758.52+000301.9',0.583,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13912,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003jj',NULL,13912,43.01,0.09,2530,2946,65,NULL,'SN d058, SALT','ESSENCE J010758.52+000301.9',0.583,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13913,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003jj',NULL,13913,43.1,0.15,2640,2946,65,NULL,'SN d058, MLCS2k2','ESSENCE J010758.52+000301.9',0.583,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13914,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13914,38.49,0.46,499,2947,70,NULL,NULL,'2MASX J01080227-0009234',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000111,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,17.009417,-0.15658,0.107,NULL,34498202292,539034410,8422412,18.1),(13915,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13915,37.45,0.46,310,2948,70,NULL,NULL,'2MASX J01080277+0055569',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000081,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,17.0115,0.93244,0.033,NULL,66648124141,1041376939,16271514,17.7),(13916,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13916,36.49,0.59,198,2949,70,NULL,NULL,'2MASX J01080295-4331405',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'17.12',0.22,NULL,NULL,NULL,NULL,NULL,1,17.012375,-43.52786,NULL,NULL,38159790317,596246723,9316355,17.12),(13917,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13917,37.4,0.46,301,2950,70,NULL,NULL,'2MASX J01080379-0929388',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000084,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,17.015875,-9.49408,0.188,NULL,35254240678,550847510,8606992,17.2),(13918,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 10777','RN',13918,37.98,0.2,372,2951,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10777',0.063385,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13919,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 10777','RN',13919,38.82,0.31,547,2951,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10777',0.063385,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13920,'IRAS','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13920,33.84,0.8,58.7,2952,75,NULL,'W91PP, r','UGC 00697',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.00003,NULL,'14.67',0.5,'SB?            HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,17.01975,33.45322,0.125,NULL,67262371096,1050974548,16421477,14.67),(13921,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13921,34.12,0.4,66.5,2952,NULL,NULL,'mean','UGC 00697',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13922,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13922,34.13,0.38,66.9,2952,75,NULL,'W91PP, r, raw','UGC 00697',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13923,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13923,34.24,0.38,70.5,2952,75,NULL,'W91PP, r, inv','UGC 00697',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13924,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13924,34.27,0.38,71.3,2952,75,NULL,'W91PP, r, cor','UGC 00697',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13925,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13925,34.6,0.47,83.3,2952,NULL,NULL,'H','UGC 00697',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13926,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13926,36.6,0.23,209,2953,70,NULL,NULL,'2MASX J01080474+0001195',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000073,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,17.0197917,0.02192,0.107,NULL,66647495568,1041367118,16271361,16.7),(13927,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13927,34.84,0.25,92.9,2954,74.4,NULL,NULL,'2MASX J01080501-4551175',NULL,'2013AJ....146...86T',2013,1,0.65,NULL,'G',0.000093,NULL,'16.22',0.27,'S0','Group member',NULL,NULL,NULL,1,17.021,-45.85489,NULL,NULL,38142467600,595976056,9312125,16.22),(13928,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 12917','RN',13928,40.58,0.19,1080,2955,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 12917',0.202097,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13929,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 12917','RN',13929,40.69,0.28,1140,2955,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 12917',0.202097,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13930,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13930,36.7,0.46,219,2956,70,NULL,NULL,'2MASX J01080594+1539052',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000089,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,17.0247083333,15.65153,0.125,NULL,67642917053,1056920578,16514384,17.2),(13931,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 19689','R',13931,39.34,0.2,638,2957,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19689',0.153622,'2014arXiv1401.3317S',2014,1,0.17,NULL,'G',NULL,'PHOT','19.3g',0.07,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,17.026875,-0.08247,0.107,NULL,34498206453,539034475,8422413,19.3),(13932,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 19689','R',13932,39.49,0.25,685,2957,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19689',0.153622,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13933,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 19689',NULL,13933,39.83,0.44,924,2957,70,NULL,'SN photometric redshift distance, z photo =0.245 +/- 0.066','SDSS-II SN 19689',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13934,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 04673','RN',13934,43.3,0.23,3050,2958,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04673',0.499712,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13935,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 19690',NULL,13935,40.86,0.36,1480,2959,70,NULL,'SN photometric redshift distance, z photo =0.435 +/- 0.108','SDSS-II SN 19690',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.4g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,17.030333,-0.14033,0.107,NULL,34498202760,539034418,8422412,21.4),(13936,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 19690','R',13936,42.07,0.36,1740,2959,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19690',0.487629,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13937,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003le','R',13937,41.47,NULL,1260,2960,65,NULL,'SN f041, MLCS17','ESSENCE J010808.73+002709.7',0.56,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,17.036375,0.45269,0.145,NULL,66647685654,1041370088,16271407,NULL),(13938,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003le',NULL,13938,42.16,0.31,1730,2960,74.2,NULL,'SALT 2','ESSENCE J010808.73+002709.7',0.56,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13939,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003le',NULL,13939,42.6,0.25,2120,2960,70,NULL,'SN f041, SALT','ESSENCE J010808.73+002709.7',0.56,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13940,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003le',NULL,13940,42.63,0.21,2150,2960,65,NULL,'SN f041, m15(B)','ESSENCE J010808.73+002709.7',0.56,'2005AJ....130.2453K',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13941,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003le',NULL,13941,42.67,0.16,2190,2960,65,NULL,'SN f041, MLCS17','ESSENCE J010808.73+002709.7',0.56,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13942,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003le',NULL,13942,42.7,0.15,2220,2960,65,NULL,'SN f041, MLCS31','ESSENCE J010808.73+002709.7',0.56,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13943,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003le',NULL,13943,42.72,0.14,2240,2960,65,NULL,'SN f041, MLCS2k2','ESSENCE J010808.73+002709.7',0.56,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13944,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003le',NULL,13944,42.77,0.22,2300,2960,65,NULL,'SN f041, SALT','ESSENCE J010808.73+002709.7',0.56,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13945,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003le',NULL,13945,42.89,0.1,2420,2960,65,NULL,'SN f041, SALT','ESSENCE J010808.73+002709.7',0.56,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13946,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003le',NULL,13946,43.08,0.26,2640,2960,65,NULL,'SN f041, SALT2','ESSENCE J010808.73+002709.7',0.56,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13947,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003le',NULL,13947,43.19,0.2,2790,2960,65,NULL,'SN f041, MLCS','ESSENCE J010808.73+002709.7',0.56,'2005AJ....130.2453K',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13948,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003le',NULL,13948,43.2,0.22,2800,2960,65,NULL,'SN f041, BATM','ESSENCE J010808.73+002709.7',0.56,'2005AJ....130.2453K',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13949,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 16462','R',13949,40.18,0.22,872,2961,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J010809.75-002309.3',0.2446,'2014arXiv1401.3317S',2014,1,0.13,NULL,'G',0.0001,NULL,'19.2g',0.1,NULL,NULL,NULL,NULL,NULL,1,17.040625,-0.38594,0.124,NULL,34498257535,539035273,8422426,19.2),(13950,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 16462','R',13950,40.28,0.15,914,2961,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J010809.75-002309.3',0.2446,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13951,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 16462',NULL,13951,39.97,0.12,986,2961,70,NULL,'SALT 2','SDSS J010809.75-002309.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13952,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 16462',NULL,13952,39.98,0.12,991,2961,70,NULL,'SALT 2, Malmquist cor.','SDSS J010809.75-002309.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13953,'IRAS','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13953,34.43,0.8,76.8,2962,75,NULL,'MAT, I','IC 1627',NULL,'1997ApJS..109..333W',1997,1,2.5,'The APM position is southeast of the center of the galaxy.','G',0.000033,NULL,'13.69',0.6,'SB(s)b: sp','Group member',NULL,NULL,NULL,1,17.045167,-46.09406,NULL,NULL,38142395196,595974924,9312108,13.69),(13954,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13954,34.25,0.43,70.8,2962,75,NULL,'MAT, I, raw','IC 1627',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13955,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13955,34.31,0.49,72.8,2962,75,NULL,'IR','IC 1627',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13956,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13956,34.33,0.47,73.4,2962,NULL,NULL,'H','IC 1627',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13957,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13957,34.33,0.46,73.6,2962,NULL,NULL,'J','IC 1627',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13958,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13958,34.4,0.45,75.9,2962,NULL,NULL,'K','IC 1627',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13959,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13959,34.44,0.32,77.2,2962,85,NULL,'I, raw','IC 1627',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13960,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13960,34.53,0.32,80.4,2962,85,NULL,'I, inv','IC 1627',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13961,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13961,34.6,0.43,83.3,2962,75,NULL,'MAT, I, inv','IC 1627',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13962,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13962,34.65,0.4,85,2962,NULL,NULL,'mean','IC 1627',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13963,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13963,34.67,0.43,85.8,2962,75,NULL,'MAT, I, cor','IC 1627',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13964,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13964,35.02,0.1,101,2962,NULL,NULL,NULL,'IC 1627',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13965,'BCG','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13965,37.19,0.35,263,2963,60,NULL,NULL,'ABELL 0147',0.0441,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,17.047917,2.17611,0.013,NULL,66649654341,1041400849,16271888,NULL),(13966,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13966,36.2,0.25,174,2964,74.4,NULL,NULL,'UGC 00701',NULL,'2013AJ....146...86T',2013,1,NULL,'Mislabeled as A150 C in Colless, et al. (1993,MNRAS,262,475).','GPair',0.000043,NULL,NULL,NULL,'DBL SYS','Group member',NULL,NULL,NULL,1,17.048333,2.1975,0.013,NULL,66649668376,1041401068,16271891,NULL),(13967,'BCG','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13967,37.19,0.35,263,2965,60,NULL,'ABELL 0147, BCG','UGC 00701 NED02',0.0441,'1980ApJ...241..486H',1980,1,NULL,'1995ApJ...440...28P has z = 0.04199 +- 0.00025.','G',0.00025,NULL,'13.9V',NULL,'BrClG','Group member, 2nd ranked galaxy',NULL,NULL,NULL,1,17.050167,2.19394,0.013,NULL,66649668374,1041401068,16271891,13.9),(13968,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13968,36.4,0.16,191,2965,70,NULL,NULL,'UGC 00701 NED02',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13969,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13969,34.24,0.23,70.5,2966,74.4,NULL,NULL,'2MASX J01081297+3227128',NULL,'2013AJ....146...86T',2013,1,0.52,NULL,'G',0.000067,NULL,'14.78',0.27,'S0',NULL,NULL,NULL,NULL,1,17.054,32.45361,0.181,NULL,67273943601,1051155368,16424302,14.78),(13970,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 07882',NULL,13970,40.2,0.24,1100,2967,70,NULL,'SN photometric redshift distance, z photo =0.299 +/- 0.043','SDSS-II SN 07882',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.4g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,17.054333,0.17325,0.107,NULL,66647539924,1041367811,16271372,22.4),(13971,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 07882','R',13971,41.14,0.23,1270,2967,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07882',0.335924,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13972,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 07882','R',13972,41.3,0.15,1360,2967,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07882',0.335924,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13973,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 07882',NULL,13973,41.1,0.15,1660,2967,70,NULL,'SALT 2','SDSS-II SN 07882',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13974,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 07882',NULL,13974,41.14,0.15,1690,2967,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 07882',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13975,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13975,35.86,0.7,149,2968,70,NULL,NULL,'AM 0106-620 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.26',0.27,NULL,NULL,NULL,NULL,NULL,1,17.054417,-61.78522,0,NULL,36061561593,563461899,8804092,16.26),(13976,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13976,36.88,0.64,238,2969,70,NULL,NULL,'2MASX J01081312-1339157',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'16.82',0.37,NULL,NULL,NULL,NULL,NULL,1,17.0547083333,-13.6545,0.032,NULL,35424779897,553512185,8648627,16.82),(13977,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 19521','RN',13977,40.95,0.25,1280,2970,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19521',0.205414,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13978,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 19521','RN',13978,41.67,0.41,1790,2970,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19521',0.205414,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13979,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13979,37.61,0.46,333,2971,70,NULL,NULL,'2MASX J01081368-0837106',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000075,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,17.056875,-8.61958,0.23,NULL,35259611621,550931431,8608303,18),(13980,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13980,38.16,0.46,429,2972,70,NULL,NULL,'2MASX J01081378+0036419',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000095,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,17.0575,0.6115,0.073,NULL,66648347975,1041380437,16271569,17.4),(13981,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13981,36.2,0.25,174,2973,74.4,NULL,NULL,'MCG +00-04-006',NULL,'2013AJ....146...86T',2013,1,0.15,'Mislabeled as A150 D in Colless, et al. (1993,MNRAS,262,475).','G',0.00004,NULL,'15.0V',0.15,'E/S0','Group member',NULL,NULL,NULL,1,17.0607083,2.17703,0.013,NULL,66649667787,1041401059,16271891,15),(13982,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13982,36.4,0.16,191,2973,70,NULL,NULL,'MCG +00-04-006',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13983,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 16023','RN',13983,42.52,0.37,2560,2974,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 16023',0.243207,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13984,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13984,36.43,0.51,194,2975,70,NULL,NULL,'2MASX J01081580-1800034',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00007,NULL,'16.37',0.45,'E',NULL,NULL,NULL,NULL,1,17.065667,-18.00092,0,NULL,35388943416,552952240,8639878,16.37),(13985,'IRAS','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13985,34.72,0.8,87.7,2976,75,NULL,'MAT, I','IC 1630',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'15.13',0.5,'Sb pec sp','Group member',NULL,NULL,NULL,1,17.069875,-46.75403,NULL,NULL,38141750998,595964859,9311950,15.13),(13986,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13986,34.62,0.43,84.1,2976,75,NULL,'MAT, I, raw','IC 1630',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13987,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13987,34.7,0.32,87.2,2976,85,NULL,'I, raw','IC 1630',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13988,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13988,34.74,0.32,88.7,2976,85,NULL,'I, inv','IC 1630',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13989,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13989,34.81,0.43,91.4,2976,75,NULL,'MAT, I, inv','IC 1630',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13990,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13990,34.95,0.43,97.8,2976,75,NULL,'MAT, I, cor','IC 1630',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13991,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13991,35.01,0.12,101,2976,NULL,NULL,NULL,'IC 1630',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13992,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13992,35.26,0.49,113,2976,75,NULL,'IR','IC 1630',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13993,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',13993,38.09,0.46,415,2977,70,NULL,NULL,'2MASX J01081714-0002454',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000087,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,17.071417,-0.04603,0.107,NULL,34498188942,539034202,8422409,16.8),(13994,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,13994,29.57,NULL,8.2,2978,NULL,NULL,NULL,'AM 0106-382',NULL,'2013AJ....145..101K',2013,1,0.73,NULL,'G',0.000033,NULL,'16.6B',0.41,'dwarf Im',NULL,NULL,NULL,NULL,1,17.091375,-38.20958,NULL,NULL,38337511051,599023610,9359743,16.6),(13995,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2005fr',NULL,13995,40.33,0.13,902,2979,74.2,NULL,'SALT 2','SDSS J010821.96-000546.6',0.29,'2010ApJ...716..712A',2010,1,0.05,NULL,'G',0.005,NULL,'22.4g',0.02,NULL,NULL,NULL,NULL,NULL,1,17.0915416667,-0.09628,0.107,NULL,34498193957,539034280,8422410,22.4),(13996,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2005fr',NULL,13996,40.42,0.04,942,2979,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 02165, SN 2005fr','SDSS J010821.96-000546.6',0.29,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13997,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2005fr',NULL,13997,40.45,0.13,1230,2979,70,NULL,'Hubble residual 0.32 for z0.28800','SDSS J010821.96-000546.6',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13998,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2005fr',NULL,13998,41.09,0.12,1280,2979,65,NULL,'SALT2','SDSS J010821.96-000546.6',0.29,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13999,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 02165','R',13999,41.13,0.23,1310,2979,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fr','SDSS J010821.96-000546.6',0.288,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14000,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2005fr',NULL,14000,41.16,0.15,1320,2979,70,NULL,'SDSS-II SN 02165, SALT 2','SDSS J010821.96-000546.6',0.29,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14001,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2005fr',NULL,14001,41.21,NULL,1350,2979,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 02165, SN 2005fr','SDSS J010821.96-000546.6',0.29,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14002,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2005fr',NULL,14002,41.24,0.11,1370,2979,65,NULL,'MLCS2k2','SDSS J010821.96-000546.6',0.29,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14003,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 02165','R',14003,41.26,0.14,1380,2979,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fr','SDSS J010821.96-000546.6',0.288,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14004,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14004,35.02,0.07,101,2980,NULL,NULL,NULL,'ESO 243- G 038',NULL,'2009ApJS..182..474S',2009,1,0.92,NULL,'G',0.000033,NULL,'15.11',0.44,'Sa             LLAGN','Group member',NULL,NULL,NULL,1,17.095625,-47.09878,NULL,NULL,38141512121,595961126,9311892,15.11),(14005,'D-Sigma','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14005,33.98,0.4,62.5,2981,75,NULL,'Edat, raw','NGC 0392',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000087,NULL,'13.68',0.9,'S0-:','in a triple',NULL,NULL,NULL,1,17.09775,33.13361,0.181,NULL,67262895424,1050982741,16421605,13.68),(14006,'D-Sigma','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14006,34.08,0.4,65.6,2981,75,NULL,'Edat, cor','NGC 0392',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14007,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14007,34.2,0.23,69.2,2981,74.4,NULL,NULL,'NGC 0392',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14008,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14008,34.1,0.4,66.2,2981,NULL,NULL,'mean','NGC 0392',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14009,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14009,34.75,0.45,89.2,2981,NULL,NULL,'K','NGC 0392',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14010,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14010,34.99,0.65,99.7,2982,NULL,NULL,'Malmquist cor.','ESO 475- G 012',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.91',0.7,'Sc',NULL,NULL,NULL,NULL,1,17.1043333333,-23.50528,0.069,NULL,35205079958,550079374,8594990,14.91),(14011,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14011,35.18,0.6,109,2982,NULL,NULL,NULL,'ESO 475- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14012,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14012,35.22,0.2,111,2982,74.4,NULL,NULL,'ESO 475- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14013,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14013,37.19,0.46,274,2983,70,NULL,NULL,'2MASX J01082541-0838156',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000079,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,17.1057083,-8.63778,0.23,NULL,35259599520,550931242,8608300,18),(14014,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14014,34.14,0.23,67.3,2984,74.4,NULL,NULL,'NGC 0394',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000077,NULL,'14.8',0.2,'S0','in a triple',NULL,NULL,NULL,1,17.1085417,33.14797,0.181,NULL,67262896036,1050982750,16421605,14.8),(14015,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14015,37.27,0.46,285,2985,70,NULL,NULL,'2MASX J01082617-0919016',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000077,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,17.109083,-9.31711,0.176,NULL,35261669480,550963585,8608806,17.3),(14016,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14016,37.12,0.59,266,2986,70,NULL,NULL,'2MASX J01083062-1457047',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.7',0.2,'S0','Group member',NULL,NULL,NULL,1,17.127583,-14.95133,0.02,NULL,35431683315,553620051,8650313,14.7),(14017,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14017,33.99,0.23,62.8,2987,74.4,NULL,NULL,'NGC 0397',NULL,'2013AJ....146...86T',2013,1,0.2,NULL,'G',0.000077,NULL,'15.7',0.2,'E','in a triple',NULL,NULL,NULL,1,17.129583,33.10919,0.181,NULL,67262926133,1050983220,16421612,15.7),(14018,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14018,38.12,0.46,420,2988,70,NULL,NULL,'2MASX J01083169+0108521',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000101,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,17.1319583,1.14772,0.033,NULL,66648060807,1041375950,16271499,17.2),(14019,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14019,35.31,0.46,116,2989,70,NULL,NULL,'2MASX J01083209+1501227',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.00008,NULL,'15.6g',0.45,'E0',NULL,NULL,NULL,NULL,1,17.133625,15.02306,0.081,NULL,67643134242,1056923972,16514437,15.6),(14020,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 18034',NULL,14020,39.29,1.11,720,2990,70,NULL,'SN photometric redshift distance, z photo =0.185 +/- 0.149','SDSS-II SN 18034',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','21.0g',0.02,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,17.134667,-0.21833,0.086,NULL,34498410151,539037658,8422463,21),(14021,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14021,36.18,0.25,172,2991,74.4,NULL,NULL,'GIN 041',NULL,'2013AJ....146...86T',2013,1,0.43,NULL,'G',0.00004,NULL,'15.9V',0.36,'S','Group member',NULL,NULL,NULL,1,17.1459166667,2.16233,0.013,NULL,66649657387,1041400896,16271889,15.9),(14022,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14022,36.4,0.16,191,2991,70,NULL,NULL,'GIN 041',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14023,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14023,36.54,0.54,203,2992,70,NULL,NULL,'2MASX J01083559-1700468',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.63',0.35,NULL,NULL,NULL,NULL,NULL,1,17.148417,-17.01303,0.012,NULL,35419514503,553429914,8647342,16.63),(14024,'IRAS','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14024,31.95,0.8,24.6,2993,75,NULL,'A82, H','UGC 00711',NULL,'1997ApJS..109..333W',1997,1,4.65,NULL,'G',0.000003,NULL,'14.39',0.3,'SB(s)d? sp',NULL,NULL,NULL,NULL,1,17.15375,1.64167,0.021,NULL,66650099328,1041407802,16271996,14.39),(14025,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14025,31.34,NULL,18.5,2993,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00711',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14026,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14026,31.35,NULL,18.6,2993,NULL,NULL,'Dipole','UGC 00711',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14027,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14027,31.35,NULL,18.6,2993,NULL,NULL,'Dipole + Quadrupole','UGC 00711',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14028,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14028,31.57,0.2,20.6,2993,74.4,NULL,NULL,'UGC 00711',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14029,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14029,31.58,NULL,20.7,2993,NULL,NULL,NULL,'UGC 00711',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14030,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14030,31.73,0.43,22.2,2993,75,NULL,'3.6 micron, color corrected','UGC 00711',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14031,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14031,31.84,0.43,23.3,2993,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00711',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14032,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14032,31.86,0.4,23.6,2993,NULL,NULL,'Virgo cluster at 15.6 Mpc','UGC 00711',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14033,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14033,32.02,0.4,25.3,2993,75,NULL,'B','UGC 00711',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14034,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14034,32.13,0.38,26.7,2993,NULL,NULL,NULL,'UGC 00711',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14035,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14035,32.13,0.39,26.7,2993,73,NULL,'opt','UGC 00711',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14036,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14036,32.32,0.47,29.1,2993,75,NULL,'A82, H, inv','UGC 00711',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14037,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14037,32.41,0.47,30.4,2993,75,NULL,'A82, H, raw','UGC 00711',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14038,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14038,32.74,0.47,35.3,2993,75,NULL,'A82, H, cor','UGC 00711',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14039,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14039,36.2,0.25,174,2994,74.4,NULL,NULL,'CGCG 385-006',NULL,'2013AJ....146...86T',2013,1,0.25,NULL,'G',0.000037,NULL,'13.9V',0.22,'BrClG','Group member',NULL,NULL,NULL,1,17.15825,2.26886,0.013,NULL,66649704517,1041401633,16271900,13.9),(14040,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14040,36.4,0.16,191,2994,70,NULL,NULL,'CGCG 385-006',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14041,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14041,37.2,0.46,275,2995,70,NULL,NULL,'2MASX J01083802-0030067',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000095,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,17.158625,-0.50183,0.123,NULL,34499106105,539048532,8422633,16.8),(14042,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 13929','RN',14042,42.81,0.2,2420,2996,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13929',0.511671,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14043,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14043,36.39,0.64,189,2997,70,NULL,NULL,'2MASX J01083979-1529518',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00008,NULL,'15.7V',0.2,'S0','Group member',NULL,NULL,NULL,1,17.165875,-15.49778,0.02,NULL,35432178030,553627781,8650434,15.7),(14044,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14044,36.13,0.66,168,2998,70,NULL,NULL,'2MASX J01084013-1551168',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00014,NULL,'15.38',0.27,'S0','Group member',NULL,NULL,NULL,1,17.1672083,-15.85464,0.018,NULL,35432060890,553625951,8650405,15.38),(14045,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14045,37.18,0.46,273,2999,70,NULL,NULL,'2MASX J01084059+1451127',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000081,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,17.169,14.85361,0.081,NULL,67638697432,1056854647,16513353,17.2),(14046,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14046,37.8,0.46,363,3000,70,NULL,NULL,'2MASX J01084190-0917400',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000079,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,17.1747917,-9.29442,0.176,NULL,35254279398,550848115,8607001,17.2),(14047,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 13520','R',14047,40.43,0.24,960,3001,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13520',0.269329,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',NULL,'PHOT','20.9g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,17.175375,-0.01597,0.107,NULL,34498187004,539034171,8422408,20.9),(14048,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 13520','R',14048,40.58,0.16,1030,3001,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13520',0.269329,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14049,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 13520',NULL,14049,40.16,0.23,1080,3001,70,NULL,'SN photometric redshift distance, z photo =0.293 +/- 0.040','SDSS-II SN 13520',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14050,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 13520',NULL,14050,40.23,0.13,1110,3001,70,NULL,'SALT 2','SDSS-II SN 13520',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14051,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 13520',NULL,14051,40.25,0.13,1120,3001,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13520',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14052,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14052,36.2,0.25,174,3002,74.4,NULL,NULL,'GIN 040',NULL,'2013AJ....146...86T',2013,1,0.4,'Mislabeled as A150 E in Colless, et al. (1993,MNRAS,262,475).','G',0.000033,NULL,'15.5V',0.37,'SB0',NULL,NULL,NULL,NULL,1,17.180375,2.19214,0.013,NULL,66649681872,1041401279,16271894,15.5),(14053,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14053,36.4,0.16,191,3002,70,NULL,NULL,'GIN 040',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14054,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14054,36.04,0.49,162,3003,75,NULL,'IR','UGC 00710',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.000033,NULL,'15.28',0.5,'Sbc','Group member',NULL,NULL,NULL,1,17.1852083,33.46394,0.125,NULL,67748073901,1058563654,16540057,15.28),(14055,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14055,35.84,0.57,147,3004,70,NULL,NULL,'MCG -02-04-001',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15',0.6,NULL,NULL,NULL,NULL,NULL,1,17.189083,-11.81531,0.059,NULL,35375154554,552736789,8636512,15),(14056,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 14205','RN',14056,40.25,0.21,897,3005,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14205',0.253653,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14057,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 14205','RN',14057,40.55,0.15,1030,3005,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14205',0.253653,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14058,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14058,37.13,0.11,267,3006,70,NULL,NULL,'2MASX J01084601+1355417',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000073,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,17.1917083,13.92825,0.057,NULL,67641479986,1056898124,16514033,17.4),(14059,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14059,37.83,0.46,367,3007,70,NULL,NULL,'SDSS J010846.50-001719.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000081,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,17.1937917,-0.28864,0.086,NULL,34498362812,539036918,8422451,18.6),(14060,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14060,35.24,0.47,112,3008,NULL,NULL,'H','IC 0078',NULL,'2007A&A...465...71T',2007,1,1.7,'The position in 1999ApJS..120..147M is 9 arcsec north of the nucleus.','G',0.000047,NULL,'13.02',0.7,'SA(rs)a pec:   Sy2','Group member',NULL,NULL,NULL,1,17.19875,-15.84508,0.018,NULL,35432062519,553625976,8650405,13.02),(14061,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14061,35.38,0.45,119,3008,NULL,NULL,'K','IC 0078',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14062,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14062,35.43,0.46,122,3008,NULL,NULL,'J','IC 0078',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14063,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14063,36.06,0.4,163,3008,NULL,NULL,'mean','IC 0078',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14064,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2004hr',NULL,14064,41.21,0.34,1240,3009,74.2,NULL,'SALT 2','ESSENCE J010848.33+000049.5',0.409,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,17.201375,0.01375,0.107,NULL,66647507919,1041367311,16271364,NULL),(14065,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2004hr',NULL,14065,41.93,0.24,1730,3009,70,NULL,'SN k448, SALT','ESSENCE J010848.33+000049.5',0.409,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14066,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2004hr',NULL,14066,41.99,0.39,1770,3009,65,NULL,'SN k448, SALT2','ESSENCE J010848.33+000049.5',0.409,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14067,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2004hr',NULL,14067,42.02,0.21,1800,3009,65,NULL,'SN k448, SALT','ESSENCE J010848.33+000049.5',0.409,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14068,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2004hr',NULL,14068,42.1,0.39,1870,3009,65,NULL,'SN k448, SALT2','ESSENCE J010848.33+000049.5',0.409,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14069,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2004hr','R',14069,42.12,NULL,1880,3009,65,NULL,'SN k448, SALT','ESSENCE J010848.33+000049.5',0.409,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14070,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2004hr',NULL,14070,42.26,0.36,2010,3009,65,NULL,'SN k448, MLCS17','ESSENCE J010848.33+000049.5',0.409,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14071,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2004hr',NULL,14071,42.28,0.29,2030,3009,65,NULL,'SN k448, MLCS2k2','ESSENCE J010848.33+000049.5',0.409,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14072,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2004hr',NULL,14072,42.34,0.39,2090,3009,65,NULL,'SN k448, MLCS2k2','ESSENCE J010848.33+000049.5',0.409,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14073,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2004hr',NULL,14073,42.4,0.16,2150,3009,65,NULL,'SN k448, SALT','ESSENCE J010848.33+000049.5',0.409,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14074,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2006oj',NULL,14074,40.66,0.18,1350,3010,70,NULL,'Hubble residual 0.09 for z0.36700','SDSS J010849.30-005922.4',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,17.205,-0.9895,0.133,NULL,34498647113,539041361,8422521,NULL),(14075,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 16232','R',14075,41.55,0.26,1500,3010,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006oj','SDSS J010849.30-005922.4',0.367,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14076,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 16232','R',14076,41.72,0.26,1620,3010,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006oj','SDSS J010849.30-005922.4',0.367,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14077,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2006oj',NULL,14077,41.44,0.17,1940,3010,70,NULL,'SALT 2','SDSS J010849.30-005922.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14078,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2006oj',NULL,14078,41.5,0.17,2000,3010,70,NULL,'SALT 2, Malmquist cor.','SDSS J010849.30-005922.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14079,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14079,35.9,0.49,151,3011,70,NULL,NULL,'IC 0079',NULL,'2014MNRAS.445.2677S',2014,1,0.92,NULL,'G',0.00007,NULL,'14.87',0.46,'SA0-','Group member',NULL,NULL,NULL,1,17.207125,-15.94858,0.019,NULL,35432136427,553627131,8650423,14.87),(14080,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14080,36.3,0.4,182,3011,NULL,NULL,'mean','IC 0079',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14081,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14081,36.98,0.45,248,3011,NULL,NULL,'K','IC 0079',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14082,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003lf',NULL,14082,40.63,0.26,948,3012,74.2,NULL,'SALT 2','ESSENCE J010849.81-004413.5',0.41,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,17.2075416667,-0.73708,0.156,NULL,34498580168,539040315,8422504,NULL),(14083,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003lf','R',14083,40.84,NULL,1040,3012,65,NULL,'SN f076, MLCS17','ESSENCE J010849.81-004413.5',0.41,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14084,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003lf',NULL,14084,41.35,0.22,1320,3012,70,NULL,'SN f076, SALT','ESSENCE J010849.81-004413.5',0.41,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14085,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003lf',NULL,14085,41.37,0.29,1330,3012,65,NULL,'SN f076, MLCS17','ESSENCE J010849.81-004413.5',0.41,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14086,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003lf',NULL,14086,41.43,0.32,1370,3012,65,NULL,'SN f076, MLCS31','ESSENCE J010849.81-004413.5',0.41,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14087,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003lf',NULL,14087,41.48,0.19,1400,3012,65,NULL,'SN f076, SALT','ESSENCE J010849.81-004413.5',0.41,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14088,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003lf',NULL,14088,41.47,0.32,1400,3012,65,NULL,'SN f076, MLCS2k2','ESSENCE J010849.81-004413.5',0.41,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14089,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003lf',NULL,14089,41.54,0.29,1440,3012,65,NULL,'SN f076, SALT2','ESSENCE J010849.81-004413.5',0.41,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14090,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003lf',NULL,14090,41.65,0.09,1520,3012,65,NULL,'SN f076, SALT','ESSENCE J010849.81-004413.5',0.41,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14091,'BCG','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14091,36.67,0.35,205,3013,60,NULL,NULL,'ABELL 0151',0.0526,'1980ApJ...241..486H',1980,1,NULL,'Katgert (1996,A&A,310,8) identifies multiple redshift systems in this cluster.','GClstr',NULL,NULL,NULL,NULL,'II:    [BM]',NULL,NULL,NULL,NULL,1,17.20875,-15.41,0.02,NULL,35431736122,553620876,8650326,NULL),(14092,'Magnitude','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14092,35.91,0.13,152,3013,100,NULL,NULL,'ABELL 0151',NULL,'1998A&A...337...31R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14093,'BCG','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14093,36.67,0.35,205,3014,60,NULL,'ABELL 0151, BCG','IC 0080 NED01',0.0526,'1980ApJ...241..486H',1980,1,0.3,NULL,'G',0.00005,NULL,'15.8V',0.2,'D','Pair member (points to parent)',NULL,NULL,NULL,1,17.21125,-15.40894,0.02,NULL,35431736075,553620876,8650326,15.8),(14094,'Magnitude','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14094,35.91,0.13,152,3014,100,NULL,NULL,'IC 0080 NED01',NULL,'1998A&A...337...31R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14095,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14095,34.85,0.25,93.3,3015,74.4,NULL,NULL,'ESO 243- G 041',NULL,'2013AJ....146...86T',2013,1,1,'The APM position is for the eastern end of the galaxy.','G',0.000123,NULL,'14.43',0.3,'S0^0^: pec','Group member',NULL,NULL,NULL,1,17.2160417,-45.83267,NULL,NULL,38142455257,595975863,9312122,14.43),(14096,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 18768','R',14096,40.09,0.21,870,3016,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007lh','SN 2007lh',0.198,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,17.21675,1.19789,0.029,NULL,66650930810,1041420793,16272199,NULL),(14097,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 18768','R',14097,40.28,0.13,950,3016,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007lh','SN 2007lh',0.198,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14098,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 20272',NULL,14098,40.7,0.3,1380,3017,70,NULL,'SN photometric redshift distance, z photo =0.397 +/- 0.078','SDSS-II SN 20272',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,17.218333,-0.02122,0.1,NULL,34498363555,539036930,8422452,NULL),(14099,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 20272',NULL,14099,41.83,0.2,2320,3017,70,NULL,'SALT 2','SDSS-II SN 20272',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14100,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 20272',NULL,14100,41.9,0.2,2400,3017,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20272',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14101,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14101,37.03,0.62,254,3018,70,NULL,NULL,'2MASX J01085249-0039187',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.000107,NULL,'17.26',0.37,NULL,NULL,NULL,NULL,NULL,1,17.2186666667,-0.65539,0.123,NULL,34499099326,539048426,8422631,17.26),(14102,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14102,33.2,0.23,43.7,3019,74.4,NULL,NULL,'NGC 0398',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000093,NULL,'15.4',0.2,'S0',NULL,NULL,NULL,NULL,1,17.223625,32.51453,0.181,NULL,67273884264,1051154441,16424288,15.4),(14103,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','ESSENCE m138','R',14103,41.68,NULL,1370,3020,65,NULL,'SALT','ESSENCE m138 HOST',0.587,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,17.2347917,0.65706,0.065,NULL,66648377925,1041380905,16271576,NULL),(14104,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','ESSENCE m138',NULL,14104,42.82,0.19,2300,3020,65,NULL,'MLCS2k2','ESSENCE m138 HOST',0.587,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14105,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','ESSENCE m138',NULL,14105,42.97,0.39,2470,3020,74.2,NULL,'SALT 2','ESSENCE m138 HOST',0.587,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14106,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','ESSENCE m138',NULL,14106,43.6,0.38,3310,3020,70,NULL,'SALT','ESSENCE m138 HOST',0.587,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14107,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','ESSENCE m138',NULL,14107,43.66,0.15,3400,3020,65,NULL,'SALT','ESSENCE m138 HOST',0.587,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14108,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','ESSENCE m138',NULL,14108,43.87,0.36,3750,3020,65,NULL,'SALT','ESSENCE m138 HOST',0.587,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14109,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14109,37.42,0.46,305,3021,70,NULL,NULL,'SDSS J010857.58-000026.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000074,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,17.2399583,-0.00739,0.1,NULL,34498298031,539035906,8422436,18.2),(14110,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14110,36.41,0.54,192,3022,70,NULL,NULL,'2MASX J01085835-8235410',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,17.243125,-82.59478,0.417,NULL,35483433091,554428642,8662947,15.8),(14111,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 1999dv',NULL,14111,38.99,0.2,529,3023,74.2,NULL,'SALT 2','SCP J010858.96+000024.8',0.187,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,17.245667,0.00689,0.107,NULL,66647589820,1041368590,16271384,NULL),(14112,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 1999dv',NULL,14112,39.81,0.18,772,3023,NULL,NULL,'M(B) = -19.31','SCP J010858.96+000024.8',0.187,'2008A&A...486..375A',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14113,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14113,36.19,0.46,173,3024,70,NULL,NULL,'2MASX J01085960+1520210',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000106,NULL,'15.9g',0.39,'E0',NULL,NULL,NULL,NULL,1,17.2482917,15.33919,0.137,NULL,67643291979,1056926437,16514475,15.9),(14114,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14114,35.27,0.5,113,3025,NULL,NULL,'Malmquist cor.','ESO 243- G 044',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.00015,NULL,'15.39',0.6,'(R\'_1)SB(rs)b','Pair member (points to parent)',NULL,NULL,NULL,1,17.250083,-45.34803,NULL,NULL,38139585918,595931029,9311422,15.39),(14115,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14115,35.41,0.46,121,3025,NULL,NULL,NULL,'ESO 243- G 044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14116,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14116,35.45,0.2,123,3025,74.4,NULL,NULL,'ESO 243- G 044',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14117,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14117,35.44,NULL,122,3026,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0125',NULL,'2010Ap&SS.325..163P',2010,1,0.83,NULL,'G',NULL,NULL,'17.16',0.11,'Scd',NULL,NULL,NULL,NULL,1,17.2514583,33.52314,0.125,NULL,67748092532,1058563945,16540061,17.16),(14118,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14118,35.44,NULL,123,3026,NULL,NULL,'Dipole + Quadrupole','FGC 0125',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14119,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14119,35.45,NULL,123,3026,NULL,NULL,'Dipole','FGC 0125',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14120,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14120,36.33,0.41,185,3026,NULL,NULL,'Malmquist cor.','FGC 0125',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14121,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14121,36.38,0.4,188,3026,NULL,NULL,NULL,'FGC 0125',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14122,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14122,36.48,0.2,198,3026,74.4,NULL,NULL,'FGC 0125',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14123,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14123,36.82,0.43,232,3026,75,NULL,'3.6 micron, color corrected','FGC 0125',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14124,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14124,37.26,0.43,283,3026,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0125',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14125,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14125,34.62,0.47,83.8,3027,NULL,NULL,'H','ESO 296- G 002',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000027,NULL,'14.25',1,'(R\'_1)SB(r)ab  HII',NULL,NULL,NULL,NULL,1,17.261,-37.28889,NULL,NULL,38339178427,599049662,9360150,14.25),(14126,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14126,34.78,0.46,90.2,3027,NULL,NULL,'J','ESO 296- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14127,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14127,34.79,0.45,90.7,3027,NULL,NULL,'K','ESO 296- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14128,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14128,34.8,0.4,91.3,3027,NULL,NULL,'mean','ESO 296- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14129,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14129,34.57,0.25,82,3028,74.4,NULL,NULL,'ESO 243- G 045',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.00009,NULL,'13.39',1.2,'S0-','Group member',NULL,NULL,NULL,1,17.2689583,-45.77353,NULL,NULL,38142237577,595972462,9312069,13.39),(14130,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 01158','R',14130,40.59,0.39,928,3029,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01158',0.411625,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',NULL,'PHOT','20.6g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,17.276167,-0.35178,0.123,NULL,34499019181,539047174,8422612,20.6),(14131,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 01158','R',14131,41.07,0.39,1160,3029,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01158',0.411625,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14132,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 01158',NULL,14132,41.58,0.01,2070,3029,70,NULL,'SN photometric redshift distance, z photo =0.694 +/- 0.006','SDSS-II SN 01158',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14133,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14133,36.61,0.56,210,3030,70,NULL,NULL,'2MASX J01090879-5344313',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.44',0.43,NULL,NULL,NULL,NULL,NULL,1,17.28675,-53.742,NULL,NULL,36189950314,565467973,8835437,16.44),(14134,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14134,37.15,0.46,269,3031,70,NULL,NULL,'2MASX J01091017-1055150',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000067,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,17.29225,-10.92094,0.072,NULL,35253464952,550835389,8606802,17.8),(14135,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14135,37.87,0.33,375,3032,70,NULL,NULL,'2MASX J01091037-0025083',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00009,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,17.293083,-0.41911,0.123,NULL,34499148901,539049201,8422643,17.4),(14136,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 13155','RN',14136,40.56,0.22,1170,3033,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13155',0.103273,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14137,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 13155','RN',14137,41.04,0.4,1460,3033,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13155',0.103273,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14138,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14138,34.27,0.23,71.5,3034,74.4,NULL,NULL,'CGCG 501-102',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000033,NULL,'15.3',0.4,'E',NULL,NULL,NULL,NULL,1,17.3062083,31.97944,0.181,NULL,67274329291,1051161395,16424396,15.3),(14139,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14139,37.87,0.33,375,3035,70,NULL,NULL,'2MASX J01091357-0025533',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000074,NULL,'17.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,17.3065417,-0.43144,0.123,NULL,34499149183,539049205,8422643,17.5),(14140,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14140,37.41,0.46,304,3036,70,NULL,NULL,'2MASX J01091390-0051043',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000083,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,17.307917,-0.85125,0.133,NULL,34498502207,539039096,8422485,17.5),(14141,'IRAS','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14141,33.8,0.8,57.6,3037,75,NULL,'W91PP, r','UGC 00714',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'14.35',0.9,'SAc','in a radial-velocity based grouping',NULL,NULL,NULL,1,17.3084583,32.15133,0.165,NULL,67274503838,1051164122,16424439,14.35),(14142,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14142,33.54,0.43,51.2,3037,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00714',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14143,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14143,33.64,0.43,53.4,3037,75,NULL,'3.6 micron, color corrected','UGC 00714',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14144,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14144,33.75,0.2,56.2,3037,74.4,NULL,NULL,'UGC 00714',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14145,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14145,33.8,0.38,57.5,3037,75,NULL,'W91PP, r, raw','UGC 00714',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14146,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14146,33.88,0.38,59.7,3037,75,NULL,'W91PP, r, inv','UGC 00714',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14147,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14147,34.02,0.38,63.8,3037,75,NULL,'W91PP, r, cor','UGC 00714',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14148,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14148,34.06,0.4,65,3037,NULL,NULL,'mean','UGC 00714',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14149,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14149,34.22,0.08,70,3037,NULL,NULL,NULL,'UGC 00714',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14150,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14150,34.52,0.47,80.1,3037,NULL,NULL,'H','UGC 00714',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14151,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','ESSENCE m027',NULL,14151,40.48,0.26,968,3038,74.2,NULL,'SALT 2','ESSENCE m027 HOST',0.289,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,17.3125417,0.13744,0.107,NULL,66647608364,1041368880,16271388,NULL),(14152,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','ESSENCE m027','R',14152,41.28,NULL,1400,3038,65,NULL,'SALT2','ESSENCE m027 HOST',0.289,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14153,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','ESSENCE m027',NULL,14153,41.37,0.31,1450,3038,65,NULL,'SALT2','ESSENCE m027 HOST',0.289,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14154,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','ESSENCE m027',NULL,14154,41.37,0.31,1460,3038,65,NULL,'SALT2','ESSENCE m027 HOST',0.289,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14155,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','ESSENCE m027',NULL,14155,41.39,0.33,1470,3038,70,NULL,'SALT','ESSENCE m027 HOST',0.289,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14156,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','ESSENCE m027',NULL,14156,41.41,0.3,1490,3038,65,NULL,'MLCS31','ESSENCE m027 HOST',0.289,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14157,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','ESSENCE m027',NULL,14157,41.44,0.28,1510,3038,65,NULL,'MLCS17','ESSENCE m027 HOST',0.289,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14158,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','ESSENCE m027',NULL,14158,41.47,0.23,1530,3038,65,NULL,'MLCS2k2','ESSENCE m027 HOST',0.289,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14159,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','ESSENCE m027',NULL,14159,41.49,0.35,1540,3038,65,NULL,'SALT','ESSENCE m027 HOST',0.289,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14160,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','ESSENCE m027',NULL,14160,41.53,0.31,1570,3038,65,NULL,'MLCS2k2','ESSENCE m027 HOST',0.289,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14161,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','ESSENCE m027',NULL,14161,41.86,0.2,1830,3038,65,NULL,'SALT','ESSENCE m027 HOST',0.289,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14162,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14162,35.27,0.5,113,3039,NULL,NULL,NULL,'AGC 410650',NULL,'2009ApJS..182..474S',2009,1,0.73,NULL,'G',0.000027,NULL,'16.19',0.28,'Irr',NULL,NULL,NULL,NULL,1,17.31675,-46.30572,NULL,NULL,38141276943,595957452,9311835,16.19),(14163,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14163,35.31,0.2,115,3039,74.4,NULL,NULL,'AGC 410650',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14164,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14164,35.32,0.49,116,3039,NULL,NULL,'Malmquist cor.','AGC 410650',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14165,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14165,36.4,0.16,191,3040,70,NULL,NULL,'UGC 00720 NED01',NULL,'2001MNRAS.321..277C',2001,1,1.4,'1999ApJS..121..287H has V = 12841 +- 32 km/sec.','G',0.000037,NULL,'14.09',0.9,'E/S0;BrClG','Group member',NULL,NULL,NULL,1,17.325333,2.20439,0.017,NULL,66649787937,1041402936,16271920,14.09),(14166,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14166,36.19,0.25,173,3041,74.4,NULL,NULL,'UGC 00720',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'GPair',NULL,NULL,NULL,NULL,'DBL SYS',NULL,NULL,NULL,NULL,1,17.327083,2.20083,0.017,NULL,66649784599,1041402884,16271920,NULL),(14167,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14167,34.8,0.25,91.2,3042,74.4,NULL,NULL,'2MASX J01092051-4540559',NULL,'2013AJ....146...86T',2013,1,0.53,NULL,'G',0.00008,NULL,'16.18',0.37,'S0','Group member',NULL,NULL,NULL,1,17.3355,-45.68222,NULL,NULL,38142244230,595972566,9312071,16.18),(14168,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14168,35.69,0.77,137,3042,70,NULL,NULL,'2MASX J01092051-4540559',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14169,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14169,35.64,0.2,134,3043,74.4,NULL,NULL,'UGC 00717',NULL,'2013AJ....146...86T',2013,1,1.71,NULL,'G',0.000097,NULL,'14.4g',0.59,'SBb            AGN',NULL,NULL,NULL,NULL,1,17.341625,14.34231,0.085,NULL,67640650779,1056885168,16513830,14.4),(14170,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14170,34.67,0.53,86,3044,70,NULL,NULL,'IC 0081',NULL,'2014MNRAS.445.2677S',2014,1,0.9,'The APM image includes a neighboring star.','G',0.000077,NULL,'14.8',0.8,NULL,NULL,NULL,NULL,NULL,1,17.34275,-1.69586,0.201,NULL,34499901218,539060956,8422827,14.8),(14171,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14171,34.93,0.47,96.8,3045,70,NULL,NULL,'2MASX J01092285-4639430',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00014,NULL,'15.43',0.48,'S0','Group member',NULL,NULL,NULL,1,17.345083,-46.66192,NULL,NULL,38141737452,595964647,9311947,15.43),(14172,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14172,35.41,0.51,121,3046,70,NULL,NULL,'2MASX J01092522-1621491',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.50',0.49,NULL,NULL,NULL,NULL,NULL,1,17.35525,-16.36367,0.041,NULL,35418075091,553407423,8646990,16.5),(14173,'CMD','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14173,27.48,0.09,3.13,3047,NULL,NULL,NULL,'NGC 0404',NULL,'2010ApJ...716...71W',2010,1,3.5,NULL,'G',0.00003,NULL,'11.21',3.5,'SA(s)0-:       LINER','Isolated galaxy',NULL,NULL,'LINER',1,17.362583,35.71814,0.221,NULL,67749862312,1058591598,16540493,11.21),(14174,'SBF','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14174,27.38,0.07,3,3047,74.4,NULL,NULL,'NGC 0404',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14175,'SBF','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14175,27.41,0.1,3.03,3047,NULL,NULL,'I','NGC 0404',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14176,'SBF','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14176,27.57,0.1,3.27,3047,NULL,NULL,'I','NGC 0404',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14177,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14177,27.38,0.07,3,3047,74.4,NULL,NULL,'NGC 0404',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14178,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14178,27.42,0.03,3.05,3047,NULL,NULL,'I','NGC 0404',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14179,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14179,27.43,0.25,3.06,3047,NULL,NULL,NULL,'NGC 0404',NULL,'2002A&A...389..812K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14180,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14180,27.67,0.15,3.42,3047,NULL,NULL,NULL,'NGC 0404',NULL,'2003A&A...401..863T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14181,'Faber-Jackson','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14181,26.64,NULL,2.13,3047,NULL,NULL,'LEDA [April 2006]','NGC 0404',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14182,'Faber-Jackson','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14182,27.97,0.65,3.93,3047,95,NULL,'Weighted Mean','NGC 0404',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14183,'Faber-Jackson','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14183,28.48,0.81,4.97,3047,55,NULL,'Visvanathan & Sandage 1979','NGC 0404',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14184,'Radio Brightness','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14184,30,NULL,10,3047,NULL,NULL,NULL,'NGC 0404',NULL,'1990A&A...227..394W',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14185,'Tully est','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14185,26.95,0.8,2.4,3047,75,NULL,'B','NGC 0404',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14186,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14186,37.13,0.11,267,3048,70,NULL,NULL,'2MASX J01092719+1415359',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000106,NULL,'16.1g',0.34,'E0',NULL,NULL,NULL,NULL,1,17.3632917,14.26006,0.085,NULL,67640686106,1056885720,16513839,16.1),(14187,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14187,37.7,0.46,346,3049,70,NULL,NULL,'2MASX J01092916+1329115',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000091,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,17.371333,13.48642,0.053,NULL,67641290345,1056895161,16513986,17.1),(14188,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14188,34.94,0.4,97.2,3050,NULL,NULL,NULL,'ESO 195- G 032',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000033,NULL,'15.43',0.64,'SAB(rs)dm',NULL,NULL,NULL,NULL,1,17.3831666667,-47.79189,NULL,NULL,38149415236,596084613,9313822,15.43),(14189,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14189,34.98,0.2,99.1,3050,74.4,NULL,NULL,'ESO 195- G 032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14190,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14190,35,0.39,99.8,3050,NULL,NULL,'Malmquist cor.','ESO 195- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14191,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14191,37.54,0.46,322,3051,70,NULL,NULL,'2MASX J01093312-1013117',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000078,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,17.3879583,-10.22,0.107,NULL,35254860563,550857196,8607143,16.9),(14192,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14192,34.92,0.46,96.4,3052,70,NULL,NULL,'NGC 0409',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000103,NULL,'14.26',1.1,'E:',NULL,NULL,NULL,NULL,1,17.3884166667,-35.80561,NULL,NULL,38272557203,598008706,9343886,14.26),(14193,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2006hc',NULL,14193,34.23,0.25,58.5,3053,65,NULL,'MLCS31','SDSS J010934.73+004214.9',0.2,'2009ApJ...700.1097H',2009,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,17.3947083333,0.70414,0.029,NULL,66648305260,1041379769,16271558,NULL),(14194,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2006hc',NULL,14194,34.26,0.24,59.2,3053,65,NULL,'MLCS17','SDSS J010934.73+004214.9',0.2,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14195,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 13578','R',14195,40.17,0.21,878,3053,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006hc','SDSS J010934.73+004214.9',0.229,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14196,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2006hc',NULL,14196,39.8,0.1,912,3053,70,NULL,'Hubble residual 0.10 for z0.22900','SDSS J010934.73+004214.9',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14197,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 13578','R',14197,40.42,0.12,986,3053,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006hc','SDSS J010934.73+004214.9',0.229,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14198,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 14206',NULL,14198,40.1,0.22,1050,3053,70,NULL,'SN photometric redshift distance, z photo =0.283 +/- 0.037','SDSS J010934.73+004214.9',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14199,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14199,37.66,0.46,340,3054,70,NULL,NULL,'GALEXMSC J010934.91+001935.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.77',0.18,NULL,NULL,NULL,NULL,NULL,1,17.39575,0.32647,0.111,NULL,66648453072,1041382079,16271594,18.77),(14200,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14200,34.52,0.25,80.2,3055,74.4,NULL,NULL,'2MASX J01093552-4603160',NULL,'2013AJ....146...86T',2013,1,0.43,NULL,'G',0.000147,NULL,'16.37',0.32,'S','Group member',NULL,NULL,NULL,1,17.3979583,-46.0545,NULL,NULL,38142250918,595972670,9312072,16.37),(14201,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 13559','RN',14201,43.09,0.31,2610,3056,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13559',0.58709,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14202,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14202,36.85,0.8,235,3057,70,NULL,NULL,'2MASX J01093705-1108087',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.91',0.31,NULL,NULL,NULL,NULL,NULL,1,17.404375,-11.13572,0.072,NULL,35253957081,550843079,8606923,16.91),(14203,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14203,35.41,0.25,121,3058,74.4,NULL,NULL,'2MASX J01093781-4553520',NULL,'2013AJ....146...86T',2013,1,0.55,NULL,'G',0.000207,NULL,'15.70',0.48,'S0','Group member',NULL,NULL,NULL,1,17.4074583,-45.89769,NULL,NULL,38142264921,595972889,9312076,15.7),(14204,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14204,37.13,0.11,267,3059,70,NULL,NULL,'2MASX J01093827+1355095',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000113,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,17.4095,13.91922,0.053,NULL,67641393616,1056896775,16514012,17.1),(14205,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14205,34.44,0.62,77.2,3060,70,NULL,NULL,'ESO 113- G 018',NULL,'2014MNRAS.445.2677S',2014,1,1.24,NULL,'G',0.000107,NULL,'15.17',0.31,'S0-a',NULL,NULL,NULL,NULL,1,17.4128333333,-61.33325,0,NULL,36181710629,565339228,8833425,15.17),(14206,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14206,35.3,0.25,115,3061,74.4,NULL,NULL,'2MASX J01093965-4559310',NULL,'2013AJ....146...86T',2013,1,0.31,NULL,'G',0.00015,NULL,'17.30',0.24,NULL,NULL,NULL,NULL,NULL,1,17.415333,-45.99189,NULL,NULL,38142263146,595972861,9312075,17.3),(14207,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14207,36.31,0.54,183,3061,70,NULL,NULL,'2MASX J01093965-4559310',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14208,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14208,34.83,0.1,92.7,3062,NULL,NULL,NULL,'AGC 410684',NULL,'2009ApJS..182..474S',2009,1,0.61,NULL,'G',0.000023,NULL,'17.36',0.15,'Sc',NULL,NULL,NULL,NULL,1,17.417083,-45.65208,NULL,NULL,38139370453,595927663,9311369,17.36),(14209,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14209,32.43,0.43,30.6,3063,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-04-005',NULL,'2014MNRAS.444..527S',2014,1,1.4,NULL,'G',0.000017,NULL,'15.5',0.7,'IB(s)m:',NULL,NULL,NULL,NULL,1,17.42275,-2.26647,0.155,NULL,34499315897,539051810,8422684,15.5),(14210,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14210,37.13,0.11,267,3064,70,NULL,NULL,'2MASX J01094343+1406365',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000076,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,17.431083,14.11031,0.081,NULL,67641348682,1056896073,16514001,17.3),(14211,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14211,36.6,0.23,209,3065,70,NULL,NULL,'2MASX J01094725+0010102',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00007,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,17.446833,0.16958,0.111,NULL,66648416967,1041381515,16271586,17),(14212,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14212,34.61,0.25,83.6,3066,74.4,NULL,NULL,'2MASX J01094729-4552409',NULL,'2013AJ....146...86T',2013,1,0.31,NULL,'G',0.000257,NULL,'17.31',0.23,'E','Group member',NULL,NULL,NULL,1,17.447167,-45.878,NULL,NULL,38142278234,595973097,9312079,17.31),(14213,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 02149',NULL,14213,40.1,0.23,1050,3067,70,NULL,'SN photometric redshift distance, z photo =0.284 +/- 0.038','SDSS-II SN 02149',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.3g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,17.447125,-0.58881,0.136,NULL,34498987701,539046682,8422604,21.3),(14214,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 02149','R',14214,41.23,0.25,1360,3067,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02149',0.295639,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14215,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 02149','R',14215,41.41,0.21,1480,3067,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 02149',0.295639,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14216,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 02149',NULL,14216,41.14,0.15,1690,3067,70,NULL,'SALT 2','SDSS-II SN 02149',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14217,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 02149',NULL,14217,41.16,0.15,1710,3067,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 02149',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14218,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14218,37.13,0.11,267,3068,70,NULL,NULL,'2MASX J01094805+1425525',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000088,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,17.4502917,14.43139,0.081,NULL,67638773365,1056855833,16513372,17.1),(14219,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003kl',NULL,14219,40.54,0.24,961,3069,74.2,NULL,'SALT 2','ESSENCE J010948.80+010005.6',0.335,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,17.453333,1.00156,0.033,NULL,66651014302,1041422098,16272220,NULL),(14220,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003kl','R',14220,41.18,NULL,1290,3069,65,NULL,'SN e029, SALT2','ESSENCE J010948.80+010005.6',0.335,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14221,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003kl',NULL,14221,41.24,0.22,1330,3069,70,NULL,'SN e029, SALT','ESSENCE J010948.80+010005.6',0.335,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14222,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003kl',NULL,14222,41.29,0.31,1360,3069,65,NULL,'SN e029, SALT2','ESSENCE J010948.80+010005.6',0.335,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14223,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003kl',NULL,14223,41.35,0.19,1390,3069,65,NULL,'SN e029, SALT','ESSENCE J010948.80+010005.6',0.335,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14224,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003kl',NULL,14224,41.44,0.28,1460,3069,65,NULL,'SN e029, SALT2','ESSENCE J010948.80+010005.6',0.335,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14225,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003kl',NULL,14225,41.48,0.29,1480,3069,65,NULL,'SN e029, MLCS17','ESSENCE J010948.80+010005.6',0.335,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14226,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003kl',NULL,14226,41.5,0.25,1500,3069,65,NULL,'SN e029, MLCS31','ESSENCE J010948.80+010005.6',0.335,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14227,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003kl',NULL,14227,41.51,0.26,1500,3069,65,NULL,'SN e029, MLCS2k2','ESSENCE J010948.80+010005.6',0.335,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14228,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003kl',NULL,14228,41.59,0.09,1560,3069,65,NULL,'SN e029, SALT','ESSENCE J010948.80+010005.6',0.335,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14229,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SN 2003kl',NULL,14229,41.61,0.22,1570,3069,65,NULL,'SN e029, MLCS2k2','ESSENCE J010948.80+010005.6',0.335,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14230,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14230,35.66,0.14,135,3070,70,NULL,NULL,'ABELL 2877b',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',0.00016,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,17.455417,-45.90061,NULL,NULL,38142277884,595973091,9312079,NULL),(14231,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14231,35.3,0.25,115,3071,74.4,NULL,NULL,'2MASX J01094979-4612249',NULL,'2013AJ....146...86T',2013,1,0.46,NULL,'G',0.000077,NULL,'16.68',0.3,'S0','Group member',NULL,NULL,NULL,1,17.457625,-46.20686,NULL,NULL,38141398216,595959347,9311864,16.68),(14232,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14232,37.13,0.11,267,3072,70,NULL,NULL,'2MASX J01094998+1425195',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,'FoF','15.9r',NULL,NULL,NULL,NULL,NULL,NULL,1,17.45825,14.42225,0.081,NULL,67638773608,1056855837,16513372,15.9),(14233,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 02293','RN',14233,41.56,0.12,1540,3073,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 02293',0.331762,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14234,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 02293','RN',14234,41.82,0.2,1730,3073,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02293',0.331762,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14235,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14235,34.98,0.08,99.3,3074,NULL,NULL,NULL,'2MASX J01095135-4614143',NULL,'2009ApJS..182..474S',2009,1,0.62,NULL,'G',0.000027,NULL,'15.93',0.35,'Sc','Group member',NULL,NULL,NULL,1,17.463917,-46.23725,NULL,NULL,38141409809,595959528,9311867,15.93),(14236,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','ESSENCE m062',NULL,14236,40.52,0.24,967,3075,74.2,NULL,'SALT 2','ESSENCE m062 HOST',0.314,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,17.470417,0.60528,0.057,NULL,66648339833,1041380309,16271567,NULL),(14237,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','ESSENCE m062','R',14237,40.56,NULL,987,3075,65,NULL,'MLCS17','ESSENCE m062 HOST',0.314,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14238,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 03825',NULL,14238,40.11,0.58,1050,3075,70,NULL,'SN photometric redshift distance, z photo =0.285 +/- 0.109','ESSENCE m062 HOST',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14239,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 03825','R',14239,40.96,0.35,1180,3075,70,NULL,'SDSS CAND. zSNIa; SALT 2','ESSENCE m062 HOST',0.314,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14240,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','ESSENCE m062',NULL,14240,41.02,0.29,1220,3075,70,NULL,'SALT','ESSENCE m062 HOST',0.314,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14241,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 03825','R',14241,41.1,0.33,1260,3075,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','ESSENCE m062 HOST',0.314,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14242,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','ESSENCE m062',NULL,14242,41.17,0.26,1300,3075,65,NULL,'SALT','ESSENCE m062 HOST',0.314,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14243,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','ESSENCE m062',NULL,14243,41.18,0.31,1310,3075,65,NULL,'MLCS17','ESSENCE m062 HOST',0.314,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14244,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','ESSENCE m062',NULL,14244,41.27,0.17,1370,3075,65,NULL,'SALT','ESSENCE m062 HOST',0.314,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14245,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','ESSENCE m062',NULL,14245,41.28,0.25,1370,3075,65,NULL,'MLCS2k2','ESSENCE m062 HOST',0.314,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14246,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 03825',NULL,14246,40.8,0.24,1450,3075,70,NULL,'SALT 2','ESSENCE m062 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14247,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 03825',NULL,14247,40.83,0.24,1470,3075,70,NULL,'SALT 2, Malmquist cor.','ESSENCE m062 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14248,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','ESSENCE m062',NULL,14248,41.43,0.28,1470,3075,65,NULL,'SALT2','ESSENCE m062 HOST',0.314,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14249,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14249,37.13,0.11,267,3076,70,NULL,NULL,'2MASX J01095436+1407225',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000069,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,17.476417,14.12286,0.081,NULL,67640633179,1056884893,16513826,17.4),(14250,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14250,34.84,0.25,92.9,3077,74.4,NULL,NULL,'IC 1633',NULL,'2013AJ....146...86T',2013,1,2.9,'The APM position is northeast of the center of the galaxy.','G',0.000044,NULL,'12.48',2.4,'cD;E+1','Group member',NULL,NULL,NULL,1,17.4815833333,-45.93119,NULL,NULL,38142252165,595972690,9312073,12.48),(14251,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14251,34.55,0.45,81.4,3077,NULL,NULL,'K','IC 1633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14252,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14252,34.9,0.4,95.6,3077,NULL,NULL,'mean','IC 1633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14253,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14253,35,0.15,99.9,3077,70,NULL,'ABELL 2877, BGC','IC 1633',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14254,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14254,33.68,0.49,54.5,3078,75,NULL,'IR','UGC 00723',NULL,'2011yCatp016004901K',2011,1,1.85,NULL,'G',0.000007,NULL,'15.56',0.12,'Sd',NULL,NULL,NULL,NULL,1,17.483625,20.77136,0.145,NULL,67401154317,1053143036,16455359,15.56),(14255,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14255,33.76,0.2,56.5,3078,74.4,NULL,NULL,'UGC 00723',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14256,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14256,33.78,NULL,56.9,3078,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00723',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14257,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14257,33.79,NULL,57.2,3078,NULL,NULL,'Dipole + Quadrupole','UGC 00723',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14258,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14258,33.79,NULL,57.4,3078,NULL,NULL,'Dipole','UGC 00723',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14259,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14259,33.83,0.4,58.4,3078,NULL,NULL,NULL,'UGC 00723',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14260,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14260,33.85,NULL,58.8,3078,NULL,NULL,NULL,'UGC 00723',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14261,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14261,34.18,0.34,68.5,3078,NULL,NULL,'Malmquist cor.','UGC 00723',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14262,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 05909',NULL,14262,40.05,0.3,1020,3079,70,NULL,'SN photometric redshift distance, z photo =0.276 +/- 0.050','SDSS-II SN 05909',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','20.8g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,17.4849583,-1.19408,0.175,NULL,34502029196,539094206,8423346,20.8),(14263,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 05909','R',14263,41.4,0.26,1410,3079,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 05909',0.347576,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14264,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 05909','R',14264,41.67,0.35,1600,3079,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05909',0.347576,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14265,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 05909',NULL,14265,41.61,0.24,2100,3079,70,NULL,'SALT 2','SDSS-II SN 05909',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14266,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 05909',NULL,14266,41.65,0.24,2140,3079,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 05909',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14267,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14267,37.01,0.56,252,3080,70,NULL,NULL,'2MASX J01095887-0237583',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.000093,NULL,'16.95',0.41,NULL,NULL,NULL,NULL,NULL,1,17.4952083,-2.63286,0.146,NULL,34506797742,539168714,8424511,16.95),(14268,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 18942','R',14268,41.7,0.29,1560,3081,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18942',0.406594,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,17.4972917,-0.01858,0.1,NULL,34498283445,539035678,8422432,NULL),(14269,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 18942','R',14269,41.81,0.27,1640,3081,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18942',0.406594,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14270,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 18942',NULL,14270,41.19,0.18,1730,3081,70,NULL,'SN photometric redshift distance, z photo =0.536 +/- 0.065','SDSS-II SN 18942',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14271,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 18942',NULL,14271,41.61,0.18,2100,3081,70,NULL,'SALT 2','SDSS-II SN 18942',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14272,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 18942',NULL,14272,41.68,0.18,2170,3081,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18942',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14273,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14273,34.27,0.4,71.5,3082,NULL,NULL,'mean','UGC 00724',NULL,'2007A&A...465...71T',2007,1,2.1,NULL,'G',0.000017,NULL,'13.61',1.7,'S','in a radial-velocity based grouping',NULL,NULL,NULL,1,17.4974583,32.36836,0.165,NULL,67273583081,1051149735,16424214,13.61),(14274,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14274,34.38,0.06,75.3,3082,NULL,NULL,NULL,'UGC 00724',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14275,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14275,34.94,0.45,97.5,3082,NULL,NULL,'K','UGC 00724',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14276,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14276,34.98,0.47,99,3082,NULL,NULL,'H','UGC 00724',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14277,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14277,35,0.46,100,3082,NULL,NULL,'J','UGC 00724',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14278,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14278,38.16,0.46,428,3083,70,NULL,NULL,'SDSS J010959.67+142326.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000081,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,17.498667,14.39058,0.081,NULL,67638787313,1056856051,16513375,18.6),(14279,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14279,35,0.15,99.9,3084,70,NULL,NULL,'ABELL 2877',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I      [BM];R  [A]',NULL,NULL,NULL,NULL,1,17.501667,-45.92278,NULL,NULL,38142269857,595972966,9312077,NULL),(14280,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 20678','RN',14280,40.22,0.29,918,3085,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20678',0.205733,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14281,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 20678','RN',14281,40.95,0.2,1280,3085,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20678',0.205733,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14282,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14282,34.42,0.25,76.6,3086,74.4,NULL,NULL,'2MASX J01100153-4558074',NULL,'2013AJ....146...86T',2013,1,0.26,NULL,'G',0.00017,NULL,'17.46',0.25,NULL,NULL,NULL,NULL,NULL,1,17.506417,-45.96881,NULL,NULL,38142254965,595972733,9312073,17.46),(14283,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14283,36.67,0.46,215,3087,70,NULL,NULL,'2MASX J01100168+1336157',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000073,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,17.5069583333,13.60442,0.053,NULL,67641306696,1056895417,16513990,16.4),(14284,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14284,37.19,0.76,274,3088,70,NULL,NULL,'MCG -03-04-016',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.5',0.4,NULL,NULL,NULL,NULL,NULL,1,17.509,-19.73447,0.006,NULL,35208623103,550134735,8595855,15.5),(14285,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14285,37.13,0.11,267,3089,70,NULL,NULL,'2MASX J01100272+1400237',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000085,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,17.511417,14.00669,0.081,NULL,67641355171,1056896174,16514002,17.6),(14286,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,'R',14286,37.13,0.11,267,3090,70,NULL,NULL,'2MASX J01100320+1358417',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000114,NULL,'15.5g',0.56,'BrClG',NULL,NULL,NULL,NULL,1,17.5132083,13.97814,0.081,NULL,67641399000,1056896859,16514013,15.5),(14287,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:45','1','SDSS-II SN 09822','RN',14287,39.8,0.62,856,3091,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 09822',0.065765,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14288,'FP','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14288,36.55,0.54,204,3092,70,NULL,NULL,'2MASX J01100500-1533516',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.3',0.6,'E','Group member',NULL,NULL,NULL,1,17.520875,-15.56444,0.021,NULL,35432277016,553629328,8650458,14.3),(14289,'IRAS','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14289,34.63,0.8,84.3,3093,75,NULL,'MAT, I','NGC 0415',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.28',0.8,'SB(rs)b',NULL,NULL,NULL,NULL,1,17.5237083333,-35.49078,NULL,NULL,38272735945,598011499,9343929,14.28),(14290,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14290,34.25,0.32,70.8,3093,85,NULL,'I, raw','NGC 0415',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14291,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14291,34.29,0.43,72.1,3093,75,NULL,'MAT, I, raw','NGC 0415',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14292,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14292,34.3,0.32,72.6,3093,85,NULL,'I, inv','NGC 0415',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14293,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:45','1',NULL,NULL,14293,34.52,0.43,80.3,3093,75,NULL,'MAT, I, inv','NGC 0415',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14294,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14294,34.55,0.43,81.3,3093,75,NULL,'MAT, I, cor','NGC 0415',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14295,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14295,34.61,0.44,83.5,3093,NULL,NULL,'Malmquist cor.','NGC 0415',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14296,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14296,34.68,0.42,86.4,3093,NULL,NULL,NULL,'NGC 0415',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14297,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14297,34.72,0.2,87.9,3093,74.4,NULL,NULL,'NGC 0415',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14298,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14298,34.78,0.4,90.5,3093,NULL,NULL,'mean','NGC 0415',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14299,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14299,34.91,0.47,95.8,3093,NULL,NULL,'H','NGC 0415',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14300,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14300,35.06,0.46,103,3093,NULL,NULL,'J','NGC 0415',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14301,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14301,35.1,0.45,105,3093,NULL,NULL,'K','NGC 0415',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14302,'FP','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14302,35.2,0.25,110,3094,74.4,NULL,NULL,'2MASX J01100662-4555544',NULL,'2013AJ....146...86T',2013,1,0.35,NULL,'G',0.000223,NULL,'16.93',0.29,'S0','Group member',NULL,NULL,NULL,1,17.527667,-45.93183,NULL,NULL,38142270757,595972980,9312077,16.93),(14303,'FP','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,'R',14303,36.59,0.46,208,3095,70,NULL,NULL,'2MASX J01100723+1337517',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000067,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,17.530125,13.63092,0.053,NULL,67641304072,1056895376,16513990,17.3),(14304,'FP','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,'R',14304,37.13,0.11,267,3096,70,NULL,NULL,'SDSS J011007.97+134905.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000078,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,17.53325,13.81811,0.053,NULL,67641378706,1056896542,16514008,18),(14305,'FP','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,'R',14305,37.13,0.11,267,3097,70,NULL,NULL,'2MASX J01100884+1402507',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000074,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,17.536833,14.0475,0.081,NULL,67641360207,1056896253,16514003,17.8),(14306,'FP','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,'R',14306,37.13,0.11,267,3098,70,NULL,NULL,'2MASX J01100905+1406097',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000091,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,17.537833,14.1025,0.081,NULL,67641345822,1056896028,16514000,17.4),(14307,'FP','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,'R',14307,37.13,0.11,267,3099,70,NULL,NULL,'2MASX J01100926+1407237',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000094,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,17.538667,14.12328,0.081,NULL,67640625623,1056884775,16513824,16.3),(14308,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,'R',14308,33.57,0.49,51.8,3100,75,NULL,'IR','UGC 00725',NULL,'2011yCatp016004901K',2011,1,2.2,NULL,'G',0.000023,NULL,'14.4',0.5,'SBcd?','Pair member (points to parent)',NULL,NULL,NULL,1,17.543375,43.10847,0.357,NULL,67889226341,1060769161,16574518,14.4),(14309,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14309,33.6,0.2,52.5,3100,74.4,NULL,NULL,'UGC 00725',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14310,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14310,33.7,0.32,55,3100,NULL,NULL,NULL,'UGC 00725',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14311,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14311,33.85,0.3,58.8,3100,NULL,NULL,'Malmquist cor.','UGC 00725',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14312,'FP','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,'R',14312,37.13,0.11,267,3101,70,NULL,NULL,'2MASX J01101158+1353197',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000083,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,17.54825,13.88881,0.053,NULL,67641384395,1056896631,16514009,17),(14313,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:46','1','SDSS-II SN 14521','RN',14313,42.7,0.21,2240,3102,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 14521',0.547788,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14314,'FP','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,'R',14314,38.3,0.46,457,3103,70,NULL,NULL,'SDSS J011013.04-000105.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000077,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,17.554375,-0.01819,0.093,NULL,34498282363,539035661,8422432,18.6),(14315,'FP','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,'R',14315,37.12,0.46,266,3104,70,NULL,NULL,'2MASX J01101332-0943144',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000075,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,17.5555417,-9.72067,0.16,NULL,35255034096,550859907,8607186,17.6),(14316,'FP','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,'R',14316,38.27,0.33,451,3105,70,NULL,NULL,'2MASX J01101429-0027133',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000081,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,17.559417,-0.45386,0.101,NULL,34498966847,539046356,8422599,17.5),(14317,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:46','1','SDSS-II SN 11827','RN',14317,37.97,0.41,353,3106,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 11827',0.1106,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14318,'FP','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,'R',14318,37.52,0.46,319,3107,70,NULL,NULL,'2MASX J01101429-0043044',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000085,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,17.5595417,-0.71803,0.136,NULL,34498939345,539045927,8422592,17),(14319,'FP','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,'R',14319,36.73,0.46,222,3108,70,NULL,NULL,'2MASX J01101444+1504107',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000071,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,17.56,15.06972,0.101,NULL,67643449450,1056928897,16514514,16.7),(14320,'FP','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,'R',14320,37.13,0.11,267,3109,70,NULL,NULL,'2MASX J01101575+1422357',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000099,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,17.5654583,14.37661,0.081,NULL,67638781531,1056855961,16513374,17.1),(14321,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:46','1','SDSS-II SN 18463','R',14321,40.69,0.22,1090,3110,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007kv','SDSS J011015.94+002819.1',0.26,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',NULL,NULL,'21.0g',0.06,NULL,NULL,NULL,NULL,NULL,1,17.566417,0.472,0.08,NULL,66648324897,1041380076,16271563,21),(14322,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:46','1','SDSS-II SN 18463','R',14322,40.72,0.15,1110,3110,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007kv','SDSS J011015.94+002819.1',0.26,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14323,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:46','1','SN 2007kv',NULL,14323,40.65,0.12,1350,3110,70,NULL,'SALT 2','SDSS J011015.94+002819.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14324,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:46','1','SN 2007kv',NULL,14324,40.67,0.12,1360,3110,70,NULL,'SALT 2, Malmquist cor.','SDSS J011015.94+002819.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14325,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14325,34.32,NULL,73,3111,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0129',NULL,'2010Ap&SS.325..163P',2010,1,0.73,NULL,'G',0.000012,NULL,'16.37',0.1,'Sdm',NULL,NULL,NULL,NULL,1,17.569417,29.20017,0.205,NULL,67307165713,1051674464,16432413,16.37),(14326,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14326,34.36,NULL,74.4,3111,NULL,NULL,'Dipole','FGC 0129',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14327,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14327,34.36,NULL,74.5,3111,NULL,NULL,'Dipole + Quadrupole','FGC 0129',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14328,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14328,34.41,NULL,76.2,3111,NULL,NULL,NULL,'FGC 0129',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14329,'CMD','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14329,24.49,NULL,0.791,3112,NULL,NULL,NULL,'Andromeda V',NULL,'2014ApJ...789..147W',2014,1,2,NULL,'G',0.000013,NULL,'15.92',1.5,'dSph','Brightest group member',NULL,NULL,NULL,1,17.57125,47.62806,0.613,1,67693076505,1057704320,16526630,15.92),(14330,'CMD','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14330,24.57,0.04,0.82,3112,NULL,NULL,NULL,'Andromeda V',NULL,'2008AJ....136.1913M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14331,'Horizontal Branch','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,'R',14331,24.46,0.15,0.78,3112,NULL,NULL,NULL,'Andromeda V',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14332,'RR Lyrae','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14332,24.41,0.09,0.762,3112,NULL,NULL,'V','Andromeda V',NULL,'2013MNRAS.435.3206D',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14333,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14333,24.35,0.07,0.742,3112,NULL,NULL,NULL,'Andromeda V',NULL,'2012ApJ...758...11C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14334,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14334,24.44,0.08,0.773,3112,NULL,NULL,NULL,'Andromeda V',NULL,'2005MNRAS.356..979M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14335,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14335,24.53,0.2,0.805,3112,NULL,NULL,'I','Andromeda V',NULL,'2004ApJ...612L.121Z',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14336,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14336,24.55,0.12,0.81,3112,NULL,NULL,NULL,'Andromeda V',NULL,'1998AJ....116.2287A',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14337,'TRGB','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14337,24.66,0.13,0.855,3112,NULL,NULL,'HST KP Calibrated','Andromeda V',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14338,'FP','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,'R',14338,36.6,0.23,209,3113,70,NULL,NULL,'2MASX J01101717+0020412',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000079,NULL,'15.9g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,17.5714583,0.34489,0.111,NULL,66648424794,1041381637,16271588,15.9),(14339,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14339,35.66,0.14,135,3114,70,NULL,'ABELL 2877b, BGC','2MASX J01101802-4555584',NULL,'1999AJ....118.1489D',1999,1,0.63,NULL,'G',0.000087,NULL,'15.6V',0.25,'S0',NULL,NULL,NULL,NULL,1,17.575125,-45.93294,NULL,NULL,38142268378,595972943,9312077,15.6),(14340,'IRAS','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14340,33.25,0.8,44.6,3115,75,NULL,'MAT, I','ESO 352- G 015',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.34',1.1,'SAB(s)d',NULL,NULL,NULL,NULL,1,17.580417,-35.73639,NULL,NULL,38270438632,597975603,9343368,14.34),(14341,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14341,33.18,0.32,43.3,3115,85,NULL,'I, raw','ESO 352- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14342,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14342,33.19,0.32,43.5,3115,85,NULL,'I, inv','ESO 352- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14343,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14343,33.43,0.43,48.5,3115,75,NULL,'MAT, I, raw','ESO 352- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14344,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14344,33.52,0.43,50.7,3115,75,NULL,'MAT, I, inv','ESO 352- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14345,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14345,33.76,0.43,56.5,3115,75,NULL,'MAT, I, cor','ESO 352- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14346,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14346,33.78,0.49,56.9,3115,NULL,NULL,NULL,'ESO 352- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14347,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14347,33.82,0.2,58.1,3115,74.4,NULL,NULL,'ESO 352- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14348,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14348,33.94,0.46,61.4,3115,NULL,NULL,'Malmquist cor.','ESO 352- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14349,'FP','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14349,34.99,0.25,99.5,3116,74.4,NULL,NULL,'2MASX J01101993-4551184',NULL,'2013AJ....146...86T',2013,1,0.88,NULL,'G',0.000077,NULL,'15.62',0.35,'S0','Group member',NULL,NULL,NULL,1,17.583,-45.85511,NULL,NULL,38142224476,595972257,9312066,15.62),(14350,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:46','1','SDSS-II SN 14963',NULL,14350,35.21,3.58,110,3117,70,NULL,'SN photometric redshift distance, z photo =0.026 +/- 0.118','SDSS-II SN 14963',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,17.583375,0.95017,0.033,NULL,66650991921,1041421748,16272214,NULL),(14351,'FP','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,'R',14351,37.13,0.11,267,3118,70,NULL,NULL,'2MASX J01102068+1410176',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000069,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,17.586,14.17156,0.081,NULL,67638726285,1056855098,16513360,17.2),(14352,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14352,34.57,0.41,82.1,3119,NULL,NULL,'Malmquist cor.','CGCG 501-113',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.00003,NULL,'15.5',0.35,'Sc',NULL,NULL,NULL,NULL,1,17.589083,30.18383,0.245,NULL,67272553957,1051133655,16423963,15.5),(14353,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14353,34.86,0.36,93.8,3119,NULL,NULL,NULL,'CGCG 501-113',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14354,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14354,34.93,0.2,96.8,3119,74.4,NULL,NULL,'CGCG 501-113',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14355,'FP','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,'R',14355,37.13,0.11,267,3120,70,NULL,NULL,'2MASX J01102453+1412386',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000109,NULL,'16.2g',0.36,'E0',NULL,NULL,NULL,NULL,1,17.602167,14.21078,0.081,NULL,67638723671,1056855057,16513360,16.2),(14356,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14356,35.01,0.15,101,3121,NULL,NULL,NULL,'ESO 243- G 048',NULL,'2009ApJS..182..474S',2009,1,0.96,NULL,'G',0.000033,NULL,'16.74',0.16,'Sc',NULL,NULL,NULL,NULL,1,17.6030833333,-46.57133,NULL,NULL,38141363629,595958806,9311856,16.74),(14357,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,'R',14357,35.07,0.49,103,3121,75,NULL,'IR','ESO 243- G 048',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14358,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14358,35.18,NULL,109,3121,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 243- G 048',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14359,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14359,35.19,NULL,109,3121,NULL,NULL,'Dipole + Quadrupole','ESO 243- G 048',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14360,'Tully-Fisher','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14360,35.22,NULL,111,3121,NULL,NULL,'Dipole','ESO 243- G 048',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14361,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:46','1','SDSS-II SN 12991','R',14361,39.37,0.08,647,3122,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2006gd','SN 2006gd',0.154856,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,17.6099583,-1.068,0.129,NULL,34501985251,539093519,8423336,NULL),(14362,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:46','1','SDSS-II SN 12991','R',14362,39.89,0.19,822,3122,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2006gd','SN 2006gd',0.154856,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14363,'FP','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14363,35.31,0.25,115,3123,74.4,NULL,NULL,'ESO 243- G 049',NULL,'2013AJ....146...86T',2013,1,1.06,NULL,'G',0.000113,NULL,'15.0B',0.3,'S0-a','Group member',NULL,NULL,NULL,1,17.6155833333,-46.07425,NULL,NULL,38141193052,595956141,9311814,15),(14364,'FP','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14364,34.69,0.55,86.8,3124,70,NULL,NULL,'2MASX J01102865-6133327',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'15.76',0.42,'S0',NULL,NULL,NULL,NULL,1,17.6192917,-61.55917,0,NULL,36061455431,563460241,8804066,15.76),(14365,'FP','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14365,35.62,0.25,133,3125,74.4,NULL,NULL,'GIN 045',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000113,NULL,'14.31',NULL,'E/S0',NULL,NULL,NULL,NULL,1,17.620375,16.19042,0.129,NULL,67631840496,1056747507,16511679,14.31),(14366,'FP','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,NULL,14366,35.8,0.2,144,3125,70,NULL,NULL,'GIN 045',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14367,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:46','1','SDSS-II SN 18425','RN',14367,40.67,0.11,1230,3126,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18425',0.10914,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14368,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:46','1','SDSS-II SN 18425','RN',14368,40.79,0.19,1300,3126,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18425',0.10914,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14369,'FP','2016-12-15 15:13:43','2016-12-16 11:18:46','1',NULL,'R',14369,36.6,0.23,209,3127,70,NULL,NULL,'2MASX J01103022+0032108',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000095,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,17.6260417,0.53631,0.053,NULL,66647875721,1041373058,16271454,16.8),(14370,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:46','1','SDSS-II SN 15233','RN',14370,41,0.25,1200,3128,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 15233',0.3174,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14371,'SNIa SDSS','2016-12-15 15:13:43','2016-12-16 11:18:46','1','SDSS-II SN 15233','RN',14371,41.17,0.17,1300,3128,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 15233',0.3174,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14372,'SNIa','2016-12-15 15:13:43','2016-12-16 11:18:46','1','SDSS-II SN 21615',NULL,14372,39.4,1.14,758,3129,70,NULL,'SN photometric redshift distance, z photo =0.196 +/- 0.166','SDSS-II SN 21615',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,17.633125,0.59706,0.053,NULL,66647824983,1041372265,16271441,NULL),(14373,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 21615','R',14373,42.6,0.5,2140,3129,70,NULL,'SDSS CAND. Unknown; SALT 2; SN 2007ua','SDSS-II SN 21615',0.551035,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14374,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14374,34.96,0.25,98.2,3130,74.4,NULL,NULL,'2MASX J01103349-4547395',NULL,'2013AJ....146...86T',2013,1,0.72,NULL,'G',0.000083,NULL,'15.49',0.62,'SB0^0','Group member',NULL,NULL,NULL,1,17.639583,-45.79433,NULL,NULL,38142228754,595972324,9312067,15.49),(14375,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14375,35.24,0.47,112,3131,70,NULL,NULL,'ESO 151- G 026',NULL,'2014MNRAS.445.2677S',2014,1,1.15,NULL,'G',0.00015,NULL,'14.31',0.5,'E4:',NULL,NULL,NULL,NULL,1,17.6419583,-52.55656,NULL,NULL,36007340439,562614694,8790854,14.31),(14376,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14376,33.65,0.47,53.8,3132,NULL,NULL,'H','NGC 0418',NULL,'2007A&A...465...71T',2007,1,2,NULL,'G',0.000026,NULL,'13.12',1.7,'SB(s)c         HII','in a pair',NULL,NULL,NULL,1,17.648417,-30.22128,NULL,NULL,34741579336,542837177,8481830,13.12),(14377,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14377,33.83,0.45,58.3,3132,NULL,NULL,'K','NGC 0418',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14378,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14378,33.84,0.46,58.7,3132,NULL,NULL,'J','NGC 0418',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14379,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14379,34.33,0.4,73.3,3132,NULL,NULL,'mean','NGC 0418',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14380,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14380,38.27,0.33,451,3133,70,NULL,NULL,'2MASX J01103625-0028063',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00015,NULL,'17.91',0.25,NULL,NULL,NULL,NULL,NULL,1,17.6509583333,-0.46839,0.112,NULL,34498844469,539044444,8422569,17.91),(14381,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14381,36.22,0.6,175,3134,70,NULL,NULL,'MCG -02-04-007',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15',0.6,NULL,NULL,NULL,NULL,NULL,1,17.657875,-12.03553,0.038,NULL,35375006437,552734475,8636476,15),(14382,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14382,35.8,0.2,144,3135,70,NULL,NULL,'GIN 054',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.000237,NULL,'14.82',NULL,'E',NULL,NULL,NULL,NULL,1,17.658,16.24522,0.105,NULL,67631834650,1056747416,16511678,14.82),(14383,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14383,38.07,0.46,411,3136,70,NULL,NULL,'2MASX J01103951-0026013',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000097,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,17.6647083,-0.43372,0.112,NULL,34498851492,539044554,8422571,17.6),(14384,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14384,37.56,0.46,324,3137,70,NULL,NULL,'SDSS J011039.86+154411.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000075,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,17.666125,15.73656,0.105,NULL,67642993222,1056921769,16514402,18.4),(14385,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14385,35.47,0.51,124,3138,70,NULL,NULL,'2MASX J01104136-1531120',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.44',0.3,'SB0','Group member',NULL,NULL,NULL,1,17.672333,-15.52,0.018,NULL,35432297965,553629655,8650463,14.44),(14386,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14386,36.97,0.56,248,3139,70,NULL,NULL,'2MASX J01104170-1546050',NULL,'2014MNRAS.445.2677S',2014,1,0.4,'The APM image includes a superposed star.','G',0.00015,NULL,'16.25',0.3,'S0','Group member',NULL,NULL,NULL,1,17.67375,-15.76808,0.021,NULL,35431983733,553624745,8650386,16.25),(14387,'Tully est','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14387,30.37,0.8,11.8,3140,75,NULL,NULL,'UGC 00731',NULL,'1988NBGC.C....0000T',1988,1,2.2,NULL,'G',0.000027,NULL,'17.',2,'Im:',NULL,NULL,NULL,NULL,1,17.68325,49.60219,0.721,NULL,67682512706,1057539261,16524050,17),(14388,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14388,34.32,0.8,73.2,3141,75,NULL,'W91PP, r','UGC 00732',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.00002,NULL,'14.64',0.6,'SA(r)d',NULL,NULL,NULL,NULL,1,17.684625,33.55839,0.145,NULL,67748348683,1058567948,16540124,14.64),(14389,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14389,34.32,0.8,73.3,3141,75,NULL,'HMCL, I','UGC 00732',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14390,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14390,34.33,0.8,73.3,3141,75,NULL,'W91CL, r','UGC 00732',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14391,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14391,34.33,0.8,73.6,3141,75,NULL,'CF, r','UGC 00732',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14392,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14392,33.75,0.43,56.3,3141,75,NULL,'3.6 micron, color corrected','UGC 00732',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14393,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14393,33.77,0.43,56.7,3141,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00732',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14394,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14394,33.78,0.2,57,3141,74.4,NULL,NULL,'UGC 00732',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14395,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14395,33.81,NULL,57.8,3141,NULL,NULL,'I','UGC 00732',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14396,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14396,33.85,NULL,58.9,3141,NULL,NULL,'B','UGC 00732',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14397,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14397,33.85,0.38,59,3141,75,NULL,'CF, r, raw','UGC 00732',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14398,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14398,33.94,0.38,61.3,3141,75,NULL,'CF, r, inv','UGC 00732',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14399,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14399,33.95,0.38,61.6,3141,75,NULL,'W91PP, r, raw','UGC 00732',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14400,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14400,33.97,0.38,62.1,3141,75,NULL,'W91CL, r, raw','UGC 00732',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14401,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14401,34.03,0.4,64.1,3141,75,NULL,'HMCL, I, raw','UGC 00732',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14402,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14402,34.04,0.38,64.2,3141,75,NULL,'W91PP, r, inv','UGC 00732',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14403,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14403,34.06,0.38,64.9,3141,75,NULL,'W91CL, r, inv','UGC 00732',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14404,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14404,34.07,0.38,65.1,3141,75,NULL,'CF, r, cor','UGC 00732',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14405,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14405,34.12,0.38,66.8,3141,75,NULL,'W91CL, r, cor','UGC 00732',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14406,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14406,34.14,0.38,67.2,3141,75,NULL,'W91PP, r, cor','UGC 00732',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14407,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14407,34.18,0.4,68.4,3141,75,NULL,'HMCL, I, inv','UGC 00732',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14408,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14408,34.22,0.4,69.7,3141,75,NULL,'HMCL, I, cor','UGC 00732',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14409,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14409,34.23,0.1,70.3,3141,NULL,NULL,NULL,'UGC 00732',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14410,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14410,34,0.11,63.2,3142,NULL,NULL,NULL,'KUG 0107+327',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000057,NULL,'16.27',0.2,'Spiral',NULL,NULL,NULL,NULL,1,17.6850417,33.03142,0.189,NULL,67747608436,1058556381,16539943,16.27),(14411,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14411,34.15,0.2,67.6,3142,74.4,NULL,NULL,'KUG 0107+327',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14412,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14412,34.45,0.49,77.7,3142,75,NULL,'IR','KUG 0107+327',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14413,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14413,35.41,0.53,121,3143,NULL,NULL,'Malmquist cor.','2MFGC 00869',NULL,'2009ApJS..182..474S',2009,1,0.52,NULL,'G',0.000033,NULL,'16.1V',0.15,'Sc',NULL,NULL,NULL,NULL,1,17.691083,-46.54414,NULL,NULL,38141368754,595958886,9311857,16.1),(14414,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14414,35.54,0.5,128,3143,NULL,NULL,NULL,'2MFGC 00869',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14415,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14415,35.56,0.49,130,3143,75,NULL,'IR','2MFGC 00869',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14416,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14416,35.58,0.2,131,3143,74.4,NULL,NULL,'2MFGC 00869',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14417,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14417,37.76,0.46,357,3144,70,NULL,NULL,'SDSS J011045.98+134203.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000069,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,17.691667,13.70106,0.081,NULL,67641224225,1056894128,16513970,18.3),(14418,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 19135','RN',14418,41.59,0.2,1800,3145,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19135',0.153597,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14419,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 19135','RN',14419,41.94,0.25,2110,3145,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19135',0.153597,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14420,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14420,35.87,0.25,149,3146,74.4,NULL,NULL,'2MASX J01104727-4545236',NULL,'2013AJ....146...86T',2013,1,0.53,NULL,'G',0.000113,NULL,'15.95',0.42,'S0','Group member',NULL,NULL,NULL,1,17.697,-45.75656,NULL,NULL,38142215388,595972115,9312064,15.95),(14421,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14421,35.11,0.25,105,3147,74.4,NULL,NULL,'2MASX J01104774-4547016',NULL,'2013AJ....146...86T',2013,1,0.57,NULL,'G',0.000073,NULL,'15.97',0.47,'S0','Group member',NULL,NULL,NULL,1,17.699,-45.78369,NULL,NULL,38142215607,595972118,9312064,15.97),(14422,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 19556',NULL,14422,40.69,0.44,1380,3148,70,NULL,'SN photometric redshift distance, z photo =0.395 +/- 0.120','SDSS-II SN 19556',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,17.7000417,0.22686,0.09,NULL,66647926413,1041373850,16271466,NULL),(14423,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 19556','R',14423,41.53,0.17,1490,3148,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19556',0.36289,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14424,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 19556','R',14424,41.6,0.25,1530,3148,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19556',0.36289,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14425,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005go',NULL,14425,39.83,0.14,734,3149,74.2,NULL,'SALT 2','SDSS-II SN 02943 HOST',0.26,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,17.704917,1.00789,0.033,NULL,66651636935,1041431827,16272372,NULL),(14426,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005go',NULL,14426,39.88,0.13,946,3149,70,NULL,'Hubble residual -0.10 for z0.26540','SDSS-II SN 02943 HOST',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14427,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005go',NULL,14427,40.53,0.04,1010,3149,70,NULL,'SDSS-II SN 02943','SDSS-II SN 02943 HOST',0.26,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14428,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005go',NULL,14428,40.55,0.12,1020,3149,65,NULL,'SALT2','SDSS-II SN 02943 HOST',0.26,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14429,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005go',NULL,14429,40.56,0.17,1030,3149,70,NULL,'SDSS-II SN 02943, SALT 2','SDSS-II SN 02943 HOST',0.26,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14430,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 02943','R',14430,40.62,0.23,1050,3149,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005go','SDSS-II SN 02943 HOST',0.2654,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14431,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005go',NULL,14431,40.81,0.16,1150,3149,65,NULL,'MLCS2k2','SDSS-II SN 02943 HOST',0.26,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14432,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 02943','R',14432,40.84,0.17,1160,3149,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005go','SDSS-II SN 02943 HOST',0.2654,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14433,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14433,37.51,0.46,318,3150,70,NULL,NULL,'2MASX J01104981-0903555',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000075,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,17.7074583,-9.06553,0.184,NULL,35284614372,551322099,8614407,17.9),(14434,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 09594','R',14434,40.49,0.23,965,3151,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J011051.44+000717.8',0.298,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',0.01,NULL,'21.0g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,17.714375,0.12164,0.093,NULL,66647948447,1041374194,16271471,21),(14435,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 09594','R',14435,40.64,0.34,1030,3151,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J011051.44+000717.8',0.298,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14436,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 09594',NULL,14436,40.43,0.19,1220,3151,70,NULL,'SALT 2','SDSS J011051.44+000717.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14437,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 09594',NULL,14437,40.46,0.19,1240,3151,70,NULL,'SALT 2, Malmquist cor.','SDSS J011051.44+000717.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14438,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14438,36.44,0.38,194,3152,NULL,NULL,'Malmquist cor.','AGC 111673',NULL,'2009ApJS..182..474S',2009,1,0.62,NULL,'G',0.000103,NULL,'15.4',0.21,NULL,'Group member',NULL,NULL,NULL,1,17.721917,2.61872,0.061,NULL,66652563372,1041446302,16272598,15.4),(14439,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14439,36.67,0.34,216,3152,NULL,NULL,NULL,'AGC 111673',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14440,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14440,36.71,0.2,220,3152,74.4,NULL,NULL,'AGC 111673',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14441,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14441,34.41,0.8,76,3153,75,NULL,'MAT, I','MCG -01-04-008',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.00002,NULL,'14.97',0.9,'SA(s)c:',NULL,NULL,NULL,NULL,1,17.723917,-5.82153,0.287,NULL,35291062723,551422855,8615982,14.97),(14442,'Sosies','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14442,34.67,0.07,85.9,3153,NULL,NULL,NULL,'MCG -01-04-008',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14443,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14443,34.12,0.2,66.7,3153,74.4,NULL,NULL,'MCG -01-04-008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14444,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14444,34.19,0.38,68.9,3153,NULL,NULL,NULL,'MCG -01-04-008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14445,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14445,34.24,0.37,70.6,3153,NULL,NULL,'Malmquist cor.','MCG -01-04-008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14446,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14446,34.46,0.46,77.9,3153,NULL,NULL,'J','MCG -01-04-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14447,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14447,34.49,0.4,79,3153,NULL,NULL,'mean','MCG -01-04-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14448,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14448,34.5,0.47,79.5,3153,NULL,NULL,'H','MCG -01-04-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14449,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14449,34.57,0.45,82.2,3153,NULL,NULL,'K','MCG -01-04-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14450,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14450,35.01,0.43,100,3153,75,NULL,'MAT, I, raw','MCG -01-04-008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14451,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14451,35.25,0.43,112,3153,75,NULL,'MAT, I, cor','MCG -01-04-008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14452,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14452,35.26,0.32,113,3153,85,NULL,'I, raw','MCG -01-04-008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14453,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14453,35.35,0.32,118,3153,85,NULL,'I, inv','MCG -01-04-008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14454,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14454,35.38,0.43,119,3153,75,NULL,'MAT, I, inv','MCG -01-04-008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14455,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14455,36.46,0.49,196,3154,70,NULL,NULL,'2MASX J01105442-1857501',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.12',0.43,NULL,NULL,NULL,NULL,NULL,1,17.7267917,-18.96386,0.025,NULL,35388122020,552939406,8639678,15.12),(14456,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14456,36.33,0.41,184,3155,NULL,NULL,'Malmquist cor.','AGC 111433',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',NULL,NULL,'15.6I',0.1,NULL,NULL,NULL,NULL,NULL,1,17.727917,33.56278,0.145,NULL,67748320170,1058567502,16540117,15.6),(14457,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14457,36.37,0.4,188,3155,NULL,NULL,NULL,'AGC 111433',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14458,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14458,36.65,0.2,214,3155,74.4,NULL,NULL,'AGC 111433',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14459,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14459,34.74,0.05,88.9,3156,NULL,NULL,NULL,'2MASX J01105586-4539196',NULL,'2009ApJS..182..474S',2009,1,0.33,NULL,'G',0.000177,NULL,'16.2V',0.24,'Sc             Sbrst','Group member',NULL,NULL,NULL,1,17.7327917,-45.65547,NULL,NULL,38139345352,595927271,9311363,16.2),(14460,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14460,36.62,0.78,211,3157,70,NULL,NULL,'MCG -02-04-009',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15',0.6,NULL,NULL,NULL,NULL,NULL,1,17.7413333333,-13.65322,0.007,NULL,35424561395,553508771,8648574,15),(14461,'BCG','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14461,37.12,0.35,250,3158,60,NULL,NULL,'ABELL 0154',0.0612,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II     [BM]',NULL,NULL,NULL,NULL,1,17.7419583,17.66564,0.105,NULL,67629452287,1056710191,16511096,NULL),(14462,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005kt',NULL,14462,36.6,0.12,196,3159,74.2,NULL,'SALT 2','2MASX J01105805+0016343',0.065397,'2010ApJ...716..712A',2010,1,0.27,NULL,'G',0.000085,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,17.7419166667,0.27617,0.09,NULL,66647962485,1041374413,16271475,17.3),(14463,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005kt',NULL,14463,37.02,0.09,254,3159,70,NULL,'SALT 2','2MASX J01105805+0016343',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14464,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005kt',NULL,14464,37.02,0.09,254,3159,70,NULL,'SALT 2, Malmquist cor.','2MASX J01105805+0016343',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14465,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 10028','R',14465,37.17,0.19,255,3159,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2005kt','2MASX J01105805+0016343',0.065397,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14466,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005kt',NULL,14466,37.18,0.14,256,3159,70,NULL,'SDSS-II SN 10028, SALT 2','2MASX J01105805+0016343',0.065397,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14467,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005kt',NULL,14467,37.21,0.17,260,3159,65,NULL,'SALT2','2MASX J01105805+0016343',0.065397,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14468,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005kt',NULL,14468,37.18,0.1,273,3159,74.4,NULL,NULL,'2MASX J01105805+0016343',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14469,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 10028','R',14469,37.37,0.07,279,3159,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2005kt','2MASX J01105805+0016343',0.065397,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14470,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005kt',NULL,14470,37.47,0.13,293,3159,65,NULL,'MLCS2k2','2MASX J01105805+0016343',0.065397,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14471,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005kt',NULL,14471,37.91,0.03,358,3159,70,NULL,'SDSS-II SN 10028','2MASX J01105805+0016343',0.065397,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14472,'D-Sigma','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14472,33.98,0.4,62.5,3160,75,NULL,'Edat, raw','NGC 0410',NULL,'1997ApJS..109..333W',1997,1,2.4,NULL,'G',0.000053,NULL,'12.52',1.3,'E+:;LINER      HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,17.745417,33.15189,0.189,NULL,67747629504,1058556711,16539948,12.52),(14473,'D-Sigma','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14473,34.08,0.4,65.6,3160,75,NULL,'Edat, cor','NGC 0410',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14474,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14474,34.08,0.23,65.5,3160,74.4,NULL,NULL,'NGC 0410',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14475,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14475,34,0.45,63.2,3160,NULL,NULL,'K','NGC 0410',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14476,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14476,34.32,0.4,73.2,3160,NULL,NULL,'mean','NGC 0410',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14477,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14477,36.13,0.79,168,3161,70,NULL,NULL,'2MASX J01105973-1728527',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'15.3R',0.17,NULL,NULL,NULL,NULL,NULL,1,17.748917,-17.48128,0,NULL,35420224640,553441010,8647515,15.3),(14478,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14478,34.46,0.8,78.1,3162,75,NULL,'MAT, I','IC 1637',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00002,NULL,'13.39',1.3,'SB(rs)c:','in a pair',NULL,NULL,NULL,1,17.75475,-30.43853,NULL,NULL,34734997956,542734343,8480224,13.39),(14479,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14479,34.16,0.43,67.9,3162,75,NULL,'MAT, I, raw','IC 1637',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14480,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14480,34.22,0.32,69.7,3162,85,NULL,'I, raw','IC 1637',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14481,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14481,34.29,0.32,72,3162,85,NULL,'I, inv','IC 1637',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14482,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14482,34.32,NULL,73.1,3162,NULL,NULL,'B','IC 1637',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14483,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14483,34.4,0.47,75.9,3162,NULL,NULL,'H','IC 1637',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14484,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14484,34.41,0.45,76.2,3162,NULL,NULL,'K','IC 1637',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14485,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14485,34.41,0.43,76.2,3162,75,NULL,'MAT, I, cor','IC 1637',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14486,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14486,34.43,0.46,76.9,3162,NULL,NULL,'J','IC 1637',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14487,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14487,34.45,0.43,77.7,3162,75,NULL,'MAT, I, inv','IC 1637',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14488,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14488,34.47,NULL,78.3,3162,NULL,NULL,'I','IC 1637',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14489,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14489,34.49,0.4,78.9,3162,NULL,NULL,'mean','IC 1637',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14490,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14490,37.32,0.46,291,3163,70,NULL,NULL,'2MASX J01110166-0114274',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000087,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,17.7568333333,-1.24111,0.182,NULL,34502208494,539097007,8423390,17),(14491,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14491,36.91,0.61,241,3164,70,NULL,NULL,'2MASX J01110270-1402587',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'17.15',0.24,NULL,NULL,NULL,NULL,NULL,1,17.7612917,-14.04958,0.006,NULL,35423335412,553489615,8648275,17.15),(14492,'BCG','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14492,37.12,0.35,250,3165,60,NULL,'ABELL 0154, BCG','IC 1635',0.0612,'1980ApJ...241..486H',1980,1,1,NULL,'G',0.00011,NULL,'15.7',1,'MLT SYS','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,17.7647083333,17.65203,0.105,NULL,67629451815,1056710184,16511096,15.7),(14493,'BCG','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14493,37.12,0.35,250,3166,60,NULL,'ABELL 0154, BCG','IC 1634',0.0612,'1980ApJ...241..486H',1980,1,1,NULL,'G',0.00011,NULL,'15.7',1,'MLT SYS','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,17.7657917,17.66306,0.105,NULL,67629463006,1056710359,16511099,15.7),(14494,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14494,35.46,0.51,123,3167,70,NULL,NULL,'2MASX J01110461-4558435',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00009,NULL,'15.81',0.53,'S0','Group member',NULL,NULL,NULL,1,17.7692917,-45.97878,NULL,NULL,38141178707,595955917,9311811,15.81),(14495,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14495,36.07,0.49,164,3168,70,NULL,NULL,'NGC 0417',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.13',0.5,'SAB0-:   poss. LINER',NULL,NULL,NULL,NULL,1,17.7731666667,-18.14833,0,NULL,35387829927,552934842,8639606,15.13),(14496,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2003jr',NULL,14496,39.87,0.06,703,3169,65,NULL,'SN d087, SALT','ESSENCE J011106.23+001344.2',0.34,'2007ApJ...666..694W',2007,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,17.7759583,0.22894,0.09,NULL,66648009190,1041375143,16271486,NULL),(14497,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2003jr','R',14497,40.42,NULL,904,3169,65,NULL,'SN d087, SALT2','ESSENCE J011106.23+001344.2',0.34,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14498,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2003jr',NULL,14498,40.5,0.23,939,3169,74.2,NULL,'SALT 2','ESSENCE J011106.23+001344.2',0.34,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14499,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2003jr',NULL,14499,41.1,0.22,1240,3169,70,NULL,'SN d087, SALT','ESSENCE J011106.23+001344.2',0.34,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14500,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2003jr',NULL,14500,41.26,0.21,1330,3169,65,NULL,'SN d087, MLCS17','ESSENCE J011106.23+001344.2',0.34,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14501,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2003jr',NULL,14501,41.26,0.23,1330,3169,65,NULL,'SN d087, SALT','ESSENCE J011106.23+001344.2',0.34,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14502,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2003jr',NULL,14502,41.3,0.23,1350,3169,65,NULL,'SN d087, SALT2','ESSENCE J011106.23+001344.2',0.34,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14503,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2003jr',NULL,14503,41.3,0.19,1360,3169,65,NULL,'SN d087, MLCS31','ESSENCE J011106.23+001344.2',0.34,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14504,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2003jr',NULL,14504,41.32,0.17,1370,3169,65,NULL,'SN d087, MLCS2k2','ESSENCE J011106.23+001344.2',0.34,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14505,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14505,35.1,0.62,105,3170,NULL,NULL,NULL,'CGCG 436-007',NULL,'2009ApJS..182..474S',2009,1,0.58,NULL,'G',0.000013,NULL,'15.8g',0.48,'Sc',NULL,NULL,NULL,NULL,1,17.7757916667,15.17211,0.085,NULL,67642759355,1056918114,16514345,15.8),(14506,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14506,35.14,0.2,107,3170,74.4,NULL,NULL,'CGCG 436-007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14507,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14507,35.4,0.54,120,3170,NULL,NULL,'Malmquist cor.','CGCG 436-007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14508,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14508,36.98,0.4,249,3171,NULL,NULL,'Malmquist cor.','2MASX J01110777+1501061',NULL,'2009ApJS..182..474S',2009,1,0.49,NULL,'G',0.000115,NULL,'16.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,17.782417,15.01825,0.085,NULL,67642731644,1056917681,16514338,16.2),(14509,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14509,37.28,0.35,285,3171,NULL,NULL,NULL,'2MASX J01110777+1501061',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14510,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14510,37.13,0.11,267,3172,70,NULL,NULL,'2MASX J01110829+1413221',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000105,NULL,'15.5g',0.46,'E0',NULL,NULL,NULL,NULL,1,17.7846666667,14.22281,0.085,NULL,67639240153,1056863127,16513486,15.5),(14511,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14511,33.95,0.8,61.6,3173,75,NULL,'MAT, I','ESO 113- G 021',NULL,'1997ApJS..109..333W',1997,1,1.39,NULL,'G',0.000033,NULL,'15.89',0.22,'Sc?',NULL,NULL,NULL,NULL,1,17.8021666667,-58.839,0,NULL,36234616969,566165890,8846342,15.89),(14512,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14512,33.79,0.32,57.4,3173,85,NULL,'I, inv','ESO 113- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14513,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14513,33.81,0.32,57.7,3173,85,NULL,'I, raw','ESO 113- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14514,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14514,34.09,0.43,65.7,3173,75,NULL,'MAT, I, raw','ESO 113- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14515,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14515,34.1,0.43,66.1,3173,75,NULL,'MAT, I, inv','ESO 113- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14516,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14516,34.25,0.46,70.7,3173,NULL,NULL,NULL,'ESO 113- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14517,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14517,34.29,0.2,72.1,3173,74.4,NULL,NULL,'ESO 113- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14518,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14518,34.49,0.41,78.9,3173,NULL,NULL,'Malmquist cor.','ESO 113- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14519,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14519,34.51,0.43,79.9,3173,75,NULL,'MAT, I, cor','ESO 113- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14520,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14520,36.83,0.46,232,3174,70,NULL,NULL,'2MASX J01111421+1452412',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00013,NULL,'16.1g',0.35,'E0',NULL,NULL,NULL,NULL,1,17.8092083,14.87817,0.085,NULL,67638463096,1056850985,16513296,16.1),(14521,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14521,34.29,0.09,72.3,3175,NULL,NULL,NULL,'MCG +00-04-027',NULL,'2009ApJS..182..474S',2009,1,0.59,NULL,'G',0.000023,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,17.8157917,-0.45594,0.091,NULL,34498833467,539044272,8422566,16.2),(14522,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14522,35.99,0.61,158,3176,70,NULL,NULL,'2MASX J01111597-6130326',NULL,'2014MNRAS.445.2677S',2014,1,0.31,NULL,'G',0.00015,NULL,'17.27',0.25,NULL,NULL,NULL,NULL,NULL,1,17.8165417,-61.50908,0,NULL,36060596263,563446816,8803856,17.27),(14523,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 17935','RN',14523,42.83,0.22,2320,3177,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 17935',0.586521,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14524,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 20560','R',14524,41.16,0.23,1240,3178,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20560',0.373829,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,17.8355,-0.20536,0.092,NULL,34498935722,539045870,8422591,NULL),(14525,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 20560','R',14525,41.34,0.17,1350,3178,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20560',0.373829,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14526,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 20560',NULL,14526,40.77,0.14,1420,3178,70,NULL,'SN photometric redshift distance, z photo =0.413 +/- 0.036','SDSS-II SN 20560',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14527,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14527,37.24,0.9,280,3179,70,NULL,NULL,'MCG -03-04-025',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.5',0.4,'SA(rl)0^+',NULL,NULL,NULL,NULL,1,17.839583,-18.27736,0,NULL,35387782218,552934097,8639595,15.5),(14528,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14528,37.7,0.59,347,3180,70,NULL,NULL,'2MASX J01112460-1627397',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.76',0.22,NULL,NULL,NULL,NULL,NULL,1,17.8525417,-16.46097,0.015,NULL,35419980898,553437201,8647456,16.76),(14529,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 00764','RN',14529,40.78,0.2,1210,3181,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 00764',0.187068,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14530,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14530,35.8,0.2,144,3182,70,NULL,NULL,'GIN 051',NULL,'2001MNRAS.321..277C',2001,1,0.55,NULL,'G',0.000122,NULL,'15.8g',0.43,'E',NULL,NULL,NULL,NULL,1,17.853333,15.57314,0.085,NULL,67642669663,1056916713,16514323,15.8),(14531,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14531,36.9,0.23,240,3182,70,NULL,NULL,'GIN 051',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14532,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14532,33.82,0.2,58.1,3183,74.4,NULL,NULL,'NGC 0424',NULL,'2013AJ....146...86T',2013,1,1.8,NULL,'G',0.000031,NULL,'13.90',0.8,'(R)SB(r)0/a; Sy1/Sy2',NULL,NULL,NULL,'Sy 1 h',1,17.865125,-38.08347,NULL,NULL,38349835845,599216185,9362752,13.9),(14533,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14533,34.19,0.25,68.9,3184,74.4,NULL,NULL,'ESO 243- G 052',NULL,'2013AJ....146...86T',2013,1,1.19,NULL,'G',0.000073,NULL,'14.68',0.36,'S0^0^: sp','Group member',NULL,NULL,NULL,1,17.865167,-45.93767,NULL,NULL,38141174889,595955857,9311810,14.68),(14534,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14534,35.37,0.49,118,3185,75,NULL,'IR','CGCG 480-048 NED02',NULL,'2011yCatp016004901K',2011,1,0.95,NULL,'G',0.000087,NULL,'15.5',0.12,'Sc',NULL,NULL,NULL,NULL,1,17.88,23.21731,0.089,NULL,67403863086,1053185360,16456021,15.5),(14535,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14535,35.63,NULL,134,3185,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 480-048 NED02',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14536,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14536,35.65,NULL,135,3185,NULL,NULL,'Dipole + Quadrupole','CGCG 480-048 NED02',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14537,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14537,35.66,NULL,135,3185,NULL,NULL,NULL,'CGCG 480-048 NED02',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14538,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14538,35.67,NULL,136,3185,NULL,NULL,'Dipole','CGCG 480-048 NED02',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14539,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 15057','R',14539,40.69,0.26,1060,3186,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006md','SDSS J011131.48+002434.2',0.3,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,NULL,'21.6g',0.04,NULL,NULL,NULL,NULL,NULL,1,17.881167,0.40953,0.09,NULL,66647852812,1041372700,16271448,21.6),(14540,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2006md',NULL,14540,40.39,0.15,1200,3186,70,NULL,'SALT 2','SDSS J011131.48+002434.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14541,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 15057','R',14541,40.98,0.2,1210,3186,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006md','SDSS J011131.48+002434.2',0.3,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14542,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2006md',NULL,14542,40.41,0.15,1210,3186,70,NULL,'SALT 2, Malmquist cor.','SDSS J011131.48+002434.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14543,'SGRB','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14543,41.59,NULL,2080,3187,70,NULL,'Photometric Distance, Host A, M(R) = -20 mag and spectral slope Beta = 1.0 ','GRB 080915A',NULL,'2012A&A...545A..77R',2012,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,17.9485417,-76.02036,0.193,NULL,35620494540,556570227,8696409,NULL),(14544,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14544,36.99,0.62,250,3188,70,NULL,NULL,'2MASX J01113227-1402303',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'16.57',0.18,NULL,NULL,NULL,NULL,NULL,1,17.884375,-14.04175,0,NULL,35423380538,553490320,8648286,16.57),(14545,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005ia',NULL,14545,40.03,0.12,811,3189,74.2,NULL,'SALT 2','SDSS J011135.03-000021.4',0.25,'2010ApJ...716..712A',2010,1,0.04,NULL,'G',NULL,NULL,'22.1g',0.02,NULL,NULL,NULL,NULL,NULL,1,17.8959583,-0.00597,0.074,NULL,34498773496,539043335,8422552,22.1),(14546,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005ia',NULL,14546,40.28,0.03,911,3189,70,NULL,'SDSS-II SN 05717','SDSS J011135.03-000021.4',0.25,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14547,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005ia',NULL,14547,40.1,0.19,1050,3189,70,NULL,'SDSS-II SN 05717','SDSS J011135.03-000021.4',NULL,'2013MNRAS.434.1443X',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14548,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005ia',NULL,14548,40.71,0.13,1110,3189,70,NULL,'SDSS-II SN 05717, SALT 2','SDSS J011135.03-000021.4',0.25,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14549,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 05717','R',14549,40.76,0.2,1130,3189,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ia','SDSS J011135.03-000021.4',0.25,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14550,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 05717','R',14550,40.79,0.09,1150,3189,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ia','SDSS J011135.03-000021.4',0.25,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14551,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005ia',NULL,14551,40.78,0.09,1150,3189,65,NULL,'SALT2','SDSS J011135.03-000021.4',0.25,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14552,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005ia',NULL,14552,40.81,0.09,1160,3189,65,NULL,'MLCS2k2','SDSS J011135.03-000021.4',0.25,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14553,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14553,34.1,0.2,66.1,3190,74.4,NULL,NULL,'2MFGC 00881',NULL,'2013AJ....146...86T',2013,1,0.26,NULL,'G',0.000048,NULL,'16.9g',0.06,'Sd(f)',NULL,NULL,NULL,NULL,1,17.898,0.46278,0.033,NULL,66651323602,1041426931,16272295,16.9),(14554,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14554,34.35,0.35,74,3190,NULL,NULL,NULL,'2MFGC 00881',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14555,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14555,34.35,0.49,74.1,3190,75,NULL,'IR','2MFGC 00881',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14556,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14556,34.42,0.34,76.5,3190,NULL,NULL,'Malmquist cor.','2MFGC 00881',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14557,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14557,36.01,0.5,159,3191,70,NULL,NULL,'2MASX J01113629-1512523',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14',0.3,'S0/E','Group member',NULL,NULL,NULL,1,17.9012083,-15.2145,0.015,NULL,35431595626,553618681,8650291,14),(14558,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 03795','RN',14558,42.8,0.31,2190,3192,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03795',0.662154,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14559,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14559,36.12,0.81,168,3193,70,NULL,NULL,'2MFGC 00882',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'16.68',0.14,NULL,NULL,NULL,NULL,NULL,1,17.9187917,-12.45206,0.038,NULL,35421073106,553454267,8647722,16.68),(14560,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14560,35.41,0.51,121,3194,70,NULL,NULL,'2MASX J01114243-3001418',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00015,NULL,'15.41',0.62,'E',NULL,NULL,NULL,NULL,1,17.92675,-30.02825,NULL,NULL,34734331754,542723933,8480061,15.41),(14561,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 20316','RN',14561,40.39,0.23,1020,3195,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20316',0.176147,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14562,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14562,33.94,0.8,61.3,3196,75,NULL,'W91PP, r','UGC 00748',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.00002,NULL,'14.85',0.6,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,17.9315,35.27611,0.173,NULL,67750465030,1058601016,16540640,14.85),(14563,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14563,34.26,0.38,71.1,3196,75,NULL,'W91PP, r, raw','UGC 00748',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14564,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14564,34.34,0.38,73.7,3196,75,NULL,'W91PP, r, inv','UGC 00748',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14565,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14565,34.41,0.38,76.1,3196,75,NULL,'W91PP, r, cor','UGC 00748',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14566,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14566,34.46,0.43,78,3196,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00748',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14567,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14567,34.68,0.49,86.5,3196,75,NULL,'IR','UGC 00748',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14568,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 19107','RN',14568,41.15,0.24,1220,3197,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19107',0.391416,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14569,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 19107','RN',14569,41.81,0.25,1650,3197,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19107',0.391416,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14570,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14570,36.07,0.15,163,3198,70,NULL,NULL,'2MASX J01114615+1458403',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000091,NULL,'15.8g',0.33,'S0',NULL,NULL,NULL,NULL,1,17.942417,14.97786,0.089,NULL,67642747819,1056917934,16514342,15.8),(14571,'Tully est','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14571,32.56,0.8,32.5,3199,75,NULL,'B','IC 1639',NULL,'1988NBGC.C....0000T',1988,1,0.6,NULL,'G',0.00004,NULL,'14.35',0.5,'cE','in a radial-velocity based grouping',NULL,NULL,NULL,1,17.9439583,-0.66436,0.108,NULL,34501642027,539088156,8423252,14.35),(14572,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 21535','RN',14572,43.42,0.43,3500,3200,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 21535',0.377177,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14573,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 21535','RN',14573,44.06,0.35,4710,3200,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 21535',0.377177,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14574,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 16362','RN',14574,39.89,0.22,807,3201,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16362',0.180119,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14575,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 16362','N',14575,39.63,0.12,843,3201,70,NULL,'SALT 2','SDSS-II SN 16362',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14576,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 16362','N',14576,39.64,0.12,847,3201,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16362',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14577,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 16362','RN',14577,40.27,0.14,961,3201,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16362',0.180119,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14578,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14578,36.34,0.6,185,3202,70,NULL,NULL,'2MASX J01114846-3128196',NULL,'2014MNRAS.445.2677S',2014,1,0.31,NULL,'G',0.00015,NULL,'16.94',0.3,NULL,NULL,NULL,NULL,NULL,1,17.951917,-31.47208,NULL,NULL,34735669590,542744837,8480388,16.94),(14579,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14579,36.17,0.56,172,3203,70,NULL,NULL,'2MASX J01114886-1233043',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.53',0.31,NULL,NULL,NULL,NULL,NULL,1,17.953625,-12.55122,0,NULL,35421068907,553454201,8647721,16.53),(14580,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2008fr','R',14580,36.12,0.06,167,3204,NULL,NULL,'MLCS2k2, R(V) = 1.8','SDSS J011149.19+143826.5',NULL,'2015Sci...347.1459K',2015,1,0.12,NULL,'G',NULL,NULL,'19.1r',0.1,NULL,NULL,NULL,NULL,NULL,1,17.955,14.64069,0.089,NULL,67639352203,1056864878,16513513,19.1),(14581,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2008fr','R',14581,36.17,0.06,171,3204,NULL,NULL,'MLCS2k2, R(V) = 3.1','SDSS J011149.19+143826.5',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14582,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2008fr',NULL,14582,36.42,0.19,183,3204,73.8,NULL,'SALT 2 (SNANA)','SDSS J011149.19+143826.5',0.0481,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14583,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14583,35.8,0.2,144,3205,70,NULL,NULL,'GIN 053',NULL,'2001MNRAS.321..277C',2001,1,0.44,NULL,'G',0.000097,NULL,'16.4g',0.38,'E/S0',NULL,NULL,NULL,NULL,1,17.958917,15.35078,0.085,NULL,67642707770,1056917308,16514332,16.4),(14584,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14584,35.8,0.2,144,3205,70,NULL,NULL,'GIN 053',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14585,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14585,37.04,0.46,256,3205,70,NULL,NULL,'GIN 053',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14586,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14586,34.15,0.8,67.7,3206,75,NULL,'MAT, I','IC 1649',NULL,'1997ApJS..109..333W',1997,1,1.7,'The APMUKS position applies to the southeastern end of the galaxy.','G',0.000033,NULL,'14.67',0.3,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,17.96225,-55.85733,0,NULL,36201432629,565647384,8838240,14.67),(14587,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14587,33.89,0.43,60,3206,75,NULL,'MAT, I, raw','IC 1649',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14588,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14588,33.99,0.32,62.7,3206,85,NULL,'I, raw','IC 1649',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14589,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14589,34.03,0.32,64.1,3206,85,NULL,'I, inv','IC 1649',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14590,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14590,34.1,0.43,66.2,3206,75,NULL,'MAT, I, inv','IC 1649',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14591,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14591,34.11,0.49,66.5,3206,75,NULL,'IR','IC 1649',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14592,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14592,34.16,0.47,68,3206,NULL,NULL,'H','IC 1649',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14593,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14593,34.29,0.43,72.1,3206,75,NULL,'MAT, I, cor','IC 1649',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14594,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14594,34.29,0.45,72.2,3206,NULL,NULL,'K','IC 1649',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14595,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14595,34.31,0.42,72.7,3206,NULL,NULL,NULL,'IC 1649',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14596,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14596,34.32,0.4,73.1,3206,NULL,NULL,'mean','IC 1649',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14597,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14597,34.33,0.46,73.5,3206,NULL,NULL,'J','IC 1649',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14598,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14598,34.35,0.2,74.1,3206,74.4,NULL,NULL,'IC 1649',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14599,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14599,34.43,0.39,77.1,3206,NULL,NULL,'Malmquist cor.','IC 1649',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14600,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14600,33.48,0.23,49.7,3207,74.4,NULL,NULL,'CGCG 501-126',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.00008,NULL,'15.7',0.3,'S0',NULL,NULL,NULL,NULL,1,17.963417,31.55914,0.201,NULL,67269708603,1051089196,16423268,15.7),(14601,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 07363','RN',14601,39.77,0.11,762,3208,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 07363',0.180405,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14602,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 07363','RN',14602,39.91,0.21,814,3208,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 07363',0.180405,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14603,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14603,34.86,0.53,93.6,3209,70,NULL,NULL,'2MASX J01115251-4549022',NULL,'2014MNRAS.445.2677S',2014,1,0.67,'The APMUKS data refer to the eastern end of the galaxy.','G',0.000073,NULL,'15.72',0.4,'S0','Group member',NULL,NULL,NULL,1,17.968875,-45.81736,NULL,NULL,38364775591,599449618,9366400,15.72),(14604,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14604,37.15,0.59,270,3210,70,NULL,NULL,'2MASX J01115310-1534193',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'17.12',0.25,NULL,NULL,NULL,NULL,NULL,1,17.9711666667,-15.57208,0.02,NULL,35417828499,553403570,8646930,17.12),(14605,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14605,37.32,0.64,291,3211,70,NULL,NULL,'2MASX J01115324-1421393',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.000063,NULL,'15.0',0.19,NULL,'Group member',NULL,NULL,NULL,1,17.971917,-14.36092,0,NULL,35424038760,553500605,8648446,15),(14606,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 13898','RN',14606,40.56,0.2,1050,3212,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13898',0.226262,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14607,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 13898','RN',14607,40.67,0.24,1110,3212,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13898',0.226262,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14608,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14608,36.66,0.1,215,3213,70,NULL,NULL,'UGC 00753',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.00015,NULL,'15.8g',0.45,'E0',NULL,NULL,NULL,NULL,1,18.01925,-0.24511,0.062,NULL,34498722242,539042535,8422539,15.8),(14609,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14609,38.1,0.83,417,3214,70,NULL,NULL,'2MASX J01120530-0009402',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000102,NULL,'16.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,18.0221666667,-0.16117,0.074,NULL,34498724934,539042577,8422540,16.5),(14610,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 20998',NULL,14610,39.87,0.32,943,3215,70,NULL,'SN photometric redshift distance, z photo =0.251 +/- 0.047','SDSS-II SN 20998',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,18.02325,0.15986,0.074,NULL,66647804034,1041371938,16271436,NULL),(14611,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 20998','R',14611,41.43,0.2,1420,3215,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20998',0.359106,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14612,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 20998','R',14612,41.81,0.41,1690,3215,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20998',0.359106,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14613,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14613,35.14,0.52,106,3216,70,NULL,NULL,'2MASX J01120607-6141425',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.31',0.28,'S',NULL,NULL,NULL,NULL,1,18.025375,-61.69517,0,NULL,36060616211,563447128,8803861,16.31),(14614,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14614,35.24,0.51,111,3217,70,NULL,NULL,'ESO 352- G 018',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000037,NULL,'14.82',1.1,'SA(r)a',NULL,NULL,NULL,NULL,1,18.03925,-32.24236,NULL,NULL,34743747198,542871049,8482360,14.82),(14615,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14615,33.55,0.23,51.3,3218,74.4,NULL,NULL,'NGC 0420',NULL,'2013AJ....146...86T',2013,1,2,NULL,'G',0.000033,NULL,'13.09',2,'S0:','in a radial-velocity based grouping',NULL,NULL,NULL,1,18.0402083,32.12317,0.165,NULL,67273647335,1051150739,16424230,13.09),(14616,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14616,34.22,0.4,69.9,3218,NULL,NULL,'mean','NGC 0420',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14617,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14617,34.23,0.45,70,3218,NULL,NULL,'K','NGC 0420',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14618,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2003lj','R',14618,40.92,NULL,1080,3219,65,NULL,'SN f235, MLCS31','ESSENCE J011210.03+001951.3',0.417,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,18.0417917,0.33092,0.064,NULL,66651207578,1041425118,16272267,NULL),(14619,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2003lj',NULL,14619,41.02,0.23,1130,3219,74.2,NULL,'SALT 2','ESSENCE J011210.03+001951.3',0.417,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14620,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2003lj',NULL,14620,41.67,0.24,1520,3219,70,NULL,'SN f235, SALT','ESSENCE J011210.03+001951.3',0.417,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14621,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2003lj',NULL,14621,41.78,0.21,1600,3219,65,NULL,'SN f235, MLCS2k2','ESSENCE J011210.03+001951.3',0.417,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14622,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2003lj',NULL,14622,41.78,0.23,1600,3219,65,NULL,'SN f235, MLCS31','ESSENCE J011210.03+001951.3',0.417,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14623,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2003lj',NULL,14623,41.84,0.22,1650,3219,65,NULL,'SN f235, SALT','ESSENCE J011210.03+001951.3',0.417,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14624,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2003lj',NULL,14624,41.89,0.08,1680,3219,65,NULL,'SN f235, SALT','ESSENCE J011210.03+001951.3',0.417,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14625,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2003lj',NULL,14625,41.92,0.24,1710,3219,65,NULL,'SN f235, SALT2','ESSENCE J011210.03+001951.3',0.417,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14626,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14626,34.16,0.08,68.1,3220,NULL,NULL,NULL,'KUG 0109+317',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000033,NULL,'15.3',0.3,'Spiral',NULL,NULL,NULL,NULL,1,18.043875,32.00369,0.165,NULL,67269370206,1051083909,16423186,15.3),(14627,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14627,34.34,0.2,73.8,3220,74.4,NULL,NULL,'KUG 0109+317',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14628,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14628,36.82,0.67,231,3221,70,NULL,NULL,'LCRS B010955.7-382158',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.56',0.44,NULL,NULL,NULL,NULL,NULL,1,18.05575,-38.10081,NULL,NULL,38349892913,599217076,9362766,16.56),(14629,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14629,36.71,0.46,220,3222,70,NULL,NULL,'2MASX J01121423+1356191',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000066,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,18.05925,13.93853,0.085,NULL,67639176132,1056862127,16513470,17.5),(14630,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14630,37.74,0.46,353,3223,70,NULL,NULL,'2MASXi J0112164+143443',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.0001,NULL,'17.9g',0.17,'NLAGN',NULL,NULL,NULL,'Sy 2',1,18.0687083333,14.57853,0.089,NULL,67638480393,1056851256,16513300,17.9),(14631,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14631,36.9,0.23,240,3224,70,NULL,NULL,'2MASX J01121792+1549471',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00008,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,18.074917,15.82975,0.089,NULL,67631931038,1056748922,16511701,17.5),(14632,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14632,35.8,0.2,144,3225,70,NULL,NULL,'GIN 046',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.000137,NULL,'14.78',NULL,'E/S0',NULL,NULL,NULL,NULL,1,18.07775,16.32597,0.133,NULL,67631388948,1056740452,16511569,14.78),(14633,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14633,38.15,0.46,426,3226,70,NULL,NULL,'2MASX J01121867-0024341',NULL,'2015arXiv151105856S',2015,1,0.11,NULL,'G',0.000095,NULL,'17.4g',0.09,NULL,NULL,NULL,NULL,NULL,1,18.077917,-0.40964,0.091,NULL,34501805575,539090712,8423292,17.4),(14634,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14634,34.92,0.1,96.6,3227,NULL,NULL,NULL,'ESO 244- G 001',NULL,'2009ApJS..182..474S',2009,1,0.93,NULL,'G',0.000027,NULL,'18.3V',0.26,'Sa-b           Sbrst','Group member',NULL,NULL,NULL,1,18.0793333333,-45.88842,NULL,NULL,38362689339,599417020,9365890,18.3),(14635,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14635,34.69,0.47,86.7,3228,NULL,NULL,'H','IC 1650',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000033,NULL,'14.40',0.7,'SAB(rs)ab',NULL,NULL,NULL,NULL,1,18.0795417,-50.40172,NULL,NULL,38138603366,595915677,9311182,14.4),(14636,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14636,34.78,0.42,90.2,3228,NULL,NULL,NULL,'IC 1650',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14637,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14637,34.82,0.2,92,3228,74.4,NULL,NULL,'IC 1650',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14638,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14638,34.83,0.41,92.4,3228,NULL,NULL,'Malmquist cor.','IC 1650',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14639,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14639,34.84,0.45,92.8,3228,NULL,NULL,'K','IC 1650',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14640,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14640,34.86,0.46,93.6,3228,NULL,NULL,'J','IC 1650',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14641,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14641,34.96,0.4,98.3,3228,NULL,NULL,'mean','IC 1650',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14642,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14642,33.83,0.23,58.3,3229,74.4,NULL,NULL,'IC 1638',NULL,'2013AJ....146...86T',2013,1,0.35,NULL,'G',0.00007,NULL,'14.9',0.35,'S0',NULL,NULL,NULL,NULL,1,18.090875,33.36453,0.161,NULL,67747541560,1058555336,16539927,14.9),(14643,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14643,34.13,0.4,67,3229,NULL,NULL,'mean','IC 1638',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14644,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14644,34.81,0.45,91.7,3229,NULL,NULL,'K','IC 1638',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14645,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14645,36.9,0.23,240,3230,70,NULL,NULL,'2MASX J01122256+1543571',NULL,'2015arXiv151105856S',2015,1,0.24,'Cava et al. (2009A&A...495..707C) give z = 0.0444 +/- 0.0001.','G',0.000078,NULL,'17.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,18.0939166667,15.73267,0.089,NULL,67631934475,1056748976,16511702,17.7),(14646,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14646,35.8,0.2,144,3231,70,NULL,NULL,'GIN 044',NULL,'2001MNRAS.321..277C',2001,1,0.47,NULL,'G',0.00008,NULL,'15.13',0.46,'E/S0;BrClG',NULL,NULL,NULL,NULL,1,18.0977083,15.72625,0.089,NULL,67631932695,1056748948,16511702,15.13),(14647,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14647,36.9,0.23,240,3231,70,NULL,NULL,'GIN 044',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14648,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14648,36.07,0.15,163,3232,70,NULL,NULL,'2MASX J01122497+1538371',NULL,'2015arXiv151105856S',2015,1,0.35,'Smith et al. (2004AJ....128.1558S) give z = 0.044387 +/- 0.000067.','G',0.00004,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,18.104125,15.64364,0.097,NULL,67631226690,1056737917,16511529,17),(14649,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14649,35.31,0.58,115,3233,70,NULL,NULL,'MCG -02-04-012',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15',0.3,NULL,NULL,NULL,NULL,NULL,1,18.111125,-12.77547,0,NULL,35421499564,553460930,8647827,15),(14650,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14650,35.61,0.25,132,3234,74.4,NULL,NULL,'IC 1645',NULL,'2013AJ....146...86T',2013,1,0.78,'Cava et al. (2009A&A...495..707C) give z = 0.0611 +/- 0.0001.','G',0.00005,NULL,'14.9g',0.64,'E/S0',NULL,NULL,NULL,NULL,1,18.113917,15.75008,0.089,NULL,67631939558,1056749055,16511703,14.9),(14651,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14651,35.8,0.2,144,3234,70,NULL,NULL,'IC 1645',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14652,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14652,36.07,0.15,163,3234,70,NULL,NULL,'IC 1645',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14653,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 16144','RN',14653,38.88,0.09,459,3235,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 16144',0.299828,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14654,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 16144','RN',14654,39.77,0.19,692,3235,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 16144',0.299828,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14655,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14655,34.06,0.2,64.9,3236,74.4,NULL,NULL,'NGC 0413',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.00011,NULL,'15.06',0.7,'SB(r)c:',NULL,NULL,NULL,NULL,1,18.130833,-2.79342,0.173,NULL,34507015565,539172118,8424564,15.06),(14656,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14656,34.49,0.09,79.2,3236,NULL,NULL,NULL,'NGC 0413',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14657,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14657,35.28,0.46,114,3237,70,NULL,NULL,'ESO 244- G 002',NULL,'2014MNRAS.445.2677S',2014,1,0.88,NULL,'G',0.000077,NULL,'15.30',0.52,'(RL)SA0^0','Group member',NULL,NULL,NULL,1,18.157583,-46.06931,NULL,NULL,38362729701,599417651,9365900,15.3),(14658,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14658,37.63,0.46,335,3238,70,NULL,NULL,'SDSS J011239.48+132630.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000063,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,18.1645417,13.44186,0.109,NULL,67641032479,1056891132,16513923,18.2),(14659,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 01179','RN',14659,40.41,0.09,975,3239,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01179',0.237163,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14660,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14660,35.95,0.59,155,3240,70,NULL,NULL,'2MASX J01124220-1720358',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'14.5R',0.24,NULL,NULL,NULL,NULL,NULL,1,18.175875,-17.34331,0.028,NULL,35417548817,553399200,8646862,14.5),(14661,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14661,36.07,0.15,163,3241,70,NULL,NULL,'2MASX J01124798+1531431',NULL,'2015arXiv151105856S',2015,1,0.61,'Cava et al. (2009A&A...495..707C) give z = 0.1004 +/- 0.0007.','G',0.00008,NULL,'15.8g',0.41,'E0',NULL,NULL,NULL,NULL,1,18.1999166667,15.52861,0.097,NULL,67631227849,1056737935,16511530,15.8),(14662,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 12804','R',14662,39.09,0.19,581,3242,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 12804',0.133717,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,18.2015,1.04017,0.025,NULL,66650791476,1041418616,16272165,NULL),(14663,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 12804','R',14663,39.25,0.12,626,3242,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 12804',0.133717,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14664,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14664,35.03,0.58,101,3243,70,NULL,NULL,'2MASX J01124856-5543280',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.23',0.38,'S0',NULL,NULL,NULL,NULL,1,18.202375,-55.7245,0,NULL,36201458498,565647789,8838246,16.23),(14665,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14665,34.35,0.25,74.1,3244,74.4,NULL,NULL,'NGC 0426',NULL,'2013AJ....146...86T',2013,1,1.14,NULL,'G',0.000144,NULL,'14.0g',0.82,'E+             NLAGN','in a radial-velocity based grouping',NULL,NULL,'Sy 2',1,18.2025417,-0.29019,0.062,NULL,34501601462,539087522,8423242,14),(14666,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14666,34.88,0.46,94.5,3244,70,NULL,NULL,'NGC 0426',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14667,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14667,36.75,0.22,224,3244,70,NULL,NULL,'NGC 0426',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14668,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14668,34.24,0.8,70.5,3245,75,NULL,'MAT, I','ESO 412- G 015',NULL,'1997ApJS..109..333W',1997,1,1.84,'Ramella, et al. (1996, A&A, 312, 745) give v = 18260 +/- 90 km/sec.','G',0.000033,NULL,'15.4b',0.22,'Sc',NULL,NULL,NULL,NULL,1,18.2077083,-31.20056,NULL,NULL,34735686939,542745108,8480392,15.4),(14669,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14669,33.93,0.32,61,3245,85,NULL,'I, raw','ESO 412- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14670,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14670,33.94,0.32,61.5,3245,85,NULL,'I, inv','ESO 412- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14671,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14671,33.98,0.43,62.6,3245,75,NULL,'MAT, I, raw','ESO 412- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14672,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14672,34.11,0.43,66.2,3245,75,NULL,'MAT, I, inv','ESO 412- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14673,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14673,34.24,0.49,70.5,3245,75,NULL,'IR','ESO 412- G 015',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14674,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14674,34.27,0.43,71.5,3245,75,NULL,'MAT, I, cor','ESO 412- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14675,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14675,34.3,0.2,72.4,3245,74.4,NULL,NULL,'ESO 412- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14676,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14676,34.35,NULL,74,3245,NULL,NULL,NULL,'ESO 412- G 015',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14677,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14677,34.41,NULL,76.3,3245,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 412- G 015',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14678,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14678,34.42,NULL,76.5,3245,NULL,NULL,'Dipole + Quadrupole','ESO 412- G 015',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14679,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14679,34.43,NULL,77.1,3245,NULL,NULL,'Dipole','ESO 412- G 015',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14680,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14680,36.87,0.46,237,3246,70,NULL,NULL,'2MASX J01124997+1502061',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000084,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,18.20825,15.03483,0.089,NULL,67642633215,1056916143,16514314,16.7),(14681,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14681,36.21,0.74,175,3247,70,NULL,NULL,'2MASX J01125019-1618448',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.74',0.36,NULL,NULL,NULL,NULL,NULL,1,18.209083,-16.31236,0.018,NULL,35418471207,553413612,8647087,16.74),(14682,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14682,36.32,0.16,184,3248,70,NULL,NULL,'ABELL 0160',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,18.214167,15.51494,0.097,NULL,67631255698,1056738370,16511537,NULL),(14683,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14683,37.12,0.46,265,3249,70,NULL,NULL,'2MASX J01125384-0038316',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.38',0.17,NULL,NULL,NULL,NULL,NULL,1,18.224333,-0.64217,0.108,NULL,34501699728,539089058,8423266,18.38),(14684,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14684,36.07,0.15,163,3250,70,NULL,NULL,'2MASX J01125386+1536091',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00009,NULL,'15.9g',0.33,'S0',NULL,NULL,NULL,NULL,1,18.224583,15.60247,0.097,NULL,67631220751,1056737824,16511528,15.9),(14685,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14685,36.32,0.16,184,3251,70,NULL,'ABELL 0160, BGC','CGCG 436-011',NULL,'1999AJ....118.1489D',1999,1,0.72,NULL,'G',0.000077,NULL,'15.6g',0.28,'S0','Group member',NULL,NULL,NULL,1,18.2250833333,15.54697,0.097,NULL,67631258933,1056738420,16511537,15.6),(14686,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 06259','RN',14686,39.07,0.22,604,3252,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06259',0.078022,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14687,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 06259','RN',14687,40.26,0.27,1050,3252,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06259',0.078022,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14688,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 02690','RN',14688,37.54,0.23,303,3253,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02690',0.064802,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14689,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 02690','RN',14689,40.43,0.65,1150,3253,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02690',0.064802,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14690,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14690,30.01,0.43,10.1,3254,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0428',NULL,'2014MNRAS.444..527S',2014,1,4.1,'UM 309 is a set of four HII regions within NGC 0428.','G',0.000007,NULL,'11.91',3.1,'SAB(s)m        HII','Isolated galaxy',NULL,NULL,NULL,1,18.232125,0.98156,0.025,NULL,66650830026,1041419219,16272175,11.91),(14691,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14691,30.1,0.43,10.5,3254,75,NULL,'3.6 micron, color corrected','NGC 0428',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14692,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14692,30.27,0.2,11.3,3254,74.4,NULL,NULL,'NGC 0428',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14693,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14693,30.62,0.4,13.3,3254,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 3 galaxy group','NGC 0428',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14694,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14694,30.69,0.68,13.8,3254,NULL,NULL,NULL,'NGC 0428',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14695,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14695,30.85,0.36,14.8,3254,NULL,NULL,NULL,'NGC 0428',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14696,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14696,30.87,0.4,14.9,3254,75,NULL,'B','NGC 0428',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14697,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14697,30.99,0.4,15.8,3254,73,NULL,'opt','NGC 0428',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14698,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14698,31.09,0.57,16.5,3254,NULL,NULL,'Malmquist cor.','NGC 0428',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14699,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 15953','R',14699,41.42,0.34,1420,3255,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15953',0.355483,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,18.2364583,0.94033,0.025,NULL,66650829118,1041419204,16272175,NULL),(14700,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 15953','R',14700,41.48,0.37,1460,3255,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15953',0.355483,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14701,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 15953',NULL,14701,41.39,0.25,1900,3255,70,NULL,'SALT 2','SDSS-II SN 15953',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14702,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 15953',NULL,14702,41.44,0.25,1940,3255,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15953',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14703,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 15953',NULL,14703,41.51,0.08,2010,3255,70,NULL,'SN photometric redshift distance, z photo =0.663 +/- 0.036','SDSS-II SN 15953',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14704,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14704,34.85,0.48,93.5,3256,70,NULL,NULL,'NGC 0429',NULL,'2014MNRAS.445.2677S',2014,1,1.52,NULL,'G',0.000077,NULL,'14.3g',0.35,'S0^0^: sp','in a radial-velocity based grouping',NULL,NULL,NULL,1,18.23925,-0.345,0.062,NULL,34501594111,539087407,8423240,14.3),(14705,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14705,36.02,0.39,160,3257,NULL,NULL,'Malmquist cor.','2MFGC 00903',NULL,'2009ApJS..182..474S',2009,1,1.07,NULL,'G',0.000033,NULL,'15.9g',0.21,'Sbc:',NULL,NULL,NULL,NULL,1,18.2475833333,15.59142,0.097,NULL,67631265967,1056738530,16511539,15.9),(14706,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14706,36.12,0.37,167,3257,NULL,NULL,NULL,'2MFGC 00903',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14707,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14707,36.16,0.2,171,3257,74.4,NULL,NULL,'2MFGC 00903',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14708,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14708,36.23,0.49,176,3257,75,NULL,'IR','2MFGC 00903',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14709,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14709,35.8,0.2,144,3258,70,NULL,NULL,'VV 382 NED01',NULL,'2001MNRAS.321..277C',2001,1,0.84,NULL,'G',0.000043,NULL,'15.2g',0.7,'cD',NULL,NULL,NULL,NULL,1,18.2482083,15.49131,0.097,NULL,67631309504,1056739211,16511550,15.2),(14710,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14710,36.07,0.15,163,3258,70,NULL,NULL,'VV 382 NED01',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14711,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14711,35.63,0.25,134,3259,74.4,NULL,NULL,'VV 382',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'GPair',0.00067,NULL,NULL,NULL,'BrClG','Group member',NULL,'radio jet','Flat-Spectrum Radio Source',1,18.249375,15.49133,0.097,NULL,67631309507,1056739211,16511550,NULL),(14712,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14712,34.33,0.47,73.4,3260,70,NULL,NULL,'NGC 0430',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000063,NULL,'13.9b',1.1,'E:','in a radial-velocity based grouping',NULL,NULL,NULL,1,18.2497083,-0.2525,0.062,NULL,34501598340,539087474,8423241,13.9),(14713,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14713,34.35,0.25,74.1,3260,74.4,NULL,NULL,'NGC 0430',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14714,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14714,36.75,0.22,224,3260,70,NULL,NULL,'NGC 0430',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14715,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14715,34.31,0.4,72.8,3260,NULL,NULL,'mean','NGC 0430',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14716,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14716,35.03,0.45,101,3260,NULL,NULL,'K','NGC 0430',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14717,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14717,37.45,0.46,309,3261,70,NULL,NULL,'2MASX J01130216+0008457',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000083,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,18.259167,0.14597,0.036,NULL,66651168681,1041424510,16272257,17.4),(14718,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14718,35.8,0.2,144,3262,70,NULL,NULL,'GIN 048',NULL,'2001MNRAS.321..277C',2001,1,0.59,NULL,'G',0.000047,NULL,'15.5g',0.49,'E/S0',NULL,NULL,NULL,NULL,1,18.2618333333,15.52744,0.097,NULL,67631259465,1056738429,16511537,15.5),(14719,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14719,36.07,0.15,163,3262,70,NULL,NULL,'GIN 048',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14720,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14720,38,0.46,399,3263,70,NULL,NULL,'2MASX J01130389-0101447',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000068,NULL,'17.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,18.2662083,-1.02917,0.136,NULL,34501410676,539084541,8423195,17.6),(14721,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 18298','R',14721,38.38,0.11,424,3264,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007li','SN 2007li',0.119774,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,18.2667083,-0.54,0.054,NULL,34501746953,539089796,8423278,NULL),(14722,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 18298','R',14722,38.4,0.2,428,3264,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007li','SN 2007li',0.119774,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14723,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14723,37.4,0.46,302,3265,70,NULL,NULL,'2MASX J01130434+1415413',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000081,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,18.268083,14.26167,0.093,NULL,67639254057,1056863344,16513489,16.9),(14724,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14724,36.54,0.64,203,3266,70,NULL,NULL,'MCG -03-04-030',NULL,'2014MNRAS.445.2677S',2014,1,1.1,'ESO misidentifies ESO 541-IG 26 as MCG -03-04-030 & 031.','G',0.00015,NULL,'16.60',0.9,'SA0-: pec',NULL,NULL,NULL,NULL,1,18.2695416667,-18.997,0.011,NULL,35207438311,550116223,8595565,16.6),(14725,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 15803',NULL,14725,39.21,0.79,695,3267,70,NULL,'SN photometric redshift distance, z photo =0.178 +/- 0.091','SDSS-II SN 15803',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.8g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,18.270875,-0.67178,0.108,NULL,34501704205,539089128,8423267,21.8),(14726,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 15803',NULL,14726,40.8,0.37,1450,3267,70,NULL,NULL,'SDSS-II SN 15803',NULL,'2013MNRAS.434.1443X',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14727,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 15803','R',14727,41.77,0.45,1580,3267,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 15803',0.429323,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14728,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 15803','R',14728,41.82,0.37,1620,3267,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 15803',0.429323,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14729,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 15803',NULL,14729,41.67,0.32,2160,3267,70,NULL,'SALT 2','SDSS-II SN 15803',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14730,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 15803',NULL,14730,41.75,0.32,2240,3267,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15803',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14731,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 19061','RN',14731,44.3,0.3,4840,3268,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 19061',0.499671,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14732,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14732,35.69,0.31,137,3269,NULL,NULL,'Malmquist cor.','ESO 352- G 021',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'15.13',0.4,'Sb',NULL,NULL,NULL,NULL,1,18.280667,-34.01578,NULL,NULL,38271659729,597994683,9343666,15.13),(14733,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14733,35.94,0.28,154,3269,NULL,NULL,NULL,'ESO 352- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14734,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14734,35.98,0.2,157,3269,74.4,NULL,NULL,'ESO 352- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14735,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 15740','RN',14735,43.05,0.51,3090,3270,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15740',0.317825,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14736,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 15740','RN',14736,43.41,0.49,3640,3270,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15740',0.317825,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14737,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 15773',NULL,14737,41.47,0.12,1970,3271,70,NULL,'SN photometric redshift distance, z photo =0.645 +/- 0.054','SDSS-II SN 15773',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,18.2849166667,-0.99933,0.136,NULL,34501410095,539084532,8423195,NULL),(14738,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14738,36.42,0.39,192,3272,NULL,NULL,'Malmquist cor.','2MASX J01131189+1505583',NULL,'2009ApJS..182..474S',2009,1,0.57,'Pinkney, et al. (2000AJ....120.2269P) give v=45460 +/- 200 km/sec.','G',0.00003,NULL,'16.8g',0.15,'Sc(f)',NULL,NULL,NULL,NULL,1,18.299667,15.09958,0.097,NULL,67642648207,1056916378,16514318,16.8),(14739,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14739,36.57,0.36,206,3272,NULL,NULL,NULL,'2MASX J01131189+1505583',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14740,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14740,36.61,0.2,210,3272,74.4,NULL,NULL,'2MASX J01131189+1505583',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14741,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14741,34.2,0.13,69.3,3273,NULL,NULL,NULL,'UGC 00764',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000014,NULL,'16.52',0.1,'Scd',NULL,NULL,NULL,NULL,1,18.3020417,34.96519,0.169,NULL,67749645382,1058588209,16540440,16.52),(14742,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14742,34.34,NULL,73.9,3273,NULL,NULL,NULL,'UGC 00764',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14743,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14743,34.48,NULL,78.7,3273,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00764',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14744,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14744,34.48,NULL,78.8,3273,NULL,NULL,'Dipole + Quadrupole','UGC 00764',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14745,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14745,34.49,NULL,79,3273,NULL,NULL,'Dipole','UGC 00764',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14746,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14746,34.63,0.2,84.3,3273,74.4,NULL,NULL,'UGC 00764',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14747,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14747,34.68,0.43,86.1,3273,75,NULL,'3.6 micron, color corrected','UGC 00764',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14748,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14748,34.72,0.43,87.8,3273,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00764',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14749,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14749,35.32,0.62,116,3274,70,NULL,NULL,'LCRS B011059.7-450133',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.000067,NULL,'15.78',0.52,'S0',NULL,NULL,NULL,NULL,1,18.304333,-44.76075,NULL,NULL,38362111782,599407996,9365749,15.78),(14750,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14750,35.57,0.49,130,3275,75,NULL,'IR','CGCG 411-007',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',NULL,NULL,'15.58',0.2,NULL,NULL,NULL,NULL,NULL,1,18.305875,8.86514,0.173,NULL,67562976544,1055671508,16494867,15.58),(14751,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 02294','RN',14751,43.79,0.36,4040,3276,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02294',0.42033,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14752,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 02294','RN',14752,44.34,0.33,5190,3276,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02294',0.42033,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14753,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14753,35.65,0.25,135,3277,74.4,NULL,NULL,'VV 377 NED01',NULL,'2013AJ....146...86T',2013,1,0.87,NULL,'G',0.000043,NULL,'14.9g',0.68,'E/S0','Group member',NULL,NULL,NULL,1,18.315375,15.51644,0.097,NULL,67631261728,1056738464,16511538,14.9),(14754,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14754,35.8,0.2,144,3277,70,NULL,NULL,'VV 377 NED01',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14755,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14755,36.07,0.15,163,3277,70,NULL,NULL,'VV 377 NED01',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14756,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 19523','R',14756,41.2,0.33,1220,3278,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19523',0.421841,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,18.315833,-0.02539,0.071,NULL,34500513686,539070526,8422976,NULL),(14757,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 19523',NULL,14757,40.55,0.61,1290,3278,70,NULL,'SN photometric redshift distance, z photo =0.365 +/- 0.160','SDSS-II SN 19523',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14758,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 19523','R',14758,41.41,0.32,1340,3278,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19523',0.421841,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14759,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 19523',NULL,14759,41.29,0.24,1810,3278,70,NULL,'SALT 2','SDSS-II SN 19523',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14760,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 19523',NULL,14760,41.37,0.24,1880,3278,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19523',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14761,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14761,36.97,0.52,248,3279,70,NULL,NULL,'2MASX J01131843-1519541',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.36',0.48,NULL,NULL,NULL,NULL,NULL,1,18.32675,-15.33169,0.015,NULL,35417992906,553406139,8646970,16.36),(14762,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14762,37,0.46,251,3280,70,NULL,NULL,'LSBC F611-03',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.0001,NULL,'16.7g',0.3,'Sc(r)/LSB disk',NULL,NULL,NULL,NULL,1,18.3340417,14.72772,0.089,NULL,67638436436,1056850569,16513290,16.7),(14763,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14763,36.44,0.39,194,3281,NULL,NULL,'Malmquist cor.','2MASX J01132289+1515522',NULL,'2009ApJS..182..474S',2009,1,0.53,NULL,'G',0.000104,NULL,'16.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,18.345333,15.26469,0.097,NULL,67631098523,1056735914,16511498,16.8),(14764,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14764,36.61,0.36,210,3281,NULL,NULL,NULL,'2MASX J01132289+1515522',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14765,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14765,36.65,0.2,214,3281,74.4,NULL,NULL,'2MASX J01132289+1515522',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14766,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14766,35.59,0.47,131,3282,NULL,NULL,NULL,'2MASX J01132427+1514282',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000027,NULL,'16.1g',0.32,'Sc:',NULL,NULL,NULL,NULL,1,18.351125,15.24106,0.097,NULL,67631097987,1056735906,16511498,16.1),(14767,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14767,35.63,0.2,134,3282,74.4,NULL,NULL,'2MASX J01132427+1514282',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14768,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14768,35.81,0.43,145,3282,NULL,NULL,'Malmquist cor.','2MASX J01132427+1514282',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14769,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14769,36,0.2,158,3283,74.4,NULL,NULL,'CGCG 459-017',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000027,NULL,'15.7g',0.31,'Sc',NULL,NULL,NULL,NULL,1,18.3520416667,15.78278,0.097,NULL,67632017557,1056750274,16511723,15.7),(14770,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14770,36.88,0.63,237,3284,70,NULL,NULL,'2MASX J01132528-1522151',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'17.05',0.24,NULL,NULL,NULL,NULL,NULL,1,18.35525,-15.37089,0.015,NULL,35418001095,553406267,8646972,17.05),(14771,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004fo',NULL,14771,41.16,0.23,1140,3285,74.2,NULL,'SALT 2','ESSENCE J011328.97+003516.3',0.5,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,18.3707083333,0.58786,0.033,NULL,66649210181,1041393909,16271779,NULL),(14772,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004fo','R',14772,41.18,NULL,1150,3285,65,NULL,'SN g120, SALT','ESSENCE J011328.97+003516.3',0.5,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14773,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004fo',NULL,14773,41.85,0.18,1570,3285,65,NULL,'SN g120, SALT2','ESSENCE J011328.97+003516.3',0.5,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14774,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004fo',NULL,14774,41.92,0.26,1610,3285,70,NULL,'SN g120, SALT','ESSENCE J011328.97+003516.3',0.5,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14775,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004fo',NULL,14775,42,0.21,1670,3285,65,NULL,'SN g120, MLCS2k2','ESSENCE J011328.97+003516.3',0.5,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14776,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004fo',NULL,14776,42.05,0.23,1710,3285,65,NULL,'SN g120, SALT','ESSENCE J011328.97+003516.3',0.5,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14777,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004fo',NULL,14777,42.22,0.08,1860,3285,65,NULL,'SN g120, SALT','ESSENCE J011328.97+003516.3',0.5,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14778,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004fo',NULL,14778,42.3,0.19,1930,3285,65,NULL,'SN g120, MLCS2k2','ESSENCE J011328.97+003516.3',0.5,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14779,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004hn','R',14779,42.41,NULL,1900,3286,65,NULL,'SN k430, MLCS17','ESSENCE J011332.38+003715.3',0.6,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,18.3849166667,0.62092,0.033,NULL,66649208751,1041393886,16271779,NULL),(14780,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004hn',NULL,14780,42.45,0.33,1930,3286,74.2,NULL,'SALT 2','ESSENCE J011332.38+003715.3',0.6,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14781,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004hn',NULL,14781,43.21,0.28,2740,3286,70,NULL,'SN k430, SALT','ESSENCE J011332.38+003715.3',0.6,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14782,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004hn',NULL,14782,43.25,0.23,2790,3286,65,NULL,'SN k430, MLCS17','ESSENCE J011332.38+003715.3',0.6,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14783,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004hn',NULL,14783,43.29,0.22,2840,3286,65,NULL,'SN k430, MLCS31','ESSENCE J011332.38+003715.3',0.6,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14784,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004hn',NULL,14784,43.31,0.2,2870,3286,65,NULL,'SN k430, MLCS2k2','ESSENCE J011332.38+003715.3',0.6,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14785,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004hn',NULL,14785,43.36,0.29,2940,3286,65,NULL,'SN k430, SALT2','ESSENCE J011332.38+003715.3',0.6,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14786,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004hn',NULL,14786,43.41,0.25,3000,3286,65,NULL,'SN k430, SALT','ESSENCE J011332.38+003715.3',0.6,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14787,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004hn',NULL,14787,43.41,0.13,3010,3286,65,NULL,'SN k430, SALT','ESSENCE J011332.38+003715.3',0.6,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14788,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14788,35.77,0.52,143,3287,NULL,NULL,NULL,'2MFGC 00913',NULL,'2009ApJS..182..474S',2009,1,0.86,NULL,'G',0.000016,NULL,'16.6g',0.16,'Sb(f)',NULL,NULL,NULL,'Sy 2',1,18.38775,0.49667,0.041,NULL,66649254965,1041394608,16271790,16.6),(14789,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14789,35.8,0.51,144,3287,NULL,NULL,'Malmquist cor.','2MFGC 00913',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14790,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14790,35.81,0.2,145,3287,74.4,NULL,NULL,'2MFGC 00913',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14791,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14791,36.09,0.49,165,3287,75,NULL,'IR','2MFGC 00913',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14792,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14792,36.48,0.46,198,3288,70,NULL,NULL,'2MASX J01133446+1532246',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000087,NULL,'17.1g',0.22,'NLAGN',NULL,NULL,NULL,NULL,1,18.3935417,15.54033,0.097,NULL,67631141464,1056736585,16511509,17.1),(14793,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004fk',NULL,14793,40.57,0.28,1000,3289,74.2,NULL,'SALT 2','ESSENCE J011335.84-000927.6',0.296,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,18.399333,-0.15767,0.071,NULL,34500561728,539071277,8422988,NULL),(14794,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004fk',NULL,14794,41.19,0.3,1340,3289,65,NULL,'SN g055, SALT2','ESSENCE J011335.84-000927.6',0.296,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14795,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004fk',NULL,14795,41.36,0.35,1440,3289,65,NULL,'SN g055, MLCS31','ESSENCE J011335.84-000927.6',0.296,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14796,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004fk',NULL,14796,41.39,0.35,1460,3289,65,NULL,'SN g055, MLCS2k2','ESSENCE J011335.84-000927.6',0.296,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14797,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004fk',NULL,14797,41.39,0.25,1470,3289,65,NULL,'SN g055, MLCS2k2','ESSENCE J011335.84-000927.6',0.296,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14798,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004fk',NULL,14798,41.56,0.31,1580,3289,65,NULL,'SN g055, MLCS17','ESSENCE J011335.84-000927.6',0.296,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14799,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004fk',NULL,14799,41.55,0.33,1580,3289,65,NULL,'SN g055, SALT','ESSENCE J011335.84-000927.6',0.296,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14800,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004fk',NULL,14800,41.57,0.26,1590,3289,70,NULL,'SN g055, SALT','ESSENCE J011335.84-000927.6',0.296,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14801,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004fk',NULL,14801,41.57,0.34,1590,3289,65,NULL,'SN g055, SALT2','ESSENCE J011335.84-000927.6',0.296,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14802,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004fk','R',14802,42.26,NULL,2180,3289,65,NULL,'SN g055, MLCS31','ESSENCE J011335.84-000927.6',0.296,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14803,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004fk',NULL,14803,42.42,0.2,2350,3289,65,NULL,'SN g055, SALT','ESSENCE J011335.84-000927.6',0.296,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14804,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14804,36.15,0.74,170,3290,70,NULL,NULL,'2MASX J01133620-0146203',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.0001,NULL,'17.34',0.18,NULL,NULL,NULL,NULL,NULL,1,18.400875,-1.77236,0.224,NULL,34510176880,539221513,8425336,17.34),(14805,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14805,36.4,0.2,191,3291,74.4,NULL,NULL,'SDSS J011336.59+002424.9',NULL,'2013AJ....146...86T',2013,1,0.19,NULL,'G',0.000058,NULL,'17.8g',0.15,'S0',NULL,NULL,NULL,NULL,1,18.4024583,0.40694,0.037,NULL,66649216364,1041394005,16271781,17.8),(14806,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 16215','R',14806,36.4,0.06,182,3292,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ne','2MASX J01133756+0025256',0.046615,'2014arXiv1401.3317S',2014,1,0.48,'Dressler(1980,ApJS,42,565) position points to a different object.','G',0.000023,NULL,'17.6g',0.11,'Scd(f)','Group member',NULL,NULL,NULL,1,18.4065833333,0.42375,0.037,NULL,66649216882,1041394013,16271781,17.6),(14807,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 16215','R',14807,36.69,0.19,208,3292,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ne','2MASX J01133756+0025256',0.046615,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14808,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14808,36.29,0.36,181,3292,NULL,NULL,'Malmquist cor.','2MASX J01133756+0025256',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14809,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14809,36.36,0.35,187,3292,NULL,NULL,NULL,'2MASX J01133756+0025256',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14810,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004hl',NULL,14810,40,0.21,787,3293,74.2,NULL,'SALT 2','SDSS J011338.07-002736.6',0.27,'2010ApJ...716..712A',2010,1,0.1,NULL,'G',NULL,NULL,'20.0g',0.09,NULL,NULL,NULL,NULL,NULL,1,18.408625,-0.46019,0.054,NULL,34500639600,539072493,8423007,20),(14811,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004hl','R',14811,40.58,NULL,1030,3293,65,NULL,'SN k425, MLCS17','SDSS J011338.07-002736.6',0.27,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14812,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004hl',NULL,14812,40.73,0.2,1100,3293,65,NULL,'SN k425, SALT2','SDSS J011338.07-002736.6',0.27,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14813,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004hl',NULL,14813,40.77,0.22,1120,3293,70,NULL,'SN k425, SALT','SDSS J011338.07-002736.6',0.27,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14814,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004hl',NULL,14814,40.83,0.3,1150,3293,65,NULL,'SN k425, MLCS17','SDSS J011338.07-002736.6',0.27,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14815,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004hl',NULL,14815,40.84,0.22,1160,3293,65,NULL,'SN k425, MLCS2k2','SDSS J011338.07-002736.6',0.27,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14816,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004hl',NULL,14816,40.9,0.19,1190,3293,65,NULL,'SN k425, SALT','SDSS J011338.07-002736.6',0.27,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14817,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004hl',NULL,14817,40.9,0.24,1190,3293,65,NULL,'SN k425, SALT2','SDSS J011338.07-002736.6',0.27,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14818,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004hl',NULL,14818,41.08,0.28,1300,3293,65,NULL,'SN k425, MLCS31','SDSS J011338.07-002736.6',0.27,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14819,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004hl',NULL,14819,41.12,0.26,1320,3293,65,NULL,'SN k425, MLCS2k2','SDSS J011338.07-002736.6',0.27,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14820,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2004hl',NULL,14820,41.13,0.06,1330,3293,65,NULL,'SN k425, SALT','SDSS J011338.07-002736.6',0.27,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14821,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 04669','R',14821,39.39,0.22,661,3294,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 04669',0.142,'2014arXiv1401.3317S',2014,1,0.04,NULL,'G',NULL,'PHOT','22.5g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,18.4080833333,-0.96644,0.136,NULL,34500934049,539077094,8423079,22.5),(14822,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 04669','R',14822,39.58,0.21,722,3294,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 04669',0.142,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14823,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 04669',NULL,14823,39.85,0.43,934,3294,70,NULL,'SN photometric redshift distance, z photo =0.248 +/- 0.065','SDSS-II SN 04669',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14824,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14824,37.33,0.46,293,3295,70,NULL,NULL,'2MASX J01134033+1428076',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000106,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,18.417917,14.46886,0.089,NULL,67638556466,1056852444,16513319,16.8),(14825,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14825,37.8,0.46,363,3296,70,NULL,NULL,'2MASX J01134141+0040046',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000083,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,18.4224583,0.66781,0.041,NULL,66649341103,1041395954,16271811,17.5),(14826,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14826,33.68,0.23,54.5,3297,74.4,NULL,NULL,'IC 1648',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000077,NULL,'15.0',0.2,'S0',NULL,NULL,NULL,NULL,1,18.4255,33.21822,0.177,NULL,67761241753,1058769402,16543271,15),(14827,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14827,35.07,0.55,103,3298,70,NULL,NULL,'2MASX J01134317-3150350',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.000097,NULL,'15.17',0.57,'Sa             LLAGN',NULL,NULL,NULL,NULL,1,18.429917,-31.84311,NULL,NULL,34735997283,542749957,8480468,15.17),(14828,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 17434','R',14828,39.87,0.2,798,3299,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 17434',0.178799,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,18.43725,-0.07289,0.071,NULL,34500565642,539071338,8422989,NULL),(14829,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 17434','R',14829,39.89,0.12,805,3299,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 17434',0.178799,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14830,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14830,34.59,0.58,82.8,3300,70,NULL,NULL,'ESO 412- G 017',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000087,NULL,'15.08',1,'(R_1)SBa',NULL,NULL,NULL,NULL,1,18.4397083,-31.06331,NULL,NULL,34736285503,542754460,8480538,15.08),(14831,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 14386','R',14831,38.98,0.09,598,3301,70,NULL,'SDSS CAND. Variable; MLCS2K2','MCG +00-04-045',0.044344,'2014arXiv1401.3317S',2014,1,0.73,NULL,'G',0.000023,NULL,'15.5g',0.45,'SBa','Group member',NULL,NULL,NULL,1,18.443,0.30572,0.065,NULL,66649287414,1041395115,16271798,15.5),(14832,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 14386','R',14832,39.64,0.23,813,3301,70,NULL,'SDSS CAND. Variable; SALT 2','MCG +00-04-045',0.044344,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14833,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14833,36.09,0.38,165,3301,NULL,NULL,'Malmquist cor.','MCG +00-04-045',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14834,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14834,36.19,0.36,173,3301,NULL,NULL,NULL,'MCG +00-04-045',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14835,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14835,36.23,0.2,176,3301,74.4,NULL,NULL,'MCG +00-04-045',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14836,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14836,36.66,0.1,215,3302,70,NULL,NULL,'2MASX J01134683+0012071',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000119,NULL,'16.2g',0.29,'E/S0','Group member',NULL,NULL,NULL,1,18.4452083,0.20203,0.065,NULL,66649104448,1041392257,16271754,16.2),(14837,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14837,34.06,0.46,64.9,3303,70,NULL,NULL,'NGC 0439',NULL,'2014MNRAS.445.2677S',2014,1,2.5,NULL,'G',0.000083,NULL,'12.59',1.5,'SAB(rs)0-?    LLAGN?','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,18.446917,-31.74714,NULL,NULL,34736121607,542751900,8480498,12.59),(14838,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14838,33.54,0.45,51,3303,NULL,NULL,'K','NGC 0439',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14839,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14839,34.38,0.4,75.3,3303,NULL,NULL,'mean','NGC 0439',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14840,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14840,35.64,0.25,134,3304,74.4,NULL,NULL,'GIN 050',NULL,'2013AJ....146...86T',2013,1,0.45,NULL,'G',0.00007,NULL,'16.0g',0.4,'E/S0',NULL,NULL,NULL,NULL,1,18.4484583,15.50831,0.093,NULL,67631161982,1056736905,16511514,16),(14841,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14841,35.8,0.2,144,3304,70,NULL,NULL,'GIN 050',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14842,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14842,36.07,0.15,163,3304,70,NULL,NULL,'GIN 050',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14843,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14843,37.88,0.46,377,3305,70,NULL,NULL,'2MASX J01134948-0043359',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000103,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,18.456125,-0.72678,0.113,NULL,34500911613,539076743,8423074,17.3),(14844,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14844,36.45,0.46,195,3306,70,NULL,NULL,'2MASX J01135298-0841249',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000078,NULL,'16.8g',0.33,NULL,NULL,NULL,NULL,NULL,1,18.4707083,-8.69019,0.159,NULL,35297047091,551516360,8617443,16.8),(14845,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2006hx',NULL,14845,36.13,0.06,169,3307,72,NULL,'M(H) = -18.317 mag','2MASX J01135716+0022171',NULL,'2014ApJ...784..105W',2013,1,0.34,NULL,'G',0.000084,NULL,'16.5g',0.22,'S0','Group member',NULL,NULL,NULL,1,18.48825,0.37142,0.037,NULL,66649236417,1041394319,16271786,16.5),(14846,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2006hx',NULL,14846,36.17,0.1,171,3307,70,NULL,'SALT 2','2MASX J01135716+0022171',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14847,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2006hx',NULL,14847,36.17,0.1,171,3307,70,NULL,'SALT 2, Malmquist cor.','2MASX J01135716+0022171',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14848,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 14279','R',14848,36.31,0.19,175,3307,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006hx','2MASX J01135716+0022171',0.045494,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14849,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 14279','R',14849,36.33,0.06,176,3307,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006hx','2MASX J01135716+0022171',0.045494,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14850,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2006hx',NULL,14850,37.02,0.21,232,3307,72,NULL,NULL,'2MASX J01135716+0022171',0.04444,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14851,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14851,36.97,0.46,248,3308,70,NULL,NULL,'2MASX J01135768+0100051',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.0001,NULL,'16.7g',0.35,NULL,NULL,NULL,NULL,NULL,1,18.49025,1.00142,0.041,NULL,66649043048,1041391297,16271739,16.7),(14852,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14852,34.04,0.8,64.1,3309,75,NULL,'MAT, I','ESO 080- G 001',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.85',0.7,'SAB(s)cd',NULL,NULL,NULL,NULL,1,18.4919583,-62.39914,0,NULL,36069856011,563591500,8806117,14.85),(14853,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14853,33.91,0.59,60.6,3309,NULL,NULL,NULL,'ESO 080- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14854,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14854,33.95,0.2,61.7,3309,74.4,NULL,NULL,'ESO 080- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14855,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14855,34.1,0.32,66,3309,85,NULL,'I, raw','ESO 080- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14856,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14856,34.11,0.32,66.5,3309,85,NULL,'I, inv','ESO 080- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14857,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14857,34.15,0.53,67.5,3309,NULL,NULL,'Malmquist cor.','ESO 080- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14858,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14858,34.3,0.43,72.3,3309,75,NULL,'MAT, I, raw','ESO 080- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14859,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14859,34.41,0.43,76.1,3309,75,NULL,'MAT, I, inv','ESO 080- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14860,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14860,34.67,0.43,85.8,3309,75,NULL,'MAT, I, cor','ESO 080- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14861,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14861,35.62,0.76,133,3310,70,NULL,NULL,'LCRS B011146.1-454040',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00014,NULL,'17.01',0.28,'S0 pec','Group member',NULL,NULL,NULL,1,18.4949583,-45.41311,NULL,NULL,38364938179,599452159,9366439,17.01),(14862,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14862,37.05,0.46,258,3311,70,NULL,NULL,'2MASX J01140087+1402399',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00008,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,18.5037083,14.04439,0.089,NULL,67606291549,1056348305,16505442,17.5),(14863,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14863,33.98,0.8,62.6,3312,75,NULL,'MAT, I','ESO 113- G 027',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000026,NULL,'14.20',0.2,'(R\')SB(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,18.5060417,-57.93517,0,NULL,36233211189,566143924,8845998,14.2),(14864,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14864,33.72,0.32,55.5,3312,85,NULL,'I, raw','ESO 113- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14865,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14865,33.75,0.32,56.3,3312,85,NULL,'I, inv','ESO 113- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14866,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14866,34.01,0.43,63.5,3312,75,NULL,'MAT, I, raw','ESO 113- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14867,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14867,34.18,0.43,68.5,3312,75,NULL,'MAT, I, inv','ESO 113- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14868,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14868,34.45,0.43,77.5,3312,75,NULL,'MAT, I, cor','ESO 113- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14869,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14869,33.91,0.8,60.4,3313,75,NULL,'CF, r','UGC 00784',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000017,NULL,'14.63',0.8,'Sb',NULL,NULL,NULL,NULL,1,18.5170833333,-1.74228,0.224,NULL,34510181811,539221590,8425337,14.63),(14870,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14870,34.3,0.08,72.6,3313,NULL,NULL,NULL,'UGC 00784',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14871,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14871,34.62,0.38,84.1,3313,75,NULL,'CF, r, raw','UGC 00784',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14872,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14872,34.65,0.2,85.1,3313,74.4,NULL,NULL,'UGC 00784',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14873,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14873,34.74,0.38,88.5,3313,75,NULL,'CF, r, cor','UGC 00784',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14874,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14874,34.74,0.38,88.7,3313,75,NULL,'CF, r, inv','UGC 00784',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14875,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14875,34.68,0.8,86.3,3314,75,NULL,'HMCL, I','NGC 0431',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000067,NULL,'13.86',0.9,'SB0',NULL,NULL,NULL,NULL,1,18.518917,33.70419,0.177,NULL,67761670279,1058776098,16543376,13.86),(14876,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14876,34.18,0.45,68.7,3314,NULL,NULL,'K','NGC 0431',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14877,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14877,34.52,0.4,80,3314,NULL,NULL,'mean','NGC 0431',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14878,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14878,35.14,0.4,106,3314,75,NULL,'HMCL, I, raw','NGC 0431',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14879,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14879,35.43,0.4,122,3314,75,NULL,'HMCL, I, inv','NGC 0431',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14880,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14880,35.46,0.4,123,3314,75,NULL,'HMCL, I, cor','NGC 0431',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14881,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14881,36.28,0.55,181,3315,70,NULL,NULL,'2MASX J01140661-1245384',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.47',0.39,NULL,NULL,NULL,NULL,NULL,1,18.527625,-12.76075,0,NULL,35404595004,553196796,8643699,16.47),(14882,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14882,33.24,0.8,44.5,3316,75,NULL,'MAT, I','IC 1657',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.000013,NULL,'13.15',0.5,'(R\')SB(s)bc;Sy2HII',NULL,NULL,NULL,'Sy 2',1,18.52925,-32.65089,NULL,NULL,38278292956,598098327,9345286,13.15),(14883,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14883,33.07,0.46,41.1,3316,NULL,NULL,'J','IC 1657',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14884,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14884,33.09,0.43,41.5,3316,75,NULL,'MAT, I, raw','IC 1657',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14885,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14885,33.1,0.32,41.6,3316,85,NULL,'I, raw','IC 1657',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14886,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14886,33.12,0.47,42.1,3316,NULL,NULL,'H','IC 1657',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14887,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14887,33.15,0.32,42.6,3316,85,NULL,'I, inv','IC 1657',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14888,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14888,33.17,0.45,43,3316,NULL,NULL,'K','IC 1657',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14889,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14889,33.24,0.4,44.5,3316,NULL,NULL,'mean','IC 1657',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14890,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14890,33.33,0.43,46.4,3316,75,NULL,'MAT, I, inv','IC 1657',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14891,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14891,33.37,0.49,47.2,3316,75,NULL,'IR','IC 1657',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14892,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14892,33.42,0.2,48.3,3316,74.4,NULL,NULL,'IC 1657',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14893,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14893,33.49,0.43,49.8,3316,75,NULL,'MAT, I, cor','IC 1657',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14894,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14894,33.7,0.34,55,3316,NULL,NULL,NULL,'IC 1657',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14895,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14895,33.71,0.34,55.2,3316,NULL,NULL,'Malmquist cor.','IC 1657',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14896,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14896,34.14,0.08,67.4,3317,NULL,NULL,NULL,'CGCG 385-036',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000043,NULL,'14.90',0.6,NULL,NULL,NULL,NULL,NULL,1,18.542625,-1.85389,0.224,NULL,34510063900,539219748,8425308,14.9),(14897,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14897,35.61,0.25,132,3318,74.4,NULL,NULL,'UGC 00785',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000017,NULL,'14.71',0.9,'(R)SAB0^0^:',NULL,NULL,NULL,NULL,1,18.560417,15.89831,0.101,NULL,67631458417,1056741537,16511586,14.71),(14898,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14898,35.8,0.2,144,3318,70,NULL,NULL,'UGC 00785',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14899,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14899,36.64,0.88,213,3319,70,NULL,NULL,'2MFGC 00926',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'16.81',0.16,NULL,NULL,NULL,NULL,NULL,1,18.56225,-14.66125,0,NULL,35405207488,553206367,8643849,16.81),(14900,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14900,36.25,0.33,178,3320,NULL,NULL,NULL,'2MASX J01141571+1538129',NULL,'2009ApJS..182..474S',2009,1,0.59,NULL,'G',0.00003,NULL,'15.13',NULL,'Sa(f)',NULL,NULL,NULL,NULL,1,18.5655,15.63692,0.101,NULL,67631136393,1056736506,16511507,15.13),(14901,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14901,36.27,0.33,179,3320,NULL,NULL,'Malmquist cor.','2MASX J01141571+1538129',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14902,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14902,36.29,0.2,181,3320,74.4,NULL,NULL,'2MASX J01141571+1538129',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14903,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 17068','RN',14903,39.59,0.65,597,3321,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17068',0.387771,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14904,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 17068','RN',14904,41.13,1.02,1210,3321,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17068',0.387771,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14905,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14905,37.31,0.33,290,3322,70,NULL,NULL,'2MASXi J0114165+143541',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000088,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,18.569,14.59464,0.097,NULL,67605920241,1056342503,16505351,17.6),(14906,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 05859','RN',14906,41.22,0.35,1420,3323,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 05859',0.240003,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14907,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 05859','RN',14907,41.3,0.32,1470,3323,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05859',0.240003,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14908,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14908,37.31,0.33,290,3324,70,NULL,NULL,'2MASX J01141746+1437339',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000085,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,18.5727083,14.62625,0.097,NULL,67605918574,1056342477,16505351,16.8),(14909,'TRGB','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14909,23.98,0.26,0.626,3325,NULL,NULL,NULL,'ANDROMEDA XV',NULL,'2012ApJ...758...11C',2012,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'dSph',NULL,NULL,NULL,NULL,1,18.577917,38.1175,0.233,0,67896001143,1060875017,16576172,NULL),(14910,'TRGB','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14910,24,0.2,0.63,3325,NULL,NULL,'I','ANDROMEDA XV',NULL,'2007ApJ...671.1591I',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14911,'TRGB','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14911,24.4,0.2,0.76,3325,NULL,NULL,'I','ANDROMEDA XV',NULL,'2009MNRAS.400.1472L',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14912,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14912,37.39,0.46,300,3326,70,NULL,NULL,'2MASX J01142053+1408529',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000091,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,18.5855,14.14803,0.089,NULL,67606815499,1056356492,16505570,17.6),(14913,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14913,36.52,0.25,201,3327,74.4,NULL,NULL,'GIN 058',NULL,'2013AJ....146...86T',2013,1,0.55,NULL,'G',0.000073,NULL,'15.6g',0.53,'E','Group member',NULL,NULL,NULL,1,18.5897917,0.17972,0.081,NULL,66649298457,1041395288,16271801,15.6),(14914,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14914,36.66,0.1,215,3327,70,NULL,NULL,'GIN 058',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14915,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14915,36.75,0.22,224,3327,70,NULL,NULL,'GIN 058',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14916,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14916,35.16,0.49,107,3328,75,NULL,'IR','UGC 00778',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',NULL,NULL,'17.',0.11,'Sd',NULL,NULL,NULL,NULL,1,18.592917,50.22728,0.973,NULL,67682933767,1057545840,16524153,17),(14917,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14917,35.51,NULL,126,3328,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00778',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14918,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14918,35.53,NULL,127,3328,NULL,NULL,'Dipole + Quadrupole','UGC 00778',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14919,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14919,35.53,NULL,128,3328,NULL,NULL,'Dipole','UGC 00778',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14920,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14920,35.55,NULL,129,3328,NULL,NULL,NULL,'UGC 00778',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14921,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14921,35.99,0.54,158,3329,70,NULL,NULL,'2MASX J01142273-1638213',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.17',0.45,NULL,NULL,NULL,NULL,NULL,1,18.5947917,-16.63928,0.021,NULL,35420381780,553443465,8647554,16.17),(14922,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14922,36,0.66,158,3330,70,NULL,NULL,'2MASX J01142388-1522173',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'16.20',0.29,NULL,NULL,NULL,NULL,NULL,1,18.5995417,-15.37153,0.015,NULL,35410513421,553289272,8645144,16.2),(14923,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14923,36.66,0.1,215,3331,70,NULL,NULL,'2MASX J01142404+0028126',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00006,NULL,'17.4g',0.2,'E/S0','Group member',NULL,NULL,NULL,1,18.6001666667,0.47003,0.037,NULL,66649357485,1041396210,16271815,17.4),(14924,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14924,36.66,0.1,215,3332,70,NULL,NULL,'2MASX J01142471+0024286',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.0001,NULL,'16.8g',0.23,'E','Group member',NULL,NULL,NULL,1,18.602875,0.40806,0.041,NULL,66649228860,1041394200,16271784,16.8),(14925,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14925,36.36,0.33,187,3333,70,NULL,NULL,'2MASX J01142504+1343099',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000095,NULL,'16.2g',0.4,'E0',NULL,NULL,NULL,NULL,1,18.60425,13.71944,0.081,NULL,67606407673,1056350119,16505470,16.2),(14926,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14926,36.87,0.82,236,3334,70,NULL,NULL,'2MASX J01142572-1321473',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,18.6072083,-13.36319,0.017,NULL,35407820779,553247199,8644487,15.5),(14927,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14927,34.56,0.8,81.5,3335,75,NULL,'CF, r','UGC 00783',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000023,NULL,'14.44',0.8,'SAB(rs)c',NULL,NULL,NULL,NULL,1,18.6094583,42.55631,0.349,NULL,67889549238,1060774206,16574596,14.44),(14928,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14928,34.51,0.38,79.8,3335,75,NULL,'CF, r, raw','UGC 00783',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14929,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14929,34.64,0.38,84.6,3335,NULL,NULL,'Malmquist cor.','UGC 00783',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14930,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14930,34.64,0.38,84.8,3335,75,NULL,'CF, r, inv','UGC 00783',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14931,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14931,34.65,0.38,85.2,3335,75,NULL,'CF, r, cor','UGC 00783',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14932,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14932,34.7,0.2,87.1,3335,74.4,NULL,NULL,'UGC 00783',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14933,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14933,34.71,0.36,87.6,3335,NULL,NULL,NULL,'UGC 00783',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14934,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14934,36.75,0.33,224,3336,70,NULL,NULL,'2MASX J01142676+1516252',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000087,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,18.6114583,15.27361,0.085,NULL,67600682311,1056260661,16504072,16.7),(14935,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14935,37.76,0.33,356,3337,70,NULL,NULL,'2MASX J01142944+0028126',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00025,NULL,'16.8',0.19,'E','Group member',NULL,NULL,NULL,1,18.622667,0.47019,0.037,NULL,66649357090,1041396204,16271815,16.8),(14936,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 03910','RN',14936,40.08,0.42,746,3338,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03910',0.389345,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14937,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 03910','RN',14937,40.69,0.38,990,3338,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03910',0.389345,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14938,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14938,34.23,0.8,70,3339,75,NULL,'MAT, I','ESO 412- G 021',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.00003,NULL,'15.19',0.3,'SA(r)b',NULL,NULL,NULL,NULL,1,18.6239583,-31.18144,NULL,NULL,34735790323,542746723,8480417,15.19),(14939,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14939,34.24,0.4,70.6,3339,NULL,NULL,'mean','ESO 412- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14940,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14940,34.54,0.32,81,3339,85,NULL,'I, raw','ESO 412- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14941,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14941,34.59,0.45,82.7,3339,NULL,NULL,'K','ESO 412- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14942,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14942,34.59,0.32,82.8,3339,85,NULL,'I, inv','ESO 412- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14943,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14943,34.6,0.47,83,3339,NULL,NULL,'H','ESO 412- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14944,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14944,34.66,0.43,85.7,3339,75,NULL,'MAT, I, raw','ESO 412- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14945,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14945,34.89,0.43,94.9,3339,75,NULL,'MAT, I, inv','ESO 412- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14946,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14946,34.98,0.43,99.2,3339,75,NULL,'MAT, I, cor','ESO 412- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14947,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14947,34.99,0.2,99.5,3339,74.4,NULL,NULL,'ESO 412- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14948,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14948,35.05,0.69,103,3339,NULL,NULL,'Malmquist cor.','ESO 412- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14949,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14949,35.26,0.63,113,3339,NULL,NULL,NULL,'ESO 412- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14950,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14950,36.66,0.1,215,3340,70,NULL,NULL,'2MASX J01143024+0031436',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00019,NULL,'16.7',0.17,'E/S0','Group member',NULL,NULL,NULL,1,18.626,0.52892,0.037,NULL,66649346528,1041396039,16271813,16.7),(14951,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14951,37.76,0.33,356,3341,70,NULL,NULL,'2MASX J01143090+0028126',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000075,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,18.628833,0.47025,0.037,NULL,66649357241,1041396206,16271815,18.5),(14952,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14952,34.12,0.8,66.8,3342,75,NULL,'MAT, I','ESO 352- G 027',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.1',1,'SB(s)bc pec:',NULL,NULL,NULL,NULL,1,18.6305,-32.26428,NULL,NULL,38278481999,598101281,9345332,14.1),(14953,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14953,34.9,0.32,95.3,3342,85,NULL,'I, raw','ESO 352- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14954,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14954,34.96,0.32,98.3,3342,85,NULL,'I, inv','ESO 352- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14955,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14955,35.28,0.43,114,3342,75,NULL,'MAT, I, raw','ESO 352- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14956,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14956,35.61,0.43,132,3342,75,NULL,'MAT, I, inv','ESO 352- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14957,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14957,35.63,0.43,134,3342,75,NULL,'MAT, I, cor','ESO 352- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14958,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14958,37.9,0.46,380,3343,70,NULL,NULL,'2MASX J01143228+1425103',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000077,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,18.6345833333,14.41964,0.097,NULL,67606126335,1056345723,16505401,17.5),(14959,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14959,36.11,0.64,167,3344,NULL,NULL,'Malmquist cor.','SDSS J011432.82+010015.1',NULL,'2009ApJS..182..474S',2009,1,0.58,NULL,'G',0.000023,NULL,'17.4g',0.13,'Sc(f)',NULL,NULL,NULL,NULL,1,18.63675,1.00419,0.037,NULL,66649030255,1041391097,16271735,17.4),(14960,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14960,36.18,0.62,172,3344,NULL,NULL,NULL,'SDSS J011432.82+010015.1',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14961,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14961,36.22,0.2,175,3344,74.4,NULL,NULL,'SDSS J011432.82+010015.1',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14962,'BCG','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14962,39.28,0.35,643,3345,60,NULL,'ABELL 0166, BCG','2MASX J01143345-1616526',0.1156,'1980ApJ...241..486H',1980,1,0.29,NULL,'G',NULL,NULL,'17.63',0.29,NULL,'Brightest group member',NULL,NULL,NULL,1,18.6393333333,-16.28131,0.019,NULL,35418304563,553411008,8647047,17.63),(14963,'BCG','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14963,39.28,0.35,643,3346,60,NULL,NULL,'ABELL 0166',0.1156,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III:   [BM]',NULL,NULL,NULL,NULL,1,18.639917,-16.26903,0.019,NULL,35418304684,553411010,8647047,NULL),(14964,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14964,36.75,0.33,224,3347,70,NULL,NULL,'2MASX J01143597+1459303',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00009,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,18.649875,14.99186,0.097,NULL,67600651744,1056260183,16504065,17.1),(14965,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 14215','RN',14965,37.73,0.06,347,3348,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14215',0.015539,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14966,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14966,34.52,0.5,80.2,3349,70,NULL,NULL,'NGC 0442',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000053,NULL,'14.45',0.5,'S0/a: sp','in a radial-velocity based grouping',NULL,NULL,NULL,1,18.6610417,-1.02064,0.15,NULL,34501003161,539078174,8423096,14.45),(14967,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14967,36.32,0.41,183,3350,NULL,NULL,'Malmquist cor.','2MASX J01144386+0017100',NULL,'2009ApJS..182..474S',2009,1,0.56,NULL,'G',0.000023,NULL,'16.0g',0.33,'Se','Group member',NULL,NULL,'Sy 2',1,18.68275,0.28603,0.081,NULL,66649148668,1041392947,16271764,16),(14968,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14968,36.46,0.39,196,3350,NULL,NULL,NULL,'2MASX J01144386+0017100',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14969,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14969,36.5,0.2,200,3350,74.4,NULL,NULL,'2MASX J01144386+0017100',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14970,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14970,33.32,0.49,46.1,3351,75,NULL,'IR','UGC 00786',NULL,'2011yCatp016004901K',2011,1,1.09,NULL,'G',0.000067,NULL,'17.',0.15,'Sd',NULL,NULL,NULL,NULL,1,18.6849583,50.45264,0.973,NULL,67679975235,1057499613,16523431,17),(14971,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 03892','RN',14971,41.2,0.27,1280,3352,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03892',0.350271,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14972,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 03892','RN',14972,41.33,0.22,1360,3352,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03892',0.350271,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14973,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14973,38.28,0.46,453,3353,70,NULL,NULL,'SDSS J011445.43-004737.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000085,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,18.6893333333,-0.79372,0.15,NULL,34500868283,539076066,8423063,18.7),(14974,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14974,36.75,0.22,224,3354,70,NULL,NULL,'GIN 064',NULL,'2001MNRAS.321..277C',2001,1,0.62,NULL,'G',0.000072,NULL,'15.4g',0.45,'S0/a','Group member',NULL,NULL,NULL,1,18.692875,-0.00108,0.081,NULL,34500659640,539072806,8423012,15.4),(14975,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14975,36.66,0.1,215,3355,70,NULL,NULL,'2MASX J01144873+0013480',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00008,NULL,'16.5g',0.25,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,18.703,0.22997,0.081,NULL,66649161081,1041393141,16271767,16.5),(14976,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14976,37.56,0.46,324,3356,70,NULL,NULL,'SDSS J011448.93+135914.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000075,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,18.7039166667,13.9875,0.085,NULL,67606858660,1056357166,16505580,18.2),(14977,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 14999','RN',14977,40.34,0.09,1020,3357,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14999',0.143805,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14978,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 14999','RN',14978,40.71,0.19,1210,3357,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 14999',0.143805,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14979,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14979,38.02,0.46,402,3358,70,NULL,NULL,'SDSS J011450.89-000710.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000075,NULL,'18.2g',0.15,'S0',NULL,NULL,NULL,NULL,1,18.712083,-0.11947,0.094,NULL,34500692988,539073327,8423020,18.2),(14980,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14980,36.97,0.46,247,3359,70,NULL,NULL,'2MASX J01145093+1419433',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000096,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,18.7122083,14.32864,0.085,NULL,67606097746,1056345277,16505394,16.7),(14981,'BL Lac Luminosity','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14981,41.32,0.02,1840,3360,70,NULL,NULL,'2MASS J01145278+1325376',NULL,'2014ApJ...784..151S',2014,1,NULL,NULL,'QSO',NULL,'PHOT','17.0r',NULL,'BLLAC',NULL,NULL,NULL,'BL Lac',1,18.719917,13.42708,0.081,NULL,67606250123,1056347658,16505432,17),(14982,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14982,36.66,0.1,215,3361,70,NULL,NULL,'2MASX J01145420+0030270',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000102,NULL,'16.2g',0.28,'Se','Group member',NULL,NULL,NULL,1,18.725917,0.50739,0.037,NULL,66649574494,1041399601,16271868,16.2),(14983,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14983,36.52,0.25,201,3362,74.4,NULL,NULL,'GIN 060',NULL,'2013AJ....146...86T',2013,1,0.52,NULL,'G',0.000124,NULL,'15.7g',0.47,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,18.7260417,0.30328,0.045,NULL,66649425315,1041397270,16271832,15.7),(14984,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14984,36.66,0.1,215,3362,70,NULL,NULL,'GIN 060',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14985,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14985,36.75,0.22,224,3362,70,NULL,NULL,'GIN 060',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14986,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14986,36.66,0.1,215,3363,70,NULL,NULL,'2MASX J01145613+0023300',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000082,NULL,'17.3g',0.2,'E','Group member',NULL,NULL,NULL,1,18.7337917,0.39153,0.045,NULL,66649569708,1041399526,16271867,17.3),(14987,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14987,36.42,0.33,192,3364,70,NULL,NULL,'2MASX J01145631-0911107',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000097,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,18.7345,-9.18636,0.114,NULL,35285331186,551333299,8614582,16.5),(14988,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14988,37.5,0.72,317,3364,70,NULL,NULL,'2MASX J01145631-0911107',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14989,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14989,35.74,0.47,141,3365,NULL,NULL,'Malmquist cor.','MCG +00-04-056',NULL,'2009ApJS..182..474S',2009,1,0.54,NULL,'G',0.000023,NULL,'15.7g',0.39,'S0/a:','Group member',NULL,NULL,NULL,1,18.734417,0.13069,0.081,NULL,66649193533,1041393648,16271775,15.7),(14990,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14990,35.78,0.47,143,3365,NULL,NULL,NULL,'MCG +00-04-056',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14991,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14991,35.82,0.2,146,3365,74.4,NULL,NULL,'MCG +00-04-056',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14992,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14992,36.52,0.25,201,3366,74.4,NULL,NULL,'UGC 00797',NULL,'2013AJ....146...86T',2013,1,0.39,NULL,'G',0.000087,NULL,'14.7g',0.29,'cD;E:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,18.7399583,0.43081,0.037,NULL,66649567373,1041399490,16271867,14.7),(14993,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14993,36.66,0.1,215,3366,70,NULL,NULL,'UGC 00797',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14994,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14994,36.75,0.22,224,3366,70,NULL,NULL,'UGC 00797',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14995,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14995,36.66,0.1,215,3367,70,NULL,NULL,'2MASX J01145959+0015330',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000127,NULL,'15.4',0.6,'Sbe','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,18.748375,0.25919,0.088,NULL,66649430247,1041397347,16271833,15.4),(14996,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',14996,37.63,0.46,336,3368,70,NULL,NULL,'2MASX J01150115+1521221',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00023,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,18.754667,15.35606,0.085,NULL,67600798497,1056262476,16504101,16.8),(14997,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14997,34.3,0.33,72.5,3369,NULL,NULL,'Malmquist cor.','UGC 00799',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.00002,NULL,'16.5',0.4,'Scd:',NULL,NULL,NULL,NULL,1,18.760833,6.85833,0.117,NULL,67569382850,1055771607,16496431,16.5),(14998,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14998,34.4,0.32,75.7,3369,NULL,NULL,NULL,'UGC 00799',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14999,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,14999,34.54,0.2,80.9,3369,74.4,NULL,NULL,'UGC 00799',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15000,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15000,33.71,0.2,55.2,3370,74.4,NULL,NULL,'CGCG 411-012',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000013,NULL,'15.02',0.3,'S?',NULL,NULL,NULL,NULL,1,18.765583,5.37614,0.105,NULL,67523557575,1055055587,16485243,15.02),(15001,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15001,33.78,0.49,57.1,3370,NULL,NULL,NULL,'CGCG 411-012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15002,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15002,34.12,0.42,66.6,3370,NULL,NULL,'Malmquist cor.','CGCG 411-012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15003,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15003,35.09,0.56,104,3371,70,NULL,NULL,'LCRS B011250.7-444933',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.04',0.3,NULL,NULL,NULL,NULL,NULL,1,18.765417,-44.56147,NULL,NULL,38361840355,599403755,9365683,15.04),(15004,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15004,37.63,0.57,336,3372,70,NULL,NULL,'2MASX J01150400-5338591',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'17.30',0.19,NULL,NULL,NULL,NULL,NULL,1,18.7669166667,-53.64978,NULL,NULL,36191766867,565496357,8835880,17.3),(15005,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15005,36.42,0.33,192,3373,70,NULL,NULL,'2MASX J01150678-0909376',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000086,NULL,'16.2g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,18.778333,-9.16033,0.114,NULL,35285335849,551333372,8614583,16.2),(15006,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15006,36.74,0.68,223,3374,70,NULL,NULL,'2MASX J01150688-1351464',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'16.28',0.46,NULL,NULL,NULL,NULL,NULL,1,18.778875,-13.86294,0.006,NULL,35406186432,553221663,8644088,16.28),(15007,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15007,36.66,0.1,215,3375,70,NULL,NULL,'2MASX J01150733+0027570',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000092,NULL,'16.1g',0.28,'S0/Se','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,18.780583,0.46578,0.037,NULL,66649587189,1041399799,16271871,16.1),(15008,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15008,36.37,0.39,188,3376,NULL,NULL,'Malmquist cor.','FGC 0142',NULL,'2009ApJS..182..474S',2009,1,0.86,NULL,'G',0.000033,NULL,'17.4g',0.13,'Scd(f)',NULL,NULL,NULL,NULL,1,18.78725,15.29228,0.085,NULL,67600900389,1056264068,16504126,17.4),(15009,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15009,36.47,0.37,197,3376,NULL,NULL,NULL,'FGC 0142',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15010,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15010,36.51,0.2,200,3376,74.4,NULL,NULL,'FGC 0142',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15011,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15011,36.66,0.1,215,3377,70,NULL,NULL,'2MASX J01150953+0040530',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000097,NULL,'17.4g',0.21,'E/S0',NULL,NULL,NULL,NULL,1,18.789625,0.68144,0.037,NULL,66649486876,1041398232,16271847,17.4),(15012,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15012,33.19,0.2,43.5,3378,74.4,NULL,NULL,'KUG 0112+335',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000033,NULL,'15.3',0.5,'Sbc','Group member, peripheral',NULL,NULL,NULL,1,18.790625,33.79069,0.149,NULL,67761694872,1058776482,16543382,15.3),(15013,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15013,34.2,0.1,69.3,3378,NULL,NULL,NULL,'KUG 0112+335',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15014,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15014,34.15,0.4,67.6,3379,NULL,NULL,'mean','IC 1654',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000033,NULL,'14.06',1.2,'(R)SB(r)a','in a radial-velocity based grouping',NULL,NULL,NULL,1,18.7995,30.19483,0.153,NULL,67270718407,1051104975,16423515,14.06),(15015,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15015,34.15,0.47,67.7,3379,NULL,NULL,'H','IC 1654',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15016,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15016,34.31,0.46,72.8,3379,NULL,NULL,'J','IC 1654',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15017,'BCG','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15017,36.97,0.35,237,3380,60,NULL,NULL,'ABELL 0168',0.0457,'1980ApJ...241..486H',1980,1,NULL,'Katgert (1996,A&A,310,8) identifies multiple redshift systems in this cluster.','GClstr',NULL,NULL,NULL,NULL,'II-III:[BM]',NULL,NULL,NULL,NULL,1,18.8,0.33,0.057,NULL,66649435945,1041397436,16271834,NULL),(15018,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15018,35.98,0.3,157,3380,72,NULL,'MASS PLANE','ABELL 0168',NULL,'2015MNRAS.451.2723S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15019,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15019,36.11,0.36,167,3380,72,NULL,NULL,'ABELL 0168',NULL,'2015MNRAS.451.2723S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15020,'Magnitude','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15020,35.63,0.13,134,3380,100,NULL,NULL,'ABELL 0168',NULL,'1998A&A...337...31R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15021,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15021,36.53,0.11,203,3380,70,NULL,NULL,'ABELL 0168',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15022,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15022,36.67,0.46,216,3381,70,NULL,NULL,'2MASX J01151256+1327511',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.00012,NULL,'15.4g',0.59,'BrClG',NULL,NULL,NULL,NULL,1,18.8024583,13.46428,0.045,NULL,67606262300,1056347848,16505435,15.4),(15023,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15023,36.66,0.1,215,3382,70,NULL,NULL,'2MASX J01151290+0020323',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.000334,NULL,'15.9',0.42,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,18.8037083333,0.34231,0.057,NULL,66649432840,1041397388,16271834,15.9),(15024,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 15760','R',15024,39.48,0.3,696,3383,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006mh','SN 2006mh',0.129,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,18.8057916667,0.39925,0.041,NULL,66649576100,1041399626,16271869,NULL),(15025,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 15760','R',15025,39.68,0.4,763,3383,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006mh','SN 2006mh',0.129,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15026,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 15016','RN',15026,42.63,0.2,2420,3384,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 15016',0.387667,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15027,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 15016','RN',15027,42.65,0.15,2440,3384,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 15016',0.387667,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15028,'BCG','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15028,36.97,0.35,237,3385,60,NULL,'ABELL 0168, BCG','GIN 061',0.0457,'1980ApJ...241..486H',1980,1,0.24,NULL,'G',0.0001,NULL,'15.6g',0.19,'E              LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,18.8157917,0.2135,0.088,NULL,66649428374,1041397318,16271833,15.6),(15029,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15029,35.98,0.3,157,3385,72,NULL,'MASS PLANE, ABELL 0168, BCG','GIN 061',NULL,'2015MNRAS.451.2723S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15030,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15030,36.11,0.36,167,3385,72,NULL,'ABELL 0168, BCG','GIN 061',NULL,'2015MNRAS.451.2723S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15031,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15031,36.52,0.25,201,3385,74.4,NULL,NULL,'GIN 061',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15032,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15032,36.66,0.1,215,3385,70,NULL,NULL,'GIN 061',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15033,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15033,36.75,0.22,224,3385,70,NULL,NULL,'GIN 061',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15034,'Magnitude','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15034,35.63,0.13,134,3385,100,NULL,NULL,'GIN 061',NULL,'1998A&A...337...31R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15035,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15035,36.53,0.11,203,3385,70,NULL,'ABELL 0168, BGC','GIN 061',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15036,'SBF','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15036,32.36,0.14,29.7,3386,74.4,NULL,NULL,'NGC 0448',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.000017,NULL,'13.14',0.8,'S0-',NULL,NULL,NULL,NULL,1,18.8188333333,-1.62619,0.265,NULL,34510116728,539220573,8425321,13.14),(15037,'SBF','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15037,32.41,0.35,30.3,3386,NULL,NULL,'I','NGC 0448',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15038,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15038,32.78,0.57,36,3386,70,NULL,NULL,'NGC 0448',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15039,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15039,31.27,0.45,17.9,3386,NULL,NULL,'K','NGC 0448',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15040,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15040,31.68,0.4,21.7,3386,NULL,NULL,'mean','NGC 0448',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15041,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15041,36.52,0.25,201,3387,74.4,NULL,NULL,'2MASX J01151677+0011083',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'E','Group member',NULL,NULL,NULL,1,18.819875,0.18564,0.088,NULL,66649444389,1041397568,16271837,NULL),(15042,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15042,36.75,0.22,224,3388,70,NULL,NULL,'SDSS J011516.77+001108.3',NULL,'2001MNRAS.321..277C',2001,1,0.53,NULL,'G',NULL,NULL,'15.7g',0.38,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,18.819875,0.18567,0.088,NULL,66649444389,1041397568,16271837,15.7),(15043,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 09597','RN',15043,39.29,0.34,690,3389,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 09597',0.045056,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15044,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 09597','RN',15044,39.38,0.49,719,3389,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 09597',0.045056,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15045,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 04676','R',15045,40.54,0.2,1030,3390,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J011517.69+004717.7',0.2446,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',0.0005,NULL,'21.5g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,18.8237083,0.78828,0.037,NULL,66648988803,1041390450,16271725,21.5),(15046,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 04676','R',15046,40.71,0.12,1120,3390,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J011517.69+004717.7',0.2446,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15047,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 04676',NULL,15047,40.45,0.1,1230,3390,70,NULL,'SALT 2','SDSS J011517.69+004717.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15048,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 04676',NULL,15048,40.46,0.1,1240,3390,70,NULL,'SALT 2, Malmquist cor.','SDSS J011517.69+004717.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15049,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15049,34.06,0.1,65,3391,NULL,NULL,NULL,'UGC 00800',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000033,NULL,'14.94',0.8,'Scd:',NULL,NULL,NULL,NULL,1,18.830417,28.48956,0.105,NULL,67307630015,1051681718,16432526,14.94),(15050,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15050,38.32,0.46,461,3392,70,NULL,NULL,'2MASX J01151944+0013563',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000088,NULL,'18.0g',0.16,'Se',NULL,NULL,NULL,NULL,1,18.830875,0.23247,0.088,NULL,66649446857,1041397607,16271837,18),(15051,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15051,37.18,0.33,274,3393,70,NULL,NULL,'2MASX J01152071-0938306',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.0001,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,18.8364583,-9.64189,0.095,NULL,35286584471,551352882,8614888,16.6),(15052,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15052,36.38,0.2,189,3394,74.4,NULL,NULL,'UGC 00802',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',NULL,NULL,'16.0',0.7,'Sc',NULL,NULL,NULL,NULL,1,18.8394166667,7.35578,0.085,NULL,67568673984,1055760531,16496258,16),(15053,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15053,37.18,0.33,274,3395,70,NULL,NULL,'2MASX J01152207-0941306',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000086,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,18.841917,-9.69197,0.095,NULL,35286615260,551353363,8614896,16.9),(15054,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15054,36.66,0.1,215,3396,70,NULL,NULL,'2MASX J01152490+0016543',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000085,NULL,'16.5g',0.31,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,18.853625,0.28181,0.057,NULL,66649441635,1041397525,16271836,16.5),(15055,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15055,35.19,0.55,109,3397,70,NULL,NULL,'2MASX J01152596-3145210',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000113,NULL,'15.83',0.35,'E',NULL,NULL,NULL,NULL,1,18.85825,-31.75583,NULL,NULL,34736053729,542750839,8480481,15.83),(15056,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15056,35.69,0.57,138,3398,70,NULL,NULL,'LCRS B011315.3-450201',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'16.14',0.25,'S',NULL,NULL,NULL,NULL,1,18.867,-44.76939,NULL,NULL,38361824224,599403503,9365679,16.14),(15057,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15057,37.98,0.46,395,3399,70,NULL,NULL,'2MASX J01152833-0003209',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000081,NULL,'17.5g',0.2,'S0/E','Group member',NULL,NULL,NULL,1,18.868167,-0.05578,0.094,NULL,34500657041,539072766,8423011,17.5),(15058,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15058,34.36,0.37,74.6,3400,NULL,NULL,'Malmquist cor.','UGC 00805',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.00001,NULL,'16.5',0.3,'Sc',NULL,NULL,NULL,NULL,1,18.874167,6.88417,0.109,NULL,67569349861,1055771091,16496423,16.5),(15059,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15059,34.62,0.33,83.8,3400,NULL,NULL,NULL,'UGC 00805',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15060,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15060,34.62,0.2,84,3400,74.4,NULL,NULL,'UGC 00805',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15061,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15061,31.71,0.8,22,3401,75,NULL,'MAT, I','NGC 0450',NULL,'1997ApJS..109..333W',1997,1,3.1,'Possible host galaxy of UM 311.','G',0.000013,NULL,'12.2B',2.3,'SAB(s)cd:','Pair member (points to parent)',NULL,NULL,NULL,1,18.876833,-0.86097,0.126,NULL,34500845911,539075717,8423058,12.2),(15062,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15062,30.98,0.32,15.7,3401,85,NULL,'I, raw','NGC 0450',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15063,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15063,30.98,0.32,15.7,3401,85,NULL,'I, inv','NGC 0450',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15064,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15064,31.1,0.43,16.6,3401,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0450',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15065,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15065,31.11,0.43,16.7,3401,75,NULL,'3.6 micron, color corrected','NGC 0450',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15066,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15066,31.14,0.2,16.9,3401,74.4,NULL,NULL,'NGC 0450',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15067,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15067,31.3,0.39,18.2,3401,73,NULL,'opt','NGC 0450',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15068,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15068,31.36,0.4,18.7,3401,NULL,NULL,NULL,'NGC 0450',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15069,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15069,31.38,0.43,18.9,3401,75,NULL,'MAT, I, raw','NGC 0450',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15070,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15070,31.39,0.5,19,3401,NULL,NULL,NULL,'NGC 0450',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15071,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15071,31.39,0.5,19,3401,NULL,NULL,'Malmquist cor.','NGC 0450',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15072,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15072,31.42,0.43,19.2,3401,75,NULL,'MAT, I, inv','NGC 0450',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15073,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15073,31.63,0.43,21.2,3401,75,NULL,'MAT, I, cor','NGC 0450',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15074,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15074,31.75,0.4,22.4,3401,75,NULL,'B','NGC 0450',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15075,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15075,36.66,0.1,215,3402,70,NULL,NULL,'2MASX J01153117+0017573',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000097,NULL,'15.4',0.34,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,18.879917,0.29925,0.057,NULL,66649442716,1041397542,16271836,15.4),(15076,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 02235','RN',15076,41.17,0.27,1270,3403,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 02235',0.347842,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15077,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 02235','RN',15077,41.22,0.39,1300,3403,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02235',0.347842,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15078,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15078,33.3,0.8,45.7,3404,75,NULL,'MAT, I','ESO 475- G 014',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000003,NULL,'14.91',0.5,'SB(s)m pec',NULL,NULL,NULL,NULL,1,18.886167,-26.44683,0.068,NULL,34757406433,543084475,8485694,14.91),(15079,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15079,32.2,0.32,27.6,3404,85,NULL,'I, inv','ESO 475- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15080,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15080,32.22,0.32,27.8,3404,85,NULL,'I, raw','ESO 475- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15081,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15081,32.44,0.43,30.7,3404,75,NULL,'MAT, I, raw','ESO 475- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15082,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15082,32.44,0.43,30.8,3404,75,NULL,'MAT, I, inv','ESO 475- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15083,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15083,32.59,0.68,33,3404,NULL,NULL,NULL,'ESO 475- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15084,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15084,32.63,0.2,33.6,3404,74.4,NULL,NULL,'ESO 475- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15085,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15085,32.71,0.43,34.9,3404,75,NULL,'MAT, I, cor','ESO 475- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15086,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15086,32.75,0.4,35.4,3404,73,NULL,'opt','ESO 475- G 014',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15087,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15087,32.83,0.61,36.8,3404,NULL,NULL,'Malmquist cor.','ESO 475- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15088,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15088,33.05,0.49,40.7,3404,75,NULL,'IR','ESO 475- G 014',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15089,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 07423','RN',15089,42.93,0.34,2830,3405,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 07423',0.36412,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15090,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 07423','RN',15090,43.09,0.31,3040,3405,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 07423',0.36412,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15091,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15091,34.79,0.53,90.9,3406,70,NULL,NULL,'MCG -01-04-018',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.30',0.8,'S0',NULL,NULL,NULL,NULL,1,18.9038333333,-6.59831,0.318,NULL,35293628887,551462951,8616608,15.3),(15092,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15092,36.66,0.1,215,3407,70,NULL,NULL,'2MASX J01153917+0006113',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,18.913333,0.10306,0.088,NULL,66649405378,1041396959,16271827,16.8),(15093,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 03911','RN',15093,38.1,5.45,399,3408,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03911',0.044186,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15094,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 03911','RN',15094,38.68,0.33,520,3408,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03911',0.044186,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15095,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15095,36.36,0.33,187,3409,70,NULL,NULL,'2MASX J01154180+1337152',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000092,NULL,'16.1g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,18.924333,13.621,0.045,NULL,67606712425,1056354881,16505545,16.1),(15096,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 21888','RN',15096,41.08,0.37,1220,3410,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21888',0.342403,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15097,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 21888','RN',15097,41.08,0.37,1220,3410,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 21888',0.342403,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15098,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 21888','N',15098,40.89,0.27,1510,3410,70,NULL,'SALT 2','SDSS-II SN 21888',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15099,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 21888','N',15099,40.93,0.27,1530,3410,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 21888',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15100,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15100,36.42,0.58,193,3411,70,NULL,NULL,'2MASX J01154295-1431043',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.00015,NULL,'15.86',0.45,NULL,NULL,NULL,NULL,NULL,1,18.929,-14.51783,0,NULL,35412658658,553322791,8645668,15.86),(15101,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 14965',NULL,15101,38.94,0.61,613,3412,70,NULL,'SN photometric redshift distance, z photo =0.155 +/- 0.057','SDSS-II SN 14965',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,18.9355,1.03783,0.045,NULL,66653347026,1041458547,16272789,NULL),(15102,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 14965','R',15102,40.55,0.22,1010,3412,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14965',0.280999,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15103,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 14965','R',15103,40.6,0.15,1030,3412,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14965',0.280999,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15104,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 14965',NULL,15104,40.43,0.12,1220,3412,70,NULL,'SALT 2','SDSS-II SN 14965',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15105,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 14965',NULL,15105,40.46,0.12,1240,3412,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14965',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15106,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15106,36.27,0.4,180,3413,NULL,NULL,'Malmquist cor.','2MASX J01154476+0019595',NULL,'2009ApJS..182..474S',2009,1,0.43,NULL,'G',0.00008,NULL,'16.2g',0.27,'Se','Group member',NULL,NULL,NULL,1,18.9362917,0.33242,0.073,NULL,66649422405,1041397225,16271831,16.2),(15107,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15107,36.31,0.39,183,3413,NULL,NULL,NULL,'2MASX J01154476+0019595',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15108,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15108,36.35,0.2,186,3413,74.4,NULL,NULL,'2MASX J01154476+0019595',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15109,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 10030','R',15109,40.38,0.13,1140,3414,70,NULL,'SDSS CAND. Variable; MLCS2K2','2MASX J01154483+0014005',0.044337,'2014arXiv1401.3317S',2014,1,0.47,NULL,'G',0.000023,NULL,'16.4',0.16,'Se','Group member',NULL,NULL,NULL,1,18.936875,0.23333,0.088,NULL,66649450239,1041397659,16271838,16.4),(15110,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 10030','R',15110,41.69,0.24,2090,3414,70,NULL,'SDSS CAND. Variable; SALT 2','2MASX J01154483+0014005',0.044337,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15111,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15111,36.26,0.37,179,3414,NULL,NULL,'Malmquist cor.','2MASX J01154483+0014005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15112,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15112,36.28,0.37,180,3414,NULL,NULL,NULL,'2MASX J01154483+0014005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15113,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15113,36.32,0.2,184,3414,74.4,NULL,NULL,'2MASX J01154483+0014005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15114,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15114,37.25,0.46,282,3415,70,NULL,NULL,'2MASX J01154496-1046340',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000073,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,18.9374166667,-10.77622,0.065,NULL,35282902103,551295345,8613989,16.7),(15115,'BL Lac Luminosity','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15115,40.52,0.03,1270,3416,70,NULL,NULL,'BZB J0115+2519',NULL,'2014ApJ...784..151S',2014,1,NULL,NULL,'QSO',NULL,'EST','19.0',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,18.9422917,25.3315,0.225,NULL,67298380767,1051537199,16430268,19),(15116,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 04779','RN',15116,42.4,0.37,1970,3417,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 04779',0.53536,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15117,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15117,34.94,0.2,97.3,3418,74.4,NULL,NULL,'AGC 111795',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',NULL,NULL,'15.5I',0.1,NULL,NULL,NULL,NULL,NULL,1,18.95,5.11139,0.081,NULL,67523399118,1055053111,16485204,15.5),(15118,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15118,35.1,0.82,105,3418,NULL,NULL,'Malmquist cor.','AGC 111795',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15119,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15119,35.14,0.8,107,3418,NULL,NULL,NULL,'AGC 111795',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15120,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15120,33.93,0.8,61.2,3419,75,NULL,'W91PP, r','NGC 0444',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000017,NULL,'15.02',0.4,'Sd','Pair member (points to parent)',NULL,NULL,NULL,1,18.956667,31.08025,0.165,NULL,67272042605,1051125665,16423838,15.02),(15121,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15121,33.93,0.8,61.2,3419,75,NULL,'HMCL, I','NGC 0444',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15122,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15122,33.94,0.8,61.3,3419,75,NULL,'HMCL, I','NGC 0444',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15123,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15123,33.94,0.8,61.3,3419,75,NULL,'W91CL, r','NGC 0444',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15124,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15124,33.95,0.8,61.6,3419,75,NULL,'CF, r','NGC 0444',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15125,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15125,33.07,NULL,41.1,3419,NULL,NULL,'B','NGC 0444',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15126,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15126,33.25,0.38,44.6,3419,75,NULL,'CF, r, raw','NGC 0444',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15127,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15127,33.26,0.38,44.9,3419,75,NULL,'CF, r, inv','NGC 0444',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15128,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15128,33.31,0.4,45.8,3419,75,NULL,'HMCL, I, raw','NGC 0444',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15129,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15129,33.34,0.49,46.5,3419,75,NULL,'IR','NGC 0444',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15130,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15130,33.36,NULL,47,3419,NULL,NULL,'I','NGC 0444',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15131,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15131,33.37,0.2,47.2,3419,74.4,NULL,NULL,'NGC 0444',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15132,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15132,33.38,0.38,47.5,3419,75,NULL,'W91CL, r, raw','NGC 0444',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15133,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15133,33.39,0.4,47.6,3419,75,NULL,'HMCL, I, inv','NGC 0444',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15134,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15134,33.41,0.38,48.1,3419,75,NULL,'W91CL, r, inv','NGC 0444',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15135,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15135,33.42,0.38,48.3,3419,75,NULL,'W91PP, r, raw','NGC 0444',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15136,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15136,33.42,0.38,48.3,3419,75,NULL,'W91PP, r, inv','NGC 0444',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15137,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15137,33.43,0.43,48.5,3419,75,NULL,'3.6 micron, color corrected','NGC 0444',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15138,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15138,33.49,0.4,50,3419,75,NULL,'HMCL, I, raw','NGC 0444',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15139,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15139,33.51,0.43,50.3,3419,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0444',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15140,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15140,33.57,0.4,51.8,3419,75,NULL,'HMCL, I, inv','NGC 0444',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15141,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15141,33.7,0.38,54.9,3419,75,NULL,'CF, r, cor','NGC 0444',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15142,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15142,33.76,0.4,56.4,3419,75,NULL,'HMCL, I, cor','NGC 0444',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15143,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15143,33.79,0.38,57.4,3419,75,NULL,'W91CL, r, cor','NGC 0444',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15144,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15144,33.8,0.38,57.6,3419,75,NULL,'W91PP, r, cor','NGC 0444',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15145,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15145,33.86,0.4,59.2,3419,75,NULL,'HMCL, I, cor','NGC 0444',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15146,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15146,34.2,0.13,69.3,3419,NULL,NULL,NULL,'NGC 0444',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15147,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15147,35.59,0.49,131,3420,75,NULL,'IR','2MFGC 00952',NULL,'2011yCatp016004901K',2011,1,0.57,NULL,'G',0.00003,NULL,'16.9g',0.15,'Sc(f)','Group member',NULL,NULL,NULL,1,18.963917,0.14692,0.088,NULL,66649399288,1041396863,16271825,16.9),(15148,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15148,36.15,0.38,170,3420,NULL,NULL,NULL,'2MFGC 00952',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15149,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15149,36.19,0.2,173,3420,74.4,NULL,NULL,'2MFGC 00952',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15150,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15150,36.2,0.37,173,3420,NULL,NULL,'Malmquist cor.','2MFGC 00952',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15151,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15151,34.92,0.52,96.2,3421,70,NULL,NULL,'MCG -05-04-026',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000103,NULL,'15.20',0.2,'S              HII',NULL,NULL,NULL,NULL,1,18.9649583,-31.58964,NULL,NULL,34735565472,542743210,8480362,15.2),(15152,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15152,36.58,0.47,207,3422,NULL,NULL,'Malmquist cor.','2MASX J01155159+1511482',NULL,'2009ApJS..182..474S',2009,1,0.49,NULL,'G',0.000037,NULL,'17.2g',0.16,'Sb(f)',NULL,NULL,NULL,NULL,1,18.965,15.19669,0.081,NULL,67600851256,1056263300,16504114,17.2),(15153,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15153,36.91,0.4,241,3422,NULL,NULL,NULL,'2MASX J01155159+1511482',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15154,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15154,36.95,0.2,245,3422,74.4,NULL,NULL,'2MASX J01155159+1511482',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15155,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15155,33.48,0.8,49.6,3423,75,NULL,'W91PP, r','UGC 00809',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000017,NULL,'15.4',0.2,'Scd:','Group non-member, foreground',NULL,NULL,NULL,1,18.966125,33.81072,0.145,NULL,67761802554,1058778164,16543408,15.4),(15156,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15156,33.48,0.8,49.7,3423,75,NULL,'HMCL, I','UGC 00809',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15157,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15157,34.05,0.49,64.7,3423,75,NULL,'IR','UGC 00809',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15158,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15158,34.13,0.43,67.1,3423,75,NULL,'3.6 micron, color corrected','UGC 00809',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15159,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15159,34.13,0.43,67.1,3423,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00809',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15160,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15160,34.17,0.2,68.2,3423,74.4,NULL,NULL,'UGC 00809',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15161,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15161,34.2,0.13,69.3,3423,NULL,NULL,NULL,'UGC 00809',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15162,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15162,34.2,0.38,69.3,3423,75,NULL,'W91PP, r, raw','UGC 00809',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15163,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15163,34.24,0.4,70.6,3423,75,NULL,'HMCL, I, raw','UGC 00809',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15164,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15164,34.27,0.38,71.4,3423,75,NULL,'W91PP, r, inv','UGC 00809',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15165,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15165,34.34,0.38,73.9,3423,75,NULL,'W91PP, r, cor','UGC 00809',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15166,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15166,34.37,0.4,75,3423,75,NULL,'HMCL, I, inv','UGC 00809',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15167,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15167,34.39,0.4,75.7,3423,75,NULL,'HMCL, I, cor','UGC 00809',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15168,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15168,35.48,0.51,125,3424,70,NULL,NULL,'2MASX J01155228-0122063',NULL,'2014MNRAS.445.2677S',2014,1,0.71,NULL,'G',0.00007,NULL,'16.51',0.41,NULL,NULL,NULL,NULL,NULL,1,18.967667,-1.36861,0.197,NULL,34508976199,539202753,8425043,16.51),(15169,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15169,34.17,0.46,68.4,3425,NULL,NULL,NULL,'ESO 151- G 037',NULL,'2009ApJS..182..474S',2009,1,1.25,NULL,'G',0.000033,NULL,'14.92',0.43,'S...',NULL,NULL,NULL,NULL,1,18.9687917,-54.55483,NULL,NULL,36202582445,565665350,8838521,14.92),(15170,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15170,34.22,0.2,69.8,3425,74.4,NULL,NULL,'ESO 151- G 037',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15171,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15171,34.49,0.4,79.1,3425,NULL,NULL,'Malmquist cor.','ESO 151- G 037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15172,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15172,34.07,0.46,65.2,3426,70,NULL,NULL,'CGCG 436-016',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000087,NULL,'14.7g',0.45,'S0',NULL,NULL,NULL,NULL,1,18.9762083,13.35333,0.073,NULL,67607336352,1056364630,16505697,14.7),(15173,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15173,37.05,0.65,258,3427,70,NULL,NULL,'2MASX J01155525-1546513',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'17.13',0.26,NULL,NULL,NULL,NULL,NULL,1,18.980167,-15.78094,0.017,NULL,35410840200,553294378,8645224,17.13),(15174,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15174,37.66,0.46,340,3428,70,NULL,NULL,'SDSS J011557.04+001800.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000071,NULL,'18.6g',0.14,'E',NULL,NULL,NULL,NULL,1,18.9877083,0.30006,0.073,NULL,66649410521,1041397039,16271828,18.6),(15175,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15175,30.57,NULL,13,3429,NULL,NULL,NULL,'UGC 00819',NULL,'2000BSAO...50....5K',2000,1,1.25,'Schneider et al. (1990ApJS...72..245S) give v=5239 +/- 16 km/sec.','G',0.000018,NULL,'18.1',0.11,'Scd',NULL,NULL,NULL,NULL,1,19.002583,6.63703,0.101,NULL,67567423805,1055740996,16495953,18.1),(15176,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15176,32.26,NULL,28.3,3429,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00819',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15177,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15177,32.27,NULL,28.5,3429,NULL,NULL,'Dipole + Quadrupole','UGC 00819',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15178,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15178,32.3,NULL,28.8,3429,NULL,NULL,'Dipole','UGC 00819',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15179,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15179,32.32,0.2,29.1,3429,74.4,NULL,NULL,'UGC 00819',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15180,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15180,37.08,0.46,261,3430,70,NULL,NULL,'SDSS J011601.81-105131.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000081,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,19.0075416667,-10.85875,0.065,NULL,35274733641,551167713,8611995,17.6),(15181,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15181,35.55,0.55,129,3431,70,NULL,NULL,'UGC 00821',NULL,'2014MNRAS.445.2677S',2014,1,0.98,NULL,'G',0.000097,NULL,'15.6g',0.27,'Sc(f)','Group member',NULL,NULL,NULL,1,19.023333,-0.01492,0.138,NULL,34500316665,539067447,8422928,15.6),(15182,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15182,37.33,0.46,292,3432,70,NULL,NULL,'2MASX J01160757+1522407',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,19.031583,15.37811,0.081,NULL,67601633273,1056275519,16504304,16.9),(15183,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15183,36.43,0.52,193,3433,70,NULL,NULL,'2MASX J01161049-1748205',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'16.58',0.25,NULL,NULL,NULL,NULL,NULL,1,19.0437917,-17.80567,0.01,NULL,35408371082,553255798,8644621,16.58),(15184,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15184,36.87,0.55,237,3434,70,NULL,NULL,'2MASX J01161066-1510325',NULL,'2014MNRAS.445.2677S',2014,1,0.69,NULL,'G',0.00015,NULL,'16.27',0.53,NULL,NULL,NULL,NULL,NULL,1,19.0445,-15.17561,0.007,NULL,35410587712,553290433,8645163,16.27),(15185,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15185,35.86,0.46,148,3435,70,NULL,NULL,'2MASX J01161173-0949329',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000081,NULL,'16.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,19.0489583,-9.82575,0.083,NULL,35286521737,551351902,8614873,16.4),(15186,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15186,37.96,0.46,390,3436,70,NULL,NULL,'SDSS J011611.97-000403.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00024,NULL,'16.86',0.16,'E/S0',NULL,NULL,NULL,NULL,1,19.0499166667,-0.06775,0.138,NULL,34500328774,539067637,8422931,16.86),(15187,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 16024',NULL,15187,41.13,0.23,1680,3437,70,NULL,'SN photometric redshift distance, z photo =0.514 +/- 0.084','SDSS-II SN 16024',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,19.050667,-0.37719,0.098,NULL,34500413765,539068965,8422952,NULL),(15188,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005gb',NULL,15188,37.25,0.11,259,3438,74.2,NULL,'SALT 2','2MASX J01161269+0047265',0.086603,'2010ApJ...716..712A',2010,1,0.27,NULL,'G',0.00011,NULL,'17.4g',0.21,'NLAGN',NULL,NULL,NULL,NULL,1,19.0529583,0.79056,0.049,NULL,66653599638,1041462494,16272851,17.4),(15189,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005gb',NULL,15189,37.87,0.03,345,3438,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 03592, SN 2005gb','2MASX J01161269+0047265',0.086603,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15190,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005gb',NULL,15190,37.71,0.05,348,3438,70,NULL,'Hubble residual -0.04 for z0.08656','2MASX J01161269+0047265',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15191,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 03592','R',15191,37.95,0.18,358,3438,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005gb','2MASX J01161269+0047265',0.086603,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15192,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005gb',NULL,15192,37.96,0.08,360,3438,65,NULL,'SALT2','2MASX J01161269+0047265',0.086603,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15193,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005gb',NULL,15193,37.99,0.12,364,3438,70,NULL,'SALT 2','2MASX J01161269+0047265',0.086603,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15194,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005gb',NULL,15194,38.04,NULL,374,3438,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 03592, SN 2005gb','2MASX J01161269+0047265',0.086603,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15195,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005gb',NULL,15195,37.87,0.06,375,3438,70,NULL,'SALT 2','2MASX J01161269+0047265',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15196,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005gb',NULL,15196,37.88,0.06,377,3438,70,NULL,'SALT 2, Malmquist cor.','2MASX J01161269+0047265',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15197,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 03592','R',15197,38.2,0.05,402,3438,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005gb','2MASX J01161269+0047265',0.086603,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15198,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005gb',NULL,15198,38.28,0.07,417,3438,65,NULL,'MLCS2k2','2MASX J01161269+0047265',0.086603,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15199,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15199,37.49,0.33,315,3439,70,NULL,NULL,'SDSS J011612.77+134055.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000082,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,19.05325,13.68222,0.073,NULL,67606734685,1056355229,16505550,18.4),(15200,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15200,36.53,0.25,202,3440,74.4,NULL,NULL,'GIN 062',NULL,'2013AJ....146...86T',2013,1,0.49,NULL,'G',0.000103,NULL,'15.8g',0.41,'E','Group member',NULL,NULL,NULL,1,19.0532917,-0.10789,0.138,NULL,34500319099,539067485,8422929,15.8),(15201,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15201,36.66,0.1,215,3440,70,NULL,NULL,'GIN 062',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15202,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15202,36.75,0.22,224,3440,70,NULL,NULL,'GIN 062',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15203,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15203,37.49,0.33,315,3441,70,NULL,NULL,'2MASX J01161395+1339147',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00009,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,19.058167,13.65414,0.073,NULL,67606736710,1056355261,16505550,17.1),(15204,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15204,34.02,0.8,63.6,3442,75,NULL,'HMCL, I','NGC 0452',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000017,NULL,'13.64',0.8,'SBab','Pair member (points to parent)',NULL,NULL,NULL,1,19.0617917,31.03383,0.165,NULL,67272034901,1051125545,16423836,13.64),(15205,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15205,34.02,0.8,63.6,3442,75,NULL,'W91CL, r','NGC 0452',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15206,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15206,34.02,0.8,63.8,3442,75,NULL,'HMCL, I','NGC 0452',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15207,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15207,34.02,0.8,63.8,3442,75,NULL,'W91PP, r','NGC 0452',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15208,'Sosies','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15208,34.24,0.14,70.5,3442,NULL,NULL,NULL,'NGC 0452',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15209,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15209,33.74,NULL,56,3442,NULL,NULL,'B','NGC 0452',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15210,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15210,33.77,0.2,56.8,3442,74.4,NULL,NULL,'NGC 0452',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15211,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15211,33.78,0.38,56.9,3442,75,NULL,'W91PP, r, raw','NGC 0452',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15212,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15212,33.81,0.47,57.9,3442,NULL,NULL,'H','NGC 0452',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15213,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15213,33.83,0.43,58.3,3442,75,NULL,'3.6 micron, color corrected','NGC 0452',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15214,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15214,33.84,NULL,58.6,3442,NULL,NULL,'I','NGC 0452',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15215,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15215,33.86,0.4,59.1,3442,75,NULL,'HMCL, I, raw','NGC 0452',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15216,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15216,33.86,0.45,59.2,3442,NULL,NULL,'K','NGC 0452',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15217,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15217,33.88,0.46,59.8,3442,NULL,NULL,'J','NGC 0452',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15218,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15218,33.88,0.38,59.8,3442,75,NULL,'W91CL, r, raw','NGC 0452',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15219,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15219,34,0.4,63,3442,75,NULL,'HMCL, I, raw','NGC 0452',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15220,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15220,34,0.38,63.2,3442,75,NULL,'W91PP, r, cor','NGC 0452',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15221,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15221,34.01,0.43,63.3,3442,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0452',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15222,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15222,34.01,0.38,63.4,3442,75,NULL,'W91PP, r, inv','NGC 0452',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15223,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15223,34.07,0.38,65.1,3442,75,NULL,'W91CL, r, cor','NGC 0452',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15224,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15224,34.07,0.4,65.3,3442,75,NULL,'HMCL, I, cor','NGC 0452',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15225,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15225,34.08,0.38,65.5,3442,75,NULL,'W91CL, r, inv','NGC 0452',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15226,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15226,34.1,0.4,66,3442,75,NULL,'HMCL, I, inv','NGC 0452',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15227,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15227,34.17,0.4,68.2,3442,75,NULL,'HMCL, I, cor','NGC 0452',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15228,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15228,34.18,0.4,68.6,3442,NULL,NULL,'mean','NGC 0452',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15229,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15229,34.24,0.4,70.4,3442,75,NULL,'HMCL, I, inv','NGC 0452',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15230,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15230,34.34,0.12,73.9,3442,NULL,NULL,NULL,'NGC 0452',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15231,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15231,35.6,0.54,132,3443,70,NULL,NULL,'2MASX J01161688-6323056',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.54',0.32,NULL,NULL,NULL,NULL,NULL,1,19.070167,-63.38483,0,NULL,36070156355,563596193,8806190,16.54),(15232,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15232,37.64,0.46,337,3444,70,NULL,NULL,'2MASXi J0116188-003822',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000076,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,19.078125,-0.63967,0.081,NULL,34500380586,539068446,8422944,18),(15233,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005lg',NULL,15233,40.58,0.18,968,3445,74.2,NULL,'SALT 2','SDSS J011619.85-004846.4',0.35,'2010ApJ...716..712A',2010,1,0.03,NULL,'G',NULL,NULL,'22.6g',0.02,NULL,NULL,NULL,NULL,NULL,1,19.08275,-0.81289,0.081,NULL,34509559229,539211862,8425185,22.6),(15234,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005lg',NULL,15234,40.51,0.2,1260,3445,70,NULL,'Hubble residual 0.03 for z0.35000','SDSS J011619.85-004846.4',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15235,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005lg',NULL,15235,41.17,0.07,1270,3445,70,NULL,'SDSS-II SN 09207','SDSS J011619.85-004846.4',0.35,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15236,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 09207','R',15236,41.25,0.22,1320,3445,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005lg','SDSS J011619.85-004846.4',0.350268,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15237,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005lg',NULL,15237,41.27,0.2,1330,3445,65,NULL,'SALT2','SDSS J011619.85-004846.4',0.35,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15238,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005lg',NULL,15238,41.31,0.21,1350,3445,70,NULL,'SDSS-II SN 09207, SALT 2','SDSS J011619.85-004846.4',0.35,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15239,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 09207','R',15239,41.39,0.29,1410,3445,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005lg','SDSS J011619.85-004846.4',0.350268,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15240,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005lg',NULL,15240,41.46,0.18,1450,3445,65,NULL,'MLCS2k2','SDSS J011619.85-004846.4',0.35,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15241,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005lg',NULL,15241,41.33,0.18,1850,3445,70,NULL,'SALT 2','SDSS J011619.85-004846.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15242,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SN 2005lg',NULL,15242,41.37,0.18,1880,3445,70,NULL,'SALT 2, Malmquist cor.','SDSS J011619.85-004846.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15243,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15243,34.46,0.4,78.1,3446,NULL,NULL,'mean','UGC 00816',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000037,NULL,'14.2',1,'Sc','in a triple',NULL,NULL,NULL,1,19.085625,46.74797,0.485,NULL,67871151755,1060486746,16570105,14.2),(15244,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15244,35,0.47,100,3446,NULL,NULL,'H','UGC 00816',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15245,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15245,37.3,0.46,288,3447,70,NULL,NULL,'2MASX J01162069+1413437',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000077,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,19.086167,14.22875,0.081,NULL,67606034156,1056344283,16505379,16.8),(15246,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 16478','R',15246,40.89,0.27,1110,3448,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16478',0.363696,'2014arXiv1401.3317S',2014,1,0.1,NULL,'G',NULL,'PHOT','20.5g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,19.086667,0.56753,0.049,NULL,66648617932,1041384655,16271635,20.5),(15247,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 16478',NULL,15247,40.46,1.12,1240,3448,70,NULL,'SN photometric redshift distance, z photo =0.346 +/- 0.349','SDSS-II SN 16478',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15248,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:46','1','SDSS-II SN 16478','R',15248,41.32,0.35,1350,3448,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16478',0.363696,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15249,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15249,38.1,0.33,416,3449,70,NULL,NULL,'2MASX J01162278-0026161',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000099,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,19.095083,-0.43769,0.098,NULL,34500421840,539069091,8422954,17.5),(15250,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15250,37.54,0.46,322,3450,70,NULL,NULL,'2MASX J01162606-1036598',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000072,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,19.108625,-10.61664,0.089,NULL,35282789678,551293588,8613962,17.2),(15251,'FP','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,'R',15251,37.78,0.46,360,3451,70,NULL,NULL,'2MASX J01162798-0002011',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,19.116667,-0.03369,0.138,NULL,34500324704,539067573,8422930,18.1),(15252,'CMD','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15252,23.83,0.42,0.583,3452,NULL,NULL,NULL,'Andromeda II Dwarf Spheroidal',NULL,'1993AJ....106.1819K',1993,1,3.6,NULL,'G',0.00001,NULL,'13.5',2.52,'dSph','Group member',NULL,NULL,NULL,1,19.1240833333,33.41911,0.141,1,67762120382,1058783130,16543486,13.5),(15253,'CMD','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15253,24.09,NULL,0.658,3452,NULL,NULL,NULL,'Andromeda II Dwarf Spheroidal',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15254,'Horizontal Branch','2016-12-15 15:13:44','2016-12-16 11:18:46','1',NULL,NULL,15254,23.83,0.46,0.583,3452,NULL,NULL,NULL,'Andromeda II Dwarf Spheroidal',NULL,'2004MNRAS.350..243M',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15255,'Horizontal Branch','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15255,24.06,0.16,0.649,3452,NULL,NULL,NULL,'Andromeda II Dwarf Spheroidal',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15256,'Horizontal Branch','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15256,24.17,0.06,0.682,3452,NULL,NULL,NULL,'Andromeda II Dwarf Spheroidal',NULL,'2000AJ....119..705D',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15257,'RR Lyrae','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15257,23.93,0.11,0.611,3452,NULL,NULL,'V','Andromeda II Dwarf Spheroidal',NULL,'2013MNRAS.435.3206D',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15258,'RR Lyrae','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15258,24.11,0.02,0.665,3452,NULL,NULL,NULL,'Andromeda II Dwarf Spheroidal',NULL,'2004AJ....127..318P',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15259,'RR Lyrae','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15259,24.15,NULL,0.676,3452,NULL,NULL,NULL,'Andromeda II Dwarf Spheroidal',NULL,'2008ApJ...679...52T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15260,'TRGB','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15260,24,0.05,0.63,3452,NULL,NULL,NULL,'Andromeda II Dwarf Spheroidal',NULL,'2012ApJ...758...11C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15261,'TRGB','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15261,24.01,0.01,0.634,3452,NULL,NULL,NULL,'Andromeda II Dwarf Spheroidal',NULL,'2011ApJ...740...69C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15262,'TRGB','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15262,24.05,0.06,0.646,3452,NULL,NULL,NULL,'Andromeda II Dwarf Spheroidal',NULL,'2004MNRAS.350..243M',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15263,'TRGB','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15263,24.07,0.08,0.65,3452,74.4,NULL,NULL,'Andromeda II Dwarf Spheroidal',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15264,'TRGB','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15264,24.07,0.06,0.652,3452,NULL,NULL,NULL,'Andromeda II Dwarf Spheroidal',NULL,'2005MNRAS.356..979M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15265,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15265,36.05,0.71,162,3453,70,NULL,NULL,'2MASX J01163008-1555081',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'16.42',0.35,NULL,NULL,NULL,NULL,NULL,1,19.12525,-15.91878,0.017,NULL,35410788863,553293575,8645212,16.42),(15266,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15266,37.01,0.46,253,3454,70,NULL,NULL,'2MASX J01163019+1428528',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000111,NULL,'16.4g',0.35,'NLAGN',NULL,NULL,NULL,'Sy 2',1,19.12575,14.48153,0.089,NULL,67608103521,1056376617,16505884,16.4),(15267,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15267,37.43,0.91,306,3455,70,NULL,NULL,'2MASX J01163022-1604121',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'17.03',0.17,NULL,NULL,NULL,NULL,NULL,1,19.1259166667,-16.07003,0.017,NULL,35410775415,553293365,8645208,17.03),(15268,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15268,34.6,0.47,83.3,3456,70,NULL,NULL,'IC 0090',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000053,NULL,'14.50',0.9,'E+',NULL,NULL,NULL,NULL,1,19.1264583,-7.97714,0.238,NULL,35298819898,551544060,8617875,14.5),(15269,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15269,36.22,0.74,175,3457,70,NULL,NULL,'2MASX J01163077-1551351',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'17.17',0.2,NULL,NULL,NULL,NULL,NULL,1,19.12825,-15.85986,0.017,NULL,35410761405,553293146,8645205,17.17),(15270,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15270,36.35,0.46,186,3458,70,NULL,NULL,'2MASX J01163477+1546368',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000088,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,19.1450416667,15.77706,0.077,NULL,67601348954,1056271077,16504235,16.6),(15271,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','PTF10rbp','N',15271,37.8,0.03,335,3459,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10rbp',0.0823,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15272,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 13560','RN',15272,42.97,0.23,2660,3460,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13560',0.477374,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15273,'SGRB','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15273,42.05,NULL,2570,3461,70,NULL,'Amati relation, minimum D','GRB 080602',NULL,'2012A&A...545A..77R',2012,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,19.1757083333,-9.23219,0.144,NULL,35285665953,551338530,8614664,NULL),(15274,'SGRB','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15274,42.4,NULL,3020,3461,70,NULL,'Photometric Distance, Host A, M(R) = -20 mag and spectral slope Beta = 1.0 ','GRB 080602',NULL,'2012A&A...545A..77R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15275,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 15444','RN',15275,41.18,0.22,1380,3462,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15444',0.246462,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15276,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 15444','RN',15276,41.9,0.31,1920,3462,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15444',0.246462,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15277,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 14821',NULL,15277,38.58,0.37,521,3463,70,NULL,'SN photometric redshift distance, z photo =0.130 +/- 0.026','SDSS-II SN 14821',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,19.1792083,-0.32011,0.104,NULL,34500502066,539070344,8422974,NULL),(15278,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SN 2005ir',NULL,15278,36.92,0.15,225,3464,74.2,NULL,'SALT 2','SDSS J011643.87+004736.9',0.07634,'2010ApJ...716..712A',2010,1,0.26,NULL,'G',0.000046,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,19.1827917,0.79361,0.053,NULL,66653644756,1041463199,16272862,17.4),(15279,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SN 2005ir',NULL,15279,37.57,0.14,304,3464,70,NULL,'SALT 2','SDSS J011643.87+004736.9',0.07634,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15280,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SN 2005ir',NULL,15280,37.59,0.13,306,3464,72,NULL,NULL,'SDSS J011643.87+004736.9',0.07634,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15281,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SN 2005ir',NULL,15281,37.59,0.06,306,3464,72,NULL,NULL,'SDSS J011643.87+004736.9',0.07634,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15282,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SN 2005ir',NULL,15282,37.59,0.02,307,3464,70,NULL,'SALT 2','SDSS J011643.87+004736.9',0.07634,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15283,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SN 2005ir',NULL,15283,37.6,0.18,308,3464,73.8,NULL,'SALT 2 (SNANA)','SDSS J011643.87+004736.9',0.0753,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15284,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SN 2005ir',NULL,15284,37.61,0.09,308,3464,65,NULL,'SALT2','SDSS J011643.87+004736.9',0.07634,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15285,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SN 2005ir',NULL,15285,37.64,0.12,314,3464,70,NULL,'SALT 2','SDSS J011643.87+004736.9',0.07634,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15286,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 07876','R',15286,37.65,0.18,314,3464,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ir','SDSS J011643.87+004736.9',0.07634,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15287,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SN 2005ir',NULL,15287,37.5,0.03,316,3464,72,NULL,NULL,'SDSS J011643.87+004736.9',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15288,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SN 2005ir',NULL,15288,37.59,0.07,330,3464,70,NULL,'SALT 2','SDSS J011643.87+004736.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15289,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SN 2005ir',NULL,15289,37.59,0.07,330,3464,70,NULL,'SALT 2, Malmquist cor.','SDSS J011643.87+004736.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15290,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 07876','R',15290,37.76,0.06,331,3464,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ir','SDSS J011643.87+004736.9',0.07634,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15291,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SN 2005ir',NULL,15291,37.9,0.09,354,3464,65,NULL,'MLCS2k2','SDSS J011643.87+004736.9',0.07634,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15292,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SN 2005ir',NULL,15292,38.04,0.14,376,3464,65,NULL,'MLCS17','SDSS J011643.87+004736.9',0.07634,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15293,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SN 2005ir',NULL,15293,38.11,0.17,389,3464,65,NULL,'SALT','SDSS J011643.87+004736.9',0.07634,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15294,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SN 2005ir',NULL,15294,38.11,0.14,389,3464,65,NULL,'MLCS31','SDSS J011643.87+004736.9',0.07634,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15295,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SN 2005ir',NULL,15295,38.16,0.3,398,3464,73.8,NULL,'SALT 2 (SNANA)','SDSS J011643.87+004736.9',0.0753,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15296,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SN 2005ir',NULL,15296,38.25,0.19,415,3464,65,NULL,'SALT2','SDSS J011643.87+004736.9',0.07634,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15297,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15297,38.68,0.46,544,3465,70,NULL,NULL,'SDSS J011644.36+134206.5',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000081,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,19.184833,13.70183,0.073,NULL,67606592218,1056353003,16505515,18),(15298,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15298,34.84,0.43,93.1,3466,NULL,NULL,NULL,'ESO 151- G 038',NULL,'2009ApJS..182..474S',2009,1,0.87,NULL,'G',0.000033,NULL,'15.92',0.29,'S...',NULL,NULL,NULL,NULL,1,19.188875,-52.43439,NULL,NULL,36188535135,565445861,8835091,15.92),(15299,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15299,34.88,0.2,94.6,3466,74.4,NULL,NULL,'ESO 151- G 038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15300,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15300,35,0.4,100,3466,NULL,NULL,'Malmquist cor.','ESO 151- G 038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15301,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 04143','RN',15301,41.68,0.2,1390,3467,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04143',0.56208,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15302,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 16554',NULL,15302,41.24,0.32,1770,3468,70,NULL,'SN photometric redshift distance, z photo =0.553 +/- 0.133','SDSS-II SN 16554',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','23.1g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,19.225375,-0.78017,0.133,NULL,34509591997,539212374,8425193,23.1),(15303,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 16554','R',15303,42.34,0.44,1940,3468,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16554',0.509847,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15304,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 16554',NULL,15304,42.34,0.35,2940,3468,70,NULL,'SALT 2','SDSS-II SN 16554',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15305,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 16554',NULL,15305,42.49,0.35,3150,3468,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16554',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15306,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15306,36.51,0.46,201,3469,70,NULL,NULL,'2MASX J01165475-1022029',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.0001,NULL,'15.7g',0.45,'E0',NULL,NULL,NULL,NULL,1,19.228,-10.36742,0.111,NULL,35286192144,551346752,8614793,15.7),(15307,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15307,36.4,0.46,191,3470,70,NULL,NULL,'SDSS J011656.55+000817.3',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000068,NULL,'16.9g',0.28,'S0/E','Group member',NULL,NULL,NULL,1,19.235625,0.13814,0.101,NULL,66648763580,1041386930,16271670,16.9),(15308,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 04503','RN',15308,39.45,0.15,719,3471,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04503',0.078158,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15309,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 04503','RN',15309,40.19,0.24,1010,3471,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04503',0.078158,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15310,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15310,34.36,0.32,74.3,3472,NULL,NULL,'Malmquist cor.','UGC 00824',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.00006,NULL,'14.88',0.2,'Sa',NULL,NULL,NULL,NULL,1,19.2465,13.02497,0.077,NULL,67607978205,1056374659,16505854,14.88),(15311,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15311,34.6,0.29,83.2,3472,NULL,NULL,NULL,'UGC 00824',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15312,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15312,34.72,0.49,88,3472,75,NULL,'IR','UGC 00824',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15313,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15313,34.73,0.2,88.3,3472,74.4,NULL,NULL,'UGC 00824',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15314,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15314,34.89,0.51,95,3473,70,NULL,NULL,'ESO 244- G 010',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00009,NULL,'14.21',1,'SA(r)a',NULL,NULL,NULL,NULL,1,19.264625,-44.18069,NULL,NULL,38369804136,599528189,9367627,14.21),(15315,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 09598','RN',15315,37.84,0.05,353,3474,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 09598',0.045635,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15316,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 09598','RN',15316,39.24,0.2,675,3474,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 09598',0.045635,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15317,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15317,36.87,0.51,237,3475,70,NULL,NULL,'2MASX J01170423-4659188',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.39',0.37,'S0',NULL,NULL,NULL,NULL,1,19.267583,-46.98858,NULL,NULL,38363132765,599423949,9365999,16.39),(15318,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 04034','RN',15318,42.73,0.22,2710,3476,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 04034',0.298036,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15319,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 04034','RN',15319,42.93,0.25,2970,3476,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04034',0.298036,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15320,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15320,36.72,0.68,221,3477,70,NULL,NULL,'FAIRALL 0689',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.00015,NULL,'15.53',0.57,'S0',NULL,NULL,NULL,NULL,1,19.2702083,-50.28408,NULL,NULL,38134930198,595858284,9310285,15.53),(15321,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15321,36.71,0.46,220,3478,70,NULL,NULL,'2MASX J01170795+0107161',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000086,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,19.2830416667,1.12111,0.065,NULL,66653566727,1041461980,16272843,17),(15322,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15322,35.75,0.46,141,3479,70,NULL,NULL,'2MASX J01170895+0106163',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000087,NULL,'15.8g',0.43,'E0',NULL,NULL,NULL,NULL,1,19.28725,1.10464,0.065,NULL,66653566810,1041461981,16272843,15.8),(15323,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15323,36.82,0.46,232,3480,70,NULL,NULL,'SDSS J011711.63+135352.3',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.6g',0.3,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,19.2984583333,13.89786,0.085,NULL,67606530902,1056352045,16505500,16.6),(15324,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15324,36.62,0.33,210,3481,70,NULL,NULL,'2MASX J01171162+1320274',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000094,NULL,'16.3g',0.3,'NLAGN',NULL,NULL,NULL,NULL,1,19.2985417,13.34092,0.101,NULL,67607057490,1056360273,16505629,16.3),(15325,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15325,35.95,0.64,155,3482,70,NULL,NULL,'2MASX J01171327-1606006',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'16.73',0.19,NULL,NULL,NULL,NULL,NULL,1,19.305333,-16.10008,0.008,NULL,35411874219,553310534,8645477,16.73),(15326,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15326,34.35,0.38,74.3,3483,NULL,NULL,NULL,'ESO 196- G 001',NULL,'2009ApJS..182..474S',2009,1,0.88,NULL,'G',0.000033,NULL,'15.22',0.54,'S...',NULL,NULL,NULL,NULL,1,19.314875,-50.93128,NULL,NULL,38135042256,595860035,9310313,15.22),(15327,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15327,34.4,0.2,75.9,3483,74.4,NULL,NULL,'ESO 196- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15328,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15328,34.62,0.34,83.9,3483,NULL,NULL,'Malmquist cor.','ESO 196- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15329,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15329,38.52,0.46,506,3484,70,NULL,NULL,'2MASX J01171641-0054380',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000118,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,19.3185417,-0.91058,0.133,NULL,34509674190,539213659,8425213,17.3),(15330,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15330,37.41,0.62,304,3485,70,NULL,NULL,'2MASX J01171704-1416356',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'16.42',0.38,NULL,NULL,NULL,NULL,NULL,1,19.321,-14.27661,0.011,NULL,35413373887,553333966,8645843,16.42),(15331,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15331,37.27,0.46,285,3486,70,NULL,NULL,'2MASX J01171742+0030293',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000113,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,19.3224583,0.50819,0.057,NULL,66652888241,1041451378,16272677,16.6),(15332,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15332,38.1,0.33,416,3487,70,NULL,NULL,'2MASX J01171787-0025080',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000096,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,19.3245417,-0.41881,0.108,NULL,34508738542,539199039,8424984,16.8),(15333,'IRAS','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15333,34.3,0.8,72.4,3488,75,NULL,'MAT, I','NGC 0461',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'14.08',0.9,'SAB(s)c:',NULL,NULL,NULL,NULL,1,19.336,-33.84089,NULL,NULL,38283256186,598175877,9346498,14.08),(15334,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15334,33.81,0.32,57.9,3488,85,NULL,'I, raw','NGC 0461',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15335,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15335,33.82,0.43,58.2,3488,75,NULL,'MAT, I, raw','NGC 0461',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15336,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15336,33.85,0.32,59,3488,85,NULL,'I, inv','NGC 0461',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15337,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15337,34.01,0.43,63.3,3488,75,NULL,'MAT, I, inv','NGC 0461',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15338,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15338,34.14,0.43,67.4,3488,75,NULL,'MAT, I, cor','NGC 0461',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15339,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15339,34.17,NULL,68.2,3488,NULL,NULL,'I','NGC 0461',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15340,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15340,34.26,0.41,71.1,3488,NULL,NULL,NULL,'NGC 0461',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15341,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15341,34.3,0.2,72.4,3488,74.4,NULL,NULL,'NGC 0461',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15342,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15342,34.34,NULL,73.8,3488,NULL,NULL,'B','NGC 0461',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15343,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15343,34.37,0.39,74.9,3488,NULL,NULL,'Malmquist cor.','NGC 0461',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15344,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15344,36.07,0.5,164,3489,70,NULL,NULL,'MCG -03-04-038',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000133,NULL,'15',0.4,NULL,NULL,NULL,NULL,NULL,1,19.34925,-16.06247,0.008,NULL,35411906422,553311037,8645484,15),(15345,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 01161','RN',15345,36,0.11,150,3490,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 01161',0.05328,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15346,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15346,37.6,0.46,331,3491,70,NULL,NULL,'2MASX J01172580-0035280',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000104,NULL,'16.7g',0.31,'AGN',NULL,NULL,NULL,NULL,1,19.3575,-0.591,0.108,NULL,34508725541,539198836,8424981,16.7),(15347,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 07014','RN',15347,39.56,0.26,760,3492,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07014',0.076964,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15348,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 18332','RN',15348,42.31,0.18,2280,3493,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 18332',0.270716,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15349,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 18332','RN',15349,42.9,0.23,2990,3493,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 18332',0.270716,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15350,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15350,36.74,0.46,223,3494,70,NULL,NULL,'2MASX J01172614+1543000',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000087,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,19.3590417,15.71667,0.085,NULL,67601447815,1056272622,16504259,16.7),(15351,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 15812',NULL,15351,40.65,0.18,1350,3495,70,NULL,'SN photometric redshift distance, z photo =0.385 +/- 0.042','SDSS-II SN 15812',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,19.359917,-0.30903,0.108,NULL,34500283690,539066932,8422920,NULL),(15352,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 15812','R',15352,41.53,0.29,1500,3495,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15812',0.343436,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15353,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 15812','R',15353,42.24,0.29,2090,3495,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15812',0.343436,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15354,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15354,39.13,0.46,669,3496,70,NULL,NULL,'2MASX J01172920-0017000',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00009,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,19.3715417,-0.28339,0.104,NULL,34500283154,539066924,8422920,18.1),(15355,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 03829','RN',15355,43.96,0.24,3930,3497,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03829',0.57389,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15356,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 13582','RN',15356,41.47,0.11,1550,3498,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13582',0.275866,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15357,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 13582','RN',15357,41.65,0.18,1670,3498,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13582',0.275866,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15358,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 17984','RN',15358,41.57,0.32,1500,3499,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 17984',0.376907,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15359,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 17984','RN',15359,41.61,0.38,1520,3499,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 17984',0.376907,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15360,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15360,33.88,NULL,59.6,3500,NULL,NULL,NULL,'UGC 00825',NULL,'2000BSAO...50....5K',2000,1,1.46,NULL,'G',0.000017,NULL,'17.',0.17,'Sd',NULL,NULL,NULL,NULL,1,19.40575,49.00958,0.845,NULL,67865786835,1060402919,16568795,17),(15361,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15361,34.18,NULL,68.6,3500,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00825',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15362,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15362,34.19,NULL,68.9,3500,NULL,NULL,'Dipole + Quadrupole','UGC 00825',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15363,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15363,34.19,NULL,69,3500,NULL,NULL,'Dipole','UGC 00825',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15364,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15364,34.3,0.49,72.5,3500,75,NULL,'IR','UGC 00825',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15365,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15365,34.53,0.43,80.6,3500,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00825',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15366,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 21543',NULL,15366,39.9,0.54,953,3501,70,NULL,'SN photometric redshift distance, z photo =0.254 +/- 0.087','SDSS-II SN 21543',NULL,'2011ApJ...738..162S',2011,1,0.12,NULL,'G',NULL,'PHOT','19.8g',0.1,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,19.411417,1.19606,0.061,NULL,66653202108,1041456282,16272754,19.8),(15367,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 21543','R',15367,40.91,0.28,1150,3501,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 21543',0.324839,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15368,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 21543',NULL,15368,40.97,0.26,1560,3501,70,NULL,'SALT 2','SDSS-II SN 21543',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15369,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 21543',NULL,15369,41,0.26,1580,3501,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 21543',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15370,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15370,37.34,0.46,294,3502,70,NULL,NULL,'2MASX J01174229-0044479',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000068,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,19.4262083,-0.74661,0.108,NULL,34509507279,539211051,8425172,17.6),(15371,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 16576','RN',15371,38.93,0.15,539,3503,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16576',0.133064,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15372,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 16576','RN',15372,38.96,0.26,548,3503,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16576',0.133064,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15373,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15373,35.79,0.46,144,3504,70,NULL,NULL,'2MASX J01174375-0049529',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000082,NULL,'16.1g',0.14,'NLAGN',NULL,NULL,NULL,NULL,1,19.43225,-0.83139,0.133,NULL,34509510417,539211100,8425173,16.1),(15374,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 08902','RN',15374,40.52,0.61,1180,3505,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08902',0.077525,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15375,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15375,36.62,0.33,210,3506,70,NULL,NULL,'2MASX J01174674+1319241',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000068,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,19.444875,13.32347,0.073,NULL,67607047314,1056360114,16505626,17.3),(15376,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15376,37.22,0.46,278,3507,70,NULL,NULL,'2MASX J01174795-0024399',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000075,NULL,'17.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,19.449833,-0.41103,0.108,NULL,34508876528,539201195,8425018,17.1),(15377,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 18333',NULL,15377,39.31,0.31,727,3508,70,NULL,'SN photometric redshift distance, z photo =0.187 +/- 0.032','SDSS-II SN 18333',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','20.5g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,19.4580417,1.12181,0.061,NULL,66653207177,1041456362,16272755,20.5),(15378,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 18333','R',15378,40.29,0.25,911,3508,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18333',0.253975,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15379,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 18333','R',15379,40.38,0.24,950,3508,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18333',0.253975,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15380,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 18333',NULL,15380,40.12,0.15,1060,3508,70,NULL,'SALT 2','SDSS-II SN 18333',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15381,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 18333',NULL,15381,40.14,0.15,1070,3508,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18333',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15382,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 18035','RN',15382,41.94,0.17,1830,3509,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 18035',0.340559,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15383,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 18035','RN',15383,42.36,0.23,2220,3509,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 18035',0.340559,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15384,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15384,36.26,0.58,178,3510,70,NULL,NULL,'2MASX J01175267-3558103',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'15.9b',0.48,'E0            LINER?',NULL,NULL,NULL,NULL,1,19.4694583333,-35.96953,NULL,NULL,38283690033,598182656,9346604,15.9),(15385,'CMD','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'N',15385,17.38,0.19,0.03,3511,NULL,NULL,'If object = GC, ID = DES J2337_6316','Tucana V',NULL,'2015ApJ...813..109D',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15386,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15386,37.45,0.46,309,3512,70,NULL,NULL,'2MASX J01175416-0857436',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000074,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,19.475833,-8.96206,0.118,NULL,35283842750,551310042,8614219,17.6),(15387,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 20592',NULL,15387,41.17,0.42,1710,3513,70,NULL,'SN photometric redshift distance, z photo =0.527 +/- 0.172','SDSS-II SN 20592',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,19.488167,0.16611,0.053,NULL,66648600211,1041384378,16271630,NULL),(15388,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15388,34.94,0.54,97.4,3514,70,NULL,NULL,'2MASX J01180073-1655435',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'16.42',0.21,NULL,NULL,NULL,NULL,NULL,1,19.503083,-16.92881,0.009,NULL,35409320761,553270636,8644853,16.42),(15389,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 07673','RN',15389,43.87,0.41,3550,3515,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 07673',0.677016,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15390,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15390,36,0.4,158,3516,NULL,NULL,NULL,'2MASX J01180192+0018525',NULL,'2009ApJS..182..474S',2009,1,0.54,NULL,'G',0.000023,NULL,'16.1g',0.24,'Sc',NULL,NULL,NULL,NULL,1,19.508167,0.31447,0.045,NULL,66652776770,1041449637,16272650,16.1),(15391,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15391,36.04,0.2,161,3516,74.4,NULL,NULL,'2MASX J01180192+0018525',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15392,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15392,36.1,0.38,166,3516,NULL,NULL,'Malmquist cor.','2MASX J01180192+0018525',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15393,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15393,35.38,0.53,119,3517,70,NULL,NULL,'2MASX J01180282-0134199',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.000097,NULL,'16.56',0.45,NULL,NULL,NULL,NULL,NULL,1,19.5117083,-1.57233,0.191,NULL,34509749298,539214832,8425231,16.56),(15394,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 01364','RN',15394,40.83,0.17,1200,3518,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01364',0.218694,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15395,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 01364','RN',15395,41.64,0.23,1750,3518,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01364',0.218694,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15396,'Ring Diameter','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15396,33,0.84,40,3519,NULL,NULL,'Published at H = 100 km/s/Mpc','UGC 00833',NULL,'1981ApJS...45..541P',1981,1,2.3,NULL,'G',0.00002,NULL,'13.76',1.5,'SB(r)cd','Isolated galaxy',NULL,NULL,NULL,1,19.5369166667,11.38178,0.117,NULL,67533171990,1055205812,16487590,13.76),(15397,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15397,34.23,0.2,70.2,3519,74.4,NULL,NULL,'UGC 00833',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15398,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15398,34.27,0.4,71.4,3519,NULL,NULL,'mean','UGC 00833',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15399,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15399,34.27,0.34,71.4,3519,NULL,NULL,'Malmquist cor.','UGC 00833',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15400,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15400,34.34,0.33,73.8,3519,NULL,NULL,NULL,'UGC 00833',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15401,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15401,34.55,0.47,81.5,3519,NULL,NULL,'H','UGC 00833',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15402,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15402,34.62,0.45,83.9,3519,NULL,NULL,'K','UGC 00833',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15403,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15403,34.65,0.46,85.1,3519,NULL,NULL,'J','UGC 00833',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15404,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15404,36.88,0.57,238,3520,70,NULL,NULL,'2MASX J01181077-1354015',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.99',0.23,NULL,NULL,NULL,NULL,NULL,1,19.544875,-13.9005,0.017,NULL,35413133963,553330218,8645784,16.99),(15405,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15405,37.19,0.81,274,3521,70,NULL,NULL,'2MASX J01181298-0104226',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.000086,NULL,'16.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,19.5540833333,-1.07303,0.15,NULL,34509246637,539206978,8425109,16.5),(15406,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 06968',NULL,15406,38.41,0.13,438,3522,74.2,NULL,'SALT 2','SDSS J011813.23-005420.7',0.098247,'2010ApJ...716..712A',2010,1,0.23,NULL,'G',0.000116,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,19.555125,-0.90575,0.133,NULL,34509250570,539207040,8425110,18.1),(15407,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 06968','R',15407,39.02,0.08,581,3522,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS J011813.23-005420.7',0.098247,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15408,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 06968','R',15408,39.22,0.21,635,3522,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS J011813.23-005420.7',0.098247,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15409,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15409,36.38,0.41,188,3523,NULL,NULL,'Malmquist cor.','FGC 0146',NULL,'2009ApJS..182..474S',2009,1,1.34,NULL,'G',0.000033,NULL,'16.6g',0.15,'Sb(f)',NULL,NULL,NULL,NULL,1,19.561167,15.09875,0.081,NULL,67601061005,1056266578,16504165,16.6),(15410,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15410,36.51,0.38,200,3523,NULL,NULL,NULL,'FGC 0146',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15411,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15411,36.55,0.49,204,3523,75,NULL,'IR','FGC 0146',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15412,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15412,36.55,0.2,204,3523,74.4,NULL,NULL,'FGC 0146',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15413,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 04781','RN',15413,39.75,0.1,801,3524,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04781',0.11542,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15414,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 04781','RN',15414,40.18,0.2,975,3524,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04781',0.11542,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15415,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 20916',NULL,15415,37.78,0.83,360,3525,70,NULL,'SN photometric redshift distance, z photo =0.088 +/- 0.044','SDSS-II SN 20916',NULL,'2011ApJ...738..162S',2011,1,0.03,NULL,'G',NULL,'PHOT','23.3g',0.01,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,19.58775,1.02461,0.057,NULL,66653179665,1041455932,16272748,23.3),(15416,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 20916','R',15416,41.37,0.29,1380,3525,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20916',0.362181,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15417,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 20916','R',15417,41.54,0.26,1490,3525,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20916',0.362181,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15418,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 20916',NULL,15418,41.21,0.18,1750,3525,70,NULL,'SALT 2','SDSS-II SN 20916',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15419,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 20916',NULL,15419,41.26,0.18,1790,3525,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20916',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15420,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15420,36.02,0.46,160,3526,70,NULL,NULL,'2MASX J01182165+1524338',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000096,NULL,'15.5g',0.46,'E0',NULL,NULL,NULL,NULL,1,19.590333,15.40944,0.081,NULL,67601023321,1056265989,16504156,15.5),(15421,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15421,37.8,0.46,364,3527,70,NULL,NULL,'2MASX J01182181-0957174',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000082,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,19.5907916667,-9.95492,0.147,NULL,35284307931,551317311,8614332,17.3),(15422,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15422,36.81,0.21,230,3528,70,NULL,NULL,'2MASX J01182461-0852418',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000103,NULL,'15.3g',0.52,'BrClG',NULL,NULL,NULL,NULL,1,19.602375,-8.87817,0.067,NULL,35297788113,551527939,8617624,15.3),(15423,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15423,37.71,0.33,349,3529,70,NULL,NULL,'2MASX J01182690-0011066',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000077,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,19.6122083,-0.18522,0.107,NULL,34508690482,539198288,8424973,17.3),(15424,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 03593','R',15424,41.39,0.25,1400,3530,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03593',0.35647,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,'PHOT','21.3g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,19.616625,0.73228,0.045,NULL,66653660241,1041463441,16272866,21.3),(15425,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 03593',NULL,15425,40.74,0.84,1410,3530,70,NULL,'SN photometric redshift distance, z photo =0.407 +/- 0.288','SDSS-II SN 03593',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15426,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 03593','R',15426,41.59,0.31,1540,3530,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03593',0.35647,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15427,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 03593',NULL,15427,41.49,0.2,1990,3530,70,NULL,'SALT 2','SDSS-II SN 03593',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15428,'SNIa','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 03593',NULL,15428,41.54,0.2,2030,3530,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 03593',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15429,'Horizontal Branch','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15429,23.89,0.12,0.6,3531,NULL,NULL,NULL,'Andromeda XXIV',NULL,'2011ApJ...732...76R',2011,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,19.625,46.36611,0.381,1,67870816748,1060481511,16570023,NULL),(15430,'TRGB','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15430,24.77,0.1,0.898,3531,NULL,NULL,NULL,'Andromeda XXIV',NULL,'2012ApJ...758...11C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15431,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15431,36.81,0.21,230,3532,70,NULL,NULL,'2MASX J01183183-0850508',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000095,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,19.6325,-8.84747,0.067,NULL,35297788426,551527944,8617624,16.7),(15432,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 11232','RN',15432,37.72,0.24,325,3533,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 11232',0.07822,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15433,'SNIa SDSS','2016-12-15 15:13:44','2016-12-16 11:18:47','1','SDSS-II SN 11232','RN',15433,38.5,0.27,465,3533,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 11232',0.07822,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15434,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15434,36.14,0.46,169,3534,70,NULL,NULL,'2MASX J01183293+0109304',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.0001,NULL,'16.40',0.44,'AGN',NULL,NULL,NULL,NULL,1,19.6372083,1.15856,0.057,NULL,66653223712,1041456620,16272759,16.4),(15435,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15435,37.71,0.33,349,3535,70,NULL,NULL,'2MASX J01183450-0009376',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000087,NULL,'17.58',0.29,'AGN',NULL,NULL,NULL,NULL,1,19.643625,-0.16036,0.107,NULL,34508647225,539197612,8424962,17.58),(15436,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15436,36.81,0.21,230,3536,70,NULL,NULL,'2MASX J01183459-0852398',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000081,NULL,'16.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,19.6440833333,-8.87764,0.067,NULL,35297791703,551527995,8617624,16.4),(15437,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15437,36.81,0.21,230,3537,70,NULL,NULL,'2MASX J01183661-0846388',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000084,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,19.652583,-8.77733,0.124,NULL,35297934131,551530220,8617659,16.9),(15438,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15438,34.72,0.5,87.8,3538,NULL,NULL,'Malmquist cor.','UGC 00835',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.00003,NULL,'14.62',0.8,'Scd:',NULL,NULL,NULL,NULL,1,19.6672917,31.03597,0.193,NULL,67268517478,1051070585,16422977,14.62),(15439,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15439,35.24,0.39,112,3538,NULL,NULL,NULL,'UGC 00835',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15440,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15440,35.28,0.2,114,3538,74.4,NULL,NULL,'UGC 00835',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15441,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15441,37.85,0.46,371,3539,70,NULL,NULL,'2MASX J01184023-0006304',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000123,NULL,'17.79',0.24,NULL,NULL,NULL,NULL,NULL,1,19.667625,-0.10856,0.107,NULL,34508650367,539197661,8424963,17.79),(15442,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15442,36.44,0.19,194,3540,70,NULL,NULL,'2MASX J01184049-0103544',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000086,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,19.6687917,-1.065,0.133,NULL,34509272164,539207377,8425115,16.4),(15443,'FP','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,'R',15443,36.81,0.21,230,3541,70,NULL,NULL,'2MASX J01184147-0842318',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000094,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,19.672917,-8.709,0.124,NULL,35297924344,551530067,8617657,16.3),(15444,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15444,34.24,NULL,70.6,3542,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0147',NULL,'2010Ap&SS.325..163P',2010,1,0.96,NULL,'G',NULL,NULL,'16.4',0.12,'Scd',NULL,NULL,NULL,NULL,1,19.685625,49.68136,0.889,NULL,67865446258,1060397597,16568712,16.4),(15445,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15445,34.26,NULL,71.3,3542,NULL,NULL,'Dipole + Quadrupole','FGC 0147',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15446,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15446,34.27,NULL,71.4,3542,NULL,NULL,'Dipole','FGC 0147',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15447,'Tully-Fisher','2016-12-15 15:13:44','2016-12-16 11:18:47','1',NULL,NULL,15447,34.32,NULL,73.2,3542,NULL,NULL,NULL,'FGC 0147',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15448,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15448,36.44,0.46,194,3543,70,NULL,NULL,'2MASX J01184469+1511275',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00009,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,19.686167,15.19111,0.077,NULL,67601156176,1056268065,16504188,16.7),(15449,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15449,37.39,0.46,301,3544,70,NULL,NULL,'2MASX J01184625+1450595',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000086,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,19.69275,14.84989,0.085,NULL,67608620859,1056384700,16506010,17.6),(15450,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15450,34.62,0.47,84.1,3545,NULL,NULL,'H','ESO 475- G 016',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000117,NULL,'14.20',0.6,'(R?)SB(r)ab',NULL,NULL,NULL,NULL,1,19.691875,-23.94497,0.064,NULL,35202845986,550044468,8594444,14.2),(15451,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15451,34.73,0.45,88.2,3545,NULL,NULL,'K','ESO 475- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15452,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15452,34.79,0.46,90.7,3545,NULL,NULL,'J','ESO 475- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15453,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15453,34.84,0.4,92.9,3545,NULL,NULL,'mean','ESO 475- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15454,'IRAS','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15454,34.92,0.8,96.3,3546,75,NULL,'MAT, I','ESO 151- G 040',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'14.11',1.2,'SAB(s)c',NULL,NULL,NULL,NULL,1,19.70175,-53.29264,NULL,NULL,36191978703,565499667,8835932,14.11),(15455,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15455,34.18,0.43,68.4,3546,75,NULL,'MAT, I, raw','ESO 151- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15456,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15456,34.41,0.43,76.2,3546,75,NULL,'MAT, I, inv','ESO 151- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15457,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15457,34.5,0.32,79.5,3546,85,NULL,'I, raw','ESO 151- G 040',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15458,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15458,34.56,0.43,81.7,3546,75,NULL,'MAT, I, cor','ESO 151- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15459,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15459,34.56,0.32,81.8,3546,85,NULL,'I, inv','ESO 151- G 040',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15460,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15460,34.74,NULL,88.7,3546,NULL,NULL,'I','ESO 151- G 040',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15461,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15461,34.81,NULL,91.6,3546,NULL,NULL,'B','ESO 151- G 040',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15462,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15462,35.12,0.4,106,3546,NULL,NULL,'mean','ESO 151- G 040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15463,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15463,35.33,0.47,116,3546,NULL,NULL,'H','ESO 151- G 040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15464,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15464,34.39,0.47,75.4,3547,NULL,NULL,'H','IC 1670A',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.00003,NULL,'14.50',0.4,'Sbc? sp        HII',NULL,NULL,NULL,NULL,1,19.7035,-16.80344,0,NULL,35408673565,553260524,8644695,14.5),(15465,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15465,34.43,0.45,76.9,3547,NULL,NULL,'K','IC 1670A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15466,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15466,34.5,0.49,79.3,3547,75,NULL,'IR','IC 1670A',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15467,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15467,34.51,0.4,79.9,3547,NULL,NULL,'mean','IC 1670A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15468,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15468,34.63,0.46,84.4,3547,NULL,NULL,'J','IC 1670A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15469,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15469,36.66,0.46,214,3548,70,NULL,NULL,'2MASX J01184930-1003468',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000085,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,19.7054583333,-10.06294,0.147,NULL,35284078521,551313726,8614276,16.8),(15470,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15470,35.87,0.57,149,3549,70,NULL,NULL,'2MASX J01185303-0039354',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.000093,NULL,'16.2g',0.38,'E0',NULL,NULL,NULL,NULL,1,19.720833,-0.65983,0.117,NULL,34508768868,539199513,8424992,16.2),(15471,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15471,36.44,0.19,194,3549,70,NULL,NULL,'2MASX J01185303-0039354',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15472,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 15857','RN',15472,38.01,0.18,381,3550,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15857',0.048171,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15473,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 15857','RN',15473,41.06,0.32,1550,3550,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15857',0.048171,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15474,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15474,36.05,0.47,162,3551,70,NULL,NULL,'UGC 00842',NULL,'2014MNRAS.445.2677S',2014,1,1.14,NULL,'G',0.000107,NULL,'14.5g',0.73,'S0?            BLLAC',NULL,NULL,NULL,'BL Lac',1,19.723375,-1.002,0.133,NULL,34509273238,539207394,8425115,14.5),(15475,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15475,36.44,0.19,194,3551,70,NULL,NULL,'UGC 00842',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15476,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15476,36.08,0.55,165,3552,70,NULL,NULL,'2MASX J01185449-0040594',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.000097,NULL,'17.13',0.19,NULL,NULL,NULL,NULL,NULL,1,19.7269583,-0.68319,0.117,NULL,34495070955,538985483,8421648,17.13),(15477,'GRB','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15477,36.51,NULL,200,3553,NULL,NULL,NULL,'GRB 781119',NULL,'1992grbo.book..107S',1992,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,19.7231666667,-28.62072,0.143,NULL,34753833784,543028652,8484822,NULL),(15478,'GRB','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15478,37.75,NULL,354,3553,65,NULL,'L = 10e57 photons/s','GRB 781119',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15479,'GRB','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15479,38.09,NULL,416,3553,75,NULL,NULL,'GRB 781119',NULL,'1995ApJ...453..583W',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15480,'GRB','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15480,40.69,NULL,1380,3553,65,NULL,'L = 2 x 10e58 photons/s','GRB 781119',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15481,'GRB','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15481,44.91,NULL,9600,3553,NULL,NULL,NULL,'GRB 781119',NULL,'1992grbo.book..107S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15482,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 19557','R',15482,41.75,1.31,1550,3554,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19557',0.444784,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',NULL,'PHOT','21.2g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,19.735417,0.27633,0.053,NULL,66641233175,1041269268,16269832,21.2),(15483,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 19557',NULL,15483,41.54,0.05,2030,3554,70,NULL,'SN photometric redshift distance, z photo =0.675 +/- 0.025','SDSS-II SN 19557',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15484,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 19557',NULL,15484,41.77,0.34,2260,3554,70,NULL,'SALT 2','SDSS-II SN 19557',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15485,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 19557',NULL,15485,41.86,0.34,2360,3554,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19557',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15486,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 09560','RN',15486,41.36,0.37,1710,3555,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 09560',0.09162,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15487,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15487,38.91,0.46,605,3556,70,NULL,NULL,'SDSS J011858.15-002949.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.0001,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,19.7422917,-0.49722,0.117,NULL,34495107439,538986053,8421657,18.1),(15488,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 01549','RN',15488,40.57,0.39,1070,3557,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01549',0.216084,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15489,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 01549','RN',15489,42.21,0.47,2280,3557,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01549',0.216084,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15490,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 14387','RN',15490,43.31,0.24,2950,3558,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 14387',0.555865,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15491,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15491,36.44,0.19,194,3559,70,NULL,NULL,'2MASX J01190316-0114014',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000127,NULL,'17.11',0.31,NULL,NULL,NULL,NULL,NULL,1,19.763083,-1.23369,0.145,NULL,34495304652,538989135,8421705,17.11),(15492,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15492,36.84,0.62,233,3559,70,NULL,NULL,'2MASX J01190316-0114014',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15493,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15493,34.24,NULL,70.6,3560,NULL,NULL,'Dipole + Quadrupole','UGC 00847',NULL,'2010Ap&SS.325..163P',2010,1,1.7,NULL,'G',0.00003,NULL,'16.1g',0.18,'Sd(f)',NULL,NULL,NULL,NULL,1,19.768333,-0.13858,0.115,NULL,34495065318,538985395,8421646,16.1),(15494,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15494,34.24,NULL,70.6,3560,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00847',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15495,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15495,34.25,NULL,70.8,3560,NULL,NULL,'Dipole','UGC 00847',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15496,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15496,34.3,0.16,72.6,3560,NULL,NULL,NULL,'UGC 00847',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15497,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15497,34.44,0.49,77.4,3560,75,NULL,'IR','UGC 00847',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15498,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15498,34.51,0.2,79.8,3560,74.4,NULL,NULL,'UGC 00847',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15499,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15499,37.4,0.55,302,3561,NULL,NULL,'Malmquist cor.','2MASX J01190434-0017330',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000094,NULL,'17.5g',0.11,'Sb(f)          NLAGN',NULL,NULL,NULL,NULL,1,19.768167,-0.29253,0.107,NULL,34495022912,538984733,8421636,17.5),(15500,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15500,37.6,0.5,330,3561,NULL,NULL,NULL,'2MASX J01190434-0017330',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15501,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15501,37.64,0.2,337,3561,74.4,NULL,NULL,'2MASX J01190434-0017330',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15502,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 05607','RN',15502,42.21,0.2,2280,3562,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 05607',0.217736,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15503,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 05607','RN',15503,42.55,0.29,2660,3562,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 05607',0.217736,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15504,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15504,36.65,0.52,214,3563,70,NULL,NULL,'6dF J0119070-011553',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,19.779,-1.26475,0.145,NULL,34495275633,538988681,8421698,16.6),(15505,'Faber-Jackson','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15505,32.96,0.5,39.1,3564,95,NULL,'de Vaucouleurs','NGC 0467',NULL,'1984ApJS...56...91D',1984,1,1.7,NULL,'G',0.000073,NULL,'12.9',1.7,'SA(s)0^0^ pec?','in a triple',NULL,NULL,NULL,1,19.7922083333,3.30083,0.057,NULL,67521197331,1055018708,16484667,12.9),(15506,'Faber-Jackson','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15506,33.26,0.33,44.9,3564,95,NULL,'Weighted Mean','NGC 0467',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15507,'Faber-Jackson','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15507,33.78,0.46,57,3564,95,NULL,'Michard 1979a','NGC 0467',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15508,'Faber-Jackson','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15508,34.33,0.63,73.5,3564,95,NULL,'Michard 1979b, c','NGC 0467',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15509,'Tertiary','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15509,33.77,0.5,56.8,3564,95,NULL,NULL,'NGC 0467',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15510,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15510,34.33,0.4,73.4,3564,NULL,NULL,'mean','NGC 0467',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15511,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15511,34.47,0.45,78.2,3564,NULL,NULL,'K','NGC 0467',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15512,'IRAS','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15512,34.38,0.8,75.2,3565,75,NULL,'W91CL, r','UGC 00841',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00002,NULL,'14.94',0.3,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,19.792083,33.03056,0.141,NULL,67753444047,1058647563,16541368,14.94),(15513,'IRAS','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15513,34.4,0.8,75.7,3565,75,NULL,'HMCL, I','UGC 00841',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15514,'IRAS','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15514,34.4,0.8,75.7,3565,75,NULL,'HMCL, I','UGC 00841',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15515,'IRAS','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15515,34.4,0.8,75.7,3565,75,NULL,'W91PP, r','UGC 00841',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15516,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15516,33.8,NULL,57.5,3565,NULL,NULL,'B','UGC 00841',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15517,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15517,33.8,0.4,57.6,3565,75,NULL,'HMCL, I, raw','UGC 00841',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15518,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15518,33.84,0.4,58.6,3565,75,NULL,'HMCL, I, raw','UGC 00841',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15519,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15519,33.85,0.38,59,3565,75,NULL,'W91CL, r, raw','UGC 00841',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15520,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15520,33.87,0.49,59.4,3565,75,NULL,'IR','UGC 00841',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15521,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15521,33.89,0.4,60,3565,75,NULL,'HMCL, I, inv','UGC 00841',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15522,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15522,33.9,0.38,60.1,3565,75,NULL,'W91CL, r, inv','UGC 00841',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15523,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15523,33.93,0.4,61.1,3565,75,NULL,'HMCL, I, inv','UGC 00841',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15524,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15524,33.98,0.43,62.5,3565,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00841',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15525,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15525,34,0.43,63,3565,75,NULL,'3.6 micron, color corrected','UGC 00841',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15526,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15526,34.04,0.2,64.3,3565,74.4,NULL,NULL,'UGC 00841',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15527,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15527,34.05,0.38,64.5,3565,75,NULL,'W91PP, r, raw','UGC 00841',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15528,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15528,34.05,0.38,64.6,3565,75,NULL,'W91CL, r, cor','UGC 00841',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15529,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15529,34.05,0.4,64.7,3565,75,NULL,'HMCL, I, cor','UGC 00841',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15530,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15530,34.07,NULL,65.2,3565,NULL,NULL,'I','UGC 00841',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15531,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15531,34.08,0.4,65.5,3565,75,NULL,'HMCL, I, cor','UGC 00841',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15532,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15532,34.09,0.38,65.7,3565,75,NULL,'W91PP, r, inv','UGC 00841',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15533,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15533,34.2,0.12,69.3,3565,NULL,NULL,NULL,'UGC 00841',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15534,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15534,34.21,0.38,69.5,3565,75,NULL,'W91PP, r, cor','UGC 00841',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15535,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 03913','RN',15535,40.86,0.12,1180,3566,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03913',0.257874,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15536,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 03913','RN',15536,41.42,0.28,1530,3566,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03913',0.257874,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15537,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15537,35.94,0.62,154,3567,70,NULL,NULL,'2MASX J01191145-1352324',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'16.40',0.19,NULL,NULL,NULL,NULL,NULL,1,19.7977917,-13.87558,0.014,NULL,35413253976,553332093,8645813,16.4),(15538,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15538,36.44,0.19,194,3568,70,NULL,NULL,'2MASX J01191301-0110390',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000073,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,19.804333,-1.17753,0.145,NULL,34495305132,538989142,8421705,16.7),(15539,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15539,36.44,0.19,194,3569,70,NULL,NULL,'2MASX J01191347-0108400',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000113,NULL,'15.6g',0.42,'E',NULL,NULL,NULL,NULL,1,19.80625,-1.14442,0.145,NULL,34495315761,538989308,8421707,15.6),(15540,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15540,37.12,0.52,265,3569,70,NULL,NULL,'2MASX J01191347-0108400',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15541,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15541,37.07,0.15,260,3570,70,NULL,NULL,'GIN 075',NULL,'2001MNRAS.321..277C',2001,1,0.42,NULL,'G',0.000167,NULL,'16.61',0.29,'S',NULL,NULL,NULL,NULL,1,19.8199583,-13.90239,0.014,NULL,35413258884,553332170,8645815,16.61),(15542,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15542,35.18,0.49,108,3571,70,NULL,NULL,'2MASX J01191947-1638274',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000027,NULL,'15.97',0.49,NULL,NULL,NULL,NULL,NULL,1,19.8310833333,-16.64108,0,NULL,35408685649,553260713,8644698,15.97),(15543,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 18334','RN',15543,40.24,0.23,1030,3572,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18334',0.085608,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15544,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 18334','RN',15544,40.77,0.25,1310,3572,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18334',0.085608,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15545,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 07499',NULL,15545,40.28,0.19,1140,3573,70,NULL,'SN photometric redshift distance, z photo =0.313 +/- 0.035','SDSS-II SN 07499',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.6g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,19.8560417,-0.23583,0.115,NULL,34495245761,538988215,8421690,22.6),(15546,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 07499','R',15546,41.26,0.28,1320,3573,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07499',0.352531,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15547,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 07499','R',15547,41.39,0.33,1410,3573,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07499',0.352531,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15548,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 07499',NULL,15548,41.36,0.23,1870,3573,70,NULL,'SALT 2','SDSS-II SN 07499',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15549,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 07499',NULL,15549,41.4,0.23,1910,3573,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 07499',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15550,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 03994',NULL,15550,39.01,0.82,635,3574,70,NULL,'SN photometric redshift distance, z photo =0.161 +/- 0.085','SDSS-II SN 03994',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,19.8577917,-0.24528,0.115,NULL,34495244623,538988197,8421690,NULL),(15551,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15551,38.19,0.46,435,3575,70,NULL,NULL,'SDSS J011926.34-103430.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000092,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,19.8597917,-10.57514,0.113,NULL,35277656263,551213379,8612709,18.3),(15552,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 06938','RN',15552,41.57,1.24,1930,3576,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06938',0.071717,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15553,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 03481','RN',15553,39.69,0.07,796,3577,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03481',0.090092,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15554,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 03481','RN',15554,39.83,0.21,850,3577,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03481',0.090092,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15555,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15555,36.89,0.46,239,3578,70,NULL,NULL,'2MASX J01193015+0102291',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000092,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,19.875667,1.04131,0.053,NULL,66641964081,1041280688,16270010,17.1),(15556,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 20968','RN',15556,42.21,0.32,2210,3579,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 20968',0.254595,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15557,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15557,36.86,0.25,236,3580,74.4,NULL,NULL,'GIN 077',NULL,'2013AJ....146...86T',2013,1,0.48,NULL,'G',0.000037,NULL,'16.06',0.28,'S',NULL,NULL,NULL,NULL,1,19.884125,-13.72628,0.019,NULL,35413071199,553329237,8645769,16.06),(15558,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15558,37.07,0.15,260,3580,70,NULL,NULL,'GIN 077',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15559,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15559,33.53,0.49,50.7,3581,75,NULL,'IR','2MFGC 00997',NULL,'2011yCatp016004901K',2011,1,0.44,NULL,'G',0.000082,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,19.8877083333,14.8765,0.081,NULL,67608534179,1056383346,16505989,17.3),(15560,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15560,36.04,0.49,161,3582,70,NULL,NULL,'MCG -03-04-048',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00009,NULL,'15',0.2,NULL,NULL,NULL,NULL,NULL,1,19.8886666667,-17.69325,0.025,NULL,35186976608,549796509,8590570,15),(15561,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15561,34.09,0.45,65.8,3583,NULL,NULL,'K','NGC 0484',NULL,'2007A&A...465...71T',2007,1,1.9,'Chapman et al. (1988AJ.....95..999C) give v = 7159 +/- 71 km/sec.','G',0.000087,NULL,'12.05',1.4,'E+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,19.8947083333,-58.52431,0,NULL,36177546902,565274170,8832408,12.05),(15562,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15562,34.17,0.4,68.4,3583,NULL,NULL,'mean','NGC 0484',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15563,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 14538','RN',15563,41.65,0.28,1730,3584,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14538',0.235292,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15564,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 14538','RN',15564,42.49,0.35,2550,3584,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 14538',0.235292,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15565,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 15419',NULL,15565,40.12,0.19,1060,3585,70,NULL,'SN photometric redshift distance, z photo =0.287 +/- 0.031','SDSS-II SN 15419',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,19.90525,0.88564,0.053,NULL,66641838269,1041278722,16269980,NULL),(15566,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 15419','R',15566,40.73,0.21,1100,3585,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15419',0.277787,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15567,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 15419','R',15567,40.86,0.15,1160,3585,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15419',0.277787,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15568,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 15419',NULL,15568,40.6,0.14,1320,3585,70,NULL,'SALT 2','SDSS-II SN 15419',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15569,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 15419',NULL,15569,40.62,0.14,1330,3585,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15419',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15570,'Sosies','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15570,33.52,0.17,50.6,3586,NULL,NULL,NULL,'NGC 0470',NULL,'2002A&A...393...57T',2002,1,2.8,NULL,'G',0.00001,NULL,'12.53',1.7,'SA(rs)b        HII','Possible pair member',NULL,NULL,NULL,1,19.936875,3.40994,0.057,NULL,67525305151,1055082892,16485670,12.53),(15571,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15571,31.7,0.69,21.8,3586,100,NULL,'mid-IR','NGC 0470',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15572,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15572,32.42,0.4,30.5,3586,75,NULL,'B','NGC 0470',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15573,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15573,32.62,0.4,33.4,3586,NULL,NULL,'mean','NGC 0470',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15574,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15574,32.79,0.4,36.1,3586,NULL,NULL,NULL,'NGC 0470',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15575,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15575,32.79,0.39,36.1,3586,73,NULL,'opt','NGC 0470',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15576,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15576,32.9,0.45,38,3586,NULL,NULL,'K','NGC 0470',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15577,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15577,32.9,0.47,38,3586,NULL,NULL,'H','NGC 0470',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15578,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15578,32.91,0.43,38.1,3586,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0470',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15579,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15579,32.92,0.46,38.3,3586,NULL,NULL,'J','NGC 0470',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15580,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15580,32.94,0.43,38.8,3586,75,NULL,'3.6 micron, color corrected','NGC 0470',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15581,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15581,33.01,0.43,39.9,3586,NULL,NULL,'Malmquist cor.','NGC 0470',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15582,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15582,33.08,0.2,41.3,3586,74.4,NULL,NULL,'NGC 0470',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15583,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15583,33.27,0.38,45,3586,NULL,NULL,NULL,'NGC 0470',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15584,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15584,36.51,0.21,201,3587,70,NULL,NULL,'2MASX J01194490+1453557',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000079,NULL,'17.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,19.937125,14.89889,0.081,NULL,67608572965,1056383952,16505999,17.3),(15585,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 18383','RN',15585,43.15,0.27,3160,3588,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 18383',0.349416,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15586,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 18383','RN',15586,43.16,0.26,3180,3588,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 18383',0.349416,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15587,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15587,38.6,0.46,524,3589,70,NULL,NULL,'SDSS J011945.89+000709.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000078,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,19.9412083,0.11925,0.065,NULL,66641438711,1041272479,16269882,18.4),(15588,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15588,36.51,0.21,201,3590,70,NULL,NULL,'2MASX J01195117+1450247',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000067,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,19.9632916667,14.84017,0.081,NULL,67608562867,1056383794,16505996,17),(15589,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 11655','RN',15589,40.23,0.2,916,3591,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 11655',0.215968,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15590,'Tully est','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15590,32.37,0.8,29.8,3592,75,NULL,'B','NGC 0473',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000017,NULL,'13.33',1.1,'SAB(r)0/a:',NULL,NULL,NULL,NULL,1,19.9794583,16.54469,0.109,NULL,67600269354,1056254208,16503972,13.33),(15591,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15591,35.64,0.4,134,3593,NULL,NULL,'mean','CGCG 459-031',NULL,'2007A&A...465...71T',2007,1,0.65,NULL,'G',0.000033,NULL,'15.0',0.2,NULL,NULL,NULL,NULL,NULL,1,19.988667,21.38081,0.117,NULL,67437152259,1053705504,16464148,15),(15592,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15592,35.72,0.47,139,3593,NULL,NULL,'H','CGCG 459-031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15593,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15593,35.78,0.45,144,3593,NULL,NULL,'K','CGCG 459-031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15594,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15594,35.92,0.46,152,3593,NULL,NULL,'J','CGCG 459-031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15595,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15595,36.65,0.57,214,3594,70,NULL,NULL,'2MASX J01200158-0008156',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.000077,NULL,'16.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,20.0067917,-0.13758,0.115,NULL,34495228982,538987952,8421686,16.3),(15596,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15596,36.51,0.21,201,3595,70,NULL,NULL,'NGC 0475',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.00012,NULL,'15.7g',0.45,'BrClG',NULL,NULL,NULL,NULL,1,20.008333,14.86106,0.081,NULL,67608575447,1056383991,16505999,15.7),(15597,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 11233','RN',15597,39.04,0.34,595,3596,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 11233',0.079214,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15598,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 11233','RN',15598,39.45,0.32,718,3596,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 11233',0.079214,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15599,'IRAS','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15599,33.25,0.8,44.8,3597,75,NULL,'MAT, I','NGC 0491A',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.00001,NULL,'14.3',0.9,'SB(s)dm:',NULL,NULL,NULL,NULL,1,20.0194583,-33.8995,NULL,NULL,38285172212,598205815,9346965,14.3),(15600,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15600,32.9,0.32,38,3597,85,NULL,'I, raw','NGC 0491A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15601,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15601,32.91,0.32,38.2,3597,85,NULL,'I, inv','NGC 0491A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15602,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15602,33.12,0.2,42.1,3597,74.4,NULL,NULL,'NGC 0491A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15603,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15603,33.14,0.43,42.4,3597,75,NULL,'MAT, I, raw','NGC 0491A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15604,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15604,33.22,0.43,44,3597,75,NULL,'MAT, I, inv','NGC 0491A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15605,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15605,33.37,0.35,47.1,3597,NULL,NULL,NULL,'NGC 0491A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15606,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15606,33.54,0.43,51,3597,75,NULL,'MAT, I, cor','NGC 0491A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15607,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15607,33.71,0.3,55.2,3597,NULL,NULL,'Malmquist cor.','NGC 0491A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15608,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 20467','R',15608,40.82,0.15,1150,3598,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J012004.76+005448.5',0.27095,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',NULL,'PHOT','21.5g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,20.0198333333,0.9135,0.061,NULL,66641979730,1041280933,16270014,21.5),(15609,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 20467','R',15609,40.96,0.22,1220,3598,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J012004.76+005448.5',0.27095,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15610,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 20467',NULL,15610,40.73,0.12,1400,3598,70,NULL,'SALT 2','SDSS J012004.76+005448.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15611,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 20467',NULL,15611,40.75,0.12,1410,3598,70,NULL,'SALT 2, Malmquist cor.','SDSS J012004.76+005448.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15612,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15612,36.85,0.25,234,3599,74.4,NULL,NULL,'GIN 076',NULL,'2013AJ....146...86T',2013,1,0.37,NULL,'G',0.000043,NULL,'15.26',0.33,'E',NULL,NULL,NULL,NULL,1,20.0207083,-13.79644,0.014,NULL,35416149432,553377334,8646520,15.26),(15613,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15613,37.07,0.15,260,3599,70,NULL,NULL,'GIN 076',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15614,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15614,37.42,0.57,305,3599,70,NULL,NULL,'GIN 076',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15615,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 09650','RN',15615,39.98,0.46,918,3600,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 09650',0.078212,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15616,'SBF','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15616,32.21,0.17,27.7,3601,NULL,NULL,'BV A01','NGC 0474',NULL,'2007ApJ...668..130C',2007,1,7.1,NULL,'G',0.000017,NULL,'12.37',6.3,'(R\')SA(s)0^0^','Possible pair member',NULL,NULL,NULL,1,20.027875,3.41539,0.053,NULL,67525341521,1055083461,16485679,12.37),(15617,'SBF','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15617,32.35,0.14,29.5,3601,74.4,NULL,NULL,'NGC 0474',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15618,'SBF','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15618,32.43,0.13,30.6,3601,NULL,NULL,'J03','NGC 0474',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15619,'SBF','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15619,32.43,0.13,30.6,3601,NULL,NULL,'M06','NGC 0474',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15620,'SBF','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15620,32.59,0.13,33,3601,NULL,NULL,'T01','NGC 0474',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15621,'Faber-Jackson','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15621,31.32,0.63,18.4,3601,95,NULL,'de Vaucouleurs','NGC 0474',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15622,'Faber-Jackson','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15622,31.52,0.45,20.1,3601,95,NULL,'Weighted Mean','NGC 0474',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15623,'Faber-Jackson','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15623,33.13,0.81,42.3,3601,55,NULL,'Visvanathan & Sandage 1979','NGC 0474',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15624,'Tertiary','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15624,31.83,0.25,23.2,3601,95,NULL,NULL,'NGC 0474',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15625,'Tully est','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15625,32.56,0.8,32.5,3601,75,NULL,'B','NGC 0474',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15626,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15626,32.35,0.14,29.5,3601,74.4,NULL,NULL,'NGC 0474',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15627,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15627,31.81,0.43,23,3602,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00866',NULL,'2014MNRAS.444..527S',2014,1,0.53,NULL,'G',0.000013,NULL,'15.4g',0.15,'Sdm:',NULL,NULL,NULL,NULL,1,20.0284583,-0.20536,0.118,NULL,34495206286,538987598,8421681,15.4),(15628,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15628,31.89,0.2,23.9,3602,74.4,NULL,NULL,'UGC 00866',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15629,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15629,31.9,0.43,24,3602,75,NULL,'3.6 micron, color corrected','UGC 00866',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15630,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15630,32.02,0.4,25.4,3602,73,NULL,'opt','UGC 00866',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15631,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15631,32.07,0.76,26,3602,NULL,NULL,NULL,'UGC 00866',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15632,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15632,32.1,0.74,26.4,3602,NULL,NULL,'Malmquist cor.','UGC 00866',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15633,'IRAS','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15633,34.46,0.8,78,3603,75,NULL,'HMCL, I','IC 1669',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000033,NULL,'15.56',0.3,'Sa',NULL,NULL,NULL,NULL,1,20.0285,33.18475,0.141,NULL,67761394660,1058771791,16543309,15.56),(15634,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15634,33.52,0.4,50.6,3603,75,NULL,'HMCL, I, raw','IC 1669',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15635,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15635,33.54,0.4,51,3603,75,NULL,'HMCL, I, inv','IC 1669',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15636,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15636,33.88,0.4,59.8,3603,75,NULL,'HMCL, I, cor','IC 1669',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15637,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 09959','RN',15637,42.18,0.33,1900,3604,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 09959',0.438545,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15638,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 09959','RN',15638,43.2,0.3,3030,3604,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 09959',0.438545,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15639,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 11234','RN',15639,43.79,0.89,5180,3605,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 11234',0.103593,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15640,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 11234','RN',15640,45.91,1.87,13800,3605,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 11234',0.103593,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15641,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15641,36.5,0.46,199,3606,70,NULL,NULL,'UGC 00865',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.000115,NULL,'15.2g',0.54,'E0',NULL,NULL,NULL,NULL,1,20.0504583333,14.56128,0.073,NULL,67608660760,1056385324,16506020,15.2),(15642,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15642,37,0.6,251,3607,70,NULL,NULL,'2MASX J01201240-0458033',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.000113,NULL,'15.89',0.26,NULL,NULL,NULL,NULL,NULL,1,20.0517083,-4.96761,0.236,NULL,35237852399,550591443,8602991,15.89),(15643,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15643,37.05,0.46,257,3608,70,NULL,NULL,'2MASX J01201462+0106494',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,20.060833,1.11383,0.061,NULL,66641756625,1041277447,16269960,17.6),(15644,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15644,33.62,0.74,53,3609,NULL,NULL,'Malmquist cor.','CGCG 459-032',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000033,NULL,'15.6',0.6,NULL,NULL,NULL,NULL,NULL,1,20.061167,17.83022,0.113,NULL,67419860106,1053435314,16459926,15.6),(15645,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15645,33.79,0.68,57.4,3609,NULL,NULL,NULL,'CGCG 459-032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15646,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 13144',NULL,15646,35.21,4.32,110,3610,70,NULL,'SN photometric redshift distance, z photo =0.026 +/- 0.183','SDSS-II SN 13144',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,20.082083,-0.33358,0.118,NULL,34495873609,538998025,8421844,NULL),(15647,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15647,37.07,0.15,260,3611,70,NULL,NULL,'GIN 074',NULL,'2001MNRAS.321..277C',2001,1,0.45,NULL,'G',0.000017,NULL,'16.83',0.35,'E',NULL,NULL,NULL,NULL,1,20.0855416667,-13.974,0.014,NULL,35416045975,553375718,8646495,16.83),(15648,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15648,37.26,0.25,283,3611,74.4,NULL,NULL,'GIN 074',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15649,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15649,36.84,0.25,233,3612,74.4,NULL,NULL,'GIN 073',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000043,NULL,'14.84',0.3,'E/S0',NULL,NULL,NULL,NULL,1,20.085875,-13.88975,0.014,NULL,35416026219,553375409,8646490,14.84),(15650,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15650,37.07,0.15,260,3612,70,NULL,NULL,'GIN 073',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15651,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15651,37.24,0.46,280,3613,70,NULL,NULL,'2MASX J01202313-0004443',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000127,NULL,'15.4g',0.52,'S0',NULL,NULL,NULL,NULL,1,20.096417,-0.07894,0.108,NULL,34495167761,538986996,8421671,15.4),(15652,'Tully est','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15652,32.24,0.8,28.1,3614,75,NULL,NULL,'UGC 00871',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.000003,NULL,'17.',1.6,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,20.100583,5.82744,0.149,NULL,67522061943,1055032217,16484878,17),(15653,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15653,37.21,0.46,277,3615,70,NULL,NULL,'2MASX J01202649+0041504',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000082,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,20.11025,0.69747,0.049,NULL,66642002258,1041281285,16270020,17),(15654,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15654,37.39,0.46,300,3616,70,NULL,NULL,'2MASX J01203149+0050254',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000075,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,20.1312916667,0.84042,0.049,NULL,66641897957,1041279655,16269994,17.4),(15655,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15655,36.86,0.25,236,3617,74.4,NULL,NULL,'GIN 072',NULL,'2013AJ....146...86T',2013,1,0.44,NULL,'G',0.000033,NULL,'14.82',0.29,'E',NULL,NULL,NULL,NULL,1,20.142667,-13.86406,0.012,NULL,35416023231,553375362,8646490,14.82),(15656,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15656,37.07,0.15,260,3617,70,NULL,NULL,'GIN 072',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15657,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15657,36.77,0.66,226,3618,70,NULL,NULL,'2MASX J01203610-2101035',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.17',0.4,NULL,NULL,NULL,NULL,NULL,1,20.1505417,-21.01747,0.026,NULL,35230134357,550470849,8601107,16.17),(15658,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15658,36.83,0.25,232,3619,74.4,NULL,NULL,'GIN 071',NULL,'2013AJ....146...86T',2013,1,0.33,NULL,'G',0.00001,NULL,'15.34',0.32,'E/S0',NULL,NULL,NULL,NULL,1,20.1509583333,-13.86389,0.012,NULL,35416031337,553375489,8646492,15.34),(15659,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15659,37.07,0.15,260,3619,70,NULL,NULL,'GIN 071',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15660,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 02181','R',15660,41.17,0.27,1240,3620,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02181',0.37864,'2014arXiv1401.3317S',2014,1,0.04,NULL,'G',NULL,'PHOT','22.5g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,20.1630417,-0.00753,0.069,NULL,34495161902,538986904,8421670,22.5),(15661,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 02181','R',15661,41.57,0.24,1500,3620,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 02181',0.37864,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15662,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 02181',NULL,15662,41.17,0.2,1710,3620,70,NULL,'SN photometric redshift distance, z photo =0.528 +/- 0.074','SDSS-II SN 02181',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15663,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 02181',NULL,15663,41.29,0.17,1810,3620,70,NULL,'SALT 2','SDSS-II SN 02181',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15664,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 02181',NULL,15664,41.34,0.17,1850,3620,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 02181',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15665,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15665,37.89,0.33,379,3621,70,NULL,NULL,'2MASX J01204012-0030389',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.69',0.16,NULL,NULL,NULL,NULL,NULL,1,20.167167,-0.51083,0.124,NULL,34496051196,539000799,8421887,18.69),(15666,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15666,34.07,0.2,65.2,3622,74.4,NULL,NULL,'2MASX J01204229+0121336',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000063,NULL,'16.32',0.37,NULL,NULL,NULL,NULL,NULL,1,20.17625,1.35931,0.025,NULL,66642462893,1041288482,16270132,16.32),(15667,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15667,34.08,0.08,65.6,3622,NULL,NULL,NULL,'2MASX J01204229+0121336',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15668,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15668,36.51,0.21,201,3623,70,NULL,NULL,'SDSS J012044.05+144446.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000076,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,20.1835833333,14.74625,0.073,NULL,67611453311,1056428957,16506702,17.9),(15669,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15669,34.75,NULL,89.3,3624,NULL,NULL,NULL,'UGC 00876',NULL,'2000BSAO...50....5K',2000,1,1.12,NULL,'G',0.000017,NULL,'17.2',0.11,'Sd',NULL,NULL,NULL,NULL,1,20.1909583333,4.18006,0.041,NULL,67525730139,1055089533,16485773,17.2),(15670,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15670,34.78,NULL,90.6,3624,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00876',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15671,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15671,34.79,NULL,90.8,3624,NULL,NULL,'Dipole + Quadrupole','UGC 00876',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15672,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15672,34.79,NULL,90.9,3624,NULL,NULL,'Dipole','UGC 00876',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15673,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15673,34.3,0.08,72.6,3625,NULL,NULL,NULL,'UGC 00875',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000073,NULL,'14.87',0.8,'SAB(s)c',NULL,NULL,NULL,NULL,1,20.1912083,1.44522,0.025,NULL,66640512042,1041258000,16269656,14.87),(15674,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15674,34.24,0.23,70.5,3626,74.4,NULL,NULL,'IC 1673',NULL,'2013AJ....146...86T',2013,1,0.45,NULL,'G',0.000023,NULL,'14.6',0.45,'E',NULL,NULL,NULL,NULL,1,20.193125,33.04494,0.137,NULL,67753225658,1058644150,16541314,14.6),(15675,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15675,35.91,0.59,152,3627,70,NULL,NULL,'2MASX J01204815-4304584',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.37',0.33,'S',NULL,NULL,NULL,NULL,1,20.200667,-43.08289,NULL,NULL,38373626406,599587912,9368561,16.37),(15676,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15676,37.81,0.46,365,3628,70,NULL,NULL,'SDSS J012049.98+004200.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000085,NULL,'18.3g',0.12,'NLAGN',NULL,NULL,NULL,'Sy 2',1,20.2082917,0.70022,0.037,NULL,66642013775,1041281465,16270022,18.3),(15677,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15677,35.94,0.6,154,3629,NULL,NULL,NULL,'FGC 016A',NULL,'2009ApJS..182..474S',2009,1,0.29,NULL,'G',0.000046,NULL,'17.9g',0.11,'Sm',NULL,NULL,NULL,NULL,1,20.217333,1.26333,0.049,NULL,66642471354,1041288614,16270134,17.9),(15678,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15678,35.98,0.2,157,3629,74.4,NULL,NULL,'FGC 016A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15679,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15679,36.07,0.57,164,3629,NULL,NULL,'Malmquist cor.','FGC 016A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15680,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 2008gl',NULL,15680,35.71,0.12,130,3630,72,NULL,NULL,'UGC 00881',0.03297,'2013ApJ...773...53F',2013,1,1.3,NULL,'G',0.000117,NULL,'14.71',1.1,'E',NULL,NULL,NULL,NULL,1,20.2227917,4.80133,0.073,NULL,67524524989,1055070702,16485479,14.71),(15681,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 2008gl',NULL,15681,35.81,0.2,140,3630,73.8,NULL,'SALT 2 (SNANA)','UGC 00881',0.0332,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15682,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 2008gl','R',15682,35.8,0.08,145,3630,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 00881',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15683,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 2008gl','R',15683,35.85,0.08,148,3630,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 00881',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15684,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15684,37.89,0.33,379,3631,70,NULL,NULL,'2MASX J01205452-0031329',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000083,NULL,'16.4g',0.35,'S0;BrClG',NULL,NULL,NULL,NULL,1,20.227083,-0.52592,0.124,NULL,34496037884,539000591,8421884,16.4),(15685,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15685,34.99,0.74,99.8,3632,NULL,NULL,NULL,'ESO 352- G 048',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.54',0.3,'E              Sy2',NULL,NULL,NULL,NULL,1,20.228,-36.32378,NULL,NULL,38275295452,598051491,9344554,16.54),(15686,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15686,35.04,0.2,102,3632,74.4,NULL,NULL,'ESO 352- G 048',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15687,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15687,35.16,0.69,108,3632,NULL,NULL,'Malmquist cor.','ESO 352- G 048',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15688,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15688,36.84,0.25,233,3633,74.4,NULL,NULL,'MCG -02-04-029',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00004,NULL,'14.97',0.6,'S',NULL,NULL,NULL,NULL,1,20.2315,-13.83519,0.012,NULL,35416123062,553376922,8646514,14.97),(15689,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15689,37.07,0.15,260,3633,70,NULL,NULL,'MCG -02-04-029',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15690,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15690,36.26,0.46,179,3634,70,NULL,NULL,'2MASX J01205644-0006199',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000086,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,20.23525,-0.10558,0.129,NULL,34495147005,538986671,8421666,16.3),(15691,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 07721',NULL,15691,40.06,0.25,1030,3635,70,NULL,'SN photometric redshift distance, z photo =0.277 +/- 0.040','SDSS-II SN 07721',NULL,'2011ApJ...738..162S',2011,1,0.13,NULL,'G',NULL,'PHOT','20.50',0.07,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,20.2409583333,-1.11825,0.148,NULL,34497356274,539021191,8422206,20.5),(15692,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 07721','R',15692,41.01,0.19,1220,3635,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07721',0.302,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15693,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 07721','R',15693,41.17,0.32,1320,3635,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07721',0.302,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15694,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15694,36.16,0.51,171,3636,70,NULL,NULL,'2MASX J01205820-1430352',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.25',0.22,NULL,NULL,NULL,NULL,NULL,1,20.242667,-14.50967,0,NULL,35416402712,553381292,8646582,16.25),(15695,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15695,37.07,0.15,260,3637,70,NULL,NULL,'GIN 069',NULL,'2001MNRAS.321..277C',2001,1,0.6,NULL,'G',0.000023,NULL,'14.04',0.44,'cD',NULL,NULL,NULL,NULL,1,20.2438333333,-13.85014,0.012,NULL,35416122555,553376914,8646514,14.04),(15696,'IRAS','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15696,35.52,0.8,127,3638,75,NULL,'W91PP, r','UGC 00877',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'15.79',0.1,'Sbc',NULL,NULL,NULL,NULL,1,20.243625,29.23142,0.189,NULL,67302652660,1051603947,16431311,15.79),(15697,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15697,35.02,0.49,101,3638,75,NULL,'IR','UGC 00877',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15698,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15698,35.33,0.38,116,3638,75,NULL,'W91PP, r, raw','UGC 00877',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15699,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15699,35.48,0.38,125,3638,75,NULL,'W91PP, r, inv','UGC 00877',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15700,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15700,35.65,0.38,135,3638,75,NULL,'W91PP, r, cor','UGC 00877',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15701,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15701,34.29,0.11,72.3,3639,NULL,NULL,NULL,'UGC 00885',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',NULL,NULL,'16.5',0.4,'Scd:',NULL,NULL,NULL,NULL,1,20.26,2.96,0.061,NULL,67525250016,1055082031,16485656,16.5),(15702,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15702,34.35,0.2,74.1,3639,74.4,NULL,NULL,'UGC 00885',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15703,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15703,33.77,0.45,56.7,3640,NULL,NULL,'K','UGC 00878',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000083,NULL,'14.44',0.9,'S0?',NULL,NULL,NULL,NULL,1,20.2625,33.89861,0.185,NULL,67762639756,1058791246,16543613,14.44),(15704,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15704,33.81,0.4,57.9,3640,NULL,NULL,'mean','UGC 00878',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15705,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15705,36.8,0.46,229,3641,70,NULL,NULL,'2MASX J01210376-0946244',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000099,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,20.26575,-9.77356,0.125,NULL,35277176114,551205876,8612591,16.5),(15706,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15706,35.25,0.53,112,3642,NULL,NULL,'Malmquist cor.','ESO 352- G 049',NULL,'2009ApJS..182..474S',2009,1,1.6,NULL,'G',0.000033,NULL,'14.25',0.6,'Sab: pec       HII',NULL,NULL,NULL,NULL,1,20.2705,-36.11783,NULL,NULL,38275261529,598050961,9344546,14.25),(15707,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15707,35.33,0.47,116,3642,NULL,NULL,'H','ESO 352- G 049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15708,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15708,35.42,0.49,121,3642,NULL,NULL,NULL,'ESO 352- G 049',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15709,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15709,35.43,0.45,122,3642,NULL,NULL,'K','ESO 352- G 049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15710,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15710,35.45,0.46,123,3642,NULL,NULL,'J','ESO 352- G 049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15711,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15711,35.46,0.2,124,3642,74.4,NULL,NULL,'ESO 352- G 049',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15712,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15712,35.59,0.4,131,3642,NULL,NULL,'mean','ESO 352- G 049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15713,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15713,33.74,0.23,56,3643,74.4,NULL,NULL,'CGCG 502-043',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00006,NULL,'14.9',0.6,'E',NULL,NULL,NULL,NULL,1,20.2734583,33.37892,0.137,NULL,67762405150,1058787580,16543555,14.9),(15714,'IRAS','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15714,34.4,0.8,76,3644,75,NULL,'MAT, I','ESO 352- G 050',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'15.40',0.3,'Sbc? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,20.28025,-35.20197,NULL,NULL,38283881633,598185650,9346650,15.4),(15715,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15715,34.52,0.32,80.1,3644,85,NULL,'I, raw','ESO 352- G 050',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15716,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15716,34.55,0.32,81.2,3644,85,NULL,'I, inv','ESO 352- G 050',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15717,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15717,34.6,0.43,83,3644,75,NULL,'MAT, I, raw','ESO 352- G 050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15718,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15718,34.75,0.43,89.2,3644,75,NULL,'MAT, I, inv','ESO 352- G 050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15719,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15719,34.87,0.43,94.1,3644,75,NULL,'MAT, I, cor','ESO 352- G 050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15720,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15720,34.96,0.54,98.1,3644,NULL,NULL,'Malmquist cor.','ESO 352- G 050',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15721,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15721,35.03,0.2,101,3644,74.4,NULL,NULL,'ESO 352- G 050',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15722,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15722,35.11,0.51,105,3644,NULL,NULL,NULL,'ESO 352- G 050',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15723,'IRAS','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15723,33.98,0.8,62.6,3645,75,NULL,'CF, r','UGC 00890',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000013,NULL,'14.08',0.5,'SB(s)bc:','in a radial-velocity based grouping',NULL,NULL,NULL,1,20.283333,1.37333,0.025,NULL,66642405441,1041287585,16270118,14.08),(15724,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15724,33.4,0.38,47.9,3645,75,NULL,'CF, r, raw','UGC 00890',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15725,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15725,33.48,0.38,49.6,3645,75,NULL,'CF, r, inv','UGC 00890',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15726,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15726,33.61,0.2,52.7,3645,74.4,NULL,NULL,'UGC 00890',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15727,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15727,33.79,0.38,57.3,3645,75,NULL,'CF, r, cor','UGC 00890',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15728,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15728,34.17,0.47,68.2,3645,NULL,NULL,'H','UGC 00890',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15729,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15729,34.24,0.4,70.4,3645,NULL,NULL,'mean','UGC 00890',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15730,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15730,34.3,0.09,72.6,3645,NULL,NULL,NULL,'UGC 00890',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15731,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15731,34.36,0.46,74.4,3645,NULL,NULL,'J','UGC 00890',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15732,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15732,34.39,0.45,75.5,3645,NULL,NULL,'K','UGC 00890',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15733,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15733,35.25,0.4,112,3646,NULL,NULL,'mean','UGC 00880',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.00005,NULL,'15.0',0.9,'S',NULL,NULL,NULL,NULL,1,20.28375,42.85142,0.313,NULL,67901395207,1060959300,16577489,15),(15734,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15734,35.62,0.47,133,3646,NULL,NULL,'H','UGC 00880',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15735,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15735,34.07,0.2,65.2,3647,74.4,NULL,NULL,'CGCG 436-032',NULL,'2013AJ....146...86T',2013,1,0.68,NULL,'G',0.000061,NULL,'15.4g',0.5,'SBc:',NULL,NULL,NULL,NULL,1,20.288875,15.69469,0.101,NULL,67602351610,1056286743,16504480,15.4),(15736,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 15761','RN',15736,41.87,0.24,1750,3648,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15761',0.355011,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15737,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 15761','N',15737,41.4,0.19,1910,3648,70,NULL,'SALT 2','SDSS-II SN 15761',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15738,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 15761','RN',15738,42.09,0.37,1930,3648,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15761',0.355011,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15739,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 15761','N',15739,41.44,0.19,1940,3648,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15761',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15740,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15740,35.33,0.46,116,3649,NULL,NULL,NULL,'UGC 00889',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000017,NULL,'16.0',0.5,'SBcd:',NULL,NULL,NULL,NULL,1,20.29375,17.86861,0.093,NULL,67420026906,1053437920,16459967,16),(15741,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15741,35.44,0.44,123,3649,NULL,NULL,'Malmquist cor.','UGC 00889',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15742,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15742,35.5,0.2,126,3649,74.4,NULL,NULL,'UGC 00889',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15743,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 11294','RN',15743,38.94,0.19,549,3650,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 11294',0.116746,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15744,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 11294','RN',15744,39.07,0.23,582,3650,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 11294',0.116746,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15745,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 12999','RN',15745,39.94,0.13,891,3651,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 12999',0.091679,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15746,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 12999','RN',15746,40.29,0.21,1040,3651,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 12999',0.091679,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15747,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15747,33.71,0.51,55.3,3652,70,NULL,NULL,'NGC 0481',NULL,'2014MNRAS.445.2677S',2014,1,1.7,'Identification as NGC 0481 is not certain.','G',0.0001,NULL,'14.57',1.3,'SA(r)0- pec?',NULL,NULL,NULL,NULL,1,20.302125,-9.21122,0.123,NULL,35283789746,551309214,8614206,14.57),(15748,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15748,36.3,0.7,182,3653,70,NULL,NULL,'2MASX J01211266-1424152',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.46',0.19,NULL,NULL,NULL,NULL,NULL,1,20.3030416667,-14.40436,0,NULL,35416382796,553380981,8646577,16.46),(15749,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15749,35.18,0.53,109,3654,70,NULL,NULL,'ESO 352- G 051',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000047,NULL,'14.96',0.7,'E1',NULL,NULL,NULL,NULL,1,20.306083,-36.47258,NULL,NULL,38275319129,598051861,9344560,14.96),(15750,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15750,37.15,0.77,269,3655,70,NULL,NULL,'2MASX J01211459-0410162',NULL,'2014MNRAS.445.2677S',2014,1,0.28,NULL,'G',0.00015,NULL,'16.77',0.22,NULL,NULL,NULL,NULL,NULL,1,20.310833,-4.17111,0.135,NULL,35248184426,550752881,8605513,16.77),(15751,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 07674','RN',15751,43.42,0.36,3160,3656,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07674',0.531111,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15752,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15752,36.29,0.33,181,3657,70,NULL,NULL,'MCG +00-04-094',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000107,NULL,'15.4g',0.5,'E;BrClG',NULL,NULL,NULL,NULL,1,20.323333,-0.59764,0.124,NULL,34495853027,538997703,8421839,15.4),(15753,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15753,34.32,0.48,73.2,3658,70,NULL,NULL,'ESO 476- G 005',NULL,'2014MNRAS.445.2677S',2014,1,1.9,NULL,'G',0.000023,NULL,'13.72',0.6,'SB:(r)bc       HII',NULL,NULL,NULL,NULL,1,20.324,-22.80067,0.052,NULL,35220361463,550318147,8598721,13.72),(15754,'IRAS','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15754,34.41,0.8,76.1,3658,75,NULL,'MAT, I','ESO 476- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15755,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15755,33.94,0.43,61.3,3658,75,NULL,'MAT, I, raw','ESO 476- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15756,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15756,33.96,0.47,61.9,3658,NULL,NULL,'H','ESO 476- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15757,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15757,34,0.49,63.2,3658,75,NULL,'IR','ESO 476- G 005',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15758,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15758,34.01,0.46,63.3,3658,NULL,NULL,'J','ESO 476- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15759,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15759,34.1,0.45,66.1,3658,NULL,NULL,'K','ESO 476- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15760,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15760,34.12,0.32,66.6,3658,85,NULL,'I, raw','ESO 476- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15761,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15761,34.19,0.32,68.8,3658,85,NULL,'I, inv','ESO 476- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15762,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15762,34.23,0.43,70.3,3658,75,NULL,'MAT, I, inv','ESO 476- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15763,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15763,34.32,0.43,73.1,3658,75,NULL,'MAT, I, cor','ESO 476- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15764,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15764,34.33,0.2,73.5,3658,74.4,NULL,NULL,'ESO 476- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15765,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15765,34.44,0.4,77.2,3658,NULL,NULL,'mean','ESO 476- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15766,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15766,34.48,0.28,78.8,3658,NULL,NULL,'Malmquist cor.','ESO 476- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15767,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15767,34.51,0.27,79.8,3658,NULL,NULL,NULL,'ESO 476- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15768,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15768,29.87,0.4,9.4,3659,75,NULL,'B','UGC 00891',NULL,'1988NBGC.C....0000T',1988,1,2.3,NULL,'G',0.000005,NULL,'14.67',1,'SABm:',NULL,NULL,NULL,NULL,1,20.32875,12.41194,0.101,NULL,67605882893,1056341920,16505342,14.67),(15769,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15769,37.86,0.46,374,3660,70,NULL,NULL,'2MASX J01211946+0021190',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000088,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,20.3312083333,0.35514,0.049,NULL,66642134064,1041283344,16270052,17.3),(15770,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15770,36.29,0.33,181,3661,70,NULL,NULL,'2MASX J01212030-0036512',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000092,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,20.3347917,-0.61431,0.124,NULL,34495850651,538997666,8421838,16.6),(15771,'IRAS','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15771,33.41,0.8,48.2,3662,75,NULL,'MAT, I','NGC 0491',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'13.21',1,'SB(rs)b:',NULL,NULL,NULL,NULL,1,20.335125,-34.06328,NULL,NULL,38285251783,598207059,9346985,13.21),(15772,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15772,33.64,0.4,53.6,3662,NULL,NULL,'mean','NGC 0491',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15773,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15773,33.91,0.45,60.6,3662,NULL,NULL,'K','NGC 0491',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15774,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15774,33.92,0.43,60.8,3662,75,NULL,'MAT, I, raw','NGC 0491',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15775,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15775,33.92,0.47,60.8,3662,NULL,NULL,'H','NGC 0491',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15776,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15776,33.95,0.46,61.7,3662,NULL,NULL,'J','NGC 0491',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15777,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15777,34,0.32,63.1,3662,85,NULL,'I, raw','NGC 0491',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15778,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15778,34.07,0.32,65.3,3662,85,NULL,'I, inv','NGC 0491',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15779,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15779,34.22,0.43,69.7,3662,75,NULL,'MAT, I, cor','NGC 0491',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15780,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15780,34.23,0.43,70.2,3662,75,NULL,'MAT, I, inv','NGC 0491',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15781,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 2002jy',NULL,15781,34.31,0.19,71.4,3663,74.2,NULL,'SALT 2','NGC 0477',0.0196,'2010ApJ...716..712A',2010,1,2.2,NULL,'G',0.000027,NULL,'13.70',1.2,'SAB(s)c',NULL,NULL,NULL,NULL,1,20.334875,40.48819,0.349,NULL,67893437033,1060834953,16575546,13.7),(15782,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 2002jy',NULL,15782,34.68,0.08,86.3,3663,74.4,NULL,NULL,'NGC 0477',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15783,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 2002jy',NULL,15783,34.79,0.03,89.1,3663,70,NULL,'SALT 2','NGC 0477',0.0196,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15784,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 2002jy',NULL,15784,34.82,0.03,90.3,3663,72,NULL,'SALT','NGC 0477',0.0196,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15785,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 2002jy',NULL,15785,35.06,0.17,101,3663,73.8,NULL,'SALT 2 (SNANA)','NGC 0477',0.0216,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15786,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 2002jy',NULL,15786,35.07,0.18,101,3663,70,NULL,'SALT 2','NGC 0477',0.0196,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15787,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 2002jy',NULL,15787,35.17,0.2,106,3663,65,NULL,'SALT','NGC 0477',0.0196,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15788,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 2002jy',NULL,15788,35.19,0.18,107,3663,65,NULL,'MLCS17','NGC 0477',0.0196,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15789,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 2002jy',NULL,15789,35.19,0.21,107,3663,65,NULL,'SALT2','NGC 0477',0.0196,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15790,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 2002jy',NULL,15790,35.28,0.18,111,3663,65,NULL,'MLCS31','NGC 0477',0.0196,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15791,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 2002jy',NULL,15791,35.99,0.2,155,3663,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','NGC 0477',0.0196,'2011A&A...526A..81B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15792,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15792,33.78,0.4,57,3663,75,NULL,'HOSTS SN 2002jy','NGC 0477',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15793,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15793,33.95,0.39,61.7,3663,NULL,NULL,NULL,'NGC 0477',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15794,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15794,33.99,0.69,62.8,3663,100,NULL,'mid-IR','NGC 0477',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15795,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15795,34.2,0.34,69.2,3663,NULL,NULL,'Malmquist cor.','NGC 0477',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15796,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15796,34.45,0.47,77.8,3663,NULL,NULL,'H','NGC 0477',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15797,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15797,34.54,0.46,81,3663,NULL,NULL,'J','NGC 0477',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15798,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15798,34.57,0.45,82.2,3663,NULL,NULL,'K','NGC 0477',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15799,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15799,34.61,0.4,83.4,3663,NULL,NULL,'mean','NGC 0477',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15800,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15800,34.68,0.08,86.3,3663,74.4,NULL,NULL,'NGC 0477',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15801,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15801,33.24,0.2,44.5,3664,74.4,NULL,NULL,'IC 1681',NULL,'2013AJ....146...86T',2013,1,1.13,NULL,'G',0.000023,NULL,'14.9g',0.38,'Sm',NULL,NULL,NULL,NULL,1,20.338833,0.09039,0.065,NULL,66642130323,1041283286,16270051,14.9),(15802,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15802,33.49,0.55,50,3664,NULL,NULL,NULL,'IC 1681',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15803,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15803,33.86,0.47,59,3664,NULL,NULL,'Malmquist cor.','IC 1681',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15804,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 17435','R',15804,40.24,0.2,916,3665,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ka','SN 2007ka',0.218,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,20.344583,-0.01481,0.073,NULL,34495139478,538986554,8421664,NULL),(15805,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 17435','R',15805,40.47,0.12,1020,3665,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ka','SN 2007ka',0.218,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15806,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15806,33,NULL,39.8,3666,NULL,NULL,NULL,'FGC 0155',NULL,'2000BSAO...50....5K',2000,1,1.03,NULL,'G',0.000027,NULL,'16.84',0.12,'Sdm',NULL,NULL,NULL,NULL,1,20.349167,-1.86278,0.178,NULL,34497065688,539016651,8422135,16.84),(15807,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15807,33.03,0.43,40.3,3666,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0155',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15808,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15808,33.04,NULL,40.5,3666,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0155',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15809,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15809,33.06,NULL,40.9,3666,NULL,NULL,'Dipole + Quadrupole','FGC 0155',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15810,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15810,33.07,NULL,41.1,3666,NULL,NULL,'Dipole','FGC 0155',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15811,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 02297','RN',15811,40.9,0.11,1230,3667,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 02297',0.231249,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15812,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 02297','RN',15812,41.37,0.2,1530,3667,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 02297',0.231249,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15813,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 07722','RN',15813,43.34,0.58,2760,3668,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 07722',0.6855,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15814,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15814,31.9,0.4,24,3669,73,NULL,'IR','NGC 0485',NULL,'2011A&A...532A.104N',2011,1,1.7,NULL,'G',0.000007,NULL,'14.02',0.6,'S','Pair member, wide',NULL,NULL,NULL,1,20.365,7.01808,0.117,NULL,67574848496,1055857007,16497765,14.02),(15815,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15815,31.9,0.4,24,3669,75,NULL,NULL,'NGC 0485',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15816,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15816,32.25,0.49,28.2,3669,75,NULL,'IR','NGC 0485',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15817,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15817,32.43,0.43,30.6,3669,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0485',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15818,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15818,32.47,0.43,31.2,3669,75,NULL,'3.6 micron, color corrected','NGC 0485',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15819,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15819,32.52,0.2,31.9,3669,74.4,NULL,NULL,'NGC 0485',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15820,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15820,32.53,0.4,32.1,3669,NULL,NULL,'mean','NGC 0485',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15821,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15821,32.84,0.47,37,3669,NULL,NULL,'H','NGC 0485',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15822,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15822,32.91,0.46,38.1,3669,NULL,NULL,'J','NGC 0485',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15823,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 01428','RN',15823,41.37,0.2,1410,3670,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01428',0.328309,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15824,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 01428','RN',15824,41.5,0.1,1500,3670,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01428',0.328309,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15825,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15825,37.97,0.46,393,3671,70,NULL,NULL,'2MASX J01212874-1012132',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000081,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,20.3696666667,-10.20372,0.153,NULL,35277041302,551203770,8612558,17.9),(15826,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15826,36.51,0.21,201,3672,70,NULL,NULL,'2MASX J01212908+1452456',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000082,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,20.37125,14.87933,0.097,NULL,67610407230,1056412612,16506447,17),(15827,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15827,35.96,0.4,156,3673,NULL,NULL,NULL,'AGC 111140',NULL,'2009ApJS..182..474S',2009,1,0.49,NULL,'G',0.000023,NULL,'15.5I',NULL,NULL,NULL,NULL,NULL,NULL,1,20.373333,5.29667,0.109,NULL,67524217966,1055065905,16485404,15.5),(15828,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15828,36.14,0.37,169,3673,NULL,NULL,'Malmquist cor.','AGC 111140',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15829,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15829,36.84,0.5,233,3674,NULL,NULL,'Malmquist cor.','2MFGC 01025',NULL,'2009ApJS..182..474S',2009,1,0.89,NULL,'G',0.000027,NULL,'13.2K',NULL,NULL,NULL,NULL,NULL,NULL,1,20.373417,7.07006,0.117,NULL,67574921200,1055858143,16497783,13.2),(15830,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15830,37.22,0.42,278,3674,NULL,NULL,NULL,'2MFGC 01025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15831,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15831,37.26,0.2,283,3674,74.4,NULL,NULL,'2MFGC 01025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15832,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15832,37.1,0.46,263,3675,70,NULL,NULL,'2MASX J01213296-0058115',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000072,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,20.3873333333,-0.96997,0.119,NULL,34497271583,539019868,8422185,17.4),(15833,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15833,38.52,0.46,505,3676,70,NULL,NULL,'2MASX J01213476-0020125',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000103,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,20.3947917,-0.33681,0.125,NULL,34495889757,538998277,8421848,17.7),(15834,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15834,38.23,0.46,443,3677,70,NULL,NULL,'2MASX J01213537-1042372',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000085,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,20.39725,-10.71025,0.118,NULL,35277452901,551210201,8612659,17.8),(15835,'IRAS','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15835,35.4,0.8,120,3678,75,NULL,'CF, r','UGC 00899',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000017,NULL,'15.00',0.5,'Sbc',NULL,NULL,NULL,NULL,1,20.404,20.91983,0.129,NULL,67442123620,1053783181,16465362,15),(15836,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15836,35.14,0.38,107,3678,75,NULL,'CF, r, raw','UGC 00899',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15837,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15837,35.27,0.38,113,3678,75,NULL,'CF, r, inv','UGC 00899',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15838,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15838,35.46,0.38,123,3678,75,NULL,'CF, r, cor','UGC 00899',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15839,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15839,37.2,0.46,275,3679,70,NULL,NULL,'2MASX J01213728-0925242',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000084,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,20.405417,-9.4235,0.133,NULL,35276308330,551192317,8612379,17.3),(15840,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 2005gc',NULL,15840,38.69,0.11,468,3680,74.2,NULL,'SALT 2','SDSS J012137.57-005838.0',0.17,'2010ApJ...716..712A',2010,1,0.12,NULL,'G',NULL,NULL,'20.4g',0.05,NULL,NULL,NULL,NULL,NULL,1,20.4065833333,-0.97722,0.119,NULL,34497273070,539019891,8422185,20.4),(15841,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 2005gc',NULL,15841,39.39,0.12,646,3680,70,NULL,'SALT 2','SDSS J012137.57-005838.0',0.17,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15842,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 2005gc',NULL,15842,39.43,0.07,657,3680,65,NULL,'SALT2','SDSS J012137.57-005838.0',0.17,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15843,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 03087','R',15843,39.43,0.18,658,3680,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005gc','SDSS J012137.57-005838.0',0.17,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15844,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 2005gc',NULL,15844,39.48,0.03,672,3680,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 03087, SN 2005gc','SDSS J012137.57-005838.0',0.17,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15845,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 2005gc',NULL,15845,39.48,NULL,674,3680,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 03087, SN 2005gc','SDSS J012137.57-005838.0',0.17,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15846,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 2005gc',NULL,15846,39.63,0.08,721,3680,65,NULL,'MLCS2k2','SDSS J012137.57-005838.0',0.17,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15847,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 2005gc',NULL,15847,39.34,0.06,738,3680,70,NULL,'SALT 2','SDSS J012137.57-005838.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15848,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 03087','R',15848,39.69,0.09,740,3680,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005gc','SDSS J012137.57-005838.0',0.17,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15849,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 2005gc',NULL,15849,39.35,0.06,741,3680,70,NULL,'SALT 2, Malmquist cor.','SDSS J012137.57-005838.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15850,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 12907','R',15850,38.86,0.18,522,3681,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006fv','SN 2006fv',0.132042,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia?',NULL,NULL,NULL,NULL,1,20.407833,0.4145,0.065,NULL,66642019890,1041281560,16270024,NULL),(15851,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 12907','R',15851,39.05,0.07,571,3681,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006fv','SN 2006fv',0.132042,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15852,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 18007','RN',15852,43.67,0.27,3540,3682,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 18007',0.531622,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15853,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 02236','RN',15853,42.37,0.17,2370,3683,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 02236',0.254312,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15854,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 02236','RN',15854,42.53,0.21,2550,3683,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 02236',0.254312,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15855,'Ring Diameter','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15855,32.5,0.84,31,3684,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 0488',NULL,'1981ApJS...45..541P',1981,1,5.2,NULL,'G',0.000003,NULL,'11.15',3.9,'SA(r)b','Pair member, wide',NULL,NULL,NULL,1,20.4452083,5.25672,0.085,NULL,67524189192,1055065456,16485397,11.15),(15856,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15856,32.33,0.4,29.3,3684,75,NULL,'B','NGC 0488',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15857,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15857,32.59,0.43,33,3685,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00903',NULL,'2014MNRAS.444..527S',2014,1,1.8,NULL,'G',0.000017,NULL,'14.50',0.4,'S?             HII:',NULL,NULL,NULL,NULL,1,20.449125,17.59242,0.173,NULL,67419960373,1053436880,16459951,14.5),(15858,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15858,32.61,0.4,33.3,3685,NULL,NULL,'mean','UGC 00903',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15859,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15859,32.61,0.4,33.3,3685,73,NULL,'IR','UGC 00903',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15860,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15860,32.61,0.4,33.3,3685,73,NULL,'opt','UGC 00903',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15861,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15861,32.61,0.4,33.3,3685,75,NULL,NULL,'UGC 00903',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15862,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15862,32.65,0.45,33.9,3685,NULL,NULL,'K','UGC 00903',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15863,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15863,32.71,0.47,34.8,3685,NULL,NULL,'H','UGC 00903',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15864,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15864,32.84,0.46,37,3685,NULL,NULL,'J','UGC 00903',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15865,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15865,32.99,0.43,39.6,3685,75,NULL,'3.6 micron, color corrected','UGC 00903',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15866,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15866,33.41,0.2,48.1,3685,74.4,NULL,NULL,'UGC 00903',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15867,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15867,33.51,0.49,50.3,3685,75,NULL,'IR','UGC 00903',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15868,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15868,33.55,0.43,51.2,3685,NULL,NULL,'Malmquist cor.','UGC 00903',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15869,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15869,33.58,0.42,52,3685,NULL,NULL,NULL,'UGC 00903',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15870,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15870,34.94,0.47,97.3,3686,NULL,NULL,'H','ESO 244- G 021',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000033,NULL,'14.11',0.8,'SB(r)bc',NULL,NULL,NULL,NULL,1,20.454917,-44.05753,NULL,NULL,38371217736,599550277,9367973,14.11),(15871,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15871,34.94,NULL,97.3,3686,NULL,NULL,'I','ESO 244- G 021',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15872,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15872,34.94,0.4,97.4,3686,NULL,NULL,'mean','ESO 244- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15873,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15873,35.01,0.46,101,3686,NULL,NULL,'J','ESO 244- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15874,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15874,35.02,0.52,101,3686,NULL,NULL,'Malmquist cor.','ESO 244- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15875,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15875,35.06,0.45,103,3686,NULL,NULL,'K','ESO 244- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15876,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15876,35.07,NULL,103,3686,NULL,NULL,'B, Hubble-type-TF','ESO 244- G 021',NULL,'2005Ap&SS.299..387R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15877,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15877,35.12,NULL,106,3686,NULL,NULL,'B','ESO 244- G 021',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15878,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15878,35.29,0.46,114,3686,NULL,NULL,NULL,'ESO 244- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15879,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15879,35.33,0.2,116,3686,74.4,NULL,NULL,'ESO 244- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15880,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15880,35.16,0.42,107,3687,NULL,NULL,NULL,'UGC 00904',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.95',0.6,'(R\')SB(s)a',NULL,NULL,NULL,NULL,1,20.457917,18.26767,0.109,NULL,67431354617,1053614915,16462733,14.95),(15881,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15881,35.23,0.41,111,3687,NULL,NULL,'Malmquist cor.','UGC 00904',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15882,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15882,35.43,0.2,122,3687,74.4,NULL,NULL,'UGC 00904',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15883,'GRB','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15883,46.86,0.8,5410,3688,72,NULL,NULL,'GRB 050908',3.35,'2008JCAP...07..004M',2008,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,20.4614583,-12.95478,0.011,NULL,35415062064,553360344,8646255,NULL),(15884,'GRB','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15884,46.97,0.79,5700,3688,70,NULL,NULL,'GRB 050908',3.35,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15885,'GRB','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15885,47,0.76,5770,3688,69.7,NULL,'Calibrated','GRB 050908',3.35,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15886,'GRB','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15886,47.03,0.93,5860,3688,NULL,NULL,NULL,'GRB 050908',3.35,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15887,'GRB','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15887,47.38,0.76,6880,3688,69.7,NULL,'Fiducial','GRB 050908',3.35,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15888,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15888,33.81,0.23,57.8,3689,74.4,NULL,NULL,'IC 1680',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00002,NULL,'14.9',0.6,'S0','Group member',NULL,NULL,NULL,1,20.463333,33.2825,0.169,NULL,67759511792,1058742371,16542849,14.9),(15889,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15889,35.6,0.5,132,3690,70,NULL,NULL,'MCG -01-04-029',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00011,NULL,'15',0.7,NULL,NULL,NULL,NULL,NULL,1,20.4646666667,-7.31289,0.181,NULL,35295597987,551493718,8617089,15),(15890,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 10915','R',15890,40.35,0.28,960,3691,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 10915',0.2244,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,20.4677083,0.38886,0.065,NULL,66641544597,1041274134,16269908,NULL),(15891,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 10915','R',15891,40.73,0.25,1140,3691,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 10915',0.2244,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15892,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15892,32.79,0.4,36.1,3692,NULL,NULL,'mean','NGC 0489',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000003,NULL,'13.55',0.4,'S0','X-ray-bright group member',NULL,NULL,NULL,1,20.474583,9.20656,0.085,NULL,67563977275,1055687144,16495111,13.55),(15893,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15893,33.09,0.2,41.5,3692,74.4,NULL,NULL,'NGC 0489',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15894,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15894,33.13,0.4,42.2,3692,75,NULL,NULL,'NGC 0489',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15895,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15895,33.19,0.46,43.5,3692,NULL,NULL,'J','NGC 0489',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15896,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15896,33.19,0.43,43.5,3692,75,NULL,'3.6 micron, color corrected','NGC 0489',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15897,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15897,33.29,0.47,45.5,3692,NULL,NULL,'H','NGC 0489',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15898,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15898,33.4,0.43,47.8,3692,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0489',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15899,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15899,33.4,0.45,47.9,3692,NULL,NULL,'K','NGC 0489',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15900,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15900,33.46,0.49,49.2,3692,75,NULL,'IR','NGC 0489',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15901,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15901,36.82,0.33,231,3693,70,NULL,NULL,'2MASX J01215564+1419145',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.0001,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,20.4817917,14.32078,0.089,NULL,67611571979,1056430812,16506731,16.4),(15902,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15902,37.34,0.46,294,3694,70,NULL,NULL,'2MASX J01215676+0030384',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000081,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,20.4864583,0.51056,0.065,NULL,66641587327,1041274801,16269918,17.5),(15903,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 18700','R',15903,38.16,0.07,405,3695,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2007md','CGCG 385-083',0.054626,'2014arXiv1401.3317S',2014,1,0.72,NULL,'G',0.000103,NULL,'15.8g',0.28,'NLAGN',NULL,NULL,NULL,NULL,1,20.487375,-1.01433,0.144,NULL,34497971843,539030810,8422356,15.8),(15904,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 18700','R',15904,39.41,0.2,722,3695,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2007md','CGCG 385-083',0.054626,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15905,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 21012','RN',15905,38.73,0.12,528,3696,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 21012',0.054503,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15906,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 15498','RN',15906,39.79,0.23,747,3697,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15498',0.215546,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15907,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 15498','RN',15907,39.88,0.16,777,3697,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15498',0.215546,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15908,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15908,35.83,0.31,146,3698,NULL,NULL,'Malmquist cor.','ESO 352- G 056',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.44',0.5,'Sb',NULL,NULL,NULL,NULL,1,20.4938333333,-34.14475,NULL,NULL,38285224961,598206640,9346978,15.44),(15909,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15909,36.22,0.26,176,3698,NULL,NULL,NULL,'ESO 352- G 056',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15910,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15910,36.26,0.2,179,3698,74.4,NULL,NULL,'ESO 352- G 056',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15911,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 10231','RN',15911,39.79,0.23,792,3699,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 10231',0.144823,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15912,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 10231','RN',15912,40.11,0.18,919,3699,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 10231',0.144823,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15913,'IRAS','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15913,34.08,0.8,65.6,3700,75,NULL,'W91PP, r','UGC 00909',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000017,NULL,'14.10',1.1,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,20.5057083,37.40047,0.257,NULL,67887845822,1060747590,16574181,14.1),(15914,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15914,34.19,0.09,69,3700,NULL,NULL,NULL,'UGC 00909',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15915,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15915,34.4,0.38,75.9,3700,75,NULL,'W91PP, r, raw','UGC 00909',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15916,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15916,34.54,0.38,80.9,3700,75,NULL,'W91PP, r, inv','UGC 00909',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15917,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15917,34.55,0.38,81.2,3700,75,NULL,'W91PP, r, cor','UGC 00909',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15918,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15918,34.59,0.43,82.9,3700,75,NULL,'3.6 micron, color corrected','UGC 00909',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15919,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15919,34.6,0.2,83.2,3700,74.4,NULL,NULL,'UGC 00909',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15920,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15920,34.66,0.43,85.7,3700,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00909',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15921,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 02183','RN',15921,39.52,0.08,735,3701,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 02183',0.089714,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15922,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 02183','RN',15922,39.83,0.21,849,3701,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 02183',0.089714,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15923,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1992bo',NULL,15923,33.93,0.2,60,3702,74.2,NULL,'SALT 2','ESO 352- G 057',0.01851,'2010ApJ...716..712A',2010,1,1.4,NULL,'G',0.00015,NULL,'15.00',0.4,'SB(s)0^0^ pec',NULL,NULL,NULL,NULL,1,20.5100416667,-34.19678,NULL,NULL,38285223145,598206611,9346978,15),(15924,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1992bo',NULL,15924,34.31,0.22,71.5,3702,72,NULL,NULL,'ESO 352- G 057',0.01851,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15925,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1992bo',NULL,15925,34.44,0.08,77.3,3702,74.4,NULL,NULL,'ESO 352- G 057',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15926,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1992bo',NULL,15926,34.5,0.26,79,3702,67,NULL,NULL,'ESO 352- G 057',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15927,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1992bo',NULL,15927,34.49,0.12,79.1,3702,70.8,NULL,NULL,'ESO 352- G 057',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15928,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1992bo',NULL,15928,34.53,0.08,80.5,3702,65,NULL,'LCS','ESO 352- G 057',NULL,'1995ApJ...445L..91R',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15929,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1992bo',NULL,15929,34.58,0.12,80.8,3702,70,NULL,NULL,'ESO 352- G 057',0.01851,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15930,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1992bo',NULL,15930,34.6,0.08,81.6,3702,65,NULL,'MLCS','ESO 352- G 057',0.01851,'1996ApJ...473..588R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15931,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1992bo',NULL,15931,34.61,0.01,82.2,3702,72,NULL,NULL,'ESO 352- G 057',0.01851,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15932,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1992bo',NULL,15932,34.59,0.07,82.8,3702,65,NULL,'Snapshot','ESO 352- G 057',NULL,'1996ApJ...473...88R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15933,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1992bo',NULL,15933,34.65,0.19,83.6,3702,70,NULL,'SALT','ESO 352- G 057',0.01851,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15934,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1992bo',NULL,15934,34.67,0.2,84.3,3702,65,NULL,'MLCS17','ESO 352- G 057',0.01851,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15935,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1992bo',NULL,15935,34.68,0.19,84.8,3702,70,NULL,'SALT 2','ESO 352- G 057',0.01851,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15936,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1992bo',NULL,15936,34.7,0.23,85.5,3702,65,NULL,NULL,'ESO 352- G 057',0.01851,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15937,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1992bo',NULL,15937,34.74,0.09,85.6,3702,65,NULL,'MLCS2k2','ESO 352- G 057',0.01851,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15938,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1992bo',NULL,15938,34.71,0.2,86,3702,65,NULL,'MLCS31','ESO 352- G 057',0.01851,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15939,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1992bo',NULL,15939,34.72,0.16,86.3,3702,65,NULL,'MLCS','ESO 352- G 057',0.01851,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15940,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1992bo',NULL,15940,34.73,0.1,86.9,3702,65,NULL,'MLCS2k2','ESO 352- G 057',0.01851,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15941,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1992bo',NULL,15941,34.74,0.18,87,3702,73.8,NULL,'SALT 2 (SNANA)','ESO 352- G 057',0.0189,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15942,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1992bo',NULL,15942,34.82,0.24,90.2,3702,65,NULL,'SALT','ESO 352- G 057',0.01851,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15943,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1992bo',NULL,15943,34.87,0.02,92.5,3702,65,NULL,'SALT','ESO 352- G 057',0.01851,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15944,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1992bo',NULL,15944,34.88,0.21,92.9,3702,65,NULL,'Template','ESO 352- G 057',0.01851,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15945,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1992bo',NULL,15945,34.97,0.14,98.6,3702,60,NULL,NULL,'ESO 352- G 057',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15946,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1992bo',NULL,15946,35.02,0.05,101,3702,60,NULL,'M(I) = -19.19 mag','ESO 352- G 057',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15947,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1992bo',NULL,15947,35.13,0.07,106,3702,60,NULL,'M(B) = -19.48 mag','ESO 352- G 057',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15948,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1992bo',NULL,15948,35.14,0.06,107,3702,60,NULL,'M(V) = -19.47 mag','ESO 352- G 057',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15949,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1992bo',NULL,15949,35.23,0.03,109,3702,70,NULL,'SALT 2','ESO 352- G 057',0.01851,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15950,'SBF','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15950,34.33,0.15,73.5,3702,NULL,NULL,'I','ESO 352- G 057',NULL,'2001ApJ...559..584A',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15951,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 18045','RN',15951,38.69,0.15,452,3703,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 18045',0.209406,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15952,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 18045','RN',15952,39.49,0.21,654,3703,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 18045',0.209406,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15953,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 02249','RN',15953,41.04,0.01,1330,3704,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 02249',0.216622,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15954,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 02249','RN',15954,41.23,0.21,1450,3704,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02249',0.216622,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15955,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15955,35.55,0.56,129,3705,70,NULL,NULL,'FAIRALL 0693',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.0001,NULL,'15.01',0.3,NULL,NULL,NULL,NULL,NULL,1,20.529583,-42.27575,NULL,NULL,38372409237,599568894,9368263,15.01),(15956,'IRAS','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15956,32.29,0.8,28.7,3706,75,NULL,'A82, H','NGC 0493',NULL,'1997ApJS..109..333W',1997,1,3.4,'Contains the possible HII region UM 318.','G',0.000017,NULL,'12.93',1,'SAB(s)cd: sp',NULL,NULL,NULL,NULL,1,20.5374583,0.94536,0.065,NULL,66643209248,1041300144,16270314,12.93),(15957,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15957,31.7,0.2,21.9,3706,74.4,NULL,NULL,'NGC 0493',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15958,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15958,31.72,0.52,22.1,3706,NULL,NULL,'Malmquist cor.','NGC 0493',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15959,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15959,31.76,0.43,22.5,3706,75,NULL,'3.6 micron, color corrected','NGC 0493',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15960,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15960,31.8,0.5,23,3706,NULL,NULL,NULL,'NGC 0493',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15961,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15961,31.81,0.43,23.1,3706,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0493',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15962,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15962,31.83,0.38,23.2,3706,NULL,NULL,NULL,'NGC 0493',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15963,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15963,31.83,0.39,23.2,3706,73,NULL,'opt','NGC 0493',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15964,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15964,31.87,0.4,23.7,3706,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 0493',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15965,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15965,32.06,0.47,25.8,3706,75,NULL,'A82, H, inv','NGC 0493',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15966,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15966,32.06,0.47,25.9,3706,75,NULL,'A82, H, raw','NGC 0493',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15967,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15967,32.28,0.47,28.6,3706,75,NULL,'A82, H, cor','NGC 0493',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15968,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15968,32.38,0.4,29.9,3706,75,NULL,'B','NGC 0493',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15969,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15969,34.83,0.62,92.4,3707,70,NULL,NULL,'MRK 0986',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.000085,NULL,'15.3g',0.47,'S0',NULL,NULL,NULL,NULL,1,20.5384583333,-9.88856,0.141,NULL,35277086790,551204481,8612570,15.3),(15970,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15970,37.13,0.9,267,3708,70,NULL,NULL,'2MASX J01220985-0752292',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.000113,NULL,'16.70',0.28,NULL,NULL,NULL,NULL,NULL,1,20.540917,-7.87481,0.141,NULL,35297576100,551524626,8617572,16.7),(15971,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15971,37.69,0.46,345,3709,70,NULL,NULL,'2MASX J01221379-1021292',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000097,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,20.5574583,-10.35822,0.157,NULL,35276881287,551201270,8612519,17.7),(15972,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15972,36.82,0.33,231,3710,70,NULL,NULL,'2MASX J01221470+1414025',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000084,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,20.56125,14.23408,0.093,NULL,67612075798,1056438684,16506854,16.5),(15973,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15973,34.26,0.4,71,3711,NULL,NULL,'mean','UGC 00913',NULL,'2007A&A...465...71T',2007,1,0.5,NULL,'G',0.000033,NULL,'14.80',0.3,'S?',NULL,NULL,NULL,NULL,1,20.562917,34.66917,0.133,NULL,67762831393,1058794240,16543660,14.8),(15974,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15974,34.55,0.47,81.2,3711,NULL,NULL,'H','UGC 00913',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15975,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15975,33.22,0.2,44.1,3712,74.4,NULL,NULL,'CGCG 502-054',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'15.50',0.3,'Sc',NULL,NULL,NULL,NULL,1,20.571417,28.79792,0.205,NULL,67302545396,1051602271,16431285,15.5),(15976,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15976,33.5,0.4,50,3712,NULL,NULL,NULL,'CGCG 502-054',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15977,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15977,34.06,0.31,64.9,3712,NULL,NULL,'Malmquist cor.','CGCG 502-054',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15978,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 01163','RN',15978,41.79,0.21,1720,3713,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01163',0.322689,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15979,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 01163','RN',15979,41.93,0.09,1840,3713,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01163',0.322689,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15980,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 16276','R',15980,39.93,0.22,811,3714,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006om','SN 2006om',0.193,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,20.578667,1.01061,0.065,NULL,66643243788,1041300684,16270323,NULL),(15981,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 16276','R',15981,40.1,0.11,878,3714,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006om','SN 2006om',0.193,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15982,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15982,34.73,0.46,88.3,3715,70,NULL,NULL,'NGC 0497',NULL,'2014MNRAS.445.2677S',2014,1,2.03,NULL,'G',0.00001,NULL,'13.7g',0.79,'SB(rs)bc:',NULL,NULL,NULL,NULL,1,20.5990833333,-0.87519,0.163,NULL,34498003286,539031301,8422364,13.7),(15983,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15983,34.76,0.42,89.4,3715,NULL,NULL,'Malmquist cor.','NGC 0497',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15984,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15984,35.09,0.2,104,3715,74.4,NULL,NULL,'NGC 0497',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15985,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15985,35.14,0.43,107,3715,75,NULL,'3.6 micron, color corrected','NGC 0497',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15986,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15986,35.19,0.34,109,3715,NULL,NULL,NULL,'NGC 0497',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15987,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15987,35.42,0.43,122,3715,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0497',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15988,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15988,37.24,0.76,280,3716,70,NULL,NULL,'2MASX J01222731-0218148',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00014,NULL,'16.20',0.2,NULL,NULL,NULL,NULL,NULL,1,20.61375,-2.30406,0.183,NULL,35234114089,550533032,8602078,16.2),(15989,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15989,35.62,0.46,133,3717,70,NULL,NULL,'2MASX J01222797+1532386',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000089,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,20.616583,15.54403,0.109,NULL,67602504490,1056289132,16504517,16.5),(15990,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15990,34.61,0.49,83.7,3718,75,NULL,'IR','2MFGC 01042',NULL,'2011yCatp016004901K',2011,1,0.76,NULL,'G',0.000264,NULL,'15.99',0.12,NULL,NULL,NULL,NULL,NULL,1,20.621667,34.04,0.201,NULL,67759644421,1058744444,16542881,15.99),(15991,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 05988','RN',15991,40.7,0.25,1170,3719,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 05988',0.177178,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15992,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15992,34.5,0.57,79.3,3720,70,NULL,NULL,'2MFGC 01043',NULL,'2014MNRAS.445.2677S',2014,1,0.6,'1988AJ.....95..999C has V = 7159 +- 71 km/s.','G',0.00015,NULL,'15.36',0.3,'S0:',NULL,NULL,NULL,NULL,1,20.63375,-2.40986,0.183,NULL,35234085183,550532580,8602071,15.36),(15993,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 19332','N',15993,40.4,0.17,1200,3721,70,NULL,'SALT 2','SDSS-II SN 19332',NULL,'2013ApJ...763...88C',2013,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15994,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 19332','N',15994,40.42,0.17,1210,3721,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19332',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15995,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15995,34.62,0.5,83.8,3722,70,NULL,NULL,'CGCG 385-086',NULL,'2014MNRAS.445.2677S',2014,1,0.69,NULL,'G',0.000077,NULL,'15.2g',0.58,'S0?',NULL,NULL,NULL,NULL,1,20.6475,-0.57008,0.132,NULL,34497747711,539027307,8422301,15.2),(15996,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15996,35.18,0.46,109,3722,70,NULL,NULL,'CGCG 385-086',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15997,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',15997,38.13,0.23,422,3723,70,NULL,NULL,'SDSS J012236.25-102317.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000093,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,20.651083,-10.38806,0.157,NULL,35276934691,551202104,8612532,18.6),(15998,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15998,34.15,0.4,67.7,3724,NULL,NULL,'mean','IC 1683',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000067,NULL,'14.17',0.6,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,20.6625,34.43694,0.153,NULL,67762789586,1058793587,16543649,14.17),(15999,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,15999,34.19,0.47,68.9,3724,NULL,NULL,'H','IC 1683',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16000,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16000,34.22,0.45,69.9,3724,NULL,NULL,'K','IC 1683',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16001,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16001,34.27,0.46,71.3,3724,NULL,NULL,'J','IC 1683',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16002,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',16002,38.8,0.27,576,3725,70,NULL,NULL,'2MASX J01224122+0017462',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000089,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,20.671833,0.29614,0.057,NULL,66641703541,1041276617,16269947,17.5),(16003,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16003,34.03,0.55,64,3726,70,NULL,NULL,'UGC 00921',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.000113,NULL,'14.26',0.6,'S0 pec sp',NULL,NULL,NULL,NULL,1,20.6955,-1.392,0.152,NULL,34497522149,539023783,8422246,14.26),(16004,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16004,34.48,0.07,78.9,3726,NULL,NULL,NULL,'UGC 00921',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16005,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',16005,37.03,0.33,254,3727,70,NULL,NULL,'2MASX J01224692+1348547',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000082,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,20.6954583,13.81533,0.097,NULL,67612015845,1056437747,16506839,16.8),(16006,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',16006,38.13,0.23,422,3728,70,NULL,NULL,'2MASX J01224806-1028434',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000097,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,20.700125,-10.47886,0.157,NULL,35277272884,551207388,8612615,17.6),(16007,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',16007,37.03,0.33,254,3729,70,NULL,NULL,'SDSS J012248.22+135658.5',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000109,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,20.7009583333,13.94958,0.089,NULL,67612084312,1056438817,16506856,16.3),(16008,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 03914','RN',16008,38.88,0.4,572,3730,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03914',0.04347,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16009,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 03914','RN',16009,39.34,0.63,707,3730,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03914',0.04347,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16010,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16010,35.3,0.49,115,3731,70,NULL,NULL,'ESO 244- G 022',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.000067,NULL,'15.18',0.57,'S0',NULL,NULL,NULL,NULL,1,20.7192083,-42.56492,NULL,NULL,38372297156,599567143,9368236,15.18),(16011,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',16011,35.7,0.49,138,3732,75,NULL,'IR','UGC 00923',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',NULL,NULL,'16.16',0.3,'Sbc',NULL,NULL,NULL,NULL,1,20.725917,13.12736,0.109,NULL,67609852759,1056403949,16506311,16.16),(16012,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',16012,38.13,0.23,422,3733,70,NULL,NULL,'SDSS J012254.48-102307.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000093,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,20.727,-10.38531,0.157,NULL,35276766455,551199475,8612491,18.4),(16013,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 19084','RN',16013,42.05,0.22,2150,3734,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 19084',0.199572,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16014,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 19084','RN',16014,42.18,0.23,2280,3734,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 19084',0.199572,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16015,'IRAS','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16015,34.34,0.8,73.9,3735,75,NULL,'HMCL, I','NGC 0494',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000033,NULL,'13.8',0.8,'Sab','Group member',NULL,NULL,NULL,1,20.730833,33.17389,0.169,NULL,67751952693,1058624260,16541004,13.8),(16016,'IRAS','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16016,34.34,0.8,73.9,3735,75,NULL,'W91PP, r','NGC 0494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16017,'Sosies','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16017,34.17,0.06,68.2,3735,NULL,NULL,NULL,'NGC 0494',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16018,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16018,33.72,0.4,55.5,3735,75,NULL,'HMCL, I, raw','NGC 0494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16019,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16019,33.84,NULL,58.6,3735,NULL,NULL,'I','NGC 0494',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16020,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16020,33.87,NULL,59.4,3735,NULL,NULL,'B','NGC 0494',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16021,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16021,33.89,0.47,59.9,3735,NULL,NULL,'H','NGC 0494',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16022,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16022,33.92,0.38,60.8,3735,75,NULL,'W91PP, r, raw','NGC 0494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16023,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16023,33.92,0.46,60.8,3735,NULL,NULL,'J','NGC 0494',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16024,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16024,33.92,0.45,60.9,3735,NULL,NULL,'K','NGC 0494',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16025,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16025,33.97,0.4,62.1,3735,75,NULL,'HMCL, I, inv','NGC 0494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16026,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16026,34,0.4,63.2,3735,75,NULL,'HMCL, I, cor','NGC 0494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16027,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16027,34.12,0.38,66.6,3735,75,NULL,'W91PP, r, cor','NGC 0494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16028,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16028,34.17,0.38,68.3,3735,75,NULL,'W91PP, r, inv','NGC 0494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16029,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16029,34.38,0.4,75.2,3735,NULL,NULL,'mean','NGC 0494',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16030,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16030,34.39,0.12,75.7,3735,NULL,NULL,NULL,'NGC 0494',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16031,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16031,32.64,0.4,33.8,3736,NULL,NULL,'mean','NGC 0502',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000017,NULL,'13.74',1,'SA(r)0^0^','X-ray-bright group member',NULL,NULL,NULL,1,20.731417,9.04919,0.081,NULL,67533550920,1055211733,16487683,13.74),(16032,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16032,32.7,0.45,34.7,3736,NULL,NULL,'K','NGC 0502',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16033,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1999ej',NULL,16033,33.53,0.28,50.1,3737,74.2,NULL,'SALT 2','NGC 0495',0.01372,'2010ApJ...716..712A',2010,1,1.3,NULL,'G',0.000033,NULL,'13.2B',0.8,'(R\')SB(s)0/a pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,20.733333,33.47167,0.169,NULL,67759528769,1058742637,16542853,13.2),(16034,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1999ej',NULL,16034,33.68,0.12,54.5,3737,70.8,NULL,NULL,'NGC 0495',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16035,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1999ej',NULL,16035,34.11,0.08,66.4,3737,74.4,NULL,NULL,'NGC 0495',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16036,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1999ej',NULL,16036,34.19,0.31,67.9,3737,70,NULL,'SALT','NGC 0495',0.01372,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16037,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1999ej',NULL,16037,34.2,0.04,68.2,3737,72,NULL,NULL,'NGC 0495',0.01372,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16038,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1999ej',NULL,16038,34.24,0.22,69.6,3737,70,NULL,'SALT 2','NGC 0495',0.01372,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16039,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1999ej',NULL,16039,34.29,0.25,71.1,3737,72,NULL,NULL,'NGC 0495',0.01372,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16040,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1999ej',NULL,16040,34.4,0.26,75,3737,65,NULL,'MLCS31','NGC 0495',0.01372,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16041,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1999ej',NULL,16041,34.41,0.26,75.3,3737,65,NULL,'MLCS17','NGC 0495',0.01372,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16042,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1999ej',NULL,16042,34.46,0.12,75.9,3737,65,NULL,'MLCS2k2','NGC 0495',0.01372,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16043,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1999ej',NULL,16043,34.47,0.31,77.1,3737,65,NULL,'SALT2','NGC 0495',0.01372,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16044,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1999ej',NULL,16044,34.7,0.3,87.1,3737,60,NULL,NULL,'NGC 0495',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16045,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',16045,38.13,0.23,422,3738,70,NULL,NULL,'2MASX J01225891-1026054',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000083,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,20.7452917,-10.43469,0.157,NULL,35276757893,551199342,8612489,17.8),(16046,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 19588','RN',16046,41.35,0.19,1500,3739,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19588',0.242654,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16047,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 19588','RN',16047,42.16,0.31,2180,3739,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19588',0.242654,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16048,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 18943',NULL,16048,40.06,0.3,1030,3740,70,NULL,'SN photometric redshift distance, z photo =0.277 +/- 0.050','SDSS-II SN 18943',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,20.769625,-0.06722,0.041,NULL,34495560257,538993129,8421767,NULL),(16049,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 18943','R',16049,41.27,0.18,1330,3740,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18943',0.350196,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16050,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 18943','R',16050,41.4,0.26,1410,3740,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18943',0.350196,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16051,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 18943',NULL,16051,41.28,0.15,1800,3740,70,NULL,'SALT 2','SDSS-II SN 18943',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16052,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 18943',NULL,16052,41.33,0.15,1850,3740,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18943',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16053,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',16053,38.27,0.46,451,3741,70,NULL,NULL,'2MASX J01230479-1007304',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000098,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,20.7700416667,-10.12503,0.144,NULL,35276953186,551202393,8612537,17.2),(16054,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',16054,35.89,0.46,151,3742,70,NULL,NULL,'2MASX J01230589-1026354',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000069,NULL,'16.2g',0.34,'S0',NULL,NULL,NULL,NULL,1,20.774667,-10.44317,0.157,NULL,35277267237,551207300,8612614,16.2),(16055,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16055,34.87,0.63,94.1,3743,70,NULL,NULL,'ESO 352- G 062',NULL,'2014MNRAS.445.2677S',2014,1,1.85,NULL,'G',0.000047,NULL,'15.23',0.22,'Sbc',NULL,NULL,NULL,NULL,1,20.778625,-34.73439,NULL,NULL,38284919536,598201867,9346904,15.23),(16056,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16056,35.58,0.4,131,3743,NULL,NULL,'mean','ESO 352- G 062',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16057,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16057,35.61,NULL,132,3743,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 352- G 062',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16058,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',16058,35.6,0.49,132,3743,75,NULL,'IR','ESO 352- G 062',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16059,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16059,35.64,NULL,134,3743,NULL,NULL,'Dipole + Quadrupole','ESO 352- G 062',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16060,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16060,35.67,NULL,136,3743,NULL,NULL,'Dipole','ESO 352- G 062',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16061,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16061,35.89,0.47,151,3743,NULL,NULL,'H','ESO 352- G 062',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16062,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16062,36,0.45,158,3743,NULL,NULL,'K','ESO 352- G 062',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16063,'D-Sigma','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16063,33.92,0.4,60.8,3744,75,NULL,'Edat, raw','NGC 0499',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'13.17',1.3,'S0-','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,20.797917,33.46056,0.165,NULL,67759737787,1058745902,16542904,13.17),(16064,'D-Sigma','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16064,34.33,0.4,73.6,3744,75,NULL,'Edat, cor','NGC 0499',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16065,'Faber-Jackson','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16065,33.46,0.44,49.2,3744,95,NULL,'Weighted Mean','NGC 0499',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16066,'Faber-Jackson','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16066,33.67,0.46,54.2,3744,95,NULL,'Michard 1979a','NGC 0499',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16067,'Faber-Jackson','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16067,34.41,0.63,76.2,3744,95,NULL,'Michard 1979b, c','NGC 0499',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16068,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16068,33.68,0.23,54.5,3744,74.4,NULL,NULL,'NGC 0499',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16069,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16069,33.76,0.45,56.6,3744,NULL,NULL,'K','NGC 0499',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16070,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16070,33.92,0.4,60.8,3744,NULL,NULL,'mean','NGC 0499',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16071,'IRAS','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16071,34.55,0.8,81.3,3745,75,NULL,'W91CL, r','NGC 0496',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000027,NULL,'14.09',0.9,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,20.798333,33.52917,0.201,NULL,67759748819,1058746075,16542907,14.09),(16072,'IRAS','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16072,34.58,0.8,82.3,3745,75,NULL,'W91PP, r','NGC 0496',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16073,'IRAS','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16073,34.59,0.8,82.7,3745,75,NULL,'CF, r','NGC 0496',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16074,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16074,33.56,0.38,51.5,3745,75,NULL,'CF, r, raw','NGC 0496',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16075,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16075,33.62,0.43,52.9,3745,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0496',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16076,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16076,33.63,0.43,53.2,3745,75,NULL,'3.6 micron, color corrected','NGC 0496',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16077,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16077,33.63,0.38,53.3,3745,75,NULL,'CF, r, inv','NGC 0496',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16078,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16078,33.68,0.2,54.5,3745,74.4,NULL,NULL,'NGC 0496',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16079,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16079,33.88,0.38,59.8,3745,75,NULL,'CF, r, cor','NGC 0496',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16080,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16080,33.9,0.38,60.2,3745,75,NULL,'W91CL, r, raw','NGC 0496',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16081,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16081,34,0.38,63.1,3745,75,NULL,'W91CL, r, inv','NGC 0496',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16082,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16082,34.01,0.38,63.3,3745,75,NULL,'W91PP, r, raw','NGC 0496',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16083,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16083,34.02,NULL,63.7,3745,NULL,NULL,'B','NGC 0496',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16084,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16084,34.05,0.69,64.6,3745,100,NULL,'mid-IR','NGC 0496',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16085,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16085,34.08,0.38,65.4,3745,75,NULL,'W91CL, r, cor','NGC 0496',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16086,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16086,34.13,0.38,66.9,3745,75,NULL,'W91PP, r, inv','NGC 0496',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16087,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16087,34.19,0.38,68.8,3745,75,NULL,'W91PP, r, cor','NGC 0496',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16088,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16088,34.19,NULL,68.9,3745,NULL,NULL,'I','NGC 0496',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16089,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16089,34.2,0.09,69.3,3745,NULL,NULL,NULL,'NGC 0496',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16090,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16090,37.49,0.55,315,3746,70,NULL,NULL,'2MASX J01231180-2029133',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.15',0.3,NULL,NULL,NULL,NULL,NULL,1,20.7992083,-20.48714,0.035,NULL,35230854504,550482101,8601282,16.15),(16091,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',16091,35.21,0.33,110,3747,70,NULL,NULL,'UGC 00928',NULL,'2015arXiv151105856S',2015,1,0.98,NULL,'G',0.000057,NULL,'14.8g',0.44,'S0','Group member',NULL,NULL,NULL,1,20.8015416667,-0.64119,0.121,NULL,34497825479,539028523,8422320,14.8),(16092,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16092,35.34,0.46,117,3747,70,NULL,NULL,'UGC 00928',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16093,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 14823',NULL,16093,40.15,0.26,1070,3748,70,NULL,'SN photometric redshift distance, z photo =0.291 +/- 0.045','SDSS-II SN 14823',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,20.802875,-0.31058,0.133,NULL,34495563275,538993176,8421768,NULL),(16094,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 14823','R',16094,40.95,0.24,1150,3748,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14823',0.349572,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16095,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 14823','R',16095,41.14,0.19,1250,3748,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14823',0.349572,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16096,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 14823',NULL,16096,40.83,0.15,1470,3748,70,NULL,'SALT 2','SDSS-II SN 14823',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16097,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 14823',NULL,16097,40.88,0.15,1500,3748,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14823',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16098,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16098,32.36,0.39,29.6,3749,73,NULL,'opt','UGC 00931',NULL,'2011A&A...532A.104N',2011,1,1.2,'Multiple SDSS entries describe this object.','G',0.00002,NULL,'15.69',0.2,'Sc','Group member',NULL,NULL,NULL,1,20.8104583,-0.70133,0.121,NULL,34497790957,539027983,8422312,15.69),(16099,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16099,32.44,0.6,30.8,3749,NULL,NULL,'Malmquist cor.','UGC 00931',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16100,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16100,32.59,0.56,33,3749,NULL,NULL,NULL,'UGC 00931',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16101,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16101,32.65,0.2,33.9,3749,74.4,NULL,NULL,'UGC 00931',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16102,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 14492','R',16102,37.77,0.07,333,3750,70,NULL,'SDSS CAND. SNIb; MLCS2K2; SN 2006jo','SN 2006jo',0.076921,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ib',NULL,NULL,NULL,NULL,1,20.811333,-0.32964,0.133,NULL,34497646382,539025724,8422276,NULL),(16103,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 14492','R',16103,38.14,0.19,394,3750,70,NULL,'SDSS CAND. SNIb; SALT 2; SN 2006jo','SN 2006jo',0.076921,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16104,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16104,34.51,0.29,79.6,3751,NULL,NULL,'Malmquist cor.','ESO 352- G 063',NULL,'2009ApJS..182..474S',2009,1,1.22,NULL,'G',0.000083,NULL,'14.4b',0.44,'Sbc',NULL,NULL,NULL,NULL,1,20.8119583333,-32.84131,NULL,NULL,38280000996,598125015,9345703,14.4),(16105,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16105,34.62,0.28,83.9,3751,NULL,NULL,NULL,'ESO 352- G 063',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16106,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16106,34.66,0.2,85.5,3751,74.4,NULL,NULL,'ESO 352- G 063',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16107,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16107,35.27,0.47,113,3751,NULL,NULL,'H','ESO 352- G 063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16108,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16108,35.41,0.45,121,3751,NULL,NULL,'K','ESO 352- G 063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16109,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16109,35.42,0.46,122,3751,NULL,NULL,'J','ESO 352- G 063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16110,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16110,35.48,0.4,125,3751,NULL,NULL,'mean','ESO 352- G 063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16111,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',16111,38.48,0.46,496,3752,70,NULL,NULL,'SDSS J012315.45-100607.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000081,NULL,'18.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,20.814375,-10.10219,0.144,NULL,35276954144,551202408,8612537,18.3),(16112,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16112,37.16,0.54,270,3753,70,NULL,NULL,'2MASX J01231555-2032555',NULL,'2014MNRAS.445.2677S',2014,1,0.71,NULL,'G',0.00015,NULL,'15.93',0.58,NULL,NULL,NULL,NULL,NULL,1,20.815,-20.54894,0.035,NULL,35230442350,550475661,8601182,15.93),(16113,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16113,36.13,0.61,168,3754,70,NULL,NULL,'MCG -02-04-035',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.000075,NULL,'15.5g',0.41,'Sb',NULL,NULL,NULL,NULL,1,20.816,-9.02811,0.123,NULL,35278305364,551223521,8612867,15.5),(16114,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',16114,38.8,0.27,576,3755,70,NULL,NULL,'2MASX J01231694+0017441',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000117,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,20.8205417,0.29553,0.041,NULL,66642544194,1041289753,16270152,18.1),(16115,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16115,34.9,0.57,95.6,3756,NULL,NULL,'Malmquist cor.','CGCG 385-093',NULL,'2009ApJS..182..474S',2009,1,0.72,NULL,'G',0.00002,NULL,'15.5g',0.28,'S0/a?','Group member',NULL,NULL,NULL,1,20.820833,-0.90603,0.163,NULL,34497929960,539030155,8422346,15.5),(16116,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16116,35.2,0.5,110,3756,NULL,NULL,NULL,'CGCG 385-093',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16117,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16117,35.24,0.2,112,3756,74.4,NULL,NULL,'CGCG 385-093',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16118,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',16118,38.8,0.27,576,3757,70,NULL,NULL,'SDSS J012317.05+001643.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000092,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,20.8210833333,0.27872,0.041,NULL,66641480541,1041273133,16269892,18.5),(16119,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16119,31.47,0.2,19.7,3758,74.4,NULL,NULL,'VV 730 NED01',NULL,'2013AJ....146...86T',2013,1,0.73,NULL,'G',NULL,NULL,'15.3',0.37,NULL,NULL,NULL,NULL,NULL,1,20.8304583,7.79631,0.109,NULL,67571749879,1055808591,16497009,15.3),(16120,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 16640',NULL,16120,39.96,0.56,982,3759,70,NULL,'SN photometric redshift distance, z photo =0.263 +/- 0.095','SDSS-II SN 16640',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.6g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,20.8314166667,-0.24547,0.112,NULL,34495576401,538993381,8421771,21.6),(16121,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 16640','R',16121,41.37,0.34,1400,3759,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16640',0.340292,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16122,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 16640','R',16122,41.56,0.29,1530,3759,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16640',0.340292,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16123,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 16640',NULL,16123,41.28,0.21,1800,3759,70,NULL,'SALT 2','SDSS-II SN 16640',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16124,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 16640',NULL,16124,41.33,0.21,1850,3759,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16640',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16125,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1998dm',NULL,16125,31.86,0.17,23.6,3760,70.8,NULL,NULL,'VV 730',NULL,'2008MNRAS.389.1577T',2008,1,NULL,NULL,'GPair',0.000007,NULL,NULL,NULL,'Sm',NULL,NULL,NULL,NULL,1,20.83125,7.795,0.109,NULL,67571749884,1055808591,16497009,NULL),(16126,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1998dm',NULL,16126,32.34,0.44,29.1,3760,74.2,NULL,'SALT 2','VV 730',0.009006,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16127,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1998dm',NULL,16127,33.07,0.18,40.3,3760,65,NULL,'MLCS2k2','VV 730',0.009006,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16128,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1998dm',NULL,16128,33.27,0.14,45.1,3760,60,NULL,NULL,'VV 730',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16129,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 1998dm',NULL,16129,33.34,0.39,46.1,3760,70,NULL,'SALT','VV 730',0.009006,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16130,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16130,31.81,0.4,23,3760,75,NULL,'HOSTS SN 1998dm','VV 730',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16131,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16131,32.07,0.4,25.9,3760,75,NULL,'HOSTS SN 1998dm','VV 730',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16132,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16132,35.68,NULL,137,3761,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0157',NULL,'2010Ap&SS.325..163P',2010,1,0.92,NULL,'G',0.000021,NULL,'17.2g',0.14,'Sd(f)',NULL,NULL,NULL,NULL,1,20.836083,14.26628,0.097,NULL,67610869992,1056419843,16506560,17.2),(16133,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16133,35.7,NULL,138,3761,NULL,NULL,'Dipole + Quadrupole','FGC 0157',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16134,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16134,35.73,NULL,140,3761,NULL,NULL,'Dipole','FGC 0157',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16135,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16135,35.76,NULL,142,3761,NULL,NULL,NULL,'FGC 0157',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16136,'D-Sigma','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16136,33.99,0.14,62.8,3762,72,NULL,'[HMS56] 0122+3305 cluster, 10 galaxies','NGC 0501',NULL,'2002AJ....123.2159B',2002,1,NULL,NULL,'G',0.00005,NULL,'15.50',NULL,'E0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,20.843375,33.43297,0.165,NULL,67759735462,1058745866,16542904,15.5),(16137,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16137,33.98,0.14,62.4,3762,75,NULL,'[HMS56] 0122+3305 cluster, 9 galaxies','NGC 0501',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16138,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16138,33.98,0.14,62.4,3762,75,NULL,'[HMS56] 0122+3305 cluster, 9 galaxies','NGC 0501',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16139,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16139,34.53,0.23,80.5,3762,74.4,NULL,NULL,'NGC 0501',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16140,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16140,35.68,0.25,137,3763,74.4,NULL,NULL,'2MASX J01232367+0146051',NULL,'2013AJ....146...86T',2013,1,0.37,NULL,'G',0.000028,NULL,'17.01',0.35,NULL,NULL,NULL,NULL,NULL,1,20.848667,1.76806,0.029,NULL,66640692180,1041260815,16269700,17.01),(16141,'BCG','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16141,36.86,0.35,228,3764,60,NULL,'ABELL 0189, BCG','VV 509',0.0349,'1980ApJ...241..486H',1980,1,0.4,NULL,'G',0.000022,NULL,'15.5',0.2,NULL,'Brightest group member',NULL,NULL,NULL,1,20.860125,1.70594,0.029,NULL,66640706162,1041261033,16269703,15.5),(16142,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16142,35.51,0.25,126,3764,74.4,NULL,NULL,'VV 509',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16143,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 04149','RN',16143,42.61,0.18,2220,3765,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04149',0.498414,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16144,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 15998',NULL,16144,40.2,0.2,1100,3766,70,NULL,'SN photometric redshift distance, z photo =0.300 +/- 0.035','SDSS-II SN 15998',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','21.6g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,20.8627083,0.02911,0.041,NULL,66641502195,1041273471,16269897,21.6),(16145,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 15998','R',16145,41.2,0.27,1300,3766,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15998',0.34098,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16146,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 15998','R',16146,41.43,0.24,1440,3766,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15998',0.34098,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16147,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 15998',NULL,16147,41.07,0.18,1640,3766,70,NULL,'SALT 2','SDSS-II SN 15998',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16148,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 15998',NULL,16148,41.11,0.18,1670,3766,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15998',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16149,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16149,34.06,0.25,64.9,3767,74.4,NULL,NULL,'NGC 0504',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.00008,NULL,'13.99',0.4,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,20.86625,33.20444,0.165,NULL,67752121834,1058626903,16541045,13.99),(16150,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16150,33.87,0.4,59.4,3767,NULL,NULL,'mean','NGC 0504',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16151,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16151,34.22,0.45,69.8,3767,NULL,NULL,'K','NGC 0504',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16152,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16152,35.06,0.69,103,3768,100,NULL,'mid-IR','UGC 00934',NULL,'2013ApJ...771...88L',2013,1,1.7,NULL,'G',0.000033,NULL,'15',0.6,'S?',NULL,NULL,NULL,NULL,1,20.8680417,30.78447,0.181,NULL,67751589194,1058618581,16540915,15),(16153,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16153,35.9,0.4,152,3768,NULL,NULL,'mean','UGC 00934',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16154,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16154,36,0.47,158,3768,NULL,NULL,'H','UGC 00934',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16155,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',16155,35.21,0.33,110,3769,70,NULL,NULL,'2MASX J01232928-0031570',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000096,NULL,'15.4g',0.49,'E0',NULL,NULL,NULL,NULL,1,20.872,-0.53256,0.121,NULL,34497882367,539029411,8422334,15.4),(16156,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16156,35.73,0.53,140,3769,70,NULL,NULL,'2MASX J01232928-0031570',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16157,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16157,34.36,0.45,74.3,3770,NULL,NULL,NULL,'ESO 151- G 043',NULL,'2009ApJS..182..474S',2009,1,1.08,NULL,'G',0.000033,NULL,'14.34',0.53,'SAB(rs)c',NULL,NULL,NULL,NULL,1,20.874917,-56.68742,0,NULL,36197560242,565586878,8837294,14.34),(16158,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16158,34.4,0.2,75.9,3770,74.4,NULL,NULL,'ESO 151- G 043',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16159,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16159,34.65,0.4,85,3770,NULL,NULL,'Malmquist cor.','ESO 151- G 043',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16160,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',16160,37.86,0.21,374,3771,70,NULL,NULL,'SDSS J012332.38-095153.3',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000087,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,20.8849583,-9.86481,0.144,NULL,35276795388,551199927,8612498,18),(16161,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',16161,37.86,0.21,374,3772,70,NULL,NULL,'2MASX J01233665-0951453',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000081,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,20.9027916667,-9.86264,0.144,NULL,35276792634,551199884,8612498,17.8),(16162,'IRAS','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16162,34.89,0.8,95,3773,75,NULL,'W91PP, r','UGC 00940',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000033,NULL,'15.1',0.7,'SA(s)c','Group non-member, background',NULL,NULL,NULL,1,20.907917,34.56917,0.153,NULL,67759352662,1058739885,16542810,15.1),(16163,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16163,34.85,0.66,93.3,3773,NULL,NULL,'Malmquist cor.','UGC 00940',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16164,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16164,35.12,0.38,106,3773,75,NULL,'W91PP, r, raw','UGC 00940',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16165,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16165,35.25,0.38,112,3773,75,NULL,'W91PP, r, inv','UGC 00940',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16166,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16166,35.36,0.38,118,3773,75,NULL,'W91PP, r, cor','UGC 00940',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16167,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16167,35.37,0.2,119,3773,74.4,NULL,NULL,'UGC 00940',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16168,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16168,35.37,0.52,119,3773,NULL,NULL,NULL,'UGC 00940',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16169,'D-Sigma','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16169,33.92,0.4,60.8,3774,75,NULL,'Edat, raw','NGC 0507',NULL,'1997ApJS..109..333W',1997,1,3.1,NULL,'G',0.000023,NULL,'12.2',3.1,'SA(r)0^0^;BrClG','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,20.9162917,33.25606,0.165,NULL,67752130200,1058627034,16541047,12.2),(16170,'D-Sigma','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16170,34.33,0.4,73.6,3774,75,NULL,'Edat, cor','NGC 0507',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16171,'Faber-Jackson','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16171,33.01,0.6,40,3774,95,NULL,'de Vaucouleurs','NGC 0507',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16172,'Faber-Jackson','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16172,33.17,0.31,43.1,3774,95,NULL,'Weighted Mean','NGC 0507',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16173,'Faber-Jackson','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16173,33.46,0.46,49.2,3774,95,NULL,'Michard 1979a','NGC 0507',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16174,'Faber-Jackson','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16174,34.42,0.63,76.6,3774,95,NULL,'Michard 1979b, c','NGC 0507',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16175,'Faber-Jackson','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16175,34.63,0.81,84.3,3774,55,NULL,'Visvanathan & Sandage 1979','NGC 0507',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16176,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16176,34.05,0.23,64.6,3774,74.4,NULL,NULL,'NGC 0507',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16177,'Tertiary','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16177,33.35,0.5,46.8,3774,95,NULL,NULL,'NGC 0507',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16178,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16178,33.79,NULL,57.3,3774,71,NULL,'NGC 0507, 99 galaxies','NGC 0507',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16179,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16179,33.86,0.3,59.1,3774,NULL,NULL,'NGC 0507, 7 galaxies','NGC 0507',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16180,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16180,33.98,0.18,62.5,3774,70,NULL,'NGC 0507 GROUP NED01','NGC 0507',NULL,'1992ApJ...396..453H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16181,'Faber-Jackson','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16181,34.19,0.33,68.9,3775,95,NULL,'Weighted Mean','NGC 0508',NULL,'1984ApJS...56...91D',1984,1,1.3,'Geller et al. (2006AJ....132.2243G) give v = 249 km/sec.','G',0.00004,NULL,'14.08',1.3,'E0:','Group member',NULL,NULL,NULL,1,20.919167,33.28028,0.165,NULL,67752130462,1058627038,16541047,14.08),(16182,'Faber-Jackson','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16182,34.33,0.49,73.5,3775,95,NULL,'de Vaucouleurs','NGC 0508',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16183,'Faber-Jackson','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16183,34.56,0.63,81.7,3775,95,NULL,'Michard 1979b, c','NGC 0508',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16184,'Faber-Jackson','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16184,34.67,0.46,85.9,3775,95,NULL,'Michard 1979a','NGC 0508',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16185,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16185,34.58,0.25,82.4,3775,74.4,NULL,NULL,'NGC 0508',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16186,'Tertiary','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16186,33.35,0.5,46.8,3775,95,NULL,NULL,'NGC 0508',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16187,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16187,34.41,0.4,76.3,3775,NULL,NULL,'mean','NGC 0508',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16188,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16188,34.96,0.45,98.4,3775,NULL,NULL,'K','NGC 0508',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16189,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16189,33.68,0.25,54.5,3776,74.4,NULL,NULL,'CGCG 385-098',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000057,NULL,'16.0b',0.5,'S0','Group member',NULL,NULL,NULL,1,20.919667,-1.83003,0.17,NULL,35233970087,550530782,8602043,16),(16190,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16190,35.67,0.5,136,3776,70,NULL,NULL,'CGCG 385-098',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16191,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',16191,37.86,0.21,374,3777,70,NULL,NULL,'2MASX J01234497-0950503',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000075,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,20.937333,-9.84736,0.162,NULL,35278689043,551229516,8612961,18.3),(16192,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 2006hi',NULL,16192,40.57,0.22,1300,3778,70,NULL,'Hubble residual 0.61 for z0.26200','SDSS-II SN 13956 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,20.9414583,0.81628,0.065,NULL,66643095729,1041298370,16270287,NULL),(16193,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 13956','R',16193,41.11,0.33,1320,3778,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006hi','SDSS-II SN 13956 HOST',0.262,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16194,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 13956','R',16194,41.27,0.26,1420,3778,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006hi','SDSS-II SN 13956 HOST',0.262,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16195,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 2006hi',NULL,16195,42.05,0.2,2570,3778,70,NULL,'SALT 2','SDSS-II SN 13956 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16196,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 2006hi',NULL,16196,42.13,0.2,2670,3778,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13956 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16197,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',16197,36.91,0.46,240,3779,70,NULL,NULL,'2MASX J01234680-1008297',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000113,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,20.945,-10.14178,0.139,NULL,35276736835,551199013,8612484,16.8),(16198,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',16198,38.06,0.46,409,3780,70,NULL,NULL,'2MASX J01234756+0015544',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.79',0.23,NULL,NULL,NULL,NULL,NULL,1,20.9482917,0.26506,0.041,NULL,66642573488,1041290210,16270159,17.79),(16199,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16199,36.25,0.68,177,3781,70,NULL,NULL,'2MASX J01234900-1542350',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.40',0.19,NULL,NULL,NULL,NULL,NULL,1,20.9540417,-15.70989,0,NULL,35410276387,553285568,8645087,16.4),(16200,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16200,35.73,0.62,140,3782,70,NULL,NULL,'2MASX J01234921-1648310',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'16.32',0.29,NULL,NULL,NULL,NULL,NULL,1,20.955,-16.80853,0,NULL,35189594940,549837420,8591209,16.32),(16201,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',16201,38.27,0.46,450,3783,70,NULL,NULL,'2MASX J01235017-1031487',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000086,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,20.959083,-10.53022,0.143,NULL,35275409320,551178270,8612160,17.9),(16202,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',16202,38.12,0.46,421,3784,70,NULL,NULL,'2MASX J01235032-1014337',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000096,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,20.959667,-10.24267,0.139,NULL,35276743448,551199116,8612486,17.7),(16203,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',16203,37.83,0.33,368,3785,70,NULL,NULL,'SDSS J012350.82+001601.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000078,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,20.96175,0.26717,0.045,NULL,66642573950,1041290217,16270159,18.3),(16204,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16204,34.84,0.59,92.8,3786,70,NULL,NULL,'ESO 413- G 002',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000147,NULL,'14.76',0.6,'(R)SB(r)0^+',NULL,NULL,NULL,NULL,1,20.9632916667,-27.78839,0.084,NULL,34706233430,542284897,8473201,14.76),(16205,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',16205,38.32,0.46,461,3787,70,NULL,NULL,'SDSS J012352.24+002753.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,20.967667,0.46494,0.041,NULL,66642744703,1041292885,16270201,18.4),(16206,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',16206,37.83,0.33,368,3788,70,NULL,NULL,'2MASX J01235229+0018564',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000081,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,20.9679583333,0.31556,0.045,NULL,66642559520,1041289992,16270156,17.5),(16207,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 17863','RN',16207,41.6,0.2,1460,3789,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17863',0.432356,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16208,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SN 2007jz',NULL,16208,39.85,0.1,932,3790,70,NULL,'Hubble residual 0.12 for z0.23230','SDSS-II SN 17875 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,20.9837083,1.25508,0.029,NULL,66642989112,1041296704,16270261,NULL),(16209,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 17875','R',16209,40.35,0.22,971,3790,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007jz','SDSS-II SN 17875 HOST',0.212,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16210,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:47','1','SDSS-II SN 17875','R',16210,40.54,0.15,1060,3790,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007jz','SDSS-II SN 17875 HOST',0.212,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16211,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',16211,37.86,0.21,374,3791,70,NULL,NULL,'2MASX J01235703-0941077',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000108,NULL,'17.1g',0.3,'AGN',NULL,NULL,NULL,NULL,1,20.987667,-9.6855,0.162,NULL,35279209558,551237649,8613088,17.1),(16212,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16212,32.81,NULL,36.5,3792,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0159',NULL,'2010Ap&SS.325..163P',2010,1,0.99,NULL,'G',0.000008,NULL,'16.1',0.11,'Scd',NULL,NULL,NULL,NULL,1,20.987917,28.63306,0.217,NULL,67247758226,1050746222,16417909,16.1),(16213,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16213,32.83,NULL,36.9,3792,NULL,NULL,'Dipole + Quadrupole','FGC 0159',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16214,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16214,32.87,NULL,37.5,3792,NULL,NULL,'Dipole','FGC 0159',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16215,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16215,32.92,NULL,38.3,3792,NULL,NULL,NULL,'FGC 0159',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16216,'FP','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16216,36.49,0.7,198,3793,70,NULL,NULL,'MCG -02-04-036',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.000088,NULL,'16.1g',0.36,'S0/a',NULL,NULL,NULL,NULL,1,20.99575,-9.56497,0.134,NULL,35278363418,551224428,8612881,16.1),(16217,'IRAS','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16217,33.93,0.8,61.1,3794,75,NULL,'W91PP, r','NGC 0512',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'14.11',0.4,'Sab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,20.999167,33.90778,0.193,NULL,67759670266,1058744847,16542888,14.11),(16218,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16218,34.06,NULL,64.9,3794,NULL,NULL,'B','NGC 0512',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16219,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16219,34.13,0.4,67.1,3794,NULL,NULL,'mean','NGC 0512',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16220,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16220,34.18,0.47,68.5,3794,NULL,NULL,'H','NGC 0512',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16221,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16221,34.21,0.46,69.6,3794,NULL,NULL,'J','NGC 0512',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16222,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16222,34.25,0.45,70.8,3794,NULL,NULL,'K','NGC 0512',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16223,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16223,34.32,NULL,73.1,3794,NULL,NULL,'I','NGC 0512',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16224,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,'R',16224,34.36,0.49,74.5,3794,75,NULL,'IR','NGC 0512',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16225,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16225,34.39,0.07,75.7,3794,NULL,NULL,NULL,'NGC 0512',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16226,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16226,34.41,0.38,76.1,3794,75,NULL,'W91PP, r, raw','NGC 0512',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16227,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16227,34.52,0.38,80.3,3794,75,NULL,'W91PP, r, cor','NGC 0512',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16228,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:47','1',NULL,NULL,16228,34.67,0.38,86,3794,75,NULL,'W91PP, r, inv','NGC 0512',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16229,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16229,34.73,0.2,88.3,3794,74.4,NULL,NULL,'NGC 0512',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16230,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16230,34.77,0.43,89.9,3794,75,NULL,'3.6 micron, color corrected','NGC 0512',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16231,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16231,34.95,0.43,97.8,3794,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0512',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16232,'Sosies','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16232,32.68,0.6,34.4,3795,NULL,NULL,NULL,'NGC 0514',NULL,'2002A&A...393...57T',2002,1,3.5,NULL,'G',0.000005,NULL,'12.24',2.8,'SAB(rs)c',NULL,NULL,NULL,NULL,1,21.01625,12.91739,0.073,NULL,67609972763,1056405824,16506341,12.24),(16233,'Tully est','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16233,32.55,0.8,32.4,3795,75,NULL,'B','NGC 0514',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16234,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16234,31.9,0.4,24,3795,NULL,NULL,NULL,'NGC 0514',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16235,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16235,31.9,0.4,24,3795,73,NULL,'opt','NGC 0514',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16236,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16236,32.04,0.43,25.6,3795,75,NULL,'3.6 micron, color corrected','NGC 0514',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16237,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16237,32.05,0.2,25.7,3795,74.4,NULL,NULL,'NGC 0514',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16238,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16238,32.1,0.43,26.3,3795,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0514',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16239,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16239,32.17,0.39,27.2,3795,73,NULL,'opt','NGC 0514',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16240,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16240,32.25,0.5,28.1,3795,NULL,NULL,NULL,'NGC 0514',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16241,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16241,32.25,0.5,28.2,3795,NULL,NULL,'Malmquist cor.','NGC 0514',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16242,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16242,37.47,0.57,312,3796,70,NULL,NULL,'2MASX J01240432-0315356',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.000133,NULL,'16.71',0.34,NULL,NULL,NULL,NULL,NULL,1,21.018125,-3.25997,0.11,NULL,35247572227,550743316,8605364,16.71),(16243,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,'R',16243,37.86,0.21,374,3797,70,NULL,NULL,'2MASX J01240704-0943187',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000109,NULL,'16.8g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,21.029375,-9.72197,0.162,NULL,35278696014,551229625,8612962,16.8),(16244,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16244,34.06,0.52,65,3798,70,NULL,NULL,'ARK 040',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00009,NULL,'15.1b',0.2,'S0-a','Group member',NULL,NULL,NULL,1,21.031417,-1.86017,0.17,NULL,35233975615,550530868,8602044,15.1),(16245,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,'R',16245,37.84,0.46,370,3799,70,NULL,NULL,'2MASX J01240805-0951387',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000061,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,21.033667,-9.86067,0.162,NULL,35278747477,551230429,8612975,17.8),(16246,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16246,32.69,0.43,34.5,3800,75,NULL,'3.6 micron, color + selection bias corrected','IC 0101',NULL,'2014MNRAS.444..527S',2014,1,1.4,NULL,'G',0.000003,NULL,'14.74',0.6,'S?','X-ray-bright group member',NULL,NULL,NULL,1,21.035625,9.93053,0.129,NULL,67541510671,1055336104,16489626,14.74),(16247,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16247,32.74,0.43,35.4,3800,75,NULL,'3.6 micron, color corrected','IC 0101',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16248,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16248,32.88,0.2,37.7,3800,74.4,NULL,NULL,'IC 0101',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16249,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16249,33.2,0.48,43.7,3800,NULL,NULL,'Malmquist cor.','IC 0101',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16250,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16250,33.27,0.47,45.1,3800,NULL,NULL,NULL,'IC 0101',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16251,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SDSS-II SN 09052',NULL,16251,39.2,0.75,692,3801,70,NULL,'SN photometric redshift distance, z photo =0.177 +/- 0.085','SDSS-II SN 09052',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,21.041125,-0.48308,0.117,NULL,34497788387,539027943,8422311,NULL),(16252,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,'R',16252,37.99,0.27,396,3802,70,NULL,NULL,'SDSS J012410.34-002923.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,21.043083,-0.48972,0.117,NULL,34497789424,539027959,8422311,18.3),(16253,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SDSS-II SN 20273',NULL,16253,37.81,0.81,364,3803,70,NULL,'SN photometric redshift distance, z photo =0.089 +/- 0.043','SDSS-II SN 20273',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','21.6g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,21.054,-0.02317,0.049,NULL,34495529609,538992650,8421760,21.6),(16254,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SDSS-II SN 20273','R',16254,42.01,0.32,1710,3803,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20273',0.469041,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16255,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SDSS-II SN 20273',NULL,16255,41.77,0.23,2260,3803,70,NULL,'SALT 2','SDSS-II SN 20273',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16256,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SDSS-II SN 20273',NULL,16256,41.88,0.23,2380,3803,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20273',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16257,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16257,34.4,0.47,75.9,3804,NULL,NULL,'H','ESO 352- G 069',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000027,NULL,'14.15',1.2,'SB(s)ab? pec   HII',NULL,NULL,NULL,NULL,1,21.058625,-34.72631,NULL,NULL,38282155239,598158675,9346229,14.15),(16258,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16258,34.53,0.45,80.4,3804,NULL,NULL,'K','ESO 352- G 069',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16259,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16259,34.6,0.46,83,3804,NULL,NULL,'J','ESO 352- G 069',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16260,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16260,34.61,0.4,83.5,3804,NULL,NULL,'mean','ESO 352- G 069',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16261,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SDSS-II SN 03594','RN',16261,43.49,0.24,3130,3805,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03594',0.593956,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16262,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16262,35.64,0.38,134,3806,NULL,NULL,'Malmquist cor.','ESO 296- G 019',NULL,'2009ApJS..182..474S',2009,1,0.99,NULL,'G',0.000033,NULL,'14.36',0.58,'SA(rs)c        HII',NULL,NULL,NULL,NULL,1,21.0707083333,-37.3355,NULL,NULL,38346135527,599158367,9361849,14.36),(16263,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16263,35.89,0.34,151,3806,NULL,NULL,NULL,'ESO 296- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16264,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16264,35.93,0.2,153,3806,74.4,NULL,NULL,'ESO 296- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16265,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,'R',16265,37.16,0.46,270,3807,70,NULL,NULL,'2MASX J01241724+0044278',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,21.0718333333,0.74108,0.045,NULL,66643037621,1041297462,16270272,16.9),(16266,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16266,34.26,0.48,71,3808,70,NULL,NULL,'CGCG 385-102',NULL,'2014MNRAS.445.2677S',2014,1,0.7,'MCG lists this as \'N 519?\'. NED adopts CGCG choice N 519=CGCG 0121.9-0154.','G',0.000093,NULL,'15.00',0.3,'Sa','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,21.081125,-1.74628,0.17,NULL,35233777355,550527771,8601996,15),(16267,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SDSS-II SN 00904',NULL,16267,40.13,0.17,1060,3809,70,NULL,'SN photometric redshift distance, z photo =0.288 +/- 0.029','SDSS-II SN 00904',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','22.1g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,21.0947083,-0.12519,0.049,NULL,34497636068,539025563,8422274,22.1),(16268,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SDSS-II SN 00904','R',16268,42.06,0.42,1870,3809,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 00904',0.385316,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16269,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SDSS-II SN 00904','R',16269,42.51,0.26,2300,3809,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 00904',0.385316,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16270,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16270,34.55,0.4,81.4,3810,NULL,NULL,'mean','NGC 0513',NULL,'2007A&A...465...71T',2007,1,0.7,NULL,'G',0.000033,NULL,'13.9',0.3,'Sb/c           Sy2','Group member',NULL,NULL,'Sy 1 h',1,21.111875,33.79944,0.193,NULL,67759600869,1058743763,16542871,13.9),(16271,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16271,34.67,0.47,85.7,3810,NULL,NULL,'H','NGC 0513',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16272,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16272,34.69,0.46,86.8,3810,NULL,NULL,'J','NGC 0513',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16273,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16273,34.69,0.45,86.8,3810,NULL,NULL,'K','NGC 0513',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16274,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SDSS-II SN 04248','RN',16274,40.03,0.24,864,3811,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 04248',0.171418,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16275,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SDSS-II SN 04248','RN',16275,40.7,0.25,1180,3811,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 04248',0.171418,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16276,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SN 2006nj',NULL,16276,40.99,0.19,1570,3812,70,NULL,'Hubble residual 0.32 for z0.39000','SDSS-II SN 16000 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,21.1174583,0.07431,0.049,NULL,66639639675,1041244369,16269443,NULL),(16277,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SDSS-II SN 16000','R',16277,42.01,0.29,1810,3812,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006nj','SDSS-II SN 16000 HOST',0.39,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16278,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SDSS-II SN 16000','R',16278,42.07,0.22,1860,3812,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006nj','SDSS-II SN 16000 HOST',0.39,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16279,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16279,34.46,0.53,77.9,3813,70,NULL,NULL,'NGC 0519',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000107,NULL,'15.28',0.3,'E+?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,21.119333,-1.64125,0.176,NULL,35233781758,550527839,8601997,15.28),(16280,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16280,34.22,0.6,69.9,3814,NULL,NULL,'Malmquist cor.','UGC 00955',NULL,'2009ApJS..182..474S',2009,1,1.27,NULL,'G',0.000005,NULL,'15.62',0.16,'Sc',NULL,NULL,NULL,NULL,1,21.124917,15.76744,0.113,NULL,67420422403,1053444100,16460064,15.62),(16281,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16281,34.37,0.2,74.8,3814,74.4,NULL,NULL,'UGC 00955',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16282,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,'R',16282,34.45,0.49,77.5,3814,75,NULL,'IR','UGC 00955',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16283,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16283,34.46,NULL,77.9,3814,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00955',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16284,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16284,34.47,NULL,78.4,3814,NULL,NULL,'Dipole + Quadrupole','UGC 00955',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16285,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16285,34.48,NULL,78.6,3814,NULL,NULL,'Dipole','UGC 00955',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16286,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16286,34.51,0.53,79.7,3814,NULL,NULL,NULL,'UGC 00955',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16287,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16287,34.56,NULL,81.7,3814,NULL,NULL,NULL,'UGC 00955',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16288,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16288,34.4,0.48,75.9,3815,70,NULL,NULL,'MCG -03-04-061',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.00007,NULL,'14.28',1.6,'(R)SAB(r)0/a   HII',NULL,NULL,NULL,NULL,1,21.1282916667,-15.53783,0.005,NULL,35409549549,553274211,8644909,14.28),(16289,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SDSS-II SN 03916','RN',16289,43.25,0.29,3050,3816,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03916',0.464913,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16290,'Ring Diameter','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16290,32.8,0.84,36,3817,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 0521',NULL,'1981ApJS...45..541P',1981,1,3.2,NULL,'G',0.000013,NULL,'12.55',2.9,'SB(r)bc','in a radial-velocity based grouping',NULL,NULL,NULL,1,21.14075,1.73139,0.077,NULL,67513905568,1054904774,16482887,12.55),(16291,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16291,32.53,NULL,32.1,3818,NULL,NULL,NULL,'UGC 00958',NULL,'2000BSAO...50....5K',2000,1,1.83,NULL,'G',0.000011,NULL,'15.20',0.24,'SBcd:',NULL,NULL,NULL,NULL,1,21.142625,16.53692,0.133,NULL,67420947815,1053452309,16460192,15.2),(16292,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16292,32.58,0.2,32.8,3818,74.4,NULL,NULL,'UGC 00958',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16293,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16293,32.59,NULL,32.9,3818,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00958',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16294,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16294,32.6,NULL,33.2,3818,NULL,NULL,'Dipole + Quadrupole','UGC 00958',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16295,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16295,32.61,NULL,33.2,3818,NULL,NULL,'Dipole','UGC 00958',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16296,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16296,32.68,0.43,34.3,3818,75,NULL,'3.6 micron, color corrected','UGC 00958',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16297,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16297,32.74,0.43,35.3,3818,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00958',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16298,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16298,32.82,0.56,36.7,3818,NULL,NULL,NULL,'UGC 00958',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16299,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16299,32.92,0.53,38.4,3818,NULL,NULL,'Malmquist cor.','UGC 00958',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16300,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16300,34.8,0.54,91.3,3819,NULL,NULL,'Malmquist cor.','ESO 352- G 071',NULL,'2009ApJS..182..474S',2009,1,1.24,NULL,'G',0.000033,NULL,'14.2b',0.46,'SB(s)bc?',NULL,NULL,NULL,NULL,1,21.1437917,-33.17353,NULL,NULL,38279928527,598123883,9345685,14.2),(16301,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16301,35.12,0.46,106,3819,NULL,NULL,NULL,'ESO 352- G 071',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16302,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16302,35.15,0.47,107,3819,NULL,NULL,'H','ESO 352- G 071',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16303,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16303,35.16,0.2,108,3819,74.4,NULL,NULL,'ESO 352- G 071',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16304,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16304,35.25,0.45,112,3819,NULL,NULL,'K','ESO 352- G 071',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16305,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16305,35.29,0.46,114,3819,NULL,NULL,'J','ESO 352- G 071',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16306,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16306,35.45,0.4,123,3819,NULL,NULL,'mean','ESO 352- G 071',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16307,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16307,36.02,0.25,160,3820,74.4,NULL,NULL,'GIN 082',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.00016,NULL,'15.6V',0.4,'S',NULL,NULL,NULL,NULL,1,21.144917,8.57631,0.109,NULL,67538879040,1055294985,16488984,15.6),(16308,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16308,36.19,0.25,173,3820,70,NULL,NULL,'GIN 082',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16309,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16309,31.59,NULL,20.8,3821,75,NULL,'CO','NGC 0520',NULL,'1994A&A...283...21S',1994,1,NULL,'Diameter includes companions or long extensions.','GPair',0.00001,NULL,NULL,NULL,'Pec;HII        Sbrst','in a radial-velocity based grouping',NULL,NULL,NULL,1,21.146125,3.79242,0.045,NULL,67528235038,1055128672,16486385,NULL),(16310,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16310,32.15,NULL,26.9,3821,75,NULL,'HI','NGC 0520',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16311,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16311,32.22,0.4,27.8,3821,75,NULL,'B','NGC 0520',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16312,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16312,32.63,NULL,33.6,3821,54,NULL,'HI','NGC 0520',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16313,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16313,33.11,NULL,41.9,3821,65.2,NULL,'CO','NGC 0520',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16314,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16314,32.76,0.39,35.7,3822,73,NULL,'IR','UGC 00964',NULL,'2011A&A...532A.104N',2011,1,1.3,NULL,'G',0.000003,NULL,'15.23',0.3,'Sb',NULL,NULL,NULL,NULL,1,21.1460833333,7.72117,0.109,NULL,67572110833,1055814231,16497097,15.23),(16315,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,'R',16315,32.77,0.4,35.7,3822,75,NULL,NULL,'UGC 00964',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16316,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16316,32.83,0.4,36.8,3822,73,NULL,'opt','UGC 00964',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16317,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16317,32.89,0.4,37.8,3822,NULL,NULL,NULL,'UGC 00964',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16318,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16318,33.03,0.43,40.3,3822,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00964',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16319,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16319,33.28,0.43,45.4,3822,75,NULL,'3.6 micron, color corrected','UGC 00964',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16320,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,'R',16320,33.59,0.49,52.3,3822,75,NULL,'IR','UGC 00964',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16321,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16321,33.82,0.2,58.1,3822,74.4,NULL,NULL,'UGC 00964',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16322,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16322,34.38,0.37,75.3,3822,NULL,NULL,'Malmquist cor.','UGC 00964',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16323,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16323,34.62,0.33,83.9,3822,NULL,NULL,NULL,'UGC 00964',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16324,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,'R',16324,37.99,0.27,396,3823,70,NULL,NULL,'2MASX J01243549-0024154',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000075,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,21.1478333333,-0.40425,0.117,NULL,34494319824,538973747,8421464,17.1),(16325,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16325,33.8,0.4,57.6,3824,70,NULL,NULL,'IC 0103',NULL,'2001MNRAS.321..277C',2001,1,0.9,NULL,'G',0.000025,NULL,'15.00',0.5,'S0-:','Group member',NULL,NULL,NULL,1,21.1518333333,2.04425,0.077,NULL,67514005875,1054906341,16482911,15),(16326,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16326,35.3,0.23,115,3824,74.4,NULL,NULL,'IC 0103',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16327,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,'R',16327,35.86,0.46,148,3825,70,NULL,NULL,'2MASX J01243736-0946015',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000076,NULL,'16.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,21.1557917,-9.767,0.162,NULL,35278729883,551230154,8612971,16.3),(16328,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16328,36,0.73,159,3825,70,NULL,NULL,'2MASX J01243736-0946015',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16329,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16329,36.04,0.25,161,3826,74.4,NULL,NULL,'CGCG 411-049',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000083,NULL,'14.5V',0.8,'E/S0',NULL,NULL,NULL,NULL,1,21.16075,8.50989,0.133,NULL,67571435852,1055803685,16496932,14.5),(16330,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16330,36.19,0.25,173,3826,70,NULL,NULL,'CGCG 411-049',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16331,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16331,34.16,0.4,68,3827,NULL,NULL,'mean','NGC 0515',NULL,'2007A&A...465...71T',2007,1,1.4,'1999ApJS..121..287H has V = 4152 +- 27 km/sec.','G',0.000067,NULL,'14.02',1.1,'S0','in a pair',NULL,NULL,NULL,1,21.160833,33.47278,0.177,NULL,67752038589,1058625602,16541025,14.02),(16332,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16332,34.75,0.45,89.2,3827,NULL,NULL,'K','NGC 0515',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16333,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16333,36.02,0.25,160,3828,74.4,NULL,NULL,'GIN 080',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000093,NULL,'14.61',0.4,'E/S0',NULL,NULL,NULL,NULL,1,21.1705833333,8.60875,0.109,NULL,67539012795,1055297074,16489016,14.61),(16334,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16334,36.19,0.25,173,3828,70,NULL,NULL,'GIN 080',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16335,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16335,35.99,0.52,158,3829,70,NULL,NULL,'2MASX J01244090-2134079',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.4I',0.4,NULL,NULL,NULL,NULL,NULL,1,21.1704583,-21.56889,0,NULL,35220980855,550327825,8598872,13.4),(16336,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16336,36.04,0.25,161,3830,74.4,NULL,NULL,'UGC 00967',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.00011,NULL,'15.4V',1.1,'Sc',NULL,NULL,NULL,NULL,1,21.18175,8.77639,0.109,NULL,67538997748,1055296839,16489013,15.4),(16337,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16337,36.19,0.25,173,3830,70,NULL,NULL,'UGC 00967',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16338,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16338,33.98,0.25,62.5,3831,74.4,NULL,NULL,'NGC 0517',NULL,'2013AJ....146...86T',2013,1,2,NULL,'G',0.00006,NULL,'13.42',1,'S0','in a pair',NULL,NULL,NULL,1,21.1825,33.42944,0.177,NULL,67752038670,1058625604,16541025,13.42),(16339,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16339,33.74,0.45,56,3831,NULL,NULL,'K','NGC 0517',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16340,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16340,33.87,0.4,59.3,3831,NULL,NULL,'mean','NGC 0517',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16341,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16341,35.34,0.25,117,3832,74.4,NULL,NULL,'2MASX J01244391+0122022',NULL,'2013AJ....146...86T',2013,1,0.55,NULL,'G',0.000019,NULL,'16.64',0.36,NULL,NULL,NULL,NULL,NULL,1,21.1830417,1.36739,0.021,NULL,66639365930,1041240092,16269376,16.64),(16342,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SDSS-II SN 08755','RN',16342,41.04,0.22,1260,3833,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 08755',0.282827,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16343,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SDSS-II SN 08755','RN',16343,41.78,0.26,1770,3833,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 08755',0.282827,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16344,'BL Lac Luminosity','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16344,41.4,NULL,1530,3834,NULL,NULL,NULL,'MS 0122.1+0903',0.339,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.003,NULL,'19.98',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,21.185417,9.31361,0.129,NULL,67541077606,1055329337,16489520,19.98),(16345,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16345,34.51,0.47,79.9,3835,70,NULL,NULL,'NGC 0534',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000017,NULL,'14.46',1,'SB(s)0^0       LLAGN','Group member, 2nd ranked galaxy',NULL,NULL,NULL,1,21.1859583,-38.12908,NULL,NULL,38348333641,599192713,9362386,14.46),(16346,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16346,34.55,0.4,81.1,3835,NULL,NULL,'mean','NGC 0534',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16347,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16347,34.76,0.45,89.5,3835,NULL,NULL,'K','NGC 0534',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16348,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16348,35.93,0.4,153,3836,NULL,NULL,'mean','UGC 00959',NULL,'2007A&A...465...71T',2007,1,0.7,NULL,'G',0.000067,NULL,'14.41',0.5,'Sa:            Sy1','in a triple',NULL,NULL,'AGN',1,21.187625,32.16572,0.177,NULL,67754372412,1058662068,16541594,14.41),(16349,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16349,35.96,0.45,156,3836,NULL,NULL,'K','UGC 00959',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16350,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16350,35.97,0.47,156,3836,NULL,NULL,'H','UGC 00959',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16351,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16351,36.13,0.46,168,3836,NULL,NULL,'J','UGC 00959',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16352,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16352,32.32,0.39,29.1,3837,73,NULL,'opt','NGC 0522',NULL,'2011A&A...532A.104N',2011,1,2.63,NULL,'G',0.000011,NULL,'13.94',0.35,'Sc','X-ray-bright group member',NULL,NULL,NULL,1,21.1910417,9.99464,0.137,NULL,67541650457,1055338288,16489660,13.94),(16353,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16353,32.41,0.4,30.3,3837,73,NULL,'IR','NGC 0522',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16354,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16354,32.41,0.4,30.3,3837,73,NULL,'opt','NGC 0522',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16355,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16355,32.61,0.4,33.3,3837,73,NULL,'opt','NGC 0522',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16356,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,'R',16356,32.68,0.49,34.4,3837,75,NULL,'IR','NGC 0522',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16357,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16357,32.7,0.43,34.6,3837,NULL,NULL,'Malmquist cor.','NGC 0522',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16358,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16358,32.7,0.2,34.7,3837,74.4,NULL,NULL,'NGC 0522',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16359,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16359,32.75,0.42,35.4,3837,NULL,NULL,NULL,'NGC 0522',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16360,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16360,32.9,0.43,38,3837,75,NULL,'3.6 micron, color corrected','NGC 0522',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16361,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16361,33.01,0.43,39.9,3837,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0522',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16362,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,'R',16362,33.09,0.4,41.5,3837,75,NULL,NULL,'NGC 0522',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16363,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16363,33.55,NULL,51.3,3837,NULL,NULL,NULL,'NGC 0522',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16364,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16364,33.56,NULL,51.4,3837,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 0522',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16365,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16365,33.57,NULL,51.9,3837,NULL,NULL,'Dipole + Quadrupole','NGC 0522',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16366,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16366,33.58,NULL,52.1,3837,NULL,NULL,'Dipole','NGC 0522',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16367,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SDSS-II SN 02718','RN',16367,40.99,0.25,1230,3838,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 02718',0.288883,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16368,'SNIa SDSS','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SDSS-II SN 02718','RN',16368,41.29,0.33,1400,3838,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 02718',0.288883,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16369,'GCLF','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16369,31.51,0.12,20,3839,NULL,NULL,'blue GCs, TOM(V) = -7.17 mag','NGC 0524',NULL,'2001AJ....121.2974L',2001,1,2.8,NULL,'G',0.000017,NULL,'11.3',2.8,'SA(rs)0+','X-ray-bright group member',NULL,NULL,NULL,1,21.198833,9.53883,0.129,NULL,67541781903,1055340342,16489692,11.3),(16370,'GCLF','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16370,32.14,0.09,26.8,3839,NULL,NULL,'all GCs, TOM(V) = -7.63 mag','NGC 0524',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16371,'GCLF','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16371,32.23,0.14,27.9,3839,NULL,NULL,'red GCs, TOM(V) = -7.55 mag','NGC 0524',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16372,'PNLF','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16372,31.6,NULL,20.9,3839,NULL,NULL,NULL,'NGC 0524',NULL,'2007ApJ...657...76F',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16373,'PNLF','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,'R',16373,31.8,NULL,22.9,3839,NULL,NULL,NULL,'NGC 0524',NULL,'2004AAS...205.6906J',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16374,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SN 2008Q','R',16374,28.02,0.1,4.02,3839,NULL,NULL,'MLCS2k2, R(V) = 1.8','NGC 0524',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16375,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SN 2008Q','R',16375,28.04,0.08,4.06,3839,NULL,NULL,'MLCS2k2, R(V) = 3.1','NGC 0524',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16376,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SN 2000cx',NULL,16376,32.37,0.19,29.6,3839,72,NULL,NULL,'NGC 0524',0.00793,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16377,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SN 2000cx',NULL,16377,32.4,0.12,30.2,3839,70.8,NULL,NULL,'NGC 0524',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16378,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SN 2000cx',NULL,16378,32.51,NULL,31.8,3839,NULL,NULL,'H','NGC 0524',NULL,'2003PASP..115..277C',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16379,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SN 2000cx',NULL,16379,32.53,0.05,32.1,3839,NULL,NULL,'MLCS','NGC 0524',NULL,'2001PASP..113.1178L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16380,'SBF','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16380,31.74,0.2,22.3,3839,NULL,NULL,'I','NGC 0524',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16381,'SBF','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16381,31.9,0.14,24,3839,74.4,NULL,NULL,'NGC 0524',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16382,'SBF','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16382,31.9,0.2,24,3839,NULL,NULL,'I','NGC 0524',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16383,'SBF','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16383,31.9,0.2,24,3839,NULL,NULL,'I','NGC 0524',NULL,'2001ApJ...559..584A',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16384,'Faber-Jackson','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16384,31.74,0.37,22.3,3839,95,NULL,'Weighted Mean','NGC 0524',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16385,'Faber-Jackson','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16385,31.8,0.46,22.9,3839,95,NULL,'Michard 1979a','NGC 0524',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16386,'Faber-Jackson','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,'R',16386,31.86,NULL,23.6,3839,NULL,NULL,'LEDA [April 2006]','NGC 0524',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16387,'Faber-Jackson','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16387,31.97,0.69,24.8,3839,95,NULL,'de Vaucouleurs','NGC 0524',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16388,'Faber-Jackson','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16388,32.14,0.63,26.8,3839,95,NULL,'Michard 1979b, c','NGC 0524',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16389,'Tertiary','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16389,31.83,0.25,23.2,3839,95,NULL,NULL,'NGC 0524',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16390,'Tully est','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16390,32.53,0.8,32.1,3839,75,NULL,'B','NGC 0524',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16391,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16391,32.32,0.45,29.1,3839,NULL,NULL,'K','NGC 0524',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16392,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16392,32.65,0.4,33.8,3839,NULL,NULL,'mean','NGC 0524',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16393,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16393,33.6,0.25,52.5,3840,74.4,NULL,NULL,'IC 1694',NULL,'2013AJ....146...86T',2013,1,0.82,NULL,'G',0.000073,NULL,'13.59',0.61,'S',NULL,NULL,NULL,NULL,1,21.199167,1.60717,0.021,NULL,67514933316,1054920833,16483138,13.59),(16394,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16394,33.8,0.4,57.6,3840,70,NULL,NULL,'IC 1694',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16395,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,'R',16395,37.99,0.27,396,3841,70,NULL,NULL,'2MASXi J0124478-002843',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000098,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,21.1992916667,-0.47864,0.147,NULL,34494339941,538974061,8421469,18.2),(16396,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16396,33.85,NULL,59,3842,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 00971',NULL,'2010Ap&SS.325..163P',2010,1,1.14,NULL,'G',0.000027,NULL,'18.3g',0.11,'Sd(f)',NULL,NULL,NULL,NULL,1,21.2024583,1.03683,0.029,NULL,66639597152,1041243705,16269432,18.3),(16397,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16397,33.86,NULL,59,3842,NULL,NULL,'Dipole + Quadrupole','UGC 00971',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16398,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16398,33.86,NULL,59.2,3842,NULL,NULL,'Dipole','UGC 00971',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16399,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16399,35.27,0.91,113,3843,NULL,NULL,'Malmquist cor.','KUG 0122+319',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.00003,NULL,'15.13',0.4,'Sb','in a triple',NULL,NULL,NULL,1,21.206667,32.23444,0.177,NULL,67754365959,1058661968,16541593,15.13),(16400,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16400,35.71,0.74,139,3843,NULL,NULL,NULL,'KUG 0122+319',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16401,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16401,36.03,0.2,161,3843,74.4,NULL,NULL,'KUG 0122+319',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16402,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16402,34.25,0.13,70.9,3844,NULL,NULL,NULL,'CGCG 385-112',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.00015,NULL,'15.6b',0.2,'S0:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,21.2127083,-1.6915,0.176,NULL,35235849842,550560153,8602502,15.6),(16403,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,'R',16403,38.95,0.46,617,3845,70,NULL,NULL,'2MASX J01245232-0934123',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000087,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,21.2180416667,-9.57014,0.127,NULL,35279259956,551238436,8613100,17.8),(16404,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16404,34.14,0.23,67.3,3846,74.4,NULL,NULL,'IC 1696',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000037,NULL,'14.63',0.8,'E+','Group member',NULL,NULL,NULL,1,21.218167,-1.61706,0.176,NULL,35235881135,550560642,8602510,14.63),(16405,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16405,34.43,0.52,76.8,3846,70,NULL,NULL,'IC 1696',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16406,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16406,35.85,0.4,148,3847,NULL,NULL,'mean','MCG -02-04-044',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000067,NULL,'14.85',0.5,'Sc',NULL,NULL,NULL,NULL,1,21.22,-11.58925,0.075,NULL,35279372921,551240201,8613128,14.85),(16407,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16407,35.85,0.47,148,3847,NULL,NULL,'H','MCG -02-04-044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16408,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16408,35.97,0.45,156,3847,NULL,NULL,'K','MCG -02-04-044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16409,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16409,36,0.46,159,3847,NULL,NULL,'J','MCG -02-04-044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16410,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,'R',16410,37.62,0.46,334,3848,70,NULL,NULL,'2MASX J01245520+1319463',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000075,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,21.230083,13.32975,0.089,NULL,67609535115,1056398986,16506234,17.7),(16411,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SDSS-II SN 18907','R',16411,39.57,0.18,676,3849,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18907',0.216528,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,'PHOT','20.3g',0.07,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,21.233625,0.51619,0.037,NULL,66639811983,1041247062,16269485,20.3),(16412,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SDSS-II SN 18907','R',16412,39.78,0.23,743,3849,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18907',0.216528,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16413,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SDSS-II SN 18907',NULL,16413,40.1,0.2,1050,3849,70,NULL,'SN photometric redshift distance, z photo =0.283 +/- 0.032','SDSS-II SN 18907',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16414,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16414,35.52,0.25,127,3850,74.4,NULL,NULL,'MCG +00-04-123',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000042,NULL,'15',0.6,NULL,NULL,NULL,NULL,NULL,1,21.245333,1.55672,0.021,NULL,67514936115,1054920876,16483138,15),(16415,'BCG','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16415,36.77,0.35,216,3851,60,NULL,NULL,'ABELL 0193',0.0478,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',0.00029,NULL,NULL,NULL,'II     [BM]',NULL,NULL,NULL,NULL,1,21.265833,8.68806,0.133,NULL,67539040616,1055297509,16489023,NULL),(16416,'SNII optical','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SN 1992am',NULL,16416,35.68,0.14,137,3852,NULL,NULL,'SCM','MCG -01-04-039',NULL,'2015ApJ...799..215P',2015,1,0.5,NULL,'G',0.000107,NULL,'15.63',0.5,'S',NULL,NULL,NULL,NULL,1,21.2679583333,-4.64978,0.172,NULL,35245215870,550706497,8604789,15.63),(16417,'SNII optical','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SN 1992am',NULL,16417,36.27,0.11,163,3852,NULL,NULL,'SEAM','MCG -01-04-039',0.047733,'2009ApJ...694.1067P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16418,'SNII optical','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SN 1992am',NULL,16418,36.28,0.4,180,3852,NULL,NULL,NULL,'MCG -01-04-039',NULL,'1994AJ....107.1444S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16419,'SNII optical','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SN 1992am',NULL,16419,36.28,0.4,180,3852,NULL,NULL,NULL,'MCG -01-04-039',NULL,'1994ApJ...432...42S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16420,'SNII optical','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SN 1992am','R',16420,36.28,0.33,180,3852,NULL,NULL,'EPM','MCG -01-04-039',NULL,'1993PhDT........95S',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16421,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SDSS-II SN 16618','R',16421,39.69,0.19,726,3853,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006pq','SN 2006pq',0.193145,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,21.279375,-1.21894,0.168,NULL,34494542108,538977220,8421519,NULL),(16422,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SDSS-II SN 16618','R',16422,40.06,0.15,863,3853,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006pq','SN 2006pq',0.193145,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16423,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16423,34.48,0.33,78.5,3854,NULL,NULL,'Malmquist cor.','NGC 0549',NULL,'2009ApJS..182..474S',2009,1,0.58,NULL,'G',0.00017,NULL,'15.43',0.57,'(R\')SB(s)0/a:',NULL,NULL,NULL,NULL,1,21.2795,-38.00775,NULL,NULL,38348121996,599189406,9362334,15.43),(16424,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16424,34.54,0.32,80.9,3854,NULL,NULL,NULL,'NGC 0549',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16425,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,'R',16425,36.96,0.33,246,3855,70,NULL,NULL,'2MASX J01250725-0853203',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000071,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,21.280417,-8.889,0.119,NULL,35271062879,551110357,8611099,17),(16426,'BCG','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16426,36.77,0.35,216,3856,60,NULL,'ABELL 0193, BCG','IC 1695',0.0478,'1980ApJ...241..486H',1980,1,1.1,NULL,'G',0.00011,NULL,'13.2V',1.1,'cD;S?','Brightest group member',NULL,NULL,NULL,1,21.2817917,8.6995,0.133,NULL,67539042057,1055297532,16489023,13.2),(16427,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16427,36.03,0.25,161,3856,74.4,NULL,NULL,'IC 1695',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16428,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16428,36.19,0.25,173,3856,70,NULL,NULL,'IC 1695',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16429,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16429,36.03,0.25,161,3857,74.4,NULL,NULL,'GIN 079',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000083,NULL,'15.5V',0.5,'E',NULL,NULL,NULL,NULL,1,21.2997917,8.65575,0.133,NULL,67539033230,1055297394,16489021,15.5),(16430,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16430,36.19,0.25,173,3857,70,NULL,NULL,'GIN 079',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16431,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,'R',16431,36.96,0.33,246,3858,70,NULL,NULL,'2MASX J01251238-0855243',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.00009,NULL,'16.3g',0.37,'AGN',NULL,NULL,NULL,NULL,1,21.3015416667,-8.92333,0.119,NULL,35271063976,551110374,8611099,16.3),(16432,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16432,34.73,0.62,88.3,3859,70,NULL,NULL,'ESO 352- G 072',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000033,NULL,'15.1b',0.25,'Sb:',NULL,NULL,NULL,NULL,1,21.302833,-35.81636,NULL,NULL,38276270274,598066723,9344792,15.1),(16433,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,'R',16433,35.21,0.49,110,3859,75,NULL,'IR','ESO 352- G 072',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16434,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16434,35.27,0.58,113,3859,NULL,NULL,'Malmquist cor.','ESO 352- G 072',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16435,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16435,35.43,0.54,122,3859,NULL,NULL,NULL,'ESO 352- G 072',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16436,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16436,35.47,0.2,124,3859,74.4,NULL,NULL,'ESO 352- G 072',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16437,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16437,35.77,0.47,143,3859,NULL,NULL,'H','ESO 352- G 072',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16438,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16438,35.82,0.4,146,3859,NULL,NULL,'mean','ESO 352- G 072',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16439,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16439,35.9,0.45,151,3859,NULL,NULL,'K','ESO 352- G 072',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16440,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,'R',16440,38.14,0.46,425,3860,70,NULL,NULL,'2MASX J01251273-0921573',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000089,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,21.30325,-9.36583,0.106,NULL,35279276769,551238699,8613104,17.4),(16441,'IRAS','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16441,34.64,0.8,84.5,3861,75,NULL,'MAT, I','NGC 0546',NULL,'1997ApJS..109..333W',1997,1,1.42,NULL,'G',0.000033,NULL,'14.52',0.4,'Sc pec         HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,21.303375,-38.06908,NULL,NULL,38348091264,599188926,9362326,14.52),(16442,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16442,34.49,0.43,79,3861,75,NULL,'MAT, I, raw','NGC 0546',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16443,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16443,34.5,0.34,79.4,3861,NULL,NULL,'Malmquist cor.','NGC 0546',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16444,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16444,34.51,0.32,79.8,3861,85,NULL,'I, raw','NGC 0546',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16445,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16445,34.52,0.34,80,3861,NULL,NULL,NULL,'NGC 0546',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16446,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16446,34.56,0.2,81.7,3861,74.4,NULL,NULL,'NGC 0546',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16447,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16447,34.57,0.32,81.9,3861,85,NULL,'I, inv','NGC 0546',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16448,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16448,34.73,0.43,88.3,3861,75,NULL,'MAT, I, inv','NGC 0546',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16449,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16449,34.74,0.43,88.8,3861,75,NULL,'MAT, I, cor','NGC 0546',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16450,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16450,34.78,0.47,90.5,3861,NULL,NULL,'H','NGC 0546',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16451,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16451,34.83,0.4,92.3,3861,NULL,NULL,'mean','NGC 0546',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16452,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16452,34.91,0.45,95.8,3861,NULL,NULL,'K','NGC 0546',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16453,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16453,34.95,0.46,97.7,3861,NULL,NULL,'J','NGC 0546',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16454,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,'R',16454,38.77,0.46,568,3862,70,NULL,NULL,'2MASX J01251278-1041573',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000092,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,21.303333,-10.69939,0.091,NULL,35280124986,551251952,8613311,17.8),(16455,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16455,33.8,0.4,57.6,3863,70,NULL,NULL,'IC 0109',NULL,'2001MNRAS.321..277C',2001,1,1.1,NULL,'G',0.000083,NULL,'14.50',0.9,'SB0','Group member',NULL,NULL,NULL,1,21.3045417,2.06622,0.069,NULL,67515070752,1054922980,16483171,14.5),(16456,'IRAS','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16456,33.95,0.8,61.8,3864,75,NULL,'W91PP, r','UGC 00975',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'15.0',0.8,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,21.315417,34.35917,0.189,NULL,67759916479,1058748694,16542948,15),(16457,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16457,33.72,0.2,55.5,3864,74.4,NULL,NULL,'UGC 00975',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16458,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16458,34.08,0.1,65.6,3864,NULL,NULL,NULL,'UGC 00975',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16459,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16459,34.4,0.38,76,3864,75,NULL,'W91PP, r, raw','UGC 00975',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16460,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16460,34.47,0.38,78.3,3864,75,NULL,'W91PP, r, inv','UGC 00975',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16461,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16461,34.52,0.38,80.2,3864,75,NULL,'W91PP, r, cor','UGC 00975',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16462,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16462,36.42,0.58,193,3865,70,NULL,NULL,'MCG -02-04-046',NULL,'2014MNRAS.445.2677S',2014,1,0.4,'Huchra, et al. (1993AJ....105.1637H) give v = 5481 +/- 39 km/sec.','G',0.000093,NULL,'15.4',0.4,NULL,NULL,NULL,NULL,NULL,1,21.3174583333,-11.91394,0.067,NULL,35267807553,551059493,8610304,15.4),(16463,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16463,32.36,0.45,29.7,3866,NULL,NULL,NULL,'NGC 0532',NULL,'2009ApJS..182..474S',2009,1,2.5,NULL,'G',0.000003,NULL,'13.95',0.8,'Sab? sp','X-ray-bright group member',NULL,NULL,NULL,1,21.32225,9.26411,0.129,NULL,67541829506,1055341086,16489704,13.95),(16464,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16464,32.38,0.45,29.9,3866,NULL,NULL,'Malmquist cor.','NGC 0532',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16465,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,'R',16465,32.41,0.4,30.3,3866,75,NULL,NULL,'NGC 0532',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16466,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16466,32.44,0.4,30.8,3866,NULL,NULL,'mean','NGC 0532',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16467,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,'R',16467,32.49,0.49,31.5,3866,75,NULL,'IR','NGC 0532',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16468,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16468,32.51,0.2,31.8,3866,74.4,NULL,NULL,'NGC 0532',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16469,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16469,32.51,0.47,31.8,3866,NULL,NULL,'H','NGC 0532',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16470,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16470,32.56,0.45,32.4,3866,NULL,NULL,'K','NGC 0532',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16471,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16471,32.57,0.46,32.7,3866,NULL,NULL,'J','NGC 0532',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16472,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16472,32.67,0.43,34.3,3866,75,NULL,'3.6 micron, color corrected','NGC 0532',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16473,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16473,32.74,0.43,35.4,3866,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0532',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16474,'D-Sigma','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16474,33.94,0.4,61.4,3867,75,NULL,'Edat, raw','UGC 00984',NULL,'1997ApJS..109..333W',1997,1,1.2,'UZC has V = 5262 +- 28 km/sec.','G',0.000093,NULL,'14.62',0.4,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,21.324375,-1.51744,0.176,NULL,35235878530,550560602,8602509,14.62),(16475,'D-Sigma','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16475,33.97,0.4,62.2,3867,75,NULL,'Edat, cor','UGC 00984',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16476,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16476,35.81,0.5,145,3868,70,NULL,NULL,'2MASX J01251821-0752060',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.10',0.34,NULL,NULL,NULL,NULL,NULL,1,21.3259166667,-7.86842,0.11,NULL,35289779282,551402801,8615668,16.1),(16477,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SN 2001en',NULL,16477,33.3,0.21,45,3869,74.2,NULL,'SALT 2','NGC 0523',0.015871,'2010ApJ...716..712A',2010,1,2.5,NULL,'G',0.000013,NULL,'12.3B',0.7,'Pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,21.336375,34.02494,0.177,NULL,67759973107,1058749579,16542962,12.3),(16478,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SN 2001en',NULL,16478,33.87,0.09,59.4,3869,74.4,NULL,NULL,'NGC 0523',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16479,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SN 2001en',NULL,16479,33.94,0.04,60.4,3869,72,NULL,'SALT2','NGC 0523',0.015871,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16480,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SN 2001en',NULL,16480,34.03,0.17,64,3869,70.8,NULL,NULL,'NGC 0523',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16481,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SN 2001en',NULL,16481,34.09,0.2,64.7,3869,70,NULL,'SALT 2','NGC 0523',0.015871,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16482,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SN 2001en',NULL,16482,34.18,0.25,67.4,3869,65,NULL,'SALT2','NGC 0523',0.015871,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16483,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SN 2001en',NULL,16483,34.24,0.22,69.3,3869,65,NULL,'MLCS17','NGC 0523',0.015871,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16484,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SN 2001en',NULL,16484,34.25,0.23,69.7,3869,65,NULL,'MLCS31','NGC 0523',0.015871,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16485,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SN 2001en',NULL,16485,34.6,0.08,81.7,3869,70,NULL,'SALT 2','NGC 0523',0.015871,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16486,'Sosies','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16486,33.7,0.11,55,3869,NULL,NULL,NULL,'NGC 0523',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16487,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16487,33.87,0.46,59.5,3869,NULL,NULL,'J','NGC 0523',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16488,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16488,33.88,0.47,59.7,3869,NULL,NULL,'H','NGC 0523',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16489,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16489,33.91,0.45,60.6,3869,NULL,NULL,'K','NGC 0523',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16490,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16490,34.09,0.4,65.8,3869,NULL,NULL,'mean','NGC 0523',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16491,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SDSS-II SN 16547','RN',16491,40.58,0.55,959,3870,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16547',0.361097,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16492,'SNIa','2016-12-15 15:13:45','2016-12-16 11:18:48','1','SDSS-II SN 16547','RN',16492,40.79,0.34,1060,3870,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16547',0.361097,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16493,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,'R',16493,37.92,0.46,384,3871,70,NULL,NULL,'2MASX J01252213+1358568',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000074,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,21.3422917,13.98244,0.101,NULL,67610854684,1056419604,16506556,17.6),(16494,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16494,33.51,0.25,50.4,3872,74.4,NULL,NULL,'2MASX J01252369-0111411',NULL,'2013AJ....146...86T',2013,1,0.48,NULL,'G',0.000064,NULL,'15.9g',0.4,'E','Group member',NULL,NULL,NULL,1,21.348625,-1.19478,0.168,NULL,34494507335,538976677,8421510,15.9),(16495,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16495,35.85,0.2,148,3873,74.4,NULL,NULL,'UGC 00985',NULL,'2013AJ....146...86T',2013,1,1.41,NULL,'G',0.000073,NULL,'14.8g',0.42,'Sb',NULL,NULL,NULL,NULL,1,21.348667,14.52,0.109,NULL,67610964290,1056421317,16506583,14.8),(16496,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16496,33.9,0.45,60.1,3874,NULL,NULL,'K','IC 0107',NULL,'2007A&A...465...71T',2007,1,1.21,NULL,'G',0.000063,NULL,'13.7g',0.94,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,21.35275,14.86461,0.105,NULL,67610317720,1056411214,16506425,13.7),(16497,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16497,34.4,0.4,75.9,3874,NULL,NULL,'mean','IC 0107',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16498,'BCG','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16498,36.86,0.35,228,3875,60,NULL,NULL,'ABELL 0189',0.0349,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,21.352917,1.74111,0.057,NULL,67515153709,1054924276,16483191,NULL),(16499,'D-Sigma','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16499,33.94,0.4,61.4,3876,75,NULL,'Edat, raw','NGC 0538',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000093,NULL,'14.58',0.5,'SB(s)ab:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,21.3585417,-1.55064,0.155,NULL,35235887199,550560737,8602511,14.58),(16500,'D-Sigma','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16500,33.97,0.4,62.2,3876,75,NULL,'Edat, cor','NGC 0538',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16501,'IRAS','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16501,34.51,0.8,79.8,3877,75,NULL,'MAT, I','ESO 296- G 026',NULL,'1997ApJS..109..333W',1997,1,2,'APMUKS position is 21 arcsec SW of nucleus.  Misident. as NGC 0549 in SGC.','G',0.000033,NULL,'14.79',0.5,'Sab            HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,21.368667,-38.26739,NULL,NULL,38348367753,599193246,9362394,14.79),(16502,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16502,34.51,0.43,79.7,3877,75,NULL,'MAT, I, raw','ESO 296- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16503,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16503,34.58,0.2,82.4,3877,74.4,NULL,NULL,'ESO 296- G 026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16504,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16504,34.76,0.32,89.4,3877,85,NULL,'I, raw','ESO 296- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16505,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16505,34.77,0.43,89.7,3877,75,NULL,'MAT, I, cor','ESO 296- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16506,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,'R',16506,34.79,0.49,90.6,3877,75,NULL,'IR','ESO 296- G 026',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16507,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16507,34.84,0.32,93.1,3877,85,NULL,'I, inv','ESO 296- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16508,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16508,34.86,0.43,93.7,3877,75,NULL,'MAT, I, inv','ESO 296- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16509,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16509,33.04,0.2,40.6,3878,74.4,NULL,NULL,'UGC 00989',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000003,NULL,'16.0',0.8,'SAB(s)m',NULL,NULL,NULL,NULL,1,21.373333,7.56139,0.105,NULL,67571951505,1055811742,16497058,16),(16510,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,'R',16510,37.59,0.27,330,3879,70,NULL,NULL,'2MASX J01253004+0037095',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000082,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,21.3752083,0.61919,0.049,NULL,66639952838,1041249263,16269519,17.7),(16511,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16511,34.18,0.45,68.5,3880,NULL,NULL,'K','NGC 0535',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000057,NULL,'14.83',0.3,'S0+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,21.3797917,-1.40814,0.155,NULL,35232473868,550507404,8601678,14.83),(16512,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16512,34.23,0.4,70,3880,NULL,NULL,'mean','NGC 0535',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16513,'D-Sigma','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16513,33.94,0.4,61.4,3881,75,NULL,'Edat, raw','NGC 0533',NULL,'1997ApJS..109..333W',1997,1,3.8,NULL,'G',0.000028,NULL,'12.41',2.3,'cD;E3:','in a radial-velocity based grouping',NULL,NULL,NULL,1,21.380667,1.75911,0.057,NULL,67515150781,1054924230,16483191,12.41),(16514,'D-Sigma','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16514,33.97,0.4,62.2,3881,75,NULL,'Edat, cor','NGC 0533',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16515,'Faber-Jackson','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16515,33.12,0.48,42.1,3881,95,NULL,'de Vaucouleurs','NGC 0533',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16516,'Faber-Jackson','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16516,33.31,0.29,45.9,3881,95,NULL,'Weighted Mean','NGC 0533',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16517,'Faber-Jackson','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16517,33.99,0.46,62.8,3881,95,NULL,'Michard 1979a','NGC 0533',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16518,'Faber-Jackson','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16518,34.49,0.81,79.1,3881,55,NULL,'Visvanathan & Sandage 1979','NGC 0533',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16519,'Faber-Jackson','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16519,34.56,0.63,81.7,3881,95,NULL,'Michard 1979b, c','NGC 0533',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16520,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16520,33.61,0.25,52.7,3881,74.4,NULL,NULL,'NGC 0533',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16521,'FP','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16521,33.8,0.4,57.6,3881,70,NULL,NULL,'NGC 0533',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16522,'Tertiary','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16522,33.69,0.5,54.7,3881,95,NULL,NULL,'NGC 0533',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16523,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16523,34.07,0.45,65.3,3881,NULL,NULL,'K','NGC 0533',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16524,'Tully-Fisher','2016-12-15 15:13:45','2016-12-16 11:18:48','1',NULL,NULL,16524,34.33,0.4,73.5,3881,NULL,NULL,'mean','NGC 0533',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16525,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16525,33.8,0.8,57.4,3882,75,NULL,'W91PP, r','UGC 00987',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.00002,NULL,'14.39',0.7,'SAB0/a         Sy2','in a pair',NULL,NULL,'Sy 1.5',1,21.3810833333,32.1365,0.133,NULL,67754495753,1058663996,16541624,14.39),(16526,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16526,33.8,0.8,57.5,3882,75,NULL,'HMCL, I','UGC 00987',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16527,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16527,33.8,0.8,57.6,3882,75,NULL,'HMCL, I','UGC 00987',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16528,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16528,33.82,0.8,58.1,3882,75,NULL,'W91CL, r','UGC 00987',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16529,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16529,33.85,0.8,58.9,3882,75,NULL,'CF, r','UGC 00987',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16530,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16530,33.55,0.38,51.2,3882,75,NULL,'CF, r, raw','UGC 00987',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16531,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16531,33.6,0.38,52.6,3882,75,NULL,'W91PP, r, raw','UGC 00987',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16532,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16532,33.68,0.38,54.4,3882,75,NULL,'CF, r, inv','UGC 00987',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16533,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16533,33.74,0.47,55.9,3882,NULL,NULL,'H','UGC 00987',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16534,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16534,33.74,0.43,56,3882,75,NULL,'3.6 micron, color corrected','UGC 00987',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16535,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16535,33.75,0.2,56.2,3882,74.4,NULL,NULL,'UGC 00987',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16536,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16536,33.75,0.45,56.3,3882,NULL,NULL,'K','UGC 00987',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16537,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16537,33.76,0.38,56.4,3882,75,NULL,'W91PP, r, inv','UGC 00987',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16538,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16538,33.77,0.4,56.8,3882,75,NULL,'HMCL, I, raw','UGC 00987',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16539,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16539,33.79,0.38,57.4,3882,75,NULL,'W91CL, r, raw','UGC 00987',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16540,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16540,33.81,0.43,57.9,3882,75,NULL,'3.6 micron, color + selection bias corrected','UGC 00987',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16541,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16541,33.82,0.46,58.2,3882,NULL,NULL,'J','UGC 00987',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16542,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16542,33.87,0.4,59.4,3882,75,NULL,'HMCL, I, raw','UGC 00987',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16543,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16543,33.87,0.38,59.4,3882,75,NULL,'CF, r, cor','UGC 00987',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16544,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16544,33.9,0.38,60.4,3882,75,NULL,'W91PP, r, cor','UGC 00987',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16545,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16545,33.95,0.38,61.5,3882,75,NULL,'W91CL, r, inv','UGC 00987',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16546,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16546,33.96,0.4,62.1,3882,75,NULL,'HMCL, I, inv','UGC 00987',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16547,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16547,34.02,0.38,63.6,3882,75,NULL,'W91CL, r, cor','UGC 00987',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16548,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16548,34.03,0.4,63.9,3882,75,NULL,'HMCL, I, cor','UGC 00987',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16549,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16549,34.05,0.4,64.6,3882,NULL,NULL,'mean','UGC 00987',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16550,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16550,34.06,0.4,65,3882,75,NULL,'HMCL, I, inv','UGC 00987',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16551,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16551,34.09,0.4,65.9,3882,75,NULL,'HMCL, I, cor','UGC 00987',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16552,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16552,34.27,0.07,71.6,3882,NULL,NULL,NULL,'UGC 00987',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16553,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16553,33.94,0.4,61.4,3883,75,NULL,'Edat, raw','UGC 00996',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000057,NULL,'14.92',0.2,'S0/a','Group member',NULL,NULL,NULL,1,21.3834583333,-1.50261,0.155,NULL,35235862235,550560347,8602505,14.92),(16554,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16554,33.97,0.4,62.2,3883,75,NULL,'Edat, cor','UGC 00996',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16555,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16555,33.6,0.23,52.5,3883,74.4,NULL,NULL,'UGC 00996',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16556,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16556,34.37,0.53,74.8,3884,70,NULL,NULL,'LCRS B012317.7-383237',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.000011,NULL,'15.35',0.47,'S0',NULL,NULL,NULL,NULL,1,21.3849166667,-38.28375,NULL,NULL,38348366999,599193234,9362394,15.35),(16557,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16557,34.11,0.07,66.5,3885,NULL,NULL,NULL,'CGCG 385-122',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000023,NULL,'15.7',0.2,'S0:','Group member',NULL,NULL,NULL,1,21.38825,-1.81172,0.163,NULL,35236057759,550563402,8602553,15.7),(16558,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16558,34.3,0.23,72.4,3886,74.4,NULL,NULL,'NGC 0528',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.000093,NULL,'13.51',1.1,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,21.39,33.67167,0.177,NULL,67759848544,1058747633,16542931,13.51),(16559,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16559,34.16,0.4,68,3886,NULL,NULL,'mean','NGC 0528',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16560,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16560,34.36,0.45,74.4,3886,NULL,NULL,'K','NGC 0528',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16561,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16561,36.82,0.54,232,3887,70,NULL,NULL,'MCG -01-04-041',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15',0.4,NULL,NULL,NULL,NULL,NULL,1,21.4024583,-7.74003,0.097,NULL,35289122947,551392546,8615508,15),(16562,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16562,37.59,0.77,329,3888,70,NULL,NULL,'2MASX J01253788-1250592',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.75',0.34,NULL,NULL,NULL,NULL,NULL,1,21.407833,-12.84972,0.023,NULL,35401374637,553146478,8642913,16.75),(16563,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16563,37.59,0.27,330,3889,70,NULL,NULL,'2MASX J01254004+0032305',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000082,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,21.4167917,0.54192,0.049,NULL,66639939987,1041249062,16269516,17.2),(16564,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16564,33.6,0.23,52.5,3890,74.4,NULL,NULL,'NGC 0529',NULL,'2013AJ....146...86T',2013,1,2.4,NULL,'G',0.00006,NULL,'13.14',2.1,'E1','in a pair',NULL,NULL,NULL,1,21.418333,34.71333,0.153,NULL,67759395964,1058740561,16542821,13.14),(16565,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16565,34.16,0.45,67.9,3890,NULL,NULL,'K','NGC 0529',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16566,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16566,34.16,0.4,68,3890,NULL,NULL,'mean','NGC 0529',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16567,'BCG','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16567,34.63,0.35,82.9,3891,60,NULL,NULL,'ABELL 0194',0.0178,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II     [BM]',NULL,NULL,NULL,NULL,1,21.42,-1.40722,0.155,NULL,35232443806,550506934,8601670,NULL),(16568,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16568,34.37,0.12,74.9,3891,70,NULL,NULL,'ABELL 0194',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16569,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16569,38.21,0.46,439,3892,70,NULL,NULL,'2MASX J01254303+1511048',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000079,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,21.429333,15.18467,0.117,NULL,67601739166,1056277174,16504330,18),(16570,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16570,33.93,0.17,61,3893,NULL,NULL,'ABELL 0194, 25 galaxies','NGC 0541',NULL,'2000ApJ...529..768K',2000,1,1.8,'NVSS position is about 12 arcsec northwest of the nucleus.','G',0.000019,NULL,'13.03',1.7,'cD;S0-:','in a radial-velocity based grouping',NULL,'radio jet',NULL,1,21.434625,-1.37958,0.155,NULL,35232442489,550506913,8601670,13.03),(16571,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16571,33.94,0.4,61.4,3893,75,NULL,'Edat, raw','NGC 0541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16572,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16572,33.97,0.4,62.2,3893,75,NULL,'Edat, cor','NGC 0541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16573,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16573,34.04,0.2,64.4,3893,70,NULL,'ABELL 0194, 25 galaxies','NGC 0541',NULL,'1988MNRAS.235.1177L',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16574,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16574,34.17,0.16,68.3,3893,70,NULL,'ABELL 0194, 25 galaxies','NGC 0541',NULL,'1988MNRAS.235.1177L',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16575,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16575,34.24,0.11,70.5,3893,72,NULL,'ABELL 0194, 15 galaxies','NGC 0541',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16576,'Faber-Jackson','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16576,32.06,0.61,25.8,3893,95,NULL,'de Vaucouleurs','NGC 0541',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16577,'Faber-Jackson','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16577,33.33,0.36,46.3,3893,95,NULL,'Weighted Mean','NGC 0541',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16578,'Faber-Jackson','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16578,34.28,0.46,71.8,3893,95,NULL,'Michard 1979a','NGC 0541',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16579,'Faber-Jackson','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16579,34.96,0.63,98.2,3893,95,NULL,'Michard 1979b, c','NGC 0541',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16580,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16580,33.74,0.16,55.9,3893,NULL,NULL,'ABELL 0194, 25 galaxies','NGC 0541',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16581,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16581,33.83,0.09,58.4,3893,75,NULL,'ABELL 0194, 19 galaxies','NGC 0541',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16582,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16582,33.83,0.09,58.4,3893,75,NULL,'ABELL 0194 Cluster, 19 galaxies','NGC 0541',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16583,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16583,33.85,0.18,59,3893,NULL,NULL,'ABELL 0194, 25 galaxies','NGC 0541',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16584,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16584,34.11,0.23,66.4,3893,74.4,NULL,NULL,'NGC 0541',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16585,'Tertiary','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16585,33.69,0.5,54.7,3893,95,NULL,NULL,'NGC 0541',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16586,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16586,34.22,0.45,70,3893,NULL,NULL,'K','NGC 0541',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16587,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16587,34.32,0.4,73.2,3893,NULL,NULL,'mean','NGC 0541',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16588,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16588,33.94,0.4,61.4,3894,75,NULL,'Edat, raw','UGC 01003',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000057,NULL,'14.88',0.3,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,21.434417,-1.45669,0.155,NULL,35235863430,550560366,8602505,14.88),(16589,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16589,33.97,0.4,62.2,3894,75,NULL,'Edat, cor','UGC 01003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16590,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16590,33.98,0.23,62.5,3894,74.4,NULL,NULL,'UGC 01003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16591,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16591,35.55,0.52,129,3895,70,NULL,NULL,'2MASX J01254707-0808166',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.000103,NULL,'17.17',0.34,NULL,NULL,NULL,NULL,NULL,1,21.44625,-8.13797,0.101,NULL,35289172046,551393313,8615520,17.17),(16592,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16592,33.94,0.4,61.4,3896,75,NULL,'Edat, raw','CGCG 385-127',NULL,'1997ApJS..109..333W',1997,1,0.4,NULL,'G',0.00007,NULL,'15.2',0.25,'E3:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,21.44875,-1.34461,0.155,NULL,35232467161,550507299,8601676,15.2),(16593,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16593,33.97,0.4,62.2,3896,75,NULL,'Edat, cor','CGCG 385-127',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16594,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16594,34.03,0.25,64,3896,74.4,NULL,NULL,'CGCG 385-127',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16595,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16595,33.9,0.25,60.3,3897,74.4,NULL,NULL,'2MASX J01254810-0129321',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000117,NULL,'15.8',0.3,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,21.4504583,-1.49231,0.155,NULL,35235871514,550560492,8602507,15.8),(16596,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16596,33.94,0.4,61.4,3898,75,NULL,'Edat, raw','NGC 0543',NULL,'1997ApJS..109..333W',1997,1,0.6,NULL,'G',0.000057,NULL,'14.1',0.3,'S0-: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,21.4582917,-1.29281,0.168,NULL,35232466249,550507285,8601676,14.1),(16597,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16597,33.97,0.4,62.2,3898,75,NULL,'Edat, cor','NGC 0543',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16598,'Faber-Jackson','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16598,33.94,0.44,61.4,3898,95,NULL,'Weighted Mean','NGC 0543',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16599,'Faber-Jackson','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16599,34.43,0.63,76.9,3898,95,NULL,'Michard 1979b, c','NGC 0543',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16600,'Faber-Jackson','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16600,34.52,0.46,80.2,3898,95,NULL,'Michard 1979a','NGC 0543',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16601,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16601,34.99,0.23,99.5,3898,74.4,NULL,NULL,'NGC 0543',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16602,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16602,37.59,0.27,330,3899,70,NULL,NULL,'2MASX J01255038+0031205',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000098,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,21.459917,0.52233,0.049,NULL,66639909863,1041248591,16269509,17),(16603,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16603,33.94,0.4,61.4,3900,75,NULL,'Edat, raw','ARK 045',NULL,'1997ApJS..109..333W',1997,1,0.4,'Geller et al. (2006AJ....132.2243G) give v = 5527 km/sec.','G',0.000047,NULL,'15.2',0.4,'S0/a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,21.464625,-1.31797,0.155,NULL,35232467723,550507308,8601676,15.2),(16604,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16604,33.97,0.4,62.2,3900,75,NULL,'Edat, cor','ARK 045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16605,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 04035','R',16605,42.11,0.25,1850,3901,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J012552.13+010252.2',0.4276,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',0.0005,NULL,'21.6g',0.02,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,21.46725,1.04783,0.021,NULL,66639581123,1041243455,16269428,21.6),(16606,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 04035','R',16606,42.45,0.21,2170,3901,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J012552.13+010252.2',0.4276,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16607,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 04035',NULL,16607,42.03,0.16,2550,3901,70,NULL,'SALT 2','SDSS J012552.13+010252.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16608,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 04035',NULL,16608,42.11,0.16,2640,3901,70,NULL,'SALT 2, Malmquist cor.','SDSS J012552.13+010252.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16609,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16609,33.94,0.4,61.4,3902,75,NULL,'Edat, raw','2MASX J01255244-0115594',NULL,'1997ApJS..109..333W',1997,1,0.5,NULL,'G',0.000117,NULL,'16.20',0.3,'E','Group member',NULL,NULL,NULL,1,21.4685417,-1.26658,0.168,NULL,35232459152,550507174,8601674,16.2),(16610,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16610,33.97,0.4,62.2,3902,75,NULL,'Edat, cor','2MASX J01255244-0115594',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16611,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16611,33.88,0.23,59.7,3902,74.4,NULL,NULL,'2MASX J01255244-0115594',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16612,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16612,36.16,0.69,171,3903,70,NULL,NULL,'2MASX J01255594-1128296',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,21.483125,-11.475,0.092,NULL,35279592275,551243629,8613181,14.7),(16613,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16613,33.83,0.4,58.3,3904,NULL,NULL,'mean','IC 1702',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000017,NULL,'14.19',1,'Scd:',NULL,NULL,NULL,NULL,1,21.4845417,16.60181,0.141,NULL,67422550007,1053477343,16460583,14.19),(16614,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16614,34.2,0.47,69.1,3904,NULL,NULL,'H','IC 1702',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16615,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16615,34.26,0.46,71.1,3904,NULL,NULL,'J','IC 1702',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16616,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16616,35.97,0.46,156,3905,70,NULL,NULL,'2MASX J01255676-0952206',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00008,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,21.4865,-9.87256,0.129,NULL,35278675955,551229311,8612957,16.9),(16617,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16617,32.01,0.43,25.2,3906,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-04-042',NULL,'2014MNRAS.444..527S',2014,1,1.9,NULL,'G',0.000007,NULL,'15.00',1,'SB(rs)dm',NULL,NULL,NULL,NULL,1,21.491125,-3.98194,0.151,NULL,35248510071,550757969,8605593,15),(16618,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16618,37.55,0.46,323,3907,70,NULL,NULL,'2MASX J01255861+0005149',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00008,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,21.4942083,0.08747,0.029,NULL,66639740417,1041245944,16269467,17.6),(16619,'BCG','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16619,34.63,0.35,82.9,3908,60,NULL,'ABELL 0194, BCG','NGC 0545',0.0178,'1980ApJ...241..486H',1980,1,2.4,'MCG incorrectly identifies this galaxy as \'N0547a\'.','G',0.000025,NULL,'13.21',1.6,'SA0-','Pair member (points to parent)',NULL,NULL,NULL,1,21.496333,-1.34022,0.155,NULL,35232439436,550506866,8601669,13.21),(16620,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16620,33.94,0.4,61.4,3908,75,NULL,'Edat, raw','NGC 0545',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16621,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16621,33.97,0.4,62.2,3908,75,NULL,'Edat, cor','NGC 0545',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16622,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16622,34.04,0.2,64.4,3908,70,NULL,'ABELL 0194, BCG','NGC 0545',0.0178,'1988MNRAS.235.1177L',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16623,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16623,34.17,0.16,68.3,3908,70,NULL,'ABELL 0194, BCG','NGC 0545',0.0178,'1988MNRAS.235.1177L',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16624,'Faber-Jackson','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16624,34.81,0.79,91.6,3908,95,NULL,'Weighted Mean','NGC 0545',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16625,'Faber-Jackson','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16625,34.81,0.79,91.6,3908,95,NULL,'de Vaucouleurs','NGC 0545',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16626,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16626,33.83,0.09,58.4,3908,75,NULL,'ABELL 0194 Cluster, 19 galaxies','NGC 0545',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16627,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16627,34.13,0.25,67,3908,74.4,NULL,NULL,'NGC 0545',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16628,'Tertiary','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16628,33.69,0.5,54.7,3908,95,NULL,NULL,'NGC 0545',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16629,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16629,34.37,0.12,74.9,3908,70,NULL,'ABELL 0194, BGC','NGC 0545',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16630,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16630,33.94,0.4,61.4,3909,75,NULL,'Edat, raw','NGC 0547',NULL,'1997ApJS..109..333W',1997,1,1.3,'MCG incorrectly identifies this galaxy as \'N0547b\'.','G',0.00002,NULL,'13.16',1.3,'E1;BrClG','Pair member (points to parent)',NULL,NULL,NULL,1,21.502625,-1.34517,0.155,NULL,35232439548,550506867,8601669,13.16),(16631,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16631,33.97,0.4,62.2,3909,75,NULL,'Edat, cor','NGC 0547',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16632,'Faber-Jackson','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16632,33.59,0.39,52.2,3909,95,NULL,'de Vaucouleurs','NGC 0547',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16633,'Faber-Jackson','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16633,33.72,0.29,55.5,3909,95,NULL,'Weighted Mean','NGC 0547',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16634,'Faber-Jackson','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16634,34.28,0.46,71.8,3909,95,NULL,'Michard 1979a','NGC 0547',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16635,'Faber-Jackson','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16635,34.64,0.63,84.7,3909,95,NULL,'Michard 1979b, c','NGC 0547',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16636,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16636,34.3,0.25,72.4,3909,74.4,NULL,NULL,'NGC 0547',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16637,'Tertiary','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16637,33.69,0.5,54.7,3909,95,NULL,NULL,'NGC 0547',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16638,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16638,33.24,0.45,44.4,3909,NULL,NULL,'K','NGC 0547',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16639,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16639,34.32,0.4,73.2,3909,NULL,NULL,'mean','NGC 0547',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16640,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16640,33.94,0.4,61.4,3910,75,NULL,'Edat, raw','NGC 0548',NULL,'1997ApJS..109..333W',1997,1,0.87,NULL,'G',0.000019,NULL,'14.7g',0.68,'E+:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,21.5104583,-1.22561,0.139,NULL,35232460525,550507195,8601674,14.7),(16641,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16641,33.97,0.4,62.2,3910,75,NULL,'Edat, cor','NGC 0548',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16642,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16642,34.64,0.23,84.7,3910,74.4,NULL,NULL,'NGC 0548',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16643,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16643,34.68,0.33,86.4,3910,70,NULL,NULL,'NGC 0548',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16644,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16644,34.32,0.4,73.2,3910,NULL,NULL,'mean','NGC 0548',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16645,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16645,35.03,0.45,102,3910,NULL,NULL,'K','NGC 0548',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16646,'Magnitude','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16646,36.84,0.13,233,3911,100,NULL,NULL,'ABELL 2911',NULL,'1998A&A...337...31R',1998,1,NULL,'Katgert (1996,A&A,310,8) identifies multiple redshift systems in this cluster.','GClstr',NULL,NULL,NULL,NULL,'I-II   [BM];R  [A]',NULL,NULL,NULL,NULL,1,21.519167,-37.97667,NULL,NULL,38348204705,599190698,9362354,NULL),(16647,'Magnitude','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16647,36.84,0.13,233,3912,100,NULL,NULL,'GALEXASC J012605.62-375753.0',NULL,'1998A&A...337...31R',1998,1,0.9,NULL,'G',0.000057,NULL,'15.73',0.38,'E',NULL,NULL,NULL,NULL,1,21.522625,-37.96467,NULL,NULL,38348205018,599190703,9362354,15.73),(16648,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16648,36.66,0.53,215,3913,70,NULL,NULL,'MCG -02-04-049',NULL,'2014MNRAS.445.2677S',2014,1,0.91,NULL,'G',0.000087,NULL,'15.42',0.48,NULL,NULL,NULL,NULL,NULL,1,21.5280833333,-13.42011,0,NULL,35401239062,553144360,8642880,15.42),(16649,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 2005gy',NULL,16649,40.33,0.15,875,3914,74.2,NULL,'SALT 2','SDSS J012606.76+004036.7',0.33,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,21.5281666667,0.67686,0.045,NULL,66640039431,1041250616,16269540,NULL),(16650,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 2005gy',NULL,16650,40.26,0.17,1130,3914,70,NULL,'Hubble residual -0.13 for z0.33240','SDSS J012606.76+004036.7',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16651,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 04679','R',16651,40.91,0.2,1140,3914,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005gy','SDSS J012606.76+004036.7',0.3324,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16652,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 2005gy',NULL,16652,41.05,0.18,1220,3914,65,NULL,'SALT2','SDSS J012606.76+004036.7',0.33,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16653,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 04679','R',16653,41.07,0.27,1230,3914,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005gy','SDSS J012606.76+004036.7',0.3324,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16654,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 2005gy',NULL,16654,41.08,0.19,1230,3914,70,NULL,'SDSS 4679, SALT 2','SDSS J012606.76+004036.7',0.33,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16655,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 2005gy',NULL,16655,41.25,0.17,1330,3914,65,NULL,'MLCS2k2','SDSS J012606.76+004036.7',0.33,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16656,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 2005gy',NULL,16656,41.45,0.24,1470,3914,72,NULL,'SDSS 4679','SDSS J012606.76+004036.7',0.33,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16657,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 04682','R',16657,41.42,0.32,1370,3915,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 04682',0.402323,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',NULL,'PHOT','22.0g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,21.5509583333,0.81086,0.049,NULL,66639538754,1041242793,16269418,22),(16658,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 04682','R',16658,41.42,0.3,1370,3915,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 04682',0.402323,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16659,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 04682',NULL,16659,40.78,0.23,1440,3915,70,NULL,'SN photometric redshift distance, z photo =0.417 +/- 0.062','SDSS-II SN 04682',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16660,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 04682',NULL,16660,41.25,0.22,1780,3915,70,NULL,'SALT 2','SDSS-II SN 04682',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16661,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 04682',NULL,16661,41.32,0.22,1840,3915,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 04682',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16662,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16662,37.92,0.46,383,3916,70,NULL,NULL,'2MASX J01261394-0859370',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000094,NULL,'16.9g',0.32,NULL,NULL,NULL,NULL,NULL,1,21.55825,-8.99353,0.105,NULL,35279143870,551236622,8613072,16.9),(16663,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 1998dm','R',16663,33.18,NULL,43.3,3917,62.3,NULL,NULL,'UGCA 017',NULL,'2008A&ARv..15..289T',2008,1,2.9,'HOLM 043B is a star.','G',0.000022,NULL,'12.1B',0.4,'SBc:           HII','X-ray-faint group member',NULL,NULL,NULL,1,21.560125,-6.09414,0.161,NULL,35288274435,551379288,8615301,12.1),(16664,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16664,31.95,0.8,24.6,3917,75,NULL,'MAT, I','UGCA 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16665,'Tully est','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16665,31.96,0.8,24.6,3917,75,NULL,NULL,'UGCA 017',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16666,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16666,31.47,0.4,19.7,3917,75,NULL,NULL,'UGCA 017',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16667,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16667,31.47,0.39,19.7,3917,73,NULL,'IR','UGCA 017',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16668,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16668,31.73,0.32,22.2,3917,85,NULL,'I, raw','UGCA 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16669,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16669,31.74,0.32,22.3,3917,85,NULL,'I, inv','UGCA 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16670,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16670,31.83,0.2,23.2,3917,74.4,NULL,NULL,'UGCA 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16671,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16671,31.85,0.43,23.4,3917,75,NULL,'MAT, I, raw','UGCA 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16672,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16672,31.87,0.4,23.7,3917,NULL,NULL,NULL,'UGCA 017',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16673,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16673,31.87,0.39,23.7,3917,73,NULL,'opt','UGCA 017',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16674,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16674,31.91,0.43,24.1,3917,75,NULL,'MAT, I, inv','UGCA 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16675,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16675,31.93,0.43,24.3,3917,75,NULL,'3.6 micron, color corrected','UGCA 017',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16676,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16676,31.96,0.59,24.6,3917,NULL,NULL,NULL,'UGCA 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16677,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16677,31.96,0.59,24.6,3917,NULL,NULL,'Malmquist cor.','UGCA 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16678,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16678,31.97,0.42,24.8,3917,NULL,18.48,'3.6 micron','UGCA 017',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16679,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16679,31.97,0.43,24.8,3917,75,NULL,'MAT, I, cor','UGCA 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16680,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16680,31.97,0.43,24.8,3917,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 017',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16681,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16681,31.98,0.49,24.9,3917,75,NULL,'IR','UGCA 017',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16682,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16682,32.29,0.4,28.6,3917,NULL,NULL,'mean','UGCA 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16683,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16683,32.5,0.46,31.6,3917,NULL,NULL,'J','UGCA 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16684,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16684,32.58,0.47,32.8,3917,NULL,NULL,'H','UGCA 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16685,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16685,32.72,0.45,35,3917,NULL,NULL,'K','UGCA 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16686,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16686,38.59,0.46,523,3918,70,NULL,NULL,'SDSS J012615.58+004417.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000091,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,21.564917,0.73817,0.045,NULL,66639542472,1041242851,16269419,18.1),(16687,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16687,37.62,0.82,335,3919,70,NULL,NULL,'2MASX J01261582-4537284',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'15.29',0.58,'S',NULL,NULL,NULL,NULL,1,21.5659583,-45.62453,NULL,NULL,38365373969,599458968,9366546,15.29),(16688,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16688,36.18,0.46,172,3920,70,NULL,NULL,'2MASX J01261746+0049530',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000078,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,21.572667,0.83136,0.045,NULL,66639545413,1041242897,16269420,16.7),(16689,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16689,34.32,0.08,73.3,3921,NULL,NULL,NULL,'CGCG 385-135',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.00003,NULL,'15.8b',0.3,'S','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,21.573875,-1.79339,0.16,NULL,35236023549,550562867,8602544,15.8),(16690,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16690,35.53,0.56,128,3922,70,NULL,NULL,'2MASX J01262180-0531575',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.47',0.38,NULL,NULL,NULL,NULL,NULL,1,21.5907916667,-5.53267,0.213,NULL,35242988877,550671701,8604245,15.47),(16691,'Ring Diameter','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16691,31.4,0.84,19,3923,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 0536',NULL,'1981ApJS...45..541P',1981,1,3,NULL,'G',0.000017,NULL,'13.20',1.1,'SB(r)b         AGN','in a pair',NULL,NULL,NULL,1,21.59075,34.70303,0.153,NULL,67759379429,1058740303,16542817,13.2),(16692,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16692,34.16,0.8,68,3923,75,NULL,'HMCL, I','NGC 0536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16693,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16693,34.17,0.8,68.1,3923,75,NULL,'W91PP, r','NGC 0536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16694,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16694,34.17,0.8,68.2,3923,75,NULL,'HMCL, I','NGC 0536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16695,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16695,34.18,0.8,68.4,3923,75,NULL,'W91CL, r','NGC 0536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16696,'Sosies','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16696,33.96,0.12,61.9,3923,NULL,NULL,NULL,'NGC 0536',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16697,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16697,33.35,NULL,46.8,3923,NULL,NULL,'B','NGC 0536',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16698,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16698,33.48,0.4,49.7,3923,75,NULL,'HMCL, I, raw','NGC 0536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16699,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16699,33.62,0.38,52.9,3923,75,NULL,'W91PP, r, raw','NGC 0536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16700,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16700,33.65,NULL,53.7,3923,NULL,NULL,'I','NGC 0536',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16701,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16701,33.72,0.4,55.5,3923,75,NULL,'HMCL, I, raw','NGC 0536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16702,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16702,33.73,0.4,55.8,3923,75,NULL,'HMCL, I, inv','NGC 0536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16703,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16703,33.79,0.46,57.4,3923,NULL,NULL,'J','NGC 0536',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16704,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16704,33.86,0.4,59.2,3923,75,NULL,'HMCL, I, cor','NGC 0536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16705,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16705,33.87,0.38,59.3,3923,75,NULL,'W91CL, r, raw','NGC 0536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16706,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16706,33.87,0.47,59.4,3923,NULL,NULL,'H','NGC 0536',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16707,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16707,33.9,0.38,60.2,3923,75,NULL,'W91PP, r, inv','NGC 0536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16708,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16708,33.9,0.45,60.3,3923,NULL,NULL,'K','NGC 0536',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16709,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16709,33.92,0.38,60.9,3923,75,NULL,'W91PP, r, cor','NGC 0536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16710,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16710,33.98,0.2,62.5,3923,74.4,NULL,NULL,'NGC 0536',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16711,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16711,33.99,0.4,62.8,3923,75,NULL,'HMCL, I, inv','NGC 0536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16712,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16712,34.02,0.4,63.5,3923,75,NULL,'HMCL, I, cor','NGC 0536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16713,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16713,34.06,0.38,64.8,3923,75,NULL,'W91CL, r, cor','NGC 0536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16714,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16714,34.1,0.38,66,3923,75,NULL,'W91CL, r, inv','NGC 0536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16715,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16715,34.1,0.43,66.1,3923,75,NULL,'3.6 micron, color corrected','NGC 0536',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16716,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16716,34.28,0.4,71.7,3923,NULL,NULL,'mean','NGC 0536',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16717,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16717,34.38,0.43,75.2,3923,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0536',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16718,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16718,34.39,0.07,75.7,3923,NULL,NULL,NULL,'NGC 0536',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16719,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 18969','RN',16719,41.73,0.44,1720,3924,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18969',0.289217,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16720,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16720,34.11,0.54,66.4,3925,70,NULL,NULL,'NGC 0557',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000103,NULL,'14.48',0.8,'SB(rs)0+ pec:','Group member',NULL,NULL,NULL,1,21.6047917,-1.63872,0.16,NULL,35236004093,550562563,8602540,14.48),(16721,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16721,34.38,0.12,75.3,3925,NULL,NULL,NULL,'NGC 0557',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16722,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 13177','RN',16722,40.53,0.28,966,3926,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13177',0.318671,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16723,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 13177','RN',16723,40.66,0.31,1030,3926,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13177',0.318671,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16724,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16724,34.77,0.46,90,3927,70,NULL,NULL,'MCG -02-04-050',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000043,NULL,'15.0g',0.64,'E0',NULL,NULL,NULL,NULL,1,21.608,-8.56425,0.097,NULL,35271935416,551123990,8611312,15),(16725,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16725,35.66,0.48,135,3928,70,NULL,NULL,'MCG -06-04-035',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000113,NULL,'15.09',1.3,'(R)SA(rl)0^0',NULL,NULL,NULL,NULL,1,21.60925,-37.45733,NULL,NULL,38348005167,599187580,9362305,15.09),(16726,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16726,34.4,0.49,76,3929,75,NULL,'IR','NGC 0542',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000027,NULL,'15.68',0.2,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,21.62875,34.67528,0.153,NULL,67759380982,1058740327,16542817,15.68),(16727,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16727,36.91,0.64,241,3930,70,NULL,NULL,'2MASX J01263130-2014370',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'17.42',0.22,NULL,NULL,NULL,NULL,NULL,1,21.630417,-20.24361,0.06,NULL,35231956346,550499317,8601551,17.42),(16728,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16728,34.23,0.25,70.2,3931,74.4,NULL,NULL,'2MASX J01263143-0134295',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.00013,NULL,'15.9',0.4,'S0','Group member',NULL,NULL,NULL,1,21.630833,-1.57494,0.16,NULL,35235976513,550562133,8602533,15.9),(16729,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 15793',NULL,16729,39.7,0.38,871,3932,70,NULL,'SN photometric redshift distance, z photo =0.229 +/- 0.051','SDSS-II SN 15793',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','21.0g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,21.63725,1.02725,0.021,NULL,67512155793,1054877434,16482459,21),(16730,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16730,36.78,0.6,227,3933,70,NULL,NULL,'2MASX J01263372-1926520',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'16.07',0.41,NULL,NULL,NULL,NULL,NULL,1,21.6405416667,-19.44781,0.081,NULL,35229340179,550458440,8600913,16.07),(16731,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16731,36.63,0.46,212,3934,70,NULL,NULL,'2MASX J01263402+1412030',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00009,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,21.6417083,14.20075,0.109,NULL,67596847002,1056200734,16503136,16.4),(16732,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 12974','RN',16732,40.42,0.32,931,3935,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 12974',0.306327,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16733,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 12974','RN',16733,41.13,0.34,1290,3935,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 12974',0.306327,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16734,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16734,31.6,0.8,20.9,3936,75,NULL,'MAT, I','ESO 476- G 010',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00001,NULL,'15.44',0.6,'SB(s)m',NULL,NULL,NULL,NULL,1,21.67625,-25.31497,0.079,NULL,34702862148,542232221,8472378,15.44),(16735,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16735,31.09,0.32,16.5,3936,85,NULL,'I, inv','ESO 476- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16736,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16736,31.16,0.32,17.1,3936,85,NULL,'I, raw','ESO 476- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16737,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16737,31.4,0.6,19,3936,NULL,NULL,'Malmquist cor.','ESO 476- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16738,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16738,31.6,0.2,20.9,3936,74.4,NULL,NULL,'ESO 476- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16739,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16739,31.64,0.4,21.3,3936,NULL,NULL,NULL,'ESO 476- G 010',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16740,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16740,31.64,0.4,21.3,3936,73,NULL,'opt','ESO 476- G 010',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16741,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16741,31.67,0.43,21.5,3936,75,NULL,'MAT, I, inv','ESO 476- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16742,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16742,31.7,0.43,21.9,3936,75,NULL,'3.6 micron, color corrected','ESO 476- G 010',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16743,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16743,31.72,0.43,22.1,3936,75,NULL,'3.6 micron, color + selection bias corrected','ESO 476- G 010',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16744,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16744,31.81,0.5,23,3936,NULL,NULL,NULL,'ESO 476- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16745,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16745,31.83,0.43,23.2,3936,75,NULL,'MAT, I, raw','ESO 476- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16746,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16746,31.9,0.43,23.9,3936,75,NULL,'MAT, I, cor','ESO 476- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16747,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16747,34.84,0.06,93.1,3937,NULL,NULL,NULL,'NGC 0550',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.00008,NULL,'13.59',0.6,'SB(s)a?','in a radial-velocity based grouping',NULL,NULL,NULL,1,21.6772917,2.02236,0.045,NULL,67515703873,1054932873,16483326,13.59),(16748,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16748,34.09,0.07,65.9,3938,NULL,NULL,NULL,'CGCG 385-138',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.00015,NULL,'15.33',0.2,'Sb?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,21.68125,-1.30622,0.123,NULL,35232652663,550510197,8601721,15.33),(16749,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16749,32.99,0.43,39.7,3939,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01020',NULL,'2014MNRAS.444..527S',2014,1,1.2,NULL,'G',0.000017,NULL,'14.81',0.4,'S?',NULL,NULL,NULL,NULL,1,21.6832917,17.26447,0.165,NULL,67422030700,1053469229,16460456,14.81),(16750,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16750,34.33,0.46,73.4,3940,70,NULL,NULL,'IC 1705',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000103,NULL,'14.38',0.35,NULL,NULL,NULL,NULL,NULL,1,21.686833,-3.50147,0.137,NULL,35246171011,550721422,8605022,14.38),(16751,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16751,37.4,0.46,301,3941,70,NULL,NULL,'2MASX J01264497+1325591',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00009,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,21.687625,13.43297,0.105,NULL,67598559253,1056227488,16503554,17.2),(16752,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16752,35.54,0.47,128,3942,NULL,NULL,NULL,'SDSS J012645.33+143728.3',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000058,NULL,'17.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,21.688917,14.62456,0.105,NULL,67610233097,1056409892,16506404,17.5),(16753,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16753,35.9,0.4,151,3942,NULL,NULL,'Malmquist cor.','SDSS J012645.33+143728.3',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16754,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 2005hj',NULL,16754,36.38,0.15,179,3943,74.2,NULL,'SALT 2','SDSS J012648.45-011417.3',0.0564,'2010ApJ...716..712A',2010,1,0.18,NULL,'G',NULL,NULL,'18.9g',0.08,NULL,NULL,NULL,NULL,NULL,1,21.701917,-1.23814,0.123,NULL,35232669386,550510459,8601725,18.9),(16755,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 2005hj',NULL,16755,36.66,0.12,214,3943,72,NULL,'M(H) = -18.317 mag','SDSS J012648.45-011417.3',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16756,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 2005hj',NULL,16756,36.98,0.13,235,3943,72,NULL,'z lit','SDSS J012648.45-011417.3',0.0564,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16757,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 2005hj',NULL,16757,36.99,0.13,237,3943,70,NULL,'SALT 2','SDSS J012648.45-011417.3',0.0564,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16758,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 2005hj',NULL,16758,37.03,0.04,241,3943,72,NULL,'SALT2','SDSS J012648.45-011417.3',0.0564,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16759,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 2005hj',NULL,16759,37.04,0.1,242,3943,65,NULL,'SALT2','SDSS J012648.45-011417.3',0.0564,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16760,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 06558','R',16760,37.07,0.18,245,3943,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005hj','SDSS J012648.45-011417.3',0.057,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16761,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 2005hj',NULL,16761,36.99,0.08,250,3943,70,NULL,'SALT 2','SDSS J012648.45-011417.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16762,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 2005hj',NULL,16762,36.99,0.08,250,3943,70,NULL,'SALT 2, Malmquist cor.','SDSS J012648.45-011417.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16763,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 2005hj',NULL,16763,37.11,0.19,250,3943,73.8,NULL,'SALT 2 (SNANA)','SDSS J012648.45-011417.3',0.057,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16764,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 06558','R',16764,37.3,0.05,273,3943,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005hj','SDSS J012648.45-011417.3',0.057,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16765,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 2005hj',NULL,16765,37.31,0.08,275,3943,65,NULL,'MLCS2k2','SDSS J012648.45-011417.3',0.0564,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16766,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 2005hj',NULL,16766,37.33,0.25,276,3943,73.8,NULL,'SALT 2 (SNANA)','SDSS J012648.45-011417.3',0.057,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16767,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 2005hj',NULL,16767,37.24,0.16,281,3943,65,NULL,'SALT','SDSS J012648.45-011417.3',NULL,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16768,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 2005hj',NULL,16768,37.26,0.14,283,3943,65,NULL,'MLCS17','SDSS J012648.45-011417.3',NULL,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16769,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 2005hj',NULL,16769,37.33,0.18,292,3943,65,NULL,'SALT2','SDSS J012648.45-011417.3',NULL,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16770,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 2005hj',NULL,16770,37.37,0.13,298,3943,65,NULL,'MLCS31','SDSS J012648.45-011417.3',NULL,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16771,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16771,35.84,0.49,147,3944,70,NULL,NULL,'6dF J0126499-082927',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,21.707875,-8.49086,0.097,NULL,35271995536,551124930,8611327,15),(16772,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16772,35.47,0.46,124,3945,70,NULL,NULL,'SDSS J012649.88-082927.1',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'15.5g',0.37,'S0',NULL,NULL,NULL,NULL,1,21.707875,-8.49089,0.097,NULL,35271995536,551124930,8611327,15.5),(16773,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 12975','RN',16773,42.79,0.21,2780,3946,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 12975',0.298735,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16774,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 12975','RN',16774,43.2,0.25,3360,3946,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 12975',0.298735,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16775,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16775,35.5,0.55,126,3947,70,NULL,NULL,'2MASX J01265166-2257108',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'15.71',0.57,'S0',NULL,NULL,NULL,NULL,1,21.7152083,-22.95303,0.026,NULL,35177054147,549641471,8588147,15.71),(16776,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 13529','R',16776,40.69,0.23,1060,3948,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13529',0.302444,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',NULL,'PHOT','21.9g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,21.720083,0.33681,0.033,NULL,66639977051,1041249641,16269525,21.9),(16777,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 13529',NULL,16777,40.29,0.23,1140,3948,70,NULL,'SN photometric redshift distance, z photo =0.315 +/- 0.043','SDSS-II SN 13529',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16778,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 13529',NULL,16778,40.33,0.15,1160,3948,70,NULL,'SALT 2','SDSS-II SN 13529',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16779,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 13529',NULL,16779,40.36,0.15,1180,3948,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13529',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16780,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 13529','R',16780,41,0.19,1210,3948,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13529',0.302444,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16781,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16781,33.96,0.44,61.9,3949,NULL,NULL,NULL,'ESO 353- G 001',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.75',0.3,'S...',NULL,NULL,NULL,NULL,1,21.72575,-36.55622,NULL,NULL,38276612388,598072068,9344876,15.75),(16782,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16782,34,0.2,63.1,3949,74.4,NULL,NULL,'ESO 353- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16783,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16783,34.26,0.39,71,3949,NULL,NULL,'Malmquist cor.','ESO 353- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16784,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16784,35.96,0.51,156,3950,70,NULL,NULL,'2MASX J01265610-0722240',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000107,NULL,'16.19',0.52,NULL,NULL,NULL,NULL,NULL,1,21.733833,-7.37353,0.079,NULL,35290313847,551411153,8615799,16.19),(16785,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16785,36.14,0.56,169,3951,70,NULL,NULL,'2MASX J01265705-1313482',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'16.71',0.34,NULL,NULL,NULL,NULL,NULL,1,21.7377083,-13.23003,0,NULL,35401266311,553144786,8642887,16.71),(16786,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16786,37.38,0.89,299,3952,70,NULL,NULL,'LCSB S0229P',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.49',0.37,NULL,NULL,NULL,NULL,NULL,1,21.7422917,-37.55619,NULL,NULL,38348054103,599188345,9362317,16.49),(16787,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 13014','RN',16787,42.24,0.17,2110,3953,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13014',0.331717,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16788,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 13014','RN',16788,42.4,0.22,2270,3953,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13014',0.331717,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16789,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 18429','RN',16789,39.82,0.25,809,3954,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18429',0.135198,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16790,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 18429','RN',16790,40.52,5.89,1120,3954,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18429',0.135198,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16791,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16791,34.11,0.12,66.5,3955,NULL,NULL,NULL,'CGCG 521-028',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000033,NULL,'15.6',0.25,'Sb','Group non-member, foreground',NULL,NULL,NULL,1,21.759083,33.95544,0.173,NULL,67759185869,1058737279,16542769,15.6),(16792,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16792,34.71,0.2,87.5,3955,74.4,NULL,NULL,'CGCG 521-028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16793,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16793,35.15,0.47,107,3956,70,NULL,NULL,'NGC 0567',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00009,NULL,'14.6g',0.5,'SB0o:',NULL,NULL,NULL,NULL,1,21.76,-10.26525,0.147,NULL,35282051878,551282060,8613782,14.6),(16794,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 07884',NULL,16794,39.57,1.21,820,3957,70,NULL,'SN photometric redshift distance, z photo =0.214 +/- 0.203','SDSS-II SN 07884',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,21.767375,0.12339,0.033,NULL,66639968726,1041249511,16269523,NULL),(16795,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 07884','R',16795,41.96,0.29,1710,3957,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07884',0.441372,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16796,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 07884','R',16796,42.38,0.31,2080,3957,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07884',0.441372,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16797,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 07884',NULL,16797,41.88,0.19,2380,3957,70,NULL,'SALT 2','SDSS-II SN 07884',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16798,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 07884',NULL,16798,41.97,0.19,2480,3957,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 07884',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16799,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16799,34.45,0.8,77.8,3958,75,NULL,'MAT, I','ESO 353- G 002',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.00003,NULL,'15.41',0.5,'S?',NULL,NULL,NULL,NULL,1,21.772583,-35.85603,NULL,NULL,38276337654,598067775,9344808,15.41),(16800,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16800,33.64,0.32,53.4,3958,85,NULL,'I, inv','ESO 353- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16801,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16801,33.64,0.32,53.5,3958,85,NULL,'I, raw','ESO 353- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16802,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16802,33.93,0.43,61,3958,75,NULL,'MAT, I, raw','ESO 353- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16803,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16803,33.95,0.43,61.7,3958,75,NULL,'MAT, I, inv','ESO 353- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16804,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16804,34.22,0.43,69.7,3958,75,NULL,'MAT, I, cor','ESO 353- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16805,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16805,34.31,0.2,72.8,3958,74.4,NULL,NULL,'ESO 353- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16806,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16806,34.43,0.37,76.9,3958,NULL,NULL,NULL,'ESO 353- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16807,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16807,34.5,0.35,79.5,3958,NULL,NULL,'Malmquist cor.','ESO 353- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16808,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 2005hf',NULL,16808,35.68,0.16,131,3959,74.2,NULL,'SALT 2','2MASX J01270614+1906587',0.04311,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.000193,NULL,'14.0',NULL,NULL,'Group member',NULL,NULL,NULL,1,21.7755,19.11639,0.121,NULL,67443333037,1053802078,16465657,14),(16809,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 2005hf',NULL,16809,36.1,0.03,159,3959,72,NULL,'SALT2','2MASX J01270614+1906587',0.04311,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16810,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 2005hf',NULL,16810,36.36,0.17,179,3959,70,NULL,'SALT 2','2MASX J01270614+1906587',0.04311,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16811,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 2005hf',NULL,16811,36.55,0.2,196,3959,65,NULL,'SALT2','2MASX J01270614+1906587',0.04311,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16812,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 2005hf',NULL,16812,36.56,0.16,197,3959,65,NULL,'MLCS31','2MASX J01270614+1906587',0.04311,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16813,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 2005hf',NULL,16813,36.59,0.16,199,3959,65,NULL,'MLCS17','2MASX J01270614+1906587',0.04311,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16814,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16814,36.25,0.7,177,3960,70,NULL,NULL,'MCG -01-04-050',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.7b',0.6,NULL,NULL,NULL,NULL,NULL,1,21.7849166667,-3.21981,0.165,NULL,35246249662,550722650,8605041,15.7),(16815,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 13958','R',16815,41.28,0.22,1390,3961,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13958',0.302507,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,21.78775,0.80036,0.041,NULL,67512109730,1054876714,16482448,NULL),(16816,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 13958','R',16816,41.69,0.17,1670,3961,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13958',0.302507,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16817,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16817,34.34,0.51,73.8,3962,NULL,NULL,'Malmquist cor.','IC 1704',NULL,'2009ApJS..182..474S',2009,1,1.06,NULL,'G',0.000032,NULL,'14.2g',0.68,'S pec?','in a pair',NULL,NULL,NULL,1,21.7897083,14.77628,0.105,NULL,67596479040,1056194985,16503046,14.2),(16818,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16818,34.59,0.45,83,3962,NULL,NULL,NULL,'IC 1704',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16819,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16819,34.63,0.2,84.3,3962,74.4,NULL,NULL,'IC 1704',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16820,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16820,35.51,0.49,126,3963,70,NULL,NULL,'ESO 542- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'15.18',0.8,'Sa-b',NULL,NULL,NULL,NULL,1,21.791417,-20.40425,0.063,NULL,35228745993,550449156,8600768,15.18),(16821,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16821,34.4,0.47,76,3964,70,NULL,NULL,'ESO 542- G 015',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00009,NULL,'14.49',0.8,'S0?','in a pair',NULL,NULL,NULL,1,21.806417,-21.77367,0,NULL,35221521452,550336272,8599004,14.49),(16822,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 03642','RN',16822,37.11,0.63,244,3965,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03642',0.08252,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16823,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16823,35.39,0.61,120,3966,70,NULL,NULL,'2MASX J01271498-0318090',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.000107,NULL,'16.23',0.36,NULL,NULL,NULL,NULL,NULL,1,21.8124166667,-3.30264,0.137,NULL,35246247164,550722611,8605040,16.23),(16824,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16824,33.94,0.4,61.4,3967,75,NULL,'Edat, raw','UGC 01030',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000057,NULL,'14.57',0.6,'E','Group member',NULL,NULL,NULL,1,21.8172916667,-1.27197,0.123,NULL,35232503030,550507859,8601685,14.57),(16825,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16825,33.97,0.4,62.2,3967,75,NULL,'Edat, cor','UGC 01030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16826,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16826,34.36,0.23,74.5,3967,74.4,NULL,NULL,'UGC 01030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16827,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16827,34.65,0.47,85.2,3967,70,NULL,NULL,'UGC 01030',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16828,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16828,34.39,0.6,75.6,3968,70,NULL,NULL,'NGC 0558',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.0001,NULL,'15.4b',0.2,'E+? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,21.817375,-1.97089,0.176,NULL,35236341719,550567839,8602622,15.4),(16829,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16829,35.93,0.51,154,3969,70,NULL,NULL,'LCRS B012509.3-441924',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'16.07',0.45,'(R_1)SB0^+:',NULL,NULL,NULL,NULL,1,21.829917,-44.06481,NULL,NULL,38370608209,599540753,9367824,16.07),(16830,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16830,35.74,0.33,140,3970,NULL,NULL,NULL,'UGC 01029',NULL,'2009ApJS..182..474S',2009,1,1,'The 2MASS position is for the stellar object just east of the galaxy.','G',0.000167,NULL,'15.53',0.2,'Sa',NULL,NULL,NULL,NULL,1,21.838375,11.97558,0.141,NULL,67529498858,1055148419,16486694,15.53),(16831,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16831,35.75,0.33,141,3970,NULL,NULL,'Malmquist cor.','UGC 01029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16832,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16832,35.78,0.2,143,3970,74.4,NULL,NULL,'UGC 01029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16833,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16833,35.92,0.49,153,3970,75,NULL,'IR','UGC 01029',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16834,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16834,39.39,0.46,754,3971,70,NULL,NULL,'SDSS J012724.66+151706.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000081,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,21.85275,15.28519,0.105,NULL,67424523749,1053508183,16461065,18.5),(16835,'Faber-Jackson','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16835,33.8,0.44,57.5,3972,95,NULL,'Weighted Mean','NGC 0560',NULL,'1984ApJS...56...91D',1984,1,1.9,NULL,'G',0.000057,NULL,'13.95',0.6,'S0^0^','in a radial-velocity based grouping',NULL,NULL,NULL,1,21.855917,-1.91297,0.176,NULL,35236311631,550567369,8602615,13.95),(16836,'Faber-Jackson','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16836,34.2,0.46,69.2,3972,95,NULL,'Michard 1979a','NGC 0560',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16837,'Faber-Jackson','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16837,34.54,0.63,80.9,3972,95,NULL,'Michard 1979b, c','NGC 0560',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16838,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16838,33.27,0.61,45.2,3972,70,NULL,NULL,'NGC 0560',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16839,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16839,33.88,0.23,59.7,3972,74.4,NULL,NULL,'NGC 0560',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16840,'Tertiary','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16840,33.69,0.5,54.7,3972,95,NULL,NULL,'NGC 0560',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16841,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16841,33.57,0.45,51.9,3972,NULL,NULL,'K','NGC 0560',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16842,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16842,34.32,0.4,73.3,3972,NULL,NULL,'mean','NGC 0560',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16843,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16843,36.58,0.46,207,3973,70,NULL,NULL,'2MASX J01272571+1531357',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000098,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,21.857083,15.52661,0.101,NULL,67424646337,1053510099,16461095,16.3),(16844,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 17757','RN',16844,39.43,0.25,637,3974,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 17757',0.207278,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16845,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 17757','RN',16845,40.59,0.27,1090,3974,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 17757',0.207278,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16846,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16846,36.71,0.46,220,3975,70,NULL,NULL,'SDSS J012733.26+150827.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000066,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,21.888625,15.14092,0.105,NULL,67424490675,1053507666,16461057,17.8),(16847,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16847,36.9,0.56,240,3976,70,NULL,NULL,'MCG -01-04-052',NULL,'2014MNRAS.445.2677S',2014,1,0.76,NULL,'G',0.00015,NULL,'14.96',0.53,'S0','Compact group member',NULL,NULL,NULL,1,21.889167,-4.683,0.169,NULL,35243934039,550686469,8604476,14.96),(16848,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16848,36.25,0.58,178,3977,70,NULL,NULL,'2MASX J01273441-0439075',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.000127,NULL,'16.82',0.39,'SB0','Compact group member',NULL,NULL,NULL,1,21.893375,-4.65211,0.169,NULL,35243905147,550686017,8604469,16.82),(16849,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16849,33.35,0.8,46.9,3978,75,NULL,'HMCL, I','UGC 01033',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000023,NULL,'14.10',0.5,'Scd:','Group non-member, foreground',NULL,NULL,NULL,1,21.8952917,31.55472,0.117,NULL,67767957978,1058874343,16544911,14.1),(16850,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16850,33.36,0.8,46.9,3978,75,NULL,'W91PP, r','UGC 01033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16851,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16851,33.45,0.4,49,3978,75,NULL,'HMCL, I, raw','UGC 01033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16852,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16852,33.55,0.38,51.3,3978,75,NULL,'W91PP, r, raw','UGC 01033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16853,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16853,33.58,0.4,52.1,3978,75,NULL,'HMCL, I, inv','UGC 01033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16854,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16854,33.6,0.2,52.5,3978,74.4,NULL,NULL,'UGC 01033',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16855,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16855,33.61,0.42,52.8,3978,NULL,NULL,NULL,'UGC 01033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16856,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16856,33.65,0.38,53.6,3978,75,NULL,'W91PP, r, inv','UGC 01033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16857,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16857,33.65,0.49,53.7,3978,75,NULL,'IR','UGC 01033',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16858,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16858,33.75,0.4,56.3,3978,NULL,NULL,'mean','UGC 01033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16859,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16859,33.78,0.43,57.1,3978,75,NULL,'3.6 micron, color corrected','UGC 01033',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16860,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16860,33.83,0.4,58.4,3978,75,NULL,'HMCL, I, cor','UGC 01033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16861,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16861,33.87,0.38,59.4,3978,75,NULL,'W91PP, r, cor','UGC 01033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16862,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16862,33.9,0.47,60.4,3978,NULL,NULL,'H','UGC 01033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16863,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16863,33.95,0.43,61.7,3978,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01033',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16864,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16864,33.98,0.46,62.5,3978,NULL,NULL,'J','UGC 01033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16865,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16865,33.99,0.35,62.7,3978,NULL,NULL,'Malmquist cor.','UGC 01033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16866,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16866,34.11,0.45,66.4,3978,NULL,NULL,'K','UGC 01033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16867,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16867,38.68,0.46,545,3979,70,NULL,NULL,'SDSS J012735.10+145925.9',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000087,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,21.8962917,14.99053,0.105,NULL,67412966783,1053327605,16458243,17.5),(16868,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16868,33.22,0.23,44.1,3980,74.4,NULL,NULL,'UGC 01040',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000057,NULL,'14.85',0.2,'S0/a','Group member',NULL,NULL,NULL,1,21.899583,-1.10511,0.136,NULL,35232973035,550515203,8601800,14.85),(16869,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16869,36.39,0.5,189,3981,70,NULL,NULL,'IC 0118',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.48',0.2,NULL,NULL,NULL,NULL,NULL,1,21.900167,-4.99747,0.185,NULL,35243814672,550684604,8604446,15.48),(16870,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 20928',NULL,16870,36.72,3.85,221,3982,70,NULL,'SN photometric redshift distance, z photo =0.053 +/- 0.316','SDSS-II SN 20928',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','22.9g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,21.901,0.97417,0.025,NULL,67512408699,1054881385,16482521,22.9),(16871,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 20928','R',16871,41.27,0.25,1310,3982,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20928',0.370739,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16872,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 20928','R',16872,41.52,0.2,1470,3982,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20928',0.370739,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16873,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 20928',NULL,16873,41.11,0.15,1670,3982,70,NULL,'SALT 2','SDSS-II SN 20928',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16874,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 20928',NULL,16874,41.17,0.15,1710,3982,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20928',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16875,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16875,34.93,0.49,96.6,3983,75,NULL,'IR','FGC 0167',NULL,'2011yCatp016004901K',2011,1,0.87,NULL,'G',0.000037,NULL,'16.8',0.11,'Scd',NULL,NULL,NULL,NULL,1,21.906375,51.14794,1.449,NULL,67797239856,1059331872,16552060,16.8),(16876,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16876,35.18,0.43,108,3983,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0167',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16877,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16877,33.76,0.62,56.5,3984,NULL,NULL,NULL,'ESO 542- G 016',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16',0.2,'SB(s)c         HII','in a pair',NULL,NULL,NULL,1,21.907417,-21.64308,0,NULL,35221500558,550335946,8598999,16),(16878,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16878,33.8,0.2,57.5,3984,74.4,NULL,NULL,'ESO 542- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16879,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16879,33.88,0.49,59.8,3984,75,NULL,'IR','ESO 542- G 016',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16880,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16880,33.95,0.56,61.6,3984,NULL,NULL,'Malmquist cor.','ESO 542- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16881,'Horizontal Branch','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16881,24.65,0.07,0.853,3985,NULL,NULL,NULL,'Andromeda XXII',NULL,'2013MNRAS.430...37C',2013,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,21.916667,28.09028,0.217,1,67251242261,1050800660,16418760,NULL),(16882,'Horizontal Branch','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16882,24.87,NULL,0.94,3985,NULL,NULL,NULL,'Andromeda XXII',NULL,'2009ApJ...705..758M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16883,'TRGB','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16883,24.82,0.36,0.92,3985,NULL,NULL,NULL,'Andromeda XXII',NULL,'2012ApJ...758...11C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16884,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16884,34.16,0.8,67.8,3986,75,NULL,'W91PP, r','NGC 0551',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000023,NULL,'13.48',0.8,'SBbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,21.919417,37.18292,0.217,NULL,67755056917,1058672764,16541761,13.48),(16885,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16885,33.39,NULL,47.6,3986,NULL,NULL,'B','NGC 0551',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16886,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16886,33.68,0.38,54.4,3986,75,NULL,'W91PP, r, raw','NGC 0551',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16887,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16887,33.83,0.38,58.3,3986,75,NULL,'W91PP, r, inv','NGC 0551',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16888,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16888,33.85,NULL,58.9,3986,NULL,NULL,'I','NGC 0551',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16889,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16889,33.95,0.2,61.7,3986,74.4,NULL,NULL,'NGC 0551',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16890,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16890,33.98,0.38,62.4,3986,75,NULL,'W91PP, r, cor','NGC 0551',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16891,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16891,33.99,0.47,62.7,3986,NULL,NULL,'H','NGC 0551',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16892,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16892,33.99,0.43,62.8,3986,75,NULL,'3.6 micron, color corrected','NGC 0551',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16893,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16893,34.03,0.46,64.1,3986,NULL,NULL,'J','NGC 0551',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16894,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16894,34.07,0.45,65.3,3986,NULL,NULL,'K','NGC 0551',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16895,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16895,34.12,0.43,66.8,3986,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0551',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16896,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16896,34.25,0.07,70.9,3986,NULL,NULL,NULL,'NGC 0551',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16897,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16897,34.29,0.4,72.1,3986,NULL,NULL,'mean','NGC 0551',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16898,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 13901',NULL,16898,40.8,0.19,1450,3987,70,NULL,'SN photometric redshift distance, z photo =0.422 +/- 0.051','SDSS-II SN 13901',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,21.9209166667,-0.14467,0.045,NULL,34494084603,538970071,8421407,NULL),(16899,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 13901','R',16899,41.65,0.3,1490,3987,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13901',0.431273,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16900,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 13901','R',16900,41.93,0.37,1700,3987,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13901',0.431273,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16901,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 13901',NULL,16901,42.12,0.3,2650,3987,70,NULL,'SALT 2','SDSS-II SN 13901',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16902,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 13901',NULL,16902,42.2,0.3,2750,3987,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13901',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16903,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16903,37.27,0.46,284,3988,70,NULL,NULL,'2MASX J01274580-0951005',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000102,NULL,'16.9g',0.3,'AGN',NULL,NULL,NULL,NULL,1,21.9407917,-9.85006,0.129,NULL,35282268079,551285438,8613834,16.9),(16904,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16904,37.44,0.46,307,3989,70,NULL,NULL,'SDSS J012746.51-100146.7',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000086,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,21.9438333333,-10.02967,0.129,NULL,35282475940,551288686,8613885,18.7),(16905,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16905,36.59,0.8,208,3990,75,NULL,'CF, r','UGC 01037',NULL,'1997ApJS..109..333W',1997,1,1.1,'1998A&AS..130..333T has V = 4969 +- 10 km/sec.','G',0.000167,NULL,'15.20',0.5,'Sb',NULL,NULL,NULL,NULL,1,21.944417,43.15436,0.393,NULL,67911315984,1061114312,16579911,15.2),(16906,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16906,36.05,0.38,162,3990,75,NULL,'CF, r, raw','UGC 01037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16907,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16907,36.28,0.38,180,3990,75,NULL,'CF, r, inv','UGC 01037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16908,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16908,36.28,0.38,181,3990,75,NULL,'CF, r, cor','UGC 01037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16909,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16909,38.62,0.46,530,3991,70,NULL,NULL,'2MASX J01274773+0101184',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000097,NULL,'18.2g',0.14,'AGN',NULL,NULL,NULL,NULL,1,21.949,1.02181,0.037,NULL,67512404933,1054881327,16482520,18.2),(16910,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16910,33.94,0.4,61.4,3992,75,NULL,'Edat, raw','NGC 0564',NULL,'1997ApJS..109..333W',1997,1,1.4,'HOLM 044B is a star.','G',0.000057,NULL,'13.52',1.2,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,21.950875,-1.87953,0.143,NULL,35236302837,550567231,8602612,13.52),(16911,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16911,33.97,0.4,62.2,3992,75,NULL,'Edat, cor','NGC 0564',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16912,'Faber-Jackson','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16912,34.61,0.44,83.6,3992,95,NULL,'Weighted Mean','NGC 0564',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16913,'Faber-Jackson','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16913,34.93,0.46,96.8,3992,95,NULL,'Michard 1979a','NGC 0564',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16914,'Faber-Jackson','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16914,35.72,0.63,139,3992,95,NULL,'Michard 1979b, c','NGC 0564',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16915,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16915,34.38,0.23,75.2,3992,74.4,NULL,NULL,'NGC 0564',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16916,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16916,34.86,0.46,93.6,3992,70,NULL,NULL,'NGC 0564',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16917,'Tertiary','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16917,33.69,0.5,54.7,3992,95,NULL,NULL,'NGC 0564',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16918,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16918,34.32,0.4,73.3,3992,NULL,NULL,'mean','NGC 0564',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16919,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16919,34.79,0.45,90.8,3992,NULL,NULL,'K','NGC 0564',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16920,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16920,38.17,0.46,431,3993,70,NULL,NULL,'2MASX J01274991-0012235',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.0001,NULL,'16.49',0.2,NULL,NULL,NULL,NULL,NULL,1,21.957917,-0.20653,0.045,NULL,34494161286,538971270,8421426,16.49),(16921,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 02530','RN',16921,41.38,0.31,1310,3994,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02530',0.43775,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16922,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 02530','RN',16922,42.21,0.39,1930,3994,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02530',0.43775,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16923,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16923,34.3,0.07,72.6,3995,NULL,NULL,NULL,'2MASX J01275610-0121265',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000043,NULL,'15.91',0.4,'I','Group member',NULL,NULL,NULL,1,21.98375,-1.35778,0.109,NULL,35232953984,550514906,8601795,15.91),(16924,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 09250','RN',16924,41.85,0.23,1850,3996,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 09250',0.265928,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16925,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 09250','RN',16925,42.36,0.32,2350,3996,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 09250',0.265928,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16926,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16926,34.73,0.48,88.5,3997,70,NULL,NULL,'NGC 0568',NULL,'2014MNRAS.445.2677S',2014,1,2.2,NULL,'G',0.000067,NULL,'13.58',1.4,'SA0- pec:',NULL,NULL,NULL,NULL,1,21.9875417,-35.71769,NULL,NULL,38277026325,598078536,9344977,13.58),(16927,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16927,34.45,0.4,77.8,3997,NULL,NULL,'mean','NGC 0568',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16928,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16928,34.48,0.45,78.6,3997,NULL,NULL,'K','NGC 0568',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16929,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16929,33.89,0.08,60.1,3998,NULL,NULL,NULL,'APMUKS(BJ) B012525.36-020851.1',NULL,'2009ApJS..182..474S',2009,1,0.49,NULL,'G',0.000264,NULL,'16.33',0.19,NULL,NULL,NULL,NULL,NULL,1,21.992917,-1.88861,0.143,NULL,35236233566,550566149,8602596,16.33),(16930,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16930,37.46,0.46,310,3999,70,NULL,NULL,'2MASX J01280010-0058065',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00009,NULL,'16.8g',0.25,'E','Group member',NULL,NULL,NULL,1,22.000417,-0.96861,0.136,NULL,35233094088,550517095,8601829,16.8),(16931,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16931,34.72,0.8,87.8,4000,75,NULL,'HMCL, I','UGC 01045',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.00002,NULL,'14.45',0.3,'Sb','Group non-member, background',NULL,NULL,NULL,1,22.00375,32.03311,0.117,NULL,67769791136,1058902986,16545359,14.45),(16932,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16932,34.72,0.8,87.8,4000,75,NULL,'W91PP, r','UGC 01045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16933,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16933,34.3,0.2,72.4,4000,74.4,NULL,NULL,'UGC 01045',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16934,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16934,34.33,0.4,73.3,4000,75,NULL,'HMCL, I, raw','UGC 01045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16935,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16935,34.39,0.38,75.6,4000,75,NULL,'W91PP, r, raw','UGC 01045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16936,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16936,34.42,0.29,76.6,4000,NULL,NULL,'Malmquist cor.','UGC 01045',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16937,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16937,34.45,0.4,77.7,4000,75,NULL,'HMCL, I, cor','UGC 01045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16938,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16938,34.45,0.4,77.7,4000,75,NULL,'HMCL, I, inv','UGC 01045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16939,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16939,34.45,0.28,77.7,4000,NULL,NULL,NULL,'UGC 01045',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16940,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16940,34.48,0.38,78.7,4000,75,NULL,'W91PP, r, inv','UGC 01045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16941,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16941,34.5,0.38,79.4,4000,75,NULL,'W91PP, r, cor','UGC 01045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16942,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16942,35.91,0.48,152,4001,70,NULL,NULL,'MCG -03-04-071',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.00015,NULL,'15',0.2,NULL,NULL,NULL,NULL,NULL,1,22.005875,-16.857,0.006,NULL,35187366627,549802603,8590665,15),(16943,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 21764',NULL,16943,41.25,0.33,1770,4002,70,NULL,'SN photometric redshift distance, z photo =0.554 +/- 0.137','SDSS-II SN 21764',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,22.006375,-0.40022,0.045,NULL,34494111466,538970491,8421413,NULL),(16944,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16944,33.49,0.23,49.9,4003,74.4,NULL,NULL,'CGCG 385-151',NULL,'2013AJ....146...86T',2013,1,0.58,NULL,'G',0.000062,NULL,'15.2g',0.53,'E2:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,22.008875,-0.73831,0.099,NULL,35233079376,550516865,8601826,15.2),(16945,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16945,35.55,0.52,129,4003,70,NULL,NULL,'CGCG 385-151',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16946,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16946,34.08,0.07,65.6,4004,NULL,NULL,NULL,'2MASX J01280350-0143135',NULL,'2009ApJS..182..474S',2009,1,0.54,NULL,'G',0.00026,NULL,'16.24',0.23,NULL,NULL,NULL,NULL,NULL,1,22.014583,-1.72028,0.143,NULL,35235653420,550557084,8602454,16.24),(16947,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16947,37.33,0.63,292,4005,70,NULL,NULL,'2MASX J01280414-0526255',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'16.85',0.27,NULL,NULL,NULL,NULL,NULL,1,22.0173333333,-5.44069,0.212,NULL,35244207797,550690746,8604542,16.85),(16948,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 20999','RN',16948,39.04,1.77,596,4006,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 20999',0.078979,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16949,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16949,33.31,0.49,45.9,4007,70,NULL,NULL,'NGC 0565',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000067,NULL,'14.42',0.4,'Sa:','Group member',NULL,NULL,NULL,1,22.042417,-1.30603,0.109,NULL,35232946161,550514783,8601793,14.42),(16950,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16950,34.47,0.07,78.5,4007,NULL,NULL,NULL,'NGC 0565',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16951,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16951,34.49,0.49,79.1,4007,75,NULL,'IR','NGC 0565',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16952,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16952,34.11,0.53,66.4,4008,70,NULL,NULL,'IC 0120',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000057,NULL,'15.23',0.2,'S0^0^:','Group member',NULL,NULL,NULL,1,22.054,-1.91553,0.143,NULL,35235726746,550558230,8602472,15.23),(16953,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16953,34.29,0.09,72.3,4008,NULL,NULL,NULL,'IC 0120',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16954,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 04470','RN',16954,41.31,0.37,1550,4009,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04470',0.180037,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16955,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 18047','R',16955,41.33,0.28,1360,4010,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18047',0.358855,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,22.0742083,-0.65806,0.099,NULL,35232278330,550504348,8601630,NULL),(16956,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 18047','R',16956,41.6,0.28,1540,4010,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18047',0.358855,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16957,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 18951','RN',16957,41.42,0.2,1650,4011,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18951',0.164046,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16958,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 18951','RN',16958,42.2,0.28,2360,4011,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18951',0.164046,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16959,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16959,37.81,0.46,365,4012,70,NULL,NULL,'2MASX J01281962+1332128',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000087,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,22.081625,13.53686,0.109,NULL,67596817223,1056200269,16503129,17.5),(16960,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 15967',NULL,16960,40.6,0.16,1320,4013,70,NULL,'SN photometric redshift distance, z photo =0.374 +/- 0.037','SDSS-II SN 15967',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,22.0843333333,-0.77097,0.099,NULL,35233111067,550517360,8601833,NULL),(16961,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 15967',NULL,16961,40.65,0.18,1350,4013,70,NULL,'SALT 2','SDSS-II SN 15967',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16962,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 15967',NULL,16962,40.69,0.18,1370,4013,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15967',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16963,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16963,35.34,0.8,117,4014,75,NULL,'CF, r','IC 0121',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000073,NULL,'14.28',0.5,'Sbc',NULL,NULL,NULL,NULL,1,22.09075,2.51303,0.037,NULL,67512923981,1054889437,16482647,14.28),(16964,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16964,34.73,0.69,88.4,4014,100,NULL,'mid-IR','IC 0121',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16965,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16965,35.17,0.38,108,4014,75,NULL,'CF, r, raw','IC 0121',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16966,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16966,35.37,0.38,119,4014,75,NULL,'CF, r, inv','IC 0121',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16967,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16967,35.42,0.47,122,4014,NULL,NULL,'H','IC 0121',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16968,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16968,35.45,0.45,123,4014,NULL,NULL,'K','IC 0121',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16969,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16969,35.46,0.4,124,4014,NULL,NULL,'mean','IC 0121',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16970,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16970,35.46,0.38,124,4014,75,NULL,'CF, r, cor','IC 0121',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16971,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16971,35.48,0.46,125,4014,NULL,NULL,'J','IC 0121',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16972,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 19589',NULL,16972,38.49,0.87,498,4015,70,NULL,'SN photometric redshift distance, z photo =0.124 +/- 0.068','SDSS-II SN 19589',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,22.119875,0.66411,0.013,NULL,67511693903,1054870217,16482347,NULL),(16973,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16973,38.2,0.46,438,4016,70,NULL,NULL,'2MASX J01282924+1450414',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00008,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,22.12175,14.84489,0.117,NULL,67412972271,1053327691,16458245,18.2),(16974,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16974,34.3,0.09,72.6,4017,NULL,NULL,NULL,'LCSB S0237O',NULL,'2009ApJS..182..474S',2009,1,0.43,NULL,'G',0.000023,NULL,'15.65',0.17,'Sc',NULL,NULL,NULL,NULL,1,22.1422083333,-1.89283,0.143,NULL,35235737507,550558398,8602474,15.65),(16975,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 13159','RN',16975,43.51,0.28,3180,4018,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13159',0.584962,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16976,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16976,34.41,0.07,76.4,4019,NULL,NULL,NULL,'UGC 01055',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.00002,NULL,'14.59',0.8,'SBa','Group member',NULL,NULL,NULL,1,22.153333,-1.73167,0.143,NULL,35235770342,550558911,8602482,14.59),(16977,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',16977,35.23,0.46,111,4020,70,NULL,NULL,'2MASX J01283743-0004099',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000073,NULL,'16.1g',0.27,'E0',NULL,NULL,NULL,NULL,1,22.156,-0.06931,0.045,NULL,34493973685,538968338,8421380,16.1),(16978,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16978,35.91,0.66,152,4020,70,NULL,NULL,'2MASX J01283743-0004099',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16979,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 10976','R',16979,39.63,0.12,769,4021,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 10976',0.095606,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,22.1705833333,-0.88922,0.112,NULL,35233149939,550517967,8601843,NULL),(16980,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 10976','R',16980,39.71,0.21,799,4021,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 10976',0.095606,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16981,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16981,35.31,0.54,115,4022,70,NULL,NULL,'MCG -04-04-017',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00012,NULL,'15.31',0.4,'S0',NULL,NULL,NULL,NULL,1,22.1856666667,-23.41061,0.013,NULL,35177170738,549643292,8588176,15.31),(16982,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 19802','RN',16982,39.47,0.13,672,4023,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 19802',0.164302,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16983,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 19802','RN',16983,39.71,0.22,751,4023,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19802',0.164302,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16984,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16984,33.14,NULL,42.4,4024,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01054',NULL,'2010Ap&SS.325..163P',2010,1,1.76,NULL,'G',0.000017,NULL,'16.30',0.1,'Sd','Group non-member, foreground',NULL,NULL,NULL,1,22.201083,34.34642,0.189,NULL,67757106419,1058704787,16542262,16.3),(16985,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16985,33.16,NULL,42.8,4024,NULL,NULL,'Dipole','UGC 01054',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16986,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16986,33.16,NULL,42.8,4024,NULL,NULL,'Dipole + Quadrupole','UGC 01054',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16987,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16987,33.24,NULL,44.4,4024,NULL,NULL,NULL,'UGC 01054',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16988,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16988,34.27,0.43,71.5,4024,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01054',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16989,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16989,35.87,0.74,149,4025,70,NULL,NULL,'ESO 542-IG 019 NED03',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.90',NULL,NULL,NULL,NULL,NULL,NULL,1,22.2165417,-19.96619,0.101,NULL,35228239829,550441247,8600644,16.9),(16990,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16990,34.45,0.47,77.5,4026,NULL,NULL,'Malmquist cor.','UGC 01057',NULL,'2009ApJS..182..474S',2009,1,1.53,NULL,'G',0.000044,NULL,'14.6g',0.4,'Sbc            NLAGN',NULL,NULL,NULL,NULL,1,22.221917,13.79378,0.113,NULL,67597303657,1056207869,16503247,14.6),(16991,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16991,34.6,0.2,83.2,4026,74.4,NULL,NULL,'UGC 01057',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16992,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16992,34.69,0.42,86.8,4026,NULL,NULL,NULL,'UGC 01057',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16993,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16993,34.23,0.1,70.3,4027,NULL,NULL,NULL,'UGC 01060',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000023,NULL,'15.7',0.25,'S',NULL,NULL,NULL,NULL,1,22.232417,-1.81919,0.143,NULL,35235815795,550559621,8602494,15.7),(16994,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16994,34.6,0.2,83.2,4027,74.4,NULL,NULL,'UGC 01060',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16995,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16995,33.89,0.48,60,4028,70,NULL,NULL,'NGC 0570',NULL,'2014MNRAS.445.2677S',2014,1,1.35,NULL,'G',0.000076,NULL,'13.7g',0.97,'(R\')SB(rs)a:','in a radial-velocity based grouping',NULL,NULL,NULL,1,22.244333,-0.949,0.112,NULL,35233174438,550518350,8601849,13.7),(16996,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16996,33.79,0.46,57.2,4029,70,NULL,NULL,'UGC 01062',NULL,'2014MNRAS.445.2677S',2014,1,1.45,NULL,'G',0.000077,NULL,'13.7g',0.71,'(R\')SB(s)0^0^:','in a radial-velocity based grouping',NULL,NULL,NULL,1,22.2481666667,-0.56194,0.065,NULL,35232360720,550505636,8601650,13.7),(16997,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 15002','R',16997,41.42,0.25,1410,4030,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2006ko','SN 2006ko',0.362,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,22.2497917,0.76994,0.017,NULL,67512470885,1054882357,16482536,NULL),(16998,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 15002','R',16998,41.43,0.17,1420,4030,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2006ko','SN 2006ko',0.362,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16999,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,16999,36.75,0.58,224,4031,70,NULL,NULL,'2MASX J01290121-2049152',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'17.56',0.27,NULL,NULL,NULL,NULL,NULL,1,22.2550417,-20.82083,0.046,NULL,35228126148,550439471,8600616,17.56),(17000,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17000,35.44,0.51,122,4032,70,NULL,NULL,'2MASX J01290164-4337226',NULL,'2014MNRAS.445.2677S',2014,1,0.93,NULL,'G',0.00015,NULL,'15.62',0.3,'S',NULL,NULL,NULL,NULL,1,22.2567917,-43.62303,NULL,NULL,38384783188,599762237,9371284,15.62),(17001,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17001,36.67,0.56,215,4033,70,NULL,NULL,'2MASX J01290241-0908290',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.72',0.3,NULL,NULL,NULL,NULL,NULL,1,22.260083,-9.14136,0.113,NULL,35281706922,551276670,8613697,16.72),(17002,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17002,34.15,0.4,67.8,4034,NULL,NULL,'mean','NGC 0566',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000103,NULL,'14.49',0.4,'S0',NULL,NULL,NULL,NULL,1,22.262333,32.33225,0.153,NULL,67769987008,1058906047,16545406,14.49),(17003,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17003,34.17,0.45,68.4,4034,NULL,NULL,'K','NGC 0566',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17004,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 06943','RN',17004,39.3,0.82,646,4035,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06943',0.122148,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17005,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 06943','RN',17005,39.79,0.65,807,4035,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06943',0.122148,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17006,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17006,34.07,0.46,65,4036,NULL,NULL,NULL,'NGC 0574',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.21',0.7,'(R\'_1)SB(rl)b',NULL,NULL,NULL,NULL,1,22.262833,-35.59892,NULL,NULL,38274729201,598042643,9344416,14.21),(17007,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17007,34.11,0.2,66.4,4036,74.4,NULL,NULL,'NGC 0574',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17008,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17008,34.31,0.41,72.8,4036,NULL,NULL,'Malmquist cor.','NGC 0574',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17009,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17009,34.33,0.47,73.3,4036,NULL,NULL,'H','NGC 0574',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17010,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17010,34.4,0.45,75.9,4036,NULL,NULL,'K','NGC 0574',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17011,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17011,34.48,0.46,78.7,4036,NULL,NULL,'J','NGC 0574',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17012,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17012,34.49,0.4,79,4036,NULL,NULL,'mean','NGC 0574',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17013,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17013,37.18,0.7,273,4037,70,NULL,NULL,'2MASX J01290815-5352413',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.57',0.39,NULL,NULL,NULL,NULL,NULL,1,22.2840833333,-53.87819,NULL,NULL,36123192762,564424886,8819138,16.57),(17014,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17014,33.67,0.56,54.1,4038,NULL,NULL,'Malmquist cor.','UGC 01065',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.00005,NULL,'15.18',0.7,'SAB(s)bc','Pair member (points to parent)',NULL,NULL,NULL,1,22.296167,11.14069,0.205,NULL,67529779104,1055152798,16486762,15.18),(17015,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17015,33.73,0.54,55.7,4038,NULL,NULL,NULL,'UGC 01065',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17016,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17016,33.77,0.2,56.8,4038,74.4,NULL,NULL,'UGC 01065',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17017,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17017,35.37,0.84,119,4039,NULL,NULL,'Malmquist cor.','KUG 0126+334A',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000033,NULL,'15.28',0.4,'Sb','Group non-member, background',NULL,NULL,NULL,1,22.3054583,33.66825,0.161,NULL,67751703488,1058620367,16540943,15.28),(17018,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17018,35.59,0.2,131,4039,74.4,NULL,NULL,'KUG 0126+334A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17019,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17019,35.64,0.75,134,4039,NULL,NULL,NULL,'KUG 0126+334A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17020,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17020,36.54,0.73,204,4040,70,NULL,NULL,'2MASX J01291919-1212150',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'17.43',0.22,NULL,NULL,NULL,NULL,NULL,1,22.329917,-12.20417,0.046,NULL,35401751953,553152374,8643005,17.43),(17021,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17021,34.09,0.8,65.9,4041,75,NULL,'HMCL, I','UGC 01066',NULL,'1997ApJS..109..333W',1997,1,1.14,NULL,'G',0.000009,NULL,'16.5',0.18,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,22.336667,32.06436,0.097,NULL,67769962307,1058905661,16545400,16.5),(17022,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17022,34.09,0.8,65.9,4041,75,NULL,'HMCL, I','UGC 01066',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17023,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17023,33.77,0.4,56.7,4041,75,NULL,'HMCL, I, inv','UGC 01066',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17024,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17024,33.79,0.4,57.2,4041,75,NULL,'HMCL, I, inv','UGC 01066',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17025,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17025,33.82,0.4,58.1,4041,75,NULL,'HMCL, I, raw','UGC 01066',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17026,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17026,33.83,0.4,58.4,4041,75,NULL,'HMCL, I, raw','UGC 01066',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17027,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17027,33.92,0.2,60.8,4041,74.4,NULL,NULL,'UGC 01066',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17028,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17028,34.06,0.4,64.9,4041,75,NULL,'HMCL, I, cor','UGC 01066',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17029,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17029,34.07,0.4,65.1,4041,75,NULL,'HMCL, I, cor','UGC 01066',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17030,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17030,34.2,0.13,69.3,4041,NULL,NULL,NULL,'UGC 01066',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17031,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17031,34.22,0.43,69.9,4041,75,NULL,'3.6 micron, color corrected','UGC 01066',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17032,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17032,34.51,0.43,79.9,4041,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01066',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17033,'Horizontal Branch','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17033,24.43,0.13,0.767,4042,NULL,NULL,NULL,'Andromeda XXIII',NULL,'2011ApJ...732...76R',2011,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,22.340833,38.71889,0.261,1,67885184681,1060706010,16573531,NULL),(17034,'TRGB','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17034,24.33,0.03,0.733,4042,NULL,NULL,NULL,'Andromeda XXIII',NULL,'2011ApJ...740...69C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17035,'TRGB','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17035,24.37,0.09,0.748,4042,NULL,NULL,NULL,'Andromeda XXIII',NULL,'2012ApJ...758...11C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17036,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17036,36.03,0.58,161,4043,70,NULL,NULL,'2MASX J01292568-1211435',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.36',0.4,NULL,NULL,NULL,NULL,NULL,1,22.357125,-12.19533,0.046,NULL,35401750651,553152353,8643005,16.36),(17037,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 18430','R',17037,41.54,0.32,1460,4044,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18430',0.389724,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',NULL,'PHOT','20.0g',0.08,'BrClG',NULL,NULL,NULL,NULL,1,22.3564166667,0.08953,0.053,NULL,66639114868,1041236169,16269315,20),(17038,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 18430','R',17038,41.84,0.33,1680,4044,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18430',0.389724,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17039,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 18430',NULL,17039,41.28,0.22,1810,4044,70,NULL,'SN photometric redshift distance, z photo =0.568 +/- 0.091','SDSS-II SN 18430',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17040,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 18430',NULL,17040,41.39,0.22,1900,4044,70,NULL,'SALT 2','SDSS-II SN 18430',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17041,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 18430',NULL,17041,41.45,0.22,1950,4044,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18430',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17042,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17042,34.3,0.11,72.6,4045,NULL,NULL,NULL,'2MASX J01292655-0111595',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000023,NULL,'14.45',0.2,'Sbc',NULL,NULL,NULL,NULL,1,22.36075,-1.19978,0.109,NULL,35232887328,550513864,8601779,14.45),(17043,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17043,35.8,0.6,144,4046,70,NULL,NULL,'2MASX J01292685-1039155',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.70',0.36,NULL,NULL,NULL,NULL,NULL,1,22.361833,-10.65439,0.14,NULL,35279665592,551244774,8613199,16.7),(17044,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17044,36.14,0.55,169,4047,70,NULL,NULL,'2MASX J01292808-2019258',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'16.41',0.46,NULL,NULL,NULL,NULL,NULL,1,22.3670417,-20.32389,0.071,NULL,35228393048,550443641,8600681,16.41),(17045,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 15003',NULL,17045,41.33,0.11,1850,4048,70,NULL,'SN photometric redshift distance, z photo =0.587 +/- 0.045','SDSS-II SN 15003',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,22.388583,0.69567,0.033,NULL,67511609999,1054868906,16482326,NULL),(17046,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 07172','RN',17046,38.64,0.39,469,4049,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 07172',0.137505,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17047,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',17047,35.85,0.46,148,4050,70,NULL,NULL,'2MASX J01294103+1443342',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000084,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,22.4210417,14.72606,0.101,NULL,67413150829,1053330481,16458288,16.7),(17048,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17048,34.59,0.47,82.7,4051,70,NULL,NULL,'UGC 01072',NULL,'2014MNRAS.445.2677S',2014,1,1.16,NULL,'G',0.000085,NULL,'14.3g',0.67,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,22.4332917,-1.24142,0.109,NULL,35232939825,550514684,8601791,14.3),(17049,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',17049,34.68,0.33,86.4,4051,70,NULL,NULL,'UGC 01072',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17050,'Tully est','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17050,30.13,0.8,10.6,4051,75,NULL,'B','UGC 01072',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17051,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17051,34.5,0.33,79.6,4052,NULL,NULL,'Malmquist cor.','KUG 0126+317',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000414,NULL,'15.6',0.3,'Spiral',NULL,NULL,NULL,NULL,1,22.442625,32.02114,0.113,NULL,67769829205,1058903581,16545368,15.6),(17052,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17052,34.61,0.2,83.6,4052,74.4,NULL,NULL,'KUG 0126+317',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17053,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17053,34.78,0.29,90.4,4052,NULL,NULL,NULL,'KUG 0126+317',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17054,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17054,33.36,0.69,47,4053,100,NULL,'mid-IR','UGC 01068',NULL,'2013ApJ...771...88L',2013,1,1.7,NULL,'G',0.00003,NULL,'13.56',1.1,'Sc','Pair member (points to parent)',NULL,NULL,NULL,1,22.4460833333,45.59903,0.385,NULL,67876652647,1060572697,16571448,13.56),(17055,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17055,33.7,0.2,55,4053,74.4,NULL,NULL,'UGC 01068',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17056,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17056,33.82,0.28,58,4053,NULL,NULL,NULL,'UGC 01068',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17057,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17057,33.98,0.47,62.5,4053,NULL,NULL,'H','UGC 01068',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17058,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17058,34.05,0.46,64.6,4053,NULL,NULL,'J','UGC 01068',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17059,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17059,34.08,0.45,65.6,4053,NULL,NULL,'K','UGC 01068',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17060,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17060,34.14,0.24,67.3,4053,NULL,NULL,'Malmquist cor.','UGC 01068',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17061,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17061,34.37,0.4,74.8,4053,NULL,NULL,'mean','UGC 01068',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17062,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17062,32.32,0.4,29.2,4054,NULL,NULL,'mean','IC 0127',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.00014,NULL,'14.83',0.5,'Sb: sp','X-ray-faint group member',NULL,NULL,NULL,1,22.448375,-6.98006,0.112,NULL,35287311904,551364248,8615066,14.83),(17063,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17063,32.96,0.47,39.1,4054,NULL,NULL,'H','IC 0127',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17064,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17064,32.96,0.45,39.1,4054,NULL,NULL,'K','IC 0127',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17065,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17065,33.07,0.46,41,4054,NULL,NULL,'J','IC 0127',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17066,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 1993ae',NULL,17066,33.65,0.21,52.7,4055,74.2,NULL,'SALT 2','IC 0126',0.01905,'2010ApJ...716..712A',2010,1,1.4,NULL,'G',0.00015,NULL,'15.3b',1.2,'S?',NULL,NULL,NULL,NULL,1,22.449417,-1.98375,0.124,NULL,35234749058,550542954,8602233,15.3),(17067,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 1993ae',NULL,17067,34.17,0.09,68.2,4055,74.4,NULL,NULL,'IC 0126',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17068,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 1993ae',NULL,17068,34.29,0.23,70.8,4055,65,NULL,NULL,'IC 0126',0.01905,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17069,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 1993ae',NULL,17069,34.31,0.03,71.4,4055,72,NULL,NULL,'IC 0126',0.01905,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17070,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 1993ae',NULL,17070,34.41,0.13,74.8,4055,70,NULL,'SALT','IC 0126',0.01905,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17071,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 1993ae',NULL,17071,34.47,0.19,75.4,4055,65,NULL,'MLCS2k2','IC 0126',0.01905,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17072,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 1993ae',NULL,17072,34.53,0.14,79.1,4055,65,NULL,'MLCS','IC 0126',0.01905,'1996ApJ...473..588R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17073,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 1993ae',NULL,17073,34.52,0.11,80.2,4055,65,NULL,'Snapshot','IC 0126',NULL,'1996ApJ...473...88R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17074,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 1993ae',NULL,17074,34.54,0.14,80.9,4055,65,NULL,'LCS','IC 0126',NULL,'1995ApJ...445L..91R',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17075,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 1993ae',NULL,17075,34.55,0.17,81.3,4055,70.8,NULL,NULL,'IC 0126',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17076,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 1993ae',NULL,17076,34.6,0.2,83.2,4055,60,NULL,'M(B) = -19.48 mag','IC 0126',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17077,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 1993ae',NULL,17077,34.63,0.14,84.3,4055,60,NULL,'M(I) = -19.19 mag','IC 0126',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17078,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 1993ae',NULL,17078,34.65,0.16,85.1,4055,60,NULL,'M(V) = -19.47 mag','IC 0126',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17079,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 1993ae',NULL,17079,34.86,0.14,93.8,4055,60,NULL,NULL,'IC 0126',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17080,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17080,35.83,0.71,147,4055,70,NULL,NULL,'IC 0126',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17081,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17081,36.07,0.55,164,4056,70,NULL,NULL,'2MASX J01294898-5303351',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'17.02',0.16,NULL,NULL,NULL,NULL,NULL,1,22.454125,-53.05981,NULL,NULL,36124870996,564451109,8819548,17.02),(17082,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17082,35.71,0.52,139,4057,70,NULL,NULL,'2MASX J01295521-2026288',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'16.09',0.59,NULL,NULL,NULL,NULL,NULL,1,22.479917,-20.44147,0.053,NULL,35228892790,550451449,8600803,16.09),(17083,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 17317','RN',17083,41.06,0.07,1460,4058,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 17317',0.117275,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17084,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 17317','RN',17084,41.29,0.19,1620,4058,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 17317',0.117275,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17085,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17085,31.42,0.49,19.3,4059,NULL,NULL,'Malmquist cor.','UGC 01070',NULL,'2009ApJS..182..474S',2009,1,1.9,NULL,'G',0.000017,NULL,'13.94',1.3,'Scd:','in a pair',NULL,NULL,NULL,1,22.4994583,40.97381,0.305,NULL,67904415241,1061006488,16578226,13.94),(17086,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17086,31.57,0.46,20.6,4059,NULL,NULL,NULL,'UGC 01070',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17087,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17087,31.61,0.2,21,4059,74.4,NULL,NULL,'UGC 01070',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17088,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17088,31.75,0.4,22.4,4059,NULL,NULL,NULL,'UGC 01070',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17089,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 03294','RN',17089,39.91,0.09,856,4060,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 03294',0.122757,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17090,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 03294','RN',17090,40.31,0.22,1030,4060,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 03294',0.122757,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17091,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',17091,38.55,0.46,512,4061,70,NULL,NULL,'2MASX J01300411+1530327',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000091,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,22.5170416667,15.50919,0.089,NULL,67425499865,1053523435,16461303,17.9),(17092,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17092,34.7,0.8,87.3,4062,75,NULL,'MAT, I','ESO 244- G 031',NULL,'1997ApJS..109..333W',1997,1,1.6,'ESO-LV gives v= 7600+/-10 km/sec.','G',0.000033,NULL,'13.65',1.3,'SA(rs)c',NULL,NULL,NULL,NULL,1,22.522583,-42.68631,NULL,NULL,38385386192,599771659,9371432,13.65),(17093,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17093,34.59,0.43,83,4062,75,NULL,'MAT, I, raw','ESO 244- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17094,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17094,34.79,0.52,90.8,4062,NULL,NULL,'Malmquist cor.','ESO 244- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17095,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17095,34.83,0.32,92.3,4062,85,NULL,'I, raw','ESO 244- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17096,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17096,34.86,0.43,93.5,4062,75,NULL,'MAT, I, cor','ESO 244- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17097,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17097,34.91,0.32,95.8,4062,85,NULL,'I, inv','ESO 244- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17098,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17098,34.91,0.43,96,4062,75,NULL,'MAT, I, inv','ESO 244- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17099,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17099,35.11,0.45,105,4062,NULL,NULL,NULL,'ESO 244- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17100,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17100,35.15,0.2,107,4062,74.4,NULL,NULL,'ESO 244- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17101,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17101,34.89,0.5,95.2,4063,70,NULL,NULL,'2MASX J01300639-0239235',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000097,NULL,'16.27',1.1,'SA(s)dm',NULL,NULL,NULL,NULL,1,22.5265417,-2.65656,0.134,NULL,35234415334,550537739,8602152,16.27),(17102,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17102,33.15,0.8,42.7,4064,75,NULL,'W91PP, r','UGC 01073',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000007,NULL,'14.44',1.1,'Sm:','Dwarf, possible member',NULL,NULL,NULL,1,22.53125,25.86389,0.257,NULL,67259705952,1050932905,16420826,14.44),(17103,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17103,32.87,0.38,37.6,4064,75,NULL,'W91PP, r, inv','UGC 01073',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17104,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17104,32.96,0.38,39.1,4064,75,NULL,'W91PP, r, raw','UGC 01073',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17105,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17105,33.31,0.38,45.8,4064,75,NULL,'W91PP, r, cor','UGC 01073',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17106,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 03837','RN',17106,41.51,0.17,1480,4065,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03837',0.36055,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17107,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 03837','RN',17107,42.11,0.23,1940,4065,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03837',0.36055,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17108,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',17108,37.8,0.46,363,4066,70,NULL,NULL,'SDSS J013010.43-010744.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000057,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,22.5435,-1.12911,0.095,NULL,35232913883,550514279,8601785,18.2),(17109,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 02955','RN',17109,41.2,0.18,1300,4067,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02955',0.336566,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17110,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 02955','RN',17110,41.46,0.1,1470,4067,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 02955',0.336566,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17111,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 17822','RN',17111,39.01,0.22,575,4068,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 17822',0.104684,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17112,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 17822','RN',17112,39.82,0.41,833,4068,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 17822',0.104684,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17113,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17113,36.07,0.42,164,4069,NULL,NULL,'Malmquist cor.','UGC 01076',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000017,NULL,'15.30',0.3,'S?',NULL,NULL,NULL,NULL,1,22.5830417,17.02158,0.157,NULL,67424442308,1053506911,16461045,15.3),(17114,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17114,36.32,0.38,184,4069,NULL,NULL,NULL,'UGC 01076',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17115,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17115,36.37,0.2,188,4069,74.4,NULL,NULL,'UGC 01076',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17116,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',17116,37.82,0.46,367,4070,70,NULL,NULL,'2MASX J01302020-0053207',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000071,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,22.5842083333,-0.889,0.095,NULL,35232759337,550511864,8601747,17.9),(17117,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',17117,37.16,0.46,270,4071,70,NULL,NULL,'2MASX J01302473-0949545',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000096,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,22.6030833333,-9.83181,0.146,NULL,35281053949,551266467,8613538,17),(17118,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17118,34.44,0.8,77.3,4072,75,NULL,'MAT, I','ESO 476- G 016',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.25',0.7,'SB(r)bc','in a pair',NULL,NULL,NULL,1,22.608,-26.78003,0.022,NULL,34709684861,542338825,8474044,14.25),(17119,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17119,34.25,0.43,70.9,4072,75,NULL,'MAT, I, raw','ESO 476- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17120,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17120,34.32,0.32,73.2,4072,85,NULL,'I, raw','ESO 476- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17121,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17121,34.38,0.32,75,4072,85,NULL,'I, inv','ESO 476- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17122,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17122,34.47,0.43,78.4,4072,75,NULL,'MAT, I, cor','ESO 476- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17123,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17123,34.48,0.43,78.7,4072,75,NULL,'MAT, I, inv','ESO 476- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17124,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17124,34.54,0.4,80.9,4072,NULL,NULL,'mean','ESO 476- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17125,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17125,34.75,0.47,89.2,4072,NULL,NULL,'H','ESO 476- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17126,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17126,34.81,0.46,91.5,4072,NULL,NULL,'J','ESO 476- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17127,'Quasar spectrum','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17127,42.88,NULL,3770,4073,NULL,NULL,NULL,'UM 109',NULL,'2002A&A...381L..57D',2002,1,NULL,NULL,'QSO',0.03,NULL,'18.9',NULL,NULL,NULL,NULL,NULL,'QSO',1,22.6085,6.17261,0.065,NULL,67571101908,1055798467,16496851,18.9),(17128,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17128,31.63,0.8,21.2,4074,75,NULL,'MAT, I','NGC 0578',NULL,'1997ApJS..109..333W',1997,1,4.9,'Loveday, et al. (1996,ApJS,107,201) give v = 9542 +/- 36 km/sec.','G',0.00001,NULL,'11.44',3.1,'SAB(rs)c',NULL,NULL,NULL,NULL,1,22.6212083,-22.66736,0.022,NULL,35176598232,549634347,8588036,11.44),(17129,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17129,31.63,0.8,21.2,4074,75,NULL,'A82, H','NGC 0578',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17130,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17130,30.95,0.32,15.5,4074,85,NULL,'I, raw','NGC 0578',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17131,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17131,30.98,0.32,15.7,4074,85,NULL,'I, inv','NGC 0578',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17132,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17132,31.04,0.69,16.1,4074,100,NULL,'mid-IR','NGC 0578',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17133,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17133,31.12,0.38,16.7,4074,NULL,NULL,NULL,'NGC 0578',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17134,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17134,31.14,0.43,16.9,4074,75,NULL,'MAT, I, raw','NGC 0578',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17135,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17135,31.27,0.43,17.9,4074,75,NULL,'MAT, I, inv','NGC 0578',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17136,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17136,31.29,0.43,18.1,4074,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0578',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17137,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17137,31.33,0.43,18.4,4074,75,NULL,'3.6 micron, color corrected','NGC 0578',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17138,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',17138,31.34,NULL,18.5,4074,NULL,NULL,'I','NGC 0578',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17139,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',17139,31.34,NULL,18.5,4074,NULL,NULL,'B','NGC 0578',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17140,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17140,31.34,0.4,18.5,4074,73,NULL,'opt','NGC 0578',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17141,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17141,31.38,0.43,18.9,4074,75,NULL,'MAT, I, cor','NGC 0578',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17142,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17142,31.42,0.5,19.3,4074,NULL,NULL,'Malmquist cor.','NGC 0578',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17143,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17143,31.44,0.2,19.4,4074,74.4,NULL,NULL,'NGC 0578',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17144,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17144,31.45,0.4,19.5,4074,75,NULL,'B','NGC 0578',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17145,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',17145,31.5,NULL,20,4074,NULL,NULL,'LEDA [Nov 2006]','NGC 0578',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17146,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17146,31.68,0.4,21.6,4074,NULL,NULL,'mean','NGC 0578',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17147,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17147,31.68,0.44,21.7,4074,NULL,NULL,NULL,'NGC 0578',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17148,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17148,31.86,0.4,23.5,4074,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 0578',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17149,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17149,31.88,0.46,23.7,4074,NULL,NULL,'J','NGC 0578',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17150,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17150,31.91,0.47,24.1,4074,NULL,NULL,'H','NGC 0578',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17151,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17151,31.93,0.45,24.3,4074,NULL,NULL,'K','NGC 0578',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17152,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17152,32.08,0.47,26.1,4074,75,NULL,'A82, H, raw','NGC 0578',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17153,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17153,32.17,0.47,27.1,4074,75,NULL,'A82, H, cor','NGC 0578',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17154,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17154,32.2,0.47,27.6,4074,75,NULL,'A82, H, inv','NGC 0578',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17155,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SN 2006jv',NULL,17155,40.55,0.32,1290,4075,70,NULL,'Hubble residual -0.02 for z0.36800','SDSS J013032.21+001311.2',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,22.634125,0.221,0.005,NULL,66974689937,1046479530,16351242,NULL),(17156,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 15217','R',17156,41.25,0.3,1300,4075,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006jv','SDSS J013032.21+001311.2',0.368,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17157,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 15217','R',17157,41.25,0.33,1300,4075,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006jv','SDSS J013032.21+001311.2',0.368,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17158,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',17158,37.83,0.16,368,4076,70,NULL,NULL,'2MASX J01303645+0027305',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000102,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,22.6517917,0.45858,0.029,NULL,66974806178,1046481346,16351271,16.4),(17159,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',17159,37.59,0.46,329,4077,70,NULL,NULL,'2MASX J01303818+0006533',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000088,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,22.6590416667,0.11489,0.005,NULL,66974709548,1046479836,16351247,16.7),(17160,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',17160,36.39,0.46,189,4078,70,NULL,NULL,'2MASX J01303820-1045482',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000093,NULL,'16.0g',0.42,'S0',NULL,NULL,NULL,NULL,1,22.659167,-10.7635,0.121,NULL,35268880288,551076254,8610566,16),(17161,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17161,36.99,0.67,250,4078,70,NULL,NULL,'2MASX J01303820-1045482',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17162,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 02588','RN',17162,42.86,0.27,2660,4079,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02588',0.401986,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17163,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:48','1','SDSS-II SN 02588','RN',17163,42.97,0.26,2810,4079,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02588',0.401986,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17164,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,'R',17164,37.71,0.46,348,4080,70,NULL,NULL,'SDSS J013041.84-085049.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000091,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,22.674375,-8.84706,0.097,NULL,35272576815,551134012,8611468,17.9),(17165,'FP','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17165,36.37,0.49,188,4081,70,NULL,NULL,'MCG -03-04-078',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'15.24',0.25,NULL,NULL,NULL,NULL,NULL,1,22.6775417,-16.46442,0.008,NULL,35197940621,549967822,8593247,15.24),(17166,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17166,33.35,0.8,46.9,4082,75,NULL,'MAT, I','ESO 196- G 011',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00003,NULL,'14.42',0.7,'SAB(s)d',NULL,NULL,NULL,NULL,1,22.682583,-51.14192,NULL,NULL,38222143005,597220984,9331577,14.42),(17167,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17167,32.57,0.32,32.7,4082,85,NULL,'I, raw','ESO 196- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17168,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17168,32.58,0.32,32.8,4082,85,NULL,'I, inv','ESO 196- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17169,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17169,32.85,0.43,37.2,4082,75,NULL,'MAT, I, raw','ESO 196- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17170,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17170,32.92,0.78,38.3,4082,NULL,NULL,NULL,'ESO 196- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17171,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17171,32.92,0.43,38.3,4082,75,NULL,'MAT, I, inv','ESO 196- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17172,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17172,32.96,0.2,39.1,4082,74.4,NULL,NULL,'ESO 196- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17173,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17173,32.96,0.39,39.1,4082,73,NULL,'opt','ESO 196- G 011',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17174,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17174,33.05,0.73,40.7,4082,NULL,NULL,'Malmquist cor.','ESO 196- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17175,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:48','1',NULL,NULL,17175,33.15,0.43,42.7,4082,75,NULL,'MAT, I, cor','ESO 196- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17176,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17176,37.51,1.01,318,4083,70,NULL,NULL,'2MASX J01304386-1257072',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.65',0.24,NULL,NULL,NULL,NULL,NULL,1,22.6827917,-12.952,0.017,NULL,35403908871,553186076,8643532,16.65),(17177,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17177,34.58,0.33,82.2,4084,NULL,NULL,'Malmquist cor.','ESO 476- G 017',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'14.94',0.8,'Sb','in a triple',NULL,NULL,NULL,1,22.696375,-23.58789,0.01,NULL,35175522545,549617539,8587774,14.94),(17178,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17178,34.72,0.31,88,4084,NULL,NULL,NULL,'ESO 476- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17179,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17179,34.76,0.2,89.5,4084,74.4,NULL,NULL,'ESO 476- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17180,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,'R',17180,37.99,0.46,396,4085,70,NULL,NULL,'2MASX J01304899-1017152',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000102,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,22.704167,-10.28756,0.15,NULL,35280972397,551265193,8613518,17.5),(17181,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17181,35.61,0.63,133,4086,70,NULL,NULL,'2MASX J01305169-2242422',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,22.7154583,-22.71167,0.022,NULL,35176638258,549634972,8588046,14.2),(17182,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,'R',17182,37.83,0.16,368,4087,70,NULL,NULL,'2MASX J01305362+0015261',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000084,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,22.723333,0.25742,0.005,NULL,66974895031,1046482734,16351292,17.8),(17183,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17183,32.81,0.4,36.5,4088,NULL,NULL,'mean','IC 1711',NULL,'2007A&A...465...71T',2007,1,2.97,NULL,'G',0.000016,NULL,'14.41',0.59,'Sb',NULL,NULL,NULL,NULL,1,22.73025,17.18856,0.157,NULL,67424341114,1053505329,16461020,14.41),(17184,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17184,32.94,0.47,38.7,4088,NULL,NULL,'H','IC 1711',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17185,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17185,32.98,0.45,39.4,4088,NULL,NULL,'K','IC 1711',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17186,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17186,33.02,0.46,40.3,4088,NULL,NULL,'J','IC 1711',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17187,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17187,33.19,0.43,43.5,4088,75,NULL,'3.6 micron, color + selection bias corrected','IC 1711',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17188,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,'R',17188,33.2,0.4,43.6,4088,75,NULL,NULL,'IC 1711',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17189,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17189,33.26,0.43,45,4088,75,NULL,'3.6 micron, color corrected','IC 1711',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17190,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17190,33.42,0.2,48.3,4088,74.4,NULL,NULL,'IC 1711',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17191,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,'R',17191,33.49,0.49,49.9,4088,75,NULL,'IR','IC 1711',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17192,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17192,33.55,0.44,51.2,4088,NULL,NULL,'Malmquist cor.','IC 1711',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17193,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17193,33.64,0.42,53.4,4088,NULL,NULL,NULL,'IC 1711',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17194,'GRB','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,'R',17194,46.16,1.47,4530,4089,NULL,NULL,NULL,'GRB 081222',2.77,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,22.740375,-34.09528,NULL,NULL,38304544460,598508507,9351695,NULL),(17195,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17195,33.75,0.8,56.2,4090,75,NULL,'CF, r','UGC 01083',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000003,NULL,'14.39',0.7,'Sb',NULL,NULL,NULL,NULL,1,22.7425,14.10833,0.129,NULL,67413366577,1053333852,16458341,14.39),(17196,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17196,33.99,0.46,62.7,4090,NULL,NULL,'Malmquist cor.','UGC 01083',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17197,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17197,34.16,0.2,67.9,4090,74.4,NULL,NULL,'UGC 01083',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17198,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17198,34.17,0.43,68.2,4090,NULL,NULL,NULL,'UGC 01083',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17199,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17199,34.49,0.38,79.2,4090,75,NULL,'CF, r, raw','UGC 01083',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17200,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17200,34.62,0.38,84,4090,75,NULL,'CF, r, inv','UGC 01083',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17201,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17201,34.67,0.38,85.8,4090,75,NULL,'CF, r, cor','UGC 01083',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17202,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,'R',17202,37.66,0.46,340,4091,70,NULL,NULL,'2MASX J01310047-0930402',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000085,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,22.751875,-9.51128,0.121,NULL,35281221905,551269092,8613579,17.5),(17203,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,'R',17203,34.85,0.46,93.2,4092,70,NULL,NULL,'2MASX J01310103+1303155',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000066,NULL,'15.6g',0.46,NULL,NULL,NULL,NULL,NULL,1,22.7543333333,13.05436,0.129,NULL,67599244231,1056238191,16503721,15.6),(17204,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,'R',17204,35.15,0.46,107,4093,70,NULL,NULL,'CGCG 436-067',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000095,NULL,'15.3g',0.38,'E0',NULL,NULL,NULL,NULL,1,22.7698333333,13.64967,0.129,NULL,67597022724,1056203480,16503179,15.3),(17205,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,'R',17205,38.87,0.46,595,4094,70,NULL,NULL,'2MASX J01310517-0058418',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00009,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,22.771417,-0.97831,0.078,NULL,34964135831,546314622,8536165,17.7),(17206,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,'R',17206,38.09,0.27,415,4095,70,NULL,NULL,'2MASX J01310620+0100412',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00009,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,22.7757916667,1.01153,0.005,NULL,66975406516,1046490726,16351417,17.3),(17207,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 19065','R',17207,38.76,0.14,489,4096,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 19065',0.154496,'2014arXiv1401.3317S',2014,1,0.09,NULL,'G',NULL,'PHOT','20.2g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,22.7778333333,0.48517,0.005,NULL,66974815573,1046481493,16351273,20.2),(17208,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 19065','R',17208,39.07,0.2,565,4096,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 19065',0.154496,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17209,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 19065',NULL,17209,40.6,0.07,1320,4096,70,NULL,'SN photometric redshift distance, z photo =0.374 +/- 0.015','SDSS-II SN 19065',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17210,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,'R',17210,37.36,0.46,296,4097,70,NULL,NULL,'2MASX J01310698+1429235',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000096,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,22.7792083333,14.48981,0.121,NULL,67413962909,1053343170,16458487,16.9),(17211,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17211,37.37,0.57,298,4098,70,NULL,NULL,'2MASX J01310838-5113558',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'16.30',0.37,'E',NULL,NULL,NULL,NULL,1,22.785,-51.23211,NULL,NULL,38221992652,597218635,9331541,16.3),(17212,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,'R',17212,37.83,0.16,368,4099,70,NULL,NULL,'2MASX J01310981+0024152',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000089,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,22.790875,0.40433,0.005,NULL,66974819670,1046481557,16351274,17.9),(17213,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17213,36.67,0.53,216,4100,70,NULL,NULL,'2MASX J01311356-1120538',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.50',NULL,NULL,NULL,NULL,NULL,NULL,1,22.8063333333,-11.34822,0.098,NULL,35269260020,551082187,8610659,16.5),(17214,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17214,34.87,0.51,94.2,4101,70,NULL,NULL,'ESO 476- G 018',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000037,NULL,'15.38',0.8,'S0       poss. LINER','in a pair',NULL,NULL,NULL,1,22.808333,-26.85958,0.032,NULL,34709554926,542336795,8474012,15.38),(17215,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17215,35.14,0.2,107,4102,74.4,NULL,NULL,'2MASX J01311452+1402014',NULL,'2013AJ....146...86T',2013,1,0.81,NULL,'G',0.000059,NULL,'16.2g',0.27,'Scd',NULL,NULL,NULL,NULL,1,22.8103333333,14.03353,0.129,NULL,67413439622,1053334994,16458359,16.2),(17216,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17216,35.34,0.47,117,4102,NULL,NULL,NULL,'2MASX J01311452+1402014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17217,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17217,35.43,0.45,122,4102,NULL,NULL,'Malmquist cor.','2MASX J01311452+1402014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17218,'BL Lac Luminosity','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17218,37.59,NULL,329,4103,NULL,NULL,'Min. z = 0.08','1FGL J0131.2+6121',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,22.823,61.352,NULL,NULL,65971378813,1030802793,16106293,NULL),(17219,'SBF','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17219,31.51,0.14,20,4104,74.4,NULL,NULL,'NGC 0584',NULL,'2013AJ....146...86T',2013,1,4.2,'Position in 1996ApJS..106....1W is 12 arcsec south of the nucleus.','G',0.000011,NULL,'11.44',2.3,'E4','X-ray-faint group member',NULL,NULL,NULL,1,22.8364583,-6.86806,0.129,NULL,35270826663,551106666,8611041,11.44),(17220,'SBF','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17220,31.52,0.2,20.1,4104,NULL,NULL,'I','NGC 0584',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17221,'SBF','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17221,31.52,0.2,20.1,4104,NULL,NULL,NULL,'NGC 0584',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17222,'SBF','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17222,31.59,0.2,20.8,4104,NULL,NULL,'Malmquist cor.','NGC 0584',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17223,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17223,31.21,0.4,17.5,4104,75,NULL,'Edat, raw','NGC 0584',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17224,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17224,31.41,0.4,19.1,4104,75,NULL,'Edat, cor','NGC 0584',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17225,'Faber-Jackson','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17225,30.58,0.63,13.1,4104,95,NULL,'Michard 1979b, c','NGC 0584',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17226,'Faber-Jackson','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17226,30.92,0.24,15.3,4104,95,NULL,'Weighted Mean','NGC 0584',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17227,'Faber-Jackson','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17227,31.02,0.32,16,4104,95,NULL,'de Vaucouleurs','NGC 0584',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17228,'Faber-Jackson','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17228,31.11,0.46,16.7,4104,95,NULL,'Michard 1979a','NGC 0584',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17229,'Faber-Jackson','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,'R',17229,31.57,NULL,20.6,4104,NULL,NULL,'LEDA [April 2006]','NGC 0584',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17230,'Faber-Jackson','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17230,32.12,0.81,26.5,4104,55,NULL,'Visvanathan & Sandage 1979','NGC 0584',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17231,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17231,31.05,0.41,16.2,4104,NULL,NULL,NULL,'NGC 0584',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17232,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17232,31.38,0.41,18.9,4104,NULL,NULL,'Malmquist cor.','NGC 0584',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17233,'Tertiary','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17233,31.24,0.22,17.7,4104,95,NULL,NULL,'NGC 0584',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17234,'Tully est','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17234,31.84,0.8,23.4,4104,75,NULL,'B','NGC 0584',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17235,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17235,31.48,0.45,19.8,4104,NULL,NULL,'K','NGC 0584',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17236,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17236,31.84,0.4,23.4,4104,NULL,NULL,'mean','NGC 0584',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17237,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 03596','RN',17237,37.94,0.28,346,4105,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 03596',0.118097,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17238,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 03596','RN',17238,38.98,0.35,560,4105,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 03596',0.118097,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17239,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,'R',17239,36.31,0.46,183,4106,70,NULL,NULL,'2MASX J01312182-0035432',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000094,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,22.840917,-0.59539,0.021,NULL,34964700120,546323439,8536303,16.3),(17240,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17240,35.47,0.55,124,4107,70,NULL,NULL,'2MASX J01312288-0040272',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.000066,NULL,'15.7g',0.25,'S0',NULL,NULL,NULL,NULL,1,22.8455417,-0.67414,0.021,NULL,34964694985,546323359,8536302,15.7),(17241,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17241,36.35,0.5,187,4108,70,NULL,NULL,'2MASX J01312491-2011204',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.000103,NULL,'16.01',0.51,NULL,NULL,NULL,NULL,NULL,1,22.853875,-20.18892,0.036,NULL,35226770369,550418287,8600285,16.01),(17242,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SN 2005ib',NULL,17242,40.79,0.17,1040,4109,74.2,NULL,'SALT 2, SN 5737 SDSS','SDSS J013125.72-003611.9',0.39,'2010ApJ...716..712A',2010,1,0.05,NULL,'G',0.0005,NULL,'22.3g',0.02,NULL,NULL,NULL,NULL,NULL,1,22.8572083,-0.60333,0.021,NULL,34964699665,546323432,8536303,22.3),(17243,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SN 2005ib',NULL,17243,40.41,0.17,1210,4109,70,NULL,'Hubble residual -0.27 for z0.39300','SDSS J013125.72-003611.9',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17244,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SN 2005ib',NULL,17244,41.43,0.2,1390,4109,70,NULL,'SN 5737 SDSS, SALT 2','SDSS J013125.72-003611.9',0.39,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17245,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SN 2005ib',NULL,17245,41.43,0.24,1390,4109,65,NULL,'SALT2','SDSS J013125.72-003611.9',0.39,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17246,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 05737','R',17246,41.46,0.22,1410,4109,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ib','SDSS J013125.72-003611.9',0.393,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17247,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SN 2005ib',NULL,17247,41.59,0.16,1500,4109,65,NULL,'MLCS2k2','SDSS J013125.72-003611.9',0.39,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17248,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 05737','R',17248,41.62,0.29,1510,4109,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ib','SDSS J013125.72-003611.9',0.393,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17249,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SN 2005ib',NULL,17249,41.73,0.07,1590,4109,70,NULL,'SALT 2, SN 5737 SDSS','SDSS J013125.72-003611.9',0.39,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17250,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,'R',17250,38.09,0.27,415,4110,70,NULL,NULL,'SDSS J013126.52+010945.6',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,22.8605416667,1.16267,0.005,NULL,66975212142,1046487689,16351370,18.6),(17251,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SN 1999dk',NULL,17251,33.14,0.17,41.8,4111,74.2,NULL,'SALT 2','UGC 01087',0.01496,'2010ApJ...716..712A',2010,1,1.5,NULL,'G',0.000003,NULL,'14.4B',1.4,'SA(rs)c',NULL,NULL,NULL,NULL,1,22.860833,14.2775,0.121,NULL,67413410556,1053334539,16458352,14.4),(17252,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SN 1999dk',NULL,17252,33.79,0.25,56.4,4111,72,NULL,NULL,'UGC 01087',0.01496,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17253,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SN 1999dk',NULL,17253,33.82,0.21,57.1,4111,70,NULL,'SALT 2','UGC 01087',0.01496,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17254,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SN 1999dk',NULL,17254,33.85,0.08,58.9,4111,74.4,NULL,NULL,'UGC 01087',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17255,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SN 1999dk',NULL,17255,33.87,0.17,59.4,4111,70.8,NULL,NULL,'UGC 01087',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17256,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SN 1999dk',NULL,17256,34.01,0.26,62.5,4111,65,NULL,'SALT2','UGC 01087',0.01496,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17257,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SN 1999dk',NULL,17257,34.03,0.18,63,4111,70,NULL,'SALT','UGC 01087',0.01496,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17258,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SN 1999dk',NULL,17258,34.16,0.06,66.8,4111,72,NULL,NULL,'UGC 01087',0.01496,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17259,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SN 1999dk',NULL,17259,34.16,0.23,66.9,4111,65,NULL,'MLCS17','UGC 01087',0.01496,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17260,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SN 1999dk',NULL,17260,34.17,0.14,68.2,4111,60,NULL,NULL,'UGC 01087',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17261,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SN 1999dk',NULL,17261,34.22,0.24,68.6,4111,65,NULL,'MLCS31','UGC 01087',0.01496,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17262,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SN 1999dk',NULL,17262,34.27,0.1,69.5,4111,65,NULL,'MLCS2k2','UGC 01087',0.01496,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17263,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SN 1999dk',NULL,17263,34.24,0.09,70.5,4111,65,NULL,'LC','UGC 01087',NULL,'2001AJ....122.1616K',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17264,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SN 1999dk',NULL,17264,34.37,0.03,73.9,4111,70,NULL,'SALT 2','UGC 01087',0.01496,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17265,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SN 1999dk',NULL,17265,34.43,0.26,75.8,4111,65,NULL,NULL,'UGC 01087',0.01496,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17266,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SN 1999dk',NULL,17266,34.45,0.18,77.6,4111,65,NULL,'MLCS','UGC 01087',NULL,'2001AJ....122.1616K',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17267,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17267,33.67,0.67,54.3,4111,NULL,NULL,'Malmquist cor.','UGC 01087',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17268,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17268,33.85,0.08,58.9,4111,74.4,NULL,NULL,'UGC 01087',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17269,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17269,33.89,0.61,60,4111,NULL,NULL,NULL,'UGC 01087',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17270,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,'R',17270,38.09,0.27,415,4112,70,NULL,NULL,'2MASX J01312761+0109470',NULL,'2015arXiv151105856S',2015,1,0.58,'May be a resolved component of PMN J0131+0110.','G',0.000105,NULL,'15.7g',0.52,'AGN',NULL,NULL,NULL,NULL,1,22.865083,1.16306,0.005,NULL,66975212268,1046487691,16351370,15.7),(17271,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 10142','RN',17271,39.1,0.19,613,4113,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10142',0.077962,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17272,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 10142','RN',17272,39.57,0.23,761,4113,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10142',0.077962,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17273,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SN 2005jz',NULL,17273,39.83,0.12,808,4114,74.2,NULL,'SALT 2','SDSS J013127.74-003743.6',0.144341,'2010ApJ...716..712A',2010,1,0.12,NULL,'G',0.000045,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,22.865625,-0.62878,0.021,NULL,34964687479,546323241,8536300,18.7),(17274,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SN 2005jz',NULL,17274,39.84,0.1,931,4114,70,NULL,'Hubble residual -0.04 for z0.25300','SDSS J013127.74-003743.6',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17275,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 05736','R',17275,40.46,0.2,1080,4114,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005jz','SDSS J013127.74-003743.6',0.144341,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17276,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SN 2005jz',NULL,17276,40.49,0.13,1090,4114,70,NULL,'SDSS-II SN 05736, SALT 2','SDSS J013127.74-003743.6',0.144341,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17277,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SN 2005jz',NULL,17277,40.51,0.08,1110,4114,65,NULL,'SALT2','SDSS J013127.74-003743.6',0.144341,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17278,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 05736','R',17278,40.59,0.09,1150,4114,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005jz','SDSS J013127.74-003743.6',0.144341,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17279,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SN 2005jz',NULL,17279,40.67,0.08,1190,4114,65,NULL,'MLCS2k2','SDSS J013127.74-003743.6',0.144341,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17280,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SN 2005jz',NULL,17280,40.74,0.04,1230,4114,70,NULL,'SDSS-II SN 05736','SDSS J013127.74-003743.6',0.144341,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17281,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,'R',17281,37.83,0.16,368,4115,70,NULL,NULL,'2MASX J01312808+0038060',NULL,'2015arXiv151105856S',2015,1,0.11,NULL,'G',0.000102,NULL,'17.2g',0.1,NULL,NULL,NULL,NULL,NULL,1,22.866875,0.63517,0,NULL,66975549314,1046492958,16351452,17.2),(17282,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,'R',17282,37.83,0.16,368,4116,70,NULL,NULL,'2MASX J01312835+0032060',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000113,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,22.86825,0.53497,0.009,NULL,66975527788,1046492621,16351447,17.2),(17283,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 15805','RN',17283,41.09,0.28,1280,4117,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15805',0.295372,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17284,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 15805','RN',17284,41.36,0.39,1450,4117,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15805',0.295372,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17285,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 04857',NULL,17285,40.37,0.36,1180,4118,70,NULL,'SN photometric redshift distance, z photo =0.328 +/- 0.075','SDSS-II SN 04857',NULL,'2011ApJ...738..162S',2011,1,0.03,NULL,'G',NULL,'PHOT','23.5g',0.01,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,22.87925,-0.15508,0.025,NULL,34963870314,546310473,8536101,23.5),(17286,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 04857','R',17286,42.81,0.33,2410,4118,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 04857',0.516965,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17287,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 18010',NULL,17287,40.07,0.29,1030,4119,70,NULL,'SN photometric redshift distance, z photo =0.279 +/- 0.048','SDSS-II SN 18010',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','22.3g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,22.881917,0.98878,0,NULL,66975429128,1046491080,16351423,22.3),(17288,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 18010','R',17288,41.82,0.39,1770,4119,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18010',0.308534,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17289,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 18010','R',17289,41.91,0.33,1840,4119,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18010',0.308534,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17290,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,'R',17290,37.83,0.16,368,4120,70,NULL,NULL,'4C +00.05',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000112,NULL,'15.7g',0.49,'E;BrClG        AGN',NULL,NULL,'radio jet',NULL,1,22.887167,0.55597,0,NULL,66975520460,1046492507,16351445,15.7),(17291,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 15795',NULL,17291,39.76,0.86,897,4121,70,NULL,'SN photometric redshift distance, z photo =0.237 +/- 0.143','SDSS-II SN 15795',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.5g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,22.891625,0.92439,0,NULL,66975378218,1046490284,16351410,21.5),(17292,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 15795','R',17292,42.54,0.36,2130,4121,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15795',0.509764,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17293,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 15795',NULL,17293,42.49,0.25,3150,4121,70,NULL,'SALT 2','SDSS-II SN 15795',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17294,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 15795',NULL,17294,42.64,0.25,3370,4121,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15795',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17295,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17295,34.67,0.42,85.8,4122,NULL,NULL,NULL,'ESO 296- G 037',NULL,'2009ApJS..182..474S',2009,1,1.17,NULL,'G',0.000033,NULL,'15.92',0.3,'Sb',NULL,NULL,NULL,NULL,1,22.894417,-41.53122,NULL,NULL,38383714269,599745535,9371023,15.92),(17296,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17296,34.68,0.42,86.3,4122,NULL,NULL,'Malmquist cor.','ESO 296- G 037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17297,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17297,34.71,0.2,87.5,4122,74.4,NULL,NULL,'ESO 296- G 037',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17298,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17298,33.42,0.8,48.3,4123,75,NULL,'W91PP, r','UGC 01086',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000017,NULL,'14.97',0.4,'S?',NULL,NULL,NULL,NULL,1,22.89475,34.78283,0.157,NULL,67764359033,1058818109,16544032,14.97),(17299,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17299,33.82,0.38,57.9,4123,75,NULL,'W91PP, r, inv','UGC 01086',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17300,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17300,33.86,0.38,59.1,4123,75,NULL,'W91PP, r, raw','UGC 01086',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17301,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17301,34.09,0.38,65.8,4123,75,NULL,'W91PP, r, cor','UGC 01086',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17302,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,'R',17302,37.83,0.46,369,4124,70,NULL,NULL,'SDSS J013136.08+001955.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000054,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,22.9003333333,0.33217,0.009,NULL,66974846223,1046481972,16351280,18.4),(17303,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17303,35.11,0.46,105,4125,70,NULL,NULL,'FAIRALL 0700',NULL,'2014MNRAS.445.2677S',2014,1,0.97,NULL,'G',0.000133,NULL,'14.76',0.55,'E',NULL,NULL,NULL,NULL,1,22.9128333333,-42.36625,NULL,NULL,38386109633,599782963,9371608,14.76),(17304,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,'R',17304,37.83,0.16,368,4126,70,NULL,NULL,'2MASX J01314039+0031246',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000089,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,22.9182917,0.52342,0.009,NULL,66975522196,1046492534,16351445,17.6),(17305,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 17987','RN',17305,42.24,0.19,1800,4127,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 17987',0.563147,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17306,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17306,33.92,0.45,60.7,4128,NULL,NULL,'K','NGC 0585',NULL,'2007A&A...465...71T',2007,1,2.64,NULL,'G',0.000063,NULL,'13.8g',0.56,'Sa: sp','in a radial-velocity based grouping',NULL,NULL,NULL,1,22.925583,-0.93331,0.078,NULL,34964187389,546315427,8536178,13.8),(17307,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17307,33.93,0.47,61,4128,NULL,NULL,'H','NGC 0585',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17308,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17308,34.02,0.46,63.6,4128,NULL,NULL,'J','NGC 0585',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17309,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,'R',17309,34.14,0.49,67.3,4128,75,NULL,'IR','NGC 0585',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17310,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17310,34.34,0.4,73.8,4128,NULL,NULL,'mean','NGC 0585',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17311,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 20033','R',17311,40.32,0.22,926,4129,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20033',0.253644,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,22.9302083,-0.73192,0.013,NULL,34964655532,546322742,8536292,NULL),(17312,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 20033',NULL,17312,39.85,0.32,934,4129,70,NULL,'SN photometric redshift distance, z photo =0.248 +/- 0.046','SDSS-II SN 20033',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17313,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 20033','R',17313,40.47,0.13,992,4129,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20033',0.253644,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17314,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 20033',NULL,17314,40.15,0.11,1070,4129,70,NULL,'SALT 2','SDSS-II SN 20033',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17315,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 20033',NULL,17315,40.17,0.11,1080,4129,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20033',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17316,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,'R',17316,37.83,0.16,368,4130,70,NULL,NULL,'2MASX J01315259+0041296',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000086,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,22.969167,0.6915,0,NULL,66975663869,1046494747,16351480,17.8),(17317,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 09824','RN',17317,38.98,0.86,579,4131,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 09824',0.080466,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17318,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 09824','RN',17318,39.85,2.03,866,4131,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 09824',0.080466,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17319,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,'R',17319,36.59,0.46,208,4132,70,NULL,NULL,'SDSS J013154.59+135315.8',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000077,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,22.9775,13.88772,0.137,NULL,67413266135,1053332283,16458316,16.9),(17320,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 13940','R',17320,40.05,0.3,829,4133,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13940',0.234956,'2014arXiv1401.3317S',2014,1,0.11,NULL,'G',NULL,'PHOT','19.6g',0.08,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,22.979625,-0.45244,0.013,NULL,34964716915,546323701,8536307,19.6),(17321,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 13940','R',17321,40.33,0.23,943,4133,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13940',0.234956,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17322,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 13940',NULL,17322,40.68,0.25,1370,4133,70,NULL,'SN photometric redshift distance, z photo =0.392 +/- 0.062','SDSS-II SN 13940',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17323,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17323,33.54,0.8,51,4134,75,NULL,'W91PP, r','NGC 0582',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000013,NULL,'14.1',0.6,'SBb','in a pair',NULL,NULL,NULL,1,22.991875,33.47653,0.157,NULL,67777956895,1059030576,16547352,14.1),(17324,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17324,33.54,0.8,51,4134,75,NULL,'HMCL, I','NGC 0582',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17325,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17325,33.55,0.8,51.3,4134,75,NULL,'CF, r','NGC 0582',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17326,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17326,33.59,0.8,52.2,4134,75,NULL,'W91CL, r','NGC 0582',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17327,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17327,33.64,0.4,53.4,4134,75,NULL,'HMCL, I, raw','NGC 0582',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17328,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17328,33.79,0.38,57.3,4134,75,NULL,'W91CL, r, raw','NGC 0582',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17329,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17329,33.81,0.47,57.9,4134,NULL,NULL,'H','NGC 0582',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17330,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17330,33.82,0.38,58,4134,75,NULL,'W91PP, r, raw','NGC 0582',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17331,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17331,33.82,0.46,58.2,4134,NULL,NULL,'J','NGC 0582',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17332,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17332,33.84,0.4,58.7,4134,75,NULL,'HMCL, I, inv','NGC 0582',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17333,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17333,33.86,0.45,59.2,4134,NULL,NULL,'K','NGC 0582',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17334,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,'R',17334,33.88,0.49,59.6,4134,75,NULL,'IR','NGC 0582',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17335,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17335,33.89,0.4,60.1,4134,NULL,NULL,'mean','NGC 0582',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17336,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17336,33.95,0.38,61.7,4134,75,NULL,'W91CL, r, inv','NGC 0582',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17337,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17337,33.95,0.4,61.8,4134,75,NULL,'HMCL, I, cor','NGC 0582',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17338,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17338,33.96,0.2,61.9,4134,74.4,NULL,NULL,'NGC 0582',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17339,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17339,33.96,0.38,62,4134,75,NULL,'CF, r, raw','NGC 0582',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17340,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17340,33.98,0.43,62.6,4134,75,NULL,'3.6 micron, color corrected','NGC 0582',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17341,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17341,33.99,0.09,62.9,4134,NULL,NULL,NULL,'NGC 0582',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17342,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17342,34.01,0.38,63.5,4134,75,NULL,'W91CL, r, cor','NGC 0582',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17343,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17343,34.02,0.38,63.5,4134,75,NULL,'W91PP, r, inv','NGC 0582',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17344,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17344,34.05,0.38,64.6,4134,75,NULL,'W91PP, r, cor','NGC 0582',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17345,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17345,34.12,0.43,66.8,4134,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0582',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17346,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17346,34.13,0.38,67.1,4134,75,NULL,'CF, r, inv','NGC 0582',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17347,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17347,34.15,0.38,67.7,4134,75,NULL,'CF, r, cor','NGC 0582',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17348,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17348,35.55,0.48,129,4135,70,NULL,NULL,'LCRS B012951.1-415648',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00015,NULL,'16.43',1,'(R)SAB0^0',NULL,NULL,NULL,NULL,1,23.00775,-41.68994,NULL,NULL,38385770831,599777669,9371526,16.43),(17349,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 20142','R',17349,40.9,0.23,1150,4136,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007qg','SN 2007qg',0.316,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,23.0082083,-0.42972,0.013,NULL,34964711992,546323624,8536306,NULL),(17350,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 20142','R',17350,40.98,0.13,1200,4136,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007qg','SN 2007qg',0.316,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17351,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 16237','R',17351,41.07,0.21,1250,4137,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J013202.50-003724.6',0.313153,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',NULL,'PHOT','21.6g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,23.0104583,-0.6235,0.013,NULL,34964733716,546323964,8536311,21.6),(17352,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 16237','R',17352,41.35,0.14,1420,4137,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J013202.50-003724.6',0.313153,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17353,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 16237',NULL,17353,40.94,0.11,1540,4137,70,NULL,'SALT 2','SDSS J013202.50-003724.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17354,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 16237',NULL,17354,40.98,0.11,1570,4137,70,NULL,'SALT 2, Malmquist cor.','SDSS J013202.50-003724.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17355,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,'R',17355,37.92,0.46,384,4138,70,NULL,NULL,'2MASX J01320726+1306228',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000087,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,23.0301666667,13.10625,0.137,NULL,67599223182,1056237862,16503716,17.5),(17356,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 20562','R',17356,41.53,0.21,1510,4139,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20562',0.337542,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,'PHOT','21.1g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,23.0335416667,-0.42028,0.013,NULL,34964712842,546323638,8536306,21.1),(17357,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 20562','R',17357,41.61,0.3,1570,4139,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20562',0.337542,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17358,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 20562',NULL,17358,41.48,0.18,1980,4139,70,NULL,'SALT 2','SDSS-II SN 20562',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17359,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 20562',NULL,17359,41.52,0.18,2010,4139,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20562',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17360,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 20562',NULL,17360,41.59,0.01,2080,4139,70,NULL,'SN photometric redshift distance, z photo =0.697 +/- 0.003','SDSS-II SN 20562',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17361,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17361,34.93,0.69,96.7,4140,100,NULL,'mid-IR','UGC 01098',NULL,'2013ApJ...771...88L',2013,1,0.9,NULL,'G',0.000033,NULL,'14.67',0.5,'SBc+           LINER',NULL,NULL,NULL,'Sy ?',1,23.0670833333,21.41081,0.177,NULL,67390138589,1052970915,16452670,14.67),(17362,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 18459',NULL,17362,37.25,0.61,281,4141,70,NULL,'SN photometric redshift distance, z photo =0.068 +/- 0.023','SDSS-II SN 18459',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.6g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,23.0752083,0.06678,0.025,NULL,66974724439,1046480069,16351251,21.6),(17363,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 18459','R',17363,40.87,0.17,1080,4141,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18459',0.384698,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17364,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 18459','R',17364,41.63,0.25,1530,4141,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18459',0.384698,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17365,'Magnitude','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17365,36.51,0.13,200,4142,100,NULL,NULL,'ABELL 2923',NULL,'1998A&A...337...31R',1998,1,NULL,'Katgert (1996,A&A,310,8) identifies multiple redshift systems in this cluster.','GClstr',NULL,NULL,NULL,NULL,'I-II   [BM];RI [A]',NULL,NULL,NULL,NULL,1,23.0752917,-31.09328,NULL,NULL,38314389772,598662340,9354099,NULL),(17366,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 20514','R',17366,41.35,0.23,1330,4143,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20514',0.404404,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,23.0760417,-0.75533,0.013,NULL,34964071557,546313618,8536150,NULL),(17367,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 20514',NULL,17367,40.67,0.46,1360,4143,70,NULL,'SN photometric redshift distance, z photo =0.389 +/- 0.125','SDSS-II SN 20514',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17368,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 20514','R',17368,41.76,0.33,1600,4143,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20514',0.404404,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17369,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 20514',NULL,17369,41.77,0.21,2260,4143,70,NULL,'SALT 2','SDSS-II SN 20514',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17370,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 20514',NULL,17370,41.84,0.21,2330,4143,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20514',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17371,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17371,36.09,0.48,165,4144,70,NULL,NULL,'ESO 542- G 023',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'16',0.5,'S0',NULL,NULL,NULL,NULL,1,23.083083,-20.82903,0.032,NULL,35170322632,549536291,8586504,16),(17372,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17372,35.52,0.54,127,4145,70,NULL,NULL,'MCG -01-05-002',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00014,NULL,'15.55',0.5,'SA(s)b:','Compact group member',NULL,NULL,NULL,1,23.085375,-7.85956,0.085,NULL,35273522169,551148783,8611699,15.55),(17373,'Magnitude','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17373,36.51,0.13,200,4146,100,NULL,NULL,'SARS 022.51402-31.34852',NULL,'1998A&A...337...31R',1998,1,0.6,NULL,'G',0.000127,NULL,'15.75',0.47,'E',NULL,NULL,NULL,NULL,1,23.0895,-31.09231,NULL,NULL,38314390007,598662343,9354099,15.75),(17374,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17374,36.81,0.67,230,4147,70,NULL,NULL,'MCG -01-05-003',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.00015,NULL,'15.97',0.6,'E0             AGN?','Compact group member',NULL,NULL,NULL,1,23.0929583,-7.87319,0.085,NULL,35273513099,551148642,8611697,15.97),(17375,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 13917','RN',17375,40.91,0.19,1320,4148,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13917',0.15338,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17376,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 13917','RN',17376,41.47,0.23,1710,4148,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13917',0.15338,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17377,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17377,33.57,0.43,51.7,4149,NULL,NULL,NULL,'ESO 353- G 013',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.90',0.5,'S...',NULL,NULL,NULL,NULL,1,23.1110417,-34.60919,NULL,NULL,38304573059,598508954,9351702,14.9),(17378,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17378,33.61,0.2,52.7,4149,74.4,NULL,NULL,'ESO 353- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17379,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17379,33.98,0.36,62.5,4149,NULL,NULL,'Malmquist cor.','ESO 353- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17380,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 16086','RN',17380,40.12,0.19,932,4150,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16086',0.133834,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17381,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 16086','RN',17381,40.53,0.28,1120,4150,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16086',0.133834,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17382,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17382,32.03,0.4,25.5,4151,75,NULL,'B','UGC 01102',NULL,'1988NBGC.C....0000T',1988,1,NULL,'Contains the emission line region UM 111.','GPair',0.000003,NULL,NULL,NULL,'Pec',NULL,NULL,NULL,NULL,1,23.122,4.59831,0.049,NULL,67519133856,1054986466,16484163,NULL),(17383,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 07502','RN',17383,42.14,0.39,1850,4152,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07502',0.449808,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17384,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 07502','RN',17384,42.27,0.5,1970,4152,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07502',0.449808,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17385,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 07502','N',17385,42.12,0.3,2650,4152,70,NULL,'SALT 2','SDSS-II SN 07502',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17386,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 07502','N',17386,42.21,0.3,2770,4152,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 07502',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17387,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17387,33.67,0.8,54.3,4153,75,NULL,'W91PP, r','NGC 0587',NULL,'1997ApJS..109..333W',1997,1,2.2,'Sometimes identified as IC 1713, but that is a star.','G',0.000017,NULL,'13.58',0.8,'SAB(s)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,23.138875,35.35858,0.133,NULL,67764981066,1058827829,16544184,13.58),(17388,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17388,33.71,0.38,55.2,4153,75,NULL,'W91PP, r, raw','NGC 0587',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17389,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17389,33.76,0.47,56.4,4153,NULL,NULL,'H','NGC 0587',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17390,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17390,33.76,0.46,56.5,4153,NULL,NULL,'J','NGC 0587',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17391,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17391,33.82,0.45,58.1,4153,NULL,NULL,'K','NGC 0587',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17392,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17392,33.91,0.38,60.5,4153,75,NULL,'W91PP, r, inv','NGC 0587',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17393,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17393,33.96,0.4,61.9,4153,NULL,NULL,'mean','NGC 0587',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17394,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17394,33.99,0.38,62.7,4153,75,NULL,'W91PP, r, cor','NGC 0587',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17395,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 20750',NULL,17395,38.73,1.13,558,4154,70,NULL,'SN photometric redshift distance, z photo =0.140 +/- 0.109','SDSS-II SN 20750',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,23.140625,0.41275,0.025,NULL,66975655191,1046494612,16351478,NULL),(17396,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 20750','R',17396,40.86,0.27,1140,4154,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20750',0.305661,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17397,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 20750','R',17397,41.27,0.22,1380,4154,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20750',0.305661,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17398,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 20750',NULL,17398,40.76,0.18,1420,4154,70,NULL,'SALT 2','SDSS-II SN 20750',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17399,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 20750',NULL,17399,40.79,0.18,1440,4154,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20750',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17400,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 00752','RN',17400,43.02,0.23,2830,4155,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00752',0.41656,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17401,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 00752','RN',17401,43.35,0.19,3310,4155,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 00752',0.41656,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17402,'SNIa','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 14883',NULL,17402,39.55,0.71,813,4156,70,NULL,'SN photometric redshift distance, z photo =0.212 +/- 0.097','SDSS-II SN 14883',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,23.1518333333,-0.73756,0.013,NULL,34964558079,546321219,8536269,NULL),(17403,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,'R',17403,37.42,0.46,305,4157,70,NULL,NULL,'2MASX J01323687+0002077',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000089,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,23.1537917,0.03547,0.033,NULL,66974715472,1046479929,16351248,16.6),(17404,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17404,35.73,NULL,140,4158,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01103',NULL,'2010Ap&SS.325..163P',2010,1,1.03,NULL,'G',0.000038,NULL,'17.',0.11,'Scd',NULL,NULL,NULL,NULL,1,23.1662917,11.82939,0.153,NULL,67528580619,1055134072,16486469,17),(17405,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17405,35.75,NULL,141,4158,NULL,NULL,'Dipole + Quadrupole','UGC 01103',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17406,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,'R',17406,35.77,0.49,142,4158,75,NULL,'IR','UGC 01103',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17407,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17407,35.77,NULL,143,4158,NULL,NULL,'Dipole','UGC 01103',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17408,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17408,36.25,NULL,178,4158,NULL,NULL,NULL,'UGC 01103',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17409,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17409,33.95,0.49,61.6,4159,70,NULL,NULL,'NGC 0589',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00011,NULL,'14.89',0.9,'(R)SB(r)0/a',NULL,NULL,NULL,NULL,1,23.1664166667,-12.04269,0.061,NULL,35400222518,553128476,8642632,14.89),(17410,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 01000','RN',17410,39.13,0.2,593,4160,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 01000',0.12943,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17411,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 01000','RN',17411,39.36,0.17,658,4160,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 01000',0.12943,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17412,'Brightest Stars','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17412,29.39,0.4,7.55,4161,NULL,NULL,NULL,'UGC 01104',NULL,'1996A&AS..119..499S',1996,1,1,NULL,'G',0.000003,NULL,'14.21',0.6,'Im             HII','X-ray-faint group member',NULL,NULL,NULL,1,23.1772083,18.31711,0.121,NULL,67434361306,1053661895,16463467,14.21),(17413,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 04262','RN',17413,41.58,0.39,1700,4162,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 04262',0.221788,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17414,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 04262','RN',17414,41.66,0.3,1760,4162,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 04262',0.221788,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17415,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17415,34.92,0.65,96.5,4163,70,NULL,NULL,'2MASX J01324340-1209169',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.27',0.31,NULL,NULL,NULL,NULL,NULL,1,23.1809583,-12.15458,0.037,NULL,35400416722,553131511,8642679,16.27),(17416,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17416,34.45,0.4,77.7,4164,NULL,NULL,'mean','UGC 01039',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000037,NULL,'15.10',0.7,'Sab',NULL,NULL,NULL,NULL,1,23.1840416667,85.01411,0.389,NULL,65561105229,1024392269,16006129,15.1),(17417,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17417,34.47,0.47,78.3,4164,NULL,NULL,'H','UGC 01039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17418,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17418,34.56,0.45,81.8,4164,NULL,NULL,'K','UGC 01039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17419,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17419,34.61,0.46,83.6,4164,NULL,NULL,'J','UGC 01039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (17420,'IRAS','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17420,31.75,0.8,22.4,4165,75,NULL,'MAT, I','ESO 013- G 016',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.00001,NULL,'13.51',1.4,'SB(rs)cd',NULL,NULL,NULL,NULL,1,23.2005,-79.47431,0.289,NULL,35668062798,557313481,8708023,13.51),(17421,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17421,31.29,0.32,18.1,4165,85,NULL,'I, inv','ESO 013- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17422,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17422,31.3,0.32,18.2,4165,85,NULL,'I, raw','ESO 013- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17423,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17423,31.56,0.4,20.5,4165,73,NULL,'opt','ESO 013- G 016',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17424,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17424,31.73,0.43,22.2,4165,75,NULL,'MAT, I, raw','ESO 013- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17425,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17425,31.75,0.43,22.4,4165,75,NULL,'MAT, I, inv','ESO 013- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17426,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17426,31.78,0.62,22.7,4165,NULL,NULL,'Malmquist cor.','ESO 013- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17427,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17427,31.91,0.58,24.1,4165,NULL,NULL,NULL,'ESO 013- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17428,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17428,31.93,0.43,24.3,4165,75,NULL,'MAT, I, cor','ESO 013- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17429,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17429,31.95,0.2,24.6,4165,74.4,NULL,NULL,'ESO 013- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17430,'SNIa SDSS','2016-12-15 15:13:46','2016-12-16 11:18:49','1','SDSS-II SN 01184','RN',17430,43.31,0.22,2960,4166,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01184',0.55031,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17431,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,'R',17431,37.88,0.33,377,4167,70,NULL,NULL,'2MASX J01325162-0034405',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000089,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,23.215125,-0.57797,0.013,NULL,34964563038,546321297,8536270,16.7),(17432,'SBF','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17432,31.68,0.14,21.7,4168,74.4,NULL,NULL,'NGC 0596',NULL,'2013AJ....146...86T',2013,1,3.2,NULL,'G',0.000037,NULL,'12.50',2.1,'E+ pec:','X-ray-faint group member',NULL,NULL,NULL,1,23.217,-7.03183,0.107,NULL,35270925206,551108206,8611065,12.5),(17433,'SBF','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17433,31.69,0.1,21.8,4168,NULL,NULL,'I','NGC 0596',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17434,'SBF','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17434,31.69,0.1,21.8,4168,NULL,NULL,NULL,'NGC 0596',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17435,'SBF','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17435,31.71,0.1,21.9,4168,NULL,NULL,'Malmquist cor.','NGC 0596',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17436,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17436,31.21,0.4,17.5,4168,75,NULL,'Edat, raw','NGC 0596',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17437,'D-Sigma','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17437,31.41,0.4,19.1,4168,75,NULL,'Edat, cor','NGC 0596',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17438,'Faber-Jackson','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17438,30.92,0.32,15.3,4168,95,NULL,'de Vaucouleurs','NGC 0596',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17439,'Faber-Jackson','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17439,31.1,0.24,16.6,4168,95,NULL,'Weighted Mean','NGC 0596',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17440,'Faber-Jackson','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17440,31.55,0.63,20.4,4168,95,NULL,'Michard 1979b, c','NGC 0596',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17441,'Faber-Jackson','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17441,31.96,0.46,24.7,4168,95,NULL,'Michard 1979a','NGC 0596',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17442,'Faber-Jackson','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17442,32.15,0.81,26.9,4168,55,NULL,'Visvanathan & Sandage 1979','NGC 0596',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17443,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17443,31.32,0.41,18.3,4168,NULL,NULL,NULL,'NGC 0596',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17444,'FP','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17444,31.59,0.41,20.8,4168,NULL,NULL,'Malmquist cor.','NGC 0596',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17445,'Tertiary','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17445,31.24,0.22,17.7,4168,95,NULL,NULL,'NGC 0596',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17446,'Tully est','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17446,31.88,0.8,23.8,4168,75,NULL,'B','NGC 0596',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17447,'Tully-Fisher','2016-12-15 15:13:46','2016-12-16 11:18:49','1',NULL,NULL,17447,31.74,0.45,22.2,4168,NULL,NULL,'K','NGC 0596',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17448,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17448,32.23,0.4,27.9,4168,NULL,NULL,'mean','NGC 0596',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17449,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17449,34.02,0.47,63.7,4169,70,NULL,NULL,'NGC 0599',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00007,NULL,'13.71',1.3,'SAB0- pec:     AGN',NULL,NULL,NULL,NULL,1,23.224083,-12.19125,0.037,NULL,35400413056,553131454,8642678,13.71),(17450,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17450,38.3,0.33,457,4170,70,NULL,NULL,'2MASX J01325562-0057445',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000072,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,23.2317917,-0.96233,0.061,NULL,34967579453,546368428,8537006,18.1),(17451,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 16119','R',17451,39.49,0.19,683,4171,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16119',0.157064,'2014arXiv1401.3317S',2014,1,0.14,NULL,'G',NULL,'PHOT','19.4g',0.07,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,23.235583,-0.32917,0.013,NULL,34964604545,546321946,8536280,19.4),(17452,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 16119','R',17452,39.78,0.24,779,4171,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16119',0.157064,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17453,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 16119',NULL,17453,41.56,0.03,2050,4171,70,NULL,'SN photometric redshift distance, z photo =0.686 +/- 0.014','SDSS-II SN 16119',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17454,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17454,33.56,0.69,51.6,4172,100,NULL,'mid-IR','NGC 0594',NULL,'2013ApJ...771...88L',2013,1,1.3,NULL,'G',0.00001,NULL,'14.18',0.6,'Sbc:           HII',NULL,NULL,NULL,NULL,1,23.237125,-16.536,0.011,NULL,35198288186,549973252,8593332,14.18),(17455,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17455,34.24,0.47,70.5,4172,NULL,NULL,'H','NGC 0594',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17456,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17456,34.34,0.4,73.7,4172,NULL,NULL,'mean','NGC 0594',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17457,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17457,34.38,0.45,75.2,4172,NULL,NULL,'K','NGC 0594',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17458,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17458,34.39,0.46,75.4,4172,NULL,NULL,'J','NGC 0594',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17459,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17459,35.91,0.51,152,4173,70,NULL,NULL,'ESO 152- G 010',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'15.80',0.41,'N',NULL,NULL,NULL,NULL,1,23.2378333333,-52.71889,NULL,NULL,36123715407,564433053,8819266,15.8),(17460,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17460,37.88,0.33,377,4174,70,NULL,NULL,'2MASX J01325889-0036145',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000088,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,23.245375,-0.60406,0.017,NULL,34964565447,546321335,8536270,17.8),(17461,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17461,37.65,0.46,339,4175,70,NULL,NULL,'2MASX J01330149-0050115',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00007,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,23.2562917,-0.83644,0.017,NULL,34964047889,546313248,8536144,17.9),(17462,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17462,38.3,0.33,457,4176,70,NULL,NULL,'2MASX J01330189-0057185',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000076,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,23.257875,-0.955,0.061,NULL,34967580909,546368451,8537007,17.9),(17463,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 16472','R',17463,40.83,0.25,1120,4177,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J013302.52+001000.1',0.3097,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',0.0005,NULL,'21.6g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,23.2605,0.16672,0.033,NULL,66975093649,1046485838,16351341,21.6),(17464,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 16472','R',17464,40.93,0.19,1170,4177,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J013302.52+001000.1',0.3097,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17465,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 16472',NULL,17465,40.71,0.15,1390,4177,70,NULL,'SALT 2','SDSS J013302.52+001000.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17466,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 16472',NULL,17466,40.74,0.15,1410,4177,70,NULL,'SALT 2, Malmquist cor.','SDSS J013302.52+001000.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17467,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17467,38.35,0.46,468,4178,70,NULL,NULL,'2MASX J01330398-0824540',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000095,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,23.266833,-8.41492,0.069,NULL,35272827537,551137930,8611530,17.9),(17468,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17468,31.8,0.4,22.9,4179,75,NULL,'B','NGC 0600',NULL,'1988NBGC.C....0000T',1988,1,3.3,NULL,'G',0.000003,NULL,'13.65',2.8,'(R\')SB(rs)d    HII','X-ray-faint group member',NULL,NULL,NULL,1,23.272083,-7.31142,0.09,NULL,35270599552,551103118,8610986,13.65),(17469,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 01372','RN',17469,39.52,0.22,749,4180,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01372',0.068916,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17470,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 01372','RN',17470,39.63,0.11,790,4180,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01372',0.068916,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17471,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17471,37.15,0.46,269,4181,70,NULL,NULL,'2MASX J01330943-0858480',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000077,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,23.28925,-8.98003,0.091,NULL,35272145205,551127268,8611363,17.7),(17472,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17472,37.02,0.46,254,4182,70,NULL,NULL,'2MASX J01331282+1400227',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000091,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,23.303333,14.00617,0.125,NULL,67414415223,1053350237,16458597,16.9),(17473,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17473,36.64,0.46,213,4183,70,NULL,NULL,'MCG +00-05-005',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000109,NULL,'15.7g',0.45,'E',NULL,NULL,NULL,NULL,1,23.31225,-0.63697,0.017,NULL,34964382894,546318482,8536226,15.7),(17474,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 13258','RN',17474,40.27,0.29,896,4184,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13258',0.261257,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17475,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 13258','RN',17475,40.64,0.31,1070,4184,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13258',0.261257,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17476,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17476,35.56,0.5,130,4185,70,NULL,NULL,'AM 0131-364 NED02',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.42',NULL,NULL,NULL,NULL,NULL,NULL,1,23.320125,-36.44025,NULL,NULL,38273513167,598023643,9344119,15.42),(17477,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17477,32.64,0.4,33.7,4186,NULL,NULL,NULL,'UGC 01110',NULL,'2009AJ....138..323T',2009,1,2.02,NULL,'G',0.000003,NULL,'15.1g',0.39,'Scd(f)',NULL,NULL,NULL,NULL,1,23.323667,13.33203,0.141,NULL,67411406399,1053303224,16457862,15.1),(17478,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17478,32.64,0.39,33.7,4186,73,NULL,'opt','UGC 01110',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17479,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17479,32.73,0.2,35.2,4186,74.4,NULL,NULL,'UGC 01110',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17480,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17480,32.8,0.43,36.2,4186,75,NULL,'3.6 micron, color corrected','UGC 01110',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17481,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17481,32.83,0.43,36.9,4186,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01110',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17482,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17482,32.85,0.52,37.2,4186,NULL,NULL,NULL,'UGC 01110',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17483,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17483,32.9,0.51,38,4186,NULL,NULL,'Malmquist cor.','UGC 01110',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17484,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17484,36.63,0.51,212,4187,70,NULL,NULL,'ESO 542- G 025',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.46',0.9,'S0',NULL,NULL,NULL,NULL,1,23.3269166667,-21.00264,0.026,NULL,35170404173,549537565,8586524,15.46),(17485,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17485,31.93,0.2,24.3,4188,74.4,NULL,NULL,'UGC 01112',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.00015,NULL,'14.70',0.6,'Scd:',NULL,NULL,NULL,NULL,1,23.3275,3.07056,0.021,NULL,66984316649,1046629947,16353592,14.7),(17486,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17486,31.93,0.43,24.4,4188,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01112',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17487,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17487,31.98,0.43,24.9,4188,75,NULL,'3.6 micron, color corrected','UGC 01112',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17488,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17488,31.99,0.4,25,4188,73,NULL,'opt','UGC 01112',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17489,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17489,32.03,0.64,25.4,4188,NULL,NULL,NULL,'UGC 01112',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17490,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17490,32.09,0.63,26.1,4188,NULL,NULL,'Malmquist cor.','UGC 01112',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17491,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17491,37.53,0.46,321,4189,70,NULL,NULL,'2MASX J01332398-0033089',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000096,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,23.35,-0.55264,0.017,NULL,34964428439,546319194,8536237,17.1),(17492,'CMD','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'N',17492,17.72,0.18,0.035,4190,NULL,NULL,NULL,'Pisces Stellar Stream',NULL,'2013ApJ...765L..39M',2013,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17493,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17493,37.57,0.19,326,4191,70,NULL,NULL,'2MASX J01332541-0107479',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000083,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,23.3560417,-1.12994,0.095,NULL,34967552584,546368009,8537000,17.4),(17494,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 14826','RN',17494,40.71,0.35,1220,4192,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14826',0.134867,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17495,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 14826','RN',17495,40.76,0.37,1250,4192,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14826',0.134867,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17496,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2007ku',NULL,17496,40.7,0.19,1380,4193,70,NULL,'Hubble residual 0.11 for z0.37160','SDSS J013328.29+003128.6',NULL,'2011ApJ...740...92G',2011,1,0.1,NULL,'G',0.0005,NULL,'20.5g',0.05,NULL,NULL,NULL,NULL,NULL,1,23.367875,0.52461,0.009,NULL,66975034392,1046484912,16351326,20.5),(17497,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 18091','R',17497,41.45,0.26,1420,4193,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ku','SDSS J013328.29+003128.6',0.3716,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17498,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 18091','R',17498,41.63,0.25,1550,4193,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ku','SDSS J013328.29+003128.6',0.3716,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17499,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2007ku',NULL,17499,41.34,0.17,1850,4193,70,NULL,'SALT 2','SDSS J013328.29+003128.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17500,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2007ku',NULL,17500,41.39,0.17,1900,4193,70,NULL,'SALT 2, Malmquist cor.','SDSS J013328.29+003128.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17501,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 03225','R',17501,41,0.22,1180,4194,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J013331.45+001840.4',0.3419,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',0.0005,NULL,'20.5g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,23.3810833333,0.31125,0.033,NULL,66975121034,1046486266,16351347,20.5),(17502,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 03225','R',17502,41.08,0.3,1230,4194,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J013331.45+001840.4',0.3419,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17503,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 03225',NULL,17503,40.94,0.19,1540,4194,70,NULL,'SALT 2','SDSS J013331.45+001840.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17504,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 03225',NULL,17504,40.98,0.19,1570,4194,70,NULL,'SALT 2, Malmquist cor.','SDSS J013331.45+001840.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17505,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 11467','RN',17505,40.93,0.48,1100,4195,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 11467',0.395689,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17506,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17506,36.73,0.83,221,4196,70,NULL,NULL,'ESO 542- G 026',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'16.22',0.5,'SB...',NULL,NULL,NULL,NULL,1,23.38675,-21.07767,0.026,NULL,35170364673,549536948,8586514,16.22),(17507,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17507,34.44,0.49,77.4,4197,75,NULL,'IR','UGC 01116',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.00002,NULL,'16.27',0.2,'Scd(f)','Group member',NULL,NULL,NULL,1,23.393875,-1.09064,0.095,NULL,34967667515,546369804,8537028,16.27),(17508,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17508,35.4,0.48,120,4198,70,NULL,NULL,'6dF J0133350-363552',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,23.3962083,-36.59769,NULL,NULL,38273468664,598022947,9344108,13.7),(17509,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 18824',NULL,17509,40.74,0.16,1410,4199,70,NULL,'SN photometric redshift distance, z photo =0.407 +/- 0.041','SDSS-II SN 18824',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,23.401375,1.19069,0.057,NULL,66978728355,1046542630,16352228,NULL),(17510,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17510,36.58,0.59,207,4200,70,NULL,NULL,'2MASX J01333940-0216389',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000123,NULL,'16.78',0.38,NULL,NULL,NULL,NULL,NULL,1,23.4142917,-2.27747,0.078,NULL,34964837052,546325578,8536337,16.78),(17511,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 19137','RN',17511,39.61,0.08,792,4201,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19137',0.055385,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17512,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 19137','RN',17512,40.44,0.21,1160,4201,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19137',0.055385,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17513,'IRAS','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17513,33.11,0.8,41.8,4202,75,NULL,'CF, r','UGC 01118',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000013,NULL,'14.43',0.5,'SA(s)dm:',NULL,NULL,NULL,NULL,1,23.426167,3.54322,0.045,NULL,66985075027,1046641797,16353778,14.43),(17514,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17514,32.84,0.38,37,4202,75,NULL,'CF, r, raw','UGC 01118',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17515,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17515,32.85,0.38,37.2,4202,75,NULL,'CF, r, inv','UGC 01118',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17516,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17516,32.94,0.2,38.7,4202,74.4,NULL,NULL,'UGC 01118',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17517,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17517,33.05,0.38,40.8,4202,75,NULL,'CF, r, cor','UGC 01118',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17518,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17518,33.1,0.57,41.6,4202,NULL,NULL,'Malmquist cor.','UGC 01118',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17519,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17519,33.13,0.56,42.2,4202,NULL,NULL,NULL,'UGC 01118',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17520,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17520,35.65,0.54,135,4203,70,NULL,NULL,'ESO 244- G 033',NULL,'2014MNRAS.445.2677S',2014,1,0.89,NULL,'G',0.00015,NULL,'15.96',0.28,'Sa',NULL,NULL,NULL,NULL,1,23.427917,-43.50411,NULL,NULL,38384678299,599760598,9371259,15.96),(17521,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17521,37.57,0.19,326,4204,70,NULL,NULL,'2MASX J01334382-0110399',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000077,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,23.432583,-1.17786,0.095,NULL,34967749891,546371092,8537048,17.4),(17522,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17522,36.34,0.46,185,4205,70,NULL,NULL,'2MASX J01334427-0943340',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000092,NULL,'17.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,23.4345,-9.72614,0.139,NULL,35266827624,551044181,8610065,17),(17523,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 16556','RN',17523,38.4,0.12,445,4206,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16556',0.078497,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17524,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 16556','RN',17524,38.83,0.24,541,4206,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16556',0.078497,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17525,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17525,36.91,0.46,241,4207,70,NULL,NULL,'2MASX J01335029-0038219',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000083,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,23.459625,-0.63958,0.017,NULL,34967202567,546362540,8536914,16.8),(17526,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17526,37.62,0.6,334,4208,70,NULL,NULL,'2MASX J01335074-5402216',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'17.09',0.25,NULL,NULL,NULL,NULL,NULL,1,23.461417,-54.03944,0,NULL,36122716222,564417440,8819022,17.09),(17527,'Brightest Stars','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17527,24.2,0.2,0.692,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'1983ApJ...269..335H',1983,1,70.8,NULL,'G',0.00001,NULL,'6.27',41.7,'SA(s)cd        HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,23.4620417,30.66022,0.181,0,67768998016,1058890594,16545165,6.27),(17528,'Brightest Stars','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17528,24.2,NULL,0.692,4209,NULL,NULL,'Photographic','MESSIER 033',NULL,'1986AN....307..379I',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17529,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17529,23.83,0.35,0.583,4209,NULL,NULL,'1, V','MESSIER 033',NULL,'2004ASPC..310...95B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17530,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17530,24.1,0.11,0.661,4209,NULL,18.47,'13, B, Photographic','MESSIER 033',NULL,'1987SAAOC..11..125W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17531,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17531,24.1,NULL,0.661,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'1985cto..conf..225F',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17532,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17532,24.2,0.15,0.692,4209,NULL,NULL,'54, B','MESSIER 033',NULL,'1987AJ.....93..557C',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17533,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17533,24.25,0.2,0.708,4209,NULL,18.47,'Photographic','MESSIER 033',NULL,'1988Obs...108..119F',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17534,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17534,24.3,0.2,0.724,4209,NULL,NULL,'15, H','MESSIER 033',NULL,'1985ApJ...294..560M',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17535,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17535,24.37,0.02,0.748,4209,NULL,NULL,'inner','MESSIER 033',NULL,'2009MNRAS.396.1287S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17536,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17536,24.38,0.14,0.752,4209,NULL,18.45,'LMC ZP','MESSIER 033',NULL,'2009AcA....59..403M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17537,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17537,24.39,0.3,0.755,4209,NULL,NULL,'BV(W), inner','MESSIER 033',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17538,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17538,24.4,0.17,0.759,4209,NULL,18.45,'LMC ZP','MESSIER 033',NULL,'2009AcA....59..403M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17539,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17539,24.41,0.27,0.762,4209,NULL,NULL,'VI(W), inner','MESSIER 033',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17540,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17540,24.43,0.14,0.769,4209,NULL,18.44,NULL,'MESSIER 033',NULL,'2010JAVSO..38..100M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17541,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17541,24.47,0.13,0.78,4209,NULL,NULL,'LMC W01','MESSIER 033',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17542,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17542,24.47,0.11,0.783,4209,NULL,NULL,'LMC VIHJK','MESSIER 033',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17543,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17543,24.49,0.16,0.791,4209,NULL,NULL,'?, VI(W)','MESSIER 033',NULL,'2004Ap.....47..389A',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17544,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17544,24.5,0.05,0.794,4209,NULL,NULL,'11, BVRI','MESSIER 033',NULL,'1997ApJ...491...13K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17545,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17545,24.5,0.2,0.794,4209,NULL,NULL,'15, H','MESSIER 033',NULL,'1988STIN...8822846M',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17546,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17546,24.5,NULL,0.794,4209,NULL,NULL,'BVRI','MESSIER 033',NULL,'1988ASPC....4...24F',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17547,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17547,24.52,0.14,0.802,4209,NULL,NULL,'21, I','MESSIER 033',NULL,'2002ApJ...565..959L',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17548,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17548,24.52,0.15,0.802,4209,NULL,NULL,'21, I(W)','MESSIER 033',NULL,'2002ApJ...565..959L',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17549,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17549,24.52,0.14,0.802,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2004MNRAS.350..243M',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17550,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17550,24.53,0.11,0.805,4209,NULL,NULL,'Z','MESSIER 033',NULL,'2009MNRAS.396.1287S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17551,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17551,24.54,0.03,0.809,4209,NULL,NULL,'outer','MESSIER 033',NULL,'2009MNRAS.396.1287S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17552,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17552,24.55,0.28,0.813,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2007ApJ...671.1640A',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17553,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17553,24.56,0.08,0.82,4209,NULL,NULL,'11, VI, KEY PROJECT','MESSIER 033',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17554,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17554,24.59,0.03,0.828,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2007Natur.449..872O',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17555,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17555,24.6,0.08,0.832,4209,NULL,NULL,'24, JHKs, GAL PL','MESSIER 033',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17556,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17556,24.61,0.06,0.836,4209,NULL,NULL,'24, JHKs, LMC PL','MESSIER 033',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17557,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17557,24.62,0.07,0.839,4209,NULL,NULL,'26, JK','MESSIER 033',NULL,'2013ApJ...773...69G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17558,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17558,24.62,0.06,0.839,4209,NULL,NULL,'24, JHKs, GAL+LMC PL','MESSIER 033',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17559,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17559,24.63,0.09,0.84,4209,NULL,NULL,'BVRI','MESSIER 033',NULL,'1991PASP..103..933M',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17560,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17560,24.62,0.08,0.84,4209,NULL,NULL,'11, VI, +Z, KEY PROJECT','MESSIER 033',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17561,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17561,24.63,NULL,0.843,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17562,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17562,24.64,0.09,0.847,4209,NULL,NULL,'BVRI','MESSIER 033',NULL,'1991ApJ...372..455F',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17563,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17563,24.64,0.06,0.847,4209,NULL,18.54,'LMC ZP','MESSIER 033',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17564,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17564,24.64,0.09,0.847,4209,NULL,NULL,'HST KP Calibrated','MESSIER 033',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17565,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17565,24.65,0.19,0.851,4209,NULL,NULL,'VI(W), outer','MESSIER 033',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17566,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17566,24.65,0.12,0.851,4209,NULL,NULL,'61, VI','MESSIER 033',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17567,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17567,24.67,0.07,0.859,4209,NULL,18.45,'LMC ZP','MESSIER 033',NULL,'2009AcA....59..403M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17568,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17568,24.67,0.31,0.859,4209,NULL,NULL,'BV(W), outer','MESSIER 033',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17569,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17569,24.7,0.1,0.871,4209,NULL,NULL,'BV','MESSIER 033',NULL,'1991MNRAS.250..438M',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17570,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17570,24.7,0.13,0.871,4209,NULL,NULL,'MW HIPP','MESSIER 033',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17571,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17571,24.76,0.03,0.895,4209,NULL,18.45,'91, R, LMC ZP','MESSIER 033',NULL,'1987PASP...99.1127M',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17572,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17572,24.76,0.02,0.895,4209,NULL,NULL,'564, WVI, Cleaned Sample','MESSIER 033',NULL,'2011ApJS..193...26P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17573,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17573,24.77,0.39,0.899,4209,NULL,NULL,'MW P02','MESSIER 033',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17574,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17574,24.77,0.04,0.899,4209,NULL,NULL,'564, WVI','MESSIER 033',NULL,'2011ApJS..193...26P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17575,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17575,24.79,0.05,0.91,4209,74.4,NULL,NULL,'MESSIER 033',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17576,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17576,24.81,0.13,0.916,4209,NULL,18.45,'I, LMC ZP','MESSIER 033',NULL,'1987PASP...99.1127M',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17577,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17577,24.83,0.12,0.925,4209,NULL,NULL,'22, VI','MESSIER 033',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17578,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17578,24.83,0.12,0.925,4209,NULL,NULL,'MW GFG','MESSIER 033',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17579,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17579,24.85,0.09,0.933,4209,NULL,NULL,'11, BVRI +Z','MESSIER 033',NULL,'1997ApJ...491...13K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17580,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17580,25.01,0.03,1,4209,NULL,NULL,'BVRI','MESSIER 033',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17581,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17581,25.03,0.25,1.01,4209,73,NULL,'Cepheids periods Gaussian ','MESSIER 033',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17582,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17582,25.06,0.04,1.03,4209,73,NULL,'Cepheids magnitudes Gaussian ','MESSIER 033',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17583,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17583,25.06,0.14,1.03,4209,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian ','MESSIER 033',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17584,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17584,25.1,0.03,1.05,4209,NULL,NULL,'BVRI+','MESSIER 033',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17585,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17585,25.25,NULL,1.12,4209,NULL,NULL,'Photographic, APPARENT BLUE m-M','MESSIER 033',NULL,'1988PASP..100..935S',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17586,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17586,25.35,NULL,1.17,4209,NULL,NULL,'Photographic, APPARENT BLUE m-M','MESSIER 033',NULL,'1983AJ.....88.1108S',1983,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17587,'Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17587,25.35,NULL,1.17,4209,NULL,NULL,'Photographic, APPARENT BLUE m-M, 13, B','MESSIER 033',NULL,'1983ApJ...267L..25S',1983,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17588,'CMD','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17588,24.58,0.05,0.824,4209,NULL,NULL,'6 Padova fits','MESSIER 033',NULL,'2008MNRAS.390..863B',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17589,'CMD','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17589,24.67,0.06,0.859,4209,NULL,NULL,'6 Teramo fits','MESSIER 033',NULL,'2008MNRAS.390..863B',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17590,'CMD','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17590,24.69,0.09,0.867,4209,NULL,NULL,'Field S2','MESSIER 033',NULL,'2011MNRAS.410..504B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17591,'CMD','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17591,24.72,0.09,0.879,4209,NULL,NULL,'Field S1','MESSIER 033',NULL,'2011MNRAS.410..504B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17592,'FGLR','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17592,24.47,NULL,0.783,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2008ApJ...681..269K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17593,'FGLR','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17593,24.93,0.11,0.968,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2009ApJ...704.1120U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17594,'M Stars','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17594,23.9,NULL,0.6,4209,NULL,NULL,'Photographic','MESSIER 033',NULL,'1980ApJ...241..587H',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17595,'Miras','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17595,24.4,0.2,0.76,4209,NULL,NULL,'LPV','MESSIER 033',NULL,'1990ApJ...349..503M',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17596,'Miras','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17596,24.63,0.08,0.843,4209,NULL,18.45,'LPV, LMC ZP','MESSIER 033',NULL,'1987PASP...99.1127M',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17597,'Miras','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17597,24.85,0.13,0.933,4209,NULL,NULL,'LPV, I(8250)','MESSIER 033',NULL,'2000MNRAS.313..271P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17598,'Novae','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17598,24.8,0.3,0.912,4209,NULL,NULL,'Photographic','MESSIER 033',NULL,'1988ASPC....4...73D',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17599,'PNLF','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17599,24.62,0.25,0.84,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2000A&A...355..713M',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17600,'PNLF','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17600,24.65,0.24,0.85,4209,NULL,NULL,'58','MESSIER 033',NULL,'1999AAS...195.1103K',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17601,'PNLF','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17601,24.86,0.11,0.938,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2004ApJ...614..167C',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17602,'Red Clump','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17602,24.72,NULL,0.877,4209,NULL,NULL,'V, M RC(V) = +0.73 mag','MESSIER 033',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17603,'Red Clump','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17603,24.75,0.07,0.891,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2007Natur.449..872O',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17604,'Red Clump','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17604,24.76,0.04,0.895,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2002AJ....123..244K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17605,'Red Clump','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17605,24.8,0.04,0.912,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2002AJ....123..244K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17606,'Red Clump','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17606,24.8,0.14,0.912,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2004MNRAS.350..243M',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17607,'Red Clump','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17607,24.81,0.24,0.916,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2000AJ....120.2437S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17608,'Red Clump','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17608,24.92,NULL,0.962,4209,NULL,NULL,'I, M RC(I) = -0.50 mag','MESSIER 033',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17609,'RSV Stars','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17609,24.24,0.09,0.705,4209,NULL,18.28,'K','MESSIER 033',NULL,'1993AstL...19..172D',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17610,'RSV Stars','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17610,24.6,0.1,0.832,4209,NULL,NULL,'Photographic, K','MESSIER 033',NULL,'1987AJ.....93..833K',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17611,'RR Lyrae','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17611,24.36,0.09,0.745,4209,NULL,NULL,'V','MESSIER 033',NULL,'2013MNRAS.435.3206D',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17612,'RR Lyrae','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17612,24.45,0.2,0.776,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'1988ASPC....4...59P',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17613,'RR Lyrae','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17613,24.52,0.11,0.802,4209,NULL,NULL,'65, RRab, Z','MESSIER 033',NULL,'2010ApJ...724..799Y',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17614,'RR Lyrae','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17614,24.52,0.11,0.802,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2011PhDT........32Y',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17615,'RR Lyrae','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17615,24.54,0.14,0.809,4209,NULL,18.44,NULL,'MESSIER 033',NULL,'2010JAVSO..38..100M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17616,'RR Lyrae','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17616,24.54,0.81,0.809,4209,NULL,18.19,NULL,'MESSIER 033',NULL,'1992MmSAI..63..409C',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17617,'RR Lyrae','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17617,24.62,NULL,0.839,4209,NULL,NULL,'Fe/H = -1.5','MESSIER 033',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17618,'RR Lyrae','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17618,24.66,0.09,0.855,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2007Natur.449..872O',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17619,'RR Lyrae','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17619,24.67,0.08,0.859,4209,NULL,NULL,'43 RR Lyrae','MESSIER 033',NULL,'2006AJ....132.1361S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17620,'RR Lyrae','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17620,24.69,NULL,0.867,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17621,'RR Lyrae','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17621,24.69,0.17,0.867,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2011AJ....142..198P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17622,'RR Lyrae','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17622,24.71,NULL,0.875,4209,NULL,NULL,'RR','MESSIER 033',NULL,'1992MmSAI..63..331L',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17623,'RR Lyrae','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17623,24.77,NULL,0.899,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2008ApJ...679...52T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17624,'RR Lyrae','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17624,24.78,NULL,0.904,4209,NULL,NULL,'Fe/H = -1.5','MESSIER 033',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17625,'RR Lyrae','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17625,24.84,0.16,0.929,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2000AJ....120.2437S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17626,'RR Lyrae','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17626,24.85,NULL,0.933,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17627,'S Doradus Stars','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17627,25.4,NULL,1.2,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'1989A&A...217...87W',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17628,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17628,24.5,0.06,0.794,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2004MNRAS.350..243M',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17629,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17629,24.54,0.06,0.809,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2005MNRAS.356..979M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17630,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17630,24.57,0.05,0.82,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2012ApJ...758...11C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17631,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17631,24.6,0.3,0.832,4209,NULL,NULL,'I','MESSIER 033',NULL,'1990AJ.....99..149W',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17632,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17632,24.63,0.1,0.843,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2007Natur.449..872O',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17633,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17633,24.64,0.15,0.847,4209,NULL,NULL,'I','MESSIER 033',NULL,'2004A&A...423..925G',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17634,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17634,24.65,NULL,0.85,4209,NULL,NULL,'outer disk','MESSIER 033',NULL,'2008AJ....135.1482S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17635,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17635,24.69,0.07,0.867,4209,NULL,NULL,'I','MESSIER 033',NULL,'2004AJ....128..224T',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17636,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17636,24.7,0.1,0.871,4209,NULL,NULL,'I','MESSIER 033',NULL,'1993ApJ...417..553L',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17637,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17637,24.71,0.03,0.875,4209,NULL,NULL,'I, blue edge','MESSIER 033',NULL,'2007ApJ...661..815R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17638,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17638,24.71,0.04,0.875,4209,NULL,NULL,'I, red edge','MESSIER 033',NULL,'2007ApJ...661..815R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17639,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17639,24.72,0.14,0.88,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2004AJ....128..237B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17640,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17640,24.73,0.11,0.883,4209,NULL,NULL,'I, M33 center','MESSIER 033',NULL,'2011A&A...533A..91G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17641,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17641,24.73,0.12,0.883,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17642,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17642,24.75,0.1,0.89,4209,NULL,NULL,'M33-EC1 star cluster','MESSIER 033',NULL,'2008AJ....135.1482S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17643,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17643,24.75,0.11,0.891,4209,NULL,NULL,'I, field SE3b','MESSIER 033',NULL,'2011A&A...533A..91G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17644,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17644,24.77,0.13,0.899,4209,NULL,NULL,'I','MESSIER 033',NULL,'2010ApJ...724..799Y',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17645,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17645,24.79,0.05,0.91,4209,74.4,NULL,NULL,'MESSIER 033',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17646,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17646,24.8,0.3,0.912,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'1986ApJ...305..591M',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17647,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17647,24.81,0.04,0.916,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2002AJ....123..244K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17648,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17648,24.81,0.04,0.916,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17649,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17649,24.81,0.13,0.916,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2004MNRAS.350..243M',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17650,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17650,24.82,0.1,0.92,4209,NULL,NULL,'I','MESSIER 033',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17651,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17651,24.82,NULL,0.92,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17652,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17652,24.82,NULL,0.92,4209,NULL,NULL,'DA90','MESSIER 033',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17653,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17653,24.84,0.1,0.929,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2009ApJ...704.1120U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17654,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17654,24.87,NULL,0.942,4209,NULL,NULL,'theory','MESSIER 033',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17655,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17655,24.92,NULL,0.964,4209,NULL,NULL,'Yale','MESSIER 033',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17656,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17656,24.93,0.18,0.968,4209,NULL,NULL,'HST KP Calibrated','MESSIER 033',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17657,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17657,24.97,NULL,0.986,4209,NULL,NULL,'I, M TRGB(I) = -4.05 mag','MESSIER 033',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17658,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17658,24.97,NULL,0.986,4209,NULL,NULL,'K97','MESSIER 033',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17659,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17659,24.99,0.04,0.995,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2002AJ....123..244K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17660,'Type II Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17660,24.49,0.08,0.791,4209,NULL,18.45,'LMC ZP','MESSIER 033',NULL,'2009AcA....59..403M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17661,'Type II Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17661,24.49,0.26,0.791,4209,NULL,18.45,'LMC ZP','MESSIER 033',NULL,'2009AcA....59..403M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17662,'Type II Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17662,24.5,0.3,0.794,4209,NULL,18.44,NULL,'MESSIER 033',NULL,'2010JAVSO..38..100M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17663,'Type II Cepheids','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17663,24.54,NULL,0.809,4209,NULL,18.44,NULL,'MESSIER 033',NULL,'2010JAVSO..38..100M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17664,'Statistical','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17664,24.49,0.01,0.792,4209,NULL,NULL,'20 estimates','MESSIER 033',NULL,'2014arXiv1410.7843C',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17665,'CO ring diameter','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17665,24.87,NULL,0.9,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'1991PASJ...43..671S',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17666,'Eclipsing Binary','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17666,24.87,0.16,0.942,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2006Ap&SS.304..207B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17667,'Eclipsing Binary','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17667,24.92,0.12,0.964,4209,NULL,NULL,'Eclipsing Binary D33 J013346.2+304439.9','MESSIER 033',NULL,'2006ApJ...652..313B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17668,'HII region diameter','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17668,24.37,0.13,0.748,4209,NULL,NULL,'Method 2','MESSIER 033',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17669,'HII region diameter','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17669,24.39,0.13,0.755,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'1986Ap&SS.125...43I',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17670,'HII region diameter','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17670,24.43,0.15,0.769,4209,NULL,NULL,'Method 1','MESSIER 033',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17671,'HII region diameter','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17671,25.06,NULL,1.03,4209,NULL,NULL,'Photographic','MESSIER 033',NULL,'1981AN....302..251I',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17672,'Maser','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17672,23.89,0.81,0.6,4209,NULL,NULL,'IC 0133','MESSIER 033',NULL,'1993ApJ...406..482G',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17673,'Maser','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17673,24.32,0.27,0.73,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2005Sci...307.1440B',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17674,'Maser','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17674,24.52,0.45,0.8,4209,NULL,NULL,'IC 0133','MESSIER 033',NULL,'2004ApJ...615..702A',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17675,'Maser','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17675,24.6,0.57,0.83,4209,NULL,NULL,'IC 0133','MESSIER 033',NULL,'1998ASPC..144..235A',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17676,'Proper Motion','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17676,24.54,NULL,0.809,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2011arXiv1105.5596P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17677,'IRAS','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17677,27.42,0.8,3.05,4209,75,NULL,'A82, H','MESSIER 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17678,'Magnitude','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17678,24.57,0.11,0.82,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17679,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17679,24.23,0.4,0.7,4209,75,NULL,'B','MESSIER 033',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17680,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17680,24.48,0.47,0.787,4209,75,NULL,'A82, H, inv','MESSIER 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17681,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17681,24.55,0.07,0.813,4209,NULL,NULL,'B','MESSIER 033',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17682,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17682,24.55,0.47,0.813,4209,75,NULL,'A82, H, raw','MESSIER 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17683,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17683,24.56,0.06,0.817,4209,NULL,NULL,'I','MESSIER 033',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17684,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17684,24.59,NULL,0.828,4209,NULL,NULL,'B','MESSIER 033',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17685,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17685,24.73,0.35,0.883,4209,NULL,NULL,NULL,'MESSIER 033',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17686,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17686,24.91,0.47,0.96,4209,75,NULL,'A82, H, cor','MESSIER 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17687,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17687,25.05,NULL,1.02,4209,NULL,NULL,'LEDA [April 2006]','MESSIER 033',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17688,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 05247',NULL,17688,39.06,0.47,649,4210,70,NULL,'SN photometric redshift distance, z photo =0.165 +/- 0.045','SDSS-II SN 05247',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','22.0g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,23.4659583333,-0.92372,0.021,NULL,34967702500,546370351,8537036,22),(17689,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 05247','R',17689,41.11,0.3,1210,4210,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 05247',0.377309,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17690,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 05247','R',17690,41.13,0.27,1220,4210,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 05247',0.377309,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17691,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 05247',NULL,17691,40.95,0.2,1550,4210,70,NULL,'SALT 2','SDSS-II SN 05247',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17692,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 05247',NULL,17692,41,0.2,1580,4210,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 05247',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17693,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17693,37.57,0.19,326,4211,70,NULL,NULL,'2MASX J01335209-0056549',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000071,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,23.467167,-0.94867,0.045,NULL,34967672407,546369881,8537029,18.1),(17694,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17694,32.89,NULL,37.8,4212,NULL,NULL,NULL,'SDSS J0133+1342',NULL,'2014A&A...562A..49M',2014,1,0.21,NULL,'G',0.001753,NULL,'18.1g',0.13,'BlueCG         HII',NULL,NULL,NULL,NULL,1,23.4690417,13.70264,0.137,NULL,67414506769,1053351668,16458619,18.1),(17695,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 03310','RN',17695,41.22,0.24,1340,4213,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03310',0.307967,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17696,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 03310','RN',17696,41.22,0.12,1340,4213,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03310',0.307967,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17697,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17697,36.91,0.46,241,4214,70,NULL,NULL,'SDSS J013353.28+132412.2',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000111,NULL,'15.8g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,23.4720417,13.40342,0.141,NULL,67411420091,1053303438,16457866,15.8),(17698,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 21001',NULL,17698,39.67,0.74,861,4215,70,NULL,'SN photometric redshift distance, z photo =0.226 +/- 0.111','SDSS-II SN 21001',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.5g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,23.4739583,0.16669,0.025,NULL,66975132428,1046486444,16351350,21.5),(17699,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 21001','R',17699,41.18,0.32,1210,4215,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 21001',0.428703,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17700,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 21001','R',17700,42.12,0.46,1860,4215,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21001',0.428703,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17701,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 16998','RN',17701,42.64,0.62,3130,4216,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 16998',0.07752,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17702,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 1999dx',NULL,17702,40.06,0.26,809,4217,74.2,NULL,'SALT 2','SDSS J013359.45+000414.6',0.27,'2010ApJ...716..712A',2010,1,0.09,NULL,'G',NULL,NULL,'20.4g',0.05,NULL,NULL,NULL,NULL,NULL,1,23.49775,0.07072,0.017,NULL,66975057026,1046485266,16351332,20.4),(17703,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 1999dx',NULL,17703,40.82,0.18,1150,4217,NULL,NULL,'M(B) = -19.31','SDSS J013359.45+000414.6',0.27,'2008A&A...486..375A',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17704,'IRAS','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17704,33.38,0.8,47.4,4218,75,NULL,'MAT, I','ESO 353- G 014',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'14.46',0.4,'Sab: sp        HII','Pair member (points to parent)',NULL,NULL,NULL,1,23.501,-34.38739,NULL,NULL,38305394268,598521785,9351902,14.46),(17705,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17705,32.49,0.49,31.4,4218,75,NULL,'IR','ESO 353- G 014',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17706,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17706,32.96,0.32,39,4218,85,NULL,'I, raw','ESO 353- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17707,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17707,32.97,0.32,39.3,4218,85,NULL,'I, inv','ESO 353- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17708,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17708,33.1,0.43,41.6,4218,75,NULL,'MAT, I, raw','ESO 353- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17709,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17709,33.22,0.43,44,4218,75,NULL,'MAT, I, inv','ESO 353- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17710,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17710,33.52,0.47,50.5,4218,NULL,NULL,'H','ESO 353- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17711,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17711,33.52,0.43,50.6,4218,75,NULL,'MAT, I, cor','ESO 353- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17712,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17712,33.59,0.4,52.2,4218,NULL,NULL,NULL,'ESO 353- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17713,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17713,33.59,0.4,52.3,4218,NULL,NULL,'mean','ESO 353- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17714,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17714,33.62,0.45,53.1,4218,NULL,NULL,'K','ESO 353- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17715,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17715,33.63,0.2,53.2,4218,74.4,NULL,NULL,'ESO 353- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17716,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17716,33.71,0.46,55.2,4218,NULL,NULL,'J','ESO 353- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17717,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17717,33.89,0.35,59.9,4218,NULL,NULL,'Malmquist cor.','ESO 353- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17718,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17718,34.15,0.4,67.7,4219,NULL,NULL,'mean','UGC 01120',NULL,'2007A&A...465...71T',2007,1,1.42,NULL,'G',0.000023,NULL,'14.7g',0.43,'SBab pec sp    NLAGN','Group member',NULL,NULL,NULL,1,23.51025,-1.07578,0.095,NULL,34967892537,546373320,8537083,14.7),(17719,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17719,34.35,0.08,74.3,4219,NULL,NULL,NULL,'UGC 01120',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17720,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17720,34.43,0.47,76.9,4219,NULL,NULL,'H','UGC 01120',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17721,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17721,34.5,0.45,79.6,4219,NULL,NULL,'K','UGC 01120',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17722,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17722,34.54,0.49,81,4219,75,NULL,'IR','UGC 01120',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17723,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17723,34.6,0.46,83.2,4219,NULL,NULL,'J','UGC 01120',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17724,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 14762','RN',17724,40.31,0.21,880,4220,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 14762',0.30807,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17725,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 14762','RN',17725,40.33,0.26,890,4220,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 14762',0.30807,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17726,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 14762','N',17726,40.34,0.15,1170,4220,70,NULL,'SALT 2','SDSS-II SN 14762',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17727,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 14762','N',17727,40.38,0.15,1190,4220,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14762',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17728,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17728,37.57,0.19,326,4221,70,NULL,NULL,'2MASX J01340621-0107358',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000061,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,23.5259583,-1.12661,0.095,NULL,34967884525,546373195,8537081,17.5),(17729,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17729,38.02,0.46,403,4222,70,NULL,NULL,'SDSS J013407.88-084129.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.001026,NULL,'18.1g',0.15,'AGN',NULL,NULL,NULL,NULL,1,23.532833,-8.69167,0.087,NULL,35272199361,551128115,8611376,18.1),(17730,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17730,34,0.58,63.2,4223,70,NULL,NULL,'UGC 01123',NULL,'2014MNRAS.445.2677S',2014,1,1.62,NULL,'G',0.000027,NULL,'14.1g',0.38,'Sab: sp','Group member',NULL,NULL,NULL,1,23.5332083,-1.03228,0.033,NULL,34967890141,546373283,8537082,14.1),(17731,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17731,34.13,0.49,66.9,4223,75,NULL,'IR','UGC 01123',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17732,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17732,34.2,0.4,69.2,4223,NULL,NULL,'mean','UGC 01123',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17733,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17733,34.36,0.09,74.6,4223,NULL,NULL,NULL,'UGC 01123',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17734,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17734,34.38,0.47,75,4223,NULL,NULL,'H','UGC 01123',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17735,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17735,34.41,0.46,76.3,4223,NULL,NULL,'J','UGC 01123',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17736,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17736,34.48,0.45,78.7,4223,NULL,NULL,'K','UGC 01123',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17737,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 18447','RN',17737,39.7,0.24,759,4224,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18447',0.14919,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17738,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 18447','RN',17738,40.35,0.27,1020,4224,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18447',0.14919,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17739,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17739,37.57,0.19,326,4225,70,NULL,NULL,'2MASX J01341281-0107298',NULL,'2015arXiv151105856S',2015,1,0.52,'May contribute to the radio flux of PMN J0134-0106.','G',0.000114,NULL,'16.2g',0.41,'AGN',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,23.55325,-1.12486,0.095,NULL,34967883824,546373184,8537081,16.2),(17740,'IRAS','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17740,34.37,0.8,74.7,4226,75,NULL,'MAT, I','ESO 476- G 025',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.59',0.3,'SA(s)b',NULL,NULL,NULL,NULL,1,23.5537917,-25.5665,0.048,NULL,34711011336,542359552,8474368,14.59),(17741,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17741,34.19,0.43,68.9,4226,75,NULL,'MAT, I, raw','ESO 476- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17742,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17742,34.29,0.32,72,4226,85,NULL,'I, raw','ESO 476- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17743,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17743,34.29,0.47,72,4226,NULL,NULL,'H','ESO 476- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17744,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17744,34.34,0.32,73.8,4226,85,NULL,'I, inv','ESO 476- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17745,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17745,34.38,0.45,75.3,4226,NULL,NULL,'K','ESO 476- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17746,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17746,34.43,0.43,76.8,4226,75,NULL,'MAT, I, inv','ESO 476- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17747,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17747,34.43,0.43,76.8,4226,75,NULL,'MAT, I, cor','ESO 476- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17748,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17748,34.44,0.46,77.3,4226,NULL,NULL,'J','ESO 476- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17749,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17749,34.46,0.4,78,4226,NULL,NULL,'mean','ESO 476- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17750,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17750,34.55,0.21,81.3,4226,NULL,NULL,'Malmquist cor.','ESO 476- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17751,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17751,34.77,0.19,89.8,4226,NULL,NULL,NULL,'ESO 476- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17752,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17752,34.81,0.2,91.6,4226,74.4,NULL,NULL,'ESO 476- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17753,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 14556','RN',17753,42.43,0.15,2260,4227,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 14556',0.351643,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17754,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 14556','RN',17754,42.51,0.22,2360,4227,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 14556',0.351643,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17755,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 20484','RN',17755,43.32,0.21,3300,4228,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20484',0.402426,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17756,'IRAS','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17756,31.46,0.8,19.6,4229,75,NULL,'A82, H','NGC 0613',NULL,'1997ApJS..109..333W',1997,1,5.5,NULL,'G',0.000017,NULL,'10.7B',4.2,'SB(rs)bc;HII   Sy',NULL,NULL,NULL,'Sy ?',1,23.5757083,-29.41836,NULL,NULL,38260285772,597816965,9340890,10.7),(17757,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17757,31.21,0.4,17.5,4229,75,NULL,'B','NGC 0613',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17758,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17758,31.56,NULL,20.5,4229,NULL,NULL,'B','NGC 0613',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17759,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17759,32.11,0.38,26.4,4229,NULL,NULL,NULL,'NGC 0613',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17760,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17760,32.11,0.4,26.4,4229,73,NULL,'opt','NGC 0613',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17761,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17761,32.13,0.4,26.7,4229,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 0613',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17762,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17762,32.2,0.47,27.5,4229,75,NULL,'A82, H, raw','NGC 0613',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17763,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17763,32.47,0.47,31.1,4229,75,NULL,'A82, H, inv','NGC 0613',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17764,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17764,32.51,0.47,31.7,4229,75,NULL,'A82, H, cor','NGC 0613',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17765,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 21589',NULL,17765,40.25,0.39,1120,4230,70,NULL,'SN photometric redshift distance, z photo =0.308 +/- 0.076','SDSS-II SN 21589',NULL,'2011ApJ...738..162S',2011,1,0.13,NULL,'G',NULL,'PHOT','20.5g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,23.5764583,-0.02219,0.017,NULL,34964259595,546316556,8536196,20.5),(17766,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 21589','R',17766,41.05,0.27,1270,4230,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 21589',0.273434,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17767,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 21589','R',17767,41.3,0.5,1430,4230,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21589',0.273434,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17768,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17768,37.49,0.46,315,4231,70,NULL,NULL,'2MASX J01341937-0952163',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000088,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,23.58075,-9.87111,0.147,NULL,35267720232,551058128,8610283,18.2),(17769,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17769,37.69,0.77,345,4232,70,NULL,NULL,'2MASX J01341977-1428107',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.48',0.26,NULL,NULL,NULL,NULL,NULL,1,23.5824166667,-14.46964,0,NULL,35185177038,549768391,8590131,16.48),(17770,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 17957','RN',17770,41.56,0.31,1500,4233,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17957',0.371044,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17771,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 17957','RN',17771,41.76,0.29,1640,4233,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17957',0.371044,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17772,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17772,35.95,0.46,155,4234,70,NULL,NULL,'2MASX J01342533+1457591',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000164,NULL,'16.6g',0.24,'S0/E',NULL,NULL,NULL,NULL,1,23.6055417,14.96647,0.125,NULL,67412228555,1053316071,16458063,16.6),(17773,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17773,37.71,0.15,348,4235,70,NULL,NULL,'2MASX J01342714-0033418',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000075,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,23.61325,-0.56183,0.021,NULL,34967233262,546363019,8536922,18.2),(17774,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 11304','RN',17774,39.16,0.28,627,4236,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 11304',0.083309,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17775,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 11304','RN',17775,40.41,0.27,1110,4236,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 11304',0.083309,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17776,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17776,37.71,0.15,348,4237,70,NULL,NULL,'2MASX J01343381-0032598',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000073,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,23.6409583,-0.54997,0.021,NULL,34967232615,546363009,8536922,17.6),(17777,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17777,37.57,0.19,326,4238,70,NULL,NULL,'2MASX J01343495-0111384',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000087,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,23.6457083,-1.19417,0.057,NULL,34967746020,546371031,8537047,17.3),(17778,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17778,34.29,0.49,72,4239,75,NULL,'IR','MCG -03-05-008',NULL,'2011yCatp016004901K',2011,1,1.34,NULL,'G',0.000013,NULL,'15.32',0.22,'Sbc',NULL,NULL,NULL,NULL,1,23.645625,-15.50439,0,NULL,35195803454,549934428,8592725,15.32),(17779,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17779,34.6,NULL,83.3,4239,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -03-05-008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17780,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17780,34.61,NULL,83.6,4239,NULL,NULL,'Dipole + Quadrupole','MCG -03-05-008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17781,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17781,34.62,NULL,84,4239,NULL,NULL,'Dipole','MCG -03-05-008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17782,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17782,34.69,0.46,86.5,4239,NULL,NULL,'Malmquist cor.','MCG -03-05-008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17783,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17783,34.78,0.2,90.4,4239,74.4,NULL,NULL,'MCG -03-05-008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17784,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17784,35.04,0.39,102,4239,NULL,NULL,NULL,'MCG -03-05-008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17785,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 19364','RN',17785,41.71,0.28,1570,4240,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19364',0.404627,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17786,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 19364','RN',17786,42.35,0.32,2100,4240,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 19364',0.404627,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17787,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 13971','RN',17787,40.77,0.27,1130,4241,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13971',0.261899,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17788,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 13971','RN',17788,41.11,0.22,1320,4241,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13971',0.261899,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17789,'Quasar spectrum','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17789,42.9,NULL,3800,4242,NULL,NULL,NULL,'UM 672',NULL,'2002A&A...381L..57D',2002,1,NULL,NULL,'QSO',0.001,NULL,'18.7',NULL,NULL,NULL,NULL,NULL,'QSO',1,23.661,-19.53528,0,NULL,35227335499,550427117,8600423,18.7),(17790,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17790,37.76,0.46,357,4243,70,NULL,NULL,'2MASX J01344101-0915167',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000086,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,23.670875,-9.25469,0.106,NULL,35280434159,551256783,8613387,17.3),(17791,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 06295','R',17791,37.81,0.21,338,4244,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005js','2MASX J01344182-0036154',0.079683,'2014arXiv1401.3317S',2014,1,0.27,NULL,'G',0.000097,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,23.674333,-0.60422,0.029,NULL,34967334757,546364605,8536946,17.3),(17792,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2005js',NULL,17792,37.91,0.23,354,4244,65,NULL,'SALT2','2MASX J01344182-0036154',0.079683,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17793,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2005js',NULL,17793,37.98,0.06,366,4244,65,NULL,'MLCS2k2','2MASX J01344182-0036154',0.079683,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17794,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 06295','R',17794,38.06,0.09,380,4244,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005js','2MASX J01344182-0036154',0.079683,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17795,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17795,37.71,0.15,348,4244,70,NULL,NULL,'2MASX J01344182-0036154',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17796,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17796,36.54,0.57,203,4245,70,NULL,NULL,'2MASX J01344536-0059414',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.000117,NULL,'16.2g',0.27,'S0^-',NULL,NULL,NULL,NULL,1,23.689083,-0.99492,0.029,NULL,34967854858,546372732,8537073,16.2),(17797,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17797,36.82,0.46,231,4245,70,NULL,NULL,'2MASX J01344536-0059414',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17798,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17798,35.77,0.47,142,4246,NULL,NULL,'H','NGC 0606',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000017,NULL,'14.10',1.2,'SB(r)c',NULL,NULL,NULL,NULL,1,23.709,21.41844,0.161,NULL,67390355630,1052974306,16452723,14.1),(17799,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17799,35.78,0.4,143,4246,NULL,NULL,'mean','NGC 0606',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17800,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17800,35.9,0.45,151,4246,NULL,NULL,'K','NGC 0606',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17801,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17801,35.93,0.46,153,4246,NULL,NULL,'J','NGC 0606',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17802,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17802,37.13,0.46,267,4247,70,NULL,NULL,'2MASX J01345087+1436486',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000191,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,23.711917,14.61353,0.137,NULL,67414148449,1053346069,16458532,17.1),(17803,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17803,37.71,0.15,348,4248,70,NULL,NULL,'2MASX J01345135-0039304',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000078,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,23.714083,-0.65856,0.029,NULL,34967337488,546364648,8536947,17.5),(17804,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17804,37.71,0.15,348,4249,70,NULL,NULL,'SDSS J013451.57-004029.4',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00007,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,23.714875,-0.67486,0.029,NULL,34967324463,546364444,8536944,18.1),(17805,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17805,33.87,NULL,59.4,4250,NULL,NULL,NULL,'FGC 0173',NULL,'2000BSAO...50....5K',2000,1,1.36,NULL,'G',0.00006,NULL,'16.2',0.11,'Sd',NULL,NULL,NULL,NULL,1,23.715,-3.05083,0.101,NULL,34970603494,546415679,8537744,16.2),(17806,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17806,34.02,NULL,63.6,4250,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0173',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17807,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17807,34.04,NULL,64.2,4250,NULL,NULL,'Dipole + Quadrupole','FGC 0173',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17808,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17808,34.04,NULL,64.3,4250,NULL,NULL,'Dipole','FGC 0173',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17809,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17809,27.86,NULL,3.73,4251,NULL,NULL,NULL,'kkh 006',NULL,'2006AJ....131.1361K',2006,1,0.85,NULL,'G',0.000002,NULL,'17.0',0.6,'Ir',NULL,NULL,NULL,NULL,1,23.714875,52.09169,1.697,NULL,67800326605,1059380103,16552814,17),(17810,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17810,27.88,0.06,3.77,4251,NULL,NULL,'I','kkh 006',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17811,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17811,34.22,0.2,69.8,4252,74.4,NULL,NULL,'UGC 01124',NULL,'2013AJ....146...86T',2013,1,1.2,'Velocity reported in 1997ApJS..112..245N (V = 5257) has digits transposed.','G',0.000167,NULL,'15.3',0.3,'Sc',NULL,NULL,NULL,NULL,1,23.7202917,55.40233,NULL,NULL,65877308945,1029332952,16083327,15.3),(17812,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 17944','RN',17812,42.11,0.2,2030,4253,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17944',0.303641,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17813,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 17944','RN',17813,42.14,0.14,2050,4253,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 17944',0.303641,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17814,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17814,37.17,0.19,271,4254,70,NULL,NULL,'2MASX J01345588+1521236',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00006,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,23.732917,15.35664,0.089,NULL,67426267551,1053535430,16461491,17.9),(17815,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 21394','RN',17815,45.78,0.72,12600,4255,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 21394',0.134516,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17816,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 21394','RN',17816,46.06,1.62,14300,4255,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 21394',0.134516,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17817,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17817,36.2,0.61,174,4256,70,NULL,NULL,'ESO 476- G 026',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000073,NULL,'15.43',0.7,'S0 ?',NULL,NULL,NULL,NULL,1,23.740167,-24.42361,0.017,NULL,34696497818,542132778,8470824,15.43),(17818,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 17729','RN',17818,42.3,0.2,2060,4257,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17729',0.404738,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17819,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 17729','RN',17819,42.76,0.15,2540,4257,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 17729',0.404738,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17820,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17820,34.06,0.49,64.9,4258,75,NULL,'IR','UGC 01130',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000147,NULL,'15.54',0.2,'S?',NULL,NULL,NULL,NULL,1,23.7427083,1.33586,0.053,NULL,66977907628,1046529806,16352028,15.54),(17821,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17821,37.71,0.15,348,4259,70,NULL,NULL,'SDSS J013458.94-003616.9',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,23.7455833333,-0.60469,0.029,NULL,34967328025,546364500,8536945,18.6),(17822,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17822,37.71,0.15,348,4260,70,NULL,NULL,'2MASX J01350202-0100524',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000086,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,23.7585416667,-1.01456,0.029,NULL,34967827777,546372309,8537067,17.4),(17823,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17823,37.17,0.19,271,4261,70,NULL,NULL,'2MASX J01350259+1529156',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000093,NULL,'16.0g',0.42,'E/S0',NULL,NULL,NULL,NULL,1,23.760833,15.48772,0.089,NULL,67426225866,1053534779,16461480,16),(17824,'Tully est','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17824,32.01,0.8,25.2,4262,75,NULL,NULL,'UGC 01133',NULL,'1988NBGC.C....0000T',1988,1,3.1,NULL,'G',0.000003,NULL,'14.2',1.9,'Im:',NULL,NULL,NULL,NULL,1,23.761667,4.38111,0.077,NULL,66986888217,1046670128,16354220,14.2),(17825,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17825,37.71,0.15,348,4263,70,NULL,NULL,'2MASX J01350342-0054274',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000118,NULL,'15.7g',0.43,'AGN',NULL,NULL,NULL,NULL,1,23.7642917,-0.90767,0.029,NULL,34967834448,546372413,8537068,15.7),(17826,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17826,37.71,0.15,348,4264,70,NULL,NULL,'2MASX J01350342-0029024',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00011,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,23.764333,-0.484,0.029,NULL,34967385443,546365397,8536959,16.7),(17827,'CMD','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17827,28.05,0.04,4.07,4265,NULL,NULL,NULL,'NGC 0625',NULL,'2010ApJ...721..297M',2010,1,5.8,NULL,'G',0.000003,NULL,'11.5B',1.9,'SB(s)m? sp     HII','Isolated galaxy',NULL,NULL,NULL,1,23.7692917,-41.43619,NULL,NULL,38380526576,599695727,9370245,11.5),(17828,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17828,27.73,0.09,3.52,4265,74.4,NULL,NULL,'NGC 0625',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17829,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17829,27.95,0.07,3.89,4265,NULL,NULL,NULL,'NGC 0625',NULL,'2003AJ....126.2806C',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17830,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17830,27.96,0.21,3.9,4265,NULL,NULL,NULL,'NGC 0625',NULL,'2014A&A...566A..71L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17831,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17831,28.05,NULL,4.07,4265,NULL,NULL,NULL,'NGC 0625',NULL,'2004AJ....127.2031K',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17832,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17832,28.12,0.03,4.21,4265,NULL,NULL,'I','NGC 0625',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17833,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17833,27.1,NULL,2.63,4265,NULL,NULL,'LEDA [April 2006]','NGC 0625',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17834,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17834,27.16,NULL,2.7,4265,NULL,NULL,NULL,'NGC 0625',NULL,'2003A&A...404...93K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17835,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17835,27.73,0.09,3.52,4265,74.4,NULL,NULL,'NGC 0625',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17836,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17836,27.95,0.4,3.9,4265,75,NULL,'B','NGC 0625',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17837,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17837,38.45,0.46,490,4266,70,NULL,NULL,'SDSS J013504.98+150422.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000081,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,23.77075,15.07281,0.125,NULL,67426156663,1053533697,16461464,18.4),(17838,'IRAS','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17838,31.83,0.8,23.2,4267,75,NULL,'MAT, I','NGC 0615',NULL,'1997ApJS..109..333W',1997,1,3.6,NULL,'G',0.000017,NULL,'12.47',1.4,'SA(rs)b','X-ray-faint group member',NULL,NULL,NULL,1,23.7736666667,-7.34031,0.092,NULL,34989205758,546706339,8542286,12.47),(17839,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17839,31.82,0.4,23.1,4267,75,NULL,'B','NGC 0615',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17840,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17840,31.87,0.4,23.6,4267,NULL,NULL,'mean','NGC 0615',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17841,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17841,32.05,0.4,25.7,4267,NULL,NULL,NULL,'NGC 0615',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17842,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17842,32.05,0.39,25.7,4267,73,NULL,'opt','NGC 0615',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17843,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17843,32.16,NULL,27,4267,NULL,NULL,'B','NGC 0615',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17844,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17844,32.16,0.4,27,4267,73,NULL,'opt','NGC 0615',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17845,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17845,32.16,0.32,27.1,4267,85,NULL,'I, raw','NGC 0615',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17846,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17846,32.17,0.45,27.2,4267,NULL,NULL,'Malmquist cor.','NGC 0615',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17847,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17847,32.21,0.45,27.7,4267,NULL,NULL,NULL,'NGC 0615',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17848,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17848,32.21,0.32,27.7,4267,85,NULL,'I, inv','NGC 0615',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17849,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17849,32.25,0.2,28.2,4267,74.4,NULL,NULL,'NGC 0615',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17850,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17850,32.25,0.43,28.2,4267,75,NULL,'MAT, I, raw','NGC 0615',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17851,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17851,32.31,0.46,28.9,4267,NULL,NULL,'J','NGC 0615',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17852,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17852,32.33,0.43,29.3,4267,75,NULL,'3.6 micron, color corrected','NGC 0615',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17853,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17853,32.37,0.43,29.8,4267,75,NULL,'MAT, I, cor','NGC 0615',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17854,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17854,32.38,0.45,29.9,4267,NULL,NULL,'K','NGC 0615',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17855,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17855,32.39,0.43,30,4267,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0615',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17856,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17856,32.49,0.43,31.4,4267,75,NULL,'MAT, I, inv','NGC 0615',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17857,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 19525','R',17857,39.31,0.13,632,4268,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 19525',0.153494,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,23.783,-0.18406,0.017,NULL,34967131021,546361422,8536897,NULL),(17858,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 19525','R',17858,39.47,0.21,678,4268,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 19525',0.153494,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17859,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 04627','RN',17859,40.61,0.13,1030,4269,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 04627',0.291,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17860,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 07504','RN',17860,41.74,0.2,1700,4270,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 07504',0.312136,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17861,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 07504','RN',17861,41.79,0.28,1740,4270,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 07504',0.312136,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17862,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17862,37.17,0.19,271,4271,70,NULL,NULL,'2MASX J01351879+1520074',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000094,NULL,'17.0g',0.31,NULL,NULL,NULL,NULL,NULL,1,23.8280833333,15.33539,0.113,NULL,67426155480,1053533679,16461463,17),(17863,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 17770','RN',17863,41.77,0.11,1930,4272,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 17770',0.167854,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17864,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 17770','RN',17864,42.01,0.19,2160,4272,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 17770',0.167854,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17865,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17865,38.31,0.46,460,4273,70,NULL,NULL,'2MASX J01352725-1026310',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000088,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,23.8634166667,-10.44203,0.07,NULL,35267508402,551054818,8610231,17.5),(17866,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 10036',NULL,17866,41.23,0.21,1770,4274,70,NULL,'SN photometric redshift distance, z photo =0.550 +/- 0.080','SDSS-II SN 10036',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.7g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,23.8634583,0.23183,0.017,NULL,66978376753,1046537136,16352142,22.7),(17867,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 19343','RN',17867,43.71,0.26,3900,4275,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19343',0.414886,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17868,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 19343','RN',17868,43.74,0.29,3970,4275,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 19343',0.414886,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17869,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17869,33.31,NULL,45.8,4276,NULL,NULL,NULL,'FGC 0175',NULL,'2000BSAO...50....5K',2000,1,1.29,NULL,'G',0.000013,NULL,'16.1',0.12,'Sdm',NULL,NULL,NULL,NULL,1,23.8814166667,2.03158,0.069,NULL,66988761386,1046699396,16354678,16.1),(17870,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17870,33.34,NULL,46.6,4276,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0175',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17871,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17871,33.35,NULL,46.8,4276,NULL,NULL,'Dipole + Quadrupole','FGC 0175',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17872,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17872,33.36,NULL,47,4276,NULL,NULL,'Dipole','FGC 0175',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17873,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17873,33.62,0.43,52.9,4276,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0175',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17874,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17874,37.17,0.19,271,4277,70,NULL,NULL,'2MASX J01353449+1516525',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000093,NULL,'16.1g',0.41,'E/S0',NULL,NULL,NULL,NULL,1,23.8935417,15.28114,0.113,NULL,67426151287,1053533613,16461462,16.1),(17875,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17875,35.02,0.57,101,4278,NULL,NULL,'Malmquist cor.','ESO 297- G 010',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.22',0.7,'SB(s)c',NULL,NULL,NULL,NULL,1,23.911875,-41.28794,NULL,NULL,38380764290,599699442,9370303,15.22),(17876,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17876,35.14,0.54,107,4278,NULL,NULL,NULL,'ESO 297- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17877,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17877,35.18,0.2,109,4278,74.4,NULL,NULL,'ESO 297- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17878,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17878,37.17,0.19,271,4279,70,NULL,NULL,'2MASX J01354154+1519025',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000167,NULL,'16.0g',0.36,'S0',NULL,NULL,NULL,NULL,1,23.930833,15.31956,0.113,NULL,67426425299,1053537895,16461529,16),(17879,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17879,37.3,0.9,289,4280,70,NULL,NULL,'2MASX J01354767-0511102',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.53',0.42,NULL,NULL,NULL,NULL,NULL,1,23.948625,-5.18617,0.103,NULL,34968842283,546388160,8537315,16.53),(17880,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 1999dy',NULL,17880,39.66,0.2,709,4281,74.2,NULL,'SALT 2','SDSS J013549.59+000838.0',0.206,'2010ApJ...716..712A',2010,1,0.05,NULL,'G',NULL,NULL,'20.7g',0.01,NULL,NULL,NULL,NULL,NULL,1,23.956625,0.14392,0.025,NULL,66976227994,1046503562,16351618,20.7),(17881,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 1999dy',NULL,17881,40.39,0.18,995,4281,NULL,NULL,'M(B) = -19.31','SDSS J013549.59+000838.0',0.206,'2008A&A...486..375A',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17882,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17882,34.69,0.49,86.6,4282,70,NULL,NULL,'NGC 0624',NULL,'2014MNRAS.445.2677S',2014,1,1.32,NULL,'G',0.000033,NULL,'14.0g',0.66,'(R\')SB(r)b pec HII',NULL,NULL,NULL,NULL,1,23.962875,-10.00297,0.074,NULL,35267406617,551053228,8610206,14),(17883,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17883,37.52,0.46,319,4283,70,NULL,NULL,'2MASX J01355611-0020222',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.95',0.23,NULL,NULL,NULL,NULL,NULL,1,23.983917,-0.33953,0.033,NULL,34966094161,546345221,8536644,17.95),(17884,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17884,35.42,0.33,121,4284,70,NULL,NULL,'CGCG 437-006',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000096,NULL,'15.5g',0.41,'E0',NULL,NULL,NULL,NULL,1,24.0007917,14.56544,0.137,NULL,67412289133,1053317017,16458078,15.5),(17885,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17885,34.26,0.4,71.3,4285,NULL,NULL,'mean','NGC 0622',NULL,'2007A&A...465...71T',2007,1,1.47,NULL,'G',0.000027,NULL,'13.8g',0.96,'SB(rs)b        Sbrst','Isolated galaxy',NULL,NULL,'Starburst',1,24.000667,0.66353,0.017,NULL,66978395350,1046537427,16352147,13.8),(17886,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17886,34.63,0.45,84.4,4285,NULL,NULL,'K','NGC 0622',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17887,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17887,34.65,0.47,85.2,4285,NULL,NULL,'H','NGC 0622',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17888,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17888,34.7,0.46,87.2,4285,NULL,NULL,'J','NGC 0622',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17889,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17889,37.17,0.19,271,4286,70,NULL,NULL,'2MASX J01360058+1517569',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,24.0025417,15.29908,0.113,NULL,67426442731,1053538167,16461533,17.5),(17890,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17890,38.5,0.46,501,4287,70,NULL,NULL,'2MASX J01360106-0017133',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00008,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,24.0043333333,-0.28686,0.033,NULL,34966095327,546345239,8536644,18.1),(17891,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17891,36.07,0.57,164,4288,70,NULL,NULL,'2MASX J01360060-0759335',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.44',NULL,NULL,NULL,NULL,NULL,NULL,1,24.005375,-7.99019,0.084,NULL,34990554821,546727419,8542615,16.44),(17892,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17892,34.07,0.2,65.2,4289,74.4,NULL,NULL,'UGC 01144',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',NULL,NULL,'16.0',0.6,'Scd:',NULL,NULL,NULL,NULL,1,24.018625,11.68964,0.161,NULL,67528494761,1055132730,16486448,16),(17893,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17893,34.16,0.58,67.9,4289,NULL,NULL,NULL,'UGC 01144',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17894,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17894,34.22,0.56,69.9,4289,NULL,NULL,'Malmquist cor.','UGC 01144',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17895,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17895,36.88,0.46,238,4290,70,NULL,NULL,'2MASX J01360767-0816435',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000088,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,24.031875,-8.27889,0.089,NULL,34990810003,546731406,8542678,16.7),(17896,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 14500','RN',17896,41.56,0.37,1460,4291,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14500',0.403372,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17897,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 14500','RN',17897,41.57,0.37,1470,4291,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14500',0.403372,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17898,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 22116','RN',17898,43.06,0.25,2810,4292,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 22116',0.454158,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17899,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17899,35.42,0.33,121,4293,70,NULL,NULL,'2MASX J01361936+1439245',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000165,NULL,'16.0g',0.28,'AGN+SF',NULL,NULL,NULL,NULL,1,24.080625,14.65683,0.129,NULL,67412247058,1053316360,16458068,16),(17900,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 14644','R',17900,41.74,0.35,1540,4294,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14644',0.449299,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,24.080667,-0.06972,0.033,NULL,34966133074,546345829,8536653,NULL),(17901,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 14644',NULL,17901,40.94,0.21,1550,4294,70,NULL,'SN photometric redshift distance, z photo =0.459 +/- 0.063','SDSS-II SN 14644',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17902,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 14644','R',17902,41.99,0.42,1730,4294,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14644',0.449299,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17903,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 14644',NULL,17903,41.39,0.27,1900,4294,70,NULL,'SALT 2','SDSS-II SN 14644',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17904,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 14644',NULL,17904,41.48,0.27,1980,4294,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14644',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17905,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17905,36.24,0.81,177,4295,70,NULL,NULL,'2MASX J01361966-0828415',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.000105,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,24.081833,-8.47831,0.089,NULL,34990134788,546720856,8542513,16.3),(17906,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 04547','RN',17906,41.72,0.31,1530,4296,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 04547',0.441182,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17907,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 04547','RN',17907,41.9,0.34,1660,4296,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 04547',0.441182,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17908,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 04547','N',17908,41.61,0.21,2100,4296,70,NULL,'SALT 2','SDSS-II SN 04547',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17909,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 04547','N',17909,41.7,0.21,2190,4296,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 04547',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17910,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17910,37.86,0.46,373,4297,70,NULL,NULL,'2MASX J01362176+1522325',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000158,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,24.09075,15.37561,0.117,NULL,67426407505,1053537617,16461525,18),(17911,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 15806','R',17911,40.37,0.23,950,4298,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J013622.16-004950.3',0.25,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',0.01,NULL,'20.3g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,24.092333,-0.83067,0.029,NULL,34966486516,546351351,8536739,20.3),(17912,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 15806','R',17912,40.51,0.17,1010,4298,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J013622.16-004950.3',0.25,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17913,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 15806',NULL,17913,40.13,0.13,1060,4298,70,NULL,'SALT 2','SDSS J013622.16-004950.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17914,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 15806',NULL,17914,40.15,0.13,1070,4298,70,NULL,'SALT 2, Malmquist cor.','SDSS J013622.16-004950.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17915,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 11156','RN',17915,41.33,0.2,1410,4299,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 11156',0.309079,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17916,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 11156','RN',17916,41.68,0.38,1660,4299,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 11156',0.309079,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17917,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17917,34.32,NULL,73.1,4300,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01146',NULL,'2010Ap&SS.325..163P',2010,1,0.82,NULL,'G',0.00002,NULL,'17.',0.11,'Sdm',NULL,NULL,NULL,NULL,1,24.1007083,10.53592,0.193,NULL,67530668065,1055166688,16486979,17),(17918,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17918,34.33,NULL,73.5,4300,NULL,NULL,'Dipole + Quadrupole','UGC 01146',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17919,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17919,34.34,NULL,73.9,4300,NULL,NULL,'Dipole','UGC 01146',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17920,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17920,37.68,0.46,344,4301,70,NULL,NULL,'SDSS J013627.10-083527.5',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000076,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,24.1129583,-8.591,0.093,NULL,34990180208,546721565,8542524,17.9),(17921,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17921,38.41,0.46,481,4302,70,NULL,NULL,'SDSS J013627.58-004055.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000086,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,24.114917,-0.68203,0.029,NULL,34966615840,546353372,8536771,18.1),(17922,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17922,35.96,0.25,156,4303,74.4,NULL,NULL,'GIN 095',NULL,'2013AJ....146...86T',2013,1,0.44,NULL,'G',0.00004,NULL,'15.9g',0.37,'E/S0',NULL,NULL,NULL,NULL,1,24.115167,-9.47861,0.09,NULL,34982701649,546604713,8540698,15.9),(17923,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17923,36.15,0.16,170,4303,70,NULL,NULL,'GIN 095',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17924,'IRAS','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17924,34.4,0.8,75.8,4304,75,NULL,'MAT, I','ESO 353- G 026',NULL,'1997ApJS..109..333W',1997,1,1.6,'Da Costa, et al. (1998,AJ,116,1) give v = 5448 +/- 37 km/sec.','G',0.000033,NULL,'13.78',0.6,'SB(s)b: pec',NULL,NULL,NULL,NULL,1,24.115125,-36.37742,NULL,NULL,38303086894,598485732,9351339,13.78),(17925,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17925,33.71,0.43,55.2,4304,75,NULL,'MAT, I, raw','ESO 353- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17926,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17926,33.73,0.32,55.8,4304,85,NULL,'I, raw','ESO 353- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17927,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17927,33.78,0.32,56.9,4304,85,NULL,'I, inv','ESO 353- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17928,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17928,33.9,0.43,60.3,4304,75,NULL,'MAT, I, inv','ESO 353- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17929,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17929,33.97,0.2,62.2,4304,74.4,NULL,NULL,'ESO 353- G 026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17930,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17930,34.05,0.43,64.5,4304,75,NULL,'MAT, I, cor','ESO 353- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17931,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17931,34.06,0.49,65,4304,75,NULL,'IR','ESO 353- G 026',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17932,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17932,34.18,0.37,68.7,4304,NULL,NULL,NULL,'ESO 353- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17933,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17933,34.29,0.35,72.2,4304,NULL,NULL,'Malmquist cor.','ESO 353- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17934,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17934,38.44,0.33,488,4305,70,NULL,NULL,'SDSS J013632.50+151133.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,24.1354583,15.19264,0.117,NULL,67426400689,1053537510,16461523,18.5),(17935,'IRAS','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17935,33.75,0.8,56.4,4306,75,NULL,'MAT, I','ESO 013- G 018',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.00003,NULL,'16.05',0.22,'Sd',NULL,NULL,NULL,NULL,1,24.1404166667,-80.34722,0.329,NULL,35666546356,557289786,8707652,16.05),(17936,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17936,33.41,NULL,48.2,4306,NULL,NULL,NULL,'ESO 013- G 018',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17937,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17937,33.7,NULL,54.9,4306,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 013- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17938,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17938,33.7,NULL,54.9,4306,NULL,NULL,'Dipole + Quadrupole','ESO 013- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17939,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17939,33.73,NULL,55.7,4306,NULL,NULL,'Dipole','ESO 013- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17940,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17940,33.79,0.32,57.2,4306,85,NULL,'I, inv','ESO 013- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17941,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17941,33.79,0.32,57.4,4306,85,NULL,'I, raw','ESO 013- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17942,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17942,33.97,0.43,62.1,4306,75,NULL,'MAT, I, raw','ESO 013- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17943,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17943,34,0.43,63.2,4306,75,NULL,'MAT, I, inv','ESO 013- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17944,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17944,34.15,0.43,67.5,4306,75,NULL,'MAT, I, cor','ESO 013- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17945,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 14884','RN',17945,43.38,0.25,3420,4307,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 14884',0.388513,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17946,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 14884','RN',17946,43.4,0.25,3440,4307,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 14884',0.388513,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17947,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17947,38.26,0.33,449,4308,70,NULL,NULL,'2MASX J01363566-1031189',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000093,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,24.1485,-10.52175,0.037,NULL,35267284894,551051326,8610176,17.3),(17948,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17948,38.44,0.33,488,4309,70,NULL,NULL,'2MASX J01363857+1515256',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000188,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,24.1607917,15.25706,0.117,NULL,67426390095,1053537345,16461521,17.8),(17949,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17949,35.52,0.58,127,4310,70,NULL,NULL,'UGC 01151',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000107,NULL,'14.63',0.9,'S0-:',NULL,NULL,NULL,NULL,1,24.166125,-1.39558,0.062,NULL,34966353700,546349276,8536707,14.63),(17950,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17950,35.7,0.48,138,4311,70,NULL,NULL,'MCG -02-05-016',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.5',0.2,NULL,NULL,NULL,NULL,NULL,1,24.1690417,-13.88944,0,NULL,35185487209,549773237,8590206,15.5),(17951,'Brightest Stars','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17951,29.3,NULL,7.24,4312,NULL,NULL,NULL,'MESSIER 074',NULL,'1996AJ....111.2280S',1996,1,10.5,NULL,'G',0.000003,NULL,'9.95',9.5,'SA(s)c         HII','X-ray-faint group member',NULL,NULL,NULL,1,24.1739583,15.78367,0.117,NULL,67426466097,1053538532,16461539,9.95),(17952,'Brightest Stars','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17952,29.32,0.4,7.31,4312,NULL,NULL,NULL,'MESSIER 074',NULL,'1996A&AS..119..499S',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17953,'Brightest Stars','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17953,29.43,0.43,7.7,4312,NULL,NULL,NULL,'MESSIER 074',NULL,'2005MNRAS.359..906H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17954,'Brightest Stars','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17954,29.91,0.45,9.6,4312,NULL,NULL,NULL,'MESSIER 074',NULL,'2005MNRAS.359..906H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17955,'PNLF','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17955,29.67,0.06,8.59,4312,NULL,NULL,NULL,'MESSIER 074',NULL,'2008ApJ...683..630H',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17956,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17956,30.02,0.03,10.1,4312,NULL,NULL,'T, syst. +/- 0.12 mag','MESSIER 074',NULL,'2014ApJ...792...52J',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17957,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17957,30.04,0.03,10.2,4312,NULL,NULL,'I, syst +/- 0.12 mag','MESSIER 074',NULL,'2014ApJ...792...52J',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17958,'Grav. Stability Gas. Disk','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17958,29.87,NULL,9.4,4312,NULL,NULL,NULL,'MESSIER 074',NULL,'1996AstL...22...71Z',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17959,'HII region diameter','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17959,31.14,NULL,16.9,4312,NULL,NULL,NULL,'MESSIER 074',NULL,'1988ApL&C..27...41S',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17960,'SNII optical','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2002ap',NULL,17960,29.13,NULL,6.7,4312,NULL,NULL,'EPM','MESSIER 074',NULL,'2004A&A...427..453V',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17961,'SNII optical','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2003gd',NULL,17961,29.29,NULL,7.2,4312,NULL,NULL,NULL,'MESSIER 074',NULL,'2006PASP..118..351V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17962,'SNII optical','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2013ej','R',17962,29.33,0.44,7.35,4312,NULL,NULL,'EPM','MESSIER 074',NULL,'2014JAVSO..42..333R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17963,'SNII optical','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2003gd',NULL,17963,29.74,0.18,8.87,4312,NULL,NULL,'I, photospheric magnitude method','MESSIER 074',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17964,'SNII optical','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2003gd',NULL,17964,29.76,0.24,8.95,4312,NULL,NULL,'V, photospheric magnitude method','MESSIER 074',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17965,'SNII optical','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2013ej','R',17965,29.78,0.03,9.02,4312,NULL,NULL,'EPM, SN 2013ej + SN 2002ap, syst. +/- 0.60 mag','MESSIER 074',NULL,'2015arXiv150901721D',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17966,'SNII optical','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2013ej',NULL,17966,29.88,0.05,9.46,4312,NULL,NULL,'I, photospheric magnitude method','MESSIER 074',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17967,'SNII optical','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2003gd',NULL,17967,29.91,0.56,9.6,4312,NULL,NULL,'SCM','MESSIER 074',NULL,'2005MNRAS.359..906H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17968,'SNII optical','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2013ej','R',17968,29.93,0.13,9.7,4312,NULL,NULL,'EPM, SN 2013ej, syst. +/- 0.90 mag','MESSIER 074',NULL,'2015arXiv150901721D',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17969,'SNII optical','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2003gd',NULL,17969,29.94,0.54,9.73,4312,NULL,NULL,'SCM, I','MESSIER 074',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17970,'SNII optical','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2003gd',NULL,17970,29.98,0.28,9.91,4312,NULL,NULL,'SCM, BVI','MESSIER 074',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17971,'SNII optical','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2003gd',NULL,17971,29.98,0.55,9.91,4312,NULL,NULL,'SCM, V','MESSIER 074',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17972,'SNII optical','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2003gd',NULL,17972,29.99,0.42,9.95,4312,NULL,NULL,'SCM, B','MESSIER 074',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17973,'SNII optical','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2013ej',NULL,17973,30.01,0.07,10,4312,NULL,NULL,'V, photospheric magnitude method','MESSIER 074',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17974,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17974,27.45,NULL,3.09,4312,NULL,NULL,'LEDA [April 2006]','MESSIER 074',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17975,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17975,29.93,0.4,9.7,4312,75,NULL,'B','MESSIER 074',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17976,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17976,35.65,0.46,135,4313,70,NULL,NULL,'2MASX J01364389+1351306',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00008,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,24.1827917,13.85844,0.125,NULL,67414775136,1053355861,16458685,16.8),(17977,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17977,36.58,0.67,207,4314,70,NULL,NULL,'2MASX J01364618-1520594',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'16.55',0.34,NULL,NULL,NULL,NULL,NULL,1,24.192667,-15.34972,0,NULL,35196409919,549943904,8592873,16.55),(17978,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17978,34.22,0.4,69.7,4315,NULL,NULL,'mean','NGC 0631',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.00007,NULL,'14.25',1.5,'E','in a pair',NULL,NULL,NULL,1,24.1960833333,5.83536,0.117,NULL,67030084069,1047345063,16364766,14.25),(17979,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17979,35.7,0.45,138,4315,NULL,NULL,'K','NGC 0631',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17980,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17980,36.54,0.53,203,4316,70,NULL,NULL,'2MASX J01364805-1347064',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.42',0.22,NULL,NULL,NULL,NULL,NULL,1,24.2002917,-13.78503,0,NULL,35185490335,549773286,8590207,16.42),(17981,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17981,34.26,0.4,71.3,4317,NULL,NULL,'mean','NGC 0621',NULL,'2007A&A...465...71T',2007,1,1.9,'RC3 gives v = 3305 +/- 96 km/sec.','G',0.000067,NULL,'13.73',1.8,'SB0',NULL,NULL,NULL,NULL,1,24.2044166667,35.51219,0.133,NULL,67767221146,1058862830,16544731,13.73),(17982,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17982,34.49,0.45,78.9,4317,NULL,NULL,'K','NGC 0621',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17983,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17983,36.43,0.46,193,4318,70,NULL,NULL,'2MASX J01365279-0856230',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000073,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,24.21975,-8.93978,0.094,NULL,34994149283,546783582,8543493,16.7),(17984,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17984,36.6,0.57,209,4319,70,NULL,NULL,'2MASX J01365383-1405104',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.92',0.17,NULL,NULL,NULL,NULL,NULL,1,24.22425,-14.08628,0,NULL,35185385779,549771652,8590182,16.92),(17985,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17985,37.52,0.46,320,4320,70,NULL,NULL,'2MASX J01365484+1257501',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,24.2284583333,12.96406,0.137,NULL,67411812970,1053309577,16457962,17.6),(17986,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17986,35.76,0.81,142,4321,70,NULL,NULL,'2MASX J01365557-0500037',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.66',0.18,NULL,NULL,NULL,NULL,NULL,1,24.2315833333,-5.00119,0.099,NULL,34968331771,546380183,8537190,16.66),(17987,'IRAS','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17987,34.78,0.8,90.3,4322,75,NULL,'W91PP, r','UGC 01152',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.00002,NULL,'14.54',0.6,'Sb',NULL,NULL,NULL,NULL,1,24.2342916667,31.98531,0.161,NULL,67768908372,1058889193,16545143,14.54),(17988,'IRAS','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17988,34.78,0.8,90.4,4322,75,NULL,'CF, r','UGC 01152',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17989,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17989,34.49,0.34,78.9,4322,NULL,NULL,'Malmquist cor.','UGC 01152',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17990,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17990,34.72,0.38,87.8,4322,75,NULL,'CF, r, raw','UGC 01152',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17991,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17991,34.81,0.38,91.8,4322,75,NULL,'CF, r, inv','UGC 01152',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17992,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17992,34.85,0.38,93.2,4322,75,NULL,'CF, r, cor','UGC 01152',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17993,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17993,34.95,0.27,97.7,4322,NULL,NULL,NULL,'UGC 01152',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17994,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17994,35.04,0.38,102,4322,75,NULL,'W91PP, r, raw','UGC 01152',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17995,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17995,35.05,0.2,102,4322,74.4,NULL,NULL,'UGC 01152',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17996,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17996,35.17,0.38,108,4322,75,NULL,'W91PP, r, inv','UGC 01152',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17997,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17997,35.31,0.38,115,4322,75,NULL,'W91PP, r, cor','UGC 01152',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17998,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,17998,36.85,0.56,234,4323,70,NULL,NULL,'2MASX J01365698-1357563',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,24.237375,-13.96572,0,NULL,35185392001,549771750,8590183,15.3),(17999,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',17999,36.31,0.17,183,4324,70,NULL,NULL,'SDSS J013658.81-085701.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000089,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,24.245083,-8.95053,0.094,NULL,34994157826,546783716,8543495,18.2),(18000,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',18000,37,0.27,251,4325,70,NULL,NULL,'2MASX J01365929+1306591',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000169,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,24.2472083333,13.11628,0.137,NULL,67411791683,1053309245,16457956,17.7),(18001,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 17943','RN',18001,39.85,0.21,694,4326,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 17943',0.344193,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18002,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 17943','RN',18002,40.75,0.25,1050,4326,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 17943',0.344193,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18003,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',18003,37.64,0.46,337,4327,70,NULL,NULL,'2MASX J01370308+0013439',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000083,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,24.2630416667,0.22897,0.033,NULL,66976424691,1046506635,16351666,17.8),(18004,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',18004,38.31,0.46,459,4328,70,NULL,NULL,'SDSS J013703.69-005142.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000083,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,24.265375,-0.86189,0.029,NULL,34966513004,546351765,8536746,18.3),(18005,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',18005,36.57,0.46,206,4329,70,NULL,NULL,'2MASX J01370573-0909375',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000067,NULL,'17.7g',0.17,'AGN',NULL,NULL,NULL,NULL,1,24.2739583,-9.16033,0.092,NULL,34982821045,546606578,8540727,17.7),(18006,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18006,36.15,0.16,170,4330,70,NULL,NULL,'GIN 086',NULL,'2001MNRAS.321..277C',2001,1,0.45,NULL,'G',0.000137,NULL,'16.0g',0.39,'(R)Sb          Sy2',NULL,NULL,NULL,NULL,1,24.2789583,-9.14931,0.092,NULL,34982819310,546606551,8540727,16),(18007,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18007,35.63,0.5,134,4331,70,NULL,NULL,'MCG -03-05-009',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000123,NULL,'15.31',0.3,NULL,NULL,NULL,NULL,NULL,1,24.283625,-15.06158,0.011,NULL,35184056751,549750886,8589857,15.31),(18008,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',18008,36.31,0.17,183,4332,70,NULL,NULL,'2MASX J01370856-0921485',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000076,NULL,'16.0g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,24.285833,-9.36347,0.09,NULL,34982805198,546606331,8540723,16),(18009,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18009,36.54,0.6,203,4332,70,NULL,NULL,'2MASX J01370856-0921485',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18010,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 11038','RN',18010,39,0.34,596,4333,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 11038',0.055709,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18011,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 11038','RN',18011,40.95,0.71,1470,4333,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 11038',0.055709,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18012,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',18012,36.6,0.23,209,4334,70,NULL,NULL,'2MASX J01371285-0030153',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000113,NULL,'15.6g',0.4,'BrClG',NULL,NULL,NULL,NULL,1,24.303625,-0.50431,0.045,NULL,34966648559,546353883,8536779,15.6),(18013,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',18013,38.26,0.33,449,4335,70,NULL,NULL,'2MASX J01371327-1038195',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000086,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,24.30525,-10.63872,0.023,NULL,34981073971,546579280,8540301,18),(18014,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',18014,37.48,0.46,313,4336,70,NULL,NULL,'SDSS J013715.06-083914.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000074,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,24.31275,-8.65414,0.093,NULL,34994276342,546785567,8543524,18),(18015,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18015,35.96,0.25,156,4337,74.4,NULL,NULL,'MCG -02-05-020',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.00004,NULL,'14.33',1.1,'SA0-;BrClG',NULL,NULL,NULL,NULL,1,24.313917,-9.19764,0.092,NULL,34982817497,546606523,8540726,14.33),(18016,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18016,36.15,0.16,170,4337,70,NULL,NULL,'MCG -02-05-020',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18017,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18017,36.33,0.4,185,4337,NULL,NULL,'mean','MCG -02-05-020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18018,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18018,36.43,0.45,193,4337,NULL,NULL,'K','MCG -02-05-020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18019,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18019,35.95,0.25,155,4338,74.4,NULL,NULL,'GIN 094',NULL,'2013AJ....146...86T',2013,1,0.43,NULL,'G',0.00004,NULL,'16.3g',0.3,'S',NULL,NULL,NULL,NULL,1,24.3152917,-9.02572,0.094,NULL,34994356351,546786817,8543544,16.3),(18020,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18020,36.15,0.16,170,4338,70,NULL,NULL,'GIN 094',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18021,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18021,36.35,0.68,186,4338,70,NULL,NULL,'GIN 094',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18022,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18022,36.59,0.61,208,4339,70,NULL,NULL,'2MASX J01371682-0645215',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'17.35',0.27,NULL,NULL,NULL,NULL,NULL,1,24.320083,-6.75603,0.146,NULL,34992357993,546755593,8543056,17.35),(18023,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 18993',NULL,18023,40,0.3,1000,4340,70,NULL,'SN photometric redshift distance, z photo =0.269 +/- 0.047','SDSS-II SN 18993',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,24.3205417,-0.50392,0.045,NULL,34966644700,546353823,8536778,NULL),(18024,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 18993',NULL,18024,41.33,0.15,1850,4340,70,NULL,'SALT 2','SDSS-II SN 18993',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18025,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 18993',NULL,18025,41.37,0.15,1880,4340,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18993',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18026,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 1998es',NULL,18026,32.18,0.31,27,4341,74.2,NULL,'SALT 2','NGC 0632',0.01057,'2010ApJ...716..712A',2010,1,1.5,NULL,'G',0.00002,NULL,'13.4B',1.2,'S0?            Sbrst','in a radial-velocity based grouping',NULL,NULL,'Starburst',1,24.3230416667,5.87764,0.109,NULL,67029820014,1047340937,16364702,13.4),(18027,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 1998es',NULL,18027,32.82,0.09,36.6,4341,74.4,NULL,NULL,'NGC 0632',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18028,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 1998es',NULL,18028,32.89,0.02,37.4,4341,72,NULL,NULL,'NGC 0632',0.01057,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18029,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 1998es',NULL,18029,32.89,0.22,37.4,4341,72,NULL,NULL,'NGC 0632',0.01057,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18030,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 1998es',NULL,18030,32.95,0.35,38.5,4341,70,NULL,'SALT','NGC 0632',0.01057,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18031,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 1998es',NULL,18031,33.05,0.12,40.7,4341,70.8,NULL,NULL,'NGC 0632',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18032,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 1998es',NULL,18032,33.26,0.08,44,4341,65,NULL,'MLCS2k2','NGC 0632',0.01057,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18033,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 1998es',NULL,18033,33.34,0.3,46.6,4341,60,NULL,NULL,'NGC 0632',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18034,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18034,36.69,0.56,218,4342,70,NULL,NULL,'2MASX J01372116-1338458',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.67',0.19,NULL,NULL,NULL,NULL,NULL,1,24.3382083,-13.64611,0,NULL,35185261483,549769710,8590151,16.67),(18035,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',18035,38.19,0.46,434,4343,70,NULL,NULL,'SDSS J013722.50+151810.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000164,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,24.34375,15.303,0.121,NULL,67425735180,1053527112,16461361,18.2),(18036,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18036,35.95,0.25,155,4344,74.4,NULL,NULL,'MCG -02-05-024',NULL,'2013AJ....146...86T',2013,1,0.69,NULL,'G',0.000043,NULL,'15.3g',0.59,'E/SO;BrClG',NULL,NULL,NULL,NULL,1,24.346417,-9.27053,0.092,NULL,34982764821,546605700,8540714,15.3),(18037,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18037,36.15,0.16,170,4344,70,NULL,NULL,'MCG -02-05-024',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18038,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',18038,36.31,0.17,183,4344,70,NULL,NULL,'MCG -02-05-024',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18039,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18039,35.95,0.25,155,4345,74.4,NULL,NULL,'GIN 093',NULL,'2013AJ....146...86T',2013,1,0.47,NULL,'G',0.00004,NULL,'15.7g',0.46,'E/S0',NULL,NULL,NULL,NULL,1,24.3472083,-9.09964,0.092,NULL,34982741291,546605332,8540708,15.7),(18040,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18040,36.15,0.16,170,4345,70,NULL,NULL,'GIN 093',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18041,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',18041,36.31,0.17,183,4345,70,NULL,NULL,'GIN 093',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18042,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18042,35.95,0.25,155,4346,74.4,NULL,NULL,'MCG -02-05-022',NULL,'2013AJ....146...86T',2013,1,0.68,'Not to be confused with the Seyfert IRAS  01346-0924 (PGC 005996).','G',0.000037,NULL,'15.0g',0.64,'E/S0',NULL,NULL,NULL,NULL,1,24.347583,-9.16867,0.092,NULL,34982748088,546605438,8540709,15),(18043,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18043,36.15,0.16,170,4346,70,NULL,NULL,'MCG -02-05-022',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18044,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',18044,36.31,0.17,183,4346,70,NULL,NULL,'MCG -02-05-022',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18045,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2007ol',NULL,18045,36.69,0.09,218,4347,70,NULL,'SALT 2','2MASX J01372378-0018422',NULL,'2013ApJ...763...88C',2013,1,0.26,NULL,'G',0.000063,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,24.3490833333,-0.31172,0.045,NULL,34966244938,546347577,8536680,17.1),(18046,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2007ol',NULL,18046,36.69,0.09,218,4347,70,NULL,'SALT 2, Malmquist cor.','2MASX J01372378-0018422',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18047,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 19968','R',18047,36.9,0.19,227,4347,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ol','2MASX J01372378-0018422',0.055908,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18048,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 19968','R',18048,37.23,0.05,265,4347,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ol','2MASX J01372378-0018422',0.055908,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18049,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',18049,37.88,0.46,377,4348,70,NULL,NULL,'2MASX J01372447+1453068',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,24.351875,14.88533,0.129,NULL,67412025817,1053312903,16458014,17.6),(18050,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 15692','RN',18050,40.34,0.12,1000,4349,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15692',0.168803,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18051,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 15692','RN',18051,40.48,0.21,1070,4349,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15692',0.168803,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18052,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18052,35.97,0.25,156,4350,74.4,NULL,NULL,'GIN 090',NULL,'2013AJ....146...86T',2013,1,0.48,NULL,'G',0.000037,NULL,'16.1g',0.42,'SB',NULL,NULL,NULL,NULL,1,24.355875,-8.93147,0.094,NULL,34994371388,546787052,8543547,16.1),(18053,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18053,36.15,0.16,170,4350,70,NULL,NULL,'GIN 090',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18054,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',18054,36.34,0.33,185,4351,70,NULL,NULL,'2MASX J01372540+0058379',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.0001,NULL,'15.8g',0.44,'E0',NULL,NULL,NULL,NULL,1,24.355875,0.97733,0.081,NULL,66976215022,1046503359,16351614,15.8),(18055,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',18055,36.31,0.17,183,4352,70,NULL,NULL,'2MASX J01372676-0913029',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000074,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,24.361625,-9.21753,0.092,NULL,34982773759,546605839,8540716,16.6),(18056,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',18056,36.6,0.23,209,4353,70,NULL,NULL,'2MASX J01372692-0025062',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00015,NULL,'16.06',0.35,NULL,NULL,NULL,NULL,NULL,1,24.362083,-0.4185,0.045,NULL,34966818004,546356531,8536820,16.06),(18057,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 04701','RN',18057,43.32,0.34,2850,4354,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04701',0.620947,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18058,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 01461','R',18058,41.06,0.24,1210,4355,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J013729.43+001234.7',0.3407,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',0.0005,NULL,'21.7g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,24.372667,0.20967,0.045,NULL,66976313436,1046504897,16351639,21.7),(18059,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 01461','R',18059,41.07,0.16,1220,4355,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J013729.43+001234.7',0.3407,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18060,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 01461',NULL,18060,40.92,0.14,1530,4355,70,NULL,'SALT 2','SDSS J013729.43+001234.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18061,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 01461',NULL,18061,40.96,0.14,1560,4355,70,NULL,'SALT 2, Malmquist cor.','SDSS J013729.43+001234.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18062,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',18062,38.07,0.46,411,4356,70,NULL,NULL,'2MASX J01373275+0059132',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000085,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,24.3866666667,0.98714,0.081,NULL,66976178844,1046502794,16351606,17.4),(18063,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18063,34.39,0.48,75.6,4357,70,NULL,NULL,'ESO 244- G 039',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'14.48',0.43,'(R:)SB(rl)0/a',NULL,NULL,NULL,NULL,1,24.3914583333,-42.67394,NULL,NULL,38382685149,599729455,9370772,14.48),(18064,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 17080','RN',18064,42.76,0.37,2740,4358,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 17080',0.303636,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18065,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18065,36.32,0.5,184,4359,70,NULL,NULL,'MCG -02-05-027',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'14.5',0.5,NULL,NULL,NULL,NULL,NULL,1,24.4049583333,-12.51889,0,NULL,35182048427,549719506,8589367,14.5),(18066,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18066,35.27,0.47,113,4360,70,NULL,NULL,'MCG -01-05-010',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.000077,NULL,'15.18',0.25,NULL,NULL,NULL,NULL,NULL,1,24.4100833333,-5.06222,0.088,NULL,35023215945,547237749,8550589,15.18),(18067,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 04702','RN',18067,38.37,0.22,447,4361,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04702',0.055995,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18068,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 04702','RN',18068,39.6,0.56,788,4361,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04702',0.055995,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18069,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',18069,36.6,0.23,209,4362,70,NULL,NULL,'2MASX J01373935-0024284',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000077,NULL,'17.2g',0.07,NULL,NULL,NULL,NULL,NULL,1,24.414083,-0.408,0.033,NULL,34966824342,546356630,8536822,17.2),(18070,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18070,35.86,0.49,149,4363,70,NULL,NULL,'IC 0144',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000077,NULL,'15',0.6,NULL,NULL,NULL,NULL,NULL,1,24.4202083,-13.31467,0,NULL,35182593428,549728022,8589500,15),(18071,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18071,36.99,0.7,250,4364,70,NULL,NULL,'2MASX J01374334-0029104',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.000081,NULL,'16.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,24.4305,-0.48619,0.033,NULL,34966860889,546357201,8536831,16.6),(18072,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 15108','R',18072,41.53,0.26,1420,4365,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15108',0.420066,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,24.434667,-0.54161,0.033,NULL,34966862657,546357229,8536831,NULL),(18073,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 15108',NULL,18073,40.88,0.17,1500,4365,70,NULL,'SN photometric redshift distance, z photo =0.442 +/- 0.048','SDSS-II SN 15108',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18074,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 15108','R',18074,42.16,0.35,1900,4365,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15108',0.420066,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18075,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 13205','RN',18075,41.39,0.3,1340,4366,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13205',0.41844,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18076,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 13205','RN',18076,41.63,0.36,1490,4366,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13205',0.41844,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18077,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 16039',NULL,18077,41.01,0.17,1590,4367,70,NULL,'SN photometric redshift distance, z photo =0.477 +/- 0.054','SDSS-II SN 16039',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,24.451125,-1.09667,0.025,NULL,34966438878,546350607,8536728,NULL),(18078,'BL Lac Luminosity','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18078,38.42,NULL,483,4368,NULL,NULL,'Min. z = 0.12','1FGL J0137.8+5814',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,24.453,58.249,NULL,NULL,65855789813,1028996715,16078073,NULL),(18079,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18079,35.95,0.25,155,4369,74.4,NULL,NULL,'GIN 089',NULL,'2013AJ....146...86T',2013,1,0.58,NULL,'G',0.000037,NULL,'15.8g',0.39,'S',NULL,NULL,NULL,NULL,1,24.459375,-8.98056,0.109,NULL,34994231242,546784863,8543513,15.8),(18080,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18080,36.15,0.16,170,4369,70,NULL,NULL,'GIN 089',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18081,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',18081,37.2,0.46,275,4370,70,NULL,NULL,'2MASX J01375195-0905479',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000084,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,24.466375,-9.09656,0.092,NULL,34982784782,546606012,8540718,17.3),(18082,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 07936','RN',18082,39.07,0.49,625,4371,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07936',0.043743,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18083,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 07936','RN',18083,39.36,0.29,713,4371,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 07936',0.043743,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18084,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',18084,38.36,0.46,471,4372,70,NULL,NULL,'SDSS J013754.32-002129.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000076,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,24.476333,-0.35831,0.033,NULL,34966754263,546355535,8536805,18.1),(18085,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',18085,36.34,0.33,185,4373,70,NULL,NULL,'UGC 01163',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000113,NULL,'15.0g',0.66,'COMPACT',NULL,NULL,NULL,NULL,1,24.482125,1.00136,0.049,NULL,66976120800,1046501887,16351591,15),(18086,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18086,35.96,0.25,156,4374,74.4,NULL,NULL,'GIN 088',NULL,'2013AJ....146...86T',2013,1,0.66,NULL,'G',0.000043,NULL,'15.6g',0.34,'E/S0',NULL,NULL,NULL,NULL,1,24.4995417,-9.00719,0.109,NULL,34994245977,546785093,8543517,15.6),(18087,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18087,36.15,0.16,170,4374,70,NULL,NULL,'GIN 088',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18088,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18088,36.27,0.55,179,4374,70,NULL,NULL,'GIN 088',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18089,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',18089,36.31,0.17,183,4374,70,NULL,NULL,'GIN 088',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18090,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 13003','RN',18090,43.1,0.22,2900,4375,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13003',0.433231,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18091,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 13003','RN',18091,44.04,0.21,4490,4375,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13003',0.433231,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18092,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',18092,37,0.27,251,4376,70,NULL,NULL,'2MASX J01380357+1318192',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.40',0.26,'BrClG',NULL,NULL,NULL,NULL,1,24.5149583333,13.30544,0.121,NULL,67411335596,1053302118,16457845,17.4),(18093,'IRAS','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18093,34.34,0.8,73.9,4377,75,NULL,'HMCL, I','UGC 01160',NULL,'1997ApJS..109..333W',1997,1,1.83,NULL,'G',0.000023,NULL,'15.57',0.19,'Sd',NULL,NULL,NULL,NULL,1,24.5152917,32.49414,0.109,NULL,67776317696,1059004964,16546952,15.57),(18094,'IRAS','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18094,34.34,0.8,73.9,4377,75,NULL,'W91PP, r','UGC 01160',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18095,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',18095,33.97,0.49,62.3,4377,75,NULL,'IR','UGC 01160',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18096,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18096,34.07,NULL,65.2,4377,NULL,NULL,NULL,'UGC 01160',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18097,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18097,34.07,NULL,65.2,4377,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01160',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18098,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18098,34.08,NULL,65.5,4377,NULL,NULL,'Dipole + Quadrupole','UGC 01160',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18099,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18099,34.08,NULL,65.6,4377,NULL,NULL,'Dipole','UGC 01160',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18100,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18100,34.1,0.4,66.1,4377,75,NULL,'HMCL, I, raw','UGC 01160',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18101,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18101,34.21,0.4,69.6,4377,75,NULL,'HMCL, I, inv','UGC 01160',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18102,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18102,34.23,0.43,70,4377,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01160',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18103,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18103,34.26,0.4,71,4377,75,NULL,'HMCL, I, cor','UGC 01160',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18104,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18104,34.31,0.43,72.8,4377,75,NULL,'3.6 micron, color corrected','UGC 01160',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18105,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18105,34.34,0.2,73.8,4377,74.4,NULL,NULL,'UGC 01160',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18106,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18106,34.35,0.15,74.3,4377,NULL,NULL,NULL,'UGC 01160',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18107,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18107,34.41,0.38,76.3,4377,75,NULL,'W91PP, r, raw','UGC 01160',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18108,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18108,34.47,0.38,78.4,4377,75,NULL,'W91PP, r, inv','UGC 01160',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18109,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18109,34.49,0.38,79.1,4377,75,NULL,'W91PP, r, cor','UGC 01160',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18110,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 15004','RN',18110,42.94,0.24,2990,4378,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15004',0.299763,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18111,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 15004','RN',18111,43.1,0.28,3210,4378,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15004',0.299763,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18112,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 05920','RN',18112,40.18,0.13,1000,4379,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 05920',0.081664,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18113,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SDSS-II SN 05920','RN',18113,40.2,0.22,1010,4379,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 05920',0.081664,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18114,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18114,36.52,0.54,202,4380,70,NULL,NULL,'2MASX J01381318-0929001',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00009,NULL,'15.9g',0.32,'Sa',NULL,NULL,NULL,NULL,1,24.5550417,-9.48342,0.076,NULL,34983614051,546618969,8540921,15.9),(18115,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18115,36.36,0.7,187,4381,70,NULL,NULL,'2MASX J01381400-0234321',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000137,NULL,'13.9I',0.4,NULL,NULL,NULL,NULL,NULL,1,24.55825,-2.57558,0.079,NULL,34979948983,546561702,8540026,13.9),(18116,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18116,35.71,0.54,138,4382,70,NULL,NULL,'2MASX J01381512-1947310',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.44',0.25,'S',NULL,NULL,NULL,NULL,1,24.562917,-19.79189,0,NULL,35173081247,549579394,8587178,16.44),(18117,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2001eh',NULL,18117,35.25,0.16,108,4383,74.2,NULL,'SALT 2','UGC 01162',0.037036,'2010ApJ...716..712A',2010,1,1.5,NULL,'G',0.000113,NULL,'14.60',1.4,'SB(r)b',NULL,NULL,NULL,NULL,1,24.564417,41.65397,0.353,NULL,67903555696,1060993057,16578016,14.6),(18118,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2001eh',NULL,18118,35.61,0.03,127,4383,70,NULL,'SALT 2','UGC 01162',0.037036,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18119,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2001eh',NULL,18119,35.81,0.09,145,4383,74.4,NULL,NULL,'UGC 01162',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18120,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2001eh',NULL,18120,35.91,0.03,147,4383,72,NULL,'SALT2','UGC 01162',0.037036,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18121,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2001eh',NULL,18121,36.04,0.15,156,4383,70,NULL,'SALT 2','UGC 01162',0.037036,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18122,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2001eh',NULL,18122,36.05,0.15,157,4383,73.8,NULL,'SALT 2 (SNANA)','UGC 01162',0.0371,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18123,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2001eh',NULL,18123,36.1,0.18,160,4383,65,NULL,'SALT2','UGC 01162',0.037036,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18124,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2001eh',NULL,18124,36.18,0.16,166,4383,65,NULL,'SALT','UGC 01162',0.037036,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18125,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2001eh',NULL,18125,36.27,0.13,173,4383,65,NULL,'MLCS17','UGC 01162',0.037036,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18126,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2001eh',NULL,18126,36.3,0.12,175,4383,65,NULL,'MLCS31','UGC 01162',0.037036,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18127,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:49','1','SN 2001eh',NULL,18127,38.07,0.2,396,4383,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','UGC 01162',0.037036,'2011A&A...526A..81B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18128,'FP','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',18128,37,0.27,251,4384,70,NULL,NULL,'2MASX J01381654+1318085',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000156,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,24.568875,13.30242,0.133,NULL,67411162760,1053299418,16457803,17),(18129,'IRAS','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18129,33.97,0.8,62.2,4385,75,NULL,'W91PP, r','NGC 0634',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000027,NULL,'13.89',0.6,'Sa','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,24.57775,35.36483,0.177,NULL,67767308281,1058864191,16544752,13.89),(18130,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18130,34.01,0.47,63.4,4385,NULL,NULL,'H','NGC 0634',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18131,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18131,34.02,0.45,63.5,4385,NULL,NULL,'K','NGC 0634',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18132,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18132,34.1,0.46,66.2,4385,NULL,NULL,'J','NGC 0634',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18133,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18133,34.15,0.4,67.5,4385,NULL,NULL,'mean','NGC 0634',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18134,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18134,34.25,0.38,70.7,4385,75,NULL,'W91PP, r, raw','NGC 0634',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18135,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,'R',18135,34.28,0.49,71.8,4385,75,NULL,'IR','NGC 0634',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18136,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18136,34.37,0.38,75,4385,75,NULL,'W91PP, r, cor','NGC 0634',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18137,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18137,34.5,0.38,79.3,4385,75,NULL,'W91PP, r, inv','NGC 0634',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18138,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18138,33.79,0.55,57.3,4386,NULL,NULL,NULL,'UGC 01167',NULL,'2009ApJS..182..474S',2009,1,2.7,NULL,'G',0.000024,NULL,'14.0',2.1,'SA(rs)cd','Isolated galaxy',NULL,NULL,NULL,1,24.586875,7.53414,0.101,NULL,67015614679,1047118979,16361234,14),(18139,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18139,33.83,0.2,58.3,4386,74.4,NULL,NULL,'UGC 01167',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18140,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18140,33.93,0.4,61,4386,NULL,NULL,'mean','UGC 01167',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18141,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18141,33.98,0.5,62.5,4386,NULL,NULL,'Malmquist cor.','UGC 01167',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18142,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:49','1',NULL,NULL,18142,34.29,0.47,72.1,4386,NULL,NULL,'H','UGC 01167',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18143,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18143,35.96,0.25,156,4387,74.4,NULL,NULL,'GIN 092',NULL,'2013AJ....146...86T',2013,1,0.41,NULL,'G',0.00004,NULL,'16.3g',0.32,'S',NULL,NULL,NULL,NULL,1,24.5928333333,-8.97539,0.109,NULL,34994208095,546784501,8543507,16.3),(18144,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18144,36.15,0.16,170,4387,70,NULL,NULL,'GIN 092',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18145,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 04480','RN',18145,41.6,0.18,1560,4388,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 04480',0.338711,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18146,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 04480','RN',18146,42.02,0.23,1890,4388,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 04480',0.338711,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18147,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18147,36.6,0.23,209,4389,70,NULL,NULL,'MCG +00-05-018',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00009,NULL,'15.5g',0.22,'E0',NULL,NULL,NULL,NULL,1,24.6019166667,-0.20581,0.033,NULL,34966786426,546356037,8536813,15.5),(18148,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 01431','RN',18148,41.98,0.18,1950,4390,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01431',0.275318,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18149,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 01431','RN',18149,42.25,0.2,2210,4390,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01431',0.275318,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18150,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18150,36.24,0.77,177,4391,70,NULL,NULL,'MRK 1161',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.000084,NULL,'16.2g',0.18,'Sa',NULL,NULL,NULL,NULL,1,24.6157083,-9.16286,0.109,NULL,34983459457,546616554,8540883,16.2),(18151,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18151,35.44,0.52,122,4392,NULL,NULL,'Malmquist cor.','ESO 353- G 029',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.43',0.7,'SBbc? pec      HII',NULL,NULL,NULL,NULL,1,24.6187083333,-33.60794,NULL,NULL,38318305834,598723528,9355055,14.43),(18152,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18152,35.5,0.5,126,4392,NULL,NULL,NULL,'ESO 353- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18153,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18153,35.54,0.2,128,4392,74.4,NULL,NULL,'ESO 353- G 029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18154,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18154,35.37,NULL,118,4393,NULL,NULL,'Dipole','UGC 01165',NULL,'2010Ap&SS.325..163P',2010,1,1.53,NULL,'G',0.000014,NULL,'15.62',0.18,'Sbc','Isolated galaxy',NULL,NULL,NULL,1,24.6305417,28.72353,0.265,NULL,67727060378,1058235318,16534926,15.62),(18155,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18155,35.37,NULL,119,4393,NULL,NULL,'Dipole + Quadrupole','UGC 01165',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18156,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18156,35.37,NULL,119,4393,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01165',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18157,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18157,35.55,NULL,129,4393,NULL,NULL,NULL,'UGC 01165',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18158,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18158,35.63,0.49,133,4393,75,NULL,'IR','UGC 01165',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18159,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 21347','RN',18159,41.92,0.42,1630,4394,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21347',0.486695,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18160,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 21347','N',18160,41.38,0.36,1890,4394,70,NULL,'SALT 2','SDSS-II SN 21347',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18161,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 21347','N',18161,41.51,0.36,2000,4394,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 21347',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18162,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18162,38.01,0.46,400,4395,70,NULL,NULL,'SDSS J013838.90+134827.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,24.662083,13.80775,0.149,NULL,67412485837,1053320091,16458126,18.4),(18163,'D-Sigma','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18163,33.83,0.4,58.2,4396,75,NULL,'Edat, raw','NGC 0641',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000057,NULL,'13.06',1.3,'E',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,24.6634583333,-42.52753,NULL,NULL,38382991078,599734235,9370847,13.06),(18164,'D-Sigma','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18164,34.16,0.4,68,4396,75,NULL,'Edat, cor','NGC 0641',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18165,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18165,34.77,0.4,89.9,4396,NULL,NULL,'mean','NGC 0641',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18166,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18166,34.81,0.45,91.5,4396,NULL,NULL,'K','NGC 0641',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18167,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18167,35.55,0.48,129,4397,70,NULL,NULL,'NGC 0648',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000143,NULL,'14.5',0.5,'SA0- pec:',NULL,NULL,NULL,NULL,1,24.6657917,-17.83119,0,NULL,35191103048,549860985,8591577,14.5),(18168,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18168,37.64,0.46,338,4398,70,NULL,NULL,'2MASX J01383999-0916292',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000088,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,24.666625,-9.27467,0.078,NULL,34983481814,546616903,8540889,17.2),(18169,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18169,35.48,0.51,125,4399,70,NULL,NULL,'ESO 543- G 007',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000113,NULL,'14.97',0.5,'Sa',NULL,NULL,NULL,NULL,1,24.673,-20.24978,0,NULL,35173381607,549584087,8587251,14.97),(18170,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 19344','R',18170,40.22,0.18,852,4400,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19344',0.299019,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,24.684917,0.37661,0.029,NULL,66975891608,1046498306,16351536,NULL),(18171,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 19344','R',18171,40.4,0.26,926,4400,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19344',0.299019,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18172,'IRAS','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18172,34.07,0.8,65.1,4401,75,NULL,'MAT, I','ESO 003- G 003',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000027,NULL,'14.70',0.7,'SAB(rs)c','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,24.6989583,-83.36431,0.441,NULL,35479851007,554372671,8662072,14.7),(18173,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18173,33.49,0.32,49.9,4401,85,NULL,'I, raw','ESO 003- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18174,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18174,33.53,0.32,50.8,4401,85,NULL,'I, inv','ESO 003- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18175,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18175,33.67,0.43,54.2,4401,75,NULL,'MAT, I, raw','ESO 003- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18176,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18176,33.86,0.43,59.1,4401,75,NULL,'MAT, I, inv','ESO 003- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18177,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18177,33.88,0.43,59.7,4401,75,NULL,'MAT, I, cor','ESO 003- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18178,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18178,34.07,0.34,65,4401,NULL,NULL,'Malmquist cor.','ESO 003- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18179,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18179,34.1,0.33,65.9,4401,NULL,NULL,NULL,'ESO 003- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18180,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18180,34.14,0.2,67.3,4401,74.4,NULL,NULL,'ESO 003- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18181,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18181,34.43,0.4,76.9,4401,NULL,NULL,'mean','ESO 003- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18182,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18182,34.55,0.47,81.2,4401,NULL,NULL,'H','ESO 003- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18183,'BCG','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18183,37.72,0.35,327,4402,60,NULL,'ABELL 0225, BCG','2MASX J01384892+1849311',0.0692,'1980ApJ...241..486H',1980,1,0.4,NULL,'G',0.0001,NULL,'14.0',0.28,'cD','Brightest group member',NULL,'radio jet',NULL,1,24.7040833333,18.82539,0.093,NULL,67432757435,1053636834,16463075,14),(18184,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18184,35.32,0.33,116,4403,70,NULL,NULL,'CGCG 437-007',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000165,NULL,'15.6g',0.54,'E0',NULL,NULL,NULL,NULL,1,24.7164583,15.04969,0.113,NULL,67411927372,1053311365,16457990,15.6),(18185,'IRAS','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18185,34.53,0.8,80.4,4404,75,NULL,'MAT, I','NGC 0644',NULL,'1997ApJS..109..333W',1997,1,1.07,'RC3 gives v= 11900+/-190 km/sec.','G',0.000033,NULL,'14.74',0.54,'SB(s)c',NULL,NULL,NULL,NULL,1,24.720667,-42.58528,NULL,NULL,38382987335,599734177,9370846,14.74),(18186,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18186,33.9,0.32,60.3,4404,85,NULL,'I, raw','NGC 0644',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18187,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18187,33.94,0.32,61.3,4404,85,NULL,'I, inv','NGC 0644',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18188,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18188,33.97,0.43,62.3,4404,75,NULL,'MAT, I, raw','NGC 0644',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18189,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18189,34.15,0.43,67.5,4404,75,NULL,'MAT, I, inv','NGC 0644',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18190,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18190,34.15,NULL,67.6,4404,NULL,NULL,'B','NGC 0644',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18191,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18191,34.18,NULL,68.6,4404,NULL,NULL,'I','NGC 0644',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18192,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18192,34.36,0.43,74.4,4404,75,NULL,'MAT, I, cor','NGC 0644',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18193,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18193,34.54,0.39,80.8,4404,NULL,NULL,NULL,'NGC 0644',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18194,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18194,34.55,0.38,81.3,4404,NULL,NULL,'Malmquist cor.','NGC 0644',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18195,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18195,34.58,0.2,82.4,4404,74.4,NULL,NULL,'NGC 0644',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18196,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18196,37.36,0.46,297,4405,70,NULL,NULL,'2MASX J01385445+1517519',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000168,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,24.7267917,15.29792,0.113,NULL,67425562366,1053524411,16461318,17.1),(18197,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 18836','R',18197,40.85,0.23,1140,4406,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J013854.73-000157.8',0.3003,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',0.01,NULL,'22.3g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,24.7280416667,-0.03272,0.025,NULL,34965893069,546342079,8536594,22.3),(18198,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 18836','R',18198,41.15,0.32,1310,4406,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J013854.73-000157.8',0.3003,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18199,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 18836',NULL,18199,41.02,0.2,1600,4406,70,NULL,'SALT 2','SDSS J013854.73-000157.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18200,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 18836',NULL,18200,41.05,0.2,1620,4406,70,NULL,'SALT 2, Malmquist cor.','SDSS J013854.73-000157.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18201,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18201,35.32,0.33,116,4407,70,NULL,NULL,'CGCG 437-008',NULL,'2015arXiv151105856S',2015,1,0.93,NULL,'G',0.00009,NULL,'14.8g',0.66,'E0',NULL,NULL,NULL,NULL,1,24.7282083333,15.02158,0.137,NULL,67411930401,1053311412,16457990,14.8),(18202,'BCG','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18202,37.72,0.35,327,4408,60,NULL,NULL,'ABELL 0225',0.0692,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III [BM]',NULL,NULL,NULL,NULL,1,24.7297083,18.88686,0.093,NULL,67432222330,1053628473,16462944,NULL),(18203,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18203,36.14,0.46,169,4409,70,NULL,NULL,'2MASX J01385582+0052114',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000062,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,24.732583,0.86972,0.073,NULL,66989922487,1046717538,16354961,17.1),(18204,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 19140',NULL,18204,40,0.33,998,4410,70,NULL,'SN photometric redshift distance, z photo =0.268 +/- 0.052','SDSS-II SN 19140',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,24.7394583,-1.16539,0.025,NULL,34977812435,546528319,8539504,NULL),(18205,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18205,34.7,0.45,87.2,4411,NULL,NULL,'K','ESO 244- G 045',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000063,NULL,'13.61',0.9,'SA0^-',NULL,NULL,NULL,NULL,1,24.7436666667,-46.57331,NULL,NULL,38361074780,599391793,9365496,13.61),(18206,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18206,34.81,0.4,91.5,4411,NULL,NULL,'mean','ESO 244- G 045',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18207,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18207,34.61,0.85,83.7,4412,NULL,NULL,'Malmquist cor.','NGC 0639',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000143,NULL,'15.05',0.2,'Sa?','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,24.7460417,-29.92533,NULL,NULL,38258270297,597785473,9340398,15.05),(18208,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18208,35.14,0.49,107,4412,75,NULL,'IR','NGC 0639',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18209,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18209,35.59,0.54,131,4412,NULL,NULL,NULL,'NGC 0639',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18210,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18210,35.63,0.2,134,4412,74.4,NULL,NULL,'NGC 0639',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18211,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18211,37.65,0.46,340,4413,70,NULL,NULL,'2MASX J01385919+1341449',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00016,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,24.746667,13.69578,0.133,NULL,66926685535,1045729461,16339522,17.2),(18212,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 16160',NULL,18212,39.3,0.95,724,4414,70,NULL,'SN photometric redshift distance, z photo =0.186 +/- 0.121','SDSS-II SN 16160',NULL,'2011ApJ...738..162S',2011,1,0.1,NULL,'G',NULL,'PHOT','20.8g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,24.7642083333,-0.95292,0.025,NULL,34978291937,546535811,8539622,20.8),(18213,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 16160',NULL,18213,40.15,0.36,1070,4414,70,NULL,NULL,'SDSS-II SN 16160',NULL,'2013MNRAS.434.1443X',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18214,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 16160','R',18214,40.99,0.35,1190,4414,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 16160',0.320367,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18215,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 16160','R',18215,41.1,0.34,1260,4414,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 16160',0.320367,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18216,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 16160',NULL,18216,40.74,0.25,1410,4414,70,NULL,'SALT 2','SDSS-II SN 16160',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18217,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 16160',NULL,18217,40.77,0.25,1430,4414,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16160',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18218,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 14827',NULL,18218,38.83,1.96,584,4415,70,NULL,'SN photometric redshift distance, z photo =0.147 +/- 0.271','SDSS-II SN 14827',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','23.9g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,24.7724583,-0.36622,0.013,NULL,34966018247,546344035,8536625,23.9),(18219,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 14827','R',18219,41.93,0.29,1720,4415,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14827',0.410778,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18220,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 14827','R',18220,41.96,0.32,1750,4415,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14827',0.410778,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18221,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 14827',NULL,18221,41.88,0.22,2380,4415,70,NULL,'SALT 2','SDSS-II SN 14827',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18222,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 14827',NULL,18222,41.95,0.22,2450,4415,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14827',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18223,'IRAS','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18223,34.42,0.8,76.4,4416,75,NULL,'MAT, I','NGC 0642',NULL,'1997ApJS..109..333W',1997,1,2,'The APM position is 8 arcsec north of nucleus.','G',0.000023,NULL,'12.88',1.1,'SB(s)c','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,24.776375,-29.91489,NULL,NULL,38258217158,597784643,9340385,12.88),(18224,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18224,34.42,0.43,76.6,4416,75,NULL,'MAT, I, raw','NGC 0642',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18225,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18225,34.56,0.4,81.7,4416,NULL,NULL,'mean','NGC 0642',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18226,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18226,34.61,0.43,83.5,4416,75,NULL,'MAT, I, cor','NGC 0642',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18227,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18227,34.73,0.43,88.2,4416,75,NULL,'MAT, I, inv','NGC 0642',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18228,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18228,34.82,0.46,92.2,4416,NULL,NULL,'J','NGC 0642',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18229,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18229,34.91,0.45,96,4416,NULL,NULL,'K','NGC 0642',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18230,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18230,34.93,0.47,96.6,4416,NULL,NULL,'H','NGC 0642',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18231,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18231,35.21,0.32,110,4416,85,NULL,'I, raw','NGC 0642',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18232,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18232,35.31,0.32,115,4416,85,NULL,'I, inv','NGC 0642',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18233,'SBF','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18233,32.34,0.14,29.4,4417,74.4,NULL,NULL,'NGC 0636',NULL,'2013AJ....146...86T',2013,1,2.8,NULL,'G',0.00002,NULL,'12.76',2.1,'E3','X-ray-faint group member',NULL,NULL,NULL,1,24.7772083,-7.51261,0.119,NULL,34992243563,546753805,8543028,12.76),(18234,'SBF','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18234,32.36,0.16,29.6,4417,NULL,NULL,'Malmquist cor.','NGC 0636',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18235,'SBF','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18235,32.37,0.16,29.8,4417,NULL,NULL,'I','NGC 0636',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18236,'SBF','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18236,32.37,0.16,29.8,4417,NULL,NULL,NULL,'NGC 0636',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18237,'D-Sigma','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18237,31.21,0.4,17.5,4417,75,NULL,'Edat, raw','NGC 0636',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18238,'D-Sigma','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18238,31.41,0.4,19.1,4417,75,NULL,'Edat, cor','NGC 0636',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18239,'Faber-Jackson','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18239,31.03,0.47,16.1,4417,95,NULL,'de Vaucouleurs','NGC 0636',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18240,'Faber-Jackson','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18240,31.13,0.38,16.8,4417,95,NULL,'Weighted Mean','NGC 0636',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18241,'Faber-Jackson','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18241,32.62,0.81,33.4,4417,55,NULL,'Visvanathan & Sandage 1979','NGC 0636',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18242,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18242,32.12,0.41,26.5,4417,NULL,NULL,NULL,'NGC 0636',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18243,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18243,32.14,0.41,26.7,4417,NULL,NULL,'Malmquist cor.','NGC 0636',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18244,'Tertiary','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18244,31.24,0.22,17.7,4417,95,NULL,NULL,'NGC 0636',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18245,'Tully est','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18245,31.92,0.8,24.2,4417,75,NULL,'B','NGC 0636',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18246,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18246,32.16,0.4,27.1,4417,NULL,NULL,'mean','NGC 0636',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18247,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18247,32.39,0.45,30.1,4417,NULL,NULL,'K','NGC 0636',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18248,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 05922','RN',18248,41.58,0.15,1540,4418,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05922',0.343496,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18249,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 05922','RN',18249,41.91,0.22,1790,4418,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 05922',0.343496,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18250,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18250,34.25,NULL,70.9,4419,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -02-05-030',NULL,'2010Ap&SS.325..163P',2010,1,0.9,NULL,'G',0.000049,NULL,'16.4g',0.16,'Sd(f)',NULL,NULL,NULL,NULL,1,24.787875,-10.50389,0,NULL,34983979381,546624677,8541010,16.4),(18251,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18251,34.27,NULL,71.6,4419,NULL,NULL,'Dipole + Quadrupole','MCG -02-05-030',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18252,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18252,34.28,NULL,71.6,4419,NULL,NULL,'Dipole','MCG -02-05-030',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18253,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18253,34.34,NULL,73.8,4419,NULL,NULL,NULL,'MCG -02-05-030',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18254,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18254,37.09,0.69,261,4420,70,NULL,NULL,'2MASX J01391243-2125492',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.83',0.18,NULL,NULL,NULL,NULL,NULL,1,24.801875,-21.43036,0.012,NULL,35180185035,549690391,8588912,16.83),(18255,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18255,36.07,0.52,164,4421,70,NULL,NULL,'MCG -03-05-012',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.28',0.4,NULL,NULL,NULL,NULL,NULL,1,24.8085417,-14.27819,0,NULL,35184312617,549754884,8589920,15.28),(18256,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 04866','RN',18256,42.85,0.33,2690,4422,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 04866',0.377549,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18257,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 04866','RN',18257,43.32,0.32,3350,4422,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 04866',0.377549,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18258,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18258,34.48,0.4,78.8,4423,NULL,NULL,'mean','UGC 01168',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000037,NULL,'14.9',1.1,'S?',NULL,NULL,NULL,NULL,1,24.825125,48.76433,0.697,NULL,67803130512,1059423914,16553498,14.9),(18259,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18259,35.39,0.45,120,4423,NULL,NULL,'K','UGC 01168',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18260,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18260,35.43,0.47,122,4423,NULL,NULL,'H','UGC 01168',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18261,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18261,35.5,0.46,126,4423,NULL,NULL,'J','UGC 01168',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18262,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18262,37.94,0.46,387,4424,70,NULL,NULL,'SDSS J013919.65-094239.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000072,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,24.831875,-9.71106,0.056,NULL,34983249343,546613270,8540832,18.7),(18263,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 07304',NULL,18263,40,0.32,1000,4425,70,NULL,'SN photometric redshift distance, z photo =0.269 +/- 0.051','SDSS-II SN 07304',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,24.835917,-0.65619,0.005,NULL,34977424861,546522263,8539410,NULL),(18264,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18264,36.93,0.53,243,4426,70,NULL,NULL,'2MASX J01392164-0450504',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.32',0.37,NULL,NULL,NULL,NULL,NULL,1,24.840083,-4.84728,0.065,NULL,35026081574,547282524,8551289,16.32),(18265,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18265,35.89,0.25,151,4427,74.4,NULL,NULL,'NGC 0640',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.000043,NULL,'15.2g',0.43,'Sa             Sy2',NULL,NULL,NULL,'Sy 2',1,24.853667,-9.40117,0.078,NULL,34983320195,546614378,8540849,15.2),(18266,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18266,36.15,0.16,170,4427,70,NULL,NULL,'NGC 0640',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18267,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 15693','RN',18267,41.69,1.58,1620,4428,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15693',0.341212,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18268,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 15693','N',18268,41.6,0.33,2090,4428,70,NULL,'SALT 2','SDSS-II SN 15693',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18269,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 15693','N',18269,41.64,0.33,2130,4428,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15693',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18270,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 21661',NULL,18270,40.23,0.18,1110,4429,70,NULL,'SN photometric redshift distance, z photo =0.305 +/- 0.032','SDSS-II SN 21661',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'G',NULL,'PHOT','23.9g',NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,24.8724583,0.13864,0.025,NULL,66975917709,1046498714,16351542,23.9),(18271,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18271,34.08,0.1,65.6,4430,NULL,NULL,NULL,'KUG 0136+335',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000033,NULL,'15.5',0.4,'Spiral',NULL,NULL,NULL,NULL,1,24.879833,33.82439,0.117,NULL,67779162941,1059049420,16547647,15.5),(18272,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18272,34.17,0.2,68.2,4430,74.4,NULL,NULL,'KUG 0136+335',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18273,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18273,36.58,0.76,207,4431,70,NULL,NULL,'6dF J0139317-333524',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,24.882,-33.58994,NULL,NULL,38318277278,598723082,9355048,15.6),(18274,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18274,37.34,0.46,293,4432,70,NULL,NULL,'2MASX J01393233+0032232',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,24.88475,0.53969,0.085,NULL,66975798097,1046496845,16351513,18.5),(18275,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18275,33.25,0.49,44.7,4433,75,NULL,'IR','KUG 0136+349',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000014,NULL,'15.39',0.3,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,24.8880416667,35.15983,0.173,NULL,67766437800,1058850590,16544540,15.39),(18276,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18276,34.24,0.08,70.6,4433,NULL,NULL,NULL,'KUG 0136+349',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18277,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SN 2005fa',NULL,18277,38.58,0.12,448,4434,74.2,NULL,'SALT 2','2MASX J01393602-0045290',0.161531,'2010ApJ...716..712A',2010,1,0.18,NULL,'G',0.000101,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,24.9000417,-0.75794,0.033,NULL,34978275381,546535552,8539618,18.5),(18278,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SN 2005fa',NULL,18278,39.32,0.1,628,4434,65,NULL,'SALT2','2MASX J01393602-0045290',0.161531,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18279,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 02689','R',18279,39.37,0.19,643,4434,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fa','2MASX J01393602-0045290',0.161531,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18280,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SN 2005fa',NULL,18280,39.43,0.11,663,4434,65,NULL,'MLCS2k2','2MASX J01393602-0045290',0.161531,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18281,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 02689','R',18281,39.48,0.1,677,4434,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fa','2MASX J01393602-0045290',0.161531,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18282,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SN 2005fa',NULL,18282,39.53,0.03,694,4434,70,NULL,'SDSS-II SN 02689','2MASX J01393602-0045290',0.161531,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18283,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SN 2005fa',NULL,18283,39.28,0.1,718,4434,70,NULL,'SALT 2','2MASX J01393602-0045290',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18284,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SN 2005fa',NULL,18284,39.29,0.1,721,4434,70,NULL,'SALT 2, Malmquist cor.','2MASX J01393602-0045290',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18285,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18285,35.89,0.46,150,4435,70,NULL,NULL,'2MASX J01393629-0026470',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000083,NULL,'16.3g',0.32,'S0^-',NULL,NULL,NULL,NULL,1,24.90125,-0.44656,0.005,NULL,34965978880,546343420,8536615,16.3),(18286,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18286,33.6,0.4,52.4,4436,NULL,NULL,'mean','NGC 0638',NULL,'2007A&A...465...71T',2007,1,0.8,'RC3 has V = 3650 +- 10 km/sec.','G',0.000137,NULL,'14.5',0.5,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,24.9077083,7.23733,0.097,NULL,67015764902,1047121326,16361270,14.5),(18287,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18287,33.68,0.47,54.4,4436,NULL,NULL,'H','NGC 0638',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18288,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18288,33.75,0.46,56.2,4436,NULL,NULL,'J','NGC 0638',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18289,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18289,33.4,0.49,47.9,4437,75,NULL,'IR','UGC 01172',NULL,'2011yCatp016004901K',2011,1,0.9,'Contains the Emission Line Source UM 123.','G',0.00004,NULL,'15.06',0.2,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,24.910417,5.78289,0.105,NULL,67032639346,1047384989,16365390,15.06),(18290,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 04156','RN',18290,40,0.1,836,4438,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04156',0.193952,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18291,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 17454','RN',18291,41.69,0.18,1480,4439,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17454',0.471509,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18292,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 14671',NULL,18292,35.96,1.38,156,4440,70,NULL,'SN photometric redshift distance, z photo =0.037 +/- 0.034','SDSS-II SN 14671',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.0g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,24.936583,-0.83569,0.033,NULL,34978312360,546536130,8539627,22),(18293,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 14671','R',18293,41.29,0.34,1320,4440,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14671',0.371526,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18294,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 14671','R',18294,41.45,0.3,1420,4440,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14671',0.371526,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18295,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 14671',NULL,18295,41.2,0.23,1740,4440,70,NULL,'SALT 2','SDSS-II SN 14671',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18296,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 14671',NULL,18296,41.25,0.23,1780,4440,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14671',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18297,'Brightest Stars','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18297,29.34,0.4,7.38,4441,NULL,NULL,NULL,'UGC 01171',NULL,'1996A&AS..119..499S',1996,1,1.3,NULL,'G',0.000003,NULL,'17.',1.2,'Im:','X-ray-faint group member',NULL,NULL,NULL,1,24.937083,15.9,0.145,NULL,67418075801,1053407434,16459491,17),(18298,'IRAS','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18298,36.94,0.8,244,4442,75,NULL,'CF, r','UGC 01174',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000133,NULL,'14.82',0.6,'Sbc            HII',NULL,NULL,NULL,NULL,1,24.9462917,-2.03619,0.083,NULL,34980139713,546564683,8540073,14.82),(18299,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18299,36.13,0.38,168,4442,75,NULL,'CF, r, raw','UGC 01174',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18300,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18300,36.34,0.38,185,4442,75,NULL,'CF, r, inv','UGC 01174',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18301,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18301,36.36,0.38,187,4442,75,NULL,'CF, r, cor','UGC 01174',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18302,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 08297',NULL,18302,38.96,0.96,620,4443,70,NULL,'SN photometric redshift distance, z photo =0.157 +/- 0.101','SDSS-II SN 08297',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,24.9745,0.69144,0.049,NULL,66989496221,1046710878,16354857,NULL),(18303,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18303,36.33,0.56,184,4444,70,NULL,NULL,'2MASX J01395557-1330124',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'17.10',0.19,NULL,NULL,NULL,NULL,NULL,1,24.9815417,-13.50344,0,NULL,35068083975,547938812,8561543,17.1),(18304,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18304,35.07,0.46,104,4445,70,NULL,NULL,'NGC 0647',NULL,'2015arXiv151105856S',2015,1,1.04,NULL,'G',0.00011,NULL,'14.0g',0.83,'SB(r)0^0^?',NULL,NULL,NULL,NULL,1,24.984125,-9.24239,0.079,NULL,34983364429,546615069,8540860,14),(18305,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18305,36.21,0.54,174,4446,70,NULL,NULL,'MRK 1004',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'15.0',0.32,NULL,NULL,NULL,NULL,NULL,1,24.986,-5.07428,0.054,NULL,35026408524,547287633,8551369,15),(18306,'IRAS','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18306,34.44,0.8,77.1,4447,75,NULL,'MAT, I','ESO 413- G 016',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'13.42',0.4,'Sbc',NULL,NULL,NULL,NULL,1,24.987625,-28.69667,0.045,NULL,38268079182,597938737,9342792,13.42),(18307,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18307,34.09,0.49,65.8,4447,75,NULL,'IR','ESO 413- G 016',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18308,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18308,34.21,0.43,69.5,4447,75,NULL,'MAT, I, raw','ESO 413- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18309,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18309,34.39,0.32,75.6,4447,85,NULL,'I, raw','ESO 413- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18310,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18310,34.42,0.43,76.5,4447,75,NULL,'MAT, I, cor','ESO 413- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18311,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18311,34.47,0.32,78.5,4447,85,NULL,'I, inv','ESO 413- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18312,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18312,34.5,0.2,79.4,4447,74.4,NULL,NULL,'ESO 413- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18313,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18313,34.5,0.24,79.5,4447,NULL,NULL,'Malmquist cor.','ESO 413- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18314,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18314,34.54,0.43,81,4447,75,NULL,'MAT, I, inv','ESO 413- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18315,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18315,34.63,0.22,84.4,4447,NULL,NULL,NULL,'ESO 413- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18316,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 15972','RN',18316,42.26,0.27,2250,4448,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15972',0.261087,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18317,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 15972','RN',18317,42.42,0.3,2420,4448,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15972',0.261087,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18318,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 04482','RN',18318,43.72,0.28,3770,4449,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04482',0.47283,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18319,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18319,37.11,0.76,265,4450,70,NULL,NULL,'2MASX J01400304-0712106',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'17.09',0.19,NULL,NULL,NULL,NULL,NULL,1,25.012667,-7.20292,0.116,NULL,34992263129,546754111,8543032,17.09),(18320,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18320,35.97,0.66,156,4451,70,NULL,NULL,'2MASX J01400755-0625426',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'16.44',0.35,NULL,NULL,NULL,NULL,NULL,1,25.0314583,-6.42847,0.103,NULL,34991355091,546739923,8542811,16.44),(18321,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18321,32.68,0.2,34.4,4452,74.4,NULL,NULL,'NGC 0645',NULL,'2013AJ....146...86T',2013,1,2.6,NULL,'G',0.000003,NULL,'13.41',1.2,'SBb:','in a radial-velocity based grouping',NULL,NULL,NULL,1,25.03625,5.72669,0.113,NULL,67032625593,1047384774,16365387,13.41),(18322,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18322,32.74,0.42,35.3,4452,NULL,NULL,'Malmquist cor.','NGC 0645',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18323,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18323,32.76,0.42,35.6,4452,NULL,NULL,NULL,'NGC 0645',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18324,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18324,33.22,0.49,44.1,4452,75,NULL,'IR','NGC 0645',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18325,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18325,33.45,0.4,49,4452,NULL,NULL,'mean','NGC 0645',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18326,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18326,33.62,0.46,53.1,4452,NULL,NULL,'J','NGC 0645',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18327,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18327,33.64,0.45,53.4,4452,NULL,NULL,'K','NGC 0645',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18328,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18328,33.64,0.47,53.5,4452,NULL,NULL,'H','NGC 0645',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18329,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 05923','RN',18329,42.63,0.23,2280,4453,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05923',0.469715,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18330,'Brightest Stars','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18330,29.78,0.4,9.04,4454,NULL,NULL,NULL,'UGC 01176',NULL,'1996A&AS..119..499S',1996,1,4.6,NULL,'G',0.000001,NULL,'14.4',3.6,'Im','X-ray-faint group member',NULL,NULL,NULL,1,25.04125,15.90472,0.145,NULL,67417541660,1053399088,16459360,14.4),(18331,'Tully est','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18331,29.84,0.8,9.3,4454,75,NULL,NULL,'UGC 01176',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18332,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 14645','RN',18332,39.32,0.1,651,4455,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 14645',0.124691,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18333,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 14645','RN',18333,39.43,0.18,683,4455,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 14645',0.124691,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18334,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18334,36.63,0.46,212,4456,70,NULL,NULL,'UGC 01180',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000131,NULL,'15.2g',0.54,'COMPACT',NULL,NULL,NULL,NULL,1,25.0727916667,-0.29469,0.033,NULL,34965850048,546341407,8536584,15.2),(18335,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 20906','RN',18335,38.83,0.29,506,4457,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 20906',0.155019,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18336,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 20906','RN',18336,38.94,0.43,530,4457,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 20906',0.155019,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18337,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18337,34.16,0.47,67.8,4458,NULL,NULL,'H','IC 1720',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000033,NULL,'13.69',0.9,'Sbc',NULL,NULL,NULL,NULL,1,25.0899583,-28.91275,0.053,NULL,38268064472,597938507,9342789,13.69),(18338,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18338,34.18,0.45,68.4,4458,NULL,NULL,'K','IC 1720',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18339,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18339,34.22,0.46,69.9,4458,NULL,NULL,'J','IC 1720',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18340,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18340,34.41,0.4,76.3,4458,NULL,NULL,'mean','IC 1720',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18341,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18341,34.46,0.31,77.9,4458,NULL,NULL,'Malmquist cor.','IC 1720',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18342,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18342,34.62,0.28,83.8,4458,NULL,NULL,NULL,'IC 1720',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18343,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18343,34.66,0.2,85.5,4458,74.4,NULL,NULL,'IC 1720',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18344,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 20969','R',18344,40.66,0.15,1020,4459,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20969',0.332255,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',NULL,'PHOT','21.7g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,25.09075,-0.35367,0.033,NULL,34977367846,546521372,8539396,21.7),(18345,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 20969','R',18345,41.02,0.29,1200,4459,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20969',0.332255,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18346,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 20969',NULL,18346,40.54,0.1,1280,4459,70,NULL,'SN photometric redshift distance, z photo =0.361 +/- 0.021','SDSS-II SN 20969',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18347,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 16973',NULL,18347,38.17,2.52,430,4460,70,NULL,'SN photometric redshift distance, z photo =0.106 +/- 0.288','SDSS-II SN 16973',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,25.103,-0.25261,0.037,NULL,34965855228,546341487,8536585,NULL),(18348,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 16973',NULL,18348,40.67,0.23,1360,4460,70,NULL,'SALT 2','SDSS-II SN 16973',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18349,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 16973',NULL,18349,40.72,0.23,1390,4460,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16973',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18350,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18350,32.14,0.4,26.8,4461,73,NULL,'opt','MCG -01-05-014',NULL,'2011A&A...532A.104N',2011,1,1.8,NULL,'G',0.000017,NULL,'14.5',0.4,'SAB(s)d:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,25.1159583,-5.52056,0.062,NULL,35026345504,547286648,8551353,14.5),(18351,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18351,32.23,0.62,28,4461,NULL,NULL,'Malmquist cor.','MCG -01-05-014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18352,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18352,32.35,0.2,29.5,4461,74.4,NULL,NULL,'MCG -01-05-014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18353,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18353,32.45,0.43,30.9,4461,75,NULL,'3.6 micron, color corrected','MCG -01-05-014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18354,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18354,32.5,0.55,31.6,4461,NULL,NULL,NULL,'MCG -01-05-014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18355,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18355,32.51,0.43,31.8,4461,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-05-014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18356,'IRAS','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18356,34.37,0.8,74.7,4462,75,NULL,'W91PP, r','UGC 01178',NULL,'1997ApJS..109..333W',1997,1,2.02,NULL,'G',0.000017,NULL,'14.71',0.28,'Sc',NULL,NULL,NULL,NULL,1,25.1165416667,34.62531,0.125,NULL,67765825746,1058841027,16544391,14.71),(18357,'IRAS','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18357,34.37,0.8,74.7,4462,75,NULL,'HMCL, I','UGC 01178',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18358,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18358,33.67,0.43,54.2,4462,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01178',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18359,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18359,33.75,0.38,56.3,4462,75,NULL,'W91PP, r, raw','UGC 01178',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18360,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18360,33.85,0.49,58.9,4462,75,NULL,'IR','UGC 01178',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18361,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18361,33.87,0.43,59.5,4462,75,NULL,'3.6 micron, color corrected','UGC 01178',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18362,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18362,33.88,0.38,59.7,4462,75,NULL,'W91PP, r, inv','UGC 01178',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18363,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18363,33.93,0.4,61,4462,75,NULL,'HMCL, I, raw','UGC 01178',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18364,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18364,34,NULL,63.1,4462,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01178',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18365,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18365,34.01,0.38,63.5,4462,75,NULL,'W91PP, r, cor','UGC 01178',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18366,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18366,34.02,NULL,63.7,4462,NULL,NULL,'Dipole + Quadrupole','UGC 01178',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18367,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18367,34.03,NULL,63.9,4462,NULL,NULL,'Dipole','UGC 01178',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18368,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18368,34.06,NULL,64.9,4462,NULL,NULL,NULL,'UGC 01178',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18369,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18369,34.09,0.4,65.7,4462,75,NULL,'HMCL, I, inv','UGC 01178',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18370,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18370,34.13,0.2,67,4462,74.4,NULL,NULL,'UGC 01178',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18371,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18371,34.15,0.4,67.7,4462,75,NULL,'HMCL, I, cor','UGC 01178',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18372,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18372,34.24,0.15,70.6,4462,NULL,NULL,NULL,'UGC 01178',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18373,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18373,35.01,NULL,101,4463,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01181',NULL,'2010Ap&SS.325..163P',2010,1,1.09,NULL,'G',0.00001,NULL,'16.6g',0.16,'Sb(f)',NULL,NULL,NULL,NULL,1,25.1249583333,14.52289,0.137,NULL,66926670056,1045729219,16339519,16.6),(18374,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18374,35.03,NULL,102,4463,NULL,NULL,'Dipole + Quadrupole','UGC 01181',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18375,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18375,35.04,NULL,102,4463,NULL,NULL,'Dipole','UGC 01181',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18376,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18376,35.08,NULL,104,4463,NULL,NULL,NULL,'UGC 01181',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18377,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18377,35.53,0.2,128,4463,74.4,NULL,NULL,'UGC 01181',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18378,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18378,35.7,0.56,138,4464,70,NULL,NULL,'2MASX J01403338-0445479',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.95',0.37,NULL,NULL,NULL,NULL,NULL,1,25.139125,-4.76325,0.066,NULL,35026016585,547281509,8551273,16.95),(18379,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 15018','RN',18379,40.17,0.37,900,4465,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15018',0.201776,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18380,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 15018','RN',18380,40.18,0.34,906,4465,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15018',0.201776,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18381,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 02301','RN',18381,41.35,0.19,1330,4466,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02301',0.404782,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18382,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 02301','RN',18382,41.68,0.09,1540,4466,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 02301',0.404782,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18383,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18383,36.53,0.46,203,4467,70,NULL,NULL,'2MASX J01404264+1333052',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000184,NULL,'16.0g',0.3,'S0',NULL,NULL,NULL,NULL,1,25.177833,13.55131,0.129,NULL,66927879562,1045748118,16339814,16),(18384,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 01185','RN',18384,42.15,0.2,1890,4468,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01185',0.42512,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18385,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 01185','RN',18385,42.42,0.23,2140,4468,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01185',0.42512,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18386,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18386,33.59,0.2,52.2,4469,74.4,NULL,NULL,'NGC 0652',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000107,NULL,'14.55',0.6,'S?',NULL,NULL,NULL,NULL,1,25.180333,7.98292,0.117,NULL,67023244895,1047238201,16363096,14.55),(18387,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18387,37.34,0.46,293,4470,70,NULL,NULL,'2MASX J01404913+0005265',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000079,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,25.2047917,0.09058,0.037,NULL,66975709483,1046495460,16351491,17),(18388,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18388,34.44,0.48,77.4,4471,70,NULL,NULL,'MCG -02-05-035',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.000083,NULL,'14.6g',0.49,'Sb',NULL,NULL,NULL,NULL,1,25.2234583,-10.27822,0.01,NULL,34984338447,546630288,8541098,14.6),(18389,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 18834','R',18389,40.49,0.12,1100,4472,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2007ny','SDSS J014055.58+001307.0',0.143,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,25.2315833333,0.21861,0.029,NULL,66989388388,1046709193,16354831,NULL),(18390,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 18834','R',18390,41.06,0.25,1430,4472,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2007ny','SDSS J014055.58+001307.0',0.143,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18391,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18391,37.01,0.46,252,4473,70,NULL,NULL,'2MASX J01405684-0814325',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000075,NULL,'16.2g',0.33,'S0^-',NULL,NULL,NULL,NULL,1,25.2367916667,-8.24236,0.063,NULL,34994783989,546793499,8543648,16.2),(18392,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18392,35.44,0.6,122,4474,70,NULL,NULL,'2MASX J01405745-0135291',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.000097,NULL,'16.26',0.43,NULL,NULL,NULL,NULL,NULL,1,25.2394583,-1.59147,0.033,NULL,34980002723,546562542,8540039,16.26),(18393,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18393,37.17,0.46,271,4475,70,NULL,NULL,'2MASX J01405808+1520183',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000175,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,25.242125,15.3385,0.125,NULL,66934013572,1045843962,16341311,16.8),(18394,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SN 2006hg',NULL,18394,39.87,0.13,942,4476,70,NULL,'Hubble residual 0.04 for z0.24500','SDSS-II SN 13506 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,25.2436666667,-0.72844,0.037,NULL,34977518019,546523719,8539433,NULL),(18395,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 13506','R',18395,40.46,0.16,993,4476,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006hg','SDSS-II SN 13506 HOST',0.244619,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18396,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 13506','R',18396,40.54,0.23,1030,4476,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006hg','SDSS-II SN 13506 HOST',0.244619,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18397,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SN 2006hg',NULL,18397,40.32,0.12,1160,4476,70,NULL,'SALT 2','SDSS-II SN 13506 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18398,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SN 2006hg',NULL,18398,40.34,0.12,1170,4476,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13506 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18399,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18399,36.57,0.46,206,4477,70,NULL,NULL,'2MASX J01410031-0013151',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000074,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,25.251167,-0.22097,0.037,NULL,34977411937,546522061,8539407,17.2),(18400,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18400,34.79,0.49,90.9,4478,75,NULL,'IR','FGC 0186',NULL,'2011yCatp016004901K',2011,1,1.15,NULL,'G',0.00005,NULL,'16.3g',0.17,'Sd(f)',NULL,NULL,NULL,NULL,1,25.25875,-9.33961,0.077,NULL,34983692504,546620195,8540940,16.3),(18401,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18401,36.09,0.62,165,4479,70,NULL,NULL,'2MASX J01410281-1418527',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'16.05',0.33,NULL,NULL,NULL,NULL,NULL,1,25.2615833333,-14.31475,0,NULL,35066382311,547912223,8561128,16.05),(18402,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 18804','R',18402,39.84,0.18,770,4480,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007me','SDSS J014103.85-002653.7',0.205,'2014arXiv1401.3317S',2014,1,0.11,NULL,'G',NULL,NULL,'19.9g',0.09,NULL,NULL,NULL,NULL,NULL,1,25.2660417,-0.44825,0.061,NULL,34977578589,546524665,8539447,19.9),(18403,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 18804','R',18403,40.02,0.08,837,4480,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007me','SDSS J014103.85-002653.7',0.205,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18404,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SN 2007me',NULL,18404,39.7,0.07,871,4480,70,NULL,'SALT 2','SDSS J014103.85-002653.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18405,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SN 2007me',NULL,18405,39.72,0.07,879,4480,70,NULL,'SALT 2, Malmquist cor.','SDSS J014103.85-002653.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18406,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18406,31.42,0.2,19.2,4481,74.4,NULL,NULL,'MCG -01-05-017',NULL,'2013AJ....146...86T',2013,1,2.4,'Confused HIPASS source','G',0.000013,NULL,'14.14',1,'SAB(s)m:',NULL,NULL,NULL,NULL,1,25.279625,-5.56811,0.039,NULL,35024172640,547252697,8550823,14.14),(18407,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18407,31.44,0.43,19.4,4481,75,NULL,'3.6 micron, color corrected','MCG -01-05-017',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18408,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18408,31.46,0.43,19.5,4481,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-05-017',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18409,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18409,31.53,0.39,20.2,4481,73,NULL,'opt','MCG -01-05-017',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18410,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18410,31.64,0.59,21.3,4481,NULL,NULL,'Malmquist cor.','MCG -01-05-017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18411,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18411,31.7,0.58,21.9,4481,NULL,NULL,NULL,'MCG -01-05-017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18412,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 04303','RN',18412,42.58,0.22,2040,4482,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04303',0.609223,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18413,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18413,28.92,0.1,6.07,4483,74.4,NULL,NULL,'AGC 112521',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000002,NULL,'17.8B',NULL,NULL,NULL,NULL,NULL,NULL,1,25.283333,27.32222,0.225,NULL,67715571173,1058055799,16532121,17.8),(18414,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18414,29.09,0.05,6.58,4483,NULL,NULL,'I','AGC 112521',NULL,'2014ApJ...785....3M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18415,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18415,37.33,0.46,292,4484,70,NULL,NULL,'2MASX J01410830-0849555',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000086,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,25.2846666667,-8.83203,0.064,NULL,34994416238,546787753,8543558,16.9),(18416,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 13015','R',18416,40.7,0.2,1170,4485,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13015',0.176506,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,25.303167,0.92775,0.097,NULL,66989727870,1046714497,16354914,NULL),(18417,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 13015','R',18417,40.78,0.14,1220,4485,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13015',0.176506,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18418,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18418,37.17,0.46,272,4486,70,NULL,NULL,'2MASX J01411483-0039492',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,25.3117917,-0.66361,0.037,NULL,34977535098,546523985,8539437,17.9),(18419,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 14971','RN',18419,43.65,0.28,3590,4487,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 14971',0.498868,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18420,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18420,37.63,0.46,336,4488,70,NULL,NULL,'2MASX J01411538+1342123',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,25.314,13.70356,0.133,NULL,66926745956,1045730405,16339537,17.8),(18421,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 04078',NULL,18421,41.08,0.3,1650,4489,70,NULL,'SN photometric redshift distance, z photo =0.500 +/- 0.107','SDSS-II SN 04078',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','22.2g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,25.31375,0.6445,0.089,NULL,66989454332,1046710223,16354847,22.2),(18422,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18422,36.47,0.46,197,4490,70,NULL,NULL,'2MASX J01411632-0835395',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000091,NULL,'16.0g',0.34,'AGN',NULL,NULL,NULL,NULL,1,25.318125,-8.59425,0.061,NULL,34996374472,546818351,8544036,16),(18423,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18423,37.85,0.46,372,4491,70,NULL,NULL,'2MASX J01412296+1447323',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,25.3457083333,14.79233,0.129,NULL,66938187867,1045909185,16342331,17.7),(18424,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18424,33.5,0.57,50.1,4492,NULL,NULL,NULL,'IC 1721',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.00012,NULL,'14.30',0.5,'S?',NULL,NULL,NULL,NULL,1,25.351833,8.52553,0.109,NULL,67024040695,1047250635,16363291,14.3),(18425,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18425,33.52,0.2,50.6,4492,74.4,NULL,NULL,'IC 1721',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18426,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18426,33.56,0.55,51.6,4492,NULL,NULL,'Malmquist cor.','IC 1721',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18427,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18427,37.16,0.69,271,4493,70,NULL,NULL,'2MASX J01412688-2058002',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.81',0.23,NULL,NULL,NULL,NULL,NULL,1,25.3619583,-20.96686,0,NULL,35171477809,549554340,8586786,16.81),(18428,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18428,36.65,0.46,214,4494,70,NULL,NULL,'2MASX J01412777+1304363',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000199,NULL,'17.7g',0.16,'BLAGN',NULL,NULL,NULL,'Sy 1',1,25.36575,13.07681,0.113,NULL,66928286493,1045754476,16339913,17.7),(18429,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 19165',NULL,18429,39.78,0.77,904,4495,70,NULL,'SN photometric redshift distance, z photo =0.239 +/- 0.125','SDSS-II SN 19165',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.9g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,25.374333,0.5465,0.089,NULL,66989429064,1046709829,16354841,21.9),(18430,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 19165','R',18430,41.67,0.29,1520,4495,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19165',0.416755,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18431,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 19165','R',18431,41.89,0.33,1690,4495,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19165',0.416755,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18432,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 19165',NULL,18432,41.58,0.22,2070,4495,70,NULL,'SALT 2','SDSS-II SN 19165',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18433,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 19165',NULL,18433,41.65,0.22,2140,4495,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19165',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18434,'SBF','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18434,35.1,0.2,105,4496,NULL,NULL,'HST, Cantiello et al. 05','AM 0139-655 NED02',NULL,'2008ApJ...678..168B',2008,1,1.03,NULL,'G',0.00005,NULL,'14.76',0.67,'S0',NULL,NULL,NULL,NULL,1,25.3789583,-65.61558,0,NULL,36355385431,568052897,8875826,14.76),(18435,'SBF','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18435,35.2,0.25,110,4496,NULL,NULL,'ACS','AM 0139-655 NED02',NULL,'2008ApJ...678..168B',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18436,'SBF','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18436,35.2,0.25,110,4496,NULL,NULL,'HST, Jensen et al. 03','AM 0139-655 NED02',NULL,'2008ApJ...678..168B',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18437,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18437,36.37,0.75,188,4497,70,NULL,NULL,'2MASX J01413253-0152039',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.81',0.36,NULL,NULL,NULL,NULL,NULL,1,25.3856666667,-1.86781,0.119,NULL,34976586533,546509164,8539205,16.81),(18438,'IRAS','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18438,33.93,0.8,61.2,4498,75,NULL,'MAT, I','ESO 003- G 004',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'14.97',0.3,'Sbc: sp','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,25.3890833333,-83.21222,0.421,NULL,35477710096,554339220,8661550,14.97),(18439,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18439,33.59,0.49,52.2,4498,75,NULL,'IR','ESO 003- G 004',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18440,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18440,33.66,0.32,54,4498,85,NULL,'I, raw','ESO 003- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18441,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18441,33.68,0.43,54.4,4498,75,NULL,'MAT, I, raw','ESO 003- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18442,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18442,33.71,0.32,55.1,4498,85,NULL,'I, inv','ESO 003- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18443,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18443,33.88,0.43,59.7,4498,75,NULL,'MAT, I, inv','ESO 003- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18444,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18444,33.89,0.43,59.9,4498,75,NULL,'MAT, I, cor','ESO 003- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18445,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18445,34.03,0.33,64,4498,NULL,NULL,NULL,'ESO 003- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18446,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18446,34.04,0.33,64.2,4498,NULL,NULL,'Malmquist cor.','ESO 003- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18447,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18447,34.07,0.2,65.2,4498,74.4,NULL,NULL,'ESO 003- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18448,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18448,34.13,0.47,67.1,4498,NULL,NULL,'H','ESO 003- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18449,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18449,34.24,0.4,70.4,4498,NULL,NULL,'mean','ESO 003- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18450,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18450,34.25,0.46,70.9,4498,NULL,NULL,'J','ESO 003- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18451,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18451,34.28,0.45,71.9,4498,NULL,NULL,'K','ESO 003- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18452,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 14557','RN',18452,40.8,0.32,1320,4499,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 14557',0.097462,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18453,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 14557','RN',18453,41.19,0.26,1570,4499,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 14557',0.097462,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18454,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18454,32.02,0.43,25.4,4500,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2573',NULL,'2014MNRAS.444..527S',2014,1,2,NULL,'G',0.000017,NULL,'14.1',0.8,'SAB(rs+)c',NULL,NULL,NULL,NULL,1,25.4055416667,-89.33453,0.517,NULL,35434375257,553662113,8650970,14.1),(18455,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18455,32.79,0.4,36.1,4500,NULL,NULL,'mean','NGC 2573',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18456,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18456,33.05,0.46,40.7,4500,NULL,NULL,'J','NGC 2573',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18457,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18457,33.08,0.47,41.2,4500,NULL,NULL,'H','NGC 2573',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18458,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18458,35.21,0.49,110,4501,75,NULL,'IR','CGCG 412-016',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',NULL,NULL,'15.6',0.17,NULL,NULL,NULL,NULL,NULL,1,25.4211666667,5.85342,0.097,NULL,67031712052,1047370500,16365164,15.6),(18459,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18459,37.02,0.46,253,4502,70,NULL,NULL,'2MASX J01414111+1338592',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,25.421375,13.64981,0.141,NULL,66927201871,1045737529,16339648,17.4),(18460,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18460,37.26,0.51,283,4503,70,NULL,NULL,'2MASX J01414232-0735281',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00014,NULL,'15.92',0.51,NULL,NULL,NULL,NULL,NULL,1,25.426333,-7.59122,0.089,NULL,34996785026,546824766,8544136,15.92),(18461,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 16567','R',18461,41.67,0.2,1580,4504,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006pf','SN 2006pf',0.365913,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,25.4380417,-0.18914,0.033,NULL,34973176870,546455888,8538373,NULL),(18462,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 16567','R',18462,41.8,0.33,1670,4504,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006pf','SN 2006pf',0.365913,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18463,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 15162','RN',18463,37.45,0.48,267,4505,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15162',0.154404,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18464,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 15162','RN',18464,38.54,0.26,442,4505,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15162',0.154404,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18465,'IRAS','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18465,34.38,0.8,75.3,4506,75,NULL,'MAT, I','ESO 413- G 023',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'15.43',0.8,'Sb:',NULL,NULL,NULL,NULL,1,25.4554583333,-28.24722,0.058,NULL,38267861627,597935337,9342739,15.43),(18466,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18466,33.93,0.32,61.1,4506,85,NULL,'I, raw','ESO 413- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18467,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18467,33.95,0.32,61.6,4506,85,NULL,'I, inv','ESO 413- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18468,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18468,34.09,0.43,65.7,4506,75,NULL,'MAT, I, raw','ESO 413- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18469,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18469,34.21,0.43,69.6,4506,75,NULL,'MAT, I, inv','ESO 413- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18470,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18470,34.32,0.2,73.1,4506,74.4,NULL,NULL,'ESO 413- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18471,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18471,34.32,0.43,73.2,4506,75,NULL,'MAT, I, cor','ESO 413- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18472,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18472,34.42,0.32,76.5,4506,NULL,NULL,NULL,'ESO 413- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18473,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18473,34.48,0.31,78.7,4506,NULL,NULL,'Malmquist cor.','ESO 413- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18474,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18474,35.06,0.49,103,4506,75,NULL,'IR','ESO 413- G 023',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18475,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 13507',NULL,18475,40.31,0.26,1150,4507,70,NULL,'SN photometric redshift distance, z photo =0.318 +/- 0.050','SDSS-II SN 13507',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.8g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,25.4564583,-0.79567,0.013,NULL,34973552356,546461755,8538464,21.8),(18476,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SN 2005ex',NULL,18476,37.43,0.12,280,4508,74.2,NULL,'SALT 2','2MASX J01415126-0052365',0.094,'2010ApJ...716..712A',2010,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,25.463667,-0.87672,0.037,NULL,34973555147,546461799,8538465,17.9),(18477,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SN 2005ex',NULL,18477,38.22,0.14,403,4508,70,NULL,'SALT 2','2MASX J01415126-0052365',0.094,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18478,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 00774','R',18478,38.27,0.19,413,4508,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ex','2MASX J01415126-0052365',0.09,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18479,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 00774','R',18479,38.43,0.1,445,4508,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ex','2MASX J01415126-0052365',0.09,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18480,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18480,37.45,0.46,309,4508,70,NULL,NULL,'2MASX J01415126-0052365',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18481,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18481,37.31,0.46,289,4509,70,NULL,NULL,'2MASX J01415177+1332559',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000079,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,25.465583,13.54872,0.105,NULL,66927526192,1045742596,16339728,17.5),(18482,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18482,37.7,0.46,347,4510,70,NULL,NULL,'SDSS J014151.90-082154.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000073,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,25.4662917,-8.36519,0.069,NULL,34996393352,546818646,8544041,18.2),(18483,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18483,35.39,0.51,120,4511,70,NULL,NULL,'MCG -01-05-020',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.2b',0.3,'SB0+? pec',NULL,NULL,NULL,NULL,1,25.4697083333,-4.88986,0.053,NULL,35025782556,547277852,8551216,15.2),(18484,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 06950','RN',18484,38.95,0.23,561,4512,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06950',0.101273,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18485,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 06950','RN',18485,39.22,0.11,635,4512,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06950',0.101273,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18486,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18486,34.25,0.2,70.8,4513,74.4,NULL,NULL,'UGC 01189',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.00012,NULL,'15.21',0.4,'S?',NULL,NULL,NULL,NULL,1,25.478875,7.12133,0.109,NULL,67021407884,1047209498,16362648,15.21),(18487,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18487,34.36,0.36,74.6,4513,NULL,NULL,NULL,'UGC 01189',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18488,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18488,34.39,0.35,75.4,4513,NULL,NULL,'Malmquist cor.','UGC 01189',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18489,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18489,36.33,0.2,185,4514,74.4,NULL,NULL,'UGC 01188',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'15.44',0.5,'S?',NULL,NULL,NULL,NULL,1,25.4847083333,22.68997,0.405,NULL,67380851811,1052825809,16450403,15.44),(18490,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 14855','RN',18490,42.93,0.3,2630,4515,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 14855',0.465138,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18491,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18491,35.75,0.51,141,4516,70,NULL,NULL,'2MASX J01415955-2036275',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'16.38',0.28,NULL,NULL,NULL,NULL,NULL,1,25.4982917,-20.60761,0,NULL,35172326309,549567598,8586993,16.38),(18492,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 12987','RN',18492,39.49,0.25,660,4517,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 12987',0.196209,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18493,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 12987','RN',18493,40.02,0.42,846,4517,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 12987',0.196209,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18494,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 07306','RN',18494,40.93,0.11,1380,4518,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 07306',0.11192,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18495,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 07306','RN',18495,41.33,0.24,1660,4518,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 07306',0.11192,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18496,'IRAS','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18496,32.74,0.8,35.3,4519,75,NULL,'CF, r','NGC 0658',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.00001,NULL,'13.12',1.6,'Sb',NULL,NULL,NULL,NULL,1,25.54025,12.60189,0.121,NULL,66928145922,1045752280,16339879,13.12),(18497,'IRAS','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18497,32.75,0.8,35.4,4519,75,NULL,'A82, H','NGC 0658',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18498,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18498,32.26,0.33,28.3,4519,91,NULL,'H','NGC 0658',NULL,'1984ApJ...278..475B',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18499,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18499,32.51,0.47,31.7,4519,75,NULL,'A82, H, raw','NGC 0658',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18500,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18500,32.61,0.47,33.3,4519,75,NULL,'A82, H, inv','NGC 0658',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18501,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18501,32.84,0.47,37,4519,75,NULL,'A82, H, cor','NGC 0658',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18502,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18502,32.89,0.38,37.8,4519,75,NULL,'CF, r, raw','NGC 0658',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18503,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18503,33,0.38,39.8,4519,75,NULL,'CF, r, inv','NGC 0658',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18504,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18504,33.07,0.4,41.1,4519,NULL,NULL,'mean','NGC 0658',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18505,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18505,33.12,0.38,42,4519,75,NULL,'CF, r, cor','NGC 0658',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18506,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18506,33.19,0.45,43.4,4519,NULL,NULL,'K','NGC 0658',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18507,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18507,33.24,0.47,44.4,4519,NULL,NULL,'H','NGC 0658',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18508,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18508,33.25,0.43,44.7,4519,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0658',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18509,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18509,33.26,0.46,44.8,4519,NULL,NULL,'J','NGC 0658',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18510,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18510,33.26,0.43,44.8,4519,75,NULL,'3.6 micron, color corrected','NGC 0658',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18511,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18511,33.33,0.2,46.3,4519,74.4,NULL,NULL,'NGC 0658',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18512,'TRGB','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18512,29.47,0.05,7.82,4520,NULL,NULL,'I','AGC 110482',NULL,'2014ApJ...785....3M',2014,1,0.7,NULL,'G',0.000003,NULL,'16.6',0.4,'Irr',NULL,NULL,NULL,NULL,1,25.5725,26.36667,0.289,NULL,67716389318,1058068583,16532321,16.6),(18513,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 13016',NULL,18513,39.1,0.52,660,4521,70,NULL,'SN photometric redshift distance, z photo =0.168 +/- 0.051','SDSS-II SN 13016',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,25.5884583,0.97958,0.057,NULL,66981572449,1046587069,16352922,NULL),(18514,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 13016','R',18514,40.72,0.21,1120,4521,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13016',0.25098,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18515,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 13016','R',18515,40.98,0.18,1250,4521,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13016',0.25098,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18516,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18516,37.3,0.66,289,4522,70,NULL,NULL,'2MASX J01422255-1136173',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.00015,NULL,'16.86',0.42,NULL,NULL,NULL,NULL,NULL,1,25.593875,-11.60514,0,NULL,35098291255,548410800,8568918,16.86),(18517,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 14467',NULL,18517,38.52,1.01,506,4523,70,NULL,'SN photometric redshift distance, z photo =0.126 +/- 0.084','SDSS-II SN 14467',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,25.6019583333,-0.31297,0.029,NULL,34973362613,546458790,8538418,NULL),(18518,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18518,34.17,0.47,68.1,4524,NULL,NULL,'H','IC 0149',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000097,NULL,'14.24',0.3,'HII',NULL,NULL,NULL,NULL,1,25.60575,-16.30042,0.037,NULL,35072209077,548003266,8562551,14.24),(18519,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18519,34.23,0.45,70,4524,NULL,NULL,'K','IC 0149',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18520,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18520,34.31,0.46,72.9,4524,NULL,NULL,'J','IC 0149',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18521,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18521,34.38,0.4,75.1,4524,NULL,NULL,'mean','IC 0149',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18522,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18522,36.96,0.55,247,4525,70,NULL,NULL,'2MASX J01422541-0446204',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,25.605833,-4.77242,0.06,NULL,35025845525,547278836,8551231,14),(18523,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18523,34.4,0.4,76,4526,NULL,NULL,'mean','NGC 0653',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000047,NULL,'14.31',0.2,'Sab',NULL,NULL,NULL,NULL,1,25.60725,35.63833,0.149,NULL,67765631394,1058837990,16544343,14.31),(18524,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18524,34.85,0.49,93.5,4526,75,NULL,'IR','NGC 0653',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18525,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18525,34.89,0.46,95.1,4526,NULL,NULL,'J','NGC 0653',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18526,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18526,34.93,0.47,96.9,4526,NULL,NULL,'H','NGC 0653',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18527,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18527,35.03,0.45,101,4526,NULL,NULL,'K','NGC 0653',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18528,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18528,30.17,0.4,10.8,4527,75,NULL,'B','IC 0148',NULL,'1988NBGC.C....0000T',1988,1,2.95,'Confused HIPASS source','G',0.00001,NULL,'13.9g',0.65,'Sc(f)','X-ray-faint group member',NULL,NULL,NULL,1,25.612375,13.97703,0.141,NULL,66927024928,1045734764,16339605,13.9),(18529,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18529,36.96,0.55,246,4528,70,NULL,NULL,'2MASX J01422827-0732093',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'15.9b',0.52,NULL,NULL,NULL,NULL,NULL,1,25.6178333333,-7.53589,0.078,NULL,34993446352,546772599,8543321,15.9),(18530,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18530,34.44,0.49,77.4,4529,75,NULL,'IR','CGCG 386-032',NULL,'2011yCatp016004901K',2011,1,0.8,'Star superposed 10\\\" southwest.','G',0.000054,NULL,'15.31',0.5,NULL,NULL,NULL,NULL,NULL,1,25.628667,-0.81942,0.061,NULL,34973587313,546462301,8538473,15.31),(18531,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18531,32.48,0.4,31.3,4530,75,NULL,NULL,'UGC 01197',NULL,'2008Ap.....51..336K',2008,1,1.8,NULL,'G',0.000003,NULL,'14.84',0.6,'Im',NULL,NULL,NULL,NULL,1,25.6377083333,18.30569,0.141,NULL,66911776418,1045496506,16335882,14.84),(18532,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18532,32.48,0.4,31.3,4530,73,NULL,'IR','UGC 01197',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18533,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18533,32.61,0.2,33.3,4530,74.4,NULL,NULL,'UGC 01197',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18534,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18534,32.73,0.4,35.2,4530,NULL,NULL,NULL,'UGC 01197',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18535,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18535,32.75,0.43,35.5,4530,75,NULL,'3.6 micron, color corrected','UGC 01197',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18536,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18536,32.83,0.4,36.9,4530,75,NULL,'B','UGC 01197',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18537,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18537,32.84,0.43,37.1,4530,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01197',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18538,'Tully-Fisher','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18538,33.34,0.49,46.6,4530,75,NULL,'IR','UGC 01197',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18539,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,NULL,18539,37.08,0.74,260,4531,70,NULL,NULL,'2MASX J01423527-1551272',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'16.73',0.3,NULL,NULL,NULL,NULL,NULL,1,25.646917,-15.85761,0,NULL,35071005629,547984462,8562257,16.73),(18540,'SNIa SDSS','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SDSS-II SN 15005','RN',18540,40.16,0.33,897,4532,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 15005',0.202588,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18541,'FP','2016-12-15 15:13:47','2016-12-16 11:18:50','1',NULL,'R',18541,37.29,0.46,287,4533,70,NULL,NULL,'SDSS J014238.19-101856.4',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000077,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,25.659167,-10.31567,0.007,NULL,34982124326,546595692,8540557,17.5),(18542,'SNIa','2016-12-15 15:13:47','2016-12-16 11:18:50','1','SN 2007or',NULL,18542,38.86,0.08,592,4534,70,NULL,'Hubble residual -0.22 for z0.16640, SDSS-II SN 19174','APMUKS(BJ) B014004.08+004643.6',NULL,'2011ApJ...740...92G',2011,1,0.16,NULL,'G',0.0005,NULL,'19.79',0.09,NULL,NULL,NULL,NULL,NULL,1,25.65975,1.03033,0.057,NULL,66981713956,1046589280,16352957,19.79),(18543,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 19174','R',18543,39.33,0.19,630,4534,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007or','APMUKS(BJ) B014004.08+004643.6',0.1664,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18544,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 19174','R',18544,39.47,0.1,671,4534,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007or','APMUKS(BJ) B014004.08+004643.6',0.1664,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18545,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 2007or',NULL,18545,39.2,0.08,692,4534,70,NULL,'SALT 2','APMUKS(BJ) B014004.08+004643.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18546,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 2007or',NULL,18546,39.21,0.08,695,4534,70,NULL,'SALT 2, Malmquist cor.','APMUKS(BJ) B014004.08+004643.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18547,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 20125','R',18547,39.34,0.19,634,4535,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20125',0.166236,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,25.6597083333,1.03042,0.057,NULL,66981713956,1046589280,16352957,NULL),(18548,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 20125','R',18548,39.48,0.1,674,4535,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20125',0.166236,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18549,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 20125',NULL,18549,39.19,0.28,688,4535,70,NULL,'SN photometric redshift distance, z photo =0.176 +/- 0.027','SDSS-II SN 20125',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18550,'IRAS','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18550,33.93,0.8,61.1,4536,75,NULL,'MAT, I','ESO 543- G 012',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.37',0.7,'(R\'_1)SB(s)ab:',NULL,NULL,NULL,NULL,1,25.6762916667,-18.22692,0,NULL,35039268359,547488568,8554508,14.37),(18551,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18551,33.93,0.32,61.2,4536,85,NULL,'I, raw','ESO 543- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18552,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18552,33.98,0.32,62.4,4536,85,NULL,'I, inv','ESO 543- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18553,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18553,34.04,0.43,64.3,4536,75,NULL,'MAT, I, raw','ESO 543- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18554,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18554,34.17,0.4,68.1,4536,NULL,NULL,'mean','ESO 543- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18555,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18555,34.23,0.43,70.2,4536,75,NULL,'MAT, I, inv','ESO 543- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18556,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18556,34.29,0.37,72.1,4536,NULL,NULL,NULL,'ESO 543- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18557,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18557,34.3,0.43,72.3,4536,75,NULL,'MAT, I, cor','ESO 543- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18558,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18558,34.33,0.2,73.5,4536,74.4,NULL,NULL,'ESO 543- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18559,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18559,34.36,0.36,74.4,4536,NULL,NULL,'Malmquist cor.','ESO 543- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18560,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18560,34.55,0.47,81.4,4536,NULL,NULL,'H','ESO 543- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18561,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18561,36.43,0.2,193,4537,74.4,NULL,NULL,'UGC 01199',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000167,NULL,'15.38',0.3,'Sab',NULL,NULL,NULL,NULL,1,25.676417,8.17492,0.109,NULL,67024926438,1047264475,16363507,15.38),(18562,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18562,35.79,0.67,144,4538,70,NULL,NULL,'2MASX J01424555-0451324',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'16.43',0.31,NULL,NULL,NULL,NULL,NULL,1,25.689875,-4.85906,0.047,NULL,35025812664,547278322,8551223,16.43),(18563,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18563,37.38,0.46,299,4539,70,NULL,NULL,'2MASX J01424739+1310496',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000202,NULL,'16.2g',0.41,'BrClG',NULL,NULL,NULL,NULL,1,25.6975833333,13.18056,0.125,NULL,66928447406,1045756990,16339952,16.2),(18564,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18564,30.66,0.43,13.5,4540,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01200',NULL,'2014MNRAS.444..527S',2014,1,1.5,NULL,'G',0.000013,NULL,'14.0g',0.82,'IBm:','X-ray-faint group member',NULL,NULL,NULL,1,25.7012083,13.15597,0.125,NULL,66928446041,1045756969,16339952,14),(18565,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18565,30.68,0.2,13.7,4540,74.4,NULL,NULL,'UGC 01200',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18566,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18566,30.71,0.43,13.9,4540,75,NULL,'3.6 micron, color corrected','UGC 01200',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18567,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 14888',NULL,18567,40.58,0.12,1310,4541,70,NULL,'SN photometric redshift distance, z photo =0.370 +/- 0.026','SDSS-II SN 14888',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,25.7045,-0.64986,0.061,NULL,34974095279,546470238,8538597,NULL),(18568,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 14111','RN',18568,42.13,0.3,1830,4542,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 14111',0.452526,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18569,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18569,35.16,0.52,108,4543,70,NULL,NULL,'ESO 297- G 021',NULL,'2014MNRAS.445.2677S',2014,1,0.85,NULL,'G',0.000103,NULL,'15.76',0.24,'S0',NULL,NULL,NULL,NULL,1,25.720417,-40.84275,NULL,NULL,38325306939,598832920,9356764,15.76),(18570,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18570,34.3,0.29,72.6,4544,NULL,NULL,NULL,'IC 0150',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000127,NULL,'14.74',0.5,'Sb',NULL,NULL,NULL,NULL,1,25.7396666667,4.20017,0.073,NULL,67030685155,1047354455,16364913,14.74),(18571,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18571,34.34,0.2,73.8,4544,74.4,NULL,NULL,'IC 0150',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18572,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18572,34.39,0.27,75.5,4544,NULL,NULL,'Malmquist cor.','IC 0150',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18573,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 05935','RN',18573,43.87,0.29,3640,4545,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05935',0.630805,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18574,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 2007qo',NULL,18574,39.63,0.14,842,4546,70,NULL,'Hubble residual 0.02 for z0.21810','SDSS J014301.58-005642.6',NULL,'2011ApJ...740...92G',2011,1,0.07,NULL,'G',0.0009,NULL,'20.9g',0.04,NULL,NULL,NULL,NULL,NULL,1,25.7565833333,-0.94519,0.049,NULL,34973668972,546463577,8538493,20.9),(18575,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 20364','R',18575,40.2,0.25,900,4546,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007qo','SDSS J014301.58-005642.6',0.2181,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18576,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 20364','R',18576,40.21,0.15,906,4546,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007qo','SDSS J014301.58-005642.6',0.2181,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18577,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 2007qo',NULL,18577,40.19,0.13,1090,4546,70,NULL,'SALT 2','SDSS J014301.58-005642.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18578,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 2007qo',NULL,18578,40.21,0.13,1100,4546,70,NULL,'SALT 2, Malmquist cor.','SDSS J014301.58-005642.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18579,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18579,30.37,0.4,11.8,4547,75,NULL,'B','NGC 0660',NULL,'1988NBGC.C....0000T',1988,1,8.3,NULL,'G',0.000003,NULL,'12.0B',3.2,'SB(s)a pec;HII LINER','X-ray-faint group member',NULL,NULL,'Sy 2',1,25.76,13.64506,0.137,NULL,66927151371,1045736740,16339636,12),(18580,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18580,30.61,0.37,13.3,4547,NULL,NULL,NULL,'NGC 0660',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18581,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18581,30.66,0.2,13.6,4547,74.4,NULL,NULL,'NGC 0660',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18582,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18582,30.73,0.4,14,4547,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 3 galaxy group','NGC 0660',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18583,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18583,30.75,0.39,14.1,4547,73,NULL,'opt','NGC 0660',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18584,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18584,30.83,0.33,14.7,4547,NULL,NULL,'Malmquist cor.','NGC 0660',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18585,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18585,30.99,NULL,15.8,4547,75,NULL,'HI','NGC 0660',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18586,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18586,31.42,NULL,19.2,4547,54,NULL,'HI','NGC 0660',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18587,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18587,31.42,NULL,19.2,4547,75,NULL,'CO','NGC 0660',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18588,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18588,31.9,NULL,24,4547,65.2,NULL,'CO','NGC 0660',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18589,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18589,34.79,0.4,90.8,4548,NULL,NULL,'mean','ESO 245- G 003',NULL,'2007A&A...465...71T',2007,1,1.17,NULL,'G',0.000033,NULL,'14.92',0.39,'Sb',NULL,NULL,NULL,NULL,1,25.775583,-44.21478,NULL,NULL,38377565374,599649458,9369522,14.92),(18590,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18590,34.96,0.45,98.1,4548,NULL,NULL,'K','ESO 245- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18591,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18591,35,0.47,99.8,4548,NULL,NULL,'H','ESO 245- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18592,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18592,35.1,0.46,105,4548,NULL,NULL,'J','ESO 245- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18593,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18593,35.42,0.46,121,4548,NULL,NULL,'Malmquist cor.','ESO 245- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18594,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18594,35.85,0.38,148,4548,NULL,NULL,NULL,'ESO 245- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18595,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18595,35.89,0.2,151,4548,74.4,NULL,NULL,'ESO 245- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18596,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 10146','RN',18596,41.47,0.29,1530,4549,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 10146',0.284241,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18597,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 10146','RN',18597,41.81,0.45,1790,4549,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 10146',0.284241,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18598,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18598,35.84,0.4,147,4550,NULL,NULL,'mean','CGCG 482-005',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000033,NULL,'14.86',0.3,'S?',NULL,NULL,NULL,NULL,1,25.783333,27.75083,0.229,NULL,67726763555,1058230680,16534854,14.86),(18599,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18599,35.89,0.47,150,4550,NULL,NULL,'H','CGCG 482-005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18600,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18600,35.92,0.45,153,4550,NULL,NULL,'K','CGCG 482-005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18601,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18601,35.94,0.46,154,4550,NULL,NULL,'J','CGCG 482-005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18602,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18602,37.57,0.46,326,4551,70,NULL,NULL,'2MASX J01430900+1322158',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,25.7875833333,13.371,0.125,NULL,66927665858,1045744779,16339762,17.9),(18603,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18603,33.38,0.49,47.5,4552,70,NULL,NULL,'IC 1724',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'14.20',0.5,'S0+:',NULL,NULL,NULL,NULL,1,25.790333,-34.24189,NULL,NULL,38317951790,598717996,9354968,14.2),(18604,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18604,36.99,0.59,250,4553,70,NULL,NULL,'2MASX J01431083-1439579',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'16.41',0.31,NULL,NULL,NULL,NULL,NULL,1,25.7952916667,-14.66606,0,NULL,35080050388,548125787,8564465,16.41),(18605,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18605,34.38,0.2,75.2,4554,74.4,NULL,NULL,'UGC 01204',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000137,NULL,'15.20',0.4,'Sbc',NULL,NULL,NULL,NULL,1,25.799625,4.27872,0.073,NULL,67030742418,1047355350,16364927,15.2),(18606,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18606,34.38,0.26,75.2,4554,NULL,NULL,NULL,'UGC 01204',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18607,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18607,34.4,0.26,76,4554,NULL,NULL,'Malmquist cor.','UGC 01204',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18608,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18608,34.6,0.49,83.2,4554,75,NULL,'IR','UGC 01204',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18609,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18609,34.86,0.46,93.9,4555,70,NULL,NULL,'2MASX J01431251-0900112',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000067,NULL,'16.1g',0.26,'S0',NULL,NULL,NULL,NULL,1,25.802083,-9.00328,0.039,NULL,34995800756,546809386,8543896,16.1),(18610,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 07307','RN',18610,40.96,0.13,1350,4556,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 07307',0.151143,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18611,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 07307','RN',18611,41.51,0.42,1740,4556,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07307',0.151143,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18612,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18612,38.31,0.46,458,4557,70,NULL,NULL,'SDSS J014313.91+134511.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,25.8079583,13.75322,0.137,NULL,66927156554,1045736821,16339637,18.3),(18613,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18613,33.67,0.47,54.2,4558,NULL,NULL,'H','IC 1723',NULL,'2007A&A...465...71T',2007,1,3.3,NULL,'G',0.000023,NULL,'13.76',0.8,'Sb','in a radial-velocity based grouping',NULL,NULL,NULL,1,25.809083,8.88936,0.133,NULL,67022318433,1047223725,16362870,13.76),(18614,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18614,33.76,0.45,56.6,4558,NULL,NULL,'K','IC 1723',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18615,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18615,33.81,0.46,57.8,4558,NULL,NULL,'J','IC 1723',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18616,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18616,33.83,0.49,58.3,4558,75,NULL,'IR','IC 1723',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18617,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18617,33.93,0.2,61.1,4558,74.4,NULL,NULL,'IC 1723',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18618,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18618,33.96,0.45,61.9,4558,NULL,NULL,NULL,'IC 1723',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18619,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18619,34.05,0.43,64.7,4558,NULL,NULL,'Malmquist cor.','IC 1723',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18620,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18620,34.29,0.4,72.3,4558,NULL,NULL,'mean','IC 1723',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18621,'Brightest Stars','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18621,30.2,0.4,11,4559,NULL,NULL,NULL,'UGCA 020',NULL,'1996A&AS..119..499S',1996,1,3.1,NULL,'G',0.000018,NULL,'18',0.8,'Im',NULL,NULL,NULL,NULL,1,25.811375,19.97547,0.121,NULL,66914239323,1045534989,16336484,18),(18622,'Tully est','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18622,29.52,0.8,8,4559,75,NULL,NULL,'UGCA 020',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18623,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18623,36.29,0.2,181,4560,74.4,NULL,NULL,'CGCG 482-006',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000033,NULL,'15.7',0.3,'Sc',NULL,NULL,NULL,NULL,1,25.828375,22.42028,0.357,NULL,67379765287,1052808832,16450138,15.7),(18624,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18624,36.67,0.33,215,4561,70,NULL,NULL,'2MASX J01432246-0056503',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000091,NULL,'16.0g',0.32,'S0',NULL,NULL,NULL,NULL,1,25.8435833333,-0.94722,0.049,NULL,34973524595,546461321,8538458,16),(18625,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18625,36.67,0.33,215,4562,70,NULL,NULL,'2MASX J01432506-0052593',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000073,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,25.854375,-0.88322,0.049,NULL,34973505238,546461019,8538453,16.9),(18626,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18626,35.49,0.46,125,4563,70,NULL,NULL,'2MASX J01432665+1319131',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000081,NULL,'15.8g',0.26,'S0',NULL,NULL,NULL,NULL,1,25.861125,13.32028,0.125,NULL,66927718523,1045745601,16339775,15.8),(18627,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 14141',NULL,18627,41.59,NULL,2080,4564,70,NULL,'SN photometric redshift distance, z photo =0.699 +/- 0.001','SDSS-II SN 14141',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','20.4g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,25.8645,0.16444,0.053,NULL,66981061185,1046579081,16352798,20.4),(18628,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 14937','RN',18628,42.44,0.28,2080,4565,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14937',0.479807,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18629,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18629,38.15,0.46,426,4566,70,NULL,NULL,'2MASX J01433141-1016335',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000082,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,25.8810417,-10.27594,0.031,NULL,35100329359,548442646,8569416,17.5),(18630,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18630,34.53,0.42,80.7,4567,NULL,NULL,NULL,'ESO 245- G 004',NULL,'2009ApJS..182..474S',2009,1,0.88,NULL,'G',0.000033,NULL,'15.56',0.38,'Sb',NULL,NULL,NULL,NULL,1,25.882833,-44.16167,NULL,NULL,38377610709,599650167,9369533,15.56),(18631,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18631,34.57,0.2,82,4567,74.4,NULL,NULL,'ESO 245- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18632,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18632,34.65,0.4,85.1,4567,NULL,NULL,'Malmquist cor.','ESO 245- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18633,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18633,35.15,0.49,107,4568,75,NULL,'IR','ESO 477- G 001',NULL,'2011yCatp016004901K',2011,1,1.75,NULL,'G',0.00002,NULL,'16.57',0.11,'Scd',NULL,NULL,NULL,NULL,1,25.9002083,-26.94794,0.032,NULL,38255413301,597740832,9339700,16.57),(18634,'Brightest Stars','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18634,29.48,0.4,7.87,4569,NULL,NULL,NULL,'KDG 010',NULL,'1996A&AS..119..499S',1996,1,1.5,NULL,'G',0.000001,NULL,'16.28',1,'Dwarf','X-ray-faint group member',NULL,NULL,NULL,1,25.903333,15.69222,0.129,NULL,66934090861,1045845169,16341330,16.28),(18635,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18635,34.87,0.47,94,4570,70,NULL,NULL,'MCG -01-05-025',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000087,NULL,'14.65',0.9,'SA(s)0^0^?',NULL,NULL,NULL,NULL,1,25.9282083333,-4.00169,0.13,NULL,35025162541,547268164,8551065,14.65),(18636,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 13497',NULL,18636,40.66,0.18,1350,4571,70,NULL,'SN photometric redshift distance, z photo =0.387 +/- 0.044','SDSS-II SN 13497',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.2g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,25.93475,-1.04647,0.037,NULL,34975414109,546490845,8538919,21.2),(18637,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 13497','R',18637,41.45,0.22,1400,4571,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13497',0.395788,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18638,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 13497','R',18638,41.49,0.27,1420,4571,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13497',0.395788,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18639,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 13497',NULL,18639,41.37,0.17,1880,4571,70,NULL,'SALT 2','SDSS-II SN 13497',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18640,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 13497',NULL,18640,41.43,0.17,1930,4571,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13497',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18641,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18641,34.04,0.33,64.2,4572,NULL,NULL,NULL,'NGC 0664',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000017,NULL,'13.61',1.3,'Sb:',NULL,NULL,NULL,NULL,1,25.940875,4.22289,0.069,NULL,67030518190,1047351846,16364872,13.61),(18642,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18642,34.07,0.47,65.2,4572,NULL,NULL,'H','NGC 0664',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18643,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18643,34.08,0.2,65.5,4572,74.4,NULL,NULL,'NGC 0664',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18644,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18644,34.14,0.45,67.4,4572,NULL,NULL,'K','NGC 0664',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18645,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18645,34.19,0.46,68.8,4572,NULL,NULL,'J','NGC 0664',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18646,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18646,34.27,0.29,71.6,4572,NULL,NULL,'Malmquist cor.','NGC 0664',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18647,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18647,34.29,0.4,72.3,4572,NULL,NULL,'mean','NGC 0664',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18648,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 17031',NULL,18648,40.09,0.95,1040,4573,70,NULL,'SN photometric redshift distance, z photo =0.282 +/- 0.204','SDSS-II SN 17031',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.8g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,25.9647917,-0.67581,0.049,NULL,34973998065,546468719,8538573,21.8),(18649,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 17031','R',18649,41.53,0.42,1460,4573,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17031',0.390602,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18650,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 17031','R',18650,41.81,0.48,1650,4573,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17031',0.390602,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18651,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 17031',NULL,18651,41.51,0.32,2000,4573,70,NULL,'SALT 2','SDSS-II SN 17031',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18652,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 17031',NULL,18652,41.57,0.32,2060,4573,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 17031',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18653,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 18175',NULL,18653,38.3,1.46,457,4574,70,NULL,'SN photometric redshift distance, z photo =0.113 +/- 0.123','SDSS-II SN 18175',NULL,'2011ApJ...738..162S',2011,1,0.03,NULL,'G',NULL,'PHOT','18.4g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,25.991625,-0.399,0.041,NULL,34974185601,546471650,8538619,18.4),(18654,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 18175','R',18654,41.81,0.34,1670,4574,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18175',0.377082,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18655,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 18175','R',18655,41.89,0.41,1730,4574,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18175',0.377082,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18656,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 18175',NULL,18656,41.84,0.27,2330,4574,70,NULL,'SALT 2','SDSS-II SN 18175',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18657,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 18175',NULL,18657,41.89,0.27,2390,4574,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18175',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18658,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18658,34.21,0.2,69.5,4575,74.4,NULL,NULL,'CGCG 437-016',NULL,'2013AJ....146...86T',2013,1,0.5,'This galaxy may also be IC 0152.','G',0.000113,NULL,'16.0g',0.4,'Sd',NULL,NULL,NULL,NULL,1,26.005875,13.07414,0.125,NULL,66927652041,1045744563,16339758,16),(18659,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18659,37.91,0.46,383,4576,70,NULL,NULL,'2MASX J01440391-1010168',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000086,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,26.0164583,-10.17131,0.031,NULL,35100443750,548444433,8569444,17.5),(18660,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18660,36.51,0.46,201,4577,70,NULL,NULL,'2MASX J01440557-0902208',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000074,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,26.0231666667,-9.03908,0.053,NULL,34995767484,546808866,8543888,16.9),(18661,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18661,34.5,0.55,79.4,4578,70,NULL,NULL,'2MASX J01440751-3611268',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.000103,NULL,'16.25',0.4,'E',NULL,NULL,NULL,NULL,1,26.0312916667,-36.19083,NULL,NULL,38296582229,598384097,9349751,16.25),(18662,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18662,35.12,0.69,106,4579,100,NULL,'mid-IR','UGC 01212',NULL,'2013ApJ...771...88L',2013,1,1.4,NULL,'G',0.000012,NULL,'14.25',1,'Sb',NULL,NULL,NULL,NULL,1,26.0339583,34.38731,0.129,NULL,67777767477,1059027616,16547306,14.25),(18663,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 16087','R',18663,39.1,0.13,627,4580,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2006pc','SN 2006pc',0.054968,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'II',NULL,NULL,NULL,NULL,1,26.044083,-0.15589,0.033,NULL,34973749873,546464841,8538513,NULL),(18664,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 16087','R',18664,40.44,0.23,1160,4580,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2006pc','SN 2006pc',0.054968,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18665,'SBF','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18665,32.19,0.25,27.4,4581,NULL,NULL,NULL,'NGC 0661',NULL,'2001MNRAS.327.1004B',2001,1,1.7,NULL,'G',0.000017,NULL,'13.18',1.4,'E+:','in a radial-velocity based grouping',NULL,NULL,NULL,1,26.0609166667,28.70592,0.229,NULL,67729519122,1058273736,16535527,13.18),(18666,'SBF','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18666,32.43,0.25,30.6,4581,NULL,NULL,'Malmquist cor.','NGC 0661',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18667,'D-Sigma','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18667,32,0.4,25.1,4581,75,NULL,'Edat, raw','NGC 0661',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18668,'D-Sigma','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18668,32.33,0.4,29.3,4581,75,NULL,'Edat, cor','NGC 0661',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18669,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18669,32.75,0.41,35.5,4581,NULL,NULL,NULL,'NGC 0661',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18670,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18670,33.41,0.41,48,4581,NULL,NULL,'Malmquist cor.','NGC 0661',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18671,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18671,33.49,0.4,49.9,4581,NULL,NULL,'mean','NGC 0661',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18672,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18672,33.61,0.45,52.6,4581,NULL,NULL,'K','NGC 0661',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18673,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18673,35.52,0.46,127,4582,NULL,NULL,'Malmquist cor.','UGC 01218',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000153,NULL,'15.27',0.4,'SBbc:',NULL,NULL,NULL,NULL,1,26.0725,12.25444,0.129,NULL,66925937949,1045717780,16339340,15.27),(18674,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18674,35.64,0.43,135,4582,NULL,NULL,NULL,'UGC 01218',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18675,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18675,35.73,0.2,140,4582,74.4,NULL,NULL,'UGC 01218',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18676,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18676,33.03,0.69,40.3,4583,100,NULL,'mid-IR','UGC 01219',NULL,'2013ApJ...771...88L',2013,1,1.3,NULL,'G',0.000017,NULL,'13.66',0.6,'SB?',NULL,NULL,NULL,NULL,1,26.085917,17.47758,0.141,NULL,66966330050,1046348907,16349201,13.66),(18677,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18677,33.79,0.45,57.2,4583,NULL,NULL,'K','UGC 01219',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18678,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18678,33.79,0.47,57.3,4583,NULL,NULL,'H','UGC 01219',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18679,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18679,33.79,0.46,57.4,4583,NULL,NULL,'J','UGC 01219',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18680,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18680,33.94,0.4,61.4,4583,NULL,NULL,'mean','UGC 01219',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18681,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18681,34.01,0.43,63.4,4583,NULL,NULL,'Malmquist cor.','UGC 01219',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18682,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18682,34.07,0.41,65.1,4583,NULL,NULL,NULL,'UGC 01219',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18683,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18683,34.08,0.2,65.5,4583,74.4,NULL,NULL,'UGC 01219',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18684,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18684,35.43,0.46,122,4584,70,NULL,NULL,'2MASX J01442619+1309351',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000086,NULL,'16.4g',0.3,'NLAGN',NULL,NULL,NULL,NULL,1,26.10925,13.15986,0.125,NULL,66925725364,1045714458,16339288,16.4),(18685,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18685,35.64,0.49,134,4585,75,NULL,'IR','2MFGC 01309',NULL,'2011yCatp016004901K',2011,1,0.65,NULL,'G',NULL,NULL,'15.73',0.14,NULL,NULL,NULL,NULL,NULL,1,26.1105416667,38.26347,0.165,NULL,67734398765,1058349980,16536718,15.73),(18686,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18686,38.07,0.46,411,4586,70,NULL,NULL,'2MASX J01442677+0044185',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000082,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,26.111625,0.73842,0.041,NULL,66981724507,1046589445,16352960,17.9),(18687,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18687,35,0.52,100,4587,70,NULL,NULL,'ESO 297- G 023',NULL,'2014MNRAS.445.2677S',2014,1,1.24,NULL,'G',0.000033,NULL,'14.42',0.46,'SAB(rs)b','Pair member (points to parent)',NULL,NULL,NULL,1,26.11975,-40.66461,NULL,NULL,38325233454,598831772,9356746,14.42),(18688,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18688,34.78,0.22,90.4,4587,NULL,NULL,'B, Hubble-type-TF','ESO 297- G 023',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18689,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18689,35.75,0.3,142,4587,NULL,NULL,'Malmquist cor.','ESO 297- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18690,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18690,36.07,0.26,164,4587,NULL,NULL,NULL,'ESO 297- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18691,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18691,36.11,0.2,167,4587,74.4,NULL,NULL,'ESO 297- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18692,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18692,33.29,NULL,45.6,4588,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0191',NULL,'2010Ap&SS.325..163P',2010,1,1.79,NULL,'G',0.000002,NULL,'16.0',0.13,'Sd',NULL,NULL,NULL,NULL,1,26.12,27.92889,0.213,NULL,67728602585,1058259415,16535303,16),(18693,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18693,33.3,NULL,45.6,4588,NULL,NULL,'Dipole + Quadrupole','FGC 0191',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18694,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18694,33.3,NULL,45.7,4588,NULL,NULL,'Dipole','FGC 0191',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18695,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18695,33.32,NULL,46.2,4588,NULL,NULL,NULL,'FGC 0191',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18696,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18696,33.57,0.2,51.8,4588,74.4,NULL,NULL,'FGC 0191',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18697,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18697,33.71,0.44,55.3,4588,NULL,NULL,NULL,'FGC 0191',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18698,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18698,34.12,0.37,66.6,4588,NULL,NULL,'Malmquist cor.','FGC 0191',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18699,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 20764','R',18699,39.41,0.2,650,4589,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ro','APMUKS(BJ) B014155.17-000115.2',0.17,'2014arXiv1401.3317S',2014,1,0.18,NULL,'G',NULL,NULL,'19.33',0.13,NULL,NULL,NULL,NULL,NULL,1,26.1207916667,0.22981,0.065,NULL,66981376773,1046584012,16352875,19.33),(18700,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 2007ro',NULL,18700,39.22,0.09,698,4589,70,NULL,'SALT 2','APMUKS(BJ) B014155.17-000115.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18701,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 2007ro',NULL,18701,39.23,0.09,701,4589,70,NULL,'SALT 2, Malmquist cor.','APMUKS(BJ) B014155.17-000115.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18702,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 20764','R',18702,39.78,0.14,771,4589,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ro','APMUKS(BJ) B014155.17-000115.2',0.17,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18703,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18703,37.25,0.46,282,4590,70,NULL,NULL,'2MASX J01443108-0110041',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000071,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,26.129583,-1.16778,0,NULL,34975452381,546491443,8538928,17.5),(18704,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 18121','RN',18704,41.38,0.17,1400,4591,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18121',0.345506,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18705,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 18121','RN',18705,42.06,0.23,1920,4591,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18121',0.345506,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18706,'IRAS','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18706,34.44,0.8,77.4,4592,75,NULL,'HMCL, I','NGC 0662',NULL,'1997ApJS..109..333W',1997,1,0.8,NULL,'G',0.000013,NULL,'14.0B',0.5,'S pec','Isolated galaxy',NULL,NULL,NULL,1,26.1477083,37.69578,0.197,NULL,67737326003,1058395718,16537433,14),(18707,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18707,33.96,0.69,61.9,4592,100,NULL,'mid-IR','NGC 0662',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18708,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18708,34.17,0.4,68.1,4592,75,NULL,'HMCL, I, raw','NGC 0662',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18709,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18709,34.33,0.4,73.5,4592,75,NULL,'HMCL, I, inv','NGC 0662',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18710,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18710,34.33,0.4,73.5,4592,75,NULL,'HMCL, I, cor','NGC 0662',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18711,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18711,34.39,0.2,75.5,4592,74.4,NULL,NULL,'NGC 0662',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18712,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18712,34.48,0.4,78.7,4592,NULL,NULL,'mean','NGC 0662',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18713,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18713,34.56,0.47,81.7,4592,NULL,NULL,'H','NGC 0662',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18714,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18714,34.69,0.45,86.7,4592,NULL,NULL,'K','NGC 0662',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18715,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18715,34.71,0.46,87.4,4592,NULL,NULL,'J','NGC 0662',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18716,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18716,38.16,0.33,428,4593,70,NULL,NULL,'2MASX J01443704+0027305',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000088,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,26.154167,0.45844,0.037,NULL,66981294419,1046582725,16352855,18),(18717,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18717,35.59,0.46,131,4594,70,NULL,NULL,'2MASX J01443806-0951432',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000085,NULL,'16.0g',0.38,'S0',NULL,NULL,NULL,NULL,1,26.158625,-9.86189,0.059,NULL,34982136487,546595882,8540560,16),(18718,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18718,33.43,0.49,48.6,4595,75,NULL,'IR','KUG 0141+344',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000033,NULL,'15.0',0.2,'S: pec         HII',NULL,NULL,NULL,NULL,1,26.159875,34.66022,0.193,NULL,67776926813,1059014481,16547101,15),(18719,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18719,34.19,0.07,69,4595,NULL,NULL,NULL,'KUG 0141+344',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18720,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18720,37.18,0.46,272,4596,70,NULL,NULL,'2MASX J01443881+1342331',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,26.161875,13.70908,0.141,NULL,66938223447,1045909741,16342339,17.8),(18721,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 05925',NULL,18721,39.28,1.61,717,4597,70,NULL,'SN photometric redshift distance, z photo =0.184 +/- 0.258','SDSS-II SN 05925',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,26.1625833333,-1.14606,0,NULL,34975449436,546491397,8538928,NULL),(18722,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 05925','R',18722,41.42,0.25,1380,4597,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 05925',0.396531,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18723,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 05925','R',18723,41.59,0.3,1490,4597,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05925',0.396531,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18724,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 05925',NULL,18724,41.51,0.19,2000,4597,70,NULL,'SALT 2','SDSS-II SN 05925',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18725,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 05925',NULL,18725,41.57,0.19,2060,4597,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 05925',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18726,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 05978','RN',18726,40.71,0.27,1080,4598,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 05978',0.280661,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18727,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 05978','RN',18727,40.92,0.35,1190,4598,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05978',0.280661,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18728,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 05978','N',18728,40.77,0.22,1430,4598,70,NULL,'SALT 2','SDSS-II SN 05978',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18729,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 05978','N',18729,40.8,0.22,1450,4598,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 05978',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18730,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18730,34.66,0.52,85.5,4599,70,NULL,NULL,'MCG -01-05-028',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00015,NULL,'15.05',1.3,'(R\')SA(r)0+:',NULL,NULL,NULL,NULL,1,26.162667,-7.61997,0.081,NULL,34996717192,546823706,8544120,15.05),(18731,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18731,37.65,0.46,338,4600,70,NULL,NULL,'2MASX J01443972-0828052',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000082,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,26.165583,-8.46808,0.073,NULL,34996011424,546812678,8543948,17.3),(18732,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 13004','RN',18732,41.39,0.29,1590,4601,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 13004',0.192038,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18733,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 13004','RN',18733,42.25,0.35,2370,4601,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 13004',0.192038,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18734,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 19528','RN',18734,38.68,0.19,521,4602,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 19528',0.043083,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18735,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18735,36.83,0.46,232,4603,70,NULL,NULL,'2MASX J01444241-0008101',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00008,NULL,'17.3g',0.2,'NLAGN',NULL,NULL,NULL,NULL,1,26.17675,-0.13614,0.041,NULL,34973795638,546465556,8538524,17.3),(18736,'BCG','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18736,38.41,0.35,447,4604,60,NULL,NULL,'ABELL 0246',0.0753,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III [BM]',NULL,NULL,NULL,NULL,1,26.1777083,5.80053,0.121,NULL,67031316030,1047364312,16365067,NULL),(18737,'TRGB','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18737,29.23,0.1,7.03,4605,74.4,NULL,NULL,'AGC 111945',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.000002,NULL,'17.1',0.6,'Irr',NULL,NULL,NULL,NULL,1,26.178333,27.28861,0.237,NULL,67716030139,1058062970,16532233,17.1),(18738,'BCG','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18738,38.41,0.35,447,4606,60,NULL,'ABELL 0246, BCG','2MASX J01444342+0548435',0.0753,'1980ApJ...241..486H',1980,1,0.41,NULL,'G',0.00012,NULL,'17.47',NULL,NULL,'Brightest group member',NULL,NULL,NULL,1,26.181,5.81211,0.121,NULL,67031314709,1047364292,16365067,17.47),(18739,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18739,38.16,0.33,428,4607,70,NULL,NULL,'2MASX J01444351+0027035',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000079,NULL,'16.9g',0.26,'AGN',NULL,NULL,NULL,NULL,1,26.18125,0.451,0.065,NULL,66981287037,1046582609,16352853,16.9),(18740,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18740,34.64,0.64,84.7,4608,NULL,NULL,'Malmquist cor.','2MASX J01444498+1721365',NULL,'2009ApJS..182..474S',2009,1,0.3,NULL,'G',0.000063,NULL,'17.43',0.2,NULL,NULL,NULL,NULL,NULL,1,26.1875833333,17.36014,0.141,NULL,66967181521,1046362211,16349409,17.43),(18741,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18741,34.67,0.2,85.9,4608,74.4,NULL,NULL,'2MASX J01444498+1721365',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18742,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18742,34.72,0.62,87.8,4608,NULL,NULL,NULL,'2MASX J01444498+1721365',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18743,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 18136','RN',18743,43.41,0.33,3140,4609,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 18136',0.530997,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18744,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18744,32.55,1.81,32.4,4610,NULL,NULL,NULL,'CGCG 482-008',NULL,'2009ApJS..182..474S',2009,1,0.86,'VCV and MCG identification as IC 1725 is incorrect.','G',0.000033,NULL,'15.15',0.73,'SBb            Sy2',NULL,NULL,NULL,'Sy 2',1,26.208333,21.88242,0.269,NULL,66909190706,1045456104,16335251,15.15),(18745,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18745,33.63,1.1,53.3,4610,NULL,NULL,'Malmquist cor.','CGCG 482-008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18746,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 14169','R',18746,40.38,0.27,888,4611,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 14169',0.343067,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,26.212875,0.988,0.041,NULL,66982943770,1046608496,16353257,NULL),(18747,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 14169','R',18747,40.62,0.34,990,4611,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 14169',0.343067,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18748,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 14169',NULL,18748,40.46,0.28,1240,4611,70,NULL,'SN photometric redshift distance, z photo =0.346 +/- 0.061','SDSS-II SN 14169',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18749,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18749,37.24,0.46,280,4612,70,NULL,NULL,'2MASX J01445445-1020101',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000084,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,26.2270417,-10.33619,0.037,NULL,35100384257,548443504,8569429,17.8),(18750,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18750,33.36,0.45,47.1,4613,NULL,NULL,'K','NGC 0665',NULL,'2007A&A...465...71T',2007,1,2.4,'87GB source with large sky, narrow minor axis, or very bad confusion.','G',0.000067,NULL,'13.17',1.6,'(R)S0^0^?','in a radial-velocity based grouping',NULL,NULL,NULL,1,26.23375,10.42303,0.157,NULL,67043523021,1047555047,16368047,13.17),(18751,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18751,34.26,0.4,71.2,4613,NULL,NULL,'mean','NGC 0665',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18752,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18752,36.69,0.46,217,4614,70,NULL,NULL,'2MASX J01445646+1507186',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000083,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,26.2351666667,15.12181,0.105,NULL,66934050934,1045844545,16341321,17.6),(18753,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18753,36.19,0.66,173,4615,70,NULL,NULL,'NGC 0667',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.18',0.5,'SA0^0^:',NULL,NULL,NULL,NULL,1,26.236167,-22.91894,0,NULL,35165350458,549458600,8585290,15.18),(18754,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18754,35.14,0.51,107,4616,70,NULL,NULL,'ESO 543- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000103,NULL,'15.20',0.8,'S0(r)',NULL,NULL,NULL,NULL,1,26.262417,-21.28758,0,NULL,35033170546,547393289,8553020,15.2),(18755,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18755,38,0.46,398,4617,70,NULL,NULL,'2MASX J01450350+0044065',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000067,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,26.264625,0.73525,0.037,NULL,66982389383,1046599834,16353122,18.2),(18756,'TRGB','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18756,28.23,0.23,4.43,4618,NULL,NULL,NULL,'ESO 245- G 005',NULL,'2003A&A...404...93K',2003,1,3.6,NULL,'G',0.000007,NULL,'12.7B',3.2,'IB(s)m','Field galaxy',NULL,NULL,NULL,1,26.265583,-43.59803,NULL,NULL,38375505062,599617266,9369019,12.7),(18757,'TRGB','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18757,28.29,0.06,4.55,4618,NULL,NULL,'I','ESO 245- G 005',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18758,'TRGB','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18758,28.3,0.1,4.57,4618,74.4,NULL,NULL,'ESO 245- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18759,'Tully est','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18759,27.81,0.8,3.6,4618,75,NULL,NULL,'ESO 245- G 005',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18760,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18760,37.13,0.46,267,4619,70,NULL,NULL,'2MASX J01450664+0046075',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000067,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,26.277625,0.76883,0.037,NULL,66982908588,1046607946,16353249,17.3),(18761,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18761,37.95,0.46,389,4620,70,NULL,NULL,'2MASX J01450916-0052040',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.38',0.18,NULL,NULL,NULL,NULL,NULL,1,26.288167,-0.86781,0,NULL,34976168265,546502629,8539103,18.38),(18762,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18762,35.45,0.49,123,4621,75,NULL,'IR','UGC 01224',NULL,'2011yCatp016004901K',2011,1,1.12,NULL,'G',0.000025,NULL,'17.',0.11,'Scd',NULL,NULL,NULL,NULL,1,26.292333,32.12317,0.093,NULL,67774271249,1058972988,16546452,17),(18763,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18763,35.86,NULL,149,4621,NULL,NULL,NULL,'UGC 01224',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18764,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18764,35.88,NULL,150,4621,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01224',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18765,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18765,35.88,NULL,150,4621,NULL,NULL,'Dipole + Quadrupole','UGC 01224',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18766,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18766,35.9,NULL,151,4621,NULL,NULL,'Dipole','UGC 01224',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18767,'IRAS','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18767,34.59,0.8,82.6,4622,75,NULL,'MAT, I','ESO 297- G 027',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.85',0.7,'SA(rs)ab','in a triple',NULL,NULL,NULL,1,26.295,-41.88,NULL,NULL,38331990980,598937359,9358396,14.85),(18768,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18768,34.66,0.32,85.6,4622,85,NULL,'I, raw','ESO 297- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18769,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18769,34.71,0.32,87.3,4622,85,NULL,'I, inv','ESO 297- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18770,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18770,34.76,0.43,89.7,4622,75,NULL,'MAT, I, raw','ESO 297- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18771,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18771,34.88,0.58,94.8,4622,NULL,NULL,'Malmquist cor.','ESO 297- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18772,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18772,34.97,0.43,98.5,4622,75,NULL,'MAT, I, inv','ESO 297- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18773,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18773,35.01,0.43,100,4622,75,NULL,'MAT, I, cor','ESO 297- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18774,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18774,35.06,0.53,103,4622,NULL,NULL,NULL,'ESO 297- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18775,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18775,35.1,0.2,105,4622,74.4,NULL,NULL,'ESO 297- G 027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18776,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 13376','R',18776,39.2,0.05,646,4623,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2006gq','2MASX J01451219+0021225',0.069723,'2014arXiv1401.3317S',2014,1,0.48,NULL,'G',0.000079,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,26.3007083,0.35625,0.065,NULL,66981436766,1046584949,16352889,16.3),(18777,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 13376','R',18777,39.46,0.19,730,4623,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2006gq','2MASX J01451219+0021225',0.069723,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18778,'SNII optical','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 2006gq',NULL,18778,36.85,0.09,219,4623,NULL,NULL,'SCM 55 SNII','2MASX J01451219+0021225',0.069723,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18779,'SNII optical','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 2006gq',NULL,18779,37.36,0.11,277,4623,NULL,NULL,'SCM 15 SDSS SNII','2MASX J01451219+0021225',0.069723,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18780,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18780,36.4,0.57,190,4624,70,NULL,NULL,'2MFGC 01322',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.000091,NULL,'16.1g',0.19,'Sb(f)',NULL,NULL,NULL,NULL,1,26.3022917,-8.66344,0.073,NULL,34996171927,546815186,8543987,16.1),(18781,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 02629','RN',18781,40.33,0.26,950,4625,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 02629',0.22305,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18782,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 02629','RN',18782,40.51,0.24,1040,4625,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 02629',0.22305,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18783,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 20921','RN',18783,40.77,0.34,1180,4626,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20921',0.210532,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18784,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 20921','RN',18784,40.87,0.27,1240,4626,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20921',0.210532,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18785,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 07630',NULL,18785,39.87,0.79,943,4627,70,NULL,'SN photometric redshift distance, z photo =0.251 +/- 0.138','SDSS-II SN 07630',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','22.1g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,26.3157083333,-1.19586,0.009,NULL,34976213916,546503342,8539114,22.1),(18786,'G Lens','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18786,40.77,NULL,1430,4628,NULL,NULL,'Standard','UM 673A',NULL,'2014ApJ...788..190W',2014,1,NULL,'One of two images of a gravitationally lensed quasar.','Q_Lens',NULL,NULL,NULL,NULL,'DLyA',NULL,NULL,NULL,NULL,1,26.319125,-9.75481,0.045,NULL,35100114140,548439283,8569363,NULL),(18787,'G Lens','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18787,40.78,NULL,1430,4628,NULL,NULL,'R(H) = ct','UM 673A',NULL,'2014ApJ...788..190W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18788,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18788,37.92,0.46,384,4629,70,NULL,NULL,'2MASX J01451922+1407481',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000081,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,26.3300416667,14.12994,0.101,NULL,66940235589,1045941181,16342830,18),(18789,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18789,36.91,0.46,241,4630,70,NULL,NULL,'2MASX J01452109-0811502',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000079,NULL,'16.1g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,26.3377917,-8.19744,0.107,NULL,34995648504,546807007,8543859,16.1),(18790,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 21590','RN',18790,44.48,0.39,5460,4631,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 21590',0.444807,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18791,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 04631','RN',18791,39.49,0.25,705,4632,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 04631',0.119614,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18792,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 04631','RN',18792,40.19,0.26,974,4632,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 04631',0.119614,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18793,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18793,36.68,0.21,217,4633,70,NULL,NULL,'2MASX J01452310-1000152',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000077,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,26.346417,-10.00417,0.043,NULL,35100977158,548452768,8569574,17.9),(18794,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 02545','RN',18794,41.19,0.18,1400,4634,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 02545',0.240564,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18795,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 02545','RN',18795,42.13,0.34,2150,4634,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 02545',0.240564,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18796,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 17731','RN',18796,42.23,0.18,1800,4635,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17731',0.557992,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18797,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 17223','R',18797,40.25,0.22,910,4636,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007jj','SN 2007jj',0.235,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,26.361375,-0.01942,0.069,NULL,34973909199,546467331,8538552,NULL),(18798,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 17223','R',18798,40.53,0.15,1030,4636,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007jj','SN 2007jj',0.235,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18799,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18799,38.4,0.46,480,4637,70,NULL,NULL,'2MASX J01452764-0002076',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000085,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,26.365333,-0.03533,0.069,NULL,34973909590,546467337,8538552,17.5),(18800,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18800,36.55,0.5,204,4638,70,NULL,NULL,'MCG -02-05-041',NULL,'2014MNRAS.445.2677S',2014,1,0.97,NULL,'G',0.00015,NULL,'14.8g',0.7,'S0-',NULL,NULL,NULL,NULL,1,26.3685833333,-10.09331,0.043,NULL,35100973111,548452704,8569573,14.8),(18801,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18801,37.16,0.46,270,4639,70,NULL,NULL,'2MASX J01453077+1413531',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000102,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,26.3781666667,14.23153,0.101,NULL,66940184024,1045940375,16342818,16.6),(18802,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 09109',NULL,18802,39.37,0.62,748,4640,70,NULL,'SN photometric redshift distance, z photo =0.193 +/- 0.074','SDSS-II SN 09109',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,26.3889583,0.85064,0.037,NULL,66982926965,1046608233,16353253,NULL),(18803,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 09109','R',18803,40.82,0.22,1140,4640,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 09109',0.281658,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18804,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 09109','R',18804,40.98,0.16,1220,4640,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 09109',0.281658,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18805,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 09109',NULL,18805,40.73,0.12,1400,4640,70,NULL,'SALT 2','SDSS-II SN 09109',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18806,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 09109',NULL,18806,40.75,0.12,1410,4640,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 09109',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18807,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 01464','RN',18807,40.96,0.38,1210,4641,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01464',0.290028,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18808,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 01464','RN',18808,41.52,0.27,1560,4641,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01464',0.290028,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18809,'IRAS','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18809,34.22,0.8,69.8,4642,75,NULL,'CF, r','UGC 01235',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.00011,NULL,'14.77',0.5,'Sbc',NULL,NULL,NULL,NULL,1,26.398667,3.35753,0.069,NULL,67038527830,1047476997,16366828,14.77),(18810,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18810,34.27,0.2,71.5,4642,74.4,NULL,NULL,'UGC 01235',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18811,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18811,34.28,0.29,71.7,4642,NULL,NULL,NULL,'UGC 01235',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18812,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18812,34.3,0.38,72.6,4642,75,NULL,'CF, r, raw','UGC 01235',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18813,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18813,34.36,0.38,74.5,4642,75,NULL,'CF, r, inv','UGC 01235',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18814,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18814,34.37,0.38,75,4642,75,NULL,'CF, r, cor','UGC 01235',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18815,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18815,34.4,0.28,76,4642,NULL,NULL,'Malmquist cor.','UGC 01235',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18816,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18816,35.67,0.75,136,4643,70,NULL,NULL,'2MASX J01453711-4017149',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000103,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,26.4047917,-40.28744,NULL,NULL,38326657048,598854016,9357094,14.2),(18817,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 14235','RN',18817,40.25,0.49,1040,4644,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 14235',0.083098,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18818,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 2006nn',NULL,18818,39.53,0.09,804,4645,70,NULL,'Hubble residual 0.12 for z0.19686','SDSS J014541.02-010315.8',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.00015,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,26.42125,-1.05456,0.009,NULL,34976294900,546504607,8539134,NULL),(18819,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 16099','R',18819,40.03,0.07,846,4645,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006nn','SDSS J014541.02-010315.8',0.19686,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18820,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 16099','R',18820,40.08,0.19,868,4645,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006nn','SDSS J014541.02-010315.8',0.19686,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18821,'IRAS','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18821,35.07,0.8,103,4646,75,NULL,'W91PP, r','UGC 01233',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.00003,NULL,'14.58',0.7,'Scd:',NULL,NULL,NULL,NULL,1,26.422,28.80553,0.233,NULL,67729026627,1058266041,16535406,14.58),(18822,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18822,34.6,0.54,83.3,4646,NULL,NULL,'Malmquist cor.','UGC 01233',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18823,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18823,34.85,0.38,93.5,4646,75,NULL,'W91PP, r, raw','UGC 01233',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18824,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18824,35,0.38,100,4646,75,NULL,'W91PP, r, inv','UGC 01233',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18825,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18825,35.06,0.2,103,4646,74.4,NULL,NULL,'UGC 01233',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18826,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18826,35.1,0.38,105,4646,75,NULL,'W91PP, r, cor','UGC 01233',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18827,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18827,35.11,0.43,105,4646,NULL,NULL,NULL,'UGC 01233',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18828,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18828,34.96,0.54,98,4647,NULL,NULL,'Malmquist cor.','2MASX J01454214+0959495',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',NULL,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,26.425625,9.99714,0.157,NULL,67043704914,1047557889,16368092,14.3),(18829,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18829,35.12,0.2,106,4647,74.4,NULL,NULL,'2MASX J01454214+0959495',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18830,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18830,35.14,0.5,107,4647,NULL,NULL,NULL,'2MASX J01454214+0959495',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18831,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 11403','RN',18831,42.29,0.34,2070,4648,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 11403',0.388726,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18832,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 11403','RN',18832,42.66,0.43,2460,4648,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 11403',0.388726,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18833,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18833,37.13,0.23,267,4649,70,NULL,NULL,'2MASX J01454325+0052430',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,26.43025,0.87875,0.037,NULL,66982999803,1046609371,16353271,16.5),(18834,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18834,37.58,0.46,328,4650,70,NULL,NULL,'2MASX J01454344+1336244',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000073,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,26.431125,13.60678,0.137,NULL,66939558011,1045930593,16342665,18),(18835,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18835,36.22,0.6,175,4651,70,NULL,NULL,'2MASX J01454433-0650126',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.75',0.28,NULL,NULL,NULL,NULL,NULL,1,26.434875,-6.83678,0.029,NULL,34993668638,546776072,8543376,16.75),(18836,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 1992br',NULL,18836,37.5,0.19,291,4652,74.2,NULL,'SALT 2','2MASX J01454460-5605518',0.088,'2010ApJ...716..712A',2010,1,0.19,NULL,'G',0.002,NULL,'18.59',0.18,'E0',NULL,NULL,NULL,NULL,1,26.435833,-56.09769,0.009,NULL,36127467651,564491682,8820182,18.59),(18837,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 1992br',NULL,18837,37.54,0.22,295,4652,65,NULL,'MLCS17','2MASX J01454460-5605518',0.088,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18838,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 1992br',NULL,18838,37.75,0.26,326,4652,65,NULL,'MLCS31','2MASX J01454460-5605518',0.088,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18839,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 1992br',NULL,18839,37.76,0.21,328,4652,65,NULL,'MLCS2k2','2MASX J01454460-5605518',0.088,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18840,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 1992br',NULL,18840,37.98,0.19,333,4652,65,NULL,'MLCS2k2','2MASX J01454460-5605518',0.088,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18841,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 1992br',NULL,18841,37.82,0.16,337,4652,72,NULL,NULL,'2MASX J01454460-5605518',0.088,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18842,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 1992br',NULL,18842,37.86,0.39,343,4652,72,NULL,NULL,'2MASX J01454460-5605518',0.088,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18843,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 1992br',NULL,18843,38.07,0.28,378,4652,65,NULL,NULL,'2MASX J01454460-5605518',0.088,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18844,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 1992br',NULL,18844,38.09,0.36,381,4652,65,NULL,'Template','2MASX J01454460-5605518',0.088,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18845,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 1992br',NULL,18845,38.12,0.05,387,4652,70,NULL,NULL,'2MASX J01454460-5605518',0.088,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18846,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 1992br',NULL,18846,37.94,0.12,387,4652,70.8,NULL,NULL,'2MASX J01454460-5605518',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18847,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 1992br',NULL,18847,38.19,0.16,399,4652,70,NULL,'SALT','2MASX J01454460-5605518',0.088,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18848,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 1992br',NULL,18848,38.21,0.19,403,4652,65,NULL,'MLCS','2MASX J01454460-5605518',0.088,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18849,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 1992br',NULL,18849,38.28,0.21,415,4652,65,NULL,'SALT2','2MASX J01454460-5605518',0.088,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18850,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 1992br',NULL,18850,38.35,0.14,430,4652,65,NULL,'SALT','2MASX J01454460-5605518',0.088,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18851,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 1992br',NULL,18851,38.36,0.09,433,4652,65,NULL,'SALT','2MASX J01454460-5605518',0.088,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18852,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 1992br',NULL,18852,38.39,0.24,437,4652,70,NULL,'SALT 2','2MASX J01454460-5605518',0.088,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18853,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 1992br',NULL,18853,38.37,0.14,472,4652,60,NULL,NULL,'2MASX J01454460-5605518',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18854,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 1992br',NULL,18854,38.62,0.1,530,4652,60,NULL,'M(V) = -19.47 mag','2MASX J01454460-5605518',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18855,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 1992br',NULL,18855,38.63,0.17,532,4652,60,NULL,'M(B) = -19.48 mag','2MASX J01454460-5605518',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18856,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18856,37,0.64,251,4653,70,NULL,NULL,'2MASX J01454666-0944346',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.000091,NULL,'16.1g',0.42,NULL,NULL,NULL,NULL,NULL,1,26.4445,-9.74283,0.043,NULL,35100157700,548439964,8569374,16.1),(18857,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18857,34.65,0.56,85.1,4654,NULL,NULL,'Malmquist cor.','AGC 111639',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',NULL,NULL,'15.3I',0.1,NULL,NULL,NULL,NULL,NULL,1,26.457917,9.8625,0.145,NULL,67043683342,1047557552,16368086,15.3),(18858,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18858,34.81,0.2,91.6,4654,74.4,NULL,NULL,'AGC 111639',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18859,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18859,34.85,0.51,93.5,4654,NULL,NULL,NULL,'AGC 111639',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18860,'IRAS','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18860,34.45,0.8,77.5,4655,75,NULL,'W91PP, r','UGC 01234',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000009,NULL,'14.60',0.8,'SAB(s)c','Group member, peripheral',NULL,NULL,NULL,1,26.46575,35.11092,0.133,NULL,67765521415,1058836272,16544316,14.6),(18861,'IRAS','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18861,34.45,0.8,77.5,4655,75,NULL,'HMCL, I','UGC 01234',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18862,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18862,34.45,0.11,77.8,4655,NULL,NULL,NULL,'UGC 01234',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18863,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18863,34.46,0.38,77.8,4655,75,NULL,'W91PP, r, raw','UGC 01234',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18864,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18864,34.5,0.38,79.6,4655,75,NULL,'W91PP, r, inv','UGC 01234',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18865,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18865,34.52,0.38,80,4655,75,NULL,'W91PP, r, cor','UGC 01234',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18866,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18866,34.68,0.4,86.1,4655,75,NULL,'HMCL, I, raw','UGC 01234',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18867,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18867,34.74,0.4,88.9,4655,75,NULL,'HMCL, I, cor','UGC 01234',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18868,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18868,34.79,0.2,90.8,4655,74.4,NULL,NULL,'UGC 01234',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18869,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18869,34.8,0.4,91.2,4655,75,NULL,'HMCL, I, inv','UGC 01234',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18870,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18870,34.83,0.43,92.4,4655,75,NULL,'3.6 micron, color corrected','UGC 01234',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18871,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18871,34.93,0.43,97,4655,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01234',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18872,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18872,37.09,0.51,262,4656,70,NULL,NULL,'IC 0158',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.09',0.57,NULL,NULL,NULL,NULL,NULL,1,26.473,-6.93569,0.029,NULL,34986139002,546658421,8541537,16.09),(18873,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18873,36.62,0.46,211,4657,70,NULL,NULL,'2MASX J01455442+1442484',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000097,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,26.4768333333,14.71328,0.089,NULL,66940811076,1045950173,16342971,16.5),(18874,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18874,34.13,0.47,66.9,4658,NULL,NULL,'H','UGC 01237',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00002,NULL,'15.04',0.5,'Sab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,26.47875,9.82294,0.145,NULL,67043681452,1047557522,16368086,15.04),(18875,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18875,34.19,0.4,68.8,4658,NULL,NULL,'mean','UGC 01237',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18876,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18876,34.19,0.45,69,4658,NULL,NULL,'K','UGC 01237',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18877,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18877,34.2,0.38,69.3,4658,NULL,NULL,NULL,'UGC 01237',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18878,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18878,34.27,0.37,71.4,4658,NULL,NULL,'Malmquist cor.','UGC 01237',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18879,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18879,34.31,0.2,72.8,4658,74.4,NULL,NULL,'UGC 01237',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18880,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18880,34.31,0.46,72.8,4658,NULL,NULL,'J','UGC 01237',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18881,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 04705','RN',18881,42.59,0.27,2560,4659,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04705',0.288404,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18882,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 04705','RN',18882,43.12,0.28,3260,4659,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04705',0.288404,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18883,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 18451','R',18883,41.67,0.27,1560,4660,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2007mt','SN 2007mt',0.388,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia?',NULL,NULL,NULL,NULL,1,26.4857917,-0.21764,0.069,NULL,34973725252,546464457,8538507,NULL),(18884,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 18451','R',18884,41.69,0.22,1570,4660,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2007mt','SN 2007mt',0.388,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18885,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 2005jk',NULL,18885,39.05,0.12,557,4661,74.2,NULL,'SALT 2','SDSS J014559.73+011144.5',0.16,'2010ApJ...716..712A',2010,1,0.13,NULL,'G',NULL,NULL,'19.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,26.498917,1.19569,0.017,NULL,66982872695,1046607385,16353240,19.4),(18886,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 2005jk',NULL,18886,39.74,0.13,764,4661,70,NULL,'SALT 2','SDSS J014559.73+011144.5',0.16,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18887,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 2005jk',NULL,18887,39.75,NULL,769,4661,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 06304, SN 2005jk','SDSS J014559.73+011144.5',0.16,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18888,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 2005jk',NULL,18888,39.76,0.08,770,4661,65,NULL,'SALT2','SDSS J014559.73+011144.5',0.16,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18889,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 06304','R',18889,39.77,0.19,776,4661,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005jk','SDSS J014559.73+011144.5',0.16,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18890,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 2005jk',NULL,18890,39.9,0.09,825,4661,65,NULL,'MLCS2k2','SDSS J014559.73+011144.5',0.16,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18891,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 06304','R',18891,39.93,0.09,833,4661,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005jk','SDSS J014559.73+011144.5',0.16,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18892,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 2005jk',NULL,18892,39.61,0.07,836,4661,70,NULL,'SALT 2','SDSS J014559.73+011144.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18893,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 2005jk',NULL,18893,39.62,0.07,839,4661,70,NULL,'SALT 2, Malmquist cor.','SDSS J014559.73+011144.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18894,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 2005jk',NULL,18894,40.56,0.03,1120,4661,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 06304, SN 2005jk','SDSS J014559.73+011144.5',0.16,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18895,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18895,37.13,0.23,267,4662,70,NULL,NULL,'2MASX J01460205+0054380',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,26.5085416667,0.91047,0.037,NULL,66982990590,1046609227,16353269,17.8),(18896,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18896,36.83,0.46,232,4663,70,NULL,NULL,'2MASX J01460571-0853536',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000086,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,26.523833,-8.89814,0.05,NULL,34995393988,546803031,8543797,16.6),(18897,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 14093',NULL,18897,38.4,0.34,480,4664,70,NULL,'SN photometric redshift distance, z photo =0.119 +/- 0.022','SDSS-II SN 14093',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,26.5392083,-1.05636,0.033,NULL,34976073807,546501153,8539080,NULL),(18898,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 14093','R',18898,41.86,0.26,1620,4664,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14093',0.453804,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18899,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 14093',NULL,18899,41.77,0.16,2260,4664,70,NULL,'SALT 2','SDSS-II SN 14093',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18900,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 14093',NULL,18900,41.87,0.16,2370,4664,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14093',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18901,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 15006','RN',18901,42.03,0.42,1720,4665,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15006',0.47979,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18902,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 15006','N',18902,42.13,0.32,2670,4665,70,NULL,'SALT 2','SDSS-II SN 15006',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18903,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 15006','N',18903,42.25,0.32,2820,4665,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15006',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18904,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18904,37.6,0.27,331,4666,70,NULL,NULL,'2MASX J01461270-0038359',NULL,'2015arXiv151105856S',2015,1,0.42,'The APM image includes a neighboring star.','G',0.000086,NULL,'16.4g',0.34,'AGN',NULL,NULL,NULL,NULL,1,26.552917,-0.64336,0.041,NULL,34975987800,546499809,8539059,16.4),(18905,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18905,38.39,0.46,477,4667,70,NULL,NULL,'2MASX J01461947+1453380',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000084,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,26.581125,14.89403,0.089,NULL,66940621539,1045947211,16342925,18),(18906,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18906,31.86,0.43,23.5,4668,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01240',NULL,'2014MNRAS.444..527S',2014,1,1.1,'Host galaxy of UM 137.  UM 137 NED01 is the nucleus.','G',0.000013,NULL,'14.75',0.4,'Sdm:',NULL,NULL,NULL,NULL,1,26.585833,4.26417,0.065,NULL,67041172157,1047518314,16367473,14.75),(18907,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 15973','RN',18907,40.31,0.24,985,4669,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15973',0.168878,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18908,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 15973','RN',18908,40.68,0.31,1170,4669,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15973',0.168878,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18909,'SBF','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18909,33.6,0.25,52.5,4670,NULL,NULL,'HST, Jensen et al. 03','MC 0148-836',NULL,'2008ApJ...678..168B',2008,1,1.4,NULL,'G',NULL,NULL,'13.74',1.2,'SAB0-:','in a triple',NULL,NULL,NULL,1,26.591125,-83.39975,0.453,NULL,35477740227,554339691,8661557,13.74),(18910,'SBF','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18910,33.6,0.25,52.5,4670,NULL,NULL,'HST, Cantiello et al. 05','MC 0148-836',NULL,'2008ApJ...678..168B',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18911,'SBF','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18911,33.7,0.25,55,4670,NULL,NULL,'ACS','MC 0148-836',NULL,'2008ApJ...678..168B',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18912,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18912,34.26,0.4,71.1,4670,NULL,NULL,'mean','MC 0148-836',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18913,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18913,35.26,0.45,113,4670,NULL,NULL,'K','MC 0148-836',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18914,'IRAS','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18914,33.62,0.8,52.9,4671,75,NULL,'HMCL, I','NGC 0668',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000006,NULL,'13.74',1.2,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,26.5944583,36.46031,0.173,NULL,67735573466,1058368335,16537005,13.74),(18915,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18915,32.36,0.4,29.6,4671,75,NULL,'HMCL, I, raw','NGC 0668',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18916,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18916,32.43,0.4,30.6,4671,75,NULL,'HMCL, I, inv','NGC 0668',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18917,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18917,32.78,0.4,36,4671,75,NULL,'HMCL, I, cor','NGC 0668',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18918,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18918,32.83,0.69,36.8,4671,100,NULL,'mid-IR','NGC 0668',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18919,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18919,33.19,NULL,43.5,4671,NULL,NULL,'B','NGC 0668',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18920,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18920,33.65,NULL,53.7,4671,NULL,NULL,'I','NGC 0668',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18921,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18921,33.74,0.43,56,4671,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0668',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18922,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18922,33.76,0.43,56.5,4671,75,NULL,'3.6 micron, color corrected','NGC 0668',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18923,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18923,33.85,0.2,58.9,4671,74.4,NULL,NULL,'NGC 0668',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18924,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18924,33.86,0.47,59,4671,NULL,NULL,'H','NGC 0668',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18925,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18925,33.88,0.46,59.7,4671,NULL,NULL,'J','NGC 0668',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18926,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18926,33.88,0.45,59.7,4671,NULL,NULL,'K','NGC 0668',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18927,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18927,33.91,0.4,60.7,4671,NULL,NULL,'mean','NGC 0668',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18928,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18928,34.19,0.06,69,4671,NULL,NULL,NULL,'NGC 0668',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18929,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18929,36.41,0.98,191,4672,70,NULL,NULL,'2MASX J01462366-3525442',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.000103,NULL,'16.88',0.16,NULL,NULL,NULL,NULL,NULL,1,26.5987083,-35.42903,NULL,NULL,38296205324,598378208,9349659,16.88),(18930,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18930,37.13,0.23,267,4673,70,NULL,NULL,'2MASX J01462605+0048554',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000071,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,26.6085,0.81547,0.053,NULL,66982811489,1046606429,16353225,17.3),(18931,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18931,34.74,0.47,88.6,4674,70,NULL,NULL,'IC 0160',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00012,NULL,'14.65',0.8,'SAB0-:',NULL,NULL,NULL,NULL,1,26.623167,-13.24772,0,NULL,35078496732,548101511,8564086,14.65),(18932,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18932,37.13,0.23,267,4675,70,NULL,NULL,'2MASX J01462971+0057174',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000087,NULL,'16.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,26.6239166667,0.95469,0.053,NULL,66982800326,1046606255,16353222,16.4),(18933,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18933,36.1,0.46,166,4676,70,NULL,NULL,'2MASX J01462980+1357090',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000109,NULL,'15.4g',0.52,'E0',NULL,NULL,NULL,NULL,1,26.6242083,13.95264,0.097,NULL,66940125863,1045939466,16342804,15.4),(18934,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18934,37.64,0.46,338,4677,70,NULL,NULL,'2MASX J01463019+1306520',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000084,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,26.625833,13.11444,0.145,NULL,66939623123,1045931611,16342681,17.1),(18935,'Tully est','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18935,32.08,0.8,26.1,4678,75,NULL,NULL,'ESO 114- G 007',NULL,'1988NBGC.C....0000T',1988,1,1.8,NULL,'G',0.000013,NULL,'14.19',1.5,'SB(s)m','Pair member (points to parent)',NULL,NULL,NULL,1,26.624917,-58.67358,0,NULL,36150104097,564845376,8825709,14.19),(18936,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18936,37.95,0.46,388,4679,70,NULL,NULL,'2MASX J01463338+1341150',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000095,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,26.639167,13.68761,0.137,NULL,66940154456,1045939913,16342811,17.4),(18937,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18937,37.6,0.27,331,4680,70,NULL,NULL,'2MASX J01463477-0042089',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000092,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,26.6449583,-0.70258,0.037,NULL,34975946388,546499162,8539049,16.9),(18938,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18938,37.6,0.27,331,4681,70,NULL,NULL,'2MASX J01463524-0039499',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'17.68',0.23,NULL,NULL,NULL,NULL,NULL,1,26.6467916667,-0.66383,0.041,NULL,34975945734,546499152,8539049,17.68),(18939,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 06614','R',18939,39.54,0.14,693,4682,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 06614',0.169185,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,26.646917,0.86672,0.053,NULL,66982835005,1046606796,16353231,NULL),(18940,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 06614','R',18940,39.59,0.22,707,4682,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 06614',0.169185,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18941,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18941,36.68,0.21,217,4683,70,NULL,NULL,'2MASX J01463644-0941456',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000102,NULL,'15.7g',0.48,'S0^-',NULL,NULL,NULL,NULL,1,26.6518333333,-9.69589,0.046,NULL,35100244400,548441318,8569395,15.7),(18942,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18942,36.75,0.46,224,4684,70,NULL,NULL,'2MASX J01463715-0822106',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000109,NULL,'15.8g',0.46,'S0^-',NULL,NULL,NULL,NULL,1,26.654667,-8.36956,0.087,NULL,34995244666,546800697,8543760,15.8),(18943,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18943,36.68,0.21,217,4685,70,NULL,NULL,'2MASX J01464103-0939409',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000094,NULL,'15.8g',0.5,'E0',NULL,NULL,NULL,NULL,1,26.6709166667,-9.66136,0.046,NULL,35100236982,548441202,8569393,15.8),(18944,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18944,37.16,0.63,270,4685,70,NULL,NULL,'2MASX J01464103-0939409',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18945,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 00779','R',18945,40.3,0.21,928,4686,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J014641.70-010114.3',0.2377,'2014arXiv1401.3317S',2014,1,0.09,NULL,'G',0.0005,NULL,'20.1g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,26.67375,-1.02064,0.041,NULL,34975608052,546493875,8538966,20.1),(18946,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 00779','R',18946,40.39,0.13,965,4686,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J014641.70-010114.3',0.2377,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18947,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 00779',NULL,18947,40.17,0.1,1080,4686,70,NULL,'SALT 2','SDSS J014641.70-010114.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18948,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 00779',NULL,18948,40.19,0.1,1090,4686,70,NULL,'SALT 2, Malmquist cor.','SDSS J014641.70-010114.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18949,'TRGB','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18949,29.69,0.1,8.65,4687,74.4,NULL,NULL,'AGC 111946',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000003,NULL,'18.5',0.18,'Irr',NULL,NULL,NULL,NULL,1,26.675833,26.80139,0.261,NULL,67716120576,1058064384,16532256,18.5),(18950,'TRGB','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18950,29.78,0.06,9.02,4687,NULL,NULL,'I','AGC 111946',NULL,'2014ApJ...785....3M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18951,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18951,37.53,0.46,320,4688,70,NULL,NULL,'2MASX J01464297+1248222',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000083,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,26.679,12.80617,0.133,NULL,66926293732,1045723339,16339427,17.2),(18952,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 20596',NULL,18952,39.8,0.34,914,4689,70,NULL,'SN photometric redshift distance, z photo =0.242 +/- 0.048','SDSS-II SN 20596',NULL,'2011ApJ...738..162S',2011,1,0.13,NULL,'G',NULL,'PHOT','19.6g',0.08,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,26.6975833333,0.11758,0.029,NULL,66982263561,1046597868,16353091,19.6),(18953,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 20596','R',18953,40.25,0.16,924,4689,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20596',0.214973,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18954,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 20596','R',18954,40.76,0.3,1170,4689,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20596',0.214973,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18955,'IRAS','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18955,32.8,0.8,36.3,4690,75,NULL,'W91PP, r','UGC 01244',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000007,NULL,'15.20',0.6,'Sb','Isolated galaxy',NULL,NULL,NULL,1,26.706375,24.46525,0.349,NULL,67712869376,1058013584,16531462,15.2),(18956,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18956,33.28,0.2,45.3,4690,74.4,NULL,NULL,'UGC 01244',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18957,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18957,33.46,0.38,49.1,4690,75,NULL,'W91PP, r, inv','UGC 01244',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18958,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18958,33.55,0.38,51.3,4690,75,NULL,'W91PP, r, raw','UGC 01244',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18959,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18959,33.57,0.59,51.7,4690,NULL,NULL,NULL,'UGC 01244',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18960,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18960,33.86,0.38,59.2,4690,75,NULL,'W91PP, r, cor','UGC 01244',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18961,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18961,33.91,0.5,60.6,4690,NULL,NULL,'Malmquist cor.','UGC 01244',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18962,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18962,36.96,0.93,247,4691,70,NULL,NULL,'2MASX J01465035-1523324',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'16.72',0.29,NULL,NULL,NULL,NULL,NULL,1,26.70975,-15.39236,0,NULL,35070147065,547971047,8562047,16.72),(18963,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18963,37.66,0.46,340,4692,70,NULL,NULL,'2MASX J01465805+1348503',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000118,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,26.741875,13.814,0.141,NULL,66940133544,1045939586,16342806,17.1),(18964,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18964,37.17,0.62,271,4693,70,NULL,NULL,'2MASX J01465830-2412374',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.000103,NULL,'15.81',0.55,'S0',NULL,NULL,NULL,NULL,1,26.7429583333,-24.21039,0,NULL,38386282573,599785665,9371651,15.81),(18965,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18965,34.29,0.47,72,4694,NULL,NULL,'H','NGC 0671',NULL,'2007A&A...465...71T',2007,1,1.23,NULL,'G',0.00009,NULL,'14.2g',0.46,'S?             NLAGN','in a radial-velocity based grouping',NULL,NULL,'Sy 2',1,26.7465416667,13.12511,0.133,NULL,66939643735,1045931933,16342686,14.2),(18966,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18966,34.29,0.4,72,4694,NULL,NULL,'mean','NGC 0671',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18967,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18967,34.32,0.45,73.2,4694,NULL,NULL,'K','NGC 0671',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18968,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18968,34.33,0.46,73.5,4694,NULL,NULL,'J','NGC 0671',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18969,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18969,34.4,0.35,76,4694,NULL,NULL,'Malmquist cor.','NGC 0671',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18970,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18970,34.55,0.33,81.4,4694,NULL,NULL,NULL,'NGC 0671',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18971,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18971,34.58,0.2,82.4,4694,74.4,NULL,NULL,'NGC 0671',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18972,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 17945',NULL,18972,40.08,0.2,1040,4695,70,NULL,'SN photometric redshift distance, z photo =0.281 +/- 0.032','SDSS-II SN 17945',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','20.5g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,26.753167,-0.30178,0.057,NULL,34975810686,546497041,8539016,20.5),(18973,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 17945','R',18973,41.02,0.23,1200,4695,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17945',0.329549,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18974,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 17945','R',18974,41.28,0.32,1350,4695,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17945',0.329549,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18975,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 17945',NULL,18975,41.17,0.2,1710,4695,70,NULL,'SALT 2','SDSS-II SN 17945',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18976,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 17945',NULL,18976,41.21,0.2,1750,4695,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 17945',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18977,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18977,36.07,0.46,163,4696,70,NULL,NULL,'2MASX J01470081-0049376',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000078,NULL,'16.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,26.7534166667,-0.82708,0.033,NULL,34976053202,546500831,8539075,16.5),(18978,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18978,37.72,0.46,350,4697,70,NULL,NULL,'2MASX J01470110+1244293',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,26.7545,12.74142,0.133,NULL,66925435171,1045709924,16339217,17.6),(18979,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18979,36.68,0.21,217,4698,70,NULL,NULL,'SDSS J014701.08-093522.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000063,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,26.7545417,-9.58947,0.073,NULL,35100254578,548441477,8569398,17.4),(18980,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18980,37.47,0.21,311,4699,70,NULL,NULL,'2MASX J01470204+1256533',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000095,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,26.758625,12.94792,0.133,NULL,66939587740,1045931058,16342672,16.9),(18981,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 07845','RN',18981,40.1,0.35,967,4700,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07845',0.083116,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18982,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 07845','RN',18982,40.15,0.26,990,4700,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 07845',0.083116,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18983,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 2006fw',NULL,18983,37.69,0.06,345,4701,70,NULL,'Hubble residual 0.01 for z0.08350','APMUKS(BJ) B014436.69-002345.6',NULL,'2011ApJ...740...92G',2011,1,0.12,NULL,'G',0.0005,NULL,'19.77',0.11,NULL,NULL,NULL,NULL,NULL,1,26.7930417,-0.14686,0.057,NULL,34972429780,546444215,8538190,19.77),(18984,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 12898','R',18984,37.92,0.18,353,4701,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006fw','APMUKS(BJ) B014436.69-002345.6',0.0835,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18985,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 2006fw',NULL,18985,38.12,0.19,359,4701,72,NULL,NULL,'APMUKS(BJ) B014436.69-002345.6',0.08204,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18986,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 2006fw',NULL,18986,37.83,0.06,368,4701,70,NULL,'SALT 2','APMUKS(BJ) B014436.69-002345.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18987,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 2006fw',NULL,18987,37.83,0.06,368,4701,70,NULL,'SALT 2, Malmquist cor.','APMUKS(BJ) B014436.69-002345.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18988,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 12898','R',18988,38.14,0.06,392,4701,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006fw','APMUKS(BJ) B014436.69-002345.6',0.0835,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18989,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18989,37.57,0.61,326,4702,70,NULL,NULL,'2MASX J01471122-0351288',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00009,NULL,'16.84',0.2,NULL,NULL,NULL,NULL,NULL,1,26.796667,-3.85789,0.078,NULL,35030620821,547353450,8552397,16.84),(18990,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18990,36.55,0.78,204,4703,70,NULL,NULL,'2MASX J01471218-2348044',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.000103,NULL,'16.79',0.26,NULL,NULL,NULL,NULL,NULL,1,26.80075,-23.80131,0,NULL,35030857613,547357150,8552455,16.79),(18991,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18991,34.59,0.21,82.8,4704,NULL,NULL,'B, Hubble-type-TF','ESO 297- G 029',NULL,'2005Ap&SS.298..577R',2005,1,0.95,NULL,'G',0.000033,NULL,'15.15',0.49,'SAB:(s)bc',NULL,NULL,NULL,NULL,1,26.8047083333,-40.65806,NULL,NULL,38324884238,598826316,9356661,15.15),(18992,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18992,35.24,0.54,112,4704,NULL,NULL,'Malmquist cor.','ESO 297- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18993,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18993,35.38,0.5,119,4704,NULL,NULL,NULL,'ESO 297- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18994,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18994,35.42,0.2,121,4704,74.4,NULL,NULL,'ESO 297- G 029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18995,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18995,38.11,0.46,418,4705,70,NULL,NULL,'2MASX J01471375+1438599',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000087,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,26.807375,14.64981,0.065,NULL,66940728557,1045948883,16342951,18.1),(18996,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',18996,36.47,0.46,197,4706,70,NULL,NULL,'2MASX J01471573+0057478',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000108,NULL,'15.7g',0.49,'E0',NULL,NULL,NULL,NULL,1,26.815625,0.96336,0.021,NULL,66982702526,1046604726,16353198,15.7),(18997,'IRAS','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18997,33.74,0.8,55.9,4707,75,NULL,'W91PP, r','NGC 0669',NULL,'1997ApJS..109..333W',1997,1,3.2,NULL,'G',0.000017,NULL,'13.36',0.6,'Sab            LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,26.8172916667,35.56331,0.133,NULL,67735118732,1058361230,16536894,13.36),(18998,'IRAS','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18998,33.77,0.8,56.7,4707,75,NULL,'HMCL, I','NGC 0669',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18999,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,18999,34.01,0.4,63.3,4707,NULL,NULL,'mean','NGC 0669',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19000,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19000,34.2,0.47,69.3,4707,NULL,NULL,'H','NGC 0669',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19001,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19001,34.21,0.46,69.4,4707,NULL,NULL,'J','NGC 0669',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19002,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19002,34.29,0.45,72,4707,NULL,NULL,'K','NGC 0669',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19003,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',19003,34.31,0.49,72.7,4707,75,NULL,'IR','NGC 0669',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19004,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19004,34.39,0.38,75.6,4707,75,NULL,'W91PP, r, raw','NGC 0669',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19005,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19005,34.45,0.11,77.8,4707,NULL,NULL,NULL,'NGC 0669',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19006,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19006,34.46,0.38,78.1,4707,75,NULL,'W91PP, r, cor','NGC 0669',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19007,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19007,34.79,0.38,90.8,4707,75,NULL,'W91PP, r, inv','NGC 0669',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19008,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19008,34.9,0.4,95.5,4707,75,NULL,'HMCL, I, raw','NGC 0669',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19009,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19009,35.02,0.4,101,4707,75,NULL,'HMCL, I, cor','NGC 0669',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19010,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19010,35.27,0.4,113,4707,75,NULL,'HMCL, I, inv','NGC 0669',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19011,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19011,37.1,0.66,263,4708,70,NULL,NULL,'2MASX J01471623-1512411',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'16.46',0.34,'poss. LINER',NULL,NULL,NULL,NULL,1,26.81775,-15.21147,0,NULL,35070101545,547970336,8562036,16.46),(19012,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19012,35.7,0.71,138,4709,70,NULL,NULL,'MCG -02-05-048',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000127,NULL,'15.02',0.7,NULL,NULL,NULL,NULL,NULL,1,26.8260417,-14.04542,0,NULL,35081131331,548142677,8564729,15.02),(19013,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 04706','RN',19013,42.81,0.21,2290,4710,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 04706',0.591266,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19014,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19014,36.36,0.54,187,4711,70,NULL,NULL,'2MASX J01472384-5426408',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.25',0.42,'S0',NULL,NULL,NULL,NULL,1,26.84925,-54.44475,0,NULL,36131054672,564547729,8821058,16.25),(19015,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',19015,37.01,0.46,253,4712,70,NULL,NULL,'2MASX J01472453+1335499',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000075,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,26.85225,13.59725,0.145,NULL,66939651422,1045932053,16342688,16.8),(19016,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19016,32.54,0.45,32.2,4713,NULL,NULL,'K','NGC 0670',NULL,'2007A&A...465...71T',2007,1,2,NULL,'G',0.000008,NULL,'13.59',1,'SA0','in a radial-velocity based grouping',NULL,NULL,NULL,1,26.8535417,27.88575,0.197,NULL,67728173975,1058252718,16535198,13.59),(19017,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19017,33.37,0.4,47.2,4713,NULL,NULL,'mean','NGC 0670',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19018,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 13919','RN',19018,42.05,0.18,1840,4714,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13919',0.400187,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19019,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 13919','RN',19019,42.3,0.12,2060,4714,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13919',0.400187,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19020,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',19020,35.72,0.46,139,4715,70,NULL,NULL,'2MASX J01472820-0045028',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000093,NULL,'15.3g',0.52,'S0',NULL,NULL,NULL,NULL,1,26.867375,-0.75089,0.033,NULL,34972893578,546451462,8538304,15.3),(19021,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',19021,37.47,0.21,311,4716,70,NULL,NULL,'2MASX J01472872+1255139',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000091,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,26.8696666667,12.92061,0.125,NULL,66939861273,1045935332,16342739,17),(19022,'Brightest Stars','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19022,29.29,NULL,7.2,4717,NULL,NULL,NULL,'IC 1727',NULL,'2004AJ....127.2031K',2004,1,6.9,NULL,'G',0.000003,NULL,'12.07',3.1,'SB(s)m        LINER2','Possible pair member',NULL,NULL,NULL,1,26.8745417,27.33336,0.249,NULL,67714319260,1058036238,16531816,12.07),(19023,'TRGB','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',19023,29.27,0.03,7.14,4717,NULL,NULL,NULL,'IC 1727',NULL,'2014AstL...40...11T',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19024,'TRGB','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19024,29.36,0.1,7.45,4717,74.4,NULL,NULL,'IC 1727',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19025,'Tully est','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19025,29.04,0.8,6.4,4717,75,NULL,'B','IC 1727',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19026,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19026,29.18,0.36,6.85,4717,NULL,NULL,NULL,'IC 1727',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19027,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19027,29.19,0.4,6.9,4717,73,NULL,'opt','IC 1727',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19028,'IRAS','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19028,33.88,0.8,59.8,4718,75,NULL,'HMCL, I','UGC 01251',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000027,NULL,'14.94',0.5,'Irr','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,26.875667,36.03492,0.173,NULL,67735852147,1058372689,16537073,14.94),(19029,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19029,34.08,0.4,65.3,4718,75,NULL,'HMCL, I, raw','UGC 01251',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19030,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19030,34.1,0.4,66,4718,NULL,NULL,'mean','UGC 01251',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19031,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19031,34.2,0.4,69.2,4718,75,NULL,'HMCL, I, inv','UGC 01251',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19032,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19032,34.25,0.4,70.9,4718,75,NULL,'HMCL, I, cor','UGC 01251',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19033,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19033,34.44,0.47,77.3,4718,NULL,NULL,'H','UGC 01251',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19034,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',19034,38.18,0.46,432,4719,70,NULL,NULL,'2MASX J01473019-0010588',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000078,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,26.8759166667,-0.183,0.057,NULL,34972420403,546444068,8538188,18.4),(19035,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',19035,37.86,0.33,373,4720,70,NULL,NULL,'2MASX J01473462+1406539',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00007,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,26.89425,14.11489,0.129,NULL,66940871843,1045951122,16342986,17.7),(19036,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',19036,37.86,0.33,373,4721,70,NULL,NULL,'2MASX J01473537+1403449',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000091,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,26.897417,14.06247,0.129,NULL,66941044120,1045953814,16343028,17.1),(19037,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19037,34.86,0.62,93.9,4722,NULL,NULL,'Malmquist cor.','AGC 111642',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',NULL,NULL,'15.9I',0.1,NULL,NULL,NULL,NULL,NULL,1,26.898333,11.46889,0.121,NULL,67044746413,1047574162,16368346,15.9),(19038,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19038,34.91,0.61,95.8,4722,NULL,NULL,NULL,'AGC 111642',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19039,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 14938',NULL,19039,38.09,2.61,415,4723,70,NULL,'SN photometric redshift distance, z photo =0.102 +/- 0.294','SDSS-II SN 14938',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','19.9g',0.07,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,26.9057083,0.4995,0.053,NULL,66979561035,1046555641,16352431,19.9),(19040,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 14938','R',19040,39.53,0.24,678,4723,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14938',0.184998,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19041,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 14938','R',19041,40.24,0.31,943,4723,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 14938',0.184998,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19042,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',19042,37.97,0.46,393,4724,70,NULL,NULL,'SDSS J014737.50+124641.5',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000094,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,26.90625,12.77822,0.125,NULL,66939131198,1045923924,16342561,17.6),(19043,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 18096','RN',19043,40.93,0.25,1330,4725,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18096',0.158255,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19044,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 18096','RN',19044,41.57,0.29,1780,4725,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18096',0.158255,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19045,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',19045,37.47,0.21,311,4726,70,NULL,NULL,'2MASX J01474136+1258106',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00009,NULL,'16.6g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,26.9222917,12.96961,0.125,NULL,66939908385,1045936068,16342751,16.6),(19046,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',19046,36.68,0.21,217,4727,70,NULL,NULL,'2MASX J01474145-0938198',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000081,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,26.9227917,-9.63886,0.073,NULL,35111641141,548619392,8572178,17),(19047,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 11404','RN',19047,40.42,0.24,1010,4728,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 11404',0.195421,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19048,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 2005lp',NULL,19048,40.77,0.25,1090,4729,74.2,NULL,'SALT 2','SDSS J014742.71+001226.2',0.303,'2010ApJ...716..712A',2010,1,0.06,NULL,'G',NULL,NULL,'22.4g',0.02,NULL,NULL,NULL,NULL,NULL,1,26.9279583,0.20731,0.057,NULL,66979582024,1046555969,16352437,22.4),(19049,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 2005lp',NULL,19049,41.3,NULL,1400,4729,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 11864, SN 2005lp','SDSS J014742.71+001226.2',0.303,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19050,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SN 2005lp',NULL,19050,41.71,0.08,1690,4729,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 11864, SN 2005lp','SDSS J014742.71+001226.2',0.303,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19051,'Tully est','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19051,30.92,0.8,15.2,4730,75,NULL,'B','NGC 0685',NULL,'1988NBGC.C....0000T',1988,1,3.7,NULL,'G',0.00001,NULL,'11.5',3.3,'SB(rs)d',NULL,NULL,NULL,NULL,1,26.928375,-52.76181,NULL,NULL,38224984863,597265388,9332271,11.5),(19052,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',19052,37.47,0.21,311,4731,70,NULL,NULL,'2MASX J01474354+1259366',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00007,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,26.9313333333,12.99342,0.125,NULL,66939912008,1045936125,16342751,18.1),(19053,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19053,34.9,0.47,95.4,4732,NULL,NULL,'H','IC 1728',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000033,NULL,'13.81',0.9,'SAB(s)bc',NULL,NULL,NULL,NULL,1,26.935375,-33.6015,NULL,NULL,38309282705,598582542,9352852,13.81),(19054,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19054,34.97,0.45,98.7,4732,NULL,NULL,'K','IC 1728',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19055,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19055,35.01,0.46,100,4732,NULL,NULL,'J','IC 1728',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19056,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19056,35.05,0.64,102,4732,NULL,NULL,'Malmquist cor.','IC 1728',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19057,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19057,35.21,0.4,110,4732,NULL,NULL,'mean','IC 1728',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19058,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19058,35.3,0.57,115,4732,NULL,NULL,NULL,'IC 1728',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19059,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19059,35.34,0.2,117,4732,74.4,NULL,NULL,'IC 1728',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19060,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',19060,37.78,0.46,359,4733,70,NULL,NULL,'2MASX J01474335+1415526',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000083,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,26.9356666667,14.26922,0.129,NULL,66940884195,1045951315,16342989,17.9),(19061,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 17953','RN',19061,38.77,0.11,526,4734,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 17953',0.078952,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19062,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 17953','RN',19062,39.2,0.33,642,4734,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 17953',0.078952,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19063,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19063,35.45,0.47,123,4735,70,NULL,NULL,'MCG -04-05-007 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'13.8R',NULL,'Part of dumbbell sys',NULL,NULL,NULL,NULL,1,26.939,-21.83339,0,NULL,35033580445,547399694,8553120,13.8),(19064,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19064,34.67,1.04,86.1,4736,NULL,NULL,'Malmquist cor.','NGC 0690',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.12',0.8,'SAB(s)c:',NULL,NULL,NULL,NULL,1,26.9503333333,-16.722,0,NULL,35088804403,548262568,8566602,15.12),(19065,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19065,34.86,0.95,93.8,4736,NULL,NULL,NULL,'NGC 0690',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19066,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19066,34.9,0.2,95.5,4736,74.4,NULL,NULL,'NGC 0690',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19067,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19067,36.31,0.78,182,4737,70,NULL,NULL,'2MASX J01475003-0514262',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.00015,NULL,'17.12',0.17,NULL,NULL,NULL,NULL,NULL,1,26.9585,-5.24069,0.036,NULL,35016739539,547136555,8549008,17.12),(19068,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 03317',NULL,19068,39.3,0.12,624,4738,70,NULL,'SALT 2','SDSS J014751.04+003825.6',0.161,'2013MNRAS.433.2240G',2013,1,0.1,NULL,'G',NULL,NULL,'20.0g',0.08,NULL,NULL,NULL,NULL,NULL,1,26.962667,0.64047,0.053,NULL,66979634381,1046556787,16352449,20),(19069,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 03317','R',19069,39.31,0.18,627,4738,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005gd','SDSS J014751.04+003825.6',0.161011,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19070,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 03317','R',19070,39.47,0.1,676,4738,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005gd','SDSS J014751.04+003825.6',0.161011,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19071,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 03317',NULL,19071,39.16,0.07,679,4738,70,NULL,'SALT 2','SDSS J014751.04+003825.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19072,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 03317',NULL,19072,39.17,0.07,682,4738,70,NULL,'SALT 2, Malmquist cor.','SDSS J014751.04+003825.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19073,'Brightest Stars','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19073,29.29,NULL,7.2,4739,NULL,NULL,NULL,'NGC 0672',NULL,'2004AJ....127.2031K',2004,1,7.2,NULL,'G',0.000003,NULL,'11.47',2.6,'SB(s)cd        HII','Possible pair member',NULL,NULL,NULL,1,26.9771666667,27.43278,0.241,NULL,67714840091,1058044376,16531943,11.47),(19074,'Brightest Stars','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19074,29.5,0.25,7.9,4739,NULL,NULL,'Red Super Giants','NGC 0672',NULL,'1996AJ....112.2559S',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19075,'TRGB','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19075,29.28,0.1,7.18,4739,74.4,NULL,NULL,'NGC 0672',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19076,'TRGB','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',19076,29.29,0.03,7.22,4739,NULL,NULL,NULL,'NGC 0672',NULL,'2014AstL...40...11T',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19077,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19077,29.35,0.4,7.4,4739,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 3 galaxy group','NGC 0672',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19078,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19078,29.38,0.4,7.5,4739,75,NULL,'B','NGC 0672',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19079,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19079,30,0.36,10,4739,NULL,NULL,NULL,'NGC 0672',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19080,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19080,30,0.4,10,4739,73,NULL,'opt','NGC 0672',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19081,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',19081,37.47,0.21,311,4740,70,NULL,NULL,'2MASX J01475572+1300557',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000084,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,26.982167,13.01553,0.125,NULL,66939898170,1045935908,16342748,17),(19082,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',19082,37.71,0.46,348,4741,70,NULL,NULL,'2MASX J01475683+0038256',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.79',0.26,NULL,NULL,NULL,NULL,NULL,1,26.98675,0.64039,0.053,NULL,66979633126,1046556767,16352449,17.79),(19083,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19083,36.87,0.66,236,4742,70,NULL,NULL,'2MASX J01475731-1542468',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,26.98875,-15.71303,0,NULL,35070653322,547978958,8562171,15.5),(19084,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',19084,37.95,0.46,389,4743,70,NULL,NULL,'2MASX J01480041-0825317',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000079,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,27.001625,-8.42542,0.107,NULL,34986999717,546671870,8541747,17.9),(19085,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 06121',NULL,19085,39.61,1.06,834,4744,70,NULL,'SN photometric redshift distance, z photo =0.218 +/- 0.171','SDSS-II SN 06121',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','22.8g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,27.002375,0.30433,0.061,NULL,66979621791,1046556590,16352446,22.8),(19086,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 06121','R',19086,41.18,0.33,1270,4744,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06121',0.356765,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19087,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 06121','R',19087,41.19,0.27,1270,4744,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06121',0.356765,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19088,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 06121',NULL,19088,41,0.21,1580,4744,70,NULL,'SALT 2','SDSS-II SN 06121',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19089,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:50','1','SDSS-II SN 06121',NULL,19089,41.05,0.21,1620,4744,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 06121',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19090,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',19090,37.65,0.46,340,4745,70,NULL,NULL,'SDSS J014800.76-093828.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000076,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,27.0032083,-9.64111,0.073,NULL,35111643199,548619424,8572178,18.4),(19091,'FP','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,'R',19091,37.7,0.33,346,4746,70,NULL,NULL,'2MASX J01480645-0114332',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.33',0.19,NULL,NULL,NULL,NULL,NULL,1,27.0269583,-1.24247,0.049,NULL,34972695324,546448364,8538255,18.33),(19092,'IRAS','2016-12-15 15:13:48','2016-12-16 11:18:50','1',NULL,NULL,19092,33.73,0.8,55.8,4747,75,NULL,'W91PP, r','UGC 01257',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000009,NULL,'14.87',0.5,'Sab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,27.0294583333,36.45325,0.157,NULL,67735217537,1058362774,16536918,14.87),(19093,'IRAS','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19093,33.74,0.8,55.9,4747,75,NULL,'HMCL, I','UGC 01257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19094,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19094,34.17,0.07,68.4,4747,NULL,NULL,NULL,'UGC 01257',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19095,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19095,34.34,NULL,73.8,4747,NULL,NULL,'B','UGC 01257',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19096,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19096,34.46,NULL,78,4747,NULL,NULL,'I','UGC 01257',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19097,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19097,34.49,0.4,79,4747,75,NULL,'HMCL, I, raw','UGC 01257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19098,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19098,34.56,0.4,81.5,4747,75,NULL,'HMCL, I, cor','UGC 01257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19099,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19099,34.57,0.2,82,4747,74.4,NULL,NULL,'UGC 01257',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19100,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19100,34.58,0.43,82.6,4747,75,NULL,'3.6 micron, color corrected','UGC 01257',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19101,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19101,34.63,0.38,84.4,4747,75,NULL,'W91PP, r, raw','UGC 01257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19102,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19102,34.64,0.4,84.7,4747,75,NULL,'HMCL, I, inv','UGC 01257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19103,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19103,34.67,0.38,86.1,4747,75,NULL,'W91PP, r, cor','UGC 01257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19104,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19104,34.68,0.43,86.3,4747,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01257',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19105,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19105,34.76,0.38,89.6,4747,75,NULL,'W91PP, r, inv','UGC 01257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19106,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 14389','R',19106,40.34,0.26,947,4748,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14389',0.232806,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,27.038625,0.29608,0.061,NULL,66979573923,1046555842,16352435,NULL),(19107,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 14389','R',19107,40.35,0.21,955,4748,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14389',0.232806,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19108,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19108,38.46,0.46,492,4749,70,NULL,NULL,'SDSS J014809.85+141548.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000077,NULL,'18.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,27.0410833333,14.26358,0.129,NULL,66940377278,1045943394,16342865,18.4),(19109,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19109,37.7,0.33,346,4750,70,NULL,NULL,'2MASX J01481409-0110090',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'17.80',0.23,NULL,NULL,NULL,NULL,NULL,1,27.058625,-1.16922,0.041,NULL,34972680653,546448135,8538252,17.8),(19110,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 12227','RN',19110,40,0.28,922,4751,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 12227',0.085531,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19111,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 12227','RN',19111,40.36,0.19,1090,4751,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 12227',0.085531,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19112,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19112,37.89,0.46,379,4752,70,NULL,NULL,'2MASX J01481417+0107469',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000098,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,27.059125,1.12967,0.029,NULL,66979340367,1046552193,16352378,16.9),(19113,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19113,35.94,0.6,154,4753,NULL,NULL,NULL,'KUG 0145+321',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.00005,NULL,'17:',0.2,'Sc',NULL,NULL,NULL,NULL,1,27.0662083333,32.36006,0.109,NULL,67775640361,1058994380,16546787,17),(19114,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19114,35.98,0.59,157,4753,NULL,NULL,'Malmquist cor.','KUG 0145+321',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19115,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19115,35.98,0.2,157,4753,74.4,NULL,NULL,'KUG 0145+321',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19116,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 19175',NULL,19116,40.3,0.28,1150,4754,70,NULL,'SN photometric redshift distance, z photo =0.317 +/- 0.054','SDSS-II SN 19175',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,27.078917,0.89953,0.033,NULL,66979189253,1046549832,16352341,NULL),(19117,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19117,37.6,0.46,330,4755,70,NULL,NULL,'2MASX J01482236-0048160',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000098,NULL,'16.8g',0.27,'AGN',NULL,NULL,NULL,NULL,1,27.0930417,-0.80433,0.041,NULL,34972810316,546450161,8538283,16.8),(19118,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SN 1996bo',NULL,19118,33.27,0.21,44.3,4756,74.2,NULL,'SALT 2','NGC 0673',0.01728,'2010ApJ...716..712A',2010,1,2.1,NULL,'G',0.000017,NULL,'13.20',1.7,'SAB(s)c','in a radial-velocity based grouping',NULL,NULL,NULL,1,27.0935,11.52131,0.145,NULL,67044709264,1047573582,16368337,13.2),(19119,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SN 1996bo',NULL,19119,33.82,0.27,57.1,4756,65,NULL,NULL,'NGC 0673',0.01728,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19120,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SN 1996bo',NULL,19120,33.84,0.08,58.6,4756,74.4,NULL,NULL,'NGC 0673',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19121,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SN 1996bo',NULL,19121,33.9,0.19,59.2,4756,72,NULL,NULL,'NGC 0673',0.01728,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19122,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SN 1996bo',NULL,19122,33.98,0.13,61.5,4756,65,NULL,'MLCS2k2','NGC 0673',0.01728,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19123,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SN 1996bo',NULL,19123,34,0.22,62.1,4756,65,NULL,'MLCS31','NGC 0673',0.01728,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19124,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SN 1996bo',NULL,19124,34.04,0.14,62.2,4756,65,NULL,'MLCS2k2','NGC 0673',0.01728,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19125,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SN 1996bo',NULL,19125,34.03,0.07,62.8,4756,72,NULL,NULL,'NGC 0673',0.01728,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19126,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SN 1996bo',NULL,19126,34.11,0.21,65.2,4756,70,NULL,'SALT','NGC 0673',0.01728,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19127,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SN 1996bo',NULL,19127,34.17,0.26,66.9,4756,65,NULL,'SALT','NGC 0673',0.01728,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19128,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SN 1996bo',NULL,19128,34.18,0.24,67.4,4756,65,NULL,'SALT2','NGC 0673',0.01728,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19129,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SN 1996bo',NULL,19129,34.3,0.21,71.3,4756,65,NULL,'MLCS17','NGC 0673',0.01728,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19130,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SN 1996bo',NULL,19130,34.31,0.14,72.8,4756,60,NULL,NULL,'NGC 0673',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19131,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SN 1996bo',NULL,19131,34.41,0.13,74.7,4756,70,NULL,NULL,'NGC 0673',0.01728,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19132,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SN 1996bo',NULL,19132,34.61,0.01,82.2,4756,65,NULL,'SALT','NGC 0673',0.01728,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19133,'IRAS','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19133,34.16,0.8,67.9,4756,75,NULL,'A82, H','NGC 0673',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19134,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19134,33.67,0.33,54.3,4756,91,NULL,'H','NGC 0673',NULL,'1984ApJ...278..475B',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19135,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19135,33.77,0.77,56.8,4756,NULL,NULL,'Malmquist cor.','NGC 0673',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19136,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19136,33.83,0.43,58.4,4756,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0673',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19137,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19137,33.84,0.08,58.6,4756,74.4,NULL,NULL,'NGC 0673',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19138,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19138,33.85,0.43,59,4756,75,NULL,'3.6 micron, color corrected','NGC 0673',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19139,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19139,33.94,0.42,61.4,4756,NULL,18.48,'3.6 micron','NGC 0673',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19140,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19140,33.96,0.45,62.1,4756,NULL,NULL,'K','NGC 0673',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19141,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19141,33.97,0.47,62.3,4756,NULL,NULL,'H','NGC 0673',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19142,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19142,33.98,0.7,62.6,4756,NULL,NULL,NULL,'NGC 0673',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19143,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19143,33.99,0.4,62.8,4756,75,NULL,'HOSTS SN 1996bo','NGC 0673',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19144,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19144,34.04,0.46,64.3,4756,NULL,NULL,'J','NGC 0673',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19145,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19145,34.17,0.4,68.3,4756,NULL,NULL,'mean','NGC 0673',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19146,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19146,34.23,0.47,70.3,4756,75,NULL,'A82, H, raw','NGC 0673',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19147,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19147,34.44,0.47,77.4,4756,75,NULL,'A82, H, cor','NGC 0673',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19148,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19148,34.45,0.47,77.5,4756,75,NULL,'A82, H, inv','NGC 0673',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19149,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19149,34.45,NULL,77.8,4757,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0194',NULL,'2010Ap&SS.325..163P',2010,1,0.91,NULL,'G',0.000012,NULL,'16.47',0.09,'Sd',NULL,NULL,NULL,NULL,1,27.093375,33.845,0.129,NULL,67773653055,1058963328,16546302,16.47),(19150,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19150,34.47,NULL,78.4,4757,NULL,NULL,'Dipole + Quadrupole','FGC 0194',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19151,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19151,34.49,NULL,79,4757,NULL,NULL,'Dipole','FGC 0194',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19152,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19152,34.5,0.12,79.6,4757,NULL,NULL,NULL,'FGC 0194',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19153,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19153,34.55,0.2,81.3,4757,74.4,NULL,NULL,'FGC 0194',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19154,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19154,34.62,0.43,84.1,4757,75,NULL,'3.6 micron, color corrected','FGC 0194',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19155,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19155,34.63,0.43,84.2,4757,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0194',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19156,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 17849','RN',19156,41.14,0.29,1250,4758,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17849',0.353462,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19157,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 17849','RN',19157,41.16,0.31,1260,4758,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17849',0.353462,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19158,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 17849','N',19158,41.01,0.22,1590,4758,70,NULL,'SALT 2','SDSS-II SN 17849',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19159,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 17849','N',19159,41.06,0.22,1630,4758,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 17849',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19160,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19160,31.48,0.4,19.8,4759,75,NULL,'B','ARP 004',NULL,'1988NBGC.C....0000T',1988,1,2.8,NULL,'G',0.00001,NULL,'13.71',2.3,'IAB(rs)m','X-ray-bright group member',NULL,NULL,NULL,1,27.107,-12.38203,0,NULL,35066527354,547914489,8561163,13.71),(19161,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19161,37.52,0.46,319,4760,70,NULL,NULL,'2MASX J01482736-0810409',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000082,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,27.1139583,-8.17803,0.107,NULL,34987776616,546684009,8541937,17.4),(19162,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19162,37.42,0.46,305,4761,70,NULL,NULL,'2MASX J01483255-0822269',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000081,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,27.13575,-8.37422,0.107,NULL,34986881453,546670022,8541719,17),(19163,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19163,33.86,0.2,59.2,4762,74.4,NULL,NULL,'UGC 01261',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000027,NULL,'15.21',0.3,'Scd(f)','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,27.1394583333,13.43072,0.141,NULL,66939349953,1045927343,16342614,15.21),(19164,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19164,33.94,0.46,61.3,4762,NULL,NULL,NULL,'UGC 01261',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19165,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19165,34.01,0.44,63.3,4762,NULL,NULL,'Malmquist cor.','UGC 01261',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19166,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19166,34.03,0.49,63.9,4762,75,NULL,'IR','UGC 01261',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19167,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19167,34.07,0.2,65.2,4763,74.4,NULL,NULL,'UGC 01262',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.00002,NULL,'16.0',0.7,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,27.1432917,13.70142,0.133,NULL,66940466128,1045944783,16342887,16),(19168,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19168,37.62,0.46,335,4764,70,NULL,NULL,'SDSS J014834.42-005833.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000066,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,27.1434166667,-0.97586,0.041,NULL,34972882397,546451287,8538301,18.6),(19169,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 13370','R',19169,40.54,0.28,1070,4765,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006gv','SN 2006gv',0.199,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,27.1515417,0.32822,0.073,NULL,66979450231,1046553909,16352404,NULL),(19170,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 13370','R',19170,40.64,0.17,1120,4765,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006gv','SN 2006gv',0.199,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19171,'IRAS','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19171,34.55,0.8,81.2,4766,75,NULL,'MAT, I','ESO 197- G 002',NULL,'1997ApJS..109..333W',1997,1,1.56,NULL,'G',0.000033,NULL,'15.10',0.29,'SB(s)cd? sp    LINER',NULL,NULL,NULL,NULL,1,27.156,-48.82111,NULL,NULL,38230118172,597345596,9333524,15.1),(19172,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19172,34.17,0.43,68.4,4766,75,NULL,'MAT, I, raw','ESO 197- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19173,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19173,34.21,0.32,69.4,4766,85,NULL,'I, raw','ESO 197- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19174,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19174,34.25,0.32,70.9,4766,85,NULL,'I, inv','ESO 197- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19175,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19175,34.27,0.49,71.5,4766,75,NULL,'IR','ESO 197- G 002',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19176,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19176,34.38,0.43,75.2,4766,75,NULL,'MAT, I, inv','ESO 197- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19177,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19177,34.42,0.35,76.6,4766,NULL,NULL,NULL,'ESO 197- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19178,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19178,34.46,0.2,78,4766,74.4,NULL,NULL,'ESO 197- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19179,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19179,34.57,0.43,81.9,4766,75,NULL,'MAT, I, cor','ESO 197- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19180,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19180,34.61,0.32,83.5,4766,NULL,NULL,'Malmquist cor.','ESO 197- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19181,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19181,34.73,0.4,88.2,4766,NULL,NULL,'mean','ESO 197- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19182,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19182,34.73,0.47,88.3,4766,NULL,NULL,'H','ESO 197- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19183,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19183,34.91,0.45,95.8,4766,NULL,NULL,'K','ESO 197- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19184,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19184,34.33,0.45,73.4,4767,NULL,NULL,'Malmquist cor.','UGC 01264',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',NULL,NULL,'16.0',0.3,'Scd(f)',NULL,NULL,NULL,NULL,1,27.1577083,13.76889,0.133,NULL,66940460514,1045944695,16342885,16),(19185,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19185,34.34,0.2,73.8,4767,74.4,NULL,NULL,'UGC 01264',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19186,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19186,34.43,0.43,76.7,4767,NULL,NULL,NULL,'UGC 01264',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19187,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19187,34.64,0.49,84.7,4767,75,NULL,'IR','UGC 01264',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19188,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SN 2006ls',NULL,19188,38.64,0.05,535,4768,70,NULL,'Hubble residual -0.19 for z0.14740','APMUKS(BJ) B014607.31-004928.2',NULL,'2011ApJ...740...92G',2011,1,0.24,NULL,'G',0.0005,NULL,'19.70',0.09,NULL,NULL,NULL,NULL,NULL,1,27.1694583333,-0.57575,0.037,NULL,34973130999,546455171,8538362,19.7),(19189,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 15508','R',19189,39.03,0.18,557,4768,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ls','APMUKS(BJ) B014607.31-004928.2',0.1474,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19190,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SN 2006ls',NULL,19190,38.93,0.06,611,4768,70,NULL,'SALT 2','APMUKS(BJ) B014607.31-004928.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19191,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 15508','R',19191,39.24,0.08,613,4768,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ls','APMUKS(BJ) B014607.31-004928.2',0.1474,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19192,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SN 2006ls',NULL,19192,38.94,0.06,614,4768,70,NULL,'SALT 2, Malmquist cor.','APMUKS(BJ) B014607.31-004928.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19193,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19193,37.5,0.46,316,4769,70,NULL,NULL,'SDSS J014844.19-084644.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000064,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,27.184125,-8.77917,0.084,NULL,35107598958,548556233,8571191,18.6),(19194,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19194,36.89,0.46,238,4770,70,NULL,NULL,'2MASX J01484616+0105217',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000073,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,27.1925,1.08931,0.033,NULL,66979330608,1046552040,16352375,17),(19195,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19195,34.7,0.69,87.1,4771,100,NULL,'mid-IR','UGC 01265 NED01',NULL,'2013ApJ...771...88L',2013,1,0.9,'Component \'a)\' in UGC notes.','G',0.000097,NULL,'14.5',0.6,'SB?','Pair member (points to parent)',NULL,NULL,NULL,1,27.1938333333,20.26519,0.221,NULL,66922566796,1045665106,16338517,14.5),(19196,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19196,35.51,0.47,126,4772,NULL,NULL,'H','UGC 01265',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'GPair',0.000033,NULL,NULL,NULL,NULL,'in a pair',NULL,NULL,NULL,1,27.194667,20.26281,0.221,NULL,66922566785,1045665106,16338517,NULL),(19197,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19197,35.59,0.4,131,4772,NULL,NULL,'mean','UGC 01265',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19198,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19198,35.59,0.45,131,4772,NULL,NULL,'K','UGC 01265',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19199,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19199,35.66,0.46,136,4772,NULL,NULL,'J','UGC 01265',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19200,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19200,32.77,0.49,35.8,4773,75,NULL,'IR','UGC 01268',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.00009,NULL,'15.22',0.3,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,27.2185,10.58994,0.161,NULL,67057493584,1047773337,16371458,15.22),(19201,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19201,33.85,0.47,59,4773,NULL,NULL,'H','UGC 01268',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19202,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19202,34.03,0.45,63.9,4773,NULL,NULL,'K','UGC 01268',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19203,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19203,34.08,0.46,65.5,4773,NULL,NULL,'J','UGC 01268',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19204,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19204,34.18,0.4,68.4,4773,NULL,NULL,'mean','UGC 01268',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19205,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19205,34.17,0.4,68.4,4774,NULL,NULL,'mean','IC 0162',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000103,NULL,'13.71',1.6,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,27.222625,10.52161,0.161,NULL,67057496758,1047773386,16371459,13.71),(19206,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19206,34.59,0.45,82.9,4774,NULL,NULL,'K','IC 0162',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19207,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19207,33.55,0.49,51.2,4775,70,NULL,NULL,'NGC 0686',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.000037,NULL,'13.35',1.4,'SA0-:',NULL,NULL,NULL,NULL,1,27.233917,-23.79814,0,NULL,37916712280,592448629,9257009,13.35),(19208,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19208,33.63,0.45,53.3,4775,NULL,NULL,'K','NGC 0686',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19209,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19209,33.94,0.4,61.4,4775,NULL,NULL,'mean','NGC 0686',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19210,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 04304','RN',19210,39.59,0.91,682,4776,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 04304',0.212655,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19211,'Tully est','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19211,31.45,0.8,19.5,4777,75,NULL,'B','NGC 0676',NULL,'1988NBGC.C....0000T',1988,1,4,'BD +04 0244 (V = 10.44) is superposed 5.1 arcsec ssw of the nucleus.','G',0.00001,NULL,'10.5',1.2,'S0/a: sp       Sy2','in a radial-velocity based grouping',NULL,NULL,NULL,1,27.2387916667,5.90753,0.137,NULL,67026681018,1047291890,16363935,10.5),(19212,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19212,36.19,0.7,173,4778,70,NULL,NULL,'6dF J0148574-344313',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,27.2392917,-34.72028,NULL,NULL,38308703924,598573498,9352710,14.9),(19213,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19213,37.51,0.23,317,4779,70,NULL,NULL,'2MASX J01485783+1308225',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000077,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,27.2409583333,13.13953,0.153,NULL,66939944833,1045936638,16342759,17.3),(19214,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 21451',NULL,19214,41.14,0.36,1690,4780,70,NULL,'SN photometric redshift distance, z photo =0.518 +/- 0.140','SDSS-II SN 21451',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,27.262875,0.54533,0.073,NULL,66979886213,1046560722,16352511,NULL),(19215,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19215,34.25,0.46,70.7,4781,70,NULL,NULL,'NGC 0682',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000063,NULL,'13.65',1.1,'SA0-',NULL,NULL,NULL,NULL,1,27.269167,-14.97483,0,NULL,35077823652,548090994,8563921,13.65),(19216,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 06813','R',19216,39.66,0.21,664,4782,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 06813',0.286137,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,27.270333,0.05711,0.065,NULL,66979441455,1046553772,16352402,NULL),(19217,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 06813','R',19217,39.77,0.26,698,4782,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 06813',0.286137,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19218,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19218,34.41,0.25,76.2,4783,74.4,NULL,NULL,'UGC 01269',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000083,NULL,'15.10',0.6,'S0-:','Group member',NULL,NULL,NULL,1,27.2740417,34.98311,0.133,NULL,67740118844,1058439356,16538114,15.1),(19219,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19219,33.6,0.4,52.4,4783,NULL,NULL,'mean','UGC 01269',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19220,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19220,34.61,0.45,83.5,4783,NULL,NULL,'K','UGC 01269',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19221,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19221,36.84,0.46,233,4784,70,NULL,NULL,'SDSS J014906.09+142550.6',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00007,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,27.275417,14.43072,0.073,NULL,66937711136,1045901736,16342214,16.6),(19222,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19222,34.63,0.47,84.3,4785,70,NULL,NULL,'IC 0164',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000067,NULL,'14.24',1.2,'E+:      poss. LINER',NULL,NULL,NULL,NULL,1,27.2850417,-3.90439,0.036,NULL,35029858806,547341543,8552211,14.24),(19223,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19223,37.61,0.23,333,4786,70,NULL,NULL,'SDSS J014909.07+140301.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000066,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,27.287833,14.05053,0.133,NULL,66940407620,1045943869,16342872,18.3),(19224,'Tully est','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19224,31.95,0.8,24.6,4787,75,NULL,NULL,'UGCA 021',NULL,'1988NBGC.C....0000T',1988,1,1.55,'Confused HIPASS source','G',0.000002,NULL,'14.2g',1.18,'SB(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,27.2931666667,-10.06122,0.061,NULL,35112083282,548626301,8572285,14.2),(19225,'Sosies','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19225,33.3,0.12,45.7,4788,NULL,NULL,NULL,'NGC 0681',NULL,'2002A&A...393...57T',2002,1,1.86,'Confused HIPASS source','G',0.000022,NULL,'12.9g',1.34,'SAB(s)ab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,27.295125,-10.42642,0.025,NULL,35113720190,548651877,8572685,12.9),(19226,'Tully est','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19226,31.67,0.8,21.5,4788,75,NULL,'B','NGC 0681',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19227,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19227,31.11,0.69,16.7,4788,100,NULL,'mid-IR','NGC 0681',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19228,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19228,33.36,0.43,47.1,4788,75,NULL,'3.6 micron, color corrected','NGC 0681',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19229,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19229,33.38,0.43,47.3,4788,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0681',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19230,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19230,33.48,0.2,49.7,4788,74.4,NULL,NULL,'NGC 0681',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19231,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 13355','R',19231,37.56,0.04,307,4789,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2006kh','SN 2006kh',0.059657,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'II',NULL,NULL,NULL,NULL,1,27.299375,-0.60525,0.073,NULL,34973130009,546455156,8538361,NULL),(19232,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19232,37.61,0.23,333,4790,70,NULL,NULL,'SDSS J014911.89+140301.8',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00008,NULL,'16.1g',0.38,'E0',NULL,NULL,NULL,NULL,1,27.2995416667,14.0505,0.133,NULL,66940407524,1045943867,16342872,16.1),(19233,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19233,35.66,0.25,136,4791,74.4,NULL,NULL,'CGCG 503-025',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000044,NULL,'14.01',0.4,'E/S0',NULL,NULL,NULL,NULL,1,27.3036666667,33.09578,0.137,NULL,67775576258,1058993379,16546771,14.01),(19234,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19234,35.84,0.26,147,4791,70,NULL,NULL,'CGCG 503-025',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19235,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19235,34.13,0.4,67,4792,NULL,NULL,'mean','NGC 0677',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000073,NULL,'13.7g',0.92,'E              NLAGN','in a radial-velocity based grouping',NULL,NULL,NULL,1,27.308583,13.05536,0.153,NULL,66939971352,1045937052,16342766,13.7),(19236,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19236,34.39,0.45,75.5,4792,NULL,NULL,'K','NGC 0677',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19237,'IRAS','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19237,32.55,0.8,32.4,4793,75,NULL,'A82, H','IC 0163',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000003,NULL,'13.60',0.9,'SBdm','in a radial-velocity based grouping',NULL,NULL,NULL,1,27.3124583,20.71131,0.285,NULL,66922922647,1045670666,16338604,13.6),(19238,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19238,31.58,0.4,20.7,4793,NULL,NULL,'Virgo cluster at 15.6 Mpc','IC 0163',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19239,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19239,31.89,0.69,23.8,4793,100,NULL,'mid-IR','IC 0163',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19240,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19240,31.91,0.43,24.1,4793,75,NULL,'3.6 micron, color + selection bias corrected','IC 0163',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19241,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19241,31.97,0.43,24.8,4793,75,NULL,'3.6 micron, color corrected','IC 0163',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19242,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19242,32,0.2,25.1,4793,74.4,NULL,NULL,'IC 0163',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19243,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19243,32.04,0.38,25.6,4793,NULL,NULL,NULL,'IC 0163',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19244,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19244,32.04,0.39,25.6,4793,73,NULL,'opt','IC 0163',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19245,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19245,32.14,0.52,26.8,4793,NULL,NULL,NULL,'IC 0163',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19246,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19246,32.2,0.51,27.6,4793,NULL,NULL,'Malmquist cor.','IC 0163',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19247,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19247,32.31,0.47,29,4793,75,NULL,'A82, H, inv','IC 0163',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19248,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19248,32.34,0.47,29.3,4793,75,NULL,'A82, H, raw','IC 0163',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19249,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19249,32.73,0.47,35.2,4793,75,NULL,'A82, H, cor','IC 0163',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19250,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19250,32.8,0.4,36.3,4793,75,NULL,'B','IC 0163',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19251,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19251,31.5,0.4,20,4794,NULL,NULL,'mean','UGC 01198',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000027,NULL,'14.80',0.8,'E?',NULL,NULL,NULL,NULL,1,27.323583,85.26053,0.361,NULL,65559727742,1024370745,16005792,14.8),(19252,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19252,31.93,0.45,24.3,4794,NULL,NULL,'K','UGC 01198',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19253,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19253,37.61,0.23,333,4795,70,NULL,NULL,'2MASX J01491770+1352068',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000095,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,27.3239166667,13.86858,0.133,NULL,66940326400,1045942600,16342853,17.2),(19254,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19254,37.51,0.23,317,4796,70,NULL,NULL,'2MASX J01491843+1300218',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000067,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,27.3267917,13.00608,0.165,NULL,66939972173,1045937065,16342766,17.5),(19255,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19255,37.12,0.46,265,4797,70,NULL,NULL,'2MASX J01491986-0856005',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000096,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,27.33275,-8.93356,0.084,NULL,35107481911,548554404,8571162,17),(19256,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19256,36.23,0.38,176,4798,NULL,NULL,'Malmquist cor.','AGC 110543',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000013,NULL,'15.1I',0.2,'S',NULL,NULL,NULL,NULL,1,27.33375,27.71222,0.209,NULL,67714019658,1058031557,16531743,15.1),(19257,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19257,36.36,0.36,187,4798,NULL,NULL,NULL,'AGC 110543',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19258,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19258,36.37,0.2,188,4798,74.4,NULL,NULL,'AGC 110543',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19259,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19259,37.51,0.23,317,4799,70,NULL,NULL,'2MASX J01492028+1301258',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00008,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,27.3347083,13.02392,0.165,NULL,66939972354,1045937068,16342766,17.8),(19260,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19260,34.41,0.2,76.2,4800,74.4,NULL,NULL,'MCG -02-05-055',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'15.02',0.15,'HII',NULL,NULL,NULL,NULL,1,27.3425,-14.12311,0,NULL,35077339007,548083421,8563803,15.02),(19261,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19261,36.58,0.46,207,4801,70,NULL,NULL,'2MASX J01492242-0834585',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000112,NULL,'16.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,27.3434583,-8.58303,0.079,NULL,35107568469,548555757,8571183,16.3),(19262,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19262,36.6,0.61,209,4802,70,NULL,NULL,'2MASX J01492433-2141089',NULL,'2014MNRAS.445.2677S',2014,1,0.97,NULL,'G',0.000103,NULL,'16.72',0.3,NULL,NULL,NULL,NULL,NULL,1,27.351375,-21.68592,0,NULL,35034224454,547409757,8553277,16.72),(19263,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19263,34.27,0.2,71.5,4803,74.4,NULL,NULL,'UGC 01279',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000108,NULL,'15.2g',0.35,'S?',NULL,NULL,NULL,NULL,1,27.353417,13.36894,0.153,NULL,66939515251,1045929925,16342655,15.2),(19264,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19264,34.29,0.42,72,4803,NULL,NULL,'Malmquist cor.','UGC 01279',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19265,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19265,34.34,0.41,73.8,4803,NULL,NULL,NULL,'UGC 01279',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19266,'IRAS','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19266,32.63,0.8,33.6,4804,75,NULL,'W91PP, r','NGC 0678',NULL,'1997ApJS..109..333W',1997,1,4.5,NULL,'G',0.000013,NULL,'13.33',0.8,'SB(s)b: sp','in a radial-velocity based grouping',NULL,NULL,NULL,1,27.353583,21.99731,0.309,NULL,66911643269,1045494426,16335850,13.33),(19267,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19267,31.84,0.38,23.3,4804,75,NULL,'W91PP, r, raw','NGC 0678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19268,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19268,31.97,0.38,24.8,4804,75,NULL,'W91PP, r, inv','NGC 0678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19269,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19269,32.1,0.46,26.3,4804,NULL,NULL,'J','NGC 0678',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19270,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19270,32.11,0.38,26.5,4804,75,NULL,'W91PP, r, cor','NGC 0678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19271,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19271,32.12,0.47,26.6,4804,NULL,NULL,'H','NGC 0678',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19272,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19272,32.19,0.45,27.4,4804,NULL,NULL,'K','NGC 0678',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19273,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19273,32.69,0.4,34.5,4804,NULL,NULL,'mean','NGC 0678',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19274,'IRAS','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19274,33.37,0.8,47.3,4805,75,NULL,'HMCL, I','UGC 01277',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000021,NULL,'14.23',0.9,'S0/a',NULL,NULL,NULL,NULL,1,27.35725,35.45289,0.133,NULL,67742419595,1058475306,16538676,14.23),(19275,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19275,32.68,0.69,34.4,4805,100,NULL,'mid-IR','UGC 01277',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19276,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19276,34.32,0.12,73.3,4805,NULL,NULL,NULL,'UGC 01277',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19277,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19277,34.42,0.4,76.5,4805,75,NULL,'HMCL, I, raw','UGC 01277',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19278,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19278,34.49,0.4,79.1,4805,75,NULL,'HMCL, I, cor','UGC 01277',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19279,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19279,34.67,0.4,85.9,4805,75,NULL,'HMCL, I, inv','UGC 01277',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19280,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19280,35.07,0.2,103,4805,74.4,NULL,NULL,'UGC 01277',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19281,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19281,34.75,0.48,89,4806,70,NULL,NULL,'ESO 152- G 026',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.00009,NULL,'14.09',1.3,'(R_1R\'_2)SAB(r)ab',NULL,NULL,NULL,NULL,1,27.3664583,-56.05339,0.005,NULL,36126623453,564478491,8819976,14.09),(19282,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 05869','RN',19282,41.77,0.34,1950,4807,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 05869',0.158377,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19283,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 05869','RN',19283,42.3,0.37,2490,4807,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05869',0.158377,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19284,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19284,37.61,0.23,333,4808,70,NULL,NULL,'SDSS J014930.41+135933.2',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000099,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,27.3767083,13.99258,0.133,NULL,66937455579,1045897743,16342152,16.7),(19285,'Brightest Stars','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19285,28.68,0.2,5.45,4809,NULL,NULL,NULL,'UGC 01281',NULL,'1998A&AS..133..181M',1998,1,5.82,'The 2MASS position is 11 arcsec southwest of the optical center of the galaxy.','G',0.000003,NULL,'12.87',0.65,'Sdm','Field galaxy',NULL,NULL,NULL,1,27.383333,32.58972,0.137,NULL,67775751951,1058996124,16546814,12.87),(19286,'TRGB','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19286,28.1,0.35,4.17,4809,NULL,NULL,NULL,'UGC 01281',NULL,'2005AJ....129..698M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19287,'TRGB','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19287,28.54,NULL,5.11,4809,NULL,NULL,'I','UGC 01281',NULL,'2006ARep...50..517T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19288,'TRGB','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19288,28.55,0.03,5.13,4809,NULL,NULL,NULL,'UGC 01281',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19289,'TRGB','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19289,28.61,0.1,5.27,4809,74.4,NULL,NULL,'UGC 01281',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19290,'TRGB','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19290,28.63,0.02,5.32,4809,NULL,NULL,'I','UGC 01281',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19291,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19291,28.29,0.4,4.6,4809,75,NULL,'B','UGC 01281',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19292,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19292,28.95,NULL,6.16,4809,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01281',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19293,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19293,28.97,NULL,6.23,4809,NULL,NULL,'Dipole + Quadrupole','UGC 01281',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19294,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19294,28.99,NULL,6.27,4809,NULL,NULL,'Dipole','UGC 01281',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19295,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19295,29.07,NULL,6.53,4809,NULL,NULL,NULL,'UGC 01281',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19296,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19296,32.16,0.43,27,4810,75,NULL,'3.6 micron, color + selection bias corrected','KUG 0147-138',NULL,'2014MNRAS.444..527S',2014,1,1.5,NULL,'G',0.000038,NULL,'14.86',0.5,'SB(r)b?','X-ray-bright group member',NULL,NULL,NULL,1,27.408,-13.57094,0,NULL,35078585673,548102901,8564107,14.86),(19297,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19297,31.61,0.4,21,4811,75,NULL,'B','DDO 015',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.00002,NULL,'14.91',1.5,'SB(s)m','X-ray-bright group member',NULL,NULL,NULL,1,27.417417,-12.82422,0,NULL,35078156792,548096199,8564003,14.91),(19298,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19298,37.51,0.23,317,4812,70,NULL,NULL,'2MASX J01494033+1301180',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00009,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,27.418125,13.02167,0.165,NULL,66939397880,1045928091,16342626,17.8),(19299,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19299,35.12,0.55,106,4813,70,NULL,NULL,'2MASX J01494179-5837500',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'15.60',0.55,'S',NULL,NULL,NULL,NULL,1,27.424125,-58.63056,0,NULL,36149433174,564834893,8825545,15.6),(19300,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19300,37.69,0.46,346,4814,70,NULL,NULL,'SDSS J014941.81+124458.3',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000076,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,27.42425,12.74953,0.137,NULL,66939115141,1045923674,16342557,17.7),(19301,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 13377','RN',19301,41.72,0.18,1490,4815,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13377',0.484952,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19302,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SN 2002eu',NULL,19302,36.09,0.15,159,4816,70,NULL,'SALT 2','2MASX J01494273+3237303',0.037626,'2013MNRAS.433.2240G',2013,1,0.51,NULL,'G',0.000334,NULL,'16.30',0.22,NULL,NULL,NULL,NULL,NULL,1,27.428,32.62517,0.137,NULL,67775756044,1058996188,16546815,16.3),(19303,'D-Sigma','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19303,33.62,0.4,53,4817,75,NULL,'Edat, raw','NGC 0679',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.00003,NULL,'13.33',2.1,'S0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,27.432417,35.78564,0.185,NULL,67742341814,1058474090,16538657,13.33),(19304,'D-Sigma','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19304,33.74,0.4,56,4817,75,NULL,'Edat, cor','NGC 0679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19305,'Faber-Jackson','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19305,33.93,0.45,61.1,4817,95,NULL,'Weighted Mean','NGC 0679',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19306,'Faber-Jackson','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19306,33.93,0.45,61.1,4817,95,NULL,'de Vaucouleurs','NGC 0679',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19307,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19307,33.9,0.22,60.3,4817,74.4,NULL,NULL,'NGC 0679',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19308,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19308,34.08,0.24,65.4,4817,70,NULL,NULL,'NGC 0679',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19309,'Tertiary','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19309,33.51,0.5,50.4,4817,95,NULL,NULL,'NGC 0679',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19310,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19310,34.13,0.4,67,4817,NULL,NULL,'mean','NGC 0679',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19311,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19311,34.4,0.45,75.9,4817,NULL,NULL,'K','NGC 0679',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19312,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19312,34.21,NULL,69.6,4818,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0196',NULL,'2010Ap&SS.325..163P',2010,1,1.18,NULL,'G',0.000053,NULL,'16.46',0.1,'Sd',NULL,NULL,NULL,NULL,1,27.4347083333,28.71892,0.181,NULL,67728444727,1058256948,16535264,16.46),(19313,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19313,34.24,NULL,70.3,4818,NULL,NULL,'Dipole','FGC 0196',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19314,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19314,34.24,NULL,70.4,4818,NULL,NULL,'Dipole + Quadrupole','FGC 0196',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19315,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19315,34.3,NULL,72.5,4818,NULL,NULL,NULL,'FGC 0196',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19316,'SNII optical','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SN 2003hd',NULL,19316,35.77,0.53,143,4819,NULL,NULL,'SCM, I','ESO 543- G 017',NULL,'2010ApJ...715..833O',2010,1,1.4,NULL,'G',0.000033,NULL,'14.77',0.8,'Sb             HII',NULL,NULL,NULL,NULL,1,27.446417,-21.9075,0,NULL,35034853224,547419581,8553430,14.77),(19317,'SNII optical','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SN 2003hd',NULL,19317,35.85,0.54,148,4819,NULL,NULL,'SCM, V','ESO 543- G 017',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19318,'SNII optical','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SN 2003hd',NULL,19318,35.86,0.28,149,4819,NULL,NULL,'SCM, BVI','ESO 543- G 017',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19319,'SNII optical','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SN 2003hd',NULL,19319,35.93,0.4,153,4819,NULL,NULL,'SCM, B','ESO 543- G 017',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19320,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19320,35.85,0.4,148,4819,NULL,NULL,'Malmquist cor.','ESO 543- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19321,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19321,35.86,0.4,149,4819,NULL,NULL,NULL,'ESO 543- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19322,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19322,35.9,0.2,151,4819,74.4,NULL,NULL,'ESO 543- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19323,'SBF','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19323,32.46,0.41,31,4820,NULL,NULL,NULL,'NGC 0680',NULL,'2001MNRAS.327.1004B',2001,1,1.9,NULL,'G',0.000017,NULL,'12.90',1.6,'E+ pec:','in a radial-velocity based grouping',NULL,NULL,NULL,1,27.4470417,21.97086,0.261,NULL,66911656122,1045494626,16335853,12.9),(19324,'SBF','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19324,32.87,0.41,37.5,4820,NULL,NULL,'Malmquist cor.','NGC 0680',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19325,'D-Sigma','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19325,32.33,0.4,29.3,4820,75,NULL,'Edat, raw','NGC 0680',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19326,'D-Sigma','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19326,32.67,0.4,34.2,4820,75,NULL,'Edat, cor','NGC 0680',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19327,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19327,32.51,0.41,31.8,4820,NULL,NULL,NULL,'NGC 0680',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19328,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19328,32.92,0.41,38.3,4820,NULL,NULL,'Malmquist cor.','NGC 0680',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19329,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19329,32.74,0.4,35.4,4820,NULL,NULL,'mean','NGC 0680',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19330,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19330,33.08,0.45,41.3,4820,NULL,NULL,'K','NGC 0680',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19331,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 06639','RN',19331,40.99,0.09,1260,4821,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 06639',0.252511,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19332,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 06639','RN',19332,41.54,0.18,1620,4821,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 06639',0.252511,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19333,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19333,33.69,0.45,54.6,4822,NULL,NULL,'K','NGC 0689',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000033,NULL,'14.11',0.6,'(R\'_1)SB(r)b   HII',NULL,NULL,NULL,NULL,1,27.4657083333,-27.46661,0,NULL,38254349730,597724214,9339440,14.11),(19334,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19334,33.69,0.47,54.8,4822,NULL,NULL,'H','NGC 0689',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19335,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19335,33.73,0.4,55.7,4822,NULL,NULL,'mean','NGC 0689',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19336,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19336,33.81,0.46,57.9,4822,NULL,NULL,'J','NGC 0689',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19337,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19337,34.25,0.42,70.9,4822,NULL,NULL,NULL,'NGC 0689',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19338,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19338,34.29,0.2,72.1,4822,74.4,NULL,NULL,'NGC 0689',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19339,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19339,34.35,0.4,74,4822,NULL,NULL,'Malmquist cor.','NGC 0689',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19340,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 05937','RN',19340,43.46,0.25,2950,4823,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05937',0.667692,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19341,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 14142','RN',19341,44.01,0.34,3820,4824,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 14142',0.655829,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19342,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 14143','RN',19342,42.22,0.21,2060,4825,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14143',0.349981,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19343,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 14143','RN',19343,42.57,0.24,2420,4825,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 14143',0.349981,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19344,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19344,37.53,0.46,321,4826,70,NULL,NULL,'2MASX J01495825-0035131',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000084,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,27.492875,-0.58706,0.061,NULL,34973016911,546453389,8538334,16.7),(19345,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 07939','R',19345,39.62,0.4,734,4827,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07939',0.142024,'2014arXiv1401.3317S',2014,1,0.18,NULL,'G',NULL,'PHOT','20.0g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,27.495333,1.20036,0.037,NULL,67034103596,1047407868,16365747,20),(19346,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 07939','R',19346,39.84,0.37,813,4827,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07939',0.142024,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19347,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 07939',NULL,19347,40.99,0.6,1580,4827,70,NULL,'SN photometric redshift distance, z photo =0.473 +/- 0.226','SDSS-II SN 07939',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19348,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19348,35.23,0.53,111,4828,70,NULL,NULL,'MCG -01-05-038',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'16',0.3,NULL,NULL,NULL,NULL,NULL,1,27.5015417,-6.44142,0.031,NULL,34988591962,546696749,8542136,16),(19349,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19349,33.92,0.2,60.8,4829,74.4,NULL,NULL,'UGC 01289',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000017,NULL,'16.0',0.9,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,27.515,16.43917,0.117,NULL,66968152209,1046377378,16349646,16),(19350,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19350,34.2,0.48,69.3,4829,NULL,NULL,'Malmquist cor.','UGC 01289',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19351,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19351,34.25,0.47,70.9,4829,NULL,NULL,NULL,'UGC 01289',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19352,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 17952','R',19352,41.21,0.2,1290,4830,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J015004.02+000447.8',0.348,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',0.0005,NULL,'19.9g',0.08,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,27.51675,0.07994,0.069,NULL,66978984108,1046546626,16352291,19.9),(19353,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 17952','R',19353,41.34,0.28,1380,4830,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J015004.02+000447.8',0.348,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19354,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 17952',NULL,19354,41.27,0.17,1790,4830,70,NULL,'SALT 2','SDSS J015004.02+000447.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19355,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 17952',NULL,19355,41.31,0.17,1830,4830,70,NULL,'SALT 2, Malmquist cor.','SDSS J015004.02+000447.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19356,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19356,37.71,0.46,348,4831,70,NULL,NULL,'2MASX J01500717+1306379',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00009,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,27.529875,13.11039,0.165,NULL,66939413084,1045928329,16342630,17),(19357,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19357,35.07,0.49,103,4832,75,NULL,'IR','2MFGC 01381',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.000033,NULL,'16.5',0.2,NULL,NULL,NULL,NULL,NULL,1,27.5301666667,16.92981,0.121,NULL,66969568345,1046399505,16349992,16.5),(19358,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19358,38.48,0.46,496,4833,70,NULL,NULL,'SDSS J015009.56+125830.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000081,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,27.539875,12.97511,0.165,NULL,66931209234,1045800144,16340627,18.8),(19359,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19359,37.45,0.46,309,4834,70,NULL,NULL,'2MASX J01500995+0032055',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,27.5415,0.53494,0.065,NULL,66978963928,1046546311,16352286,17.9),(19360,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 13962','RN',19360,40.41,0.14,888,4835,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13962',0.357473,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19361,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 13962','RN',19361,41.06,0.22,1200,4835,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13962',0.357473,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19362,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 17328','RN',19362,39.66,0.28,791,4836,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 17328',0.082214,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19363,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19363,37.77,0.46,358,4837,70,NULL,NULL,'2MASX J01501149+0004341',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.29',0.17,NULL,NULL,NULL,NULL,NULL,1,27.5478333333,0.07631,0.069,NULL,66979031985,1046547374,16352302,18.29),(19364,'IRAS','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19364,33.02,0.8,40.2,4838,75,NULL,'W91PP, r','IC 1731',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000003,NULL,'14.00',1,'SAB(s)c:','in a radial-velocity based grouping',NULL,NULL,NULL,1,27.551417,27.19617,0.213,NULL,67714748882,1058042951,16531921,14),(19365,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19365,32.65,0.2,33.9,4838,74.4,NULL,NULL,'IC 1731',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19366,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19366,32.87,0.52,37.4,4838,NULL,NULL,NULL,'IC 1731',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19367,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19367,32.9,0.51,38,4838,NULL,NULL,'Malmquist cor.','IC 1731',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19368,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19368,33.17,0.38,43,4838,75,NULL,'W91PP, r, raw','IC 1731',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19369,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19369,33.18,0.38,43.3,4838,75,NULL,'W91PP, r, inv','IC 1731',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19370,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19370,33.58,0.38,52,4838,75,NULL,'W91PP, r, cor','IC 1731',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19371,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19371,32.07,0.2,25.9,4839,74.4,NULL,NULL,'UGC 01294',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.00002,NULL,'18.',1.1,'Im:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,27.555417,23.15861,0.289,NULL,68048804866,1063262576,16613477,18),(19372,'IRAS','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19372,33.01,0.8,39.9,4840,75,NULL,'W91PP, r','NGC 0684',NULL,'1997ApJS..109..333W',1997,1,3.2,'The UZC position is 14 arcsec off the nucleus.','G',0.000005,NULL,'13.34',0.6,'Sb','in a triple',NULL,NULL,NULL,1,27.5584166667,27.64567,0.209,NULL,67714145963,1058033530,16531773,13.34),(19373,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19373,32.88,0.38,37.7,4840,75,NULL,'W91PP, r, raw','NGC 0684',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19374,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19374,32.89,0.46,37.8,4840,NULL,NULL,'J','NGC 0684',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19375,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19375,32.91,0.47,38.1,4840,NULL,NULL,'H','NGC 0684',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19376,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19376,32.97,0.45,39.2,4840,NULL,NULL,'K','NGC 0684',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19377,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19377,33.1,0.38,41.6,4840,75,NULL,'W91PP, r, inv','NGC 0684',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19378,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19378,33.11,0.49,42,4840,75,NULL,'IR','NGC 0684',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19379,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19379,33.16,0.4,42.8,4840,NULL,NULL,'mean','NGC 0684',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19380,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19380,33.16,0.44,42.9,4840,NULL,NULL,'Malmquist cor.','NGC 0684',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19381,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19381,33.2,0.2,43.7,4840,74.4,NULL,NULL,'NGC 0684',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19382,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19382,33.28,0.38,45.3,4840,75,NULL,'W91PP, r, cor','NGC 0684',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19383,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19383,33.37,0.4,47.2,4840,NULL,NULL,NULL,'NGC 0684',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19384,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19384,35.13,0.25,106,4841,74.4,NULL,NULL,'V Zw 116',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000103,NULL,'15.58',0.3,'E',NULL,NULL,NULL,NULL,1,27.561625,36.22875,0.209,NULL,67735282502,1058363789,16536934,15.58),(19385,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SN 2006hr',NULL,19385,38.87,0.06,595,4842,70,NULL,'Hubble residual -0.10 for z0.15760','2MASX J01501529-0053158',NULL,'2011ApJ...740...92G',2011,1,0.22,NULL,'G',0.000074,NULL,'18.4g',0.09,NULL,NULL,NULL,NULL,NULL,1,27.5637917,-0.88769,0.033,NULL,35018647070,547166360,8549474,18.4),(19386,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 13354','R',19386,39.34,0.19,655,4842,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006hr','2MASX J01501529-0053158',0.125174,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19387,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 13354','R',19387,39.46,0.08,694,4842,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006hr','2MASX J01501529-0053158',0.125174,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19388,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SN 2006hr',NULL,19388,39.23,0.08,701,4842,70,NULL,'SALT 2','2MASX J01501529-0053158',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19389,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SN 2006hr',NULL,19389,39.24,0.08,705,4842,70,NULL,'SALT 2, Malmquist cor.','2MASX J01501529-0053158',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19390,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19390,35.64,0.25,134,4843,74.4,NULL,NULL,'UGC 01295',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000077,NULL,'15.26',0.7,'S0',NULL,NULL,NULL,NULL,1,27.5645,33.49561,0.137,NULL,67773323477,1058958179,16546221,15.26),(19391,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19391,35.84,0.26,147,4843,70,NULL,NULL,'UGC 01295',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19392,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19392,35.9,0.4,151,4843,NULL,NULL,'mean','UGC 01295',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19393,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19393,36.09,0.45,165,4843,NULL,NULL,'K','UGC 01295',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19394,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19394,37.97,0.23,393,4844,70,NULL,NULL,'2MASXi J0150159-000700',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000095,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,27.5660833333,-0.11703,0.073,NULL,34972237223,546441206,8538143,17.9),(19395,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 01188','RN',19395,39.63,0.17,776,4845,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01188',0.085023,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19396,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19396,36.88,0.43,238,4846,NULL,NULL,'Malmquist cor.','2MASX J01501994+3309172',NULL,'2009ApJS..182..474S',2009,1,0.49,NULL,'G',NULL,NULL,'14.5',0.32,NULL,'Group member',NULL,NULL,NULL,1,27.583083,33.15481,0.161,NULL,67775361114,1058990017,16546719,14.5),(19397,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19397,37.21,0.37,276,4846,NULL,NULL,NULL,'2MASX J01501994+3309172',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19398,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 21766','R',19398,38.94,0.18,544,4847,70,NULL,'SDSS CAND. Variable; SALT 2; SN 2007rc','SN 2007rc',0.127856,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,27.584167,-0.40381,0.061,NULL,34972280270,546441879,8538154,NULL),(19399,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 21766','R',19399,39.09,0.09,583,4847,70,NULL,'SDSS CAND. Variable; MLCS2K2; SN 2007rc','SN 2007rc',0.127856,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19400,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 06305','RN',19400,42.21,0.24,2030,4848,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 06305',0.361523,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19401,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 20565','RN',19401,39.67,0.12,788,4849,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 20565',0.087822,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19402,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 20565','RN',19402,39.67,0.23,789,4849,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 20565',0.087822,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19403,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SN 2007kt',NULL,19403,39.76,0.12,895,4850,70,NULL,'Hubble residual -0.02 for z0.23900','SDSS J015023.84+011020.4',NULL,'2011ApJ...740...92G',2011,1,0.07,NULL,'G',0.005,NULL,'20.8g',0.05,NULL,NULL,NULL,NULL,NULL,1,27.599333,1.17236,0.029,NULL,67034055003,1047407109,16365736,20.8),(19404,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 17884','R',19404,40.42,0.19,980,4850,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007kt','SDSS J015023.84+011020.4',0.239,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19405,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 17884','R',19405,40.57,0.13,1050,4850,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007kt','SDSS J015023.84+011020.4',0.239,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19406,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SN 2007kt',NULL,19406,40.33,0.1,1160,4850,70,NULL,'SALT 2','SDSS J015023.84+011020.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19407,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SN 2007kt',NULL,19407,40.35,0.1,1170,4850,70,NULL,'SALT 2, Malmquist cor.','SDSS J015023.84+011020.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19408,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19408,37.97,0.23,393,4851,70,NULL,NULL,'2MASX J01502655-0009238',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.53',0.16,NULL,NULL,NULL,NULL,NULL,1,27.610625,-0.15658,0.061,NULL,34972221805,546440965,8538140,18.53),(19409,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19409,37.97,0.23,393,4852,70,NULL,NULL,'2MASX J01502709-0008398',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000092,NULL,'16.8g',0.33,NULL,NULL,NULL,NULL,NULL,1,27.612875,-0.14433,0.061,NULL,34972225081,546441016,8538140,16.8),(19410,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19410,34.55,0.47,81.4,4853,70,NULL,NULL,'IC 0168',NULL,'2014MNRAS.445.2677S',2014,1,1.04,NULL,'G',0.000109,NULL,'14.3g',0.4,'Sa',NULL,NULL,NULL,NULL,1,27.615125,-8.52294,0.108,NULL,35108364458,548568194,8571378,14.3),(19411,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19411,34.77,0.27,90.1,4853,70,NULL,NULL,'IC 0168',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19412,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19412,37.93,0.46,385,4854,70,NULL,NULL,'SDSS J015029.46-080756.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000074,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,27.62275,-8.13239,0.076,NULL,35108018392,548562787,8571293,18.6),(19413,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19413,37.97,0.23,393,4855,70,NULL,NULL,'2MASX J01503022-0011247',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000089,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,27.6257917,-0.19025,0.061,NULL,34972192770,546440512,8538133,17.1),(19414,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19414,31.38,0.4,18.9,4856,73,NULL,'opt','NGC 0693',NULL,'2011A&A...532A.104N',2011,1,2.1,NULL,'G',0.000017,NULL,'13.24',1,'S0/a?          HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,27.6285417,6.14522,0.149,NULL,67018955597,1047171181,16362049,13.24),(19415,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19415,31.41,0.2,19.1,4856,74.4,NULL,NULL,'NGC 0693',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19416,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19416,31.58,0.49,20.7,4856,NULL,NULL,'Malmquist cor.','NGC 0693',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19417,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19417,31.59,0.49,20.8,4856,NULL,NULL,NULL,'NGC 0693',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19418,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19418,35.64,0.25,134,4857,74.4,NULL,NULL,'CGCG 503-029',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000036,NULL,'14.44',0.3,'S','Group member',NULL,NULL,NULL,1,27.633875,33.04714,0.161,NULL,67775326350,1058989474,16546710,14.44),(19419,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19419,35.84,0.26,147,4857,70,NULL,NULL,'CGCG 503-029',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19420,'IRAS','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19420,34.37,0.8,74.7,4858,75,NULL,'HMCL, I','UGC 01299',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000014,NULL,'15.39',0.6,'Im',NULL,NULL,NULL,NULL,1,27.6365833333,35.35969,0.141,NULL,67742457792,1058475903,16538685,15.39),(19421,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19421,34.2,0.2,69.2,4858,74.4,NULL,NULL,'UGC 01299',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19422,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19422,34.44,0.4,77.3,4858,75,NULL,'HMCL, I, raw','UGC 01299',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19423,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19423,34.47,0.4,78.2,4858,75,NULL,'HMCL, I, inv','UGC 01299',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19424,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19424,34.51,0.4,79.7,4858,75,NULL,'HMCL, I, cor','UGC 01299',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19425,'D-Sigma','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19425,33.62,0.4,53,4859,75,NULL,'Edat, raw','NGC 0687',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000027,NULL,'13.30',1.4,'S0','Pair member (points to parent)',NULL,NULL,NULL,1,27.6385,36.37081,0.209,NULL,67735275938,1058363686,16536932,13.3),(19426,'D-Sigma','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19426,33.74,0.4,56,4859,75,NULL,'Edat, cor','NGC 0687',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19427,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19427,33.76,0.22,56.5,4859,74.4,NULL,NULL,'NGC 0687',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19428,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19428,34.08,0.24,65.4,4859,70,NULL,NULL,'NGC 0687',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19429,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19429,34.25,0.4,70.8,4859,NULL,NULL,'mean','NGC 0687',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19430,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19430,34.33,0.45,73.4,4859,NULL,NULL,'K','NGC 0687',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19431,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19431,36.13,0.51,168,4860,70,NULL,NULL,'2MASX J01503833-2439223',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.000103,NULL,'15.26',0.57,'E',NULL,NULL,NULL,NULL,1,27.659667,-24.65631,0,NULL,38387163861,599799435,9371866,15.26),(19432,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19432,37.34,0.61,294,4861,70,NULL,NULL,'2MASX J01503847-0845492',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00008,NULL,'15.7g',0.48,'Sb',NULL,NULL,NULL,NULL,1,27.660375,-8.76364,0.108,NULL,35108342193,548567846,8571372,15.7),(19433,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19433,36.05,0.46,162,4862,70,NULL,NULL,'2MASX J01503973-0042535',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00009,NULL,'16.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,27.665625,-0.71486,0.049,NULL,35018316345,547161192,8549393,16.2),(19434,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 15741',NULL,19434,41.13,0.22,1680,4863,70,NULL,'SN photometric redshift distance, z photo =0.515 +/- 0.079','SDSS-II SN 15741',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,27.672375,-0.10656,0.077,NULL,34972215261,546440863,8538138,NULL),(19435,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SN 2005W',NULL,19435,32.73,0.01,35.2,4864,72,NULL,NULL,'NGC 0691',NULL,'2011AJ....141...19B',2011,1,3.5,NULL,'G',0.000013,NULL,'11.6B',2.6,'SA(rs)bc','in a radial-velocity based grouping',NULL,NULL,NULL,1,27.673833,21.75992,0.221,NULL,66910758638,1045480603,16335634,11.6),(19436,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19436,32.61,0.4,33.2,4864,NULL,NULL,'mean','NGC 0691',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19437,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19437,32.71,0.4,34.8,4864,NULL,NULL,NULL,'NGC 0691',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19438,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19438,32.74,0.4,35.2,4864,75,NULL,'B','NGC 0691',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19439,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19439,32.79,0.46,36.2,4864,NULL,NULL,'Malmquist cor.','NGC 0691',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19440,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19440,32.83,0.2,36.8,4864,74.4,NULL,NULL,'NGC 0691',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19441,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19441,32.89,0.43,37.8,4864,75,NULL,'3.6 micron, color corrected','NGC 0691',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19442,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19442,32.93,0.43,38.6,4864,NULL,NULL,NULL,'NGC 0691',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19443,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19443,32.96,0.47,39.1,4864,NULL,NULL,'H','NGC 0691',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19444,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19444,33,0.46,39.8,4864,NULL,NULL,'J','NGC 0691',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19445,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19445,33,0.43,39.9,4864,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0691',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19446,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19446,33.02,0.45,40.2,4864,NULL,NULL,'K','NGC 0691',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19447,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19447,35.64,0.25,134,4865,74.4,NULL,NULL,'IC 1733',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000039,NULL,'14.12',1.4,'cD;E:','Group member',NULL,NULL,NULL,1,27.6787083,33.08203,0.161,NULL,67775350850,1058989857,16546716,14.12),(19448,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19448,35.84,0.26,147,4865,70,NULL,NULL,'IC 1733',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19449,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19449,35.72,0.45,139,4865,NULL,NULL,'K','IC 1733',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19450,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19450,35.77,0.17,142,4865,70,NULL,'ABELL 0260, BGC','IC 1733',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19451,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19451,35.88,0.4,150,4865,NULL,NULL,'mean','IC 1733',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19452,'IRAS','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19452,34.29,0.8,72.1,4866,75,NULL,'MAT, I','NGC 0699',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.92',0.3,'SBbc? sp       HII',NULL,NULL,NULL,NULL,1,27.682,-12.03567,0.008,NULL,35104251024,548503922,8570373,14.92),(19453,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19453,34.06,0.32,64.8,4866,85,NULL,'I, raw','NGC 0699',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19454,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19454,34.1,0.43,66,4866,75,NULL,'MAT, I, raw','NGC 0699',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19455,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19455,34.1,0.32,66,4866,85,NULL,'I, inv','NGC 0699',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19456,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19456,34.25,0.43,70.9,4866,75,NULL,'MAT, I, cor','NGC 0699',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19457,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19457,34.29,0.43,72.1,4866,75,NULL,'MAT, I, inv','NGC 0699',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19458,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19458,34.46,0.4,77.9,4866,NULL,NULL,'mean','NGC 0699',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19459,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19459,34.46,0.31,77.9,4866,NULL,NULL,'Malmquist cor.','NGC 0699',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19460,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19460,34.47,0.49,78.2,4866,75,NULL,'IR','NGC 0699',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19461,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19461,34.61,0.2,83.6,4866,74.4,NULL,NULL,'NGC 0699',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19462,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19462,34.74,0.28,88.5,4866,NULL,NULL,NULL,'NGC 0699',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19463,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19463,34.75,0.47,89.1,4866,NULL,NULL,'H','NGC 0699',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19464,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19464,36.07,0.37,164,4867,NULL,NULL,NULL,'2MASX J01504419+3335451',NULL,'2009ApJS..182..474S',2009,1,0.33,NULL,'G',0.00003,NULL,'15.0I',0.12,NULL,NULL,NULL,NULL,NULL,1,27.68425,33.59594,0.129,NULL,67773340977,1058958452,16546225,15),(19465,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19465,36.11,0.2,167,4867,74.4,NULL,NULL,'2MASX J01504419+3335451',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19466,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19466,36.12,0.36,168,4867,NULL,NULL,'Malmquist cor.','2MASX J01504419+3335451',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19467,'IRAS','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19467,33.37,0.8,47.2,4868,75,NULL,'HMCL, I','NGC 0688',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000009,NULL,'13.35',1.5,'(R\')SAB(rs)b   Sbrst','Group member, radial-velocity confirmed',NULL,NULL,'Starburst',1,27.684083,35.28453,0.141,NULL,67742440931,1058475639,16538681,13.35),(19468,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19468,33.17,NULL,43.1,4868,NULL,NULL,'B','NGC 0688',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19469,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19469,33.68,NULL,54.5,4868,NULL,NULL,'I','NGC 0688',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19470,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19470,33.73,0.4,55.7,4868,NULL,NULL,'mean','NGC 0688',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19471,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19471,33.85,0.43,58.8,4868,75,NULL,'3.6 micron, color corrected','NGC 0688',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19472,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19472,33.85,0.2,58.9,4868,74.4,NULL,NULL,'NGC 0688',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19473,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19473,33.9,0.47,60.3,4868,NULL,NULL,'H','NGC 0688',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19474,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19474,33.91,0.45,60.6,4868,NULL,NULL,'K','NGC 0688',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19475,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19475,33.92,0.4,60.8,4868,75,NULL,'HMCL, I, raw','NGC 0688',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19476,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19476,33.93,0.43,61.1,4868,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0688',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19477,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19477,33.94,0.46,61.2,4868,NULL,NULL,'J','NGC 0688',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19478,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19478,34.13,0.4,67,4868,75,NULL,'HMCL, I, inv','NGC 0688',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19479,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19479,34.14,0.4,67.3,4868,75,NULL,'HMCL, I, cor','NGC 0688',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19480,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19480,34.27,0.07,71.6,4868,NULL,NULL,NULL,'NGC 0688',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19481,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19481,35.77,0.17,142,4869,70,NULL,NULL,'ABELL 0260',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II     [BM]',NULL,NULL,NULL,NULL,1,27.687083,33.09,0.161,NULL,67775351223,1058989862,16546716,NULL),(19482,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 18051','RN',19482,43.18,0.29,2910,4870,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 18051',0.485422,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19483,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19483,36.31,0.46,183,4871,70,NULL,NULL,'2MASX J01504647+1341277',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000107,NULL,'16.3g',0.33,'E0',NULL,NULL,NULL,NULL,1,27.6936666667,13.691,0.149,NULL,66929822355,1045778474,16340288,16.3),(19484,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19484,34.34,0.64,73.6,4872,NULL,NULL,'Malmquist cor.','UGC 01306',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'14.56',1.1,'(R)SAB0^0^','Group member',NULL,NULL,NULL,1,27.695125,32.54669,0.141,NULL,67775560681,1058993135,16546767,14.56),(19485,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19485,34.51,0.59,79.6,4872,NULL,NULL,NULL,'UGC 01306',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19486,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19486,34.55,0.2,81.3,4872,74.4,NULL,NULL,'UGC 01306',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19487,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 20909','RN',19487,40.69,0.14,1180,4873,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 20909',0.162191,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19488,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 20909','RN',19488,40.95,0.21,1330,4873,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 20909',0.162191,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19489,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19489,37.9,0.69,380,4874,70,NULL,NULL,'2MASX J01504721-0730482',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,27.696625,-7.51342,0.023,NULL,34988133617,546689587,8542024,16),(19490,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19490,37.73,0.46,352,4875,70,NULL,NULL,'SDSS J015047.39+131407.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000075,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,27.6974583,13.23539,0.165,NULL,66931373683,1045802713,16340667,18.3),(19491,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 03997','RN',19491,41.1,0.16,1410,4876,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03997',0.172648,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19492,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 03997','RN',19492,41.72,0.29,1880,4876,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03997',0.172648,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19493,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19493,34.26,0.08,71.3,4877,NULL,NULL,NULL,'IC 1732',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.00004,NULL,'14.93',0.4,'Sa','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,27.699583,35.93275,0.185,NULL,67743067122,1058485423,16538834,14.93),(19494,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 07444','R',19494,40.76,0.16,1140,4878,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07444 HOST',0.2499,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,27.702917,0.42972,0.069,NULL,66978949693,1046546088,16352282,NULL),(19495,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 07444','R',19495,40.85,0.23,1180,4878,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07444 HOST',0.2499,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19496,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 07444',NULL,19496,40.66,0.13,1360,4878,70,NULL,'SALT 2','SDSS-II SN 07444 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19497,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 07444',NULL,19497,40.68,0.13,1370,4878,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 07444 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19498,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19498,36.36,0.4,187,4879,NULL,NULL,'Malmquist cor.','2MASX J01504897+3230361',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000027,NULL,'14.0I',NULL,NULL,NULL,NULL,NULL,NULL,1,27.7039166667,32.50994,0.141,NULL,67775552481,1058993007,16546765,14),(19499,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19499,36.5,0.38,199,4879,NULL,NULL,NULL,'2MASX J01504897+3230361',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19500,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19500,36.54,0.2,203,4879,74.4,NULL,NULL,'2MASX J01504897+3230361',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19501,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19501,34.63,0.8,84.1,4880,NULL,NULL,'Malmquist cor.','AGC 110930',NULL,'2009ApJS..182..474S',2009,1,0.49,NULL,'G',0.00003,NULL,'15.99',NULL,'Sc',NULL,NULL,NULL,NULL,1,27.713,32.50556,0.141,NULL,67775552260,1058993004,16546765,15.99),(19502,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19502,35,0.67,99.8,4880,NULL,NULL,NULL,'AGC 110930',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19503,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19503,35.04,0.2,102,4880,74.4,NULL,NULL,'AGC 110930',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19504,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19504,33.87,0.25,59.4,4881,74.4,NULL,NULL,'UGC 01308',NULL,'2013AJ....146...86T',2013,1,2.3,NULL,'G',0.000027,NULL,'13.77',2.3,'E','Pair member (points to parent)',NULL,NULL,NULL,1,27.7135,36.27583,0.209,NULL,67742839575,1058481868,16538779,13.77),(19505,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19505,34.08,0.24,65.4,4881,70,NULL,NULL,'UGC 01308',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19506,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19506,34.27,0.4,71.6,4881,NULL,NULL,'mean','UGC 01308',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19507,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19507,34.61,0.45,83.6,4881,NULL,NULL,'K','UGC 01308',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19508,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19508,35.63,0.25,134,4882,74.4,NULL,NULL,'IC 1735',NULL,'2013AJ....146...86T',2013,1,0.67,NULL,'G',0.000063,NULL,'14.14',0.41,'SB','Group member',NULL,NULL,NULL,1,27.715583,33.09233,0.161,NULL,67775352067,1058989876,16546716,14.14),(19509,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19509,35.84,0.26,147,4882,70,NULL,NULL,'IC 1735',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19510,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19510,38.3,0.46,457,4883,70,NULL,NULL,'2MASX J01505239+0056210',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000085,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,27.718167,0.93911,0.021,NULL,67034267944,1047410436,16365788,18),(19511,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19511,34.57,0.53,82.1,4884,70,NULL,NULL,'6dF J0150525-360047',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'12.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,27.7189583,-36.01306,NULL,NULL,38298591625,598415494,9350242,12.9),(19512,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19512,33.6,0.52,52.6,4885,NULL,NULL,NULL,'IC 1736',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.87',0.4,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,27.721667,18.30278,0.117,NULL,66913637873,1045525591,16336337,14.87),(19513,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19513,33.74,0.49,55.9,4885,NULL,NULL,'Malmquist cor.','IC 1736',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19514,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19514,33.86,0.2,59.2,4885,74.4,NULL,NULL,'IC 1736',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19515,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 15436','RN',19515,39.93,0.2,830,4886,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 15436',0.1677,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19516,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 15436','RN',19516,40,0.79,855,4886,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 15436',0.1677,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19517,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19517,35.94,0.44,154,4887,NULL,NULL,NULL,'AGC 110931',NULL,'2009ApJS..182..474S',2009,1,0.38,NULL,'G',0.00003,NULL,'16.35',NULL,'Sc',NULL,NULL,NULL,NULL,1,27.726625,32.45442,0.141,NULL,67775550075,1058992969,16546765,16.35),(19518,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19518,35.98,0.2,157,4887,74.4,NULL,NULL,'AGC 110931',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19519,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19519,36.08,0.41,165,4887,NULL,NULL,'Malmquist cor.','AGC 110931',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19520,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19520,36.49,0.44,198,4888,NULL,NULL,'Malmquist cor.','2MASX J01505503-0222235',NULL,'2009ApJS..182..474S',2009,1,0.53,NULL,'G',0.000027,NULL,'18.13',0.11,NULL,NULL,NULL,NULL,NULL,1,27.729333,-2.37322,0.025,NULL,35021011042,547203297,8550051,18.13),(19521,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19521,36.74,0.39,222,4888,NULL,NULL,NULL,'2MASX J01505503-0222235',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19522,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19522,36.78,0.2,227,4888,74.4,NULL,NULL,'2MASX J01505503-0222235',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19523,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19523,37.22,0.46,278,4889,70,NULL,NULL,'2MASX J01505708+0014040',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000102,NULL,'16.0g',0.41,'E0',NULL,NULL,NULL,NULL,1,27.737917,0.2345,0.069,NULL,66979089565,1046548274,16352316,16),(19524,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19524,32.03,0.69,25.5,4890,100,NULL,'mid-IR','NGC 0694',NULL,'2013ApJ...771...88L',2013,1,3.8,'RC1 and RC3 diameters are incorrect.','G',0.000013,NULL,'14.28',2.5,'S0? pec        Sbrst','in a radial-velocity based grouping',NULL,NULL,'Starburst',1,27.7437083,21.9975,0.221,NULL,66909972267,1045468316,16335442,14.28),(19525,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 02532','R',19525,40.91,0.26,1200,4891,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J015059.29-001401.9',0.27,'2014arXiv1401.3317S',2014,1,0.12,NULL,'G',0.01,NULL,'19.3g',0.09,NULL,NULL,NULL,NULL,NULL,1,27.7470417,-0.23389,0.053,NULL,34972356481,546443070,8538172,19.3),(19526,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 02532','R',19526,40.92,0.21,1200,4891,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J015059.29-001401.9',0.27,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19527,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 02532',NULL,19527,40.82,0.16,1460,4891,70,NULL,'SALT 2','SDSS J015059.29-001401.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19528,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 02532',NULL,19528,40.85,0.16,1480,4891,70,NULL,'SALT 2, Malmquist cor.','SDSS J015059.29-001401.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19529,'SNIa SDSS','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 01189','RN',19529,41.79,0.19,1530,4892,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01189',0.491491,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19530,'IRAS','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19530,31.82,0.8,23.1,4893,75,NULL,'MAT, I','NGC 0701',NULL,'1997ApJS..109..333W',1997,1,2.5,'HOLM 047B is a star.','G',0.000017,NULL,'12.1B',1.2,'SB(rs)c;HII    Sbrst','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,27.766,-9.70261,0.046,NULL,35112230004,548628593,8572321,12.1),(19531,'IRAS','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19531,31.84,0.8,23.3,4893,75,NULL,'A82, H','NGC 0701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19532,'Sosies','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19532,31.64,0.16,21.3,4893,NULL,NULL,NULL,'NGC 0701',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19533,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19533,31.05,0.4,16.2,4893,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 0701',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19534,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19534,31.28,0.43,18,4893,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0701',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19535,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19535,31.43,0.38,19.3,4893,NULL,NULL,NULL,'NGC 0701',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19536,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19536,31.43,0.4,19.3,4893,73,NULL,'opt','NGC 0701',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19537,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19537,31.45,0.55,19.5,4893,NULL,NULL,'Malmquist cor.','NGC 0701',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19538,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19538,31.47,0.43,19.7,4893,75,NULL,'3.6 micron, color corrected','NGC 0701',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19539,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19539,31.59,0.2,20.8,4893,74.4,NULL,NULL,'NGC 0701',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19540,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19540,31.6,0.51,20.9,4893,NULL,NULL,NULL,'NGC 0701',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19541,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19541,31.61,0.47,20.9,4893,75,NULL,'A82, H, raw','NGC 0701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19542,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19542,31.64,0.47,21.3,4893,75,NULL,'A82, H, inv','NGC 0701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19543,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19543,31.71,0.32,22,4893,85,NULL,'I, raw','NGC 0701',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19544,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19544,31.73,0.32,22.2,4893,85,NULL,'I, inv','NGC 0701',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19545,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19545,31.78,0.4,22.7,4893,75,NULL,'B','NGC 0701',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19546,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19546,31.8,0.47,22.9,4893,75,NULL,'A82, H, cor','NGC 0701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19547,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19547,31.92,0.4,24.2,4893,NULL,NULL,'mean','NGC 0701',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19548,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19548,31.97,0.43,24.8,4893,75,NULL,'MAT, I, raw','NGC 0701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19549,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19549,32,0.46,25.1,4893,NULL,NULL,'J','NGC 0701',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19550,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19550,32.01,0.45,25.2,4893,NULL,NULL,'K','NGC 0701',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19551,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19551,32.03,0.47,25.5,4893,NULL,NULL,'H','NGC 0701',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19552,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19552,32.08,0.43,26.1,4893,75,NULL,'MAT, I, cor','NGC 0701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19553,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19553,32.11,0.43,26.5,4893,75,NULL,'MAT, I, inv','NGC 0701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19554,'Carbon Stars','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19554,23,0.1,0.398,4894,NULL,NULL,'2','ESO 245- G 007',NULL,'1999AJ....117.2199C',1999,1,4.9,NULL,'G',0.000097,NULL,'13.07',4.1,'IAm',NULL,NULL,NULL,NULL,1,27.776417,-44.44469,NULL,0,38328217398,598878396,9357474,13.07),(19555,'Cepheids','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19555,24.6,NULL,0.832,4894,NULL,18.4,NULL,'ESO 245- G 007',NULL,'1988BAAS...20Q1084C',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19556,'CMD','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19556,23.02,NULL,0.402,4894,NULL,NULL,NULL,'ESO 245- G 007',NULL,'1991AJ....102..130v',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19557,'CMD','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19557,23.1,NULL,0.417,4894,NULL,NULL,NULL,'ESO 245- G 007',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19558,'CMD','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19558,23.1,NULL,0.417,4894,NULL,NULL,NULL,'ESO 245- G 007',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19559,'CMD','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19559,23.21,0.08,0.439,4894,NULL,NULL,NULL,'ESO 245- G 007',NULL,'1999A&A...345..747H',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19560,'CMD','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19560,23.24,0.38,0.445,4894,NULL,NULL,NULL,'ESO 245- G 007',NULL,'1986MmSAI..57..561G',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19561,'CMD','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19561,23.5,0.5,0.5,4894,NULL,18.4,NULL,'ESO 245- G 007',NULL,'1988PASP..100.1405O',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19562,'Horizontal Branch','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19562,23.07,0.15,0.411,4894,NULL,NULL,NULL,'ESO 245- G 007',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19563,'Horizontal Branch','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19563,23.3,NULL,0.457,4894,NULL,NULL,NULL,'ESO 245- G 007',NULL,'2000AJ....120.3060H',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19564,'Miras','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19564,23.1,0.18,0.417,4894,NULL,NULL,NULL,'ESO 245- G 007',NULL,'2008MNRAS.385.1045M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19565,'Red Clump','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19565,22.86,NULL,0.374,4894,NULL,NULL,'V, M RC(V) = +0.73 mag','ESO 245- G 007',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19566,'Red Clump','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19566,23.16,NULL,0.429,4894,NULL,NULL,'I, M RC(I) = -0.50 mag','ESO 245- G 007',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19567,'RR Lyrae','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19567,23.05,NULL,0.407,4894,NULL,NULL,NULL,'ESO 245- G 007',NULL,'2008ApJ...679...52T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19568,'TRGB','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19568,22.77,0.1,0.358,4894,NULL,NULL,NULL,'ESO 245- G 007',NULL,'1999AJ....117.2199C',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19569,'TRGB','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19569,23,0.1,0.398,4894,NULL,NULL,NULL,'ESO 245- G 007',NULL,'1999AJ....117.2199C',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19570,'TRGB','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19570,23,0.1,0.398,4894,NULL,NULL,'I','ESO 245- G 007',NULL,'1999AJ....118..862M',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19571,'TRGB','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19571,23.04,0.07,0.406,4894,NULL,NULL,NULL,'ESO 245- G 007',NULL,'1999A&A...345..747H',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19572,'TRGB','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19572,23.06,0.12,0.409,4894,NULL,NULL,NULL,'ESO 245- G 007',NULL,'2012MNRAS.424.1113B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19573,'TRGB','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19573,23.07,0.12,0.411,4894,NULL,NULL,'Z','ESO 245- G 007',NULL,'2012MNRAS.424.1113B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19574,'TRGB','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19574,23.09,0.1,0.415,4894,NULL,NULL,NULL,'ESO 245- G 007',NULL,'2009ApJ...705..704H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19575,'TRGB','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19575,23.11,NULL,0.419,4894,NULL,NULL,NULL,'ESO 245- G 007',NULL,'2000AJ....120.3060H',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19576,'TRGB','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19576,23.13,0.06,0.42,4894,74.4,NULL,NULL,'ESO 245- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19577,'TRGB','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19577,23.12,0.12,0.421,4894,NULL,NULL,'Z','ESO 245- G 007',NULL,'2012MNRAS.424.1113B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19578,'TRGB','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19578,23.21,NULL,0.439,4894,NULL,NULL,'I, M TRGB(I) = -4.05 mag','ESO 245- G 007',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19579,'TRGB','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19579,23.24,0.08,0.445,4894,NULL,NULL,'I','ESO 245- G 007',NULL,'1991AJ....102..130v',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19580,'Type II Cepheids','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19580,23.15,0.16,0.427,4894,NULL,NULL,'11','ESO 245- G 007',NULL,'2014MNRAS.437.2307R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19581,'Quasar spectrum','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19581,42.86,NULL,3740,4895,NULL,NULL,NULL,'UM 674',NULL,'2002A&A...381L..57D',2002,1,NULL,NULL,'QSO',NULL,NULL,'18.6',NULL,'Candidate      QSO',NULL,NULL,NULL,'QSO',1,27.777917,-9.53344,0.046,NULL,35112275885,548629310,8572332,18.6),(19582,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19582,35.71,0.74,139,4896,NULL,NULL,NULL,'AGC 110804',NULL,'2009ApJS..182..474S',2009,1,0.41,NULL,'G',0.000033,NULL,'16.43',NULL,'Sc',NULL,NULL,NULL,NULL,1,27.7789583,32.87736,0.141,NULL,67775400325,1058990630,16546728,16.43),(19583,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19583,35.75,0.2,141,4896,74.4,NULL,NULL,'AGC 110804',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19584,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19584,35.84,0.7,147,4896,NULL,NULL,'Malmquist cor.','AGC 110804',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19585,'IRAS','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19585,32.68,0.8,34.4,4897,75,NULL,'W91PP, r','IC 0167',NULL,'1997ApJS..109..333W',1997,1,2.9,NULL,'G',0.000007,NULL,'13.6',1.9,'SAB(s)c','in a radial-velocity based grouping',NULL,NULL,NULL,1,27.785667,21.91281,0.221,NULL,66909977464,1045468397,16335443,13.6),(19586,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19586,31.35,0.43,18.6,4897,75,NULL,'3.6 micron, color + selection bias corrected','IC 0167',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19587,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19587,31.53,0.43,20.2,4897,75,NULL,'3.6 micron, color corrected','IC 0167',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19588,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19588,31.55,0.51,20.4,4897,NULL,NULL,NULL,'IC 0167',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19589,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19589,31.56,0.2,20.5,4897,74.4,NULL,NULL,'IC 0167',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19590,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19590,31.63,0.49,21.2,4897,NULL,NULL,'Malmquist cor.','IC 0167',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19591,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19591,32.24,0.38,28.1,4897,75,NULL,'W91PP, r, inv','IC 0167',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19592,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19592,32.32,0.38,29.1,4897,75,NULL,'W91PP, r, raw','IC 0167',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19593,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19593,32.58,0.38,32.9,4897,75,NULL,'W91PP, r, cor','IC 0167',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19594,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19594,33.64,0.52,53.5,4898,NULL,NULL,NULL,'2MASXi J0151102+323724',NULL,'2009ApJS..182..474S',2009,1,0.62,NULL,'G',0.000067,NULL,'15.58',NULL,'Sb:',NULL,NULL,NULL,NULL,1,27.7925,32.62344,0.141,NULL,67775557608,1058993087,16546766,15.58),(19595,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19595,34.17,0.41,68.2,4898,NULL,NULL,'Malmquist cor.','2MASXi J0151102+323724',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19596,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19596,36.81,0.46,230,4899,70,NULL,NULL,'2MASX J01511152+1417282',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000061,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,27.7979583,14.29131,0.085,NULL,66929965939,1045780717,16340323,17.6),(19597,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19597,37.8,0.46,363,4900,70,NULL,NULL,'2MASX J01511203+1442462',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000082,NULL,'17.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,27.8000417,14.71281,0.101,NULL,66937060387,1045891568,16342055,17.3),(19598,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19598,36.49,0.46,199,4901,70,NULL,NULL,'2MASX J01511284+1455332',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,27.8036666667,14.92575,0.113,NULL,66936943519,1045889742,16342027,16.3),(19599,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,'R',19599,35.93,0.46,154,4902,70,NULL,NULL,'CGCG 386-045',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000112,NULL,'15.3g',0.48,'E0',NULL,NULL,NULL,NULL,1,27.80575,-1.06072,0.021,NULL,35019279552,547176243,8549628,15.3),(19600,'FP','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19600,35.72,0.62,139,4903,70,NULL,NULL,'2MASX J01511367-7625391',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'16.4b',0.22,NULL,NULL,NULL,NULL,NULL,1,27.8067916667,-76.4275,0.225,NULL,35610477254,556413707,8693964,16.4),(19601,'SGRB','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19601,38.73,NULL,557,4904,71,NULL,NULL,'GRB 070724A',NULL,'2010ApJ...709..664R',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,27.8085417,-18.59442,0,NULL,35042183936,547534124,8555220,NULL),(19602,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 16484','RN',19602,41.47,0.31,1570,4905,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16484',0.25664,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19603,'SNIa','2016-12-15 15:13:48','2016-12-16 11:18:51','1','SDSS-II SN 16484','RN',19603,41.56,0.3,1630,4905,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16484',0.25664,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19604,'IRAS','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19604,32.79,0.8,36.2,4906,75,NULL,'W91PP, r','NGC 0674',NULL,'1997ApJS..109..333W',1997,1,4.5,NULL,'G',0.000007,NULL,'12.84',1.5,'SAB(r)c:','in a radial-velocity based grouping',NULL,NULL,NULL,1,27.8232083,22.35797,0.297,NULL,66909922693,1045467542,16335430,12.84),(19605,'IRAS','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19605,32.8,0.8,36.2,4906,75,NULL,'MAT, I','NGC 0674',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19606,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19606,32.34,0.46,29.4,4906,NULL,NULL,'J','NGC 0674',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19607,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19607,32.35,0.47,29.6,4906,NULL,NULL,'H','NGC 0674',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19608,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19608,32.39,0.45,30,4906,NULL,NULL,'K','NGC 0674',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19609,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19609,32.52,0.43,32,4906,75,NULL,'MAT, I, raw','NGC 0674',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19610,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19610,32.56,0.32,32.5,4906,85,NULL,'I, raw','NGC 0674',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19611,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19611,32.57,0.2,32.7,4906,74.4,NULL,NULL,'NGC 0674',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19612,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19612,32.59,0.38,33,4906,75,NULL,'W91PP, r, raw','NGC 0674',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19613,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19613,32.62,0.32,33.4,4906,85,NULL,'I, inv','NGC 0674',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19614,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19614,32.68,0.44,34.3,4906,NULL,NULL,'Malmquist cor.','NGC 0674',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19615,'Tully-Fisher','2016-12-15 15:13:48','2016-12-16 11:18:51','1',NULL,NULL,19615,32.78,0.42,35.9,4906,NULL,NULL,NULL,'NGC 0674',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19616,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19616,32.79,0.43,36.1,4906,75,NULL,'MAT, I, inv','NGC 0674',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19617,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19617,32.81,0.38,36.5,4906,75,NULL,'W91PP, r, inv','NGC 0674',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19618,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19618,32.84,0.4,37.1,4906,NULL,NULL,'mean','NGC 0674',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19619,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19619,32.85,0.38,37.2,4906,75,NULL,'W91PP, r, cor','NGC 0674',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19620,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19620,32.88,0.43,37.6,4906,75,NULL,'MAT, I, cor','NGC 0674',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19621,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19621,34.13,0.1,67.1,4907,NULL,NULL,NULL,'UGC 01316',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000011,NULL,'16.5',0.4,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,27.823167,34.84869,0.117,NULL,67740311017,1058442359,16538161,16.5),(19622,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19622,34.31,0.2,72.8,4907,74.4,NULL,NULL,'UGC 01316',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19623,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19623,34.47,0.43,78.5,4907,75,NULL,'3.6 micron, color corrected','UGC 01316',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19624,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19624,34.67,0.43,85.8,4907,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01316',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19625,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 08850',NULL,19625,41.59,NULL,2080,4908,70,NULL,'SN photometric redshift distance, z photo =0.700 +/- 0.001','SDSS-II SN 08850',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.8g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,27.82875,0.32708,0.077,NULL,66978858509,1046544664,16352260,21.8),(19626,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 08850','R',19626,43.85,0.37,3780,4908,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 08850',0.559147,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19627,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19627,37.35,0.7,295,4909,NULL,NULL,'Malmquist cor.','2MASX J01512108+3303323',NULL,'2009ApJS..182..474S',2009,1,0.36,NULL,'G',0.000043,NULL,'16.05',NULL,'Sc','Group member',NULL,NULL,NULL,1,27.8379583,33.05897,0.153,NULL,67775485493,1058991960,16546749,16.05),(19628,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19628,37.6,0.62,331,4909,NULL,NULL,NULL,'2MASX J01512108+3303323',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19629,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19629,37.64,0.2,337,4909,74.4,NULL,NULL,'2MASX J01512108+3303323',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19630,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19630,36.43,0.41,193,4910,NULL,NULL,'Malmquist cor.','AGC 410956',NULL,'2009ApJS..182..474S',2009,1,0.49,NULL,'G',0.00002,NULL,'18.31',0.12,NULL,NULL,NULL,NULL,NULL,1,27.838125,-2.34669,0.017,NULL,35021142991,547205359,8550083,18.31),(19631,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19631,36.58,0.38,207,4910,NULL,NULL,NULL,'AGC 410956',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19632,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19632,36.62,0.2,211,4910,74.4,NULL,NULL,'AGC 410956',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19633,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19633,35.66,0.25,136,4911,74.4,NULL,NULL,'VI Zw 068',NULL,'2013AJ....146...86T',2013,1,0.44,NULL,'G',0.000025,NULL,'14.61',0.42,'E/S0','Group member',NULL,NULL,NULL,1,27.8387083333,33.18644,0.153,NULL,67775470368,1058991724,16546745,14.61),(19634,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19634,35.84,0.26,147,4911,70,NULL,NULL,'VI Zw 068',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19635,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19635,35.64,0.25,134,4912,74.4,NULL,NULL,'UGC 01318',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000087,NULL,'14.98',0.8,'E:','Group member, 2nd ranked galaxy',NULL,NULL,NULL,1,27.848125,33.03119,0.153,NULL,67775441803,1058991278,16546738,14.98),(19636,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19636,35.84,0.26,147,4912,70,NULL,NULL,'UGC 01318',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19637,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19637,35.86,0.4,149,4912,NULL,NULL,'mean','UGC 01318',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19638,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19638,36.44,0.45,194,4912,NULL,NULL,'K','UGC 01318',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19639,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19639,38.29,0.46,455,4913,70,NULL,NULL,'2MASX J01512573+1506343',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,27.8574166667,15.10967,0.113,NULL,66936912612,1045889259,16342019,17.2),(19640,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19640,36.82,0.46,231,4914,70,NULL,NULL,'2MASX J01512627-0834523',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000114,NULL,'15.9g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,27.859583,-8.58128,0.108,NULL,35108207747,548565746,8571339,15.9),(19641,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19641,34.77,0.27,90.1,4915,70,NULL,NULL,'NGC 0707',NULL,'2015arXiv151105856S',2015,1,1.02,NULL,'G',0.000007,NULL,'14.4g',0.67,'(R\')SAB(s)0-:',NULL,NULL,NULL,NULL,1,27.862917,-8.50536,0.088,NULL,35108210300,548565785,8571340,14.4),(19642,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19642,38.95,0.46,615,4916,70,NULL,NULL,'SDSS J015127.96+130253.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000092,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,27.8665416667,13.04819,0.161,NULL,66931334179,1045802096,16340657,18.6),(19643,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19643,32.96,0.2,39.1,4917,74.4,NULL,NULL,'KUG 0148-067',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.000025,NULL,'15.36',0.6,'SAd pec sp',NULL,NULL,NULL,NULL,1,27.8682083,-6.51661,0.009,NULL,34985063029,546641609,8541275,15.36),(19644,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19644,33.15,0.43,42.6,4917,75,NULL,'3.6 micron, color corrected','KUG 0148-067',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19645,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19645,33.16,0.76,42.9,4917,NULL,NULL,NULL,'KUG 0148-067',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19646,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19646,33.31,0.71,45.9,4917,NULL,NULL,'Malmquist cor.','KUG 0148-067',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19647,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19647,33.34,0.43,46.5,4917,75,NULL,'3.6 micron, color + selection bias corrected','KUG 0148-067',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19648,'IRAS','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19648,34.24,0.8,70.6,4918,75,NULL,'HMCL, I','UGC 01319',NULL,'1997ApJS..109..333W',1997,1,0.9,'MCG notes this as possibly interacting.','G',0.000017,NULL,'14.50',0.6,'Irr','Group member',NULL,NULL,NULL,1,27.8714583,36.06594,0.241,NULL,67742820285,1058481566,16538774,14.5),(19649,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19649,33.14,0.69,42.4,4918,100,NULL,'mid-IR','UGC 01319',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19650,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19650,33.68,0.43,54.5,4918,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01319',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19651,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19651,33.85,0.43,59,4918,75,NULL,'3.6 micron, color corrected','UGC 01319',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19652,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19652,34.05,0.2,64.6,4918,74.4,NULL,NULL,'UGC 01319',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19653,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19653,34.11,0.4,66.5,4918,75,NULL,'HMCL, I, raw','UGC 01319',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19654,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19654,34.17,0.07,68.4,4918,NULL,NULL,NULL,'UGC 01319',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19655,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19655,34.26,0.4,71.2,4918,75,NULL,'HMCL, I, inv','UGC 01319',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19656,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19656,34.28,0.4,71.7,4918,75,NULL,'HMCL, I, cor','UGC 01319',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19657,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19657,34.34,0.4,73.7,4918,NULL,NULL,'mean','UGC 01319',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19658,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19658,34.48,0.47,78.7,4918,NULL,NULL,'H','UGC 01319',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19659,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19659,34.64,0.46,84.8,4918,NULL,NULL,'J','UGC 01319',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19660,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19660,35.29,NULL,114,4919,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01320',NULL,'2010Ap&SS.325..163P',2010,1,1.23,NULL,'G',NULL,NULL,'15.7',0.12,'Sc',NULL,NULL,NULL,NULL,1,27.888167,41.83683,0.273,NULL,67860328386,1060317631,16567462,15.7),(19661,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19661,35.3,NULL,115,4919,NULL,NULL,'Dipole + Quadrupole','UGC 01320',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19662,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19662,35.32,NULL,116,4919,NULL,NULL,'Dipole','UGC 01320',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19663,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19663,35.34,0.49,117,4919,75,NULL,'IR','UGC 01320',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19664,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19664,35.33,NULL,117,4919,NULL,NULL,NULL,'UGC 01320',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19665,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19665,38.47,0.46,495,4920,70,NULL,NULL,'2MASX J01513556-0008131',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000081,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,27.89825,-0.13689,0.061,NULL,34972171495,546440179,8538127,17.5),(19666,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19666,35,0.69,99.9,4921,100,NULL,'mid-IR','UGC 01324',NULL,'2013ApJ...771...88L',2013,1,1.3,NULL,'G',0.000033,NULL,'14.26',0.9,'SBb',NULL,NULL,NULL,NULL,1,27.9010417,19.1035,0.129,NULL,66920768427,1045637006,16338078,14.26),(19667,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19667,35.61,0.47,132,4921,NULL,NULL,'H','UGC 01324',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19668,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19668,35.74,0.4,141,4921,NULL,NULL,'mean','UGC 01324',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19669,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19669,35.76,0.45,142,4921,NULL,NULL,'K','UGC 01324',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19670,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19670,35.81,0.46,145,4921,NULL,NULL,'J','UGC 01324',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19671,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19671,34.26,0.4,71.2,4922,NULL,NULL,'mean','UGC 01325',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000053,NULL,'13.58',1.8,'E','Pair member (points to parent)',NULL,NULL,NULL,1,27.9042083,8.25661,0.121,NULL,67048401516,1047631273,16369238,13.58),(19672,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19672,34.7,0.45,87.3,4922,NULL,NULL,'K','UGC 01325',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19673,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 15696','RN',19673,40.52,0.22,1080,4923,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15696',0.171047,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19674,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 15696','RN',19674,41.31,0.25,1560,4923,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15696',0.171047,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19675,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 16238',NULL,19675,39.94,0.53,973,4924,70,NULL,'SN photometric redshift distance, z photo =0.260 +/- 0.087','SDSS-II SN 16238',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,27.915125,-0.43586,0.049,NULL,35018489543,547163899,8549435,NULL),(19676,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 16238','R',19676,41.19,0.31,1290,4924,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16238',0.335098,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19677,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 16238','R',19677,41.19,0.26,1300,4924,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16238',0.335098,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19678,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 16238',NULL,19678,41.07,0.21,1640,4924,70,NULL,'SALT 2','SDSS-II SN 16238',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19679,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 16238',NULL,19679,41.11,0.21,1670,4924,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16238',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19680,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19680,36.01,0.65,159,4925,70,NULL,NULL,'2MASX J01514011-1447269',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'17.05',0.19,NULL,NULL,NULL,NULL,NULL,1,27.917,-14.79086,0,NULL,35074902835,548045356,8563208,17.05),(19681,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19681,37.61,0.46,333,4926,70,NULL,NULL,'2MASX J01514293+0109039',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000079,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,27.9289583,1.151,0.025,NULL,67034186546,1047409164,16365768,17.3),(19682,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19682,37.02,0.23,253,4927,70,NULL,NULL,'2MASX J01514494+0105439',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000128,NULL,'16.4g',0.3,'NLAGN',NULL,NULL,NULL,'Sy 2',1,27.937125,1.09569,0.025,NULL,67034369487,1047412023,16365812,16.4),(19683,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19683,37.45,0.46,309,4928,70,NULL,NULL,'2MASX J01514520-0914249',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000112,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,27.9385,-9.24031,0.081,NULL,35112112745,548626761,8572293,16.2),(19684,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19684,35.64,0.25,134,4929,74.4,NULL,NULL,'V Zw 129',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000039,NULL,'13.99',0.9,'E/S0',NULL,NULL,NULL,NULL,1,27.93925,33.53739,0.113,NULL,67773357966,1058958718,16546229,13.99),(19685,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19685,35.84,0.26,147,4929,70,NULL,NULL,'V Zw 129',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19686,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19686,36.13,0.37,168,4930,NULL,NULL,NULL,'2MASX J01514608+3311127',NULL,'2009ApJS..182..474S',2009,1,0.26,NULL,'G',0.00003,NULL,'15.80',0.15,'Sc','Group member',NULL,NULL,NULL,1,27.942083,33.18694,0.153,NULL,67775476183,1058991815,16546747,15.8),(19687,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19687,36.17,0.37,171,4930,NULL,NULL,'Malmquist cor.','2MASX J01514608+3311127',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19688,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19688,36.17,0.2,171,4930,74.4,NULL,NULL,'2MASX J01514608+3311127',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19689,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19689,37.37,0.33,299,4931,70,NULL,NULL,'2MASX J01514720+0113359',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,27.9467916667,1.22658,0.025,NULL,67033712018,1047401750,16365652,16.4),(19690,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19690,33.81,0.2,57.8,4932,74.4,NULL,NULL,'UGC 01329',NULL,'2013AJ....146...86T',2013,1,1.9,NULL,'G',0.000017,NULL,'15.61',0.5,'SBcd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,27.947417,18.18742,0.121,NULL,66912936685,1045514635,16336166,15.61),(19691,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SN 2006ob',NULL,19691,36.32,0.16,173,4933,74.2,NULL,'SALT 2','UGC 01333',0.059239,'2010ApJ...716..712A',2010,1,0.8,NULL,'G',0.000114,NULL,'15.1g',0.66,'Sb:',NULL,NULL,NULL,NULL,1,27.952125,0.26383,0.061,NULL,67033406590,1047396977,16365577,15.1),(19692,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SN 2006ob',NULL,19692,37.04,0.31,228,4933,72,NULL,NULL,'UGC 01333',0.0583,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19693,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SN 2006ob',NULL,19693,37.03,0.16,240,4933,70,NULL,'SALT 2','UGC 01333',0.059239,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19694,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SN 2006ob',NULL,19694,36.91,0.09,241,4933,74.4,NULL,NULL,'UGC 01333',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19695,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SN 2006ob',NULL,19695,37.08,0.21,246,4933,73.8,NULL,'SALT 2 (SNANA)','UGC 01333',0.0594,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19696,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SN 2006ob',NULL,19696,37.11,0.14,249,4933,65,NULL,'MLCS17','UGC 01333',0.059239,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19697,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SN 2006ob',NULL,19697,37.11,0.13,250,4933,65,NULL,'MLCS31','UGC 01333',0.059239,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19698,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SN 2006ob',NULL,19698,37.15,0.15,254,4933,65,NULL,'SALT','UGC 01333',0.059239,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19699,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SN 2006ob',NULL,19699,37.19,0.19,259,4933,73.8,NULL,'SALT 2 (SNANA)','UGC 01333',0.0594,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19700,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SN 2006ob',NULL,19700,37.08,0.19,260,4933,72,NULL,'M(H) = -18.317 mag','UGC 01333',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19701,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SN 2006ob',NULL,19701,37.24,0.17,265,4933,65,NULL,'SALT2','UGC 01333',0.059239,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19702,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SN 2006ob',NULL,19702,37.94,0.03,366,4933,70,NULL,'SALT 2','UGC 01333',0.059239,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19703,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19703,32.79,0.43,36.1,4934,75,NULL,'3.6 micron, color + selection bias corrected','KUG 0149-057',NULL,'2014MNRAS.444..527S',2014,1,1.6,NULL,'G',0.000007,NULL,'15',0.5,'SB(s)dm',NULL,NULL,NULL,NULL,1,27.959583,-5.49653,0.035,NULL,35017708533,547151695,8549245,15),(19704,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19704,33.74,0.45,56.1,4935,NULL,NULL,'K','NGC 0706',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000017,NULL,'13.20',1.4,'Sbc?','in a radial-velocity based grouping',NULL,NULL,NULL,1,27.9605417,6.29689,0.153,NULL,67017362389,1047146287,16361660,13.2),(19705,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19705,33.79,0.47,57.2,4935,NULL,NULL,'H','NGC 0706',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19706,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19706,33.83,0.46,58.3,4935,NULL,NULL,'J','NGC 0706',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19707,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19707,34.09,0.4,65.7,4935,NULL,NULL,'mean','NGC 0706',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19708,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19708,36.02,0.78,160,4936,70,NULL,NULL,'ESO 477- G 010',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000033,NULL,'14.63',0.6,'Sc',NULL,NULL,NULL,NULL,1,27.9797917,-24.31664,0,NULL,38386914060,599795532,9371805,14.63),(19709,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19709,35.25,0.65,112,4936,NULL,NULL,'Malmquist cor.','ESO 477- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19710,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19710,35.37,0.61,119,4936,NULL,NULL,NULL,'ESO 477- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19711,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19711,35.41,0.2,121,4936,74.4,NULL,NULL,'ESO 477- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19712,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19712,34.74,0.48,88.6,4937,NULL,NULL,'Malmquist cor.','UGC 01337',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',NULL,NULL,'16.5',0.3,'Sd',NULL,NULL,NULL,NULL,1,27.980417,8.83139,0.129,NULL,67048833018,1047638015,16369343,16.5),(19713,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19713,34.8,0.2,91.2,4937,74.4,NULL,NULL,'UGC 01337',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19714,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19714,34.9,0.45,95.3,4937,NULL,NULL,NULL,'UGC 01337',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19715,'IRAS','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19715,33.51,0.8,50.3,4938,75,NULL,'MAT, I','ESO 414- G 008',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000017,NULL,'15.74',0.7,'SB(s)dm:',NULL,NULL,NULL,NULL,1,27.9851666667,-31.73678,NULL,NULL,38306884951,598545077,9352266,15.74),(19716,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19716,32.04,0.32,25.6,4938,85,NULL,'I, inv','ESO 414- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19717,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19717,32.1,0.32,26.3,4938,85,NULL,'I, raw','ESO 414- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19718,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19718,32.71,0.43,34.8,4938,75,NULL,'MAT, I, inv','ESO 414- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19719,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19719,32.85,0.43,37.1,4938,75,NULL,'MAT, I, raw','ESO 414- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19720,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19720,33.3,0.43,45.7,4938,75,NULL,'MAT, I, cor','ESO 414- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19721,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19721,33.73,0.51,55.8,4938,NULL,NULL,NULL,'ESO 414- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19722,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19722,33.77,0.2,56.8,4938,74.4,NULL,NULL,'ESO 414- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19723,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19723,34.21,0.4,69.6,4938,NULL,NULL,'Malmquist cor.','ESO 414- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19724,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19724,35.51,0.67,127,4939,70,NULL,NULL,'IC 1741',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000083,NULL,'14.5',0.4,'S',NULL,NULL,NULL,NULL,1,27.986375,-16.78803,0,NULL,35088563595,548258806,8566543,14.5),(19725,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19725,34.77,0.27,90.1,4940,70,NULL,NULL,'IC 0170',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000094,NULL,'14.9g',0.58,'E0',NULL,NULL,NULL,NULL,1,27.9896666667,-8.51761,0.093,NULL,35107758322,548558723,8571230,14.9),(19726,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19726,36.51,0.75,201,4941,70,NULL,NULL,'2MASX J01515804-0545211',NULL,'2014MNRAS.445.2677S',2014,1,0.76,NULL,'G',0.00015,NULL,'16.69',0.19,NULL,NULL,NULL,NULL,NULL,1,27.9919166667,-5.75586,0.019,NULL,35014609981,547103280,8548488,16.69),(19727,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19727,37.75,0.46,354,4942,70,NULL,NULL,'SDSS J015158.99-101850.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000065,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,27.9957917,-10.31417,0,NULL,35114611066,548665797,8572903,18.4),(19728,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 15500','R',19728,40.29,0.15,920,4943,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15500',0.240492,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,27.999583,0.30219,0.061,NULL,67033416839,1047397138,16365580,NULL),(19729,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 15500','R',19729,40.58,0.25,1050,4943,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15500',0.240492,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19730,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 13356','RN',19730,42.37,0.13,2230,4944,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13356',0.333331,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19731,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 13356','RN',19731,42.49,0.2,2370,4944,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13356',0.333331,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19732,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19732,33.3,0.2,45.7,4945,74.4,NULL,NULL,'KUG 0149+353',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',NULL,NULL,'16',0.3,'Spiral',NULL,NULL,NULL,NULL,1,28.002,35.63908,0.189,NULL,67743193942,1058487405,16538865,16),(19733,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19733,33.94,0.09,61.5,4945,NULL,NULL,NULL,'KUG 0149+353',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19734,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19734,34.13,0.08,67.1,4946,NULL,NULL,NULL,'KUG 0149+358A',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000029,NULL,'15.6',0.5,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,28.0115,36.13103,0.241,NULL,67742928188,1058483252,16538800,15.6),(19735,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19735,35.56,0.47,129,4947,NULL,NULL,'H','ESO 543- G 020',NULL,'2007A&A...465...71T',2007,1,2.1,NULL,'G',0.000023,NULL,'14.06',0.9,'SAB(rs)b:',NULL,NULL,NULL,NULL,1,28.014,-20.1665,0,NULL,35047497091,547617142,8556517,14.06),(19736,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19736,35.62,0.4,133,4947,NULL,NULL,'mean','ESO 543- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19737,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19737,35.64,0.46,134,4947,NULL,NULL,'J','ESO 543- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19738,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19738,35.65,0.45,135,4947,NULL,NULL,'K','ESO 543- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19739,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19739,36.71,0.56,219,4948,70,NULL,NULL,'2MASX J01520368-1439039',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'16.77',0.24,NULL,NULL,NULL,NULL,NULL,1,28.01525,-14.65106,0,NULL,35075090884,548048295,8563254,16.77),(19740,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 14916',NULL,19740,39.95,0.79,979,4949,70,NULL,'SN photometric redshift distance, z photo =0.262 +/- 0.144','SDSS-II SN 14916',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','23.0g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,28.024375,-1.14169,0.005,NULL,35018967993,547171374,8549552,23),(19741,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 14916',NULL,19741,41.34,0.28,1850,4949,70,NULL,'SALT 2','SDSS-II SN 14916',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19742,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 14916',NULL,19742,41.37,0.28,1880,4949,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14916',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19743,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19743,37.53,0.46,321,4950,70,NULL,NULL,'SDSS J015208.40+145641.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000071,NULL,'18.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,28.0350417,14.94483,0.117,NULL,66929614580,1045775227,16340237,18.2),(19744,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19744,38.28,0.46,453,4951,70,NULL,NULL,'2MASX J01521097+1343051',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000079,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,28.045667,13.71806,0.153,NULL,66929920937,1045780014,16340312,17.5),(19745,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19745,33.78,0.4,57.1,4952,NULL,NULL,'mean','UGC 01336',NULL,'2007A&A...465...71T',2007,1,1.2,'Identification as NGC 0700 in CGCG, MCG, and UGC is wrong.','G',0.000023,NULL,'15.37',0.3,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,28.0529583,36.09742,0.241,NULL,67742924909,1058483201,16538800,15.37),(19746,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19746,34.62,0.45,83.9,4952,NULL,NULL,'K','UGC 01336',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19747,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 18139','RN',19747,41.55,0.39,1370,4953,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18139',0.486492,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19748,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19748,37.37,0.33,299,4954,70,NULL,NULL,'2MASX J01521388+0112597',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000089,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,28.0577916667,1.2165,0.025,NULL,67033837764,1047403715,16365683,16.8),(19749,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19749,37.66,0.46,340,4955,70,NULL,NULL,'2MASX J01521530+0008077',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000085,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,28.063875,0.13558,0.049,NULL,67033380404,1047396568,16365571,17.2),(19750,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 02784',NULL,19750,40.64,0.13,1340,4956,70,NULL,'SN photometric redshift distance, z photo =0.383 +/- 0.030','SDSS-II SN 02784',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,28.07525,-0.04169,0.049,NULL,34972110259,546439222,8538112,NULL),(19751,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 02784','R',19751,41.62,0.27,1510,4956,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02784',0.399991,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19752,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 02784','R',19752,41.74,0.16,1590,4956,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 02784',0.399991,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19753,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 02784',NULL,19753,41.49,0.17,1990,4956,70,NULL,'SALT 2','SDSS-II SN 02784',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19754,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 02784',NULL,19754,41.56,0.17,2050,4956,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 02784',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19755,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 13213','RN',19755,39.44,0.3,700,4957,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13213',0.10251,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19756,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 13213','RN',19756,39.87,0.39,855,4957,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13213',0.10251,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19757,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19757,33.63,0.45,53.2,4958,NULL,NULL,'K','UGC 01339',NULL,'2007A&A...465...71T',2007,1,1.1,'HOLM 048B is a star superposed northeast of center.','G',0.000033,NULL,'14.68',0.9,'SB(r)0+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,28.103417,35.85642,0.189,NULL,67743237375,1058488083,16538876,14.68),(19758,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19758,33.68,0.4,54.5,4958,NULL,NULL,'mean','UGC 01339',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19759,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19759,35.84,0.26,147,4959,70,NULL,NULL,'GIN 103',NULL,'2001MNRAS.321..277C',2001,1,0.43,NULL,'G',0.000063,NULL,'14.33',0.31,'SB0',NULL,NULL,NULL,NULL,1,28.10375,33.50747,0.113,NULL,67773192404,1058956131,16546189,14.33),(19760,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 08569','RN',19760,39.58,0.09,763,4960,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 08569',0.08048,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19761,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 08569','RN',19761,39.89,0.24,881,4960,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 08569',0.08048,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19762,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19762,35.67,0.74,136,4961,70,NULL,NULL,'2MASX J01522758-1803032',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'16.22',0.2,'S',NULL,NULL,NULL,NULL,1,28.115,-18.05097,0,NULL,35086623977,548228499,8566070,16.22),(19763,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19763,34.38,0.23,75.2,4962,74.4,NULL,NULL,'VI Zw 088',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000027,NULL,'15.7',0.2,'S0/a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,28.1357083,36.11528,0.241,NULL,67742893757,1058482714,16538792,15.7),(19764,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19764,34.9,0.26,95.5,4963,NULL,NULL,'B, Hubble-type-TF','ESO 354- G 006',NULL,'2005Ap&SS.298..577R',2005,1,1,'Ratcliffe et al. (1998MNRAS.300..417R) give v = 7592 km/sec.','G',0.000033,NULL,'15.75',0.5,'Sb',NULL,NULL,NULL,NULL,1,28.1367917,-35.83967,NULL,NULL,38299224763,598425386,9350396,15.75),(19765,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19765,35.48,0.53,125,4963,NULL,NULL,'Malmquist cor.','ESO 354- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19766,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19766,35.5,0.52,126,4963,NULL,NULL,NULL,'ESO 354- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19767,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19767,35.54,0.2,128,4963,74.4,NULL,NULL,'ESO 354- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19768,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 08930','RN',19768,38.49,0.21,471,4964,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 08930',0.060015,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19769,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 21034','R',19769,38.59,0.18,472,4965,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007qa','APMUKS(BJ) B014959.77+005952.4',0.11,'2014arXiv1401.3317S',2014,1,0.27,NULL,'G',NULL,NULL,'18.63',0.13,NULL,NULL,NULL,NULL,NULL,1,28.14225,1.24411,0.029,NULL,67033887846,1047404497,16365695,18.63),(19770,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 21034','R',19770,38.68,0.1,491,4965,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007qa','APMUKS(BJ) B014959.77+005952.4',0.11,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19771,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SN 2007qa',NULL,19771,38.48,0.06,497,4965,70,NULL,'SALT 2','APMUKS(BJ) B014959.77+005952.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19772,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SN 2007qa',NULL,19772,38.48,0.06,497,4965,70,NULL,'SALT 2, Malmquist cor.','APMUKS(BJ) B014959.77+005952.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19773,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19773,32.5,0.47,31.6,4966,NULL,NULL,'H','UGC 01344',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.00003,NULL,'13.55',0.8,'(R)SBa','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,28.144583,36.50089,0.241,NULL,67742956231,1058483691,16538807,13.55),(19774,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19774,32.69,0.46,34.6,4966,NULL,NULL,'J','UGC 01344',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19775,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19775,32.75,0.45,35.5,4966,NULL,NULL,'K','UGC 01344',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19776,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19776,33.83,0.4,58.4,4966,NULL,NULL,'mean','UGC 01344',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19777,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 19393','RN',19777,38.67,0.57,479,4967,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 19393',0.130835,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19778,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 19393','RN',19778,38.91,1.29,535,4967,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 19393',0.130835,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19779,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19779,37.9,0.46,380,4968,70,NULL,NULL,'2MASX J01523686-0012305',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000085,NULL,'16.39',0.23,NULL,NULL,NULL,NULL,NULL,1,28.153667,-0.20847,0.053,NULL,35018281131,547160642,8549385,16.39),(19780,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19780,33.85,0.25,58.9,4969,74.4,NULL,NULL,'NGC 0704',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'GPair',0.00002,NULL,NULL,NULL,'DBL SYS','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,28.1575,36.12556,0.241,NULL,67742893974,1058482718,16538792,NULL),(19781,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19781,34.01,0.4,63.2,4969,NULL,NULL,'mean','NGC 0704',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19782,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19782,34.45,0.45,77.6,4969,NULL,NULL,'K','NGC 0704',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19783,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 21780','RN',19783,43.38,0.37,3110,4970,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 21780',0.524665,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19784,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19784,34.08,0.24,65.4,4971,70,NULL,NULL,'NGC 0703',NULL,'2001MNRAS.321..277C',2001,1,1.2,NULL,'G',0.000027,NULL,'14.27',0.9,'S0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,28.165,36.17142,0.241,NULL,67742907643,1058482931,16538795,14.27),(19785,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19785,34.31,0.23,72.8,4971,74.4,NULL,NULL,'NGC 0703',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19786,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19786,36.68,0.46,217,4972,70,NULL,NULL,'2MASX J01524102-0909032',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000077,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,28.1709166667,-9.15094,0.047,NULL,35112107183,548626674,8572291,16.7),(19787,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 17638','RN',19787,42.6,0.31,1950,4973,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17638',0.696649,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19788,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19788,34.93,0.74,96.7,4974,NULL,NULL,'Malmquist cor.','KUG 0150-036A',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000017,NULL,'16.5:',0.2,NULL,NULL,NULL,NULL,NULL,1,28.173375,-3.424,0.064,NULL,35028882318,547326286,8551973,16.5),(19789,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19789,35.12,0.67,106,4974,NULL,NULL,NULL,'KUG 0150-036A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19790,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19790,35.16,0.2,108,4974,74.4,NULL,NULL,'KUG 0150-036A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19791,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19791,34.33,0.5,73.5,4975,NULL,NULL,'Malmquist cor.','KUG 0150-036B',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000027,NULL,'16:',0.2,'Spiral',NULL,NULL,NULL,NULL,1,28.186417,-3.39872,0.064,NULL,35028951116,547327361,8551990,16),(19792,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19792,34.38,0.49,75,4975,NULL,NULL,NULL,'KUG 0150-036B',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19793,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19793,34.42,0.2,76.6,4975,74.4,NULL,NULL,'KUG 0150-036B',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19794,'GCLF','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19794,34.14,0.25,67.3,4976,NULL,NULL,NULL,'NGC 0708',NULL,'1998ApJ...499..577L',1998,1,3,NULL,'G',0.000053,NULL,'13.70',2.5,'cD;E           Sy2','Group member, radial-velocity confirmed',NULL,'radio jet',NULL,1,28.1936666667,36.15183,0.241,NULL,67742907171,1058482924,16538795,13.7),(19795,'GCLF','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19795,34.17,0.17,68.2,4976,NULL,NULL,NULL,'NGC 0708',NULL,'2002ApJ...567..294O',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19796,'SBF','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19796,33.77,0.19,56.8,4976,NULL,NULL,'I','NGC 0708',NULL,'1998ApJ...499..577L',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19797,'SBF','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19797,33.83,0.2,58.3,4976,NULL,NULL,'I','NGC 0708',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19798,'SBF','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19798,33.99,0.2,62.8,4976,NULL,NULL,NULL,'NGC 0708',NULL,'2001ApJ...550..503J',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19799,'SBF','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19799,34.22,0.22,69.8,4976,NULL,NULL,'HST KP Calibrated, F814W','NGC 0708',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19800,'D-Sigma','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19800,33.62,0.4,53,4976,75,NULL,'Edat, raw','NGC 0708',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19801,'D-Sigma','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19801,33.74,0.4,56,4976,75,NULL,'Edat, cor','NGC 0708',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19802,'D-Sigma','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19802,33.93,0.16,61.1,4976,72,NULL,'ABELL 0262 cluster, 8 galaxies','NGC 0708',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19803,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19803,34.02,0.13,63.8,4976,75,NULL,'ABELL 0262 cluster, 10 galaxies','NGC 0708',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19804,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19804,34.02,0.13,63.8,4976,75,NULL,'ABELL 0262 cluster, 10 galaxies','NGC 0708',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19805,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19805,34.08,0.24,65.4,4976,70,NULL,NULL,'NGC 0708',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19806,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19806,34.26,0.22,71.1,4976,74.4,NULL,NULL,'NGC 0708',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19807,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19807,34.12,NULL,66.7,4976,71,NULL,'ABELL 0262, 80 galaxies','NGC 0708',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19808,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19808,34.18,0.3,68.7,4976,NULL,NULL,'ABELL 0262, 22 galaxies','NGC 0708',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19809,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19809,34.34,0.16,73.8,4976,70,NULL,'ABELL 0262 Cluster','NGC 0708',NULL,'1992ApJ...396..453H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19810,'GCLF','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19810,34.14,0.25,67.3,4977,NULL,NULL,'NGC 0708','ABELL 0262',NULL,'1998ApJ...499..577L',1998,1,NULL,NULL,'GClstr',0.00027,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,28.195,36.15139,0.241,NULL,67742907344,1058482927,16538795,NULL),(19811,'SBF','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19811,33.77,0.19,56.8,4977,NULL,NULL,'NGC 0708','ABELL 0262',NULL,'1998ApJ...499..577L',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19812,'SBF','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19812,34.22,0.22,69.8,4977,NULL,NULL,'HST KP Calibrated, F814W','ABELL 0262',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19813,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19813,38.2,0.46,437,4978,70,NULL,NULL,'2MASX J01524751+1402155',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000092,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,28.1979583,14.03778,0.161,NULL,66930563155,1045790049,16340469,17.5),(19814,'IRAS','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19814,34.02,0.8,63.6,4979,75,NULL,'MAT, I','MCG -01-05-047',NULL,'1997ApJS..109..333W',1997,1,3.25,'Incorrectly called NGC 6966 in 2008A&A...482..113M.','G',0.00003,NULL,'13.4r',0.37,'SA(s)c? sp     HII?',NULL,NULL,NULL,NULL,1,28.204167,-3.44683,0.064,NULL,35028884634,547326322,8551973,13.4),(19815,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19815,33.78,0.47,57,4979,NULL,NULL,'H','MCG -01-05-047',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19816,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19816,33.81,0.45,57.8,4979,NULL,NULL,'K','MCG -01-05-047',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19817,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19817,33.83,0.46,58.3,4979,NULL,NULL,'J','MCG -01-05-047',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19818,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19818,33.92,0.49,60.8,4979,75,NULL,'IR','MCG -01-05-047',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19819,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19819,33.96,0.43,61.9,4979,75,NULL,'MAT, I, raw','MCG -01-05-047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19820,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19820,34.11,0.43,66.3,4979,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-05-047',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19821,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19821,34.15,0.4,67.5,4979,NULL,NULL,'mean','MCG -01-05-047',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19822,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19822,34.15,0.43,67.6,4979,75,NULL,'MAT, I, cor','MCG -01-05-047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19823,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19823,34.19,0.43,68.9,4979,75,NULL,'3.6 micron, color corrected','MCG -01-05-047',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19824,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19824,34.23,0.32,70,4979,85,NULL,'I, raw','MCG -01-05-047',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19825,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19825,34.26,0.43,71.2,4979,75,NULL,'MAT, I, inv','MCG -01-05-047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19826,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19826,34.3,0.32,72.5,4979,85,NULL,'I, inv','MCG -01-05-047',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19827,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19827,34.32,0.2,73.1,4979,74.4,NULL,NULL,'MCG -01-05-047',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19828,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19828,34.34,NULL,73.9,4979,NULL,NULL,'Dipole','MCG -01-05-047',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19829,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19829,34.35,NULL,74.2,4979,NULL,NULL,'Dipole + Quadrupole','MCG -01-05-047',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19830,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19830,34.36,NULL,74.5,4979,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -01-05-047',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19831,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19831,34.37,0.29,75,4979,NULL,NULL,'Malmquist cor.','MCG -01-05-047',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19832,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19832,34.49,0.28,79,4979,NULL,NULL,NULL,'MCG -01-05-047',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19833,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19833,37.12,0.46,265,4980,70,NULL,NULL,'2MASX J01524921-0100055',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000115,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,28.205125,-1.00169,0.041,NULL,35018897697,547170276,8549535,16.2),(19834,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 02238','RN',19834,40.25,0.75,1060,4981,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02238',0.059749,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19835,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 02238','RN',19835,42.01,0.51,2380,4981,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02238',0.059749,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19836,'SZ effect','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19836,38.89,0.37,600,4982,NULL,NULL,'Hydrost. Eq.','ABELL 0267',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'Medium compact [Zw]',NULL,NULL,NULL,NULL,1,28.21775,1.04606,0.033,NULL,67033788628,1047402947,16365671,NULL),(19837,'SZ effect','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19837,39.95,NULL,978,4982,NULL,NULL,'3.1 (red) calibration','ABELL 0267',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19838,'SZ effect','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19838,40.04,NULL,1020,4982,NULL,NULL,'4.2 (black) calibration','ABELL 0267',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19839,'SZ effect','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19839,40.25,NULL,1120,4982,NULL,NULL,'4.1 (blue) calibration','ABELL 0267',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19840,'SZ effect','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19840,40.27,0.6,1130,4982,NULL,NULL,'Isotherm.','ABELL 0267',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19841,'SZ effect','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19841,40.28,0.65,1140,4982,NULL,NULL,'Isotherm., r < 100 kpc','ABELL 0267',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19842,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19842,39.26,0.46,711,4983,70,NULL,NULL,'SDSS J015251.99+134813.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000092,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,28.216667,13.80378,0.153,NULL,66929946060,1045780407,16340318,18.3),(19843,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 18307',NULL,19843,41.43,0.14,1930,4984,70,NULL,'SN photometric redshift distance, z photo =0.626 +/- 0.063','SDSS-II SN 18307',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.1g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,28.2202083,0.83386,0.033,NULL,67033762456,1047402538,16365664,21.1),(19844,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19844,32.76,0.43,35.7,4985,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0710',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.000023,NULL,'14.27',1.2,'Scd:','Group member',NULL,NULL,NULL,1,28.22475,36.05289,0.241,NULL,67743022824,1058484731,16538823,14.27),(19845,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19845,36.87,0.46,236,4986,70,NULL,NULL,'2MASX J01525680+0104052',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000066,NULL,'17.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,28.2367083333,1.06825,0.033,NULL,67033791813,1047402997,16365671,17.4),(19846,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19846,34.07,0.47,65.2,4987,NULL,NULL,'H','UGC 01350',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.00003,NULL,'14.21',1.2,'SB(r)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,28.239417,36.51289,0.241,NULL,67742944513,1058483508,16538804,14.21),(19847,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19847,34.14,0.46,67.3,4987,NULL,NULL,'J','UGC 01350',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19848,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19848,34.19,0.45,68.8,4987,NULL,NULL,'K','UGC 01350',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19849,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19849,34.3,0.4,72.4,4987,NULL,NULL,'mean','UGC 01350',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19850,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19850,36.07,0.51,163,4988,70,NULL,NULL,'IC 1745',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.00015,NULL,'16.15',0.32,NULL,NULL,NULL,NULL,NULL,1,28.2462083,-16.669,0,NULL,35094266564,548347915,8567936,16.15),(19851,'IRAS','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19851,33.76,0.8,56.6,4989,75,NULL,'A82, H','NGC 0716',NULL,'1997ApJS..109..333W',1997,1,1.73,NULL,'G',0.000017,NULL,'13.7g',0.6,'SBa:           HII','Group member',NULL,NULL,NULL,1,28.248667,12.70847,0.133,NULL,66930991969,1045796749,16340574,13.7),(19852,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19852,33.21,0.33,43.7,4989,91,NULL,'H','NGC 0716',NULL,'1984ApJ...278..475B',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19853,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19853,33.54,0.45,51.2,4989,NULL,NULL,'K','NGC 0716',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19854,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19854,33.62,0.47,53,4989,NULL,NULL,'H','NGC 0716',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19855,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19855,33.64,0.47,53.4,4989,75,NULL,'A82, H, raw','NGC 0716',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19856,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19856,33.75,0.46,56.2,4989,NULL,NULL,'J','NGC 0716',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19857,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19857,33.82,0.42,58,4989,NULL,NULL,NULL,'NGC 0716',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19858,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19858,33.83,0.42,58.3,4989,NULL,NULL,'Malmquist cor.','NGC 0716',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19859,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19859,33.83,0.47,58.3,4989,75,NULL,'A82, H, inv','NGC 0716',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19860,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19860,33.88,0.4,59.7,4989,NULL,NULL,'mean','NGC 0716',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19861,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19861,33.89,0.2,60,4989,74.4,NULL,NULL,'NGC 0716',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19862,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19862,33.96,0.47,62,4989,75,NULL,'A82, H, cor','NGC 0716',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19863,'GCLF','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19863,31.35,0.35,18.6,4990,NULL,NULL,NULL,'NGC 0720',NULL,'1996A&A...308..704K',1996,1,4.7,NULL,'G',0.000022,NULL,'11.16',2.4,'E5','X-ray-bright group member',NULL,NULL,NULL,1,28.252083,-13.73867,0,NULL,35075535765,548055246,8563363,11.16),(19864,'SBF','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19864,31.91,0.17,24.1,4990,NULL,NULL,'I','NGC 0720',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19865,'SBF','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19865,31.92,0.24,24.2,4990,NULL,NULL,'K','NGC 0720',NULL,'2001A&A...376..793M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19866,'SBF','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19866,31.92,0.24,24.2,4990,NULL,NULL,'K, MK = -6.14 mag','NGC 0720',NULL,'2001A&A...376..793M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19867,'SBF','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19867,32.17,0.14,27.2,4990,74.4,NULL,NULL,'NGC 0720',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19868,'SBF','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19868,32.2,0.17,27.6,4990,NULL,NULL,'Malmquist cor.','NGC 0720',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19869,'SBF','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19869,32.21,0.17,27.7,4990,NULL,NULL,NULL,'NGC 0720',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19870,'D-Sigma','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19870,31.75,0.4,22.4,4990,75,NULL,'Edat, raw','NGC 0720',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19871,'D-Sigma','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19871,32.08,0.4,26.1,4990,75,NULL,'Edat, cor','NGC 0720',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19872,'Faber-Jackson','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19872,31.03,0.37,16.1,4990,95,NULL,'de Vaucouleurs','NGC 0720',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19873,'Faber-Jackson','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19873,31.09,0.26,16.5,4990,95,NULL,'Weighted Mean','NGC 0720',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19874,'Faber-Jackson','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19874,31.09,0.63,16.5,4990,95,NULL,'Michard 1979b, c','NGC 0720',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19875,'Faber-Jackson','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19875,31.36,0.46,18.7,4990,95,NULL,'Michard 1979a','NGC 0720',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19876,'Faber-Jackson','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19876,31.99,NULL,25,4990,NULL,NULL,'LEDA [April 2006]','NGC 0720',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19877,'Faber-Jackson','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19877,32.71,0.81,34.8,4990,55,NULL,'Visvanathan & Sandage 1979','NGC 0720',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19878,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19878,31.89,0.41,23.9,4990,NULL,NULL,NULL,'NGC 0720',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19879,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19879,31.97,0.41,24.8,4990,NULL,NULL,'Malmquist cor.','NGC 0720',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19880,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19880,32.44,0.61,30.7,4990,70,NULL,NULL,'NGC 0720',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19881,'Tertiary','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19881,31.24,0.22,17.7,4990,95,NULL,NULL,'NGC 0720',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19882,'Tully est','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19882,31.53,0.8,20.3,4990,75,NULL,'B','NGC 0720',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19883,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19883,31.65,0.4,21.4,4990,NULL,NULL,'mean','NGC 0720',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19884,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19884,31.84,0.45,23.3,4990,NULL,NULL,'K','NGC 0720',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19885,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 06631','RN',19885,39.08,0.4,617,4991,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06631',0.060741,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19886,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19886,36.5,0.8,200,4992,70,NULL,NULL,'2MASX J01530313-1856422',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'16.99',0.23,NULL,NULL,NULL,NULL,NULL,1,28.2630416667,-18.94497,0,NULL,35044393751,547568652,8555760,16.99),(19887,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19887,36.57,0.73,206,4993,70,NULL,NULL,'2MASX J01530334-1844452',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00015,NULL,'16.83',0.3,NULL,NULL,NULL,NULL,NULL,1,28.263875,-18.74597,0,NULL,35043618432,547556538,8555570,16.83),(19888,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19888,34.95,0.96,97.6,4994,NULL,NULL,'Malmquist cor.','2MASX J01530484-0334099',NULL,'2009ApJS..182..474S',2009,1,0.58,NULL,'G',0.00015,NULL,'16.32',0.32,NULL,NULL,NULL,NULL,NULL,1,28.270125,-3.56961,0.09,NULL,35015202594,547112540,8548633,16.32),(19889,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19889,35.37,0.79,119,4994,NULL,NULL,NULL,'2MASX J01530484-0334099',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19890,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19890,35.41,0.2,121,4994,74.4,NULL,NULL,'2MASX J01530484-0334099',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19891,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 03520','RN',19891,43.55,0.23,3630,4995,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03520',0.409769,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19892,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 03520','RN',19892,44.1,0.22,4690,4995,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03520',0.409769,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19893,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 01008','R',19893,40.17,0.21,882,4996,70,NULL,'SDSS CAND. zSNIa; SALT 2; SN 2005il','SDSS J015306.70+010649.6',0.226191,'2014arXiv1401.3317S',2014,1,0.09,NULL,'G',NULL,NULL,'21.0g',0.04,NULL,NULL,NULL,NULL,NULL,1,28.277917,1.11381,0.033,NULL,67033779919,1047402811,16365668,21),(19894,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 01008','R',19894,40.33,0.15,948,4996,70,NULL,'SDSS CAND. zSNIa; MLCS2K2; SN 2005il','SDSS J015306.70+010649.6',0.226191,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19895,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19895,37.02,0.23,253,4997,70,NULL,NULL,'2MASX J01530827+0101502',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.5g',0.37,'AGN',NULL,NULL,NULL,NULL,1,28.2845417,1.03075,0.033,NULL,67033785433,1047402897,16365670,16.5),(19896,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19896,34.08,0.24,65.4,4998,70,NULL,NULL,'NGC 0712',NULL,'2001MNRAS.321..277C',2001,1,1.3,NULL,'G',0.000067,NULL,'13.77',1,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,28.285167,36.81986,0.201,NULL,67745663359,1058525989,16539468,13.77),(19897,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19897,34.12,0.23,66.7,4998,74.4,NULL,NULL,'NGC 0712',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19898,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19898,34.33,0.4,73.4,4998,NULL,NULL,'mean','NGC 0712',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19899,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19899,34.39,0.45,75.4,4998,NULL,NULL,'K','NGC 0712',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19900,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 15237',NULL,19900,40.16,0.37,1080,4999,70,NULL,'SN photometric redshift distance, z photo =0.293 +/- 0.068','SDSS-II SN 15237',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,28.29125,-0.93236,0.041,NULL,35001864418,546904131,8545377,NULL),(19901,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19901,31.14,NULL,16.9,5000,NULL,NULL,NULL,'FGC 0202',NULL,'2000BSAO...50....5K',2000,1,1.12,NULL,'G',0.000027,NULL,'17.74',0.15,'Sdm',NULL,NULL,NULL,NULL,1,28.292083,20.67306,0.213,NULL,66922003671,1045656307,16338379,17.74),(19902,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19902,31.96,NULL,24.7,5000,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0202',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19903,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19903,31.99,NULL,25,5000,NULL,NULL,'Dipole + Quadrupole','FGC 0202',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19904,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19904,32.02,NULL,25.3,5000,NULL,NULL,'Dipole','FGC 0202',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19905,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 03998','RN',19905,41.35,0.15,1290,5001,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03998',0.446146,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19906,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 03998','RN',19906,41.84,0.21,1610,5001,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03998',0.446146,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19907,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 15163','RN',19907,39.07,0.09,575,5002,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 15163',0.134712,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19908,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 15163','RN',19908,39.31,0.18,642,5002,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 15163',0.134712,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19909,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19909,34.17,0.45,68.3,5003,NULL,NULL,'K','ESO 197- G 010',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000063,NULL,'13.46',1.2,'E',NULL,NULL,NULL,NULL,1,28.3025,-49.56036,NULL,NULL,38229899345,597342177,9333471,13.46),(19910,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19910,34.69,0.4,86.8,5003,NULL,NULL,'mean','ESO 197- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19911,'Tully est','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19911,31.65,0.8,21.4,5004,75,NULL,'B','NGC 0718',NULL,'1988NBGC.C....0000T',1988,1,2.3,NULL,'G',0.000033,NULL,'12.59',2,'SAB(s)a','Isolated galaxy',NULL,NULL,NULL,1,28.305417,4.19583,0.073,NULL,67027903025,1047310984,16364234,12.59),(19912,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 21266','R',19912,39.69,0.23,699,5005,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 21266',0.242229,'2014arXiv1401.3317S',2014,1,0.12,NULL,'G',NULL,'PHOT','20.1g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,28.308125,-1.20111,0,NULL,35018788230,547168566,8549508,20.1),(19913,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 21266',NULL,19913,40.23,0.28,1110,5005,70,NULL,'SN photometric redshift distance, z photo =0.304 +/- 0.051','SDSS-II SN 21266',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19914,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 11241','RN',19914,38.24,0.32,408,5006,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 11241',0.089238,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19915,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 11241','RN',19915,38.46,0.16,451,5006,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 11241',0.089238,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19916,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19916,37.02,0.23,253,5007,70,NULL,NULL,'2MASX J01531521+0102203',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000102,NULL,'15.7g',0.5,'cD;BrClG       XBONG',NULL,NULL,NULL,NULL,1,28.3135,1.03908,0.033,NULL,67000449170,1046882018,16357531,15.7),(19917,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19917,37.02,0.23,253,5008,70,NULL,NULL,'2MASX J01531521+0102203',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000102,NULL,'15.7g',0.5,'cD;BrClG       XBONG',NULL,NULL,NULL,NULL,1,28.3135,1.03908,0.033,NULL,67000449170,1046882018,16357531,15.7),(19918,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 18468','R',19918,38.86,0.15,522,5009,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 18468',0.131963,'2014arXiv1401.3317S',2014,1,0.12,NULL,'G',NULL,'PHOT','20.7g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,28.329,0.89919,0.025,NULL,67000458769,1046882168,16357533,20.7),(19919,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 18468','R',19919,38.98,0.22,553,5009,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 18468',0.131963,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19920,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 18468',NULL,19920,39.13,0.29,671,5009,70,NULL,'SN photometric redshift distance, z photo =0.171 +/- 0.027','SDSS-II SN 18468',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19921,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19921,37.87,0.23,376,5010,70,NULL,NULL,'SDSS J015321.48+143555.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000085,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,28.3395416667,14.59881,0.137,NULL,66929713713,1045776776,16340262,18.1),(19922,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19922,35.53,0.49,128,5011,75,NULL,'IR','UGC 01357',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'15.29',0.2,'Sa',NULL,NULL,NULL,NULL,1,28.341917,19.95364,0.201,NULL,66924042918,1045688170,16338877,15.29),(19923,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19923,35.62,0.4,133,5011,NULL,NULL,'mean','UGC 01357',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19924,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19924,35.77,0.47,143,5011,NULL,NULL,'H','UGC 01357',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19925,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19925,35.81,0.45,145,5011,NULL,NULL,'K','UGC 01357',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19926,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19926,35.96,0.46,155,5011,NULL,NULL,'J','UGC 01357',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19927,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19927,34.17,0.25,68.2,5012,74.4,NULL,NULL,'UGC 01353',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000077,NULL,'14.14',1,'S0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,28.3456666667,36.95514,0.201,NULL,67745660687,1058525948,16539467,14.14),(19928,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 14972','RN',19928,42.09,0.29,2080,5013,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14972',0.255584,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19929,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 14972','RN',19929,42.34,0.34,2340,5013,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14972',0.255584,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19930,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19930,38.05,0.46,408,5014,70,NULL,NULL,'2MASX J01532434-0037488',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000096,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,28.3514583,-0.63022,0.041,NULL,35002394217,546912409,8545506,17.4),(19931,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 16164','RN',19931,43.8,0.29,4120,5015,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 16164',0.392665,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19932,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 16164','RN',19932,43.89,0.35,4310,5015,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 16164',0.392665,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19933,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19933,37.87,0.23,376,5016,70,NULL,NULL,'2MASX J01532595+1432078',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,'FoF','16.4r',0.19,NULL,NULL,NULL,NULL,NULL,1,28.3581666667,14.53561,0.161,NULL,66929748304,1045777317,16340270,16.4),(19934,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19934,34.49,NULL,79.2,5017,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0205',NULL,'2010Ap&SS.325..163P',2010,1,1.06,NULL,'G',0.000043,NULL,'16.40',0.1,'Sdm',NULL,NULL,NULL,NULL,1,28.382083,18.385,0.105,NULL,66920176977,1045627765,16337933,16.4),(19935,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19935,34.52,NULL,80.1,5017,NULL,NULL,'Dipole','FGC 0205',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19936,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19936,34.53,NULL,80.4,5017,NULL,NULL,'Dipole + Quadrupole','FGC 0205',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19937,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19937,34.58,NULL,82.4,5017,NULL,NULL,NULL,'FGC 0205',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19938,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 00932','RN',19938,41.45,0.26,1400,5018,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 00932',0.391335,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19939,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 00932','RN',19939,41.82,0.39,1660,5018,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 00932',0.391335,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19940,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 07680',NULL,19940,39.86,0.6,937,5019,70,NULL,'SN photometric redshift distance, z photo =0.249 +/- 0.096','SDSS-II SN 07680',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.5g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,28.385,0.98253,0.025,NULL,67000445484,1046881960,16357530,21.5),(19941,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 07680','R',19941,41.5,0.32,1440,5019,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07680',0.37894,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19942,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 07680','R',19942,41.67,0.37,1560,5019,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07680',0.37894,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19943,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 07680',NULL,19943,41.55,0.24,2040,5019,70,NULL,'SALT 2','SDSS-II SN 07680',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19944,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 07680',NULL,19944,41.61,0.24,2100,5019,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 07680',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19945,'CMD','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'N',19945,16.02,NULL,0.016,5020,NULL,NULL,NULL,'Eridanus-Phoenix overdensity',NULL,'2016ApJ...817..135L',2016,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19946,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19946,36.86,0.46,235,5021,70,NULL,NULL,'2MASX J01533748+1402217',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.0001,NULL,'16.3g',0.39,'E0',NULL,NULL,NULL,NULL,1,28.4061666667,14.03944,0.145,NULL,66930575639,1045790244,16340472,16.3),(19947,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19947,37.46,0.33,311,5022,70,NULL,NULL,'2MASX J01533923+0015473',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000076,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,28.4135,0.26317,0.025,NULL,67000070965,1046876108,16357439,17.1),(19948,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19948,36.68,0.19,216,5023,70,NULL,NULL,'2MASX J01534374-0940197',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000082,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,28.432083,-9.67231,0.05,NULL,35110857004,548607140,8571986,16.5),(19949,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19949,37.46,0.33,311,5024,70,NULL,NULL,'2MASX J01534416+0015273',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,28.433917,0.25756,0.025,NULL,67000063362,1046875990,16357437,17.6),(19950,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19950,37.07,0.33,259,5025,70,NULL,NULL,'2MASX J01534632+1252502',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'17.28',0.45,NULL,NULL,NULL,NULL,NULL,1,28.4430416667,12.88047,0.125,NULL,66932102064,1045814094,16340845,17.28),(19951,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 14113','R',19951,39.88,0.22,762,5026,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14113',0.242319,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,'PHOT','20.7g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,28.4445,-0.81842,0.033,NULL,35001898586,546904665,8545385,20.7),(19952,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 14113',NULL,19952,39.59,0.22,827,5026,70,NULL,'SN photometric redshift distance, z photo =0.216 +/- 0.027','SDSS-II SN 14113',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19953,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 14113','R',19953,40.06,0.14,827,5026,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14113',0.242319,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19954,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 14113',NULL,19954,39.68,0.11,863,5026,70,NULL,'SALT 2','SDSS-II SN 14113',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19955,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 14113',NULL,19955,39.7,0.11,871,5026,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14113',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19956,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19956,33.97,0.25,62.2,5027,74.4,NULL,NULL,'CGCG 522-048',NULL,'2013AJ....146...86T',2013,1,0.2,NULL,'G',0.00002,NULL,'15.3',0.2,'E?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,28.458917,36.35028,0.241,NULL,67742864357,1058482255,16538785,15.3),(19957,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19957,34.13,0.11,67.1,5028,NULL,NULL,NULL,'CGCG 522-049',NULL,'2009ApJS..182..474S',2009,1,0.8,'The UZC has the redshift for UGC 01361 on this galaxy.','G',0.000031,NULL,'15.3',0.6,'SBd','Group member',NULL,NULL,NULL,1,28.461167,36.56419,0.201,NULL,67745719611,1058526868,16539482,15.3),(19958,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19958,36.64,0.56,213,5029,70,NULL,NULL,'2MASX J01535244-2143136',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'16.34',0.4,'S0',NULL,NULL,NULL,NULL,1,28.4686666667,-21.72061,0,NULL,35032015693,547375245,8552738,16.34),(19959,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19959,34.02,0.2,63.7,5030,74.4,NULL,NULL,'UGC 01361',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000013,NULL,'15.7',0.4,'Scd:','Group member',NULL,NULL,NULL,1,28.4725,36.58508,0.201,NULL,67745719618,1058526869,16539482,15.7),(19960,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19960,34.13,0.11,67.1,5030,NULL,NULL,NULL,'UGC 01361',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19961,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 20718','R',19961,38.75,0.19,517,5031,70,NULL,'SDSS CAND. Unknown; SALT 2; SN 2007rj','SN 2007rj',0.088795,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,28.49525,-0.09267,0.053,NULL,35001628687,546900448,8545319,NULL),(19962,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 20718','R',19962,38.82,0.13,534,5031,70,NULL,'SDSS CAND. Unknown; MLCS2K2; SN 2007rj','SN 2007rj',0.088795,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19963,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19963,36.68,0.19,216,5032,70,NULL,NULL,'2MASX J01535890-0947173',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000103,NULL,'16.3g',0.4,NULL,NULL,NULL,NULL,NULL,1,28.4955,-9.78817,0.05,NULL,35111319437,548614366,8572099,16.3),(19964,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19964,36.88,0.46,238,5033,70,NULL,NULL,'2MASX J01540211+1235002',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000067,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,28.508833,12.58336,0.117,NULL,66930968116,1045796376,16340568,17.5),(19965,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19965,34.07,0.2,65.2,5034,74.4,NULL,NULL,'UGC 01364',NULL,'2013AJ....146...86T',2013,1,0.84,NULL,'G',0.000058,NULL,'16.0g',0.5,'SBcd:',NULL,NULL,NULL,NULL,1,28.515333,14.90953,0.137,NULL,66960140137,1046252189,16347690,16),(19966,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19966,34.4,0.6,75.7,5034,NULL,NULL,'Malmquist cor.','UGC 01364',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19967,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19967,34.5,0.57,79.5,5034,NULL,NULL,NULL,'UGC 01364',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19968,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19968,37.07,0.33,259,5035,70,NULL,NULL,'2MASX J01540547+1247592',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000084,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,28.522917,12.79975,0.125,NULL,66932098197,1045814034,16340844,16.9),(19969,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 01470','RN',19969,39.53,0.07,741,5036,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01470',0.087735,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19970,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 01470','RN',19970,39.84,0.24,854,5036,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01470',0.087735,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19971,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19971,36.68,0.19,216,5037,70,NULL,NULL,'2MASX J01540614-0941483',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00008,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,28.525583,-9.69669,0.05,NULL,35110851252,548607050,8571985,16.8),(19972,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 14522','R',19972,41.99,0.3,1740,5038,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14522',0.438058,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,28.5287083,-0.72564,0.033,NULL,35002414996,546912734,8545511,NULL),(19973,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 14522',NULL,19973,41.4,0.1,1910,5038,70,NULL,'SN photometric redshift distance, z photo =0.615 +/- 0.045','SDSS-II SN 14522',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19974,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 14522','R',19974,42.25,0.33,1960,5038,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14522',0.438058,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19975,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 14522',NULL,19975,41.89,0.21,2390,5038,70,NULL,'SALT 2','SDSS-II SN 14522',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19976,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 14522',NULL,19976,41.98,0.21,2490,5038,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14522',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19977,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19977,36.22,0.52,175,5039,70,NULL,NULL,'2MASX J01540699-0453002',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.43',0.45,NULL,NULL,NULL,NULL,NULL,1,28.529125,-4.88342,0.02,NULL,35017946551,547155414,8549303,15.43),(19978,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19978,33.81,0.48,57.8,5040,70,NULL,NULL,'NGC 0745 NED01',NULL,'2014MNRAS.445.2677S',2014,1,1.38,NULL,'G',0.0001,NULL,'14.04',0.81,NULL,'Pair member (points to parent)',NULL,NULL,NULL,1,28.532167,-56.69367,0.005,NULL,36168929354,565139521,8830305,14.04),(19979,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19979,33.68,0.2,54.5,5041,74.4,NULL,NULL,'KUG 0151+352',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',NULL,NULL,'16.07',0.3,'Spiral',NULL,NULL,NULL,NULL,1,28.546625,35.53481,0.185,NULL,67742639059,1058478735,16538730,16.07),(19980,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19980,33.85,0.1,59,5041,NULL,NULL,NULL,'KUG 0151+352',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19981,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19981,37.12,0.46,266,5042,70,NULL,NULL,'2MASX J01541168-0111502',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000114,NULL,'16.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,28.548583,-1.19722,0.037,NULL,35001761142,546902517,8545351,16.4),(19982,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 16975','RN',19982,41.74,0.3,1640,5043,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16975',0.361016,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19983,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 16975','RN',19983,42.27,0.32,2090,5043,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16975',0.361016,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19984,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 16650','RN',19984,41.46,0.28,1440,5044,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16650',0.361732,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19985,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 16650','RN',19985,41.54,0.18,1490,5044,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16650',0.361732,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19986,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19986,33.37,0.2,47.2,5045,74.4,NULL,NULL,'UGC 01369',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000017,NULL,'14.46',1,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,28.5562917,18.10178,0.109,NULL,66970454451,1046413350,16350208,14.46),(19987,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19987,33.49,0.61,49.9,5045,NULL,NULL,NULL,'UGC 01369',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19988,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19988,33.67,0.56,54.2,5045,NULL,NULL,'Malmquist cor.','UGC 01369',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19989,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19989,37.16,0.33,271,5046,70,NULL,NULL,'2MASX J01541473+0006388',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000067,NULL,'17.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,28.5615,0.11072,0.033,NULL,66999920731,1046873761,16357402,17.9),(19990,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19990,37.87,0.23,376,5047,70,NULL,NULL,'2MASX J01541503+1447166',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00011,NULL,'17.3g',0.23,'NLAGN',NULL,NULL,NULL,'Sy 2',1,28.5625417,14.788,0.137,NULL,66960163387,1046252552,16347696,17.3),(19991,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19991,33.65,0.69,53.6,5048,100,NULL,'mid-IR','ESO 297-G 032',NULL,'2013ApJ...771...88L',2013,1,0.91,NULL,'G',0.000027,NULL,'14.68',0.5,'(R\'_2)SB(s)a',NULL,NULL,NULL,NULL,1,28.5676666667,-37.786,NULL,NULL,38300144078,598439751,9350621,14.68),(19992,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19992,36.68,0.19,216,5049,70,NULL,NULL,'MCG -02-05-071',NULL,'2015arXiv151105856S',2015,1,1.25,NULL,'G',0.000107,NULL,'14.5g',0.66,'SB0-:;BrClG',NULL,NULL,NULL,NULL,1,28.5752917,-9.71347,0.05,NULL,35111358744,548614980,8572109,14.5),(19993,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',19993,33.87,0.49,59.5,5050,75,NULL,'IR','UGC 01366',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.000027,NULL,'14.58',0.4,'SBcd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,28.5825,36.62981,0.201,NULL,67745698041,1058526531,16539477,14.58),(19994,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19994,33.89,0.47,60,5050,NULL,NULL,'H','UGC 01366',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19995,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19995,33.99,0.46,62.9,5050,NULL,NULL,'J','UGC 01366',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19996,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19996,34.05,0.45,64.4,5050,NULL,NULL,'K','UGC 01366',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19997,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19997,34.13,0.08,67.1,5050,NULL,NULL,NULL,'UGC 01366',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19998,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19998,34.22,0.2,69.8,5050,74.4,NULL,NULL,'UGC 01366',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(19999,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,19999,34.23,0.4,70.2,5050,NULL,NULL,'mean','UGC 01366',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20000,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20000,34.32,0.43,73.1,5050,75,NULL,'3.6 micron, color corrected','UGC 01366',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20001,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20001,34.52,0.43,80.3,5050,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01366',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20002,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',20002,36,0.46,158,5051,70,NULL,NULL,'2MASX J01541993-0037251',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000087,NULL,'15.8g',0.15,'E0',NULL,NULL,NULL,NULL,1,28.5830417,-0.62353,0.033,NULL,35002476049,546913688,8545526,15.8),(20003,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',20003,37.71,0.33,348,5052,70,NULL,NULL,'2MASX J01542097+0108178',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000079,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,28.587375,1.13842,0.017,NULL,67000371435,1046880803,16357512,17),(20004,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20004,34.63,0.35,84.2,5053,NULL,NULL,NULL,'ESO 197- G 011',NULL,'2009ApJS..182..474S',2009,1,0.84,NULL,'G',0.000033,NULL,'15.51',0.43,'Scd',NULL,NULL,NULL,NULL,1,28.5922083,-49.26058,NULL,NULL,38230024224,597344128,9333502,15.51),(20005,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20005,34.67,0.2,85.9,5053,74.4,NULL,NULL,'ESO 197- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20006,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20006,34.71,0.33,87.7,5053,NULL,NULL,'Malmquist cor.','ESO 197- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20007,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',20007,37.87,0.23,376,5054,70,NULL,NULL,'2MASXi J0154224+143050',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00007,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,28.5935417,14.51386,0.141,NULL,66960895025,1046263984,16347874,17.8),(20008,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20008,33.57,0.2,51.8,5055,74.4,NULL,NULL,'UGC 01373',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.00006,NULL,'15.36',0.3,'S?','Group member',NULL,NULL,NULL,1,28.6001666667,5.42189,0.141,NULL,67026007574,1047281368,16363771,15.36),(20009,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20009,33.69,0.64,54.6,5055,NULL,NULL,NULL,'UGC 01373',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20010,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',20010,33.7,0.49,55.1,5055,75,NULL,'IR','UGC 01373',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20011,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20011,33.98,0.56,62.6,5055,NULL,NULL,'Malmquist cor.','UGC 01373',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20012,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20012,35.27,0.6,113,5056,70,NULL,NULL,'NGC 0756',NULL,'2014MNRAS.445.2677S',2014,1,NULL,'Star superposed.','GPair',0.000107,NULL,NULL,NULL,'S0: pec',NULL,NULL,NULL,NULL,1,28.6210417,-16.70717,0,NULL,35094417010,548350265,8567972,NULL),(20013,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',20013,36.68,0.19,216,5057,70,NULL,NULL,'2MASX J01542970-0942495',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000095,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,28.6237916667,-9.71367,0.05,NULL,35111369006,548615140,8572111,16.8),(20014,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',20014,38.28,0.33,452,5058,70,NULL,NULL,'2MASX J01543027+1457326',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000096,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,28.6262083333,14.959,0.137,NULL,66960134998,1046252109,16347689,17.9),(20015,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20015,34.25,0.42,70.7,5059,NULL,NULL,'Malmquist cor.','UGC 01372',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.93',0.4,'S?',NULL,NULL,NULL,NULL,1,28.6300833333,17.67425,0.121,NULL,66970712501,1046417382,16350271,14.93),(20016,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20016,34.32,0.41,73.2,5059,NULL,NULL,NULL,'UGC 01372',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20017,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20017,34.43,0.2,76.9,5059,74.4,NULL,NULL,'UGC 01372',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20018,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 01181','RN',20018,43.75,0.23,3500,5060,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01181',0.60403,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20019,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 16167','RN',20019,38.4,0.18,443,5061,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 16167',0.080536,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20020,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',20020,37.71,0.33,348,5062,70,NULL,NULL,'2MASX J01543323+0108497',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000094,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,28.6385417,1.14717,0.017,NULL,67000370158,1046880783,16357512,16.9),(20021,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',20021,36.54,0.46,204,5063,70,NULL,NULL,'2MASX J01543450+0112497',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.0001,NULL,'16.1g',0.37,'E0',NULL,NULL,NULL,NULL,1,28.643625,1.21392,0.017,NULL,67003239665,1046925619,16358212,16.1),(20022,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20022,33.29,0.58,45.4,5064,NULL,NULL,NULL,'UGC 01374',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000017,NULL,'15.22',0.7,'SBcd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,28.64375,16.86667,0.121,NULL,66970801088,1046418767,16350293,15.22),(20023,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20023,33.33,0.2,46.3,5064,74.4,NULL,NULL,'UGC 01374',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20024,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20024,33.5,0.53,50.2,5064,NULL,NULL,'Malmquist cor.','UGC 01374',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20025,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',20025,37.16,0.33,271,5065,70,NULL,NULL,'2MASX J01543634+0011127',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000092,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,28.651375,0.18686,0.045,NULL,66999935441,1046873991,16357406,17.1),(20026,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20026,34.21,NULL,69.5,5066,NULL,NULL,'Dipole','UGC 01377',NULL,'2010Ap&SS.325..163P',2010,1,1.34,NULL,'G',0.000013,NULL,'16.5',0.17,'Sbc',NULL,NULL,NULL,NULL,1,28.657167,17.07581,0.129,NULL,66971386837,1046427919,16350436,16.5),(20027,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20027,34.22,NULL,69.7,5066,NULL,NULL,'Dipole + Quadrupole','UGC 01377',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20028,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20028,34.22,NULL,69.7,5066,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01377',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20029,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20029,34.41,NULL,76.3,5066,NULL,NULL,NULL,'UGC 01377',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20030,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20030,34.53,0.2,80.5,5066,74.4,NULL,NULL,'UGC 01377',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20031,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20031,34.58,0.6,82.3,5066,NULL,NULL,'Malmquist cor.','UGC 01377',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20032,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20032,34.7,0.57,86.9,5066,NULL,NULL,NULL,'UGC 01377',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20033,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20033,34.57,0.46,82,5067,70,NULL,NULL,'ESO 152- G 034',NULL,'2014MNRAS.445.2677S',2014,1,0.71,NULL,'G',0.000133,NULL,'14.57',0.56,'SB(l)0^0',NULL,NULL,NULL,NULL,1,28.669917,-55.66275,0.033,NULL,36164499869,565070310,8829223,14.57),(20034,'FP','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',20034,34.85,0.46,93.4,5068,70,NULL,NULL,'UGC 01382',NULL,'2015arXiv151105856S',2015,1,1.03,'This has a very faint, patchy, asymmetrical, and much extended corona.','G',0.000037,NULL,'14.3g',0.76,'E?',NULL,NULL,NULL,NULL,1,28.671,-0.14333,0.045,NULL,35001654789,546900856,8545325,14.3),(20035,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20035,34.43,0.4,76.9,5068,NULL,NULL,'mean','UGC 01382',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20036,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20036,34.78,0.45,90.2,5068,NULL,NULL,'K','UGC 01382',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20037,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,'R',20037,34.46,0.49,78,5069,75,NULL,'IR','UGC 01383',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.0001,NULL,'16.0',0.2,'Scd:',NULL,NULL,NULL,NULL,1,28.670833,6.03492,0.141,NULL,67025082733,1047266917,16363545,16),(20038,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20038,34.57,0.2,82,5069,74.4,NULL,NULL,'UGC 01383',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20039,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20039,34.58,0.38,82.6,5069,NULL,NULL,'Malmquist cor.','UGC 01383',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20040,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20040,34.7,0.36,87,5069,NULL,NULL,NULL,'UGC 01383',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20041,'BCG','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20041,38.83,0.35,517,5070,60,NULL,NULL,'ABELL 0274',0.1289,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,28.675833,-6.27167,0.032,NULL,34984943456,546639741,8541245,NULL),(20042,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:51','1','SDSS-II SN 13350','RN',20042,41.15,0.4,1280,5071,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13350',0.328888,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20043,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20043,33.72,0.43,55.4,5072,75,NULL,'3.6 micron, color corrected','NGC 0721',NULL,'2014MNRAS.444..527S',2014,1,1.7,NULL,'G',0.000033,NULL,'14.17',1,'SB(rs)bc',NULL,NULL,NULL,NULL,1,28.689417,39.38353,0.169,NULL,67860910731,1060326730,16567605,14.17),(20044,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20044,33.74,0.2,56,5072,74.4,NULL,NULL,'NGC 0721',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20045,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20045,33.76,0.43,56.5,5072,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0721',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20046,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20046,33.9,NULL,60.3,5072,NULL,NULL,'B','NGC 0721',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20047,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20047,34.04,NULL,64.3,5072,NULL,NULL,'I','NGC 0721',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20048,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20048,34.44,0.4,77.3,5072,NULL,NULL,'mean','NGC 0721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20049,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20049,34.47,0.07,78.5,5072,NULL,NULL,NULL,'NGC 0721',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20050,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20050,34.49,0.47,78.9,5072,NULL,NULL,'H','NGC 0721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20051,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20051,34.59,0.46,82.9,5072,NULL,NULL,'J','NGC 0721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20052,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20052,34.66,0.45,85.4,5072,NULL,NULL,'K','NGC 0721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20053,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:51','1',NULL,NULL,20053,33.16,0.69,42.8,5073,100,NULL,'mid-IR','NGC 0722',NULL,'2013ApJ...771...88L',2013,1,1.7,NULL,'G',0.000017,NULL,'14.35',0.5,'S?',NULL,NULL,NULL,NULL,1,28.695625,20.69822,0.197,NULL,66922040141,1045656877,16338388,14.35),(20054,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20054,34.13,0.4,66.9,5073,NULL,NULL,'mean','NGC 0722',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20055,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20055,34.17,0.47,68.4,5073,NULL,NULL,'H','NGC 0722',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20056,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20056,34.21,0.46,69.4,5073,NULL,NULL,'J','NGC 0722',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20057,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20057,34.28,0.45,71.8,5073,NULL,NULL,'K','NGC 0722',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20058,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20058,38.38,0.46,473,5074,70,NULL,NULL,'2MASXi J0154470+130437',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000096,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,28.6959166667,13.07708,0.117,NULL,66932490574,1045820165,16340940,17.8),(20059,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 16169','RN',20059,41.26,0.39,1310,5075,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 16169',0.35913,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20060,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20060,34.58,0.46,82.5,5076,70,NULL,NULL,'2MASX J01545308-0035491',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000075,NULL,'15.3g',0.46,'E0',NULL,NULL,NULL,NULL,1,28.7212917,-0.59706,0.045,NULL,35002471019,546913609,8545525,15.3),(20061,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20061,33.88,0.25,59.7,5077,74.4,NULL,NULL,'UGC 01385',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000027,NULL,'13.9',0.6,'(R)SB0/a       Sbrst','Group member',NULL,NULL,NULL,1,28.724125,36.91794,0.189,NULL,67745792768,1058528012,16539500,13.9),(20062,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20062,34.08,0.24,65.4,5077,70,NULL,NULL,'UGC 01385',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20063,'IRAS','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20063,34.43,0.8,76.9,5077,75,NULL,'HMCL, I','UGC 01385',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20064,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20064,33.32,0.4,46.1,5077,75,NULL,'HMCL, I, raw','UGC 01385',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20065,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20065,33.33,0.4,46.4,5077,75,NULL,'HMCL, I, inv','UGC 01385',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20066,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20066,33.72,0.4,55.5,5077,75,NULL,'HMCL, I, cor','UGC 01385',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20067,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20067,35.79,0.2,144,5078,74.4,NULL,NULL,'IC 0172',NULL,'2013AJ....146...86T',2013,1,0.73,NULL,'G',0.00002,NULL,'14.9g',0.49,'S?',NULL,NULL,NULL,NULL,1,28.7259583333,0.81122,0.013,NULL,67000506025,1046882906,16357545,14.9),(20068,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20068,38.12,0.46,420,5079,70,NULL,NULL,'SDSS J015454.76+130246.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000071,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,28.7282083333,13.04614,0.117,NULL,66932491725,1045820183,16340940,17.9),(20069,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20069,33.61,0.45,52.8,5080,NULL,NULL,'K','NGC 0731',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.00003,NULL,'14.00',1.7,'E+:',NULL,NULL,NULL,NULL,1,28.7342083,-9.01081,0.084,NULL,35109058169,548579033,8571547,14),(20070,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20070,33.72,0.4,55.4,5080,NULL,NULL,'mean','NGC 0731',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20071,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 07919','RN',20071,40.88,0.28,1140,5081,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07919',0.319315,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20072,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 07919','RN',20072,41.31,0.37,1390,5081,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07919',0.319315,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20073,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20073,33.47,0.2,49.4,5082,74.4,NULL,NULL,'UGC 01380',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.00001,NULL,'15.6',0.6,'Sc',NULL,NULL,NULL,NULL,1,28.7402083,37.343,0.205,NULL,67744650277,1058510160,16539221,15.6),(20074,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20074,33.95,0.1,61.8,5082,NULL,NULL,NULL,'UGC 01380',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20075,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20075,34.06,0.1,65,5083,NULL,NULL,NULL,'MRK 1010',NULL,'2009ApJS..182..474S',2009,1,0.4,'1999ApJS..121..287H has V = 16200 km/sec.','G',0.000284,NULL,'15.1',0.3,'Spiral',NULL,NULL,NULL,NULL,1,28.74475,35.42281,0.205,NULL,67742682351,1058479411,16538740,15.1),(20076,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20076,34.1,0.2,66.1,5083,74.4,NULL,NULL,'MRK 1010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20077,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20077,34.49,0.49,79,5083,75,NULL,'IR','MRK 1010',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20078,'BCG','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20078,38.83,0.35,517,5084,60,NULL,'ABELL 0274, BCG','2MASX J01545954-0615401',0.1289,'1980ApJ...241..486H',1980,1,0.58,NULL,'G',0.00015,NULL,'16.80',0.35,NULL,'Brightest group member',NULL,NULL,NULL,1,28.748125,-6.26119,0.041,NULL,34984936866,546639638,8541244,16.8),(20079,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20079,32.63,0.55,33.6,5085,NULL,NULL,NULL,'UGC 01386',NULL,'2009ApJS..182..474S',2009,1,0.96,NULL,'G',0.000074,NULL,'15.7g',0.21,'Sc(f)',NULL,NULL,NULL,NULL,1,28.7482917,13.48294,0.153,NULL,66932413317,1045818958,16340921,15.7),(20080,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20080,32.72,0.53,35,5085,NULL,NULL,'Malmquist cor.','UGC 01386',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20081,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 08651','RN',20081,41.94,0.34,1730,5086,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 08651',0.412585,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20082,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 08651','RN',20082,42.25,0.42,2000,5086,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 08651',0.412585,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20083,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20083,33.98,0.11,62.6,5087,NULL,NULL,NULL,'KUG 0152+366',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000033,NULL,'15.2',0.5,'SBb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,28.757833,36.91992,0.189,NULL,67745795659,1058528057,16539500,15.2),(20084,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20084,34.33,0.2,73.5,5088,74.4,NULL,NULL,'KUG 0152+051B',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.0001,NULL,'15.5',0.4,'Spiral','Group member',NULL,NULL,NULL,1,28.778833,5.37358,0.137,NULL,67025885283,1047279457,16363741,15.5),(20085,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20085,34.34,0.34,73.6,5088,NULL,NULL,NULL,'KUG 0152+051B',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20086,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20086,34.42,0.32,76.7,5088,NULL,NULL,'Malmquist cor.','KUG 0152+051B',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20087,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20087,38.28,0.33,452,5089,70,NULL,NULL,'2MASX J01550753+1444562',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000068,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,28.781333,14.74889,0.141,NULL,66960957957,1046264968,16347890,17.9),(20088,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20088,33.44,0.22,48.8,5090,74.4,NULL,NULL,'IC 0171',NULL,'2013AJ....146...86T',2013,1,2.5,NULL,'G',0.000026,NULL,'13.23',2.2,'E?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,28.7925417,35.28189,0.205,NULL,67740860963,1058450952,16538296,13.23),(20089,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20089,34.08,0.24,65.4,5090,70,NULL,NULL,'IC 0171',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20090,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 04557',NULL,20090,40.17,0.4,1080,5091,70,NULL,'SN photometric redshift distance, z photo =0.294 +/- 0.074','SDSS-II SN 04557',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','22.3g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,28.795167,0.26781,0.045,NULL,67000788187,1046887315,16357614,22.3),(20091,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20091,34.13,0.09,67.1,5092,NULL,NULL,NULL,'UGC 01387',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000011,NULL,'15.15',0.6,'Sdm:',NULL,NULL,NULL,NULL,1,28.795,36.26072,0.249,NULL,67746142790,1058533481,16539585,15.15),(20092,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 16976',NULL,20092,37.12,1.14,265,5093,70,NULL,'SN photometric redshift distance, z photo =0.064 +/- 0.047','SDSS-II SN 16976',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,28.7952083,-0.41197,0.045,NULL,35002498027,546914031,8545531,NULL),(20093,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 15743','RN',20093,41.45,0.49,1250,5094,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 15743',0.568893,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20094,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 15743','N',20094,41.59,0.46,2080,5094,70,NULL,'SALT 2','SDSS-II SN 15743',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20095,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 15743','N',20095,41.82,0.46,2310,5094,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15743',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20096,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20096,34.26,0.08,71.3,5095,NULL,NULL,NULL,'CGCG 522-065',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000017,NULL,'15.6',0.3,'S0',NULL,NULL,NULL,NULL,1,28.80825,35.45856,0.205,NULL,67742693397,1058479584,16538743,15.6),(20097,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 21033','R',20097,40.19,0.15,886,5096,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007qy','SN 2007qy',0.229,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,28.813667,0.64311,0.005,NULL,67000663749,1046885371,16357583,NULL),(20098,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 21033','R',20098,40.65,0.21,1100,5096,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007qy','SN 2007qy',0.229,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20099,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20099,34.28,0.49,71.8,5097,75,NULL,'IR','UGC 01391',NULL,'2011yCatp016004901K',2011,1,1.57,NULL,'G',0.000011,NULL,'15.35',0.17,'Sbc','Isolated galaxy',NULL,NULL,NULL,1,28.816,10.01367,0.165,NULL,67054772509,1047730820,16370794,15.35),(20100,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20100,34.5,0.4,79.3,5097,NULL,NULL,'mean','UGC 01391',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20101,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20101,34.67,0.47,85.9,5097,NULL,NULL,'H','UGC 01391',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20102,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20102,34.76,0.43,89.6,5097,NULL,NULL,'Malmquist cor.','UGC 01391',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20103,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20103,34.78,0.2,90.4,5097,74.4,NULL,NULL,'UGC 01391',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20104,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20104,34.78,0.45,90.4,5097,NULL,NULL,'K','UGC 01391',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20105,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20105,34.86,0.41,94,5097,NULL,NULL,NULL,'UGC 01391',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20106,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20106,34.93,NULL,96.8,5097,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01391',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20107,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20107,34.94,NULL,97.2,5097,NULL,NULL,'Dipole + Quadrupole','UGC 01391',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20108,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20108,34.95,NULL,97.7,5097,NULL,NULL,'Dipole','UGC 01391',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20109,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20109,35.02,NULL,101,5097,NULL,NULL,NULL,'UGC 01391',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20110,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 02906','RN',20110,39.45,0.11,627,5098,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 02906',0.236,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20111,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 02906','RN',20111,39.92,0.19,781,5098,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 02906',0.236,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20112,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20112,37.69,0.46,346,5099,70,NULL,NULL,'2MASX J01551689-0807522',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00008,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,28.8204166667,-8.13125,0.025,NULL,35109900511,548592195,8571753,17),(20113,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 13942',NULL,20113,40.95,0.5,1550,5100,70,NULL,'SN photometric redshift distance, z photo =0.460 +/- 0.173','SDSS-II SN 13942',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','22.1g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,28.824917,-0.58217,0.045,NULL,35002315886,546911185,8545487,22.1),(20114,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 13942','R',20114,42.13,0.63,1740,5100,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13942',0.529984,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20115,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20115,36.01,0.46,159,5101,70,NULL,NULL,'III Zw 037',NULL,'2015arXiv151105856S',2015,1,0.51,'CGPG +1 deg Dec error.','G',0.000099,NULL,'15.7g',0.47,'NLAGN',NULL,NULL,NULL,'Sy 2',1,28.8277083,0.48675,0.045,NULL,67000644785,1046885074,16357579,15.7),(20116,'TRGB','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20116,28.38,NULL,4.74,5102,NULL,NULL,NULL,'AGC 111977',NULL,'2003A&A...398..479K',2003,1,0.8,NULL,'G',0.000003,NULL,'16.3',0.3,'Irr',NULL,NULL,NULL,NULL,1,28.834583,27.95389,0.289,NULL,68599113528,1071861148,16747830,16.3),(20117,'TRGB','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20117,28.69,0.05,5.47,5102,NULL,NULL,NULL,'AGC 111977',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20118,'TRGB','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20118,28.75,0.1,5.62,5102,74.4,NULL,NULL,'AGC 111977',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20119,'TRGB','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20119,28.78,0.04,5.7,5102,NULL,NULL,NULL,'AGC 111977',NULL,'2006AJ....132.2729M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20120,'TRGB','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20120,28.88,0.04,5.96,5102,NULL,NULL,'I','AGC 111977',NULL,'2014ApJ...785....3M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20121,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20121,34.14,0.09,67.4,5103,NULL,NULL,NULL,'UGC 01390',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000049,NULL,'15.5',0.22,'Sbc',NULL,NULL,NULL,NULL,1,28.8384583,36.30692,0.249,NULL,67746142015,1058533468,16539585,15.5),(20122,'Ring Diameter','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20122,33.5,0.84,51,5104,NULL,NULL,'Published at H = 100 km/s/Mpc','UGC 01395',NULL,'1981ApJS...45..541P',1981,1,1.3,NULL,'G',0.00008,NULL,'14.18',1,'SA(rs)b        Sy1.9','Isolated galaxy',NULL,NULL,'Sy 1.9',1,28.8418333333,6.61183,0.133,NULL,67046102589,1047595352,16368677,14.18),(20123,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20123,33.89,0.47,60,5104,NULL,NULL,'H','UGC 01395',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20124,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20124,34.03,0.45,64,5104,NULL,NULL,'K','UGC 01395',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20125,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20125,34.08,0.46,65.3,5104,NULL,NULL,'J','UGC 01395',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20126,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20126,34.16,0.4,68,5104,NULL,NULL,'mean','UGC 01395',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20127,'L(H{beta})-{sigma}','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20127,44.95,NULL,1638,5105,74.3,NULL,NULL,'WISP 173_0205',1.444,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,28.8485,-9.05283,0.073,NULL,35109068342,548579192,8571549,NULL),(20128,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 17947','RN',20128,41.8,0.48,1430,5106,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 17947',0.602772,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20129,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 18321','R',20129,39.84,0.08,842,5107,70,NULL,'SDSS CAND. SNII; MLCS2K2','SDSS J015529.39+010935.9',0.103,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,NULL,'21.9g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,28.8725,1.16,0.013,NULL,67003428620,1046928572,16358258,21.9),(20130,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 18321','R',20130,39.94,0.22,880,5107,70,NULL,'SDSS CAND. SNII; SALT 2','SDSS J015529.39+010935.9',0.103,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20131,'SNII optical','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN SDSS 18321',NULL,20131,38.23,0.09,401,5107,NULL,NULL,'SCM 55 SNII','SDSS J015529.39+010935.9',0.1041,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20132,'SNII optical','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN SDSS 18321',NULL,20132,38.4,0.11,434,5107,NULL,NULL,'SCM 15 SDSS SNII','SDSS J015529.39+010935.9',0.1041,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20133,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20133,33.86,0.45,59.1,5108,NULL,NULL,'K','UGC 01392',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000264,NULL,'16.0',0.6,'S0?',NULL,NULL,NULL,NULL,1,28.8727083,36.56189,0.189,NULL,67746184394,1058534131,16539595,16),(20134,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20134,34.32,0.4,73.1,5108,NULL,NULL,'mean','UGC 01392',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20135,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20135,36.68,0.19,216,5109,70,NULL,NULL,'2MASX J01553106-1004191',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000072,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,28.8795,-10.07189,0.011,NULL,35111152543,548611758,8572058,17.2),(20136,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20136,36.75,0.46,224,5110,70,NULL,NULL,'2MASX J01553252+1500511',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000074,NULL,'17.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,28.8855416667,15.01408,0.161,NULL,66960614893,1046259607,16347806,17),(20137,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20137,36.97,0.46,248,5111,70,NULL,NULL,'SDSS J015533.46+010942.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000067,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,28.8894583333,1.16169,0.013,NULL,67003427981,1046928562,16358258,17.9),(20138,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20138,37.04,0.46,256,5112,70,NULL,NULL,'2MASX J01553354-0009079',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000088,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,28.88975,-0.15231,0.045,NULL,35002114590,546908040,8545438,17.3),(20139,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20139,35.32,NULL,116,5113,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0209',NULL,'2010Ap&SS.325..163P',2010,1,0.92,NULL,'G',0.000007,NULL,'16.45',0.11,'Sbc',NULL,NULL,NULL,NULL,1,28.8989583,16.81086,0.117,NULL,66971247931,1046425748,16350402,16.45),(20140,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20140,35.33,NULL,117,5113,NULL,NULL,'Dipole + Quadrupole','FGC 0209',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20141,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20141,35.35,NULL,117,5113,NULL,NULL,'Dipole','FGC 0209',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20142,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20142,35.36,NULL,118,5113,NULL,NULL,NULL,'FGC 0209',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20143,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20143,37.22,0.46,278,5114,70,NULL,NULL,'SDSS J015539.03+123836.3',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000076,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,28.912625,12.64342,0.121,NULL,66932030325,1045812973,16340827,17.1),(20144,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20144,34.46,0.47,78.1,5115,NULL,NULL,'H','UGC 01394',NULL,'2007A&A...465...71T',2007,1,2.3,NULL,'G',0.000037,NULL,'14.3',1.2,'Sa',NULL,NULL,NULL,NULL,1,28.9259583333,46.80192,0.661,NULL,67831292748,1059863949,16560374,14.3),(20145,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20145,34.5,0.45,79.5,5115,NULL,NULL,'K','UGC 01394',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20146,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20146,34.53,0.46,80.5,5115,NULL,NULL,'J','UGC 01394',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20147,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20147,34.67,0.4,86,5115,NULL,NULL,'mean','UGC 01394',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20148,'BCG','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20148,38.26,0.35,410,5116,60,NULL,NULL,'ABELL 0277',0.0947,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,28.948083,-7.37231,0,NULL,35107024938,548547264,8571051,NULL),(20149,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 20923',NULL,20149,41.35,0.15,1870,5117,70,NULL,'SN photometric redshift distance, z photo =0.595 +/- 0.065','SDSS-II SN 20923',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,28.953125,-0.80994,0.029,NULL,35005271508,546957367,8546208,NULL),(20150,'BCG','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20150,38.26,0.35,410,5118,60,NULL,'ABELL 0277, BCG','2MASX J01555051-0724181',0.0947,'1980ApJ...241..486H',1980,1,0.5,NULL,'G',0.00015,NULL,'14.0I',0.4,NULL,'Brightest group member',NULL,NULL,NULL,1,28.9605417,-7.40503,0.025,NULL,35107030943,548547358,8571052,14),(20151,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20151,37.49,0.23,315,5119,70,NULL,NULL,'2MASX J01555249+1453566',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000089,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,28.9687083,14.899,0.137,NULL,66960587627,1046259181,16347799,16.5),(20152,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20152,37.49,0.23,315,5120,70,NULL,NULL,'2MASX J01555324+1449395',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,'PHOT','17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,28.971917,14.82767,0.137,NULL,66960573407,1046258959,16347796,17.5),(20153,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20153,37.71,0.13,349,5121,70,NULL,NULL,'2MASX J01555440+0058576',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000062,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,28.9765,0.98261,0.005,NULL,67003310899,1046926732,16358230,17.6),(20154,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20154,37.49,0.23,315,5122,70,NULL,NULL,'2MASX J01555455+1449175',NULL,'2015arXiv151105856S',2015,1,0.33,'Both SHK 045:[STB96a] 08 and 09 contribute to the IR source.','G',NULL,'PHOT','16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,28.9773333333,14.82158,0.137,NULL,66960573370,1046258958,16347796,16.8),(20155,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20155,37.49,0.23,315,5123,70,NULL,NULL,'2MASX J01555504+1448075',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000078,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,28.9794583,14.80228,0.137,NULL,66960572443,1046258944,16347796,17.2),(20156,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 14161','RN',20156,42.77,0.2,2480,5124,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 14161',0.444265,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20157,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 14161','RN',20157,43.6,0.17,3630,5124,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 14161',0.444265,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20158,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20158,37.71,0.13,349,5125,70,NULL,NULL,'2MASX J01555900+0059196',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000076,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,28.995875,0.98869,0.005,NULL,67003781646,1046934088,16358345,17.4),(20159,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20159,37.12,0.46,266,5126,70,NULL,NULL,'2MASX J01560041-0813341',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000097,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,29.001625,-8.22614,0.04,NULL,35108760540,548574383,8571474,17.2),(20160,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20160,33.24,0.49,44.6,5127,75,NULL,'IR','KUG 0153+328',NULL,'2011yCatp016004901K',2011,1,0.7,NULL,'G',NULL,NULL,'15.7',0.2,'Spiral',NULL,NULL,NULL,NULL,1,29.009167,33.13406,0.149,NULL,67738644194,1058416315,16537754,15.7),(20161,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 08029','RN',20161,41.46,0.35,1800,5128,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08029',0.08498,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20162,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20162,35.2,0.2,110,5129,74.4,NULL,NULL,'CGCG 460-051',NULL,'2013AJ....146...86T',2013,1,0.55,NULL,'G',0.000033,NULL,'15.7',0.3,NULL,NULL,NULL,NULL,NULL,1,29.0135417,17.53206,0.117,NULL,66970590183,1046415471,16350241,15.7),(20163,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20163,35.41,0.43,121,5129,NULL,NULL,'Malmquist cor.','CGCG 460-051',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20164,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20164,35.46,0.42,124,5129,NULL,NULL,NULL,'CGCG 460-051',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20165,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20165,37.71,0.13,349,5130,70,NULL,NULL,'2MASX J01560620+0100286',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00007,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,29.025875,1.00797,0.005,NULL,67003783781,1046934121,16358345,18.4),(20166,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20166,36.48,0.33,198,5131,70,NULL,NULL,'2MASX J01560709-0937431',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000079,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,29.0295417,-9.62872,0.038,NULL,35111402875,548615669,8572119,16.9),(20167,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20167,34.94,0.76,97.4,5132,NULL,NULL,'Malmquist cor.','IC 1748',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.47',0.7,'SABbc',NULL,NULL,NULL,NULL,1,29.0369166667,17.64128,0.117,NULL,66963232186,1046300502,16348445,14.47),(20168,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20168,35.03,0.73,101,5132,NULL,NULL,NULL,'IC 1748',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20169,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20169,35.13,0.2,106,5132,74.4,NULL,NULL,'IC 1748',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20170,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 20971','R',20170,40.96,0.25,1200,5133,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20971',0.300455,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,29.041917,-0.21597,0.045,NULL,35002241413,546910022,8545469,NULL),(20171,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 20971','R',20171,41.47,0.22,1510,5133,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20971',0.300455,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20172,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20172,35.4,0.52,120,5134,70,NULL,NULL,'2MASX J01561067-2158100',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'16.13',0.15,NULL,NULL,NULL,NULL,NULL,1,29.044583,-21.96947,0,NULL,37919588354,592493568,9257712,16.13),(20173,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20173,37.71,0.13,349,5135,70,NULL,NULL,'2MASX J01561100+0102486',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,29.04575,1.04672,0.005,NULL,67003780156,1046934064,16358344,17.1),(20174,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20174,34.15,0.36,67.6,5136,NULL,NULL,NULL,'IC 1749',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000053,NULL,'14.56',0.7,'S0:',NULL,NULL,NULL,NULL,1,29.04625,6.74494,0.137,NULL,67046047512,1047594492,16368663,14.56),(20175,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20175,34.24,0.2,70.5,5136,74.4,NULL,NULL,'IC 1749',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20176,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20176,34.33,0.34,73.3,5136,NULL,NULL,'Malmquist cor.','IC 1749',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20177,'Tully est','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20177,30.16,0.8,10.8,5137,75,NULL,'B','ARK 065',NULL,'1988NBGC.C....0000T',1988,1,0.2,'RC3 gives v = 900 +/- 64 km/sec.','G',0.000077,NULL,'15.4',0.2,'E','Group member',NULL,NULL,NULL,1,29.0500417,5.58858,0.133,NULL,67025138773,1047267793,16363559,15.4),(20178,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20178,37.71,0.13,349,5138,70,NULL,NULL,'2MASX J01561200+0102016',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000088,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,29.0500417,1.03361,0.005,NULL,67003792437,1046934256,16358347,17.4),(20179,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20179,33.88,0.54,59.8,5139,NULL,NULL,NULL,'2MASX J01561251+1454234',NULL,'2009ApJS..182..474S',2009,1,0.58,NULL,'G',0.000059,NULL,'15.5g',0.33,'Sc',NULL,NULL,NULL,NULL,1,29.0522083,14.90667,0.137,NULL,66960698036,1046260906,16347826,15.5),(20180,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20180,33.95,0.52,61.5,5139,NULL,NULL,'Malmquist cor.','2MASX J01561251+1454234',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20181,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 21577',NULL,20181,40.97,0.52,1560,5140,70,NULL,'SN photometric redshift distance, z photo =0.466 +/- 0.186','SDSS-II SN 21577',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','20.9g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,29.055333,-0.53181,0.037,NULL,35002182740,546909105,8545454,20.9),(20182,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 21577','R',20182,41.74,0.51,1570,5140,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21577',0.420973,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20183,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 21577',NULL,20183,41.49,0.36,1990,5140,70,NULL,'SALT 2','SDSS-II SN 21577',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20184,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 21577',NULL,20184,41.57,0.36,2060,5140,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 21577',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20185,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20185,35.29,0.36,114,5141,NULL,NULL,'Malmquist cor.','UGC 01408',NULL,'2009ApJS..182..474S',2009,1,1.01,NULL,'G',0.000066,NULL,'15.3g',0.44,'Sd',NULL,NULL,NULL,NULL,1,29.0634583333,13.16586,0.145,NULL,66928876233,1045763691,16340057,15.3),(20186,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20186,35.41,0.34,121,5141,NULL,NULL,NULL,'UGC 01408',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20187,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20187,35.51,0.2,126,5141,74.4,NULL,NULL,'UGC 01408',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20188,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20188,37.71,0.13,349,5142,70,NULL,NULL,'2MASX J01561574+0102286',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.09',0.22,NULL,NULL,NULL,NULL,NULL,1,29.065583,1.04133,0.009,NULL,67003779663,1046934057,16358344,18.09),(20189,'IRAS','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20189,31.91,0.8,24.1,5143,75,NULL,'MAT, I','ESO 477- G 016',NULL,'1997ApJS..109..333W',1997,1,2.76,NULL,'G',0.000026,NULL,'15.14',0.34,'Sb',NULL,NULL,NULL,NULL,1,29.066625,-22.90111,0,NULL,37919725988,592495718,9257745,15.14),(20190,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20190,32.63,NULL,33.6,5143,NULL,NULL,NULL,'ESO 477- G 016',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20191,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20191,32.72,0.32,35,5143,85,NULL,'I, inv','ESO 477- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20192,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20192,32.73,0.32,35.1,5143,85,NULL,'I, raw','ESO 477- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20193,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20193,32.87,0.43,37.5,5143,75,NULL,'MAT, I, raw','ESO 477- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20194,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20194,32.9,NULL,38,5143,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 477- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20195,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20195,32.91,0.43,38.3,5143,75,NULL,'MAT, I, inv','ESO 477- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20196,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20196,32.92,NULL,38.5,5143,NULL,NULL,'Dipole + Quadrupole','ESO 477- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20197,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20197,32.94,NULL,38.7,5143,NULL,NULL,'Dipole','ESO 477- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20198,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20198,33.28,0.43,45.4,5143,75,NULL,'MAT, I, cor','ESO 477- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20199,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20199,37.71,0.13,349,5144,70,NULL,NULL,'MCG +00-06-002',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00011,NULL,'15.6g',0.22,'BrClG',NULL,NULL,NULL,NULL,1,29.070625,1.05083,0.009,NULL,67003779920,1046934061,16358344,15.6),(20200,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20200,34.38,0.49,75.2,5145,75,NULL,'IR','UGC 01410',NULL,'2011yCatp016004901K',2011,1,2.05,NULL,'G',0.000011,NULL,'15.26',0.22,'Sbc',NULL,NULL,NULL,NULL,1,29.070625,4.64714,0.109,NULL,66995931291,1046811426,16356428,15.26),(20201,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20201,34.46,NULL,78.1,5145,NULL,NULL,'Dipole','UGC 01410',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20202,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20202,34.47,NULL,78.3,5145,NULL,NULL,'Dipole + Quadrupole','UGC 01410',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20203,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20203,34.47,NULL,78.5,5145,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01410',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20204,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20204,34.71,NULL,87.7,5145,NULL,NULL,NULL,'UGC 01410',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20205,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20205,34.85,0.45,93.5,5145,NULL,NULL,'Malmquist cor.','UGC 01410',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20206,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20206,34.97,0.2,98.6,5145,74.4,NULL,NULL,'UGC 01410',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20207,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20207,35.23,0.38,111,5145,NULL,NULL,NULL,'UGC 01410',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20208,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20208,37.71,0.13,349,5146,70,NULL,NULL,'2MASX J01561807+0101076',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000084,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,29.075333,1.01886,0.009,NULL,67003791330,1046934239,16358347,18.1),(20209,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20209,35.64,NULL,134,5147,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0211',NULL,'2010Ap&SS.325..163P',2010,1,0.6,NULL,'G',0.00001,NULL,'17.11',0.08,'Sd',NULL,NULL,NULL,NULL,1,29.077083,31.42111,0.101,NULL,67717235259,1058081800,16532528,17.11),(20210,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20210,35.66,NULL,136,5147,NULL,NULL,'Dipole + Quadrupole','FGC 0211',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20211,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20211,35.69,NULL,137,5147,NULL,NULL,'Dipole','FGC 0211',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20212,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20212,32.29,0.69,28.7,5148,100,NULL,'mid-IR','UGC 01378',NULL,'2013ApJ...771...88L',2013,1,3.4,NULL,'G',0.000005,NULL,'13.5',2.3,'(R)SB(rs)a:',NULL,NULL,NULL,NULL,1,29.0801666667,73.28278,2.081,NULL,65591787194,1024871674,16013619,13.5),(20213,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20213,33.1,0.46,41.7,5148,NULL,NULL,'J','UGC 01378',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20214,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20214,33.13,0.4,42.3,5148,NULL,NULL,'mean','UGC 01378',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20215,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20215,33.22,0.45,44,5148,NULL,NULL,'K','UGC 01378',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20216,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20216,33.26,0.47,44.8,5148,NULL,NULL,'H','UGC 01378',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20217,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20217,33.36,0.43,47,5148,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01378',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20218,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20218,37.71,0.13,349,5149,70,NULL,NULL,'2MASX J01562054+0102386',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000083,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,29.085667,1.04417,0.009,NULL,67003779131,1046934048,16358344,16.7),(20219,'D-Sigma','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20219,33.81,0.4,57.9,5150,75,NULL,'Edat, raw','NGC 0741',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000057,NULL,'12.2',2.9,'E0:','in a radial-velocity based grouping',NULL,NULL,NULL,1,29.087625,5.62894,0.133,NULL,66995716439,1046808069,16356376,12.2),(20220,'D-Sigma','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20220,34.15,0.4,67.6,5150,75,NULL,'Edat, cor','NGC 0741',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20221,'Faber-Jackson','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20221,33.11,0.55,41.9,5150,95,NULL,'de Vaucouleurs','NGC 0741',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20222,'Faber-Jackson','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20222,33.37,0.3,47.2,5150,95,NULL,'Weighted Mean','NGC 0741',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20223,'Faber-Jackson','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20223,33.88,0.46,59.7,5150,95,NULL,'Michard 1979a','NGC 0741',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20224,'Faber-Jackson','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20224,34.73,0.63,88.3,5150,95,NULL,'Michard 1979b, c','NGC 0741',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20225,'Faber-Jackson','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20225,34.74,0.81,88.7,5150,55,NULL,'Visvanathan & Sandage 1979','NGC 0741',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20226,'Tertiary','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20226,33.62,0.5,53,5150,95,NULL,NULL,'NGC 0741',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20227,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20227,34.07,0.45,65.1,5150,NULL,NULL,'K','NGC 0741',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20228,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20228,34.36,0.4,74.5,5150,NULL,NULL,'mean','NGC 0741',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20229,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20229,34,0.49,63.1,5151,75,NULL,'IR','UGC 01405',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.00001,NULL,'15.80',0.15,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,29.087875,37.45219,0.181,NULL,67745147424,1058517928,16539342,15.8),(20230,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20230,34.13,0.14,67.1,5151,NULL,NULL,NULL,'UGC 01405',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20231,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20231,34.16,NULL,67.8,5151,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01405',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20232,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20232,34.17,NULL,68.2,5151,NULL,NULL,'Dipole + Quadrupole','UGC 01405',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20233,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20233,34.18,NULL,68.5,5151,NULL,NULL,'Dipole','UGC 01405',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20234,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20234,34.45,0.2,77.6,5151,74.4,NULL,NULL,'UGC 01405',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20235,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20235,33.79,0.52,57.2,5152,70,NULL,NULL,'NGC 0748',NULL,'2014MNRAS.445.2677S',2014,1,2.3,NULL,'G',0.000017,NULL,'13.85',1.1,'(R\')SA(r)b?',NULL,NULL,NULL,NULL,1,29.090833,-4.46764,0,NULL,35009130332,547017661,8547150,13.85),(20236,'Sosies','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20236,34.42,0.21,76.6,5152,NULL,NULL,NULL,'NGC 0748',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20237,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20237,33.4,0.69,47.9,5152,100,NULL,'mid-IR','NGC 0748',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20238,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20238,34.06,0.46,64.8,5152,NULL,NULL,'J','NGC 0748',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20239,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20239,34.08,0.47,65.4,5152,NULL,NULL,'H','NGC 0748',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20240,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20240,34.14,0.45,67.2,5152,NULL,NULL,'K','NGC 0748',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20241,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20241,34.28,0.4,71.8,5152,NULL,NULL,'mean','NGC 0748',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20242,'IRAS','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20242,33.57,0.8,51.7,5153,75,NULL,'HMCL, I','UGC 01404',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000013,NULL,'15.25',0.6,'SB(s)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,29.0992083,37.21586,0.181,NULL,67744957250,1058514957,16539296,15.25),(20243,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20243,33.44,NULL,48.8,5153,NULL,NULL,'B','UGC 01404',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20244,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20244,33.59,NULL,52.2,5153,NULL,NULL,'I','UGC 01404',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20245,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20245,33.84,0.2,58.6,5153,74.4,NULL,NULL,'UGC 01404',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20246,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20246,33.98,0.13,62.6,5153,NULL,NULL,NULL,'UGC 01404',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20247,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20247,34.4,0.49,76,5153,75,NULL,'IR','UGC 01404',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20248,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20248,34.57,0.4,82.2,5153,75,NULL,'HMCL, I, raw','UGC 01404',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20249,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20249,34.62,0.4,84.1,5153,75,NULL,'HMCL, I, cor','UGC 01404',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20250,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20250,34.67,0.4,86.1,5153,75,NULL,'HMCL, I, inv','UGC 01404',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20251,'IRAS','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20251,31.58,0.8,20.7,5154,75,NULL,'MAT, I','NGC 0755',NULL,'1997ApJS..109..333W',1997,1,3.4,NULL,'G',0.00001,NULL,'13.46',1.1,'SB(rs)b?       HII',NULL,NULL,NULL,NULL,1,29.0945,-9.06142,0.051,NULL,35108567697,548571370,8571427,13.46),(20252,'IRAS','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20252,31.59,0.8,20.8,5154,75,NULL,'A82, H','NGC 0755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20253,'Tully est','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20253,31.52,0.8,20.1,5154,75,NULL,NULL,'NGC 0755',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20254,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20254,30.79,0.4,14.4,5154,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 0755',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20255,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20255,31.18,0.32,17.2,5154,85,NULL,'I, inv','NGC 0755',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20256,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20256,31.19,0.32,17.3,5154,85,NULL,'I, raw','NGC 0755',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20257,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20257,31.4,0.43,19,5154,75,NULL,'MAT, I, raw','NGC 0755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20258,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20258,31.43,0.38,19.3,5154,NULL,NULL,NULL,'NGC 0755',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20259,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20259,31.43,0.43,19.3,5154,75,NULL,'MAT, I, inv','NGC 0755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20260,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20260,31.43,0.4,19.3,5154,73,NULL,'opt','NGC 0755',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20261,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20261,31.44,0.47,19.4,5154,75,NULL,'A82, H, inv','NGC 0755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20262,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20262,31.47,0.47,19.7,5154,75,NULL,'A82, H, raw','NGC 0755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20263,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20263,31.51,0.43,20,5154,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0755',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20264,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20264,31.55,0.43,20.4,5154,75,NULL,'3.6 micron, color corrected','NGC 0755',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20265,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20265,31.62,0.2,21.1,5154,74.4,NULL,NULL,'NGC 0755',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20266,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20266,31.62,0.43,21.1,5154,75,NULL,'MAT, I, cor','NGC 0755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20267,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20267,31.71,0.47,22,5154,75,NULL,'A82, H, cor','NGC 0755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20268,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20268,31.82,0.62,23.1,5154,NULL,NULL,'Malmquist cor.','NGC 0755',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20269,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20269,31.86,0.61,23.5,5154,NULL,NULL,NULL,'NGC 0755',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20270,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20270,36.48,0.33,198,5155,70,NULL,NULL,'2MASX J01562375-0937359',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000107,NULL,'15.0g',0.58,'E0',NULL,NULL,NULL,NULL,1,29.099125,-9.62672,0.036,NULL,35110689062,548604516,8571945,15),(20271,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20271,36.74,0.46,223,5156,70,NULL,NULL,'2MASX J01562601-0826229',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00011,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,29.108375,-8.43961,0.035,NULL,35109250350,548582036,8571594,16.2),(20272,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 18956','RN',20272,42.71,0.34,2870,5157,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 18956',0.212475,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20273,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 18956','RN',20273,43.28,0.27,3740,5157,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 18956',0.212475,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20274,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20274,37.54,0.46,323,5158,70,NULL,NULL,'2MASX J01562824+1358394',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000071,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,29.1178333333,13.97767,0.129,NULL,66960257679,1046254026,16347719,17.9),(20275,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20275,37.71,0.13,349,5159,70,NULL,NULL,'SDSS J015630.03+010242.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00006,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,29.125125,1.04514,0.009,NULL,67003972052,1046937063,16358391,18.4),(20276,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 11242','RN',20276,38.33,0.08,444,5160,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 11242',0.045541,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20277,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 16642',NULL,20277,34.75,2.81,89,5161,70,NULL,'SN photometric redshift distance, z photo =0.021 +/- 0.058','SDSS-II SN 16642',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,29.1470417,-0.28858,0.037,NULL,35002216660,546909635,8545463,NULL),(20278,'Quasar spectrum','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20278,42.88,NULL,3770,5162,NULL,NULL,NULL,'UM 148',NULL,'2002A&A...381L..57D',2002,1,NULL,NULL,'QSO',NULL,NULL,'18.8',NULL,NULL,NULL,NULL,NULL,'QSO',1,29.150125,4.75781,0.109,NULL,66996127074,1046814485,16356476,18.8),(20279,'SNII optical','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2000dj',NULL,20279,34.26,0.18,69,5163,NULL,NULL,'SEAM','NGC 0735',0.015441,'2009ApJ...694.1067P',2009,1,1.8,'GSC 2315-0156 (V=14.1) superposed 20 arcsec northwest of nucleus.','G',0.000011,NULL,'14.07',0.9,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,29.15825,34.17678,0.213,NULL,67741582344,1058462224,16538472,14.07),(20280,'IRAS','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20280,33.7,0.8,55.1,5163,75,NULL,'W91PP, r','NGC 0735',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20281,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20281,33.99,0.4,62.7,5163,NULL,NULL,'mean','NGC 0735',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20282,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20282,34.08,0.38,65.4,5163,75,NULL,'W91PP, r, raw','NGC 0735',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20283,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20283,34.21,0.38,69.6,5163,75,NULL,'W91PP, r, cor','NGC 0735',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20284,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20284,34.29,0.38,72,5163,75,NULL,'W91PP, r, inv','NGC 0735',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20285,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20285,34.37,0.47,74.8,5163,NULL,NULL,'H','NGC 0735',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20286,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20286,34.38,0.46,75.2,5163,NULL,NULL,'J','NGC 0735',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20287,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20287,34.41,0.45,76.2,5163,NULL,NULL,'K','NGC 0735',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20288,'D-Sigma','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20288,33.62,0.4,53,5164,75,NULL,'Edat, raw','NGC 0736',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00009,NULL,'13.16',1.5,'E+:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,29.1702917,33.0435,0.145,NULL,67738657875,1058416529,16537758,13.16),(20289,'D-Sigma','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20289,33.74,0.4,56,5164,75,NULL,'Edat, cor','NGC 0736',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20290,'Faber-Jackson','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20290,33.08,0.44,41.3,5164,95,NULL,'Weighted Mean','NGC 0736',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20291,'Faber-Jackson','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20291,33.44,0.46,48.8,5164,95,NULL,'Michard 1979a','NGC 0736',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20292,'Faber-Jackson','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20292,33.67,0.63,54.2,5164,95,NULL,'Michard 1979b, c','NGC 0736',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20293,'Tertiary','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20293,32.77,0.32,35.8,5164,95,NULL,NULL,'NGC 0736',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20294,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20294,33.85,0.4,59,5164,NULL,NULL,'mean','NGC 0736',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20295,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20295,33.94,0.45,61.3,5164,NULL,NULL,'K','NGC 0736',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20296,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20296,37.71,0.13,349,5165,70,NULL,NULL,'2MASX J01564207+0106498',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000087,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,29.17525,1.11392,0.033,NULL,67003966258,1046936972,16358390,17.2),(20297,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20297,35.59,NULL,131,5166,NULL,NULL,NULL,'UGC 01417',NULL,'2000BSAO...50....5K',2000,1,1.03,NULL,'G',0.000012,NULL,'18.',0.09,'Sd',NULL,NULL,NULL,NULL,1,29.1787083,17.71072,0.117,NULL,66964063238,1046313488,16348648,18),(20298,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20298,35.6,NULL,132,5166,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01417',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20299,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20299,35.61,NULL,132,5166,NULL,NULL,'Dipole + Quadrupole','UGC 01417',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20300,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20300,35.61,NULL,133,5166,NULL,NULL,'Dipole','UGC 01417',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20301,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20301,35.66,0.48,136,5166,NULL,NULL,'Malmquist cor.','UGC 01417',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20302,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20302,35.81,0.45,145,5166,NULL,NULL,NULL,'UGC 01417',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20303,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20303,36.03,0.2,161,5166,74.4,NULL,NULL,'UGC 01417',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20304,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20304,34.23,0.43,70,5167,NULL,NULL,'Malmquist cor.','UGC 01420',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.00003,NULL,'14.73',0.6,'Sab',NULL,NULL,NULL,NULL,1,29.181375,15.01481,0.149,NULL,66960511562,1046257993,16347781,14.73),(20305,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20305,34.26,0.2,71.1,5167,74.4,NULL,NULL,'UGC 01420',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20306,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20306,34.31,0.41,72.8,5167,NULL,NULL,NULL,'UGC 01420',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20307,'IRAS','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20307,34.34,0.8,73.8,5168,75,NULL,'MAT, I','ESO 245- G 010',NULL,'1997ApJS..109..333W',1997,1,2.4,NULL,'G',0.000025,NULL,'14.28',0.6,'Sb pec',NULL,NULL,NULL,NULL,1,29.185375,-43.97258,NULL,NULL,38329349852,598896091,9357751,14.28),(20308,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20308,34.22,0.49,69.7,5168,75,NULL,'IR','ESO 245- G 010',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20309,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20309,34.27,0.32,71.6,5168,85,NULL,'I, raw','ESO 245- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20310,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20310,34.33,0.32,73.5,5168,85,NULL,'I, inv','ESO 245- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20311,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20311,34.35,0.43,74.2,5168,75,NULL,'MAT, I, raw','ESO 245- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20312,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20312,34.57,0.4,82.2,5168,NULL,NULL,'Malmquist cor.','ESO 245- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20313,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20313,34.6,0.43,83.1,5168,75,NULL,'MAT, I, inv','ESO 245- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20314,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20314,34.6,0.4,83.1,5168,NULL,NULL,'mean','ESO 245- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20315,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20315,34.61,0.43,83.5,5168,75,NULL,'MAT, I, cor','ESO 245- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20316,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20316,34.69,0.38,86.6,5168,NULL,NULL,NULL,'ESO 245- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20317,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20317,34.73,0.2,88.3,5168,74.4,NULL,NULL,'ESO 245- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20318,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20318,34.8,0.47,91,5168,NULL,NULL,'H','ESO 245- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20319,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20319,34.89,0.45,95,5168,NULL,NULL,'K','ESO 245- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20320,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20320,34.89,0.46,95.1,5168,NULL,NULL,'J','ESO 245- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20321,'IRAS','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20321,34.34,0.8,73.8,5169,75,NULL,'W91PP, r','UGC 01416',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000018,NULL,'14.72',0.6,'Sb','Group member, radial-velocity confirmed',NULL,NULL,'Sy 2',1,29.1919166667,36.88639,0.205,NULL,67746330720,1058536417,16539631,14.72),(20322,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20322,34.25,0.07,70.9,5169,NULL,NULL,NULL,'UGC 01416',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20323,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20323,35.13,0.38,106,5169,75,NULL,'W91PP, r, raw','UGC 01416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20324,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20324,35.3,0.38,115,5169,75,NULL,'W91PP, r, cor','UGC 01416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20325,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20325,35.32,0.38,116,5169,75,NULL,'W91PP, r, inv','UGC 01416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20326,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20326,35.34,0.43,117,5169,75,NULL,'3.6 micron, color corrected','UGC 01416',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20327,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20327,35.48,0.43,125,5169,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01416',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20328,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20328,31.71,0.46,21.9,5170,NULL,NULL,'J','CGCG 522-082',NULL,'2007A&A...465...71T',2007,1,0.8,'Two stars superposed.  1999ApJS..121..287H has V = 14519 +- 57.','G',0.000045,NULL,'15.3',0.5,'Spiral',NULL,NULL,NULL,NULL,1,29.2009583333,35.99481,0.261,NULL,67746133141,1058533330,16539583,15.3),(20329,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20329,31.79,0.47,22.8,5170,NULL,NULL,'H','CGCG 522-082',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20330,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20330,31.86,0.45,23.5,5170,NULL,NULL,'K','CGCG 522-082',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20331,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20331,34.68,0.4,86.3,5170,NULL,NULL,'mean','CGCG 522-082',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20332,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2005hc',NULL,20332,35.87,0.16,143,5171,74.2,NULL,'SALT 2','MCG +00-06-003',0.045,'2010ApJ...716..712A',2010,1,0.61,NULL,'G',0.00017,NULL,'16.74',0.32,NULL,NULL,NULL,NULL,NULL,1,29.202083,-0.21258,0.013,NULL,35002208338,546909505,8545461,16.74),(20333,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2005hc',NULL,20333,36.25,0.06,178,5171,72,NULL,'M(H) = -18.317 mag','MCG +00-06-003',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20334,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2005hc',NULL,20334,36.38,0.03,181,5171,70,NULL,'SALT 2','MCG +00-06-003',0.045,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20335,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2005hc',NULL,20335,36.59,0.13,190,5171,72,NULL,NULL,'MCG +00-06-003',0.04501,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20336,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2005hc',NULL,20336,36.51,0.05,192,5171,72,NULL,NULL,'MCG +00-06-003',0.045,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20337,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2005hc',NULL,20337,36.43,0.01,193,5171,72,NULL,NULL,'MCG +00-06-003',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20338,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2005hc',NULL,20338,36.44,0.09,194,5171,74.4,NULL,NULL,'MCG +00-06-003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20339,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2005hc',NULL,20339,36.56,0.14,197,5171,70,NULL,'SALT 2','MCG +00-06-003',0.045,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20340,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 05944','R',20340,36.57,0.18,197,5171,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005hc','MCG +00-06-003',0.04594,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20341,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2005hc',NULL,20341,36.57,0.18,197,5171,73.8,NULL,'SALT 2 (SNANA)','MCG +00-06-003',0.045,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20342,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2005hc',NULL,20342,36.58,0.13,198,5171,70,NULL,'SALT 2','MCG +00-06-003',0.045,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20343,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2005hc',NULL,20343,36.58,0.13,198,5171,72,NULL,'z lit','MCG +00-06-003',0.045,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20344,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2005hc',NULL,20344,36.49,0.07,198,5171,70,NULL,'Hubble residual 0.07 for z0.04594','MCG +00-06-003',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20345,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2005hc',NULL,20345,36.6,0.2,200,5171,73.8,NULL,'SALT 2 (SNANA)','MCG +00-06-003',0.045,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20346,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2005hc',NULL,20346,36.63,0.06,202,5171,65,NULL,'SALT2','MCG +00-06-003',0.045,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20347,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2005hc',NULL,20347,36.63,0.15,203,5171,65,NULL,'SALT, z SN CMB','MCG +00-06-003',0.045,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20348,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2005hc',NULL,20348,36.55,0.08,204,5171,70,NULL,'SALT 2','MCG +00-06-003',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20349,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2005hc',NULL,20349,36.56,0.08,205,5171,70,NULL,'SALT 2, Malmquist cor.','MCG +00-06-003',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20350,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2005hc',NULL,20350,36.7,0.03,209,5171,72,NULL,NULL,'MCG +00-06-003',0.045,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20351,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2005hc',NULL,20351,36.73,0.17,212,5171,65,NULL,'SALT2, z SN CMB','MCG +00-06-003',0.045,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20352,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2005hc',NULL,20352,36.76,0.14,215,5171,65,NULL,'MLCS17, z SN CMB','MCG +00-06-003',0.045,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20353,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2005hc','R',20353,36.67,0.05,216,5171,NULL,NULL,'MLCS2k2, R(V) = 1.8','MCG +00-06-003',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20354,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2005hc','R',20354,36.72,0.06,221,5171,NULL,NULL,'MLCS2k2, R(V) = 3.1','MCG +00-06-003',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20355,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 05944','R',20355,36.82,0.03,221,5171,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005hc','MCG +00-06-003',0.04594,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20356,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2005hc',NULL,20356,36.87,0.14,226,5171,65,NULL,'MLCS31, z SN CMB','MCG +00-06-003',0.045,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20357,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2005hc',NULL,20357,36.95,0.05,235,5171,65,NULL,'MLCS2k2','MCG +00-06-003',0.045,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20358,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 17949','R',20358,40.67,0.23,1080,5172,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17949',0.264127,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,29.205,-0.23558,0.013,NULL,35002208921,546909514,8545461,NULL),(20359,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 17949','R',20359,40.69,0.25,1090,5172,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17949',0.264127,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20360,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 17949',NULL,20360,40.38,0.16,1190,5172,70,NULL,'SN photometric redshift distance, z photo =0.331 +/- 0.032','SDSS-II SN 17949',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20361,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 17949',NULL,20361,40.57,0.15,1300,5172,70,NULL,'SALT 2','SDSS-II SN 17949',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20362,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 17949',NULL,20362,40.59,0.15,1310,5172,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 17949',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20363,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 04079','R',20363,41.48,0.28,1440,5173,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 04079',0.371731,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,29.206625,0.75403,0.013,NULL,67003652207,1046932065,16358313,NULL),(20364,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 04079','R',20364,41.67,0.24,1570,5173,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 04079',0.371731,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20365,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 04079',NULL,20365,41.04,0.16,1610,5173,70,NULL,'SN photometric redshift distance, z photo =0.486 +/- 0.052','SDSS-II SN 04079',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20366,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 04079',NULL,20366,41.37,0.16,1880,5173,70,NULL,'SALT 2','SDSS-II SN 04079',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20367,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 04079',NULL,20367,41.43,0.16,1930,5173,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 04079',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20368,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20368,37.86,0.46,373,5174,70,NULL,NULL,'SDSS J015650.62-075504.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000077,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,29.2109583,-7.91786,0.022,NULL,35108703345,548573489,8571460,18.4),(20369,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20369,36.6,0.46,209,5175,70,NULL,NULL,'2MASX J01565202+1312461',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000118,NULL,'16.1g',0.36,'E0',NULL,NULL,NULL,NULL,1,29.2165833333,13.21278,0.145,NULL,66929012970,1045765827,16340091,16.1),(20370,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20370,37.71,0.13,349,5176,70,NULL,NULL,'2MASX J01565219+0104282',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000075,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,29.2174583333,1.07442,0.009,NULL,67004002256,1046937535,16358398,17.2),(20371,'IRAS','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20371,33.67,0.8,54.3,5177,75,NULL,'CF, r','IC 0176',NULL,'1997ApJS..109..333W',1997,1,2.35,NULL,'G',0.000013,NULL,'14.70',0.33,'Sb',NULL,NULL,NULL,NULL,1,29.2225,-2.01897,0.025,NULL,35002947299,546921051,8545641,14.7),(20372,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20372,33.49,0.49,50,5177,75,NULL,'IR','IC 0176',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20373,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20373,33.55,NULL,51.3,5177,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 0176',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20374,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20374,33.56,NULL,51.4,5177,NULL,NULL,'Dipole','IC 0176',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20375,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20375,33.56,NULL,51.5,5177,NULL,NULL,'Dipole + Quadrupole','IC 0176',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20376,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20376,33.72,0.2,55.5,5177,74.4,NULL,NULL,'IC 0176',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20377,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20377,33.73,0.38,55.8,5177,75,NULL,'CF, r, raw','IC 0176',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20378,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20378,33.79,0.38,57.2,5177,75,NULL,'CF, r, inv','IC 0176',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20379,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20379,33.89,0.45,59.9,5177,NULL,NULL,NULL,'IC 0176',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20380,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20380,34,0.38,63,5177,75,NULL,'CF, r, cor','IC 0176',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20381,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20381,34.17,0.39,68.2,5177,NULL,NULL,'Malmquist cor.','IC 0176',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20382,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20382,34.62,0.46,84,5178,70,NULL,NULL,'CGCG 387-006',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000076,NULL,'15.3g',0.48,'E0',NULL,NULL,NULL,NULL,1,29.2285,-0.64025,0.029,NULL,35004962668,546952541,8546133,15.3),(20383,'IRAS','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20383,33.69,0.8,54.7,5179,75,NULL,'W91PP, r','NGC 0740',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.00002,NULL,'14.77',0.4,'SBb?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,29.228625,33.01517,0.145,NULL,67738624741,1058416011,16537750,14.77),(20384,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20384,33.92,0.38,60.7,5179,75,NULL,'W91PP, r, raw','NGC 0740',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20385,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20385,33.92,0.49,60.8,5179,75,NULL,'IR','NGC 0740',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20386,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20386,33.98,0.4,62.7,5179,NULL,NULL,'mean','NGC 0740',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20387,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20387,34.02,0.11,63.8,5179,NULL,NULL,NULL,'NGC 0740',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20388,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20388,34.03,0.38,63.8,5179,75,NULL,'W91PP, r, inv','NGC 0740',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20389,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20389,34.1,0.38,66,5179,75,NULL,'W91PP, r, cor','NGC 0740',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20390,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20390,34.24,0.47,70.3,5179,NULL,NULL,'H','NGC 0740',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20391,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20391,34.37,0.45,74.8,5179,NULL,NULL,'K','NGC 0740',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20392,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 01183','RN',20392,42.72,0.22,2540,5180,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01183',0.382523,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20393,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 01183','RN',20393,42.85,0.18,2690,5180,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01183',0.382523,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20394,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 04737','R',20394,41.82,0.3,1570,5181,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 04737',0.465436,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,'PHOT','21.8g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,29.2455417,-0.93839,0.025,NULL,35005617172,546962768,8546293,21.8),(20395,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 04737',NULL,20395,41.08,0.15,1640,5181,70,NULL,'SN photometric redshift distance, z photo =0.499 +/- 0.049','SDSS-II SN 04737',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20396,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 04737',NULL,20396,41.74,0.2,2230,5181,70,NULL,'SALT 2','SDSS-II SN 04737',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20397,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 04737',NULL,20397,41.84,0.2,2330,5181,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 04737',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20398,'Tully est','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20398,31.79,0.8,22.8,5182,75,NULL,NULL,'UGCA 022',NULL,'1988NBGC.C....0000T',1988,1,2.7,'6dF has z = 0.018016 +- 0.000183, but there appears to be a superposed star.','G',0.00002,NULL,'14.50',0.5,'SB(s)dm:','X-ray-bright group member',NULL,NULL,NULL,1,29.245667,-11.78047,0,NULL,35102808096,548481376,8570021,14.5),(20399,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20399,32.26,0.2,28.3,5182,74.4,NULL,NULL,'UGCA 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20400,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20400,32.28,0.4,28.6,5182,NULL,NULL,NULL,'UGCA 022',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20401,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20401,32.28,0.39,28.6,5182,73,NULL,'opt','UGCA 022',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20402,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20402,32.36,0.43,29.7,5182,75,NULL,'3.6 micron, color corrected','UGCA 022',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20403,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20403,32.4,0.43,30.2,5182,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 022',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20404,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20404,37.71,0.13,349,5183,70,NULL,NULL,'2MASX J01570000+0103172',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000087,NULL,'16.8g',0.12,'AGN',NULL,NULL,NULL,NULL,1,29.2499583,1.05464,0.013,NULL,67004000346,1046937505,16358398,16.8),(20405,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20405,37.35,0.46,294,5184,70,NULL,NULL,'2MASX J01570180-0933501',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000094,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,29.257583,-9.56383,0.036,NULL,35110701506,548604711,8571948,16.8),(20406,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20406,37.54,0.27,322,5185,70,NULL,NULL,'2MASX J01570289+1301090',NULL,'2015arXiv151105856S',2015,1,0.38,'May be a resolved component of 87GB[BWE91] 0154+1246.','G',0.000095,NULL,'16.6g',0.31,'NLAGN',NULL,NULL,NULL,'Sy 2',1,29.2619583333,13.01919,0.145,NULL,66928859971,1045763437,16340053,16.6),(20407,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20407,35.75,0.33,142,5186,70,NULL,NULL,'2MASX J01570379+1310010',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000101,NULL,'15.5g',0.46,'E0',NULL,NULL,NULL,NULL,1,29.2657083,13.16708,0.145,NULL,66929031455,1045766116,16340095,15.5),(20408,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20408,36.47,0.46,197,5187,70,NULL,NULL,'2MASX J01570451-0908191',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000093,NULL,'16.1g',0.39,'E0',NULL,NULL,NULL,NULL,1,29.268833,-9.13867,0.044,NULL,35110632277,548603629,8571931,16.1),(20409,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20409,34.7,0.49,87.3,5188,75,NULL,'IR','IC 1756',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000123,NULL,'15.30',0.2,'Sd(f)          HII',NULL,NULL,NULL,NULL,1,29.27225,-0.46825,0.029,NULL,35005118702,546954979,8546171,15.3),(20410,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20410,34.89,0.46,95.1,5188,NULL,NULL,'Malmquist cor.','IC 1756',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20411,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20411,34.91,0.4,96,5188,NULL,NULL,'mean','IC 1756',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20412,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20412,35.12,0.2,106,5188,74.4,NULL,NULL,'IC 1756',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20413,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20413,35.15,0.47,107,5188,NULL,NULL,'H','IC 1756',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20414,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20414,35.26,0.39,113,5188,NULL,NULL,NULL,'IC 1756',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20415,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20415,36.83,0.46,233,5189,70,NULL,NULL,'2MASX J01570624+1430270',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000085,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,29.2760833333,14.50764,0.137,NULL,66960623511,1046259742,16347808,16.4),(20416,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 15373','RN',20416,39.99,0.08,837,5190,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 15373',0.189917,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20417,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20417,35.16,0.46,108,5191,70,NULL,NULL,'2MASX J01570732+1455432',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000075,NULL,'15.7g',0.46,'S0^-',NULL,NULL,NULL,NULL,1,29.2805,14.92878,0.145,NULL,66960532887,1046258326,16347786,15.7),(20418,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20418,37.12,0.46,266,5192,70,NULL,NULL,'2MASX J01570834+1228552',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000098,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,29.28475,12.48197,0.177,NULL,66929116753,1045767449,16340116,17.3),(20419,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20419,35.13,0.37,106,5193,NULL,NULL,'Malmquist cor.','IC 1755',NULL,'2009ApJS..182..474S',2009,1,1.44,NULL,'G',0.000037,NULL,'14.6g',0.36,'Sb(f)',NULL,NULL,NULL,NULL,1,29.2907917,14.54989,0.137,NULL,66960628699,1046259823,16347809,14.6),(20420,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20420,35.14,0.37,107,5193,NULL,NULL,NULL,'IC 1755',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20421,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20421,35.18,0.2,109,5193,74.4,NULL,NULL,'IC 1755',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20422,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20422,35.25,0.49,112,5193,75,NULL,'IR','IC 1755',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20423,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20423,37.54,0.27,322,5194,70,NULL,NULL,'SDSS J015709.95+130013.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00007,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,29.2914583,13.00375,0.145,NULL,66928854236,1045763347,16340052,18.5),(20424,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20424,35.61,0.27,132,5195,70,NULL,NULL,'CGCG 438-008',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000098,NULL,'15.5g',0.57,'E0',NULL,NULL,NULL,NULL,1,29.3040417,14.73544,0.137,NULL,66960651716,1046260183,16347815,15.5),(20425,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20425,35.65,0.51,135,5196,NULL,NULL,'Malmquist cor.','2MASX J01571518+1450072',NULL,'2009ApJS..182..474S',2009,1,0.58,NULL,'G',0.000084,NULL,'16.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,29.3132917,14.83533,0.137,NULL,66960703840,1046260997,16347828,16.3),(20426,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20426,35.87,0.47,149,5196,NULL,NULL,NULL,'2MASX J01571518+1450072',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20427,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20427,35.91,0.2,152,5196,74.4,NULL,NULL,'2MASX J01571518+1450072',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20428,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 03320','RN',20428,41.77,0.12,1620,5197,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03320',0.389268,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20429,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 03320','RN',20429,41.97,0.2,1780,5197,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03320',0.389268,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20430,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20430,35.75,0.33,142,5198,70,NULL,NULL,'2MASX J01571839+1307462',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000068,NULL,'16.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,29.326667,13.12939,0.145,NULL,66929027877,1045766060,16340094,16.4),(20431,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20431,34.19,0.2,68.9,5199,74.4,NULL,NULL,'KUG 0154+041',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',NULL,NULL,'15.7',0.4,'Spiral',NULL,NULL,NULL,NULL,1,29.335625,4.34847,0.121,NULL,66999511342,1046867364,16357302,15.7),(20432,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20432,34.37,0.38,74.9,5199,NULL,NULL,NULL,'KUG 0154+041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20433,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20433,34.43,0.37,77,5199,NULL,NULL,'Malmquist cor.','KUG 0154+041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20434,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 21591',NULL,20434,37.76,1.36,356,5200,70,NULL,'SN photometric redshift distance, z photo =0.087 +/- 0.083','SDSS-II SN 21591',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,29.34275,-0.10142,0.021,NULL,35002053029,546907078,8545423,NULL),(20435,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20435,35.81,0.46,145,5201,70,NULL,NULL,'2MASX J01572273-0930304',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000095,NULL,'15.8g',0.44,'S0^-',NULL,NULL,NULL,NULL,1,29.344875,-9.50847,0.036,NULL,35110680790,548604387,8571943,15.8),(20436,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20436,37.85,0.27,371,5202,70,NULL,NULL,'2MASX J01572310-0927051',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00008,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,29.346167,-9.45147,0.036,NULL,35110745814,548605403,8571959,18.1),(20437,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20437,37.78,0.46,360,5203,70,NULL,NULL,'2MASX J01572428+1443122',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000084,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,29.3510417,14.72,0.137,NULL,66961115086,1046267423,16347928,17.5),(20438,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 04639',NULL,20438,38.17,1.07,430,5204,70,NULL,'SN photometric redshift distance, z photo =0.106 +/- 0.074','SDSS-II SN 04639',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','21.5g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,29.357625,-0.75728,0.025,NULL,35005548839,546961700,8546276,21.5),(20439,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 04639','R',20439,41.9,0.27,1750,5204,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 04639',0.365265,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20440,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 04639','R',20440,41.94,0.34,1790,5204,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 04639',0.365265,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20441,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20441,37.54,0.27,322,5205,70,NULL,NULL,'SDSS J015726.36+130451.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000068,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,29.359833,13.08106,0.157,NULL,66928975858,1045765247,16340081,18.1),(20442,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20442,35.11,0.49,105,5206,75,NULL,'IR','2MFGC 01488',NULL,'2011yCatp016004901K',2011,1,0.83,NULL,'G',0.000066,NULL,'16.8g',0.17,'Sd(f)',NULL,NULL,NULL,NULL,1,29.3677083,14.43064,0.137,NULL,66961081348,1046266896,16347920,16.8),(20443,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20443,35.22,0.44,111,5206,NULL,NULL,'Malmquist cor.','2MFGC 01488',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20444,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20444,35.28,0.42,114,5206,NULL,NULL,NULL,'2MFGC 01488',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20445,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20445,37.63,0.46,335,5207,70,NULL,NULL,'2MASX J01572933+1358462',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000072,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,29.37225,13.9795,0.113,NULL,66961500280,1046273441,16348022,17.1),(20446,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20446,38.26,0.46,449,5208,70,NULL,NULL,'2MASX J01572950+1326351',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000081,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,29.3730416667,13.44314,0.145,NULL,66958422303,1046225348,16347271,17.5),(20447,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20447,34.37,0.4,74.8,5209,NULL,NULL,'mean','NGC 0747',NULL,'2007A&A...465...71T',2007,1,1.04,NULL,'G',0.000023,NULL,'14.1g',0.54,'Sb:',NULL,NULL,NULL,NULL,1,29.376875,-9.46236,0.036,NULL,35110734572,548605227,8571956,14.1),(20448,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20448,34.53,0.47,80.7,5209,NULL,NULL,'H','NGC 0747',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20449,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20449,34.57,0.45,82,5209,NULL,NULL,'K','NGC 0747',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20450,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20450,34.59,0.46,82.9,5209,NULL,NULL,'J','NGC 0747',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20451,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20451,34.77,0.2,90,5209,74.4,NULL,NULL,'NGC 0747',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20452,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 14419','R',20452,38.37,0.12,417,5210,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 14419',0.134019,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',NULL,'PHOT','20.3g',0.07,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,29.377333,1.16408,0.029,NULL,67003155047,1046924297,16358192,20.3),(20453,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 14419',NULL,20453,38.35,0.42,468,5210,70,NULL,'SN photometric redshift distance, z photo =0.116 +/- 0.027','SDSS-II SN 14419',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20454,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 14419','R',20454,38.72,0.21,490,5210,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 14419',0.134019,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20455,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20455,37.85,0.27,371,5211,70,NULL,NULL,'2MASX J01573125-0929154',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000088,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,29.3800833333,-9.48753,0.036,NULL,35110734278,548605223,8571956,17),(20456,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20456,36.15,0.52,170,5212,70,NULL,NULL,'2MASX J01573263-0725564',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,29.3859166667,-7.43231,0.021,NULL,35106853668,548544588,8571009,14.4),(20457,'D-Sigma','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20457,33.62,0.4,53,5213,75,NULL,'Edat, raw','NGC 0750',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000027,NULL,'12.89',1.3,'E pec','Pair member (points to parent)',NULL,NULL,NULL,1,29.386375,33.20928,0.149,NULL,67739025493,1058422273,16537848,12.89),(20458,'D-Sigma','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20458,33.74,0.4,56,5213,75,NULL,'Edat, cor','NGC 0750',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20459,'Faber-Jackson','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20459,32.13,0.76,26.7,5213,95,NULL,'de Vaucouleurs','NGC 0750',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20460,'Faber-Jackson','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20460,32.82,0.33,36.6,5213,95,NULL,'Weighted Mean','NGC 0750',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20461,'Faber-Jackson','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20461,33.38,0.63,47.4,5213,95,NULL,'Michard 1979b, c','NGC 0750',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20462,'Faber-Jackson','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20462,33.44,0.46,48.8,5213,95,NULL,'Michard 1979a','NGC 0750',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20463,'Faber-Jackson','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20463,34.69,0.81,86.7,5213,55,NULL,'Visvanathan & Sandage 1979','NGC 0750',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20464,'Tertiary','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20464,32.77,0.32,35.8,5213,95,NULL,NULL,'NGC 0750',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20465,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20465,33,0.45,39.9,5213,NULL,NULL,'K','NGC 0750',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20466,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20466,34.26,0.4,71.1,5213,NULL,NULL,'mean','NGC 0750',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20467,'Faber-Jackson','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20467,33.1,0.44,41.7,5214,95,NULL,'Weighted Mean','NGC 0751',NULL,'1984ApJS...56...91D',1984,1,1.4,NULL,'G',0.000027,NULL,'13.5',1.4,'E pec','Pair member (points to parent)',NULL,NULL,NULL,1,29.3874583,33.20308,0.149,NULL,67739025478,1058422273,16537848,13.5),(20468,'Faber-Jackson','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20468,33.4,0.63,47.9,5214,95,NULL,'Michard 1979b, c','NGC 0751',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20469,'Faber-Jackson','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20469,33.64,0.46,53.5,5214,95,NULL,'Michard 1979a','NGC 0751',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20470,'Tertiary','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20470,32.77,0.32,35.8,5214,95,NULL,NULL,'NGC 0751',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20471,'GRB','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20471,44.12,0.28,3230,5215,NULL,NULL,NULL,'GRB 091208B',1.063,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,29.3922083333,16.88975,0.133,NULL,66970996866,1046421826,16350341,NULL),(20472,'GRB','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20472,44.3,0.09,7240,5215,NULL,NULL,NULL,'GRB 091208B',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20473,'GRB','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20473,44.77,0.77,8990,5215,NULL,NULL,NULL,'GRB 091208B',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20474,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20474,36.27,0.52,179,5216,70,NULL,NULL,'2MASX J01573731-0649144',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.64',0.36,NULL,NULL,NULL,NULL,NULL,1,29.4055,-6.82058,0.038,NULL,35152865101,549263517,8582242,16.64),(20475,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 19365','RN',20475,41.85,0.28,1700,5217,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2007os','SDSS-II SN 19365',0.379667,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20476,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 19365','RN',20476,41.98,0.22,1810,5217,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2007os','SDSS-II SN 19365',0.379667,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20477,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 19365','N',20477,41.76,0.16,2250,5217,70,NULL,'SALT 2','SDSS-II SN 19365',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20478,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 19365','N',20478,41.82,0.16,2310,5217,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19365',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20479,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 19346',NULL,20479,38.86,0.82,591,5218,70,NULL,'SN photometric redshift distance, z photo =0.149 +/- 0.077','SDSS-II SN 19346',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','22.1g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,29.417583,0.32744,0.009,NULL,67003534908,1046930232,16358284,22.1),(20480,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 19346','R',20480,41.57,0.24,1520,5218,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19346',0.361973,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20481,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 19346','R',20481,41.71,0.44,1610,5218,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19346',0.361973,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20482,'Ring Diameter','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20482,32.8,0.84,37,5219,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 0782',NULL,'1981ApJS...45..541P',1981,1,2.3,NULL,'G',0.000026,NULL,'12.48',2,'SB(r)b',NULL,NULL,NULL,NULL,1,29.41825,-57.79017,0,NULL,36170172592,565158946,8830608,12.48),(20483,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20483,33.48,0.51,49.6,5219,70,NULL,NULL,'NGC 0782',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20484,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20484,37.85,0.27,371,5220,70,NULL,NULL,'2MASX J01574132-0927083',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000087,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,29.42225,-9.45233,0.036,NULL,35110735420,548605240,8571956,17.4),(20485,'IRAS','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20485,33.91,0.8,60.5,5221,75,NULL,'W91PP, r','NGC 0753',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000007,NULL,'12.97',1.9,'SAB(rs)bc','in a pair',NULL,NULL,NULL,1,29.425833,35.91611,0.217,NULL,67746105355,1058532896,16539576,12.97),(20486,'IRAS','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20486,33.96,0.8,62.1,5221,75,NULL,'CF, r','NGC 0753',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20487,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20487,33.04,0.38,40.5,5221,75,NULL,'W91PP, r, raw','NGC 0753',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20488,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20488,33.22,0.38,44,5221,75,NULL,'W91PP, r, inv','NGC 0753',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20489,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20489,33.37,NULL,47.2,5221,NULL,NULL,'I','NGC 0753',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20490,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20490,33.41,NULL,48.1,5221,NULL,NULL,'B','NGC 0753',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20491,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20491,33.48,0.38,49.6,5221,75,NULL,'W91PP, r, cor','NGC 0753',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20492,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20492,33.54,NULL,51.1,5221,NULL,NULL,'B','NGC 0753',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20493,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20493,33.56,NULL,51.5,5221,NULL,NULL,'I','NGC 0753',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20494,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20494,33.56,0.38,51.6,5221,75,NULL,'CF, r, raw','NGC 0753',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20495,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20495,33.61,0.45,52.8,5221,NULL,NULL,'K','NGC 0753',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20496,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20496,33.65,0.46,53.7,5221,NULL,NULL,'J','NGC 0753',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20497,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20497,33.66,0.47,53.9,5221,NULL,NULL,'H','NGC 0753',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20498,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20498,33.77,0.38,56.6,5221,75,NULL,'CF, r, inv','NGC 0753',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20499,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20499,33.87,0.38,59.4,5221,75,NULL,'CF, r, cor','NGC 0753',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20500,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20500,34.12,0.4,66.5,5221,NULL,NULL,'mean','NGC 0753',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20501,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20501,34.13,0.07,67.1,5221,NULL,NULL,NULL,'NGC 0753',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20502,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2005lj',NULL,20502,37.59,0.14,306,5222,74.2,NULL,'SALT 2','APMUKS(BJ) B015509.46-002521.6',0.078,'2010ApJ...716..712A',2010,1,0.28,NULL,'G',NULL,NULL,'18.84',0.16,NULL,NULL,NULL,NULL,NULL,1,29.429625,-0.17939,0.021,NULL,35004879122,546951236,8546113,18.84),(20503,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2005lj',NULL,20503,38.22,0.14,408,5222,70,NULL,'SALT 2','APMUKS(BJ) B015509.46-002521.6',0.078,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20504,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 10096','R',20504,38.28,0.13,421,5222,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005lj','APMUKS(BJ) B015509.46-002521.6',0.077649,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20505,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 10096','R',20505,38.37,0.2,438,5222,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005lj','APMUKS(BJ) B015509.46-002521.6',0.077649,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20506,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 18100','R',20506,42.44,0.31,2060,5223,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18100',0.498089,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,29.4327917,0.42414,0.021,NULL,67003723060,1046933172,16358330,NULL),(20507,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 18178','RN',20507,42.74,0.24,2480,5224,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18178',0.428235,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20508,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 18178','RN',20508,42.81,0.25,2550,5224,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18178',0.428235,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20509,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20509,37.74,0.46,353,5225,70,NULL,NULL,'2MASX J01574486-0022173',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000071,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,29.436917,-0.37161,0.025,NULL,35004915797,546951809,8546122,18.1),(20510,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20510,35.93,0.33,153,5226,70,NULL,NULL,'MCG -02-06-008',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.00009,NULL,'15.4g',0.43,'E0',NULL,NULL,NULL,NULL,1,29.4415833333,-8.55944,0.013,NULL,35108544585,548571009,8571422,15.4),(20511,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20511,36.61,0.59,209,5226,70,NULL,NULL,'MCG -02-06-008',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20512,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20512,38.67,0.46,542,5227,70,NULL,NULL,'SDSS J015747.47-092731.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000071,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,29.4478333333,-9.45883,0.036,NULL,35110552370,548602380,8571912,18.6),(20513,'IRAS','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20513,34.32,0.8,73.3,5228,75,NULL,'MAT, I','IC 1762',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000017,NULL,'13.84',0.4,'SB(s)bc        HII','in a pair',NULL,NULL,NULL,1,29.452667,-33.23981,NULL,NULL,38290622864,598290982,9348296,13.84),(20514,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20514,33.53,NULL,50.8,5228,NULL,NULL,'B','IC 1762',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20515,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20515,33.91,0.32,60.5,5228,85,NULL,'I, raw','IC 1762',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20516,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20516,33.92,0.43,60.7,5228,75,NULL,'MAT, I, raw','IC 1762',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20517,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20517,33.95,0.32,61.7,5228,85,NULL,'I, inv','IC 1762',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20518,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20518,34.12,0.43,66.6,5228,75,NULL,'MAT, I, inv','IC 1762',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20519,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20519,34.12,NULL,66.7,5228,NULL,NULL,'I','IC 1762',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20520,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20520,34.16,0.43,67.9,5228,75,NULL,'MAT, I, cor','IC 1762',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20521,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20521,34.4,0.2,75.9,5228,74.4,NULL,NULL,'IC 1762',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20522,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20522,34.48,0.29,78.9,5228,NULL,NULL,'Malmquist cor.','IC 1762',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20523,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20523,34.49,0.4,79,5228,NULL,NULL,'mean','IC 1762',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20524,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20524,34.6,0.27,83.2,5228,NULL,NULL,NULL,'IC 1762',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20525,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20525,34.7,0.47,87.2,5228,NULL,NULL,'H','IC 1762',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20526,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20526,37.48,0.46,314,5229,70,NULL,NULL,'2MASX J01574911-0841563',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000091,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,29.4545417,-8.69908,0.028,NULL,35108508015,548570437,8571413,16.3),(20527,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20527,34.15,0.47,67.7,5230,NULL,NULL,'H','NGC 0761',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000033,NULL,'14.40',0.5,'SBa:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,29.456625,33.37714,0.149,NULL,67738822428,1058419100,16537798,14.4),(20528,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20528,34.18,0.45,68.4,5230,NULL,NULL,'K','NGC 0761',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20529,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20529,34.21,0.4,69.5,5230,NULL,NULL,'mean','NGC 0761',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20530,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20530,34.22,0.46,69.7,5230,NULL,NULL,'J','NGC 0761',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20531,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 18456','R',20531,39.94,0.2,796,5231,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007lk','SDSS J015750.12-002353.2',0.22,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',NULL,NULL,'20.2g',0.06,NULL,NULL,NULL,NULL,NULL,1,29.458875,-0.39814,0.025,NULL,35005095366,546954615,8546165,20.2),(20532,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 18456','R',20532,40.14,0.12,874,5231,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007lk','SDSS J015750.12-002353.2',0.22,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20533,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2007lk',NULL,20533,39.82,0.09,920,5231,70,NULL,'SALT 2','SDSS J015750.12-002353.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20534,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2007lk',NULL,20534,39.84,0.09,929,5231,70,NULL,'SALT 2, Malmquist cor.','SDSS J015750.12-002353.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20535,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20535,34.17,0.4,68.2,5232,NULL,NULL,'mean','UGC 01441',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.00005,NULL,'15.50',0.2,'Sb',NULL,NULL,NULL,NULL,1,29.4589583,37.36172,0.213,NULL,67744985287,1058515395,16539303,15.5),(20536,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20536,34.62,0.49,83.9,5232,75,NULL,'IR','UGC 01441',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20537,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20537,34.64,0.47,84.9,5232,NULL,NULL,'H','UGC 01441',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20538,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2002fb',NULL,20538,34.07,0.09,65.2,5233,74.4,NULL,NULL,'NGC 0759',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.000047,NULL,'13.3B',1.4,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,29.4597083333,36.34311,0.205,NULL,67745964855,1058530700,16539542,13.3),(20539,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2002fb',NULL,20539,34.21,0.23,68.4,5233,65,NULL,'MLCS31','NGC 0759',0.015567,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20540,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2002fb',NULL,20540,34.37,0.22,73.6,5233,65,NULL,'MLCS17','NGC 0759',0.015567,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20541,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20541,34.07,0.09,65.2,5233,74.4,NULL,NULL,'NGC 0759',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20542,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20542,34.08,0.24,65.4,5233,70,NULL,NULL,'NGC 0759',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20543,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20543,34.12,0.4,66.7,5233,NULL,NULL,'mean','NGC 0759',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20544,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20544,34.61,0.45,83.4,5233,NULL,NULL,'K','NGC 0759',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20545,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20545,35.61,0.27,132,5234,70,NULL,NULL,'2MASX J01575057+1429345',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000075,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,29.4607917,14.49306,0.129,NULL,66961139332,1046267802,16347934,17.1),(20546,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20546,30.44,0.4,12.3,5235,75,NULL,'B','NGC 0746',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000013,NULL,'13.5',1.3,'Im',NULL,NULL,NULL,NULL,1,29.4625417,44.91858,0.537,NULL,67822183474,1059721616,16558150,13.5),(20547,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 04488','RN',20547,40.75,0.13,1190,5236,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 04488',0.189801,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20548,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 04488','RN',20548,41.35,0.19,1560,5236,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04488',0.189801,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20549,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20549,37.1,0.46,263,5237,70,NULL,NULL,'2MASX J01575521+1247355',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000089,NULL,'16.3g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,29.48,12.79325,0.201,NULL,66929450481,1045772663,16340197,16.3),(20550,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20550,35.99,0.46,158,5238,70,NULL,NULL,'SDSS J015755.83+132129.2',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'15.6g',0.37,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,29.482667,13.35814,0.157,NULL,66958636337,1046228692,16347323,15.6),(20551,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20551,37.99,0.46,397,5239,70,NULL,NULL,'2MASX J01575625-0914132',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000079,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,29.484375,-9.23692,0.036,NULL,35110581686,548602838,8571919,17.7),(20552,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20552,34.95,0.23,97.7,5240,NULL,NULL,'B, Hubble-type-TF','ESO 297- G 036',NULL,'2005Ap&SS.299..387R',2005,1,1.05,NULL,'G',0.000033,NULL,'14.72',0.55,'SAB?(rs?)c',NULL,NULL,NULL,NULL,1,29.4947917,-38.01944,NULL,NULL,38299641761,598431902,9350498,14.72),(20553,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20553,34.95,NULL,97.7,5240,NULL,NULL,'B, Hubble-type-TF','ESO 297- G 036',NULL,'2005Ap&SS.299..405R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20554,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20554,34.95,0.23,97.7,5240,NULL,NULL,'B, Hubble-type-TF','ESO 297- G 036',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20555,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20555,35.47,0.5,124,5240,NULL,NULL,'Malmquist cor.','ESO 297- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20556,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20556,35.61,0.47,132,5240,NULL,NULL,NULL,'ESO 297- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20557,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20557,35.65,0.2,135,5240,74.4,NULL,NULL,'ESO 297- G 036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20558,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20558,33.61,0.23,52.7,5241,74.4,NULL,NULL,'CGCG 522-089',NULL,'2013AJ....146...86T',2013,1,0.2,NULL,'G',0.00018,NULL,'15.7',0.2,'E',NULL,NULL,NULL,NULL,1,29.4995417,36.91789,0.185,NULL,67745548308,1058524192,16539440,15.7),(20559,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20559,34.57,0.2,82,5242,74.4,NULL,NULL,'UGC 01444',NULL,'2013AJ....146...86T',2013,1,1.9,NULL,'G',0.000013,NULL,'15.12',0.4,'S?',NULL,NULL,NULL,NULL,1,29.499583,4.39506,0.109,NULL,66999473508,1046866773,16357293,15.12),(20560,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20560,34.59,0.37,82.7,5242,NULL,NULL,'Malmquist cor.','UGC 01444',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20561,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20561,34.67,0.36,86.1,5242,NULL,NULL,NULL,'UGC 01444',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20562,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20562,35.05,0.19,102,5243,NULL,NULL,'B, Hubble-type-TF','ESO 354- G 019',NULL,'2005Ap&SS.298..577R',2005,1,1.2,NULL,'G',0.000033,NULL,'14.37',0.7,'Sb',NULL,NULL,NULL,NULL,1,29.502375,-35.57258,NULL,NULL,38300562411,598446287,9350723,14.37),(20563,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20563,35.68,0.28,137,5243,NULL,NULL,'Malmquist cor.','ESO 354- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20564,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20564,35.81,0.27,145,5243,NULL,NULL,NULL,'ESO 354- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20565,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20565,35.85,0.2,148,5243,74.4,NULL,NULL,'ESO 354- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20566,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20566,37.57,0.46,326,5244,70,NULL,NULL,'2MASX J01580153-0900122',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000097,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,29.506333,-9.00356,0.027,NULL,35108465430,548569772,8571402,16.8),(20567,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 11305',NULL,20567,39.28,1.45,717,5245,70,NULL,'SN photometric redshift distance, z photo =0.184 +/- 0.218','SDSS-II SN 11305',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.6g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,29.5195,-0.57139,0.025,NULL,35005057146,546954017,8546156,22.6),(20568,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 00933','RN',20568,42.49,0.22,1990,5246,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00933',0.584619,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20569,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 21027','RN',20569,41.02,0.28,1260,5247,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 21027',0.273548,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20570,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 21027','RN',20570,41.69,0.41,1710,5247,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21027',0.273548,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20571,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20571,35.93,0.33,153,5248,70,NULL,NULL,'2MASX J01580734-0835012',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000085,NULL,'16.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,29.5307083,-8.58369,0.013,NULL,35108549168,548571080,8571423,16.5),(20572,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20572,34.16,0.49,68,5249,75,NULL,'IR','UGC 01448',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000033,NULL,'14.91',0.3,'Scd:','Isolated galaxy',NULL,NULL,NULL,1,29.535667,2.0645,0.037,NULL,67004489981,1046945155,16358518,14.91),(20573,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20573,34.47,0.2,78.3,5249,74.4,NULL,NULL,'UGC 01448',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20574,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20574,34.58,0.33,82.6,5249,NULL,NULL,'Malmquist cor.','UGC 01448',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20575,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20575,34.68,0.31,86.1,5249,NULL,NULL,NULL,'UGC 01448',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20576,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20576,36.32,0.46,184,5250,70,NULL,NULL,'2MASX J01580924+1303133',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000087,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,29.5385,13.05378,0.157,NULL,66928962149,1045765033,16340078,16.6),(20577,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20577,36.98,0.72,249,5251,70,NULL,NULL,'2MASX J01581000-4807369',NULL,'2014MNRAS.445.2677S',2014,1,0.82,'The APM image includes a superposed star.','G',0.000103,NULL,'15.48',0.33,'Sab',NULL,NULL,NULL,NULL,1,29.5415833333,-48.12683,NULL,NULL,38239054394,597485224,9335706,15.48),(20578,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20578,38.08,0.46,413,5252,70,NULL,NULL,'2MASXi J0158123+143443',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000078,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,29.551417,14.57867,0.129,NULL,66961223370,1046269115,16347954,17.6),(20579,'IRAS','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20579,34.26,0.8,71.1,5253,75,NULL,'MAT, I','ESO 297- G 037',NULL,'1997ApJS..109..333W',1997,1,1.68,NULL,'G',0.000033,NULL,'14.56',0.34,'SB(rs)b:',NULL,NULL,NULL,NULL,1,29.5535417,-39.54475,NULL,NULL,38320293657,598754588,9355540,14.56),(20580,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20580,34,0.43,63.1,5253,75,NULL,'MAT, I, raw','ESO 297- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20581,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20581,34.06,0.32,65,5253,85,NULL,'I, raw','ESO 297- G 037',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20582,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20582,34.11,0.32,66.4,5253,85,NULL,'I, inv','ESO 297- G 037',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20583,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20583,34.21,0.43,69.5,5253,75,NULL,'MAT, I, inv','ESO 297- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20584,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20584,34.27,0.43,71.5,5253,75,NULL,'MAT, I, cor','ESO 297- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20585,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20585,34.44,0.49,77.4,5253,75,NULL,'IR','ESO 297- G 037',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20586,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20586,34.48,0.4,78.5,5253,NULL,NULL,'mean','ESO 297- G 037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20587,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20587,34.52,0.32,80.2,5253,NULL,NULL,'Malmquist cor.','ESO 297- G 037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20588,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20588,34.65,0.47,85.1,5253,NULL,NULL,'H','ESO 297- G 037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20589,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20589,34.7,0.3,87,5253,NULL,NULL,NULL,'ESO 297- G 037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20590,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20590,34.74,0.2,88.7,5253,74.4,NULL,NULL,'ESO 297- G 037',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20591,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 15817',NULL,20591,40.99,0.23,1580,5254,70,NULL,'SN photometric redshift distance, z photo =0.472 +/- 0.073','SDSS-II SN 15817',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,29.5645417,0.01328,0.021,NULL,67001385315,1046896645,16357760,NULL),(20592,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2006td',NULL,20592,33.64,0.21,52.6,5255,74.2,NULL,'SALT 2','KUG 0155+361',0.01588,'2010ApJ...716..712A',2010,1,0.4,NULL,'G',NULL,NULL,'16  :',0.4,'Spiral',NULL,NULL,NULL,NULL,1,29.5657917,36.34828,0.205,NULL,67745947318,1058530426,16539537,16),(20593,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2006td',NULL,20593,34.26,0.04,70,5255,72,NULL,'MLCS31','KUG 0155+361',0.01588,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20594,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2006td',NULL,20594,34.23,0.09,70.2,5255,74.4,NULL,NULL,'KUG 0155+361',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20595,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2006td',NULL,20595,34.3,0.2,71.4,5255,70,NULL,'SALT 2','KUG 0155+361',0.01588,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20596,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2006td',NULL,20596,34.32,0.18,72,5255,73.8,NULL,'SALT 2 (SNANA)','KUG 0155+361',0.016,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20597,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2006td',NULL,20597,34.43,0.25,75.5,5255,65,NULL,'MLCS31','KUG 0155+361',0.01588,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20598,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2006td',NULL,20598,34.46,0.24,76.9,5255,65,NULL,'MLCS17','KUG 0155+361',0.01588,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20599,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2006td',NULL,20599,34.54,0.23,79.5,5255,65,NULL,'SALT','KUG 0155+361',0.01588,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20600,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2006td',NULL,20600,34.56,0.25,80.2,5255,65,NULL,'SALT2','KUG 0155+361',0.01588,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20601,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2006td',NULL,20601,35.55,0.04,127,5255,70,NULL,'SALT 2','KUG 0155+361',0.01588,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20602,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20602,35.61,0.27,132,5256,70,NULL,NULL,'UGC 01450',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000098,NULL,'15.0g',0.66,'E0',NULL,NULL,NULL,NULL,1,29.5675833333,14.29661,0.129,NULL,66961983211,1046280987,16348140,15),(20603,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 15807','RN',20603,41.05,0.16,1340,5257,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15807',0.209262,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20604,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 15807','RN',20604,41.13,0.23,1390,5257,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15807',0.209262,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20605,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 09672','RN',20605,38.74,0.38,470,5258,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 09672',0.189282,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20606,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 09672','RN',20606,39.86,0.37,787,5258,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 09672',0.189282,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20607,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20607,37.04,0.46,256,5259,70,NULL,NULL,'2MASX J01582547+0109511',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000077,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,29.6060833333,1.16419,0.029,NULL,67003180536,1046924695,16358198,17),(20608,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 19986',NULL,20608,40.51,0.16,1260,5260,70,NULL,'SN photometric redshift distance, z photo =0.355 +/- 0.034','SDSS-II SN 19986',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,29.6242917,0.15794,0.021,NULL,67001441371,1046897521,16357773,NULL),(20609,'IRAS','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20609,34.02,0.8,63.5,5261,75,NULL,'W91PP, r','UGC 01451',NULL,'1997ApJS..109..333W',1997,1,1.35,NULL,'G',0.00002,NULL,'14.27',0.59,'SBb            HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,29.6251666667,25.36011,0.373,NULL,68587134395,1071673974,16744905,14.27),(20610,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20610,33.4,0.2,47.9,5261,74.4,NULL,NULL,'UGC 01451',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20611,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20611,33.43,0.38,48.6,5261,75,NULL,'W91PP, r, raw','UGC 01451',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20612,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20612,33.44,0.47,48.8,5261,NULL,NULL,'H','UGC 01451',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20613,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20613,33.47,0.45,49.5,5261,NULL,NULL,'K','UGC 01451',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20614,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20614,33.58,0.38,52,5261,75,NULL,'W91PP, r, inv','UGC 01451',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20615,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20615,33.58,0.59,52,5261,NULL,NULL,NULL,'UGC 01451',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20616,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20616,33.64,0.46,53.4,5261,NULL,NULL,'J','UGC 01451',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20617,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20617,33.79,0.38,57.4,5261,75,NULL,'W91PP, r, cor','UGC 01451',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20618,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20618,33.87,0.52,59.3,5261,NULL,NULL,'Malmquist cor.','UGC 01451',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20619,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20619,34.17,0.4,68.3,5261,NULL,NULL,'mean','UGC 01451',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20620,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20620,33.74,NULL,56,5262,NULL,NULL,NULL,'UGC 01452',NULL,'2000BSAO...50....5K',2000,1,1.12,NULL,'G',0.000027,NULL,'17.',0.15,'Sdm',NULL,NULL,NULL,NULL,1,29.6290416667,22.11519,0.289,NULL,68049831902,1063278623,16613728,17),(20621,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20621,33.78,NULL,57,5262,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01452',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20622,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20622,33.79,NULL,57.2,5262,NULL,NULL,'Dipole + Quadrupole','UGC 01452',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20623,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20623,33.79,NULL,57.4,5262,NULL,NULL,'Dipole','UGC 01452',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20624,'IRAS','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20624,33.75,0.8,56.1,5263,75,NULL,'MAT, I','NGC 0775',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00002,NULL,'13.23',1.2,'SA(r)cd',NULL,NULL,NULL,NULL,1,29.636125,-26.29372,0,NULL,38389416372,599834630,9372416,13.23),(20625,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20625,33.3,0.43,45.7,5263,75,NULL,'MAT, I, raw','NGC 0775',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20626,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20626,33.5,0.43,50.1,5263,75,NULL,'MAT, I, inv','NGC 0775',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20627,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20627,33.64,0.47,53.4,5263,NULL,NULL,'H','NGC 0775',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20628,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20628,33.66,0.45,53.8,5263,NULL,NULL,'K','NGC 0775',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20629,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20629,33.67,0.46,54.2,5263,NULL,NULL,'J','NGC 0775',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20630,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20630,33.7,0.43,54.8,5263,75,NULL,'MAT, I, cor','NGC 0775',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20631,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20631,33.89,0.4,60,5263,NULL,NULL,'mean','NGC 0775',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20632,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20632,33.96,0.32,61.9,5263,85,NULL,'I, raw','NGC 0775',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20633,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20633,34.02,0.32,63.6,5263,85,NULL,'I, inv','NGC 0775',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20634,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 21452','RN',20634,40.97,0.19,1380,5264,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 21452',0.13563,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20635,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 18457','R',20635,39.3,0.07,671,5265,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2007ll','SN 2007ll',0.080673,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'II?',NULL,NULL,NULL,NULL,1,29.6672083,-0.24906,0.017,NULL,35003849303,546935145,8545861,NULL),(20636,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 18457','R',20636,39.93,0.21,895,5265,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2007ll','SN 2007ll',0.080673,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20637,'IRAS','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20637,34.82,0.8,91.9,5266,75,NULL,'CF, r','NGC 0768',NULL,'1997ApJS..109..333W',1997,1,1.91,'CGCG misprints name as \'NGC 7628\'.','G',0.000037,NULL,'14.1g',0.57,'SB(r)bc:','Pair member (points to parent)',NULL,NULL,NULL,1,29.6705417,0.52922,0.009,NULL,67001577209,1046899643,16357806,14.1),(20638,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20638,34.24,0.69,70.4,5266,100,NULL,'mid-IR','NGC 0768',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20639,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20639,34.47,0.3,78.4,5266,NULL,NULL,NULL,'NGC 0768',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20640,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20640,34.5,0.3,79.4,5266,NULL,NULL,'Malmquist cor.','NGC 0768',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20641,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20641,34.51,0.2,79.8,5266,74.4,NULL,NULL,'NGC 0768',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20642,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20642,34.69,0.38,86.5,5266,75,NULL,'CF, r, raw','NGC 0768',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20643,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20643,34.86,0.38,93.9,5266,75,NULL,'CF, r, inv','NGC 0768',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20644,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20644,34.88,0.38,94.8,5266,75,NULL,'CF, r, cor','NGC 0768',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20645,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20645,35,0.4,100,5266,NULL,NULL,'mean','NGC 0768',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20646,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20646,35.06,0.47,103,5266,NULL,NULL,'H','NGC 0768',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20647,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20647,35.11,0.46,105,5266,NULL,NULL,'J','NGC 0768',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20648,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20648,35.16,0.45,108,5266,NULL,NULL,'K','NGC 0768',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20649,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 05993','R',20649,41.07,0.25,1190,5267,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J015843.75+000256.2',0.3767,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',0.0005,NULL,'21.3g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,29.682333,0.04894,0.025,NULL,67001445857,1046897591,16357774,21.3),(20650,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 05993','R',20650,41.13,0.28,1220,5267,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J015843.75+000256.2',0.3767,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20651,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 05993',NULL,20651,41.14,0.18,1690,5267,70,NULL,'SALT 2','SDSS J015843.75+000256.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20652,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 05993',NULL,20652,41.2,0.18,1740,5267,70,NULL,'SALT 2, Malmquist cor.','SDSS J015843.75+000256.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20653,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 04709','RN',20653,43.06,0.25,2610,5268,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04709',0.564958,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20654,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20654,32.84,1.37,37,5269,NULL,NULL,NULL,'KUG 0156-084',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'13.6',1,'SB(r)c pec',NULL,NULL,NULL,NULL,1,29.716375,-8.16225,0.017,NULL,35154104416,549282881,8582545,13.6),(20655,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20655,32.88,0.2,37.7,5269,74.4,NULL,NULL,'KUG 0156-084',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20656,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20656,33.08,1.22,41.3,5269,NULL,NULL,'Malmquist cor.','KUG 0156-084',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20657,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20657,35.4,0.46,120,5270,70,NULL,NULL,'IC 1761',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000086,NULL,'15.3g',0.37,'S0?','Pair member (points to parent)',NULL,NULL,NULL,1,29.717875,0.56831,0,NULL,67001526286,1046898848,16357794,15.3),(20658,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 21663',NULL,20658,36.23,1.92,176,5271,70,NULL,'SN photometric redshift distance, z photo =0.042 +/- 0.063','SDSS-II SN 21663',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','23.3g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,29.7197083333,0.00025,0.025,NULL,67001409633,1046897025,16357766,23.3),(20659,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20659,34.23,0.2,70.2,5272,74.4,NULL,NULL,'UGC 01461',NULL,'2013AJ....146...86T',2013,1,1.29,NULL,'G',0.000016,NULL,'16.0',0.13,'Sd',NULL,NULL,NULL,NULL,1,29.7225,5.59386,0.109,NULL,67067015525,1047922117,16373783,16),(20660,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20660,34.26,0.49,71,5272,75,NULL,'IR','UGC 01461',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20661,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20661,34.53,NULL,80.6,5272,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01461',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20662,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20662,34.55,NULL,81.1,5272,NULL,NULL,'Dipole + Quadrupole','UGC 01461',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20663,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20663,34.55,NULL,81.4,5272,NULL,NULL,'Dipole','UGC 01461',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20664,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20664,34.59,NULL,82.9,5272,NULL,NULL,NULL,'UGC 01461',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20665,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 15814',NULL,20665,40.53,0.1,1270,5273,70,NULL,'SN photometric redshift distance, z photo =0.359 +/- 0.022','SDSS-II SN 15814',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,29.725125,-0.37272,0.005,NULL,35004062008,546938468,8545913,NULL),(20666,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 15814','R',20666,41.59,0.24,1510,5273,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15814',0.371177,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20667,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 15814','R',20667,41.67,0.17,1570,5273,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15814',0.371177,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20668,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 15814',NULL,20668,41.52,0.14,2010,5273,70,NULL,'SALT 2','SDSS-II SN 15814',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20669,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 15814',NULL,20669,41.58,0.14,2070,5273,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15814',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20670,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 18787','R',20670,40.2,0.2,909,5274,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007mf','SDSS J015854.86-010137.1',0.207,'2014arXiv1401.3317S',2014,1,0.2,NULL,'G',NULL,NULL,'18.9g',0.09,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,29.728583,-1.02697,0.033,NULL,35004250051,546941407,8545959,18.9),(20671,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 18787','R',20671,40.33,0.11,964,5274,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007mf','SDSS J015854.86-010137.1',0.207,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20672,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2007mf',NULL,20672,40.07,0.08,1030,5274,70,NULL,'SALT 2','SDSS J015854.86-010137.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20673,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SN 2007mf',NULL,20673,40.08,0.08,1040,5274,70,NULL,'SALT 2, Malmquist cor.','SDSS J015854.86-010137.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20674,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20674,33.87,0.25,59.4,5275,74.4,NULL,NULL,'IC 0178',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000012,NULL,'14.06',0.9,'Sab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,29.728625,36.67469,0.201,NULL,67745535400,1058523990,16539437,14.06),(20675,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20675,34.08,0.24,65.4,5275,70,NULL,NULL,'IC 0178',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20676,'FP','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20676,36.42,0.46,192,5275,70,NULL,NULL,'2MASX J01590061-0001397',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20677,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20677,32.94,0.69,38.7,5275,100,NULL,'mid-IR','IC 0178',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20678,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20678,34.24,0.06,70.6,5275,NULL,NULL,NULL,'IC 0178',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20679,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 15802','R',20679,41.29,0.27,1350,5276,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J015900.78-010444.6',0.3417,'2014arXiv1401.3317S',2014,1,0.11,NULL,'G',0.01,NULL,'20.3g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,29.75325,-1.07908,0.033,NULL,35004239595,546941243,8545956,20.3),(20680,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 15802','R',20680,41.55,0.23,1520,5276,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J015900.78-010444.6',0.3417,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20681,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 15802',NULL,20681,41.18,0.17,1720,5276,70,NULL,'SALT 2','SDSS J015900.78-010444.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20682,'SNIa','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 15802',NULL,20682,41.22,0.17,1750,5276,70,NULL,'SALT 2, Malmquist cor.','SDSS J015900.78-010444.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20683,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20683,33.47,0.47,49.3,5277,NULL,NULL,'H','UGC 01285',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000067,NULL,'14.35',1,'Sbc','Isolated galaxy',NULL,NULL,NULL,1,29.7555,86.67369,0.405,NULL,65503803160,1023496924,15992139,14.35),(20684,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20684,33.57,0.45,51.7,5277,NULL,NULL,'K','UGC 01285',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20685,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20685,33.67,0.46,54.1,5277,NULL,NULL,'J','UGC 01285',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20686,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20686,33.96,0.4,62.1,5277,NULL,NULL,'mean','UGC 01285',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20687,'SNIa SDSS','2016-12-15 15:13:49','2016-12-16 11:18:52','1','SDSS-II SN 08250','RN',20687,39.76,0.61,786,5278,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 08250',0.136946,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20688,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,'R',20688,34.1,0.49,65.9,5279,75,NULL,'IR','UGC 01459',NULL,'2011yCatp016004901K',2011,1,1.77,NULL,'G',0.000033,NULL,'15.33',0.22,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,29.7778333333,36.063,0.217,NULL,67743930205,1058498909,16539045,15.33),(20689,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20689,34.11,0.43,66.3,5279,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01459',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20690,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20690,34.13,0.14,67.1,5279,NULL,NULL,NULL,'UGC 01459',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20691,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20691,34.21,0.43,69.4,5279,75,NULL,'3.6 micron, color corrected','UGC 01459',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20692,'Tully-Fisher','2016-12-15 15:13:49','2016-12-16 11:18:52','1',NULL,NULL,20692,34.25,0.2,70.8,5279,74.4,NULL,NULL,'UGC 01459',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20693,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20693,34.37,NULL,74.7,5279,NULL,NULL,NULL,'UGC 01459',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20694,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20694,34.41,0.4,76.3,5279,NULL,NULL,'mean','UGC 01459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20695,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20695,34.43,NULL,76.8,5279,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01459',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20696,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20696,34.45,NULL,77.7,5279,NULL,NULL,'Dipole + Quadrupole','UGC 01459',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20697,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20697,34.46,NULL,78,5279,NULL,NULL,'Dipole','UGC 01459',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20698,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20698,34.51,0.47,79.7,5279,NULL,NULL,'H','UGC 01459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20699,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20699,34.57,0.45,81.9,5279,NULL,NULL,'K','UGC 01459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20700,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20700,33.45,0.73,48.9,5280,NULL,NULL,NULL,'UGC 01462',NULL,'2009ApJS..182..474S',2009,1,1.6,NULL,'G',0.00002,NULL,'15.00',1.1,'SBcd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,29.789375,25.38572,0.357,NULL,68587127702,1071673870,16744904,15),(20701,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20701,33.6,0.2,52.5,5280,74.4,NULL,NULL,'UGC 01462',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20702,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20702,33.88,0.6,59.7,5280,NULL,NULL,'Malmquist cor.','UGC 01462',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20703,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 03649','RN',20703,45.87,0.94,13800,5281,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03649',0.079713,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20704,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 14162','RN',20704,43.67,0.22,3710,5282,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 14162',0.462522,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20705,'Tully est','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20705,32.55,0.8,32.3,5283,75,NULL,'B','NGC 0770',NULL,'1988NBGC.C....0000T',1988,1,1.2,NULL,'G',0.000017,NULL,'13.91',0.9,'E3:','Pair member (points to parent)',NULL,NULL,NULL,1,29.8068333333,18.95467,0.157,NULL,66919891131,1045623298,16337864,13.91),(20706,'GRB','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20706,42.27,0.65,1520,5284,69.7,NULL,'Calibrated','GRB 000210',0.87463,'2009MNRAS.400..775C',2009,1,NULL,NULL,'G',0.0002,NULL,'24.1V',NULL,'SAX/WFC',NULL,NULL,NULL,NULL,1,29.815,-40.65908,NULL,NULL,38320537033,598758391,9355599,24.1),(20707,'GRB','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',20707,42.28,0.66,1520,5284,72,NULL,NULL,'GRB 000210',0.87463,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20708,'GRB','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20708,42.34,0.66,1570,5284,69.7,NULL,'Fiducial','GRB 000210',0.87463,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20709,'GRB','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20709,42.45,0.67,1650,5284,70,NULL,NULL,'GRB 000210',0.87463,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20710,'GRB','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',20710,43.9,0.29,2350,5284,73,NULL,'H const./H=100','GRB 000210',0.87463,'2006astro.ph..9262M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20711,'GRB','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',20711,43.67,0.7,2890,5284,69.7,NULL,'Calibrated','GRB 000210',0.87463,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20712,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20712,31.67,0.61,21.6,5285,NULL,NULL,NULL,'CGCG 482-035',NULL,'2009ApJS..182..474S',2009,1,0.68,NULL,'G',0.000033,NULL,'14.8',0.34,'Sc+            Sbrst',NULL,NULL,NULL,NULL,1,29.8155416667,24.41661,0.377,NULL,68050885135,1063295080,16613985,14.8),(20713,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20713,31.82,0.57,23.2,5285,NULL,NULL,'Malmquist cor.','CGCG 482-035',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20714,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 03975','R',20714,41.49,0.2,1420,5286,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J015916.99+001214.7',0.393,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',0.01,NULL,'21.0g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,29.820833,0.20411,0.009,NULL,67001645274,1046900707,16357823,21),(20715,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 03975','R',20715,41.52,0.25,1450,5286,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J015916.99+001214.7',0.393,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20716,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 03975',NULL,20716,41.37,0.15,1880,5286,70,NULL,'SALT 2','SDSS J015916.99+001214.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20717,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 03975',NULL,20717,41.43,0.15,1930,5286,70,NULL,'SALT 2, Malmquist cor.','SDSS J015916.99+001214.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20718,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20718,33.69,NULL,54.8,5287,NULL,NULL,NULL,'UGC 01465',NULL,'2000BSAO...50....5K',2000,1,1.02,'RC3 gives v= 2012 +/- 10 km/sec.','G',0.000033,NULL,'17.',0.12,'Sbc',NULL,NULL,NULL,NULL,1,29.825667,18.01014,0.149,NULL,66963686297,1046307598,16348556,17),(20719,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20719,36.28,NULL,180,5287,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01465',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20720,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20720,36.31,NULL,182,5287,NULL,NULL,'Dipole + Quadrupole','UGC 01465',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20721,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20721,36.33,NULL,185,5287,NULL,NULL,'Dipole','UGC 01465',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20722,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',20722,36.41,0.49,191,5287,75,NULL,'IR','UGC 01465',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20723,'SNII optical','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SN 2003hl',NULL,20723,31.24,0.24,17.7,5288,NULL,NULL,'EPM E96','NGC 0772',NULL,'2009ApJ...696.1176J',2009,1,7.2,NULL,'G',0.00001,NULL,'10.0B',4.3,'SA(s)b         HII','Pair member (points to parent)',NULL,NULL,NULL,1,29.831583,19.00753,0.157,NULL,66919893849,1045623341,16337864,10),(20724,'SNII optical','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SN 2003hl',NULL,20724,32.01,0.14,24.8,5288,NULL,NULL,'SEAM','NGC 0772',0.008246,'2009ApJ...694.1067P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20725,'SNII optical','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SN 2003hl',NULL,20725,32,0.53,25.1,5288,NULL,NULL,'SCM, I','NGC 0772',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20726,'SNII optical','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SN 2003hl',NULL,20726,32.01,0.54,25.2,5288,NULL,NULL,'SCM, V','NGC 0772',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20727,'SNII optical','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SN 2003hl',NULL,20727,32.04,0.28,25.6,5288,NULL,NULL,'SCM, BVI','NGC 0772',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20728,'SNII optical','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SN 2003hl',NULL,20728,32.08,0.41,26.1,5288,NULL,NULL,'SCM, B','NGC 0772',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20729,'SNII optical','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SN 2003iq',NULL,20729,32.16,0.1,26.6,5288,NULL,NULL,'SEAM','NGC 0772',0.008246,'2009ApJ...694.1067P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20730,'SNII optical','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SN 2003iq',NULL,20730,32.34,0.53,29.4,5288,NULL,NULL,'SCM, I','NGC 0772',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20731,'SNII optical','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SN 2003iq',NULL,20731,32.4,0.54,30.2,5288,NULL,NULL,'SCM, V','NGC 0772',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20732,'SNII optical','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SN 2003hl',NULL,20732,32.41,0.42,30.3,5288,NULL,NULL,'EPM D05','NGC 0772',NULL,'2009ApJ...696.1176J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20733,'SNII optical','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SN 2003hl',NULL,20733,32.42,0.11,30.5,5288,NULL,NULL,'I, photospheric magnitude method','NGC 0772',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20734,'SNII optical','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SN 2003iq',NULL,20734,32.43,0.28,30.6,5288,NULL,NULL,'SCM, BVI','NGC 0772',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20735,'SNII optical','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SN 2003hl',NULL,20735,32.46,0.25,31,5288,NULL,NULL,'V, photospheric magnitude method','NGC 0772',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20736,'SNII optical','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SN 2003iq',NULL,20736,32.5,0.4,31.6,5288,NULL,NULL,'SCM, B','NGC 0772',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20737,'SNII optical','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SN 2003iq',NULL,20737,32.72,0.07,35,5288,NULL,NULL,'I, photospheric magnitude method','NGC 0772',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20738,'SNII optical','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SN 2003iq',NULL,20738,32.74,0.15,35.3,5288,NULL,NULL,'V, photospheric magnitude method','NGC 0772',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20739,'SNII optical','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SN 2003iq',NULL,20739,32.78,0.31,36,5288,NULL,NULL,'EPM E96','NGC 0772',NULL,'2009ApJ...696.1176J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20740,'SNII optical','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SN 2003iq',NULL,20740,33.63,0.64,53.3,5288,NULL,NULL,'EPM D05','NGC 0772',NULL,'2009ApJ...696.1176J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20741,'IRAS','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20741,32.35,0.8,29.5,5288,75,NULL,'A82, H','NGC 0772',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20742,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20742,32.4,0.47,30.1,5288,75,NULL,'A82, H, raw','NGC 0772',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20743,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20743,32.41,NULL,30.4,5288,65.2,NULL,'CO','NGC 0772',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20744,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20744,32.57,0.4,32.6,5288,75,NULL,'B','NGC 0772',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20745,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20745,32.68,0.47,34.3,5288,75,NULL,'A82, H, inv','NGC 0772',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20746,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20746,32.73,NULL,35.2,5288,54,NULL,'HI','NGC 0772',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20747,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20747,32.83,0.47,36.8,5288,75,NULL,'A82, H, cor','NGC 0772',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20748,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20748,34.13,0.4,66.9,5289,NULL,NULL,'mean','CGCG 522-098',NULL,'2007A&A...465...71T',2007,1,0.2,NULL,'G',0.000267,NULL,'15.0',0.2,'E?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,29.840833,36.827,0.197,NULL,67745502492,1058523476,16539429,15),(20749,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20749,34.77,0.45,89.9,5289,NULL,NULL,'K','CGCG 522-098',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20750,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20750,36.65,0.71,214,5290,70,NULL,NULL,'2MFGC 01515',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'17.17',0.17,NULL,NULL,NULL,NULL,NULL,1,29.8551666667,-7.60361,0.023,NULL,35154184562,549284133,8582564,17.17),(20751,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20751,36.61,0.78,209,5291,70,NULL,NULL,'2MASX J01592601-1303395',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'16.52',0.24,NULL,NULL,NULL,NULL,NULL,1,29.8582916667,-13.061,0,NULL,35082137952,548158405,8564975,16.52),(20752,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20752,33.34,0.2,46.6,5292,74.4,NULL,NULL,'UGC 01468',NULL,'2013AJ....146...86T',2013,1,1.38,NULL,'G',0.000027,NULL,'15.5g',0.51,'Sd',NULL,NULL,NULL,NULL,1,29.879,13.94378,0.125,NULL,66961828622,1046278572,16348102,15.5),(20753,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20753,33.58,0.55,52.1,5292,NULL,NULL,NULL,'UGC 01468',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20754,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20754,33.73,0.51,55.7,5292,NULL,NULL,'Malmquist cor.','UGC 01468',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20755,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',20755,33.81,0.46,57.7,5293,70,NULL,NULL,'NGC 0774',NULL,'2015arXiv151105856S',2015,1,1.25,NULL,'G',0.000063,NULL,'13.8g',0.96,'S0',NULL,NULL,NULL,NULL,1,29.8947083333,14.00819,0.125,NULL,66961832968,1046278640,16348103,13.8),(20756,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20756,33.91,NULL,60.6,5294,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0221',NULL,'2010Ap&SS.325..163P',2010,1,1.02,NULL,'G',0.00004,NULL,'16.6',0.11,'Sd',NULL,NULL,NULL,NULL,1,29.895,40.09389,0.193,NULL,67849880337,1060154380,16564912,16.6),(20757,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20757,33.92,NULL,60.9,5294,NULL,NULL,'Dipole + Quadrupole','FGC 0221',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20758,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20758,33.93,NULL,61,5294,NULL,NULL,'Dipole','FGC 0221',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20759,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20759,33.94,NULL,61.4,5294,NULL,NULL,NULL,'FGC 0221',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20760,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20760,33.46,0.43,49.2,5295,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0769',NULL,'2014MNRAS.444..527S',2014,1,0.8,NULL,'G',0.000103,NULL,'13.80',0.5,'S?',NULL,NULL,NULL,NULL,1,29.899583,30.90992,0.169,NULL,68594607914,1071790748,16746730,13.8),(20761,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20761,33.57,0.43,51.7,5295,75,NULL,'3.6 micron, color corrected','NGC 0769',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20762,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20762,33.73,0.2,55.7,5295,74.4,NULL,NULL,'NGC 0769',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20763,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20763,36.71,0.54,219,5296,70,NULL,NULL,'2MASX J01593881-0641029',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.66',0.35,NULL,NULL,NULL,NULL,NULL,1,29.911625,-6.68411,0.078,NULL,35153308383,549270443,8582350,16.66),(20764,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 14858',NULL,20764,40.71,0.88,1390,5297,70,NULL,'SN photometric redshift distance, z photo =0.399 +/- 0.301','SDSS-II SN 14858',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,29.917375,0.00247,0.017,NULL,67001483565,1046898180,16357784,NULL),(20765,'Ring Diameter','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20765,31.8,0.98,23,5298,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 0779',NULL,'1981ApJS...45..541P',1981,1,4,NULL,'G',0.000013,NULL,'11.95',1.2,'SAB(r)b','Group non-member, foreground',NULL,NULL,NULL,1,29.926167,-5.96319,0,NULL,35136603213,549009425,8578272,11.95),(20766,'Ring Diameter','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20766,32.4,0.76,30,5298,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 0779',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20767,'IRAS','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20767,31.21,0.8,17.5,5298,75,NULL,'A82, H','NGC 0779',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20768,'Sosies','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20768,31.52,0.2,20.1,5298,NULL,NULL,NULL,'NGC 0779',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20769,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20769,30.67,0.4,13.6,5298,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 0779',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20770,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20770,31.12,NULL,16.7,5298,NULL,NULL,'B','NGC 0779',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20771,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20771,31.19,0.4,17.3,5298,75,NULL,'B','NGC 0779',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20772,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20772,31.21,0.47,17.5,5298,75,NULL,'A82, H, raw','NGC 0779',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20773,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20773,31.27,0.38,17.9,5298,NULL,NULL,NULL,'NGC 0779',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20774,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20774,31.26,0.4,17.9,5298,73,NULL,'opt','NGC 0779',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20775,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20775,31.33,0.47,18.4,5298,75,NULL,'A82, H, inv','NGC 0779',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20776,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20776,31.52,0.47,20.1,5298,75,NULL,'A82, H, cor','NGC 0779',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20777,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20777,31.53,0.2,20.2,5298,74.4,NULL,NULL,'NGC 0779',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20778,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20778,31.55,0.43,20.4,5298,75,NULL,'3.6 micron, color corrected','NGC 0779',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20779,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20779,31.64,0.43,21.2,5298,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0779',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20780,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',20780,32.06,NULL,25.8,5298,NULL,NULL,'LEDA [April 2006]','NGC 0779',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20781,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 15023','RN',20781,42.11,0.11,1970,5299,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 15023',0.339703,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20782,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 15023','RN',20782,42.18,0.19,2040,5299,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 15023',0.339703,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20783,'IRAS','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20783,34.15,0.8,67.7,5300,75,NULL,'W91PP, r','UGC 01470',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000018,NULL,'16.5',0.19,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,29.9282917,32.08181,0.157,NULL,68623021873,1072234716,16753667,16.5),(20784,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20784,33.8,NULL,57.7,5300,NULL,NULL,'Dipole','UGC 01470',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20785,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20785,33.81,NULL,57.8,5300,NULL,NULL,'Dipole + Quadrupole','UGC 01470',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20786,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20786,33.81,NULL,57.8,5300,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01470',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20787,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20787,33.89,NULL,60,5300,NULL,NULL,NULL,'UGC 01470',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20788,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',20788,34.14,0.49,67.3,5300,75,NULL,'IR','UGC 01470',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20789,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20789,34.15,0.38,67.7,5300,75,NULL,'W91PP, r, inv','UGC 01470',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20790,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20790,34.19,0.38,68.9,5300,75,NULL,'W91PP, r, raw','UGC 01470',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20791,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20791,34.27,0.38,71.3,5300,75,NULL,'W91PP, r, cor','UGC 01470',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20792,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20792,34.32,0.43,73.1,5300,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01470',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20793,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20793,33.44,0.69,48.8,5301,100,NULL,'mid-IR','VV 733',NULL,'2013ApJ...771...88L',2013,1,1.28,NULL,'G',0.000027,NULL,'13.8g',0.82,'Sbc            HII',NULL,NULL,NULL,NULL,1,29.9353333333,-7.83914,0,NULL,35154213170,549284580,8582571,13.8),(20794,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20794,34.03,0.46,64.1,5302,70,NULL,NULL,'NGC 0795',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000133,NULL,'14.19',0.7,'S0-:',NULL,NULL,NULL,NULL,1,29.955667,-55.82417,0.025,NULL,36165341023,565083453,8829428,14.19),(20795,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20795,34.52,0.4,80.3,5303,NULL,NULL,'mean','MCG -01-06-020',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000093,NULL,'15.26',0.6,'SA0^0^ pec','Compact group member',NULL,NULL,NULL,1,29.9577917,-7.05928,0.043,NULL,35156325045,549317578,8583087,15.26),(20796,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20796,35.53,0.45,127,5303,NULL,NULL,'K','MCG -01-06-020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20797,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 04307','R',20797,40.8,0.16,1130,5304,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 04307',0.272,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,29.9625,0.94969,0.021,NULL,67001379051,1046896547,16357758,NULL),(20798,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 04307','R',20798,40.85,0.23,1160,5304,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 04307',0.272,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20799,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 22075','RN',20799,38.82,0.19,515,5305,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007si','SDSS-II SN 22075',0.130028,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20800,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 22075','N',20800,38.61,0.08,527,5305,70,NULL,'SALT 2','SDSS-II SN 22075',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20801,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 22075','N',20801,38.61,0.08,527,5305,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 22075',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20802,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 22075','RN',20802,39.05,0.15,572,5305,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007si','SDSS-II SN 22075',0.130028,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20803,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SN 2005gd',NULL,20803,38.65,0.12,463,5306,74.2,NULL,'SALT 2','SDSS J015951.23+003823.4',0.16,'2010ApJ...716..712A',2010,1,0.07,NULL,'G',NULL,NULL,'23.6g',0.03,NULL,NULL,NULL,NULL,NULL,1,29.9635,0.63986,0.009,NULL,67001691317,1046901426,16357834,23.6),(20804,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SN 2005gd',NULL,20804,39.34,0.08,636,5306,65,NULL,'SALT2','SDSS J015951.23+003823.4',0.16,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20805,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SN 2005gd',NULL,20805,39.45,0.1,668,5306,65,NULL,'MLCS2k2','SDSS J015951.23+003823.4',0.16,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20806,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 19593',NULL,20806,40.23,0.16,1110,5307,70,NULL,'SN photometric redshift distance, z photo =0.305 +/- 0.029','SDSS-II SN 19593',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,29.9692917,0.67894,0.021,NULL,67001694200,1046901471,16357835,NULL),(20807,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 19593','R',20807,41.47,0.27,1430,5307,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19593',0.375455,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20808,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 19593','R',20808,41.53,0.31,1470,5307,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19593',0.375455,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20809,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 19593',NULL,20809,41.33,0.17,1850,5307,70,NULL,'SALT 2','SDSS-II SN 19593',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20810,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 19593',NULL,20810,41.39,0.17,1900,5307,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19593',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20811,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20811,36.42,0.61,192,5308,70,NULL,NULL,'2MASX J01595354-0541000',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.50',0.24,'E/S0',NULL,NULL,NULL,NULL,1,29.9730417,-5.68347,0.014,NULL,35136643114,549010048,8578282,16.5),(20812,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20812,33.77,0.49,56.9,5309,70,NULL,NULL,'2MASX J01595398-5713019',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.000067,NULL,'16.07',0.37,'S',NULL,NULL,NULL,NULL,1,29.9749166667,-57.21728,0,NULL,36170863161,565169736,8830777,16.07),(20813,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20813,34.22,0.2,69.8,5310,74.4,NULL,NULL,'CGCG 482-038',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'15.60',0.2,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,29.980375,24.31222,0.341,NULL,68051415655,1063303369,16614115,15.6),(20814,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20814,34.27,0.3,71.5,5310,NULL,NULL,'Malmquist cor.','CGCG 482-038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20815,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20815,34.29,0.3,72.1,5310,NULL,NULL,NULL,'CGCG 482-038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20816,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',20816,34.42,0.49,76.6,5310,75,NULL,'IR','CGCG 482-038',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20817,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',20817,38.19,0.46,434,5311,70,NULL,NULL,'2MASXi J0159558-100751',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000092,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,29.9827083,-10.13089,0.021,NULL,35159178901,549362170,8583783,17.9),(20818,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 15697',NULL,20818,38.54,0.51,510,5312,70,NULL,'SN photometric redshift distance, z photo =0.127 +/- 0.037','SDSS-II SN 15697',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,30.016417,0.77631,0.021,NULL,67001286797,1046895106,16357736,NULL),(20819,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 13267','RN',20819,38.68,0.1,512,5313,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13267',0.060452,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20820,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 13267','RN',20820,40.14,0.23,1000,5313,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13267',0.060452,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20821,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20821,36,0.55,159,5314,70,NULL,NULL,'IC 0185',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16',0.2,'Sab',NULL,NULL,NULL,NULL,1,30.025167,-1.52833,0.025,NULL,35013303285,547082863,8548169,16),(20822,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',20822,34.83,0.22,92.5,5315,NULL,NULL,'B, Hubble-type-TF','ESO 354- G 024',NULL,'2005Ap&SS.298..577R',2005,1,1.2,NULL,'G',0.000033,NULL,'15.71',0.7,'Sb-c',NULL,NULL,NULL,NULL,1,30.0421666667,-35.41094,NULL,NULL,38292659482,598322804,9348793,15.71),(20823,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20823,35.76,0.33,142,5315,NULL,NULL,'Malmquist cor.','ESO 354- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20824,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20824,35.99,0.3,157,5315,NULL,NULL,NULL,'ESO 354- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20825,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20825,36.03,0.2,161,5315,74.4,NULL,NULL,'ESO 354- G 024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20826,'TRGB','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20826,28.37,NULL,4.72,5316,NULL,NULL,NULL,'AGC 111164',NULL,'2003A&A...398..479K',2003,1,0.6,NULL,'G',0.000005,NULL,'17.2',0.3,'Irr',NULL,NULL,NULL,NULL,1,30.0425,28.83139,0.197,NULL,68596942882,1071827232,16747300,17.2),(20827,'TRGB','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20827,28.45,0.07,4.91,5316,NULL,NULL,NULL,'AGC 111164',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20828,'TRGB','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20828,28.46,0.1,4.92,5316,NULL,NULL,NULL,'AGC 111164',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20829,'TRGB','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20829,28.5,0.1,5.01,5316,74.4,NULL,NULL,'AGC 111164',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20830,'TRGB','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20830,28.54,0.03,5.11,5316,NULL,NULL,'I','AGC 111164',NULL,'2014ApJ...785....3M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20831,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20831,33.69,0.4,54.7,5317,NULL,NULL,'mean','IC 0179',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000077,NULL,'13.56',1.5,'E',NULL,NULL,NULL,NULL,1,30.047917,38.02133,0.169,NULL,67731185787,1058299777,16535934,13.56),(20832,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20832,34.17,0.45,68.4,5317,NULL,NULL,'K','IC 0179',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20833,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 09557','RN',20833,41.76,0.3,1640,5318,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 09557',0.375758,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20834,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 09557','RN',20834,42.43,0.36,2220,5318,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 09557',0.375758,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20835,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 14674','RN',20835,41.35,0.14,1500,5319,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 14674',0.241646,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20836,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 14674','RN',20836,41.88,0.21,1920,5319,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 14674',0.241646,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20837,'D-Sigma','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20837,33.62,0.4,53,5320,75,NULL,'Edat, raw','NGC 0777',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000027,NULL,'12.49',2,'E1          Sy;LINER','in a pair',NULL,NULL,NULL,1,30.062083,31.42958,0.145,NULL,68593873352,1071779271,16746551,12.49),(20838,'D-Sigma','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20838,33.74,0.4,56,5320,75,NULL,'Edat, cor','NGC 0777',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20839,'Faber-Jackson','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20839,33.28,0.41,45.3,5320,95,NULL,'Weighted Mean','NGC 0777',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20840,'Faber-Jackson','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20840,33.47,0.52,49.4,5320,95,NULL,'de Vaucouleurs','NGC 0777',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20841,'Faber-Jackson','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20841,34.65,0.81,85.1,5320,55,NULL,'Visvanathan & Sandage 1979','NGC 0777',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20842,'Tertiary','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20842,32.77,0.32,35.8,5320,95,NULL,NULL,'NGC 0777',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20843,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20843,34.22,0.4,69.9,5320,NULL,NULL,'mean','NGC 0777',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20844,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20844,34.23,0.45,70.1,5320,NULL,NULL,'K','NGC 0777',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20845,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',20845,37,0.46,252,5321,70,NULL,NULL,'2MASX J02001548+0026554',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000071,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,30.064583,0.44867,0.013,NULL,67001882439,1046904413,16357881,17.2),(20846,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',20846,34.58,0.46,82.4,5322,70,NULL,NULL,'2MASX J02001568+0011574',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000066,NULL,'15.2g',0.58,'S0',NULL,NULL,NULL,NULL,1,30.0652917,0.19925,0,NULL,67001475955,1046898061,16357782,15.2),(20847,'IRAS','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20847,34.02,0.8,63.6,5323,75,NULL,'W91PP, r','UGC 01479',NULL,'1997ApJS..109..333W',1997,1,1.32,'Field star at north-east.','G',0.000067,NULL,'14.94',0.39,'Sc+            Sy2','Group member, radial-velocity confirmed',NULL,NULL,'Sy 2',1,30.079417,24.47369,0.341,NULL,68050553214,1063289893,16613904,14.94),(20848,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20848,34.17,0.4,68.3,5323,NULL,NULL,'mean','UGC 01479',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20849,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20849,34.34,0.47,73.9,5323,NULL,NULL,'H','UGC 01479',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20850,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20850,34.34,0.29,73.9,5323,NULL,NULL,'Malmquist cor.','UGC 01479',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20851,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20851,34.36,0.46,74.4,5323,NULL,NULL,'J','UGC 01479',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20852,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20852,34.38,0.45,75.2,5323,NULL,NULL,'K','UGC 01479',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20853,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',20853,34.41,0.49,76.1,5323,75,NULL,'IR','UGC 01479',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20854,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20854,34.56,0.26,81.7,5323,NULL,NULL,NULL,'UGC 01479',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20855,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20855,34.59,0.38,83,5323,75,NULL,'W91PP, r, raw','UGC 01479',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20856,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20856,34.6,0.2,83.2,5323,74.4,NULL,NULL,'UGC 01479',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20857,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20857,34.77,0.38,89.8,5323,75,NULL,'W91PP, r, cor','UGC 01479',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20858,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20858,34.82,0.38,92.2,5323,75,NULL,'W91PP, r, inv','UGC 01479',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20859,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20859,33.81,0.45,57.8,5324,NULL,NULL,NULL,'IC 1764',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.00001,NULL,'14.14',1.4,'SB(r)b','in a radial-velocity based grouping',NULL,NULL,NULL,1,30.097375,24.58056,0.341,NULL,68586452738,1071663324,16744739,14.14),(20860,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20860,33.85,0.2,58.9,5324,74.4,NULL,NULL,'IC 1764',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20861,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20861,34.05,0.4,64.5,5324,NULL,NULL,'Malmquist cor.','IC 1764',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20862,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20862,33.11,0.69,42,5325,100,NULL,'mid-IR','UGC 01485',NULL,'2013ApJ...771...88L',2013,1,1.1,NULL,'G',0.000017,NULL,'14.41',0.7,'S?',NULL,NULL,NULL,NULL,1,30.0990417,21.10825,0.245,NULL,68054819827,1063356559,16614946,14.41),(20863,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20863,33.75,0.2,56.2,5325,74.4,NULL,NULL,'UGC 01485',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20864,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20864,33.98,0.47,62.4,5325,NULL,NULL,'H','UGC 01485',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20865,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20865,34.12,0.4,66.7,5325,NULL,NULL,'mean','UGC 01485',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20866,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20866,34.12,0.45,66.8,5325,NULL,NULL,'K','UGC 01485',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20867,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20867,34.13,0.46,67,5325,NULL,NULL,'J','UGC 01485',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20868,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 18443','RN',20868,40.49,0.19,1080,5326,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18443',0.162582,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20869,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 18443','RN',20869,41.15,0.24,1460,5326,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18443',0.162582,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20870,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20870,34.28,NULL,71.9,5327,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01484',NULL,'2010Ap&SS.325..163P',2010,1,0.94,NULL,'G',0.000011,NULL,'17.',0.11,'Scd',NULL,NULL,NULL,NULL,1,30.106333,15.96317,0.133,NULL,66972980007,1046452812,16350825,17),(20871,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20871,34.31,NULL,72.6,5327,NULL,NULL,'Dipole + Quadrupole','UGC 01484',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20872,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20872,34.31,NULL,72.9,5327,NULL,NULL,'Dipole','UGC 01484',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20873,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20873,34.35,NULL,74.3,5327,NULL,NULL,NULL,'UGC 01484',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20874,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 14523',NULL,20874,39.18,0.91,685,5328,70,NULL,'SN photometric redshift distance, z photo =0.175 +/- 0.106','SDSS-II SN 14523',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.4g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,30.126,-0.71056,0.013,NULL,35004463391,546944740,8546011,21.4),(20875,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 14523','R',20875,40.88,0.26,1220,5328,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14523',0.22709,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20876,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 14523','R',20876,41.05,0.33,1320,5328,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14523',0.22709,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20877,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',20877,37.7,0.46,346,5329,70,NULL,NULL,'2MASX J02003193+0002369',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00008,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,30.133083,0.04369,0,NULL,67001464590,1046897884,16357779,17),(20878,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',20878,37.66,0.46,341,5330,70,NULL,NULL,'2MASX J02003910-0911063',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000078,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,30.162917,-9.18503,0.028,NULL,35158916290,549358067,8583719,17.5),(20879,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 09632',NULL,20879,40.89,0.65,1510,5331,70,NULL,'SN photometric redshift distance, z photo =0.444 +/- 0.231','SDSS-II SN 09632',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,30.17025,1.24947,0.037,NULL,67005826217,1046966034,16358844,NULL),(20880,'SGRB','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20880,42.9,NULL,3800,5332,70,NULL,'Photometric Distance, Host A, M(R) = -20 mag and spectral slope Beta = 1.0 ','GRB 081012',NULL,'2012A&A...545A..77R',2012,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,30.2007083333,-17.63811,0.01,NULL,35093206040,548331344,8567677,NULL),(20881,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20881,36.41,0.59,192,5333,70,NULL,NULL,'2MASX J02004491-0131108',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.35',0.3,NULL,NULL,NULL,NULL,NULL,1,30.187083,-1.51978,0.041,NULL,35013413148,547084580,8548196,16.35),(20882,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20882,34.47,0.48,78.4,5334,70,NULL,NULL,'IC 1768',NULL,'2014MNRAS.445.2677S',2014,1,3.5,NULL,'G',0.000107,NULL,'14.09',3,'SA0      poss. LINER',NULL,NULL,NULL,NULL,1,30.2077917,-25.02669,0,NULL,38389236265,599831816,9372372,14.09),(20883,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 15516',NULL,20883,40.61,0.18,1320,5335,70,NULL,'SN photometric redshift distance, z photo =0.376 +/- 0.041','SDSS-II SN 15516',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','21.7g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,30.22675,0.65678,0.021,NULL,67001840092,1046903751,16357871,21.7),(20884,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 15516','R',20884,41.7,0.24,1600,5335,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15516',0.365315,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20885,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 15516','R',20885,42.1,0.34,1930,5335,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15516',0.365315,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20886,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',20886,34.2,0.49,69.2,5336,75,NULL,'IR','IC 1769',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.08',0.3,'Sb:',NULL,NULL,NULL,NULL,1,30.2288333333,-31.91978,NULL,NULL,38445017301,600703395,9385990,15.08),(20887,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20887,34.43,0.31,77.1,5336,NULL,NULL,NULL,'IC 1769',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20888,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20888,34.46,0.3,78.1,5336,NULL,NULL,'Malmquist cor.','IC 1769',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20889,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20889,34.47,0.2,78.3,5336,74.4,NULL,NULL,'IC 1769',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20890,'IRAS','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20890,33.34,0.8,46.6,5337,75,NULL,'W91PP, r','UGC 01493',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.00002,NULL,'13.89',0.7,'SB:ab',NULL,NULL,NULL,NULL,1,30.2288333333,38.21072,0.169,NULL,67731014818,1058297106,16535892,13.89),(20891,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20891,32.79,0.38,36.1,5337,75,NULL,'W91PP, r, raw','UGC 01493',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20892,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20892,32.82,0.38,36.7,5337,75,NULL,'W91PP, r, inv','UGC 01493',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20893,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20893,32.96,0.47,39,5337,NULL,NULL,'H','UGC 01493',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20894,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20894,33.03,0.45,40.4,5337,NULL,NULL,'K','UGC 01493',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20895,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20895,33.15,0.46,42.6,5337,NULL,NULL,'J','UGC 01493',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20896,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20896,33.24,0.38,44.4,5337,75,NULL,'W91PP, r, cor','UGC 01493',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20897,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20897,33.4,0.43,47.8,5337,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01493',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20898,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20898,33.47,0.43,49.4,5337,75,NULL,'3.6 micron, color corrected','UGC 01493',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20899,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20899,33.6,0.2,52.5,5337,74.4,NULL,NULL,'UGC 01493',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20900,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20900,33.66,0.4,53.9,5337,NULL,NULL,'mean','UGC 01493',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20901,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20901,33.78,0.07,57.1,5337,NULL,NULL,NULL,'UGC 01493',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20902,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20902,34.49,0.56,79.2,5338,NULL,NULL,'Malmquist cor.','FGC 0227',NULL,'2009ApJS..182..474S',2009,1,0.91,NULL,'G',0.000017,NULL,'17.0',0.09,'Scd',NULL,NULL,NULL,NULL,1,30.23625,19.70722,0.253,NULL,66917512411,1045586131,16337283,17),(20903,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20903,34.62,0.53,84,5338,NULL,NULL,NULL,'FGC 0227',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20904,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20904,34.7,NULL,87,5338,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0227',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20905,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20905,34.7,0.2,87.1,5338,74.4,NULL,NULL,'FGC 0227',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20906,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20906,34.71,NULL,87.6,5338,NULL,NULL,'Dipole + Quadrupole','FGC 0227',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20907,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20907,34.73,NULL,88.5,5338,NULL,NULL,'Dipole','FGC 0227',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20908,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20908,34.76,NULL,89.4,5338,NULL,NULL,NULL,'FGC 0227',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20909,'IRAS','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20909,33.88,0.8,59.8,5339,75,NULL,'A82, H','UGC 01498',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.00004,NULL,'14.35',0.5,'S',NULL,NULL,NULL,NULL,1,30.2455,8.31117,0.165,NULL,67103439969,1048491249,16382675,14.35),(20910,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20910,33.11,0.69,41.9,5339,100,NULL,'mid-IR','UGC 01498',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20911,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20911,33.23,0.33,44.2,5339,91,NULL,'H','UGC 01498',NULL,'1984ApJ...278..475B',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20912,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20912,33.72,0.47,55.4,5339,75,NULL,'A82, H, raw','UGC 01498',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20913,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20913,33.75,0.47,56.2,5339,75,NULL,'A82, H, inv','UGC 01498',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20914,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20914,34,0.2,63.1,5339,74.4,NULL,NULL,'UGC 01498',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20915,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20915,34.03,0.47,63.9,5339,75,NULL,'A82, H, cor','UGC 01498',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20916,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20916,34.07,0.44,65.1,5339,NULL,NULL,NULL,'UGC 01498',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20917,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20917,34.22,0.41,70,5339,NULL,NULL,'Malmquist cor.','UGC 01498',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20918,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',20918,37.86,0.46,374,5340,70,NULL,NULL,'2MASX J02010070-0014138',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000071,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,30.252875,-0.23722,0.009,NULL,35004521792,546945653,8546025,17.8),(20919,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 02799','RN',20919,40.87,0.37,1080,5341,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02799',0.37692,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20920,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 02799','RN',20920,40.93,0.34,1110,5341,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 02799',0.37692,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20921,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',20921,36.13,0.46,169,5342,70,NULL,NULL,'2MASX J02010371+1446070',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000077,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,30.2655417,14.76853,0.097,NULL,66959927649,1046248869,16347638,16.7),(20922,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20922,36.28,0.53,180,5343,70,NULL,NULL,'2MASX J02010492-2132598',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.16',0.28,NULL,NULL,NULL,NULL,NULL,1,30.270417,-21.55011,0.007,NULL,37931047599,592672618,9260509,16.16),(20923,'BL Lac Luminosity','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20923,40.9,NULL,1170,5344,NULL,NULL,NULL,'SDSS J020106.17+003400.1',0.298632,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.000104,NULL,'18.4g',NULL,'BLLAC',NULL,NULL,NULL,'BL Lac',1,30.27575,0.56669,0.017,NULL,67001816592,1046903384,16357865,18.4),(20924,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SN 2004fz',NULL,20924,33.91,0.19,59.4,5345,70,NULL,'SALT 2','NGC 0783',0.017312,'2013MNRAS.433.2240G',2013,1,1.6,NULL,'G',0.000017,NULL,'12.84',1.4,'SBc','Group member, radial-velocity confirmed',NULL,NULL,'Starburst',1,30.2775417,31.88247,0.161,NULL,68639828779,1072497324,16757770,12.84),(20925,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 15062','RN',20925,43.15,0.38,3340,5346,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15062',0.276507,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20926,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 15062','RN',20926,43.17,0.45,3370,5346,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15062',0.276507,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20927,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',20927,37.57,0.46,326,5347,70,NULL,NULL,'2MASX J02010898-0801079',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000098,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,30.287375,-8.01875,0.008,NULL,35153939696,549280307,8582504,16.5),(20928,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20928,32.28,0.43,28.5,5348,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01500',NULL,'2014MNRAS.444..527S',2014,1,1,NULL,'G',0.000017,NULL,'16.5',0.2,'Scd:',NULL,NULL,NULL,NULL,1,30.3007917,19.67525,0.229,NULL,66919599764,1045618746,16337792,16.5),(20929,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20929,32.49,0.43,31.5,5348,75,NULL,'3.6 micron, color corrected','UGC 01500',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20930,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20930,32.61,0.39,33.2,5348,73,NULL,'IR','UGC 01500',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20931,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',20931,32.61,0.4,33.2,5348,75,NULL,NULL,'UGC 01500',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20932,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20932,32.61,0.4,33.3,5348,73,NULL,'opt','UGC 01500',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20933,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20933,32.67,0.2,34.2,5348,74.4,NULL,NULL,'UGC 01500',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20934,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20934,32.97,0.59,39.3,5348,NULL,NULL,NULL,'UGC 01500',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20935,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',20935,33,0.49,39.9,5348,75,NULL,'IR','UGC 01500',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20936,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20936,33.09,0.56,41.5,5348,NULL,NULL,'Malmquist cor.','UGC 01500',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20937,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 19259','RN',20937,41.88,0.17,1830,5349,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 19259',0.29715,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20938,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 19259','RN',20938,42.23,0.23,2150,5349,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 19259',0.29715,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20939,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20939,33.39,0.63,47.6,5350,NULL,NULL,NULL,'ESO 354- G 030',NULL,'2009ApJS..182..474S',2009,1,1.1,'The APM image includes a neighboring star.','G',0.000033,NULL,'14.80',0.5,'Sb:',NULL,NULL,NULL,NULL,1,30.310625,-34.36303,NULL,NULL,38293358962,598333733,9348964,14.8),(20940,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20940,33.43,0.2,48.5,5350,74.4,NULL,NULL,'ESO 354- G 030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20941,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20941,34.03,0.47,63.9,5350,NULL,NULL,'Malmquist cor.','ESO 354- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20942,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',20942,38.27,0.46,451,5351,70,NULL,NULL,'2MASX J02011470-0753459',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000087,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,30.311167,-7.89611,0.008,NULL,35153971420,549280803,8582512,17.8),(20943,'Brightest Stars','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20943,28.47,NULL,4.9,5352,NULL,NULL,NULL,'NGC 0784',NULL,'2000A&AS..142..425D',2000,1,6.6,NULL,'G',0.000003,NULL,'12.23',1.5,'SBdm: sp','in a radial-velocity based grouping',NULL,NULL,NULL,1,30.3205417,28.83725,0.217,NULL,68597011571,1071828305,16747317,12.23),(20944,'CMD','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20944,28.7,0.04,5.5,5352,NULL,NULL,NULL,'NGC 0784',NULL,'2010ApJ...721..297M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20945,'TRGB','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20945,27.4,0.75,3.02,5352,NULL,NULL,NULL,'NGC 0784',NULL,'2005AJ....129..698M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20946,'TRGB','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20946,28.56,0.09,5.15,5352,74.4,NULL,NULL,'NGC 0784',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20947,'TRGB','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20947,28.58,0.05,5.19,5352,NULL,NULL,NULL,'NGC 0784',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20948,'TRGB','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20948,28.68,0.02,5.45,5352,NULL,NULL,'I','NGC 0784',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20949,'IRAS','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20949,28.86,0.8,5.92,5352,75,NULL,'A82, H','NGC 0784',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20950,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20950,27.57,0.47,3.27,5352,75,NULL,'A82, H, inv','NGC 0784',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (20951,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20951,27.66,0.4,3.4,5352,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 0784',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20952,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20952,27.91,0.47,3.83,5352,75,NULL,'A82, H, raw','NGC 0784',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20953,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20953,28.11,0.35,4.19,5352,NULL,NULL,NULL,'NGC 0784',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20954,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20954,28.26,0.47,4.48,5352,75,NULL,'A82, H, cor','NGC 0784',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20955,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20955,28.35,0.4,4.7,5352,75,NULL,'B','NGC 0784',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20956,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20956,28.56,0.09,5.15,5352,74.4,NULL,NULL,'NGC 0784',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20957,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',20957,37.31,0.46,289,5353,70,NULL,NULL,'SDSS J020120.37+131508.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00007,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,30.334917,13.25225,0.157,NULL,66958306299,1046223535,16347242,18.2),(20958,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20958,36.01,0.49,159,5354,70,NULL,NULL,'MRK 1015',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.000103,NULL,'15.4',0.2,'S?',NULL,NULL,NULL,NULL,1,30.337375,-1.30319,0.041,NULL,35012304509,547067257,8547925,15.4),(20959,'IRAS','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20959,34.16,0.8,67.8,5355,75,NULL,'W91PP, r','IC 0187',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000033,NULL,'13.78',0.7,'SBa','in a radial-velocity based grouping',NULL,NULL,NULL,1,30.3781666667,26.48097,0.245,NULL,68601102128,1071892220,16748315,13.78),(20960,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',20960,34.27,0.49,71.5,5355,75,NULL,'IR','IC 0187',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20961,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20961,34.29,0.4,72.2,5355,NULL,NULL,'mean','IC 0187',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20962,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20962,34.38,0.38,75.2,5355,75,NULL,'W91PP, r, raw','IC 0187',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20963,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20963,34.41,0.38,76.3,5355,75,NULL,'W91PP, r, cor','IC 0187',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20964,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20964,34.43,0.47,77.1,5355,NULL,NULL,'H','IC 0187',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20965,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20965,34.47,0.46,78.4,5355,NULL,NULL,'J','IC 0187',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20966,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20966,34.48,0.45,78.9,5355,NULL,NULL,'K','IC 0187',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20967,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20967,34.65,0.38,85.3,5355,75,NULL,'W91PP, r, inv','IC 0187',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20968,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20968,36.01,0.7,159,5356,70,NULL,NULL,'2MASX J02013189-1623598',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'16.18',0.3,NULL,NULL,NULL,NULL,NULL,1,30.382917,-16.40006,0,NULL,35090943210,548295987,8567124,16.18),(20969,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 00765','RN',20969,42.91,0.2,3030,5357,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 00765',0.261047,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20970,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 00765','RN',20970,43.1,0.18,3310,5357,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 00765',0.261047,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20971,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',20971,36.65,0.46,214,5358,70,NULL,NULL,'2MASX J02013606+1235391',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000092,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,30.400167,12.59425,0.197,NULL,66957967749,1046218246,16347160,16.4),(20972,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 03977','RN',20972,38.04,0.16,388,5359,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03977',0.043229,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20973,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20973,33.92,0.47,60.7,5360,70,NULL,NULL,'2MASX J02013826-5816068',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.000133,NULL,'14.3b',0.62,'E',NULL,NULL,NULL,NULL,1,30.4092916667,-58.26861,0,NULL,36169812027,565153312,8830520,14.3),(20974,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 09888','RN',20974,38.68,0.18,521,5361,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 09888',0.043485,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20975,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 09888','RN',20975,40.1,0.26,1000,5361,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 09888',0.043485,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20976,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',20976,37.83,0.46,369,5362,70,NULL,NULL,'SDSS J020138.79+002038.3',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,30.411625,0.344,0.013,NULL,67001071203,1046891737,16357683,18.6),(20977,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20977,36.28,0.58,180,5363,70,NULL,NULL,'2MASX J02013986-0707518',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'15.32',0.52,NULL,NULL,NULL,NULL,NULL,1,30.416125,-7.13111,0.017,NULL,35156605903,549321967,8583155,15.32),(20978,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SN 2009lf','R',20978,35.65,0.07,135,5364,NULL,NULL,'MLCS2k2, R(V) = 1.8','2MASX J02014081+1519521',NULL,'2015Sci...347.1459K',2015,1,NULL,NULL,'G',NULL,NULL,'16.18',NULL,NULL,NULL,NULL,NULL,NULL,1,30.419917,15.33125,0.125,NULL,66972704070,1046448501,16350757,16.18),(20979,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SN 2009lf','R',20979,35.7,0.07,138,5364,NULL,NULL,'MLCS2k2, R(V) = 3.1','2MASX J02014081+1519521',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20980,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SN 2009lf',NULL,20980,35.92,0.21,146,5364,73.8,NULL,'SALT 2 (SNANA)','2MASX J02014081+1519521',0.0442,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20981,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',20981,36.32,0.12,183,5365,70,NULL,NULL,'2MASX J02014340-0104114',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000111,NULL,'15.5g',0.47,'E',NULL,NULL,NULL,NULL,1,30.4307917,-1.06981,0.041,NULL,35012888935,547076389,8548068,15.5),(20982,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',20982,36.32,0.12,183,5366,70,NULL,NULL,'2MASX J02014440-0056044',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000079,NULL,'16.1g',0.33,'S0',NULL,NULL,NULL,NULL,1,30.4350833333,-0.93444,0.013,NULL,35012927971,547076999,8548078,16.1),(20983,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SN 2006nl',NULL,20983,39.42,0.12,764,5367,70,NULL,'Hubble residual 0.03 for z0.19500','SDSS-II SN 16100 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,30.436375,-1.03236,0.041,NULL,35012900793,547076574,8548071,NULL),(20984,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 16100','R',20984,39.96,0.21,822,5367,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006nl','SDSS-II SN 16100 HOST',0.195,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20985,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:52','1','SDSS-II SN 16100','R',20985,40.01,0.11,839,5367,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006nl','SDSS-II SN 16100 HOST',0.195,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20986,'IRAS','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20986,34.07,0.8,65.1,5368,75,NULL,'W91PP, r','IC 0188',NULL,'1997ApJS..109..333W',1997,1,0.6,NULL,'G',0.00002,NULL,'14.70',0.3,'S?','in a radial-velocity based grouping',NULL,NULL,NULL,1,30.44375,26.54689,0.245,NULL,68601103487,1071892241,16748316,14.7),(20987,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20987,33.65,0.38,53.8,5368,75,NULL,'W91PP, r, raw','IC 0188',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20988,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20988,33.69,0.38,54.7,5368,75,NULL,'W91PP, r, inv','IC 0188',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20989,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20989,33.93,0.38,61.2,5368,75,NULL,'W91PP, r, cor','IC 0188',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20990,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20990,34.23,0.4,70.1,5368,NULL,NULL,'mean','IC 0188',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20991,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20991,34.29,0.47,72.1,5368,NULL,NULL,'H','IC 0188',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20992,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20992,34.36,0.45,74.4,5368,NULL,NULL,'K','IC 0188',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20993,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20993,34.49,0.46,79,5368,NULL,NULL,'J','IC 0188',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(20994,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20994,36.75,0.55,224,5369,70,NULL,NULL,'MRK 1016',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.000087,NULL,'15.7',0.26,NULL,NULL,NULL,NULL,NULL,1,30.4592916667,-1.33039,0.029,NULL,35012284468,547066944,8547921,15.7),(20995,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',20995,36.32,0.12,183,5370,70,NULL,NULL,'2MASX J02015527-0110084',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000063,NULL,'17.4g',0.21,'E',NULL,NULL,NULL,NULL,1,30.4802916667,-1.16908,0.041,NULL,35012774622,547074603,8548040,17.4),(20996,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20996,36.13,0.65,168,5371,70,NULL,NULL,'2MASX J02015727-0107524',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.000086,NULL,'16.2g',0.23,'S0',NULL,NULL,NULL,NULL,1,30.4885,-1.13108,0.041,NULL,35012953727,547077401,8548084,16.2),(20997,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20997,36.08,0.53,165,5372,70,NULL,NULL,'2MASX J02015820-0059524',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.000096,NULL,'15.9g',0.26,'S0',NULL,NULL,NULL,NULL,1,30.4925,-0.99775,0.017,NULL,35012893240,547076456,8548069,15.9),(20998,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',20998,38.27,0.46,450,5373,70,NULL,NULL,'SDSS J020159.56+132639.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000072,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,30.4982083,13.44422,0.157,NULL,66958179954,1046221561,16347211,18.4),(20999,'IRAS','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,20999,34.58,0.8,82.4,5374,75,NULL,'MAT, I','ESO 114- G 021',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'14.16',1,'SA(s)b','in a pair',NULL,NULL,NULL,1,30.4987083333,-58.57078,0,NULL,36161216741,565019011,8828422,14.16),(21000,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,21000,33.82,0.43,58,5374,75,NULL,'MAT, I, raw','ESO 114- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21001,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,21001,33.87,0.32,59.4,5374,85,NULL,'I, raw','ESO 114- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21002,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,21002,33.91,0.32,60.6,5374,85,NULL,'I, inv','ESO 114- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21003,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,21003,34.01,0.43,63.3,5374,75,NULL,'MAT, I, inv','ESO 114- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21004,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',21004,34.17,NULL,68.2,5374,NULL,NULL,'I','ESO 114- G 021',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21005,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,21005,34.22,0.31,69.7,5374,NULL,NULL,NULL,'ESO 114- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21006,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,21006,34.26,0.2,71.1,5374,74.4,NULL,NULL,'ESO 114- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21007,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,21007,34.32,0.43,73.2,5374,75,NULL,'MAT, I, cor','ESO 114- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21008,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,21008,34.53,0.27,80.7,5374,NULL,NULL,'Malmquist cor.','ESO 114- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21009,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,'R',21009,34.87,NULL,94.2,5374,NULL,NULL,'B','ESO 114- G 021',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21010,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,21010,34.89,0.4,95.3,5374,NULL,NULL,'mean','ESO 114- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21011,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,21011,34.97,0.47,98.6,5374,NULL,NULL,'H','ESO 114- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21012,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,21012,35.07,0.45,103,5374,NULL,NULL,'K','ESO 114- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21013,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,21013,35.1,0.46,105,5374,NULL,NULL,'J','ESO 114- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21014,'FP','2016-12-15 15:13:50','2016-12-16 11:18:52','1',NULL,NULL,21014,36.4,0.78,191,5375,70,NULL,NULL,'2MASX J02020135-7356577',NULL,'2014MNRAS.445.2677S',2014,1,0.22,NULL,'G',0.00015,NULL,'16.6b',0.16,NULL,NULL,NULL,NULL,NULL,1,30.505,-73.94925,0.117,NULL,35616936275,556514629,8695541,16.6),(21015,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21015,37.73,0.46,352,5376,70,NULL,NULL,'2MASX J02020195-0821352',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000089,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,30.508125,-8.35967,0.01,NULL,35161465065,549397891,8584342,17.1),(21016,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21016,36.32,0.12,183,5377,70,NULL,NULL,'2MASX J02020794-0109234',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000074,NULL,'17.2g',0.19,'E',NULL,NULL,NULL,NULL,1,30.53325,-1.1565,0.029,NULL,35012781871,547074716,8548042,17.2),(21017,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 16977','RN',21017,41.25,0.25,1290,5378,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16977',0.384021,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21018,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 16977','RN',21018,41.41,0.31,1380,5378,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16977',0.384021,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21019,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 16977','N',21019,41.29,0.21,1810,5378,70,NULL,'SALT 2','SDSS-II SN 16977',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21020,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 16977','N',21020,41.34,0.21,1850,5378,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16977',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21021,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 10470','RN',21021,37.09,0.24,251,5379,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10470',0.043579,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21022,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 10470','RN',21022,39.18,0.23,658,5379,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10470',0.043579,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21023,'IRAS','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21023,33.99,0.8,62.9,5380,75,NULL,'MAT, I','ESO 414- G 025',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'14.13',0.8,'SB(s)c',NULL,NULL,NULL,NULL,1,30.550125,-28.65744,0,NULL,38393656191,599900877,9373451,14.13),(21024,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21024,33.84,0.32,58.6,5380,85,NULL,'I, raw','ESO 414- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21025,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21025,33.88,0.43,59.8,5380,75,NULL,'MAT, I, raw','ESO 414- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21026,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21026,33.89,0.32,59.9,5380,85,NULL,'I, inv','ESO 414- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21027,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21027,34.11,0.43,66.4,5380,75,NULL,'MAT, I, inv','ESO 414- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21028,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21028,34.12,0.43,66.6,5380,75,NULL,'MAT, I, cor','ESO 414- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21029,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21029,34.16,0.4,67.8,5380,NULL,NULL,'mean','ESO 414- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21030,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21030,34.22,0.2,69.8,5380,74.4,NULL,NULL,'ESO 414- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21031,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21031,34.3,0.47,72.6,5380,NULL,NULL,'H','ESO 414- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21032,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21032,34.32,0.46,73,5380,NULL,NULL,'J','ESO 414- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21033,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21033,34.34,0.38,73.7,5380,NULL,NULL,NULL,'ESO 414- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21034,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21034,34.4,0.37,76,5380,NULL,NULL,'Malmquist cor.','ESO 414- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21035,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21035,34.44,0.45,77.4,5380,NULL,NULL,'K','ESO 414- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21036,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2004dt',NULL,21036,34.15,0.18,65.1,5381,72,NULL,NULL,'NGC 0799',0.01883,'2013ApJ...773...53F',2013,1,1.66,'HOLM 054C is a star.','G',0.000027,NULL,'13.8g',1.28,'(R\')SB(s)a:','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,30.551417,-0.10064,0.013,NULL,35003808293,546934504,8545851,13.8),(21037,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21037,34.59,0.4,82.9,5381,NULL,NULL,'mean','NGC 0799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21038,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21038,34.89,0.45,95,5381,NULL,NULL,'K','NGC 0799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21039,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21039,34.9,0.47,95.4,5381,NULL,NULL,'H','NGC 0799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21040,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21040,34.94,0.46,97.4,5381,NULL,NULL,'J','NGC 0799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21041,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21041,33.97,0.49,62.1,5382,75,NULL,'IR','MCG -01-06-031',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.00015,NULL,'15',0.3,'Sc pec sp      HII',NULL,NULL,NULL,NULL,1,30.5552916667,-6.07889,0.01,NULL,35152989905,549265467,8582272,15),(21042,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21042,34.96,0.48,98.3,5383,70,NULL,NULL,'MCG -01-06-029',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000087,NULL,'14.89',0.4,NULL,NULL,NULL,NULL,NULL,1,30.561,-2.84494,0,NULL,35011543935,547055373,8547740,14.89),(21043,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21043,33.94,0.4,61.2,5384,NULL,NULL,'mean','NGC 0792',NULL,'2007A&A...465...71T',2007,1,1.7,'The 2MASS position is 17.5 arcsec northwest of the optical nucleus.','G',0.000077,NULL,'14.12',1,'S0',NULL,NULL,NULL,NULL,1,30.563875,15.71219,0.129,NULL,66964320512,1046317508,16348711,14.12),(21044,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21044,34.13,0.45,67,5384,NULL,NULL,'K','NGC 0792',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21045,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21045,36.32,0.12,183,5385,70,NULL,NULL,'2MASX J02021544-0059065',NULL,'2015arXiv151105856S',2015,1,0.33,'Slinglend et al. (1998ApJS..115....1S) give v = 28581 +/- 27 km/sec.','G',0.000065,NULL,'17.0g',0.19,'S0',NULL,NULL,NULL,NULL,1,30.5644583,-0.98522,0.017,NULL,35012960943,547077514,8548086,17),(21046,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21046,36.8,0.46,229,5386,70,NULL,NULL,'SDSS J020216.89+123652.4',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000117,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,30.5704583,12.61456,0.209,NULL,66949661001,1046088453,16345132,16.5),(21047,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21047,36.32,0.12,183,5387,70,NULL,NULL,'UGC 01525',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000097,NULL,'14.5g',0.64,'E','Brightest group member',NULL,NULL,NULL,1,30.572,-1.12783,0.029,NULL,35012956926,547077451,8548085,14.5),(21048,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21048,31.8,0.47,22.9,5388,NULL,NULL,'H','2MASX J02021731+6821460',NULL,'2007A&A...465...71T',2007,1,1.2,'Within 10 degrees of the galactic plane.','G',0.000007,NULL,'8.98K',0.45,'S',NULL,NULL,NULL,NULL,1,30.572167,68.36275,NULL,NULL,66488749144,1038886705,16232604,8.98),(21049,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21049,31.9,0.45,24,5388,NULL,NULL,'K','2MASX J02021731+6821460',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21050,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21050,31.99,0.46,25,5388,NULL,NULL,'J','2MASX J02021731+6821460',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21051,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21051,32.95,0.4,38.8,5388,NULL,NULL,'mean','2MASX J02021731+6821460',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21052,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21052,38.29,0.46,454,5389,70,NULL,NULL,'2MASX J02022003+1245369',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000077,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,30.583417,12.76017,0.209,NULL,66949620454,1046087819,16345122,17.9),(21053,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21053,36.32,0.12,183,5390,70,NULL,NULL,'2MASX J02022024-0106385',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000099,NULL,'16.8g',0.11,'S0','Group member, 2nd ranked galaxy',NULL,NULL,NULL,1,30.5844583,-1.11078,0.029,NULL,35012956505,547077445,8548085,16.8),(21054,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 19375','RN',21054,40.82,0.3,1260,5391,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19375 HOST',0.162322,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21055,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 20366','RN',21055,40.85,0.31,1270,5391,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19375 HOST',0.162261,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21056,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 20366','RN',21056,42,0.33,2160,5391,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19375 HOST',0.162261,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21057,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 06955','RN',21057,41.09,0.31,1560,5392,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06955',0.061143,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21058,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 04564','RN',21058,43.08,0.25,3030,5393,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04564',0.366476,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21059,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 04564','RN',21059,46.28,0.55,13200,5393,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 04564',0.366476,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21060,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21060,35.27,0.45,113,5394,NULL,NULL,'K','NGC 0794',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00008,NULL,'13.81',1.1,'S0-:',NULL,NULL,NULL,NULL,1,30.6222083,18.373,0.177,NULL,66916574159,1045571471,16337054,13.81),(21061,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21061,35.43,0.4,122,5394,NULL,NULL,'mean','NGC 0794',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21062,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21062,35.21,0.49,110,5395,70,NULL,NULL,'ESO 197- G 018',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000053,NULL,'13.45',1,'SA(r)0-?',NULL,NULL,NULL,NULL,1,30.6284583,-50.93164,NULL,NULL,38242540296,597539692,9336557,13.45),(21063,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2007jw',NULL,21063,38.54,0.07,510,5396,70,NULL,'Hubble residual -0.15 for z0.13690','2MASX J02023271-0105235',NULL,'2011ApJ...740...92G',2011,1,0.24,NULL,'G',0.00007,NULL,'17.8g',0.14,'NLAGN',NULL,NULL,NULL,NULL,1,30.6365,-1.08994,0.021,NULL,35012985101,547077892,8548092,17.8),(21064,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 17629','R',21064,38.93,0.18,537,5396,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007jw','2MASX J02023271-0105235',0.1369,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21065,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 17629','R',21065,39.06,0.11,570,5396,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007jw','2MASX J02023271-0105235',0.1369,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21066,'IRAS','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21066,33.91,0.8,60.5,5397,75,NULL,'MAT, I','ESO 013- G 028',NULL,'1997ApJS..109..333W',1997,1,2.35,NULL,'G',0.000033,NULL,'15.22',0.28,'Sc','in an interacting pair',NULL,NULL,NULL,1,30.636917,-79.67039,0.301,NULL,35664402514,557256289,8707129,15.22),(21067,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21067,34.05,0.47,64.4,5397,NULL,NULL,'H','ESO 013- G 028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21068,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21068,34.05,0.45,64.5,5397,NULL,NULL,'K','ESO 013- G 028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21069,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21069,34.11,0.4,66.2,5397,NULL,NULL,'mean','ESO 013- G 028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21070,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21070,34.11,0.49,66.5,5397,75,NULL,'IR','ESO 013- G 028',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21071,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21071,34.19,0.43,68.8,5397,75,NULL,'MAT, I, raw','ESO 013- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21072,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21072,34.23,0.46,70.1,5397,NULL,NULL,'J','ESO 013- G 028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21073,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21073,34.27,NULL,71.5,5397,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 013- G 028',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21074,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21074,34.28,0.32,71.9,5397,85,NULL,'I, raw','ESO 013- G 028',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21075,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21075,34.29,NULL,72.1,5397,NULL,NULL,'Dipole + Quadrupole','ESO 013- G 028',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21076,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21076,34.29,NULL,72.2,5397,NULL,NULL,NULL,'ESO 013- G 028',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21077,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21077,34.31,NULL,72.8,5397,NULL,NULL,'Dipole','ESO 013- G 028',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21078,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21078,34.34,0.32,73.7,5397,85,NULL,'I, inv','ESO 013- G 028',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21079,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21079,34.38,0.43,75.3,5397,75,NULL,'MAT, I, cor','ESO 013- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21080,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21080,34.42,0.43,76.7,5397,75,NULL,'MAT, I, inv','ESO 013- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21081,'IRAS','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21081,35.12,0.8,106,5398,75,NULL,'CF, r','UGC 01531',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.86',0.4,'Sb',NULL,NULL,NULL,NULL,1,30.643375,17.16772,0.137,NULL,66965563976,1046336937,16349014,14.86),(21082,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21082,34.79,0.38,90.9,5398,75,NULL,'CF, r, raw','UGC 01531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21083,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21083,34.91,0.38,96.1,5398,75,NULL,'CF, r, inv','UGC 01531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21084,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21084,35.12,0.38,105,5398,75,NULL,'CF, r, cor','UGC 01531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21085,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21085,35.15,0.49,107,5398,75,NULL,'IR','UGC 01531',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21086,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21086,37.53,0.46,321,5399,70,NULL,NULL,'2MASX J02023564-0102545',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000071,NULL,'16.62',0.21,'S0',NULL,NULL,NULL,NULL,1,30.648583,-1.04836,0.021,NULL,35012986778,547077918,8548092,16.62),(21087,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21087,36.2,0.2,174,5400,74.4,NULL,NULL,'CGCG 482-054',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000033,NULL,'15.7',0.2,'Sc',NULL,NULL,NULL,NULL,1,30.649583,22.38114,0.277,NULL,68064238661,1063503729,16617245,15.7),(21088,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 21890',NULL,21088,39.64,0.75,847,5401,70,NULL,'SN photometric redshift distance, z photo =0.222 +/- 0.111','SDSS-II SN 21890',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','21.2g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,30.651917,0.22103,0.013,NULL,67000885245,1046888831,16357637,21.2),(21089,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 21890','R',21089,41.2,0.28,1270,5401,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21890',0.364784,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21090,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 21890','R',21090,41.28,0.26,1320,5401,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 21890',0.364784,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21091,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 13215','RN',21091,41.21,0.07,1340,5402,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13215',0.297624,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21092,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21092,36.32,0.12,183,5403,70,NULL,NULL,'2MASX J02023789-0105570',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00014,NULL,'16.10',0.24,'E/S0',NULL,NULL,NULL,NULL,1,30.6580417,-1.09908,0.021,NULL,35012980648,547077822,8548090,16.1),(21093,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21093,37.15,0.23,269,5404,70,NULL,NULL,'2MASX J02024301+0013323',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000091,NULL,'16.7g',0.28,'NLAGN',NULL,NULL,NULL,'Sy 2',1,30.6792083,0.22567,0.013,NULL,67000890080,1046888907,16357639,16.7),(21094,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21094,37.43,0.46,307,5405,70,NULL,NULL,'2MASX J02024394+0032223',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,30.6830833333,0.5395,0.025,NULL,67005277114,1046957454,16358710,17.4),(21095,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21095,37.21,0.46,276,5406,70,NULL,NULL,'2MASX J02024422-0918533',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000082,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,30.6842083,-9.31492,0.048,NULL,35159384113,549365376,8583834,16.9),(21096,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 19484','RN',21096,42.05,0.41,2030,5407,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19484',0.267246,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21097,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 19484','RN',21097,42.51,0.4,2500,5407,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19484',0.267246,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21098,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21098,37.29,0.54,288,5408,70,NULL,NULL,'2MASX J02025021-0604363',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'16.60',0.29,NULL,NULL,NULL,NULL,NULL,1,30.70925,-6.07681,0.008,NULL,35154831193,549294237,8582722,16.6),(21099,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21099,37.15,0.23,269,5409,70,NULL,NULL,'2MASX J02025148+0005144',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000082,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,30.714625,0.08725,0.013,NULL,67000916853,1046889325,16357645,16.8),(21100,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21100,37.08,0.33,260,5410,70,NULL,NULL,'2MASX J02025365+1407376',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000083,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,30.723583,14.12708,0.149,NULL,66951989586,1046124837,16345700,17.4),(21101,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21101,35.03,0.42,101,5411,NULL,NULL,'Malmquist cor.','UGC 01536',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.00014,NULL,'15.12',0.5,'Sbc',NULL,NULL,NULL,NULL,1,30.7287917,7.52386,0.157,NULL,67103681722,1048495026,16382734,15.12),(21102,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21102,35.14,0.2,107,5411,74.4,NULL,NULL,'UGC 01536',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21103,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21103,35.25,0.38,112,5411,NULL,NULL,NULL,'UGC 01536',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21104,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 16165','R',21104,39.39,0.2,653,5412,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006nw','SN 2006nw',0.157,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,30.733125,-0.53386,0.017,NULL,35012206559,547065727,8547901,NULL),(21105,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 16165','R',21105,39.57,0.09,709,5412,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006nw','SN 2006nw',0.157,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21106,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 19347',NULL,21106,39.67,0.45,861,5413,70,NULL,'SN photometric redshift distance, z photo =0.226 +/- 0.061','SDSS-II SN 19347',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,30.757833,0.35758,0.025,NULL,67005097866,1046954654,16358666,NULL),(21107,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 19347','R',21107,40.72,0.21,1110,5413,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19347',0.259043,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21108,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 19347','R',21108,40.82,0.14,1160,5413,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19347',0.259043,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21109,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 19347',NULL,21109,40.58,0.11,1310,5413,70,NULL,'SALT 2','SDSS-II SN 19347',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21110,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 19347',NULL,21110,40.6,0.11,1320,5413,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19347',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21111,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21111,32.99,NULL,39.7,5414,NULL,NULL,'Dipole + Quadrupole + Octopole','UGCA 023',NULL,'2010Ap&SS.325..163P',2010,1,2.8,'Confused HIPASS source','G',0.000017,NULL,'14.50',0.18,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,30.7585416667,-9.65628,0.065,NULL,35159436566,549366196,8583846,14.5),(21112,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21112,33,NULL,39.8,5414,NULL,NULL,'Dipole + Quadrupole','UGCA 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21113,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21113,33,NULL,39.9,5414,NULL,NULL,'Dipole','UGCA 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21114,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21114,33.27,0.49,45,5414,75,NULL,'IR','UGCA 023',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21115,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21115,34.67,NULL,86,5415,NULL,NULL,NULL,'IC 0194',NULL,'2000BSAO...50....5K',2000,1,2.07,NULL,'G',0.000015,NULL,'15.21',0.29,'Sbc',NULL,NULL,NULL,NULL,1,30.77175,2.61425,0.049,NULL,67007116723,1046986198,16359159,15.21),(21116,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21116,34.77,0.38,89.9,5415,NULL,NULL,'Malmquist cor.','IC 0194',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21117,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21117,34.77,0.4,90.1,5415,NULL,NULL,'mean','IC 0194',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21118,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21118,34.78,0.47,90.2,5415,NULL,NULL,'H','IC 0194',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21119,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21119,34.78,NULL,90.3,5415,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 0194',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21120,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21120,34.81,NULL,91.5,5415,NULL,NULL,'Dipole + Quadrupole','IC 0194',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21121,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21121,34.81,NULL,91.8,5415,NULL,NULL,'Dipole','IC 0194',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21122,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21122,34.82,0.49,92.2,5415,75,NULL,'IR','IC 0194',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21123,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21123,34.86,0.45,93.8,5415,NULL,NULL,'K','IC 0194',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21124,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21124,34.92,0.46,96.5,5415,NULL,NULL,'J','IC 0194',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21125,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21125,35.02,0.2,101,5415,74.4,NULL,NULL,'IC 0194',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21126,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21126,35.02,0.34,101,5415,NULL,NULL,NULL,'IC 0194',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21127,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 16842','RN',21127,37.69,0.27,321,5416,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16842',0.076165,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21128,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 16842','RN',21128,38.22,0.24,409,5416,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16842',0.076165,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21129,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21129,36.32,0.12,183,5417,70,NULL,NULL,'2MASX J02031605-0102252',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000097,NULL,'15.7g',0.19,'E0',NULL,NULL,NULL,NULL,1,30.81675,-1.04033,0.025,NULL,35012838688,547075604,8548056,15.7),(21130,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21130,36.57,0.58,206,5417,70,NULL,NULL,'2MASX J02031605-0102252',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21131,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21131,35.86,0.46,149,5418,70,NULL,NULL,'2MASX J02031600+0017554',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000087,NULL,'15.52',0.43,NULL,NULL,NULL,NULL,NULL,1,30.8167916667,0.29883,0.025,NULL,67005105342,1046954770,16358668,15.52),(21132,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21132,36.15,0.51,170,5419,70,NULL,NULL,'2MASX J02031705-1500508',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.44',0.18,NULL,NULL,NULL,NULL,NULL,1,30.821125,-15.01417,0,NULL,35083314757,548176793,8565262,16.44),(21133,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21133,36.83,0.63,232,5420,70,NULL,NULL,'VV 379',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000137,NULL,'15.47',0.5,NULL,NULL,NULL,NULL,NULL,1,30.8217083333,-12.63794,0,NULL,35052796549,547699946,8557811,15.47),(21134,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21134,37.39,0.63,301,5421,70,NULL,NULL,'2MASX J02031741-0622120',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.89',0.4,NULL,NULL,NULL,NULL,NULL,1,30.8225417,-6.37014,0.012,NULL,35155062963,549297858,8582779,16.89),(21135,'Tully est','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21135,32.47,0.8,31.2,5422,75,NULL,'B','UGC 01546',NULL,'1988NBGC.C....0000T',1988,1,1.1,NULL,'G',0.000019,NULL,'14.42',1.1,'SAB(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,30.834167,18.62961,0.177,NULL,66916879653,1045576244,16337128,14.42),(21136,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21136,32.73,0.4,35.1,5423,75,NULL,'B','UGC 01547',NULL,'1988NBGC.C....0000T',1988,1,2.2,'The 2MASS position applies to a knot or star superposed east of the galaxy.','G',0.000003,NULL,'14.40',2.1,'IBm','Isolated galaxy',NULL,NULL,NULL,1,30.8345,22.04142,0.273,NULL,68064516265,1063508066,16617313,14.4),(21137,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21137,32.48,0.2,31.3,5424,74.4,NULL,NULL,'UGC 01538',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000017,NULL,'17.',0.8,'Im:',NULL,NULL,NULL,NULL,1,30.83625,23.76083,0.301,NULL,68062089731,1063470152,16616721,17),(21138,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21138,35.48,0.46,125,5425,70,NULL,NULL,'2MASX J02032263-0837500',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000075,NULL,'15.6g',0.4,'E0',NULL,NULL,NULL,NULL,1,30.844375,-8.63064,0.006,NULL,35161676675,549401198,8584393,15.6),(21139,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21139,37.73,0.46,352,5426,70,NULL,NULL,'SDSS J020326.19-090558.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000075,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,30.859167,-9.09944,0.025,NULL,35161146093,549392907,8584264,18.5),(21140,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21140,36.96,0.33,246,5427,70,NULL,NULL,'2MASX J02032653+1235210',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000122,NULL,'16.4g',0.32,'E0',NULL,NULL,NULL,NULL,1,30.86075,12.58919,0.221,NULL,66950469764,1046101090,16345329,16.4),(21141,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 04491','RN',21141,41.9,0.33,2020,5428,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04491',0.191982,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21142,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 04491','RN',21142,42.15,0.32,2260,5428,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04491',0.191982,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21143,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21143,34.45,0.4,77.7,5429,NULL,NULL,'mean','NGC 0797 NED02',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000013,NULL,'13.1',1.4,'SAB(s)a','in a pair',NULL,NULL,NULL,1,30.866417,38.11694,0.193,NULL,67732954001,1058327406,16536365,13.1),(21144,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21144,35.25,0.47,112,5429,NULL,NULL,'H','NGC 0797 NED02',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21145,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21145,35.25,0.45,112,5429,NULL,NULL,'K','NGC 0797 NED02',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21146,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21146,35.32,0.46,116,5429,NULL,NULL,'J','NGC 0797 NED02',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21147,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21147,37.08,0.33,260,5430,70,NULL,NULL,'2MASX J02032890+1358160',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000099,NULL,'16.2g',0.33,'E0',NULL,NULL,NULL,NULL,1,30.870333,13.97122,0.153,NULL,66952087590,1046126368,16345724,16.2),(21148,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21148,36.96,0.33,246,5431,70,NULL,NULL,'2MASX J02033036+1235180',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000102,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,30.876667,12.58825,0.221,NULL,66950470640,1046101103,16345329,17.3),(21149,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21149,32.23,0.49,27.9,5432,75,NULL,'IR','NGC 0806',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.00003,NULL,'14.50',0.4,'Scd pec?       HII',NULL,NULL,NULL,NULL,1,30.8797917,-9.93336,0.043,NULL,35160767461,549386991,8584171,14.5),(21150,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 17204','R',21150,38.16,0.08,404,5433,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2007hw','2MASX J02033513+0047044',0.061951,'2014arXiv1401.3317S',2014,1,0.37,NULL,'G',0.000085,NULL,'16.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,30.8964583,0.78469,0.025,NULL,67005981256,1046968457,16358882,16.4),(21151,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 17204','R',21151,39.19,0.2,648,5433,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2007hw','2MASX J02033513+0047044',0.061951,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21152,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21152,34.03,0.2,64,5434,74.4,NULL,NULL,'UGC 01553',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.00008,NULL,'15.14',0.6,'Sd',NULL,NULL,NULL,NULL,1,30.8980417,4.78572,0.113,NULL,67070974266,1047983972,16374749,15.14),(21153,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21153,34.13,0.41,67.1,5434,NULL,NULL,NULL,'UGC 01553',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21154,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21154,34.34,0.38,73.8,5434,NULL,NULL,'Malmquist cor.','UGC 01553',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21155,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21155,34.56,0.49,81.8,5435,75,NULL,'IR','UGC 01537',NULL,'2011yCatp016004901K',2011,1,1.66,NULL,'G',0.00003,NULL,'16.5',0.17,'Sc',NULL,NULL,NULL,NULL,1,30.9015,48.45525,1.045,NULL,67832953034,1059889891,16560779,16.5),(21156,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21156,35.18,NULL,108,5435,NULL,NULL,'Dipole','UGC 01537',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21157,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21157,35.18,NULL,109,5435,NULL,NULL,'Dipole + Quadrupole','UGC 01537',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21158,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21158,35.18,NULL,109,5435,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01537',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21159,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21159,35.21,0.4,110,5435,NULL,NULL,'mean','UGC 01537',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21160,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21160,35.31,0.47,116,5435,NULL,NULL,'H','UGC 01537',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21161,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21161,35.34,0.2,117,5435,74.4,NULL,NULL,'UGC 01537',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21162,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21162,35.44,0.45,122,5435,NULL,NULL,'K','UGC 01537',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21163,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21163,35.07,0.49,103,5436,75,NULL,'IR','CGCG 438-018',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000067,NULL,'15.58',0.2,NULL,NULL,NULL,NULL,NULL,1,30.9042083,15.74686,0.133,NULL,66964270565,1046316727,16348698,15.58),(21164,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21164,35.19,0.2,109,5436,74.4,NULL,NULL,'CGCG 438-018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21165,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21165,35.23,0.48,111,5436,NULL,NULL,'Malmquist cor.','CGCG 438-018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21166,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21166,35.3,0.47,115,5436,NULL,NULL,NULL,'CGCG 438-018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21167,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 01437','RN',21167,43.99,0.29,4160,5437,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01437',0.510152,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21168,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21168,32.75,0.4,35.6,5438,75,NULL,'B','UGC 01551',NULL,'1988NBGC.C....0000T',1988,1,2.8,NULL,'G',0.000007,NULL,'13.50',2.3,'Sdm            HII',NULL,NULL,NULL,NULL,1,30.9062083,24.0755,0.333,NULL,68062120648,1063470635,16616728,13.5),(21169,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21169,36.49,0.63,199,5439,70,NULL,NULL,'2MASX J02033775-1708005',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'16.46',0.23,NULL,NULL,NULL,NULL,NULL,1,30.907375,-17.13347,0.022,NULL,35089911543,548279867,8566872,16.46),(21170,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21170,37.15,0.23,269,5440,70,NULL,NULL,'2MASX J02033946+0012575',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000095,NULL,'15.8g',0.17,'BrClG',NULL,NULL,NULL,NULL,1,30.9143333333,0.21592,0.021,NULL,67005116309,1046954942,16358670,15.8),(21171,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21171,34.29,0.44,72.2,5441,NULL,NULL,'Malmquist cor.','CGCG 482-062',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000033,NULL,'15.00',0.4,'Sc',NULL,NULL,NULL,NULL,1,30.9210833333,26.27692,0.313,NULL,68600735052,1071886485,16748226,15),(21172,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21172,34.36,0.43,74.4,5441,NULL,NULL,NULL,'CGCG 482-062',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21173,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21173,34.4,0.2,75.9,5441,74.4,NULL,NULL,'CGCG 482-062',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21174,'IRAS','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21174,32.03,0.8,25.5,5442,75,NULL,'CF, r','NGC 0803',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000003,NULL,'13.24',1.3,'SA(s)c: sp','Isolated galaxy (6 Mpc isolation)',NULL,NULL,NULL,1,30.93625,16.03097,0.133,NULL,66965091279,1046329551,16348899,13.24),(21175,'IRAS','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21175,32.04,0.8,25.6,5442,75,NULL,'A82, H','NGC 0803',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21176,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21176,31.13,0.4,16.8,5442,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 0803',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21177,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21177,31.23,0.47,17.6,5442,75,NULL,'A82, H, inv','NGC 0803',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21178,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21178,31.27,0.47,17.9,5442,75,NULL,'A82, H, raw','NGC 0803',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21179,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21179,31.58,0.47,20.7,5442,75,NULL,'A82, H, cor','NGC 0803',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21180,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21180,31.61,0.36,21,5442,NULL,NULL,NULL,'NGC 0803',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21181,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21181,31.61,0.4,21,5442,73,NULL,'opt','NGC 0803',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21182,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21182,31.68,0.43,21.7,5442,75,NULL,'3.6 micron, color corrected','NGC 0803',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21183,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21183,31.69,0.2,21.8,5442,74.4,NULL,NULL,'NGC 0803',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21184,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21184,31.72,0.43,22.1,5442,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0803',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21185,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21185,31.94,0.49,24.4,5442,NULL,NULL,NULL,'NGC 0803',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21186,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21186,31.96,0.49,24.6,5442,NULL,NULL,'Malmquist cor.','NGC 0803',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21187,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21187,32.16,0.4,27,5442,NULL,NULL,'mean','NGC 0803',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21188,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21188,32.19,0.38,27.4,5442,75,NULL,'CF, r, raw','NGC 0803',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21189,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21189,32.19,0.46,27.4,5442,NULL,NULL,'J','NGC 0803',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21190,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21190,32.2,0.47,27.6,5442,NULL,NULL,'H','NGC 0803',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21191,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21191,32.2,0.4,27.6,5442,75,NULL,'B','NGC 0803',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21192,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21192,32.26,0.38,28.3,5442,75,NULL,'CF, r, inv','NGC 0803',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21193,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21193,32.29,0.45,28.7,5442,NULL,NULL,'K','NGC 0803',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21194,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21194,32.46,0.38,31,5442,75,NULL,'CF, r, cor','NGC 0803',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21195,'IRAS','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21195,34.51,0.8,79.7,5443,75,NULL,'CF, r','NGC 0801',NULL,'1997ApJS..109..333W',1997,1,3.2,NULL,'G',0.00002,NULL,'13.96',0.7,'Sc             LINER','in a pair',NULL,NULL,NULL,1,30.9367916667,38.25872,0.193,NULL,67733626403,1058337912,16536529,13.96),(21196,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21196,33.4,0.38,47.8,5443,75,NULL,'CF, r, raw','NGC 0801',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21197,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21197,33.57,0.38,51.7,5443,75,NULL,'CF, r, inv','NGC 0801',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21198,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21198,33.59,0.2,52.2,5443,74.4,NULL,NULL,'NGC 0801',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21199,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21199,33.68,0.43,54.4,5443,75,NULL,'3.6 micron, color corrected','NGC 0801',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21200,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21200,33.68,0.47,54.5,5443,NULL,NULL,'H','NGC 0801',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21201,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21201,33.74,0.38,56,5443,75,NULL,'CF, r, cor','NGC 0801',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21202,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21202,33.75,0.45,56.2,5443,NULL,NULL,'K','NGC 0801',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21203,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21203,33.76,0.46,56.4,5443,NULL,NULL,'J','NGC 0801',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21204,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21204,33.89,0.43,60.1,5443,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0801',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21205,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21205,34.49,0.4,79.1,5443,NULL,NULL,'mean','NGC 0801',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21206,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21206,34.5,0.09,79.6,5443,NULL,NULL,NULL,'NGC 0801',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21207,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21207,36.32,0.12,183,5444,70,NULL,NULL,'2MASX J02034537-0057394',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000068,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,30.939083,-0.96097,0.025,NULL,35012600826,547071887,8547998,16.4),(21208,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 10237','RN',21208,40.01,0.2,963,5445,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10237',0.042438,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21209,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 10237','RN',21209,40.47,0.35,1190,5445,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10237',0.042438,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21210,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 01559','RN',21210,40.75,0.1,1190,5446,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 01559',0.182601,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21211,'HII LF','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21211,47.49,3.43,7060,5447,71,NULL,NULL,'PKS 0201+113 oB013',2.167,'2005MNRAS.356.1117S',2005,1,NULL,NULL,'G',0.002,NULL,'23.43',NULL,'LBG',NULL,NULL,NULL,NULL,1,30.955125,11.60297,0.209,NULL,67080429737,1048131714,16377058,23.43),(21212,'L(H{beta})-{sigma}','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21212,46.04,NULL,1606,5447,74.3,NULL,NULL,'PKS 0201+113 oB013',2.167,'2015MNRAS.451.3001T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21213,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21213,34.88,0.44,94.4,5448,NULL,NULL,'Malmquist cor.','ESO 153- G 012',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.37',0.47,'S...',NULL,NULL,NULL,NULL,1,30.955875,-52.44769,0.005,NULL,38223000480,597234382,9331787,15.37),(21214,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21214,34.92,0.43,96.4,5448,NULL,NULL,NULL,'ESO 153- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21215,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21215,34.96,0.2,98.2,5448,74.4,NULL,NULL,'ESO 153- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21216,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21216,33.21,0.47,43.9,5449,NULL,NULL,'H','IC 0196',NULL,'2007A&A...465...71T',2007,1,2.6,NULL,'G',0.00003,NULL,'13.6g',0.79,'SBb:','Pair member (points to parent)',NULL,NULL,NULL,1,30.9575,14.73914,0.137,NULL,66951821822,1046122215,16345659,13.6),(21217,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21217,33.24,0.45,44.4,5449,NULL,NULL,'K','IC 0196',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21218,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21218,33.24,0.46,44.4,5449,NULL,NULL,'J','IC 0196',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21219,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21219,33.43,0.4,48.6,5449,NULL,NULL,'mean','IC 0196',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21220,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21220,33.71,0.49,55.2,5449,75,NULL,'IR','IC 0196',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21221,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21221,36.46,0.46,196,5450,70,NULL,NULL,'2MASX J02035320+1340114',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000098,NULL,'16.2g',0.36,'E0',NULL,NULL,NULL,NULL,1,30.9717916667,13.67,0.157,NULL,66952921789,1046139402,16345928,16.2),(21222,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21222,36.32,0.12,183,5451,70,NULL,NULL,'2MASX J02035351-0058354',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000078,NULL,'16.2g',0.34,'E0',NULL,NULL,NULL,NULL,1,30.9729583,-0.97661,0.025,NULL,35012602523,547071914,8547998,16.2),(21223,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21223,35.7,0.73,138,5452,70,NULL,NULL,'2MASX J02035503-1636225',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'16.34',0.37,NULL,NULL,NULL,NULL,NULL,1,30.979333,-16.60633,0.014,NULL,35091162370,548299412,8567178,16.34),(21224,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21224,35.49,0.4,125,5453,NULL,NULL,'mean','UGC 01560',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000017,NULL,'14.56',0.8,'(R\')SB(s)b:',NULL,NULL,NULL,NULL,1,30.984167,19.66869,0.277,NULL,68053268697,1063332323,16614567,14.56),(21225,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21225,35.64,0.47,134,5453,NULL,NULL,'H','UGC 01560',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21226,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21226,33.91,0.47,60.7,5454,NULL,NULL,'H','NGC 0808',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000033,NULL,'13.87',0.6,'(R\')SAB(rs)bc  HII',NULL,NULL,NULL,NULL,1,30.985833,-23.31161,0,NULL,37931993567,592687399,9260740,13.87),(21227,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21227,33.92,0.45,60.7,5454,NULL,NULL,'K','NGC 0808',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21228,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21228,34.01,0.39,63.4,5454,NULL,NULL,'Malmquist cor.','NGC 0808',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21229,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21229,34.02,0.46,63.7,5454,NULL,NULL,'J','NGC 0808',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21230,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21230,34.08,0.4,65.5,5454,NULL,NULL,'mean','NGC 0808',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21231,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21231,34.18,0.36,68.4,5454,NULL,NULL,NULL,'NGC 0808',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21232,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21232,34.22,0.2,69.8,5454,74.4,NULL,NULL,'NGC 0808',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21233,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21233,36.32,0.12,183,5455,70,NULL,NULL,'2MASX J02035797-0058164',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000084,NULL,'16.1g',0.31,'S0^-',NULL,NULL,NULL,NULL,1,30.991667,-0.97117,0.025,NULL,35012604289,547071942,8547999,16.1),(21234,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21234,36.48,0.46,198,5456,70,NULL,NULL,'KUG 0201-093',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000112,NULL,'15.3g',0.55,'Spiral',NULL,NULL,NULL,NULL,1,31.000083,-9.10597,0.009,NULL,35161149944,549392967,8584265,15.3),(21235,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 03935','RN',21235,43.29,0.19,2760,5457,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03935',0.642542,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21236,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2005gt',NULL,21236,40.12,0.17,826,5458,74.2,NULL,'SALT 2','SDSS J020404.00-002158.6',0.28,'2010ApJ...716..712A',2010,1,0.09,NULL,'G',0.0005,NULL,'20.2g',0.07,NULL,NULL,NULL,NULL,NULL,1,31.0167083,-0.36631,0.029,NULL,34998550696,546852354,8544568,20.2),(21237,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2005gt',NULL,21237,40.81,0.18,1130,5458,65,NULL,'SALT2','SDSS J020404.00-002158.6',0.28,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21238,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2005gt',NULL,21238,40.27,0.2,1130,5458,70,NULL,'Hubble residual 0.20 for z0.27860','SDSS J020404.00-002158.6',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21239,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 04000','R',21239,40.83,0.27,1150,5458,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005gt','SDSS J020404.00-002158.6',0.2786,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21240,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2005gt',NULL,21240,40.85,0.2,1160,5458,70,NULL,'SALT 2','SDSS J020404.00-002158.6',0.28,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21241,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 04000','R',21241,40.96,0.24,1220,5458,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005gt','SDSS J020404.00-002158.6',0.2786,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21242,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2005gt',NULL,21242,41.05,0.21,1270,5458,65,NULL,'MLCS2k2','SDSS J020404.00-002158.6',0.28,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21243,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2005gt',NULL,21243,40.67,0.17,1360,5458,70,NULL,'SALT 2','SDSS J020404.00-002158.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21244,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2005gt',NULL,21244,40.7,0.17,1380,5458,70,NULL,'SALT 2, Malmquist cor.','SDSS J020404.00-002158.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21245,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21245,33.86,0.48,59.1,5459,NULL,NULL,NULL,'IC 0197',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.00002,NULL,'14.29',0.5,'SBbc:          HII',NULL,NULL,NULL,NULL,1,31.0205416667,2.78683,0.045,NULL,67006192142,1046971752,16358933,14.29),(21246,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21246,33.9,0.2,60.3,5459,74.4,NULL,NULL,'IC 0197',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21247,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21247,33.98,0.69,62.6,5459,100,NULL,'mid-IR','IC 0197',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21248,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21248,34.14,0.42,67.3,5459,NULL,NULL,'Malmquist cor.','IC 0197',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21249,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21249,29.83,0.4,9.3,5460,75,NULL,'B','UGC 01561',NULL,'1988NBGC.C....0000T',1988,1,1,NULL,'G',0.000007,NULL,'14.51',0.9,'Im',NULL,NULL,NULL,NULL,1,31.02125,24.20833,0.305,NULL,68062051270,1063469551,16616711,14.51),(21250,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21250,34.83,0.41,92.3,5461,NULL,NULL,'Malmquist cor.','FGC 0233',NULL,'2009ApJS..182..474S',2009,1,0.76,NULL,'G',NULL,NULL,'17.18',0.1,'Sdm',NULL,NULL,NULL,NULL,1,31.0284166667,2.67133,0.045,NULL,67006185633,1046971650,16358932,17.18),(21251,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21251,35.12,0.36,106,5461,NULL,NULL,NULL,'FGC 0233',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21252,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21252,35.18,0.2,109,5461,74.4,NULL,NULL,'FGC 0233',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21253,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21253,35.4,0.49,120,5461,75,NULL,'IR','FGC 0233',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21254,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21254,35.46,NULL,124,5461,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0233',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21255,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21255,35.48,NULL,125,5461,NULL,NULL,'Dipole + Quadrupole','FGC 0233',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21256,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21256,35.51,NULL,126,5461,NULL,NULL,'Dipole','FGC 0233',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21257,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21257,37.15,0.23,269,5462,70,NULL,NULL,'2MASX J02040795+0010195',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000072,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,31.0332916667,0.17206,0.025,NULL,66993576740,1046774636,16355853,17.1),(21258,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21258,35.95,0.49,155,5463,75,NULL,'IR','FGC 027A',NULL,'2011yCatp016004901K',2011,1,0.73,NULL,'G',0.000017,NULL,'13.0K',0.12,NULL,NULL,NULL,NULL,NULL,1,31.045833,10.45586,0.177,NULL,67099778683,1048434041,16381781,13),(21259,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2006ef',NULL,21259,33.71,0.2,54.2,5464,74.2,NULL,'SALT 2','NGC 0809',0.017884,'2010ApJ...716..712A',2010,1,1.14,NULL,'G',0.00006,NULL,'14.1g',0.92,'(R)S0+:',NULL,NULL,NULL,NULL,1,31.0790416667,-8.73531,0.017,NULL,35161214407,549393975,8584280,14.1),(21260,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2006ef',NULL,21260,34.29,0.15,69.7,5464,72,NULL,NULL,'NGC 0809',0.01702,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21261,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2006ef',NULL,21261,34.38,0.09,75.2,5464,74.4,NULL,NULL,'NGC 0809',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21262,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2006ef',NULL,21262,34.42,0.04,75.2,5464,72,NULL,'MLCS17','NGC 0809',0.017884,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21263,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2006ef',NULL,21263,34.48,0.19,77.4,5464,70,NULL,'SALT 2','NGC 0809',0.017884,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21264,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2006ef',NULL,21264,34.77,0.23,88.4,5464,65,NULL,'MLCS17','NGC 0809',0.017884,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21265,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2006ef',NULL,21265,34.79,0.24,89,5464,65,NULL,'SALT2','NGC 0809',0.017884,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21266,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2006ef',NULL,21266,34.84,0.23,91.3,5464,65,NULL,'MLCS31','NGC 0809',0.017884,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21267,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21267,38.23,0.46,443,5465,70,NULL,NULL,'2MASX J02041960-0052195',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'18.46',0.21,NULL,NULL,NULL,NULL,NULL,1,31.081833,-0.87211,0.025,NULL,35012551862,547071122,8547986,18.46),(21268,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21268,36.32,0.12,183,5466,70,NULL,NULL,'2MASX J02042127-0052005',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000067,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,31.0885,-0.86683,0.025,NULL,34998720638,546855009,8544609,17.1),(21269,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE g276',NULL,21269,40.5,0.22,1010,5467,65,NULL,'SALT2','ESSENCE g276 HOST',0.244,'2009ApJ...700.1097H',2009,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,31.1125416667,-3.59547,0,NULL,35137902595,549029728,8578589,NULL),(21270,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE g276',NULL,21270,40.5,0.33,1010,5467,65,NULL,'MLCS31','ESSENCE g276 HOST',0.244,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21271,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE g276',NULL,21271,40.55,0.26,1040,5467,65,NULL,'MLCS17','ESSENCE g276 HOST',0.244,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21272,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2004ha',NULL,21272,41.76,0.34,1500,5468,65,NULL,'SN h283, SALT2','ESSENCE J020427.00-045246.0',0.5,'2009ApJS..185...32K',2009,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,31.1125,-4.87944,0.009,NULL,35138915659,549045557,8578836,NULL),(21273,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2004ha',NULL,21273,41.9,0.31,1600,5468,70,NULL,'SN h283, SALT','ESSENCE J020427.00-045246.0',0.5,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21274,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2004ha',NULL,21274,42.01,0.43,1690,5468,65,NULL,'SN h283, SALT','ESSENCE J020427.00-045246.0',0.5,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21275,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2004ha','R',21275,42.06,NULL,1720,5468,65,NULL,'SN h283, SALT','ESSENCE J020427.00-045246.0',0.5,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21276,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2004ha',NULL,21276,42.21,0.23,1840,5468,65,NULL,'SN h283, MLCS2k2','ESSENCE J020427.00-045246.0',0.5,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21277,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2004ha',NULL,21277,42.23,0.1,1860,5468,65,NULL,'SN h283, SALT','ESSENCE J020427.00-045246.0',0.5,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21278,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2004ha',NULL,21278,42.35,0.33,1970,5468,65,NULL,'SN h283, MLCS17','ESSENCE J020427.00-045246.0',0.5,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21279,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2004ha',NULL,21279,42.5,0.35,2100,5468,65,NULL,'SN h283, MLCS2k2','ESSENCE J020427.00-045246.0',0.5,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21280,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 07942','RN',21280,43.05,0.25,2780,5469,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 07942',0.465527,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21281,'IRAS','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21281,31.16,0.8,17.1,5470,75,NULL,'A82, H','UGCA 024',NULL,'1997ApJS..109..333W',1997,1,3.2,'Position in 1986AnTok..212.127T is incorrect.','G',0.00001,NULL,'13.5',1.3,'SB(s)m',NULL,NULL,NULL,NULL,1,31.131,-6.19892,0.04,NULL,35155014360,549297099,8582767,13.5),(21282,'Tully est','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21282,31.13,0.8,16.8,5470,75,NULL,NULL,'UGCA 024',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21283,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21283,31.85,0.47,23.5,5470,75,NULL,'A82, H, inv','UGCA 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21284,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21284,31.99,0.47,25,5470,75,NULL,'A82, H, raw','UGCA 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21285,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21285,32.19,0.47,27.4,5470,75,NULL,'A82, H, cor','UGCA 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21286,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21286,37.65,0.46,340,5471,70,NULL,NULL,'2MASX J02043447+1316364',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000074,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,31.143625,13.27672,0.169,NULL,66952975924,1046140248,16345941,17.6),(21287,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21287,37.98,0.46,394,5472,70,NULL,NULL,'2MASX J02043768+1424384',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000837,NULL,'18.2g',0.14,'BLAGN',NULL,NULL,NULL,'Sy 1',1,31.156875,14.41058,0.141,NULL,66952561461,1046133772,16345840,18.2),(21288,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 02437','RN',21288,42.42,0.26,2420,5473,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 02437',0.259608,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21289,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 02437','RN',21289,42.5,0.28,2510,5473,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02437',0.259608,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21290,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21290,36.32,0.12,183,5474,70,NULL,NULL,'2MASX J02043851-0048378',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000071,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,31.1605,-0.81044,0.025,NULL,34998726972,546855108,8544611,16.3),(21291,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21291,37.62,0.46,334,5475,70,NULL,NULL,'2MASX J02043907-0806042',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000081,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,31.1627917,-8.10122,0.017,NULL,35164382314,549443473,8585054,17.1),(21292,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2002jr',NULL,21292,40.62,0.46,934,5476,74.2,NULL,'SALT 2','ESSENCE J020441.03-050940.7',0.425,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,'20.6r',NULL,NULL,NULL,NULL,NULL,NULL,1,31.17125,-5.16189,0.013,NULL,35138973304,549046457,8578850,20.6),(21293,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2002jr',NULL,21293,41.41,0.29,1340,5476,70,NULL,'SN b020, SALT','ESSENCE J020441.03-050940.7',0.425,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21294,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2002jr',NULL,21294,41.65,0.59,1500,5476,65,NULL,'SN b020, SALT2','ESSENCE J020441.03-050940.7',0.425,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21295,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2002jr',NULL,21295,41.67,0.36,1510,5476,65,NULL,'SN b020, MLCS17','ESSENCE J020441.03-050940.7',0.425,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21296,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2002jr',NULL,21296,41.7,0.32,1530,5476,65,NULL,'SN b020, SALT','ESSENCE J020441.03-050940.7',0.425,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21297,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2002jr',NULL,21297,41.74,0.37,1570,5476,65,NULL,'SN b020, MLCS31','ESSENCE J020441.03-050940.7',0.425,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21298,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2002jr',NULL,21298,41.77,0.37,1580,5476,65,NULL,'SN b020, MLCS2k2','ESSENCE J020441.03-050940.7',0.425,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21299,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 19707','RN',21299,43.95,0.22,3790,5477,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19707',0.626504,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21300,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21300,33.12,0.49,42.1,5478,75,NULL,'IR','UGC 01572',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000003,NULL,'14.30',0.3,'S?','Pair member, wide',NULL,NULL,NULL,1,31.1824583,8.54308,0.193,NULL,67108206761,1048565730,16383839,14.3),(21301,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21301,33.54,0.4,51,5478,NULL,NULL,'mean','UGC 01572',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21302,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21302,33.87,0.46,59.3,5478,NULL,NULL,'J','UGC 01572',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21303,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21303,33.87,0.47,59.5,5478,NULL,NULL,'H','UGC 01572',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21304,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21304,33.97,0.45,62.3,5478,NULL,NULL,'K','UGC 01572',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21305,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 15699','RN',21305,41.32,0.18,1610,5479,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15699',0.141973,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21306,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21306,35.67,0.54,136,5480,NULL,NULL,NULL,'2MASX J02045062+3448149',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',NULL,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,31.2109583,34.80414,0.253,NULL,68625500724,1072273448,16754272,14.5),(21307,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21307,35.71,0.2,139,5480,74.4,NULL,NULL,'2MASX J02045062+3448149',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21308,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21308,35.74,0.52,141,5480,NULL,NULL,'Malmquist cor.','2MASX J02045062+3448149',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21309,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2005fs',NULL,21309,40.59,0.17,987,5481,74.2,NULL,'SALT 2','SDSS J020452.96-001934.8',0.33,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,31.220667,-0.32633,0.013,NULL,34998528318,546852004,8544562,NULL),(21310,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2005fs',NULL,21310,40.61,0.06,994,5481,70,NULL,'SDSS-II SN 02533','SDSS J020452.96-001934.8',0.33,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21311,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2005fs',NULL,21311,40.58,0.19,1300,5481,70,NULL,'Hubble residual 0.15 for z0.34000','SDSS J020452.96-001934.8',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21312,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 02533','R',21312,41.36,0.19,1390,5481,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fs','SDSS J020452.96-001934.8',0.34,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21313,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 02533','R',21313,41.41,0.27,1430,5481,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fs','SDSS J020452.96-001934.8',0.34,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21314,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2005fs',NULL,21314,41.4,0.3,1430,5481,65,NULL,'SALT2','SDSS J020452.96-001934.8',0.33,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21315,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2005fs',NULL,21315,41.45,0.13,1470,5481,65,NULL,'MLCS2k2','SDSS J020452.96-001934.8',0.33,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21316,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21316,37.97,0.46,392,5482,70,NULL,NULL,'2MASX J02045454+1323354',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000072,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,31.22725,13.39342,0.169,NULL,66953086789,1046141981,16345968,18.1),(21317,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21317,37.58,0.46,328,5483,70,NULL,NULL,'2MASX J02045469-0948549',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000085,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,31.227875,-9.81528,0.014,NULL,35159987242,549374800,8583981,17.7),(21318,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21318,35.04,0.49,102,5484,75,NULL,'IR','UGC 01567',NULL,'2011yCatp016004901K',2011,1,1.57,NULL,'G',NULL,NULL,'16.0',0.15,'Sc',NULL,NULL,NULL,NULL,1,31.2312917,43.155,0.381,NULL,67827160310,1059799379,16559365,16),(21319,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21319,35.34,NULL,117,5484,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01567',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21320,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21320,35.36,NULL,118,5484,NULL,NULL,'Dipole + Quadrupole','UGC 01567',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21321,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21321,35.36,NULL,118,5484,NULL,NULL,'Dipole','UGC 01567',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21322,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21322,35.82,NULL,146,5484,NULL,NULL,NULL,'UGC 01567',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21323,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21323,36.09,0.43,165,5484,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01567',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21324,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21324,36.1,0.43,166,5484,75,NULL,'3.6 micron, color corrected','UGC 01567',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21325,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21325,36.18,0.2,172,5484,74.4,NULL,NULL,'UGC 01567',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21326,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21326,33.65,0.45,53.7,5485,NULL,NULL,'K','NGC 0807',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.00004,NULL,'13.47',1.3,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,31.231917,28.98744,0.141,NULL,68596557204,1071821206,16747206,13.47),(21327,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21327,34.12,0.4,66.6,5485,NULL,NULL,'mean','NGC 0807',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21328,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21328,35.78,0.46,143,5486,70,NULL,NULL,'SDSS J020455.76+140055.3',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'15.9g',0.42,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,31.232333,14.01539,0.157,NULL,66952407954,1046131374,16345802,15.9),(21329,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE p534','R',21329,41.78,NULL,1410,5487,65,NULL,'SALT','ESSENCE p534 HOST',0.619,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,31.2337083,-3.81769,0,NULL,35138765823,549043215,8578800,NULL),(21330,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE p534',NULL,21330,41.9,0.26,1480,5487,74.2,NULL,'SALT 2','ESSENCE p534 HOST',0.619,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21331,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE p534',NULL,21331,42.43,0.33,1890,5487,70,NULL,'SALT','ESSENCE p534 HOST',0.619,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21332,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE p534',NULL,21332,42.53,0.17,1980,5487,65,NULL,'SALT','ESSENCE p534 HOST',0.619,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21333,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE p534',NULL,21333,42.61,0.61,2060,5487,65,NULL,'SALT','ESSENCE p534 HOST',0.619,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21334,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE p534',NULL,21334,42.84,0.21,2290,5487,65,NULL,'MLCS2k2','ESSENCE p534 HOST',0.619,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21335,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 04278','RN',21335,43.23,0.23,3060,5488,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04278',0.444835,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21336,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 04278','RN',21336,43.49,0.21,3450,5488,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04278',0.444835,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21337,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 19155','R',21337,37.82,0.18,340,5489,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007mn','2MASX J02050352+0010309',0.076974,'2014arXiv1401.3317S',2014,1,0.49,NULL,'G',0.000126,NULL,'17.5g',0.14,'Sb(f)          NLAGN',NULL,NULL,NULL,NULL,1,31.264833,0.17511,0.029,NULL,66993755923,1046777436,16355897,17.5),(21338,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2007mn',NULL,21338,37.8,0.07,363,5489,70,NULL,'SALT 2','2MASX J02050352+0010309',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21339,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2007mn',NULL,21339,37.8,0.07,363,5489,70,NULL,'SALT 2, Malmquist cor.','2MASX J02050352+0010309',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21340,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 19155','R',21340,38.02,0.05,374,5489,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007mn','2MASX J02050352+0010309',0.076974,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21341,'IRAS','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21341,34.64,0.8,84.7,5490,75,NULL,'MAT, I','ESO 153- G 017',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.00002,NULL,'13.8B',1.9,'SAB(r)bc',NULL,NULL,NULL,NULL,1,31.2731666667,-55.11186,0.017,NULL,36163670263,565057347,8829021,13.8),(21342,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21342,31.7,0.43,21.8,5490,75,NULL,'MAT, I, raw','ESO 153- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21343,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21343,31.71,0.43,22,5490,75,NULL,'MAT, I, inv','ESO 153- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21344,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21344,31.81,0.43,23,5490,75,NULL,'MAT, I, cor','ESO 153- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21345,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21345,33.08,0.32,41.3,5490,85,NULL,'I, raw','ESO 153- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21346,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21346,33.12,0.32,42,5490,85,NULL,'I, inv','ESO 153- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21347,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21347,34.51,0.47,79.9,5490,NULL,NULL,'H','ESO 153- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21348,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21348,34.7,0.45,87,5490,NULL,NULL,'K','ESO 153- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21349,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21349,34.7,0.46,87,5490,NULL,NULL,'J','ESO 153- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21350,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21350,34.78,0.4,90.5,5490,NULL,NULL,'mean','ESO 153- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21351,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 17302','RN',21351,42.11,0.16,2140,5491,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 17302',0.234596,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21352,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 15063','RN',21352,42.56,0.5,2420,5492,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15063',0.342773,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21353,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21353,33.98,NULL,62.4,5493,NULL,NULL,'Dipole','UGC 01575',NULL,'2010Ap&SS.325..163P',2010,1,1.37,NULL,'G',0.00001,NULL,'18.',0.12,'Scd',NULL,NULL,NULL,NULL,1,31.2927083,24.66628,0.273,NULL,68591566126,1071743220,16745987,18),(21354,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21354,33.98,NULL,62.4,5493,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01575',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21355,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21355,33.98,NULL,62.6,5493,NULL,NULL,'Dipole + Quadrupole','UGC 01575',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21356,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21356,34.21,NULL,69.5,5493,NULL,NULL,NULL,'UGC 01575',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21357,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21357,34.61,0.49,83.4,5494,75,NULL,'IR','UGC 01580',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000073,NULL,'15.05',0.3,'S?',NULL,NULL,NULL,NULL,1,31.3082917,9.92525,0.137,NULL,67100344969,1048442890,16381920,15.05),(21358,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21358,34.81,0.41,91.5,5494,NULL,NULL,'Malmquist cor.','UGC 01580',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21359,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21359,34.87,0.4,94.2,5494,NULL,NULL,NULL,'UGC 01580',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21360,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21360,34.91,0.2,95.9,5494,74.4,NULL,NULL,'UGC 01580',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21361,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE n263','R',21361,40.52,NULL,928,5495,65,NULL,'MLCS17','ESSENCE n263 HOST',0.368,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,31.3122917,-4.94419,0.009,NULL,35138982575,549046602,8578853,NULL),(21362,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE n263',NULL,21362,40.76,0.21,1040,5495,74.2,NULL,'SALT 2','ESSENCE n263 HOST',0.368,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21363,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE n263',NULL,21363,41.42,0.18,1400,5495,65,NULL,'MLCS17','ESSENCE n263 HOST',0.368,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21364,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE n263',NULL,21364,41.41,0.2,1400,5495,70,NULL,'SALT','ESSENCE n263 HOST',0.368,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21365,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE n263',NULL,21365,41.5,0.18,1460,5495,65,NULL,'MLCS31','ESSENCE n263 HOST',0.368,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21366,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE n263',NULL,21366,41.52,0.16,1470,5495,65,NULL,'SALT2','ESSENCE n263 HOST',0.368,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21367,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE n263',NULL,21367,41.56,0.14,1500,5495,65,NULL,'MLCS2k2','ESSENCE n263 HOST',0.368,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21368,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE n263',NULL,21368,41.6,0.18,1530,5495,65,NULL,'SALT','ESSENCE n263 HOST',0.368,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21369,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE n263',NULL,21369,41.64,0.05,1560,5495,65,NULL,'SALT','ESSENCE n263 HOST',0.368,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21370,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE n263',NULL,21370,41.67,0.12,1580,5495,65,NULL,'MLCS2k2','ESSENCE n263 HOST',0.368,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21371,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE n263',NULL,21371,41.69,0.2,1590,5495,65,NULL,'SALT2','ESSENCE n263 HOST',0.368,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21372,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21372,33.66,NULL,54.1,5496,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01576',NULL,'2010Ap&SS.325..163P',2010,1,1.02,NULL,'G',0.000007,NULL,'17.',0.11,'Sd',NULL,NULL,NULL,NULL,1,31.3124166667,30.00483,0.161,NULL,68596064840,1071813513,16747086,17),(21373,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21373,33.68,NULL,54.5,5496,NULL,NULL,'Dipole + Quadrupole','UGC 01576',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21374,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21374,33.7,NULL,55,5496,NULL,NULL,'Dipole','UGC 01576',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21375,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21375,33.72,0.2,55.5,5496,74.4,NULL,NULL,'UGC 01576',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21376,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21376,33.87,NULL,59.5,5496,NULL,NULL,NULL,'UGC 01576',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21377,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21377,33.96,0.35,61.8,5496,NULL,NULL,NULL,'UGC 01576',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21378,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21378,34.21,0.31,69.5,5496,NULL,NULL,'Malmquist cor.','UGC 01576',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21379,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21379,34.26,0.09,71.3,5497,NULL,NULL,NULL,'UGC 01574',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.00006,NULL,'15.52',0.3,'Scd:',NULL,NULL,NULL,NULL,1,31.3137917,37.63375,0.125,NULL,67732846469,1058325726,16536339,15.52),(21380,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21380,34.75,0.2,89.1,5497,74.4,NULL,NULL,'UGC 01574',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21381,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21381,34.32,0.49,73.1,5498,75,NULL,'IR','KUG 0202+345',NULL,'2011yCatp016004901K',2011,1,0.8,'The UZC has V = 11868 +- 44 km/sec.','G',0.000014,NULL,'15.4',0.4,'Double','Group member',NULL,NULL,NULL,1,31.321417,34.78875,0.253,NULL,68626029485,1072281710,16754401,15.4),(21382,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21382,34.56,0.43,81.5,5498,75,NULL,'3.6 micron, color + selection bias corrected','KUG 0202+345',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21383,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21383,34.6,0.43,83.3,5498,75,NULL,'3.6 micron, color corrected','KUG 0202+345',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21384,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21384,34.7,0.2,87.1,5498,74.4,NULL,NULL,'KUG 0202+345',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21385,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21385,36.92,0.46,242,5499,70,NULL,NULL,'2MASX J02051819+0013529',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000073,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,31.3257917,0.23136,0.029,NULL,66993725758,1046776964,16355890,17.1),(21386,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 02304','RN',21386,42.89,0.22,2290,5500,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02304',0.654883,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21387,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21387,35.13,0.46,106,5501,70,NULL,NULL,'2MASX J02051989+1315304',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000075,NULL,'16.0g',0.32,'E0',NULL,NULL,NULL,NULL,1,31.332833,13.2585,0.217,NULL,66953447845,1046147622,16346056,16),(21388,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21388,34.94,0.43,97.3,5502,NULL,NULL,'Malmquist cor.','CGCG 413-038',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000167,NULL,'15.6',0.3,NULL,NULL,NULL,NULL,NULL,1,31.3374583333,8.52614,0.201,NULL,67108285675,1048566963,16383858,15.6),(21389,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21389,35,0.42,100,5502,NULL,NULL,NULL,'CGCG 413-038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21390,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21390,35.32,0.2,116,5502,74.4,NULL,NULL,'CGCG 413-038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21391,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21391,37.45,0.46,309,5503,70,NULL,NULL,'SDSS J020523.08-002733.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000067,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,31.3462083,-0.45931,0.013,NULL,34999274259,546863660,8544744,18.3),(21392,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21392,33.13,0.69,42.2,5504,100,NULL,'mid-IR','IC 0200',NULL,'2013ApJ...771...88L',2013,1,2.2,NULL,'G',0.000013,NULL,'13.65',1.5,'SBbc           AGN?','Isolated galaxy',NULL,NULL,NULL,1,31.361,31.17533,0.157,NULL,68640131292,1072502051,16757844,13.65),(21393,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21393,34.1,0.47,66.1,5504,NULL,NULL,'H','IC 0200',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21394,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21394,34.18,0.45,68.4,5504,NULL,NULL,'K','IC 0200',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21395,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21395,34.25,0.46,70.8,5504,NULL,NULL,'J','IC 0200',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21396,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21396,34.29,0.08,72.3,5504,NULL,NULL,NULL,'IC 0200',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21397,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21397,34.36,0.4,74.5,5504,NULL,NULL,'mean','IC 0200',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21398,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21398,34.64,0.49,84.8,5505,NULL,NULL,'Malmquist cor.','UGC 01584',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',NULL,NULL,'16.0',0.7,'Scd:',NULL,NULL,NULL,NULL,1,31.3615,13.32708,0.217,NULL,66953561240,1046149394,16346084,16),(21399,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21399,34.67,0.48,86.1,5505,NULL,NULL,NULL,'UGC 01584',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21400,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21400,34.73,0.2,88.3,5505,74.4,NULL,NULL,'UGC 01584',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21401,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 07017','R',21401,40.03,0.08,798,5506,70,NULL,'SDSS CAND. SNIa; MLCS2K2','SDSS-II SN 07017',0.269,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,31.365333,-0.49792,0.013,NULL,34999281501,546863773,8544746,NULL),(21402,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 07017','R',21402,40.49,0.22,986,5506,70,NULL,'SDSS CAND. SNIa; SALT 2','SDSS-II SN 07017',0.269,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21403,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21403,36.92,0.46,242,5507,70,NULL,NULL,'2MASX J02053241+0057520',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000072,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,31.385083,0.96444,0.033,NULL,66994301758,1046785964,16356030,17.5),(21404,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21404,33.79,0.43,57.4,5508,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01581',NULL,'2014MNRAS.444..527S',2014,1,1.7,NULL,'G',0.000008,NULL,'15.06',0.7,'Sdm:','Group member',NULL,NULL,NULL,1,31.3905,34.88094,0.253,NULL,68626031909,1072281748,16754402,15.06),(21405,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21405,33.89,0.08,60.1,5508,NULL,NULL,NULL,'UGC 01581',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21406,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21406,33.96,0.43,62.1,5508,75,NULL,'3.6 micron, color corrected','UGC 01581',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21407,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21407,34.17,0.2,68.2,5508,74.4,NULL,NULL,'UGC 01581',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21408,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 18984','RN',21408,38.96,0.11,537,5509,70,NULL,'SDSS CAND. SNII; MLCS2K2','SDSS-II SN 18984',0.154964,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21409,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 18984','RN',21409,39.03,0.19,554,5509,70,NULL,'SDSS CAND. SNII; SALT 2','SDSS-II SN 18984',0.154964,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21410,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21410,34.24,0.49,70.5,5510,75,NULL,'IR','UGC 01587',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'14.60',0.4,'Sa','Isolated galaxy',NULL,NULL,NULL,1,31.405417,6.77203,0.125,NULL,67102457827,1048475903,16382435,14.6),(21411,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21411,34.44,0.4,77.3,5510,NULL,NULL,'mean','UGC 01587',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21412,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21412,34.73,0.47,88.4,5510,NULL,NULL,'H','UGC 01587',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21413,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 13371','RN',21413,43.04,0.21,2910,5511,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13371',0.395937,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21414,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 13371','RN',21414,43.66,0.16,3860,5511,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13371',0.395937,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21415,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21415,36.19,0.46,173,5512,70,NULL,NULL,'2MASX J02053916+1439081',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000105,NULL,'15.3g',0.46,'E0',NULL,NULL,NULL,NULL,1,31.4132083333,14.65217,0.149,NULL,66953797168,1046153080,16346141,15.3),(21416,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 16047','RN',21416,40.17,0.4,858,5513,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 16047',0.263248,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21417,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21417,33.63,NULL,53.2,5514,NULL,NULL,'B','ESO 052- G 020',NULL,'2004ApJ...607..241R',2004,1,1.2,NULL,'G',0.000033,NULL,'14.54',0.6,'SB(s)bc pec','Pair member (points to parent)',NULL,NULL,NULL,1,31.4295,-71.11547,0.017,NULL,36335933953,567748968,8871077,14.54),(21418,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21418,34,NULL,63.1,5514,NULL,NULL,'B','ESO 052- G 020',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21419,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21419,34,NULL,63.1,5514,NULL,NULL,'B, Hubble-type-TF','ESO 052- G 020',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21420,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21420,34,0.18,63.1,5514,NULL,NULL,'B, Hubble-type-TF','ESO 052- G 020',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21421,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21421,34,NULL,63.1,5514,NULL,NULL,'I','ESO 052- G 020',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21422,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21422,34,NULL,63.1,5514,NULL,NULL,'B','ESO 052- G 020',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21423,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21423,34,0.18,63.1,5514,NULL,NULL,'B, Hubble-type-TF','ESO 052- G 020',NULL,'2005Ap&SS.299..387R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21424,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21424,34,NULL,63.2,5514,NULL,NULL,'B, Hubble-type-TF','ESO 052- G 020',NULL,'2005Ap&SS.299..405R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21425,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21425,34.25,NULL,70.8,5514,NULL,NULL,'I','ESO 052- G 020',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21426,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21426,34.84,0.47,92.7,5514,NULL,NULL,NULL,'ESO 052- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21427,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21427,34.88,0.2,94.6,5514,74.4,NULL,NULL,'ESO 052- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21428,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21428,35.09,0.42,104,5514,NULL,NULL,'Malmquist cor.','ESO 052- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21429,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 18971','R',21429,40.6,0.25,1030,5515,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18971',0.271354,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,31.445417,1.20878,0.025,NULL,66994588476,1046790444,16356100,NULL),(21430,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 18971',NULL,21430,40.1,0.31,1050,5515,70,NULL,'SN photometric redshift distance, z photo =0.284 +/- 0.052','SDSS-II SN 18971',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21431,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 18971','R',21431,40.9,0.19,1190,5515,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18971',0.271354,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21432,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 18971',NULL,21432,40.4,0.16,1200,5515,70,NULL,'SALT 2','SDSS-II SN 18971',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21433,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 18971',NULL,21433,40.42,0.16,1210,5515,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18971',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21434,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21434,34.2,0.4,69.1,5516,NULL,NULL,'mean','MCG -01-06-043',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000103,NULL,'15.03',0.3,'Sb             HII',NULL,NULL,NULL,NULL,1,31.453333,-5.29436,0.017,NULL,35137090728,549017042,8578391,15.03),(21435,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21435,34.25,0.47,70.7,5516,NULL,NULL,'H','MCG -01-06-043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21436,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21436,34.25,0.45,70.9,5516,NULL,NULL,'K','MCG -01-06-043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21437,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21437,34.39,0.46,75.5,5516,NULL,NULL,'J','MCG -01-06-043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21438,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2007ni',NULL,21438,39.03,0.11,641,5517,70,NULL,'Hubble residual -0.37 for z0.19600','SDSS J020550.49-001957.1',NULL,'2011ApJ...740...92G',2011,1,0.07,NULL,'G',0.005,NULL,'21.0g',0.05,NULL,NULL,NULL,NULL,NULL,1,31.460417,-0.33256,0.013,NULL,34999204215,546862565,8544727,21),(21439,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 19149','R',21439,39.75,0.18,744,5517,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ni','SDSS J020550.49-001957.1',0.196,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21440,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 19149','R',21440,39.81,0.09,766,5517,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ni','SDSS J020550.49-001957.1',0.196,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21441,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2007ni',NULL,21441,39.56,0.07,817,5517,70,NULL,'SALT 2','SDSS J020550.49-001957.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21442,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2007ni',NULL,21442,39.57,0.07,820,5517,70,NULL,'SALT 2, Malmquist cor.','SDSS J020550.49-001957.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21443,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21443,34.8,0.49,91.2,5518,75,NULL,'IR','UGC 01578',NULL,'2011yCatp016004901K',2011,1,1.52,NULL,'G',0.000077,NULL,'17.',0.17,'Sc',NULL,NULL,NULL,NULL,1,31.4782083333,50.73767,0.997,NULL,67840148132,1060002314,16562536,17),(21444,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21444,34.86,NULL,93.7,5518,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01578',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21445,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21445,34.87,NULL,94.1,5518,NULL,NULL,'Dipole','UGC 01578',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21446,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21446,34.87,NULL,94.3,5518,NULL,NULL,'Dipole + Quadrupole','UGC 01578',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21447,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21447,34.92,NULL,96.3,5518,NULL,NULL,NULL,'UGC 01578',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21448,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21448,36.12,0.27,168,5519,70,NULL,NULL,'CGCG 387-033',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000104,NULL,'15.1g',0.59,'E0',NULL,NULL,NULL,NULL,1,31.487625,0.77333,0.021,NULL,66994209880,1046784529,16356008,15.1),(21449,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 14661','RN',21449,40.22,0.23,943,5520,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 14661',0.176694,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21450,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 14661','RN',21450,40.45,0.15,1050,5520,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 14661',0.176694,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21451,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 16163','R',21451,39.48,0.21,683,5521,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J020559.79-005121.0',0.1549,'2014arXiv1401.3317S',2014,1,0.19,NULL,'G',0.0005,NULL,'19.34',0.16,NULL,NULL,NULL,NULL,NULL,1,31.4989583,-0.85586,0.021,NULL,34998671244,546854238,8544597,19.34),(21452,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 16163',NULL,21452,39.23,0.11,701,5521,70,NULL,'SALT 2','SDSS J020559.79-005121.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21453,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 16163',NULL,21453,39.24,0.11,705,5521,70,NULL,'SALT 2, Malmquist cor.','SDSS J020559.79-005121.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21454,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 16163','R',21454,39.68,0.13,747,5521,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J020559.79-005121.0',0.1549,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21455,'Brightest Stars','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21455,24.5,NULL,0.79,5522,NULL,NULL,NULL,'Cas 1',NULL,'1996AN....317..175T',1996,1,1.9,NULL,'G',0.000001,NULL,'16.38',1.55,'Dwarf Irregular','Brightest group member',NULL,NULL,NULL,1,31.511667,68.99972,NULL,1,66488545439,1038883522,16232555,16.38),(21456,'HII region diameter','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21456,28.49,NULL,5,5522,NULL,NULL,NULL,'Cas 1',NULL,'1995PASP..107...58W',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21457,'IRAS','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21457,35.44,0.8,122,5523,75,NULL,'A82, H','IC 0198',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000027,NULL,'14.58',0.6,'S',NULL,NULL,NULL,NULL,1,31.513,9.29556,0.201,NULL,67099144529,1048424133,16381627,14.58),(21458,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21458,34.26,0.33,71.2,5523,91,NULL,'H','IC 0198',NULL,'1984ApJ...278..475B',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21459,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21459,34.74,0.47,88.9,5523,75,NULL,'A82, H, raw','IC 0198',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21460,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21460,34.86,0.69,93.5,5523,100,NULL,'mid-IR','IC 0198',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21461,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21461,34.9,0.47,95.3,5523,75,NULL,'A82, H, inv','IC 0198',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21462,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21462,34.95,0.42,97.9,5523,NULL,NULL,'Malmquist cor.','IC 0198',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21463,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21463,35.01,0.41,101,5523,NULL,NULL,NULL,'IC 0198',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21464,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21464,35.12,0.47,106,5523,75,NULL,'A82, H, cor','IC 0198',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21465,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21465,35.23,0.2,111,5523,74.4,NULL,NULL,'IC 0198',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21466,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE m226',NULL,21466,41.38,0.3,1130,5524,74.2,NULL,'SALT 2','ESSENCE m226 HOST',0.675,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,31.515375,-4.66642,0.009,NULL,35138893719,549045214,8578831,NULL),(21467,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE m226','R',21467,42.01,NULL,1500,5524,65,NULL,'SALT','ESSENCE m226 HOST',0.675,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21468,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE m226',NULL,21468,42.19,0.33,1640,5524,70,NULL,'SALT','ESSENCE m226 HOST',0.675,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21469,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE m226',NULL,21469,42.23,0.41,1670,5524,65,NULL,'SALT','ESSENCE m226 HOST',0.675,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21470,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE m226',NULL,21470,42.76,0.18,2130,5524,65,NULL,'SALT','ESSENCE m226 HOST',0.675,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21471,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE m226',NULL,21471,43.05,0.2,2430,5524,65,NULL,'SALT2','ESSENCE m226 HOST',0.675,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21472,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE m226',NULL,21472,43.13,0.2,2520,5524,65,NULL,'MLCS2k2','ESSENCE m226 HOST',0.675,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21473,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21473,37.45,0.33,309,5525,70,NULL,NULL,'2MASX J02060495-0944105',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000086,NULL,'16.4g',0.36,'BrClG',NULL,NULL,NULL,NULL,1,31.5205416667,-9.73633,0,NULL,35158545037,549352266,8583629,16.4),(21474,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21474,35.15,0.2,107,5526,74.4,NULL,NULL,'UGC 01593',NULL,'2013AJ....146...86T',2013,1,0.84,NULL,'G',0.000061,NULL,'15.2g',0.61,'SAB(rs)c',NULL,NULL,NULL,NULL,1,31.524875,13.28522,0.253,NULL,66953617018,1046150265,16346097,15.2),(21475,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21475,34.73,0.4,88.4,5527,NULL,NULL,'mean','UGC 01586',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000037,NULL,'14.6',0.9,'SABb',NULL,NULL,NULL,NULL,1,31.5329583,49.90939,1.221,NULL,67844801333,1060075020,16563672,14.6),(21476,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21476,34.89,0.47,94.9,5527,NULL,NULL,'H','UGC 01586',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21477,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21477,36.44,0.33,194,5528,70,NULL,NULL,'2MASX J02061372-0947156',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000076,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,31.557125,-9.78767,0,NULL,35158556423,549352444,8583631,17.3),(21478,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21478,37.16,0.46,271,5529,70,NULL,NULL,'2MASX J02061601-0848526',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000104,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,31.56675,-8.81478,0.016,NULL,35162652248,549416441,8584631,16.3),(21479,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21479,36.44,0.33,194,5530,70,NULL,NULL,'2MASX J02061636-0958506',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000111,NULL,'15.2g',0.49,'S0^-',NULL,NULL,NULL,NULL,1,31.5682083,-9.98072,0.016,NULL,35158405952,549350093,8583595,15.2),(21480,'IRAS','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21480,34.19,0.8,68.9,5531,75,NULL,'MAT, I','ESO 298- G 008',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000026,NULL,'14.68',0.6,'SAB(rs)c','in a pair',NULL,NULL,NULL,1,31.5682083,-41.52308,NULL,NULL,38321774525,598777726,9355901,14.68),(21481,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21481,33.7,0.32,54.9,5531,85,NULL,'I, raw','ESO 298- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21482,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21482,33.73,0.32,55.6,5531,85,NULL,'I, inv','ESO 298- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21483,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21483,33.8,0.34,57.5,5531,NULL,NULL,NULL,'ESO 298- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21484,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21484,33.84,0.43,58.6,5531,75,NULL,'MAT, I, raw','ESO 298- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21485,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21485,33.84,0.2,58.6,5531,74.4,NULL,NULL,'ESO 298- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21486,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21486,33.99,0.43,62.8,5531,75,NULL,'MAT, I, inv','ESO 298- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21487,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21487,34.18,0.43,68.5,5531,75,NULL,'MAT, I, cor','ESO 298- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21488,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21488,34.19,0.28,69,5531,NULL,NULL,'Malmquist cor.','ESO 298- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21489,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21489,37.45,0.33,309,5532,70,NULL,NULL,'2MASX J02061825-0940006',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000076,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,31.5760417,-9.66675,0,NULL,35158538497,549352164,8583627,17.7),(21490,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21490,37.51,0.69,318,5533,70,NULL,NULL,'MCG -01-06-044',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.5',0.5,NULL,NULL,NULL,NULL,NULL,1,31.580375,-2.35628,0.025,NULL,34999547487,546867929,8544811,15.5),(21491,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21491,35.11,0.38,105,5534,NULL,NULL,'Malmquist cor.','IC 0199',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.00011,NULL,'14.90',0.8,'Sab',NULL,NULL,NULL,NULL,1,31.580833,9.22742,0.201,NULL,67099002897,1048421920,16381592,14.9),(21492,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21492,35.23,0.36,111,5534,NULL,NULL,NULL,'IC 0199',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21493,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21493,35.52,0.2,127,5534,74.4,NULL,NULL,'IC 0199',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21494,'IRAS','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21494,34.38,0.8,75.1,5535,75,NULL,'MAT, I','ESO 197- G 024',NULL,'1997ApJS..109..333W',1997,1,1.83,NULL,'G',0.000033,NULL,'15.36',0.29,'Scd',NULL,NULL,NULL,NULL,1,31.5865833333,-52.02808,0,NULL,38243120270,597548754,9336699,15.36),(21495,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21495,34.1,0.32,66.1,5535,85,NULL,'I, raw','ESO 197- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21496,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21496,34.11,0.43,66.3,5535,75,NULL,'MAT, I, raw','ESO 197- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21497,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21497,34.13,0.32,67.1,5535,85,NULL,'I, inv','ESO 197- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21498,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21498,34.19,0.49,69,5535,75,NULL,'IR','ESO 197- G 024',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21499,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21499,34.27,0.43,71.6,5535,75,NULL,'MAT, I, inv','ESO 197- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21500,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21500,34.4,0.34,75.7,5535,NULL,NULL,NULL,'ESO 197- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21501,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21501,34.44,0.2,77.3,5535,74.4,NULL,NULL,'ESO 197- G 024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21502,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21502,34.51,0.43,79.8,5535,75,NULL,'MAT, I, cor','ESO 197- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21503,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21503,34.55,0.32,81.4,5535,NULL,NULL,'Malmquist cor.','ESO 197- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21504,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21504,34.56,NULL,81.8,5535,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 197- G 024',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21505,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21505,34.57,NULL,82,5535,NULL,NULL,'Dipole + Quadrupole','ESO 197- G 024',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21506,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21506,34.58,NULL,82.6,5535,NULL,NULL,'Dipole','ESO 197- G 024',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21507,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21507,34.62,NULL,84.1,5535,NULL,NULL,NULL,'ESO 197- G 024',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21508,'GRB','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21508,43.61,0.55,2840,5536,69.7,NULL,'Calibrated','GRB 040924',0.859,'2009MNRAS.400..775C',2009,1,NULL,NULL,'G',NULL,NULL,'18.0R',NULL,'Opt.var.',NULL,NULL,NULL,NULL,1,31.5939583,16.11356,0.145,NULL,66947053531,1046047711,16344495,18),(21509,'GRB','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21509,43.74,0.61,3010,5536,72,NULL,NULL,'GRB 040924',0.859,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21510,'GRB','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21510,43.84,0.61,3150,5536,70,NULL,NULL,'GRB 040924',0.859,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21511,'GRB','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21511,44.06,0.61,3490,5536,69.7,NULL,'Fiducial','GRB 040924',0.859,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21512,'GRB','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21512,44.11,0.3,3570,5536,69.7,NULL,'Calibrated','GRB 040924',0.859,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21513,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2004hh',NULL,21513,39.37,0.23,623,5537,74.2,NULL,'SALT 2','APMUKS(BJ) B020353.90-045222.0',0.2,'2010ApJ...716..712A',2010,1,0.16,NULL,'G',NULL,NULL,'19.59',0.12,NULL,NULL,NULL,NULL,NULL,1,31.6032083,-4.63486,0,NULL,35138842769,549044418,8578819,19.59),(21514,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2004hh',NULL,21514,40.25,0.32,935,5537,65,NULL,'SN h363, MLCS31','APMUKS(BJ) B020353.90-045222.0',0.2,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21515,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2004hh',NULL,21515,40.27,0.27,943,5537,65,NULL,'SN h363, SALT2','APMUKS(BJ) B020353.90-045222.0',0.2,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21516,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2004hh',NULL,21516,40.29,0.28,952,5537,65,NULL,'SN h363, SALT2','APMUKS(BJ) B020353.90-045222.0',0.2,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21517,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2004hh',NULL,21517,40.33,0.32,971,5537,65,NULL,'SN h363, MLCS2k2','APMUKS(BJ) B020353.90-045222.0',0.2,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21518,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2004hh',NULL,21518,40.34,0.2,975,5537,70,NULL,'SN h363, SALT','APMUKS(BJ) B020353.90-045222.0',0.2,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21519,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2004hh',NULL,21519,40.39,0.19,999,5537,65,NULL,'SN h363, SALT','APMUKS(BJ) B020353.90-045222.0',0.2,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21520,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2004hh',NULL,21520,40.48,0.29,1040,5537,65,NULL,'SN h363, MLCS17','APMUKS(BJ) B020353.90-045222.0',0.2,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21521,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2004hh',NULL,21521,40.51,0.21,1050,5537,65,NULL,'SN h363, MLCS2k2','APMUKS(BJ) B020353.90-045222.0',0.2,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21522,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2004hh','R',21522,40.8,NULL,1200,5537,65,NULL,'SN h363, MLCS31','APMUKS(BJ) B020353.90-045222.0',0.2,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21523,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2004hh',NULL,21523,40.83,0.07,1220,5537,65,NULL,'SN h363, SALT','APMUKS(BJ) B020353.90-045222.0',0.2,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21524,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21524,38.17,0.46,431,5538,70,NULL,NULL,'SDSS J020625.10-003841.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000076,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,31.604625,-0.64472,0.021,NULL,34999172086,546862063,8544719,18),(21525,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2007hx',NULL,21525,38.02,0.13,373,5539,73.8,NULL,'SALT 2 (SNANA)','SDSS J020626.74-005400.4',0.0789,'2014ApJ...795...44R',2014,1,0.05,NULL,'G',NULL,NULL,'21.6g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,31.6114583,-0.90011,0.033,NULL,34998705690,546854776,8544605,21.6),(21526,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2007hx',NULL,21526,38.01,0.07,400,5539,70,NULL,'SALT 2','SDSS J020626.74-005400.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21527,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2007hx',NULL,21527,38.02,0.07,402,5539,70,NULL,'SALT 2, Malmquist cor.','SDSS J020626.74-005400.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21528,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 17186','R',21528,38.12,0.19,389,5540,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007hx','SN 2007hx',0.079443,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,31.612833,-0.89953,0.033,NULL,34998705720,546854776,8544605,NULL),(21529,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 17186','R',21529,38.19,0.08,402,5540,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007hx','SN 2007hx',0.079443,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21530,'IRAS','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21530,34.03,0.8,63.9,5541,75,NULL,'W91PP, r','UGC 01595',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.00001,NULL,'15.19',0.5,'Scd:','Isolated galaxy',NULL,NULL,NULL,1,31.613125,27.0335,0.217,NULL,68598514488,1071851788,16747684,15.19),(21531,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21531,34.27,0.38,71.6,5541,75,NULL,'W91PP, r, raw','UGC 01595',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21532,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21532,34.31,0.38,72.8,5541,75,NULL,'W91PP, r, cor','UGC 01595',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21533,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21533,34.31,0.38,72.9,5541,75,NULL,'W91PP, r, inv','UGC 01595',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21534,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21534,34.36,0.2,74.5,5541,74.4,NULL,NULL,'UGC 01595',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21535,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21535,33.75,NULL,56.4,5542,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0242',NULL,'2010Ap&SS.325..163P',2010,1,1.03,'Matthews (2000A&AS..143..421M) may have detected a feature at v=6051 km/sec.','G',0.000274,NULL,'16.5',0.11,'Sd',NULL,NULL,NULL,NULL,1,31.614333,31.11872,0.157,NULL,68640117932,1072501842,16757841,16.5),(21536,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21536,33.78,NULL,57,5542,NULL,NULL,'Dipole + Quadrupole','FGC 0242',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21537,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21537,33.79,NULL,57.2,5542,NULL,NULL,'Dipole','FGC 0242',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21538,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21538,33.86,NULL,59.2,5542,NULL,NULL,NULL,'FGC 0242',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21539,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21539,35.09,0.49,104,5543,75,NULL,'IR','FGC 0243',NULL,'2011yCatp016004901K',2011,1,0.92,NULL,'G',0.000011,NULL,'16.69',0.1,'Sd(f)',NULL,NULL,NULL,NULL,1,31.615375,13.66464,0.197,NULL,66952731899,1046136435,16345881,16.69),(21540,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21540,35.34,NULL,117,5543,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0243',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21541,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21541,35.36,NULL,118,5543,NULL,NULL,'Dipole + Quadrupole','FGC 0243',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21542,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21542,35.38,NULL,119,5543,NULL,NULL,'Dipole','FGC 0243',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21543,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21543,35.42,NULL,121,5543,NULL,NULL,NULL,'FGC 0243',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21544,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21544,35.5,0.2,126,5543,74.4,NULL,NULL,'FGC 0243',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21545,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21545,34.03,0.49,64,5544,75,NULL,'IR','CGCG 538-017',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.7',0.2,'S0/S',NULL,NULL,NULL,NULL,1,31.639875,44.377,0.429,NULL,67827764560,1059808821,16559512,15.7),(21546,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 00934','RN',21546,43.31,0.3,2740,5545,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00934',0.67511,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21547,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21547,35.68,0.34,137,5546,NULL,NULL,'Malmquist cor.','ESO 414- G 031',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.21',0.5,'SA(r)b',NULL,NULL,NULL,NULL,1,31.652375,-31.77783,NULL,NULL,38445459589,600710306,9386098,15.21),(21548,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21548,35.83,0.32,147,5546,NULL,NULL,NULL,'ESO 414- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21549,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21549,35.87,0.2,149,5546,74.4,NULL,NULL,'ESO 414- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21550,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21550,34.98,0.49,98.9,5547,NULL,NULL,'Malmquist cor.','UGC 01600',NULL,'2009ApJS..182..474S',2009,1,1.29,NULL,'G',0.000015,NULL,'17.',0.13,'Sd',NULL,NULL,NULL,NULL,1,31.653375,1.51569,0.025,NULL,66992838732,1046763105,16355673,17),(21551,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21551,35.3,NULL,115,5547,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01600',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21552,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21552,35.3,NULL,115,5547,NULL,NULL,'Dipole + Quadrupole','UGC 01600',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21553,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21553,35.3,NULL,115,5547,NULL,NULL,NULL,'UGC 01600',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21554,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21554,35.31,NULL,115,5547,NULL,NULL,'Dipole','UGC 01600',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21555,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21555,35.34,0.49,117,5547,75,NULL,'IR','UGC 01600',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21556,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21556,35.35,0.2,117,5547,74.4,NULL,NULL,'UGC 01600',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21557,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21557,35.39,0.4,120,5547,NULL,NULL,NULL,'UGC 01600',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21558,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21558,37.31,0.46,290,5548,70,NULL,NULL,'2MASX J02063806+1225313',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000095,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,31.6584166667,12.42525,0.241,NULL,66953204459,1046143819,16345997,17.3),(21559,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 00770','RN',21559,38.7,0.19,526,5549,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 00770',0.042391,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21560,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 00770','RN',21560,40.12,0.35,1010,5549,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 00770',0.042391,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21561,'D-Sigma','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21561,33.36,0.4,47,5550,75,NULL,'Edat, raw','NGC 0822',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000063,NULL,'14.11',0.6,'E+','in a pair',NULL,NULL,NULL,1,31.663083,-41.15675,NULL,NULL,38322795819,598793684,9356151,14.11),(21562,'D-Sigma','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21562,33.7,0.4,54.9,5550,75,NULL,'Edat, cor','NGC 0822',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21563,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21563,36.1,0.56,166,5551,70,NULL,NULL,'2MASX J02064135-0416423',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'16.95',0.3,NULL,NULL,NULL,NULL,NULL,1,31.672375,-4.2785,0.013,NULL,35138336688,549036510,8578695,16.95),(21564,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE n258','R',21564,41.81,NULL,1510,5552,65,NULL,'SALT','ESSENCE n258 HOST',0.522,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,31.6764583,-4.37694,0.033,NULL,35138363756,549036933,8578702,NULL),(21565,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE n258',NULL,21565,41.97,0.25,1630,5552,74.2,NULL,'SALT 2','ESSENCE n258 HOST',0.522,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21566,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE n258',NULL,21566,42.67,0.3,2250,5552,70,NULL,'SALT','ESSENCE n258 HOST',0.522,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21567,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE n258',NULL,21567,42.74,0.21,2320,5552,65,NULL,'MLCS2k2','ESSENCE n258 HOST',0.522,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21568,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE n258',NULL,21568,42.85,0.29,2440,5552,65,NULL,'SALT','ESSENCE n258 HOST',0.522,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21569,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE n258',NULL,21569,42.86,0.09,2460,5552,65,NULL,'SALT','ESSENCE n258 HOST',0.522,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21570,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21570,38.07,0.33,411,5553,70,NULL,NULL,'2MASX J02064460+0113455',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00009,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,31.685875,1.22936,0.029,NULL,66994778144,1046793408,16356147,16.7),(21571,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 15324','R',21571,41.39,0.2,1360,5554,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15324',0.392801,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,31.693583,-0.83908,0.033,NULL,34998662253,546854097,8544595,NULL),(21572,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 15324','R',21572,41.41,0.24,1370,5554,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15324',0.392801,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21573,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 15324',NULL,21573,41.25,0.15,1780,5554,70,NULL,'SALT 2','SDSS-II SN 15324',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21574,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 15324',NULL,21574,41.31,0.15,1830,5554,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15324',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21575,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 15324',NULL,21575,41.4,0.17,1900,5554,70,NULL,'SN photometric redshift distance, z photo =0.613 +/- 0.076','SDSS-II SN 15324',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21576,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21576,36.13,0.75,169,5555,70,NULL,NULL,'2MASX J02064662-2136363',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.19',0.35,NULL,NULL,NULL,NULL,NULL,1,31.6940833333,-21.61017,0,NULL,37929405800,592646965,9260108,16.19),(21577,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21577,36.03,0.75,160,5556,70,NULL,NULL,'2MASX J02064755-1823543',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,31.6982083,-18.39842,0.017,NULL,37971092303,593298317,9270286,15.3),(21578,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21578,38.07,0.33,411,5557,70,NULL,NULL,'2MASX J02064821+0112115',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000074,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,31.700833,1.20311,0.029,NULL,66994778533,1046793414,16356147,18),(21579,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 18179','RN',21579,41.69,0.45,1510,5558,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18179',0.446989,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21580,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 18179','RN',21580,41.96,0.55,1710,5558,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18179',0.446989,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21581,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21581,33.61,0.2,52.7,5559,74.4,NULL,NULL,'NGC 0812',NULL,'2013AJ....146...86T',2013,1,9.3,NULL,'G',0.000033,NULL,'12.2',2.2,'S pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,31.714583,44.57292,0.517,NULL,67827688556,1059807633,16559494,12.2),(21582,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21582,33.67,0.43,54.1,5559,75,NULL,'3.6 micron, color corrected','NGC 0812',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21583,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21583,33.81,0.49,57.7,5559,75,NULL,'IR','NGC 0812',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21584,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21584,33.83,0.43,58.2,5559,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0812',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21585,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21585,33.89,0.47,59.9,5559,NULL,NULL,'H','NGC 0812',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21586,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21586,33.89,0.45,60.1,5559,NULL,NULL,'K','NGC 0812',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21587,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21587,33.92,0.46,60.9,5559,NULL,NULL,'J','NGC 0812',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21588,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21588,34.24,0.4,70.6,5559,NULL,NULL,'mean','NGC 0812',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21589,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 21017','RN',21589,38.45,0.17,470,5560,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 21017',0.043359,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21590,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 21017','RN',21590,40.41,0.3,1160,5560,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 21017',0.043359,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21591,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21591,38.59,0.46,523,5561,70,NULL,NULL,'SDSS J020656.28+141259.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00007,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,31.7345417,14.21664,0.193,NULL,66954094052,1046157719,16346214,18.7),(21592,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 05879','RN',21592,39.88,0.21,820,5562,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 05879',0.153204,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21593,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 05879','RN',21593,40.13,0.24,919,5562,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 05879',0.153204,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21594,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 05879','N',21594,39.95,0.14,977,5562,70,NULL,'SALT 2','SDSS-II SN 05879',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21595,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 05879','N',21595,39.96,0.14,982,5562,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 05879',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21596,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 14349','RN',21596,42.85,0.25,2500,5563,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 14349',0.486412,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21597,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21597,36.98,0.55,249,5564,70,NULL,NULL,'2MASX J02070137-1354186',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.67',0.38,NULL,NULL,NULL,NULL,NULL,1,31.75575,-13.90525,0,NULL,35053355176,547708674,8557948,16.67),(21598,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21598,36.12,0.27,168,5565,70,NULL,NULL,'2MASX J02070216+0045228',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000086,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,31.759,0.75644,0.029,NULL,66994307296,1046786051,16356032,16.2),(21599,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 18366','RN',21599,41.55,0.17,1750,5566,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18366',0.164925,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21600,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 18366','RN',21600,41.56,0.23,1760,5566,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18366',0.164925,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21601,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21601,36.64,0.56,213,5567,70,NULL,NULL,'2MASX J02070439-0735249',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'17.31',0.19,NULL,NULL,NULL,NULL,NULL,1,31.7682083,-7.59033,0,NULL,35163610541,549431414,8584865,17.31),(21602,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE p528','R',21602,42.49,NULL,1760,5568,65,NULL,'SALT','ESSENCE p528 HOST',0.781,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,31.769417,-3.46789,0,NULL,35146267921,549160436,8580631,NULL),(21603,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE p528',NULL,21603,42.73,0.33,1970,5568,74.2,NULL,'SALT 2','ESSENCE p528 HOST',0.781,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21604,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE p528',NULL,21604,43.38,0.34,2660,5568,70,NULL,'SALT','ESSENCE p528 HOST',0.781,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21605,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE p528',NULL,21605,43.54,0.46,2860,5568,65,NULL,'SALT','ESSENCE p528 HOST',0.781,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21606,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE p528',NULL,21606,43.62,0.39,2970,5568,65,NULL,'SALT2','ESSENCE p528 HOST',0.781,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21607,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE p528',NULL,21607,43.63,0.34,2980,5568,65,NULL,'SALT','ESSENCE p528 HOST',0.781,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21608,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE p528',NULL,21608,43.73,0.17,3120,5568,65,NULL,'MLCS17','ESSENCE p528 HOST',0.781,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21609,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE p528',NULL,21609,43.75,0.14,3160,5568,65,NULL,'MLCS31','ESSENCE p528 HOST',0.781,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21610,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE p528',NULL,21610,43.76,0.12,3170,5568,65,NULL,'MLCS2k2','ESSENCE p528 HOST',0.781,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21611,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21611,34.08,0.49,65.4,5569,75,NULL,'IR','UGC 01601',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000063,NULL,'15.49',0.2,'SBbc',NULL,NULL,NULL,NULL,1,31.784625,42.96572,0.329,NULL,67815800647,1059621885,16556591,15.49),(21612,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21612,34.2,0.2,69.2,5569,74.4,NULL,NULL,'UGC 01601',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21613,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21613,34.31,0.37,72.8,5569,NULL,NULL,NULL,'UGC 01601',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21614,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21614,34.37,0.36,74.9,5569,NULL,NULL,'Malmquist cor.','UGC 01601',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21615,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21615,38.38,0.46,474,5570,70,NULL,NULL,'2MASX J02071014+1349263',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000077,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,31.792333,13.82397,0.209,NULL,66952146848,1046127294,16345738,18.7),(21616,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21616,35.08,0.56,104,5571,NULL,NULL,'Malmquist cor.','UGC 01606',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',NULL,NULL,'16.5',1,'Sd',NULL,NULL,NULL,NULL,1,31.8010417,8.97803,0.217,NULL,67107224457,1048550382,16383599,16.5),(21617,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21617,35.45,0.47,123,5571,NULL,NULL,NULL,'UGC 01606',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21618,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21618,35.49,0.2,125,5571,74.4,NULL,NULL,'UGC 01606',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21619,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 07648','RN',21619,39.68,0.21,738,5572,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 07648',0.171587,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21620,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 07648','RN',21620,39.81,0.28,783,5572,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07648',0.171587,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21621,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21621,34.54,NULL,80.9,5573,NULL,NULL,NULL,'FGC 0245',NULL,'2000BSAO...50....5K',2000,1,1.12,NULL,'G',NULL,NULL,'16.4',0.13,'Sd',NULL,NULL,NULL,NULL,1,31.8140833333,46.25547,0.645,NULL,67824983540,1059765367,16558833,16.4),(21622,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21622,37.72,0.46,350,5574,70,NULL,NULL,'2MASX J02071585+1413003',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000073,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,31.8160417,14.21681,0.193,NULL,66954091268,1046157676,16346213,18.2),(21623,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21623,36.12,0.27,168,5575,70,NULL,NULL,'2MASX J02071603+0034229',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000077,NULL,'15.9g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,31.8167083333,0.57303,0.025,NULL,66993853488,1046778960,16355921,15.9),(21624,'GRB','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21624,46.82,1.57,6730,5576,100,NULL,NULL,'GRB 060908',2.43,'2009EPJC...63..139W',2009,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,31.8265,0.342,0.033,NULL,66993988884,1046781076,16355954,NULL),(21625,'GRB','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21625,46.99,1.51,7290,5576,100,NULL,NULL,'GRB 060908',2.43,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21626,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 14421','R',21626,39.72,0.18,747,5577,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ia','2MASX J02071915+0115079',0.175024,'2014arXiv1401.3317S',2014,1,0.28,NULL,'G',0.000083,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,31.829917,1.25203,0.033,NULL,66994748294,1046792942,16356139,17.9),(21627,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 14421','R',21627,39.97,0.1,840,5577,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ia','2MASX J02071915+0115079',0.175024,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21628,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2006ia',NULL,21628,39.82,0.08,920,5577,70,NULL,'SALT 2','2MASX J02071915+0115079',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21629,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2006ia',NULL,21629,39.83,0.08,925,5577,70,NULL,'SALT 2, Malmquist cor.','2MASX J02071915+0115079',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21630,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21630,33.78,NULL,56.9,5578,NULL,NULL,'Dipole','UGC 01602',NULL,'2010Ap&SS.325..163P',2010,1,1.43,NULL,'G',0.00006,NULL,'16.5',0.17,'Sd',NULL,NULL,NULL,NULL,1,31.841167,43.77297,0.389,NULL,67828011847,1059812685,16559573,16.5),(21631,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21631,33.78,NULL,57,5578,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01602',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21632,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21632,33.79,NULL,57.2,5578,NULL,NULL,'Dipole + Quadrupole','UGC 01602',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21633,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21633,38.51,0.46,504,5579,70,NULL,NULL,'SDSS J020721.91+140840.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000079,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,31.841333,14.14456,0.193,NULL,66954152932,1046158639,16346228,18.7),(21634,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21634,36.94,0.46,245,5580,70,NULL,NULL,'2MASX J02072331+1329353',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000083,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,31.847167,13.49314,0.217,NULL,66952875781,1046138684,16345916,17.5),(21635,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 15008',NULL,21635,41.06,0.3,1630,5581,70,NULL,'SN photometric redshift distance, z photo =0.493 +/- 0.106','SDSS-II SN 15008',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,31.8482917,0.72803,0.029,NULL,66994965107,1046796329,16356192,NULL),(21636,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21636,35.09,0.39,104,5582,NULL,NULL,'Malmquist cor.','IC 0202',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000113,NULL,'15.14',0.2,'Sb',NULL,NULL,NULL,NULL,1,31.869417,9.16831,0.197,NULL,67098971530,1048421430,16381584,15.14),(21637,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21637,35.09,0.49,104,5582,75,NULL,'IR','IC 0202',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21638,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21638,35.19,0.37,109,5582,NULL,NULL,NULL,'IC 0202',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21639,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21639,35.37,0.2,119,5582,74.4,NULL,NULL,'IC 0202',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21640,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 18339',NULL,21640,40.22,0.14,1110,5583,70,NULL,'SN photometric redshift distance, z photo =0.303 +/- 0.024','SDSS-II SN 18339',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,31.872,1.15925,0.033,NULL,66995441504,1046803773,16356308,NULL),(21641,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 18339','R',21641,41.4,0.29,1420,5583,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18339',0.34593,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21642,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 18339','R',21642,41.46,0.2,1460,5583,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18339',0.34593,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21643,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 18339',NULL,21643,41.36,0.18,1870,5583,70,NULL,'SALT 2','SDSS-II SN 18339',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21644,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 18339',NULL,21644,41.41,0.18,1910,5583,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18339',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21645,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21645,36.19,0.67,173,5584,70,NULL,NULL,'6dF J0207293-350903',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,31.872667,-35.15072,NULL,NULL,38412692617,600198322,9378098,14.4),(21646,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21646,37.5,0.46,316,5585,70,NULL,NULL,'2MASX J02073087-0916577',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000082,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,31.878583,-9.28275,0.01,NULL,35158638065,549353719,8583651,17.3),(21647,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2007pt',NULL,21647,39.02,0.07,638,5586,70,NULL,'Hubble residual -0.16 for z0.17529','SDSS J020738.35-001926.5',NULL,'2011ApJ...740...92G',2011,1,0.11,NULL,'G',0.0001,NULL,'19.0g',0.08,NULL,NULL,NULL,NULL,NULL,1,31.909833,-0.32403,0.033,NULL,34999103219,546860987,8544702,19),(21648,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 19969','R',21648,39.57,0.18,699,5586,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007pt','SDSS J020738.35-001926.5',0.17529,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21649,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 19969','R',21649,39.71,0.09,743,5586,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007pt','SDSS J020738.35-001926.5',0.17529,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21650,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2007pt',NULL,21650,39.41,0.06,762,5586,70,NULL,'SALT 2','SDSS J020738.35-001926.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21651,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2007pt',NULL,21651,39.42,0.06,766,5586,70,NULL,'SALT 2, Malmquist cor.','SDSS J020738.35-001926.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21652,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21652,36.58,0.62,207,5587,70,NULL,NULL,'2MASX J02074195-0737436',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.96',0.31,NULL,NULL,NULL,NULL,NULL,1,31.9247917,-7.62886,0,NULL,35164096286,549439004,8584984,16.96),(21653,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21653,35.44,0.34,123,5588,NULL,NULL,'Malmquist cor.','ESO 081- G 003',NULL,'2009ApJS..182..474S',2009,1,1.34,NULL,'G',0.000033,NULL,'15.03',0.4,'Sb-c',NULL,NULL,NULL,NULL,1,31.9277083,-65.92803,0.045,NULL,36480118745,570001855,8906278,15.03),(21654,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21654,35.57,0.32,130,5588,NULL,NULL,NULL,'ESO 081- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21655,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21655,35.61,0.2,132,5588,74.4,NULL,NULL,'ESO 081- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21656,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21656,34.18,0.47,68.6,5589,NULL,NULL,'H','UGC 01607',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000037,NULL,'13.9',0.8,'SB(s)ab',NULL,NULL,NULL,NULL,1,31.928083,45.62306,0.529,NULL,67824722521,1059761289,16558770,13.9),(21657,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21657,34.25,0.45,71,5589,NULL,NULL,'K','UGC 01607',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21658,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21658,34.3,0.46,72.4,5589,NULL,NULL,'J','UGC 01607',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21659,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21659,34.6,0.4,83.2,5589,NULL,NULL,'mean','UGC 01607',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21660,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21660,34.81,0.45,91.5,5590,NULL,NULL,'K','UGC 01624',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.0001,NULL,'14.73',0.5,'S0:','Group member',NULL,NULL,NULL,1,31.9711666667,2.16761,0.045,NULL,66993335359,1046770864,16355794,14.73),(21661,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21661,34.94,0.4,97.3,5590,NULL,NULL,'mean','UGC 01624',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21662,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21662,36.72,0.33,221,5591,70,NULL,NULL,'2MASX J02075373-0748446',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.0001,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,31.974,-7.81239,0.014,NULL,35164243668,549441307,8585020,16.9),(21663,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2006od',NULL,21663,39.5,0.08,795,5592,70,NULL,'Hubble residual 0.01 for z0.20530','SDSS J020754.62-003207.7',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'*',NULL,NULL,'20.6g',NULL,NULL,NULL,NULL,NULL,NULL,1,31.977625,-0.53547,0.033,NULL,35001048255,546891378,8545177,20.6),(21664,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 15901','R',21664,40.01,0.19,834,5592,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006od','SDSS J020754.62-003207.7',0.20474,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21665,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 15901','R',21665,40.24,0.1,928,5592,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006od','SDSS J020754.62-003207.7',0.20474,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21666,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2006od',NULL,21666,39.92,0.08,964,5592,70,NULL,'SALT 2','SDSS J020754.62-003207.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21667,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2006od',NULL,21667,39.93,0.08,968,5592,70,NULL,'SALT 2, Malmquist cor.','SDSS J020754.62-003207.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21668,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2003ji',NULL,21668,39.37,0.22,618,5593,74.2,NULL,'SALT 2','ESSENCE J020754.84-032828.4',0.21,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,31.9785,-3.47456,0,NULL,35147169429,549174522,8580851,NULL),(21669,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2003ji',NULL,21669,40.22,0.08,915,5593,70,NULL,'SN d099, SALT','ESSENCE J020754.84-032828.4',0.21,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21670,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2003ji',NULL,21670,40.31,0.22,954,5593,65,NULL,'SN d099, MLCS17','ESSENCE J020754.84-032828.4',0.21,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21671,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2003ji',NULL,21671,40.4,0.19,994,5593,65,NULL,'SN d099, MLCS31','ESSENCE J020754.84-032828.4',0.21,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21672,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2003ji',NULL,21672,40.42,0.18,1000,5593,65,NULL,'SN d099, MLCS2k2','ESSENCE J020754.84-032828.4',0.21,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21673,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2003ji',NULL,21673,40.44,0.07,1010,5593,65,NULL,'SN d099, SALT','ESSENCE J020754.84-032828.4',0.21,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21674,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SN 2003ji',NULL,21674,40.61,0.29,1090,5593,65,NULL,'SN d099, SALT2','ESSENCE J020754.84-032828.4',0.21,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21675,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 01561','RN',21675,40.77,0.31,1180,5594,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 01561',0.211635,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21676,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 01561','RN',21676,41.85,0.3,1940,5594,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 01561',0.211635,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21677,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21677,34.9,0.2,95.5,5595,74.4,NULL,NULL,'UGC 01612',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000197,NULL,'15.13',0.8,'SAc',NULL,NULL,NULL,NULL,1,31.9830417,43.58878,0.389,NULL,67828097319,1059814020,16559594,15.13),(21678,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21678,36,0.58,158,5596,70,NULL,NULL,'2MASX J02075654-0727306',NULL,'2014MNRAS.445.2677S',2014,1,0.86,NULL,'G',0.00015,NULL,'15.98',0.4,NULL,NULL,NULL,NULL,NULL,1,31.985583,-7.45853,0.008,NULL,35163696992,549432765,8584886,15.98),(21679,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21679,37.12,0.53,265,5597,70,NULL,NULL,'2MASX J02075688-0552116',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.56',0.37,NULL,NULL,NULL,NULL,NULL,1,31.986917,-5.87,0.008,NULL,35136761161,549011893,8578310,16.56),(21680,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21680,33.99,0.2,62.8,5598,74.4,NULL,NULL,'UGC 01625',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.00043,NULL,'16.5',0.2,'Sbc',NULL,NULL,NULL,NULL,1,32.0164583,28.33214,0.193,NULL,68597963396,1071843178,16747549,16.5),(21681,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 19485','RN',21681,39.19,0.66,592,5599,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 19485',0.163937,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21682,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 19485','RN',21682,41.24,0.7,1520,5599,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19485',0.163937,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21683,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21683,34.37,0.4,75,5600,NULL,NULL,'mean','ESO 414- G 032',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000027,NULL,'14.35',0.5,'SB:(r)a',NULL,NULL,NULL,NULL,1,32.0312916667,-28.63658,0,NULL,38391631198,599869237,9372956,14.35),(21684,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21684,34.41,0.47,76.4,5600,NULL,NULL,'H','ESO 414- G 032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21685,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21685,34.48,0.45,78.8,5600,NULL,NULL,'K','ESO 414- G 032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21686,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21686,34.51,0.46,79.8,5600,NULL,NULL,'J','ESO 414- G 032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21687,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 14941','RN',21687,39.19,0.19,637,5601,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 14941',0.083991,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21688,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 14941','RN',21688,40.2,0.22,1010,5601,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 14941',0.083991,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21689,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21689,38.44,0.46,487,5602,70,NULL,NULL,'SDSS J020812.35+143213.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000081,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,32.0515416667,14.53719,0.161,NULL,66954517758,1046164339,16346317,18.5),(21690,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21690,35.65,0.46,135,5603,70,NULL,NULL,'CGCG 387-046',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.00009,NULL,'15.1g',0.61,'E','Pair member (points to parent)',NULL,NULL,NULL,1,32.064833,1.19544,0.037,NULL,66995466592,1046804165,16356315,15.1),(21691,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 21648','R',21691,41.56,0.33,1410,5604,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 21648',0.44672,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,'PHOT','23.2g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,32.079083,0.42378,0.041,NULL,66995047839,1046797622,16356212,23.2),(21692,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 21648','R',21692,41.66,0.34,1480,5604,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 21648',0.44672,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21693,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 21648',NULL,21693,41.4,0.09,1910,5604,70,NULL,'SN photometric redshift distance, z photo =0.615 +/- 0.040','SDSS-II SN 21648',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21694,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 14831','RN',21694,42.9,0.44,2480,5605,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14831',0.536047,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21695,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 18789','RN',21695,41.02,0.22,1230,5606,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18789',0.306192,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21696,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 18789','RN',21696,41.41,0.18,1460,5606,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18789',0.306192,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21697,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 18789','N',21697,40.91,0.14,1520,5606,70,NULL,'SALT 2','SDSS-II SN 18789',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21698,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 18789','N',21698,40.94,0.14,1540,5606,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18789',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21699,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21699,35.47,0.6,124,5607,NULL,NULL,'Malmquist cor.','ESO 478- G 005',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.35',0.7,'Sb-c',NULL,NULL,NULL,NULL,1,32.086625,-24.54764,0,NULL,37922925501,592545710,9258526,14.35),(21700,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21700,35.7,0.54,138,5607,NULL,NULL,NULL,'ESO 478- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21701,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21701,35.74,0.2,141,5607,74.4,NULL,NULL,'ESO 478- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21702,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21702,36.26,0.64,179,5608,70,NULL,NULL,'2MASX J02082095-0718292',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'17.25',0.27,NULL,NULL,NULL,NULL,NULL,1,32.087417,-7.30814,0.008,NULL,35163724875,549433201,8584893,17.25),(21703,'PNLF','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21703,31.4,NULL,19,5609,NULL,NULL,'40','NGC 0821',NULL,'2010ApJ...721..369T',2010,1,2.6,NULL,'G',0.000014,NULL,'11.67',1.6,'E6?','Isolated galaxy',NULL,NULL,NULL,1,32.088083,10.99492,0.161,NULL,67083545452,1048180397,16377818,11.67),(21704,'SBF','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21704,31.75,0.17,22.4,5609,NULL,NULL,'I','NGC 0821',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21705,'SBF','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21705,31.83,0.14,23.2,5609,74.4,NULL,NULL,'NGC 0821',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21706,'SBF','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21706,31.91,0.17,24.1,5609,NULL,NULL,'I','NGC 0821',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21707,'SBF','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21707,31.91,0.17,24.1,5609,NULL,NULL,NULL,'NGC 0821',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21708,'SBF','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21708,31.93,0.17,24.3,5609,NULL,NULL,'Malmquist cor.','NGC 0821',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21709,'D-Sigma','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21709,31.99,0.4,25,5609,75,NULL,'Edat, raw','NGC 0821',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21710,'D-Sigma','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21710,32.32,0.4,29.1,5609,75,NULL,'Edat, cor','NGC 0821',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21711,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21711,31.8,0.41,22.9,5609,NULL,NULL,NULL,'NGC 0821',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21712,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21712,31.98,0.41,24.9,5609,NULL,NULL,'Malmquist cor.','NGC 0821',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21713,'Tully est','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21713,31.82,0.8,23.2,5609,75,NULL,'B','NGC 0821',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21714,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21714,31.84,0.4,23.3,5609,NULL,NULL,'mean','NGC 0821',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21715,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21715,32.03,0.45,25.4,5609,NULL,NULL,'K','NGC 0821',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21716,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 08086','RN',21716,40.09,0.28,991,5610,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 08086',0.051919,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21717,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 08086','RN',21717,41.05,0.36,1540,5610,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 08086',0.051919,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21718,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 18181','R',21718,40.09,0.34,789,5611,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 18181',0.321601,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',NULL,'PHOT','20.7g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,32.1005,-0.37372,0.033,NULL,35000962571,546890040,8545156,20.7),(21719,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 18181','R',21719,40.61,0.41,1000,5611,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 18181',0.321601,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21720,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 18181',NULL,21720,40.32,0.39,1160,5611,70,NULL,'SN photometric redshift distance, z photo =0.319 +/- 0.080','SDSS-II SN 18181',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21721,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21721,32.93,0.69,38.5,5612,100,NULL,'mid-IR','NGC 0820',NULL,'2013ApJ...771...88L',2013,1,1.24,NULL,'G',0.000017,NULL,'13.6g',0.81,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,32.104083,14.34956,0.177,NULL,66954067702,1046157307,16346207,13.6),(21722,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21722,33.54,0.45,51,5612,NULL,NULL,'K','NGC 0820',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21723,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21723,33.54,0.47,51.1,5612,NULL,NULL,'H','NGC 0820',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21724,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21724,33.6,0.46,52.5,5612,NULL,NULL,'J','NGC 0820',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21725,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21725,33.83,0.4,58.3,5612,NULL,NULL,'mean','NGC 0820',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21726,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21726,34.04,0.36,64.1,5612,NULL,NULL,NULL,'NGC 0820',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21727,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21727,34.04,0.43,64.4,5612,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0820',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21728,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21728,34.05,0.43,64.6,5612,75,NULL,'3.6 micron, color corrected','NGC 0820',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21729,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21729,34.06,0.36,65,5612,NULL,NULL,'Malmquist cor.','NGC 0820',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21730,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21730,34.08,0.2,65.5,5612,74.4,NULL,NULL,'NGC 0820',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21731,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21731,37.33,0.46,292,5613,70,NULL,NULL,'2MASX J02082525+1423419',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000068,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,32.10525,14.39492,0.165,NULL,66954063290,1046157238,16346206,18.1),(21732,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 09154','RN',21732,39.81,0.24,859,5614,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 09154',0.066505,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21733,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21733,32.86,0.97,37.3,5615,NULL,NULL,NULL,'IC 0208',NULL,'2009ApJS..182..474S',2009,1,1.8,NULL,'G',0.000097,NULL,'14.2B',1.8,'SAbc','Pair member (points to parent)',NULL,NULL,NULL,1,32.1155833333,6.39492,0.133,NULL,67105737600,1048527150,16383236,14.2),(21734,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21734,32.9,0.2,38,5615,74.4,NULL,NULL,'IC 0208',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21735,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21735,32.91,0.95,38.3,5615,NULL,NULL,'Malmquist cor.','IC 0208',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21736,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21736,36.68,0.77,217,5616,70,NULL,NULL,'2MASX J02082952-0309220',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.89',0.32,NULL,NULL,NULL,NULL,NULL,1,32.123125,-3.15622,0.029,NULL,35147037132,549172455,8580819,16.89),(21737,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21737,36.72,0.33,221,5617,70,NULL,NULL,'2MASX J02083031-0745392',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000096,NULL,'16.0g',0.4,'S0',NULL,NULL,NULL,NULL,1,32.126417,-7.76086,0.014,NULL,35164060319,549438442,8584975,16),(21738,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21738,34.44,0.49,77.3,5618,75,NULL,'IR','CGCG 461-050',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000017,NULL,'15.61',0.2,NULL,NULL,NULL,NULL,NULL,1,32.12875,18.99533,0.313,NULL,68107962365,1064186911,16627920,15.61),(21739,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21739,34.46,0.2,78,5618,74.4,NULL,NULL,'CGCG 461-050',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21740,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21740,34.51,0.51,79.7,5618,NULL,NULL,'Malmquist cor.','CGCG 461-050',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21741,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21741,34.6,0.49,83.2,5618,NULL,NULL,NULL,'CGCG 461-050',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21742,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 04311','R',21742,40.73,0.24,1080,5619,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J020831.37+010111.5',0.2953,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',0.0005,NULL,'20.7g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,32.13075,1.01989,0.033,NULL,66995596374,1046806193,16356346,20.7),(21743,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 04311','R',21743,40.8,0.2,1120,5619,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J020831.37+010111.5',0.2953,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21744,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 04311',NULL,21744,40.6,0.15,1320,5619,70,NULL,'SALT 2','SDSS J020831.37+010111.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21745,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 04311',NULL,21745,40.63,0.15,1340,5619,70,NULL,'SALT 2, Malmquist cor.','SDSS J020831.37+010111.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21746,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21746,33.53,0.4,50.7,5620,NULL,NULL,'mean','NGC 0825',NULL,'2007A&A...465...71T',2007,1,2.2,NULL,'G',0.000017,NULL,'14.06',0.9,'Sa','Pair member, wide',NULL,NULL,NULL,1,32.134833,6.32372,0.113,NULL,67094223507,1048347242,16380425,14.06),(21747,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21747,34.01,0.47,63.3,5620,NULL,NULL,'H','NGC 0825',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21748,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21748,34.04,0.45,64.2,5620,NULL,NULL,'K','NGC 0825',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21749,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21749,34.09,0.46,65.8,5620,NULL,NULL,'J','NGC 0825',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21750,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21750,34.35,0.35,74.2,5620,NULL,NULL,NULL,'NGC 0825',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21751,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21751,34.39,0.34,75.4,5620,NULL,NULL,'Malmquist cor.','NGC 0825',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21752,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21752,34.52,0.2,80.2,5620,74.4,NULL,NULL,'NGC 0825',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21753,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21753,34.67,0.43,85.7,5620,75,NULL,'3.6 micron, color corrected','NGC 0825',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21754,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21754,34.8,0.43,91.2,5620,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0825',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21755,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE p454','R',21755,42.37,NULL,1760,5621,65,NULL,'SALT','ESSENCE p454 HOST',0.695,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,32.1352083333,-3.5595,0.005,NULL,35147194851,549174919,8580858,NULL),(21756,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE p454',NULL,21756,42.75,0.28,2090,5621,65,NULL,'SALT2','ESSENCE p454 HOST',0.695,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21757,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE p454',NULL,21757,42.92,0.41,2260,5621,70,NULL,'SALT','ESSENCE p454 HOST',0.695,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21758,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE p454',NULL,21758,43.09,0.44,2440,5621,65,NULL,'SALT','ESSENCE p454 HOST',0.695,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21759,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE p454',NULL,21759,43.25,0.19,2630,5621,65,NULL,'MLCS2k2','ESSENCE p454 HOST',0.695,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21760,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE p454',NULL,21760,43.53,0.14,3000,5621,65,NULL,'MLCS2k2','ESSENCE p454 HOST',0.695,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21761,'SNIa','2016-12-15 15:13:50','2016-12-16 11:18:53','1','ESSENCE p454',NULL,21761,44.99,2.53,5880,5621,65,NULL,'SALT','ESSENCE p454 HOST',0.695,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21762,'SNIa SDSS','2016-12-15 15:13:50','2016-12-16 11:18:53','1','SDSS-II SN 22169','RN',21762,39.89,0.7,811,5622,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 22169',0.172508,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21763,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21763,34.15,0.69,67.5,5623,100,NULL,'mid-IR','NGC 0819',NULL,'2013ApJ...771...88L',2013,1,0.6,NULL,'G',0.000033,NULL,'14.40',0.4,'S?','Group member',NULL,NULL,NULL,1,32.1432083,29.23403,0.201,NULL,68595825736,1071809777,16747027,14.4),(21764,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21764,34.82,0.4,92.2,5623,NULL,NULL,'mean','NGC 0819',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21765,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21765,34.87,0.47,94.3,5623,NULL,NULL,'H','NGC 0819',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21766,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21766,34.96,0.45,98.4,5623,NULL,NULL,'K','NGC 0819',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21767,'Tully-Fisher','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,NULL,21767,34.98,0.46,98.9,5623,NULL,NULL,'J','NGC 0819',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21768,'FP','2016-12-15 15:13:50','2016-12-16 11:18:53','1',NULL,'R',21768,35.66,0.46,135,5624,70,NULL,NULL,'MCG -02-06-029',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000124,NULL,'14.8g',0.58,'S0^-',NULL,NULL,NULL,NULL,1,32.1492083333,-8.63189,0,NULL,35162889745,549420152,8584689,14.8),(21769,'FP','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,'R',21769,36.24,0.46,177,5625,70,NULL,NULL,'2MASX J02083598+0027302',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000103,NULL,'15.5g',0.44,'E0',NULL,NULL,NULL,NULL,1,32.15,0.45836,0.041,NULL,66995057490,1046797773,16356215,15.5),(21770,'FP','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,'R',21770,37.81,0.46,366,5626,70,NULL,NULL,'2MASX J02083743+1233330',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000078,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,32.1560417,12.55908,0.217,NULL,66951264422,1046113506,16345523,18.2),(21771,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2004hi',NULL,21771,40.87,0.22,1070,5627,74.2,NULL,'SALT 2','ESSENCE J020838.82-050811.7',0.4,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,32.16175,-5.13658,0,NULL,35144976245,549140253,8580316,NULL),(21772,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2004hi','R',21772,41.31,NULL,1310,5627,65,NULL,'SN h359, SALT','ESSENCE J020838.82-050811.7',0.4,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21773,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2004hi',NULL,21773,41.55,0.2,1460,5627,70,NULL,'SN h359, SALT','ESSENCE J020838.82-050811.7',0.4,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21774,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2004hi',NULL,21774,41.65,0.18,1530,5627,65,NULL,'SN h359, SALT2','ESSENCE J020838.82-050811.7',0.4,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21775,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2004hi',NULL,21775,41.66,0.18,1540,5627,65,NULL,'SN h359, SALT','ESSENCE J020838.82-050811.7',0.4,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21776,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2004hi',NULL,21776,41.76,0.22,1610,5627,65,NULL,'SN h359, SALT2','ESSENCE J020838.82-050811.7',0.4,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21777,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2004hi',NULL,21777,41.88,0.18,1700,5627,65,NULL,'SN h359, MLCS2k2','ESSENCE J020838.82-050811.7',0.4,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21778,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2004hi',NULL,21778,41.89,0.26,1700,5627,65,NULL,'SN h359, MLCS2k2','ESSENCE J020838.82-050811.7',0.4,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21779,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2004hi',NULL,21779,41.9,0.25,1710,5627,65,NULL,'SN h359, MLCS17','ESSENCE J020838.82-050811.7',0.4,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21780,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2004hi',NULL,21780,41.92,0.07,1730,5627,65,NULL,'SN h359, SALT','ESSENCE J020838.82-050811.7',0.4,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21781,'FP','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,'R',21781,37.34,0.46,294,5628,70,NULL,NULL,'2MASX J02084234+1309550',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000069,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,32.176417,13.16517,0.221,NULL,66951041167,1046110018,16345469,17.7),(21782,'FP','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,'R',21782,38.13,0.46,423,5629,70,NULL,NULL,'SDSS J020843.78-083458.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000078,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,32.1824583,-8.58294,0,NULL,35162886182,549420096,8584689,18.6),(21783,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 16089','RN',21783,40.11,0.2,992,5630,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 16089',0.06195,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21784,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 16089','RN',21784,41.37,0.27,1770,5630,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 16089',0.06195,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21785,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21785,33.42,0.8,48.3,5631,75,NULL,'W91PP, r','NGC 0818',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000013,NULL,'13.20',1.3,'SABc:','in a pair',NULL,NULL,NULL,1,32.1855,38.77719,0.153,NULL,67730469709,1058288589,16535759,13.2),(21786,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21786,32.7,0.69,34.7,5631,100,NULL,'mid-IR','NGC 0818',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21787,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21787,33.5,0.46,50.2,5631,NULL,NULL,'J','NGC 0818',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21788,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21788,33.54,0.38,51.1,5631,75,NULL,'W91PP, r, raw','NGC 0818',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21789,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21789,33.59,0.45,52.3,5631,NULL,NULL,'K','NGC 0818',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21790,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21790,33.64,0.47,53.4,5631,NULL,NULL,'H','NGC 0818',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21791,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21791,33.72,0.4,55.3,5631,NULL,NULL,'mean','NGC 0818',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21792,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21792,33.77,0.38,56.8,5631,75,NULL,'W91PP, r, inv','NGC 0818',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21793,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21793,33.79,0.43,57.3,5631,75,NULL,'3.6 micron, color corrected','NGC 0818',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21794,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21794,33.8,0.07,57.7,5631,NULL,NULL,NULL,'NGC 0818',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21795,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21795,33.82,0.2,58.1,5631,74.4,NULL,NULL,'NGC 0818',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21796,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21796,33.85,0.38,58.9,5631,75,NULL,'W91PP, r, cor','NGC 0818',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21797,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21797,33.88,0.43,59.7,5631,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0818',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21798,'GRB','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,'R',21798,44.51,0.23,4050,5632,NULL,NULL,NULL,'GRB 091018',0.971,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,32.1857083,-57.54817,0,NULL,36170893974,565170218,8830784,NULL),(21799,'FP','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,'R',21799,36.6,0.46,209,5633,70,NULL,NULL,'2MASX J02084531+0034292',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000074,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,32.188875,0.57489,0.041,NULL,66995038411,1046797475,16356210,17.5),(21800,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2004hd','R',21800,41.35,NULL,1250,5634,65,NULL,'SN h319, MLCS17','ESSENCE J020848.21-042610.4',0.49,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,32.200875,-4.43622,0,NULL,35147717546,549183086,8580985,NULL),(21801,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2004hd',NULL,21801,41.53,0.23,1360,5634,74.2,NULL,'SALT 2','ESSENCE J020848.21-042610.4',0.49,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21802,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2004hd',NULL,21802,42.2,0.25,1850,5634,70,NULL,'SN h319, SALT','ESSENCE J020848.21-042610.4',0.49,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21803,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2004hd',NULL,21803,42.29,0.18,1930,5634,65,NULL,'SN h319, SALT2','ESSENCE J020848.21-042610.4',0.49,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21804,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2004hd',NULL,21804,42.31,0.2,1940,5634,65,NULL,'SN h319, MLCS17','ESSENCE J020848.21-042610.4',0.49,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21805,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2004hd',NULL,21805,42.35,0.18,1980,5634,65,NULL,'SN h319, MLCS2k2','ESSENCE J020848.21-042610.4',0.49,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21806,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2004hd',NULL,21806,42.35,0.23,1980,5634,65,NULL,'SN h319, SALT','ESSENCE J020848.21-042610.4',0.49,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21807,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2004hd',NULL,21807,42.37,0.2,2000,5634,65,NULL,'SN h319, MLCS31','ESSENCE J020848.21-042610.4',0.49,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21808,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2004hd',NULL,21808,42.4,0.18,2020,5634,65,NULL,'SN h319, MLCS2k2','ESSENCE J020848.21-042610.4',0.49,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21809,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2004hd',NULL,21809,42.4,0.22,2030,5634,65,NULL,'SN h319, SALT2','ESSENCE J020848.21-042610.4',0.49,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21810,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2004hd',NULL,21810,42.54,0.09,2160,5634,65,NULL,'SN h319, SALT','ESSENCE J020848.21-042610.4',0.49,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21811,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 08942','RN',21811,41.35,0.65,1580,5635,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 08942',0.175625,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21812,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 08942','RN',21812,41.83,0.71,1980,5635,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08942',0.175625,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21813,'FP','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21813,36.49,0.58,198,5636,70,NULL,NULL,'2MASX J02085130-1518078',NULL,'2014MNRAS.445.2677S',2014,1,0.81,NULL,'G',0.00015,NULL,'16.51',0.24,NULL,NULL,NULL,NULL,NULL,1,32.2137083,-15.30225,0,NULL,35058674233,547791784,8559246,16.51),(21814,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 14390','RN',21814,43.9,0.19,4440,5637,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 14390',0.355996,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21815,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 14390','RN',21815,44.2,0.28,5110,5637,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 14390',0.355996,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21816,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 18182',NULL,21816,41.23,0.17,1770,5638,70,NULL,'SN photometric redshift distance, z photo =0.550 +/- 0.064','SDSS-II SN 18182',NULL,'2011ApJ...738..162S',2011,1,0.03,NULL,'G',NULL,'PHOT','22.7g',0.02,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,32.2162917,-0.32108,0.033,NULL,35000964855,546890075,8545157,22.7),(21817,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21817,34.6,0.8,83,5639,75,NULL,'MAT, I','NGC 0852',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000025,NULL,'14.15',1,'(R\')SAB(rs)bc',NULL,NULL,NULL,NULL,1,32.231083,-56.73706,0.017,NULL,36168306388,565129787,8830152,14.15),(21818,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21818,34.24,0.43,70.6,5639,75,NULL,'MAT, I, raw','NGC 0852',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21819,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21819,34.48,0.43,78.7,5639,75,NULL,'MAT, I, inv','NGC 0852',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21820,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21820,34.56,0.43,81.6,5639,75,NULL,'MAT, I, cor','NGC 0852',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21821,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21821,34.8,0.4,91.1,5639,NULL,NULL,'mean','NGC 0852',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21822,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21822,34.93,0.32,96.8,5639,85,NULL,'I, raw','NGC 0852',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21823,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21823,34.95,0.47,97.9,5639,NULL,NULL,'H','NGC 0852',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21824,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21824,35,0.32,100,5639,85,NULL,'I, inv','NGC 0852',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21825,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21825,35.1,0.46,105,5639,NULL,NULL,'J','NGC 0852',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21826,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21826,33.32,0.45,46.2,5640,NULL,NULL,'K','NGC 0827',NULL,'2007A&A...465...71T',2007,1,2.2,NULL,'G',0.000017,NULL,'13.70',0.8,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,32.234417,7.97147,0.177,NULL,67107332806,1048552075,16383626,13.7),(21827,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21827,33.33,0.47,46.3,5640,NULL,NULL,'H','NGC 0827',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21828,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21828,33.42,0.46,48.4,5640,NULL,NULL,'J','NGC 0827',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21829,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21829,33.5,0.4,50.1,5640,NULL,NULL,'mean','NGC 0827',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21830,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21830,33.55,0.2,51.3,5640,74.4,NULL,NULL,'NGC 0827',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21831,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21831,33.59,0.43,52.2,5640,NULL,NULL,NULL,'NGC 0827',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21832,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21832,33.67,0.41,54.3,5640,NULL,NULL,'Malmquist cor.','NGC 0827',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21833,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21833,33.97,0.8,62.2,5641,75,NULL,'W91PP, r','UGC 01638',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000005,NULL,'15.22',0.5,'Scd:','Isolated galaxy',NULL,NULL,NULL,1,32.237,26.03572,0.165,NULL,68592303209,1071754737,16746167,15.22),(21834,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21834,34.43,0.38,76.9,5641,75,NULL,'W91PP, r, raw','UGC 01638',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21835,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21835,34.44,0.38,77.3,5641,75,NULL,'W91PP, r, inv','UGC 01638',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21836,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21836,34.48,0.38,78.8,5641,75,NULL,'W91PP, r, cor','UGC 01638',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21837,'FP','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,'R',21837,36.37,0.46,188,5642,70,NULL,NULL,'2MASX J02085763+0003298',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000071,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,32.24025,0.05822,0.045,NULL,66993798999,1046778109,16355907,17.6),(21838,'FP','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,'R',21838,33.3,0.46,45.8,5643,70,NULL,NULL,'NGC 0830',NULL,'2015arXiv151105856S',2015,1,1.31,NULL,'G',0.000063,NULL,'13.6g',0.83,'SB0-?','in a pair',NULL,NULL,NULL,1,32.2445,-7.76681,0,NULL,35162165784,549408840,8584513,13.6),(21839,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21839,33.78,0.4,56.9,5644,NULL,NULL,'mean','IC 0209',NULL,'2007A&A...465...71T',2007,1,1.7,'HOLM 056B is a star.','G',0.000053,NULL,'14.11',1.3,'SB(r)bc:',NULL,NULL,NULL,NULL,1,32.244625,-7.05892,0.01,NULL,35163574421,549430850,8584857,14.11),(21840,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21840,33.98,0.46,62.5,5644,NULL,NULL,'J','IC 0209',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21841,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21841,33.99,0.45,62.9,5644,NULL,NULL,'K','IC 0209',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21842,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21842,34.02,0.47,63.7,5644,NULL,NULL,'H','IC 0209',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21843,'FP','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,'R',21843,37.55,0.23,323,5645,70,NULL,NULL,'2MASXi J0208596+122343',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000113,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,32.248625,12.39539,0.217,NULL,66951140870,1046111576,16345493,17.9),(21844,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21844,33.92,0.2,60.8,5646,74.4,NULL,NULL,'UGC 01647',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',NULL,NULL,'16.0',0.4,'SB:c',NULL,NULL,NULL,NULL,1,32.26,6.15917,0.109,NULL,67094210646,1048347041,16380422,16),(21845,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21845,34.24,0.49,70.4,5646,NULL,NULL,NULL,'UGC 01647',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21846,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21846,34.39,0.45,75.6,5646,NULL,NULL,'Malmquist cor.','UGC 01647',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21847,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,'R',21847,33.17,0.49,43,5647,75,NULL,'IR','UGC 01646',NULL,'2011yCatp016004901K',2011,1,1.9,NULL,'G',0.000013,NULL,'14.61',0.5,'SBbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,32.269125,5.113,0.113,NULL,67072156298,1048002442,16375038,14.61),(21848,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 08730','RN',21848,42.79,0.43,2460,5648,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 08730',0.470738,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21849,'FP','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21849,36.41,0.54,191,5649,70,NULL,NULL,'2MASX J02090776-0720351',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'16.73',0.48,NULL,NULL,NULL,NULL,NULL,1,32.2822917,-7.34314,0.01,NULL,35163501743,549429714,8584839,16.73),(21850,'FP','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,'R',21850,37.55,0.23,323,5650,70,NULL,NULL,'2MASX J02090930+1225479',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000099,NULL,'17.7g',0.17,'NLAGN',NULL,NULL,NULL,NULL,1,32.2887917,12.43006,0.205,NULL,66951147969,1046111687,16345495,17.7),(21851,'FP','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,'R',21851,37.55,0.23,323,5651,70,NULL,NULL,'2MASX J02090937+1223239',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000074,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,32.2890833333,12.39003,0.205,NULL,66951170056,1046112032,16345500,17.7),(21852,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21852,34.65,NULL,85.1,5652,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01642',NULL,'2010Ap&SS.325..163P',2010,1,1.43,NULL,'G',0.000033,NULL,'16.31',0.17,'Sdm',NULL,NULL,NULL,NULL,1,32.29775,37.21161,0.113,NULL,67732137871,1058314654,16536166,16.31),(21853,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21853,34.66,NULL,85.5,5652,NULL,NULL,'Dipole + Quadrupole','UGC 01642',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21854,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21854,34.67,NULL,85.7,5652,NULL,NULL,'Dipole','UGC 01642',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21855,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 15064','RN',21855,44.57,0.41,5320,5653,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 15064',0.539647,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21856,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 15325','R',21856,40.1,0.2,863,5654,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J020911.60-004432.1',0.2144,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',0.0005,NULL,'20.1g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,32.298333,-0.74225,0.033,NULL,35001127133,546892611,8545197,20.1),(21857,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 15325','R',21857,40.18,0.12,894,5654,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J020911.60-004432.1',0.2144,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21858,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 15325',NULL,21858,39.99,0.09,995,5654,70,NULL,'SALT 2','SDSS J020911.60-004432.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21859,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 15325',NULL,21859,40,0.09,1000,5654,70,NULL,'SALT 2, Malmquist cor.','SDSS J020911.60-004432.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21860,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21860,34.16,0.4,67.8,5655,NULL,NULL,'mean','UGC 01648',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000027,NULL,'14.51',0.5,'S0?','Isolated galaxy',NULL,NULL,NULL,1,32.309167,25.57078,0.201,NULL,68592369256,1071755769,16746183,14.51),(21861,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21861,34.6,0.47,83.3,5655,NULL,NULL,'H','UGC 01648',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21862,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21862,34.64,0.45,84.7,5655,NULL,NULL,'K','UGC 01648',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21863,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21863,34.67,0.46,85.9,5655,NULL,NULL,'J','UGC 01648',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21864,'FP','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,'R',21864,37.09,0.46,262,5656,70,NULL,NULL,'2MASX J02091504+1212070',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000079,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,32.312833,12.20194,0.241,NULL,67082019291,1048156551,16377446,18.7),(21865,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2003kn',NULL,21865,39.53,0.21,647,5657,74.2,NULL,'SALT 2','ESSENCE J020915.55-033541.4',0.244,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,32.3147917,-3.59483,0.005,NULL,35146879906,549169998,8580781,NULL),(21866,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2003kn',NULL,21866,40.34,0.18,941,5657,65,NULL,'SN e132, SALT2','ESSENCE J020915.55-033541.4',0.244,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21867,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2003kn',NULL,21867,40.35,0.28,943,5657,65,NULL,'SN e132, MLCS31','ESSENCE J020915.55-033541.4',0.244,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21868,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2003kn','R',21868,40.37,NULL,953,5657,65,NULL,'SN e132, MLCS31','ESSENCE J020915.55-033541.4',0.244,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21869,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2003kn',NULL,21869,40.42,0.28,977,5657,65,NULL,'SN e132, MLCS2k2','ESSENCE J020915.55-033541.4',0.244,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21870,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2003kn',NULL,21870,40.44,0.23,982,5657,65,NULL,'SN e132, SALT2','ESSENCE J020915.55-033541.4',0.244,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21871,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2003kn',NULL,21871,40.47,0.27,998,5657,65,NULL,'SN e132, MLCS17','ESSENCE J020915.55-033541.4',0.244,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21872,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2003kn',NULL,21872,40.47,0.19,998,5657,70,NULL,'SN e132, SALT','ESSENCE J020915.55-033541.4',0.244,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21873,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2003kn',NULL,21873,40.53,0.16,1030,5657,65,NULL,'SN e132, MLCS2k2','ESSENCE J020915.55-033541.4',0.244,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21874,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2003kn',NULL,21874,40.57,0.17,1050,5657,65,NULL,'SN e132, SALT','ESSENCE J020915.55-033541.4',0.244,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21875,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2003kn',NULL,21875,40.86,0.05,1190,5657,65,NULL,'SN e132, SALT','ESSENCE J020915.55-033541.4',0.244,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21876,'FP','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,'R',21876,35.62,0.46,133,5658,70,NULL,NULL,'2MASX J02091711+0046049',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.48',0.32,NULL,NULL,NULL,NULL,NULL,1,32.321333,0.76792,0.041,NULL,66995364752,1046802574,16356290,16.48),(21877,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2009le',NULL,21877,34.27,0.06,70.2,5659,70,NULL,'SiFTO+SALT2, SN 2009le','ESO 478- G 006',0.017786,'2012MNRAS.426.2359M',2012,1,1.8,'The 2MASS position is 13 arcsec east of the nucleus.','G',0.00003,NULL,'13.21',1,'Sbc            HII','Pair member (points to parent)',NULL,NULL,NULL,1,32.325333,-23.41508,0,NULL,37923376093,592552751,9258636,13.21),(21878,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2009le',NULL,21878,34.28,0.22,70.5,5659,73.8,NULL,'SALT 2 (SNANA)','ESO 478- G 006',0.0171,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21879,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21879,34.19,0.8,68.9,5659,75,NULL,'MAT, I','ESO 478- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21880,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21880,33.59,0.69,52.1,5659,100,NULL,'mid-IR','ESO 478- G 006',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21881,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21881,33.78,0.43,57.1,5659,75,NULL,'MAT, I, raw','ESO 478- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21882,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21882,33.86,0.32,59.1,5659,85,NULL,'I, raw','ESO 478- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21883,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21883,33.86,0.45,59.3,5659,NULL,NULL,'K','ESO 478- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21884,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21884,33.89,0.47,59.9,5659,NULL,NULL,'H','ESO 478- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21885,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21885,33.91,0.46,60.4,5659,NULL,NULL,'J','ESO 478- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21886,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21886,33.92,0.32,60.9,5659,85,NULL,'I, inv','ESO 478- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21887,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21887,34.03,0.43,64.1,5659,75,NULL,'MAT, I, cor','ESO 478- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21888,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21888,34.06,0.43,64.8,5659,75,NULL,'MAT, I, inv','ESO 478- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21889,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,'R',21889,34.1,NULL,66.1,5659,NULL,NULL,'I','ESO 478- G 006',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21890,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21890,34.21,0.39,69.4,5659,NULL,NULL,'Malmquist cor.','ESO 478- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21891,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21891,34.24,0.4,70.4,5659,NULL,NULL,'mean','ESO 478- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21892,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21892,34.33,0.2,73.5,5659,74.4,NULL,NULL,'ESO 478- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21893,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21893,34.38,0.36,75.2,5659,NULL,NULL,NULL,'ESO 478- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21894,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,'R',21894,34.41,NULL,76.2,5659,NULL,NULL,'B','ESO 478- G 006',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21895,'Ring Diameter','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21895,32.7,0.84,34,5660,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 0835',NULL,'1981ApJS...45..541P',1981,1,1.3,NULL,'G',0.000033,NULL,'13.14',1,'SAB(r)ab: pec  LINER','in an interacting pair',NULL,NULL,'Sy 2',1,32.3525,-10.13592,0,NULL,35126242376,548847537,8575742,13.14),(21896,'FP','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,'R',21896,37.55,0.23,323,5661,70,NULL,NULL,'2MASX J02092582+1221209',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000099,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,32.357667,12.35578,0.205,NULL,66951179717,1046112183,16345502,17.7),(21897,'L(H{beta})-{sigma}','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21897,46.11,NULL,1598,5662,74.3,NULL,NULL,'WISP 096_0158',2.234,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,32.359875,-4.72472,0,NULL,35144864325,549138505,8580289,NULL),(21898,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21898,33.71,NULL,55.3,5663,NULL,NULL,NULL,'UGC 01650',NULL,'2000BSAO...50....5K',2000,1,2.13,NULL,'G',0.000017,NULL,'16.08',0.11,'Sd','X-ray-faint group member',NULL,NULL,NULL,1,32.36025,37.25825,0.113,NULL,68620486271,1072195097,16753048,16.08),(21899,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21899,33.78,NULL,57,5663,NULL,NULL,'Dipole','UGC 01650',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21900,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21900,33.79,NULL,57.3,5663,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01650',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21901,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21901,33.8,NULL,57.4,5663,NULL,NULL,'Dipole + Quadrupole','UGC 01650',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21902,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21902,34.41,0.43,76.3,5663,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01650',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21903,'FP','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,'R',21903,36.2,0.46,174,5664,70,NULL,NULL,'2MASX J02092664+1216279',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000088,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,32.361083,12.27436,0.205,NULL,66951129481,1046111398,16345490,18.1),(21904,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21904,31.35,0.43,18.6,5665,75,NULL,'3.6 micron, color + selection bias corrected','IC 0210',NULL,'2014MNRAS.444..527S',2014,1,2.3,'Confused HIPASS source','G',0.000017,NULL,'14.00',0.6,'SBbc?          HII',NULL,NULL,NULL,NULL,1,32.3678333333,-9.68033,0,NULL,35125308567,548832946,8575514,14),(21905,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21905,31.62,0.43,21.1,5665,75,NULL,'3.6 micron, color corrected','IC 0210',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21906,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21906,31.92,0.2,24.2,5665,74.4,NULL,NULL,'IC 0210',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21907,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21907,31.93,0.45,24.4,5665,NULL,NULL,'K','IC 0210',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21908,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21908,31.96,0.47,24.6,5665,NULL,NULL,'H','IC 0210',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21909,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21909,32.01,0.46,25.2,5665,NULL,NULL,'J','IC 0210',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21910,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21910,32.03,0.4,25.5,5665,NULL,NULL,'mean','IC 0210',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21911,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21911,32.07,0.4,26,5665,73,NULL,'opt','IC 0210',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21912,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21912,32.12,0.54,26.5,5665,NULL,NULL,NULL,'IC 0210',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21913,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21913,32.15,0.53,26.9,5665,NULL,NULL,'Malmquist cor.','IC 0210',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21914,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21914,32.2,0.4,27.5,5665,73,NULL,'IR','IC 0210',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21915,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21915,32.2,0.4,27.5,5665,73,NULL,'opt','IC 0210',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21916,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,'R',21916,32.2,0.4,27.5,5665,75,NULL,NULL,'IC 0210',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21917,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,'R',21917,32.25,0.49,28.1,5665,75,NULL,'IR','IC 0210',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21918,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 05261','RN',21918,42.9,0.28,2660,5666,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 05261',0.427136,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21919,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 05261','RN',21919,42.93,0.27,2700,5666,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05261',0.427136,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21920,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21920,35.31,0.2,115,5667,74.4,NULL,NULL,'CGCG 461-052',NULL,'2013AJ....146...86T',2013,1,0.55,NULL,'G',0.000033,NULL,'15.7',0.3,NULL,NULL,NULL,NULL,NULL,1,32.3744583,21.60075,0.293,NULL,68061567179,1063461987,16616593,15.7),(21921,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21921,34.05,0.2,64.6,5668,74.4,NULL,NULL,'UGC 01652',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000017,NULL,'14.68',0.6,'Sd',NULL,NULL,NULL,NULL,1,32.38575,21.24708,0.321,NULL,68054609444,1063353272,16614894,14.68),(21922,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 20208','R',21922,38.98,0.12,599,5669,70,NULL,'SDSS CAND. SNIa; MLCS2K2','SN 2007qd',0.043357,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,32.3898333333,-1.00061,0.041,NULL,35000811249,546887675,8545119,NULL),(21923,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 20208','R',21923,39.12,0.21,640,5669,70,NULL,'SDSS CAND. SNIa; SALT 2','SN 2007qd',0.043357,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21924,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2004hs',NULL,21924,40.81,0.3,1040,5670,74.2,NULL,'SALT 2','ESSENCE J020933.69-041304.0',0.4,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,32.390375,-4.21778,0.013,NULL,35147563357,549180677,8580948,NULL),(21925,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2004hs',NULL,21925,41.53,0.34,1450,5670,65,NULL,'SN k485, SALT2','ESSENCE J020933.69-041304.0',0.4,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21926,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2004hs',NULL,21926,41.72,0.32,1570,5670,65,NULL,'SN k485, SALT','ESSENCE J020933.69-041304.0',0.4,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21927,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2004hs',NULL,21927,41.75,0.3,1600,5670,70,NULL,'SN k485, SALT','ESSENCE J020933.69-041304.0',0.4,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21928,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2004hs',NULL,21928,41.85,0.25,1680,5670,65,NULL,'SN k485, MLCS2k2','ESSENCE J020933.69-041304.0',0.4,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21929,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2004hs',NULL,21929,42.16,0.38,1930,5670,65,NULL,'SN k485, MLCS2k2','ESSENCE J020933.69-041304.0',0.4,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21930,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2004hs',NULL,21930,42.42,0.18,2180,5670,65,NULL,'SN k485, SALT','ESSENCE J020933.69-041304.0',0.4,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21931,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2004hs','R',21931,42.93,NULL,2760,5670,65,NULL,'SN k485, SALT','ESSENCE J020933.69-041304.0',0.4,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21932,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21932,35.85,NULL,148,5671,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0250',NULL,'2010Ap&SS.325..163P',2010,1,0.82,NULL,'G',NULL,NULL,'16.79',0.1,'Scd',NULL,NULL,NULL,NULL,1,32.390375,33.67792,0.221,NULL,68626239122,1072284986,16754452,16.79),(21933,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21933,35.87,NULL,149,5671,NULL,NULL,'Dipole + Quadrupole','FGC 0250',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21934,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21934,35.9,NULL,151,5671,NULL,NULL,'Dipole','FGC 0250',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21935,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21935,36.06,0.43,163,5671,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0250',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21936,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,'R',21936,36.08,0.49,164,5671,75,NULL,'IR','FGC 0250',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21937,'FP','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,'R',21937,35.95,0.46,155,5672,70,NULL,NULL,'2MASX J02093611+0105277',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000083,NULL,'16.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,32.400417,1.09111,0.033,NULL,66995248650,1046800760,16356261,16.5),(21938,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 08087','RN',21938,42.55,0.29,2460,5673,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 08087',0.317036,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21939,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2003kv',NULL,21939,43.46,0.27,2730,5674,65,NULL,'MLCS','ESSENCE e531 HOST',0.8,'2005AJ....130.2453K',2005,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,32.4271666667,-3.78017,0,NULL,35147299061,549176547,8580883,NULL),(21940,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2003kv',NULL,21940,43.54,0.2,2840,5674,65,NULL,'m15(B)','ESSENCE e531 HOST',0.8,'2005AJ....130.2453K',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21941,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2003kv',NULL,21941,44.12,0.21,3700,5674,65,NULL,'BATM','ESSENCE e531 HOST',0.8,'2005AJ....130.2453K',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21942,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21942,34.2,0.2,69.2,5675,74.4,NULL,NULL,'AGC 121507',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',NULL,NULL,'14.5I',0.2,NULL,NULL,NULL,NULL,NULL,1,32.429167,10.67722,0.169,NULL,67080917146,1048139330,16377177,14.5),(21943,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21943,34.29,0.48,72,5675,NULL,NULL,NULL,'AGC 121507',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21944,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21944,34.36,0.46,74.3,5675,NULL,NULL,'Malmquist cor.','AGC 121507',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21945,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 18146','R',21945,41.73,0.3,1550,5676,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18146',0.429563,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,32.4292917,-0.00044,0.045,NULL,34997536769,546836512,8544320,NULL),(21946,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 18146','R',21946,41.76,0.3,1570,5676,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18146',0.429563,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21947,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 18146',NULL,21947,41.42,0.09,1920,5676,70,NULL,'SN photometric redshift distance, z photo =0.622 +/- 0.041','SDSS-II SN 18146',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21948,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 18146',NULL,21948,41.68,0.21,2170,5676,70,NULL,'SALT 2','SDSS-II SN 18146',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21949,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 18146',NULL,21949,41.76,0.21,2250,5676,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18146',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21950,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 16431',NULL,21950,40.05,0.49,1020,5677,70,NULL,'SN photometric redshift distance, z photo =0.276 +/- 0.086','SDSS-II SN 16431',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,32.431917,0.48825,0.041,NULL,66992104638,1046751634,16355494,NULL),(21951,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 04619','RN',21951,41.69,0.3,1840,5678,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 04619',0.179835,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21952,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 04619','RN',21952,42.59,0.3,2790,5678,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 04619',0.179835,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21953,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 13372','RN',21953,41.88,0.2,1980,5679,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13372',0.201691,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21954,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 13372','RN',21954,42.47,0.21,2590,5679,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13372',0.201691,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21955,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','ESSENCE g133',NULL,21955,41.41,0.33,1350,5680,74.2,NULL,'SALT 2','ESSENCE g133 HOST',0.421,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,32.4567917,-4.18197,0.013,NULL,35148040502,549188132,8581064,NULL),(21956,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','ESSENCE g133','R',21956,41.85,NULL,1650,5680,65,NULL,'SALT','ESSENCE g133 HOST',0.421,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21957,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','ESSENCE g133',NULL,21957,41.97,0.23,1740,5680,70,NULL,'SALT','ESSENCE g133 HOST',0.421,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21958,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','ESSENCE g133',NULL,21958,42.04,0.21,1800,5680,65,NULL,'SALT','ESSENCE g133 HOST',0.421,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21959,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','ESSENCE g133',NULL,21959,42.22,0.31,1950,5680,65,NULL,'MLCS2k2','ESSENCE g133 HOST',0.421,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21960,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','ESSENCE g133',NULL,21960,42.47,0.09,2190,5680,65,NULL,'SALT','ESSENCE g133 HOST',0.421,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21961,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2005jp',NULL,21961,39.26,0.12,588,5681,74.2,NULL,'SALT 2','SDSS J020950.32-000342.0',0.21,'2010ApJ...716..712A',2010,1,0.08,NULL,'G',0.0005,NULL,'20.3g',0.07,NULL,NULL,NULL,NULL,NULL,1,32.4597083333,-0.06169,0.045,NULL,34997545948,546836655,8544322,20.3),(21962,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2005jp',NULL,21962,39.36,0.09,744,5681,70,NULL,'Hubble residual -0.20 for z0.21240','SDSS J020950.32-000342.0',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21963,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2005jp',NULL,21963,39.93,0.13,801,5681,70,NULL,'SALT 2','SDSS J020950.32-000342.0',0.21,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21964,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2005jp',NULL,21964,39.97,NULL,814,5681,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 07847, SN 2005jp','SDSS J020950.32-000342.0',0.21,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21965,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2005jp',NULL,21965,39.97,0.09,815,5681,65,NULL,'SALT2','SDSS J020950.32-000342.0',0.21,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21966,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 07847','R',21966,39.98,0.19,818,5681,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005jp','SDSS J020950.32-000342.0',0.2124,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21967,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2005jp',NULL,21967,40.02,0.1,832,5681,65,NULL,'MLCS2k2','SDSS J020950.32-000342.0',0.21,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21968,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 07847','R',21968,40.07,0.12,851,5681,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005jp','SDSS J020950.32-000342.0',0.2124,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21969,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2005jp',NULL,21969,39.82,0.08,920,5681,70,NULL,'SALT 2','SDSS J020950.32-000342.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21970,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2005jp',NULL,21970,39.84,0.08,929,5681,70,NULL,'SALT 2, Malmquist cor.','SDSS J020950.32-000342.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21971,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2005jp',NULL,21971,40.9,0.03,1250,5681,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 07847, SN 2005jp','SDSS J020950.32-000342.0',0.21,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21972,'FP','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21972,33,0.48,39.7,5682,70,NULL,NULL,'NGC 0842',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000103,NULL,'14.13',0.9,'SB?(r:)0^0^','in a pair',NULL,NULL,NULL,1,32.461625,-7.76247,0,NULL,35150949476,549233585,8581774,14.13),(21973,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SN 2000ea',NULL,21973,40.79,0.32,1010,5683,65,NULL,NULL,'H-ZSNS J020954.02-052817.8',0.42,'2004ApJ...607..665R',2004,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,32.4750833333,-5.47161,0.009,NULL,35144192260,549128004,8580125,NULL),(21974,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21974,34.07,0.2,65.2,5684,74.4,NULL,NULL,'UGC 01658',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.00012,NULL,'15.4',0.4,'S',NULL,NULL,NULL,NULL,1,32.4749166667,10.96108,0.233,NULL,67082907705,1048170432,16377663,15.4),(21975,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21975,34.1,0.47,66.1,5684,NULL,NULL,NULL,'UGC 01658',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21976,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21976,34.21,0.45,69.5,5684,NULL,NULL,'Malmquist cor.','UGC 01658',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21977,'FP','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21977,36.46,0.72,196,5685,70,NULL,NULL,'2MASX J02095534-0659096',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.52',0.33,NULL,NULL,NULL,NULL,NULL,1,32.4805,-6.98592,0,NULL,35149781442,549215335,8581489,16.52),(21978,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21978,34.41,0.2,76.2,5686,74.4,NULL,NULL,'CGCG 522-119',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000123,NULL,'15.6',0.2,NULL,NULL,NULL,NULL,NULL,1,32.4855,38.17839,0.169,NULL,67730193954,1058284280,16535691,15.6),(21979,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21979,34.42,0.11,76.7,5686,NULL,NULL,NULL,'CGCG 522-119',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21980,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,'R',21980,34.65,0.49,85.2,5686,75,NULL,'IR','CGCG 522-119',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21981,'FP','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,'R',21981,37.14,0.46,268,5687,70,NULL,NULL,'2MASX J02095687+1211279',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000077,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,32.4870417,12.19108,0.225,NULL,67081998076,1048156219,16377440,17.8),(21982,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21982,35.09,0.44,104,5688,NULL,NULL,'Malmquist cor.','UGC 01659',NULL,'2009ApJS..182..474S',2009,1,1.6,NULL,'G',0.000033,NULL,'14.55',0.6,'SBcd:',NULL,NULL,NULL,NULL,1,32.487,16.03272,0.181,NULL,66949364385,1046083818,16345059,14.55),(21983,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21983,35.12,0.2,106,5688,74.4,NULL,NULL,'UGC 01659',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21984,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21984,35.13,0.43,106,5688,NULL,NULL,NULL,'UGC 01659',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21985,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 15970','RN',21985,40.04,0.18,922,5689,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15970',0.104225,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21986,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:53','1','SDSS-II SN 15970','RN',21986,40.49,0.26,1130,5689,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15970',0.104225,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21987,'FP','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,'R',21987,37.15,0.46,269,5690,70,NULL,NULL,'2MASX J02095858-0015121',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000095,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,32.494167,-0.25347,0.033,NULL,34997558165,546836846,8544325,16.7),(21988,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21988,33.12,0.8,42.1,5691,75,NULL,'MAT, I','IC 1783',NULL,'1997ApJS..109..333W',1997,1,2,'The APMUKS position is north of the nucleus.','G',0.000033,NULL,'13.12',0.8,'SA(rs)b?       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,32.5255417,-32.93986,NULL,NULL,38415033515,600234898,9378670,13.12),(21989,'Sosies','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21989,32.93,0.07,38.5,5691,NULL,NULL,NULL,'IC 1783',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21990,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21990,33.04,0.46,40.6,5691,NULL,NULL,'J','IC 1783',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21991,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21991,33.09,0.45,41.4,5691,NULL,NULL,'K','IC 1783',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21992,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21992,33.09,0.47,41.5,5691,NULL,NULL,'H','IC 1783',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21993,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21993,33.18,0.4,43.3,5691,NULL,NULL,'mean','IC 1783',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21994,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21994,33.3,0.32,45.7,5691,85,NULL,'I, raw','IC 1783',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21995,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:53','1',NULL,NULL,21995,33.33,0.43,46.3,5691,75,NULL,'MAT, I, raw','IC 1783',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21996,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,21996,33.36,0.32,46.9,5691,85,NULL,'I, inv','IC 1783',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21997,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,21997,33.58,0.43,52.1,5691,75,NULL,'MAT, I, inv','IC 1783',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21998,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,21998,33.64,0.34,53.4,5691,NULL,NULL,NULL,'IC 1783',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21999,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,21999,33.68,0.2,54.5,5691,74.4,NULL,NULL,'IC 1783',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22000,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22000,33.72,0.43,55.4,5691,75,NULL,'MAT, I, cor','IC 1783',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22001,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22001,33.95,0.29,61.7,5691,NULL,NULL,'Malmquist cor.','IC 1783',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22002,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 14405','RN',22002,43.38,0.37,3680,5692,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14405',0.290943,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22003,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 14405','RN',22003,43.71,0.34,4280,5692,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 14405',0.290943,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22004,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22004,36.39,0.46,190,5693,70,NULL,NULL,'2MASX J02100785-0002581',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000078,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,32.5327083,-0.04956,0.045,NULL,34997573175,546837080,8544329,16.3),(22005,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22005,33.7,0.2,55,5694,74.4,NULL,NULL,'UGC 01663',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.00004,NULL,'14.64',0.8,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,32.537083,7.64586,0.153,NULL,67093455781,1048335246,16380238,14.64),(22006,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22006,33.71,0.5,55.3,5694,NULL,NULL,NULL,'UGC 01663',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22007,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22007,33.91,0.46,60.5,5694,NULL,NULL,'Malmquist cor.','UGC 01663',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22008,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22008,34.06,0.45,64.8,5695,NULL,NULL,'K','NGC 0828',NULL,'2007A&A...465...71T',2007,1,2.9,NULL,'G',0.00003,NULL,'13.15',2.2,'Sa: pec;LINER  HII','in a pair',NULL,NULL,NULL,1,32.539875,39.19036,0.153,NULL,67730579980,1058290312,16535786,13.15),(22009,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22009,34.18,0.47,68.5,5695,NULL,NULL,'H','NGC 0828',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22010,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22010,34.3,0.46,72.3,5695,NULL,NULL,'J','NGC 0828',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22011,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22011,34.33,0.4,73.4,5695,NULL,NULL,'mean','NGC 0828',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22012,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22012,32.91,NULL,38.2,5696,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01656',NULL,'2010Ap&SS.325..163P',2010,1,1.2,NULL,'G',0.00002,NULL,'18.',0.1,'Sd',NULL,NULL,NULL,NULL,1,32.5492917,41.56214,0.281,NULL,67816977142,1059640267,16556879,18),(22013,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22013,32.93,NULL,38.5,5696,NULL,NULL,'Dipole','UGC 01656',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22014,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22014,32.93,NULL,38.5,5696,NULL,NULL,'Dipole + Quadrupole','UGC 01656',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22015,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22015,31.39,0.43,18.9,5697,75,NULL,'3.6 micron, color + selection bias corrected','KUG 0207-099',NULL,'2014MNRAS.444..527S',2014,1,2.5,NULL,'G',0.000037,NULL,'13.5',1,'SBc pec?',NULL,NULL,NULL,NULL,1,32.560167,-9.71103,0,NULL,35125453461,548835210,8575550,13.5),(22016,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22016,31.44,0.43,19.4,5697,75,NULL,'3.6 micron, color corrected','KUG 0207-099',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22017,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22017,31.46,0.2,19.6,5697,74.4,NULL,NULL,'KUG 0207-099',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22018,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22018,31.48,0.4,19.8,5697,73,NULL,'opt','KUG 0207-099',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22019,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22019,31.57,0.6,20.6,5697,NULL,NULL,'Malmquist cor.','KUG 0207-099',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22020,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22020,31.71,0.57,21.9,5697,NULL,NULL,NULL,'KUG 0207-099',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22021,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 04803',NULL,22021,40.93,0.33,1530,5698,70,NULL,'SN photometric redshift distance, z photo =0.455 +/- 0.103','SDSS-II SN 04803',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,32.564,0.30203,0.045,NULL,66992171211,1046752675,16355510,NULL),(22022,'Ring Diameter','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22022,33.3,0.84,46,5699,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 0840',NULL,'1981ApJS...45..541P',1981,1,1.8,NULL,'G',0.000017,NULL,'14.27',1,'SB(r)b',NULL,NULL,NULL,NULL,1,32.5675417,7.84531,0.153,NULL,67093615594,1048337743,16380277,14.27),(22023,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22023,34.88,0.8,94.6,5699,75,NULL,'A82, H','NGC 0840',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22024,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22024,34.21,0.33,69.4,5699,91,NULL,'H','NGC 0840',NULL,'1984ApJ...278..475B',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22025,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22025,34.26,0.69,71.1,5699,100,NULL,'mid-IR','NGC 0840',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22026,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22026,34.7,0.42,87.1,5699,NULL,NULL,'Malmquist cor.','NGC 0840',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22027,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22027,34.75,0.41,89,5699,NULL,NULL,NULL,'NGC 0840',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22028,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22028,34.84,0.2,92.9,5699,74.4,NULL,NULL,'NGC 0840',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22029,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22029,34.85,0.47,93.4,5699,75,NULL,'A82, H, raw','NGC 0840',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22030,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22030,34.94,0.47,97.2,5699,NULL,NULL,'H','NGC 0840',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22031,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22031,35.03,0.4,101,5699,NULL,NULL,'mean','NGC 0840',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22032,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22032,35.03,0.45,102,5699,NULL,NULL,'K','NGC 0840',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22033,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22033,35.09,0.46,104,5699,NULL,NULL,'J','NGC 0840',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22034,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22034,35.09,0.47,104,5699,75,NULL,'A82, H, inv','NGC 0840',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22035,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22035,35.25,0.47,112,5699,75,NULL,'A82, H, cor','NGC 0840',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22036,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22036,34.58,0.53,82.6,5700,NULL,NULL,'Malmquist cor.','NGC 0837',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000033,NULL,'14.60',0.4,'Sb?',NULL,NULL,NULL,NULL,1,32.5677083,-22.4315,0,NULL,37929704625,592651634,9260181,14.6),(22037,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22037,34.6,0.52,83.3,5700,NULL,NULL,NULL,'NGC 0837',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22038,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22038,34.64,0.2,84.7,5700,74.4,NULL,NULL,'NGC 0837',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22039,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 18109','R',22039,38.78,0.05,535,5701,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2007kw','2MASX J02101705-0015481',0.068125,'2014arXiv1401.3317S',2014,1,0.42,NULL,'G',0.000079,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,32.570875,-0.26333,0.033,NULL,34997781674,546840338,8544380,16.7),(22040,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 18109','R',22040,39.42,0.19,715,5701,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2007kw','2MASX J02101705-0015481',0.068125,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22041,'SNII optical','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2007kw',NULL,22041,36.81,0.09,215,5701,NULL,NULL,'SCM 55 SNII','2MASX J02101705-0015481',0.068125,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22042,'SNII optical','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2007kw',NULL,22042,37.07,0.11,243,5701,NULL,NULL,'SCM 15 SDSS SNII','2MASX J02101705-0015481',0.068125,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22043,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22043,33.76,0.4,56.5,5702,NULL,NULL,'mean','NGC 0848',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00002,NULL,'13.95',1,'(R\')SB(s)abpec?Sbrst','in a chain',NULL,NULL,'Starburst',1,32.5735,-10.32144,0,NULL,35125922561,548842540,8575664,13.95),(22044,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22044,33.82,0.47,58.1,5702,NULL,NULL,'H','NGC 0848',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22045,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22045,33.83,0.45,58.3,5702,NULL,NULL,'K','NGC 0848',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22046,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22046,33.89,0.46,59.9,5702,NULL,NULL,'J','NGC 0848',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22047,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22047,34.99,0.8,99.3,5703,75,NULL,'CF, r','UGC 01660',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.00006,NULL,'15.20',0.5,'Sd',NULL,NULL,NULL,NULL,1,32.5769166667,38.59353,0.169,NULL,67730344504,1058286632,16535728,15.2),(22048,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22048,34.48,0.4,78.9,5703,NULL,NULL,'Malmquist cor.','UGC 01660',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22049,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22049,34.5,0.2,79.4,5703,74.4,NULL,NULL,'UGC 01660',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22050,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22050,34.51,0.38,79.8,5703,75,NULL,'CF, r, raw','UGC 01660',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22051,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22051,34.56,0.38,81.7,5703,75,NULL,'CF, r, inv','UGC 01660',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22052,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22052,34.56,0.38,81.8,5703,NULL,NULL,NULL,'UGC 01660',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22053,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22053,34.57,0.38,82.1,5703,75,NULL,'CF, r, cor','UGC 01660',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22054,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22054,34.68,NULL,86.2,5704,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0252',NULL,'2010Ap&SS.325..163P',2010,1,0.87,NULL,'G',NULL,NULL,'16.56',0.11,'Scd',NULL,NULL,NULL,NULL,1,32.579583,36.52036,0.197,NULL,68620732182,1072198940,16753108,16.56),(22055,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22055,34.69,NULL,86.8,5704,NULL,NULL,'Dipole + Quadrupole','FGC 0252',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22056,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22056,34.71,NULL,87.5,5704,NULL,NULL,'Dipole','FGC 0252',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22057,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22057,35.03,0.43,101,5704,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0252',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22058,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22058,35.04,0.49,102,5704,75,NULL,'IR','FGC 0252',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22059,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22059,37.73,0.46,351,5705,70,NULL,NULL,'2MASX J02101945-0111021',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000076,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,32.5810417,-1.18389,0.041,NULL,34997830942,546841108,8544392,17.4),(22060,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 11481','RN',22060,36.5,0.1,181,5706,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 11481',0.098142,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22061,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003lh',NULL,22061,41.51,0.24,1340,5707,74.2,NULL,'SALT 2','ESSENCE J021019.51-045932.3',0.5,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,32.5812916667,-4.99231,0,NULL,35144500891,549132826,8580200,NULL),(22062,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003lh','R',22062,41.77,NULL,1510,5707,65,NULL,'SN f011, SALT2','ESSENCE J021019.51-045932.3',0.5,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22063,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003lh',NULL,22063,42.27,0.22,1900,5707,65,NULL,'SN f011, SALT2','ESSENCE J021019.51-045932.3',0.5,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22064,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003lh',NULL,22064,42.36,0.24,1980,5707,70,NULL,'SN f011, SALT','ESSENCE J021019.51-045932.3',0.5,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22065,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003lh',NULL,22065,42.42,0.23,2030,5707,65,NULL,'SN f011, SALT2','ESSENCE J021019.51-045932.3',0.5,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22066,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003lh',NULL,22066,42.47,0.22,2080,5707,65,NULL,'SN f011, MLCS2k2','ESSENCE J021019.51-045932.3',0.5,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22067,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003lh',NULL,22067,42.51,0.19,2120,5707,65,NULL,'SN f011, m15(B)','ESSENCE J021019.51-045932.3',0.5,'2005AJ....130.2453K',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22068,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003lh',NULL,22068,42.53,0.21,2140,5707,65,NULL,'SN f011, SALT','ESSENCE J021019.51-045932.3',0.5,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22069,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003lh',NULL,22069,42.55,0.25,2160,5707,65,NULL,'SN f011, MLCS17','ESSENCE J021019.51-045932.3',0.5,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22070,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003lh',NULL,22070,42.63,0.1,2240,5707,65,NULL,'SN f011, SALT','ESSENCE J021019.51-045932.3',0.5,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22071,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003lh',NULL,22071,42.64,0.24,2250,5707,65,NULL,'SN f011, MLCS31','ESSENCE J021019.51-045932.3',0.5,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22072,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003lh',NULL,22072,42.66,0.22,2270,5707,65,NULL,'SN f011, MLCS2k2','ESSENCE J021019.51-045932.3',0.5,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22073,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003lh',NULL,22073,42.76,0.21,2380,5707,65,NULL,'SN f011, MLCS','ESSENCE J021019.51-045932.3',0.5,'2005AJ....130.2453K',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22074,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003lh',NULL,22074,42.86,0.15,2490,5707,65,NULL,'SN f011, BATM','ESSENCE J021019.51-045932.3',0.5,'2005AJ....130.2453K',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22075,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22075,36.97,0.46,248,5708,70,NULL,NULL,'2MASX J02102105-0053441',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000078,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,32.5876666667,-0.89556,0.045,NULL,34997989646,546843588,8544431,17.1),(22076,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22076,36.9,0.72,240,5709,70,NULL,NULL,'2MASX J02102127-1646050',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'17.44',0.27,NULL,NULL,NULL,NULL,NULL,1,32.5885833333,-16.768,0.024,NULL,35056260443,547754069,8558657,17.44),(22077,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 08944','RN',22077,39.19,0.41,646,5710,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 08944',0.067974,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22078,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 17295','RN',22078,41.02,0.31,1240,5711,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 17295',0.292942,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22079,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 17295','RN',22079,41.21,0.41,1350,5711,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 17295',0.292942,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22080,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22080,34.04,0.2,64.3,5712,74.4,NULL,NULL,'UGC 01665',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',NULL,NULL,'18.',0.9,'Im:',NULL,NULL,NULL,NULL,1,32.593875,1.20117,0.045,NULL,66991717508,1046745586,16355399,18),(22081,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22081,34.46,0.53,77.9,5713,70,NULL,NULL,'NGC 0836',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000117,NULL,'14.43',0.9,'(R\')SA(s)0/a',NULL,NULL,NULL,NULL,1,32.603667,-22.05486,0,NULL,37930086120,592657595,9260274,14.43),(22082,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 04279','RN',22082,41.08,0.11,1400,5714,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04279',0.170764,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22083,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 04279','RN',22083,41.55,0.2,1740,5714,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04279',0.170764,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22084,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 19619','RN',22084,40.89,0.28,1200,5715,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19619',0.259916,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22085,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 19619','RN',22085,40.98,0.27,1250,5715,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19619',0.259916,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22086,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 16978','RN',22086,42.38,0.43,2600,5716,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 16978',0.151558,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22087,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 16978','RN',22087,42.68,0.4,2980,5716,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 16978',0.151558,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22088,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22088,37.12,1,265,5717,70,NULL,NULL,'2MASX J02103685-1419230',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.73',0.31,NULL,NULL,NULL,NULL,NULL,1,32.6534583333,-14.32311,0,NULL,35064364554,547880696,8560635,16.73),(22089,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22089,34.78,0.2,90.4,5718,74.4,NULL,NULL,'UGC 01669',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.0001,NULL,'14.44',0.6,'Sbc','Group member',NULL,NULL,NULL,1,32.65725,5.87006,0.117,NULL,67063952293,1047874254,16373035,14.44),(22090,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22090,31.37,0.8,18.8,5719,75,NULL,'MAT, I','ESO 298- G 015',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000017,NULL,'14.28',0.7,'SB(rs)d',NULL,NULL,NULL,NULL,1,32.662125,-40.91808,NULL,NULL,38319787653,598746682,9355416,14.28),(22091,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22091,31.24,0.32,17.7,5719,85,NULL,'I, inv','ESO 298- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22092,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22092,31.28,0.32,18,5719,85,NULL,'I, raw','ESO 298- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22093,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22093,31.69,0.43,21.7,5719,75,NULL,'MAT, I, inv','ESO 298- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22094,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22094,31.75,0.43,22.3,5719,75,NULL,'MAT, I, raw','ESO 298- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22095,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22095,31.82,0.43,23.1,5719,75,NULL,'MAT, I, cor','ESO 298- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22096,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22096,34.14,0.8,67.4,5720,75,NULL,'MAT, I','ESO 478- G 011',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'16',0.17,'Scd',NULL,NULL,NULL,NULL,1,32.6652916667,-22.65231,0,NULL,37929716071,592651813,9260184,16),(22097,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22097,34.27,0.32,71.3,5720,85,NULL,'I, inv','ESO 478- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22098,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22098,34.27,0.32,71.4,5720,85,NULL,'I, raw','ESO 478- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22099,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22099,34.27,NULL,71.6,5720,NULL,NULL,NULL,'ESO 478- G 011',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22100,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22100,34.36,NULL,74.5,5720,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 478- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22101,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22101,34.37,NULL,75,5720,NULL,NULL,'Dipole + Quadrupole','ESO 478- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22102,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22102,34.38,NULL,75.1,5720,NULL,NULL,'Dipole','ESO 478- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22103,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22103,34.41,0.43,76.1,5720,75,NULL,'MAT, I, raw','ESO 478- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22104,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22104,34.45,0.43,77.8,5720,75,NULL,'MAT, I, inv','ESO 478- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22105,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22105,34.59,0.49,82.7,5720,75,NULL,'IR','ESO 478- G 011',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22106,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22106,34.62,0.43,84.1,5720,75,NULL,'MAT, I, cor','ESO 478- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22107,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22107,34.73,0.2,88.3,5720,74.4,NULL,NULL,'ESO 478- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22108,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22108,34.79,0.51,90.7,5720,NULL,NULL,NULL,'ESO 478- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22109,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22109,34.94,0.48,97.3,5720,NULL,NULL,'Malmquist cor.','ESO 478- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22110,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22110,34.78,0.5,90.5,5721,70,NULL,NULL,'ESO 030- G 009',NULL,'2014MNRAS.445.2677S',2014,1,2.5,NULL,'G',0.000033,NULL,'14.27',0.6,'(R\')SAB(rs)b',NULL,NULL,NULL,NULL,1,32.671625,-75.03769,0.173,NULL,35615694438,556495225,8695237,14.27),(22111,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22111,35.1,0.8,105,5721,75,NULL,'MAT, I','ESO 030- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22112,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22112,34.24,0.2,70.5,5721,NULL,NULL,'B, Hubble-type-TF','ESO 030- G 009',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22113,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22113,34.76,0.43,89.7,5721,75,NULL,'MAT, I, raw','ESO 030- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22114,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22114,34.83,0.32,92.4,5721,85,NULL,'I, raw','ESO 030- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22115,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22115,34.93,0.32,96.7,5721,85,NULL,'I, inv','ESO 030- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22116,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22116,35.06,0.43,103,5721,75,NULL,'MAT, I, cor','ESO 030- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22117,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22117,35.15,0.43,107,5721,75,NULL,'MAT, I, inv','ESO 030- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22118,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22118,35.28,0.27,114,5721,NULL,NULL,'Malmquist cor.','ESO 030- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22119,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22119,35.47,0.25,124,5721,NULL,NULL,NULL,'ESO 030- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22120,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22120,35.51,0.2,126,5721,74.4,NULL,NULL,'ESO 030- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22121,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22121,34.86,0.53,93.9,5722,70,NULL,NULL,'2MASX J02104207-0038182',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.000072,NULL,'15.6g',0.2,'Sa',NULL,NULL,NULL,NULL,1,32.6755417,-0.63839,0.041,NULL,34998124289,546845692,8544463,15.6),(22122,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22122,35.95,0.52,155,5723,70,NULL,NULL,'MCG -01-06-062',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.000103,NULL,'15.5b',0.2,NULL,NULL,NULL,NULL,NULL,1,32.67975,-6.57981,0,NULL,35150362792,549224418,8581631,15.5),(22123,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22123,31.58,0.4,20.7,5724,75,NULL,'B','UGC 01670',NULL,'1988NBGC.C....0000T',1988,1,2.2,NULL,'G',0.000017,NULL,'14.8',2.2,'Sm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,32.684583,6.75833,0.137,NULL,67095001353,1048359396,16380615,14.8),(22124,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22124,36.25,0.55,178,5725,70,NULL,NULL,'2MASX J02104842-0638134',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'17.62',0.24,NULL,NULL,NULL,NULL,NULL,1,32.7018333333,-6.63706,0.017,NULL,35150348719,549224198,8581628,17.62),(22125,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2005lz',NULL,22125,35.64,0.16,129,5726,74.2,NULL,'SALT 2','UGC 01666',0.0402,'2010ApJ...716..712A',2010,1,1.1,NULL,'G',0.00014,NULL,'16.0',1.1,'DISTRBD',NULL,NULL,NULL,NULL,1,32.7025,34.98461,0.277,NULL,68633898082,1072404657,16756322,16),(22126,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2005lz',NULL,22126,36.31,0.02,176,5726,72,NULL,'SALT, z SN CMB','UGC 01666',0.0402,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22127,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2005lz',NULL,22127,36.33,0.16,177,5726,70,NULL,'SALT 2','UGC 01666',0.0402,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22128,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2005lz',NULL,22128,36.24,0.09,177,5726,74.4,NULL,NULL,'UGC 01666',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22129,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2005lz',NULL,22129,36.39,0.15,182,5726,73.8,NULL,'SALT 2 (SNANA)','UGC 01666',0.0407,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22130,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2005lz',NULL,22130,36.43,0.16,186,5726,65,NULL,'SALT, z SN CMB','UGC 01666',0.0402,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22131,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2005lz',NULL,22131,36.52,0.17,194,5726,65,NULL,'MLCS31, z SN CMB','UGC 01666',0.0402,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22132,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2005lz',NULL,22132,36.56,0.16,197,5726,65,NULL,'MLCS17, z SN CMB','UGC 01666',0.0402,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22133,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2005lz',NULL,22133,36.57,0.18,198,5726,65,NULL,'SALT2, z SN CMB','UGC 01666',0.0402,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22134,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2005lz',NULL,22134,37.4,0.04,290,5726,70,NULL,'SALT 2','UGC 01666',0.0402,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22135,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22135,35.74,0.49,140,5727,70,NULL,NULL,'2MASX J02105311-0626264',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.23',0.4,NULL,NULL,NULL,NULL,NULL,1,32.721333,-6.44067,0.025,NULL,35150212472,549222069,8581594,16.23),(22136,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003jy',NULL,22136,40.67,0.22,1020,5728,74.2,NULL,'SALT 2','ESSENCE J021053.98-042549.8',0.339,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,32.7249166667,-4.4305,0.009,NULL,35147937071,549186516,8581039,NULL),(22137,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003jy','R',22137,40.75,NULL,1060,5728,65,NULL,'SN d149, MLCS17','ESSENCE J021053.98-042549.8',0.339,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22138,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003jy',NULL,22138,41.34,0.12,1380,5728,72,NULL,'SN d149','ESSENCE J021053.98-042549.8',0.339,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22139,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003jy',NULL,22139,41.33,0.2,1380,5728,70,NULL,'SN d149, SALT','ESSENCE J021053.98-042549.8',0.339,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22140,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003jy',NULL,22140,41.48,0.16,1480,5728,65,NULL,'SN d149, SALT2','ESSENCE J021053.98-042549.8',0.339,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22141,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003jy',NULL,22141,41.49,0.18,1480,5728,65,NULL,'SN d149, SALT','ESSENCE J021053.98-042549.8',0.339,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22142,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003jy',NULL,22142,41.54,0.22,1520,5728,65,NULL,'SN d149, MLCS17','ESSENCE J021053.98-042549.8',0.339,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22143,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003jy',NULL,22143,41.56,0.2,1530,5728,65,NULL,'SN d149, SALT2','ESSENCE J021053.98-042549.8',0.339,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22144,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003jy',NULL,22144,41.59,0.14,1550,5728,65,NULL,'SN d149, MLCS2k2','ESSENCE J021053.98-042549.8',0.339,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22145,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003jy',NULL,22145,41.59,0.2,1550,5728,65,NULL,'SN d149, MLCS31','ESSENCE J021053.98-042549.8',0.339,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22146,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003jy',NULL,22146,41.63,0.18,1580,5728,65,NULL,'SN d149, MLCS2k2','ESSENCE J021053.98-042549.8',0.339,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22147,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003jy',NULL,22147,41.66,0.05,1610,5728,65,NULL,'SN d149, SALT','ESSENCE J021053.98-042549.8',0.339,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22148,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22148,35.76,0.55,142,5729,70,NULL,NULL,'2MASX J02105432-2231422',NULL,'2014MNRAS.445.2677S',2014,1,0.93,NULL,'G',0.000133,NULL,'15.24',0.72,'E',NULL,NULL,NULL,NULL,1,32.726417,-22.52839,0,NULL,37929718965,592651858,9260185,15.24),(22149,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22149,34.12,0.8,66.8,5730,75,NULL,'MAT, I','ESO 298- G 016',NULL,'1997ApJS..109..333W',1997,1,1.9,'The APMUKS position is 15 arcsec northwest of the galaxy\'s center.','G',0.000033,NULL,'13.40',0.4,'Sa:      poss. LINER','in a pair',NULL,NULL,NULL,1,32.7277083,-39.36586,NULL,NULL,38285778503,598215289,9347113,13.4),(22150,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22150,34.13,0.49,67.1,5730,75,NULL,'IR','ESO 298- G 016',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22151,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22151,34.14,0.43,67.3,5730,75,NULL,'MAT, I, raw','ESO 298- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22152,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22152,34.34,0.43,74,5730,75,NULL,'MAT, I, cor','ESO 298- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22153,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22153,34.36,0.32,74.4,5730,85,NULL,'I, raw','ESO 298- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22154,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22154,34.37,0.28,74.9,5730,NULL,NULL,'Malmquist cor.','ESO 298- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22155,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22155,34.45,0.32,77.6,5730,85,NULL,'I, inv','ESO 298- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22156,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22156,34.49,0.43,79.2,5730,75,NULL,'MAT, I, inv','ESO 298- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22157,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22157,34.56,0.26,81.7,5730,NULL,NULL,NULL,'ESO 298- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22158,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22158,34.6,0.2,83.2,5730,74.4,NULL,NULL,'ESO 298- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22159,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 05263','RN',22159,38.13,0.38,385,5731,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05263',0.099926,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22160,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 05263','RN',22160,39.49,0.33,718,5731,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 05263',0.099926,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22161,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22161,37.91,0.46,382,5732,70,NULL,NULL,'2MASX J02105592-0057111',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000084,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,32.7330417,-0.953,0.041,NULL,34998053363,546844583,8544446,17.8),(22162,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','ESSENCE m057',NULL,22162,40.75,0.32,1200,5733,70,NULL,'SALT','ESSENCE m057 HOST',0.18,'2008ApJ...686..749K',2008,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,32.7365416667,-4.45831,0.009,NULL,35147925553,549186336,8581036,NULL),(22163,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','ESSENCE m057',NULL,22163,41.33,0.2,1560,5733,65,NULL,'MLCS2k2','ESSENCE m057 HOST',0.18,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22164,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','ESSENCE m057',NULL,22164,42.11,0.78,2240,5733,65,NULL,'SALT','ESSENCE m057 HOST',0.18,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22165,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22165,33.47,0.2,49.4,5734,74.4,NULL,NULL,'UGC 01673',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.00012,NULL,'15.22',0.3,'S?','X-ray-faint group member',NULL,NULL,NULL,1,32.749,37.82386,0.153,NULL,68622485997,1072226343,16753536,15.22),(22166,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22166,33.77,0.4,56.8,5734,NULL,NULL,'mean','UGC 01673',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22167,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22167,33.79,0.49,57.2,5734,75,NULL,'IR','UGC 01673',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22168,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22168,33.89,0.1,60.1,5734,NULL,NULL,NULL,'UGC 01673',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22169,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22169,34.96,0.47,98,5734,NULL,NULL,'H','UGC 01673',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22170,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22170,36.04,0.49,161,5735,75,NULL,'IR','KUG 0208+324',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.6',0.1,'Spiral','Pair member (points to parent)',NULL,NULL,NULL,1,32.749583,32.73061,0.273,NULL,68624734664,1072261479,16754085,15.6),(22171,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','ESSENCE p455',NULL,22171,40.12,0.21,814,5736,74.2,NULL,'SALT 2','ESSENCE p455 HOST',0.298,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,32.750083,-4.16044,0.017,NULL,35148235565,549191180,8581112,NULL),(22172,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','ESSENCE p455','R',22172,40.23,NULL,857,5736,65,NULL,'MLCS17','ESSENCE p455 HOST',0.298,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22173,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','ESSENCE p455',NULL,22173,40.79,0.2,1110,5736,70,NULL,'SALT','ESSENCE p455 HOST',0.298,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22174,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','ESSENCE p455',NULL,22174,40.87,0.18,1150,5736,65,NULL,'SALT2','ESSENCE p455 HOST',0.298,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22175,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','ESSENCE p455',NULL,22175,40.92,0.34,1170,5736,65,NULL,'MLCS17','ESSENCE p455 HOST',0.298,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22176,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','ESSENCE p455',NULL,22176,40.97,0.18,1200,5736,65,NULL,'SALT','ESSENCE p455 HOST',0.298,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22177,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','ESSENCE p455',NULL,22177,41.01,0.04,1230,5736,65,NULL,'SALT','ESSENCE p455 HOST',0.298,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22178,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','ESSENCE p455',NULL,22178,41.03,0.21,1240,5736,65,NULL,'SALT2','ESSENCE p455 HOST',0.298,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22179,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','ESSENCE p455',NULL,22179,41.1,0.27,1280,5736,65,NULL,'MLCS2k2','ESSENCE p455 HOST',0.298,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22180,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','ESSENCE p455',NULL,22180,41.12,0.18,1290,5736,65,NULL,'MLCS2k2','ESSENCE p455 HOST',0.298,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22181,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22181,33.61,0.8,52.8,5737,75,NULL,'W91PP, r','NGC 0834',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.00002,NULL,'13.84',0.5,'S?','X-ray-faint group member',NULL,NULL,NULL,1,32.755375,37.66628,0.153,NULL,68620395845,1072193685,16753026,13.84),(22182,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22182,32.82,0.47,36.6,5737,NULL,NULL,'H','NGC 0834',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22183,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22183,32.83,0.69,36.9,5737,100,NULL,'mid-IR','NGC 0834',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22184,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22184,32.92,0.45,38.4,5737,NULL,NULL,'K','NGC 0834',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22185,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22185,33.05,0.46,40.8,5737,NULL,NULL,'J','NGC 0834',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22186,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22186,33.32,0.38,46.1,5737,75,NULL,'W91PP, r, raw','NGC 0834',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22187,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22187,33.42,0.38,48.2,5737,75,NULL,'W91PP, r, inv','NGC 0834',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22188,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22188,33.45,0.2,49,5737,74.4,NULL,NULL,'NGC 0834',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22189,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22189,33.67,0.38,54.2,5737,75,NULL,'W91PP, r, cor','NGC 0834',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22190,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22190,33.94,0.4,61.3,5737,NULL,NULL,'mean','NGC 0834',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22191,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22191,34.03,0.07,64.1,5737,NULL,NULL,NULL,'NGC 0834',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22192,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22192,33.32,0.2,46.1,5738,74.4,NULL,NULL,'CGCG 461-057',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000033,NULL,'15.7',0.2,NULL,NULL,NULL,NULL,NULL,1,32.7613333333,17.19958,0.189,NULL,68074063022,1063657234,16619644,15.7),(22193,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22193,33.67,0.51,54.1,5738,NULL,NULL,NULL,'CGCG 461-057',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22194,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22194,33.7,0.49,54.9,5738,75,NULL,'IR','CGCG 461-057',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22195,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22195,33.9,0.45,60.4,5738,NULL,NULL,'Malmquist cor.','CGCG 461-057',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22196,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22196,32.92,NULL,38.4,5739,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01677',NULL,'2010Ap&SS.325..163P',2010,1,0.9,NULL,'G',0.00002,NULL,'18.',0.08,'Sd',NULL,NULL,NULL,NULL,1,32.7662916667,6.66689,0.137,NULL,67095021106,1048359704,16380620,18),(22197,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22197,32.95,NULL,38.9,5739,NULL,NULL,'Dipole + Quadrupole','UGC 01677',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22198,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22198,32.96,NULL,39.2,5739,NULL,NULL,'Dipole','UGC 01677',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22199,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22199,33.02,NULL,40.3,5739,NULL,NULL,NULL,'UGC 01677',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22200,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003ko',NULL,22200,40.7,0.23,1010,5740,74.2,NULL,'SALT 2','ESSENCE J021106.48-034756.1',0.36,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,32.777,-3.79892,0.021,NULL,35147383852,549177872,8580904,NULL),(22201,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003ko',NULL,22201,41.43,0.22,1420,5740,65,NULL,'SN e136, SALT2','ESSENCE J021106.48-034756.1',0.36,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22202,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003ko',NULL,22202,41.44,0.22,1430,5740,70,NULL,'SN e136, SALT','ESSENCE J021106.48-034756.1',0.36,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22203,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003ko','R',22203,41.5,NULL,1470,5740,65,NULL,'SN e136, SALT','ESSENCE J021106.48-034756.1',0.36,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22204,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003ko',NULL,22204,41.55,0.19,1500,5740,65,NULL,'SN e136, SALT','ESSENCE J021106.48-034756.1',0.36,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22205,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003ko',NULL,22205,41.58,0.27,1520,5740,65,NULL,'SN e136, MLCS31','ESSENCE J021106.48-034756.1',0.36,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22206,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003ko',NULL,22206,41.62,0.25,1550,5740,65,NULL,'SN e136, MLCS2k2','ESSENCE J021106.48-034756.1',0.36,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22207,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003ko',NULL,22207,41.64,0.23,1560,5740,65,NULL,'SN e136, SALT2','ESSENCE J021106.48-034756.1',0.36,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22208,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003ko',NULL,22208,41.63,0.26,1560,5740,65,NULL,'SN e136, MLCS17','ESSENCE J021106.48-034756.1',0.36,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22209,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003ko',NULL,22209,41.68,0.17,1590,5740,65,NULL,'SN e136, MLCS2k2','ESSENCE J021106.48-034756.1',0.36,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22210,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003ko',NULL,22210,41.79,0.06,1670,5740,65,NULL,'SN e136, SALT','ESSENCE J021106.48-034756.1',0.36,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22211,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 01478','RN',22211,40.29,0.27,952,5741,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01478',0.201959,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22212,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 01478','RN',22212,40.36,0.17,984,5741,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01478',0.201959,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22213,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22213,33.89,0.5,59.9,5742,70,NULL,NULL,'CGCG 387-052 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.000081,NULL,'14.4g',0.63,'S0','Pair member (points to parent)',NULL,NULL,NULL,1,32.7845833333,-0.65478,0.045,NULL,34998082139,546845033,8544453,14.4),(22214,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22214,35.7,0.2,138,5743,74.4,NULL,NULL,'FGC 031A',NULL,'2013AJ....146...86T',2013,1,0.67,NULL,'G',NULL,NULL,'16.1I',0.11,NULL,NULL,NULL,NULL,NULL,1,32.793917,37.82219,0.153,NULL,68622485676,1072226338,16753536,16.1),(22215,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22215,35.87,0.53,149,5743,NULL,NULL,NULL,'FGC 031A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22216,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22216,35.88,0.53,150,5743,NULL,NULL,'Malmquist cor.','FGC 031A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22217,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 15009','R',22217,41.14,0.34,1310,5744,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2006kp','SDSS J021111.66+004145.0',0.29,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,32.798583,0.69583,0.025,NULL,66992245747,1046753839,16355528,NULL),(22218,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2006kp',NULL,22218,41.15,0.26,1700,5744,70,NULL,'SALT 2','SDSS J021111.66+004145.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22219,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2006kp',NULL,22219,41.18,0.26,1720,5744,70,NULL,'SALT 2, Malmquist cor.','SDSS J021111.66+004145.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22220,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22220,34.38,0.49,75.2,5745,75,NULL,'IR','UGC 01674',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000093,NULL,'14.90',0.6,'Sd',NULL,NULL,NULL,NULL,1,32.79875,38.75781,0.185,NULL,67730510527,1058289226,16535769,14.9),(22221,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22221,34.68,0.57,86.4,5745,NULL,NULL,'Malmquist cor.','UGC 01674',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22222,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22222,34.93,0.51,96.8,5745,NULL,NULL,NULL,'UGC 01674',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22223,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22223,34.97,0.2,98.6,5745,74.4,NULL,NULL,'UGC 01674',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22224,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003lk',NULL,22224,42.78,0.24,2490,5746,65,NULL,'MLCS17','ESSENCE J021112.82-041352.1',0.442,'2009ApJ...700.1097H',2009,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,32.803417,-4.23114,0.017,NULL,35147941197,549186581,8581040,NULL),(22225,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003lk',NULL,22225,42.83,0.22,2560,5746,65,NULL,'MLCS31','ESSENCE J021112.82-041352.1',0.442,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22226,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2003lk',NULL,22226,43.24,0.35,3080,5746,65,NULL,'SALT2','ESSENCE J021112.82-041352.1',0.442,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22227,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22227,35.06,0.45,103,5747,70,NULL,NULL,'NGC 0850',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000057,NULL,'13.86',1.1,'SAB(s)0+',NULL,NULL,NULL,NULL,1,32.8067083333,-1.48558,0.009,NULL,35131777608,548934025,8577094,13.86),(22228,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22228,34.14,0.8,67.3,5748,75,NULL,'W91PP, r','UGC 01675',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000067,NULL,'15.5',0.3,'SB?',NULL,NULL,NULL,NULL,1,32.8075,25.81083,0.169,NULL,68593526779,1071773855,16746466,15.5),(22229,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22229,33.67,0.49,54.2,5748,75,NULL,'IR','UGC 01675',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22230,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22230,34.12,0.38,66.7,5748,75,NULL,'W91PP, r, raw','UGC 01675',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22231,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22231,34.2,0.38,69.1,5748,75,NULL,'W91PP, r, inv','UGC 01675',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22232,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22232,34.2,0.38,69.3,5748,75,NULL,'W91PP, r, cor','UGC 01675',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22233,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22233,33.61,0.8,52.7,5749,75,NULL,'W91PP, r','NGC 0841',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000023,NULL,'13.42',1,'(R\')SAB(s)ab   LINER','X-ray-faint group member',NULL,NULL,'LINER b',1,32.822333,37.49717,0.153,NULL,68620424319,1072194129,16753033,13.42),(22234,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22234,33.46,0.47,49.1,5749,NULL,NULL,'H','NGC 0841',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22235,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22235,33.48,0.38,49.6,5749,75,NULL,'W91PP, r, raw','NGC 0841',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22236,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22236,33.51,0.45,50.3,5749,NULL,NULL,'K','NGC 0841',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22237,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22237,33.52,0.46,50.6,5749,NULL,NULL,'J','NGC 0841',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22238,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22238,33.68,0.38,54.5,5749,75,NULL,'W91PP, r, inv','NGC 0841',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22239,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22239,33.69,0.2,54.7,5749,74.4,NULL,NULL,'NGC 0841',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22240,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22240,33.7,0.43,54.8,5749,75,NULL,'3.6 micron, color corrected','NGC 0841',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22241,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22241,33.79,0.38,57.3,5749,75,NULL,'W91PP, r, cor','NGC 0841',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22242,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22242,33.8,0.43,57.7,5749,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0841',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22243,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22243,33.9,0.4,60.3,5749,NULL,NULL,'mean','NGC 0841',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22244,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22244,34.1,0.06,66.2,5749,NULL,NULL,NULL,'NGC 0841',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22245,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22245,37.21,0.23,276,5750,70,NULL,NULL,'2MASX J02111803+1255195',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.0001,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,32.82525,12.92208,0.245,NULL,66954865866,1046169779,16346402,17),(22246,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2006na',NULL,22246,40.35,0.21,1170,5751,70,NULL,'Hubble residual 0.11 for z0.30500','SDSS-II SN 15776 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,32.8302917,-0.99811,0.041,NULL,34998034135,546844283,8544441,NULL),(22247,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 15776','R',22247,40.97,0.24,1190,5751,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006na','SDSS-II SN 15776 HOST',0.316961,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22248,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 15776','R',22248,41.36,0.19,1420,5751,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006na','SDSS-II SN 15776 HOST',0.316961,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22249,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2006na',NULL,22249,40.8,0.14,1450,5751,70,NULL,'SALT 2','SDSS-II SN 15776 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22250,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2006na',NULL,22250,40.84,0.14,1470,5751,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15776 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22251,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 15765','R',22251,40.89,0.26,1150,5752,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J021123.51+001446.4',0.3048,'2014arXiv1401.3317S',2014,1,0.11,NULL,'G',0.0001,NULL,'19.9g',0.08,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,32.848,0.24622,0.049,NULL,66992039587,1046750618,16355478,19.9),(22252,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 15765','R',22252,40.93,0.2,1180,5752,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J021123.51+001446.4',0.3048,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22253,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 15765',NULL,22253,40.73,0.16,1400,5752,70,NULL,'SALT 2','SDSS J021123.51+001446.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22254,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 15765',NULL,22254,40.77,0.16,1430,5752,70,NULL,'SALT 2, Malmquist cor.','SDSS J021123.51+001446.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22255,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22255,35.03,0.49,102,5753,75,NULL,'IR','UGC 01683',NULL,'2011yCatp016004901K',2011,1,0.96,NULL,'G',0.000026,NULL,'16.41',0.12,'Scd',NULL,NULL,NULL,NULL,1,32.8553333333,15.89881,0.169,NULL,66948215503,1046065867,16344779,16.41),(22256,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22256,35.31,0.44,116,5753,NULL,NULL,'Malmquist cor.','UGC 01683',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22257,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22257,35.39,0.43,120,5753,NULL,NULL,NULL,'UGC 01683',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22258,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22258,35.43,0.2,122,5753,74.4,NULL,NULL,'UGC 01683',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22259,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22259,35.44,NULL,122,5753,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01683',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22260,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22260,35.45,NULL,123,5753,NULL,NULL,NULL,'UGC 01683',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22261,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22261,35.46,NULL,123,5753,NULL,NULL,'Dipole + Quadrupole','UGC 01683',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22262,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22262,35.47,NULL,124,5753,NULL,NULL,'Dipole','UGC 01683',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22263,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 07067','RN',22263,41.34,0.25,1630,5754,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 07067',0.137359,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22264,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 07067','RN',22264,41.7,0.29,1920,5754,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 07067',0.137359,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22265,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22265,34.7,0.49,87.3,5755,75,NULL,'IR','FGC 0255',NULL,'2011yCatp016004901K',2011,1,1.06,NULL,'G',NULL,NULL,'16.3',0.12,'Scd',NULL,NULL,NULL,NULL,1,32.859917,40.75914,0.225,NULL,67814106027,1059595406,16556178,16.3),(22266,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22266,34.87,NULL,94.4,5755,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0255',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22267,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22267,34.89,NULL,95.1,5755,NULL,NULL,'Dipole + Quadrupole','FGC 0255',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22268,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22268,34.9,NULL,95.4,5755,NULL,NULL,'Dipole','FGC 0255',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22269,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22269,34.94,NULL,97.1,5755,NULL,NULL,NULL,'FGC 0255',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22270,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22270,35.98,0.43,157,5755,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0255',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22271,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22271,37.83,0.46,368,5756,70,NULL,NULL,'2MASX J02112666+1400565',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000079,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,32.861083,14.01569,0.225,NULL,66957704771,1046214137,16347095,17.3),(22272,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22272,37.56,0.46,324,5757,70,NULL,NULL,'SDSS J021126.71-004124.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000075,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,32.8612916667,-0.69019,0.045,NULL,34998290109,546848282,8544504,18.1),(22273,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22273,34.55,0.8,81.4,5758,75,NULL,'MAT, I','NGC 0854',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000023,NULL,'13.54',0.6,'SA:(rs)b:      HII',NULL,NULL,NULL,NULL,1,32.878125,-35.83511,NULL,NULL,38416751035,600261734,9379089,13.54),(22274,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22274,33.98,0.43,62.4,5758,75,NULL,'MAT, I, raw','NGC 0854',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22275,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22275,34.06,0.32,65,5758,85,NULL,'I, raw','NGC 0854',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22276,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22276,34.13,0.32,67,5758,85,NULL,'I, inv','NGC 0854',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22277,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22277,34.19,0.43,68.8,5758,75,NULL,'MAT, I, cor','NGC 0854',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22278,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22278,34.23,0.47,70.1,5758,NULL,NULL,'H','NGC 0854',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22279,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22279,34.24,0.43,70.6,5758,75,NULL,'MAT, I, inv','NGC 0854',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22280,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22280,34.29,0.46,72.1,5758,NULL,NULL,'J','NGC 0854',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22281,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22281,34.38,0.29,75.2,5758,NULL,NULL,'Malmquist cor.','NGC 0854',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22282,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22282,34.39,0.45,75.3,5758,NULL,NULL,'K','NGC 0854',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22283,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22283,34.39,0.2,75.5,5758,74.4,NULL,NULL,'NGC 0854',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22284,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22284,34.41,0.29,76.2,5758,NULL,NULL,NULL,'NGC 0854',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22285,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22285,34.58,0.4,82.4,5758,NULL,NULL,'mean','NGC 0854',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22286,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2000ec',NULL,22286,42.77,0.21,2440,5759,65,NULL,NULL,'H-ZSNS J021132.03-041356.1',0.47,'2004ApJ...607..665R',2004,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,32.8834583333,-4.23225,0.009,NULL,35147950749,549186730,8581042,NULL),(22287,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22287,37.62,0.46,334,5760,70,NULL,NULL,'2MASX J02113210+1316186',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000064,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,32.883667,13.27175,0.237,NULL,66955755172,1046183674,16346619,18.2),(22288,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22288,36.77,0.54,226,5761,70,NULL,NULL,'2MASX J02113239-0301212',NULL,'2014MNRAS.445.2677S',2014,1,0.93,NULL,'G',0.00015,NULL,'16.15',0.49,NULL,NULL,NULL,NULL,NULL,1,32.8849166667,-3.02244,0.009,NULL,35132802032,548950031,8577344,16.15),(22289,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22289,35,0.61,100,5762,70,NULL,NULL,'ESO 030- G 011',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.00008,NULL,'15.31',1.1,'(R\')SA(s)ab?',NULL,NULL,NULL,NULL,1,32.8857917,-73.16183,0.061,NULL,36325017307,567578395,8868412,15.31),(22290,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22290,35.94,0.73,154,5763,70,NULL,NULL,'2MASX J02113326-7334063',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.0b',0.18,NULL,NULL,NULL,NULL,NULL,1,32.8883333333,-73.56844,0.081,NULL,35602506410,556289162,8692018,16),(22291,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22291,36.12,0.69,167,5764,70,NULL,NULL,'2MASX J02113378-7316014',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'16.3b',0.15,NULL,NULL,NULL,NULL,NULL,1,32.8905416667,-73.26703,0.081,NULL,36325001554,567578149,8868408,16.3),(22292,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22292,34.01,0.8,63.5,5765,75,NULL,'W91PP, r','UGC 01682',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.00002,NULL,'14.66',0.5,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,32.894875,31.50986,0.217,NULL,68643328675,1072552010,16758625,14.66),(22293,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22293,33.41,0.2,48.1,5765,74.4,NULL,NULL,'UGC 01682',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22294,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22294,33.6,0.38,52.6,5765,75,NULL,'W91PP, r, inv','UGC 01682',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22295,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22295,33.63,0.38,53.2,5765,75,NULL,'W91PP, r, raw','UGC 01682',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22296,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22296,33.9,0.38,60.1,5765,75,NULL,'W91PP, r, cor','UGC 01682',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22297,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22297,34.18,0.1,68.7,5765,NULL,NULL,NULL,'UGC 01682',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22298,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22298,37.59,0.46,330,5766,70,NULL,NULL,'2MASX J02113735-0810263',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00008,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,32.905625,-8.174,0.01,NULL,35151402760,549240668,8581885,17),(22299,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22299,34.66,0.8,85.5,5767,75,NULL,'W91PP, r','UGC 01685',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000033,NULL,'14.97',0.3,'Sab',NULL,NULL,NULL,NULL,1,32.9105417,34.04428,0.241,NULL,68626212439,1072284569,16754446,14.97),(22300,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22300,34.61,0.47,83.4,5767,NULL,NULL,'H','UGC 01685',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22301,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22301,34.62,0.49,83.9,5767,75,NULL,'IR','UGC 01685',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22302,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22302,34.64,0.4,84.9,5767,NULL,NULL,'mean','UGC 01685',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22303,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22303,34.66,0.45,85.7,5767,NULL,NULL,'K','UGC 01685',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22304,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22304,34.73,0.38,88.4,5767,75,NULL,'W91PP, r, raw','UGC 01685',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22305,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22305,34.76,0.46,89.5,5767,NULL,NULL,'J','UGC 01685',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22306,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22306,34.79,0.43,90.7,5767,75,NULL,'3.6 micron, color corrected','UGC 01685',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22307,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22307,34.8,0.43,91.1,5767,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01685',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22308,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22308,34.86,0.2,93.8,5767,74.4,NULL,NULL,'UGC 01685',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22309,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22309,34.87,0.38,94.3,5767,75,NULL,'W91PP, r, cor','UGC 01685',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22310,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22310,34.92,0.38,96.5,5767,75,NULL,'W91PP, r, inv','UGC 01685',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22311,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22311,34.94,0.33,97.1,5768,70,NULL,NULL,'2MASX J02113910+1408306',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000068,NULL,'16.2g',0.28,'E0',NULL,NULL,NULL,NULL,1,32.9127917,14.14178,0.249,NULL,66957774503,1046215226,16347112,16.2),(22312,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22312,37.71,0.46,348,5769,70,NULL,NULL,'2MASX J02114025-0822353',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'18.07',0.25,NULL,NULL,NULL,NULL,NULL,1,32.91775,-8.37653,0,NULL,35151315296,549239301,8581864,18.07),(22313,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 04690','R',22313,39.59,0.16,690,5770,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 04690',0.199854,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,32.9294583,0.68817,0.029,NULL,66992373660,1046755838,16355559,NULL),(22314,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 04690','R',22314,39.87,0.23,787,5770,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 04690',0.199854,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22315,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22315,34.13,NULL,67.1,5771,NULL,NULL,'Dipole + Quadrupole + Octopole','KUG 0209-067',NULL,'2010Ap&SS.325..163P',2010,1,1.79,NULL,'G',0.00002,NULL,'15.6b',0.21,'Sbc',NULL,NULL,NULL,NULL,1,32.93325,-6.49036,0.025,NULL,35150006460,549218850,8581544,15.6),(22316,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22316,34.13,NULL,67.1,5771,NULL,NULL,'Dipole','KUG 0209-067',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22317,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22317,34.15,NULL,67.7,5771,NULL,NULL,'Dipole + Quadrupole','KUG 0209-067',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22318,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22318,34.4,0.4,75.8,5771,NULL,NULL,'Malmquist cor.','KUG 0209-067',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22319,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22319,34.42,0.49,76.5,5771,75,NULL,'IR','KUG 0209-067',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22320,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22320,34.46,0.2,78,5771,74.4,NULL,NULL,'KUG 0209-067',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22321,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22321,34.57,0.37,82.2,5771,NULL,NULL,NULL,'KUG 0209-067',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22322,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22322,34.47,0.56,78.5,5772,NULL,NULL,'Malmquist cor.','ESO 544- G 021',NULL,'2009ApJS..182..474S',2009,1,1.44,NULL,'G',0.000033,NULL,'15.29',0.34,'Sb',NULL,NULL,NULL,NULL,1,32.9425,-19.92289,0,NULL,37974730606,593355165,9271174,15.29),(22323,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22323,34.52,0.55,80.3,5772,NULL,NULL,NULL,'ESO 544- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22324,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22324,34.56,0.2,81.7,5772,74.4,NULL,NULL,'ESO 544- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22325,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22325,34.57,0.49,82,5772,75,NULL,'IR','ESO 544- G 021',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22326,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22326,34.1,0.2,66.1,5773,74.4,NULL,NULL,'ESO 544- G 020',NULL,'2013AJ....146...86T',2013,1,1.5,'The APM position is 12 arcsec southeast of the nucleus.','G',0.000107,NULL,'15.26',0.5,'SB(r)b?',NULL,NULL,NULL,NULL,1,32.9435417,-18.26608,0.024,NULL,37954711207,593042362,9266286,15.26),(22327,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22327,34.15,0.4,67.6,5773,NULL,NULL,'Malmquist cor.','ESO 544- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22328,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22328,34.28,0.38,71.8,5773,NULL,NULL,NULL,'ESO 544- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22329,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22329,35.68,0.66,137,5774,70,NULL,NULL,'MCG -01-06-068',NULL,'2014MNRAS.445.2677S',2014,1,0.9,'The APM image includes a superposed star.','G',0.000097,NULL,'14.9b',0.8,NULL,NULL,NULL,NULL,NULL,1,32.945167,-5.9155,0.009,NULL,35142423549,549100367,8579693,14.9),(22330,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 17825','R',22330,39.46,0.2,672,5775,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007je','SN 2007je',0.161,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,32.947125,-0.91244,0.037,NULL,34997926495,546842601,8544415,NULL),(22331,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 17825','R',22331,39.59,0.11,714,5775,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007je','SN 2007je',0.161,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22332,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 17521','RN',22332,40.01,0.1,777,5776,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 17521',0.295102,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22333,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 17521','RN',22333,40.68,0.2,1060,5776,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17521',0.295102,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22334,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22334,37.21,0.23,276,5777,70,NULL,NULL,'2MASX J02114911+1301157',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000106,NULL,'16.3g',0.4,'E0',NULL,NULL,NULL,NULL,1,32.9545417,13.02106,0.245,NULL,66955607135,1046181361,16346583,16.3),(22335,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 19348','RN',22335,40.59,0.17,1110,5778,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19348',0.179597,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22336,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22336,35.34,0.46,117,5779,NULL,NULL,NULL,'ESO 544- G 023',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000033,NULL,'15.17',0.8,'Sb             HII',NULL,NULL,NULL,NULL,1,32.9847083333,-20.37611,0,NULL,37972714960,593323671,9270682,15.17),(22337,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22337,35.34,0.46,117,5779,NULL,NULL,'Malmquist cor.','ESO 544- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22338,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22338,35.38,0.2,119,5779,74.4,NULL,NULL,'ESO 544- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22339,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22339,35.49,0.47,126,5779,NULL,NULL,'H','ESO 544- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22340,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22340,35.56,0.4,129,5779,NULL,NULL,'mean','ESO 544- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22341,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22341,35.66,0.45,136,5779,NULL,NULL,'K','ESO 544- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22342,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22342,35.68,0.46,137,5779,NULL,NULL,'J','ESO 544- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22343,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22343,33.98,0.8,62.4,5780,75,NULL,'W91PP, r','UGC 01690',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'15.66',0.1,'S?',NULL,NULL,NULL,NULL,1,32.9892083,29.31389,0.213,NULL,68640950486,1072514851,16758044,15.66),(22344,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22344,34.41,0.29,76.1,5780,NULL,NULL,'Malmquist cor.','UGC 01690',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22345,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22345,34.58,0.38,82.3,5780,75,NULL,'W91PP, r, raw','UGC 01690',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22346,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22346,34.67,0.38,86.1,5780,75,NULL,'W91PP, r, cor','UGC 01690',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22347,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22347,34.7,0.2,87.1,5780,74.4,NULL,NULL,'UGC 01690',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22348,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22348,34.73,0.38,88.2,5780,75,NULL,'W91PP, r, inv','UGC 01690',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22349,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22349,34.74,0.25,88.7,5780,NULL,NULL,NULL,'UGC 01690',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22350,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22350,34.75,0.49,89.3,5780,75,NULL,'IR','UGC 01690',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22351,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 14675','RN',22351,40.7,0.31,1100,5781,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14675',0.255439,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22352,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 14675','RN',22352,40.89,0.3,1200,5781,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14675',0.255439,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22353,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22353,36.94,0.46,244,5782,70,NULL,NULL,'2MASX J02115928-0913088',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000092,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,32.997083,-9.21908,0.048,NULL,35127512693,548867385,8576052,17),(22354,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22354,36.18,0.53,172,5783,70,NULL,NULL,'2MASX J02115942-1521188',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.30',0.39,NULL,NULL,NULL,NULL,NULL,1,32.9975,-15.35522,0.008,NULL,35057489616,547773275,8558957,16.3),(22355,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22355,34.46,0.2,78,5784,74.4,NULL,NULL,'UGC 01689',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000355,NULL,'16.5',0.9,'Sm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,33.001167,14.01636,0.249,NULL,66957018179,1046203409,16346928,16.5),(22356,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22356,37.21,0.23,276,5785,70,NULL,NULL,'SDSS J021202.78+130323.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000063,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,33.011625,13.05653,0.245,NULL,66955720090,1046183126,16346611,18.2),(22357,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 17337',NULL,22357,39.98,0.23,989,5786,70,NULL,'SN photometric redshift distance, z photo =0.265 +/- 0.035','SDSS-II SN 17337',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,33.0130416667,0.23447,0.033,NULL,66992336030,1046755250,16355550,NULL),(22358,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22358,36.77,0.46,226,5787,70,NULL,NULL,'2MASX J02120778+1358591',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000096,NULL,'16.0g',0.39,'E0',NULL,NULL,NULL,NULL,1,33.0325416667,13.98303,0.249,NULL,66957023942,1046203499,16346929,16),(22359,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22359,34.6,0.47,83.1,5788,70,NULL,NULL,'2MASX J02120886-5136003',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00008,NULL,'14.75',0.75,'E',NULL,NULL,NULL,NULL,1,33.037,-51.60014,0.033,NULL,38243476165,597554315,9336786,14.75),(22360,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22360,37.94,0.33,386,5789,70,NULL,NULL,'SDSS J021214.03-085420.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00007,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,33.0584583,-8.90558,0.022,NULL,35120204481,548753195,8574268,18),(22361,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22361,35.57,0.47,130,5790,70,NULL,NULL,'MCG -01-06-069',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.39',0.3,NULL,NULL,NULL,NULL,NULL,1,33.06125,-2.50106,0.033,NULL,35134894958,548982733,8577855,15.39),(22362,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22362,36.95,0.6,246,5791,70,NULL,NULL,'2MASX J02121506-1655248',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,33.0627917,-16.92344,0.014,NULL,37957716326,593089317,9267020,15.8),(22363,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22363,35.73,0.55,140,5792,70,NULL,NULL,'2MASX J02121535-5004353',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.000067,NULL,'16.70',0.26,'S0',NULL,NULL,NULL,NULL,1,33.0640416667,-50.07644,NULL,NULL,38248595568,597634305,9338036,16.7),(22364,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22364,37.86,0.33,373,5793,70,NULL,NULL,'SDSS J021215.51-002756.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,33.0646666667,-0.46581,0.053,NULL,34998142908,546845982,8544468,18.5),(22365,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 03938','RN',22365,41.58,0.17,1540,5794,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03938',0.343283,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22366,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 03938','RN',22366,41.75,0.27,1670,5794,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03938',0.343283,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22367,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22367,37.94,0.33,386,5795,70,NULL,NULL,'2MASX J02121725-0851559',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000082,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,33.072,-8.86544,0.022,NULL,35120210974,548753296,8574270,17.2),(22368,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22368,37.86,0.33,373,5796,70,NULL,NULL,'2MASX J02121835-0027357',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'18.03',0.23,NULL,NULL,NULL,NULL,NULL,1,33.0765,-0.46,0.053,NULL,34998142320,546845973,8544468,18.03),(22369,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 01204','RN',22369,42.39,0.18,2060,5797,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01204',0.455709,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22370,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22370,35.22,0.58,111,5798,70,NULL,NULL,'UGC 01698',NULL,'2014MNRAS.445.2677S',2014,1,0.97,NULL,'G',0.000103,NULL,'14.8g',0.58,'(R\')SB(r)a:',NULL,NULL,NULL,NULL,1,33.082,-0.8115,0.037,NULL,34997878005,546841843,8544403,14.8),(22371,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 10528','RN',22371,37.89,0.11,364,5799,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10528',0.040759,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22372,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 10528','RN',22372,39.44,0.41,744,5799,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10528',0.040759,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22373,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22373,33.43,0.45,48.6,5800,NULL,NULL,'K','NGC 0845',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000057,NULL,'14.34',0.4,'Sb','X-ray-faint group member',NULL,NULL,NULL,1,33.0824583333,37.47733,0.177,NULL,68622501552,1072226586,16753540,14.34),(22374,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22374,33.46,0.47,49.1,5800,NULL,NULL,'H','NGC 0845',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22375,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22375,33.56,0.46,51.6,5800,NULL,NULL,'J','NGC 0845',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22376,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22376,33.84,0.4,58.7,5800,NULL,NULL,'mean','NGC 0845',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22377,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22377,34.03,0.49,63.9,5800,75,NULL,'IR','NGC 0845',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22378,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22378,34.08,0.08,65.6,5800,NULL,NULL,NULL,'NGC 0845',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22379,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22379,35.99,0.5,158,5801,70,NULL,NULL,'UGC 01697',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00003,NULL,'14.74',0.5,'Sb             HII?',NULL,NULL,NULL,NULL,1,33.0850417,-2.14156,0.029,NULL,35135510791,548992356,8578005,14.74),(22380,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22380,35.86,0.8,148,5801,75,NULL,'CF, r','UGC 01697',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22381,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22381,36.35,0.38,187,5801,75,NULL,'CF, r, raw','UGC 01697',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22382,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22382,36.59,0.38,208,5801,75,NULL,'CF, r, cor','UGC 01697',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22383,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22383,36.66,0.38,215,5801,75,NULL,'CF, r, inv','UGC 01697',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22384,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22384,37.28,0.46,286,5802,70,NULL,NULL,'2MASX J02122069-0756039',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000087,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,33.0862916667,-7.93433,0.01,NULL,35151199556,549237493,8581835,16.5),(22385,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 04409','RN',22385,43.73,0.3,3900,5803,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 04409',0.430337,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22386,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 04409','RN',22386,43.82,0.31,4070,5803,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 04409',0.430337,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22387,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22387,37.44,0.46,308,5804,70,NULL,NULL,'2MASX J02122455-0007247',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000076,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,33.1022083333,-0.12344,0.041,NULL,34997346160,546833533,8544273,17.7),(22388,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 06269','RN',22388,38.34,0.12,424,5805,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06269',0.097516,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22389,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 06269','RN',22389,39.38,0.27,686,5805,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06269',0.097516,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22390,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22390,36.12,0.46,168,5806,70,NULL,NULL,'2MASXi J0212274-001523',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000076,NULL,'17.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,33.1144166667,-0.25631,0.041,NULL,34997364111,546833814,8544278,17.5),(22391,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22391,34.46,0.2,78,5807,74.4,NULL,NULL,'UGC 01700',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',NULL,NULL,'15.31',0.2,'Scd:',NULL,NULL,NULL,NULL,1,33.1295,16.85525,0.225,NULL,68077245943,1063706967,16620421,15.31),(22392,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22392,34.6,0.58,83.2,5807,NULL,NULL,'Malmquist cor.','UGC 01700',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22393,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22393,34.65,0.57,85.1,5807,NULL,NULL,NULL,'UGC 01700',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22394,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 18183','RN',22394,42.32,0.38,2070,5808,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18183',0.41024,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22395,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 18183','RN',22395,43.22,0.3,3120,5808,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18183',0.41024,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22396,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 06274','RN',22396,40.67,0.24,1130,5809,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06274',0.207333,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22397,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 06274','RN',22397,40.76,0.17,1180,5809,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06274',0.207333,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22398,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22398,35.68,0.53,137,5810,70,NULL,NULL,'2MASX J02123758-0550207',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'17.15',0.25,NULL,NULL,NULL,NULL,NULL,1,33.1565417,-5.83908,0.021,NULL,35142494623,549101478,8579710,17.15),(22399,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22399,37.29,0.59,287,5811,70,NULL,NULL,'2MASX J02123789-0217267',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'17.53',0.26,NULL,NULL,NULL,NULL,NULL,1,33.157917,-2.29078,0.033,NULL,35134721300,548980020,8577812,17.53),(22400,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22400,37.67,0.63,341,5812,70,NULL,NULL,'2MASX J02123792-0539237',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'17.47',0.18,NULL,NULL,NULL,NULL,NULL,1,33.157917,-5.65661,0.009,NULL,35142335540,549098992,8579671,17.47),(22401,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22401,35.99,0.72,158,5813,70,NULL,NULL,'2MASX J02123892-4857315',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'16.63',0.38,'S0',NULL,NULL,NULL,NULL,1,33.162083,-48.95881,NULL,NULL,38251622603,597681603,9338775,16.63),(22402,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22402,37.57,0.46,326,5814,70,NULL,NULL,'2MASX J02123929-0047147',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000098,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,33.163667,-0.78736,0.037,NULL,35131884439,548935694,8577120,16.5),(22403,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 04175','RN',22403,42.69,0.5,2700,5815,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 04175',0.279179,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22404,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 04175','RN',22404,43.5,0.55,3920,5815,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 04175',0.279179,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22405,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 14505',NULL,22405,40.46,0.2,1230,5816,70,NULL,'SN photometric redshift distance, z photo =0.345 +/- 0.041','SDSS-II SN 14505',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.8g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,33.189583,-1.08936,0.033,NULL,35131931686,548936432,8577131,22.8),(22406,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 01193','RN',22406,41.46,0.19,1370,5817,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01193',0.423747,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22407,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 01193','RN',22407,41.63,0.12,1490,5817,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01193',0.423747,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22408,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22408,37.56,0.46,325,5818,70,NULL,NULL,'2MASX J02124896+0107254',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000079,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,33.204125,1.12372,0.049,NULL,67059140242,1047799066,16371860,18),(22409,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 07921','RN',22409,43.18,0.25,2720,5819,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07921',0.592814,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22410,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22410,36.62,0.55,211,5820,70,NULL,NULL,'AM 0211-565 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.61',0.4,NULL,NULL,NULL,NULL,NULL,1,33.223667,-56.68867,0.029,NULL,36167579953,565118436,8829975,16.61),(22411,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22411,32.49,0.8,31.4,5821,75,NULL,'MAT, I','ESO 544- G 027',NULL,'1997ApJS..109..333W',1997,1,1.55,NULL,'G',0.000033,NULL,'15.05',0.32,'Sb             HII',NULL,NULL,NULL,NULL,1,33.22775,-19.31689,0.059,NULL,37974847478,593356991,9271202,15.05),(22412,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22412,32.35,0.32,29.5,5821,85,NULL,'I, inv','ESO 544- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22413,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22413,32.36,0.32,29.7,5821,85,NULL,'I, raw','ESO 544- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22414,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22414,32.71,0.43,34.9,5821,75,NULL,'MAT, I, raw','ESO 544- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22415,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22415,32.72,0.43,35,5821,75,NULL,'MAT, I, inv','ESO 544- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22416,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22416,32.72,0.4,35,5821,73,NULL,'opt','ESO 544- G 027',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22417,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22417,32.73,0.4,35.1,5821,75,NULL,NULL,'ESO 544- G 027',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22418,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22418,32.73,0.39,35.1,5821,73,NULL,'IR','ESO 544- G 027',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22419,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22419,32.73,0.39,35.2,5821,73,NULL,'opt','ESO 544- G 027',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22420,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22420,33,0.43,39.9,5821,75,NULL,'3.6 micron, color + selection bias corrected','ESO 544- G 027',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22421,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22421,33.05,0.43,40.7,5821,75,NULL,'MAT, I, cor','ESO 544- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22422,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22422,33.22,0.43,44.1,5821,75,NULL,'3.6 micron, color corrected','ESO 544- G 027',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22423,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22423,33.38,0.2,47.4,5821,74.4,NULL,NULL,'ESO 544- G 027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22424,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22424,33.44,0.71,48.8,5821,NULL,NULL,NULL,'ESO 544- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22425,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22425,33.47,0.49,49.5,5821,75,NULL,'IR','ESO 544- G 027',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22426,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22426,33.53,0.68,50.9,5821,NULL,NULL,'Malmquist cor.','ESO 544- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22427,'SBF','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22427,28.11,0.15,4.2,5822,NULL,NULL,'R','UGC 01703',NULL,'2005A&A...437..823R',2005,1,1.1,NULL,'G',NULL,NULL,NULL,1,'dE',NULL,NULL,NULL,NULL,1,33.22875,32.815,0.329,NULL,68625074511,1072266789,16754168,NULL),(22428,'TRGB','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22428,28.17,0.1,4.31,5822,74.4,NULL,NULL,'UGC 01703',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22429,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 01564','RN',22429,42.67,0.22,2620,5823,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01564',0.306034,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22430,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 01564','RN',22430,42.8,0.17,2770,5823,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01564',0.306034,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22431,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 17773',NULL,22431,40.14,0.26,1060,5824,70,NULL,'SN photometric redshift distance, z photo =0.289 +/- 0.045','SDSS-II SN 17773',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,33.2841666667,-0.30633,0.053,NULL,34997529501,546836398,8544318,NULL),(22432,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 17773','R',22432,40.84,0.24,1140,5824,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17773',0.288027,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22433,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 17773','R',22433,41.14,0.2,1310,5824,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17773',0.288027,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22434,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 17773',NULL,22434,40.91,0.15,1520,5824,70,NULL,'SALT 2','SDSS-II SN 17773',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22435,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 17773',NULL,22435,40.94,0.15,1540,5824,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 17773',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22436,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22436,36.61,0.51,210,5825,70,NULL,NULL,'MCG -01-06-071',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.000137,NULL,'14.9b',0.2,NULL,NULL,NULL,NULL,NULL,1,33.29525,-6.34089,0,NULL,35149880012,549216875,8581513,14.9),(22437,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22437,34.94,0.33,97.1,5826,70,NULL,NULL,'2MASX J02131090+1401048',NULL,'2015arXiv151105856S',2015,1,0.08,NULL,'G',0.000082,NULL,'18.3g',0.08,NULL,NULL,NULL,NULL,NULL,1,33.2954583,14.01797,0.233,NULL,66956838681,1046200604,16346884,18.3),(22438,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22438,35.16,0.43,107,5827,NULL,NULL,'Malmquist cor.','UGC 01705',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000167,NULL,'15.30',0.5,'SAB(s)b',NULL,NULL,NULL,NULL,1,33.2970417,9.51103,0.185,NULL,67088860027,1048263437,16379116,15.3),(22439,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22439,35.43,0.38,122,5827,NULL,NULL,NULL,'UGC 01705',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22440,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22440,35.47,0.2,124,5827,74.4,NULL,NULL,'UGC 01705',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22441,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22441,35.07,0.8,103,5828,75,NULL,'MAT, I','ESO 053- G 002',NULL,'1997ApJS..109..333W',1997,1,1.88,NULL,'G',0.000033,NULL,'16.21',0.2,'Scd',NULL,NULL,NULL,NULL,1,33.299083,-70.91308,0.021,NULL,36337625059,567775391,8871490,16.21),(22442,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22442,34.01,NULL,63.4,5828,NULL,NULL,'B','ESO 053- G 002',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22443,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22443,34.01,NULL,63.4,5828,NULL,NULL,'I','ESO 053- G 002',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22444,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22444,34.01,NULL,63.4,5828,NULL,NULL,'B, Hubble-type-TF','ESO 053- G 002',NULL,'2004ApJ...607..241R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22445,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22445,34.03,0.21,64,5828,NULL,NULL,'B, Hubble-type-TF','ESO 053- G 002',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22446,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22446,34.21,NULL,69.5,5828,NULL,NULL,'B','ESO 053- G 002',NULL,'2004ApJ...607..241R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22447,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22447,34.21,NULL,69.7,5828,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 053- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22448,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22448,34.23,NULL,70.3,5828,NULL,NULL,'Dipole + Quadrupole','ESO 053- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22449,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22449,34.26,NULL,71,5828,NULL,NULL,'Dipole','ESO 053- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22450,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22450,34.27,NULL,71.4,5828,NULL,NULL,NULL,'ESO 053- G 002',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22451,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22451,34.62,0.32,83.9,5828,85,NULL,'I, raw','ESO 053- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22452,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22452,34.65,0.32,85,5828,85,NULL,'I, inv','ESO 053- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22453,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22453,34.77,0.43,90,5828,75,NULL,'MAT, I, raw','ESO 053- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22454,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22454,34.89,0.49,95.1,5828,75,NULL,'IR','ESO 053- G 002',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22455,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22455,34.92,0.43,96.4,5828,75,NULL,'MAT, I, inv','ESO 053- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22456,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22456,35.11,0.39,105,5828,NULL,NULL,NULL,'ESO 053- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22457,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22457,35.11,0.43,105,5828,75,NULL,'MAT, I, cor','ESO 053- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22458,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22458,35.16,0.2,108,5828,74.4,NULL,NULL,'ESO 053- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22459,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22459,35.23,0.37,111,5828,NULL,NULL,'Malmquist cor.','ESO 053- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22460,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 03353','RN',22460,41.48,0.14,1560,5829,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03353',0.264906,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22461,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 03353','RN',22461,42.33,0.2,2320,5829,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03353',0.264906,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22462,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22462,37.12,0.54,265,5830,70,NULL,NULL,'MCG -02-06-040',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.5',0.2,NULL,NULL,NULL,NULL,NULL,1,33.3088333333,-14.00756,0.037,NULL,35063368350,547865130,8560392,15.5),(22463,'CMD','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'N',22463,17.4,0.1,0.03,5831,NULL,NULL,'helio D, 0.036 Mpc GSR','Laevens 2',NULL,'2015ApJ...802L..18L',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22464,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22464,34.93,0.46,96.8,5832,70,NULL,NULL,'MCG -01-06-073',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00014,NULL,'15.46',0.3,NULL,NULL,NULL,NULL,NULL,1,33.343,-2.34222,0.037,NULL,35134714464,548979913,8577811,15.46),(22465,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22465,35.64,0.48,134,5833,70,NULL,NULL,'MCG -01-06-072',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.21',0.7,NULL,NULL,NULL,NULL,NULL,1,33.343625,-3.08928,0.033,NULL,35145545027,549149141,8580455,15.21),(22466,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22466,35.7,0.37,138,5834,NULL,NULL,'Malmquist cor.','ESO 544- G 028',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.00012,NULL,'15.29',0.7,'Sb',NULL,NULL,NULL,NULL,1,33.358375,-18.83328,0.023,NULL,37971719616,593308119,9270439,15.29),(22467,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22467,35.72,0.37,139,5834,NULL,NULL,NULL,'ESO 544- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22468,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22468,35.76,0.2,142,5834,74.4,NULL,NULL,'ESO 544- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22469,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 04281','R',22469,39.82,0.19,760,5835,70,NULL,'SDSS CAND. Unknown; SALT 2; SN 2005in','SN 2005in',0.2132,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia?',NULL,NULL,NULL,NULL,1,33.367417,-0.96825,0.025,NULL,35132429295,548944207,8577253,NULL),(22470,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 04281','R',22470,40.08,0.1,855,5835,70,NULL,'SDSS CAND. Unknown; MLCS2K2; SN 2005in','SN 2005in',0.2132,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22471,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 16656','RN',22471,39.46,0.52,682,5836,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16656',0.142969,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22472,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22472,37.76,0.46,357,5837,70,NULL,NULL,'SDSS J021328.40-000355.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000091,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,33.368333,-0.06544,0.053,NULL,34997505612,546836025,8544312,18.3),(22473,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22473,37.21,0.23,276,5838,70,NULL,NULL,'2MASX J02133022+1314411',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000071,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,33.375833,13.24464,0.273,NULL,66955167899,1046174498,16346476,17.7),(22474,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22474,36.39,0.47,190,5839,NULL,NULL,'Malmquist cor.','2MASX J02133051+1652521',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',NULL,NULL,'14.5I',0.2,NULL,NULL,NULL,NULL,NULL,1,33.377125,16.88122,0.225,NULL,68077332317,1063708317,16620442,14.5),(22475,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22475,36.54,0.44,203,5839,NULL,NULL,NULL,'2MASX J02133051+1652521',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22476,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22476,36.55,0.2,204,5839,74.4,NULL,NULL,'2MASX J02133051+1652521',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22477,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','PTF10accd','N',22477,36.21,0.05,169,5840,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10accd',0.0348,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22478,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22478,35.77,0.52,142,5841,70,NULL,NULL,'2MASX J02133257-0528552',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00008,NULL,'16.29',0.5,NULL,NULL,NULL,NULL,NULL,1,33.385833,-5.48194,0.021,NULL,35142312246,549098628,8579666,16.29),(22479,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22479,38.61,0.46,526,5842,70,NULL,NULL,'SDSS J021333.53-093454.0',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000095,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,33.38975,-9.58167,0.089,NULL,35128314892,548879920,8576248,17.9),(22480,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22480,33.9,0.8,60.3,5843,75,NULL,'W91PP, r','UGC 01706',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000023,NULL,'14.73',0.4,'Scd:','Isolated galaxy',NULL,NULL,NULL,1,33.39125,25.8555,0.157,NULL,68593428440,1071772319,16746442,14.73),(22481,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22481,33.92,0.8,60.8,5843,75,NULL,'CF, r','UGC 01706',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22482,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22482,33.38,0.49,47.3,5843,75,NULL,'IR','UGC 01706',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22483,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22483,33.57,0.2,51.8,5843,74.4,NULL,NULL,'UGC 01706',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22484,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22484,33.73,0.45,55.7,5843,NULL,NULL,NULL,'UGC 01706',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22485,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22485,33.76,0.38,56.5,5843,75,NULL,'W91PP, r, raw','UGC 01706',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22486,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22486,33.77,0.38,56.7,5843,75,NULL,'CF, r, raw','UGC 01706',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22487,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22487,33.81,0.38,57.7,5843,75,NULL,'W91PP, r, inv','UGC 01706',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22488,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22488,33.82,0.38,58.1,5843,75,NULL,'CF, r, inv','UGC 01706',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22489,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22489,33.99,0.38,62.8,5843,75,NULL,'W91PP, r, cor','UGC 01706',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22490,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22490,33.99,0.38,62.9,5843,75,NULL,'CF, r, cor','UGC 01706',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22491,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22491,34,0.4,63.2,5843,NULL,NULL,'Malmquist cor.','UGC 01706',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22492,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22492,37.69,0.46,345,5844,70,NULL,NULL,'2MASX J02133529+1355141',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000107,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,33.397,13.92067,0.245,NULL,66956848459,1046200757,16346886,17.3),(22493,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22493,33.32,NULL,46.1,5845,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01714',NULL,'2010Ap&SS.325..163P',2010,1,1.16,NULL,'G',0.000011,NULL,'17.',0.15,'Scd',NULL,NULL,NULL,NULL,1,33.402625,10.33628,0.193,NULL,67091534320,1048305223,16379769,17),(22494,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22494,33.33,NULL,46.3,5845,NULL,NULL,'Dipole + Quadrupole','UGC 01714',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22495,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22495,33.33,NULL,46.4,5845,NULL,NULL,'Dipole','UGC 01714',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22496,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22496,33.41,NULL,48.1,5845,NULL,NULL,NULL,'UGC 01714',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22497,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22497,38.34,0.46,465,5846,70,NULL,NULL,'2MASX J02133670-0947057',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000114,NULL,'16.8g',0.35,NULL,NULL,NULL,NULL,NULL,1,33.402875,-9.78494,0.06,NULL,35128147538,548877305,8576207,16.8),(22498,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22498,35.78,0.46,143,5847,70,NULL,NULL,'2MASX J02133767+1327411',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000099,NULL,'16.1g',0.34,'E0',NULL,NULL,NULL,NULL,1,33.4069583333,13.46153,0.273,NULL,66955205018,1046175078,16346485,16.1),(22499,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22499,35.45,0.42,123,5848,NULL,NULL,'Malmquist cor.','IC 0212',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000017,NULL,'15.23',0.6,NULL,NULL,NULL,NULL,NULL,1,33.409417,16.59394,0.221,NULL,68075348888,1063677326,16619958,15.23),(22500,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22500,35.64,0.39,134,5848,NULL,NULL,NULL,'IC 0212',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22501,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22501,35.78,0.2,143,5848,74.4,NULL,NULL,'IC 0212',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22502,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 04044',NULL,22502,41.53,0.06,2020,5849,70,NULL,'SN photometric redshift distance, z photo =0.670 +/- 0.030','SDSS-II SN 04044',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,33.41525,1.24086,0.049,NULL,67059383027,1047802859,16371919,NULL),(22503,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22503,34.95,0.49,97.9,5850,75,NULL,'IR','CGCG 504-032',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000033,NULL,'15.70',0.2,'Sc',NULL,NULL,NULL,NULL,1,33.417417,31.19183,0.241,NULL,68642602203,1072540659,16758447,15.7),(22504,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22504,37.44,0.46,308,5851,70,NULL,NULL,'2MASX J02134153+0012290',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,33.423,0.20806,0.033,NULL,66991661224,1046744706,16355386,14.3),(22505,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22505,36.77,0.46,226,5852,70,NULL,NULL,'2MASX J02134411+1333322',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000076,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,33.4336666667,13.55883,0.273,NULL,66955049564,1046172649,16346447,17.7),(22506,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22506,35.17,0.59,108,5853,NULL,NULL,'Malmquist cor.','UGC 01717',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.31',0.6,'SBcd:',NULL,NULL,NULL,NULL,1,33.453625,16.79694,0.221,NULL,68077328987,1063708265,16620441,15.31),(22507,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22507,35.23,0.58,111,5853,NULL,NULL,NULL,'UGC 01717',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22508,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22508,35.27,0.2,113,5853,74.4,NULL,NULL,'UGC 01717',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22509,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 21875',NULL,22509,37.18,1.27,273,5854,70,NULL,'SN photometric redshift distance, z photo =0.066 +/- 0.056','SDSS-II SN 21875',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,33.4582083,0.76303,0.053,NULL,67059402991,1047803171,16371924,NULL),(22510,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22510,36.39,0.51,190,5855,70,NULL,NULL,'2MASX J02135297-0505481',NULL,'2014MNRAS.445.2677S',2014,1,NULL,'The APM image includes a neighboring star.','G',0.00015,NULL,'15.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,33.470667,-5.09675,0,NULL,35143151433,549111741,8579870,15.6),(22511,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 18148','RN',22511,42.02,0.3,1960,5856,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18148',0.294849,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22512,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 18148','RN',22512,42.62,0.33,2580,5856,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18148',0.294849,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22513,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 13946','RN',22513,41.63,0.24,1700,5857,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13946',0.245902,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22514,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 13946','RN',22514,42.03,0.38,2050,5857,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13946',0.245902,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22515,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 16136','R',22515,40.46,0.18,920,5858,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16136',0.342718,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,33.485875,-0.73158,0.029,NULL,35131574970,548930858,8577044,NULL),(22516,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 16136','R',22516,40.9,0.27,1130,5858,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16136',0.342718,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22517,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22517,37.31,0.46,290,5859,70,NULL,NULL,'2MASX J02140069-0900578',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000087,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,33.5029583333,-9.01597,0.045,NULL,35120361018,548755640,8574306,17),(22518,'SBF','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22518,29.73,0.14,8.83,5860,74.4,NULL,NULL,'NGC 0855',NULL,'2013AJ....146...86T',2013,1,2.6,NULL,'G',0.000017,NULL,'13.30',1,'E','Group member',NULL,NULL,NULL,1,33.5145417,27.87733,0.209,NULL,68646199110,1072596861,16759325,13.3),(22519,'SBF','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22519,29.94,0.17,9.73,5860,NULL,NULL,'I','NGC 0855',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22520,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22520,35.27,0.34,113,5861,NULL,NULL,'Malmquist cor.','IC 0213',NULL,'2009ApJS..182..474S',2009,1,1.9,NULL,'G',0.000017,NULL,'14.6',1.5,'SAB(rs)b',NULL,NULL,NULL,NULL,1,33.517833,16.45589,0.221,NULL,68075324598,1063676946,16619952,14.6),(22521,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22521,35.39,0.32,120,5861,NULL,NULL,NULL,'IC 0213',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22522,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22522,35.41,0.4,121,5861,NULL,NULL,'mean','IC 0213',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22523,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22523,35.64,0.45,134,5861,NULL,NULL,'K','IC 0213',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22524,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22524,35.7,0.47,138,5861,NULL,NULL,'H','IC 0213',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22525,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22525,35.71,0.46,139,5861,NULL,NULL,'J','IC 0213',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22526,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22526,35.74,0.2,141,5861,74.4,NULL,NULL,'IC 0213',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22527,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2005ml',NULL,22527,37.84,0.12,332,5862,74.2,NULL,'SALT 2','SDSS J021404.48-001420.6',0.114,'2010ApJ...716..712A',2010,1,0.11,NULL,'G',NULL,NULL,'20.0g',0.09,NULL,NULL,NULL,NULL,NULL,1,33.5187083333,-0.23908,0.065,NULL,34997320988,546833140,8544267,20),(22528,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2005ml',NULL,22528,38.63,0.15,477,5862,70,NULL,'SALT 2','SDSS J021404.48-001420.6',0.114,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22529,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 11067','R',22529,38.72,0.21,497,5862,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ml','SDSS J021404.48-001420.6',0.117758,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22530,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 11067','R',22530,38.89,0.09,538,5862,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ml','SDSS J021404.48-001420.6',0.117758,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22531,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22531,35.67,0.5,136,5863,70,NULL,NULL,'MCG -02-06-041',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.5',0.17,NULL,NULL,NULL,NULL,NULL,1,33.524833,-12.82022,0,NULL,35048725799,547636340,8556817,15.5),(22532,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','PTF10zdk',NULL,22532,36.18,0.04,167,5864,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10zdk',0.0322,'2014MNRAS.438.1391P',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,33.5305417,23.63061,0.245,NULL,68060930600,1063452040,16616438,NULL),(22533,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22533,33.31,0.8,45.9,5865,75,NULL,'MAT, I','ESO 415- G 010',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.80',0.3,'SB(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,33.5537083333,-31.14933,NULL,NULL,38446415905,600725248,9386332,14.8),(22534,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22534,33.18,0.32,43.3,5865,85,NULL,'I, inv','ESO 415- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22535,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22535,33.19,0.32,43.4,5865,85,NULL,'I, raw','ESO 415- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22536,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22536,33.43,0.43,48.4,5865,75,NULL,'MAT, I, raw','ESO 415- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22537,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22537,33.47,0.43,49.5,5865,75,NULL,'MAT, I, inv','ESO 415- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22538,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22538,33.67,0.42,54.1,5865,NULL,NULL,NULL,'ESO 415- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22539,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22539,33.71,0.2,55.2,5865,74.4,NULL,NULL,'ESO 415- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22540,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22540,33.79,0.43,57.3,5865,75,NULL,'MAT, I, cor','ESO 415- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22541,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22541,34.17,0.33,68.2,5865,NULL,NULL,'Malmquist cor.','ESO 415- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22542,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 14763',NULL,22542,40.48,0.18,1250,5866,70,NULL,'SN photometric redshift distance, z photo =0.350 +/- 0.037','SDSS-II SN 14763',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,33.5665417,1.12131,0.053,NULL,67059535435,1047805241,16371956,NULL),(22543,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 14763','R',22543,41.4,0.29,1380,5866,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14763',0.375042,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22544,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 14763','R',22544,41.43,0.3,1400,5866,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14763',0.375042,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22545,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 14763',NULL,22545,40.98,0.2,1570,5866,70,NULL,'SALT 2','SDSS-II SN 14763',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22546,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 14763',NULL,22546,41.04,0.2,1610,5866,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14763',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22547,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 03329','RN',22547,40.72,0.22,1240,5867,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 03329',0.12276,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22548,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 03329','RN',22548,40.75,0.13,1260,5867,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 03329',0.12276,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22549,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22549,37.25,0.2,282,5868,74.4,NULL,NULL,'UGC 01723',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',NULL,NULL,'16.0',0.9,'SABcd',NULL,NULL,NULL,NULL,1,33.571875,7.58842,0.217,NULL,67095787026,1048371672,16380807,16),(22550,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22550,36.14,0.73,169,5869,70,NULL,NULL,'2MASX J02141879-2420505',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.00015,NULL,'15.3R',0.16,NULL,NULL,NULL,NULL,NULL,1,33.578417,-24.34728,0,NULL,37924355613,592568056,9258875,15.3),(22551,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22551,37.14,0.46,267,5870,70,NULL,NULL,'2MASX J02142000+1206453',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000077,NULL,'17.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,33.583375,12.11253,0.269,NULL,67076400569,1048068758,16376074,17.6),(22552,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22552,33.5,0.49,50.1,5871,75,NULL,'IR','KUG 0211-075',NULL,'2011yCatp016004901K',2011,1,2.3,'Position given in 1985AnTok..202.237T is incorrect.','G',0.00002,NULL,'14.50',0.4,'Sb pec sp      HII',NULL,NULL,NULL,NULL,1,33.60775,-7.36847,0.04,NULL,35151916987,549248702,8582010,14.5),(22553,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22553,33.54,0.2,51.1,5871,74.4,NULL,NULL,'KUG 0211-075',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22554,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22554,33.66,0.43,53.8,5871,NULL,NULL,NULL,'KUG 0211-075',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22555,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22555,33.77,0.47,56.7,5871,NULL,NULL,'H','KUG 0211-075',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22556,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22556,33.83,0.4,58.4,5871,NULL,NULL,'Malmquist cor.','KUG 0211-075',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22557,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22557,33.84,0.45,58.6,5871,NULL,NULL,'K','KUG 0211-075',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22558,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22558,33.98,0.46,62.5,5871,NULL,NULL,'J','KUG 0211-075',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22559,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22559,34.13,0.4,67,5871,NULL,NULL,'mean','KUG 0211-075',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22560,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 17781','RN',22560,41.04,0.16,1330,5872,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 17781',0.214861,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22561,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 17781','RN',22561,41.71,0.29,1810,5872,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 17781',0.214861,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22562,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22562,34.56,0.47,81.6,5873,70,NULL,NULL,'KUG 0212-134',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.000143,NULL,'15.37',0.2,'Scd',NULL,NULL,NULL,NULL,1,33.626375,-13.26328,0,NULL,35049143943,547642874,8556919,15.37),(22563,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22563,37.29,0.46,287,5874,70,NULL,NULL,'2MASX J02143043+1342359',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000099,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,33.6269166667,13.71003,0.257,NULL,66944238143,1046003720,16343808,16.9),(22564,'AGN time lag','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22564,34.89,0.15,95.2,5875,NULL,NULL,NULL,'NGC 0863',NULL,'2014ApJ...784L..11Y',2014,1,1.1,NULL,'G',0.00004,NULL,'13.2r',1,'SA(s)a:        Sy1.2',NULL,NULL,NULL,'Sy 1',1,33.6398333333,-0.76669,0.053,NULL,35132368121,548943251,8577238,13.2),(22565,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22565,36.43,0.66,193,5876,70,NULL,NULL,'2MASX J02143393-4953404',NULL,'2014MNRAS.445.2677S',2014,1,0.85,NULL,'G',0.000129,NULL,'15.56',0.27,'Sa',NULL,NULL,NULL,NULL,1,33.6415833333,-49.89461,NULL,NULL,38248702062,597635969,9338062,15.56),(22566,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 08259','RN',22566,43.89,0.29,4140,5877,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 08259',0.446857,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22567,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 08259','RN',22567,44.1,0.38,4560,5877,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 08259',0.446857,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22568,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 01206','RN',22568,41.22,0.17,1200,5878,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01206',0.462299,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22569,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 01568','RN',22569,41.15,0.17,1180,5879,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01568',0.43677,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22570,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 01568','RN',22570,41.84,0.09,1630,5879,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01568',0.43677,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22571,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22571,35.79,0.49,144,5880,75,NULL,'IR','MCG -01-06-078',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000037,NULL,'15.8b',0.15,NULL,NULL,NULL,NULL,NULL,1,33.649417,-7.31011,0.04,NULL,35151918442,549248725,8582011,15.8),(22572,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22572,35.8,0.51,145,5880,NULL,NULL,'Malmquist cor.','MCG -01-06-078',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22573,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22573,35.86,0.49,149,5880,NULL,NULL,NULL,'MCG -01-06-078',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22574,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22574,35.9,0.2,151,5880,74.4,NULL,NULL,'MCG -01-06-078',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22575,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22575,37.86,0.46,374,5881,70,NULL,NULL,'2MASX J02143763+0012406',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000086,NULL,'16.62',0.17,NULL,NULL,NULL,NULL,NULL,1,33.656917,0.21119,0.033,NULL,67058587265,1047790426,16371725,16.62),(22576,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22576,37.78,0.46,359,5882,70,NULL,NULL,'2MASX J02143898-1000354',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000101,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,33.6624583,-10.00997,0.096,NULL,35131282452,548926288,8576973,17.3),(22577,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 15226','R',22577,40.53,0.24,990,5883,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15226',0.2881,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',0.0003,NULL,'22.1g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,33.663375,0.69644,0.049,NULL,67058626919,1047791045,16371735,22.1),(22578,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 15226','R',22578,40.62,0.2,1030,5883,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15226',0.2881,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22579,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 15226',NULL,22579,40.21,0.15,1100,5883,70,NULL,'SALT 2','SDSS-II SN 15226',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22580,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 15226',NULL,22580,40.24,0.15,1120,5883,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15226',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22581,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 15226',NULL,22581,40.46,0.2,1240,5883,70,NULL,'SN photometric redshift distance, z photo =0.346 +/- 0.042','SDSS-II SN 15226',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22582,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22582,35.42,0.54,121,5884,70,NULL,NULL,'2MASX J02144196-1241401',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.41',0.29,NULL,NULL,NULL,NULL,NULL,1,33.6747917,-12.69467,0,NULL,35049618077,547650282,8557035,16.41),(22583,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 00936','RN',22583,41.03,0.19,1340,5885,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 00936',0.197488,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22584,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 00936','RN',22584,41.65,0.23,1780,5885,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 00936',0.197488,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22585,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 16943','RN',22585,41.83,0.19,1720,5886,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 16943',0.348549,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22586,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 16943','RN',22586,41.89,0.11,1770,5886,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 16943',0.348549,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22587,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 13500','RN',22587,41.35,0.23,1580,5887,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13500',0.176961,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22588,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 13500','RN',22588,41.94,0.26,2080,5887,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13500',0.176961,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22589,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22589,34.23,0.8,70.3,5888,75,NULL,'W91PP, r','UGC 01726',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.00002,NULL,'14.62',0.4,'Sbc',NULL,NULL,NULL,NULL,1,33.71075,31.47058,0.265,NULL,68642899651,1072545307,16758520,14.62),(22590,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22590,34.02,0.38,63.7,5888,75,NULL,'W91PP, r, raw','UGC 01726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22591,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22591,34.12,0.38,66.8,5888,75,NULL,'W91PP, r, inv','UGC 01726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22592,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22592,34.13,0.38,67.1,5888,75,NULL,'W91PP, r, cor','UGC 01726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22593,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22593,34.17,0.11,68.4,5888,NULL,NULL,NULL,'UGC 01726',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22594,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22594,34.19,0.43,68.9,5888,75,NULL,'3.6 micron, color corrected','UGC 01726',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22595,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22595,34.19,0.43,69,5888,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01726',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22596,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22596,34.24,0.2,70.5,5888,74.4,NULL,NULL,'UGC 01726',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22597,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22597,34.42,0.49,76.5,5888,75,NULL,'IR','UGC 01726',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22598,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 11603','RN',22598,40.24,0.19,947,5889,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 11603',0.177285,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22599,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 11603','RN',22599,40.73,0.24,1190,5889,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 11603',0.177285,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22600,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22600,37.81,0.46,365,5890,70,NULL,NULL,'2MASX J02145481-0007418',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000082,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,33.728375,-0.12831,0.029,NULL,35131506287,548929785,8577027,17.5),(22601,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 12625','RN',22601,41.31,0.6,1660,5891,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 12625',0.100182,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22602,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22602,37.98,0.33,394,5892,70,NULL,NULL,'2MASX J02145534-0036498',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00007,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,33.7304583333,-0.61381,0.029,NULL,35131673648,548932400,8577068,18.2),(22603,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22603,36.5,0.75,199,5893,70,NULL,NULL,'2MASX J02145558-2451174',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'16.20',0.45,'S0','Group member, 3rd ranked galaxy',NULL,NULL,NULL,1,33.7315833333,-24.85478,0,NULL,38394974806,599921481,9373773,16.2),(22604,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22604,31.61,0.8,21,5894,75,NULL,'MAT, I','ESO 544- G 030',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000003,NULL,'13.33',1.3,'SB(s)dm pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,33.738625,-20.21178,0,NULL,37972926206,593326971,9270733,13.33),(22605,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22605,30.19,0.32,10.9,5894,85,NULL,'I, inv','ESO 544- G 030',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22606,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22606,30.23,0.32,11.1,5894,85,NULL,'I, raw','ESO 544- G 030',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22607,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22607,30.52,0.43,12.7,5894,75,NULL,'MAT, I, inv','ESO 544- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22608,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22608,30.63,0.43,13.4,5894,75,NULL,'MAT, I, raw','ESO 544- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22609,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22609,30.72,0.4,13.9,5894,NULL,NULL,NULL,'ESO 544- G 030',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22610,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22610,30.72,0.4,13.9,5894,73,NULL,'opt','ESO 544- G 030',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22611,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22611,30.99,0.43,15.8,5894,75,NULL,'MAT, I, cor','ESO 544- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22612,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22612,31.49,0.07,19.9,5894,NULL,NULL,NULL,'ESO 544- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22613,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2006kw',NULL,22613,39.35,0.07,743,5895,70,NULL,'Hubble residual 0.07 for z0.18500','SDSS J021457.90+003609.8',NULL,'2011ApJ...740...92G',2011,1,0.11,NULL,'G',0.0005,NULL,'19.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,33.7412917,0.60272,0.049,NULL,67058648575,1047791383,16371740,19.4),(22614,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 15421','R',22614,39.9,0.18,806,5895,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006kw','SDSS J021457.90+003609.8',0.185,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22615,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 15421','R',22615,40.03,0.09,856,5895,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006kw','SDSS J021457.90+003609.8',0.185,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22616,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2006kw',NULL,22616,39.76,0.07,895,5895,70,NULL,'SALT 2','SDSS J021457.90+003609.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22617,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2006kw',NULL,22617,39.77,0.07,899,5895,70,NULL,'SALT 2, Malmquist cor.','SDSS J021457.90+003609.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22618,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22618,37.98,0.33,394,5896,70,NULL,NULL,'SDSS J021501.41-003514.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000085,NULL,'18.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,33.755875,-0.58731,0.029,NULL,35131672758,548932386,8577068,18.5),(22619,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 08160',NULL,22619,40.27,0.32,1130,5897,70,NULL,NULL,'SDSS-II SN 08160',NULL,'2013MNRAS.434.1443X',2013,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,33.7650833333,-1.10039,0.037,NULL,35132104312,548939129,8577173,NULL),(22620,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 08160','R',22620,41.24,0.32,1260,5897,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 08160',0.408152,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22621,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 08160','R',22621,41.24,0.32,1260,5897,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 08160',0.408152,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22622,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 08160',NULL,22622,41.09,0.22,1650,5897,70,NULL,'SALT 2','SDSS-II SN 08160',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22623,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 08160',NULL,22623,41.16,0.22,1710,5897,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 08160',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22624,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22624,33.54,0.8,51.1,5898,75,NULL,'W91PP, r','UGC 01729',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.00002,NULL,'15.12',0.9,'SAB(s)cd',NULL,NULL,NULL,NULL,1,33.7675,32.72486,0.285,NULL,68624221742,1072253464,16753960,15.12),(22625,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22625,33.76,0.38,56.4,5898,75,NULL,'W91PP, r, inv','UGC 01729',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22626,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22626,33.81,0.38,57.8,5898,75,NULL,'W91PP, r, raw','UGC 01729',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22627,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22627,33.91,0.16,60.7,5898,NULL,NULL,NULL,'UGC 01729',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22628,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22628,34,0.38,63.1,5898,75,NULL,'W91PP, r, cor','UGC 01729',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22629,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22629,34.11,0.2,66.4,5898,74.4,NULL,NULL,'UGC 01729',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22630,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2006ot',NULL,22630,35.94,0.18,147,5899,74.2,NULL,'SALT 2','ESO 544- G 031',0.0522,'2010ApJ...716..712A',2010,1,1.1,NULL,'G',0.00015,NULL,'15.43',0.4,'Sa',NULL,NULL,NULL,NULL,1,33.769167,-20.76769,0,NULL,37973047899,593328873,9270763,15.43),(22631,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2006ot',NULL,22631,36.52,0.1,201,5899,74.4,NULL,NULL,'ESO 544- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22632,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2006ot',NULL,22632,36.85,0.09,212,5899,72,NULL,NULL,'ESO 544- G 031',0.05219,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22633,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SN 2006ot',NULL,22633,36.83,0.13,221,5899,73.8,NULL,'SALT 2 (SNANA)','ESO 544- G 031',0.0524,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22634,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22634,36.75,0.51,223,5899,70,NULL,NULL,'ESO 544- G 031',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22635,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22635,38.01,0.46,400,5900,70,NULL,NULL,'SDSS J021505.53+002143.5',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000082,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,33.7730417,0.36208,0.033,NULL,67058550411,1047789850,16371716,17.6),(22636,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22636,36.63,0.52,212,5901,70,NULL,NULL,'2MASX J02150793-6420402',NULL,'2014MNRAS.445.2677S',2014,1,0.69,NULL,'G',0.00015,NULL,'16.54',0.3,NULL,NULL,NULL,NULL,NULL,1,33.783167,-64.3445,0.025,NULL,36476403872,569943810,8905372,16.54),(22637,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 08260','RN',22637,39.99,0.28,784,5902,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 08260',0.268327,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22638,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 08260','RN',22638,41.33,0.23,1460,5902,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 08260',0.268327,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22639,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 15818','RN',22639,42.12,0.32,1970,5903,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15818',0.35072,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22640,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 15818','RN',22640,43.01,0.32,2970,5903,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15818',0.35072,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22641,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22641,36.21,0.46,174,5904,70,NULL,NULL,'2MASX J02152034-0004501',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000091,NULL,'16.7g',0.22,'NLAGN',NULL,NULL,NULL,NULL,1,33.8347083,-0.08058,0.029,NULL,34913399789,545521871,8523779,16.7),(22642,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22642,33.64,0.8,53.4,5905,75,NULL,'W91PP, r','UGC 01733',NULL,'1997ApJS..109..333W',1997,1,1.79,NULL,'G',0.000006,NULL,'15.48',0.11,'Sd','Isolated galaxy',NULL,NULL,NULL,1,33.835917,22.00611,0.269,NULL,68058890352,1063420161,16615940,15.48),(22643,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22643,33.65,0.49,53.6,5905,75,NULL,'IR','UGC 01733',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22644,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22644,33.88,0.2,59.7,5905,74.4,NULL,NULL,'UGC 01733',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22645,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22645,33.93,0.38,61.1,5905,75,NULL,'W91PP, r, raw','UGC 01733',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22646,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22646,33.94,0.38,61.2,5905,75,NULL,'W91PP, r, inv','UGC 01733',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22647,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22647,34.03,0.36,64,5905,NULL,NULL,NULL,'UGC 01733',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22648,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22648,34.05,NULL,64.5,5905,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01733',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22649,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22649,34.06,NULL,64.8,5905,NULL,NULL,'Dipole + Quadrupole','UGC 01733',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22650,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22650,34.07,NULL,65.1,5905,NULL,NULL,'Dipole','UGC 01733',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22651,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22651,34.09,0.38,65.7,5905,75,NULL,'W91PP, r, cor','UGC 01733',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22652,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22652,34.12,NULL,66.6,5905,NULL,NULL,NULL,'UGC 01733',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22653,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22653,34.15,0.34,67.5,5905,NULL,NULL,'Malmquist cor.','UGC 01733',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22654,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22654,35.04,0.49,102,5906,75,NULL,'IR','UGC 01732',NULL,'2011yCatp016004901K',2011,1,1.09,NULL,'G',0.000017,NULL,'16.5',0.09,'Scd',NULL,NULL,NULL,NULL,1,33.845083,18.67689,0.377,NULL,68110805925,1064231342,16628614,16.5),(22655,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22655,35.5,NULL,126,5906,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01732',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22656,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22656,35.51,NULL,127,5906,NULL,NULL,'Dipole + Quadrupole','UGC 01732',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22657,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22657,35.53,NULL,128,5906,NULL,NULL,'Dipole','UGC 01732',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22658,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22658,35.54,NULL,128,5906,NULL,NULL,NULL,'UGC 01732',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22659,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22659,33.64,0.8,53.5,5907,75,NULL,'MAT, I','NGC 0872',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.51',0.8,'SB(s)c?',NULL,NULL,NULL,NULL,1,33.855125,-17.78106,0.017,NULL,37958135198,593095862,9267122,14.51),(22660,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22660,32.95,0.32,38.9,5907,85,NULL,'I, raw','NGC 0872',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22661,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22661,32.97,0.32,39.3,5907,85,NULL,'I, inv','NGC 0872',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22662,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22662,33.16,0.43,42.8,5907,75,NULL,'MAT, I, raw','NGC 0872',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22663,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22663,33.3,0.43,45.6,5907,75,NULL,'MAT, I, inv','NGC 0872',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22664,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22664,33.5,0.43,50.2,5907,75,NULL,'MAT, I, cor','NGC 0872',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22665,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22665,33.77,0.2,56.8,5907,74.4,NULL,NULL,'NGC 0872',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22666,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22666,33.89,0.36,59.9,5907,NULL,NULL,NULL,'NGC 0872',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22667,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22667,33.89,0.4,60,5907,NULL,NULL,'mean','NGC 0872',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22668,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22668,33.96,0.35,62.1,5907,NULL,NULL,'Malmquist cor.','NGC 0872',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22669,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22669,34.05,0.47,64.6,5907,NULL,NULL,'H','NGC 0872',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22670,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22670,34.14,0.46,67.2,5907,NULL,NULL,'J','NGC 0872',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22671,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22671,34.21,0.45,69.6,5907,NULL,NULL,'K','NGC 0872',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22672,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22672,30.85,0.4,14.8,5908,NULL,NULL,NULL,'NGC 0864',NULL,'2009AJ....138..323T',2009,1,4.7,NULL,'G',0.000004,NULL,'11.4',3.5,'SAB(rs)c','Isolated galaxy',NULL,NULL,NULL,1,33.865167,6.00261,0.133,NULL,67063203043,1047862547,16372852,11.4),(22673,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22673,30.85,0.4,14.8,5908,73,NULL,'opt','NGC 0864',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22674,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22674,31.42,0.47,19.2,5908,NULL,NULL,'H','NGC 0864',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22675,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22675,31.44,0.46,19.4,5908,NULL,NULL,'J','NGC 0864',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22676,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22676,31.45,0.45,19.5,5908,NULL,NULL,'K','NGC 0864',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22677,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22677,31.48,0.4,19.7,5908,NULL,NULL,'mean','NGC 0864',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22678,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22678,31.51,0.4,20,5908,75,NULL,'B','NGC 0864',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22679,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22679,37.58,0.46,328,5909,70,NULL,NULL,'2MASX J02152927-0110381',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000083,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,33.8719166667,-1.17714,0.033,NULL,35132259217,548941550,8577211,17.3),(22680,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 04711','RN',22680,41.17,0.44,1450,5910,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04711',0.180794,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22681,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 04711','RN',22681,44.58,0.94,6980,5910,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04711',0.180794,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22682,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 20719',NULL,22682,40.76,0.21,1420,5911,70,NULL,'SN photometric redshift distance, z photo =0.410 +/- 0.055','SDSS-II SN 20719',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','20.8g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,33.87425,-0.08456,0.029,NULL,34913440963,545522515,8523789,20.8),(22683,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 20719','R',22683,41.95,0.31,1790,5911,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20719',0.373119,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22684,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 20719','R',22684,42.01,0.3,1840,5911,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20719',0.373119,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22685,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 20719',NULL,22685,41.75,0.21,2240,5911,70,NULL,'SALT 2','SDSS-II SN 20719',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22686,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 20719',NULL,22686,41.81,0.21,2300,5911,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20719',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22687,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22687,35.52,0.2,127,5912,74.4,NULL,NULL,'CGCG 438-044',NULL,'2013AJ....146...86T',2013,1,0.63,NULL,'G',0.000066,NULL,'15.6g',0.36,'Sa',NULL,NULL,NULL,NULL,1,33.874583,13.85922,0.305,NULL,66942643390,1045978802,16343418,15.6),(22688,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22688,36.28,0.46,180,5913,70,NULL,NULL,'2MASX J02153098-0913033',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000075,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,33.879083,-9.21764,0.029,NULL,35127847901,548872623,8576134,16.5),(22689,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22689,36.07,0.59,164,5914,70,NULL,NULL,'2MASX J02153756-5952331',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'16.51',0.31,NULL,NULL,NULL,NULL,NULL,1,33.9063333333,-59.87592,0.105,NULL,36145929740,564780152,8824689,16.51),(22690,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 09633','R',22690,40.11,0.21,878,5915,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 09633',0.195643,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,33.9182917,1.09528,0.101,NULL,67058957319,1047796208,16371815,NULL),(22691,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 09633','R',22691,40.24,0.27,936,5915,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 09633',0.195643,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22692,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 18262','RN',22692,40.7,0.26,1210,5916,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18262',0.13827,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22693,'SNIa SDSS','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 18262','RN',22693,41.25,0.28,1560,5916,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18262',0.13827,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22694,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22694,34.11,0.8,66.5,5917,75,NULL,'W91PP, r','UGC 01739',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000017,NULL,'14.98',0.3,'S?',NULL,NULL,NULL,NULL,1,33.9337083,25.20658,0.173,NULL,68590233351,1071722396,16745662,14.98),(22695,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22695,33.88,0.2,59.7,5917,74.4,NULL,NULL,'UGC 01739',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22696,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22696,33.95,0.39,61.6,5917,NULL,NULL,NULL,'UGC 01739',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22697,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22697,33.97,0.38,62.4,5917,75,NULL,'W91PP, r, inv','UGC 01739',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22698,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22698,33.98,0.38,62.6,5917,75,NULL,'W91PP, r, raw','UGC 01739',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22699,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22699,34.12,0.38,66.7,5917,75,NULL,'W91PP, r, cor','UGC 01739',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22700,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22700,34.15,0.35,67.8,5917,NULL,NULL,'Malmquist cor.','UGC 01739',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22701,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22701,34.84,0.49,93,5918,70,NULL,NULL,'MCG -02-06-045',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.000123,NULL,'15.5',0.25,NULL,NULL,NULL,NULL,NULL,1,33.9485417,-13.82369,0,NULL,35050452990,547663327,8557239,15.5),(22702,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 16432','RN',22702,41.48,0.3,1410,5919,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16432',0.399981,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22703,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 16432','RN',22703,41.58,0.32,1480,5919,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16432',0.399981,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22704,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 16432','N',22704,41.44,0.2,1940,5919,70,NULL,'SALT 2','SDSS-II SN 16432',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22705,'SNIa','2016-12-15 15:13:51','2016-12-16 11:18:54','1','SDSS-II SN 16432','N',22705,41.51,0.2,2000,5919,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16432',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22706,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22706,37.39,0.57,300,5920,70,NULL,NULL,'2MASX J02154875-1541478',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'17.15',0.25,NULL,NULL,NULL,NULL,NULL,1,33.953125,-15.69656,0.033,NULL,37956572336,593071442,9266741,17.15),(22707,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22707,33.22,0.8,44,5921,75,NULL,'MAT, I','IC 1788',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.000026,NULL,'12.34',1.1,'SB(s)bc?       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,33.958167,-31.201,NULL,NULL,38446485386,600726334,9386348,12.34),(22708,'Sosies','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22708,33.36,0.07,47,5921,NULL,NULL,NULL,'IC 1788',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22709,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22709,33.34,0.4,46.5,5921,NULL,NULL,'mean','IC 1788',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22710,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22710,33.36,0.45,47.1,5921,NULL,NULL,'K','IC 1788',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22711,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22711,33.37,0.46,47.1,5921,NULL,NULL,'J','IC 1788',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22712,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22712,33.37,0.47,47.3,5921,NULL,NULL,'H','IC 1788',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22713,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22713,33.45,0.43,49.1,5921,75,NULL,'MAT, I, raw','IC 1788',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22714,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22714,33.49,0.32,50,5921,85,NULL,'I, raw','IC 1788',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22715,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22715,33.56,0.32,51.6,5921,85,NULL,'I, inv','IC 1788',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22716,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22716,33.75,0.43,56.2,5921,75,NULL,'MAT, I, inv','IC 1788',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22717,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22717,33.82,0.43,58,5921,75,NULL,'MAT, I, cor','IC 1788',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22718,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22718,34.09,0.3,65.9,5921,NULL,NULL,NULL,'IC 1788',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22719,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22719,34.13,0.2,67,5921,74.4,NULL,NULL,'IC 1788',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22720,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22720,34.14,0.29,67.4,5921,NULL,NULL,'Malmquist cor.','IC 1788',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22721,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22721,35.19,0.8,109,5922,75,NULL,'W91PP, r','NGC 0861',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000017,NULL,'14.63',0.5,'Sb',NULL,NULL,NULL,NULL,1,33.963083,35.91358,0.245,NULL,68634083318,1072407551,16756367,14.63),(22722,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22722,34.89,0.38,95,5922,75,NULL,'W91PP, r, raw','NGC 0861',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22723,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22723,35.03,0.49,101,5922,75,NULL,'IR','NGC 0861',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22724,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22724,35.06,0.47,103,5922,NULL,NULL,'H','NGC 0861',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22725,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22725,35.08,0.38,104,5922,75,NULL,'W91PP, r, cor','NGC 0861',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22726,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22726,35.14,0.38,107,5922,75,NULL,'W91PP, r, inv','NGC 0861',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22727,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22727,35.22,0.45,110,5922,NULL,NULL,'K','NGC 0861',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22728,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22728,35.24,0.46,112,5922,NULL,NULL,'J','NGC 0861',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22729,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22729,35.27,0.4,113,5922,NULL,NULL,'mean','NGC 0861',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22730,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22730,34.97,0.48,98.4,5923,70,NULL,NULL,'MCG -03-06-021',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000147,NULL,'15.16',0.25,'S',NULL,NULL,NULL,NULL,1,33.96525,-18.91428,0.041,NULL,37974604028,593353187,9271143,15.16),(22731,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22731,34.31,0.37,72.9,5924,NULL,NULL,NULL,'UGC 01738',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.00003,NULL,'15.48',0.2,'Scd:','Pair member (points to parent)',NULL,NULL,NULL,1,33.975583,42.82389,0.405,NULL,67814921247,1059608144,16556377,15.48),(22732,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22732,34.38,0.36,75,5924,NULL,NULL,'Malmquist cor.','UGC 01738',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22733,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22733,34.39,0.49,75.5,5924,75,NULL,'IR','UGC 01738',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22734,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22734,34.46,0.2,78,5924,74.4,NULL,NULL,'UGC 01738',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22735,'FP','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22735,35.96,0.65,155,5925,70,NULL,NULL,'2MASX J02160617-6306173',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'16.02',0.38,'(R)SB0^+:',NULL,NULL,NULL,NULL,1,34.025583,-63.10478,0.025,NULL,36257625964,566525405,8851959,16.02),(22736,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22736,31.55,0.43,20.5,5926,75,NULL,'3.6 micron, color + selection bias corrected','IC 0217',NULL,'2014MNRAS.444..527S',2014,1,2.2,NULL,'G',0.000007,NULL,'14.99',0.4,'Scd? sp        HII',NULL,NULL,NULL,NULL,1,34.0435,-11.92672,0,NULL,35117791266,548715488,8573679,14.99),(22737,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22737,31.61,0.43,21,5926,75,NULL,'3.6 micron, color corrected','IC 0217',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22738,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22738,31.65,0.2,21.4,5926,74.4,NULL,NULL,'IC 0217',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22739,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22739,31.66,0.4,21.5,5926,73,NULL,'IR','IC 0217',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22740,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22740,31.67,0.4,21.5,5926,75,NULL,NULL,'IC 0217',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22741,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22741,31.86,0.39,23.6,5926,73,NULL,'opt','IC 0217',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22742,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22742,31.87,0.53,23.7,5926,NULL,NULL,NULL,'IC 0217',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22743,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22743,31.97,0.51,24.7,5926,NULL,NULL,'Malmquist cor.','IC 0217',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22744,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22744,32.03,0.4,25.5,5926,NULL,NULL,'mean','IC 0217',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22745,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22745,32.09,0.49,26.2,5926,75,NULL,'IR','IC 0217',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22746,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22746,32.29,0.46,28.8,5926,NULL,NULL,'J','IC 0217',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22747,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22747,32.37,0.47,29.7,5926,NULL,NULL,'H','IC 0217',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22748,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22748,32.41,0.45,30.3,5926,NULL,NULL,'K','IC 0217',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22749,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22749,33.86,0.8,59.1,5927,75,NULL,'W91PP, r','IC 1784',NULL,'1997ApJS..109..333W',1997,1,1.7,'Position in 1991PNAOJ...2...37T is incorrect.','G',0.00002,NULL,'14.00',1,'SA(rs)bc pec:','Pair member (points to parent)',NULL,NULL,NULL,1,34.0532917,32.6495,0.269,NULL,68624313147,1072254892,16753982,14),(22750,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22750,34.1,0.4,66,5927,NULL,NULL,'mean','IC 1784',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22751,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22751,34.21,0.1,69.6,5927,NULL,NULL,NULL,'IC 1784',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22752,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22752,34.66,0.47,85.4,5927,NULL,NULL,'H','IC 1784',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22753,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22753,34.67,0.38,86,5927,75,NULL,'W91PP, r, raw','IC 1784',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22754,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22754,34.7,0.46,87.1,5927,NULL,NULL,'J','IC 1784',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22755,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22755,34.73,0.45,88.1,5927,NULL,NULL,'K','IC 1784',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22756,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22756,34.82,0.38,92,5927,75,NULL,'W91PP, r, cor','IC 1784',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22757,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22757,34.93,0.38,96.8,5927,75,NULL,'W91PP, r, inv','IC 1784',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22758,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22758,34.95,0.2,97.7,5927,74.4,NULL,NULL,'IC 1784',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22759,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,'R',22759,35.14,0.49,107,5928,75,NULL,'IR','UGC 01749',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000017,NULL,'15.44',0.3,'Sab',NULL,NULL,NULL,NULL,1,34.0599583333,18.31097,0.365,NULL,68075969053,1063687016,16620109,15.44),(22760,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22760,35.37,0.4,119,5928,NULL,NULL,'mean','UGC 01749',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22761,'Tully-Fisher','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22761,35.63,0.47,134,5928,NULL,NULL,'H','UGC 01749',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22762,'IRAS','2016-12-15 15:13:51','2016-12-16 11:18:54','1',NULL,NULL,22762,32.69,0.8,34.6,5929,75,NULL,'W91PP, r','NGC 0865',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000023,NULL,'14.09',0.4,'S?',NULL,NULL,NULL,NULL,1,34.0629583333,28.59972,0.241,NULL,68648239333,1072628739,16759824,14.09),(22763,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,'R',22763,32.02,0.4,25.4,5929,75,NULL,NULL,'NGC 0865',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22764,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22764,32.02,0.4,25.4,5929,73,NULL,'IR','NGC 0865',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22765,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22765,32.38,0.43,29.9,5929,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0865',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22766,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22766,32.49,0.43,31.5,5929,75,NULL,'3.6 micron, color corrected','NGC 0865',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22767,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22767,32.59,0.2,33,5929,74.4,NULL,NULL,'NGC 0865',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22768,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22768,32.69,0.49,34.5,5929,NULL,NULL,NULL,'NGC 0865',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22769,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22769,32.7,0.38,34.7,5929,75,NULL,'W91PP, r, raw','NGC 0865',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22770,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22770,32.7,0.49,34.7,5929,NULL,NULL,'Malmquist cor.','NGC 0865',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22771,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22771,32.72,0.46,35.1,5929,NULL,NULL,'J','NGC 0865',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22772,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22772,32.73,0.38,35.2,5929,75,NULL,'W91PP, r, inv','NGC 0865',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22773,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,'R',22773,32.75,0.49,35.4,5929,75,NULL,'IR','NGC 0865',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22774,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22774,32.75,0.47,35.5,5929,NULL,NULL,'H','NGC 0865',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22775,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22775,32.82,0.45,36.7,5929,NULL,NULL,'K','NGC 0865',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22776,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22776,32.83,0.4,36.9,5929,NULL,NULL,'mean','NGC 0865',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22777,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22777,33.13,0.38,42.3,5929,75,NULL,'W91PP, r, cor','NGC 0865',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22778,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 13501','RN',22778,40.09,0.14,951,5930,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13501',0.096194,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22779,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 13501','RN',22779,40.69,0.35,1250,5930,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13501',0.096194,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22780,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 09634','RN',22780,42.73,0.44,2880,5931,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 09634',0.219259,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22781,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 09634','RN',22781,43,0.43,3260,5931,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 09634',0.219259,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22782,'IRAS','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22782,35.3,0.8,115,5932,75,NULL,'W91PP, r','UGC 01750',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.00002,NULL,'14.55',0.5,'Sab',NULL,NULL,NULL,NULL,1,34.097333,31.99947,0.269,NULL,68642091399,1072532678,16758323,14.55),(22783,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22783,34.83,0.38,92.5,5932,75,NULL,'W91PP, r, raw','UGC 01750',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22784,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22784,34.99,0.38,99.7,5932,75,NULL,'W91PP, r, inv','UGC 01750',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22785,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22785,35.09,0.38,104,5932,75,NULL,'W91PP, r, cor','UGC 01750',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22786,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 18054','RN',22786,41.56,0.43,1430,5933,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18054',0.437059,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22787,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 18054','RN',22787,42.37,0.51,2080,5933,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18054',0.437059,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22788,'FP','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22788,35.28,0.46,114,5934,70,NULL,NULL,'2MASX J02162596-5956270',NULL,'2014MNRAS.445.2677S',2014,1,1.07,NULL,'G',0.000133,NULL,'14.6b',0.93,'E',NULL,NULL,NULL,NULL,1,34.1082083333,-59.94086,0.105,NULL,36145943645,564780369,8824693,14.6),(22789,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 05017','RN',22789,43.99,0.26,4060,5935,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05017',0.550151,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22790,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22790,32.27,0.43,28.5,5936,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01753',NULL,'2014MNRAS.444..527S',2014,1,1.1,NULL,'G',0.00002,NULL,'15.05',0.4,'Im:',NULL,NULL,NULL,NULL,1,34.132375,28.20353,0.229,NULL,68646981626,1072609087,16759516,15.05),(22791,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 15902','R',22791,39.99,0.22,785,5937,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15902',0.26526,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,'PHOT','20.7g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,34.1415,-0.46556,0.033,NULL,34914338253,545536535,8524008,20.7),(22792,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 15902','R',22792,40.51,0.3,1000,5937,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15902',0.26526,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22793,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 15902',NULL,22793,40.62,0.97,1330,5937,70,NULL,'SN photometric redshift distance, z photo =0.379 +/- 0.321','SDSS-II SN 15902',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22794,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 19625','R',22794,41.32,0.24,1410,5938,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2007pn','SN 2007pn',0.304942,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia?',NULL,NULL,NULL,NULL,1,34.14125,-0.72236,0.057,NULL,34914331895,545536435,8524006,NULL),(22795,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 19625','R',22795,41.55,0.21,1560,5938,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2007pn','SN 2007pn',0.304942,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22796,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 14258','N',22796,41.83,0.16,2320,5939,70,NULL,'SALT 2','SDSS-II SN 14258',NULL,'2013ApJ...763...88C',2013,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22797,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 14258','N',22797,42.02,0.16,2540,5939,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14258',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22798,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 20428','RN',22798,39.91,0.2,856,5940,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 20428',0.12219,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22799,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 20428','RN',22799,40.33,0.11,1040,5940,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 20428',0.12219,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22800,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 04757',NULL,22800,40.98,0.19,1570,5941,70,NULL,'SN photometric redshift distance, z photo =0.470 +/- 0.058','SDSS-II SN 04757',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,34.1467083,-1.01575,0.041,NULL,34913904529,545529758,8523902,NULL),(22801,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 04757','R',22801,41.82,0.33,1610,5941,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 04757',0.436471,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22802,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 04757','R',22802,41.97,0.33,1720,5941,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 04757',0.436471,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22803,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SN 2006lq',NULL,22803,40.25,0.15,1120,5942,70,NULL,'Hubble residual -0.05 for z0.31620','SDSS J021635.88-000918.5',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,34.1496666667,-0.15528,0.037,NULL,34913539028,545524047,8523813,NULL),(22804,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 15383','R',22804,41.08,0.25,1250,5942,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006lq','SDSS J021635.88-000918.5',0.3162,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22805,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 15383','R',22805,41.18,0.18,1310,5942,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006lq','SDSS J021635.88-000918.5',0.3162,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22806,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SN 2006lq',NULL,22806,41.08,0.14,1640,5942,70,NULL,'SALT 2','SDSS J021635.88-000918.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22807,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SN 2006lq',NULL,22807,41.12,0.14,1670,5942,70,NULL,'SALT 2, Malmquist cor.','SDSS J021635.88-000918.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22808,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 18389',NULL,22808,39.45,0.25,776,5943,70,NULL,NULL,'SDSS-II SN 18389',NULL,'2013MNRAS.434.1443X',2013,1,0.1,NULL,'G',NULL,'PHOT','19.9g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,34.150125,0.22967,0.049,NULL,66874069565,1044907336,16326677,19.9),(22809,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 18389','R',22809,40,0.21,804,5943,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18389',0.244902,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22810,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 18389','R',22810,40.21,0.25,886,5943,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18389',0.244902,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22811,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 18389',NULL,22811,40.43,0.12,1220,5943,70,NULL,'SN photometric redshift distance, z photo =0.341 +/- 0.023','SDSS-II SN 18389',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22812,'FP','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,'R',22812,37.24,0.46,280,5944,70,NULL,NULL,'2MASX J02164553-0729189',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000107,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,34.18975,-7.48869,0.009,NULL,35119408445,548740756,8574074,17.3),(22813,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 18104','RN',22813,43.36,0.52,3290,5945,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18104',0.428842,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22814,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 18104','RN',22814,43.83,0.64,4080,5945,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18104',0.428842,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22815,'FP','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22815,36.54,0.54,203,5946,70,NULL,NULL,'MCG -01-06-079',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'15.6b',0.45,NULL,NULL,NULL,NULL,NULL,1,34.2157917,-3.19286,0.017,NULL,35145133409,549142709,8580354,15.6),(22816,'FP','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22816,37.51,0.58,318,5947,70,NULL,NULL,'2MASX J02165833-1738210',NULL,'2014MNRAS.445.2677S',2014,1,0.28,NULL,'G',0.00015,NULL,'16.53',0.2,NULL,NULL,NULL,NULL,NULL,1,34.242917,-17.63925,0.05,NULL,37957994320,593093661,9267088,16.53),(22817,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22817,35.14,0.77,107,5948,NULL,NULL,'Malmquist cor.','UGC 01754',NULL,'2009ApJS..182..474S',2009,1,0.78,NULL,'G',0.000018,NULL,'15.6',0.22,'SBbc?',NULL,NULL,NULL,NULL,1,34.259,30.9435,0.293,NULL,68650755942,1072668061,16760438,15.6),(22818,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22818,35.26,0.73,113,5948,NULL,NULL,NULL,'UGC 01754',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22819,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22819,35.46,0.2,124,5948,74.4,NULL,NULL,'UGC 01754',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22820,'FP','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,'R',22820,33.96,0.46,62.1,5949,70,NULL,NULL,'NGC 0867',NULL,'2015arXiv151105856S',2015,1,1.11,NULL,'G',0.000037,NULL,'13.7g',1,'S0+:','Pair member (points to parent)',NULL,NULL,NULL,1,34.269917,1.24419,0.109,NULL,66877420773,1044959699,16327495,13.7),(22821,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SN 2005ey',NULL,22821,38.18,0.03,383,5950,70,NULL,'SDSS-II SN 02308','SDSS J021705.61+001650.8',0.13,'2011ApJS..192....1C',2011,1,0.11,NULL,'G',NULL,NULL,'19.9g',0.09,NULL,NULL,NULL,NULL,NULL,1,34.273417,0.28081,0.049,NULL,66874940027,1044920937,16326889,19.9),(22822,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SN 2005ey',NULL,22822,38.58,0.11,460,5950,74.2,NULL,'SALT 2','SDSS J021705.61+001650.8',0.13,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22823,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 02308','R',22823,39.31,0.2,643,5950,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ey','SDSS J021705.61+001650.8',0.13,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22824,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SN 2005ey',NULL,22824,39.35,0.06,655,5950,65,NULL,'MLCS2k2','SDSS J021705.61+001650.8',0.13,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22825,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SN 2005ey',NULL,22825,39.36,0.07,658,5950,65,NULL,'SALT2','SDSS J021705.61+001650.8',0.13,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22826,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SN 2005ey',NULL,22826,39.36,0.12,659,5950,70,NULL,'SDSS-II SN 02308, SALT 2','SDSS J021705.61+001650.8',0.13,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22827,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 02308','R',22827,39.62,0.09,744,5950,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ey','SDSS J021705.61+001650.8',0.13,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22828,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SN 2005jd',NULL,22828,40.3,0.14,870,5951,74.2,NULL,'SALT 2','SDSS J021706.08+003203.5',0.32,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,34.275333,0.53431,0.049,NULL,66875022529,1044922227,16326909,NULL),(22829,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SN 2005jd',NULL,22829,40.5,0.04,955,5951,70,NULL,'SDSS-II SN 06649','SDSS J021706.08+003203.5',0.32,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22830,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SN 2005jd',NULL,22830,40.26,0.13,1130,5951,70,NULL,'Hubble residual -0.02 for z0.31400','SDSS J021706.08+003203.5',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22831,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SN 2005jd',NULL,22831,41.03,0.13,1220,5951,65,NULL,'SALT2','SDSS J021706.08+003203.5',0.32,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22832,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 06649','R',22832,41.04,0.23,1220,5951,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005jd','SDSS J021706.08+003203.5',0.32,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22833,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SN 2005jd',NULL,22833,41.06,0.16,1230,5951,70,NULL,'SDSS-II SN 06649, SALT 2','SDSS J021706.08+003203.5',0.32,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22834,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 06649','R',22834,41.17,0.14,1300,5951,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005jd','SDSS J021706.08+003203.5',0.32,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22835,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SN 2005jd',NULL,22835,41.19,0.11,1310,5951,65,NULL,'MLCS2k2','SDSS J021706.08+003203.5',0.32,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22836,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 17647',NULL,22836,39.97,0.15,985,5952,70,NULL,'SN photometric redshift distance, z photo =0.264 +/- 0.022','SDSS-II SN 17647',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,34.2820416667,-0.80164,0.041,NULL,34913734237,545527097,8523860,NULL),(22837,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 17647',NULL,22837,40.7,0.12,1380,5952,70,NULL,'SALT 2','SDSS-II SN 17647',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22838,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 17647','R',22838,41.49,0.24,1380,5952,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17647',0.434,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22839,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 17647',NULL,22839,40.72,0.12,1390,5952,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 17647',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22840,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 17647','R',22840,41.75,0.16,1560,5952,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17647',0.434,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22841,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22841,32.6,0.56,33.1,5953,NULL,NULL,'Malmquist cor.','NGC 0871',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000003,NULL,'14.2',0.5,'SB(s)c:','Pair member, wide',NULL,NULL,NULL,1,34.2947083333,14.54783,0.289,NULL,66942326219,1045973847,16343341,14.2),(22842,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22842,32.68,0.2,34.4,5953,74.4,NULL,NULL,'NGC 0871',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22843,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22843,32.78,0.52,36,5953,NULL,NULL,NULL,'NGC 0871',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22844,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22844,33.09,0.47,41.5,5953,NULL,NULL,'H','NGC 0871',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22845,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22845,33.14,0.46,42.6,5953,NULL,NULL,'J','NGC 0871',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22846,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22846,33.17,0.45,43.1,5953,NULL,NULL,'K','NGC 0871',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22847,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22847,33.5,0.4,50.2,5953,NULL,NULL,'mean','NGC 0871',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22848,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22848,35.48,NULL,125,5954,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0271',NULL,'2010Ap&SS.325..163P',2010,1,0.78,NULL,'G',0.000011,NULL,'16.83',0.08,'Sd',NULL,NULL,NULL,NULL,1,34.3,8.09028,0.209,NULL,67087857607,1048247775,16378871,16.83),(22849,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22849,35.51,NULL,126,5954,NULL,NULL,'Dipole + Quadrupole','FGC 0271',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22850,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22850,35.52,NULL,127,5954,NULL,NULL,'Dipole','FGC 0271',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22851,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22851,35.57,NULL,130,5954,NULL,NULL,NULL,'FGC 0271',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22852,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 09370','RN',22852,43.01,0.33,2900,5955,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 09370',0.378322,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22853,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 09370','RN',22853,43.02,0.35,2910,5955,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 09370',0.378322,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22854,'FP','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,'R',22854,36.82,0.46,231,5956,70,NULL,NULL,'2MASX J02172262-0738096',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000094,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,34.344375,-7.63597,0.029,NULL,35122733142,548792705,8574886,16.7),(22855,'FP','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22855,35.67,0.47,136,5957,70,NULL,NULL,'NGC 0888',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000133,NULL,'14.43',0.9,'E1: pec','in a pair',NULL,NULL,'Flat-Spectrum Radio Source',1,34.362917,-59.86106,0.105,NULL,36145970764,564780793,8824699,14.43),(22856,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 20886','RN',22856,41.76,0.38,1510,5958,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 20886',0.490074,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22857,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 20886','N',22857,41.76,0.33,2250,5958,70,NULL,'SALT 2','SDSS-II SN 20886',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22858,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 20886','N',22858,41.89,0.33,2390,5958,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20886',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22859,'FP','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22859,35.21,0.47,110,5959,70,NULL,NULL,'ESO 053- G 003',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000107,NULL,'15.13',0.26,'S0',NULL,NULL,NULL,NULL,1,34.3814166667,-69.90342,0.009,NULL,36330389693,567662338,8869724,15.13),(22860,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 19405','RN',22860,43.19,0.32,3230,5960,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 19405',0.343746,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22861,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 19405','RN',22861,43.38,0.29,3530,5960,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19405',0.343746,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22862,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,'R',22862,33.75,0.49,56.3,5961,75,NULL,'IR','MCG -02-06-050',NULL,'2011yCatp016004901K',2011,1,1.22,NULL,'G',0.00005,NULL,'15',0.17,'Sdm',NULL,NULL,NULL,NULL,1,34.38625,-11.51886,0.014,NULL,35117657153,548713393,8573646,15),(22863,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22863,34.39,NULL,75.6,5961,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -02-06-050',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22864,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22864,34.4,NULL,76,5961,NULL,NULL,'Dipole + Quadrupole','MCG -02-06-050',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22865,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22865,34.42,NULL,76.4,5961,NULL,NULL,'Dipole','MCG -02-06-050',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22866,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22866,34.47,NULL,78.3,5961,NULL,NULL,NULL,'MCG -02-06-050',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22867,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 16543','RN',22867,41.39,0.23,1470,5962,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 16543',0.289376,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22868,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 16543','RN',22868,41.87,0.36,1840,5962,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 16543',0.289376,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22869,'FP','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,'R',22869,35.93,0.46,154,5963,70,NULL,NULL,'CGCG 387-068',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00011,NULL,'15.2g',0.57,'E0',NULL,NULL,NULL,NULL,1,34.399167,-0.49358,0.045,NULL,34914413239,545537706,8524026,15.2),(22870,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,'R',22870,35.29,0.49,114,5964,75,NULL,'IR','ESO 544- G 033',NULL,'2011yCatp016004901K',2011,1,1.18,NULL,'G',0.00003,NULL,'16.55',0.11,'Scd',NULL,NULL,NULL,NULL,1,34.3999166667,-21.76383,0,NULL,37977519953,593398749,9271855,16.55),(22871,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 06395','RN',22871,41.2,0.39,1590,5965,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06395',0.095446,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22872,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 06395','RN',22872,42.08,0.38,2370,5965,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06395',0.095446,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22873,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 17958','R',22873,41.02,0.23,1250,5966,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17958',0.275974,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,34.4349583,-0.713,0.057,NULL,34914229605,545534837,8523981,NULL),(22874,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 17958','R',22874,41.2,0.18,1360,5966,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17958',0.275974,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22875,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SN UDS10Wil','N',22875,45.54,0.39,4400,5967,71.6,NULL,'SALT 2','SN UDS10Wil',1.914,'2013ApJ...768..166J',2013,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22876,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22876,32.6,NULL,33.1,5968,NULL,NULL,'Dipole + Quadrupole + Octopole','KUG 0215-070',NULL,'2010Ap&SS.325..163P',2010,1,1.34,'Matthews (2000A&AS..143..421M) detects another feature at v=7100 km/sec.','G',0.00004,NULL,'15.5',0.16,'Sdm',NULL,NULL,NULL,NULL,1,34.4517917,-6.83231,0.013,NULL,35118976851,548734013,8573968,15.5),(22877,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22877,32.63,NULL,33.5,5968,NULL,NULL,'Dipole + Quadrupole','KUG 0215-070',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22878,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22878,32.64,NULL,33.8,5968,NULL,NULL,'Dipole','KUG 0215-070',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22879,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22879,32.72,NULL,34.9,5968,NULL,NULL,NULL,'KUG 0215-070',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22880,'FP','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,'R',22880,38.06,0.33,410,5969,70,NULL,NULL,'2MASX J02175005-0840026',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000073,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,34.4585,-8.66747,0.164,NULL,35122166639,548783853,8574747,18.2),(22881,'IRAS','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22881,33.85,0.8,58.8,5970,75,NULL,'W91PP, r','IC 1789',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.00002,NULL,'14.63',0.4,'Sa:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,34.46325,32.39603,0.297,NULL,68624093297,1072251457,16753929,14.63),(22882,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22882,33.87,0.38,59.4,5970,75,NULL,'W91PP, r, raw','IC 1789',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22883,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22883,33.97,0.45,62.3,5970,NULL,NULL,'K','IC 1789',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22884,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22884,34,0.47,63.2,5970,NULL,NULL,'H','IC 1789',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22885,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22885,34.03,0.38,64.1,5970,75,NULL,'W91PP, r, cor','IC 1789',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22886,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22886,34.05,0.38,64.7,5970,75,NULL,'W91PP, r, inv','IC 1789',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22887,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,'R',22887,34.07,0.49,65.2,5970,75,NULL,'IR','IC 1789',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22888,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22888,34.09,0.4,65.7,5970,NULL,NULL,'mean','IC 1789',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22889,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22889,34.11,0.46,66.3,5970,NULL,NULL,'J','IC 1789',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22890,'GRB','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,'R',22890,46.46,0.79,5700,5971,NULL,NULL,NULL,'XRF 050406',2.44,'2008AIPC.1065..367L',2008,1,NULL,NULL,'VisS',NULL,NULL,'19.4R',NULL,'Swift',NULL,NULL,NULL,NULL,1,34.4675,-50.18772,0,NULL,38248842157,597638158,9338096,19.4),(22891,'GRB','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,'R',22891,47.87,0.77,10900,5971,72,NULL,NULL,'XRF 050406',2.44,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22892,'GRB','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22892,47.92,0.78,11200,5971,70,NULL,NULL,'XRF 050406',2.44,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22893,'GRB','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22893,48.03,0.7,11700,5971,69.7,NULL,'Calibrated','XRF 050406',2.44,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22894,'GRB','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22894,48.44,0.72,14200,5971,69.7,NULL,'Fiducial','XRF 050406',2.44,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22895,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22895,33.59,0.4,52.2,5972,NULL,NULL,'mean','NGC 0876',NULL,'2007A&A...465...71T',2007,1,2.1,NULL,'G',0.000057,NULL,'16.5',0.4,'SAc: sp','in a pair',NULL,NULL,NULL,1,34.472125,14.52128,0.301,NULL,68067331580,1063552055,16618000,16.5),(22896,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22896,34.02,0.45,63.8,5972,NULL,NULL,'K','NGC 0876',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22897,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22897,34.12,0.47,66.7,5972,NULL,NULL,'H','NGC 0876',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22898,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22898,34.8,0.49,91.2,5972,NULL,NULL,NULL,'NGC 0876',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22899,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22899,34.83,0.48,92.6,5972,NULL,NULL,'Malmquist cor.','NGC 0876',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22900,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22900,32.78,0.98,36,5973,NULL,NULL,'Malmquist cor.','ESO 355- G 004',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'14.08',0.9,'SB(s)b pec     HII',NULL,NULL,NULL,NULL,1,34.4789166667,-34.80325,NULL,NULL,38419811006,600309546,9379836,14.08),(22901,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22901,33,0.88,39.9,5973,NULL,NULL,NULL,'ESO 355- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22902,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22902,33.19,0.59,43.4,5974,NULL,NULL,NULL,'ESO 030- G 014',NULL,'2009ApJS..182..474S',2009,1,1.6,NULL,'G',0.000033,NULL,'14.09',1.2,'SA(s)c',NULL,NULL,NULL,NULL,1,34.483875,-76.08125,0.241,NULL,35641493185,556898331,8701536,14.09),(22903,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22903,33.52,0.51,50.5,5974,NULL,NULL,'Malmquist cor.','ESO 030- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22904,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,'R',22904,33.96,NULL,61.9,5974,NULL,NULL,'I','ESO 030- G 014',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22905,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,'R',22905,34.11,0.54,66.4,5974,NULL,NULL,'B, Hubble-type-TF','ESO 030- G 014',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22906,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,'R',22906,34.11,NULL,66.4,5974,NULL,NULL,'B, Hubble-type-TF','ESO 030- G 014',NULL,'2005Ap&SS.299..405R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22907,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,'R',22907,34.11,0.54,66.4,5974,NULL,NULL,'B, Hubble-type-TF','ESO 030- G 014',NULL,'2005Ap&SS.299..387R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22908,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,'R',22908,34.12,NULL,66.7,5974,NULL,NULL,'B','ESO 030- G 014',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22909,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,'R',22909,34.12,NULL,66.7,5974,NULL,NULL,'I','ESO 030- G 014',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22910,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,'R',22910,34.12,NULL,66.7,5974,NULL,NULL,'B','ESO 030- G 014',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22911,'FP','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22911,36.6,0.58,209,5975,70,NULL,NULL,'2MASX J02175624-0418370',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.31',0.38,NULL,NULL,NULL,NULL,NULL,1,34.484375,-4.31033,0.013,NULL,35141691241,549088925,8579514,16.31),(22912,'FP','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,'R',22912,36.91,0.46,241,5976,70,NULL,NULL,'2MASX J02175665-0910456',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00009,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,34.4860417,-9.17942,0.095,NULL,35129869127,548904205,8576628,17.3),(22913,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22913,33.35,0.78,46.8,5977,NULL,NULL,'Malmquist cor.','NGC 0877',NULL,'2009ApJS..182..474S',2009,1,2.4,NULL,'G',0.00001,NULL,'12.58',1.8,'SAB(rs)bc      LIRG','Pair member, wide',NULL,NULL,NULL,1,34.4985,14.54406,0.301,NULL,68067331259,1063552050,16618000,12.58),(22914,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22914,33.52,0.72,50.6,5977,NULL,NULL,NULL,'NGC 0877',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22915,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22915,33.62,0.4,52.9,5977,NULL,NULL,'mean','NGC 0877',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22916,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22916,33.67,0.2,54.2,5977,74.4,NULL,NULL,'NGC 0877',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22917,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22917,33.68,0.47,54.3,5977,NULL,NULL,'H','NGC 0877',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22918,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22918,33.7,0.45,54.9,5977,NULL,NULL,'K','NGC 0877',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22919,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22919,33.72,0.46,55.5,5977,NULL,NULL,'J','NGC 0877',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22920,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22920,34.57,0.43,82,5978,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 504-050',NULL,'2014MNRAS.444..527S',2014,1,0.8,NULL,'G',0.000033,NULL,'15.4',0.4,'Sa',NULL,NULL,NULL,NULL,1,34.5014583,31.88181,0.261,NULL,68642030340,1072531724,16758308,15.4),(22921,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22921,34.8,0.43,91.4,5978,75,NULL,'3.6 micron, color corrected','CGCG 504-050',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22922,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22922,35.07,0.2,103,5978,74.4,NULL,NULL,'CGCG 504-050',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22923,'FP','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,'R',22923,38.06,0.33,410,5979,70,NULL,NULL,'2MASX J02180050-0845566',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000099,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,34.502083,-8.76578,0.164,NULL,35121690684,548776416,8574631,17.8),(22924,'FP','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22924,35.48,0.5,125,5980,70,NULL,NULL,'ESO 198- G 002',NULL,'2014MNRAS.445.2677S',2014,1,0.98,NULL,'G',0.000097,NULL,'14.72',0.58,'SAB0^0','Pair member (points to parent)',NULL,NULL,NULL,1,34.510083,-47.53719,NULL,NULL,38245743064,597589735,9337339,14.72),(22925,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22925,34.1,0.54,66,5981,NULL,NULL,NULL,'ESO 415- G 017',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.42',0.3,'Sb:',NULL,NULL,NULL,NULL,1,34.5105416667,-27.81831,0,NULL,38442692954,600667077,9385423,15.42),(22926,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22926,34.14,0.2,67.3,5981,74.4,NULL,NULL,'ESO 415- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22927,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,'R',22927,34.2,0.49,69.3,5981,75,NULL,'IR','ESO 415- G 017',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22928,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22928,34.32,0.49,73,5981,NULL,NULL,'Malmquist cor.','ESO 415- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22929,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 14750','R',22929,40.16,0.21,886,5982,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14750',0.2149,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,34.5189583,0.65297,0.101,NULL,66874780578,1044918446,16326850,NULL),(22930,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 14750','R',22930,40.27,0.13,930,5982,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14750',0.2149,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22931,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 06816',NULL,22931,39.98,0.32,992,5983,70,NULL,'SN photometric redshift distance, z photo =0.266 +/- 0.051','SDSS-II SN 06816',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','22.6g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,34.5204583,0.11228,0.073,NULL,66874387128,1044912298,16326754,22.6),(22932,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 06816','R',22932,41.28,0.27,1330,5983,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06816',0.353482,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22933,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 06816','R',22933,41.35,0.2,1380,5983,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06816',0.353482,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22934,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 06816',NULL,22934,41.18,0.16,1720,5983,70,NULL,'SALT 2','SDSS-II SN 06816',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22935,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 06816',NULL,22935,41.23,0.16,1760,5983,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 06816',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22936,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 20779','RN',22936,44.47,0.41,5400,5984,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20779',0.454774,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22937,'FP','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22937,35.9,0.51,151,5985,70,NULL,NULL,'2MASX J02181116-1424577',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'15.97',0.22,NULL,NULL,NULL,NULL,NULL,1,34.546667,-14.416,0.008,NULL,37951703394,592995365,9265552,15.97),(22938,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SN 2005ge',NULL,22938,39.3,0.12,609,5986,74.2,NULL,'SALT 2','SDSS J021814.55+004745.4',0.19,'2010ApJ...716..712A',2010,1,0.11,NULL,'G',NULL,NULL,'20.0g',0.07,NULL,NULL,NULL,NULL,NULL,1,34.560625,0.79597,0.101,NULL,66874642092,1044916282,16326816,20),(22939,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SN 2005ge',NULL,22939,39.75,0.18,748,5986,72,NULL,'SDSS 3331','SDSS J021814.55+004745.4',0.19,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22940,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SN 2005ge',NULL,22940,40,0.13,840,5986,70,NULL,'SDSS 3331, SALT 2','SDSS J021814.55+004745.4',0.19,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22941,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 03331','R',22941,40.03,0.2,854,5986,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2005ge','SDSS J021814.55+004745.4',0.19,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22942,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 03331','R',22942,40.21,0.14,925,5986,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2005ge','SDSS J021814.55+004745.4',0.19,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22943,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SN 2005ge',NULL,22943,39.9,0.09,955,5986,70,NULL,'SALT 2','SDSS J021814.55+004745.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22944,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SN 2005ge',NULL,22944,39.92,0.09,964,5986,70,NULL,'SALT 2, Malmquist cor.','SDSS J021814.55+004745.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22945,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SN 2005ge',NULL,22945,40.61,0.04,1110,5986,70,NULL,'SDSS 3331','SDSS J021814.55+004745.4',0.19,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22946,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 20276',NULL,22946,40.59,0.13,1310,5987,70,NULL,'SN photometric redshift distance, z photo =0.373 +/- 0.029','SDSS-II SN 20276',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,34.563125,-0.11414,0.069,NULL,34914035844,545531810,8523934,NULL),(22947,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 20276','R',22947,41.33,0.27,1370,5987,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20276',0.346981,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22948,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 20276','R',22948,41.45,0.21,1450,5987,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20276',0.346981,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22949,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 20276',NULL,22949,41.16,0.15,1710,5987,70,NULL,'SALT 2','SDSS-II SN 20276',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22950,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SDSS-II SN 20276',NULL,22950,41.2,0.15,1740,5987,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20276',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22951,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22951,32.08,0.2,26.1,5988,74.4,NULL,NULL,'UGC 01773',NULL,'2013AJ....146...86T',2013,1,1.79,NULL,'G',0.000048,NULL,'15.10',0.24,'SB?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,34.5632083,13.20439,0.297,NULL,66945265325,1046019770,16344058,15.1),(22952,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22952,32.58,NULL,32.9,5988,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01773',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22953,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22953,32.61,NULL,33.2,5988,NULL,NULL,'Dipole + Quadrupole','UGC 01773',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22954,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:54','1',NULL,NULL,22954,32.62,NULL,33.4,5988,NULL,NULL,'Dipole','UGC 01773',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22955,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SN 2002hu',NULL,22955,35.26,0.17,109,5989,74.2,NULL,'SALT 2','KUG 0215+372',0.03,'2010ApJ...716..712A',2010,1,0.4,NULL,'G',NULL,':','15.5',0.4,'Spiral',NULL,NULL,NULL,NULL,1,34.5764583,37.46433,0.201,NULL,68622399348,1072224989,16753515,15.5),(22956,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:54','1','SN 2002hu','R',22956,35.31,0.06,115,5989,NULL,NULL,'MLCS2k2, R(V) = 1.8','KUG 0215+372',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22957,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2002hu','R',22957,35.36,0.07,118,5989,NULL,NULL,'MLCS2k2, R(V) = 3.1','KUG 0215+372',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22958,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2002hu',NULL,22958,35.65,0.02,131,5989,70,NULL,'SALT 2','KUG 0215+372',0.03,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22959,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2002hu',NULL,22959,35.89,0.19,146,5989,72,NULL,NULL,'KUG 0215+372',0.03,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22960,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2002hu',NULL,22960,35.85,0.09,148,5989,74.4,NULL,NULL,'KUG 0215+372',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22961,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2002hu',NULL,22961,36.02,0.14,154,5989,73.8,NULL,'SALT 2 (SNANA)','KUG 0215+372',0.0381,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22962,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2002hu',NULL,22962,36.01,0.02,155,5989,72,NULL,'SALT','KUG 0215+372',0.03,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22963,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2002hu',NULL,22963,36.06,0.2,158,5989,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','KUG 0215+372',0.03,'2011A&A...526A..81B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22964,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2002hu',NULL,22964,36.07,0.15,159,5989,70,NULL,'SALT 2','KUG 0215+372',0.03,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22965,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2002hu',NULL,22965,36.04,0.2,161,5989,65,NULL,NULL,'KUG 0215+372',NULL,'2006MNRAS.366..682S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22966,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2002hu',NULL,22966,36.15,0.16,165,5989,65,NULL,'SALT','KUG 0215+372',0.03,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22967,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2002hu',NULL,22967,36.16,0.18,166,5989,65,NULL,'SALT2','KUG 0215+372',0.03,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22968,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2002hu',NULL,22968,36.23,0.13,171,5989,65,NULL,'MLCS17','KUG 0215+372',0.03,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22969,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2002hu',NULL,22969,36.29,0.13,176,5989,65,NULL,'MLCS31','KUG 0215+372',0.03,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22970,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,22970,36.6,0.61,209,5990,70,NULL,NULL,'2MASX J02182011-0631278',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.62',0.24,NULL,NULL,NULL,NULL,NULL,1,34.583667,-6.52447,0.013,NULL,35148429992,549194218,8581159,16.62),(22971,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 06275','R',22971,40.37,0.15,933,5991,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J021821.55+000147.8',0.2731,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',0.0005,NULL,'20.8g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,34.589833,0.02997,0.073,NULL,66874384056,1044912250,16326753,20.8),(22972,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 06275','R',22972,40.43,0.23,959,5991,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J021821.55+000147.8',0.2731,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22973,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 06275',NULL,22973,40.29,0.12,1140,5991,70,NULL,'SALT 2','SDSS J021821.55+000147.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22974,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 06275',NULL,22974,40.31,0.12,1150,5991,70,NULL,'SALT 2, Malmquist cor.','SDSS J021821.55+000147.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22975,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 02746','R',22975,40.21,0.09,983,5992,70,NULL,'SDSS CAND. SNIa?; MLCS2K2','SDSS-II SN 02746',0.11924,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,34.6047083,1.13358,0.101,NULL,66877474023,1044960531,16327508,NULL),(22976,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 02746','R',22976,40.44,0.19,1090,5992,70,NULL,'SDSS CAND. SNIa?; SALT 2','SDSS-II SN 02746',0.11924,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22977,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 14117','RN',22977,43,0.17,2380,5993,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 14117',0.671945,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22978,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',22978,37.7,0.46,347,5994,70,NULL,NULL,'2MASXi J0218257-083232',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000078,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,34.607583,-8.54239,0.131,NULL,35121667994,548776062,8574625,17.2),(22979,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',22979,38.1,0.46,417,5995,70,NULL,NULL,'2MASX J02182615-0810568',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000082,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,34.6089583,-8.18239,0.183,NULL,35122997576,548796837,8574950,18.1),(22980,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',22980,38.02,0.46,402,5996,70,NULL,NULL,'2MASXi J0218264-003250',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000079,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,34.610375,-0.54731,0.057,NULL,34914098951,545532796,8523949,17.7),(22981,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',22981,36.13,0.46,168,5997,70,NULL,NULL,'2MASX J02182661+0033029',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000075,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,34.610917,0.55092,0.073,NULL,66874371449,1044912053,16326750,17.1),(22982,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2006ka',NULL,22982,39.96,0.13,980,5998,70,NULL,'Hubble residual 0.11 for z0.24800','SDSS-II SN 15219 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,34.61075,0.22614,0.073,NULL,66874421197,1044912831,16326762,NULL),(22983,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 15219','R',22983,40.51,0.19,1020,5998,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ka','SDSS-II SN 15219 HOST',0.247421,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22984,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 15219','R',22984,40.83,0.12,1170,5998,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ka','SDSS-II SN 15219 HOST',0.247421,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22985,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2006ka',NULL,22985,40.45,0.09,1230,5998,70,NULL,'SALT 2','SDSS-II SN 15219 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22986,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2006ka',NULL,22986,40.47,0.09,1240,5998,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15219 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22987,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 15198',NULL,22987,40.13,0.11,1060,5999,70,NULL,'SN photometric redshift distance, z photo =0.288 +/- 0.018','SDSS-II SN 15198',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,34.627417,-0.21228,0.045,NULL,34913997122,545531205,8523925,NULL),(22988,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 15198','R',22988,40.85,0.19,1150,5999,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15198',0.289402,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22989,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 15198','R',22989,40.99,0.09,1220,5999,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15198',0.289402,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22990,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 15198',NULL,22990,40.72,0.08,1390,5999,70,NULL,'SALT 2','SDSS-II SN 15198',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22991,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 15198',NULL,22991,40.75,0.08,1410,5999,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15198',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22992,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 19825',NULL,22992,38.92,0.38,609,6000,70,NULL,'SN photometric redshift distance, z photo =0.154 +/- 0.033','SDSS-II SN 19825',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,34.6377917,0.88078,0.101,NULL,66877925219,1044967581,16327618,NULL),(22993,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 19825','R',22993,40.81,0.15,1050,6000,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19825',0.383011,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22994,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 19825','R',22994,40.91,0.22,1100,6000,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19825',0.383011,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22995,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 19825',NULL,22995,40.75,0.13,1410,6000,70,NULL,'SALT 2','SDSS-II SN 19825',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22996,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 19825',NULL,22996,40.8,0.13,1450,6000,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19825',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22997,'GRB','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',22997,44,0.46,2240,6001,73,NULL,'H const./H=100','GRB 000911',1.0585,'2006astro.ph..9262M',2006,1,NULL,NULL,'G',0.0001,NULL,'25.2R',NULL,'Sbrst',NULL,NULL,NULL,NULL,1,34.643167,7.74103,0.237,NULL,67087553690,1048243026,16378797,25.2),(22998,'GRB','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',22998,44.14,0.25,3270,6001,73,NULL,'H const./H=100','GRB 000911',1.0585,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(22999,'GRB','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,22999,44.21,0.68,3380,6001,69.7,NULL,'Fiducial','GRB 000911',1.0585,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23000,'GRB','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23000,44.27,0.67,3470,6001,69.7,NULL,'Calibrated','GRB 000911',1.0585,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23001,'GRB','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23001,44.94,0.68,4730,6001,72,NULL,NULL,'GRB 000911',1.0585,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23002,'GRB','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23002,45.1,0.68,5090,6001,70,NULL,NULL,'GRB 000911',1.0585,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23003,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23003,35.62,0.43,133,6002,NULL,NULL,'Malmquist cor.','ESO 478- G 023',NULL,'2009ApJS..182..474S',2009,1,1.3,'Da Costa, et al. (1998,AJ,116,1) give v = 10286 +/- 76 km/sec.','G',0.000033,NULL,'14.28',0.7,'Sb',NULL,NULL,NULL,NULL,1,34.6459166667,-25.75661,0,NULL,38395559170,599930612,9373915,14.28),(23004,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23004,35.77,0.4,143,6002,NULL,NULL,NULL,'ESO 478- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23005,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23005,35.81,0.2,145,6002,74.4,NULL,NULL,'ESO 478- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23006,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23006,36.24,0.85,177,6003,70,NULL,NULL,'ESO 115- G 004',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000093,NULL,'15.36',0.9,'SA(rs)bc',NULL,NULL,NULL,NULL,1,34.65375,-61.06153,0.089,NULL,36265970728,566655792,8853996,15.36),(23007,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 15422',NULL,23007,40.18,0.21,1090,6004,70,NULL,'SN photometric redshift distance, z photo =0.296 +/- 0.037','SDSS-II SN 15422',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.3g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,34.6552083,0.53147,0.073,NULL,66874372599,1044912071,16326751,21.3),(23008,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 15422','R',23008,41.72,0.25,1650,6004,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15422',0.334328,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23009,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 15422','R',23009,42.06,0.4,1930,6004,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15422',0.334328,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23010,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23010,34.73,0.47,88.3,6005,70,NULL,NULL,'IC 0219',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00013,NULL,'14.44',0.9,'E?',NULL,NULL,NULL,NULL,1,34.6617916667,-6.90333,0.017,NULL,35119872716,548748011,8574187,14.44),(23011,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23011,36.59,0.61,208,6006,70,NULL,NULL,'2MASX J02183898-1519082',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.56',0.38,NULL,NULL,NULL,NULL,NULL,1,34.662375,-15.31906,0.045,NULL,37964901763,593201590,9268774,16.56),(23012,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23012,36.21,0.52,175,6007,70,NULL,NULL,'2MASX J02184099-0637128',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'17.11',0.23,NULL,NULL,NULL,NULL,NULL,1,34.670833,-6.62031,0.013,NULL,35119015208,548734612,8573978,17.11),(23013,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 13214','RN',23013,41.52,0.19,1220,6008,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13214',0.650434,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23014,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 14147','RN',23014,41.42,0.11,1510,6009,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 14147',0.274528,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23015,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 14147','RN',23015,41.94,0.18,1910,6009,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 14147',0.274528,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23016,'IRAS','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23016,33.8,0.8,57.6,6010,75,NULL,'W91PP, r','UGC 01777',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'15.42',0.5,'SAB(s)cd',NULL,NULL,NULL,NULL,1,34.6839583,30.50233,0.305,NULL,68651737596,1072683399,16760678,15.42),(23017,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23017,34.22,0.2,69.8,6010,74.4,NULL,NULL,'UGC 01777',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23018,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23018,34.3,0.31,72.4,6010,NULL,NULL,'Malmquist cor.','UGC 01777',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23019,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23019,34.32,0.38,73,6010,75,NULL,'W91PP, r, inv','UGC 01777',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23020,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23020,34.37,0.38,74.9,6010,75,NULL,'W91PP, r, raw','UGC 01777',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23021,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23021,34.38,0.3,75.2,6010,NULL,NULL,NULL,'UGC 01777',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23022,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23022,34.41,0.38,76.1,6010,75,NULL,'W91PP, r, cor','UGC 01777',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23023,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 00908','RN',23023,41.99,0.19,1520,6011,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00908',0.649307,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23024,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23024,33.47,0.69,49.5,6012,100,NULL,'mid-IR','NGC 0881',NULL,'2013ApJ...771...88L',2013,1,2.2,NULL,'G',0.000023,NULL,'13.39',1.5,'SAB(r)c',NULL,NULL,NULL,NULL,1,34.688625,-6.63908,0.017,NULL,35119017634,548734650,8573978,13.39),(23025,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23025,33.71,0.45,55.2,6012,NULL,NULL,'K','NGC 0881',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23026,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23026,33.72,0.47,55.5,6012,NULL,NULL,'H','NGC 0881',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23027,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23027,33.73,0.46,55.8,6012,NULL,NULL,'J','NGC 0881',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23028,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23028,33.96,0.2,61.9,6012,74.4,NULL,NULL,'NGC 0881',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23029,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23029,34.01,0.35,63.3,6012,NULL,NULL,'Malmquist cor.','NGC 0881',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23030,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23030,34.03,0.35,64,6012,NULL,NULL,NULL,'NGC 0881',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23031,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23031,34.25,0.4,70.7,6012,NULL,NULL,'mean','NGC 0881',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23032,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23032,37.91,0.33,381,6013,70,NULL,NULL,'2MASX J02185152-0819131',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000089,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,34.7146666667,-8.32047,0.183,NULL,35122450337,548788286,8574816,17.8),(23033,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23033,37.52,0.46,319,6014,70,NULL,NULL,'2MASX J02185401-0805141',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000096,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,34.725125,-8.08717,0.045,NULL,35122491509,548788929,8574827,17.3),(23034,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23034,33.82,0.45,58,6015,NULL,NULL,NULL,'CGCG 438-054',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000167,NULL,'15.7',0.4,NULL,NULL,NULL,NULL,NULL,1,34.7325,15.15694,0.301,NULL,68067458760,1063554043,16618031,15.7),(23035,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23035,33.86,0.2,59.2,6015,74.4,NULL,NULL,'CGCG 438-054',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23036,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23036,33.99,0.42,62.7,6015,NULL,NULL,'Malmquist cor.','CGCG 438-054',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23037,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23037,35.38,0.2,119,6016,74.4,NULL,NULL,'UGC 01785',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',NULL,NULL,'16.0',0.7,'Sd',NULL,NULL,NULL,NULL,1,34.737917,4.815,0.129,NULL,66882673298,1045041770,16328777,16),(23038,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23038,35.77,0.78,143,6016,NULL,NULL,'Malmquist cor.','UGC 01785',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23039,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23039,35.79,0.78,144,6016,NULL,NULL,NULL,'UGC 01785',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23040,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23040,37.32,0.46,292,6017,70,NULL,NULL,'2MASXi J0219003-073040',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000073,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,34.7512917,-7.51106,0.033,NULL,35119627957,548744186,8574127,17.8),(23041,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2005ie',NULL,23041,40.06,0.13,803,6018,74.2,NULL,'SALT 2','SDSS J021902.35-001621.2',0.28,'2010ApJ...716..712A',2010,1,0.06,NULL,'G',0.0005,NULL,'20.8g',0.05,NULL,NULL,NULL,NULL,NULL,1,34.7597917,-0.27258,0.065,NULL,34914170817,545533919,8523967,20.8),(23042,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2005ie',NULL,23042,40.41,0.04,942,6018,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 05957, SN 2005ie','SDSS J021902.35-001621.2',0.28,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23043,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2005ie',NULL,23043,40.06,0.11,1030,6018,70,NULL,'Hubble residual -0.01 for z0.27960','SDSS J021902.35-001621.2',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23044,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2005ie',NULL,23044,40.76,0.11,1110,6018,65,NULL,'SALT2','SDSS J021902.35-001621.2',0.28,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23045,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 05957','R',23045,40.83,0.21,1150,6018,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ie','SDSS J021902.35-001621.2',0.2796,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23046,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2005ie',NULL,23046,40.88,0.14,1170,6018,70,NULL,'SALT 2','SDSS J021902.35-001621.2',0.28,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23047,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2005ie',NULL,23047,40.92,NULL,1190,6018,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 05957, SN 2005ie','SDSS J021902.35-001621.2',0.28,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23048,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2005ie',NULL,23048,40.94,0.11,1210,6018,65,NULL,'MLCS2k2','SDSS J021902.35-001621.2',0.28,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23049,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 05957','R',23049,40.99,0.13,1230,6018,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ie','SDSS J021902.35-001621.2',0.2796,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23050,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2005ie',NULL,23050,40.73,0.1,1400,6018,70,NULL,'SALT 2','SDSS J021902.35-001621.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23051,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2005ie',NULL,23051,40.75,0.1,1410,6018,70,NULL,'SALT 2, Malmquist cor.','SDSS J021902.35-001621.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23052,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 16004','RN',23052,40.26,0.09,837,6019,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16004',0.346743,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23053,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23053,34.26,0.46,71.2,6020,70,NULL,NULL,'NGC 0883',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000063,NULL,'13.50',1.3,'SA(s)0-:',NULL,NULL,NULL,NULL,1,34.7715833333,-6.79092,0.017,NULL,35119107167,548736049,8574000,13.5),(23054,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23054,34.32,0.4,73.2,6020,NULL,NULL,'mean','NGC 0883',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23055,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23055,34.75,0.45,89.1,6020,NULL,NULL,'K','NGC 0883',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23056,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23056,38.3,0.46,457,6021,70,NULL,NULL,'SDSS J021906.30-073201.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000078,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,34.77625,-7.53375,0.033,NULL,35119621187,548744081,8574126,18.4),(23057,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 17914','RN',23057,40.95,0.27,1200,6022,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 17914',0.294168,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23058,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 17914','RN',23058,41.33,0.26,1430,6022,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 17914',0.294168,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23059,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23059,34.62,0.4,83.8,6023,NULL,NULL,'mean','IC 0220',NULL,'2007A&A...465...71T',2007,1,0.8,NULL,'G',0.00004,NULL,'15.08',0.3,'Sbc',NULL,NULL,NULL,NULL,1,34.798875,-12.78164,0,NULL,35051464441,547679131,8557486,15.08),(23060,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23060,34.85,0.47,93.2,6023,NULL,NULL,'H','IC 0220',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23061,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2007ps',NULL,23061,39.88,0.13,944,6024,70,NULL,'Hubble residual 0.04 for z0.24600','SDSS J021913.44-002304.3',NULL,'2011ApJ...740...92G',2011,1,0.06,NULL,'G',0.005,NULL,'21.4g',0.04,NULL,NULL,NULL,NULL,NULL,1,34.806,-0.38456,0.057,NULL,34914059413,545532178,8523940,21.4),(23062,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 19990','R',23062,40.49,0.2,1010,6024,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ps','SDSS J021913.44-002304.3',0.246,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23063,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 19990','R',23063,40.69,0.13,1100,6024,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ps','SDSS J021913.44-002304.3',0.246,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23064,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2007ps',NULL,23064,40.34,0.11,1170,6024,70,NULL,'SALT 2','SDSS J021913.44-002304.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23065,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2007ps',NULL,23065,40.36,0.11,1180,6024,70,NULL,'SALT 2, Malmquist cor.','SDSS J021913.44-002304.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23066,'IRAS','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23066,31.6,0.8,20.9,6025,75,NULL,'MAT, I','ESO 545- G 002',NULL,'1997ApJS..109..333W',1997,1,2.2,'Da Costa, et al. (1998,AJ,116,1) give v = 14148 +/- 30 km/sec.','G',0.000007,NULL,'15.18',0.9,'SB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,34.813667,-18.93225,0.069,NULL,37974173415,593346459,9271038,15.18),(23067,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23067,31.11,0.32,16.7,6025,85,NULL,'I, inv','ESO 545- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23068,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23068,31.16,0.32,17.1,6025,85,NULL,'I, raw','ESO 545- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23069,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23069,31.48,0.09,19.8,6025,NULL,NULL,NULL,'ESO 545- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23070,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23070,31.49,0.2,19.9,6025,74.4,NULL,NULL,'ESO 545- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23071,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23071,31.52,0.4,20.1,6025,NULL,NULL,NULL,'ESO 545- G 002',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23072,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23072,31.52,0.39,20.1,6025,73,NULL,'opt','ESO 545- G 002',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23073,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23073,31.57,0.43,20.6,6025,75,NULL,'3.6 micron, color corrected','ESO 545- G 002',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23074,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23074,31.58,0.43,20.7,6025,75,NULL,'3.6 micron, color + selection bias corrected','ESO 545- G 002',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23075,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23075,31.65,0.43,21.3,6025,75,NULL,'MAT, I, inv','ESO 545- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23076,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23076,31.75,0.43,22.4,6025,75,NULL,'MAT, I, raw','ESO 545- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23077,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23077,31.88,0.43,23.8,6025,75,NULL,'MAT, I, cor','ESO 545- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23078,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23078,37.91,0.33,381,6026,70,NULL,NULL,'2MASX J02191598-0815417',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000119,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,34.8165417,-8.26164,0.105,NULL,35121344082,548771001,8574546,16.8),(23079,'CMD','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23079,17.72,NULL,0.035,6027,NULL,NULL,NULL,'SEGUE 2',NULL,'2015ApJ...811...35J',2015,1,6.8,NULL,'G',0.000008,NULL,'15.5V',5.8,NULL,NULL,NULL,NULL,NULL,1,34.816667,20.17528,0.365,1,68111579873,1064243435,16628803,15.5),(23080,'Horizontal Branch','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23080,17.68,0.16,0.0344,6027,NULL,NULL,'Fe/H = -2.257 dex','SEGUE 2',NULL,'2013AJ....146...94B',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23081,'Horizontal Branch','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23081,17.7,NULL,0.035,6027,NULL,NULL,NULL,'SEGUE 2',NULL,'2009MNRAS.397.1748B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23082,'RR Lyrae','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23082,17.82,0.14,0.0366,6027,NULL,NULL,'Fe/H = -2.16 dex','SEGUE 2',NULL,'2013AJ....146...94B',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23083,'RR Lyrae','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23083,17.88,0.15,0.0377,6027,NULL,NULL,'Fe/H = -2.44 dex','SEGUE 2',NULL,'2013AJ....146...94B',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23084,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23084,37.26,0.46,283,6028,70,NULL,NULL,'2MASX J02191806-0846277',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000079,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,34.825333,-8.77428,0.133,NULL,35121891621,548779556,8574680,17.5),(23085,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23085,38.18,0.46,433,6029,70,NULL,NULL,'2MASX J02192749-0745337',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000092,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,34.864667,-7.75947,0.041,NULL,35122560448,548790007,8574843,17.7),(23086,'IRAS','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23086,31.61,0.8,21,6030,75,NULL,'MAT, I','ESO 545- G 003',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00002,NULL,'15.25',0.26,'Sb-c',NULL,NULL,NULL,NULL,1,34.8712917,-21.43592,0,NULL,37980365466,593443210,9272550,15.25),(23087,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23087,30.41,0.32,12.1,6030,85,NULL,'I, inv','ESO 545- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23088,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23088,30.5,0.32,12.6,6030,85,NULL,'I, raw','ESO 545- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23089,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23089,30.93,0.43,15.3,6030,75,NULL,'MAT, I, inv','ESO 545- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23090,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23090,31.16,0.43,17.1,6030,75,NULL,'MAT, I, raw','ESO 545- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23091,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23091,31.42,0.43,19.2,6030,75,NULL,'MAT, I, cor','ESO 545- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23092,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23092,31.44,0.08,19.4,6030,NULL,NULL,NULL,'ESO 545- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23093,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23093,31.79,0.43,22.8,6030,75,NULL,'3.6 micron, color + selection bias corrected','ESO 545- G 003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23094,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23094,31.82,0.4,23.1,6030,75,NULL,NULL,'ESO 545- G 003',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23095,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23095,31.82,0.39,23.1,6030,73,NULL,'IR','ESO 545- G 003',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23096,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23096,31.83,0.2,23.2,6030,74.4,NULL,NULL,'ESO 545- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23097,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23097,31.85,0.43,23.5,6030,75,NULL,'3.6 micron, color corrected','ESO 545- G 003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23098,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23098,31.95,0.4,24.5,6030,NULL,NULL,NULL,'ESO 545- G 003',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23099,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23099,32.4,0.49,30.2,6030,75,NULL,'IR','ESO 545- G 003',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23100,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23100,35.34,0.48,117,6031,70,NULL,NULL,'2MASX J02193177-2252001',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.0001,NULL,'15.06',0.55,'S0',NULL,NULL,NULL,NULL,1,34.8823333333,-22.86675,0,NULL,37977820581,593403446,9271928,15.06),(23101,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23101,33.73,0.47,55.6,6032,NULL,NULL,'H','NGC 0887',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.00002,NULL,'13.50',1.5,'SAB(rs)c',NULL,NULL,NULL,NULL,1,34.885875,-16.06972,0.15,NULL,37965679092,593213735,9268964,13.5),(23102,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23102,33.81,0.46,57.8,6032,NULL,NULL,'J','NGC 0887',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23103,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23103,33.82,0.45,58.1,6032,NULL,NULL,'K','NGC 0887',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23104,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23104,33.89,0.4,60.1,6032,NULL,NULL,'mean','NGC 0887',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23105,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23105,34.02,0.63,63.7,6032,NULL,NULL,'Malmquist cor.','NGC 0887',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23106,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23106,34.23,0.57,70,6032,NULL,NULL,NULL,'NGC 0887',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23107,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23107,34.27,0.2,71.5,6032,74.4,NULL,NULL,'NGC 0887',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23108,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','PS1 SN PS10byq','N',23108,40.19,0.19,901,6033,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10byq HOST',0.2092,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23109,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23109,33.38,0.69,47.3,6034,100,NULL,'mid-IR','ESO 298- G 028',NULL,'2013ApJ...771...88L',2013,1,2.8,NULL,'G',0.00002,NULL,'13.67',1.3,'SA(rs)b',NULL,NULL,NULL,NULL,1,34.9067083,-37.81878,NULL,NULL,38406768368,600105755,9376652,13.67),(23110,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23110,34.24,0.4,70.4,6034,NULL,NULL,'mean','ESO 298- G 028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23111,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23111,34.44,0.46,77.1,6034,NULL,NULL,'J','ESO 298- G 028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23112,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23112,34.49,0.47,79.2,6034,NULL,NULL,'H','ESO 298- G 028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23113,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23113,34.51,0.45,79.8,6034,NULL,NULL,'K','ESO 298- G 028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23114,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23114,35.14,0.49,107,6035,75,NULL,'IR','UGC 01787',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000027,NULL,'14.63',0.4,'Sdm:','Group member',NULL,NULL,NULL,1,34.9100417,37.93597,0.201,NULL,68622249895,1072222654,16753478,14.63),(23115,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23115,36.39,0.71,190,6036,70,NULL,NULL,'2MASX J02194222-1014147',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'16.12',0.28,NULL,NULL,NULL,NULL,NULL,1,34.925875,-10.23742,0.043,NULL,35116207708,548690745,8573292,16.12),(23116,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23116,35.18,0.52,108,6037,70,NULL,NULL,'2MASX J02194494-0650597',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'16.19',0.42,NULL,NULL,NULL,NULL,NULL,1,34.937333,-6.84992,0.017,NULL,35119091932,548735811,8573997,16.19),(23117,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23117,36.33,0.59,185,6038,70,NULL,NULL,'2MASX J02194615-0539186',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.50',0.32,NULL,NULL,NULL,NULL,NULL,1,34.942375,-5.65536,0.005,NULL,34917796762,545590574,8524852,16.5),(23118,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 13486','RN',23118,40.44,0.28,1010,6039,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13486',0.215185,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23119,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 13486','RN',23119,40.47,0.23,1020,6039,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13486',0.215185,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23120,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23120,34.63,NULL,84.5,6040,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0277',NULL,'2010Ap&SS.325..163P',2010,1,0.9,NULL,'G',0.000037,NULL,'17.0',0.08,'Sd',NULL,NULL,NULL,NULL,1,34.952917,18.98389,0.377,NULL,68109146038,1064205406,16628209,17),(23121,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23121,34.64,NULL,84.8,6040,NULL,NULL,'Dipole + Quadrupole','FGC 0277',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23122,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23122,34.64,NULL,84.9,6040,NULL,NULL,NULL,'FGC 0277',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23123,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23123,34.65,NULL,85.1,6040,NULL,NULL,'Dipole','FGC 0277',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23124,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23124,35.25,0.46,112,6041,70,NULL,NULL,'2MASX J02195177-0431546',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.00015,NULL,'15.26',0.69,NULL,NULL,NULL,NULL,NULL,1,34.9657917,-4.53189,0.041,NULL,34921008172,545640752,8525636,15.26),(23125,'IRAS','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23125,34.03,0.8,63.9,6042,75,NULL,'W91PP, r','UGC 01792',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'13.98',1.2,'SAB(r)c',NULL,NULL,NULL,NULL,1,34.969667,29.03625,0.309,NULL,68648454481,1072632101,16759876,13.98),(23126,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23126,33.03,0.69,40.3,6042,100,NULL,'mid-IR','UGC 01792',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23127,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23127,34.07,0.38,65.1,6042,75,NULL,'W91PP, r, raw','UGC 01792',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23128,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23128,34.16,0.38,68.1,6042,75,NULL,'W91PP, r, cor','UGC 01792',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23129,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23129,34.22,0.4,69.8,6042,NULL,NULL,'mean','UGC 01792',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23130,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23130,34.25,0.38,70.9,6042,75,NULL,'W91PP, r, inv','UGC 01792',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23131,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23131,34.33,0.29,73.5,6042,NULL,NULL,'Malmquist cor.','UGC 01792',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23132,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23132,34.44,0.2,77.3,6042,74.4,NULL,NULL,'UGC 01792',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23133,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23133,34.51,0.27,79.9,6042,NULL,NULL,NULL,'UGC 01792',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23134,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23134,34.58,0.47,82.5,6042,NULL,NULL,'H','UGC 01792',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23135,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23135,34.61,0.45,83.5,6042,NULL,NULL,'K','UGC 01792',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23136,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23136,34.63,0.46,84.4,6042,NULL,NULL,'J','UGC 01792',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23137,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23137,38.58,0.46,520,6043,70,NULL,NULL,'SDSS J021954.88+011508.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000079,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,34.978667,1.25231,0.093,NULL,66877224910,1044956639,16327447,18.6),(23138,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','PS1 SN PS10ahk','N',23138,42.02,0.17,1770,6044,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10ahk HOST',0.4302,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23139,'IRAS','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23139,34.5,0.8,79.4,6045,75,NULL,'MAT, I','NGC 0893',NULL,'1997ApJS..109..333W',1997,1,1.3,'1996ApJS..107...97M has z = 0.020247 +- 0.000033.','G',0.00004,NULL,'13.55',1,'SA(s)c pec:',NULL,NULL,NULL,NULL,1,34.9940833333,-41.40314,NULL,NULL,38487223710,601362870,9396294,13.55),(23140,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23140,34.11,0.43,66.3,6045,75,NULL,'MAT, I, raw','NGC 0893',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23141,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23141,34.23,0.34,70.2,6045,NULL,NULL,NULL,'NGC 0893',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23142,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23142,34.27,0.2,71.5,6045,74.4,NULL,NULL,'NGC 0893',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23143,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23143,34.29,0.33,72.2,6045,NULL,NULL,'Malmquist cor.','NGC 0893',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23144,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23144,34.33,0.43,73.5,6045,75,NULL,'MAT, I, cor','NGC 0893',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23145,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23145,34.35,0.32,74.1,6045,85,NULL,'I, raw','NGC 0893',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23146,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23146,34.41,0.43,76.3,6045,75,NULL,'MAT, I, inv','NGC 0893',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23147,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23147,34.43,0.32,76.8,6045,85,NULL,'I, inv','NGC 0893',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23148,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23148,35.09,0.38,104,6046,NULL,NULL,'Malmquist cor.','2MFGC 01811',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.0001,NULL,'17.2O',0.2,NULL,NULL,NULL,NULL,NULL,1,34.999417,8.17908,0.229,NULL,67085423420,1048209740,16378277,17.2),(23149,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23149,35.23,0.36,111,6046,NULL,NULL,NULL,'2MFGC 01811',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23150,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23150,35.34,0.2,117,6046,74.4,NULL,NULL,'2MFGC 01811',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23151,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23151,35.49,0.49,125,6046,75,NULL,'IR','2MFGC 01811',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23152,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 06831','R',23152,40.34,0.16,964,6047,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06831',0.211453,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,35.01125,0.72147,0.081,NULL,66877738874,1044964669,16327572,NULL),(23153,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 06831','R',23153,40.62,0.26,1100,6047,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06831',0.211453,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23154,'IRAS','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23154,32.39,0.8,30.1,6048,75,NULL,'MAT, I','ESO 545- G 005',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000013,NULL,'13.79',0.8,'Im pec sp      HII',NULL,NULL,NULL,NULL,1,35.0254583,-19.75072,0.019,NULL,37973675006,593338671,9270916,13.79),(23155,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23155,32.07,0.32,26,6048,85,NULL,'I, raw','ESO 545- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23156,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23156,32.08,0.32,26.1,6048,85,NULL,'I, inv','ESO 545- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23157,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23157,32.3,0.43,28.8,6048,75,NULL,'3.6 micron, color + selection bias corrected','ESO 545- G 005',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23158,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23158,32.35,0.43,29.6,6048,75,NULL,'3.6 micron, color corrected','ESO 545- G 005',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23159,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23159,32.36,0.43,29.7,6048,75,NULL,'MAT, I, raw','ESO 545- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23160,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23160,32.4,0.4,30.2,6048,NULL,NULL,NULL,'ESO 545- G 005',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23161,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23161,32.4,0.39,30.2,6048,73,NULL,'opt','ESO 545- G 005',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23162,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23162,32.4,0.39,30.2,6048,73,NULL,'opt','ESO 545- G 005',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23163,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23163,32.44,0.2,30.8,6048,74.4,NULL,NULL,'ESO 545- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23164,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23164,32.44,0.43,30.8,6048,75,NULL,'MAT, I, inv','ESO 545- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23165,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23165,32.49,0.46,31.5,6048,NULL,NULL,'Malmquist cor.','ESO 545- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23166,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23166,32.54,0.43,32.2,6048,75,NULL,'MAT, I, cor','ESO 545- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23167,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23167,32.63,0.43,33.6,6048,NULL,NULL,NULL,'ESO 545- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23168,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23168,32.98,0.49,39.5,6048,75,NULL,'IR','ESO 545- G 005',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23169,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23169,35.14,0.56,107,6049,NULL,NULL,'Malmquist cor.','ESO 115- G 005',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.31',0.8,'SA(s)c:',NULL,NULL,NULL,NULL,1,35.064917,-58.70822,0.033,NULL,36159979621,564999681,8828120,15.31),(23170,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23170,35.31,0.52,115,6049,NULL,NULL,NULL,'ESO 115- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23171,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23171,35.35,0.2,117,6049,74.4,NULL,NULL,'ESO 115- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23172,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 04808','R',23172,40.83,0.24,1090,6050,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 04808',0.34916,'2014arXiv1401.3317S',2014,1,0.12,NULL,'G',NULL,'PHOT','21.9g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,35.0705833333,0.41181,0.065,NULL,66877891322,1044967051,16327610,21.9),(23173,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 04808','R',23173,41.14,0.33,1250,6050,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 04808',0.34916,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23174,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 04808',NULL,23174,40.98,0.61,1570,6050,70,NULL,'SN photometric redshift distance, z photo =0.470 +/- 0.230','SDSS-II SN 04808',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23175,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 04808',NULL,23175,41,0.2,1580,6050,70,NULL,'SALT 2','SDSS-II SN 04808',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23176,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 04808',NULL,23176,41.04,0.2,1610,6050,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 04808',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23177,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23177,37.84,0.46,370,6051,70,NULL,NULL,'2MASX J02201910-0847113',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000093,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,35.0797083,-8.78639,0.168,NULL,35121874588,548779290,8574676,17.6),(23178,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23178,34.93,0.57,96.8,6052,NULL,NULL,'Malmquist cor.','UGC 01801',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000167,NULL,'15.23',0.7,'SB(s)b',NULL,NULL,NULL,NULL,1,35.083083,8.03825,0.233,NULL,67085490806,1048210793,16378293,15.23),(23179,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23179,35.07,0.53,103,6052,NULL,NULL,NULL,'UGC 01801',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23180,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23180,35.13,0.2,106,6052,74.4,NULL,NULL,'UGC 01801',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23181,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','PS1 SN PS10i','N',23181,39.14,0.11,585,6053,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10i HOST',0.1492,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23182,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23182,35.45,0.49,123,6054,70,NULL,NULL,'2MASX J02202533-1644547',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.43',0.62,NULL,NULL,NULL,NULL,NULL,1,35.1055417,-16.74847,0.128,NULL,37966064947,593219764,9269058,15.43),(23183,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 08700',NULL,23183,40.67,0.88,1360,6055,70,NULL,'SN photometric redshift distance, z photo =0.391 +/- 0.289','SDSS-II SN 08700',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,35.109583,0.22706,0.077,NULL,66877714905,1044964295,16327567,NULL),(23184,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 08700','R',23184,41.89,0.28,1680,6055,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 08700',0.423438,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23185,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 08700','R',23185,42.01,0.27,1770,6055,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 08700',0.423438,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23186,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 08700',NULL,23186,41.84,0.19,2330,6055,70,NULL,'SALT 2','SDSS-II SN 08700',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23187,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 08700',NULL,23187,41.91,0.19,2410,6055,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 08700',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23188,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23188,35.97,0.68,157,6056,70,NULL,NULL,'2MASX J02202631-3158164',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,35.1097083,-31.97122,NULL,NULL,38450250108,600785157,9387268,15.5),(23189,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23189,36.2,0.46,174,6057,70,NULL,NULL,'CGCG 388-003',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.00011,NULL,'15.3g',0.41,'E0',NULL,NULL,NULL,NULL,1,35.1105833333,-0.31286,0.057,NULL,34916838284,545575598,8524618,15.3),(23190,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 21035','RN',23190,42.27,0.32,2200,6058,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 21035',0.290265,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23191,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 21035','RN',23191,42.34,0.39,2280,6058,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 21035',0.290265,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23192,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23192,31.74,NULL,22.3,6059,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01803',NULL,'2010Ap&SS.325..163P',2010,1,2.8,NULL,'G',0.000013,NULL,'14.70',0.31,'SB(s)m: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,35.122083,6.81083,0.221,NULL,66861534936,1044711483,16323616,14.7),(23193,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23193,31.75,NULL,22.4,6059,NULL,NULL,'Dipole + Quadrupole','UGC 01803',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23194,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23194,31.76,NULL,22.4,6059,NULL,NULL,'Dipole','UGC 01803',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23195,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 16744','RN',23195,41.84,0.35,1750,6060,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16744',0.335224,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23196,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 16744','RN',23196,41.88,0.43,1780,6060,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16744',0.335224,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23197,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23197,36.49,0.58,199,6061,70,NULL,NULL,'6dF J0220300-364356',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,35.124917,-36.73217,NULL,NULL,38404930425,600077037,9376203,15.1),(23198,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 01446','RN',23198,42.08,0.3,2060,6062,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01446',0.268128,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23199,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 01446','RN',23199,42.11,0.29,2080,6062,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01446',0.268128,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23200,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 13487','R',23200,40.78,0.24,1110,6063,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13487',0.289052,'2014arXiv1401.3317S',2014,1,0.1,NULL,'G',NULL,'PHOT','21.4g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,35.140625,0.20331,0.077,NULL,66877712736,1044964261,16327566,21.4),(23201,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 13487',NULL,23201,40.29,0.15,1140,6063,70,NULL,'SN photometric redshift distance, z photo =0.314 +/- 0.028','SDSS-II SN 13487',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23202,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 13487','R',23202,40.93,0.23,1190,6063,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13487',0.289052,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23203,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23203,35.89,0.65,151,6064,70,NULL,NULL,'2MASX J02203668-1828348',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.16',0.36,NULL,NULL,NULL,NULL,NULL,1,35.152833,-18.47642,0.094,NULL,37955493938,593054592,9266478,16.16),(23204,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2006km',NULL,23204,39.99,0.11,997,6065,70,NULL,'Hubble residual -0.22 for z0.30110','SDSS-II SN 14735 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,35.1584583,0.34811,0.077,NULL,66877684579,1044963821,16327559,NULL),(23205,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 14735','R',23205,40.69,0.22,1060,6065,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006km','SDSS-II SN 14735 HOST',0.300443,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23206,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 14735','R',23206,40.75,0.15,1090,6065,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006km','SDSS-II SN 14735 HOST',0.300443,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23207,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23207,36.76,0.46,225,6066,70,NULL,NULL,'2MASX J02204134-0816042',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000077,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,35.17225,-8.26789,0.089,NULL,35121440398,548772506,8574570,17.9),(23208,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 05377','RN',23208,42.06,0.2,1790,6067,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05377',0.43881,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23209,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 05377','RN',23209,42.39,0.14,2090,6067,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 05377',0.43881,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23210,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SCP 06N33',NULL,23210,44.87,0.13,4310,6068,70,NULL,'SALT2, M(B)-19.289 mag, Alpha -0.019, Beta 3.480, Delta -0.151','[DAA2009] N',1.188,'2012ApJ...746...85S',2012,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,35.232083,-3.55278,0.005,NULL,34920389540,545631086,8525485,NULL),(23211,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23211,35.55,0.54,129,6069,70,NULL,NULL,'MCG -04-06-028',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.08',0.25,'S',NULL,NULL,NULL,NULL,1,35.253333,-20.82333,0,NULL,37980079205,593438737,9272480,15.08),(23212,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 02630',NULL,23212,40.17,0.18,1080,6070,70,NULL,'SN photometric redshift distance, z photo =0.295 +/- 0.031','SDSS-II SN 02630',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.6g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,35.2592083,-1.12008,0.045,NULL,34916642656,545572541,8524570,22.6),(23213,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 02630','R',23213,41.44,0.26,1430,6070,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02630',0.35072,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23214,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 02630','R',23214,41.53,0.2,1500,6070,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 02630',0.35072,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23215,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23215,32.15,NULL,26.9,6071,NULL,NULL,NULL,'ESO 081- G 007',NULL,'2000BSAO...50....5K',2000,1,1.57,NULL,'G',0.000033,NULL,'15.25',0.22,'Sc',NULL,NULL,NULL,NULL,1,35.2645,-63.62453,0.009,NULL,36256657513,566510273,8851723,15.25),(23216,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 09895',NULL,23216,39.82,0.58,920,6072,70,NULL,'SN photometric redshift distance, z photo =0.244 +/- 0.091','SDSS-II SN 09895',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,35.265875,0.50431,0.077,NULL,66875713231,1044933019,16327078,NULL),(23217,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2007pe',NULL,23217,40.03,0.11,1010,6073,70,NULL,'Hubble residual -0.20 for z0.30440','SDSS J022103.96+002947.5',NULL,'2011ApJ...740...92G',2011,1,0.06,NULL,'G',0.0005,NULL,'21.1g',0.04,NULL,NULL,NULL,NULL,NULL,1,35.2665416667,0.49656,0.077,NULL,66875713510,1044933023,16327078,21.1),(23218,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 19818','R',23218,40.86,0.22,1140,6073,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007pe','SDSS J022103.96+002947.5',0.3044,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23219,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 19818','R',23219,40.87,0.13,1150,6073,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007pe','SDSS J022103.96+002947.5',0.3044,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23220,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2007pe',NULL,23220,40.78,0.12,1430,6073,70,NULL,'SALT 2','SDSS J022103.96+002947.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23221,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2007pe',NULL,23221,40.82,0.12,1460,6073,70,NULL,'SALT 2, Malmquist cor.','SDSS J022103.96+002947.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23222,'G Lens','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23222,41.53,0.48,2020,6074,NULL,NULL,NULL,'B2 0218+35',NULL,'2000ApJ...545..578C',2000,1,NULL,'1993MNRAS..261..435P calls this a G_Lens.  [VCV96] have z = 0.936.','G',0.00004,NULL,'20.0V',NULL,'Grav Lens cand BLLAC',NULL,NULL,NULL,'QSO',1,35.2727917,35.93714,0.181,NULL,68632901851,1072389091,16756079,20),(23223,'G Lens','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23223,43.61,NULL,5270,6074,NULL,NULL,'Standard','B2 0218+35',NULL,'2014ApJ...788..190W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23224,'G Lens','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23224,43.65,NULL,5360,6074,NULL,NULL,'R(H) = ct','B2 0218+35',NULL,'2014ApJ...788..190W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23225,'G Lens','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23225,44.17,NULL,6840,6074,NULL,NULL,NULL,'B2 0218+35',NULL,'2007ApJ...660....1O',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23226,'G Lens','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23226,45.34,0.58,11700,6074,NULL,NULL,NULL,'B2 0218+35',NULL,'2014MNRAS.437..600S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23227,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','PS1 SN PS0910017','N',23227,41.04,0.13,1220,6075,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS0910017 HOST',0.3192,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23228,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 14894','R',23228,41.3,0.39,1270,6076,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14894',0.437768,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',NULL,'PHOT','21.6g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,35.2824583,-0.75797,0.045,NULL,34916926073,545576969,8524640,21.6),(23229,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 14894','R',23229,41.75,0.4,1560,6076,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14894',0.437768,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23230,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 14894',NULL,23230,41.26,0.21,1790,6076,70,NULL,'SN photometric redshift distance, z photo =0.561 +/- 0.084','SDSS-II SN 14894',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23231,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 14894',NULL,23231,41.59,0.32,2080,6076,70,NULL,'SALT 2','SDSS-II SN 14894',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23232,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 14894',NULL,23232,41.68,0.32,2170,6076,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14894',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23233,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23233,34.13,0.4,67,6077,NULL,NULL,'mean','ESO 298- G 031',NULL,'2007A&A...465...71T',2007,1,1.29,NULL,'G',0.000087,NULL,'15.03',0.45,'(R)S(r)ab',NULL,NULL,NULL,NULL,1,35.2989583,-42.00161,NULL,NULL,38488744609,601386634,9396666,15.03),(23234,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23234,34.13,0.47,67.1,6077,NULL,NULL,'H','ESO 298- G 031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23235,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23235,34.24,0.45,70.6,6077,NULL,NULL,'K','ESO 298- G 031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23236,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23236,34.26,0.46,71,6077,NULL,NULL,'J','ESO 298- G 031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23237,'Tully est','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23237,30.19,0.8,10.9,6078,75,NULL,'B','UGC 01807',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.00002,NULL,'16.5',1.5,'Im:','Group member',NULL,NULL,NULL,1,35.305833,42.76269,0.297,NULL,67814700225,1059604691,16556323,16.5),(23238,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23238,35.31,0.36,115,6079,NULL,NULL,'Malmquist cor.','UGC 01811',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',NULL,NULL,'16.0',0.6,'Scd:',NULL,NULL,NULL,NULL,1,35.3269583333,13.718,0.353,NULL,68065698001,1063526531,16617602,16),(23239,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23239,35.43,0.2,122,6079,74.4,NULL,NULL,'UGC 01811',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23240,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23240,35.43,0.35,122,6079,NULL,NULL,NULL,'UGC 01811',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23241,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23241,32.61,0.2,33.3,6080,74.4,NULL,NULL,'UGC 01814',NULL,'2013AJ....146...86T',2013,1,2.5,NULL,'G',0.00002,NULL,'13.56',1.2,'SAB(s)bc','Pair member (points to parent)',NULL,NULL,NULL,1,35.3487916667,16.56656,0.381,NULL,68081663205,1063775987,16621499,13.56),(23242,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23242,32.66,0.66,34,6080,NULL,NULL,'Malmquist cor.','UGC 01814',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23243,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23243,32.73,0.69,35.2,6080,100,NULL,'mid-IR','UGC 01814',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23244,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23244,32.8,0.62,36.3,6080,NULL,NULL,NULL,'UGC 01814',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23245,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23245,33.73,0.47,55.7,6080,NULL,NULL,'H','UGC 01814',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23246,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23246,33.73,0.4,55.8,6080,NULL,NULL,'mean','UGC 01814',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23247,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23247,33.92,0.46,60.7,6080,NULL,NULL,'J','UGC 01814',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23248,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23248,34.43,0.49,77,6081,75,NULL,'IR','UGC 01814 NOTES01',NULL,'2011yCatp016004901K',2011,1,0.6,NULL,'G',NULL,NULL,'12.3K',0.2,NULL,NULL,NULL,NULL,NULL,1,35.354,16.54906,0.381,NULL,68081662658,1063775979,16621499,12.3),(23249,'IRAS','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23249,33.69,0.8,54.7,6082,75,NULL,'W91PP, r','UGC 01812',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000023,NULL,'14.65',0.4,'Scd:',NULL,NULL,NULL,NULL,1,35.355125,25.42283,0.189,NULL,68589552530,1071711758,16745496,14.65),(23250,'IRAS','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23250,33.72,0.8,55.5,6082,75,NULL,'CF, r','UGC 01812',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23251,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23251,33.34,0.2,46.6,6082,74.4,NULL,NULL,'UGC 01812',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23252,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23252,33.36,0.38,47,6082,75,NULL,'W91PP, r, inv','UGC 01812',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23253,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23253,33.38,0.38,47.4,6082,75,NULL,'W91PP, r, raw','UGC 01812',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23254,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23254,33.39,0.58,47.7,6082,NULL,NULL,NULL,'UGC 01812',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23255,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23255,33.58,0.38,52,6082,75,NULL,'CF, r, raw','UGC 01812',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23256,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23256,33.61,0.38,52.7,6082,75,NULL,'CF, r, inv','UGC 01812',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23257,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23257,33.63,0.52,53.1,6082,NULL,NULL,'Malmquist cor.','UGC 01812',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23258,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23258,33.73,0.38,55.6,6082,75,NULL,'W91PP, r, cor','UGC 01812',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23259,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23259,33.87,0.38,59.5,6082,75,NULL,'CF, r, cor','UGC 01812',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23260,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23260,35.12,0.4,106,6083,NULL,NULL,'mean','Rose Galaxy',NULL,'2007A&A...465...71T',2007,1,2.2,NULL,'G',0.000037,NULL,'13.42',1.4,'SA(s)b pec','Pair member (points to parent)',NULL,NULL,NULL,1,35.369583,39.37567,0.185,NULL,68653399050,1072709360,16761083,13.42),(23261,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23261,35.2,0.47,110,6083,NULL,NULL,'H','Rose Galaxy',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23262,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23262,35.23,0.45,111,6083,NULL,NULL,'K','Rose Galaxy',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23263,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23263,35.24,0.46,112,6083,NULL,NULL,'J','Rose Galaxy',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23264,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23264,33.51,0.4,50.3,6084,NULL,NULL,'mean','UGC 01817',NULL,'2007A&A...465...71T',2007,1,2.52,NULL,'G',0.000007,NULL,'14.57',0.22,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,35.37925,14.19886,0.353,NULL,68068723647,1063573806,16618340,14.57),(23265,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23265,33.57,0.49,51.7,6084,75,NULL,'IR','UGC 01817',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23266,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23266,33.7,0.47,55,6084,NULL,NULL,'H','UGC 01817',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23267,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23267,33.76,0.46,56.6,6084,NULL,NULL,'J','UGC 01817',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23268,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23268,33.78,0.45,57.1,6084,NULL,NULL,'K','UGC 01817',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23269,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23269,33.79,0.2,57.3,6084,74.4,NULL,NULL,'UGC 01817',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23270,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23270,33.8,0.32,57.5,6084,NULL,NULL,NULL,'UGC 01817',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23271,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23271,33.9,0.31,60.1,6084,NULL,NULL,'Malmquist cor.','UGC 01817',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23272,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23272,34.15,NULL,67.5,6084,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01817',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23273,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23273,34.15,NULL,67.7,6084,NULL,NULL,'Dipole + Quadrupole','UGC 01817',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23274,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23274,34.15,NULL,67.7,6084,NULL,NULL,'Dipole','UGC 01817',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23275,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23275,34.21,NULL,69.4,6084,NULL,NULL,NULL,'UGC 01817',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23276,'IRAS','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23276,34.25,0.8,70.9,6085,75,NULL,'W91PP, r','IC 1793',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.00002,NULL,'14.74',0.6,'Sab',NULL,NULL,NULL,NULL,1,35.385,32.5445,0.277,NULL,68629531381,1072336427,16755256,14.74),(23277,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23277,34.39,0.4,75.5,6085,NULL,NULL,'mean','IC 1793',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23278,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23278,34.98,0.38,99.1,6085,75,NULL,'W91PP, r, raw','IC 1793',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23279,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23279,35.08,0.45,104,6085,NULL,NULL,'K','IC 1793',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23280,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23280,35.14,0.47,107,6085,NULL,NULL,'H','IC 1793',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23281,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23281,35.18,0.46,108,6085,NULL,NULL,'J','IC 1793',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23282,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23282,35.27,0.38,113,6085,75,NULL,'W91PP, r, inv','IC 1793',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23283,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23283,35.31,0.38,115,6085,75,NULL,'W91PP, r, cor','IC 1793',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23284,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23284,35.62,0.49,133,6086,75,NULL,'IR','UGC 01813',NULL,'2011yCatp016004901K',2011,1,1.5,'1999ApJS..121..287H has V = 7778 +- 137.','G',0.000153,NULL,'15.08',0.4,'SB(s)a pec','Pair member (points to parent)',NULL,NULL,NULL,1,35.3857917,39.35681,0.185,NULL,68653397419,1072709334,16761083,15.08),(23285,'IRAS','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23285,32.29,0.8,28.8,6087,75,NULL,'MAT, I','NGC 0895',NULL,'1997ApJS..109..333W',1997,1,3.6,'NGC 0894 is the northwestern arm of NGC 0895.','G',0.000004,NULL,'11.8B',2.6,'SA(s)cd',NULL,NULL,NULL,NULL,1,35.4019583,-5.52139,0.029,NULL,34947077039,546048078,8532001,11.8),(23286,'Sosies','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23286,32.82,0.2,36.6,6087,NULL,NULL,NULL,'NGC 0895',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23287,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23287,31.99,0.32,25,6087,85,NULL,'I, raw','NGC 0895',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23288,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23288,32.03,0.32,25.5,6087,85,NULL,'I, inv','NGC 0895',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23289,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23289,32.05,0.43,25.7,6087,75,NULL,'MAT, I, raw','NGC 0895',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23290,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23290,32.14,0.43,26.8,6087,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0895',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23291,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23291,32.2,0.43,27.5,6087,75,NULL,'3.6 micron, color corrected','NGC 0895',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23292,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23292,32.21,0.43,27.6,6087,75,NULL,'MAT, I, cor','NGC 0895',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23293,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23293,32.22,0.43,27.8,6087,75,NULL,'MAT, I, inv','NGC 0895',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23294,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23294,32.27,0.4,28.5,6087,75,NULL,'B','NGC 0895',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23295,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23295,32.31,0.4,29,6087,73,NULL,'opt','NGC 0895',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23296,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23296,32.32,0.2,29.1,6087,74.4,NULL,NULL,'NGC 0895',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23297,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23297,32.4,0.73,30.2,6087,NULL,NULL,'Malmquist cor.','NGC 0895',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23298,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23298,32.52,0.69,31.9,6087,NULL,NULL,NULL,'NGC 0895',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23299,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23299,33.9,NULL,60.2,6088,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0282',NULL,'2010Ap&SS.325..163P',2010,1,1.27,NULL,'G',0.00003,NULL,'16.2',0.11,'Sd',NULL,NULL,NULL,NULL,1,35.4077917,-9.70344,0.079,NULL,35116013470,548687710,8573245,16.2),(23300,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23300,33.91,NULL,60.7,6088,NULL,NULL,'Dipole + Quadrupole','FGC 0282',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23301,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23301,33.93,NULL,61,6088,NULL,NULL,'Dipole','FGC 0282',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23302,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23302,33.97,NULL,62.3,6088,NULL,NULL,NULL,'FGC 0282',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23303,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 06320','RN',23303,41.88,0.13,1820,6089,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06320',0.306554,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23304,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 06320','RN',23304,41.89,0.21,1830,6089,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06320',0.306554,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23305,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SCP 05D00',NULL,23305,44.29,0.07,3590,6090,70,NULL,'SALT2, M(B) -19.289 mag, Alpha -0.019, Beta 3.480, Delta -0.151','[ADP2008] J022142.04-032154.1',1.014,'2012ApJ...746...85S',2012,1,NULL,NULL,'G',NULL,NULL,'21.9z',NULL,'Late',NULL,NULL,NULL,NULL,1,35.425167,-3.36503,0.005,NULL,34920431546,545631742,8525495,21.9),(23306,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','PS1 SN PS10blh','N',23306,41.22,0.16,1330,6091,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10blh HOST',0.3182,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23307,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 05886','RN',23307,42.83,0.26,2710,6092,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 05886',0.357062,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23308,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 05886','RN',23308,43.04,0.38,2990,6092,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05886',0.357062,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23309,'IRAS','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23309,33.24,0.8,44.4,6093,75,NULL,'W91PP, r','UGC 01820',NULL,'1997ApJS..109..333W',1997,1,2.13,NULL,'G',0.00002,NULL,'15.06',0.24,'Scd',NULL,NULL,NULL,NULL,1,35.4435,33.02083,0.205,NULL,68629475360,1072335552,16755243,15.06),(23310,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23310,32.84,NULL,37,6093,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01820',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23311,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23311,32.85,NULL,37.1,6093,NULL,NULL,'Dipole + Quadrupole','UGC 01820',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23312,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23312,32.86,NULL,37.2,6093,NULL,NULL,'Dipole','UGC 01820',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23313,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23313,32.89,NULL,37.9,6093,NULL,NULL,NULL,'UGC 01820',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23314,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23314,33.03,0.6,40.4,6093,NULL,NULL,NULL,'UGC 01820',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23315,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23315,33.07,0.43,41.2,6093,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01820',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23316,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23316,33.09,0.49,41.5,6093,75,NULL,'IR','UGC 01820',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23317,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23317,33.09,0.2,41.5,6093,74.4,NULL,NULL,'UGC 01820',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23318,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23318,33.1,0.58,41.7,6093,NULL,NULL,'Malmquist cor.','UGC 01820',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23319,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23319,33.13,0.43,42.3,6093,75,NULL,'3.6 micron, color corrected','UGC 01820',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23320,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23320,33.3,0.38,45.7,6093,75,NULL,'W91PP, r, inv','UGC 01820',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23321,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23321,33.33,0.38,46.3,6093,75,NULL,'W91PP, r, raw','UGC 01820',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23322,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23322,33.67,0.38,54.3,6093,75,NULL,'W91PP, r, cor','UGC 01820',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23323,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SCP 05D06',NULL,23323,45.18,0.05,4690,6094,70,NULL,'SALT2, M(B) -19.289 mag, Alpha -0.019, Beta 3.480, Delta -0.151','SCP 05D06',1.315,'2012ApJ...746...85S',2012,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,35.4436666667,-3.38228,0.005,NULL,34920416562,545631508,8525492,NULL),(23324,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23324,33.67,0.46,54.2,6095,70,NULL,NULL,'MRK 1033',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00007,NULL,'14.26',0.5,'S0-? sp',NULL,NULL,NULL,NULL,1,35.44675,-10.02369,0.072,NULL,35116635475,548697429,8573397,14.26),(23325,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23325,33.65,0.4,53.7,6096,NULL,NULL,'mean','UGC 01822',NULL,'2007A&A...465...71T',2007,1,1.48,NULL,'G',0.000012,NULL,'15.57',0.17,'Sc',NULL,NULL,NULL,NULL,1,35.452083,16.87467,0.425,NULL,68081451559,1063772680,16621448,15.57),(23326,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23326,33.7,0.49,54.9,6096,75,NULL,'IR','UGC 01822',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23327,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23327,33.89,0.2,60,6096,74.4,NULL,NULL,'UGC 01822',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23328,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23328,33.96,0.36,62,6096,NULL,NULL,NULL,'UGC 01822',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23329,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23329,33.98,0.47,62.4,6096,NULL,NULL,'H','UGC 01822',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23330,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23330,34.03,0.35,63.9,6096,NULL,NULL,'Malmquist cor.','UGC 01822',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23331,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23331,34.33,NULL,73.6,6096,NULL,NULL,NULL,'UGC 01822',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23332,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23332,34.35,NULL,74.1,6096,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01822',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23333,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23333,34.37,NULL,74.9,6096,NULL,NULL,'Dipole + Quadrupole','UGC 01822',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23334,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23334,34.39,NULL,75.5,6096,NULL,NULL,'Dipole','UGC 01822',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23335,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23335,37.77,0.46,359,6097,70,NULL,NULL,'2MASX J02215153-0834572',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000069,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,35.4647083,-8.58261,0.089,NULL,34939756550,545933696,8530214,17.7),(23336,'Tully est','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23336,31.34,0.8,18.5,6098,75,NULL,NULL,'NGC 0899',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000027,NULL,'12.90',1.3,'IB(s)m         HII','in an interacting triple',NULL,NULL,NULL,1,35.471417,-20.82325,0,NULL,37983368713,593490136,9273283,12.9),(23337,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23337,38.18,0.27,432,6099,70,NULL,NULL,'2MASX J02215693-0840412',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000122,NULL,'16.3g',0.34,'AGN',NULL,NULL,NULL,NULL,1,35.4871666667,-8.67822,0.089,NULL,34939750460,545933600,8530212,16.3),(23338,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23338,36.37,0.57,188,6100,70,NULL,NULL,'2MASX J02215861-0553152',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.97',0.19,NULL,NULL,NULL,NULL,NULL,1,35.4942083,-5.88761,0.033,NULL,34947027594,546047306,8531989,16.97),(23339,'IRAS','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23339,33.97,0.8,62.3,6101,75,NULL,'MAT, I','ESO 298- G 036',NULL,'1997ApJS..109..333W',1997,1,1.45,'The APMUKS position is 18 arcsec southeast of the nucleus.','G',0.000033,NULL,'14.31',0.4,'SAB:(rs:)bc',NULL,NULL,NULL,NULL,1,35.49575,-37.45494,NULL,NULL,38404860114,600075939,9376186,14.31),(23340,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23340,33.55,0.32,51.3,6101,85,NULL,'I, raw','ESO 298- G 036',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23341,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23341,33.57,0.32,51.7,6101,85,NULL,'I, inv','ESO 298- G 036',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23342,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23342,33.73,0.43,55.6,6101,75,NULL,'MAT, I, raw','ESO 298- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23343,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23343,33.83,0.43,58.3,6101,75,NULL,'MAT, I, inv','ESO 298- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23344,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23344,34.04,0.43,64.4,6101,75,NULL,'MAT, I, cor','ESO 298- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23345,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23345,34.09,0.32,65.8,6101,NULL,NULL,NULL,'ESO 298- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23346,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23346,34.13,0.2,67,6101,74.4,NULL,NULL,'ESO 298- G 036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23347,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23347,34.31,0.29,72.8,6101,NULL,NULL,'Malmquist cor.','ESO 298- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23348,'Faber-Jackson','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23348,32.1,0.4,26.3,6102,95,NULL,'Weighted Mean','NGC 0890',NULL,'1984ApJS...56...91D',1984,1,2.5,NULL,'G',0.000063,NULL,'12.2',1.7,'SAB(r)0-?',NULL,NULL,NULL,NULL,1,35.5042083,33.26606,0.269,NULL,68630164058,1072346313,16755411,12.2),(23349,'Faber-Jackson','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23349,32.28,0.51,28.6,6102,95,NULL,'de Vaucouleurs','NGC 0890',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23350,'Faber-Jackson','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23350,33.21,0.81,43.9,6102,55,NULL,'Visvanathan & Sandage 1979','NGC 0890',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23351,'Tertiary','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23351,32.77,0.32,35.8,6102,95,NULL,NULL,'NGC 0890',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23352,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23352,32.72,0.45,35,6102,NULL,NULL,'K','NGC 0890',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23353,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23353,33.61,0.4,52.6,6102,NULL,NULL,'mean','NGC 0890',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23354,'Tully est','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23354,31.38,0.8,18.8,6103,75,NULL,NULL,'IC 0223',NULL,'1988NBGC.C....0000T',1988,1,1.05,NULL,'G',0.000003,NULL,'14.13',0.53,'IB(s)m pec?','in an interacting triple',NULL,NULL,NULL,1,35.504583,-20.74592,0,NULL,37983409080,593490766,9273293,14.13),(23355,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 18972','R',23355,40.85,0.27,1110,6104,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18972',0.330984,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',NULL,'PHOT','20.5g',0.07,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,35.507125,1.15489,0.077,NULL,66875316496,1044926820,16326981,20.5),(23356,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 18972','R',23356,40.85,0.21,1110,6104,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18972',0.330984,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23357,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 18972',NULL,23357,40.37,0.19,1180,6104,70,NULL,'SN photometric redshift distance, z photo =0.328 +/- 0.038','SDSS-II SN 18972',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23358,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 18972',NULL,23358,40.7,0.17,1380,6104,70,NULL,'SALT 2','SDSS-II SN 18972',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23359,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 18972',NULL,23359,40.74,0.17,1410,6104,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18972',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23360,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23360,35.83,0.5,146,6105,70,NULL,NULL,'ESO 115-IG 007',NULL,'2014MNRAS.445.2677S',2014,1,0.8,'ESO-LV gives v = 2321 km/sec.','G',0.000133,NULL,'15.19',0.6,'N',NULL,NULL,NULL,NULL,1,35.511667,-58.60803,0.025,NULL,36160140723,565002198,8828159,15.19),(23361,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23361,35.79,0.52,144,6106,70,NULL,NULL,'2MASX J02220471-0733442',NULL,'2014MNRAS.445.2677S',2014,1,0.71,NULL,'G',0.000079,NULL,'15.6g',0.27,'S0/a',NULL,NULL,NULL,NULL,1,35.5195,-7.56219,0.037,NULL,34942249800,545972653,8530822,15.6),(23362,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23362,37.77,0.46,358,6107,70,NULL,NULL,'2MASX J02221192-0038349',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00008,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,35.549833,-0.64289,0.045,NULL,34916322115,545567533,8524492,17.4),(23363,'IRAS','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23363,33.88,0.8,59.6,6108,75,NULL,'W91PP, r','UGC 01828',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'15.40',0.3,'S?','Pair member (points to parent)',NULL,NULL,NULL,1,35.552125,28.73475,0.345,NULL,68649804307,1072653192,16760206,15.4),(23364,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23364,33.7,0.38,55.1,6108,75,NULL,'W91PP, r, inv','UGC 01828',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23365,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23365,33.75,0.38,56.2,6108,75,NULL,'W91PP, r, raw','UGC 01828',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23366,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23366,33.76,0.42,56.4,6108,NULL,NULL,NULL,'UGC 01828',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23367,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23367,33.8,0.2,57.5,6108,74.4,NULL,NULL,'UGC 01828',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23368,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23368,33.97,0.38,62.2,6108,75,NULL,'W91PP, r, cor','UGC 01828',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23369,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23369,34.06,0.36,64.9,6108,NULL,NULL,'Malmquist cor.','UGC 01828',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23370,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23370,33.62,0.51,53,6109,NULL,NULL,NULL,'UGC 01834',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.00005,NULL,'15.3',0.8,'SBcd:',NULL,NULL,NULL,NULL,1,35.555417,12.03,0.293,NULL,67076237669,1048066213,16376034,15.3),(23371,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23371,33.66,0.2,54,6109,74.4,NULL,NULL,'UGC 01834',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23372,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23372,33.92,0.44,60.8,6109,NULL,NULL,'Malmquist cor.','UGC 01834',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23373,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23373,34.95,0.46,97.6,6110,70,NULL,NULL,'2MASX J02221831-0916403',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000077,NULL,'15.9g',0.29,'S0^-',NULL,NULL,NULL,NULL,1,35.57625,-9.27778,0.091,NULL,35115771288,548683926,8573186,15.9),(23374,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23374,35.95,0.46,155,6111,70,NULL,NULL,'2MASX J02221858-0941183',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000077,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,35.577375,-9.68839,0.079,NULL,35115916450,548686194,8573221,16.6),(23375,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23375,37.97,0.46,392,6112,70,NULL,NULL,'2MASX J02222230-0819343',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000088,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,35.592875,-8.32608,0.093,NULL,34940512668,545945510,8530398,17.9),(23376,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23376,36.56,0.59,205,6113,70,NULL,NULL,'2MASX J02222634-0617393',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'17.30',0.18,NULL,NULL,NULL,NULL,NULL,1,35.609667,-6.29419,0.017,NULL,34939409593,545928274,8530129,17.3),(23377,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23377,35.82,0.56,146,6114,70,NULL,NULL,'2MASX J02222955-0615323',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'16.27',0.52,NULL,NULL,NULL,NULL,NULL,1,35.623125,-6.25903,0.025,NULL,34939417335,545928395,8530131,16.27),(23378,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23378,31.41,0.4,19.1,6115,75,NULL,'B','UGC 01839',NULL,'1988NBGC.C....0000T',1988,1,2,NULL,'G',0.000017,NULL,'15.4g',0.2,'Sdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,35.625083,-0.61756,0.045,NULL,34916291109,545567048,8524485,15.4),(23379,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23379,31.91,NULL,24.1,6115,NULL,NULL,NULL,'UGC 01839',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23380,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23380,31.96,NULL,24.6,6115,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01839',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23381,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23381,31.98,NULL,24.9,6115,NULL,NULL,'Dipole + Quadrupole','UGC 01839',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23382,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23382,31.98,NULL,24.9,6115,NULL,NULL,'Dipole','UGC 01839',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23383,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23383,32.18,0.43,27.3,6115,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01839',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23384,'PNLF','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23384,29.97,0.16,9.86,6116,NULL,NULL,'33 PNe','NGC 0891',NULL,'1991ApJ...383..487C',1991,1,13.5,NULL,'G',0.000013,NULL,'10.81',2.5,'SA(s)b? sp     HII','Group member, radial-velocity confirmed',NULL,'radio jet',NULL,1,35.6392083,42.34914,0.297,NULL,68537457450,1070897772,16732777,10.81),(23385,'PNLF','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23385,29.99,0.13,9.95,6116,NULL,NULL,NULL,'NGC 0891',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23386,'PNLF','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23386,30.1,0.13,10.5,6116,NULL,NULL,'HST KP Calibrated','NGC 0891',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23387,'SNII radio','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 1986J',NULL,23387,29.29,0.31,7.2,6116,NULL,NULL,NULL,'NGC 0891',NULL,'1998ApJ...500...51W',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23388,'SBF','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23388,29.61,0.14,8.36,6116,NULL,NULL,'I','NGC 0891',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23389,'SBF','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23389,29.67,0.18,8.59,6116,NULL,NULL,'HST KP Calibrated, I','NGC 0891',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23390,'SBF','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23390,29.8,0.08,9.12,6116,74.4,NULL,NULL,'NGC 0891',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23391,'TRGB','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23391,29.8,0.09,9.1,6116,NULL,NULL,'I','NGC 0891',NULL,'2011ApJS..195...18R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23392,'TRGB','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23392,29.8,0.08,9.12,6116,74.4,NULL,NULL,'NGC 0891',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23393,'TRGB','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23393,29.82,NULL,9.2,6116,NULL,NULL,'I','NGC 0891',NULL,'2008ApJ...686L..75M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23394,'TRGB','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23394,29.96,0.08,9.82,6116,NULL,NULL,NULL,'NGC 0891',NULL,'2005Ap.....48..221T',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23395,'Grav. Stability Gas. Disk','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23395,29.96,NULL,9.8,6116,NULL,NULL,NULL,'NGC 0891',NULL,'1996AstL...22...71Z',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23396,'IRAS','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23396,29.98,0.8,9.89,6116,75,NULL,'A82, H','NGC 0891',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23397,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23397,29.91,0.4,9.6,6116,75,NULL,'B','NGC 0891',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23398,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23398,30.02,0.4,10.1,6116,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 0891',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23399,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23399,30.17,0.38,10.8,6116,NULL,NULL,NULL,'NGC 0891',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23400,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23400,30.25,0.47,11.2,6116,75,NULL,'A82, H, raw','NGC 0891',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23401,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23401,30.27,NULL,11.3,6116,75,NULL,'CO','NGC 0891',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23402,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23402,30.27,NULL,11.3,6116,75,NULL,'HI','NGC 0891',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23403,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23403,30.4,0.3,12,6116,NULL,18.45,'NGC 1023 group','NGC 0891',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23404,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23404,30.45,0.47,12.3,6116,75,NULL,'A82, H, inv','NGC 0891',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23405,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23405,30.5,0.47,12.6,6116,75,NULL,'A82, H, cor','NGC 0891',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23406,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23406,30.79,NULL,14.4,6116,NULL,NULL,'LEDA [April 2006]','NGC 0891',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23407,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23407,38.18,0.27,432,6117,70,NULL,NULL,'2MASX J02223377-0838333',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000082,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,35.6408333333,-8.64267,0.089,NULL,34939825565,545934774,8530230,17.2),(23408,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23408,38.18,0.27,432,6118,70,NULL,NULL,'2MASXi J0222344-083852',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000099,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,35.6436666667,-8.64808,0.089,NULL,34939824471,545934757,8530230,18.2),(23409,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23409,37.21,0.46,277,6119,70,NULL,NULL,'2MASX J02223895-0826463',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000081,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,35.6622917,-8.44617,0.089,NULL,34939780382,545934068,8530219,17.4),(23410,'BL Lac Luminosity','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23410,40.4,NULL,1200,6120,70,NULL,'z >0.3347','3C 066A',NULL,'2015arXiv150203012A',2015,1,NULL,NULL,'QSO',NULL,NULL,'15.2V',NULL,'blazar         BLLAC',NULL,NULL,NULL,'HP BL Lac',1,35.6650417,43.0355,0.397,NULL,68537126068,1070892594,16732696,15.2),(23411,'BL Lac Luminosity','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23411,40.59,0.17,1310,6120,70,NULL,'Photo z = 0.37 +/- 0.4','3C 066A',NULL,'2013ApJ...766...35F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23412,'BL Lac Luminosity','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23412,40.8,NULL,1440,6120,70,NULL,'min.','3C 066A',NULL,'2014ApJ...784..151S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23413,'GeV TeV ratio','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23413,39.5,NULL,794,6120,72,NULL,NULL,'3C 066A',NULL,'2010MNRAS.405L..76P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23414,'GeV TeV ratio','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23414,40.6,0.21,1320,6120,72,NULL,NULL,'3C 066A',NULL,'2011arXiv1111.0913P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23415,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','PS1 SN PS0910018','N',23415,40.57,0.13,1030,6121,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS0910018 HOST',0.2642,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23416,'IRAS','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23416,34.1,0.8,66,6122,75,NULL,'W91PP, r','IC 0221',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000017,NULL,'13.70',1.2,'Sc',NULL,NULL,NULL,NULL,1,35.670417,28.25697,0.245,NULL,68645519963,1072586249,16759160,13.7),(23417,'IRAS','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23417,34.12,0.8,66.6,6122,75,NULL,'CF, r','IC 0221',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23418,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23418,33.09,0.69,41.6,6122,100,NULL,'mid-IR','IC 0221',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23419,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23419,34.13,0.38,67,6122,75,NULL,'W91PP, r, raw','IC 0221',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23420,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23420,34.21,0.38,69.5,6122,75,NULL,'W91PP, r, cor','IC 0221',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23421,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23421,34.24,0.47,70.4,6122,NULL,NULL,'H','IC 0221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23422,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23422,34.25,0.4,70.9,6122,NULL,NULL,'mean','IC 0221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23423,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23423,34.26,0.45,71,6122,NULL,NULL,'K','IC 0221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23424,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23424,34.29,0.46,72.2,6122,NULL,NULL,'J','IC 0221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23425,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23425,34.3,0.3,72.6,6122,NULL,NULL,'Malmquist cor.','IC 0221',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23426,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23426,34.36,0.38,74.6,6122,75,NULL,'W91PP, r, inv','IC 0221',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23427,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23427,34.4,0.38,75.8,6122,75,NULL,'CF, r, raw','IC 0221',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23428,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23428,34.45,0.38,77.6,6122,75,NULL,'CF, r, cor','IC 0221',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23429,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23429,34.53,0.27,80.6,6122,NULL,NULL,NULL,'IC 0221',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23430,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23430,34.58,0.2,82.4,6122,74.4,NULL,NULL,'IC 0221',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23431,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23431,34.6,0.38,83.3,6122,75,NULL,'CF, r, inv','IC 0221',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23432,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 09885','RN',23432,40.02,0.28,694,6123,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 09885',0.45818,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23433,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 13262','RN',23433,41.05,0.31,1240,6124,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13262',0.30736,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23434,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 13262','RN',23434,41.29,0.29,1390,6124,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13262',0.30736,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23435,'CMD','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'N',23435,19.7,NULL,0.087,6125,NULL,NULL,NULL,'Eridanus III',NULL,'2015ApJ...805..130K',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23436,'CMD','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'N',23436,19.9,NULL,0.095,6125,NULL,NULL,'DESJ0222.7_5217','Eridanus III',NULL,'2015ApJ...807...50B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23437,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23437,34.33,0.47,73.6,6126,70,NULL,NULL,'IC 1796',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000133,NULL,'13.02',0.9,'(R?)SB0^-',NULL,NULL,NULL,NULL,1,35.697167,-41.37108,NULL,NULL,38490805546,601418836,9397169,13.02),(23438,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23438,35.63,0.69,134,6127,100,NULL,'mid-IR','IC 0222',NULL,'2013ApJ...771...88L',2013,1,0.6,NULL,'G',0.000107,NULL,'15.2',0.4,NULL,NULL,NULL,NULL,NULL,1,35.699375,11.63833,0.269,NULL,67076346020,1048067906,16376061,15.2),(23439,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23439,34.39,NULL,75.5,6128,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0284',NULL,'2010Ap&SS.325..163P',2010,1,1.01,NULL,'G',0.000027,'?','17.89',0.1,'Sd',NULL,NULL,NULL,NULL,1,35.7100417,17.81508,0.393,NULL,68077873826,1063716778,16620574,17.89),(23440,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23440,34.39,NULL,75.7,6128,NULL,NULL,'Dipole + Quadrupole','FGC 0284',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23441,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23441,34.4,NULL,76,6128,NULL,NULL,'Dipole','FGC 0284',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23442,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23442,34.41,NULL,76.2,6128,NULL,NULL,NULL,'FGC 0284',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23443,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 18973',NULL,23443,41.25,0.14,1780,6129,70,NULL,'SN photometric redshift distance, z photo =0.555 +/- 0.053','SDSS-II SN 18973',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'G',NULL,'PHOT','23.6R',NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,35.7209583,1.24822,0.089,NULL,66889218762,1045144043,16330375,23.6),(23444,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23444,34.39,0.25,75.5,6130,74.4,NULL,NULL,'UGC 01837',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000043,NULL,'14.81',0.9,'S0','Group member',NULL,NULL,NULL,1,35.743583,43.01203,0.397,NULL,68537136239,1070892753,16732699,14.81),(23445,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 14863','RN',23445,42.49,0.39,2130,6131,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14863',0.473755,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23446,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 08053',NULL,23446,39.83,0.51,924,6132,70,NULL,'SN photometric redshift distance, z photo =0.245 +/- 0.078','SDSS-II SN 08053',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,35.7504583,-0.82281,0.053,NULL,34916102626,545564103,8524439,NULL),(23447,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SCP 06R12',NULL,23447,45.67,0.11,6160,6133,70,NULL,'SALT2, M(B) -19.289 mag, Alpha -0.019, Beta 3.480, Delta -0.151','SCP 06R12',1.212,'2012ApJ...746...85S',2012,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,35.750333,-4.60083,0.009,NULL,34917862727,545591605,8524868,NULL),(23448,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23448,36.66,0.33,215,6134,70,NULL,NULL,'2MASX J02230156-0818531',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000086,NULL,'16.4g',0.32,'AGN',NULL,NULL,NULL,NULL,1,35.7564583,-8.31464,0.089,NULL,34940470475,545944851,8530388,16.4),(23449,'IRAS','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23449,31.72,0.8,22.1,6135,75,NULL,'MAT, I','NGC 0907',NULL,'1997ApJS..109..333W',1997,1,1.8,'Confused HIPASS source','G',0.00002,NULL,'12.90',0.6,'SBdm? sp       HII','in an interacting triple',NULL,NULL,NULL,1,35.7579583,-20.71206,0.005,NULL,37983572829,593493325,9273333,12.9),(23450,'Tully est','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23450,31.56,0.8,20.5,6135,75,NULL,NULL,'NGC 0907',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23451,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23451,31.09,0.32,16.5,6135,85,NULL,'I, inv','NGC 0907',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23452,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23452,31.1,0.32,16.6,6135,85,NULL,'I, raw','NGC 0907',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23453,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23453,31.44,0.1,19.4,6135,NULL,NULL,NULL,'NGC 0907',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23454,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23454,31.47,0.43,19.7,6135,75,NULL,'MAT, I, raw','NGC 0907',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23455,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23455,31.52,0.43,20.1,6135,75,NULL,'MAT, I, inv','NGC 0907',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23456,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23456,31.66,0.43,21.5,6135,75,NULL,'MAT, I, cor','NGC 0907',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23457,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23457,32.04,0.43,25.6,6135,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0907',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23458,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23458,32.08,0.43,26.1,6135,75,NULL,'3.6 micron, color corrected','NGC 0907',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23459,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23459,32.14,0.2,26.8,6135,74.4,NULL,NULL,'NGC 0907',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23460,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 04045','RN',23460,43.68,0.27,3830,6136,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04045',0.424366,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23461,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 04045','RN',23461,44.02,0.28,4480,6136,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04045',0.424366,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23462,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23462,31.37,0.49,18.8,6137,75,NULL,'IR','2MFGC 01844',NULL,'2011yCatp016004901K',2011,1,NULL,'This is a part of the galaxy NGC 0907.','PofG',0.00015,NULL,NULL,NULL,'HII',NULL,NULL,NULL,NULL,1,35.76225,-20.71186,0.005,NULL,37983572928,593493327,9273333,NULL),(23463,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23463,36.66,0.33,215,6138,70,NULL,NULL,'2MASX J02230432-0819591',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000077,NULL,'16.9g',0.21,'AGN',NULL,NULL,NULL,NULL,1,35.7680417,-8.33314,0.089,NULL,34940471011,545944859,8530388,16.9),(23464,'IRAS','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23464,31.45,0.8,19.5,6139,75,NULL,'MAT, I','NGC 0908',NULL,'1997ApJS..109..333W',1997,1,6,NULL,'G',0.000017,NULL,'10.83',2.6,'SA(s)c         HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,35.7690416667,-21.23386,0,NULL,37983316572,593489321,9273270,10.83),(23465,'IRAS','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23465,31.47,0.8,19.7,6139,75,NULL,'A82, H','NGC 0908',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23466,'Sosies','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23466,31.36,0.09,18.7,6139,NULL,NULL,NULL,'NGC 0908',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23467,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23467,30.73,0.4,14,6139,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 0908',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23468,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23468,30.81,0.32,14.5,6139,85,NULL,'I, raw','NGC 0908',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23469,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23469,30.87,0.32,14.9,6139,85,NULL,'I, inv','NGC 0908',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23470,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23470,30.92,0.43,15.3,6139,75,NULL,'MAT, I, raw','NGC 0908',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23471,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23471,30.99,0.35,15.8,6139,NULL,NULL,NULL,'NGC 0908',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23472,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23472,30.99,0.4,15.8,6139,73,NULL,'opt','NGC 0908',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23473,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23473,31.13,0.47,16.8,6139,75,NULL,'A82, H, raw','NGC 0908',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23474,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23474,31.15,0.43,17,6139,75,NULL,'MAT, I, inv','NGC 0908',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23475,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23475,31.15,0.43,17,6139,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0908',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23476,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23476,31.17,0.43,17.1,6139,75,NULL,'3.6 micron, color corrected','NGC 0908',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23477,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23477,31.23,0.43,17.6,6139,75,NULL,'MAT, I, cor','NGC 0908',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23478,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23478,31.26,0.4,17.8,6139,75,NULL,'B','NGC 0908',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23479,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23479,31.27,0.2,18,6139,74.4,NULL,NULL,'NGC 0908',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23480,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23480,31.28,0.47,18,6139,75,NULL,'A82, H, inv','NGC 0908',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23481,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23481,31.29,NULL,18.1,6139,NULL,NULL,'LEDA [April 2006]','NGC 0908',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23482,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23482,31.44,0.47,19.4,6139,75,NULL,'A82, H, cor','NGC 0908',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23483,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23483,31.44,0.07,19.4,6139,NULL,NULL,NULL,'NGC 0908',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23484,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','PS1 SN PS11cn','N',23484,40.61,0.13,1060,6140,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11cn HOST',0.2492,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23485,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 04507','RN',23485,43.16,0.26,2590,6141,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04507',0.649093,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23486,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23486,34.34,0.25,73.8,6142,74.4,NULL,NULL,'UGC 01841',NULL,'2013AJ....146...86T',2013,1,2.2,'Additional radio sources may contribute to the WMAP flux.','G',0.00005,NULL,'15.0',3,'E              LERG','Group member',NULL,'FR I','Flat-Spectrum Radio Source',1,35.7975417,42.99206,0.397,NULL,68537132160,1070892690,16732698,15),(23487,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23487,35.82,0.25,146,6143,74.4,NULL,NULL,'UGC 01841 NOTES01',NULL,'2013AJ....146...86T',2013,1,0.15,NULL,'G',NULL,NULL,'17.2',0.15,'E',NULL,NULL,NULL,NULL,1,35.804,42.98778,0.397,NULL,68537260430,1070894694,16732729,17.2),(23488,'BL Lac Luminosity','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23488,39.44,NULL,772,6144,NULL,NULL,'Min. z = 0.2','6dF J0223143-111738',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'G',0.000183,NULL,'19.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,35.8094583333,-11.29397,0,NULL,35115147596,548674181,8573034,19),(23489,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23489,35.58,0.47,131,6145,70,NULL,NULL,'MCG -03-07-008',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000133,NULL,'14.98',0.5,'E',NULL,NULL,NULL,NULL,1,35.828,-18.83981,0.084,NULL,37981550116,593461720,9272839,14.98),(23490,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23490,34.62,0.49,83.9,6146,75,NULL,'IR','NGC 0898',NULL,'2011yCatp016004901K',2011,1,1.9,NULL,'G',0.00006,NULL,'13.84',0.5,'Sab',NULL,NULL,NULL,NULL,1,35.834875,41.95142,0.245,NULL,68537415007,1070897109,16732767,13.84),(23491,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23491,35.46,0.52,124,6147,70,NULL,NULL,'2MASX J02232137-2132286',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.000053,NULL,'15.74',0.5,'S',NULL,NULL,NULL,NULL,1,35.839083,-21.54119,0,NULL,37983147899,593486685,9273229,15.74),(23492,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23492,35.18,0.47,109,6148,NULL,NULL,'H','MRK 1034 NED02',NULL,'2007A&A...465...71T',2007,1,0.6,NULL,'G',0.000013,NULL,'15.01',0.4,'S?;LINER;HII   Sy1','Pair member (points to parent)',NULL,NULL,'Sy ?',1,35.841625,32.19708,0.245,NULL,68636811117,1072450173,16757033,15.01),(23493,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23493,35.22,0.45,111,6148,NULL,NULL,'K','MRK 1034 NED02',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23494,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23494,35.44,0.46,123,6148,NULL,NULL,'J','MRK 1034 NED02',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23495,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23495,35.72,0.4,139,6148,NULL,NULL,'mean','MRK 1034 NED02',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23496,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 15161','R',23496,40.46,0.2,991,6149,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006jw','RCS 01220201597',0.25,'2014arXiv1401.3317S',2014,1,0.16,NULL,'G',NULL,NULL,'19.63',0.14,NULL,NULL,NULL,NULL,NULL,1,35.842417,0.81917,0.077,NULL,66875479614,1044929368,16327021,19.63),(23497,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 15161','R',23497,40.47,0.13,992,6149,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006jw','RCS 01220201597',0.25,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23498,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2006jw',NULL,23498,40.27,0.1,1130,6149,70,NULL,'SALT 2','RCS 01220201597',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23499,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2006jw',NULL,23499,40.29,0.1,1140,6149,70,NULL,'SALT 2, Malmquist cor.','RCS 01220201597',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23500,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 16048','RN',23500,40.91,0.26,1100,6150,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16048',0.380767,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23501,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 16048','RN',23501,41.18,0.31,1250,6150,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16048',0.380767,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23502,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 16048','N',23502,41.04,0.2,1610,6150,70,NULL,'SALT 2','SDSS-II SN 16048',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23503,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 16048','N',23503,41.1,0.2,1660,6150,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16048',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23504,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23504,37.68,0.46,343,6151,70,NULL,NULL,'2MASX J02232770-0913123',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.95',0.2,NULL,NULL,NULL,NULL,NULL,1,35.8654583333,-9.21997,0.089,NULL,34932296261,545817129,8528392,17.95),(23505,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 16030','RN',23505,42.24,0.37,2200,6152,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 16030',0.275511,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23506,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 16030','RN',23506,42.29,0.33,2250,6152,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 16030',0.275511,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23507,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23507,37.91,0.46,381,6153,70,NULL,NULL,'2MASX J02232984-0824533',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00007,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,35.87425,-8.41478,0.077,NULL,34939696269,545932754,8530199,18.1),(23508,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','PS1 SN PS10g','N',23508,39.09,0.14,578,6154,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10g HOST',0.1361,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23509,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23509,36.49,0.46,198,6155,70,NULL,NULL,'2MASX J02233090-0048010',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000065,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,35.8787917,-0.80014,0.053,NULL,34916080843,545563763,8524433,17.5),(23510,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23510,35.78,0.26,143,6156,NULL,NULL,'Malmquist cor.','CGCG 483-022',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.00011,NULL,'15.7',0.2,NULL,'Group member',NULL,NULL,NULL,1,35.88275,25.46508,0.221,NULL,68644211834,1072565809,16758840,15.7),(23511,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23511,35.8,0.26,145,6156,NULL,NULL,NULL,'CGCG 483-022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23512,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23512,35.92,0.2,153,6156,74.4,NULL,NULL,'CGCG 483-022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23513,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23513,36.38,0.46,189,6157,70,NULL,NULL,'2MASX J02233430-0851113',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00009,NULL,'16.4g',0.32,'AGN',NULL,NULL,NULL,NULL,1,35.892875,-8.85322,0.089,NULL,34944022682,546000354,8531255,16.4),(23514,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2007ou',NULL,23514,38.75,0.08,562,6158,70,NULL,'Hubble residual 0.45 for z0.11321','SDSS-II SN 19626 HOST',NULL,'2011ApJ...740...92G',2011,1,0.09,NULL,'G',0.000043,NULL,'18.4g',0.04,NULL,NULL,NULL,NULL,NULL,1,35.92775,-0.82647,0.057,NULL,34916087294,545563863,8524435,18.4),(23515,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 19626','R',23515,39.26,0.09,638,6158,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ou','SDSS-II SN 19626 HOST',0.113211,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23516,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 19626','R',23516,39.31,0.2,654,6158,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ou','SDSS-II SN 19626 HOST',0.113211,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23517,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23517,36.5,0.54,200,6159,70,NULL,NULL,'2MASX J02234313-0510040',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.17',0.5,NULL,NULL,NULL,NULL,NULL,1,35.92975,-5.16797,0.013,NULL,34947667068,546057297,8532145,16.17),(23518,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23518,35.82,0.57,146,6160,70,NULL,NULL,'2MASX J02234484-1712430',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.16',0.45,'(R\'_2)SB(r)0/a',NULL,NULL,NULL,NULL,1,35.9367916667,-17.21192,0.126,NULL,37963458975,593179046,9268422,16.16),(23519,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 05980','RN',23519,41.89,0.24,2100,6161,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05980',0.136395,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23520,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 05980','RN',23520,42.15,0.25,2370,6161,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 05980',0.136395,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23521,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23521,36.71,0.52,220,6162,NULL,NULL,'Malmquist cor.','2MASX J02234718+2728242',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',NULL,NULL,'15.0I',0.1,NULL,NULL,NULL,NULL,NULL,1,35.946583,27.47344,0.301,NULL,68647773892,1072621467,16759710,15),(23522,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23522,37.07,0.44,260,6162,NULL,NULL,NULL,'2MASX J02234718+2728242',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23523,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23523,37.11,0.2,264,6162,74.4,NULL,NULL,'2MASX J02234718+2728242',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23524,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23524,37.72,0.46,350,6163,70,NULL,NULL,'2MASX J02234830-0058580',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000078,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,35.951375,-0.98278,0.057,NULL,34927473604,545741775,8527215,17.3),(23525,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23525,35.52,0.52,127,6164,NULL,NULL,'Malmquist cor.','CGCG 483-026',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000033,NULL,'14.94',0.6,'S?','Group member',NULL,NULL,NULL,1,35.9664166667,25.54206,0.221,NULL,68644080693,1072563760,16758808,14.94),(23526,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23526,35.56,0.51,129,6164,NULL,NULL,NULL,'CGCG 483-026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23527,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23527,34.76,0.46,89.6,6165,70,NULL,NULL,'MCG -01-07-006',NULL,'2014MNRAS.445.2677S',2014,1,0.84,NULL,'G',0.000127,NULL,'14.3g',0.78,NULL,NULL,NULL,NULL,NULL,1,35.9735,-7.3525,0.053,NULL,34942588187,545977940,8530905,14.3),(23528,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23528,36.14,0.6,169,6166,70,NULL,NULL,'2MASX J02235473-0447388',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.20',0.43,NULL,NULL,NULL,NULL,NULL,1,35.9782083333,-4.79425,0.021,NULL,34947526535,546055102,8532110,16.2),(23529,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23529,38.47,0.46,494,6167,70,NULL,NULL,'SDSS J022355.06-082251.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00007,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,35.9794166667,-8.38103,0.077,NULL,34940526785,545945731,8530402,18.6),(23530,'IRAS','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23530,35.84,0.8,147,6168,75,NULL,'W91PP, r','UGC 01848',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.00002,NULL,'15.23',0.5,'Sb',NULL,NULL,NULL,NULL,1,35.9815833333,27.49281,0.301,NULL,68647775464,1072621491,16759710,15.23),(23531,'IRAS','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23531,35.85,0.8,148,6168,75,NULL,'CF, r','UGC 01848',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23532,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23532,35.37,0.38,119,6168,75,NULL,'CF, r, raw','UGC 01848',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23533,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23533,35.51,0.38,127,6168,75,NULL,'W91PP, r, raw','UGC 01848',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23534,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23534,35.53,0.38,127,6168,75,NULL,'CF, r, inv','UGC 01848',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23535,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23535,35.68,0.38,137,6168,75,NULL,'CF, r, cor','UGC 01848',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23536,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23536,35.73,0.38,140,6168,75,NULL,'W91PP, r, inv','UGC 01848',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23537,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23537,35.78,0.38,144,6168,75,NULL,'W91PP, r, cor','UGC 01848',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23538,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23538,35.82,0.26,146,6168,NULL,NULL,'Malmquist cor.','UGC 01848',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23539,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23539,35.89,0.25,151,6168,NULL,NULL,NULL,'UGC 01848',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23540,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23540,36.08,0.2,164,6168,74.4,NULL,NULL,'UGC 01848',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23541,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23541,35.72,0.25,139,6169,74.4,NULL,NULL,'CGCG 523-034',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000137,NULL,'13.98',0.5,'E',NULL,NULL,NULL,NULL,1,35.9830833333,37.06269,0.197,NULL,68621842985,1072216296,16753379,13.98),(23542,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23542,35.93,0.33,153,6169,70,NULL,NULL,'CGCG 523-034',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23543,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 13240','RN',23543,39.13,0.71,557,6170,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13240',0.199796,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23544,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23544,37.17,0.99,272,6171,70,NULL,NULL,'2MASX J02240255-0707374',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.94',0.49,NULL,NULL,NULL,NULL,NULL,1,36.010583,-7.12711,0.037,NULL,34942723763,545980058,8530938,15.94),(23545,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 18839','RN',23545,42.28,0.41,1840,6172,70,NULL,'SDSS CAND. SNIa; SALT 2','SDSS-II SN 18839',0.551,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23546,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1em',NULL,23546,43.15,0.06,2290,6173,70,NULL,'SIFTO','VVDS:[RBO2008] ir 00171777',0.866,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',NULL,NULL,'22.7r',NULL,NULL,NULL,NULL,NULL,NULL,1,36.022917,-4.93981,0.021,NULL,34947509967,546054843,8532106,22.7),(23547,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1em',NULL,23547,43.82,0.22,3120,6173,70,NULL,'SALT 2','VVDS:[RBO2008] ir 00171777',0.866,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23548,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1em',NULL,23548,43.85,0.15,3160,6173,NULL,NULL,'SIFTO','VVDS:[RBO2008] ir 00171777',0.866,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23549,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1em',NULL,23549,44.37,0.17,4020,6173,NULL,NULL,'SALT2','VVDS:[RBO2008] ir 00171777',0.866,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23550,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23550,31.28,0.43,18.1,6174,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01845',NULL,'2014MNRAS.444..527S',2014,1,1.2,NULL,'G',0.000183,NULL,'14.8',0.7,'Sab;LIRG       HII',NULL,NULL,NULL,NULL,1,36.03325,47.96972,1.297,NULL,67838015320,1059968989,16562015,14.8),(23551,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23551,33.08,0.45,41.3,6174,NULL,NULL,'K','UGC 01845',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23552,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23552,33.1,0.47,41.8,6174,NULL,NULL,'H','UGC 01845',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23553,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23553,33.49,0.46,49.9,6174,NULL,NULL,'J','UGC 01845',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23554,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23554,33.93,0.4,61.2,6174,NULL,NULL,'mean','UGC 01845',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23555,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1hy',NULL,23555,43.28,0.06,2450,6175,70,NULL,'SIFTO','[HSP2005] J022408.67-044952.22',0.85,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.02,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,36.036167,-4.83117,0.021,NULL,34947521134,546055017,8532109,NULL),(23556,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1hy',NULL,23556,43.71,0.15,2980,6175,NULL,NULL,'SIFTO','[HSP2005] J022408.67-044952.22',0.85,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23557,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1hy',NULL,23557,43.72,0.21,3000,6175,70,NULL,'SALT 2','[HSP2005] J022408.67-044952.22',0.85,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23558,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1hy',NULL,23558,45.4,0.17,6500,6175,NULL,NULL,'SALT2','[HSP2005] J022408.67-044952.22',0.85,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23559,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1ks',NULL,23559,43.07,0.22,2280,6176,70,NULL,'SALT 2','SNLS 04D1ks HOST',0.798,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',0.012,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,36.0396666667,-4.97872,0.021,NULL,34947685234,546057581,8532149,NULL),(23560,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1ks',NULL,23560,43.29,0.15,2530,6176,NULL,NULL,'SIFTO','SNLS 04D1ks HOST',0.798,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23561,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1ks',NULL,23561,43.48,0.05,2770,6176,70,NULL,'SIFTO','SNLS 04D1ks HOST',0.798,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23562,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1ks',NULL,23562,44.23,0.17,3890,6176,NULL,NULL,'SALT2','SNLS 04D1ks HOST',0.798,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23563,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1au','R',23563,41.43,NULL,1290,6177,65,NULL,'SALT','[AGR2006] J022410.39-040214.9',0.504,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.0005,NULL,'22.6r',NULL,'Candidate      QSO',NULL,NULL,NULL,NULL,1,36.0432916667,-4.03747,0.041,NULL,34919314287,545614285,8525223,22.6),(23564,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1au',NULL,23564,41.64,0.15,1410,6177,74.2,NULL,'SALT 2','[AGR2006] J022410.39-040214.9',0.504,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23565,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1au',NULL,23565,42.08,0.04,1740,6177,70,NULL,'SALT','[AGR2006] J022410.39-040214.9',0.504,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23566,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1au',NULL,23566,42.3,0.14,1920,6177,70,NULL,'SALT','[AGR2006] J022410.39-040214.9',0.504,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23567,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1au',NULL,23567,42.3,0.13,1920,6177,70,NULL,'SALT 2','[AGR2006] J022410.39-040214.9',0.504,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23568,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1au',NULL,23568,42.38,0.15,1990,6177,NULL,NULL,'SIFTO','[AGR2006] J022410.39-040214.9',0.504,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23569,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1au',NULL,23569,42.39,0.1,2000,6177,65,NULL,'SALT2','[AGR2006] J022410.39-040214.9',0.504,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23570,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1au',NULL,23570,42.43,0.04,2040,6177,70,NULL,NULL,'[AGR2006] J022410.39-040214.9',0.504,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23571,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1au',NULL,23571,42.47,0.11,2070,6177,65,NULL,'SALT','[AGR2006] J022410.39-040214.9',0.504,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23572,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1au',NULL,23572,42.5,0.17,2100,6177,65,NULL,'SALT2','[AGR2006] J022410.39-040214.9',0.504,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23573,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1au',NULL,23573,42.51,0.17,2120,6177,65,NULL,'MLCS17','[AGR2006] J022410.39-040214.9',0.504,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23574,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1au',NULL,23574,42.54,0.18,2140,6177,65,NULL,'MLCS31','[AGR2006] J022410.39-040214.9',0.504,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23575,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1au',NULL,23575,42.55,0.16,2150,6177,65,NULL,'MLCS2k2','[AGR2006] J022410.39-040214.9',0.504,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23576,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1au',NULL,23576,42.6,0.12,2200,6177,65,NULL,'MLCS2k2','[AGR2006] J022410.39-040214.9',0.504,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23577,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1au',NULL,23577,42.62,0.03,2230,6177,65,NULL,'SALT','[AGR2006] J022410.39-040214.9',0.504,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23578,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1au',NULL,23578,43.92,0.17,4050,6177,NULL,NULL,'SALT2','[AGR2006] J022410.39-040214.9',0.504,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23579,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23579,35.2,0.2,110,6178,74.4,NULL,NULL,'CGCG 414-006',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000063,NULL,'15.20',0.2,'S?',NULL,NULL,NULL,NULL,1,36.051625,5.37286,0.085,NULL,66891600824,1045181262,16330957,15.2),(23580,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23580,35.34,0.49,117,6179,75,NULL,'IR','CGCG 414-006',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000063,NULL,'15.20',0.2,'S?',NULL,NULL,NULL,NULL,1,36.051625,5.37286,0.085,NULL,66891600824,1045181262,16330957,15.2),(23581,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ew','R',23581,42.7,NULL,1850,6180,65,NULL,'MLCS17','[HSP2005] J022414.08-043956.98',0.868,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,36.0587083,-4.66583,0.021,NULL,34947468018,546054187,8532096,NULL),(23582,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ew',NULL,23582,42.79,0.25,1930,6180,74.2,NULL,'SALT 2','[HSP2005] J022414.08-043956.98',0.868,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23583,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ew',NULL,23583,43.41,0.07,2570,6180,70,NULL,'MLCS17','[HSP2005] J022414.08-043956.98',0.868,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23584,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ew',NULL,23584,43.53,0.23,2720,6180,65,NULL,'SALT2','[HSP2005] J022414.08-043956.98',0.868,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23585,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ew',NULL,23585,43.62,0.26,2840,6180,65,NULL,'MLCS2k2','[HSP2005] J022414.08-043956.98',0.868,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23586,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ew',NULL,23586,43.65,0.24,2870,6180,70,NULL,'SALT 2','[HSP2005] J022414.08-043956.98',0.868,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23587,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ew',NULL,23587,43.74,NULL,3000,6180,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','[HSP2005] J022414.08-043956.98',0.868,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23588,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ew',NULL,23588,43.79,0.15,3060,6180,NULL,NULL,'SIFTO','[HSP2005] J022414.08-043956.98',0.868,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23589,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ew',NULL,23589,43.79,0.21,3070,6180,65,NULL,'MLCS17','[HSP2005] J022414.08-043956.98',0.868,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23590,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ew',NULL,23590,43.87,0.34,3180,6180,70,NULL,NULL,'[HSP2005] J022414.08-043956.98',0.868,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23591,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ew',NULL,23591,43.95,0.16,3300,6180,65,NULL,'MLCS31','[HSP2005] J022414.08-043956.98',0.868,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23592,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ew',NULL,23592,43.95,0.14,3310,6180,65,NULL,'MLCS2k2','[HSP2005] J022414.08-043956.98',0.868,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23593,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ew',NULL,23593,43.96,0.7,3320,6180,70,NULL,'SALT','[HSP2005] J022414.08-043956.98',0.868,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23594,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ew',NULL,23594,44.01,0.48,3400,6180,65,NULL,'SALT2','[HSP2005] J022414.08-043956.98',0.868,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23595,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ew',NULL,23595,44.12,0.23,3570,6180,65,NULL,'SALT','[HSP2005] J022414.08-043956.98',0.868,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23596,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ew',NULL,23596,44.14,0.65,3610,6180,65,NULL,'SALT','[HSP2005] J022414.08-043956.98',0.868,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23597,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ew',NULL,23597,44.38,0.17,4030,6180,NULL,NULL,'SALT2','[HSP2005] J022414.08-043956.98',0.868,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23598,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1aw',NULL,23598,41.97,0.16,1570,6181,74.2,NULL,'SALT 2','[AGR2006] J022414.78-043101.6',0.582,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,36.061625,-4.51711,0.013,NULL,34919156179,545611815,8525184,NULL),(23599,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1aw','R',23599,42.1,NULL,1660,6181,65,NULL,'SALT2','[AGR2006] J022414.78-043101.6',0.582,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23600,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1aw',NULL,23600,42.66,0.04,2150,6181,70,NULL,'SALT 2','[AGR2006] J022414.78-043101.6',0.582,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23601,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1aw',NULL,23601,42.73,0.12,2220,6181,65,NULL,'SALT2','[AGR2006] J022414.78-043101.6',0.582,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23602,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1aw',NULL,23602,42.77,0.17,2260,6181,65,NULL,'MLCS2k2','[AGR2006] J022414.78-043101.6',0.582,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23603,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1aw',NULL,23603,42.84,0.18,2340,6181,70,NULL,'SALT','[AGR2006] J022414.78-043101.6',0.582,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23604,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1aw',NULL,23604,42.86,0.18,2360,6181,65,NULL,'SALT2','[AGR2006] J022414.78-043101.6',0.582,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23605,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1aw',NULL,23605,42.88,0.15,2380,6181,70,NULL,'SALT 2','[AGR2006] J022414.78-043101.6',0.582,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23606,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1aw',NULL,23606,42.88,0.05,2400,6181,70,NULL,NULL,'[AGR2006] J022414.78-043101.6',0.582,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23607,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1aw',NULL,23607,42.92,0.15,2420,6181,NULL,NULL,'SIFTO','[AGR2006] J022414.78-043101.6',0.582,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23608,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1aw',NULL,23608,43,0.16,2520,6181,65,NULL,'SALT','[AGR2006] J022414.78-043101.6',0.582,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23609,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1aw',NULL,23609,43.05,0.19,2580,6181,65,NULL,'MLCS17','[AGR2006] J022414.78-043101.6',0.582,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23610,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1aw',NULL,23610,43.1,0.21,2630,6181,65,NULL,'MLCS31','[AGR2006] J022414.78-043101.6',0.582,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23611,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1aw',NULL,23611,43.11,0.05,2650,6181,65,NULL,'SALT','[AGR2006] J022414.78-043101.6',0.582,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23612,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1aw',NULL,23612,43.12,0.18,2660,6181,65,NULL,'MLCS2k2','[AGR2006] J022414.78-043101.6',0.582,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23613,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1aw',NULL,23613,44.37,0.17,4730,6181,NULL,NULL,'SALT2','[AGR2006] J022414.78-043101.6',0.582,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23614,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','PS1 SN PS10h','N',23614,40.39,0.13,959,6182,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10h HOST',0.2492,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23615,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23615,36.87,0.46,237,6183,70,NULL,NULL,'2MASX J02241966-0826185',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000077,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,36.082,-8.43836,0.093,NULL,34939669569,545932337,8530192,17.3),(23616,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1ix',NULL,23616,41.91,0.04,1610,6184,70,NULL,'z lit','SNLS 05D1ix HOST',0.49,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,36.083125,-4.66992,0.021,NULL,34947467478,546054179,8532096,NULL),(23617,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1ix',NULL,23617,42.02,0.13,1700,6184,72,NULL,'z lit','SNLS 05D1ix HOST',0.49,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23618,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1ix',NULL,23618,42.25,0.12,1890,6184,70,NULL,'SALT 2','SNLS 05D1ix HOST',0.49,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23619,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1ix',NULL,23619,42.26,0.15,1900,6184,NULL,NULL,'SIFTO','SNLS 05D1ix HOST',0.49,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23620,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1ix',NULL,23620,43.13,0.17,2840,6184,NULL,NULL,'SALT2','SNLS 05D1ix HOST',0.49,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23621,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1sk',NULL,23621,42.94,0.19,2320,6185,70,NULL,'SALT 2','SNLS 04D1sk HOST',0.6634,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',0.0005,NULL,'22.6r',NULL,NULL,NULL,NULL,NULL,NULL,1,36.0949583333,-4.35394,0.045,NULL,34919210159,545612658,8525197,22.6),(23622,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1sk',NULL,23622,42.95,0.15,2340,6185,NULL,NULL,'SIFTO','SNLS 04D1sk HOST',0.6634,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23623,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1sk',NULL,23623,42.99,NULL,2380,6185,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SNLS 04D1sk HOST',0.6634,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23624,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1sk',NULL,23624,43.31,0.23,2760,6185,72,NULL,'z lit','SNLS 04D1sk HOST',0.6634,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23625,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1sk',NULL,23625,43.51,0.17,3030,6185,NULL,NULL,'SALT2','SNLS 04D1sk HOST',0.6634,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23626,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1sk',NULL,23626,43.54,0.05,3070,6185,70,NULL,'SIFTO','SNLS 04D1sk HOST',0.6634,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23627,'D-Sigma','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23627,35.41,0.4,121,6186,75,NULL,'Edat, raw','ESO 115- G 008',NULL,'1997ApJS..109..333W',1997,1,0.75,NULL,'G',0.000123,NULL,'14.18',0.65,'E1:','Pair member (points to parent)',NULL,NULL,NULL,1,36.0947917,-58.39664,0.033,NULL,36159550166,564992971,8828015,14.18),(23628,'D-Sigma','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23628,35.74,0.4,141,6186,75,NULL,'Edat, cor','ESO 115- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23629,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ax','R',23629,41.42,NULL,1290,6187,65,NULL,'MLCS17','[HSP2005] J022423.32-044314.41',0.496,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,36.097167,-4.72067,0.021,NULL,34947474952,546054296,8532098,NULL),(23630,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ax',NULL,23630,41.48,0.15,1320,6187,74.2,NULL,'SALT 2','[HSP2005] J022423.32-044314.41',0.496,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23631,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ax',NULL,23631,41.79,0.17,1530,6187,NULL,NULL,'SALT2','[HSP2005] J022423.32-044314.41',0.496,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23632,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ax',NULL,23632,42.11,0.04,1770,6187,70,NULL,'MLCS17','[HSP2005] J022423.32-044314.41',0.496,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23633,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ax',NULL,23633,42.18,0.04,1820,6187,70,NULL,NULL,'[HSP2005] J022423.32-044314.41',0.496,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23634,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ax',NULL,23634,42.19,0.18,1840,6187,65,NULL,'MLCS17','[HSP2005] J022423.32-044314.41',0.496,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23635,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ax',NULL,23635,42.21,0.1,1850,6187,65,NULL,'SALT2','[HSP2005] J022423.32-044314.41',0.496,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23636,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ax',NULL,23636,42.22,0.16,1860,6187,70,NULL,'SALT','[HSP2005] J022423.32-044314.41',0.496,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23637,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ax',NULL,23637,42.25,0.11,1880,6187,65,NULL,'MLCS2k2','[HSP2005] J022423.32-044314.41',0.496,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23638,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ax',NULL,23638,42.25,0.15,1880,6187,NULL,NULL,'SIFTO','[HSP2005] J022423.32-044314.41',0.496,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23639,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ax',NULL,23639,42.29,0.13,1920,6187,70,NULL,'SALT 2','[HSP2005] J022423.32-044314.41',0.496,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23640,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ax',NULL,23640,42.3,NULL,1930,6187,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','[HSP2005] J022423.32-044314.41',0.496,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23641,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ax',NULL,23641,42.33,0.17,1950,6187,65,NULL,'MLCS2k2','[HSP2005] J022423.32-044314.41',0.496,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23642,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ax',NULL,23642,42.32,0.19,1950,6187,65,NULL,'MLCS31','[HSP2005] J022423.32-044314.41',0.496,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23643,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ax',NULL,23643,42.38,0.17,2000,6187,65,NULL,'SALT2','[HSP2005] J022423.32-044314.41',0.496,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23644,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ax',NULL,23644,42.41,0.13,2020,6187,65,NULL,'SALT','[HSP2005] J022423.32-044314.41',0.496,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23645,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1ax',NULL,23645,42.43,0.03,2040,6187,65,NULL,'SALT','[HSP2005] J022423.32-044314.41',0.496,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23646,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23646,35.58,0.45,131,6188,NULL,NULL,NULL,'2MASX J02242354+2714059',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000048,NULL,'13.9I',0.2,NULL,NULL,NULL,NULL,NULL,1,36.098125,27.23494,0.277,NULL,68647901684,1072623463,16759741,13.9),(23647,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23647,35.65,0.2,135,6188,74.4,NULL,NULL,'2MASX J02242354+2714059',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23648,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23648,35.71,0.43,139,6188,NULL,NULL,'Malmquist cor.','2MASX J02242354+2714059',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23649,'IRAS','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23649,31.19,0.8,17.3,6189,75,NULL,'MAT, I','UGC 01862',NULL,'1997ApJS..109..333W',1997,1,1.7,'Marginal HIPASS detection.','G',0.000001,NULL,'13.66',1.3,'SAB(rs)d pec:','in a radial-velocity based grouping',NULL,NULL,NULL,1,36.103375,-2.16236,0.037,NULL,34929944941,545780389,8527818,13.66),(23650,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23650,30.88,0.32,15,6189,85,NULL,'I, inv','UGC 01862',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23651,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23651,30.91,0.32,15.2,6189,85,NULL,'I, raw','UGC 01862',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23652,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23652,31.04,0.43,16.2,6189,75,NULL,'MAT, I, inv','UGC 01862',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23653,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23653,31.12,0.43,16.7,6189,75,NULL,'MAT, I, raw','UGC 01862',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23654,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23654,31.4,0.43,19.1,6189,75,NULL,'MAT, I, cor','UGC 01862',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23655,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23655,31.43,0.4,19.3,6189,73,NULL,'opt','UGC 01862',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23656,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23656,31.46,0.58,19.6,6189,NULL,NULL,NULL,'UGC 01862',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23657,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23657,31.5,0.2,20,6189,74.4,NULL,NULL,'UGC 01862',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23658,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23658,31.52,0.56,20.1,6189,NULL,NULL,'Malmquist cor.','UGC 01862',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23659,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23659,31.56,0.4,20.5,6189,NULL,NULL,'mean','UGC 01862',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23660,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23660,31.74,0.4,22.3,6189,NULL,NULL,NULL,'UGC 01862',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23661,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23661,31.74,0.4,22.3,6189,73,NULL,'opt','UGC 01862',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23662,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23662,32.05,0.46,25.8,6189,NULL,NULL,'J','UGC 01862',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23663,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23663,32.12,0.47,26.5,6189,NULL,NULL,'H','UGC 01862',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23664,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1ck',NULL,23664,42.83,0.15,2270,6190,70,NULL,'SALT 2','VVDS:[RBO2008] ir 00180025',0.617,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',0.001,NULL,'21.9r',NULL,NULL,NULL,NULL,NULL,NULL,1,36.103375,-4.71264,0.021,NULL,34950355249,546099300,8532801,21.9),(23665,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1ck',NULL,23665,42.95,0.15,2400,6190,NULL,NULL,'SIFTO','VVDS:[RBO2008] ir 00180025',0.617,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23666,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1ck',NULL,23666,43.11,0.17,2590,6190,NULL,NULL,'SALT2','VVDS:[RBO2008] ir 00180025',0.617,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23667,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1ck',NULL,23667,43.62,0.05,3280,6190,70,NULL,'SIFTO','VVDS:[RBO2008] ir 00180025',0.617,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23668,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1dn',NULL,23668,42.4,0.04,1930,6191,70,NULL,'z lit','SNLS 05D1dn HOST',0.566,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,36.1110417,-4.99156,0.021,NULL,34947681655,546057525,8532148,NULL),(23669,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1dn',NULL,23669,42.42,0.15,1940,6191,72,NULL,'z lit','SNLS 05D1dn HOST',0.566,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23670,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1dn',NULL,23670,42.61,0.15,2120,6191,70,NULL,'SALT 2','SNLS 05D1dn HOST',0.566,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23671,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1dn',NULL,23671,42.64,0.15,2150,6191,NULL,NULL,'SIFTO','SNLS 05D1dn HOST',0.566,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23672,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1dn',NULL,23672,44.3,0.17,4620,6191,NULL,NULL,'SALT2','SNLS 05D1dn HOST',0.566,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23673,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23673,35.23,0.47,111,6192,70,NULL,NULL,'ESO 115- G 009',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000093,NULL,'15.10',0.3,'Sab pec sp','Pair member (points to parent)',NULL,NULL,NULL,1,36.121083,-58.43389,0.033,NULL,36159542834,564992856,8828013,15.1),(23674,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1if',NULL,23674,43.13,0.05,2400,6193,70,NULL,'SIFTO','SNLS 05D1if HOST',0.763,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,36.1237916667,-4.57028,0.013,NULL,34949301807,546082840,8532544,NULL),(23675,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1if',NULL,23675,43.35,0.19,2660,6193,70,NULL,'SALT 2','SNLS 05D1if HOST',0.763,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23676,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1if',NULL,23676,43.4,0.15,2710,6193,NULL,NULL,'SIFTO','SNLS 05D1if HOST',0.763,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23677,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1if',NULL,23677,43.73,0.17,3160,6193,NULL,NULL,'SALT2','SNLS 05D1if HOST',0.763,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23678,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23678,36.33,0.46,184,6194,70,NULL,NULL,'GALEXASC J022431.46-080039.7',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,36.1310833333,-8.01119,0.061,NULL,34940060802,545938450,8530288,14.4),(23679,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23679,36.47,0.5,196,6194,70,NULL,NULL,'GALEXASC J022431.46-080039.7',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23680,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23680,33.04,NULL,40.5,6195,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01856',NULL,'2010Ap&SS.325..163P',2010,1,2.24,NULL,'G',0.000006,NULL,'14.78',0.25,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,36.131583,31.61531,0.245,NULL,68637642132,1072463158,16757236,14.78),(23681,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23681,33.05,NULL,40.7,6195,NULL,NULL,'Dipole + Quadrupole','UGC 01856',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23682,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23682,33.05,NULL,40.8,6195,NULL,NULL,'Dipole','UGC 01856',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23683,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23683,33.18,NULL,43.3,6195,NULL,NULL,NULL,'UGC 01856',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23684,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23684,36.44,0.75,194,6196,70,NULL,NULL,'2MASX J02243278-6139561',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'15.71',0.62,'S',NULL,NULL,NULL,NULL,1,36.1366666667,-61.66558,0.061,NULL,36271836525,566747445,8855428,15.71),(23685,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1kl',NULL,23685,42.89,0.16,2430,6197,70,NULL,'SALT 2','SNLS 05D1kl HOST',0.56,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',NULL,NULL,'24.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,36.13975,-4.31897,0.045,NULL,34919219150,545612799,8525199,24.4),(23686,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1kl',NULL,23686,42.94,0.15,2480,6197,NULL,NULL,'SIFTO','SNLS 05D1kl HOST',0.56,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23687,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1kl',NULL,23687,43.78,0.05,3650,6197,70,NULL,'SIFTO','SNLS 05D1kl HOST',0.56,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23688,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1kl',NULL,23688,43.9,0.17,3870,6197,NULL,NULL,'SALT2','SNLS 05D1kl HOST',0.56,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23689,'IRAS','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23689,33.52,0.8,50.5,6198,75,NULL,'W91PP, r','UGC 01857',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000017,NULL,'15.10',0.5,'Sd:',NULL,NULL,NULL,NULL,1,36.142125,33.16853,0.261,NULL,68630126842,1072345731,16755402,15.1),(23690,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23690,33.81,0.38,57.8,6198,75,NULL,'W91PP, r, raw','UGC 01857',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23691,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23691,33.83,0.38,58.4,6198,75,NULL,'W91PP, r, inv','UGC 01857',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23692,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23692,33.98,0.38,62.6,6198,75,NULL,'W91PP, r, cor','UGC 01857',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23693,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1bm',NULL,23693,42.51,0.15,2010,6199,NULL,NULL,'SIFTO','VVDS:[RBO2008] ir 00065892',0.575,'2010A&A...523A...7G',2010,1,NULL,NULL,'VisS',0.001,NULL,'21.0r',NULL,'Candidate      QSO',NULL,NULL,NULL,NULL,1,36.1502917,-4.21242,0.045,NULL,34919195486,545612429,8525194,21),(23694,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1bm',NULL,23694,43.15,0.17,2710,6199,NULL,NULL,'SALT2','VVDS:[RBO2008] ir 00065892',0.575,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23695,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 04313',NULL,23695,40.64,0.17,1340,6200,70,NULL,'SN photometric redshift distance, z photo =0.384 +/- 0.040','SDSS-II SN 04313',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.2g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,36.1503333333,1.03475,0.081,NULL,66889561266,1045149394,16330459,21.2),(23696,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 04313','R',23696,41.8,0.27,1640,6200,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 04313',0.39189,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23697,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 04313','R',23697,42,0.25,1800,6200,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 04313',0.39189,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23698,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 04313',NULL,23698,41.76,0.17,2250,6200,70,NULL,'SALT 2','SDSS-II SN 04313',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23699,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 04313',NULL,23699,41.83,0.17,2320,6200,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 04313',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23700,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2005ky',NULL,23700,39.13,0.24,583,6201,72,NULL,'SNLS 05D1hn','APMUKS(BJ) B022205.44-042424.0',0.148,'2009ApJ...704.1036F',2009,1,0.17,NULL,'G',0.0006,NULL,'19.60',0.11,NULL,NULL,NULL,NULL,NULL,1,36.151167,-4.18069,0.045,NULL,34919371755,545615183,8525237,19.6),(23701,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2005ky',NULL,23701,39.35,0.15,646,6201,NULL,NULL,'SNLS 05D1hn, SIFTO','APMUKS(BJ) B022205.44-042424.0',0.148,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23702,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2005ky',NULL,23702,40.25,0.17,976,6201,NULL,NULL,'SNLS 05D1hn, SALT2','APMUKS(BJ) B022205.44-042424.0',0.148,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23703,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23703,38.73,0.46,558,6202,70,NULL,NULL,'SDSS J022437.39-083926.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000076,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,36.155833,-8.65731,0.065,NULL,34943966375,545999474,8531241,18.7),(23704,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23704,34.09,NULL,65.9,6203,NULL,NULL,NULL,'FGC 0288',NULL,'2000BSAO...50....5K',2000,1,1.34,NULL,'G',0.000067,NULL,'15.8',0.17,'Sdm',NULL,NULL,NULL,NULL,1,36.1592916667,19.37647,0.449,NULL,68113309099,1064270454,16629225,15.8),(23705,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23705,34.13,NULL,67,6203,NULL,NULL,'Dipole + Quadrupole','FGC 0288',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23706,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23706,34.13,NULL,67.1,6203,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0288',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23707,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23707,34.15,NULL,67.5,6203,NULL,NULL,'Dipole','FGC 0288',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23708,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23708,34.18,0.49,68.5,6203,75,NULL,'IR','FGC 0288',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23709,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23709,36.93,0.33,243,6204,70,NULL,NULL,'2MASX J02243838-0108025',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000083,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,36.159917,-1.13403,0.045,NULL,34928019281,545750301,8527348,16.4),(23710,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1hk',NULL,23710,40.14,0.03,845,6205,70,NULL,'z lit','SNLS 05D1hk HOST',0.2631,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.0002,NULL,'21.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,36.163375,-4.63419,0.021,NULL,34950364719,546099448,8532803,21.8),(23711,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1hk',NULL,23711,40.44,0.18,969,6205,72,NULL,'z lit','SNLS 05D1hk HOST',0.2631,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23712,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1hk',NULL,23712,40.7,0.15,1090,6205,NULL,NULL,'SIFTO','SNLS 05D1hk HOST',0.2631,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23713,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1hk',NULL,23713,42.37,0.17,2360,6205,NULL,NULL,'SALT2','SNLS 05D1hk HOST',0.2631,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23714,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 07292','RN',23714,39.39,0.35,706,6206,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 07292',0.069374,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23715,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23715,34.44,NULL,77.3,6207,NULL,NULL,'B','ESO 545- G 013',NULL,'2004ApJ...607..241R',2004,1,1.1,NULL,'G',0.000033,NULL,'13.94',0.9,'SAB(s)c        Sy1',NULL,NULL,NULL,'Sy 1.5',1,36.16925,-19.14203,0.094,NULL,37981675223,593463675,9272869,13.94),(23716,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23716,34.69,NULL,86.7,6207,NULL,NULL,'B','ESO 545- G 013',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23717,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23717,34.69,NULL,86.7,6207,NULL,NULL,'I','ESO 545- G 013',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23718,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23718,34.69,NULL,86.7,6207,NULL,NULL,'B','ESO 545- G 013',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23719,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23719,34.69,NULL,86.7,6207,NULL,NULL,'B, Hubble-type-TF','ESO 545- G 013',NULL,'2004ApJ...607..241R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23720,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23720,34.71,0.47,87.5,6207,NULL,NULL,'B, Hubble-type-TF','ESO 545- G 013',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23721,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23721,34.71,NULL,87.5,6207,NULL,NULL,'B, Hubble-type-TF','ESO 545- G 013',NULL,'2005Ap&SS.299..405R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23722,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23722,34.71,0.47,87.5,6207,NULL,NULL,'B, Hubble-type-TF','ESO 545- G 013',NULL,'2005Ap&SS.299..387R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23723,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23723,34.81,NULL,91.6,6207,NULL,NULL,'I','ESO 545- G 013',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23724,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23724,35.19,0.81,109,6207,NULL,NULL,'Malmquist cor.','ESO 545- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23725,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23725,35.63,0.66,134,6207,NULL,NULL,NULL,'ESO 545- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23726,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23726,35.67,0.2,136,6207,74.4,NULL,NULL,'ESO 545- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23727,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1ag','R',23727,41.36,NULL,1200,6208,65,NULL,'MLCS17','[AGR2006] J022441.12-041719.6',0.557,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,'19.9r',NULL,NULL,NULL,NULL,NULL,NULL,1,36.171375,-4.28881,0.045,NULL,34919205702,545612589,8525196,19.9),(23728,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1ag',NULL,23728,41.85,0.16,1510,6208,74.2,NULL,'SALT 2','[AGR2006] J022441.12-041719.6',0.557,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23729,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1ag',NULL,23729,42.51,0.03,2040,6208,70,NULL,NULL,'[AGR2006] J022441.12-041719.6',0.557,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23730,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1ag',NULL,23730,42.51,0.21,2040,6208,65,NULL,'MLCS17','[AGR2006] J022441.12-041719.6',0.557,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23731,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1ag',NULL,23731,42.6,0.18,2120,6208,65,NULL,'MLCS2k2','[AGR2006] J022441.12-041719.6',0.557,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23732,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1ag',NULL,23732,42.62,0.21,2150,6208,65,NULL,'MLCS31','[AGR2006] J022441.12-041719.6',0.557,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23733,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1ag',NULL,23733,42.65,0.15,2180,6208,70,NULL,'SALT','[AGR2006] J022441.12-041719.6',0.557,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23734,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1ag',NULL,23734,42.78,0.03,2310,6208,65,NULL,'SALT','[AGR2006] J022441.12-041719.6',0.557,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23735,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1ag',NULL,23735,42.8,0.17,2330,6208,65,NULL,'SALT2','[AGR2006] J022441.12-041719.6',0.557,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23736,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1ag',NULL,23736,42.86,0.12,2390,6208,65,NULL,'SALT','[AGR2006] J022441.12-041719.6',0.557,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23737,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1ag',NULL,23737,43.13,0.17,2720,6208,NULL,NULL,'SALT2','[AGR2006] J022441.12-041719.6',0.557,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23738,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23738,38.45,0.46,491,6209,70,NULL,NULL,'SDSS J022441.77-003754.3',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000077,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,36.174083,-0.63178,0.057,NULL,34927138577,545736540,8527133,18),(23739,'IRAS','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23739,35.53,0.8,128,6210,75,NULL,'W91PP, r','UGC 01860',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00003,NULL,'14.44',0.9,'SB(rs)b',NULL,NULL,NULL,NULL,1,36.175625,25.56108,0.221,NULL,68610584583,1072040384,16750631,14.44),(23740,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23740,34.79,0.69,90.9,6210,100,NULL,'mid-IR','UGC 01860',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23741,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23741,35.36,0.38,118,6210,75,NULL,'W91PP, r, raw','UGC 01860',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23742,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23742,35.51,0.3,127,6210,NULL,NULL,NULL,'UGC 01860',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23743,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23743,35.55,0.2,129,6210,74.4,NULL,NULL,'UGC 01860',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23744,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23744,35.61,0.29,133,6210,NULL,NULL,'Malmquist cor.','UGC 01860',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23745,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23745,35.65,0.38,135,6210,75,NULL,'W91PP, r, inv','UGC 01860',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23746,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23746,35.66,0.38,135,6210,75,NULL,'W91PP, r, cor','UGC 01860',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23747,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23747,35.67,0.47,136,6210,NULL,NULL,'H','UGC 01860',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23748,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23748,35.73,0.4,140,6210,NULL,NULL,'mean','UGC 01860',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23749,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23749,35.82,0.45,146,6210,NULL,NULL,'K','UGC 01860',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23750,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23750,35.83,0.46,147,6210,NULL,NULL,'J','UGC 01860',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23751,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 11405','RN',23751,39.94,0.23,799,6211,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 11405',0.216031,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23752,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 11405','RN',23752,40.41,0.2,995,6211,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 11405',0.216031,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23753,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1hx',NULL,23753,42.49,0.14,2020,6212,70,NULL,'SALT 2','[NSB2006] J022442.48-044725.3',0.56,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',0.001,NULL,'22.4r',NULL,NULL,NULL,NULL,NULL,NULL,1,36.177,-4.79039,0.021,NULL,34950376305,546099629,8532806,22.4),(23754,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1hx',NULL,23754,42.5,0.15,2030,6212,NULL,NULL,'SIFTO','[NSB2006] J022442.48-044725.3',0.56,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23755,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1hx',NULL,23755,42.53,NULL,2050,6212,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','[NSB2006] J022442.48-044725.3',0.56,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23756,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1hx',NULL,23756,43.19,0.17,2790,6212,NULL,NULL,'SALT2','[NSB2006] J022442.48-044725.3',0.56,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23757,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1hx',NULL,23757,43.32,0.04,2950,6212,70,NULL,'SIFTO','[NSB2006] J022442.48-044725.3',0.56,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23758,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 04508','RN',23758,43.39,0.18,3040,6213,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04508',0.569554,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23759,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23759,36.93,0.33,243,6214,70,NULL,NULL,'SDSS J022443.14-005109.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00006,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,36.17975,-0.85258,0.049,NULL,34927991410,545749865,8527341,18.4),(23760,'TRGB','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23760,26.63,0.07,2.12,6215,NULL,NULL,'HST ACS F814W band','SGC 0224.3-7345',NULL,'2015MNRAS.447L..85K',2015,1,2.3,'Position in 2000A&AS..144..475P is for star superposed on southwest side.','G',NULL,NULL,'16.0B',0.9,'E3',NULL,NULL,NULL,NULL,1,36.18575,-73.51367,0.097,0,35602924179,556295690,8692120,16),(23761,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23761,35.33,0.25,116,6216,74.4,NULL,NULL,'UGC 01859',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.000057,NULL,'13.90',1.1,'E?',NULL,NULL,NULL,NULL,1,36.185125,42.62325,0.285,NULL,68537894723,1070904605,16732884,13.9),(23762,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,'R',23762,36.94,0.46,245,6217,70,NULL,NULL,'2MASX J02244497-0732581',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000101,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,36.1874166667,-7.54936,0.069,NULL,34941889577,545967024,8530734,16.5),(23763,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1ee',NULL,23763,42.07,0.17,1670,6218,NULL,NULL,'SALT2','XMM:[RBO2008] ir 00074601',0.558,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',NULL,NULL,'21.7r',NULL,NULL,NULL,NULL,NULL,NULL,1,36.194875,-4.00053,0.041,NULL,34919356018,545614937,8525233,21.7),(23764,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1ee',NULL,23764,42.56,0.14,2090,6218,70,NULL,'SALT 2','XMM:[RBO2008] ir 00074601',0.558,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23765,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1ee',NULL,23765,42.63,0.15,2150,6218,NULL,NULL,'SIFTO','XMM:[RBO2008] ir 00074601',0.558,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23766,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 05D1ee',NULL,23766,42.9,0.04,2440,6218,70,NULL,'SALT2','XMM:[RBO2008] ir 00074601',0.558,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23767,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1iv',NULL,23767,43.39,0.08,2380,6219,70,NULL,'SIFTO','SNLS 04D1iv HOST',0.998,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,'24.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,36.2004583,-4.15258,0.045,NULL,34919399740,545615620,8525244,24.2),(23768,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1iv',NULL,23768,44.17,0.15,3420,6219,NULL,NULL,'SIFTO','SNLS 04D1iv HOST',0.998,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23769,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1iv',NULL,23769,44.26,0.22,3560,6219,70,NULL,'SALT 2','SNLS 04D1iv HOST',0.998,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23770,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1iv',NULL,23770,46.16,0.17,8530,6219,NULL,NULL,'SALT2','SNLS 04D1iv HOST',0.998,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23771,'G Lens','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23771,47.43,0.17,15300,6219,NULL,NULL,'SNLS 04D1iv HOST','SNLS 04D1iv HOST',0.998,'2010A&A...514A..44K',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23772,'Faber-Jackson','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23772,47.36,0.17,14800,6219,NULL,NULL,'SNLS 04D1iv HOST','SNLS 04D1iv HOST',0.998,'2010A&A...514A..44K',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23773,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1si',NULL,23773,43.04,0.19,2380,6220,70,NULL,'SALT 2','VVDS:[RBO2008] ir 00050831',0.702,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',0.001,NULL,'22.3r',NULL,'Candidate      QSO',NULL,NULL,NULL,NULL,1,36.2032083333,-4.56897,0.021,NULL,34949306642,546082916,8532545,22.3),(23774,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1si',NULL,23774,43.05,0.15,2390,6220,NULL,NULL,'SIFTO','VVDS:[RBO2008] ir 00050831',0.702,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23775,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1si',NULL,23775,43.08,0.05,2420,6220,70,NULL,'SIFTO','VVDS:[RBO2008] ir 00050831',0.702,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23776,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1si',NULL,23776,43.37,0.17,2780,6220,NULL,NULL,'SALT2','VVDS:[RBO2008] ir 00050831',0.702,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23777,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 10794','RN',23777,41.54,0.57,1870,6221,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10794',0.08749,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23778,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 10794','RN',23778,42.87,0.75,3450,6221,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10794',0.08749,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23779,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 15426','RN',23779,38.61,0.45,486,6222,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15426',0.084712,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23780,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 15426','RN',23780,38.69,0.51,504,6222,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15426',0.084712,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23781,'FP','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23781,34.47,0.23,78.3,6223,74.4,NULL,NULL,'CGCG 538-065',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000183,NULL,'15.4',1,'E',NULL,NULL,NULL,NULL,1,36.221875,43.32511,0.337,NULL,68537064918,1070891639,16732681,15.4),(23782,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1cm','R',23782,42.83,NULL,1960,6224,65,NULL,'SALT','[HSP2005] J022455.28-042303.68',0.87,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.02,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,36.230375,-4.38436,0.049,NULL,34949337157,546083393,8532553,NULL),(23783,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1cm',NULL,23783,43.51,0.28,2690,6224,74.2,NULL,'SALT 2','[HSP2005] J022455.28-042303.68',0.87,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23784,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1cm',NULL,23784,44,0.12,3370,6224,65,NULL,'MLCS2k2','[HSP2005] J022455.28-042303.68',0.87,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23785,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1cm',NULL,23785,44.08,0.5,3500,6224,70,NULL,'SALT','[HSP2005] J022455.28-042303.68',0.87,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23786,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1cm',NULL,23786,44.1,0.3,3530,6224,70,NULL,NULL,'[HSP2005] J022455.28-042303.68',0.87,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23787,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1cm',NULL,23787,44.26,0.46,3810,6224,65,NULL,'SALT','[HSP2005] J022455.28-042303.68',0.87,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23788,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1cm',NULL,23788,44.38,0.2,4020,6224,65,NULL,'SALT','[HSP2005] J022455.28-042303.68',0.87,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23789,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 1995aw','R',23789,40.63,NULL,954,6225,65,NULL,'SALT','[PDG95a] J022455.55+005307.7',0.4,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.03,NULL,'23.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,36.231417,0.88572,0.073,NULL,66889539149,1045149049,16330453,23.7),(23790,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 1995aw',NULL,23790,41.61,0.48,1500,6225,74.2,NULL,'SALT 2','[PDG95a] J022455.55+005307.7',0.4,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23791,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 1995aw',NULL,23791,42.04,0.19,1830,6225,65,NULL,NULL,'[PDG95a] J022455.55+005307.7',0.4,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23792,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 1995aw',NULL,23792,42.11,0.38,1890,6225,70,NULL,'SALT','[PDG95a] J022455.55+005307.7',0.4,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23793,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 1995aw',NULL,23793,42.33,0.36,2090,6225,65,NULL,'SALT','[PDG95a] J022455.55+005307.7',0.4,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23794,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1gt',NULL,23794,40.86,0.17,962,6226,NULL,NULL,'SALT2','[AGR2006] J022456.02-040737.1',0.548,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,'22.3r',NULL,NULL,NULL,NULL,NULL,NULL,1,36.2334583,-4.12697,0.045,NULL,34919394210,545615534,8525242,22.3),(23795,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1gt',NULL,23795,41.57,0.19,1330,6226,74.2,NULL,'SALT 2','[AGR2006] J022456.02-040737.1',0.548,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23796,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1gt',NULL,23796,42.4,0.42,1950,6226,65,NULL,'MLCS31','[AGR2006] J022456.02-040737.1',0.548,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23797,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1gt',NULL,23797,42.42,0.34,1970,6226,65,NULL,'MLCS17','[AGR2006] J022456.02-040737.1',0.548,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23798,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1gt',NULL,23798,42.42,0.41,1970,6226,65,NULL,'MLCS2k2','[AGR2006] J022456.02-040737.1',0.548,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23799,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1gt',NULL,23799,42.52,0.23,2060,6226,65,NULL,'SALT2','[AGR2006] J022456.02-040737.1',0.548,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23800,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1gt',NULL,23800,42.68,0.16,2220,6226,70,NULL,'SALT','[AGR2006] J022456.02-040737.1',0.548,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23801,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1gt',NULL,23801,42.79,0.17,2330,6226,65,NULL,'SALT','[AGR2006] J022456.02-040737.1',0.548,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23802,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1gt',NULL,23802,42.83,0.08,2370,6226,70,NULL,NULL,'[AGR2006] J022456.02-040737.1',0.548,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23803,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1gt','R',23803,42.93,NULL,2490,6226,65,NULL,'MLCS31','[AGR2006] J022456.02-040737.1',0.548,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23804,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 03D1gt',NULL,23804,43.09,0.09,2680,6226,65,NULL,'SALT','[AGR2006] J022456.02-040737.1',0.548,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23805,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 06D1ab',NULL,23805,37.51,0.17,269,6227,NULL,NULL,'SALT2','APMUKS(BJ) B022228.46-045423.5',0.182,'2010A&A...523A...7G',2010,1,0.12,NULL,'G',0.001,NULL,'18.1R',0.09,NULL,NULL,NULL,NULL,NULL,1,36.2455833333,-4.68089,0.021,NULL,34950413237,546100206,8532815,18.1),(23806,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 06D1ab',NULL,23806,39.75,0.15,753,6227,NULL,NULL,'SIFTO','APMUKS(BJ) B022228.46-045423.5',0.182,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23807,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23807,29.96,0.4,9.8,6228,75,NULL,'B','UGC 01865',NULL,'1988NBGC.C....0000T',1988,1,2.9,NULL,'G',0.000017,NULL,'16.5',2.2,'Sm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,36.250917,36.03778,0.205,NULL,68632690487,1072385788,16756027,16.5),(23808,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23808,36.33,NULL,185,6229,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01870',NULL,'2010Ap&SS.325..163P',2010,1,1.34,NULL,'G',0.000033,NULL,'18.',0.17,'Sbc',NULL,NULL,NULL,NULL,1,36.252583,19.7025,0.449,NULL,68113287455,1064270116,16629220,18),(23809,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23809,36.34,NULL,185,6229,NULL,NULL,'Dipole + Quadrupole','UGC 01870',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23810,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23810,36.34,NULL,186,6229,NULL,NULL,'Dipole','UGC 01870',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23811,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23811,36.5,NULL,199,6229,NULL,NULL,NULL,'UGC 01870',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23812,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 21582',NULL,23812,40.49,0.22,1250,6230,70,NULL,'SN photometric redshift distance, z photo =0.352 +/- 0.047','SDSS-II SN 21582',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,36.256667,-0.51531,0.069,NULL,34927132321,545736442,8527131,NULL),(23813,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1oh',NULL,23813,42.43,0.04,1930,6231,70,NULL,NULL,'[NSB2006] J022502.37-041410.5',0.59,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,36.259875,-4.23625,0.049,NULL,34919185146,545612267,8525191,NULL),(23814,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1oh',NULL,23814,42.68,0.18,2160,6231,72,NULL,NULL,'[NSB2006] J022502.37-041410.5',0.59,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23815,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1oh',NULL,23815,42.69,0.14,2170,6231,70,NULL,'SALT 2','[NSB2006] J022502.37-041410.5',0.59,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23816,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1oh',NULL,23816,42.78,0.15,2260,6231,NULL,NULL,'SIFTO','[NSB2006] J022502.37-041410.5',0.59,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23817,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SNLS 04D1oh',NULL,23817,42.86,0.17,2340,6231,NULL,NULL,'SALT2','[NSB2006] J022502.37-041410.5',0.59,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23818,'SNII optical','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2002gw',NULL,23818,32.86,0.26,37.4,6232,NULL,NULL,'EPM E96','NGC 0922',NULL,'2009ApJ...696.1176J',2009,1,1.9,NULL,'G',0.000018,NULL,'12.1B',1.6,'SB(s)cd pec    HII','Line-of-sight pair member',NULL,NULL,NULL,1,36.268417,-24.78817,0,NULL,37941914071,592842407,9263162,12.1),(23819,'SNII optical','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2002gw',NULL,23819,33.27,0.15,45.1,6232,NULL,NULL,'V, photospheric magnitude method','NGC 0922',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23820,'SNII optical','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2002gw',NULL,23820,33.34,0.06,46.6,6232,NULL,NULL,'I, photospheric magnitude method','NGC 0922',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23821,'SNII optical','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2002gw',NULL,23821,33.35,0.41,46.8,6232,NULL,NULL,'SCM, B','NGC 0922',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23822,'SNII optical','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2002gw',NULL,23822,33.41,0.28,48.1,6232,NULL,NULL,'SCM, BVI','NGC 0922',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23823,'SNII optical','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2002gw',NULL,23823,33.44,0.53,48.8,6232,NULL,NULL,'SCM, I','NGC 0922',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23824,'SNII optical','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2002gw',NULL,23824,33.46,0.54,49.2,6232,NULL,NULL,'SCM, V','NGC 0922',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23825,'SNII optical','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SN 2002gw',NULL,23825,34.03,0.53,63.9,6232,NULL,NULL,'EPM D05','NGC 0922',NULL,'2009ApJ...696.1176J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23826,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 04572','R',23826,41.16,0.3,1230,6233,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 04572',0.384125,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,36.2684583333,0.396,0.057,NULL,66875129949,1044923905,16326936,NULL),(23827,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 04572','R',23827,41.35,0.28,1350,6233,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 04572',0.384125,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23828,'SNIa','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 04572',NULL,23828,40.78,0.19,1440,6233,70,NULL,'SN photometric redshift distance, z photo =0.417 +/- 0.050','SDSS-II SN 04572',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23829,'IRAS','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23829,35.69,0.8,137,6234,75,NULL,'W91PP, r','UGC 01871',NULL,'1997ApJS..109..333W',1997,1,0.8,NULL,'G',0.000103,NULL,'14.87',0.5,'S?             HII',NULL,NULL,NULL,NULL,1,36.269167,22.21697,0.329,NULL,68105698077,1064151532,16627367,14.87),(23830,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23830,34.96,0.69,98.2,6234,100,NULL,'mid-IR','UGC 01871',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23831,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23831,35.68,0.45,137,6234,NULL,NULL,'K','UGC 01871',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23832,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23832,35.78,0.47,144,6234,NULL,NULL,'H','UGC 01871',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23833,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23833,35.82,0.4,146,6234,NULL,NULL,'mean','UGC 01871',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23834,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23834,35.93,0.38,153,6234,75,NULL,'W91PP, r, raw','UGC 01871',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23835,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23835,35.95,0.46,155,6234,NULL,NULL,'J','UGC 01871',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23836,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23836,36.1,0.38,166,6234,75,NULL,'W91PP, r, cor','UGC 01871',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23837,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23837,36.29,0.38,181,6234,75,NULL,'W91PP, r, inv','UGC 01871',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23838,'Tully-Fisher','2016-12-15 15:13:52','2016-12-16 11:18:55','1',NULL,NULL,23838,36.77,0.2,226,6234,74.4,NULL,NULL,'UGC 01871',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23839,'SNIa SDSS','2016-12-15 15:13:52','2016-12-16 11:18:55','1','SDSS-II SN 10747','RN',23839,38.62,0.11,509,6235,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10747',0.041152,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23840,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SDSS-II SN 10747','RN',23840,39.63,0.22,810,6235,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10747',0.041152,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23841,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SNLS 05D1cl',NULL,23841,43.17,0.06,2350,6236,70,NULL,'SALT2','SNLS 05D1cl HOST',0.83,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.01,NULL,'26.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,36.273417,-4.22075,0.049,NULL,34919171489,545612054,8525188,26.2),(23842,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SNLS 05D1cl',NULL,23842,43.91,0.15,3310,6236,NULL,NULL,'SIFTO','SNLS 05D1cl HOST',0.83,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23843,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SNLS 05D1cl',NULL,23843,46.75,0.17,12200,6236,NULL,NULL,'SALT2','SNLS 05D1cl HOST',0.83,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23844,'FP','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23844,36.29,0.57,181,6237,70,NULL,NULL,'2MASX J02250641-0618341',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.52',0.37,NULL,NULL,NULL,NULL,NULL,1,36.2768333333,-6.30953,0.073,NULL,34942018293,545969035,8530766,16.52),(23845,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SDSS-II SN 21029','RN',23845,44.63,0.38,5530,6238,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 21029',0.52794,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23846,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SNLS 04D1rx',NULL,23846,43.67,0.08,2730,6239,70,NULL,'SIFTO','SNLS 04D1rx HOST',0.985,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,36.2959583,-4.61836,0.021,NULL,34950388990,546099827,8532809,NULL),(23847,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SNLS 04D1rx',NULL,23847,44.23,0.23,3540,6239,70,NULL,'SALT 2','SNLS 04D1rx HOST',0.985,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23848,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SNLS 04D1rx',NULL,23848,44.23,0.15,3540,6239,NULL,NULL,'SIFTO','SNLS 04D1rx HOST',0.985,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23849,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SNLS 04D1rx',NULL,23849,45.19,0.17,5490,6239,NULL,NULL,'SALT2','SNLS 04D1rx HOST',0.985,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23850,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SDSS-II SN 17851','R',23850,41.14,0.26,1250,6240,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17851',0.353082,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,'PHOT','20.9g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,36.296,0.75886,0.061,NULL,66888828043,1045137938,16330280,20.9),(23851,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SDSS-II SN 17851',NULL,23851,40.69,0.82,1370,6240,70,NULL,'SN photometric redshift distance, z photo =0.394 +/- 0.266','SDSS-II SN 17851',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23852,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SDSS-II SN 17851','R',23852,41.36,0.33,1380,6240,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17851',0.353082,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23853,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SNLS 05D1az',NULL,23853,43.25,0.06,2430,6241,70,NULL,'SIFTO','SNLS 05D1az HOST',0.842,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'a',NULL,NULL,NULL,NULL,1,36.3020417,-4.60228,0.021,NULL,34950388494,546099820,8532809,NULL),(23854,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SNLS 05D1az',NULL,23854,43.55,0.21,2780,6241,70,NULL,'SALT 2','SNLS 05D1az HOST',0.842,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23855,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SNLS 05D1az',NULL,23855,43.73,0.15,3030,6241,NULL,NULL,'SIFTO','SNLS 05D1az HOST',0.842,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23856,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SNLS 05D1az',NULL,23856,45.69,0.17,7470,6241,NULL,NULL,'SALT2','SNLS 05D1az HOST',0.842,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23857,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SNLS 04D1pp',NULL,23857,42.08,0.17,1500,6242,NULL,NULL,'SALT2','VVDS:[RBO2008] ir 00044242',0.735,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,'21.7r',NULL,NULL,NULL,NULL,NULL,NULL,1,36.301917,-4.70172,0.021,NULL,34950393782,546099902,8532810,21.7),(23858,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SNLS 04D1pp',NULL,23858,43.18,0.15,2490,6242,NULL,NULL,'SIFTO','VVDS:[RBO2008] ir 00044242',0.735,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23859,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SNLS 04D1pp',NULL,23859,43.19,0.05,2510,6242,70,NULL,'SALT2','VVDS:[RBO2008] ir 00044242',0.735,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23860,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SNLS 04D1pp',NULL,23860,43.22,NULL,2540,6242,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','VVDS:[RBO2008] ir 00044242',0.735,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23861,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SNLS 04D1pp',NULL,23861,43.26,0.19,2580,6242,70,NULL,'SALT 2','VVDS:[RBO2008] ir 00044242',0.735,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23862,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SDSS-II SN 10239','RN',23862,41.51,0.72,1600,6243,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10239',0.255744,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23863,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23863,36.19,0.2,173,6244,74.4,NULL,NULL,'CGCG 462-009',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'15.47',0.3,NULL,NULL,NULL,NULL,NULL,1,36.308667,20.95525,0.353,NULL,68115380325,1064302817,16629731,15.47),(23864,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,'R',23864,35.98,0.49,157,6245,75,NULL,'IR','CGCG 462-009',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.47',0.3,NULL,NULL,NULL,NULL,NULL,1,36.308667,20.95525,0.353,NULL,68115380325,1064302817,16629731,15.47),(23865,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,'R',23865,33.57,0.49,51.8,6246,75,NULL,'IR','UGC 01867',NULL,'2011yCatp016004901K',2011,1,2.02,NULL,'G',0.000037,NULL,'15.1',0.2,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,36.314917,45.45125,0.713,NULL,67821266244,1059707285,16557926,15.1),(23866,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23866,33.6,NULL,52.5,6246,NULL,NULL,NULL,'UGC 01867',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23867,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23867,33.65,NULL,53.7,6246,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01867',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23868,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23868,33.66,NULL,53.8,6246,NULL,NULL,'Dipole','UGC 01867',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23869,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23869,33.66,NULL,53.9,6246,NULL,NULL,'Dipole + Quadrupole','UGC 01867',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23870,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23870,33.72,0.2,55.5,6246,74.4,NULL,NULL,'UGC 01867',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23871,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23871,33.84,0.43,58.5,6246,75,NULL,'3.6 micron, color corrected','UGC 01867',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23872,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23872,33.9,0.43,60.2,6246,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01867',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23873,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SDSS-II SN 14751','RN',23873,41,0.18,1270,6247,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14751',0.242695,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23874,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SDSS-II SN 14751','RN',23874,41.21,0.21,1400,6247,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14751',0.242695,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23875,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23875,35.75,0.4,141,6248,NULL,NULL,'mean','CGCG 483-035',NULL,'2007A&A...465...71T',2007,1,0.7,NULL,'G',0.000033,NULL,'15.10',0.3,'S?',NULL,NULL,NULL,NULL,1,36.318083,24.26481,0.285,NULL,68086205234,1063846956,16622608,15.1),(23876,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23876,35.99,0.47,158,6248,NULL,NULL,'H','CGCG 483-035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23877,'FP','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,'R',23877,36.69,0.33,217,6249,70,NULL,NULL,'2MASX J02251691-0841372',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000088,NULL,'16.0g',0.39,'BrClG',NULL,NULL,NULL,NULL,1,36.320375,-8.69378,0.061,NULL,34944792214,546012378,8531443,16),(23878,'FP','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,'R',23878,38.02,0.46,401,6250,70,NULL,NULL,'2MASX J02252018-0011443',NULL,'2015arXiv151105856S',2015,1,0.09,NULL,'G',0.000084,NULL,'17.7g',0.08,NULL,NULL,NULL,NULL,NULL,1,36.3342083333,-0.19567,0.073,NULL,34915528711,545555136,8524299,17.7),(23879,'FP','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,'R',23879,39.06,0.46,649,6251,70,NULL,NULL,'2MASX J02252102-0849162',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000082,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,36.3377083,-8.82117,0.061,NULL,34944756812,546011825,8531434,18.5),(23880,'FP','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23880,36.48,0.57,198,6252,70,NULL,NULL,'2MASX J02252168-0613052',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'16.48',0.37,NULL,NULL,NULL,NULL,NULL,1,36.340333,-6.21822,0.057,NULL,34941975520,545968367,8530755,16.48),(23881,'FP','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,'R',23881,35.5,0.46,126,6253,70,NULL,NULL,'2MASX J02252209-0751062',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000075,NULL,'16.3g',0.3,'AGN+SF',NULL,NULL,NULL,NULL,1,36.342125,-7.85169,0.077,NULL,34940109447,545939210,8530300,16.3),(23882,'FP','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23882,33.99,0.23,62.8,6254,74.4,NULL,NULL,'NGC 0909',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.00004,NULL,'14.28',0.9,'E','Group member',NULL,NULL,NULL,1,36.3449583333,42.03567,0.241,NULL,68537815117,1070903361,16732865,14.28),(23883,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SNLS 05D1eo',NULL,23883,42.03,0.17,1470,6255,NULL,NULL,'SALT2','VVDS:[RBO2008] ir 00045922',0.737,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',NULL,NULL,'22.6r',NULL,NULL,NULL,NULL,NULL,NULL,1,36.346333,-4.64261,0.021,NULL,34950395354,546099927,8532811,22.6),(23884,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SNLS 05D1eo',NULL,23884,43.42,0.23,2770,6255,70,NULL,'SALT 2','VVDS:[RBO2008] ir 00045922',0.737,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23885,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SNLS 05D1eo',NULL,23885,43.44,0.15,2810,6255,NULL,NULL,'SIFTO','VVDS:[RBO2008] ir 00045922',0.737,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23886,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SNLS 05D1eo',NULL,23886,43.61,0.05,3040,6255,70,NULL,'SALT2','VVDS:[RBO2008] ir 00045922',0.737,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23887,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SDSS-II SN 18083',NULL,23887,39.19,0.43,688,6256,70,NULL,'SN photometric redshift distance, z photo =0.176 +/- 0.043','SDSS-II SN 18083',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,36.349125,-1.20822,0.045,NULL,34927836315,545747442,8527303,NULL),(23888,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SDSS-II SN 18083','R',23888,40.54,0.28,995,6256,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18083',0.289396,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23889,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SDSS-II SN 18083','R',23889,40.58,0.26,1010,6256,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18083',0.289396,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23890,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SDSS-II SN 18083',NULL,23890,40.36,0.17,1180,6256,70,NULL,'SALT 2','SDSS-II SN 18083',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23891,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SDSS-II SN 18083',NULL,23891,40.39,0.17,1200,6256,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18083',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23892,'FP','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,'R',23892,38.36,0.33,470,6257,70,NULL,NULL,'2MASX J02252628-0844302',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000095,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,36.3594583,-8.74183,0.061,NULL,34944786381,546012287,8531441,17.6),(23893,'D-Sigma','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23893,34.12,0.17,66.8,6258,72,NULL,'ABELL 0347 cluster, 7 galaxies','NGC 0910',NULL,'2002AJ....123.2159B',2002,1,2,NULL,'G',0.00007,NULL,'13.18',2,'E+','Group member',NULL,NULL,NULL,1,36.3615833333,41.82428,0.241,NULL,68537681763,1070901277,16732832,13.18),(23894,'FP','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23894,34.08,0.25,65.5,6258,74.4,NULL,NULL,'NGC 0910',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23895,'FP','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23895,34.36,0.15,74.5,6258,75,NULL,'ABELL 0347 cluster, 8 galaxies','NGC 0910',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23896,'FP','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23896,34.36,0.15,74.5,6258,75,NULL,'ABELL 0347 cluster, 8 galaxies','NGC 0910',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23897,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23897,34.35,0.4,74,6258,NULL,NULL,'mean','NGC 0910',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23898,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23898,34.73,0.45,88.2,6258,NULL,NULL,'K','NGC 0910',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23899,'FP','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23899,35.71,0.25,139,6259,74.4,NULL,NULL,'CGCG 523-037',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000067,NULL,'15.0',0.3,'E?             AGN',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,36.363875,37.17436,0.193,NULL,68654276499,1072723070,16761297,15),(23900,'FP','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23900,35.93,0.33,153,6259,70,NULL,NULL,'CGCG 523-037',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23901,'IRAS','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23901,33.96,0.8,62,6260,75,NULL,'MAT, I','ESO 479- G 001',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.00001,NULL,'14.09',1.3,'SB(s)cd:',NULL,NULL,NULL,NULL,1,36.368083,-25.63792,0,NULL,38424109617,600376712,9380886,14.09),(23902,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23902,32.94,0.32,38.7,6260,85,NULL,'I, raw','ESO 479- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23903,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23903,32.94,0.32,38.8,6260,85,NULL,'I, inv','ESO 479- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23904,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23904,33.12,0.43,42.1,6260,75,NULL,'MAT, I, raw','ESO 479- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23905,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23905,33.16,1.1,42.8,6260,NULL,NULL,'Malmquist cor.','ESO 479- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23906,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23906,33.19,1.09,43.4,6260,NULL,NULL,NULL,'ESO 479- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23907,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23907,33.19,0.43,43.5,6260,75,NULL,'MAT, I, inv','ESO 479- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23908,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23908,33.23,0.2,44.3,6260,74.4,NULL,NULL,'ESO 479- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23909,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23909,33.5,0.43,50.1,6260,75,NULL,'MAT, I, cor','ESO 479- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23910,'FP','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,'R',23910,36.23,0.46,176,6261,70,NULL,NULL,'2MASX J02252855-0747572',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000095,NULL,'16.1g',0.39,'E0',NULL,NULL,NULL,NULL,1,36.3689583,-7.79917,0.077,NULL,34940101031,545939078,8530298,16.1),(23911,'FP','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23911,36.51,0.55,201,6262,70,NULL,NULL,'2MASX J02252977-0400413',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.000093,NULL,'14.8g',0.51,NULL,NULL,NULL,NULL,NULL,1,36.3740417,-4.01164,0.045,NULL,34919263109,545613486,8525210,14.8),(23912,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,'R',23912,34.02,0.49,63.8,6263,75,NULL,'IR','UGC 01883',NULL,'2011yCatp016004901K',2011,1,2.2,NULL,'G',0.000013,NULL,'15.10',0.6,'Sd:',NULL,NULL,NULL,NULL,1,36.3748333333,11.47153,0.253,NULL,66857288043,1044645125,16322580,15.1),(23913,'FP','2016-12-15 15:13:53','2016-12-16 11:18:55','1',NULL,NULL,23913,35.88,0.48,150,6264,70,NULL,NULL,'AM 0224-594',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.000143,NULL,'15.65',0.57,'E',NULL,NULL,NULL,NULL,1,36.38075,-59.47731,0.077,NULL,36142474043,564726156,8823846,15.65),(23914,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:55','1','SDSS-II SN 03285','RN',23914,42.03,0.19,2070,6265,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03285',0.229498,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23915,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23915,36.38,0.73,189,6266,70,NULL,NULL,'2MASX J02253625-0355413',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'17.09',0.26,NULL,NULL,NULL,NULL,NULL,1,36.4010417,-3.92811,0.045,NULL,34919282455,545613788,8525215,17.09),(23916,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23916,36.19,0.57,173,6267,70,NULL,NULL,'MCG -03-07-013',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15',0.4,NULL,NULL,NULL,NULL,NULL,1,36.4020417,-16.10958,0.046,NULL,37965933455,593217710,9269026,15),(23917,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',23917,36.95,0.46,245,6268,70,NULL,NULL,'2MASX J02253674-0825396',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000073,NULL,'18.1g',0.15,'AGN',NULL,NULL,NULL,NULL,1,36.402917,-8.42764,0.065,NULL,34944695271,546010863,8531419,18.1),(23918,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2010hs',NULL,23918,37.7,0.09,322,6269,70,NULL,'SiFTO+SALT2, SN PTF10ufj, SN 2010hs','2MASX J02253767+2445579',0.076,'2012MNRAS.426.2359M',2012,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,36.4069583333,24.76606,0.221,NULL,68086394548,1063849914,16622654,NULL),(23919,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2010hs',NULL,23919,37.62,0.04,335,6269,72,NULL,'M(H) = -18.317 mag','2MASX J02253767+2445579',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23920,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2010hs',NULL,23920,37.64,0.05,337,6269,NULL,NULL,'H, SN 2010hs','2MASX J02253767+2445579',NULL,'2012MNRAS.425.1007B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23921,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2010hs',NULL,23921,37.7,0.06,346,6269,NULL,NULL,'J, SN 2010hs','2MASX J02253767+2445579',NULL,'2012MNRAS.425.1007B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23922,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 18959','RN',23922,41.69,0.31,1550,6270,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2007ng','SDSS-II SN 18959',0.401237,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23923,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 18959','RN',23923,41.74,0.29,1590,6270,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2007ng','SDSS-II SN 18959',0.401237,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23924,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 18959','N',23924,41.61,0.21,2100,6270,70,NULL,'SALT 2','SDSS-II SN 18959',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23925,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 18959','N',23925,41.68,0.21,2170,6270,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18959',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23926,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23926,35.72,0.25,139,6271,74.4,NULL,NULL,'UGC 01877',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000097,NULL,'14.2',1.1,'E',NULL,NULL,NULL,NULL,1,36.409,36.96447,0.237,NULL,68653608174,1072712627,16761134,14.2),(23927,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23927,35.93,0.33,153,6271,70,NULL,NULL,'UGC 01877',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23928,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23928,35.58,0.45,131,6271,NULL,NULL,'K','UGC 01877',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23929,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23929,35.72,0.4,140,6271,NULL,NULL,'mean','UGC 01877',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23930,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23930,34.25,0.36,70.9,6272,NULL,NULL,'Malmquist cor.','CGCG 483-039',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000033,NULL,'15.45',0.4,'S?',NULL,NULL,NULL,NULL,1,36.4101666667,23.00081,0.309,NULL,68106543275,1064164738,16627574,15.45),(23931,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23931,34.38,0.2,75.2,6272,74.4,NULL,NULL,'CGCG 483-039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23932,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23932,34.48,0.33,78.5,6272,NULL,NULL,NULL,'CGCG 483-039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23933,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1ff',NULL,23933,43.3,0.21,2450,6273,70,NULL,'SALT 2','SNLS 04D1ff HOST',0.86,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',0.01,NULL,'25.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,36.410875,-4.90258,0.021,NULL,34950558184,546102471,8532851,25.9),(23934,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1ff',NULL,23934,43.46,0.15,2640,6273,NULL,NULL,'SIFTO','SNLS 04D1ff HOST',0.86,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23935,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1ff',NULL,23935,43.49,0.06,2680,6273,70,NULL,'SIFTO','SNLS 04D1ff HOST',0.86,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23936,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1ff',NULL,23936,44.3,0.17,3900,6273,NULL,NULL,'SALT2','SNLS 04D1ff HOST',0.86,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23937,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1er',NULL,23937,43.55,0.26,2770,6274,70,NULL,'SALT 2','XMM:[RBO2008] ir 00071187',0.85,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',NULL,NULL,'24.8r',NULL,NULL,NULL,NULL,NULL,NULL,1,36.4227917,-4.00453,0.045,NULL,34919274893,545613670,8525213,24.8),(23938,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1er',NULL,23938,43.77,0.15,3070,6274,NULL,NULL,'SIFTO','XMM:[RBO2008] ir 00071187',0.85,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23939,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1er',NULL,23939,43.96,0.07,3360,6274,70,NULL,'SIFTO','XMM:[RBO2008] ir 00071187',0.85,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23940,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1er',NULL,23940,44.29,0.17,3910,6274,NULL,NULL,'SALT2','XMM:[RBO2008] ir 00071187',0.85,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23941,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',23941,37.82,0.46,366,6275,70,NULL,NULL,'SDSS J022542.04-011231.4',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000069,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,36.4252083,-1.20875,0.045,NULL,34927710201,545745471,8527272,17.9),(23942,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23942,36.73,0.69,222,6276,70,NULL,NULL,'2MASX J02254219-0840206',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00008,NULL,'16.1g',0.4,'S0/a',NULL,NULL,NULL,NULL,1,36.425667,-8.67253,0.061,NULL,34944843314,546013176,8531455,16.1),(23943,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 20319',NULL,23943,40.04,0.46,1020,6277,70,NULL,'SN photometric redshift distance, z photo =0.275 +/- 0.079','SDSS-II SN 20319',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','20.9g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,36.426083,0.79486,0.065,NULL,66889614750,1045150230,16330472,20.9),(23944,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 20319','R',23944,40.89,0.31,1140,6277,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20319',0.318863,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23945,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 20319','R',23945,40.93,0.25,1170,6277,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20319',0.318863,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23946,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 20319',NULL,23946,40.67,0.2,1360,6277,70,NULL,'SALT 2','SDSS-II SN 20319',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23947,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 20319',NULL,23947,40.71,0.2,1390,6277,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20319',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23948,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23948,36.17,0.64,171,6278,70,NULL,NULL,'2MASX J02254232-2317439',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'16.41',0.35,'S',NULL,NULL,NULL,NULL,1,36.4262916667,-23.29561,0,NULL,37979112533,593423633,9272244,16.41),(23949,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2006em',NULL,23949,35.06,0.25,101,6279,65,NULL,'MLCS31','NGC 0911',0.019233,'2009ApJ...700.1097H',2009,1,1.7,NULL,'G',0.000053,NULL,'13.73',0.9,'E','Group member',NULL,NULL,NULL,1,36.426667,41.95628,0.241,NULL,68537690895,1070901420,16732834,13.73),(23950,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23950,34.49,0.23,79.1,6279,74.4,NULL,NULL,'NGC 0911',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23951,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23951,34.33,0.23,73.5,6280,74.4,NULL,NULL,'NGC 0912',NULL,'2013AJ....146...86T',2013,1,0.25,'1999ApJS..121..287H has V = 5627 +- 58 km/sec.','G',0.000077,NULL,'15.0',0.25,'E','Group member',NULL,NULL,NULL,1,36.4280416667,41.77744,0.241,NULL,68538152933,1070908639,16732947,15),(23952,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fc','R',23952,40.31,NULL,865,6281,65,NULL,'SALT','[AGR2006] J022543.62-040838.9',0.331,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,'20.2r',NULL,NULL,NULL,NULL,NULL,NULL,1,36.43175,-4.14414,0.049,NULL,34949463048,546085360,8532583,20.2),(23953,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fc',NULL,23953,40.34,0.14,879,6281,74.2,NULL,'SALT 2','[AGR2006] J022543.62-040838.9',0.331,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23954,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fc',NULL,23954,40.93,0.12,1150,6281,70,NULL,'SALT','[AGR2006] J022543.62-040838.9',0.331,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23955,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fc',NULL,23955,40.95,0.01,1160,6281,70,NULL,NULL,'[AGR2006] J022543.62-040838.9',0.331,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23956,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fc',NULL,23956,41.05,0.15,1220,6281,NULL,NULL,'SIFTO','[AGR2006] J022543.62-040838.9',0.331,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23957,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fc',NULL,23957,41.06,0.03,1220,6281,70,NULL,'SALT','[AGR2006] J022543.62-040838.9',0.331,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23958,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fc',NULL,23958,41.08,0.11,1240,6281,70,NULL,'SALT 2','[AGR2006] J022543.62-040838.9',0.331,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23959,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fc',NULL,23959,41.1,0.08,1240,6281,65,NULL,'SALT2','[AGR2006] J022543.62-040838.9',0.331,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23960,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fc',NULL,23960,41.09,0.09,1240,6281,65,NULL,'SALT','[AGR2006] J022543.62-040838.9',0.331,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23961,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fc',NULL,23961,41.21,0.01,1310,6281,65,NULL,'SALT','[AGR2006] J022543.62-040838.9',0.331,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23962,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fc',NULL,23962,41.22,0.17,1320,6281,65,NULL,'SALT2','[AGR2006] J022543.62-040838.9',0.331,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23963,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fc',NULL,23963,41.24,0.18,1330,6281,65,NULL,'MLCS17','[AGR2006] J022543.62-040838.9',0.331,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23964,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fc',NULL,23964,41.28,0.1,1350,6281,65,NULL,'MLCS2k2','[AGR2006] J022543.62-040838.9',0.331,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23965,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fc',NULL,23965,41.3,0.18,1370,6281,65,NULL,'MLCS2k2','[AGR2006] J022543.62-040838.9',0.331,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23966,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fc',NULL,23966,41.31,0.21,1380,6281,65,NULL,'MLCS31','[AGR2006] J022543.62-040838.9',0.331,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23967,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fc',NULL,23967,41.93,0.17,1830,6281,NULL,NULL,'SALT2','[AGR2006] J022543.62-040838.9',0.331,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23968,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 20367','RN',23968,41.72,0.31,1940,6282,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 20367',0.137,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23969,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 20367','RN',23969,42.1,0.33,2320,6282,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20367',0.137,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23970,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 03652','RN',23970,39.26,0.51,662,6283,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03652',0.074089,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23971,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 03652','RN',23971,39.45,0.61,722,6283,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03652',0.074089,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23972,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',23972,38.36,0.33,470,6284,70,NULL,NULL,'SDSS J022546.66-084509.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000075,NULL,'18.5g',0.09,NULL,NULL,NULL,NULL,NULL,1,36.4444583333,-8.75269,0.061,NULL,34944806683,546012604,8531446,18.5),(23973,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23973,37.8,0.65,363,6285,70,NULL,NULL,'2MASX J02254691-0542313',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'16.83',0.31,NULL,NULL,NULL,NULL,NULL,1,36.4455417,-5.70889,0.033,NULL,34950831567,546106743,8532917,16.83),(23974,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23974,37.1,0.72,264,6286,70,NULL,NULL,'2MASX J02254837-0601297',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'17.42',0.21,NULL,NULL,NULL,NULL,NULL,1,36.4515,-6.02494,0.045,NULL,34948515868,546070560,8532352,17.42),(23975,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',23975,38.71,0.46,552,6287,70,NULL,NULL,'SDSS J022548.70-084117.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000097,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,36.4529583,-8.68822,0.061,NULL,34944836855,546013075,8531454,18.4),(23976,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2011ek',NULL,23976,32.33,0.15,29.1,6288,70,NULL,'SiFTO+SALT2, SN 2011ek','NGC 0918',0.005027,'2012MNRAS.426.2359M',2012,1,3.5,'The 2MASS position refers to superposed star.','G',0.00001,NULL,'13.05',2,'SAB(rs)c:','Isolated galaxy',NULL,NULL,'AGN',1,36.461833,18.49625,0.441,NULL,68070443147,1063600674,16618760,13.05),(23977,'SNII optical','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2009js',NULL,23977,31.62,0.18,21.1,6288,NULL,NULL,'I, photospheric magnitude method','NGC 0918',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23978,'SNII optical','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2009js',NULL,23978,31.74,0.21,22.3,6288,NULL,NULL,'V, photospheric magnitude method','NGC 0918',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23979,'SNII optical','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2009js',NULL,23979,33.28,0.28,45.3,6288,NULL,NULL,'SCM','NGC 0918',NULL,'2015ApJ...799..215P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23980,'IRAS','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23980,31.43,0.8,19.3,6288,75,NULL,'CF, r','NGC 0918',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23981,'IRAS','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23981,31.43,0.8,19.3,6288,75,NULL,'A82, H','NGC 0918',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23982,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23982,30.72,0.69,13.9,6288,100,NULL,'mid-IR','NGC 0918',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23983,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23983,30.92,0.4,15.3,6288,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 0918',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23984,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23984,31.01,0.2,15.9,6288,74.4,NULL,NULL,'NGC 0918',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23985,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23985,31.04,0.38,16.1,6288,NULL,NULL,NULL,'NGC 0918',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23986,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23986,31.03,0.39,16.1,6288,73,NULL,'opt','NGC 0918',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23987,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23987,31.07,0.43,16.4,6288,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0918',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23988,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23988,31.1,0.38,16.6,6288,75,NULL,'CF, r, raw','NGC 0918',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23989,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23989,31.11,0.38,16.6,6288,75,NULL,'CF, r, inv','NGC 0918',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23990,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23990,31.11,0.43,16.6,6288,75,NULL,'3.6 micron, color corrected','NGC 0918',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23991,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23991,31.2,0.39,17.3,6288,NULL,NULL,NULL,'NGC 0918',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23992,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23992,31.27,0.38,17.9,6288,75,NULL,'CF, r, cor','NGC 0918',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23993,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23993,31.34,0.47,18.6,6288,75,NULL,'A82, H, raw','NGC 0918',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23994,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23994,31.35,0.36,18.6,6288,NULL,NULL,'Malmquist cor.','NGC 0918',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23995,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23995,31.37,0.47,18.8,6288,75,NULL,'A82, H, inv','NGC 0918',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23996,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23996,31.54,0.4,20.3,6288,75,NULL,'B','NGC 0918',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23997,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,23997,31.61,0.47,21,6288,75,NULL,'A82, H, cor','NGC 0918',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23998,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 13479',NULL,23998,40.97,0.38,1560,6289,70,NULL,'SN photometric redshift distance, z photo =0.465 +/- 0.125','SDSS-II SN 13479',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,36.472083,-0.37156,0.081,NULL,34927059153,545735299,8527114,NULL),(23999,'SNII optical','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1ln',NULL,23999,39.43,0.12,528,6290,NULL,NULL,'SEAM','[HSP2005] J022553.48-042703.75',0.2072,'2009ApJ...694.1067P',2009,1,NULL,NULL,'G',0.0002,NULL,'19.8r',NULL,NULL,NULL,NULL,NULL,NULL,1,36.4728333333,-4.45106,0.021,NULL,34949545365,546086646,8532603,19.8),(24000,'SNII optical','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1ln',NULL,24000,39.7,0.15,871,6290,NULL,NULL,NULL,'[HSP2005] J022553.48-042703.75',NULL,'2006ApJ...645..841N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24001,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1aj','R',24001,42.28,NULL,1660,6291,65,NULL,'SALT','[AGR2006] J022553.98-045940.5',0.72,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,36.4749166667,-4.99458,0.013,NULL,34950431487,546100491,8532820,NULL),(24002,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1aj',NULL,24002,42.46,0.19,1800,6291,74.2,NULL,'SALT 2','[AGR2006] J022553.98-045940.5',0.72,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24003,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1aj',NULL,24003,43.06,0.05,2380,6291,70,NULL,'SALT','[AGR2006] J022553.98-045940.5',0.72,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24004,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1aj',NULL,24004,43.13,0.15,2460,6291,NULL,NULL,'SIFTO','[AGR2006] J022553.98-045940.5',0.72,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24005,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1aj',NULL,24005,43.13,0.19,2460,6291,70,NULL,'SALT','[AGR2006] J022553.98-045940.5',0.72,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24006,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1aj',NULL,24006,43.15,0.23,2480,6291,70,NULL,'SALT 2','[AGR2006] J022553.98-045940.5',0.72,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24007,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1aj',NULL,24007,43.21,0.11,2550,6291,70,NULL,NULL,'[AGR2006] J022553.98-045940.5',0.72,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24008,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1aj',NULL,24008,43.29,0.16,2640,6291,65,NULL,'SALT2','[AGR2006] J022553.98-045940.5',0.72,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24009,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1aj',NULL,24009,43.3,0.22,2660,6291,65,NULL,'MLCS2k2','[AGR2006] J022553.98-045940.5',0.72,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24010,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1aj',NULL,24010,43.46,0.2,2850,6291,65,NULL,'MLCS2k2','[AGR2006] J022553.98-045940.5',0.72,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24011,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1aj',NULL,24011,43.47,0.1,2880,6291,65,NULL,'SALT','[AGR2006] J022553.98-045940.5',0.72,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24012,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1aj',NULL,24012,43.27,0.17,2900,6291,65,NULL,'SALT','[AGR2006] J022553.98-045940.5',0.72,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24013,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1aj',NULL,24013,43.34,0.2,2990,6291,65,NULL,'SALT2','[AGR2006] J022553.98-045940.5',0.72,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24014,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1aj',NULL,24014,43.42,0.22,3100,6291,65,NULL,'MLCS17','[AGR2006] J022553.98-045940.5',0.72,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24015,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1aj',NULL,24015,43.45,0.22,3140,6291,65,NULL,'MLCS31','[AGR2006] J022553.98-045940.5',0.72,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24016,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1aj',NULL,24016,43.89,0.17,3490,6291,NULL,NULL,'SALT2','[AGR2006] J022553.98-045940.5',0.72,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24017,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24017,37.46,0.61,311,6292,70,NULL,NULL,'2MASX J02255410-0520272',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00015,NULL,'16.51',0.35,NULL,NULL,NULL,NULL,NULL,1,36.475375,-5.34106,0.009,NULL,34950899525,546107805,8532934,16.51),(24018,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 06958','RN',24018,41.55,0.34,1900,6293,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06958',0.072887,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24019,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 06958','RN',24019,42.09,0.37,2440,6293,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06958',0.072887,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24020,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24020,37.57,0.46,327,6294,70,NULL,NULL,'2MASX J02255761+0112509',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000087,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,36.490125,1.21411,0.073,NULL,66889135454,1045142741,16330355,16.8),(24021,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24021,35.78,0.47,143,6295,NULL,NULL,'H','ESO 479- G 002',NULL,'2007A&A...465...71T',2007,1,0.93,NULL,'G',0.00015,NULL,'15.18',0.55,'(R\':)SB(r)a    HII',NULL,NULL,NULL,NULL,1,36.490375,-24.70961,0,NULL,37941880179,592841877,9263154,15.18),(24022,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24022,35.8,0.4,145,6295,NULL,NULL,'mean','ESO 479- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24023,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fl','R',24023,41.96,NULL,1460,6296,65,NULL,'MLCS17','[AGR2006] J022558.32-040744.1',0.688,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,'20.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,36.4930416667,-4.12894,0.049,NULL,34949453756,546085214,8532581,20.8),(24024,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fl',NULL,24024,42.34,0.17,1740,6296,74.2,NULL,'SALT 2','[AGR2006] J022558.32-040744.1',0.688,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24025,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fl',NULL,24025,43,0.15,2360,6296,65,NULL,'MLCS2k2','[AGR2006] J022558.32-040744.1',0.688,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24026,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fl',NULL,24026,43.04,0.18,2400,6296,70,NULL,'SALT','[AGR2006] J022558.32-040744.1',0.688,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24027,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fl',NULL,24027,43.05,0.05,2410,6296,70,NULL,NULL,'[AGR2006] J022558.32-040744.1',0.688,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24028,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fl',NULL,24028,43.06,0.11,2420,6296,65,NULL,'SALT2','[AGR2006] J022558.32-040744.1',0.688,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24029,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fl',NULL,24029,43.08,0.21,2440,6296,65,NULL,'MLCS17','[AGR2006] J022558.32-040744.1',0.688,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24030,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fl',NULL,24030,43.13,0.21,2500,6296,65,NULL,'MLCS2k2','[AGR2006] J022558.32-040744.1',0.688,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24031,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fl',NULL,24031,43.12,0.23,2500,6296,65,NULL,'MLCS31','[AGR2006] J022558.32-040744.1',0.688,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24032,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fl',NULL,24032,43.19,0.18,2570,6296,65,NULL,'SALT2','[AGR2006] J022558.32-040744.1',0.688,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24033,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fl',NULL,24033,43.23,0.15,2620,6296,65,NULL,'SALT','[AGR2006] J022558.32-040744.1',0.688,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24034,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fl',NULL,24034,43.25,0.04,2650,6296,65,NULL,'SALT','[AGR2006] J022558.32-040744.1',0.688,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24035,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24035,31.33,0.4,18.4,6297,75,NULL,'B','UGCA 031',NULL,'1988NBGC.C....0000T',1988,1,1.8,NULL,'G',0.000028,NULL,'14.2',1.5,'SAB(s)m:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,36.498583,-21.42114,0,NULL,37981200062,593456250,9272753,14.2),(24036,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24036,36.69,0.33,217,6298,70,NULL,NULL,'2MASX J02255992-0836167',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000083,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,36.49975,-8.60469,0.061,NULL,34944827717,546012933,8531452,17.3),(24037,'IRAS','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24037,33.85,0.8,58.9,6299,75,NULL,'CF, r','UGC 01886',NULL,'1997ApJS..109..333W',1997,1,3.7,NULL,'G',0.000027,NULL,'12.73',2,'SAB(rs)bc','Isolated galaxy',NULL,NULL,NULL,1,36.5020417,39.47092,0.157,NULL,68656016651,1072750260,16761722,12.73),(24038,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24038,33.64,0.38,53.3,6299,75,NULL,'CF, r, raw','UGC 01886',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24039,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24039,33.84,0.38,58.7,6299,75,NULL,'CF, r, inv','UGC 01886',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24040,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24040,33.91,0.38,60.4,6299,75,NULL,'CF, r, cor','UGC 01886',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24041,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24041,34.09,0.4,65.7,6299,NULL,NULL,'mean','UGC 01886',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24042,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24042,34.52,0.47,80.2,6299,NULL,NULL,'H','UGC 01886',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24043,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24043,34.53,0.46,80.6,6299,NULL,NULL,'J','UGC 01886',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24044,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24044,34.54,0.45,81,6299,NULL,NULL,'K','UGC 01886',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24045,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24045,36.39,0.56,190,6300,70,NULL,NULL,'ESO 479- G 003',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000133,NULL,'15.24',0.9,'S0       poss. LINER',NULL,NULL,NULL,NULL,1,36.5029583333,-23.96078,0,NULL,37975647229,593369487,9271398,15.24),(24046,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 10865','RN',24046,38.53,0.12,497,6301,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10865',0.023057,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24047,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 15423',NULL,24047,40.51,0.08,1260,6302,70,NULL,'SN photometric redshift distance, z photo =0.355 +/- 0.016','SDSS-II SN 15423',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,36.5080417,0.62611,0.057,NULL,66888750645,1045136728,16330261,NULL),(24048,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 15423','R',24048,41.78,0.22,1630,6302,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15423',0.395058,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24049,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 15423','R',24049,42.14,0.16,1920,6302,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15423',0.395058,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24050,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 15423',NULL,24050,41.68,0.12,2170,6302,70,NULL,'SALT 2','SDSS-II SN 15423',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24051,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 15423',NULL,24051,41.75,0.12,2240,6302,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15423',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24052,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24052,37.7,0.46,347,6303,70,NULL,NULL,'2MASX J02260274-0745497',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00015,NULL,'17.50',0.28,NULL,NULL,NULL,NULL,NULL,1,36.5114583,-7.76383,0.085,NULL,34939925230,545936331,8530255,17.5),(24053,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 16225',NULL,24053,34.64,3.05,84.8,6304,70,NULL,'SN photometric redshift distance, z photo =0.020 +/- 0.064','SDSS-II SN 16225',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,36.5120417,0.26114,0.049,NULL,66888726183,1045136346,16330255,NULL),(24054,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 14540',NULL,24054,39.97,0.16,985,6305,70,NULL,'SN photometric redshift distance, z photo =0.264 +/- 0.024','SDSS-II SN 14540',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,36.5122917,0.58206,0.057,NULL,66888777935,1045137155,16330268,NULL),(24055,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 17205','RN',24055,39.87,0.2,792,6306,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17205',0.192245,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24056,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 17205','RN',24056,40.02,0.15,846,6306,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17205',0.192245,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24057,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 18450',NULL,24057,39.8,0.82,914,6307,70,NULL,'SN photometric redshift distance, z photo =0.242 +/- 0.138','SDSS-II SN 18450',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,36.5205416667,-0.72767,0.065,NULL,34927189648,545737338,8527145,NULL),(24058,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24058,34.31,0.43,72.9,6308,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0914',NULL,'2014MNRAS.444..527S',2014,1,1.8,NULL,'G',0.00002,NULL,'13.66',1.3,'SA(s)c','Group member',NULL,NULL,NULL,1,36.5215833333,42.14408,0.265,NULL,68537727771,1070901996,16732843,13.66),(24059,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24059,34.35,0.4,74.2,6308,NULL,NULL,'mean','NGC 0914',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24060,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24060,34.36,0.43,74.5,6308,75,NULL,'3.6 micron, color corrected','NGC 0914',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24061,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24061,34.48,0.47,78.7,6308,NULL,NULL,'H','NGC 0914',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24062,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24062,34.5,0.45,79.3,6308,NULL,NULL,'K','NGC 0914',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24063,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24063,34.56,0.2,81.7,6308,74.4,NULL,NULL,'NGC 0914',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24064,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24064,34.56,0.46,81.7,6308,NULL,NULL,'J','NGC 0914',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24065,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24065,34.6,0.44,83.2,6308,NULL,NULL,'Malmquist cor.','NGC 0914',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24066,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24066,34.76,0.41,89.4,6308,NULL,NULL,NULL,'NGC 0914',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24067,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1ej',NULL,24067,39.51,0.17,609,6309,NULL,NULL,'SALT2','VVDS:[RBO2008] ir 00039770',0.312,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',NULL,NULL,'19.7r',NULL,NULL,NULL,NULL,NULL,NULL,1,36.5263333333,-4.72939,0.021,NULL,34950532217,546102065,8532844,19.7),(24068,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1ej',NULL,24068,40.84,0.15,1120,6309,NULL,NULL,'SIFTO','VVDS:[RBO2008] ir 00039770',0.312,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24069,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24069,34.69,0.39,86.6,6310,NULL,NULL,NULL,'NGC 0926',NULL,'2009ApJS..182..474S',2009,1,1.72,NULL,'G',0.000033,NULL,'13.8g',0.79,'SB(rs)bc:poss. LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,36.5279583,-0.33194,0.081,NULL,34927061663,545735338,8527114,13.8),(24070,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24070,34.71,0.47,87.3,6310,NULL,NULL,'H','NGC 0926',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24071,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24071,34.71,0.4,87.3,6310,NULL,NULL,'mean','NGC 0926',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24072,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24072,34.72,0.46,87.7,6310,NULL,NULL,'J','NGC 0926',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24073,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24073,34.77,0.37,89.9,6310,NULL,NULL,'Malmquist cor.','NGC 0926',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24074,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24074,34.78,0.45,90.3,6310,NULL,NULL,'K','NGC 0926',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24075,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24075,34.89,0.2,95.1,6310,74.4,NULL,NULL,'NGC 0926',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24076,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 16090','RN',24076,43.97,0.44,4150,6311,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16090',0.502136,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24077,'IRAS','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24077,34.31,0.8,72.7,6312,75,NULL,'W91PP, r','NGC 0917',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'14.20',1,'Sab',NULL,NULL,NULL,NULL,1,36.5320416667,31.91233,0.257,NULL,68637333660,1072458338,16757161,14.2),(24078,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24078,33.19,0.69,43.5,6312,100,NULL,'mid-IR','NGC 0917',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24079,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24079,34.4,0.38,75.8,6312,75,NULL,'W91PP, r, raw','NGC 0917',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24080,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24080,34.43,0.4,76.8,6312,NULL,NULL,'mean','NGC 0917',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24081,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24081,34.44,0.38,77.3,6312,75,NULL,'W91PP, r, cor','NGC 0917',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24082,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24082,34.77,0.38,90.1,6312,75,NULL,'W91PP, r, inv','NGC 0917',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24083,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24083,34.97,0.45,98.4,6312,NULL,NULL,'K','NGC 0917',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24084,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24084,34.98,0.46,99.3,6312,NULL,NULL,'J','NGC 0917',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24085,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24085,34.99,0.47,99.5,6312,NULL,NULL,'H','NGC 0917',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24086,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 04284','RN',24086,40.77,0.12,1290,6313,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04284',0.106484,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24087,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1hd',NULL,24087,41.09,0.03,1210,6314,70,NULL,'SIFTO','[HSP2005] J022608.85-040635.22',0.3688,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.0004,NULL,'24.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,36.536875,-4.10978,0.049,NULL,34949483263,546085675,8532588,24),(24088,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1hd',NULL,24088,41.64,0.11,1550,6314,70,NULL,'SALT 2','[HSP2005] J022608.85-040635.22',0.3688,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24089,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1hd',NULL,24089,41.66,0.15,1570,6314,NULL,NULL,'SIFTO','[HSP2005] J022608.85-040635.22',0.3688,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24090,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1hd',NULL,24090,42.66,0.17,2490,6314,NULL,NULL,'SALT2','[HSP2005] J022608.85-040635.22',0.3688,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24091,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24091,35.71,0.25,139,6315,74.4,NULL,NULL,'MRK 1037',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',NULL,NULL,'14.19',NULL,'Compact',NULL,NULL,NULL,NULL,1,36.5404583,36.78467,0.181,NULL,68653565902,1072711967,16761124,14.19),(24092,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24092,35.93,0.33,153,6315,70,NULL,NULL,'MRK 1037',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24093,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 13378',NULL,24093,39.42,1.03,765,6316,70,NULL,'SN photometric redshift distance, z photo =0.198 +/- 0.145','SDSS-II SN 13378',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,36.542625,1.14644,0.065,NULL,66889128037,1045142625,16330353,NULL),(24094,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 13378','R',24094,41.06,0.27,1250,6316,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13378',0.305136,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24095,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 13378','R',24095,41.07,0.3,1250,6316,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13378',0.305136,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24096,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24096,35.93,0.33,153,6317,70,NULL,NULL,'GIN 120',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.000057,NULL,'14.79',NULL,'E/S0',NULL,NULL,NULL,NULL,1,36.5505833333,37.22172,0.237,NULL,68654295769,1072723371,16761302,14.79),(24097,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1jg',NULL,24097,42.19,0.04,1730,6318,70,NULL,'SIFTO','[NSB2006] J022612.56-040805.3',0.5842,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,36.552375,-4.13481,0.021,NULL,34949484157,546085689,8532588,NULL),(24098,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1jg',NULL,24098,42.73,0.14,2220,6318,70,NULL,'SALT 2','[NSB2006] J022612.56-040805.3',0.5842,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24099,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1jg',NULL,24099,42.76,0.15,2240,6318,NULL,NULL,'SIFTO','[NSB2006] J022612.56-040805.3',0.5842,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24100,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1jg',NULL,24100,43.28,0.17,2860,6318,NULL,NULL,'SALT2','[NSB2006] J022612.56-040805.3',0.5842,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24101,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1iz',NULL,24101,43.21,0.08,2360,6319,70,NULL,'SIFTO','SNLS 05D1iz HOST',0.86,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,36.5532083333,-4.77336,0.021,NULL,34950522883,546101920,8532842,NULL),(24102,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1iz',NULL,24102,43.94,0.15,3290,6319,NULL,NULL,'SIFTO','SNLS 05D1iz HOST',0.86,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24103,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1iz',NULL,24103,44.04,0.26,3450,6319,70,NULL,'SALT 2','SNLS 05D1iz HOST',0.86,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24104,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1iz',NULL,24104,45.75,0.17,7580,6319,NULL,NULL,'SALT2','SNLS 05D1iz HOST',0.86,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24105,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24105,35.72,0.25,139,6320,74.4,NULL,NULL,'V Zw 240',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000077,NULL,'14.24',0.4,'SB0',NULL,NULL,NULL,NULL,1,36.560417,37.29197,0.193,NULL,68654290883,1072723295,16761301,14.24),(24106,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24106,35.73,0.25,140,6320,74.4,NULL,NULL,'V Zw 240',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24107,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24107,35.93,0.33,153,6320,70,NULL,NULL,'V Zw 240',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24108,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24108,35.59,0.6,131,6321,70,NULL,NULL,'2MASX J02261545-0606265',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.53',0.27,NULL,NULL,NULL,NULL,NULL,1,36.564375,-6.10747,0.057,NULL,34948571147,546071424,8532366,16.53),(24109,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24109,36.61,0.73,210,6322,70,NULL,NULL,'AM 0223-234 NED03',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'16.13',0.33,'S',NULL,NULL,NULL,NULL,1,36.56725,-23.48981,0,NULL,37975519428,593367491,9271367,16.13),(24110,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1co','R',24110,42.64,NULL,2010,6323,65,NULL,'SALT','[HSP2005] J022616.23-045605.76',0.679,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,'24.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,36.5676666667,-4.93494,0.013,NULL,34951023755,546109746,8532964,24.4),(24111,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1co',NULL,24111,42.76,0.2,2120,6323,74.2,NULL,'SALT 2','[HSP2005] J022616.23-045605.76',0.679,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24112,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1co',NULL,24112,43.12,0.05,2510,6323,70,NULL,'SALT','[HSP2005] J022616.23-045605.76',0.679,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24113,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1co',NULL,24113,43.4,0.09,2850,6323,70,NULL,NULL,'[HSP2005] J022616.23-045605.76',0.679,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24114,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1co',NULL,24114,43.41,0.22,2860,6323,70,NULL,'SALT 2','[HSP2005] J022616.23-045605.76',0.679,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24115,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1co',NULL,24115,43.42,0.18,2880,6323,70,NULL,'SALT','[HSP2005] J022616.23-045605.76',0.679,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24116,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1co',NULL,24116,43.46,0.15,2930,6323,NULL,NULL,'SIFTO','[HSP2005] J022616.23-045605.76',0.679,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24117,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1co',NULL,24117,43.58,0.15,3090,6323,65,NULL,'SALT','[HSP2005] J022616.23-045605.76',0.679,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24118,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1co',NULL,24118,43.58,0.26,3090,6323,65,NULL,'MLCS17','[HSP2005] J022616.23-045605.76',0.679,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24119,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1co',NULL,24119,43.59,0.25,3110,6323,65,NULL,'MLCS2k2','[HSP2005] J022616.23-045605.76',0.679,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24120,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1co',NULL,24120,43.59,0.26,3110,6323,65,NULL,'MLCS31','[HSP2005] J022616.23-045605.76',0.679,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24121,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1co',NULL,24121,43.63,0.22,3170,6323,65,NULL,'SALT2','[HSP2005] J022616.23-045605.76',0.679,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24122,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1co',NULL,24122,43.67,0.18,3230,6323,65,NULL,'MLCS2k2','[HSP2005] J022616.23-045605.76',0.679,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24123,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1co',NULL,24123,43.69,0.08,3260,6323,65,NULL,'SALT','[HSP2005] J022616.23-045605.76',0.679,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24124,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1co',NULL,24124,43.69,0.19,3260,6323,65,NULL,'SALT2','[HSP2005] J022616.23-045605.76',0.679,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24125,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1co',NULL,24125,44.52,0.17,4780,6323,NULL,NULL,'SALT2','[HSP2005] J022616.23-045605.76',0.679,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24126,'IRAS','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24126,35.75,0.8,141,6324,75,NULL,'W91PP, r','NGC 0919',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000067,NULL,'15.39',0.3,'Sab','Group member',NULL,NULL,NULL,1,36.5694583,27.21211,0.289,NULL,68645590213,1072587347,16759177,15.39),(24127,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24127,35.5,0.49,126,6324,75,NULL,'IR','NGC 0919',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24128,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24128,35.63,0.38,134,6324,75,NULL,'W91PP, r, raw','NGC 0919',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24129,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24129,35.8,0.47,144,6324,NULL,NULL,'H','NGC 0919',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24130,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24130,35.83,0.4,147,6324,NULL,NULL,'mean','NGC 0919',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24131,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24131,35.87,0.38,149,6324,75,NULL,'W91PP, r, cor','NGC 0919',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24132,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24132,35.87,0.46,149,6324,NULL,NULL,'J','NGC 0919',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24133,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24133,35.88,0.45,150,6324,NULL,NULL,'K','NGC 0919',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24134,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24134,35.96,0.38,156,6324,75,NULL,'W91PP, r, inv','NGC 0919',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24135,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1dc',NULL,24135,38.82,0.17,479,6325,NULL,NULL,'SALT2','[NSB2006] J022618.47-041843.2',0.211,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,'18.7r',NULL,NULL,NULL,NULL,NULL,NULL,1,36.577,-4.31203,0.021,NULL,34949508212,546086065,8532594,18.7),(24136,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1dc',NULL,24136,39.97,0.11,814,6325,70,NULL,'SALT 2','[NSB2006] J022618.47-041843.2',0.211,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24137,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1dc',NULL,24137,40.01,0.15,830,6325,NULL,NULL,'SIFTO','[NSB2006] J022618.47-041843.2',0.211,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24138,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1dc',NULL,24138,40.01,NULL,830,6325,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','[NSB2006] J022618.47-041843.2',0.211,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24139,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1dc',NULL,24139,40.57,0.03,1070,6325,70,NULL,'SALT2','[NSB2006] J022618.47-041843.2',0.211,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24140,'GRB','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'RN',24140,41.79,0.45,1530,6326,NULL,NULL,'SN 2009nz','GRB 091127 HOST',0.49,'2010JCAP...08..020W',2010,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24141,'IRAS','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24141,35.67,0.8,136,6327,75,NULL,'W91PP, r','UGC 01896',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'14.65',0.4,'SA(r)0^0^',NULL,NULL,NULL,NULL,1,36.5862916667,30.44567,0.345,NULL,68638275223,1072473050,16757391,14.65),(24142,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24142,35.44,0.38,122,6327,75,NULL,'W91PP, r, raw','UGC 01896',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24143,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24143,35.72,0.38,139,6327,75,NULL,'W91PP, r, cor','UGC 01896',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24144,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24144,35.75,0.38,141,6327,75,NULL,'W91PP, r, inv','UGC 01896',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24145,'Tully est','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24145,32.05,0.8,25.7,6328,75,NULL,NULL,'VV 525',NULL,'1988NBGC.C....0000T',1988,1,3,'Confused HIPASS source','G',0.000013,NULL,'14.50',1.1,'SAB(s)dm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,36.58875,-9.84083,0.029,NULL,34933388277,545834191,8528659,14.5),(24146,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24146,32.53,0.2,32.1,6328,74.4,NULL,NULL,'VV 525',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24147,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24147,32.58,0.43,32.8,6328,75,NULL,'3.6 micron, color corrected','VV 525',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24148,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24148,32.61,0.43,33.3,6328,75,NULL,'3.6 micron, color + selection bias corrected','VV 525',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24149,'IRAS','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24149,31.49,0.8,19.9,6329,75,NULL,'MAT, I','UGCA 032',NULL,'1997ApJS..109..333W',1997,1,2.7,NULL,'G',0.000019,NULL,'12.86',1.4,'SB(s)dm','Line-of-sight pair member',NULL,NULL,NULL,1,36.5905,-24.2895,0,NULL,37942581153,592852830,9263325,12.86),(24150,'Tully est','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24150,31.25,0.8,17.8,6329,75,NULL,NULL,'UGCA 032',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24151,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24151,31.06,0.32,16.3,6329,85,NULL,'I, inv','UGCA 032',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24152,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24152,31.07,0.32,16.4,6329,85,NULL,'I, raw','UGCA 032',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24153,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24153,31.11,0.2,16.7,6329,74.4,NULL,NULL,'UGCA 032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24154,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24154,31.12,0.43,16.8,6329,75,NULL,'3.6 micron, color corrected','UGCA 032',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24155,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24155,31.12,0.43,16.8,6329,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 032',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24156,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24156,31.35,0.38,18.6,6329,NULL,NULL,NULL,'UGCA 032',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24157,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24157,31.35,0.39,18.6,6329,73,NULL,'opt','UGCA 032',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24158,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24158,31.44,0.43,19.4,6329,75,NULL,'MAT, I, raw','UGCA 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24159,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24159,31.46,0.43,19.6,6329,75,NULL,'MAT, I, inv','UGCA 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24160,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24160,31.63,0.43,21.1,6329,75,NULL,'MAT, I, cor','UGCA 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24161,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1pc',NULL,24161,43.39,0.21,2700,6330,70,NULL,'SALT 2','VVDS 020273370',0.767,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',0.000921,NULL,'24.7V',NULL,NULL,NULL,NULL,NULL,NULL,1,36.6037917,-4.39944,0.021,NULL,34949418271,546084660,8532572,24.7),(24162,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1pc',NULL,24162,43.55,0.15,2900,6330,NULL,NULL,'SIFTO','VVDS 020273370',0.767,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24163,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1pc',NULL,24163,43.56,0.17,2920,6330,NULL,NULL,'SALT2','VVDS 020273370',0.767,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24164,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1pc',NULL,24164,44.02,0.05,3600,6330,70,NULL,'SIFTO','VVDS 020273370',0.767,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24165,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 08307','R',24165,41.78,0.43,1580,6331,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 08307',0.43608,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,'PHOT','21.4g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,36.6050416667,0.79081,0.061,NULL,66889590202,1045149846,16330466,21.4),(24166,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 08307',NULL,24166,41.37,0.18,1880,6331,70,NULL,'SN photometric redshift distance, z photo =0.601 +/- 0.077','SDSS-II SN 08307',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24167,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 08307',NULL,24167,41.57,0.31,2060,6331,70,NULL,'SALT 2','SDSS-II SN 08307',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24168,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 08307',NULL,24168,41.66,0.31,2150,6331,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 08307',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24169,'IRAS','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24169,35.71,0.8,139,6332,75,NULL,'W91PP, r','UGC 01898',NULL,'1997ApJS..109..333W',1997,1,1.27,NULL,'G',0.000025,NULL,'16.5',0.17,'Sbc',NULL,NULL,NULL,NULL,1,36.606917,22.99594,0.293,NULL,68106472962,1064163640,16627556,16.5),(24170,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24170,35.8,0.49,144,6332,75,NULL,'IR','UGC 01898',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24171,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24171,35.8,0.31,145,6332,NULL,NULL,'Malmquist cor.','UGC 01898',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24172,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24172,35.81,0.38,145,6332,75,NULL,'W91PP, r, raw','UGC 01898',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24173,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24173,35.9,NULL,151,6332,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01898',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24174,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24174,35.9,NULL,151,6332,NULL,NULL,'Dipole + Quadrupole','UGC 01898',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24175,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24175,35.9,NULL,151,6332,NULL,NULL,'Dipole','UGC 01898',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24176,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24176,35.97,0.38,156,6332,75,NULL,'W91PP, r, cor','UGC 01898',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24177,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24177,36.03,0.38,161,6332,75,NULL,'W91PP, r, inv','UGC 01898',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24178,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24178,36.04,0.28,162,6332,NULL,NULL,NULL,'UGC 01898',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24179,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24179,36.05,NULL,163,6332,NULL,NULL,NULL,'UGC 01898',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24180,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24180,36.08,0.2,164,6332,74.4,NULL,NULL,'UGC 01898',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24181,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 1995ax','R',24181,41.54,NULL,1260,6333,65,NULL,'SALT','[PDG95a] J022625.82+004844.4',0.615,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,'E/S0',NULL,NULL,NULL,NULL,1,36.607583,0.81233,0.061,NULL,66889596519,1045149945,16330467,NULL),(24182,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 1995ax',NULL,24182,41.83,0.56,1440,6333,74.2,NULL,'SALT 2','[PDG95a] J022625.82+004844.4',0.615,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24183,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 1995ax',NULL,24183,42.61,0.52,2060,6333,70,NULL,'SALT','[PDG95a] J022625.82+004844.4',0.615,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24184,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 1995ax',NULL,24184,42.78,0.49,2230,6333,65,NULL,'SALT','[PDG95a] J022625.82+004844.4',0.615,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24185,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 1995ax',NULL,24185,42.85,0.23,2300,6333,65,NULL,NULL,'[PDG95a] J022625.82+004844.4',0.615,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24186,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1bk',NULL,24186,43,0.07,2140,6334,70,NULL,'SIFTO','VVDS 020209246',0.865,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.0005,NULL,'22.5V',NULL,NULL,NULL,NULL,NULL,NULL,1,36.6142083,-4.53667,0.021,NULL,34949419657,546084682,8532573,22.5),(24187,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1bk',NULL,24187,44.09,0.15,3530,6334,NULL,NULL,'SIFTO','VVDS 020209246',0.865,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24188,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1bk',NULL,24188,44.18,0.21,3670,6334,70,NULL,'SALT 2','VVDS 020209246',0.865,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24189,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1bk',NULL,24189,44.58,0.17,4420,6334,NULL,NULL,'SALT2','VVDS 020209246',0.865,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24190,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24190,35.72,0.25,139,6335,74.4,NULL,NULL,'VI Zw 209',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000077,NULL,'14.67',0.2,'E',NULL,NULL,NULL,NULL,1,36.6147917,37.04031,0.237,NULL,68653591265,1072712363,16761130,14.67),(24191,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24191,35.93,0.33,153,6335,70,NULL,NULL,'VI Zw 209',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24192,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24192,31.08,0.45,16.4,6336,NULL,NULL,'K','IC 0225',NULL,'2007A&A...465...71T',2007,1,0.94,NULL,'G',0.000007,NULL,'14.6g',0.82,'E;WR?          HII',NULL,NULL,NULL,NULL,1,36.617875,1.16053,0.065,NULL,66889179247,1045143425,16330366,14.6),(24193,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24193,31.6,0.4,20.9,6336,NULL,NULL,'mean','IC 0225',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24194,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1dt',NULL,24194,42.27,0.05,1770,6337,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','[AGR2006] J022631.20-040308.5',0.612,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,'22.7r',NULL,NULL,NULL,NULL,NULL,NULL,1,36.63,-4.05236,0.025,NULL,34949485059,546085704,8532589,22.7),(24195,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1dt',NULL,24195,42.69,0.15,2140,6337,70,NULL,'SALT 2','[AGR2006] J022631.20-040308.5',0.612,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24196,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1dt',NULL,24196,42.76,NULL,2210,6337,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','[AGR2006] J022631.20-040308.5',0.612,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24197,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1cc',NULL,24197,42.63,0.12,2140,6338,70,NULL,'SALT 2','SNLS 05D1cc HOST',0.564,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',NULL,NULL,'22.7R',NULL,'a',NULL,NULL,NULL,NULL,1,36.629875,-4.16483,0.021,NULL,34949477793,546085590,8532587,22.7),(24198,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1cc',NULL,24198,42.69,0.15,2210,6338,NULL,NULL,'SIFTO','SNLS 05D1cc HOST',0.564,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24199,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1cc',NULL,24199,42.72,0.04,2230,6338,70,NULL,'SIFTO','SNLS 05D1cc HOST',0.564,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24200,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1cc',NULL,24200,42.76,0.17,2280,6338,NULL,NULL,'SALT2','SNLS 05D1cc HOST',0.564,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24201,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 19141','RN',24201,40.76,0.13,1280,6339,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19141',0.108176,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24202,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 19141','RN',24202,40.92,0.21,1380,6339,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19141',0.108176,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24203,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1qd',NULL,24203,43.36,0.19,2650,6340,70,NULL,'SALT 2','VVDS:[RBO2008] ir 00062666',0.767,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'VisS',0.001,NULL,'22.8r',NULL,'Candidate      QSO',NULL,NULL,NULL,NULL,1,36.637833,-4.10725,0.025,NULL,34949479695,546085620,8532587,22.8),(24204,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1qd',NULL,24204,43.41,0.15,2720,6340,NULL,NULL,'SIFTO','VVDS:[RBO2008] ir 00062666',0.767,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24205,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1qd',NULL,24205,43.47,0.05,2790,6340,70,NULL,'SIFTO','VVDS:[RBO2008] ir 00062666',0.767,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24206,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1qd',NULL,24206,43.9,0.17,3410,6340,NULL,NULL,'SALT2','VVDS:[RBO2008] ir 00062666',0.767,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24207,'IRAS','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24207,35.78,0.8,143,6341,75,NULL,'W91PP, r','UGC 01903',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'15.63',0.2,'Sb','Isolated galaxy',NULL,NULL,NULL,1,36.6377083333,29.83064,0.353,NULL,68649679848,1072651247,16760175,15.63),(24208,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24208,35.42,0.49,122,6341,75,NULL,'IR','UGC 01903',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24209,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24209,35.55,0.38,129,6341,75,NULL,'W91PP, r, raw','UGC 01903',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24210,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24210,35.79,0.38,144,6341,75,NULL,'W91PP, r, inv','UGC 01903',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24211,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24211,35.81,0.38,145,6341,75,NULL,'W91PP, r, cor','UGC 01903',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24212,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2001jb',NULL,24212,42.84,0.25,2180,6342,72,NULL,'dm15','H-ZSNS J022633.31+002535.0',0.698,'2004ApJ...602..571B',2004,1,NULL,NULL,'G',0.001,NULL,'22.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,36.638875,0.42647,0.049,NULL,66888761826,1045136903,16330264,22.8),(24213,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2001jb',NULL,24213,43.07,0.44,2420,6342,74.2,NULL,'SALT 2','H-ZSNS J022633.31+002535.0',0.698,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24214,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2001jb',NULL,24214,43.09,0.42,2440,6342,72,NULL,'BATM','H-ZSNS J022633.31+002535.0',0.698,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24215,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2001jb',NULL,24215,43.24,0.45,2620,6342,72,NULL,'MLCS','H-ZSNS J022633.31+002535.0',0.698,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24216,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2001jb',NULL,24216,43.33,0.32,2730,6342,65,NULL,NULL,'H-ZSNS J022633.31+002535.0',0.698,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24217,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2001jb',NULL,24217,43.88,0.3,3520,6342,70,NULL,'SALT','H-ZSNS J022633.31+002535.0',0.698,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24218,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24218,34.38,0.43,75.3,6343,NULL,NULL,'Malmquist cor.','NGC 0921',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000073,NULL,'15.41',0.6,'SB(r)c?',NULL,NULL,NULL,NULL,1,36.63925,-15.84753,0.023,NULL,37964071576,593188618,9268572,15.41),(24219,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24219,34.55,0.2,81.3,6343,74.4,NULL,NULL,'NGC 0921',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24220,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24220,34.6,0.39,83.2,6343,NULL,NULL,NULL,'NGC 0921',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24221,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24221,35.62,0.6,133,6344,70,NULL,NULL,'2MASX J02263392-2238343',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,36.641333,-22.64294,0,NULL,37976943892,593389748,9271714,14.8),(24222,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 18797','RN',24222,41.39,0.23,1390,6345,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18797',0.365307,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24223,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 18797','RN',24223,41.76,0.16,1650,6345,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18797',0.365307,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24224,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 18797','N',24224,41.22,0.13,1750,6345,70,NULL,'SALT 2','SDSS-II SN 18797',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24225,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 18797','N',24225,41.28,0.13,1800,6345,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18797',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24226,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 15071',NULL,24226,41.59,NULL,2080,6346,70,NULL,'SN photometric redshift distance, z photo =0.700 +/- 0.001','SDSS-II SN 15071',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','21.0g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,36.644875,0.38489,0.049,NULL,66880421949,1045006592,16328228,21),(24227,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1de',NULL,24227,42.96,0.05,2210,6347,70,NULL,'SIFTO','VVDS 020262777',0.7677,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.0002,NULL,'23.4V',NULL,NULL,NULL,NULL,NULL,NULL,1,36.6496666667,-4.42269,0.021,NULL,34949429101,546084829,8532575,23.4),(24228,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1de',NULL,24228,43.72,0.15,3140,6347,NULL,NULL,'SIFTO','VVDS 020262777',0.7677,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24229,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1de',NULL,24229,43.73,0.2,3160,6347,70,NULL,'SALT 2','VVDS 020262777',0.7677,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24230,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1de',NULL,24230,44.91,0.17,5440,6347,NULL,NULL,'SALT2','VVDS 020262777',0.7677,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24231,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24231,36.33,0.52,184,6348,70,NULL,NULL,'AM 0224-233',NULL,'2014MNRAS.445.2677S',2014,1,0.17,NULL,'G',0.00015,NULL,'14.76',0.17,'S0',NULL,NULL,NULL,NULL,1,36.6509583333,-23.41708,0,NULL,37975515295,593367426,9271366,14.76),(24232,'Ring Diameter','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24232,33.2,0.84,43,6349,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 0927',NULL,'1981ApJS...45..541P',1981,1,1.2,NULL,'G',0.00002,NULL,'14.13',1.2,'SB(r)c         Sbrst',NULL,NULL,NULL,'Starburst',1,36.6554583333,12.15533,0.301,NULL,67947771178,1061683924,16588811,14.13),(24233,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1bp',NULL,24233,40.28,0.17,847,6350,NULL,NULL,'SALT2','[AGR2006] J022637.71-045019.5',0.346,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,'19.5r',NULL,NULL,NULL,NULL,NULL,NULL,1,36.657125,-4.83878,0.013,NULL,34951031172,546109862,8532966,19.5),(24234,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1bp',NULL,24234,40.63,0.15,993,6350,74.2,NULL,'SALT 2','[AGR2006] J022637.71-045019.5',0.346,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24235,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1bp','R',24235,41.06,NULL,1210,6350,65,NULL,'SALT','[AGR2006] J022637.71-045019.5',0.346,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24236,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1bp',NULL,24236,41.28,0.13,1340,6350,70,NULL,'SALT','[AGR2006] J022637.71-045019.5',0.346,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24237,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1bp',NULL,24237,41.37,0.02,1390,6350,70,NULL,NULL,'[AGR2006] J022637.71-045019.5',0.346,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24238,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1bp',NULL,24238,41.37,0.13,1400,6350,65,NULL,'SALT2','[AGR2006] J022637.71-045019.5',0.346,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24239,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1bp',NULL,24239,41.41,0.1,1420,6350,65,NULL,'SALT','[AGR2006] J022637.71-045019.5',0.346,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24240,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1bp',NULL,24240,41.41,0.15,1420,6350,NULL,NULL,'SIFTO','[AGR2006] J022637.71-045019.5',0.346,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24241,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1bp',NULL,24241,41.44,0.11,1440,6350,70,NULL,'SALT 2','[AGR2006] J022637.71-045019.5',0.346,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24242,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1bp',NULL,24242,41.46,0.21,1450,6350,65,NULL,'MLCS17','[AGR2006] J022637.71-045019.5',0.346,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24243,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1bp',NULL,24243,41.5,0.23,1480,6350,65,NULL,'MLCS2k2','[AGR2006] J022637.71-045019.5',0.346,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24244,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1bp',NULL,24244,41.52,0.26,1490,6350,65,NULL,'MLCS31','[AGR2006] J022637.71-045019.5',0.346,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24245,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1bp',NULL,24245,41.53,0.19,1510,6350,65,NULL,'SALT2','[AGR2006] J022637.71-045019.5',0.346,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24246,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1bp',NULL,24246,41.6,0.03,1550,6350,65,NULL,'SALT','[AGR2006] J022637.71-045019.5',0.346,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24247,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1bp',NULL,24247,41.61,0.1,1560,6350,65,NULL,'MLCS2k2','[AGR2006] J022637.71-045019.5',0.346,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24248,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1bp',NULL,24248,41.8,0.03,1710,6350,70,NULL,'SALT2','[AGR2006] J022637.71-045019.5',0.346,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24249,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1ow',NULL,24249,43.18,0.07,2260,6351,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','VVDS 020466469',0.915,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,'24.6V',NULL,NULL,NULL,NULL,NULL,NULL,1,36.6779583,-4.30628,0.021,NULL,34949397545,546084336,8532567,24.6),(24250,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1ow',NULL,24250,43.94,0.2,3210,6351,70,NULL,'SALT 2','VVDS 020466469',0.915,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24251,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1ow',NULL,24251,43.97,NULL,3260,6351,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','VVDS 020466469',0.915,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24252,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1ow',NULL,24252,44.01,0.15,3310,6351,NULL,NULL,'SIFTO','VVDS 020466469',0.915,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24253,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1ow',NULL,24253,44.05,0.17,3380,6351,NULL,NULL,'SALT2','VVDS 020466469',0.915,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24254,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24254,35.63,0.49,133,6352,75,NULL,'IR','UGC 01906',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',NULL,NULL,'16.5',0.2,'Sb',NULL,NULL,NULL,NULL,1,36.687917,22.75125,0.293,NULL,68105403459,1064146929,16627295,16.5),(24255,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1ke',NULL,24255,42.53,0.04,1900,6353,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SNLS 05D1ke HOST',0.69,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.01,NULL,'23.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,36.692917,-4.86225,0.013,NULL,34951067052,546110422,8532975,23.6),(24256,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1ke',NULL,24256,43.11,0.17,2480,6353,70,NULL,'SALT 2','SNLS 05D1ke HOST',0.69,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24257,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1ke',NULL,24257,43.13,NULL,2500,6353,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SNLS 05D1ke HOST',0.69,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24258,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24258,34.4,0.47,75.7,6354,NULL,NULL,'H','CGCG 539-024',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000053,NULL,'14.93',0.5,'SBb            HII','Group member',NULL,NULL,NULL,1,36.6930416667,41.8345,0.213,NULL,68538177794,1070909028,16732953,14.93),(24259,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24259,34.42,0.4,76.6,6354,NULL,NULL,'mean','CGCG 539-024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24260,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24260,34.48,0.45,78.9,6354,NULL,NULL,'K','CGCG 539-024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24261,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24261,34.59,0.46,82.6,6354,NULL,NULL,'J','CGCG 539-024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24262,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24262,32.9,0.69,38,6355,100,NULL,'mid-IR','NGC 0924',NULL,'2013ApJ...771...88L',2013,1,2.3,NULL,'G',0.000017,NULL,'13.37',1.3,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,36.695125,20.4975,0.317,NULL,68114465852,1064288528,16629508,13.37),(24263,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24263,33.94,0.4,61.5,6355,NULL,NULL,'mean','NGC 0924',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24264,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24264,34.16,0.45,67.9,6355,NULL,NULL,'K','NGC 0924',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24265,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24265,34.24,0.2,70.5,6355,74.4,NULL,NULL,'NGC 0924',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24266,'SNII optical','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1pj',NULL,24266,39.28,0.11,538,6356,NULL,NULL,'SEAM','XMDS J022649.3-041154',0.1556,'2009ApJ...694.1067P',2009,1,NULL,NULL,'G',0.000921,NULL,'21.7I',NULL,'BLAGN',NULL,NULL,NULL,NULL,1,36.705875,-4.19814,0.021,NULL,34950037518,546094336,8532724,21.7),(24267,'SNII optical','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1pj',NULL,24267,39.69,0.15,867,6356,NULL,NULL,NULL,'XMDS J022649.3-041154',NULL,'2006ApJ...645..841N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24268,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2006nb',NULL,24268,39.38,0.09,751,6357,70,NULL,'Hubble residual 0.10 for z0.18460','SDSS-II SN 15872 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,36.722375,-0.32783,0.065,NULL,34923068452,545672944,8526139,NULL),(24269,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 15872','R',24269,39.99,0.19,825,6357,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006nb','SDSS-II SN 15872 HOST',0.206456,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24270,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 15872','R',24270,40.11,0.11,873,6357,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006nb','SDSS-II SN 15872 HOST',0.206456,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24271,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2006nb',NULL,24271,40.01,0.08,1000,6357,70,NULL,'SALT 2','SDSS-II SN 15872 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24272,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2006nb',NULL,24272,40.03,0.08,1010,6357,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15872 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24273,'IRAS','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24273,34.01,0.8,63.4,6358,75,NULL,'W91PP, r','UGC 01909',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'15.21',0.6,'Sd',NULL,NULL,NULL,NULL,1,36.725833,32.09597,0.257,NULL,68637417797,1072459653,16757182,15.21),(24274,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24274,34.31,0.38,72.9,6358,75,NULL,'W91PP, r, inv','UGC 01909',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24275,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24275,34.33,0.38,73.3,6358,75,NULL,'W91PP, r, raw','UGC 01909',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24276,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24276,34.36,0.38,74.5,6358,75,NULL,'W91PP, r, cor','UGC 01909',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24277,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24277,35.91,0.25,152,6359,74.4,NULL,NULL,'2MASX J02265443+2337316',NULL,'2013AJ....146...86T',2013,1,0.37,NULL,'G',0.000607,NULL,'15.07',0.2,'S0',NULL,NULL,NULL,NULL,1,36.726875,23.62553,0.317,NULL,68103466436,1064116663,16626822,15.07),(24278,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fq',NULL,24278,42.94,0.17,2150,6360,NULL,NULL,'SALT2','[HSP2005] J022655.68-041808.10',0.8,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.02,NULL,'23.2r',NULL,NULL,NULL,NULL,NULL,NULL,1,36.732,-4.30225,0.021,NULL,34949863679,546091619,8532681,23.2),(24279,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fq',NULL,24279,42.98,0.22,2190,6360,74.2,NULL,'SALT 2','[HSP2005] J022655.68-041808.10',0.8,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24280,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fq','R',24280,43.04,NULL,2250,6360,65,NULL,'MLCS17','[HSP2005] J022655.68-041808.10',0.8,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24281,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fq',NULL,24281,43.49,0.09,2770,6360,70,NULL,NULL,'[HSP2005] J022655.68-041808.10',0.8,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24282,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fq',NULL,24282,43.65,0.24,2980,6360,70,NULL,'SALT 2','[HSP2005] J022655.68-041808.10',0.8,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24283,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fq',NULL,24283,43.69,0.15,3040,6360,NULL,NULL,'SIFTO','[HSP2005] J022655.68-041808.10',0.8,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24284,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fq',NULL,24284,43.76,0.26,3140,6360,65,NULL,'MLCS17','[HSP2005] J022655.68-041808.10',0.8,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24285,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fq',NULL,24285,43.76,0.06,3140,6360,70,NULL,'SALT2','[HSP2005] J022655.68-041808.10',0.8,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24286,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fq',NULL,24286,43.78,0.08,3170,6360,65,NULL,'SALT','[HSP2005] J022655.68-041808.10',0.8,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24287,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fq',NULL,24287,43.83,0.21,3240,6360,65,NULL,'SALT2','[HSP2005] J022655.68-041808.10',0.8,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24288,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fq',NULL,24288,43.85,0.18,3280,6360,65,NULL,'MLCS2k2','[HSP2005] J022655.68-041808.10',0.8,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24289,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fq',NULL,24289,43.89,0.22,3330,6360,65,NULL,'SALT2','[HSP2005] J022655.68-041808.10',0.8,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24290,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fq',NULL,24290,43.92,0.25,3380,6360,65,NULL,'MLCS2k2','[HSP2005] J022655.68-041808.10',0.8,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24291,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fq',NULL,24291,43.92,0.26,3380,6360,65,NULL,'MLCS31','[HSP2005] J022655.68-041808.10',0.8,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24292,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fq',NULL,24292,44.42,0.54,4250,6360,70,NULL,'SALT','[HSP2005] J022655.68-041808.10',0.8,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24293,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1fq',NULL,24293,44.71,0.55,4860,6360,65,NULL,'SALT','[HSP2005] J022655.68-041808.10',0.8,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24294,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24294,32.66,1.14,34,6361,NULL,NULL,NULL,'CGCG 462-013',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000017,NULL,'15.31',0.7,'SB?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,36.734917,20.533,0.317,NULL,68114468461,1064288569,16629508,15.31),(24295,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24295,32.7,0.2,34.7,6361,74.4,NULL,NULL,'CGCG 462-013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24296,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24296,33.19,0.89,43.5,6361,NULL,NULL,'Malmquist cor.','CGCG 462-013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24297,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1cb',NULL,24297,42.7,0.17,2130,6362,NULL,NULL,'SALT2','VVDS:[RBO2008] ir 00060734',0.632,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,'21.6r',NULL,'Candidate      QSO',NULL,NULL,NULL,NULL,1,36.738,-4.11758,0.025,NULL,34949973343,546093333,8532708,21.6),(24298,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1cb',NULL,24298,42.78,0.15,2200,6362,70,NULL,'SALT 2','VVDS:[RBO2008] ir 00060734',0.632,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24299,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1cb',NULL,24299,42.88,NULL,2310,6362,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','VVDS:[RBO2008] ir 00060734',0.632,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24300,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1cb',NULL,24300,42.91,0.15,2340,6362,NULL,NULL,'SIFTO','VVDS:[RBO2008] ir 00060734',0.632,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24301,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1cb',NULL,24301,42.97,0.04,2400,6362,70,NULL,'SALT2','VVDS:[RBO2008] ir 00060734',0.632,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24302,'IRAS','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24302,34.09,0.8,65.9,6363,75,NULL,'W91PP, r','UGC 01910',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000017,NULL,'14.65',0.5,'S?',NULL,NULL,NULL,NULL,1,36.7380417,35.18128,0.201,NULL,68629231718,1072331745,16755183,14.65),(24303,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24303,33.94,0.49,61.4,6363,75,NULL,'IR','UGC 01910',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24304,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24304,34.09,0.38,65.7,6363,75,NULL,'W91PP, r, raw','UGC 01910',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24305,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24305,34.19,0.38,68.7,6363,75,NULL,'W91PP, r, cor','UGC 01910',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24306,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24306,34.22,0.38,70,6363,75,NULL,'W91PP, r, inv','UGC 01910',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24307,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24307,34.25,0.4,71,6363,NULL,NULL,'mean','UGC 01910',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24308,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24308,34.53,0.47,80.5,6363,NULL,NULL,'H','UGC 01910',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24309,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1ju',NULL,24309,42.69,0.17,2020,6364,NULL,NULL,'SALT2','VVDS:[RBO2008] ir 00060050',0.707,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',NULL,NULL,'22.7r',NULL,NULL,NULL,NULL,NULL,NULL,1,36.73875,-4.13411,0.025,NULL,34949973652,546093338,8532708,22.7),(24310,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1ju',NULL,24310,42.92,0.15,2240,6364,NULL,NULL,'SIFTO','VVDS:[RBO2008] ir 00060050',0.707,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24311,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24311,38.06,0.46,410,6365,70,NULL,NULL,'SDSS J022657.46-010531.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000074,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,36.739417,-1.09219,0.049,NULL,34927655434,545744616,8527259,18.5),(24312,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24312,37.02,0.55,254,6366,70,NULL,NULL,'2MASX J02270007-2256133',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'17.43',0.21,NULL,NULL,NULL,NULL,NULL,1,36.75025,-22.93706,0,NULL,37977017285,593390895,9271732,17.43),(24313,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24313,34.05,NULL,64.4,6367,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0295',NULL,'2010Ap&SS.325..163P',2010,1,1.29,NULL,'G',0.00002,NULL,'15.85',0.17,'Sdm',NULL,NULL,NULL,NULL,1,36.750833,-2.695,0.033,NULL,34926133376,545720834,8526888,15.85),(24314,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24314,34.06,NULL,65,6367,NULL,NULL,'Dipole + Quadrupole','FGC 0295',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24315,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24315,34.06,NULL,65,6367,NULL,NULL,'Dipole','FGC 0295',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24316,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24316,34.12,NULL,66.7,6367,NULL,NULL,NULL,'FGC 0295',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24317,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24317,35.44,0.47,123,6368,70,NULL,NULL,'ESO 545- G 017',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000093,NULL,'14.80',0.8,'S0',NULL,NULL,NULL,NULL,1,36.759375,-19.25406,0.105,NULL,37968867862,593263560,9269743,14.8),(24318,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 14342','RN',24318,40.86,0.28,1040,6369,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14342',0.433187,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24319,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 14342','RN',24319,41.46,0.38,1360,6369,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14342',0.433187,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24320,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1pg',NULL,24320,42.35,0.15,1960,6370,72,NULL,NULL,'[NSB2006] J022704.16-041031.3',0.51,'2009ApJ...704.1036F',2009,1,NULL,NULL,'G',0.001,NULL,'22.7r',NULL,NULL,NULL,NULL,NULL,NULL,1,36.7673333333,-4.17536,0.021,NULL,34950039298,546094364,8532724,22.7),(24321,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1pg',NULL,24321,42.5,0.15,2100,6370,NULL,NULL,'SIFTO','[NSB2006] J022704.16-041031.3',0.51,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24322,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1pg',NULL,24322,42.51,0.14,2100,6370,70,NULL,'SALT 2','[NSB2006] J022704.16-041031.3',0.51,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24323,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1pg',NULL,24323,43.03,0.04,2670,6370,70,NULL,NULL,'[NSB2006] J022704.16-041031.3',0.51,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24324,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1pg',NULL,24324,43.86,0.17,3920,6370,NULL,NULL,'SALT2','[NSB2006] J022704.16-041031.3',0.51,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24325,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24325,37.05,0.69,258,6371,70,NULL,NULL,'2MASX J02270511-5117448',NULL,'2014MNRAS.445.2677S',2014,1,0.87,NULL,'G',0.00015,NULL,'16.09',0.38,'E',NULL,NULL,NULL,NULL,1,36.771375,-51.29583,0.065,NULL,38198396631,596849947,9325780,16.09),(24326,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24326,34.79,0.48,90.8,6372,NULL,NULL,'B, Hubble-type-TF','ESO 545- G 018',NULL,'2005Ap&SS.298..577R',2005,1,1,NULL,'G',0.000033,NULL,'15.79',0.3,'S',NULL,NULL,NULL,NULL,1,36.772375,-19.09456,0.105,NULL,37968853580,593263337,9269739,15.79),(24327,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24327,34.81,NULL,91.6,6372,NULL,NULL,'B, Hubble-type-TF','ESO 545- G 018',NULL,'2004ApJ...607..241R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24328,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24328,34.81,NULL,91.6,6372,NULL,NULL,'B','ESO 545- G 018',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24329,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24329,34.81,NULL,91.6,6372,NULL,NULL,'I','ESO 545- G 018',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24330,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24330,35.01,NULL,100,6372,NULL,NULL,'B','ESO 545- G 018',NULL,'2004ApJ...607..241R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24331,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24331,35.68,0.35,137,6372,NULL,NULL,'Malmquist cor.','ESO 545- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24332,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24332,35.78,0.33,144,6372,NULL,NULL,NULL,'ESO 545- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24333,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24333,35.83,0.2,147,6372,74.4,NULL,NULL,'ESO 545- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24334,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24334,35.33,0.55,116,6373,70,NULL,NULL,'6dF J0227078-225954',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,36.7825,-22.99839,0,NULL,37977016172,593390877,9271732,15.1),(24335,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2010gy',NULL,24335,37.52,0.02,300,6374,70,NULL,'SiFTO+SALT2, SN PTF10qyx, SN 2010gy','SN 2010gy',0.065,'2012MNRAS.426.2359M',2012,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,36.800167,-4.53469,0.021,NULL,34949824868,546091013,8532672,NULL),(24336,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2010gy',NULL,24336,37.41,0.05,303,6374,NULL,NULL,'J','SN 2010gy',NULL,'2012MNRAS.425.1007B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24337,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2010gy',NULL,24337,37.44,0.02,308,6374,72,NULL,'M(H) = -18.317 mag','SN 2010gy',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24338,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2010gy',NULL,24338,37.48,0.03,314,6374,NULL,NULL,'H','SN 2010gy',NULL,'2012MNRAS.425.1007B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24339,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','PS1 SN PS10nu',NULL,24339,37.54,0.13,302,6375,73.8,NULL,'SALT 2 (SNANA)','PTF10qyz HOST',0.0642,'2014ApJ...795...44R',2014,1,NULL,NULL,'G',0.0003,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,36.800125,-4.53467,0.021,NULL,34949824868,546091013,8532672,NULL),(24340,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24340,34.4,0.49,75.7,6376,70,NULL,NULL,'2MASX J02271313-1830304',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.000083,NULL,'15.81',0.32,'S',NULL,NULL,NULL,NULL,1,36.8047917,-18.5085,0.084,NULL,37960669881,593135466,9267741,15.81),(24341,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 14683',NULL,24341,40.12,0.27,1060,6377,70,NULL,'SN photometric redshift distance, z photo =0.286 +/- 0.045','SDSS-II SN 14683',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,36.805875,-0.08094,0.049,NULL,34922872561,545669883,8526091,NULL),(24342,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 14683','R',24342,40.75,0.21,1090,6377,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14683',0.292264,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24343,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 14683','R',24343,41.2,0.34,1340,6377,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14683',0.292264,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24344,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1ar',NULL,24344,41.09,0.17,1170,6378,NULL,NULL,'SALT2','[NSB2006] J022714.68-041905.0',0.408,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,'20.1r',NULL,NULL,NULL,NULL,NULL,NULL,1,36.811167,-4.31806,0.021,NULL,34949879988,546091874,8532685,20.1),(24345,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 03D1ar',NULL,24345,42.07,0.15,1840,6378,NULL,NULL,'SIFTO','[NSB2006] J022714.68-041905.0',0.408,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24346,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 16644','R',24346,41.01,0.36,1220,6379,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006pt','SN 2006pt',0.298808,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,36.817375,-0.39347,0.065,NULL,34922909920,545670467,8526101,NULL),(24347,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 16644','R',24347,41.16,0.25,1320,6379,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006pt','SN 2006pt',0.298808,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24348,'Brightest Stars','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24348,29.67,NULL,8.6,6380,NULL,NULL,NULL,'NGC 0925',NULL,'1998AJ....115..130S',1998,1,10.5,NULL,'G',0.00001,NULL,'10.69',5.9,'SAB(s)d        HII','Isolated galaxy',NULL,NULL,NULL,1,36.820333,33.57917,0.253,NULL,68631327689,1072364495,16755695,10.69),(24349,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24349,29.61,0.14,8.36,6380,73,NULL,'Cepheids periods Gaussian, Data 2','NGC 0925',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24350,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24350,29.62,0.03,8.39,6380,73,NULL,'Cepheids magnitudes Gaussian, Data 1','NGC 0925',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24351,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24351,29.68,0.1,8.63,6380,NULL,NULL,'73, VI','NGC 0925',NULL,'1997ApJ...491...13K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24352,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24352,29.72,0.06,8.78,6380,NULL,NULL,'cte LMC K03','NGC 0925',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24353,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24353,29.73,0.1,8.83,6380,NULL,NULL,'73, VI +Z','NGC 0925',NULL,'1997ApJ...491...13K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24354,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24354,29.73,0.06,8.83,6380,NULL,NULL,'cte U99','NGC 0925',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24355,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24355,29.74,0.06,8.89,6380,NULL,NULL,'cte LMC STS02','NGC 0925',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24356,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24356,29.75,0.07,8.91,6380,74.4,NULL,NULL,'NGC 0925',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24357,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24357,29.75,0.14,8.91,6380,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian, Data 1','NGC 0925',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24358,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24358,29.77,0.06,8.97,6380,NULL,NULL,'cte MW GFG98','NGC 0925',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24359,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24359,29.77,0.07,8.99,6380,NULL,NULL,'MW HIPP','NGC 0925',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24360,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24360,29.77,0.06,8.99,6380,NULL,NULL,'cte MW FSG03','NGC 0925',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24361,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24361,29.78,0.05,9.04,6380,NULL,NULL,'LMC W01','NGC 0925',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24362,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24362,29.8,0.04,9.12,6380,NULL,NULL,'72, VI, KEY PROJECT','NGC 0925',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24363,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24363,29.8,0.16,9.12,6380,NULL,NULL,'MW P02','NGC 0925',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24364,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24364,29.8,0.06,9.12,6380,NULL,NULL,'cte MF91','NGC 0925',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24365,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24365,29.81,0.04,9.16,6380,NULL,NULL,'72, VI, +Z, KEY PROJECT','NGC 0925',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24366,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24366,29.81,0.1,9.16,6380,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian, Data 2','NGC 0925',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24367,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24367,29.83,0.06,9.25,6380,NULL,NULL,'238, VI','NGC 0925',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24368,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24368,29.83,0.06,9.25,6380,NULL,NULL,'MW GFG','NGC 0925',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24369,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24369,29.83,0.06,9.26,6380,NULL,NULL,'cte MW STS03','NGC 0925',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24370,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24370,29.84,0.08,9.29,6380,NULL,NULL,'10, H','NGC 0925',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24371,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24371,29.84,0.08,9.29,6380,NULL,NULL,'HST KP Calibrated','NGC 0925',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24372,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24372,29.84,0.08,9.29,6380,NULL,NULL,'10, H','NGC 0925',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24373,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24373,29.84,NULL,9.29,6380,NULL,18.54,NULL,'NGC 0925',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24374,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24374,29.84,0.08,9.29,6380,NULL,NULL,'80, VI','NGC 0925',NULL,'1996ApJ...470....1S',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24375,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24375,29.84,0.04,9.29,6380,NULL,18.54,'LMC ZP','NGC 0925',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24376,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24376,29.89,0.15,9.51,6380,73,NULL,'Cepheids periods Gaussian, Data 1','NGC 0925',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24377,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24377,30.01,0.03,10,6380,73,NULL,'Cepheids magnitudes Gaussian, Data 2','NGC 0925',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24378,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24378,30.08,0.05,10.4,6380,NULL,NULL,'10, I','NGC 0925',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24379,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24379,30.08,0.05,10.4,6380,NULL,NULL,'10, I','NGC 0925',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24380,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24380,30.3,0.1,11.5,6380,NULL,NULL,'10, V','NGC 0925',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24381,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24381,30.3,0.01,11.5,6380,NULL,NULL,'10, V','NGC 0925',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24382,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24382,30.3,0.02,11.5,6380,NULL,NULL,'BVRI','NGC 0925',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24383,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24383,30.33,0.02,11.6,6380,NULL,NULL,'BVRI','NGC 0925',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24384,'Cepheids','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24384,30.71,NULL,13.9,6380,NULL,NULL,'60, VI','NGC 0925',NULL,'2006A&A...452..423P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24385,'TRGB','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24385,29.75,0.07,8.91,6380,74.4,NULL,NULL,'NGC 0925',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24386,'HII region diameter','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24386,29.91,NULL,9.6,6380,NULL,NULL,NULL,'NGC 0925',NULL,'1988ApL&C..27...41S',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24387,'IRAS','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24387,29.94,0.8,9.75,6380,75,NULL,'A82, H','NGC 0925',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24388,'Sosies','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24388,29.82,0.19,9.2,6380,NULL,NULL,NULL,'NGC 0925',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24389,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24389,28.8,0.3,5.75,6380,NULL,18.45,'NGC 1023 group','NGC 0925',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24390,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24390,29.03,0.4,6.4,6380,73,NULL,'opt','NGC 0925',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24391,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24391,29.05,0.43,6.5,6380,75,NULL,'3.6 micron, color corrected','NGC 0925',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24392,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24392,29.07,0.43,6.5,6380,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0925',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24393,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24393,29.13,0.57,6.69,6380,NULL,NULL,NULL,'NGC 0925',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24394,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24394,29.13,0.57,6.69,6380,NULL,NULL,'Malmquist cor.','NGC 0925',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24395,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24395,29.16,0.47,6.8,6380,75,NULL,'A82, H, inv','NGC 0925',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24396,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24396,29.18,0.63,6.85,6380,NULL,NULL,'B','NGC 0925',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24397,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24397,29.2,0.47,6.92,6380,75,NULL,'A82, H, raw','NGC 0925',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24398,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24398,29.22,NULL,6.98,6380,NULL,NULL,'LEDA [April 2006]','NGC 0925',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24399,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24399,29.23,0.4,7,6380,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 0925',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24400,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24400,29.34,0.35,7.38,6380,NULL,NULL,NULL,'NGC 0925',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24401,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24401,29.42,0.39,7.66,6380,NULL,NULL,'I','NGC 0925',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24402,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24402,29.52,0.47,8.03,6380,75,NULL,'A82, H, cor','NGC 0925',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24403,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24403,29.75,0.07,8.91,6380,74.4,NULL,NULL,'NGC 0925',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24404,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24404,29.81,0.04,9.16,6380,75,NULL,NULL,'NGC 0925',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24405,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24405,29.86,0.4,9.4,6380,75,NULL,'B','NGC 0925',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24406,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24406,35.77,0.47,143,6381,70,NULL,NULL,'MCG -03-07-020',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.000143,NULL,'14.93',0.54,'E',NULL,NULL,NULL,NULL,1,36.824417,-19.18936,0.105,NULL,37968849010,593263265,9269738,14.93),(24407,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 01495','RN',24407,39.95,0.26,812,6382,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 01495',0.204987,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24408,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 01495','RN',24408,40.29,0.34,950,6382,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 01495',0.204987,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24409,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 17852','RN',24409,40.1,0.1,976,6383,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 17852',0.07185,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24410,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 17852','RN',24410,40.88,0.23,1400,6383,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 17852',0.07185,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24411,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1pu',NULL,24411,41.03,0.17,978,6384,NULL,NULL,'SALT2','VVDS:[RBO2008] ir 00034185',0.639,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',NULL,NULL,'22.7r',NULL,'Ia',NULL,NULL,NULL,NULL,1,36.8685,-4.74492,0.009,NULL,34950213427,546097084,8532766,22.7),(24412,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1pu',NULL,24412,42.6,0.26,2020,6384,70,NULL,'SALT 2','VVDS:[RBO2008] ir 00034185',0.639,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24413,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1pu',NULL,24413,42.76,0.15,2170,6384,NULL,NULL,'SIFTO','VVDS:[RBO2008] ir 00034185',0.639,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24414,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1pu',NULL,24414,43.75,0.06,3430,6384,70,NULL,'SALT2','VVDS:[RBO2008] ir 00034185',0.639,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24415,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24415,34.25,0.4,70.8,6385,NULL,NULL,'mean','UGC 01918',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000033,NULL,'14.57',0.6,'SBab',NULL,NULL,NULL,NULL,1,36.8853333333,25.66872,0.221,NULL,68611460324,1072054067,16750844,14.57),(24416,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24416,34.41,0.47,76.3,6385,NULL,NULL,'H','UGC 01918',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24417,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24417,34.45,0.45,77.5,6385,NULL,NULL,'K','UGC 01918',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24418,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24418,34.51,0.46,79.7,6385,NULL,NULL,'J','UGC 01918',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24419,'IRAS','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24419,32.14,0.8,26.8,6386,75,NULL,'MAT, I','MRK 1039',NULL,'1997ApJS..109..333W',1997,1,1.5,'Redshift refers to eastern component. See 1992, A&AS, 96, 389.','G',0.000017,NULL,'15.5',0.5,'Sc? sp         HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,36.8865416667,-10.16564,0.009,NULL,34934204212,545846940,8528858,15.5),(24420,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24420,31.3,0.43,18.2,6386,75,NULL,'3.6 micron, color + selection bias corrected','MRK 1039',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24421,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24421,31.34,0.32,18.5,6386,85,NULL,'I, inv','MRK 1039',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24422,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24422,31.37,0.32,18.8,6386,85,NULL,'I, raw','MRK 1039',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24423,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24423,31.38,0.43,18.9,6386,75,NULL,'3.6 micron, color corrected','MRK 1039',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24424,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24424,31.42,0.4,19.2,6386,75,NULL,NULL,'MRK 1039',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24425,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24425,31.42,0.39,19.2,6386,73,NULL,'IR','MRK 1039',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24426,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24426,31.51,0.2,20,6386,74.4,NULL,NULL,'MRK 1039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24427,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24427,31.79,0.43,22.8,6386,75,NULL,'MAT, I, inv','MRK 1039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24428,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24428,31.81,0.44,23,6386,NULL,NULL,'Malmquist cor.','MRK 1039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24429,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24429,31.84,0.49,23.3,6386,75,NULL,'IR','MRK 1039',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24430,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24430,31.87,0.43,23.6,6386,75,NULL,'MAT, I, raw','MRK 1039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24431,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24431,31.91,0.42,24.1,6386,NULL,NULL,NULL,'MRK 1039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24432,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24432,32.02,0.43,25.4,6386,75,NULL,'MAT, I, cor','MRK 1039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24433,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24433,34.92,0.46,96.3,6387,70,NULL,NULL,'NGC 0934',NULL,'2015arXiv151105856S',2015,1,1.09,NULL,'G',0.000073,NULL,'14.3g',0.79,'SAB0-','in a radial-velocity based grouping',NULL,NULL,NULL,1,36.8872083,-0.24456,0.041,NULL,34923080360,545673130,8526142,14.3),(24434,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24434,35.55,0.23,129,6388,74.4,NULL,NULL,'MCG +04-06-048',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.00007,NULL,'14.38',0.5,'E',NULL,NULL,NULL,NULL,1,36.888083,23.05992,0.329,NULL,68105297033,1064145266,16627269,14.38),(24435,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24435,35.77,0.17,143,6388,70,NULL,NULL,'MCG +04-06-048',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24436,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1ak',NULL,24436,40.64,0.17,879,6389,NULL,NULL,'SALT2','[AGR2006] J022733.39-041938.7',0.526,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,'22.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,36.889167,-4.32742,0.021,NULL,34949883867,546091935,8532686,22.3),(24437,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1ak',NULL,24437,41.68,0.17,1420,6389,74.2,NULL,'SALT 2','[AGR2006] J022733.39-041938.7',0.526,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24438,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1ak','R',24438,42.27,NULL,1860,6389,65,NULL,'MLCS17','[AGR2006] J022733.39-041938.7',0.526,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24439,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1ak',NULL,24439,42.37,0.19,1950,6389,65,NULL,'MLCS2k2','[AGR2006] J022733.39-041938.7',0.526,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24440,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1ak',NULL,24440,42.38,0.27,1960,6389,65,NULL,'MLCS17','[AGR2006] J022733.39-041938.7',0.526,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24441,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1ak',NULL,24441,42.47,0.29,2040,6389,65,NULL,'MLCS31','[AGR2006] J022733.39-041938.7',0.526,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24442,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1ak',NULL,24442,42.49,0.27,2070,6389,65,NULL,'MLCS2k2','[AGR2006] J022733.39-041938.7',0.526,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24443,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1ak',NULL,24443,42.52,0.22,2090,6389,65,NULL,'SALT2','[AGR2006] J022733.39-041938.7',0.526,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24444,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1ak',NULL,24444,42.64,0.06,2210,6389,70,NULL,NULL,'[AGR2006] J022733.39-041938.7',0.526,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24445,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1ak',NULL,24445,42.67,0.15,2240,6389,70,NULL,'SALT','[AGR2006] J022733.39-041938.7',0.526,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24446,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1ak',NULL,24446,42.71,0.21,2290,6389,65,NULL,'SALT2','[AGR2006] J022733.39-041938.7',0.526,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24447,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1ak',NULL,24447,42.82,0.12,2400,6389,65,NULL,'SALT','[AGR2006] J022733.39-041938.7',0.526,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24448,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1ak',NULL,24448,42.91,0.06,2500,6389,65,NULL,'SALT','[AGR2006] J022733.39-041938.7',0.526,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24449,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1ak',NULL,24449,43.04,0.15,2660,6389,NULL,NULL,'SIFTO','[AGR2006] J022733.39-041938.7',0.526,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24450,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2000ee',NULL,24450,42.74,0.23,2400,6390,65,NULL,NULL,'H-ZSNS J022734.53+011149.4',0.47,'2004ApJ...607..665R',2004,1,NULL,NULL,'G',NULL,NULL,'22.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,36.8936666667,1.19736,0.021,NULL,66880820542,1045012820,16328325,22.9),(24451,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24451,34.14,0.47,67.2,6391,NULL,NULL,'H','NGC 0923',NULL,'2007A&A...465...71T',2007,1,0.8,NULL,'G',0.000023,NULL,'14.47',0.5,'Sb:','Group member',NULL,NULL,NULL,1,36.894333,41.97761,0.273,NULL,68537776071,1070902751,16732855,14.47),(24452,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24452,34.22,0.45,69.8,6391,NULL,NULL,'K','NGC 0923',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24453,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24453,34.31,0.46,72.7,6391,NULL,NULL,'J','NGC 0923',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24454,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24454,34.4,0.4,75.7,6391,NULL,NULL,'mean','NGC 0923',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24455,'SBF','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24455,31.81,0.28,23,6392,NULL,NULL,'I','NGC 0936',NULL,'2001ApJ...546..681T',2001,1,4.7,NULL,'G',0.000014,NULL,'11.12',4.1,'SB(rs)0+','in a radial-velocity based grouping',NULL,NULL,NULL,1,36.906083,-1.15628,0.049,NULL,34923128515,545673883,8526154,11.12),(24456,'SBF','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24456,31.81,0.28,23,6392,NULL,NULL,NULL,'NGC 0936',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24457,'SBF','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24457,31.89,0.28,23.9,6392,NULL,NULL,'Malmquist cor.','NGC 0936',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24458,'SBF','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24458,32.24,0.12,28.1,6392,74.4,NULL,NULL,'NGC 0936',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24459,'Faber-Jackson','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24459,30.72,0.53,13.9,6392,95,NULL,'de Vaucouleurs','NGC 0936',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24460,'Faber-Jackson','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24460,30.94,0.3,15.4,6392,95,NULL,'Weighted Mean','NGC 0936',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24461,'Faber-Jackson','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24461,31.02,NULL,16,6392,NULL,NULL,'LEDA [April 2006]','NGC 0936',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24462,'Faber-Jackson','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24462,31.11,0.46,16.7,6392,95,NULL,'Michard 1979a','NGC 0936',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24463,'Faber-Jackson','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24463,31.14,0.63,16.9,6392,95,NULL,'Michard 1979b, c','NGC 0936',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24464,'Faber-Jackson','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24464,32.63,0.81,33.6,6392,55,NULL,'Visvanathan & Sandage 1979','NGC 0936',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24465,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24465,31.2,0.41,17.4,6392,NULL,NULL,NULL,'NGC 0936',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24466,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24466,31.49,0.41,19.9,6392,NULL,NULL,'Malmquist cor.','NGC 0936',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24467,'Tertiary','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24467,30.69,0.25,13.7,6392,95,NULL,NULL,'NGC 0936',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24468,'Tully est','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24468,31.14,0.8,16.9,6392,75,NULL,'B','NGC 0936',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24469,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24469,32.24,0.12,28.1,6392,74.4,NULL,NULL,'NGC 0936',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24470,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24470,38.63,0.46,533,6393,70,NULL,NULL,'2MASX J02273826-0051444',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000099,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,36.9095,-0.86225,0.045,NULL,34923267087,545676048,8526188,17.4),(24471,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1pd',NULL,24471,43.77,0.23,2880,6394,70,NULL,'SALT 2','VVDS 020167448',0.965,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',0.000921,NULL,'25.5V',NULL,NULL,NULL,NULL,NULL,NULL,1,36.915583,-4.63111,0.013,NULL,34950162706,546096292,8532754,25.5),(24472,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1pd',NULL,24472,43.93,NULL,3110,6394,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','VVDS 020167448',0.965,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24473,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1pd',NULL,24473,43.96,0.08,3150,6394,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','VVDS 020167448',0.965,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24474,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1pd',NULL,24474,43.99,0.15,3190,6394,NULL,NULL,'SIFTO','VVDS 020167448',0.965,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (24475,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1pd',NULL,24475,44.35,0.17,3770,6394,NULL,NULL,'SALT2','VVDS 020167448',0.965,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24476,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1iy',NULL,24476,39.16,0.17,546,6395,NULL,NULL,'SALT2','SNLS 05D1iy HOST',0.2478,'2010A&A...523A...7G',2010,1,NULL,NULL,'SN',0.0003,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,36.9165417,-4.42258,0.021,NULL,34949702507,546089101,8532642,NULL),(24477,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1iy',NULL,24477,40.51,0.15,1010,6395,72,NULL,'z lit','SNLS 05D1iy HOST',0.2478,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24478,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1iy',NULL,24478,40.66,0.15,1090,6395,NULL,NULL,'SIFTO','SNLS 05D1iy HOST',0.2478,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24479,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 20458','RN',24479,42.95,0.32,2810,6396,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20458',0.384198,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24480,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 20458','RN',24480,43.43,0.31,3510,6396,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 20458',0.384198,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24481,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2005eu',NULL,24481,35.22,0.17,107,6397,74.2,NULL,'SALT 2','NSF J022743.32+281037.6',0.0349,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,'?',NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,36.9305,28.17711,0.321,NULL,68645909513,1072592336,16759255,NULL),(24482,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2005eu',NULL,24482,35.39,0.06,116,6397,72,NULL,NULL,'NSF J022743.32+281037.6',0.0349,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24483,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2005eu',NULL,24483,35.5,0.05,122,6397,70,NULL,'SALT 2','NSF J022743.32+281037.6',0.0349,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24484,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2005eu',NULL,24484,35.48,0.07,125,6397,72,NULL,'M(H) = -18.317 mag','NSF J022743.32+281037.6',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24485,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2005eu',NULL,24485,35.81,0.04,140,6397,72,NULL,NULL,'NSF J022743.32+281037.6',0.0349,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24486,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2005eu','R',24486,35.83,0.06,147,6397,NULL,NULL,'MLCS2k2, R(V) = 1.8','NSF J022743.32+281037.6',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24487,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2005eu','R',24487,35.88,0.06,150,6397,NULL,NULL,'MLCS2k2, R(V) = 3.1','NSF J022743.32+281037.6',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24488,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2005eu',NULL,24488,35.96,0.15,150,6397,73.8,NULL,'SALT 2 (SNANA)','NSF J022743.32+281037.6',0.0348,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24489,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2005eu',NULL,24489,36.03,0.19,156,6397,65,NULL,'SALT2','NSF J022743.32+281037.6',0.0349,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24490,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2005eu',NULL,24490,36.09,0.16,159,6397,65,NULL,'SALT','NSF J022743.32+281037.6',0.0349,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24491,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2005eu',NULL,24491,36.12,0.15,162,6397,65,NULL,'MLCS17','NSF J022743.32+281037.6',0.0349,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24492,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2005eu',NULL,24492,36.18,0.14,166,6397,65,NULL,'MLCS31','NSF J022743.32+281037.6',0.0349,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24493,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24493,35.77,0.17,143,6398,70,NULL,NULL,'GIN 133',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,36.93475,23.02844,0.329,NULL,68105294675,1064145229,16627269,NULL),(24494,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 06397','RN',24494,40.11,0.21,983,6399,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06397',0.069689,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24495,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 06397','RN',24495,40.45,0.26,1150,6399,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06397',0.069689,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24496,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1hm',NULL,24496,42.92,0.16,2410,6400,70,NULL,'SALT 2','SNLS 05D1hm',0.587,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,36.942583,-4.71728,0.009,NULL,34950216722,546097136,8532767,NULL),(24497,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1hm',NULL,24497,43,0.15,2510,6400,NULL,NULL,'SIFTO','SNLS 05D1hm',0.587,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24498,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1hm',NULL,24498,43.62,0.05,3340,6400,70,NULL,'SIFTO','SNLS 05D1hm',0.587,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24499,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1hm',NULL,24499,44.47,0.17,4950,6400,NULL,NULL,'SALT2','SNLS 05D1hm',0.587,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24500,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24500,37.52,0.17,319,6401,70,NULL,NULL,'2MASX J02274637-0110033',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,'FoF','18.41',0.16,NULL,NULL,NULL,NULL,NULL,1,36.943083,-1.16756,0.041,NULL,34923127662,545673869,8526154,18.41),(24501,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24501,38.11,0.77,419,6402,70,NULL,NULL,'2MASX J02274654-2333213',NULL,'2014MNRAS.445.2677S',2014,1,0.38,'6dF DR2 has z = 0.053060.','G',0.00009,NULL,'17.03',0.32,NULL,NULL,NULL,NULL,NULL,1,36.943917,-23.55583,0,NULL,37942214614,592847103,9263235,17.03),(24502,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1dx',NULL,24502,42.32,0.04,1840,6403,70,NULL,'SIFTO','SNLS 05D1dx',0.58,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,36.9457917,-4.0325,0.021,NULL,34950076192,546094940,8532733,NULL),(24503,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1dx',NULL,24503,42.67,0.13,2160,6403,70,NULL,'SALT 2','SNLS 05D1dx',0.58,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24504,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1dx',NULL,24504,42.68,0.15,2170,6403,NULL,NULL,'SIFTO','SNLS 05D1dx',0.58,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24505,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 05D1dx',NULL,24505,43.65,0.17,3400,6403,NULL,NULL,'SALT2','SNLS 05D1dx',0.58,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24506,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1rh',NULL,24506,41.63,0.04,1480,6404,70,NULL,'SIFTO','[NSB2006] J022747.16-041513.6',0.43,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.0005,NULL,'21.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,36.9465,-4.25378,0.021,NULL,34949856728,546091511,8532679,21.8),(24507,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1rh',NULL,24507,41.91,0.15,1690,6404,NULL,NULL,'SIFTO','[NSB2006] J022747.16-041513.6',0.43,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24508,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1rh',NULL,24508,41.94,0.13,1710,6404,72,NULL,NULL,'[NSB2006] J022747.16-041513.6',0.43,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24509,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1rh',NULL,24509,41.98,0.12,1740,6404,70,NULL,'SALT 2','[NSB2006] J022747.16-041513.6',0.43,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24510,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1rh',NULL,24510,43.41,0.17,3360,6404,NULL,NULL,'SALT2','[NSB2006] J022747.16-041513.6',0.43,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24511,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003li','R',24511,41.79,NULL,1470,6405,65,NULL,'SN f244, MLCS17','ESSENCE J022747.29-073346.2',0.544,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,36.9470417,-7.56283,0.089,NULL,34943035573,545984930,8531014,NULL),(24512,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003li',NULL,24512,41.8,0.28,1480,6405,74.2,NULL,'SALT 2','ESSENCE J022747.29-073346.2',0.544,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24513,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003li',NULL,24513,42.57,0.25,2120,6405,70,NULL,'SN f244, SALT','ESSENCE J022747.29-073346.2',0.544,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24514,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003li',NULL,24514,42.6,0.27,2140,6405,65,NULL,'SN f244, SALT2','ESSENCE J022747.29-073346.2',0.544,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24515,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003li',NULL,24515,42.61,0.26,2160,6405,65,NULL,'SN f244, MLCS17','ESSENCE J022747.29-073346.2',0.544,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24516,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003li',NULL,24516,42.64,0.27,2190,6405,65,NULL,'SN f244, SALT2','ESSENCE J022747.29-073346.2',0.544,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24517,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003li',NULL,24517,42.68,0.21,2230,6405,65,NULL,'SN f244, m15(B)','ESSENCE J022747.29-073346.2',0.544,'2005AJ....130.2453K',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24518,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003li',NULL,24518,42.68,0.24,2230,6405,65,NULL,'SN f244, MLCS2k2','ESSENCE J022747.29-073346.2',0.544,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24519,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003li',NULL,24519,42.69,0.25,2240,6405,65,NULL,'SN f244, MLCS31','ESSENCE J022747.29-073346.2',0.544,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24520,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003li',NULL,24520,42.72,0.24,2270,6405,65,NULL,'SN f244, MLCS2k2','ESSENCE J022747.29-073346.2',0.544,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24521,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003li',NULL,24521,42.74,0.22,2290,6405,65,NULL,'SN f244, SALT','ESSENCE J022747.29-073346.2',0.544,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24522,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003li',NULL,24522,42.81,0.08,2360,6405,65,NULL,'SN f244, SALT','ESSENCE J022747.29-073346.2',0.544,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24523,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003li',NULL,24523,43.03,0.24,2610,6405,65,NULL,'SN f244, MLCS','ESSENCE J022747.29-073346.2',0.544,'2005AJ....130.2453K',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24524,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003li',NULL,24524,43.03,0.35,2610,6405,65,NULL,'SN f244, BATM','ESSENCE J022747.29-073346.2',0.544,'2005AJ....130.2453K',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24525,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24525,37.52,0.17,319,6406,70,NULL,NULL,'2MASX J02274904-0110353',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000078,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,36.954333,-1.17639,0.041,NULL,34923135903,545673998,8526156,17.5),(24526,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 15451','RN',24526,39.35,0.1,691,6407,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15451',0.072843,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24527,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 15451','RN',24527,39.36,0.3,695,6407,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15451',0.072843,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24528,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24528,36.99,0.62,250,6408,70,NULL,NULL,'2MASX J02274954-0526053',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'17.25',0.3,NULL,NULL,NULL,NULL,NULL,1,36.956417,-5.43481,0.013,NULL,34948646930,546072608,8532384,17.25),(24529,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24529,30.63,NULL,13.4,6409,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01924',NULL,'2010Ap&SS.325..163P',2010,1,2.39,NULL,'G',0.000008,NULL,'15.23',0.34,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,36.9577083,31.72672,0.297,NULL,68639337439,1072489647,16757650,15.23),(24530,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24530,30.67,NULL,13.6,6409,NULL,NULL,'Dipole + Quadrupole','UGC 01924',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24531,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24531,30.67,NULL,13.6,6409,NULL,NULL,'Dipole','UGC 01924',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24532,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24532,30.77,NULL,14.3,6409,NULL,NULL,NULL,'UGC 01924',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24533,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 16665','RN',24533,38.07,0.59,360,6410,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16665',0.140367,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24534,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE m034',NULL,24534,42.34,0.34,1890,6411,74.2,NULL,'SALT 2','ESSENCE m034 HOST',0.557,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,36.9597083333,-7.98656,0.069,NULL,34946667369,546041677,8531901,NULL),(24535,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE m034',NULL,24535,42.67,0.27,2190,6411,65,NULL,'MLCS17','ESSENCE m034 HOST',0.557,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24536,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE m034',NULL,24536,42.77,0.24,2300,6411,65,NULL,'MLCS31','ESSENCE m034 HOST',0.557,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24537,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE m034',NULL,24537,42.8,0.23,2330,6411,65,NULL,'MLCS2k2','ESSENCE m034 HOST',0.557,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24538,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE m034',NULL,24538,43.18,0.25,2780,6411,70,NULL,'SALT','ESSENCE m034 HOST',0.557,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24539,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE m034',NULL,24539,43.19,0.33,2790,6411,65,NULL,'SALT2','ESSENCE m034 HOST',0.557,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24540,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE m034',NULL,24540,43.34,0.13,2990,6411,65,NULL,'SALT','ESSENCE m034 HOST',0.557,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24541,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1jd',NULL,24541,43.31,0.24,2590,6412,70,NULL,'SALT 2','VVDS:[RBO2008] ir 00023872',0.778,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'VisS',0.001,NULL,'24.0r',NULL,'Candidate      QSO',NULL,NULL,NULL,NULL,1,36.9617083333,-4.94381,0.017,NULL,34950297669,546098401,8532787,24),(24542,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1jd',NULL,24542,43.61,0.15,2970,6412,NULL,NULL,'SIFTO','VVDS:[RBO2008] ir 00023872',0.778,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24543,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1jd',NULL,24543,43.76,0.17,3170,6412,NULL,NULL,'SALT2','VVDS:[RBO2008] ir 00023872',0.778,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24544,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1jd',NULL,24544,43.78,0.05,3210,6412,70,NULL,'SIFTO','VVDS:[RBO2008] ir 00023872',0.778,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24545,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24545,35.9,0.49,151,6412,75,NULL,'IR','UGC 01934',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24546,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24546,36.27,0.2,179,6413,74.4,NULL,NULL,'UGC 01934',NULL,'2013AJ....146...86T',2013,1,1.55,NULL,'G',0.000024,NULL,'15.3g',0.3,'Sb(f)',NULL,NULL,NULL,NULL,1,36.9643333333,0.50156,0.037,NULL,66881159076,1045018110,16328407,15.3),(24547,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24547,37.52,0.17,319,6414,70,NULL,NULL,'2MASX J02275197-0110103',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.16',0.19,NULL,NULL,NULL,NULL,NULL,1,36.9665417,-1.16944,0.041,NULL,34923135832,545673997,8526156,18.16),(24548,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24548,37.52,0.17,319,6415,70,NULL,NULL,'2MASX J02275250-0109103',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000103,NULL,'16.5g',0.38,NULL,NULL,NULL,NULL,NULL,1,36.9687917,-1.15278,0.041,NULL,34923135015,545673984,8526156,16.5),(24549,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24549,37.52,0.17,319,6416,70,NULL,NULL,'SDSS J022752.51-011103.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000078,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,36.9688333333,-1.18436,0.041,NULL,34923135743,545673995,8526156,18.3),(24550,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1kj',NULL,24550,42.34,0.04,1860,6417,70,NULL,'SIFTO','[NSB2006] J022752.66-041049.2',0.585,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,36.9694583333,-4.18036,0.021,NULL,34950067390,546094802,8532731,NULL),(24551,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1kj',NULL,24551,42.7,0.13,2190,6417,70,NULL,'SALT 2','[NSB2006] J022752.66-041049.2',0.585,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24552,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1kj',NULL,24552,42.76,0.15,2250,6417,NULL,NULL,'SIFTO','[NSB2006] J022752.66-041049.2',0.585,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24553,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1kj',NULL,24553,43.21,0.17,2770,6417,NULL,NULL,'SALT2','[NSB2006] J022752.66-041049.2',0.585,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24554,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 17835','RN',24554,42.29,0.28,1810,6418,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17835',0.587383,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24555,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1sa',NULL,24555,42.47,0.17,1970,6419,NULL,NULL,'SALT2','[NSB2006] J022756.16-041034.3',0.585,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,'21.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,36.984,-4.17619,0.021,NULL,34950068098,546094814,8532731,21.1),(24556,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1sa',NULL,24556,42.65,0.05,2140,6419,70,NULL,'SALT2','[NSB2006] J022756.16-041034.3',0.585,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24557,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1sa',NULL,24557,42.85,0.14,2340,6419,70,NULL,'SALT 2','[NSB2006] J022756.16-041034.3',0.585,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24558,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SNLS 04D1sa',NULL,24558,42.86,0.15,2360,6419,NULL,NULL,'SIFTO','[NSB2006] J022756.16-041034.3',0.585,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24559,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 1999fh',NULL,24559,41.37,0.38,1380,6420,70,NULL,'SALT','H-ZSNS J022758.33+003936.8',0.36,'2008ApJ...686..749K',2008,1,NULL,NULL,'G',NULL,NULL,'21.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,36.993167,0.6605,0.037,NULL,66881170167,1045018283,16328410,21.4),(24560,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 1999fh',NULL,24560,41.46,0.47,1440,6420,65,NULL,'BATM','H-ZSNS J022758.33+003936.8',0.36,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24561,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 1999fh',NULL,24561,41.61,0.36,1540,6420,65,NULL,'Final','H-ZSNS J022758.33+003936.8',0.36,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24562,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 1999fh',NULL,24562,41.62,0.31,1550,6420,65,NULL,NULL,'H-ZSNS J022758.33+003936.8',0.36,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24563,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 1999fh',NULL,24563,41.77,0.26,1660,6420,65,NULL,'dm15','H-ZSNS J022758.33+003936.8',0.36,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24564,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 01449','RN',24564,42.99,0.21,2890,6421,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01449',0.371837,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24565,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 01449','RN',24565,43.22,0.07,3210,6421,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01449',0.371837,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24566,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 16433',NULL,24566,40.33,0.21,1170,6422,70,NULL,'SN photometric redshift distance, z photo =0.322 +/- 0.040','SDSS-II SN 16433',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','23.6g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,36.9960833333,-1.16928,0.041,NULL,34923110147,545673596,8526149,23.6),(24567,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 16433','R',24567,41.96,0.23,1750,6422,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16433',0.402876,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24568,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 16433','R',24568,42.11,0.32,1890,6422,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16433',0.402876,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24569,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24569,36.35,0.71,186,6423,70,NULL,NULL,'2MASX J02280002-0240383',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.72',0.36,NULL,NULL,NULL,NULL,NULL,1,37.000167,-2.67733,0.041,NULL,34926205160,545721955,8526905,16.72),(24570,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24570,35.29,0.2,114,6424,74.4,NULL,NULL,'CGCG 483-061',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000033,NULL,'15.49',0.3,'S?',NULL,NULL,NULL,NULL,1,37.0062917,21.79772,0.353,NULL,68114317480,1064286210,16629472,15.49),(24571,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2004hm',NULL,24571,38.97,0.23,531,6425,74.2,NULL,'SALT 2','ESSENCE J022803.11-074229.7',0.172,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.0129583,-7.70825,0.101,NULL,34946631251,546041113,8531892,NULL),(24572,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2004hm',NULL,24572,39.58,0.07,703,6425,70,NULL,'SN k429, SALT','ESSENCE J022803.11-074229.7',0.172,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24573,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2004hm',NULL,24573,39.8,0.18,778,6425,65,NULL,'SN k429, MLCS17','ESSENCE J022803.11-074229.7',0.172,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24574,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2004hm',NULL,24574,39.82,0.3,784,6425,65,NULL,'SN k429, SALT2','ESSENCE J022803.11-074229.7',0.172,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24575,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2004hm',NULL,24575,39.84,0.02,791,6425,65,NULL,'SN k429, SALT','ESSENCE J022803.11-074229.7',0.172,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24576,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2004hm',NULL,24576,39.85,0.17,797,6425,65,NULL,'SN k429, MLCS31','ESSENCE J022803.11-074229.7',0.172,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24577,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2004hm',NULL,24577,39.85,0.31,798,6425,65,NULL,'SN k429, SALT2','ESSENCE J022803.11-074229.7',0.172,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24578,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2004hm',NULL,24578,39.89,0.14,811,6425,65,NULL,'SN k429, MLCS2k2','ESSENCE J022803.11-074229.7',0.172,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24579,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2004hm',NULL,24579,39.89,0.13,812,6425,65,NULL,'SN k429, MLCS2k2','ESSENCE J022803.11-074229.7',0.172,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24580,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24580,37.84,0.46,370,6426,70,NULL,NULL,'2MASX J02280371-0052373',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000075,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,37.0155417,-0.87717,0.049,NULL,34923297756,545676527,8526195,17.7),(24581,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE m039',NULL,24581,39.67,0.24,688,6427,74.2,NULL,'SALT 2','SDSS J022804.62-074244.1',0.248,'2010ApJ...716..712A',2010,1,0.1,NULL,'G',NULL,NULL,'20.40',0.09,NULL,NULL,NULL,NULL,NULL,1,37.0192917,-7.71225,0.101,NULL,34946631487,546041116,8531892,20.4),(24582,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE m039',NULL,24582,40.63,0.19,1070,6427,70,NULL,'SALT','SDSS J022804.62-074244.1',0.248,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24583,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE m039',NULL,24583,40.74,0.32,1130,6427,65,NULL,'SALT2','SDSS J022804.62-074244.1',0.248,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24584,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE m039',NULL,24584,40.8,0.35,1160,6427,65,NULL,'MLCS2k2','SDSS J022804.62-074244.1',0.248,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24585,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE m039',NULL,24585,40.79,0.37,1160,6427,65,NULL,'MLCS31','SDSS J022804.62-074244.1',0.248,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24586,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE m039',NULL,24586,40.83,0.33,1170,6427,65,NULL,'MLCS17','SDSS J022804.62-074244.1',0.248,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24587,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE m039',NULL,24587,41.12,0.17,1340,6427,65,NULL,'SALT','SDSS J022804.62-074244.1',0.248,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24588,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24588,34.22,0.49,69.7,6428,75,NULL,'IR','ESO 198- G 012',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.68',0.2,'Sb-c',NULL,NULL,NULL,NULL,1,37.0219166667,-47.85622,NULL,NULL,38244669272,597572957,9337077,15.68),(24589,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24589,34.23,0.41,70.1,6428,NULL,NULL,NULL,'ESO 198- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24590,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24590,34.27,0.2,71.5,6428,74.4,NULL,NULL,'ESO 198- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24591,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24591,34.48,0.36,78.8,6428,NULL,NULL,'Malmquist cor.','ESO 198- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24592,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2001jf',NULL,24592,43.36,0.75,2590,6429,74.2,NULL,'SALT 2','H-ZSNS J022807.13+002645.1',0.815,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.0297083,0.44586,0.037,NULL,66881260151,1045019689,16328432,NULL),(24593,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2001jf',NULL,24593,43.8,0.3,3170,6429,72,NULL,'MLCS','H-ZSNS J022807.13+002645.1',0.815,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24594,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2001jf',NULL,24594,43.9,0.32,3320,6429,72,NULL,'BATM','H-ZSNS J022807.13+002645.1',0.815,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24595,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2001jf','R',24595,43.97,NULL,3430,6429,65,NULL,'SALT','H-ZSNS J022807.13+002645.1',0.815,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24596,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2001jf',NULL,24596,44.09,0.28,3620,6429,65,NULL,NULL,'H-ZSNS J022807.13+002645.1',0.815,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24597,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2001jf',NULL,24597,44.14,0.92,3710,6429,70,NULL,'SALT','H-ZSNS J022807.13+002645.1',0.815,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24598,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2001jf',NULL,24598,44.3,1.1,4000,6429,65,NULL,'SALT','H-ZSNS J022807.13+002645.1',0.815,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24599,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24599,38.05,0.59,407,6430,70,NULL,NULL,'2MASX J02280783-0316403',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.68',0.38,NULL,NULL,NULL,NULL,NULL,1,37.0325416667,-3.27778,0.017,NULL,34949063663,546079119,8532486,16.68),(24600,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE n256','R',24600,41.77,NULL,1380,6431,65,NULL,'SALT','ESSENCE n256 HOST',0.631,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.0375417,-7.79711,0.101,NULL,34946640635,546041259,8531894,NULL),(24601,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE n256',NULL,24601,42.17,0.24,1670,6431,74.2,NULL,'SALT 2','ESSENCE n256 HOST',0.631,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24602,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE n256',NULL,24602,42.93,0.23,2360,6431,70,NULL,'SALT','ESSENCE n256 HOST',0.631,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24603,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE n256',NULL,24603,42.96,0.18,2400,6431,65,NULL,'MLCS2k2','ESSENCE n256 HOST',0.631,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24604,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE n256',NULL,24604,43.01,0.15,2450,6431,65,NULL,'MLCS17','ESSENCE n256 HOST',0.631,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24605,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE n256',NULL,24605,43.02,0.17,2460,6431,65,NULL,'SALT2','ESSENCE n256 HOST',0.631,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24606,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE n256',NULL,24606,43.09,0.11,2540,6431,65,NULL,'MLCS2k2','ESSENCE n256 HOST',0.631,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24607,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE n256',NULL,24607,43.12,0.21,2580,6431,65,NULL,'SALT','ESSENCE n256 HOST',0.631,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24608,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE n256',NULL,24608,43.18,0.1,2650,6431,65,NULL,'SALT','ESSENCE n256 HOST',0.631,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24609,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 18186','RN',24609,43.52,0.21,3370,6432,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 18186',0.5033,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24610,'Sosies','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24610,33.06,0.49,40.9,6433,NULL,NULL,NULL,'NGC 0935',NULL,'2002A&A...393...57T',2002,1,1.7,NULL,'G',0.000017,NULL,'12.5B',1.1,'Scd:','Pair member (points to parent)',NULL,NULL,NULL,1,37.0464583,19.59911,0.345,NULL,68101548229,1064086691,16626354,12.5),(24611,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24611,33.43,0.47,48.5,6433,NULL,NULL,'H','NGC 0935',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24612,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24612,33.45,0.46,49.1,6433,NULL,NULL,'J','NGC 0935',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24613,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24613,33.47,0.45,49.4,6433,NULL,NULL,'K','NGC 0935',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24614,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24614,33.79,0.4,57.4,6433,NULL,NULL,'mean','NGC 0935',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24615,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24615,35.35,0.49,118,6434,75,NULL,'IR','UGC 01928',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000057,NULL,'16.5',0.3,'S',NULL,NULL,NULL,NULL,1,37.0464583,43.85261,0.401,NULL,68544492921,1071007701,16734495,16.5),(24616,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24616,37.52,0.17,319,6435,70,NULL,NULL,'2MASX J02281371-0105203',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000073,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,37.0572083333,-1.08897,0.041,NULL,34923331285,545677051,8526203,18.5),(24617,'IRAS','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24617,34.01,0.8,63.3,6436,75,NULL,'CF, r','NGC 0931',NULL,'1997ApJS..109..333W',1997,1,3.9,NULL,'G',0.00002,NULL,'14.46',0.8,'Sbc            Sy1.5','Group member, radial-velocity confirmed',NULL,NULL,'Sy 1.0',1,37.0603333333,31.31167,0.301,NULL,68639616087,1072494001,16757718,14.46),(24618,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24618,32.62,0.43,33.4,6436,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0931',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24619,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24619,32.94,0.43,38.8,6436,75,NULL,'3.6 micron, color corrected','NGC 0931',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24620,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24620,33.16,0.38,42.9,6436,75,NULL,'CF, r, raw','NGC 0931',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24621,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24621,33.32,0.38,46.1,6436,75,NULL,'CF, r, inv','NGC 0931',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24622,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24622,33.35,0.2,46.8,6436,74.4,NULL,NULL,'NGC 0931',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24623,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24623,33.4,0.45,47.8,6436,NULL,NULL,'K','NGC 0931',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24624,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24624,33.42,0.47,48.3,6436,NULL,NULL,'H','NGC 0931',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24625,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24625,33.45,0.46,49.1,6436,NULL,NULL,'J','NGC 0931',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24626,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24626,33.51,0.48,50.4,6436,NULL,NULL,NULL,'NGC 0931',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24627,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24627,33.55,0.38,51.3,6436,75,NULL,'CF, r, cor','NGC 0931',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24628,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24628,33.71,0.43,55.2,6436,NULL,NULL,'Malmquist cor.','NGC 0931',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24629,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24629,34.19,0.4,68.7,6436,NULL,NULL,'mean','NGC 0931',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24630,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 13932','RN',24630,41.55,0.18,1730,6437,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13932',0.184459,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24631,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 13932','RN',24631,42.23,0.23,2360,6437,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13932',0.184459,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24632,'IRAS','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24632,34.2,0.8,69.2,6438,75,NULL,'W91PP, r','UGC 01939',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000045,NULL,'14.70',0.9,'SBa',NULL,NULL,NULL,NULL,1,37.073333,26.31242,0.253,NULL,68611110355,1072048599,16750759,14.7),(24633,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24633,35.13,0.38,106,6438,75,NULL,'W91PP, r, raw','UGC 01939',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24634,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24634,35.45,0.38,123,6438,75,NULL,'W91PP, r, inv','UGC 01939',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24635,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24635,35.51,0.38,126,6438,75,NULL,'W91PP, r, cor','UGC 01939',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24636,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24636,33.95,0.48,61.5,6439,70,NULL,NULL,'ESO 415- G 026',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000047,NULL,'14.81',0.6,'S0^0^: pec',NULL,NULL,NULL,NULL,1,37.0837917,-31.88103,NULL,NULL,38440170021,600627656,9384807,14.81),(24637,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 06352','RN',24637,41.83,0.84,2020,6440,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06352',0.151588,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24638,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24638,35.77,0.17,143,6441,70,NULL,NULL,'GIN 131',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.08725,23.02833,0.329,NULL,68105315486,1064145554,16627274,NULL),(24639,'IRAS','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24639,34.66,0.8,85.3,6442,75,NULL,'MAT, I','UGC 01938',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.94',0.3,'Sbc',NULL,NULL,NULL,NULL,1,37.0922083,23.21467,0.329,NULL,68105326800,1064145731,16627277,14.94),(24640,'IRAS','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24640,34.66,0.8,85.5,6442,75,NULL,'W91PP, r','UGC 01938',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24641,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24641,34.55,0.49,81.5,6442,75,NULL,'IR','UGC 01938',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24642,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24642,34.65,0.32,85,6442,85,NULL,'I, raw','UGC 01938',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24643,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24643,34.68,0.43,86.1,6442,75,NULL,'MAT, I, raw','UGC 01938',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24644,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24644,34.7,0.32,87.1,6442,85,NULL,'I, inv','UGC 01938',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24645,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24645,34.75,0.38,89,6442,75,NULL,'W91PP, r, raw','UGC 01938',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24646,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24646,34.84,0.66,92.9,6442,NULL,NULL,'Malmquist cor.','UGC 01938',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24647,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24647,34.91,0.43,95.8,6442,75,NULL,'MAT, I, inv','UGC 01938',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24648,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24648,34.91,0.38,96.1,6442,75,NULL,'W91PP, r, inv','UGC 01938',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24649,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24649,34.92,0.2,96.4,6442,74.4,NULL,NULL,'UGC 01938',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24650,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24650,34.95,0.63,97.9,6442,NULL,NULL,NULL,'UGC 01938',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24651,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24651,35.06,0.43,103,6442,75,NULL,'MAT, I, cor','UGC 01938',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24652,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24652,35.07,0.38,103,6442,75,NULL,'W91PP, r, cor','UGC 01938',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24653,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 1999fj','R',24653,42.57,NULL,1800,6443,65,NULL,'SALT','DEEP2 41100811',0.81,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.000044,NULL,'22.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,37.0985417,0.65358,0.037,NULL,66881305823,1045020403,16328443,22.3),(24654,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 1999fj',NULL,24654,42.98,0.47,2180,6443,74.2,NULL,'SALT 2','DEEP2 41100811',0.81,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24655,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 1999fj',NULL,24655,43.55,0.43,2830,6443,65,NULL,'BATM','DEEP2 41100811',0.81,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24656,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 1999fj',NULL,24656,43.59,0.37,2890,6443,65,NULL,'delta m15','DEEP2 41100811',0.81,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24657,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 1999fj',NULL,24657,43.67,0.36,2990,6443,65,NULL,'Final','DEEP2 41100811',0.81,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24658,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 1999fj',NULL,24658,43.76,0.33,3120,6443,65,NULL,NULL,'DEEP2 41100811',0.81,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24659,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 1999fj',NULL,24659,43.76,0.35,3120,6443,65,NULL,'dm15','DEEP2 41100811',0.81,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24660,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 1999fj',NULL,24660,43.8,0.42,3180,6443,70,NULL,'SALT','DEEP2 41100811',0.81,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24661,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 1999fj',NULL,24661,43.99,0.47,3480,6443,65,NULL,'SALT','DEEP2 41100811',0.81,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24662,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 1999fj',NULL,24662,44.03,0.22,3530,6443,65,NULL,'MLCS','DEEP2 41100811',0.81,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24663,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 19616','R',24663,39.45,0.18,666,6444,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ok','SDSS J022823.91+001109.5',0.165422,'2014arXiv1401.3317S',2014,1,0.2,NULL,'G',0.000069,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,37.099625,0.186,0.049,NULL,66880397716,1045006214,16328222,18.5),(24664,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 19616','R',24664,39.64,0.09,729,6444,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ok','SDSS J022823.91+001109.5',0.165422,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24665,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2007ok',NULL,24665,39.34,0.08,738,6444,70,NULL,'SALT 2','SDSS J022823.91+001109.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24666,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2007ok',NULL,24666,39.35,0.08,741,6444,70,NULL,'SALT 2, Malmquist cor.','SDSS J022823.91+001109.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24667,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24667,37.52,0.17,319,6445,70,NULL,NULL,'2MASX J02282458-0108596',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000088,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,37.102417,-1.14983,0.041,NULL,34923102523,545673476,8526148,17.8),(24668,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 02770','RN',24668,39.05,0.55,561,6446,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02770',0.152431,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24669,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 02770','RN',24669,41.32,1.28,1590,6446,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02770',0.152431,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24670,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24670,33.42,NULL,48.4,6447,NULL,NULL,'Dipole + Quadrupole','UGC 01946',NULL,'2010Ap&SS.325..163P',2010,1,1.9,NULL,'G',0.000009,NULL,'16.0',0.13,'Scd',NULL,NULL,NULL,NULL,1,37.1137083333,15.60708,0.509,NULL,68080708950,1063761077,16621266,16),(24671,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24671,33.42,NULL,48.4,6447,NULL,NULL,'Dipole','UGC 01946',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24672,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24672,33.42,NULL,48.4,6447,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01946',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24673,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24673,33.51,NULL,50.4,6447,NULL,NULL,NULL,'UGC 01946',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24674,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24674,33.79,0.2,57.3,6447,74.4,NULL,NULL,'UGC 01946',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24675,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24675,33.92,0.43,60.9,6447,NULL,NULL,NULL,'UGC 01946',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24676,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24676,34.04,0.41,64.3,6447,NULL,NULL,'Malmquist cor.','UGC 01946',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24677,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24677,30.81,0.69,14.5,6448,100,NULL,'mid-IR','NGC 0941',NULL,'2013ApJ...771...88L',2013,1,1.83,'Confused HIPASS source','G',0.000019,NULL,'13.4g',1.19,'SAB(rs)c','in a radial-velocity based grouping',NULL,NULL,NULL,1,37.1160417,-1.15153,0.041,NULL,34923102631,545673478,8526148,13.4),(24678,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24678,31.54,0.4,20.4,6448,75,NULL,'B','NGC 0941',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24679,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24679,31.71,0.4,22,6448,NULL,NULL,NULL,'NGC 0941',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24680,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24680,31.71,0.4,22,6448,73,NULL,'opt','NGC 0941',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24681,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24681,32.16,0.4,27.1,6448,NULL,NULL,'mean','NGC 0941',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24682,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24682,32.63,0.47,33.6,6448,NULL,NULL,'H','NGC 0941',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24683,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24683,32.63,0.46,33.6,6448,NULL,NULL,'J','NGC 0941',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24684,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003jl','R',24684,40.95,NULL,1080,6449,65,NULL,'SN d089, MLCS17','ESSENCE J022828.56-080844.7',0.429,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.119,-8.14575,0.069,NULL,34946791070,546043610,8531931,NULL),(24685,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003jl',NULL,24685,41.17,0.22,1200,6449,74.2,NULL,'SALT 2','ESSENCE J022828.56-080844.7',0.429,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24686,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003jl',NULL,24686,41.84,0.22,1630,6449,70,NULL,'SN d089, SALT','ESSENCE J022828.56-080844.7',0.429,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24687,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003jl',NULL,24687,41.94,0.18,1710,6449,65,NULL,'SN d089, SALT2','ESSENCE J022828.56-080844.7',0.429,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24688,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003jl',NULL,24688,41.97,0.18,1740,6449,65,NULL,'SN d089, MLCS17','ESSENCE J022828.56-080844.7',0.429,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24689,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003jl',NULL,24689,41.99,0.14,1750,6449,65,NULL,'SN d089, MLCS2k2','ESSENCE J022828.56-080844.7',0.429,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24690,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003jl',NULL,24690,42.01,0.2,1770,6449,65,NULL,'SN d089, SALT','ESSENCE J022828.56-080844.7',0.429,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24691,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003jl',NULL,24691,42.02,0.18,1780,6449,65,NULL,'SN d089, MLCS31','ESSENCE J022828.56-080844.7',0.429,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24692,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003jl',NULL,24692,42.04,0.21,1790,6449,65,NULL,'SN d089, SALT2','ESSENCE J022828.56-080844.7',0.429,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24693,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003jl',NULL,24693,42.05,0.17,1800,6449,65,NULL,'SN d089, MLCS2k2','ESSENCE J022828.56-080844.7',0.429,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24694,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003jl',NULL,24694,42.13,0.07,1860,6449,65,NULL,'SN d089, SALT','ESSENCE J022828.56-080844.7',0.429,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24695,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2007jt',NULL,24695,38.7,0.05,549,6450,70,NULL,'Hubble residual -0.10 for z0.14478','SDSS J022832.75-010234.1',NULL,'2011ApJ...740...92G',2011,1,0.18,NULL,'G',0.0001,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,37.1364583,-1.04283,0.041,NULL,34923197683,545674963,8526171,18.5),(24696,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 17497','R',24696,39.2,0.18,605,6450,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007jt','SDSS J022832.75-010234.1',0.14478,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24697,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 17497','R',24697,39.33,0.07,643,6450,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007jt','SDSS J022832.75-010234.1',0.14478,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24698,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24698,33.8,0.58,57.6,6451,NULL,NULL,NULL,'ESO 545- G 020',NULL,'2009ApJS..182..474S',2009,1,1.07,NULL,'G',0.000033,NULL,'15.88',0.29,'Sb','Pair member (points to parent)',NULL,NULL,NULL,1,37.1376666667,-18.98208,0.091,NULL,37968784709,593262261,9269722,15.88),(24699,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24699,33.84,0.2,58.6,6451,74.4,NULL,NULL,'ESO 545- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24700,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24700,33.91,0.55,60.6,6451,NULL,NULL,'Malmquist cor.','ESO 545- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24701,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24701,34.02,0.49,63.6,6451,75,NULL,'IR','ESO 545- G 020',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24702,'IRAS','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24702,34.02,0.8,63.7,6452,75,NULL,'MAT, I','NGC 0947',NULL,'1997ApJS..109..333W',1997,1,2,'The APMBGC position is 11 arcsec northwest of the nucleus.','G',0.000013,NULL,'13.18',1.1,'SA(r)c','Pair member (points to parent)',NULL,NULL,NULL,1,37.138,-19.04211,0.079,NULL,37968912009,593264250,9269753,13.18),(24703,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24703,33.43,0.69,48.4,6452,100,NULL,'mid-IR','NGC 0947',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24704,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24704,33.58,NULL,52,6452,NULL,NULL,'B','NGC 0947',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24705,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24705,33.6,0.32,52.5,6452,85,NULL,'I, raw','NGC 0947',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24706,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24706,33.62,0.2,53,6452,74.4,NULL,NULL,'NGC 0947',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24707,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24707,33.66,0.43,53.9,6452,75,NULL,'MAT, I, raw','NGC 0947',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24708,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24708,33.66,0.32,53.9,6452,85,NULL,'I, inv','NGC 0947',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24709,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24709,33.78,0.37,57.1,6452,NULL,NULL,NULL,'NGC 0947',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24710,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24710,33.81,NULL,57.8,6452,NULL,NULL,'I','NGC 0947',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24711,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24711,33.87,0.43,59.4,6452,75,NULL,'MAT, I, cor','NGC 0947',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24712,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24712,33.91,0.43,60.5,6452,75,NULL,'MAT, I, inv','NGC 0947',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24713,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24713,33.92,0.35,60.8,6452,NULL,NULL,'Malmquist cor.','NGC 0947',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24714,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24714,33.98,0.46,62.5,6452,NULL,NULL,'J','NGC 0947',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24715,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24715,33.99,0.47,62.9,6452,NULL,NULL,'H','NGC 0947',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24716,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24716,34.03,0.45,64,6452,NULL,NULL,'K','NGC 0947',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24717,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24717,34.09,0.4,65.7,6452,NULL,NULL,'mean','NGC 0947',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24718,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24718,36.34,0.52,185,6453,70,NULL,NULL,'2MASX J02283718-0249376',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'16.63',0.24,NULL,NULL,NULL,NULL,NULL,1,37.154833,-2.82706,0.033,NULL,34923909549,545686086,8526345,16.63),(24719,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24719,33.76,0.53,56.4,6454,70,NULL,NULL,'NGC 0945',NULL,'2014MNRAS.445.2677S',2014,1,2.4,NULL,'G',0.000023,NULL,'12.5B',2,'SB(rs)c','Pair member (points to parent)',NULL,NULL,NULL,1,37.155333,-10.53897,0.029,NULL,34933886110,545841970,8528780,12.5),(24720,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24720,36.61,0.72,210,6455,70,NULL,NULL,'2MASX J02283731-0244416',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'17.32',0.3,NULL,NULL,NULL,NULL,NULL,1,37.1554583333,-2.74481,0.033,NULL,34923920130,545686252,8526347,17.32),(24721,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24721,37.5,0.53,317,6456,70,NULL,NULL,'2MASX J02283738-0239186',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.58',0.5,NULL,NULL,NULL,NULL,NULL,1,37.1559583,-2.65511,0.041,NULL,34924086939,545688858,8526388,16.58),(24722,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 07194','RN',24722,41.73,0.24,1620,6457,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07194',0.364341,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24723,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 07194','RN',24723,41.8,0.33,1680,6457,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07194',0.364341,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24724,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 07194','N',24724,41.72,0.2,2210,6457,70,NULL,'SALT 2','SDSS-II SN 07194',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24725,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 07194','N',24725,41.77,0.2,2260,6457,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 07194',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24726,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24726,35.55,0.25,129,6458,74.4,NULL,NULL,'V Zw 247',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000053,NULL,'14.68',NULL,'S0',NULL,NULL,NULL,NULL,1,37.166,23.01203,0.281,NULL,68105488024,1064148250,16627316,14.68),(24727,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24727,35.77,0.17,143,6458,70,NULL,NULL,'V Zw 247',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24728,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 01208','RN',24728,38.81,0.24,486,6459,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 01208',0.186312,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24729,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 01208','RN',24729,39.57,0.18,690,6459,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 01208',0.186312,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24730,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 01209','RN',24730,40.5,0.24,1010,6460,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 01209',0.242036,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24731,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 01209','RN',24731,40.54,0.17,1030,6460,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 01209',0.242036,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24732,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 19169','RN',24732,41.79,0.26,1880,6461,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19169',0.211647,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24733,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 19169','RN',24733,42.82,0.33,3020,6461,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19169',0.211647,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24734,'L(H{beta})-{sigma}','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24734,42.94,NULL,1371,6462,74.3,NULL,NULL,'DEEP2 41040416',0.681404,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',0.000048,NULL,'23.7R',NULL,'AGN',NULL,NULL,NULL,NULL,1,37.1877083,0.69244,0.037,NULL,66881089862,1045017029,16328391,23.7),(24735,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24735,34.18,0.4,68.6,6463,NULL,NULL,'mean','IC 1799',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000033,NULL,'14.6',0.4,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,37.1912917,45.97064,0.741,NULL,67818471617,1059663619,16557244,14.6),(24736,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24736,34.21,0.47,69.5,6463,NULL,NULL,'H','IC 1799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24737,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24737,34.21,0.45,69.5,6463,NULL,NULL,'K','IC 1799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24738,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24738,34.22,0.46,70,6463,NULL,NULL,'J','IC 1799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24739,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 21395','RN',24739,41.46,0.23,1570,6464,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 21395',0.245747,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24740,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 21395','RN',24740,41.58,0.29,1660,6464,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 21395',0.245747,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24741,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003jm','R',24741,42.29,NULL,1890,6465,65,NULL,'SN d084, SALT2','SDSS J022850.94-090957.9',0.522,'2010arXiv1006.2112L',2010,1,0.07,NULL,'G',0.001,NULL,'23.3g',0.03,NULL,NULL,NULL,NULL,NULL,1,37.2122917,-9.16608,0.077,NULL,34931511435,545804866,8528201,23.3),(24742,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003jm',NULL,24742,42.36,0.32,1950,6465,74.2,NULL,'SALT 2','SDSS J022850.94-090957.9',0.522,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24743,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003jm',NULL,24743,42.68,0.3,2260,6465,65,NULL,'SN d084, SALT2','SDSS J022850.94-090957.9',0.522,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24744,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003jm',NULL,24744,42.77,0.32,2350,6465,65,NULL,'SN d084, MLCS17','SDSS J022850.94-090957.9',0.522,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24745,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003jm',NULL,24745,42.88,0.26,2480,6465,65,NULL,'SN d084, MLCS2k2','SDSS J022850.94-090957.9',0.522,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24746,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003jm',NULL,24746,42.95,0.27,2550,6465,65,NULL,'SN d084, MLCS2k2','SDSS J022850.94-090957.9',0.522,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24747,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003jm',NULL,24747,42.94,0.29,2550,6465,65,NULL,'SN d084, MLCS31','SDSS J022850.94-090957.9',0.522,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24748,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003jm',NULL,24748,43.09,0.39,2730,6465,70,NULL,'SN d084, SALT','SDSS J022850.94-090957.9',0.522,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24749,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003jm',NULL,24749,43.21,0.31,2890,6465,65,NULL,'SN d084, SALT2','SDSS J022850.94-090957.9',0.522,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24750,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003jm',NULL,24750,43.24,0.42,2920,6465,65,NULL,'SN d084, SALT','SDSS J022850.94-090957.9',0.522,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24751,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003jm',NULL,24751,43.39,0.19,3120,6465,65,NULL,'SN d084, SALT','SDSS J022850.94-090957.9',0.522,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24752,'IRAS','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24752,34.19,0.8,68.9,6466,75,NULL,'MAT, I','NGC 0954',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'13.5',0.8,'SA:(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,37.215125,-41.40267,NULL,NULL,38490190864,601409232,9397019,13.5),(24753,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24753,33.57,0.32,51.7,6466,85,NULL,'I, raw','NGC 0954',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24754,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24754,33.62,0.32,52.9,6466,85,NULL,'I, inv','NGC 0954',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24755,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24755,33.63,0.43,53.2,6466,75,NULL,'MAT, I, raw','NGC 0954',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24756,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24756,33.72,NULL,55.5,6466,NULL,NULL,'B','NGC 0954',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24757,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24757,33.81,NULL,57.8,6466,NULL,NULL,'I','NGC 0954',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24758,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24758,33.85,0.43,58.9,6466,75,NULL,'MAT, I, inv','NGC 0954',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24759,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24759,34.01,0.47,63.4,6466,NULL,NULL,'H','NGC 0954',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24760,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24760,34.01,0.46,63.4,6466,NULL,NULL,'J','NGC 0954',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24761,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24761,34.04,0.43,64.1,6466,75,NULL,'MAT, I, cor','NGC 0954',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24762,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24762,34.06,0.27,65,6466,NULL,NULL,NULL,'NGC 0954',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24763,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24763,34.07,0.45,65.1,6466,NULL,NULL,'K','NGC 0954',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24764,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24764,34.1,0.2,66.1,6466,74.4,NULL,NULL,'NGC 0954',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24765,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24765,34.21,0.26,69.5,6466,NULL,NULL,'Malmquist cor.','NGC 0954',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24766,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24766,34.29,0.4,72,6466,NULL,NULL,'mean','NGC 0954',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24767,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE m193 HOST','R',24767,40.12,NULL,795,6467,65,NULL,'SALT2','ESSENCE m193 HOST',0.33,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.2175,-7.70272,0.109,NULL,34946609148,546040767,8531886,NULL),(24768,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE m193 HOST',NULL,24768,40.28,0.23,855,6467,74.2,NULL,'SALT 2','ESSENCE m193 HOST',0.33,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24769,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE m193 HOST',NULL,24769,41.03,0.22,1210,6467,65,NULL,'SALT2','ESSENCE m193 HOST',0.33,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24770,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE m193 HOST',NULL,24770,41.09,0.21,1240,6467,70,NULL,'SALT','ESSENCE m193 HOST',0.33,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24771,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE m193 HOST',NULL,24771,41.16,0.23,1280,6467,65,NULL,'SALT2','ESSENCE m193 HOST',0.33,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24772,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE m193 HOST',NULL,24772,41.2,0.25,1310,6467,65,NULL,'MLCS17','ESSENCE m193 HOST',0.33,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24773,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE m193 HOST',NULL,24773,41.26,0.23,1340,6467,65,NULL,'MLCS31','ESSENCE m193 HOST',0.33,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24774,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE m193 HOST',NULL,24774,41.26,0.22,1350,6467,65,NULL,'MLCS2k2','ESSENCE m193 HOST',0.33,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24775,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE m193 HOST',NULL,24775,41.28,0.19,1360,6467,65,NULL,'SALT','ESSENCE m193 HOST',0.33,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24776,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE m193 HOST',NULL,24776,41.29,0.21,1360,6467,65,NULL,'MLCS2k2','ESSENCE m193 HOST',0.33,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24777,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE m193 HOST',NULL,24777,41.31,0.08,1380,6467,65,NULL,'SALT','ESSENCE m193 HOST',0.33,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24778,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 1999fk','R',24778,42.98,NULL,1920,6468,65,NULL,'SALT','H-ZSNS J022853.88+011624.2',1.05,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.2245,1.27339,0.017,NULL,66881563101,1045024423,16328506,NULL),(24779,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 1999fk',NULL,24779,43.44,0.24,2380,6468,74.2,NULL,'SALT 2','H-ZSNS J022853.88+011624.2',1.05,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24780,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 1999fk',NULL,24780,44.08,0.21,3190,6468,70,NULL,'SALT','H-ZSNS J022853.88+011624.2',1.05,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24781,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 1999fk',NULL,24781,44.17,0.36,3330,6468,65,NULL,'BATM','H-ZSNS J022853.88+011624.2',1.05,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24782,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 1999fk',NULL,24782,44.23,0.3,3420,6468,65,NULL,'MLCS','H-ZSNS J022853.88+011624.2',1.05,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24783,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 1999fk',NULL,24783,44.23,0.37,3420,6468,65,NULL,'Final','H-ZSNS J022853.88+011624.2',1.05,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24784,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 1999fk',NULL,24784,44.25,0.23,3450,6468,65,NULL,NULL,'H-ZSNS J022853.88+011624.2',1.05,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24785,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 1999fk',NULL,24785,44.25,0.24,3450,6468,65,NULL,'SALT','H-ZSNS J022853.88+011624.2',1.05,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24786,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 1999fk',NULL,24786,44.26,0.39,3470,6468,65,NULL,'dm15','H-ZSNS J022853.88+011624.2',1.05,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24787,'IRAS','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24787,34.18,0.8,68.7,6469,75,NULL,'W91PP, r','UGC 01955',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000013,NULL,'15.07',0.6,'S?',NULL,NULL,NULL,NULL,1,37.2262083,25.34431,0.277,NULL,68610861032,1072044703,16750698,15.07),(24788,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24788,33.49,0.2,49.9,6469,74.4,NULL,NULL,'UGC 01955',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24789,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24789,33.58,0.38,52,6469,75,NULL,'W91PP, r, inv','UGC 01955',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24790,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24790,33.61,0.38,52.7,6469,75,NULL,'W91PP, r, raw','UGC 01955',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24791,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24791,33.76,0.38,56.6,6469,NULL,NULL,NULL,'UGC 01955',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24792,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24792,33.88,0.38,59.8,6469,75,NULL,'W91PP, r, cor','UGC 01955',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24793,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24793,34.05,0.33,64.5,6469,NULL,NULL,'Malmquist cor.','UGC 01955',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24794,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 16277',NULL,24794,40.13,0.47,1060,6470,70,NULL,'SN photometric redshift distance, z photo =0.288 +/- 0.086','SDSS-II SN 16277',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.3g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,37.235625,0.44817,0.033,NULL,66881290199,1045020159,16328439,21.3),(24795,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 16277','R',24795,41.57,0.34,1480,6470,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16277',0.396301,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24796,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 16277','R',24796,41.62,0.33,1510,6470,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16277',0.396301,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24797,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 16277',NULL,24797,41.48,0.23,1980,6470,70,NULL,'SALT 2','SDSS-II SN 16277',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24798,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 16277',NULL,24798,41.54,0.23,2030,6470,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16277',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24799,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 07195','RN',24799,41.67,0.3,1580,6471,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07195',0.362359,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24800,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 07195','RN',24800,41.7,0.21,1610,6471,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07195',0.362359,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24801,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 07195','N',24801,41.48,0.17,1980,6471,70,NULL,'SALT 2','SDSS-II SN 07195',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24802,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 07195','N',24802,41.53,0.17,2020,6471,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 07195',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24803,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24803,31.49,0.2,19.9,6472,74.4,NULL,NULL,'UGC 01958',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000033,NULL,'15.49',0.3,'Scd:',NULL,NULL,NULL,NULL,1,37.245125,28.14553,0.317,NULL,68645217972,1072581530,16759086,15.49),(24804,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24804,31.63,0.54,21.2,6472,NULL,NULL,NULL,'UGC 01958',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24805,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24805,31.89,0.48,23.9,6472,NULL,NULL,'Malmquist cor.','UGC 01958',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24806,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24806,31.96,0.4,24.7,6472,NULL,NULL,NULL,'UGC 01958',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24807,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24807,31.96,0.39,24.7,6472,73,NULL,'opt','UGC 01958',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24808,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2001jh','R',24808,42.58,NULL,1740,6473,65,NULL,'SALT','H-ZSNS J022900.29+002044.2',0.885,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.2512083,0.34561,0.029,NULL,66881223129,1045019111,16328423,NULL),(24809,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2001jh',NULL,24809,43.4,0.45,2540,6473,72,NULL,'BATM','H-ZSNS J022900.29+002044.2',0.885,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24810,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2001jh',NULL,24810,43.48,0.29,2630,6473,74.2,NULL,'SALT 2','H-ZSNS J022900.29+002044.2',0.885,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24811,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2001jh',NULL,24811,43.59,0.23,2770,6473,72,NULL,'MLCS','H-ZSNS J022900.29+002044.2',0.885,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24812,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2001jh',NULL,24812,44.18,0.47,3640,6473,70,NULL,'SALT','H-ZSNS J022900.29+002044.2',0.885,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24813,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2001jh',NULL,24813,44.23,0.19,3720,6473,65,NULL,NULL,'H-ZSNS J022900.29+002044.2',0.885,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24814,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2001jh',NULL,24814,44.43,0.47,4070,6473,65,NULL,'SALT','H-ZSNS J022900.29+002044.2',0.885,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24815,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2002P',NULL,24815,42.97,0.23,2280,6474,72,NULL,'dm15','H-ZSNS J022905.71+004720.1',0.719,'2004ApJ...602..571B',2004,1,NULL,NULL,'G',0.001,NULL,'22.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,37.273625,0.78908,0.037,NULL,66880941829,1045014716,16328354,22.7),(24816,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2002P',NULL,24816,42.99,0.33,2310,6474,72,NULL,'BATM','H-ZSNS J022905.71+004720.1',0.719,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24817,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2002P',NULL,24817,43.06,0.49,2380,6474,72,NULL,'MLCS','H-ZSNS J022905.71+004720.1',0.719,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24818,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2002P',NULL,24818,43.22,0.26,2560,6474,65,NULL,NULL,'H-ZSNS J022905.71+004720.1',0.719,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24819,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24819,36.09,0.52,165,6475,70,NULL,NULL,'2MASX J02290683-0533596',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.14',NULL,NULL,NULL,NULL,NULL,NULL,1,37.278333,-5.56664,0.021,NULL,34949033847,546078653,8532478,16.14),(24820,'IRAS','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24820,34,0.8,63,6476,75,NULL,'MAT, I','ESO 415- G 028',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000032,NULL,'15.29',0.7,'SAB(s)bc',NULL,NULL,NULL,NULL,1,37.2797083,-30.99703,NULL,NULL,38440626131,600634783,9384918,15.29),(24821,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24821,33.57,0.32,51.7,6476,85,NULL,'I, inv','ESO 415- G 028',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24822,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24822,33.58,0.32,51.9,6476,85,NULL,'I, raw','ESO 415- G 028',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24823,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24823,34.02,0.43,63.7,6476,75,NULL,'MAT, I, raw','ESO 415- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24824,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24824,34.06,0.43,64.8,6476,75,NULL,'MAT, I, inv','ESO 415- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24825,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24825,34.23,0.43,70,6476,75,NULL,'MAT, I, cor','ESO 415- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24826,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24826,34.55,0.47,81.4,6476,NULL,NULL,NULL,'ESO 415- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24827,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24827,34.59,0.2,82.8,6476,74.4,NULL,NULL,'ESO 415- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24828,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24828,34.59,0.46,82.9,6476,NULL,NULL,'Malmquist cor.','ESO 415- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24829,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24829,36.19,0.58,173,6477,70,NULL,NULL,'2MASX J02290752-1845094',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000103,NULL,'17.07',0.28,NULL,NULL,NULL,NULL,NULL,1,37.2812916667,-18.75275,0.081,NULL,37968538045,593258406,9269662,17.07),(24830,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24830,35.54,0.5,129,6478,70,NULL,NULL,'2MASX J02290908-5444128',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.96',0.24,NULL,NULL,NULL,NULL,NULL,1,37.287917,-54.73694,0.009,NULL,36110945821,564233528,8816148,16.96),(24831,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24831,34.14,0.5,67.2,6479,70,NULL,NULL,'NGC 0943',NULL,'2014MNRAS.445.2677S',2014,1,0.4,'MCG, VV, and RC2 switch NGC 0942 and NGC 0943. NGC 0943 is northern of two.','G',0.00009,NULL,'14.00',0.25,'S0+ pec:','Pair member (points to parent)',NULL,NULL,NULL,1,37.290333,-10.82806,0.033,NULL,37866707467,591667304,9244801,14),(24832,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24832,38.38,0.46,474,6480,70,NULL,NULL,'2MASX J02291246-0930297',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000086,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,37.302,-9.50842,0.065,NULL,34931679981,545807499,8528242,17.5),(24833,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24833,37.34,0.46,293,6481,70,NULL,NULL,'2MASX J02291389-0723597',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000068,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,37.3078333333,-7.39986,0.101,NULL,34943106768,545986043,8531031,18.1),(24834,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24834,35.6,0.23,132,6482,74.4,NULL,NULL,'GIN 130',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000067,NULL,'14.40',0.3,'SB0',NULL,NULL,NULL,NULL,1,37.308083,22.96633,0.281,NULL,68087809614,1063872025,16623000,14.4),(24835,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24835,35.77,0.17,143,6482,70,NULL,NULL,'GIN 130',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24836,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24836,35.59,0.23,131,6483,74.4,NULL,NULL,'IC 1802',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000043,NULL,'14.55',1.1,'S0?',NULL,NULL,NULL,NULL,1,37.30825,23.08269,0.281,NULL,68087942551,1063874102,16623032,14.55),(24837,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24837,35.77,0.17,143,6483,70,NULL,NULL,'IC 1802',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24838,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24838,35.77,0.17,143,6484,70,NULL,NULL,'GIN 134',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',NULL,NULL,'15.63',NULL,'S',NULL,NULL,NULL,NULL,1,37.309583,22.83944,0.281,NULL,68105431506,1064147367,16627302,15.63),(24839,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 04623','RN',24839,41.19,0.09,1300,6485,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 04623',0.332457,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24840,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 04623','RN',24840,41.33,0.19,1380,6485,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04623',0.332457,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24841,'GRB','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24841,42.65,NULL,3390,6486,71,NULL,NULL,'GRB 081230',NULL,'2011A&A...526A.153K',2011,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,37.3312916667,-25.14744,0,NULL,38424655580,600385243,9381019,NULL),(24842,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003jn',NULL,24842,39.84,0.2,715,6487,74.2,NULL,'SALT 2','ESSENCE J022921.21-090215.6',0.3,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.338375,-9.03767,0.049,NULL,34945391100,546021735,8531589,NULL),(24843,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003jn',NULL,24843,40.6,0.2,1010,6487,70,NULL,'SN d083, SALT','ESSENCE J022921.21-090215.6',0.3,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24844,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003jn',NULL,24844,40.64,0.15,1030,6487,65,NULL,'SN d083, MLCS17','ESSENCE J022921.21-090215.6',0.3,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24845,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003jn',NULL,24845,40.68,0.15,1050,6487,65,NULL,'SN d083, SALT2','ESSENCE J022921.21-090215.6',0.3,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24846,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003jn',NULL,24846,40.69,0.13,1060,6487,65,NULL,'SN d083, MLCS31','ESSENCE J022921.21-090215.6',0.3,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24847,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003jn',NULL,24847,40.71,0.19,1060,6487,65,NULL,'SN d083, SALT2','ESSENCE J022921.21-090215.6',0.3,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24848,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003jn',NULL,24848,40.71,0.1,1070,6487,65,NULL,'SN d083, MLCS2k2','ESSENCE J022921.21-090215.6',0.3,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24849,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003jn',NULL,24849,40.71,0.1,1070,6487,65,NULL,'SN d083, MLCS2k2','ESSENCE J022921.21-090215.6',0.3,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24850,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SN 2003jn',NULL,24850,40.91,0.03,1170,6487,65,NULL,'SN d083, SALT','ESSENCE J022921.21-090215.6',0.3,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24851,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE f308','R',24851,41.75,NULL,1610,6488,65,NULL,'SALT','ESSENCE f308 HOST',0.394,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.3432917,-8.62733,0.065,NULL,34946003657,546031307,8531739,NULL),(24852,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE f308',NULL,24852,41.84,0.37,1670,6488,74.2,NULL,'SALT 2','ESSENCE f308 HOST',0.394,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24853,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE f308',NULL,24853,42.07,0.31,1860,6488,70,NULL,'SALT','ESSENCE f308 HOST',0.394,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24854,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE f308',NULL,24854,42.21,0.31,1980,6488,65,NULL,'SALT','ESSENCE f308 HOST',0.394,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24855,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE f308',NULL,24855,42.39,0.08,2160,6488,65,NULL,'SALT','ESSENCE f308 HOST',0.394,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24856,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','ESSENCE f308',NULL,24856,42.43,0.26,2200,6488,65,NULL,'MLCS2k2','ESSENCE f308 HOST',0.394,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24857,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24857,34.12,0.49,66.7,6489,75,NULL,'IR','UGC 01957',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000037,NULL,'15.1',0.2,'Scd:',NULL,NULL,NULL,NULL,1,37.3449166667,47.49053,0.973,NULL,67834618441,1059915913,16561186,15.1),(24858,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24858,34.14,0.2,67.3,6489,74.4,NULL,NULL,'UGC 01957',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24859,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24859,34.66,0.69,85.5,6490,100,NULL,'mid-IR','UGC 01966',NULL,'2013ApJ...771...88L',2013,1,1.4,NULL,'G',0.00009,NULL,'14.52',0.8,'(R\')SABab',NULL,NULL,NULL,NULL,1,37.3485417,10.17711,0.265,NULL,66859800990,1044684390,16323193,14.52),(24860,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24860,33.44,0.42,48.7,6491,NULL,NULL,NULL,'UGC 01965',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'15.32',0.3,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,37.3592917,20.21725,0.361,NULL,68101903298,1064092239,16626441,15.32),(24861,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24861,33.5,0.2,50.1,6491,74.4,NULL,NULL,'UGC 01965',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24862,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,'R',24862,33.53,0.49,50.8,6491,75,NULL,'IR','UGC 01965',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24863,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24863,33.71,0.37,55.1,6491,NULL,NULL,'Malmquist cor.','UGC 01965',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24864,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24864,33.79,0.4,57.3,6491,NULL,NULL,'mean','UGC 01965',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24865,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24865,33.81,0.47,57.7,6491,NULL,NULL,'H','UGC 01965',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24866,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24866,33.91,0.45,60.4,6491,NULL,NULL,'K','UGC 01965',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24867,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24867,36.21,0.74,174,6492,70,NULL,NULL,'2MASX J02292907-5832452',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.62',0.42,NULL,NULL,NULL,NULL,NULL,1,37.371333,-58.54597,0.045,NULL,36113826019,564278531,8816852,16.62),(24868,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 04651','R',24868,39.43,0.2,667,6493,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 04651',0.151605,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.3755417,-0.74725,0.029,NULL,34923613657,545681463,8526272,NULL),(24869,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 04651','R',24869,39.57,0.24,712,6493,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 04651',0.151605,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24870,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24870,34.37,0.47,75,6494,70,NULL,NULL,'IC 1812',NULL,'2014MNRAS.445.2677S',2014,1,2,NULL,'G',0.000083,NULL,'13.22',1.6,'SA0^-','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,37.3824166667,-42.81136,NULL,NULL,38502512843,601601763,9400027,13.22),(24871,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24871,33.99,0.45,62.9,6494,NULL,NULL,'K','IC 1812',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24872,'Tully-Fisher','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24872,34.24,0.4,70.3,6494,NULL,NULL,'mean','IC 1812',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24873,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:56','1','PTF10zbk','N',24873,37.82,0.11,344,6495,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10zbk',0.0642,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24874,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24874,36.53,0.57,202,6496,70,NULL,NULL,'2MASX J02293450-5759183',NULL,'2014MNRAS.445.2677S',2014,1,0.92,NULL,'G',0.00015,NULL,'16.12',0.42,'S0',NULL,NULL,NULL,NULL,1,37.3936666667,-57.9885,0.037,NULL,36113614842,564275231,8816800,16.12),(24875,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24875,35.58,0.23,131,6497,74.4,NULL,NULL,'IC 1806',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000067,NULL,'14.16',0.5,'E',NULL,NULL,NULL,NULL,1,37.395625,22.94322,0.309,NULL,68087823619,1063872244,16623003,14.16),(24876,'FP','2016-12-15 15:13:53','2016-12-16 11:18:56','1',NULL,NULL,24876,35.77,0.17,143,6497,70,NULL,NULL,'IC 1806',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24877,'SNIa SDSS','2016-12-15 15:13:53','2016-12-16 11:18:56','1','SDSS-II SN 11539','RN',24877,43.44,0.31,3070,6498,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 11539',0.583404,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24878,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:57','1','SDSS-II SN 06300',NULL,24878,40.25,0.19,1120,6499,70,NULL,NULL,'SDSS-II SN 06300',NULL,'2013MNRAS.434.1443X',2013,1,0.05,NULL,'G',NULL,'PHOT','22.1g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,37.4115416667,-0.55003,0.033,NULL,34923533085,545680204,8526253,22.1),(24879,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:57','1','SDSS-II SN 06300','R',24879,41.14,0.31,1240,6499,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06300',0.35812,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24880,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:57','1','SDSS-II SN 06300','R',24880,41.74,0.28,1640,6499,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06300',0.35812,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24881,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:57','1','SDSS-II SN 06300',NULL,24881,41.32,0.14,1840,6499,70,NULL,'SN photometric redshift distance, z photo =0.583 +/- 0.056','SDSS-II SN 06300',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24882,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:57','1','SN 2004hj','R',24882,40.18,NULL,774,6500,65,NULL,'SN h364, MLCS17','ESSENCE J022941.93-084349.4',0.4,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.4247083,-8.73039,0.061,NULL,34945520959,546023764,8531621,NULL),(24883,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:57','1','SN 2004hj',NULL,24883,40.46,0.21,883,6500,74.2,NULL,'SALT 2','ESSENCE J022941.93-084349.4',0.4,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24884,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:57','1','SN 2004hj',NULL,24884,41.07,0.2,1170,6500,70,NULL,'SN h364, SALT','ESSENCE J022941.93-084349.4',0.4,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24885,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:57','1','SN 2004hj',NULL,24885,41.2,0.17,1240,6500,65,NULL,'SN h364, SALT2','ESSENCE J022941.93-084349.4',0.4,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24886,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:57','1','SN 2004hj',NULL,24886,41.22,0.2,1250,6500,65,NULL,'SN h364, MLCS17','ESSENCE J022941.93-084349.4',0.4,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24887,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:57','1','SN 2004hj',NULL,24887,41.26,0.06,1270,6500,65,NULL,'SN h364, SALT','ESSENCE J022941.93-084349.4',0.4,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24888,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:57','1','SN 2004hj',NULL,24888,41.26,0.18,1270,6500,65,NULL,'SN h364, SALT','ESSENCE J022941.93-084349.4',0.4,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24889,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:57','1','SN 2004hj',NULL,24889,41.29,0.14,1300,6500,65,NULL,'SN h364, MLCS2k2','ESSENCE J022941.93-084349.4',0.4,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24890,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:57','1','SN 2004hj',NULL,24890,41.3,0.16,1300,6500,65,NULL,'SN h364, MLCS31','ESSENCE J022941.93-084349.4',0.4,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24891,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:57','1','SN 2004hj',NULL,24891,41.32,0.14,1310,6500,65,NULL,'SN h364, MLCS2k2','ESSENCE J022941.93-084349.4',0.4,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24892,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:57','1','SN 2004hj',NULL,24892,41.35,0.21,1330,6500,65,NULL,'SN h364, SALT2','ESSENCE J022941.93-084349.4',0.4,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24893,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:57','1','SDSS-II SN 03527',NULL,24893,40.19,0.21,1090,6501,70,NULL,'SN photometric redshift distance, z photo =0.298 +/- 0.036','SDSS-II SN 03527',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','21.9g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,37.4265417,-0.16075,0.033,NULL,34923465365,545679146,8526236,21.9),(24894,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:57','1','SDSS-II SN 03527','R',24894,41.6,0.37,1470,6501,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03527',0.419931,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24895,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:57','1','SDSS-II SN 03527','R',24895,42.29,0.45,2020,6501,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03527',0.419931,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24896,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:57','1','SDSS-II SN 08662','RN',24896,42.05,0.4,1650,6502,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 08662',0.55816,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24897,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:57','1','SDSS-II SN 08662','N',24897,41.93,0.3,2430,6502,70,NULL,'SALT 2','SDSS-II SN 08662',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24898,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:57','1','SDSS-II SN 08662','N',24898,42.15,0.3,2690,6502,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 08662',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24899,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:57','1','SN 2004he','R',24899,41.91,NULL,1510,6503,65,NULL,'SN h323, SALT','ESSENCE J022948.79-082045.9',0.598,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.4532917,-8.34608,0.057,NULL,34946820921,546044076,8531938,NULL),(24900,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:57','1','SN 2004he',NULL,24900,41.93,0.28,1520,6503,74.2,NULL,'SALT 2','ESSENCE J022948.79-082045.9',0.598,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24901,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:57','1','SN 2004he',NULL,24901,42.64,0.25,2110,6503,65,NULL,'SN h323, SALT2','ESSENCE J022948.79-082045.9',0.598,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24902,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:57','1','SN 2004he',NULL,24902,42.64,0.27,2110,6503,70,NULL,'SN h323, SALT','ESSENCE J022948.79-082045.9',0.598,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24903,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:57','1','SN 2004he',NULL,24903,42.79,0.24,2270,6503,65,NULL,'SN h323, SALT','ESSENCE J022948.79-082045.9',0.598,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24904,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:57','1','SN 2004he',NULL,24904,42.83,0.24,2300,6503,65,NULL,'SN h323, MLCS2k2','ESSENCE J022948.79-082045.9',0.598,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24905,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:57','1','SN 2004he',NULL,24905,42.82,0.26,2300,6503,65,NULL,'SN h323, SALT2','ESSENCE J022948.79-082045.9',0.598,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24906,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:57','1','SN 2004he',NULL,24906,42.92,0.09,2400,6503,65,NULL,'SN h323, SALT','ESSENCE J022948.79-082045.9',0.598,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24907,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:57','1','SN 2004he',NULL,24907,42.92,0.25,2400,6503,65,NULL,'SN h323, MLCS17','ESSENCE J022948.79-082045.9',0.598,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24908,'SNIa','2016-12-15 15:13:53','2016-12-16 11:18:57','1','SN 2004he',NULL,24908,42.99,0.22,2480,6503,65,NULL,'SN h323, MLCS31','ESSENCE J022948.79-082045.9',0.598,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24909,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2004he',NULL,24909,43.01,0.2,2500,6503,65,NULL,'SN h323, MLCS2k2','ESSENCE J022948.79-082045.9',0.598,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24910,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24910,35.23,0.23,111,6504,74.4,NULL,NULL,'IC 1803',NULL,'2013AJ....146...86T',2013,1,0.3,'The IC identification is not certain.','G',0.00005,NULL,'14.17',0.3,'E',NULL,NULL,NULL,NULL,1,37.4580833333,23.10858,0.281,NULL,68087945182,1063874143,16623033,14.17),(24911,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24911,35.72,0.12,139,6504,75,NULL,'[CBW93] J08 = J8 cluster, 13 galaxies','IC 1803',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24912,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24912,35.72,0.12,139,6504,75,NULL,'[CBW93] J08 = J8 cluster, 13 galaxies','IC 1803',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24913,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24913,35.77,0.17,143,6504,70,NULL,NULL,'IC 1803',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24914,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 15111','RN',24914,43.31,0.22,2740,6505,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 15111',0.677974,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24915,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 01023','RN',24915,41.73,0.13,1780,6506,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01023',0.247078,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24916,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 01023','RN',24916,41.98,0.2,2000,6506,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01023',0.247078,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24917,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003js','R',24917,40.35,NULL,862,6507,65,NULL,'SN d093, SALT2','ESSENCE J022952.15-083228.1',0.363,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.4672917,-8.54114,0.065,NULL,34945967629,546030744,8531730,NULL),(24918,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003js',NULL,24918,40.84,0.21,1080,6507,74.2,NULL,'SALT 2','ESSENCE J022952.15-083228.1',0.363,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24919,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003js',NULL,24919,41.4,0.21,1400,6507,70,NULL,'SN d093, SALT','ESSENCE J022952.15-083228.1',0.363,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24920,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003js',NULL,24920,41.59,0.18,1520,6507,65,NULL,'SN d093, SALT','ESSENCE J022952.15-083228.1',0.363,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24921,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003js',NULL,24921,41.64,0.05,1560,6507,65,NULL,'SN d093, SALT','ESSENCE J022952.15-083228.1',0.363,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24922,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003js',NULL,24922,41.66,0.18,1580,6507,65,NULL,'SN d093, SALT2','ESSENCE J022952.15-083228.1',0.363,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24923,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003js',NULL,24923,41.71,0.13,1610,6507,65,NULL,'SN d093, MLCS31','ESSENCE J022952.15-083228.1',0.363,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24924,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003js',NULL,24924,41.71,0.21,1610,6507,65,NULL,'SN d093, SALT2','ESSENCE J022952.15-083228.1',0.363,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24925,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003js',NULL,24925,41.73,0.1,1620,6507,65,NULL,'SN d093, MLCS2k2','ESSENCE J022952.15-083228.1',0.363,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24926,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003js',NULL,24926,41.76,0.09,1650,6507,65,NULL,'SN d093, MLCS2k2','ESSENCE J022952.15-083228.1',0.363,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24927,'IRAS','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24927,31.86,0.8,23.6,6508,75,NULL,'W91PP, r','UGC 01970',NULL,'1997ApJS..109..333W',1997,1,2.13,NULL,'G',0.00001,NULL,'15.05',0.27,'Sc',NULL,NULL,NULL,NULL,1,37.475167,25.25636,0.241,NULL,68610905999,1072045406,16750709,15.05),(24928,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',24928,32.31,0.4,29,6508,75,NULL,NULL,'UGC 01970',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24929,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24929,32.31,0.4,29,6508,73,NULL,'IR','UGC 01970',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24930,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24930,32.38,0.43,30,6508,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01970',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24931,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24931,32.39,0.39,30.1,6508,73,NULL,'opt','UGC 01970',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24932,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24932,32.45,0.2,30.9,6508,74.4,NULL,NULL,'UGC 01970',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24933,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24933,32.46,0.43,31,6508,75,NULL,'3.6 micron, color corrected','UGC 01970',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24934,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24934,32.48,0.4,31.3,6508,73,NULL,'opt','UGC 01970',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24935,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24935,32.49,0.52,31.4,6508,NULL,NULL,'Malmquist cor.','UGC 01970',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24936,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24936,32.58,0.5,32.7,6508,NULL,NULL,NULL,'UGC 01970',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24937,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24937,32.64,0.37,33.7,6508,NULL,NULL,NULL,'UGC 01970',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24938,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',24938,32.66,0.49,34,6508,75,NULL,'IR','UGC 01970',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24939,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24939,32.75,0.38,35.5,6508,75,NULL,'W91PP, r, inv','UGC 01970',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24940,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24940,32.8,0.38,36.3,6508,75,NULL,'W91PP, r, raw','UGC 01970',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24941,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24941,33.17,NULL,43.1,6508,NULL,NULL,'Dipole','UGC 01970',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24942,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24942,33.18,NULL,43.2,6508,NULL,NULL,'Dipole + Quadrupole','UGC 01970',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24943,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24943,33.18,NULL,43.3,6508,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01970',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24944,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24944,33.22,0.38,44,6508,75,NULL,'W91PP, r, cor','UGC 01970',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24945,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24945,33.35,NULL,46.7,6508,NULL,NULL,NULL,'UGC 01970',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24946,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24946,35.52,0.23,127,6509,74.4,NULL,NULL,'IC 1804',NULL,'2013AJ....146...86T',2013,1,0.8,'The IC identification is not certain.','G',0.000077,NULL,'13.82',0.5,'E',NULL,NULL,NULL,NULL,1,37.47675,23.09708,0.309,NULL,68087944861,1063874138,16623033,13.82),(24947,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24947,35.77,0.17,143,6509,70,NULL,NULL,'IC 1804',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24948,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',24948,35.23,0.23,111,6510,70,NULL,NULL,'IC 0231',NULL,'2015arXiv151105856S',2015,1,0.86,NULL,'G',0.00007,NULL,'14.8g',0.67,'S0:',NULL,NULL,NULL,NULL,1,37.4849583,1.17908,0.013,NULL,66881487850,1045023247,16328488,14.8),(24949,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 17115','RN',24949,42.31,0.32,2380,6511,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17115',0.217547,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24950,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 17115','RN',24950,42.81,0.45,3000,6511,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17115',0.217547,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24951,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24951,32.85,0.69,37.2,6512,100,NULL,'mid-IR','UGC 01971',NULL,'2013ApJ...771...88L',2013,1,1,NULL,'G',0.000033,NULL,'14.67',0.7,'S0?',NULL,NULL,NULL,NULL,1,37.5000417,28.63367,0.317,NULL,68645082816,1072579419,16759053,14.67),(24952,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',24952,36.81,0.46,230,6513,70,NULL,NULL,'2MASX J02300149-0038541',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00009,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,37.5062917,-0.64844,0.029,NULL,34925520711,545711261,8526738,17.3),(24953,'Black Hole','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24953,32.48,1.53,31.4,6514,NULL,NULL,NULL,'MRK 1044',NULL,'2014ApJ...793..108W',2014,1,0.7,NULL,'G',0.000037,NULL,'14.5r',0.6,'SB0            Sy1',NULL,NULL,NULL,'NL Sy 1',1,37.523,-8.99814,0.049,NULL,34945483188,546023174,8531612,14.5),(24954,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24954,34.16,0.4,67.8,6514,NULL,NULL,'mean','MRK 1044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24955,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24955,34.18,0.45,68.5,6514,NULL,NULL,'K','MRK 1044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24956,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24956,34.47,0.47,78.5,6514,NULL,NULL,'H','MRK 1044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24957,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24957,34.69,0.46,86.8,6514,NULL,NULL,'J','MRK 1044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24958,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',24958,37.3,0.33,289,6515,70,NULL,NULL,'2MASX J02300716-0043231',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00015,NULL,'17.35',0.23,NULL,NULL,NULL,NULL,NULL,1,37.529833,-0.72311,0.033,NULL,34925525490,545711335,8526739,17.35),(24959,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',24959,37.3,0.33,289,6516,70,NULL,NULL,'2MASX J02300789-0042321',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000071,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,37.5327917,-0.70892,0.033,NULL,34925526514,545711351,8526739,17.3),(24960,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003km','R',24960,40.95,NULL,1050,6517,65,NULL,'SN e108, MLCS17','ESSENCE J023009.00-090435.9',0.47,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.5375,-9.07664,0.037,NULL,34945489129,546023267,8531613,NULL),(24961,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003km',NULL,24961,41.64,0.28,1450,6517,74.2,NULL,'SALT 2','ESSENCE J023009.00-090435.9',0.47,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24962,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003km',NULL,24962,42.09,0.22,1780,6517,70,NULL,'SN e108, SALT','ESSENCE J023009.00-090435.9',0.47,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24963,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003km',NULL,24963,42.23,0.15,1900,6517,65,NULL,'SN e108, MLCS17','ESSENCE J023009.00-090435.9',0.47,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24964,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003km',NULL,24964,42.26,0.15,1920,6517,65,NULL,'SN e108, MLCS31','ESSENCE J023009.00-090435.9',0.47,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24965,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003km',NULL,24965,42.27,0.2,1930,6517,65,NULL,'SN e108, SALT','ESSENCE J023009.00-090435.9',0.47,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24966,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003km',NULL,24966,42.28,0.13,1940,6517,65,NULL,'SN e108, MLCS2k2','ESSENCE J023009.00-090435.9',0.47,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24967,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003km',NULL,24967,42.36,0.06,2020,6517,65,NULL,'SN e108, SALT','ESSENCE J023009.00-090435.9',0.47,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24968,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003km',NULL,24968,42.39,0.18,2050,6517,72,NULL,'SN e108','ESSENCE J023009.00-090435.9',0.47,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24969,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003km',NULL,24969,42.59,0.34,2240,6517,65,NULL,'SN e108, SALT2','ESSENCE J023009.00-090435.9',0.47,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24970,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE p524','R',24970,41.33,NULL,1230,6518,65,NULL,'SALT2, z SN CMB','ESSENCE p524 HOST',0.508,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.542333,-8.88078,0.049,NULL,34945574198,546024596,8531634,NULL),(24971,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE p524',NULL,24971,41.48,0.23,1310,6518,74.2,NULL,'SALT 2','ESSENCE p524 HOST',0.508,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24972,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE p524',NULL,24972,42.34,0.23,1650,6518,65,NULL,'SALT2, z SN CMB','ESSENCE p524 HOST',0.508,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24973,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE p524',NULL,24973,42.14,0.21,1780,6518,70,NULL,'SALT','ESSENCE p524 HOST',0.508,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24974,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE p524',NULL,24974,42.24,0.19,1860,6518,65,NULL,'SALT2, z SN CMB','ESSENCE p524 HOST',0.508,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24975,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE p524',NULL,24975,42.3,0.19,1910,6518,65,NULL,'SALT, z SN CMB','ESSENCE p524 HOST',0.508,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24976,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE p524',NULL,24976,42.36,0.22,1960,6518,65,NULL,'MLCS17, z SN CMB','ESSENCE p524 HOST',0.508,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24977,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE p524',NULL,24977,42.38,0.2,1990,6518,65,NULL,'MLCS2k2, z SN CMB','ESSENCE p524 HOST',0.508,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24978,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE p524',NULL,24978,42.4,0.21,2000,6518,65,NULL,'MLCS31, z SN CMB','ESSENCE p524 HOST',0.508,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24979,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE p524',NULL,24979,42.43,0.2,2030,6518,65,NULL,'MLCS2k2','ESSENCE p524 HOST',0.508,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24980,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE p524',NULL,24980,42.45,0.07,2050,6518,65,NULL,'SALT','ESSENCE p524 HOST',0.508,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24981,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24981,35.77,0.17,143,6519,70,NULL,NULL,'GIN 123',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.5439583,23.14264,0.309,NULL,68087960855,1063874388,16623037,NULL),(24982,'IRAS','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24982,32.79,0.8,36.2,6520,75,NULL,'W91PP, r','UGC 01975',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000023,NULL,'15.36',0.2,'Sc','Isolated galaxy',NULL,NULL,NULL,1,37.5612083,33.13239,0.249,NULL,68630723131,1072355048,16755547,15.36),(24983,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24983,32.8,0.38,36.4,6520,75,NULL,'W91PP, r, inv','UGC 01975',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24984,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24984,32.94,0.38,38.7,6520,75,NULL,'W91PP, r, raw','UGC 01975',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24985,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',24985,32.95,0.49,39,6520,75,NULL,'IR','UGC 01975',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24986,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24986,33.36,0.38,47,6520,75,NULL,'W91PP, r, cor','UGC 01975',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24987,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24987,35.69,0.23,137,6521,74.4,NULL,NULL,'CGCG 483-070',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000057,NULL,'13.76',0.4,'E',NULL,NULL,NULL,NULL,1,37.5687083333,23.15325,0.309,NULL,68087968577,1063874509,16623039,13.76),(24988,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24988,35.77,0.17,143,6521,70,NULL,NULL,'CGCG 483-070',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24989,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,24989,35.54,0.73,128,6522,70,NULL,NULL,'ESO 115- G 013',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000097,NULL,'14.88',1.1,'SAB(r)bc',NULL,NULL,NULL,NULL,1,37.5687916667,-58.16944,0.037,NULL,36113799686,564278120,8816845,14.88),(24990,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2004hq','R',24990,42.11,NULL,1560,6523,65,NULL,'SN k441, SALT','ESSENCE J023018.04-082225.0',0.7,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.5751666667,-8.37361,0.097,NULL,34946286450,546035725,8531808,NULL),(24991,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2004hq',NULL,24991,42.18,0.29,1610,6523,74.2,NULL,'SALT 2','ESSENCE J023018.04-082225.0',0.7,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24992,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2004hq',NULL,24992,42.83,0.25,2170,6523,70,NULL,'SN k441, SALT','ESSENCE J023018.04-082225.0',0.7,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24993,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2004hq',NULL,24993,42.94,0.22,2280,6523,65,NULL,'SN k441, SALT','ESSENCE J023018.04-082225.0',0.7,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24994,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2004hq',NULL,24994,43.04,0.25,2390,6523,65,NULL,'SN k441, SALT2','ESSENCE J023018.04-082225.0',0.7,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24995,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2004hq',NULL,24995,43.15,0.22,2510,6523,65,NULL,'SN k441, MLCS17','ESSENCE J023018.04-082225.0',0.7,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24996,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2004hq',NULL,24996,43.23,0.18,2610,6523,65,NULL,'SN k441, MLCS31','ESSENCE J023018.04-082225.0',0.7,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24997,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2004hq',NULL,24997,43.24,0.16,2620,6523,65,NULL,'SN k441, MLCS2k2','ESSENCE J023018.04-082225.0',0.7,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24998,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2004hq',NULL,24998,43.28,0.14,2670,6523,65,NULL,'SN k441, SALT','ESSENCE J023018.04-082225.0',0.7,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24999,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 13242','RN',24999,42.45,0.2,2140,6524,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 13242',0.442459,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25000,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 13242','RN',25000,42.82,0.17,2550,6524,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 13242',0.442459,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25001,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2000eg',NULL,25001,41.96,0.41,1600,6525,65,NULL,NULL,'H-ZSNS J023021.05+010348.5',0.54,'2004ApJ...607..665R',2004,1,0.06,NULL,'G',NULL,NULL,'22.7g',0.05,NULL,NULL,NULL,NULL,NULL,1,37.5877917,1.06328,0.005,NULL,66882321186,1045036268,16328691,22.7),(25002,'IRAS','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25002,35.43,0.8,122,6526,75,NULL,'W91PP, r','UGC 01976',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'14.65',0.8,'Sb',NULL,NULL,NULL,NULL,1,37.589667,35.32594,0.177,NULL,68629103021,1072329734,16755152,14.65),(25003,'IRAS','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25003,35.44,0.8,123,6526,75,NULL,'CF, r','UGC 01976',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25004,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25004,35,0.38,99.9,6526,75,NULL,'CF, r, raw','UGC 01976',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25005,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25005,35.18,0.38,109,6526,75,NULL,'CF, r, inv','UGC 01976',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25006,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25006,35.22,0.38,110,6526,75,NULL,'W91PP, r, raw','UGC 01976',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25007,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25007,35.26,0.38,113,6526,75,NULL,'CF, r, cor','UGC 01976',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25008,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25008,35.46,0.38,124,6526,75,NULL,'W91PP, r, inv','UGC 01976',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25009,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25009,35.49,0.38,126,6526,75,NULL,'W91PP, r, cor','UGC 01976',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25010,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25010,34.23,0.59,70,6527,NULL,NULL,NULL,'ESO 545- G 025',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.98',0.4,'S...',NULL,NULL,NULL,NULL,1,37.597333,-20.68372,0.041,NULL,37969576747,593274636,9269916,15.98),(25011,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25011,34.24,0.59,70.4,6527,NULL,NULL,'Malmquist cor.','ESO 545- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25012,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25012,34.27,0.2,71.5,6527,74.4,NULL,NULL,'ESO 545- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25013,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE k490',NULL,25013,42.89,0.27,2200,6528,65,NULL,'SALT2','ESSENCE k490 HOST',0.715,'2009ApJ...700.1097H',2009,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.601333,-7.88917,0.089,NULL,34946363105,546036923,8531826,NULL),(25014,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE k490',NULL,25014,43.47,0.17,2880,6528,65,NULL,'MLCS31','ESSENCE k490 HOST',0.715,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25015,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 04715','RN',25015,39.57,0.19,789,6529,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04715',0.041333,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25016,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 04715','RN',25016,40.71,0.26,1330,6529,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04715',0.041333,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25017,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25017,37.44,0.46,307,6530,70,NULL,NULL,'2MASX J02302570-0050165',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.94',0.21,NULL,NULL,NULL,NULL,NULL,1,37.6072083,-0.83806,0.033,NULL,34925828174,545716065,8526813,17.94),(25018,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25018,34.47,0.47,78.4,6531,70,NULL,NULL,'ESO 246- G 021',NULL,'2014MNRAS.445.2677S',2014,1,2.2,NULL,'G',0.000087,NULL,'13.46',1.3,'(R\')SB(r)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,37.61625,-43.02686,NULL,NULL,38502640086,601603751,9400058,13.46),(25019,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 18188','R',25019,41.4,0.33,1320,6532,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18188',0.435327,'2014arXiv1401.3317S',2014,1,0.04,NULL,'G',NULL,'PHOT','22.8g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,37.621333,-0.30581,0.033,NULL,34923576690,545680885,8526263,22.8),(25020,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 18188','R',25020,41.57,0.37,1430,6532,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18188',0.435327,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25021,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 18188',NULL,25021,40.92,0.25,1530,6532,70,NULL,'SN photometric redshift distance, z photo =0.452 +/- 0.074','SDSS-II SN 18188',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25022,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25022,38.55,0.46,513,6533,70,NULL,NULL,'SDSS J023030.17-002140.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000075,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,37.6257083,-0.36114,0.029,NULL,34923563845,545680685,8526260,18.5),(25023,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25023,35.24,0.23,112,6534,74.4,NULL,NULL,'IC 1807',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000047,NULL,'14.05',0.4,'E',NULL,NULL,NULL,NULL,1,37.629167,22.94972,0.309,NULL,68087802077,1063871907,16622998,14.05),(25024,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25024,35.77,0.17,143,6534,70,NULL,NULL,'IC 1807',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25025,'Tully est','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25025,31.41,0.8,19.2,6535,75,NULL,'B','NGC 0955',NULL,'1988NBGC.C....0000T',1988,1,2.8,NULL,'G',0.000013,NULL,'12.93',0.7,'Sab: sp','in a radial-velocity based grouping',NULL,NULL,NULL,1,37.638125,-1.10842,0.041,NULL,34925911912,545717373,8526833,12.93),(25026,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25026,31.65,0.4,21.4,6535,NULL,NULL,NULL,'NGC 0955',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25027,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25027,31.71,0.4,22,6535,NULL,NULL,'mean','NGC 0955',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25028,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25028,31.78,0.47,22.7,6535,NULL,NULL,'H','NGC 0955',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25029,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25029,31.81,0.46,23,6535,NULL,NULL,'J','NGC 0955',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25030,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25030,31.84,0.45,23.3,6535,NULL,NULL,'K','NGC 0955',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25031,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25031,31.84,0.4,23.3,6535,73,NULL,'opt','NGC 0955',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25032,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25032,31.9,0.43,24,6535,75,NULL,'3.6 micron, color corrected','NGC 0955',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25033,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25033,31.93,0.2,24.3,6535,74.4,NULL,NULL,'NGC 0955',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25034,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25034,31.95,0.43,24.5,6535,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0955',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25035,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25035,32.01,0.39,25.2,6535,73,NULL,'opt','NGC 0955',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25036,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25036,32.02,0.4,25.4,6535,75,NULL,NULL,'NGC 0955',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25037,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25037,32.02,0.4,25.4,6535,73,NULL,'IR','NGC 0955',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25038,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25038,32.06,0.45,25.8,6535,NULL,NULL,'Malmquist cor.','NGC 0955',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25039,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25039,32.17,0.43,27.2,6535,NULL,NULL,NULL,'NGC 0955',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25040,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25040,32.29,0.49,28.7,6535,75,NULL,'IR','NGC 0955',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25041,'IRAS','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25041,33.83,0.8,58.5,6536,75,NULL,'W91PP, r','UGC 01980',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'14.54',0.4,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,37.6402917,32.17622,0.229,NULL,68635872380,1072435505,16756804,14.54),(25042,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25042,33.73,0.45,55.7,6536,NULL,NULL,'K','UGC 01980',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25043,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25043,33.74,0.47,55.9,6536,NULL,NULL,'H','UGC 01980',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25044,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25044,33.83,0.46,58.2,6536,NULL,NULL,'J','UGC 01980',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25045,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25045,34.04,0.4,64.2,6536,NULL,NULL,'mean','UGC 01980',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25046,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25046,34.09,0.43,65.8,6536,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01980',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25047,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25047,34.22,0.38,69.9,6536,75,NULL,'W91PP, r, raw','UGC 01980',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25048,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25048,34.22,0.43,69.9,6536,75,NULL,'3.6 micron, color corrected','UGC 01980',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25049,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25049,34.26,0.38,71.3,6536,75,NULL,'W91PP, r, cor','UGC 01980',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25050,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25050,34.36,0.3,74.6,6536,NULL,NULL,'Malmquist cor.','UGC 01980',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25051,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25051,34.43,0.38,77,6536,75,NULL,'W91PP, r, inv','UGC 01980',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25052,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25052,34.45,0.2,77.6,6536,74.4,NULL,NULL,'UGC 01980',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25053,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25053,34.58,0.27,82.4,6536,NULL,NULL,NULL,'UGC 01980',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25054,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25054,36.11,0.51,167,6537,70,NULL,NULL,'MCG -01-07-018',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.0001,NULL,'15.5b',0.3,NULL,NULL,NULL,NULL,NULL,1,37.6412083,-4.62481,0.025,NULL,34962198830,546284356,8535693,15.5),(25055,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 15719',NULL,25055,39.1,0.95,660,6538,70,NULL,'SN photometric redshift distance, z photo =0.168 +/- 0.107','SDSS-II SN 15719',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,37.647917,1.10331,0.005,NULL,66882317816,1045036215,16328690,NULL),(25056,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 15719','R',25056,40.61,0.21,1040,6538,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15719',0.268672,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25057,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 15719','R',25057,40.71,0.15,1090,6538,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15719',0.268672,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25058,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 15719',NULL,25058,40.49,0.11,1250,6538,70,NULL,'SALT 2','SDSS-II SN 15719',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25059,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 15719',NULL,25059,40.51,0.11,1260,6538,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15719',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25060,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999fm','R',25060,42.46,NULL,1610,6539,65,NULL,'SALT','H-ZSNS J023035.62+010943.3',0.93,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.648417,1.16203,0.013,NULL,66882196392,1045034318,16328661,NULL),(25061,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999fm',NULL,25061,42.92,0.3,1990,6539,74.2,NULL,'SALT 2','H-ZSNS J023035.62+010943.3',0.93,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25062,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999fm',NULL,25062,43.7,0.27,2850,6539,70,NULL,'SALT','H-ZSNS J023035.62+010943.3',0.93,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25063,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999fm',NULL,25063,43.77,0.35,2940,6539,65,NULL,'BATM','H-ZSNS J023035.62+010943.3',0.93,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25064,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999fm',NULL,25064,43.84,0.37,3040,6539,65,NULL,'dm15','H-ZSNS J023035.62+010943.3',0.93,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25065,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999fm',NULL,25065,43.86,0.26,3060,6539,65,NULL,'SALT','H-ZSNS J023035.62+010943.3',0.93,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25066,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999fm',NULL,25066,43.95,0.29,3190,6539,65,NULL,'Final','H-ZSNS J023035.62+010943.3',0.93,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25067,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999fm',NULL,25067,43.99,0.25,3250,6539,65,NULL,NULL,'H-ZSNS J023035.62+010943.3',0.93,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25068,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999fm',NULL,25068,44.06,0.23,3360,6539,65,NULL,'delta m15','H-ZSNS J023035.62+010943.3',0.93,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25069,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999fm',NULL,25069,44.18,0.22,3550,6539,65,NULL,'MLCS','H-ZSNS J023035.62+010943.3',0.93,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25070,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 08309','RN',25070,40.85,0.15,1290,6540,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 08309',0.149362,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25071,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 08309','RN',25071,41.29,0.26,1570,6540,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 08309',0.149362,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25072,'IRAS','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25072,33.52,0.8,50.7,6541,75,NULL,'MAT, I','ESO 415- G 031',NULL,'1997ApJS..109..333W',1997,1,1.6,'1996ApJS..107...97M have V = 4057 +- 10.','G',0.000123,NULL,'14.93',0.3,'SB(s)cd? sp',NULL,NULL,NULL,NULL,1,37.650917,-31.59619,NULL,NULL,38440571546,600633930,9384905,14.93),(25073,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25073,31.72,0.32,22.1,6541,85,NULL,'I, inv','ESO 415- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25074,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25074,31.75,0.32,22.4,6541,85,NULL,'I, raw','ESO 415- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25075,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25075,32.08,0.43,26,6541,75,NULL,'MAT, I, inv','ESO 415- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25076,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25076,32.13,0.43,26.7,6541,75,NULL,'MAT, I, raw','ESO 415- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25077,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25077,32.22,0.43,27.9,6541,75,NULL,'MAT, I, cor','ESO 415- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25078,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25078,33.65,0.2,53.7,6541,74.4,NULL,NULL,'ESO 415- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25079,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25079,33.84,0.31,58.7,6541,NULL,NULL,NULL,'ESO 415- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25080,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25080,33.92,0.49,60.9,6541,75,NULL,'IR','ESO 415- G 031',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25081,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25081,34.17,0.27,68.2,6541,NULL,NULL,'Malmquist cor.','ESO 415- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25082,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25082,35.29,0.25,114,6542,74.4,NULL,NULL,'2MASX J02303663+2243096',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000547,NULL,'17.06',NULL,'S0',NULL,NULL,NULL,NULL,1,37.652667,22.71939,0.337,NULL,68088051187,1063875799,16623059,17.06),(25083,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25083,33.84,0.25,58.6,6543,74.4,NULL,NULL,'NGC 0946',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000067,NULL,'14.19',1,'S0:',NULL,NULL,NULL,NULL,1,37.660125,42.23261,0.245,NULL,68548883760,1071076308,16735567,14.19),(25084,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25084,34.33,0.4,73.6,6543,NULL,NULL,'mean','NGC 0946',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25085,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25085,34.47,0.45,78.4,6543,NULL,NULL,'K','NGC 0946',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25086,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25086,34.79,0.49,90.7,6544,75,NULL,'IR','CGCG 483-072',NULL,'2011yCatp016004901K',2011,1,0.7,NULL,'G',0.000033,NULL,'15.83',0.2,'Sc','Isolated galaxy',NULL,NULL,NULL,1,37.6646666667,27.15867,0.281,NULL,68612907447,1072076678,16751198,15.83),(25087,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2002iy','R',25087,41.83,NULL,1460,6545,65,NULL,'SN b010, SALT2','ESSENCE J023040.00-081140.5',0.587,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.666667,-8.19458,0.077,NULL,34946346391,546036662,8531822,NULL),(25088,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2002iy',NULL,25088,42.5,0.31,1990,6545,74.2,NULL,'SALT 2','ESSENCE J023040.00-081140.5',0.587,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25089,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2002iy',NULL,25089,42.87,0.24,2360,6545,65,NULL,'SN b010, MLCS17','ESSENCE J023040.00-081140.5',0.587,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25090,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2002iy',NULL,25090,42.97,0.21,2470,6545,65,NULL,'SN b010, MLCS31','ESSENCE J023040.00-081140.5',0.587,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25091,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2002iy',NULL,25091,42.98,0.2,2490,6545,65,NULL,'SN b010, MLCS2k2','ESSENCE J023040.00-081140.5',0.587,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25092,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2002iy',NULL,25092,43.31,0.27,2890,6545,70,NULL,'SN b010, SALT','ESSENCE J023040.00-081140.5',0.587,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25093,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2002iy',NULL,25093,43.35,0.31,2940,6545,65,NULL,'SN b010, SALT2','ESSENCE J023040.00-081140.5',0.587,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25094,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2002iy',NULL,25094,43.52,0.24,3190,6545,65,NULL,'SN b010, SALT','ESSENCE J023040.00-081140.5',0.587,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25095,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2002iy',NULL,25095,43.53,0.24,3190,6545,65,NULL,'SN b010, SALT','ESSENCE J023040.00-081140.5',0.587,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25096,'Tully est','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25096,31.53,0.8,20.2,6546,75,NULL,NULL,'UGCA 033',NULL,'1988NBGC.C....0000T',1988,1,3.5,NULL,'G',0.00001,NULL,'15',2.7,'SB(s)dm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,37.67225,-3.81192,0.025,NULL,34961506470,546273538,8535524,15),(25097,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 11995','RN',25097,41.35,0.82,1730,6547,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 11995',0.079923,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25098,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2005A',NULL,25098,34.38,0.58,72.5,6548,72,NULL,NULL,'NGC 0958',0.01835,'2013ApJ...773...53F',2013,1,2.9,NULL,'G',0.00002,NULL,'11.8B',1,'SB(rs)c:;LIRG  HII',NULL,NULL,NULL,NULL,1,37.6784583333,-2.939,0.017,NULL,34956487562,546195118,8534298,11.8),(25099,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2005A',NULL,25099,34.36,0.09,74.5,6548,74.4,NULL,NULL,'NGC 0958',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25100,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2005A',NULL,25100,34.46,0.06,76.5,6548,72,NULL,NULL,'NGC 0958',0.01914,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25101,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2005A',NULL,25101,34.46,0.02,78,6548,72,NULL,NULL,'NGC 0958',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25102,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25102,33.39,0.49,47.8,6548,70,NULL,NULL,'NGC 0958',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25103,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25103,33.55,0.46,51.2,6548,NULL,NULL,'J','NGC 0958',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25104,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25104,33.56,0.47,51.5,6548,NULL,NULL,'H','NGC 0958',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25105,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25105,33.6,0.45,52.4,6548,NULL,NULL,'K','NGC 0958',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25106,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25106,33.73,NULL,55.7,6548,NULL,NULL,'B','NGC 0958',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25107,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25107,34.07,0.42,65.2,6548,NULL,18.48,'3.6 micron','NGC 0958',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25108,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25108,34.09,0.4,65.8,6548,75,NULL,'HOSTS SN 2005A','NGC 0958',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25109,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25109,34.18,0.43,68.6,6548,75,NULL,'3.6 micron, color corrected','NGC 0958',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25110,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25110,34.26,0.43,71.2,6548,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0958',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25111,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25111,34.36,0.09,74.5,6548,74.4,NULL,NULL,'NGC 0958',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25112,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25112,34.37,0.4,74.7,6548,NULL,NULL,'mean','NGC 0958',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25113,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 21570','RN',25113,41.45,0.17,1540,6549,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 21570',0.265953,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25114,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 21570','RN',25114,41.9,0.23,1890,6549,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 21570',0.265953,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25115,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25115,36,0.5,158,6550,70,NULL,NULL,'2MASX J02304534-1358516',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00014,NULL,'15.41',0.61,NULL,NULL,NULL,NULL,NULL,1,37.6889583,-13.981,0,NULL,38085896023,595092125,9298314,15.41),(25116,'SBF','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25116,30.06,0.14,10.3,6551,74.4,NULL,NULL,'NGC 0949',NULL,'2013AJ....146...86T',2013,1,2.4,NULL,'G',0.000007,NULL,'12.40',1.3,'SA(rs)b:?','Isolated galaxy',NULL,NULL,NULL,1,37.7027083,37.13678,0.165,NULL,68667913152,1072936143,16764627,12.4),(25117,'SBF','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25117,30.26,0.18,11.3,6551,NULL,NULL,'I','NGC 0949',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25118,'IRAS','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25118,30.11,0.8,10.5,6551,75,NULL,'A82, H','NGC 0949',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25119,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25119,29.49,0.4,7.9,6551,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 0949',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25120,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25120,29.6,0.3,8.32,6551,NULL,18.45,'NGC 1023 group','NGC 0949',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25121,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25121,29.87,0.47,9.4,6551,75,NULL,'A82, H, inv','NGC 0949',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25122,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25122,29.96,0.47,9.84,6551,75,NULL,'A82, H, raw','NGC 0949',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25123,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25123,30.02,0.38,10.1,6551,NULL,NULL,NULL,'NGC 0949',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25124,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25124,30.06,0.4,10.3,6551,75,NULL,'B','NGC 0949',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25125,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25125,30.24,0.47,11.2,6551,75,NULL,'A82, H, cor','NGC 0949',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25126,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25126,35.65,0.69,135,6552,100,NULL,'mid-IR','CGCG 483-073',NULL,'2013ApJ...771...88L',2013,1,0.7,NULL,'G',0.000033,NULL,'15.64',0.3,'S?',NULL,NULL,NULL,NULL,1,37.710583,26.1935,0.269,NULL,68614409399,1072100146,16751564,15.64),(25127,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25127,34.16,0.2,67.9,6553,74.4,NULL,NULL,'CGCG 414-010',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'GPair',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.715,3.85222,0.061,NULL,66906131833,1045408309,16334504,NULL),(25128,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25128,34.77,0.08,90.1,6553,NULL,NULL,NULL,'CGCG 414-010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25129,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25129,35.65,0.75,135,6554,70,NULL,NULL,'AM 0229-604 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'17.10',0.3,NULL,NULL,NULL,NULL,NULL,1,37.722417,-60.52672,0.085,NULL,36267568001,566680750,8854386,17.1),(25130,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25130,35.13,0.49,106,6555,75,NULL,'IR','UGC 01984',NULL,'2011yCatp016004901K',2011,1,1.27,NULL,'G',NULL,NULL,'16.5',0.11,'Sbc',NULL,NULL,NULL,NULL,1,37.7222917,43.34983,0.361,NULL,68549458568,1071085290,16735707,16.5),(25131,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25131,35.66,NULL,136,6555,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01984',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25132,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25132,35.67,NULL,136,6555,NULL,NULL,'Dipole + Quadrupole','UGC 01984',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25133,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25133,35.69,NULL,137,6555,NULL,NULL,'Dipole','UGC 01984',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25134,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25134,35.7,NULL,138,6555,NULL,NULL,NULL,'UGC 01984',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25135,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2006mv',NULL,25135,39.16,0.07,679,6556,70,NULL,'Hubble residual -0.02 for z0.17520','SDSS-II SN 15583 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.731083,0.94628,0.005,NULL,66882327787,1045036371,16328693,NULL),(25136,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 15583','R',25136,39.7,0.2,740,6556,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006mv','SDSS-II SN 15583 HOST',0.178,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25137,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 15583','R',25137,39.79,0.07,770,6556,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006mv','SDSS-II SN 15583 HOST',0.178,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25138,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 05378','R',25138,40.65,0.2,1080,6557,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05378',0.2511,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.736917,-1.25208,0.041,NULL,34925866016,545716656,8526822,NULL),(25139,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 05378','R',25139,41.03,0.12,1290,6557,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 05378',0.2511,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25140,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 15093',NULL,25140,40.66,0.69,1360,6558,70,NULL,'SN photometric redshift distance, z photo =0.388 +/- 0.206','SDSS-II SN 15093',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','22.7g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,37.7402083,-0.96083,0.037,NULL,34925954939,545718045,8526844,22.7),(25141,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 13509','RN',25141,41,0.19,1300,6559,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13509',0.217308,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25142,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 13509','RN',25142,42.28,0.43,2350,6559,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13509',0.217308,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25143,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kp','R',25143,41.7,NULL,1330,6560,65,NULL,'SN e147, MLCS17','ESSENCE J023102.64-083950.8',0.64,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.761,-8.66411,0.093,NULL,34945871424,546029241,8531706,NULL),(25144,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kp',NULL,25144,42.11,0.24,1610,6560,74.2,NULL,'SALT 2','ESSENCE J023102.64-083950.8',0.64,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25145,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kp',NULL,25145,42.83,0.23,2240,6560,70,NULL,'SN e147, SALT','ESSENCE J023102.64-083950.8',0.64,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25146,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kp',NULL,25146,42.84,0.18,2260,6560,65,NULL,'SN e147, MLCS2k2','ESSENCE J023102.64-083950.8',0.64,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25147,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kp',NULL,25147,42.9,0.18,2310,6560,65,NULL,'SN e147, SALT2','ESSENCE J023102.64-083950.8',0.64,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25148,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kp',NULL,25148,42.95,0.18,2380,6560,65,NULL,'SN e147, MLCS17','ESSENCE J023102.64-083950.8',0.64,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25149,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kp',NULL,25149,43,0.17,2430,6560,65,NULL,'SN e147, MLCS31','ESSENCE J023102.64-083950.8',0.64,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25150,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kp',NULL,25150,43,0.22,2430,6560,65,NULL,'SN e147, SALT2','ESSENCE J023102.64-083950.8',0.64,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25151,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kp',NULL,25151,43.02,0.16,2440,6560,65,NULL,'SN e147, MLCS2k2','ESSENCE J023102.64-083950.8',0.64,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25152,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kp',NULL,25152,43.03,0.21,2460,6560,65,NULL,'SN e147, SALT','ESSENCE J023102.64-083950.8',0.64,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25153,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kp',NULL,25153,43.05,0.06,2480,6560,65,NULL,'SN e147, SALT','ESSENCE J023102.64-083950.8',0.64,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25154,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kp',NULL,25154,43.09,0.18,2530,6560,65,NULL,'SN e147, m15(B)','ESSENCE J023102.64-083950.8',0.64,'2005AJ....130.2453K',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25155,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kp',NULL,25155,43.11,0.2,2550,6560,65,NULL,'SN e147, MLCS','ESSENCE J023102.64-083950.8',0.64,'2005AJ....130.2453K',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25156,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kp',NULL,25156,43.11,0.19,2550,6560,65,NULL,'SN e147, BATM','ESSENCE J023102.64-083950.8',0.64,'2005AJ....130.2453K',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25157,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kq',NULL,25157,41.66,0.25,1340,6561,74.2,NULL,'SALT 2','ESSENCE J023104.09-081056.6',0.606,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.7670416667,-8.18239,0.077,NULL,34945212272,546018941,8531545,NULL),(25158,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kq','R',25158,41.74,NULL,1390,6561,65,NULL,'SN e140, SALT','ESSENCE J023104.09-081056.6',0.606,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25159,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kq',NULL,25159,42.39,0.18,1870,6561,65,NULL,'SN e140, SALT2','ESSENCE J023104.09-081056.6',0.606,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25160,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kq',NULL,25160,42.57,0.27,2030,6561,70,NULL,'SN e140, SALT','ESSENCE J023104.09-081056.6',0.606,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25161,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kq',NULL,25161,42.71,0.24,2170,6561,65,NULL,'SN e140, SALT','ESSENCE J023104.09-081056.6',0.606,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25162,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kq',NULL,25162,42.73,0.22,2190,6561,65,NULL,'SN e140, MLCS2k2','ESSENCE J023104.09-081056.6',0.606,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25163,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kq',NULL,25163,42.75,0.2,2210,6561,65,NULL,'SN e140, SALT2','ESSENCE J023104.09-081056.6',0.606,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25164,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kq',NULL,25164,42.81,0.22,2270,6561,65,NULL,'SN e140, MLCS17','ESSENCE J023104.09-081056.6',0.606,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25165,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kq',NULL,25165,42.88,0.1,2340,6561,65,NULL,'SN e140, SALT','ESSENCE J023104.09-081056.6',0.606,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25166,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kq',NULL,25166,42.88,0.17,2350,6561,65,NULL,'SN e140, MLCS31','ESSENCE J023104.09-081056.6',0.606,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25167,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kq',NULL,25167,42.89,0.15,2360,6561,65,NULL,'SN e140, MLCS2k2','ESSENCE J023104.09-081056.6',0.606,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25168,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25168,35.35,0.47,117,6562,NULL,NULL,'H','ESO 545- G 026',NULL,'2007A&A...465...71T',2007,1,1.23,'The APM position is 7.5 arcsec west of the nucleus.','G',0.00003,NULL,'14.62',0.47,'SAB(r)bc',NULL,NULL,NULL,NULL,1,37.7677083,-19.33336,0.063,NULL,37970586845,593290419,9270162,14.62),(25169,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25169,35.51,0.45,127,6562,NULL,NULL,'K','ESO 545- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25170,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25170,35.54,0.46,128,6562,NULL,NULL,'J','ESO 545- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25171,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25171,35.6,0.4,132,6562,NULL,NULL,'mean','ESO 545- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25172,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25172,33.9,0.46,60.2,6563,NULL,NULL,'J','NGC 0964',NULL,'2007A&A...465...71T',2007,1,2,'SGC claims = IC 1814.','G',0.00004,NULL,'13.46',0.5,'Sab','Pair member (points to parent)',NULL,NULL,NULL,1,37.774125,-36.03467,NULL,NULL,38630674568,603604290,9431317,13.46),(25173,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25173,33.91,0.47,60.4,6563,NULL,NULL,'H','NGC 0964',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25174,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25174,33.97,0.45,62.2,6563,NULL,NULL,'K','NGC 0964',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25175,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25175,34.09,0.4,65.6,6563,NULL,NULL,'mean','NGC 0964',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25176,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25176,34.1,0.49,66,6563,75,NULL,'IR','NGC 0964',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25177,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003jw',NULL,25177,40.46,0.24,954,6564,74.2,NULL,'SALT 2','ESSENCE J023106.84-084536.5',0.296,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.7785,-8.76014,0.049,NULL,34945866497,546029164,8531705,NULL),(25178,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003jw','R',25178,41.03,NULL,1240,6564,65,NULL,'SN d117, SALT2','ESSENCE J023106.84-084536.5',0.296,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25179,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003jw',NULL,25179,41.2,0.28,1340,6564,65,NULL,'SN d117, SALT2','ESSENCE J023106.84-084536.5',0.296,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25180,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003jw',NULL,25180,41.29,0.21,1400,6564,70,NULL,'SN d117, SALT','ESSENCE J023106.84-084536.5',0.296,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25181,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003jw',NULL,25181,41.3,0.29,1400,6564,65,NULL,'SN d117, MLCS17','ESSENCE J023106.84-084536.5',0.296,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25182,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003jw',NULL,25182,41.34,0.2,1430,6564,65,NULL,'SN d117, MLCS2k2','ESSENCE J023106.84-084536.5',0.296,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25183,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003jw',NULL,25183,41.36,0.26,1440,6564,65,NULL,'SN d117, MLCS31','ESSENCE J023106.84-084536.5',0.296,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25184,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003jw',NULL,25184,41.38,0.3,1460,6564,65,NULL,'SN d117, SALT2','ESSENCE J023106.84-084536.5',0.296,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25185,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003jw',NULL,25185,41.43,0.18,1490,6564,65,NULL,'SN d117, SALT','ESSENCE J023106.84-084536.5',0.296,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25186,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003jw',NULL,25186,41.42,0.26,1490,6564,65,NULL,'SN d117, MLCS2k2','ESSENCE J023106.84-084536.5',0.296,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25187,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003jw',NULL,25187,41.56,0.11,1580,6564,65,NULL,'SN d117, SALT','ESSENCE J023106.84-084536.5',0.296,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25188,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25188,37.61,0.46,333,6565,70,NULL,NULL,'2MASX J02310927-0011124',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000086,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,37.7887917,-0.18692,0.017,NULL,34923404559,545678196,8526221,16.9),(25189,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25189,34.68,0.4,86.3,6566,NULL,NULL,'mean','IC 0232',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000067,NULL,'14.3g',1.2,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,37.7984166667,1.26564,0.021,NULL,66881943207,1045030362,16328599,14.3),(25190,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25190,34.74,0.45,88.7,6566,NULL,NULL,'K','IC 0232',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25191,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25191,36.45,0.52,195,6567,70,NULL,NULL,'2MASX J02311320-5915510',NULL,'2014MNRAS.445.2677S',2014,1,0.74,NULL,'G',0.00015,NULL,'16.39',0.29,NULL,NULL,NULL,NULL,NULL,1,37.8050417,-59.26419,0.045,NULL,36297557683,567149338,8861708,16.39),(25192,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25192,33.88,0.43,59.7,6568,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01988',NULL,'2014MNRAS.444..527S',2014,1,1,NULL,'G',0.000073,NULL,'14.79',0.3,'Sab',NULL,NULL,NULL,NULL,1,37.809625,40.39033,0.177,NULL,68536883942,1070888811,16732637,14.79),(25193,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25193,33.98,0.43,62.4,6568,75,NULL,'3.6 micron, color corrected','UGC 01988',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25194,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25194,34.12,0.2,66.7,6568,74.4,NULL,NULL,'UGC 01988',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25195,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25195,36.3,0.53,182,6569,70,NULL,NULL,'2MASX J02311467-1741120',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.23',0.38,'S0',NULL,NULL,NULL,NULL,1,37.8110417,-17.68669,0.047,NULL,37962523540,593164430,9268194,16.23),(25196,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 04181','R',25196,41.2,0.26,1350,6570,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 04181',0.289167,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.8177916667,-1.131,0.037,NULL,34925920946,545717514,8526836,NULL),(25197,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 04181','R',25197,41.24,0.16,1370,6570,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 04181',0.289167,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25198,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25198,38.25,0.46,446,6571,70,NULL,NULL,'2MASX J02311693-0036544',NULL,'2015arXiv151105856S',2015,1,0.11,NULL,'G',0.000064,NULL,'17.7g',0.09,NULL,NULL,NULL,NULL,NULL,1,37.8205833333,-0.61514,0.033,NULL,34925654741,545713355,8526771,17.7),(25199,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25199,36.77,0.33,225,6572,70,NULL,NULL,'2MASX J02311707-0803261',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000063,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,37.821167,-8.05714,0.077,NULL,34946302701,546035979,8531812,17.7),(25200,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2004fs','R',25200,41.38,NULL,1260,6573,65,NULL,'SN g160, SALT','ESSENCE J023119.95-084921.7',0.5,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.833125,-8.82269,0.037,NULL,34945745649,546027275,8531676,NULL),(25201,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2004fs',NULL,25201,41.43,0.27,1290,6573,74.2,NULL,'SALT 2','ESSENCE J023119.95-084921.7',0.5,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25202,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2004fs',NULL,25202,42.12,0.23,1770,6573,70,NULL,'SN g160, SALT','ESSENCE J023119.95-084921.7',0.5,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25203,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2004fs',NULL,25203,42.23,0.26,1860,6573,65,NULL,'SN g160, SALT2','ESSENCE J023119.95-084921.7',0.5,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25204,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2004fs',NULL,25204,42.25,0.2,1880,6573,65,NULL,'SN g160, SALT','ESSENCE J023119.95-084921.7',0.5,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25205,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2004fs',NULL,25205,42.27,0.24,1890,6573,65,NULL,'SN g160, MLCS2k2','ESSENCE J023119.95-084921.7',0.5,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25206,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2004fs',NULL,25206,42.28,0.27,1900,6573,65,NULL,'SN g160, SALT2','ESSENCE J023119.95-084921.7',0.5,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25207,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2004fs',NULL,25207,42.31,0.26,1930,6573,65,NULL,'SN g160, MLCS17','ESSENCE J023119.95-084921.7',0.5,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25208,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2004fs',NULL,25208,42.39,0.24,2000,6573,65,NULL,'SN g160, MLCS2k2','ESSENCE J023119.95-084921.7',0.5,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25209,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2004fs',NULL,25209,42.39,0.25,2000,6573,65,NULL,'SN g160, MLCS31','ESSENCE J023119.95-084921.7',0.5,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25210,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2004fs',NULL,25210,42.48,0.08,2090,6573,65,NULL,'SN g160, SALT','ESSENCE J023119.95-084921.7',0.5,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25211,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 18827','RN',25211,41.26,0.23,1370,6574,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18827',0.299006,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25212,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 18827','RN',25212,41.37,0.14,1450,6574,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18827',0.299006,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25213,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 18827','N',25213,41.23,0.12,1760,6574,70,NULL,'SALT 2','SDSS-II SN 18827',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25214,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 18827','N',25214,41.25,0.12,1780,6574,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18827',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25215,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 11996','RN',25215,41.08,0.32,1280,6575,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 11996',0.286703,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25216,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 11996','RN',25216,41.13,0.31,1310,6575,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 11996',0.286703,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25217,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 11996','N',25217,40.94,0.22,1540,6575,70,NULL,'SALT 2','SDSS-II SN 11996',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25218,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 11996','N',25218,40.97,0.22,1560,6575,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 11996',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25219,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25219,36.77,0.33,225,6576,70,NULL,NULL,'2MASX J02312077-0804140',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000103,NULL,'16.0g',0.29,'E0',NULL,NULL,NULL,NULL,1,37.836625,-8.0705,0.077,NULL,34945207936,546018874,8531544,16),(25220,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2002iz',NULL,25220,41.05,0.23,1140,6577,74.2,NULL,'SALT 2','SDSS J023120.85-083613.5',0.428,'2010ApJ...716..712A',2010,1,0.09,NULL,'G',0.001,NULL,'20.4g',0.03,NULL,NULL,NULL,NULL,NULL,1,37.836917,-8.60378,0.093,NULL,34945879331,546029364,8531708,20.4),(25221,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2002iz','R',25221,41.2,NULL,1210,6577,65,NULL,'SN b013, MLCS17','SDSS J023120.85-083613.5',0.428,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25222,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2002iz',NULL,25222,41.81,0.19,1610,6577,65,NULL,'SN b013, SALT2','SDSS J023120.85-083613.5',0.428,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25223,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2002iz',NULL,25223,41.81,0.2,1610,6577,70,NULL,'SN b013, SALT','SDSS J023120.85-083613.5',0.428,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25224,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2002iz',NULL,25224,41.94,0.21,1710,6577,65,NULL,'SN b013, MLCS17','SDSS J023120.85-083613.5',0.428,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25225,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2002iz',NULL,25225,41.94,0.21,1710,6577,65,NULL,'SN b013, SALT2','SDSS J023120.85-083613.5',0.428,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25226,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2002iz',NULL,25226,41.95,0.18,1720,6577,65,NULL,'SN b013, SALT','SDSS J023120.85-083613.5',0.428,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25227,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2002iz',NULL,25227,41.95,0.22,1720,6577,65,NULL,'SN b013, MLCS31','SDSS J023120.85-083613.5',0.428,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25228,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2002iz',NULL,25228,41.98,0.21,1740,6577,65,NULL,'SN b013, MLCS2k2','SDSS J023120.85-083613.5',0.428,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25229,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2002iz',NULL,25229,41.99,0.18,1750,6577,65,NULL,'SN b013, MLCS2k2','SDSS J023120.85-083613.5',0.428,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25230,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2002iz',NULL,25230,42.14,0.09,1880,6577,65,NULL,'SN b013, SALT','SDSS J023120.85-083613.5',0.428,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25231,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kr','R',25231,41.15,NULL,1190,6578,65,NULL,'SN e148, SALT','ESSENCE J023120.96-083614.2',0.427,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.8373333333,-8.60394,0.093,NULL,34945879331,546029364,8531708,NULL),(25232,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kr',NULL,25232,41.18,0.22,1210,6578,74.2,NULL,'SALT 2','ESSENCE J023120.96-083614.2',0.427,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25233,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kr',NULL,25233,41.83,0.22,1630,6578,70,NULL,'SN e148, SALT','ESSENCE J023120.96-083614.2',0.427,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25234,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kr',NULL,25234,41.89,0.17,1670,6578,65,NULL,'SN e148, SALT2','ESSENCE J023120.96-083614.2',0.427,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25235,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kr',NULL,25235,42.01,0.2,1760,6578,65,NULL,'SN e148, SALT','ESSENCE J023120.96-083614.2',0.427,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25236,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kr',NULL,25236,42.06,0.05,1810,6578,65,NULL,'SN e148, SALT','ESSENCE J023120.96-083614.2',0.427,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25237,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kr',NULL,25237,42.08,0.14,1830,6578,65,NULL,'SN e148, MLCS2k2','ESSENCE J023120.96-083614.2',0.427,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25238,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kr',NULL,25238,42.08,0.2,1830,6578,65,NULL,'SN e148, SALT2','ESSENCE J023120.96-083614.2',0.427,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25239,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kr',NULL,25239,42.2,0.18,1930,6578,65,NULL,'SN e148, MLCS17','ESSENCE J023120.96-083614.2',0.427,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25240,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kr',NULL,25240,42.23,0.19,1960,6578,65,NULL,'SN e148, MLCS31','ESSENCE J023120.96-083614.2',0.427,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25241,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kr',NULL,25241,42.25,0.18,1970,6578,65,NULL,'SN e148, MLCS2k2','ESSENCE J023120.96-083614.2',0.427,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25242,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 19532','RN',25242,43.62,0.28,3330,6579,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19532',0.58972,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25243,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 18312',NULL,25243,40.89,0.17,1510,6580,70,NULL,'SN photometric redshift distance, z photo =0.445 +/- 0.050','SDSS-II SN 18312',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,37.8435833333,0.74028,0,NULL,66881669984,1045026093,16328532,NULL),(25244,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 18312','R',25244,42.42,0.42,2090,6580,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18312',0.454146,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25245,'IRAS','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25245,34.88,0.8,94.5,6581,75,NULL,'A82, H','UGC 01995',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00004,NULL,'14.26',0.8,'SB(r)c pec:','Group member',NULL,NULL,NULL,1,37.859,1.34628,0.021,NULL,66881962863,1045030669,16328604,14.26),(25246,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25246,34.17,0.33,68.2,6581,91,NULL,'H','UGC 01995',NULL,'1984ApJ...278..475B',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25247,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25247,34.7,0.47,87.2,6581,75,NULL,'A82, H, raw','UGC 01995',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25248,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25248,34.82,0.47,92.1,6581,75,NULL,'A82, H, inv','UGC 01995',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25249,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25249,34.99,0.47,99.5,6581,75,NULL,'A82, H, cor','UGC 01995',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25250,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25250,35.1,0.31,105,6581,NULL,NULL,'Malmquist cor.','UGC 01995',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25251,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25251,35.14,0.2,107,6581,74.4,NULL,NULL,'UGC 01995',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25252,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25252,35.2,0.29,110,6581,NULL,NULL,NULL,'UGC 01995',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25253,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25253,35.81,0.48,145,6582,70,NULL,NULL,'ESO 545- G 028',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000093,NULL,'14.64',0.7,'S?;cD',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,37.859167,-17.65375,0.047,NULL,37962551740,593164870,9268201,14.64),(25254,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 13353','RN',25254,42.36,0.18,2300,6583,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 13353',0.286177,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25255,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 13353','RN',25255,42.54,0.23,2500,6583,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 13353',0.286177,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25256,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 14375','RN',25256,40.57,0.12,982,6584,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14375',0.323264,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25257,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 14375','RN',25257,40.7,0.21,1040,6584,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14375',0.323264,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25258,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 14375','N',25258,40.57,0.1,1300,6584,70,NULL,'SALT 2','SDSS-II SN 14375',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25259,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 14375','N',25259,40.61,0.1,1320,6584,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14375',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25260,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE n404',NULL,25260,39.68,0.22,710,6585,74.2,NULL,'SALT 2','SDSS J023131.56-085510.7',0.216,'2010ApJ...716..712A',2010,1,0.1,NULL,'G',NULL,NULL,'19.4r',0.08,NULL,NULL,NULL,NULL,NULL,1,37.8815417,-8.91964,0.033,NULL,34945723736,546026933,8531670,19.4),(25261,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE n404',NULL,25261,40.46,0.28,1020,6585,65,NULL,'SALT2','SDSS J023131.56-085510.7',0.216,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25262,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE n404',NULL,25262,40.54,0.32,1060,6585,65,NULL,'MLCS31','SDSS J023131.56-085510.7',0.216,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25263,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE n404',NULL,25263,40.58,0.29,1080,6585,65,NULL,'SALT2','SDSS J023131.56-085510.7',0.216,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25264,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE n404',NULL,25264,40.59,0.29,1080,6585,65,NULL,'MLCS2k2','SDSS J023131.56-085510.7',0.216,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25265,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE n404',NULL,25265,40.61,0.2,1090,6585,70,NULL,'SALT','SDSS J023131.56-085510.7',0.216,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25266,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE n404',NULL,25266,40.64,0.29,1110,6585,65,NULL,'MLCS17','SDSS J023131.56-085510.7',0.216,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25267,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE n404',NULL,25267,40.7,0.19,1130,6585,65,NULL,'MLCS2k2','SDSS J023131.56-085510.7',0.216,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25268,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE n404',NULL,25268,41,0.06,1300,6585,65,NULL,'SALT','SDSS J023131.56-085510.7',0.216,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25269,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003ks','R',25269,41.34,NULL,1240,6586,65,NULL,'SN e149, MLCS17','ESSENCE J023134.54-083646.4',0.5,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.893917,-8.61289,0.093,NULL,34945886130,546029470,8531710,NULL),(25270,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003ks',NULL,25270,41.36,0.22,1250,6586,74.2,NULL,'SALT 2','ESSENCE J023134.54-083646.4',0.5,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25271,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003ks',NULL,25271,42.09,0.23,1750,6586,70,NULL,'SN e149, SALT','ESSENCE J023134.54-083646.4',0.5,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25272,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003ks',NULL,25272,42.13,0.2,1780,6586,65,NULL,'SN e149, SALT2','ESSENCE J023134.54-083646.4',0.5,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25273,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003ks',NULL,25273,42.16,0.24,1800,6586,65,NULL,'SN e149, MLCS17','ESSENCE J023134.54-083646.4',0.5,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25274,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003ks',NULL,25274,42.2,0.09,1840,6586,65,NULL,'SN e149, SALT','ESSENCE J023134.54-083646.4',0.5,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25275,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003ks',NULL,25275,42.21,0.25,1840,6586,65,NULL,'SN e149, SALT2','ESSENCE J023134.54-083646.4',0.5,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25276,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003ks',NULL,25276,42.22,0.26,1850,6586,65,NULL,'SN e149, MLCS31','ESSENCE J023134.54-083646.4',0.5,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25277,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003ks',NULL,25277,42.23,0.24,1860,6586,65,NULL,'SN e149, MLCS2k2','ESSENCE J023134.54-083646.4',0.5,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25278,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003ks',NULL,25278,42.24,0.2,1870,6586,65,NULL,'SN e149, SALT','ESSENCE J023134.54-083646.4',0.5,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25279,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003ks',NULL,25279,42.27,0.2,1900,6586,65,NULL,'SN e149, MLCS2k2','ESSENCE J023134.54-083646.4',0.5,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25280,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25280,36.88,0.46,238,6587,70,NULL,NULL,'2MASX J02313489+0100135',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000081,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,37.8955417,1.00383,0.005,NULL,66882141907,1045033467,16328647,16.9),(25281,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 06055',NULL,25281,41.38,0.1,1890,6588,70,NULL,'SN photometric redshift distance, z photo =0.606 +/- 0.042','SDSS-II SN 06055',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,37.9062917,-0.89603,0.037,NULL,34925771856,545715185,8526799,NULL),(25282,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25282,37.52,0.79,320,6589,70,NULL,NULL,'2MASX J02313785-5044465',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'16.27',0.28,'S',NULL,NULL,NULL,NULL,1,37.907833,-50.74619,0.009,NULL,38190669181,596729205,9323893,16.27),(25283,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25283,33.62,0.46,53.1,6590,70,NULL,NULL,'NGC 0979',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'13.78',1,'(R)SB(rl)0^0','in a triple',NULL,NULL,NULL,1,37.911625,-44.52431,NULL,NULL,38494024206,601469128,9397955,13.78),(25284,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999gp',NULL,25284,34.63,0.11,82.1,6591,74.2,NULL,'SALT 2','UGC 01993',0.02675,'2010ApJ...716..712A',2010,1,2.3,NULL,'G',0.000037,NULL,'14.10',0.6,'Sb',NULL,NULL,NULL,NULL,1,37.9169166667,39.37836,0.193,NULL,68655491500,1072742054,16761594,14.1),(25285,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999gp',NULL,25285,35.08,0.11,101,6591,72,NULL,NULL,'UGC 01993',0.02675,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25286,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999gp',NULL,25286,35.09,0.03,102,6591,70,NULL,'SALT 2','UGC 01993',0.02675,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25287,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999gp',NULL,25287,35.04,0.09,102,6591,72,NULL,'M(H) = -18.317 mag','UGC 01993',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25288,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999gp',NULL,25288,35.1,0.2,102,6591,72,NULL,NULL,'UGC 01993',0.02675,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25289,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999gp',NULL,25289,35.16,0.25,105,6591,72,NULL,NULL,'UGC 01993',0.02675,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25290,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999gp',NULL,25290,35.21,0.03,107,6591,72,NULL,NULL,'UGC 01993',0.02675,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25291,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999gp',NULL,25291,35.16,0.08,108,6591,74.4,NULL,NULL,'UGC 01993',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25292,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999gp',NULL,25292,35.28,0.03,111,6591,72,NULL,NULL,'UGC 01993',0.02675,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25293,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999gp',NULL,25293,35.23,0.17,111,6591,70.8,NULL,NULL,'UGC 01993',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25294,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999gp',NULL,25294,35.28,0.16,111,6591,70,NULL,'SALT 2','UGC 01993',0.02675,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25295,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999gp',NULL,25295,35.32,0.16,113,6591,73.8,NULL,'SALT 2 (SNANA)','UGC 01993',0.0267,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25296,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999gp',NULL,25296,35.33,0.05,114,6591,65,NULL,'SALT2','UGC 01993',0.02675,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25297,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999gp',NULL,25297,35.34,0.08,114,6591,70,NULL,NULL,'UGC 01993',0.02675,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25298,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999gp',NULL,25298,35.36,0.11,115,6591,70,NULL,'SALT','UGC 01993',0.02675,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25299,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999gp',NULL,25299,35.44,0.19,119,6591,65,NULL,'SALT2','UGC 01993',0.02675,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25300,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999gp',NULL,25300,35.4,0.09,120,6591,65,NULL,'LC','UGC 01993',NULL,'2001AJ....122.1616K',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25301,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999gp',NULL,25301,35.51,0.13,123,6591,65,NULL,'SALT','UGC 01993',0.02675,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25302,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999gp',NULL,25302,35.55,0.01,126,6591,65,NULL,'SALT','UGC 01993',0.02675,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25303,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999gp',NULL,25303,35.56,0.03,126,6591,65,NULL,'MLCS2k2','UGC 01993',0.02675,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25304,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999gp',NULL,25304,35.62,0.06,127,6591,65,NULL,'MLCS2k2','UGC 01993',0.02675,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25305,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999gp',NULL,25305,35.53,0.3,128,6591,60,NULL,NULL,'UGC 01993',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25306,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999gp',NULL,25306,35.61,0.15,129,6591,65,NULL,'MLCS31','UGC 01993',0.02675,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25307,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999gp',NULL,25307,35.62,0.07,130,6591,65,NULL,'MLCS2k2','UGC 01993',0.02675,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25308,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999gp',NULL,25308,35.62,0.2,130,6591,65,NULL,NULL,'UGC 01993',0.02675,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25309,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999gp',NULL,25309,35.67,0.19,136,6591,65,NULL,'MLCS','UGC 01993',NULL,'2001AJ....122.1616K',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25310,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25310,34.75,0.49,89.1,6591,75,NULL,'IR','UGC 01993',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25311,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25311,34.94,0.4,97.3,6591,75,NULL,'HOSTS SN 1999gp','UGC 01993',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25312,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25312,35.13,0.43,106,6591,75,NULL,'3.6 micron, color corrected','UGC 01993',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25313,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25313,35.16,0.08,108,6591,74.4,NULL,NULL,'UGC 01993',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25314,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25314,35.22,0.47,111,6591,NULL,NULL,'H','UGC 01993',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25315,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25315,35.27,0.4,113,6591,NULL,NULL,'mean','UGC 01993',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25316,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25316,35.36,0.46,118,6591,NULL,NULL,'J','UGC 01993',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25317,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25317,35.43,0.43,122,6591,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01993',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25318,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25318,35.45,0.45,123,6591,NULL,NULL,'K','UGC 01993',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25319,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25319,33.73,0.69,55.8,6592,100,NULL,'mid-IR','IC 1809',NULL,'2013ApJ...771...88L',2013,1,1,NULL,'G',0.000103,NULL,'14.82',0.7,'(R\')SB(s)ab',NULL,NULL,NULL,NULL,1,37.918125,22.91719,0.337,NULL,68088081949,1063876280,16623066,14.82),(25320,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25320,34.22,0.47,69.7,6592,NULL,NULL,'H','IC 1809',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25321,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25321,34.31,0.45,72.9,6592,NULL,NULL,'K','IC 1809',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25322,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25322,34.39,0.46,75.4,6592,NULL,NULL,'J','IC 1809',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25323,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25323,34.45,0.4,77.6,6592,NULL,NULL,'mean','IC 1809',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25324,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE h300','R',25324,41.82,NULL,1370,6593,65,NULL,'SALT','ESSENCE h300 HOST',0.687,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.9194583333,-8.81758,0.085,NULL,34945727069,546026985,8531671,NULL),(25325,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE h300',NULL,25325,42.12,0.27,1570,6593,74.2,NULL,'SALT 2','ESSENCE h300 HOST',0.687,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25326,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE h300',NULL,25326,42.8,0.24,2150,6593,65,NULL,'SALT2','ESSENCE h300 HOST',0.687,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25327,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE h300',NULL,25327,42.82,0.25,2170,6593,70,NULL,'SALT','ESSENCE h300 HOST',0.687,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25328,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE h300',NULL,25328,42.94,0.23,2290,6593,65,NULL,'MLCS2k2','ESSENCE h300 HOST',0.687,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25329,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE h300',NULL,25329,42.98,0.23,2340,6593,65,NULL,'SALT','ESSENCE h300 HOST',0.687,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25330,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE h300',NULL,25330,42.99,0.24,2350,6593,65,NULL,'SALT2','ESSENCE h300 HOST',0.687,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25331,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE h300',NULL,25331,43.08,0.16,2450,6593,65,NULL,'MLCS31','ESSENCE h300 HOST',0.687,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25332,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE h300',NULL,25332,43.09,0.14,2460,6593,65,NULL,'MLCS2k2','ESSENCE h300 HOST',0.687,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25333,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','ESSENCE h300',NULL,25333,43.13,0.11,2500,6593,65,NULL,'SALT','ESSENCE h300 HOST',0.687,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25334,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 06398','RN',25334,38.14,0.21,403,6594,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06398',0.054349,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25335,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 06398','RN',25335,41.79,0.35,2170,6594,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06398',0.054349,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25336,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25336,37.32,0.46,291,6595,70,NULL,NULL,'2MASX J02314097-0110037',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000084,NULL,'17.1g',0.24,'BLAGN',NULL,NULL,NULL,NULL,1,37.92075,-1.16769,0.037,NULL,34925392961,545709265,8526707,17.1),(25337,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25337,33.96,0.47,62,6596,70,NULL,NULL,'NGC 0960',NULL,'2014MNRAS.445.2677S',2014,1,1.31,NULL,'G',0.00008,NULL,'14.5g',0.38,'Sb(f)',NULL,NULL,NULL,NULL,1,37.922333,-9.30044,0.029,NULL,34931328824,545802012,8528156,14.5),(25338,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 18189',NULL,25338,39.76,0.52,897,6597,70,NULL,'SN photometric redshift distance, z photo =0.237 +/- 0.076','SDSS-II SN 18189',NULL,'2011ApJ...738..162S',2011,1,0.12,NULL,'G',NULL,'PHOT','20.0g',0.08,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,37.930125,-0.36739,0.029,NULL,34925487788,545710746,8526730,20),(25339,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 18189','R',25339,40.55,0.28,1000,6597,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18189',0.285824,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25340,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 18189','R',25340,40.59,0.26,1020,6597,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18189',0.285824,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25341,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 18189',NULL,25341,40.36,0.18,1180,6597,70,NULL,'SALT 2','SDSS-II SN 18189',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25342,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 18189',NULL,25342,40.39,0.18,1200,6597,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18189',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25343,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 01452','RN',25343,43.04,0.23,3050,6598,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 01452',0.325205,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25344,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 01452','RN',25344,43.1,0.26,3140,6598,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 01452',0.325205,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25345,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25345,34.12,0.43,66.7,6599,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01998',NULL,'2014MNRAS.444..527S',2014,1,1.12,NULL,'G',0.000033,NULL,'15.6g',0.5,'Scd:',NULL,NULL,NULL,NULL,1,37.93075,0.29347,0.013,NULL,66881636380,1045025568,16328524,15.6),(25346,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25346,34.15,0.43,67.6,6599,75,NULL,'3.6 micron, color corrected','UGC 01998',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25347,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25347,34.18,0.2,68.6,6599,74.4,NULL,NULL,'UGC 01998',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25348,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25348,36.86,0.59,235,6600,70,NULL,NULL,'2MASX J02314824-0109257',NULL,'2014MNRAS.445.2677S',2014,1,0.5,'Huchra et al. (1999ApJS..121..287H) give v = 13800 km/sec.','G',0.000085,NULL,'15.8g',0.35,'S0/a',NULL,NULL,NULL,NULL,1,37.951083,-1.15703,0.037,NULL,34925389762,545709215,8526706,15.8),(25349,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 19000',NULL,25349,39.97,0.24,985,6601,70,NULL,'SN photometric redshift distance, z photo =0.264 +/- 0.036','SDSS-II SN 19000',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,37.9520417,-0.49289,0.041,NULL,34925668341,545713567,8526774,NULL),(25350,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 19000','R',25350,40.77,0.21,1110,6601,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19000',0.286131,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25351,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 19000','R',25351,40.83,0.13,1140,6601,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19000',0.286131,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25352,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 19000',NULL,25352,40.69,0.1,1370,6601,70,NULL,'SALT 2','SDSS-II SN 19000',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25353,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 19000',NULL,25353,40.72,0.1,1390,6601,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19000',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25354,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25354,36.38,0.72,189,6602,70,NULL,NULL,'2MASX J02314941-0536417',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.00015,NULL,'16.50',0.34,NULL,NULL,NULL,NULL,NULL,1,37.9559166667,-5.61153,0.033,NULL,34961881471,546279397,8535615,16.5),(25355,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25355,30.69,NULL,13.8,6603,NULL,NULL,'Dipole','UGC 01999',NULL,'2010Ap&SS.325..163P',2010,1,4.03,NULL,'G',0.000003,NULL,'14.60',0.56,'Sbc',NULL,NULL,NULL,NULL,1,37.969167,19.15306,0.273,NULL,68102276332,1064098067,16626532,14.6),(25356,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25356,30.7,NULL,13.8,6603,NULL,NULL,'Dipole + Quadrupole','UGC 01999',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25357,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25357,30.7,NULL,13.8,6603,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 01999',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25358,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25358,30.93,NULL,15.3,6603,NULL,NULL,NULL,'UGC 01999',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25359,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25359,31.53,0.2,20.2,6603,74.4,NULL,NULL,'UGC 01999',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25360,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25360,31.69,0.4,21.8,6603,73,NULL,'opt','UGC 01999',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25361,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25361,31.7,0.43,21.9,6603,75,NULL,'3.6 micron, color corrected','UGC 01999',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25362,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25362,31.74,0.51,22.3,6603,NULL,NULL,NULL,'UGC 01999',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25363,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25363,31.78,0.43,22.7,6603,75,NULL,'3.6 micron, color + selection bias corrected','UGC 01999',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25364,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25364,31.79,0.49,22.8,6603,NULL,NULL,'Malmquist cor.','UGC 01999',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25365,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003jt','R',25365,40.95,NULL,1070,6604,65,NULL,'SN d097, MLCS31','ESSENCE J023154.60-083548.4',0.45,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,37.9775,-8.59678,0.093,NULL,34945802283,546028160,8531690,NULL),(25366,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003jt',NULL,25366,41.21,0.23,1200,6604,74.2,NULL,'SALT 2','ESSENCE J023154.60-083548.4',0.45,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25367,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003jt',NULL,25367,41.92,0.21,1670,6604,70,NULL,'SN d097, SALT','ESSENCE J023154.60-083548.4',0.45,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25368,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003jt',NULL,25368,41.95,0.23,1700,6604,65,NULL,'SN d097, SALT2','ESSENCE J023154.60-083548.4',0.45,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25369,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003jt',NULL,25369,42.05,0.19,1780,6604,65,NULL,'SN d097, SALT','ESSENCE J023154.60-083548.4',0.45,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25370,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003jt',NULL,25370,42.07,0.16,1790,6604,65,NULL,'SN d097, MLCS2k2','ESSENCE J023154.60-083548.4',0.45,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25371,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003jt',NULL,25371,42.08,0.16,1790,6604,65,NULL,'SN d097, MLCS31','ESSENCE J023154.60-083548.4',0.45,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25372,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003jt',NULL,25372,42.07,0.23,1790,6604,65,NULL,'SN d097, SALT2','ESSENCE J023154.60-083548.4',0.45,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25373,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003jt',NULL,25373,42.1,0.14,1810,6604,65,NULL,'SN d097, MLCS2k2','ESSENCE J023154.60-083548.4',0.45,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25374,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003jt',NULL,25374,42.33,0.08,2020,6604,65,NULL,'SN d097, SALT','ESSENCE J023154.60-083548.4',0.45,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25375,'GRB','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25375,44.25,0.14,3490,6605,NULL,NULL,NULL,'GRB 080411',1.03,'2010JCAP...08..020W',2010,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,37.9785,-71.30244,0.025,NULL,36337397785,567771840,8871435,NULL),(25376,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 02309','RN',25376,37.16,0.19,255,6606,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 02309',0.060284,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25377,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 02309','RN',25377,37.45,0.07,291,6606,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 02309',0.060284,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25378,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25378,35.23,0.23,111,6607,70,NULL,NULL,'UGC 02005',NULL,'2015arXiv151105856S',2015,1,1.06,NULL,'G',0.000077,NULL,'14.1g',0.86,'SA(rs)0-:','Group member',NULL,NULL,NULL,1,37.9907083333,1.24653,0.017,NULL,66882105621,1045032900,16328639,14.1),(25379,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25379,34.5,0.2,79.4,6608,74.4,NULL,NULL,'UGC 02004',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.00005,NULL,'14.4B',0.8,'SAB(s)c',NULL,NULL,NULL,NULL,1,37.99825,0.90997,0,NULL,66882114185,1045033034,16328641,14.4),(25380,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25380,34.67,0.37,85.7,6608,NULL,NULL,NULL,'UGC 02004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25381,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25381,34.89,0.34,95,6608,NULL,NULL,'Malmquist cor.','UGC 02004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25382,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2004hf','R',25382,40.9,NULL,1080,6609,65,NULL,'SN h342, MLCS31','ESSENCE J023200.14-084223.8',0.4,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,38.000583,-8.70661,0.085,NULL,34945797028,546028078,8531688,NULL),(25383,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2004hf',NULL,25383,41.47,0.23,1410,6609,74.2,NULL,'SALT 2','ESSENCE J023200.14-084223.8',0.4,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25384,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2004hf',NULL,25384,42.04,0.28,1830,6609,70,NULL,'SN h342, SALT','ESSENCE J023200.14-084223.8',0.4,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25385,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2004hf',NULL,25385,42.16,0.14,1930,6609,65,NULL,'SN h342, MLCS31','ESSENCE J023200.14-084223.8',0.4,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25386,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2004hf',NULL,25386,42.17,0.11,1940,6609,65,NULL,'SN h342, MLCS2k2','ESSENCE J023200.14-084223.8',0.4,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25387,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2004hf',NULL,25387,42.18,0.12,1950,6609,65,NULL,'SN h342, MLCS2k2','ESSENCE J023200.14-084223.8',0.4,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25388,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2004hf',NULL,25388,42.22,0.27,1990,6609,65,NULL,'SN h342, SALT','ESSENCE J023200.14-084223.8',0.4,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25389,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2004hf',NULL,25389,42.34,0.09,2090,6609,65,NULL,'SN h342, SALT','ESSENCE J023200.14-084223.8',0.4,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25390,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2004hf',NULL,25390,42.33,0.24,2090,6609,65,NULL,'SN h342, SALT2','ESSENCE J023200.14-084223.8',0.4,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25391,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2004hf',NULL,25391,42.48,0.33,2240,6609,65,NULL,'SN h342, SALT2','ESSENCE J023200.14-084223.8',0.4,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25392,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 19559','RN',25392,41.59,0.27,1450,6610,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19559',0.429997,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25393,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 19559','RN',25393,41.75,0.31,1560,6610,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19559',0.429997,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25394,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 19559','N',25394,41.69,0.2,2180,6610,70,NULL,'SALT 2','SDSS-II SN 19559',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25395,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 19559','N',25395,41.77,0.2,2260,6610,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19559',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25396,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25396,35.67,0.49,136,6611,70,NULL,NULL,'UGC 02010',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00009,NULL,'14.10',0.8,'SB(rs)bc',NULL,NULL,NULL,NULL,1,38.0297083,-1.36214,0.053,NULL,34925400748,545709386,8526709,14.1),(25397,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25397,35.23,0.23,111,6612,70,NULL,NULL,'2MASX J02321031+0114509',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00009,NULL,'15.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,38.042875,1.24747,0.017,NULL,66882095160,1045032736,16328636,15.7),(25398,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25398,37.8,0.46,363,6613,70,NULL,NULL,'2MASX J02321174+0013259',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000101,NULL,'16.9g',0.1,'AGN',NULL,NULL,NULL,NULL,1,38.0490416667,0.22403,0.013,NULL,66878742354,1044980349,16327817,16.9),(25399,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25399,34.93,0.48,96.6,6614,70,NULL,NULL,'NGC 0967',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000093,NULL,'14.38',1,'SAB0-',NULL,NULL,NULL,NULL,1,38.0529583,-17.21686,0.028,NULL,37961783007,593152859,9268013,14.38),(25400,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25400,35.27,0.45,113,6614,NULL,NULL,'K','NGC 0967',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25401,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25401,35.3,0.4,115,6614,NULL,NULL,'mean','NGC 0967',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25402,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 05959','R',25402,40.09,0.18,864,6615,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J023214.30-001829.0',0.2085,'2014arXiv1401.3317S',2014,1,0.16,NULL,'G',0.0005,NULL,'19.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,38.059583,-0.30806,0.029,NULL,34922056827,545657137,8525892,19.2),(25403,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 05959','R',25403,40.26,0.09,931,6615,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J023214.30-001829.0',0.2085,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25404,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 05959',NULL,25404,39.95,0.07,977,6615,70,NULL,'SALT 2','SDSS J023214.30-001829.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25405,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 05959',NULL,25405,39.97,0.07,986,6615,70,NULL,'SALT 2, Malmquist cor.','SDSS J023214.30-001829.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25406,'IRAS','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25406,32.2,0.8,27.5,6616,75,NULL,'MAT, I','ESO 355- G 026',NULL,'1997ApJS..109..333W',1997,1,1.6,'The APMUKS position is east of the nucleus.','G',0.000031,NULL,'13.77',0.9,'SB(s)bc:       HII',NULL,NULL,NULL,NULL,1,38.0729583333,-35.03022,NULL,NULL,38631220335,603612817,9431450,13.77),(25407,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25407,31.98,0.32,24.9,6616,85,NULL,'I, raw','ESO 355- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25408,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25408,31.98,0.32,24.9,6616,85,NULL,'I, inv','ESO 355- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25409,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25409,32.1,0.08,26.4,6616,NULL,NULL,NULL,'ESO 355- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25410,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25410,32.32,0.43,29.2,6616,75,NULL,'MAT, I, raw','ESO 355- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25411,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25411,32.39,0.43,30,6616,75,NULL,'MAT, I, inv','ESO 355- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25412,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25412,32.39,0.4,30.1,6616,NULL,NULL,'mean','ESO 355- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25413,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25413,32.47,0.43,31.3,6616,75,NULL,'MAT, I, cor','ESO 355- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25414,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25414,32.93,0.47,38.5,6616,NULL,NULL,'H','ESO 355- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25415,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25415,32.97,0.46,39.3,6616,NULL,NULL,'J','ESO 355- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25416,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25416,37.76,0.46,356,6617,70,NULL,NULL,'2MASX J02321987-0032568',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00009,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,38.0827917,-0.549,0.041,NULL,34922139785,545658434,8525913,17.4),(25417,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25417,36.99,0.46,250,6618,70,NULL,NULL,'2MASX J02322222-0912355',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000075,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,38.092625,-9.20975,0.029,NULL,34931442220,545803784,8528184,16.9),(25418,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25418,34.72,0.47,87.9,6619,NULL,NULL,'H','UGC 02001',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.00004,NULL,'14.33',1,'Sab',NULL,NULL,NULL,NULL,1,38.0945,42.19869,0.305,NULL,68550700201,1071104690,16736010,14.33),(25419,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25419,34.86,0.4,93.9,6619,NULL,NULL,'mean','UGC 02001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25420,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25420,34.87,0.46,94.3,6619,NULL,NULL,'J','UGC 02001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25421,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25421,34.88,0.45,94.6,6619,NULL,NULL,'K','UGC 02001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25422,'IRAS','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25422,30.09,0.8,10.4,6620,75,NULL,'A82, H','NGC 0959',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.000017,NULL,'12.95',1.4,'Sdm:           HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,38.09975,35.49464,0.157,NULL,68659598763,1072806230,16762597,12.95),(25423,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25423,29.21,0.69,6.94,6620,100,NULL,'mid-IR','NGC 0959',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25424,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25424,29.96,0.43,9.8,6620,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0959',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25425,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25425,30.03,0.4,10.1,6620,75,NULL,'B','NGC 0959',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25426,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25426,30.13,0.4,10.6,6620,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 0959',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25427,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25427,30.14,0.43,10.7,6620,75,NULL,'3.6 micron, color corrected','NGC 0959',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25428,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25428,30.24,0.2,11.2,6620,74.4,NULL,NULL,'NGC 0959',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25429,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25429,30.82,0.47,14.6,6620,75,NULL,'A82, H, inv','NGC 0959',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25430,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25430,30.92,0.47,15.3,6620,75,NULL,'A82, H, raw','NGC 0959',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25431,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25431,31.17,0.47,17.2,6620,75,NULL,'A82, H, cor','NGC 0959',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25432,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25432,36.73,0.46,222,6621,70,NULL,NULL,'2MASX J02322407-0033068',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000092,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,38.1001666667,-0.55203,0.041,NULL,34922156175,545658690,8525917,16.6),(25433,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 15868','R',25433,40.75,0.19,1130,6622,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006pa','SDSS J023223.95-004248.9',0.25,'2014arXiv1401.3317S',2014,1,0.09,NULL,'G',NULL,NULL,'20.5g',0.06,NULL,NULL,NULL,NULL,NULL,1,38.100333,-0.71408,0.037,NULL,34925577873,545712154,8526752,20.5),(25434,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 15868','R',25434,40.82,0.11,1170,6622,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006pa','SDSS J023223.95-004248.9',0.25,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25435,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2006pa',NULL,25435,40.51,0.09,1260,6622,70,NULL,'SALT 2','SDSS J023223.95-004248.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25436,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2006pa',NULL,25436,40.53,0.09,1280,6622,70,NULL,'SALT 2, Malmquist cor.','SDSS J023223.95-004248.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25437,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25437,34.08,0.23,65.5,6623,74.4,NULL,NULL,'CGCG 539-042',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000173,NULL,'15.6',0.5,'E',NULL,NULL,NULL,NULL,1,38.11775,41.94428,0.229,NULL,68550680958,1071104389,16736006,15.6),(25438,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 15119',NULL,25438,39.84,0.76,930,6624,70,NULL,'SN photometric redshift distance, z photo =0.247 +/- 0.129','SDSS-II SN 15119',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,38.122625,1.09058,0.017,NULL,66882011032,1045031422,16328615,NULL),(25439,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 15119',NULL,25439,41.5,0.25,2000,6624,70,NULL,'SALT 2','SDSS-II SN 15119',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25440,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 15119',NULL,25440,41.53,0.25,2020,6624,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15119',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25441,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25441,38.14,0.63,424,6625,70,NULL,NULL,'2MASX J02323261-0515428',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'17.54',0.2,NULL,NULL,NULL,NULL,NULL,1,38.135833,-5.26192,0.033,NULL,34962583991,546290374,8535787,17.54),(25442,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25442,35.59,0.52,131,6626,70,NULL,NULL,'2MASX J02323273-6235050',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.41',0.4,'S0',NULL,NULL,NULL,NULL,1,38.1365,-62.58469,0.041,NULL,36271614251,566743972,8855374,16.41),(25443,'IRAS','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25443,35.52,0.8,127,6627,75,NULL,'W91PP, r','UGC 02011',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'15.22',0.7,'SAB(r)ab',NULL,NULL,NULL,NULL,1,38.159167,31.56428,0.361,NULL,68636261614,1072441587,16756899,15.22),(25444,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25444,35.68,0.4,137,6627,NULL,NULL,'mean','UGC 02011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25445,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25445,35.68,0.38,137,6627,75,NULL,'W91PP, r, raw','UGC 02011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25446,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25446,35.9,0.47,151,6627,NULL,NULL,'H','UGC 02011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25447,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25447,35.92,0.38,153,6627,75,NULL,'W91PP, r, cor','UGC 02011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25448,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25448,35.97,0.46,157,6627,NULL,NULL,'J','UGC 02011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25449,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25449,36.01,0.45,160,6627,NULL,NULL,'K','UGC 02011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25450,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25450,36.01,0.38,160,6627,75,NULL,'W91PP, r, inv','UGC 02011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25451,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 13195','R',25451,35.63,0.05,131,6628,70,NULL,'SDSS CAND. SNIb; MLCS2K2; SN 2006fo','SN 2006fo',0.020709,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ib or Ia',NULL,NULL,NULL,NULL,1,38.1620417,0.6175,0.013,NULL,66878845262,1044981957,16327843,NULL),(25452,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 13195','R',25452,36.37,0.23,184,6628,70,NULL,'SDSS CAND. SNIb; SALT 2; SN 2006fo','SN 2006fo',0.020709,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25453,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2010A',NULL,25453,34.64,0.22,83,6629,73.8,NULL,'SALT 2 (SNANA)','UGC 02019',0.02,'2014ApJ...795...44R',2014,1,0.68,NULL,'G',0.000033,NULL,'14.6g',0.48,'Sab','in a radial-velocity based grouping',NULL,NULL,NULL,1,38.1637083,0.61733,0.013,NULL,66878845260,1044981957,16327843,14.6),(25454,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 13540','RN',25454,43.29,0.22,4460,6629,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13540',0.020392,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25455,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 05897',NULL,25455,40.39,0.12,1200,6630,70,NULL,'SN photometric redshift distance, z photo =0.333 +/- 0.023','SDSS-II SN 05897',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.7g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,38.164,-0.80414,0.037,NULL,34922433732,545663027,8525984,21.7),(25456,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 05897','R',25456,41.26,0.2,1300,6630,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 05897',0.368966,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25457,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 05897','R',25457,41.41,0.27,1400,6630,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05897',0.368966,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25458,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 05897',NULL,25458,41.25,0.17,1780,6630,70,NULL,'SALT 2','SDSS-II SN 05897',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25459,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 05897',NULL,25459,41.3,0.17,1820,6630,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 05897',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25460,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25460,35.85,0.2,148,6631,74.4,NULL,NULL,'UGC 02012',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000033,NULL,'14.73',0.8,'Sbc',NULL,NULL,NULL,NULL,1,38.173375,21.03264,0.345,NULL,68100752092,1064074251,16626160,14.73),(25461,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 17733','RN',25461,40.55,0.41,940,6632,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17733',0.369608,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25462,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 17733','RN',25462,40.82,0.38,1060,6632,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17733',0.369608,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25463,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25463,34.47,NULL,78.5,6633,NULL,NULL,'Dipole + Quadrupole','FGC 0310',NULL,'2010Ap&SS.325..163P',2010,1,0.9,NULL,'G',0.000012,NULL,'16.0',0.11,'Sd',NULL,NULL,NULL,NULL,1,38.174167,15.71889,0.453,NULL,68071510728,1063617355,16619021,16),(25464,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25464,34.47,NULL,78.5,6633,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0310',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25465,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25465,34.5,NULL,79.4,6633,NULL,NULL,'Dipole','FGC 0310',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25466,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25466,34.54,NULL,80.8,6633,NULL,NULL,NULL,'FGC 0310',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25467,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25467,35.04,0.59,102,6634,NULL,NULL,'Malmquist cor.','ESO 355- G 028',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.92',0.4,'Sb',NULL,NULL,NULL,NULL,1,38.176583,-33.00269,NULL,NULL,38407668341,600119817,9376872,14.92),(25468,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25468,35.17,0.55,108,6634,NULL,NULL,NULL,'ESO 355- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25469,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25469,35.21,0.2,110,6634,74.4,NULL,NULL,'ESO 355- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25470,'Tully est','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25470,30.86,0.8,14.8,6635,75,NULL,NULL,'UGC 02017',NULL,'1988NBGC.C....0000T',1988,1,2.3,NULL,'G',0.000017,NULL,'17.',1.8,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,38.1885,28.84081,0.285,NULL,68607298462,1071989038,16749828,17),(25471,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25471,35.66,0.57,136,6636,70,NULL,NULL,'2MASX J02324668-1735282',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000103,NULL,'16.85',0.35,NULL,NULL,NULL,NULL,NULL,1,38.194583,-17.59117,0.042,NULL,37962642382,593166287,9268223,16.85),(25472,'BL Lac Luminosity','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25472,39.38,NULL,660,6637,NULL,NULL,NULL,'2MASX J02324860+2017175',0.14,'2005ApJ...635..173S',2005,1,NULL,NULL,'G',NULL,NULL,'18.0',NULL,'BLLAC',NULL,NULL,NULL,'BL Lac',1,38.202583,20.28819,0.297,NULL,68100424654,1064069135,16626080,18),(25473,'IRAS','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25473,34.35,0.8,74.2,6638,75,NULL,'MAT, I','UGC 02020',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'15.49',0.2,'Scd:',NULL,NULL,NULL,NULL,1,38.22425,23.32761,0.417,NULL,68087517914,1063867467,16622929,15.49),(25474,'IRAS','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25474,34.35,0.8,74.2,6638,75,NULL,'W91PP, r','UGC 02020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25475,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25475,33.69,0.32,54.7,6638,85,NULL,'I, inv','UGC 02020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25476,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25476,33.69,0.32,54.8,6638,85,NULL,'I, raw','UGC 02020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25477,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25477,34.02,0.43,63.6,6638,75,NULL,'MAT, I, raw','UGC 02020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25478,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25478,34.06,0.43,65,6638,75,NULL,'MAT, I, inv','UGC 02020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25479,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25479,34.17,0.53,68.2,6638,NULL,NULL,'Malmquist cor.','UGC 02020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25480,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25480,34.24,0.43,70.5,6638,75,NULL,'MAT, I, cor','UGC 02020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25481,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25481,34.28,0.2,71.8,6638,74.4,NULL,NULL,'UGC 02020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25482,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25482,34.39,0.38,75.5,6638,75,NULL,'W91PP, r, raw','UGC 02020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25483,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25483,34.39,0.38,75.6,6638,75,NULL,'W91PP, r, inv','UGC 02020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25484,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25484,34.41,0.48,76.2,6638,NULL,NULL,NULL,'UGC 02020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25485,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25485,34.55,0.38,81.1,6638,75,NULL,'W91PP, r, cor','UGC 02020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25486,'Tully est','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25486,29.97,0.8,9.9,6639,75,NULL,NULL,'UGC 02014',NULL,'1988NBGC.C....0000T',1988,1,2,NULL,'G',0.00002,NULL,'15.65',0.6,'Im:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,38.225,38.68058,0.173,NULL,68655006951,1072734483,16761476,15.65),(25487,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25487,36.77,0.52,226,6640,70,NULL,NULL,'IC 0236',NULL,'2014MNRAS.445.2677S',2014,1,0.71,NULL,'G',0.000106,NULL,'15.5g',0.4,'S0',NULL,NULL,NULL,NULL,1,38.2325416667,-0.13125,0.041,NULL,34922256836,545660263,8525941,15.5),(25488,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25488,38.05,0.46,407,6641,70,NULL,NULL,'SDSS J023258.98+000426.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000074,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,38.24575,0.07394,0.017,NULL,66878732418,1044980194,16327815,18.1),(25489,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25489,38.34,0.46,465,6642,70,NULL,NULL,'SDSS J023259.58-001915.7',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000069,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,38.2482917,-0.32106,0.041,NULL,34922290800,545660793,8525949,17.8),(25490,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1976J',NULL,25490,33.57,0.3,51.8,6643,60,NULL,'M(B) = -19.48 mag','NGC 0977',NULL,'2000ApJ...540..634P',2000,1,1.9,NULL,'G',0.000037,NULL,'13.5',1.6,'(R\')SAB(r)a:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,38.2642917,-10.75997,0.013,NULL,37869731126,591714548,9245539,13.5),(25491,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1976J',NULL,25491,33.57,0.3,51.8,6643,60,NULL,'M(V) = -19.47 mag','NGC 0977',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25492,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1976J','R',25492,34.2,NULL,69.2,6643,NULL,NULL,'Photographic','NGC 0977',NULL,'1988SSRv...48....1R',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25493,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25493,33.93,0.51,61.2,6643,70,NULL,NULL,'NGC 0977',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25494,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25494,34.04,0.4,64.2,6643,NULL,NULL,'mean','NGC 0977',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25495,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25495,34.43,0.47,77,6643,NULL,NULL,'H','NGC 0977',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25496,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25496,34.46,0.45,77.9,6643,NULL,NULL,'K','NGC 0977',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25497,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25497,34.5,0.46,79.5,6643,NULL,NULL,'J','NGC 0977',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25498,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 02311','RN',25498,42.38,0.21,2320,6644,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02311',0.28903,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25499,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 02311','RN',25499,42.42,0.13,2360,6644,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 02311',0.28903,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25500,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25500,35.73,0.46,140,6645,70,NULL,NULL,'2MASX J02331076-0748131',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000096,NULL,'16.6g',0.24,'BLAGN',NULL,NULL,NULL,'Sy 1',1,38.2949583,-7.80372,0.077,NULL,34937031300,545891114,8529548,16.6),(25501,'IRAS','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25501,35.91,0.8,152,6646,75,NULL,'W91PP, r','UGC 02025',NULL,'1997ApJS..109..333W',1997,1,1.42,NULL,'G',0.000044,NULL,'15.65',0.16,'Sbc',NULL,NULL,NULL,NULL,1,38.309667,25.50611,0.241,NULL,68612031141,1072062986,16750984,15.65),(25502,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25502,35.48,0.49,125,6646,75,NULL,'IR','UGC 02025',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25503,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25503,35.54,NULL,128,6646,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25504,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25504,35.56,NULL,129,6646,NULL,NULL,'Dipole + Quadrupole','UGC 02025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25505,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25505,35.57,NULL,130,6646,NULL,NULL,'Dipole','UGC 02025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25506,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25506,35.61,0.38,133,6646,75,NULL,'W91PP, r, raw','UGC 02025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25507,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25507,35.63,NULL,134,6646,NULL,NULL,NULL,'UGC 02025',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25508,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25508,35.82,0.38,146,6646,75,NULL,'W91PP, r, cor','UGC 02025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25509,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25509,35.83,0.38,147,6646,75,NULL,'W91PP, r, inv','UGC 02025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25510,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25510,33.1,0.2,41.7,6647,74.4,NULL,NULL,'KUG 0230-119',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.000017,NULL,'14',1,'SB(s)cd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,38.3161666667,-11.74489,0.005,NULL,37870070165,591719846,9245622,14),(25511,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25511,33.31,0.72,46,6647,NULL,NULL,NULL,'KUG 0230-119',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25512,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25512,33.74,0.59,56,6647,NULL,NULL,'Malmquist cor.','KUG 0230-119',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25513,'IRAS','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25513,34.29,0.8,72,6648,75,NULL,'W91PP, r','UGC 02028',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000067,NULL,'14.48',0.6,'Scd:',NULL,NULL,NULL,NULL,1,38.32575,22.39383,0.413,NULL,68087420949,1063865952,16622905,14.48),(25514,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25514,34,0.35,63.2,6648,NULL,NULL,'Malmquist cor.','UGC 02028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25515,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25515,34.29,0.2,72.1,6648,74.4,NULL,NULL,'UGC 02028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25516,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25516,34.31,0.31,72.6,6648,NULL,NULL,NULL,'UGC 02028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25517,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25517,34.39,0.4,75.4,6648,NULL,NULL,'mean','UGC 02028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25518,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25518,34.46,0.38,78,6648,75,NULL,'W91PP, r, raw','UGC 02028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25519,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25519,34.5,0.47,79.4,6648,NULL,NULL,'H','UGC 02028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25520,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25520,34.52,0.46,80.2,6648,NULL,NULL,'J','UGC 02028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25521,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25521,34.55,0.45,81.2,6648,NULL,NULL,'K','UGC 02028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25522,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25522,34.64,0.38,84.6,6648,75,NULL,'W91PP, r, inv','UGC 02028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25523,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25523,34.66,0.38,85.5,6648,75,NULL,'W91PP, r, cor','UGC 02028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25524,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25524,30.02,0.4,10.1,6649,75,NULL,'B','UGC 02023',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000003,NULL,'13.90',1.7,'Im:','Group member',NULL,NULL,NULL,1,38.325833,33.49111,0.341,NULL,68628022378,1072312849,16754888,13.9),(25525,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25525,36.19,0.53,173,6650,70,NULL,NULL,'2MASX J02331836-1736445',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.000103,NULL,'17.10',0.31,NULL,NULL,NULL,NULL,NULL,1,38.326625,-17.61225,0.047,NULL,37962623419,593165990,9268218,17.1),(25526,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25526,33.74,0.2,56,6651,74.4,NULL,NULL,'UGC 02032',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000017,NULL,'16.5',0.2,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,38.351667,20.57889,0.297,NULL,68100580466,1064071569,16626118,16.5),(25527,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 21351',NULL,25527,40.52,1.07,1270,6652,70,NULL,'SN photometric redshift distance, z photo =0.358 +/- 0.342','SDSS-II SN 21351',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,38.354583,-1.08,0.049,NULL,34922518373,545664349,8526005,NULL),(25528,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 21015','R',25528,41.05,0.3,1220,6653,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21015',0.329251,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,38.3702917,-0.98158,0.041,NULL,34922557226,545664956,8526014,NULL),(25529,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 21015','R',25529,41.08,0.25,1240,6653,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 21015',0.329251,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25530,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 21015',NULL,25530,40.68,0.23,1370,6653,70,NULL,'SN photometric redshift distance, z photo =0.392 +/- 0.057','SDSS-II SN 21015',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25531,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 21015',NULL,25531,40.92,0.18,1530,6653,70,NULL,'SALT 2','SDSS-II SN 21015',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25532,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 21015',NULL,25532,40.96,0.18,1560,6653,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 21015',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25533,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25533,34.45,0.6,77.5,6654,NULL,NULL,NULL,'CGCG 414-019',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000123,NULL,'15.2',0.4,NULL,NULL,NULL,NULL,NULL,1,38.379375,6.52781,0.209,NULL,66868682379,1044823162,16325361,15.2),(25534,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25534,34.64,0.2,84.7,6654,74.4,NULL,NULL,'CGCG 414-019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25535,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25535,34.67,0.54,86.1,6654,NULL,NULL,'Malmquist cor.','CGCG 414-019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25536,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 06308','RN',25536,38.85,0.09,576,6655,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06308',0.020877,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25537,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 06308','RN',25537,39.54,0.28,793,6655,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06308',0.020877,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25538,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25538,35.59,0.46,131,6656,70,NULL,NULL,'ESO 545- G 034',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000103,NULL,'14.82',0.6,'S0','Pair member (points to parent)',NULL,NULL,NULL,1,38.3840417,-20.18217,0.036,NULL,37970433026,593288016,9270125,14.82),(25539,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 05999','RN',25539,41.71,0.24,1860,6657,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 05999',0.183893,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25540,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 05999','RN',25540,41.86,0.19,1990,6657,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 05999',0.183893,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25541,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25541,30.22,NULL,11.1,6658,NULL,NULL,'B','NGC 0986',NULL,'2002ApJ...565..681R',2002,1,3.9,NULL,'G',0.000019,NULL,'12.00',3,'(R\'_1)SB(rs)b  HII',NULL,NULL,NULL,NULL,1,38.393125,-39.04506,NULL,NULL,38622655460,603478991,9429359,12),(25542,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25542,31.83,0.4,23.2,6658,75,NULL,'B','NGC 0986',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25543,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25543,37.64,0.46,338,6659,70,NULL,NULL,'2MASX J02333508+0057436',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000096,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,38.396333,0.96228,0.021,NULL,66878690905,1044979545,16327805,16.7),(25544,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 05946','RN',25544,40.95,0.19,1130,6660,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05946',0.367505,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25545,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25545,35.71,0.57,139,6661,NULL,NULL,'Malmquist cor.','CGCG 505-007',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000033,NULL,'15.51',0.4,'Sc',NULL,NULL,NULL,NULL,1,38.40525,32.53733,0.305,NULL,68635999005,1072437484,16756835,15.51),(25546,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25546,35.85,0.53,148,6661,NULL,NULL,NULL,'CGCG 505-007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25547,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25547,35.89,0.2,151,6661,74.4,NULL,NULL,'CGCG 505-007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25548,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25548,34.94,0.49,97.4,6662,75,NULL,'IR','UGC 02037',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',NULL,NULL,'15.39',0.3,'S?',NULL,NULL,NULL,NULL,1,38.411333,6.47331,0.209,NULL,66868650617,1044822665,16325354,15.39),(25549,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25549,35.11,0.3,105,6662,NULL,NULL,'Malmquist cor.','UGC 02037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25550,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25550,35.12,0.3,106,6662,NULL,NULL,NULL,'UGC 02037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25551,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25551,35.16,0.2,108,6662,74.4,NULL,NULL,'UGC 02037',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25552,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25552,30.04,0.4,10.2,6663,75,NULL,'B','UGC 02034',NULL,'1988NBGC.C....0000T',1988,1,2.5,NULL,'G',0.000003,NULL,'13.7',2,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,38.429,40.52811,0.185,NULL,68536186378,1070877912,16732467,13.7),(25553,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25553,34.65,0.47,85.1,6664,70,NULL,NULL,'NGC 0989',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.000107,NULL,'15.1b',0.25,'(R\':)SAB0o:',NULL,NULL,NULL,NULL,1,38.441875,-16.51117,0.046,NULL,37960393490,593131148,9267674,15.1),(25554,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kt',NULL,25554,42.1,0.28,1630,6665,74.2,NULL,'SALT 2','ESSENCE J023347.01-083622.1',0.61,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,38.445875,-8.60614,0.057,NULL,34936608454,545884507,8529445,NULL),(25555,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kt',NULL,25555,42.15,0.31,1670,6665,65,NULL,'SN e138, SALT2','ESSENCE J023347.01-083622.1',0.61,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25556,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kt',NULL,25556,42.21,0.84,1720,6665,65,NULL,'SN e138, SALT','ESSENCE J023347.01-083622.1',0.61,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25557,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kt',NULL,25557,42.26,0.82,1760,6665,70,NULL,'SN e138, SALT','ESSENCE J023347.01-083622.1',0.61,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25558,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kt','R',25558,42.7,NULL,2150,6665,65,NULL,'SN e138, SALT2','ESSENCE J023347.01-083622.1',0.61,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25559,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kt',NULL,25559,42.82,0.24,2280,6665,65,NULL,'SN e138, SALT2','ESSENCE J023347.01-083622.1',0.61,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25560,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kt',NULL,25560,42.87,0.24,2330,6665,65,NULL,'SN e138, MLCS2k2','ESSENCE J023347.01-083622.1',0.61,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25561,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kt',NULL,25561,42.9,0.2,2360,6665,65,NULL,'SN e138, MLCS17','ESSENCE J023347.01-083622.1',0.61,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25562,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kt',NULL,25562,42.97,0.17,2440,6665,65,NULL,'SN e138, MLCS31','ESSENCE J023347.01-083622.1',0.61,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25563,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kt',NULL,25563,42.99,0.16,2460,6665,65,NULL,'SN e138, MLCS2k2','ESSENCE J023347.01-083622.1',0.61,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25564,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003kt',NULL,25564,43.24,0.09,2760,6665,65,NULL,'SN e138, SALT','ESSENCE J023347.01-083622.1',0.61,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25565,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25565,37.34,0.6,294,6666,70,NULL,NULL,'2MASX J02334766-5903535',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.000083,NULL,'15.79',0.55,'SAB(r)ab',NULL,NULL,NULL,NULL,1,38.4485417,-59.06497,0.049,NULL,36243087526,566298242,8848410,15.79),(25566,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25566,35.23,0.23,111,6667,70,NULL,NULL,'CGCG 388-052',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000083,NULL,'15.2g',0.39,'BLAGN',NULL,NULL,NULL,'Sy 1',1,38.465125,1.13714,0.021,NULL,66878666815,1044979168,16327799,15.2),(25567,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2005gv',NULL,25567,40.67,0.17,1000,6668,74.2,NULL,'SALT 2','SDSS J023354.19+001651.2',0.36,'2010ApJ...716..712A',2010,1,0.07,NULL,'G',0.005,NULL,'22.3g',0.05,NULL,NULL,NULL,NULL,NULL,1,38.4757916667,0.28089,0.017,NULL,66879068372,1044985443,16327897,22.3),(25568,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2005gv',NULL,25568,40.43,0.17,1220,6668,70,NULL,'Hubble residual -0.11 for z0.36300','SDSS J023354.19+001651.2',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25569,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2005gv',NULL,25569,41.36,0.17,1370,6668,65,NULL,'SALT2','SDSS J023354.19+001651.2',0.36,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25570,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2005gv',NULL,25570,41.4,0.19,1400,6668,70,NULL,'SALT 2','SDSS J023354.19+001651.2',0.36,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25571,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 04577','R',25571,41.46,0.28,1440,6668,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2005gv','SDSS J023354.19+001651.2',0.363,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25572,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 04577','R',25572,41.57,0.22,1510,6668,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2005gv','SDSS J023354.19+001651.2',0.363,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25573,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2005gv',NULL,25573,41.68,0.16,1590,6668,65,NULL,'MLCS2k2','SDSS J023354.19+001651.2',0.36,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25574,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999ff',NULL,25574,41.61,0.23,1440,6669,74.2,NULL,'SALT 2','H-ZSNS J023354.39+003255.6',0.46,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,38.476625,0.54878,0.017,NULL,66879212865,1044987701,16327932,NULL),(25575,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999ff','R',25575,41.83,NULL,1590,6669,65,NULL,'SALT','H-ZSNS J023354.39+003255.6',0.46,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25576,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999ff',NULL,25576,42.29,0.28,1970,6669,65,NULL,NULL,'H-ZSNS J023354.39+003255.6',0.46,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25577,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999ff',NULL,25577,42.35,0.24,2020,6669,70,NULL,'SALT','H-ZSNS J023354.39+003255.6',0.46,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25578,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999ff',NULL,25578,42.35,0.43,2020,6669,65,NULL,'dm15','H-ZSNS J023354.39+003255.6',0.46,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25579,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999ff',NULL,25579,42.38,0.29,2050,6669,65,NULL,'MLCS','H-ZSNS J023354.39+003255.6',0.46,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25580,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999ff',NULL,25580,42.49,0.3,2160,6669,65,NULL,'Final','H-ZSNS J023354.39+003255.6',0.46,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25581,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999ff',NULL,25581,42.5,0.25,2170,6669,65,NULL,'SALT','H-ZSNS J023354.39+003255.6',0.46,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25582,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999ff',NULL,25582,42.6,0.22,2270,6669,65,NULL,'delta m15','H-ZSNS J023354.39+003255.6',0.46,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25583,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999ff',NULL,25583,42.61,0.32,2280,6669,65,NULL,'BATM','H-ZSNS J023354.39+003255.6',0.46,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25584,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25584,33.63,0.49,53.2,6670,NULL,NULL,'Malmquist cor.','UGC 02044',NULL,'2009ApJS..182..474S',2009,1,0.79,NULL,'G',0.000056,NULL,'15.6g',0.51,'SB(s)cd:',NULL,NULL,NULL,NULL,1,38.484583,0.92369,0.017,NULL,66878643544,1044978805,16327793,15.6),(25585,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25585,33.64,0.49,53.6,6670,NULL,NULL,NULL,'UGC 02044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25586,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25586,33.68,0.2,54.5,6670,74.4,NULL,NULL,'UGC 02044',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25587,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 01573','RN',25587,42.32,0.19,1950,6671,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01573',0.493158,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25588,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25588,34.01,0.43,63.4,6672,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02035',NULL,'2014MNRAS.444..527S',2014,1,1.7,NULL,'G',0.000037,NULL,'13.9',1.1,'Sb',NULL,NULL,NULL,NULL,1,38.4935417,44.34447,0.441,NULL,68546622829,1071040981,16735015,13.9),(25589,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25589,34.11,0.43,66.3,6672,75,NULL,'3.6 micron, color corrected','UGC 02035',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25590,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25590,34.19,0.4,68.8,6672,NULL,NULL,'mean','UGC 02035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25591,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25591,34.25,0.2,70.8,6672,74.4,NULL,NULL,'UGC 02035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25592,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25592,34.38,0.47,75.1,6672,NULL,NULL,'H','UGC 02035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25593,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25593,34.4,0.45,75.7,6672,NULL,NULL,'K','UGC 02035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25594,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25594,34.46,0.46,78,6672,NULL,NULL,'J','UGC 02035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25595,'SGRB','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25595,38.41,0.48,480,6673,NULL,NULL,NULL,'GRB 000607',NULL,'2006ApJ...640..849N',2006,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Ulysses/Ko/NE',NULL,NULL,NULL,NULL,1,38.494583,17.1475,0.441,NULL,68072959292,1063639988,16619374,NULL),(25596,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 04716','RN',25596,42.99,0.21,2560,6674,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04716',0.545469,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25597,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999dq',NULL,25597,32.74,0.26,34.8,6675,74.2,NULL,'SALT 2','NGC 0976',0.01433,'2010ApJ...716..712A',2010,1,1.5,NULL,'G',0.000017,NULL,'12.6B',1.2,'SA(rs)c:','in a radial-velocity based grouping',NULL,NULL,NULL,1,38.500083,20.97678,0.377,NULL,68100674670,1064073041,16626141,12.6),(25598,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999dq',NULL,25598,33.31,0.08,45.9,6675,74.4,NULL,NULL,'NGC 0976',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25599,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999dq',NULL,25599,33.39,0.02,47,6675,72,NULL,NULL,'NGC 0976',0.01433,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25600,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999dq',NULL,25600,33.44,0.21,48,6675,70,NULL,'SALT 2','NGC 0976',0.01433,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25601,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999dq',NULL,25601,33.48,0.2,48.9,6675,73.8,NULL,'SALT 2 (SNANA)','NGC 0976',0.0135,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25602,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999dq',NULL,25602,33.5,0.31,49.4,6675,70,NULL,'SALT','NGC 0976',0.01433,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25603,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999dq',NULL,25603,33.53,0.26,50.1,6675,65,NULL,'SALT2','NGC 0976',0.01433,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25604,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999dq',NULL,25604,33.53,0.22,50.1,6675,72,NULL,NULL,'NGC 0976',0.01433,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25605,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999dq',NULL,25605,33.67,0.07,52.6,6675,65,NULL,'MLCS2k2','NGC 0976',0.01433,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25606,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999dq',NULL,25606,33.66,0.23,53.2,6675,65,NULL,'MLCS31','NGC 0976',0.01433,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25607,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999dq',NULL,25607,33.71,0.23,54.3,6675,65,NULL,'MLCS17','NGC 0976',0.01433,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25608,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999dq',NULL,25608,33.71,0.04,54.5,6675,70,NULL,'SALT 2','NGC 0976',0.01433,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25609,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999dq',NULL,25609,33.73,0.26,54.9,6675,65,NULL,NULL,'NGC 0976',0.01433,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25610,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999dq',NULL,25610,33.77,0.3,56.8,6675,60,NULL,NULL,'NGC 0976',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25611,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1999dq',NULL,25611,33.82,0.17,58.1,6675,70.8,NULL,NULL,'NGC 0976',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25612,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25612,33.31,0.08,45.9,6675,74.4,NULL,NULL,'NGC 0976',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25613,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25613,38.18,0.46,433,6676,70,NULL,NULL,'2MASX J02340521-0017054',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00008,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,38.521625,-0.28483,0.033,NULL,34922719968,545667499,8526054,18.2),(25614,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25614,37.41,0.46,303,6677,70,NULL,NULL,'2MASX J02340587+0107178',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,38.5245417,1.12164,0.021,NULL,66878653184,1044978956,16327796,18.3),(25615,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25615,37.15,0.7,269,6678,70,NULL,NULL,'2MASX J02340791-1353512',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'16.91',0.19,NULL,NULL,NULL,NULL,NULL,1,38.5330416667,-13.89747,0,NULL,38085666475,595088538,9298258,16.91),(25616,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25616,37.6,0.69,330,6679,70,NULL,NULL,'2MASX J02341044-0308584',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'17.05',0.23,NULL,NULL,NULL,NULL,NULL,1,38.5434583,-3.14953,0.041,NULL,34963195004,546299921,8535936,17.05),(25617,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25617,36.6,0.46,209,6680,70,NULL,NULL,'2MASX J02341054-0000064',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000072,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,38.544,-0.00178,0.013,NULL,34922174730,545658980,8525921,16.6),(25618,'IRAS','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25618,31.48,0.8,19.8,6681,75,NULL,'W91PP, r','NGC 0972',NULL,'1997ApJS..109..333W',1997,1,3.3,'The 2MASS Extended Source position is 11 arcsec northwest of the nucleus.','G',0.00002,NULL,'12.27',1.7,'Sab            HII',NULL,NULL,NULL,NULL,1,38.55575,29.31128,0.349,NULL,68608262144,1072004096,16750064,12.27),(25619,'Tully est','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25619,31.65,0.8,21.4,6681,75,NULL,'B','NGC 0972',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25620,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25620,30.62,0.43,13.3,6681,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0972',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25621,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25621,30.81,0.43,14.5,6681,75,NULL,'3.6 micron, color corrected','NGC 0972',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25622,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25622,30.94,0.45,15.4,6681,NULL,NULL,'K','NGC 0972',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25623,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25623,30.95,0.37,15.5,6681,NULL,NULL,NULL,'NGC 0972',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25624,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25624,30.95,0.4,15.5,6681,73,NULL,'opt','NGC 0972',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25625,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25625,30.99,0.2,15.8,6681,74.4,NULL,NULL,'NGC 0972',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25626,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25626,31.02,0.47,16,6681,NULL,NULL,'H','NGC 0972',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25627,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25627,31.07,0.46,16.4,6681,NULL,NULL,'J','NGC 0972',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25628,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25628,31.17,0.38,17.1,6681,75,NULL,'W91PP, r, raw','NGC 0972',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25629,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25629,31.27,0.38,17.9,6681,75,NULL,'W91PP, r, inv','NGC 0972',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25630,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25630,31.32,0.38,18.4,6681,75,NULL,'W91PP, r, cor','NGC 0972',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25631,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25631,31.34,0.4,18.6,6681,NULL,NULL,'mean','NGC 0972',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25632,'IRAS','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25632,33.89,0.8,60,6682,75,NULL,'W91PP, r','NGC 0973',NULL,'1997ApJS..109..333W',1997,1,4.03,'Right Ascension in 1993AN....314...97K is incorrect.','G',0.000027,NULL,'13.55',0.47,'Sbc        Sy2/LINER','in a pair',NULL,NULL,NULL,1,38.5837917,32.50561,0.305,NULL,68636510540,1072445477,16756960,13.55),(25633,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25633,33.52,0.47,50.6,6682,NULL,NULL,'H','NGC 0973',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25634,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25634,33.53,0.45,50.7,6682,NULL,NULL,'K','NGC 0973',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25635,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25635,33.57,0.49,51.8,6682,75,NULL,'IR','NGC 0973',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25636,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25636,33.58,0.46,51.9,6682,NULL,NULL,'J','NGC 0973',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25637,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25637,33.83,NULL,58.5,6682,NULL,NULL,'Dipole','NGC 0973',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25638,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25638,33.83,NULL,58.5,6682,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 0973',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25639,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25639,33.84,NULL,58.5,6682,NULL,NULL,'Dipole + Quadrupole','NGC 0973',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25640,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25640,33.87,0.38,59.4,6682,75,NULL,'W91PP, r, raw','NGC 0973',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25641,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25641,33.91,0.34,60.5,6682,NULL,NULL,NULL,'NGC 0973',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25642,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25642,33.92,NULL,60.7,6682,NULL,NULL,NULL,'NGC 0973',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25643,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25643,33.95,0.2,61.7,6682,74.4,NULL,NULL,'NGC 0973',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25644,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25644,33.99,0.43,62.8,6682,75,NULL,'3.6 micron, color corrected','NGC 0973',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25645,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25645,34,0.43,63.1,6682,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0973',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25646,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25646,34.01,0.38,63.3,6682,75,NULL,'W91PP, r, cor','NGC 0973',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25647,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25647,34.05,0.31,64.7,6682,NULL,NULL,'Malmquist cor.','NGC 0973',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25648,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25648,34.07,0.4,65.1,6682,NULL,NULL,'mean','NGC 0973',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25649,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25649,34.16,0.38,67.9,6682,75,NULL,'W91PP, r, inv','NGC 0973',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25650,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 04578',NULL,25650,40.52,0.23,1270,6683,70,NULL,'SN photometric redshift distance, z photo =0.358 +/- 0.050','SDSS-II SN 04578',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,38.596583,0.31128,0.017,NULL,66879082420,1044985662,16327900,NULL),(25651,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 04578','R',25651,41.73,0.27,1570,6683,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 04578',0.413618,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25652,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 04578','R',25652,42.05,0.27,1820,6683,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 04578',0.413618,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25653,'IRAS','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25653,33.92,0.8,60.8,6684,75,NULL,'MAT, I','MCG -02-07-033',NULL,'1997ApJS..109..333W',1997,1,2.9,NULL,'G',0.000013,NULL,'14.07',1,'SBbc?          HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,38.602125,-10.84372,0,NULL,37869393523,591709273,9245457,14.07),(25654,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25654,33.92,0.43,60.8,6684,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-07-033',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25655,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25655,33.97,0.47,62.2,6684,NULL,NULL,'H','MCG -02-07-033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25656,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25656,33.98,0.32,62.6,6684,85,NULL,'I, raw','MCG -02-07-033',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25657,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25657,33.99,0.43,62.7,6684,75,NULL,'MAT, I, raw','MCG -02-07-033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25658,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25658,34,0.45,63.2,6684,NULL,NULL,'K','MCG -02-07-033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25659,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25659,34.01,0.43,63.5,6684,75,NULL,'3.6 micron, color corrected','MCG -02-07-033',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25660,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25660,34.03,0.32,64.1,6684,85,NULL,'I, inv','MCG -02-07-033',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25661,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25661,34.04,0.46,64.3,6684,NULL,NULL,'J','MCG -02-07-033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25662,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25662,34.11,0.4,66.4,6684,NULL,NULL,'mean','MCG -02-07-033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25663,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25663,34.13,0.43,67.1,6684,75,NULL,'MAT, I, cor','MCG -02-07-033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25664,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25664,34.15,0.28,67.8,6684,NULL,NULL,'Malmquist cor.','MCG -02-07-033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25665,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25665,34.18,0.2,68.6,6684,74.4,NULL,NULL,'MCG -02-07-033',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25666,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25666,34.23,0.43,70,6684,75,NULL,'MAT, I, inv','MCG -02-07-033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25667,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25667,34.24,0.27,70.5,6684,NULL,NULL,NULL,'MCG -02-07-033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25668,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25668,34.15,0.5,67.7,6685,70,NULL,NULL,'MCG -02-07-034',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000087,NULL,'14.4b',0.6,NULL,NULL,NULL,NULL,NULL,1,38.607917,-14.27164,0.005,NULL,38085673212,595088643,9298260,14.4),(25669,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25669,34.44,0.33,77.2,6686,NULL,NULL,'Malmquist cor.','2MFGC 02027',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',NULL,NULL,'12.0K',0.2,NULL,NULL,NULL,NULL,NULL,1,38.6105416667,32.42358,0.305,NULL,68636522008,1072445656,16756963,12),(25670,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25670,34.65,0.3,85.3,6686,NULL,NULL,NULL,'2MFGC 02027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25671,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25671,34.69,0.2,86.7,6686,74.4,NULL,NULL,'2MFGC 02027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25672,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 16849','RN',25672,40.9,0.27,1300,6687,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16849',0.160322,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25673,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 16849','RN',25673,40.96,0.18,1340,6687,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16849',0.160322,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25674,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25674,30.89,0.4,15.1,6688,75,NULL,'B','UGC 02053',NULL,'1988NBGC.C....0000T',1988,1,2,NULL,'G',0.000017,NULL,'15.10',1,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,38.622125,29.74983,0.365,NULL,68608170671,1072002666,16750041,15.1),(25675,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25675,36.59,0.27,208,6689,70,NULL,NULL,'2MASX J02343116-0109024',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000085,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,38.629875,-1.15069,0.053,NULL,34955806740,546184480,8534132,17.2),(25676,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25676,36.59,0.27,208,6690,70,NULL,NULL,'2MASX J02343157-0108436',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.28',0.16,NULL,NULL,NULL,NULL,NULL,1,38.631583,-1.14542,0.053,NULL,34955806745,546184480,8534132,18.28),(25677,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 09676',NULL,25677,39.71,0.3,874,6691,70,NULL,'SN photometric redshift distance, z photo =0.230 +/- 0.039','SDSS-II SN 09676',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,38.632583,-0.60967,0.037,NULL,34922680029,545666875,8526044,NULL),(25678,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25678,37.79,0.46,362,6692,70,NULL,NULL,'2MASX J02343279-0016027',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000082,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,38.636625,-0.26728,0,NULL,34922756171,545668065,8526063,17.3),(25679,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25679,32.19,0.43,27.4,6693,75,NULL,'3.6 micron, color + selection bias corrected','KUG 0231+346',NULL,'2014MNRAS.444..527S',2014,1,0.7,NULL,'G',0.000017,NULL,'15.0',0.25,'Irr',NULL,NULL,NULL,NULL,1,38.6534583333,34.86944,0.129,NULL,68660003091,1072812548,16762696,15),(25680,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25680,32.65,0.43,34,6693,75,NULL,'3.6 micron, color corrected','KUG 0231+346',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25681,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25681,33.07,0.2,41.1,6693,74.4,NULL,NULL,'KUG 0231+346',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25682,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25682,33.5,0.4,50,6693,NULL,NULL,'mean','KUG 0231+346',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25683,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25683,33.57,0.47,51.7,6693,NULL,NULL,'H','KUG 0231+346',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25684,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25684,33.69,0.45,54.6,6693,NULL,NULL,'K','KUG 0231+346',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25685,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25685,36.1,0.56,166,6694,70,NULL,NULL,'UGC 02061',NULL,'2014MNRAS.445.2677S',2014,1,1.07,NULL,'G',0.000115,NULL,'15.8g',0.27,'Sa(f)          NLAGN',NULL,NULL,NULL,'Sy 2',1,38.65725,-0.97981,0.045,NULL,34922402479,545662538,8525977,15.8),(25686,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 07241','RN',25686,38.58,0.16,495,6695,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 07241',0.049248,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25687,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 07241','RN',25687,39.67,0.27,820,6695,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07241',0.049248,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25688,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25688,36.59,0.27,208,6696,70,NULL,NULL,'2MASX J02343877-0107557',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000096,NULL,'16.1g',0.32,'S0',NULL,NULL,NULL,NULL,1,38.661667,-1.13222,0.053,NULL,34955746241,546183535,8534117,16.1),(25689,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25689,36.82,0.52,231,6696,70,NULL,NULL,'2MASX J02343877-0107557',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25690,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25690,37.33,0.46,293,6697,70,NULL,NULL,'2MASX J02343935+0107086',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000069,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,38.664083,1.11903,0.017,NULL,66895586725,1045243542,16331930,18.2),(25691,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25691,35.57,0.46,130,6698,70,NULL,NULL,'2MASX J02344017+0031386',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000066,NULL,'16.1g',0.33,'S0',NULL,NULL,NULL,NULL,1,38.6675,0.52725,0.025,NULL,66879139649,1044986557,16327914,16.1),(25692,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 05976','RN',25692,42.02,0.39,2220,6699,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 05976',0.141257,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25693,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 05976','RN',25693,42.13,0.49,2340,6699,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 05976',0.141257,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25694,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25694,34.55,0.49,81.5,6700,70,NULL,NULL,'2MASX J02344144-0114187',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00008,NULL,'15.1g',0.47,'S0/a',NULL,NULL,NULL,NULL,1,38.6727083,-1.2385,0.053,NULL,34955846754,546185105,8534142,15.1),(25695,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 04579',NULL,25695,41.04,0.28,1620,6701,70,NULL,'SN photometric redshift distance, z photo =0.487 +/- 0.097','SDSS-II SN 04579',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,38.6747083,0.36411,0.013,NULL,66879046772,1044985105,16327892,NULL),(25696,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 04579',NULL,25696,41.87,0.27,2370,6701,70,NULL,'SALT 2','SDSS-II SN 04579',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25697,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 04579',NULL,25697,41.97,0.27,2480,6701,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 04579',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25698,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 00911','R',25698,40,0.25,828,6702,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 00911',0.207264,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,38.690667,-0.11572,0.009,NULL,34922702014,545667218,8526050,NULL),(25699,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 00911','R',25699,40.04,0.21,845,6702,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 00911',0.207264,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25700,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 15120',NULL,25700,40.63,0.39,1330,6703,70,NULL,'SN photometric redshift distance, z photo =0.380 +/- 0.098','SDSS-II SN 15120',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','23.2g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,38.693167,-0.99911,0.053,NULL,34955747894,546183560,8534118,23.2),(25701,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 15120','R',25701,42.52,0.31,2080,6703,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15120',0.534776,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25702,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25702,38.26,0.46,448,6704,70,NULL,NULL,'2MASX J02344932-0857272',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000069,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,38.705625,-8.95753,0.053,NULL,37875651662,591807057,9246985,17.9),(25703,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25703,37.1,0.46,263,6705,70,NULL,NULL,'2MASX J02345218+0002196',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000073,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,38.717375,0.03867,0.009,NULL,66878311673,1044973619,16327712,17.8),(25704,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25704,33.73,0.2,55.7,6706,74.4,NULL,NULL,'MCG -02-07-036',NULL,'2013AJ....146...86T',2013,1,1.9,NULL,'G',0.000037,NULL,'14.02',0.9,'SAB(rs)c:      HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,38.724333,-13.65831,0,NULL,38087598459,595118725,9298730,14.02),(25705,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25705,33.81,0.32,57.9,6706,NULL,NULL,NULL,'MCG -02-07-036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25706,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25706,33.98,0.47,62.6,6706,NULL,NULL,'H','MCG -02-07-036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25707,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25707,34.02,0.29,63.6,6706,NULL,NULL,'Malmquist cor.','MCG -02-07-036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25708,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25708,34.07,0.46,65.1,6706,NULL,NULL,'J','MCG -02-07-036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25709,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25709,34.09,0.4,65.7,6706,NULL,NULL,'mean','MCG -02-07-036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25710,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25710,34.11,0.45,66.3,6706,NULL,NULL,'K','MCG -02-07-036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25711,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25711,35.7,0.52,138,6707,70,NULL,NULL,'CGCG 388-056',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.000094,NULL,'15.3g',0.51,'Sa',NULL,NULL,NULL,NULL,1,38.728583,-0.79597,0.045,NULL,34922380285,545662191,8525971,15.3),(25712,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25712,37.86,0.46,374,6708,70,NULL,NULL,'2MASX J02345496-0842369',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000071,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,38.7289583,-8.71014,0.093,NULL,34936556351,545883692,8529432,17.8),(25713,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25713,37.5,0.46,316,6709,70,NULL,NULL,'2MASX J02345764-0920219',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000073,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,38.7402916667,-9.33933,0.057,NULL,37879859791,591872809,9248012,18.2),(25714,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25714,32.71,0.49,34.8,6710,75,NULL,'IR','UGC 02064',NULL,'2011yCatp016004901K',2011,1,2,NULL,'G',0.000013,NULL,'14.30',1.3,'SAB(s)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,38.792125,20.85147,0.369,NULL,68100414215,1064068972,16626077,14.3),(25715,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25715,32.98,0.2,39.5,6710,74.4,NULL,NULL,'UGC 02064',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25716,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25716,33.1,0.65,41.7,6710,NULL,NULL,NULL,'UGC 02064',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25717,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25717,33.39,0.57,47.6,6710,NULL,NULL,'Malmquist cor.','UGC 02064',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25718,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25718,33.84,0.4,58.7,6710,NULL,NULL,'mean','UGC 02064',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25719,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25719,34.01,0.47,63.3,6710,NULL,NULL,'H','UGC 02064',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25720,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25720,34.14,0.46,67.4,6710,NULL,NULL,'J','UGC 02064',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25721,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25721,36.08,0.37,165,6711,NULL,NULL,'Malmquist cor.','2MFGC 02036',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',NULL,NULL,'11.7K',0.2,NULL,NULL,NULL,NULL,NULL,1,38.7919583,32.65228,0.305,NULL,68627340918,1072302201,16754721,11.7),(25722,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25722,36.32,0.33,184,6711,NULL,NULL,NULL,'2MFGC 02036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25723,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25723,35.76,0.46,142,6712,70,NULL,NULL,'2MASX J02352252-0006598',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000083,NULL,'15.6g',0.38,'E0',NULL,NULL,NULL,NULL,1,38.8439583,-0.11678,0,NULL,34921905014,545654765,8525855,15.6),(25724,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25724,34.04,0.45,64.4,6713,NULL,NULL,'K','IC 0238',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.00007,NULL,'13.79',0.9,'S0',NULL,NULL,NULL,NULL,1,38.8445,12.83772,0.281,NULL,68134039260,1064594363,16634286,13.79),(25725,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25725,34.55,0.4,81.4,6713,NULL,NULL,'mean','IC 0238',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25726,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25726,36.1,0.8,166,6714,70,NULL,NULL,'2MFGC 02039',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,38.851875,-10.12939,0.037,NULL,37869134048,591705219,9245394,14.8),(25727,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25727,35.52,0.2,127,6715,74.4,NULL,NULL,'UGC 02071',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000033,NULL,'15.18',0.6,'Sbc',NULL,NULL,NULL,NULL,1,38.852,19.94119,0.353,NULL,68102612434,1064103319,16626614,15.18),(25728,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25728,33.8,0.45,57.6,6716,NULL,NULL,'K','NGC 0982',NULL,'2007A&A...465...71T',2007,1,1.5,'Often incorrectly called NGC 0980.','G',0.000037,NULL,'13.40',0.6,'Sa','in a pair',NULL,NULL,NULL,1,38.853625,40.86972,0.201,NULL,68549797336,1071090583,16735790,13.4),(25729,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25729,33.85,0.47,59,6716,NULL,NULL,'H','NGC 0982',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25730,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25730,33.92,0.46,60.8,6716,NULL,NULL,'J','NGC 0982',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25731,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25731,34.42,0.4,76.6,6716,NULL,NULL,'mean','NGC 0982',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25732,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2005je',NULL,25732,37.57,0.12,299,6717,74.2,NULL,'SALT 2','2MASX J02352657+0104287',0.094,'2010ApJ...716..712A',2010,1,0.27,NULL,'G',0.000085,NULL,'17.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,38.86075,1.07453,0.021,NULL,66895574438,1045243350,16331927,17.4),(25733,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 06962','R',25733,38.22,0.18,403,6717,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2005je','2MASX J02352657+0104287',0.093988,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25734,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2005je',NULL,25734,38.03,0.07,404,6717,70,NULL,'SALT 2','2MASX J02352657+0104287',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25735,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2005je',NULL,25735,38.03,0.07,404,6717,70,NULL,'SALT 2, Malmquist cor.','2MASX J02352657+0104287',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25736,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2005je',NULL,25736,38.25,0.12,408,6717,70,NULL,'SALT 2','2MASX J02352657+0104287',0.094,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25737,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 06962','R',25737,38.37,0.06,431,6717,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2005je','2MASX J02352657+0104287',0.093988,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25738,'Sosies','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25738,31.02,0.23,16,6718,NULL,NULL,NULL,'NGC 0988',NULL,'2002A&A...393...57T',2002,1,4.6,'HD 1615 (V=7.1) superposed 52\\\" northwest of center.','G',0.000017,NULL,'11.50',2.5,'SB(s)cd:       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,38.865625,-9.35619,0.057,NULL,37880025233,591875394,9248053,11.5),(25739,'Tully est','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25739,31.32,0.8,18.3,6718,75,NULL,NULL,'NGC 0988',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25740,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25740,29.93,NULL,9.68,6718,NULL,NULL,'LEDA [April 2006]','NGC 0988',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25741,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 19833','R',25741,40.51,0.2,1030,6719,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19833',0.233698,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,38.8720416667,-1.17886,0.057,NULL,34955789020,546184203,8534128,NULL),(25742,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 19833','R',25742,40.52,0.12,1030,6719,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 19833',0.233698,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25743,'IRAS','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25743,33.17,0.8,43.1,6720,75,NULL,'W91PP, r','UGC 02067',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000013,NULL,'14.64',0.4,'Sab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,38.8725417,37.51892,0.153,NULL,68668167989,1072940124,16764689,14.64),(25744,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25744,32.7,0.38,34.7,6720,75,NULL,'W91PP, r, inv','UGC 02067',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25745,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25745,32.71,0.38,34.9,6720,75,NULL,'W91PP, r, raw','UGC 02067',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25746,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25746,33.12,0.38,42,6720,75,NULL,'W91PP, r, cor','UGC 02067',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25747,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25747,29.82,0.49,9.21,6721,75,NULL,'IR','2MFGC 02043',NULL,'2011yCatp016004901K',2011,1,NULL,'This is a part of the galaxy NGC 0991.','PofG',0.00015,NULL,NULL,NULL,'HII',NULL,NULL,NULL,NULL,1,38.883375,-7.16017,0,NULL,34938497576,545914024,8529906,NULL),(25748,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25748,31.37,0.4,18.8,6722,75,NULL,'B','NGC 0991',NULL,'1988NBGC.C....0000T',1988,1,1.91,NULL,'G',0.000003,NULL,'13.5g',1.63,'SAB(rs)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,38.886167,-7.15444,0,NULL,34938497686,545914026,8529906,13.5),(25749,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25749,34.94,0.63,97.5,6723,70,NULL,NULL,'2MASX J02353437-0603496',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'16.29',0.36,NULL,NULL,NULL,NULL,NULL,1,38.893083,-6.06394,0.045,NULL,34953711271,546151738,8533620,16.29),(25750,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 1961P','R',25750,33.47,NULL,49.4,6724,NULL,NULL,'Photographic','UGC 02069',NULL,'1988SSRv...48....1R',1988,1,2.3,'The UZC redshift is for KPG 072B, a superposed star.','G',0.00002,NULL,'13.03',1.4,'SAB(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,38.905625,37.63919,0.153,NULL,68668220597,1072940946,16764702,13.03),(25751,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25751,32.68,0.69,34.4,6724,100,NULL,'mid-IR','UGC 02069',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25752,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25752,32.82,0.2,36.6,6724,74.4,NULL,NULL,'UGC 02069',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25753,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25753,33.53,0.4,50.7,6724,NULL,NULL,'mean','UGC 02069',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25754,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25754,33.65,0.47,53.6,6724,NULL,NULL,'H','UGC 02069',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25755,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25755,33.68,0.46,54.3,6724,NULL,NULL,'J','UGC 02069',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25756,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25756,33.75,0.45,56.4,6724,NULL,NULL,'K','UGC 02069',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25757,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 04514','RN',25757,43.45,0.3,2940,6725,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04514',0.66363,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25758,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003ll',NULL,25758,42.03,0.39,1590,6726,74.2,NULL,'SALT 2','ESSENCE J023541.19-080629.6',0.6,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,38.921625,-8.10822,0.061,NULL,34937391979,545896749,8529636,NULL),(25759,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003ll',NULL,25759,42.08,0.52,1630,6726,65,NULL,'SN f216, MLCS','ESSENCE J023541.19-080629.6',0.6,'2005AJ....130.2453K',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25760,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003ll','R',25760,42.29,NULL,1800,6726,65,NULL,'SN f216, SALT2','ESSENCE J023541.19-080629.6',0.6,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25761,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003ll',NULL,25761,42.62,0.29,2090,6726,65,NULL,'SN f216, m15(B)','ESSENCE J023541.19-080629.6',0.6,'2005AJ....130.2453K',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25762,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003ll',NULL,25762,42.85,0.29,2320,6726,70,NULL,'SN f216, SALT','ESSENCE J023541.19-080629.6',0.6,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25763,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003ll',NULL,25763,42.97,0.39,2460,6726,65,NULL,'SN f216, SALT2','ESSENCE J023541.19-080629.6',0.6,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25764,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003ll',NULL,25764,43,0.19,2480,6726,65,NULL,'SN f216, SALT','ESSENCE J023541.19-080629.6',0.6,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25765,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003ll',NULL,25765,43.03,0.53,2520,6726,65,NULL,'SN f216, BATM','ESSENCE J023541.19-080629.6',0.6,'2005AJ....130.2453K',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25766,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003ll',NULL,25766,43.04,0.26,2530,6726,65,NULL,'SN f216, SALT','ESSENCE J023541.19-080629.6',0.6,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25767,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003ll',NULL,25767,43.19,0.29,2720,6726,65,NULL,'SN f216, MLCS17','ESSENCE J023541.19-080629.6',0.6,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25768,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003ll',NULL,25768,43.32,0.24,2880,6726,65,NULL,'SN f216, MLCS31','ESSENCE J023541.19-080629.6',0.6,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25769,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2003ll',NULL,25769,43.34,0.23,2910,6726,65,NULL,'SN f216, MLCS2k2','ESSENCE J023541.19-080629.6',0.6,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25770,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25770,34.58,0.2,82.4,6727,74.4,NULL,NULL,'UGC 02076',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',NULL,NULL,'16.0',0.6,'Sbc',NULL,NULL,NULL,NULL,1,38.931,11.46556,0.305,NULL,67951788785,1061746699,16589792,16),(25771,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25771,35.21,0.12,110,6727,NULL,NULL,NULL,'UGC 02076',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25772,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25772,33.84,0.52,58.6,6728,70,NULL,NULL,'MCG -02-07-041',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000043,NULL,'14.08',1.1,'(R\')SB(rs)0/a',NULL,NULL,NULL,NULL,1,38.93575,-13.65486,0,NULL,38087674606,595119915,9298748,14.08),(25773,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25773,37.34,0.46,294,6729,70,NULL,NULL,'2MASX J02354472-0011169',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000089,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,38.936333,-0.18817,0.029,NULL,34922010171,545656408,8525881,16.5),(25774,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25774,37.63,0.46,336,6730,70,NULL,NULL,'2MASX J02354657-0742076',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,38.944167,-7.70214,0.057,NULL,34936793824,545887403,8529490,17.4),(25775,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25775,34.67,0.63,85.9,6731,70,NULL,NULL,'ESO 030- GA017',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000113,NULL,'14.74',0.2,'S...',NULL,NULL,NULL,NULL,1,38.94925,-74.24194,0.097,NULL,35605221797,556331590,8692681,14.74),(25776,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 13510','RN',25776,42.68,0.39,2730,6732,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13510',0.254494,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25777,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 13510','RN',25777,42.76,0.38,2840,6732,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13510',0.254494,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25778,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25778,32.95,0.2,38.9,6733,74.4,NULL,NULL,'UGC 02081',NULL,'2013AJ....146...86T',2013,1,2.2,NULL,'G',0.00002,NULL,'15.2g',1.4,'SAB(s)cd',NULL,NULL,NULL,NULL,1,39.004,0.42022,0.037,NULL,66878289708,1044973276,16327707,15.2),(25779,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25779,33,0.43,39.7,6733,75,NULL,'3.6 micron, color corrected','UGC 02081',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25780,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25780,33.07,0.43,41.1,6733,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02081',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25781,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25781,33.14,0.56,42.5,6733,NULL,NULL,NULL,'UGC 02081',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25782,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25782,33.22,0.54,44,6733,NULL,NULL,'Malmquist cor.','UGC 02081',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25783,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 13703','R',25783,40.28,0.19,920,6734,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13703 HOST',0.2354,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,39.013625,1.25339,0.025,NULL,66895799313,1045246864,16331982,NULL),(25784,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 13703','R',25784,40.37,0.11,960,6734,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13703 HOST',0.2354,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25785,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 13703',NULL,25785,40.12,0.08,1060,6734,70,NULL,'SALT 2','SDSS-II SN 13703 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25786,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 13703',NULL,25786,40.14,0.08,1070,6734,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13703 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25787,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2005lu',NULL,25787,35.31,0.17,112,6735,74.2,NULL,'SALT 2','ESO 545- G 038',0.032009,'2010ApJ...716..712A',2010,1,1.2,NULL,'G',0.000037,NULL,'14.98',1,'S.../Irr?',NULL,NULL,NULL,NULL,1,39.015125,-17.26294,0.062,NULL,37962173176,593158955,9268108,14.98),(25788,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2005lu',NULL,25788,35.85,0.02,148,6735,72,NULL,NULL,'ESO 545- G 038',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25789,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2005lu',NULL,25789,35.98,0.16,152,6735,70,NULL,'SALT 2','ESO 545- G 038',0.032009,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25790,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2005lu',NULL,25790,35.98,0.04,152,6735,72,NULL,NULL,'ESO 545- G 038',0.032009,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25791,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2005lu',NULL,25791,36.05,0.1,152,6735,72,NULL,NULL,'ESO 545- G 038',0.03132,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25792,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SN 2005lu',NULL,25792,35.91,0.09,152,6735,74.4,NULL,NULL,'ESO 545- G 038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25793,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 13655','R',25793,40.53,0.25,1020,6736,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006hs','SN 2006hs',0.252,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,39.02025,-0.99417,0.057,NULL,34956337650,546192775,8534262,NULL),(25794,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 13655','R',25794,40.69,0.16,1100,6736,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006hs','SN 2006hs',0.252,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25795,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25795,34.87,0.1,94.4,6737,NULL,NULL,NULL,'UGC 02085',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000063,NULL,'15.38',0.4,'Scd:','Group member, peripheral',NULL,NULL,NULL,1,39.027875,1.55364,0.025,NULL,66898759540,1045293117,16332704,15.38),(25796,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25796,34.93,0.2,96.8,6737,74.4,NULL,NULL,'UGC 02085',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25797,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25797,36.83,0.46,232,6738,70,NULL,NULL,'2MASX J02360729-0014216',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000069,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,39.03025,-0.23925,0.029,NULL,34921995789,545656184,8525877,17.2),(25798,'IRAS','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25798,34.39,0.8,75.5,6739,75,NULL,'MAT, I','UGC 02079',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000027,NULL,'14.66',0.8,'SAB(s)c',NULL,NULL,NULL,NULL,1,39.040417,23.89911,0.397,NULL,68088793910,1063887404,16623240,14.66),(25799,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25799,33.39,0.32,47.6,6739,85,NULL,'I, raw','UGC 02079',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25800,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25800,33.4,0.32,47.9,6739,85,NULL,'I, inv','UGC 02079',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25801,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25801,33.46,0.2,49.2,6739,74.4,NULL,NULL,'UGC 02079',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25802,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25802,33.5,0.43,50.1,6739,75,NULL,'MAT, I, raw','UGC 02079',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25803,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25803,33.59,0.43,52.3,6739,75,NULL,'MAT, I, inv','UGC 02079',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25804,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25804,33.72,0.31,55.4,6739,NULL,NULL,NULL,'UGC 02079',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25805,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25805,33.84,0.43,58.7,6739,75,NULL,'MAT, I, cor','UGC 02079',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25806,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25806,33.86,0.29,59,6739,NULL,NULL,'Malmquist cor.','UGC 02079',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25807,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25807,35.99,0.33,158,6740,70,NULL,NULL,'MCG -02-07-042 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000075,NULL,'16.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,39.0484583333,-9.31744,0.041,NULL,37880030548,591875477,9248054,16.7),(25808,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25808,35.51,0.47,127,6741,70,NULL,NULL,'MCG -02-07-042',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.36',0.25,NULL,NULL,NULL,NULL,NULL,1,39.0559583,-9.30972,0.041,NULL,37880031199,591875487,9248054,15.36),(25809,'IRAS','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25809,30.2,0.8,11,6742,75,NULL,'A82, H','UGC 02082',NULL,'1997ApJS..109..333W',1997,1,5.94,NULL,'G',0.000003,NULL,'13.69',0.78,'Sc','Isolated galaxy',NULL,NULL,NULL,1,39.0672916667,25.42383,0.369,NULL,68612363814,1072068184,16751065,13.69),(25810,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25810,30.15,0.4,10.7,6742,75,NULL,'B','UGC 02082',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25811,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25811,30.34,0.4,11.7,6742,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','UGC 02082',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25812,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25812,30.42,0.47,12.1,6742,75,NULL,'A82, H, inv','UGC 02082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25813,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25813,30.53,0.47,12.8,6742,75,NULL,'A82, H, raw','UGC 02082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25814,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25814,30.56,NULL,12.9,6742,NULL,NULL,'Dipole','UGC 02082',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25815,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25815,30.56,NULL,13,6742,NULL,NULL,'Dipole + Quadrupole','UGC 02082',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25816,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25816,30.57,NULL,13,6742,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02082',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25817,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25817,30.64,0.2,13.4,6742,74.4,NULL,NULL,'UGC 02082',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25818,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25818,30.75,NULL,14.1,6742,NULL,NULL,NULL,'UGC 02082',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25819,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25819,30.79,0.47,14.4,6742,75,NULL,'A82, H, cor','UGC 02082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25820,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25820,30.79,0.43,14.4,6742,75,NULL,'3.6 micron, color corrected','UGC 02082',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25821,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25821,30.82,0.46,14.6,6742,NULL,NULL,NULL,'UGC 02082',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25822,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25822,30.82,0.43,14.6,6742,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02082',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25823,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25823,30.83,0.35,14.7,6742,NULL,NULL,NULL,'UGC 02082',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25824,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25824,30.84,0.39,14.7,6742,73,NULL,'opt','UGC 02082',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25825,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25825,31.27,0.37,17.9,6742,NULL,NULL,'Malmquist cor.','UGC 02082',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25826,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25826,37.36,0.46,296,6743,70,NULL,NULL,'2MASX J02361789-0044156',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000084,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,39.0744583,-0.73772,0.053,NULL,34955421009,546178453,8534038,17.5),(25827,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25827,33.14,0.45,42.4,6744,NULL,NULL,'K','NGC 0990',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.00007,NULL,'13.48',1.5,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,39.075875,11.64208,0.305,NULL,67950620208,1061728440,16589506,13.48),(25828,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25828,33.36,0.4,46.9,6744,NULL,NULL,'mean','NGC 0990',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25829,'FP','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25829,36.64,0.46,213,6745,70,NULL,NULL,'2MASX J02362100+0011150',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000078,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,39.087375,0.18744,0.029,NULL,66878227015,1044972297,16327692,17.2),(25830,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 15428','R',25830,41.44,0.16,1400,6746,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15428',0.383289,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,39.094167,1.04247,0.037,NULL,66896001737,1045250027,16332031,NULL),(25831,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 15428','R',25831,41.45,0.24,1410,6746,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15428',0.383289,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25832,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 15428',NULL,25832,41.34,0.13,1850,6746,70,NULL,'SALT 2','SDSS-II SN 15428',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25833,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 15428',NULL,25833,41.4,0.13,1910,6746,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15428',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25834,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:57','1','SDSS-II SN 15428',NULL,25834,41.49,0.04,1990,6746,70,NULL,'SN photometric redshift distance, z photo =0.652 +/- 0.019','SDSS-II SN 15428',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25835,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,'R',25835,34.74,0.49,88.9,6747,75,NULL,'IR','UGC 02091',NULL,'2011yCatp016004901K',2011,1,1.26,NULL,'G',0.00004,NULL,'15.1g',0.36,'Sc pec sp',NULL,NULL,NULL,NULL,1,39.098417,0.70853,0.033,NULL,66895134121,1045236470,16331819,15.1),(25836,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25836,34.79,0.2,90.8,6747,74.4,NULL,NULL,'UGC 02091',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25837,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25837,34.81,0.08,91.8,6747,NULL,NULL,NULL,'UGC 02091',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25838,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25838,33.98,0.2,62.5,6748,74.4,NULL,NULL,'ARK 087',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.00003,NULL,'14.90',0.3,NULL,NULL,NULL,NULL,NULL,1,39.0990833333,31.71142,0.309,NULL,68636456941,1072444639,16756947,14.9),(25839,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:57','1',NULL,NULL,25839,30.76,0.4,14.2,6749,75,NULL,'B','IC 0239',NULL,'1988NBGC.C....0000T',1988,1,4.6,NULL,'G',0.000017,NULL,'11.8B',4.2,'SAB(rs)cd     LINER2','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,39.116167,38.96992,0.229,NULL,68666939087,1072920923,16764389,11.8),(25840,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:58','1','SN 2005ju',NULL,25840,39.93,0.14,768,6750,74.2,NULL,'SALT 2','SDSS J023628.25+003042.6',0.26,'2010ApJ...716..712A',2010,1,0.12,NULL,'G',NULL,NULL,'19.7g',0.07,NULL,NULL,NULL,NULL,NULL,1,39.1177083,0.51183,0.037,NULL,66895108512,1045236070,16331813,19.7),(25841,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:58','1','SN 2005ju',NULL,25841,40.59,0.16,1040,6750,70,NULL,'SALT 2','SDSS J023628.25+003042.6',0.26,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25842,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:58','1','SDSS-II SN 08046','R',25842,40.61,0.22,1050,6750,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ju','SDSS J023628.25+003042.6',0.26,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25843,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:58','1','SN 2005ju',NULL,25843,40.64,0.12,1070,6750,65,NULL,'SALT2','SDSS J023628.25+003042.6',0.26,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25844,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:58','1','SN 2005ju',NULL,25844,40.67,NULL,1080,6750,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 08046, SN 2005ju','SDSS J023628.25+003042.6',0.26,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25845,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:58','1','SDSS-II SN 08046','R',25845,40.73,0.16,1110,6750,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ju','SDSS J023628.25+003042.6',0.26,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25846,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:58','1','SN 2005ju',NULL,25846,40.76,0.14,1130,6750,65,NULL,'MLCS2k2','SDSS J023628.25+003042.6',0.26,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25847,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:58','1','SN 2005ju',NULL,25847,41.02,0.04,1270,6750,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 08046, SN 2005ju','SDSS J023628.25+003042.6',0.26,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25848,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:58','1','SN 2005ju',NULL,25848,40.53,0.12,1280,6750,70,NULL,'SALT 2','SDSS J023628.25+003042.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25849,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:58','1','SN 2005ju',NULL,25849,40.55,0.12,1290,6750,70,NULL,'SALT 2, Malmquist cor.','SDSS J023628.25+003042.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25850,'IRAS','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25850,33.77,0.8,56.6,6751,75,NULL,'W91PP, r','UGC 02083',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'15.04',0.2,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,39.126125,32.71533,0.273,NULL,68627417976,1072303405,16754740,15.04),(25851,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25851,33.97,0.4,62.2,6751,NULL,NULL,'mean','UGC 02083',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25852,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,'R',25852,34.14,0.49,67.3,6751,75,NULL,'IR','UGC 02083',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25853,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25853,34.31,0.38,72.8,6751,75,NULL,'W91PP, r, raw','UGC 02083',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25854,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25854,34.33,0.47,73.4,6751,NULL,NULL,'H','UGC 02083',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25855,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25855,34.35,0.38,74.1,6751,75,NULL,'W91PP, r, cor','UGC 02083',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25856,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25856,34.35,0.46,74.3,6751,NULL,NULL,'J','UGC 02083',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25857,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25857,34.45,0.2,77.6,6751,74.4,NULL,NULL,'UGC 02083',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25858,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25858,34.46,0.32,77.8,6751,NULL,NULL,'Malmquist cor.','UGC 02083',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25859,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25859,34.48,0.38,78.8,6751,75,NULL,'W91PP, r, inv','UGC 02083',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25860,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25860,34.49,0.45,79.1,6751,NULL,NULL,'K','UGC 02083',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25861,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25861,34.7,0.28,87.2,6751,NULL,NULL,NULL,'UGC 02083',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25862,'FP','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25862,36.38,0.59,189,6752,70,NULL,NULL,'2MASX J02363098-5325303',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.76',0.3,NULL,NULL,NULL,NULL,NULL,1,39.129083,-53.42514,0.065,NULL,38199005534,596859461,9325929,16.76),(25863,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25863,34.17,NULL,68.3,6753,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02092',NULL,'2010Ap&SS.325..163P',2010,1,2.89,NULL,'G',0.000011,NULL,'15.11',0.22,'Scd',NULL,NULL,NULL,NULL,1,39.13175,7.3095,0.249,NULL,66869464328,1044835380,16325552,15.11),(25864,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25864,34.18,NULL,68.4,6753,NULL,NULL,'Dipole + Quadrupole','UGC 02092',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25865,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25865,34.18,NULL,68.4,6753,NULL,NULL,'Dipole','UGC 02092',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25866,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25866,34.24,NULL,70.4,6753,NULL,NULL,NULL,'UGC 02092',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25867,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,'R',25867,34.28,0.49,71.7,6753,75,NULL,'IR','UGC 02092',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25868,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25868,34.63,0.4,84.2,6753,NULL,NULL,'mean','UGC 02092',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25869,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25869,34.64,0.15,84.9,6753,NULL,NULL,NULL,'UGC 02092',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25870,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25870,34.7,0.2,87.1,6753,74.4,NULL,NULL,'UGC 02092',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25871,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25871,34.8,0.47,91.2,6753,NULL,NULL,'H','UGC 02092',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25872,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25872,34.83,0.45,92.6,6753,NULL,NULL,'K','UGC 02092',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25873,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:58','1','SDSS-II SN 14486','RN',25873,42.91,0.24,2320,6754,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 14486',0.645797,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25874,'FP','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,'R',25874,35.99,0.33,158,6755,70,NULL,NULL,'MCG -02-07-043',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000102,NULL,'15.2g',0.56,'E0',NULL,NULL,NULL,NULL,1,39.145625,-9.35403,0.081,NULL,37879988365,591874818,9248044,15.2),(25875,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:58','1','SDSS-II SN 16667','RN',25875,40.2,0.44,909,6756,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 16667',0.206803,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25876,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:58','1','SDSS-II SN 16667','RN',25876,41.1,0.4,1370,6756,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 16667',0.206803,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25877,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:58','1','SDSS-II SN 06321','RN',25877,42.14,0.17,1790,6757,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 06321',0.497394,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25878,'Brightest Stars','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,'R',25878,26.61,NULL,2.1,6758,NULL,NULL,NULL,'Maffei 1',NULL,'2001ASPC..240..589H',2001,1,3.36,NULL,'G',0.000017,NULL,'11.4',1.68,'S0- pec:       HII','Group member',NULL,NULL,NULL,1,39.14775,59.65492,NULL,0,66359117475,1036861210,16200956,11.4),(25879,'CMD','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25879,28.2,0.3,4.4,6758,NULL,NULL,NULL,'Maffei 1',NULL,'2001ApJ...553L.133D',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25880,'SBF','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25880,28.1,0.25,4.15,6758,NULL,NULL,'K\'','Maffei 1',NULL,'1993ApJ...410...81L',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25881,'TRGB','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25881,27.64,0.2,3.37,6758,NULL,NULL,'Corrected','Maffei 1',NULL,'2014AJ....148....7W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25882,'TRGB','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25882,27.68,0.2,3.43,6758,NULL,NULL,'F110W','Maffei 1',NULL,'2014AJ....148....7W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25883,'TRGB','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25883,27.69,0.1,3.45,6758,74.4,NULL,NULL,'Maffei 1',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25884,'TRGB','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25884,27.71,0.18,3.48,6758,NULL,NULL,'F160W','Maffei 1',NULL,'2014AJ....148....7W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25885,'Faber-Jackson','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25885,26.65,1,2.14,6758,NULL,NULL,NULL,'Maffei 1',NULL,'1983MNRAS.205..131B',1983,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25886,'FP','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25886,27.33,NULL,2.92,6758,NULL,NULL,NULL,'Maffei 1',NULL,'2003ApJ...587..672F',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25887,'FP','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25887,27.39,0.22,3.01,6758,NULL,NULL,'avg 3','Maffei 1',NULL,'2003ApJ...587..672F',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25888,'FP','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25888,27.44,NULL,3.08,6758,NULL,NULL,NULL,'Maffei 1',NULL,'2003ApJ...587..672F',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25889,'FP','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25889,27.55,NULL,3.23,6758,NULL,NULL,NULL,'Maffei 1',NULL,'2003ApJ...587..672F',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25890,'Magnitude','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25890,37.14,0.13,268,6758,100,NULL,NULL,'2MASX J02363713-1922168',NULL,'1998A&A...337...31R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25891,'Tully est','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25891,27.79,0.8,3.6,6758,75,NULL,NULL,'Maffei 1',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25892,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:58','1','SDSS-II SN 19826','RN',25892,41.31,0.24,1320,6759,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19826',0.381584,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25893,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:58','1','SDSS-II SN 19826','RN',25893,41.48,0.17,1430,6759,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 19826',0.381584,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25894,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:58','1','SDSS-II SN 19826','N',25894,41.18,0.14,1720,6759,70,NULL,'SALT 2','SDSS-II SN 19826',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25895,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:58','1','SDSS-II SN 19826','N',25895,41.23,0.14,1760,6759,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19826',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25896,'Magnitude','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25896,37.14,0.13,268,6760,100,NULL,NULL,'ABELL 0367',NULL,'1998A&A...337...31R',1998,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III:   [BM]',NULL,NULL,NULL,NULL,1,39.1675,-19.38694,0.051,NULL,37967650807,593244543,9269445,NULL),(25897,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:58','1','SDSS-II SN 04186','RN',25897,39.59,0.16,737,6761,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04186',0.123158,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25898,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:58','1','SDSS-II SN 04186','RN',25898,39.89,0.23,845,6761,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04186',0.123158,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25899,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25899,34.84,0.45,93,6762,NULL,NULL,'K','NGC 0993',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000093,NULL,'14.56',0.8,'S0- pec:',NULL,NULL,NULL,NULL,1,39.1919166667,2.05042,0.041,NULL,66898755115,1045293048,16332703,14.56),(25900,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25900,34.9,0.4,95.3,6762,NULL,NULL,'mean','NGC 0993',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25901,'FP','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25901,35.44,0.48,123,6763,70,NULL,NULL,'2MASX J02364887-0859267',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.000097,NULL,'15.0g',0.45,'Sab',NULL,NULL,NULL,NULL,1,39.203625,-8.99072,0.077,NULL,37875730702,591808292,9247004,15),(25902,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:58','1','SDSS-II SN 18846','RN',25902,42.46,0.2,2160,6764,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 18846',0.432728,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25903,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:58','1','SDSS-II SN 18846','RN',25903,42.66,0.16,2370,6764,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 18846',0.432728,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25904,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25904,34.89,0.2,95.1,6765,74.4,NULL,NULL,'UGC 02096',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',NULL,NULL,'16.0',0.3,'Sbc',NULL,NULL,NULL,NULL,1,39.231833,11.08697,0.285,NULL,67950887835,1061732622,16589572,16),(25905,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25905,35.22,0.12,111,6765,NULL,NULL,NULL,'UGC 02096',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25906,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25906,34.29,0.6,72.1,6766,NULL,NULL,NULL,'ESO 416- G 003',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.02',0.5,'S?',NULL,NULL,NULL,NULL,1,39.237917,-29.19064,0,NULL,38430923612,600483181,9382549,15.02),(25907,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25907,34.33,0.2,73.5,6766,74.4,NULL,NULL,'ESO 416- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25908,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25908,34.48,0.55,78.8,6766,NULL,NULL,'Malmquist cor.','ESO 416- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25909,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25909,32.96,0.69,39,6767,100,NULL,'mid-IR','UGCA 036',NULL,'2013ApJ...771...88L',2013,1,1.3,NULL,'G',0.00011,NULL,'13.5B',0.9,'SA(s)c pec:',NULL,NULL,NULL,NULL,1,39.244333,-5.34922,0.045,NULL,34955202610,546175040,8533985,13.5),(25910,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25910,33.28,0.53,45.3,6767,NULL,NULL,NULL,'UGCA 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25911,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25911,33.32,0.2,46.1,6767,74.4,NULL,NULL,'UGCA 036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25912,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25912,33.51,0.48,50.3,6767,NULL,NULL,'Malmquist cor.','UGCA 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25913,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25913,33.9,0.4,60.4,6767,NULL,NULL,'mean','UGCA 036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25914,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25914,34.03,0.47,63.9,6767,NULL,NULL,'H','UGCA 036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25915,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,'R',25915,36,0.49,159,6768,75,NULL,'IR','FGC 0321',NULL,'2011yCatp016004901K',2011,1,1.02,NULL,'G',0.000029,NULL,'16.57',0.11,'Sc',NULL,NULL,NULL,NULL,1,39.2510833333,25.62533,0.425,NULL,68612468553,1072069821,16751090,16.57),(25916,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25916,36.21,NULL,174,6768,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0321',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25917,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25917,36.22,NULL,176,6768,NULL,NULL,'Dipole + Quadrupole','FGC 0321',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25918,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25918,36.23,NULL,176,6768,NULL,NULL,NULL,'FGC 0321',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25919,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25919,36.25,NULL,178,6768,NULL,NULL,'Dipole','FGC 0321',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25920,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:58','1','SN 2007ns',NULL,25920,40.95,0.2,1550,6769,70,NULL,'Hubble residual 0.39 for z0.36590','SDSS J023702.92-005200.2',NULL,'2011ApJ...740...92G',2011,1,0.09,NULL,'G',0.0005,NULL,'20.8g',0.05,NULL,NULL,NULL,NULL,NULL,1,39.2622083,-0.86672,0.057,NULL,34956203960,546190686,8534229,20.8),(25921,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:58','1','SDSS-II SN 18782','R',25921,41.73,0.27,1620,6769,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ns','SDSS J023702.92-005200.2',0.3659,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25922,'SNIa','2016-12-15 15:13:54','2016-12-16 11:18:58','1','SDSS-II SN 18782','R',25922,42.07,0.26,1900,6769,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ns','SDSS J023702.92-005200.2',0.3659,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25923,'FP','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,'R',25923,36.93,0.46,243,6770,70,NULL,NULL,'2MASX J02370865-0924017',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000075,NULL,'17.7g',0.13,'NLAGN',NULL,NULL,NULL,'Sy 2',1,39.286167,-9.40039,0.081,NULL,37879977863,591874654,9248041,17.7),(25924,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25924,35.26,0.2,113,6771,74.4,NULL,NULL,'UGC 02098',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000017,NULL,'16.5',0.4,'S?',NULL,NULL,NULL,NULL,1,39.3077916667,19.94894,0.317,NULL,68099031125,1064047361,16625740,16.5),(25925,'FP','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,'R',25925,37.58,0.46,328,6772,70,NULL,NULL,'2MASX J02372294-0907049',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000082,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,39.3454583,-9.118,0.081,NULL,37875690356,591807661,9246994,17.7),(25926,'FP','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25926,35.69,0.53,137,6773,70,NULL,NULL,'2MASX J02372403-1152139',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.21',NULL,NULL,NULL,NULL,NULL,NULL,1,39.350125,-11.87064,0.013,NULL,37868242306,591691286,9245176,16.21),(25927,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25927,34.99,0.39,99.6,6774,NULL,NULL,'Malmquist cor.','UGC 02106',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.00002,NULL,'15.4',0.3,'HII',NULL,NULL,NULL,NULL,1,39.351,-1.82147,0.053,NULL,34958966020,546233844,8534903,15.4),(25928,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25928,35,0.39,100,6774,NULL,NULL,NULL,'UGC 02106',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25929,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25929,35.04,0.2,102,6774,74.4,NULL,NULL,'UGC 02106',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25930,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25930,33.04,0.43,40.6,6775,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0992',NULL,'2014MNRAS.444..527S',2014,1,0.9,NULL,'G',0.000013,NULL,'13.65',0.7,'S?             LIRG','in a radial-velocity based grouping',NULL,NULL,NULL,1,39.3562083333,21.10083,0.409,NULL,68092776342,1063949630,16624212,13.65),(25931,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25931,33.48,0.43,49.6,6775,75,NULL,'3.6 micron, color corrected','NGC 0992',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25932,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25932,33.78,0.4,57,6775,NULL,NULL,'mean','NGC 0992',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25933,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25933,33.9,0.2,60.3,6775,74.4,NULL,NULL,'NGC 0992',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25934,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25934,33.98,0.45,62.5,6775,NULL,NULL,'K','NGC 0992',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25935,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25935,34.05,0.47,64.6,6775,NULL,NULL,'H','NGC 0992',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25936,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25936,34.15,0.46,67.7,6775,NULL,NULL,'J','NGC 0992',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25937,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25937,34.54,NULL,80.8,6775,75,NULL,'HI','NGC 0992',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25938,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25938,34.78,NULL,90.2,6775,75,NULL,'CO','NGC 0992',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25939,'FP','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25939,34.81,0.52,91.7,6776,70,NULL,NULL,'2MASX J02373138-6051368',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.33',0.25,'S',NULL,NULL,NULL,NULL,1,39.380833,-60.86017,0.045,NULL,36266501192,566664081,8854126,16.33),(25940,'FP','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,'R',25940,37.92,0.46,385,6777,70,NULL,NULL,'2MASX J02373152-0904310',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000082,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,39.381375,-9.07519,0.081,NULL,37875684702,591807573,9246993,17.5),(25941,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25941,34.53,0.2,80.5,6778,74.4,NULL,NULL,'CGCG 388-066',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.00005,NULL,'15.5',0.3,NULL,'Group member',NULL,NULL,NULL,1,39.38725,1.652,0.041,NULL,66898669385,1045291709,16332682,15.5),(25942,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25942,34.89,0.08,95.3,6778,NULL,NULL,NULL,'CGCG 388-066',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25943,'SNIa SDSS','2016-12-15 15:13:54','2016-12-16 11:18:58','1','SDSS-II SN 01574','RN',25943,42.19,0.2,1710,6779,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01574',0.601785,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25944,'IRAS','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25944,33.81,0.8,57.8,6780,75,NULL,'MAT, I','ESO 355- G 030',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000013,NULL,'13.19',0.8,'SB(rs:)bc:;HII LINER',NULL,NULL,NULL,NULL,1,39.4024583,-32.92444,NULL,NULL,38407284134,600113814,9376778,13.19),(25945,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25945,33.58,0.43,52.1,6780,75,NULL,'MAT, I, raw','ESO 355- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25946,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25946,33.7,0.32,55,6780,85,NULL,'I, raw','ESO 355- G 030',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25947,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25947,33.77,0.32,56.7,6780,85,NULL,'I, inv','ESO 355- G 030',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25948,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25948,33.81,0.47,57.8,6780,NULL,NULL,'H','ESO 355- G 030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25949,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25949,33.83,0.46,58.3,6780,NULL,NULL,'J','ESO 355- G 030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25950,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25950,33.86,0.43,59.1,6780,75,NULL,'MAT, I, inv','ESO 355- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25951,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25951,33.87,0.45,59.4,6780,NULL,NULL,'K','ESO 355- G 030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25952,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25952,33.95,0.4,61.5,6780,NULL,NULL,'mean','ESO 355- G 030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25953,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25953,33.97,0.43,62.2,6780,75,NULL,'MAT, I, cor','ESO 355- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25954,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25954,34.16,0.28,68,6780,NULL,NULL,NULL,'ESO 355- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25955,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25955,34.21,0.27,69.6,6780,NULL,NULL,'Malmquist cor.','ESO 355- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25956,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25956,34.26,0.2,71.1,6780,74.4,NULL,NULL,'ESO 355- G 030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25957,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,'R',25957,34.21,0.49,69.5,6781,75,NULL,'IR','UGC 02101',NULL,'2011yCatp016004901K',2011,1,2.07,NULL,'G',0.00005,NULL,'15.0',0.24,'Sbc',NULL,NULL,NULL,NULL,1,39.406,42.63589,0.325,NULL,68551486182,1071116971,16736202,15),(25958,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25958,34.28,0.47,71.9,6781,NULL,NULL,'H','UGC 02101',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25959,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25959,34.32,0.45,73.1,6781,NULL,NULL,'K','UGC 02101',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25960,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25960,34.45,0.4,77.5,6781,NULL,NULL,'mean','UGC 02101',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25961,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25961,34.45,NULL,77.5,6781,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02101',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25962,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25962,34.45,NULL,77.8,6781,NULL,NULL,'Dipole + Quadrupole','UGC 02101',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25963,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25963,34.45,NULL,77.8,6781,NULL,NULL,'Dipole','UGC 02101',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25964,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25964,34.49,0.46,79.2,6781,NULL,NULL,'J','UGC 02101',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25965,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25965,33.41,0.47,48.1,6782,NULL,NULL,'H','UGC 02105',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.00003,NULL,'14.2',0.8,'(R\')SB(s)a:    Sbrst','in a pair',NULL,NULL,'Starburst',1,39.4165,34.43158,0.189,NULL,68657223224,1072769112,16762017,14.2),(25966,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25966,33.52,0.45,50.6,6782,NULL,NULL,'K','UGC 02105',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25967,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25967,33.62,0.46,52.9,6782,NULL,NULL,'J','UGC 02105',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25968,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25968,34.11,0.4,66.4,6782,NULL,NULL,'mean','UGC 02105',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25969,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25969,34.73,0.4,88.4,6783,NULL,NULL,'mean','NGC 1004',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.00007,NULL,'13.71',1.3,'E+','in a radial-velocity based grouping',NULL,NULL,'Flat-Spectrum Radio Source',1,39.424083,1.97531,0.045,NULL,66896676605,1045260571,16332196,13.71),(25970,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25970,34.83,0.45,92.4,6783,NULL,NULL,'K','NGC 1004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25971,'FP','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,'R',25971,36.74,0.46,223,6784,70,NULL,NULL,'2MASX J02374503-0030186',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000074,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,39.4375,-0.50514,0.037,NULL,34955490949,546179546,8534055,17.3),(25972,'TRGB','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25972,28.34,0.22,4.66,6785,NULL,NULL,NULL,'ESO 115- G 021',NULL,'2003A&A...398..479K',2003,1,7.17,'Extended HIPASS source','G',0.000007,NULL,'13.3B',0.78,'Scd',NULL,NULL,NULL,NULL,1,39.447,-61.33669,0.009,NULL,36266261093,566660329,8854067,13.3),(25973,'TRGB','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,'R',25973,28.37,NULL,4.72,6785,NULL,NULL,'I','ESO 115- G 021',NULL,'2006ARep...50..517T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25974,'TRGB','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25974,28.49,0.03,4.99,6785,NULL,NULL,NULL,'ESO 115- G 021',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25975,'TRGB','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25975,28.65,0.09,5.37,6785,74.4,NULL,NULL,'ESO 115- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25976,'Tully est','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25976,28.28,0.8,4.5,6785,75,NULL,NULL,'ESO 115- G 021',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25977,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25977,28.65,0.09,5.37,6785,74.4,NULL,NULL,'ESO 115- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25978,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25978,28.97,NULL,6.21,6785,NULL,NULL,NULL,'ESO 115- G 021',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25979,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25979,29.04,NULL,6.41,6785,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 115- G 021',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25980,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25980,29.07,NULL,6.53,6785,NULL,NULL,'Dipole + Quadrupole','ESO 115- G 021',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25981,'Tully-Fisher','2016-12-15 15:13:54','2016-12-16 11:18:58','1',NULL,NULL,25981,29.1,NULL,6.6,6785,NULL,NULL,'Dipole','ESO 115- G 021',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25982,'GRB','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,25982,42.91,NULL,3810,6786,71,NULL,NULL,'GRB 081228',NULL,'2011A&A...526A.153K',2011,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,39.462333,30.85281,0.441,NULL,68606605007,1071978203,16749659,NULL),(25983,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 13657',NULL,25983,39.93,0.3,969,6787,70,NULL,'SN photometric redshift distance, z photo =0.259 +/- 0.046','SDSS-II SN 13657',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,39.48825,-0.93475,0.049,NULL,34955931821,546186434,8534163,NULL),(25984,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,25984,34.67,0.49,86,6788,70,NULL,NULL,'UGC 02119',NULL,'2014MNRAS.445.2677S',2014,1,1.7,'Sometimes incorrectly called NGC 1037.','G',0.00003,NULL,'14.2',0.9,'SB(r)b:',NULL,NULL,NULL,NULL,1,39.4945416667,-1.84406,0.077,NULL,34957718919,546214358,8534599,14.2),(25985,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,25985,35.03,0.4,101,6788,NULL,NULL,'Malmquist cor.','UGC 02119',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25986,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,25986,35.17,0.38,108,6788,NULL,NULL,NULL,'UGC 02119',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25987,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,25987,35.34,0.2,117,6788,74.4,NULL,NULL,'UGC 02119',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25988,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,25988,35.39,0.47,120,6788,NULL,NULL,'H','UGC 02119',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25989,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,25989,35.44,0.4,123,6788,NULL,NULL,'mean','UGC 02119',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25990,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,25990,35.49,0.45,125,6788,NULL,NULL,'K','UGC 02119',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25991,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,25991,35.49,0.46,125,6788,NULL,NULL,'J','UGC 02119',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25992,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',25992,36.51,0.46,201,6789,70,NULL,NULL,'2MASX J02380434-0746161',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000078,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,39.5180417,-7.77122,0.017,NULL,37876152825,591814887,9247107,16.5),(25993,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',25993,34.49,0.49,79,6790,75,NULL,'IR','UGC 02120',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000023,NULL,'14.91',0.4,'SBbc:',NULL,NULL,NULL,NULL,1,39.5315,1.38839,0.053,NULL,66895281154,1045238768,16331855,14.91),(25994,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,25994,36.73,0.56,222,6791,70,NULL,NULL,'NGC 1018',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.38',0.6,'(R\')SB(r)0/a',NULL,NULL,NULL,NULL,1,39.5431666667,-9.54392,0.061,NULL,37880710044,591886094,9248220,15.38),(25995,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,25995,36.63,0.58,212,6792,70,NULL,NULL,'2MASX J02381161-0613141',NULL,'2014MNRAS.445.2677S',2014,1,0.96,NULL,'G',0.00015,NULL,'16.49',0.48,NULL,NULL,NULL,NULL,NULL,1,39.54825,-6.22072,0.041,NULL,34934848247,545857003,8529015,16.49),(25996,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2009ig',NULL,25996,32.82,0.09,36.6,6793,73,NULL,'MLCS2k2','NGC 1015',NULL,'2013ApJ...777...40M',2013,1,2.6,NULL,'G',0.000021,NULL,'12.9B',2.6,'SB(r)a:',NULL,NULL,NULL,NULL,1,39.548167,-1.31869,0.073,NULL,34955876319,546185567,8534149,12.9),(25997,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2009ig',NULL,25997,32.96,0.02,39.1,6793,74,NULL,'MLCS2k2','NGC 1015',NULL,'2012ApJ...744...38F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25998,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,25998,32.6,0.4,33.1,6793,75,NULL,'B','NGC 1015',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25999,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,25999,34.58,0.54,82.2,6794,70,NULL,NULL,'2MASX J02381540-0358430',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.41',0.34,NULL,NULL,NULL,NULL,NULL,1,39.5640833333,-3.97861,0.041,NULL,34953161921,546143155,8533486,15.41),(26000,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26000,33.55,0.43,51.2,6795,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J02381608+0155491',NULL,'2014MNRAS.444..527S',2014,1,0.51,'Springob et al. (2005ApJS..160..149S) give v = 6040 km/sec.','G',0.0003,NULL,'17.23',0.16,NULL,NULL,NULL,NULL,NULL,1,39.5669583,1.93031,0.041,NULL,66896745428,1045261647,16332213,17.23),(26001,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26001,34.69,0.49,86.8,6796,75,NULL,'IR','NGC 1009',NULL,'2011yCatp016004901K',2011,1,1.55,NULL,'G',0.000059,NULL,'15.21',0.22,'Sb','Group member',NULL,NULL,NULL,1,39.5794583,2.31003,0.053,NULL,66896902361,1045264099,16332251,15.21),(26002,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26002,34.83,NULL,92.3,6796,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 1009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26003,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26003,34.83,NULL,92.6,6796,NULL,NULL,'Dipole + Quadrupole','NGC 1009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26004,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26004,34.84,NULL,93.1,6796,NULL,NULL,'Dipole','NGC 1009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26005,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26005,34.89,NULL,94.9,6796,NULL,NULL,NULL,'NGC 1009',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26006,'D-Sigma','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26006,33.82,0.4,58,6797,75,NULL,'Edat, raw','NGC 1016',NULL,'1997ApJS..109..333W',1997,1,2.4,NULL,'G',0.000057,NULL,'12.61',2.4,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,39.5815,2.11925,0.053,NULL,66896735647,1045261494,16332210,12.61),(26007,'D-Sigma','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26007,34.15,0.4,67.6,6797,75,NULL,'Edat, cor','NGC 1016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26008,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26008,34.46,0.45,78,6797,NULL,NULL,'K','NGC 1016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26009,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26009,34.76,0.4,89.7,6797,NULL,NULL,'mean','NGC 1016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26010,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26010,36.91,0.46,241,6798,70,NULL,NULL,'2MASX J02382087-0033350',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000066,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,39.5869583,-0.55967,0.033,NULL,34900930794,545327043,8520735,17.1),(26011,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26011,37.84,0.46,369,6799,70,NULL,NULL,'2MASX J02382297-0931116',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000081,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,39.595833,-9.51989,0.061,NULL,37880703321,591885989,9248218,17.6),(26012,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26012,34.56,0.49,81.8,6800,75,NULL,'IR','UGC 02130',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'15.16',0.4,'Sb','Isolated galaxy',NULL,NULL,NULL,1,39.6015417,7.99294,0.273,NULL,67954302712,1061785979,16590405,15.16),(26013,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26013,34.73,0.4,88.2,6800,NULL,NULL,'mean','UGC 02130',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26014,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26014,34.82,0.47,92.2,6800,NULL,NULL,'H','UGC 02130',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26015,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26015,34.93,0.45,97,6800,NULL,NULL,'K','UGC 02130',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26016,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26016,35.94,0.54,154,6801,70,NULL,NULL,'2MASX J02382507-2713470',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,39.6044583,-27.22972,0.006,NULL,38436033621,600563025,9383797,14.3),(26017,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 03341',NULL,26017,41.08,0.23,1640,6802,70,NULL,'SN photometric redshift distance, z photo =0.498 +/- 0.078','SDSS-II SN 03341',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.8g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,39.6105833333,0.78761,0.061,NULL,66849421492,1044522210,16320659,21.8),(26018,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 03341','R',26018,42.15,0.22,1880,6802,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03341',0.431112,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26019,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 03341','R',26019,42.16,0.31,1890,6802,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03341',0.431112,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26020,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26020,33.36,0.45,47,6803,NULL,NULL,'K','NGC 0995',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000067,NULL,'14.40',1.2,'S0','Group member',NULL,NULL,NULL,1,39.6335,41.52925,0.269,NULL,68550036849,1071094325,16735848,14.4),(26021,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26021,33.64,0.4,53.5,6803,NULL,NULL,'mean','NGC 0995',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26022,'Ring Diameter','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26022,32.1,0.84,26,6804,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 1022',NULL,'1981ApJS...45..541P',1981,1,2.4,NULL,'G',0.00002,NULL,'12.09',2,'(R\')SB(s)a;HII Sbrst','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,39.6362916667,-6.67742,0.041,NULL,34935187629,545862306,8529098,12.09),(26023,'Tully est','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26023,31.33,0.8,18.5,6804,75,NULL,'B','NGC 1022',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26024,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 13381','RN',26024,42.85,0.23,2540,6805,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 13381',0.460585,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26025,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 06635','RN',26025,41.14,0.13,1440,6806,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 06635',0.173804,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26026,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 06635','RN',26026,41.76,0.24,1910,6806,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 06635',0.173804,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26027,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 14919','RN',26027,41.44,0.3,1560,6807,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 14919',0.243348,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26028,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 14919','RN',26028,41.71,0.38,1770,6807,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 14919',0.243348,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26029,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 13489',NULL,26029,41.26,0.16,1790,6808,70,NULL,'SN photometric redshift distance, z photo =0.561 +/- 0.061','SDSS-II SN 13489',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,39.6538333333,0.21133,0.041,NULL,66849064855,1044516638,16320572,NULL),(26030,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26030,35.1,NULL,105,6809,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0326',NULL,'2010Ap&SS.325..163P',2010,1,1.01,NULL,'G',0.000018,NULL,'16.51',0.1,'Sd',NULL,NULL,NULL,NULL,1,39.677,10.77197,0.273,NULL,67961633176,1061900518,16592195,16.51),(26031,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26031,35.13,NULL,106,6809,NULL,NULL,'Dipole + Quadrupole','FGC 0326',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26032,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26032,35.13,NULL,106,6809,NULL,NULL,'Dipole','FGC 0326',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26033,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26033,35.15,NULL,107,6809,NULL,NULL,NULL,'FGC 0326',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26034,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26034,35.22,0.15,111,6809,NULL,NULL,NULL,'FGC 0326',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26035,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26035,35.24,0.2,112,6809,74.4,NULL,NULL,'FGC 0326',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26036,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26036,35.41,0.49,121,6809,75,NULL,'IR','FGC 0326',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26037,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26037,36.64,0.46,213,6810,70,NULL,NULL,'2MASX J02384298-0717165',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000084,NULL,'16.0g',0.41,'E0',NULL,NULL,NULL,NULL,1,39.679125,-7.28794,0.017,NULL,34934906499,545857914,8529029,16),(26038,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','PTF10zgy','N',26038,36.96,0.06,236,6811,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10zgy',0.0443,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26039,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26039,37.24,0.69,281,6812,70,NULL,NULL,'2MASX J02384486-6307247',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.65',0.37,NULL,NULL,NULL,NULL,NULL,1,39.687,-63.12347,0.025,NULL,36262996097,566609314,8853270,16.65),(26040,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 06154','RN',26040,41.76,0.2,1890,6813,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 06154',0.186603,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26041,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 06154','RN',26041,42.28,0.32,2410,6813,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 06154',0.186603,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26042,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26042,36.04,0.54,162,6814,70,NULL,NULL,'2MASX J02384894-2911180',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'16.95',0.34,NULL,NULL,NULL,NULL,NULL,1,39.7039166667,-29.18822,0,NULL,38430877018,600482453,9382538,16.95),(26043,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26043,36.72,0.61,221,6815,70,NULL,NULL,'2MASX J02384944-0833126',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.000088,NULL,'15.6g',0.51,'Sb',NULL,NULL,NULL,NULL,1,39.706125,-8.55358,0.045,NULL,37876424211,591819128,9247173,15.6),(26044,'IRAS','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26044,33.7,0.8,55.1,6816,75,NULL,'W91PP, r','UGC 02134',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000012,NULL,'14.21',0.7,'Sb',NULL,NULL,NULL,NULL,1,39.715875,27.84731,0.277,NULL,68618565905,1072165092,16752579,14.21),(26045,'IRAS','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26045,33.74,0.8,55.9,6816,75,NULL,'CF, r','UGC 02134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26046,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26046,33.06,0.43,40.9,6816,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02134',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26047,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26047,33.09,0.43,41.4,6816,75,NULL,'3.6 micron, color corrected','UGC 02134',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26048,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26048,33.1,0.2,41.7,6816,74.4,NULL,NULL,'UGC 02134',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26049,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26049,33.18,0.58,43.3,6816,NULL,NULL,NULL,'UGC 02134',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26050,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26050,33.2,0.58,43.7,6816,NULL,NULL,'Malmquist cor.','UGC 02134',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26051,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26051,33.21,0.47,43.8,6816,NULL,NULL,'H','UGC 02134',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26052,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26052,33.28,0.38,45.2,6816,75,NULL,'CF, r, raw','UGC 02134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26053,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26053,33.3,0.45,45.7,6816,NULL,NULL,'K','UGC 02134',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26054,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26054,33.31,0.46,46,6816,NULL,NULL,'J','UGC 02134',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26055,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26055,33.38,0.38,47.3,6816,75,NULL,'CF, r, inv','UGC 02134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26056,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26056,33.45,0.38,48.9,6816,75,NULL,'W91PP, r, raw','UGC 02134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26057,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26057,33.57,0.38,51.7,6816,75,NULL,'W91PP, r, inv','UGC 02134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26058,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26058,33.62,0.38,53.1,6816,75,NULL,'CF, r, cor','UGC 02134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26059,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26059,33.75,0.38,56.2,6816,75,NULL,'W91PP, r, cor','UGC 02134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26060,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26060,33.91,0.4,60.6,6816,NULL,NULL,'mean','UGC 02134',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26061,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2006lr',NULL,26061,39.71,0.11,874,6817,70,NULL,'Hubble residual -0.25 for z0.26190','SDSS-II SN 15440 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,39.7205833333,0.09011,0.049,NULL,66849047998,1044516374,16320568,NULL),(26062,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 15440','R',26062,40.42,0.22,960,6817,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006lr','SDSS-II SN 15440 HOST',0.262254,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26063,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 15440','R',26063,40.45,0.14,975,6817,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006lr','SDSS-II SN 15440 HOST',0.262254,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26064,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2006lr',NULL,26064,40.45,0.11,1230,6817,70,NULL,'SALT 2','SDSS-II SN 15440 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26065,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2006lr',NULL,26065,40.47,0.11,1240,6817,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15440 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26066,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26066,33.18,0.49,43.3,6818,75,NULL,'IR','IC 0245',NULL,'2011yCatp016004901K',2011,1,0.7,NULL,'G',0.000037,NULL,'15.1b',0.2,NULL,NULL,NULL,NULL,NULL,1,39.727667,-14.30556,0.009,NULL,38100238377,595316224,9301816,15.1),(26067,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26067,33.39,0.69,47.6,6819,100,NULL,'mid-IR','IC 1825',NULL,'2013ApJ...771...88L',2013,1,1.2,NULL,'G',0.00002,NULL,'14.55',0.8,'Scd:','Isolated galaxy',NULL,NULL,NULL,1,39.7317917,9.09736,0.277,NULL,67954618412,1061790912,16590483,14.55),(26068,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26068,33.94,0.2,61.4,6819,74.4,NULL,NULL,'IC 1825',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26069,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26069,34.07,0.44,65.1,6819,NULL,NULL,NULL,'IC 1825',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26070,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26070,34.1,0.43,66,6819,NULL,NULL,'Malmquist cor.','IC 1825',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26071,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26071,34.24,0.4,70.3,6819,NULL,NULL,'mean','IC 1825',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26072,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26072,34.26,0.47,71,6819,NULL,NULL,'H','IC 1825',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26073,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26073,34.33,0.45,73.5,6819,NULL,NULL,'K','IC 1825',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26074,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26074,34.36,0.46,74.3,6819,NULL,NULL,'J','IC 1825',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26075,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26075,33.98,0.4,62.6,6820,NULL,NULL,'mean','NGC 0983',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000067,NULL,'13.94',0.9,'SB(r)b:','in a pair',NULL,NULL,NULL,1,39.731833,34.62228,0.153,NULL,68660496308,1072820254,16762816,13.94),(26076,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26076,34.08,0.45,65.6,6820,NULL,NULL,'K','NGC 0983',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26077,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26077,34.11,0.47,66.2,6820,NULL,NULL,'H','NGC 0983',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26078,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26078,34.14,0.46,67.3,6820,NULL,NULL,'J','NGC 0983',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26079,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 21594','RN',26079,42.06,0.37,1780,6821,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21594',0.451125,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26080,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26080,33.71,0.49,55.3,6822,75,NULL,'IR','MCG -03-07-047',NULL,'2011yCatp016004901K',2011,1,1.37,NULL,'G',0.000013,NULL,'15.8b',0.18,'Sc',NULL,NULL,NULL,NULL,1,39.741125,-14.32061,0.009,NULL,38100107434,595314178,9301784,15.8),(26081,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26081,33.81,NULL,57.7,6822,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -03-07-047',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26082,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26082,33.82,NULL,58.1,6822,NULL,NULL,'Dipole + Quadrupole','MCG -03-07-047',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26083,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26083,33.83,NULL,58.2,6822,NULL,NULL,'Dipole','MCG -03-07-047',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26084,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26084,36.77,0.41,226,6823,NULL,NULL,'Malmquist cor.','2MASX J02385841+1016344',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000017,NULL,'14.3I',NULL,NULL,NULL,NULL,NULL,NULL,1,39.7434166667,10.27631,0.265,NULL,67963144264,1061924129,16592564,14.3),(26085,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26085,37.02,0.37,254,6823,NULL,NULL,NULL,'2MASX J02385841+1016344',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26086,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26086,37.06,0.2,258,6823,74.4,NULL,NULL,'2MASX J02385841+1016344',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26087,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 18283','R',26087,40.54,0.27,986,6824,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18283',0.299249,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,39.7512917,-0.54572,0.033,NULL,34901759367,545339990,8520937,NULL),(26088,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 18283','R',26088,40.63,0.26,1030,6824,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18283',0.299249,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26089,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 18283',NULL,26089,40.11,0.27,1050,6824,70,NULL,'SN photometric redshift distance, z photo =0.285 +/- 0.045','SDSS-II SN 18283',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26090,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 18283',NULL,26090,40.35,0.18,1170,6824,70,NULL,'SALT 2','SDSS-II SN 18283',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26091,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 18283',NULL,26091,40.38,0.18,1190,6824,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18283',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26092,'IRAS','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26092,31.42,0.8,19.3,6825,75,NULL,'MAT, I','IC 1826',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000026,NULL,'13.2',1.4,'SAB(rs)0^+     HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,39.7647917,-27.44314,0,NULL,38436026320,600562911,9383795,13.2),(26093,'Tully est','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26093,31.08,0.8,16.4,6825,75,NULL,'B','IC 1826',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26094,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26094,33.2,0.43,43.7,6825,75,NULL,'MAT, I, raw','IC 1826',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26095,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26095,33.26,0.32,44.9,6825,85,NULL,'I, raw','IC 1826',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26096,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26096,33.31,0.32,46,6825,85,NULL,'I, inv','IC 1826',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26097,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26097,33.42,0.43,48.3,6825,75,NULL,'MAT, I, inv','IC 1826',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26098,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26098,33.63,0.43,53.1,6825,75,NULL,'MAT, I, cor','IC 1826',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26099,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 04442','RN',26099,42.51,0.27,2510,6826,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04442',0.261849,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26100,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 04442','RN',26100,43.24,0.26,3520,6826,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04442',0.261849,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26101,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 15874',NULL,26101,37.22,1.31,277,6827,70,NULL,'SN photometric redshift distance, z photo =0.067 +/- 0.059','SDSS-II SN 15874',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,39.7694583,-0.38711,0.049,NULL,34900885800,545326340,8520724,NULL),(26102,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 15874','R',26102,42,0.25,1790,6827,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15874',0.402736,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26103,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 15874','R',26103,42.3,0.32,2050,6827,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15874',0.402736,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26104,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 15874',NULL,26104,42.31,0.22,2900,6827,70,NULL,'SALT 2','SDSS-II SN 15874',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26105,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 15874',NULL,26105,42.38,0.22,2990,6827,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15874',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26106,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26106,35.52,0.51,127,6828,70,NULL,NULL,'2MASX J02390575-0656486',NULL,'2014MNRAS.445.2677S',2014,1,0.87,NULL,'G',0.000063,NULL,'15.82',0.45,NULL,NULL,NULL,NULL,NULL,1,39.774083,-6.94689,0.041,NULL,34934966216,545858847,8529044,15.82),(26107,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26107,34.47,0.2,78.3,6829,74.4,NULL,NULL,'UGC 02135',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.00004,NULL,'15.20',0.9,'Sd',NULL,NULL,NULL,NULL,1,39.7959583,41.24564,0.297,NULL,68550531876,1071102060,16735969,15.2),(26108,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26108,34.51,0.37,79.7,6829,NULL,NULL,'Malmquist cor.','UGC 02135',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26109,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26109,34.56,0.36,81.6,6829,NULL,NULL,NULL,'UGC 02135',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26110,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26110,38.06,0.46,409,6830,70,NULL,NULL,'2MASX J02391180-0713366',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000088,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,39.799375,-7.22689,0.041,NULL,34935115744,545861183,8529080,17.3),(26111,'Sosies','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26111,33.34,0.08,46.6,6831,NULL,NULL,NULL,'NGC 1024',NULL,'2002A&A...393...57T',2002,1,3.9,NULL,'G',0.00002,NULL,'13.08',1.4,'(R\')SA(r)ab','in a triple',NULL,NULL,NULL,1,39.799833,10.84683,0.273,NULL,67961681445,1061901272,16592207,13.08),(26112,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26112,33.2,0.47,43.7,6831,NULL,NULL,'H','NGC 1024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26113,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26113,33.22,0.46,44,6831,NULL,NULL,'J','NGC 1024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26114,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26114,33.29,0.45,45.5,6831,NULL,NULL,'K','NGC 1024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26115,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26115,33.35,0.4,46.7,6831,NULL,NULL,'mean','NGC 1024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26116,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26116,33.56,0.2,51.5,6831,74.4,NULL,NULL,'NGC 1024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26117,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 02243','RN',26117,41.8,0.18,1440,6832,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02243',0.592119,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26118,'IRAS','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26118,30.73,0.8,14,6833,75,NULL,'W91PP, r','NGC 1012',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000009,NULL,'13.00',1.1,'S0/a?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,39.812125,30.15139,0.433,NULL,68610399198,1072037487,16750585,13),(26119,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26119,29.99,0.69,9.94,6833,100,NULL,'mid-IR','NGC 1012',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26120,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26120,30.79,0.4,14.4,6833,75,NULL,'B','NGC 1012',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26121,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26121,31.13,0.38,16.9,6833,75,NULL,'W91PP, r, inv','NGC 1012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26122,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26122,31.18,0.38,17.2,6833,75,NULL,'W91PP, r, raw','NGC 1012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26123,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26123,31.33,0.38,18.5,6833,75,NULL,'W91PP, r, cor','NGC 1012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26124,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26124,36.09,0.46,165,6834,70,NULL,NULL,'2MASX J02391502+0028423',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000098,NULL,'16.0g',0.26,'S0^-',NULL,NULL,NULL,NULL,1,39.8125833333,0.47847,0.053,NULL,66849699986,1044526562,16320727,16),(26125,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 1937D','R',26125,31.8,NULL,22.9,6835,NULL,NULL,'Photographic','NGC 1003',NULL,'1988SSRv...48....1R',1988,1,5.5,NULL,'G',0.000017,NULL,'12.00',1.9,'SA(s)cd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,39.820375,40.87231,0.237,NULL,68541407480,1070959491,16733742,12),(26126,'IRAS','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26126,30.18,0.8,10.9,6835,75,NULL,'A82, H','NGC 1003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26127,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26127,29.7,0.3,8.71,6835,NULL,18.45,'SN 1937D host','NGC 1003',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26128,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26128,29.7,0.3,8.71,6835,NULL,18.45,'NGC 1023 group','NGC 1003',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26129,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26129,29.98,0.4,9.9,6835,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 1003',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26130,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26130,30.13,0.38,10.6,6835,NULL,NULL,NULL,'NGC 1003',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26131,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26131,30.13,0.39,10.6,6835,73,NULL,'opt','NGC 1003',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26132,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26132,30.15,0.4,10.7,6835,75,NULL,'B','NGC 1003',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26133,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26133,30.19,0.2,10.9,6835,74.4,NULL,NULL,'NGC 1003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26134,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26134,30.23,0.43,11.1,6835,75,NULL,'3.6 micron, color corrected','NGC 1003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26135,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26135,30.26,0.47,11.3,6835,75,NULL,'A82, H, inv','NGC 1003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26136,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26136,30.28,0.43,11.4,6835,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26137,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26137,30.32,0.47,11.6,6835,75,NULL,'A82, H, raw','NGC 1003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26138,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26138,30.49,0.6,12.5,6835,NULL,NULL,NULL,'NGC 1003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26139,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26139,30.58,0.47,13,6835,75,NULL,'A82, H, cor','NGC 1003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26140,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26140,30.65,0.56,13.5,6835,NULL,NULL,'Malmquist cor.','NGC 1003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26141,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26141,35.12,0.73,106,6836,NULL,NULL,NULL,'AGC 420612',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000023,NULL,'17.54',0.13,NULL,NULL,NULL,NULL,NULL,1,39.8265417,-14.23489,0.009,NULL,38100252628,595316447,9301819,17.54),(26142,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26142,35.2,0.71,110,6836,NULL,NULL,'Malmquist cor.','AGC 420612',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26143,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26143,33.7,0.4,54.9,6837,NULL,NULL,'mean','NGC 1026',NULL,'2007A&A...465...71T',2007,1,2,NULL,'G',0.000073,NULL,'13.55',1.8,'S0',NULL,NULL,NULL,NULL,1,39.8300833333,6.544,0.213,NULL,66866631349,1044791114,16324861,13.55),(26144,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26144,34.09,0.45,65.9,6837,NULL,NULL,'K','NGC 1026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26145,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26145,37.08,0.46,261,6838,70,NULL,NULL,'2MASX J02391953-0013348',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000093,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,39.831375,-0.22619,0.049,NULL,34900980126,545327814,8520747,17.4),(26146,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26146,36.43,0.46,193,6839,70,NULL,NULL,'2MASX J02391985-0849512',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000086,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,39.832583,-8.83089,0.049,NULL,37876073344,591813646,9247088,16.3),(26147,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26147,34.75,0.1,89.3,6840,NULL,NULL,NULL,'CGCG 388-087',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.00005,NULL,'15.4',0.3,NULL,NULL,NULL,NULL,NULL,1,39.850667,1.96239,0.049,NULL,66851339661,1044552182,16321127,15.4),(26148,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26148,34.92,0.2,96.4,6840,74.4,NULL,NULL,'CGCG 388-087',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26149,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26149,32.76,0.2,35.7,6841,74.4,NULL,NULL,'UGC 02148',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000024,NULL,'16.0',0.3,'SB?',NULL,NULL,NULL,NULL,1,39.86875,12.67972,0.301,NULL,68133522430,1064586287,16634160,16),(26150,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26150,33.16,0.55,42.8,6841,NULL,NULL,NULL,'UGC 02148',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26151,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26151,33.62,0.44,53,6841,NULL,NULL,'Malmquist cor.','UGC 02148',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26152,'SNII optical','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 1990E',NULL,26152,31.28,0.35,18,6842,NULL,NULL,NULL,'NGC 1035',NULL,'1994ApJ...432...42S',1994,1,2.2,'The 2MASX and SDSS positions are southeast of the J-band nucleus.','G',0.000017,NULL,'12.89',0.7,'SA(s)c?','in a triple',NULL,NULL,NULL,1,39.8712083,-8.13294,0.029,NULL,37876298848,591817169,9247143,12.89),(26153,'SNII optical','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 1990E',NULL,26153,31.44,0.37,19.2,6842,NULL,NULL,'SEAM','NGC 1035',0.00414,'2009ApJ...694.1067P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26154,'SNII optical','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 1990E','R',26154,31.51,0.21,20,6842,NULL,NULL,'EPM','NGC 1035',NULL,'1992AAS...18110704S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26155,'SNII optical','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 1990E',NULL,26155,31.71,0.27,22,6842,NULL,NULL,'EPM','NGC 1035',NULL,'1992ApJ...395..366S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26156,'IRAS','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26156,30.95,0.8,15.5,6842,75,NULL,'A82, H','NGC 1035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26157,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26157,30.7,0.3,13.8,6842,NULL,18.45,'SN 1990E host','NGC 1035',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26158,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26158,30.74,0.43,14,6842,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1035',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26159,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26159,30.87,0.43,14.9,6842,75,NULL,'3.6 micron, color corrected','NGC 1035',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26160,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26160,30.88,0.4,15,6842,75,NULL,'B','NGC 1035',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26161,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26161,30.97,0.39,15.6,6842,73,NULL,'IR','NGC 1035',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26162,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26162,30.97,0.4,15.6,6842,75,NULL,NULL,'NGC 1035',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26163,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26163,31.01,0.2,15.9,6842,74.4,NULL,NULL,'NGC 1035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26164,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26164,31.07,0.4,16.4,6842,73,NULL,'opt','NGC 1035',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26165,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26165,31.19,0.35,17.3,6842,NULL,NULL,NULL,'NGC 1035',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26166,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26166,31.55,0.47,20.4,6842,75,NULL,'A82, H, raw','NGC 1035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26167,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26167,31.55,0.47,20.5,6842,75,NULL,'A82, H, inv','NGC 1035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26168,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26168,31.8,0.47,22.9,6842,75,NULL,'A82, H, cor','NGC 1035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26169,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26169,31.48,0.49,19.8,6843,75,NULL,'IR','2MFGC 02101',NULL,'2011yCatp016004901K',2011,1,NULL,'This is part of the galaxy NGC 1035.','PofG',0.00015,NULL,NULL,NULL,'HII',NULL,NULL,NULL,NULL,1,39.874667,-8.13919,0.029,NULL,37876298995,591817171,9247143,NULL),(26170,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26170,32.86,0.49,37.3,6844,75,NULL,'IR','NGC 1029',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.00006,NULL,'14.09',0.4,'S0/a','in a triple',NULL,NULL,NULL,1,39.90225,10.79333,0.305,NULL,67961650692,1061900792,16592199,14.09),(26171,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26171,34.33,0.64,73.6,6845,NULL,NULL,NULL,'NGC 1028',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.0001,NULL,'15.3',0.3,'Sa','in a triple',NULL,NULL,NULL,1,39.9047917,10.84367,0.305,NULL,67961640377,1061900630,16592197,15.3),(26172,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26172,34.44,0.2,77.3,6845,74.4,NULL,NULL,'NGC 1028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26173,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26173,34.59,0.57,82.9,6845,NULL,NULL,'Malmquist cor.','NGC 1028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26174,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26174,36.63,0.44,212,6846,NULL,NULL,'Malmquist cor.','2MASX J02393723+1803009',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',NULL,NULL,'13.7I',0.4,NULL,NULL,NULL,NULL,NULL,1,39.905083,18.05033,0.241,NULL,68069492189,1063585815,16618528,13.7),(26175,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26175,36.84,0.4,234,6846,NULL,NULL,NULL,'2MASX J02393723+1803009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26176,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26176,37.1,0.2,263,6846,74.4,NULL,NULL,'2MASX J02393723+1803009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26177,'Cepheids','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26177,29.84,0.08,9.29,6847,NULL,NULL,'HST KP Calibrated','NGC 1023 GROUP',NULL,'2000ApJ...529..745F',2000,1,NULL,NULL,'GGroup',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,39.9077917,39.3475,0.193,NULL,68666146243,1072908535,16764195,NULL),(26178,'PNLF','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26178,30.08,0.08,10.4,6847,NULL,NULL,'HST KP Calibrated','NGC 1023 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26179,'SBF','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26179,30.08,0.11,10.4,6847,NULL,NULL,'HST KP Calibrated, I','NGC 1023 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26180,'SBF','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26180,30.44,0.14,12.2,6847,NULL,NULL,'HST KP Calibrated, F814W','NGC 1023 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26181,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26181,33.34,0.2,46.6,6848,74.4,NULL,NULL,'ESO 545- G 043',NULL,'2013AJ....146...86T',2013,1,0.96,NULL,'G',0.000033,NULL,'15.10',0.42,'Sb',NULL,NULL,NULL,NULL,1,39.927083,-21.23994,0.039,NULL,37940771039,592824547,9262883,15.1),(26182,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26182,33.98,0.32,62.6,6848,NULL,NULL,NULL,'ESO 545- G 043',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26183,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26183,34,0.31,63.2,6848,NULL,NULL,'Malmquist cor.','ESO 545- G 043',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26184,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26184,35.56,0.53,130,6849,70,NULL,NULL,'2MASX J02394906-0253435',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.48',0.39,NULL,NULL,NULL,NULL,NULL,1,39.9545,-2.89544,0.053,NULL,34957431183,546209862,8534529,16.48),(26185,'SZ effect','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26185,40.17,0.37,1080,6850,NULL,NULL,'Hydrost. Eq.','ABELL 0370',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III [BM]',NULL,NULL,NULL,NULL,1,39.960375,-1.58561,0.065,NULL,34902424622,545350384,8521099,NULL),(26186,'SZ effect','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26186,40.45,NULL,1230,6850,NULL,NULL,NULL,'ABELL 0370',NULL,'2005ApJ...625..108D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26187,'SZ effect','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26187,41.07,0.49,1640,6850,NULL,NULL,'Isotherm.','ABELL 0370',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26188,'SZ effect','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26188,41.16,NULL,1710,6850,NULL,NULL,'3.1 (red) calibration','ABELL 0370',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26189,'SZ effect','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26189,41.31,0.45,1830,6850,NULL,NULL,'Isotherm., r < 100 kpc','ABELL 0370',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26190,'SZ effect','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26190,41.46,NULL,1960,6850,NULL,NULL,'4.2 (black) calibration','ABELL 0370',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26191,'SZ effect','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26191,41.57,NULL,2060,6850,NULL,NULL,'4.1 (blue) calibration','ABELL 0370',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26192,'SZ effect','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26192,43.19,NULL,4350,6850,NULL,NULL,NULL,'ABELL 0370',NULL,'2002ApJ...581...53R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26193,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26193,35.06,0.45,103,6851,NULL,NULL,'K','NGC 1030',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.00002,NULL,'14.22',0.7,'S0',NULL,NULL,NULL,NULL,1,39.960833,18.02428,0.241,NULL,68140731380,1064698927,16635920,14.22),(26194,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26194,35.13,0.47,106,6851,NULL,NULL,'H','NGC 1030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26195,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26195,35.19,0.46,109,6851,NULL,NULL,'J','NGC 1030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26196,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26196,35.22,0.3,110,6851,NULL,NULL,'Malmquist cor.','NGC 1030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26197,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26197,35.25,0.3,112,6851,NULL,NULL,NULL,'NGC 1030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26198,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26198,35.42,0.4,121,6851,NULL,NULL,'mean','NGC 1030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26199,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26199,35.55,0.2,129,6851,74.4,NULL,NULL,'NGC 1030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26200,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 06459','RN',26200,39.73,0.44,776,6852,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06459',0.136103,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26201,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 06459','RN',26201,39.86,0.41,827,6852,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06459',0.136103,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26202,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26202,36.23,0.49,176,6853,70,NULL,NULL,'2MASX J02395459-0132338',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.01',0.46,'Sb',NULL,NULL,NULL,'AGN',1,39.9775,-1.54267,0.065,NULL,34902411239,545350175,8521096,16.01),(26203,'GRB','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26203,44.66,0.58,2240,6854,69.7,NULL,'Calibrated','GRB 050603',2.821,'2009MNRAS.400..775C',2009,1,NULL,NULL,'VisS',NULL,NULL,'18.2V',NULL,'Swift',NULL,NULL,NULL,NULL,1,39.987083,-25.18183,0.032,NULL,38426144335,600408505,9381382,18.2),(26204,'GRB','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26204,45.12,0.55,2770,6854,69.7,NULL,'Fiducial','GRB 050603',2.821,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26205,'GRB','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26205,45.32,0.61,3030,6854,72,NULL,NULL,'GRB 050603',2.821,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26206,'GRB','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26206,45.45,0.61,3220,6854,70,NULL,NULL,'GRB 050603',2.821,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26207,'GRB','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26207,45.66,0.66,3560,6854,NULL,NULL,NULL,'GRB 050603',2.821,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26208,'GRB','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26208,47.02,1.53,6650,6854,100,NULL,NULL,'GRB 050603',2.821,'2009EPJC...63..139W',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26209,'GRB','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26209,47.25,1.47,7380,6854,69.7,NULL,'Calibrated','GRB 050603',2.821,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26210,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 03949','RN',26210,41.9,0.24,1970,6855,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03949',0.21665,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26211,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 03949','RN',26211,41.97,0.36,2040,6855,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03949',0.21665,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26212,'IRAS','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26212,35.88,0.8,150,6856,75,NULL,'CF, r','UGC 02151',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'14.47',0.8,'SAc',NULL,NULL,NULL,NULL,1,39.9913333333,28.32547,0.329,NULL,68618272028,1072160500,16752507,14.47),(26213,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26213,35.39,0.38,119,6856,75,NULL,'CF, r, raw','UGC 02151',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26214,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26214,35.6,0.38,132,6856,75,NULL,'CF, r, inv','UGC 02151',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26215,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26215,35.67,0.38,136,6856,75,NULL,'CF, r, cor','UGC 02151',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26216,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26216,35.98,0.4,157,6856,NULL,NULL,'mean','UGC 02151',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26217,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26217,36.2,0.47,173,6856,NULL,NULL,'H','UGC 02151',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26218,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 18369','RN',26218,41.89,0.16,1710,6857,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 18369',0.394883,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26219,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 18369','RN',26219,42.02,0.21,1820,6857,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 18369',0.394883,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26220,'Carbon Stars','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26220,20.57,0.57,0.13,6858,NULL,NULL,'Carbon star S13, RA 040.0741, DEC -34.4599','Fornax Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,1,17,NULL,'G',0.000003,NULL,'9.28',12.6,'dE0','Group member',NULL,NULL,NULL,1,39.9972083333,-34.44919,NULL,0,38630254945,603597733,9431214,9.28),(26221,'Carbon Stars','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26221,20.7,0.57,0.138,6858,NULL,NULL,'Carbon star S18, RA 040.2223, DEC -34.2037','Fornax Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26222,'Carbon Stars','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26222,20.72,0.57,0.139,6858,NULL,NULL,'Carbon star S10, RA 040.0278, DEC -34.3895','Fornax Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26223,'Carbon Stars','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26223,20.72,0.57,0.139,6858,NULL,NULL,'Carbon star S19, RA 040.2648, DEC -34.8015','Fornax Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26224,'Carbon Stars','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26224,20.75,0.57,0.141,6858,NULL,NULL,'Carbon star S3, RA 039.7211, DEC -34.8224','Fornax Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26225,'Carbon Stars','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26225,20.84,0.57,0.147,6858,NULL,NULL,'Carbon star S20, RA 040.2847, DEC -34.5978','Fornax Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26226,'Carbon Stars','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26226,20.85,0.57,0.148,6858,NULL,NULL,'Carbon star S11, RA 040.0426, DEC -34.5561','Fornax Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26227,'Carbon Stars','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26227,20.85,0.57,0.148,6858,NULL,NULL,'Carbon star S7, RA 040.0039, DEC -34.3787','Fornax Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26228,'Carbon Stars','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26228,20.87,0.57,0.149,6858,NULL,NULL,'Carbon star S16, RA 040.1301, DEC -34.4789','Fornax Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26229,'Carbon Stars','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26229,20.87,0.57,0.149,6858,NULL,NULL,'Carbon star S4, RA 039.7375, DEC -34.7760','Fornax Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26230,'Carbon Stars','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26230,20.88,0.57,0.15,6858,NULL,NULL,'Carbon star S5, RA 039.7377, DEC -34.7969','Fornax Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26231,'Carbon Stars','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26231,20.95,0.57,0.155,6858,NULL,NULL,'Carbon star S17, RA 040.2177, DEC -34.6231','Fornax Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26232,'Carbon Stars','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26232,21.01,0.57,0.159,6858,NULL,NULL,'Carbon star S8, RA 040.0056, DEC -34.3386','Fornax Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26233,'Carbon Stars','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26233,21.05,0.57,0.162,6858,NULL,NULL,'Carbon star S12, RA 040.0651, DEC -34.5675','Fornax Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26234,'Carbon Stars','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26234,21.06,0.57,0.163,6858,NULL,NULL,'Carbon star S6, RA 039.8138, DEC -34.2523','Fornax Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26235,'Carbon Stars','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26235,21.14,0.57,0.169,6858,NULL,NULL,'Carbon star S15, RA 040.1043, DEC -34.4829','Fornax Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26236,'Carbon Stars','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26236,21.15,0.57,0.17,6858,NULL,NULL,'Carbon star S14, RA 040.0831, DEC -34.5527','Fornax Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26237,'Carbon Stars','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26237,21.18,0.57,0.172,6858,NULL,NULL,'Carbon star S9, RA 040.0114, DEC -34.5303','Fornax Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26238,'CMD','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26238,18.4,0.03,0.0479,6858,NULL,NULL,'ESO 356-SC 001, Hodge 2','Fornax Dwarf Spheroidal',NULL,'2014ApJ...797...35G',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26239,'CMD','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26239,18.4,0.03,0.0479,6858,NULL,NULL,'Hodge 6','Fornax Dwarf Spheroidal',NULL,'2014ApJ...797...35G',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26240,'CMD','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26240,20.26,0.17,0.113,6858,NULL,NULL,NULL,'Fornax Dwarf Spheroidal',NULL,'1994AAS...184.4810G',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26241,'CMD','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26241,20.59,0.22,0.131,6858,NULL,NULL,'PHOTOGRAPHIC','Fornax Dwarf Spheroidal',NULL,'1985A&A...152...65B',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26242,'CMD','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26242,20.79,NULL,0.144,6858,NULL,NULL,NULL,'Fornax Dwarf Spheroidal',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26243,'CMD','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26243,20.88,NULL,0.15,6858,NULL,NULL,NULL,'Fornax Dwarf Spheroidal',NULL,'2013MNRAS.434.1138D',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26244,'CMD','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26244,20.8,0.2,0.15,6858,NULL,NULL,'Photographic','Fornax Dwarf Spheroidal',NULL,'1981AJ.....86..357V',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26245,'Delta Scuti','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26245,20.93,0.07,0.153,6858,NULL,NULL,NULL,'Fornax Dwarf Spheroidal',NULL,'2011AJ....142..110M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26246,'Horizontal Branch','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26246,20.4,0.14,0.12,6858,NULL,NULL,NULL,'Fornax Dwarf Spheroidal',NULL,'1995MNRAS.277.1354I',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26247,'Horizontal Branch','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26247,20.62,0.08,0.133,6858,NULL,NULL,NULL,'Fornax Dwarf Spheroidal',NULL,'1999AJ....118.1671B',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26248,'Horizontal Branch','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26248,20.7,0.3,0.138,6858,NULL,NULL,'ESO 356-SC 001, Hodge 2, and ESO 356-SC 005, Hodge 4','Fornax Dwarf Spheroidal',NULL,'1995AJ....109.1628B',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26249,'Horizontal Branch','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26249,20.72,0.06,0.139,6858,NULL,NULL,NULL,'Fornax Dwarf Spheroidal',NULL,'2007MNRAS.380.1255R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26250,'Horizontal Branch','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26250,20.74,NULL,0.141,6858,NULL,NULL,NULL,'Fornax Dwarf Spheroidal',NULL,'2004AJ....127..840P',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26251,'Horizontal Branch','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26251,20.76,0.1,0.142,6858,NULL,NULL,'ESO 356-SC 008, Fornax Dwarf Cluster 5, Hodge 5','Fornax Dwarf Spheroidal',NULL,'1999AJ....118.1671B',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26252,'Horizontal Branch','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26252,20.76,0.04,0.142,6858,NULL,NULL,NULL,'Fornax Dwarf Spheroidal',NULL,'2000A&A...355...56S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26253,'Horizontal Branch','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26253,20.76,NULL,0.142,6858,NULL,NULL,'ESO 355-SC 029, Fornax Dwarf Cluster 1, Hodge 1','Fornax Dwarf Spheroidal',NULL,'1990PASP..102..632D',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26254,'Horizontal Branch','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26254,20.81,NULL,0.145,6858,NULL,NULL,NULL,'Fornax Dwarf Spheroidal',NULL,'2004AJ....127..840P',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26255,'Horizontal Branch','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26255,20.81,NULL,0.145,6858,NULL,NULL,NULL,'Fornax Dwarf Spheroidal',NULL,'1985IAUS..113..541W',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26256,'Horizontal Branch','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26256,20.82,0.14,0.146,6858,NULL,NULL,NULL,'Fornax Dwarf Spheroidal',NULL,'1986MmSAI..57..561G',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26257,'M Stars','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26257,20.42,NULL,0.121,6858,NULL,NULL,NULL,'Fornax Dwarf Spheroidal',NULL,'2010ApJ...722..750S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26258,'Miras','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26258,20.69,0.04,0.137,6858,NULL,18.39,NULL,'Fornax Dwarf Spheroidal',NULL,'2009MNRAS.394..795W',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26259,'Red Clump','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26259,20.6,NULL,0.132,6858,NULL,NULL,'Udalski 2000','Fornax Dwarf Spheroidal',NULL,'2000ApJ...543L..23B',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26260,'Red Clump','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26260,20.66,NULL,0.136,6858,NULL,NULL,'Popowski 2000','Fornax Dwarf Spheroidal',NULL,'2000ApJ...543L..23B',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26261,'Red Clump','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26261,20.73,0.09,0.14,6858,NULL,NULL,NULL,'Fornax Dwarf Spheroidal',NULL,'2007MNRAS.380.1255R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26262,'Red Clump','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26262,20.74,0.11,0.141,6858,NULL,NULL,'K','Fornax Dwarf Spheroidal',NULL,'2007A&A...467.1025G',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26263,'Red Clump','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26263,20.86,0.01,0.148,6858,NULL,NULL,'K','Fornax Dwarf Spheroidal',NULL,'2003AJ....125.2494P',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26264,'Red Clump','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26264,20.86,0.01,0.148,6858,NULL,NULL,NULL,'Fornax Dwarf Spheroidal',NULL,'2003AJ....125.2494P',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26265,'RR Lyrae','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26265,20.53,0.09,0.128,6858,NULL,NULL,'ESO 356-SC 005, Fornax Dwarf Cluster 4, Hodge 4, Z high','Fornax Dwarf Spheroidal',NULL,'2007ApJ...670..332G',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26266,'RR Lyrae','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26266,20.53,0.08,0.128,6858,NULL,18.44,NULL,'Fornax Dwarf Spheroidal',NULL,'2010JAVSO..38..100M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26267,'RR Lyrae','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26267,20.57,0.11,0.13,6858,NULL,18.44,NULL,'Fornax Dwarf Spheroidal',NULL,'2010JAVSO..38..100M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26268,'RR Lyrae','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26268,20.58,0.05,0.131,6858,NULL,NULL,'Fornax Dwarf Cluster 1','Fornax Dwarf Spheroidal',NULL,'2003MNRAS.345..747M',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26269,'RR Lyrae','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26269,20.64,0.09,0.134,6858,NULL,NULL,'ESO 356-SC 005, Fornax Dwarf Cluster 4, Hodge 4, Z low','Fornax Dwarf Spheroidal',NULL,'2007ApJ...670..332G',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26270,'RR Lyrae','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26270,20.66,0.03,0.136,6858,NULL,NULL,NULL,'Fornax Dwarf Spheroidal',NULL,'2003MNRAS.345..747M',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26271,'RR Lyrae','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26271,20.66,0.07,0.136,6858,NULL,NULL,'ESO 356-SC 008, Fornax Dwarf Cluster 5, Hodge 5, Fe/H = -1.73','Fornax Dwarf Spheroidal',NULL,'2009ApJ...701.1323G',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26272,'RR Lyrae','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26272,20.67,NULL,0.136,6858,NULL,NULL,NULL,'Fornax Dwarf Spheroidal',NULL,'2008ApJ...679...52T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26273,'RR Lyrae','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26273,20.67,0.05,0.136,6858,NULL,NULL,'Fornax Dwarf Cluster 2','Fornax Dwarf Spheroidal',NULL,'2003MNRAS.345..747M',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26274,'RR Lyrae','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26274,20.66,0.05,0.136,6858,NULL,NULL,'Fornax Dwarf Cluster 3','Fornax Dwarf Spheroidal',NULL,'2003MNRAS.345..747M',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26275,'RR Lyrae','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26275,20.74,0.05,0.141,6858,NULL,NULL,'Fornax Dwarf Cluster 5','Fornax Dwarf Spheroidal',NULL,'2003MNRAS.345..747M',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26276,'RR Lyrae','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26276,20.76,0.07,0.142,6858,NULL,NULL,'ESO 356-SC 008, Fornax Dwarf Cluster 5, Hodge 5, Fe/H = -2.20','Fornax Dwarf Spheroidal',NULL,'2009ApJ...701.1323G',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26277,'RR Lyrae','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26277,20.9,0.05,0.151,6858,NULL,NULL,NULL,'Fornax Dwarf Spheroidal',NULL,'2011AJ....142..110M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26278,'TRGB','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26278,20.65,0.11,0.135,6858,NULL,NULL,NULL,'Fornax Dwarf Spheroidal',NULL,'2000ApJ...543L..23B',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26279,'TRGB','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26279,20.7,0.12,0.138,6858,NULL,NULL,NULL,'Fornax Dwarf Spheroidal',NULL,'2000A&A...355...56S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26280,'TRGB','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26280,20.71,0.07,0.139,6858,NULL,NULL,NULL,'Fornax Dwarf Spheroidal',NULL,'2007MNRAS.380.1255R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26281,'TRGB','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26281,20.7,NULL,0.14,6858,NULL,NULL,NULL,'Fornax Dwarf Spheroidal',NULL,'2000glg..book.....V',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26282,'TRGB','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26282,20.75,0.19,0.141,6858,NULL,NULL,'K','Fornax Dwarf Spheroidal',NULL,'2007A&A...467.1025G',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26283,'TRGB','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26283,20.76,0.04,0.142,6858,NULL,NULL,'I','Fornax Dwarf Spheroidal',NULL,'2007ApJ...661..815R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26284,'TRGB','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26284,20.84,0.03,0.147,6858,NULL,NULL,'J','Fornax Dwarf Spheroidal',NULL,'2009AJ....138..459P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26285,'TRGB','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26285,20.84,0.04,0.147,6858,NULL,NULL,'K','Fornax Dwarf Spheroidal',NULL,'2009AJ....138..459P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26286,'TRGB','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26286,20.84,0.08,0.15,6858,74.4,NULL,NULL,'Fornax Dwarf Spheroidal',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26287,'TRGB','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26287,21.08,0.11,0.164,6858,NULL,NULL,'V, upper limit distance','Fornax Dwarf Spheroidal',NULL,'1999AJ....118.1671B',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26288,'Type II Cepheids','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26288,20.5,0.16,0.126,6858,NULL,NULL,'15','Fornax Dwarf Spheroidal',NULL,'2014MNRAS.437.2307R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26289,'Type II Cepheids','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26289,20.7,0.02,0.138,6858,NULL,NULL,NULL,'Fornax Dwarf Spheroidal',NULL,'2008ApJ...685..947P',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26290,'Type II Cepheids','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26290,20.71,0.04,0.139,6858,NULL,NULL,NULL,'Fornax Dwarf Spheroidal',NULL,'2006MmSAI..77..219P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26291,'Tully est','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26291,20,0.8,0.1,6858,75,NULL,'B','Fornax Dwarf Spheroidal',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26292,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 01504','RN',26292,41.21,0.24,1320,6859,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01504',0.317369,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26293,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 01504','RN',26293,41.46,0.17,1490,6859,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01504',0.317369,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26294,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 01504','N',26294,41.03,0.14,1610,6859,70,NULL,'SALT 2','SDSS-II SN 01504',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26295,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 01504','N',26295,41.07,0.14,1640,6859,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 01504',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26296,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 1994am',NULL,26296,40.28,0.44,829,6860,74.2,NULL,'SALT 2','[PDG95] J024002.10-013715.8',0.372,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,'19.79',NULL,'E',NULL,NULL,NULL,NULL,1,40.00875,-1.62106,0.065,NULL,34902590871,545352982,8521140,19.79),(26297,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 1994am',NULL,26297,41.16,0.15,1240,6860,70,NULL,'SALT','[PDG95] J024002.10-013715.8',0.372,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26298,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26298,37.23,0.69,279,6861,70,NULL,NULL,'2MASX J02400263-0951128',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.43',NULL,NULL,NULL,NULL,NULL,NULL,1,40.0109583333,-9.85375,0.057,NULL,37880472662,591882385,9248162,16.43),(26299,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26299,36.47,0.53,197,6862,70,NULL,NULL,'2MASX J02400371-1250474',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.86',0.32,NULL,NULL,NULL,NULL,NULL,1,40.0155,-12.84653,0.013,NULL,38086573544,595102711,9298479,16.86),(26300,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 21605',NULL,26300,40.52,1.08,1270,6863,70,NULL,'SN photometric redshift distance, z photo =0.357 +/- 0.343','SDSS-II SN 21605',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.4g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,40.01825,0.38131,0.053,NULL,66849755677,1044527432,16320741,21.4),(26301,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26301,35.65,0.59,135,6864,70,NULL,NULL,'2MASX J02400444-2255218',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.43',0.43,'S0',NULL,NULL,NULL,NULL,1,40.0185,-22.92275,0.031,NULL,37949861188,592966581,9265102,16.43),(26302,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 1994H',NULL,26302,40.19,0.42,794,6865,74.2,NULL,'SALT 2','[PPG94] 023732.30-014657.6',0.374,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,'21.1',NULL,'S/comp',NULL,NULL,NULL,NULL,1,40.02,-1.56847,0.065,NULL,34902589730,545352964,8521140,21.1),(26303,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 1994H',NULL,26303,41.1,0.25,1210,6865,70,NULL,'SALT','[PPG94] 023732.30-014657.6',0.374,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26304,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26304,34.94,0.49,97.1,6866,75,NULL,'IR','NGC 1038',NULL,'2011yCatp016004901K',2011,1,1.2,'RC3 gives an HI velocity of 4372 +/- 9 km/sec.','G',0.00007,NULL,'14.37',0.4,'(R\')S0/a:','in a radial-velocity based grouping',NULL,NULL,NULL,1,40.0263333333,1.50878,0.057,NULL,66852258590,1044566540,16321352,14.37),(26305,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26305,35.51,0.57,127,6867,NULL,NULL,'Malmquist cor.','CGCG 462-040',NULL,'2009ApJS..182..474S',2009,1,0.75,NULL,'G',0.000033,NULL,'14.9',0.4,'SBb',NULL,NULL,NULL,NULL,1,40.058,17.88256,0.241,NULL,68141592900,1064712389,16636131,14.9),(26306,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26306,36,0.45,159,6867,NULL,NULL,NULL,'CGCG 462-040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26307,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26307,36.04,0.2,161,6867,74.4,NULL,NULL,'CGCG 462-040',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26308,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 11540','RN',26308,40.09,0.22,855,6868,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 11540',0.216538,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26309,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 11540','RN',26309,40.25,0.18,920,6868,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 11540',0.216538,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26310,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 11540','N',26310,39.93,0.12,968,6868,70,NULL,'SALT 2','SDSS-II SN 11540',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26311,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 11540','N',26311,39.94,0.12,973,6868,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 11540',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26312,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26312,35.06,0.56,103,6869,70,NULL,NULL,'NGC 1033',NULL,'2014MNRAS.445.2677S',2014,1,1.12,NULL,'G',0.000047,NULL,'14.4g',0.96,'SA(s)c:',NULL,NULL,NULL,NULL,1,40.067167,-8.77694,0.041,NULL,37875991146,591812361,9247068,14.4),(26313,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26313,35,0.4,99.9,6869,NULL,NULL,'mean','NGC 1033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26314,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26314,35.13,0.47,106,6869,NULL,NULL,'H','NGC 1033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26315,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26315,35.21,0.56,110,6870,70,NULL,NULL,'MCG -02-07-056',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.9b',0.4,NULL,NULL,NULL,NULL,NULL,1,40.0852916667,-12.48836,0.033,NULL,38086618015,595103406,9298490,15.9),(26316,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26316,37.81,0.46,365,6871,70,NULL,NULL,'2MASX J02402152-0911121',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000085,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,40.089583,-9.18683,0.033,NULL,37876088851,591813888,9247092,17.1),(26317,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 11054','RN',26317,40.93,0.35,1460,6872,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 11054',0.051351,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26318,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 11054','RN',26318,41.7,0.39,2080,6872,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 11054',0.051351,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26319,'Tully est','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26319,30.89,0.8,15.1,6873,75,NULL,NULL,'UGC 02162',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.00002,NULL,'16.2',1.3,'IB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,40.0962083,1.22925,0.057,NULL,66852477903,1044569967,16321405,16.2),(26320,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26320,28.12,0.36,4.21,6874,NULL,NULL,NULL,'NGC 1042',NULL,'2009AJ....138..323T',2009,1,4.7,'Confused HIPASS source','G',0.000007,NULL,'11.5B',3.6,'SAB(rs)cd      NLAGN','in a triple',NULL,NULL,NULL,1,40.099875,-8.43356,0.057,NULL,37877841950,591841280,9247520,11.5),(26321,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26321,29.45,0.47,7.77,6874,NULL,NULL,'H','NGC 1042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26322,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26322,29.46,0.46,7.8,6874,NULL,NULL,'J','NGC 1042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26323,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26323,29.5,0.45,7.94,6874,NULL,NULL,'K','NGC 1042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26324,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26324,29.62,0.4,8.4,6874,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 3 galaxy group','NGC 1042',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26325,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26325,30.61,0.4,13.2,6874,NULL,NULL,'mean','NGC 1042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26326,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26326,30.88,0.4,15,6874,73,NULL,'opt','NGC 1042',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26327,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26327,31.11,0.4,16.7,6874,75,NULL,'B','NGC 1042',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26328,'Brightest Stars','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26328,30.06,0.42,10.3,6875,NULL,NULL,NULL,'NGC 1023',NULL,'2002Ap.....45..253T',2002,1,8.7,NULL,'G',0.000013,NULL,'10.35',3,'SB(rs)0-','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,40.1000416667,39.06328,0.253,NULL,68666602444,1072915663,16764307,10.35),(26329,'GCLF','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26329,29.99,0.47,9.95,6875,NULL,NULL,'blue GCs, TOM(V) = -7.17 mag','NGC 1023',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26330,'GCLF','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26330,31.16,0.31,17.1,6875,NULL,NULL,'all GCs, TOM(V) = -7.63 mag','NGC 1023',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26331,'GCLF','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26331,31.47,0.39,19.7,6875,NULL,NULL,'red GCs, TOM(V) = -7.55 mag','NGC 1023',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26332,'PNLF','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26332,29.96,0.1,9.82,6875,NULL,NULL,NULL,'NGC 1023',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26333,'PNLF','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26333,29.97,0.13,9.86,6875,NULL,NULL,'110 PNe','NGC 1023',NULL,'1991ApJ...383..487C',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26334,'PNLF','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26334,30.07,0.11,10.3,6875,NULL,NULL,'HST KP Calibrated','NGC 1023',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26335,'SBF','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26335,29.91,0.09,9.6,6875,NULL,NULL,'I','NGC 1023',NULL,'1997ApJ...475..399T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26336,'SBF','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26336,30.08,0.09,10.4,6875,NULL,NULL,'I','NGC 1023',NULL,'1997AJ....114..626A',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26337,'SBF','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26337,30.09,0.14,10.4,6875,74.4,NULL,NULL,'NGC 1023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26338,'SBF','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26338,30.29,0.16,11.4,6875,NULL,NULL,'I','NGC 1023',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26339,'SBF','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26339,30.29,0.16,11.4,6875,NULL,NULL,NULL,'NGC 1023',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26340,'SBF','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26340,30.32,0.16,11.6,6875,NULL,NULL,'Malmquist cor.','NGC 1023',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26341,'SBF','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26341,30.35,0.19,11.7,6875,NULL,NULL,'HST KP Calibrated, I','NGC 1023',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26342,'SBF','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26342,30.44,0.14,12.2,6875,NULL,NULL,'HST KP Calibrated, F814W','NGC 1023',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26343,'TRGB','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26343,29.93,0.11,9.7,6875,NULL,NULL,NULL,'NGC 1023',NULL,'2002Ap.....45..253T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26344,'Faber-Jackson','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26344,29.21,0.63,6.95,6875,95,NULL,'Michard 1979b, c','NGC 1023',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26345,'Faber-Jackson','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26345,29.44,0.46,7.73,6875,95,NULL,'Michard 1979a','NGC 1023',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26346,'Faber-Jackson','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26346,29.75,0.29,8.91,6875,95,NULL,'Weighted Mean','NGC 1023',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26347,'Faber-Jackson','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26347,30.11,0.47,10.5,6875,95,NULL,'de Vaucouleurs','NGC 1023',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26348,'Faber-Jackson','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26348,30.15,NULL,10.7,6875,NULL,NULL,'LEDA [April 2006]','NGC 1023',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26349,'Faber-Jackson','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26349,30.97,0.81,15.6,6875,55,NULL,'Visvanathan & Sandage 1979','NGC 1023',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26350,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26350,29.86,0.41,9.36,6875,NULL,NULL,NULL,'NGC 1023',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26351,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26351,30.08,0.41,10.4,6875,NULL,NULL,'Malmquist cor.','NGC 1023',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26352,'Tertiary','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26352,29.09,0.22,6.58,6875,95,NULL,NULL,'NGC 1023',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26353,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26353,30.11,0.4,10.5,6875,75,NULL,'B','NGC 1023',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26354,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26354,34.4,0.49,76,6876,70,NULL,NULL,'NGC 1041',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.00009,NULL,'14.26',1.2,'S0- pec',NULL,NULL,NULL,NULL,1,40.1050833333,-5.44044,0.017,NULL,34952136182,546127127,8533236,14.26),(26355,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 15971','R',26355,41.27,0.25,1360,6877,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J024027.02+003134.5',0.316,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',NULL,NULL,'20.9g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,40.112625,0.52628,0.053,NULL,66849648993,1044525765,16320715,20.9),(26356,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 15971','R',26356,41.53,0.2,1530,6877,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J024027.02+003134.5',0.316,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26357,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 15971',NULL,26357,41.16,0.14,1710,6877,70,NULL,'SALT 2','SDSS J024027.02+003134.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26358,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 15971',NULL,26358,41.19,0.14,1730,6877,70,NULL,'SALT 2, Malmquist cor.','SDSS J024027.02+003134.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26359,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26359,33.27,NULL,45,6878,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02159',NULL,'2010Ap&SS.325..163P',2010,1,1.14,NULL,'G',0.000015,NULL,'16.5',0.12,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,40.114875,30.08025,0.417,NULL,68610417511,1072037773,16750590,16.5),(26360,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26360,33.28,NULL,45.3,6878,NULL,NULL,'Dipole + Quadrupole','UGC 02159',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26361,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26361,33.3,NULL,45.8,6878,NULL,NULL,'Dipole','UGC 02159',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26362,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26362,33.42,0.43,48.3,6878,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02159',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26363,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26363,33.49,0.2,49.9,6878,74.4,NULL,NULL,'UGC 02159',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26364,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26364,33.54,0.43,50.9,6878,75,NULL,'3.6 micron, color corrected','UGC 02159',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26365,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26365,36.31,0.5,183,6879,70,NULL,NULL,'VV 200a',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'15.6b',0.15,NULL,NULL,NULL,NULL,NULL,1,40.1202917,-12.87722,0.021,NULL,38086569602,595102650,9298478,15.6),(26366,'Tully est','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26366,30.25,0.8,11.2,6880,75,NULL,'B','NGC 1036',NULL,'1988NBGC.C....0000T',1988,1,1.4,NULL,'G',0.000017,NULL,'13.75',1,'Pec?',NULL,NULL,NULL,NULL,1,40.1207916667,19.29711,0.245,NULL,68090492624,1063913947,16623655,13.75),(26367,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26367,29.53,0.69,8.07,6880,100,NULL,'mid-IR','NGC 1036',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26368,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 14149','RN',26368,41.79,0.38,1480,6881,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14149',0.53615,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26369,'Tully est','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26369,31.06,0.8,16.3,6882,75,NULL,NULL,'UGCA 038',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.000019,NULL,'16',1.2,'SB(s)m:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,40.1257917,-6.10639,0.049,NULL,34951323885,546114435,8533038,16),(26370,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26370,35.89,0.54,151,6883,70,NULL,NULL,'ESO 546- G 001',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15',0.7,'S0-a',NULL,NULL,NULL,NULL,1,40.131,-20.37269,0.079,NULL,37941338351,592833411,9263022,15),(26371,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 13660','R',26371,41.17,0.33,1250,6884,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13660',0.370585,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,'PHOT','21.8g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,40.155,-0.55225,0.053,NULL,34901618085,545337782,8520902,21.8),(26372,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 13660','R',26372,41.43,0.32,1410,6884,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13660',0.370585,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26373,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 13660',NULL,26373,41.02,0.23,1600,6884,70,NULL,'SALT 2','SDSS-II SN 13660',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26374,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 13660',NULL,26374,41.08,0.23,1640,6884,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13660',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26375,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 13660',NULL,26375,41.16,0.26,1710,6884,70,NULL,'SN photometric redshift distance, z photo =0.525 +/- 0.096','SDSS-II SN 13660',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26376,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 16007','RN',26376,42.82,0.27,2490,6885,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 16007',0.469016,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26377,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26377,35.8,0.52,145,6886,70,NULL,NULL,'MCG -03-07-053',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.00015,NULL,'15.4b',0.25,NULL,NULL,NULL,NULL,NULL,1,40.1914166667,-17.12014,0.043,NULL,38092002292,595187535,9299805,15.4),(26378,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26378,34.91,0.47,96.1,6887,NULL,NULL,'H','MCG -03-07-052',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000033,NULL,'14.64',1,'SAB(s)c',NULL,NULL,NULL,NULL,1,40.1917917,-15.14103,0.045,NULL,38099452393,595303943,9301624,14.64),(26379,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26379,34.98,0.4,99,6887,NULL,NULL,'mean','MCG -03-07-052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26380,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26380,35.08,0.46,104,6887,NULL,NULL,'J','MCG -03-07-052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26381,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26381,36.41,0.33,191,6888,70,NULL,NULL,'2MASX J02404788-0846389',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000068,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,40.1995,-8.77744,0.037,NULL,37875988192,591812315,9247067,16.9),(26382,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 04659','RN',26382,44.11,0.38,4140,6889,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04659',0.606849,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26383,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26383,36.11,0.46,167,6890,70,NULL,NULL,'2MASX J02404997-0910159',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000087,NULL,'16.1g',0.39,NULL,NULL,NULL,NULL,NULL,1,40.2082917,-9.17106,0.029,NULL,37875923831,591811309,9247051,16.1),(26384,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2005jv',NULL,26384,41.42,0.2,1350,6891,74.2,NULL,'SALT 2','SDSS J024050.02+005941.4',0.42,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,40.2084166667,0.99483,0.065,NULL,66852350993,1044567984,16321374,NULL),(26385,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2005jv',NULL,26385,41.2,0.25,1730,6891,70,NULL,'Hubble residual 0.39 for z0.42200','SDSS J024050.02+005941.4',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26386,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2005jv',NULL,26386,42.13,0.34,1870,6891,65,NULL,'SALT2','SDSS J024050.02+005941.4',0.42,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26387,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2005jv',NULL,26387,42.17,0.22,1910,6891,70,NULL,'SALT 2','SDSS J024050.02+005941.4',0.42,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26388,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 08030','R',26388,42.19,0.3,1920,6891,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005jv','SDSS J024050.02+005941.4',0.422,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26389,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2005jv',NULL,26389,42.27,0.12,2010,6891,65,NULL,'MLCS2k2','SDSS J024050.02+005941.4',0.42,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26390,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 08030','R',26390,42.42,0.3,2140,6891,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005jv','SDSS J024050.02+005941.4',0.422,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26391,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26391,35.3,0.4,115,6892,NULL,NULL,'mean','CGCG 462-042',NULL,'2007A&A...465...71T',2007,1,0.8,'1999ApJS..121..287H has V = 7672 +- 23 km/sec.','G',0.000033,NULL,'15.46',0.2,'S?',NULL,NULL,NULL,NULL,1,40.20825,21.60939,0.397,NULL,68093495952,1063960874,16624388,15.46),(26392,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26392,35.44,0.47,123,6892,NULL,NULL,'H','CGCG 462-042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26393,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26393,35.47,0.49,124,6892,75,NULL,'IR','CGCG 462-042',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26394,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26394,35.51,0.46,126,6892,NULL,NULL,'J','CGCG 462-042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26395,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26395,35.51,0.2,126,6892,74.4,NULL,NULL,'CGCG 462-042',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26396,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26396,35.54,0.45,128,6892,NULL,NULL,'K','CGCG 462-042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26397,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2006nh',NULL,26397,40.66,0.19,1360,6893,70,NULL,'Hubble residual 0.11 for z0.36500','SDSS J024050.57+003931.6',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,40.2107083,0.65878,0.053,NULL,66849613018,1044525203,16320706,NULL),(26398,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 15704','R',26398,41.69,0.25,1600,6893,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006nh','SDSS J024050.57+003931.6',0.365,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26399,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 15704','R',26399,41.85,0.23,1720,6893,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006nh','SDSS J024050.57+003931.6',0.365,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26400,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2006nh',NULL,26400,41.61,0.16,2100,6893,70,NULL,'SALT 2','SDSS J024050.57+003931.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26401,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2006nh',NULL,26401,41.66,0.16,2150,6893,70,NULL,'SALT 2, Malmquist cor.','SDSS J024050.57+003931.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26402,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26402,37.06,0.51,258,6894,70,NULL,NULL,'6dF J0240547-230456',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,40.228333,-23.08217,0.016,NULL,37950043790,592969434,9265147,15.3),(26403,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26403,34.54,0.2,80.9,6895,74.4,NULL,NULL,'UGC 02167',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000127,NULL,'14.93',0.4,'SBcd:','Group member',NULL,NULL,NULL,1,40.2302916667,8.59578,0.297,NULL,67955139419,1061799053,16590610,14.93),(26404,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26404,34.64,0.46,84.7,6895,NULL,NULL,NULL,'UGC 02167',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26405,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26405,34.83,0.42,92.6,6895,NULL,NULL,'Malmquist cor.','UGC 02167',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26406,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26406,35.87,0.58,149,6896,70,NULL,NULL,'2MASX J02410138-0449514',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.45',0.37,NULL,NULL,NULL,NULL,NULL,1,40.25575,-4.83097,0.041,NULL,34951462442,546116600,8533071,16.45),(26407,'Tully est','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26407,31.01,0.8,15.9,6897,75,NULL,NULL,'NGC 0961',NULL,'1988NBGC.C....0000T',1988,1,1.95,'The APM image includes a superposed star.','G',0.000017,NULL,'13.4g',1.07,'SB(rs)m pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,40.260375,-6.93592,0.041,NULL,37875498518,591804664,9246947,13.4),(26408,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26408,31.65,0.43,21.4,6897,75,NULL,'3.6 micron, color + selection bias corrected','NGC 0961',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26409,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26409,34.8,0.47,91.4,6898,70,NULL,NULL,'MCG -02-07-065',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.42',0.6,'S0?',NULL,NULL,NULL,NULL,1,40.2687083333,-13.44614,0,NULL,38098848105,595294501,9301476,15.42),(26410,'SBF','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26410,31.28,0.27,18,6899,NULL,NULL,'I','NGC 1052',NULL,'2003ApJ...583..712J',2003,1,3,NULL,'G',0.00002,NULL,'12.08',2.1,'E4;LINER       Sy2','in a triple',NULL,'radio jet','Flat-Spectrum Radio Source',1,40.27,-8.25578,0.057,NULL,37878616895,591853388,9247709,12.08),(26411,'SBF','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26411,31.42,0.14,19.2,6899,74.4,NULL,NULL,'NGC 1052',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26412,'SBF','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26412,31.44,0.27,19.4,6899,NULL,NULL,'I','NGC 1052',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26413,'SBF','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26413,31.44,0.27,19.4,6899,NULL,NULL,NULL,'NGC 1052',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26414,'SBF','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26414,31.57,0.27,20.6,6899,NULL,NULL,'Malmquist cor.','NGC 1052',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26415,'D-Sigma','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26415,31.37,0.4,18.8,6899,75,NULL,'Edat, raw','NGC 1052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26416,'D-Sigma','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26416,31.71,0.4,21.9,6899,75,NULL,'Edat, cor','NGC 1052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26417,'Faber-Jackson','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26417,30.76,0.32,14.2,6899,95,NULL,'de Vaucouleurs','NGC 1052',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26418,'Faber-Jackson','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26418,30.98,0.24,15.7,6899,95,NULL,'Weighted Mean','NGC 1052',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26419,'Faber-Jackson','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26419,31.02,0.63,16,6899,95,NULL,'Michard 1979b, c','NGC 1052',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26420,'Faber-Jackson','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26420,31.47,0.46,19.7,6899,95,NULL,'Michard 1979a','NGC 1052',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26421,'Faber-Jackson','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26421,31.76,NULL,22.5,6899,NULL,NULL,'LEDA [April 2006]','NGC 1052',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26422,'Faber-Jackson','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26422,33.12,0.81,42.1,6899,55,NULL,'Visvanathan & Sandage 1979','NGC 1052',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26423,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26423,31.39,0.41,19,6899,NULL,NULL,NULL,'NGC 1052',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26424,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26424,31.66,0.41,21.4,6899,NULL,NULL,'Malmquist cor.','NGC 1052',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26425,'Tertiary','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26425,30.69,0.25,13.7,6899,95,NULL,NULL,'NGC 1052',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26426,'Tully est','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26426,31.25,0.8,17.8,6899,75,NULL,'B','NGC 1052',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26427,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26427,31.19,0.4,17.3,6899,NULL,NULL,'mean','NGC 1052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26428,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26428,31.58,0.45,20.7,6899,NULL,NULL,'K','NGC 1052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26429,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26429,36.27,0.68,180,6900,70,NULL,NULL,'2MASX J02410563-1924096',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00012,NULL,'16.42',0.27,'S0',NULL,NULL,NULL,NULL,1,40.2734583,-19.40269,0.066,NULL,37937566158,592774471,9262101,16.42),(26430,'SGRB','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26430,38.01,0.48,400,6901,NULL,NULL,NULL,'GRB 001204',NULL,'2006ApJ...640..849N',2006,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Ulysses/Ko/NE',NULL,NULL,NULL,NULL,1,40.285833,12.89611,0.305,NULL,68147112131,1064798627,16637478,NULL),(26431,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2007ov',NULL,26431,40.23,0.13,1110,6902,70,NULL,'Hubble residual -0.07 for z0.31530','SDSS J024108.79+000839.2',NULL,'2011ApJ...740...92G',2011,1,0.07,NULL,'G',0.0005,NULL,'20.6g',0.04,NULL,NULL,NULL,NULL,NULL,1,40.286625,0.14425,0.065,NULL,66849231118,1044519236,16320613,20.6),(26432,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 19632','R',26432,41.09,0.23,1250,6902,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ov','SDSS J024108.79+000839.2',0.3153,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26433,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 19632','R',26433,41.18,0.18,1310,6902,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ov','SDSS J024108.79+000839.2',0.3153,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26434,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2007ov',NULL,26434,41,0.14,1580,6902,70,NULL,'SALT 2','SDSS J024108.79+000839.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26435,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2007ov',NULL,26435,41.03,0.14,1610,6902,70,NULL,'SALT 2, Malmquist cor.','SDSS J024108.79+000839.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26436,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26436,34.64,0.49,84.6,6903,75,NULL,'IR','UGC 02164',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.00003,NULL,'15.2',0.4,'Sbc',NULL,NULL,NULL,NULL,1,40.288917,43.68269,0.461,NULL,68547915428,1071061178,16735330,15.2),(26437,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 17775','RN',26437,42.76,0.26,2470,6904,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17775',0.447013,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26438,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 17775','RN',26438,43.35,0.17,3230,6904,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 17775',0.447013,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26439,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26439,36.41,0.33,191,6905,70,NULL,NULL,'2MASX J02411283-0849093',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000076,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,40.303375,-8.81914,0.049,NULL,37876105515,591814148,9247096,16.7),(26440,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26440,34.89,0.48,95.1,6906,70,NULL,NULL,'IC 0251',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000127,NULL,'15.3b',0.4,NULL,NULL,NULL,NULL,NULL,1,40.3077083,-14.95783,0.013,NULL,38100426560,595319165,9301861,15.3),(26441,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26441,35.79,0.51,144,6907,70,NULL,NULL,'2MASX J02411662-1856546',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'15.97',0.22,'S',NULL,NULL,NULL,NULL,1,40.3192917,-18.94847,0.061,NULL,37937484629,592773197,9262081,15.97),(26442,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26442,35.35,0.56,118,6908,70,NULL,NULL,'6dF J0241177-095558',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,40.32425,-9.93264,0.045,NULL,37882552894,591914888,9248670,13.5),(26443,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 19352',NULL,26443,39.94,0.38,973,6909,70,NULL,'SN photometric redshift distance, z photo =0.260 +/- 0.060','SDSS-II SN 19352',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,40.329625,0.25314,0.065,NULL,66849335901,1044520873,16320638,NULL),(26444,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26444,35.84,0.53,147,6910,70,NULL,NULL,'2MASX J02412243-1809532',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'16.18',0.28,'S0',NULL,NULL,NULL,NULL,1,40.343375,-18.16494,0.006,NULL,38088729152,595136393,9299006,16.18),(26445,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26445,34.21,0.56,69.6,6911,70,NULL,NULL,'2MASX J02412395-6234209',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'15.96',0.27,'S',NULL,NULL,NULL,NULL,1,40.349625,-62.57256,0.017,NULL,36261632675,566588010,8852937,15.96),(26446,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26446,38.67,0.46,542,6912,70,NULL,NULL,'2MASXi J0241252-090116',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000081,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,40.3553333333,-9.02131,0.033,NULL,37875938324,591811536,9247055,18),(26447,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 15875','RN',26447,42.23,0.18,2190,6913,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15875',0.273562,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26448,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 15875','RN',26448,42.72,0.25,2750,6913,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15875',0.273562,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26449,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26449,35.4,0.45,120,6914,NULL,NULL,'K','IC 0248',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000033,NULL,'14.32',0.6,'Sa:',NULL,NULL,NULL,NULL,1,40.357625,17.81222,0.245,NULL,68141652230,1064713316,16636145,14.32),(26450,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26450,35.43,0.47,122,6914,NULL,NULL,'H','IC 0248',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26451,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26451,35.51,0.4,126,6914,NULL,NULL,'mean','IC 0248',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26452,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26452,35.56,0.46,129,6914,NULL,NULL,'J','IC 0248',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26453,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 17741','RN',26453,39.52,0.2,715,6915,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 17741',0.121719,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26454,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 17741','RN',26454,40.25,0.25,999,6915,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 17741',0.121719,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26455,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26455,35.6,0.47,132,6916,70,NULL,NULL,'MCG -02-07-068',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'15.21',0.8,'S0- pec',NULL,NULL,NULL,NULL,1,40.3593333333,-13.12836,0.033,NULL,38098866875,595294794,9301481,15.21),(26456,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 01214','RN',26456,42.31,0.25,2290,6917,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01214',0.264749,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26457,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26457,36.2,0.49,174,6918,70,NULL,NULL,'2MASX J02412982-0246198',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'16.02',0.5,NULL,NULL,NULL,NULL,NULL,1,40.374417,-2.77219,0.049,NULL,34909417606,545459650,8522807,16.02),(26458,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 13244','RN',26458,43.42,0.4,3540,6919,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13244',0.365548,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26459,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26459,35.88,0.46,150,6920,70,NULL,NULL,'2MASX J02413331+0023053',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000078,NULL,'16.6g',0.22,'NLAGN',NULL,NULL,NULL,NULL,1,40.3886666667,0.38483,0.065,NULL,66849187553,1044518555,16320602,16.6),(26460,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2005lq',NULL,26460,40.87,0.2,1080,6921,74.2,NULL,'SALT 2','SDSS J024136.02+001216.9',0.38,'2010ApJ...716..712A',2010,1,0.06,NULL,'G',NULL,NULL,'22.7g',0.03,NULL,NULL,NULL,NULL,NULL,1,40.4000833333,0.20469,0.065,NULL,66849328123,1044520751,16320636,22.7),(26461,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2005lq',NULL,26461,41.59,0.21,1510,6921,70,NULL,'SALT 2','SDSS J024136.02+001216.9',0.38,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26462,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 15503',NULL,26462,38.03,0.96,403,6922,70,NULL,'SN photometric redshift distance, z photo =0.099 +/- 0.060','SDSS-II SN 15503',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.5g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,40.4052083,0.2615,0.065,NULL,66849327022,1044520734,16320636,21.5),(26463,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 15503','R',26463,40.88,0.3,1060,6922,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15503',0.409642,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26464,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 15503','R',26464,41.03,0.32,1140,6922,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15503',0.409642,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26465,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 15503',NULL,26465,40.84,0.25,1470,6922,70,NULL,'SALT 2','SDSS-II SN 15503',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26466,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 15503',NULL,26466,40.91,0.25,1520,6922,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15503',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26467,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 17226','RN',26467,38.51,0.1,451,6923,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 17226',0.115962,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26468,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 17226','RN',26468,39.16,0.2,609,6923,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 17226',0.115962,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26469,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 20755','RN',26469,39.08,0.3,505,6924,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 20755',0.296793,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26470,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 20755','RN',26470,40.2,0.42,847,6924,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 20755',0.296793,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26471,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 18961','RN',26471,41.89,0.24,1740,6925,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18961',0.371537,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26472,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 18961','RN',26472,41.99,0.31,1820,6925,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18961',0.371537,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26473,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 18961','N',26473,41.95,0.19,2450,6925,70,NULL,'SALT 2','SDSS-II SN 18961',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26474,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 18961','N',26474,42.01,0.19,2520,6925,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18961',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26475,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 08705','R',26475,41.65,0.28,1530,6926,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 08705',0.394218,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,40.4330833333,0.26872,0.065,NULL,66849319730,1044520620,16320634,NULL),(26476,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 08705','R',26476,41.9,0.28,1720,6926,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 08705',0.394218,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26477,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 08705',NULL,26477,41.49,0.09,1980,6926,70,NULL,'SN photometric redshift distance, z photo =0.651 +/- 0.040','SDSS-II SN 08705',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26478,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 08705',NULL,26478,41.51,0.19,2000,6926,70,NULL,'SALT 2','SDSS-II SN 08705',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26479,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 08705',NULL,26479,41.57,0.19,2060,6926,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 08705',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26480,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26480,36.03,0.72,161,6927,70,NULL,NULL,'2MFGC 02137',NULL,'2014MNRAS.445.2677S',2014,1,0.98,NULL,'G',0.00015,NULL,'16.19',0.21,NULL,NULL,NULL,NULL,NULL,1,40.434375,-16.97136,0.057,NULL,38092417830,595194028,9299906,16.19),(26481,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26481,36.61,0.46,210,6928,70,NULL,NULL,'2MASX J02414437+0105443',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000102,NULL,'16.1g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,40.434917,1.09575,0.065,NULL,66852978239,1044577784,16321527,16.1),(26482,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26482,35.38,0.48,119,6929,70,NULL,NULL,'IC 0252',NULL,'2014MNRAS.445.2677S',2014,1,0.87,NULL,'G',0.000083,NULL,'15.35',0.56,NULL,NULL,NULL,NULL,NULL,1,40.4380417,-14.84825,0.013,NULL,38100445133,595319455,9301866,15.35),(26483,'IRAS','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26483,30.54,0.8,12.8,6930,75,NULL,'A82, H','NGC 1055',NULL,'1997ApJS..109..333W',1997,1,7.6,'Confused and extended HIPASS source','G',0.000017,NULL,'11.40',2.7,'SBb: sp;Sy2   LINER2','in a radial-velocity based grouping',NULL,NULL,NULL,1,40.4384583333,0.44317,0.065,NULL,66849179028,1044518422,16320600,11.4),(26484,'Sosies','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26484,31.54,0.11,20.3,6930,NULL,NULL,NULL,'NGC 1055',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26485,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26485,30.51,0.4,12.6,6930,75,NULL,'B','NGC 1055',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26486,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26486,30.67,0.47,13.6,6930,75,NULL,'A82, H, raw','NGC 1055',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26487,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26487,30.79,0.35,14.4,6930,NULL,NULL,NULL,'NGC 1055',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26488,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26488,30.79,0.4,14.4,6930,73,NULL,'opt','NGC 1055',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26489,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26489,30.81,0.47,14.5,6930,75,NULL,'A82, H, inv','NGC 1055',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26490,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26490,31.03,0.43,16.1,6930,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1055',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26491,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26491,31.06,0.47,16.3,6930,75,NULL,'A82, H, cor','NGC 1055',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26492,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26492,31.16,0.4,17.1,6930,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 2 galaxy group','NGC 1055',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26493,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26493,31.24,0.43,17.7,6930,75,NULL,'3.6 micron, color corrected','NGC 1055',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26494,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26494,31.54,0.2,20.3,6930,74.4,NULL,NULL,'NGC 1055',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26495,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26495,31.72,0.46,22.1,6930,NULL,NULL,'Malmquist cor.','NGC 1055',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26496,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26496,31.77,0.45,22.6,6930,NULL,NULL,NULL,'NGC 1055',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26497,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26497,31.89,NULL,23.9,6930,NULL,NULL,'LEDA [April 2006]','NGC 1055',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26498,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 04519','RN',26498,41.82,0.28,1950,6931,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 04519',0.186411,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26499,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 04519','RN',26499,42.57,0.27,2750,6931,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 04519',0.186411,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26500,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26500,37.08,0.46,260,6932,70,NULL,NULL,'2MASX J02414789+0112071',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000089,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,40.4495417,1.20208,0.065,NULL,66852902632,1044576603,16321509,16.9),(26501,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26501,36.91,0.61,241,6933,70,NULL,NULL,'2MASX J02415080-0050260',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.000092,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,40.4617916667,-0.84069,0.057,NULL,34904781801,545387215,8521675,16.4),(26502,'IRAS','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26502,34.55,0.8,81.3,6934,75,NULL,'CF, r','UGC 02176',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000097,NULL,'14.46',0.5,'Sb',NULL,NULL,NULL,NULL,1,40.475917,5.94806,0.189,NULL,66899201630,1045300025,16332812,14.46),(26503,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26503,34.31,0.2,72.8,6934,74.4,NULL,NULL,'UGC 02176',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26504,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26504,34.44,0.38,77.3,6934,75,NULL,'CF, r, raw','UGC 02176',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26505,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26505,34.56,0.38,81.6,6934,75,NULL,'CF, r, inv','UGC 02176',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26506,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26506,34.74,0.38,88.8,6934,75,NULL,'CF, r, cor','UGC 02176',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26507,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26507,34.75,0.09,89.3,6934,NULL,NULL,NULL,'UGC 02176',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26508,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26508,33.64,NULL,53.4,6935,NULL,NULL,'Dipole + Quadrupole','UGC 02171',NULL,'2010Ap&SS.325..163P',2010,1,1.61,NULL,'G',0.00002,NULL,'17.',0.17,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,40.4794583,32.08822,0.469,NULL,68677651653,1073088307,16767004,17),(26509,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26509,33.64,NULL,53.4,6935,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02171',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26510,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26510,33.64,NULL,53.4,6935,NULL,NULL,'Dipole','UGC 02171',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26511,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26511,33.72,NULL,55.5,6935,NULL,NULL,NULL,'UGC 02171',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26512,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26512,33.89,0.43,60.1,6935,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02171',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26513,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26513,33.91,0.2,60.5,6935,74.4,NULL,NULL,'UGC 02171',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26514,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26514,33.92,0.43,60.8,6935,75,NULL,'3.6 micron, color corrected','UGC 02171',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26515,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26515,34.05,0.34,64.7,6935,NULL,NULL,NULL,'UGC 02171',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26516,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26516,34.11,0.49,66.4,6935,75,NULL,'IR','UGC 02171',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26517,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26517,34.24,0.31,70.6,6935,NULL,NULL,'Malmquist cor.','UGC 02171',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26518,'Brightest Stars','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26518,27.16,NULL,2.7,6936,NULL,NULL,NULL,'Maffei 2',NULL,'2001ASPC..240..589H',2001,1,5.82,NULL,'G',0.000017,NULL,'9.3I',1.57,'SAB(rs)bc:','Group member',NULL,NULL,NULL,1,40.47925,59.60428,NULL,0,66358447665,1036850744,16200792,9.3),(26519,'TRGB','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26519,26.77,NULL,2.26,6936,NULL,NULL,NULL,'Maffei 2',NULL,'1994BSAO...38...32T',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26520,'TRGB','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26520,27.69,0.19,3.45,6936,NULL,NULL,'F160W','Maffei 2',NULL,'2014AJ....148....7W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26521,'TRGB','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26521,27.71,0.1,3.49,6936,74.4,NULL,NULL,'Maffei 2',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26522,'TRGB','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26522,27.73,0.19,3.52,6936,NULL,NULL,'F110W','Maffei 2',NULL,'2014AJ....148....7W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26523,'TRGB','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26523,27.73,0.19,3.52,6936,NULL,NULL,'Corrected','Maffei 2',NULL,'2014AJ....148....7W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26524,'CO ring diameter','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26524,28.31,NULL,4.6,6936,NULL,NULL,NULL,'Maffei 2',NULL,'1991PASJ...43..671S',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26525,'Grav. Stability Gas. Disk','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26525,28.74,NULL,5.6,6936,NULL,NULL,NULL,'Maffei 2',NULL,'1996AstL...22...71Z',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26526,'Tully est','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26526,27.67,0.8,3.4,6936,75,NULL,NULL,'Maffei 2',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26527,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26527,27.24,NULL,2.8,6936,NULL,NULL,NULL,'Maffei 2',NULL,'2003A&A...408..111K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26528,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26528,27.62,0.34,3.34,6936,NULL,NULL,'I','Maffei 2',NULL,'2007ApJ...655..814F',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26529,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26529,36.45,0.46,195,6937,70,NULL,NULL,'2MASX J02415647-0111580',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000068,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,40.4852917,-1.19936,0.065,NULL,34904853887,545388341,8521692,17.4),(26530,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26530,36.58,0.52,207,6938,70,NULL,NULL,'2MASX J02415660-0119210',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.00015,NULL,'15.89',0.48,NULL,NULL,NULL,NULL,NULL,1,40.485917,-1.32247,0.065,NULL,34904862105,545388470,8521694,15.89),(26531,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26531,35.46,0.52,124,6939,70,NULL,NULL,'MCG -01-07-035',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000033,NULL,'16',0.6,'SB(r)0+ pec',NULL,NULL,NULL,NULL,1,40.4874583,-6.79236,0.041,NULL,37874659959,591791561,9246743,16),(26532,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26532,38.13,0.46,423,6940,70,NULL,NULL,'SDSS J024200.68+000334.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000079,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,40.502875,0.05961,0.065,NULL,66849128340,1044517630,16320587,18.1),(26533,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 20489',NULL,26533,40.72,0.22,1390,6941,70,NULL,'SN photometric redshift distance, z photo =0.402 +/- 0.057','SDSS-II SN 20489',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','22.6g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,40.5134583,0.85631,0.065,NULL,66852780054,1044574688,16321479,22.6),(26534,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 20489','R',26534,41.64,0.29,1540,6941,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20489',0.379401,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26535,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 20489','R',26535,41.84,0.29,1690,6941,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20489',0.379401,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26536,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 20489',NULL,26536,41.54,0.2,2030,6941,70,NULL,'SALT 2','SDSS-II SN 20489',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26537,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 20489',NULL,26537,41.59,0.2,2080,6941,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20489',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26538,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2005ft',NULL,26538,38.92,0.12,524,6942,74.2,NULL,'SALT 2','SDSS J024205.00-003227.7',0.16,'2010ApJ...716..712A',2010,1,0.1,NULL,'G',0.0005,NULL,'20.3g',0.06,NULL,NULL,NULL,NULL,NULL,1,40.520833,-0.54103,0.057,NULL,34904321702,545380026,8521562,20.3),(26539,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2005ft',NULL,26539,39.1,0.07,661,6942,70,NULL,'Hubble residual -0.14 for z0.18050','SDSS J024205.00-003227.7',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26540,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 02372','R',26540,39.63,0.18,714,6942,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ft','SDSS J024205.00-003227.7',0.1805,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26541,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2005ft',NULL,26541,39.6,0.12,717,6942,70,NULL,'SALT 2','SDSS J024205.00-003227.7',0.16,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26542,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2005ft',NULL,26542,39.63,0.07,727,6942,65,NULL,'SALT2','SDSS J024205.00-003227.7',0.16,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26543,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2005ft',NULL,26543,39.69,NULL,747,6942,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 02372, SN 2005ft','SDSS J024205.00-003227.7',0.16,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26544,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 02372','R',26544,39.75,0.09,756,6942,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ft','SDSS J024205.00-003227.7',0.1805,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26545,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2005ft',NULL,26545,39.73,0.1,762,6942,65,NULL,'MLCS2k2','SDSS J024205.00-003227.7',0.16,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26546,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2005ft',NULL,26546,39.48,0.07,787,6942,70,NULL,'SALT 2','SDSS J024205.00-003227.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26547,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2005ft',NULL,26547,39.49,0.07,791,6942,70,NULL,'SALT 2, Malmquist cor.','SDSS J024205.00-003227.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26548,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2005ft',NULL,26548,39.89,0.04,818,6942,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 02372, SN 2005ft','SDSS J024205.00-003227.7',0.16,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26549,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 11444','RN',26549,41.63,0.29,1790,6943,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 11444',0.181919,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26550,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 16181','RN',26550,39.15,0.18,646,6944,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 16181',0.04621,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26551,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 16181','RN',26551,40.67,0.27,1300,6944,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 16181',0.04621,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26552,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','PTF10qwg','N',26552,37.17,0.1,254,6945,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10qwg',0.0679,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26553,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26553,29.84,NULL,9.29,6946,NULL,NULL,NULL,'UGC 02172',NULL,'2013AJ....145..101K',2013,1,1.8,NULL,'G',0.000057,NULL,'14.6',1.1,'IRR',NULL,NULL,NULL,NULL,1,40.545167,43.35519,0.473,NULL,68548497714,1071070276,16735473,14.6),(26554,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26554,34.62,0.68,84.1,6947,NULL,NULL,'Malmquist cor.','ESO 546- G 010',NULL,'2009ApJS..182..474S',2009,1,0.9,'Da Costa, et al. (1998,AJ,116,1) give v = 5211 +/- 25 km/sec.','G',0.000033,NULL,'15.23',0.57,'Sb-c',NULL,NULL,NULL,NULL,1,40.5519583,-19.82972,0.11,NULL,37938503340,592789114,9262329,15.23),(26555,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26555,34.65,0.67,85.1,6947,NULL,NULL,NULL,'ESO 546- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26556,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26556,34.69,0.2,86.7,6947,74.4,NULL,NULL,'ESO 546- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26557,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 00822',NULL,26557,39.09,0.64,656,6948,70,NULL,'SN photometric redshift distance, z photo =0.167 +/- 0.065','SDSS-II SN 00822',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,40.5607083,-0.86217,0.061,NULL,34904963589,545390056,8521719,NULL),(26558,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 00822',NULL,26558,40.05,0.23,1020,6948,70,NULL,NULL,'SDSS-II SN 00822',NULL,'2013MNRAS.434.1443X',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26559,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 00822','R',26559,40.61,0.23,1070,6948,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 00822',0.237556,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26560,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 00822','R',26560,40.65,0.18,1090,6948,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 00822',0.237556,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26561,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 00822',NULL,26561,40.39,0.13,1200,6948,70,NULL,'SALT 2','SDSS-II SN 00822',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26562,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 00822',NULL,26562,40.41,0.13,1210,6948,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 00822',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26563,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26563,36.52,0.67,201,6949,70,NULL,NULL,'2MASX J02421472-7823250',NULL,'2014MNRAS.445.2677S',2014,1,0.23,NULL,'G',0.00015,NULL,'16.6b',0.18,NULL,NULL,NULL,NULL,NULL,1,40.5615,-78.39031,0.329,NULL,35696236910,557753701,8714901,16.6),(26564,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26564,34.88,0.69,94.6,6950,100,NULL,'mid-IR','NGC 1054',NULL,'2013ApJ...771...88L',2013,1,0.9,NULL,'G',0.000017,NULL,'14.57',0.5,'S?',NULL,NULL,NULL,NULL,1,40.565583,18.21719,0.257,NULL,68140884518,1064701320,16635958,14.57),(26565,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26565,35.77,0.4,142,6950,NULL,NULL,'mean','NGC 1054',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26566,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26566,35.83,0.47,146,6950,NULL,NULL,'H','NGC 1054',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26567,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26567,35.96,0.45,156,6950,NULL,NULL,'K','NGC 1054',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26568,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26568,36,0.46,158,6950,NULL,NULL,'J','NGC 1054',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26569,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 08978','RN',26569,41.94,0.3,2030,6951,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 08978',0.204245,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26570,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 08978','RN',26570,43.06,0.38,3390,6951,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 08978',0.204245,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26571,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26571,35.19,0.47,109,6952,70,NULL,NULL,'MCG -01-07-037',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'14.76',0.25,NULL,NULL,NULL,NULL,NULL,1,40.59575,-3.10758,0.053,NULL,34907240704,545425636,8522275,14.76),(26572,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2006hh',NULL,26572,39.95,0.11,979,6953,70,NULL,'Hubble residual 0.18 for z0.23757','SDSS J024226.70-004739.1',NULL,'2011ApJ...740...92G',2011,1,0.19,NULL,'G',0.00015,NULL,'19.3g',0.08,NULL,NULL,NULL,NULL,NULL,1,40.6112916667,-0.79422,0.061,NULL,34904883572,545388805,8521700,19.3),(26573,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2006hh',NULL,26573,40.03,0.21,1010,6953,70,NULL,'SDSS-II SN 13511','SDSS J024226.70-004739.1',NULL,'2013MNRAS.434.1443X',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26574,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 13511','R',26574,40.59,0.21,1060,6953,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006hh','SDSS J024226.70-004739.1',0.23757,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26575,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 13511','R',26575,40.82,0.13,1180,6953,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006hh','SDSS J024226.70-004739.1',0.23757,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26576,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2006hh',NULL,26576,40.38,0.11,1190,6953,70,NULL,'SALT 2','SDSS J024226.70-004739.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26577,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2006hh',NULL,26577,40.39,0.11,1200,6953,70,NULL,'SALT 2, Malmquist cor.','SDSS J024226.70-004739.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26578,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26578,35.7,0.4,138,6954,NULL,NULL,'mean','ARK 090',NULL,'2007A&A...465...71T',2007,1,0.3,'1999ApJS..121..287H has V = 7770 +- 35 km/sec.','G',0.000017,NULL,'15.5',0.2,NULL,NULL,NULL,NULL,NULL,1,40.620875,18.16472,0.245,NULL,68140843147,1064700674,16635948,15.5),(26579,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26579,37.84,0.47,370,6954,NULL,NULL,'H','ARK 090',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26580,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2007qq',NULL,26580,40.02,0.26,1010,6955,70,NULL,'SDSS-II SN 20768','SDSS J024230.34-005816.5',NULL,'2013MNRAS.434.1443X',2013,1,0.19,NULL,'G',NULL,NULL,'21.2g',0.03,NULL,NULL,NULL,NULL,NULL,1,40.6264583,-0.97125,0.061,NULL,34904936701,545389635,8521713,21.2),(26581,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 20768','R',26581,40.71,0.19,1120,6955,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007qq','SDSS J024230.34-005816.5',0.24,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26582,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 20768','R',26582,40.72,0.28,1120,6955,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007qq','SDSS J024230.34-005816.5',0.24,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26583,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2007qq',NULL,26583,40.49,0.15,1250,6955,70,NULL,'SALT 2','SDSS J024230.34-005816.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26584,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2007qq',NULL,26584,40.51,0.15,1260,6955,70,NULL,'SALT 2, Malmquist cor.','SDSS J024230.34-005816.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26585,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26585,34.48,NULL,78.8,6956,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0333',NULL,'2010Ap&SS.325..163P',2010,1,1.04,NULL,'G',NULL,NULL,'16.71',0.1,'Sdm',NULL,NULL,NULL,NULL,1,40.631667,41.99822,0.273,NULL,68541743870,1070964747,16733824,16.71),(26586,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26586,34.51,NULL,80,6956,NULL,NULL,'Dipole + Quadrupole','FGC 0333',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26587,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26587,34.52,NULL,80.2,6956,NULL,NULL,'Dipole','FGC 0333',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26588,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26588,34.7,NULL,87.1,6956,NULL,NULL,NULL,'FGC 0333',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26589,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26589,35.17,0.47,108,6957,70,NULL,NULL,'MCG -02-07-072',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000143,NULL,'15.16',0.8,NULL,NULL,NULL,NULL,NULL,1,40.6392917,-9.46778,0.029,NULL,37882494388,591913974,9248655,15.16),(26590,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26590,35.9,0.46,151,6958,70,NULL,NULL,'2MASX J02423522-0809540',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000076,NULL,'16.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,40.6467916667,-8.16503,0.045,NULL,37878758586,591855602,9247743,16.2),(26591,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26591,33.23,0.45,44.2,6959,NULL,NULL,'K','NGC 1050',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000033,NULL,'13.47',1.1,'(R\')SB(s)a     HII','Isolated galaxy',NULL,NULL,'Sy 2',1,40.6482917,34.7635,0.201,NULL,68660284225,1072816941,16762764,13.47),(26592,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26592,33.29,0.47,45.6,6959,NULL,NULL,'H','NGC 1050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26593,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26593,33.36,0.46,47,6959,NULL,NULL,'J','NGC 1050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26594,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26594,33.6,0.4,52.5,6959,NULL,NULL,'mean','NGC 1050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26595,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26595,33.93,0.5,61,6960,70,NULL,NULL,'MCG -02-07-073',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00006,NULL,'14.19',0.9,'S0- pec:','in a triple',NULL,NULL,NULL,1,40.6600417,-12.42147,0.025,NULL,38097921120,595280017,9301250,14.19),(26596,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26596,34.7,0.62,87.1,6961,70,NULL,NULL,'2MASX J02423851-0338118',NULL,'2014MNRAS.445.2677S',2014,1,0.79,NULL,'G',0.000077,NULL,'15.45',0.54,NULL,NULL,NULL,NULL,NULL,1,40.6603333333,-3.63658,0.069,NULL,34907922446,545436288,8522442,15.45),(26597,'CO ring diameter','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26597,31.02,NULL,16,6962,NULL,NULL,NULL,'MESSIER 077',NULL,'1991PASJ...43..671S',1991,1,7.1,'2009A&A...505..417B incorrectly reports z = 0.0288; confused HIPASS source.','G',0.00001,NULL,'9.61',6,'(R)SA(rs)b;Sy1 Sy2','in a radial-velocity based grouping',NULL,'radio jet','Sy 2',1,40.669625,-0.01328,0.049,NULL,34901334983,545333359,8520833,9.61),(26598,'Maser','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26598,31.28,NULL,18,6962,NULL,NULL,NULL,'MESSIER 077',NULL,'1999AAS...19511509G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26599,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26599,30.02,0.36,10.1,6962,NULL,NULL,NULL,'MESSIER 077',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26600,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26600,30.02,0.39,10.1,6962,73,NULL,'opt','MESSIER 077',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26601,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26601,30.45,NULL,12.3,6962,75,NULL,'HI','MESSIER 077',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26602,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26602,30.5,NULL,12.6,6962,75,NULL,'CO','MESSIER 077',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26603,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26603,30.8,0.4,14.4,6962,75,NULL,'B','MESSIER 077',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26604,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26604,31.5,NULL,20,6962,NULL,NULL,'LEDA [April 2006]','MESSIER 077',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26605,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 19560','RN',26605,42.68,0.37,2860,6963,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19560',0.201744,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26606,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 19560','RN',26606,43.29,0.52,3790,6963,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19560',0.201744,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26607,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26607,36.7,0.62,219,6964,70,NULL,NULL,'2MASX J02424452-8532127',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9b',NULL,'SB(r)ab',NULL,NULL,NULL,NULL,1,40.683125,-85.53689,0.217,NULL,35496536601,554633384,8666146,15.9),(26608,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26608,34.55,0.47,81.4,6965,70,NULL,NULL,'2MASX J02424559-1925315',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.000083,NULL,'15.41',0.42,'S',NULL,NULL,NULL,NULL,1,40.6899166667,-19.42539,0.066,NULL,37937673581,592776149,9262127,15.41),(26609,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26609,37.3,0.46,288,6966,70,NULL,NULL,'2MASX J02424779-0844583',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00007,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,40.699,-8.74967,0.057,NULL,37877950544,591842977,9247546,17),(26610,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26610,30.79,0.69,14.4,6967,100,NULL,'mid-IR','NGC 1056',NULL,'2013ApJ...771...88L',2013,1,2.3,NULL,'G',0.000033,NULL,'13.32',1.1,'Sa;HII         Sy2',NULL,NULL,NULL,NULL,1,40.70125,28.57419,0.417,NULL,68617239006,1072144359,16752255,13.32),(26611,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26611,31.36,0.4,18.7,6967,NULL,NULL,'mean','NGC 1056',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26612,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26612,32.03,0.45,25.5,6967,NULL,NULL,'K','NGC 1056',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26613,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26613,32.08,0.47,26.1,6967,NULL,NULL,'H','NGC 1056',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26614,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26614,32.17,0.46,27.2,6967,NULL,NULL,'J','NGC 1056',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26615,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26615,32.41,0.43,30.3,6967,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1056',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26616,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26616,32.42,0.43,30.5,6967,75,NULL,'3.6 micron, color corrected','NGC 1056',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26617,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26617,32.45,0.2,30.9,6967,74.4,NULL,NULL,'NGC 1056',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26618,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26618,32.54,0.4,32.2,6967,NULL,NULL,NULL,'NGC 1056',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26619,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26619,32.54,0.39,32.2,6967,73,NULL,'opt','NGC 1056',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26620,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26620,35.95,0.89,155,6968,70,NULL,NULL,'2MASX J02424860-0848463',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,40.7024166667,-8.81294,0.045,NULL,37877952028,591843000,9247546,14.3),(26621,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26621,35.56,0.8,130,6969,70,NULL,NULL,'2MASX J02425197-0955593',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.69',0.4,NULL,NULL,NULL,NULL,NULL,1,40.7164166667,-9.93319,0.037,NULL,37882595895,591915560,9248680,15.69),(26622,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26622,37.5,0.46,316,6970,70,NULL,NULL,'2MASX J02425406-0821563',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000078,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,40.7250833333,-8.36581,0.049,NULL,37878674828,591854294,9247723,17.1),(26623,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26623,35.25,0.63,112,6971,70,NULL,NULL,'2MASX J02425711-1002593',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.10',NULL,NULL,NULL,NULL,NULL,NULL,1,40.737875,-10.04975,0.033,NULL,37882723447,591917553,9248711,16.1),(26624,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26624,34.93,0.69,96.6,6972,100,NULL,'mid-IR','NGC 1069',NULL,'2013ApJ...771...88L',2013,1,1.29,NULL,'G',0.000023,NULL,'14.1g',0.89,'SAB(s)c',NULL,NULL,NULL,NULL,1,40.74925,-8.2895,0.045,NULL,37878669596,591854212,9247722,14.1),(26625,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26625,35.72,0.4,139,6972,NULL,NULL,'mean','NGC 1069',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26626,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26626,35.72,0.47,139,6972,NULL,NULL,'H','NGC 1069',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26627,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26627,35.84,0.45,148,6972,NULL,NULL,'K','NGC 1069',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26628,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26628,35.86,0.46,149,6972,NULL,NULL,'J','NGC 1069',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26629,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26629,38.21,0.46,439,6973,70,NULL,NULL,'2MASX J02425980-0853453',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000091,NULL,'18.0g',0.18,'NLAGN',NULL,NULL,NULL,NULL,1,40.7492083333,-8.89597,0.045,NULL,37877739840,591839685,9247495,18),(26630,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26630,35.61,0.5,132,6974,NULL,NULL,'Malmquist cor.','CGCG 414-044',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000167,NULL,'15.7',0.4,NULL,NULL,NULL,NULL,NULL,1,40.7574583,8.13022,0.289,NULL,67956093627,1061813962,16590843,15.7),(26631,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26631,35.95,0.43,155,6974,NULL,NULL,NULL,'CGCG 414-044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26632,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26632,36.06,0.2,163,6974,74.4,NULL,NULL,'CGCG 414-044',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26633,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26633,37.67,0.33,343,6975,70,NULL,NULL,'2MASX J02430239-0024215',NULL,'2015arXiv151105856S',2015,1,0.09,NULL,'G',0.000078,NULL,'17.8g',0.07,NULL,NULL,NULL,NULL,NULL,1,40.759875,-0.40606,0.061,NULL,34904438854,545381857,8521591,17.8),(26634,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26634,37.67,0.33,343,6976,70,NULL,NULL,'2MASX J02430393-0022045',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000086,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,40.7664583,-0.36786,0.061,NULL,34904253553,545378961,8521546,17),(26635,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26635,35.78,0.23,143,6977,70,NULL,NULL,'2MASX J02430578-0808002',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000064,NULL,'16.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,40.7740417,-8.13342,0.045,NULL,37878726378,591855099,9247735,16.8),(26636,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 18799','RN',26636,40.5,0.19,1020,6978,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18799',0.23768,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26637,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 18799','RN',26637,41.31,0.24,1470,6978,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18799',0.23768,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26638,'IRAS','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26638,33.48,0.8,49.6,6979,75,NULL,'CF, r','UGC 02185',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000037,NULL,'13.54',0.9,'Scd:',NULL,NULL,NULL,NULL,1,40.797167,40.42675,0.241,NULL,68542143660,1070970994,16733921,13.54),(26639,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26639,33.52,0.38,50.5,6979,75,NULL,'CF, r, raw','UGC 02185',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26640,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26640,33.67,0.38,54.2,6979,75,NULL,'CF, r, inv','UGC 02185',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26641,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26641,33.73,0.49,55.8,6979,75,NULL,'IR','UGC 02185',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26642,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26642,33.8,0.38,57.6,6979,75,NULL,'CF, r, cor','UGC 02185',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26643,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26643,33.88,0.4,59.7,6979,NULL,NULL,'mean','UGC 02185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26644,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26644,33.93,0.46,61,6979,NULL,NULL,'J','UGC 02185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26645,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26645,33.93,0.2,61.1,6979,74.4,NULL,NULL,'UGC 02185',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26646,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26646,33.99,0.47,62.7,6979,NULL,NULL,'H','UGC 02185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26647,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26647,34.04,0.32,64.4,6979,NULL,NULL,NULL,'UGC 02185',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26648,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26648,34.06,0.45,64.9,6979,NULL,NULL,'K','UGC 02185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26649,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26649,34.16,0.3,67.8,6979,NULL,NULL,'Malmquist cor.','UGC 02185',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26650,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26650,35.85,0.49,148,6980,70,NULL,NULL,'MCG -01-07-040',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.000147,NULL,'14.81',0.2,NULL,NULL,NULL,NULL,NULL,1,40.808083,-8.12506,0.045,NULL,37878724499,591855070,9247735,14.81),(26651,'D-Sigma','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26651,33.94,0.4,61.3,6981,75,NULL,'Edat, raw','NGC 1060',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.000073,NULL,'13.00',1.7,'S0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,40.8127083,32.42497,0.469,NULL,68677702806,1073089106,16767017,13),(26652,'D-Sigma','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26652,34.27,0.4,71.5,6981,75,NULL,'Edat, cor','NGC 1060',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26653,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26653,33.9,0.45,60.2,6981,NULL,NULL,'K','NGC 1060',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26654,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26654,34.2,0.4,69.3,6981,NULL,NULL,'mean','NGC 1060',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26655,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26655,34.43,0.5,76.9,6982,70,NULL,NULL,'2MASX J02431524-6625378',NULL,'2014MNRAS.445.2677S',2014,1,NULL,'A much brighter star is superposed about 20 arcsec northeast.','G',0.000073,NULL,'14.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,40.813583,-66.42722,0.025,NULL,36505163105,570393173,8912393,14.2),(26656,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26656,35.18,0.57,109,6983,70,NULL,NULL,'MCG -03-07-061',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'15.4b',0.2,NULL,NULL,NULL,NULL,NULL,1,40.8176666667,-15.2615,0.025,NULL,38097433956,595272405,9301131,15.4),(26657,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 05286','RN',26657,40.78,0.36,1210,6984,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 05286',0.184953,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26658,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26658,35.38,0.49,119,6985,NULL,NULL,'Malmquist cor.','ESO 479- G 027',NULL,'2009ApJS..182..474S',2009,1,0.96,NULL,'G',0.000033,NULL,'15.70',0.29,'S...',NULL,NULL,NULL,NULL,1,40.826667,-23.84094,0.013,NULL,37947387384,592927927,9264498,15.7),(26659,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26659,35.37,0.49,119,6985,NULL,NULL,NULL,'ESO 479- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26660,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26660,35.41,0.2,121,6985,74.4,NULL,NULL,'ESO 479- G 027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26661,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26661,36.3,0.62,182,6986,70,NULL,NULL,'2MASX J02432205-0346062',NULL,'2014MNRAS.445.2677S',2014,1,0.95,NULL,'G',0.00015,NULL,'15.94',0.29,NULL,NULL,NULL,NULL,NULL,1,40.8418333333,-3.76836,0.065,NULL,34907882846,545435669,8522432,15.94),(26662,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 01508','RN',26662,42.18,0.14,1980,6987,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01508',0.37368,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26663,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 01508','RN',26663,42.28,0.21,2080,6987,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01508',0.37368,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26664,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 00913','RN',26664,40.8,0.08,1070,6988,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 00913',0.355451,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26665,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 00913','RN',26665,41.01,0.19,1180,6988,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00913',0.355451,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26666,'IRAS','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26666,34.08,0.8,65.6,6989,75,NULL,'W91PP, r','UGC 02197',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'15.10',1,'Scd:',NULL,NULL,NULL,NULL,1,40.8581666667,31.47089,0.517,NULL,68677949349,1073092958,16767077,15.1),(26667,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26667,33.87,0.2,59.4,6989,74.4,NULL,NULL,'UGC 02197',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26668,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26668,33.9,0.38,60.4,6989,75,NULL,'W91PP, r, raw','UGC 02197',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26669,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26669,33.94,0.35,61.5,6989,NULL,NULL,NULL,'UGC 02197',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26670,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26670,33.99,0.38,62.8,6989,75,NULL,'W91PP, r, inv','UGC 02197',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26671,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26671,34.03,0.38,63.9,6989,75,NULL,'W91PP, r, cor','UGC 02197',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26672,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26672,34.15,0.32,67.5,6989,NULL,NULL,'Malmquist cor.','UGC 02197',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26673,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26673,33.76,0.43,56.5,6990,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02194',NULL,'2014MNRAS.444..527S',2014,1,1.4,NULL,'G',0.000037,NULL,'14.42',0.7,'SBb:','Group member',NULL,NULL,NULL,1,40.861083,41.40678,0.305,NULL,68541895243,1070967113,16733861,14.42),(26674,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26674,34.33,0.4,73.5,6990,NULL,NULL,'mean','UGC 02194',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26675,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26675,34.56,0.47,81.6,6990,NULL,NULL,'H','UGC 02194',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26676,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26676,34.55,0.51,81.3,6991,70,NULL,NULL,'2MASX J02432705-0806331',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.000091,NULL,'15.0g',0.54,'NLAGN',NULL,NULL,NULL,NULL,1,40.8627917,-8.10933,0.045,NULL,37878712798,591854887,9247732,15),(26677,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26677,35.78,0.23,143,6991,70,NULL,NULL,'2MASX J02432705-0806331',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26678,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 00785','RN',26678,40.21,0.1,1070,6992,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 00785',0.027865,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26679,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 00785','RN',26679,40.89,0.27,1470,6992,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00785',0.027865,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26680,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26680,37.07,0.93,260,6993,70,NULL,NULL,'2MASX J02432905-0100102',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000095,NULL,'15.7g',0.43,'Sab',NULL,NULL,NULL,NULL,1,40.8710417,-1.00272,0.061,NULL,34904076640,545376197,8521503,15.7),(26681,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26681,31.52,0.69,20.1,6994,100,NULL,'mid-IR','NGC 1076',NULL,'2013ApJ...771...88L',2013,1,1.9,NULL,'G',0.000017,NULL,'13.71',1.1,'SB0/a pec?',NULL,NULL,NULL,NULL,1,40.871875,-14.75431,0.029,NULL,38100341402,595317834,9301841,13.71),(26682,'SNII optical','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 1969L',NULL,26682,30.13,0.35,10.6,6995,NULL,NULL,NULL,'NGC 1058',NULL,'1994ApJ...432...42S',1994,1,3,NULL,'G',0.000003,NULL,'11.2V',2.8,'SA(rs)c        Sy2','Group member, radial-velocity confirmed',NULL,NULL,'Sy 2',1,40.875,37.34133,0.229,NULL,68665953927,1072905530,16764148,11.2),(26683,'SNII optical','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 1969L',NULL,26683,30.25,0.36,11.2,6995,NULL,NULL,'EPM','NGC 1058',NULL,'1992ApJ...395..366S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26684,'SNII optical','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 1969L',NULL,26684,30.4,0.48,12,6995,NULL,NULL,'EPM, first use of','NGC 1058',NULL,'1974ApJ...193...27K',1974,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26685,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26685,26.88,8.66,2.37,6995,NULL,NULL,NULL,'NGC 1058',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26686,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26686,27.54,6.39,3.21,6995,NULL,NULL,'Malmquist cor.','NGC 1058',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26687,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26687,29.32,NULL,7.3,6995,NULL,NULL,NULL,'NGC 1058',NULL,'2011A&A...536A.103Z',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26688,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26688,29.8,0.4,9.1,6995,75,NULL,'B','NGC 1058',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26689,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26689,29.9,0.2,9.55,6995,NULL,18.45,'SN 1969L host','NGC 1058',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26690,'IRAS','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26690,33.79,0.8,57.2,6996,75,NULL,'W91PP, r','UGC 02198',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'15.63',0.2,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,40.886125,31.78997,0.517,NULL,68678478199,1073101221,16767206,15.63),(26691,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26691,33.3,0.2,45.7,6996,74.4,NULL,NULL,'UGC 02198',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26692,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26692,33.47,0.49,49.5,6996,75,NULL,'IR','UGC 02198',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26693,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26693,33.63,0.38,53.3,6996,75,NULL,'W91PP, r, raw','UGC 02198',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26694,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26694,33.69,0.38,54.7,6996,75,NULL,'W91PP, r, inv','UGC 02198',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26695,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26695,33.85,0.38,58.9,6996,75,NULL,'W91PP, r, cor','UGC 02198',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26696,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 13965','RN',26696,39.93,0.12,764,6997,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13965',0.266101,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26697,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 13965','RN',26697,40.85,0.21,1170,6997,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13965',0.266101,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26698,'Ring Diameter','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26698,30.4,0.76,12,6998,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 1073',NULL,'1981ApJS...45..541P',1981,1,4.9,NULL,'G',0.000017,NULL,'11.47',4.5,'SB(rs)c','in a radial-velocity based grouping',NULL,NULL,NULL,1,40.9188333333,1.37611,0.069,NULL,66852016051,1044562750,16321292,11.47),(26699,'Ring Diameter','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26699,30.7,0.6,14,6998,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 1073',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26700,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26700,30.91,0.4,15.2,6998,75,NULL,'B','NGC 1073',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26701,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 13661','RN',26701,42.07,0.11,2040,6999,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13661',0.268135,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26702,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 13661','RN',26702,42.13,0.19,2100,6999,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13661',0.268135,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26703,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26703,35.78,0.23,143,7000,70,NULL,NULL,'2MASX J02434198-0806046',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000077,NULL,'15.9g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,40.92475,-8.10119,0.045,NULL,37878645392,591853834,9247716,15.9),(26704,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26704,35.5,0.52,126,7001,70,NULL,NULL,'NGC 1105',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'15.44',0.6,'SAB(rs)0+: pec',NULL,NULL,NULL,NULL,1,40.9249166667,-15.70558,0.021,NULL,38089827006,595153546,9299274,15.44),(26705,'IRAS','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26705,33.35,0.8,46.7,7002,75,NULL,'W91PP, r','UGC 02201',NULL,'1997ApJS..109..333W',1997,1,2.02,NULL,'G',0.000015,NULL,'15.45',0.28,'Sc','Group member',NULL,NULL,NULL,1,40.934,32.49592,0.397,NULL,68677676396,1073088693,16767010,15.45),(26706,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26706,33.87,0.43,59.3,7002,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02201',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26707,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26707,34.03,NULL,64,7002,NULL,NULL,'Dipole','UGC 02201',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26708,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26708,34.04,NULL,64.1,7002,NULL,NULL,'Dipole + Quadrupole','UGC 02201',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26709,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26709,34.04,NULL,64.3,7002,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02201',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26710,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26710,34.05,0.43,64.5,7002,75,NULL,'3.6 micron, color corrected','UGC 02201',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26711,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26711,34.07,0.49,65.2,7002,75,NULL,'IR','UGC 02201',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26712,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26712,34.17,NULL,68.3,7002,NULL,NULL,NULL,'UGC 02201',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26713,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26713,34.24,0.2,70.5,7002,74.4,NULL,NULL,'UGC 02201',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26714,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26714,34.33,0.38,73.6,7002,75,NULL,'W91PP, r, raw','UGC 02201',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26715,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26715,34.34,0.31,73.9,7002,NULL,NULL,'Malmquist cor.','UGC 02201',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26716,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26716,34.38,0.38,75.3,7002,75,NULL,'W91PP, r, cor','UGC 02201',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26717,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26717,34.42,0.3,76.5,7002,NULL,NULL,NULL,'UGC 02201',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26718,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26718,34.42,0.38,76.7,7002,75,NULL,'W91PP, r, inv','UGC 02201',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26719,'Sosies','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26719,32.73,0.33,35.2,7003,NULL,NULL,NULL,'NGC 1079',NULL,'2002A&A...393...57T',2002,1,3.5,NULL,'G',0.000017,NULL,'12.74',2.1,'(R_1R\'_2)SAB(r\'l)a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,40.93475,-29.00336,0,NULL,38429682109,600463782,9382246,12.74),(26720,'Tully est','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26720,31.13,0.8,16.9,7003,75,NULL,'B','NGC 1079',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26721,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26721,31.9,0.2,24,7003,74.4,NULL,NULL,'NGC 1079',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26722,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 13233','RN',26722,43.95,0.22,3930,7004,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13233',0.573332,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26723,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26723,35.78,0.23,143,7005,70,NULL,NULL,'2MASX J02434595-0810566',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000079,NULL,'15.9g',0.37,'E0',NULL,NULL,NULL,NULL,1,40.9414166667,-8.18253,0.049,NULL,37878658813,591854043,9247719,15.9),(26724,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26724,36.01,0.84,159,7005,70,NULL,NULL,'2MASX J02434595-0810566',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26725,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26725,36.09,0.54,165,7006,70,NULL,NULL,'2MASX J02434696-1349005',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.41',NULL,NULL,NULL,NULL,NULL,NULL,1,40.9457917,-13.81686,0.029,NULL,38098589591,595290462,9301413,15.41),(26726,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 00824','RN',26726,40.78,0.09,1160,7007,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 00824',0.23728,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26727,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 00824','RN',26727,41.27,0.18,1450,7007,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00824',0.23728,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26728,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26728,37.29,0.46,287,7008,70,NULL,NULL,'2MASX J02434788-0059478',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000072,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,40.949583,-0.99647,0.061,NULL,34904068665,545376072,8521501,17.6),(26729,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26729,34.27,0.49,71.5,7009,75,NULL,'IR','UGC 02211',NULL,'2011yCatp016004901K',2011,1,1.48,NULL,'G',0.000012,NULL,'16.5',0.21,'Sc','Group member, peripheral',NULL,NULL,NULL,1,40.954583,6.64292,0.237,NULL,67952032051,1061750500,16589851,16.5),(26730,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26730,34.41,NULL,76.1,7009,NULL,NULL,NULL,'UGC 02211',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26731,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26731,34.45,NULL,77.6,7009,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02211',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26732,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26732,34.48,NULL,78.7,7009,NULL,NULL,'Dipole + Quadrupole','UGC 02211',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26733,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26733,34.49,NULL,78.9,7009,NULL,NULL,'Dipole','UGC 02211',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26734,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26734,34.55,0.2,81.3,7009,74.4,NULL,NULL,'UGC 02211',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26735,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26735,34.64,0.13,84.9,7009,NULL,NULL,NULL,'UGC 02211',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26736,'IRAS','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26736,34.34,0.8,73.7,7010,75,NULL,'W91PP, r','UGC 02205',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000033,NULL,'15.04',0.7,'SABc:',NULL,NULL,NULL,NULL,1,40.978667,33.16844,0.305,NULL,68712077643,1073626213,16775409,15.04),(26737,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26737,34.1,0.2,66.1,7010,74.4,NULL,NULL,'UGC 02205',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26738,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26738,34.39,0.34,75.4,7010,NULL,NULL,'Malmquist cor.','UGC 02205',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26739,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26739,34.46,0.33,77.9,7010,NULL,NULL,NULL,'UGC 02205',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26740,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26740,34.76,0.38,89.7,7010,75,NULL,'W91PP, r, raw','UGC 02205',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26741,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26741,34.88,0.38,94.8,7010,75,NULL,'W91PP, r, inv','UGC 02205',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26742,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26742,34.95,0.38,97.9,7010,75,NULL,'W91PP, r, cor','UGC 02205',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26743,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 01456',NULL,26743,39.42,0.21,765,7011,70,NULL,'SN photometric redshift distance, z photo =0.198 +/- 0.023','SDSS-II SN 01456',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.7g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,41.0249583333,0.52133,0.073,NULL,66850584843,1044540388,16320943,21.7),(26744,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 01456','R',26744,39.91,0.2,800,7011,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01456',0.199155,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26745,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 01456','R',26745,40.99,0.35,1310,7011,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01456',0.199155,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26746,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26746,35.75,0.48,141,7012,70,NULL,NULL,'FAIRALL 0012',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'15.9b',0.28,'Compact',NULL,NULL,NULL,NULL,1,41.0327083,-75.37928,0.245,NULL,35636900114,556826564,8700415,15.9),(26747,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26747,35.51,0.48,127,7013,70,NULL,NULL,'NGC 1078',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'15.32',0.3,'(R\'?)S0-:',NULL,NULL,NULL,NULL,1,41.0335,-9.45239,0.033,NULL,37879259917,591863436,9247866,15.32),(26748,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26748,34.79,0.58,90.8,7014,70,NULL,NULL,'2MASX J02442084-1639209',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'16.02',0.33,NULL,NULL,NULL,NULL,NULL,1,41.086833,-16.65575,0.021,NULL,38092274501,595191789,9299871,16.02),(26749,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26749,35.2,0.61,110,7015,70,NULL,NULL,'MCG -02-08-002',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.5',0.2,NULL,NULL,NULL,NULL,NULL,1,41.09425,-9.73767,0.037,NULL,37879142738,591861605,9247837,15.5),(26750,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26750,36.63,0.62,212,7016,70,NULL,NULL,'2MASX J02442557-1437389',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'17.20',0.26,NULL,NULL,NULL,NULL,NULL,1,41.1065,-14.62756,0.029,NULL,38100679904,595323123,9301923,17.2),(26751,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 03295','RN',26751,43.54,0.38,3010,7017,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03295',0.697949,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26752,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26752,35.59,0.72,132,7018,70,NULL,NULL,'2MASX J02443150-1438439',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.09',0.49,NULL,NULL,NULL,NULL,NULL,1,41.1312083333,-14.64547,0.029,NULL,38100666246,595322910,9301920,16.09),(26753,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 10440','RN',26753,39.56,0.24,762,7019,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10440',0.071714,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26754,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 10440','RN',26754,40.61,0.33,1230,7019,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10440',0.071714,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26755,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26755,35.61,0.5,132,7020,70,NULL,NULL,'2MASX J02443597-1940340',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'15.99',0.25,'S0',NULL,NULL,NULL,NULL,1,41.1497917,-19.67611,0.077,NULL,38059520784,594680012,9291875,15.99),(26756,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26756,35.57,0.46,130,7021,70,NULL,NULL,'2MASX J02443671+0008311',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000078,NULL,'16.0g',0.31,'S0^-',NULL,NULL,NULL,NULL,1,41.152917,0.14208,0.089,NULL,66850625811,1044541028,16320953,16),(26757,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26757,37.82,0.57,366,7022,70,NULL,NULL,'2MASX J02443751-2341360',NULL,'2014MNRAS.445.2677S',2014,1,0.36,'The APMUKS position is 10 arcsec southeast of the nucleus.','G',0.00015,NULL,'17.34',0.26,NULL,NULL,NULL,NULL,NULL,1,41.156375,-23.69328,0.044,NULL,37947200535,592925008,9264453,17.34),(26758,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26758,35.15,0.49,107,7023,70,NULL,NULL,'2MASX J02443926-1604249',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'15.28',0.51,NULL,NULL,NULL,NULL,NULL,1,41.1637083,-16.07375,0.021,NULL,38089878441,595154350,9299286,15.28),(26759,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26759,37.57,0.46,326,7024,70,NULL,NULL,'SDSS J024439.30-080108.8',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000078,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,41.16375,-8.01914,0.061,NULL,37878227700,591847307,9247614,16.9),(26760,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 21353','RN',26760,42.88,0.32,3070,7025,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 21353',0.225812,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26761,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 21353','RN',26761,43.22,0.29,3600,7025,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 21353',0.225812,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26762,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26762,35.26,0.46,113,7026,70,NULL,NULL,'2MASX J02444064-0907353',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000048,NULL,'15.7g',0.35,'NLAGN',NULL,NULL,NULL,'Sy 2',1,41.169375,-9.12656,0.029,NULL,37877419032,591834672,9247416,15.7),(26763,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26763,35.62,0.5,133,7027,70,NULL,NULL,'FAIRALL 1243',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.2B',0.83,NULL,NULL,NULL,NULL,NULL,1,41.17375,-72.85603,0.077,NULL,36323168916,567549514,8867961,15.2),(26764,'IRAS','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26764,34.96,0.8,98.2,7028,75,NULL,'CF, r','IC 1839',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.00011,NULL,'15.04',0.5,'Sbc',NULL,NULL,NULL,NULL,1,41.1787917,15.24008,0.305,NULL,68145328301,1064770754,16637043,15.04),(26765,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26765,34.72,0.38,87.7,7028,75,NULL,'CF, r, raw','IC 1839',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26766,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26766,34.83,0.38,92.6,7028,75,NULL,'CF, r, inv','IC 1839',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26767,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26767,34.89,0.2,95.1,7028,74.4,NULL,NULL,'IC 1839',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26768,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26768,35.01,0.39,100,7028,NULL,NULL,NULL,'IC 1839',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26769,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26769,35.01,0.38,101,7028,75,NULL,'CF, r, cor','IC 1839',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26770,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26770,35.1,0.37,105,7028,NULL,NULL,'Malmquist cor.','IC 1839',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26771,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26771,35.8,0.2,145,7029,74.4,NULL,NULL,'IC 1838',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000033,NULL,'15.2',0.2,NULL,NULL,NULL,NULL,NULL,1,41.179125,19.45511,0.217,NULL,68120603036,1064384422,16631006,15.2),(26772,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26772,34.15,0.2,67.6,7030,74.4,NULL,NULL,'CGCG 415-006',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.00012,NULL,'15.0',0.3,NULL,NULL,NULL,NULL,NULL,1,41.179583,5.33536,0.133,NULL,66845475604,1044460556,16319696,15),(26773,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26773,35.25,0.49,112,7031,75,NULL,'IR','UGC 02217',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000033,NULL,'15.40',0.2,'Sb',NULL,NULL,NULL,NULL,1,41.1805416667,16.72931,0.337,NULL,68144233373,1064753646,16636775,15.4),(26774,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26774,35.67,0.4,136,7031,NULL,NULL,'mean','UGC 02217',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26775,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26775,35.76,0.47,142,7031,NULL,NULL,'H','UGC 02217',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26776,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26776,35.83,0.45,146,7031,NULL,NULL,'K','UGC 02217',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26777,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26777,36.53,0.46,202,7032,70,NULL,NULL,'SDSS J024443.38-010654.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000076,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,41.1807917,-1.11511,0.065,NULL,34903642597,545369415,8521397,17.4),(26778,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26778,34.25,0.52,70.9,7033,70,NULL,NULL,'2MASX J02444408-0529176',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00009,NULL,'15.16',0.49,NULL,NULL,NULL,NULL,NULL,1,41.1835417,-5.48822,0.065,NULL,37853740538,591464695,9241635,15.16),(26779,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 17853','RN',26779,40.67,0.15,1260,7034,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 17853',0.079128,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26780,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 17853','RN',26780,41.19,0.24,1600,7034,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 17853',0.079128,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26781,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26781,35.64,0.68,134,7035,70,NULL,NULL,'MCG -01-08-002',NULL,'2014MNRAS.445.2677S',2014,1,1.13,NULL,'G',0.000083,NULL,'14.7g',0.89,'Sab',NULL,NULL,NULL,NULL,1,41.18925,-8.16414,0.049,NULL,37878166800,591846356,9247599,14.7),(26782,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,'R',26782,35.92,0.46,153,7036,70,NULL,NULL,'2MASX J02444570-0901343',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000071,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,41.1904583,-9.02619,0.029,NULL,37877421278,591834707,9247417,16.4),(26783,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 05021',NULL,26783,40.63,0.96,1340,7037,70,NULL,'SN photometric redshift distance, z photo =0.381 +/- 0.319','SDSS-II SN 05021',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,41.1907083333,-0.46831,0.053,NULL,34903723057,545370672,8521416,NULL),(26784,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 17340','R',26784,40.37,0.22,943,7038,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007kl','SDSS J024451.21+002155.1',0.26,'2014arXiv1401.3317S',2014,1,0.18,NULL,'G',NULL,NULL,'19.0g',0.11,NULL,NULL,NULL,NULL,NULL,1,41.213375,0.36531,0.085,NULL,66850472040,1044538625,16320916,19),(26785,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 17340','R',26785,40.54,0.17,1020,7038,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007kl','SDSS J024451.21+002155.1',0.26,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26786,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2007kl',NULL,26786,40.25,0.12,1120,7038,70,NULL,'SALT 2','SDSS J024451.21+002155.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26787,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2007kl',NULL,26787,40.27,0.12,1130,7038,70,NULL,'SALT 2, Malmquist cor.','SDSS J024451.21+002155.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26788,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 20723',NULL,26788,39.68,0.95,864,7039,70,NULL,'SN photometric redshift distance, z photo =0.227 +/- 0.155','SDSS-II SN 20723',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,41.21875,-0.10736,0.093,NULL,34903316386,545364318,8521317,NULL),(26789,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 20723',NULL,26789,40.53,0.33,1280,7039,70,NULL,NULL,'SDSS-II SN 20723',NULL,'2013MNRAS.434.1443X',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26790,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 20723','R',26790,41.44,0.31,1410,7039,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20723',0.377305,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26791,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 20723','R',26791,41.64,0.33,1550,7039,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20723',0.377305,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26792,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 20723',NULL,26792,41.25,0.24,1780,7039,70,NULL,'SALT 2','SDSS-II SN 20723',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26793,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 20723',NULL,26793,41.3,0.24,1820,7039,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20723',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26794,'FP','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26794,34.5,0.46,79.5,7040,70,NULL,NULL,'NGC 1098',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.000087,NULL,'14.33',1.3,'SA(s)0-:       LLAGN','Compact group member',NULL,NULL,NULL,1,41.223625,-17.65914,0.054,NULL,38088897643,595139025,9299047,14.33),(26795,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 05318','RN',26795,43.17,0.35,2640,7041,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05318',0.626789,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26796,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2005mh',NULL,26796,41.05,0.05,1160,7042,70,NULL,'SDSS-II SN 08707','SDSS J024456.67+001212.5',0.395,'2011ApJS..192....1C',2011,1,0.03,NULL,'G',NULL,NULL,'23.2g',0.02,NULL,NULL,NULL,NULL,NULL,1,41.236125,0.2035,0.089,NULL,66850478024,1044538719,16320917,23.2),(26797,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2005mh',NULL,26797,41.07,0.15,1170,7042,74.2,NULL,'SALT 2','SDSS J024456.67+001212.5',0.395,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26798,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SN 2005mh',NULL,26798,41.92,0.18,1740,7042,70,NULL,'SDSS-II SN 08707, SALT 2','SDSS J024456.67+001212.5',0.395,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26799,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 08707','R',26799,41.98,0.27,1790,7042,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2005mh','SDSS J024456.67+001212.5',0.3951,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26800,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:58','1','SDSS-II SN 08707','R',26800,42.01,0.17,1810,7042,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2005mh','SDSS J024456.67+001212.5',0.3951,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26801,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26801,31.97,NULL,24.8,7043,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02221',NULL,'2010Ap&SS.325..163P',2010,1,1.57,NULL,'G',0.000013,NULL,'17.',0.13,'Scd',NULL,NULL,NULL,NULL,1,41.241833,30.37794,0.501,NULL,68608631508,1072009867,16750154,17),(26802,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:58','1',NULL,NULL,26802,32,NULL,25.1,7043,NULL,NULL,'Dipole','UGC 02221',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26803,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26803,32,NULL,25.1,7043,NULL,NULL,'Dipole + Quadrupole','UGC 02221',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26804,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26804,32.13,NULL,26.6,7043,NULL,NULL,NULL,'UGC 02221',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26805,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,'R',26805,35.29,0.46,114,7044,70,NULL,NULL,'2MASX J02445852-0110146',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000072,NULL,'15.7g',0.39,'S0',NULL,NULL,NULL,NULL,1,41.2437917,-1.17089,0.069,NULL,34903448962,545366390,8521349,15.7),(26806,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26806,35.69,0.52,138,7044,70,NULL,NULL,'2MASX J02445852-0110146',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26807,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26807,36.21,0.25,175,7045,74.4,NULL,NULL,'GIN 141',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000077,NULL,'15.3V',NULL,'E','Group member',NULL,NULL,NULL,1,41.266583,36.71006,0.205,NULL,68665124887,1072892576,16763946,15.3),(26808,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26808,36.39,0.21,190,7045,70,NULL,NULL,'GIN 141',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26809,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,'R',26809,34.13,0.49,67,7046,75,NULL,'IR','ESO 479- G 032',NULL,'2011yCatp016004901K',2011,1,1.46,NULL,'G',0.000027,NULL,'15.88',0.2,'Sc',NULL,NULL,NULL,NULL,1,41.2669583333,-26.44928,0,NULL,38421358240,600333722,9380214,15.88),(26810,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SDSS-II SN 21396',NULL,26810,35.21,5.88,110,7047,70,NULL,'SN photometric redshift distance, z photo =0.026 +/- 0.473','SDSS-II SN 21396',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.4g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,41.271875,0.02497,0.089,NULL,66850492750,1044538949,16320921,21.4),(26811,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SDSS-II SN 21396','R',26811,40.94,0.34,1120,7047,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21396',0.375584,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26812,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SDSS-II SN 21396','R',26812,41.39,0.32,1380,7047,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 21396',0.375584,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26813,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26813,33.58,0.2,52,7048,74.4,NULL,NULL,'NGC 1081',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.00001,NULL,'14.36',0.6,'SB(s)b?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,41.273,-15.58781,0.005,NULL,38089944230,595155378,9299302,14.36),(26814,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26814,33.7,0.4,55,7048,NULL,NULL,'mean','NGC 1081',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26815,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26815,33.79,0.47,57.3,7048,NULL,NULL,'H','NGC 1081',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26816,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26816,33.85,0.32,59,7048,NULL,NULL,NULL,'NGC 1081',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26817,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26817,33.87,0.46,59.4,7048,NULL,NULL,'J','NGC 1081',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26818,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26818,33.89,0.45,60,7048,NULL,NULL,'K','NGC 1081',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26819,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26819,34.02,0.3,63.8,7048,NULL,NULL,'Malmquist cor.','NGC 1081',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26820,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SDSS-II SN 08991','RN',26820,44.05,0.45,4120,7049,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 08991',0.566203,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26821,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,'R',26821,37.62,0.46,334,7050,70,NULL,NULL,'2MASX J02450885+0114260',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00009,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,41.2867083,1.24047,0.065,NULL,66850175052,1044533985,16320843,16.6),(26822,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26822,33.26,0.68,44.8,7051,NULL,NULL,NULL,'NGC 1080',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000013,NULL,'14.08',0.8,'SAB(s)c:',NULL,NULL,NULL,NULL,1,41.291417,-4.71078,0.105,NULL,34905368231,545396378,8521818,14.08),(26823,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26823,33.6,0.58,52.4,7051,NULL,NULL,'Malmquist cor.','NGC 1080',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26824,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26824,35.15,0.47,107,7051,NULL,NULL,'H','NGC 1080',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26825,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26825,35.2,0.4,110,7051,NULL,NULL,'mean','NGC 1080',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26826,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26826,35.27,0.46,113,7051,NULL,NULL,'J','NGC 1080',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26827,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26827,36.2,0.25,174,7052,74.4,NULL,NULL,'GIN 140',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000057,NULL,'15.7V',NULL,'S0','Group member',NULL,NULL,NULL,1,41.30175,36.71217,0.205,NULL,68665125303,1072892582,16763946,15.7),(26828,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26828,36.39,0.21,190,7052,70,NULL,NULL,'GIN 140',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26829,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,'R',26829,35.51,0.33,127,7053,70,NULL,NULL,'2MASX J02451327-0820539',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000094,NULL,'15.6g',0.38,'E0',NULL,NULL,NULL,NULL,1,41.3052916667,-8.34839,0.053,NULL,37877003800,591828184,9247315,15.6),(26830,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26830,36.18,0.61,172,7053,70,NULL,NULL,'2MASX J02451327-0820539',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26831,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26831,36.21,0.25,175,7054,74.4,NULL,NULL,'GIN 139',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.00007,NULL,'15.2V',NULL,'S0/E','Group member',NULL,NULL,NULL,1,41.3072083333,36.69494,0.205,NULL,68665132625,1072892697,16763948,15.2),(26832,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26832,36.39,0.21,190,7054,70,NULL,NULL,'GIN 139',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26833,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,'R',26833,37.01,0.46,253,7055,70,NULL,NULL,'2MASX J02451375-0044458',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000128,NULL,'15.8g',0.41,'E0',NULL,NULL,NULL,NULL,1,41.307375,-0.74611,0.057,NULL,34903785605,545371650,8521432,15.8),(26834,'IRAS','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26834,33.97,0.8,62.2,7056,75,NULL,'W91PP, r','UGC 02223',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'14.84',0.3,'Scd:',NULL,NULL,NULL,NULL,1,41.3092083,35.18869,0.265,NULL,68658248925,1072785139,16762267,14.84),(26835,'IRAS','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26835,33.97,0.8,62.3,7056,75,NULL,'CF, r','UGC 02223',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26836,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,'R',26836,33.69,0.49,54.8,7056,75,NULL,'IR','UGC 02223',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26837,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26837,33.75,0.38,56.2,7056,75,NULL,'W91PP, r, raw','UGC 02223',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26838,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26838,33.76,0.38,56.5,7056,75,NULL,'W91PP, r, inv','UGC 02223',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26839,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26839,33.81,0.2,57.8,7056,74.4,NULL,NULL,'UGC 02223',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26840,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26840,33.82,0.37,58,7056,NULL,NULL,NULL,'UGC 02223',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26841,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26841,33.86,0.38,59.3,7056,75,NULL,'CF, r, raw','UGC 02223',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26842,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26842,33.92,0.38,60.8,7056,75,NULL,'CF, r, inv','UGC 02223',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26843,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26843,33.93,0.38,61.2,7056,75,NULL,'W91PP, r, cor','UGC 02223',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26844,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26844,34.02,0.38,63.5,7056,75,NULL,'CF, r, cor','UGC 02223',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26845,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26845,34.13,0.32,66.9,7056,NULL,NULL,'Malmquist cor.','UGC 02223',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26846,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SDSS-II SN 01457','RN',26846,41.23,0.36,1300,7057,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01457',0.360187,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26847,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SDSS-II SN 01457','RN',26847,41.25,0.33,1310,7057,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01457',0.360187,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26848,'IRAS','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26848,34.92,0.8,96.3,7058,75,NULL,'MAT, I','NGC 1099',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'14.33',0.6,'SB(rs)ab;EmLG  HII','Compact group member',NULL,NULL,NULL,1,41.325083,-17.70836,0.042,NULL,38105890425,595404537,9303195,14.33),(26849,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26849,34.39,0.43,75.5,7058,75,NULL,'MAT, I, raw','NGC 1099',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26850,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26850,34.52,0.47,80.2,7058,NULL,NULL,'H','NGC 1099',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26851,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26851,34.53,0.32,80.7,7058,85,NULL,'I, raw','NGC 1099',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26852,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26852,34.55,0.45,81.3,7058,NULL,NULL,'K','NGC 1099',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26853,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26853,34.59,0.46,82.7,7058,NULL,NULL,'J','NGC 1099',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26854,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26854,34.62,0.32,83.8,7058,85,NULL,'I, inv','NGC 1099',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26855,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26855,34.72,0.43,88,7058,75,NULL,'MAT, I, inv','NGC 1099',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26856,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26856,34.8,0.43,91.2,7058,75,NULL,'MAT, I, cor','NGC 1099',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26857,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26857,34.91,0.4,96,7058,NULL,NULL,'mean','NGC 1099',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26858,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26858,34.96,0.67,98.2,7058,NULL,NULL,'Malmquist cor.','NGC 1099',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26859,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26859,35.16,0.61,108,7058,NULL,NULL,NULL,'NGC 1099',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26860,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26860,35.2,0.2,110,7058,74.4,NULL,NULL,'NGC 1099',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26861,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SDSS-II SN 05287','RN',26861,42.5,0.37,2290,7059,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05287',0.380894,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26862,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SDSS-II SN 05287','RN',26862,43.06,0.5,2960,7059,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 05287',0.380894,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26863,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26863,35.14,0.49,107,7060,70,NULL,NULL,'NGC 1091',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00011,NULL,'15.33',0.6,'(R\')SAB(rs)a pec?','Compact group member',NULL,NULL,NULL,1,41.3434583,-17.53317,0.054,NULL,38105793055,595403016,9303172,15.33),(26864,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26864,33.94,0.69,61.4,7061,100,NULL,'mid-IR','IC 1843',NULL,'2013ApJ...771...88L',2013,1,1.4,NULL,'G',0.000103,NULL,'14.01',0.7,'SB(s)ab?','in a radial-velocity based grouping',NULL,NULL,NULL,1,41.352583,2.88053,0.109,NULL,66853589856,1044587341,16321677,14.01),(26865,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SDSS-II SN 00829','RN',26865,42.44,0.18,2160,7062,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00829',0.427463,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26866,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SDSS-II SN 00829','RN',26866,43.31,0.14,3220,7062,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 00829',0.427463,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26867,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26867,35.64,0.54,134,7063,70,NULL,NULL,'MCG -04-07-033',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00012,NULL,'15',0.4,'S0',NULL,NULL,NULL,NULL,1,41.3555,-20.82181,0.093,NULL,37940071087,592813610,9262712,15),(26868,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SDSS-II SN 18192','RN',26868,43.88,0.21,3600,7064,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 18192',0.657871,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26869,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26869,35.32,0.46,116,7065,70,NULL,NULL,'NGC 1092',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.64',0.8,'E2','Compact group member',NULL,NULL,NULL,1,41.3732083,-17.54228,0.054,NULL,38105796389,595403068,9303172,15.64),(26870,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26870,34.32,0.47,73.1,7066,70,NULL,NULL,'NGC 1100',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000083,NULL,'14.33',0.7,'SA(r)a        LLAGN?','Compact group member',NULL,NULL,NULL,1,41.4002917,-17.68894,0.042,NULL,38106011735,595406433,9303225,14.33),(26871,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26871,34.3,0.56,72.5,7067,NULL,NULL,NULL,'ESO 416- G 015',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000033,NULL,'13.91',0.8,'Sb',NULL,NULL,NULL,NULL,1,41.40525,-27.96106,0,NULL,38433885537,600529461,9383272,13.91),(26872,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26872,34.31,0.56,72.7,7067,NULL,NULL,'Malmquist cor.','ESO 416- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26873,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26873,34.34,0.2,73.8,7067,74.4,NULL,NULL,'ESO 416- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26874,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26874,34.55,0.47,81.2,7067,NULL,NULL,'H','ESO 416- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26875,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26875,34.63,0.45,84.3,7067,NULL,NULL,'K','ESO 416- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26876,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26876,34.65,0.46,85.2,7067,NULL,NULL,'J','ESO 416- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26877,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26877,34.8,0.4,91.2,7067,NULL,NULL,'mean','ESO 416- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26878,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SDSS-II SN 01575','RN',26878,41.95,0.23,1650,7068,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01575',0.488381,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26879,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26879,33.99,0.45,62.9,7069,70,NULL,NULL,'ESO 479- G 033',NULL,'2014MNRAS.445.2677S',2014,1,1.47,NULL,'G',0.000063,NULL,'14.51',0.38,'S0^0^',NULL,NULL,NULL,NULL,1,41.413833,-24.81475,0.007,NULL,37936343002,592755359,9261802,14.51),(26880,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SDSS-II SN 16044','R',26880,41.5,0.35,1420,7070,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16044',0.408288,'2014arXiv1401.3317S',2014,1,0.04,NULL,'G',NULL,'PHOT','21.2g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,41.4185417,-1.08803,0.073,NULL,34911701465,545495335,8523364,21.2),(26881,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SDSS-II SN 16044','R',26881,41.51,0.34,1430,7070,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16044',0.408288,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26882,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SDSS-II SN 16044',NULL,26882,41.35,0.08,1860,7070,70,NULL,'SN photometric redshift distance, z photo =0.593 +/- 0.034','SDSS-II SN 16044',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26883,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,'R',26883,34.19,0.49,68.7,7071,75,NULL,'IR','NGC 1083',NULL,'2011yCatp016004901K',2011,1,1.6,NULL,'G',0.000067,NULL,'15.19',0.3,'Sb pec sp      HII',NULL,NULL,NULL,NULL,1,41.419167,-15.35778,0,NULL,38097511986,595273624,9301150,15.19),(26884,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26884,35.11,0.51,105,7072,70,NULL,NULL,'NGC 1082',NULL,'2014MNRAS.445.2677S',2014,1,0.95,NULL,'G',0.000107,NULL,'14.3g',0.8,'SB?0o',NULL,NULL,NULL,NULL,1,41.421875,-8.18053,0.069,NULL,37877037870,591828716,9247323,14.3),(26885,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,'R',26885,35.51,0.33,127,7072,70,NULL,NULL,'NGC 1082',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26886,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SDSS-II SN 17236','RN',26886,41.76,0.13,2150,7073,70,NULL,'SDSS CAND. SNII; MLCS2K2','SDSS-II SN 17236',0.042371,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26887,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SDSS-II SN 17236','RN',26887,41.97,0.24,2380,7073,70,NULL,'SDSS CAND. SNII; SALT 2','SDSS-II SN 17236',0.042371,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26888,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26888,36.2,0.25,174,7074,74.4,NULL,NULL,'GIN 137',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000093,NULL,'15.3V',NULL,'E','Group member',NULL,NULL,NULL,1,41.4324583,36.85472,0.205,NULL,68665163081,1072893173,16763955,15.3),(26889,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26889,36.39,0.21,190,7074,70,NULL,NULL,'GIN 137',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26890,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,'R',26890,36.48,0.46,197,7075,70,NULL,NULL,'2MASX J02454466-0001003',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000069,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,41.436167,-0.01692,0.093,NULL,34903297788,545364027,8521312,17.1),(26891,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26891,35.21,0.57,110,7076,NULL,NULL,'Malmquist cor.','MCG -03-08-018',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000023,NULL,'15.3b',0.4,NULL,NULL,NULL,NULL,NULL,1,41.4460833333,-15.51067,0.005,NULL,38097464555,595272883,9301138,15.3),(26892,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26892,35.41,0.52,121,7076,NULL,NULL,NULL,'MCG -03-08-018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26893,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26893,35.45,0.2,123,7076,74.4,NULL,NULL,'MCG -03-08-018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26894,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26894,36.19,0.25,173,7077,74.4,NULL,NULL,'GIN 136',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000077,NULL,'15.0V',NULL,'E','Group member',NULL,NULL,NULL,1,41.451083,36.85381,0.205,NULL,68665160491,1072893132,16763955,15),(26895,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26895,36.39,0.21,190,7077,70,NULL,NULL,'GIN 136',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26896,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 1995ak',NULL,26896,34.12,0.19,65.2,7078,74.2,NULL,'SALT 2','IC 1844',0.02272,'2010ApJ...716..712A',2010,1,0.7,NULL,'G',0.000067,NULL,'15.0',0.25,'Sbc',NULL,NULL,NULL,NULL,1,41.455833,3.23031,0.081,NULL,66847773505,1044496461,16320257,15),(26897,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 1995ak',NULL,26897,34.4,0.07,74.1,7078,72,NULL,NULL,'IC 1844',0.02272,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26898,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 1995ak',NULL,26898,34.48,0.08,78.7,7078,74.4,NULL,NULL,'IC 1844',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26899,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 1995ak',NULL,26899,34.74,0.14,84.9,7078,65,NULL,'MLCS2k2','IC 1844',0.02272,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26900,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 1995ak',NULL,26900,34.7,0.22,85.2,7078,65,NULL,NULL,'IC 1844',0.02272,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26901,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 1995ak',NULL,26901,34.7,0.13,85.2,7078,65,NULL,'MLCS2k2','IC 1844',0.02272,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26902,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 1995ak',NULL,26902,34.71,0.18,85.5,7078,70,NULL,'SALT 2','IC 1844',0.02272,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26903,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 1995ak',NULL,26903,34.72,0.2,86.1,7078,65,NULL,'MLCS31','IC 1844',0.02272,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26904,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 1995ak',NULL,26904,34.76,0.17,87.4,7078,73.8,NULL,'SALT 2 (SNANA)','IC 1844',0.0224,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26905,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 1995ak',NULL,26905,34.79,0.22,88.8,7078,72,NULL,NULL,'IC 1844',0.02272,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26906,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 1995ak',NULL,26906,34.82,0.15,89.8,7078,65,NULL,'SALT2','IC 1844',0.02272,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26907,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 1995ak',NULL,26907,34.88,0.2,92.5,7078,70,NULL,'SALT','IC 1844',0.02272,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26908,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 1995ak',NULL,26908,34.89,0.08,92.8,7078,65,NULL,'MLCS2k2','IC 1844',0.02272,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26909,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 1995ak',NULL,26909,34.9,0.19,93.2,7078,65,NULL,'MLCS17','IC 1844',0.02272,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26910,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 1995ak',NULL,26910,34.94,0.17,97.3,7078,70.8,NULL,NULL,'IC 1844',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26911,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 1995ak',NULL,26911,35.02,0.22,98.5,7078,65,NULL,'SALT','IC 1844',0.02272,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26912,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 1995ak',NULL,26912,35.04,0.22,99.5,7078,65,NULL,'SALT2','IC 1844',0.02272,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26913,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 1995ak',NULL,26913,35.15,0.16,105,7078,65,NULL,'MLCS','IC 1844',0.02272,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26914,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 1995ak',NULL,26914,35.16,0.07,105,7078,65,NULL,'SALT','IC 1844',0.02272,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26915,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 1995ak',NULL,26915,35.15,0.14,107,7078,60,NULL,NULL,'IC 1844',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26916,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 1995ak',NULL,26916,35.19,0.08,109,7078,60,NULL,'M(I) = -19.19 mag','IC 1844',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26917,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 1995ak',NULL,26917,35.43,0.18,119,7078,65,NULL,'Template','IC 1844',0.02272,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26918,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 1995ak',NULL,26918,35.44,0.07,120,7078,70,NULL,'SALT 2','IC 1844',0.02272,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26919,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 1995ak',NULL,26919,35.41,0.09,121,7078,60,NULL,'M(V) = -19.47 mag','IC 1844',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26920,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 1995ak',NULL,26920,35.5,0.1,126,7078,60,NULL,'M(B) = -19.48 mag','IC 1844',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26921,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26921,33.2,0.4,43.7,7078,75,NULL,'HOSTS SN 1995ak','IC 1844',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26922,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26922,33.95,0.43,61.7,7078,75,NULL,'3.6 micron, color + selection bias corrected','IC 1844',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26923,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26923,34.08,0.43,65.6,7078,75,NULL,'3.6 micron, color corrected','IC 1844',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26924,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26924,34.48,0.08,78.7,7078,74.4,NULL,NULL,'IC 1844',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26925,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SDSS-II SN 10443','RN',26925,39.46,0.39,662,7079,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10443',0.178912,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26926,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SDSS-II SN 10443','RN',26926,41.24,0.87,1500,7079,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10443',0.178912,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26927,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26927,36.95,0.72,245,7080,70,NULL,NULL,'2MASX J02455136-2824279',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.79',0.28,NULL,NULL,NULL,NULL,NULL,1,41.4640417,-28.40775,0,NULL,38434455147,600538361,9383411,16.79),(26928,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26928,34.95,0.53,97.7,7081,70,NULL,NULL,'2MASX J02455250-1702302',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'15.72',0.34,NULL,NULL,NULL,NULL,NULL,1,41.468625,-17.04167,0.013,NULL,38092152747,595189886,9299841,15.72),(26929,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26929,36.01,0.48,160,7082,NULL,NULL,'Malmquist cor.','2MASX J02455316-1533432',NULL,'2009ApJS..182..474S',2009,1,0.52,NULL,'G',0.00001,NULL,'16.82',0.21,NULL,NULL,NULL,NULL,NULL,1,41.4714583,-15.562,0.005,NULL,38089922675,595155041,9299297,16.82),(26930,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26930,36.16,0.45,171,7082,NULL,NULL,NULL,'2MASX J02455316-1533432',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26931,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26931,35.75,0.53,141,7083,70,NULL,NULL,'2MASX J02455854-1504512',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'15.71',0.36,NULL,NULL,NULL,NULL,NULL,1,41.4937917,-15.08097,0.005,NULL,38097895288,595279613,9301243,15.71),(26932,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 1963P','R',26932,33.11,NULL,41.9,7084,NULL,NULL,'Photographic','NGC 1084',NULL,'1988SSRv...48....1R',1988,1,3.26,'Extended HIPASS source','G',0.000013,NULL,'11.6g',1.23,'SA(s)c         HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,41.499625,-7.57847,0.053,NULL,37875151000,591799234,9246863,11.6),(26933,'SNII optical','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 2012ec',NULL,26933,31.11,0.2,16.7,7084,NULL,NULL,'SCM Olivares 2010','NGC 1084',NULL,'2015MNRAS.448.2312B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26934,'SNII optical','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 2012ec',NULL,26934,31.15,0.2,17,7084,NULL,NULL,'SCM Poznanski 2009','NGC 1084',NULL,'2015MNRAS.448.2312B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26935,'SNII optical','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 2012ec',NULL,26935,31.22,0.3,17.5,7084,NULL,NULL,'SCM HP 2002','NGC 1084',NULL,'2015MNRAS.448.2312B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26936,'SNII optical','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 2012ec',NULL,26936,31.29,0.3,18.1,7084,NULL,NULL,'SCM Nugent 2006','NGC 1084',NULL,'2015MNRAS.448.2312B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26937,'SNII optical','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 2012ec',NULL,26937,31.33,0.2,18.5,7084,NULL,NULL,'SCM D\'Andrea 2010','NGC 1084',NULL,'2015MNRAS.448.2312B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26938,'IRAS','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26938,31.24,0.8,17.7,7084,75,NULL,'MAT, I','NGC 1084',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26939,'Sosies','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26939,30.95,0.24,15.5,7084,NULL,NULL,NULL,'NGC 1084',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26940,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26940,31.1,0.06,16.6,7084,NULL,NULL,NULL,'NGC 1084',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26941,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26941,31.17,0.4,17.1,7084,75,NULL,'B','NGC 1084',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26942,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26942,31.33,0.43,18.4,7084,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1084',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26943,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26943,31.43,0.43,19.4,7084,75,NULL,'3.6 micron, color corrected','NGC 1084',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26944,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26944,31.6,0.2,20.9,7084,74.4,NULL,NULL,'NGC 1084',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26945,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,'R',26945,31.73,NULL,22.2,7084,NULL,NULL,'LEDA [April 2006]','NGC 1084',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26946,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26946,31.9,0.4,24,7084,NULL,NULL,NULL,'NGC 1084',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26947,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26947,31.9,0.4,24,7084,73,NULL,'opt','NGC 1084',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26948,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26948,31.93,0.32,24.3,7084,85,NULL,'I, raw','NGC 1084',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26949,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26949,31.94,0.43,24.5,7084,75,NULL,'MAT, I, raw','NGC 1084',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26950,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26950,32,0.32,25.1,7084,85,NULL,'I, inv','NGC 1084',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26951,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26951,32.11,0.43,26.4,7084,75,NULL,'MAT, I, cor','NGC 1084',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26952,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26952,32.23,0.43,28,7084,75,NULL,'MAT, I, inv','NGC 1084',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26953,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SDSS-II SN 18792','RN',26953,40.73,0.09,1160,7085,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 18792',0.200879,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26954,'SNIa SDSS','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SDSS-II SN 18792','RN',26954,41.15,0.22,1420,7085,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 18792',0.200879,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26955,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26955,36.21,0.25,175,7086,74.4,NULL,NULL,'UGC 02232',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000113,NULL,'13.7V',1.4,'cD;E/D','Group member',NULL,NULL,NULL,1,41.5165,36.90519,0.205,NULL,68665159115,1072893111,16763954,13.7),(26956,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26956,36.39,0.21,190,7086,70,NULL,NULL,'UGC 02232',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26957,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26957,35.9,0.55,152,7087,70,NULL,NULL,'2MASX J02460680-0738033',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000074,NULL,'15.3g',0.37,'Sb',NULL,NULL,NULL,NULL,1,41.5282917,-7.63436,0.053,NULL,37875100760,591798449,9246850,15.3),(26958,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26958,36.66,0.76,215,7088,70,NULL,NULL,'ESO 014- G 006',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'15.9b',0.4,'Sb:',NULL,NULL,NULL,NULL,1,41.534625,-81.28319,0.277,NULL,35685792229,557590503,8712351,15.9),(26959,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26959,35.42,0.56,121,7089,70,NULL,NULL,'2MASX J02460987-0818463',NULL,'2014MNRAS.445.2677S',2014,1,0.81,NULL,'G',0.000072,NULL,'15.2g',0.43,'S0/a',NULL,NULL,NULL,NULL,1,41.5411666667,-8.31283,0.065,NULL,37877041630,591828775,9247324,15.2),(26960,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26960,35.52,0.47,127,7090,70,NULL,NULL,'NGC 1089',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000087,NULL,'14.77',0.3,'E2 or SA0-',NULL,NULL,NULL,NULL,1,41.542083,-15.07319,0.005,NULL,38097892321,595279567,9301243,14.77),(26961,'IRAS','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26961,34.44,0.8,77.2,7091,75,NULL,'W91PP, r','UGC 02236',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000012,NULL,'15.20',0.6,'S?',NULL,NULL,NULL,NULL,1,41.546625,27.04469,0.429,NULL,68605195339,1071956177,16749315,15.2),(26962,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26962,33.92,0.38,60.8,7091,75,NULL,'W91PP, r, inv','UGC 02236',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26963,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26963,33.94,0.38,61.5,7091,75,NULL,'W91PP, r, raw','UGC 02236',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26964,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26964,34.11,0.38,66.3,7091,75,NULL,'W91PP, r, cor','UGC 02236',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26965,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SDSS-II SN 14524','R',26965,40.76,0.22,1120,7092,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14524 HOST',0.2719,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,41.56275,-0.79786,0.073,NULL,34903505518,545367273,8521363,NULL),(26966,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SDSS-II SN 14524','R',26966,40.84,0.16,1160,7092,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14524 HOST',0.2719,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26967,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SDSS-II SN 14524',NULL,26967,40.56,0.12,1290,7092,70,NULL,'SALT 2','SDSS-II SN 14524 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26968,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SDSS-II SN 14524',NULL,26968,40.59,0.12,1310,7092,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14524 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26969,'CO ring diameter','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26969,31.15,NULL,17,7093,NULL,NULL,NULL,'NGC 1097',NULL,'1991PASJ...43..671S',1991,1,9.3,'Extended HIPASS source','G',0.00001,NULL,'10.23',6.3,'(R\'_1:)SB(r\'l)bSy1','Parent (of companion) galaxy',NULL,NULL,'LINER b',1,41.579375,-30.27489,NULL,NULL,38611077463,603298085,9426532,10.23),(26970,'SNII optical','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 2003B',NULL,26970,31.97,0.05,24.8,7093,NULL,NULL,'I, photospheric magnitude method','NGC 1097',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26971,'SNII optical','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 2003B',NULL,26971,31.98,0.09,24.9,7093,NULL,NULL,'V, photospheric magnitude method','NGC 1097',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26972,'SNII optical','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 2003B',NULL,26972,32.15,0.53,26.9,7093,NULL,NULL,'SCM, I','NGC 1097',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26973,'SNII optical','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 2003B',NULL,26973,32.18,0.27,27.3,7093,NULL,NULL,'SCM, BVI','NGC 1097',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26974,'SNII optical','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 2003B',NULL,26974,32.18,0.54,27.3,7093,NULL,NULL,'SCM, V','NGC 1097',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26975,'SNII optical','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 2003B',NULL,26975,32.21,0.4,27.7,7093,NULL,NULL,'SCM, B','NGC 1097',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26976,'IRAS','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26976,31.12,0.8,16.7,7093,75,NULL,'MAT, I','NGC 1097',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26977,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26977,30.76,0.36,14.2,7093,NULL,NULL,NULL,'NGC 1097',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26978,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26978,30.76,0.39,14.2,7093,73,NULL,'opt','NGC 1097',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26979,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26979,30.81,0.4,14.5,7093,75,NULL,'B','NGC 1097',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26980,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26980,30.91,0.43,15.2,7093,75,NULL,'3.6 micron, color corrected','NGC 1097',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26981,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26981,30.91,0.43,15.2,7093,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1097',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26982,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26982,31,0.06,15.9,7093,NULL,NULL,NULL,'NGC 1097',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26983,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26983,31.02,0.2,16,7093,74.4,NULL,NULL,'NGC 1097',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26984,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26984,31.13,0.4,16.8,7093,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 3 galaxy group','NGC 1097',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26985,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26985,31.16,0.43,17,7093,75,NULL,'MAT, I, raw','NGC 1097',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26986,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26986,31.4,0.43,19.1,7093,75,NULL,'MAT, I, cor','NGC 1097',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26987,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26987,31.52,0.32,20.1,7093,85,NULL,'I, raw','NGC 1097',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26988,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26988,31.52,0.43,20.1,7093,75,NULL,'MAT, I, inv','NGC 1097',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26989,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26989,31.61,0.32,21,7093,85,NULL,'I, inv','NGC 1097',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26990,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,'R',26990,32.97,0.49,39.3,7094,75,NULL,'IR','UGC 02233',NULL,'2011yCatp016004901K',2011,1,1.5,'1999ApJS..121..287H has V=7338+-50 km/sec; 1997ApJS..112..245N has V = 8359.','G',0.000037,NULL,'15.0',0.3,'Sb',NULL,NULL,NULL,NULL,1,41.584917,44.95222,0.613,NULL,68578822889,1071544107,16742876,15),(26991,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26991,33.56,0.47,51.6,7094,NULL,NULL,'H','UGC 02233',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26992,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26992,33.62,0.45,52.9,7094,NULL,NULL,'K','UGC 02233',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26993,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26993,33.91,0.46,60.6,7094,NULL,NULL,'J','UGC 02233',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26994,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26994,34.36,0.4,74.5,7094,NULL,NULL,'mean','UGC 02233',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26995,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,'R',26995,33.84,0.49,58.5,7095,75,NULL,'IR','UGC 02234',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000017,NULL,'14.9',0.4,'Scd:',NULL,NULL,NULL,NULL,1,41.593333,45.143,0.885,NULL,68578805791,1071543840,16742872,14.9),(26996,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26996,35.61,0.51,133,7096,70,NULL,NULL,'CGCG 389-009',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00013,NULL,'15.5b',0.6,NULL,NULL,NULL,NULL,NULL,1,41.6020416667,-1.74242,0.085,NULL,34912769834,545512028,8523625,15.5),(26997,'Tully est','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26997,31.39,0.8,19,7097,75,NULL,'B','NGC 1087',NULL,'1988NBGC.C....0000T',1988,1,3.12,NULL,'G',0.000013,NULL,'12.2g',1.5,'SAB(rs)c;WR    HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,41.604833,-0.49864,0.113,NULL,34903071530,545360492,8521257,12.2),(26998,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26998,30.29,0.43,11.4,7097,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1087',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26999,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,26999,30.49,0.43,12.5,7097,75,NULL,'3.6 micron, color corrected','NGC 1087',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27000,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27000,30.54,0.4,12.8,7097,NULL,NULL,NULL,'NGC 1087',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27001,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27001,30.54,0.4,12.8,7097,73,NULL,'opt','NGC 1087',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27002,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27002,30.86,0.2,14.9,7097,74.4,NULL,NULL,'NGC 1087',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27003,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27003,31.11,0.46,16.7,7097,NULL,NULL,'J','NGC 1087',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27004,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27004,31.12,0.45,16.8,7097,NULL,NULL,'K','NGC 1087',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27005,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27005,31.19,0.47,17.3,7097,NULL,NULL,'H','NGC 1087',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27006,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27006,31.4,0.54,19,7097,NULL,NULL,NULL,'NGC 1087',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27007,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27007,31.39,0.54,19,7097,NULL,NULL,'Malmquist cor.','NGC 1087',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27008,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27008,31.45,0.4,19.5,7097,NULL,NULL,'mean','NGC 1087',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27009,'SNII optical','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 2003hk',NULL,27009,34.35,0.53,74.1,7098,NULL,NULL,'SCM, I','NGC 1085',NULL,'2010ApJ...715..833O',2010,1,3,NULL,'G',0.000017,NULL,'13.07',2.1,'SA(s)bc:','in a radial-velocity based grouping',NULL,NULL,NULL,1,41.605417,3.60728,0.117,NULL,66847435855,1044491185,16320174,13.07),(27010,'SNII optical','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 2003hk',NULL,27010,34.41,0.28,76.2,7098,NULL,NULL,'SCM, BVI','NGC 1085',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27011,'SNII optical','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 2003hk',NULL,27011,34.41,0.54,76.2,7098,NULL,NULL,'SCM, V','NGC 1085',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27012,'SNII optical','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 2003hk',NULL,27012,34.45,0.4,77.6,7098,NULL,NULL,'SCM, B','NGC 1085',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27013,'SNII optical','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 2003hk',NULL,27013,34.79,0.08,90.8,7098,NULL,NULL,'I, photospheric magnitude method','NGC 1085',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27014,'SNII optical','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SN 2003hk',NULL,27014,34.8,0.16,91.2,7098,NULL,NULL,'V, photospheric magnitude method','NGC 1085',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27015,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27015,33.95,0.69,61.5,7098,100,NULL,'mid-IR','NGC 1085',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27016,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27016,34.56,0.47,81.5,7098,NULL,NULL,'H','NGC 1085',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27017,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27017,34.65,0.45,85.2,7098,NULL,NULL,'K','NGC 1085',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27018,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27018,34.71,0.46,87.4,7098,NULL,NULL,'J','NGC 1085',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27019,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27019,34.85,0.4,93.2,7098,NULL,NULL,'mean','NGC 1085',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27020,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27020,35.07,0.06,103,7098,NULL,NULL,NULL,'NGC 1085',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27021,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27021,35.22,0.2,111,7098,74.4,NULL,NULL,'NGC 1085',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27022,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,'R',27022,38.16,0.46,428,7099,70,NULL,NULL,'2MASX J02462774-0858283',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000085,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,41.6155833333,-8.97439,0.057,NULL,37877552650,591836760,9247449,17.6),(27023,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27023,34.5,0.55,79.5,7100,70,NULL,NULL,'ESO 479- G 037',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000037,NULL,'14.10',1,'(R\':)SA(rs:)bc',NULL,NULL,NULL,NULL,1,41.62625,-26.24994,0.013,NULL,38421230305,600331723,9380183,14.1),(27024,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27024,35,0.47,99.8,7100,NULL,NULL,'H','ESO 479- G 037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27025,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27025,35.02,0.4,101,7100,NULL,NULL,'mean','ESO 479- G 037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27026,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27026,35.09,0.46,104,7100,NULL,NULL,'J','ESO 479- G 037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27027,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27027,35.13,0.45,106,7100,NULL,NULL,'K','ESO 479- G 037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27028,'SNIa','2016-12-15 15:13:55','2016-12-16 11:18:59','1','SDSS-II SN 05144',NULL,27028,39.64,0.22,847,7101,70,NULL,'SN photometric redshift distance, z photo =0.222 +/- 0.027','SDSS-II SN 05144',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.5g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,41.630125,0.69119,0.093,NULL,66849932419,1044530194,16320784,21.5),(27029,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,'R',27029,38.01,0.46,400,7102,70,NULL,NULL,'SDSS J024632.33-084354.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000068,NULL,'18.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,41.6347083,-8.73189,0.049,NULL,37877688573,591838883,9247482,18.1),(27030,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27030,36.58,0.52,207,7103,70,NULL,NULL,'2MASX J02463343-0039153',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.000093,NULL,'15.97',0.3,NULL,NULL,NULL,NULL,NULL,1,41.639375,-0.65422,0.065,NULL,34903045310,545360082,8521251,15.97),(27031,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,'R',27031,36.62,0.21,211,7103,70,NULL,NULL,'2MASX J02463343-0039153',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27032,'FP','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27032,35.1,0.46,105,7104,70,NULL,NULL,'ESO 479- G 038',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00006,NULL,'14.13',1,'SAB(s)0^0^? pec',NULL,NULL,NULL,NULL,1,41.63975,-24.86608,0.013,NULL,37936329361,592755146,9261799,14.13),(27033,'IRAS','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27033,32.64,0.8,33.8,7105,75,NULL,'MAT, I','NGC 1090',NULL,'1997ApJS..109..333W',1997,1,4,NULL,'G',0.000013,NULL,'12.51',1.7,'SB(rs)bc','in a radial-velocity based grouping',NULL,NULL,NULL,1,41.6414166667,-0.24717,0.105,NULL,34902989629,545359212,8521237,12.51),(27034,'IRAS','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27034,32.65,0.8,33.8,7105,75,NULL,'A82, H','NGC 1090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27035,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27035,31.83,0.4,23.2,7105,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 1090',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27036,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27036,32.08,0.47,26.1,7105,75,NULL,'A82, H, raw','NGC 1090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27037,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27037,32.17,0.47,27.2,7105,75,NULL,'A82, H, inv','NGC 1090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27038,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27038,32.2,0.38,27.5,7105,NULL,NULL,NULL,'NGC 1090',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27039,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27039,32.2,0.4,27.5,7105,73,NULL,'opt','NGC 1090',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27040,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27040,32.27,0.43,28.4,7105,75,NULL,'3.6 micron, color corrected','NGC 1090',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27041,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27041,32.26,0.43,28.4,7105,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1090',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27042,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27042,32.31,0.47,28.9,7105,75,NULL,'A82, H, cor','NGC 1090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27043,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27043,32.43,0.2,30.6,7105,74.4,NULL,NULL,'NGC 1090',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27044,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27044,32.54,0.32,32.2,7105,85,NULL,'I, raw','NGC 1090',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27045,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27045,32.59,0.32,32.9,7105,85,NULL,'I, inv','NGC 1090',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27046,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27046,32.6,0.39,33.1,7105,73,NULL,'opt','NGC 1090',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27047,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27047,32.61,0.43,33.2,7105,75,NULL,'MAT, I, raw','NGC 1090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27048,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27048,32.64,0.46,33.7,7105,NULL,NULL,'J','NGC 1090',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27049,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27049,32.64,0.47,33.8,7105,NULL,NULL,'H','NGC 1090',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27050,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27050,32.68,0.48,34.3,7105,NULL,NULL,'Malmquist cor.','NGC 1090',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27051,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27051,32.68,0.45,34.4,7105,NULL,NULL,'K','NGC 1090',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27052,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27052,32.71,0.4,34.9,7105,75,NULL,'B','NGC 1090',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27053,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27053,32.75,0.4,35.5,7105,NULL,NULL,'mean','NGC 1090',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27054,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27054,32.78,0.46,35.9,7105,NULL,NULL,NULL,'NGC 1090',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27055,'Tully-Fisher','2016-12-15 15:13:55','2016-12-16 11:18:59','1',NULL,NULL,27055,32.82,0.43,36.6,7105,75,NULL,'MAT, I, inv','NGC 1090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27056,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27056,32.82,0.43,36.7,7105,75,NULL,'MAT, I, cor','NGC 1090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27057,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 19001',NULL,27057,39.34,0.3,738,7106,70,NULL,'SN photometric redshift distance, z photo =0.190 +/- 0.032','SDSS-II SN 19001',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,41.647125,-0.45203,0.113,NULL,34903077186,545360581,8521259,NULL),(27058,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 19001','R',27058,39.93,0.16,910,7106,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 19001',0.066218,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27059,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 19001','R',27059,40.3,0.27,1080,7106,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19001',0.066218,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27060,'IRAS','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27060,33.87,0.8,59.3,7107,75,NULL,'W91PP, r','UGC 02239',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'15.46',0.3,'SBbc?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,41.648875,32.44928,0.437,NULL,68678308479,1073098569,16767165,15.46),(27061,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27061,33.85,0.49,58.8,7107,75,NULL,'IR','UGC 02239',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27062,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27062,34,0.4,63,7107,NULL,NULL,'mean','UGC 02239',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27063,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27063,34.02,0.2,63.7,7107,74.4,NULL,NULL,'UGC 02239',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27064,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27064,34.05,0.38,64.5,7107,75,NULL,'W91PP, r, raw','UGC 02239',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27065,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27065,34.12,0.38,66.8,7107,75,NULL,'W91PP, r, inv','UGC 02239',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27066,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27066,34.13,0.38,67.1,7107,75,NULL,'W91PP, r, cor','UGC 02239',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27067,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27067,34.21,0.31,69.6,7107,NULL,NULL,NULL,'UGC 02239',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27068,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27068,34.25,0.47,70.8,7107,NULL,NULL,'H','UGC 02239',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27069,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27069,34.26,0.31,71.3,7107,NULL,NULL,'Malmquist cor.','UGC 02239',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27070,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27070,36.62,0.21,211,7108,70,NULL,NULL,'2MASX J02463676-0035075',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000081,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,41.653333,-0.58531,0.113,NULL,34903042529,545360039,8521250,16.7),(27071,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27071,35.04,0.4,102,7109,NULL,NULL,'mean','ESO 479- G 039',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000033,NULL,'14.35',0.7,'Sb;LINER       HII',NULL,NULL,NULL,NULL,1,41.6567917,-26.97194,0.018,NULL,38423029875,600359841,9380622,14.35),(27072,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27072,35.3,0.58,115,7109,NULL,NULL,'Malmquist cor.','ESO 479- G 039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27073,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27073,35.43,0.47,122,7109,NULL,NULL,'H','ESO 479- G 039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27074,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27074,35.53,0.53,127,7109,NULL,NULL,NULL,'ESO 479- G 039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27075,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27075,35.57,0.2,130,7109,74.4,NULL,NULL,'ESO 479- G 039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27076,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27076,29.66,NULL,8.55,7110,NULL,NULL,NULL,'KUG 0243+275',NULL,'2013AJ....145..101K',2013,1,0.8,NULL,'G',0.000002,NULL,'17.08',0.4,'Spiral',NULL,NULL,NULL,NULL,1,41.662,27.72647,0.361,NULL,68617351982,1072146124,16752283,17.08),(27077,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 14577','RN',27077,41.45,0.17,1620,7111,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14577',0.201637,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27078,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 14577','RN',27078,41.96,0.31,2050,7111,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 14577',0.201637,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27079,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27079,35.17,NULL,108,7112,NULL,NULL,'B','ESO 479- G 040',NULL,'2005Ap&SS.298..577R',2005,1,1.5,NULL,'G',0.000033,NULL,'14.36',0.5,'SB(s)bc:','in a pair',NULL,NULL,NULL,1,41.673667,-25.34667,0,NULL,38421470349,600335474,9380241,14.36),(27080,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27080,35.38,0.49,119,7112,NULL,NULL,'Malmquist cor.','ESO 479- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27081,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27081,35.52,0.46,127,7112,NULL,NULL,NULL,'ESO 479- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27082,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27082,35.56,0.2,129,7112,74.4,NULL,NULL,'ESO 479- G 040',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27083,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27083,35.6,NULL,132,7112,NULL,NULL,'I','ESO 479- G 040',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27084,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27084,35.56,0.46,129,7113,70,NULL,NULL,'2MASX J02464516+0008266',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000074,NULL,'16.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,41.6880417,0.14067,0.093,NULL,66850048271,1044532004,16320812,16.4),(27085,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27085,36,0.64,159,7114,70,NULL,NULL,'2MASX J02464670-0043435',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.0001,NULL,'15.70',0.46,NULL,NULL,NULL,NULL,NULL,1,41.694625,-0.72881,0.073,NULL,34911358878,545489982,8523280,15.7),(27086,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27086,36.62,0.21,211,7115,70,NULL,NULL,'2MASX J02464776-0034145',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000097,NULL,'15.2g',0.64,'E0',NULL,NULL,NULL,NULL,1,41.699167,-0.57078,0.113,NULL,34903091257,545360800,8521262,15.2),(27087,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27087,36.02,0.46,160,7116,70,NULL,NULL,'CGCG 389-013',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00011,NULL,'15.1g',0.45,'E0',NULL,NULL,NULL,NULL,1,41.699875,0.42158,0.097,NULL,66849955541,1044530555,16320789,15.1),(27088,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 09677',NULL,27088,40.86,0.16,1490,7117,70,NULL,'SN photometric redshift distance, z photo =0.437 +/- 0.044','SDSS-II SN 09677',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,41.702125,-0.62742,0.113,NULL,34903046408,545360100,8521251,NULL),(27089,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27089,38.32,0.33,462,7118,70,NULL,NULL,'2MASX J02464977-0114265',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000088,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,41.7072917,-1.24086,0.081,NULL,34911636025,545494312,8523348,18.1),(27090,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27090,36.21,0.25,175,7119,74.4,NULL,NULL,'GIN 138',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.00007,NULL,'14.9V',NULL,'S0','Group member',NULL,NULL,NULL,1,41.708333,36.97892,0.265,NULL,68665059290,1072891551,16763930,14.9),(27091,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27091,36.39,0.21,190,7119,70,NULL,NULL,'GIN 138',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27092,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27092,35.2,0.53,110,7120,70,NULL,NULL,'2MASX J02465243-0623421',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.94',0.3,NULL,NULL,NULL,NULL,NULL,1,41.7184166667,-6.39511,0.065,NULL,37909034754,592328668,9255135,15.94),(27093,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27093,33.98,0.49,62.5,7121,75,NULL,'IR','2MFGC 02221',NULL,'2011yCatp016004901K',2011,1,0.77,NULL,'G',0.00015,NULL,'17.4R',0.2,'HII',NULL,NULL,NULL,NULL,1,41.724625,-22.64258,0.063,NULL,37948870393,592951099,9264860,17.4),(27094,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27094,37.31,0.46,290,7122,70,NULL,NULL,'SDSS J024655.80+003334.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000081,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,41.7325,0.55961,0.101,NULL,66849986194,1044531034,16320797,18),(27095,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27095,38.08,0.46,413,7123,70,NULL,NULL,'SDSS J024656.43-080908.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000075,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,41.735125,-8.15228,0.065,NULL,37877172950,591830827,9247356,18),(27096,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27096,37.46,0.69,310,7124,NULL,NULL,'Malmquist cor.','2MASX J02470016-0009215',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000083,NULL,'17.62',0.2,NULL,NULL,NULL,NULL,NULL,1,41.7507917,-0.15594,0.105,NULL,34903138265,545361535,8521273,17.62),(27097,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27097,37.73,0.61,351,7124,NULL,NULL,NULL,'2MASX J02470016-0009215',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27098,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27098,37.77,0.2,358,7124,74.4,NULL,NULL,'2MASX J02470016-0009215',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27099,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27099,36.02,0.7,160,7125,70,NULL,NULL,'2MASX J02470230-8355353',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,41.7594583,-83.92644,0.465,NULL,35485166410,554455725,8663370,17),(27100,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27100,36.62,0.21,211,7126,70,NULL,NULL,'2MASX J02470300-0038523',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000093,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,41.762625,-0.64797,0.113,NULL,34911366338,545490099,8523282,16.9),(27101,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 02731','RN',27101,40.65,0.17,1140,7127,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02731',0.184771,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27102,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 02731','RN',27102,41.2,0.24,1470,7127,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02731',0.184771,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27103,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27103,35.08,0.57,104,7128,70,NULL,NULL,'MCG -01-08-008',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'14.95',0.3,'Sb: sp',NULL,NULL,NULL,NULL,1,41.7782083,-2.97258,0.077,NULL,34910997348,545484333,8523192,14.95),(27104,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 12927','R',27104,39.55,0.19,682,7129,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006fj','SN 2006fj',0.189776,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,41.786125,0.77514,0.101,NULL,66854916805,1044608075,16322001,NULL),(27105,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 12927','R',27105,39.77,0.13,756,7129,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006fj','SN 2006fj',0.189776,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27106,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27106,38.32,0.33,462,7130,70,NULL,NULL,'2MASXi J0247145-011348',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000077,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,41.8102083,-1.23064,0.081,NULL,34912121827,545501903,8523467,18.1),(27107,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 20926','RN',27107,40.98,0.44,1280,7131,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20926',0.230203,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27108,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 20926','RN',27108,41.57,0.31,1680,7131,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20926',0.230203,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27109,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27109,36.62,0.21,211,7132,70,NULL,NULL,'2MASX J02471694-0023253',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000101,NULL,'15.8g',0.45,'S0^-',NULL,NULL,NULL,NULL,1,41.820667,-0.39033,0.113,NULL,34903054383,545360224,8521253,15.8),(27110,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27110,37.58,0.6,328,7132,70,NULL,NULL,'2MASX J02471694-0023253',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27111,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27111,34.89,0.47,94.9,7133,70,NULL,NULL,'ARP 131 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00004,NULL,'14.8b',0.5,'Sa',NULL,NULL,NULL,NULL,1,41.8327917,-14.80181,0.017,NULL,38097807880,595278248,9301222,14.8),(27112,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27112,34.41,0.47,76.1,7133,NULL,NULL,'H','ARP 131 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27113,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27113,34.57,0.45,82.1,7133,NULL,NULL,'K','ARP 131 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27114,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27114,34.59,0.46,82.9,7133,NULL,NULL,'J','ARP 131 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27115,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27115,35.05,0.4,102,7133,NULL,NULL,'mean','ARP 131 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27116,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 18326','RN',27116,42.49,0.32,2470,7134,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18326',0.27339,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27117,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 18326','RN',27117,42.79,0.28,2840,7134,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18326',0.27339,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27118,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27118,37.07,0.69,259,7135,70,NULL,NULL,'2MASX J02472102-0349503',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'16.89',0.29,NULL,NULL,NULL,NULL,NULL,1,41.837625,-3.83047,0.061,NULL,34906740971,545417827,8522153,16.89),(27119,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 14771','RN',27119,41.67,0.28,1700,7136,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14771',0.267073,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27120,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27120,36.71,0.62,220,7137,70,NULL,NULL,'ESO 546- G 020',NULL,'2014MNRAS.445.2677S',2014,1,1,'Identification as NGC 1102 in ESO is incorrect.','G',0.00015,NULL,'14.5',0.9,'(R\'_2)SB(r)a',NULL,NULL,NULL,NULL,1,41.851417,-22.26783,0.03,NULL,37948062164,592938471,9264663,14.5),(27121,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27121,33.55,0.52,51.4,7138,70,NULL,NULL,'NGC 1094',NULL,'2014MNRAS.445.2677S',2014,1,1.53,'UGC misprints R.A. as 03h44.9m.','G',0.000057,NULL,'13.7g',0.85,'SAB(s)ab','in a radial-velocity based grouping',NULL,NULL,NULL,1,41.8659583,-0.28511,0.113,NULL,34903120495,545361257,8521269,13.7),(27122,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27122,33.84,0.69,58.6,7138,100,NULL,'mid-IR','NGC 1094',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27123,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27123,34.39,0.47,75.7,7138,NULL,NULL,'H','NGC 1094',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27124,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27124,34.44,0.45,77.2,7138,NULL,NULL,'K','NGC 1094',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27125,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27125,34.52,0.46,80,7138,NULL,NULL,'J','NGC 1094',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27126,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27126,34.73,0.4,88.3,7138,NULL,NULL,'mean','NGC 1094',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27127,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 19701','RN',27127,39.61,0.18,737,7139,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19701',0.135003,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27128,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 19701','RN',27128,39.97,0.1,867,7139,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19701',0.135003,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27129,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27129,34.28,0.2,71.8,7140,74.4,NULL,NULL,'NGC 1095',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000013,NULL,'13.99',0.8,'SBc','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,41.90775,4.63764,0.137,NULL,67926243589,1061347556,16583555,13.99),(27130,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27130,34.71,0.4,87.5,7140,NULL,NULL,'mean','NGC 1095',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27131,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27131,34.75,0.08,89.3,7140,NULL,NULL,NULL,'NGC 1095',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27132,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27132,35.05,0.47,102,7140,NULL,NULL,'H','NGC 1095',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27133,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 06618',NULL,27133,40.14,0.19,1060,7141,70,NULL,'SN photometric redshift distance, z photo =0.289 +/- 0.032','SDSS-II SN 06618',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,41.9195416667,0.96417,0.141,NULL,66855097951,1044610905,16322045,NULL),(27134,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27134,33.19,NULL,43.4,7142,NULL,NULL,NULL,'ESO 546- G 021',NULL,'2000BSAO...50....5K',2000,1,1.25,'Karachentsev (1993,AN,314,97) dec. in error by 1\'.','G',0.000013,NULL,'16.33',0.17,'Sdm',NULL,NULL,NULL,NULL,1,41.928375,-18.84039,0.092,NULL,38059745131,594683517,9291929,16.33),(27135,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27135,33.22,NULL,44.1,7142,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 546- G 021',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27136,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27136,33.23,NULL,44.2,7142,NULL,NULL,'Dipole + Quadrupole','ESO 546- G 021',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27137,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27137,33.24,NULL,44.5,7142,NULL,NULL,'Dipole','ESO 546- G 021',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27138,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27138,35.17,0.2,108,7143,74.4,NULL,NULL,'UGC 02271',NULL,'2013AJ....146...86T',2013,1,1.27,NULL,'G',0.000068,NULL,'14.9g',0.55,'SB(rs)b:       NLAGN',NULL,NULL,NULL,NULL,1,41.9370417,0.41417,0.117,NULL,66854273689,1044598026,16321844,14.9),(27139,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 18286',NULL,27139,40.12,0.48,1060,7144,70,NULL,'SN photometric redshift distance, z photo =0.287 +/- 0.089','SDSS-II SN 18286',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,41.952583,-0.48972,0.113,NULL,34911525718,545492589,8523321,NULL),(27140,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27140,36.67,0.7,215,7145,70,NULL,NULL,'2MASX J02474873-1453362',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.16',0.32,NULL,NULL,NULL,NULL,NULL,1,41.9529583,-14.89356,0.017,NULL,38097845521,595278836,9301231,16.16),(27141,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27141,34.61,0.4,83.6,7146,NULL,NULL,'mean','UGC 02267',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',NULL,NULL,'15.10',1.1,'(R)SB(r)b',NULL,NULL,NULL,NULL,1,41.965583,23.40397,0.513,NULL,68084809791,1063825152,16622268,15.1),(27142,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27142,34.78,0.47,90.2,7146,NULL,NULL,'H','UGC 02267',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27143,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27143,34.81,0.45,91.8,7146,NULL,NULL,'K','UGC 02267',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27144,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27144,34.88,0.46,94.4,7146,NULL,NULL,'J','UGC 02267',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27145,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 03349','RN',27145,41.78,0.16,1630,7147,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03349',0.393163,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27146,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 03349','RN',27146,42.36,0.21,2130,7147,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03349',0.393163,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27147,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 20725',NULL,27147,38.33,1.23,464,7148,70,NULL,'SN photometric redshift distance, z photo =0.115 +/- 0.098','SDSS-II SN 20725',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','22.5g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,41.9785,0.00172,0.141,NULL,66849903331,1044529739,16320777,22.5),(27148,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 20725','R',27148,41.41,0.31,1410,7148,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20725',0.363129,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27149,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 20725','R',27149,41.77,0.31,1660,7148,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20725',0.363129,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27150,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 20725',NULL,27150,41.35,0.23,1860,7148,70,NULL,'SALT 2','SDSS-II SN 20725',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27151,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 20725',NULL,27151,41.4,0.23,1910,7148,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20725',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27152,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27152,29.99,0.4,10,7149,75,NULL,'B','UGC 02259',NULL,'1988NBGC.C....0000T',1988,1,2.6,NULL,'G',0.000003,NULL,'13.80',1.9,'SB(s)dm','Pair member (points to parent)',NULL,NULL,NULL,1,41.980875,37.5385,0.233,NULL,68663732463,1072870819,16763606,13.8),(27153,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27153,33.74,0.4,56,7150,NULL,NULL,'mean','NGC 1086',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000023,NULL,'13.5',1,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,41.984875,41.24647,0.313,NULL,68543202602,1070987540,16734180,13.5),(27154,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27154,34.01,0.47,63.5,7150,NULL,NULL,'H','NGC 1086',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27155,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27155,34.05,0.45,64.5,7150,NULL,NULL,'K','NGC 1086',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27156,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27156,34.09,0.46,65.9,7150,NULL,NULL,'J','NGC 1086',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27157,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 17695','R',27157,39.57,0.2,693,7151,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J024757.55+003521.1',0.182906,'2014arXiv1401.3317S',2014,1,0.11,NULL,'G',NULL,'PHOT','20.8g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,41.9898333333,0.58922,0.097,NULL,66854264477,1044597882,16321841,20.8),(27158,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 17695','R',27158,39.57,0.15,694,7151,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J024757.55+003521.1',0.182906,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27159,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 17695',NULL,27159,39.34,0.09,738,7151,70,NULL,'SALT 2','SDSS J024757.55+003521.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27160,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 17695',NULL,27160,39.35,0.09,741,7151,70,NULL,'SALT 2, Malmquist cor.','SDSS J024757.55+003521.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27161,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27161,30.58,0.4,13.1,7152,75,NULL,'B','UGC 02275',NULL,'1988NBGC.C....0000T',1988,1,7.5,NULL,'G',0.000017,NULL,'13.6',5.5,'(R_2)SB(s)m V','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,41.990833,3.88389,0.133,NULL,66847159583,1044486868,16320107,13.6),(27162,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN CLA11Tib','N',27162,43.63,0.14,2480,7153,71.6,NULL,'MLCS2k2','SN CLA11Tib',1.143,'2014ApJ...786....9P',2013,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27163,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN CLA11Tib','N',27163,43.87,0.19,2770,7153,71.6,NULL,'SALT 2','SN CLA11Tib',1.143,'2014ApJ...786....9P',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27164,'IRAS','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27164,34.4,0.8,76,7154,75,NULL,'W91PP, r','UGC 02272',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000007,NULL,'14.62',0.3,'Sbc',NULL,NULL,NULL,NULL,1,42.018167,27.10311,0.453,NULL,68603445388,1071928834,16748888,14.62),(27165,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27165,34.1,0.38,66.1,7154,75,NULL,'W91PP, r, raw','UGC 02272',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27166,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27166,34.19,0.47,68.9,7154,NULL,NULL,'H','UGC 02272',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27167,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27167,34.23,0.45,70,7154,NULL,NULL,'K','UGC 02272',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27168,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27168,34.23,0.38,70.2,7154,75,NULL,'W91PP, r, cor','UGC 02272',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27169,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27169,34.26,0.49,71.1,7154,75,NULL,'IR','UGC 02272',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27170,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27170,34.28,0.46,71.7,7154,NULL,NULL,'J','UGC 02272',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27171,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27171,34.33,0.38,73.5,7154,75,NULL,'W91PP, r, inv','UGC 02272',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27172,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27172,34.48,0.4,78.5,7154,NULL,NULL,'mean','UGC 02272',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27173,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27173,34.49,0.42,79.1,7154,NULL,NULL,'Malmquist cor.','UGC 02272',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27174,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27174,34.59,0.2,82.8,7154,74.4,NULL,NULL,'UGC 02272',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27175,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27175,34.76,0.37,89.7,7154,NULL,NULL,NULL,'UGC 02272',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27176,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27176,33.22,0.49,44,7155,75,NULL,'IR','NGC 1103',NULL,'2011yCatp016004901K',2011,1,2.1,NULL,'G',0.00003,NULL,'13.61',0.5,'SB(s)b:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,42.025,-13.95922,0.045,NULL,38095330717,595239542,9300617,13.61),(27177,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27177,35.36,0.57,118,7156,70,NULL,NULL,'ESO 546- G 023',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.32',0.3,'(R)SBa:',NULL,NULL,NULL,NULL,1,42.031583,-22.20658,0.058,NULL,37948200463,592940632,9264697,15.32),(27178,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27178,37.74,0.46,353,7157,70,NULL,NULL,'2MASX J02480774-0706042',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000079,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,42.0322083,-7.10122,0.085,NULL,37908485258,592320082,9255001,17),(27179,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27179,35.02,0.25,101,7158,74.4,NULL,NULL,'GIN 148',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000237,NULL,'14.89',NULL,'E',NULL,NULL,NULL,NULL,1,42.0444583,47.02692,1.013,NULL,68580492602,1071570196,16743284,14.89),(27180,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27180,35.23,0.22,111,7158,70,NULL,NULL,'GIN 148',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27181,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27181,35.31,0.55,115,7159,70,NULL,NULL,'2MASX J02481406-2931438',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.000103,NULL,'15.51',0.5,'S0',NULL,NULL,NULL,NULL,1,42.0585417,-29.52878,NULL,NULL,38429422775,600459730,9382183,15.51),(27182,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 13254','R',27182,40.07,0.2,874,7160,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006gx','SN 2006gx',0.180746,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,42.058667,-0.34703,0.113,NULL,34911313894,545489279,8523269,NULL),(27183,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 13254','R',27183,40.25,0.13,949,7160,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006gx','SN 2006gx',0.180746,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27184,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27184,34.56,0.45,81.7,7161,NULL,NULL,'K','NGC 1101',NULL,'2007A&A...465...71T',2007,1,1.3,'RC3 and UZC have V = 6207 +- 31 km/sec.','G',0.00001,NULL,'13.96',1,'S0','Pair member, radial velocity confirmed',NULL,NULL,'Flat-Spectrum Radio Source',1,42.0617917,4.57803,0.141,NULL,67924169390,1061315146,16583049,13.96),(27185,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27185,34.95,0.4,97.7,7161,NULL,NULL,'mean','NGC 1101',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27186,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27186,33.09,0.69,41.5,7162,100,NULL,'mid-IR','NGC 1093',NULL,'2013ApJ...771...88L',2013,1,1.8,NULL,'G',0.000023,NULL,'13.99',1.1,'SABab?',NULL,NULL,NULL,NULL,1,42.0672916667,34.41978,0.277,NULL,68714683428,1073666928,16776045,13.99),(27187,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27187,34.29,0.4,72.1,7162,NULL,NULL,'mean','NGC 1093',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27188,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27188,34.51,0.47,79.8,7162,NULL,NULL,'H','NGC 1093',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27189,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27189,34.52,0.45,80.2,7162,NULL,NULL,'K','NGC 1093',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27190,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27190,34.58,0.46,82.4,7162,NULL,NULL,'J','NGC 1093',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27191,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 18793','R',27191,40.73,0.11,1160,7163,70,NULL,'SDSS CAND. SNII; MLCS2K2','SN 2007og',0.204,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'IIP',NULL,NULL,NULL,NULL,1,42.0855833333,-0.96964,0.121,NULL,34912184685,545502885,8523482,NULL),(27192,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 18793','R',27192,41.25,0.25,1470,7163,70,NULL,'SDSS CAND. SNII; SALT 2','SN 2007og',0.204,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27193,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27193,36.7,0.67,219,7164,70,NULL,NULL,'GALEXASC J024826.31-453757.4',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.00009,NULL,'16.07',0.35,'S',NULL,NULL,NULL,NULL,1,42.10925,-45.63347,0,NULL,38510670505,601729226,9402019,16.07),(27194,'IRAS','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27194,33.96,0.8,61.9,7165,75,NULL,'MAT, I','ESO 299- G 018',NULL,'1997ApJS..109..333W',1997,1,3.02,NULL,'G',0.000033,NULL,'15.01',0.27,'Sc',NULL,NULL,NULL,NULL,1,42.116583,-40.55492,NULL,NULL,38499054064,601547719,9399183,15.01),(27195,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27195,33.51,NULL,50.3,7165,NULL,NULL,NULL,'ESO 299- G 018',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27196,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27196,33.85,0.32,58.8,7165,85,NULL,'I, raw','ESO 299- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27197,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27197,33.85,0.43,59,7165,75,NULL,'MAT, I, raw','ESO 299- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27198,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27198,33.87,0.32,59.4,7165,85,NULL,'I, inv','ESO 299- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27199,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27199,33.99,0.43,62.7,7165,75,NULL,'MAT, I, inv','ESO 299- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27200,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27200,34,NULL,63.2,7165,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 299- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27201,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27201,34.03,NULL,63.8,7165,NULL,NULL,'Dipole + Quadrupole','ESO 299- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27202,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27202,34.03,NULL,64,7165,NULL,NULL,'Dipole','ESO 299- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27203,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27203,34.05,0.3,64.5,7165,NULL,NULL,NULL,'ESO 299- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27204,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27204,34.09,0.2,65.8,7165,74.4,NULL,NULL,'ESO 299- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27205,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27205,34.15,0.43,67.7,7165,75,NULL,'MAT, I, cor','ESO 299- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27206,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27206,34.29,0.27,72.2,7165,NULL,NULL,'Malmquist cor.','ESO 299- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27207,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27207,34.38,0.49,75.3,7165,75,NULL,'IR','ESO 299- G 018',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27208,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27208,34.28,0.4,71.8,7166,NULL,NULL,'mean','UGC 02270',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000037,NULL,'14.20',1.8,'Sb:','Pair member (points to parent)',NULL,NULL,NULL,1,42.128833,50.75453,NULL,NULL,68533073314,1070829270,16731707,14.2),(27209,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27209,35.16,0.46,108,7166,NULL,NULL,'J','UGC 02270',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27210,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27210,35.19,0.47,109,7166,NULL,NULL,'H','UGC 02270',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27211,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27211,35.2,0.45,110,7166,NULL,NULL,'K','UGC 02270',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27212,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27212,34.98,0.09,99.3,7167,NULL,NULL,NULL,'2MFGC 02245',NULL,'2009ApJS..182..474S',2009,1,0.84,NULL,'G',0.000017,NULL,'16.2g',0.28,'NLAGN',NULL,NULL,NULL,NULL,1,42.1432917,-0.99308,0.133,NULL,34912181280,545502832,8523481,16.2),(27213,'IRAS','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27213,35.22,0.8,110,7168,75,NULL,'HMCL, I','UGC 02285',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000005,NULL,'15.01',0.4,'Sdm:','Isolated galaxy',NULL,NULL,NULL,1,42.144125,6.52247,0.277,NULL,67969054780,1062016480,16594007,15.01),(27214,'IRAS','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27214,35.22,0.8,110,7168,75,NULL,'CF, r','UGC 02285',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27215,'IRAS','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27215,35.23,0.8,111,7168,75,NULL,'W91CL, r','UGC 02285',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27216,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27216,33.99,0.2,62.8,7168,74.4,NULL,NULL,'UGC 02285',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27217,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27217,34.3,0.38,72.3,7168,75,NULL,'W91CL, r, raw','UGC 02285',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27218,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27218,34.34,0.38,73.9,7168,75,NULL,'CF, r, raw','UGC 02285',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27219,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27219,34.36,0.38,74.5,7168,75,NULL,'W91CL, r, inv','UGC 02285',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27220,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27220,34.41,0.38,76.2,7168,75,NULL,'CF, r, inv','UGC 02285',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27221,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27221,34.44,0.4,77.3,7168,75,NULL,'HMCL, I, raw','UGC 02285',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27222,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27222,34.55,0.4,81.4,7168,75,NULL,'HMCL, I, inv','UGC 02285',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27223,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27223,34.69,0.38,86.7,7168,75,NULL,'W91CL, r, cor','UGC 02285',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27224,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27224,34.7,0.38,87,7168,75,NULL,'CF, r, cor','UGC 02285',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27225,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27225,34.79,0.4,90.7,7168,75,NULL,'HMCL, I, cor','UGC 02285',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27226,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27226,36.11,0.65,167,7169,70,NULL,NULL,'2MASX J02483631-1137216',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.42',NULL,NULL,NULL,NULL,NULL,NULL,1,42.1512916667,-11.62289,0.045,NULL,37873268160,591769815,9246403,16.42),(27227,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27227,35.52,0.49,127,7170,70,NULL,NULL,'NGC 1108',NULL,'2014MNRAS.445.2677S',2014,1,0.93,NULL,'G',0.00012,NULL,'14.4g',0.78,'S0-: pec?',NULL,NULL,NULL,NULL,1,42.160583,-7.95111,0.081,NULL,37909932862,592342700,9255354,14.4),(27228,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27228,35.56,0.46,130,7170,70,NULL,NULL,'NGC 1108',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27229,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27229,33.96,0.2,61.9,7171,74.4,NULL,NULL,'UGC 02283',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000033,NULL,'15.09',0.5,'SBc?',NULL,NULL,NULL,NULL,1,42.168583,17.22364,0.309,NULL,68178117438,1065283084,16645048,15.09),(27230,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27230,34.16,0.45,67.9,7171,NULL,NULL,NULL,'UGC 02283',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27231,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27231,34.19,0.44,69,7171,NULL,NULL,'Malmquist cor.','UGC 02283',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27232,'IRAS','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27232,34.05,0.8,64.7,7172,75,NULL,'MAT, I','ESO 416- G 025',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000023,NULL,'14.35',0.3,'Sb: sp','Group member',NULL,NULL,NULL,1,42.169917,-31.53622,NULL,NULL,38612551397,603321115,9426892,14.35),(27233,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27233,34.14,0.4,67.4,7172,NULL,NULL,'mean','ESO 416- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27234,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27234,34.15,0.43,67.5,7172,75,NULL,'MAT, I, raw','ESO 416- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27235,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27235,34.35,0.32,74.2,7172,85,NULL,'I, raw','ESO 416- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27236,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27236,34.36,0.43,74.3,7172,75,NULL,'MAT, I, cor','ESO 416- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27237,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27237,34.4,0.47,75.7,7172,NULL,NULL,'H','ESO 416- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27238,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27238,34.41,0.43,76.1,7172,75,NULL,'MAT, I, inv','ESO 416- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27239,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27239,34.41,0.32,76.3,7172,85,NULL,'I, inv','ESO 416- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27240,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27240,34.42,0.45,76.6,7172,NULL,NULL,'K','ESO 416- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27241,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27241,34.49,0.46,79.1,7172,NULL,NULL,'J','ESO 416- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27242,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27242,34.53,0.49,80.7,7172,75,NULL,'IR','ESO 416- G 025',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27243,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27243,34.59,0.36,82.6,7172,NULL,NULL,'Malmquist cor.','ESO 416- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27244,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27244,34.61,0.2,83.6,7172,74.4,NULL,NULL,'ESO 416- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27245,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27245,34.71,0.34,87.5,7172,NULL,NULL,NULL,'ESO 416- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27246,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 19708',NULL,27246,39.35,0.19,741,7173,70,NULL,NULL,'SDSS-II SN 19708',NULL,'2013MNRAS.434.1443X',2013,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,42.1727917,0.65458,0.157,NULL,66854188973,1044596702,16321823,NULL),(27247,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 19708',NULL,27247,39.49,0.34,790,7173,70,NULL,'SN photometric redshift distance, z photo =0.205 +/- 0.040','SDSS-II SN 19708',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27248,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 19708','R',27248,39.95,0.2,791,7173,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19708',0.237445,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27249,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 19708','R',27249,40.07,0.12,834,7173,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19708',0.237445,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27250,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 19708',NULL,27250,39.79,0.09,908,7173,70,NULL,'SALT 2','SDSS-II SN 19708',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27251,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 19708',NULL,27251,39.81,0.09,916,7173,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19708',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27252,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 12919','RN',27252,39.8,0.23,771,7174,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 12919',0.183194,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27253,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 12919','RN',27253,39.97,0.17,832,7174,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 12919',0.183194,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27254,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27254,34.36,0.2,74.5,7175,74.4,NULL,NULL,'2MFGC 02248',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000033,NULL,'12.3K',0.2,NULL,NULL,NULL,NULL,NULL,1,42.1865,5.38586,0.205,NULL,67923348131,1061302314,16582848,12.3),(27255,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27255,34.56,0.49,81.6,7176,75,NULL,'IR','2MFGC 02248',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.000033,NULL,'12.3K',0.2,NULL,NULL,NULL,NULL,NULL,1,42.1865,5.38586,0.205,NULL,67923348131,1061302314,16582848,12.3),(27256,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 00830','RN',27256,42.14,0.19,1930,7177,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00830',0.387223,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27257,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 00830','RN',27257,42.36,0.11,2140,7177,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 00830',0.387223,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27258,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27258,34.57,0.41,82,7178,NULL,NULL,'Malmquist cor.','ESO 356- G 013',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000029,NULL,'14.44',0.9,'SA(s)c','in a pair',NULL,NULL,NULL,1,42.196875,-36.71467,NULL,NULL,38626399897,603537498,9430273,14.44),(27259,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27259,34.86,0.36,93.6,7178,NULL,NULL,NULL,'ESO 356- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27260,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27260,34.9,0.2,95.5,7178,74.4,NULL,NULL,'ESO 356- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27261,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 16009','RN',27261,41.87,0.3,2020,7179,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 16009',0.174647,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27262,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 16009','RN',27262,42.86,0.32,3180,7179,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 16009',0.174647,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27263,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27263,34.03,0.5,63.8,7180,70,NULL,NULL,'ESO 546- G 025',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00013,NULL,'14.39',0.3,'Sb:            HII',NULL,NULL,NULL,NULL,1,42.202083,-19.97125,0.129,NULL,38062960544,594733758,9292714,14.39),(27264,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 15745',NULL,27264,40.69,0.41,1380,7181,70,NULL,'SN photometric redshift distance, z photo =0.395 +/- 0.111','SDSS-II SN 15745',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,42.207917,-0.10764,0.125,NULL,34911298769,545489043,8523266,NULL),(27265,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27265,34.74,0.4,88.8,7182,NULL,NULL,'mean','IC 1856',NULL,'2007A&A...465...71T',2007,1,1.18,NULL,'G',0.00004,NULL,'14.3g',0.62,'(R)SB(r)ab:','in a radial-velocity based grouping',NULL,NULL,NULL,1,42.211667,-0.76739,0.121,NULL,34912145925,545502280,8523473,14.3),(27266,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27266,34.8,0.2,91.2,7182,74.4,NULL,NULL,'IC 1856',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27267,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27267,34.88,0.07,94.8,7182,NULL,NULL,NULL,'IC 1856',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27268,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27268,35.08,0.47,104,7182,NULL,NULL,'H','IC 1856',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27269,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27269,35.1,0.45,105,7182,NULL,NULL,'K','IC 1856',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27270,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27270,35.11,0.46,105,7182,NULL,NULL,'J','IC 1856',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27271,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27271,35.22,0.27,111,7183,70,NULL,NULL,'I Zw 009',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00008,NULL,'15.6g',0.39,'cE:',NULL,NULL,NULL,NULL,1,42.2169166667,-0.52406,0.125,NULL,34911452473,545491444,8523303,15.6),(27272,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27272,35.34,0.62,117,7183,70,NULL,NULL,'I Zw 009',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27273,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27273,35.4,0.4,120,7184,NULL,NULL,'mean','UGC 02280',NULL,'2007A&A...465...71T',2007,1,2,NULL,'G',0.000037,NULL,'14.6',0.7,'SAbc',NULL,NULL,NULL,NULL,1,42.22375,41.77797,0.245,NULL,68543158037,1070986844,16734169,14.6),(27274,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27274,35.57,0.47,130,7184,NULL,NULL,'H','UGC 02280',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27275,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27275,34.61,0.48,83.5,7185,70,NULL,NULL,'ESO 416- G 026',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000103,NULL,'15.36',0.3,'SB(r)0/a',NULL,NULL,NULL,NULL,1,42.237375,-28.54242,0.011,NULL,38433473235,600523019,9383172,15.36),(27276,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27276,36.05,0.57,163,7186,70,NULL,NULL,'ESO 416- G 027',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.95',0.2,'S0','Group member',NULL,NULL,NULL,1,42.238833,-30.79289,NULL,NULL,38611002741,603296917,9426514,15.95),(27277,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27277,36.12,0.5,168,7187,70,NULL,NULL,'2MASX J02485779-0230059',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.38',0.43,NULL,NULL,NULL,NULL,NULL,1,42.2407917,-2.50167,0.101,NULL,34911275810,545488684,8523260,16.38),(27278,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27278,36.31,0.46,183,7188,70,NULL,NULL,'2MASX J02485792-0045389',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.32',0.14,NULL,NULL,NULL,NULL,NULL,1,42.2412083,-0.76075,0.121,NULL,34911430471,545491101,8523298,18.32),(27279,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27279,33.32,0.47,46,7189,NULL,NULL,'H','UGC 02295',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000017,NULL,'13.92',0.6,'Sb pec sp',NULL,NULL,NULL,NULL,1,42.245167,3.16867,0.157,NULL,66846912708,1044483011,16320047,13.92),(27280,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27280,33.34,0.45,46.6,7189,NULL,NULL,'K','UGC 02295',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27281,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27281,33.35,0.46,46.8,7189,NULL,NULL,'J','UGC 02295',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27282,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27282,33.59,0.4,52.2,7189,NULL,NULL,'mean','UGC 02295',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27283,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27283,33.63,0.2,53.2,7189,74.4,NULL,NULL,'UGC 02295',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27284,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27284,33.72,0.36,55.4,7189,NULL,NULL,'Malmquist cor.','UGC 02295',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27285,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27285,33.78,0.35,56.9,7189,NULL,NULL,NULL,'UGC 02295',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27286,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27286,35.02,0.25,101,7190,74.4,NULL,NULL,'GIN 147',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.00006,NULL,'14.66',NULL,'E/S0',NULL,NULL,NULL,NULL,1,42.249,47.10342,0.877,NULL,68579459891,1071554060,16743032,14.66),(27287,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27287,35.23,0.22,111,7190,70,NULL,NULL,'GIN 147',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27288,'IRAS','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27288,34.44,0.8,77.1,7191,75,NULL,'MAT, I','IC 1859',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'13.99',0.8,'Sb;Sy2         HII','Group member',NULL,NULL,'Sy 2',1,42.266333,-31.1725,NULL,NULL,38612657456,603322772,9426918,13.99),(27289,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27289,32.86,0.32,37.3,7191,85,NULL,'I, raw','IC 1859',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27290,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27290,32.88,0.32,37.7,7191,85,NULL,'I, inv','IC 1859',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27291,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27291,33.13,0.43,42.2,7191,75,NULL,'MAT, I, raw','IC 1859',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27292,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27292,33.27,0.43,45,7191,75,NULL,'MAT, I, inv','IC 1859',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27293,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27293,33.63,0.43,53.2,7191,75,NULL,'MAT, I, cor','IC 1859',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27294,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27294,34.03,0.47,63.9,7191,NULL,NULL,'H','IC 1859',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27295,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27295,34.14,0.45,67.4,7191,NULL,NULL,'K','IC 1859',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27296,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27296,34.16,0.46,68,7191,NULL,NULL,'J','IC 1859',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27297,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27297,34.46,0.4,78,7191,NULL,NULL,'mean','IC 1859',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27298,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27298,35.59,0.48,131,7192,70,NULL,NULL,'NGC 1120',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000093,NULL,'14.83',0.8,'S0-',NULL,NULL,NULL,NULL,1,42.2670416667,-14.47069,0.033,NULL,38095418501,595240914,9300639,14.83),(27299,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 20726','R',27299,40.23,0.2,840,7193,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20726',0.320204,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,42.2799166667,-0.15947,0.125,NULL,34897719295,545276863,8519950,NULL),(27300,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 20726','R',27300,40.58,0.34,990,7193,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20726',0.320204,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27301,'IRAS','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27301,33.14,0.8,42.5,7194,75,NULL,'MAT, I','NGC 1114',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000017,NULL,'13.27',0.8,'SA(r)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,42.28,-16.99336,0.041,NULL,38107845545,595435086,9303673,13.27),(27302,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27302,33.3,0.46,45.7,7194,NULL,NULL,'J','NGC 1114',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27303,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27303,33.31,0.47,46,7194,NULL,NULL,'H','NGC 1114',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27304,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27304,33.35,0.4,46.8,7194,NULL,NULL,'mean','NGC 1114',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27305,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27305,33.37,0.45,47.1,7194,NULL,NULL,'K','NGC 1114',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27306,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27306,33.41,0.32,48.1,7194,85,NULL,'I, raw','NGC 1114',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27307,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27307,33.44,0.43,48.7,7194,75,NULL,'MAT, I, raw','NGC 1114',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27308,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27308,33.46,0.32,49.3,7194,85,NULL,'I, inv','NGC 1114',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27309,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27309,33.54,0.2,51.1,7194,74.4,NULL,NULL,'NGC 1114',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27310,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27310,33.66,0.43,54.1,7194,75,NULL,'MAT, I, inv','NGC 1114',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27311,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27311,33.67,0.43,54.2,7194,75,NULL,'MAT, I, cor','NGC 1114',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27312,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27312,33.73,0.35,55.6,7194,NULL,NULL,NULL,'NGC 1114',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27313,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27313,33.86,0.33,59,7194,NULL,NULL,'Malmquist cor.','NGC 1114',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27314,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 15220','R',27314,42.12,0.39,1810,7195,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15220',0.464547,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,'PHOT','21.8g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,42.2830833333,0.28661,0.141,NULL,66842573330,1044415208,16318987,21.8),(27315,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 15220',NULL,27315,41.39,0.13,1900,7195,70,NULL,'SN photometric redshift distance, z photo =0.609 +/- 0.056','SDSS-II SN 15220',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27316,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 15220',NULL,27316,42.09,0.27,2620,7195,70,NULL,'SALT 2','SDSS-II SN 15220',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27317,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 15220',NULL,27317,42.2,0.27,2750,7195,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15220',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27318,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27318,34.63,0.25,84.3,7196,74.4,NULL,NULL,'IC 1858',NULL,'2013AJ....146...86T',2013,1,1.8,NULL,'G',0.00005,NULL,'14.37',0.6,'SA0+     poss. LINER','Group member',NULL,NULL,'Flat-Spectrum Radio Source',1,42.2850417,-31.28958,NULL,NULL,38612654119,603322720,9426917,14.37),(27319,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27319,34.66,0.48,85.6,7196,70,NULL,NULL,'IC 1858',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27320,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27320,30.73,0.4,14,7197,75,NULL,'B','UGC 02302',NULL,'1988NBGC.C....0000T',1988,1,4.8,NULL,'G',0.000003,NULL,'14.1',3.7,'(R\')SB(rs)m:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,42.285833,2.12728,0.241,NULL,66855834435,1044622413,16322225,14.1),(27321,'Tully est','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27321,31.06,0.8,16.3,7198,75,NULL,NULL,'NGC 1110',NULL,'1988NBGC.C....0000T',1988,1,2.9,'Confused HIPASS source','G',0.000007,NULL,'14.5B',0.5,'SB(s)m: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,42.289875,-7.83756,0.081,NULL,37909918170,592342471,9255351,14.5),(27322,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27322,31.45,NULL,19.5,7198,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 1110',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27323,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27323,31.47,NULL,19.7,7198,NULL,NULL,'Dipole + Quadrupole','NGC 1110',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27324,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27324,31.47,NULL,19.7,7198,NULL,NULL,'Dipole','NGC 1110',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27325,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27325,31.49,0.2,19.9,7198,74.4,NULL,NULL,'NGC 1110',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27326,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27326,31.52,0.43,20.1,7198,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1110',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27327,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27327,31.54,0.43,20.3,7198,75,NULL,'3.6 micron, color corrected','NGC 1110',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27328,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27328,31.59,NULL,20.8,7198,NULL,NULL,NULL,'NGC 1110',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27329,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27329,31.77,0.4,22.6,7198,NULL,NULL,NULL,'NGC 1110',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27330,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27330,31.77,0.39,22.6,7198,73,NULL,'opt','NGC 1110',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27331,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 19377','RN',27331,42.31,0.29,2090,7199,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19377',0.381631,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27332,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 19377','RN',27332,42.84,0.28,2680,7199,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19377',0.381631,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27333,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 09678','RN',27333,40.63,0.26,936,7200,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 09678',0.426022,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27334,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 09678','RN',27334,40.97,0.33,1100,7200,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 09678',0.426022,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27335,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27335,35.59,0.67,131,7201,70,NULL,NULL,'2MASX J02491494-3103060',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.000077,NULL,'16.22',0.57,'SBa','Group member',NULL,NULL,NULL,1,42.3119583333,-31.05161,NULL,NULL,38612635842,603322435,9426913,16.22),(27336,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27336,33.93,0.2,61.1,7202,74.4,NULL,NULL,'2MASX J02491516+2118173',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000033,NULL,'16.0',0.8,NULL,NULL,NULL,NULL,NULL,1,42.313167,21.30489,0.565,NULL,68121859123,1064404048,16631313,16),(27337,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27337,33.05,0.45,40.8,7203,NULL,NULL,'K','NGC 1107',NULL,'2007A&A...465...71T',2007,1,1.8,'HOLM 063B is a star.','G',0.000093,NULL,'13.46',1.5,'S0',NULL,NULL,NULL,NULL,1,42.3317083,8.09264,0.301,NULL,67971231406,1062050490,16594538,13.46),(27338,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27338,33.25,0.4,44.7,7203,NULL,NULL,'mean','NGC 1107',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27339,'Tully est','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27339,30.66,0.8,13.5,7204,75,NULL,NULL,'UGCA 044',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.000003,NULL,'16.9',1.3,'IB(s)m:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,42.3425,-2.65389,0.109,NULL,34911226542,545487914,8523248,16.9),(27340,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27340,35.15,0.25,107,7205,74.4,NULL,NULL,'MCG -05-07-036',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000077,NULL,'17.31',0.15,'E','Group member',NULL,NULL,NULL,1,42.342625,-31.18172,NULL,NULL,38612660240,603322816,9426919,17.31),(27341,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27341,36.99,0.59,250,7206,70,NULL,NULL,'2MASX J02492571-0225001',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.79',0.24,NULL,NULL,NULL,NULL,NULL,1,42.35725,-2.41675,0.101,NULL,34911181149,545487205,8523237,16.79),(27342,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27342,33.88,0.2,59.7,7207,74.4,NULL,NULL,'UGC 02311',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000081,NULL,'13.9g',0.91,'(R\')SB(r)b','in a radial-velocity based grouping',NULL,NULL,NULL,1,42.3664583,-0.873,0.133,NULL,34911888596,545498259,8523410,13.9),(27343,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27343,34.15,0.69,67.6,7207,100,NULL,'mid-IR','UGC 02311',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27344,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27344,35.81,0.7,145,7208,70,NULL,NULL,'2MASX J02492901-0034021',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.000074,NULL,'15.9g',0.37,'S0',NULL,NULL,NULL,NULL,1,42.370833,-0.56733,0.121,NULL,34897778266,545277785,8519965,15.9),(27345,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27345,35.25,0.25,112,7209,74.4,NULL,NULL,'2MASX J02492990-3109249',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.00015,NULL,'17.76',0.3,'E','Group member',NULL,NULL,NULL,1,42.374375,-31.15675,NULL,NULL,38612689994,603323281,9426926,17.76),(27346,'IRAS','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27346,34.9,0.8,95.5,7210,75,NULL,'W91PP, r','UGC 02304',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',NULL,NULL,'16.0',0.2,'S?',NULL,NULL,NULL,NULL,1,42.3809583,22.14422,0.557,NULL,68095639517,1063994367,16624911,16),(27347,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27347,34.8,0.49,91,7210,75,NULL,'IR','UGC 02304',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27348,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27348,35.04,0.4,102,7210,NULL,NULL,'mean','UGC 02304',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27349,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27349,35.13,0.47,106,7210,NULL,NULL,'H','UGC 02304',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27350,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27350,35.19,0.45,109,7210,NULL,NULL,'K','UGC 02304',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27351,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27351,35.24,0.46,112,7210,NULL,NULL,'J','UGC 02304',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27352,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27352,35.27,0.38,113,7210,75,NULL,'W91PP, r, raw','UGC 02304',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27353,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27353,35.5,0.38,126,7210,75,NULL,'W91PP, r, inv','UGC 02304',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27354,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27354,35.51,0.38,126,7210,75,NULL,'W91PP, r, cor','UGC 02304',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27355,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27355,35.37,0.25,119,7211,74.4,NULL,NULL,'2MASX J02493200-3110229',NULL,'2013AJ....146...86T',2013,1,0.43,NULL,'G',0.00007,NULL,'16.82',0.35,'E','Group member',NULL,NULL,NULL,1,42.3830417,-31.173,NULL,NULL,38612694261,603323347,9426927,16.82),(27356,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27356,34.94,0.25,97.3,7212,74.4,NULL,NULL,'2MASX J02493349-3107159',NULL,'2013AJ....146...86T',2013,1,0.68,NULL,'G',0.000077,NULL,'16.06',0.33,'S0','Group member',NULL,NULL,NULL,1,42.3890833333,-31.12111,NULL,NULL,38612692005,603323312,9426926,16.06),(27357,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27357,34.86,0.25,93.8,7213,74.4,NULL,NULL,'IC 1860',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.000067,NULL,'13.35',1.2,'E4;BrClG','Group member',NULL,NULL,NULL,1,42.3904583333,-31.18911,NULL,NULL,38612682942,603323170,9426924,13.35),(27358,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27358,34.95,0.47,97.7,7213,70,NULL,NULL,'IC 1860',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27359,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27359,35.98,0.33,157,7214,70,NULL,NULL,'2MASX J02493395-0035191',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000083,NULL,'16.1g',0.31,'E0',NULL,NULL,NULL,NULL,1,42.3912917,-0.58853,0.121,NULL,34897735914,545277123,8519955,16.1),(27360,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 11501',NULL,27360,40.28,1.31,1140,7215,70,NULL,'SN photometric redshift distance, z photo =0.312 +/- 0.387','SDSS-II SN 11501',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','23.3g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,42.3965,-1.09606,0.149,NULL,34911913737,545498652,8523416,23.3),(27361,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 11501','R',27361,41.23,0.29,1290,7215,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 11501',0.362703,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27362,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27362,34.75,0.1,89.3,7216,NULL,NULL,NULL,'CGCG 389-026',NULL,'2009ApJS..182..474S',2009,1,0.73,NULL,'G',0.000023,NULL,'15.7g',0.22,'Sc(f)',NULL,NULL,NULL,NULL,1,42.397375,-0.72375,0.133,NULL,34898578860,545290294,8520160,15.7),(27363,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 14570','RN',27363,39.15,0.35,571,7217,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14570',0.186456,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27364,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 14570','RN',27364,40.53,0.34,1070,7217,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 14570',0.186456,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27365,'IRAS','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27365,34.67,0.8,85.9,7218,75,NULL,'MAT, I','ESO 416- G 033',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'15.03',0.7,'Sc','Group member',NULL,NULL,NULL,1,42.406417,-30.99583,NULL,NULL,38612646194,603322596,9426915,15.03),(27366,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27366,33.69,0.32,54.6,7218,85,NULL,'I, raw','ESO 416- G 033',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27367,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27367,33.69,0.32,54.7,7218,85,NULL,'I, inv','ESO 416- G 033',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27368,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27368,33.95,0.43,61.6,7218,75,NULL,'MAT, I, raw','ESO 416- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27369,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27369,34.02,0.43,63.6,7218,75,NULL,'MAT, I, inv','ESO 416- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27370,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27370,34.22,0.43,69.7,7218,75,NULL,'MAT, I, cor','ESO 416- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27371,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27371,34.38,0.2,75.2,7218,74.4,NULL,NULL,'ESO 416- G 033',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27372,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27372,34.73,0.37,88.3,7218,NULL,NULL,'Malmquist cor.','ESO 416- G 033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27373,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27373,34.9,0.34,95.5,7218,NULL,NULL,NULL,'ESO 416- G 033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27374,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27374,35.4,0.37,120,7219,NULL,NULL,'Malmquist cor.','IC 1857',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000083,NULL,'14.90',0.5,'S?',NULL,NULL,NULL,NULL,1,42.4121666667,14.61981,0.285,NULL,68138494865,1064663982,16635374,14.9),(27375,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27375,35.49,0.35,125,7219,NULL,NULL,NULL,'IC 1857',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27376,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27376,35.73,0.2,140,7219,74.4,NULL,NULL,'IC 1857',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27377,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27377,35.12,0.25,106,7220,74.4,NULL,NULL,'2MASX J02493933-3112169',NULL,'2013AJ....146...86T',2013,1,0.46,NULL,'G',0.000067,NULL,'14',0.42,'E','Group member',NULL,NULL,NULL,1,42.4137083,-31.20472,NULL,NULL,38612683544,603323180,9426924,14),(27378,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27378,35.03,0.25,101,7221,74.4,NULL,NULL,'IC 0256',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000063,NULL,'14.31',NULL,'E/S0',NULL,NULL,NULL,NULL,1,42.417917,46.95467,0.877,NULL,68579333482,1071552085,16743001,14.31),(27379,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27379,35.23,0.22,111,7221,70,NULL,NULL,'IC 0256',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27380,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27380,35.98,0.33,157,7222,70,NULL,NULL,'2MASX J02494068-0033570',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000077,NULL,'15.5g',0.47,'E0',NULL,NULL,NULL,NULL,1,42.419583,-0.56592,0.121,NULL,34897783742,545277870,8519966,15.5),(27381,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27381,36.24,0.53,177,7222,70,NULL,NULL,'2MASX J02494068-0033570',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27382,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27382,34.69,0.25,86.7,7223,74.4,NULL,NULL,'2dFGRS S467Z174',NULL,'2013AJ....146...86T',2013,1,0.57,NULL,'G',0.000067,NULL,'15.69',0.52,'S0','Group member',NULL,NULL,NULL,1,42.4324583,-31.15794,NULL,NULL,38612696254,603323378,9426927,15.69),(27383,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27383,35.02,0.25,101,7224,74.4,NULL,NULL,'IC 0257',NULL,'2013AJ....146...86T',2013,1,2.2,'Wegner et al. (1993, AJ, 105, 1251) give v=9240+/-47 km/sec.','G',0.000057,NULL,'13.8',1.6,'S0-:',NULL,NULL,NULL,NULL,1,42.4393333333,46.97619,0.877,NULL,68579340871,1071552201,16743003,13.8),(27384,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27384,35.23,0.22,111,7224,70,NULL,NULL,'IC 0257',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27385,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 10043','RN',27385,39.24,0.57,656,7225,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10043',0.075376,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27386,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 10043','RN',27386,39.74,0.34,826,7225,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10043',0.075376,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27387,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 07804',NULL,27387,38.92,1.77,609,7226,70,NULL,'SN photometric redshift distance, z photo =0.154 +/- 0.242','SDSS-II SN 07804',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','20.8g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,42.454,0.98711,0.157,NULL,66843153819,1044424278,16319129,20.8),(27388,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 07804',NULL,27388,41.27,0.17,1790,7226,70,NULL,'SALT 2','SDSS-II SN 07804',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27389,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 07804',NULL,27389,41.32,0.17,1840,7226,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 07804',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27390,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27390,36.43,0.44,194,7227,NULL,NULL,'Malmquist cor.','2MASX J02494936-0047360',NULL,'2009ApJS..182..474S',2009,1,0.78,NULL,'G',0.000027,NULL,'15.9g',0.28,'Sb',NULL,NULL,NULL,NULL,1,42.4555416667,-0.79353,0.133,NULL,34898060658,545282197,8520034,15.9),(27391,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27391,36.7,0.39,219,7227,NULL,NULL,NULL,'2MASX J02494936-0047360',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27392,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27392,36.74,0.2,223,7227,74.4,NULL,NULL,'2MASX J02494936-0047360',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27393,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27393,35.14,0.2,107,7228,74.4,NULL,NULL,'UGC 02315',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',NULL,NULL,'17.',0.2,'Sbc',NULL,NULL,NULL,NULL,1,42.4587083,22.75364,0.565,NULL,68084209630,1063815775,16622121,17),(27394,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 15721','RN',27394,43.99,0.28,4240,7229,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 15721',0.48354,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27395,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27395,35.43,0.39,122,7230,NULL,NULL,'Malmquist cor.','CGCG 440-017',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000167,NULL,'15.50',0.3,NULL,NULL,NULL,NULL,NULL,1,42.4715416667,14.40181,0.289,NULL,68138451489,1064663304,16635364,15.5),(27396,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27396,35.51,0.37,126,7230,NULL,NULL,NULL,'CGCG 440-017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27397,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27397,35.58,0.2,131,7230,74.4,NULL,NULL,'CGCG 440-017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27398,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 03532','R',27398,40.38,0.48,1010,7231,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03532',0.182169,'2014arXiv1401.3317S',2014,1,0.09,NULL,'G',NULL,'PHOT','20.6g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,42.472375,-0.09825,0.141,NULL,34897885198,545279456,8519991,20.6),(27399,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 03532',NULL,27399,41.09,0.5,1650,7231,70,NULL,'SN photometric redshift distance, z photo =0.502 +/- 0.197','SDSS-II SN 03532',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27400,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 06358','R',27400,38.78,0.19,558,7232,70,NULL,'SDSS CAND. Variable; MLCS2K2','UGC 02319',0.023466,'2014arXiv1401.3317S',2014,1,1.44,NULL,'G',0.00002,NULL,'15.2g',0.31,'Sc(f)',NULL,NULL,NULL,NULL,1,42.473333,-1.00364,0.149,NULL,34898080413,545282506,8520039,15.2),(27401,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 06358','R',27401,39.96,0.27,958,7232,70,NULL,'SDSS CAND. Variable; SALT 2','UGC 02319',0.023466,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27402,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27402,34.32,0.49,73.1,7232,75,NULL,'IR','UGC 02319',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27403,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27403,34.8,0.2,91.2,7232,74.4,NULL,NULL,'UGC 02319',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27404,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27404,34.97,0.1,98.8,7232,NULL,NULL,NULL,'UGC 02319',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27405,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 19144','RN',27405,41.43,0.29,1410,7233,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19144',0.36744,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27406,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 19144','RN',27406,41.5,0.35,1460,7233,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19144',0.36744,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27407,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 19144','N',27407,41.46,0.24,1960,7233,70,NULL,'SALT 2','SDSS-II SN 19144',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27408,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 19144','N',27408,41.51,0.24,2000,7233,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19144',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27409,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27409,36.78,0.46,227,7234,70,NULL,NULL,'2MASXi J0249538-090028',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000071,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,42.474167,-9.00794,0.077,NULL,37876686679,591823229,9247237,16.5),(27410,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27410,34.86,0.25,93.8,7235,74.4,NULL,NULL,'2MFGC 02270',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000103,NULL,'16.23',0.22,'S0','Group member',NULL,NULL,NULL,1,42.4827917,-31.2875,NULL,NULL,38612673438,603323022,9426922,16.23),(27411,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27411,35.77,0.65,143,7235,70,NULL,NULL,'2MFGC 02270',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27412,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27412,35.58,0.25,131,7236,74.4,NULL,NULL,'2MASX J02495627-3107599',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000137,NULL,'15.96',0.45,'S0','Group member',NULL,NULL,NULL,1,42.484417,-31.13339,NULL,NULL,38612695348,603323364,9426927,15.96),(27413,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 08089','RN',27413,40.69,0.17,1160,7237,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 08089',0.186136,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27414,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 21878','RN',27414,42.16,0.41,2110,7238,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 21878',0.282959,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27415,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27415,34.29,0.49,72.2,7239,75,NULL,'IR','UGC 02313',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.00005,NULL,'15.5',0.2,'Scd:','Group member of poor cluster',NULL,NULL,NULL,1,42.518875,41.38928,0.297,NULL,68543112570,1070986133,16734158,15.5),(27416,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27416,34.39,0.2,75.5,7239,74.4,NULL,NULL,'UGC 02313',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27417,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27417,35.35,0.59,117,7240,70,NULL,NULL,'2MASX J02500784-0016014',NULL,'2014MNRAS.445.2677S',2014,1,0.74,NULL,'G',0.000086,NULL,'15.4g',0.5,NULL,NULL,NULL,NULL,NULL,1,42.5327083,-0.26697,0.141,NULL,34897860479,545279069,8519985,15.4),(27418,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27418,35.74,0.46,141,7240,70,NULL,NULL,'2MASX J02500784-0016014',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27419,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2003iv',NULL,27419,32.56,0.2,31.4,7241,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','UGC 02320 NOTES01',0.034307,'2011A&A...526A..81B',2011,1,0.7,NULL,'G',0.00009,NULL,'15.4',0.6,'compact',NULL,NULL,NULL,NULL,1,42.536833,12.84361,0.361,NULL,68140038901,1064688107,16635751,15.4),(27420,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2003iv',NULL,27420,35.28,0.18,110,7241,74.2,NULL,'SALT 2','UGC 02320 NOTES01',0.034307,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27421,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2003iv',NULL,27421,35.88,0.09,150,7241,74.4,NULL,NULL,'UGC 02320 NOTES01',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27422,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2003iv',NULL,27422,35.97,0.17,151,7241,70,NULL,'SALT 2','UGC 02320 NOTES01',0.034307,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27423,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2003iv',NULL,27423,36.06,0.17,157,7241,73.8,NULL,'SALT 2 (SNANA)','UGC 02320 NOTES01',0.035,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27424,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2003iv',NULL,27424,36.1,0.17,161,7241,65,NULL,'SALT','UGC 02320 NOTES01',0.034307,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27425,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2003iv',NULL,27425,36.2,0.2,168,7241,65,NULL,'SALT2','UGC 02320 NOTES01',0.034307,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27426,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2003iv',NULL,27426,36.21,0.16,169,7241,65,NULL,'MLCS31','UGC 02320 NOTES01',0.034307,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27427,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2003iv',NULL,27427,36.26,0.16,173,7241,65,NULL,'MLCS17','UGC 02320 NOTES01',0.034307,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27428,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2003iv',NULL,27428,36.48,0.05,191,7241,70,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','UGC 02320 NOTES01',0.034307,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27429,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27429,35.03,0.25,101,7242,74.4,NULL,NULL,'GIN 145',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.00007,NULL,'14.07',NULL,'S',NULL,NULL,NULL,NULL,1,42.5535833333,47.18083,0.877,NULL,68579482395,1071554412,16743037,14.07),(27430,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27430,35.23,0.22,111,7242,70,NULL,NULL,'GIN 145',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27431,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27431,35.96,0.61,155,7243,70,NULL,NULL,'2MASX J02501611-0520514',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.00015,NULL,'16.29',0.38,NULL,NULL,NULL,NULL,NULL,1,42.567125,-5.34769,0.121,NULL,37857550482,591524226,9242566,16.29),(27432,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27432,36.4,0.54,190,7244,70,NULL,NULL,'6dF J0250162-344857',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,42.5677916667,-34.81575,NULL,NULL,38639365894,603740092,9433438,15),(27433,'IRAS','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27433,34.21,0.8,69.4,7245,75,NULL,'MAT, I','MCG -02-08-012',NULL,'1997ApJS..109..333W',1997,1,1.21,'The SDSS positions straddle the dark lane.','G',0.00002,NULL,'15.0g',0.35,'Sb(f)          HII',NULL,NULL,NULL,NULL,1,42.5740417,-8.59708,0.113,NULL,37909363259,592333800,9255215,15),(27434,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27434,33.12,0.32,42.1,7245,85,NULL,'I, raw','MCG -02-08-012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27435,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27435,33.14,0.32,42.4,7245,85,NULL,'I, inv','MCG -02-08-012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27436,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27436,33.16,0.43,42.8,7245,75,NULL,'MAT, I, raw','MCG -02-08-012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27437,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27437,33.26,0.43,45,7245,75,NULL,'MAT, I, inv','MCG -02-08-012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27438,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27438,33.51,0.43,50.4,7245,75,NULL,'MAT, I, cor','MCG -02-08-012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27439,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27439,33.55,NULL,51.3,7245,NULL,NULL,NULL,'MCG -02-08-012',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27440,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27440,34.03,0.47,64,7245,NULL,NULL,'H','MCG -02-08-012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27441,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27441,34.06,0.49,64.8,7245,75,NULL,'IR','MCG -02-08-012',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27442,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27442,34.09,0.45,65.7,7245,NULL,NULL,'K','MCG -02-08-012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27443,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27443,34.22,NULL,69.7,7245,NULL,NULL,'Dipole','MCG -02-08-012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27444,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27444,34.22,NULL,69.9,7245,NULL,NULL,'Dipole + Quadrupole','MCG -02-08-012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27445,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27445,34.23,NULL,70.1,7245,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -02-08-012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27446,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27446,34.34,0.46,73.6,7245,NULL,NULL,'J','MCG -02-08-012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27447,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27447,34.36,0.4,74.4,7245,NULL,NULL,'mean','MCG -02-08-012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27448,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27448,34.74,0.2,88.7,7245,74.4,NULL,NULL,'MCG -02-08-012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27449,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27449,34.75,0.57,89.2,7245,NULL,NULL,'Malmquist cor.','MCG -02-08-012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27450,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27450,34.98,0.51,99.2,7245,NULL,NULL,NULL,'MCG -02-08-012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27451,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 10535','RN',27451,42.39,0.24,1900,7246,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10535',0.585774,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27452,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27452,30.28,0.2,11.4,7247,74.4,NULL,NULL,'CGCG 463-025',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000017,NULL,'14.81',0.3,'S?',NULL,NULL,NULL,NULL,1,42.5822917,19.11206,0.321,NULL,68123406866,1064428232,16631691,14.81),(27453,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27453,35.68,0.33,137,7248,NULL,NULL,'Malmquist cor.','NGC 1115',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000167,NULL,'15.6',0.2,NULL,NULL,NULL,NULL,NULL,1,42.60575,13.26622,0.377,NULL,68140553848,1064696153,16635877,15.6),(27454,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27454,36.03,0.28,161,7248,NULL,NULL,NULL,'NGC 1115',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27455,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27455,36.6,0.2,209,7248,74.4,NULL,NULL,'NGC 1115',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27456,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 18979','RN',27456,40.69,0.14,1160,7249,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18979',0.182378,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27457,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 18979','RN',27457,41.43,0.23,1640,7249,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18979',0.182378,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27458,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2007nh',NULL,27458,39.96,0.08,981,7250,70,NULL,'Hubble residual 0.00 for z0.26290','SDSS J025027.88-003304.2',NULL,'2011ApJ...740...92G',2011,1,0.08,NULL,'G',0.0005,NULL,'20.4g',0.07,NULL,NULL,NULL,NULL,NULL,1,42.616167,-0.55117,0.137,NULL,34898619828,545290934,8520170,20.4),(27459,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 19002','R',27459,40.64,0.2,1060,7250,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007nh','SDSS J025027.88-003304.2',0.2629,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27460,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 19002','R',27460,40.85,0.12,1170,7250,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007nh','SDSS J025027.88-003304.2',0.2629,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27461,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2007nh',NULL,27461,40.53,0.09,1280,7250,70,NULL,'SALT 2','SDSS J025027.88-003304.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27462,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2007nh',NULL,27462,40.56,0.09,1290,7250,70,NULL,'SALT 2, Malmquist cor.','SDSS J025027.88-003304.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27463,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27463,35.66,0.52,136,7251,70,NULL,NULL,'2MASX J02502895-1607168',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'15.92',0.26,NULL,NULL,NULL,NULL,NULL,1,42.62075,-16.12147,0.017,NULL,38107586193,595431034,9303609,15.92),(27464,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27464,34.86,0.61,93.9,7252,70,NULL,NULL,'ESO 416- G 035',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000073,NULL,'15.10',0.8,'(R)SA(rs)0/a   HII?','Group member',NULL,NULL,NULL,1,42.6323333333,-31.39464,NULL,NULL,38612711202,603323612,9426931,15.1),(27465,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2005fu',NULL,27465,39.31,0.12,606,7253,74.2,NULL,'SALT 2','SDSS J025032.13+004826.4',0.2,'2010ApJ...716..712A',2010,1,0.11,NULL,'G',NULL,NULL,'19.5g',0.08,NULL,NULL,NULL,NULL,NULL,1,42.633875,0.80733,0.157,NULL,66843135189,1044423987,16319124,19.5),(27466,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2005fu',NULL,27466,39.6,0.04,692,7253,70,NULL,'SDSS-II SN 02440','SDSS J025032.13+004826.4',0.2,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27467,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2005fu',NULL,27467,40.02,0.13,842,7253,70,NULL,'SDSS-II SN 02440, SALT 2','SDSS J025032.13+004826.4',0.2,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27468,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2005fu',NULL,27468,40.04,0.09,849,7253,65,NULL,'SALT2','SDSS J025032.13+004826.4',0.2,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27469,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 02440','R',27469,40.05,0.19,854,7253,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fu','SDSS J025032.13+004826.4',0.2,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27470,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2005fu',NULL,27470,40.21,0.1,918,7253,65,NULL,'MLCS2k2','SDSS J025032.13+004826.4',0.2,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27471,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 02440','R',27471,40.23,0.11,926,7253,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fu','SDSS J025032.13+004826.4',0.2,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27472,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2005fu',NULL,27472,39.94,0.08,973,7253,70,NULL,'SALT 2','SDSS J025032.13+004826.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27473,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2005fu',NULL,27473,39.95,0.08,977,7253,70,NULL,'SALT 2, Malmquist cor.','SDSS J025032.13+004826.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27474,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27474,34.59,0.39,82.6,7254,NULL,NULL,'Malmquist cor.','ESO 416- G 036',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.22',0.7,'Sb','Group member',NULL,NULL,NULL,1,42.648083,-31.52008,NULL,NULL,38612586843,603321669,9426901,14.22),(27475,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27475,34.68,0.37,86.4,7254,NULL,NULL,NULL,'ESO 416- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27476,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27476,34.72,0.2,87.9,7254,74.4,NULL,NULL,'ESO 416- G 036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27477,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27477,35.1,0.4,104,7254,NULL,NULL,'mean','ESO 416- G 036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27478,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27478,35.21,0.47,110,7254,NULL,NULL,'H','ESO 416- G 036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27479,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27479,35.39,0.09,120,7255,NULL,NULL,NULL,'NGC 1116',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.00008,NULL,'15.20',0.3,'Sab',NULL,NULL,NULL,NULL,1,42.6487083333,13.33506,0.393,NULL,68140552245,1064696128,16635877,15.2),(27480,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27480,35.64,0.2,134,7255,74.4,NULL,NULL,'NGC 1116',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27481,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27481,34.48,0.47,78.7,7256,NULL,NULL,'H','UGC 02327',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000017,NULL,'14.67',0.8,'Sb:',NULL,NULL,NULL,NULL,1,42.6625417,20.68269,0.449,NULL,68122639773,1064416246,16631503,14.67),(27482,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27482,34.66,0.45,85.4,7256,NULL,NULL,'K','UGC 02327',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27483,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27483,34.67,0.46,86,7256,NULL,NULL,'J','UGC 02327',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27484,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27484,34.68,0.4,86.4,7256,NULL,NULL,'mean','UGC 02327',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27485,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2005jt',NULL,27485,40.44,0.18,900,7257,74.2,NULL,'SALT 2','SDSS J025040.19-000400.0',0.36,'2010ApJ...716..712A',2010,1,0.07,NULL,'G',0.0005,NULL,'21.2g',0.05,NULL,NULL,NULL,NULL,NULL,1,42.6674583333,-0.06667,0.141,NULL,34897815940,545278374,8519974,21.2),(27486,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2005jt',NULL,27486,40.19,0.23,1090,7257,70,NULL,'Hubble residual -0.35 for z0.36060','SDSS J025040.19-000400.0',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27487,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2005jt',NULL,27487,41,0.23,1160,7257,65,NULL,'SALT2','SDSS J025040.19-000400.0',0.36,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27488,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2005jt',NULL,27488,41.02,0.21,1180,7257,70,NULL,'SALT 2','SDSS J025040.19-000400.0',0.36,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27489,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 08598','R',27489,41.18,0.29,1270,7257,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005jt','SDSS J025040.19-000400.0',0.3606,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27490,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 08598','R',27490,41.19,0.26,1270,7257,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005jt','SDSS J025040.19-000400.0',0.3606,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27491,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2005jt',NULL,27491,41.41,0.2,1410,7257,65,NULL,'MLCS2k2','SDSS J025040.19-000400.0',0.36,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27492,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2005jt',NULL,27492,41.03,0.19,1610,7257,70,NULL,'SALT 2','SDSS J025040.19-000400.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27493,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2005jt',NULL,27493,41.08,0.19,1640,7257,70,NULL,'SALT 2, Malmquist cor.','SDSS J025040.19-000400.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27494,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27494,35.95,0.67,155,7258,70,NULL,NULL,'2MASX J02504193-3130145',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.79',0.23,'S0/a','Group member',NULL,NULL,NULL,1,42.6746666667,-31.50403,NULL,NULL,38612590565,603321727,9426901,16.79),(27495,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27495,36.5,0.55,200,7259,70,NULL,NULL,'2MASX J02504210-4323076',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.57',0.4,NULL,NULL,NULL,NULL,NULL,1,42.6754583,-43.38553,0,NULL,38504912494,601639257,9400613,16.57),(27496,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 07972','RN',27496,42.95,0.23,2670,7260,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 07972',0.457011,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27497,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27497,37.26,0.53,283,7261,70,NULL,NULL,'2MASX J02504528-2339061',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'17.06',0.32,NULL,NULL,NULL,NULL,NULL,1,42.688667,-23.65172,0.013,NULL,37937283655,592770057,9262032,17.06),(27498,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27498,35.81,0.4,145,7262,NULL,NULL,'mean','UGC 02329',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000013,NULL,'14.73',0.7,'Sab','Group member',NULL,NULL,NULL,1,42.704333,16.00772,0.217,NULL,68175483234,1065241925,16644405,14.73),(27499,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27499,35.89,0.47,150,7262,NULL,NULL,'H','UGC 02329',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27500,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27500,36.02,0.45,160,7262,NULL,NULL,'K','UGC 02329',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27501,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27501,36.04,0.46,162,7262,NULL,NULL,'J','UGC 02329',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27502,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27502,37.9,0.46,381,7263,70,NULL,NULL,'SDSS J025051.57-085611.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000072,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,42.7149166667,-8.93653,0.125,NULL,37909213359,592331458,9255179,18.4),(27503,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 01251','RN',27503,40.21,0.19,935,7264,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01251',0.179133,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27504,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 01251','RN',27504,40.83,0.23,1240,7264,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01251',0.179133,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27505,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27505,35.03,0.25,101,7265,74.4,NULL,NULL,'IC 0260',NULL,'2013AJ....146...86T',2013,1,1.4,'One of two 6cm sources associated with [WB92] 0247+4645','G',0.00007,NULL,'14.1',0.9,'E:',NULL,NULL,'radio jet','Flat-Spectrum Radio Source',1,42.753667,46.95478,0.861,NULL,68579322667,1071551916,16742998,14.1),(27506,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27506,35.23,0.22,111,7265,70,NULL,NULL,'IC 0260',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27507,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27507,35.48,0.4,125,7265,NULL,NULL,'mean','IC 0260',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27508,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27508,35.54,0.45,128,7265,NULL,NULL,'K','IC 0260',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27509,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27509,35.64,0.72,135,7266,70,NULL,NULL,'2MASX J02510246-0942087',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.24',NULL,NULL,NULL,NULL,NULL,NULL,1,42.760125,-9.70233,0.073,NULL,37871666340,591744786,9246012,16.24),(27510,'Tully est','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27510,30.51,0.8,12.6,7267,75,NULL,'B','MRK 0600',NULL,'1988NBGC.C....0000T',1988,1,0.4,NULL,'G',0.000004,NULL,'15.40',0.2,'SBb;BCD',NULL,NULL,NULL,NULL,1,42.7690416667,4.45386,0.177,NULL,67924400826,1061318762,16583105,15.4),(27511,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 16434','R',27511,41.22,0.3,1310,7268,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16434',0.345377,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',NULL,'PHOT','21.2g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,42.7849583333,-1.17044,0.157,NULL,34899787907,545309186,8520456,21.2),(27512,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 16434','R',27512,41.24,0.26,1310,7268,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16434',0.345377,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27513,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 16434',NULL,27513,40.73,0.86,1400,7268,70,NULL,'SN photometric redshift distance, z photo =0.403 +/- 0.297','SDSS-II SN 16434',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27514,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 16434',NULL,27514,41.13,0.2,1680,7268,70,NULL,'SALT 2','SDSS-II SN 16434',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27515,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 16434',NULL,27515,41.17,0.2,1710,7268,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16434',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27516,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27516,33.83,0.2,58.3,7269,74.4,NULL,NULL,'UGC 02338',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000123,NULL,'14.30',0.8,'SB(s)d:',NULL,NULL,NULL,NULL,1,42.789167,2.59383,0.229,NULL,66841578176,1044399659,16318744,14.3),(27517,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27517,33.87,0.44,59.4,7269,NULL,NULL,'Malmquist cor.','UGC 02338',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27518,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27518,33.9,0.43,60.3,7269,NULL,NULL,NULL,'UGC 02338',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27519,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27519,34.12,0.49,66.6,7270,75,NULL,'IR','KUG 0248-069B',NULL,'2011yCatp016004901K',2011,1,1.45,NULL,'G',0.00002,NULL,'15.9g',0.2,'Sd(f)',NULL,NULL,NULL,NULL,1,42.792125,-6.70628,0.137,NULL,37911779192,592371549,9255805,15.9),(27520,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 14947',NULL,27520,40.55,0.36,1290,7271,70,NULL,'SN photometric redshift distance, z photo =0.363 +/- 0.085','SDSS-II SN 14947',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.9g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,42.798125,0.45319,0.165,NULL,66843567779,1044430746,16319230,21.9),(27521,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 14947','R',27521,41.35,0.42,1510,7271,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14947',0.232006,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27522,'IRAS','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27522,34.9,0.8,95.6,7272,75,NULL,'W91PP, r','UGC 02333',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000013,NULL,'15.52',0.4,'Sbc',NULL,NULL,NULL,NULL,1,42.8020417,25.40717,0.593,NULL,68602569207,1071915143,16748674,15.52),(27523,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27523,35.07,0.38,103,7272,75,NULL,'W91PP, r, raw','UGC 02333',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27524,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27524,35.2,0.38,110,7272,75,NULL,'W91PP, r, inv','UGC 02333',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27525,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27525,35.35,0.38,117,7272,75,NULL,'W91PP, r, cor','UGC 02333',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27526,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 13482','RN',27526,40.32,0.25,878,7273,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 13482',0.317811,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27527,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 13482','RN',27527,40.36,0.34,896,7273,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 13482',0.317811,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27528,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27528,35.22,0.27,111,7274,70,NULL,NULL,'2MASX J02511327-0050422',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000077,NULL,'15.7g',0.44,'E0',NULL,NULL,NULL,NULL,1,42.805417,-0.845,0.169,NULL,34898012313,545281442,8520022,15.7),(27529,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27529,35.82,0.85,146,7274,70,NULL,NULL,'2MASX J02511327-0050422',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27530,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27530,35.58,0.64,131,7275,70,NULL,NULL,'2MASX J02511626-3119392',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'14',0.5,'SB(r)0/a','Group member',NULL,NULL,NULL,1,42.8178333333,-31.32758,NULL,NULL,38611878591,603310602,9426728,14),(27531,'IRAS','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27531,34.13,0.8,66.9,7276,75,NULL,'MAT, I','ESO 416- G 037',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.08',0.4,'Sb:            HII',NULL,NULL,NULL,NULL,1,42.825625,-28.20069,0.014,NULL,38422051916,600344561,9380383,14.08),(27532,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27532,34.02,0.43,63.6,7276,75,NULL,'MAT, I, raw','ESO 416- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27533,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27533,34.04,0.47,64.4,7276,NULL,NULL,'H','ESO 416- G 037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27534,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27534,34.08,0.32,65.6,7276,85,NULL,'I, raw','ESO 416- G 037',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27535,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27535,34.09,0.45,65.8,7276,NULL,NULL,'K','ESO 416- G 037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27536,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27536,34.11,0.46,66.4,7276,NULL,NULL,'J','ESO 416- G 037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27537,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27537,34.14,0.32,67.4,7276,85,NULL,'I, inv','ESO 416- G 037',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27538,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27538,34.21,0.4,69.6,7276,NULL,NULL,'mean','ESO 416- G 037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27539,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27539,34.27,0.43,71.5,7276,75,NULL,'MAT, I, inv','ESO 416- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27540,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27540,34.3,0.43,72.3,7276,75,NULL,'MAT, I, cor','ESO 416- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27541,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27541,34.44,0.55,77.2,7276,NULL,NULL,NULL,'ESO 416- G 037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27542,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27542,34.48,0.2,78.7,7276,74.4,NULL,NULL,'ESO 416- G 037',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27543,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27543,34.48,0.54,78.8,7276,NULL,NULL,'Malmquist cor.','ESO 416- G 037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27544,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 18164','RN',27544,41.87,0.3,1860,7277,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18164',0.27226,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27545,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 18164','RN',27545,42.59,0.29,2590,7277,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18164',0.27226,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27546,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27546,34.54,0.48,80.8,7278,70,NULL,NULL,'2MASX J02512041-6808481',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000097,NULL,'14.90',0.7,'S0',NULL,NULL,NULL,NULL,1,42.835167,-68.14667,0.053,NULL,36496131875,570252060,8910188,14.9),(27547,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27547,35.16,NULL,107,7279,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0349',NULL,'2010Ap&SS.325..163P',2010,1,0.86,NULL,'G',0.000014,NULL,'16.48',0.08,'Sd',NULL,NULL,NULL,NULL,1,42.837917,5.55639,0.197,NULL,67926222875,1061347232,16583550,16.48),(27548,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27548,35.16,NULL,108,7279,NULL,NULL,'Dipole + Quadrupole','FGC 0349',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27549,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27549,35.17,NULL,108,7279,NULL,NULL,'Dipole','FGC 0349',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27550,'BCG','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27550,38.61,0.35,472,7280,60,NULL,'ABELL 0389, BCG','2MASX J02512479-2456393',0.116,'1980ApJ...241..486H',1980,1,0.41,NULL,'G',0.00015,NULL,'16.58',0.35,'E','Brightest group member',NULL,NULL,NULL,1,42.853375,-24.94425,0,NULL,37936719666,592761244,9261894,16.58),(27551,'BCG','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27551,38.61,0.35,472,7281,60,NULL,NULL,'ABELL 0389',0.116,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II     [BM]',NULL,NULL,NULL,NULL,1,42.87,-24.94944,0,NULL,37936719480,592761241,9261894,NULL),(27552,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27552,34.79,0.63,90.6,7282,70,NULL,NULL,'UGC 02343',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000077,NULL,'14.8g',0.58,'Sa:',NULL,NULL,NULL,NULL,1,42.896333,-0.73378,0.161,NULL,34898497977,545289030,8520141,14.8),(27553,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27553,37.84,0.46,369,7283,70,NULL,NULL,'2MASX J02513627+0108214',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,42.901167,1.13928,0.161,NULL,66843682505,1044432539,16319258,16.6),(27554,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27554,34.85,0.49,93.3,7284,75,NULL,'IR','ESO 546- G 027',NULL,'2011yCatp016004901K',2011,1,0.85,NULL,'G',0.00005,NULL,'16.53',0.1,'Sd',NULL,NULL,NULL,NULL,1,42.917,-18.07014,0.053,NULL,38109014629,595453353,9303958,16.53),(27555,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27555,36.59,0.65,208,7285,70,NULL,NULL,'2MASX J02514157-0715091',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.000094,NULL,'16.2g',0.36,'E0',NULL,NULL,NULL,NULL,1,42.92325,-7.25253,0.109,NULL,37912257802,592379028,9255922,16.2),(27556,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27556,37.06,0.46,258,7285,70,NULL,NULL,'2MASX J02514157-0715091',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27557,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 03533',NULL,27557,40.17,0.21,1080,7286,70,NULL,'SN photometric redshift distance, z photo =0.294 +/- 0.036','SDSS-II SN 03533',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,42.9239583,-0.13494,0.137,NULL,34898254141,545285220,8520081,NULL),(27558,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27558,36.7,0.46,219,7287,70,NULL,NULL,'2MASX J02514177-0829091',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00006,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,42.924167,-8.48581,0.113,NULL,37909252676,592332073,9255188,17.2),(27559,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27559,38.09,0.46,415,7288,70,NULL,NULL,'2MASX J02514790-0802371',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000081,NULL,'18.3g',0.1,NULL,NULL,NULL,NULL,NULL,1,42.9496666667,-8.04369,0.125,NULL,37910001609,592343775,9255371,18.3),(27560,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 18819','RN',27560,41.12,0.18,1360,7289,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 18819',0.233195,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27561,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 18819','RN',27561,41.98,0.23,2020,7289,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 18819',0.233195,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27562,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 14752',NULL,27562,40.73,0.29,1400,7290,70,NULL,'SN photometric redshift distance, z photo =0.404 +/- 0.078','SDSS-II SN 14752',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,42.9632916667,0.66833,0.185,NULL,66843322510,1044426914,16319170,NULL),(27563,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 14752',NULL,27563,41.76,0.28,2250,7290,70,NULL,'SALT 2','SDSS-II SN 14752',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27564,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 14752',NULL,27564,41.84,0.28,2330,7290,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14752',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27565,'GRB','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27565,42.9,0.38,3800,7291,NULL,NULL,NULL,'GRB 110213A',NULL,'2012arXiv1205.2954T',2012,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,42.9645,49.27292,NULL,NULL,68525550035,1070711719,16729870,NULL),(27566,'Tully est','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27566,31.37,0.8,18.8,7292,75,NULL,NULL,'UGC 02345',NULL,'1988NBGC.C....0000T',1988,1,3.5,NULL,'G',0.00001,NULL,'14.2',3,'SB(rs)m:       HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,42.969583,-1.17222,0.157,NULL,34899956134,545311814,8520497,14.2),(27567,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27567,30.74,0.4,14.1,7292,NULL,NULL,NULL,'UGC 02345',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27568,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27568,30.75,0.39,14.1,7292,73,NULL,'opt','UGC 02345',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27569,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27569,30.77,0.2,14.3,7292,74.4,NULL,NULL,'UGC 02345',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27570,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27570,37.16,0.46,271,7293,70,NULL,NULL,'2MASX J02515421+0013516',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000068,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,42.975875,0.23103,0.177,NULL,66842959103,1044421235,16319081,18),(27571,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27571,35.13,0.48,106,7294,70,NULL,NULL,'CGCG 389-037',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000083,NULL,'14.8g',0.4,'E0',NULL,NULL,NULL,NULL,1,42.983833,-0.83628,0.169,NULL,34897988423,545281069,8520016,14.8),(27572,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27572,35.22,0.27,111,7294,70,NULL,NULL,'CGCG 389-037',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27573,'IRAS','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27573,34.61,0.8,83.6,7295,75,NULL,'MAT, I','IC 1862',NULL,'1997ApJS..109..333W',1997,1,3.25,NULL,'G',0.000027,NULL,'14.45',0.45,'SAbc: sp',NULL,NULL,NULL,NULL,1,42.995,-33.34017,NULL,NULL,38640417568,603756524,9433695,14.45),(27574,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27574,34.16,0.49,68.1,7295,75,NULL,'IR','IC 1862',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27575,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27575,34.17,0.43,68.1,7295,75,NULL,'MAT, I, raw','IC 1862',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27576,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27576,34.22,0.47,69.9,7295,NULL,NULL,'H','IC 1862',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27577,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27577,34.26,0.45,71.1,7295,NULL,NULL,'K','IC 1862',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27578,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27578,34.31,0.32,72.9,7295,85,NULL,'I, raw','IC 1862',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27579,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27579,34.32,NULL,73.1,7295,NULL,NULL,NULL,'IC 1862',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27580,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27580,34.36,0.43,74.5,7295,75,NULL,'MAT, I, cor','IC 1862',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27581,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27581,34.36,0.46,74.5,7295,NULL,NULL,'J','IC 1862',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27582,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27582,34.38,0.32,75.1,7295,85,NULL,'I, inv','IC 1862',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27583,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27583,34.41,NULL,76.4,7295,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 1862',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27584,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27584,34.42,NULL,76.5,7295,NULL,NULL,'Dipole','IC 1862',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27585,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27585,34.42,NULL,76.6,7295,NULL,NULL,'Dipole + Quadrupole','IC 1862',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27586,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27586,34.44,0.43,77.3,7295,75,NULL,'MAT, I, inv','IC 1862',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27587,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27587,34.54,0.34,80.8,7295,NULL,NULL,'Malmquist cor.','IC 1862',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27588,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27588,34.58,0.2,82.4,7295,74.4,NULL,NULL,'IC 1862',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27589,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27589,34.63,0.4,84.2,7295,NULL,NULL,'mean','IC 1862',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27590,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27590,34.69,0.32,86.6,7295,NULL,NULL,NULL,'IC 1862',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27591,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27591,34.99,0.5,99.5,7296,70,NULL,NULL,'ESO 053- G 020',NULL,'2014MNRAS.445.2677S',2014,1,1.02,NULL,'G',0.00013,NULL,'15.56',0.34,'S...',NULL,NULL,NULL,NULL,1,42.9957917,-69.43475,0.073,NULL,36451462507,569554101,8899282,15.56),(27592,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27592,35.42,0.59,121,7297,70,NULL,NULL,'2MASX J02520173-1352084',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'16.23',0.41,NULL,NULL,NULL,NULL,NULL,1,43.00725,-13.86897,0.049,NULL,38096267352,595254177,9300846,16.23),(27593,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27593,36.51,0.46,200,7298,70,NULL,NULL,'2MASX J02520716-0805342',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000088,NULL,'16.3g',0.33,'E0',NULL,NULL,NULL,NULL,1,43.03,-8.09278,0.125,NULL,37910171322,592346426,9255412,16.3),(27594,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27594,35.53,0.46,127,7299,70,NULL,NULL,'2MASX J02521320-0645532',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000102,NULL,'15.2g',0.54,'E0',NULL,NULL,NULL,NULL,1,43.055083,-6.76492,0.153,NULL,37911708940,592370452,9255788,15.2),(27595,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27595,35.57,0.49,130,7299,70,NULL,NULL,'2MASX J02521320-0645532',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27596,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27596,35.02,0.25,101,7300,74.4,NULL,NULL,'GIN 146',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000067,NULL,'14.16',0.3,'E',NULL,NULL,NULL,NULL,1,43.0697917,46.91328,0.865,NULL,68579798246,1071559347,16743114,14.16),(27597,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27597,35.23,0.22,111,7300,70,NULL,NULL,'GIN 146',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27598,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 20914','RN',27598,42.74,0.51,3010,7301,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 20914',0.174234,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27599,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27599,35.58,0.5,131,7302,70,NULL,NULL,'NGC 1126',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000073,NULL,'15.43',0.2,'Sb: sp','Group member',NULL,NULL,NULL,1,43.077625,-1.296,0.161,NULL,34899849786,545310152,8520471,15.43),(27600,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27600,35.04,0.48,102,7303,70,NULL,NULL,'ESO 116- G 001',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000133,NULL,'14.00',1.1,'(R\'_2)SB(r)bc',NULL,NULL,NULL,NULL,1,43.088875,-57.94808,0,NULL,36253781583,566465337,8851020,14),(27601,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27601,35.41,0.49,121,7304,70,NULL,NULL,'ESO 416- G 039',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.0001,NULL,'15.13',0.6,'S0?','Group member',NULL,NULL,NULL,1,43.0930417,-31.81728,NULL,NULL,38610403716,603287558,9426368,15.13),(27602,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27602,34.86,0.54,93.9,7305,NULL,NULL,'Malmquist cor.','ESO 416- G 040',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.50',0.6,'Sb             HII','Group member',NULL,NULL,NULL,1,43.1130417,-30.77653,NULL,NULL,38611406568,603303227,9426612,14.5),(27603,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27603,35.17,0.47,108,7305,NULL,NULL,NULL,'ESO 416- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27604,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27604,35.21,0.2,110,7305,74.4,NULL,NULL,'ESO 416- G 040',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27605,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2007nj',NULL,27605,38.89,0.07,599,7306,70,NULL,'Hubble residual -0.03 for z0.15395','SDSS J025227.18+001506.2',NULL,'2011ApJ...740...92G',2011,1,0.26,NULL,'G',0.00011,NULL,'18.9g',0.09,NULL,NULL,NULL,NULL,NULL,1,43.1132917,0.25172,0.137,NULL,66842990292,1044421723,16319089,18.9),(27606,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 19353','R',27606,39.39,0.18,653,7306,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007nj','SDSS J025227.18+001506.2',0.15395,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27607,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 19353','R',27607,39.55,0.09,704,7306,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007nj','SDSS J025227.18+001506.2',0.15395,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27608,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2007nj',NULL,27608,39.28,0.07,718,7306,70,NULL,'SALT 2','SDSS J025227.18+001506.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27609,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2007nj',NULL,27609,39.29,0.07,721,7306,70,NULL,'SALT 2, Malmquist cor.','SDSS J025227.18+001506.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27610,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27610,37.29,0.27,287,7307,70,NULL,NULL,'2MASX J02522751-0756056',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000094,NULL,'16.4g',0.35,'AGN',NULL,NULL,NULL,NULL,1,43.1147083333,-7.93486,0.125,NULL,37909527852,592336372,9255255,16.4),(27611,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 20528','RN',27611,38.99,0.18,553,7308,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007qr','SDSS-II SN 20528',0.135691,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27612,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 20528','RN',27612,39.02,0.1,560,7308,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007qr','SDSS-II SN 20528',0.135691,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27613,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 20528','N',27613,38.77,0.06,568,7308,70,NULL,'SALT 2','SDSS-II SN 20528',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27614,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 20528','N',27614,38.78,0.06,570,7308,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20528',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27615,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27615,36.57,0.46,206,7309,70,NULL,NULL,'2MASX J02523222-0002526',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00009,NULL,'16.1g',0.39,'E0',NULL,NULL,NULL,NULL,1,43.134333,-0.04783,0.165,NULL,34898295142,545285861,8520091,16.1),(27616,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27616,36.02,0.53,160,7310,70,NULL,NULL,'2MASX J02523709-2114336',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.04',0.38,'S0',NULL,NULL,NULL,NULL,1,43.154667,-21.24258,0.049,NULL,38060230423,594691100,9292048,16.04),(27617,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27617,37.09,0.46,261,7311,70,NULL,NULL,'2MASX J02524609-0836157',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000115,NULL,'15.9g',0.42,'AGN',NULL,NULL,NULL,NULL,1,43.192125,-8.60439,0.141,NULL,37909245196,592331956,9255186,15.9),(27618,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 06323','RN',27618,41.09,0.11,1300,7312,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 06323',0.26855,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27619,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27619,37.29,0.27,287,7313,70,NULL,NULL,'2MASX J02525040-0754537',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000079,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,43.210125,-7.91503,0.125,NULL,37909635499,592338054,9255282,17.4),(27620,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27620,33,0.47,39.8,7314,NULL,NULL,'H','NGC 1122',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000037,NULL,'12.9',1.3,'SABb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,43.213333,42.20503,0.373,NULL,68540749658,1070949213,16733581,12.9),(27621,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27621,33.01,0.45,40,7314,NULL,NULL,'K','NGC 1122',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27622,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27622,33.07,0.46,41,7314,NULL,NULL,'J','NGC 1122',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27623,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27623,33.47,0.4,49.5,7314,NULL,NULL,'mean','NGC 1122',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27624,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27624,37.29,0.27,287,7315,70,NULL,NULL,'2MASX J02525162-0758184',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00009,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,43.215,-7.97167,0.125,NULL,37909636402,592338068,9255282,16.2),(27625,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27625,34.66,0.46,85.4,7316,70,NULL,NULL,'NGC 1132',NULL,'2014MNRAS.445.2677S',2014,1,2.5,NULL,'G',0.000037,NULL,'13.25',1.3,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,43.2162917,-1.27469,0.165,NULL,34900711020,545323609,8520681,13.25),(27626,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27626,34.56,0.45,81.6,7316,NULL,NULL,'K','NGC 1132',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27627,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27627,34.93,0.4,96.7,7316,NULL,NULL,'mean','NGC 1132',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27628,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27628,35.41,0.53,121,7317,70,NULL,NULL,'2MASX J02525576-1414225',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'15.96',0.38,NULL,NULL,NULL,NULL,NULL,1,43.23225,-14.23958,0.077,NULL,38095236015,595238062,9300594,15.96),(27629,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27629,36.44,0.85,194,7318,70,NULL,NULL,'ESO 480- G 009',NULL,'2014MNRAS.445.2677S',2014,1,1.46,NULL,'G',0.00015,NULL,'15.5',0.16,'Sb','Pair member (points to parent)',NULL,NULL,NULL,1,43.245625,-24.86242,0,NULL,37934064537,592719758,9261246,15.5),(27630,'SNII optical','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 1999eg',NULL,27630,34.68,0.16,82.6,7319,NULL,NULL,'SEAM','IC 1861',0.022359,'2009ApJ...694.1067P',2009,1,1.4,NULL,'G',0.000013,NULL,'14.33',1,'SA0^0^','Isolated galaxy',NULL,NULL,NULL,1,43.279083,25.49039,0.581,NULL,68602813285,1071918957,16748733,14.33),(27631,'SNII optical','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 1999eg',NULL,27631,34.77,0.13,89.9,7319,NULL,NULL,'I, photospheric magnitude method','IC 1861',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27632,'SNII optical','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 1999eg',NULL,27632,34.97,0.14,98.6,7319,NULL,NULL,'V, photospheric magnitude method','IC 1861',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27633,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 01576',NULL,27633,40.96,0.28,1560,7320,70,NULL,'SN photometric redshift distance, z photo =0.463 +/- 0.087','SDSS-II SN 01576',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,43.280583,0.55553,0.209,NULL,66843996357,1044437443,16319335,NULL),(27634,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 01576','R',27634,41.98,0.37,1680,7320,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01576',0.476722,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27635,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 01576',NULL,27635,41.85,0.27,2340,7320,70,NULL,'SALT 2','SDSS-II SN 01576',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27636,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 01576',NULL,27636,41.97,0.27,2480,7320,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 01576',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27637,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 13491','R',27637,41.38,0.25,1390,7321,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13491',0.362005,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,43.2859583333,0.11892,0.165,NULL,66842830598,1044419228,16319050,NULL),(27638,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 13491','R',27638,41.63,0.19,1560,7321,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13491',0.362005,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27639,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27639,38.45,0.46,489,7322,70,NULL,NULL,'SDSS J025309.58-085017.9',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000089,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,43.289917,-8.83833,0.125,NULL,37913517332,592398708,9256229,18.8),(27640,'IRAS','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27640,34.2,0.8,69.2,7323,75,NULL,'HMCL, I','UGC 02364',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000008,NULL,'16.5',0.4,'Sb',NULL,NULL,NULL,NULL,1,43.3397083333,6.53947,0.281,NULL,67970421680,1062037838,16594341,16.5),(27641,'IRAS','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27641,34.2,0.8,69.3,7323,75,NULL,'A82, H','UGC 02364',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27642,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27642,34.3,0.47,72.6,7323,75,NULL,'A82, H, raw','UGC 02364',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27643,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27643,34.4,0.47,75.7,7323,75,NULL,'A82, H, inv','UGC 02364',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27644,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27644,34.47,0.2,78.3,7323,74.4,NULL,NULL,'UGC 02364',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27645,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27645,34.57,0.43,82.1,7323,75,NULL,'3.6 micron, color corrected','UGC 02364',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27646,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27646,34.67,0.43,85.7,7323,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02364',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27647,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27647,34.74,0.4,88.7,7323,75,NULL,'HMCL, I, raw','UGC 02364',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27648,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27648,34.8,0.47,91,7323,75,NULL,'A82, H, cor','UGC 02364',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27649,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27649,34.89,0.4,95.1,7323,75,NULL,'HMCL, I, inv','UGC 02364',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27650,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27650,35,0.4,99.9,7323,75,NULL,'HMCL, I, cor','UGC 02364',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27651,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27651,35.02,0.12,101,7323,NULL,NULL,NULL,'UGC 02364',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27652,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27652,37.52,0.46,319,7324,70,NULL,NULL,'2MASX J02532531-0754468',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000073,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,43.355375,-7.91297,0.125,NULL,37909691353,592338927,9255295,17.6),(27653,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27653,36.96,0.78,247,7325,70,NULL,NULL,'2MASX J02532614-0131102',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00009,NULL,'16.74',0.36,NULL,NULL,NULL,NULL,NULL,1,43.3587917,-1.5195,0.161,NULL,34900153048,545314891,8520545,16.74),(27654,'IRAS','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27654,34.6,0.8,83.2,7326,75,NULL,'MAT, I','ESO 416- G 041',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'14.33',0.6,'SAB(rs)bc',NULL,NULL,NULL,NULL,1,43.372375,-30.86036,NULL,NULL,38611739553,603308430,9426694,14.33),(27655,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27655,34.2,0.43,69.1,7326,75,NULL,'MAT, I, raw','ESO 416- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27656,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27656,34.25,0.32,70.8,7326,85,NULL,'I, raw','ESO 416- G 041',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27657,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27657,34.3,0.32,72.6,7326,85,NULL,'I, inv','ESO 416- G 041',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27658,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27658,34.4,0.43,76,7326,75,NULL,'MAT, I, cor','ESO 416- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27659,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27659,34.44,0.43,77.4,7326,75,NULL,'MAT, I, inv','ESO 416- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27660,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27660,34.54,0.35,80.7,7326,NULL,NULL,'Malmquist cor.','ESO 416- G 041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27661,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27661,34.57,0.47,81.9,7326,NULL,NULL,'H','ESO 416- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27662,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27662,34.58,0.35,82.4,7326,NULL,NULL,NULL,'ESO 416- G 041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27663,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27663,34.62,0.2,84,7326,74.4,NULL,NULL,'ESO 416- G 041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27664,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27664,34.65,0.46,85.3,7326,NULL,NULL,'J','ESO 416- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27665,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27665,34.66,0.4,85.5,7326,NULL,NULL,'mean','ESO 416- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27666,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27666,34.67,0.45,85.9,7326,NULL,NULL,'K','ESO 416- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27667,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27667,36.68,0.46,217,7327,70,NULL,NULL,'2MASX J02533217-0803598',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000074,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,43.384083,-8.06661,0.129,NULL,37909651543,592338305,9255286,16.8),(27668,'SBF','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27668,34,0.15,63.1,7328,NULL,NULL,'HST, Cantiello et al. 05','ESO 003- G 013',NULL,'2008ApJ...678..168B',2008,1,1.3,NULL,'G',0.00012,NULL,'13.72',1.1,'SA(r)0^0^:',NULL,NULL,NULL,NULL,1,43.3995417,-83.14222,0.437,NULL,35487653833,554494591,8663977,13.72),(27669,'SBF','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27669,34.1,0.25,66.1,7328,NULL,NULL,'HST, Jensen et al. 03','ESO 003- G 013',NULL,'2008ApJ...678..168B',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27670,'SBF','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27670,34.2,0.25,69.2,7328,NULL,NULL,'ACS','ESO 003- G 013',NULL,'2008ApJ...678..168B',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27671,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27671,34.21,0.4,69.5,7328,NULL,NULL,'mean','ESO 003- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27672,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27672,34.51,0.45,79.6,7328,NULL,NULL,'K','ESO 003- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27673,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27673,36.42,0.52,192,7329,70,NULL,NULL,'2MASX J02533585-5840400',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.000083,NULL,'17.36',0.21,NULL,NULL,NULL,NULL,NULL,1,43.399625,-58.67781,0,NULL,36244466057,566319782,8848746,17.36),(27674,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27674,36.16,0.54,171,7330,NULL,NULL,'Malmquist cor.','2MASX J02533701+1552381',NULL,'2009ApJS..182..474S',2009,1,0.46,NULL,'G',0.000027,NULL,'16.02',NULL,'Sc',NULL,NULL,NULL,NULL,1,43.40425,15.87733,0.277,NULL,68179667097,1065307298,16645426,16.02),(27675,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27675,36.44,0.48,194,7330,NULL,NULL,NULL,'2MASX J02533701+1552381',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27676,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27676,36.48,0.2,198,7330,74.4,NULL,NULL,'2MASX J02533701+1552381',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27677,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27677,36.17,0.46,172,7331,70,NULL,NULL,'2MASX J02533842+0112122',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000099,NULL,'16.2g',0.26,'S0/a',NULL,NULL,NULL,NULL,1,43.410125,1.20336,0.233,NULL,66844460332,1044444692,16319448,16.2),(27678,'IRAS','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27678,34.89,0.8,95.1,7332,75,NULL,'HMCL, I','UGC 02367',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000008,NULL,'14.80',0.5,'S0',NULL,NULL,NULL,NULL,1,43.4215,6.26528,0.285,NULL,67970505300,1062039145,16594361,14.8),(27679,'IRAS','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27679,34.89,0.8,95.2,7332,75,NULL,'W91CL, r','UGC 02367',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27680,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27680,34.79,0.4,90.6,7332,75,NULL,'HMCL, I, raw','UGC 02367',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27681,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27681,34.84,0.2,92.9,7332,74.4,NULL,NULL,'UGC 02367',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27682,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27682,35,0.38,100,7332,75,NULL,'W91CL, r, raw','UGC 02367',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27683,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27683,35.03,0.4,101,7332,75,NULL,'HMCL, I, cor','UGC 02367',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27684,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27684,35.07,0.4,103,7332,75,NULL,'HMCL, I, inv','UGC 02367',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27685,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27685,35.16,0.38,108,7332,75,NULL,'W91CL, r, cor','UGC 02367',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27686,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27686,35.23,0.11,111,7332,NULL,NULL,NULL,'UGC 02367',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27687,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27687,35.25,0.38,112,7332,75,NULL,'W91CL, r, inv','UGC 02367',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27688,'Sosies','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27688,32.97,0.08,39.3,7333,NULL,NULL,NULL,'NGC 1134',NULL,'2002A&A...393...57T',2002,1,2.5,NULL,'G',0.000003,NULL,'13.05',0.9,'S?             HII','Pair member, wide',NULL,NULL,NULL,1,43.42225,13.01414,0.381,NULL,68137133943,1064642717,16635042,13.05),(27689,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27689,32.67,0.47,34.2,7333,NULL,NULL,'H','NGC 1134',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27690,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27690,32.69,0.45,34.5,7333,NULL,NULL,'K','NGC 1134',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27691,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27691,32.72,0.46,35.1,7333,NULL,NULL,'J','NGC 1134',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27692,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27692,32.73,0.2,35.2,7333,74.4,NULL,NULL,'NGC 1134',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27693,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27693,33.33,0.4,46.3,7333,NULL,NULL,'mean','NGC 1134',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27694,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 03957',NULL,27694,38.69,0.42,547,7334,70,NULL,'SN photometric redshift distance, z photo =0.137 +/- 0.032','SDSS-II SN 03957',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,43.4272083,0.49786,0.213,NULL,66844091593,1044438931,16319358,NULL),(27695,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27695,34.76,0.2,89.5,7335,74.4,NULL,NULL,'2MASX J02534877+0640013',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000024,NULL,'16.08',0.2,NULL,NULL,NULL,NULL,NULL,1,43.4532083333,6.66708,0.273,NULL,67970456864,1062038388,16594349,16.08),(27696,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27696,35,0.11,100,7335,NULL,NULL,NULL,'2MASX J02534877+0640013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27697,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27697,32.72,0.9,35.1,7336,NULL,NULL,'Malmquist cor.','IC 0267',NULL,'2009ApJS..182..474S',2009,1,2,NULL,'G',0.000003,NULL,'13.87',1.6,'(R\')SB(s)b','Pair member, wide',NULL,NULL,NULL,1,43.459375,12.84922,0.381,NULL,68137162152,1064643158,16635049,13.87),(27698,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27698,32.85,0.85,37.2,7336,NULL,NULL,NULL,'IC 0267',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27699,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27699,33.21,0.2,43.9,7336,74.4,NULL,NULL,'IC 0267',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27700,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27700,33.25,0.49,44.6,7336,75,NULL,'IR','IC 0267',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27701,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27701,33.26,0.4,44.8,7336,NULL,NULL,'mean','IC 0267',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27702,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27702,33.48,0.45,49.6,7336,NULL,NULL,'K','IC 0267',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27703,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27703,33.48,0.47,49.8,7336,NULL,NULL,'H','IC 0267',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27704,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27704,33.52,0.46,50.6,7336,NULL,NULL,'J','IC 0267',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27705,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 01577','RN',27705,43.12,0.19,2710,7337,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01577',0.549966,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27706,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27706,34.53,0.2,80.5,7338,74.4,NULL,NULL,'UGC 02372',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000011,NULL,'15.08',0.8,'SAB(rs)cd:',NULL,NULL,NULL,NULL,1,43.494875,5.98772,0.285,NULL,67925070490,1061329226,16583269,15.08),(27707,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 15584','R',27707,40.73,0.21,1090,7339,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006nt','SDSS J025358.91+005913.1',0.28,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,43.4954583,0.98697,0.237,NULL,66844382564,1044443477,16319429,NULL),(27708,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 15584','R',27708,40.86,0.14,1160,7339,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006nt','SDSS J025358.91+005913.1',0.28,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27709,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2006nt',NULL,27709,40.6,0.11,1320,7339,70,NULL,'SALT 2','SDSS J025358.91+005913.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27710,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2006nt',NULL,27710,40.62,0.11,1330,7339,70,NULL,'SALT 2, Malmquist cor.','SDSS J025358.91+005913.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27711,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27711,35.32,0.47,116,7340,NULL,NULL,'H','UGC 02369 NED02',NULL,'2007A&A...465...71T',2007,1,0.7,'The UZC has V = 9218 +- 100 km/sec.','G',0.000067,NULL,'15.5',0.6,'Sb','Pair member (points to parent)',NULL,NULL,NULL,1,43.507375,14.97692,0.261,NULL,68168880588,1065138759,16642793,15.5),(27712,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27712,35.47,0.45,124,7340,NULL,NULL,'K','UGC 02369 NED02',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27713,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27713,35.58,0.46,131,7340,NULL,NULL,'J','UGC 02369 NED02',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27714,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27714,35.73,0.4,140,7340,NULL,NULL,'mean','UGC 02369 NED02',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27715,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27715,32.15,0.69,26.9,7341,100,NULL,'mid-IR','NGC 1137',NULL,'2013ApJ...771...88L',2013,1,2.1,NULL,'G',0.000017,NULL,'13.21',1.3,'(R\')SA(rs)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,43.511375,2.96208,0.265,NULL,67916422153,1061194096,16581157,13.21),(27716,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27716,32.98,0.47,39.5,7341,NULL,NULL,'H','NGC 1137',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27717,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27717,33.03,0.45,40.4,7341,NULL,NULL,'K','NGC 1137',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27718,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27718,33.04,0.46,40.6,7341,NULL,NULL,'J','NGC 1137',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27719,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27719,33.04,0.4,40.6,7341,NULL,NULL,'mean','NGC 1137',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27720,'IRAS','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27720,34.97,0.8,98.4,7342,75,NULL,'HMCL, I','UGC 02375',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.00001,NULL,'15.6',0.3,'Sab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,43.514625,6.25767,0.285,NULL,67970379701,1062037182,16594330,15.6),(27721,'IRAS','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27721,34.97,0.8,98.5,7342,75,NULL,'W91CL, r','UGC 02375',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27722,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27722,34.67,0.4,85.9,7342,75,NULL,'HMCL, I, raw','UGC 02375',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27723,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27723,34.87,0.4,94.3,7342,75,NULL,'HMCL, I, inv','UGC 02375',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27724,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27724,34.94,0.49,97.5,7342,75,NULL,'IR','UGC 02375',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27725,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27725,34.95,0.4,97.8,7342,75,NULL,'HMCL, I, cor','UGC 02375',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27726,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27726,35,0.2,100,7342,74.4,NULL,NULL,'UGC 02375',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27727,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27727,35.1,0.38,104,7342,75,NULL,'W91CL, r, raw','UGC 02375',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27728,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27728,35.12,0.43,106,7342,75,NULL,'3.6 micron, color corrected','UGC 02375',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27729,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27729,35.13,0.11,106,7342,NULL,NULL,NULL,'UGC 02375',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27730,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27730,35.13,0.4,106,7342,NULL,NULL,'mean','UGC 02375',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27731,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27731,35.23,0.47,111,7342,NULL,NULL,'H','UGC 02375',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27732,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27732,35.23,0.38,111,7342,75,NULL,'W91CL, r, cor','UGC 02375',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27733,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27733,35.26,0.38,113,7342,75,NULL,'W91CL, r, inv','UGC 02375',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27734,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27734,35.3,0.43,115,7342,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02375',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27735,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27735,35.42,0.45,122,7342,NULL,NULL,'K','UGC 02375',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27736,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 14361',NULL,27736,40.63,0.94,1330,7343,70,NULL,'SN photometric redshift distance, z photo =0.380 +/- 0.305','SDSS-II SN 14361',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,43.515417,-0.10533,0.193,NULL,34898191583,545284243,8520066,NULL),(27737,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27737,35.71,0.46,139,7344,70,NULL,NULL,'2MASX J02540528-0720423',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000102,NULL,'15.2g',0.49,'E0',NULL,NULL,NULL,NULL,1,43.5219583,-7.34506,0.121,NULL,37911509550,592367336,9255739,15.2),(27738,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27738,35.88,0.62,150,7344,70,NULL,NULL,'2MASX J02540528-0720423',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27739,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 21892','RN',27739,40.66,0.29,1020,7345,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 21892',0.324273,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27740,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 21892','RN',27740,40.94,0.37,1170,7345,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 21892',0.324273,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27741,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27741,35.39,0.48,120,7346,70,NULL,NULL,'FAIRALL 1247',NULL,'2014MNRAS.445.2677S',2014,1,1.17,NULL,'G',0.000077,NULL,'15.1B',0.83,NULL,NULL,NULL,NULL,NULL,1,43.556,-73.13667,0.105,NULL,36440258758,569379043,8896547,15.1),(27742,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27742,34.16,0.6,67.8,7347,70,NULL,NULL,'MRK 1062',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'14.70',0.3,'E','Field galaxy',NULL,NULL,NULL,1,43.5625833333,-8.48,0.149,NULL,37914226421,592409787,9256402,14.7),(27743,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2005ls',NULL,27743,33.87,0.18,58.2,7348,74.2,NULL,'SALT 2','CGCG 539-121',0.021118,'2010ApJ...716..712A',2010,1,0.7,NULL,'G',0.000117,NULL,'14.7',0.3,'Spiral',NULL,NULL,NULL,NULL,1,43.5689583,42.72592,0.381,NULL,68571093728,1071423339,16740989,14.7),(27744,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2005ls',NULL,27744,34.41,0.21,74.7,7348,65,NULL,'MLCS31','CGCG 539-121',0.021118,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27745,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2005ls',NULL,27745,34.43,0.18,75.2,7348,70,NULL,'SALT 2','CGCG 539-121',0.021118,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27746,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2005ls',NULL,27746,34.43,0.04,75.3,7348,72,NULL,'MLCS31','CGCG 539-121',0.021118,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27747,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2005ls',NULL,27747,34.43,0.09,76.9,7348,74.4,NULL,NULL,'CGCG 539-121',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27748,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2005ls',NULL,27748,34.69,0.19,85.1,7348,65,NULL,'MLCS17','CGCG 539-121',0.021118,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27749,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2005ls',NULL,27749,34.73,0.21,86.6,7348,65,NULL,'SALT2','CGCG 539-121',0.021118,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27750,'SNIa','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SN 2005ls',NULL,27750,34.85,0.2,91.2,7348,65,NULL,'SALT','CGCG 539-121',0.021118,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27751,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:18:59','1','SDSS-II SN 10159','RN',27751,38.87,0.45,557,7349,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10159',0.067877,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27752,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27752,35.53,0.5,128,7350,70,NULL,NULL,'2MASX J02542150-1356456',NULL,'2014MNRAS.445.2677S',2014,1,0.71,NULL,'G',0.00015,NULL,'15.89',0.63,NULL,NULL,NULL,NULL,NULL,1,43.589583,-13.94617,0.069,NULL,38096113916,595251779,9300809,15.89),(27753,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,'R',27753,34.49,0.49,79,7351,75,NULL,'IR','UGC 02378',NULL,'2011yCatp016004901K',2011,1,1.68,NULL,'G',0.00002,NULL,'16.0',0.19,'Scd',NULL,NULL,NULL,NULL,1,43.598667,11.74739,0.457,NULL,67956955218,1061827425,16591053,16),(27754,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27754,34.87,NULL,94.1,7351,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02378',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27755,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27755,34.88,NULL,94.6,7351,NULL,NULL,'Dipole + Quadrupole','UGC 02378',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27756,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27756,34.88,NULL,94.6,7351,NULL,NULL,'Dipole','UGC 02378',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27757,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27757,34.93,NULL,96.7,7351,NULL,NULL,NULL,'UGC 02378',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27758,'FP','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27758,36.27,0.64,179,7352,70,NULL,NULL,'ESO 480- G 011',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.96',0.2,'Sb:',NULL,NULL,NULL,NULL,1,43.607833,-22.5035,0.025,NULL,38053808079,594590751,9290480,15.96),(27759,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27759,32.46,NULL,31.1,7353,NULL,NULL,NULL,'UGC 02370',NULL,'2000BSAO...50....5K',2000,1,2.43,NULL,'G',0.000037,NULL,'15.4',0.15,'Sd',NULL,NULL,NULL,NULL,1,43.6092917,42.65003,0.405,NULL,68571081559,1071423149,16740986,15.4),(27760,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27760,32.47,NULL,31.2,7353,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02370',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27761,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:18:59','1',NULL,NULL,27761,32.48,NULL,31.3,7353,NULL,NULL,'Dipole + Quadrupole','UGC 02370',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27762,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27762,32.48,NULL,31.4,7353,NULL,NULL,'Dipole','UGC 02370',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27763,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27763,32.81,0.2,36.5,7353,74.4,NULL,NULL,'UGC 02370',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27764,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27764,32.83,0.64,36.8,7353,NULL,NULL,NULL,'UGC 02370',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27765,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27765,32.92,0.61,38.4,7353,NULL,NULL,'Malmquist cor.','UGC 02370',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27766,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,'R',27766,33.12,0.4,42.1,7353,75,NULL,NULL,'UGC 02370',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27767,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 20757',NULL,27767,40.12,0.35,1060,7354,70,NULL,NULL,'SDSS-II SN 20757',NULL,'2013MNRAS.434.1443X',2013,1,0.03,NULL,'G',NULL,'PHOT','22.4g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,43.621583,0.22164,0.205,NULL,66843861866,1044435341,16319302,22.4),(27768,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 20757','R',27768,40.82,0.25,1070,7354,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20757',0.365467,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27769,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 20757',NULL,27769,40.37,0.24,1180,7354,70,NULL,'SN photometric redshift distance, z photo =0.328 +/- 0.048','SDSS-II SN 20757',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27770,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 20757','R',27770,41.11,0.36,1220,7354,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20757',0.365467,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27771,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 20757',NULL,27771,41,0.22,1580,7354,70,NULL,'SALT 2','SDSS-II SN 20757',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27772,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 20757',NULL,27772,41.05,0.22,1620,7354,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20757',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27773,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27773,36.32,0.55,184,7355,70,NULL,NULL,'2MASX J02543198-0131068',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.0001,NULL,'16.73',0.41,NULL,NULL,NULL,NULL,NULL,1,43.6332916667,-1.51861,0.157,NULL,34900051940,545313311,8520520,16.73),(27774,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27774,34.38,0.58,75.1,7356,NULL,NULL,NULL,'CGCG 415-023',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.00005,NULL,'15.5',0.3,NULL,NULL,NULL,NULL,NULL,1,43.6353333333,9.45131,0.425,NULL,67965644907,1061963201,16593175,15.5),(27775,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27775,34.42,0.2,76.6,7356,74.4,NULL,NULL,'CGCG 415-023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27776,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27776,34.79,0.48,90.8,7356,NULL,NULL,'Malmquist cor.','CGCG 415-023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27777,'IRAS','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27777,32.19,0.8,27.4,7357,75,NULL,'MAT, I','NGC 1145',NULL,'1997ApJS..109..333W',1997,1,3.7,NULL,'G',0.000017,NULL,'13.81',0.45,'Sc: sp',NULL,NULL,NULL,NULL,1,43.639625,-18.63508,0.069,NULL,38106951398,595421115,9303454,13.81),(27778,'Tully est','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27778,31.87,0.8,23.6,7357,75,NULL,NULL,'NGC 1145',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27779,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27779,29.16,NULL,6.8,7357,NULL,NULL,NULL,'NGC 1145',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27780,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27780,31.97,0.4,24.8,7357,73,NULL,'IR','NGC 1145',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27781,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,'R',27781,31.97,0.4,24.8,7357,75,NULL,NULL,'NGC 1145',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27782,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27782,32,0.39,25.1,7357,73,NULL,'opt','NGC 1145',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27783,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27783,32.03,0.4,25.5,7357,NULL,NULL,NULL,'NGC 1145',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27784,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27784,32.16,0.43,27,7357,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1145',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27785,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27785,32.16,0.15,27.1,7357,NULL,NULL,NULL,'NGC 1145',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27786,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27786,32.18,0.43,27.3,7357,75,NULL,'3.6 micron, color corrected','NGC 1145',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27787,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,'R',27787,32.22,0.49,27.8,7357,75,NULL,'IR','NGC 1145',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27788,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27788,32.22,0.43,27.8,7357,75,NULL,'MAT, I, raw','NGC 1145',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27789,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27789,32.24,0.32,28.1,7357,85,NULL,'I, raw','NGC 1145',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27790,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27790,32.25,0.2,28.2,7357,74.4,NULL,NULL,'NGC 1145',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27791,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27791,32.28,0.32,28.6,7357,85,NULL,'I, inv','NGC 1145',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27792,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27792,32.32,0.43,29.2,7357,75,NULL,'MAT, I, cor','NGC 1145',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27793,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27793,32.4,0.43,30.1,7357,75,NULL,'MAT, I, inv','NGC 1145',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27794,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27794,32.84,NULL,37,7357,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 1145',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27795,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27795,32.84,NULL,37,7357,NULL,NULL,'Dipole','NGC 1145',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27796,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27796,32.85,NULL,37.1,7357,NULL,NULL,'Dipole + Quadrupole','NGC 1145',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27797,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27797,31.09,0.43,16.5,7358,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1140',NULL,'2014MNRAS.444..527S',2014,1,1.7,NULL,'G',0.000004,NULL,'13.62',0.9,'IBm pec:;HII   Sy2','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,43.639917,-10.02775,0.105,NULL,37902258281,592222785,9253481,13.62),(27798,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27798,31.2,0.43,17.3,7358,75,NULL,'3.6 micron, color corrected','NGC 1140',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27799,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27799,31.27,0.2,18,7358,74.4,NULL,NULL,'NGC 1140',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27800,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27800,31.31,0.4,18.2,7358,75,NULL,'B','NGC 1140',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27801,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27801,31.47,0.4,19.7,7358,NULL,NULL,NULL,'NGC 1140',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27802,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27802,31.47,0.39,19.7,7358,73,NULL,'opt','NGC 1140',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27803,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27803,35.71,0.06,139,7359,NULL,NULL,NULL,'CGCG 463-030',NULL,'2009ApJS..182..474S',2009,1,0.55,NULL,'G',0.000023,NULL,'15.7',0.4,'Scd',NULL,NULL,NULL,NULL,1,43.644667,15.84425,0.277,NULL,68179551666,1065305494,16645398,15.7),(27804,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,'R',27804,34.83,0.49,92.4,7360,75,NULL,'IR','UGC 02381',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',NULL,NULL,'16.0',0.4,'S?',NULL,NULL,NULL,NULL,1,43.6504583,12.02175,0.405,NULL,67956541108,1061820954,16590952,16),(27805,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27805,36.53,0.47,202,7361,NULL,NULL,'Malmquist cor.','2MASX J02543715+1604514',NULL,'2009ApJS..182..474S',2009,1,0.46,NULL,'G',0.000023,NULL,'14.53',0.3,'Sc',NULL,NULL,NULL,NULL,1,43.654917,16.08086,0.277,NULL,68180329477,1065317648,16645588,14.53),(27806,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27806,36.79,0.42,228,7361,NULL,NULL,NULL,'2MASX J02543715+1604514',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27807,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27807,36.83,0.2,232,7361,74.4,NULL,NULL,'2MASX J02543715+1604514',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27808,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 06046','RN',27808,37.63,0.41,314,7362,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06046',0.066785,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27809,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,'R',27809,37,0.33,252,7363,70,NULL,NULL,'2MASX J02543798+0056218',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000129,NULL,'16.0g',0.4,'AGN',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,43.6582917,0.93942,0.241,NULL,66844238522,1044441226,16319394,16),(27810,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27810,37.15,0.6,269,7364,70,NULL,NULL,'2MASX J02543910-1011255',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.63',0.36,NULL,NULL,NULL,NULL,NULL,1,43.663,-10.19061,0.101,NULL,37902273520,592223023,9253484,16.63),(27811,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,'R',27811,34.53,0.49,80.4,7365,75,NULL,'IR','UGC 02382',NULL,'2011yCatp016004901K',2011,1,1.15,NULL,'G',0.000029,NULL,'17.',0.11,'Sd',NULL,NULL,NULL,NULL,1,43.665917,9.35692,0.465,NULL,67965678553,1061963727,16593183,17),(27812,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27812,34.92,0.2,96.4,7365,74.4,NULL,NULL,'UGC 02382',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27813,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27813,35.12,0.17,106,7365,NULL,NULL,NULL,'UGC 02382',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27814,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27814,35.37,NULL,119,7365,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02382',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27815,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27815,35.38,NULL,119,7365,NULL,NULL,'Dipole + Quadrupole','UGC 02382',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27816,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27816,35.4,NULL,120,7365,NULL,NULL,'Dipole','UGC 02382',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27817,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27817,35.42,NULL,121,7365,NULL,NULL,NULL,'UGC 02382',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27818,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27818,36.03,0.51,160,7366,70,NULL,NULL,'ESO 417- G 001',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.000053,NULL,'15.59',1,'SA0^0^ pec',NULL,NULL,NULL,NULL,1,43.67275,-30.42717,NULL,NULL,38619360742,603427511,9428554,15.59),(27819,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,'R',27819,37.04,0.46,256,7367,70,NULL,NULL,'2MASX J02544152+0044108',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000078,NULL,'16.8g',0.33,NULL,NULL,NULL,NULL,NULL,1,43.672917,0.73639,0.213,NULL,66843917252,1044436207,16319315,16.8),(27820,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27820,35.13,0.2,106,7368,74.4,NULL,NULL,'AGC 121143',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000052,NULL,'17.05',0.2,'Sc',NULL,NULL,NULL,NULL,1,43.674167,16.08972,0.277,NULL,68180452392,1065319568,16645618,17.05),(27821,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27821,35.44,0.1,123,7368,NULL,NULL,NULL,'AGC 121143',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27822,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27822,35.62,0.51,133,7369,70,NULL,NULL,'2MASX J02544530-5130190',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.00015,NULL,'15.95',0.32,'S',NULL,NULL,NULL,NULL,1,43.688625,-51.50525,0,NULL,38456085652,600876338,9388692,15.95),(27823,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27823,35.06,0.52,103,7370,70,NULL,NULL,'MCG -02-08-020',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000103,NULL,'15.2b',0.35,NULL,NULL,NULL,NULL,NULL,1,43.6934583,-13.45675,0.053,NULL,38093419540,595209680,9300151,15.2),(27824,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,'R',27824,37,0.33,252,7371,70,NULL,NULL,'2MASX J02544672+0057421',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000069,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,43.694667,0.96164,0.241,NULL,66844284123,1044441939,16319405,17.6),(27825,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 13563','RN',27825,39.77,0.27,845,7372,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 13563',0.065732,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27826,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 13563','RN',27826,41.06,0.33,1530,7372,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 13563',0.065732,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27827,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27827,35.31,0.48,116,7373,70,NULL,NULL,'ESO 417- G 002',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00012,NULL,'15.41',0.4,'S0?',NULL,NULL,NULL,NULL,1,43.7075,-30.67864,NULL,NULL,38619332241,603427066,9428547,15.41),(27828,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 14772','RN',27828,39.05,0.21,614,7374,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 14772',0.05132,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27829,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 14772','RN',27829,40.64,0.38,1280,7374,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 14772',0.05132,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27830,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27830,34.94,0.51,97.5,7375,70,NULL,NULL,'IC 1866',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.22',0.3,NULL,NULL,NULL,NULL,NULL,1,43.7207917,-15.65256,0.057,NULL,38115884674,595560698,9305635,15.22),(27831,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27831,34.43,0.4,76.8,7376,NULL,NULL,'mean','MCG -01-08-015',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.00007,NULL,'14.40',1.2,'(R\')SB(r)a',NULL,NULL,NULL,NULL,1,43.725417,-6.37322,0.165,NULL,37910650335,592353911,9255529,14.4),(27832,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27832,35.16,0.47,108,7376,NULL,NULL,'H','MCG -01-08-015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27833,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27833,35.19,0.45,109,7376,NULL,NULL,'K','MCG -01-08-015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27834,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27834,35.25,0.46,112,7376,NULL,NULL,'J','MCG -01-08-015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27835,'IRAS','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27835,35.24,0.8,111,7377,75,NULL,'MAT, I','ESO 546- G 031',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'15.19',0.6,'SB(s)cd:',NULL,NULL,NULL,NULL,1,43.7336666667,-21.89817,0.053,NULL,38064429469,594756710,9293073,15.19),(27836,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27836,35.05,0.43,102,7377,75,NULL,'MAT, I, raw','ESO 546- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27837,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27837,35.08,0.32,104,7377,85,NULL,'I, raw','ESO 546- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27838,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27838,35.14,0.32,107,7377,85,NULL,'I, inv','ESO 546- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27839,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27839,35.31,0.43,115,7377,75,NULL,'MAT, I, inv','ESO 546- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27840,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27840,35.36,0.43,118,7377,75,NULL,'MAT, I, cor','ESO 546- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27841,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27841,35.47,0.41,124,7377,NULL,NULL,'Malmquist cor.','ESO 546- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27842,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27842,35.46,0.41,124,7377,NULL,NULL,NULL,'ESO 546- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27843,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27843,35.5,0.2,126,7377,74.4,NULL,NULL,'ESO 546- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27844,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SN 2006os',NULL,27844,34.9,0.17,92.5,7378,74.2,NULL,'SALT 2','UGC 02384',0.032809,'2010ApJ...716..712A',2010,1,1,'Misidentified in MCG as \'NGC 1145\'; corrected in MCG errata.','G',0.000127,NULL,'15.1',0.4,'S',NULL,NULL,NULL,NULL,1,43.752375,16.01242,0.277,NULL,68180457863,1065319654,16645619,15.1),(27845,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SN 2006os',NULL,27845,35.3,0.11,108,7378,72,NULL,NULL,'UGC 02384',0.0321,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27846,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SN 2006os',NULL,27846,35.32,0.21,112,7378,65,NULL,'MLCS31','UGC 02384',0.032809,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27847,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SN 2006os',NULL,27847,35.47,0.09,124,7378,74.4,NULL,NULL,'UGC 02384',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27848,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SN 2006os',NULL,27848,35.67,0.05,132,7378,72,NULL,'MLCS31','UGC 02384',0.032809,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27849,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SN 2006os',NULL,27849,35.64,0.05,134,7378,72,NULL,'M(H) = -18.317 mag','UGC 02384',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27850,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SN 2006os',NULL,27850,35.77,0.18,138,7378,65,NULL,'MLCS17','UGC 02384',0.032809,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27851,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SN 2006os',NULL,27851,35.77,0.19,138,7378,65,NULL,'SALT2','UGC 02384',0.032809,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27852,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SN 2006os',NULL,27852,35.84,0.17,143,7378,65,NULL,'SALT','UGC 02384',0.032809,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27853,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,'R',27853,35.23,0.33,111,7379,70,NULL,NULL,'2MASX J02550068-0009498',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000091,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,43.7529583333,-0.16386,0.189,NULL,34896923305,545264426,8519756,16.9),(27854,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,'R',27854,35.03,0.49,101,7380,75,NULL,'IR','2MFGC 02352',NULL,'2011yCatp016004901K',2011,1,0.5,NULL,'G',0.000018,NULL,'13.1K',0.1,NULL,NULL,NULL,NULL,NULL,1,43.7557916667,17.2655,0.381,NULL,68177378012,1065271531,16644867,13.1),(27855,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27855,36.16,0.6,170,7381,70,NULL,NULL,'2MASX J02550349-1424314',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.00015,NULL,'16.30',0.24,NULL,NULL,NULL,NULL,NULL,1,43.764583,-14.40869,0.053,NULL,38102873644,595357400,9302459,16.3),(27856,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SN 2007jk',NULL,27856,39.1,0.09,659,7382,70,NULL,'Hubble residual -0.17 for z0.18284','SDSS-II SN 17332 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.00015,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,43.7725,-0.14769,0.177,NULL,34896923829,545264434,8519756,NULL),(27857,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 17332','R',27857,39.63,0.19,714,7382,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007jk','SDSS-II SN 17332 HOST',0.182841,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27858,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 17332','R',27858,39.67,0.13,726,7382,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007jk','SDSS-II SN 17332 HOST',0.182841,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27859,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SN 2007jk',NULL,27859,39.46,0.08,780,7382,70,NULL,'SALT 2','SDSS-II SN 17332 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27860,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SN 2007jk',NULL,27860,39.47,0.08,783,7382,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 17332 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27861,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27861,33.01,0.2,40,7383,74.4,NULL,NULL,'MCG +11-04-003',NULL,'2013AJ....146...86T',2013,1,0.2,NULL,'G',0.000113,NULL,'18',0.05,'E/S0',NULL,NULL,NULL,NULL,1,43.7742083333,66.40183,NULL,NULL,66558070116,1039969845,16249528,18),(27862,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27862,33.06,0.4,40.9,7383,NULL,NULL,'mean','MCG +11-04-003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27863,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27863,33.07,0.46,41.2,7383,NULL,NULL,'J','MCG +11-04-003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27864,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27864,33.08,0.47,41.3,7383,NULL,NULL,'H','MCG +11-04-003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27865,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27865,33.13,0.45,42.3,7383,NULL,NULL,'K','MCG +11-04-003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27866,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27866,33.24,0.43,44.5,7383,75,NULL,'3.6 micron, color + selection bias corrected','MCG +11-04-003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27867,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27867,33.3,0.43,45.8,7383,75,NULL,'3.6 micron, color corrected','MCG +11-04-003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27868,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27868,35.98,0.58,157,7384,70,NULL,NULL,'2MASX J02550661-0009448',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000067,NULL,'16.2g',0.21,'S0/a',NULL,NULL,NULL,NULL,1,43.7774583,-0.1625,0.177,NULL,34896924467,545264444,8519756,16.2),(27869,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27869,35.6,0.58,132,7385,70,NULL,NULL,'2MASX J02550670-1033397',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'17.13',0.24,NULL,NULL,NULL,NULL,NULL,1,43.7779583,-10.56108,0.109,NULL,37902127536,592220742,9253449,17.13),(27870,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27870,35.31,0.64,116,7386,70,NULL,NULL,'MCG -02-08-021',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000043,NULL,'15.25',0.25,'S-','Field galaxy',NULL,NULL,NULL,1,43.7785,-10.75361,0.109,NULL,37871957424,591749334,9246083,15.25),(27871,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 16789','R',27871,41.07,0.34,1240,7387,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006pz','SN 2006pz',0.324952,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,43.7843333333,0.23478,0.205,NULL,66841170481,1044393288,16318645,NULL),(27872,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 16789','R',27872,41.14,0.3,1280,7387,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006pz','SN 2006pz',0.324952,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27873,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27873,33.72,0.46,55.6,7388,NULL,NULL,'J','UGC 02380',NULL,'2007A&A...465...71T',2007,1,1.4,'abs(b) < 10 degrees.','G',0.000037,NULL,'16.0',0.7,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,43.796167,51.90717,NULL,NULL,68520039563,1070625618,16728525,16),(27874,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27874,33.75,0.47,56.1,7388,NULL,NULL,'H','UGC 02380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27875,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27875,33.82,0.45,58.1,7388,NULL,NULL,'K','UGC 02380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27876,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27876,34.02,0.4,63.6,7388,NULL,NULL,'mean','UGC 02380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27877,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27877,36.14,0.15,169,7389,NULL,NULL,NULL,'AGC 121145',NULL,'2009ApJS..182..474S',2009,1,0.26,NULL,'G',0.000023,NULL,'16.74',NULL,'Sc',NULL,NULL,NULL,NULL,1,43.7964583,16.01294,0.273,NULL,68180451251,1065319550,16645617,16.74),(27878,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 17333','RN',27878,38.46,0.1,478,7390,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 17333',0.028872,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27879,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 17333','RN',27879,39.7,0.25,845,7390,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 17333',0.028872,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27880,'IRAS','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27880,31.47,0.8,19.7,7391,75,NULL,'MAT, I','ESO 356- G 018',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'15.49',0.5,'S...',NULL,NULL,NULL,NULL,1,43.802,-36.30017,NULL,NULL,38653009939,603953280,9436770,15.49),(27881,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27881,31.02,0.32,16,7391,85,NULL,'I, inv','ESO 356- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27882,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27882,31.09,0.32,16.5,7391,85,NULL,'I, raw','ESO 356- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27883,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27883,31.13,0.43,16.9,7391,75,NULL,'3.6 micron, color + selection bias corrected','ESO 356- G 018',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27884,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27884,31.24,0.43,17.7,7391,75,NULL,'3.6 micron, color corrected','ESO 356- G 018',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27885,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27885,31.24,0.2,17.7,7391,74.4,NULL,NULL,'ESO 356- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27886,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27886,31.5,0.43,20,7391,75,NULL,'MAT, I, inv','ESO 356- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27887,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27887,31.64,0.43,21.3,7391,75,NULL,'MAT, I, raw','ESO 356- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27888,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27888,31.76,0.43,22.4,7391,75,NULL,'MAT, I, cor','ESO 356- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27889,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27889,34.85,0.23,93.3,7392,74.4,NULL,NULL,'GIN 162',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000028,NULL,'14.17',0.6,'E/S0','Group member',NULL,NULL,NULL,1,43.8119166667,6.17758,0.285,NULL,67970337292,1062036520,16594320,14.17),(27890,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27890,35.37,0.17,119,7392,70,NULL,NULL,'GIN 162',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27891,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27891,34.62,0.59,83.9,7393,70,NULL,NULL,'MCG -05-08-003',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000103,NULL,'15.28',0.3,'E',NULL,NULL,NULL,NULL,1,43.817125,-29.83347,NULL,NULL,38619876298,603435567,9428680,15.28),(27892,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27892,34.77,0.2,90,7394,74.4,NULL,NULL,'UGC 02387',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000167,NULL,'15.22',0.5,'Scd:',NULL,NULL,NULL,NULL,1,43.8210417,12.22467,0.405,NULL,67957037159,1061828705,16591073,15.22),(27893,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27893,35.19,0.11,109,7394,NULL,NULL,NULL,'UGC 02387',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27894,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 13922','RN',27894,43.05,0.28,2690,7395,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13922',0.509118,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27895,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27895,35.15,0.25,107,7396,74.4,NULL,NULL,'CGCG 415-025',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000017,NULL,'14.49',0.5,'Sa? pec','Group member',NULL,NULL,NULL,1,43.833083,6.12472,0.273,NULL,67925051102,1061328923,16583264,14.49),(27896,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27896,35.37,0.17,119,7396,70,NULL,NULL,'CGCG 415-025',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27897,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27897,34.45,0.69,77.7,7397,100,NULL,'mid-IR','IC 1865',NULL,'2013ApJ...771...88L',2013,1,1.1,NULL,'G',0.000017,NULL,'14.73',0.6,'Sbc','Group member, peripheral',NULL,NULL,NULL,1,43.834083,8.82817,0.501,NULL,67980176979,1062190265,16596722,14.73),(27898,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27898,34.94,0.2,97.3,7397,74.4,NULL,NULL,'IC 1865',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27899,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27899,35.07,0.47,103,7397,NULL,NULL,'H','IC 1865',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27900,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27900,35.12,0.45,106,7397,NULL,NULL,'K','IC 1865',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27901,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27901,35.2,0.46,109,7397,NULL,NULL,'J','IC 1865',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27902,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27902,35.23,0.4,111,7397,NULL,NULL,'mean','IC 1865',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27903,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27903,35.26,0.11,113,7397,NULL,NULL,NULL,'IC 1865',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27904,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,'R',27904,37.14,0.46,267,7398,70,NULL,NULL,'2MASX J02552145-0826369',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00007,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,43.839333,-8.44364,0.197,NULL,37913972169,592405815,9256340,17.5),(27905,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27905,36.49,0.63,199,7399,70,NULL,NULL,'ESO 480- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'15.4b',0.8,'Sa:',NULL,NULL,NULL,NULL,1,43.857,-23.04722,0.021,NULL,38053337033,594583391,9290365,15.4),(27906,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27906,34.72,0.49,87.7,7400,70,NULL,NULL,'IC 0269',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.2b',0.2,NULL,NULL,NULL,NULL,NULL,1,43.860375,-14.06681,0.069,NULL,38102645449,595353835,9302403,15.2),(27907,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27907,34.33,0.25,73.4,7401,NULL,NULL,NULL,'ESO 247- G 012',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.98',0.2,'Sb',NULL,NULL,NULL,NULL,1,43.8617083,-42.36922,0,NULL,38507407497,601678242,9401222,15.98),(27908,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27908,34.36,0.24,74.5,7401,NULL,NULL,'Malmquist cor.','ESO 247- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27909,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27909,34.37,0.2,74.8,7401,74.4,NULL,NULL,'ESO 247- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27910,'CMD','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,'N',27910,19.5,NULL,0.079,7402,NULL,NULL,NULL,'Horologium I',NULL,'2015ApJ...805..130K',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27911,'CMD','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,'N',27911,19.7,NULL,0.087,7402,NULL,NULL,'DES J0255.4_5406','Horologium I',NULL,'2015ApJ...807...50B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27912,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27912,36.73,0.55,222,7403,NULL,NULL,'Malmquist cor.','2MASX J02552895+1613347',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000023,NULL,'16.23',0.1,'Sbc',NULL,NULL,NULL,NULL,1,43.8706666667,16.22622,0.349,NULL,68180489010,1065320140,16645627,16.23),(27913,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27913,37.05,0.47,257,7403,NULL,NULL,NULL,'2MASX J02552895+1613347',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27914,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27914,37.09,0.2,262,7403,74.4,NULL,NULL,'2MASX J02552895+1613347',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27915,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 04062','RN',27915,41.18,0.16,1490,7404,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 04062',0.152414,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27916,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 04062','RN',27916,41.37,0.22,1630,7404,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 04062',0.152414,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27917,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 14578','RN',27917,41.78,0.21,1880,7405,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14578',0.204216,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27918,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 14578','RN',27918,42.38,0.46,2490,7405,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 14578',0.204216,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27919,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27919,36.92,0.59,242,7406,NULL,NULL,'Malmquist cor.','2MASX J02553157+1605277',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000023,NULL,'14.95',0.3,'Sc',NULL,NULL,NULL,NULL,1,43.881583,16.09106,0.273,NULL,68180506156,1065320408,16645631,14.95),(27920,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27920,37.32,0.49,292,7406,NULL,NULL,NULL,'2MASX J02553157+1605277',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27921,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27921,37.36,0.2,296,7406,74.4,NULL,NULL,'2MASX J02553157+1605277',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27922,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27922,35.37,0.5,119,7407,70,NULL,NULL,'MCG -02-08-026',NULL,'2014MNRAS.445.2677S',2014,1,0.4,'da Costa et al. (1998AJ....116....1D) give v = 9,734 +/- 125 km/sec.','G',0.00015,NULL,'15.15',0.2,'EL','Field galaxy',NULL,NULL,NULL,1,43.9012083,-10.14011,0.097,NULL,37902303181,592223487,9253491,15.15),(27923,'Ring Diameter','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27923,33.3,0.84,46,7408,NULL,NULL,'Published at H = 100 km/s/Mpc','ESO 417- G 003',NULL,'1981ApJS...45..541P',1981,1,1.7,NULL,'G',0.000057,NULL,'13.75',1.5,'SAB(rs)c:',NULL,NULL,NULL,NULL,1,43.9184583,-27.42314,0,NULL,38605987789,603218559,9425289,13.75),(27924,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27924,34.41,0.47,76.3,7408,70,NULL,NULL,'ESO 417- G 003',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27925,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27925,34.28,0.4,71.7,7408,NULL,NULL,'mean','ESO 417- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27926,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27926,34.29,0.47,72.2,7408,NULL,NULL,'H','ESO 417- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27927,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27927,34.3,0.45,72.6,7408,NULL,NULL,'K','ESO 417- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27928,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27928,34.31,0.46,72.8,7408,NULL,NULL,'J','ESO 417- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27929,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27929,35.4,0.52,120,7409,70,NULL,NULL,'MCG -02-08-027',NULL,'2014MNRAS.445.2677S',2014,1,0.4,'da Costa et al. (1998AJ....116....1D) give v = 9,888 +/- 125 km/sec.','G',0.00015,NULL,'15.5',0.4,'E','Field galaxy',NULL,NULL,NULL,1,43.9211666667,-10.48972,0.101,NULL,37902142159,592220971,9253452,15.5),(27930,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27930,33.11,0.69,42,7410,100,NULL,'mid-IR','UGC 02358',NULL,'2013ApJ...771...88L',2013,1,1.7,NULL,'G',0.000037,NULL,'15.0',1,'SB(r)b','Pair member (points to parent)',NULL,NULL,NULL,1,43.927583,75.15442,1.441,NULL,65703703160,1026620361,16040943,15),(27931,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27931,34,0.4,63,7410,NULL,NULL,'mean','UGC 02358',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27932,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27932,34.13,0.46,67.1,7410,NULL,NULL,'J','UGC 02358',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27933,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27933,34.15,0.47,67.7,7410,NULL,NULL,'H','UGC 02358',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27934,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27934,34.17,0.45,68.1,7410,NULL,NULL,'K','UGC 02358',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27935,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 15746','RN',27935,42.44,0.28,2410,7411,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 15746',0.275942,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27936,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 15746','RN',27936,43.02,0.25,3150,7411,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 15746',0.275942,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27937,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 06874','RN',27937,37.4,0.31,282,7412,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06874',0.072236,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27938,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27938,34.34,0.25,73.8,7413,74.4,NULL,NULL,'IC 0270',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.00008,NULL,'13.76',1.2,'cD;SA0-:',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,43.934125,-14.20789,0.061,NULL,38102686946,595354483,9302413,13.76),(27939,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27939,34.51,0.4,79.8,7413,70,NULL,NULL,'IC 0270',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27940,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27940,35.07,0.45,103,7413,NULL,NULL,'K','IC 0270',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27941,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27941,35.34,0.4,117,7413,NULL,NULL,'mean','IC 0270',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27942,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 21024','R',27942,40.99,0.22,1250,7414,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 21024',0.262555,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,43.9414166667,-0.05122,0.177,NULL,34897087849,545266997,8519796,NULL),(27943,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 21024','R',27943,41.03,0.18,1270,7414,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 21024',0.262555,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27944,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27944,31.89,0.2,23.9,7415,74.4,NULL,NULL,'UGC 02392',NULL,'2013AJ....146...86T',2013,1,1.9,NULL,'G',0.000017,NULL,'14.75',0.5,'Scd?',NULL,NULL,NULL,NULL,1,43.9434166667,33.76664,0.345,NULL,68712568646,1073633885,16775529,14.75),(27945,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27945,32.14,0.4,26.8,7415,73,NULL,'opt','UGC 02392',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27946,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27946,32.19,0.52,27.4,7415,NULL,NULL,NULL,'UGC 02392',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27947,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27947,32.24,0.5,28,7415,NULL,NULL,'Malmquist cor.','UGC 02392',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27948,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27948,35,0.1,100,7416,NULL,NULL,NULL,'UGC 02399',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000007,NULL,'14.70',1.3,'SAB(s)cd','Group member',NULL,NULL,NULL,1,43.9455417,6.21753,0.273,NULL,67970598874,1062040607,16594384,14.7),(27949,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27949,34.36,0.25,74.5,7417,74.4,NULL,NULL,'GIN 150',NULL,'2013AJ....146...86T',2013,1,0.47,NULL,'G',0.000067,NULL,'14.69',0.39,'E/S0',NULL,NULL,NULL,NULL,1,43.9514583,-14.25369,0.061,NULL,38102685749,595354464,9302413,14.69),(27950,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27950,34.51,0.4,79.8,7417,70,NULL,NULL,'GIN 150',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27951,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,'R',27951,34.31,0.49,72.7,7418,75,NULL,'IR','UGC 02404',NULL,'2011yCatp016004901K',2011,1,0.54,NULL,'G',0.000045,NULL,'17.9g',0.03,'Sd',NULL,NULL,NULL,NULL,1,43.953667,1.07936,0.249,NULL,66840932674,1044389573,16318587,17.9),(27952,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27952,34.35,0.43,74,7418,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02404',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27953,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27953,34.49,0.43,79.2,7418,75,NULL,'3.6 micron, color corrected','UGC 02404',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27954,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27954,34.55,0.2,81.3,7418,74.4,NULL,NULL,'UGC 02404',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27955,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27955,34.64,NULL,84.6,7418,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02404',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27956,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27956,34.64,NULL,84.8,7418,NULL,NULL,'Dipole + Quadrupole','UGC 02404',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27957,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27957,34.66,0.42,85.6,7418,NULL,NULL,NULL,'UGC 02404',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27958,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27958,34.67,NULL,85.8,7418,NULL,NULL,'Dipole','UGC 02404',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27959,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27959,34.68,NULL,86.4,7418,NULL,NULL,NULL,'UGC 02404',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27960,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27960,34.88,0.38,94.5,7418,NULL,NULL,'Malmquist cor.','UGC 02404',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27961,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,'R',27961,36.95,0.46,245,7419,70,NULL,NULL,'2MASX J02555367+0051381',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,43.973583,0.86044,0.257,NULL,66840785728,1044387277,16318551,16.5),(27962,'IRAS','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27962,35.94,0.8,154,7420,75,NULL,'CF, r','UGC 02393',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000033,NULL,'15.29',0.5,'Sd',NULL,NULL,NULL,NULL,1,43.973667,32.33492,0.489,NULL,68680582765,1073134105,16767720,15.29),(27963,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27963,35.44,0.38,122,7420,75,NULL,'CF, r, raw','UGC 02393',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27964,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27964,35.6,0.38,132,7420,75,NULL,'CF, r, inv','UGC 02393',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27965,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27965,35.67,0.38,136,7420,75,NULL,'CF, r, cor','UGC 02393',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27966,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 16175','RN',27966,40.61,0.28,996,7421,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 16175',0.329556,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27967,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 16175','RN',27967,40.69,0.23,1030,7421,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 16175',0.329556,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27968,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 16175','N',27968,40.51,0.18,1260,7421,70,NULL,'SALT 2','SDSS-II SN 16175',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27969,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 16175','N',27969,40.55,0.18,1290,7421,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16175',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27970,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27970,35.84,0.62,147,7422,70,NULL,NULL,'2MASX J02555681-1406509',NULL,'2014MNRAS.445.2677S',2014,1,0.31,NULL,'G',0.00015,NULL,'17.02',0.29,NULL,NULL,NULL,NULL,NULL,1,43.9867916667,-14.11419,0.049,NULL,38102638853,595353732,9302402,17.02),(27971,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27971,33.1,0.45,41.7,7423,NULL,NULL,'K','UGC 02403',NULL,'2007A&A...465...71T',2007,1,1.43,NULL,'G',0.000017,NULL,'14.3g',0.6,'SB(rs)a pec:   HII',NULL,NULL,NULL,NULL,1,43.988583,0.69261,0.257,NULL,66841253028,1044394578,16318665,14.3),(27972,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27972,33.16,0.47,42.9,7423,NULL,NULL,'H','UGC 02403',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27973,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27973,33.32,0.46,46,7423,NULL,NULL,'J','UGC 02403',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27974,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27974,33.56,0.4,51.4,7423,NULL,NULL,'mean','UGC 02403',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27975,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27975,33.56,0.2,51.5,7423,74.4,NULL,NULL,'UGC 02403',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27976,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27976,33.61,0.45,52.7,7423,NULL,NULL,NULL,'UGC 02403',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27977,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27977,33.66,0.44,53.8,7423,NULL,NULL,'Malmquist cor.','UGC 02403',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27978,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27978,36.71,1,219,7424,70,NULL,NULL,'2MASX J02555755-1211189',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.97',0.42,NULL,NULL,NULL,NULL,NULL,1,43.989875,-12.18864,0.069,NULL,37871230248,591737972,9245905,16.97),(27979,'IRAS','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27979,35,0.8,100,7425,75,NULL,'HMCL, I','UGC 02405',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000013,NULL,'14.70',0.6,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,43.99,6.49481,0.285,NULL,67970621372,1062040958,16594389,14.7),(27980,'IRAS','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27980,35,0.8,100,7425,75,NULL,'W91CL, r','UGC 02405',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27981,'IRAS','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27981,35.01,0.8,101,7425,75,NULL,'CF, r','UGC 02405',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27982,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27982,34.79,0.38,90.7,7425,75,NULL,'CF, r, raw','UGC 02405',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27983,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27983,34.82,0.4,92.2,7425,75,NULL,'HMCL, I, raw','UGC 02405',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27984,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27984,34.89,0.2,95.1,7425,74.4,NULL,NULL,'UGC 02405',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27985,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27985,34.91,0.38,96,7425,75,NULL,'W91CL, r, raw','UGC 02405',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27986,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27986,34.94,0.38,97.5,7425,75,NULL,'CF, r, inv','UGC 02405',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27987,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27987,35,0.43,99.9,7425,75,NULL,'3.6 micron, color corrected','UGC 02405',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27988,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27988,35,0.1,100,7425,NULL,NULL,NULL,'UGC 02405',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27989,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27989,35.01,0.38,101,7425,75,NULL,'CF, r, cor','UGC 02405',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27990,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27990,35.04,0.4,102,7425,75,NULL,'HMCL, I, inv','UGC 02405',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27991,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27991,35.05,0.4,103,7425,75,NULL,'HMCL, I, cor','UGC 02405',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27992,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27992,35.08,0.38,104,7425,75,NULL,'W91CL, r, inv','UGC 02405',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27993,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27993,35.1,0.38,105,7425,75,NULL,'W91CL, r, cor','UGC 02405',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27994,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27994,35.16,0.43,108,7425,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02405',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27995,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27995,35.12,0.49,106,7426,70,NULL,NULL,'2MASX J02555838-4533570',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.0001,NULL,'15.29',0.62,'E',NULL,NULL,NULL,NULL,1,43.993375,-45.56578,0,NULL,38519722460,601870663,9404229,15.29),(27996,'SNIa SDSS','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 06404','RN',27996,40.97,4.96,1310,7427,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06404',0.193608,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27997,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27997,34.41,NULL,76.3,7428,NULL,NULL,NULL,'FGC 0362',NULL,'2000BSAO...50....5K',2000,1,1.1,NULL,'G',0.000012,NULL,'16.4',0.11,'Sdm',NULL,NULL,NULL,NULL,1,44.0359583333,27.70058,0.565,NULL,68671616953,1072994014,16765531,16.4),(27998,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27998,34.46,NULL,78,7428,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0362',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(27999,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,27999,34.46,NULL,78.1,7428,NULL,NULL,'Dipole + Quadrupole','FGC 0362',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28000,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28000,34.47,NULL,78.5,7428,NULL,NULL,'Dipole','FGC 0362',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28001,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28001,35.91,0.08,152,7429,NULL,NULL,NULL,'UGC 02406',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000017,NULL,'15.23',0.7,'(R\')SAB(s)a','Group member',NULL,NULL,NULL,1,44.036417,15.79244,0.265,NULL,68179890374,1065310787,16645481,15.23),(28002,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,'R',28002,36.75,0.46,224,7430,70,NULL,NULL,'2MASX J02560915+0034411',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000084,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,44.038125,0.57822,0.185,NULL,66841264767,1044394761,16318668,16.9),(28003,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28003,33.72,NULL,55.5,7431,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02396',NULL,'2010Ap&SS.325..163P',2010,1,1.37,NULL,'G',0.00002,NULL,'16.5',0.1,'Sd',NULL,NULL,NULL,NULL,1,44.0397083,37.05619,0.449,NULL,68708289951,1073567030,16774484,16.5),(28004,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28004,33.74,NULL,56,7431,NULL,NULL,'Dipole + Quadrupole','UGC 02396',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28005,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28005,33.74,NULL,56,7431,NULL,NULL,'Dipole','UGC 02396',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (28006,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28006,35.46,0.64,123,7432,70,NULL,NULL,'2MASX J02561134-1457229',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.13',0.43,NULL,NULL,NULL,NULL,NULL,1,44.04725,-14.95633,0.061,NULL,38102942659,595358479,9302476,16.13),(28007,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28007,34,0.2,63.1,7433,74.4,NULL,NULL,'2MASX J02561271+0606483',NULL,'2013AJ....146...86T',2013,1,0.35,NULL,'G',0.00001,NULL,'15.83',0.28,'SBbc','Group member',NULL,NULL,NULL,1,44.0530416667,6.1135,0.273,NULL,67924735149,1061323986,16583187,15.83),(28008,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 16032','R',28008,40.02,0.19,840,7434,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006nk','SN 2006nk',0.204,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,44.0692083333,-0.41078,0.225,NULL,34897612732,545275198,8519924,NULL),(28009,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 16032','R',28009,40.19,0.09,906,7434,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006nk','SN 2006nk',0.204,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28010,'IRAS','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28010,35.19,0.8,109,7435,75,NULL,'HMCL, I','UGC 02414',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000024,NULL,'15.33',0.2,'Scd:','Group member, peripheral',NULL,NULL,NULL,1,44.073333,4.52933,0.249,NULL,67930435909,1061413061,16584579,15.33),(28011,'IRAS','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28011,35.19,0.8,109,7435,75,NULL,'W91CL, r','UGC 02414',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28012,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,'R',28012,34.79,0.49,90.9,7435,75,NULL,'IR','UGC 02414',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28013,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28013,35.17,0.2,108,7435,74.4,NULL,NULL,'UGC 02414',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28014,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28014,35.19,0.38,109,7435,75,NULL,'W91CL, r, raw','UGC 02414',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28015,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28015,35.26,0.4,112,7435,75,NULL,'HMCL, I, raw','UGC 02414',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28016,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28016,35.31,0.38,115,7435,75,NULL,'W91CL, r, cor','UGC 02414',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28017,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28017,35.33,0.38,116,7435,75,NULL,'W91CL, r, inv','UGC 02414',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28018,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28018,35.33,0.11,117,7435,NULL,NULL,NULL,'UGC 02414',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28019,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28019,35.42,0.4,122,7435,75,NULL,'HMCL, I, cor','UGC 02414',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28020,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28020,35.44,0.4,122,7435,75,NULL,'HMCL, I, inv','UGC 02414',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28021,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 06875','RN',28021,40.49,0.19,1070,7436,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 06875',0.16744,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28022,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 06875','RN',28022,40.61,0.3,1130,7436,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 06875',0.16744,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28023,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 06875','N',28023,40.35,0.17,1170,7436,70,NULL,'SALT 2','SDSS-II SN 06875',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28024,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 06875','N',28024,40.36,0.17,1180,7436,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 06875',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28025,'IRAS','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28025,35.02,0.8,101,7437,75,NULL,'HMCL, I','UGC 02415',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.00001,NULL,'15.65',0.4,'SB(s)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,44.0946666667,6.15522,0.265,NULL,67969882890,1062029420,16594209,15.65),(28026,'IRAS','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28026,35.02,0.8,101,7437,75,NULL,'W91CL, r','UGC 02415',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28027,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28027,34.82,0.43,92.1,7437,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02415',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28028,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28028,34.92,0.43,96.4,7437,75,NULL,'3.6 micron, color corrected','UGC 02415',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28029,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28029,34.93,0.4,96.9,7437,75,NULL,'HMCL, I, raw','UGC 02415',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28030,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28030,35.02,0.2,101,7437,74.4,NULL,NULL,'UGC 02415',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28031,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28031,35.01,0.11,101,7437,NULL,NULL,NULL,'UGC 02415',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28032,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28032,35.07,0.38,103,7437,75,NULL,'W91CL, r, raw','UGC 02415',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28033,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28033,35.08,0.4,104,7437,75,NULL,'HMCL, I, inv','UGC 02415',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28034,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28034,35.13,0.4,106,7437,75,NULL,'HMCL, I, cor','UGC 02415',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28035,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28035,35.18,0.38,109,7437,75,NULL,'W91CL, r, inv','UGC 02415',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28036,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28036,35.22,0.38,111,7437,75,NULL,'W91CL, r, cor','UGC 02415',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28037,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28037,33.92,0.2,60.8,7438,74.4,NULL,NULL,'UGC 02418',NULL,'2013AJ....146...86T',2013,1,1.26,NULL,'G',0.000083,NULL,'14.6g',0.63,'SABbc',NULL,NULL,NULL,NULL,1,44.1130417,0.87575,0.257,NULL,66840901745,1044389089,16318579,14.6),(28038,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28038,34.92,0.1,96.6,7438,NULL,NULL,NULL,'UGC 02418',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28039,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28039,35.49,0.25,125,7439,74.4,NULL,NULL,'CGCG 463-036',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000037,NULL,'14.23',0.6,'E/S0','Group member',NULL,NULL,NULL,1,44.116333,16.00794,0.413,NULL,68180460321,1065319692,16645620,14.23),(28040,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28040,35.69,0.14,138,7439,70,NULL,NULL,'CGCG 463-036',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28041,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 03535','R',28041,40.98,0.21,1200,7440,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03535',0.308446,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,44.1172083,-0.13347,0.209,NULL,34897057233,545266519,8519789,NULL),(28042,'SNIa','2016-12-15 15:13:56','2016-12-16 11:19:00','1','SDSS-II SN 03535','R',28042,41.05,0.25,1240,7440,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03535',0.308446,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28043,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28043,35.5,0.25,126,7441,74.4,NULL,NULL,'UGC 02413',NULL,'2013AJ....146...86T',2013,1,1,'UGC 02413 is \\\"npp\\\" of 2, not \\\"sff\\\".  UGC Notes to read PA = 110, not 290.','G',0.00004,NULL,'13.58',0.8,'cD;BrClG','Group member',NULL,NULL,NULL,1,44.1202083,15.91583,0.265,NULL,68179887871,1065310747,16645480,13.58),(28044,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28044,35.69,0.14,138,7441,70,NULL,NULL,'UGC 02413',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28045,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28045,35.87,0.13,150,7441,70,NULL,'ABELL 0397, BGC','UGC 02413',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28046,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28046,35.48,0.86,124,7442,70,NULL,NULL,'2MASX J02563172-1354494',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'17.07',0.2,NULL,NULL,NULL,NULL,NULL,1,44.1322917,-13.91381,0.057,NULL,38101324068,595333188,9302081,17.07),(28047,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28047,35,0.12,100,7443,NULL,NULL,NULL,'2MASX J02563176+0616465',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000016,NULL,'16.62',0.1,NULL,NULL,NULL,NULL,NULL,1,44.1324583333,6.27961,0.265,NULL,67969930592,1062030165,16594221,16.62),(28048,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28048,35.49,0.25,125,7444,74.4,NULL,NULL,'GIN 155',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000013,NULL,'16.57',0.4,'S0/a',NULL,NULL,NULL,NULL,1,44.1355416667,16.00411,0.413,NULL,68180459590,1065319681,16645620,16.57),(28049,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28049,35.69,0.14,138,7444,70,NULL,NULL,'GIN 155',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28050,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28050,35.94,0.08,154,7444,NULL,NULL,NULL,'GIN 155',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28051,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28051,35.5,0.25,126,7445,74.4,NULL,NULL,'UGC 02413 NOTES01',NULL,'2013AJ....146...86T',2013,1,0.2,'UGC 02413 is \\\"npp\\\" of 2, not \\\"sff\\\".  UGC Notes to read PA = 110, not 290.','G',0.000043,NULL,'14.20',0.2,'E/S0','Group member',NULL,NULL,NULL,1,44.136917,15.91028,0.265,NULL,68179889730,1065310777,16645480,14.2),(28052,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28052,35.69,0.14,138,7445,70,NULL,NULL,'UGC 02413 NOTES01',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28053,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28053,35.72,0.11,140,7446,NULL,NULL,NULL,'2MASX J02563355+1556511',NULL,'2009ApJS..182..474S',2009,1,0.36,NULL,'G',0.000023,NULL,'16.06',NULL,'Sc',NULL,NULL,NULL,NULL,1,44.139917,15.94744,0.265,NULL,68179886506,1065310726,16645480,16.06),(28054,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28054,34.85,0.69,93.5,7447,70,NULL,NULL,'2MASX J02563425-1503314',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.72',NULL,NULL,NULL,NULL,NULL,NULL,1,44.142875,-15.05875,0.061,NULL,38102939108,595358423,9302475,15.72),(28055,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28055,35.1,0.51,105,7448,70,NULL,NULL,'2MASX J02563432-1347584',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'16.46',0.19,NULL,NULL,NULL,NULL,NULL,1,44.143083,-13.79956,0.065,NULL,38101383664,595334119,9302095,16.46),(28056,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28056,35.69,0.47,137,7449,NULL,NULL,'H','CGCG 463-038',NULL,'2007A&A...465...71T',2007,1,0.7,NULL,'G',0.000124,NULL,'15.7',0.2,NULL,NULL,NULL,NULL,NULL,1,44.14425,16.88472,0.357,NULL,68182101011,1065345328,16646020,15.7),(28057,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28057,35.77,0.4,143,7449,NULL,NULL,'mean','CGCG 463-038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28058,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28058,35.85,0.45,148,7449,NULL,NULL,'K','CGCG 463-038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28059,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,'R',28059,37,0.46,251,7450,70,NULL,NULL,'2MASX J02563924-0707437',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000072,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,44.1634583333,-7.12869,0.157,NULL,37910850368,592357037,9255578,17.1),(28060,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28060,35.66,0.76,136,7451,70,NULL,NULL,'2MASX J02564046-0056138',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.000101,NULL,'16.0g',0.21,'S0',NULL,NULL,NULL,NULL,1,44.1684583,-0.93731,0.169,NULL,34897249151,545269517,8519836,16),(28061,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28061,36.84,0.7,233,7452,NULL,NULL,'Malmquist cor.','AGC 121157',NULL,'2009ApJS..182..474S',2009,1,0.22,NULL,'G',0.000023,NULL,'17.36',NULL,'Sc',NULL,NULL,NULL,NULL,1,44.1850833333,15.99192,0.413,NULL,68179805095,1065309454,16645460,17.36),(28062,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28062,37.12,0.62,265,7452,NULL,NULL,NULL,'AGC 121157',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28063,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28063,37.16,0.2,270,7452,74.4,NULL,NULL,'AGC 121157',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28064,'FP','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,NULL,28064,37.06,0.55,258,7453,70,NULL,NULL,'LCRS B025452.9-421921',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.000083,NULL,'16.07',0.45,'E',NULL,NULL,NULL,NULL,1,44.186167,-42.12181,0,NULL,38503989785,601624840,9400388,16.07),(28065,'Tully-Fisher','2016-12-15 15:13:56','2016-12-16 11:19:00','1',NULL,'R',28065,33.51,0.49,50.4,7454,75,NULL,'IR','UGC 02409',NULL,'2011yCatp016004901K',2011,1,1,'abs(b) < 10 degrees.','G',0.000017,NULL,'17.',0.3,'S?',NULL,NULL,NULL,NULL,1,44.187333,50.59536,NULL,NULL,68533537345,1070836521,16731820,17),(28066,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28066,33.59,0.45,52.2,7454,NULL,NULL,'K','UGC 02409',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28067,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28067,33.6,0.4,52.6,7454,NULL,NULL,'mean','UGC 02409',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28068,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28068,33.63,0.47,53.2,7454,NULL,NULL,'H','UGC 02409',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28069,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28069,34.7,0.2,87.1,7455,74.4,NULL,NULL,'2MASX J02564580+0603173',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000013,NULL,'15.17',0.3,'S+','Group member',NULL,NULL,NULL,1,44.191,6.05492,0.317,NULL,67924778089,1061324657,16583197,15.17),(28070,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28070,34.86,0.11,94,7455,NULL,NULL,NULL,'2MASX J02564580+0603173',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28071,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28071,35,0.09,100,7456,NULL,NULL,NULL,'UGC 02423',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.42',0.3,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,44.1955417,4.97783,0.237,NULL,67927228467,1061362944,16583796,15.42),(28072,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28072,35.17,0.4,108,7456,NULL,NULL,'mean','UGC 02423',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28073,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28073,35.24,0.47,112,7456,NULL,NULL,'H','UGC 02423',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28074,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28074,35.71,0.09,139,7457,NULL,NULL,NULL,'2MASX J02564815+1601446',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000027,NULL,'16.0',0.6,'Sc',NULL,NULL,NULL,NULL,1,44.200625,16.02917,0.413,NULL,68179807539,1065309492,16645460,16),(28075,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28075,35.78,0.4,143,7458,NULL,NULL,'mean','UGC 02420',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000033,NULL,'16.0',0.2,'Sb',NULL,NULL,NULL,NULL,1,44.208167,15.98436,0.413,NULL,68179804624,1065309447,16645460,16),(28076,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28076,35.97,0.15,157,7458,NULL,NULL,NULL,'UGC 02420',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28077,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28077,35.98,0.49,157,7458,75,NULL,'IR','UGC 02420',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28078,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28078,36.03,0.47,160,7458,NULL,NULL,'H','UGC 02420',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28079,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28079,36.1,0.45,166,7458,NULL,NULL,'K','UGC 02420',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28080,'CMD','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28080,28.8,0.04,5.75,7459,NULL,NULL,NULL,'ESO 154- G 023',NULL,'2010ApJ...721..297M',2010,1,8.5,'Extended HIPASS source','G',0.000007,NULL,'12.6B',1.8,'SB(s)m',NULL,NULL,NULL,NULL,1,44.209917,-54.57142,0,NULL,38185172276,596643316,9322551,12.6),(28081,'TRGB','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28081,28.8,0.03,5.76,7459,NULL,NULL,NULL,'ESO 154- G 023',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28082,'TRGB','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28082,28.84,0.02,5.86,7459,NULL,NULL,'I','ESO 154- G 023',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28083,'TRGB','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28083,28.88,0.09,5.98,7459,74.4,NULL,NULL,'ESO 154- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28084,'IRAS','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28084,29.08,0.8,6.55,7459,75,NULL,'A82, H','ESO 154- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28085,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28085,28.64,0.4,5.4,7459,75,NULL,'B','ESO 154- G 023',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28086,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28086,28.88,0.09,5.98,7459,74.4,NULL,NULL,'ESO 154- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28087,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28087,29.21,0.47,6.95,7459,75,NULL,'A82, H, inv','ESO 154- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28088,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28088,29.35,0.35,7.41,7459,NULL,NULL,NULL,'ESO 154- G 023',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28089,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28089,29.49,0.47,7.89,7459,75,NULL,'A82, H, raw','ESO 154- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28090,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28090,29.89,0.47,9.49,7459,75,NULL,'A82, H, cor','ESO 154- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28091,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 14470','R',28091,39.75,0.18,745,7460,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14470',0.19543,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,44.2149166667,-0.35178,0.225,NULL,34897576860,545274638,8519916,NULL),(28092,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 14470','R',28092,39.86,0.09,783,7460,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14470',0.19543,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28093,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 14470',NULL,28093,39.49,0.2,790,7460,70,NULL,'SN photometric redshift distance, z photo =0.205 +/- 0.023','SDSS-II SN 14470',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28094,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28094,36.12,0.58,168,7461,NULL,NULL,'Malmquist cor.','AGC 121402',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',NULL,NULL,'16.2I',0.2,NULL,NULL,NULL,NULL,NULL,1,44.21625,5.68694,0.281,NULL,67925527030,1061336359,16583380,16.2),(28095,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28095,36.21,0.2,175,7461,74.4,NULL,NULL,'AGC 121402',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28096,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28096,36.28,0.54,180,7461,NULL,NULL,NULL,'AGC 121402',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28097,'D-Sigma','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28097,27.16,NULL,2.7,7462,NULL,NULL,NULL,'Dwingeloo 1',NULL,'1997A&A...327..963P',1997,1,4.2,NULL,'G',0.000001,NULL,'8.3',0.34,'SB(s)cd',NULL,NULL,NULL,NULL,1,44.2164166667,58.91164,NULL,0,66314179524,1036159055,16189985,8.3),(28098,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28098,27.24,NULL,2.8,7462,NULL,NULL,NULL,'Dwingeloo 1',NULL,'2003A&A...408..111K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28099,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28099,27.39,NULL,3,7462,NULL,NULL,'I, TF 1','Dwingeloo 1',NULL,'1995ApL&C..31..227K',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28100,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28100,27.59,0.13,3.3,7462,NULL,NULL,'I','Dwingeloo 1',NULL,'1997A&A...327..963P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28101,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28101,27.69,0.09,3.45,7462,NULL,NULL,'R','Dwingeloo 1',NULL,'1997A&A...327..963P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28102,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28102,27.72,NULL,3.5,7462,NULL,NULL,'R, TF 2','Dwingeloo 1',NULL,'1996MNRAS.280..537L',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28103,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28103,27.78,NULL,3.6,7462,NULL,NULL,'I, TF 1','Dwingeloo 1',NULL,'1996MNRAS.280..537L',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28104,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28104,27.78,NULL,3.6,7462,NULL,NULL,'R, TF 1','Dwingeloo 1',NULL,'1996MNRAS.280..537L',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28105,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28105,28.41,NULL,4.8,7462,NULL,NULL,'I. TF 2','Dwingeloo 1',NULL,'1996MNRAS.280..537L',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28106,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28106,28.62,0.27,5.3,7462,NULL,NULL,'IR','Dwingeloo 1',NULL,'1999AJ....118..826I',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28107,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 19158','RN',28107,42.89,0.24,2760,7463,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19158',0.367209,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28108,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 19158','RN',28108,43.21,0.26,3210,7463,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19158',0.367209,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28109,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28109,35.87,0.13,150,7464,70,NULL,NULL,'ABELL 0397',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,44.245417,15.95061,0.413,NULL,68179922039,1065311281,16645488,NULL),(28110,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28110,37.38,0.65,299,7465,70,NULL,NULL,'2MASX J02570024-2203286',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.96',0.25,NULL,NULL,NULL,NULL,NULL,1,44.2510833333,-22.05803,0.013,NULL,38053451906,594585186,9290393,16.96),(28111,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28111,35.67,0.1,136,7466,NULL,NULL,NULL,'2MASX J02570378+1532476',NULL,'2009ApJS..182..474S',2009,1,0.32,NULL,'G',0.000027,NULL,'15.23',NULL,'Sc',NULL,NULL,NULL,NULL,1,44.26575,15.54661,0.285,NULL,68168555208,1065133675,16642713,15.23),(28112,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28112,35.48,0.25,125,7467,74.4,NULL,NULL,'GIN 154',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00004,NULL,'14.41',0.5,'E/S0',NULL,NULL,NULL,NULL,1,44.269333,15.98311,0.413,NULL,68179921012,1065311265,16645488,14.41),(28113,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28113,35.69,0.14,138,7467,70,NULL,NULL,'GIN 154',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28114,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 08600','R',28114,41.96,0.31,1710,7468,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 08600',0.437935,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,'PHOT','22.3g',0.02,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,44.2709583,-0.09208,0.209,NULL,34897528069,545273876,8519904,22.3),(28115,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 08600',NULL,28115,41.25,0.31,1770,7468,70,NULL,'SN photometric redshift distance, z photo =0.554 +/- 0.127','SDSS-II SN 08600',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28116,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 08600','R',28116,42.21,0.37,1920,7468,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 08600',0.437935,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28117,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 08600',NULL,28117,42.14,0.23,2680,7468,70,NULL,'SALT 2','SDSS-II SN 08600',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28118,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 08600',NULL,28118,42.23,0.23,2790,7468,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 08600',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28119,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28119,36.35,0.66,186,7469,70,NULL,NULL,'6dF J0257054-420159',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,44.272417,-42.03306,0,NULL,38504205489,601628210,9400440,14.7),(28120,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28120,34.41,0.49,76.1,7470,75,NULL,'IR','UGC 02424',NULL,'2011yCatp016004901K',2011,1,2.2,NULL,'G',0.000037,NULL,'14.25',0.6,'Sbc',NULL,NULL,NULL,NULL,1,44.2814583,17.51428,0.413,NULL,68178901276,1065295332,16645239,14.25),(28121,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28121,34.47,0.47,78.5,7470,NULL,NULL,'H','UGC 02424',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28122,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28122,34.54,0.46,81,7470,NULL,NULL,'J','UGC 02424',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28123,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28123,34.58,0.45,82.5,7470,NULL,NULL,'K','UGC 02424',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28124,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28124,34.83,0.2,92.5,7470,74.4,NULL,NULL,'UGC 02424',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28125,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28125,34.86,0.4,93.7,7470,NULL,NULL,'mean','UGC 02424',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28126,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28126,35.07,0.29,103,7470,NULL,NULL,NULL,'UGC 02424',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28127,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28127,35.11,0.29,105,7470,NULL,NULL,'Malmquist cor.','UGC 02424',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28128,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28128,35.69,0.14,138,7471,70,NULL,NULL,'GIN 159',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.000037,NULL,'14.90',NULL,'S',NULL,NULL,NULL,NULL,1,44.283583,15.97978,0.413,NULL,68179920917,1065311264,16645488,14.9),(28129,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28129,32.42,0.43,30.5,7472,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02429',NULL,'2014MNRAS.444..527S',2014,1,1.1,NULL,'G',0.00002,NULL,'16.0',0.5,'SB(s)m:',NULL,NULL,NULL,NULL,1,44.288167,1.32644,0.249,NULL,67914716123,1061167439,16580741,16),(28130,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28130,34.21,0.69,69.5,7473,100,NULL,'mid-IR','UGC 02426',NULL,'2013ApJ...771...88L',2013,1,0.9,NULL,'G',0.000037,NULL,'14.86',0.6,'SA:b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,44.288375,5.32092,0.269,NULL,67925260546,1061332196,16583315,14.86),(28131,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28131,35.08,0.4,104,7473,NULL,NULL,'mean','UGC 02426',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28132,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28132,35.12,0.08,106,7473,NULL,NULL,NULL,'UGC 02426',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28133,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28133,35.4,0.47,120,7473,NULL,NULL,'H','UGC 02426',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28134,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28134,32.77,0.2,35.8,7474,74.4,NULL,NULL,'IC 0273',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000027,NULL,'14.25',0.5,'SBa: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,44.294917,2.77506,0.265,NULL,67917002315,1061203161,16581299,14.25),(28135,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28135,34.42,0.69,76.6,7475,100,NULL,'mid-IR','2MASX J02571191+0744022',NULL,'2013ApJ...771...88L',2013,1,0.7,NULL,'G',0.000039,NULL,'16.99',0.2,NULL,NULL,NULL,NULL,NULL,1,44.299833,7.734,0.389,NULL,67980523219,1062195675,16596807,16.99),(28136,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28136,36.11,0.58,167,7476,70,NULL,NULL,'2MASX J02571562-0154390',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.82',0.35,NULL,NULL,NULL,NULL,NULL,1,44.3149583,-1.91078,0.201,NULL,37853299772,591457808,9241528,16.82),(28137,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28137,36.16,0.7,171,7477,70,NULL,NULL,'2MASX J02572175-0619253',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,44.34075,-6.32367,0.173,NULL,37910450404,592350787,9255481,16.7),(28138,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 14753','RN',28138,39.5,0.33,700,7478,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14753',0.135401,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28139,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 14753','RN',28139,40.08,0.37,913,7478,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14753',0.135401,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28140,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28140,35.48,0.25,125,7479,74.4,NULL,NULL,'MCG +03-08-034',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.00005,NULL,'14.56',0.3,'E/S0',NULL,NULL,NULL,NULL,1,44.348125,16.09522,0.413,NULL,68179814645,1065309603,16645462,14.56),(28141,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28141,35.69,0.14,138,7479,70,NULL,NULL,'MCG +03-08-034',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28142,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28142,34.77,0.56,90,7480,70,NULL,NULL,'NGC 1149',NULL,'2014MNRAS.445.2677S',2014,1,0.84,NULL,'G',0.000107,NULL,'14.8g',0.62,'S0-:',NULL,NULL,NULL,NULL,1,44.3494583,-0.30942,0.225,NULL,34897560671,545274385,8519912,14.8),(28143,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28143,35.23,0.33,111,7480,70,NULL,NULL,'NGC 1149',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28144,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 04731','RN',28144,38.2,0.26,423,7481,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04731',0.029084,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28145,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28145,35.55,0.2,129,7482,74.4,NULL,NULL,'CGCG 440-036b',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000022,NULL,'14.32',0.6,'SBb',NULL,NULL,NULL,NULL,1,44.363083,15.44464,0.325,NULL,68168686484,1065135726,16642745,14.32),(28146,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28146,35.73,0.09,140,7482,NULL,NULL,NULL,'CGCG 440-036b',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28147,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28147,34.12,0.2,66.7,7483,74.4,NULL,NULL,'2MASX J02572834+0513223',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000023,NULL,'14.89',0.3,NULL,NULL,NULL,NULL,NULL,1,44.368167,5.22289,0.269,NULL,67927153953,1061361780,16583777,14.89),(28148,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28148,35,0.1,100,7483,NULL,NULL,NULL,'2MASX J02572834+0513223',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28149,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SN 1995ao',NULL,28149,40.01,0.41,810,7484,74.2,NULL,'SALT 2','[K95] J025730.70-014119.8',0.24,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,44.377917,-1.68883,0.189,NULL,37853289823,591457653,9241525,NULL),(28150,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SN 1995ao','R',28150,40.25,NULL,905,7484,65,NULL,'SALT','[K95] J025730.70-014119.8',0.24,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28151,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SN 1995ao',NULL,28151,40.74,0.6,1130,7484,65,NULL,'Snapshot','[K95] J025730.70-014119.8',0.24,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28152,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SN 1995ao',NULL,28152,40.76,0.6,1140,7484,65,NULL,NULL,'[K95] J025730.70-014119.8',0.24,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28153,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SN 1995ao',NULL,28153,40.92,0.6,1230,7484,70,NULL,'SALT','[K95] J025730.70-014119.8',0.24,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28154,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SN 1995ao',NULL,28154,41.03,0.57,1300,7484,65,NULL,'SALT','[K95] J025730.70-014119.8',0.24,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28155,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28155,35.05,0.23,102,7485,74.4,NULL,NULL,'CGCG 415-040',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000031,NULL,'13.75',0.5,'S0','Group member',NULL,NULL,NULL,1,44.3902917,5.97692,0.317,NULL,67924893637,1061326463,16583225,13.75),(28156,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28156,35.37,0.17,119,7485,70,NULL,NULL,'CGCG 415-040',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28157,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28157,34.25,0.25,70.8,7486,74.4,NULL,NULL,'III Zw 052 NOTES04',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000025,NULL,'15.87',0.2,'E','Group member',NULL,NULL,NULL,1,44.4060417,6.04725,0.317,NULL,67924886783,1061326355,16583224,15.87),(28158,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28158,35.48,0.25,125,7487,74.4,NULL,NULL,'CGCG 463-041',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000017,NULL,'13.94',0.3,'E/S0',NULL,NULL,NULL,NULL,1,44.40625,16.06786,0.413,NULL,68179839976,1065309999,16645468,13.94),(28159,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28159,35.69,0.14,138,7487,70,NULL,NULL,'CGCG 463-041',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28160,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28160,35.61,0.47,133,7487,NULL,NULL,'H','CGCG 463-041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28161,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28161,35.67,0.4,136,7487,NULL,NULL,'mean','CGCG 463-041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28162,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28162,35.73,0.45,140,7487,NULL,NULL,'K','CGCG 463-041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28163,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28163,35.81,0.46,145,7487,NULL,NULL,'J','CGCG 463-041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28164,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 14407','RN',28164,42.28,0.24,2030,7488,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 14407',0.407354,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28165,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 14407','RN',28165,42.8,0.26,2580,7488,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 14407',0.407354,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28166,'BCG','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28166,35.84,0.35,144,7489,60,NULL,NULL,'ABELL 0400',0.0231,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III [BM]',NULL,NULL,NULL,NULL,1,44.412083,6.00611,0.317,NULL,67924900242,1061326566,16583227,NULL),(28167,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28167,34.36,0.51,74.5,7490,70,NULL,NULL,'2MASX J02573898-1028363',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.92',0.4,'E','Field galaxy',NULL,NULL,NULL,1,44.412375,-10.47672,0.101,NULL,37903394386,592240537,9253758,14.92),(28168,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28168,36.75,0.7,224,7491,70,NULL,NULL,'2MASX J02574054-1229320',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.89',0.16,NULL,NULL,NULL,NULL,NULL,1,44.418875,-12.49219,0.105,NULL,38092911117,595201736,9300027,16.89),(28169,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28169,35.14,0.25,107,7492,74.4,NULL,NULL,'NGC 1128',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'GPair',0.000067,NULL,NULL,NULL,'E0:','Group member, central object',NULL,'radio jet',NULL,1,44.4232083,6.02467,0.317,NULL,67924900854,1061326575,16583227,NULL),(28170,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28170,34.11,0.45,66.4,7492,NULL,NULL,'K','NGC 1128',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28171,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28171,34.73,NULL,88.4,7492,71,NULL,'ABELL 0400, 75 galaxies','NGC 1128',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28172,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28172,34.81,NULL,91.6,7492,77,NULL,'BRIK, ABELL 0400 cluster, 7 galaxies','NGC 1128',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28173,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28173,34.81,0.19,91.6,7492,77,NULL,'ABELL 0400, 7 galaxies','NGC 1128',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28174,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28174,34.81,0.3,91.8,7492,NULL,NULL,'ABELL 0400, 18 galaxies','NGC 1128',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28175,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28175,34.85,0.4,93.4,7492,NULL,NULL,'mean','NGC 1128',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28176,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28176,34.86,0.11,93.8,7492,75,NULL,'ABELL 0400 CLUSTER','NGC 1128',NULL,'2012ApJ...749...78T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28177,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28177,34.92,0.12,96.4,7492,75,NULL,'ABELL 0400 cluster, avg. of 7 spiral galaxies','NGC 1128',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28178,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28178,34.94,0.11,97.3,7492,75,NULL,'ABELL 0400 cluster, avg. of 7 spiral galaxies','NGC 1128',NULL,'2013ApJ...765...94S',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28179,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28179,34.98,0.16,99.1,7492,70,NULL,'ABELL 0400 Cluster','NGC 1128',NULL,'1992ApJ...396..453H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28180,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28180,35,0.12,100,7492,74.4,NULL,'ABELL 0400, 8 galaxies, WISE W1 (3.4 micro-meter), color corrected','NGC 1128',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28181,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28181,35.01,0.12,100,7492,74.4,NULL,'ABELL 0400, 8 galaxies, WISE W2 (4.6 micro-meter), color corrected','NGC 1128',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28182,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28182,35.01,0.12,100,7492,74.4,NULL,'ABELL 0400, 8 galaxies, WISE I-band','NGC 1128',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28183,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28183,35.05,0.08,103,7492,74.4,NULL,'ABELL 0400, 8 galaxies, WISE W1 (3.4 micro-meter), curved','NGC 1128',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28184,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28184,35.11,0.08,105,7492,74.4,NULL,'ABELL 0400, 8 galaxies, WISE W2 (4.6 micro-meter), curved','NGC 1128',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28185,'BCG','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28185,35.84,0.35,144,7493,60,NULL,'ABELL 0400, BCG','NGC 1128 NED02',0.0231,'1980ApJ...241..486H',1980,1,0.5,NULL,'G',0.00002,NULL,'13.60',0.5,'E;BrClG        RLG','Pair member (points to parent)',NULL,'radio jet','Flat-Spectrum Radio Source',1,44.4231666667,6.02692,0.317,NULL,67924900836,1061326575,16583227,13.6),(28186,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28186,35.37,0.17,119,7493,70,NULL,NULL,'NGC 1128 NED02',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28187,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28187,34.14,0.2,67.3,7494,74.4,NULL,NULL,'2MASX J02574165+0647461',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000071,NULL,'15.19',0.4,'Sc','Group member',NULL,NULL,NULL,1,44.423625,6.79614,0.321,NULL,67969825748,1062028527,16594195,15.19),(28188,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28188,35.11,0.08,105,7495,NULL,NULL,NULL,'2MASX J02574211+0525562',NULL,'2009ApJS..182..474S',2009,1,0.6,'Springob et al. (2005ApJS..160..149S) also give v = 7103 km/sec.','G',0.000009,NULL,'15.36',0.5,'S0/a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,44.425625,5.43206,0.269,NULL,67924789748,1061324839,16583200,15.36),(28189,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28189,35.44,0.2,122,7495,74.4,NULL,NULL,'2MASX J02574211+0525562',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28190,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28190,36.57,0.75,206,7496,70,NULL,NULL,'2MASX J02574222-1421376',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'17.12',0.18,NULL,NULL,NULL,NULL,NULL,1,44.426,-14.36044,0.065,NULL,38104961069,595390016,9302969,17.12),(28191,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28191,35.64,0.09,135,7497,NULL,NULL,NULL,'2MASX J02574457+1539218',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000023,NULL,'14.48',0.5,'Sc',NULL,NULL,NULL,NULL,1,44.43575,15.65614,0.325,NULL,68179938385,1065311537,16645492,14.48),(28192,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28192,34.05,0.49,64.5,7498,75,NULL,'IR','CGCG 415-042',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.000334,NULL,'15.7',0.2,'Scd','Group member',NULL,NULL,NULL,1,44.439,5.95364,0.317,NULL,67924890871,1061326419,16583225,15.7),(28193,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28193,36.36,0.59,187,7499,70,NULL,NULL,'LCRS B025550.4-391823',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00012,NULL,'16.43',0.43,'(R_1)SB0^+',NULL,NULL,NULL,NULL,1,44.44275,-39.10683,0,NULL,38642770827,603793294,9434270,16.43),(28194,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28194,34.84,0.25,92.9,7500,74.4,NULL,NULL,'III Zw 052 NOTES03',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000022,NULL,'15.98',0.3,'E','Group member',NULL,NULL,NULL,1,44.4475833333,6.02767,0.317,NULL,67924900560,1061326571,16583227,15.98),(28195,'IRAS','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28195,34.57,0.8,82,7501,75,NULL,'MAT, I','ESO 356- G 022',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000013,NULL,'13.33',1.3,'SB(r)bc','in a pair',NULL,NULL,NULL,1,44.454833,-36.71792,0.085,NULL,38644765202,603824456,9434757,13.33),(28196,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28196,33.96,0.69,62,7501,100,NULL,'mid-IR','ESO 356- G 022',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28197,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28197,34.15,0.43,67.8,7501,75,NULL,'MAT, I, raw','ESO 356- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28198,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28198,34.29,0.32,72.1,7501,85,NULL,'I, raw','ESO 356- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28199,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28199,34.35,0.46,74.2,7501,NULL,NULL,'J','ESO 356- G 022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28200,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28200,34.35,0.47,74.2,7501,NULL,NULL,'H','ESO 356- G 022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28201,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28201,34.35,0.43,74.3,7501,75,NULL,'MAT, I, cor','ESO 356- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28202,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28202,34.37,0.32,74.9,7501,85,NULL,'I, inv','ESO 356- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28203,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28203,34.38,0.27,75.2,7501,NULL,NULL,'Malmquist cor.','ESO 356- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28204,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28204,34.39,0.45,75.5,7501,NULL,NULL,'K','ESO 356- G 022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28205,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28205,34.49,0.43,79,7501,75,NULL,'MAT, I, inv','ESO 356- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28206,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28206,34.52,0.4,80,7501,NULL,NULL,'mean','ESO 356- G 022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28207,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28207,34.58,0.2,82.4,7501,74.4,NULL,NULL,'ESO 356- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28208,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28208,34.7,0.23,87.1,7501,NULL,NULL,NULL,'ESO 356- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28209,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 03368',NULL,28209,40.33,0.2,1170,7502,70,NULL,'SN photometric redshift distance, z photo =0.322 +/- 0.038','SDSS-II SN 03368',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,44.4559583,1.23083,0.237,NULL,67914947819,1061171059,16580797,NULL),(28210,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 03368','R',28210,41.52,0.28,1460,7502,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03368',0.377482,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28211,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 03368','R',28211,41.52,0.22,1460,7502,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03368',0.377482,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28212,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 03368',NULL,28212,41.5,0.18,2000,7502,70,NULL,'SALT 2','SDSS-II SN 03368',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28213,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 03368',NULL,28213,41.56,0.18,2050,7502,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 03368',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28214,'BCG','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28214,37.84,0.35,345,7503,60,NULL,'ABELL 0399, BCG','UGC 02438',0.0725,'1980ApJ...241..486H',1980,1,1.1,NULL,'G',0.000127,NULL,'16.5',0.9,'cD','Brightest group member',NULL,NULL,NULL,1,44.47125,13.03083,0.401,NULL,68136548140,1064633564,16634899,16.5),(28215,'Tully est','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28215,31.41,0.8,19.1,7504,75,NULL,NULL,'IC 1870',NULL,'1988NBGC.C....0000T',1988,1,2.8,'The position in 1996AJ....111..865D is for the southeastern end of the galaxy.','G',0.000013,NULL,'13.50',1.6,'SB(s)m',NULL,NULL,NULL,NULL,1,44.4730417,-2.34708,0.197,NULL,37850778978,591418421,9240912,13.5),(28216,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28216,31.09,0.4,16.5,7504,NULL,NULL,NULL,'IC 1870',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28217,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28217,31.09,0.4,16.5,7504,73,NULL,'opt','IC 1870',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28218,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28218,31.18,0.2,17.2,7504,74.4,NULL,NULL,'IC 1870',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28219,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28219,31.29,0.43,18.1,7504,75,NULL,'3.6 micron, color corrected','IC 1870',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28220,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28220,31.36,0.43,18.7,7504,75,NULL,'3.6 micron, color + selection bias corrected','IC 1870',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28221,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28221,31.87,0.49,23.6,7504,75,NULL,'IR','IC 1870',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28222,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28222,34.52,0.2,80.2,7505,74.4,NULL,NULL,'MCG +03-08-037',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000018,NULL,'16',0.4,'Sc',NULL,NULL,NULL,NULL,1,44.473417,15.74383,0.409,NULL,68179940840,1065311575,16645493,16),(28223,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28223,35.71,0.08,139,7505,NULL,NULL,NULL,'MCG +03-08-037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28224,'SZ effect','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28224,36.09,NULL,165,7506,NULL,NULL,NULL,'ABELL 0399',NULL,'2005ApJ...625..108D',2005,1,NULL,NULL,'GClstr',0.00044,NULL,NULL,NULL,'I-II   [BM]',NULL,NULL,NULL,NULL,1,44.4850833333,13.01644,0.401,NULL,68136547944,1064633561,16634899,NULL),(28225,'SZ effect','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28225,36.55,NULL,204,7506,NULL,NULL,NULL,'ABELL 0399',NULL,'2001ApJ...555L..11M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28226,'BCG','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28226,37.84,0.35,345,7506,60,NULL,NULL,'ABELL 0399',0.0725,'1980ApJ...241..486H',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28227,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SN 2008gb',NULL,28227,36.24,0.2,171,7507,73.8,NULL,'SALT 2 (SNANA)','UGC 02427',0.0365,'2014ApJ...795...44R',2014,1,1,NULL,'G',NULL,NULL,'16.5',0.5,'Sbc',NULL,NULL,NULL,NULL,1,44.486375,46.86764,0.829,NULL,68581186926,1071581045,16743453,16.5),(28228,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28228,35.69,0.14,138,7508,70,NULL,NULL,'GIN 158',NULL,'2001MNRAS.321..277C',2001,1,0.9,NULL,'G',0.00005,NULL,'14.72',0.4,'E/S0',NULL,NULL,NULL,NULL,1,44.4897917,16.10531,0.409,NULL,68179851338,1065310177,16645471,14.72),(28229,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28229,36.89,0.25,239,7508,74.4,NULL,NULL,'GIN 158',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28230,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28230,35.05,0.58,103,7509,70,NULL,NULL,'MCG -01-08-021',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.4b',0.6,NULL,NULL,NULL,NULL,NULL,1,44.50025,-4.74383,0.181,NULL,37862730788,591605168,9243830,15.4),(28231,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28231,33.12,0.2,42.1,7510,74.4,NULL,NULL,'UGC 02435',NULL,'2013AJ....146...86T',2013,1,2.1,NULL,'G',0.000017,NULL,'14.10',1.7,'SA(s)cd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,44.5140833333,35.25769,0.405,NULL,68719124358,1073736318,16777129,14.1),(28232,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28232,33.29,0.51,45.5,7510,NULL,NULL,NULL,'UGC 02435',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28233,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28233,33.62,0.44,53,7510,NULL,NULL,'Malmquist cor.','UGC 02435',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28234,'TRGB','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28234,28.9,0.1,6.03,7511,74.4,NULL,NULL,'ESO 199- G 007',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000038,NULL,'16.44',0.4,'Dwarf spiral',NULL,NULL,NULL,NULL,1,44.5174166667,-49.38306,0,NULL,38469788467,601090444,9392038,16.44),(28235,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28235,37.29,0.46,287,7512,70,NULL,NULL,'2MASX J02580575-0657169',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000081,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,44.5239583,-6.95464,0.185,NULL,37913235269,592394301,9256160,17.1),(28236,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 17323',NULL,28236,40,0.34,1000,7513,70,NULL,'SN photometric redshift distance, z photo =0.269 +/- 0.055','SDSS-II SN 17323',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,44.52475,-0.46981,0.241,NULL,34896791017,545262359,8519724,NULL),(28237,'IRAS','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28237,33.98,0.8,62.5,7514,75,NULL,'MAT, I','ESO 031- G 005',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000023,NULL,'14.04',0.8,'SAB(rs)bc      HII',NULL,NULL,NULL,NULL,1,44.5275,-74.45661,0.125,NULL,35635639319,556806864,8700107,14.04),(28238,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28238,33.69,0.32,54.6,7514,85,NULL,'I, raw','ESO 031- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28239,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28239,33.74,0.32,56.1,7514,85,NULL,'I, inv','ESO 031- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28240,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28240,33.75,0.47,56.3,7514,NULL,NULL,'H','ESO 031- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28241,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28241,33.78,0.45,57.1,7514,NULL,NULL,'K','ESO 031- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28242,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28242,33.79,0.43,57.2,7514,75,NULL,'MAT, I, raw','ESO 031- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28243,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28243,33.81,0.46,57.9,7514,NULL,NULL,'J','ESO 031- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28244,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28244,34,0.4,63.1,7514,NULL,NULL,'mean','ESO 031- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28245,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28245,34.04,0.43,64.2,7514,75,NULL,'MAT, I, inv','ESO 031- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28246,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28246,34.05,0.43,64.6,7514,75,NULL,'MAT, I, cor','ESO 031- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28247,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28247,34.11,0.33,66.3,7514,NULL,NULL,NULL,'ESO 031- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28248,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28248,34.11,0.33,66.5,7514,NULL,NULL,'Malmquist cor.','ESO 031- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28249,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28249,34.15,0.2,67.6,7514,74.4,NULL,NULL,'ESO 031- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28250,'SNII optical','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SN 2002hj',NULL,28250,34.82,0.05,92,7515,NULL,NULL,'I, photospheric magnitude method','NPM1G +04.0097',NULL,'2014AJ....148..107R',2014,1,NULL,NULL,'G',NULL,NULL,'17.39',NULL,NULL,NULL,NULL,NULL,NULL,1,44.5395,4.68633,0.261,NULL,67927127269,1061361363,16583771,17.39),(28251,'SNII optical','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SN 2002hj',NULL,28251,34.85,0.12,93.3,7515,NULL,NULL,'V, photospheric magnitude method','NPM1G +04.0097',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28252,'SNII optical','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SN 2002hj',NULL,28252,34.9,0.41,95.5,7515,NULL,NULL,'SCM, B','NPM1G +04.0097',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28253,'SNII optical','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SN 2002hj',NULL,28253,34.93,0.28,96.8,7515,NULL,NULL,'SCM, BVI','NPM1G +04.0097',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28254,'SNII optical','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SN 2002hj',NULL,28254,34.93,0.54,96.8,7515,NULL,NULL,'SCM, V','NPM1G +04.0097',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28255,'SNII optical','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SN 2002hj',NULL,28255,34.97,0.53,98.6,7515,NULL,NULL,'SCM, I','NPM1G +04.0097',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28256,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28256,35.14,0.25,107,7516,74.4,NULL,NULL,'GIN 163',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.00004,NULL,'14.35',0.4,'E','Group member',NULL,NULL,NULL,1,44.5592083,5.97181,0.317,NULL,67924894156,1061326471,16583226,14.35),(28257,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28257,35.37,0.17,119,7516,70,NULL,NULL,'GIN 163',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28258,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28258,36.03,0.51,161,7517,70,NULL,NULL,'MCG -01-08-023',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.20',0.3,NULL,NULL,NULL,NULL,NULL,1,44.574,-4.81864,0.181,NULL,37862707585,591604806,9243825,15.2),(28259,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28259,33.15,0.2,42.7,7518,74.4,NULL,NULL,'KUG 0255+321',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000033,NULL,'15.5',0.5,'S',NULL,NULL,NULL,NULL,1,44.578417,32.33592,0.457,NULL,68679845318,1073122583,16767540,15.5),(28260,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28260,32.53,0.43,32,7519,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02443',NULL,'2014MNRAS.444..527S',2014,1,1.3,'The 2MASX position applies to a knot 13 arcsec southwest of the nucleus.','G',0.00011,NULL,'14.36',0.7,'Scd:',NULL,NULL,NULL,NULL,1,44.59,-2.04253,0.197,NULL,37853163482,591455679,9241494,14.36),(28261,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28261,32.6,0.43,33.2,7519,75,NULL,'3.6 micron, color corrected','UGC 02443',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28262,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28262,32.67,0.2,34.2,7519,74.4,NULL,NULL,'UGC 02443',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28263,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28263,32.88,0.39,37.6,7519,73,NULL,'opt','UGC 02443',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28264,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28264,32.88,0.53,37.7,7519,NULL,NULL,NULL,'UGC 02443',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28265,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28265,32.97,0.5,39.3,7519,NULL,NULL,'Malmquist cor.','UGC 02443',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28266,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28266,35.15,0.23,107,7520,74.4,NULL,NULL,'CGCG 415-046',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000033,NULL,'15.4B',0.6,'E','Group member',NULL,NULL,NULL,1,44.587625,6.09514,0.317,NULL,67924686631,1061323228,16583175,15.4),(28267,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28267,35.37,0.17,119,7520,70,NULL,NULL,'CGCG 415-046',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28268,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28268,32.66,0.2,34,7521,74.4,NULL,NULL,'UGC 02441',NULL,'2013AJ....146...86T',2013,1,3.02,NULL,'G',0.000014,NULL,'14.64',0.4,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,44.5920417,3.86275,0.313,NULL,67930766325,1061418223,16584659,14.64),(28269,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28269,32.73,0.58,35.2,7521,NULL,NULL,NULL,'UGC 02441',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28270,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28270,32.76,0.49,35.6,7521,75,NULL,'IR','UGC 02441',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28271,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28271,32.78,NULL,35.9,7521,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02441',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28272,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28272,32.78,NULL,36,7521,NULL,NULL,'Dipole','UGC 02441',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28273,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28273,32.78,NULL,36,7521,NULL,NULL,'Dipole + Quadrupole','UGC 02441',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28274,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28274,32.81,0.56,36.4,7521,NULL,NULL,'Malmquist cor.','UGC 02441',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28275,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28275,32.86,NULL,37.3,7521,NULL,NULL,NULL,'UGC 02441',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28276,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28276,33.06,0.4,41,7521,73,NULL,'opt','UGC 02441',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28277,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28277,33.09,0.4,41.6,7521,NULL,NULL,'mean','UGC 02441',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28278,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28278,33.1,0.47,41.6,7521,NULL,NULL,'H','UGC 02441',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28279,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28279,33.23,0.45,44.3,7521,NULL,NULL,'K','UGC 02441',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28280,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28280,33.28,0.46,45.2,7521,NULL,NULL,'J','UGC 02441',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28281,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28281,31.93,0.43,24.4,7522,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 047',NULL,'2014MNRAS.444..527S',2014,1,2.2,NULL,'G',0.000017,NULL,'14.60',1.1,'SB(rs)d',NULL,NULL,NULL,NULL,1,44.6011666667,-4.29544,0.193,NULL,37865602671,591650041,9244531,14.6),(28282,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28282,35.14,0.25,107,7523,74.4,NULL,NULL,'CGCG 415-047',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000028,NULL,'13.43',0.25,'S0','Group member',NULL,NULL,NULL,1,44.602417,6.59181,0.313,NULL,67969859509,1062029054,16594203,13.43),(28283,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28283,35.37,0.17,119,7523,70,NULL,NULL,'CGCG 415-047',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28284,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28284,34.69,0.45,86.8,7523,NULL,NULL,'K','CGCG 415-047',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28285,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28285,34.85,0.4,93.4,7523,NULL,NULL,'mean','CGCG 415-047',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28286,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 03175',NULL,28286,39.59,0.19,827,7524,70,NULL,'SN photometric redshift distance, z photo =0.216 +/- 0.023','SDSS-II SN 03175',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','22.1g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,44.617125,-0.97056,0.309,NULL,37850341458,591411585,9240806,22.1),(28287,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 03175','R',28287,41.05,0.18,1330,7524,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03175',0.22111,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28288,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 03175','R',28288,41.11,0.23,1360,7524,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03175',0.22111,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28289,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28289,35.53,0.82,127,7525,70,NULL,NULL,'2MASX J02582923-1127132',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,44.6218333333,-11.45372,0.125,NULL,37900594172,592196783,9253074,15),(28290,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28290,36.1,0.54,166,7526,70,NULL,NULL,'2MASX J02582942-0458154',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'16.26',0.36,NULL,NULL,NULL,NULL,NULL,1,44.622667,-4.97103,0.197,NULL,37862706126,591604783,9243824,16.26),(28291,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28291,35.23,0.16,111,7527,74.4,NULL,NULL,'UGC 02444',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000008,NULL,'15.15',0.6,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,44.623625,6.30642,0.317,NULL,67969794963,1062028046,16594188,15.15),(28292,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28292,35.37,0.17,119,7527,70,NULL,NULL,'UGC 02444',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28293,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28293,33.91,0.69,60.5,7527,100,NULL,'mid-IR','UGC 02444',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28294,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28294,34.83,0.4,92.4,7527,NULL,NULL,'mean','UGC 02444',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28295,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28295,34.97,0.43,98.6,7527,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02444',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28296,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28296,34.97,0.47,98.8,7527,NULL,NULL,'H','UGC 02444',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28297,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28297,35.02,0.45,101,7527,NULL,NULL,'K','UGC 02444',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28298,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28298,35.11,0.43,105,7527,75,NULL,'3.6 micron, color corrected','UGC 02444',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28299,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28299,35.14,0.09,107,7527,NULL,NULL,NULL,'UGC 02444',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28300,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28300,35.16,0.46,108,7527,NULL,NULL,'J','UGC 02444',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28301,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28301,35.23,0.16,111,7527,74.4,NULL,NULL,'UGC 02444',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28302,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28302,38.02,0.46,401,7528,70,NULL,NULL,'2MASX J02583000-0021314',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000083,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,44.6249583333,-0.35886,0.241,NULL,34896832288,545263004,8519734,18.2),(28303,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28303,36.22,0.43,175,7529,NULL,NULL,'Malmquist cor.','2MASX J02583317+0557168',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',NULL,NULL,'15.0I',0.2,NULL,NULL,NULL,NULL,NULL,1,44.6382083,5.95464,0.317,NULL,67924705730,1061323527,16583180,15),(28304,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28304,36.39,0.4,190,7529,NULL,NULL,NULL,'2MASX J02583317+0557168',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28305,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28305,39.08,0.46,654,7530,70,NULL,NULL,'2MASX J02583384-0853042',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000098,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,44.6409583,-8.88439,0.169,NULL,37913857205,592404018,9256312,18.2),(28306,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28306,35.72,0.09,140,7531,NULL,NULL,NULL,'2MASX J02583548+1605169',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.00003,NULL,'14.09',0.2,'SBb',NULL,NULL,NULL,NULL,1,44.6478333333,16.08803,0.409,NULL,68181713923,1065339280,16645926,14.09),(28307,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28307,37.2,0.46,276,7532,70,NULL,NULL,'2MASX J02583586+0003589',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00009,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,44.6494583,0.06653,0.229,NULL,66840643251,1044385050,16318516,17.5),(28308,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28308,35.15,0.25,107,7533,74.4,NULL,NULL,'GIN 165',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000037,NULL,'14.47',0.5,'S0/-','Group member',NULL,NULL,NULL,1,44.657583,6.17606,0.317,NULL,67969785721,1062027901,16594185,14.47),(28309,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28309,35.37,0.17,119,7533,70,NULL,NULL,'GIN 165',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28310,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28310,34.96,0.45,98.4,7533,NULL,NULL,'K','GIN 165',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28311,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28311,35.07,0.4,103,7533,NULL,NULL,'mean','GIN 165',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28312,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 16127',NULL,28312,40.45,0.12,1230,7534,70,NULL,'SN photometric redshift distance, z photo =0.344 +/- 0.025','SDSS-II SN 16127',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.5g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,44.667667,0.11747,0.229,NULL,66840647770,1044385121,16318517,21.5),(28313,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 16127','R',28313,41.58,0.26,1510,7534,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16127',0.375227,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28314,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 16127','R',28314,41.72,0.25,1610,7534,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16127',0.375227,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28315,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 16127',NULL,28315,41.26,0.19,1790,7534,70,NULL,'SALT 2','SDSS-II SN 16127',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28316,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 16127',NULL,28316,41.32,0.19,1840,7534,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16127',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28317,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28317,37.33,0.46,292,7535,70,NULL,NULL,'2MASX J02584135-0749102',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000088,NULL,'17.6g',0.21,'NLAGN',NULL,NULL,NULL,NULL,1,44.67225,-7.81958,0.201,NULL,37916166748,592440105,9256876,17.6),(28318,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28318,35.87,0.46,149,7536,70,NULL,NULL,'2MASX J02584141-0743112',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000091,NULL,'16.7g',0.22,'NLAGN',NULL,NULL,NULL,NULL,1,44.67275,-7.71972,0.201,NULL,37916142968,592439733,9256870,16.7),(28319,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28319,34.31,0.2,72.8,7537,74.4,NULL,NULL,'2MASX J02584461+0625229',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000022,NULL,'15.54',0.3,'S+','Group member',NULL,NULL,NULL,1,44.685875,6.42297,0.333,NULL,67969775804,1062027746,16594183,15.54),(28320,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28320,36.4,0.45,190,7538,NULL,NULL,'Malmquist cor.','2MASX J02584506+0606346',NULL,'2009ApJS..182..474S',2009,1,0.25,NULL,'G',NULL,NULL,'14.70',0.17,NULL,NULL,NULL,NULL,NULL,1,44.68775,6.10964,0.317,NULL,67924681381,1061323146,16583174,14.7),(28321,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28321,36.62,0.4,211,7538,NULL,NULL,NULL,'2MASX J02584506+0606346',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28322,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28322,34.8,0.2,91.2,7539,74.4,NULL,NULL,'GALEXASC J025845.84+051854.7',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000011,NULL,'15.49',0.4,'Sc','Group member',NULL,NULL,NULL,1,44.6900417,5.31597,0.269,NULL,67927681291,1061370020,16583906,15.49),(28323,'Tully est','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28323,32.89,0.8,37.8,7540,75,NULL,NULL,'UGC 02411',NULL,'1988NBGC.C....0000T',1988,1,4.37,NULL,'G',0.000037,NULL,'16.5',0.34,'Sdm',NULL,NULL,NULL,NULL,1,44.6975417,75.74447,1.441,NULL,65713473833,1026773028,16043328,16.5),(28324,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28324,32.26,NULL,28.3,7540,NULL,NULL,NULL,'UGC 02411',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28325,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28325,32.41,NULL,30.3,7540,NULL,NULL,'Dipole','UGC 02411',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28326,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28326,32.41,NULL,30.3,7540,NULL,NULL,'Dipole + Quadrupole','UGC 02411',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28327,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28327,32.42,NULL,30.5,7540,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02411',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28328,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28328,32.57,0.2,32.7,7540,74.4,NULL,NULL,'UGC 02411',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28329,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28329,32.58,0.4,32.8,7540,75,NULL,NULL,'UGC 02411',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28330,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28330,32.59,0.49,33,7540,75,NULL,'IR','UGC 02411',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28331,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28331,32.79,0.43,36.1,7540,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02411',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28332,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28332,32.82,0.43,36.6,7540,75,NULL,'3.6 micron, color corrected','UGC 02411',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28333,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28333,33.73,0.47,55.6,7541,NULL,NULL,'H','NGC 1165',NULL,'2007A&A...465...71T',2007,1,2.5,NULL,'G',0.000023,NULL,'13.92',1,'(R\':)SB:(rl)a',NULL,NULL,NULL,NULL,1,44.6987083333,-32.09919,0,NULL,38617120253,603392503,9428007,13.92),(28334,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28334,33.73,0.45,55.8,7541,NULL,NULL,'K','NGC 1165',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28335,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28335,33.77,0.46,56.7,7541,NULL,NULL,'J','NGC 1165',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28336,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28336,33.79,0.49,57.2,7541,75,NULL,'IR','NGC 1165',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28337,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28337,34.12,0.4,66.7,7541,NULL,NULL,'mean','NGC 1165',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28338,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28338,37.86,0.46,373,7542,70,NULL,NULL,'2MASX J02584931-0756418',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000078,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,44.7054583333,-7.945,0.197,NULL,37916163695,592440057,9256875,17.1),(28339,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28339,34.67,0.49,85.9,7543,75,NULL,'IR','2MFGC 02414',NULL,'2011yCatp016004901K',2011,1,0.6,NULL,'G',0.000042,NULL,'16.99',0.1,NULL,NULL,NULL,NULL,NULL,1,44.7075,6.25797,0.317,NULL,67969809037,1062028266,16594191,16.99),(28340,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28340,36.08,0.61,164,7544,70,NULL,NULL,'2MASX J02585064-1037178',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.00015,NULL,'16.11',0.35,'S0','Field galaxy',NULL,NULL,NULL,1,44.7112083333,-10.62167,0.157,NULL,37903266894,592238545,9253727,16.11),(28341,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28341,34.78,0.23,90.4,7545,74.4,NULL,NULL,'GIN 166',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000019,NULL,'14.65',0.3,'SB0','Group member',NULL,NULL,NULL,1,44.7259583333,6.11656,0.317,NULL,67924713675,1061323651,16583182,14.65),(28342,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28342,35.37,0.17,119,7545,70,NULL,NULL,'GIN 166',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28343,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28343,36.22,0.46,175,7546,70,NULL,NULL,'2MASX J02585533-0643278',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000098,NULL,'16.3g',0.29,'AGN',NULL,NULL,NULL,NULL,1,44.7304583333,-6.72444,0.185,NULL,37912442932,592381920,9255967,16.3),(28344,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28344,36.78,0.62,227,7546,70,NULL,NULL,'2MASX J02585533-0643278',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28345,'SBF','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28345,33.08,0.31,41.4,7547,NULL,NULL,'I','NGC 1162',NULL,'2001ApJ...546..681T',2001,1,1.4,NULL,'G',0.00008,NULL,'13.55',1.4,'E:',NULL,NULL,NULL,NULL,1,44.733333,-12.39858,0.101,NULL,38092729692,595198901,9299982,13.55),(28346,'SBF','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28346,33.11,0.14,41.9,7547,74.4,NULL,NULL,'NGC 1162',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28347,'SZ effect','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28347,37.84,NULL,369,7548,NULL,NULL,NULL,'ABELL 0401',NULL,'2005ApJ...625..108D',2005,1,NULL,NULL,'GClstr',0.00036,NULL,NULL,NULL,'I      [BM]',NULL,NULL,NULL,NULL,1,44.739583,13.57944,0.381,NULL,68166632256,1065103629,16642244,NULL),(28348,'SZ effect','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28348,38.24,NULL,444,7548,NULL,NULL,NULL,'ABELL 0401',NULL,'2001ApJ...555L..11M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28349,'BCG','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28349,37.77,0.35,333,7548,60,NULL,NULL,'ABELL 0401',0.0752,'1980ApJ...241..486H',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28350,'BCG','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28350,37.77,0.35,333,7549,60,NULL,'ABELL 0401, BCG','UGC 02450',0.0752,'1980ApJ...241..486H',1980,1,1.1,NULL,'G',0.000193,NULL,'15.32',0.9,'cD','Brightest group member',NULL,NULL,NULL,1,44.740875,13.58281,0.381,NULL,68166632002,1065103625,16642244,15.32),(28351,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28351,38.24,0.46,444,7550,70,NULL,NULL,'2MASX J02590025+0047546',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000086,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,44.751167,0.79856,0.225,NULL,67915080093,1061173126,16580830,18.1),(28352,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 17482','RN',28352,39.33,0.09,647,7551,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 17482 HOST',0.134653,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28353,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 19629','RN',28353,39.33,0.09,647,7551,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 17482 HOST',0.134631,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28354,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 17482','RN',28354,39.64,0.19,748,7551,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 17482 HOST',0.134653,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28355,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 19629','RN',28355,39.67,0.2,757,7551,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 17482 HOST',0.134631,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28356,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28356,35.46,0.53,123,7552,70,NULL,NULL,'2MASX J02590389-1425067',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.01',0.19,NULL,NULL,NULL,NULL,NULL,1,44.7660417,-14.41856,0.085,NULL,38105220657,595394072,9303032,16.01),(28357,'IRAS','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28357,35.97,0.8,156,7553,75,NULL,'W91PP, r','UGC 02447',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'17.',0.1,'Sbc',NULL,NULL,NULL,NULL,1,44.76825,32.63053,0.457,NULL,68679643344,1073119427,16767491,17),(28358,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28358,35.98,0.49,157,7553,75,NULL,'IR','UGC 02447',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28359,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28359,36.09,0.38,165,7553,75,NULL,'W91PP, r, raw','UGC 02447',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28360,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28360,36.32,0.38,183,7553,75,NULL,'W91PP, r, cor','UGC 02447',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28361,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28361,36.34,0.38,185,7553,75,NULL,'W91PP, r, inv','UGC 02447',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28362,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 20979','RN',28362,38.96,0.19,551,7554,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 20979',0.126833,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28363,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 20979','RN',28363,39.22,0.23,621,7554,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20979',0.126833,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28364,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28364,35.93,0.54,154,7555,70,NULL,NULL,'LCRS B025721.0-412315',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.51',0.32,NULL,NULL,NULL,NULL,NULL,1,44.8064583,-41.18922,0,NULL,38503806843,601621981,9400343,16.51),(28365,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28365,35.31,0.2,115,7556,74.4,NULL,NULL,'UGC 02453',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.00002,NULL,'15.07',0.9,'SAB(s)b',NULL,NULL,NULL,NULL,1,44.8120416667,16.03822,0.385,NULL,68181772844,1065340200,16645940,15.07),(28366,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28366,35.57,0.4,130,7556,NULL,NULL,'mean','UGC 02453',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28367,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28367,35.73,0.47,140,7556,NULL,NULL,'H','UGC 02453',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28368,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28368,35.88,0.1,150,7556,NULL,NULL,NULL,'UGC 02453',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28369,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28369,35.16,0.25,108,7557,74.4,NULL,NULL,'CGCG 415-050',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000032,NULL,'14.28',0.8,'S0/a','Group member',NULL,NULL,NULL,1,44.8170833333,6.13347,0.317,NULL,67924662687,1061322854,16583169,14.28),(28370,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28370,35.37,0.17,119,7557,70,NULL,NULL,'CGCG 415-050',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28371,'IRAS','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28371,34.97,0.8,98.8,7558,75,NULL,'W91CL, r','UGC 02454',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000013,NULL,'15.97',0.3,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,44.8182083,7.30522,0.385,NULL,67977889395,1062154521,16596164,15.97),(28372,'IRAS','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28372,34.98,0.8,98.9,7558,75,NULL,'HMCL, I','UGC 02454',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28373,'IRAS','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28373,34.98,0.8,98.9,7558,75,NULL,'CF, r','UGC 02454',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28374,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28374,34.76,0.4,89.5,7558,75,NULL,'HMCL, I, raw','UGC 02454',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28375,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28375,34.76,0.49,89.5,7558,75,NULL,'IR','UGC 02454',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28376,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28376,34.88,0.38,94.5,7558,75,NULL,'W91CL, r, raw','UGC 02454',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28377,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28377,34.88,0.2,94.6,7558,74.4,NULL,NULL,'UGC 02454',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28378,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28378,34.91,0.4,96.1,7558,75,NULL,'HMCL, I, inv','UGC 02454',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28379,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28379,34.96,0.38,98.3,7558,75,NULL,'CF, r, raw','UGC 02454',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28380,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28380,34.97,0.43,98.7,7558,75,NULL,'3.6 micron, color corrected','UGC 02454',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28381,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28381,34.99,0.38,99.5,7558,75,NULL,'W91CL, r, inv','UGC 02454',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28382,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28382,35,0.16,100,7558,NULL,NULL,NULL,'UGC 02454',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28383,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28383,35.01,0.4,101,7558,75,NULL,'HMCL, I, cor','UGC 02454',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28384,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28384,35.08,0.43,104,7558,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02454',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28385,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28385,35.07,0.38,104,7558,75,NULL,'W91CL, r, cor','UGC 02454',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28386,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28386,35.08,0.38,104,7558,75,NULL,'CF, r, inv','UGC 02454',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28387,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28387,35.13,0.38,106,7558,75,NULL,'CF, r, cor','UGC 02454',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28388,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28388,36.76,0.92,225,7559,70,NULL,NULL,'FGC 0369',NULL,'2014MNRAS.445.2677S',2014,1,1.23,NULL,'G',0.00015,NULL,'16.5',0.11,'Sbc',NULL,NULL,NULL,NULL,1,44.819125,-14.84611,0.109,NULL,38104380262,595380941,9302827,16.5),(28389,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28389,36.2,0.66,174,7560,70,NULL,NULL,'2MASX J02591730-7802495',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.00015,NULL,'16.7b',0.24,NULL,NULL,NULL,NULL,NULL,1,44.8217917,-78.04703,0.401,NULL,35697745463,557777272,8715269,16.7),(28390,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28390,35.82,0.08,146,7561,NULL,NULL,NULL,'2MASX J02592215+1615327',NULL,'2009ApJS..182..474S',2009,1,0.78,NULL,'G',0.000023,NULL,'14.67',NULL,'Sbc',NULL,NULL,NULL,NULL,1,44.8422917,16.25908,0.365,NULL,68181732746,1065339574,16645930,14.67),(28391,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 13208','RN',28391,39.59,0.14,662,7562,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13208',0.250924,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28392,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 13208','RN',28392,40.44,0.22,979,7562,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13208',0.250924,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28393,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28393,35.24,0.46,112,7563,70,NULL,NULL,'2MASX J02592321-0110000',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000064,NULL,'15.9g',0.33,'S0',NULL,NULL,NULL,NULL,1,44.846667,-1.16667,0.305,NULL,37850220682,591409698,9240776,15.9),(28394,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28394,35.43,0.58,122,7563,70,NULL,NULL,'2MASX J02592321-0110000',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28395,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28395,36.64,0.41,213,7564,NULL,NULL,'Malmquist cor.','UGC 02451',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',NULL,NULL,'16.5',0.3,'Scd:',NULL,NULL,NULL,NULL,1,44.885375,37.00919,0.485,NULL,68710259123,1073597798,16774965,16.5),(28396,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28396,36.94,0.35,245,7564,NULL,NULL,NULL,'UGC 02451',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28397,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28397,37.09,0.2,262,7564,74.4,NULL,NULL,'UGC 02451',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28398,'Brightest Stars','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28398,29.16,NULL,6.79,7565,NULL,NULL,'Red','NGC 1156',NULL,'2012PASJ...64...23K',2012,1,3.3,NULL,'G',0.000005,NULL,'12.32',2.5,'IB(s)m         HII','Possible group member',NULL,NULL,NULL,1,44.92625,25.23783,0.657,NULL,68081944067,1063780376,16621568,12.32),(28399,'Brightest Stars','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28399,29.39,0.2,7.6,7565,NULL,NULL,'Weighted mean','NGC 1156',NULL,'2012PASJ...64...23K',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28400,'Brightest Stars','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28400,29.46,0.15,7.8,7565,NULL,NULL,NULL,'NGC 1156',NULL,'1996A&A...310..722K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28401,'Brightest Stars','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28401,29.55,NULL,8.13,7565,NULL,NULL,'Blue','NGC 1156',NULL,'2012PASJ...64...23K',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28402,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28402,29.02,0.4,6.4,7565,75,NULL,'B','NGC 1156',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28403,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 15511',NULL,28403,39.87,0.41,943,7566,70,NULL,'SN photometric redshift distance, z photo =0.251 +/- 0.062','SDSS-II SN 15511',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,44.93025,-0.95519,0.305,NULL,37850386689,591412292,9240817,NULL),(28404,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28404,36.15,0.52,170,7567,70,NULL,NULL,'2MASX J02594466-7314501',NULL,'2014MNRAS.445.2677S',2014,1,0.28,NULL,'G',0.00015,NULL,'15.9b',0.24,NULL,NULL,NULL,NULL,NULL,1,44.9360417,-73.24728,0.165,NULL,36440369737,569380777,8896574,15.9),(28405,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28405,36.41,0.58,192,7568,70,NULL,NULL,'FAIRALL 1250',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'15.8B',0.58,NULL,NULL,NULL,NULL,NULL,1,44.942167,-78.45486,0.385,NULL,35698716804,557792450,8715507,15.8),(28406,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28406,36.14,0.54,169,7569,70,NULL,NULL,'2MASX J02594812-7839257',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'16.2b',0.25,NULL,NULL,NULL,NULL,NULL,1,44.95025,-78.65711,0.353,NULL,35698558434,557789975,8715468,16.2),(28407,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28407,34.76,0.25,89.5,7570,74.4,NULL,NULL,'2MASX J02594859+0544338',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000022,NULL,'15.72',NULL,'E','Group member',NULL,NULL,NULL,1,44.9524166667,5.74253,0.293,NULL,67926991308,1061359239,16583738,15.72),(28408,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28408,33.53,0.2,50.8,7571,74.4,NULL,NULL,'KUG 0257+028',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.00011,NULL,'15.6',0.25,NULL,NULL,NULL,NULL,NULL,1,44.9585,3.083,0.297,NULL,67928064831,1061376012,16584000,15.6),(28409,'Sosies','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28409,34.05,0.75,64.6,7572,NULL,NULL,NULL,'IC 0277',NULL,'2002A&A...393...57T',2002,1,1.2,NULL,'G',0.000013,NULL,'13.87',0.9,'SB(rs)bc       Sbrst','Group member, radial-velocity confirmed',NULL,NULL,'Starburst',1,44.960833,2.77136,0.273,NULL,67917367476,1061208866,16581388,13.87),(28410,'Tully est','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28410,32.67,0.8,34.2,7572,75,NULL,'B','IC 0277',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28411,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 05406','RN',28411,37.93,0.19,349,7573,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 05406',0.101611,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28412,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28412,35.17,0.25,108,7574,74.4,NULL,NULL,'CGCG 415-051',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000018,NULL,'15.33',0.4,'Sab','Group member',NULL,NULL,NULL,1,44.967833,6.53292,0.333,NULL,67977302898,1062145357,16596021,15.33),(28413,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28413,35.37,0.17,119,7574,70,NULL,NULL,'CGCG 415-051',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28414,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 17880','R',28414,37.47,0.19,291,7575,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007jd','SN 2007jd',0.072673,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,44.972375,1.16072,0.225,NULL,67914978243,1061171535,16580805,NULL),(28415,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 17880','R',28415,37.79,0.08,337,7575,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007jd','SN 2007jd',0.072673,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28416,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28416,36.76,0.46,225,7576,NULL,NULL,'Malmquist cor.','2MASX J02595448+0544208',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',NULL,NULL,'16.62',0.2,NULL,NULL,NULL,NULL,NULL,1,44.977125,5.73914,0.293,NULL,67926991010,1061359234,16583738,16.62),(28417,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28417,37.09,0.39,261,7576,NULL,NULL,NULL,'2MASX J02595448+0544208',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28418,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28418,33.56,0.4,51.6,7577,NULL,NULL,'mean','UGC 02456',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000073,NULL,'13.64',1,'(R)SB(s)0+     Sy2',NULL,NULL,'radio jet','Sy 2',1,44.994125,36.82064,0.513,NULL,68710101643,1073595338,16774927,13.64),(28419,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28419,33.57,0.45,51.8,7577,NULL,NULL,'K','UGC 02456',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28420,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28420,35.17,0.25,108,7578,74.4,NULL,NULL,'MCG +01-08-034',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000006,NULL,'14.79',0.5,'Sbc','Group member',NULL,NULL,NULL,1,44.9996666667,5.96747,0.289,NULL,67926766416,1061355725,16583683,14.79),(28421,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28421,35.37,0.17,119,7578,70,NULL,NULL,'MCG +01-08-034',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28422,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28422,36.04,0.71,161,7579,70,NULL,NULL,'2MASX J03000494-1207548',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.73',0.32,NULL,NULL,NULL,NULL,NULL,1,45.0205,-12.13197,0.129,NULL,37899790501,592184226,9252878,16.73),(28423,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28423,36.63,0.7,212,7580,70,NULL,NULL,'2MASX J03000596-0117157',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'16.52',0.27,NULL,NULL,NULL,NULL,NULL,1,45.0247917,-1.28772,0.297,NULL,37850250815,591410168,9240783,16.52),(28424,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28424,35.14,0.25,107,7581,74.4,NULL,NULL,'CGCG 415-052',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.00005,NULL,'14.05',0.5,'SA0/a:','Group member',NULL,NULL,NULL,1,45.035875,5.80456,0.293,NULL,67926803975,1061356312,16583692,14.05),(28425,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28425,35.37,0.17,119,7581,70,NULL,NULL,'CGCG 415-052',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28426,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28426,34.86,0.4,93.8,7581,NULL,NULL,'mean','CGCG 415-052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28427,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28427,35.17,0.45,108,7581,NULL,NULL,'K','CGCG 415-052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28428,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 06638','R',28428,40.57,0.23,981,7582,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J030009.25-011415.2',0.3257,'2014arXiv1401.3317S',2014,1,0.11,NULL,'G',0.0001,NULL,'20.6g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,45.0385417,-1.23756,0.297,NULL,37850237092,591409954,9240780,20.6),(28429,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 06638','R',28429,40.73,0.3,1060,7582,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J030009.25-011415.2',0.3257,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28430,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 06638',NULL,28430,40.51,0.25,1260,7582,70,NULL,'SALT 2','SDSS J030009.25-011415.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28431,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 06638',NULL,28431,40.55,0.25,1290,7582,70,NULL,'SALT 2, Malmquist cor.','SDSS J030009.25-011415.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28432,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28432,34.33,0.43,73.4,7583,75,NULL,'3.6 micron, color + selection bias corrected','MCG +01-08-036',NULL,'2014MNRAS.444..527S',2014,1,0.5,NULL,'G',0.000024,NULL,'15.15',0.4,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,45.0401666667,5.71178,0.293,NULL,67926973990,1061358968,16583733,15.15),(28433,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28433,34.46,0.43,77.9,7583,75,NULL,'3.6 micron, color corrected','MCG +01-08-036',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28434,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28434,34.56,0.2,81.7,7583,74.4,NULL,NULL,'MCG +01-08-036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28435,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28435,35,0.09,100,7583,NULL,NULL,NULL,'MCG +01-08-036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28436,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 08047','RN',28436,41.88,17.17,2190,7584,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08047',0.088124,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28437,'IRAS','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28437,32.91,0.8,38.2,7585,75,NULL,'MAT, I','ESO 546- G 036',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'15.5',0.8,'Sc',NULL,NULL,NULL,NULL,1,45.064917,-22.29031,0.009,NULL,38053927610,594592618,9290509,15.5),(28438,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28438,33.03,0.32,40.3,7585,85,NULL,'I, inv','ESO 546- G 036',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28439,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28439,33.06,0.32,40.9,7585,85,NULL,'I, raw','ESO 546- G 036',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28440,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28440,33.36,0.4,47,7585,73,NULL,'opt','ESO 546- G 036',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28441,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28441,33.48,0.43,49.6,7585,75,NULL,'MAT, I, inv','ESO 546- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28442,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28442,33.54,0.43,51.1,7585,75,NULL,'MAT, I, raw','ESO 546- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28443,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28443,33.81,0.99,57.8,7585,NULL,NULL,'Malmquist cor.','ESO 546- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28444,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28444,33.85,0.97,58.8,7585,NULL,NULL,NULL,'ESO 546- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28445,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28445,33.85,0.43,58.9,7585,75,NULL,'MAT, I, cor','ESO 546- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28446,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28446,33.89,0.2,60,7585,74.4,NULL,NULL,'ESO 546- G 036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28447,'IRAS','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28447,32.38,0.8,29.9,7586,75,NULL,'MAT, I','NGC 1163',NULL,'1997ApJS..109..333W',1997,1,2.91,NULL,'G',0.000013,NULL,'14.66',0.37,'SBbc? sp',NULL,NULL,NULL,NULL,1,45.0920417,-17.15253,0.049,NULL,38117444129,595585064,9306016,14.66),(28448,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28448,32.06,0.32,25.8,7586,85,NULL,'I, raw','NGC 1163',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28449,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28449,32.06,0.32,25.8,7586,85,NULL,'I, inv','NGC 1163',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28450,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28450,32.22,0.43,27.8,7586,75,NULL,'MAT, I, raw','NGC 1163',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28451,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28451,32.27,0.43,28.5,7586,75,NULL,'MAT, I, inv','NGC 1163',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28452,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28452,32.33,0.43,29.3,7586,75,NULL,'MAT, I, cor','NGC 1163',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28453,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28453,32.36,0.47,29.6,7586,NULL,NULL,'H','NGC 1163',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28454,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28454,32.38,0.4,29.9,7586,NULL,NULL,'mean','NGC 1163',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28455,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28455,32.39,0.11,30.1,7586,NULL,NULL,NULL,'NGC 1163',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28456,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28456,32.39,0.39,30.1,7586,73,NULL,'IR','NGC 1163',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28457,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28457,32.39,0.4,30.1,7586,75,NULL,NULL,'NGC 1163',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28458,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28458,32.45,0.46,30.9,7586,NULL,NULL,'J','NGC 1163',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28459,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28459,32.47,0.45,31.2,7586,NULL,NULL,'K','NGC 1163',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28460,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28460,32.69,0.4,34.5,7586,73,NULL,'opt','NGC 1163',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28461,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28461,32.75,0.43,35.4,7586,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1163',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28462,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28462,32.86,0.43,37.4,7586,75,NULL,'3.6 micron, color corrected','NGC 1163',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28463,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28463,32.91,0.49,38.3,7586,75,NULL,'IR','NGC 1163',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28464,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28464,32.99,0.4,39.6,7586,NULL,NULL,NULL,'NGC 1163',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28465,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28465,33.01,0.2,40,7586,74.4,NULL,NULL,'NGC 1163',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28466,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28466,33.22,NULL,44,7586,NULL,NULL,'Dipole','NGC 1163',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28467,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28467,33.22,NULL,44,7586,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 1163',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28468,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28468,33.23,NULL,44.2,7586,NULL,NULL,'Dipole + Quadrupole','NGC 1163',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28469,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28469,34.54,0.42,80.8,7587,NULL,NULL,'Malmquist cor.','UGC 02461',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.43',0.5,'SAd',NULL,NULL,NULL,NULL,1,45.0946666667,34.07244,0.477,NULL,68717336508,1073708382,16776693,15.43),(28470,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28470,34.55,0.2,81.3,7587,74.4,NULL,NULL,'UGC 02461',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28471,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28471,34.67,0.39,85.9,7587,NULL,NULL,NULL,'UGC 02461',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28472,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 03959','R',28472,40.09,0.19,880,7588,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03959',0.1833,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,45.097917,0.51189,0.233,NULL,67914405612,1061162587,16580665,NULL),(28473,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 03959','R',28473,40.19,0.26,923,7588,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03959',0.1833,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28474,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 21272','RN',28474,39.79,0.42,877,7589,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 21272',0.03735,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28475,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 21272','RN',28475,39.97,0.25,952,7589,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 21272',0.03735,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28476,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28476,36.26,0.54,179,7590,70,NULL,NULL,'2MASX J03002658-1053595',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'16.29',0.47,'E','Field galaxy',NULL,NULL,NULL,1,45.1107083,-10.89981,0.149,NULL,37900065632,592188525,9252945,16.29),(28477,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28477,35.16,0.2,108,7591,74.4,NULL,NULL,'FGC 049A',NULL,'2013AJ....146...86T',2013,1,1.01,NULL,'G',0.000016,NULL,'16.02',0.17,NULL,NULL,NULL,NULL,NULL,1,45.1160417,5.31869,0.321,NULL,67927637025,1061369328,16583895,16.02),(28478,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28478,38.01,0.46,400,7592,70,NULL,NULL,'2MASX J03002856-0047027',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000101,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,45.1189583,-0.78408,0.305,NULL,37850269829,591410466,9240788,17.6),(28479,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28479,35.89,0.46,151,7593,70,NULL,NULL,'2MASX J03002980-0710385',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000089,NULL,'15.9g',0.44,'E0',NULL,NULL,NULL,NULL,1,45.124333,-7.17722,0.249,NULL,37913337679,592395901,9256185,15.9),(28480,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28480,35.48,0.4,125,7594,NULL,NULL,'mean','MCG -02-08-039',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00002,NULL,'14.4b',0.9,'SAB(rs)a pec:  Sy2','Field galaxy',NULL,NULL,NULL,1,45.1274583,-11.41572,0.137,NULL,37900689779,592198277,9253098,14.4),(28481,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28481,35.51,0.47,127,7594,NULL,NULL,'H','MCG -02-08-039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28482,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28482,35.52,0.43,127,7594,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-08-039',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28483,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28483,35.55,0.45,129,7594,NULL,NULL,'K','MCG -02-08-039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28484,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28484,35.68,0.46,137,7594,NULL,NULL,'J','MCG -02-08-039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28485,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 01226','RN',28485,39.9,0.2,795,7595,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 01226',0.198337,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28486,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 01226','RN',28486,41.67,0.35,1800,7595,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 01226',0.198337,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28487,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28487,35.35,0.11,118,7596,NULL,NULL,NULL,'NGC 1166',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000113,NULL,'14.86',1.1,'Sab','Pair member (points to parent)',NULL,NULL,NULL,1,45.145833,11.84278,0.741,NULL,67964726417,1061948850,16592950,14.86),(28488,'Tully est','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28488,32.7,0.8,34.7,7597,75,NULL,NULL,'UGC 02459',NULL,'1988NBGC.C....0000T',1988,1,2.37,NULL,'G',0.000037,NULL,'18.',0.17,'Sdm',NULL,NULL,NULL,NULL,1,45.15325,49.04397,NULL,NULL,68531558389,1070805599,16731337,18),(28489,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28489,32.33,0.4,29.2,7597,75,NULL,NULL,'UGC 02459',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28490,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28490,32.65,0.43,33.8,7597,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02459',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28491,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28491,32.8,0.49,36.3,7597,75,NULL,'IR','UGC 02459',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28492,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28492,32.9,0.43,38,7597,75,NULL,'3.6 micron, color corrected','UGC 02459',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28493,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28493,32.91,0.2,38.2,7597,74.4,NULL,NULL,'UGC 02459',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28494,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28494,33.03,NULL,40.4,7597,NULL,NULL,NULL,'UGC 02459',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28495,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28495,33.17,NULL,43,7597,NULL,NULL,'Dipole + Quadrupole','UGC 02459',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28496,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28496,33.19,NULL,43.4,7597,NULL,NULL,'Dipole','UGC 02459',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28497,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28497,33.19,NULL,43.4,7597,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02459',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28498,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28498,37.9,0.46,380,7598,70,NULL,NULL,'SDSS J030036.88-072850.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000055,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,45.1537083,-7.48067,0.213,NULL,37913006256,592390722,9256105,18.6),(28499,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28499,33.21,0.47,43.9,7599,NULL,NULL,'H','UGC 02465',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000033,NULL,'14.77',0.3,'Sa:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,45.155875,35.16908,0.513,NULL,68719427190,1073741049,16777203,14.77),(28500,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28500,33.36,0.45,46.9,7599,NULL,NULL,'K','UGC 02465',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28501,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28501,33.41,0.46,48.1,7599,NULL,NULL,'J','UGC 02465',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28502,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28502,34.14,0.4,67.2,7599,NULL,NULL,'mean','UGC 02465',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28503,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28503,32.14,0.4,26.8,7600,75,NULL,'B','UGC 02463',NULL,'1988NBGC.C....0000T',1988,1,2.3,NULL,'G',0.000006,NULL,'14.4',1.5,'SABm',NULL,NULL,NULL,NULL,1,45.155833,40.25131,0.449,NULL,68690132191,1073283315,16770051,14.4),(28504,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28504,32.56,0.2,32.5,7600,74.4,NULL,NULL,'UGC 02463',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28505,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28505,32.9,0.4,38,7600,NULL,NULL,NULL,'UGC 02463',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28506,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28506,36.67,0.46,216,7601,70,NULL,NULL,'2MASX J03003969-0820534',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000074,NULL,'17.0g',0.26,'NLAGN',NULL,NULL,NULL,NULL,1,45.1654583,-8.34828,0.197,NULL,37916420906,592444076,9256938,17),(28507,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28507,33.47,0.2,49.4,7602,74.4,NULL,NULL,'UGC 02479',NULL,'2013AJ....146...86T',2013,1,1.24,NULL,'G',0.00002,NULL,'15.7g',0.36,'Sdm: sp',NULL,NULL,NULL,NULL,1,45.1675417,0.02047,0.285,NULL,64961385353,1015021646,15859713,15.7),(28508,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28508,33.59,0.52,52.2,7602,NULL,NULL,NULL,'UGC 02479',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28509,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28509,33.69,0.5,54.7,7602,NULL,NULL,'Malmquist cor.','UGC 02479',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28510,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28510,37.48,0.33,313,7603,70,NULL,NULL,'2MASX J03004084+0102597',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000112,NULL,'16.9g',0.1,NULL,NULL,NULL,NULL,NULL,1,45.170125,1.04997,0.237,NULL,67915179906,1061174686,16580854,16.9),(28511,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28511,37.81,0.46,364,7604,70,NULL,NULL,'SDSS J030042.17+005810.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000079,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,45.1757083333,0.96953,0.229,NULL,67915109331,1061173583,16580837,18.7),(28512,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28512,35.9,0.51,151,7605,70,NULL,NULL,'2MASX J03004221-1052474',NULL,'2014MNRAS.445.2677S',2014,1,0.91,NULL,'G',0.00015,NULL,'16.08',0.36,'S-','Field galaxy',NULL,NULL,NULL,1,45.17575,-10.87997,0.149,NULL,37900071770,592188621,9252947,16.08),(28513,'IRAS','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28513,33.72,0.8,55.5,7606,75,NULL,'MAT, I','ESO 546- G 037',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'14.97',0.6,'SB?',NULL,NULL,NULL,NULL,1,45.1771666667,-22.14003,0,NULL,38052042124,594563158,9290049,14.97),(28514,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28514,32.92,0.32,38.4,7606,85,NULL,'I, inv','ESO 546- G 037',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28515,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28515,32.94,0.32,38.7,7606,85,NULL,'I, raw','ESO 546- G 037',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28516,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28516,33.05,0.2,40.7,7606,74.4,NULL,NULL,'ESO 546- G 037',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28517,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28517,33.22,0.43,44,7606,75,NULL,'MAT, I, raw','ESO 546- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28518,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28518,33.22,0.43,44.1,7606,75,NULL,'MAT, I, inv','ESO 546- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28519,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28519,33.53,0.43,50.8,7606,75,NULL,'MAT, I, cor','ESO 546- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28520,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 06273','RN',28520,43.25,0.36,2800,7607,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 06273',0.599034,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28521,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28521,31.43,0.2,19.3,7608,74.4,NULL,NULL,'NGC 1159',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000017,NULL,'14.2',0.45,'Spiral HSB',NULL,NULL,NULL,NULL,1,45.1938333333,43.16256,0.649,NULL,68571802855,1071434419,16741162,14.2),(28522,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28522,37.48,0.33,313,7609,70,NULL,NULL,'2MASX J03004704+0107368',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000077,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,45.1960833333,1.12686,0.237,NULL,67915173497,1061174585,16580852,18),(28523,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28523,37.43,0.46,307,7610,70,NULL,NULL,'2MASX J03005089-0705235',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00008,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,45.211833,-7.08983,0.249,NULL,37913218669,592394041,9256156,16.9),(28524,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 00792','RN',28524,39.47,0.21,751,7611,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 00792',0.043516,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28525,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 00792','RN',28525,40.5,0.36,1200,7611,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 00792',0.043516,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28526,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 14900',NULL,28526,41.12,0.24,1680,7612,70,NULL,'SN photometric redshift distance, z photo =0.513 +/- 0.085','SDSS-II SN 14900',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,45.236167,-0.63561,0.261,NULL,37849594611,591399915,9240623,NULL),(28527,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28527,35.31,0.59,116,7613,70,NULL,NULL,'2MASX J03005711-4829480',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.000093,NULL,'15.89',0.27,'S',NULL,NULL,NULL,NULL,1,45.2379583,-48.49669,0,NULL,38466839943,601044374,9391318,15.89),(28528,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28528,35.43,0.54,122,7614,70,NULL,NULL,'2MASX J03005931-1022355',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.74',0.3,NULL,NULL,NULL,NULL,NULL,1,45.247125,-10.37642,0.161,NULL,37903892913,592248326,9253880,15.74),(28529,'BL Lac Luminosity','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28529,40.84,NULL,1180,7615,NULL,NULL,NULL,'NVSS J030103+344102',0.245,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.003,NULL,'18.53',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,45.265583,34.68361,0.505,NULL,68718567016,1073727609,16776993,18.53),(28530,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28530,35.58,0.56,130,7616,70,NULL,NULL,'LCRS B025909.8-390707',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'16.14',0.23,'S',NULL,NULL,NULL,NULL,1,45.272625,-38.922,0,NULL,38643125950,603798842,9434356,16.14),(28531,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SN 1995ay',NULL,28531,41.45,0.53,1320,7617,74.2,NULL,'SALT 2','[PDG95a] J030107.58+022120.8',0.48,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,45.281583,0.35578,0.233,NULL,64961593790,1015024902,15859764,NULL),(28532,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SN 1995ay','R',28532,41.58,NULL,1400,7617,65,NULL,'SALT','[PDG95a] J030107.58+022120.8',0.48,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28533,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SN 1995ay',NULL,28533,42.13,0.4,1800,7617,70,NULL,'SALT','[PDG95a] J030107.58+022120.8',0.48,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28534,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SN 1995ay',NULL,28534,42.3,0.38,1950,7617,65,NULL,'SALT','[PDG95a] J030107.58+022120.8',0.48,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28535,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SN 1995ay',NULL,28535,42.37,0.2,2010,7617,65,NULL,NULL,'[PDG95a] J030107.58+022120.8',0.48,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28536,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 16779','R',28536,41.55,0.33,1460,7618,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006qa','SN 2006qa',0.4,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,45.2905416667,-0.02625,0.285,NULL,36775691682,574620182,8978440,NULL),(28537,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 16779','R',28537,41.59,0.36,1490,7618,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006qa','SN 2006qa',0.4,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28538,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28538,35.31,0.47,115,7619,70,NULL,NULL,'2MASX J03011197-1053588',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.59',0.6,'EL','Field galaxy',NULL,NULL,NULL,1,45.2999583,-10.89983,0.181,NULL,37900122563,592189415,9252959,14.59),(28539,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 04524','R',28539,36.21,0.04,165,7620,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005gj','SDSS J030111.99-003313.5',0.06,'2014arXiv1401.3317S',2014,1,0.1,NULL,'G',NULL,NULL,'20.5g',0.05,'Candidate      QSO',NULL,NULL,NULL,NULL,1,45.2999583,-0.55378,0.337,NULL,37849557867,591399341,9240614,20.5),(28540,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SN 2005gj',NULL,28540,38.88,0.12,505,7620,74.2,NULL,'SALT 2','SDSS J030111.99-003313.5',0.183,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28541,'Sosies','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28541,31.93,0.19,24.3,7621,NULL,NULL,NULL,'NGC 1160',NULL,'2002A&A...393...57T',2002,1,1.9,NULL,'G',0.000017,NULL,'13.50',0.9,'SBc','Pair member (points to parent)',NULL,NULL,NULL,1,45.3052083,44.95542,0.961,NULL,68585183269,1071643488,16744429,13.5),(28542,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28542,31.97,0.43,24.8,7621,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1160',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28543,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28543,31.98,0.2,24.9,7621,74.4,NULL,NULL,'NGC 1160',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28544,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28544,32.01,0.43,25.2,7621,75,NULL,'3.6 micron, color corrected','NGC 1160',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28545,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28545,32.35,0.46,29.5,7621,NULL,NULL,'J','NGC 1160',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28546,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28546,32.41,0.47,30.3,7621,NULL,NULL,'H','NGC 1160',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28547,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28547,32.49,0.45,31.4,7621,NULL,NULL,'K','NGC 1160',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28548,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28548,32.52,0.4,32,7621,NULL,NULL,'mean','NGC 1160',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28549,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 05407',NULL,28549,40.61,0.98,1320,7622,70,NULL,'SN photometric redshift distance, z photo =0.376 +/- 0.324','SDSS-II SN 05407',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.3g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,45.308083,-0.21842,0.313,NULL,36775895437,574623366,8978490,22.3),(28550,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 04733',NULL,28550,41.19,0.4,1730,7622,70,NULL,'SN photometric redshift distance, z photo =0.535 +/- 0.165','SDSS-II SN 04733',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28551,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28551,34.49,0.48,79.2,7623,70,NULL,NULL,'ESO 417- G 011',NULL,'2014MNRAS.445.2677S',2014,1,1.4,'CSRG -1m RA error.','G',0.00006,NULL,'15.15',0.9,'(R)SB(r)0+','Pair member (points to parent)',NULL,NULL,NULL,1,45.3129583333,-28.46775,0,NULL,38607618856,603244044,9425688,15.15),(28552,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SN 2005fb',NULL,28552,39.32,0.04,618,7624,70,NULL,'SDSS-II SN 01580','2MASX J03011802-0038427',0.182898,'2011ApJS..192....1C',2011,1,0.16,NULL,'G',0.00008,NULL,'18.7g',0.1,'NLAGN',NULL,NULL,NULL,'Sy 2',1,45.325,-0.64511,0.261,NULL,37849590593,591399853,9240622,18.7),(28553,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SN 2005fb',NULL,28553,39.15,0.08,676,7624,70,NULL,'Hubble residual -0.12 for z0.18300','2MASX J03011802-0038427',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28554,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SN 2005fb',NULL,28554,39.59,0.13,701,7624,70,NULL,'SDSS-II SN 01580, SALT 2','2MASX J03011802-0038427',0.182898,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28555,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 01580','R',28555,39.62,0.2,709,7624,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fb','2MASX J03011802-0038427',0.183,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28556,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SN 2005fb',NULL,28556,39.63,0.08,713,7624,65,NULL,'SALT2','2MASX J03011802-0038427',0.182898,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28557,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 01580','R',28557,39.77,0.1,762,7624,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fb','2MASX J03011802-0038427',0.183,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28558,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SN 2005fb',NULL,28558,39.81,0.11,773,7624,65,NULL,'MLCS2k2','2MASX J03011802-0038427',0.182898,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28559,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 16137','RN',28559,42.86,0.27,2320,7625,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 16137',0.614415,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28560,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28560,37.67,0.33,343,7626,70,NULL,NULL,'2MASX J03012256-0008177',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000095,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,45.344,-0.13828,0.313,NULL,36775877380,574623084,8978485,17.5),(28561,'TRGB','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'N',28561,24.49,0.18,0.785,7627,NULL,NULL,NULL,'Andromeda XXXIII',NULL,'2013ApJ...779L..10M',2013,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28562,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28562,37.67,0.33,343,7628,70,NULL,NULL,'2MASX J03012409-0008017',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000092,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,45.3505,-0.13372,0.313,NULL,36775877322,574623083,8978485,16.6),(28563,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 10751','RN',28563,39.64,0.11,791,7629,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10751',0.07156,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28564,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 10751','RN',28564,41.32,0.23,1710,7629,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10751',0.07156,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28565,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28565,35.54,0.51,128,7630,70,NULL,NULL,'FAIRALL 1252',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.00015,NULL,'15.4B',0.67,NULL,NULL,NULL,NULL,NULL,1,45.3562916667,-73.88022,0.137,NULL,35634852631,556794572,8699915,15.4),(28566,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28566,35.83,0.46,147,7631,70,NULL,NULL,'2MASX J03012623-0004257',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000086,NULL,'16.4g',0.3,'SF',NULL,NULL,NULL,NULL,1,45.359375,-0.07375,0.313,NULL,36775871810,574622997,8978484,16.4),(28567,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28567,36.04,0.49,161,7632,70,NULL,NULL,'2MASX J03013549-0954468',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.41',0.6,'E','Field galaxy',NULL,NULL,NULL,1,45.398125,-9.91289,0.161,NULL,37903013360,592234583,9253665,15.41),(28568,'GCLF','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28568,31.38,0.09,18.9,7633,NULL,NULL,'TOM(g) = -7.2 mag','NGC 1172',NULL,'2012MNRAS.422.3591C',2012,1,2.3,NULL,'G',0.000027,NULL,'13.31',1.8,'E+:','Group member',NULL,NULL,NULL,1,45.4002083,-14.83658,0.101,NULL,38104284534,595379445,9302803,13.31),(28569,'GCLF','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28569,31.59,0.07,20.8,7633,NULL,NULL,'TOM(z) = -8.4 mag','NGC 1172',NULL,'2012MNRAS.422.3591C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28570,'SBF','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28570,31.5,0.2,20,7633,NULL,NULL,'I','NGC 1172',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28571,'SBF','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28571,31.63,0.14,21.2,7633,74.4,NULL,NULL,'NGC 1172',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28572,'SBF','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28572,31.66,0.2,21.5,7633,NULL,NULL,'I','NGC 1172',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28573,'SBF','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28573,31.66,0.2,21.5,7633,NULL,NULL,NULL,'NGC 1172',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28574,'SBF','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28574,31.72,0.2,22.1,7633,NULL,NULL,'Malmquist cor.','NGC 1172',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28575,'D-Sigma','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28575,32.19,0.4,27.4,7633,75,NULL,'Edat, raw','NGC 1172',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28576,'D-Sigma','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28576,32.33,0.4,29.3,7633,75,NULL,'Edat, cor','NGC 1172',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28577,'Faber-Jackson','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28577,30.57,0.58,13,7633,95,NULL,'de Vaucouleurs','NGC 1172',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28578,'Faber-Jackson','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28578,31.27,0.43,17.9,7633,95,NULL,'Weighted Mean','NGC 1172',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28579,'Faber-Jackson','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28579,33.66,0.81,54,7633,55,NULL,'Visvanathan & Sandage 1979','NGC 1172',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28580,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28580,32.32,0.41,29.1,7633,NULL,NULL,NULL,'NGC 1172',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28581,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28581,32.36,0.41,29.6,7633,NULL,NULL,'Malmquist cor.','NGC 1172',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28582,'Tertiary','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28582,30.78,0.21,14.3,7633,95,NULL,NULL,'NGC 1172',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28583,'Tully est','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28583,31.31,0.8,18.3,7633,75,NULL,'B','NGC 1172',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28584,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28584,31.6,0.4,20.9,7633,NULL,NULL,'mean','NGC 1172',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28585,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28585,32.18,0.45,27.2,7633,NULL,NULL,'K','NGC 1172',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28586,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28586,34.58,0.41,82.5,7634,NULL,NULL,'Malmquist cor.','UGC 02483',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000033,NULL,'16.0',0.4,'S?',NULL,NULL,NULL,NULL,1,45.403125,31.81925,0.565,NULL,68681871052,1073154235,16768034,16),(28587,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28587,34.63,0.2,84.3,7634,74.4,NULL,NULL,'UGC 02483',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28588,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28588,34.72,0.39,88,7634,NULL,NULL,NULL,'UGC 02483',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28589,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28589,34.83,0.63,92.4,7635,70,NULL,NULL,'NGC 1181',NULL,'2014MNRAS.445.2677S',2014,1,0.86,NULL,'G',0.00015,NULL,'16.19',0.22,'SB0: pec',NULL,NULL,NULL,NULL,1,45.428167,-15.05233,0.101,NULL,38103837809,595372465,9302694,16.19),(28590,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 17737',NULL,28590,40.45,0.2,1230,7636,70,NULL,'SN photometric redshift distance, z photo =0.343 +/- 0.041','SDSS-II SN 17737',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','20.7g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,45.4595,0.60511,0.233,NULL,64961519604,1015023743,15859745,20.7),(28591,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28591,35.41,0.52,121,7637,70,NULL,NULL,'NGC 1180',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.76',0.4,'S0-:',NULL,NULL,NULL,NULL,1,45.462667,-15.02983,0.101,NULL,38103868953,595372952,9302702,15.76),(28592,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28592,31.08,0.46,16.4,7638,NULL,NULL,NULL,'UGC 02491',NULL,'2009ApJS..182..474S',2009,1,1.8,NULL,'G',0.000017,NULL,'14.29',1.5,'SB(r)0/a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,45.474333,35.73322,0.545,NULL,68718827199,1073731674,16777057,14.29),(28593,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28593,31.61,0.36,21,7638,NULL,NULL,'Malmquist cor.','UGC 02491',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28594,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28594,36.78,0.67,227,7639,70,NULL,NULL,'2MASX J03015449-5316331',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'15.35',0.48,'SAB(r)b',NULL,NULL,NULL,NULL,1,45.477,-53.27589,0,NULL,38453738035,600839656,9388119,15.35),(28595,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 16670','RN',28595,40.72,0.63,1190,7640,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 16670',0.168943,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28596,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28596,33.89,0.4,59.9,7641,NULL,NULL,'mean','NGC 1164',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000037,NULL,'14.0',1,'(R\')SAB(s)ab   Sbrst',NULL,NULL,NULL,'Starburst',1,45.499375,42.58494,0.545,NULL,68572235356,1071441177,16741268,14),(28597,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28597,34.19,0.45,68.9,7641,NULL,NULL,'K','NGC 1164',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28598,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28598,34.25,0.47,70.9,7641,NULL,NULL,'H','NGC 1164',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28599,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28599,34.34,0.46,73.8,7641,NULL,NULL,'J','NGC 1164',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28600,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28600,34.33,0.46,73.4,7642,70,NULL,NULL,'ESO 300- G 005',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.98',0.8,'SAB(s)0^0',NULL,NULL,NULL,NULL,1,45.51025,-39.99211,0,NULL,38596205953,603065718,9422901,14.98),(28601,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28601,34.98,0.45,99,7643,NULL,NULL,'K','UGC 02494',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000033,NULL,'14.73',0.4,'S?',NULL,NULL,NULL,NULL,1,45.5159583,36.09844,0.573,NULL,68717886417,1073716975,16776827,14.73),(28602,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28602,34.98,0.47,99.2,7643,NULL,NULL,'H','UGC 02494',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28603,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28603,35.11,0.46,105,7643,NULL,NULL,'J','UGC 02494',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28604,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28604,35.17,0.4,108,7643,NULL,NULL,'mean','UGC 02494',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28605,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28605,34.4,0.43,75.9,7644,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0378',NULL,'2014MNRAS.444..527S',2014,1,0.94,NULL,'G',0.000013,NULL,'16.4',0.12,'Scd',NULL,NULL,NULL,NULL,1,45.517917,25.79319,0.733,NULL,68484749220,1070074206,16719909,16.4),(28606,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28606,34.51,0.49,79.7,7644,75,NULL,'IR','FGC 0378',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28607,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28607,34.92,NULL,96.5,7644,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0378',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28608,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28608,34.94,NULL,97.2,7644,NULL,NULL,'Dipole + Quadrupole','FGC 0378',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28609,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28609,34.95,NULL,97.7,7644,NULL,NULL,'Dipole','FGC 0378',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28610,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28610,34.98,NULL,99.1,7644,NULL,NULL,NULL,'FGC 0378',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28611,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28611,36.79,0.46,228,7645,70,NULL,NULL,'2MASX J03020539-0014427',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00008,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,45.522375,-0.24514,0.253,NULL,36775860490,574622820,8978481,17.6),(28612,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28612,36.18,0.51,172,7646,70,NULL,NULL,'2MASX J03020636-1357005',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00015,NULL,'15.66',0.6,NULL,NULL,NULL,NULL,NULL,1,45.5263333333,-13.95022,0.105,NULL,38101730138,595339533,9302180,15.66),(28613,'IRAS','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28613,32.78,0.8,36,7647,75,NULL,'W91PP, r','UGC 02497',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.000013,NULL,'14.38',0.7,'Sdm',NULL,NULL,NULL,NULL,1,45.532083,29.10639,0.613,NULL,68684372211,1073193315,16768645,14.38),(28614,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28614,32.6,0.2,33.1,7647,74.4,NULL,NULL,'UGC 02497',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28615,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28615,32.73,0.65,35.2,7647,NULL,NULL,'Malmquist cor.','UGC 02497',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28616,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28616,32.74,0.65,35.3,7647,NULL,NULL,NULL,'UGC 02497',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28617,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28617,32.89,0.38,37.8,7647,75,NULL,'W91PP, r, raw','UGC 02497',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28618,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28618,32.89,0.38,37.9,7647,75,NULL,'W91PP, r, inv','UGC 02497',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28619,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28619,33.27,0.38,45.1,7647,75,NULL,'W91PP, r, cor','UGC 02497',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28620,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28620,37.6,0.46,331,7648,70,NULL,NULL,'2MASX J03020784+0115055',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000086,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,45.53275,1.25147,0.249,NULL,67914690847,1061167044,16580735,17.7),(28621,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28621,38.21,0.46,438,7649,70,NULL,NULL,'SDSS J030211.08-005427.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000074,NULL,'18.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,45.5462083,-0.90775,0.265,NULL,37850005134,591406330,9240723,18.9),(28622,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28622,34.81,0.2,91.6,7650,74.4,NULL,NULL,'UGC 02498',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.000017,NULL,'15.13',0.7,'SABcd','Isolated galaxy',NULL,NULL,NULL,1,45.550917,17.34547,0.385,NULL,68179164924,1065299451,16645303,15.13),(28623,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28623,34.82,0.4,92.1,7650,NULL,NULL,NULL,'UGC 02498',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28624,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28624,35.02,0.37,101,7650,NULL,NULL,'Malmquist cor.','UGC 02498',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28625,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28625,36.28,0.64,181,7651,70,NULL,NULL,'2MASX J03021403-1549244',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'16.19',0.46,NULL,NULL,NULL,NULL,NULL,1,45.5582917,-15.82336,0.093,NULL,38115211047,595550172,9305471,16.19),(28626,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28626,35.65,0.62,135,7652,70,NULL,NULL,'2MASX J03021924-5345483',NULL,'2014MNRAS.445.2677S',2014,1,0.95,NULL,'G',0.00012,NULL,'15.45',0.55,'S0',NULL,NULL,NULL,NULL,1,45.5803333333,-53.76339,0,NULL,38454307829,600848559,9388258,15.45),(28627,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 20915',NULL,28627,41.15,0.3,1700,7653,70,NULL,'SN photometric redshift distance, z photo =0.522 +/- 0.115','SDSS-II SN 20915',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','22.0g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,45.5804583,-1.06267,0.265,NULL,37850040238,591406878,9240732,22),(28628,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 02632','R',28628,40.83,0.26,1130,7654,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02632',0.296,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,45.590125,-1.22611,0.253,NULL,37850175610,591408993,9240765,NULL),(28629,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 02632','R',28629,41.08,0.18,1270,7654,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 02632',0.296,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28630,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28630,37.64,0.46,337,7655,70,NULL,NULL,'2MASX J03022306-0000397',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000074,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,45.5960417,-0.011,0.253,NULL,36775795632,574621806,8978465,18.5),(28631,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28631,34.33,0.2,73.5,7656,74.4,NULL,NULL,'UGC 02502',NULL,'2013AJ....146...86T',2013,1,0.95,NULL,'G',0.000077,NULL,'15.5g',0.33,'Sa(f)',NULL,NULL,NULL,NULL,1,45.598167,0.97931,0.261,NULL,67914624395,1061166006,16580718,15.5),(28632,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28632,34.92,0.49,96.6,7657,75,NULL,'IR','UGC 02502',NULL,'2011yCatp016004901K',2011,1,0.95,NULL,'G',0.000077,NULL,'15.5g',0.33,'Sa(f)',NULL,NULL,NULL,NULL,1,45.598167,0.97931,0.261,NULL,67914624395,1061166006,16580718,15.5),(28633,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28633,35.06,0.47,103,7658,70,NULL,NULL,'2MASX J03022754-1102564',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'15.09',0.28,'E','Field galaxy',NULL,NULL,NULL,1,45.614875,-11.04897,0.161,NULL,37900241894,592191279,9252988,15.09),(28634,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28634,34.82,0.49,92.2,7659,75,NULL,'IR','UGC 02496',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000037,NULL,'18.',0.12,'Sd',NULL,NULL,NULL,NULL,1,45.6395417,46.43844,0.973,NULL,68581659556,1071588430,16743569,18),(28635,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28635,34.97,NULL,98.7,7659,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02496',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28636,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28636,34.97,NULL,98.7,7659,NULL,NULL,'Dipole + Quadrupole','UGC 02496',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28637,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28637,34.97,NULL,98.8,7659,NULL,NULL,'Dipole','UGC 02496',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28638,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28638,34.98,NULL,99.2,7659,NULL,NULL,NULL,'UGC 02496',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28639,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28639,33.24,0.2,44.5,7660,74.4,NULL,NULL,'UGC 02501',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000031,NULL,'13.93',0.6,'SB(s)m pec:',NULL,NULL,NULL,NULL,1,45.6404166667,2.19453,0.229,NULL,67915881336,1061185645,16581025,13.93),(28640,'Ring Diameter','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28640,31.4,0.76,19,7661,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 1187',NULL,'1981ApJS...45..541P',1981,1,5.5,NULL,'G',0.00001,NULL,'11.67',4.1,'SB(r)c         HII','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,45.656625,-22.86717,0.037,NULL,38052433704,594569276,9290144,11.67),(28641,'Ring Diameter','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28641,31.5,0.6,20,7661,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 1187',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28642,'Sosies','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28642,31.44,0.2,19.4,7661,NULL,NULL,NULL,'NGC 1187',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28643,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28643,31.05,0.4,16.3,7661,75,NULL,'B','NGC 1187',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28644,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28644,31.29,0.4,18.1,7661,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 3 galaxy group','NGC 1187',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28645,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28645,31.32,0.36,18.4,7661,NULL,NULL,NULL,'NGC 1187',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28646,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28646,31.32,0.4,18.4,7661,73,NULL,'opt','NGC 1187',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28647,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28647,31.42,0.4,19.3,7661,NULL,NULL,'mean','NGC 1187',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28648,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28648,31.49,0.45,19.9,7661,NULL,NULL,'K','NGC 1187',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28649,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28649,31.49,0.43,19.9,7661,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1187',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28650,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28650,31.54,0.46,20.4,7661,NULL,NULL,'J','NGC 1187',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28651,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28651,31.57,0.43,20.7,7661,75,NULL,'3.6 micron, color corrected','NGC 1187',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28652,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28652,31.73,0.2,22.2,7661,74.4,NULL,NULL,'NGC 1187',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28653,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28653,31.94,NULL,24.4,7661,NULL,NULL,'LEDA [April 2006]','NGC 1187',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28654,'IRAS','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28654,31.85,0.8,23.4,7662,75,NULL,'MAT, I','NGC 1179',NULL,'1997ApJS..109..333W',1997,1,4.9,NULL,'G',0.000007,NULL,'13.83',3.8,'SB(rs)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,45.6603333333,-18.89778,0.053,NULL,38056117634,594626838,9291044,13.83),(28655,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28655,30.13,0.32,10.6,7662,85,NULL,'I, inv','NGC 1179',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28656,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28656,30.15,0.32,10.7,7662,85,NULL,'I, raw','NGC 1179',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28657,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28657,30.64,0.43,13.4,7662,75,NULL,'MAT, I, inv','NGC 1179',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28658,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28658,30.64,0.43,13.4,7662,75,NULL,'MAT, I, raw','NGC 1179',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28659,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28659,31.01,0.43,15.9,7662,75,NULL,'MAT, I, cor','NGC 1179',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28660,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28660,31.26,0.36,17.9,7662,NULL,NULL,NULL,'NGC 1179',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28661,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28661,31.26,0.4,17.9,7662,73,NULL,'opt','NGC 1179',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28662,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28662,31.64,0.4,21.2,7662,75,NULL,'B','NGC 1179',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28663,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28663,31.71,0.1,22,7662,NULL,NULL,NULL,'NGC 1179',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28664,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28664,35.63,0.49,134,7663,75,NULL,'IR','2MFGC 02468',NULL,'2011yCatp016004901K',2011,1,0.78,NULL,'G',0.000167,NULL,'11.8K',0.22,'S',NULL,NULL,NULL,NULL,1,45.6634583333,46.45894,0.973,NULL,68581659398,1071588428,16743569,11.8),(28665,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 15073','RN',28665,43.05,0.41,2950,7664,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 15073',0.379218,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28666,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 15073','RN',28666,43.35,0.33,3390,7664,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 15073',0.379218,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28667,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28667,37.69,0.33,345,7665,70,NULL,NULL,'2MASX J03024294-0831325',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00006,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,45.679,-8.52578,0.269,NULL,37915213762,592425215,9256643,17.8),(28668,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 05477','RN',28668,39.79,0.24,821,7666,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05477',0.106885,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28669,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 05477','RN',28669,40.14,0.14,962,7666,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 05477',0.106885,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28670,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28670,35.96,0.46,155,7667,70,NULL,NULL,'2MASX J03024906-0114359',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00009,NULL,'16.2g',0.29,'S0',NULL,NULL,NULL,NULL,1,45.704375,-1.24342,0.257,NULL,37850166859,591408857,9240763,16.2),(28671,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28671,36.32,0.61,184,7667,70,NULL,NULL,'2MASX J03024906-0114359',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28672,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28672,36.66,0.46,215,7668,70,NULL,NULL,'SDSS J030250.81-083508.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000071,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,45.7117083333,-8.58561,0.269,NULL,37915203355,592425052,9256641,18),(28673,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28673,37.69,0.33,345,7669,70,NULL,NULL,'SDSS J030251.79-082316.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000061,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,45.715833,-8.38794,0.249,NULL,37914751977,592417999,9256531,18.7),(28674,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 04772','RN',28674,40.13,0.23,959,7670,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 04772',0.105436,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28675,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 04772','RN',28675,40.2,0.1,994,7670,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 04772',0.105436,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28676,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28676,33.74,0.49,56.1,7671,75,NULL,'IR','NGC 1185',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.00015,NULL,'14.46',0.4,'SB(r)b?','Field galaxy',NULL,NULL,NULL,1,45.7478333333,-9.13214,0.209,NULL,37915051217,592422675,9256604,14.46),(28677,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28677,33.8,0.47,57.6,7671,NULL,NULL,'H','NGC 1185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28678,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28678,33.87,0.45,59.6,7671,NULL,NULL,'K','NGC 1185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28679,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28679,33.97,0.46,62.1,7671,NULL,NULL,'J','NGC 1185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28680,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28680,34.07,0.4,65.2,7671,NULL,NULL,'mean','NGC 1185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28681,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28681,38.36,0.46,469,7672,70,NULL,NULL,'SDSS J030302.24-083914.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000069,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,45.759333,-8.65397,0.253,NULL,37915256375,592425880,9256654,18.5),(28682,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 17033','RN',28682,41.92,0.27,1990,7673,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 17033',0.21673,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28683,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 17033','RN',28683,42.44,0.27,2520,7673,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 17033',0.21673,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28684,'TRGB','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28684,28.23,NULL,4.43,7674,NULL,NULL,NULL,'kkh 018',NULL,'2003A&A...398..479K',2003,1,0.7,NULL,'G',0.000002,NULL,'16.7',0.35,'Ir',NULL,NULL,NULL,NULL,1,45.774333,33.69436,0.529,NULL,68705388387,1073521693,16773776,16.7),(28685,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28685,37.03,0.74,255,7675,70,NULL,NULL,'6dF J0303070-363700',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,45.77975,-36.61658,0.053,NULL,38643582020,603805969,9434468,15.7),(28686,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28686,36.4,0.61,191,7676,70,NULL,NULL,'2MASX J03030939-2311558',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,45.789125,-23.19892,0.021,NULL,38054497510,594601523,9290648,14.9),(28687,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28687,38.02,0.46,402,7677,70,NULL,NULL,'2MASX J03031330-0014207',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.0001,NULL,'18.64',0.18,NULL,NULL,NULL,NULL,NULL,1,45.805333,-0.23903,0.245,NULL,36776565824,574633841,8978653,18.64),(28688,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28688,36.79,0.59,228,7678,70,NULL,NULL,'2MASX J03032211-1050526',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'17.63',0.19,NULL,NULL,NULL,NULL,NULL,1,45.842125,-10.84786,0.189,NULL,37900054012,592188343,9252942,17.63),(28689,'IRAS','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28689,34.4,0.8,75.9,7679,75,NULL,'CF, r','UGC 02509',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000009,NULL,'15.38',0.3,'S?',NULL,NULL,NULL,NULL,1,45.8505417,4.49178,0.369,NULL,67930223531,1061409742,16584527,15.38),(28690,'IRAS','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28690,34.4,0.8,75.9,7679,75,NULL,'A82, H','UGC 02509',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28691,'IRAS','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28691,34.4,0.8,75.9,7679,75,NULL,'HMCL, I','UGC 02509',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28692,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28692,34.15,0.4,67.5,7679,75,NULL,'HMCL, I, raw','UGC 02509',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28693,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28693,34.22,0.49,70,7679,75,NULL,'IR','UGC 02509',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28694,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28694,34.29,0.4,72.1,7679,75,NULL,'HMCL, I, inv','UGC 02509',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28695,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28695,34.3,0.47,72.3,7679,75,NULL,'A82, H, raw','UGC 02509',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28696,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28696,34.3,0.38,72.4,7679,75,NULL,'CF, r, raw','UGC 02509',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28697,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28697,34.39,0.47,75.7,7679,75,NULL,'A82, H, inv','UGC 02509',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28698,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28698,34.4,0.38,75.8,7679,75,NULL,'CF, r, inv','UGC 02509',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28699,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28699,34.47,0.4,78.3,7679,NULL,NULL,'mean','UGC 02509',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28700,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28700,34.47,0.2,78.3,7679,74.4,NULL,NULL,'UGC 02509',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28701,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28701,34.6,0.4,83.1,7679,75,NULL,'HMCL, I, cor','UGC 02509',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28702,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28702,34.64,0.14,84.9,7679,NULL,NULL,NULL,'UGC 02509',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28703,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28703,34.66,0.47,85.4,7679,NULL,NULL,'H','UGC 02509',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28704,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28704,34.69,0.38,86.5,7679,75,NULL,'CF, r, cor','UGC 02509',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28705,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28705,34.8,0.47,91.1,7679,75,NULL,'A82, H, cor','UGC 02509',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28706,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28706,34.94,0.49,97.3,7680,75,NULL,'IR','ESO 199-IG 012',NULL,'2011yCatp016004901K',2011,1,1.46,NULL,'G',0.00006,NULL,'14.71',0.39,'(PR?)',NULL,NULL,NULL,NULL,1,45.851833,-50.49528,0,NULL,38468776162,601074627,9391791,14.71),(28707,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,'R',28707,31.46,0.49,19.6,7681,75,NULL,'IR','NGC 1190',NULL,'2011yCatp016004901K',2011,1,0.9,'Position in 1997ApJS..110....1D is 5 arcsec southeast of the nucleus.','G',0.00009,NULL,'15.19',0.3,'S0^0^: sp','Compact group member',NULL,NULL,NULL,1,45.858875,-15.66189,0.093,NULL,38115142329,595549098,9305454,15.19),(28708,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 16648',NULL,28708,39.25,0.45,710,7682,70,NULL,'SN photometric redshift distance, z photo =0.182 +/- 0.048','SDSS-II SN 16648',NULL,'2011ApJ...738..162S',2011,1,0.15,NULL,'G',NULL,'PHOT','19.1g',0.11,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,45.8615,-0.22947,0.245,NULL,36776547055,574633547,8978649,19.1),(28709,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 16648','R',28709,40.01,0.15,835,7682,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16648',0.201267,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28710,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:00','1','SDSS-II SN 16648','R',28710,40.16,0.27,895,7682,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16648',0.201267,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28711,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28711,33.71,0.47,55.3,7683,70,NULL,NULL,'CGCG 389-066',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000133,NULL,'15.2b',0.2,NULL,NULL,NULL,NULL,NULL,1,45.87725,-2.24828,0.169,NULL,37851851074,591435173,9241174,15.2),(28712,'IRAS','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28712,33.1,0.8,41.6,7684,75,NULL,'MAT, I','ESO 547- G 004',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.97',0.7,'SAB(rs)c: pec',NULL,NULL,NULL,NULL,1,45.8777083,-20.17608,0.037,NULL,38063865500,594747898,9292935,14.97),(28713,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28713,32.64,0.32,33.7,7684,85,NULL,'I, inv','ESO 547- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28714,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28714,32.65,0.32,33.9,7684,85,NULL,'I, raw','ESO 547- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28715,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28715,33.05,0.43,40.8,7684,75,NULL,'MAT, I, raw','ESO 547- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28716,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28716,33.06,0.43,40.9,7684,75,NULL,'MAT, I, inv','ESO 547- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28717,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28717,33.28,0.4,45.3,7684,73,NULL,'opt','ESO 547- G 004',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28718,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28718,33.36,0.43,47.1,7684,75,NULL,'MAT, I, cor','ESO 547- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28719,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28719,33.44,0.79,48.7,7684,NULL,NULL,NULL,'ESO 547- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28720,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28720,33.48,0.2,49.7,7684,74.4,NULL,NULL,'ESO 547- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28721,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28721,33.59,0.74,52.4,7684,NULL,NULL,'Malmquist cor.','ESO 547- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28722,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28722,35.98,0.51,157,7685,70,NULL,NULL,'NGC 1191',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00007,NULL,'15.28',0.5,'SB0-:','Compact group member',NULL,NULL,NULL,1,45.8787083,-15.68531,0.093,NULL,38115144636,595549134,9305455,15.28),(28723,'FP','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28723,35.57,0.49,130,7686,70,NULL,NULL,'NGC 1192',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000047,NULL,'15.36',0.3,'E5','Compact group member',NULL,NULL,NULL,1,45.8942917,-15.67883,0.093,NULL,38115143776,595549121,9305455,15.36),(28724,'IRAS','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28724,32.31,0.8,29,7687,75,NULL,'A82, H','NGC 1169',NULL,'1997ApJS..109..333W',1997,1,4.2,NULL,'G',0.000017,NULL,'12.2',2.8,'SAB(r)b',NULL,NULL,NULL,NULL,1,45.8947917,46.38636,0.973,NULL,68581711764,1071589246,16743581,12.2),(28725,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28725,31.6,0.69,20.9,7687,100,NULL,'mid-IR','NGC 1169',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28726,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:00','1',NULL,NULL,28726,32.16,0.41,27.1,7687,NULL,NULL,'Malmquist cor.','NGC 1169',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28727,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28727,32.31,0.4,29,7687,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 1169',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28728,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28728,32.36,0.37,29.7,7687,NULL,NULL,NULL,'NGC 1169',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28729,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28729,32.63,0.2,33.6,7687,74.4,NULL,NULL,'NGC 1169',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28730,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28730,32.64,0.4,33.7,7687,75,NULL,'B','NGC 1169',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28731,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28731,32.74,0.38,35.3,7687,NULL,NULL,NULL,'NGC 1169',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28732,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28732,32.94,0.43,38.8,7687,75,NULL,'3.6 micron, color corrected','NGC 1169',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28733,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28733,32.99,0.47,39.7,7687,75,NULL,'A82, H, raw','NGC 1169',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28734,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28734,33.12,0.43,42.1,7687,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1169',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28735,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28735,33.3,0.47,45.7,7687,75,NULL,'A82, H, inv','NGC 1169',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28736,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28736,33.48,0.47,49.7,7687,75,NULL,'A82, H, cor','NGC 1169',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28737,'SBF','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28737,32.57,0.32,32.7,7688,NULL,NULL,'Malmquist cor.','NGC 1199',NULL,'2001MNRAS.327.1004B',2001,1,2.4,NULL,'G',0.000017,NULL,'12.37',1.9,'E3:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,45.9100417,-15.61319,0.097,NULL,38115090412,595548287,9305441,12.37),(28738,'SBF','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28738,32.6,0.32,33.1,7688,NULL,NULL,'I','NGC 1199',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28739,'SBF','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28739,32.6,0.32,33.1,7688,NULL,NULL,NULL,'NGC 1199',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28740,'SBF','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28740,32.65,0.14,33.9,7688,74.4,NULL,NULL,'NGC 1199',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28741,'D-Sigma','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28741,32.19,0.4,27.4,7688,75,NULL,'Edat, raw','NGC 1199',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28742,'D-Sigma','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28742,32.33,0.4,29.3,7688,75,NULL,'Edat, cor','NGC 1199',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28743,'Faber-Jackson','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28743,31.74,0.42,22.3,7688,95,NULL,'de Vaucouleurs','NGC 1199',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28744,'Faber-Jackson','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28744,31.95,0.28,24.5,7688,95,NULL,'Weighted Mean','NGC 1199',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28745,'Faber-Jackson','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28745,32.02,0.63,25.4,7688,95,NULL,'Michard 1979b, c','NGC 1199',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28746,'Faber-Jackson','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28746,32.53,0.46,32.1,7688,95,NULL,'Michard 1979a','NGC 1199',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28747,'Faber-Jackson','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28747,33.91,0.81,60.5,7688,55,NULL,'Visvanathan & Sandage 1979','NGC 1199',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28748,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28748,32.62,0.41,33.4,7688,NULL,NULL,NULL,'NGC 1199',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28749,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28749,32.69,0.41,34.6,7688,NULL,NULL,'Malmquist cor.','NGC 1199',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28750,'Tertiary','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28750,31.94,0.71,24.4,7688,95,NULL,NULL,'NGC 1199',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28751,'Tully est','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28751,32.5,0.8,31.6,7688,75,NULL,'B','NGC 1199',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28752,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28752,33.07,0.45,41.1,7688,NULL,NULL,'K','NGC 1199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28753,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28753,33.69,0.4,54.6,7688,NULL,NULL,'mean','NGC 1199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28754,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28754,37.27,0.46,284,7689,70,NULL,NULL,'2MASX J03033877-0027309',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000081,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,45.9115,-0.45875,0.233,NULL,36776689269,574635769,8978683,17.4),(28755,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28755,38.17,0.46,431,7690,70,NULL,NULL,'2MASX J03034330-0710128',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000087,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,45.930333,-7.17025,0.249,NULL,37905458841,592272794,9254262,17.4),(28756,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28756,36.24,0.52,177,7691,70,NULL,NULL,'2MASX J03034419-1048158',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'15.63',0.2,NULL,'Field galaxy',NULL,NULL,NULL,1,45.934167,-10.80442,0.189,NULL,37900000207,592187503,9252929,15.63),(28757,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 01858',NULL,28757,41.59,NULL,2080,7692,70,NULL,'SN photometric redshift distance, z photo =0.699 +/- 0.001','SDSS-II SN 01858',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','20.9g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,45.934875,0.41761,0.221,NULL,64962383810,1015037247,15859956,20.9),(28758,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28758,31.44,0.43,19.4,7693,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 050',NULL,'2014MNRAS.444..527S',2014,1,1.9,NULL,'G',0.00001,NULL,'15.0',1.2,'SB(s)m:',NULL,NULL,NULL,NULL,1,45.9605,-25.27236,0,NULL,38537403461,602146929,9408545,15),(28759,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28759,36.3,0.58,182,7694,70,NULL,NULL,'IC 1879',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'15.88',0.23,'S?',NULL,NULL,NULL,NULL,1,45.9685417,-52.11775,0,NULL,38455084653,600860697,9388448,15.88),(28760,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28760,36.21,0.27,175,7695,70,NULL,NULL,'CGCG 389-070',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000127,NULL,'14.8g',0.71,'E0',NULL,NULL,NULL,NULL,1,45.9704583,0.41528,0.221,NULL,64962200190,1015034377,15859912,14.8),(28761,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28761,38,0.33,398,7696,70,NULL,NULL,'SDSS J030353.51-062540.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00007,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,45.973,-6.42797,0.229,NULL,37905854879,592278982,9254359,18.5),(28762,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 2008R',NULL,28762,33.56,0.21,50.2,7697,72,NULL,NULL,'NGC 1200',0.0129,'2013ApJ...773...53F',2013,1,3,NULL,'G',0.000067,NULL,'13.20',1.5,'SA(s)0-',NULL,NULL,NULL,NULL,1,45.977,-11.99181,0.169,NULL,37892306629,592067291,9251051,13.2),(28763,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 2008R',NULL,28763,33.86,0.21,59.3,7697,72,NULL,'M(H) = -18.317 mag','NGC 1200',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28764,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 2008R',NULL,28764,33.93,0.19,60.2,7697,73.8,NULL,'SALT 2 (SNANA)','NGC 1200',0.0129,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28765,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28765,33.82,0.47,58,7697,70,NULL,NULL,'NGC 1200',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28766,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28766,36.77,0.46,226,7698,70,NULL,NULL,'2MASX J03035649-0058293',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000119,NULL,'16.3g',0.35,'S0',NULL,NULL,NULL,NULL,1,45.9855417,-0.97483,0.257,NULL,36776173168,574627705,8978557,16.3),(28767,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28767,37.22,0.7,278,7698,70,NULL,NULL,'2MASX J03035649-0058293',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28768,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 17206','R',28768,39.39,0.21,653,7699,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J030356.61+004341.4',0.1564,'2014arXiv1401.3317S',2014,1,0.17,NULL,'G',0.0001,NULL,'19.8g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,45.985917,0.72819,0.217,NULL,64962197230,1015034331,15859911,19.8),(28769,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 17206',NULL,28769,39.2,0.13,692,7699,70,NULL,'SALT 2','SDSS J030356.61+004341.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28770,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 17206',NULL,28770,39.21,0.13,695,7699,70,NULL,'SALT 2, Malmquist cor.','SDSS J030356.61+004341.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28771,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 17206','R',28771,39.63,0.15,729,7699,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J030356.61+004341.4',0.1564,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28772,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28772,38,0.33,398,7700,70,NULL,NULL,'SDSS J030357.83-062619.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000076,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,45.991,-6.43881,0.229,NULL,37905855425,592278991,9254359,18.3),(28773,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28773,36.21,0.27,175,7701,70,NULL,NULL,'2MASX J03035878+0023264',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000076,NULL,'15.9g',0.36,'E0',NULL,NULL,NULL,NULL,1,45.9949583,0.39067,0.221,NULL,64961725351,1015026958,15859796,15.9),(28774,'IRAS','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28774,32.55,0.8,32.3,7702,75,NULL,'A82, H','NGC 1171',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.00002,NULL,'13.0',1.1,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,45.9957917,43.39831,0.917,NULL,68569888170,1071404502,16740695,13),(28775,'Sosies','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28775,32.21,0.42,27.7,7702,NULL,NULL,NULL,'NGC 1171',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28776,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28776,31.16,0.4,17.1,7702,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 1171',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28777,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28777,31.43,0.47,19.4,7702,75,NULL,'A82, H, raw','NGC 1171',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28778,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28778,31.46,0.47,19.6,7702,75,NULL,'A82, H, inv','NGC 1171',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28779,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28779,31.9,0.47,24,7702,75,NULL,'A82, H, cor','NGC 1171',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28780,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28780,31.91,0.38,24.1,7702,NULL,NULL,NULL,'NGC 1171',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28781,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28781,31.91,0.39,24.1,7702,73,NULL,'opt','NGC 1171',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28782,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28782,32.22,0.47,27.7,7702,NULL,NULL,'H','NGC 1171',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28783,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28783,32.23,0.46,27.9,7702,NULL,NULL,'J','NGC 1171',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28784,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28784,32.27,0.45,28.5,7702,NULL,NULL,'K','NGC 1171',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28785,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28785,32.74,0.4,35.4,7702,NULL,NULL,'mean','NGC 1171',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28786,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28786,32.89,0.4,37.9,7702,75,NULL,'B','NGC 1171',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28787,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28787,31.87,0.4,23.7,7703,NULL,NULL,NULL,'UGC 02485',NULL,'2009AJ....138..323T',2009,1,1.4,NULL,'G',0.000037,NULL,'17.',1.3,'Scd:',NULL,NULL,NULL,NULL,1,46.016667,74.44389,1.601,NULL,65700004022,1026562562,16040040,17),(28788,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28788,36.21,0.27,175,7704,70,NULL,NULL,'2MASX J03040685+0024194',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000108,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,46.0284583,0.40547,0.221,NULL,64961728120,1015027001,15859796,16.3),(28789,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 2003hv',NULL,28789,31.58,0.05,20.7,7705,72,NULL,NULL,'NGC 1201',NULL,'2009A&A...505..265L',2009,1,3.6,NULL,'G',0.000037,NULL,'12.20',2.1,'SA(r)0^0^:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,46.03325,-26.06964,0,NULL,38538211987,602159562,9408743,12.2),(28790,'SBF','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28790,31.53,0.3,20.2,7705,NULL,NULL,'I','NGC 1201',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28791,'SBF','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28791,31.55,0.14,20.4,7705,74.4,NULL,NULL,'NGC 1201',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28792,'Faber-Jackson','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28792,30.23,0.69,11.1,7705,95,NULL,'de Vaucouleurs','NGC 1201',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28793,'Faber-Jackson','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28793,30.96,0.32,15.6,7705,95,NULL,'Weighted Mean','NGC 1201',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28794,'Faber-Jackson','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28794,31.64,0.46,21.3,7705,95,NULL,'Michard 1979a','NGC 1201',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28795,'Faber-Jackson','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28795,31.7,0.63,21.9,7705,95,NULL,'Michard 1979b, c','NGC 1201',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28796,'Faber-Jackson','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28796,32.28,0.81,28.6,7705,55,NULL,'Visvanathan & Sandage 1979','NGC 1201',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28797,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28797,31.12,0.25,16.8,7705,74.4,NULL,NULL,'NGC 1201',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28798,'Tertiary','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28798,30.78,0.21,14.3,7705,95,NULL,NULL,'NGC 1201',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28799,'Tully est','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28799,31.53,0.8,20.2,7705,75,NULL,'B','NGC 1201',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28800,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 17344','RN',28800,43.26,0.55,2640,7706,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17344',0.697909,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28801,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28801,36.1,0.82,166,7707,70,NULL,NULL,'2MASX J03041306-1458299',NULL,'2014MNRAS.445.2677S',2014,1,0.28,NULL,'G',0.00015,NULL,'16.46',0.21,NULL,NULL,NULL,NULL,NULL,1,46.0545,-14.97489,0.109,NULL,38104190216,595377972,9302780,16.46),(28802,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28802,37.39,0.67,301,7708,70,NULL,NULL,'2MASX J03041410-1326289',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.00015,NULL,'17.60',0.23,NULL,NULL,NULL,NULL,NULL,1,46.0588333333,-13.44128,0.141,NULL,38072218875,594878419,9294975,17.6),(28803,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28803,37.81,0.46,365,7709,70,NULL,NULL,'SDSS J030416.17-075603.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000074,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,46.067375,-7.93433,0.281,NULL,37914738239,592417784,9256527,17.9),(28804,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28804,34.53,0.2,80.5,7710,74.4,NULL,NULL,'UGC 02518',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',NULL,NULL,'15.33',0.4,'Scd:','Group member, peripheral',NULL,NULL,NULL,1,46.0734583,1.75764,0.245,NULL,67915805264,1061184457,16581007,15.33),(28805,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28805,34.6,0.49,83.3,7710,75,NULL,'IR','UGC 02518',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28806,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28806,34.96,0.11,98.4,7710,NULL,NULL,NULL,'UGC 02518',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28807,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 02608','RN',28807,37.81,0.05,349,7711,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02608',0.044431,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28808,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28808,37.13,0.88,267,7712,70,NULL,NULL,'2MASX J03041905-1050213',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.85',0.46,NULL,NULL,NULL,NULL,NULL,1,46.0793333333,-10.83942,0.161,NULL,37891870246,592060472,9250944,16.85),(28809,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28809,33.71,0.43,55.3,7713,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02511',NULL,'2014MNRAS.444..527S',2014,1,1.3,'abs(b) < 10 degrees.','G',0.00003,NULL,'16.0',0.4,'SBab:',NULL,NULL,NULL,NULL,1,46.085125,48.27011,NULL,NULL,68529545944,1070774155,16730846,16),(28810,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 2005ij',NULL,28810,37.98,0.11,355,7714,74.2,NULL,'SALT 2','SDSS J030421.26-010347.0',0.11,'2010ApJ...716..712A',2010,1,0.25,NULL,'G',NULL,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,46.0885833333,-1.06308,0.225,NULL,36776163547,574627555,8978555,18.6),(28811,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 2005ij',NULL,28811,38.69,0.06,494,7714,65,NULL,'SALT2','SDSS J030421.26-010347.0',0.11,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28812,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 2005ij',NULL,28812,38.71,0.12,497,7714,70,NULL,'SDSS-II SN 06406, SALT 2','SDSS J030421.26-010347.0',0.11,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28813,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 06406','R',28813,38.73,0.18,501,7714,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ij','SDSS J030421.26-010347.0',0.11,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28814,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 2005ij',NULL,28814,38.62,0.07,530,7714,70,NULL,'SALT 2','SDSS J030421.26-010347.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28815,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 2005ij',NULL,28815,38.62,0.07,530,7714,70,NULL,'SALT 2, Malmquist cor.','SDSS J030421.26-010347.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28816,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 2005ij',NULL,28816,38.9,0.07,544,7714,65,NULL,'MLCS2k2','SDSS J030421.26-010347.0',0.11,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28817,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 2005ij',NULL,28817,38.91,0.03,545,7714,70,NULL,'SDSS-II SN 06406','SDSS J030421.26-010347.0',0.11,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28818,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 06406','R',28818,38.96,0.06,558,7714,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ij','SDSS J030421.26-010347.0',0.11,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28819,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28819,37.55,0.46,323,7715,70,NULL,NULL,'2MASX J03042552+0115215',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00008,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,46.1064166667,1.25592,0.169,NULL,64961944802,1015030387,15859849,17.3),(28820,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS J030426.25+010245.2:SN',NULL,28820,38.6,0.12,454,7716,74.2,NULL,'SALT 2','SDSS J030426.25+010245.2',0.156,'2010ApJ...716..712A',2010,1,0.32,NULL,'G',NULL,'PHOT','16.9g',0.26,'BrClG',NULL,NULL,NULL,NULL,1,46.1094166667,1.04592,0.169,NULL,64962066603,1015032290,15859879,16.9),(28821,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 04064','R',28821,39.29,0.19,623,7716,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS J030426.25+010245.2',0.156453,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28822,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 04064','R',28822,39.45,0.08,672,7716,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS J030426.25+010245.2',0.156453,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28823,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28823,33.26,0.45,44.9,7717,NULL,NULL,'K','NGC 1175',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.00005,NULL,'13.89',0.6,'SA(r)0+','in a pair',NULL,NULL,NULL,1,46.1347917,42.33931,0.561,NULL,68572210396,1071440787,16741262,13.89),(28824,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28824,34.35,0.4,74,7717,NULL,NULL,'mean','NGC 1175',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28825,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28825,36.29,0.46,182,7718,70,NULL,NULL,'2MASX J03043278-0040530',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000085,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,46.1365833333,-0.68131,0.217,NULL,36776459560,574632180,8978627,16.8),(28826,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28826,36.75,0.58,224,7719,70,NULL,NULL,'2MASX J03043590-1330339',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.22',0.43,NULL,NULL,NULL,NULL,NULL,1,46.1497083,-13.50944,0.141,NULL,38072197671,594878088,9294970,16.22),(28827,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 07849','RN',28827,40.43,0.3,1190,7720,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07849',0.023064,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28828,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28828,35.37,0.13,119,7721,NULL,NULL,NULL,'CGCG 415-058',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000014,NULL,'15.6',0.4,'Sc','Group member, peripheral',NULL,NULL,NULL,1,46.16325,5.44292,0.413,NULL,67920234687,1061253666,16582088,15.6),(28829,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28829,35.45,0.2,123,7721,74.4,NULL,NULL,'CGCG 415-058',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28830,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28830,37.07,0.46,260,7722,70,NULL,NULL,'2MASX J03043931-0054060',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00008,NULL,'17.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,46.163875,-0.90161,0.185,NULL,36776039963,574625624,8978525,17.9),(28831,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28831,36.58,0.55,207,7723,70,NULL,NULL,'2MASX J03043986-1333177',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'16.04',0.43,NULL,NULL,NULL,NULL,NULL,1,46.1662083,-13.55492,0.141,NULL,38071980574,594874696,9294917,16.04),(28832,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28832,33.66,NULL,54,7724,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0382',NULL,'2010Ap&SS.325..163P',2010,1,1,NULL,'G',0.00004,NULL,'16.6',0.11,'Sd',NULL,NULL,NULL,NULL,1,46.1752917,-12.61769,0.173,NULL,38072604765,594884449,9295069,16.6),(28833,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28833,33.67,NULL,54.2,7724,NULL,NULL,'Dipole + Quadrupole','FGC 0382',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28834,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28834,33.68,NULL,54.5,7724,NULL,NULL,'Dipole','FGC 0382',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28835,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28835,33.7,NULL,54.9,7724,NULL,NULL,NULL,'FGC 0382',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28836,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28836,36.08,0.63,164,7725,70,NULL,NULL,'2MASX J03044918-2802450',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000103,NULL,'16.00',0.45,'E',NULL,NULL,NULL,NULL,1,46.204833,-28.04581,0,NULL,38607291275,603238926,9425608,16),(28837,'Quasar spectrum','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28837,42.92,NULL,3840,7726,NULL,NULL,NULL,'LBQS 0302-0019',NULL,'2002A&A...381L..57D',2002,1,NULL,NULL,'QSO',0.000298,NULL,'17.8g',NULL,'AGN',NULL,NULL,NULL,'QSO',1,46.20775,-0.13708,0.233,NULL,36776233456,574628647,8978572,17.8),(28838,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28838,33.43,0.2,48.5,7727,74.4,NULL,NULL,'UGC 02520',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000017,NULL,'16.5',0.9,'SBd:',NULL,NULL,NULL,NULL,1,46.231,21.37667,0.593,NULL,68130151051,1064533610,16633337,16.5),(28839,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28839,33.55,0.34,51.3,7727,NULL,NULL,NULL,'UGC 02520',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28840,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28840,33.88,0.29,59.6,7727,NULL,NULL,'Malmquist cor.','UGC 02520',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28841,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28841,37.23,0.55,280,7728,70,NULL,NULL,'2MASX J03045777-4015102',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'17.13',0.24,NULL,NULL,NULL,NULL,NULL,1,46.2407917,-40.25281,0,NULL,38596064898,603063514,9422867,17.13),(28842,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28842,34.09,0.51,65.8,7729,70,NULL,NULL,'IC 0287',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.26',0.6,NULL,NULL,NULL,NULL,NULL,1,46.240917,-12.07044,0.165,NULL,37892287662,592066994,9251046,15.26),(28843,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28843,35.47,0.57,124,7730,70,NULL,NULL,'2MASX J03050212-7810050',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'19.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,46.259,-78.16797,0.397,NULL,35697884851,557779450,8715303,19.5),(28844,'IRAS','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28844,31.42,0.8,19.3,7731,75,NULL,'MAT, I','ESO 248- G 002',NULL,'1997ApJS..109..333W',1997,1,3,'The APM positions are northeast of the center of the bar.','G',0.000025,NULL,'14.07',0.7,'SB(s)d',NULL,NULL,NULL,NULL,1,46.275917,-45.96208,0,NULL,38516612389,601822068,9403469,14.07),(28845,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28845,31.28,0.32,18,7731,85,NULL,'I, inv','ESO 248- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28846,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28846,31.3,0.32,18.2,7731,85,NULL,'I, raw','ESO 248- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28847,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28847,31.32,0.11,18.4,7731,NULL,NULL,NULL,'ESO 248- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28848,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28848,31.33,0.4,18.5,7731,NULL,NULL,NULL,'ESO 248- G 002',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28849,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28849,31.49,0.4,19.9,7731,73,NULL,'IR','ESO 248- G 002',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28850,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28850,31.49,0.4,19.9,7731,75,NULL,NULL,'ESO 248- G 002',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28851,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28851,31.57,0.43,20.6,7731,75,NULL,'MAT, I, inv','ESO 248- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28852,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28852,31.58,0.43,20.7,7731,75,NULL,'MAT, I, raw','ESO 248- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28853,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28853,31.68,0.43,21.7,7731,75,NULL,'MAT, I, cor','ESO 248- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28854,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28854,31.74,0.4,22.3,7731,73,NULL,'opt','ESO 248- G 002',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28855,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28855,32.24,0.49,28.1,7731,75,NULL,'IR','ESO 248- G 002',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28856,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28856,34.49,0.49,79,7732,75,NULL,'IR','UGC 02523',NULL,'2011yCatp016004901K',2011,1,2,NULL,'G',0.000075,NULL,'15.2g',0.31,'Scd(f)         NLAGN',NULL,NULL,NULL,NULL,1,46.2875833333,1.09356,0.237,NULL,64964897116,1015076517,15860570,15.2),(28857,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28857,34.76,NULL,89.4,7732,NULL,NULL,'Dipole','UGC 02523',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28858,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28858,34.76,NULL,89.6,7732,NULL,NULL,'Dipole + Quadrupole','UGC 02523',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28859,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28859,34.77,NULL,89.8,7732,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02523',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28860,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28860,34.77,0.2,90,7732,74.4,NULL,NULL,'UGC 02523',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28861,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28861,34.92,NULL,96.2,7732,NULL,NULL,NULL,'UGC 02523',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28862,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28862,34.95,0.12,97.9,7732,NULL,NULL,NULL,'UGC 02523',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28863,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28863,37.2,0.58,275,7733,70,NULL,NULL,'MCG +00-08-088',NULL,'2014MNRAS.445.2677S',2014,1,0.74,NULL,'G',0.000115,NULL,'15.7g',0.6,'NLAGN',NULL,NULL,NULL,'Sy 2',1,46.2942083333,-1.07544,0.173,NULL,36779510712,574679854,8979372,15.7),(28864,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28864,36.25,0.58,178,7734,70,NULL,NULL,'LCRS B030320.8-414539',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'15.89',0.48,'S0',NULL,NULL,NULL,NULL,1,46.2992083,-41.56761,0,NULL,38474838376,601169349,9393271,15.89),(28865,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28865,37.7,0.46,346,7735,70,NULL,NULL,'2MASX J03051190+0109325',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000087,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,46.2995,1.15908,0.237,NULL,64965025047,1015078516,15860601,17.4),(28866,'GRB','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28866,44.94,0.19,4340,7736,NULL,NULL,NULL,'GRB 090926B',1.24,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,46.308125,-39.006,0,NULL,38596751412,603074240,9423035,NULL),(28867,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28867,35.85,0.5,148,7737,70,NULL,NULL,'NGC 1203A',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.000143,NULL,'14.9b',0.35,'E0?',NULL,NULL,NULL,NULL,1,46.30875,-14.38106,0.109,NULL,38103631499,595369242,9302644,14.9),(28868,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28868,37.9,0.46,381,7738,70,NULL,NULL,'2MASX J03051417+0058435',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,46.309167,0.97883,0.237,NULL,64964913282,1015076770,15860574,18.3),(28869,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 1992bc',NULL,28869,33.86,0.18,58,7739,74.2,NULL,'SALT 2','ESO 300- G 009',0.02,'2010ApJ...716..712A',2010,1,0.95,NULL,'G',0.002,NULL,'15.54',0.35,'Sab',NULL,NULL,NULL,NULL,1,46.315875,-39.56131,0,NULL,38597009194,603078268,9423097,15.54),(28870,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 1992bc',NULL,28870,33.97,0.02,61,7739,70,NULL,'SALT 2','ESO 300- G 009',0.02,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28871,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 1992bc',NULL,28871,34.49,0.11,77.6,7739,70,NULL,NULL,'ESO 300- G 009',0.02,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28872,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 1992bc',NULL,28872,34.52,0.18,78.6,7739,70,NULL,'SALT','ESO 300- G 009',0.02,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28873,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 1992bc',NULL,28873,34.48,0.08,78.7,7739,65,NULL,'LCS','ESO 300- G 009',NULL,'1995ApJ...445L..91R',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28874,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 1992bc',NULL,28874,34.48,0.07,78.7,7739,60,NULL,'M(B) = -19.48 mag','ESO 300- G 009',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28875,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 1992bc',NULL,28875,34.55,0.08,81.3,7739,74.4,NULL,NULL,'ESO 300- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28876,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 1992bc',NULL,28876,34.57,0.06,82,7739,60,NULL,'M(V) = -19.47 mag','ESO 300- G 009',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28877,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 1992bc',NULL,28877,34.6,0.25,83,7739,67,NULL,NULL,'ESO 300- G 009',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28878,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 1992bc',NULL,28878,34.66,0.18,83.8,7739,70,NULL,'SALT 2','ESO 300- G 009',0.02,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28879,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 1992bc',NULL,28879,34.66,0.03,83.9,7739,72,NULL,NULL,'ESO 300- G 009',0.02,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28880,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 1992bc',NULL,28880,34.69,0.21,85,7739,65,NULL,'SALT2','ESO 300- G 009',0.02,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28881,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 1992bc',NULL,28881,34.7,0.17,85.3,7739,73.8,NULL,'SALT 2 (SNANA)','ESO 300- G 009',0.0208,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28882,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 1992bc',NULL,28882,34.7,0.21,85.5,7739,65,NULL,'SALT','ESO 300- G 009',0.02,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28883,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 1992bc',NULL,28883,34.66,0.17,85.5,7739,70.8,NULL,NULL,'ESO 300- G 009',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28884,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 1992bc',NULL,28884,34.66,0.05,85.5,7739,60,NULL,'M(I) = -19.19 mag','ESO 300- G 009',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28885,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 1992bc',NULL,28885,34.74,0.19,87,7739,72,NULL,NULL,'ESO 300- G 009',0.02,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28886,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 1992bc',NULL,28886,34.74,0.01,87.1,7739,65,NULL,'SALT','ESO 300- G 009',0.02,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28887,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 1992bc',NULL,28887,34.76,0.05,87.6,7739,65,NULL,'MLCS','ESO 300- G 009',0.02,'1996ApJ...473..588R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28888,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 1992bc',NULL,28888,34.77,0.15,88.2,7739,65,NULL,'Template','ESO 300- G 009',0.02,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28889,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 1992bc',NULL,28889,34.75,0.05,89.1,7739,65,NULL,'Snapshot','ESO 300- G 009',NULL,'1996ApJ...473...88R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28890,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 1992bc',NULL,28890,34.8,0.18,89.2,7739,65,NULL,'MLCS17','ESO 300- G 009',0.02,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28891,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 1992bc',NULL,28891,34.86,0.04,90.1,7739,65,NULL,'MLCS2k2','ESO 300- G 009',0.02,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28892,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 1992bc',NULL,28892,34.84,0.05,91,7739,65,NULL,'MLCS2k2','ESO 300- G 009',0.02,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28893,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 1992bc',NULL,28893,34.85,0.17,91.5,7739,65,NULL,'MLCS31','ESO 300- G 009',0.02,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28894,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 1992bc',NULL,28894,34.87,0.11,92.3,7739,65,NULL,'MLCS','ESO 300- G 009',0.02,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28895,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 1992bc',NULL,28895,34.96,0.22,96.3,7739,65,NULL,NULL,'ESO 300- G 009',0.02,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28896,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 1992bc',NULL,28896,35.06,0.14,103,7739,60,NULL,NULL,'ESO 300- G 009',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28897,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28897,34.55,0.08,81.3,7739,74.4,NULL,NULL,'ESO 300- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28898,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28898,35.1,0.4,105,7739,75,NULL,'HOSTS SN 1992bc','ESO 300- G 009',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28899,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28899,35.14,0.43,107,7739,75,NULL,'3.6 micron, color corrected','ESO 300- G 009',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28900,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28900,35.21,0.42,110,7739,NULL,18.48,'3.6 micron','ESO 300- G 009',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28901,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28901,35.3,0.43,115,7739,75,NULL,'3.6 micron, color + selection bias corrected','ESO 300- G 009',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28902,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28902,37.75,0.33,354,7740,70,NULL,NULL,'2MASX J03051597+0037405',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00009,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,46.3165417,0.62778,0.213,NULL,64965189176,1015081080,15860641,17.3),(28903,'GRB','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28903,44.87,0.21,4170,7741,NULL,NULL,NULL,'XRT 061007',1.261,'2010JCAP...08..020W',2010,1,NULL,NULL,'G',NULL,NULL,'21.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,46.331667,-50.50067,0,NULL,38468868027,601076062,9391813,21),(28904,'GRB','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28904,44.73,0.06,8830,7741,NULL,NULL,NULL,'XRT 061007',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28905,'GRB','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28905,44.78,0.16,9040,7741,NULL,NULL,NULL,'XRT 061007',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28906,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28906,35.23,0.64,111,7742,70,NULL,NULL,'6dF J0305197-005815',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,46.3325,-0.97069,0.173,NULL,36779513490,574679898,8979373,16.1),(28907,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 2005fv',NULL,28907,38.03,0.11,361,7743,74.2,NULL,'SALT 2','2MASX J03052260+0051346',0.118412,'2010ApJ...716..712A',2010,1,0.31,NULL,'G',0.000106,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,46.3442917,0.85972,0.205,NULL,64965326560,1015083227,15860675,18.6),(28908,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 2005fv',NULL,28908,38.66,0.12,483,7743,70,NULL,'SALT 2','2MASX J03052260+0051346',0.118412,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28909,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 2005fv',NULL,28909,38.68,0.07,488,7743,65,NULL,'SALT2','2MASX J03052260+0051346',0.118412,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28910,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 2005fv',NULL,28910,38.73,NULL,499,7743,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 02561, SN 2005fv','2MASX J03052260+0051346',0.118412,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28911,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 02561','R',28911,38.75,0.18,504,7743,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fv','2MASX J03052260+0051346',0.118412,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28912,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 2005fv',NULL,28912,38.56,0.07,515,7743,70,NULL,'SALT 2','2MASX J03052260+0051346',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28913,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 2005fv',NULL,28913,38.57,0.07,518,7743,70,NULL,'SALT 2, Malmquist cor.','2MASX J03052260+0051346',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28914,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 2005fv',NULL,28914,38.85,0.08,526,7743,65,NULL,'MLCS2k2','2MASX J03052260+0051346',0.118412,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28915,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 02561','R',28915,38.86,0.07,529,7743,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fv','2MASX J03052260+0051346',0.118412,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28916,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 2005fv',NULL,28916,39.3,0.03,649,7743,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 02561, SN 2005fv','2MASX J03052260+0051346',0.118412,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28917,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28917,38.21,0.46,438,7744,70,NULL,NULL,'2MASX J03052329-0042304',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,46.347083,-0.70853,0.185,NULL,36779136290,574674004,8979281,18.3),(28918,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28918,36.33,0.56,185,7745,70,NULL,NULL,'2MASX J03052536-5557129',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000067,NULL,'15.97',0.38,'S0',NULL,NULL,NULL,NULL,1,46.3557917,-55.9535,0,NULL,36242254363,566285224,8848206,15.97),(28919,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28919,38.38,0.33,474,7746,70,NULL,NULL,'2MASX J03052669-0101524',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000105,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,46.361167,-1.03136,0.173,NULL,36779513978,574679905,8979373,18),(28920,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28920,34.78,0.46,90.2,7747,70,NULL,NULL,'CGCG 389-078',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000107,NULL,'14.5g',0.23,'E0',NULL,NULL,NULL,NULL,1,46.3785417,-0.40503,0.217,NULL,36779298213,574676534,8979320,14.5),(28921,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28921,32.2,0.46,27.6,7748,NULL,NULL,'J','NGC 1174',NULL,'2007A&A...465...71T',2007,1,3.2,NULL,'G',0.000019,NULL,'12.2',1.2,'SB(r)bc:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,46.378583,42.8355,0.633,NULL,68570258802,1071410293,16740785,12.2),(28922,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28922,32.22,0.47,27.8,7748,NULL,NULL,'H','NGC 1174',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28923,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28923,32.28,0.45,28.6,7748,NULL,NULL,'K','NGC 1174',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28924,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28924,32.66,0.2,34,7748,74.4,NULL,NULL,'NGC 1174',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28925,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28925,32.74,0.4,35.3,7748,NULL,NULL,'mean','NGC 1174',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28926,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28926,32.75,0.43,35.5,7748,75,NULL,'3.6 micron, color corrected','NGC 1174',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28927,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28927,32.91,0.43,38.2,7748,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1174',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28928,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28928,38.38,0.33,474,7749,70,NULL,NULL,'SDSS J030534.69-010052.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000078,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,46.394625,-1.01456,0.173,NULL,36779499315,574679676,8979369,18.3),(28929,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28929,36.25,0.54,178,7750,70,NULL,NULL,'2MASX J03053610-0559096',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.000183,NULL,'16.46',0.38,NULL,NULL,NULL,NULL,NULL,1,46.4003333333,-5.98611,0.225,NULL,37860330559,591567664,9243244,16.46),(28930,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28930,34.89,0.2,95.1,7751,74.4,NULL,NULL,'UGC 02525',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000033,NULL,'15.55',0.3,'S?',NULL,NULL,NULL,NULL,1,46.4186666667,33.39403,0.565,NULL,68705832301,1073528629,16773884,15.55),(28931,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28931,37.17,0.46,271,7752,70,NULL,NULL,'2MASX J03054233-0627437',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000072,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,46.4262916667,-6.46219,0.225,NULL,37905697579,592276524,9254320,17.6),(28932,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28932,33.47,0.2,49.4,7753,74.4,NULL,NULL,'UGC 02526',NULL,'2013AJ....146...86T',2013,1,3.5,NULL,'G',0.000017,NULL,'13.33',0.7,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,46.430625,36.78617,0.625,NULL,68709903107,1073592236,16774878,13.33),(28933,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28933,33.57,0.49,51.7,7753,75,NULL,'IR','UGC 02526',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28934,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28934,33.91,0.46,60.5,7753,NULL,NULL,'J','UGC 02526',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28935,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28935,33.95,0.47,61.6,7753,NULL,NULL,'H','UGC 02526',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28936,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28936,34.02,0.45,63.6,7753,NULL,NULL,'K','UGC 02526',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28937,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28937,34.07,0.4,65.2,7753,NULL,NULL,'mean','UGC 02526',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28938,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28938,35.26,0.2,113,7754,74.4,NULL,NULL,'KUG 0303+011',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',NULL,NULL,'15.6',0.25,'Spiral',NULL,NULL,NULL,NULL,1,46.4442083,1.31125,0.237,NULL,64965042886,1015078795,15860606,15.6),(28939,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28939,38.35,0.15,468,7755,70,NULL,NULL,'2MASX J03054670-0011485',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000063,NULL,'16.92',0.16,NULL,NULL,NULL,NULL,NULL,1,46.4445,-0.19686,0.181,NULL,36779124970,574673827,8979278,16.92),(28940,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28940,34.86,0.46,93.9,7756,70,NULL,NULL,'2MASX J03054810-0616357',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000085,NULL,'15.3g',0.47,'E0',NULL,NULL,NULL,NULL,1,46.4502917,-6.2765,0.217,NULL,37905614373,592275224,9254300,15.3),(28941,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28941,35.63,0.49,134,7757,70,NULL,NULL,'2MASX J03054839-0932447',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000077,NULL,'15.90',0.45,'Elliptical','Field galaxy',NULL,NULL,NULL,1,46.4518333333,-9.54586,0.261,NULL,37900989542,592202961,9253171,15.9),(28942,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28942,34.88,0.33,94.5,7758,NULL,NULL,'Malmquist cor.','ESO 480- G 030',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000033,NULL,'14.80',0.8,'Sb             HII',NULL,NULL,NULL,NULL,1,46.470625,-27.23078,0,NULL,38538899693,602170307,9408911,14.8),(28943,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28943,34.97,0.32,98.5,7758,NULL,NULL,NULL,'ESO 480- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28944,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28944,35.01,0.2,100,7758,74.4,NULL,NULL,'ESO 480- G 030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28945,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28945,37.75,0.33,354,7759,70,NULL,NULL,'2MASX J03055330+0041524',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000076,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,46.4720417,0.69792,0.197,NULL,64965227179,1015081674,15860651,17),(28946,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28946,38.35,0.15,468,7760,70,NULL,NULL,'2MASX J03055517-0009388',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000099,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,46.479917,-0.16078,0.181,NULL,36779076730,574673073,8979266,18.1),(28947,'SBF','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28947,32.72,0.23,35,7761,NULL,NULL,'Malmquist cor.','NGC 1209',NULL,'2001MNRAS.327.1004B',2001,1,2.4,NULL,'G',0.00006,NULL,'12.86',1.1,'LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,46.512583,-15.61125,0.093,NULL,38114794219,595543659,9305369,12.86),(28948,'SBF','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28948,32.77,0.23,35.8,7761,NULL,NULL,'I','NGC 1209',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28949,'SBF','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28949,32.77,0.23,35.8,7761,NULL,NULL,NULL,'NGC 1209',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28950,'SBF','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28950,32.8,0.14,36.3,7761,74.4,NULL,NULL,'NGC 1209',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28951,'D-Sigma','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28951,32.19,0.4,27.4,7761,75,NULL,'Edat, raw','NGC 1209',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28952,'D-Sigma','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28952,32.33,0.4,29.3,7761,75,NULL,'Edat, cor','NGC 1209',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28953,'Faber-Jackson','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28953,31.64,0.63,21.3,7761,95,NULL,'Michard 1979b, c','NGC 1209',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28954,'Faber-Jackson','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28954,32.2,0.26,27.5,7761,95,NULL,'Weighted Mean','NGC 1209',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28955,'Faber-Jackson','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28955,32.2,0.46,27.5,7761,95,NULL,'Michard 1979a','NGC 1209',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28956,'Faber-Jackson','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28956,32.56,0.36,32.5,7761,95,NULL,'de Vaucouleurs','NGC 1209',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28957,'Faber-Jackson','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28957,33.58,0.81,52,7761,55,NULL,'Visvanathan & Sandage 1979','NGC 1209',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28958,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28958,32.35,0.41,29.4,7761,NULL,NULL,NULL,'NGC 1209',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28959,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28959,32.37,0.41,29.8,7761,NULL,NULL,'Malmquist cor.','NGC 1209',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28960,'Tertiary','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28960,31.94,0.71,24.4,7761,95,NULL,NULL,'NGC 1209',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28961,'Tully est','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28961,32.58,0.8,32.9,7761,75,NULL,'B','NGC 1209',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28962,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28962,32.25,0.45,28.1,7761,NULL,NULL,'K','NGC 1209',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28963,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28963,32.56,0.4,32.5,7761,NULL,NULL,'mean','NGC 1209',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28964,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28964,36.23,0.51,176,7762,70,NULL,NULL,'2MASX J03060467-0553228',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.13',0.22,NULL,NULL,NULL,NULL,NULL,1,46.519625,-5.88961,0.189,NULL,37860351551,591567992,9243249,16.13),(28965,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 15173','RN',28965,41.6,6.53,1680,7763,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15173',0.241583,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28966,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28966,33.94,0.45,61.3,7764,70,NULL,NULL,'NGC 1217',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.00005,NULL,'13.64',1.3,'SA:(s:)a pecHIILINER','Pair member (points to parent)',NULL,NULL,'LINER',1,46.525083,-39.03639,0,NULL,38596733367,603073958,9423030,13.64),(28967,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28967,35.51,0.63,126,7765,70,NULL,NULL,'2MASX J03060729-0835398',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.000076,NULL,'16.3g',0.18,'Sa(f)',NULL,NULL,NULL,NULL,1,46.5304583333,-8.59444,0.297,NULL,37915338384,592427162,9256674,16.3),(28968,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28968,31.93,0.4,24.3,7766,NULL,NULL,NULL,'IC 0284',NULL,'2009AJ....138..323T',2009,1,4.1,NULL,'G',0.00002,NULL,'12.47',2.1,'SAdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,46.5412917,42.37192,0.641,NULL,68570114741,1071408042,16740750,12.47),(28969,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28969,31.93,0.4,24.3,7766,73,NULL,'opt','IC 0284',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28970,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28970,32.87,0.4,37.4,7766,75,NULL,'B','IC 0284',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28971,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28971,38.35,0.15,468,7767,70,NULL,NULL,'2MASX J03061124-0008198',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000104,NULL,'17.7g',0.19,'BrClG',NULL,NULL,NULL,NULL,1,46.546875,-0.13872,0.181,NULL,36778024507,574656632,8979009,17.7),(28972,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28972,36.7,0.46,219,7768,70,NULL,NULL,'2MASX J03061184-0110598',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000116,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,46.549333,-1.18317,0.165,NULL,36779688418,574682631,8979416,16.6),(28973,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28973,37.19,0.65,275,7768,70,NULL,NULL,'2MASX J03061184-0110598',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28974,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28974,35.01,0.63,101,7769,70,NULL,NULL,'FAIRALL 1255',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'16.0B',0.5,NULL,NULL,NULL,NULL,NULL,1,46.5545417,-85.40383,0.429,NULL,35497354191,554646159,8666346,16),(28975,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28975,38.35,0.15,468,7770,70,NULL,NULL,'2MASX J03061377-0010258',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000065,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,46.5575417,-0.17394,0.181,NULL,36778075124,574657423,8979022,18.3),(28976,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28976,38.35,0.15,468,7771,70,NULL,NULL,'2MASX J03061731-0008238',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00012,NULL,'17.1g',0.27,'AGN',NULL,NULL,NULL,NULL,1,46.57225,-0.14003,0.181,NULL,36778076941,574657452,8979022,17.1),(28977,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28977,38.35,0.15,468,7772,70,NULL,NULL,'2MASX J03061737-0008349',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000083,NULL,'18.4g',0.1,'BrClG',NULL,NULL,NULL,NULL,1,46.572417,-0.14306,0.181,NULL,36778076483,574657445,8979022,18.4),(28978,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28978,38.35,0.15,468,7773,70,NULL,NULL,'2MASX J03062152-0008140',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000109,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,46.5897083333,-0.13717,0.181,NULL,36778076698,574657448,8979022,17.9),(28979,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28979,32.94,0.69,38.7,7774,100,NULL,'mid-IR','IC 1874',NULL,'2013ApJ...771...88L',2013,1,0.9,NULL,'G',0.000093,NULL,'14.8',0.6,NULL,NULL,NULL,NULL,NULL,1,46.591583,36.01453,0.537,NULL,68718366530,1073724477,16776944,14.8),(28980,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28980,34.02,0.45,63.6,7774,NULL,NULL,'K','IC 1874',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28981,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28981,34.03,0.47,64.1,7774,NULL,NULL,'H','IC 1874',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28982,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28982,34.05,0.4,64.6,7774,NULL,NULL,'mean','IC 1874',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28983,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28983,34.09,0.46,65.9,7774,NULL,NULL,'J','IC 1874',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28984,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 1994al',NULL,28984,41.23,0.43,1240,7775,74.2,NULL,'SALT 2','CL 0303+1706:[DG92] 074',0.42,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,'21.2',NULL,'S0+comp','Group member',NULL,NULL,NULL,1,46.593417,17.30931,0.357,NULL,68173192043,1065206125,16643845,21.2),(28985,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 1994al',NULL,28985,42.12,0.13,1870,7775,70,NULL,'SALT','CL 0303+1706:[DG92] 074',0.42,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28986,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28986,38.52,0.46,505,7776,70,NULL,NULL,'2MASX J03062404-0044550',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000075,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,46.60025,-0.74878,0.173,NULL,36779229336,574675458,8979304,18.1),(28987,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28987,37.8,0.33,363,7777,70,NULL,NULL,'2MASX J03062458-0055210',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000079,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,46.602375,-0.92264,0.173,NULL,36779809971,574684530,8979445,17.3),(28988,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28988,38.1,0.46,416,7778,70,NULL,NULL,'2MASX J03062517+0014396',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00008,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,46.605,0.24428,0.213,NULL,64962992817,1015046762,15860105,18.3),(28989,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 04443',NULL,28989,38.86,1.24,591,7779,70,NULL,'SN photometric redshift distance, z photo =0.149 +/- 0.134','SDSS-II SN 04443',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT','22.2g',NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,46.607083,0.05517,0.181,NULL,64963014397,1015047099,15860110,22.2),(28990,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28990,36.27,0.58,180,7780,70,NULL,NULL,'6dF J0306265-093012',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,46.6104583333,-9.50339,0.261,NULL,37901038274,592203723,9253183,16.8),(28991,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28991,37.18,0.46,273,7781,70,NULL,NULL,'2MASX J03063057+0007126',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000067,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,46.627333,0.12028,0.181,NULL,64963016007,1015047125,15860111,17.4),(28992,'IRAS','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28992,34.27,0.8,71.6,7782,75,NULL,'MAT, I','NGC 1244',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'13.88',0.4,'SA(r)ab pec:',NULL,NULL,NULL,NULL,1,46.6295417,-66.77561,0.041,NULL,36504435241,570381800,8912215,13.88),(28993,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28993,33.93,0.47,61.1,7782,NULL,NULL,'H','NGC 1244',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28994,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28994,33.97,0.46,62.3,7782,NULL,NULL,'J','NGC 1244',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28995,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28995,33.99,0.45,62.9,7782,NULL,NULL,'K','NGC 1244',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28996,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28996,34.04,0.43,64.2,7782,75,NULL,'MAT, I, raw','NGC 1244',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28997,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',28997,34.08,0.49,65.4,7782,75,NULL,'IR','NGC 1244',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28998,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28998,34.11,0.32,66.3,7782,85,NULL,'I, raw','NGC 1244',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(28999,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,28999,34.19,0.32,68.8,7782,85,NULL,'I, inv','NGC 1244',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29000,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29000,34.29,0.4,72.3,7782,NULL,NULL,'mean','NGC 1244',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29001,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29001,34.33,0.28,73.5,7782,NULL,NULL,'Malmquist cor.','NGC 1244',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29002,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29002,34.37,0.43,74.7,7782,75,NULL,'MAT, I, inv','NGC 1244',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29003,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29003,34.38,0.43,75.3,7782,75,NULL,'MAT, I, cor','NGC 1244',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29004,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29004,34.5,0.26,79.3,7782,NULL,NULL,NULL,'NGC 1244',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29005,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29005,34.54,0.2,80.9,7782,74.4,NULL,NULL,'NGC 1244',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29006,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',29006,37.14,0.46,268,7783,70,NULL,NULL,'SDSS J030631.65-072846.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000073,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,46.631917,-7.47947,0.269,NULL,37907331281,592302051,9254719,18.7),(29007,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',29007,36.74,0.46,223,7784,70,NULL,NULL,'2MASX J03063278-0033390',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000114,NULL,'16.1g',0.39,'E0',NULL,NULL,NULL,NULL,1,46.6364583,-0.56075,0.137,NULL,36779286765,574676355,8979318,16.1),(29008,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 18807','R',29008,39.8,0.2,774,7785,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007mg','SN 2007mg',0.177,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,46.6409583,0.79331,0.197,NULL,64965414716,1015084604,15860696,NULL),(29009,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 18807','R',29009,39.94,0.09,826,7785,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007mg','SN 2007mg',0.177,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29010,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',29010,34.58,0.49,82.4,7786,75,NULL,'IR','UGC 02539',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000014,NULL,'17.',0.2,'Sc',NULL,NULL,NULL,NULL,1,46.645625,7.84233,0.709,NULL,67974443792,1062100684,16595323,17),(29011,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',29011,35.73,0.33,140,7787,70,NULL,NULL,'2MASX J03063845-0030360',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000104,NULL,'15.6g',0.43,'E0',NULL,NULL,NULL,NULL,1,46.66025,-0.50997,0.137,NULL,36779219862,574675310,8979301,15.6),(29012,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29012,36.29,0.57,181,7787,70,NULL,NULL,'2MASX J03063845-0030360',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29013,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 14579',NULL,29013,41.27,0.16,1790,7788,70,NULL,'SN photometric redshift distance, z photo =0.562 +/- 0.061','SDSS-II SN 14579',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,46.66425,-1.10394,0.165,NULL,36779840062,574685000,8979453,NULL),(29014,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29014,37.71,0.55,348,7789,70,NULL,NULL,'2MASX J03063943-3724287',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'17.01',0.35,NULL,NULL,NULL,NULL,NULL,1,46.664417,-37.40797,0.005,NULL,38644063773,603813496,9434585,17.01),(29015,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 16287','R',29015,38.37,0.19,426,7790,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006np','2MASX J03063958+0003426',0.107325,'2014arXiv1401.3317S',2014,1,0.3,NULL,'G',0.000959,NULL,'16.8g',0.23,'Sbrst          NLSy1',NULL,NULL,NULL,'NL Sy 1',1,46.6649166667,0.062,0.181,NULL,64962982378,1015046599,15860103,16.8),(29016,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 2006np',NULL,29016,38.25,0.08,447,7790,70,NULL,'SALT 2','2MASX J03063958+0003426',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29017,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 2006np',NULL,29017,38.25,0.08,447,7790,70,NULL,'SALT 2, Malmquist cor.','2MASX J03063958+0003426',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29018,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 16287','R',29018,38.62,0.08,478,7790,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006np','2MASX J03063958+0003426',0.107325,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29019,'IRAS','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29019,33.95,0.8,61.7,7791,75,NULL,'MAT, I','IC 1885',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.11',0.5,'Sc?',NULL,NULL,NULL,NULL,1,46.6684583,-32.86364,0,NULL,38648019958,603875311,9435551,14.11),(29020,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29020,33.62,0.32,53,7791,85,NULL,'I, raw','IC 1885',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29021,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29021,33.63,0.32,53.2,7791,85,NULL,'I, inv','IC 1885',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29022,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29022,33.82,0.43,58,7791,75,NULL,'MAT, I, raw','IC 1885',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29023,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29023,33.91,0.43,60.4,7791,75,NULL,'MAT, I, inv','IC 1885',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29024,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29024,33.92,0.43,60.9,7791,NULL,NULL,NULL,'IC 1885',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29025,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29025,33.96,0.2,61.9,7791,74.4,NULL,NULL,'IC 1885',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29026,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29026,34.12,0.43,66.8,7791,75,NULL,'MAT, I, cor','IC 1885',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29027,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29027,34.18,0.38,68.7,7791,NULL,NULL,'Malmquist cor.','IC 1885',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29028,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',29028,35.73,0.33,140,7792,70,NULL,NULL,'2MASX J03064111-0033180',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00008,NULL,'16.2g',0.25,'E0',NULL,NULL,NULL,NULL,1,46.671375,-0.55508,0.137,NULL,36779220658,574675322,8979301,16.2),(29029,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29029,36.08,0.67,164,7792,70,NULL,NULL,'2MASX J03064111-0033180',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29030,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 13659',NULL,29030,40.12,0.38,1060,7793,70,NULL,'SN photometric redshift distance, z photo =0.287 +/- 0.068','SDSS-II SN 13659',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,46.677667,-1.04136,0.165,NULL,36779848390,574685131,8979455,NULL),(29031,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 2007nt',NULL,29031,39.27,0.1,715,7794,70,NULL,'Hubble residual -0.29 for z0.21290','SDSS J030643.76-004514.6',NULL,'2011ApJ...740...92G',2011,1,0.08,NULL,'G',0.0005,NULL,'20.7g',0.06,NULL,NULL,NULL,NULL,NULL,1,46.682333,-0.75408,0.173,NULL,36779243540,574675680,8979307,20.7),(29032,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 18927','R',29032,39.91,0.21,790,7794,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007nt','SDSS J030643.76-004514.6',0.2129,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29033,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 18927','R',29033,40.1,0.13,864,7794,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007nt','SDSS J030643.76-004514.6',0.2129,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29034,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',29034,38.35,0.15,468,7795,70,NULL,NULL,'2MASX J03064558-0011590',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000078,NULL,'17.3g',0.09,NULL,NULL,NULL,NULL,NULL,1,46.6899166667,-0.19969,0.161,NULL,36778037702,574656839,8979013,17.3),(29035,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29035,36.32,0.71,183,7796,70,NULL,NULL,'6dF J0306472-094804',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,46.697125,-9.80106,0.245,NULL,37900970309,592202661,9253166,16.6),(29036,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 14561',NULL,29036,40.81,0.25,1450,7797,70,NULL,'SN photometric redshift distance, z photo =0.424 +/- 0.068','SDSS-II SN 14561',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,46.6987917,0.94942,0.197,NULL,64965546491,1015086663,15860729,NULL),(29037,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 09218',NULL,29037,39.8,0.29,914,7798,70,NULL,'SN photometric redshift distance, z photo =0.242 +/- 0.040','SDSS-II SN 09218',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,46.7015,-0.7005,0.173,NULL,36779234748,574675542,8979305,NULL),(29038,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29038,35.7,0.67,138,7799,70,NULL,NULL,'2MASX J03064885-0956019',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'16.60',0.23,NULL,NULL,NULL,NULL,NULL,1,46.703583,-9.93392,0.233,NULL,37900911768,592201746,9253152,16.6),(29039,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 00837','RN',29039,41.5,0.15,1840,7800,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 00837',0.084031,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29040,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29040,32.38,0.51,30,7801,70,NULL,NULL,'NGC 1211',NULL,'2014MNRAS.445.2677S',2014,1,1.53,NULL,'G',0.000023,NULL,'13.2g',1.07,'(R)SB(r)0/a',NULL,NULL,NULL,NULL,1,46.7184166667,-0.79447,0.173,NULL,36779746673,574683541,8979430,13.2),(29041,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29041,32.27,0.69,28.5,7801,100,NULL,'mid-IR','NGC 1211',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29042,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29042,33.69,0.48,54.7,7802,70,NULL,NULL,'NGC 1214',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00005,NULL,'14.30',0.3,'SB(rs)0+?','Field galaxy',NULL,NULL,NULL,1,46.7334166667,-9.54417,0.257,NULL,37901004925,592203201,9253175,14.3),(29043,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',29043,37.25,0.46,281,7803,70,NULL,NULL,'SDSS J030656.91-064005.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000093,NULL,'18.3g',0.15,'NLAGN',NULL,NULL,NULL,NULL,1,46.737125,-6.66828,0.257,NULL,37905654273,592275848,9254310,18.3),(29044,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29044,35.09,0.51,104,7804,70,NULL,NULL,'2MASX J03070018-7347181',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00012,NULL,'15.4b',0.24,NULL,NULL,NULL,NULL,NULL,1,46.750583,-73.78839,0.165,NULL,35517591774,554962371,8671287,15.4),(29045,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29045,33.72,0.4,55.4,7805,NULL,NULL,'mean','UGC 02540',NULL,'2007A&A...465...71T',2007,1,1.96,NULL,'G',0.000019,NULL,'15.49',0.21,'Sbc',NULL,NULL,NULL,NULL,1,46.752417,36.16767,0.629,NULL,68717476019,1073710562,16776727,15.49),(29046,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29046,33.88,0.46,59.6,7805,NULL,NULL,'J','UGC 02540',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29047,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29047,33.88,0.47,59.6,7805,NULL,NULL,'H','UGC 02540',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29048,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',29048,33.91,0.49,60.6,7805,75,NULL,'IR','UGC 02540',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29049,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29049,33.93,0.45,61,7805,NULL,NULL,'K','UGC 02540',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29050,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29050,34.74,NULL,88.8,7805,NULL,NULL,'Dipole','UGC 02540',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29051,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29051,34.75,NULL,89,7805,NULL,NULL,'Dipole + Quadrupole','UGC 02540',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29052,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29052,34.75,NULL,89.3,7805,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02540',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29053,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29053,34.84,NULL,93.1,7805,NULL,NULL,NULL,'UGC 02540',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29054,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29054,35.1,0.43,105,7805,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02540',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29055,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',29055,37.34,0.46,294,7806,70,NULL,NULL,'2MASXi J0307025-081633',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000109,NULL,'17.5g',0.18,'BLAGN',NULL,NULL,NULL,'Sy 1',1,46.760625,-8.276,0.261,NULL,37906616573,592290883,9254545,17.5),(29056,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29056,37.05,0.67,257,7807,70,NULL,NULL,'2MASX J03070335-1240417',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.39',0.38,NULL,NULL,NULL,NULL,NULL,1,46.763875,-12.67825,0.161,NULL,38072447250,594881988,9295031,16.39),(29057,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',29057,38.35,0.15,468,7808,70,NULL,NULL,'2MASX J03070432+0000500',NULL,'2015arXiv151105856S',2015,1,0.08,NULL,'G',0.000073,NULL,'17.8g',0.07,NULL,NULL,NULL,NULL,NULL,1,46.767917,0.01383,0.181,NULL,64963051666,1015047682,15860120,17.8),(29058,'Tully est','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29058,31.31,0.8,18.3,7809,75,NULL,NULL,'UGCA 052',NULL,'1988NBGC.C....0000T',1988,1,1.5,'Confused HIPASS source','G',0.00002,NULL,'16',1.2,'SB(s)m:',NULL,NULL,NULL,NULL,1,46.7685417,-14.00361,0.165,NULL,38073420809,594897200,9295268,16),(29059,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',29059,37.33,0.46,292,7810,70,NULL,NULL,'2MASX J03070871-0720264',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000084,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,46.786375,-7.34083,0.277,NULL,37907282651,592301291,9254707,17.4),(29060,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 2005ez',NULL,29060,38.18,0.14,383,7811,74.2,NULL,'SALT 2','SDSS J030711.02+010711.9',0.13,'2010ApJ...716..712A',2010,1,0.11,NULL,'G',NULL,NULL,'19.5g',0.08,NULL,NULL,NULL,NULL,NULL,1,46.7959166667,1.12,0.189,NULL,64965510601,1015086103,15860720,19.5),(29061,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 2005ez',NULL,29061,38.8,0.18,509,7811,65,NULL,'SALT2','SDSS J030711.02+010711.9',0.13,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29062,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 2005ez',NULL,29062,38.8,0.1,509,7811,65,NULL,'MLCS2k2','SDSS J030711.02+010711.9',0.13,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29063,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 01032','R',29063,38.8,0.2,509,7811,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ez','SDSS J030711.02+010711.9',0.13,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29064,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 2005ez',NULL,29064,38.85,0.15,520,7811,70,NULL,'SALT 2','SDSS J030711.02+010711.9',0.13,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29065,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 01032','R',29065,38.91,0.11,536,7811,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ez','SDSS J030711.02+010711.9',0.13,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29066,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 2005ez',NULL,29066,38.66,0.12,540,7811,70,NULL,'SALT 2','SDSS J030711.02+010711.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29067,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 2005ez',NULL,29067,38.67,0.12,542,7811,70,NULL,'SALT 2, Malmquist cor.','SDSS J030711.02+010711.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29068,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SN 2005ez',NULL,29068,40.21,0.04,974,7811,70,NULL,'SDSS-II SN 01032','SDSS J030711.02+010711.9',0.13,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29069,'Ring Diameter','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29069,32.6,0.84,33,7812,NULL,NULL,'Published at H = 100 km/s/Mpc','ESO 417- G 018',NULL,'1981ApJS...45..541P',1981,1,2.5,NULL,'G',0.000007,NULL,'14.07',1.4,'SAB(r)c',NULL,NULL,NULL,NULL,1,46.8049583,-31.40072,0,NULL,38616019360,603375302,9427739,14.07),(29070,'IRAS','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29070,33.95,0.8,61.5,7812,75,NULL,'MAT, I','ESO 417- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29071,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29071,33.45,0.32,49,7812,85,NULL,'I, raw','ESO 417- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29072,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29072,33.49,0.32,49.8,7812,85,NULL,'I, inv','ESO 417- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29073,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29073,33.75,0.43,56.3,7812,75,NULL,'MAT, I, raw','ESO 417- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29074,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29074,33.93,0.43,61.1,7812,NULL,NULL,NULL,'ESO 417- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29075,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29075,33.95,0.43,61.8,7812,75,NULL,'MAT, I, inv','ESO 417- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29076,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29076,34.02,0.2,63.7,7812,74.4,NULL,NULL,'ESO 417- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29077,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29077,34.08,0.43,65.6,7812,75,NULL,'MAT, I, cor','ESO 417- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29078,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29078,34.13,0.39,66.9,7812,NULL,NULL,'Malmquist cor.','ESO 417- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29079,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29079,36.73,0.57,222,7813,70,NULL,NULL,'2MASX J03071523-0215259',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00015,NULL,'16.68',0.31,NULL,NULL,NULL,NULL,NULL,1,46.813625,-2.25714,0.121,NULL,36777583166,574649736,8978902,16.68),(29080,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',29080,36.09,0.17,165,7814,70,NULL,NULL,'2MASX J03072325-0059007',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000064,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,46.8467917,-0.9835,0.165,NULL,36779759021,574683734,8979433,16.8),(29081,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',29081,37.8,0.33,363,7815,70,NULL,NULL,'2MASX J03072338-0101107',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000086,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,46.8474583,-1.01978,0.165,NULL,36779769277,574683894,8979435,17.5),(29082,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',29082,33.36,0.49,47,7816,75,NULL,'IR','UGC 02543',NULL,'2011yCatp016004901K',2011,1,1.9,NULL,'G',0.000023,NULL,'14.59',0.6,'SAdm',NULL,NULL,NULL,NULL,1,46.847375,37.83608,0.509,NULL,68691802284,1073309410,16770459,14.59),(29083,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29083,34.98,0.47,98.9,7817,70,NULL,NULL,'CGCG 389-084',NULL,'2014MNRAS.445.2677S',2014,1,1.01,NULL,'G',0.000083,NULL,'14.2g',0.81,'E0',NULL,NULL,NULL,NULL,1,46.8845833333,-0.96453,0.165,NULL,36779758491,574683726,8979433,14.2),(29084,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',29084,36.09,0.17,165,7817,70,NULL,NULL,'CGCG 389-084',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29085,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 16152','R',29085,40.75,0.13,1110,7818,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16152',0.272,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,46.9084583,0.98769,0.189,NULL,64964694887,1015073357,15860521,NULL),(29086,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 16152','R',29086,40.98,0.26,1240,7818,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16152',0.272,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29087,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 08276','RN',29087,42.16,0.45,1840,7819,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 08276',0.472,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29088,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29088,34.75,0.25,89.1,7820,74.4,NULL,NULL,'GIN 175',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000063,NULL,'13.81',0.6,'E/S0',NULL,NULL,NULL,NULL,1,46.9354583,-4.31931,0.129,NULL,37859194795,591549918,9242967,13.81),(29089,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29089,34.94,0.22,97.2,7820,70,NULL,NULL,'GIN 175',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29090,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 07865','RN',29090,41.06,0.07,1140,7821,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 07865',0.427692,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29091,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29091,36.44,0.56,194,7822,70,NULL,NULL,'2MASX J03074722-7702011',NULL,'2014MNRAS.445.2677S',2014,1,0.32,NULL,'G',0.00015,NULL,'16.5b',0.15,NULL,NULL,NULL,NULL,NULL,1,46.9467916667,-77.03367,0.345,NULL,35647827467,556997304,8703082,16.5),(29092,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29092,35.19,0.08,109,7823,NULL,NULL,NULL,'IC 1882',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.00005,NULL,'14.92',0.5,'Sbc',NULL,NULL,NULL,NULL,1,46.955417,3.14789,0.261,NULL,67928904739,1061389136,16584205,14.92),(29093,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29093,35.21,0.2,110,7823,74.4,NULL,NULL,'IC 1882',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29094,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29094,37.27,0.25,284,7824,74.4,NULL,NULL,'GIN 188',NULL,'2013AJ....146...86T',2013,1,0.33,NULL,'G',0.000033,NULL,'15.89',0.25,'S',NULL,NULL,NULL,NULL,1,46.961125,-23.81464,0.021,NULL,38020763171,594074424,9282412,15.89),(29095,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29095,37.48,0.18,314,7824,70,NULL,NULL,'GIN 188',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29096,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29096,36.16,0.81,170,7825,70,NULL,NULL,'2MASX J03075186-6957505',NULL,'2014MNRAS.445.2677S',2014,1,0.28,NULL,'G',0.00015,NULL,'16.0b',0.19,NULL,NULL,NULL,NULL,NULL,1,46.966,-69.96403,0.053,NULL,36453271163,569582361,8899724,16),(29097,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',29097,36.93,0.46,244,7826,70,NULL,NULL,'2MASX J03075506-0056473',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000081,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,46.97925,-0.94664,0.137,NULL,36778874063,574669907,8979217,17.3),(29098,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 06465','RN',29098,39.86,0.11,863,7827,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 06465',0.086876,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29099,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 06465','RN',29099,40.39,0.21,1100,7827,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 06465',0.086876,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29100,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29100,34.75,0.25,89.1,7828,74.4,NULL,NULL,'IC 1886',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000067,NULL,'15.08',0.7,'E',NULL,NULL,NULL,NULL,1,47.0135,-4.39983,0.129,NULL,37859188884,591549826,9242966,15.08),(29101,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29101,34.94,0.22,97.2,7828,70,NULL,NULL,'IC 1886',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29102,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29102,37.27,0.25,284,7829,74.4,NULL,NULL,'GIN 187',NULL,'2013AJ....146...86T',2013,1,0.35,NULL,'G',0.000033,NULL,'15.73',0.3,'S',NULL,NULL,NULL,NULL,1,47.014,-23.59731,0.009,NULL,38019633590,594056774,9282137,15.73),(29103,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29103,37.48,0.18,314,7829,70,NULL,NULL,'GIN 187',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29104,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 03539',NULL,29104,40.98,0.55,1570,7830,70,NULL,'SN photometric redshift distance, z photo =0.468 +/- 0.200','SDSS-II SN 03539',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,47.0155417,-0.12828,0.137,NULL,36778202990,574659421,8979053,NULL),(29105,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 11311','R',29105,39.8,0.23,756,7831,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J030803.69+002600.5',0.2046,'2014arXiv1401.3317S',2014,1,0.09,NULL,'G',0.0001,NULL,'19.8g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,47.015417,0.43347,0.225,NULL,64963118604,1015048728,15860136,19.8),(29106,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 11311',NULL,29106,39.62,0.17,839,7831,70,NULL,'SALT 2','SDSS J030803.69+002600.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29107,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 11311',NULL,29107,39.63,0.17,843,7831,70,NULL,'SALT 2, Malmquist cor.','SDSS J030803.69+002600.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29108,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 11311','R',29108,40.06,0.15,853,7831,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J030803.69+002600.5',0.2046,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29109,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29109,36.73,0.58,222,7832,70,NULL,NULL,'2MASX J03080395-1252535',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.39',0.36,NULL,NULL,NULL,NULL,NULL,1,47.0164583,-12.88175,0.185,NULL,38075213563,594925211,9295706,16.39),(29110,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',29110,36.39,0.46,190,7833,70,NULL,NULL,'2MASX J03080537-0721580',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000115,NULL,'15.6g',0.46,'E0',NULL,NULL,NULL,NULL,1,47.022417,-7.36628,0.281,NULL,37908036236,592313066,9254891,15.6),(29111,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29111,35.73,0.68,140,7834,70,NULL,NULL,'2MASX J03080546-0058423',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.000077,NULL,'16.1g',0.44,'S0',NULL,NULL,NULL,NULL,1,47.0227917,-0.97853,0.137,NULL,36778923987,574670687,8979229,16.1),(29112,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,'R',29112,35.78,0.46,144,7835,70,NULL,NULL,'2MASX J03080665-0714030',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000074,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,47.0277917,-7.23436,0.277,NULL,37908069552,592313586,9254899,17.4),(29113,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 10054','RN',29113,40.32,0.26,1070,7836,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 10054',0.078157,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29114,'SNIa SDSS','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 10054','RN',29114,40.33,0.15,1080,7836,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 10054',0.078157,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29115,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29115,35.79,0.66,144,7837,70,NULL,NULL,'2MASX J03081021-1517095',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'16.29',0.28,NULL,NULL,NULL,NULL,NULL,1,47.0425,-15.28592,0.057,NULL,38103180466,595362194,9302534,16.29),(29116,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29116,37.29,0.25,287,7838,74.4,NULL,NULL,'GIN 178',NULL,'2013AJ....146...86T',2013,1,0.31,NULL,'G',0.000033,NULL,'15.97',0.2,'S',NULL,NULL,NULL,NULL,1,47.044875,-23.68125,0.021,NULL,38020771636,594074556,9282414,15.97),(29117,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29117,37.48,0.18,314,7838,70,NULL,NULL,'GIN 178',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29118,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29118,34.9,0.52,95.7,7839,70,NULL,NULL,'NGC 1228',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00012,NULL,'14.59',0.9,'(R\')SB(rs)0+ pec:','in a chain',NULL,NULL,NULL,1,47.048917,-22.92286,0.013,NULL,38020241922,594066280,9282285,14.59),(29119,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29119,35.69,0.57,137,7840,70,NULL,NULL,'2MASX J03081175-0408553',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.87',0.23,NULL,NULL,NULL,NULL,NULL,1,47.049,-4.14875,0.141,NULL,37859851641,591560181,9243127,16.87),(29120,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29120,34.01,0.45,63.3,7841,NULL,NULL,'K','NGC 1207',NULL,'2007A&A...465...71T',2007,1,2.3,NULL,'G',0.000033,NULL,'13.38',1.7,'SA(rs)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,47.0645417,38.38217,0.569,NULL,68691722376,1073308162,16770440,13.38),(29121,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29121,34.02,0.47,63.7,7841,NULL,NULL,'H','NGC 1207',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29122,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29122,34.03,0.4,63.9,7841,NULL,NULL,'mean','NGC 1207',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29123,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29123,34.08,0.46,65.4,7841,NULL,NULL,'J','NGC 1207',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29124,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29124,34.25,0.49,70.8,7842,70,NULL,NULL,'NGC 1221',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.60',0.4,'SB(r)0+? sp',NULL,NULL,NULL,NULL,1,47.0647083,-4.25947,0.129,NULL,37859669506,591557336,9243083,14.6),(29125,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29125,33.2,0.2,43.7,7843,74.4,NULL,NULL,'UGC 02550',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000033,NULL,'14.72',0.8,'Scd:',NULL,NULL,NULL,NULL,1,47.065333,36.44961,0.629,NULL,68717612514,1073712695,16776760,14.72),(29126,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29126,33.43,0.46,48.4,7843,NULL,NULL,NULL,'UGC 02550',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29127,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29127,33.83,0.38,58.4,7843,NULL,NULL,'Malmquist cor.','UGC 02550',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29128,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29128,37.29,0.25,287,7844,74.4,NULL,NULL,'GIN 179',NULL,'2013AJ....146...86T',2013,1,0.29,NULL,'G',0.00004,NULL,'15.53',0.23,'E',NULL,NULL,NULL,NULL,1,47.0657917,-23.6795,0.021,NULL,38020771123,594074548,9282414,15.53),(29129,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29129,37.48,0.18,314,7844,70,NULL,NULL,'GIN 179',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29130,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29130,37.28,0.25,286,7845,74.4,NULL,NULL,'GIN 177',NULL,'2013AJ....146...86T',2013,1,0.55,NULL,'G',0.000043,NULL,'16.17',0.43,'cD;S0','Brightest group member',NULL,NULL,NULL,1,47.0657917,-23.69217,0.021,NULL,38020770151,594074533,9282414,16.17),(29131,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29131,37.48,0.18,314,7845,70,NULL,NULL,'GIN 177',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29132,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29132,37.27,0.25,284,7846,74.4,NULL,NULL,'GIN 184',NULL,'2013AJ....146...86T',2013,1,0.48,NULL,'G',0.000037,NULL,'14.76',0.42,'S0',NULL,NULL,NULL,NULL,1,47.0678333333,-23.56369,0.009,NULL,38019653139,594057080,9282141,14.76),(29133,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29133,37.48,0.18,314,7846,70,NULL,NULL,'GIN 184',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29134,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29134,35.75,0.6,141,7847,70,NULL,NULL,'NGC 1230',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'15.37',0.4,'SB0^0^? pec','in a chain',NULL,NULL,NULL,1,47.0683333333,-22.984,0.013,NULL,38020249046,594066391,9282287,15.37),(29135,'SNIa','2016-12-15 15:13:57','2016-12-16 11:19:01','1','SDSS-II SN 11314',NULL,29135,39.28,0.73,717,7848,70,NULL,'SN photometric redshift distance, z photo =0.184 +/- 0.085','SDSS-II SN 11314',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.9g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,47.07525,0.95925,0.193,NULL,64964714541,1015073664,15860526,22.9),(29136,'Tully-Fisher','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29136,29.98,0.43,9.9,7849,75,NULL,'3.6 micron, color + selection bias corrected','MRK 1069',NULL,'2014MNRAS.444..527S',2014,1,0.9,'Confused HIPASS source','G',0.00001,NULL,'14.47',0.3,NULL,NULL,NULL,NULL,NULL,1,47.07925,-13.90294,0.165,NULL,38075446924,594928858,9295763,14.47),(29137,'FP','2016-12-15 15:13:57','2016-12-16 11:19:01','1',NULL,NULL,29137,34.75,0.25,89.1,7850,74.4,NULL,NULL,'NGC 1223',NULL,'2013AJ....146...86T',2013,1,1.8,NULL,'G',0.000057,NULL,'14.42',1.7,'cD',NULL,NULL,NULL,NULL,1,47.0830417,-4.13839,0.141,NULL,37859849025,591560141,9243127,14.42),(29138,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29138,34.94,0.22,97.2,7850,70,NULL,NULL,'NGC 1223',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29139,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29139,37.48,0.18,314,7851,70,NULL,NULL,'GIN 183',NULL,'2001MNRAS.321..277C',2001,1,0.48,NULL,'G',0.000033,NULL,'14.79',0.31,'S',NULL,NULL,NULL,NULL,1,47.084083,-23.62547,0.009,NULL,38020715083,594073673,9282401,14.79),(29140,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29140,35.81,0.63,145,7852,70,NULL,NULL,'2MASX J03082135-5146208',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'16.36',0.2,'S',NULL,NULL,NULL,NULL,1,47.0890417,-51.77247,0,NULL,38455303981,600864124,9388501,16.36),(29141,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29141,37.26,0.25,283,7853,74.4,NULL,NULL,'GIN 182',NULL,'2013AJ....146...86T',2013,1,0.52,'6dF DR2 has z = 0.014482.','G',0.000037,NULL,'15.02',0.41,'S',NULL,NULL,NULL,NULL,1,47.089917,-23.64633,0.021,NULL,38020715276,594073676,9282401,15.02),(29142,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29142,37.48,0.18,314,7853,70,NULL,NULL,'GIN 182',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29143,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29143,36.01,0.63,159,7854,70,NULL,NULL,'2MASX J03082395-6853044',NULL,'2014MNRAS.445.2677S',2014,1,0.24,NULL,'G',0.00015,NULL,'16.3b',0.23,NULL,NULL,NULL,NULL,NULL,1,47.0998333333,-68.8845,0.061,NULL,36445545327,569461645,8897838,16.3),(29144,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29144,35.92,0.46,153,7855,70,NULL,NULL,'2MASX J03082433-0805280',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000069,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,47.1014583,-8.09108,0.261,NULL,37907048069,592297626,9254650,16.6),(29145,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29145,35.96,0.33,155,7856,70,NULL,NULL,'2MASX J03082645+0033178',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000104,NULL,'15.8g',0.31,'S0^-',NULL,NULL,NULL,NULL,1,47.110167,0.55508,0.225,NULL,64963239550,1015050617,15860165,15.8),(29146,'Tully est','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29146,32.73,0.8,35.2,7857,75,NULL,NULL,'IC 1892',NULL,'1988NBGC.C....0000T',1988,1,NULL,'Part of the GGroup Arp 332.','GPair',0.000007,NULL,NULL,NULL,'SB(s)d pec',NULL,NULL,NULL,NULL,1,47.115833,-23.05444,0.017,NULL,38020210661,594065791,9282277,NULL),(29147,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29147,32.88,0.43,37.7,7857,75,NULL,'3.6 micron, color corrected','IC 1892',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29148,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29148,32.88,0.43,37.7,7857,75,NULL,'3.6 micron, color + selection bias corrected','IC 1892',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29149,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29149,32.89,0.2,37.8,7857,74.4,NULL,NULL,'IC 1892',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29150,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29150,37.28,0.25,286,7858,74.4,NULL,NULL,'GIN 180',NULL,'2013AJ....146...86T',2013,1,0.31,NULL,'G',0.000033,NULL,'15.60',0.28,'E',NULL,NULL,NULL,NULL,1,47.1168333333,-23.77492,0.021,NULL,38020767305,594074489,9282413,15.6),(29151,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29151,37.48,0.18,314,7858,70,NULL,NULL,'GIN 180',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29152,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29152,36.03,0.49,161,7859,70,NULL,NULL,'2MASX J03082879-2336527',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,47.12,-23.61469,0.009,NULL,38019606062,594056344,9282130,15.9),(29153,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 09118','R',29153,38.21,0.09,387,7860,70,NULL,'SDSS CAND. SNIc; MLCS2K2; SN 2005kr','SN 2005kr',0.1338,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ib/c',NULL,NULL,NULL,NULL,1,47.123583,0.88894,0.193,NULL,64962818633,1015044041,15860063,NULL),(29154,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 09118','R',29154,38.48,0.19,439,7860,70,NULL,'SDSS CAND. SNIc; SALT 2; SN 2005kr','SN 2005kr',0.1338,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29155,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 12200','RN',29155,38.6,0.58,462,7861,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 12200',0.13809,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29156,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 12200','RN',29156,38.85,0.26,518,7861,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 12200',0.13809,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29157,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29157,35.32,0.47,116,7862,NULL,NULL,'H','UGC 02553',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000032,NULL,'14.73',0.8,'SB(rs)b',NULL,NULL,NULL,NULL,1,47.1279583333,20.77222,0.461,NULL,68125756426,1064464944,16632264,14.73),(29158,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29158,35.33,0.4,116,7862,NULL,NULL,'mean','UGC 02553',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29159,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29159,37.27,0.25,284,7863,74.4,NULL,NULL,'GIN 181',NULL,'2013AJ....146...86T',2013,1,0.37,NULL,'G',0.000297,NULL,'15.59',0.36,'S',NULL,NULL,NULL,NULL,1,47.138167,-23.79831,0.033,NULL,38020764024,594074437,9282413,15.59),(29160,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29160,37.48,0.18,314,7863,70,NULL,NULL,'GIN 181',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29161,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29161,35.96,0.33,155,7864,70,NULL,NULL,'2MASX J03083432+0033028',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000085,NULL,'16.1g',0.36,'BLAGN',NULL,NULL,NULL,'Sy 1',1,47.1429583333,0.55092,0.225,NULL,64963236680,1015050573,15860165,16.1),(29162,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29162,36.47,0.92,197,7865,70,NULL,NULL,'2MASX J03084279-1102561',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.33',0.3,NULL,NULL,NULL,NULL,NULL,1,47.17825,-11.04881,0.209,NULL,37895468672,592116698,9251823,16.33),(29163,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 16622','RN',29163,38.83,0.9,543,7866,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 16622',0.075863,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29164,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 16622','RN',29164,39.31,0.45,678,7866,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 16622',0.075863,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29165,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29165,37.2,0.46,276,7867,70,NULL,NULL,'2MASX J03084654-0648511',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000069,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,47.1938333333,-6.81422,0.213,NULL,37907793374,592309271,9254832,17.2),(29166,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29166,34.73,0.46,88.4,7868,70,NULL,NULL,'NGC 1225',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00012,NULL,'14.85',0.3,'(R)SB(rs)0/a',NULL,NULL,NULL,NULL,1,47.19675,-4.10156,0.129,NULL,37859884002,591560687,9243135,14.85),(29167,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SN 2005eq',NULL,29167,34.84,0.17,90.3,7869,74.2,NULL,'SALT 2','MCG -01-09-006',0.028977,'2010ApJ...716..712A',2010,1,1.63,NULL,'G',0.000075,NULL,'14.6g',0.45,'SB(rs)cd?',NULL,NULL,NULL,NULL,1,47.201333,-7.04061,0.277,NULL,37908102754,592314105,9254907,14.6),(29168,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SN 2005eq',NULL,29168,35.35,0.06,114,7869,72,NULL,NULL,'MCG -01-09-006',0.028977,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29169,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SN 2005eq',NULL,29169,35.41,0.14,114,7869,72,NULL,NULL,'MCG -01-09-006',0.02837,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29170,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SN 2005eq',NULL,29170,35.39,0.05,116,7869,72,NULL,NULL,'MCG -01-09-006',0.028977,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29171,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SN 2005eq',NULL,29171,35.33,0.01,116,7869,72,NULL,NULL,'MCG -01-09-006',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29172,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SN 2005eq',NULL,29172,35.39,0.03,116,7869,70,NULL,'SALT 2','MCG -01-09-006',0.028977,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29173,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SN 2005eq',NULL,29173,35.44,0.03,119,7869,72,NULL,NULL,'MCG -01-09-006',0.028977,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29174,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SN 2005eq',NULL,29174,35.39,0.09,120,7869,74.4,NULL,NULL,'MCG -01-09-006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29175,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SN 2005eq',NULL,29175,35.49,0.14,122,7869,72,NULL,NULL,'MCG -01-09-006',0.028977,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29176,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SN 2005eq',NULL,29176,35.49,0.03,122,7869,72,NULL,NULL,'MCG -01-09-006',0.028977,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29177,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SN 2005eq',NULL,29177,35.5,0.16,122,7869,70,NULL,'SALT 2','MCG -01-09-006',0.028977,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29178,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SN 2005eq',NULL,29178,35.48,0.04,125,7869,72,NULL,'M(H) = -18.317 mag','MCG -01-09-006',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29179,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SN 2005eq','R',29179,35.52,0.06,127,7869,NULL,NULL,'MLCS2k2, R(V) = 3.1','MCG -01-09-006',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29180,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SN 2005eq',NULL,29180,35.6,0.19,128,7869,73.8,NULL,'SALT 2 (SNANA)','MCG -01-09-006',0.0291,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29181,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SN 2005eq','R',29181,35.54,0.05,128,7869,NULL,NULL,'MLCS2k2, R(V) = 1.8','MCG -01-09-006',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29182,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SN 2005eq',NULL,29182,35.61,0.21,129,7869,73.8,NULL,'SALT 2 (SNANA)','MCG -01-09-006',0.0291,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29183,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SN 2005eq',NULL,29183,35.67,0.19,132,7869,65,NULL,'SALT2','MCG -01-09-006',0.028977,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29184,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SN 2005eq',NULL,29184,35.73,0.17,136,7869,65,NULL,'SALT','MCG -01-09-006',0.028977,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29185,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SN 2005eq',NULL,29185,35.8,0.15,140,7869,65,NULL,'MLCS17','MCG -01-09-006',0.028977,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29186,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SN 2005eq',NULL,29186,35.89,0.15,146,7869,65,NULL,'MLCS31','MCG -01-09-006',0.028977,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29187,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29187,35.03,0.43,101,7869,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-09-006',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29188,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29188,37.28,0.25,286,7870,74.4,NULL,NULL,'GIN 185',NULL,'2013AJ....146...86T',2013,1,0.43,NULL,'G',0.000033,NULL,'15.11',0.39,'E/S0',NULL,NULL,NULL,NULL,1,47.2020417,-23.43517,0,NULL,38020063336,594063489,9282242,15.11),(29189,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29189,37.48,0.18,314,7870,70,NULL,NULL,'GIN 185',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29190,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 01525','R',29190,39.37,0.07,676,7871,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 01525',0.1072,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,47.2080417,0.15833,0.229,NULL,64963285650,1015051338,15860177,NULL),(29191,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 01525','R',29191,39.74,0.22,800,7871,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 01525',0.1072,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29192,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29192,38.13,0.46,423,7872,70,NULL,NULL,'2MASX J03085046+0005452',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00011,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,47.21025,0.09589,0.221,NULL,64962569504,1015040148,15860002,17.3),(29193,'Tully est','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29193,32.46,0.8,31,7873,75,NULL,NULL,'NGC 1222',NULL,'1988NBGC.C....0000T',1988,1,1.1,NULL,'G',0.000017,NULL,'13.62',0.9,'S0- pec:       HII','Group member, radial-velocity confirmed',NULL,NULL,'Starburst',1,47.236417,-2.95514,0.121,NULL,36790348510,574849195,8982018,13.62),(29194,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29194,33.76,0.43,56.6,7874,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-09-003',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.00013,NULL,'13.3B',0.6,'(R\')SB(r)a pec?','Field galaxy',NULL,NULL,NULL,1,47.287375,-10.29308,0.261,NULL,37894460530,592100945,9251577,13.3),(29195,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29195,37.61,0.46,333,7875,70,NULL,NULL,'SDSS J030913.07-061711.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000081,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,47.3045,-6.28658,0.205,NULL,37904192274,592253004,9253953,18.3),(29196,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29196,35.96,0.56,156,7876,70,NULL,NULL,'2MASX J03091342-1926360',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.64',0.52,'S0',NULL,NULL,NULL,NULL,1,47.3059583,-19.44333,0.037,NULL,38058799989,594668749,9291699,15.64),(29197,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29197,35.73,0.48,140,7877,70,NULL,NULL,'2MASX J03091433-4003132',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.64',0.24,NULL,NULL,NULL,NULL,NULL,1,47.3097083,-40.05358,0,NULL,38596268047,603066688,9422917,16.64),(29198,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 18201','R',29198,40.83,0.19,1130,7878,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J030915.31-003838.4',0.2931,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',0.0001,NULL,'21.4g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,47.3137917,-0.644,0.137,NULL,36778777539,574668399,8979193,21.4),(29199,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 18201','R',29199,40.83,0.27,1130,7878,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J030915.31-003838.4',0.2931,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29200,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 18201',NULL,29200,40.71,0.23,1390,7878,70,NULL,'SALT 2','SDSS J030915.31-003838.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29201,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 18201',NULL,29201,40.74,0.23,1410,7878,70,NULL,'SALT 2, Malmquist cor.','SDSS J030915.31-003838.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29202,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29202,36.09,0.17,165,7879,70,NULL,NULL,'CGCG 390-009',NULL,'2015arXiv151105856S',2015,1,0.62,'6dF final data release has z = -0.000163 +- 0.000150.','G',0.000106,NULL,'15.4g',0.47,'E0',NULL,NULL,NULL,NULL,1,47.32075,-0.90667,0.109,NULL,36778491167,574663924,8979123,15.4),(29203,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29203,33.63,0.25,53.2,7880,74.4,NULL,NULL,'UGC 02559',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000047,NULL,'14.0',0.7,'S0',NULL,NULL,NULL,NULL,1,47.3264583,42.97214,0.961,NULL,68563111730,1071298620,16739040,14),(29204,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29204,34.25,0.45,70.8,7880,NULL,NULL,'K','UGC 02559',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29205,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29205,34.39,0.4,75.6,7880,NULL,NULL,'mean','UGC 02559',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29206,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29206,32.05,0.43,25.7,7881,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02519',NULL,'2014MNRAS.444..527S',2014,1,1.2,NULL,'G',0.00003,NULL,'14.30',0.7,'Scd?','in a pair',NULL,NULL,NULL,1,47.327625,80.13061,0.913,NULL,65752757816,1027386840,16052919,14.3),(29207,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29207,32.17,0.43,27.2,7881,75,NULL,'3.6 micron, color corrected','UGC 02519',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29208,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29208,32.21,0.2,27.7,7881,74.4,NULL,NULL,'UGC 02519',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29209,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29209,32.26,0.45,28.3,7881,NULL,NULL,'K','UGC 02519',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29210,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29210,32.31,0.46,29,7881,NULL,NULL,'J','UGC 02519',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29211,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29211,32.31,0.47,29,7881,NULL,NULL,'H','UGC 02519',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29212,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29212,32.53,0.4,32,7881,NULL,NULL,'mean','UGC 02519',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29213,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 19459',NULL,29213,39.41,0.19,762,7882,70,NULL,'SN photometric redshift distance, z photo =0.197 +/- 0.020','SDSS-II SN 19459',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,47.33325,-0.73489,0.137,NULL,36778643412,574666303,8979160,NULL),(29214,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29214,37.18,0.46,273,7883,70,NULL,NULL,'2MASX J03092006+0043580',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000088,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,47.333583,0.73292,0.201,NULL,64963366890,1015052607,15860196,16.8),(29215,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29215,36.77,0.7,226,7884,70,NULL,NULL,'GIN 186',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.000033,NULL,'14.88',0.36,'S',NULL,NULL,NULL,NULL,1,47.3337917,-23.42869,0,NULL,38020067366,594063552,9282243,14.88),(29216,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29216,37.48,0.18,314,7884,70,NULL,NULL,'GIN 186',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29217,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29217,36.24,0.66,177,7885,70,NULL,NULL,'2MASX J03092105-0221038',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.97',0.28,NULL,NULL,NULL,NULL,NULL,1,47.3376666667,-2.35108,0.133,NULL,36790472357,574851130,8982048,16.97),(29218,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29218,36.29,0.64,181,7886,70,NULL,NULL,'2MASX J03092427-0906393',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.40',0.28,NULL,'Field galaxy',NULL,NULL,NULL,1,47.3511666667,-9.11114,0.217,NULL,37888207180,592003237,9250050,16.4),(29219,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29219,36.67,0.69,216,7887,70,NULL,NULL,'2MASX J03092806-0200028',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.71',0.31,NULL,NULL,NULL,NULL,NULL,1,47.36675,-2.00083,0.145,NULL,36777129849,574642653,8978791,16.71),(29220,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29220,34.32,0.51,73,7888,70,NULL,NULL,'MCG -02-09-005',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.45',0.4,'E/S0','Field galaxy',NULL,NULL,NULL,1,47.3890416667,-9.81692,0.265,NULL,37893620281,592087816,9251372,15.45),(29221,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29221,32.62,NULL,33.4,7889,NULL,NULL,NULL,'ESO 547- G 012',NULL,'2000BSAO...50....5K',2000,1,1.18,NULL,'G',0.000017,NULL,'16.75',0.13,'Sdm',NULL,NULL,NULL,NULL,1,47.403625,-17.83153,0.097,NULL,38113419686,595522182,9305034,16.75),(29222,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29222,32.82,NULL,36.6,7889,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 547- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29223,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29223,32.83,NULL,36.8,7889,NULL,NULL,'Dipole + Quadrupole','ESO 547- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29224,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29224,32.85,NULL,37.1,7889,NULL,NULL,'Dipole','ESO 547- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29225,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29225,33.12,0.43,42,7889,75,NULL,'3.6 micron, color + selection bias corrected','ESO 547- G 012',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29226,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29226,35.49,0.36,125,7890,NULL,NULL,'Malmquist cor.','UGC 02563',NULL,'2009ApJS..182..474S',2009,1,1.55,NULL,'G',0.000014,NULL,'15.34',0.18,'Scd',NULL,NULL,NULL,NULL,1,47.4038333333,18.50064,0.329,NULL,68173738725,1065214667,16643979,15.34),(29227,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29227,35.57,0.35,130,7890,NULL,NULL,NULL,'UGC 02563',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29228,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29228,35.64,NULL,134,7890,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02563',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29229,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29229,35.65,NULL,135,7890,NULL,NULL,NULL,'UGC 02563',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29230,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29230,35.65,NULL,135,7890,NULL,NULL,'Dipole + Quadrupole','UGC 02563',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29231,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29231,35.66,NULL,136,7890,NULL,NULL,'Dipole','UGC 02563',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29232,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29232,35.67,0.2,136,7890,74.4,NULL,NULL,'UGC 02563',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29233,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29233,36,0.4,158,7890,NULL,NULL,'mean','UGC 02563',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29234,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29234,36.05,0.47,162,7890,NULL,NULL,'H','UGC 02563',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29235,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29235,36.09,0.45,165,7890,NULL,NULL,'K','UGC 02563',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29236,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29236,30.45,0.8,12.3,7891,75,NULL,'A82, H','ESO 300- G 014',NULL,'1997ApJS..109..333W',1997,1,5,'The APM data refer to only the central part of the galaxy.','G',0.00001,NULL,'13.0',2.6,'SAB:(s)dm',NULL,NULL,NULL,NULL,1,47.4077917,-41.03047,0,NULL,38477879006,601216859,9394013,13),(29237,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29237,30.47,0.8,12.4,7891,75,NULL,'MAT, I','ESO 300- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29238,'Tully est','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29238,30.02,0.8,10.1,7891,75,NULL,NULL,'ESO 300- G 014',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29239,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29239,29.16,0.32,6.84,7891,85,NULL,'I, inv','ESO 300- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29240,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29240,29.23,0.32,7.03,7891,85,NULL,'I, raw','ESO 300- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29241,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29241,29.64,0.43,8.45,7891,75,NULL,'MAT, I, inv','ESO 300- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29242,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29242,29.77,0.43,9.01,7891,75,NULL,'MAT, I, raw','ESO 300- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29243,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29243,29.83,0.43,9.3,7891,75,NULL,'3.6 micron, color + selection bias corrected','ESO 300- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29244,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29244,29.94,0.43,9.7,7891,75,NULL,'3.6 micron, color corrected','ESO 300- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29245,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29245,29.96,NULL,9.82,7891,NULL,NULL,NULL,'ESO 300- G 014',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29246,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29246,29.97,0.2,9.86,7891,74.4,NULL,NULL,'ESO 300- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29247,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29247,30.13,0.43,10.6,7891,75,NULL,'MAT, I, cor','ESO 300- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29248,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29248,30.18,0.35,10.9,7891,NULL,NULL,NULL,'ESO 300- G 014',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29249,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29249,30.19,0.4,10.9,7891,73,NULL,'opt','ESO 300- G 014',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29250,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29250,30.25,0.1,11.2,7891,NULL,NULL,NULL,'ESO 300- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29251,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29251,30.46,0.47,12.4,7891,75,NULL,'A82, H, inv','ESO 300- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29252,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29252,30.65,0.47,13.5,7891,75,NULL,'A82, H, raw','ESO 300- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29253,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29253,31,0.47,15.9,7891,75,NULL,'A82, H, cor','ESO 300- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29254,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 14867',NULL,29254,39.92,0.55,963,7892,70,NULL,'SN photometric redshift distance, z photo =0.257 +/- 0.091','SDSS-II SN 14867',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,47.411875,0.04358,0.221,NULL,64962579519,1015040304,15860004,NULL),(29255,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29255,38.19,0.33,435,7893,70,NULL,NULL,'2MASX J03093961-0031328',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.63',0.2,NULL,NULL,NULL,NULL,NULL,1,47.4150417,-0.52578,0.153,NULL,36778638656,574666229,8979159,18.63),(29256,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29256,38.19,0.33,435,7894,70,NULL,NULL,'2MASX J03094068-0032028',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000068,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,47.4194583333,-0.53419,0.153,NULL,36778636086,574666188,8979159,18.5),(29257,'HII region diameter','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29257,31.75,NULL,22.4,7895,NULL,NULL,NULL,'NGC 1232',NULL,'1988ApL&C..27...41S',1988,1,7.4,'Extended HIPASS source','G',0.000003,NULL,'10.93',6.5,'SAB(rs)c       HII','Parent (of companion) galaxy',NULL,NULL,NULL,1,47.439625,-20.57931,0.037,NULL,38057349716,594646089,9291345,10.93),(29258,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29258,31.76,0.8,22.5,7895,75,NULL,'MAT, I','NGC 1232',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29259,'Sosies','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29259,31.14,0.45,16.9,7895,NULL,NULL,NULL,'NGC 1232',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29260,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29260,30.81,0.36,14.5,7895,NULL,NULL,NULL,'NGC 1232',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29261,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29261,30.81,0.4,14.5,7895,73,NULL,'opt','NGC 1232',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29262,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29262,30.81,0.32,14.5,7895,85,NULL,'I, raw','NGC 1232',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29263,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29263,30.87,0.32,14.9,7895,85,NULL,'I, inv','NGC 1232',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29264,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29264,31.06,0.43,16.3,7895,75,NULL,'MAT, I, raw','NGC 1232',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29265,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29265,31.16,NULL,17.1,7895,NULL,NULL,'I','NGC 1232',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29266,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29266,31.19,NULL,17.3,7895,NULL,NULL,'B','NGC 1232',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29267,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29267,31.3,0.43,18.2,7895,75,NULL,'MAT, I, inv','NGC 1232',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29268,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29268,31.36,0.43,18.7,7895,75,NULL,'MAT, I, cor','NGC 1232',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29269,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29269,31.38,NULL,18.9,7895,NULL,NULL,'B','NGC 1232',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29270,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29270,31.49,NULL,19.9,7895,NULL,NULL,'LEDA [Nov 2006]','NGC 1232',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29271,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29271,31.5,0.4,20,7895,75,NULL,'B','NGC 1232',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29272,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29272,31.5,NULL,20,7895,NULL,NULL,'LEDA [April 2006]','NGC 1232',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29273,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29273,31.71,0.05,22,7895,NULL,NULL,NULL,'NGC 1232',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29274,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29274,36.16,0.67,170,7896,70,NULL,NULL,'2MASX J03094875-1630121',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.71',0.19,NULL,NULL,NULL,NULL,NULL,1,47.453125,-16.50333,0.045,NULL,38111398784,595490606,9304540,16.71),(29275,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29275,35.56,0.49,130,7897,75,NULL,'IR','CGCG 464-004',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.39',0.3,NULL,NULL,NULL,NULL,NULL,1,47.482333,16.02886,0.405,NULL,68172351231,1065192987,16643640,15.39),(29276,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29276,35.7,0.4,138,7897,NULL,NULL,'mean','CGCG 464-004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29277,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29277,35.83,0.47,146,7897,NULL,NULL,'H','CGCG 464-004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29278,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29278,35.96,0.45,155,7897,NULL,NULL,'K','CGCG 464-004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29279,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 13224','R',29279,40.21,0.21,892,7898,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13224',0.236,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,47.4949583,-0.24594,0.173,NULL,36778005804,574656340,8979005,NULL),(29280,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 13224','R',29280,40.39,0.29,968,7898,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13224',0.236,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29281,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29281,30.78,0.8,14.3,7899,75,NULL,'MAT, I','NGC 1249',NULL,'1997ApJS..109..333W',1997,1,4.9,NULL,'G',0.000007,NULL,'12.19',2.3,'SB(rs)dm','X-ray-faint group member',NULL,NULL,NULL,1,47.505125,-53.33575,0,NULL,37718823254,589356613,9208697,12.19),(29282,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29282,30.81,0.8,14.5,7899,75,NULL,'A82, H','NGC 1249',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29283,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29283,30.15,0.4,10.7,7899,75,NULL,'B','NGC 1249',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29284,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29284,30.17,0.4,10.8,7899,73,NULL,'IR','NGC 1249',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29285,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29285,30.18,0.4,10.9,7899,75,NULL,NULL,'NGC 1249',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29286,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29286,30.6,0.4,13.2,7899,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 1249',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29287,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29287,30.76,0.35,14.2,7899,NULL,NULL,NULL,'NGC 1249',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29288,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29288,30.85,0.2,14.8,7899,74.4,NULL,NULL,'NGC 1249',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29289,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29289,30.91,0.47,15.2,7899,75,NULL,'A82, H, inv','NGC 1249',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29290,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29290,30.92,0.32,15.3,7899,85,NULL,'I, raw','NGC 1249',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29291,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29291,30.93,0.43,15.3,7899,75,NULL,'3.6 micron, color corrected','NGC 1249',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29292,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29292,30.94,0.32,15.4,7899,85,NULL,'I, inv','NGC 1249',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29293,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29293,30.95,0.47,15.5,7899,75,NULL,'A82, H, raw','NGC 1249',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29294,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29294,30.96,0.52,15.5,7899,NULL,NULL,NULL,'NGC 1249',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29295,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29295,30.97,0.43,15.6,7899,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1249',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29296,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29296,31.18,0.39,17.2,7899,73,NULL,'opt','NGC 1249',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29297,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29297,31.19,0.47,17.3,7899,75,NULL,'A82, H, cor','NGC 1249',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29298,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29298,31.26,0.45,17.9,7899,NULL,NULL,'Malmquist cor.','NGC 1249',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29299,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29299,31.35,0.43,18.6,7899,75,NULL,'MAT, I, raw','NGC 1249',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29300,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29300,31.43,0.43,19.4,7899,75,NULL,'MAT, I, inv','NGC 1249',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29301,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29301,31.47,0.49,19.7,7899,75,NULL,'IR','NGC 1249',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29302,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29302,31.48,0.43,19.8,7899,75,NULL,'MAT, I, cor','NGC 1249',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29303,'Tully est','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29303,31.62,0.8,21.1,7900,75,NULL,NULL,'NGC 1232A',NULL,'1988NBGC.C....0000T',1988,1,0.9,NULL,'G',0.00015,NULL,'15.22',0.8,'SB(s)m','Pair member (points to parent)',NULL,NULL,NULL,1,47.5080833333,-20.60058,0.017,NULL,38057402716,594646917,9291358,15.22),(29304,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29304,36.47,0.54,197,7901,70,NULL,NULL,'2MASX J03100269-1334263',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.36',0.39,NULL,NULL,NULL,NULL,NULL,1,47.511375,-13.57408,0.129,NULL,38075007564,594921993,9295656,16.36),(29305,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29305,29.72,NULL,8.79,7902,NULL,NULL,NULL,'ESO 300- G 016',NULL,'2013AJ....145..101K',2013,1,2.7,NULL,'G',0.000013,NULL,'15.56',2.2,'IAB(s)m: pec',NULL,NULL,NULL,NULL,1,47.5436666667,-40.00292,0,NULL,38596275454,603066803,9422918,15.56),(29306,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29306,32.75,0.43,35.4,7903,75,NULL,'3.6 micron, color + selection bias corrected','IC 0292',NULL,'2014MNRAS.444..527S',2014,1,1.2,NULL,'G',0.000017,NULL,'14.21',0.6,'Sdm:','Group non-member, foreground',NULL,NULL,NULL,1,47.553833,40.76567,0.473,NULL,68563977187,1071312143,16739252,14.21),(29307,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29307,32.89,0.43,37.8,7903,75,NULL,'3.6 micron, color corrected','IC 0292',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29308,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29308,32.99,0.2,39.6,7903,74.4,NULL,NULL,'IC 0292',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29309,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29309,33.02,0.47,40.3,7903,NULL,NULL,'H','IC 0292',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29310,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29310,33.03,0.4,40.4,7903,NULL,NULL,'mean','IC 0292',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29311,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29311,33.07,0.45,41.2,7903,NULL,NULL,'K','IC 0292',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29312,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29312,33.08,0.46,41.3,7903,NULL,NULL,'J','IC 0292',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29313,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29313,33.11,0.58,41.9,7903,NULL,NULL,NULL,'IC 0292',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29314,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29314,33.3,0.53,45.7,7903,NULL,NULL,'Malmquist cor.','IC 0292',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29315,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29315,35.89,0.49,151,7904,75,NULL,'IR','2MFGC 02588',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',NULL,NULL,'11.0K',0.2,NULL,NULL,NULL,NULL,NULL,1,47.55775,19.26892,0.309,NULL,68127395314,1064490551,16632664,11),(29316,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29316,36.81,0.33,230,7905,70,NULL,NULL,'2MASX J03101705-0645301',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000075,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,47.5712083,-6.75842,0.213,NULL,37907730786,592308293,9254817,17.8),(29317,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 07687','RN',29317,40.66,0.59,1200,7906,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 07687',0.129326,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29318,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 07687','RN',29318,41.39,0.53,1680,7906,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07687',0.129326,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29319,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29319,31.2,0.8,17.4,7907,75,NULL,'MAT, I','IC 1898',NULL,'1997ApJS..109..333W',1997,1,3.6,NULL,'G',0.000017,NULL,'13.2b',0.6,'SB(s)c: sp     HII',NULL,NULL,NULL,NULL,1,47.5824583333,-22.40486,0,NULL,38019302256,594051597,9282056,13.2),(29320,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29320,31.21,0.8,17.5,7907,75,NULL,'A82, H','IC 1898',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29321,'Tully est','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29321,30.93,0.8,15.4,7907,75,NULL,NULL,'IC 1898',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29322,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29322,31.43,0.32,19.3,7907,85,NULL,'I, raw','IC 1898',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29323,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29323,31.44,0.32,19.4,7907,85,NULL,'I, inv','IC 1898',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29324,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29324,31.45,0.38,19.5,7907,NULL,NULL,NULL,'IC 1898',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29325,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29325,31.45,0.4,19.5,7907,73,NULL,'opt','IC 1898',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29326,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29326,31.48,0.47,19.8,7907,75,NULL,'A82, H, inv','IC 1898',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29327,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29327,31.52,0.43,20.1,7907,75,NULL,'3.6 micron, color + selection bias corrected','IC 1898',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29328,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29328,31.52,0.47,20.2,7907,75,NULL,'A82, H, raw','IC 1898',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29329,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29329,31.54,0.43,20.3,7907,75,NULL,'3.6 micron, color corrected','IC 1898',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29330,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29330,31.55,0.2,20.4,7907,74.4,NULL,NULL,'IC 1898',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29331,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29331,31.59,0.43,20.8,7907,75,NULL,'MAT, I, raw','IC 1898',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29332,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29332,31.66,0.43,21.5,7907,75,NULL,'MAT, I, inv','IC 1898',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29333,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29333,31.7,0.12,21.9,7907,NULL,NULL,NULL,'IC 1898',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29334,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29334,31.74,0.47,22.3,7907,75,NULL,'A82, H, cor','IC 1898',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29335,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29335,31.76,0.43,22.5,7907,75,NULL,'MAT, I, cor','IC 1898',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29336,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29336,37.03,0.73,254,7908,70,NULL,NULL,'2MASX J03101915-7658314',NULL,'2014MNRAS.445.2677S',2014,1,0.21,NULL,'G',0.00015,NULL,'16.9b',0.19,NULL,NULL,NULL,NULL,NULL,1,47.5800416667,-76.97542,0.357,NULL,35647878023,556998094,8703095,16.9),(29337,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29337,36.81,0.33,230,7909,70,NULL,NULL,'2MASX J03101973-0644051',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000076,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,47.582375,-6.73486,0.213,NULL,37907730514,592308289,9254817,17.1),(29338,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29338,37.85,0.46,372,7910,70,NULL,NULL,'SDSS J031020.12-001939.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,47.583833,-0.32758,0.173,NULL,36777978660,574655916,8978998,18),(29339,'Tully est','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29339,30.5,0.8,12.6,7911,75,NULL,NULL,'ESO 357- G 007',NULL,'1988NBGC.C....0000T',1988,1,2.3,NULL,'G',0.000011,NULL,'14.62',0.4,'SB(s)m',NULL,NULL,NULL,NULL,1,47.6014583,-33.15617,0,NULL,38650036412,603906818,9436044,14.62),(29340,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29340,31.13,0.4,16.8,7911,NULL,NULL,NULL,'ESO 357- G 007',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29341,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29341,31.13,0.4,16.8,7911,73,NULL,'opt','ESO 357- G 007',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29342,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29342,31.15,0.2,17,7911,74.4,NULL,NULL,'ESO 357- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29343,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29343,31.25,0.43,17.8,7911,75,NULL,'3.6 micron, color corrected','ESO 357- G 007',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29344,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29344,31.28,0.43,18,7911,75,NULL,'3.6 micron, color + selection bias corrected','ESO 357- G 007',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29345,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 11564',NULL,29345,39.72,0.87,877,7912,70,NULL,'SN photometric redshift distance, z photo =0.231 +/- 0.141','SDSS-II SN 11564',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.2g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,47.6030833333,0.17986,0.185,NULL,64962478311,1015038723,15859980,22.2),(29346,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29346,35.85,0.67,148,7913,70,NULL,NULL,'2MASX J03102473-0237362',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00015,NULL,'16.61',0.22,NULL,NULL,NULL,NULL,NULL,1,47.6031666667,-2.62664,0.121,NULL,36791209534,574862648,8982228,16.61),(29347,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29347,35.68,0.49,137,7914,75,NULL,'IR','UGC 02570',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.000017,NULL,'16.5',0.3,'S?',NULL,NULL,NULL,NULL,1,47.607375,20.38503,0.469,NULL,68127675260,1064494925,16632733,16.5),(29348,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29348,36.18,0.51,172,7915,70,NULL,NULL,'2MASX J03103085-1133134',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'16.20',0.39,'S0','Field galaxy',NULL,NULL,NULL,1,47.628583,-11.55386,0.189,NULL,37895342177,592114721,9251792,16.2),(29349,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29349,36.37,0.61,188,7916,70,NULL,NULL,'2MASX J03103486-8146229',NULL,'2014MNRAS.445.2677S',2014,1,0.26,NULL,'G',0.00015,NULL,'16.7b',0.15,NULL,NULL,NULL,NULL,NULL,1,47.645,-81.77297,0.285,NULL,35676978983,557452796,8710199,16.7),(29350,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 14357',NULL,29350,40.99,0.31,1580,7917,70,NULL,'SN photometric redshift distance, z photo =0.471 +/- 0.103','SDSS-II SN 14357',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,47.646,-0.93811,0.113,NULL,36789690034,574838906,8981857,NULL),(29351,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 18851','RN',29351,40.78,0.24,1110,7918,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18851',0.292837,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29352,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 18851','RN',29352,40.99,0.18,1220,7918,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18851',0.292837,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29353,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 11328','RN',29353,43.26,0.29,3070,7919,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 11328',0.457535,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29354,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 17324',NULL,29354,41.06,0.39,1630,7920,70,NULL,'SN photometric redshift distance, z photo =0.493 +/- 0.142','SDSS-II SN 17324',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,47.6746666667,-0.45214,0.153,NULL,36777915725,574654933,8978983,NULL),(29355,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29355,36.27,0.46,180,7921,70,NULL,NULL,'2MASX J03104256-0737354',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000069,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,47.6772917,-7.62644,0.197,NULL,37907482354,592304411,9254756,17.3),(29356,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 14588',NULL,29356,40.54,0.18,1280,7922,70,NULL,'SN photometric redshift distance, z photo =0.361 +/- 0.040','SDSS-II SN 14588',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,47.6892083,-0.77678,0.153,NULL,36790207193,574846987,8981984,NULL),(29357,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS J031046.41-001217.3:SN',NULL,29357,38.83,0.12,509,7923,74.2,NULL,'SALT 2, [ZRS2008] 10106','SDSS J031046.41-001217.3',0.147,'2010ApJ...716..712A',2010,1,0.09,NULL,'G',NULL,NULL,'20.9g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,47.693375,-0.20483,0.173,NULL,36777799827,574653122,8978955,20.9),(29358,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 10106',NULL,29358,39.46,0.13,681,7923,70,NULL,'SALT 2','SDSS J031046.41-001217.3',0.147,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29359,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 10106','R',29359,39.56,0.2,711,7923,70,NULL,'SDSS CAND. SNIa?; SALT 2','SDSS J031046.41-001217.3',0.147,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29360,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 10106','R',29360,39.57,0.11,716,7923,70,NULL,'SDSS CAND. SNIa?; MLCS2K2','SDSS J031046.41-001217.3',0.147,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29361,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS J031046.41-001217.3:SN',NULL,29361,40.8,0.04,1260,7923,70,NULL,'SALT 2, [ZRS2008] 10106','SDSS J031046.41-001217.3',0.147,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29362,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29362,37.61,0.46,332,7924,70,NULL,NULL,'2MASX J03104870-0649424',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000078,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,47.7027916667,-6.82858,0.209,NULL,37904255625,592253994,9253968,17.6),(29363,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29363,37.35,0.94,295,7925,70,NULL,NULL,'2MASX J03104933-0021256',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.00015,NULL,'16.32',0.45,NULL,NULL,NULL,NULL,NULL,1,47.705625,-0.35708,0.153,NULL,36777968045,574655750,8978996,16.32),(29364,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29364,36.84,0.46,234,7926,70,NULL,NULL,'2MASX J03105147-0610304',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000063,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,47.714417,-6.17492,0.177,NULL,37904400705,592256261,9254004,17.3),(29365,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29365,34.02,0.23,63.7,7927,74.4,NULL,NULL,'IC 0293',NULL,'2013AJ....146...86T',2013,1,0.2,NULL,'G',0.000167,NULL,'15.7',0.2,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,47.734,41.13711,0.561,NULL,68563941931,1071311592,16739243,15.7),(29366,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29366,34.02,0.4,63.7,7927,NULL,NULL,'mean','IC 0293',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29367,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29367,34.37,0.45,74.9,7927,NULL,NULL,'K','IC 0293',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29368,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29368,33.17,0.49,43.1,7928,75,NULL,'IR','CGCG 524-060',NULL,'2011yCatp016004901K',2011,1,0.7,NULL,'G',NULL,NULL,'15.6',0.15,NULL,NULL,NULL,NULL,NULL,1,47.7475,38.65906,0.545,NULL,68694169027,1073346391,16771037,15.6),(29369,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 04089','RN',29369,42.93,0.25,2730,7929,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04089',0.411267,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29370,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 04089','RN',29370,43.08,0.23,2920,7929,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 04089',0.411267,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29371,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 19702','R',29371,40.66,0.23,1070,7930,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007pp','SN 2007pp',0.269,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,47.754833,0.35675,0.217,NULL,64976093516,1015251461,15863304,NULL),(29372,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 19702','R',29372,40.92,0.17,1200,7930,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007pp','SN 2007pp',0.269,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29373,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 16289','RN',29373,41.29,0.2,1470,7931,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13505 HOST',0.235087,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29374,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 13505','RN',29374,41.3,0.2,1470,7931,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13505 HOST',0.235087,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29375,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 16289','RN',29375,41.33,0.09,1500,7931,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13505 HOST',0.235087,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29376,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 13505','RN',29376,41.34,0.09,1500,7931,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13505 HOST',0.235087,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29377,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29377,35.06,0.61,103,7932,70,NULL,NULL,'2MFGC 02601',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000137,NULL,'15.30',0.3,'Sa? sp',NULL,NULL,NULL,NULL,1,47.7597083,-2.42775,0.149,NULL,36791363350,574865052,8982266,15.3),(29378,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29378,36.23,0.57,176,7933,70,NULL,NULL,'2MASX J03110299-7700060',NULL,'2014MNRAS.445.2677S',2014,1,0.21,NULL,'G',0.00015,NULL,'16.9b',0.12,NULL,NULL,NULL,NULL,NULL,1,47.76025,-77.00144,0.357,NULL,35647879166,556998111,8703095,16.9),(29379,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29379,35.76,0.5,142,7934,70,NULL,NULL,'IC 0299',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'15.79',0.56,NULL,NULL,NULL,NULL,NULL,1,47.760625,-13.10958,0.141,NULL,38074123091,594908173,9295440,15.79),(29380,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29380,35.52,0.61,127,7935,70,NULL,NULL,'CGCG 390-013',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'15.8b',0.46,NULL,NULL,NULL,NULL,NULL,1,47.761167,-2.22431,0.149,NULL,36791041792,574860028,8982187,15.8),(29381,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29381,36.68,0.6,217,7936,70,NULL,NULL,'2MASX J03111156-1212252',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00008,NULL,'17.32',0.28,NULL,NULL,NULL,NULL,NULL,1,47.79825,-12.20697,0.153,NULL,37893159811,592080622,9251259,17.32),(29382,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29382,34.43,0.23,76.9,7937,74.4,NULL,NULL,'NGC 1224',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000033,NULL,'14.7',1.2,'S0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,47.8064583,41.36369,0.561,NULL,68564266869,1071316669,16739322,14.7),(29383,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29383,34.2,0.4,69,7937,NULL,NULL,'mean','NGC 1224',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29384,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29384,34.63,0.45,84.2,7937,NULL,NULL,'K','NGC 1224',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29385,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29385,33.51,0.8,50.4,7938,75,NULL,'MAT, I','NGC 1241',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.000013,NULL,'11.99',1.7,'SB(rs)b        Sy2','Pair member, contact system',NULL,NULL,'Sy 2',1,47.811,-8.92214,0.217,NULL,37888398443,592006225,9250097,11.99),(29386,'Tully est','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29386,32.13,0.8,26.6,7938,75,NULL,'B','NGC 1241',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29387,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29387,33.19,0.45,43.4,7938,NULL,NULL,'K','NGC 1241',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29388,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29388,33.2,0.47,43.7,7938,NULL,NULL,'H','NGC 1241',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29389,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29389,33.24,0.43,44.5,7938,75,NULL,'MAT, I, raw','NGC 1241',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29390,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29390,33.25,0.46,44.6,7938,NULL,NULL,'J','NGC 1241',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29391,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29391,33.31,0.32,45.9,7938,85,NULL,'I, raw','NGC 1241',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29392,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29392,33.39,0.32,47.6,7938,85,NULL,'I, inv','NGC 1241',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29393,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29393,33.56,0.43,51.4,7938,75,NULL,'MAT, I, inv','NGC 1241',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29394,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29394,33.6,0.43,52.6,7938,75,NULL,'MAT, I, cor','NGC 1241',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29395,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29395,33.62,0.4,53.1,7938,NULL,NULL,'mean','NGC 1241',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29396,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29396,33.81,0.37,57.9,7938,NULL,NULL,'Malmquist cor.','NGC 1241',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29397,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29397,33.9,0.35,60.2,7938,NULL,NULL,NULL,'NGC 1241',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29398,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29398,33.94,0.2,61.4,7938,74.4,NULL,NULL,'NGC 1241',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29399,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29399,34.01,0.38,63.4,7939,NULL,NULL,NULL,'NGC 1242',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000017,NULL,'14.55',0.7,'SB(rs)c:','Pair member, contact system',NULL,NULL,NULL,1,47.8305,-8.90242,0.153,NULL,37888406032,592006344,9250099,14.55),(29400,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29400,34.05,0.2,64.6,7939,74.4,NULL,NULL,'NGC 1242',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29401,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29401,34.17,0.36,68.2,7939,NULL,NULL,'Malmquist cor.','NGC 1242',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29402,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 08712','RN',29402,42.03,0.75,2200,7940,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08712',0.155336,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29403,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29403,35.53,0.62,127,7941,70,NULL,NULL,'2MASX J03113150-0432043',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000183,NULL,'16.12',0.59,NULL,NULL,NULL,NULL,NULL,1,47.8812916667,-4.53461,0.213,NULL,37859406387,591553224,9243019,16.12),(29404,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29404,38.04,0.46,405,7942,70,NULL,NULL,'2MASX J03113318-0735460',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000079,NULL,'17.7g',0.17,'NLAGN',NULL,NULL,NULL,'Sy 2',1,47.888167,-7.59611,0.189,NULL,37907378512,592302789,9254731,17.7),(29405,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29405,34.17,0.5,68.4,7943,70,NULL,NULL,'MCG -02-09-013',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00013,NULL,'14.92',0.2,'S0/a',NULL,NULL,NULL,NULL,1,47.89075,-10.60969,0.253,NULL,37894005580,592093837,9251466,14.92),(29406,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29406,36.04,0.5,161,7944,70,NULL,NULL,'2MASX J03113509-1642123',NULL,'2014MNRAS.445.2677S',2014,1,NULL,'The APM image includes a superposed star.','G',0.000083,NULL,'15.26',NULL,NULL,NULL,NULL,NULL,NULL,1,47.8961666667,-16.70344,0.061,NULL,38111128527,595486383,9304474,15.26),(29407,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 04450',NULL,29407,37.81,1.05,364,7945,70,NULL,'SN photometric redshift distance, z photo =0.089 +/- 0.060','SDSS-II SN 04450',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','20.5g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,47.897,-0.16275,0.205,NULL,36789301212,574832831,8981762,20.5),(29408,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29408,33.77,0.49,56.8,7946,75,NULL,'IR','FGC 0392',NULL,'2011yCatp016004901K',2011,1,1.18,NULL,'G',NULL,'?','16.5',0.11,'Sd',NULL,NULL,NULL,NULL,1,47.9027083,35.02708,0.585,NULL,68704554203,1073508659,16773572,16.5),(29409,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29409,34.49,NULL,79,7946,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0392',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29410,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29410,34.49,NULL,79.1,7946,NULL,NULL,'Dipole','FGC 0392',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29411,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29411,34.49,NULL,79.2,7946,NULL,NULL,'Dipole + Quadrupole','FGC 0392',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29412,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29412,34.5,NULL,79.5,7946,NULL,NULL,NULL,'FGC 0392',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29413,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29413,38.54,0.46,510,7947,70,NULL,NULL,'SDSS J031141.18-081853.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000084,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,47.921625,-8.31481,0.173,NULL,37888841433,592013147,9250205,18.6),(29414,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29414,36.09,0.17,165,7948,70,NULL,NULL,'2MASX J03114217+0008532',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000083,NULL,'17.5g',0.17,'AGN',NULL,NULL,NULL,NULL,1,47.925875,0.14817,0.197,NULL,64967680490,1015120007,15861250,17.5),(29415,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 21006','R',29415,40.79,0.24,1110,7949,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007qs','SN 2007qs',0.291,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,47.9417917,0.09192,0.197,NULL,64967684490,1015120070,15861251,NULL),(29416,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 21006','R',29416,41.03,0.12,1240,7949,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007qs','SN 2007qs',0.291,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29417,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29417,34.98,0.4,98.9,7950,NULL,NULL,'mean','UGC 02585',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.00003,NULL,'13.99',1.2,'SB(r)b:','in a radial-velocity based grouping',NULL,NULL,NULL,1,47.9477917,-0.403,0.153,NULL,36789509449,574836085,8981813,13.99),(29418,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29418,35.17,0.45,108,7950,NULL,NULL,'K','UGC 02585',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29419,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29419,35.19,0.47,109,7950,NULL,NULL,'H','UGC 02585',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29420,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29420,35.29,0.46,114,7950,NULL,NULL,'J','UGC 02585',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29421,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SN 2007nu',NULL,29421,40.03,0.11,1010,7951,70,NULL,'Hubble residual -0.06 for z0.28200','SDSS J031150.17-004133.5',NULL,'2011ApJ...740...92G',2011,1,0.1,NULL,'G',0.0005,NULL,'20.4g',0.08,NULL,NULL,NULL,NULL,NULL,1,47.9590416667,-0.69264,0.157,NULL,36789488539,574835758,8981808,20.4),(29422,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 18485','R',29422,40.81,0.22,1130,7951,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007nu','SDSS J031150.17-004133.5',0.282,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29423,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 18485','R',29423,40.95,0.13,1210,7951,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007nu','SDSS J031150.17-004133.5',0.282,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29424,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29424,35.68,0.6,136,7952,70,NULL,NULL,'2MASX J03115378-1210033',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.88',NULL,NULL,NULL,NULL,NULL,NULL,1,47.974125,-12.16778,0.153,NULL,37893033190,592078643,9251228,16.88),(29425,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29425,35.47,0.66,124,7953,70,NULL,NULL,'2MASX J03115415-0000076',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.000084,NULL,'16.4g',0.24,'S0',NULL,NULL,NULL,NULL,1,47.9755417,-0.00225,0.197,NULL,36785102957,574767233,8980738,16.4),(29426,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29426,36.09,0.17,165,7953,70,NULL,NULL,'2MASX J03115415-0000076',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29427,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29427,36.09,0.17,165,7954,70,NULL,NULL,'2MASX J03115641-0001576',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000088,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,47.985125,-0.03258,0.205,NULL,36785148349,574767942,8980749,17.7),(29428,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 00800','RN',29428,42.34,0.36,2040,7955,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 00800',0.438911,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29429,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 00800','RN',29429,42.8,0.3,2530,7955,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00800',0.438911,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29430,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29430,33.04,0.4,40.6,7956,NULL,NULL,'mean','2MASX J03115889+6020491',NULL,'2007A&A...465...71T',2007,1,2.8,NULL,'G',NULL,NULL,'19.0',0.8,'dwarf Irr?',NULL,NULL,NULL,NULL,1,47.9952917,60.34697,NULL,NULL,66365641938,1036963155,16202549,19),(29431,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29431,33.12,0.47,42.1,7956,NULL,NULL,'H','2MASX J03115889+6020491',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29432,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29432,33.29,0.45,45.5,7956,NULL,NULL,'K','2MASX J03115889+6020491',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29433,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 04065','R',29433,38.76,0.18,499,7957,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04065',0.130526,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,47.998083,1.05128,0.197,NULL,64977081808,1015266903,15863545,NULL),(29434,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 04065','R',29434,38.98,0.06,553,7957,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04065',0.130526,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29435,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29435,36.09,0.17,165,7958,70,NULL,NULL,'CGCG 390-020',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000119,NULL,'14.8g',0.68,'E0',NULL,NULL,NULL,NULL,1,48.010375,-0.07847,0.205,NULL,36785151204,574767987,8980749,14.8),(29436,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 14589','R',29436,40.9,0.27,1190,7959,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14589',0.27,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,48.012083,-0.67761,0.157,NULL,36789486795,574835731,8981808,NULL),(29437,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 14589','R',29437,41.04,0.21,1270,7959,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14589',0.27,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29438,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29438,35.95,0.51,155,7960,70,NULL,NULL,'ESO 248- G 005',NULL,'2014MNRAS.445.2677S',2014,1,0.89,NULL,'G',0.00015,NULL,'15.78',0.42,'S0?',NULL,NULL,NULL,NULL,1,48.023125,-42.55369,0,NULL,38476403360,601193802,9393653,15.78),(29439,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 18852',NULL,29439,40.25,0.33,1120,7961,70,NULL,'SN photometric redshift distance, z photo =0.307 +/- 0.063','SDSS-II SN 18852',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,48.032625,0.33997,0.185,NULL,64976080308,1015251254,15863300,NULL),(29440,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29440,34.68,0.49,86.5,7962,NULL,NULL,'Malmquist cor.','UGC 02581',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',NULL,NULL,'17.',0.2,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,48.0325416667,40.24392,0.561,NULL,68692490053,1073320157,16770627,17),(29441,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29441,34.82,0.46,92.2,7962,NULL,NULL,NULL,'UGC 02581',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29442,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29442,34.86,0.2,93.8,7962,74.4,NULL,NULL,'UGC 02581',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29443,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29443,35.03,0.5,102,7963,70,NULL,NULL,'UGCA 059',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00013,NULL,'15.03',1.3,'(R_1)SB0^+',NULL,NULL,NULL,NULL,1,48.0335,-25.13181,0,NULL,38018858619,594044665,9281947,15.03),(29444,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29444,32.55,0.43,32.3,7964,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J03120931+6724214',NULL,'2014MNRAS.444..527S',2014,1,1.12,NULL,'G',0.000013,NULL,'9.35K',0.67,'dE/IR/U',NULL,NULL,NULL,NULL,1,48.038875,67.40597,NULL,NULL,66570197143,1040159330,16252489,9.35),(29445,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29445,34.95,0.46,97.6,7965,70,NULL,NULL,'CGCG 390-021',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000093,NULL,'14.9g',0.53,'S0^-',NULL,NULL,NULL,NULL,1,48.053625,-1.06192,0.161,NULL,36790324060,574848813,8982012,14.9),(29446,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29446,33.47,0.8,49.5,7966,75,NULL,'MAT, I','NGC 1247',NULL,'1997ApJS..109..333W',1997,1,4.59,NULL,'G',0.000017,NULL,'13.47',0.58,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,48.059667,-10.48111,0.253,NULL,37893982386,592093474,9251460,13.47),(29447,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29447,33.58,0.4,52.1,7966,NULL,NULL,'mean','NGC 1247',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29448,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29448,33.61,0.49,52.7,7966,75,NULL,'IR','NGC 1247',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29449,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29449,33.66,0.46,53.9,7966,NULL,NULL,'J','NGC 1247',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29450,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29450,33.73,0.47,55.7,7966,NULL,NULL,'H','NGC 1247',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29451,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29451,33.75,NULL,56.2,7966,NULL,NULL,'Dipole','NGC 1247',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29452,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29452,33.75,NULL,56.2,7966,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 1247',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29453,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29453,33.75,NULL,56.2,7966,NULL,NULL,'Dipole + Quadrupole','NGC 1247',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29454,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29454,33.86,0.45,59.1,7966,NULL,NULL,'K','NGC 1247',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29455,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29455,34.03,0.2,64,7966,74.4,NULL,NULL,'NGC 1247',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29456,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29456,34.06,0.43,64.8,7966,75,NULL,'MAT, I, raw','NGC 1247',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29457,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29457,34.14,0.4,67.2,7966,NULL,NULL,'Malmquist cor.','NGC 1247',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29458,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29458,34.2,0.43,69.3,7966,75,NULL,'MAT, I, cor','NGC 1247',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29459,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29459,34.22,0.38,69.8,7966,NULL,NULL,NULL,'NGC 1247',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29460,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29460,34.42,0.32,76.7,7966,85,NULL,'I, raw','NGC 1247',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29461,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29461,34.46,0.43,78,7966,75,NULL,'MAT, I, inv','NGC 1247',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29462,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29462,34.53,0.32,80.5,7966,85,NULL,'I, inv','NGC 1247',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29463,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29463,38.13,0.33,423,7967,70,NULL,NULL,'2MASX J03121640-0000122',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000085,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,48.068375,-0.00353,0.205,NULL,36785133590,574767712,8980745,17.5),(29464,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29464,35.78,0.47,143,7968,70,NULL,NULL,'ESO 481- G 009',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.76',0.8,'Sa','Pair member (points to parent)',NULL,NULL,NULL,1,48.07625,-24.62044,0.013,NULL,38019032011,594047375,9281990,14.76),(29465,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29465,38.13,0.33,423,7969,70,NULL,NULL,'2MASX J03122040+0003377',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000083,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,48.085,0.06039,0.205,NULL,64967704224,1015120378,15861255,17.6),(29466,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 19565',NULL,29466,41.59,NULL,2080,7970,70,NULL,'SN photometric redshift distance, z photo =0.699 +/- 0.001','SDSS-II SN 19565',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.4g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,48.0949166667,0.33228,0.197,NULL,64967886337,1015123224,15861300,21.4),(29467,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29467,34.62,0.8,84.1,7971,75,NULL,'MAT, I','ESO 481- G 011',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'15.23',0.24,'Sb','Pair member (points to parent)',NULL,NULL,NULL,1,48.1024583,-24.54614,0,NULL,38019066317,594047911,9281998,15.23),(29468,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29468,34.07,0.32,65.1,7971,85,NULL,'I, raw','ESO 481- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29469,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29469,34.09,0.32,65.7,7971,85,NULL,'I, inv','ESO 481- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29470,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29470,34.11,0.43,66.4,7971,75,NULL,'MAT, I, raw','ESO 481- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29471,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29471,34.15,0.49,67.6,7971,75,NULL,'IR','ESO 481- G 011',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29472,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29472,34.24,0.43,70.3,7971,75,NULL,'MAT, I, inv','ESO 481- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29473,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29473,34.42,0.43,76.5,7971,75,NULL,'MAT, I, cor','ESO 481- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29474,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29474,34.54,0.64,81,7971,NULL,NULL,NULL,'ESO 481- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29475,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29475,34.58,0.2,82.4,7971,74.4,NULL,NULL,'ESO 481- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29476,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29476,34.61,0.62,83.6,7971,NULL,NULL,'Malmquist cor.','ESO 481- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29477,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29477,33.15,0.47,42.7,7972,NULL,NULL,'H','4C +39.11',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'G',0.0004,NULL,'18.2',NULL,'Radio galaxy/n',NULL,NULL,'radio jet','Sy 1.0',1,48.110625,39.27511,0.589,NULL,68694207800,1073346996,16771046,18.2),(29478,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29478,33.23,0.45,44.3,7972,NULL,NULL,'K','4C +39.11',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29479,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29479,33.25,0.46,44.7,7972,NULL,NULL,'J','4C +39.11',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29480,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29480,33.95,0.4,61.6,7972,NULL,NULL,'mean','4C +39.11',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29481,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29481,36.25,0.7,178,7973,70,NULL,NULL,'2MASX J03122739-5020552',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.30',0.47,'S0',NULL,NULL,NULL,NULL,1,48.1142917,-50.34858,0,NULL,38459852025,600935187,9389612,16.3),(29482,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 15748','R',29482,39.35,0.19,641,7974,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15748',0.1561,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,48.1144166667,-0.13072,0.205,NULL,36785139552,574767805,8980746,NULL),(29483,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 15748','R',29483,39.49,0.1,683,7974,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15748',0.1561,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29484,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SN 1995ap','R',29484,40.05,NULL,787,7975,65,NULL,'SALT','[K95] J031228.13+004143.4',0.3,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,48.1172083,0.69539,0.193,NULL,64976153425,1015252397,15863318,NULL),(29485,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SN 1995ap',NULL,29485,40.15,0.46,824,7975,70,NULL,'SALT','[K95] J031228.13+004143.4',0.3,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29486,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SN 1995ap',NULL,29486,40.3,0.87,881,7975,65,NULL,'SALT','[K95] J031228.13+004143.4',0.3,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29487,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SN 1995ap',NULL,29487,40.33,0.46,895,7975,65,NULL,'Snapshot','[K95] J031228.13+004143.4',0.3,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29488,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SN 1995ap',NULL,29488,40.44,0.46,942,7975,65,NULL,NULL,'[K95] J031228.13+004143.4',0.3,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29489,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29489,35.83,0.57,146,7976,70,NULL,NULL,'2MASX J03122988-0943261',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'17.45',0.16,NULL,NULL,NULL,NULL,NULL,1,48.1244583,-9.72389,0.225,NULL,37896526497,592133226,9252081,17.45),(29490,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29490,35.29,0.43,114,7977,NULL,NULL,'Malmquist cor.','UGC 02589',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',NULL,NULL,'16.0',0.9,'Sbc',NULL,NULL,NULL,NULL,1,48.137375,12.38461,0.777,NULL,68159094304,1064985848,16640403,16),(29491,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29491,35.49,0.39,126,7977,NULL,NULL,NULL,'UGC 02589',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29492,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29492,35.59,0.2,131,7977,74.4,NULL,NULL,'UGC 02589',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29493,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29493,34.03,0.43,64,7978,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1233',NULL,'2014MNRAS.444..527S',2014,1,1.8,'Ident as NGC 1235 is uncertain. 1999ApJS..121..287H has V = 4890 +- 170 km/sec.','G',0.000023,NULL,'14.0',0.6,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,48.1379583,39.31892,0.589,NULL,68694204662,1073346947,16771046,14),(29494,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29494,34.04,0.43,64.3,7978,75,NULL,'3.6 micron, color corrected','NGC 1233',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29495,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29495,34.1,0.2,66.1,7978,74.4,NULL,NULL,'NGC 1233',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29496,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29496,37.15,0.84,269,7979,70,NULL,NULL,'2MASX J03123369-1207011',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00015,NULL,'16.66',0.32,NULL,NULL,NULL,NULL,NULL,1,48.1404583333,-12.117,0.153,NULL,37893005398,592078209,9251222,16.66),(29497,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29497,37.82,0.77,367,7980,70,NULL,NULL,'2MASX J03123428-5020222',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.7b',0.27,NULL,NULL,NULL,NULL,NULL,1,48.14275,-50.33953,0,NULL,38459844805,600935075,9389610,16.7),(29498,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29498,37.19,0.33,274,7981,70,NULL,NULL,'2MASX J03123479-0103162',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000071,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,48.144833,-1.05444,0.161,NULL,36790317647,574848713,8982011,18),(29499,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 01869','RN',29499,42.55,0.16,2300,7982,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 01869',0.40285,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29500,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 01869','RN',29500,42.66,0.23,2420,7982,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 01869',0.40285,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29501,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29501,35.89,0.62,151,7983,70,NULL,NULL,'LCRS B031055.8-452508',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.52',0.35,NULL,NULL,NULL,NULL,NULL,1,48.1650417,-45.23258,0,NULL,38514172712,601783948,9402874,16.52),(29502,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29502,35.77,0.46,143,7984,70,NULL,NULL,'2MASX J03123965-0102508',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00015,NULL,'16.44',0.26,NULL,NULL,NULL,NULL,NULL,1,48.165167,-1.04753,0.161,NULL,36790311432,574848616,8982009,16.44),(29503,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29503,35.55,0.53,129,7985,70,NULL,NULL,'IC 0303',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'16.16',0.44,NULL,NULL,NULL,NULL,NULL,1,48.1702917,-11.68994,0.245,NULL,37893222037,592081594,9251274,16.16),(29504,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29504,35.27,0.5,113,7986,70,NULL,NULL,'MCG -03-09-006',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00013,NULL,'15.21',0.2,NULL,NULL,NULL,NULL,NULL,1,48.1764583,-17.11422,0.053,NULL,38111029584,595484837,9304450,15.21),(29505,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29505,33.98,0.51,62.4,7987,70,NULL,NULL,'UGC 02594',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00007,NULL,'14.35',0.7,'SB0/a:','in a radial-velocity based grouping',NULL,NULL,NULL,1,48.190417,-0.33314,0.181,NULL,36785329439,574770772,8980793,14.35),(29506,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 04739','RN',29506,37.2,0.08,269,7988,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04739 HOST',0.022758,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29507,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 10590','RN',29507,37.75,0.26,347,7988,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04739 HOST',0.022758,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29508,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 04739','RN',29508,38.28,0.24,443,7988,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04739 HOST',0.022758,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29509,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 10590','RN',29509,38.66,0.09,527,7988,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04739 HOST',0.022758,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29510,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29510,36.07,0.65,164,7989,70,NULL,NULL,'2MASX J03124583-7214177',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.0b',0.14,NULL,NULL,NULL,NULL,NULL,1,48.190917,-72.23817,0.053,NULL,36441750505,569402351,8896911,16),(29511,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29511,37.19,0.33,274,7990,70,NULL,NULL,'2MASX J03124719-0101218',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000075,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,48.196583,-1.02283,0.161,NULL,36790183792,574846621,8981978,16.6),(29512,'Tully est','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29512,32.23,0.8,27.9,7991,75,NULL,NULL,'MRK 0604',NULL,'1988NBGC.C....0000T',1988,1,1,NULL,'G',0.000013,NULL,'15.5',0.3,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,48.1975417,-5.26853,0.193,NULL,37858248732,591535136,9242736,15.5),(29513,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29513,37.1,0.46,262,7992,70,NULL,NULL,'2MASX J03124935+0111321',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,48.2055,1.19233,0.197,NULL,64976893290,1015263957,15863499,17.3),(29514,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 02734','R',29514,40.79,0.11,1100,7993,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 02734',0.3028,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,48.206875,-0.69486,0.161,NULL,36789431234,574834863,8981794,NULL),(29515,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 02734','R',29515,40.83,0.21,1120,7993,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02734',0.3028,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29516,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29516,35.84,0.4,147,7994,NULL,NULL,'mean','UGC 02592',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000017,NULL,'15.37',0.5,'Sb',NULL,NULL,NULL,NULL,1,48.2121666667,18.79453,0.321,NULL,68170423567,1065162868,16643169,15.37),(29517,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29517,36.09,0.47,165,7994,NULL,NULL,'H','UGC 02592',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29518,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29518,36.14,0.2,169,7994,74.4,NULL,NULL,'UGC 02592',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29519,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29519,33.57,0.47,51.8,7995,NULL,NULL,'H','IC 0302',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000013,NULL,'13.59',1.5,'SB(rs)bc','Isolated galaxy',NULL,NULL,NULL,1,48.213625,4.70703,0.413,NULL,67918903166,1061232861,16581763,13.59),(29520,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29520,33.73,0.46,55.6,7995,NULL,NULL,'J','IC 0302',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29521,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29521,33.73,0.45,55.7,7995,NULL,NULL,'K','IC 0302',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29522,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29522,34.38,0.4,75.1,7995,NULL,NULL,'mean','IC 0302',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29523,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29523,37.57,0.46,327,7996,70,NULL,NULL,'2MASX J03125589+0103412',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000088,NULL,'16.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,48.2327917,1.06144,0.197,NULL,64976996274,1015265566,15863524,16.8),(29524,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 18264','RN',29524,43.1,0.24,2810,7997,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 18264',0.484285,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29525,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29525,36.86,0.46,236,7998,70,NULL,NULL,'2MASX J03130138-0713112',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000075,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,48.2557083,-7.21978,0.169,NULL,37904699278,592260926,9254076,17.1),(29526,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 14377','R',29526,39.29,0.18,633,7999,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2006hw','SDSS J031303.29-002818.3',0.14,'2014arXiv1401.3317S',2014,1,0.21,NULL,'G',NULL,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,48.26375,-0.47178,0.177,NULL,36785210788,574768918,8980764,18.5),(29527,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SN 2006hw',NULL,29527,39.11,0.08,664,7999,70,NULL,'SALT 2','SDSS J031303.29-002818.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29528,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SN 2006hw',NULL,29528,39.12,0.08,667,7999,70,NULL,'SALT 2, Malmquist cor.','SDSS J031303.29-002818.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29529,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 14377','R',29529,39.42,0.08,672,7999,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2006hw','SDSS J031303.29-002818.3',0.14,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29530,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 05098','RN',29530,40.73,0.29,1080,8000,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 05098',0.29479,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29531,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 05098','RN',29531,40.79,0.24,1110,8000,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05098',0.29479,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29532,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29532,30.94,0.8,15.4,8001,75,NULL,'A82, H','ESO 116- G 012',NULL,'1997ApJS..109..333W',1997,1,3.5,NULL,'G',0.000017,NULL,'12.95',1.1,'SB(s)m',NULL,NULL,NULL,NULL,1,48.2697917,-57.35722,0,NULL,36248324862,566380075,8849688,12.95),(29533,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29533,30.95,0.8,15.5,8001,75,NULL,'MAT, I','ESO 116- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29534,'Tully est','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29534,30.46,0.8,12.3,8001,75,NULL,NULL,'ESO 116- G 012',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29535,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29535,30.92,0.47,15.3,8001,75,NULL,'A82, H, inv','ESO 116- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29536,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29536,30.93,0.2,15.4,8001,74.4,NULL,NULL,'ESO 116- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29537,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29537,31,0.47,15.8,8001,75,NULL,'A82, H, raw','ESO 116- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29538,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29538,31.23,0.47,17.6,8001,75,NULL,'A82, H, cor','ESO 116- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29539,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29539,31.25,0.44,17.8,8001,NULL,NULL,'Malmquist cor.','ESO 116- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29540,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29540,31.56,0.43,20.5,8001,75,NULL,'MAT, I, raw','ESO 116- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29541,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29541,31.56,0.38,20.5,8001,NULL,NULL,NULL,'ESO 116- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29542,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29542,31.64,0.43,21.3,8001,75,NULL,'MAT, I, cor','ESO 116- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29543,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29543,31.66,0.4,21.4,8001,NULL,NULL,'mean','ESO 116- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29544,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29544,31.67,0.43,21.6,8001,75,NULL,'MAT, I, inv','ESO 116- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29545,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29545,31.71,0.38,22,8001,NULL,NULL,NULL,'ESO 116- G 012',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29546,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29546,31.71,0.4,22,8001,73,NULL,'opt','ESO 116- G 012',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29547,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29547,31.77,0.32,22.6,8001,85,NULL,'I, raw','ESO 116- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29548,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29548,31.8,0.32,22.9,8001,85,NULL,'I, inv','ESO 116- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29549,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29549,32.28,0.46,28.5,8001,NULL,NULL,'J','ESO 116- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29550,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29550,32.37,0.47,29.8,8001,NULL,NULL,'H','ESO 116- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29551,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29551,32.44,0.45,30.7,8001,NULL,NULL,'K','ESO 116- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29552,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29552,37.27,0.46,285,8002,70,NULL,NULL,'2MASX J03131034+0027330',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000072,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,48.293,0.45914,0.209,NULL,64967853832,1015122716,15861292,18.3),(29553,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29553,37.74,0.46,354,8003,70,NULL,NULL,'2MASX J03131757-0717382',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000094,NULL,'17.9g',0.16,'NLAGN',NULL,NULL,NULL,'Sy 2',1,48.32325,-7.29381,0.173,NULL,37904470761,592257355,9254021,17.9),(29554,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29554,35.97,0.2,156,8004,74.4,NULL,NULL,'UGC 02597',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'16.0',0.5,'Sb',NULL,NULL,NULL,NULL,1,48.3304583,17.98958,0.317,NULL,68170828081,1065169188,16643268,16),(29555,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29555,34.26,0.57,71.3,8005,70,NULL,NULL,'MCG -01-09-017',NULL,'2014MNRAS.445.2677S',2014,1,1.11,NULL,'G',0.000086,NULL,'14.7g',0.35,'Sb(f)',NULL,NULL,NULL,NULL,1,48.351,-8.21242,0.165,NULL,37888978554,592015289,9250238,14.7),(29556,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 18800',NULL,29556,40.3,0.2,1150,8006,70,NULL,'SN photometric redshift distance, z photo =0.317 +/- 0.037','SDSS-II SN 18800',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.7g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,48.359583,-0.46256,0.177,NULL,36785189223,574768581,8980759,21.7),(29557,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29557,33.96,0.2,61.9,8007,74.4,NULL,NULL,'UGC 02596',NULL,'2013AJ....146...86T',2013,1,2.1,NULL,'G',0.000017,NULL,'13.6',1,'SAm:',NULL,NULL,NULL,NULL,1,48.3719166667,44.13144,1.081,NULL,68556986142,1071202908,16737545,13.6),(29558,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29558,31.81,0.8,23,8008,75,NULL,'MAT, I','NGC 1255',NULL,'1997ApJS..109..333W',1997,1,4.2,NULL,'G',0.00001,NULL,'12.06',2.6,'SAB(rs)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,48.3835,-25.72517,0,NULL,38540375587,602193368,9409271,12.06),(29559,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29559,31.82,0.8,23.1,8008,75,NULL,'A82, H','NGC 1255',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29560,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29560,30.67,0.2,13.6,8008,74.4,NULL,NULL,'NGC 1255',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29561,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29561,30.74,0.43,14.1,8008,75,NULL,'3.6 micron, color corrected','NGC 1255',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29562,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29562,30.82,0.4,14.6,8008,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 1255',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29563,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29563,30.86,0.43,14.8,8008,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1255',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29564,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29564,31.24,0.38,17.7,8008,NULL,NULL,NULL,'NGC 1255',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29565,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29565,31.24,0.39,17.7,8008,73,NULL,'opt','NGC 1255',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29566,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29566,31.24,0.32,17.7,8008,85,NULL,'I, raw','NGC 1255',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29567,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29567,31.28,0.32,18,8008,85,NULL,'I, inv','NGC 1255',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29568,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29568,31.5,0.4,19.9,8008,75,NULL,'B','NGC 1255',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29569,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29569,31.58,0.45,20.7,8008,NULL,NULL,'K','NGC 1255',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29570,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29570,31.64,0.46,21.2,8008,NULL,NULL,'J','NGC 1255',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29571,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29571,31.64,0.47,21.3,8008,75,NULL,'A82, H, raw','NGC 1255',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29572,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29572,31.69,0.47,21.8,8008,75,NULL,'A82, H, inv','NGC 1255',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29573,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29573,31.71,0.08,22,8008,NULL,NULL,NULL,'NGC 1255',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29574,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29574,31.72,0.43,22.1,8008,75,NULL,'MAT, I, raw','NGC 1255',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29575,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29575,31.76,0.47,22.5,8008,NULL,NULL,'H','NGC 1255',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29576,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29576,31.81,0.47,23,8008,75,NULL,'A82, H, cor','NGC 1255',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29577,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29577,31.85,0.43,23.4,8008,75,NULL,'MAT, I, cor','NGC 1255',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29578,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29578,31.87,0.4,23.7,8008,NULL,NULL,'mean','NGC 1255',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29579,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29579,31.91,0.43,24.1,8008,75,NULL,'MAT, I, inv','NGC 1255',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29580,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29580,31.86,0.8,23.6,8009,75,NULL,'MAT, I','UGCA 061',NULL,'1997ApJS..109..333W',1997,1,4,NULL,'G',0.00001,NULL,'14.21',1.1,'SB(s)m: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,48.4185,-25.18808,0,NULL,38018810589,594043915,9281936,14.21),(29581,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29581,31.87,0.8,23.6,8009,75,NULL,'A82, H','UGCA 061',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29582,'Tully est','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29582,31.54,0.8,20.4,8009,75,NULL,NULL,'UGCA 061',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29583,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29583,31.09,0.32,16.5,8009,85,NULL,'I, inv','UGCA 061',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29584,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29584,31.11,0.32,16.7,8009,85,NULL,'I, raw','UGCA 061',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29585,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29585,31.25,0.2,17.8,8009,74.4,NULL,NULL,'UGCA 061',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29586,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29586,31.33,0.43,18.4,8009,75,NULL,'MAT, I, inv','UGCA 061',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29587,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29587,31.33,0.47,18.4,8009,75,NULL,'A82, H, inv','UGCA 061',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29588,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29588,31.34,0.38,18.5,8009,NULL,NULL,NULL,'UGCA 061',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29589,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29589,31.34,0.4,18.5,8009,73,NULL,'opt','UGCA 061',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29590,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29590,31.39,0.43,19,8009,75,NULL,'MAT, I, raw','UGCA 061',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29591,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29591,31.46,0.43,19.6,8009,75,NULL,'3.6 micron, color corrected','UGCA 061',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29592,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29592,31.51,0.47,20,8009,75,NULL,'A82, H, raw','UGCA 061',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29593,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29593,31.61,0.43,21,8009,75,NULL,'MAT, I, cor','UGCA 061',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29594,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29594,31.62,0.43,21.1,8009,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 061',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29595,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29595,31.72,0.47,22.1,8009,75,NULL,'A82, H, cor','UGCA 061',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29596,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 18466','R',29596,40.08,0.2,856,8010,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007lm','SN 2007lm',0.213,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,48.4185,0.62997,0.209,NULL,64968531653,1015133307,15861457,NULL),(29597,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 18466','R',29597,40.23,0.09,918,8010,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007lm','SN 2007lm',0.213,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29598,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29598,38.4,0.33,480,8011,70,NULL,NULL,'SDSS J031343.03-075718.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000086,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,48.4292917,-7.95508,0.173,NULL,37888760519,592011883,9250185,18.6),(29599,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29599,34.64,0.48,84.7,8012,70,NULL,NULL,'IC 0307',NULL,'2014MNRAS.445.2677S',2014,1,1.78,NULL,'G',0.000023,NULL,'14.3g',0.62,'(R)SB(r)a pec? NLAGN',NULL,NULL,NULL,NULL,1,48.438375,-0.24144,0.177,NULL,36785265337,574769770,8980777,14.3),(29600,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29600,36.12,0.62,167,8013,70,NULL,NULL,'2MASX J03134573-3943479',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00015,NULL,'16.63',0.24,NULL,NULL,NULL,NULL,NULL,1,48.440375,-39.73,0,NULL,38597711619,603089244,9423269,16.63),(29601,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 04012','R',29601,35.67,0.05,133,8014,70,NULL,'SDSS CAND. SNIc; MLCS2K2; SN 2005em','SN 2005em',0.0252,'2014arXiv1401.3317S',2014,1,NULL,'This supernova may also be associated with IC 0307.','SN',NULL,NULL,NULL,NULL,'IIb',NULL,NULL,NULL,NULL,1,48.4487917,-0.24361,0.177,NULL,36785265019,574769765,8980777,NULL),(29602,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 04012','R',29602,36.44,0.22,189,8014,70,NULL,'SDSS CAND. SNIc; SALT 2; SN 2005em','SN 2005em',0.0252,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29603,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29603,37.25,0.33,282,8015,70,NULL,NULL,'2MASX J03135078+0105516',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000076,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,48.461625,1.09769,0.233,NULL,64976505090,1015257892,15863404,18.2),(29604,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 13914','RN',29604,43.58,0.24,3380,8016,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13914',0.537513,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29605,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29605,38.21,0.46,439,8017,70,NULL,NULL,'2MASX J03135451+0016576',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00007,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,48.4771666667,0.28281,0.201,NULL,64968629069,1015134829,15861481,18.1),(29606,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29606,36.82,0.33,231,8018,70,NULL,NULL,'2MASX J03135482-0106486',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000066,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,48.4785,-1.11336,0.165,NULL,36789923167,574842549,8981914,17.1),(29607,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29607,36.04,0.55,162,8019,70,NULL,NULL,'2MASX J03135610-2143452',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.09',0.3,'S',NULL,NULL,NULL,NULL,1,48.483833,-21.72917,0.009,NULL,38027591291,594181113,9284079,16.09),(29608,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 00841','R',29608,41.07,0.26,1260,8020,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 00841',0.2991,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,48.496,-1.01003,0.165,NULL,36789919480,574842491,8981913,NULL),(29609,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 00841','R',29609,41.22,0.19,1350,8020,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 00841',0.2991,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29610,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 16046',NULL,29610,38.87,0.58,595,8021,70,NULL,'SN photometric redshift distance, z photo =0.150 +/- 0.051','SDSS-II SN 16046',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.3g',0.02,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,48.4976666667,-1.22553,0.205,NULL,36790066090,574844782,8981949,21.3),(29611,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 16129',NULL,29611,40.52,0.25,1270,8022,70,NULL,'SN photometric redshift distance, z photo =0.358 +/- 0.056','SDSS-II SN 16129',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','23.3g',0.01,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,48.4979583,0.21303,0.201,NULL,64968643447,1015135053,15861485,23.3),(29612,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29612,37.35,0.63,295,8023,70,NULL,NULL,'2MFGC 02647',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'12.5K',0.13,NULL,NULL,NULL,NULL,NULL,1,48.506333,-76.70758,0.365,NULL,35651070893,557047982,8703874,12.5),(29613,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29613,38.4,0.33,480,8024,70,NULL,NULL,'SDSS J031401.56-075411.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00008,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,48.5065417,-7.90328,0.173,NULL,37890845395,592044459,9250694,18.7),(29614,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29614,36.82,0.33,231,8025,70,NULL,NULL,'2MASX J03140355-0103344',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000084,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,48.514917,-1.05972,0.165,NULL,36789927195,574842612,8981915,17.4),(29615,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29615,31.51,0.8,20.1,8026,75,NULL,'MAT, I','NGC 1258',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000026,NULL,'13.95',0.9,'SAB(s)cd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,48.5227917,-21.77428,0.009,NULL,38027585865,594181029,9284078,13.95),(29616,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29616,31.71,0.07,22,8026,NULL,NULL,NULL,'NGC 1258',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29617,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29617,31.96,0.32,24.7,8026,85,NULL,'I, inv','NGC 1258',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29618,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29618,31.97,0.32,24.8,8026,85,NULL,'I, raw','NGC 1258',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29619,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29619,32.28,0.43,28.5,8026,75,NULL,'MAT, I, raw','NGC 1258',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29620,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29620,32.32,0.43,29.1,8026,75,NULL,'MAT, I, cor','NGC 1258',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29621,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29621,32.32,0.43,29.1,8026,75,NULL,'MAT, I, inv','NGC 1258',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29622,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29622,36.11,0.46,167,8027,70,NULL,NULL,'2MASX J03140551-0827243',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000113,NULL,'15.3g',0.43,'E0',NULL,NULL,NULL,NULL,1,48.523,-8.45689,0.165,NULL,37889007698,592015745,9250246,15.3),(29623,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29623,36.31,0.65,183,8027,70,NULL,NULL,'2MASX J03140551-0827243',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29624,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29624,31.7,0.8,21.9,8028,75,NULL,'MAT, I','NGC 1253',NULL,'1997ApJS..109..333W',1997,1,5.2,'Extended HIPASS source','G',0.000002,NULL,'12.27',2.3,'SAB(rs)cd','Parent (of companion) galaxy',NULL,NULL,NULL,1,48.5377083,-2.82294,0.173,NULL,36791709953,574870468,8982351,12.27),(29625,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29625,31.7,0.8,21.9,8028,75,NULL,'A82, H','NGC 1253',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29626,'Sosies','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29626,31.02,0.57,16,8028,NULL,NULL,NULL,'NGC 1253',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29627,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29627,31.43,0.32,19.3,8028,85,NULL,'I, raw','NGC 1253',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29628,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29628,31.46,0.32,19.6,8028,85,NULL,'I, inv','NGC 1253',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29629,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29629,31.55,0.2,20.4,8028,74.4,NULL,NULL,'NGC 1253',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29630,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29630,31.6,0.38,20.9,8028,NULL,NULL,NULL,'NGC 1253',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29631,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29631,31.6,0.4,20.9,8028,73,NULL,'opt','NGC 1253',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29632,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29632,31.62,0.4,21.1,8028,75,NULL,'B','NGC 1253',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29633,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29633,31.64,0.43,21.3,8028,75,NULL,'3.6 micron, color corrected','NGC 1253',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29634,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29634,31.66,0.43,21.4,8028,75,NULL,'MAT, I, raw','NGC 1253',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29635,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29635,31.73,0.4,22.2,8028,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 1253',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29636,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29636,31.75,0.43,22.4,8028,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1253',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29637,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29637,31.82,0.43,23.1,8028,75,NULL,'MAT, I, inv','NGC 1253',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29638,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29638,31.88,0.43,23.8,8028,75,NULL,'MAT, I, cor','NGC 1253',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29639,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29639,32.02,0.47,25.4,8028,75,NULL,'A82, H, raw','NGC 1253',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29640,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29640,32.11,0.47,26.4,8028,75,NULL,'A82, H, inv','NGC 1253',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29641,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29641,32.25,0.47,28.2,8028,75,NULL,'A82, H, cor','NGC 1253',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29642,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29642,32.88,0.49,37.7,8028,75,NULL,'IR','NGC 1253',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29643,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 06040','RN',29643,37.88,0.37,352,8029,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06040',0.069679,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29644,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 06040','RN',29644,39.12,0.27,622,8029,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06040',0.069679,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29645,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29645,37.25,0.33,282,8030,70,NULL,NULL,'2MASX J03141094+0106063',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000079,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,48.545625,1.10161,0.233,NULL,64976484874,1015257576,15863399,16.6),(29646,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29646,36.69,0.68,217,8031,70,NULL,NULL,'LCRS B031219.4-392223',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'16.36',0.38,'S0',NULL,NULL,NULL,NULL,1,48.5525833333,-39.18836,0,NULL,38599277434,603113709,9423651,16.36),(29647,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29647,34.2,0.49,69.3,8032,75,NULL,'IR','CGCG 525-008',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000033,NULL,'15.53',0.2,NULL,NULL,NULL,NULL,NULL,1,48.563667,35.53992,0.757,NULL,68697331807,1073395809,16771809,15.53),(29648,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29648,36.77,0.85,226,8033,70,NULL,NULL,'2MASX J03141918-0944238',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.42',0.28,NULL,NULL,NULL,NULL,NULL,1,48.58,-9.74003,0.209,NULL,37896355553,592130555,9252039,16.42),(29649,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29649,38.78,0.46,570,8034,70,NULL,NULL,'2MASX J03142082-0641288',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000077,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,48.586833,-6.69139,0.181,NULL,37904804210,592262565,9254102,18),(29650,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29650,35.26,0.58,112,8035,70,NULL,NULL,'MCG -02-09-017',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.1b',0.8,NULL,NULL,NULL,NULL,NULL,1,48.590375,-9.43672,0.185,NULL,37896148768,592127324,9251989,16.1),(29651,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29651,35.26,0.52,113,8036,70,NULL,NULL,'MCG -02-09-016',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000077,NULL,'15.30',0.4,'Sa',NULL,NULL,NULL,NULL,1,48.602083,-10.75408,0.241,NULL,37899232223,592175503,9252742,15.3),(29652,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29652,34.97,0.5,98.8,8037,70,NULL,NULL,'UGC 02611',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'14.40',1,'S0',NULL,NULL,NULL,NULL,1,48.602833,-1.91489,0.193,NULL,36792082700,574876292,8982442,14.4),(29653,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 18855','R',29653,38.92,0.18,538,8038,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007mh','SDSS J031432.12+001608.1',0.13,'2014arXiv1401.3317S',2014,1,0.13,NULL,'G',NULL,NULL,'19.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,48.6338333333,0.26892,0.173,NULL,64968647865,1015135122,15861486,19.3),(29654,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SN 2007mh',NULL,29654,38.83,0.08,583,8038,70,NULL,'SALT 2','SDSS J031432.12+001608.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29655,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SN 2007mh',NULL,29655,38.83,0.08,583,8038,70,NULL,'SALT 2, Malmquist cor.','SDSS J031432.12+001608.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29656,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 18855','R',29656,39.19,0.08,611,8038,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007mh','SDSS J031432.12+001608.1',0.13,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29657,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29657,37.64,0.46,338,8039,70,NULL,NULL,'SDSS J031434.47-074621.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000076,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,48.6436666667,-7.77278,0.189,NULL,37890861193,592044706,9250698,18.1),(29658,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 21401',NULL,29658,36.84,1.19,233,8040,70,NULL,'SN photometric redshift distance, z photo =0.056 +/- 0.043','SDSS-II SN 21401',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,48.652875,0.103,0.173,NULL,64968076155,1015126189,15861346,NULL),(29659,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29659,32.2,0.4,27.6,8041,75,NULL,'B','DDO 032',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.000019,NULL,'14.11',1.7,'IB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,48.659667,-4.77392,0.157,NULL,36780599340,574696864,8979638,14.11),(29660,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 16148',NULL,29660,39.86,0.4,937,8042,70,NULL,'SN photometric redshift distance, z photo =0.249 +/- 0.060','SDSS-II SN 16148',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,48.661125,0.58814,0.209,NULL,64968700124,1015135939,15861499,NULL),(29661,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29661,33.59,0.2,52.2,8043,74.4,NULL,NULL,'UGC 02604',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.00003,NULL,'14.4',0.9,'SAB(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,48.6687917,39.61753,0.589,NULL,68692569389,1073321396,16770646,14.4),(29662,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29662,34.09,0.38,65.9,8043,NULL,NULL,NULL,'UGC 02604',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29663,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29663,34.24,0.35,70.4,8043,NULL,NULL,'Malmquist cor.','UGC 02604',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29664,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29664,33.89,0.2,60,8044,74.4,NULL,NULL,'UGC 02610',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000016,NULL,'15.3',0.5,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,48.7414583,39.34878,0.617,NULL,68693006998,1073328234,16770753,15.3),(29665,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29665,33.27,0.69,45.1,8045,100,NULL,'mid-IR','IC 1904',NULL,'2013ApJ...771...88L',2013,1,1.4,NULL,'G',0.00002,NULL,'14.40',0.6,'(R\'_1)SB(rs)b',NULL,NULL,NULL,NULL,1,48.7532083,-30.70803,0,NULL,38614336698,603349010,9427328,14.4),(29666,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29666,33.88,0.8,59.6,8046,75,NULL,'W91PP, r','IC 0304',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000017,NULL,'14.64',0.7,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,48.7557083,37.88183,0.777,NULL,68691575692,1073305870,16770404,14.64),(29667,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29667,32.94,0.69,38.8,8046,100,NULL,'mid-IR','IC 0304',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29668,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29668,33.94,0.47,61.4,8046,NULL,NULL,'H','IC 0304',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29669,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29669,34.01,0.45,63.3,8046,NULL,NULL,'K','IC 0304',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29670,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29670,34.01,0.46,63.5,8046,NULL,NULL,'J','IC 0304',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29671,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29671,34.07,0.4,65,8046,NULL,NULL,'mean','IC 0304',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29672,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29672,34.35,0.43,74.1,8046,75,NULL,'3.6 micron, color + selection bias corrected','IC 0304',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29673,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29673,34.42,0.38,76.6,8046,75,NULL,'W91PP, r, raw','IC 0304',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29674,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29674,34.42,0.43,76.6,8046,75,NULL,'3.6 micron, color corrected','IC 0304',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29675,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29675,34.47,0.2,78.3,8046,74.4,NULL,NULL,'IC 0304',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29676,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29676,34.51,0.38,79.7,8046,75,NULL,'W91PP, r, cor','IC 0304',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29677,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29677,34.64,0.38,84.7,8046,75,NULL,'W91PP, r, inv','IC 0304',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29678,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29678,37.66,0.46,341,8047,70,NULL,NULL,'SDSS J031502.99-070420.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000077,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,48.7625,-7.07225,0.153,NULL,37887547021,591992922,9249889,18.3),(29679,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29679,35.91,0.72,152,8048,70,NULL,NULL,'2MASX J03150705-0233588',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'17.03',0.21,NULL,NULL,NULL,NULL,NULL,1,48.7794166667,-2.56631,0.205,NULL,36788959070,574827485,8981679,17.03),(29680,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29680,35.9,0.77,151,8049,70,NULL,NULL,'2MASX J03150706-1309304',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'16.92',0.35,NULL,NULL,NULL,NULL,NULL,1,48.779667,-13.15847,0.137,NULL,38074387645,594912306,9295504,16.92),(29681,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 14358','RN',29681,42.19,0.21,2150,8050,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 14358',0.27297,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29682,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 14358','RN',29682,42.48,0.27,2460,8050,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 14358',0.27297,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29683,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 22006','R',29683,41.76,0.39,1610,8051,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J031507.89-005745.3',0.3956,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',0.0002,NULL,'21.0g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,48.782917,-0.96261,0.169,NULL,36785608283,574775129,8980861,21),(29684,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 22006',NULL,29684,41.65,0.38,2140,8051,70,NULL,'SALT 2','SDSS J031507.89-005745.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29685,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 22006',NULL,29685,41.71,0.38,2200,8051,70,NULL,'SALT 2, Malmquist cor.','SDSS J031507.89-005745.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29686,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29686,35.58,0.59,131,8052,70,NULL,NULL,'2MASX J03150972-0715093',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.000075,NULL,'16.1g',0.19,'Sb(f)          NLAGN',NULL,NULL,NULL,NULL,1,48.790375,-7.25261,0.173,NULL,37887562137,591993158,9249893,16.1),(29687,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SN 2007kh',NULL,29687,36.75,0.48,213,8053,73.8,NULL,'SALT 2 (SNANA)','[YAA2007a] J031512.10+431013.0',0.0495,'2014ApJ...795...44R',2014,1,NULL,NULL,'G',NULL,':',NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,48.800417,43.17028,0.881,NULL,68564358967,1071318108,16739345,NULL),(29688,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29688,35.06,NULL,103,8054,NULL,NULL,'Dipole + Quadrupole','FGC 0402',NULL,'2010Ap&SS.325..163P',2010,1,1.24,NULL,'G',0.000047,NULL,'16.1g',0.23,'Sd(f)',NULL,NULL,NULL,NULL,1,48.8055417,-7.27075,0.173,NULL,37887590547,591993602,9249900,16.1),(29689,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29689,35.06,NULL,103,8054,NULL,NULL,'Dipole','FGC 0402',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29690,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29690,35.07,NULL,103,8054,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0402',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29691,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29691,35.13,NULL,106,8054,NULL,NULL,NULL,'FGC 0402',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29692,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29692,35.28,0.49,114,8054,75,NULL,'IR','FGC 0402',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29693,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29693,34.62,0.4,83.8,8055,NULL,NULL,'mean','NGC 1250',NULL,'2007A&A...465...71T',2007,1,2.1,NULL,'G',0.000037,NULL,'13.96',0.9,'S0^0^: sp','Group member',NULL,NULL,NULL,1,48.837917,41.35542,0.605,NULL,68561523108,1071273798,16738653,13.96),(29694,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29694,34.65,0.45,85.2,8055,NULL,NULL,'K','NGC 1250',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29695,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29695,37.69,0.46,345,8056,70,NULL,NULL,'2MASX J03152589-0725543',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000111,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,48.8577917,-7.43186,0.177,NULL,37887663166,591994736,9249917,16.9),(29696,'FP','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,NULL,29696,35.94,0.56,154,8057,70,NULL,NULL,'LCRS B031335.3-393537',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.72',0.29,NULL,NULL,NULL,NULL,NULL,1,48.8665416667,-39.41017,0,NULL,38597876787,603091824,9423309,16.72),(29697,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 15903',NULL,29697,40.42,0.17,1210,8058,70,NULL,'SN photometric redshift distance, z photo =0.338 +/- 0.035','SDSS-II SN 15903',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,48.906125,-0.60267,0.173,NULL,36785939112,574780298,8980942,NULL),(29698,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 13673','RN',29698,40.67,0.11,1130,8059,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 13673',0.207397,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29699,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:01','1','SDSS-II SN 13673','RN',29699,41.38,0.2,1560,8059,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 13673',0.207397,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29700,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:01','1',NULL,'R',29700,33.48,0.49,49.6,8060,75,NULL,'IR','MCG -02-09-019',NULL,'2011yCatp016004901K',2011,1,2.2,NULL,'G',0.000007,NULL,'14.79',0.6,'S0+: sp',NULL,NULL,NULL,NULL,1,48.942375,-12.02433,0.165,NULL,37892630661,592072354,9251130,14.79),(29701,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29701,37.09,0.72,261,8061,70,NULL,NULL,'2MASX J03155011-5554313',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.000047,NULL,'16.58',0.38,NULL,NULL,NULL,NULL,NULL,1,48.9587083,-55.90872,0.021,NULL,35770464427,558913506,8733023,16.58),(29702,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29702,34.22,0.8,69.7,8062,75,NULL,'MAT, I','ESO 116- G 014',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'14.95',0.4,'SBcd: sp',NULL,NULL,NULL,NULL,1,48.959875,-58.57425,0,NULL,36251324687,566426948,8850421,14.95),(29703,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29703,33.88,0.32,59.6,8062,85,NULL,'I, raw','ESO 116- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29704,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29704,33.89,0.43,60,8062,75,NULL,'MAT, I, raw','ESO 116- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29705,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29705,33.91,0.32,60.4,8062,85,NULL,'I, inv','ESO 116- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29706,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',29706,33.92,0.49,60.9,8062,75,NULL,'IR','ESO 116- G 014',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29707,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29707,34.05,0.43,64.5,8062,75,NULL,'MAT, I, inv','ESO 116- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29708,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29708,34.29,0.31,72.1,8062,NULL,NULL,NULL,'ESO 116- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29709,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29709,34.32,0.43,73,8062,75,NULL,'MAT, I, cor','ESO 116- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29710,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29710,34.33,0.2,73.5,8062,74.4,NULL,NULL,'ESO 116- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29711,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29711,34.45,0.29,77.8,8062,NULL,NULL,'Malmquist cor.','ESO 116- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29712,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 04530','R',29712,40.83,0.33,1130,8063,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 04530',0.296,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,'PHOT','21.1g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,48.962,-0.46567,0.157,NULL,36785801208,574778143,8980908,21.1),(29713,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 04530',NULL,29713,40.5,0.24,1260,8063,70,NULL,'SN photometric redshift distance, z photo =0.354 +/- 0.052','SDSS-II SN 04530',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29714,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 04530','R',29714,41.22,0.3,1350,8063,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 04530',0.296,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29715,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29715,34.25,0.2,70.8,8064,74.4,NULL,NULL,'UGC 02622',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000031,NULL,'16.0',0.5,'SB(s)b',NULL,NULL,NULL,NULL,1,48.975375,9.15964,0.721,NULL,67941990000,1061593593,16587399,16),(29716,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29716,35.12,0.47,106,8064,NULL,NULL,'H','UGC 02622',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29717,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29717,35.23,0.4,111,8064,NULL,NULL,'mean','UGC 02622',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29718,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29718,35.26,0.45,113,8064,NULL,NULL,'K','UGC 02622',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29719,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29719,35.29,0.15,115,8064,NULL,NULL,NULL,'UGC 02622',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29720,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29720,35.37,0.46,119,8064,NULL,NULL,'J','UGC 02622',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29721,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 14685','RN',29721,42.54,0.24,2310,8065,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 14685',0.395269,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29722,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 14685','RN',29722,42.98,0.26,2830,8065,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 14685',0.395269,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29723,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29723,36.54,0.63,203,8066,70,NULL,NULL,'2MASX J03155864-1541199',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.83',0.36,NULL,NULL,NULL,NULL,NULL,1,48.9942917,-15.68881,0.109,NULL,38078752724,594980511,9296570,16.83),(29724,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29724,32.45,0.4,30.9,8067,73,NULL,'opt','MCG -01-09-024',NULL,'2011A&A...532A.104N',2011,1,1.8,NULL,'G',0.00002,NULL,'13.83',0.5,'Sab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,49.00225,-5.49928,0.209,NULL,36780046035,574688219,8979503,13.83),(29725,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',29725,32.46,0.4,31,8067,75,NULL,NULL,'MCG -01-09-024',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29726,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29726,32.46,0.4,31,8067,73,NULL,'IR','MCG -01-09-024',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29727,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29727,32.52,0.2,31.9,8067,74.4,NULL,NULL,'MCG -01-09-024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29728,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29728,32.57,0.43,32.6,8067,75,NULL,'3.6 micron, color corrected','MCG -01-09-024',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29729,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29729,32.63,0.43,33.6,8067,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-09-024',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29730,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',29730,32.66,0.49,34.1,8067,75,NULL,'IR','MCG -01-09-024',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29731,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29731,32.68,0.4,34.3,8067,NULL,NULL,'mean','MCG -01-09-024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29732,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29732,32.82,0.46,36.6,8067,NULL,NULL,'J','MCG -01-09-024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29733,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29733,32.82,0.47,36.7,8067,NULL,NULL,'H','MCG -01-09-024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29734,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29734,32.94,0.45,38.6,8067,NULL,NULL,'K','MCG -01-09-024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29735,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29735,32.84,0.69,37,8068,100,NULL,'mid-IR','UGC 02617',NULL,'2013ApJ...771...88L',2013,1,2.5,NULL,'G',0.000013,NULL,'13.8',0.9,'SAB(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,49.0032083,40.88564,0.593,NULL,68561950177,1071280471,16738757,13.8),(29736,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29736,33.1,0.43,41.6,8068,75,NULL,'3.6 micron, color corrected','UGC 02617',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29737,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29737,33.1,0.2,41.7,8068,74.4,NULL,NULL,'UGC 02617',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29738,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29738,33.17,0.43,43.1,8068,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02617',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29739,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29739,33.35,0.53,46.8,8068,NULL,NULL,NULL,'UGC 02617',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29740,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29740,33.68,0.45,54.4,8068,NULL,NULL,'Malmquist cor.','UGC 02617',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29741,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29741,34.02,0.4,63.7,8068,NULL,NULL,'mean','UGC 02617',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29742,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29742,34.05,0.47,64.4,8068,NULL,NULL,'H','UGC 02617',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29743,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29743,34.14,0.46,67.4,8068,NULL,NULL,'J','UGC 02617',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29744,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29744,34.18,0.45,68.4,8068,NULL,NULL,'K','UGC 02617',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29745,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29745,34.27,0.8,71.5,8069,75,NULL,'MAT, I','MCG -02-09-021',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.5',0.2,'Sc? sp',NULL,NULL,NULL,NULL,1,49.02275,-13.03492,0.153,NULL,38082261340,595035333,9297427,14.5),(29746,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29746,33.65,0.2,53.7,8069,74.4,NULL,NULL,'MCG -02-09-021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29747,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29747,33.76,0.32,56.4,8069,85,NULL,'I, raw','MCG -02-09-021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29748,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29748,33.76,0.32,56.4,8069,85,NULL,'I, inv','MCG -02-09-021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29749,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',29749,33.8,0.49,57.5,8069,75,NULL,'IR','MCG -02-09-021',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29750,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29750,33.87,0.34,59.4,8069,NULL,NULL,NULL,'MCG -02-09-021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29751,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29751,33.92,0.43,60.9,8069,75,NULL,'MAT, I, raw','MCG -02-09-021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29752,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29752,33.99,0.43,62.7,8069,75,NULL,'MAT, I, inv','MCG -02-09-021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29753,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29753,34.07,0.43,65.1,8069,75,NULL,'MAT, I, cor','MCG -02-09-021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29754,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29754,34.15,0.3,67.6,8069,NULL,NULL,'Malmquist cor.','MCG -02-09-021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29755,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29755,34.16,0.4,67.9,8070,NULL,NULL,'mean','IC 1906',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000033,NULL,'14.33',0.4,'(R\')SB(s)bc?   HII',NULL,NULL,NULL,NULL,1,49.0235417,-34.36064,0,NULL,38646846802,603856981,9435265,14.33),(29756,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29756,34.31,0.47,72.7,8070,NULL,NULL,'H','IC 1906',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29757,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29757,34.42,0.45,76.5,8070,NULL,NULL,'K','IC 1906',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29758,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29758,34.45,0.42,77.8,8070,NULL,NULL,NULL,'IC 1906',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29759,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29759,34.49,0.42,79.2,8070,NULL,NULL,'Malmquist cor.','IC 1906',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29760,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29760,34.5,0.2,79.4,8070,74.4,NULL,NULL,'IC 1906',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29761,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29761,35.56,0.52,129,8071,70,NULL,NULL,'CGCG 390-040',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00007,NULL,'15.8b',0.2,NULL,NULL,NULL,NULL,NULL,1,49.02425,-2.08061,0.237,NULL,36788754305,574824286,8981629,15.8),(29762,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29762,36.31,0.57,182,8072,70,NULL,NULL,'ESO 199- G 027',NULL,'2014MNRAS.445.2677S',2014,1,0.94,NULL,'G',0.000033,NULL,'16.33',0.18,'S0',NULL,NULL,NULL,NULL,1,49.0317083,-52.1475,0,NULL,37718142474,589345976,9208530,16.33),(29763,'Tully est','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29763,31.97,0.8,24.8,8073,75,NULL,NULL,'UGCA 063',NULL,'1988NBGC.C....0000T',1988,1,1.2,NULL,'G',0.000007,NULL,'15.36',1,'IB(s)m',NULL,NULL,NULL,NULL,1,49.04025,-24.20061,0,NULL,38032453743,594257089,9285267,15.36),(29764,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 14284','R',29764,39.49,0.18,669,8074,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ib','SDSS J031611.83-003603.4',0.18,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,49.0492917,-0.60094,0.173,NULL,36785755465,574777429,8980897,NULL),(29765,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 14284','R',29765,39.61,0.08,708,8074,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ib','SDSS J031611.83-003603.4',0.18,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29766,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2006ib',NULL,29766,39.26,0.08,711,8074,70,NULL,'SALT 2','SDSS J031611.83-003603.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29767,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2006ib',NULL,29767,39.27,0.08,714,8074,70,NULL,'SALT 2, Malmquist cor.','SDSS J031611.83-003603.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29768,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',29768,37.85,0.46,371,8075,70,NULL,NULL,'2MASX J03161182-0724025',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000072,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,49.049375,-7.40064,0.157,NULL,37887507347,591992302,9249879,17.8),(29769,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 04741',NULL,29769,41.59,NULL,2080,8076,70,NULL,'SN photometric redshift distance, z photo =0.699 +/- 0.001','SDSS-II SN 04741',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.6g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,49.052,-0.38931,0.157,NULL,36785780794,574777824,8980903,22.6),(29770,'BL Lac Luminosity','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29770,40.59,0.46,1310,8077,70,NULL,NULL,'2MASS J03161273+0904434',NULL,'2014ApJ...784..151S',2014,1,NULL,NULL,'QSO',NULL,NULL,'17.4',NULL,'BLLAC',NULL,NULL,NULL,'BL Lac',1,49.0530416667,9.07869,0.721,NULL,67942009569,1061593899,16587404,17.4),(29771,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',29771,37.25,0.46,281,8078,70,NULL,NULL,'2MASX J03162167-0712436',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000099,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,49.09025,-7.21222,0.137,NULL,37888085874,592001341,9250020,16.7),(29772,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29772,36.02,0.6,160,8079,70,NULL,NULL,'MCG -04-08-054',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00014,NULL,'15.24',0.4,'S',NULL,NULL,NULL,NULL,1,49.095083,-23.81019,0,NULL,38032631116,594259861,9285310,15.24),(29773,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29773,34.7,0.8,87.3,8080,75,NULL,'CF, r','UGC 02628',NULL,'1997ApJS..109..333W',1997,1,1.75,NULL,'G',0.000017,NULL,'14.8g',0.4,'SB(s)bc:',NULL,NULL,NULL,NULL,1,49.132667,-0.46814,0.149,NULL,36787815507,574809617,8981400,14.8),(29774,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29774,34.48,0.38,78.8,8080,75,NULL,'CF, r, raw','UGC 02628',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29775,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29775,34.61,0.38,83.5,8080,75,NULL,'CF, r, inv','UGC 02628',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29776,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29776,34.74,0.2,88.7,8080,74.4,NULL,NULL,'UGC 02628',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29777,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29777,34.77,0.38,89.9,8080,75,NULL,'CF, r, cor','UGC 02628',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29778,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29778,34.96,0.33,98.3,8080,NULL,NULL,NULL,'UGC 02628',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29779,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29779,34.99,0.32,99.6,8080,NULL,NULL,'Malmquist cor.','UGC 02628',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29780,'CMD','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'N',29780,19.46,0.2,0.078,8081,NULL,NULL,NULL,'Horologium II',NULL,'2015ApJ...808L..39K',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29781,'CMD','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'RN',29781,19.5,NULL,0.0794,8081,NULL,NULL,NULL,'Horologium II',NULL,'2016MNRAS.458..603L',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29782,'D-Sigma','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29782,34.41,0.4,76.3,8082,75,NULL,'Edat, raw','IC 0310',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'13.89',1.3,'SA(r)0^0^:','Group member, radial-velocity confirmed',NULL,'NAT',NULL,1,49.1790833333,41.32497,0.597,NULL,68561490631,1071273291,16738645,13.89),(29783,'D-Sigma','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29783,34.43,0.4,77,8082,75,NULL,'Edat, cor','IC 0310',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29784,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29784,33.84,0.23,58.6,8082,74.4,NULL,NULL,'IC 0310',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29785,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29785,34.3,0.45,72.5,8082,NULL,NULL,'K','IC 0310',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29786,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29786,34.36,0.4,74.4,8082,NULL,NULL,'mean','IC 0310',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29787,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29787,32.1,0.43,26.2,8083,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J03164400+6501431',NULL,'2014MNRAS.444..527S',2014,1,1.7,NULL,'G',0.00002,NULL,'9.30K',0.78,'S/S0',NULL,NULL,NULL,NULL,1,49.183333,65.02867,NULL,NULL,66550421608,1039850337,16247661,9.3),(29788,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29788,34.62,0.2,84,8084,74.4,NULL,NULL,'UGC 02631',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',NULL,NULL,'17.',0.2,'S?',NULL,NULL,NULL,NULL,1,49.1875,6.00558,0.585,NULL,67918375704,1061224620,16581634,17),(29789,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29789,35.03,0.17,102,8084,NULL,NULL,NULL,'UGC 02631',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29790,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29790,37.03,0.8,255,8085,70,NULL,NULL,'2MASX J03164547-6905107',NULL,'2014MNRAS.445.2677S',2014,1,0.24,NULL,'G',0.00015,NULL,'16.8b',0.2,NULL,NULL,NULL,NULL,NULL,1,49.1896666667,-69.08636,0.061,NULL,36446134925,569470858,8897982,16.8),(29791,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',29791,37.39,0.33,300,8086,70,NULL,NULL,'2MASX J03164856-0112189',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000063,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,49.2022083,-1.20519,0.173,NULL,36787394295,574803035,8981297,17.3),(29792,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',29792,37.71,0.46,348,8087,70,NULL,NULL,'2MASX J03165002+0010302',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000069,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,49.2084583,0.175,0.209,NULL,64968991421,1015140490,15861570,18.3),(29793,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29793,31.7,0.8,21.9,8088,75,NULL,'MAT, I','ESO 357- G 012',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.000005,NULL,'14.87',1.6,'SB(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,49.2200416667,-35.54053,0,NULL,38593656389,603025881,9422279,14.87),(29794,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29794,31.7,0.8,21.9,8088,75,NULL,'A82, H','ESO 357- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29795,'Tully est','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29795,31.28,0.8,18,8088,75,NULL,NULL,'ESO 357- G 012',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29796,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29796,31.35,0.32,18.6,8088,85,NULL,'I, inv','ESO 357- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29797,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29797,31.36,0.43,18.7,8088,75,NULL,'3.6 micron, color + selection bias corrected','ESO 357- G 012',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29798,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29798,31.37,0.08,18.8,8088,NULL,NULL,NULL,'ESO 357- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29799,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29799,31.38,0.32,18.9,8088,85,NULL,'I, raw','ESO 357- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29800,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29800,31.51,0.43,20,8088,75,NULL,'3.6 micron, color corrected','ESO 357- G 012',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29801,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29801,31.54,0.38,20.3,8088,NULL,NULL,NULL,'ESO 357- G 012',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29802,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29802,31.54,0.4,20.3,8088,73,NULL,'opt','ESO 357- G 012',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29803,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29803,31.6,0.2,20.9,8088,74.4,NULL,NULL,'ESO 357- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29804,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29804,31.81,0.47,23,8088,75,NULL,'A82, H, inv','ESO 357- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29805,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29805,31.95,0.43,24.6,8088,75,NULL,'MAT, I, inv','ESO 357- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29806,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29806,31.97,0.47,24.8,8088,75,NULL,'A82, H, raw','ESO 357- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29807,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29807,31.99,0.43,25,8088,75,NULL,'MAT, I, raw','ESO 357- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29808,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29808,32,0.43,25.1,8088,75,NULL,'MAT, I, cor','ESO 357- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29809,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29809,32,0.47,25.1,8088,75,NULL,'A82, H, cor','ESO 357- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29810,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 16121',NULL,29810,33.54,0.75,51.1,8089,70,NULL,'SN photometric redshift distance, z photo =0.012 +/- 0.005','SDSS-II SN 16121',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,49.2288333333,-0.35597,0.149,NULL,36787747726,574808558,8981383,NULL),(29811,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 19531',NULL,29811,41.59,NULL,2080,8090,70,NULL,'SN photometric redshift distance, z photo =0.700 +/- 0.001','SDSS-II SN 19531',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.2g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,49.2357917,-0.586,0.121,NULL,36787834582,574809915,8981404,21.2),(29812,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',29812,37.39,0.33,300,8091,70,NULL,NULL,'2MASX J03165784-0113473',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000076,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,49.241,-1.22983,0.173,NULL,36787401668,574803151,8981299,17.5),(29813,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29813,37.13,0.57,267,8092,70,NULL,NULL,'2MASX J03170439-1553103',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.60',0.39,NULL,NULL,NULL,NULL,NULL,1,49.268167,-15.88633,0.101,NULL,38079056290,594985254,9296644,16.6),(29814,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29814,33.65,0.2,53.7,8093,74.4,NULL,NULL,'CGCG 441-006',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000057,NULL,'14.75',0.3,'Sc',NULL,NULL,NULL,NULL,1,49.268583,15.48453,0.469,NULL,68162164501,1065033820,16641153,14.75),(29815,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',29815,34.47,0.49,78.3,8094,75,NULL,'IR','FGC 0406',NULL,'2011yCatp016004901K',2011,1,0.95,NULL,'G',0.000067,NULL,'16.4',0.12,'Sc',NULL,NULL,NULL,NULL,1,49.279375,-16.96539,0.085,NULL,38079424123,594991001,9296734,16.4),(29816,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29816,33.45,0.2,49,8095,74.4,NULL,NULL,'UGC 02630',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000067,NULL,'15.57',0.3,'Sbc',NULL,NULL,NULL,NULL,1,49.2985417,37.137,0.745,NULL,68699332732,1073427073,16772298,15.57),(29817,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29817,33.89,0.47,60,8096,NULL,NULL,'H','NGC 1288',NULL,'2007A&A...465...71T',2007,1,2.3,NULL,'G',0.000013,NULL,'13.26',1.9,'SA(rs)bc','Group non-member, background',NULL,NULL,NULL,1,49.3049583,-32.57589,0,NULL,38612921180,603326893,9426982,13.26),(29818,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29818,33.94,0.46,61.3,8096,NULL,NULL,'J','NGC 1288',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29819,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29819,33.97,0.45,62.4,8096,NULL,NULL,'K','NGC 1288',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29820,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29820,33.97,0.4,62.4,8096,NULL,NULL,'mean','NGC 1288',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29821,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 01040','RN',29821,41.51,0.11,1550,8097,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01040',0.29739,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29822,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 01040','RN',29822,41.64,0.2,1640,8097,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01040',0.29739,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29823,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29823,35.33,NULL,116,8098,NULL,NULL,NULL,'FGC 0407',NULL,'2000BSAO...50....5K',2000,1,1.46,NULL,'G',0.00007,NULL,'16.2',0.12,'SB(s)d? sp',NULL,NULL,NULL,NULL,1,49.321167,-15.05511,0.149,NULL,38083985005,595062265,9297847,16.2),(29824,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',29824,35.37,0.49,119,8098,75,NULL,'IR','FGC 0407',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29825,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29825,35.45,NULL,123,8098,NULL,NULL,'Dipole + Quadrupole','FGC 0407',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29826,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29826,35.45,NULL,123,8098,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0407',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29827,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29827,35.46,NULL,123,8098,NULL,NULL,'Dipole','FGC 0407',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29828,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2008L',NULL,29828,33.65,0.2,52.7,8099,74.2,NULL,'SALT 2','NGC 1259',0.0194,'2010ApJ...716..712A',2010,1,0.7,NULL,'G',NULL,NULL,'16',0.4,'S0',NULL,NULL,NULL,NULL,1,49.322,41.3855,0.597,NULL,68561654909,1071275857,16738685,16),(29829,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2008L',NULL,29829,34.2,0.04,67.9,8099,72,NULL,'MLCS17','NGC 1259',0.0194,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29830,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2008L',NULL,29830,34.23,0.09,70.2,8099,74.4,NULL,NULL,'NGC 1259',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29831,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2008L',NULL,29831,34.39,0.26,74.1,8099,65,NULL,'MLCS17','NGC 1259',0.0194,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29832,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2008L',NULL,29832,34.4,0.18,74.4,8099,73.8,NULL,'SALT 2 (SNANA)','NGC 1259',0.0191,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29833,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2008L',NULL,29833,34.41,0.19,74.8,8099,70,NULL,'SALT 2','NGC 1259',0.0194,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29834,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2008L',NULL,29834,34.46,0.2,76.4,8099,65,NULL,'SALT','NGC 1259',0.0194,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29835,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2008L',NULL,29835,34.48,0.25,77.1,8099,65,NULL,'MLCS31','NGC 1259',0.0194,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29836,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2008L',NULL,29836,34.54,0.24,79.4,8099,65,NULL,'SALT2','NGC 1259',0.0194,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29837,'Tully est','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29837,30.26,0.8,11.3,8100,75,NULL,'B','ARK 099',NULL,'1988NBGC.C....0000T',1988,1,0.3,NULL,'G',0.000077,NULL,'15.2',0.15,NULL,NULL,NULL,NULL,NULL,1,49.3267083,3.61189,0.273,NULL,64972890234,1015201409,15862522,15.2),(29838,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29838,29.68,0.4,8.6,8101,75,NULL,'B','NGC 1291',NULL,'1988NBGC.C....0000T',1988,1,9.8,'Extended HIPASS source','G',0.000006,NULL,'9.39',8.1,'(R_1)SB(1)0/a  HII','Group member',NULL,NULL,NULL,1,49.3274583,-41.10806,0,NULL,38477464526,601210383,9393912,9.39),(29839,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29839,35.93,0.73,154,8102,70,NULL,NULL,'2MASX J03171861-5552165',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.23',0.48,'S0',NULL,NULL,NULL,NULL,1,49.327625,-55.87128,0.029,NULL,35770567431,558915116,8733048,16.23),(29840,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 14153','RN',29840,39.68,0.26,730,8103,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 14153',0.18149,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29841,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29841,34.46,0.4,78,8104,NULL,NULL,'mean','UGC 02633',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000033,NULL,'17.',0.19,'Sc',NULL,NULL,NULL,NULL,1,49.3434583,36.56856,0.841,NULL,68698959925,1073421248,16772207,17),(29842,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',29842,34.79,0.49,90.7,8104,75,NULL,'IR','UGC 02633',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29843,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29843,34.8,0.45,91.1,8104,NULL,NULL,'K','UGC 02633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29844,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29844,34.8,0.47,91.2,8104,NULL,NULL,'H','UGC 02633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29845,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29845,35.45,NULL,123,8104,NULL,NULL,'Dipole + Quadrupole','UGC 02633',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29846,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29846,35.45,NULL,123,8104,NULL,NULL,'Dipole','UGC 02633',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29847,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29847,35.45,NULL,123,8104,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02633',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29848,'SNII optical','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2006gy','R',29848,34.16,0.54,68,8105,NULL,NULL,'Dense Shell Method (Baade ruler)','NGC 1260',NULL,'2012JETPL..96..153B',2012,1,1.1,NULL,'G',0.000047,NULL,'14.32',0.5,'S0/a: sp','Group member',NULL,NULL,NULL,1,49.3635,41.40522,0.597,NULL,68561662382,1071275974,16738687,14.32),(29849,'SNII optical','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2006gy','R',29849,34.19,0.53,69,8105,NULL,NULL,'Dense Shell Method (Baade ruler)','NGC 1260',NULL,'2013JETPL..98..432B',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29850,'D-Sigma','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29850,34.41,0.4,76.3,8105,75,NULL,'Edat, raw','NGC 1260',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29851,'D-Sigma','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29851,34.43,0.4,77,8105,75,NULL,'Edat, cor','NGC 1260',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29852,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29852,35.61,0.55,132,8106,70,NULL,NULL,'2MASX J03172725-1648083',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.24',0.21,NULL,NULL,NULL,NULL,NULL,1,49.363375,-16.80225,0.117,NULL,38079870321,594997973,9296843,16.24),(29853,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29853,35.87,0.62,150,8107,70,NULL,NULL,'FAIRALL 0746',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.000097,NULL,'16.29',0.45,'S0',NULL,NULL,NULL,NULL,1,49.3770416667,-52.17692,0,NULL,37729210607,589518915,9211233,16.29),(29854,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',29854,33.14,0.49,42.5,8108,75,NULL,'IR','UGC 02637',NULL,'2011yCatp016004901K',2011,1,1.42,NULL,'G',0.000033,NULL,'17.',0.11,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,49.3792916667,38.02622,0.785,NULL,68701939299,1073467801,16772934,17),(29855,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29855,33.23,0.43,44.3,8108,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02637',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29856,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29856,33.47,0.2,49.4,8108,74.4,NULL,NULL,'UGC 02637',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29857,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29857,33.48,0.43,49.7,8108,75,NULL,'3.6 micron, color corrected','UGC 02637',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29858,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29858,34.34,NULL,73.7,8108,NULL,NULL,'Dipole + Quadrupole','UGC 02637',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29859,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29859,34.34,NULL,73.8,8108,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02637',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29860,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29860,34.35,NULL,74,8108,NULL,NULL,'Dipole','UGC 02637',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29861,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2006gj',NULL,29861,33.18,0.2,42.2,8109,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','UGC 02650',0.0277,'2011A&A...526A..81B',2011,1,1,NULL,'G',0.0001,NULL,'15.50',0.2,'Sab','Group member',NULL,NULL,NULL,1,49.3936666667,-1.69508,0.193,NULL,36786848333,574794505,8981164,15.5),(29862,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2006gj',NULL,29862,34.96,0.18,95.5,8109,74.2,NULL,'SALT 2','UGC 02650',0.0277,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29863,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2006gj',NULL,29863,35.31,0.18,112,8109,65,NULL,'MLCS31, z SN CMB','UGC 02650',0.0277,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29864,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2006gj',NULL,29864,35.48,0.09,118,8109,72,NULL,NULL,'UGC 02650',0.02777,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29865,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2006gj',NULL,29865,35.45,0.17,120,8109,70,NULL,'SALT 2','UGC 02650',0.0277,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29866,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2006gj',NULL,29866,35.49,0.19,125,8109,72,NULL,'M(H) = -18.317 mag','UGC 02650',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29867,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2006gj',NULL,29867,35.54,0.09,128,8109,74.4,NULL,NULL,'UGC 02650',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29868,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2006gj',NULL,29868,35.67,0.17,133,8109,65,NULL,'MLCS17, z SN CMB','UGC 02650',0.0277,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29869,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2006gj',NULL,29869,35.85,0.18,144,8109,65,NULL,'SALT, z SN CMB','UGC 02650',0.0277,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29870,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2006gj',NULL,29870,35.86,0.2,144,8109,65,NULL,'SALT2, z SN CMB','UGC 02650',0.0277,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29871,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29871,36.1,0.54,166,8110,70,NULL,NULL,'2MASX J03173593-1018511',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'16.03',0.24,NULL,NULL,NULL,NULL,NULL,1,49.3997917,-10.31406,0.245,NULL,37899722482,592183163,9252861,16.03),(29872,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',29872,37.91,0.46,382,8111,70,NULL,NULL,'SDSS J031739.16-075724.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000119,NULL,'18.3g',0.13,'NLAGN',NULL,NULL,NULL,NULL,1,49.4132083333,-7.95669,0.157,NULL,37891130602,592048915,9250764,18.3),(29873,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',29873,33.91,0.46,60.5,8112,70,NULL,NULL,'NGC 1286',NULL,'2015arXiv151105856S',2015,1,0.94,NULL,'G',0.000092,NULL,'14.1g',0.79,'S0o',NULL,NULL,NULL,NULL,1,49.4522083,-7.61686,0.153,NULL,37887806526,591996976,9249952,14.1),(29874,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29874,33.94,0.49,61.4,8112,70,NULL,NULL,'NGC 1286',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29875,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29875,36.6,0.8,209,8113,70,NULL,NULL,'2MASX J03174922-5453147',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'17.04',0.25,NULL,NULL,NULL,NULL,NULL,1,49.4550417,-54.88733,0.021,NULL,35771550675,558930479,8733288,17.04),(29876,'Magnitude','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29876,36.77,0.13,226,8113,100,NULL,NULL,'ABELL 3111',NULL,'1998A&A...337...31R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29877,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29877,35.04,0.53,102,8114,70,NULL,NULL,'2MASX J03175104-5551306',NULL,'2014MNRAS.445.2677S',2014,1,0.92,NULL,'G',0.0001,NULL,'15.19',0.48,'S0',NULL,NULL,NULL,NULL,1,49.4627083,-55.85847,0.029,NULL,35770366620,558911978,8732999,15.19),(29878,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29878,34.58,NULL,82.3,8115,NULL,NULL,NULL,'FGC 0408',NULL,'2000BSAO...50....5K',2000,1,1,NULL,'G',0.000027,NULL,'16.7',0.1,'Sdm',NULL,NULL,NULL,NULL,1,49.463,-17.22972,0.077,NULL,38076550065,594946094,9296032,16.7),(29879,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29879,34.63,NULL,84.5,8115,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0408',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29880,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29880,34.64,NULL,84.9,8115,NULL,NULL,'Dipole + Quadrupole','FGC 0408',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29881,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29881,34.65,NULL,85.1,8115,NULL,NULL,'Dipole','FGC 0408',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29882,'Magnitude','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29882,36.77,0.13,226,8116,100,NULL,NULL,'AM 0316-455 NED02',NULL,'1998A&A...337...31R',1998,1,0.55,NULL,'G',0.0002,NULL,'16.23',0.48,'S0',NULL,NULL,NULL,NULL,1,49.464875,-45.72775,0,NULL,38515782180,601809096,9403267,16.23),(29883,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29883,34.1,0.69,66.2,8117,100,NULL,'mid-IR','UGC 02640',NULL,'2013ApJ...771...88L',2013,1,1.1,NULL,'G',0.000032,NULL,'14.2',0.6,'SBb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,49.468125,43.30414,0.869,NULL,68565325149,1071333205,16739581,14.2),(29884,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29884,34.62,0.4,83.8,8117,NULL,NULL,'mean','UGC 02640',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29885,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29885,34.77,0.2,90,8117,74.4,NULL,NULL,'UGC 02640',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29886,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29886,34.87,0.47,94.2,8117,NULL,NULL,'H','UGC 02640',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29887,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29887,34.9,0.45,95.3,8117,NULL,NULL,'K','UGC 02640',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29888,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29888,34.96,0.46,98.3,8117,NULL,NULL,'J','UGC 02640',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29889,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29889,33.64,0.47,53.4,8118,NULL,NULL,'H','NGC 1285',NULL,'2007A&A...465...71T',2007,1,1.02,NULL,'G',0.000023,NULL,'13.5g',0.81,'(R\')SB(r)b pec',NULL,NULL,NULL,NULL,1,49.472625,-7.29781,0.149,NULL,37887957827,591999341,9249989,13.5),(29890,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29890,33.74,0.46,55.9,8118,NULL,NULL,'J','NGC 1285',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29891,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29891,33.77,0.45,56.7,8118,NULL,NULL,'K','NGC 1285',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29892,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29892,34.18,0.4,68.5,8118,NULL,NULL,'mean','NGC 1285',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29893,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',29893,36.2,0.27,173,8119,70,NULL,NULL,'2MASX J03175607+0102431',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000099,NULL,'15.7g',0.35,'S0',NULL,NULL,NULL,NULL,1,49.483625,1.04536,0.221,NULL,64969768244,1015152628,15861759,15.7),(29894,'Magnitude','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29894,37.06,0.13,258,8120,100,NULL,NULL,'ESO 248- G 006',NULL,'1998A&A...337...31R',1998,1,1.1,'The APM image includes several superposed stars and galaxies.','G',0.00017,NULL,'14.9',0.5,'S0?;BrClG',NULL,NULL,NULL,NULL,1,49.4902916667,-44.23817,0,NULL,38481516206,601273690,9394901,14.9),(29895,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',29895,37,0.46,252,8121,70,NULL,NULL,'2MASXi J0317584-060238',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000062,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,49.4932083,-6.04414,0.169,NULL,36834437889,575538092,8992782,17.5),(29896,'Magnitude','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29896,37.06,0.13,258,8122,100,NULL,NULL,'ABELL 3112',NULL,'1998A&A...337...31R',1998,1,NULL,'Katgert (1996,A&A,310,8) identifies multiple redshift systems in this cluster.','GClstr',0.0004,NULL,NULL,NULL,'I      [BM];R: [A]',NULL,NULL,NULL,NULL,1,49.49375,-44.23889,0,NULL,38481516207,601273690,9394901,NULL),(29897,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29897,37.14,0.53,267,8123,70,NULL,NULL,'2MASX J03180432-2409583',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.85',0.35,NULL,NULL,NULL,NULL,NULL,1,49.518125,-24.16628,0,NULL,38032888718,594263886,9285373,16.85),(29898,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29898,34.24,0.23,70.5,8124,74.4,NULL,NULL,'IC 0312',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000043,NULL,'14.4',0.5,'E:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,49.535875,41.75411,0.753,NULL,68561444499,1071272570,16738633,14.4),(29899,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29899,34.19,0.4,68.9,8124,NULL,NULL,'mean','IC 0312',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29900,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29900,34.2,0.45,69.3,8124,NULL,NULL,'K','IC 0312',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29901,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29901,36.88,0.52,237,8125,70,NULL,NULL,'FAIRALL 1259',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'15.8B',0.42,NULL,NULL,NULL,NULL,NULL,1,49.545125,-76.75844,0.361,NULL,35646344837,556974138,8702720,15.8),(29902,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29902,31.32,0.8,18.3,8126,75,NULL,'A82, H','NGC 1292',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000013,NULL,'12.70',1.3,'SA(s)c         HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,49.5620416667,-27.61033,0,NULL,38553946193,602405409,9412584,12.7),(29903,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29903,31.33,0.8,18.5,8126,75,NULL,'MAT, I','NGC 1292',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29904,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29904,30.99,0.4,15.7,8126,75,NULL,'B','NGC 1292',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29905,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29905,31.19,0.4,17.3,8126,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 1292',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29906,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29906,31.32,0.43,18.3,8126,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1292',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29907,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29907,31.36,0.43,18.7,8126,75,NULL,'3.6 micron, color corrected','NGC 1292',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29908,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29908,31.37,0.09,18.8,8126,NULL,NULL,NULL,'NGC 1292',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29909,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29909,31.39,0.35,19,8126,NULL,NULL,NULL,'NGC 1292',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29910,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29910,31.39,0.4,19,8126,73,NULL,'opt','NGC 1292',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29911,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29911,31.41,0.2,19.1,8126,74.4,NULL,NULL,'NGC 1292',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29912,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29912,31.53,0.47,20.3,8126,75,NULL,'A82, H, inv','NGC 1292',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29913,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29913,31.54,0.47,20.3,8126,75,NULL,'A82, H, raw','NGC 1292',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29914,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29914,31.64,0.32,21.3,8126,85,NULL,'I, raw','NGC 1292',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29915,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29915,31.66,0.32,21.5,8126,85,NULL,'I, inv','NGC 1292',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29916,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29916,31.66,0.4,21.5,8126,NULL,NULL,'mean','NGC 1292',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29917,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29917,31.73,0.47,22.2,8126,75,NULL,'A82, H, cor','NGC 1292',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29918,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29918,31.84,0.43,23.3,8126,75,NULL,'MAT, I, raw','NGC 1292',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29919,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29919,31.92,0.43,24.2,8126,75,NULL,'MAT, I, cor','NGC 1292',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29920,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29920,31.95,0.43,24.6,8126,75,NULL,'MAT, I, inv','NGC 1292',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29921,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29921,32.08,0.47,26,8126,NULL,NULL,'H','NGC 1292',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29922,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29922,32.09,0.46,26.2,8126,NULL,NULL,'J','NGC 1292',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29923,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29923,32.19,0.45,27.4,8126,NULL,NULL,'K','NGC 1292',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29924,'Cepheids','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29924,28.32,0.08,4.61,8127,NULL,NULL,'26, BV, +/- 0.06 mag syst.','NGC 1313',NULL,'2015ApJ...799...19Q',2015,1,9.1,'Extended HIPASS source','G',0.000007,NULL,'9.2',6.9,'SB(s)d         HII','Field galaxy',NULL,NULL,NULL,1,49.566875,-66.49825,0.033,NULL,36504133205,570377081,8912141,9.2),(29925,'SNII radio','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 1978K',NULL,29925,27.96,0.41,3.9,8127,NULL,NULL,NULL,'NGC 1313',NULL,'1998ApJ...500...51W',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29926,'TRGB','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29926,28.05,0.11,4.07,8127,NULL,NULL,'I','NGC 1313',NULL,'2008A&A...486..151G',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29927,'TRGB','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29927,28.08,0.06,4.13,8127,NULL,NULL,NULL,'NGC 1313',NULL,'2002AJ....124..213M',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29928,'TRGB','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29928,28.09,0.03,4.15,8127,NULL,NULL,NULL,'NGC 1313',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29929,'TRGB','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29929,28.14,0.08,4.25,8127,74.4,NULL,NULL,'NGC 1313',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29930,'TRGB','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29930,28.15,0.03,4.27,8127,NULL,NULL,'I','NGC 1313',NULL,'2007ApJ...661..815R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29931,'TRGB','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29931,28.21,0.02,4.39,8127,NULL,NULL,'I','NGC 1313',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29932,'HII region diameter','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29932,27.39,NULL,3,8127,NULL,NULL,'Photographic','NGC 1313',NULL,'1981AN....302..251I',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29933,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29933,27.86,0.4,3.7,8127,75,NULL,'B','NGC 1313',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29934,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',29934,28.11,NULL,4.19,8127,NULL,NULL,'LEDA [April 2006]','NGC 1313',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29935,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29935,34.26,0.25,71.1,8128,74.4,NULL,NULL,'2MASX J03181889+4128097',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000137,NULL,'16.1',0.7,'S(comp)/E?',NULL,NULL,NULL,NULL,1,49.57875,41.46931,0.649,NULL,68561627008,1071275422,16738678,16.1),(29936,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29936,34.21,0.23,69.5,8129,74.4,NULL,NULL,'CGCG 540-087',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000028,NULL,'15.3',0.6,'E:','Group member',NULL,NULL,NULL,1,49.593625,41.40969,0.649,NULL,68561558825,1071274356,16738661,15.3),(29937,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',29937,36.2,0.27,173,8130,70,NULL,NULL,'2MASX J03183009+0104418',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000089,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,49.6254583,1.07844,0.233,NULL,64969739180,1015152174,15861752,16.4),(29938,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29938,31.96,0.8,24.7,8131,75,NULL,'A82, H','UGCA 064',NULL,'1997ApJS..109..333W',1997,1,2.9,'Confused HIPASS source','G',0.000025,NULL,'13.54',1,'SB(rs)cd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,49.63675,-25.83567,0,NULL,38551147903,602361685,9411901,13.54),(29939,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29939,31.97,0.8,24.7,8131,75,NULL,'MAT, I','UGCA 064',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29940,'Tully est','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29940,31.64,0.8,21.2,8131,75,NULL,NULL,'UGCA 064',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29941,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29941,31.15,0.47,17,8131,75,NULL,'A82, H, inv','UGCA 064',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29942,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29942,31.26,0.47,17.9,8131,75,NULL,'A82, H, raw','UGCA 064',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29943,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29943,31.34,0.38,18.5,8131,NULL,NULL,NULL,'UGCA 064',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29944,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29944,31.34,0.4,18.5,8131,73,NULL,'opt','UGCA 064',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29945,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29945,31.42,0.32,19.2,8131,85,NULL,'I, inv','UGCA 064',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29946,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29946,31.43,0.32,19.3,8131,85,NULL,'I, raw','UGCA 064',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29947,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29947,31.54,0.47,20.3,8131,75,NULL,'A82, H, cor','UGCA 064',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29948,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29948,31.7,0.1,21.9,8131,NULL,NULL,NULL,'UGCA 064',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29949,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29949,31.71,0.43,22,8131,75,NULL,'MAT, I, raw','UGCA 064',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29950,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29950,31.74,0.43,22.3,8131,75,NULL,'MAT, I, inv','UGCA 064',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29951,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29951,31.84,0.43,23.3,8131,75,NULL,'MAT, I, cor','UGCA 064',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29952,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29952,32,0.4,25.1,8131,NULL,NULL,'mean','UGCA 064',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29953,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29953,32.69,0.47,34.6,8131,NULL,NULL,'H','UGCA 064',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29954,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29954,35.68,0.66,137,8132,70,NULL,NULL,'LCRS B031644.0-413736',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'16.09',0.38,'S0;E',NULL,NULL,NULL,NULL,1,49.6367917,-41.44553,0,NULL,38477079669,601204369,9393818,16.09),(29955,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2005hr',NULL,29955,38.05,0.11,364,8133,74.2,NULL,'SALT 2','SDSS J031833.79+000723.9',0.12,'2010ApJ...716..712A',2010,1,0.11,NULL,'G',NULL,NULL,'20.7g',0.04,NULL,NULL,NULL,NULL,NULL,1,49.6408333333,0.12333,0.205,NULL,64966335346,1015098989,15860921,20.7),(29956,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2005hr',NULL,29956,38.52,0.03,452,8133,70,NULL,'SDSS-II SN 05395','SDSS J031833.79+000723.9',0.12,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29957,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2005hr',NULL,29957,38.78,0.12,508,8133,70,NULL,'SDSS-II SN 05395, SALT 2','SDSS J031833.79+000723.9',0.12,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29958,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2005hr',NULL,29958,38.79,0.07,512,8133,65,NULL,'SALT2','SDSS J031833.79+000723.9',0.12,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29959,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 05395','R',29959,38.81,0.18,517,8133,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005hr','SDSS J031833.79+000723.9',0.12,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29960,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 05395','R',29960,38.97,0.06,555,8133,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005hr','SDSS J031833.79+000723.9',0.12,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29961,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2005hr',NULL,29961,39.03,0.07,572,8133,65,NULL,'MLCS2k2','SDSS J031833.79+000723.9',0.12,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29962,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29962,34.95,0.4,97.5,8134,NULL,NULL,'mean','UGC 02653',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000017,NULL,'16.5',0.5,'Sd',NULL,NULL,NULL,NULL,1,49.6592916667,37.60806,0.793,NULL,68701986836,1073468544,16772946,16.5),(29963,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29963,35.12,0.47,106,8134,NULL,NULL,'H','UGC 02653',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29964,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29964,35.18,0.45,108,8134,NULL,NULL,'K','UGC 02653',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29965,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29965,35.83,0.65,146,8135,70,NULL,NULL,'2MASX J03184018-5840596',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.0001,NULL,'16.35',0.38,'S0',NULL,NULL,NULL,NULL,1,49.667417,-58.68331,0,NULL,36251110802,566423606,8850368,16.35),(29966,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29966,37.29,0.9,287,8136,70,NULL,NULL,'2MASX J03184024-5602096',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'17.04',0.2,NULL,NULL,NULL,NULL,NULL,1,49.667583,-56.03592,0.037,NULL,35770549378,558914834,8733044,17.04),(29967,'GRB','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',29967,43.14,NULL,4240,8137,70,NULL,'Pseudo z = 14','GRB 031026',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,49.675,28.36667,0.717,NULL,68501093099,1070329579,16723899,NULL),(29968,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29968,37.1,0.6,263,8138,70,NULL,NULL,'2MASX J03184256-5217401',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.000123,NULL,'16.35',0.37,'S0',NULL,NULL,NULL,NULL,1,49.6774166667,-52.29458,0,NULL,37729301712,589520339,9211255,16.35),(29969,'Tully est','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29969,31.27,0.8,17.9,8139,75,NULL,NULL,'UGCA 065',NULL,'1988NBGC.C....0000T',1988,1,2,NULL,'G',0.000018,NULL,'15.66',1.7,'IB(s)m',NULL,NULL,NULL,NULL,1,49.6807083,-23.78378,0.009,NULL,38032694903,594260857,9285325,15.66),(29970,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29970,33.47,0.2,49.4,8140,74.4,NULL,NULL,'UGC 02655',NULL,'2013AJ....146...86T',2013,1,1.8,NULL,'G',0.000027,NULL,'13.5',0.8,'SAB(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,49.688875,43.24072,0.853,NULL,68565315433,1071333053,16739578,13.5),(29971,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29971,33.52,0.43,50.5,8140,75,NULL,'3.6 micron, color corrected','UGC 02655',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29972,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29972,33.56,0.43,51.4,8140,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02655',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29973,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29973,36.63,0.63,212,8141,70,NULL,NULL,'ESO 301- G 004',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'16.54',0.2,'S0:',NULL,NULL,NULL,NULL,1,49.698333,-38.76381,0,NULL,38601997169,603156205,9424315,16.54),(29974,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29974,32.03,0.45,25.5,8142,NULL,NULL,'K','NGC 1289',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000017,NULL,'13.48',1.1,'SB(rs)0^0^:',NULL,NULL,NULL,NULL,1,49.7075416667,-1.97333,0.197,NULL,36787179091,574799673,8981244,13.48),(29975,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29975,32.72,0.4,35,8142,NULL,NULL,'mean','NGC 1289',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29976,'GRB','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'RN',29976,44.25,1.58,2900,8143,100,NULL,NULL,'GRB 050318 OA',1.44,'2009EPJC...63..139W',2009,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29977,'GRB','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'RN',29977,44.32,1.52,3000,8143,100,NULL,NULL,'GRB 050318 OA',1.44,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29978,'GRB','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'RN',29978,45.6,0.49,5400,8143,72,NULL,NULL,'GRB 050318 OA',1.44,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29979,'GRB','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'N',29979,45.71,0.47,5680,8143,70,NULL,NULL,'GRB 050318 OA',1.44,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29980,'GRB','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'RN',29980,45.86,0.58,6110,8143,NULL,NULL,NULL,'GRB 050318 OA',1.44,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29981,'GRB','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'N',29981,45.95,0.44,6350,8143,69.7,NULL,'Calibrated','GRB 050318 OA',1.44,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29982,'GRB','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'N',29982,46.09,0.51,6770,8143,69.7,NULL,'Fiducial','GRB 050318 OA',1.44,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29983,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29983,33.26,0.2,44.9,8144,74.4,NULL,NULL,'UGC 02659',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000037,NULL,'14.6',0.5,'Sbc            HII:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,49.722375,40.59583,0.621,NULL,68561340268,1071270941,16738608,14.6),(29984,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',29984,34.07,0.49,65.2,8144,75,NULL,'IR','UGC 02659',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29985,'D-Sigma','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29985,34.41,0.4,76.3,8145,75,NULL,'Edat, raw','NGC 1270',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000053,NULL,'14.26',1.2,'E:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,49.7422917,41.47,0.649,NULL,68561554148,1071274283,16738660,14.26),(29986,'D-Sigma','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29986,34.43,0.4,77,8145,75,NULL,'Edat, cor','NGC 1270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29987,'Faber-Jackson','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29987,33.43,0.44,48.5,8145,95,NULL,'Weighted Mean','NGC 1270',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29988,'Faber-Jackson','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29988,33.86,0.46,59.2,8145,95,NULL,'Michard 1979a','NGC 1270',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29989,'Faber-Jackson','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29989,34,0.63,63.1,8145,95,NULL,'Michard 1979b, c','NGC 1270',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29990,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29990,34.46,0.25,78,8145,74.4,NULL,NULL,'NGC 1270',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29991,'Tertiary','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29991,33.65,0.5,53.7,8145,95,NULL,NULL,'NGC 1270',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29992,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29992,34.37,0.23,74.8,8146,74.4,NULL,NULL,'2MASX J03185824+4142091',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000153,NULL,'15.8:',0.2,'E:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,49.74275,41.70247,0.697,NULL,68565892114,1071342064,16739719,15.8),(29993,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 18801','R',29993,40.35,0.29,943,8147,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 18801',0.244873,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,49.760125,-0.45803,0.193,NULL,36784403209,574756300,8980567,NULL),(29994,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 18801','R',29994,40.39,0.31,961,8147,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 18801',0.244873,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29995,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 13704','RN',29995,43,0.23,2740,8148,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13704',0.455103,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29996,'D-Sigma','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29996,34.41,0.4,76.3,8149,75,NULL,'Edat, raw','2MASX J03190609+4104571',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000544,NULL,'14.15',0.9,'E',NULL,NULL,NULL,NULL,1,49.775375,41.08256,0.685,NULL,68562067403,1071282303,16738785,14.15),(29997,'D-Sigma','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29997,34.43,0.4,77,8149,75,NULL,'Edat, cor','2MASX J03190609+4104571',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(29998,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',29998,36.2,0.27,173,8150,70,NULL,NULL,'2MASX J03191026+0058524',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000097,NULL,'16.2g',0.4,'S0^-           AGN',NULL,NULL,NULL,NULL,1,49.7927083,0.98125,0.241,NULL,64969430365,1015147349,15861677,16.2),(29999,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,29999,35.57,0.62,130,8151,70,NULL,NULL,'2MASX J03191152-0824512',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00015,NULL,'15.98',0.48,NULL,NULL,NULL,NULL,NULL,1,49.797917,-8.41422,0.153,NULL,37891213472,592050210,9250784,15.98),(30000,'D-Sigma','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30000,34.41,0.4,76.3,8152,75,NULL,'Edat, raw','2MASX J03191203+4105211',NULL,'1997ApJS..109..333W',1997,1,NULL,NULL,'G',0.000031,NULL,'14.10',NULL,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,49.800125,41.08922,0.685,NULL,68562066505,1071282289,16738785,14.1),(30001,'D-Sigma','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30001,34.43,0.4,77,8152,75,NULL,'Edat, cor','2MASX J03191203+4105211',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30002,'SBF','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30002,32.17,0.12,27.2,8153,74.4,NULL,NULL,'NGC 1297',NULL,'2013AJ....146...86T',2013,1,2.2,NULL,'G',0.00004,NULL,'12.77',1.9,'SAB(s)0^0^ pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,49.80925,-19.1,0.089,NULL,38033967394,594280740,9285636,12.77),(30003,'SBF','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30003,32.28,0.42,28.6,8153,NULL,NULL,'I','NGC 1297',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30004,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30004,32.17,0.12,27.2,8153,74.4,NULL,NULL,'NGC 1297',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30005,'Tully est','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30005,31.31,0.8,18.3,8153,75,NULL,'B','NGC 1297',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30006,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 08457',NULL,30006,41.29,0.24,1820,8154,70,NULL,'SN photometric redshift distance, z photo =0.572 +/- 0.102','SDSS-II SN 08457',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.7g',0.02,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,49.8195,-0.83883,0.133,NULL,36784702647,574760978,8980640,21.7),(30007,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 10990','RN',30007,40.25,0.14,1060,8155,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10990',0.05383,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30008,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 10990','RN',30008,40.92,0.26,1450,8155,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10990',0.05383,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30009,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30009,33.16,0.69,42.9,8156,100,NULL,'mid-IR','MCG -02-09-029',NULL,'2013ApJ...771...88L',2013,1,1.3,NULL,'G',0.000007,NULL,'14.43',0.9,'SA(r)c:',NULL,NULL,NULL,NULL,1,49.82375,-12.10281,0.221,NULL,37885296657,591957760,9249340,14.43),(30010,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30010,34.77,0.23,90,8157,74.4,NULL,NULL,'2MASX J03191772+4138391',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00008,NULL,'15.95',0.5,'E',NULL,NULL,NULL,NULL,1,49.8239166667,41.64428,0.697,NULL,68566092567,1071345196,16739768,15.95),(30011,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30011,36.29,0.55,181,8158,70,NULL,NULL,'2MASX J03191839-1344509',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.61',0.28,NULL,NULL,NULL,NULL,NULL,1,49.82675,-13.74756,0.165,NULL,38082888295,595045129,9297580,16.61),(30012,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 18267','RN',30012,38.97,0.25,589,8159,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18267 HOST',0.054025,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30013,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 20773','RN',30013,38.97,0.25,589,8159,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18267 HOST',0.054025,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30014,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 18267','RN',30014,41.15,0.36,1610,8159,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18267 HOST',0.054025,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30015,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 20773','RN',30015,41.15,0.36,1610,8159,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18267 HOST',0.054025,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30016,'D-Sigma','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30016,34.41,0.4,76.3,8160,75,NULL,'Edat, raw','NGC 1272',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000028,NULL,'12.86',1.9,'E+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,49.8387083333,41.49064,0.649,NULL,68565973573,1071343337,16739739,12.86),(30017,'D-Sigma','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30017,34.43,0.4,77,8160,75,NULL,'Edat, cor','NGC 1272',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30018,'Faber-Jackson','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30018,34.45,0.52,77.6,8160,95,NULL,'Weighted Mean','NGC 1272',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30019,'Faber-Jackson','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30019,34.45,0.52,77.6,8160,95,NULL,'de Vaucouleurs','NGC 1272',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30020,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30020,34.2,0.23,69.2,8160,74.4,NULL,NULL,'NGC 1272',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30021,'Tertiary','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30021,33.65,0.5,53.7,8160,95,NULL,NULL,'NGC 1272',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30022,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30022,30.7,0.8,13.8,8161,75,NULL,'MAT, I','IC 1914',NULL,'1997ApJS..109..333W',1997,1,3.8,NULL,'G',0.000003,NULL,'13.3',1.9,'SA(s)cd',NULL,NULL,NULL,NULL,1,49.8551666667,-49.59972,0,NULL,37725172007,589455812,9210247,13.3),(30023,'Sosies','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30023,31.98,0.19,24.9,8161,NULL,NULL,NULL,'IC 1914',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30024,'Tully est','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30024,30.22,0.8,11.1,8161,75,NULL,NULL,'IC 1914',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30025,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30025,30.66,0.1,13.6,8161,NULL,NULL,NULL,'IC 1914',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30026,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30026,31.26,0.32,17.9,8161,85,NULL,'I, raw','IC 1914',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30027,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30027,31.26,0.32,17.9,8161,85,NULL,'I, inv','IC 1914',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30028,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30028,31.48,0.43,19.8,8161,75,NULL,'MAT, I, raw','IC 1914',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30029,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30029,31.5,0.43,20,8161,75,NULL,'MAT, I, inv','IC 1914',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30030,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30030,31.59,0.43,20.8,8161,75,NULL,'MAT, I, cor','IC 1914',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30031,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30031,31.62,0.37,21.1,8161,NULL,NULL,NULL,'IC 1914',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30032,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30032,31.62,0.39,21.1,8161,73,NULL,'opt','IC 1914',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30033,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30033,31.9,0.2,24,8161,74.4,NULL,NULL,'IC 1914',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30034,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30034,32.02,0.43,25.4,8161,75,NULL,'3.6 micron, color corrected','IC 1914',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30035,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30035,32.16,0.43,27,8161,75,NULL,'3.6 micron, color + selection bias corrected','IC 1914',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30036,'D-Sigma','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30036,34.41,0.4,76.3,8162,75,NULL,'Edat, raw','NGC 1273',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.00005,NULL,'14.27',1.1,'SA(r)0^0^?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,49.8614166667,41.54053,0.697,NULL,68565961302,1071343145,16739736,14.27),(30037,'D-Sigma','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30037,34.43,0.4,77,8162,75,NULL,'Edat, cor','NGC 1273',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30038,'Faber-Jackson','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30038,33.75,0.55,56.2,8162,95,NULL,'de Vaucouleurs','NGC 1273',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30039,'Faber-Jackson','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30039,33.84,0.34,58.6,8162,95,NULL,'Weighted Mean','NGC 1273',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30040,'Faber-Jackson','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30040,34.22,0.46,69.8,8162,95,NULL,'Michard 1979a','NGC 1273',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30041,'Faber-Jackson','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30041,34.8,0.63,91.2,8162,95,NULL,'Michard 1979b, c','NGC 1273',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30042,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30042,33.73,0.23,55.7,8162,74.4,NULL,NULL,'NGC 1273',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30043,'Tertiary','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30043,33.65,0.5,53.7,8162,95,NULL,NULL,'NGC 1273',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30044,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30044,34.32,0.4,73.3,8162,NULL,NULL,'mean','NGC 1273',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30045,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30045,34.9,0.45,95.5,8162,NULL,NULL,'K','NGC 1273',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30046,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 22157','RN',30046,38.97,0.12,601,8163,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 22157',0.036759,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30047,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 22157','RN',30047,40.09,0.38,1010,8163,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 22157',0.036759,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30048,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2006lb',NULL,30048,39.18,0.06,685,8164,70,NULL,'Hubble residual -0.08 for z0.18202','SDSS J031928.18-001904.7',NULL,'2011ApJ...740...92G',2011,1,0.11,NULL,'G',0.0001,NULL,'19.6g',0.09,NULL,NULL,NULL,NULL,NULL,1,49.8674583,-0.318,0.193,NULL,36784983000,574765359,8980708,19.6),(30049,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 15443','R',30049,39.69,0.19,735,8164,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006lb','SDSS J031928.18-001904.7',0.18202,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30050,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 15443','R',30050,39.88,0.07,799,8164,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006lb','SDSS J031928.18-001904.7',0.18202,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30051,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2006lb',NULL,30051,39.66,0.09,855,8164,70,NULL,'SALT 2','SDSS J031928.18-001904.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30052,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2006lb',NULL,30052,39.67,0.09,859,8164,70,NULL,'SALT 2, Malmquist cor.','SDSS J031928.18-001904.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30053,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 06362',NULL,30053,40.47,0.14,1240,8165,70,NULL,'SN photometric redshift distance, z photo =0.347 +/- 0.028','SDSS-II SN 06362',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,49.8742917,-0.92111,0.133,NULL,36784706147,574761033,8980641,NULL),(30054,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30054,36.33,0.58,185,8166,70,NULL,NULL,'2MASX J03193052-1632252',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'16.88',0.29,NULL,NULL,NULL,NULL,NULL,1,49.8772917,-16.54033,0.097,NULL,38079943397,594999115,9296861,16.88),(30055,'D-Sigma','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30055,34.41,0.4,76.3,8167,75,NULL,'Edat, raw','CGCG 540-101',NULL,'1997ApJS..109..333W',1997,1,0.2,'This object has, at times, been incorrectly referred to as IC 1907.','G',0.000097,NULL,'15.42',0.2,'E?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,49.892625,41.58056,0.697,NULL,68566090774,1071345168,16739768,15.42),(30056,'D-Sigma','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30056,34.43,0.4,77,8167,75,NULL,'Edat, cor','CGCG 540-101',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30057,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30057,34.37,0.23,74.8,8167,74.4,NULL,NULL,'CGCG 540-101',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30058,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30058,31.51,0.8,20,8168,75,NULL,'MAT, I','IC 1913',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000011,NULL,'15.05',0.3,'SBb? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,49.893917,-32.46503,0,NULL,38612827653,603325432,9426959,15.05),(30059,'Tully est','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30059,30.81,0.8,14.5,8168,75,NULL,NULL,'IC 1913',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30060,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',30060,31.28,0.4,18.1,8168,75,NULL,NULL,'IC 1913',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30061,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30061,31.29,0.39,18.1,8168,73,NULL,'IR','IC 1913',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30062,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30062,31.37,0.09,18.8,8168,NULL,NULL,NULL,'IC 1913',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30063,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30063,31.48,0.43,19.8,8168,75,NULL,'3.6 micron, color + selection bias corrected','IC 1913',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30064,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30064,31.52,0.32,20.1,8168,85,NULL,'I, inv','IC 1913',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30065,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30065,31.55,0.32,20.4,8168,85,NULL,'I, raw','IC 1913',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30066,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30066,31.59,0.4,20.8,8168,73,NULL,'opt','IC 1913',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30067,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30067,31.6,0.43,20.9,8168,75,NULL,'3.6 micron, color corrected','IC 1913',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30068,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30068,31.65,0.2,21.4,8168,74.4,NULL,NULL,'IC 1913',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30069,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30069,31.87,0.43,23.6,8168,75,NULL,'MAT, I, inv','IC 1913',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30070,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30070,31.89,0.4,23.9,8168,NULL,NULL,NULL,'IC 1913',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30071,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30071,31.92,0.43,24.2,8168,75,NULL,'MAT, I, raw','IC 1913',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30072,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',30072,31.95,0.49,24.5,8168,75,NULL,'IR','IC 1913',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30073,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30073,31.96,0.43,24.7,8168,75,NULL,'MAT, I, cor','IC 1913',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30074,'D-Sigma','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30074,34.41,0.4,76.3,8169,75,NULL,'Edat, raw','NGC 1274',NULL,'1997ApJS..109..333W',1997,1,0.5,'CGCG claims NGC 1274 = IC 1907. See CGCG 0316.3+4124. NED follows MCG.','G',0.000073,NULL,'15.12',0.4,'E3','in a pair',NULL,NULL,NULL,1,49.9189583,41.54864,0.697,NULL,68565972152,1071343314,16739739,15.12),(30075,'D-Sigma','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30075,34.43,0.4,77,8169,75,NULL,'Edat, cor','NGC 1274',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30076,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30076,34.07,0.25,65.2,8169,74.4,NULL,NULL,'NGC 1274',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30077,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30077,31.6,0.8,20.9,8170,75,NULL,'MAT, I','NGC 1300',NULL,'1997ApJS..109..333W',1997,1,6.2,NULL,'G',0.000013,NULL,'11.42',4.1,'(R\')SB(s)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,49.9211666667,-19.41136,0.077,NULL,38025751310,594152364,9283630,11.42),(30078,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30078,31.62,0.8,21,8170,75,NULL,'A82, H','NGC 1300',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30079,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30079,30.59,0.32,13.1,8170,85,NULL,'I, raw','NGC 1300',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30080,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30080,30.62,0.32,13.3,8170,85,NULL,'I, inv','NGC 1300',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30081,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30081,30.76,0.47,14.2,8170,NULL,NULL,'H','NGC 1300',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30082,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30082,30.81,0.35,14.5,8170,NULL,NULL,NULL,'NGC 1300',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30083,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30083,30.81,0.4,14.5,8170,73,NULL,'opt','NGC 1300',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30084,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30084,30.82,0.45,14.6,8170,NULL,NULL,'K','NGC 1300',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30085,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30085,30.83,0.46,14.6,8170,NULL,NULL,'J','NGC 1300',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30086,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',30086,30.87,NULL,14.9,8170,NULL,NULL,'I','NGC 1300',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30087,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30087,30.88,0.4,15,8170,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 1300',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30088,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30088,31.19,0.47,17.3,8170,75,NULL,'A82, H, raw','NGC 1300',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30089,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30089,31.2,0.43,17.4,8170,75,NULL,'MAT, I, raw','NGC 1300',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30090,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',30090,31.25,NULL,17.8,8170,NULL,NULL,'B','NGC 1300',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30091,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30091,31.29,0.47,18.1,8170,75,NULL,'A82, H, inv','NGC 1300',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30092,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30092,31.37,0.4,18.8,8170,75,NULL,'B','NGC 1300',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30093,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30093,31.45,0.43,19.5,8170,75,NULL,'MAT, I, inv','NGC 1300',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30094,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30094,31.48,0.43,19.8,8170,75,NULL,'MAT, I, cor','NGC 1300',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30095,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30095,31.51,0.47,20,8170,75,NULL,'A82, H, cor','NGC 1300',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30096,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',30096,31.53,NULL,20.2,8170,NULL,NULL,'LEDA [Nov 2006]','NGC 1300',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30097,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30097,31.56,0.4,20.5,8170,NULL,NULL,'mean','NGC 1300',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30098,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30098,31.77,0.07,22.6,8170,NULL,NULL,NULL,'NGC 1300',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30099,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',30099,36.57,0.46,206,8171,70,NULL,NULL,'2MASX J03194134-0109346',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000063,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,49.92225,-1.15958,0.145,NULL,36787690272,574807660,8981369,17.2),(30100,'D-Sigma','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30100,34.41,0.4,76.3,8172,75,NULL,'Edat, raw','PER 153',NULL,'1997ApJS..109..333W',1997,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,49.9227917,41.44572,0.649,NULL,68565964239,1071343191,16739737,NULL),(30101,'D-Sigma','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30101,34.43,0.4,77,8172,75,NULL,'Edat, cor','PER 153',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30102,'D-Sigma','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30102,34.41,0.4,76.3,8173,75,NULL,'Edat, raw','2MASX J03194386+4127251',NULL,'1997ApJS..109..333W',1997,1,NULL,NULL,'G',0.000474,NULL,'14.96',NULL,'E',NULL,NULL,NULL,NULL,1,49.932667,41.45697,0.649,NULL,68565971531,1071343305,16739739,14.96),(30103,'D-Sigma','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30103,34.43,0.4,77,8173,75,NULL,'Edat, cor','2MASX J03194386+4127251',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30104,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30104,34.78,0.25,90.4,8173,74.4,NULL,NULL,'2MASX J03194386+4127251',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30105,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30105,33.84,0.23,58.6,8174,74.4,NULL,NULL,'2MASX J03194466+4126472',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000147,NULL,'16.9:',NULL,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,49.9360417,41.44644,0.685,NULL,68565964698,1071343198,16739737,16.9),(30106,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',30106,34.38,0.46,75.3,8175,70,NULL,NULL,'CGCG 390-059',NULL,'2015arXiv151105856S',2015,1,0.86,NULL,'G',0.00005,NULL,'14.5g',0.68,'E','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,49.945875,0.58458,0.229,NULL,64966410969,1015100171,15860940,14.5),(30107,'D-Sigma','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30107,34.41,0.4,76.3,8176,75,NULL,'Edat, raw','2MASX J03194782+4135472',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.00008,NULL,'15.5',0.4,'E:',NULL,NULL,NULL,NULL,1,49.949167,41.59633,0.697,NULL,68566096737,1071345261,16739769,15.5),(30108,'D-Sigma','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30108,34.43,0.4,77,8176,75,NULL,'Edat, cor','2MASX J03194782+4135472',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30109,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30109,34.51,0.25,79.8,8176,74.4,NULL,NULL,'2MASX J03194782+4135472',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30110,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2005mz',NULL,30110,33.98,0.1,62.5,8177,74.4,NULL,NULL,'NGC 1275',NULL,'2013AJ....146...86T',2013,1,2.2,NULL,'G',0.000037,NULL,'11.8B',1.7,'cD;pec;NLRG;Sy2;LEG','Group member, radial-velocity confirmed',NULL,'FR I','Flat-Spectrum Radio Source',1,49.950667,41.51169,0.697,NULL,68565969410,1071343272,16739738,11.8),(30111,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2005mz',NULL,30111,34.08,0.22,64.2,8177,65,NULL,'MLCS31','NGC 1275',0.017559,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30112,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2005mz',NULL,30112,34.3,0.2,71.1,8177,65,NULL,'MLCS17','NGC 1275',0.017559,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30113,'SNIa','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SN 2005mz',NULL,30113,34.63,0.22,82.8,8177,65,NULL,'SALT','NGC 1275',0.017559,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30114,'D-Sigma','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30114,33.97,0.09,62.4,8177,72,NULL,'NGC 1275 = Perseus Cluster, 26 galaxies','NGC 1275',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30115,'Diameter','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30115,34.56,NULL,81.7,8177,NULL,NULL,NULL,'NGC 1275',NULL,'1991ApJ...382....1G',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30116,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30116,34.19,0.08,69,8177,75,NULL,'NGC 1275 = Perseus Cluster, 31 galaxies','NGC 1275',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30117,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30117,34.19,0.08,69,8177,75,NULL,'NGC 1275 = Perseus Cluster, 31 galaxies','NGC 1275',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30118,'Magnitude','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30118,34.34,NULL,73.8,8177,NULL,NULL,'NGC 1275 = Perseus Cluster','NGC 1275',NULL,'1995A&A...302...21G',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30119,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30119,33.66,0.45,53.9,8177,NULL,NULL,'K','NGC 1275',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30120,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30120,34.19,0.4,68.9,8177,NULL,NULL,'mean','NGC 1275',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30121,'Tully est','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30121,31.51,0.8,20,8178,75,NULL,'B','NGC 1302',NULL,'1988NBGC.C....0000T',1988,1,3.9,'Confused HIPASS source','G',0.00001,NULL,'11.69',3.7,'(R\')SAB(rl)a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,49.96325,-26.06044,0,NULL,38551065014,602360390,9411881,11.69),(30122,'Faber-Jackson','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30122,33.46,0.44,49.2,8179,95,NULL,'Weighted Mean','NGC 1277',NULL,'1984ApJS...56...91D',1984,1,1,NULL,'G',0.000093,NULL,'14.66',0.4,'S0+: pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,49.9645417,41.57353,0.697,NULL,68566096306,1071345254,16739769,14.66),(30123,'Faber-Jackson','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30123,33.89,0.46,60,8179,95,NULL,'Michard 1979a','NGC 1277',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30124,'Faber-Jackson','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30124,34.05,0.63,64.6,8179,95,NULL,'Michard 1979b, c','NGC 1277',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30125,'Tertiary','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30125,33.65,0.5,53.7,8179,95,NULL,NULL,'NGC 1277',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30126,'BL Lac Luminosity','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30126,40.12,NULL,888,8180,NULL,NULL,NULL,'[HB89] 0317+185',0.19,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.003,NULL,'18.12',NULL,'Opt.var.       BLLAC',NULL,NULL,NULL,NULL,1,49.965833,18.75956,0.449,NULL,68031636699,1062994323,16609286,18.12),(30127,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 15135','RN',30127,40.37,0.3,1140,8181,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15135',0.040477,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30128,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',30128,33.12,0.49,42.1,8182,75,NULL,'IR','FGC 0410',NULL,'2011yCatp016004901K',2011,1,2.02,NULL,'G',0.000023,NULL,'16.39',0.21,'Sd',NULL,NULL,NULL,NULL,1,49.974375,-3.59389,0.101,NULL,36836584478,575571632,8993306,16.39),(30129,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30129,33.44,NULL,48.7,8182,NULL,NULL,'Dipole + Quadrupole','FGC 0410',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30130,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30130,33.44,NULL,48.8,8182,NULL,NULL,'Dipole','FGC 0410',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30131,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30131,33.44,NULL,48.8,8182,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0410',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30132,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30132,33.46,NULL,49.3,8182,NULL,NULL,NULL,'FGC 0410',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30133,'D-Sigma','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30133,34.41,0.4,76.3,8183,75,NULL,'Edat, raw','NGC 1278',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000028,NULL,'13.57',1.3,'E pec:','in a pair',NULL,NULL,NULL,1,49.975625,41.56339,0.697,NULL,68565968617,1071343259,16739738,13.57),(30134,'D-Sigma','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30134,34.43,0.4,77,8183,75,NULL,'Edat, cor','NGC 1278',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30135,'Faber-Jackson','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30135,32.94,0.64,38.7,8183,95,NULL,'de Vaucouleurs','NGC 1278',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30136,'Faber-Jackson','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30136,33.18,0.36,43.3,8183,95,NULL,'Weighted Mean','NGC 1278',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30137,'Faber-Jackson','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30137,33.71,0.46,55.2,8183,95,NULL,'Michard 1979a','NGC 1278',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30138,'Faber-Jackson','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30138,33.87,0.63,59.4,8183,95,NULL,'Michard 1979b, c','NGC 1278',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30139,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30139,34.13,0.23,67,8183,74.4,NULL,NULL,'NGC 1278',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30140,'Tertiary','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30140,33.65,0.5,53.7,8183,95,NULL,NULL,'NGC 1278',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30141,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30141,34.52,0.45,80,8183,NULL,NULL,'K','NGC 1278',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30142,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30142,34.6,0.4,83.2,8183,NULL,NULL,'mean','NGC 1278',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30143,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30143,35.13,0.08,106,8184,NULL,NULL,NULL,'UGC 02677',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.00018,NULL,'14.96',0.4,'Sab',NULL,NULL,NULL,NULL,1,49.988333,3.59017,0.261,NULL,65017110411,1015892350,15873317,14.96),(30144,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30144,35.43,0.2,122,8184,74.4,NULL,NULL,'UGC 02677',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30145,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30145,34.32,0.25,73.1,8185,74.4,NULL,NULL,'V Zw 339',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',NULL,NULL,'16.3',NULL,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,50.003625,41.55375,0.697,NULL,68565970467,1071343288,16739738,16.3),(30146,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30146,34.23,0.23,70.2,8186,74.4,NULL,NULL,'UGC 02673',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.00016,NULL,'14.6',1.4,'S0:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,50.006875,41.25117,0.685,NULL,68565940074,1071342813,16739731,14.6),(30147,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30147,33.91,0.4,60.4,8186,NULL,NULL,'mean','UGC 02673',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30148,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30148,34.24,0.45,70.6,8186,NULL,NULL,'K','UGC 02673',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30149,'SNIa SDSS','2016-12-15 15:13:58','2016-12-16 11:19:02','1','SDSS-II SN 15615','RN',30149,39.42,0.72,727,8187,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15615',0.053764,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30150,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30150,35.61,0.59,132,8188,70,NULL,NULL,'2MASX J03200305-2021244',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'15.88',0.4,'S0',NULL,NULL,NULL,NULL,1,50.0127083,-20.35686,0.013,NULL,38029067327,594204176,9284440,15.88),(30151,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30151,34.64,0.8,84.8,8189,75,NULL,'CF, r','UGC 02679',NULL,'1997ApJS..109..333W',1997,1,2,'Marginal HIPASS detection.','G',0.00002,NULL,'14.91',0.5,'(R\')SB(rs)b:',NULL,NULL,NULL,NULL,1,50.015875,1.36153,0.269,NULL,64969294667,1015145229,15861644,14.91),(30152,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30152,34.83,0.38,92.4,8189,75,NULL,'CF, r, raw','UGC 02679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30153,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30153,34.84,0.11,93.1,8189,NULL,NULL,NULL,'UGC 02679',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30154,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30154,34.87,0.4,94.2,8189,NULL,NULL,'mean','UGC 02679',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30155,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30155,34.88,0.2,94.6,8189,74.4,NULL,NULL,'UGC 02679',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30156,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',30156,34.99,0.49,99.5,8189,75,NULL,'IR','UGC 02679',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30157,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30157,35.01,0.38,100,8189,75,NULL,'CF, r, inv','UGC 02679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30158,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30158,35.03,0.38,101,8189,75,NULL,'CF, r, cor','UGC 02679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30159,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30159,35.19,0.47,109,8189,NULL,NULL,'H','UGC 02679',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30160,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30160,36.71,0.6,220,8190,70,NULL,NULL,'2MASX J03200546-4913487',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.000103,NULL,'16.81',0.35,NULL,NULL,NULL,NULL,NULL,1,50.0226666667,-49.23019,0,NULL,38458097837,600907778,9389184,16.81),(30161,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30161,34.85,0.23,93.3,8191,74.4,NULL,NULL,'NGC 1281',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.00004,NULL,'14.5',0.7,'E5','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,50.0254583,41.63003,0.697,NULL,68566095602,1071345243,16739769,14.5),(30162,'Brightest Stars','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,'R',30162,28.31,NULL,4.6,8192,NULL,NULL,NULL,'NGC 1311',NULL,'2006AAS...208.1404E',2006,1,3,NULL,'G',0.000007,NULL,'13.1B',0.8,'SB(s)m','X-ray-faint group member',NULL,NULL,NULL,1,50.029,-52.18553,0,NULL,37729328746,589520761,9211261,13.1),(30163,'TRGB','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30163,28.59,0.09,5.22,8192,74.4,NULL,NULL,'NGC 1311',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30164,'TRGB','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30164,28.66,0.1,5.4,8192,NULL,NULL,NULL,'NGC 1311',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30165,'TRGB','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30165,28.68,0.03,5.45,8192,NULL,NULL,NULL,'NGC 1311',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30166,'TRGB','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30166,28.73,0.02,5.57,8192,NULL,NULL,'I','NGC 1311',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30167,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30167,29.08,0.8,6.53,8192,75,NULL,'MAT, I','NGC 1311',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30168,'Tully est','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30168,28.58,0.8,5.2,8192,75,NULL,NULL,'NGC 1311',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30169,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30169,27.53,0.32,3.19,8192,85,NULL,'I, inv','NGC 1311',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30170,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30170,27.66,0.32,3.36,8192,85,NULL,'I, raw','NGC 1311',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30171,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30171,28.08,0.43,4.13,8192,75,NULL,'MAT, I, inv','NGC 1311',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30172,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30172,28.38,0.43,4.75,8192,75,NULL,'MAT, I, raw','NGC 1311',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30173,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30173,28.59,0.09,5.22,8192,74.4,NULL,NULL,'NGC 1311',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30174,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30174,28.68,0.43,5.45,8192,75,NULL,'MAT, I, cor','NGC 1311',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30175,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30175,31.67,0.69,21.6,8193,100,NULL,'mid-IR','NGC 1299',NULL,'2013ApJ...771...88L',2013,1,1.1,NULL,'G',0.000007,NULL,'13.37',0.6,'SB(rs)b?',NULL,NULL,NULL,NULL,1,50.040333,-6.262,0.129,NULL,36801682834,575026294,8984785,13.37),(30176,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30176,31.9,0.43,24,8193,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1299',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30177,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30177,32.06,0.43,25.8,8193,75,NULL,'3.6 micron, color corrected','NGC 1299',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30178,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30178,32.21,0.2,27.7,8193,74.4,NULL,NULL,'NGC 1299',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30179,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30179,35.42,0.52,121,8194,70,NULL,NULL,'2MASX J03200968-7924362',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,50.040833,-79.41014,0.297,NULL,35700646970,557822608,8715978,16.9),(30180,'D-Sigma','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30180,34.41,0.4,76.3,8195,75,NULL,'Edat, raw','NGC 1282',NULL,'1997ApJS..109..333W',1997,1,1.4,'The UZC has V = 7115 +- 27 km/sec.','G',0.000017,NULL,'13.87',1.1,'E:','Group member',NULL,NULL,NULL,1,50.0505,41.367,0.685,NULL,68565988161,1071343565,16739743,13.87),(30181,'D-Sigma','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30181,34.43,0.4,77,8195,75,NULL,'Edat, cor','NGC 1282',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30182,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30182,33.6,0.25,52.5,8195,74.4,NULL,NULL,'NGC 1282',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30183,'Tully est','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30183,32.44,0.8,30.7,8195,75,NULL,'B','NGC 1282',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30184,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30184,33.13,0.4,42.2,8195,NULL,NULL,'mean','NGC 1282',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30185,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30185,34.41,0.45,76.1,8195,NULL,NULL,'K','NGC 1282',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30186,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30186,34.68,0.45,86.2,8196,NULL,NULL,'K','NGC 1298',NULL,'2007A&A...465...71T',2007,1,1.6,'UGC misprints name as \'MCG +00-08-062\'.','G',0.00001,NULL,'14.95',1.3,'E+ pec:','Group member',NULL,NULL,NULL,1,50.0545,-2.11411,0.189,NULL,36786547985,574789812,8981090,14.95),(30187,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30187,34.85,0.4,93.3,8196,NULL,NULL,'mean','NGC 1298',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30188,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30188,35.68,0.52,137,8197,70,NULL,NULL,'MCG -02-09-031',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000137,NULL,'15.72',0.4,'S?','Compact group member',NULL,NULL,NULL,1,50.063167,-10.86308,0.173,NULL,37896871037,592138609,9252165,15.72),(30189,'D-Sigma','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30189,34.41,0.4,76.3,8198,75,NULL,'Edat, raw','NGC 1283',NULL,'1997ApJS..109..333W',1997,1,0.7,NULL,'G',0.000183,NULL,'14.73',0.6,'E1:','Group member',NULL,NULL,NULL,1,50.0646666667,41.39867,0.685,NULL,68565990725,1071343605,16739743,14.73),(30190,'D-Sigma','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30190,34.43,0.4,77,8198,75,NULL,'Edat, cor','NGC 1283',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30191,'FP','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30191,34.42,0.23,76.6,8198,74.4,NULL,NULL,'NGC 1283',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30192,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30192,32.67,0.4,34.2,8199,75,NULL,'B','UGC 02620',NULL,'1988NBGC.C....0000T',1988,1,0.8,NULL,'G',0.000033,NULL,'15.30',0.8,'Sm:',NULL,NULL,NULL,NULL,1,50.07175,80.24631,0.821,NULL,65753030733,1027391105,16052986,15.3),(30193,'IRAS','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30193,31.91,0.8,24.1,8200,75,NULL,'MAT, I','ESO 481- G 021',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'15.57',0.3,'SBd? sp',NULL,NULL,NULL,NULL,1,50.073667,-26.46456,0,NULL,38551783238,602371613,9412056,15.57),(30194,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30194,31.02,0.32,16,8200,85,NULL,'I, inv','ESO 481- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30195,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30195,31.09,0.32,16.5,8200,85,NULL,'I, raw','ESO 481- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30196,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30196,31.4,0.43,19.1,8200,75,NULL,'MAT, I, inv','ESO 481- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30197,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30197,31.58,0.43,20.7,8200,75,NULL,'3.6 micron, color + selection bias corrected','ESO 481- G 021',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30198,'Tully-Fisher','2016-12-15 15:13:58','2016-12-16 11:19:02','1',NULL,NULL,30198,31.6,0.43,20.9,8200,75,NULL,'MAT, I, raw','ESO 481- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30199,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30199,31.76,0.43,22.5,8200,75,NULL,'MAT, I, cor','ESO 481- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30200,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30200,31.77,0.43,22.6,8200,75,NULL,'3.6 micron, color corrected','ESO 481- G 021',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30201,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30201,31.87,0.2,23.7,8200,74.4,NULL,NULL,'ESO 481- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30202,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 2005fy',NULL,30202,39.24,0.13,587,8201,74.2,NULL,'SALT 2','SDSS J032021.71-005305.2',0.2,'2010ApJ...716..712A',2010,1,0.13,NULL,'G',NULL,NULL,'19.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,50.0904583333,-0.88481,0.185,NULL,36784774016,574762094,8980657,19.5),(30203,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 2005fy',NULL,30203,39.88,0.14,787,8201,70,NULL,'SALT 2','SDSS J032021.71-005305.2',0.2,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30204,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 02246','R',30204,39.94,0.2,812,8201,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fy','SDSS J032021.71-005305.2',0.2,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30205,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 2005fy',NULL,30205,39.96,0.11,817,8201,65,NULL,'MLCS2k2','SDSS J032021.71-005305.2',0.2,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30206,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 2005fy',NULL,30206,39.96,0.1,820,8201,65,NULL,'SALT2','SDSS J032021.71-005305.2',0.2,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30207,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 02246','R',30207,40,0.12,834,8201,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fy','SDSS J032021.71-005305.2',0.2,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30208,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 04054',NULL,30208,40.55,0.15,1290,8202,70,NULL,'SN photometric redshift distance, z photo =0.363 +/- 0.032','SDSS-II SN 04054',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','22.7g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,50.094333,0.19536,0.229,NULL,64965742891,1015089732,15860777,22.7),(30209,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 04773','RN',30209,42.62,0.2,2510,8203,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04773',0.333176,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30210,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 04773','RN',30210,42.91,0.24,2860,8203,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04773',0.333176,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30211,'Brightest Stars','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30211,29.06,NULL,6.49,8204,NULL,NULL,NULL,'UGC 02684',NULL,'1999AstL...25..322S',1999,1,1.8,NULL,'G',0.000017,NULL,'18.',0.9,'Im?','Field galaxy',NULL,NULL,NULL,1,50.0987916667,17.29586,0.393,NULL,68153998709,1064906229,16639159,18),(30212,'Tully est','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30212,28.71,0.8,5.5,8204,75,NULL,NULL,'UGC 02684',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30213,'D-Sigma','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30213,34.41,0.4,76.3,8205,75,NULL,'Edat, raw','2MASX J03202856+4129195',NULL,'1997ApJS..109..333W',1997,1,NULL,NULL,'G',0.000019,NULL,'14.55',NULL,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,50.119167,41.48881,0.765,NULL,68565977583,1071343399,16739740,14.55),(30214,'D-Sigma','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30214,34.43,0.4,77,8205,75,NULL,'Edat, cor','2MASX J03202856+4129195',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30215,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30215,34.22,0.25,69.8,8205,74.4,NULL,NULL,'2MASX J03202856+4129195',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30216,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30216,36.6,0.64,209,8206,70,NULL,NULL,'2MASX J03203203-2409465',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'15.1R',0.26,NULL,NULL,NULL,NULL,NULL,1,50.1335416667,-24.16286,0,NULL,38032256465,594254007,9285218,15.1),(30217,'D-Sigma','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30217,34.41,0.4,76.3,8207,75,NULL,'Edat, raw','PER 164',NULL,'1997ApJS..109..333W',1997,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,50.1362916667,41.50772,0.765,NULL,68565950010,1071342968,16739733,NULL),(30218,'D-Sigma','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30218,34.43,0.4,77,8207,75,NULL,'Edat, cor','PER 164',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30219,'IRAS','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30219,33.51,0.8,50.3,8208,75,NULL,'MAT, I','NGC 1301',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000017,NULL,'13.87',0.4,'SB(rs)b?       HII',NULL,NULL,NULL,NULL,1,50.1472083333,-18.71533,0.097,NULL,38004687463,593823241,9278488,13.87),(30220,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30220,33.3,0.49,45.7,8208,75,NULL,'IR','NGC 1301',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30221,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30221,33.46,0.43,49.1,8208,75,NULL,'MAT, I, raw','NGC 1301',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30222,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30222,33.49,0.32,50,8208,85,NULL,'I, raw','NGC 1301',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30223,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30223,33.49,0.46,50,8208,NULL,NULL,'J','NGC 1301',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30224,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30224,33.5,0.47,50.1,8208,NULL,NULL,'H','NGC 1301',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30225,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30225,33.54,0.32,51.1,8208,85,NULL,'I, inv','NGC 1301',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30226,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30226,33.56,0.4,51.6,8208,NULL,NULL,'mean','NGC 1301',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30227,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30227,33.58,0.2,52,8208,74.4,NULL,NULL,'NGC 1301',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30228,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30228,33.62,0.45,53,8208,NULL,NULL,'K','NGC 1301',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30229,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30229,33.67,0.43,54.3,8208,75,NULL,'MAT, I, inv','NGC 1301',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30230,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30230,33.73,0.43,55.8,8208,75,NULL,'MAT, I, cor','NGC 1301',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30231,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30231,33.77,0.35,56.9,8208,NULL,NULL,NULL,'NGC 1301',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30232,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30232,33.87,0.33,59.5,8208,NULL,NULL,'Malmquist cor.','NGC 1301',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30233,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 21457',NULL,30233,40.32,0.19,1160,8209,70,NULL,'SN photometric redshift distance, z photo =0.320 +/- 0.036','SDSS-II SN 21457',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.2g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,50.150583,0.53167,0.229,NULL,64966562480,1015102538,15860977,21.2),(30234,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 08092',NULL,30234,40.04,0.33,1020,8210,70,NULL,'SN photometric redshift distance, z photo =0.275 +/- 0.055','SDSS-II SN 08092',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,50.151167,0.09386,0.229,NULL,64965764207,1015090065,15860782,NULL),(30235,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 19359',NULL,30235,40.4,0.15,1200,8211,70,NULL,'SN photometric redshift distance, z photo =0.335 +/- 0.029','SDSS-II SN 19359',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.9g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,50.15675,0.34294,0.229,NULL,64966446365,1015100724,15860948,21.9),(30236,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30236,34.5,0.46,79.4,8212,70,NULL,NULL,'2MASX J03203860-1425183',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'15.02',NULL,NULL,NULL,NULL,NULL,NULL,1,50.160875,-14.42178,0.121,NULL,38083388715,595052948,9297702,15.02),(30237,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30237,35.05,0.67,102,8213,70,NULL,NULL,'ESO 481- G 022',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00011,NULL,'15.22',0.8,'S?',NULL,NULL,NULL,NULL,1,50.1680416667,-22.93142,0,NULL,38033232999,594269265,9285457,15.22),(30238,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30238,33.72,0.46,55.4,8214,70,NULL,NULL,'NGC 1303',NULL,'2015arXiv151105856S',2015,1,1.07,NULL,'G',0.00008,NULL,'14.2g',0.81,'(R\')S0o:',NULL,NULL,NULL,NULL,1,50.1699583,-7.39442,0.137,NULL,37887705044,591995391,9249927,14.2),(30239,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30239,36.93,0.56,243,8215,70,NULL,NULL,'2MASX J03204204-2331512',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'17.29',0.19,NULL,NULL,NULL,NULL,NULL,1,50.175125,-23.53086,0,NULL,38033309814,594270465,9285476,17.29),(30240,'IRAS','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30240,34.53,0.8,80.5,8216,75,NULL,'CF, r','UGC 02690',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.0001,NULL,'14.56',0.6,'SAc pec:','Group member',NULL,NULL,NULL,1,50.1789166667,-1.10858,0.145,NULL,36784787761,574762308,8980661,14.56),(30241,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30241,33.95,0.38,61.5,8216,75,NULL,'CF, r, raw','UGC 02690',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30242,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30242,34.02,0.38,63.6,8216,75,NULL,'CF, r, inv','UGC 02690',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30243,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30243,34.31,0.38,72.7,8216,75,NULL,'CF, r, cor','UGC 02690',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30244,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30244,34.79,0.35,90.6,8216,NULL,NULL,NULL,'UGC 02690',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30245,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30245,34.83,0.2,92.5,8216,74.4,NULL,NULL,'UGC 02690',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30246,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30246,34.88,0.33,94.5,8216,NULL,NULL,'Malmquist cor.','UGC 02690',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30247,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 09266','RN',30247,36.01,0.09,154,8217,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 09266',0.036107,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30248,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 09266','RN',30248,37.04,0.21,247,8217,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 09266',0.036107,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30249,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 09965','RN',30249,38.9,0.14,590,8218,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 09965',0.021398,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30250,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 16091','R',30250,40.95,0.21,1190,8219,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16091',0.3006,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,50.1900417,0.84181,0.249,NULL,64966014023,1015093969,15860843,NULL),(30251,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 16091','R',30251,41.06,0.12,1250,8219,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16091',0.3006,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30252,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30252,33.98,0.23,62.5,8220,74.4,NULL,NULL,'2MASX J03204928+4122145',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000173,NULL,'15.6:',NULL,'E:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,50.205417,41.37069,0.765,NULL,68565983729,1071343495,16739742,15.6),(30253,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 14591',NULL,30253,40.78,0.81,1440,8221,70,NULL,'SN photometric redshift distance, z photo =0.417 +/- 0.283','SDSS-II SN 14591',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',0.000334,NULL,'23.4g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,50.217625,-0.83036,0.185,NULL,36784668665,574760447,8980631,23.4),(30254,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30254,32.98,0.69,39.5,8222,100,NULL,'mid-IR','UGC 02685',NULL,'2013ApJ...771...88L',2013,1,1.7,NULL,'G',0.000017,NULL,'14.3',1.2,'SAB(s)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,50.2202083,38.25342,0.821,NULL,68702102271,1073470347,16772974,14.3),(30255,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30255,33.24,0.47,44.4,8222,NULL,NULL,'H','UGC 02685',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30256,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30256,33.37,0.45,47.3,8222,NULL,NULL,'K','UGC 02685',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30257,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30257,33.46,0.46,49.1,8222,NULL,NULL,'J','UGC 02685',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30258,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30258,34.11,0.4,66.4,8222,NULL,NULL,'mean','UGC 02685',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30259,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 08165','R',30259,41.87,0.23,1800,8223,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 08165',0.319,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,50.2252917,-1.10939,0.149,NULL,36784808495,574762632,8980666,NULL),(30260,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 08165','R',30260,42.11,0.4,2000,8223,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 08165',0.319,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30261,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 07318','RN',30261,43.54,0.25,3380,8224,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07318',0.508713,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30262,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 19381','R',30262,40.18,0.2,900,8225,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007nk','SN 2007nk',0.21,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,50.2355,1.05814,0.277,NULL,64966062116,1015094720,15860855,NULL),(30263,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 19381','R',30263,40.38,0.1,984,8225,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007nk','SN 2007nk',0.21,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30264,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30264,34.48,0.23,78.7,8226,74.4,NULL,NULL,'IC 0313',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000037,NULL,'15.1',0.8,'E+:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,50.24125,41.89383,0.697,NULL,68566014137,1071343970,16739749,15.1),(30265,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30265,33.97,0.4,62.4,8226,NULL,NULL,'mean','IC 0313',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30266,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30266,34.92,0.45,96.3,8226,NULL,NULL,'K','IC 0313',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30267,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30267,36.83,0.46,233,8227,70,NULL,NULL,'2MASX J03205994-0817579',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000089,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,50.2497083,-8.2995,0.153,NULL,37889624144,592025377,9250396,17.4),(30268,'TRGB','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30268,28,NULL,3.98,8228,NULL,NULL,NULL,'AM 0319-662',NULL,'2003A&A...398..479K',2003,1,1.2,NULL,'G',NULL,NULL,'16.5B',0.4,'dwarf Irr',NULL,NULL,NULL,NULL,1,50.26,-66.31917,0.065,NULL,36469488274,569835754,8903683,16.5),(30269,'TRGB','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30269,28.09,0.07,4.15,8228,NULL,NULL,NULL,'AM 0319-662',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30270,'TRGB','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30270,28.13,0.1,4.23,8228,74.4,NULL,NULL,'AM 0319-662',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30271,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30271,31.79,0.4,22.8,8229,NULL,NULL,'mean','NGC 1306',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.00002,NULL,'13.60',0.9,'Sb?            HII',NULL,NULL,NULL,NULL,1,50.2624583,-25.51256,0,NULL,38546953559,602296149,9410877,13.6),(30272,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30272,32.58,0.45,32.9,8229,NULL,NULL,'K','NGC 1306',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30273,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30273,32.6,0.47,33.1,8229,NULL,NULL,'H','NGC 1306',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30274,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30274,32.62,0.46,33.4,8229,NULL,NULL,'J','NGC 1306',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30275,'IRAS','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30275,32.03,0.8,25.5,8230,75,NULL,'MAT, I','NGC 1310',NULL,'1997ApJS..109..333W',1997,1,2,'FCC position is incorrect.','G',0.000033,NULL,'12.55',1.5,'SB(rs)cd       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,50.2642917,-37.10169,0,NULL,38603694931,603182733,9424730,12.55),(30276,'Tully est','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30276,31.14,0.8,16.9,8230,75,NULL,NULL,'NGC 1310',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30277,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30277,31.32,0.43,18.4,8230,75,NULL,'MAT, I, raw','NGC 1310',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30278,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30278,31.34,0.43,18.6,8230,75,NULL,'MAT, I, inv','NGC 1310',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30279,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30279,31.37,0.06,18.8,8230,NULL,NULL,NULL,'NGC 1310',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30280,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30280,31.41,0.32,19.1,8230,85,NULL,'I, raw','NGC 1310',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30281,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30281,31.41,0.32,19.1,8230,85,NULL,'I, inv','NGC 1310',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30282,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30282,31.52,0.43,20.1,8230,75,NULL,'MAT, I, cor','NGC 1310',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30283,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30283,31.88,0.4,23.8,8230,NULL,NULL,'mean','NGC 1310',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30284,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30284,32.04,0.45,25.6,8230,NULL,NULL,'K','NGC 1310',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30285,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30285,32.06,0.47,25.8,8230,NULL,NULL,'H','NGC 1310',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30286,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30286,32.08,0.46,26.1,8230,NULL,NULL,'J','NGC 1310',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30287,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 14756',NULL,30287,39.75,0.51,891,8231,70,NULL,'SN photometric redshift distance, z photo =0.235 +/- 0.074','SDSS-II SN 14756',NULL,'2011ApJ...738..162S',2011,1,0.1,NULL,'G',NULL,'PHOT','22.4g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,50.269375,0.81622,0.257,NULL,64966006493,1015093851,15860841,22.4),(30288,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30288,37.55,0.46,324,8232,70,NULL,NULL,'SDSS J032107.68-080220.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000058,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,50.2820416667,-8.03892,0.209,NULL,37889739700,592027182,9250424,18.4),(30289,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30289,37.25,0.33,282,8233,70,NULL,NULL,'2MASX J03210936-0012513',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000111,NULL,'17.1g',0.23,'BLAGN',NULL,NULL,NULL,'Sy 1',1,50.2890833333,-0.21442,0.193,NULL,36784299444,574754678,8980541,17.1),(30290,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 08603','RN',30290,42.19,0.38,2110,8234,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 08603',0.297348,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30291,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 08603','RN',30291,42.77,0.31,2750,8234,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 08603',0.297348,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30292,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30292,33.89,0.5,59.8,8235,70,NULL,NULL,'NGC 1304',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000077,NULL,'14.40',0.8,'S0- pec',NULL,NULL,NULL,NULL,1,50.30325,-4.58408,0.085,NULL,36836804722,575575073,8993360,14.4),(30293,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30293,37.25,0.33,282,8236,70,NULL,NULL,'2MASX J03211323-0006513',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000071,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,50.305125,-0.11431,0.205,NULL,36784290984,574754546,8980539,17.7),(30294,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30294,36.05,NULL,162,8237,NULL,NULL,NULL,'UGC 02695',NULL,'2000BSAO...50....5K',2000,1,1.37,NULL,'G',0.000068,NULL,'16.5',0.12,'Scd',NULL,NULL,NULL,NULL,1,50.306625,7.44344,0.705,NULL,64999677996,1015619968,15869062,16.5),(30295,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30295,36.08,0.49,164,8237,75,NULL,'IR','UGC 02695',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30296,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30296,36.16,NULL,171,8237,NULL,NULL,'Dipole + Quadrupole','UGC 02695',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30297,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30297,36.17,NULL,171,8237,NULL,NULL,'Dipole','UGC 02695',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30298,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30298,36.17,NULL,171,8237,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02695',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30299,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30299,35.14,0.54,107,8238,70,NULL,NULL,'ESO 248- G 011',NULL,'2014MNRAS.445.2677S',2014,1,0.39,'This is not the SGC galaxy; that is ESO 248- G 012.','G',0.000103,NULL,'16.71',0.38,'Compact','Pair member (points to parent)',NULL,NULL,NULL,1,50.3501666667,-43.60175,0,NULL,38483220183,601300315,9395317,16.71),(30300,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30300,37.9,0.46,381,8239,70,NULL,NULL,'2MASX J03212560-0818520',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000081,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,50.3567083,-8.31439,0.217,NULL,37889595559,592024930,9250389,17.6),(30301,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30301,36.06,0.52,163,8240,70,NULL,NULL,'MCG -03-09-025',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.2b',0.2,NULL,NULL,NULL,NULL,NULL,1,50.3977083,-16.72219,0.113,NULL,38077678545,594963727,9296308,15.2),(30302,'D-Sigma','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30302,34.41,0.4,76.3,8241,75,NULL,'Edat, raw','NGC 1293',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000019,NULL,'14.50',1,'E0','in a pair',NULL,NULL,NULL,1,50.401917,41.39283,0.833,NULL,68566236624,1071347447,16739803,14.5),(30303,'D-Sigma','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30303,34.43,0.4,77,8241,75,NULL,'Edat, cor','NGC 1293',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30304,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30304,34.09,0.23,65.8,8241,74.4,NULL,NULL,'NGC 1293',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30305,'GRB','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30305,35.97,0.22,151,8242,NULL,NULL,'SN 2006aj','HG 060218',0.0331,'2010JCAP...08..020W',2010,1,NULL,NULL,'G',0.0007,NULL,'20.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,50.4154583,16.86739,0.461,NULL,68156693062,1064948329,16639817,20.1),(30306,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30306,36.22,0.51,175,8243,70,NULL,NULL,'2MASX J03214892-3637074',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'16.89',0.22,NULL,NULL,NULL,NULL,NULL,1,50.4538333333,-36.61872,0,NULL,38603598045,603181219,9424706,16.89),(30307,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30307,32.21,0.43,27.7,8244,75,NULL,'3.6 micron, color + selection bias corrected','MCG -03-09-027',NULL,'2014MNRAS.444..527S',2014,1,1.6,'Confused HIPASS source','G',0.000022,NULL,'15.3b',1,'SB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,50.4655,-15.71033,0.073,NULL,38077341950,594958467,9296226,15.3),(30308,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30308,37.8,0.55,363,8245,70,NULL,NULL,'2MASX J03215810-2303234',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.89',0.29,NULL,NULL,NULL,NULL,NULL,1,50.4920417,-23.05656,0.009,NULL,38030427914,594225436,9284772,16.89),(30309,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 21355','RN',30309,43.31,0.39,3270,8246,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 21355',0.408006,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30310,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 21355','RN',30310,44.17,0.39,4850,8246,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 21355',0.408006,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30311,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30311,36.08,0.58,165,8247,70,NULL,NULL,'2MASX J03220241-0728267',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.70',0.28,NULL,NULL,NULL,NULL,NULL,1,50.510167,-7.47414,0.193,NULL,36804547484,575071054,8985485,16.7),(30312,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 20787','R',30312,40.18,0.21,856,8248,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20787',0.270473,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,50.510875,-0.44244,0.225,NULL,36784196176,574753065,8980516,NULL),(30313,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 20787','R',30313,40.29,0.28,900,8248,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20787',0.270473,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30314,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30314,35.2,0.23,110,8249,74.4,NULL,NULL,'UGC 02698',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000047,NULL,'13.9',0.9,'E',NULL,NULL,NULL,NULL,1,50.512,40.86389,0.741,NULL,68565488006,1071335750,16739621,13.9),(30315,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30315,34.78,0.4,90.4,8249,NULL,NULL,'mean','UGC 02698',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30316,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30316,35.62,0.45,133,8249,NULL,NULL,'K','UGC 02698',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30317,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30317,34.16,0.49,67.9,8250,75,NULL,'IR','UGC 02696',NULL,'2011yCatp016004901K',2011,1,1.15,NULL,'G',0.000314,NULL,'15.5',0.11,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,50.521375,42.17203,0.789,NULL,68568086207,1071376346,16740255,15.5),(30318,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30318,35.09,NULL,104,8250,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02696',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30319,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30319,35.12,NULL,105,8250,NULL,NULL,'Dipole + Quadrupole','UGC 02696',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30320,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30320,35.13,NULL,106,8250,NULL,NULL,NULL,'UGC 02696',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30321,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30321,35.14,NULL,107,8250,NULL,NULL,'Dipole','UGC 02696',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30322,'Cepheids','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30322,32.4,0.06,30.2,8251,NULL,NULL,'V, I, NIR (W), 30, Syst. +/- 0.38 mag','NGC 1309',NULL,'2013MNRAS.434.2866F',2013,1,2.2,'Confused HIPASS source','G',0.000013,NULL,'11.7B',2,'SA(s)bc:       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,50.5273333333,-15.40006,0.069,NULL,38081995870,595031185,9297362,11.7),(30323,'Cepheids','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30323,32.47,0.07,31.2,8251,74.4,NULL,NULL,'NGC 1309',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30324,'Cepheids','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30324,32.55,0.09,32.3,8251,NULL,NULL,NULL,'NGC 1309',NULL,'2009ApJ...699..539R',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30325,'Cepheids','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30325,32.59,0.09,33,8251,NULL,NULL,'SNIa calibrated','NGC 1309',NULL,'2011ApJ...730..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30326,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 2002fk',NULL,30326,31.82,0.36,23,8251,74.2,NULL,'SALT 2','NGC 1309',0.007125,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30327,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 2002fk',NULL,30327,32.44,0.02,30.8,8251,NULL,NULL,'m-M(V)13.38 - -19.06 mag','NGC 1309',NULL,'2009ApJS..183..109R',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30328,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 2002fk',NULL,30328,32.47,0.07,31.2,8251,74.4,NULL,NULL,'NGC 1309',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30329,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 2002fk',NULL,30329,32.59,0.09,33,8251,NULL,NULL,'MLCS2k2, Cepheids calibrated','NGC 1309',NULL,'2011ApJ...730..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30330,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30330,31.98,0.4,24.9,8251,75,NULL,'HOSTS SN 2002fk','NGC 1309',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30331,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30331,32.07,0.4,26,8251,75,NULL,'B','NGC 1309',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30332,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30332,35.37,0.2,119,8252,74.4,NULL,NULL,'2MASX J03221014+1453000',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',NULL,NULL,'13.7I',0.4,NULL,NULL,NULL,NULL,NULL,1,50.54225,14.88339,0.593,NULL,68164758266,1065074347,16641786,13.7),(30333,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30333,35.4,0.42,120,8252,NULL,NULL,NULL,'2MASX J03221014+1453000',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30334,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30334,35.42,0.42,121,8252,NULL,NULL,'Malmquist cor.','2MASX J03221014+1453000',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30335,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30335,36.34,0.54,185,8253,70,NULL,NULL,'2MASX J03221579-2531264',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,50.565833,-25.52406,0,NULL,38546867928,602294811,9410856,14.8),(30336,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30336,32.21,0.47,27.7,8254,NULL,NULL,'H','KUG 0319-072',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000027,NULL,'13.6g',1.03,'SA(r)ab pec:',NULL,NULL,NULL,NULL,1,50.572833,-7.09069,0.145,NULL,36804649159,575072643,8985510,13.6),(30337,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30337,32.33,0.46,29.2,8254,NULL,NULL,'J','KUG 0319-072',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30338,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30338,32.35,0.45,29.5,8254,NULL,NULL,'K','KUG 0319-072',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30339,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30339,32.57,0.4,32.7,8254,NULL,NULL,'mean','KUG 0319-072',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30340,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30340,35.88,0.7,150,8255,70,NULL,NULL,'2MASX J03221814-1718422',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'17.03',0.23,NULL,NULL,NULL,NULL,NULL,1,50.5755417,-17.31164,0.121,NULL,38005120827,593830012,9278593,17.03),(30341,'Magnitude','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30341,36.46,0.13,196,8256,100,NULL,NULL,'ABELL 3122',NULL,'1998A&A...337...31R',1998,1,NULL,'Katgert (1996,A&A,310,8) identifies multiple redshift systems in this cluster.','GClstr',NULL,NULL,NULL,NULL,'I-II   [BM];R  [A]',NULL,NULL,NULL,NULL,1,50.57625,-41.33889,0,NULL,38485775230,601340237,9395941,NULL),(30342,'Magnitude','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30342,36.46,0.13,196,8257,100,NULL,NULL,'SARS 050.12425-41.50667',NULL,'1998A&A...337...31R',1998,1,0.53,'Brighter/northern of a pair; HD 21058 (V=8.5) about 40 arcsec northwest.','G',0.000137,NULL,'16.44',0.3,'E',NULL,NULL,NULL,NULL,1,50.5762917,-41.32792,0,NULL,38485774416,601340225,9395941,16.44),(30343,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30343,31.75,0.46,22.4,8258,NULL,NULL,'TOM(g) = -7.2 mag','ESO 301- G 008',NULL,'2010ApJ...717..603V',2010,1,1.3,NULL,'G',0.00015,NULL,'15.2',0.7,'dS0(8),N       Sbrst',NULL,NULL,NULL,NULL,1,50.5945417,-37.39822,0,NULL,38604260833,603191575,9424868,15.2),(30344,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30344,32.01,0.5,25.2,8258,NULL,NULL,'TOM(z) = -8.53 mag','ESO 301- G 008',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30345,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30345,31.51,0.14,20,8258,74.4,NULL,NULL,'ESO 301- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30346,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30346,31.53,0.07,20.3,8258,NULL,NULL,'HST ACS FCS','ESO 301- G 008',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30347,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30347,36.27,0.6,179,8259,70,NULL,NULL,'2MASX J03222416-1823071',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'16.08',0.32,NULL,NULL,NULL,NULL,NULL,1,50.6007083,-18.38522,0.077,NULL,38005549704,593836714,9278698,16.08),(30348,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30348,35.73,0.49,140,8260,75,NULL,'IR','UGC 02703',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.000023,NULL,'15.28',0.4,'Sb',NULL,NULL,NULL,NULL,1,50.64325,14.91364,0.653,NULL,68164770057,1065074532,16641789,15.28),(30349,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30349,35.77,0.31,143,8260,NULL,NULL,'Malmquist cor.','UGC 02703',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30350,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30350,36.07,0.27,163,8260,NULL,NULL,NULL,'UGC 02703',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30351,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30351,36.11,0.2,167,8260,74.4,NULL,NULL,'UGC 02703',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30352,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30352,34.85,0.49,93.2,8261,75,NULL,'IR','UGC 02701',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.000011,NULL,'16.0',0.15,'Sc',NULL,NULL,NULL,NULL,1,50.6512916667,9.47356,0.705,NULL,67945456739,1061647761,16588246,16),(30353,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30353,35.08,0.4,104,8261,NULL,NULL,'mean','UGC 02701',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30354,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30354,35.12,0.2,106,8261,74.4,NULL,NULL,'UGC 02701',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30355,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30355,35.13,0.47,106,8261,NULL,NULL,'H','UGC 02701',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30356,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30356,35.21,0.45,110,8261,NULL,NULL,'K','UGC 02701',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30357,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30357,35.32,0.46,116,8261,NULL,NULL,'J','UGC 02701',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30358,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30358,35.83,NULL,146,8261,NULL,NULL,'Dipole + Quadrupole','UGC 02701',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30359,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30359,35.83,NULL,147,8261,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02701',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30360,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30360,35.84,NULL,147,8261,NULL,NULL,'Dipole','UGC 02701',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30361,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30361,35.93,NULL,153,8261,NULL,NULL,NULL,'UGC 02701',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30362,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30362,38.26,0.46,449,8262,70,NULL,NULL,'SDSS J032236.79+004940.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000083,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,50.653333,0.82781,0.241,NULL,65021013919,1015953342,15874270,18.3),(30363,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 16436',NULL,30363,40.39,0.14,1200,8263,70,NULL,'SN photometric redshift distance, z photo =0.332 +/- 0.028','SDSS-II SN 16436',NULL,'2011ApJ...738..162S',2011,1,0.03,NULL,'G',NULL,'PHOT','22.8g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,50.656417,-0.6495,0.197,NULL,36830300359,575473443,8991772,22.8),(30364,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 09055','RN',30364,43.5,0.3,3380,8264,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 09055',0.479324,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30365,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30365,36.98,0.56,249,8265,70,NULL,NULL,'2MASX J03223915-3956563',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.80',0.25,NULL,NULL,NULL,NULL,NULL,1,50.663083,-39.94903,0,NULL,38601240629,603144384,9424131,16.8),(30366,'Cepheids','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30366,31.51,0.08,20,8266,NULL,NULL,'Fornax Cluster, HST KP Calibrated, K\'','NGC 1316',NULL,'2000ApJ...529..745F',2000,1,12,NULL,'G',0.000033,NULL,'9.4 B',8.5,'(R\')SAB(s)0^0  LINER','Pair member, radial velocity confirmed',NULL,'radio jet',NULL,1,50.673833,-37.20822,0,NULL,38603762280,603183785,9424746,9.4),(30367,'Cepheids','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30367,31.6,0.04,20.9,8266,NULL,NULL,'Fornax Cluster, HST KP Calibrated ','NGC 1316',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30368,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30368,31.38,0.15,18.9,8266,NULL,NULL,'Fornax Cluster, HST KP Calibrated, V','NGC 1316',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30369,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30369,31.76,0.31,22.5,8266,NULL,NULL,'Fornax Cluster, HST KP Calibrated, B','NGC 1316',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30370,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30370,33.55,1.23,51.3,8266,NULL,NULL,'TOM(g) = -7.2 mag','NGC 1316',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30371,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30371,33.68,0.67,54.5,8266,NULL,NULL,'TOM(z) = -8.53 mag','NGC 1316',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30372,'Novae','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30372,31.3,0.25,18.2,8266,NULL,NULL,'1','NGC 1316',NULL,'2002Sci...296.1275D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30373,'Novae','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30373,31.51,0.24,20,8266,NULL,NULL,'4','NGC 1316',NULL,'2002Sci...296.1275D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30374,'PNLF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30374,31.04,0.09,16.1,8266,NULL,NULL,NULL,'NGC 1316',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30375,'PNLF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30375,31.13,0.06,16.8,8266,NULL,NULL,NULL,'NGC 1316',NULL,'1993ApJ...416...62M',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30376,'PNLF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30376,31.15,0.11,17,8266,NULL,NULL,'HST KP Calibrated','NGC 1316',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30377,'PNLF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30377,31.19,0.07,17.3,8266,NULL,NULL,'I','NGC 1316',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30378,'PNLF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30378,31.2,0.07,17.4,8266,NULL,NULL,'Fornax Cluster, HST KP Calibrated ','NGC 1316',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30379,'PNLF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30379,31.26,0.09,17.9,8266,NULL,NULL,'45 PNe','NGC 1316',NULL,'2007ApJ...657...76F',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30380,'PNLF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30380,31.34,0.15,18.5,8266,NULL,NULL,NULL,'NGC 1316',NULL,'2004AAS...205.6906J',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30381,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 1981D',NULL,30381,31.01,0.23,15.7,8266,65,NULL,'MLCS2k2','NGC 1316',0.005871,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30382,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 1981D',NULL,30382,31.03,0.3,16,8266,70,NULL,NULL,'NGC 1316',0.005871,'2000ApJ...539..658K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30383,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 1981D',NULL,30383,31.1,0.09,16.6,8266,72,NULL,'Trip','NGC 1316',NULL,'2010AJ....140.2036S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30384,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 2006dd',NULL,30384,31.16,0.02,17,8266,72,NULL,'SNooPy','NGC 1316',NULL,'2010AJ....140.2036S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30385,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 2006dd',NULL,30385,31.16,0.01,17.1,8266,72,NULL,'NIR','NGC 1316',NULL,'2010AJ....140.2036S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30386,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 2006dd',NULL,30386,31.18,0.01,17.2,8266,72,NULL,'SNooPy, SN 2006dd, SN 1981D, SN 1980N avg.','NGC 1316',NULL,'2010AJ....140.2036S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30387,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 2006dd',NULL,30387,31.2,0.01,17.4,8266,72,NULL,'NIR, SN 2006dd, SN 1981D, SN 1980N avg.','NGC 1316',NULL,'2010AJ....140.2036S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30388,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 2006dd',NULL,30388,31.21,0.08,17.5,8266,74.4,NULL,NULL,'NGC 1316',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30389,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 1980N',NULL,30389,31.21,0.03,17.5,8266,72,NULL,'SNooPy','NGC 1316',NULL,'2010AJ....140.2036S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30390,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 1980N',NULL,30390,31.24,0.03,17.7,8266,72,NULL,'NIR','NGC 1316',NULL,'2010AJ....140.2036S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30391,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 1981D',NULL,30391,31.24,0.04,17.7,8266,72,NULL,'SNooPy','NGC 1316',NULL,'2010AJ....140.2036S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30392,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 2006dd',NULL,30392,31.25,0.03,17.8,8266,72,NULL,'Trip, SN 2006dd, SN 1981D, SN 1980N avg.','NGC 1316',NULL,'2010AJ....140.2036S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30393,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 1980N',NULL,30393,31.26,0.06,17.9,8266,72,NULL,'Trip','NGC 1316',NULL,'2010AJ....140.2036S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30394,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 2006dd',NULL,30394,31.28,0.05,18,8266,72,NULL,'Trip','NGC 1316',NULL,'2010AJ....140.2036S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30395,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 1980N',NULL,30395,31.35,0.15,18.6,8266,NULL,NULL,NULL,'NGC 1316',NULL,'1999A&A...349..877D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30396,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 1981D',NULL,30396,31.35,0.15,18.6,8266,NULL,NULL,NULL,'NGC 1316',NULL,'1999A&A...349..877D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30397,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 1981D',NULL,30397,31.38,0.14,18.9,8266,60,NULL,NULL,'NGC 1316',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30398,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 1981D',NULL,30398,31.4,0.03,19,8266,72,NULL,'NIR','NGC 1316',NULL,'2010AJ....140.2036S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30399,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 2006dd',NULL,30399,31.41,0.11,19.1,8266,NULL,NULL,'MLCS','NGC 1316',0.005871,'2008MNRAS.388..421M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30400,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 1980N',NULL,30400,31.44,0.32,19.3,8266,70,NULL,NULL,'NGC 1316',0.005871,'2000ApJ...539..658K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30401,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 1980N',NULL,30401,31.44,0.32,19.4,8266,75,NULL,NULL,'NGC 1316',NULL,'1991AJ....102..208H',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30402,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 2006dd','R',30402,31.48,NULL,19.8,8266,62.3,NULL,NULL,'NGC 1316',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30403,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 1980N',NULL,30403,31.6,0.1,20.7,8266,65,NULL,'MLCS2k2','NGC 1316',0.005871,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30404,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 1980N',NULL,30404,31.6,0.15,20.9,8266,65,NULL,'avg. of 2 SNIa and hosts','NGC 1316',NULL,'1996AJ....112.2398H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30405,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 1980N',NULL,30405,31.73,NULL,22.2,8266,60,NULL,'M(V) = -19.47 mag','NGC 1316',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30406,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 2006mr',NULL,30406,31.74,0.01,22.3,8266,72,NULL,'NIR, SNIa 0.50 mag underluminous','NGC 1316',NULL,'2010AJ....140.2036S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30407,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 1980N',NULL,30407,31.75,0.14,22.4,8266,60,NULL,NULL,'NGC 1316',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30408,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 1980N',NULL,30408,31.77,NULL,22.6,8266,60,NULL,'M(V) = -19.47 mag','NGC 1316',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30409,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 1980N',NULL,30409,31.77,NULL,22.6,8266,60,NULL,'M(I) = -19.19 mag','NGC 1316',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30410,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 1980N',NULL,30410,31.8,0.05,22.9,8266,NULL,NULL,'SN 1980N, SN 1981D avg.','NGC 1316',NULL,'2001MNRAS.322..643G',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30411,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 1981D',NULL,30411,31.8,0.05,22.9,8266,NULL,NULL,'SN 1981D, SN 1980N avg.','NGC 1316',NULL,'2001MNRAS.322..643G',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30412,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 1981D',NULL,30412,31.81,NULL,23,8266,60,NULL,'M(B) = -19.48 mag','NGC 1316',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30413,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 2006mr',NULL,30413,31.83,0.07,23.3,8266,72,NULL,'Trip, SNIa 0.50 mag underluminous','NGC 1316',NULL,'2010AJ....140.2036S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30414,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 1981D',NULL,30414,31.91,NULL,24.1,8266,60,NULL,'M(B) = -19.48 mag','NGC 1316',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30415,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 2006dd',NULL,30415,32.12,0.06,26.3,8266,72,NULL,NULL,'NGC 1316',0.00551,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30416,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 1981D','R',30416,32.29,NULL,28.7,8266,NULL,NULL,'Photographic','NGC 1316',NULL,'1988SSRv...48....1R',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30417,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 2006mr',NULL,30417,32.58,0.34,32.5,8266,72,NULL,NULL,'NGC 1316',0.00551,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30418,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30418,31.02,0.12,16,8266,NULL,NULL,'I','NGC 1316',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30419,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30419,31.21,0.08,17.5,8266,74.4,NULL,NULL,'NGC 1316',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30420,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30420,31.21,0.23,17.5,8266,NULL,NULL,'I','NGC 1316',NULL,'2001ApJ...559..584A',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30421,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30421,31.5,0.17,20,8266,NULL,NULL,'I','NGC 1316',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30422,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30422,31.53,0.13,20.2,8266,NULL,NULL,'BV A01','NGC 1316',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30423,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30423,31.59,0.04,20.8,8266,NULL,NULL,'Fornax Cluster, HST KP Calibrated, I','NGC 1316',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30424,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30424,31.59,0.05,20.8,8266,NULL,NULL,'Syst. Err. +/- 0.14 mag','NGC 1316',NULL,'2013A&A...552A.106C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30425,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30425,31.61,0.07,21,8266,NULL,NULL,'HST ACS FCS','NGC 1316',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30426,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30426,31.62,0.09,21.1,8266,NULL,NULL,'J03','NGC 1316',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30427,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30427,31.62,0.09,21.1,8266,NULL,NULL,'M06','NGC 1316',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30428,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30428,31.64,0.07,21.3,8266,NULL,NULL,'I','NGC 1316',NULL,'2010ApJ...724..657B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30429,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30429,31.66,0.17,21.5,8266,NULL,NULL,'I','NGC 1316',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30430,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30430,31.66,0.17,21.5,8266,NULL,NULL,'I','NGC 1316',NULL,'2001ApJ...559..584A',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30431,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30431,31.71,0.19,22,8266,NULL,NULL,'HST KP Calibrated, I','NGC 1316',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30432,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30432,31.78,0.09,22.7,8266,NULL,NULL,'T01','NGC 1316',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30433,'GC radius','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30433,30.59,0.11,13.1,8266,NULL,NULL,'HST ACS FCS','NGC 1316',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30434,'D-Sigma','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30434,31.1,NULL,16.6,8266,NULL,NULL,NULL,'NGC 1316',NULL,'1993ESOC...45..159D',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30435,'D-Sigma','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30435,31.14,NULL,16.9,8266,69,NULL,'Fornax Cluster, D-Sigma/Faber-Jackson hybrid indicator [for Coma D = 100 Mpc]','NGC 1316',NULL,'1991BAAS...23..956G',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30436,'D-Sigma','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30436,31.17,0.1,17.1,8266,72,NULL,'Fornax cluster, 18 galaxies','NGC 1316',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30437,'D-Sigma','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30437,31.22,0.49,17.5,8266,NULL,NULL,'assume Virgo m-M = 31.00 mag','NGC 1316',NULL,'1987ApJ...313...42D',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30438,'D-Sigma','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30438,31.66,NULL,21.5,8266,NULL,NULL,'Fornax vs. Virgo m-M = 31.31 mag, Aperture cor.','NGC 1316',NULL,'1997MNRAS.289..847D',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30439,'D-Sigma','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30439,31.76,NULL,22.5,8266,NULL,NULL,'Fornax vs. Virgo m-M = 31.31 mag','NGC 1316',NULL,'1997MNRAS.289..847D',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30440,'Diameter','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30440,31.14,NULL,16.9,8266,NULL,NULL,NULL,'NGC 1316',NULL,'1991ApJ...382....1G',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30441,'Dwarf Ellipticals','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30441,30.4,NULL,12,8266,NULL,NULL,'Fornax Cluster, Avg. Dwarfs','NGC 1316',NULL,'1987AJ.....94.1126C',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30442,'Dwarf Galaxy Diameter','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30442,31.98,0.8,24.9,8266,NULL,NULL,'Fornax cluster, bias corr.','NGC 1316',NULL,'2011MNRAS.414.3699M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30443,'Dwarf Galaxy Diameter','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30443,32.2,0.58,27.6,8266,NULL,NULL,'Fornax cluster','NGC 1316',NULL,'2011MNRAS.414.3699M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30444,'Faber-Jackson','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30444,30.18,NULL,10.9,8266,NULL,NULL,'LEDA [April 2006]','NGC 1316',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30445,'Faber-Jackson','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30445,30.19,0.65,10.9,8266,95,NULL,'Weighted Mean','NGC 1316',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30446,'Faber-Jackson','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30446,30.6,0.5,13.2,8266,88,NULL,'Fornax cluster, B','NGC 1316',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30447,'Faber-Jackson','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30447,30.6,0.5,13.2,8266,88,NULL,'Fornax Cluster, 11 galaxies, B','NGC 1316',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30448,'Faber-Jackson','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30448,30.64,0.41,13.4,8266,88,NULL,'Fornax cluster, BRI mean','NGC 1316',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30449,'Faber-Jackson','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30449,30.69,0.49,13.7,8266,88,NULL,'Fornax cluster, R','NGC 1316',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30450,'Faber-Jackson','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30450,30.69,0.41,13.7,8266,88,NULL,'Fornax cluster, I','NGC 1316',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30451,'Faber-Jackson','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30451,30.69,0.49,13.7,8266,88,NULL,'Fornax Cluster, 11 galaxies, R','NGC 1316',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30452,'Faber-Jackson','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30452,30.69,0.41,13.7,8266,88,NULL,'Fornax Cluster, 11 galaxies, I','NGC 1316',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30453,'Faber-Jackson','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30453,31.22,0.81,17.5,8266,55,NULL,'Visvanathan & Sandage 1979','NGC 1316',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30454,'Faber-Jackson','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30454,31.74,NULL,22.3,8266,NULL,NULL,'Fornax vs. Virgo m-M = 31.31 mag','NGC 1316',NULL,'1997MNRAS.289..847D',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30455,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30455,30.59,0.35,13.1,8266,88,NULL,'Fornax cluster, R','NGC 1316',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30456,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30456,30.59,0.35,13.1,8266,88,NULL,'Fornax Cluster, 11 galaxies, R','NGC 1316',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30457,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30457,30.65,0.33,13.5,8266,88,NULL,'Fornax cluster, BRI mean','NGC 1316',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30458,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30458,30.66,0.38,13.6,8266,88,NULL,'Fornax Cluster, 11 galaxies, B','NGC 1316',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30459,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30459,30.66,0.38,13.6,8266,88,NULL,'Fornax cluster, B','NGC 1316',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30460,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30460,30.69,0.15,13.7,8266,NULL,NULL,'log(m)-log(r), early FP','NGC 1316',NULL,'1989AJ.....98.1542B',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30461,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30461,30.69,0.33,13.7,8266,88,NULL,'Fornax Cluster, 11 galaxies, I','NGC 1316',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30462,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30462,30.69,0.33,13.7,8266,88,NULL,'Fornax cluster, I','NGC 1316',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30463,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30463,30.7,0.3,13.8,8266,NULL,NULL,'log(m)-log(r), early FP','NGC 1316',NULL,'1994MNRAS.268L..11Y',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30464,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30464,31.21,0.08,17.5,8266,74.4,NULL,NULL,'NGC 1316',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30465,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30465,31.22,0.65,17.5,8266,NULL,NULL,'assume Virgo m-M = 31.00 mag','NGC 1316',NULL,'1987ApJ...313...42D',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30466,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30466,31.35,0.12,18.6,8266,NULL,NULL,'Fornax cluster, Virgo m-M = 31.1 mag','NGC 1316',NULL,'1998MNRAS.295..933G',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30467,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30467,31.66,NULL,21.5,8266,NULL,NULL,'Fornax vs. Virgo m-M = 31.31 mag, Aperture cor.','NGC 1316',NULL,'1997MNRAS.289..847D',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30468,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30468,31.67,0.34,21.6,8266,NULL,NULL,'Fornax cluster, Virgo m-M = 31.1 mag','NGC 1316',NULL,'2002MNRAS.334..859G',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30469,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30469,31.69,0.44,21.8,8266,NULL,NULL,'Fornax cluster, Virgo m-M = 31.1 mag, Photometric Plane','NGC 1316',NULL,'2002MNRAS.334..859G',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30470,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30470,31.75,NULL,22.4,8266,NULL,NULL,'Fornax vs. Virgo m-M = 31.31 mag, log(m)-log(r)','NGC 1316',NULL,'1997MNRAS.289..847D',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30471,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30471,31.76,NULL,22.5,8266,NULL,NULL,'Fornax vs. Virgo m-M = 31.31 mag','NGC 1316',NULL,'1997MNRAS.289..847D',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30472,'LSB galaxies','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30472,31.25,0.28,17.8,8266,NULL,NULL,'Fornax Cluster, 5 LSB galaxy avg.','NGC 1316',NULL,'1991ApJ...376..404B',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30473,'Tully est','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30473,31.14,0.8,16.9,8266,75,NULL,'B','NGC 1316',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30474,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30474,30.2,0.45,11,8266,NULL,NULL,'K','NGC 1316',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30475,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30475,30.87,0.4,14.9,8266,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 5 galaxy group','NGC 1316',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30476,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30476,30.88,NULL,15,8266,71,NULL,'ABELL S0373, Fornax CLUSTER, 45 galaxies','NGC 1316',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30477,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30477,30.93,0.3,15.3,8266,NULL,NULL,'ABELL S0373, Fornax CLUSTER, 14 galaxies','NGC 1316',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30478,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30478,30.94,0.33,15.4,8266,74,NULL,'23 spirals','NGC 1316',NULL,'1996ApJ...463...60B',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30479,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30479,31.16,0.13,17.1,8266,75,NULL,'Fornax cluster, avg. of 15 spiral galaxies','NGC 1316',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30480,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30480,31.19,0.12,17.3,8266,75,NULL,'Fornax CLUSTER','NGC 1316',NULL,'2012ApJ...749...78T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30481,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30481,31.2,0.14,17.4,8266,75,NULL,'Fornax cluster, avg. of 15 spiral galaxies','NGC 1316',NULL,'2013ApJ...765...94S',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30482,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30482,31.2,0.4,17.4,8266,75,NULL,'HOSTS SN 1980N','NGC 1316',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30483,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30483,31.21,0.13,17.4,8266,74.4,NULL,'Fornax CLUSTER, 15 galaxies, WISE W2 (4.6 micro-meter), color corrected','NGC 1316',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30484,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30484,31.21,0.13,17.5,8266,74.4,NULL,'Fornax CLUSTER, 15 galaxies, WISE W1 (3.4 micro-meter), color corrected','NGC 1316',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30485,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30485,31.22,0.1,17.5,8266,71,NULL,'Fornax Cluster','NGC 1316',NULL,'1982PASAu...4..419V',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30486,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30486,31.22,0.13,17.5,8266,74.4,NULL,'Fornax CLUSTER, 15 galaxies, WISE I-band','NGC 1316',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30487,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30487,31.25,0.1,17.8,8266,74.4,NULL,'Fornax CLUSTER, 15 galaxies, WISE W2 (4.6 micro-meter), curved','NGC 1316',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30488,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30488,31.25,0.5,17.8,8266,77,NULL,'Fornax cluster, 16 galaxies','NGC 1316',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30489,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30489,31.25,NULL,17.8,8266,77,NULL,'BRIK, Fornax CLUSTER, 16 galaxies','NGC 1316',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30490,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30490,31.28,0.1,18.1,8266,74.4,NULL,'Fornax CLUSTER, 15 galaxies, WISE W1 (3.4 micro-meter), curved','NGC 1316',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30491,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30491,31.59,0.4,20.8,8266,NULL,NULL,'mean','NGC 1316',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30492,'Tully est','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30492,31.14,0.8,16.9,8267,75,NULL,'B','NGC 1317',NULL,'1988NBGC.C....0000T',1988,1,2.8,NULL,'G',0.000047,NULL,'11.91',2.4,'(R\')SAB(rl)0/a','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,50.6845417,-37.10369,0,NULL,38603768695,603183885,9424748,11.91),(30493,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30493,36.63,0.46,212,8268,70,NULL,NULL,'2MASX J03224839-0641402',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.00011,NULL,'15.4g',0.53,'BrClG',NULL,NULL,NULL,NULL,1,50.701667,-6.69464,0.133,NULL,36804352299,575068004,8985437,15.4),(30494,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 14398','R',30494,39.86,0.34,838,8269,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 14398 HOST',0.118381,'2014arXiv1401.3317S',2014,1,0.12,NULL,'G',0.0001,NULL,'19.9g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,50.7105,0.27289,0.257,NULL,65020163873,1015940060,15874063,19.9),(30495,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 07978','R',30495,41.01,0.13,1420,8270,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14398 HOST',0.118381,'2014arXiv1401.3317S',2014,1,0.12,NULL,'G',0.0001,NULL,'19.9g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,50.7105,0.27289,0.257,NULL,65020163873,1015940060,15874063,19.9),(30496,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 07978','R',30496,41.36,0.28,1670,8270,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 14398 HOST',0.118381,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30497,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30497,34.19,0.49,68.9,8271,75,NULL,'IR','UGC 02700',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000021,NULL,'14.8',0.4,'SBb?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,50.724375,42.55333,0.973,NULL,68568462862,1071382232,16740347,14.8),(30498,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30498,34.31,0.47,72.9,8271,NULL,NULL,'H','UGC 02700',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30499,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30499,34.32,0.2,73.1,8271,74.4,NULL,NULL,'UGC 02700',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30500,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30500,34.44,0.45,77.2,8271,NULL,NULL,'K','UGC 02700',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30501,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30501,34.53,0.46,80.5,8271,NULL,NULL,'J','UGC 02700',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30502,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30502,34.84,0.4,92.7,8271,NULL,NULL,'mean','UGC 02700',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30503,'Tully est','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30503,32.7,0.8,34.7,8272,75,NULL,NULL,'UGCA 067',NULL,'1988NBGC.C....0000T',1988,1,2.5,NULL,'G',0.000003,NULL,'14.86',1.7,'SB(s)d',NULL,NULL,NULL,NULL,1,50.729875,-11.20339,0.157,NULL,37885724626,591964447,9249444,14.86),(30504,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 03323',NULL,30504,40.63,0.97,1330,8273,70,NULL,'SN photometric redshift distance, z photo =0.380 +/- 0.320','SDSS-II SN 03323',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','22.0g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,50.7419583,0.42219,0.257,NULL,65020346869,1015942919,15874108,22),(30505,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 2008gp',NULL,30505,35.6,0.16,124,8274,72,NULL,NULL,'CGCG 390-078',0.03285,'2013ApJ...773...53F',2013,1,1.3,NULL,'G',0.000117,NULL,'14.59',0.8,'(R)SAB(r)a pec?',NULL,NULL,NULL,NULL,1,50.75,1.36578,0.281,NULL,65020808982,1015950140,15874220,14.59),(30506,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 2008gp',NULL,30506,35.74,0.13,136,8274,73.8,NULL,'SALT 2 (SNANA)','CGCG 390-078',0.0331,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30507,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 2008gp',NULL,30507,35.68,0.08,137,8274,72,NULL,'M(H) = -18.317 mag','CGCG 390-078',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30508,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30508,36.1,0.58,166,8275,70,NULL,NULL,'ESO 248- G 014',NULL,'2014MNRAS.445.2677S',2014,1,0.91,NULL,'G',0.00015,NULL,'14.64',0.63,'SAB(r)ab',NULL,NULL,NULL,NULL,1,50.75575,-42.60325,0,NULL,38486892248,601357691,9396213,14.64),(30509,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30509,36.35,0.46,186,8276,70,NULL,NULL,'2MASX J03230530+0021150',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000093,NULL,'15.8g',0.46,'E0',NULL,NULL,NULL,NULL,1,50.772,0.35428,0.257,NULL,65020124233,1015939441,15874053,15.8),(30510,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30510,30.41,0.25,12.1,8277,74.4,NULL,NULL,'NGC 1315',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.000077,NULL,'13.88',1.4,'SB(rs)0+?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,50.7774583,-21.37517,0.025,NULL,38028700307,594198442,9284350,13.88),(30511,'Tully est','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30511,31.24,0.8,17.7,8277,75,NULL,NULL,'NGC 1315',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30512,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30512,31.43,0.45,19.3,8277,NULL,NULL,'K','NGC 1315',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30513,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30513,31.75,0.4,22.4,8277,NULL,NULL,'mean','NGC 1315',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30514,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30514,36.4,0.53,190,8278,70,NULL,NULL,'AM 0322-573',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00008,NULL,'15.47',0.6,'SA(rl)0/a',NULL,NULL,NULL,NULL,1,50.8245,-57.46211,0.017,NULL,35776142430,559002225,8734409,15.47),(30515,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30515,37.48,0.46,314,8279,70,NULL,NULL,'2MASX J03232365-0112084',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000099,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,50.8485,-1.20242,0.205,NULL,36831018589,575484665,8991947,17.1),(30516,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30516,33.66,NULL,53.9,8280,NULL,NULL,'Dipole','FGC 0417',NULL,'2010Ap&SS.325..163P',2010,1,2.46,NULL,'G',0.000006,NULL,'15.3',0.27,'Sd',NULL,NULL,NULL,NULL,1,50.8499583333,11.15242,1.165,NULL,67934243985,1061472562,16585508,15.3),(30517,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30517,33.67,NULL,54.2,8280,NULL,NULL,'Dipole + Quadrupole','FGC 0417',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30518,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30518,33.68,NULL,54.5,8280,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0417',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30519,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30519,33.76,NULL,56.5,8280,NULL,NULL,NULL,'FGC 0417',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30520,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30520,34,0.49,63.2,8280,75,NULL,'IR','FGC 0417',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30521,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30521,35.34,0.46,117,8281,70,NULL,NULL,'2MASX J03232964-0629439',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000077,NULL,'16.3g',0.27,'NLAGN          Sy2',NULL,NULL,NULL,'Sy 2',1,50.8735,-6.49561,0.133,NULL,36804272148,575066752,8985418,16.3),(30522,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30522,35.41,0.5,121,8282,NULL,NULL,'Malmquist cor.','UGC 02711',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',NULL,NULL,'15.45',0.2,'(R\')SBb: sp',NULL,NULL,NULL,NULL,1,50.874167,1.32419,0.285,NULL,65020911856,1015951747,15874246,15.45),(30523,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30523,35.69,0.44,137,8282,NULL,NULL,NULL,'UGC 02711',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30524,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30524,35.84,0.2,147,8282,74.4,NULL,NULL,'UGC 02711',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30525,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 18809','R',30525,38.84,0.21,518,8283,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007mi','SN 2007mi',0.129,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,50.881333,0.66667,0.237,NULL,65020189199,1015940456,15874069,NULL),(30526,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 18809','R',30526,39.23,0.09,622,8283,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007mi','SN 2007mi',0.129,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30527,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30527,30.41,0.14,12.1,8284,NULL,NULL,'TOM(g) = -7.2 mag','ESO 357- G 025',NULL,'2010ApJ...717..603V',2010,1,1.3,'Da Costa, et al. (1998,AJ,116,1) give v = 58675 +/- 51 km/sec.','G',0.000097,NULL,'15.22',0.4,'SAB0^0^:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,50.90525,-35.77839,0,NULL,38594570782,603040168,9422502,15.22),(30528,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30528,30.92,0.23,15.3,8284,NULL,NULL,'TOM(z) = -8.53 mag','ESO 357- G 025',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30529,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30529,31.47,0.14,19.7,8284,74.4,NULL,NULL,'ESO 357- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30530,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30530,31.49,0.14,19.9,8284,NULL,NULL,'HST ACS FCS','ESO 357- G 025',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30531,'GC radius','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30531,31.7,0.41,21.8,8284,NULL,NULL,'HST ACS FCS','ESO 357- G 025',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30532,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 13492',NULL,30532,39.63,0.52,844,8285,70,NULL,'SN photometric redshift distance, z photo =0.221 +/- 0.070','SDSS-II SN 13492',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','22.3g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,50.9097917,0.21019,0.281,NULL,64986587788,1015415434,15865866,22.3),(30533,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30533,35.66,0.33,135,8286,70,NULL,NULL,'2MASX J03234412-0000491',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00007,NULL,'16.3g',0.2,'S0',NULL,NULL,NULL,NULL,1,50.934,-0.01369,0.249,NULL,36813442796,575210043,8987656,16.3),(30534,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30534,38.64,0.46,535,8287,70,NULL,NULL,'2MASX J03234574-0649341',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000085,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,50.9405416667,-6.826,0.137,NULL,36804431307,575069239,8985456,18.3),(30535,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30535,37.27,0.53,284,8288,70,NULL,NULL,'2MASX J03234576-2328098',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.81',0.29,NULL,NULL,NULL,NULL,NULL,1,50.940625,-23.46944,0,NULL,38022683136,594104424,9282881,16.81),(30536,'Tully est','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30536,31.71,0.8,21.9,8289,75,NULL,NULL,'UGCA 068',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000021,NULL,'14.79',1.4,'SAB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,50.946875,-19.75283,0.057,NULL,38034319891,594286248,9285722,14.79),(30537,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 2002es',NULL,30537,33.93,0.18,59.4,8290,74.2,NULL,'SALT 2','UGC 02708',0.02843,'2010ApJ...716..712A',2010,1,1.4,'RC3 gives v = 5394 km/sec.','G',0.000013,NULL,'14.4B',1.4,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,50.953583,40.55783,0.853,NULL,68565355047,1071333672,16739588,14.4),(30538,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 2002es',NULL,30538,34.42,0.24,74.3,8290,65,NULL,'MLCS31','UGC 02708',0.02843,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30539,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 2002es',NULL,30539,34.51,0.09,79.8,8290,74.4,NULL,NULL,'UGC 02708',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30540,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SN 2002es',NULL,30540,34.82,0.24,89.3,8290,65,NULL,'SALT2','UGC 02708',0.02843,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30541,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30541,37.08,0.46,261,8291,70,NULL,NULL,'2MASX J03235010-0012249',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000069,NULL,'16.26',0.21,NULL,NULL,NULL,NULL,NULL,1,50.958833,-0.20692,0.225,NULL,36813652911,575213326,8987708,16.26),(30542,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30542,33.64,0.38,53.4,8292,NULL,NULL,NULL,'UGC 02709',NULL,'2009ApJS..182..474S',2009,1,2.3,NULL,'G',0.00001,NULL,'14.3',0.8,'SABb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,50.9735,38.67706,0.621,NULL,68701324812,1073458200,16772784,14.3),(30543,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30543,33.65,0.2,53.7,8292,74.4,NULL,NULL,'UGC 02709',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30544,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30544,33.87,0.47,59.5,8292,NULL,NULL,'H','UGC 02709',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30545,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30545,33.9,0.33,60.4,8292,NULL,NULL,'Malmquist cor.','UGC 02709',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30546,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30546,33.94,0.46,61.3,8292,NULL,NULL,'J','UGC 02709',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30547,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30547,33.96,0.45,61.9,8292,NULL,NULL,'K','UGC 02709',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30548,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30548,34.17,0.4,68.1,8292,NULL,NULL,'mean','UGC 02709',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30549,'Ring Diameter','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30549,31.8,0.84,23,8293,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 1326',NULL,'1981ApJS...45..541P',1981,1,3.9,NULL,'G',0.000005,NULL,'12.20',2.9,'(R_1)SB(rl)0/a LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,50.985,-36.46467,0,NULL,38602586024,603165406,9424459,12.2),(30550,'Faber-Jackson','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30550,29.52,0.63,8.02,8293,95,NULL,'Michard 1979b, c','NGC 1326',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30551,'Faber-Jackson','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30551,29.98,0.44,9.91,8293,95,NULL,'Weighted Mean','NGC 1326',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30552,'Faber-Jackson','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30552,30.45,0.46,12.3,8293,95,NULL,'Michard 1979a','NGC 1326',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30553,'IRAS','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30553,31.38,0.8,18.9,8293,75,NULL,'A82, H','NGC 1326',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30554,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30554,30.83,0.47,14.6,8293,75,NULL,'A82, H, raw','NGC 1326',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30555,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30555,30.95,0.47,15.5,8293,75,NULL,'A82, H, inv','NGC 1326',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30556,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30556,31.14,0.4,16.9,8293,75,NULL,'B','NGC 1326',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30557,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30557,31.17,0.47,17.1,8293,75,NULL,'A82, H, cor','NGC 1326',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30558,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30558,31.38,0.12,18.9,8293,NULL,NULL,NULL,'NGC 1326',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30559,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30559,35.46,NULL,123,8294,NULL,NULL,NULL,'FGC 0418',NULL,'2000BSAO...50....5K',2000,1,0.9,NULL,'G',0.000018,NULL,'17.24',0.12,'Sdm',NULL,NULL,NULL,NULL,1,51.015833,15.10194,0.653,NULL,68163904560,1065061008,16641578,17.24),(30560,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30560,35.58,NULL,131,8294,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0418',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30561,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30561,35.59,NULL,131,8294,NULL,NULL,'Dipole + Quadrupole','FGC 0418',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30562,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30562,35.61,NULL,132,8294,NULL,NULL,'Dipole','FGC 0418',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30563,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30563,35.75,0.49,141,8294,75,NULL,'IR','FGC 0418',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30564,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 08605',NULL,30564,40.3,0.12,1150,8295,70,NULL,'SN photometric redshift distance, z photo =0.316 +/- 0.022','SDSS-II SN 08605',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,51.0384583333,-0.003,0.249,NULL,36813556156,575211814,8987684,NULL),(30565,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30565,35.1,0.47,105,8296,70,NULL,NULL,'2MASX J03241479-4957562',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.00015,NULL,'15.97',0.38,'S0',NULL,NULL,NULL,NULL,1,51.06175,-49.96558,0,NULL,37727630292,589494223,9210847,15.97),(30566,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 11330','RN',30566,42.09,0.24,2010,8297,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 11330',0.302925,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30567,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 11330','RN',30567,42.45,0.27,2370,8297,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 11330',0.302925,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30568,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30568,36.22,0.15,175,8298,70,NULL,NULL,'2MASX J03241843-0027390',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000068,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,51.07675,-0.46075,0.253,NULL,36813522903,575211295,8987676,17.3),(30569,'IRAS','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30569,31.64,0.8,21.2,8299,75,NULL,'MAT, I','NGC 1325',NULL,'1997ApJS..109..333W',1997,1,4.7,NULL,'G',0.000017,NULL,'12.49',1.6,'SA(s)bc','Parent (of companion) galaxy',NULL,NULL,NULL,1,51.1065417,-21.54403,0.033,NULL,38027856534,594185258,9284144,12.49),(30570,'IRAS','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30570,31.65,0.8,21.4,8299,75,NULL,'A82, H','NGC 1325',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30571,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30571,31.24,0.4,17.7,8299,75,NULL,'B','NGC 1325',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30572,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30572,31.29,NULL,18.1,8299,NULL,NULL,'B','NGC 1325',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30573,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30573,31.3,0.4,18.2,8299,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 1325',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30574,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30574,31.5,0.35,20,8299,NULL,NULL,NULL,'NGC 1325',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30575,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30575,31.51,0.4,20,8299,73,NULL,'opt','NGC 1325',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30576,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30576,31.67,0.32,21.6,8299,85,NULL,'I, raw','NGC 1325',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30577,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30577,31.68,0.43,21.7,8299,75,NULL,'MAT, I, raw','NGC 1325',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30578,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30578,31.7,0.4,21.9,8299,NULL,NULL,'mean','NGC 1325',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30579,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30579,31.71,0.32,22,8299,85,NULL,'I, inv','NGC 1325',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30580,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30580,31.71,0.47,22,8299,75,NULL,'A82, H, raw','NGC 1325',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30581,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30581,31.78,0.2,22.7,8299,74.4,NULL,NULL,'NGC 1325',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30582,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30582,31.8,0.47,22.9,8299,75,NULL,'A82, H, inv','NGC 1325',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30583,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30583,31.83,0.43,23.3,8299,75,NULL,'MAT, I, cor','NGC 1325',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30584,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30584,31.87,0.43,23.6,8299,75,NULL,'3.6 micron, color corrected','NGC 1325',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30585,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30585,31.88,0.47,23.7,8299,75,NULL,'A82, H, cor','NGC 1325',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30586,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30586,31.88,0.43,23.7,8299,75,NULL,'MAT, I, inv','NGC 1325',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30587,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30587,31.96,0.46,24.7,8299,NULL,NULL,'J','NGC 1325',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30588,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30588,32.02,0.47,25.4,8299,NULL,NULL,'H','NGC 1325',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30589,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30589,32.04,0.43,25.5,8299,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1325',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30590,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30590,32.09,0.45,26.1,8299,NULL,NULL,'K','NGC 1325',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30591,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30591,35.24,0.67,112,8300,70,NULL,NULL,'MCG -01-09-034',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00013,NULL,'15.24',0.25,NULL,NULL,NULL,NULL,NULL,1,51.107875,-4.81886,0.061,NULL,36835749026,575558578,8993102,15.24),(30592,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30592,36.67,0.46,216,8301,70,NULL,NULL,'2MASX J03242755-0109561',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000073,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,51.114667,-1.16553,0.253,NULL,36830905269,575482894,8991920,17.6),(30593,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 14157','R',30593,39.95,0.19,806,8302,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006kj','SN 2006kj',0.2115,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,51.1367083333,1.02236,0.273,NULL,65020533109,1015945829,15874153,NULL),(30594,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 14157','R',30594,40.18,0.09,898,8302,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006kj','SN 2006kj',0.2115,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30595,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30595,35.89,0.59,150,8303,70,NULL,NULL,'2MASX J03243360-4958080',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.93',0.31,NULL,NULL,NULL,NULL,NULL,1,51.140125,-49.96889,0,NULL,37727631214,589494237,9210847,16.93),(30596,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30596,33.14,0.23,42.5,8304,74.4,NULL,NULL,'UGC 02717',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.00003,NULL,'14.3',0.9,'E',NULL,NULL,NULL,NULL,1,51.152,40.69083,0.845,NULL,68565436224,1071334941,16739608,14.3),(30597,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30597,33.79,0.4,57.3,8304,NULL,NULL,'mean','UGC 02717',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30598,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30598,34.07,0.45,65,8304,NULL,NULL,'K','UGC 02717',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30599,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30599,36.22,0.15,175,8305,70,NULL,NULL,'2MASX J03243810-0025192',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000104,NULL,'16.0g',0.42,'NLAGN',NULL,NULL,NULL,'Sy 2',1,51.158875,-0.42203,0.253,NULL,36813502763,575210980,8987671,16),(30600,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30600,34.82,NULL,91.9,8306,NULL,NULL,NULL,'ESO 548- G 009',NULL,'2000BSAO...50....5K',2000,1,1.29,NULL,'G',0.00004,NULL,'16.92',0.11,'Sm',NULL,NULL,NULL,NULL,1,51.160125,-19.29836,0.085,NULL,38034657756,594291527,9285805,16.92),(30601,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30601,36.99,0.46,250,8307,70,NULL,NULL,'2MASX J03244583-0606388',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000075,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,51.1909583333,-6.11072,0.125,NULL,36836050778,575563293,8993176,17.1),(30602,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30602,38.14,0.46,424,8308,70,NULL,NULL,'2MASX J03244818-0647388',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000084,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,51.200833,-6.79406,0.145,NULL,36804375254,575068363,8985443,17.7),(30603,'Tully est','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30603,31.24,0.8,17.7,8309,75,NULL,'B','NGC 1325A',NULL,'1988NBGC.C....0000T',1988,1,2.2,NULL,'G',0.000003,NULL,'13.27',2,'SB(rs)bc?','is a companion galaxy',NULL,NULL,NULL,1,51.2022917,-21.33622,0.025,NULL,38027783943,594184124,9284126,13.27),(30604,'Tully est','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30604,32.88,0.8,37.7,8310,75,NULL,NULL,'NGC 1320',NULL,'1988NBGC.C....0000T',1988,1,1.9,'2008ApJ...689...95M has z = 0.013515.','G',0.000053,NULL,'13.32',0.6,'Sa: sp         Sy2','in a pair',NULL,NULL,'Sy 2',1,51.202917,-3.04228,0.073,NULL,36831532028,575492687,8992073,13.32),(30605,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 17049','RN',30605,41.21,0.3,1330,8311,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17049',0.309251,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30606,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 17049','RN',30606,41.59,0.27,1590,8311,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17049',0.309251,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30607,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30607,37.82,0.46,366,8312,70,NULL,NULL,'2MASX J03245479-0558182',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00007,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,51.228333,-5.97172,0.121,NULL,36836068503,575563570,8993180,18.4),(30608,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30608,38.25,0.46,446,8313,70,NULL,NULL,'2MASX J03245491+0036218',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,51.2289583,0.60592,0.269,NULL,64987402670,1015428166,15866065,16.4),(30609,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 11567','RN',30609,43.6,0.39,3550,8314,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 11567',0.480511,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30610,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30610,35.01,NULL,100,8315,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02719',NULL,'2010Ap&SS.325..163P',2010,1,0.9,NULL,'G',NULL,NULL,'16.5',0.11,'Sc',NULL,NULL,NULL,NULL,1,51.234875,38.94306,0.613,NULL,68701252390,1073457068,16772766,16.5),(30611,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30611,35.02,NULL,101,8315,NULL,NULL,'Dipole + Quadrupole','UGC 02719',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30612,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30612,35.04,NULL,102,8315,NULL,NULL,'Dipole','UGC 02719',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30613,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30613,35.07,NULL,103,8315,NULL,NULL,NULL,'UGC 02719',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30614,'Tully est','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30614,31.14,0.8,16.9,8316,75,NULL,NULL,'NGC 1316C',NULL,'1988NBGC.C....0000T',1988,1,1.4,NULL,'G',0.000017,NULL,'14.32',0.7,'(R\')SA0^0^:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,51.243583,-37.00947,0,NULL,38602665585,603166649,9424478,14.32),(30615,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30615,35.66,0.33,135,8317,70,NULL,NULL,'2MASX J03250150-0011342',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000103,NULL,'15.9g',0.35,'E0',NULL,NULL,NULL,NULL,1,51.2564583,-0.19294,0.229,NULL,36813574609,575212103,8987689,15.9),(30616,'FP','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30616,33.88,0.49,59.6,8318,70,NULL,NULL,'NGC 1324',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.000017,NULL,'13.2g',0.76,'Sb:',NULL,NULL,NULL,NULL,1,51.257,-5.74581,0.121,NULL,36836313361,575567396,8993240,13.2),(30617,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30617,34.05,0.46,64.6,8318,NULL,NULL,'J','NGC 1324',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30618,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30618,34.06,0.47,65,8318,NULL,NULL,'H','NGC 1324',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30619,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30619,34.11,0.45,66.5,8318,NULL,NULL,'K','NGC 1324',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30620,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30620,34.33,0.49,73.3,8318,75,NULL,'IR','NGC 1324',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30621,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30621,34.39,0.4,75.5,8318,NULL,NULL,'mean','NGC 1324',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30622,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30622,34.44,0.37,77.2,8318,NULL,NULL,'Malmquist cor.','NGC 1324',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30623,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30623,34.52,0.35,80,8318,NULL,NULL,NULL,'NGC 1324',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30624,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30624,34.54,0.2,80.9,8318,74.4,NULL,NULL,'NGC 1324',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30625,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 14378','RN',30625,41.98,0.17,1910,8319,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 14378',0.302175,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30626,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 14378','RN',30626,42.29,0.23,2200,8319,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 14378',0.302175,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30627,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30627,35.18,0.49,109,8320,75,NULL,'IR','UGC 02727',NULL,'2011yCatp016004901K',2011,1,1.21,NULL,'G',0.000025,NULL,'17.',0.1,'Scd',NULL,NULL,NULL,NULL,1,51.2822917,5.23489,0.429,NULL,65018738507,1015917789,15873715,17),(30628,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30628,35.27,0.46,113,8320,NULL,NULL,'Malmquist cor.','UGC 02727',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30629,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30629,35.41,0.43,121,8320,NULL,NULL,NULL,'UGC 02727',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30630,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30630,35.49,NULL,125,8320,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02727',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30631,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30631,35.49,NULL,125,8320,NULL,NULL,'Dipole + Quadrupole','UGC 02727',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30632,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30632,35.5,NULL,126,8320,NULL,NULL,'Dipole','UGC 02727',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30633,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30633,35.53,0.2,128,8320,74.4,NULL,NULL,'UGC 02727',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30634,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30634,35.54,NULL,128,8320,NULL,NULL,NULL,'UGC 02727',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30635,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 15749','R',30635,38.27,0.23,403,8321,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2006mw','SN 2006mw',0.1184,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,51.2852916667,-0.04058,0.229,NULL,36813540599,575211571,8987680,NULL),(30636,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 15749','R',30636,38.33,0.08,415,8321,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2006mw','SN 2006mw',0.1184,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30637,'Cepheids','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30637,31,0.09,15.8,8322,NULL,NULL,'cte LMC K03','NGC 1326A',NULL,'2003A&A...411..361K',2003,1,1.9,NULL,'G',0.000003,NULL,'13.77',1.7,'SB(s)m:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,51.285417,-36.36394,0,NULL,38602695911,603167123,9424486,13.77),(30638,'Cepheids','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30638,31.01,0.09,15.9,8322,NULL,NULL,'cte U99','NGC 1326A',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30639,'Cepheids','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30639,31.02,0.1,16,8322,74.4,NULL,NULL,'NGC 1326A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30640,'Cepheids','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30640,31.03,0.09,16.1,8322,NULL,NULL,'cte LMC STS02','NGC 1326A',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30641,'Cepheids','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30641,31.04,0.09,16.1,8322,NULL,NULL,'15, VI, +Z, KEY PROJECT','NGC 1326A',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30642,'Cepheids','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30642,31.04,0.09,16.1,8322,NULL,NULL,'15, VI, KEY PROJECT','NGC 1326A',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30643,'Cepheids','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30643,31.07,0.09,16.4,8322,NULL,NULL,'cte MW FSG03','NGC 1326A',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30644,'Cepheids','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30644,31.07,0.11,16.4,8322,NULL,NULL,'LMC W01','NGC 1326A',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30645,'Cepheids','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30645,31.09,0.09,16.5,8322,NULL,NULL,'cte MW GFG98','NGC 1326A',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30646,'Cepheids','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30646,31.1,0.09,16.6,8322,NULL,NULL,'cte MF91','NGC 1326A',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30647,'Cepheids','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30647,31.11,0.1,16.7,8322,NULL,NULL,'MW HIPP','NGC 1326A',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30648,'Cepheids','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30648,31.17,0.1,17.1,8322,NULL,18.54,'LMC ZP','NGC 1326A',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30649,'Cepheids','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30649,31.17,0.09,17.1,8322,NULL,NULL,'cte MW STS03','NGC 1326A',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30650,'Cepheids','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,'R',30650,31.17,NULL,17.1,8322,NULL,18.54,NULL,'NGC 1326A',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30651,'Cepheids','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30651,31.18,0.17,17.2,8322,NULL,NULL,'MW P02','NGC 1326A',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30652,'Cepheids','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30652,31.24,0.09,17.7,8322,NULL,NULL,'MW GFG','NGC 1326A',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30653,'Cepheids','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30653,31.24,0.09,17.7,8322,NULL,NULL,'70, VI','NGC 1326A',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30654,'Cepheids','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30654,31.43,0.07,19.3,8322,NULL,NULL,'8, VI','NGC 1326A',NULL,'1999ApJ...525...80P',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30655,'Cepheids','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30655,31.43,0.07,19.3,8322,NULL,NULL,'Z, Key Project','NGC 1326A',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30656,'Cepheids','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30656,31.43,0.07,19.3,8322,NULL,NULL,'HST KP Calibrated','NGC 1326A',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30657,'Cepheids','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30657,31.68,NULL,21.7,8322,NULL,NULL,'17, VI','NGC 1326A',NULL,'2006A&A...452..423P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30658,'Tully est','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30658,31.14,0.8,16.9,8322,75,NULL,NULL,'NGC 1326A',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30659,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30659,31.03,0.39,16.1,8322,73,NULL,'opt','NGC 1326A',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30660,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 04320','RN',30660,41.56,0.18,1650,8323,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04320',0.243126,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30661,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 04320','RN',30661,41.93,0.23,1950,8323,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04320',0.243126,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30662,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:02','1','SDSS-II SN 19389','R',30662,42.51,0.51,2170,8324,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2007nz','SDSS J032511.51-000621.0',0.464,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',NULL,NULL,'22.4g',0.05,NULL,NULL,NULL,NULL,NULL,1,51.298,-0.10586,0.229,NULL,36813546703,575211667,8987682,22.4),(30663,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:02','1',NULL,NULL,30663,35.31,0.47,115,8325,NULL,NULL,'H','KUG 0322-063A',NULL,'2007A&A...465...71T',2007,1,0.9,'HOLM 069A is a double star.','G',0.000023,NULL,'14.1g',0.67,'Sc             Sy1',NULL,NULL,NULL,NULL,1,51.29825,-6.18097,0.125,NULL,36803372764,575052699,8985198,14.1),(30664,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30664,35.38,0.45,119,8325,NULL,NULL,'K','KUG 0322-063A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30665,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30665,35.47,0.46,124,8325,NULL,NULL,'J','KUG 0322-063A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30666,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30666,35.62,0.4,133,8325,NULL,NULL,'mean','KUG 0322-063A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30667,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30667,36.52,0.57,201,8326,70,NULL,NULL,'2MASX J03251423-6910039',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.6I',0.4,NULL,NULL,NULL,NULL,NULL,1,51.309333,-69.16767,0.069,NULL,36448140668,569502197,8898471,14.6),(30668,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',30668,36.22,0.15,175,8327,70,NULL,NULL,'2MASX J03251629-0024323',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000113,NULL,'15.71',0.46,NULL,NULL,NULL,NULL,NULL,1,51.31775,-0.40906,0.237,NULL,36814391996,575224874,8987888,15.71),(30669,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',30669,36.22,0.15,175,8328,70,NULL,NULL,'2MASX J03251861-0037533',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000072,NULL,'16.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,51.327667,-0.63158,0.253,NULL,36814388440,575224819,8987887,16.4),(30670,'Tully est','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30670,31.14,0.8,16.9,8329,75,NULL,NULL,'NGC 1326B',NULL,'1988NBGC.C....0000T',1988,1,3.7,'SGC claims ESO 357-IG 29 (i.e. interacting).','G',0.000003,NULL,'13.59',1.1,'SB(s)m: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,51.3347917,-36.38494,0,NULL,38602697864,603167154,9424486,13.59),(30671,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30671,36.02,0.43,160,8330,NULL,NULL,'Malmquist cor.','NGC 1327',NULL,'2009ApJS..182..474S',2009,1,1.1,'NGC ident is not certain; NGC 1327 may be three Galactic stars.','G',0.000033,NULL,'15.24',0.39,'(R\')SB(s)b',NULL,NULL,NULL,NULL,1,51.3462917,-25.68028,0,NULL,38547400759,602303136,9410986,15.24),(30672,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30672,36.16,0.4,170,8330,NULL,NULL,NULL,'NGC 1327',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30673,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30673,36.2,0.2,174,8330,74.4,NULL,NULL,'NGC 1327',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30674,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',30674,37.61,0.46,333,8331,70,NULL,NULL,'2MASX J03252344-0600480',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000064,NULL,'17.7g',0.17,'NLAGN',NULL,NULL,NULL,NULL,1,51.347667,-6.01328,0.125,NULL,36836021667,575562838,8993169,17.7),(30675,'Tully est','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30675,31.77,0.8,22.6,8332,75,NULL,NULL,'UGCA 071',NULL,'1988NBGC.C....0000T',1988,1,3.23,NULL,'G',0.000006,NULL,'15.33',0.28,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,51.353667,-16.23478,0.117,NULL,38006764192,593855690,9278995,15.33),(30676,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30676,31.91,0.39,24.1,8332,73,NULL,'IR','UGCA 071',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30677,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30677,31.91,0.39,24.1,8332,73,NULL,'opt','UGCA 071',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30678,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',30678,31.91,0.4,24.1,8332,75,NULL,NULL,'UGCA 071',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30679,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30679,32.05,0.2,25.7,8332,74.4,NULL,NULL,'UGCA 071',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30680,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30680,32.13,0.43,26.7,8332,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 071',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30681,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30681,32.15,0.43,26.9,8332,75,NULL,'3.6 micron, color corrected','UGCA 071',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30682,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',30682,32.34,0.49,29.3,8332,75,NULL,'IR','UGCA 071',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30683,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30683,32.42,NULL,30.4,8332,NULL,NULL,'Dipole + Quadrupole + Octopole','UGCA 071',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30684,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30684,32.43,NULL,30.6,8332,NULL,NULL,'Dipole','UGCA 071',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30685,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30685,32.43,NULL,30.6,8332,NULL,NULL,'Dipole + Quadrupole','UGCA 071',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30686,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30686,32.56,NULL,32.5,8332,NULL,NULL,NULL,'UGCA 071',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30687,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30687,35.45,0.5,123,8333,70,NULL,NULL,'IC 1929',NULL,'2014MNRAS.445.2677S',2014,1,0.96,NULL,'G',0.00015,NULL,'14.81',0.59,'SB(s)b',NULL,NULL,NULL,NULL,1,51.3577083,-51.26719,0,NULL,37731493575,589554587,9211790,14.81),(30688,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',30688,35.11,0.46,105,8334,70,NULL,NULL,'2MASX J03252868+0016427',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.00008,NULL,'15.9g',0.34,'E0',NULL,NULL,NULL,NULL,1,51.369583,0.27853,0.249,NULL,64987527367,1015430115,15866095,15.9),(30689,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30689,34.33,0.23,73.5,8335,74.4,NULL,NULL,'UGC 02725',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000207,NULL,'14.8',0.9,'S0',NULL,NULL,NULL,NULL,1,51.3730833333,41.24092,0.877,NULL,68565737929,1071339655,16739682,14.8),(30690,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 14904',NULL,30690,41.37,0.18,1880,8336,70,NULL,'SN photometric redshift distance, z photo =0.602 +/- 0.077','SDSS-II SN 14904',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','23.3g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,51.404583,-0.73239,0.253,NULL,36814349672,575224213,8987878,23.3),(30691,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',30691,38.25,0.46,447,8337,70,NULL,NULL,'SDSS J032538.22-072232.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000071,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,51.4092916667,-7.37569,0.169,NULL,36804225211,575066018,8985406,18.7),(30692,'IRAS','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30692,30.78,0.8,14.3,8338,75,NULL,'MAT, I','IC 1933',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000013,NULL,'12.9',1.2,'(R\'_2)SB(s)d','X-ray-faint group member',NULL,NULL,NULL,1,51.4162083,-52.7855,0,NULL,37730517971,589539343,9211552,12.9),(30693,'Tully est','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30693,30.3,0.8,11.5,8338,75,NULL,'B','IC 1933',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30694,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30694,30.62,0.08,13.3,8338,NULL,NULL,NULL,'IC 1933',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30695,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30695,31.06,0.43,16.3,8338,75,NULL,'3.6 micron, color + selection bias corrected','IC 1933',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30696,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30696,31.11,0.43,16.7,8338,75,NULL,'3.6 micron, color corrected','IC 1933',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30697,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30697,31.14,0.2,16.9,8338,74.4,NULL,NULL,'IC 1933',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30698,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30698,31.21,0.4,17.5,8338,NULL,NULL,NULL,'IC 1933',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30699,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30699,31.22,0.4,17.5,8338,73,NULL,'opt','IC 1933',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30700,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30700,31.22,0.32,17.5,8338,85,NULL,'I, inv','IC 1933',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30701,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30701,31.23,0.32,17.6,8338,85,NULL,'I, raw','IC 1933',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30702,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30702,31.24,0.4,17.7,8338,NULL,NULL,'mean','IC 1933',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30703,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30703,31.58,0.43,20.7,8338,75,NULL,'MAT, I, raw','IC 1933',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30704,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30704,31.61,0.43,21,8338,75,NULL,'MAT, I, inv','IC 1933',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30705,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30705,31.67,0.43,21.6,8338,75,NULL,'MAT, I, cor','IC 1933',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30706,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30706,32.15,0.46,26.9,8338,NULL,NULL,'J','IC 1933',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30707,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30707,32.25,0.47,28.1,8338,NULL,NULL,'H','IC 1933',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30708,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30708,32.27,0.45,28.4,8338,NULL,NULL,'K','IC 1933',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30709,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 11249','RN',30709,41.61,0.59,1990,8339,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 11249',0.053657,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30710,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30710,36.83,0.77,233,8340,70,NULL,NULL,'2MASX J03254330-6913019',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.6I',0.2,NULL,NULL,NULL,NULL,NULL,1,51.4307083,-69.21719,0.069,NULL,36448167933,569502623,8898478,14.6),(30711,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',30711,33.28,0.49,45.3,8341,75,NULL,'IR','UGC 02728',NULL,'2011yCatp016004901K',2011,1,1.12,'Matthews (2000A&AS..143..421M) detects another feature at v= 906 km/sec.','G',0.000063,NULL,'17.',0.17,'Sd',NULL,NULL,NULL,NULL,1,51.4330417,42.06258,0.925,NULL,68567595311,1071368676,16740135,17),(30712,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',30712,37.5,0.46,316,8342,70,NULL,NULL,'SDSS J032545.92+001017.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000072,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,51.441375,0.17164,0.249,NULL,64987468648,1015429197,15866081,18.7),(30713,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 02808','R',30713,41.19,0.26,1320,8343,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02808',0.3141,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,51.459417,0.29222,0.265,NULL,64987492581,1015429571,15866087,NULL),(30714,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 02808','R',30714,41.28,0.18,1370,8343,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 02808',0.3141,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30715,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30715,33.77,0.4,56.8,8344,NULL,NULL,'mean','UGC 02730',NULL,'2007A&A...465...71T',2007,1,1.4,'Fisher, et al. (1995, ApJS, 100, 69) give v = 6965 +/- 32 km/sec.','G',0.000026,NULL,'14.9',0.3,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,51.468083,40.74878,0.985,NULL,68553997769,1071156215,16736815,14.9),(30716,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30716,34.12,0.45,66.8,8344,NULL,NULL,'K','UGC 02730',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30717,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',30717,34.14,0.49,67.2,8344,75,NULL,'IR','UGC 02730',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30718,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30718,34.17,0.47,68.2,8344,NULL,NULL,'H','UGC 02730',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30719,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30719,34.23,0.46,70.2,8344,NULL,NULL,'J','UGC 02730',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30720,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30720,34.34,0.2,73.8,8344,74.4,NULL,NULL,'UGC 02730',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30721,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30721,34.37,0.43,74.7,8344,75,NULL,'3.6 micron, color corrected','UGC 02730',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30722,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30722,34.37,0.43,74.8,8344,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02730',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30723,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 18802',NULL,30723,40.78,0.19,1430,8345,70,NULL,'SN photometric redshift distance, z photo =0.416 +/- 0.051','SDSS-II SN 18802',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,51.4757916667,-0.52689,0.241,NULL,36814452195,575225815,8987903,NULL),(30724,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30724,31.54,0.3,20.3,8346,NULL,NULL,'TOM(g) = -7.2 mag','IC 1919',NULL,'2010ApJ...717..603V',2010,1,1.6,NULL,'G',0.000057,NULL,'13.91',1.2,'SA(rs)0-?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,51.509333,-32.89456,0,NULL,38563346913,602552295,9414879,13.91),(30725,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30725,31.79,0.29,22.8,8346,NULL,NULL,'TOM(z) = -8.53 mag','IC 1919',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30726,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30726,30.68,0.5,13.7,8346,NULL,NULL,'KS','IC 1919',NULL,'2002ApJ...564..216L',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30727,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30727,31.31,0.17,18.3,8346,NULL,NULL,'I','IC 1919',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30728,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30728,31.46,0.14,19.6,8346,74.4,NULL,NULL,'IC 1919',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30729,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30729,31.49,0.07,19.8,8346,NULL,NULL,'HST ACS FCS','IC 1919',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30730,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30730,31.66,0.11,21.5,8346,NULL,NULL,'R','IC 1919',NULL,'2003A&A...398...63J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30731,'GC radius','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30731,31.52,0.31,20.2,8346,NULL,NULL,'HST ACS FCS','IC 1919',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30732,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30732,30.62,0.45,13.3,8346,NULL,NULL,'K','IC 1919',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30733,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30733,31.82,0.4,23.2,8346,NULL,NULL,'mean','IC 1919',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30734,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',30734,36.22,0.15,175,8347,70,NULL,NULL,'2MASX J03260242-0046188',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000063,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,51.510167,-0.772,0.253,NULL,36813832281,575216129,8987752,16.9),(30735,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30735,34.63,0.49,84.3,8348,70,NULL,NULL,'NGC 1329',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00011,NULL,'13.79',1.1,'SA(rs)0/a',NULL,NULL,NULL,NULL,1,51.5107916667,-17.5915,0.097,NULL,38008567197,593883862,9279435,13.79),(30736,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',30736,36.22,0.15,175,8349,70,NULL,NULL,'CGCG 390-090',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000157,NULL,'15.6',0.41,'BrClG','Group member',NULL,NULL,NULL,1,51.525667,-0.61572,0.229,NULL,36814412925,575225201,8987893,15.6),(30737,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 15525',NULL,30737,39.61,0.95,837,8350,70,NULL,'SN photometric redshift distance, z photo =0.219 +/- 0.147','SDSS-II SN 15525',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,51.527625,1.13072,0.273,NULL,64987313251,1015426769,15866043,NULL),(30738,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30738,35.21,NULL,110,8351,NULL,NULL,NULL,'FGC 0425',NULL,'2000BSAO...50....5K',2000,1,0.81,NULL,'G',0.000062,NULL,'17.5',0.08,'Sdm',NULL,NULL,NULL,NULL,1,51.551167,1.40703,0.285,NULL,65020417922,1015944030,15874125,17.5),(30739,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30739,35.51,NULL,127,8351,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0425',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30740,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30740,35.52,NULL,127,8351,NULL,NULL,'Dipole','FGC 0425',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30741,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30741,35.52,NULL,127,8351,NULL,NULL,'Dipole + Quadrupole','FGC 0425',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30742,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 21884',NULL,30742,40.56,0.22,1290,8352,70,NULL,'SN photometric redshift distance, z photo =0.366 +/- 0.050','SDSS-II SN 21884',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,51.5604583,-0.11386,0.237,NULL,36814060402,575219693,8987807,NULL),(30743,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 15074',NULL,30743,39.47,1.18,783,8353,70,NULL,'SN photometric redshift distance, z photo =0.203 +/- 0.183','SDSS-II SN 15074',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'G',NULL,'PHOT','21.6g',NULL,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,51.563667,0.22158,0.261,NULL,64986985432,1015421647,15865963,21.6),(30744,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30744,34.81,0.55,91.8,8354,70,NULL,NULL,'2MASX J03261531-0419034',NULL,'2014MNRAS.445.2677S',2014,1,0.88,NULL,'G',0.00015,NULL,'14.87',0.65,NULL,NULL,NULL,NULL,NULL,1,51.5637917,-4.31767,0.049,NULL,36842337659,575661525,8994711,14.87),(30745,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',30745,38.52,0.46,507,8355,70,NULL,NULL,'SDSS J032616.72-001513.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000068,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,51.5697083333,-0.25378,0.237,NULL,36814028799,575219199,8987799,18.7),(30746,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30746,31.7,0.24,21.9,8356,NULL,NULL,NULL,'NGC 1332',NULL,'2001AJ....122.1251K',2001,1,4.7,NULL,'G',0.000033,NULL,'12.11',1.4,'S(s)0-: sp','in a pair',NULL,NULL,NULL,1,51.571875,-21.33522,0.033,NULL,38035157640,594299338,9285927,12.11),(30747,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30747,31.7,0.4,21.9,8356,NULL,NULL,'TOM(V) = -7.3 mag','NGC 1332',NULL,'2009ApJ...690..512H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30748,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30748,31.8,0.18,22.9,8356,NULL,NULL,'I','NGC 1332',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30749,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30749,31.95,0.12,24.6,8356,74.4,NULL,NULL,'NGC 1332',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30750,'Faber-Jackson','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30750,31.14,0.46,16.9,8356,95,NULL,'Michard 1979a','NGC 1332',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30751,'Faber-Jackson','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30751,31.23,0.37,17.6,8356,95,NULL,'Weighted Mean','NGC 1332',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30752,'Faber-Jackson','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30752,31.48,0.63,19.8,8356,95,NULL,'Michard 1979b, c','NGC 1332',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30753,'Faber-Jackson','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',30753,32.66,NULL,34,8356,NULL,NULL,'LEDA [April 2006]','NGC 1332',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30754,'Faber-Jackson','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30754,33.5,0.81,50.1,8356,55,NULL,'Visvanathan & Sandage 1979','NGC 1332',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30755,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30755,31.95,0.12,24.6,8356,74.4,NULL,NULL,'NGC 1332',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30756,'Tertiary','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30756,30.78,0.21,14.3,8356,95,NULL,NULL,'NGC 1332',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30757,'Tully est','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30757,31.24,0.8,17.7,8356,75,NULL,'B','NGC 1332',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30758,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 19180',NULL,30758,39.88,0.34,947,8357,70,NULL,'SN photometric redshift distance, z photo =0.252 +/- 0.051','SDSS-II SN 19180',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'G',NULL,'PHOT','23.6g',NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,51.573583,0.95842,0.269,NULL,64987321351,1015426896,15866045,23.6),(30759,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30759,35.71,0.2,139,8358,74.4,NULL,NULL,'IC 1918',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000107,NULL,'15.2',0.2,NULL,NULL,NULL,NULL,NULL,1,51.5745417,4.54103,0.329,NULL,65027861968,1016060343,15875942,15.2),(30760,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',30760,36.22,0.15,175,8359,70,NULL,NULL,'2MASX J03262034-0041004',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000078,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,51.584875,-0.68342,0.229,NULL,36814239387,575222490,8987851,17.2),(30761,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',30761,38.23,0.46,442,8360,70,NULL,NULL,'2MASX J03262083-0629016',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000077,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,51.58675,-6.48372,0.129,NULL,36803879094,575060610,8985322,18.5),(30762,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',30762,36.22,0.15,175,8361,70,NULL,NULL,'2MASX J03262321-0038514',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000103,NULL,'16.2g',0.32,'E0',NULL,NULL,NULL,NULL,1,51.5967917,-0.64764,0.229,NULL,36814236422,575222444,8987850,16.2),(30763,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30763,36.45,0.56,195,8362,70,NULL,NULL,'2MASX J03262669-6357039',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'16.3b',0.27,NULL,NULL,NULL,NULL,NULL,1,51.611,-63.951,0.157,NULL,36463584373,569743505,8902242,16.3),(30764,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30764,33.52,0.58,50.6,8363,NULL,NULL,NULL,'UGC 02736',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000314,NULL,'14.4',0.3,'Sab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,51.614875,40.50792,0.821,NULL,68554014544,1071156477,16736819,14.4),(30765,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30765,33.56,0.2,51.5,8363,74.4,NULL,NULL,'UGC 02736',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30766,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30766,33.59,0.47,52.3,8363,NULL,NULL,'H','UGC 02736',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30767,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30767,33.78,0.45,56.9,8363,NULL,NULL,'K','UGC 02736',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30768,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30768,33.8,0.46,57.5,8363,NULL,NULL,'J','UGC 02736',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30769,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30769,33.87,0.5,59.5,8363,NULL,NULL,'Malmquist cor.','UGC 02736',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30770,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30770,34.54,0.4,80.9,8363,NULL,NULL,'mean','UGC 02736',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30771,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30771,31.5,0.12,20,8364,74.4,NULL,NULL,'NGC 1331',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000067,NULL,'14.33',0.9,'E2:','in a pair',NULL,NULL,NULL,1,51.617875,-21.35531,0.033,NULL,38035151460,594299241,9285925,14.33),(30772,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30772,31.8,0.37,22.9,8364,NULL,NULL,'I','NGC 1331',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30773,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30773,31.5,0.12,20,8364,74.4,NULL,NULL,'NGC 1331',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30774,'Tully est','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30774,31.24,0.8,17.7,8364,75,NULL,'B','NGC 1331',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30775,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30775,31.54,0.4,20.4,8364,NULL,NULL,'mean','NGC 1331',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30776,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30776,32.21,0.45,27.6,8364,NULL,NULL,'K','NGC 1331',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30777,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30777,31.19,0.07,17.3,8365,NULL,NULL,'TOM(g) = -7.2 mag','NGC 1336',NULL,'2010ApJ...717..603V',2010,1,2.1,NULL,'G',0.00001,NULL,'13.1B',1.5,'SA0-','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,51.634125,-35.71356,0,NULL,38594921641,603045650,9422588,13.1),(30778,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30778,31.48,0.07,19.8,8365,NULL,NULL,'TOM(z) = -8.53 mag','NGC 1336',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30779,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30779,31.31,0.08,18.3,8365,NULL,NULL,'HST ACS FCS','NGC 1336',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30780,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30780,31.36,0.12,18.7,8365,74.4,NULL,NULL,'NGC 1336',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30781,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30781,31.38,0.21,18.9,8365,NULL,NULL,'I','NGC 1336',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30782,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30782,31.55,0.23,20.4,8365,NULL,NULL,'KS','NGC 1336',NULL,'2002ApJ...564..216L',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30783,'GC radius','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30783,31.7,0.09,21.8,8365,NULL,NULL,'HST ACS FCS','NGC 1336',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30784,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30784,31.36,0.12,18.7,8365,74.4,NULL,NULL,'NGC 1336',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30785,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30785,31.83,0.4,23.3,8365,NULL,NULL,'mean','NGC 1336',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30786,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30786,32.55,0.45,32.4,8365,NULL,NULL,'K','NGC 1336',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30787,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 21381',NULL,30787,38.98,1.25,624,8366,70,NULL,'SN photometric redshift distance, z photo =0.158 +/- 0.146','SDSS-II SN 21381',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,51.665125,-0.21717,0.241,NULL,36814180790,575221574,8987837,NULL),(30788,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30788,36.51,0.53,200,8367,70,NULL,NULL,'2MASX J03264090-2329463',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.51',0.35,NULL,NULL,NULL,NULL,NULL,1,51.6704583,-23.49617,0.021,NULL,38024647370,594135115,9283361,16.51),(30789,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 20788','R',30789,41.96,0.31,1770,8368,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J032641.62-002839.9',0.394,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,NULL,'21.1g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,51.6734583,-0.47775,0.229,NULL,36814100482,575220320,8987817,21.1),(30790,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 20788','R',30790,42.16,0.32,1940,8368,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J032641.62-002839.9',0.394,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30791,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 20788',NULL,30791,41.9,0.28,2400,8368,70,NULL,'SALT 2','SDSS J032641.62-002839.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30792,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 20788',NULL,30792,41.96,0.28,2470,8368,70,NULL,'SALT 2, Malmquist cor.','SDSS J032641.62-002839.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30793,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',30793,36.22,0.15,175,8369,70,NULL,NULL,'2MASX J03264319-0046094',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000101,NULL,'15.5g',0.5,'E0',NULL,NULL,NULL,NULL,1,51.68,-0.76944,0.225,NULL,36813759419,575214990,8987734,15.5),(30794,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','PS1 SN PS11br','N',30794,41.29,0.24,1390,8370,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11br HOST',0.2996,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30795,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30795,34.9,0.2,95.5,8371,74.4,NULL,NULL,'UGC 02740',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.00002,NULL,'14.78',0.7,'Sb:',NULL,NULL,NULL,NULL,1,51.6895,7.71458,0.589,NULL,65001806739,1015653230,15869581,14.78),(30796,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30796,35.27,0.15,113,8371,NULL,NULL,NULL,'UGC 02740',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30797,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30797,34.92,0.49,96.2,8372,70,NULL,NULL,'2MASX J03265014-0422004',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'15.31',0.45,NULL,NULL,NULL,NULL,NULL,1,51.709,-4.36689,0.049,NULL,36842626181,575666034,8994781,15.31),(30798,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 02342',NULL,30798,39.78,0.26,904,8373,70,NULL,'SN photometric redshift distance, z photo =0.239 +/- 0.036','SDSS-II SN 02342',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','20.0g',0.08,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,51.716375,1.23853,0.265,NULL,64987116097,1015423689,15865995,20),(30799,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30799,34.44,0.53,77.3,8374,70,NULL,NULL,'ESO 031- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.16',0.3,'S0',NULL,NULL,NULL,NULL,1,51.7220417,-72.93553,0.129,NULL,36410721054,568917516,8889336,15.16),(30800,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30800,31.55,0.28,20.4,8375,NULL,NULL,'R','ESO 358- G 004',NULL,'2003A&A...398...63J',2003,1,1.1,NULL,'G',NULL,NULL,'16.29',0.9,'E0',NULL,NULL,NULL,NULL,1,51.7254583,-35.51789,0,NULL,38594901365,603045333,9422583,16.29),(30801,'Tully est','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30801,32.34,0.8,29.4,8376,75,NULL,NULL,'UGC 02729',NULL,'1988NBGC.C....0000T',1988,1,3.5,NULL,'G',0.000003,NULL,'18.',2.5,'S0/a',NULL,NULL,NULL,NULL,1,51.7354583,68.58125,NULL,NULL,66559920555,1039998758,16249980,18),(30802,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30802,36.27,0.55,180,8377,70,NULL,NULL,'2MASX J03265747-3636009',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'17.24',0.21,NULL,NULL,NULL,NULL,NULL,1,51.739417,-36.60022,0,NULL,38603254428,603175850,9424622,17.24),(30803,'Tully est','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30803,32.49,0.8,31.5,8378,75,NULL,NULL,'UGCA 069',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.000023,NULL,'12.8I',0.5,'Im?',NULL,NULL,NULL,NULL,1,51.744625,72.85606,1.401,NULL,66391604904,1037368826,16208887,12.8),(30804,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30804,31.72,0.2,22.1,8378,74.4,NULL,NULL,'UGCA 069',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30805,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30805,31.78,0.4,22.7,8378,NULL,NULL,NULL,'UGCA 069',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30806,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',30806,38.38,0.46,475,8379,70,NULL,NULL,'2MASX J03270046-0025014',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000079,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,51.7519583,-0.41722,0.229,NULL,36814105937,575220405,8987818,18.7),(30807,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 16130',NULL,30807,40.29,0.22,1140,8380,70,NULL,'SN photometric redshift distance, z photo =0.315 +/- 0.041','SDSS-II SN 16130',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,51.774833,0.15772,0.273,NULL,64987028850,1015422325,15865973,NULL),(30808,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2008hm',NULL,30808,34.85,0.22,91.5,8381,73.8,NULL,'SALT 2 (SNANA)','2MFGC 02845',0.0194,'2014ApJ...795...44R',2014,1,0.78,NULL,'G',0.000077,NULL,'11.7K',0.22,'Spiral',NULL,NULL,NULL,NULL,1,51.795083,46.94342,NULL,NULL,68274897060,1066795266,16668676,11.7),(30809,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30809,31.65,0.15,21.4,8382,NULL,NULL,'TOM(g) = -7.2 mag','ESO 358- G 006',NULL,'2010ApJ...717..603V',2010,1,1.2,NULL,'G',0.000057,NULL,'13.9B',0.6,'S0(9),N','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,51.8251666667,-34.52644,0,NULL,38564016916,602562764,9415043,13.9),(30810,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30810,31.97,0.18,24.8,8382,NULL,NULL,'TOM(z) = -8.53 mag','ESO 358- G 006',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30811,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30811,31.35,0.32,18.6,8382,NULL,NULL,'I','ESO 358- G 006',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30812,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30812,31.58,0.14,20.7,8382,74.4,NULL,NULL,'ESO 358- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30813,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30813,31.6,0.08,20.9,8382,NULL,NULL,'HST ACS FCS','ESO 358- G 006',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30814,'GC radius','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30814,31.52,0.24,20.2,8382,NULL,NULL,'HST ACS FCS','ESO 358- G 006',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30815,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30815,34.86,0.2,93.8,8383,74.4,NULL,NULL,'FGC 0428',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.000026,NULL,'17.0',0.1,'Scd',NULL,NULL,NULL,NULL,1,51.832083,3.92028,0.305,NULL,65028354236,1016068034,15876063,17),(30816,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30816,34.9,NULL,95.3,8383,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0428',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30817,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30817,34.9,NULL,95.7,8383,NULL,NULL,'Dipole + Quadrupole','FGC 0428',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30818,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30818,34.91,NULL,96.1,8383,NULL,NULL,'Dipole','FGC 0428',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30819,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30819,34.98,NULL,99.2,8383,NULL,NULL,NULL,'FGC 0428',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30820,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 16421','R',30820,40.89,0.33,1160,8384,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006pg','SN 2006pg',0.302,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,51.8362916667,1.08967,0.265,NULL,64990053727,1015469589,15866712,NULL),(30821,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 16421','R',30821,40.91,0.24,1170,8384,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006pg','SN 2006pg',0.302,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30822,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30822,34.07,0.49,65.1,8385,70,NULL,NULL,'IC 1928',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.00009,NULL,'14.23',0.4,'Sab? sp','Group member',NULL,NULL,NULL,1,51.871583,-21.56017,0.037,NULL,38035049145,594297642,9285900,14.23),(30823,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 16153',NULL,30823,39.4,0.94,758,8386,70,NULL,'SN photometric redshift distance, z photo =0.196 +/- 0.128','SDSS-II SN 16153',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.5g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,51.8738333333,0.89556,0.293,NULL,64990029136,1015469205,15866706,22.5),(30824,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 11159','RN',30824,37.65,0.2,299,8387,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 00846 HOST',0.133992,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30825,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 00846','RN',30825,37.69,0.2,304,8387,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 00846 HOST',0.133992,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30826,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 11159','RN',30826,38.95,0.11,543,8387,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 00846 HOST',0.133992,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30827,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 00846','RN',30827,38.99,0.11,555,8387,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 00846 HOST',0.133992,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30828,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 15075',NULL,30828,40.5,0.18,1260,8388,70,NULL,'SN photometric redshift distance, z photo =0.353 +/- 0.039','SDSS-II SN 15075',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.9g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,51.886125,0.34683,0.261,NULL,64987040915,1015422514,15865976,21.9),(30829,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',30829,35.66,0.49,136,8389,75,NULL,'IR','FGC 0429',NULL,'2011yCatp016004901K',2011,1,1.18,NULL,'G',0.000033,NULL,'17.72',0.07,'Scd',NULL,NULL,NULL,NULL,1,51.894333,8.99517,0.573,NULL,65009838908,1015778732,15871542,17.72),(30830,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30830,36.56,NULL,205,8389,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0429',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30831,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30831,36.57,NULL,206,8389,NULL,NULL,'Dipole + Quadrupole','FGC 0429',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30832,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30832,36.58,NULL,207,8389,NULL,NULL,NULL,'FGC 0429',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30833,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30833,36.59,NULL,208,8389,NULL,NULL,'Dipole','FGC 0429',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30834,'IRAS','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30834,31.76,0.8,22.5,8390,75,NULL,'MAT, I','ESO 548- G 021',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000033,NULL,'14.86',0.3,'SB(s)dm?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,51.8970417,-21.22839,0.053,NULL,38035205160,594300080,9285938,14.86),(30835,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30835,31.06,0.32,16.3,8390,85,NULL,'I, inv','ESO 548- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30836,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30836,31.11,0.32,16.7,8390,85,NULL,'I, raw','ESO 548- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30837,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30837,31.43,0.43,19.3,8390,75,NULL,'MAT, I, inv','ESO 548- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30838,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30838,31.51,0.43,20.1,8390,75,NULL,'MAT, I, raw','ESO 548- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30839,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30839,31.71,0.1,22,8390,NULL,NULL,NULL,'ESO 548- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30840,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30840,31.71,0.43,22,8390,75,NULL,'MAT, I, cor','ESO 548- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30841,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30841,31.73,0.43,22.2,8390,75,NULL,'3.6 micron, color + selection bias corrected','ESO 548- G 021',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30842,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30842,31.78,0.2,22.7,8390,74.4,NULL,NULL,'ESO 548- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30843,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30843,31.79,0.43,22.8,8390,75,NULL,'3.6 micron, color corrected','ESO 548- G 021',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30844,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 04586','RN',30844,41.83,0.42,2040,8391,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04586',0.139764,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30845,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 04586','RN',30845,42.76,0.52,3130,8391,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04586',0.139764,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30846,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 06074','RN',30846,42.44,0.21,2300,8392,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06074',0.337557,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30847,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 06074','RN',30847,42.56,0.13,2430,8392,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06074',0.337557,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30848,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 18065','RN',30848,42.58,0.23,2200,8393,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 18065',0.487461,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30849,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30849,33.74,0.42,56,8394,NULL,NULL,NULL,'UGC 02743',NULL,'2009ApJS..182..474S',2009,1,1.34,NULL,'G',NULL,NULL,'16.0',0.16,'Sc',NULL,NULL,NULL,NULL,1,51.950167,40.03403,0.793,NULL,68687115543,1073236180,16769315,16),(30850,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30850,33.78,0.2,57,8394,74.4,NULL,NULL,'UGC 02743',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30851,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30851,34.1,0.36,66,8394,NULL,NULL,'Malmquist cor.','UGC 02743',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30852,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30852,34.43,NULL,77.1,8394,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02743',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30853,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30853,34.44,NULL,77.4,8394,NULL,NULL,'Dipole + Quadrupole','UGC 02743',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30854,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30854,34.45,NULL,77.6,8394,NULL,NULL,'Dipole','UGC 02743',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30855,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',30855,34.47,0.49,78.4,8394,75,NULL,'IR','UGC 02743',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30856,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30856,34.5,NULL,79.3,8394,NULL,NULL,NULL,'UGC 02743',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30857,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30857,35.31,0.45,115,8395,NULL,NULL,'K','UGC 02748',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000197,NULL,'14.85',1.1,'E pec?;WLRG    NLRG',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,51.9757916667,2.56167,0.293,NULL,65022195382,1015971802,15874559,14.85),(30858,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30858,35.54,0.4,128,8395,NULL,NULL,'mean','UGC 02748',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30859,'Tully est','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30859,31.14,0.8,16.9,8396,75,NULL,'B','NGC 1341',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.00001,NULL,'13.21',1.3,'SAB(rs)ab      HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,51.9934166667,-37.15,0,NULL,38603175638,603174619,9424603,13.21),(30860,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',30860,38.34,0.46,466,8397,70,NULL,NULL,'2MASX J03280312-0031087',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000073,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,52.012917,-0.51894,0.225,NULL,36816926213,575264472,8988507,18.1),(30861,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30861,34.64,0.4,84.8,8398,NULL,NULL,'mean','MCG -01-09-040',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.00002,NULL,'14.67',0.4,'SBb',NULL,NULL,NULL,NULL,1,52.014625,-4.81825,0.073,NULL,36839975481,575624616,8994134,14.67),(30862,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30862,34.85,0.47,93.3,8398,NULL,NULL,'H','MCG -01-09-040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30863,'IRAS','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30863,31.01,0.8,15.9,8399,75,NULL,'MAT, I','NGC 1337',NULL,'1997ApJS..109..333W',1997,1,5.8,NULL,'G',0.000007,NULL,'13.24',1.5,'SA(s)cd',NULL,NULL,NULL,NULL,1,52.024833,-8.38861,0.149,NULL,36806675950,575104311,8986004,13.24),(30864,'IRAS','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30864,31.03,0.8,16.1,8399,75,NULL,'A82, H','NGC 1337',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30865,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30865,30.3,0.4,11.5,8399,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 1337',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30866,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30866,30.32,0.32,11.6,8399,85,NULL,'I, inv','NGC 1337',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30867,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30867,30.34,0.32,11.7,8399,85,NULL,'I, raw','NGC 1337',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30868,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30868,30.38,0.35,11.9,8399,NULL,NULL,NULL,'NGC 1337',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30869,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30869,30.38,0.4,11.9,8399,73,NULL,'opt','NGC 1337',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30870,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30870,30.62,0.43,13.3,8399,75,NULL,'MAT, I, raw','NGC 1337',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30871,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30871,30.67,0.43,13.6,8399,75,NULL,'MAT, I, inv','NGC 1337',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30872,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30872,30.71,0.2,13.9,8399,74.4,NULL,NULL,'NGC 1337',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30873,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30873,30.85,0.43,14.8,8399,75,NULL,'3.6 micron, color corrected','NGC 1337',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30874,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30874,30.88,0.4,15,8399,75,NULL,'B','NGC 1337',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30875,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30875,30.93,0.47,15.4,8399,75,NULL,'A82, H, inv','NGC 1337',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30876,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30876,30.96,0.47,15.5,8399,75,NULL,'A82, H, raw','NGC 1337',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30877,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30877,30.96,0.12,15.6,8399,NULL,NULL,NULL,'NGC 1337',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30878,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30878,30.98,0.43,15.7,8399,75,NULL,'MAT, I, cor','NGC 1337',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30879,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30879,30.99,0.43,15.8,8399,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1337',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30880,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30880,31.33,0.47,18.4,8399,75,NULL,'A82, H, cor','NGC 1337',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30881,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30881,31.34,0.4,18.5,8399,NULL,NULL,'mean','NGC 1337',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30882,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30882,31.42,0.46,19.3,8399,NULL,NULL,'J','NGC 1337',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30883,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30883,31.52,0.47,20.2,8399,NULL,NULL,'H','NGC 1337',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30884,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30884,31.64,0.45,21.3,8399,NULL,NULL,'K','NGC 1337',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30885,'Cepheids','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30885,31.73,0.18,22.2,8400,NULL,NULL,'HST KP Calibrated, K\'','NGC 1339',NULL,'2000ApJ...529..745F',2000,1,1.9,NULL,'G',0.00001,NULL,'12.5B',1.4,'E4','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,52.027417,-32.28611,0,NULL,38571341559,602677211,9416831,12.5),(30886,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30886,31.22,0.11,17.5,8400,NULL,NULL,'TOM(g) = -7.2 mag','NGC 1339',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30887,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30887,31.48,0.11,19.8,8400,NULL,NULL,'TOM(z) = -8.53 mag','NGC 1339',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30888,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30888,30.82,0.2,14.6,8400,NULL,NULL,'I','NGC 1339',NULL,'1991ApJ...373L...1T',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30889,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30889,31.34,0.14,18.5,8400,NULL,NULL,'I','NGC 1339',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30890,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30890,31.45,0.35,19.5,8400,NULL,NULL,'I','NGC 1339',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30891,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30891,31.47,0.08,19.7,8400,NULL,NULL,'HST ACS FCS','NGC 1339',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30892,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30892,31.55,0.12,20.4,8400,74.4,NULL,NULL,'NGC 1339',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30893,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30893,31.57,0.15,20.6,8400,NULL,NULL,'K','NGC 1339',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30894,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30894,31.61,0.35,21,8400,NULL,NULL,'I','NGC 1339',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30895,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30895,31.61,0.35,21,8400,NULL,NULL,NULL,'NGC 1339',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30896,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30896,31.66,0.37,21.5,8400,NULL,NULL,'HST KP Calibrated, I','NGC 1339',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30897,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30897,31.69,0.08,21.8,8400,NULL,NULL,'KS','NGC 1339',NULL,'2002ApJ...564..216L',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30898,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30898,31.72,0.35,22,8400,NULL,NULL,'Malmquist cor.','NGC 1339',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30899,'GC radius','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30899,31.28,0.07,18.1,8400,NULL,NULL,'HST ACS FCS','NGC 1339',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30900,'D-Sigma','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30900,31.26,0.4,17.8,8400,75,NULL,'Edat, raw','NGC 1339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30901,'D-Sigma','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30901,31.29,0.4,18.1,8400,75,NULL,'Edat, cor','NGC 1339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30902,'Faber-Jackson','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30902,31.47,0.65,19.7,8400,95,NULL,'Weighted Mean','NGC 1339',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30903,'Faber-Jackson','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30903,32.8,0.81,36.3,8400,55,NULL,'Visvanathan & Sandage 1979','NGC 1339',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30904,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30904,31.55,0.12,20.4,8400,74.4,NULL,NULL,'NGC 1339',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30905,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30905,32.09,0.41,26.2,8400,NULL,NULL,'Malmquist cor.','NGC 1339',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30906,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30906,32.13,NULL,26.7,8400,NULL,NULL,NULL,'NGC 1339',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30907,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30907,32.25,0.41,28.1,8400,NULL,NULL,NULL,'NGC 1339',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30908,'Tully est','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30908,30.82,0.8,14.6,8400,75,NULL,'B','NGC 1339',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30909,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30909,31.76,0.4,22.5,8400,NULL,NULL,'mean','NGC 1339',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30910,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30910,32.14,0.45,26.8,8400,NULL,NULL,'K','NGC 1339',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30911,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 16666','RN',30911,39.62,0.16,743,8401,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16666',0.132939,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30912,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 16666','RN',30912,39.78,0.25,798,8401,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16666',0.132939,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30913,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 21612','RN',30913,47.42,0.91,25800,8402,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 21612',0.179696,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30914,'Cepheids','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30914,31.57,0.13,20.6,8403,NULL,NULL,'HST KP Calibrated, K\'','Eridanus GROUP',NULL,'2000ApJ...529..745F',2000,1,NULL,NULL,'GGroup',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,52.057375,-20.74439,0.049,NULL,38035998833,594312481,9286132,NULL),(30915,'Cepheids','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30915,31.69,0.11,21.8,8403,NULL,NULL,'HST KP Calibrated, K\'','Eridanus GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30916,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30916,31.99,0.11,25,8403,NULL,NULL,'HST KP Calibrated, I','Eridanus GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30917,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30917,32.01,0.1,25.2,8403,NULL,NULL,'HST KP Calibrated, I','Eridanus GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30918,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 03376','RN',30918,42.25,0.41,2330,8404,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03376',0.208074,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30919,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 03376','RN',30919,42.26,0.34,2340,8404,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03376',0.208074,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30920,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 14722',NULL,30920,39.09,0.76,656,8405,70,NULL,'SN photometric redshift distance, z photo =0.167 +/- 0.080','SDSS-II SN 14722',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,52.055333,-0.50658,0.225,NULL,36817050056,575266407,8988537,NULL),(30921,'Tully est','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30921,31.71,0.8,21.9,8406,75,NULL,'B','UGCA 073',NULL,'1988NBGC.C....0000T',1988,1,1,NULL,'G',0.000023,NULL,'15.04',0.5,'E+?',NULL,NULL,NULL,NULL,1,52.0605417,-17.41958,0.109,NULL,38007816496,593872132,9279252,15.04),(30922,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 16781','R',30922,41.25,0.3,1340,8407,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006qb','SN 2006qb',0.329,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,52.0610417,-0.20097,0.245,NULL,36816874419,575263662,8988494,NULL),(30923,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 16781','R',30923,41.28,0.38,1360,8407,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006qb','SN 2006qb',0.329,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30924,'Cepheids','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30924,31.35,0.16,18.6,8408,NULL,NULL,'HST KP Calibrated, K\'','NGC 1344',NULL,'2000ApJ...529..745F',2000,1,6,NULL,'G',0.00005,NULL,'11.27',3.5,'E5','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,52.0819583,-31.06817,0,NULL,38574439854,602725622,9417587,11.27),(30925,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30925,31.09,0.25,16.5,8408,NULL,NULL,'TOM(V) = -7.29 mag, Secker 1992','NGC 1344',NULL,'1996ApJ...465L..19B',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30926,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30926,31.34,0.35,18.5,8408,NULL,NULL,'HST KP Calibrated, V','NGC 1344',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30927,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30927,31.4,0.25,19.1,8408,NULL,NULL,'TOM(V) = -7.60 mag, Sandage & Tammann 1995','NGC 1344',NULL,'1996ApJ...465L..19B',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30928,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30928,31.4,0.25,19.1,8408,NULL,NULL,NULL,'NGC 1344',NULL,'2001A&A...371..875G',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30929,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30929,31.58,0.1,20.7,8408,NULL,NULL,'TOM(g) = -7.2 mag','NGC 1344',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30930,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30930,32,0.11,25.1,8408,NULL,NULL,'TOM(z) = -8.53 mag','NGC 1344',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30931,'PNLF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30931,31.4,0.18,19.1,8408,NULL,NULL,NULL,'NGC 1344',NULL,'2005ApJ...635..290T',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30932,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30932,30.78,0.13,14.3,8408,NULL,NULL,'I','NGC 1344',NULL,'1991ApJ...373L...1T',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30933,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30933,30.8,0.2,14.5,8408,NULL,NULL,'I','NGC 1344',NULL,'1993A&A...275..433B',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30934,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30934,31.17,0.09,17.1,8408,NULL,NULL,'I','NGC 1344',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30935,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30935,31.19,0.12,17.3,8408,NULL,NULL,'K','NGC 1344',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30936,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30936,31.32,0.3,18.4,8408,NULL,NULL,'I','NGC 1344',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30937,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30937,31.35,0.12,18.6,8408,74.4,NULL,NULL,'NGC 1344',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30938,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30938,31.43,0.1,19.3,8408,NULL,NULL,'KS','NGC 1344',NULL,'2002ApJ...564..216L',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30939,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30939,31.48,0.3,19.8,8408,NULL,NULL,'I','NGC 1344',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30940,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30940,31.53,0.09,20.2,8408,NULL,NULL,'J03','NGC 1344',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30941,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30941,31.53,0.09,20.2,8408,NULL,NULL,'M06','NGC 1344',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30942,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30942,31.53,0.31,20.2,8408,NULL,NULL,'HST KP Calibrated, I','NGC 1344',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30943,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30943,31.56,0.13,20.5,8408,NULL,NULL,'BV A01','NGC 1344',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30944,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30944,31.6,0.07,20.9,8408,NULL,NULL,'HST ACS FCS','NGC 1344',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30945,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30945,31.61,0.08,21,8408,NULL,NULL,'I','NGC 1344',NULL,'2010ApJ...724..657B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30946,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30946,31.69,0.09,21.8,8408,NULL,NULL,'T01','NGC 1344',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30947,'GC radius','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30947,31.52,0.16,20.2,8408,NULL,NULL,'HST ACS FCS','NGC 1344',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30948,'D-Sigma','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30948,31.26,0.4,17.8,8408,75,NULL,'Edat, raw','NGC 1344',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30949,'D-Sigma','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30949,31.29,0.4,18.1,8408,75,NULL,'Edat, cor','NGC 1344',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30950,'Faber-Jackson','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30950,30.62,0.37,13.3,8408,95,NULL,'Weighted Mean','NGC 1344',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30951,'Faber-Jackson','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30951,30.67,0.63,13.6,8408,95,NULL,'Michard 1979b, c','NGC 1344',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30952,'Faber-Jackson','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',30952,30.8,NULL,14.5,8408,NULL,NULL,'LEDA [April 2006]','NGC 1344',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30953,'Faber-Jackson','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30953,31.21,0.46,17.5,8408,95,NULL,'Michard 1979a','NGC 1344',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30954,'Faber-Jackson','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30954,31.26,0.81,17.9,8408,55,NULL,'Visvanathan & Sandage 1979','NGC 1344',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30955,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30955,30.67,NULL,13.6,8408,NULL,NULL,NULL,'NGC 1344',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30956,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30956,31.35,0.12,18.6,8408,74.4,NULL,NULL,'NGC 1344',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30957,'Tully est','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30957,30.71,0.8,13.9,8408,75,NULL,'B','NGC 1344',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30958,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30958,35.57,0.64,130,8409,70,NULL,NULL,'2MASX J03282042-1412332',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'16.31',0.3,NULL,NULL,NULL,NULL,NULL,1,52.085,-14.20933,0.145,NULL,38070075352,594844927,9294451,16.31),(30959,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2005jo',NULL,30959,39.5,0.13,646,8410,74.2,NULL,'SALT 2','SDSS J032821.60-001936.4',0.23,'2010ApJ...716..712A',2010,1,0.06,NULL,'G',0.005,NULL,'21.4g',0.03,NULL,NULL,NULL,NULL,NULL,1,52.09,-0.32681,0.245,NULL,36816836123,575263064,8988485,21.4),(30960,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2005jo',NULL,30960,39.65,0.12,853,8410,70,NULL,'Hubble residual 0.04 for z0.21900','SDSS J032821.60-001936.4',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30961,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2005jo',NULL,30961,40.24,0.09,909,8410,65,NULL,'SALT2','SDSS J032821.60-001936.4',0.23,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30962,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2005jo',NULL,30962,40.25,0.14,913,8410,70,NULL,'SALT 2','SDSS J032821.60-001936.4',0.23,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30963,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 07512','R',30963,40.24,0.21,918,8410,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005jo','SDSS J032821.60-001936.4',0.219,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30964,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2005jo',NULL,30964,40.3,NULL,934,8410,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 07512, SN 2005jo','SDSS J032821.60-001936.4',0.23,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30965,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2005jo',NULL,30965,40.32,0.04,943,8410,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 07512, SN 2005jo','SDSS J032821.60-001936.4',0.23,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30966,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2005jo',NULL,30966,40.35,0.2,957,8410,72,NULL,'SDSS 7512','SDSS J032821.60-001936.4',0.23,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30967,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 07512','R',30967,40.39,0.12,982,8410,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005jo','SDSS J032821.60-001936.4',0.219,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30968,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2005jo',NULL,30968,40.42,0.11,986,8410,65,NULL,'MLCS2k2','SDSS J032821.60-001936.4',0.23,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30969,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 06851','R',30969,40.99,0.25,1210,8411,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J032825.09-000255.6',0.3049,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',0.0001,NULL,'20.8g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,52.1045417,-0.04878,0.261,NULL,36815766840,575246356,8988224,20.8),(30970,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 06851','R',30970,41.07,0.15,1260,8411,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J032825.09-000255.6',0.3049,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30971,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 06851',NULL,30971,40.88,0.2,1500,8411,70,NULL,'SALT 2','SDSS J032825.09-000255.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30972,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 06851',NULL,30972,40.91,0.2,1520,8411,70,NULL,'SALT 2, Malmquist cor.','SDSS J032825.09-000255.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30973,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30973,37.42,0.58,305,8412,70,NULL,NULL,'2MASX J03282774-2320198',NULL,'2014MNRAS.445.2677S',2014,1,0.23,NULL,'G',0.00015,NULL,'15.8R',0.19,NULL,NULL,NULL,NULL,NULL,1,52.1155,-23.33881,0.013,NULL,38023124930,594111327,9282989,15.8),(30974,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','PS1 SN PS10bji','N',30974,39.12,0.11,582,8413,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10bji HOST',0.1476,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30975,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30975,36.11,0.65,167,8414,70,NULL,NULL,'2MASX J03283052-1625488',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.73',0.26,NULL,NULL,NULL,NULL,NULL,1,52.127,-16.43042,0.157,NULL,38007546467,593867913,9279186,16.73),(30976,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',30976,36.52,0.46,201,8415,70,NULL,NULL,'2MASX J03283316+0100247',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000096,NULL,'15.9g',0.45,'E0',NULL,NULL,NULL,NULL,1,52.1382916667,1.00669,0.273,NULL,64990524940,1015476952,15866827,15.9),(30977,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','PS1 SN PS11co','N',30977,40.4,0.18,978,8416,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11co HOST',0.2296,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30978,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 01588','RN',30978,39.28,0.21,623,8417,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 01588',0.150504,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30979,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 01588','RN',30979,39.31,0.14,632,8417,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 01588',0.150504,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30980,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 04455',NULL,30980,39.81,0.33,917,8418,70,NULL,'SN photometric redshift distance, z photo =0.243 +/- 0.047','SDSS-II SN 04455',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,52.1562083,-0.06056,0.261,NULL,36815778280,575246535,8988227,NULL),(30981,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30981,35.09,NULL,104,8419,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02750',NULL,'2010Ap&SS.325..163P',2010,1,1.79,NULL,'G',0.000007,NULL,'16.5',0.2,'Sbc',NULL,NULL,NULL,NULL,1,52.194167,36.55636,0.745,NULL,68699728203,1073433253,16772394,16.5),(30982,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30982,35.1,NULL,105,8419,NULL,NULL,'Dipole + Quadrupole','UGC 02750',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30983,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30983,35.1,NULL,105,8419,NULL,NULL,'Dipole','UGC 02750',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30984,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 14268',NULL,30984,39.79,0.26,907,8420,70,NULL,'SN photometric redshift distance, z photo =0.240 +/- 0.035','SDSS-II SN 14268',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,52.199333,0.39108,0.317,NULL,64990455666,1015475869,15866810,NULL),(30985,'IRAS','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30985,31.36,0.8,18.7,8421,75,NULL,'MAT, I','NGC 1351A',NULL,'1997ApJS..109..333W',1997,1,2.7,'The APM position is southeast of the center of the galaxy.','G',0.000007,NULL,'14.18',0.5,'SB(rs)bc: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,52.203,-35.17814,0,NULL,38594289128,603035767,9422433,14.18),(30986,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30986,31.28,0.43,18,8421,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1351A',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30987,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30987,31.38,0.1,18.9,8421,NULL,NULL,NULL,'NGC 1351A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30988,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30988,31.45,0.43,19.5,8421,75,NULL,'3.6 micron, color corrected','NGC 1351A',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30989,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30989,31.45,0.32,19.5,8421,85,NULL,'I, raw','NGC 1351A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30990,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30990,31.45,0.32,19.5,8421,85,NULL,'I, inv','NGC 1351A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30991,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30991,31.47,0.39,19.7,8421,73,NULL,'IR','NGC 1351A',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30992,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',30992,31.48,0.4,19.7,8421,75,NULL,NULL,'NGC 1351A',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30993,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30993,31.53,0.4,20.2,8421,NULL,NULL,NULL,'NGC 1351A',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30994,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30994,31.55,0.4,20.4,8421,NULL,NULL,'mean','NGC 1351A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30995,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30995,31.59,0.2,20.8,8421,74.4,NULL,NULL,'NGC 1351A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30996,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30996,31.73,0.43,22.2,8421,75,NULL,'MAT, I, raw','NGC 1351A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30997,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30997,31.76,0.43,22.5,8421,75,NULL,'MAT, I, inv','NGC 1351A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30998,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,30998,31.82,0.43,23.1,8421,75,NULL,'MAT, I, cor','NGC 1351A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(30999,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',30999,31.86,0.49,23.5,8421,75,NULL,'IR','NGC 1351A',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31000,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31000,32.34,0.47,29.4,8421,NULL,NULL,'H','NGC 1351A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31001,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31001,32.36,0.46,29.7,8421,NULL,NULL,'J','NGC 1351A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31002,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31002,32.38,0.45,30,8421,NULL,NULL,'K','NGC 1351A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31003,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31003,35.74,0.49,141,8422,70,NULL,NULL,'MCG -02-09-043',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000137,NULL,'15.39',0.5,NULL,NULL,NULL,NULL,NULL,1,52.2095417,-13.80211,0.161,NULL,38071127830,594861372,9294708,15.39),(31004,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31004,34.37,0.47,74.9,8423,70,NULL,NULL,'2MASX J03285067-2328386',NULL,'2014MNRAS.445.2677S',2014,1,0.92,'The APMBGC position is 9 arcsec southeast of the nucleus.','G',0.000127,NULL,'15.26',0.57,'S0',NULL,NULL,NULL,NULL,1,52.211167,-23.47733,0.009,NULL,38025138290,594142785,9283481,15.26),(31005,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 14837','RN',31005,43.68,0.26,3930,8424,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 14837',0.38641,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31006,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 14837','RN',31006,43.78,0.3,4110,8424,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 14837',0.38641,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31007,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 14687','RN',31007,41.47,0.23,1650,8425,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 14687',0.191503,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31008,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 14687','RN',31008,42.08,0.24,2190,8425,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 14687',0.191503,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31009,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 08327',NULL,31009,41.59,NULL,2080,8426,70,NULL,'SN photometric redshift distance, z photo =0.700 +/- 0.001','SDSS-II SN 08327',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','22.9g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,52.242417,0.67658,0.253,NULL,64990415083,1015475235,15866800,22.9),(31010,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 05178',NULL,31010,40.93,0.62,1530,8427,70,NULL,'SN photometric redshift distance, z photo =0.455 +/- 0.225','SDSS-II SN 05178',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.8g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,52.276125,0.71369,0.253,NULL,64990299449,1015473428,15866772,22.8),(31011,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',31011,36.87,0.46,237,8428,70,NULL,NULL,'2MASX J03291961-0628410',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000087,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,52.331625,-6.47794,0.105,NULL,36805062230,575079097,8985610,17.2),(31012,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2005hs',NULL,31012,40.13,0.15,817,8429,74.2,NULL,'SALT 2','SDSS J032922.15-010542.8',0.3,'2010ApJ...716..712A',2010,1,0.04,NULL,'G',0.0005,NULL,'22.5g',0.03,NULL,NULL,NULL,NULL,NULL,1,52.342333,-1.09522,0.185,NULL,36817545530,575274148,8988658,22.5),(31013,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2005hs',NULL,31013,40.16,0.16,1070,8429,70,NULL,'Hubble residual -0.05 for z0.30090','SDSS J032922.15-010542.8',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31014,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2005hs',NULL,31014,40.82,0.16,1120,8429,65,NULL,'SALT2','SDSS J032922.15-010542.8',0.3,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31015,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2005hs',NULL,31015,40.86,0.19,1140,8429,70,NULL,'SALT 2','SDSS J032922.15-010542.8',0.3,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31016,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 05391','R',31016,40.89,0.26,1160,8429,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005hs','SDSS J032922.15-010542.8',0.3009,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31017,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 05391','R',31017,40.98,0.19,1210,8429,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005hs','SDSS J032922.15-010542.8',0.3009,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31018,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2005hs',NULL,31018,41.05,0.16,1250,8429,65,NULL,'MLCS2k2','SDSS J032922.15-010542.8',0.3,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31019,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 13545','R',31019,40.06,0.25,848,8430,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J032922.25+003546.6',0.2141,'2014arXiv1401.3317S',2014,1,0.11,NULL,'G',0.0001,NULL,'19.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,52.34275,0.59628,0.317,NULL,64990332825,1015473950,15866780,19.4),(31020,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 13545',NULL,31020,39.88,0.2,946,8430,70,NULL,'SALT 2','SDSS J032922.25+003546.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31021,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 13545',NULL,31021,39.89,0.2,951,8430,70,NULL,'SALT 2, Malmquist cor.','SDSS J032922.25+003546.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31022,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 13545','R',31022,40.42,0.19,998,8430,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J032922.25+003546.6',0.2141,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31023,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31023,37.45,0.57,309,8431,70,NULL,NULL,'2MASX J03292386-7605223',NULL,'2014MNRAS.445.2677S',2014,1,0.18,NULL,'G',0.00015,NULL,'17.3b',0.11,NULL,NULL,NULL,NULL,NULL,1,52.349875,-76.08947,0.401,NULL,35644368305,556943254,8702238,17.3),(31024,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 20533','R',31024,40.8,0.2,1110,8432,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007qt','SDSS J032925.41-003848.1',0.302,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',NULL,NULL,'21.1g',0.03,NULL,NULL,NULL,NULL,NULL,1,52.355917,-0.64672,0.233,NULL,36817009436,575265772,8988527,21.1),(31025,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 20533','R',31025,40.95,0.16,1190,8432,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007qt','SDSS J032925.41-003848.1',0.302,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31026,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31026,36.43,0.55,193,8433,70,NULL,NULL,'FCCB 0598',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.000127,NULL,'16.71',0.33,'E(M32?)','Group non-member, background',NULL,NULL,NULL,1,52.3580417,-35.14175,0,NULL,38564082252,602563785,9415059,16.71),(31027,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 1992bs',NULL,31027,36.75,0.16,211,8434,74.2,NULL,'SALT 2','FCCB 0602',0.063,'2010ApJ...716..712A',2010,1,0.48,NULL,'G',0.00015,NULL,'15.3',0.32,'Sc(s)II','Group non-member, background',NULL,NULL,NULL,1,52.366625,-37.27292,0,NULL,38602882020,603170031,9424531,15.3),(31028,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 1992bs',NULL,31028,37.17,0.22,256,8434,72,NULL,NULL,'FCCB 0602',0.063,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31029,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 1992bs',NULL,31029,37.19,0.17,274,8434,70.8,NULL,NULL,'FCCB 0602',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31030,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 1992bs',NULL,31030,37.43,0.07,288,8434,72,NULL,NULL,'FCCB 0602',0.063,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31031,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 1992bs',NULL,31031,37.43,0.1,288,8434,65,NULL,'SALT2','FCCB 0602',0.063,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31032,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 1992bs',NULL,31032,37.43,0.18,288,8434,70,NULL,'SALT 2','FCCB 0602',0.063,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31033,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 1992bs',NULL,31033,37.3,0.08,288,8434,74.4,NULL,NULL,'FCCB 0602',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31034,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 1992bs',NULL,31034,37.48,0.19,294,8434,73.8,NULL,'SALT 2 (SNANA)','FCCB 0602',0.0634,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31035,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 1992bs',NULL,31035,37.64,0.16,298,8434,65,NULL,'MLCS2k2','FCCB 0602',0.063,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31036,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 1992bs',NULL,31036,37.52,0.04,300,8434,70,NULL,'SALT 2','FCCB 0602',0.063,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31037,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 1992bs',NULL,31037,37.54,0.05,303,8434,70,NULL,NULL,'FCCB 0602',0.063,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31038,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 1992bs',NULL,31038,37.55,0.15,304,8434,70,NULL,'SALT','FCCB 0602',0.063,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31039,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 1992bs',NULL,31039,37.61,0.14,313,8434,65,NULL,'MLCS','FCCB 0602',0.063,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31040,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 1992bs',NULL,31040,37.61,0.17,313,8434,65,NULL,'SALT2','FCCB 0602',0.063,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31041,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 1992bs',NULL,31041,37.63,0.2,316,8434,65,NULL,'MLCS31','FCCB 0602',0.063,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31042,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 1992bs',NULL,31042,37.63,0.18,316,8434,65,NULL,'MLCS17','FCCB 0602',0.063,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31043,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 1992bs',NULL,31043,37.63,0.18,316,8434,65,NULL,'Template','FCCB 0602',0.063,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31044,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 1992bs',NULL,31044,37.64,0.17,318,8434,65,NULL,'MLCS2k2','FCCB 0602',0.063,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31045,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 1992bs',NULL,31045,37.67,0.19,322,8434,65,NULL,NULL,'FCCB 0602',0.063,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31046,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 1992bs',NULL,31046,37.68,0.09,323,8434,65,NULL,'MLCS2k2','FCCB 0602',0.063,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31047,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 1992bs',NULL,31047,37.72,0.13,330,8434,65,NULL,'SALT','FCCB 0602',0.063,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31048,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 1992bs',NULL,31048,37.78,0.05,339,8434,65,NULL,'SALT','FCCB 0602',0.063,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31049,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 1992bs',NULL,31049,37.71,0.07,348,8434,60,NULL,'M(V) = -19.47 mag','FCCB 0602',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31050,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 1992bs',NULL,31050,37.74,0.09,353,8434,60,NULL,'M(B) = -19.48 mag','FCCB 0602',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31051,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 1992bs',NULL,31051,37.78,0.14,360,8434,60,NULL,NULL,'FCCB 0602',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31052,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',31052,37.59,0.27,330,8435,70,NULL,NULL,'2MASX J03293015-0030049',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000076,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,52.375667,-0.5015,0.233,NULL,36816971700,575265182,8988518,18.3),(31053,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31053,35.1,0.55,105,8436,70,NULL,NULL,'2MASX J03293034-1448200',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'15.72',0.42,NULL,NULL,NULL,NULL,NULL,1,52.376417,-14.80564,0.161,NULL,38002302757,593785980,9277905,15.72),(31054,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 15448',NULL,31054,39.58,0.19,824,8437,70,NULL,'SN photometric redshift distance, z photo =0.215 +/- 0.023','SDSS-II SN 15448',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,52.3802917,-1.14736,0.185,NULL,36817426732,575272292,8988629,NULL),(31055,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 20889','RN',31055,39.85,0.25,771,8438,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007py','SDSS-II SN 20889',0.20939,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31056,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 20889','RN',31056,40.05,0.15,847,8438,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007py','SDSS-II SN 20889',0.20939,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31057,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 20889','N',31057,39.66,0.22,855,8438,70,NULL,'SALT 2','SDSS-II SN 20889',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31058,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 20889','N',31058,39.67,0.22,859,8438,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20889',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31059,'Tully est','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31059,31.28,0.8,18.1,8439,75,NULL,'B','NGC 1345',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.000019,NULL,'14.33',1.1,'SB(s)c pec:    HII',NULL,NULL,NULL,NULL,1,52.3820417,-17.77839,0.097,NULL,38005967278,593843238,9278800,14.33),(31060,'Tully est','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31060,31.78,0.8,22.7,8440,75,NULL,NULL,'UGCA 075',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.00001,NULL,'15.35',1.7,'SB(s)m',NULL,NULL,NULL,NULL,1,52.389125,-15.23811,0.161,NULL,38001647785,593775746,9277746,15.35),(31061,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2011gy',NULL,31061,33.95,0.19,61.6,8441,72,NULL,'M(H) = -18.317 mag','UGC 02756',NULL,'2014ApJ...784..105W',2013,1,NULL,NULL,'GPair',NULL,NULL,NULL,NULL,'DBL SYS',NULL,NULL,NULL,NULL,1,52.3975,40.87306,0.869,NULL,68554610072,1071165782,16736965,NULL),(31062,'IRAS','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31062,31.74,0.8,22.3,8442,75,NULL,'MAT, I','ESO 481- G 030',NULL,'1997ApJS..109..333W',1997,1,1.57,NULL,'G',0.000033,NULL,'15',0.22,'Sdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,52.409625,-23.35033,0.013,NULL,38023164933,594111952,9282999,15),(31063,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31063,30.68,0.32,13.7,8442,85,NULL,'I, inv','ESO 481- G 030',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31064,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31064,30.78,0.32,14.3,8442,85,NULL,'I, raw','ESO 481- G 030',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31065,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31065,31.37,0.43,18.8,8442,75,NULL,'MAT, I, inv','ESO 481- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31066,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31066,31.6,0.43,20.9,8442,75,NULL,'MAT, I, raw','ESO 481- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31067,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31067,31.71,0.08,22,8442,NULL,NULL,NULL,'ESO 481- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31068,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31068,31.77,0.43,22.6,8442,75,NULL,'MAT, I, cor','ESO 481- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31069,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31069,31.88,NULL,23.8,8442,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 481- G 030',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31070,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31070,31.94,NULL,24.4,8442,NULL,NULL,'Dipole + Quadrupole','ESO 481- G 030',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31071,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31071,31.96,NULL,24.6,8442,NULL,NULL,'Dipole','ESO 481- G 030',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31072,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31072,32.19,NULL,27.4,8442,NULL,NULL,NULL,'ESO 481- G 030',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31073,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',31073,38.02,0.46,402,8443,70,NULL,NULL,'SDSS J032938.68-005052.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000091,NULL,'18.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,52.411167,-0.84789,0.225,NULL,36817528256,575273879,8988654,18.7),(31074,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 21404',NULL,31074,41.23,0.24,1760,8444,70,NULL,'SN photometric redshift distance, z photo =0.547 +/- 0.093','SDSS-II SN 21404',NULL,'2011ApJ...738..162S',2011,1,0.03,NULL,'G',NULL,'PHOT','23.2g',0.02,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,52.411583,0.08197,0.257,NULL,64988349793,1015442965,15866296,23.2),(31075,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','PS1 SN PS10aeq','N',31075,37.3,0.12,270,8445,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10aeq HOST',0.0656,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31076,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',31076,37.59,0.27,330,8446,70,NULL,NULL,'2MASX J03294435-0035089',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000081,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,52.434833,-0.58572,0.233,NULL,36817002667,575265666,8988526,17.5),(31077,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31077,36.27,0.5,179,8447,70,NULL,NULL,'2MASX J03294455-2223567',NULL,'2014MNRAS.445.2677S',2014,1,0.85,NULL,'G',0.000103,NULL,'16.23',0.38,'S0',NULL,NULL,NULL,NULL,1,52.4356666667,-22.39917,0.045,NULL,38040370532,594380789,9287199,16.23),(31078,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',31078,37.59,0.27,330,8448,70,NULL,NULL,'SDSS J032945.13-003456.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000084,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,52.4380417,-0.5825,0.233,NULL,36817002719,575265667,8988526,18.8),(31079,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 17345',NULL,31079,41.03,0.36,1610,8449,70,NULL,'SN photometric redshift distance, z photo =0.483 +/- 0.124','SDSS-II SN 17345',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,52.439625,0.38736,0.289,NULL,64988273925,1015441780,15866277,NULL),(31080,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',31080,35.99,0.46,158,8450,70,NULL,NULL,'2MASX J03294626+0058547',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000082,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,52.44275,0.98186,0.285,NULL,64990565803,1015477590,15866837,16.6),(31081,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 07778','RN',31081,39.73,0.41,775,8451,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 07778',0.138697,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31082,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 07778','RN',31082,40.73,6.1,1230,8451,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07778',0.138697,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31083,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2007jg',NULL,31083,36.1,0.16,154,8452,72,NULL,NULL,'SDSS J032950.83+000316.0',0.0366,'2013ApJ...773...53F',2013,1,0.25,NULL,'G',0.000063,NULL,'18.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,52.4617916667,0.05444,0.257,NULL,64988230967,1015441108,15866267,18.4),(31084,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 17784','R',31084,36.09,0.2,159,8452,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007jg','SDSS J032950.83+000316.0',0.037131,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31085,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2007jg',NULL,31085,36.08,0.11,164,8452,70,NULL,'SALT 2','SDSS J032950.83+000316.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31086,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2007jg',NULL,31086,36.08,0.11,164,8452,70,NULL,'SALT 2, Malmquist cor.','SDSS J032950.83+000316.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31087,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2007jg',NULL,31087,36.22,0.18,169,8452,73.8,NULL,'SALT 2 (SNANA)','SDSS J032950.83+000316.0',0.0367,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31088,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2007jg','R',31088,36.16,0.08,171,8452,NULL,NULL,'MLCS2k2, R(V) = 1.8','SDSS J032950.83+000316.0',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31089,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2007jg',NULL,31089,36.19,0.05,173,8452,72,NULL,'M(H) = -18.317 mag','SDSS J032950.83+000316.0',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31090,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2007jg','R',31090,36.2,0.09,174,8452,NULL,NULL,'MLCS2k2, R(V) = 3.1','SDSS J032950.83+000316.0',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31091,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 17784','R',31091,36.36,0.08,181,8452,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007jg','SDSS J032950.83+000316.0',0.037131,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31092,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2007jg',NULL,31092,36.4,0.28,184,8452,73.8,NULL,'SALT 2 (SNANA)','SDSS J032950.83+000316.0',0.0367,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31093,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31093,35.79,0.51,144,8453,70,NULL,NULL,'ESO 418- G 007 NOTES01',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'14.89',0.7,'SAB(s)0^0 pec LINER?','Pair member (points to parent)',NULL,NULL,NULL,1,52.4822917,-28.76772,0,NULL,38580263782,602816621,9419009,14.89),(31094,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',31094,37.79,0.46,362,8454,70,NULL,NULL,'SDSS J032956.05-061454.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000065,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,52.4835833333,-6.24836,0.105,NULL,36797722062,574964407,8983818,18.1),(31095,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31095,35.62,0.95,133,8455,NULL,NULL,'Malmquist cor.','ESO 418- G 007',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.00003,NULL,'14.0B',1.2,'SB(s)b pec','Pair member (points to parent)',NULL,NULL,NULL,1,52.4856666667,-28.77572,0,NULL,38580263925,602816623,9419009,14),(31096,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31096,36.15,0.74,170,8455,NULL,NULL,NULL,'ESO 418- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31097,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31097,36.19,0.2,173,8455,74.4,NULL,NULL,'ESO 418- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31098,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31098,33.66,0.47,54,8456,NULL,NULL,'H','NGC 1334',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000033,NULL,'14.1',0.7,'S? pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,52.507667,41.83203,1.093,NULL,68554864275,1071169754,16737027,14.1),(31099,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31099,33.68,0.45,54.4,8456,NULL,NULL,'K','NGC 1334',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31100,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31100,33.71,0.46,55.1,8456,NULL,NULL,'J','NGC 1334',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31101,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31101,33.91,0.4,60.5,8456,NULL,NULL,'mean','NGC 1334',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31102,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',31102,37.36,0.46,296,8457,70,NULL,NULL,'SDSS J033002.98+003708.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000072,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,52.512417,0.61906,0.317,NULL,64988257299,1015441520,15866273,18.1),(31103,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','PS1 SN PS10blp','N',31103,39.89,0.3,782,8458,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10blp HOST',0.2166,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31104,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',31104,36.66,0.46,214,8459,70,NULL,NULL,'2MASX J03300631+0036579',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000104,NULL,'16.7g',0.23,'AGN',NULL,NULL,NULL,NULL,1,52.526167,0.616,0.317,NULL,64988262975,1015441608,15866275,16.7),(31105,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 04534',NULL,31105,40.57,1.02,1300,8460,70,NULL,'SN photometric redshift distance, z photo =0.369 +/- 0.331','SDSS-II SN 04534',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,52.530625,-0.60686,0.233,NULL,36815843755,575247558,8988243,NULL),(31106,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31106,36.02,0.55,160,8461,70,NULL,NULL,'2MASX J03301100-1348306',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'16.46',0.4,NULL,NULL,NULL,NULL,NULL,1,52.545833,-13.80858,0.161,NULL,38070922636,594858166,9294658,16.46),(31107,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31107,36.06,0.51,163,8462,70,NULL,NULL,'2MASX J03301134-1331226',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'16.04',0.58,NULL,NULL,NULL,NULL,NULL,1,52.5472917,-13.52311,0.149,NULL,38068062129,594813470,9293960,16.04),(31108,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2005if',NULL,31108,36.65,0.12,200,8463,74.2,NULL,'SALT 2','SDSS J033012.88-005828.1',0.067107,'2010ApJ...716..712A',2010,1,0.23,NULL,'G',0.000056,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,52.5537083333,-0.97447,0.217,NULL,36816642236,575260034,8988438,17.7),(31109,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2005if',NULL,31109,37.31,0.13,271,8463,70,NULL,'SALT 2','SDSS J033012.88-005828.1',0.067107,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31110,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2005if',NULL,31110,37.32,0.09,273,8463,65,NULL,'SALT2','SDSS J033012.88-005828.1',0.067107,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31111,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2005if',NULL,31111,37.35,NULL,276,8463,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 06057, SN 2005if','SDSS J033012.88-005828.1',0.067107,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31112,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2005if',NULL,31112,37.21,0.09,277,8463,70,NULL,'SALT 2','SDSS J033012.88-005828.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31113,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 06057','R',31113,37.35,0.19,277,8463,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005if','SDSS J033012.88-005828.1',0.067107,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31114,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2005if',NULL,31114,37.22,0.09,278,8463,70,NULL,'SALT 2, Malmquist cor.','SDSS J033012.88-005828.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31115,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2005if',NULL,31115,37.23,0.1,279,8463,74.4,NULL,NULL,'SDSS J033012.88-005828.1',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31116,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2005if',NULL,31116,37.54,0.08,302,8463,65,NULL,'MLCS2k2','SDSS J033012.88-005828.1',0.067107,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31117,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 06057','R',31117,37.56,0.06,304,8463,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005if','SDSS J033012.88-005828.1',0.067107,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31118,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2005if',NULL,31118,38.34,0.04,435,8463,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 06057, SN 2005if','SDSS J033012.88-005828.1',0.067107,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31119,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31119,33.71,0.47,55.3,8464,NULL,NULL,'H','NGC 1346',NULL,'2007A&A...465...71T',2007,1,1.27,NULL,'G',0.00002,NULL,'13.8g',0.76,'Sb pec?        LLIRG',NULL,NULL,NULL,'Sy 1',1,52.5552916667,-5.54331,0.105,NULL,36828965763,575452590,8991446,13.8),(31120,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31120,33.72,0.45,55.5,8464,NULL,NULL,'K','NGC 1346',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31121,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31121,33.78,0.4,57,8464,NULL,NULL,'mean','NGC 1346',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31122,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31122,33.8,0.46,57.6,8464,NULL,NULL,'J','NGC 1346',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31123,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',31123,34.97,0.46,98.4,8465,70,NULL,NULL,'CGCG 390-096',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.000097,NULL,'14.7g',0.7,'E0',NULL,NULL,NULL,NULL,1,52.571583,-0.92019,0.217,NULL,36816625441,575259772,8988433,14.7),(31124,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31124,35.42,0.4,121,8466,NULL,NULL,'mean','KUG 0327-044',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000033,NULL,'14.21',0.8,'SB(s)c',NULL,NULL,NULL,NULL,1,52.5802083,-4.24256,0.077,NULL,36827332903,575427076,8991048,14.21),(31125,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31125,35.49,0.47,125,8466,NULL,NULL,'H','KUG 0327-044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31126,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31126,35.58,0.45,131,8466,NULL,NULL,'K','KUG 0327-044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31127,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31127,35.64,0.46,135,8466,NULL,NULL,'J','KUG 0327-044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31128,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 17915',NULL,31128,39.57,0.64,820,8467,70,NULL,'SN photometric redshift distance, z photo =0.214 +/- 0.087','SDSS-II SN 17915',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,52.579875,0.4055,0.289,NULL,64988297126,1015442142,15866283,NULL),(31129,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',31129,38.05,0.46,408,8468,70,NULL,NULL,'SDSS J033019.68-055058.4',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000083,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,52.582,-5.84956,0.117,NULL,36828292874,575442076,8991282,18.5),(31130,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',31130,38.03,0.46,403,8469,70,NULL,NULL,'2MASX J03302209-0101103',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00006,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,52.5920417,-1.01964,0.217,NULL,36816676469,575260569,8988446,18.1),(31131,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 20470','R',31131,39.02,0.21,567,8470,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007pz','SDSS J033025.17+010033.6',0.125,'2014arXiv1401.3317S',2014,1,0.1,NULL,'G',NULL,NULL,'20.7g',0.05,NULL,NULL,NULL,NULL,NULL,1,52.604875,1.00936,0.285,NULL,64989878950,1015466858,15866669,20.7),(31132,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 20470','R',31132,39.19,0.11,613,8470,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007pz','SDSS J033025.17+010033.6',0.125,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31133,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31133,31.82,0.36,23.1,8471,NULL,NULL,'R','FCC 082',NULL,'2003A&A...398...63J',2003,1,0.98,NULL,'G',NULL,NULL,'16.7B',NULL,'dE1,N',NULL,NULL,NULL,NULL,1,52.627167,-34.26,0,NULL,38566228037,602597313,9415583,16.7),(31134,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31134,35.79,0.66,144,8472,70,NULL,NULL,'IC 1947',NULL,'2014MNRAS.445.2677S',2014,1,0.6,'Chincarini et al. (1984,A&AS, 57, 1) give v=42 km/sec.','G',0.00015,NULL,'15.50',0.48,'S',NULL,NULL,NULL,NULL,1,52.63675,-50.33853,0,NULL,37726471394,589476115,9210564,15.5),(31135,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31135,31.23,0.08,17.6,8473,NULL,NULL,'TOM(g) = -7.2 mag','NGC 1351',NULL,'2010ApJ...717..603V',2010,1,2.8,NULL,'G',0.000011,NULL,'12.5B',1.7,'SA0- pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,52.64575,-34.85394,0,NULL,38564282408,602566912,9415108,12.5),(31136,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31136,31.44,0.07,19.4,8473,NULL,NULL,'TOM(z) = -8.53 mag','NGC 1351',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31137,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31137,30.94,0.16,15.4,8473,NULL,NULL,'I','NGC 1351',NULL,'1991ApJ...373L...1T',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31138,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31138,31.42,0.07,19.2,8473,NULL,NULL,'HST ACS FCS','NGC 1351',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31139,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31139,31.42,0.12,19.2,8473,74.4,NULL,NULL,'NGC 1351',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31140,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31140,31.45,0.16,19.5,8473,NULL,NULL,'I','NGC 1351',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31141,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31141,31.61,0.16,21,8473,NULL,NULL,'I','NGC 1351',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31142,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31142,31.61,0.16,21,8473,NULL,NULL,NULL,'NGC 1351',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31143,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31143,31.64,0.16,21.3,8473,NULL,NULL,'Malmquist cor.','NGC 1351',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31144,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31144,31.77,0.11,22.6,8473,NULL,NULL,'KS','NGC 1351',NULL,'2002ApJ...564..216L',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31145,'GC radius','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31145,31.44,0.08,19.4,8473,NULL,NULL,'HST ACS FCS','NGC 1351',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31146,'D-Sigma','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31146,31.26,0.4,17.8,8473,75,NULL,'Edat, raw','NGC 1351',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31147,'D-Sigma','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31147,31.29,0.4,18.1,8473,75,NULL,'Edat, cor','NGC 1351',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31148,'Faber-Jackson','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31148,30.54,0.65,12.8,8473,95,NULL,'Weighted Mean','NGC 1351',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31149,'Faber-Jackson','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31149,31.65,0.81,21.4,8473,55,NULL,'Visvanathan & Sandage 1979','NGC 1351',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31150,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31150,31.42,0.12,19.2,8473,74.4,NULL,NULL,'NGC 1351',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31151,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31151,31.97,0.41,24.8,8473,NULL,NULL,'Malmquist cor.','NGC 1351',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31152,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31152,32.03,0.41,25.5,8473,NULL,NULL,NULL,'NGC 1351',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31153,'Tertiary','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31153,31.11,0.41,16.7,8473,95,NULL,NULL,'NGC 1351',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31154,'Tully est','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31154,31.14,0.8,16.9,8473,75,NULL,'B','NGC 1351',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31155,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31155,31.84,0.4,23.3,8473,NULL,NULL,'mean','NGC 1351',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31156,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31156,31.99,0.45,25,8473,NULL,NULL,'K','NGC 1351',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31157,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31157,36.35,0.57,186,8474,70,NULL,NULL,'2MASX J03303704-1434229',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'16.33',0.31,NULL,NULL,NULL,NULL,NULL,1,52.65425,-14.57306,0.177,NULL,38002064822,593782262,9277847,16.33),(31158,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31158,34.38,0.48,75.2,8475,70,NULL,NULL,'MCG -01-09-044',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'14.96',0.25,NULL,NULL,NULL,NULL,NULL,1,52.689,-4.84989,0.125,NULL,36828650385,575447662,8991369,14.96),(31159,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31159,31.37,0.18,18.8,8476,NULL,NULL,'R','FCC 085',NULL,'2003A&A...398...63J',2003,1,1.05,NULL,'G',0.00022,NULL,'16.3',NULL,'dE0,N',NULL,NULL,NULL,NULL,1,52.6925417,-35.54942,0,NULL,38563669032,602557328,9414958,16.3),(31160,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31160,35.59,0.59,131,8477,70,NULL,NULL,'ESO 031- G 015',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000033,NULL,'15.47',0.8,'SB...',NULL,NULL,NULL,NULL,1,52.6987083333,-73.78428,0.249,NULL,35520810390,555012662,8672072,15.47),(31161,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',31161,34.69,NULL,86.7,8477,NULL,NULL,'B','ESO 031- G 015',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31162,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',31162,34.69,NULL,86.7,8477,NULL,NULL,'I','ESO 031- G 015',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31163,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31163,34.69,NULL,86.7,8477,NULL,NULL,'B, Hubble-type-TF','ESO 031- G 015',NULL,'2004ApJ...607..241R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31164,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31164,34.83,0.63,92.3,8477,NULL,NULL,'Malmquist cor.','ESO 031- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31165,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31165,34.94,NULL,97.3,8477,NULL,NULL,'B','ESO 031- G 015',NULL,'2004ApJ...607..241R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31166,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31166,35.2,0.53,110,8477,NULL,NULL,NULL,'ESO 031- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31167,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31167,35.24,0.2,112,8477,74.4,NULL,NULL,'ESO 031- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31168,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2005fw',NULL,31168,38.41,0.11,415,8478,74.2,NULL,'SALT 2','SDSS J033048.96-011415.4',0.16,'2010ApJ...716..712A',2010,1,0.14,NULL,'G',0.0005,NULL,'19.3g',0.1,NULL,NULL,NULL,NULL,NULL,1,52.704,-1.23761,0.233,NULL,36816804866,575262576,8988477,19.3),(31169,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2005fw',NULL,31169,38.86,0.04,511,8478,70,NULL,'SDSS-II SN 02635','SDSS J033048.96-011415.4',0.16,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31170,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2005fw',NULL,31170,38.82,0.05,582,8478,70,NULL,'Hubble residual 0.04 for z0.14370','SDSS J033048.96-011415.4',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31171,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2005fw',NULL,31171,39.18,0.12,590,8478,70,NULL,'SDSS-II SN 02635, SALT 2','SDSS J033048.96-011415.4',0.16,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31172,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2005fw',NULL,31172,39.19,0.07,594,8478,65,NULL,'SALT2','SDSS J033048.96-011415.4',0.16,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31173,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 02635','R',31173,39.21,0.19,608,8478,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fw','SDSS J033048.96-011415.4',0.1437,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31174,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SN 2005fw',NULL,31174,39.5,0.08,683,8478,65,NULL,'MLCS2k2','SDSS J033048.96-011415.4',0.16,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31175,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 02635','R',31175,39.53,0.08,703,8478,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fw','SDSS J033048.96-011415.4',0.1437,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31176,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 02766','RN',31176,39.18,0.2,595,8479,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02766',0.149937,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31177,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 02766','RN',31177,39.45,0.13,674,8479,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 02766',0.149937,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31178,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',31178,36.26,0.46,178,8480,70,NULL,NULL,'2MASX J03305115-0111426',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000105,NULL,'16.1g',0.34,'E0',NULL,NULL,NULL,NULL,1,52.713083,-1.19508,0.233,NULL,36816805133,575262580,8988477,16.1),(31179,'SNIa','2016-12-15 15:13:59','2016-12-16 11:19:03','1','PS1 SN PS10cbb','N',31179,39.91,0.24,786,8481,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10cbb HOST',0.2196,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31180,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',31180,37.3,0.46,288,8482,70,NULL,NULL,'SDSS J033100.06-062926.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000065,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,52.7502917,-6.49056,0.097,NULL,36797876349,574966817,8983856,18.1),(31181,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',31181,37.17,0.46,271,8483,70,NULL,NULL,'2MASX J03310075+0004175',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000074,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,52.753167,0.07147,0.229,NULL,64988450640,1015444541,15866320,17.5),(31182,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31182,37.37,0.5,298,8484,70,NULL,NULL,'LCRS B032915.2-394216',NULL,'2014MNRAS.445.2677S',2014,1,0.57,'Way et al. (2005AJ....130.2012W) also give v = 21791 +/- 26 km/sec.','G',0.000087,NULL,'16.12',0.5,'E',NULL,NULL,NULL,NULL,1,52.771333,-39.53531,0,NULL,38590071259,602969863,9421404,16.12),(31183,'Ring Diameter','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31183,30,0.84,10,8485,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 1350',NULL,'1981ApJS...45..541P',1981,1,5.2,'ESO-LV gives v= 1441+/-29 km/sec.','G',0.000011,NULL,'11.46',2.8,'(R\'_1)SB(r)ab  Sy','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,52.7838333333,-33.62864,0,NULL,38566590744,602602980,9415671,11.46),(31184,'IRAS','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31184,32.13,0.8,26.7,8485,75,NULL,'A82, H','NGC 1350',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31185,'Sosies','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31185,31.31,0.11,18.3,8485,NULL,NULL,NULL,'NGC 1350',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31186,'Tully est','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31186,31.14,0.8,16.9,8485,75,NULL,'B','NGC 1350',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31187,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31187,31.11,0.4,16.7,8485,NULL,NULL,NULL,'NGC 1350',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31188,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31188,31.11,0.39,16.7,8485,73,NULL,'opt','NGC 1350',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31189,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31189,31.34,0.2,18.5,8485,74.4,NULL,NULL,'NGC 1350',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31190,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31190,31.37,0.43,18.8,8485,75,NULL,'3.6 micron, color corrected','NGC 1350',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31191,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31191,31.48,0.11,19.8,8485,NULL,NULL,NULL,'NGC 1350',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31192,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31192,31.5,0.43,20,8485,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1350',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31193,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31193,31.7,0.47,21.9,8485,75,NULL,'A82, H, raw','NGC 1350',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31194,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31194,31.82,0.47,23.1,8485,75,NULL,'A82, H, cor','NGC 1350',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31195,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31195,31.91,0.47,24.1,8485,75,NULL,'A82, H, inv','NGC 1350',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31196,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',31196,32.14,NULL,26.8,8485,NULL,NULL,'LEDA [April 2006]','NGC 1350',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31197,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31197,31.15,0.35,17,8486,NULL,NULL,'TOM(g) = -7.2 mag','MCG -06-08-024',NULL,'2010ApJ...717..603V',2010,1,1,NULL,'G',0.00005,NULL,'15.0B',0.6,'SA0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,52.7844166667,-36.29014,0,NULL,38602335062,603161485,9424398,15),(31198,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31198,31.56,0.21,20.5,8486,NULL,NULL,'TOM(z) = -8.53 mag','MCG -06-08-024',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31199,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31199,31.42,0.14,19.2,8486,74.4,NULL,NULL,'MCG -06-08-024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31200,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31200,31.45,0.19,19.5,8486,NULL,NULL,'HST ACS FCS','MCG -06-08-024',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31201,'GC radius','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31201,31.7,0.48,21.8,8486,NULL,NULL,'HST ACS FCS','MCG -06-08-024',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31202,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 15189','RN',31202,42.4,0.54,2680,8487,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15189',0.127316,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31203,'SNIa SDSS','2016-12-15 15:13:59','2016-12-16 11:19:03','1','SDSS-II SN 15189','RN',31203,43.56,0.31,4560,8487,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15189',0.127316,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31204,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31204,33.46,0.47,49.3,8488,NULL,NULL,'H','UGC 02770',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000017,NULL,'14.53',0.9,'SB(rs)b',NULL,NULL,NULL,NULL,1,52.8262917,35.46636,0.853,NULL,68474197676,1069909338,16717333,14.53),(31205,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31205,33.72,0.46,55.6,8488,NULL,NULL,'J','UGC 02770',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31206,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31206,33.74,0.45,56,8488,NULL,NULL,'K','UGC 02770',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31207,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31207,33.86,0.4,59.2,8488,NULL,NULL,'mean','UGC 02770',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31208,'IRAS','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31208,33.73,0.8,55.8,8489,75,NULL,'MAT, I','ESO 482- G 001',NULL,'1997ApJS..109..333W',1997,1,1.51,NULL,'G',0.000033,NULL,'14.64',0.38,'Sb',NULL,NULL,NULL,NULL,1,52.830625,-26.56111,0,NULL,38549300537,602332820,9411450,14.64),(31209,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31209,33.5,0.32,50.1,8489,85,NULL,'I, raw','ESO 482- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31210,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31210,33.5,0.43,50.2,8489,75,NULL,'MAT, I, raw','ESO 482- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31211,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31211,33.53,0.32,50.7,8489,85,NULL,'I, inv','ESO 482- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31212,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31212,33.64,0.43,53.5,8489,75,NULL,'MAT, I, inv','ESO 482- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31213,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31213,33.82,0.43,58,8489,75,NULL,'MAT, I, cor','ESO 482- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31214,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31214,34.12,0.54,66.5,8489,NULL,NULL,'Malmquist cor.','ESO 482- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31215,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31215,34.18,0.52,68.6,8489,NULL,NULL,NULL,'ESO 482- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31216,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31216,34.22,0.2,69.8,8489,74.4,NULL,NULL,'ESO 482- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31217,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31217,31.35,0.1,18.6,8490,NULL,NULL,'TOM(g) = -7.2 mag','MCG -06-08-025',NULL,'2010ApJ...717..603V',2010,1,1.3,NULL,'G',0.000087,NULL,'14.72',0.9,'SB(s)0^0^','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,52.853333,-35.33106,0,NULL,38563657762,602557152,9414955,14.72),(31218,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31218,31.6,0.06,20.9,8490,NULL,NULL,'TOM(z) = -8.53 mag','MCG -06-08-025',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31219,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31219,31.46,0.14,19.6,8490,74.4,NULL,NULL,'MCG -06-08-025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31220,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31220,31.48,0.07,19.7,8490,NULL,NULL,'HST ACS FCS','MCG -06-08-025',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31221,'GC radius','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31221,31,0.42,15.9,8490,NULL,NULL,'HST ACS FCS','MCG -06-08-025',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31222,'IRAS','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31222,31.01,0.8,15.9,8491,75,NULL,'MAT, I','ESO 418- G 008',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000001,NULL,'13.68',0.8,'SB(r)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,52.8777083,-30.21333,0,NULL,38573640550,602713133,9417392,13.68),(31223,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31223,31.11,0.07,16.7,8491,NULL,NULL,NULL,'ESO 418- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31224,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31224,31.36,0.32,18.7,8491,85,NULL,'I, inv','ESO 418- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31225,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31225,31.39,0.32,19,8491,85,NULL,'I, raw','ESO 418- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31226,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31226,31.44,0.43,19.4,8491,75,NULL,'3.6 micron, color + selection bias corrected','ESO 418- G 008',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31227,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31227,31.6,0.43,20.9,8491,75,NULL,'3.6 micron, color corrected','ESO 418- G 008',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31228,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31228,31.71,0.2,22,8491,74.4,NULL,NULL,'ESO 418- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31229,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31229,31.71,0.43,22,8491,75,NULL,'MAT, I, inv','ESO 418- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31230,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31230,31.77,0.43,22.6,8491,75,NULL,'MAT, I, raw','ESO 418- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31231,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31231,31.86,0.43,23.6,8491,75,NULL,'MAT, I, cor','ESO 418- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31232,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31232,31.86,0.4,23.6,8491,NULL,NULL,NULL,'ESO 418- G 008',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31233,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31233,31.86,0.39,23.6,8491,73,NULL,'opt','ESO 418- G 008',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31234,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31234,35.32,0.53,116,8492,70,NULL,NULL,'2MASX J03313070-0401174',NULL,'2014MNRAS.445.2677S',2014,1,0.81,NULL,'G',0.000077,NULL,'16.12',0.28,NULL,NULL,NULL,NULL,NULL,1,52.8782083,-4.02144,0.085,NULL,36827982784,575437231,8991206,16.12),(31235,'FP','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,'R',31235,38.19,0.46,435,8493,70,NULL,NULL,'SDSS J033131.35-055806.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000072,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,52.880625,-5.96842,0.093,NULL,36829016630,575453384,8991459,18.7),(31236,'IRAS','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31236,30.77,0.8,14.2,8494,75,NULL,'A82, H','IC 1954',NULL,'1997ApJS..109..333W',1997,1,3.2,'The APM position is southwest of the nucleus.','G',0.000007,NULL,'12.15',1.5,'SA(s)c','X-ray-faint group member',NULL,NULL,NULL,1,52.8807917,-51.90483,0,NULL,37728461856,589507216,9211050,12.15),(31237,'IRAS','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31237,30.78,0.8,14.3,8494,75,NULL,'MAT, I','IC 1954',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31238,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31238,30.33,0.4,11.6,8494,75,NULL,'B','IC 1954',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31239,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31239,30.36,0.47,11.8,8494,75,NULL,'A82, H, inv','IC 1954',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31240,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31240,30.41,0.47,12.1,8494,75,NULL,'A82, H, raw','IC 1954',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31241,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31241,30.52,0.43,12.7,8494,75,NULL,'3.6 micron, color + selection bias corrected','IC 1954',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31242,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31242,30.59,0.32,13.1,8494,85,NULL,'I, raw','IC 1954',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31243,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31243,30.6,0.32,13.2,8494,85,NULL,'I, inv','IC 1954',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31244,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31244,30.64,0.43,13.4,8494,75,NULL,'3.6 micron, color corrected','IC 1954',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31245,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31245,30.68,0.35,13.7,8494,NULL,NULL,NULL,'IC 1954',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31246,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31246,30.68,0.39,13.7,8494,73,NULL,'opt','IC 1954',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31247,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31247,30.76,0.47,14.2,8494,75,NULL,'A82, H, cor','IC 1954',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31248,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31248,30.77,0.2,14.3,8494,74.4,NULL,NULL,'IC 1954',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31249,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31249,30.79,0.08,14.4,8494,NULL,NULL,NULL,'IC 1954',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31250,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31250,30.9,0.43,15.2,8494,75,NULL,'MAT, I, raw','IC 1954',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31251,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31251,30.99,0.43,15.8,8494,75,NULL,'MAT, I, inv','IC 1954',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31252,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31252,31.13,0.43,16.9,8494,75,NULL,'MAT, I, cor','IC 1954',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31253,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31253,31.25,0.4,17.8,8494,NULL,NULL,'mean','IC 1954',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31254,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31254,31.39,0.46,19,8494,NULL,NULL,'J','IC 1954',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31255,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31255,31.4,0.45,19.1,8494,NULL,NULL,'K','IC 1954',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31256,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31256,31.41,0.47,19.2,8494,NULL,NULL,'H','IC 1954',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31257,'IRAS','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31257,34.61,0.8,83.7,8495,75,NULL,'MAT, I','ESO 482- G 002',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.00003,NULL,'14.77',0.8,'Sb',NULL,NULL,NULL,NULL,1,52.909917,-25.00811,0,NULL,38021965574,594093212,9282706,14.77),(31258,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31258,33.78,0.43,57.1,8495,75,NULL,'MAT, I, raw','ESO 482- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31259,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31259,33.83,0.32,58.3,8495,85,NULL,'I, raw','ESO 482- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31260,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31260,33.85,0.32,58.8,8495,85,NULL,'I, inv','ESO 482- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31261,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31261,33.88,0.43,59.7,8495,75,NULL,'MAT, I, inv','ESO 482- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31262,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31262,34.02,0.43,63.8,8495,75,NULL,'MAT, I, cor','ESO 482- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31263,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31263,31.32,0.11,18.4,8496,NULL,NULL,'TOM(g) = -7.2 mag','FCC 100',NULL,'2010ApJ...717..603V',2010,1,1.7,NULL,'G',0.000103,NULL,'15.7B',0.8,'SAB(rs)0^0^:','Group member',NULL,NULL,NULL,1,52.94825,-35.05186,0,NULL,38564517764,602570590,9415165,15.7),(31264,'GCLF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31264,31.9,0.18,24,8496,NULL,NULL,'TOM(z) = -8.53 mag','FCC 100',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31265,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31265,31.55,0.14,20.4,8496,74.4,NULL,NULL,'FCC 100',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31266,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31266,31.57,0.08,20.6,8496,NULL,NULL,'HST ACS FCS','FCC 100',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31267,'SBF','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31267,31.84,0.16,23.3,8496,NULL,NULL,'R','FCC 100',NULL,'2003A&A...398...63J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31268,'GC radius','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31268,31.44,0.5,19.4,8496,NULL,NULL,'HST ACS FCS','FCC 100',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31269,'IRAS','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31269,30.45,0.8,12.3,8497,75,NULL,'MAT, I','ESO 418- G 009',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000017,NULL,'14.24',1,'IB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,52.98175,-31.33764,0,NULL,38574842537,602731914,9417686,14.24),(31270,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31270,30.91,0.32,15.2,8497,85,NULL,'I, inv','ESO 418- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31271,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31271,30.95,0.32,15.5,8497,85,NULL,'I, raw','ESO 418- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31272,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31272,31.31,0.4,18.3,8497,NULL,NULL,NULL,'ESO 418- G 009',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31273,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31273,31.31,0.4,18.3,8497,73,NULL,'opt','ESO 418- G 009',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31274,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31274,31.36,0.43,18.7,8497,75,NULL,'MAT, I, inv','ESO 418- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31275,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31275,31.45,0.43,19.5,8497,75,NULL,'MAT, I, raw','ESO 418- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31276,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31276,31.64,0.43,21.2,8497,75,NULL,'MAT, I, cor','ESO 418- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31277,'IRAS','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31277,34.23,0.8,70,8498,75,NULL,'MAT, I','ESO 083- G 006',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'14.92',0.7,'(R\'_2)SB(rl)c',NULL,NULL,NULL,NULL,1,52.999167,-62.56917,0.077,NULL,36288697543,567010899,8859545,14.92),(31278,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31278,34.09,0.32,65.9,8498,85,NULL,'I, raw','ESO 083- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31279,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31279,34.12,0.32,66.8,8498,85,NULL,'I, inv','ESO 083- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31280,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31280,34.42,0.43,76.7,8498,75,NULL,'MAT, I, raw','ESO 083- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31281,'Tully-Fisher','2016-12-15 15:13:59','2016-12-16 11:19:03','1',NULL,NULL,31281,34.59,0.43,82.9,8498,75,NULL,'MAT, I, inv','ESO 083- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31282,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31282,34.65,0.43,85.3,8498,75,NULL,'MAT, I, cor','ESO 083- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31283,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31283,35.48,0.49,125,8499,75,NULL,'IR','FGC 0432',NULL,'2011yCatp016004901K',2011,1,0.76,NULL,'G',0.000016,NULL,'17.83',0.09,'Scd',NULL,NULL,NULL,NULL,1,52.999167,14.78094,0.885,NULL,68017769610,1062777650,16605900,17.83),(31284,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31284,36.27,NULL,179,8499,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0432',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31285,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31285,36.27,NULL,179,8499,NULL,NULL,'Dipole + Quadrupole','FGC 0432',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31286,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31286,36.3,NULL,182,8499,NULL,NULL,'Dipole','FGC 0432',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31287,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31287,36.31,NULL,183,8499,NULL,NULL,NULL,'FGC 0432',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31288,'FP','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31288,34.8,0.46,91.2,8500,70,NULL,NULL,'IC 0329',NULL,'2015arXiv151105856S',2015,1,0.98,NULL,'G',0.00008,NULL,'14.9g',0.54,'Sa','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,53.0057083,0.27944,0.257,NULL,64987772853,1015433950,15866155,14.9),(31289,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SDSS-II SN 04538','RN',31289,42.13,0.2,1900,8501,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04538',0.405689,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31290,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SDSS-II SN 04538','RN',31290,42.16,0.14,1920,8501,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 04538',0.405689,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31291,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SDSS-II SN 14951',NULL,31291,41.16,0.14,1710,8502,70,NULL,'SN photometric redshift distance, z photo =0.525 +/- 0.051','SDSS-II SN 14951',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,53.008333,0.41389,0.273,NULL,64988545657,1015446025,15866344,NULL),(31292,'IRAS','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31292,31.57,0.8,20.6,8503,75,NULL,'MAT, I','NGC 1353',NULL,'1997ApJS..109..333W',1997,1,3.4,NULL,'G',0.000027,NULL,'12.57',1.4,'SA(rs)bc;LINER HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,53.012583,-20.81917,0.029,NULL,38049355354,594521177,9289393,12.57),(31293,'Sosies','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31293,32.21,0.03,27.7,8503,NULL,NULL,NULL,'NGC 1353',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31294,'Tully est','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31294,31.25,0.8,17.8,8503,75,NULL,'B','NGC 1353',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31295,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31295,31.7,0.07,21.9,8503,NULL,NULL,NULL,'NGC 1353',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31296,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31296,32.04,0.43,25.6,8503,75,NULL,'3.6 micron, color corrected','NGC 1353',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31297,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31297,32.07,0.2,25.9,8503,74.4,NULL,NULL,'NGC 1353',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31298,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31298,32.09,0.43,26.2,8503,75,NULL,'MAT, I, raw','NGC 1353',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31299,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31299,32.11,0.32,26.4,8503,85,NULL,'I, raw','NGC 1353',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31300,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31300,32.1,0.43,26.4,8503,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1353',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31301,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31301,32.14,0.43,26.8,8503,75,NULL,'MAT, I, cor','NGC 1353',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31302,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31302,32.17,0.32,27.2,8503,85,NULL,'I, inv','NGC 1353',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31303,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31303,32.36,0.43,29.6,8503,75,NULL,'MAT, I, inv','NGC 1353',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31304,'Tully est','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31304,32.08,0.8,26.1,8504,75,NULL,NULL,'UGC 02765',NULL,'1988NBGC.C....0000T',1988,1,4,NULL,'G',0.000037,NULL,'18.',1.6,'S0/a',NULL,NULL,NULL,NULL,1,53.0142083333,68.36839,NULL,NULL,66560418279,1040006535,16250102,18),(31305,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31305,31.34,0.46,18.6,8504,NULL,NULL,'J','UGC 02765',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31306,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31306,31.41,0.47,19.1,8504,NULL,NULL,'H','UGC 02765',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31307,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31307,31.45,0.45,19.5,8504,NULL,NULL,'K','UGC 02765',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31308,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31308,31.98,0.4,24.9,8504,NULL,NULL,'mean','UGC 02765',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31309,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2006lk',NULL,31309,40.16,0.14,1080,8505,70,NULL,'Hubble residual -0.11 for z0.31120','SDSS-II SN 15213 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,53.01925,-0.10022,0.237,NULL,36815612470,575243944,8988186,NULL),(31310,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SDSS-II SN 15213','R',31310,41.03,0.25,1230,8505,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006lk','SDSS-II SN 15213 HOST',0.307,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31311,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SDSS-II SN 15213','R',31311,41.13,0.19,1290,8505,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006lk','SDSS-II SN 15213 HOST',0.307,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31312,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31312,33.93,0.4,61.2,8506,NULL,NULL,'mean','UGC 02775',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.00002,NULL,'16.0',1.3,'SAB(s)cd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,53.023417,41.59139,1.161,NULL,68555110011,1071173593,16737087,16),(31313,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31313,34.44,0.47,77.2,8506,NULL,NULL,'H','UGC 02775',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31314,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002fx',NULL,31314,42.2,1.08,1150,8507,74.2,NULL,'SALT 2','COMBO-17 40328',1.4,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,'PHOT','25.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,53.0285417,-27.74283,0,NULL,38580851892,602825810,9419153,25.4),(31315,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002fx',NULL,31315,45.09,0.45,4340,8507,65,NULL,NULL,'COMBO-17 40328',1.4,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31316,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002fx',NULL,31316,45.28,0.81,4740,8507,65,NULL,NULL,'COMBO-17 40328',1.4,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31317,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002fx',NULL,31317,45.8,5.94,6020,8507,70,NULL,'SALT','COMBO-17 40328',1.4,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31318,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002fx',NULL,31318,45.94,0.34,6420,8507,65,NULL,'SN Athena, SALT2','COMBO-17 40328',1.4,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31319,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31319,28.22,0.4,4.4,8508,73,NULL,'opt','UGC 02773',NULL,'2011A&A...532A.104N',2011,1,1.7,'abs(b) < 10 degrees.','G',0.000057,NULL,'15.0',1.3,'dwarf Irr',NULL,NULL,NULL,NULL,1,53.0305,47.79406,NULL,NULL,68309450730,1067335167,16677111,15),(31320,'FP','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31320,37.7,0.46,347,8509,70,NULL,NULL,'2MASX J03320771-0059237',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000072,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,53.0323333333,-0.98986,0.233,NULL,36816281537,575254399,8988349,17.6),(31321,'FP','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31321,35.13,0.53,106,8510,70,NULL,NULL,'2MASX J03320976-1450122',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'16.07',0.39,NULL,NULL,NULL,NULL,NULL,1,53.0405416667,-14.83667,0.181,NULL,38002272451,593785507,9277898,16.07),(31322,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Mcg','R',31322,43.92,NULL,2570,8511,65,NULL,'SALT','COMBO-17 29383',1.37,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,'24.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,53.04125,-27.83094,0,NULL,38580851225,602825800,9419153,24.1),(31323,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Mcg',NULL,31323,44.3,0.24,3060,8511,74.2,NULL,'SALT 2','COMBO-17 29383',1.37,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31324,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Mcg',NULL,31324,44.79,0.32,3830,8511,70,NULL,'SALT','COMBO-17 29383',1.37,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31325,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Mcg',NULL,31325,44.93,0.35,4080,8511,65,NULL,'SALT','COMBO-17 29383',1.37,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31326,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Mcg',NULL,31326,45.07,0.19,4360,8511,65,NULL,'SALT2','COMBO-17 29383',1.37,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31327,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Mcg',NULL,31327,45.08,0.2,4380,8511,65,NULL,'SALT2','COMBO-17 29383',1.37,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31328,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Mcg',NULL,31328,45.11,0.15,4440,8511,65,NULL,'MLCS2k2','COMBO-17 29383',1.37,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31329,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Mcg',NULL,31329,45.19,0.19,4600,8511,65,NULL,'MLCS17','COMBO-17 29383',1.37,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31330,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Mcg',NULL,31330,45.2,0.19,4620,8511,65,NULL,'MLCS31','COMBO-17 29383',1.37,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31331,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Mcg',NULL,31331,45.23,0.25,4690,8511,65,NULL,NULL,'COMBO-17 29383',1.37,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31332,'FP','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31332,36.23,0.57,177,8512,70,NULL,NULL,'2MASX J03321131-5457146',NULL,'2014MNRAS.445.2677S',2014,1,0.1,NULL,'G',0.000147,NULL,'20.32',0.09,NULL,NULL,NULL,NULL,NULL,1,53.0472917,-54.95406,0,NULL,35779403146,559053174,8735205,20.32),(31333,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SDSS-II SN 20304','RN',31333,42.23,0.2,1850,8513,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20304',0.508642,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31334,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SDSS-II SN 06060','RN',31334,42.62,0.19,2270,8514,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06060',0.473689,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31335,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SDSS-II SN 17191',NULL,31335,40.64,0.11,1340,8515,70,NULL,'SN photometric redshift distance, z photo =0.383 +/- 0.025','SDSS-II SN 17191',NULL,'2011ApJ...738..162S',2011,1,0.11,NULL,'G',NULL,'PHOT','20.1g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,53.0635,-0.85683,0.233,NULL,36816122444,575251913,8988311,20.1),(31336,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SDSS-II SN 20936','RN',31336,43.77,0.43,4110,8516,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20936',0.378359,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31337,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','PS1 SN PS10bls','N',31337,40.88,0.14,1170,8517,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10bls HOST',0.2756,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31338,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Rak','R',31338,42.16,NULL,1560,8518,65,NULL,'MLCS17','COMBO-17 41308',0.74,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,'24.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,53.07575,-27.73603,0,NULL,38580906639,602826666,9419166,24.5),(31339,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Rak',NULL,31339,42.57,0.18,1880,8518,74.2,NULL,'SALT 2','COMBO-17 41308',0.74,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31340,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Rak',NULL,31340,43.23,0.17,2540,8518,65,NULL,'MLCS2k2','COMBO-17 41308',0.74,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31341,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Rak',NULL,31341,43.23,0.14,2550,8518,65,NULL,'SALT2','COMBO-17 41308',0.74,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31342,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Rak',NULL,31342,43.28,0.2,2610,8518,65,NULL,'MLCS17','COMBO-17 41308',0.74,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31343,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Rak',NULL,31343,43.37,0.22,2710,8518,65,NULL,'MLCS31','COMBO-17 41308',0.74,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31344,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Rak',NULL,31344,43.38,0.22,2730,8518,65,NULL,NULL,'COMBO-17 41308',0.74,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31345,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Rak',NULL,31345,43.42,0.2,2780,8518,70,NULL,'SALT','COMBO-17 41308',0.74,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31346,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Rak',NULL,31346,43.53,0.19,2920,8518,65,NULL,'SALT2','COMBO-17 41308',0.74,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31347,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Rak',NULL,31347,43.61,0.17,3040,8518,65,NULL,'SALT','COMBO-17 41308',0.74,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31348,'IRAS','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31348,32.09,0.8,26.2,8519,75,NULL,'MAT, I','UGCA 077',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000023,NULL,'14.79',0.9,'SB(s)m',NULL,NULL,NULL,NULL,1,53.079875,-17.71794,0.117,NULL,38006068463,593844819,9278825,14.79),(31349,'Tully est','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31349,31.86,0.8,23.6,8519,75,NULL,NULL,'UGCA 077',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31350,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31350,32.07,0.4,25.9,8519,NULL,NULL,NULL,'UGCA 077',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31351,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31351,32.07,0.4,25.9,8519,73,NULL,'opt','UGCA 077',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31352,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31352,32.49,0.32,31.5,8519,85,NULL,'I, inv','UGCA 077',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31353,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31353,32.52,0.32,31.9,8519,85,NULL,'I, raw','UGCA 077',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31354,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31354,32.95,0.43,38.8,8519,75,NULL,'MAT, I, inv','UGCA 077',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31355,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31355,32.98,0.43,39.4,8519,75,NULL,'MAT, I, raw','UGCA 077',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31356,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31356,33.32,0.43,46.1,8519,75,NULL,'MAT, I, cor','UGCA 077',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31357,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SDSS-II SN 17830','RN',31357,42.14,0.26,1780,8520,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17830',0.503064,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31358,'FP','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31358,35.68,0.59,137,8521,70,NULL,NULL,'2MFGC 02925',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'16.24',0.18,NULL,NULL,NULL,NULL,NULL,1,53.0855833333,-29.65428,0,NULL,38585371739,602896433,9420256,16.24),(31359,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Gre','R',31359,42.79,NULL,1690,8522,65,NULL,'MLCS17','COMBO-17 35296',1.14,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,'24.9R',NULL,'Cand. AGN2',NULL,NULL,NULL,NULL,1,53.089917,-27.78239,0,NULL,38580904611,602826634,9419166,24.9),(31360,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Gre',NULL,31360,43.53,0.22,2370,8522,74.2,NULL,'SALT 2','COMBO-17 35296',1.14,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31361,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Gre',NULL,31361,43.64,0.08,2500,8522,70,NULL,'MLCS17','COMBO-17 35296',1.14,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31362,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Gre',NULL,31362,44.25,0.13,3310,8522,65,NULL,'SALT2','COMBO-17 35296',1.14,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31363,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Gre',NULL,31363,44.28,0.28,3350,8522,70,NULL,'SALT','COMBO-17 35296',1.14,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31364,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Gre',NULL,31364,44.34,0.16,3440,8522,65,NULL,'MLCS17','COMBO-17 35296',1.14,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31365,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Gre',NULL,31365,44.44,0.14,3610,8522,65,NULL,'MLCS2k2','COMBO-17 35296',1.14,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31366,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Gre',NULL,31366,44.44,0.31,3610,8522,65,NULL,NULL,'COMBO-17 35296',1.14,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31367,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Gre',NULL,31367,44.45,0.27,3620,8522,65,NULL,'SALT','COMBO-17 35296',1.14,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31368,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002kd',NULL,31368,42.37,0.19,1720,8523,74.2,NULL,'SALT 2','COMBO-17 40676',0.735,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,'PHOT','25.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,53.0924583,-27.74081,0,NULL,38580907936,602826686,9419166,25.1),(31369,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002kd','R',31369,42.42,NULL,1760,8523,65,NULL,'SN Frodo, MLCS17','COMBO-17 40676',0.735,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31370,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002kd',NULL,31370,43.01,0.21,2310,8523,65,NULL,'SN Frodo, MLCS2k2','COMBO-17 40676',0.735,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31371,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002kd',NULL,31371,43.01,0.23,2310,8523,65,NULL,'SN Frodo, MLCS17','COMBO-17 40676',0.735,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31372,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002kd',NULL,31372,43.04,0.2,2340,8523,65,NULL,'SN Frodo, SALT2','COMBO-17 40676',0.735,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31373,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002kd',NULL,31373,43.09,0.19,2390,8523,65,NULL,NULL,'COMBO-17 40676',0.735,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31374,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002kd',NULL,31374,43.09,0.28,2390,8523,65,NULL,'SN Frodo, MLCS31','COMBO-17 40676',0.735,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31375,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002kd',NULL,31375,43.11,0.18,2410,8523,70,NULL,'SALT','COMBO-17 40676',0.735,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31376,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002kd',NULL,31376,43.14,0.19,2450,8523,65,NULL,NULL,'COMBO-17 40676',0.735,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31377,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002kd',NULL,31377,43.28,0.15,2610,8523,65,NULL,'SALT','COMBO-17 40676',0.735,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31378,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002kd',NULL,31378,43.42,0.25,2780,8523,65,NULL,'SN Frodo, SALT2','COMBO-17 40676',0.735,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31379,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002hr',NULL,31379,42.63,0.25,2200,8524,74.2,NULL,'SALT 2','COMBO-17 46259',0.526,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,'24.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,53.0940417,-27.69786,0,NULL,38580911646,602826744,9419167,24.9),(31380,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002hr','R',31380,42.86,NULL,2440,8524,65,NULL,'SALT','COMBO-17 46259',0.526,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31381,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002hr',NULL,31381,43.01,0.27,2620,8524,65,NULL,NULL,'COMBO-17 46259',0.526,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31382,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002hr',NULL,31382,43.02,0.23,2630,8524,70,NULL,'SALT','COMBO-17 46259',0.526,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31383,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002hr',NULL,31383,43.08,0.27,2710,8524,65,NULL,NULL,'COMBO-17 46259',0.526,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31384,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002hr',NULL,31384,43.13,0.21,2770,8524,65,NULL,'SALT','COMBO-17 46259',0.526,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31385,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002hr',NULL,31385,43.17,0.19,2820,8524,65,NULL,'SN Isis, MLCS2k2','COMBO-17 46259',0.526,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31386,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002hr',NULL,31386,43.36,0.32,3070,8524,65,NULL,'SN Isis, SALT2','COMBO-17 46259',0.526,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31387,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002hr',NULL,31387,43.38,0.23,3110,8524,65,NULL,'SN Isis, MLCS17','COMBO-17 46259',0.526,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31388,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002hr',NULL,31388,43.44,0.26,3200,8524,65,NULL,'SN Isis, SALT2','COMBO-17 46259',0.526,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31389,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002hr',NULL,31389,43.48,0.33,3260,8524,65,NULL,'SN Isis, MLCS31','COMBO-17 46259',0.526,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31390,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002hp','R',31390,43.55,NULL,2230,8525,65,NULL,'SALT','COMBO-17 36727',1.305,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,'25.1R',NULL,'Opt.var.',NULL,NULL,NULL,NULL,1,53.1032916667,-27.77161,0,NULL,38580904268,602826629,9419166,25.1),(31391,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002hp',NULL,31391,43.91,0.25,2630,8525,74.2,NULL,'SALT 2','COMBO-17 36727',1.305,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31392,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002hp',NULL,31392,44.42,0.29,3320,8525,70,NULL,'SALT','COMBO-17 36727',1.305,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31393,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002hp',NULL,31393,44.51,0.3,3460,8525,65,NULL,NULL,'COMBO-17 36727',1.305,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31394,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002hp',NULL,31394,44.57,0.27,3560,8525,65,NULL,'SALT','COMBO-17 36727',1.305,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31395,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002hp',NULL,31395,44.63,0.27,3650,8525,65,NULL,'SN Thoth, SALT2','COMBO-17 36727',1.305,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31396,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002hp',NULL,31396,44.7,0.22,3780,8525,65,NULL,NULL,'COMBO-17 36727',1.305,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31397,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002hp',NULL,31397,44.73,0.3,3830,8525,65,NULL,'SN Thoth, MLCS2k2','COMBO-17 36727',1.305,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31398,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Omb','R',31398,43.27,NULL,2280,8526,65,NULL,'MLCS17','EIS J033225.36-274503.0',0.975,'2010arXiv1006.2112L',2010,1,NULL,'Groenewegen et al. (2002A&A...392..741G) give photometric z = 2.23.','G',0.001,NULL,'22.85',NULL,'LCG            Sbrst',NULL,NULL,NULL,NULL,1,53.105667,-27.75083,0,NULL,38580907886,602826685,9419166,22.85),(31399,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Omb',NULL,31399,43.54,0.2,2580,8526,74.2,NULL,'SALT 2','EIS J033225.36-274503.0',0.975,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31400,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Omb',NULL,31400,43.87,0.06,3010,8526,70,NULL,'MLCS17','EIS J033225.36-274503.0',0.975,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31401,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Omb',NULL,31401,44.21,0.26,3520,8526,65,NULL,NULL,'EIS J033225.36-274503.0',0.975,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31402,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Omb',NULL,31402,44.23,0.2,3550,8526,70,NULL,'SALT','EIS J033225.36-274503.0',0.975,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31403,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Omb',NULL,31403,44.23,0.16,3560,8526,65,NULL,'SALT2','EIS J033225.36-274503.0',0.975,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31404,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Omb',NULL,31404,44.24,0.18,3570,8526,65,NULL,'MLCS2k2','EIS J033225.36-274503.0',0.975,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31405,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Omb',NULL,31405,44.24,0.17,3570,8526,70,NULL,'SALT 2','EIS J033225.36-274503.0',0.975,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31406,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Omb',NULL,31406,44.27,0.21,3620,8526,65,NULL,'MLCS17','EIS J033225.36-274503.0',0.975,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31407,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Omb',NULL,31407,44.32,0.19,3710,8526,65,NULL,'SALT2','EIS J033225.36-274503.0',0.975,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31408,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Omb',NULL,31408,44.36,0.18,3770,8526,65,NULL,'SALT','EIS J033225.36-274503.0',0.975,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31409,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Omb',NULL,31409,44.38,0.2,3800,8526,65,NULL,'MLCS31','EIS J033225.36-274503.0',0.975,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31410,'FP','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31410,36.06,0.61,163,8527,70,NULL,NULL,'ESO 482- G 004',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000103,NULL,'16.13',0.2,'Sb:',NULL,NULL,NULL,NULL,1,53.1310417,-22.3955,0.013,NULL,38041273257,594394894,9287420,16.13),(31411,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002kc',NULL,31411,39.82,0.23,757,8528,74.2,NULL,'SALT 2','APMUKS(BJ) B033029.00-275002.4',0.216,'2010ApJ...716..712A',2010,1,0.11,NULL,'G',0.0004,NULL,'19.1R',0.09,'HII',NULL,NULL,NULL,NULL,1,53.14475,-27.66586,0,NULL,38580898391,602826537,9419164,19.1),(31412,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002kc',NULL,31412,40.33,0.18,957,8528,65,NULL,NULL,'APMUKS(BJ) B033029.00-275002.4',0.216,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31413,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002kc',NULL,31413,40.33,0.19,957,8528,65,NULL,NULL,'APMUKS(BJ) B033029.00-275002.4',0.216,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31414,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002kc',NULL,31414,40.33,0.3,959,8528,65,NULL,'SN Bilbo, MLCS31','APMUKS(BJ) B033029.00-275002.4',0.216,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31415,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002kc',NULL,31415,40.44,0.22,1010,8528,65,NULL,'SN Bilbo, MLCS2k2','APMUKS(BJ) B033029.00-275002.4',0.216,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31416,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002kc',NULL,31416,40.47,0.39,1020,8528,65,NULL,'SN Bilbo, SALT2','APMUKS(BJ) B033029.00-275002.4',0.216,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31417,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002kc',NULL,31417,40.54,0.23,1050,8528,65,NULL,'SN Bilbo, MLCS17','APMUKS(BJ) B033029.00-275002.4',0.216,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31418,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002kc',NULL,31418,40.58,0.42,1080,8528,65,NULL,'SN Bilbo, SALT2','APMUKS(BJ) B033029.00-275002.4',0.216,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31419,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002kc',NULL,31419,40.75,0.17,1160,8528,70,NULL,'SALT','APMUKS(BJ) B033029.00-275002.4',0.216,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31420,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Kur',NULL,31420,41.23,0.39,1300,8529,65,NULL,NULL,'SN HST04Kur',0.359,'2007ApJ...659...98R',2007,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,53.150125,-27.85492,0,NULL,38581145945,602830405,9419225,NULL),(31421,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST04Kur',NULL,31421,43.16,0.07,3150,8529,70,NULL,'SALT','SN HST04Kur',0.359,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31422,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002fw','R',31422,43.9,NULL,2620,8530,65,NULL,'SN Aphrodite, MLCS31','COMBO-17 35663',1.3,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0,NULL,'25.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,53.1565417,-27.77964,0,NULL,38580874699,602826167,9419158,25.8),(31423,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002fw',NULL,31423,44.14,0.22,2930,8530,74.2,NULL,'SALT 2','COMBO-17 35663',1.3,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31424,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002fw',NULL,31424,44.85,0.2,4050,8530,65,NULL,'SN Aphrodite, MLCS31','COMBO-17 35663',1.3,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31425,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002fw',NULL,31425,44.86,0.17,4070,8530,65,NULL,'SN Aphrodite, MLCS17','COMBO-17 35663',1.3,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31426,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002fw',NULL,31426,44.86,0.16,4070,8530,70,NULL,'SN Aphrodite, SALT 2','COMBO-17 35663',1.3,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31427,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002fw',NULL,31427,44.86,0.08,4080,8530,70,NULL,'SN Aphrodite, MLCS31','COMBO-17 35663',1.3,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31428,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002fw',NULL,31428,44.91,0.15,4160,8530,65,NULL,'SN Aphrodite, SALT2','COMBO-17 35663',1.3,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31429,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002fw',NULL,31429,44.95,0.35,4250,8530,70,NULL,'SALT','COMBO-17 35663',1.3,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31430,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002fw',NULL,31430,44.99,0.12,4320,8530,65,NULL,'SN Aphrodite, MLCS2k2','COMBO-17 35663',1.3,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31431,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002fw',NULL,31431,45.04,0.19,4420,8530,65,NULL,'SN Aphrodite, SALT2','COMBO-17 35663',1.3,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31432,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002fw',NULL,31432,45.06,0.2,4470,8530,65,NULL,NULL,'COMBO-17 35663',1.3,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31433,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002fw',NULL,31433,45.11,0.32,4580,8530,65,NULL,'SALT','COMBO-17 35663',1.3,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31434,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2002fw',NULL,31434,45.27,0.19,4920,8530,65,NULL,NULL,'COMBO-17 35663',1.3,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31435,'FP','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31435,35.41,0.46,121,8531,70,NULL,NULL,'2MASX J03324265+0101129',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000089,NULL,'16.1g',0.35,'S0',NULL,NULL,NULL,NULL,1,53.1777083,1.02033,0.289,NULL,64988020680,1015437823,15866215,16.1),(31436,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2003aj',NULL,31436,44.39,0.27,3280,8532,74.2,NULL,'SALT 2','COMBO-17 18702',1.305,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,'24.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,53.18475,-27.91842,0,NULL,38581146820,602830419,9419225,24.8),(31437,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2003aj',NULL,31437,44.99,0.31,4320,8532,65,NULL,NULL,'COMBO-17 18702',1.305,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31438,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2003aj',NULL,31438,45.09,0.32,4520,8532,65,NULL,'SN Inanna, SALT2','COMBO-17 18702',1.305,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31439,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2003aj',NULL,31439,45.15,0.36,4640,8532,65,NULL,'SN Inanna, MLCS31','COMBO-17 18702',1.305,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31440,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2003aj',NULL,31440,45.17,0.26,4680,8532,65,NULL,'SN Inanna, MLCS2k2','COMBO-17 18702',1.305,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31441,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2003aj',NULL,31441,45.18,0.29,4720,8532,65,NULL,'SN Inanna, MLCS17','COMBO-17 18702',1.305,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31442,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2003aj',NULL,31442,45.25,0.35,4870,8532,65,NULL,'SN Inanna, SALT2','COMBO-17 18702',1.305,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31443,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2003aj',NULL,31443,45.27,0.34,4910,8532,70,NULL,'SALT','COMBO-17 18702',1.305,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31444,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SDSS-II SN 09967','RN',31444,38.73,0.12,540,8533,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 09967',0.030463,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31445,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SDSS-II SN 09967','RN',31445,39.83,0.24,898,8533,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 09967',0.030463,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31446,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST05Zwi','R',31446,41.52,NULL,1320,8534,65,NULL,'MLCS17','COMBO-17 40926',0.521,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,'22.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,53.19025,-27.74006,0,NULL,38580873801,602826153,9419158,22.1),(31447,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST05Zwi',NULL,31447,41.66,0.18,1410,8534,74.2,NULL,'SALT 2','COMBO-17 40926',0.521,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31448,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST05Zwi',NULL,31448,42.05,0.37,1690,8534,65,NULL,NULL,'COMBO-17 40926',0.521,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31449,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST05Zwi',NULL,31449,42.35,0.2,1940,8534,65,NULL,'SALT2','COMBO-17 40926',0.521,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31450,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST05Zwi',NULL,31450,42.43,0.19,2010,8534,70,NULL,'SALT','COMBO-17 40926',0.521,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31451,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST05Zwi',NULL,31451,42.45,0.19,2030,8534,65,NULL,'MLCS2k2','COMBO-17 40926',0.521,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31452,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST05Zwi',NULL,31452,42.47,0.2,2050,8534,65,NULL,'MLCS17','COMBO-17 40926',0.521,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31453,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST05Zwi',NULL,31453,42.5,0.21,2080,8534,65,NULL,'SALT2','COMBO-17 40926',0.521,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31454,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST05Zwi',NULL,31454,42.5,0.23,2080,8534,65,NULL,'MLCS31','COMBO-17 40926',0.521,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31455,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN HST05Zwi',NULL,31455,42.56,0.17,2140,8534,65,NULL,'SALT','COMBO-17 40926',0.521,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31456,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2003ak',NULL,31456,45.07,0.32,4050,8535,65,NULL,NULL,'COMBO-17 19434',1.551,'2007ApJ...659...98R',2007,1,NULL,NULL,'G',0.001,NULL,'23.6R',NULL,'Candidate LBG',NULL,NULL,NULL,NULL,1,53.195375,-27.91364,0,NULL,38581146714,602830417,9419225,23.6),(31457,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2003ak',NULL,31457,45.09,0.3,4090,8535,65,NULL,'SN Gilgamesh, MLCS31','COMBO-17 19434',1.551,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31458,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2003ak',NULL,31458,45.13,0.18,4170,8535,65,NULL,'SN Gilgamesh, MLCS2k2','COMBO-17 19434',1.551,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31459,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2003ak',NULL,31459,45.15,0.21,4210,8535,65,NULL,'SN Gilgamesh, MLCS17','COMBO-17 19434',1.551,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31460,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2003ak',NULL,31460,45.3,0.22,4500,8535,65,NULL,NULL,'COMBO-17 19434',1.551,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31461,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2003ak',NULL,31461,45.33,0.21,4560,8535,65,NULL,'SN Gilgamesh, SALT2','COMBO-17 19434',1.551,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31462,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2003ak',NULL,31462,45.33,0.4,4560,8535,70,NULL,'SALT','COMBO-17 19434',1.551,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31463,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2003ak',NULL,31463,45.4,0.61,4720,8535,65,NULL,'SALT','COMBO-17 19434',1.551,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31464,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2003ak',NULL,31464,45.75,1.16,5540,8535,65,NULL,'SN Gilgamesh, SALT2','COMBO-17 19434',1.551,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31465,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31465,31.17,1.32,17.1,8536,NULL,NULL,'TOM(g) = -7.2 mag','LSBG F358-061',NULL,'2010ApJ...717..603V',2010,1,1.1,NULL,'G',0.000117,NULL,'15.02',0.6,'SAB(s)0-:','Group member',NULL,NULL,NULL,1,53.1985417,-34.23869,0,NULL,38565772945,602590202,9415471,15.02),(31466,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31466,31.77,1.88,22.6,8536,NULL,NULL,'TOM(z) = -8.53 mag','LSBG F358-061',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31467,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31467,31.47,0.14,19.7,8536,74.4,NULL,NULL,'LSBG F358-061',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31468,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31468,31.49,0.07,19.9,8536,NULL,NULL,'HST ACS FCS','LSBG F358-061',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31469,'GC radius','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31469,31.28,0.86,18.1,8536,NULL,NULL,'HST ACS FCS','LSBG F358-061',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31470,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SDSS-II SN 18353','RN',31470,39.43,0.25,679,8537,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18353',0.132394,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31471,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SDSS-II SN 18353','RN',31471,40.16,0.45,952,8537,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18353',0.132394,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31472,'FP','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31472,38.62,0.46,530,8538,70,NULL,NULL,'2MASX J03324885+0043573',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000155,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,53.203667,0.73269,0.273,NULL,64988513691,1015445526,15866336,18),(31473,'FP','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31473,36.86,0.61,235,8539,70,NULL,NULL,'6dF J0332537-350824',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,53.223625,-35.14011,0,NULL,38564448017,602569500,9415148,14.6),(31474,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SDSS-II SN 07296',NULL,31474,40.38,0.12,1190,8540,70,NULL,'SN photometric redshift distance, z photo =0.331 +/- 0.023','SDSS-II SN 07296',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.7g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,53.223833,-0.52611,0.265,NULL,36815696195,575245253,8988207,21.7),(31475,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SDSS-II SN 18920',NULL,31475,40.41,0.14,1210,8541,70,NULL,'SN photometric redshift distance, z photo =0.337 +/- 0.028','SDSS-II SN 18920',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,53.225167,0.53269,0.273,NULL,64987722557,1015433164,15866143,NULL),(31476,'FP','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31476,37.53,0.46,321,8542,70,NULL,NULL,'2MASX J03325712+0027403',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000079,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,53.2380417,0.46139,0.257,NULL,64987710654,1015432978,15866140,17.6),(31477,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SDSS-II SN 14260','RN',31477,41.17,0.32,1260,8543,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14260',0.3667,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31478,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SDSS-II SN 14260','RN',31478,41.36,0.29,1370,8543,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14260',0.3667,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31479,'FP','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31479,36.56,0.46,205,8544,70,NULL,NULL,'2MASX J03325728-0042149',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000104,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,53.238583,-0.70414,0.289,NULL,36816357102,575255579,8988368,16.8),(31480,'LSB galaxies','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31480,30.66,NULL,13.6,8545,NULL,NULL,NULL,'ESO 358- G 014',NULL,'1991ApJ...376..404B',1991,1,2,'Possible Galactic planetary nebula.','G',NULL,NULL,'16.8B',1.6,'E5:','Group member',NULL,NULL,NULL,1,53.2390417,-35.73764,0,NULL,38563711105,602557986,9414968,16.8),(31481,'LSB galaxies','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31481,31.99,NULL,25,8546,NULL,NULL,NULL,'[BIM91] F2L10',NULL,'1991ApJ...376..404B',1991,1,NULL,NULL,'G',NULL,NULL,'19.5',NULL,'Low Surf. Brightness',NULL,NULL,NULL,NULL,1,53.241375,-35.94822,0,NULL,38563504946,602554764,9414918,19.5),(31482,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31482,35.44,0.49,122,8547,75,NULL,'IR','UGC 02781',NULL,'2011yCatp016004901K',2011,1,1.46,NULL,'G',0.000016,NULL,'17.',0.1,'Scd',NULL,NULL,NULL,NULL,1,53.2462083,15.87458,0.633,NULL,68028825352,1062950396,16608599,17),(31483,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31483,35.76,0.35,142,8547,NULL,NULL,'Malmquist cor.','UGC 02781',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31484,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31484,36,NULL,159,8547,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02781',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31485,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31485,36.01,NULL,159,8547,NULL,NULL,'Dipole + Quadrupole','UGC 02781',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31486,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31486,36,0.32,159,8547,NULL,NULL,NULL,'UGC 02781',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31487,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31487,36.01,NULL,159,8547,NULL,NULL,'Dipole','UGC 02781',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31488,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31488,36.04,NULL,162,8547,NULL,NULL,NULL,'UGC 02781',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31489,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31489,36.08,0.2,164,8547,74.4,NULL,NULL,'UGC 02781',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31490,'FP','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31490,38.29,0.46,455,8548,70,NULL,NULL,'SDSS J033259.90-063730.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000069,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,53.249583,-6.62511,0.097,NULL,36798490054,574976407,8984006,18.4),(31491,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31491,32.36,NULL,29.7,8549,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 482- G 005',NULL,'2010Ap&SS.325..163P',2010,1,1.68,NULL,'G',0.00001,NULL,'15.40',0.21,'SB(s)dm: sp',NULL,NULL,NULL,NULL,1,53.259375,-24.13286,0.013,NULL,38021804902,594090701,9282667,15.4),(31492,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31492,32.37,NULL,29.8,8549,NULL,NULL,'Dipole + Quadrupole','ESO 482- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31493,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31493,32.44,NULL,30.8,8549,NULL,NULL,'Dipole','ESO 482- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31494,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31494,32.49,0.43,31.5,8549,75,NULL,'3.6 micron, color + selection bias corrected','ESO 482- G 005',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31495,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31495,31.04,0.4,16.1,8550,NULL,NULL,NULL,'ESO 358- G 015',NULL,'2009AJ....138..323T',2009,1,1.2,NULL,'G',0.000011,NULL,'14.8B',0.7,'SBm: pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,53.2785417,-34.80811,0,NULL,38563823703,602559745,9414996,14.8),(31496,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31496,31.03,0.39,16.1,8550,73,NULL,'opt','ESO 358- G 015',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31497,'FP','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31497,36.31,0.62,183,8551,70,NULL,NULL,'2MASX J03331160-5519006',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.000083,NULL,'16.97',0.23,NULL,NULL,NULL,NULL,NULL,1,53.298375,-55.31681,0.013,NULL,35778941092,559045954,8735093,16.97),(31498,'BL Lac Luminosity','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31498,40.96,NULL,1190,8552,NULL,NULL,NULL,'NVSS J033312-361947',0.308,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.003,NULL,'17.5R',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,53.3010417,-36.32961,0,NULL,38556152354,602439880,9413123,17.5),(31499,'TRGB','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31499,28.91,0.05,6.06,8553,NULL,NULL,NULL,'IC 1959',NULL,'2006AJ....132..729T',2006,1,2.8,NULL,'G',0.000003,NULL,'13.2B',0.7,'SB(s)m: sp','X-ray-faint group member',NULL,NULL,NULL,1,53.3024583,-50.41425,0,NULL,37725831408,589466115,9210408,13.2),(31500,'TRGB','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31500,29.03,0.04,6.4,8553,NULL,NULL,'I','IC 1959',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31501,'TRGB','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31501,29.1,0.09,6.61,8553,74.4,NULL,NULL,'IC 1959',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31502,'IRAS','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31502,29.38,0.8,7.51,8553,75,NULL,'MAT, I','IC 1959',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31503,'Tully est','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31503,28.91,0.8,6,8553,75,NULL,NULL,'IC 1959',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31504,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31504,29.1,0.09,6.61,8553,74.4,NULL,NULL,'IC 1959',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31505,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31505,29.23,0.32,6.96,8553,85,NULL,'I, inv','IC 1959',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31506,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31506,29.29,0.32,7.19,8553,85,NULL,'I, raw','IC 1959',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31507,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31507,29.59,0.43,8.3,8553,75,NULL,'3.6 micron, color + selection bias corrected','IC 1959',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31508,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31508,29.67,0.39,8.6,8553,73,NULL,'IR','IC 1959',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31509,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31509,29.67,0.4,8.6,8553,75,NULL,NULL,'IC 1959',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31510,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31510,29.68,0.43,8.6,8553,75,NULL,'3.6 micron, color corrected','IC 1959',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31511,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31511,29.69,0.43,8.67,8553,75,NULL,'MAT, I, inv','IC 1959',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31512,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31512,29.86,0.43,9.36,8553,75,NULL,'MAT, I, raw','IC 1959',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31513,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31513,30.13,0.4,10.6,8553,NULL,NULL,NULL,'IC 1959',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31514,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31514,30.21,0.43,11,8553,75,NULL,'MAT, I, cor','IC 1959',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31515,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31515,30.56,0.49,13,8553,75,NULL,'IR','IC 1959',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31516,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31516,31.3,0.19,18.2,8554,NULL,NULL,'R','FCC 116',NULL,'2003A&A...398...63J',2003,1,0.78,NULL,'G',0.00015,NULL,'16.3B',0.66,'dE1,N','Group member',NULL,NULL,NULL,1,53.303167,-36.01736,0,NULL,38567727935,602620748,9415949,16.3),(31517,'Tully est','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31517,31.96,0.8,24.7,8555,75,NULL,'B','NGC 1357',NULL,'1988NBGC.C....0000T',1988,1,2.8,NULL,'G',0.00004,NULL,'12.83',1.9,'SA(s)ab',NULL,NULL,NULL,NULL,1,53.321167,-13.66414,0.085,NULL,38000898605,593764040,9277563,12.83),(31518,'FP','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31518,37.36,0.46,296,8556,70,NULL,NULL,'2MASX J03332081-0720271',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000085,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,53.336875,-7.34081,0.109,NULL,36797970290,574968285,8983879,16.8),(31519,'FP','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31519,32.88,0.49,37.6,8557,70,NULL,NULL,'NGC 1355',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.0001,NULL,'14.56',0.4,'S0: sp','in a pair',NULL,NULL,NULL,1,53.347917,-4.99869,0.101,NULL,36830155248,575471175,8991737,14.56),(31520,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SDSS-II SN 15028','RN',31520,41.74,0.13,1680,8558,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 15028',0.321289,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31521,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SDSS-II SN 15028','RN',31521,41.77,0.21,1710,8558,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 15028',0.321289,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31522,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31522,31.49,0.4,19.9,8559,75,NULL,NULL,'IC 1952',NULL,'2008Ap.....51..336K',2008,1,2.6,NULL,'G',0.000013,NULL,'13.55',0.6,'SB(s)bc?       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,53.361125,-23.71278,0.013,NULL,38038685159,594354455,9286788,13.55),(31523,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31523,31.49,0.4,19.9,8559,73,NULL,'IR','IC 1952',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31524,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31524,31.64,0.49,21.3,8559,75,NULL,'IR','IC 1952',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31525,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31525,31.76,0.43,22.5,8559,75,NULL,'3.6 micron, color + selection bias corrected','IC 1952',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31526,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31526,31.81,0.43,23,8559,75,NULL,'3.6 micron, color corrected','IC 1952',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31527,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31527,31.87,0.2,23.7,8559,74.4,NULL,NULL,'IC 1952',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31528,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SDSS-II SN 14617',NULL,31528,39.98,0.17,989,8560,70,NULL,'SN photometric redshift distance, z photo =0.265 +/- 0.026','SDSS-II SN 14617',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,53.364667,1.02022,0.305,NULL,64992443976,1015506937,15867295,NULL),(31529,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','PS1 SN PS10d','N',31529,40.34,0.13,949,8561,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10d HOST',0.2304,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31530,'FP','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31530,38.04,0.46,406,8562,70,NULL,NULL,'2MASX J03332862-0006124',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000091,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,53.369417,-0.10339,0.273,NULL,36815514153,575242408,8988162,17.2),(31531,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31531,33.99,0.49,62.9,8563,75,NULL,'IR','UGC 02782',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000057,NULL,'17.',0.2,'Sdm:',NULL,NULL,NULL,NULL,1,53.3740417,40.36567,0.849,NULL,68555160883,1071174388,16737099,17),(31532,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SDSS-II SN 16179','R',31532,38.02,0.07,357,8564,70,NULL,'SDSS CAND. SNIc; MLCS2K2; SN 2006nx','SN 2006nx',0.125,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ib/c',NULL,NULL,NULL,NULL,1,53.377625,-0.67728,0.289,NULL,36823969875,575374529,8990227,NULL),(31533,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SDSS-II SN 16179','R',31533,38.3,0.21,406,8564,70,NULL,'SDSS CAND. SNIc; SALT 2; SN 2006nx','SN 2006nx',0.125,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31534,'FP','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31534,36.17,0.33,171,8565,70,NULL,NULL,'2MASX J03333355-0547034',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000076,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,53.3897083333,-5.78428,0.073,NULL,36829431468,575459866,8991560,16.7),(31535,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31535,32.66,0.95,34,8566,NULL,NULL,'TOM(g) = -7.2 mag','FCC 119',NULL,'2010ApJ...717..603V',2010,1,1.2,NULL,'G',0.000023,NULL,'15.04',1.1,'(R\')SA(r)0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,53.391,-33.57331,0,NULL,38565656652,602588385,9415443,15.04),(31536,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31536,33.68,7.39,54.5,8566,NULL,NULL,'TOM(z) = -8.53 mag','FCC 119',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31537,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31537,31.52,0.14,20.1,8566,74.4,NULL,NULL,'FCC 119',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31538,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31538,31.54,0.1,20.3,8566,NULL,NULL,'HST ACS FCS','FCC 119',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31539,'FP','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31539,36.29,0.56,181,8567,70,NULL,NULL,'2MASX J03333580-1344286',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'16.48',0.69,NULL,NULL,NULL,NULL,NULL,1,53.399167,-13.74131,0.097,NULL,38000768426,593762006,9277531,16.48),(31540,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31540,30.61,0.04,13.2,8568,73,NULL,'Cepheids periods Gaussian, Data 1','NGC 1365',NULL,'2009RoAJ...19...35A',2009,1,11.2,'Extended HIPASS source','G',0.000003,NULL,'10.32',6.2,'(R\')SBb(s)b;HIISy1.8','Possible group member',NULL,NULL,'Sy 1.8',1,53.4015417,-36.14039,0,NULL,38567733605,602620837,9415950,10.32),(31541,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31541,30.66,0.06,13.6,8568,73,NULL,'Cepheids periods Gaussian, Data 2','NGC 1365',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31542,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31542,30.73,0.03,14,8568,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian, Data 1','NGC 1365',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31543,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31543,30.76,0.04,14.2,8568,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian, Data 2','NGC 1365',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31544,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31544,30.86,0.02,14.9,8568,73,NULL,'Cepheids magnitudes Gaussian, Data 1','NGC 1365',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31545,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31545,30.86,0.02,14.9,8568,73,NULL,'Cepheids magnitudes Gaussian, Data 2','NGC 1365',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31546,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31546,31.18,0.05,17.2,8568,NULL,NULL,'47, VI, KEY PROJECT','NGC 1365',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31547,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31547,31.19,0.05,17.3,8568,NULL,NULL,'cte LMC K03','NGC 1365',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31548,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31548,31.19,0.05,17.3,8568,NULL,NULL,'cte U99','NGC 1365',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31549,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31549,31.22,0.05,17.5,8568,NULL,NULL,'cte LMC STS02','NGC 1365',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31550,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31550,31.25,0.1,17.8,8568,74.4,NULL,NULL,'NGC 1365',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (31551,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31551,31.26,0.06,17.8,8568,NULL,NULL,'LMC W01','NGC 1365',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31552,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31552,31.27,0.05,17.9,8568,NULL,NULL,'47, VI, +Z, KEY PROJECT','NGC 1365',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31553,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31553,31.26,0.06,17.9,8568,NULL,NULL,'MW HIPP','NGC 1365',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31554,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31554,31.26,0.1,17.9,8568,NULL,NULL,'34, VI, DoPHOT','NGC 1365',NULL,'1999ApJ...515....1S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31555,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31555,31.28,0.05,18.1,8568,NULL,NULL,'cte MW FSG03','NGC 1365',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31556,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31556,31.31,0.09,18.2,8568,NULL,NULL,'25, VI (WF)','NGC 1365',NULL,'2000ApJ...530L...5G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31557,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31557,31.31,0.13,18.3,8568,NULL,NULL,'9, VI (PC)','NGC 1365',NULL,'2000ApJ...530L...5G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31558,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31558,31.31,0.15,18.3,8568,NULL,NULL,'MW P02','NGC 1365',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31559,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31559,31.31,0.2,18.3,8568,NULL,NULL,'34, VI, ALLFRAME','NGC 1365',NULL,'1999ApJ...515....1S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31560,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31560,31.32,0.05,18.3,8568,NULL,NULL,'cte MF91','NGC 1365',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31561,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31561,31.32,0.05,18.4,8568,NULL,NULL,'50, VI','NGC 1365',NULL,'1996AAS...18910804M',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31562,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31562,31.34,0.05,18.5,8568,NULL,NULL,'cte MW GFG98','NGC 1365',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31563,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31563,31.35,0.07,18.6,8568,NULL,NULL,'37, VI(W)','NGC 1365',NULL,'1998Natur.395...47M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31564,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31564,31.36,0.27,18.7,8568,NULL,NULL,'3, H','NGC 1365',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31565,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31565,31.36,0.27,18.7,8568,NULL,NULL,'3, H','NGC 1365',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31566,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31566,31.38,0.07,18.9,8568,NULL,NULL,'152, VI','NGC 1365',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31567,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31567,31.38,0.07,18.9,8568,NULL,NULL,'MW GFG','NGC 1365',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31568,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31568,31.39,0.1,19,8568,NULL,NULL,'HST KP Calibrated','NGC 1365',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31569,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31569,31.39,0.1,19,8568,NULL,NULL,'26, VI','NGC 1365',NULL,'1999ApJ...515...29M',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31570,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31570,31.41,0.05,19.2,8568,NULL,NULL,'cte MW STS03','NGC 1365',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31571,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31571,31.46,NULL,19.6,8568,NULL,18.54,NULL,'NGC 1365',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31572,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31572,31.46,0.06,19.6,8568,NULL,18.54,'LMC ZP','NGC 1365',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31573,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31573,31.5,0.1,20,8568,NULL,NULL,'Z, Key Project','NGC 1365',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31574,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31574,31.69,0.21,21.8,8568,NULL,NULL,'3, I','NGC 1365',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31575,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31575,31.69,0.21,21.8,8568,NULL,NULL,'3, I','NGC 1365',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31576,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31576,31.99,0.11,25,8568,NULL,NULL,'3, V','NGC 1365',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31577,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31577,31.99,0.11,25,8568,NULL,NULL,'3, V','NGC 1365',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31578,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31578,32.09,NULL,26.2,8568,NULL,NULL,'40, VI','NGC 1365',NULL,'2006A&A...452..423P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31579,'SNII optical','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2001du',NULL,31579,31.08,0.16,16.4,8568,NULL,NULL,'SCM, Hamuy 2003','NGC 1365',NULL,'2015A&A...580L..15P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31580,'SNII optical','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2001du',NULL,31580,31.09,0.16,16.5,8568,NULL,NULL,'SCM, Poznanski et al. 2009','NGC 1365',NULL,'2015A&A...580L..15P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31581,'SNII optical','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2001du',NULL,31581,31.26,0.16,17.9,8568,NULL,NULL,'SCM, D\'Andrea et al. 2010','NGC 1365',NULL,'2015A&A...580L..15P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31582,'SNII optical','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SN 2001du',NULL,31582,31.34,0.16,18.5,8568,NULL,NULL,'SCM, Nugent et al. 2006','NGC 1365',NULL,'2015A&A...580L..15P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31583,'IRAS','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31583,31.8,0.8,22.9,8568,75,NULL,'MAT, I','NGC 1365',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31584,'IRAS','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31584,31.84,0.8,23.3,8568,75,NULL,'A82, H','NGC 1365',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31585,'Sosies','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31585,30.96,0.13,15.6,8568,NULL,NULL,NULL,'NGC 1365',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31586,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31586,29.52,NULL,8,8568,75,NULL,'CO','NGC 1365',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31587,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31587,29.7,NULL,8.7,8568,75,NULL,'HI','NGC 1365',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31588,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31588,30.26,0.47,11.3,8568,75,NULL,'A82, H, raw','NGC 1365',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31589,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31589,30.45,0.4,12.3,8568,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 1365',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31590,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31590,30.45,0.47,12.3,8568,75,NULL,'A82, H, inv','NGC 1365',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31591,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31591,30.68,0.47,13.7,8568,75,NULL,'A82, H, cor','NGC 1365',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31592,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31592,30.93,0.43,15.3,8568,75,NULL,'MAT, I, raw','NGC 1365',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31593,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31593,31.14,0.4,16.9,8568,75,NULL,'B','NGC 1365',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31594,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31594,31.15,NULL,17,8568,NULL,NULL,'I','NGC 1365',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31595,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31595,31.16,0.35,17.1,8568,NULL,NULL,NULL,'NGC 1365',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31596,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31596,31.19,0.08,17.3,8568,NULL,NULL,'I','NGC 1365',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31597,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31597,31.2,0.07,17.4,8568,NULL,NULL,'B','NGC 1365',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31598,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31598,31.22,0.32,17.5,8568,85,NULL,'I, raw','NGC 1365',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31599,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31599,31.21,0.43,17.5,8568,75,NULL,'MAT, I, cor','NGC 1365',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31600,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31600,31.22,0.4,17.5,8568,73,NULL,'opt','NGC 1365',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31601,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31601,31.24,0.43,17.7,8568,75,NULL,'MAT, I, inv','NGC 1365',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31602,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31602,31.27,0.05,17.9,8568,75,NULL,NULL,'NGC 1365',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31603,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31603,31.3,0.32,18.2,8568,85,NULL,'I, inv','NGC 1365',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31604,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31604,31.31,NULL,18.3,8568,NULL,NULL,'B','NGC 1365',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31605,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,'R',31605,31.32,NULL,18.4,8568,NULL,NULL,'LEDA [April 2006]','NGC 1365',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31606,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:03','1',NULL,NULL,31606,31.38,0.06,18.9,8568,NULL,NULL,NULL,'NGC 1365',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31607,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:03','1','SDSS-II SN 06852','R',31607,40.57,0.12,1000,8569,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2005jf','SN 2005jf',0.3006,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia?',NULL,NULL,NULL,NULL,1,53.419833,-0.11208,0.273,NULL,36823898340,575373411,8990209,NULL),(31608,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 06852','R',31608,41.12,0.27,1290,8569,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2005jf','SN 2005jf',0.3006,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31609,'Ring Diameter','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31609,31.5,0.76,20,8570,NULL,NULL,'Published at H = 100 km/s/Mpc','IC 1953',NULL,'1981ApJS...45..541P',1981,1,2.8,NULL,'G',0.00002,NULL,'12.81',2.1,'SB(rs)d        HII','Possible group member',NULL,NULL,NULL,1,53.4244583,-21.47864,0.029,NULL,38049103200,594517237,9289331,12.81),(31610,'Ring Diameter','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31610,32.3,0.6,29,8570,NULL,NULL,'Published at H = 100 km/s/Mpc','IC 1953',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31611,'IRAS','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31611,32.02,0.8,25.3,8570,75,NULL,'MAT, I','IC 1953',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31612,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31612,31.62,0.32,21.1,8570,85,NULL,'I, raw','IC 1953',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31613,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31613,31.63,0.43,21.2,8570,75,NULL,'MAT, I, raw','IC 1953',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31614,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31614,31.63,0.32,21.2,8570,85,NULL,'I, inv','IC 1953',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31615,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31615,31.71,0.09,22,8570,NULL,NULL,NULL,'IC 1953',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31616,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31616,31.73,0.4,22.1,8570,75,NULL,'B','IC 1953',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31617,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31617,31.73,0.43,22.2,8570,75,NULL,'MAT, I, inv','IC 1953',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31618,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31618,31.8,0.43,22.9,8570,75,NULL,'MAT, I, cor','IC 1953',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31619,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31619,32.17,0.4,27.1,8570,NULL,NULL,'mean','IC 1953',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31620,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31620,32.21,0.46,27.6,8570,NULL,NULL,'J','IC 1953',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31621,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31621,32.23,0.45,27.9,8570,NULL,NULL,'K','IC 1953',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31622,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31622,32.24,0.47,28.1,8570,NULL,NULL,'H','IC 1953',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31623,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31623,37.36,0.8,297,8571,70,NULL,NULL,'2MASX J03334284-2412026',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.50',0.31,NULL,NULL,NULL,NULL,NULL,1,53.4285417,-24.20072,0.009,NULL,38022287877,594098248,9282785,16.5),(31624,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31624,37.75,0.46,356,8572,70,NULL,NULL,'SDSS J033343.05+001837.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000087,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,53.4294166667,0.31031,0.253,NULL,64991838096,1015497470,15867147,18.8),(31625,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31625,35.96,0.46,156,8573,70,NULL,NULL,'2MASX J03334409-0031384',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000113,NULL,'16.0g',0.34,'E0',NULL,NULL,NULL,NULL,1,53.433625,-0.52728,0.289,NULL,36824001694,575375026,8990234,16),(31626,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 18130',NULL,31626,40.94,0.22,1540,8574,70,NULL,'SN photometric redshift distance, z photo =0.458 +/- 0.067','SDSS-II SN 18130',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,53.4412083,0.59536,0.257,NULL,64991972125,1015499564,15867180,NULL),(31627,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31627,34.32,NULL,73.2,8575,NULL,NULL,NULL,'FGC 0434',NULL,'2000BSAO...50....5K',2000,1,1.25,NULL,'G',0.00004,NULL,'16.6',0.11,'Sd',NULL,NULL,NULL,NULL,1,53.442083,-9.82639,0.061,NULL,36795726291,574933223,8983331,16.6),(31628,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31628,34.34,NULL,74,8575,NULL,NULL,'Dipole','FGC 0434',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31629,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31629,34.35,NULL,74,8575,NULL,NULL,'Dipole + Quadrupole','FGC 0434',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31630,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31630,34.35,NULL,74.2,8575,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0434',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31631,'IRAS','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31631,32.13,0.8,26.7,8576,75,NULL,'MAT, I','NGC 1359',NULL,'1997ApJS..109..333W',1997,1,2.4,NULL,'G',0.000013,NULL,'13.28',1.7,'SB(s)m? pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,53.4487917,-19.49206,0.073,NULL,38047988563,594499821,9289059,13.28),(31632,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31632,31.7,0.09,21.9,8576,NULL,NULL,NULL,'NGC 1359',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31633,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31633,31.87,0.4,23.7,8576,75,NULL,'B','NGC 1359',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31634,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31634,32.57,0.32,32.7,8576,85,NULL,'I, raw','NGC 1359',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31635,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31635,32.59,0.32,32.9,8576,85,NULL,'I, inv','NGC 1359',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31636,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31636,32.95,0.43,38.8,8576,75,NULL,'MAT, I, raw','NGC 1359',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31637,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31637,32.95,0.4,38.9,8576,NULL,NULL,NULL,'NGC 1359',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31638,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31638,32.95,0.4,38.9,8576,73,NULL,'opt','NGC 1359',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31639,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31639,33.07,0.43,41.1,8576,75,NULL,'MAT, I, inv','NGC 1359',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31640,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31640,33.28,0.43,45.3,8576,75,NULL,'MAT, I, cor','NGC 1359',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31641,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 10843','R',31641,41.27,0.3,1330,8577,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 10843',0.351,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,53.4525417,0.09928,0.273,NULL,64991802847,1015496919,15867139,NULL),(31642,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 10843','R',31642,41.35,0.29,1380,8577,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 10843',0.351,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31643,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 2005gq',NULL,31643,40.89,0.2,1100,8578,74.2,NULL,'SALT 2','SDSS J033348.86+004233.4',0.37,'2010ApJ...716..712A',2010,1,0.05,NULL,'G',0.0005,NULL,'22.0g',0.01,NULL,NULL,NULL,NULL,NULL,1,53.453625,0.70931,0.289,NULL,64991976788,1015499637,15867181,22),(31644,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 2005gq',NULL,31644,40.84,0.22,1470,8578,70,NULL,'Hubble residual 0.17 for z0.38980','SDSS J033348.86+004233.4',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31645,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 05183','R',31645,41.56,0.33,1480,8578,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005gq','SDSS J033348.86+004233.4',0.3898,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31646,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 05183','R',31646,41.7,0.31,1580,8578,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005gq','SDSS J033348.86+004233.4',0.3898,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31647,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 2005gq',NULL,31647,41.97,0.16,1810,8578,65,NULL,'MLCS2k2','SDSS J033348.86+004233.4',0.37,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31648,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 2005gq',NULL,31648,42.07,0.39,1890,8578,72,NULL,'SDSS 5183','SDSS J033348.86+004233.4',0.37,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31649,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 2005gq',NULL,31649,42.51,0.89,2320,8578,65,NULL,'SALT2','SDSS J033348.86+004233.4',0.37,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31650,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31650,31.74,0.25,22.3,8579,74.4,NULL,NULL,'NGC 1362',NULL,'2013AJ....146...86T',2013,1,1.2,'Star (or compact companion?) superposed 10 arcsec south of the nucleus.','G',0.000097,NULL,'14.11',1.1,'S0^0^ pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,53.4711666667,-20.28264,0.037,NULL,38049891428,594529553,9289524,14.11),(31651,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31651,31.66,0.4,21.5,8579,NULL,NULL,'mean','NGC 1362',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31652,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31652,32.87,0.45,37.5,8579,NULL,NULL,'K','NGC 1362',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31653,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31653,31.35,0.43,18.6,8580,NULL,NULL,'KS','NGC 1366',NULL,'2002ApJ...564..216L',2002,1,2.1,'ESO-LV gives v= 758+/-29 km/sec.','G',0.000063,NULL,'13.03',0.9,'S0^0^','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,53.473667,-31.19411,0,NULL,38572229987,602691093,9417048,13.03),(31654,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31654,31.42,0.12,19.2,8580,74.4,NULL,NULL,'NGC 1366',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31655,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31655,31.62,0.29,21.2,8580,NULL,NULL,'I','NGC 1366',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31656,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31656,31.42,0.12,19.2,8580,74.4,NULL,NULL,'NGC 1366',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31657,'Tully est','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31657,30.32,0.8,11.6,8580,75,NULL,'B','NGC 1366',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31658,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31658,31.23,0.45,17.6,8580,NULL,NULL,'K','NGC 1366',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31659,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31659,31.67,0.4,21.6,8580,NULL,NULL,'mean','NGC 1366',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31660,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31660,36.17,0.33,171,8581,70,NULL,NULL,'2MASX J03335432-0551373',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00009,NULL,'16.1g',0.31,'S0',NULL,NULL,NULL,NULL,1,53.476333,-5.86025,0.073,NULL,36829435536,575459930,8991561,16.1),(31661,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31661,36.09,0.46,165,8582,70,NULL,NULL,'2MASX J03335440-0634536',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000099,NULL,'15.5g',0.46,'E0',NULL,NULL,NULL,NULL,1,53.4767917,-6.58161,0.097,NULL,36798363178,574974424,8983975,15.5),(31662,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31662,35.39,0.49,120,8583,75,NULL,'IR','MCG -01-10-004',NULL,'2011yCatp016004901K',2011,1,2.11,NULL,'G',0.00003,NULL,'15.1g',0.28,'SAB(r)cd: sp',NULL,NULL,NULL,NULL,1,53.4950416667,-7.14072,0.093,NULL,36799968396,574999506,8984367,15.1),(31663,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31663,37.97,0.46,393,8584,70,NULL,NULL,'2MASX J03335929+0109196',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000081,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,53.497125,1.15533,0.305,NULL,64992512944,1015508014,15867312,17.7),(31664,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31664,33.37,0.2,47.2,8585,74.4,NULL,NULL,'UGC 02786',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',NULL,NULL,'17.',0.9,'SB(s)d:',NULL,NULL,NULL,NULL,1,53.552,2.97364,0.353,NULL,64991331581,1015489555,15867024,17),(31665,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31665,33.41,0.51,48.1,8585,NULL,NULL,'Malmquist cor.','UGC 02786',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31666,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31666,33.42,0.51,48.3,8585,NULL,NULL,NULL,'UGC 02786',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31667,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31667,35.98,0.49,157,8586,70,NULL,NULL,'FCCB 0933',NULL,'2014MNRAS.445.2677S',2014,1,0.69,NULL,'G',0.00015,NULL,'16.00',0.3,'(RL)SB0^+:','Group non-member, background',NULL,NULL,NULL,1,53.5554583,-37.29353,0,NULL,38589562454,602961913,9421279,16),(31668,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 14925',NULL,31668,38.92,0.34,609,8587,70,NULL,'SN photometric redshift distance, z photo =0.154 +/- 0.029','SDSS-II SN 14925',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,53.569417,-1.20089,0.297,NULL,36824239790,575378746,8990292,NULL),(31669,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31669,35.5,0.53,126,8588,70,NULL,NULL,'ESO 418- G 011',NULL,'2014MNRAS.445.2677S',2014,1,1.7,'Theureau, et al. (1998A&AS..130..333T) give v = 5450 +/- 20 km/sec.','G',0.000083,NULL,'15.04',1.3,'(R\')SA(rl)b',NULL,NULL,NULL,NULL,1,53.57,-30.73253,0,NULL,38573977901,602718404,9417475,15.04),(31670,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31670,34.65,0.46,85,8589,70,NULL,NULL,'NGC 1361',NULL,'2015arXiv151105856S',2015,1,1.18,'MCG misidentifies this as NGC 1369.','G',0.000094,NULL,'14.1g',0.86,'E+ pec:',NULL,NULL,NULL,NULL,1,53.5739166667,-6.265,0.061,NULL,36798210510,574972039,8983938,14.1),(31671,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','PS1 SN PS10cad','N',31671,40.58,0.14,1030,8590,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10cad HOST',0.2696,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31672,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31672,33.58,0.25,52,8591,74.4,NULL,NULL,'CGCG 525-043',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000053,NULL,'15.0',0.3,NULL,NULL,NULL,NULL,NULL,1,53.5815,39.59394,0.713,NULL,68689635858,1073275560,16769930,15),(31673,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 14359','RN',31673,41.85,0.24,1750,8592,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 14359',0.335562,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31674,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 14359','RN',31674,42.45,0.27,2320,8592,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 14359',0.335562,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31675,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31675,34.09,0.4,65.8,8593,NULL,NULL,'mean','UGC 02785',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000067,NULL,'16.5',0.2,'Scd:',NULL,NULL,NULL,NULL,1,53.5912917,40.91931,1.045,NULL,68555785047,1071184141,16737252,16.5),(31676,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31676,34.35,0.49,74.2,8593,75,NULL,'IR','UGC 02785',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31677,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31677,34.47,0.45,78.5,8593,NULL,NULL,'K','UGC 02785',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31678,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31678,34.48,0.47,78.9,8593,NULL,NULL,'H','UGC 02785',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31679,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 2006hu',NULL,31679,38.92,0.14,609,8594,70,NULL,'Hubble residual 0.29 for z0.13300','SDSS-II SN 14108 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,53.5947083,-1.12314,0.301,NULL,36824895148,575388986,8990452,NULL),(31680,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 14108','R',31680,39.3,0.21,638,8594,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006hu','SDSS-II SN 14108 HOST',0.133,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31681,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 14108','R',31681,39.58,0.08,729,8594,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006hu','SDSS-II SN 14108 HOST',0.133,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31682,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31682,31.17,0.16,17.1,8595,NULL,NULL,'TOM(g) = -7.2 mag','MCG -06-08-027',NULL,'2010ApJ...717..603V',2010,1,1.3,NULL,'G',0.000003,NULL,'14.8B',1,'SAB(rs)0^0^','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,53.622833,-35.54639,0,NULL,38567865414,602622897,9415982,14.8),(31683,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31683,31.54,0.1,20.3,8595,NULL,NULL,'TOM(z) = -8.53 mag','MCG -06-08-027',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31684,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31684,31.37,0.14,18.8,8595,74.4,NULL,NULL,'MCG -06-08-027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31685,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31685,31.39,0.08,18.9,8595,NULL,NULL,'HST ACS FCS','MCG -06-08-027',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31686,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31686,31.55,0.14,20.4,8595,NULL,NULL,'R','MCG -06-08-027',NULL,'2003A&A...398...63J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31687,'GC radius','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31687,31.14,0.2,16.9,8595,NULL,NULL,'HST ACS FCS','MCG -06-08-027',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31688,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','PS1 SN PS10bmk','N',31688,38.08,0.17,375,8596,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10bmk HOST',0.1029,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31689,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 04321','RN',31689,42.66,0.22,2380,8597,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04321',0.429343,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31690,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 04321','RN',31690,43.39,0.19,3330,8597,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 04321',0.429343,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31691,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31691,34.13,0.54,67,8598,70,NULL,NULL,'MCG -01-10-006',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'14.49',0.6,'Sa',NULL,NULL,NULL,NULL,1,53.633667,-4.81072,0.101,NULL,36829920061,575467500,8991679,14.49),(31692,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 21405',NULL,31692,41.4,0.13,1900,8599,70,NULL,'SN photometric redshift distance, z photo =0.612 +/- 0.057','SDSS-II SN 21405',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','23.1g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,53.642333,0.05617,0.273,NULL,64980315881,1015317435,15864334,23.1),(31693,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31693,36.97,0.46,247,8600,70,NULL,NULL,'2MASX J03343455-0628222',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000091,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,53.644,-6.47283,0.077,NULL,36800322539,575005039,8984453,16.3),(31694,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 01302',NULL,31694,40.09,0.24,1040,8601,70,NULL,'SN photometric redshift distance, z photo =0.282 +/- 0.039','SDSS-II SN 01302',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.1g',0.04,'Opt.var.',NULL,NULL,NULL,NULL,1,53.6547917,0.89194,0.289,NULL,64992788065,1015512313,15867379,21.1),(31695,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31695,35.48,0.49,124,8602,75,NULL,'IR','FGC 0435',NULL,'2011yCatp016004901K',2011,1,1.21,NULL,'G',0.000012,NULL,'17.72',0.16,'Sc',NULL,NULL,NULL,NULL,1,53.6564583,12.06481,1.085,NULL,67930959620,1061421244,16584706,17.72),(31696,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31696,36,NULL,159,8602,NULL,NULL,'Dipole + Quadrupole','FGC 0435',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31697,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31697,36,NULL,159,8602,NULL,NULL,'Dipole','FGC 0435',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31698,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31698,36.01,NULL,159,8602,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0435',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31699,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 18835','R',31699,38.77,0.18,506,8603,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007mj','SDSS J033444.49+002119.8',0.123,'2014arXiv1401.3317S',2014,1,0.14,NULL,'G',NULL,NULL,'19.0g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,53.685375,0.3555,0.253,NULL,64991806033,1015496969,15867140,19),(31700,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 18835','R',31700,38.89,0.06,535,8603,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007mj','SDSS J033444.49+002119.8',0.123,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31701,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 2007mj',NULL,31701,38.69,0.07,547,8603,70,NULL,'SALT 2','SDSS J033444.49+002119.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31702,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 2007mj',NULL,31702,38.7,0.07,550,8603,70,NULL,'SALT 2, Malmquist cor.','SDSS J033444.49+002119.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31703,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31703,34.59,0.49,82.9,8604,75,NULL,'IR','FGC 0436',NULL,'2011yCatp016004901K',2011,1,1.03,NULL,'G',0.000006,NULL,'17.46',0.1,'Sd',NULL,NULL,NULL,NULL,1,53.7032083333,15.14194,0.841,NULL,68017495501,1062773367,16605833,17.46),(31704,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31704,35.12,NULL,106,8604,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0436',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31705,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31705,35.13,NULL,106,8604,NULL,NULL,'Dipole','FGC 0436',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31706,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31706,35.13,NULL,106,8604,NULL,NULL,'Dipole + Quadrupole','FGC 0436',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31707,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31707,35.19,NULL,109,8604,NULL,NULL,NULL,'FGC 0436',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31708,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31708,36.4,0.69,191,8605,70,NULL,NULL,'2MASX J03345303-5513036',NULL,'2014MNRAS.445.2677S',2014,1,0.75,'RC3 position in error.','G',0.000057,NULL,'15.94',0.3,'S',NULL,NULL,NULL,NULL,1,53.721,-55.21772,0,NULL,35778835724,559044308,8735067,15.94),(31709,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 14210','RN',31709,41.31,0.17,1440,8606,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 14210',0.272048,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31710,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 14210','RN',31710,41.67,0.28,1700,8606,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 14210',0.272048,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31711,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31711,32,0.42,25.1,8607,NULL,NULL,NULL,'LSBG F358-054',NULL,'2006A&A...458.1013M',2006,1,0.35,NULL,'G',NULL,NULL,'19.0',NULL,'dE4,N','Group member',NULL,NULL,NULL,1,53.735,-35.19111,0,NULL,38568266620,602629165,9416080,19),(31712,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31712,31.76,0.45,22.5,8608,NULL,NULL,NULL,'WFLSB 06-02',NULL,'2006A&A...458.1013M',2006,1,NULL,NULL,'G',NULL,NULL,'20.21',NULL,NULL,NULL,NULL,NULL,NULL,1,53.740583,-35.22328,0,NULL,38568266866,602629169,9416080,20.21),(31713,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 04539',NULL,31713,40.98,0.17,1570,8609,70,NULL,'SN photometric redshift distance, z photo =0.468 +/- 0.051','SDSS-II SN 04539',NULL,'2011ApJ...738..162S',2011,1,0.1,NULL,'G',NULL,'PHOT','20.0g',0.07,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,53.74275,-0.43783,0.281,NULL,36824042966,575375671,8990244,20),(31714,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 00921','RN',31714,39.58,0.2,731,8610,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 00921',0.126349,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31715,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 00921','RN',31715,40.26,0.25,1000,8610,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 00921',0.126349,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31716,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31716,31.07,0.15,16.4,8611,NULL,NULL,'TOM(g) = -7.2 mag','NGC 1373',NULL,'2010ApJ...717..603V',2010,1,1.1,NULL,'G',0.000007,NULL,'14.1B',0.9,'E+:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,53.7467083,-35.17111,0,NULL,38568277197,602629331,9416083,14.1),(31717,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31717,31.46,0.14,19.6,8611,NULL,NULL,'TOM(z) = -8.53 mag','NGC 1373',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31718,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31718,30.73,0.16,14,8611,NULL,NULL,'I','NGC 1373',NULL,'1991ApJ...373L...1T',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31719,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31719,30.95,0.37,15.5,8611,NULL,NULL,'KS','NGC 1373',NULL,'2002ApJ...564..216L',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31720,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31720,31.22,0.12,17.5,8611,74.4,NULL,NULL,'NGC 1373',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31721,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31721,31.43,0.09,19.3,8611,NULL,NULL,'HST ACS FCS','NGC 1373',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31722,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31722,31.6,0.5,20.9,8611,NULL,NULL,'I','NGC 1373',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31723,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31723,31.78,0.47,22.7,8611,NULL,NULL,'I','NGC 1373',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31724,'GC radius','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31724,31.79,0.27,22.8,8611,NULL,NULL,'HST ACS FCS','NGC 1373',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31725,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31725,31.22,0.12,17.5,8611,74.4,NULL,NULL,'NGC 1373',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31726,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31726,31.09,0.45,16.5,8612,NULL,NULL,NULL,'FCC 144',NULL,'2006A&A...458.1013M',2006,1,0.3,NULL,'G',NULL,NULL,'19.2B',NULL,'dE0','Group member',NULL,NULL,NULL,1,53.75125,-35.32222,0,NULL,38568529071,602633266,9416144,19.2),(31727,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31727,37.45,0.46,309,8613,70,NULL,NULL,'2MASX J03350067+0020444',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000085,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,53.7527083,0.34556,0.233,NULL,64980471632,1015319869,15864372,18.4),(31728,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 2005ke',NULL,31728,31.09,0.11,16.4,8614,72,NULL,NULL,'NGC 1371',0.00449,'2013ApJ...773...53F',2013,1,5.6,NULL,'G',0.000007,NULL,'11.2B',3.9,'(R\')SAB(r\'l)a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,53.755583,-24.93322,0,NULL,38021401665,594084401,9282568,11.2),(31729,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 2005ke',NULL,31729,31.92,0.05,24.1,8614,72,NULL,'MLCS2k2, R(V) = 1.7','NGC 1371',0.00488,'2010ApJ...721.1608B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31730,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 2005ke',NULL,31730,32,0.08,25,8614,72,NULL,'MLCS2k2, R(V) = 3.1','NGC 1371',0.00488,'2010ApJ...721.1608B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31731,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 2005ke',NULL,31731,32.06,0.27,25.7,8614,72,NULL,NULL,'NGC 1371',0.00488,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31732,'Sosies','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31732,31.92,0.17,24.2,8614,NULL,NULL,NULL,'NGC 1371',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31733,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31733,31.16,0.4,17.1,8614,75,NULL,'B','NGC 1371',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31734,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31734,31.85,0.4,23.4,8614,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 3 galaxy group','NGC 1371',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31735,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31735,32.29,0.2,28.7,8614,74.4,NULL,NULL,'NGC 1371',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31736,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31736,32.33,0.43,29.2,8614,75,NULL,'3.6 micron, color corrected','NGC 1371',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31737,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31737,32.49,0.43,31.5,8614,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1371',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31738,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31738,32.98,NULL,39.4,8614,NULL,NULL,'LEDA [April 2006]','NGC 1371',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31739,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 02775','RN',31739,40.82,0.26,1220,8615,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 02775',0.193124,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31740,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 02775','RN',31740,41.59,0.4,1740,8615,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02775',0.193124,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31741,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31741,37.21,0.46,277,8616,70,NULL,NULL,'2MASX J03350234+0022544',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000091,NULL,'16.5g',0.29,'E0',NULL,NULL,NULL,NULL,1,53.7597083,0.38172,0.245,NULL,64980403713,1015318808,15864356,16.5),(31742,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31742,31.05,0.45,16.2,8617,NULL,NULL,NULL,'FCC 145',NULL,'2006A&A...458.1013M',2006,1,0.28,NULL,'G',NULL,NULL,'19.6',NULL,'dE0','Group member',NULL,NULL,NULL,1,53.772833,-35.21847,0,NULL,38568278534,602629352,9416083,19.6),(31743,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31743,34.77,0.46,90,8618,70,NULL,NULL,'2MASX J03350583-1549448',NULL,'2014MNRAS.445.2677S',2014,1,0.79,NULL,'G',0.000083,NULL,'15.41',0.64,NULL,NULL,NULL,NULL,NULL,1,53.774375,-15.82919,0.197,NULL,38016367781,594005746,9281339,15.41),(31744,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31744,36.73,0.67,221,8619,70,NULL,NULL,'2MASX J03350729-7127474',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'16.5b',0.26,'E/D',NULL,NULL,NULL,NULL,1,53.7805,-71.46311,0.153,NULL,36421149820,569080465,8891882,16.5),(31745,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31745,36.23,0.46,176,8620,70,NULL,NULL,'2MASX J03350766+0048144',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000082,NULL,'17.1g',0.33,NULL,NULL,NULL,NULL,NULL,1,53.7820416667,0.804,0.257,NULL,64992747364,1015511677,15867369,17.1),(31746,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31746,37.78,0.33,360,8621,70,NULL,NULL,'2MASX J03351080+0031164',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000076,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,53.795083,0.52119,0.245,NULL,64991894281,1015498348,15867161,18.3),(31747,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31747,35.93,0.33,153,8622,70,NULL,NULL,'2MASX J03351243+0103373',NULL,'2015arXiv151105856S',2015,1,0.11,NULL,'G',0.000085,NULL,'16.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,53.801875,1.06044,0.289,NULL,64992804392,1015512568,15867383,16.8),(31748,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31748,31.4,0.4,19.1,8623,NULL,NULL,'mean','NGC 1370',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000093,NULL,'13.70',1,'E+:            HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,53.8107083,-20.37367,0.033,NULL,38049846291,594528848,9289513,13.7),(31749,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31749,31.71,0.45,22,8623,NULL,NULL,'K','NGC 1370',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31750,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31750,35.81,0.46,145,8624,70,NULL,NULL,'CGCG 391-012',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000092,NULL,'15.7g',0.42,'E','Pair member (points to parent)',NULL,NULL,NULL,1,53.814125,-1.22858,0.297,NULL,36824707268,575386051,8990407,15.7),(31751,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31751,30.71,0.14,13.9,8625,NULL,NULL,'TOM(V) = -7.4 mag, Gaussian, Harris et al. 1991, Z corr. -0.21 mag','NGC 1374',NULL,'1996A&A...309L..39K',1996,1,2.5,NULL,'G',0.000007,NULL,'12.0B',2.3,'E3','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,53.819125,-35.22625,0,NULL,38568278816,602629356,9416083,12),(31752,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31752,30.83,0.14,14.7,8625,NULL,NULL,'TOM(I) = -8.53 mag, Gaussian, Harris et al. 1991, Z corr. -0.09 mag','NGC 1374',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31753,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31753,30.84,0.13,14.7,8625,NULL,NULL,'TOM(V) = -7.4 mag, t5 function, Harris et al. 1991','NGC 1374',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31754,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31754,30.92,0.14,15.3,8625,NULL,NULL,'TOM(V) = -7.4 mag, Gaussian, Harris et al. 1991','NGC 1374',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31755,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31755,30.92,0.14,15.3,8625,NULL,NULL,'TOM(I) = -8.53 mag, Gaussian, Harris et al. 1991','NGC 1374',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31756,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31756,31.02,0.12,16,8625,NULL,NULL,'TOM(I) = -8.53 mag, t5 function, Harris et al. 1991','NGC 1374',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31757,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31757,31.04,0.13,16.1,8625,NULL,NULL,NULL,'NGC 1374',NULL,'2001A&A...371..875G',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31758,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31758,31.12,0.13,16.7,8625,NULL,NULL,'TOM(V) = -7.68 mag, t5 function, Sandage & Tammann (1995)','NGC 1374',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31759,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31759,31.2,0.14,17.4,8625,NULL,NULL,'TOM(V) = -7.68 mag, Gaussian, Sandage & Tammann (1995)','NGC 1374',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31760,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31760,31.22,0.12,17.5,8625,NULL,NULL,'TOM(I) = -8.73 mag, t5 function, Sandage & Tammann (1995)','NGC 1374',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31761,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31761,31.28,0.09,18,8625,NULL,NULL,'TOM(g) = -7.2 mag','NGC 1374',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31762,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31762,31.33,0.13,18.5,8625,NULL,NULL,'TOM(I) = -8.73 mag, Gaussian, Sandage & Tammann (1995)','NGC 1374',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31763,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31763,31.42,0.08,19.2,8625,NULL,NULL,'TOM(z) = -8.53 mag','NGC 1374',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31764,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31764,30.78,0.11,14.3,8625,NULL,NULL,'I','NGC 1374',NULL,'1991ApJ...373L...1T',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31765,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31765,30.89,0.08,15.1,8625,NULL,NULL,'I','NGC 1374',NULL,'1993A&A...277L..15L',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31766,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31766,31.32,0.13,18.4,8625,NULL,NULL,'I','NGC 1374',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31767,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31767,31.46,0.07,19.6,8625,NULL,NULL,'HST ACS FCS','NGC 1374',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31768,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31768,31.47,0.07,19.7,8625,NULL,NULL,'I','NGC 1374',NULL,'2010ApJ...724..657B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31769,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31769,31.48,0.13,19.8,8625,NULL,NULL,'I','NGC 1374',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31770,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31770,31.48,0.13,19.8,8625,NULL,NULL,NULL,'NGC 1374',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31771,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31771,31.5,0.12,20,8625,74.4,NULL,NULL,'NGC 1374',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31772,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31772,31.5,0.05,20,8625,NULL,NULL,'KS','NGC 1374',NULL,'2002ApJ...564..216L',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31773,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31773,31.5,0.13,20,8625,NULL,NULL,'Malmquist cor.','NGC 1374',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31774,'GC radius','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31774,31.61,0.09,21,8625,NULL,NULL,'HST ACS FCS','NGC 1374',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31775,'D-Sigma','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31775,31.26,0.4,17.8,8625,75,NULL,'Edat, raw','NGC 1374',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31776,'D-Sigma','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31776,31.29,0.4,18.1,8625,75,NULL,'Edat, cor','NGC 1374',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31777,'Faber-Jackson','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31777,31.46,0.65,19.6,8625,95,NULL,'Weighted Mean','NGC 1374',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31778,'Faber-Jackson','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31778,32.79,0.81,36.1,8625,55,NULL,'Visvanathan & Sandage 1979','NGC 1374',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31779,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31779,31.5,0.12,20,8625,74.4,NULL,NULL,'NGC 1374',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31780,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31780,31.83,NULL,23.2,8625,NULL,NULL,NULL,'NGC 1374',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31781,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31781,31.85,0.62,23.4,8625,70,NULL,NULL,'NGC 1374',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31782,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31782,31.91,0.41,24.1,8625,NULL,NULL,'Malmquist cor.','NGC 1374',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31783,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31783,31.93,0.41,24.3,8625,NULL,NULL,NULL,'NGC 1374',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31784,'Tertiary','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31784,31.11,0.41,16.7,8625,95,NULL,NULL,'NGC 1374',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31785,'Tully est','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31785,31.14,0.8,16.9,8625,75,NULL,'B','NGC 1374',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31786,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31786,31.58,0.4,20.7,8625,NULL,NULL,'mean','NGC 1374',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31787,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31787,32.55,0.45,32.4,8625,NULL,NULL,'K','NGC 1374',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31788,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31788,31.05,0.13,16.2,8626,NULL,NULL,'TOM(g) = -7.2 mag','NGC 1375',NULL,'2010ApJ...717..603V',2010,1,2.2,NULL,'G',0.00002,NULL,'13.2B',0.9,'SAB0^0^: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,53.820083,-35.26567,0,NULL,38568269835,602629216,9416081,13.2),(31789,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31789,31.37,0.15,18.8,8626,NULL,NULL,'TOM(z) = -8.53 mag','NGC 1375',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31790,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31790,30.28,0.12,11.4,8626,NULL,NULL,'I','NGC 1375',NULL,'1991ApJ...373L...1T',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31791,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31791,30.88,0.12,15,8626,NULL,NULL,'I','NGC 1375',NULL,'1993A&A...277L..15L',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31792,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31792,31.36,0.26,18.7,8626,NULL,NULL,'KS','NGC 1375',NULL,'2002ApJ...564..216L',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31793,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31793,31.42,0.13,19.2,8626,NULL,NULL,'I','NGC 1375',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31794,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31794,31.48,0.14,19.8,8626,74.4,NULL,NULL,'NGC 1375',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31795,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31795,31.5,0.07,19.9,8626,NULL,NULL,'HST ACS FCS','NGC 1375',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31796,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31796,31.53,0.07,20.2,8626,NULL,NULL,'I','NGC 1375',NULL,'2010ApJ...724..657B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31797,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31797,31.58,0.13,20.7,8626,NULL,NULL,'I','NGC 1375',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31798,'GC radius','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31798,31.52,0.38,20.2,8626,NULL,NULL,'HST ACS FCS','NGC 1375',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31799,'Tully est','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31799,31.14,0.8,16.9,8626,75,NULL,'B','NGC 1375',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31800,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','PS1 SN PS10bzy','N',31800,39.95,0.15,816,8627,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10bzy HOST',0.1996,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31801,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31801,31.31,0.16,18.3,8628,NULL,NULL,'R','FCC 150',NULL,'2003A&A...398...63J',2003,1,0.72,NULL,'G',0.00008,NULL,'15.7B',0.55,'dE4,N','Group member',NULL,NULL,NULL,1,53.850375,-36.36378,0,NULL,38556362238,602443159,9413174,15.7),(31802,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31802,37.78,0.33,360,8629,70,NULL,NULL,'APMUKS(BJ) B033250.48+002534.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'19.29',0.15,NULL,NULL,NULL,NULL,NULL,1,53.852917,0.59161,0.245,NULL,64991862955,1015497858,15867154,19.29),(31803,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31803,31.27,0.18,17.9,8630,NULL,NULL,'TOM(g) = -7.2 mag','IC 0335',NULL,'2010ApJ...717..603V',2010,1,2.6,NULL,'G',0.00002,NULL,'12.9B',0.7,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,53.8793333333,-34.44706,0,NULL,38563802116,602559408,9414990,12.9),(31804,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31804,31.62,0.16,21.1,8630,NULL,NULL,'TOM(z) = -8.53 mag','IC 0335',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31805,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31805,31.32,0.12,18.4,8630,74.4,NULL,NULL,'IC 0335',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31806,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31806,31.59,0.07,20.8,8630,NULL,NULL,'HST ACS FCS','IC 0335',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31807,'GC radius','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31807,31.28,0.21,18.1,8630,NULL,NULL,'HST ACS FCS','IC 0335',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31808,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31808,31.32,0.12,18.4,8630,74.4,NULL,NULL,'IC 0335',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31809,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31809,29.78,0.45,9.06,8630,NULL,NULL,'K','IC 0335',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31810,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31810,31.62,0.4,21.1,8630,NULL,NULL,'mean','IC 0335',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31811,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31811,31.92,0.49,24.2,8630,75,NULL,'IR','IC 0335',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31812,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 2007po',NULL,31812,40.18,0.15,1080,8631,70,NULL,'Hubble residual 0.02 for z0.29200','SDSS J033532.28+004214.0',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.005,NULL,'20.4g',NULL,NULL,NULL,NULL,NULL,NULL,1,53.8845416667,0.70392,0.245,NULL,64991870868,1015497982,15867155,20.4),(31813,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 19596','R',31813,40.88,0.24,1160,8631,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007po','SDSS J033532.28+004214.0',0.292,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31814,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 19596','R',31814,40.97,0.15,1210,8631,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007po','SDSS J033532.28+004214.0',0.292,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31815,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31815,30.69,0.34,13.7,8632,NULL,NULL,'TOM(g) = -7.2 mag','ESO 358- G 025',NULL,'2010ApJ...717..603V',2010,1,1.9,NULL,'G',0.00004,NULL,'13.8B',1,'SA0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,53.8880416667,-32.46489,0,NULL,38572458706,602694667,9417104,13.8),(31816,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31816,31.02,0.25,16,8632,NULL,NULL,'TOM(z) = -8.53 mag','ESO 358- G 025',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31817,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31817,31.1,0.12,16.6,8632,74.4,NULL,NULL,'ESO 358- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31818,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31818,31.25,0.26,17.8,8632,NULL,NULL,'I','ESO 358- G 025',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31819,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31819,31.36,0.07,18.7,8632,NULL,NULL,'HST ACS FCS','ESO 358- G 025',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31820,'GC radius','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31820,30.94,0.75,15.4,8632,NULL,NULL,'HST ACS FCS','ESO 358- G 025',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31821,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31821,31.1,0.12,16.6,8632,74.4,NULL,NULL,'ESO 358- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31822,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31822,31.85,0.45,23.4,8632,NULL,NULL,'K','ESO 358- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31823,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31823,32.02,0.4,25.3,8632,NULL,NULL,'mean','ESO 358- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31824,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31824,34.48,0.2,78.7,8633,74.4,NULL,NULL,'IC 1956',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.000023,NULL,'15.28',0.3,'SBbc:','Isolated galaxy',NULL,NULL,NULL,1,53.8882083,5.067,0.641,NULL,65012398843,1015818731,15872167,15.28),(31825,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31825,34.62,0.47,84,8633,NULL,NULL,'H','IC 1956',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31826,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31826,34.74,0.45,88.5,8633,NULL,NULL,'K','IC 1956',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31827,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31827,34.74,0.4,88.9,8633,NULL,NULL,'mean','IC 1956',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31828,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31828,34.92,0.46,96.3,8633,NULL,NULL,'J','IC 1956',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31829,'IRAS','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31829,31.95,0.8,24.5,8634,75,NULL,'MAT, I','IC 1962',NULL,'1997ApJS..109..333W',1997,1,2.7,NULL,'G',0.00002,NULL,'14.63',0.5,'SB(s)dm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,53.9062083,-21.29406,0.029,NULL,38050155509,594533679,9289588,14.63),(31830,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31830,30.4,0.32,12,8634,85,NULL,'I, inv','IC 1962',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31831,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31831,30.47,0.32,12.4,8634,85,NULL,'I, raw','IC 1962',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31832,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31832,30.77,0.43,14.2,8634,75,NULL,'MAT, I, inv','IC 1962',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31833,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31833,30.95,0.43,15.5,8634,75,NULL,'MAT, I, raw','IC 1962',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31834,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31834,31.27,0.43,17.9,8634,75,NULL,'MAT, I, cor','IC 1962',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31835,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31835,31.66,0.2,21.5,8634,74.4,NULL,NULL,'IC 1962',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31836,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31836,31.71,0.11,22,8634,NULL,NULL,NULL,'IC 1962',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31837,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31837,31.78,0.43,22.7,8634,75,NULL,'3.6 micron, color corrected','IC 1962',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31838,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31838,31.84,0.43,23.4,8634,75,NULL,'3.6 micron, color + selection bias corrected','IC 1962',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31839,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31839,35.86,0.46,149,8635,70,NULL,NULL,'SDSS J033537.56+002927.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00008,NULL,'17.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,53.9065417,0.49092,0.245,NULL,64980448627,1015319509,15864367,17.6),(31840,'CMD','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'N',31840,17.4,NULL,0.03,8636,NULL,NULL,NULL,'Reticulum II',NULL,'2015ApJ...805..130K',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31841,'CMD','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'N',31841,17.5,NULL,0.032,8636,NULL,NULL,'DES J0335.6_5403','Reticulum II',NULL,'2015ApJ...807...50B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31842,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31842,36.07,0.46,163,8637,70,NULL,NULL,'2MASX J03354086-0706350',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000084,NULL,'16.1g',0.39,'E0',NULL,NULL,NULL,NULL,1,53.920333,-7.10986,0.121,NULL,36800809603,575012650,8984572,16.1),(31843,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31843,31.96,0.33,24.7,8638,NULL,NULL,NULL,'LSBG F358-052',NULL,'2006A&A...458.1013M',2006,1,0.72,NULL,'G',0.000073,'?','17.2B',NULL,'dE1','Group member',NULL,NULL,NULL,1,53.9282917,-35.33811,0,NULL,38568536471,602633382,9416146,17.2),(31844,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 09901','RN',31844,41.36,0.24,1470,8639,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 09901',0.276135,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31845,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 09901','RN',31845,41.55,0.33,1600,8639,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 09901',0.276135,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31846,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31846,38.1,0.46,418,8640,70,NULL,NULL,'2MASX J03354862-0545542',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000077,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,53.952667,-5.76511,0.089,NULL,36826724642,575417572,8990899,18.2),(31847,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31847,32.99,0.49,39.5,8641,75,NULL,'IR','2MFGC 02976',NULL,'2011yCatp016004901K',2011,1,NULL,'abs(b) < 10 degrees.','G',0.00003,NULL,'13.3K',NULL,NULL,NULL,NULL,NULL,NULL,1,53.9562917,47.96858,NULL,NULL,68312300445,1067379694,16677807,13.3),(31848,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31848,36.59,0.68,208,8642,70,NULL,NULL,'2MASX J03355006-8444504',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,53.958875,-84.74731,0.517,NULL,35498001505,554656273,8666504,16.9),(31849,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 21874',NULL,31849,40.57,0.37,1300,8643,70,NULL,'SN photometric redshift distance, z photo =0.368 +/- 0.090','SDSS-II SN 21874',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,53.9669583,-0.53664,0.269,NULL,36810386512,575162289,8986910,NULL),(31850,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31850,36.48,0.62,198,8644,70,NULL,NULL,'2MASX J03355222-7509116',NULL,'2014MNRAS.445.2677S',2014,1,0.21,NULL,'G',0.00015,NULL,'16.7b',0.2,NULL,NULL,NULL,NULL,NULL,1,53.967333,-75.15328,0.329,NULL,35518537594,554977149,8671517,16.7),(31851,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 04540',NULL,31851,40.53,0.78,1270,8645,70,NULL,'SN photometric redshift distance, z photo =0.359 +/- 0.218','SDSS-II SN 04540',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','23.2g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,53.984375,-0.49611,0.269,NULL,36810353628,575161775,8986902,23.2),(31852,'TRGB','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31852,29.31,0.1,7.27,8646,74.4,NULL,NULL,'LCRS B033417.4-452126',NULL,'2013AJ....146...86T',2013,1,0.62,NULL,'G',0.000063,NULL,'16.13',0.5,'Im',NULL,NULL,NULL,NULL,1,53.986833,-45.19144,0,NULL,37755823018,589934734,9217730,16.13),(31853,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31853,31.49,0.59,19.9,8647,NULL,NULL,NULL,'APMUKS(BJ) B033402.42-353046.4',NULL,'2006A&A...458.1013M',2006,1,0.17,NULL,'G',NULL,NULL,'20.34',0.11,NULL,NULL,NULL,NULL,NULL,1,53.990917,-35.34822,0,NULL,38568583072,602634110,9416157,20.34),(31854,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31854,36.95,0.58,245,8648,70,NULL,NULL,'2MASX J03355804-7425345',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'16.6b',0.19,NULL,NULL,NULL,NULL,NULL,1,53.991667,-74.42619,0.253,NULL,35520737093,555011517,8672054,16.6),(31855,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 05307','RN',31855,41.07,0.5,1410,8649,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 05307',0.154899,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31856,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31856,36.62,0.46,211,8650,70,NULL,NULL,'2MASX J03360156-0604253',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000079,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,54.006417,-6.07375,0.097,NULL,36826615751,575415871,8990872,17.7),(31857,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 2007jh',NULL,31857,36.06,0.07,151,8651,72,NULL,NULL,'CGCG 391-014',0.04029,'2013ApJ...773...53F',2013,1,0.71,NULL,'G',0.000119,NULL,'15.3g',0.49,'E0',NULL,NULL,NULL,NULL,1,54.006625,1.10475,0.229,NULL,64992228895,1015503576,15867243,15.3),(31858,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 17886','R',31858,36.07,0.06,158,8651,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007jh','CGCG 391-014',0.040796,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31859,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 2007jh',NULL,31859,36.37,0.13,181,8651,73.8,NULL,'SALT 2 (SNANA)','CGCG 391-014',0.0405,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31860,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 17886','R',31860,36.65,0.2,205,8651,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007jh','CGCG 391-014',0.040796,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31861,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31861,35.93,0.33,153,8651,70,NULL,NULL,'CGCG 391-014',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31862,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31862,31.61,0.41,21,8652,NULL,NULL,NULL,'LSBG F358-050',NULL,'2006A&A...458.1013M',2006,1,0.63,NULL,'G',0.000027,NULL,'17.7',NULL,'dE1,N','Group member',NULL,NULL,NULL,1,54.016417,-35.38903,0,NULL,38568589771,602634215,9416159,17.7),(31863,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31863,31.21,0.17,17.5,8653,NULL,NULL,'HST KP Calibrated, K\'','NGC 1379',NULL,'2000ApJ...529..745F',2000,1,2.4,NULL,'G',0.000007,NULL,'11.8B',2.3,'E3','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,54.0164583,-35.44119,0,NULL,38568588772,602634199,9416159,11.8),(31864,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31864,30.68,0.28,13.7,8653,NULL,NULL,'TOM(V) = -7.4 mag, Gaussian, Harris et al. 1991, Z corr. -0.40 mag','NGC 1379',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31865,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31865,30.93,0.28,15.3,8653,NULL,NULL,'TOM(I) = -8.53 mag, Gaussian, Harris et al. 1991, Z corr. -0.15 mag','NGC 1379',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31866,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31866,31.05,0.26,16.2,8653,NULL,NULL,'TOM(V) = -7.4 mag, t5 function, Harris et al. 1991','NGC 1379',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31867,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31867,31.08,0.28,16.4,8653,NULL,NULL,'TOM(V) = -7.4 mag, Gaussian, Harris et al. 1991','NGC 1379',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31868,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31868,31.08,0.28,16.4,8653,NULL,NULL,'TOM(I) = -8.53 mag, Gaussian, Harris et al. 1991','NGC 1379',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31869,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31869,31.25,0.26,17.8,8653,NULL,NULL,NULL,'NGC 1379',NULL,'2001A&A...371..875G',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31870,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31870,31.27,0.34,17.9,8653,NULL,NULL,'TOM(I) = -8.73 mag, Gaussian, Sandage & Tammann (1995)','NGC 1379',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31871,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31871,31.3,0.44,18.2,8653,NULL,NULL,'TOM(I) = -8.53 mag, t5 function, Harris et al. 1991','NGC 1379',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31872,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31872,31.32,0.36,18.4,8653,NULL,NULL,NULL,'NGC 1379',NULL,'1998MNRAS.295..240E',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31873,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31873,31.33,0.26,18.5,8653,NULL,NULL,'TOM(V) = -7.68 mag, t5 function, Sandage & Tammann (1995)','NGC 1379',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31874,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31874,31.36,0.28,18.7,8653,NULL,NULL,'TOM(V) = -7.68 mag, Gaussian, Sandage & Tammann (1995)','NGC 1379',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31875,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31875,31.5,0.44,20,8653,NULL,NULL,'TOM(I) = -8.73 mag, t5 function, Sandage & Tammann (1995)','NGC 1379',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31876,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31876,31.92,0.58,24.2,8653,NULL,NULL,'HST KP Calibrated, B','NGC 1379',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31877,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31877,31.05,0.13,16.2,8653,NULL,NULL,'K','NGC 1379',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31878,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31878,31.06,0.12,16.3,8653,NULL,NULL,'I','NGC 1379',NULL,'1991ApJ...373L...1T',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31879,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31879,31.1,0.2,16.6,8653,NULL,NULL,'I','NGC 1379',NULL,'1993A&A...275..433B',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31880,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31880,31.24,0.12,17.7,8653,74.4,NULL,NULL,'NGC 1379',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31881,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31881,31.3,0.08,18.2,8653,NULL,NULL,'I','NGC 1379',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31882,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31882,31.35,0.15,18.6,8653,NULL,NULL,'I','NGC 1379',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31883,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31883,31.5,0.08,20,8653,NULL,NULL,'KS','NGC 1379',NULL,'2002ApJ...564..216L',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31884,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31884,31.51,0.15,20,8653,NULL,NULL,'I','NGC 1379',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31885,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31885,31.51,0.15,20,8653,NULL,NULL,NULL,'NGC 1379',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31886,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31886,31.54,0.15,20.3,8653,NULL,NULL,'Malmquist cor.','NGC 1379',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31887,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31887,31.56,0.17,20.5,8653,NULL,NULL,'HST KP Calibrated, I','NGC 1379',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31888,'D-Sigma','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31888,31.26,0.4,17.8,8653,75,NULL,'Edat, raw','NGC 1379',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31889,'D-Sigma','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31889,31.29,0.4,18.1,8653,75,NULL,'Edat, cor','NGC 1379',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31890,'Faber-Jackson','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31890,30.43,0.65,12.2,8653,95,NULL,'Weighted Mean','NGC 1379',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31891,'Faber-Jackson','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31891,31.52,0.81,20.1,8653,55,NULL,'Visvanathan & Sandage 1979','NGC 1379',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31892,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31892,30.99,0.41,15.8,8653,NULL,NULL,NULL,'NGC 1379',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31893,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31893,31.24,0.12,17.7,8653,74.4,NULL,NULL,'NGC 1379',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31894,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31894,31.26,0.41,17.8,8653,NULL,NULL,'Malmquist cor.','NGC 1379',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31895,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31895,31.28,NULL,18,8653,NULL,NULL,NULL,'NGC 1379',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31896,'Tertiary','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31896,31.11,0.41,16.7,8653,95,NULL,NULL,'NGC 1379',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31897,'Tully est','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31897,31.14,0.8,16.9,8653,75,NULL,'B','NGC 1379',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31898,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 18299','R',31898,39.92,0.14,856,8654,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2007kz','2MASX J03360435-0011592',0.127542,'2014arXiv1401.3317S',2014,1,0.15,NULL,'G',0.00009,NULL,'17.4g',0.09,NULL,NULL,NULL,NULL,NULL,1,54.018125,-0.19981,0.281,NULL,36810436657,575163072,8986923,17.4),(31899,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 18299','R',31899,40.24,0.21,989,8654,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2007kz','2MASX J03360435-0011592',0.127542,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31900,'SNII optical','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 2007kz',NULL,31900,38.57,0.09,459,8654,NULL,NULL,'SCM 55 SNII','2MASX J03360435-0011592',0.127542,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31901,'SNII optical','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 2007kz',NULL,31901,38.82,0.11,515,8654,NULL,NULL,'SCM 15 SDSS SNII','2MASX J03360435-0011592',0.127542,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31902,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 15751',NULL,31902,40.33,0.35,1160,8655,70,NULL,'SN photometric redshift distance, z photo =0.321 +/- 0.070','SDSS-II SN 15751',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,54.0281666667,-0.05175,0.281,NULL,36810397055,575162453,8986913,NULL),(31903,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31903,35.9,0.49,151,8656,70,NULL,NULL,'2MASX J03360740-5201509',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'16.27',0.33,'S',NULL,NULL,NULL,NULL,1,54.031,-52.03083,0,NULL,37720856589,589388384,9209193,16.27),(31904,'GRB','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31904,47.19,1.54,6050,8657,100,NULL,NULL,'GRB 060115',3.53,'2009EPJC...63..139W',2009,1,NULL,NULL,'VisS',NULL,NULL,'22.0R',NULL,'Swift',NULL,NULL,NULL,NULL,1,54.035,17.34528,0.433,NULL,68028224005,1062941000,16608453,22),(31905,'GRB','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31905,47.31,1.48,6400,8657,72,NULL,NULL,'GRB 060115',3.53,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31906,'GRB','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31906,47.73,0.83,7760,8657,72,NULL,NULL,'GRB 060115',3.53,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31907,'GRB','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31907,47.78,0.79,7940,8657,69.7,NULL,'Calibrated','GRB 060115',3.53,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31908,'GRB','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31908,47.8,0.82,8020,8657,70,NULL,NULL,'GRB 060115',3.53,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31909,'GRB','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31909,47.97,0.96,8680,8657,NULL,NULL,NULL,'GRB 060115',3.53,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31910,'GRB','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31910,48.21,0.8,9680,8657,69.7,NULL,'Fiducial','GRB 060115',3.53,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31911,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 15526',NULL,31911,39.44,1.05,772,8658,70,NULL,'SN photometric redshift distance, z photo =0.200 +/- 0.151','SDSS-II SN 15526',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,54.0442916667,1.22869,0.265,NULL,64992261040,1015504078,15867251,NULL),(31912,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31912,35.55,0.46,129,8659,70,NULL,NULL,'2MASX J03361093-0034556',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00009,NULL,'16.2g',0.33,'S0^-',NULL,NULL,NULL,NULL,1,54.045625,-0.58206,0.269,NULL,36811231395,575175490,8987117,16.2),(31913,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31913,32.14,0.2,26.8,8660,74.4,NULL,NULL,'UGC 02789',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000037,NULL,'17.',1,'SB?',NULL,NULL,NULL,NULL,1,54.0564583,67.56464,NULL,NULL,66543142615,1039736603,16245884,17),(31914,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31914,32.44,0.46,30.8,8660,NULL,NULL,'J','UGC 02789',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31915,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31915,32.49,0.47,31.5,8660,NULL,NULL,'H','UGC 02789',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31916,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31916,32.53,0.45,32.1,8660,NULL,NULL,'K','UGC 02789',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31917,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31917,33.05,0.4,40.8,8660,NULL,NULL,'mean','UGC 02789',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31918,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31918,36.29,0.53,181,8661,70,NULL,NULL,'2MASX J03361685-4043420',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'16.07',0.52,'E',NULL,NULL,NULL,NULL,1,54.070125,-40.72839,0,NULL,38474016839,601156513,9393070,16.07),(31919,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','PS1 SN PS10ayb','N',31919,39.11,0.11,581,8662,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10ayb HOST',0.1396,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31920,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31920,30.8,0.43,14.4,8663,75,NULL,'3.6 micron, color + selection bias corrected','ESO 482- G 011',NULL,'2014MNRAS.444..527S',2014,1,1,NULL,'G',0.000017,NULL,'15.02',0.4,'Sb','in a triple',NULL,NULL,NULL,1,54.0724583,-25.60472,0,NULL,38579322379,602801912,9418779,15.02),(31921,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31921,35.98,0.55,157,8664,70,NULL,NULL,'AM 0334-254 NED01',NULL,'2014MNRAS.445.2677S',2014,1,1.35,NULL,'G',0.00015,NULL,'16.24',0.43,'E','in a triple',NULL,NULL,NULL,1,54.1002083,-25.66325,0,NULL,38579317138,602801830,9418778,16.24),(31922,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31922,31.22,0.06,17.5,8665,NULL,NULL,'TOM(g) = -7.2 mag','NGC 1380',NULL,'2010ApJ...717..603V',2010,1,4.8,NULL,'G',0.00004,NULL,'10.9B',2.3,'SA0            LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,54.1149583,-34.97622,0,NULL,38568431955,602631749,9416121,10.9),(31923,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31923,31.27,0.11,17.9,8665,NULL,NULL,NULL,'NGC 1380',NULL,'2001A&A...371..875G',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31924,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31924,31.28,0.27,18,8665,NULL,NULL,'HST KP Calibrated, V','NGC 1380',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31925,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31925,31.34,0.06,18.5,8665,NULL,NULL,'TOM(z) = -8.53 mag','NGC 1380',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31926,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31926,31.34,0.25,18.5,8665,NULL,NULL,'TOM(V) = -7.29 mag, Secker 1992','NGC 1380',NULL,'1996ApJ...465L..19B',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31927,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31927,31.35,0.16,18.6,8665,NULL,NULL,NULL,'NGC 1380',NULL,'1998MNRAS.299..267D',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31928,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31928,31.65,0.25,21.4,8665,NULL,NULL,'TOM(V) = -7.60 mag, Sandage & Tammann 1995','NGC 1380',NULL,'1996ApJ...465L..19B',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31929,'PNLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31929,31.04,0.11,16.1,8665,NULL,NULL,'44 PNe','NGC 1380',NULL,'2007ApJ...657...76F',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31930,'PNLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31930,31.1,0.2,16.6,8665,NULL,NULL,NULL,'NGC 1380',NULL,'2004AAS...205.6906J',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31931,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992A',NULL,31931,31.35,0.15,18.6,8665,NULL,NULL,NULL,'NGC 1380',NULL,'1999A&A...349..877D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31932,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992A',NULL,31932,31.36,0.08,18.7,8665,74.4,NULL,NULL,'NGC 1380',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31933,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992A',NULL,31933,31.41,0.17,19,8665,72,NULL,NULL,'NGC 1380',0.00626,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31934,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992A',NULL,31934,31.6,0.15,20.9,8665,65,NULL,'avg. of 2 SNIa and hosts','NGC 1380',NULL,'1996AJ....112.2398H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31935,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992A',NULL,31935,31.61,0.01,21,8665,72,NULL,'SNooPy','NGC 1380',NULL,'2010AJ....140.2036S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31936,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992A',NULL,31936,31.65,0.07,21.2,8665,65,NULL,'MLCS2k2','NGC 1380',0.00626,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31937,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992A','R',31937,31.81,NULL,23,8665,62.3,NULL,NULL,'NGC 1380',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31938,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992A',NULL,31938,31.9,0.06,24,8665,60,NULL,'M(I) = -19.19 mag','NGC 1380',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31939,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992A',NULL,31939,31.9,0.14,24,8665,60,NULL,NULL,'NGC 1380',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31940,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992A',NULL,31940,31.9,0.4,24,8665,68,NULL,NULL,'NGC 1380',NULL,'1996ApJ...465L..83R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31941,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992A',NULL,31941,31.91,0.06,24.1,8665,60,NULL,'M(V) = -19.47 mag','NGC 1380',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31942,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992A',NULL,31942,31.92,0.07,24.2,8665,60,NULL,'M(B) = -19.48 mag','NGC 1380',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31943,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31943,30.65,0.1,13.5,8665,NULL,NULL,'I','NGC 1380',NULL,'1991ApJ...373L...1T',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31944,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31944,30.65,0.2,13.5,8665,NULL,NULL,'I','NGC 1380',NULL,'1993A&A...275..433B',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31945,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31945,31.07,0.18,16.4,8665,NULL,NULL,'I','NGC 1380',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31946,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31946,31.23,0.04,17.6,8665,NULL,NULL,'KS','NGC 1380',NULL,'2002ApJ...564..216L',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31947,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31947,31.23,0.18,17.6,8665,NULL,NULL,'I','NGC 1380',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31948,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31948,31.23,0.18,17.6,8665,NULL,NULL,'I','NGC 1380',NULL,'2001ApJ...559..584A',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31949,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31949,31.32,0.18,18.4,8665,NULL,NULL,NULL,'NGC 1380',NULL,'2001ApJ...550..503J',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31950,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31950,31.36,0.08,18.7,8665,74.4,NULL,NULL,'NGC 1380',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31951,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31951,31.37,0.2,18.8,8665,NULL,NULL,'HST KP Calibrated, I','NGC 1380',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31952,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31952,31.57,0.07,20.6,8665,NULL,NULL,'I','NGC 1380',NULL,'2010ApJ...724..657B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31953,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31953,31.63,0.08,21.2,8665,NULL,NULL,'HST ACS FCS','NGC 1380',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31954,'GC radius','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31954,31.21,0.07,17.5,8665,NULL,NULL,'HST ACS FCS','NGC 1380',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31955,'Faber-Jackson','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31955,29.33,0.63,7.35,8665,95,NULL,'Michard 1979b, c','NGC 1380',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31956,'Faber-Jackson','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31956,29.9,0.37,9.55,8665,95,NULL,'Weighted Mean','NGC 1380',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31957,'Faber-Jackson','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31957,30.07,0.46,10.3,8665,95,NULL,'Michard 1979a','NGC 1380',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31958,'Faber-Jackson','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31958,31.39,NULL,19,8665,NULL,NULL,'LEDA [April 2006]','NGC 1380',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31959,'Faber-Jackson','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31959,31.4,0.8,19.1,8665,55,NULL,'Visvanathan & Sandage 1979','NGC 1380',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31960,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31960,31.36,0.08,18.7,8665,74.4,NULL,NULL,'NGC 1380',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31961,'Tertiary','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31961,31.11,0.41,16.7,8665,95,NULL,NULL,'NGC 1380',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31962,'Tully est','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31962,31.14,0.8,16.9,8665,75,NULL,'B','NGC 1380',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31963,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31963,31.17,0.45,17.2,8665,NULL,NULL,'K','NGC 1380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31964,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31964,31.2,0.4,17.4,8665,75,NULL,'HOSTS SN 1992A','NGC 1380',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31965,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31965,31.6,0.4,20.9,8665,NULL,NULL,'mean','NGC 1380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31966,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31966,31.36,0.48,18.7,8666,NULL,NULL,NULL,'FCC 168',NULL,'2006A&A...458.1013M',2006,1,0.43,NULL,'G',NULL,NULL,'18.7',NULL,'dE0','Group member',NULL,NULL,NULL,1,54.11625,-35.21056,0,NULL,38568294091,602629595,9416087,18.7),(31967,'IRAS','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31967,31.18,0.8,17.2,8667,75,NULL,'MAT, I','IC 1970',NULL,'1997ApJS..109..333W',1997,1,3.2,'Confused HIPASS source','G',0.000013,NULL,'12.85',0.7,'SAb: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,54.131333,-43.95683,0,NULL,37755071397,589922990,9217546,12.85),(31968,'Tully est','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31968,30.33,0.8,11.6,8667,75,NULL,NULL,'IC 1970',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31969,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31969,31.32,0.11,18.4,8667,NULL,NULL,NULL,'IC 1970',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31970,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31970,31.41,0.4,19.2,8667,75,NULL,NULL,'IC 1970',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31971,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31971,31.42,0.39,19.2,8667,73,NULL,'IR','IC 1970',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31972,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31972,31.45,0.4,19.5,8667,NULL,NULL,'mean','IC 1970',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31973,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31973,31.52,0.47,20.1,8667,NULL,NULL,'H','IC 1970',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31974,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31974,31.54,0.45,20.3,8667,NULL,NULL,'K','IC 1970',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31975,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31975,31.56,0.4,20.5,8667,NULL,NULL,NULL,'IC 1970',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31976,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31976,31.6,0.46,20.9,8667,NULL,NULL,'J','IC 1970',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31977,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31977,31.6,0.32,20.9,8667,85,NULL,'I, raw','IC 1970',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31978,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31978,31.62,0.32,21.1,8667,85,NULL,'I, inv','IC 1970',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31979,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31979,31.82,0.43,23.1,8667,75,NULL,'MAT, I, raw','IC 1970',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31980,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31980,31.86,0.43,23.5,8667,75,NULL,'MAT, I, cor','IC 1970',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31981,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31981,31.92,0.49,24.3,8667,75,NULL,'IR','IC 1970',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31982,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31982,31.95,0.43,24.5,8667,75,NULL,'MAT, I, inv','IC 1970',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31983,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31983,31.22,0.2,17.5,8668,NULL,NULL,'TOM(g) = -7.2 mag','NGC 1381',NULL,'2010ApJ...717..603V',2010,1,2.7,'6dF DR2 has z = 0.055963.','G',0.00003,NULL,'12.4B',0.7,'SA0: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,54.132,-35.29519,0,NULL,38568573345,602633958,9416155,12.4),(31984,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31984,31.6,0.2,20.9,8668,NULL,NULL,'TOM(z) = -8.53 mag','NGC 1381',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31985,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31985,31.12,0.21,16.7,8668,NULL,NULL,'I','NGC 1381',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31986,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31986,31.28,0.21,18,8668,NULL,NULL,'I','NGC 1381',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31987,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31987,31.28,0.21,18,8668,NULL,NULL,NULL,'NGC 1381',NULL,'2001ApJ...550..503J',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31988,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31988,31.69,0.14,21.8,8668,74.4,NULL,NULL,'NGC 1381',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31989,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31989,31.71,0.08,21.9,8668,NULL,NULL,'HST ACS FCS','NGC 1381',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31990,'GC radius','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31990,31.61,0.25,21,8668,NULL,NULL,'HST ACS FCS','NGC 1381',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31991,'Faber-Jackson','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31991,30.19,0.65,10.9,8668,95,NULL,'Weighted Mean','NGC 1381',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31992,'Faber-Jackson','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31992,31.22,0.81,17.5,8668,55,NULL,'Visvanathan & Sandage 1979','NGC 1381',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31993,'Tertiary','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31993,31.11,0.41,16.7,8668,95,NULL,NULL,'NGC 1381',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31994,'Tully est','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31994,31.14,0.8,16.9,8668,75,NULL,'B','NGC 1381',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31995,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31995,30.69,0.45,13.8,8668,NULL,NULL,'K','NGC 1381',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31996,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31996,31.61,0.4,20.9,8668,NULL,NULL,'mean','NGC 1381',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31997,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',31997,32.21,0.49,27.7,8668,75,NULL,'IR','NGC 1381',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(31998,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,31998,34.03,0.43,63.8,8669,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J03363404+7205448',NULL,'2014MNRAS.444..527S',2014,1,0.89,NULL,'G',0.000037,NULL,'11.2K',0.33,'Spiral',NULL,NULL,NULL,NULL,1,54.1417083,72.09581,1.509,NULL,66388792075,1037324876,16208201,11.2),(31999,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 18067',NULL,31999,39.94,0.35,973,8670,70,NULL,'SN photometric redshift distance, z photo =0.260 +/- 0.054','SDSS-II SN 18067',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'*',NULL,'PHOT','23.0g',NULL,'Point Src [SDSS]',NULL,NULL,NULL,NULL,1,54.142833,1.02222,0.229,NULL,64992210861,1015503294,15867238,23),(32000,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32000,35.25,0.49,112,8671,70,NULL,NULL,'2MASX J03363609-1553482',NULL,'2014MNRAS.445.2677S',2014,1,0.71,NULL,'G',0.00015,NULL,'15.53',0.59,NULL,NULL,NULL,NULL,NULL,1,54.1502917,-15.89661,0.217,NULL,38016277030,594004328,9281317,15.53),(32001,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 2005gr',NULL,32001,39.49,0.13,638,8672,74.2,NULL,'SALT 2','SDSS J033637.49+010443.7',0.24,'2010ApJ...716..712A',2010,1,0.05,NULL,'G',0.0005,NULL,'22.0g',0.03,NULL,NULL,NULL,NULL,NULL,1,54.1562083,1.07883,0.229,NULL,64992214824,1015503356,15867239,22),(32002,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 2005gr',NULL,32002,39.64,0.04,685,8672,70,NULL,'SDSS-II SN 03377','SDSS J033637.49+010443.7',0.24,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32003,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 2005gr',NULL,32003,39.62,0.09,841,8672,70,NULL,'Hubble residual -0.20 for z0.24510','SDSS J033637.49+010443.7',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32004,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 2005gr',NULL,32004,40.25,0.09,903,8672,65,NULL,'SALT2','SDSS J033637.49+010443.7',0.24,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32005,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 03377','R',32005,40.28,0.2,913,8672,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005gr','SDSS J033637.49+010443.7',0.2451,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32006,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 2005gr',NULL,32006,40.27,0.14,913,8672,70,NULL,'SDSS-II SN 03377, SALT 2','SDSS J033637.49+010443.7',0.24,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32007,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 2005gr',NULL,32007,40.53,0.09,1030,8672,65,NULL,'MLCS2k2','SDSS J033637.49+010443.7',0.24,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32008,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 03377','R',32008,40.54,0.12,1030,8672,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005gr','SDSS J033637.49+010443.7',0.2451,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32009,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992bp',NULL,32009,36.76,0.16,208,8673,74.2,NULL,'SALT 2','2MASX J03363839-1821123',0.079,'2010ApJ...716..712A',2010,1,0.45,NULL,'G',0.002,NULL,'16.56',0.33,'E2/S0',NULL,NULL,NULL,NULL,1,54.159917,-18.35342,0.133,NULL,38010888378,593920130,9280002,16.56),(32010,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992bp',NULL,32010,37.45,0.1,287,8673,65,NULL,'SALT2','2MASX J03363839-1821123',0.079,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32011,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992bp',NULL,32011,37.47,0.04,288,8673,70,NULL,NULL,'2MASX J03363839-1821123',0.079,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32012,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992bp',NULL,32012,37.48,0.27,290,8673,72,NULL,NULL,'2MASX J03363839-1821123',0.079,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32013,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992bp',NULL,32013,37.48,0.03,290,8673,70,NULL,'SALT 2','2MASX J03363839-1821123',0.079,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32014,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992bp',NULL,32014,37.52,0.15,296,8673,70,NULL,'SALT','2MASX J03363839-1821123',0.079,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32015,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992bp',NULL,32015,37.52,0.02,296,8673,72,NULL,NULL,'2MASX J03363839-1821123',0.079,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32016,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992bp',NULL,32016,37.38,0.08,299,8673,74.4,NULL,NULL,'2MASX J03363839-1821123',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32017,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992bp',NULL,32017,37.56,0.19,301,8673,70,NULL,'SALT 2','2MASX J03363839-1821123',0.079,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32018,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992bp',NULL,32018,37.79,0.11,311,8673,65,NULL,'MLCS2k2','2MASX J03363839-1821123',0.079,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32019,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992bp',NULL,32019,37.63,0.19,311,8673,73.8,NULL,'SALT 2 (SNANA)','2MASX J03363839-1821123',0.0789,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32020,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992bp',NULL,32020,37.65,0.13,314,8673,65,NULL,'MLCS','2MASX J03363839-1821123',0.079,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32021,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992bp',NULL,32021,37.65,0.17,314,8673,65,NULL,'SALT2','2MASX J03363839-1821123',0.079,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32022,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992bp',NULL,32022,37.5,0.07,316,8673,60,NULL,'M(B) = -19.48 mag','2MASX J03363839-1821123',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32023,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992bp',NULL,32023,37.69,0.13,319,8673,65,NULL,'SALT','2MASX J03363839-1821123',0.079,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32024,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992bp',NULL,32024,37.7,0.03,321,8673,65,NULL,'SALT','2MASX J03363839-1821123',0.079,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32025,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992bp',NULL,32025,37.75,0.15,329,8673,65,NULL,'MLCS17','2MASX J03363839-1821123',0.079,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32026,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992bp',NULL,32026,37.61,0.06,333,8673,60,NULL,'M(V) = -19.47 mag','2MASX J03363839-1821123',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32027,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992bp',NULL,32027,37.78,0.08,333,8673,65,NULL,'MLCS2k2','2MASX J03363839-1821123',0.079,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32028,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992bp',NULL,32028,37.78,0.11,334,8673,65,NULL,'MLCS2k2','2MASX J03363839-1821123',0.079,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32029,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992bp',NULL,32029,37.8,0.14,337,8673,65,NULL,'MLCS31','2MASX J03363839-1821123',0.079,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32030,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992bp',NULL,32030,37.66,0.14,340,8673,60,NULL,NULL,'2MASX J03363839-1821123',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32031,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992bp',NULL,32031,37.66,0.06,340,8673,60,NULL,'M(I) = -19.19 mag','2MASX J03363839-1821123',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32032,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992bp',NULL,32032,37.69,0.12,345,8673,70.8,NULL,NULL,'2MASX J03363839-1821123',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32033,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992bp',NULL,32033,37.94,0.18,359,8673,65,NULL,NULL,'2MASX J03363839-1821123',0.079,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32034,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1992bp',NULL,32034,37.96,0.15,362,8673,65,NULL,'Template','2MASX J03363839-1821123',0.079,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32035,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32035,31.61,0.45,21,8674,NULL,NULL,'K','NGC 1377',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.0001,NULL,'13.69',0.9,'S0^0           HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,54.1628333333,-20.90225,0.033,NULL,38050500009,594539062,9289672,13.69),(32036,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32036,32.05,0.4,25.7,8674,NULL,NULL,'mean','NGC 1377',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32037,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32037,31,0.39,15.8,8675,NULL,NULL,'I','LSBG F358-048',NULL,'2007A&A...463..503M',2007,1,0.4,NULL,'G',NULL,NULL,'18.8',NULL,'dE3','Group member',NULL,NULL,NULL,1,54.1784583333,-35.43547,0,NULL,38568567243,602633863,9416154,18.8),(32038,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 10113',NULL,32038,40.32,0.22,1160,8676,70,NULL,'SN photometric redshift distance, z photo =0.320 +/- 0.042','SDSS-II SN 10113',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,54.1817083,-0.14042,0.241,NULL,36811128506,575173882,8987091,NULL),(32039,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32039,30.93,0.25,15.3,8677,NULL,NULL,'I','NGC 1386',NULL,'2003ApJ...583..712J',2003,1,3.4,NULL,'G',0.000017,NULL,'12.09',1.3,'SB(s)0+        Sy2','Group member, radial-velocity confirmed',NULL,NULL,'Sy 1 i',1,54.192417,-35.99942,0,NULL,38567797259,602621832,9415966,12.09),(32040,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32040,31.01,0.14,15.9,8677,74.4,NULL,NULL,'NGC 1386',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32041,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32041,31.09,0.25,16.5,8677,NULL,NULL,'I','NGC 1386',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32042,'Tully est','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32042,31.14,0.8,16.9,8677,75,NULL,'B','NGC 1386',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32043,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32043,31.1,0.14,16.6,8678,NULL,NULL,'TOM(g) = -7.2 mag','NGC 1380A',NULL,'2010ApJ...717..603V',2010,1,2.4,NULL,'G',0.00002,NULL,'13.3B',0.7,'S0^0^: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,54.197875,-34.73961,0,NULL,38568218922,602628420,9416069,13.3),(32044,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32044,31.45,0.13,19.5,8678,NULL,NULL,'TOM(z) = -8.53 mag','NGC 1380A',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32045,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32045,30.84,0.29,14.7,8678,NULL,NULL,'I','NGC 1380A',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32046,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32046,31,0.29,15.8,8678,NULL,NULL,'I','NGC 1380A',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32047,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32047,31.49,0.14,19.9,8678,74.4,NULL,NULL,'NGC 1380A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32048,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32048,31.51,0.07,20,8678,NULL,NULL,'HST ACS FCS','NGC 1380A',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32049,'GC radius','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32049,31.36,0.15,18.7,8678,NULL,NULL,'HST ACS FCS','NGC 1380A',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32050,'Tully est','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32050,31.14,0.8,16.9,8678,75,NULL,NULL,'NGC 1380A',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32051,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32051,30.11,0.45,10.5,8678,NULL,NULL,'K','NGC 1380A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32052,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',32052,31.07,0.49,16.4,8678,75,NULL,'IR','NGC 1380A',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32053,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32053,31.59,0.4,20.8,8678,NULL,NULL,'mean','NGC 1380A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32054,'Magnitude','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32054,37.39,0.13,301,8679,100,NULL,NULL,'SARS 053.69162-28.24261',NULL,'1998A&A...337...31R',1998,1,0.68,'Katgert et al. (1998A&AS..129..399K) give z = 31418 km/sec.','G',0.000153,NULL,'16.43',0.4,'S0',NULL,NULL,NULL,NULL,1,54.2112083333,-28.07897,0,NULL,38580624792,602822262,9419097,16.43),(32055,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',32055,37.52,0.46,319,8680,70,NULL,NULL,'2MASX J03365108-0644126',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000074,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,54.212875,-6.73681,0.101,NULL,36797427428,574959803,8983746,17.8),(32056,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32056,35.19,0.41,109,8681,NULL,NULL,'Malmquist cor.','UGC 02796',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',NULL,NULL,'16.5',0.4,'Sbc',NULL,NULL,NULL,NULL,1,54.21875,13.40661,0.889,NULL,68015307315,1062739176,16605299,16.5),(32057,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32057,35.26,0.2,113,8681,74.4,NULL,NULL,'UGC 02796',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32058,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32058,35.29,0.39,114,8681,NULL,NULL,NULL,'UGC 02796',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32059,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 19407','RN',32059,39.83,0.52,851,8682,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 19407',0.085504,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32060,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',32060,37.63,0.46,335,8683,70,NULL,NULL,'2MASX J03365260+0111569',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000081,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,54.219167,1.19906,0.229,NULL,64992265514,1015504148,15867252,17.4),(32061,'Magnitude','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32061,37.39,0.13,301,8684,100,NULL,NULL,'ABELL 3141',NULL,'1998A&A...337...31R',1998,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III [BM];RI [A]',NULL,NULL,NULL,NULL,1,54.220625,-28.05561,0,NULL,38580621825,602822216,9419097,NULL),(32062,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32062,36.51,0.68,200,8685,70,NULL,NULL,'2MASX J03365343-2552080',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000077,NULL,'16.99',0.28,NULL,NULL,NULL,NULL,NULL,1,54.2227083,-25.86886,0,NULL,38579303669,602801619,9418775,16.99),(32063,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 15193','RN',32063,41,0.12,1400,8686,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15193',0.130729,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32064,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 15193','RN',32064,41.3,0.2,1610,8686,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15193',0.130729,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32065,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32065,31.37,0.14,18.8,8687,NULL,NULL,'TOM(g) = -7.2 mag','MCG -06-09-008',NULL,'2010ApJ...717..603V',2010,1,1.1,NULL,'G',0.00001,NULL,'14.77',1.1,'SA0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,54.22625,-35.37467,0,NULL,38568567855,602633872,9416154,14.77),(32066,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32066,31.75,0.18,22.4,8687,NULL,NULL,'TOM(z) = -8.53 mag','MCG -06-09-008',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32067,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32067,31.44,0.14,19.4,8687,74.4,NULL,NULL,'MCG -06-09-008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32068,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32068,31.46,0.09,19.6,8687,NULL,NULL,'HST ACS FCS','MCG -06-09-008',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32069,'GC radius','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32069,31.36,0.22,18.7,8687,NULL,NULL,'HST ACS FCS','MCG -06-09-008',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32070,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',32070,35.42,0.46,121,8688,70,NULL,NULL,'2MASX J03365627-0036099',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000068,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,54.234625,-0.60281,0.269,NULL,36811268596,575176071,8987126,16.8),(32071,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32071,31.16,0.07,17.1,8689,NULL,NULL,'TOM(g) = -7.2 mag','NGC 1387',NULL,'2010ApJ...717..603V',2010,1,2.8,'6dF DR2 has z = 0.055534.','G',0.00004,NULL,'12.01',2.8,'SAB(s)0- poss. LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,54.23775,-35.50664,0,NULL,38568713549,602636149,9416189,12.01),(32072,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32072,31.19,0.07,17.3,8689,NULL,NULL,'TOM(z) = -8.53 mag','NGC 1387',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32073,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32073,30,0.2,10,8689,NULL,NULL,'I','NGC 1387',NULL,'1993A&A...275..433B',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32074,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32074,30.73,0.14,14,8689,NULL,NULL,'I','NGC 1387',NULL,'1991ApJ...373L...1T',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32075,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32075,31.38,0.26,18.9,8689,NULL,NULL,'I','NGC 1387',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32076,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32076,31.41,0.14,19.1,8689,74.4,NULL,NULL,'NGC 1387',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32077,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32077,31.43,0.09,19.3,8689,NULL,NULL,'HST ACS FCS','NGC 1387',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32078,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32078,31.49,0.06,19.9,8689,NULL,NULL,'KS','NGC 1387',NULL,'2002ApJ...564..216L',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32079,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32079,31.54,0.26,20.3,8689,NULL,NULL,'I','NGC 1387',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32080,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32080,31.54,0.26,20.3,8689,NULL,NULL,NULL,'NGC 1387',NULL,'2001ApJ...550..503J',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32081,'GC radius','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32081,31.36,0.08,18.7,8689,NULL,NULL,'HST ACS FCS','NGC 1387',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32082,'Faber-Jackson','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32082,30.69,0.65,13.7,8689,95,NULL,'Weighted Mean','NGC 1387',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32083,'Faber-Jackson','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32083,31.83,0.81,23.2,8689,55,NULL,'Visvanathan & Sandage 1979','NGC 1387',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32084,'Tertiary','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32084,31.11,0.41,16.7,8689,95,NULL,NULL,'NGC 1387',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32085,'Tully est','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32085,31.14,0.8,16.9,8689,75,NULL,'B','NGC 1387',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32086,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',32086,37.34,0.46,294,8690,70,NULL,NULL,'2MASX J03365755-0534329',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000082,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,54.2399166667,-5.57583,0.089,NULL,36827032980,575422390,8990974,17),(32087,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32087,31.44,0.33,19.4,8691,NULL,NULL,NULL,'FCC 188',NULL,'2006A&A...458.1013M',2006,1,0.95,'Loveday, et al. (1996,ApJS,107,201) give v = 25682 +/- 14 km/sec.','G',0.000127,NULL,'16.2B',0.67,'dE0,N','Group member',NULL,NULL,NULL,1,54.269,-35.59061,0,NULL,38568718345,602636224,9416191,16.2),(32088,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32088,33.26,NULL,44.9,8692,NULL,NULL,'B','NGC 1376',NULL,'2002ApJ...565..681R',2002,1,2,NULL,'G',0.000022,NULL,'12.6B',1.7,'SA(s)cd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,54.274667,-5.04275,0.089,NULL,36818224147,575284752,8988824,12.6),(32089,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32089,33.88,1.32,59.7,8692,NULL,NULL,NULL,'NGC 1376',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32090,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32090,33.92,0.2,60.8,8692,74.4,NULL,NULL,'NGC 1376',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32091,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32091,33.97,1.27,62.3,8692,NULL,NULL,'Malmquist cor.','NGC 1376',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32092,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 2006jq',NULL,32092,38.58,0.05,520,8693,70,NULL,'Hubble residual 0.03 for z0.12760','SDSS J033706.50+000033.7',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,54.276917,0.00928,0.241,NULL,64980655388,1015322740,15864417,NULL),(32093,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 14871','R',32093,38.91,0.21,537,8693,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006jq','SDSS J033706.50+000033.7',0.1276,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32094,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 14871','R',32094,39.15,0.06,599,8693,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006jq','SDSS J033706.50+000033.7',0.1276,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32095,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32095,31.13,0.09,16.8,8694,NULL,NULL,'TOM(g) = -7.2 mag','NGC 1380B',NULL,'2010ApJ...717..603V',2010,1,1.5,'ESO-B misidentifies NGC 1382 as a star.','G',0.000057,NULL,'12.92',1.3,'SAB(s)0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,54.287333,-35.19503,0,NULL,38568395431,602631178,9416112,12.92),(32096,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32096,31.47,0.09,19.7,8694,NULL,NULL,'TOM(z) = -8.53 mag','NGC 1380B',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32097,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32097,30.99,0.22,15.8,8694,NULL,NULL,'I','NGC 1380B',NULL,'1991ApJ...373L...1T',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32098,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32098,31.52,0.14,20.1,8694,74.4,NULL,NULL,'NGC 1380B',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32099,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32099,31.54,0.07,20.3,8694,NULL,NULL,'HST ACS FCS','NGC 1380B',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32100,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32100,31.62,0.25,21.1,8694,NULL,NULL,'KS','NGC 1380B',NULL,'2002ApJ...564..216L',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32101,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32101,31.77,0.31,22.6,8694,NULL,NULL,'I','NGC 1380B',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32102,'GC radius','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32102,31.07,0.13,16.4,8694,NULL,NULL,'HST ACS FCS','NGC 1380B',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32103,'Tully est','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32103,31.14,0.8,16.9,8694,75,NULL,'B','NGC 1380B',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32104,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32104,31.21,0.52,17.5,8695,NULL,NULL,NULL,'FCC 191',NULL,'2006A&A...458.1013M',2006,1,0.29,NULL,'G',NULL,NULL,'19.3',NULL,'dE3','Group member',NULL,NULL,NULL,1,54.291667,-35.38694,0,NULL,38568704821,602636012,9416187,19.3),(32105,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',32105,34.89,0.46,95.1,8696,70,NULL,NULL,'2MASX J03371039-0535055',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00007,NULL,'14.7g',0.67,'E0',NULL,NULL,NULL,NULL,1,54.2932083333,-5.58475,0.089,NULL,36826979634,575421556,8990961,14.7),(32106,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32106,30.94,0.45,15.4,8697,NULL,NULL,NULL,'FCC 192',NULL,'2006A&A...458.1013M',2006,1,0.25,NULL,'G',NULL,NULL,'19.6',NULL,'dE0','Group member',NULL,NULL,NULL,1,54.293333,-35.88833,0,NULL,38568648125,602635126,9416173,19.6),(32107,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32107,31.13,0.16,16.8,8698,NULL,NULL,'TOM(g) = -7.2 mag','NGC 1389',NULL,'2010ApJ...717..603V',2010,1,2.3,NULL,'G',0.00004,NULL,'13.16',1.4,'SAB(s)0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,54.299083,-35.74558,0,NULL,38568636212,602634940,9416170,13.16),(32108,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32108,31.36,0.17,18.7,8698,NULL,NULL,'TOM(z) = -8.53 mag','NGC 1389',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32109,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32109,30.32,0.12,11.6,8698,NULL,NULL,'I','NGC 1389',NULL,'1991ApJ...373L...1T',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32110,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32110,30.91,0.1,15.2,8698,NULL,NULL,'KS','NGC 1389',NULL,'2002ApJ...564..216L',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32111,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32111,31.48,0.12,19.8,8698,74.4,NULL,NULL,'NGC 1389',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32112,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32112,31.52,0.18,20.1,8698,NULL,NULL,'I','NGC 1389',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32113,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32113,31.63,0.07,21.2,8698,NULL,NULL,'HST ACS FCS','NGC 1389',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32114,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32114,31.68,0.18,21.7,8698,NULL,NULL,'I','NGC 1389',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32115,'GC radius','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32115,30.64,0.26,13.4,8698,NULL,NULL,'HST ACS FCS','NGC 1389',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32116,'D-Sigma','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32116,31.26,0.4,17.8,8698,75,NULL,'Edat, raw','NGC 1389',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32117,'D-Sigma','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32117,31.29,0.4,18.1,8698,75,NULL,'Edat, cor','NGC 1389',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32118,'Faber-Jackson','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32118,30.44,0.65,12.2,8698,95,NULL,'Weighted Mean','NGC 1389',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32119,'Faber-Jackson','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32119,31.53,0.81,20.2,8698,55,NULL,'Visvanathan & Sandage 1979','NGC 1389',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32120,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32120,31.48,0.12,19.8,8698,74.4,NULL,NULL,'NGC 1389',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32121,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32121,31.71,0.84,21.9,8698,70,NULL,NULL,'NGC 1389',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32122,'Tully est','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32122,31.14,0.8,16.9,8698,75,NULL,'B','NGC 1389',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32123,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32123,31.12,0.4,16.7,8698,NULL,NULL,'mean','NGC 1389',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32124,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32124,31.68,0.45,21.7,8698,NULL,NULL,'K','NGC 1389',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32125,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32125,34.52,0.48,80,8699,70,NULL,NULL,'2MASX J03371309-5250358',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'15.70',0.53,'S0',NULL,NULL,NULL,NULL,1,54.304583,-52.84331,0,NULL,37722693110,589417079,9209641,15.7),(32126,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 19371','RN',32126,38.76,0.14,530,8700,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 19371',0.067291,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32127,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 19371','RN',32127,39.65,0.35,797,8700,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19371',0.067291,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32128,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32128,31.61,0.37,21,8701,NULL,NULL,NULL,'LSBG F358-045',NULL,'2006A&A...458.1013M',2006,1,0.32,NULL,'G',0.000043,NULL,'18.39',0.26,'dE3','Group member',NULL,NULL,NULL,1,54.324917,-35.69856,0,NULL,38568661851,602635341,9416177,18.39),(32129,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','PS1 SN PS10cay','N',32129,40.36,0.25,946,8702,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10cay HOST',0.2496,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32130,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1990Y',NULL,32130,35.17,0.17,104,8703,74.2,NULL,'SALT 2','FCCB 1147',0.03903,'2010ApJ...716..712A',2010,1,0.39,NULL,'G',0.000093,NULL,'17.14',0.29,'E(M32?)','Group non-member, background',NULL,NULL,NULL,1,54.344125,-33.04303,0,NULL,38565411892,602584560,9415383,17.14),(32131,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1990Y',NULL,32131,35.73,0.11,135,8703,72,NULL,NULL,'FCCB 1147',0.03903,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32132,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1990Y',NULL,32132,35.84,0.16,142,8703,70,NULL,'SALT 2','FCCB 1147',0.03903,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32133,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1990Y',NULL,32133,35.95,0.12,155,8703,70.8,NULL,NULL,'FCCB 1147',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32134,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1990Y',NULL,32134,36.22,0.25,163,8703,65,NULL,'MLCS2k2','FCCB 1147',0.03903,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32135,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1990Y',NULL,32135,36.31,0.1,176,8703,70,NULL,'SALT','FCCB 1147',0.03903,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32136,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1990Y',NULL,32136,36.4,0.45,195,8703,67,NULL,NULL,'FCCB 1147',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32137,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SN 1990Y',NULL,32137,36.47,0.14,197,8703,60,NULL,NULL,'FCCB 1147',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32138,'IRAS','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32138,31.54,0.8,20.3,8704,75,NULL,'MAT, I','NGC 1385',NULL,'1997ApJS..109..333W',1997,1,3.4,NULL,'G',0.000017,NULL,'11.76',2,'SB(s)cd        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,54.3702083,-24.50031,0.009,NULL,38038386425,594349787,9286715,11.76),(32139,'IRAS','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32139,31.56,0.8,20.5,8704,75,NULL,'A82, H','NGC 1385',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32140,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32140,29.48,0.43,7.9,8704,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1385',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32141,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32141,29.7,0.43,8.7,8704,75,NULL,'3.6 micron, color corrected','NGC 1385',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32142,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32142,29.9,0.2,9.55,8704,74.4,NULL,NULL,'NGC 1385',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32143,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32143,30.02,0.4,10.1,8704,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 1385',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32144,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32144,30.19,0.35,10.9,8704,NULL,NULL,NULL,'NGC 1385',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32145,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32145,30.19,0.4,10.9,8704,73,NULL,'opt','NGC 1385',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32146,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32146,30.27,0.47,11.3,8704,75,NULL,'A82, H, inv','NGC 1385',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32147,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32147,30.3,0.47,11.5,8704,75,NULL,'A82, H, raw','NGC 1385',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32148,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32148,30.41,0.32,12.1,8704,85,NULL,'I, raw','NGC 1385',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32149,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32149,30.43,0.32,12.2,8704,85,NULL,'I, inv','NGC 1385',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32150,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32150,30.53,0.43,12.8,8704,75,NULL,'MAT, I, raw','NGC 1385',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32151,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32151,30.62,0.43,13.3,8704,75,NULL,'MAT, I, inv','NGC 1385',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32152,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32152,30.74,0.47,14.1,8704,75,NULL,'A82, H, cor','NGC 1385',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32153,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32153,30.9,0.43,15.1,8704,75,NULL,'MAT, I, cor','NGC 1385',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32154,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32154,31.21,0.4,17.5,8704,75,NULL,'B','NGC 1385',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32155,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32155,31.71,0.08,22,8704,NULL,NULL,NULL,'NGC 1385',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32156,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 16098',NULL,32156,41.12,0.19,1680,8705,70,NULL,'SN photometric redshift distance, z photo =0.512 +/- 0.066','SDSS-II SN 16098',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,54.370125,-0.62994,0.281,NULL,36811089429,575173272,8987082,NULL),(32157,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 15709','RN',32157,42.56,0.15,2380,8706,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15709',0.368468,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32158,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 15709','RN',32158,42.64,0.22,2460,8706,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15709',0.368468,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32159,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 15078',NULL,32159,41.27,0.23,1790,8707,70,NULL,'SN photometric redshift distance, z photo =0.562 +/- 0.093','SDSS-II SN 15078',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,54.375625,0.29761,0.229,NULL,64980682641,1015323166,15864424,NULL),(32160,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',32160,34.19,0.46,68.8,8708,70,NULL,NULL,'2MASX J03373338-0631140',NULL,'2015arXiv151105856S',2015,1,1.08,NULL,'G',0.000101,NULL,'14.1g',0.66,'S0^-',NULL,NULL,NULL,NULL,1,54.3890833333,-6.52044,0.109,NULL,36797640645,574963135,8983798,14.1),(32161,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32161,34.49,0.46,79,8708,70,NULL,NULL,'2MASX J03373338-0631140',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32162,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32162,32.09,0.37,26.2,8709,NULL,NULL,NULL,'LSBG F358-044',NULL,'2006A&A...458.1013M',2006,1,0.48,NULL,'G',0.000432,NULL,'18.0B',0.22,'dE6','Group member',NULL,NULL,NULL,1,54.391875,-35.82939,0,NULL,38568654103,602635220,9416175,18),(32163,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32163,33.33,0.59,46.3,8710,70,NULL,NULL,'NGC 1383',NULL,'2014MNRAS.445.2677S',2014,1,1.9,NULL,'G',0.000063,NULL,'13.45',0.9,'SAB(s)0^0^','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,54.4135,-18.33947,0.153,NULL,38010900556,593920321,9280005,13.45),(32164,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32164,32.38,0.4,29.9,8710,NULL,NULL,'mean','NGC 1383',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32165,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32165,33.25,0.45,44.7,8710,NULL,NULL,'K','NGC 1383',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32166,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 15587','R',32166,40.14,0.2,875,8711,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J033740.30+005954.2',0.218864,'2014arXiv1401.3317S',2014,1,0.13,NULL,'G',0.000061,NULL,'19.5g',0.09,NULL,NULL,NULL,NULL,NULL,1,54.417917,0.99839,0.177,NULL,64981037369,1015328708,15864511,19.5),(32167,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 15587','R',32167,40.33,0.11,956,8711,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J033740.30+005954.2',0.218864,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32168,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 15587',NULL,32168,40.1,0.11,1050,8711,70,NULL,'SALT 2','SDSS J033740.30+005954.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32169,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 15587',NULL,32169,40.11,0.11,1050,8711,70,NULL,'SALT 2, Malmquist cor.','SDSS J033740.30+005954.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32170,'IRAS','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32170,35.17,0.8,108,8712,75,NULL,'MAT, I','ESO 031- G 018',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.94',0.6,'SA(r)c',NULL,NULL,NULL,NULL,1,54.430875,-72.39175,0.149,NULL,36409712877,568901763,8889090,14.94),(32171,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32171,34.33,NULL,73.5,8712,NULL,NULL,'B','ESO 031- G 018',NULL,'2004ApJ...607..241R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32172,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32172,34.64,NULL,84.7,8712,NULL,NULL,'B, Hubble-type-TF','ESO 031- G 018',NULL,'2004ApJ...607..241R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32173,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',32173,34.64,NULL,84.7,8712,NULL,NULL,'B','ESO 031- G 018',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32174,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',32174,34.64,NULL,84.7,8712,NULL,NULL,'I','ESO 031- G 018',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32175,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32175,34.67,0.32,85.8,8712,85,NULL,'I, raw','ESO 031- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32176,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32176,34.72,0.32,87.8,8712,85,NULL,'I, inv','ESO 031- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32177,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32177,34.97,0.43,98.7,8712,75,NULL,'MAT, I, raw','ESO 031- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32178,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32178,35.12,0.35,106,8712,NULL,NULL,'Malmquist cor.','ESO 031- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32179,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32179,35.19,0.43,109,8712,75,NULL,'MAT, I, inv','ESO 031- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32180,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32180,35.3,0.43,115,8712,75,NULL,'MAT, I, cor','ESO 031- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32181,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32181,35.45,0.3,123,8712,NULL,NULL,NULL,'ESO 031- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32182,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32182,35.49,0.2,125,8712,74.4,NULL,NULL,'ESO 031- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32183,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SCP 05P09',NULL,32183,43.67,0.05,2980,8713,70,NULL,'SALT2, M(B) -19.307 mag, Alpha 0.124, Beta 1.460, Delta 0.023','SCP 05P09',0.821,'2012ApJ...746...85S',2012,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia*',NULL,NULL,NULL,NULL,1,54.4354583,-28.73183,0,NULL,38585033303,602891145,9420174,NULL),(32184,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32184,28.14,0.4,4.25,8714,NULL,NULL,NULL,'NGC 1343',NULL,'2009AJ....138..323T',2009,1,2.6,'One of two 6cm sources associated with [WB92] 0331+7221','G',0.000023,NULL,'13.5',1.6,'SAB(s)b: pec',NULL,NULL,NULL,NULL,1,54.457083,72.57133,1.293,NULL,66390293312,1037348333,16208567,13.5),(32185,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32185,29.59,0.47,8.29,8714,NULL,NULL,'H','NGC 1343',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32186,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32186,29.75,0.45,8.9,8714,NULL,NULL,'K','NGC 1343',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32187,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32187,29.83,0.46,9.26,8714,NULL,NULL,'J','NGC 1343',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32188,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32188,29.98,0.4,9.9,8714,73,NULL,'opt','NGC 1343',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32189,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32189,31.73,0.4,22.2,8714,NULL,NULL,'mean','NGC 1343',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32190,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32190,34.95,0.69,97.6,8715,100,NULL,'mid-IR','UGC 02802',NULL,'2013ApJ...771...88L',2013,1,1.1,NULL,'G',0.00019,NULL,'15.20',0.5,'S?','Pair member (points to parent)',NULL,NULL,NULL,1,54.4617916667,4.94881,0.609,NULL,64982816803,1015356512,15864945,15.2),(32191,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32191,35.05,0.34,103,8715,NULL,NULL,'Malmquist cor.','UGC 02802',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32192,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32192,35.19,0.32,109,8715,NULL,NULL,NULL,'UGC 02802',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32193,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32193,35.23,0.2,111,8715,74.4,NULL,NULL,'UGC 02802',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32194,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32194,36.98,0.66,249,8716,70,NULL,NULL,'2MASX J03375197-8532065',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,54.4655,-85.53517,0.497,NULL,35495214772,554612730,8665823,17.1),(32195,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32195,36.51,0.82,201,8717,70,NULL,NULL,'FCCB 1192',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'16.54',0.22,'Sa(r)','Group non-member, background',NULL,NULL,NULL,1,54.4670417,-33.61283,0,NULL,38565156459,602580569,9415321,16.54),(32196,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',32196,35.89,0.33,150,8718,70,NULL,NULL,'2MASX J03375326-0609038',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000085,NULL,'15.8g',0.49,'E0',NULL,NULL,NULL,NULL,1,54.471833,-6.15094,0.109,NULL,36796706178,574948534,8983570,15.8),(32197,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32197,35.83,0.52,146,8719,70,NULL,NULL,'2MASX J03375780-0500006',NULL,'2014MNRAS.445.2677S',2014,1,0.93,NULL,'G',0.000127,NULL,'15.45',0.55,NULL,NULL,NULL,NULL,NULL,1,54.491,-5.00028,0.089,NULL,36818221817,575284715,8988823,15.45),(32198,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 15580','R',32198,40.71,0.28,1050,8720,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15580',0.322518,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,54.493125,0.48325,0.189,NULL,64980608042,1015322000,15864406,NULL),(32199,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 15580','R',32199,41.55,0.4,1540,8720,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15580',0.322518,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32200,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32200,34.03,0.69,64.1,8721,100,NULL,'mid-IR','MCG -01-10-012',NULL,'2013ApJ...771...88L',2013,1,1.2,NULL,'G',0.00002,NULL,'14.6g',0.76,'SAB(r)cd',NULL,NULL,NULL,NULL,1,54.49525,-6.27064,0.109,NULL,36796755719,574949308,8983582,14.6),(32201,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 14574','RN',32201,40.56,0.11,1100,8722,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14574',0.177896,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32202,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 16981',NULL,32202,39.78,0.47,904,8723,70,NULL,'SN photometric redshift distance, z photo =0.239 +/- 0.068','SDSS-II SN 16981',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','21.9g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,54.50625,-0.38436,0.229,NULL,36810961922,575171280,8987051,21.9),(32203,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',32203,37.31,0.46,290,8724,70,NULL,NULL,'2MASX J03380433-0035416',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000077,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,54.518167,-0.595,0.233,NULL,36811108001,575173562,8987086,18.3),(32204,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',32204,34.83,0.49,92.6,8725,75,NULL,'IR','UGC 02804',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',NULL,NULL,'16.5',0.1,'Scd:',NULL,NULL,NULL,NULL,1,54.5215,1.93714,0.313,NULL,64993578873,1015524669,15867572,16.5),(32205,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32205,34.88,0.2,94.6,8725,74.4,NULL,NULL,'UGC 02804',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32206,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32206,34.95,0.37,97.9,8725,NULL,NULL,'Malmquist cor.','UGC 02804',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32207,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32207,34.96,0.37,98.4,8725,NULL,NULL,NULL,'UGC 02804',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32208,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32208,31.09,0.48,16.5,8726,NULL,NULL,NULL,'WFLSB 10-08',NULL,'2006A&A...458.1013M',2006,1,NULL,NULL,'G',NULL,NULL,'20.42',NULL,NULL,NULL,NULL,NULL,NULL,1,54.5260833333,-36.05031,0,NULL,38568080523,602626258,9416035,20.42),(32209,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32209,31.2,0.08,17.4,8727,NULL,NULL,'TOM(g) = -7.2 mag','NGC 1396',NULL,'2010ApJ...717..603V',2010,1,1,'This is FCC 202 with a 15 arcmin error in Dec.','G',0.000073,NULL,'14.82',0.9,'SAB0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,54.52725,-35.44011,0,NULL,38568510313,602632973,9416140,14.82),(32210,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32210,31.36,0.08,18.7,8727,NULL,NULL,'TOM(z) = -8.53 mag','NGC 1396',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32211,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32211,31.49,0.14,19.9,8727,74.4,NULL,NULL,'NGC 1396',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32212,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32212,31.51,0.08,20.1,8727,NULL,NULL,'HST ACS FCS','NGC 1396',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32213,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',32213,35.89,0.33,150,8728,70,NULL,NULL,'2MASX J03380814-0608295',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.0001,NULL,'14.6g',0.73,'E0',NULL,NULL,NULL,NULL,1,54.533875,-6.14144,0.109,NULL,36796731688,574948932,8983577,14.6),(32214,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32214,31.36,0.36,18.7,8729,NULL,NULL,'TOM(g) = -7.2 mag','ESO 358- G 042',NULL,'2010ApJ...717..603V',2010,1,1.2,NULL,'G',0.000095,NULL,'15.7B',0.5,'SB0^0^:','Group member',NULL,NULL,NULL,1,54.538125,-34.51853,0,NULL,38570357987,602661843,9416591,15.7),(32215,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32215,31.7,0.33,21.9,8729,NULL,NULL,'TOM(z) = -8.53 mag','ESO 358- G 042',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32216,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32216,31.56,0.14,20.5,8729,74.4,NULL,NULL,'ESO 358- G 042',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32217,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32217,31.58,0.08,20.7,8729,NULL,NULL,'HST ACS FCS','ESO 358- G 042',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32218,'GC radius','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32218,31.28,0.35,18.1,8729,NULL,NULL,'HST ACS FCS','ESO 358- G 042',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32219,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32219,33.71,0.47,55.3,8730,NULL,NULL,'H','UGC 02798',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000037,NULL,'14.0',0.7,'SABbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,54.5415417,40.98308,1.105,NULL,68552044516,1071125695,16736338,14),(32220,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32220,33.81,0.45,57.9,8730,NULL,NULL,'K','UGC 02798',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32221,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32221,33.83,0.46,58.3,8730,NULL,NULL,'J','UGC 02798',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32222,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32222,33.84,0.2,58.6,8730,74.4,NULL,NULL,'UGC 02798',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32223,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32223,33.96,0.43,62,8730,75,NULL,'3.6 micron, color corrected','UGC 02798',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32224,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32224,34.1,0.4,66,8730,NULL,NULL,'mean','UGC 02798',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32225,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32225,34.11,0.43,66.3,8730,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02798',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32226,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',32226,36.55,0.27,204,8731,70,NULL,NULL,'CGCG 391-021 NED03',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.7g',0.21,'E1?',NULL,NULL,NULL,NULL,1,54.554125,1.16153,0.177,NULL,64980814838,1015325231,15864456,16.7),(32227,'SNIa SDSS','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 16430','RN',32227,34.99,0.08,95.4,8732,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 16430',0.040585,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32228,'SNIa','2016-12-15 15:14:00','2016-12-16 11:19:04','1','SDSS-II SN 15385',NULL,32228,39.59,0.27,827,8733,70,NULL,'SN photometric redshift distance, z photo =0.216 +/- 0.033','SDSS-II SN 15385',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.9g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,54.5554583,0.40389,0.201,NULL,64980606291,1015321973,15864405,21.9),(32229,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32229,31.62,0.26,21.1,8734,NULL,NULL,NULL,'ESO 358- G 044',NULL,'2006AJ....132.1384D',2006,1,2.2,NULL,'G',0.000067,NULL,'15.8',2,'E0:','Group member',NULL,NULL,NULL,1,54.5562083,-37.29017,0,NULL,38556611393,602447053,9413235,15.8),(32230,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32230,31.39,0.52,19,8735,NULL,NULL,'TOM(g) = -7.2 mag','ESO 358- G 043',NULL,'2010ApJ...717..603V',2010,1,1.2,NULL,'G',0.000093,NULL,'14.76',0.5,'S0-','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,54.556625,-33.12717,0,NULL,38564713362,602573646,9415213,14.76),(32231,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32231,32.13,0.76,26.7,8735,NULL,NULL,'TOM(z) = -8.53 mag','ESO 358- G 043',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32232,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32232,31.6,0.14,20.9,8735,74.4,NULL,NULL,'ESO 358- G 043',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32233,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32233,31.62,0.08,21.1,8735,NULL,NULL,'HST ACS FCS','ESO 358- G 043',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32234,'GC radius','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32234,31,0.72,15.9,8735,NULL,NULL,'HST ACS FCS','ESO 358- G 043',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32235,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',32235,37.98,0.46,395,8736,70,NULL,NULL,'2MASX J03381763-0540012',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000077,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,54.573375,-5.66692,0.117,NULL,36826107563,575407930,8990748,17.8),(32236,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',32236,36.55,0.27,204,8737,70,NULL,NULL,'CGCG 391-021 NED07',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.19,'E3',NULL,NULL,NULL,NULL,1,54.577667,1.19092,0.177,NULL,64980815003,1015325234,15864456,17.4),(32237,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32237,31.02,0.09,16,8738,NULL,NULL,NULL,'FCC 207',NULL,'2006AJ....132.1384D',2006,1,0.91,NULL,'G',0.000067,NULL,'15.9B',0.62,'dE2,N','Group member',NULL,NULL,NULL,1,54.5802917,-35.12908,0,NULL,38568385297,602631020,9416109,15.9),(32238,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32238,31.4,0.13,19.1,8738,NULL,NULL,NULL,'FCC 207',NULL,'2006AJ....132.1384D',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32239,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32239,34.46,0.43,77.8,8739,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02801',NULL,'2014MNRAS.444..527S',2014,1,1.34,'Haynes, et al. (1999AJ....117.2039H) give v = 6015 km/sec.','G',0.00004,NULL,'16.0',0.19,'Sbc',NULL,NULL,NULL,NULL,1,54.5824583333,41.29272,1.373,NULL,68555596822,1071181200,16737206,16),(32240,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',32240,34.46,0.49,77.9,8739,75,NULL,'IR','UGC 02801',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32241,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32241,34.59,0.43,82.9,8739,75,NULL,'3.6 micron, color corrected','UGC 02801',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32242,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32242,34.7,0.2,87.1,8739,74.4,NULL,NULL,'UGC 02801',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32243,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32243,35.36,NULL,118,8739,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02801',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32244,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32244,35.38,NULL,119,8739,NULL,NULL,'Dipole + Quadrupole','UGC 02801',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32245,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32245,35.38,NULL,119,8739,NULL,NULL,'Dipole','UGC 02801',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32246,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32246,35.43,0.44,122,8740,NULL,NULL,'Malmquist cor.','UGC 02806',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',NULL,NULL,'16.0',0.3,'S?',NULL,NULL,NULL,NULL,1,54.583917,7.63581,0.941,NULL,65004904903,1015701639,15870338,16),(32247,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',32247,35.56,0.49,129,8740,75,NULL,'IR','UGC 02806',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32248,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32248,35.62,0.4,133,8740,NULL,NULL,NULL,'UGC 02806',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32249,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32249,35.71,0.2,139,8740,74.4,NULL,NULL,'UGC 02806',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32250,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32250,31.69,0.33,21.8,8741,NULL,NULL,NULL,'FCC 211',NULL,'2006A&A...458.1013M',2006,1,0.56,NULL,'G',0.00005,NULL,'16.80',0.43,'d:E2,N','Group member',NULL,NULL,NULL,1,54.589667,-35.25947,0,NULL,38568485571,602632587,9416134,16.8),(32251,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',32251,36.4,0.46,191,8742,70,NULL,NULL,'2MASX J03382330-0111032',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.52',0.28,NULL,NULL,NULL,NULL,NULL,1,54.5970416667,-1.18406,0.305,NULL,36810542569,575164727,8986948,17.52),(32252,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32252,36.64,0.61,213,8743,70,NULL,NULL,'SARS 054.14868-40.23040',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.000073,NULL,'16.97',0.28,NULL,NULL,NULL,NULL,NULL,1,54.59875,-40.06761,0,NULL,38470614392,601103349,9392239,16.97),(32253,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32253,34.71,0.48,87.3,8744,70,NULL,NULL,'FAIRALL 0755',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'14.4R',0.26,NULL,NULL,NULL,NULL,NULL,1,54.6081666667,-63.35872,0.129,NULL,36274588661,566790447,8856100,14.4),(32254,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32254,31.51,0.08,20,8745,NULL,NULL,'Fornax Cluster, HST KP Calibrated, K\'','NGC 1399',NULL,'2000ApJ...529..745F',2000,1,6.9,NULL,'G',0.000013,NULL,'10.6B',6.5,'cD;E1 pec      AGN','Group member, radial-velocity confirmed',NULL,'radio jet','Sy 2',1,54.6209583333,-35.45067,0,NULL,38568510628,602632978,9416140,10.6),(32255,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32255,31.6,0.04,20.9,8745,NULL,NULL,'Fornax Cluster, HST KP Calibrated ','NGC 1399',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32256,'Cepheids','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32256,31.75,0.19,22.4,8745,NULL,NULL,'HST KP Calibrated, K\'','NGC 1399',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32257,'CMD','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32257,31.19,0.2,17.3,8745,NULL,NULL,NULL,'NGC 1399',NULL,'1982AJ.....87..462G',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32258,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32258,30.8,0.05,14.5,8745,NULL,NULL,'TOM(I) = -8.53 mag, t5 function, Harris et al. 1991','NGC 1399',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32259,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32259,30.85,0.11,14.8,8745,NULL,NULL,'TOM(I) = -8.53 mag,Harris et al. 1991, Fornax cluster, Z corr.','NGC 1399',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32260,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32260,30.85,0.22,14.8,8745,NULL,NULL,'600 GCs, M(V) = -7.50 mag, true','NGC 1399',NULL,'1990ApJ...350L...5G',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32261,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32261,30.89,0.13,15.1,8745,NULL,NULL,'TOM(I) = -8.53 mag,Harris et al. 1991, Fornax cluster','NGC 1399',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32262,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32262,30.9,0.4,15.1,8745,NULL,NULL,'B, Z','NGC 1399',NULL,'1995AJ....110.1164A',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32263,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32263,30.91,0.19,15.2,8745,NULL,NULL,NULL,'NGC 1399',NULL,'1999AJ....117..167G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32264,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32264,31,0.25,15.8,8745,NULL,NULL,'600 GCs, M(V) = -7.50 mag','NGC 1399',NULL,'1990ApJ...350L...5G',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32265,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32265,31,0.05,15.8,8745,NULL,NULL,'TOM(I) = -8.73 mag, t5 function, Sandage & Tammann (1995)','NGC 1399',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32266,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32266,31,0.35,15.8,8745,NULL,NULL,'V, Z','NGC 1399',NULL,'1995AJ....110.1164A',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32267,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32267,31.02,0.2,16,8745,NULL,NULL,NULL,'NGC 1399',NULL,'1998AJ....116.2854O',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32268,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32268,31.07,0.13,16.4,8745,NULL,NULL,'TOM(V) = -7.4 mag,Harris et al. 1991, Fornax cluster, Z corr.','NGC 1399',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32269,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32269,31.09,0.06,16.5,8745,NULL,NULL,'TOM(I) = -8.73 mag, Gaussian, Sandage & Tammann (1995)','NGC 1399',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32270,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32270,31.12,0.15,16.7,8745,NULL,NULL,'TOM(V) = -7.29 mag, Secker 1992','NGC 1399',NULL,'1996ApJ...465L..19B',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32271,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32271,31.2,0.13,17.4,8745,NULL,NULL,'TOM(V) = -7.4 mag,Harris et al. 1991, Fornax cluster','NGC 1399',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32272,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32272,31.21,0.08,17.5,8745,NULL,NULL,'TOM(V) = -7.4 mag, Gaussian, Harris et al. 1991, Z corr. -0.09 mag','NGC 1399',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32273,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32273,31.26,0.08,17.9,8745,NULL,NULL,'TOM(I) = -8.53 mag, Gaussian, Harris et al. 1991, Z corr. -0.04 mag','NGC 1399',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32274,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32274,31.29,0.05,18.1,8745,NULL,NULL,'TOM(g) = -7.2 mag','NGC 1399',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32275,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32275,31.3,0.2,18.2,8745,NULL,NULL,'TOM(V) = -7.3 mag','NGC 1399',NULL,'2009ApJ...690..512H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32276,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32276,31.3,0.08,18.2,8745,NULL,NULL,'TOM(V) = -7.4 mag, Gaussian, Harris et al. 1991','NGC 1399',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32277,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32277,31.3,0.08,18.2,8745,NULL,NULL,'TOM(I) = -8.53 mag, Gaussian, Harris et al. 1991','NGC 1399',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32278,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32278,31.3,0.08,18.2,8745,NULL,NULL,'TOM(V) = -7.4 mag, t5 function, Harris et al. 1991','NGC 1399',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32279,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32279,31.3,0.2,18.2,8745,NULL,NULL,NULL,'NGC 1399',NULL,'1991AJ....101..469B',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32280,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32280,31.31,0.27,18.3,8745,NULL,NULL,'HST KP Calibrated, V','NGC 1399',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32281,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32281,31.33,0.04,18.5,8745,NULL,NULL,'TOM(z) = -8.53 mag','NGC 1399',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32282,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32282,31.38,0.15,18.9,8745,NULL,NULL,'Fornax Cluster, HST KP Calibrated, V','NGC 1399',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32283,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32283,31.43,0.15,19.3,8745,NULL,NULL,'TOM(V) = -7.60 mag, Sandage & Tammann 1995','NGC 1399',NULL,'1996ApJ...465L..19B',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32284,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32284,31.56,0.51,20.5,8745,NULL,NULL,'HST KP Calibrated, B','NGC 1399',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32285,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32285,31.58,0.08,20.7,8745,NULL,NULL,'TOM(V) = -7.68 mag, Gaussian, Sandage & Tammann (1995)','NGC 1399',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32286,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32286,31.58,0.08,20.7,8745,NULL,NULL,'TOM(V) = -7.68 mag, t5 function, Sandage & Tammann (1995)','NGC 1399',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32287,'GCLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32287,31.76,0.31,22.5,8745,NULL,NULL,'Fornax Cluster, HST KP Calibrated, B','NGC 1399',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32288,'PNLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32288,31.11,0.09,16.7,8745,NULL,NULL,NULL,'NGC 1399',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32289,'PNLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32289,31.17,0.07,17.1,8745,NULL,NULL,NULL,'NGC 1399',NULL,'1993ApJ...416...62M',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32290,'PNLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32290,31.2,0.07,17.4,8745,NULL,NULL,'Fornax Cluster, HST KP Calibrated ','NGC 1399',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32291,'PNLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32291,31.22,0.08,17.5,8745,NULL,NULL,'I','NGC 1399',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32292,'PNLF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32292,31.22,0.11,17.5,8745,NULL,NULL,'HST KP Calibrated','NGC 1399',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32293,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32293,30.7,0.2,13.8,8745,NULL,NULL,'I','NGC 1399',NULL,'1993A&A...275..433B',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32294,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32294,30.87,0.11,14.9,8745,NULL,NULL,'I','NGC 1399',NULL,'1991ApJ...373L...1T',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32295,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32295,30.99,0.1,15.8,8745,NULL,NULL,'I','NGC 1399',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32296,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32296,31.23,0.06,17.6,8745,NULL,NULL,'I','NGC 1399',NULL,'1997ApJ...475..399T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32297,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32297,31.34,0.16,18.5,8745,NULL,NULL,'I','NGC 1399',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32298,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32298,31.42,0.14,19.2,8745,NULL,NULL,'I','NGC 1399',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32299,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32299,31.5,0.16,20,8745,NULL,NULL,NULL,'NGC 1399',NULL,'2001ApJ...550..503J',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32300,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32300,31.5,0.16,20,8745,NULL,NULL,'I','NGC 1399',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32301,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32301,31.5,0.16,20,8745,NULL,NULL,NULL,'NGC 1399',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32302,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32302,31.53,0.16,20.3,8745,NULL,NULL,'Malmquist cor.','NGC 1399',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32303,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32303,31.56,0.17,20.5,8745,NULL,NULL,'HST KP Calibrated, I','NGC 1399',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32304,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32304,31.59,0.04,20.8,8745,NULL,NULL,'Fornax Cluster, HST KP Calibrated, I','NGC 1399',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32305,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32305,31.59,0.16,20.8,8745,NULL,NULL,'K','NGC 1399',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32306,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32306,31.6,0.09,20.9,8745,NULL,NULL,'HST ACS FCS','NGC 1399',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32307,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32307,31.62,0.07,21.1,8745,NULL,NULL,'I','NGC 1399',NULL,'2010ApJ...724..657B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32308,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32308,31.72,0.12,22.1,8745,74.4,NULL,NULL,'NGC 1399',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32309,'SBF','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32309,31.98,0.12,24.9,8745,NULL,NULL,'KS','NGC 1399',NULL,'2002ApJ...564..216L',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32310,'GC radius','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32310,31.44,0.08,19.4,8745,NULL,NULL,'HST ACS FCS','NGC 1399',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32311,'D-Sigma','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',32311,31.14,NULL,16.9,8745,69,NULL,'Fornax Cluster, D-Sigma/Faber-Jackson hybrid indicator [for Coma D = 100 Mpc]','NGC 1399',NULL,'1991BAAS...23..956G',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32312,'D-Sigma','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32312,31.17,0.1,17.1,8745,72,NULL,'Fornax cluster, 18 galaxies','NGC 1399',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32313,'D-Sigma','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32313,31.22,0.49,17.5,8745,NULL,NULL,'assume Virgo m-M = 31.00 mag','NGC 1399',NULL,'1987ApJ...313...42D',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32314,'D-Sigma','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32314,31.26,0.4,17.8,8745,75,NULL,'Edat, raw','NGC 1399',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32315,'D-Sigma','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32315,31.29,0.4,18.1,8745,75,NULL,'Edat, cor','NGC 1399',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32316,'Diameter','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32316,31.14,NULL,16.9,8745,NULL,NULL,NULL,'NGC 1399',NULL,'1991ApJ...382....1G',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32317,'Faber-Jackson','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32317,29.6,0.63,8.32,8745,95,NULL,'Michard 1979b, c','NGC 1399',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32318,'Faber-Jackson','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32318,30.37,0.46,11.9,8745,95,NULL,'Michard 1979a','NGC 1399',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32319,'Faber-Jackson','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32319,30.42,0.37,12.1,8745,95,NULL,'Weighted Mean','NGC 1399',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32320,'Faber-Jackson','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32320,30.6,0.5,13.2,8745,88,NULL,'Fornax cluster, B','NGC 1399',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32321,'Faber-Jackson','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32321,30.6,0.5,13.2,8745,88,NULL,'Fornax Cluster, 11 galaxies, B','NGC 1399',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32322,'Faber-Jackson','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32322,30.64,0.41,13.4,8745,88,NULL,'Fornax cluster, BRI mean','NGC 1399',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32323,'Faber-Jackson','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32323,30.69,0.49,13.7,8745,88,NULL,'Fornax cluster, R','NGC 1399',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32324,'Faber-Jackson','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32324,30.69,0.41,13.7,8745,88,NULL,'Fornax cluster, I','NGC 1399',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32325,'Faber-Jackson','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32325,30.69,0.49,13.7,8745,88,NULL,'Fornax Cluster, 11 galaxies, R','NGC 1399',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32326,'Faber-Jackson','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32326,30.69,0.41,13.7,8745,88,NULL,'Fornax Cluster, 11 galaxies, I','NGC 1399',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32327,'Faber-Jackson','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,'R',32327,31.87,NULL,23.7,8745,NULL,NULL,'LEDA [April 2006]','NGC 1399',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32328,'Faber-Jackson','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32328,32.73,0.81,35.2,8745,55,NULL,'Visvanathan & Sandage 1979','NGC 1399',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32329,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32329,30.59,0.35,13.1,8745,88,NULL,'Fornax cluster, R','NGC 1399',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32330,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32330,30.59,0.35,13.1,8745,88,NULL,'Fornax Cluster, 11 galaxies, R','NGC 1399',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32331,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32331,30.65,0.33,13.5,8745,88,NULL,'Fornax cluster, BRI mean','NGC 1399',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32332,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32332,30.66,0.38,13.6,8745,88,NULL,'Fornax Cluster, 11 galaxies, B','NGC 1399',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32333,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32333,30.66,0.38,13.6,8745,88,NULL,'Fornax cluster, B','NGC 1399',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32334,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32334,30.69,0.33,13.7,8745,88,NULL,'Fornax Cluster, 11 galaxies, I','NGC 1399',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32335,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32335,30.69,0.33,13.7,8745,88,NULL,'Fornax cluster, I','NGC 1399',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32336,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32336,31.22,0.65,17.5,8745,NULL,NULL,'assume Virgo m-M = 31.00 mag','NGC 1399',NULL,'1987ApJ...313...42D',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32337,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32337,31.35,0.12,18.6,8745,NULL,NULL,'Fornax cluster, Virgo m-M = 31.1 mag','NGC 1399',NULL,'1998MNRAS.295..933G',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32338,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32338,31.57,NULL,20.6,8745,NULL,NULL,NULL,'NGC 1399',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32339,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32339,31.62,0.41,21.1,8745,NULL,NULL,NULL,'NGC 1399',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32340,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32340,31.67,0.34,21.6,8745,NULL,NULL,'Fornax cluster, Virgo m-M = 31.1 mag','NGC 1399',NULL,'2002MNRAS.334..859G',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32341,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32341,31.69,0.44,21.8,8745,NULL,NULL,'Fornax cluster, Virgo m-M = 31.1 mag, Photometric Plane','NGC 1399',NULL,'2002MNRAS.334..859G',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32342,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32342,31.72,0.12,22.1,8745,74.4,NULL,NULL,'NGC 1399',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32343,'FP','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32343,31.73,0.41,22.1,8745,NULL,NULL,'Malmquist cor.','NGC 1399',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32344,'Tertiary','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32344,31.11,0.41,16.7,8745,95,NULL,NULL,'NGC 1399',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32345,'Tully est','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32345,31.14,0.8,16.9,8745,75,NULL,'B','NGC 1399',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32346,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32346,30.88,NULL,15,8745,71,NULL,'ABELL S0373, Fornax CLUSTER, 45 galaxies','NGC 1399',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32347,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32347,30.93,0.3,15.3,8745,NULL,NULL,'ABELL S0373, Fornax CLUSTER, 14 galaxies','NGC 1399',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32348,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32348,30.94,0.33,15.4,8745,74,NULL,'23 spirals','NGC 1399',NULL,'1996ApJ...463...60B',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32349,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32349,31.16,0.13,17.1,8745,75,NULL,'Fornax cluster, avg. of 15 spiral galaxies','NGC 1399',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32350,'Tully-Fisher','2016-12-15 15:14:00','2016-12-16 11:19:04','1',NULL,NULL,32350,31.2,0.14,17.4,8745,75,NULL,'Fornax cluster, avg. of 15 spiral galaxies','NGC 1399',NULL,'2013ApJ...765...94S',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32351,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32351,31.21,0.13,17.4,8745,74.4,NULL,'Fornax CLUSTER, 15 galaxies, WISE W2 (4.6 micro-meter), color corrected','NGC 1399',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32352,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32352,31.21,0.13,17.5,8745,74.4,NULL,'Fornax CLUSTER, 15 galaxies, WISE W1 (3.4 micro-meter), color corrected','NGC 1399',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32353,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,'R',32353,31.22,0.1,17.5,8745,71,NULL,'Fornax Cluster','NGC 1399',NULL,'1982PASAu...4..419V',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32354,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32354,31.22,0.13,17.5,8745,74.4,NULL,'Fornax CLUSTER, 15 galaxies, WISE I-band','NGC 1399',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32355,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32355,31.25,0.1,17.8,8745,74.4,NULL,'Fornax CLUSTER, 15 galaxies, WISE W2 (4.6 micro-meter), curved','NGC 1399',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32356,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32356,31.25,0.5,17.8,8745,77,NULL,'Fornax cluster, 16 galaxies','NGC 1399',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32357,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32357,31.25,NULL,17.8,8745,77,NULL,'BRIK, Fornax CLUSTER, 16 galaxies','NGC 1399',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32358,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32358,31.28,0.1,18.1,8745,74.4,NULL,'Fornax CLUSTER, 15 galaxies, WISE W1 (3.4 micro-meter), curved','NGC 1399',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32359,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:04','1','SDSS-II SN 16631','R',32359,39.75,0.12,733,8746,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006pv','SN 2006pv',0.216,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,54.6227916667,-0.67558,0.253,NULL,36811047963,575172624,8987072,NULL),(32360,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:04','1','SDSS-II SN 16631','R',32360,40.23,0.31,913,8746,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006pv','SN 2006pv',0.216,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32361,'Cepheids','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32361,31.2,0.2,17.4,8747,NULL,NULL,'HST KP Calibrated, K\'','NGC 1395',NULL,'2000ApJ...529..745F',2000,1,5.9,NULL,'G',0.000022,NULL,'10.97',4.5,'E2','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,54.6239583,-23.02753,0.017,NULL,38042015039,594406484,9287601,10.97),(32362,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32362,31.04,0.17,16.1,8747,NULL,NULL,'K','NGC 1395',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32363,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32363,31.16,0.14,17.1,8747,NULL,NULL,'I','NGC 1395',NULL,'1991ApJ...373L...1T',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32364,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32364,31.2,0.2,17.4,8747,NULL,NULL,'I','NGC 1395',NULL,'1993A&A...275..433B',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32365,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32365,31.63,0.41,21.2,8747,NULL,NULL,'I','NGC 1395',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32366,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32366,31.88,0.12,23.8,8747,74.4,NULL,NULL,'NGC 1395',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32367,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32367,31.91,0.16,24.1,8747,NULL,NULL,'I','NGC 1395',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32368,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32368,31.91,0.16,24.1,8747,NULL,NULL,NULL,'NGC 1395',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32369,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32369,31.93,0.16,24.3,8747,NULL,NULL,'Malmquist cor.','NGC 1395',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32370,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32370,31.97,0.18,24.8,8747,NULL,NULL,'HST KP Calibrated, I','NGC 1395',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32371,'D-Sigma','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32371,31.93,0.4,24.3,8747,75,NULL,'Edat, raw','NGC 1395',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32372,'D-Sigma','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32372,32.02,0.12,25.4,8747,72,NULL,'Eridanus GROUP, 13 galaxies','NGC 1395',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32373,'D-Sigma','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32373,32.02,0.4,25.4,8747,75,NULL,'Edat, cor','NGC 1395',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32374,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32374,31.18,0.48,17.2,8747,95,NULL,'Weighted Mean','NGC 1395',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32375,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,'R',32375,31.26,NULL,17.9,8747,NULL,NULL,'LEDA [April 2006]','NGC 1395',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32376,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32376,31.49,0.71,19.9,8747,95,NULL,'de Vaucouleurs','NGC 1395',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32377,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32377,32.11,0.81,26.4,8747,55,NULL,'Visvanathan & Sandage 1979','NGC 1395',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32378,'FP','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32378,31.64,0.41,21.3,8747,NULL,NULL,NULL,'NGC 1395',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32379,'FP','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32379,31.8,0.41,22.9,8747,NULL,NULL,'Malmquist cor.','NGC 1395',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32380,'FP','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32380,31.88,0.12,23.8,8747,74.4,NULL,NULL,'NGC 1395',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32381,'Tertiary','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32381,30.78,0.21,14.3,8747,95,NULL,NULL,'NGC 1395',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32382,'Tully est','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32382,31.5,0.8,20,8747,75,NULL,'B','NGC 1395',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32383,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32383,31.58,NULL,20.7,8747,71,NULL,'Eridanus GROUP, 30 galaxies','NGC 1395',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32384,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32384,31.66,0.3,21.5,8747,NULL,NULL,'Eridanus GROUP, 14 galaxies','NGC 1395',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32385,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:04','1','SDSS-II SN 04059','R',32385,40.73,0.22,1070,8748,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 04059',0.3037,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,54.6499583,0.14575,0.197,NULL,64980569617,1015321400,15864396,NULL),(32386,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:04','1','SDSS-II SN 04059','R',32386,40.75,0.28,1080,8748,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 04059',0.3037,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32387,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32387,31.89,0.45,23.9,8749,NULL,NULL,NULL,'LSBG F358-042',NULL,'2006A&A...458.1013M',2006,1,0.38,NULL,'G',NULL,NULL,'19.0',NULL,'dE0','Group member',NULL,NULL,NULL,1,54.652917,-35.83417,0,NULL,38568115078,602626798,9416043,19),(32388,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32388,31.31,0.45,18.3,8750,NULL,NULL,NULL,'WFLSB 09-04',NULL,'2006A&A...458.1013M',2006,1,0.16,NULL,'G',NULL,NULL,'20.43',0.12,NULL,NULL,NULL,NULL,NULL,1,54.655,-35.91725,0,NULL,38568105705,602626651,9416041,20.43),(32389,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32389,31.43,0.45,19.3,8751,NULL,NULL,NULL,'FCC 215',NULL,'2006A&A...458.1013M',2006,1,0.29,NULL,'G',0.000067,':','19.2',NULL,'dE,N?','Group member',NULL,NULL,NULL,1,54.656875,-35.75761,0,NULL,38568101438,602626584,9416040,19.2),(32390,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32390,32.18,0.45,27.2,8752,NULL,NULL,'K','NGC 1393',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000057,NULL,'12.97',1.3,'SA(rl)0^0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,54.66075,-18.42797,0.145,NULL,38010992005,593921750,9280027,12.97),(32391,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32391,32.5,0.4,31.6,8752,NULL,NULL,'mean','NGC 1393',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32392,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32392,31.41,0.14,19.1,8753,74.4,NULL,NULL,'NGC 1411',NULL,'2013AJ....146...86T',2013,1,2.3,'This is most likely NGC 1411 with 9 minute RA error in IC position.','G',0.000038,NULL,'12.23',1.7,'SA(r)0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,54.6869583,-44.10061,0,NULL,37763545723,590055401,9219615,12.23),(32393,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32393,31.48,0.25,19.8,8753,NULL,NULL,'I','NGC 1411',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32394,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32394,29.88,0.65,9.46,8753,95,NULL,'Weighted Mean','NGC 1411',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32395,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32395,30.83,0.81,14.7,8753,55,NULL,'Visvanathan & Sandage 1979','NGC 1411',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32396,'Tully est','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32396,30.25,0.8,11.2,8753,75,NULL,'B','NGC 1411',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32397,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32397,30.62,0.4,13.3,8754,NULL,NULL,NULL,'LSBG F358-041',NULL,'2006A&A...458.1013M',2006,1,0.47,NULL,'G',NULL,NULL,'18.5B',NULL,'dE4','Group member',NULL,NULL,NULL,1,54.689167,-35.26639,0,NULL,38568468187,602632315,9416129,18.5),(32398,'FP','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,'R',32398,36.55,0.27,204,8755,70,NULL,NULL,'2MASX J03384573+0110049',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000105,NULL,'16.0g',0.43,'E0',NULL,NULL,NULL,NULL,1,54.6905416667,1.16803,0.297,NULL,64981534610,1015336478,15864632,16),(32399,'FP','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,'R',32399,37.66,0.46,340,8756,70,NULL,NULL,'2MASX J03384707-0520585',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000089,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,54.696125,-5.34961,0.109,NULL,36817769180,575277643,8988713,17),(32400,'FP','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,'R',32400,38.24,0.46,445,8757,70,NULL,NULL,'2MASXi J0338471-053947',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00008,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,54.696625,-5.66325,0.117,NULL,36826089263,575407644,8990744,18.4),(32401,'FP','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,'R',32401,37.45,0.46,310,8758,70,NULL,NULL,'SDSS J033849.58-070624.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000068,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,54.7065833333,-7.10672,0.117,NULL,36797261370,574957208,8983706,18.2),(32402,'FP','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32402,36.38,0.78,189,8759,70,NULL,NULL,'2MASX J03384978-6338415',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.00015,NULL,'15.8R',0.14,NULL,NULL,NULL,NULL,NULL,1,54.7075416667,-63.64489,0.129,NULL,36274465623,566788525,8856070,15.8),(32403,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,'R',32403,33.61,0.49,52.7,8760,75,NULL,'IR','FGC 0438',NULL,'2011yCatp016004901K',2011,1,1.15,NULL,'G',0.00003,NULL,'16.3',0.11,'Scd',NULL,NULL,NULL,NULL,1,54.7103333333,-4.79292,0.093,NULL,36818441646,575288150,8988877,16.3),(32404,'FP','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32404,36.83,0.78,232,8761,70,NULL,NULL,'2MASX J03385135-1648535',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'16.54',0.22,NULL,NULL,NULL,NULL,NULL,1,54.7137916667,-16.81483,0.261,NULL,38016685105,594010704,9281417,16.54),(32405,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32405,34.58,0.4,82.4,8762,NULL,NULL,'mean','UGC 02805',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000023,NULL,'14.8',0.7,'SABc',NULL,NULL,NULL,NULL,1,54.715917,40.99053,1.105,NULL,68552096118,1071126501,16736351,14.8),(32406,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32406,35.06,0.47,103,8762,NULL,NULL,'H','UGC 02805',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32407,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32407,35.1,0.45,105,8762,NULL,NULL,'K','UGC 02805',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32408,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32408,35.12,0.46,106,8762,NULL,NULL,'J','UGC 02805',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32409,'Cepheids','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32409,31.59,0.18,20.8,8763,NULL,NULL,'HST KP Calibrated, K\'','NGC 1404',NULL,'2000ApJ...529..745F',2000,1,3.3,NULL,'G',0.000013,NULL,'11.0B',3,'NELG           ALG','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,54.7163333333,-35.59439,0,NULL,38568495086,602632735,9416136,11),(32410,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32410,31.05,0.21,16.2,8763,NULL,NULL,NULL,'NGC 1404',NULL,'1999AJ....117..167G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32411,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32411,31.21,0.2,17.5,8763,NULL,NULL,'TOM(V) = -7.29 mag, Secker 1992','NGC 1404',NULL,'1996ApJ...465L..19B',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32412,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32412,31.34,0.07,18.5,8763,NULL,NULL,'TOM(g) = -7.2 mag','NGC 1404',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32413,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32413,31.4,0.2,19.1,8763,NULL,NULL,NULL,'NGC 1404',NULL,'1992A&A...264...25R',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32414,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32414,31.47,0.07,19.7,8763,NULL,NULL,'TOM(z) = -8.53 mag','NGC 1404',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32415,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32415,31.52,0.2,20.1,8763,NULL,NULL,'TOM(V) = -7.60 mag, Sandage & Tammann 1995','NGC 1404',NULL,'1996ApJ...465L..19B',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32416,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32416,31.59,0.29,20.8,8763,NULL,NULL,'HST KP Calibrated, V','NGC 1404',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32417,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32417,31.6,0.4,20.9,8763,NULL,NULL,'TOM(V) = -7.3 mag','NGC 1404',NULL,'2009ApJ...690..512H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32418,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32418,31.7,0.2,21.9,8763,NULL,NULL,NULL,'NGC 1404',NULL,'2001A&A...371..875G',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32419,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32419,31.85,0.54,23.4,8763,NULL,NULL,'HST KP Calibrated, B','NGC 1404',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32420,'PNLF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32420,31.1,0.12,16.6,8763,NULL,NULL,NULL,'NGC 1404',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32421,'PNLF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32421,31.15,0.1,17,8763,NULL,NULL,NULL,'NGC 1404',NULL,'1993ApJ...416...62M',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32422,'PNLF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32422,31.21,0.1,17.5,8763,NULL,NULL,'I','NGC 1404',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32423,'PNLF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32423,31.22,0.12,17.5,8763,NULL,NULL,'HST KP Calibrated','NGC 1404',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32424,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:04','1','SN 2007on',NULL,32424,31.61,0.09,21,8763,72,NULL,'M(H) = -18.317 mag','NGC 1404',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32425,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32425,30.99,0.1,15.8,8763,NULL,NULL,'I','NGC 1404',NULL,'1991ApJ...373L...1T',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32426,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32426,31.05,0.2,16.2,8763,NULL,NULL,'I','NGC 1404',NULL,'1993A&A...275..433B',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32427,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32427,31.09,0.09,16.5,8763,NULL,NULL,'I','NGC 1404',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32428,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32428,31.27,0.08,17.9,8763,NULL,NULL,'I','NGC 1404',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32429,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32429,31.43,0.14,19.3,8763,NULL,NULL,'K','NGC 1404',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32430,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32430,31.45,0.19,19.5,8763,NULL,NULL,'I','NGC 1404',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32431,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32431,31.45,0.12,19.5,8763,74.4,NULL,NULL,'NGC 1404',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32432,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32432,31.53,0.07,20.2,8763,NULL,NULL,'HST ACS FCS','NGC 1404',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32433,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32433,31.54,0.07,20.4,8763,NULL,NULL,'I','NGC 1404',NULL,'2010ApJ...724..657B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32434,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32434,31.61,0.19,21,8763,NULL,NULL,NULL,'NGC 1404',NULL,'2001ApJ...550..503J',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32435,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32435,31.61,0.19,21,8763,NULL,NULL,'I','NGC 1404',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32436,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32436,31.61,0.19,21,8763,NULL,NULL,NULL,'NGC 1404',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32437,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32437,31.64,0.2,21.3,8763,NULL,NULL,'HST KP Calibrated, I','NGC 1404',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32438,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32438,31.65,0.19,21.4,8763,NULL,NULL,'Malmquist cor.','NGC 1404',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32439,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32439,31.73,0.05,22.2,8763,NULL,NULL,'KS','NGC 1404',NULL,'2002ApJ...564..216L',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32440,'GC radius','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32440,31.28,0.07,18.1,8763,NULL,NULL,'HST ACS FCS','NGC 1404',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32441,'D-Sigma','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32441,31.26,0.4,17.8,8763,75,NULL,'Edat, raw','NGC 1404',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32442,'D-Sigma','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32442,31.29,0.4,18.1,8763,75,NULL,'Edat, cor','NGC 1404',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32443,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32443,31.01,0.65,15.9,8763,95,NULL,'Weighted Mean','NGC 1404',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32444,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,'R',32444,31.39,NULL,19,8763,NULL,NULL,'LEDA [April 2006]','NGC 1404',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32445,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32445,32.23,0.81,27.9,8763,55,NULL,'Visvanathan & Sandage 1979','NGC 1404',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32446,'FP','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32446,30.67,0.41,13.6,8763,NULL,NULL,NULL,'NGC 1404',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32447,'FP','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32447,30.98,0.41,15.7,8763,NULL,NULL,'Malmquist cor.','NGC 1404',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32448,'FP','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32448,31.39,0.56,19,8763,70,NULL,NULL,'NGC 1404',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32449,'FP','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32449,31.45,0.12,19.5,8763,74.4,NULL,NULL,'NGC 1404',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32450,'FP','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32450,31.74,NULL,22.3,8763,NULL,NULL,NULL,'NGC 1404',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32451,'Tertiary','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32451,31.11,0.41,16.7,8763,95,NULL,NULL,'NGC 1404',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32452,'Tully est','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32452,31.14,0.8,16.9,8763,75,NULL,'B','NGC 1404',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32453,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32453,31.41,0.45,19.2,8763,NULL,NULL,'K','NGC 1404',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32454,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32454,31.6,0.4,20.9,8763,NULL,NULL,'mean','NGC 1404',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32455,'Ring Diameter','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32455,31,0.76,16,8764,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 1398',NULL,'1981ApJS...45..541P',1981,1,7.1,NULL,'G',0.000013,NULL,'10.63',5.4,'(R_1R\'_2)SB(rs)ab;Sy','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,54.7172083,-26.33783,0,NULL,38579896345,602810880,9418920,10.63),(32456,'Ring Diameter','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32456,31,0.6,16,8764,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 1398',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32457,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32457,31.04,0.4,16.1,8764,75,NULL,'B','NGC 1398',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32458,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32458,31.73,0.4,22.2,8764,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 3 galaxy group','NGC 1398',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32459,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32459,31.97,0.36,24.8,8764,NULL,NULL,NULL,'NGC 1398',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32460,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32460,31.97,0.4,24.8,8764,73,NULL,'opt','NGC 1398',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32461,'FP','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32461,35.82,0.64,146,8765,70,NULL,NULL,'2MASX J03385281-1801336',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00012,NULL,'17.28',0.19,NULL,NULL,NULL,NULL,NULL,1,54.7200416667,-18.026,0.189,NULL,38011058858,593922794,9280043,17.28),(32462,'FP','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32462,34.2,0.47,69.2,8766,70,NULL,NULL,'NGC 1391',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00013,NULL,'14.37',0.5,'SB(s)0^0^','Group member',NULL,NULL,NULL,1,54.720667,-18.35411,0.145,NULL,38010990076,593921719,9280026,14.37),(32463,'LSB galaxies','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32463,30.84,NULL,14.7,8767,NULL,NULL,NULL,'FCC 220',NULL,'1991ApJ...376..404B',1991,1,0.32,NULL,'G',NULL,NULL,'19.5',NULL,'dE2','Group member',NULL,NULL,NULL,1,54.7297917,-35.23656,0,NULL,38568466773,602632293,9416129,19.5),(32464,'FP','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32464,36.2,0.55,174,8768,70,NULL,NULL,'2MASX J03385735-1643275',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'16.25',0.45,NULL,NULL,NULL,NULL,NULL,1,54.7387083,-16.72439,0.261,NULL,38016699186,594010924,9281420,16.25),(32465,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32465,34.25,0.2,70.8,8769,74.4,NULL,NULL,'ESO 482- G 024',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',NULL,NULL,'16.21',1,'S...',NULL,NULL,NULL,NULL,1,54.748875,-22.584,0.013,NULL,38041882559,594404414,9287568,16.21),(32466,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32466,34.48,0.77,78.5,8769,NULL,NULL,'Malmquist cor.','ESO 482- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32467,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32467,34.51,0.76,79.8,8769,NULL,NULL,NULL,'ESO 482- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32468,'FP','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32468,35.09,0.49,104,8770,70,NULL,NULL,'2MASX J03390011-1710495',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.000103,NULL,'15.87',0.33,NULL,NULL,NULL,NULL,NULL,1,54.7502917,-17.18036,0.229,NULL,38013286215,593957597,9280587,15.87),(32469,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32469,35.09,0.51,104,8771,NULL,NULL,NULL,'2MASX J03390008+1544297',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000017,NULL,'17.0',0.8,NULL,NULL,NULL,NULL,NULL,1,54.7502917,15.74156,0.757,NULL,68030317465,1062973710,16608964,17),(32470,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32470,35.12,0.2,106,8771,74.4,NULL,NULL,'2MASX J03390008+1544297',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32471,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32471,35.25,0.47,112,8771,NULL,NULL,'Malmquist cor.','2MASX J03390008+1544297',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32472,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:04','1','SDSS-II SN 19567','RN',32472,40.37,0.18,924,8772,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 14269 HOST',0.281132,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32473,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:04','1','SDSS-II SN 19567','RN',32473,40.39,0.26,935,8772,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 14269 HOST',0.281132,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32474,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:04','1','SDSS-II SN 14269','RN',32474,40.49,0.28,976,8772,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 14269 HOST',0.281132,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32475,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:04','1','SDSS-II SN 14269','RN',32475,40.53,0.18,998,8772,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 14269 HOST',0.281132,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32476,'FP','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32476,35.97,0.48,156,8773,70,NULL,NULL,'2MASX J03390302-1751405',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'15.27',0.47,'d:E,N','Group member',NULL,NULL,NULL,1,54.762667,-17.86144,0.197,NULL,38011793233,593934269,9280222,15.27),(32477,'D-Sigma','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32477,33.09,0.4,41.6,8774,75,NULL,'Edat, raw','NGC 1403',NULL,'1997ApJS..109..333W',1997,1,1.3,'HIPASS has V = 1877 +- 7 km/s.','G',0.000047,NULL,'14.21',1,'SAB(s)0^0^',NULL,NULL,NULL,NULL,1,54.795167,-22.38875,0.021,NULL,38039525566,594367586,9286993,14.21),(32478,'D-Sigma','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32478,33.43,0.4,48.5,8774,75,NULL,'Edat, cor','NGC 1403',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32479,'FP','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32479,36.54,0.75,204,8775,70,NULL,NULL,'2MASX J03391196-1642135',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.44',0.52,NULL,NULL,NULL,NULL,NULL,1,54.799625,-16.70375,0.261,NULL,38016705687,594011026,9281422,16.44),(32480,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32480,35.71,0.48,139,8776,NULL,NULL,'Malmquist cor.','2MASX J03391270+1558517',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000017,NULL,'16.5',0.7,NULL,NULL,NULL,NULL,NULL,1,54.802917,15.98103,0.757,NULL,68030350402,1062974225,16608972,16.5),(32481,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32481,35.73,0.2,140,8776,74.4,NULL,NULL,'2MASX J03391270+1558517',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32482,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32482,35.91,0.44,152,8776,NULL,NULL,NULL,'2MASX J03391270+1558517',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32483,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32483,31.3,0.18,18.2,8777,NULL,NULL,NULL,'AM 0337-353',NULL,'2006AJ....132.1384D',2006,1,1.3,NULL,'G',0.000017,NULL,'15.7B',1,'SAB(s)0^0^:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,54.805417,-35.37144,0,NULL,38568472569,602632383,9416130,15.7),(32484,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32484,31.45,0.33,19.5,8777,NULL,NULL,NULL,'AM 0337-353',NULL,'2006A&A...458.1013M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32485,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32485,34.87,0.2,94.2,8778,74.4,NULL,NULL,'NGC 1384',NULL,'2013AJ....146...86T',2013,1,0.8,'The 2MASS position is 4 arcsec south of the nucleus.','G',0.000017,NULL,'15.36',0.4,'S?',NULL,NULL,NULL,NULL,1,54.806625,15.81956,0.757,NULL,68030322909,1062973795,16608965,15.36),(32486,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32486,35.01,0.42,100,8778,NULL,NULL,NULL,'NGC 1384',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32487,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32487,35.1,0.41,105,8778,NULL,NULL,'Malmquist cor.','NGC 1384',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32488,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32488,30.85,0.33,14.8,8779,NULL,NULL,NULL,'AM 0337-355',NULL,'2006A&A...458.1013M',2006,1,1.1,'Star superposed with v = -5 km/sec (2001MNRAS.326.1076D).','G',0.000277,NULL,'16.1B',1.1,'E0:','Group member',NULL,NULL,NULL,1,54.8314583,-35.72639,0,NULL,38568146396,602627287,9416051,16.1),(32489,'FP','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32489,30.65,0.25,13.5,8780,74.4,NULL,NULL,'NGC 1401',NULL,'2013AJ....146...86T',2013,1,2.4,NULL,'G',0.000077,NULL,'13.58',0.6,'SB(s)0^0^: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,54.8410417,-22.72469,0.013,NULL,38041932123,594405189,9287581,13.58),(32490,'Tully est','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32490,31.32,0.8,18.4,8780,75,NULL,NULL,'NGC 1401',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32491,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32491,30.67,0.45,13.6,8780,NULL,NULL,'K','NGC 1401',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32492,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32492,31.86,0.4,23.6,8780,NULL,NULL,'mean','NGC 1401',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32493,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32493,30.91,0.39,15.2,8781,NULL,NULL,'I','APMUKS(BJ) B033727.86-354505.7',NULL,'2007A&A...463..503M',2007,1,0.16,NULL,'G',NULL,NULL,'20.18',0.13,NULL,NULL,NULL,NULL,NULL,1,54.84375,-35.59028,0,NULL,38568033966,602625530,9416023,20.18),(32494,'FP','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,'R',32494,36.51,0.46,200,8782,70,NULL,NULL,'2MASX J03392277-0535171',NULL,'2015arXiv151105856S',2015,1,0.37,'The APM image includes a neighboring star or compact companion.','G',0.000081,NULL,'16.5g',0.32,'NLAGN',NULL,NULL,NULL,NULL,1,54.8447917,-5.58803,0.125,NULL,36817856247,575279003,8988734,16.5),(32495,'IRAS','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32495,30.73,0.8,14,8783,75,NULL,'A82, H','NGC 1406',NULL,'1997ApJS..109..333W',1997,1,3.8,NULL,'G',0.000011,NULL,'12.40',0.8,'SB(s)bc: sp    HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,54.847083,-31.32142,0,NULL,38586403289,602912551,9420508,12.4),(32496,'IRAS','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32496,30.75,0.8,14.1,8783,75,NULL,'MAT, I','NGC 1406',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32497,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32497,30.36,0.4,11.8,8783,75,NULL,'B','NGC 1406',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32498,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,'R',32498,31.07,0.4,16.4,8783,75,NULL,NULL,'NGC 1406',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32499,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32499,31.07,0.4,16.4,8783,73,NULL,'IR','NGC 1406',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32500,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32500,31.2,0.4,17.4,8783,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 1406',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32501,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32501,31.2,0.43,17.4,8783,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1406',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32502,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32502,31.24,0.32,17.7,8783,85,NULL,'I, raw','NGC 1406',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32503,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32503,31.25,0.35,17.8,8783,NULL,NULL,NULL,'NGC 1406',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32504,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32504,31.26,0.32,17.9,8783,85,NULL,'I, inv','NGC 1406',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32505,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32505,31.33,0.47,18.4,8783,75,NULL,'A82, H, raw','NGC 1406',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32506,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32506,31.35,0.43,18.7,8783,75,NULL,'3.6 micron, color corrected','NGC 1406',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32507,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32507,31.39,0.47,19,8783,75,NULL,'A82, H, inv','NGC 1406',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32508,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32508,31.4,0.43,19.1,8783,75,NULL,'MAT, I, raw','NGC 1406',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32509,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32509,31.55,0.2,20.4,8783,74.4,NULL,NULL,'NGC 1406',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32510,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32510,31.56,0.43,20.5,8783,75,NULL,'MAT, I, inv','NGC 1406',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32511,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32511,31.57,0.47,20.6,8783,75,NULL,'A82, H, cor','NGC 1406',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32512,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32512,31.6,0.43,20.9,8783,75,NULL,'MAT, I, cor','NGC 1406',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32513,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,'R',32513,31.63,0.49,21.2,8783,75,NULL,'IR','NGC 1406',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32514,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:04','1','SN 2005ew',NULL,32514,31.84,0.89,23.3,8784,74.2,NULL,'SALT 2','NSF J033923.74+350249.0',0.0025,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,'?',NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,54.8489166667,35.04694,1.005,NULL,68483947320,1070061676,16719713,NULL),(32515,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,'R',32515,35.14,0.49,107,8785,75,NULL,'IR','FGC 0439',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000018,NULL,'16.4',0.12,'Scd',NULL,NULL,NULL,NULL,1,54.867917,13.39483,0.933,NULL,65112950482,1017389851,15896716,16.4),(32516,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32516,36.01,NULL,159,8785,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0439',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32517,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32517,36.01,NULL,159,8785,NULL,NULL,NULL,'FGC 0439',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32518,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32518,36.01,NULL,159,8785,NULL,NULL,'Dipole + Quadrupole','FGC 0439',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32519,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32519,36.03,NULL,160,8785,NULL,NULL,'Dipole','FGC 0439',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32520,'Cepheids','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32520,32.22,0.27,27.8,8786,NULL,NULL,'HST KP Calibrated, K\'','NGC 1400',NULL,'2000ApJ...529..745F',2000,1,2.3,NULL,'G',0.000047,NULL,'11.92',2,'SA0-           HII','in a pair',NULL,NULL,NULL,1,54.8785,-18.68808,0.129,NULL,38043554974,594430546,9287977,11.92),(32521,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32521,31.6,NULL,20.9,8786,NULL,NULL,NULL,'NGC 1400',NULL,'2006MNRAS.366.1230F',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32522,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32522,32.02,0.55,25.4,8786,NULL,NULL,'TOM(V) = -7.27 mag','NGC 1400',NULL,'1997AJ....113..895P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32523,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32523,32.28,0.29,28.6,8786,NULL,NULL,NULL,'NGC 1400',NULL,'2001AJ....122.1251K',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32524,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32524,30.4,0.2,12,8786,NULL,NULL,'I','NGC 1400',NULL,'1993A&A...275..433B',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32525,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32525,31.06,0.12,16.3,8786,NULL,NULL,'I','NGC 1400',NULL,'1991ApJ...373L...1T',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32526,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32526,31.67,0.14,21.6,8786,NULL,NULL,'I','NGC 1400',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32527,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32527,31.9,0.14,24,8786,74.4,NULL,NULL,'NGC 1400',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32528,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32528,31.95,0.33,24.5,8786,NULL,NULL,'I','NGC 1400',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32529,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32529,32.07,0.25,25.9,8786,NULL,NULL,'K','NGC 1400',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32530,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:04','1',NULL,NULL,32530,32.11,0.33,26.4,8786,NULL,NULL,'I','NGC 1400',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32531,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32531,32.11,0.33,26.4,8786,NULL,NULL,NULL,'NGC 1400',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32532,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32532,32.13,0.33,26.7,8786,NULL,NULL,'Malmquist cor.','NGC 1400',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32533,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32533,32.19,0.33,27.4,8786,NULL,NULL,'HST KP Calibrated, I','NGC 1400',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32534,'D-Sigma','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32534,31.93,0.4,24.3,8786,75,NULL,'Edat, raw','NGC 1400',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32535,'D-Sigma','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32535,32.02,0.4,25.4,8786,75,NULL,'Edat, cor','NGC 1400',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32536,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32536,31.43,0.63,19.3,8786,95,NULL,'Michard 1979b, c','NGC 1400',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32537,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32537,31.67,0.46,21.6,8786,95,NULL,'Michard 1979a','NGC 1400',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32538,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32538,31.9,0.26,24,8786,95,NULL,'Weighted Mean','NGC 1400',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32539,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32539,32.1,0.36,26.3,8786,95,NULL,'de Vaucouleurs','NGC 1400',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32540,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32540,34.12,0.81,66.7,8786,55,NULL,'Visvanathan & Sandage 1979','NGC 1400',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32541,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32541,32.26,0.41,28.3,8786,NULL,NULL,'Malmquist cor.','NGC 1400',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32542,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32542,32.31,0.41,29,8786,NULL,NULL,NULL,'NGC 1400',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32543,'Tertiary','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32543,30.78,0.21,14.3,8786,95,NULL,NULL,'NGC 1400',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32544,'Tully est','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32544,28.49,0.8,5,8786,75,NULL,'B','NGC 1400',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32545,'IRAS','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32545,32.15,0.8,26.9,8787,75,NULL,'MAT, I','ESO 548- G 063',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'15.31',0.3,'Sb-c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,54.894917,-20.01481,0.105,NULL,38048160515,594502508,9289101,15.31),(32546,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32546,31.56,0.32,20.5,8787,85,NULL,'I, inv','ESO 548- G 063',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32547,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32547,31.6,0.32,20.9,8787,85,NULL,'I, raw','ESO 548- G 063',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32548,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32548,31.7,0.09,21.9,8787,NULL,NULL,NULL,'ESO 548- G 063',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32549,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32549,31.97,0.43,24.8,8787,75,NULL,'MAT, I, inv','ESO 548- G 063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32550,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32550,32.04,0.43,25.6,8787,75,NULL,'MAT, I, raw','ESO 548- G 063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32551,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32551,32.11,0.43,26.4,8787,75,NULL,'MAT, I, cor','ESO 548- G 063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32552,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',32552,32.62,0.49,33.3,8787,75,NULL,'IR','ESO 548- G 063',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32553,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 17215','R',32553,39.68,0.21,730,8788,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007hy','SDSS J033942.58+010533.6',0.181364,'2014arXiv1401.3317S',2014,1,0.25,NULL,'G',0.000079,NULL,'18.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,54.9274166667,1.09269,0.285,NULL,64981387580,1015334180,15864596,18.6),(32554,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 17215','R',32554,39.88,0.15,802,8788,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007hy','SDSS J033942.58+010533.6',0.181364,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32555,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32555,36.62,0.53,211,8789,70,NULL,NULL,'2MASX J03394515-4035514',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'16.40',0.39,NULL,NULL,NULL,NULL,NULL,1,54.938125,-40.59764,0,NULL,38471183778,601112246,9392378,16.4),(32556,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2006jr',NULL,32556,39.14,0.06,673,8790,70,NULL,'Hubble residual -0.06 for z0.17710','SDSS-II SN 14979 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,54.9465416667,0.99214,0.273,NULL,64982264349,1015347880,15864810,NULL),(32557,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 14979','R',32557,39.66,0.19,726,8790,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006jr','SDSS-II SN 14979 HOST',0.1771,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32558,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 14979','R',32558,39.92,0.08,817,8790,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006jr','SDSS-II SN 14979 HOST',0.1771,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32559,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 14593','RN',32559,40.47,0.25,948,8791,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14593',0.307205,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32560,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 14593','RN',32560,40.61,0.18,1010,8791,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14593',0.307205,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32561,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 14593','N',32561,40.27,0.19,1130,8791,70,NULL,'SALT 2','SDSS-II SN 14593',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32562,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 14593','N',32562,40.31,0.19,1150,8791,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14593',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32563,'LSB galaxies','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32563,32.01,NULL,25.2,8792,NULL,NULL,NULL,'FCC 228',NULL,'1991ApJ...376..404B',1991,1,0.41,NULL,'G',NULL,NULL,'18.8',NULL,'dE0','Group member',NULL,NULL,NULL,1,54.9642083,-35.32192,0,NULL,38568004608,602625072,9416016,18.8),(32564,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32564,36.3,0.68,182,8793,70,NULL,NULL,'2MASX J03395225-5448145',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.000127,NULL,'16.89',0.37,NULL,NULL,NULL,NULL,NULL,1,54.967667,-54.80408,0,NULL,35781286393,559082599,8735665,16.89),(32565,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32565,32.07,0.45,25.9,8794,NULL,NULL,NULL,'FCC 229',NULL,'2006A&A...458.1013M',2006,1,0.42,NULL,'G',NULL,NULL,'19.1',NULL,'dE0','Group member',NULL,NULL,NULL,1,54.980833,-35.66194,0,NULL,38568022188,602625346,9416021,19.1),(32566,'Tully est','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32566,31.5,0.8,20,8795,75,NULL,NULL,'UGC 02800',NULL,'1988NBGC.C....0000T',1988,1,2.3,NULL,'G',0.000023,NULL,'16.5',1.1,'Im?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,55.01025,71.40586,1.365,NULL,66402956877,1037546201,16211659,16.5),(32567,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32567,31.39,0.2,19,8795,74.4,NULL,NULL,'UGC 02800',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32568,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32568,31.55,0.4,20.4,8795,NULL,NULL,NULL,'UGC 02800',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32569,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32569,32.16,0.4,27,8796,NULL,NULL,'mean','IC 0343',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.00008,NULL,'14.10',0.8,'SB(rs)0+:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,55.02975,-18.44347,0.161,NULL,38010948281,593921066,9280016,14.1),(32570,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32570,32.38,0.45,29.9,8796,NULL,NULL,'K','IC 0343',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32571,'Tully est','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32571,31.88,0.8,23.8,8797,75,NULL,NULL,'UGCA 081',NULL,'1988NBGC.C....0000T',1988,1,1.2,NULL,'G',0.000003,NULL,'9.91K',0.7,'Im?',NULL,NULL,NULL,NULL,1,55.032125,66.71297,NULL,NULL,66545943195,1039780362,16246568,9.91),(32572,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32572,31.01,0.21,15.9,8798,NULL,NULL,NULL,'NGC 1427A',NULL,'2006A&A...452..141G',2006,1,2.3,NULL,'G',0.000003,NULL,'13.42',1.5,'IB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,55.03875,-35.62444,0,NULL,38568043232,602625675,9416026,13.42),(32573,'Tully est','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32573,31.14,0.8,16.9,8798,75,NULL,NULL,'NGC 1427A',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32574,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32574,35.28,0.47,114,8799,70,NULL,NULL,'NGC 1413',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000103,NULL,'15.23',0.6,'cE0?',NULL,NULL,NULL,NULL,1,55.048125,-15.61078,0.129,NULL,38014994284,593984285,9281004,15.23),(32575,'Cepheids','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32575,31.95,0.19,24.5,8800,NULL,NULL,'HST KP Calibrated, K\'','NGC 1407',NULL,'2000ApJ...529..745F',2000,1,4.6,NULL,'G',0.00003,NULL,'10.7',4.3,'E0','in a pair',NULL,NULL,NULL,1,55.0494166667,-18.58011,0.161,NULL,38043526184,594430096,9287970,10.7),(32576,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32576,31.23,0.25,17.6,8800,NULL,NULL,'TOM(V) = -7.27 mag','NGC 1407',NULL,'1997AJ....113..895P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32577,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32577,31.57,0.1,20.6,8800,NULL,NULL,NULL,'NGC 1407',NULL,'2006MNRAS.366.1230F',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32578,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32578,31.6,NULL,20.9,8800,NULL,NULL,NULL,'NGC 1407',NULL,'2006MNRAS.366.1230F',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32579,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32579,30.6,0.2,13.2,8800,NULL,NULL,'I','NGC 1407',NULL,'1993A&A...275..433B',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32580,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32580,31.07,0.12,16.4,8800,NULL,NULL,'I','NGC 1407',NULL,'1991ApJ...373L...1T',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32581,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32581,31.8,0.15,22.9,8800,NULL,NULL,'K','NGC 1407',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32582,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32582,32,0.1,25.1,8800,NULL,NULL,NULL,'NGC 1407',NULL,'2005ApJ...634..239C',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32583,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32583,32.02,0.19,25.4,8800,NULL,NULL,'I','NGC 1407',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32584,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32584,32.25,0.12,28.2,8800,74.4,NULL,NULL,'NGC 1407',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32585,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32585,32.28,0.26,28.5,8800,NULL,NULL,'Malmquist cor.','NGC 1407',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32586,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32586,32.3,0.26,28.8,8800,NULL,NULL,'I','NGC 1407',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32587,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32587,32.3,0.26,28.8,8800,NULL,NULL,NULL,'NGC 1407',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32588,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32588,32.3,0.26,28.8,8800,NULL,NULL,'HST KP Calibrated, I','NGC 1407',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32589,'D-Sigma','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32589,31.93,0.4,24.3,8800,75,NULL,'Edat, raw','NGC 1407',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32590,'D-Sigma','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32590,32.02,0.4,25.4,8800,75,NULL,'Edat, cor','NGC 1407',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32591,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32591,30.46,0.63,12.4,8800,95,NULL,'Michard 1979b, c','NGC 1407',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32592,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32592,30.81,0.46,14.5,8800,95,NULL,'Michard 1979a','NGC 1407',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32593,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32593,31.08,0.29,16.4,8800,95,NULL,'Weighted Mean','NGC 1407',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32594,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32594,31.5,0.48,20,8800,95,NULL,'de Vaucouleurs','NGC 1407',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32595,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',32595,31.58,NULL,20.7,8800,NULL,NULL,'LEDA [April 2006]','NGC 1407',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32596,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32596,33.4,0.81,47.9,8800,55,NULL,'Visvanathan & Sandage 1979','NGC 1407',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32597,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32597,31.96,0.41,24.7,8800,NULL,NULL,NULL,'NGC 1407',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32598,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32598,32.04,0.41,25.5,8800,NULL,NULL,'Malmquist cor.','NGC 1407',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32599,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32599,32.25,0.12,28.2,8800,74.4,NULL,NULL,'NGC 1407',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32600,'Tertiary','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32600,30.78,0.21,14.3,8800,95,NULL,NULL,'NGC 1407',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32601,'Tully est','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32601,31.67,0.8,21.6,8800,75,NULL,'B','NGC 1407',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32602,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 15710',NULL,32602,40.57,0.17,1300,8801,70,NULL,'SN photometric redshift distance, z photo =0.368 +/- 0.037','SDSS-II SN 15710',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,55.0527083,0.722,0.257,NULL,64981647652,1015338244,15864660,NULL),(32603,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 11938','RN',32603,40.53,0.58,1080,8802,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 11938',0.181252,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32604,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 11938','RN',32604,40.63,0.67,1130,8802,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 11938',0.181252,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32605,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 04657','RN',32605,42.26,0.19,2010,8803,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04657',0.405739,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32606,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 04657','RN',32606,42.65,0.23,2410,8803,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04657',0.405739,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32607,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32607,32.56,0.25,32.5,8804,74.4,NULL,NULL,'ESO 548- G 068',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.00006,NULL,'14.24',0.7,'SB(s)0-: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,55.079875,-18.9315,0.161,NULL,38044379941,594443436,9288178,14.24),(32608,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32608,32.16,0.4,27,8804,NULL,NULL,'mean','ESO 548- G 068',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32609,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32609,32.91,0.45,38.2,8804,NULL,NULL,'K','ESO 548- G 068',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32610,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32610,36.57,0.6,206,8805,70,NULL,NULL,'LSBG F482-021',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.44',0.39,NULL,NULL,NULL,NULL,NULL,1,55.081833,-22.16108,0.029,NULL,38040192937,594378014,9287156,16.44),(32611,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32611,30.77,0.33,14.3,8806,NULL,NULL,NULL,'LSBG F358-037',NULL,'2006A&A...458.1013M',2006,1,1.2,NULL,'G',0.000023,NULL,'17.0B',1,'E0','Group member',NULL,NULL,NULL,1,55.0980833333,-35.27681,0,NULL,38569917559,602654961,9416483,17),(32612,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32612,36.66,0.56,215,8807,70,NULL,NULL,'2MASX J03402403-7322034',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'16.9b',0.15,NULL,NULL,NULL,NULL,NULL,1,55.100375,-73.36753,0.309,NULL,36408198242,568878097,8888720,16.9),(32613,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32613,31.88,0.22,23.8,8808,NULL,NULL,NULL,'FCC 243',NULL,'2006AJ....132.1384D',2006,1,0.87,NULL,'G',0.00015,NULL,'16.6B',0.33,'dE1,N','Group member',NULL,NULL,NULL,1,55.112583,-36.49892,0,NULL,38556920454,602451882,9413310,16.6),(32614,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32614,36.43,0.6,194,8809,70,NULL,NULL,'2MASX J03403012-8540119',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,55.126375,-85.66992,0.497,NULL,35495166454,554611975,8665812,17),(32615,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32615,31.33,0.18,18.5,8810,NULL,NULL,NULL,'FCC 245',NULL,'2006AJ....132.1384D',2006,1,1.02,NULL,'G',0.000107,NULL,'16.0B',0.53,'dE0,N','Group member',NULL,NULL,NULL,1,55.141083,-35.02261,0,NULL,38570677807,602666840,9416669,16),(32616,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32616,34.84,NULL,92.8,8811,NULL,NULL,NULL,'FGC 0442',NULL,'2000BSAO...50....5K',2000,1,0.9,NULL,'G',0.000012,NULL,'17.42',0.11,'Sdm',NULL,NULL,NULL,NULL,1,55.145,3.53694,0.465,NULL,64985437694,1015397463,15865585,17.42),(32617,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32617,35.06,NULL,103,8811,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0442',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32618,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32618,35.06,NULL,103,8811,NULL,NULL,'Dipole','FGC 0442',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32619,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32619,35.06,NULL,103,8811,NULL,NULL,'Dipole + Quadrupole','FGC 0442',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32620,'Tully est','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32620,31.25,0.8,17.8,8812,75,NULL,NULL,'IC 1986',NULL,'1988NBGC.C....0000T',1988,1,2.5,NULL,'G',0.000007,NULL,'14.84',1.8,'Irr',NULL,NULL,NULL,NULL,1,55.1464583,-45.35581,0,NULL,37756137369,589939646,9217806,14.84),(32621,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32621,36.43,0.68,193,8813,70,NULL,NULL,'2MASX J03403676-3049150',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'17.04',0.27,NULL,NULL,NULL,NULL,NULL,1,55.153167,-30.82078,0,NULL,38586326348,602911349,9420489,17.04),(32622,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 14490','RN',32622,40.41,0.12,1070,8814,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 14490',0.130904,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32623,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 14490','RN',32623,40.82,0.23,1290,8814,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 14490',0.130904,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32624,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32624,31.11,0.09,16.7,8815,NULL,NULL,'TOM(g) = -7.2 mag','NGC 1419',NULL,'2010ApJ...717..603V',2010,1,1.1,'1998A&AS..133..325G has V = 2133 +- 2 km/sec.','G',0.000067,NULL,'13.5B',1.1,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,55.1754583,-37.51083,0,NULL,38557604137,602462564,9413477,13.5),(32625,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32625,31.47,0.09,19.7,8815,NULL,NULL,'TOM(z) = -8.53 mag','NGC 1419',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32626,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32626,30.49,0.13,12.5,8815,NULL,NULL,'KS','NGC 1419',NULL,'2002ApJ...564..216L',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32627,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32627,31.42,0.24,19.2,8815,NULL,NULL,'I','NGC 1419',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32628,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32628,31.42,0.24,19.2,8815,NULL,NULL,NULL,'NGC 1419',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32629,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32629,31.49,0.24,19.9,8815,NULL,NULL,'Malmquist cor.','NGC 1419',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32630,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32630,31.8,0.08,22.9,8815,NULL,NULL,'HST ACS FCS','NGC 1419',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32631,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32631,31.82,0.12,23.1,8815,74.4,NULL,NULL,'NGC 1419',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32632,'GC radius','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32632,31.44,0.16,19.4,8815,NULL,NULL,'HST ACS FCS','NGC 1419',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32633,'D-Sigma','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32633,31.26,0.4,17.8,8815,75,NULL,'Edat, raw','NGC 1419',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32634,'D-Sigma','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32634,31.29,0.4,18.1,8815,75,NULL,'Edat, cor','NGC 1419',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32635,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32635,31.82,0.12,23.1,8815,74.4,NULL,NULL,'NGC 1419',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32636,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32636,32.64,0.41,33.6,8815,NULL,NULL,'Malmquist cor.','NGC 1419',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32637,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32637,32.97,0.41,39.3,8815,NULL,NULL,NULL,'NGC 1419',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32638,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2007ln',NULL,32638,39.66,0.08,855,8816,70,NULL,'Hubble residual -0.13 for z0.24030','SDSS J034043.48+010016.4',NULL,'2011ApJ...740...92G',2011,1,0.05,'2007CBET.1102A...1B give z=0.09.','G',0.0006,NULL,'22.6g',0.04,NULL,NULL,NULL,NULL,NULL,1,55.1812083,1.00456,0.273,NULL,64982330645,1015348916,15864826,22.6),(32639,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 18486','R',32639,40.35,0.2,947,8816,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ln','SDSS J034043.48+010016.4',0.2403,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32640,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 18486','R',32640,40.57,0.1,1050,8816,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ln','SDSS J034043.48+010016.4',0.2403,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32641,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32641,35.03,0.69,102,8817,100,NULL,'mid-IR','IC 1977',NULL,'2013ApJ...771...88L',2013,1,1.4,NULL,'G',0.000017,NULL,'14.29',0.8,'SBb',NULL,NULL,NULL,NULL,1,55.188,17.74117,0.529,NULL,68020909449,1062826710,16606667,14.29),(32642,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32642,35.53,0.47,128,8817,NULL,NULL,'H','IC 1977',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32643,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32643,35.53,0.45,128,8817,NULL,NULL,'K','IC 1977',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32644,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32644,35.65,0.46,135,8817,NULL,NULL,'J','IC 1977',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32645,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32645,35.66,0.4,135,8817,NULL,NULL,'mean','IC 1977',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32646,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',32646,37.7,0.46,347,8818,70,NULL,NULL,'SDSS J034047.59-063434.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000071,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,55.1982917,-6.57636,0.121,NULL,37019175070,578424610,9037884,18.5),(32647,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 08723',NULL,32647,41.2,0.34,1740,8819,70,NULL,'SN photometric redshift distance, z photo =0.537 +/- 0.136','SDSS-II SN 08723',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','22.2g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,55.1982917,0.28133,0.193,NULL,64978900414,1015295318,15863989,22.2),(32648,'GRB','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32648,47.64,0.54,6230,8820,69.7,NULL,'Calibrated','GRB 060223A',4.41,'2009MNRAS.400..775C',2009,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,55.2065,-17.13011,0.249,NULL,38011445013,593928828,9280137,NULL),(32649,'GRB','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',32649,47.74,0.58,6530,8820,72,NULL,NULL,'GRB 060223A',4.41,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32650,'GRB','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',32650,47.87,0.66,6930,8820,NULL,NULL,NULL,'GRB 060223A',4.41,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32651,'GRB','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32651,47.93,0.61,7130,8820,70,NULL,NULL,'GRB 060223A',4.41,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32652,'GRB','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32652,47.94,0.57,7160,8820,69.7,NULL,'Fiducial','GRB 060223A',4.41,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32653,'GRB','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32653,50.09,1.25,19300,8820,69.7,NULL,'Fiducial','GRB 060223A',4.41,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32654,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32654,31.76,0.35,22.5,8821,NULL,NULL,NULL,'FCC 252',NULL,'2006AJ....132.1384D',2006,1,0.98,NULL,'G',0.000117,NULL,'16.2B',0.65,'dE0,N','Group member',NULL,NULL,NULL,1,55.2100833333,-35.74822,0,NULL,38568179341,602627802,9416059,16.2),(32655,'Tully est','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32655,31.24,0.8,17.7,8822,75,NULL,'B','NGC 1415',NULL,'1988NBGC.C....0000T',1988,1,3.5,NULL,'G',0.000023,NULL,'12.77',1.8,'(R)SAB(s)0/a   HII','in a pair',NULL,NULL,NULL,1,55.236917,-22.56447,0.013,NULL,38039881946,594373155,9287080,12.77),(32656,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32656,31.87,0.2,23.7,8822,74.4,NULL,NULL,'NGC 1415',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32657,'IRAS','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32657,31.79,0.8,22.9,8823,75,NULL,'MAT, I','NGC 1414',NULL,'1997ApJS..109..333W',1997,1,1.73,NULL,'G',0.000017,NULL,'14.64',0.32,'SB(s)bc? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,55.237667,-21.71314,0.037,NULL,38039585521,594368523,9287008,14.64),(32658,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32658,31.06,0.32,16.3,8823,85,NULL,'I, inv','NGC 1414',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32659,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32659,31.1,0.32,16.6,8823,85,NULL,'I, raw','NGC 1414',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32660,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32660,31.42,0.08,19.3,8823,NULL,NULL,NULL,'NGC 1414',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32661,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32661,31.48,0.43,19.7,8823,75,NULL,'MAT, I, inv','NGC 1414',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32662,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32662,31.58,0.43,20.7,8823,75,NULL,'MAT, I, raw','NGC 1414',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32663,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32663,31.76,0.43,22.5,8823,75,NULL,'MAT, I, cor','NGC 1414',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32664,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',32664,32.28,0.49,28.6,8823,75,NULL,'IR','NGC 1414',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32665,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32665,35.93,NULL,153,8824,NULL,NULL,'Dipole','FGC 0443',NULL,'2010Ap&SS.325..163P',2010,1,1.4,NULL,'G',0.000023,NULL,'16.2',0.16,'Scd',NULL,NULL,NULL,NULL,1,55.2556666667,13.57197,0.829,NULL,65116011875,1017437685,15897463,16.2),(32666,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32666,35.93,NULL,153,8824,NULL,NULL,'Dipole + Quadrupole','FGC 0443',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32667,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32667,35.94,NULL,154,8824,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0443',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32668,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32668,35.99,NULL,158,8824,NULL,NULL,NULL,'FGC 0443',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32669,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32669,36.46,0.53,196,8824,NULL,NULL,'Malmquist cor.','FGC 0443',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32670,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32670,36.85,0.45,234,8824,NULL,NULL,NULL,'FGC 0443',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32671,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32671,36.89,0.2,239,8824,74.4,NULL,NULL,'FGC 0443',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32672,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 15768',NULL,32672,40.62,0.51,1330,8825,70,NULL,'SN photometric redshift distance, z photo =0.378 +/- 0.135','SDSS-II SN 15768',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'*',NULL,'PHOT','23.0g',NULL,'Point Src [SDSS]',NULL,NULL,NULL,NULL,1,55.2613333333,0.35014,0.237,NULL,64978903703,1015295370,15863990,23),(32673,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32673,30.94,0.11,15.4,8826,NULL,NULL,'TOM(g) = -7.2 mag','ESO 358- G 050',NULL,'2010ApJ...717..603V',2010,1,1.7,NULL,'G',0.000077,NULL,'13.9B',0.7,'SA0^0^?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,55.2650417,-33.77931,0,NULL,38567630931,602619233,9415925,13.9),(32674,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32674,31.24,0.11,17.7,8826,NULL,NULL,'TOM(z) = -8.53 mag','ESO 358- G 050',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32675,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32675,31.48,0.14,19.8,8826,74.4,NULL,NULL,'ESO 358- G 050',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32676,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32676,31.5,0.07,20,8826,NULL,NULL,'HST ACS FCS','ESO 358- G 050',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32677,'GC radius','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32677,31.61,0.17,21,8826,NULL,NULL,'HST ACS FCS','ESO 358- G 050',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32678,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32678,30.54,0.45,12.8,8826,NULL,NULL,'K','ESO 358- G 050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32679,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32679,31.3,0.4,18.2,8826,NULL,NULL,'mean','ESO 358- G 050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32680,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32680,34.9,0.45,95.5,8827,NULL,NULL,'K','NGC 1409',NULL,'2007A&A...465...71T',2007,1,1,'The UZC has V = 7403 +- 60 km/sec.','G',0.000133,NULL,'14.4b',0.8,'SAB: pec       Sy2','Pair member (points to parent)',NULL,NULL,NULL,1,55.2934583,-1.30256,0.249,NULL,36812788453,575199819,8987497,14.4),(32681,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32681,35.17,0.4,108,8827,NULL,NULL,'mean','NGC 1409',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32682,'IRAS','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32682,34,0.8,63.1,8828,75,NULL,'MAT, I','ESO 031- G 020',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000028,NULL,'14.83',0.8,'(R\')SB(r)bc pec',NULL,NULL,NULL,NULL,1,55.296167,-77.13631,0.353,NULL,35646674537,556979289,8702801,14.83),(32683,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32683,33.6,0.32,52.6,8828,85,NULL,'I, raw','ESO 031- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32684,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32684,33.63,0.32,53.2,8828,85,NULL,'I, inv','ESO 031- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32685,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32685,33.89,0.43,60,8828,75,NULL,'MAT, I, raw','ESO 031- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32686,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32686,34.05,0.43,64.5,8828,75,NULL,'MAT, I, inv','ESO 031- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32687,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32687,34.09,0.43,65.9,8828,75,NULL,'MAT, I, cor','ESO 031- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32688,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 04541','RN',32688,43.36,0.26,3180,8829,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04541',0.478954,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32689,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32689,34.95,0.2,97.7,8830,74.4,NULL,NULL,'UGC 02820',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',NULL,NULL,'16.5',0.8,'SB?',NULL,NULL,NULL,NULL,1,55.303625,5.63172,0.633,NULL,65204766975,1018824483,15919132,16.5),(32690,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 09902','RN',32690,41.43,0.19,1430,8831,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 09902',0.352817,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32691,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 09902','RN',32691,41.53,0.28,1500,8831,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 09902',0.352817,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32692,'IRAS','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32692,32.06,0.8,25.8,8832,75,NULL,'MAT, I','ESO 482- G 035',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'13.67',1.3,'SB(rs)ab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,55.3117917,-23.83694,0.021,NULL,37992783050,593637235,9275581,13.67),(32693,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32693,31.62,0.09,21.1,8832,NULL,NULL,NULL,'ESO 482- G 035',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32694,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32694,32.05,0.43,25.8,8832,75,NULL,'3.6 micron, color + selection bias corrected','ESO 482- G 035',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32695,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32695,32.06,0.43,25.9,8832,75,NULL,'3.6 micron, color corrected','ESO 482- G 035',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32696,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32696,32.08,0.2,26.1,8832,74.4,NULL,NULL,'ESO 482- G 035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32697,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32697,32.18,0.32,27.3,8832,85,NULL,'I, raw','ESO 482- G 035',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32698,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32698,32.19,0.32,27.4,8832,85,NULL,'I, inv','ESO 482- G 035',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32699,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32699,32.35,0.43,29.5,8832,75,NULL,'MAT, I, raw','ESO 482- G 035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32700,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32700,32.36,0.43,29.7,8832,75,NULL,'MAT, I, cor','ESO 482- G 035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32701,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32701,32.43,0.43,30.6,8832,75,NULL,'MAT, I, inv','ESO 482- G 035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32702,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 02636','RN',32702,41.45,0.13,1520,8833,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02636',0.277086,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32703,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 02636','RN',32703,41.73,0.2,1730,8833,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02636',0.277086,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32704,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32704,36.03,0.47,161,8834,NULL,NULL,'H','UGC 02825',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00003,NULL,'15.4b',0.4,'Sc',NULL,NULL,NULL,NULL,1,55.347375,-1.61658,0.249,NULL,36811651371,575182052,8987219,15.4),(32705,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32705,36.04,0.4,162,8834,NULL,NULL,'mean','UGC 02825',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32706,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32706,36.2,0.45,174,8834,NULL,NULL,'K','UGC 02825',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32707,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 15722','RN',32707,39.26,0.19,603,8835,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15722',0.1825,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32708,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 15722','RN',32708,39.47,0.09,662,8835,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15722',0.1825,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32709,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',32709,36.41,0.46,192,8836,70,NULL,NULL,'2MASX J03412545-0723006',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00008,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,55.3559583,-7.38342,0.129,NULL,37019769584,578433899,9038029,16.6),(32710,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',32710,35.48,0.49,125,8837,75,NULL,'IR','FGC 060A',NULL,'2011yCatp016004901K',2011,1,1.01,NULL,'G',0.000031,NULL,'11.2K',0.16,NULL,NULL,NULL,NULL,NULL,1,55.359375,13.57236,0.845,NULL,65115938432,1017436538,15897445,11.2),(32711,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32711,35.7,0.37,138,8837,NULL,NULL,'Malmquist cor.','FGC 060A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32712,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32712,36,0.32,159,8837,NULL,NULL,NULL,'FGC 060A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32713,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32713,36.04,0.2,161,8837,74.4,NULL,NULL,'FGC 060A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32714,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 14777','RN',32714,39.69,0.15,787,8838,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14777',0.099399,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32715,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 14777','RN',32715,40.1,0.22,954,8838,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 14777',0.099399,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32716,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',32716,37.85,0.46,371,8839,70,NULL,NULL,'SDSS J034128.51-072443.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000063,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,55.368833,-7.41206,0.129,NULL,37019768155,578433877,9038029,18.4),(32717,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32717,34.18,0.41,68.4,8840,NULL,NULL,NULL,'IC 0344',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.00002,NULL,'14.92',0.4,'SB',NULL,NULL,NULL,NULL,1,55.3730416667,-4.66586,0.137,NULL,36998482483,578101288,9032832,14.92),(32718,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32718,34.22,0.2,69.8,8840,74.4,NULL,NULL,'IC 0344',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32719,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32719,34.35,0.37,74,8840,NULL,NULL,'Malmquist cor.','IC 0344',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32720,'IRAS','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32720,31.74,0.8,22.3,8841,75,NULL,'MAT, I','NGC 1422',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000027,NULL,'14.47',0.5,'SBab pec sp','in a pair',NULL,NULL,NULL,1,55.3794583,-21.68153,0.037,NULL,38039260103,594363439,9286928,14.47),(32721,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32721,30.16,0.43,10.7,8841,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1422',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32722,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32722,30.27,0.32,11.3,8841,85,NULL,'I, inv','NGC 1422',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32723,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32723,30.32,0.32,11.6,8841,85,NULL,'I, raw','NGC 1422',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32724,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32724,30.42,0.43,12.2,8841,75,NULL,'3.6 micron, color corrected','NGC 1422',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32725,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32725,30.61,0.2,13.2,8841,74.4,NULL,NULL,'NGC 1422',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32726,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32726,30.69,0.43,13.8,8841,75,NULL,'MAT, I, inv','NGC 1422',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32727,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32727,30.8,0.43,14.4,8841,75,NULL,'MAT, I, raw','NGC 1422',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32728,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32728,31.14,0.43,16.9,8841,75,NULL,'MAT, I, cor','NGC 1422',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32729,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32729,31.97,0.47,24.8,8841,NULL,NULL,'H','NGC 1422',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32730,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32730,31.98,0.4,24.9,8841,NULL,NULL,'mean','NGC 1422',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32731,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32731,32.18,0.46,27.3,8841,NULL,NULL,'J','NGC 1422',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32732,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32732,32.19,0.45,27.4,8841,NULL,NULL,'K','NGC 1422',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32733,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32733,30.56,0.2,12.9,8842,74.4,NULL,NULL,'ESO 358- G 051',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.00002,NULL,'14.04',0.7,'S0/a:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,55.385833,-34.88833,0,NULL,38570794313,602668661,9416697,14.04),(32734,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32734,30.98,0.11,15.7,8842,NULL,NULL,NULL,'ESO 358- G 051',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32735,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',32735,34.97,0.49,98.6,8843,75,NULL,'IR','UGC 02823',NULL,'2011yCatp016004901K',2011,1,1.46,NULL,'G',0.000026,NULL,'16.0',0.18,'Sb',NULL,NULL,NULL,NULL,1,55.39875,16.02042,0.729,NULL,68030437926,1062975592,16608993,16),(32736,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32736,35.27,0.39,113,8843,NULL,NULL,'Malmquist cor.','UGC 02823',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32737,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32737,35.32,0.38,116,8843,NULL,NULL,NULL,'UGC 02823',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32738,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32738,35.4,0.47,120,8843,NULL,NULL,'H','UGC 02823',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32739,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32739,35.47,0.2,124,8843,74.4,NULL,NULL,'UGC 02823',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32740,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32740,35.5,0.45,126,8843,NULL,NULL,'K','UGC 02823',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32741,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32741,35.55,0.4,129,8843,NULL,NULL,'mean','UGC 02823',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32742,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32742,35.65,0.46,135,8843,NULL,NULL,'J','UGC 02823',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32743,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32743,35.85,NULL,148,8843,NULL,NULL,'Dipole + Quadrupole','UGC 02823',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32744,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32744,35.86,NULL,148,8843,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02823',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32745,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32745,35.86,NULL,149,8843,NULL,NULL,'Dipole','UGC 02823',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32746,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32746,36.03,NULL,161,8843,NULL,NULL,NULL,'UGC 02823',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32747,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32747,31.46,0.33,19.6,8844,NULL,NULL,NULL,'FCC 266',NULL,'2006AJ....132.1384D',2006,1,0.74,NULL,'G',0.000097,NULL,'15.9',0.5,'dE0,N','Group member',NULL,NULL,NULL,1,55.4222083333,-35.17036,0,NULL,38570648626,602666384,9416662,15.9),(32748,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 14567',NULL,32748,39.75,0.43,891,8845,70,NULL,'SN photometric redshift distance, z photo =0.235 +/- 0.061','SDSS-II SN 14567',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.1g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,55.4315417,-0.34519,0.189,NULL,36809674461,575151163,8986736,21.1),(32749,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32749,36.99,0.62,250,8846,70,NULL,NULL,'SARS 054.92138-28.28349',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'16.31',0.5,'S0',NULL,NULL,NULL,NULL,1,55.4392083,-28.12431,0,NULL,38581996224,602843691,9419432,16.31),(32750,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2006kf',NULL,32750,34.07,0.2,63.8,8847,74.2,NULL,'SALT 2','UGC 02829',0.021301,'2010ApJ...716..712A',2010,1,1,NULL,'G',0.00014,NULL,'14.88',0.3,'S0',NULL,NULL,NULL,NULL,1,55.461917,8.15983,0.721,NULL,65187765339,1018558833,15914981,14.88),(32751,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2006kf',NULL,32751,34.63,0.14,80.9,8847,72,NULL,NULL,'UGC 02829',0.02081,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32752,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2006kf',NULL,32752,34.68,0.09,86.3,8847,74.4,NULL,NULL,'UGC 02829',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32753,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2006kf',NULL,32753,34.74,0.06,86.9,8847,72,NULL,'MLCS31','UGC 02829',0.021301,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32754,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2006kf',NULL,32754,34.81,0.09,91.8,8847,72,NULL,'M(H) = -18.317 mag','UGC 02829',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32755,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2006kf',NULL,32755,34.86,0.18,91.8,8847,70,NULL,'SALT 2','UGC 02829',0.021301,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32756,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2006kf',NULL,32756,34.92,0.22,94.3,8847,73.8,NULL,'SALT 2 (SNANA)','UGC 02829',0.021,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32757,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2006kf',NULL,32757,34.94,0.24,95.3,8847,73.8,NULL,'SALT 2 (SNANA)','UGC 02829',0.021,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32758,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2006kf',NULL,32758,34.96,0.19,96.1,8847,65,NULL,'MLCS31','UGC 02829',0.021301,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32759,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2006kf',NULL,32759,34.96,0.2,96.2,8847,65,NULL,'MLCS17','UGC 02829',0.021301,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32760,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2006kf',NULL,32760,35,0.19,98,8847,65,NULL,'SALT','UGC 02829',0.021301,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32761,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2006kf',NULL,32761,35.03,0.22,99.2,8847,65,NULL,'SALT2','UGC 02829',0.021301,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32762,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32762,36.64,0.82,212,8848,70,NULL,NULL,'2MASX J03415168-0522128',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.000092,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,55.465375,-5.37028,0.121,NULL,36998855569,578107118,9032923,16.6),(32763,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',32763,36.66,0.46,215,8848,70,NULL,NULL,'2MASX J03415168-0522128',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32764,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 02319','R',32764,39.37,0.19,644,8849,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02319',0.1597,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,55.4655416667,0.34575,0.237,NULL,64978764770,1015293199,15863956,NULL),(32765,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 02319','R',32765,39.56,0.09,704,8849,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 02319',0.1597,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32766,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 05311',NULL,32766,40.04,0.56,1020,8850,70,NULL,'SN photometric redshift distance, z photo =0.274 +/- 0.099','SDSS-II SN 05311',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','20.0g',0.07,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,55.4785417,-0.97658,0.257,NULL,36812740388,575199068,8987485,20),(32767,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 08290',NULL,32767,40.31,0.18,1150,8851,70,NULL,'SN photometric redshift distance, z photo =0.318 +/- 0.034','SDSS-II SN 08290',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.2g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,55.4852083,1.16783,0.373,NULL,64982029208,1015344206,15864753,21.2),(32768,'IRAS','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32768,33.57,0.8,51.7,8852,75,NULL,'MAT, I','NGC 1417',NULL,'1997ApJS..109..333W',1997,1,2.7,NULL,'G',0.000025,NULL,'12.68',1.7,'SAB(rs)b','in a pair',NULL,NULL,NULL,1,55.48925,-4.70486,0.141,NULL,37001369301,578146395,9033537,12.68),(32769,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32769,33.41,0.32,48,8852,85,NULL,'I, raw','NGC 1417',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32770,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32770,33.44,0.43,48.7,8852,75,NULL,'MAT, I, raw','NGC 1417',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32771,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32771,33.44,0.47,48.7,8852,NULL,NULL,'H','NGC 1417',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32772,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32772,33.48,0.32,49.6,8852,85,NULL,'I, inv','NGC 1417',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32773,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32773,33.48,0.46,49.7,8852,NULL,NULL,'J','NGC 1417',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32774,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32774,33.5,0.45,50.1,8852,NULL,NULL,'K','NGC 1417',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32775,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32775,33.6,0.39,52.4,8852,NULL,NULL,'Malmquist cor.','NGC 1417',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32776,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32776,33.66,0.2,54,8852,74.4,NULL,NULL,'NGC 1417',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32777,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32777,33.71,0.37,55.2,8852,NULL,NULL,NULL,'NGC 1417',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32778,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32778,33.71,0.43,55.3,8852,75,NULL,'MAT, I, cor','NGC 1417',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32779,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32779,33.74,0.43,55.9,8852,75,NULL,'MAT, I, inv','NGC 1417',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32780,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32780,33.84,0.4,58.7,8852,NULL,NULL,'mean','NGC 1417',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32781,'LSB galaxies','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32781,31.28,NULL,18,8853,NULL,NULL,NULL,'FCC 269',NULL,'1991ApJ...376..404B',1991,1,0.56,NULL,'G',NULL,NULL,'18.3',NULL,'dE0','Group member',NULL,NULL,NULL,1,55.4892083,-35.29206,0,NULL,38569944450,602655382,9416490,18.3),(32782,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2005gp',NULL,32782,37.99,0.12,351,8854,74.2,NULL,'SALT 2','APMUKS(BJ) B033926.36-005631.5',0.13,'2010ApJ...716..712A',2010,1,0.14,NULL,'G',NULL,NULL,'20.03',0.12,NULL,NULL,NULL,NULL,NULL,1,55.497,-0.78311,0.189,NULL,36809880711,575154386,8986787,20.03),(32783,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2005gp',NULL,32783,38.64,0.12,474,8854,70,NULL,'SALT 2','APMUKS(BJ) B033926.36-005631.5',0.13,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32784,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 02992','R',32784,38.67,0.19,479,8854,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005gp','APMUKS(BJ) B033926.36-005631.5',0.13,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32785,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2005gp',NULL,32785,38.67,NULL,480,8854,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 02992, SN 2005gp','APMUKS(BJ) B033926.36-005631.5',0.13,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32786,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2005gp',NULL,32786,38.69,0.1,484,8854,65,NULL,'SALT2','APMUKS(BJ) B033926.36-005631.5',0.13,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32787,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2005gp',NULL,32787,38.82,0.11,514,8854,65,NULL,'MLCS2k2','APMUKS(BJ) B033926.36-005631.5',0.13,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32788,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 02992','R',32788,38.88,0.1,529,8854,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005gp','APMUKS(BJ) B033926.36-005631.5',0.13,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32789,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2005gp',NULL,32789,39.8,0.05,807,8854,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 02992, SN 2005gp','APMUKS(BJ) B033926.36-005631.5',0.13,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32790,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32790,35.98,0.49,157,8855,70,NULL,NULL,'2MASX J03420104-1717317',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.00015,NULL,'16.02',0.44,NULL,NULL,NULL,NULL,NULL,1,55.504125,-17.29211,0.233,NULL,38012040883,593938138,9280283,16.02),(32791,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',32791,35.38,0.46,119,8856,70,NULL,NULL,'2MASX J03420132-0611518',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000091,NULL,'15.9g',0.36,'HII',NULL,NULL,NULL,NULL,1,55.505625,-6.19767,0.117,NULL,37027470049,578554219,9039909,15.9),(32792,'Ring Diameter','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32792,30,0.76,9.9,8857,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 1433',NULL,'1981ApJS...45..541P',1981,1,6.5,NULL,'G',0.000003,NULL,'10.70',5.9,'(R\'_1)SB(rs)ab Sy2','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,55.5064583,-47.22208,0,NULL,37772729828,590198903,9221857,10.7),(32793,'Ring Diameter','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32793,30,0.6,9.9,8857,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 1433',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32794,'Tully est','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32794,30.31,0.8,11.6,8857,75,NULL,'B','NGC 1433',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32795,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32795,29.6,0.36,8.32,8857,NULL,NULL,NULL,'NGC 1433',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32796,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 20920',NULL,32796,41.37,0.12,1880,8858,70,NULL,'SN photometric redshift distance, z photo =0.600 +/- 0.051','SDSS-II SN 20920',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,55.510583,-1.18422,0.249,NULL,36812870310,575201098,8987517,NULL),(32797,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32797,35.97,0.48,156,8859,70,NULL,NULL,'2MASX J03420335-1731157',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000083,NULL,'15.35',0.57,'S0','Group member',NULL,NULL,NULL,1,55.513833,-17.52108,0.213,NULL,38011542598,593930353,9280161,15.35),(32798,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32798,36.96,0.63,246,8860,70,NULL,NULL,'2MASX J03420365-5647319',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'16.79',0.35,NULL,NULL,NULL,NULL,NULL,1,55.515167,-56.79214,0.009,NULL,35829906955,559842296,8747535,16.79),(32799,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32799,35.25,0.39,112,8861,NULL,NULL,'Malmquist cor.','UGC 02830',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.16',0.7,'S0:',NULL,NULL,NULL,NULL,1,55.516333,15.98847,0.729,NULL,68030433697,1062975526,16608992,15.16),(32800,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32800,35.29,0.38,115,8861,NULL,NULL,NULL,'UGC 02830',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32801,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32801,35.34,0.2,117,8861,74.4,NULL,NULL,'UGC 02830',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32802,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 17235','RN',32802,40.45,0.23,995,8862,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 17235',0.233755,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32803,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 17235','RN',32803,40.47,0.28,1010,8862,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 17235',0.233755,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32804,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',32804,35.64,0.33,134,8863,70,NULL,NULL,'2MASX J03420891-0114485',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00015,NULL,'16.74',0.39,NULL,NULL,NULL,NULL,NULL,1,55.537083,-1.24675,0.249,NULL,36812880296,575201254,8987519,16.74),(32805,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',32805,38.25,0.46,447,8864,70,NULL,NULL,'SDSS J034209.33-070148.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000069,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,55.538917,-7.03008,0.133,NULL,37019832657,578434885,9038045,18.3),(32806,'IRAS','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32806,33.63,0.8,53.2,8865,75,NULL,'MAT, I','ESO 419- G 003',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00001,NULL,'13.2B',1,'(R\')SAB(rs)c   HII',NULL,NULL,NULL,NULL,1,55.5465417,-27.86419,0,NULL,38582154543,602846164,9419471,13.2),(32807,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32807,32.96,0.69,39,8865,100,NULL,'mid-IR','ESO 419- G 003',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32808,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32808,33.11,0.32,41.8,8865,85,NULL,'I, raw','ESO 419- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32809,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32809,33.13,0.32,42.3,8865,85,NULL,'I, inv','ESO 419- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32810,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32810,33.19,0.43,43.5,8865,75,NULL,'MAT, I, raw','ESO 419- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32811,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32811,33.32,0.43,46.1,8865,75,NULL,'MAT, I, inv','ESO 419- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32812,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32812,33.37,0.2,47.2,8865,74.4,NULL,NULL,'ESO 419- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32813,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32813,33.58,0.43,52,8865,75,NULL,'MAT, I, cor','ESO 419- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32814,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32814,33.65,0.43,53.6,8865,NULL,NULL,NULL,'ESO 419- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32815,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32815,33.67,0.42,54.3,8865,NULL,NULL,'Malmquist cor.','ESO 419- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32816,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32816,33.85,0.4,58.8,8865,NULL,NULL,'mean','ESO 419- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32817,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32817,34.11,0.47,66.4,8865,NULL,NULL,'H','ESO 419- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32818,'Cepheids','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',32818,31.08,0.22,16.4,8866,73,NULL,'Cepheids magnitudes Gaussian, Data 2','NGC 1425',NULL,'2009RoAJ...19...35A',2009,1,5.8,'This may also be IC 1988.','G',0.00001,NULL,'11.87',2.6,'SA(rs)b        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,55.5477917,-29.89333,0,NULL,38586939497,602920929,9420639,11.87),(32819,'Cepheids','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',32819,31.09,0.15,16.5,8866,73,NULL,'Cepheids magnitudes Gaussian, Data 1','NGC 1425',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32820,'Cepheids','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',32820,31.09,0.07,16.5,8866,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian, Data 1','NGC 1425',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32821,'Cepheids','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',32821,31.09,0.14,16.5,8866,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian, Data 2','NGC 1425',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32822,'Cepheids','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',32822,31.11,0.1,16.7,8866,73,NULL,'Cepheids periods Gaussian, Data 2','NGC 1425',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32823,'Cepheids','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',32823,31.12,0.05,16.7,8866,73,NULL,'Cepheids periods Gaussian, Data 1','NGC 1425',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32824,'Cepheids','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32824,31.6,0.08,20.9,8866,NULL,NULL,'LMC W01','NGC 1425',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32825,'Cepheids','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32825,31.6,0.05,20.9,8866,NULL,NULL,'20, VI, KEY PROJECT','NGC 1425',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32826,'Cepheids','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32826,31.66,0.05,21.5,8866,NULL,NULL,'MW HIPP','NGC 1425',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32827,'Cepheids','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32827,31.68,0.09,21.7,8866,74.4,NULL,NULL,'NGC 1425',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32828,'Cepheids','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32828,31.68,0.17,21.7,8866,NULL,NULL,'MW P02','NGC 1425',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32829,'Cepheids','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32829,31.7,0.06,21.9,8866,NULL,NULL,'99, VI','NGC 1425',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32830,'Cepheids','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32830,31.7,0.05,21.9,8866,NULL,NULL,'20, VI, +Z, KEY PROJECT','NGC 1425',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32831,'Cepheids','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32831,31.7,0.06,21.9,8866,NULL,NULL,'MW GFG','NGC 1425',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32832,'Cepheids','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32832,31.73,0.16,22.2,8866,NULL,NULL,'29, VI(W)','NGC 1425',NULL,'2000ApJ...528..655M',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32833,'Cepheids','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32833,31.81,0.06,23,8866,NULL,NULL,'HST KP Calibrated','NGC 1425',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32834,'Cepheids','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32834,31.93,0.06,24.3,8866,NULL,NULL,'Z, Key Project','NGC 1425',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32835,'Cepheids','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',32835,31.96,NULL,24.7,8866,NULL,18.54,NULL,'NGC 1425',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32836,'Cepheids','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32836,31.96,0.11,24.7,8866,NULL,18.54,'LMC ZP','NGC 1425',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32837,'Cepheids','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32837,32.24,NULL,28.1,8866,NULL,NULL,'29, VI','NGC 1425',NULL,'2006A&A...452..423P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32838,'IRAS','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32838,31.6,0.8,20.9,8866,75,NULL,'MAT, I','NGC 1425',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32839,'IRAS','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32839,31.6,0.8,20.9,8866,75,NULL,'A82, H','NGC 1425',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32840,'Sosies','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32840,31.51,0.05,20,8866,NULL,NULL,NULL,'NGC 1425',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32841,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32841,31.2,0.4,17.4,8866,75,NULL,'B','NGC 1425',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32842,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32842,31.26,0.4,17.9,8866,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 3 galaxy group','NGC 1425',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32843,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32843,31.34,0.32,18.5,8866,85,NULL,'I, raw','NGC 1425',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32844,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32844,31.37,0.07,18.8,8866,NULL,NULL,NULL,'NGC 1425',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32845,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32845,31.38,0.32,18.9,8866,85,NULL,'I, inv','NGC 1425',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32846,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32846,31.39,0.43,19,8866,75,NULL,'MAT, I, raw','NGC 1425',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32847,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32847,31.43,0.35,19.3,8866,NULL,NULL,NULL,'NGC 1425',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32848,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32848,31.48,0.47,19.8,8866,75,NULL,'A82, H, raw','NGC 1425',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32849,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32849,31.57,0.39,20.6,8866,73,NULL,'opt','NGC 1425',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32850,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32850,31.58,0.12,20.7,8866,NULL,NULL,'B','NGC 1425',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32851,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32851,31.59,0.43,20.8,8866,75,NULL,'MAT, I, cor','NGC 1425',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32852,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32852,31.61,0.47,21,8866,75,NULL,'A82, H, inv','NGC 1425',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32853,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',32853,31.61,NULL,21,8866,NULL,NULL,'I','NGC 1425',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32854,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',32854,31.61,NULL,21,8866,NULL,NULL,'B','NGC 1425',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32855,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32855,31.61,0.43,21,8866,75,NULL,'MAT, I, inv','NGC 1425',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32856,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32856,31.68,0.09,21.7,8866,74.4,NULL,NULL,'NGC 1425',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32857,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32857,31.68,0.4,21.7,8866,NULL,NULL,'mean','NGC 1425',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32858,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32858,31.68,0.47,21.7,8866,75,NULL,'A82, H, cor','NGC 1425',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32859,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',32859,31.69,NULL,21.8,8866,NULL,NULL,'LEDA [April 2006]','NGC 1425',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32860,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',32860,31.7,0.05,21.9,8866,75,NULL,NULL,'NGC 1425',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32861,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32861,31.71,0.01,22,8866,NULL,NULL,'I','NGC 1425',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32862,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32862,31.79,0.43,22.8,8866,75,NULL,'3.6 micron, color corrected','NGC 1425',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32863,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32863,31.84,0.46,23.4,8866,NULL,NULL,'J','NGC 1425',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32864,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32864,31.91,0.47,24.1,8866,NULL,NULL,'H','NGC 1425',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32865,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32865,31.95,0.43,24.5,8866,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1425',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32866,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32866,31.98,0.45,24.9,8866,NULL,NULL,'K','NGC 1425',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32867,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32867,34.23,0.6,70,8867,NULL,NULL,NULL,'UGC 02832',NULL,'2009ApJS..182..474S',2009,1,0.96,'The 2MASS position applies to the east end of the galaxy.','G',0.000048,NULL,'15.9g',0.23,'SB?c: sp',NULL,NULL,NULL,NULL,1,55.552,-0.35431,0.189,NULL,36810161103,575158767,8986855,15.9),(32868,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',32868,34.23,0.49,70.3,8867,75,NULL,'IR','UGC 02832',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32869,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32869,34.27,0.2,71.5,8867,74.4,NULL,NULL,'UGC 02832',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32870,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32870,34.44,0.54,77.1,8867,NULL,NULL,'Malmquist cor.','UGC 02832',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32871,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2006kx',NULL,32871,38.77,0.06,567,8868,70,NULL,'Hubble residual -0.23 for z0.16004','SDSS J034214.66+002842.0',NULL,'2011ApJ...740...92G',2011,1,0.09,NULL,'G',0.00014,NULL,'19.6g',0.08,NULL,NULL,NULL,NULL,NULL,1,55.561083,0.47836,0.237,NULL,64979182657,1015299729,15864058,19.6),(32872,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 15425','R',32872,39.19,0.19,593,8868,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006kx','SDSS J034214.66+002842.0',0.16004,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32873,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2006kx',NULL,32873,39.07,0.08,652,8868,70,NULL,'SALT 2','SDSS J034214.66+002842.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32874,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2006kx',NULL,32874,39.08,0.08,655,8868,70,NULL,'SALT 2, Malmquist cor.','SDSS J034214.66+002842.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32875,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 15425','R',32875,39.41,0.07,657,8868,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006kx','SDSS J034214.66+002842.0',0.16004,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32876,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32876,33.21,0.5,43.8,8869,NULL,NULL,NULL,'NGC 1418',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.00002,NULL,'14.21',0.9,'SB(s)b:','in a pair',NULL,NULL,NULL,1,55.567333,-4.73075,0.141,NULL,37001426903,578147295,9033551,14.21),(32877,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32877,33.25,0.2,44.7,8869,74.4,NULL,NULL,'NGC 1418',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32878,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32878,33.45,0.45,48.9,8869,NULL,NULL,'Malmquist cor.','NGC 1418',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32879,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32879,33.91,0.4,60.6,8869,NULL,NULL,'mean','NGC 1418',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32880,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32880,34.7,0.47,87.3,8869,NULL,NULL,'H','NGC 1418',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32881,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32881,34.72,0.46,87.8,8869,NULL,NULL,'J','NGC 1418',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32882,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32882,34.74,0.45,88.8,8869,NULL,NULL,'K','NGC 1418',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32883,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 16038','RN',32883,42.06,0.34,1820,8870,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16038',0.419782,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32884,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 16038','RN',32884,42.39,0.4,2110,8870,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16038',0.419782,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32885,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 16038','N',32885,41.96,0.32,2470,8870,70,NULL,'SALT 2','SDSS-II SN 16038',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32886,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 16038','N',32886,42.04,0.32,2560,8870,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16038',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32887,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32887,31.22,0.16,17.5,8871,NULL,NULL,NULL,'FCC 274',NULL,'2006AJ....132.1384D',2006,1,0.61,NULL,'G',0.000254,NULL,'16.8B',0.58,'dE0,N','Group member',NULL,NULL,NULL,1,55.572083,-35.54083,0,NULL,38569989289,602656082,9416501,16.8),(32888,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32888,32.18,0.33,27.3,8871,NULL,NULL,NULL,'FCC 274',NULL,'2006A&A...458.1013M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32889,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2007rk',NULL,32889,39.4,0.21,758,8872,70,NULL,'Hubble residual 0.00 for z0.19590','SDSS J034217.36+010344.0',NULL,'2011ApJ...740...92G',2011,1,0.17,NULL,'G',0.0005,NULL,'20.6g',0.04,NULL,NULL,NULL,NULL,NULL,1,55.572333,1.06222,0.401,NULL,64981989013,1015343578,15864743,20.6),(32890,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 20821','R',32890,40.05,0.29,854,8872,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007rk','SDSS J034217.36+010344.0',0.1959,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32891,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 20821','R',32891,40.18,0.2,910,8872,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007rk','SDSS J034217.36+010344.0',0.1959,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32892,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32892,30.75,0.13,14.1,8873,NULL,NULL,'TOM(I) = -8.53 mag, t5 function, Harris et al. 1991','NGC 1427',NULL,'1996A&A...309L..39K',1996,1,3.6,NULL,'G',0.00001,NULL,'11.8B',2.5,'E5','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,55.580917,-35.39256,0,NULL,38569973368,602655833,9416497,11.8),(32893,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32893,30.95,0.13,15.5,8873,NULL,NULL,'TOM(I) = -8.73 mag, t5 function, Sandage & Tammann (1995)','NGC 1427',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32894,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32894,31.03,0.19,16.1,8873,NULL,NULL,'TOM(V) = -7.4 mag, t5 function, Harris et al. 1991','NGC 1427',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32895,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32895,31.04,0.14,16.1,8873,NULL,NULL,'TOM(I) = -8.73 mag, Gaussian, Sandage & Tammann (1995)','NGC 1427',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32896,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32896,31.08,0.21,16.4,8873,NULL,NULL,'TOM(V) = -7.4 mag, Gaussian, Harris et al. 1991, Z corr. -0.10 mag','NGC 1427',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32897,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32897,31.13,0.21,16.8,8873,NULL,NULL,'TOM(I) = -8.53 mag, Gaussian, Harris et al. 1991, Z corr. -0.05 mag','NGC 1427',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32898,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32898,31.18,0.21,17.2,8873,NULL,NULL,'TOM(V) = -7.4 mag, Gaussian, Harris et al. 1991','NGC 1427',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32899,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32899,31.18,0.21,17.2,8873,NULL,NULL,'TOM(I) = -8.53 mag, Gaussian, Harris et al. 1991','NGC 1427',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32900,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32900,31.23,0.07,17.6,8873,NULL,NULL,'TOM(g) = -7.2 mag','NGC 1427',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32901,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32901,31.31,0.19,18.3,8873,NULL,NULL,'TOM(V) = -7.68 mag, t5 function, Sandage & Tammann (1995)','NGC 1427',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32902,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32902,31.46,0.21,19.6,8873,NULL,NULL,'TOM(V) = -7.68 mag, Gaussian, Sandage & Tammann (1995)','NGC 1427',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32903,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32903,31.49,0.08,19.9,8873,NULL,NULL,'TOM(z) = -8.53 mag','NGC 1427',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32904,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32904,31.64,0.18,21.3,8873,NULL,NULL,NULL,'NGC 1427',NULL,'2001AJ....121.2950K',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32905,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32905,31.3,0.06,18.2,8873,NULL,NULL,'KS','NGC 1427',NULL,'2002ApJ...564..216L',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32906,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32906,31.43,0.07,19.4,8873,NULL,NULL,'I','NGC 1427',NULL,'2010ApJ...724..657B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32907,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32907,31.45,0.27,19.5,8873,NULL,NULL,'K','NGC 1427',NULL,'2001A&A...376..793M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32908,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32908,31.45,0.27,19.5,8873,NULL,NULL,'K, MK = -6.14 mag','NGC 1427',NULL,'2001A&A...376..793M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32909,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32909,31.45,0.12,19.5,8873,74.4,NULL,NULL,'NGC 1427',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32910,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32910,31.46,0.07,19.6,8873,NULL,NULL,'HST ACS FCS','NGC 1427',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32911,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32911,31.7,0.24,21.9,8873,NULL,NULL,'I','NGC 1427',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32912,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32912,31.86,0.24,23.6,8873,NULL,NULL,'I','NGC 1427',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32913,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32913,31.86,0.24,23.6,8873,NULL,NULL,NULL,'NGC 1427',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32914,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32914,31.88,0.24,23.7,8873,NULL,NULL,'Malmquist cor.','NGC 1427',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32915,'GC radius','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32915,31.88,0.1,23.8,8873,NULL,NULL,'HST ACS FCS','NGC 1427',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32916,'D-Sigma','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32916,31.26,0.4,17.8,8873,75,NULL,'Edat, raw','NGC 1427',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32917,'D-Sigma','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32917,31.29,0.4,18.1,8873,75,NULL,'Edat, cor','NGC 1427',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32918,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32918,30.24,0.65,11.2,8873,95,NULL,'Weighted Mean','NGC 1427',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32919,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32919,31.28,0.81,18,8873,55,NULL,'Visvanathan & Sandage 1979','NGC 1427',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32920,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32920,31.45,0.12,19.5,8873,74.4,NULL,NULL,'NGC 1427',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32921,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32921,31.7,0.41,21.9,8873,NULL,NULL,NULL,'NGC 1427',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32922,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32922,31.77,0.41,22.6,8873,NULL,NULL,'Malmquist cor.','NGC 1427',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32923,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32923,32,NULL,25.1,8873,NULL,NULL,NULL,'NGC 1427',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32924,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32924,32.06,0.63,25.8,8873,70,NULL,NULL,'NGC 1427',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32925,'Tertiary','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32925,31.11,0.41,16.7,8873,95,NULL,NULL,'NGC 1427',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32926,'Tully est','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32926,31.14,0.8,16.9,8873,75,NULL,'B','NGC 1427',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32927,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32927,31.44,0.16,19.4,8874,NULL,NULL,'TOM(g) = -7.2 mag','NGC 1428',NULL,'2010ApJ...717..603V',2010,1,1.6,'ESO-LV gives v= 228+/-146 km/sec.','G',0.000027,NULL,'13.90',0.8,'SAB0- pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,55.5947083,-35.154,0,NULL,38570754098,602668032,9416688,13.9),(32928,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32928,31.81,0.16,23,8874,NULL,NULL,'TOM(z) = -8.53 mag','NGC 1428',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32929,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32929,31.56,0.14,20.5,8874,74.4,NULL,NULL,'NGC 1428',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32930,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32930,31.58,0.08,20.7,8874,NULL,NULL,'HST ACS FCS','NGC 1428',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32931,'GC radius','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32931,31.52,0.24,20.2,8874,75,NULL,'HST ACS FCS','NGC 1428',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32932,'Tully est','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32932,31.14,0.8,16.9,8874,75,NULL,NULL,'NGC 1428',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32933,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2007kk',NULL,32933,36.26,0.19,171,8875,73.8,NULL,'SALT 2 (SNANA)','UGC 02828',0.0406,'2014ApJ...795...44R',2014,1,1.3,NULL,'G',0.000103,NULL,'14.5',1,'SB(rs)bc',NULL,NULL,NULL,NULL,1,55.6001666667,39.24453,0.993,NULL,68686104810,1073220387,16769068,14.5),(32934,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',32934,36.9,0.46,240,8876,70,NULL,NULL,'2MASX J03422414-0606309',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000066,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,55.600625,-6.10861,0.105,NULL,37027451042,578553922,9039905,17.4),(32935,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32935,31.34,0.14,18.5,8877,NULL,NULL,NULL,'LSBG F358-079',NULL,'2006AJ....132.1384D',2006,1,2,NULL,'G',NULL,NULL,'16.8B',1.8,'E0:','Group member',NULL,NULL,NULL,1,55.609833,-36.68669,0,NULL,38557424474,602459757,9413433,16.8),(32936,'IRAS','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32936,32.17,0.8,27.2,8878,75,NULL,'MAT, I','NGC 1421',NULL,'1997ApJS..109..333W',1997,1,3.5,NULL,'G',0.000017,NULL,'11.95',0.9,'SAB(rs)bc:     HII',NULL,NULL,NULL,NULL,1,55.622,-13.48803,0.101,NULL,36880380364,576255943,9003999,11.95),(32937,'IRAS','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32937,32.21,0.8,27.6,8878,75,NULL,'A82, H','NGC 1421',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32938,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',32938,31.27,0.4,18,8878,75,NULL,NULL,'NGC 1421',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32939,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32939,31.28,0.4,18,8878,73,NULL,'IR','NGC 1421',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32940,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32940,31.51,0.43,20,8878,75,NULL,'3.6 micron, color corrected','NGC 1421',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32941,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32941,31.52,0.43,20.1,8878,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1421',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32942,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32942,31.54,0.2,20.3,8878,74.4,NULL,NULL,'NGC 1421',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32943,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32943,31.67,0.32,21.6,8878,85,NULL,'I, raw','NGC 1421',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32944,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32944,31.72,0.32,22.1,8878,85,NULL,'I, inv','NGC 1421',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32945,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',32945,31.78,0.49,22.7,8878,75,NULL,'IR','NGC 1421',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32946,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32946,31.79,0.43,22.8,8878,75,NULL,'MAT, I, raw','NGC 1421',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32947,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32947,31.95,0.43,24.6,8878,75,NULL,'MAT, I, cor','NGC 1421',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32948,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32948,32,0.43,25.1,8878,75,NULL,'MAT, I, inv','NGC 1421',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32949,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32949,32.03,0.47,25.5,8878,75,NULL,'A82, H, raw','NGC 1421',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32950,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32950,32.03,0.4,25.5,8878,75,NULL,'B','NGC 1421',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32951,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32951,32.09,0.46,26.2,8878,NULL,NULL,'J','NGC 1421',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32952,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32952,32.14,0.47,26.8,8878,75,NULL,'A82, H, inv','NGC 1421',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32953,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32953,32.18,0.47,27.3,8878,75,NULL,'A82, H, cor','NGC 1421',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32954,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32954,32.19,0.47,27.5,8878,NULL,NULL,'H','NGC 1421',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32955,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32955,32.25,0.45,28.2,8878,NULL,NULL,'K','NGC 1421',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32956,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32956,32.29,0.4,28.7,8878,NULL,NULL,'mean','NGC 1421',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32957,'Tully est','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32957,31.8,0.8,22.9,8879,75,NULL,NULL,'UGC 02813',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.000023,NULL,'16.5',0.9,'Im:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,55.6408333333,71.30806,1.365,NULL,66402475158,1037538674,16211541,16.5),(32958,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32958,31.04,0.4,16.1,8879,NULL,NULL,NULL,'UGC 02813',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32959,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32959,31.03,0.39,16.1,8879,73,NULL,'opt','UGC 02813',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32960,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 14594','RN',32960,40.41,0.23,1070,8880,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 14594',0.126853,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32961,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 14594','RN',32961,40.52,0.29,1130,8880,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 14594',0.126853,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32962,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32962,35.94,0.53,154,8881,70,NULL,NULL,'2MASX J03423630-2455336',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'17.26',0.21,NULL,NULL,NULL,NULL,NULL,1,55.651333,-24.92592,0,NULL,38525282761,601957543,9405586,17.26),(32963,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32963,34.19,0.51,68.7,8882,70,NULL,NULL,'NGC 1423',NULL,'2014MNRAS.445.2677S',2014,1,0.86,'MCG RA is +0.6 minutes in error.','G',0.00003,NULL,'14.3g',0.67,'SBbc',NULL,NULL,NULL,NULL,1,55.667083,-6.38183,0.125,NULL,37027494423,578554600,9039915,14.3),(32964,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32964,34.78,0.47,90.3,8882,NULL,NULL,'H','NGC 1423',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32965,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32965,34.78,0.4,90.5,8882,NULL,NULL,'mean','NGC 1423',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32966,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32966,34.82,0.45,92,8882,NULL,NULL,'K','NGC 1423',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32967,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32967,34.92,0.46,96.2,8882,NULL,NULL,'J','NGC 1423',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32968,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 15221','RN',32968,40.52,0.18,1100,8883,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 15221',0.151803,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32969,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 15221','RN',32969,40.85,0.25,1290,8883,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 15221',0.151803,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32970,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32970,33.04,0.43,40.6,8884,75,NULL,'3.6 micron, color + selection bias corrected','ESO 548- G 082',NULL,'2014MNRAS.444..527S',2014,1,2,NULL,'G',0.000037,NULL,'15.37',1,'Sd',NULL,NULL,NULL,NULL,1,55.680333,-17.50722,0.213,NULL,38012008870,593937638,9280275,15.37),(32971,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 14568',NULL,32971,41.59,NULL,2080,8885,70,NULL,'SN photometric redshift distance, z photo =0.699 +/- 0.001','SDSS-II SN 14568',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,55.6862083333,-0.23847,0.209,NULL,36810169888,575158904,8986857,NULL),(32972,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32972,36.11,0.71,167,8886,70,NULL,NULL,'2MASX J03424801-1754561',NULL,'2014MNRAS.445.2677S',2014,1,0.28,NULL,'G',0.00015,NULL,'16.38',0.2,NULL,NULL,NULL,NULL,NULL,1,55.6999166667,-17.91556,0.177,NULL,38011272131,593926127,9280095,16.38),(32973,'Cepheids','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32973,31.44,0.32,19.4,8887,NULL,NULL,'HST KP Calibrated, K\'','NGC 1426',NULL,'2000ApJ...529..745F',2000,1,2.6,NULL,'G',0.00002,NULL,'13.11',1.7,'E4','Isolated elliptical galaxy',NULL,NULL,NULL,1,55.704625,-22.10836,0.021,NULL,38039370953,594365171,9286955,13.11),(32974,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32974,31.93,0.12,24.3,8887,NULL,NULL,'TOM(g) = -7.2 mag','NGC 1426',NULL,'2012MNRAS.422.3591C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32975,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32975,32.17,0.14,27.2,8887,NULL,NULL,'TOM(z) = -8.4 mag','NGC 1426',NULL,'2012MNRAS.422.3591C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32976,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32976,31.02,0.18,16,8887,NULL,NULL,'I','NGC 1426',NULL,'1991ApJ...373L...1T',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32977,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32977,31.28,0.3,18.1,8887,NULL,NULL,'K','NGC 1426',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32978,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32978,31.75,0.18,22.4,8887,NULL,NULL,'I','NGC 1426',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32979,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32979,31.8,0.08,22.9,8887,NULL,NULL,'I','NGC 1426',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32980,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32980,31.82,0.12,23.1,8887,74.4,NULL,NULL,'NGC 1426',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32981,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32981,31.89,0.16,23.9,8887,NULL,NULL,'HST KP Calibrated, I','NGC 1426',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32982,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32982,31.91,0.18,24.1,8887,NULL,NULL,'I','NGC 1426',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32983,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32983,31.91,0.18,24.1,8887,NULL,NULL,NULL,'NGC 1426',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32984,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32984,31.93,0.18,24.4,8887,NULL,NULL,'Malmquist cor.','NGC 1426',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32985,'D-Sigma','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32985,31.93,0.4,24.3,8887,75,NULL,'Edat, raw','NGC 1426',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32986,'D-Sigma','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32986,32.02,0.4,25.4,8887,75,NULL,'Edat, cor','NGC 1426',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32987,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32987,31.29,0.81,18.1,8887,55,NULL,'Visvanathan & Sandage 1979','NGC 1426',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32988,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32988,31.36,0.27,18.7,8887,95,NULL,'Weighted Mean','NGC 1426',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32989,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32989,31.48,0.4,19.8,8887,95,NULL,'de Vaucouleurs','NGC 1426',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32990,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32990,31.62,0.63,21.1,8887,95,NULL,'Michard 1979b, c','NGC 1426',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32991,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32991,32.27,0.46,28.4,8887,95,NULL,'Michard 1979a','NGC 1426',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32992,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32992,31.82,0.12,23.1,8887,74.4,NULL,NULL,'NGC 1426',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32993,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32993,32,0.41,25.2,8887,NULL,NULL,NULL,'NGC 1426',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32994,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32994,32.03,0.41,25.5,8887,NULL,NULL,'Malmquist cor.','NGC 1426',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32995,'Tertiary','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32995,30.78,0.21,14.3,8887,95,NULL,NULL,'NGC 1426',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32996,'Tully est','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32996,31.13,0.8,16.8,8887,75,NULL,'B','NGC 1426',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32997,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32997,31.79,0.4,22.8,8887,NULL,NULL,'mean','NGC 1426',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32998,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32998,32.11,0.45,26.4,8887,NULL,NULL,'K','NGC 1426',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(32999,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,32999,35.5,0.39,126,8888,NULL,NULL,'Malmquist cor.','UGC 02833',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000067,NULL,'16.5',0.3,'Scd?',NULL,NULL,NULL,NULL,1,55.7145417,15.9985,0.797,NULL,68021270298,1062832348,16606755,16.5),(33000,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33000,35.52,0.2,127,8888,74.4,NULL,NULL,'UGC 02833',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33001,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33001,35.6,0.38,132,8888,NULL,NULL,NULL,'UGC 02833',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33002,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 14727',NULL,33002,40.1,0.28,1050,8889,70,NULL,'SN photometric redshift distance, z photo =0.283 +/- 0.048','SDSS-II SN 14727',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,55.715667,-0.06283,0.217,NULL,36809332453,575145819,8986653,NULL),(33003,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 19399',NULL,33003,40.03,0.17,1010,8890,70,NULL,'SN photometric redshift distance, z photo =0.273 +/- 0.027','SDSS-II SN 19399',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,55.718917,0.83189,0.341,NULL,64978503599,1015289118,15863892,NULL),(33004,'Magnitude','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33004,36.28,0.13,180,8891,100,NULL,NULL,'ESO 156- G 008 NED01',NULL,'1998A&A...337...31R',1998,1,0.58,NULL,'G',0.00018,NULL,'13.5V',0.55,'E0 pec;BrClG',NULL,NULL,NULL,NULL,1,55.72075,-53.63131,0,NULL,37720190135,589377970,9209030,13.5),(33005,'Magnitude','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33005,36.28,0.13,180,8892,100,NULL,NULL,'ABELL 3158',NULL,'1998A&A...337...31R',1998,1,NULL,'Katgert (1996,A&A,310,8) identifies multiple redshift systems in this cluster.','GClstr',NULL,NULL,NULL,NULL,'I-II   [BM];R  [A]','Group member, cD galaxy',NULL,NULL,NULL,1,55.724583,-53.63528,0,NULL,37720190104,589377970,9209030,NULL),(33006,'IRAS','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33006,32.27,0.8,28.5,8893,75,NULL,'MAT, I','MCG -02-10-009',NULL,'1997ApJS..109..333W',1997,1,3.42,NULL,'G',0.000013,NULL,'14.0b',0.32,'Sc',NULL,NULL,NULL,NULL,1,55.7336666667,-12.91642,0.101,NULL,36879873795,576248028,9003875,14),(33007,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33007,32.29,0.14,28.8,8893,NULL,NULL,NULL,'MCG -02-10-009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33008,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33008,32.32,0.4,29.1,8893,NULL,NULL,'mean','MCG -02-10-009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33009,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33009,32.32,0.39,29.1,8893,73,NULL,'opt','MCG -02-10-009',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33010,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33010,32.33,0.4,29.2,8893,75,NULL,NULL,'MCG -02-10-009',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33011,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33011,32.33,0.39,29.2,8893,73,NULL,'IR','MCG -02-10-009',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33012,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33012,32.38,0.46,30,8893,NULL,NULL,'J','MCG -02-10-009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33013,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33013,32.4,0.47,30.2,8893,NULL,NULL,'H','MCG -02-10-009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33014,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33014,32.49,0.45,31.4,8893,NULL,NULL,'K','MCG -02-10-009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33015,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33015,32.53,0.49,32,8893,75,NULL,'IR','MCG -02-10-009',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33016,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33016,32.6,0.43,33.1,8893,75,NULL,'MAT, I, raw','MCG -02-10-009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33017,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33017,32.64,0.32,33.8,8893,85,NULL,'I, raw','MCG -02-10-009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33018,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33018,32.66,0.43,34,8893,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-10-009',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33019,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33019,32.69,0.32,34.5,8893,85,NULL,'I, inv','MCG -02-10-009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33020,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33020,32.77,0.43,35.9,8893,75,NULL,'3.6 micron, color corrected','MCG -02-10-009',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33021,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33021,32.79,0.43,36.1,8893,75,NULL,'MAT, I, inv','MCG -02-10-009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33022,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33022,32.8,0.43,36.3,8893,75,NULL,'MAT, I, cor','MCG -02-10-009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33023,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33023,32.81,0.2,36.5,8893,74.4,NULL,NULL,'MCG -02-10-009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33024,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33024,33.35,NULL,46.7,8893,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -02-10-009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33025,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33025,33.35,NULL,46.7,8893,NULL,NULL,'Dipole','MCG -02-10-009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33026,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33026,33.35,NULL,46.8,8893,NULL,NULL,'Dipole + Quadrupole','MCG -02-10-009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33027,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 1992bk',NULL,33027,36.35,0.17,176,8894,74.2,NULL,'SALT 2','ESO 156- G 008',0.0587,'2010ApJ...716..712A',2010,1,NULL,NULL,'GPair',0.000334,NULL,NULL,NULL,'(E0:pec)+(S0-pec)',NULL,NULL,NULL,NULL,1,55.735833,-53.63444,0,NULL,37720190160,589377971,9209030,NULL),(33028,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 1992bk',NULL,33028,36.74,0.24,210,8894,72,NULL,NULL,'ESO 156- G 008',0.0587,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33029,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 1992bk',NULL,33029,36.98,0.04,235,8894,72,NULL,NULL,'ESO 156- G 008',0.0587,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33030,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 1992bk',NULL,33030,36.91,0.08,241,8894,74.4,NULL,NULL,'ESO 156- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33031,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 1992bk',NULL,33031,37.18,0.17,244,8894,65,NULL,'MLCS2k2','ESO 156- G 008',0.0587,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33032,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 1992bk',NULL,33032,37,0.12,251,8894,70.8,NULL,NULL,'ESO 156- G 008',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33033,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 1992bk',NULL,33033,37.13,0.06,252,8894,70,NULL,'SALT','ESO 156- G 008',0.0587,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33034,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 1992bk',NULL,33034,37.13,0.19,252,8894,65,NULL,NULL,'ESO 156- G 008',0.0587,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33035,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 1992bk',NULL,33035,37.16,0.23,255,8894,65,NULL,'MLCS17','ESO 156- G 008',0.0587,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33036,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 1992bk',NULL,33036,37.18,0.19,257,8894,70,NULL,'SALT 2','ESO 156- G 008',0.0587,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33037,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 1992bk',NULL,33037,37.19,0.22,259,8894,65,NULL,'MLCS31','ESO 156- G 008',0.0587,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33038,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 1992bk',NULL,33038,37.37,0.28,281,8894,65,NULL,'SALT2','ESO 156- G 008',0.0587,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33039,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 1992bk',NULL,33039,37.32,0.14,291,8894,60,NULL,NULL,'ESO 156- G 008',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33040,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 1992bk',NULL,33040,37.41,0.06,303,8894,60,NULL,'M(I) = -19.19 mag','ESO 156- G 008',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33041,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 1992bk',NULL,33041,37.45,0.1,309,8894,60,NULL,'M(B) = -19.48 mag','ESO 156- G 008',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33042,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 1992bk',NULL,33042,37.48,0.07,313,8894,60,NULL,'M(V) = -19.47 mag','ESO 156- G 008',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33043,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 07980','RN',33043,36.61,0.05,180,8895,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 07980',0.169485,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33044,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 07980','RN',33044,39.69,0.19,742,8895,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07980',0.169485,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33045,'Tully est','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33045,31.14,0.8,16.9,8896,75,NULL,NULL,'NGC 1437A',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.00001,NULL,'14.1B',1.4,'SAB(s)dm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,55.759125,-36.27336,0,NULL,38557201200,602456268,9413379,14.1),(33046,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33046,36.38,0.6,189,8897,70,NULL,NULL,'2MASX J03430373-5516093',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00015,NULL,'16.61',0.41,'S0',NULL,NULL,NULL,NULL,1,55.7654583,-55.26933,0.013,NULL,35781076682,559079323,8735614,16.61),(33047,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 20386','RN',33047,40.72,0.24,1070,8898,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20386',0.307786,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33048,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 20386','RN',33048,40.9,0.16,1160,8898,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20386',0.307786,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33049,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 20386','N',33049,40.64,0.18,1340,8898,70,NULL,'SALT 2','SDSS-II SN 20386',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33050,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 20386','N',33050,40.67,0.18,1360,8898,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20386',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33051,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33051,32.04,0.37,25.6,8899,NULL,NULL,NULL,'LSBG F358-027',NULL,'2006A&A...458.1013M',2006,1,0.52,NULL,'G',0.000177,NULL,'18.0',0.26,'dE0','Group member',NULL,NULL,NULL,1,55.80625,-35.51872,0,NULL,38570016239,602656503,9416507,18),(33052,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33052,35.64,0.33,134,8900,70,NULL,NULL,'CGCG 391-030',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000094,NULL,'15.3g',0.56,'E0',NULL,NULL,NULL,NULL,1,55.8082083,-1.01872,0.229,NULL,36809998181,575156221,8986815,15.3),(33053,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33053,33.65,0.69,53.8,8901,100,NULL,'mid-IR','NGC 1424',NULL,'2013ApJ...771...88L',2013,1,1.7,NULL,'G',0.000023,NULL,'14.38',0.6,'SAB(rs)b:','in a pair',NULL,NULL,NULL,1,55.8085,-4.73008,0.141,NULL,37001588370,578149818,9033590,14.38),(33054,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33054,34.06,0.2,64.9,8901,74.4,NULL,NULL,'NGC 1424',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33055,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33055,34.12,0.44,66.6,8901,NULL,NULL,NULL,'NGC 1424',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33056,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33056,34.17,0.43,68.3,8901,NULL,NULL,'Malmquist cor.','NGC 1424',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33057,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33057,34.42,0.4,76.6,8901,NULL,NULL,'mean','NGC 1424',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33058,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33058,34.65,0.47,85,8901,NULL,NULL,'H','NGC 1424',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33059,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 08774','RN',33059,41.73,0.18,1700,8902,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 08774',0.306199,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33060,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 08774','RN',33060,42.01,0.23,1930,8902,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08774',0.306199,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33061,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33061,32.11,0.51,26.4,8903,NULL,NULL,'TOM(g) = -7.2 mag','ESO 358- G 056',NULL,'2010ApJ...717..603V',2010,1,1.2,NULL,'G',0.000097,NULL,'15.10',0.3,'S0^0^: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,55.8442917,-33.94031,0,NULL,38567325403,602614459,9415850,15.1),(33062,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33062,32.89,0.71,37.8,8903,NULL,NULL,'TOM(z) = -8.53 mag','ESO 358- G 056',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33063,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33063,31.66,0.14,21.5,8903,74.4,NULL,NULL,'ESO 358- G 056',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33064,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33064,31.68,0.08,21.7,8903,NULL,NULL,'HST ACS FCS','ESO 358- G 056',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33065,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 14128','RN',33065,43.12,0.24,2800,8904,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 14128',0.503539,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33066,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33066,32.22,0.43,27.8,8905,75,NULL,'3.6 micron, color + selection bias corrected','MCG -03-10-041',NULL,'2014MNRAS.444..527S',2014,1,2,NULL,'G',0.00001,NULL,'14.75',1.1,'SB(s)dm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,55.898,-16.01442,0.109,NULL,38009921997,593905031,9279766,14.75),(33067,'IRAS','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33067,31.45,0.8,19.5,8906,75,NULL,'MAT, I','NGC 1436',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000027,NULL,'12.41',2,'(R\'_2)SAB(s)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,55.9045,-35.85303,0,NULL,38569300854,602645325,9416333,12.41),(33068,'Tully est','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33068,31.14,0.8,16.9,8906,75,NULL,'B','NGC 1436',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33069,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33069,30.88,0.43,15,8906,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1436',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33070,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33070,31.01,0.43,15.9,8906,75,NULL,'3.6 micron, color corrected','NGC 1436',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33071,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33071,31.1,0.47,16.6,8906,NULL,NULL,'H','NGC 1436',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33072,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33072,31.13,0.46,16.8,8906,NULL,NULL,'J','NGC 1436',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33073,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33073,31.14,0.45,16.9,8906,NULL,NULL,'K','NGC 1436',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33074,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33074,31.16,0.2,17.1,8906,74.4,NULL,NULL,'NGC 1436',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33075,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33075,31.2,0.32,17.4,8906,85,NULL,'I, raw','NGC 1436',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33076,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33076,31.22,0.32,17.5,8906,85,NULL,'I, inv','NGC 1436',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33077,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33077,31.34,0.4,18.5,8906,NULL,NULL,'mean','NGC 1436',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33078,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33078,31.37,0.08,18.8,8906,NULL,NULL,NULL,'NGC 1436',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33079,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33079,31.39,0.43,18.9,8906,75,NULL,'MAT, I, raw','NGC 1436',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33080,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33080,31.51,0.43,20.1,8906,75,NULL,'MAT, I, inv','NGC 1436',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33081,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33081,31.57,0.43,20.6,8906,75,NULL,'MAT, I, cor','NGC 1436',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33082,'IRAS','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33082,34.48,0.8,78.8,8907,75,NULL,'W91PP, r','UGC 02838',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',NULL,NULL,'16.0',0.2,'Scd:',NULL,NULL,NULL,NULL,1,55.9356666667,24.06069,0.689,NULL,67986129472,1062283273,16598176,16),(33083,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33083,34.59,0.49,82.9,8907,75,NULL,'IR','UGC 02838',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33084,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33084,34.93,0.2,96.8,8907,74.4,NULL,NULL,'UGC 02838',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33085,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33085,35.05,0.38,102,8907,75,NULL,'W91PP, r, raw','UGC 02838',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33086,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33086,35.18,0.38,109,8907,75,NULL,'W91PP, r, inv','UGC 02838',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33087,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33087,35.25,0.38,112,8907,75,NULL,'W91PP, r, cor','UGC 02838',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33088,'IRAS','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33088,31.61,0.8,21,8908,75,NULL,'MAT, I','ESO 015- G 001',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000013,NULL,'14.51',0.9,'IB(s)m',NULL,NULL,NULL,NULL,1,55.93925,-80.10544,0.305,NULL,35679080537,557485633,8710713,14.51),(33089,'Tully est','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33089,31.4,0.8,19.1,8908,75,NULL,NULL,'ESO 015- G 001',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33090,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33090,30.85,0.32,14.8,8908,85,NULL,'I, inv','ESO 015- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33091,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33091,30.89,0.32,15.1,8908,85,NULL,'I, raw','ESO 015- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33092,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33092,31,0.2,15.9,8908,74.4,NULL,NULL,'ESO 015- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33093,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33093,31.14,0.43,16.9,8908,75,NULL,'3.6 micron, color corrected','ESO 015- G 001',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33094,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33094,31.17,0.43,17.2,8908,75,NULL,'3.6 micron, color + selection bias corrected','ESO 015- G 001',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33095,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33095,31.34,0.43,18.5,8908,75,NULL,'MAT, I, inv','ESO 015- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33096,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33096,31.46,0.43,19.6,8908,75,NULL,'MAT, I, raw','ESO 015- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33097,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33097,31.56,0.4,20.5,8908,NULL,NULL,NULL,'ESO 015- G 001',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33098,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33098,31.56,0.4,20.5,8908,73,NULL,'opt','ESO 015- G 001',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33099,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33099,31.62,0.43,21,8908,75,NULL,'MAT, I, cor','ESO 015- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33100,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33100,36.79,0.46,228,8909,70,NULL,NULL,'2MASX J03434567+0020539',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000073,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,55.9402083,0.34822,0.229,NULL,64978366290,1015286973,15863858,17.3),(33101,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33101,35.16,0.44,107,8910,NULL,NULL,'Malmquist cor.','UGC 02839',NULL,'2009ApJS..182..474S',2009,1,1.12,'Position in 1997ApJ...490..173Z is incorrect.','G',0.000011,NULL,'18.',0.19,'Sdm:',NULL,NULL,NULL,NULL,1,55.95925,14.29581,0.933,NULL,65115374344,1017427724,15897308,18),(33102,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33102,35.14,0.44,107,8910,NULL,NULL,NULL,'UGC 02839',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33103,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33103,35.18,0.2,109,8910,74.4,NULL,NULL,'UGC 02839',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33104,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33104,33.66,0.47,53.9,8911,NULL,NULL,'H','UGC 02837',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000037,NULL,'14.2',0.8,'SB(rs)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,55.977083,40.01567,1.189,NULL,68551756012,1071121187,16736268,14.2),(33105,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33105,33.81,0.45,57.9,8911,NULL,NULL,'K','UGC 02837',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33106,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33106,33.88,0.46,59.6,8911,NULL,NULL,'J','UGC 02837',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33107,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33107,34.08,0.4,65.4,8911,NULL,NULL,'mean','UGC 02837',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33108,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 10524',NULL,33108,37.64,3.34,337,8912,70,NULL,'SN photometric redshift distance, z photo =0.082 +/- 0.385','SDSS-II SN 10524',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.8g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,55.98275,0.5845,0.313,NULL,64978228161,1015284815,15863825,21.8),(33109,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33109,36.56,0.46,205,8913,70,NULL,NULL,'2MASX J03435751+0026165',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000105,NULL,'16.1g',0.3,'E0',NULL,NULL,NULL,NULL,1,55.9897083,0.43781,0.313,NULL,64978274597,1015285540,15863836,16.1),(33110,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33110,31.77,0.4,22.6,8914,75,NULL,NULL,'UGC 02827',NULL,'2008Ap.....51..336K',2008,1,1.1,NULL,'G',0.000037,NULL,'17.',0.9,'SB?',NULL,NULL,NULL,NULL,1,56.001667,69.32339,2.449,NULL,66392661989,1037385343,16209145,17),(33111,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33111,31.9,0.49,24,8914,75,NULL,'IR','UGC 02827',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33112,'IRAS','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33112,31.62,0.8,21.1,8915,75,NULL,'MAT, I','MCG -03-10-042',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000027,NULL,'13.54',0.7,'SAB(s)bc:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,56.0043333333,-14.35867,0.089,NULL,36878350505,576224226,9003503,13.54),(33113,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33113,31.7,0.11,21.9,8915,NULL,NULL,NULL,'MCG -03-10-042',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33114,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33114,31.95,0.4,24.6,8915,NULL,NULL,'mean','MCG -03-10-042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33115,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33115,32.16,0.32,27.1,8915,85,NULL,'I, raw','MCG -03-10-042',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33116,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33116,32.19,0.32,27.4,8915,85,NULL,'I, inv','MCG -03-10-042',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33117,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33117,32.33,0.43,29.3,8915,75,NULL,'3.6 micron, color corrected','MCG -03-10-042',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33118,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33118,32.33,0.43,29.3,8915,75,NULL,'3.6 micron, color + selection bias corrected','MCG -03-10-042',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33119,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33119,32.36,0.43,29.6,8915,75,NULL,'MAT, I, raw','MCG -03-10-042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33120,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33120,32.36,0.2,29.7,8915,74.4,NULL,NULL,'MCG -03-10-042',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33121,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33121,32.39,0.46,30,8915,NULL,NULL,'J','MCG -03-10-042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33122,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33122,32.43,0.47,30.6,8915,NULL,NULL,'H','MCG -03-10-042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33123,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33123,32.46,0.43,31,8915,75,NULL,'MAT, I, cor','MCG -03-10-042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33124,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33124,32.49,0.43,31.5,8915,75,NULL,'MAT, I, inv','MCG -03-10-042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33125,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33125,32.51,0.45,31.8,8915,NULL,NULL,'K','MCG -03-10-042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33126,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 14166','RN',33126,36.99,0.05,240,8916,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 14166',0.04105,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33127,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 14166','RN',33127,37.78,0.21,345,8916,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 14166',0.04105,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33128,'CMD','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'N',33128,22.6,NULL,0.33,8917,NULL,NULL,'DES J0344.3_4331','Eridanus II',NULL,'2015ApJ...807...50B',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33129,'CMD','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'N',33129,22.9,NULL,0.38,8917,NULL,NULL,NULL,'Eridanus II',NULL,'2015ApJ...805..130K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33130,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33130,36.3,0.46,182,8918,70,NULL,NULL,'2MASXi J0344277-004630',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000068,NULL,'17.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,56.1155417,-0.775,0.309,NULL,36994678870,578041857,9031904,17.6),(33131,'PNLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33131,31,NULL,15.8,8919,NULL,NULL,NULL,'NGC 1448',NULL,'2007ApJ...657...76F',2007,1,7.6,NULL,'G',0.000007,NULL,'11.40',1.7,'SAcd: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,56.133,-44.64483,0,NULL,37764908663,590076697,9219948,11.4),(33132,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2001el',NULL,33132,30.92,0.17,15.3,8919,70.8,NULL,NULL,'NGC 1448',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33133,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2001el',NULL,33133,31.01,0.34,15.9,8919,72,NULL,NULL,'NGC 1448',0.0039,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33134,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2001el',NULL,33134,31.04,0.14,16.1,8919,74,NULL,NULL,'NGC 1448',NULL,'2003AJ....125..166K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33135,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2001el',NULL,33135,31.1,0.03,16.5,8919,72,NULL,NULL,'NGC 1448',0.0039,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33136,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2001el',NULL,33136,31.18,0.19,17.2,8919,72,NULL,NULL,'NGC 1448',0.0039,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33137,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2001el',NULL,33137,31.18,0.09,17.2,8919,74.4,NULL,NULL,'NGC 1448',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33138,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2001el',NULL,33138,31.19,0.03,17.3,8919,72,NULL,'M(H) = -18.317 mag','NGC 1448',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33139,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2001el',NULL,33139,31.29,0.08,17.9,8919,74,NULL,NULL,'NGC 1448',NULL,'2003AJ....125..166K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33140,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2001el',NULL,33140,31.39,0.03,18.9,8919,72,NULL,NULL,'NGC 1448',0.0039,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33141,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2001el',NULL,33141,31.54,0.08,20.2,8919,65,NULL,'MLCS2k2','NGC 1448',0.0039,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33142,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2001el','R',33142,31.78,NULL,22.7,8919,62.3,NULL,NULL,'NGC 1448',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33143,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2001el',NULL,33143,31.87,0.14,23.7,8919,60,NULL,NULL,'NGC 1448',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33144,'SNII optical','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2003hn',NULL,33144,31.04,0.17,16.1,8919,NULL,NULL,'V, photospheric magnitude method','NGC 1448',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33145,'SNII optical','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2003hn',NULL,33145,31.11,0.53,16.7,8919,NULL,NULL,'SCM, I','NGC 1448',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33146,'SNII optical','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2003hn',NULL,33146,31.12,0.09,16.7,8919,NULL,NULL,'I, photospheric magnitude method','NGC 1448',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33147,'SNII optical','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2003hn',NULL,33147,31.13,0.27,16.8,8919,NULL,NULL,'SCM, BVI','NGC 1448',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33148,'SNII optical','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2003hn',NULL,33148,31.14,0.26,16.9,8919,NULL,NULL,'EPM E96','NGC 1448',NULL,'2009ApJ...696.1176J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33149,'SNII optical','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2003hn',NULL,33149,31.14,0.4,16.9,8919,NULL,NULL,'SCM, B','NGC 1448',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33150,'SNII optical','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2003hn',NULL,33150,31.15,0.54,17,8919,NULL,NULL,'SCM, V','NGC 1448',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33151,'SNII optical','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SN 2003hn',NULL,33151,32.1,0.54,26.3,8919,NULL,NULL,'EPM D05','NGC 1448',NULL,'2009ApJ...696.1176J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33152,'IRAS','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33152,31.04,0.8,16.1,8919,75,NULL,'MAT, I','NGC 1448',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33153,'IRAS','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33153,31.04,0.8,16.1,8919,75,NULL,'A82, H','NGC 1448',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33154,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33154,30.55,0.4,12.9,8919,75,NULL,'B','NGC 1448',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33155,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33155,30.81,0.4,14.5,8919,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 1448',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33156,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33156,30.84,0.4,14.7,8919,75,NULL,NULL,'NGC 1448',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33157,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33157,30.84,0.39,14.7,8919,73,NULL,'IR','NGC 1448',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33158,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33158,30.88,NULL,15,8919,NULL,NULL,'LEDA [April 2006]','NGC 1448',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33159,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33159,30.93,0.35,15.3,8919,NULL,NULL,NULL,'NGC 1448',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33160,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33160,31.07,0.47,16.4,8919,75,NULL,'A82, H, raw','NGC 1448',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33161,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33161,31.1,0.4,16.6,8919,75,NULL,'HOSTS SN 2001el','NGC 1448',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33162,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33162,31.1,0.43,16.6,8919,75,NULL,'MAT, I, raw','NGC 1448',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33163,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33163,31.14,0.4,16.9,8919,75,NULL,'HOSTS SN 2001el','NGC 1448',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33164,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33164,31.15,0.43,17,8919,75,NULL,'3.6 micron, color corrected','NGC 1448',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33165,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33165,31.18,0.42,17.2,8919,NULL,18.48,'3.6 micron','NGC 1448',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33166,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33166,31.18,0.43,17.2,8919,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1448',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33167,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33167,31.18,0.09,17.2,8919,74.4,NULL,NULL,'NGC 1448',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33168,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33168,31.2,0.47,17.4,8919,75,NULL,'A82, H, inv','NGC 1448',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33169,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33169,31.22,0.32,17.5,8919,85,NULL,'I, raw','NGC 1448',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33170,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33170,31.26,0.32,17.9,8919,85,NULL,'I, inv','NGC 1448',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33171,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33171,31.32,0.43,18.3,8919,75,NULL,'MAT, I, cor','NGC 1448',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33172,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33172,31.32,0.47,18.4,8919,75,NULL,'A82, H, cor','NGC 1448',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33173,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33173,31.34,0.43,18.5,8919,75,NULL,'MAT, I, inv','NGC 1448',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33174,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33174,31.37,0.13,18.8,8919,NULL,NULL,NULL,'NGC 1448',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33175,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33175,31.65,0.35,21.4,8919,NULL,NULL,'I','NGC 1448',NULL,'2003AJ....125..166K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33176,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33176,31.74,0.49,22.2,8919,75,NULL,'IR','NGC 1448',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33177,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33177,34.83,0.46,92.3,8920,70,NULL,NULL,'2MASX J03443356-0035460',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000069,NULL,'16.0g',0.38,'E0',NULL,NULL,NULL,NULL,1,56.139875,-0.59628,0.257,NULL,36993835942,578028686,9031698,16),(33178,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33178,37.83,0.46,368,8921,70,NULL,NULL,'2MASX J03444790-0012210',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000107,NULL,'17.3g',0.08,'BrClG',NULL,NULL,NULL,NULL,1,56.1995,-0.20581,0.233,NULL,36809249630,575144525,8986633,17.3),(33179,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 21356',NULL,33179,39.69,0.47,867,8922,70,NULL,'SN photometric redshift distance, z photo =0.228 +/- 0.065','SDSS-II SN 21356',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','22.4g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,56.202875,-1.13931,0.289,NULL,36994203661,578034432,9031788,22.4),(33180,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 17831','RN',33180,41.34,0.09,1670,8923,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 17831',0.109457,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33181,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 17831','RN',33181,41.4,0.19,1720,8923,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 17831',0.109457,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33182,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33182,31.86,0.08,23.6,8924,NULL,NULL,'TOM(g) = -7.2 mag','NGC 1439',NULL,'2012MNRAS.422.3591C',2012,1,2.5,NULL,'G',0.000033,NULL,'13.02',2.3,'E1','in a pair',NULL,NULL,NULL,1,56.208125,-21.92056,0.065,NULL,37994121256,593658144,9275908,13.02),(33183,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33183,31.91,0.1,24.1,8924,NULL,NULL,'TOM(z) = -8.4 mag','NGC 1439',NULL,'2012MNRAS.422.3591C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33184,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33184,31.15,0.19,17,8924,NULL,NULL,'I','NGC 1439',NULL,'1991ApJ...373L...1T',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33185,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33185,32.05,0.12,25.7,8924,74.4,NULL,NULL,'NGC 1439',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33186,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33186,32.13,0.15,26.7,8924,NULL,NULL,'I','NGC 1439',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33187,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33187,32.13,0.15,26.7,8924,NULL,NULL,NULL,'NGC 1439',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33188,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33188,32.13,0.15,26.7,8924,NULL,NULL,'Malmquist cor.','NGC 1439',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33189,'D-Sigma','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33189,31.93,0.4,24.3,8924,75,NULL,'Edat, raw','NGC 1439',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33190,'D-Sigma','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33190,32.02,0.4,25.4,8924,75,NULL,'Edat, cor','NGC 1439',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33191,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33191,31.31,0.41,18.3,8924,95,NULL,'Weighted Mean','NGC 1439',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33192,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33192,31.65,0.52,21.4,8924,95,NULL,'de Vaucouleurs','NGC 1439',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33193,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33193,31.93,0.81,24.3,8924,55,NULL,'Visvanathan & Sandage 1979','NGC 1439',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33194,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33194,32.05,0.12,25.7,8924,74.4,NULL,NULL,'NGC 1439',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33195,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33195,32.08,0.41,26,8924,NULL,NULL,NULL,'NGC 1439',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33196,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33196,32.07,0.41,26,8924,NULL,NULL,'Malmquist cor.','NGC 1439',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33197,'Tertiary','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33197,30.78,0.21,14.3,8924,95,NULL,NULL,'NGC 1439',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33198,'Tully est','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33198,31.47,0.8,19.7,8924,75,NULL,'B','NGC 1439',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33199,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33199,32.18,0.4,27.3,8924,NULL,NULL,'mean','NGC 1439',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33200,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33200,32.69,0.45,34.6,8924,NULL,NULL,'K','NGC 1439',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33201,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33201,34.33,0.38,73.5,8925,NULL,NULL,NULL,'IC 1997',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'13.94',0.6,'SAB(rs)c?',NULL,NULL,NULL,'H_alpha Emission-Line Galaxy',1,56.21625,-59.13767,0,NULL,35797617384,559337771,8739652,13.94),(33202,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33202,34.37,0.2,74.8,8925,74.4,NULL,NULL,'IC 1997',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33203,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33203,34.41,0.37,76.1,8925,NULL,NULL,'Malmquist cor.','IC 1997',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33204,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33204,34.01,0.49,63.4,8926,75,NULL,'IR','UGC 02852',NULL,'2011yCatp016004901K',2011,1,1.81,NULL,'G',0.000011,NULL,'16.0',0.13,'Sd',NULL,NULL,NULL,NULL,1,56.2327083,5.90519,0.589,NULL,65205225024,1018831641,15919244,16),(33205,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33205,34.72,NULL,87.8,8926,NULL,NULL,'Dipole + Quadrupole','UGC 02852',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33206,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33206,34.72,NULL,87.9,8926,NULL,NULL,'Dipole','UGC 02852',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33207,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33207,34.72,NULL,87.9,8926,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02852',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33208,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33208,34.73,NULL,88.2,8926,NULL,NULL,NULL,'UGC 02852',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33209,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33209,38.13,0.46,423,8927,70,NULL,NULL,'2MASX J03445663+0015425',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000087,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,56.2359583,0.26183,0.317,NULL,65196302169,1018692221,15917065,18.2),(33210,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33210,33.23,0.49,44.2,8928,75,NULL,'IR','FGC 0447',NULL,'2011yCatp016004901K',2011,1,1.57,NULL,'G',0.000047,NULL,'15.4b',0.21,'Sc',NULL,NULL,NULL,NULL,1,56.250875,-4.20456,0.153,NULL,37000782940,578137233,9033394,15.4),(33211,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33211,33.48,0.46,49.7,8928,NULL,NULL,NULL,'FGC 0447',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33212,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33212,33.52,0.2,50.6,8928,74.4,NULL,NULL,'FGC 0447',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33213,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33213,33.71,0.41,55.2,8928,NULL,NULL,'Malmquist cor.','FGC 0447',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33214,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33214,33.9,NULL,60.3,8928,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0447',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33215,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33215,33.91,NULL,60.6,8928,NULL,NULL,'Dipole','FGC 0447',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33216,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33216,33.92,NULL,60.8,8928,NULL,NULL,'Dipole + Quadrupole','FGC 0447',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33217,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33217,34.29,0.49,72,8929,75,NULL,'IR','FGC 0448',NULL,'2011yCatp016004901K',2011,1,1.15,NULL,'G',0.00005,NULL,'15.83',0.19,'Sdm',NULL,NULL,NULL,NULL,1,56.255125,-4.27675,0.153,NULL,37000789285,578137332,9033395,15.83),(33218,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33218,32.93,0.65,38.5,8930,95,NULL,'Weighted Mean','NGC 1440',NULL,'1984ApJS...56...91D',1984,1,2.1,NULL,'G',0.00009,NULL,'12.56',1.6,'(L)SB(rs)0^+','in a pair',NULL,NULL,NULL,1,56.262125,-18.26603,0.189,NULL,38012206039,593940719,9280323,12.56),(33219,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33219,34.6,0.81,83.2,8930,55,NULL,'Visvanathan & Sandage 1979','NGC 1440',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33220,'Tully est','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33220,31.3,0.8,18.2,8930,75,NULL,'B','NGC 1440',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33221,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33221,31.58,0.42,20.7,8931,NULL,NULL,'TOM(g) = -7.2 mag','ESO 358- G 059',NULL,'2010ApJ...717..603V',2010,1,1,NULL,'G',0.000057,NULL,'14.0B',0.8,'SAB0-','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,56.264833,-35.97261,0,NULL,38569264536,602644758,9416324,14),(33222,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33222,32.14,0.63,26.8,8931,NULL,NULL,'TOM(z) = -8.53 mag','ESO 358- G 059',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33223,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33223,31.06,0.12,16.3,8931,74.4,NULL,NULL,'ESO 358- G 059',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33224,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33224,31.47,0.08,19.7,8931,NULL,NULL,'HST ACS FCS','ESO 358- G 059',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33225,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33225,31.6,0.2,20.9,8931,NULL,NULL,'I','ESO 358- G 059',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33226,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33226,31.06,0.12,16.3,8931,74.4,NULL,NULL,'ESO 358- G 059',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33227,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33227,31.02,0.4,16,8931,NULL,NULL,'mean','ESO 358- G 059',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33228,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33228,31.29,0.45,18.1,8931,NULL,NULL,'K','ESO 358- G 059',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33229,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33229,38.56,0.46,516,8932,70,NULL,NULL,'2MASX J03450407-0730595',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000067,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,56.267125,-7.51664,0.157,NULL,37030996986,578609327,9040770,18.4),(33230,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33230,38.04,0.46,406,8933,70,NULL,NULL,'2MASX J03450819-0056493',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00012,NULL,'17.0g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,56.2841666667,-0.94708,0.373,NULL,36994739723,578042808,9031918,17),(33231,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 17907','RN',33231,39.79,0.23,760,8934,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17907',0.193909,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33232,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 17907','RN',33232,39.88,0.18,792,8934,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17907',0.193909,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33233,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33233,30.98,0.2,15.7,8935,74.4,NULL,NULL,'ESO 358- G 060',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.000003,NULL,'15.5B',0.4,'IB(s)m: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,56.3005833333,-35.57092,0,NULL,38569398291,602646848,9416357,15.5),(33234,'Brightest Stars','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33234,26.63,0.35,2.12,8936,NULL,NULL,NULL,'LEDA 166077',NULL,'2000ASPC..209..345D',2000,1,NULL,'Star complex in IC 0342.','*Ass',0.000004,NULL,NULL,NULL,'Irr',NULL,NULL,NULL,NULL,1,56.302417,67.86403,3.357,0,66543542386,1039742849,16245982,NULL),(33235,'TRGB','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33235,27.5,NULL,3.16,8936,NULL,NULL,NULL,'LEDA 166077',NULL,'2003A&A...408..111K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33236,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33236,30.68,0.2,13.7,8937,NULL,NULL,'TOM(g) = -7.2 mag','MCG -06-09-028',NULL,'2010ApJ...717..603V',2010,1,1.2,NULL,'G',0.00001,NULL,'15.5B',0.82,'dE1,N','Group member',NULL,NULL,NULL,1,56.3087083,-36.93675,0,NULL,38557328737,602458261,9413410,15.5),(33237,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33237,31.06,0.22,16.3,8937,NULL,NULL,'TOM(z) = -8.53 mag','MCG -06-09-028',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33238,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33238,31.45,0.14,19.5,8937,74.4,NULL,NULL,'MCG -06-09-028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33239,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33239,31.47,0.08,19.7,8937,NULL,NULL,'HST ACS FCS','MCG -06-09-028',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33240,'GC radius','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33240,31.14,0.38,16.9,8937,NULL,NULL,'HST ACS FCS','MCG -06-09-028',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33241,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 16894','R',33241,41.1,0.36,1290,8938,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006tb','SN 2006tb',0.29,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,56.3145417,-0.12856,0.233,NULL,36993775203,578027737,9031683,NULL),(33242,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 16894','R',33242,41.37,0.34,1460,8938,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006tb','SN 2006tb',0.29,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33243,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 18319','RN',33243,42.52,0.22,2130,8939,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 18319',0.498029,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33244,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33244,32.86,0.4,37.3,8940,75,NULL,'B','IC 0334',NULL,'1988NBGC.C....0000T',1988,1,2.5,NULL,'G',0.000023,NULL,'12.45',1.9,'S?',NULL,NULL,NULL,NULL,1,56.321167,76.63831,0.809,NULL,65707221941,1026675342,16041802,12.45),(33245,'IRAS','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33245,31.64,0.8,21.3,8941,75,NULL,'MAT, I','NGC 1438',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.00002,NULL,'13.08',0.9,'SB(r)0/a:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,56.3217917,-23.00247,0,NULL,37994487832,593663872,9275998,13.08),(33246,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33246,31.71,0.08,22,8941,NULL,NULL,NULL,'NGC 1438',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33247,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33247,32.46,0.32,31,8941,85,NULL,'I, raw','NGC 1438',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33248,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33248,32.49,0.2,31.5,8941,74.4,NULL,NULL,'NGC 1438',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33249,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33249,32.5,0.32,31.6,8941,85,NULL,'I, inv','NGC 1438',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33250,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33250,32.54,0.43,32.2,8941,75,NULL,'MAT, I, raw','NGC 1438',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33251,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33251,32.64,0.43,33.8,8941,75,NULL,'MAT, I, cor','NGC 1438',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33252,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33252,32.72,0.43,35,8941,75,NULL,'MAT, I, inv','NGC 1438',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33253,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 20759',NULL,33253,36.72,1.61,221,8942,70,NULL,'SN photometric redshift distance, z photo =0.053 +/- 0.062','SDSS-II SN 20759',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,56.33275,0.32942,0.321,NULL,65196314262,1018692410,15917068,NULL),(33254,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33254,36.29,0.56,181,8943,70,NULL,NULL,'2MASX J03452171-7438539',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'16.0b',0.34,NULL,NULL,NULL,NULL,NULL,1,56.340333,-74.64842,0.281,NULL,35532623413,555197240,8674956,16),(33255,'Ring Diameter','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33255,31.4,0.84,19,8944,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 1452',NULL,'1981ApJS...45..541P',1981,1,2.2,NULL,'G',0.000033,NULL,'12.76',1.5,'SB(r)a','in a pair',NULL,NULL,NULL,1,56.3429583,-18.63364,0.133,NULL,38046062909,594469732,9288589,12.76),(33256,'Tully est','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33256,31.79,0.8,22.8,8944,75,NULL,'B','NGC 1452',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33257,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33257,38.02,0.46,402,8945,70,NULL,NULL,'SDSS J034526.31+001927.7',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.00009,NULL,'19.1g',0.1,NULL,NULL,NULL,NULL,NULL,1,56.359625,0.32439,0.321,NULL,65196312859,1018692388,15917068,19.1),(33258,'CMD','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'N',33258,19.81,0.31,0.092,8946,NULL,NULL,'If object = GC, ID = DESJ0345_6026','Reticulum III',NULL,'2015ApJ...813..109D',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33259,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33259,35.54,0.46,128,8947,70,NULL,NULL,'MCG -01-10-028',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.000099,NULL,'14.7g',0.77,'E0',NULL,NULL,NULL,NULL,1,56.362583,-7.47756,0.157,NULL,37031038037,578609969,9040780,14.7),(33260,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 10991',NULL,33260,39.99,0.34,995,8948,70,NULL,'SN photometric redshift distance, z photo =0.267 +/- 0.054','SDSS-II SN 10991',NULL,'2011ApJ...738..162S',2011,1,0.11,NULL,'G',NULL,'PHOT','21.1g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,56.364333,-0.96903,0.373,NULL,36994701104,578042204,9031909,21.1),(33261,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 16247',NULL,33261,40.45,0.16,1230,8949,70,NULL,'SN photometric redshift distance, z photo =0.344 +/- 0.032','SDSS-II SN 16247',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,56.36975,-0.46344,0.257,NULL,36994008550,578031383,9031740,NULL),(33262,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 18917',NULL,33262,39.04,0.76,642,8950,70,NULL,'SN photometric redshift distance, z photo =0.163 +/- 0.078','SDSS-II SN 18917',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.1g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,56.3842083333,0.03925,0.409,NULL,65062051013,1016594547,15884289,21.1),(33263,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33263,35.45,0.4,123,8951,NULL,NULL,'mean','UGC 02849',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000037,NULL,'17.',1.1,'Scd:',NULL,NULL,NULL,NULL,1,56.387125,44.85483,NULL,NULL,68282922555,1066920664,16670635,17),(33264,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33264,35.52,0.47,127,8951,NULL,NULL,'H','UGC 02849',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33265,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33265,35.6,0.45,132,8951,NULL,NULL,'K','UGC 02849',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33266,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33266,35.64,0.46,134,8951,NULL,NULL,'J','UGC 02849',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33267,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33267,35.7,0.2,138,8951,74.4,NULL,NULL,'UGC 02849',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33268,'IRAS','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33268,34.3,0.8,72.5,8952,75,NULL,'MAT, I','ESO 083- G 010',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.95',0.8,'SA(r)bc',NULL,NULL,NULL,NULL,1,56.4190417,-64.30083,0.125,NULL,36458404967,569662577,8900977,14.95),(33269,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33269,34.8,0.32,91.4,8952,85,NULL,'I, raw','ESO 083- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33270,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33270,34.85,0.32,93.4,8952,85,NULL,'I, inv','ESO 083- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33271,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33271,35.2,0.43,110,8952,75,NULL,'MAT, I, raw','ESO 083- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33272,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33272,35.45,0.43,123,8952,75,NULL,'MAT, I, inv','ESO 083- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33273,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33273,35.47,0.43,124,8952,75,NULL,'MAT, I, cor','ESO 083- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33274,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33274,33.49,0.47,49.8,8953,70,NULL,NULL,'NGC 1441',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000047,NULL,'13.95',0.6,'SB(s)b','in a pair',NULL,NULL,NULL,1,56.429667,-4.09158,0.237,NULL,37000681487,578135648,9033369,13.95),(33275,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33275,33.87,0.47,59.5,8954,NULL,NULL,'H','UGC 02851',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000027,NULL,'14.97',0.7,'Sb:',NULL,NULL,NULL,NULL,1,56.4324583,46.67356,NULL,NULL,68277195754,1066831183,16669237,14.97),(33276,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33276,33.93,0.45,61.1,8954,NULL,NULL,'K','UGC 02851',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33277,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33277,33.96,0.46,62,8954,NULL,NULL,'J','UGC 02851',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33278,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33278,34.29,0.4,72.1,8954,NULL,NULL,'mean','UGC 02851',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33279,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33279,35.41,0.49,121,8955,70,NULL,NULL,'NGC 1447',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.02',0.6,'S0o: pec:',NULL,NULL,NULL,NULL,1,56.4464583,-9.01869,0.113,NULL,37021673971,578463655,9038494,16.02),(33280,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33280,35.58,0.46,131,8956,70,NULL,NULL,'2MASX J03454802-0000253',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00015,NULL,'16.8g',0.24,'NLAGN',NULL,NULL,NULL,'Sy 2',1,56.4499166667,-0.00708,0.409,NULL,36926690172,576979533,9015305,16.8),(33281,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33281,29.08,0.43,6.5,8957,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1437B',NULL,'2014MNRAS.444..527S',2014,1,2.6,'Position in 1997AJ....113...22G is incorrect.','G',0.000011,NULL,'13.97',0.9,'I0:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,56.4785417,-36.35697,0,NULL,38555612049,602431438,9412991,13.97),(33282,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33282,29.43,0.43,7.7,8957,75,NULL,'3.6 micron, color corrected','NGC 1437B',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33283,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33283,29.67,0.2,8.59,8957,74.4,NULL,NULL,'NGC 1437B',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33284,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33284,30.06,0.4,10.3,8957,NULL,NULL,NULL,'NGC 1437B',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33285,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33285,30.06,0.4,10.3,8957,73,NULL,'opt','NGC 1437B',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33286,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 11317',NULL,33286,40.15,0.35,1070,8958,70,NULL,'SN photometric redshift distance, z photo =0.292 +/- 0.063','SDSS-II SN 11317',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','20.6g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,56.507333,0.56208,0.317,NULL,65196368114,1018693251,15917082,20.6),(33287,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33287,35.22,0.54,111,8959,70,NULL,NULL,'2MASX J03460325-2522337',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'16.66',0.35,NULL,NULL,NULL,NULL,NULL,1,56.5136666667,-25.37606,0,NULL,38528332347,602005192,9406331,16.66),(33288,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 14137','RN',33288,41.26,0.34,1360,8960,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14137',0.311647,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33289,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 14137','RN',33289,41.54,0.31,1550,8960,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14137',0.311647,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33290,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33290,33.42,0.49,48.2,8961,70,NULL,NULL,'NGC 1451',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.05',0.4,'S0-?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,56.529833,-4.06919,0.237,NULL,37008926528,578264477,9035382,15.05),(33291,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33291,35.28,0.46,114,8962,70,NULL,NULL,'2MASX J03461212+0107164',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00016,NULL,'16.2g',0.31,'S0^-',NULL,NULL,NULL,NULL,1,56.550417,1.12108,0.385,NULL,65197285516,1018707586,15917306,16.2),(33292,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33292,35.31,0.51,115,8963,70,NULL,NULL,'NGC 1434',NULL,'2014MNRAS.445.2677S',2014,1,0.73,'Identification as NGC 1434 is very uncertain.','G',0.000137,NULL,'15.2b',0.44,'S0+:',NULL,NULL,NULL,NULL,1,56.553625,-9.68261,0.097,NULL,37023953423,578499272,9039051,15.2),(33293,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33293,31.34,0.17,18.5,8964,NULL,NULL,'TOM(g) = -7.2 mag','NGC 1460',NULL,'2010ApJ...717..603V',2010,1,1.7,NULL,'G',0.000043,NULL,'13.50',1.4,'SB(rl)0^0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,56.55725,-36.69633,0,NULL,38555479950,602429374,9412958,13.5),(33294,'GCLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33294,31.71,0.17,22,8964,NULL,NULL,'TOM(z) = -8.53 mag','NGC 1460',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33295,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33295,31.48,0.14,19.8,8964,74.4,NULL,NULL,'NGC 1460',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33296,'SBF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33296,31.5,0.07,19.9,8964,NULL,NULL,'HST ACS FCS','NGC 1460',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33297,'GC radius','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33297,31.99,0.29,24.9,8964,NULL,NULL,'HST ACS FCS','NGC 1460',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33298,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33298,35.53,0.61,128,8965,70,NULL,NULL,'2MASX J03461378-2141350',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00015,NULL,'16.17',0.45,'S',NULL,NULL,NULL,NULL,1,56.5572083333,-21.69311,0.057,NULL,37996207312,593690739,9276417,16.17),(33299,'IRAS','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33299,32.16,0.8,27.1,8966,75,NULL,'MAT, I','ESO 358- G 063',NULL,'1997ApJS..109..333W',1997,1,4.7,NULL,'G',0.000007,NULL,'12.83',1.3,'I0?            HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,56.5792083333,-34.94356,0,NULL,38569113077,602642391,9416287,12.83),(33300,'IRAS','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33300,32.18,0.8,27.3,8966,75,NULL,'A82, H','ESO 358- G 063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33301,'Tully est','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33301,31.14,0.8,16.9,8966,75,NULL,NULL,'ESO 358- G 063',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33302,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33302,30.91,0.32,15.2,8966,85,NULL,'I, raw','ESO 358- G 063',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33303,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33303,30.92,0.32,15.3,8966,85,NULL,'I, inv','ESO 358- G 063',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33304,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33304,31,0.47,15.8,8966,75,NULL,'A82, H, raw','ESO 358- G 063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33305,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33305,31,0.47,15.9,8966,75,NULL,'A82, H, inv','ESO 358- G 063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33306,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33306,31.04,0.38,16.1,8966,NULL,NULL,NULL,'ESO 358- G 063',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33307,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33307,31.06,0.43,16.3,8966,75,NULL,'MAT, I, raw','ESO 358- G 063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33308,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33308,31.17,0.43,17.2,8966,75,NULL,'MAT, I, inv','ESO 358- G 063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33309,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33309,31.2,0.43,17.4,8966,75,NULL,'3.6 micron, color + selection bias corrected','ESO 358- G 063',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33310,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33310,31.22,0.43,17.5,8966,75,NULL,'3.6 micron, color corrected','ESO 358- G 063',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33311,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33311,31.28,0.2,18,8966,74.4,NULL,NULL,'ESO 358- G 063',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33312,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33312,31.31,0.47,18.2,8966,75,NULL,'A82, H, cor','ESO 358- G 063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33313,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33313,31.32,0.43,18.3,8966,75,NULL,'MAT, I, cor','ESO 358- G 063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33314,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33314,31.37,0.11,18.8,8966,NULL,NULL,NULL,'ESO 358- G 063',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33315,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33315,31.51,0.4,20,8966,73,NULL,'IR','ESO 358- G 063',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33316,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33316,31.51,0.4,20,8966,75,NULL,NULL,'ESO 358- G 063',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33317,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33317,31.59,0.46,20.8,8966,NULL,NULL,'J','ESO 358- G 063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33318,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33318,31.61,0.47,20.9,8966,NULL,NULL,'H','ESO 358- G 063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33319,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33319,31.64,0.45,21.3,8966,NULL,NULL,'K','ESO 358- G 063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33320,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33320,31.92,0.4,24.2,8966,NULL,NULL,'mean','ESO 358- G 063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33321,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33321,32.03,0.49,25.5,8966,75,NULL,'IR','ESO 358- G 063',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33322,'D-Sigma','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33322,33.39,0.4,47.7,8967,75,NULL,'Edat, raw','NGC 1453',NULL,'1997ApJS..109..333W',1997,1,2.4,NULL,'G',0.00002,NULL,'12.77',1.9,'E2-3           LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,56.6135417,-3.96878,0.237,NULL,37008912969,578264265,9035379,12.77),(33323,'D-Sigma','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33323,33.73,0.4,55.7,8967,75,NULL,'Edat, cor','NGC 1453',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33324,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33324,32.8,0.37,36.3,8967,95,NULL,'Weighted Mean','NGC 1453',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33325,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33325,32.96,0.46,39.1,8967,95,NULL,'Michard 1979a','NGC 1453',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33326,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33326,33.05,0.63,40.7,8967,95,NULL,'Michard 1979b, c','NGC 1453',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33327,'Faber-Jackson','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33327,35,0.81,100,8967,55,NULL,'Visvanathan & Sandage 1979','NGC 1453',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33328,'Tertiary','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33328,32.6,0.25,33.1,8967,95,NULL,NULL,'NGC 1453',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33329,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33329,33.57,0.45,51.8,8967,NULL,NULL,'K','NGC 1453',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33330,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33330,33.66,0.4,54,8967,NULL,NULL,'mean','NGC 1453',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33331,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33331,33.3,0.49,45.8,8968,75,NULL,'IR','UGC 02854',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000067,NULL,'17.',0.4,'Scd:',NULL,NULL,NULL,NULL,1,56.618625,36.73664,1.213,NULL,68470580072,1069852813,16716450,17),(33332,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33332,35.22,0.49,110,8969,75,NULL,'IR','UGC 02856',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',NULL,NULL,'17.',0.3,'Sbc',NULL,NULL,NULL,NULL,1,56.6242917,15.41219,1.041,NULL,65121898700,1017529667,15898901,17),(33333,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33333,36.19,0.2,173,8969,74.4,NULL,NULL,'UGC 02856',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33334,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33334,34.95,0.53,97.8,8970,70,NULL,NULL,'2MASX J03463210-1315477',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.000077,NULL,'15.65',0.59,NULL,NULL,NULL,NULL,NULL,1,56.633875,-13.26333,0.117,NULL,36890397591,576412462,9006444,15.65),(33335,'IRAS','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33335,33.36,0.8,47.1,8971,75,NULL,'MAT, I','MCG -01-10-035',NULL,'1997ApJS..109..333W',1997,1,2.82,NULL,'G',0.000007,NULL,'15.26',0.35,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,56.6497083,-4.45319,0.205,NULL,37000582935,578134108,9033345,15.26),(33336,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33336,33.29,0.47,45.6,8971,NULL,NULL,'H','MCG -01-10-035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33337,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33337,33.34,0.46,46.5,8971,NULL,NULL,'J','MCG -01-10-035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33338,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33338,33.35,0.45,46.7,8971,NULL,NULL,'K','MCG -01-10-035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33339,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33339,33.55,0.4,51.2,8971,NULL,NULL,'mean','MCG -01-10-035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33340,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33340,33.55,0.43,51.3,8971,75,NULL,'MAT, I, raw','MCG -01-10-035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33341,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33341,33.57,0.49,51.9,8971,75,NULL,'IR','MCG -01-10-035',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33342,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33342,33.71,0.32,55.1,8971,85,NULL,'I, raw','MCG -01-10-035',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33343,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33343,33.76,0.32,56.5,8971,85,NULL,'I, inv','MCG -01-10-035',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33344,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33344,33.8,0.43,57.5,8971,75,NULL,'MAT, I, inv','MCG -01-10-035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33345,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33345,33.8,0.43,57.5,8971,75,NULL,'MAT, I, cor','MCG -01-10-035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33346,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33346,33.83,0.2,58.3,8971,74.4,NULL,NULL,'MCG -01-10-035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33347,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33347,33.97,0.42,62.3,8971,NULL,NULL,'Malmquist cor.','MCG -01-10-035',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33348,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33348,34.03,0.41,63.8,8971,NULL,NULL,NULL,'MCG -01-10-035',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33349,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33349,34.03,NULL,64,8971,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -01-10-035',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33350,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33350,34.03,NULL,64.1,8971,NULL,NULL,'Dipole','MCG -01-10-035',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33351,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33351,34.04,NULL,64.2,8971,NULL,NULL,'Dipole + Quadrupole','MCG -01-10-035',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33352,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33352,29.4,0.43,7.6,8972,75,NULL,'3.6 micron, color + selection bias corrected','MCG -03-10-045',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.00003,NULL,'13.68',0.6,'IBm pec:       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,56.65875,-16.55017,0.125,NULL,38010611683,593915807,9279934,13.68),(33353,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33353,29.77,0.43,9,8972,75,NULL,'3.6 micron, color corrected','MCG -03-10-045',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33354,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33354,30.05,0.2,10.2,8972,74.4,NULL,NULL,'MCG -03-10-045',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33355,'FP','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33355,35.36,0.63,118,8973,70,NULL,NULL,'ESO 419- G 006',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000103,NULL,'15.07',1,'Sb',NULL,NULL,NULL,NULL,1,56.700833,-29.93928,0,NULL,38576476318,602757442,9418085,15.07),(33356,'Brightest Stars','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33356,26.6,NULL,2.08,8974,NULL,NULL,'3B + 3R mean','IC 0342',NULL,'1993A&AS..100..227K',1993,1,21.4,NULL,'G',0.00001,NULL,'9.10',20.9,'SAB(rs)cd  Sbrst;HII','Possible group member',NULL,NULL,NULL,1,56.702083,68.09636,3.357,0,66412722984,1037698796,16214043,9.1),(33357,'Brightest Stars','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33357,27.29,NULL,2.87,8974,NULL,NULL,NULL,'IC 0342',NULL,'1997A&AS..124..559K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33358,'Brightest Stars','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33358,27.31,NULL,2.9,8974,NULL,NULL,NULL,'IC 0342',NULL,'2001ASPC..240..589H',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33359,'Cepheids','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33359,27.58,0.18,3.28,8974,NULL,NULL,'20, ri','IC 0342',NULL,'2002AJ....124..839S',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33360,'Cepheids','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33360,27.65,0.07,3.39,8974,74.4,NULL,NULL,'IC 0342',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33361,'PNLF','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33361,27.72,0.17,3.5,8974,NULL,NULL,NULL,'IC 0342',NULL,'2008ApJ...683..630H',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33362,'TRGB','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33362,27.59,0.14,3.3,8974,NULL,NULL,'F160W','IC 0342',NULL,'2014AJ....148....7W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33363,'TRGB','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33363,27.6,0.13,3.31,8974,NULL,NULL,'F110W','IC 0342',NULL,'2014AJ....148....7W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33364,'TRGB','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33364,27.65,0.07,3.39,8974,74.4,NULL,NULL,'IC 0342',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33365,'TRGB','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33365,27.69,0.08,3.45,8974,NULL,NULL,'Corrected','IC 0342',NULL,'2014AJ....148....7W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33366,'TRGB','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33366,27.97,0.1,3.93,8974,NULL,NULL,NULL,'IC 0342',NULL,'2010AstL...36..167T',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33367,'CO ring diameter','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33367,28.89,NULL,6,8974,NULL,NULL,NULL,'IC 0342',NULL,'1991PASJ...43..671S',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33368,'Tertiary','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33368,26.32,0.15,1.84,8974,NULL,NULL,NULL,'IC 0342',NULL,'1989AJ.....97.1341M',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33369,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33369,25,NULL,1,8974,75,NULL,'CO','IC 0342',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33370,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33370,25.88,NULL,1.5,8974,75,NULL,'HI','IC 0342',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33371,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33371,27.35,NULL,2.95,8974,NULL,NULL,'LEDA [April 2006]','IC 0342',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33372,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33372,27.96,0.4,3.9,8974,75,NULL,'B','IC 0342',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33373,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 19402','RN',33373,39.61,0.1,708,8975,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 19402',0.1815,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33374,'SNIa SDSS','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 19402','RN',33374,39.65,0.19,720,8975,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19402',0.1815,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33375,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33375,34.45,0.49,77.8,8976,75,NULL,'IR','FGC 0452',NULL,'2011yCatp016004901K',2011,1,1.37,NULL,'G',0.000007,NULL,'16.2',0.13,'Scd',NULL,NULL,NULL,NULL,1,56.7310417,-11.80614,0.105,NULL,37025450868,578522669,9039416,16.2),(33376,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33376,34.52,NULL,80.2,8976,NULL,NULL,'Dipole + Quadrupole','FGC 0452',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33377,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33377,34.52,NULL,80.2,8976,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0452',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33378,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33378,34.52,NULL,80.3,8976,NULL,NULL,'Dipole','FGC 0452',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33379,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 11306','R',33379,40.66,0.27,1060,8977,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J034657.17-003109.1',0.2738,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',0.0002,NULL,'21.9g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,56.7382083333,-0.51922,0.513,NULL,36926782747,576980980,9015327,21.9),(33380,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 11306','R',33380,40.71,0.22,1090,8977,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J034657.17-003109.1',0.2738,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33381,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 11306',NULL,33381,40.57,0.23,1300,8977,70,NULL,'SALT 2','SDSS J034657.17-003109.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33382,'SNIa','2016-12-15 15:14:01','2016-12-16 11:19:05','1','SDSS-II SN 11306',NULL,33382,40.6,0.23,1320,8977,70,NULL,'SALT 2, Malmquist cor.','SDSS J034657.17-003109.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33383,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,'R',33383,33.52,0.49,50.5,8978,75,NULL,'IR','MCG -01-10-036',NULL,'2011yCatp016004901K',2011,1,1.6,NULL,'G',0.00007,NULL,'14.90',0.4,'Sbc: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,56.741375,-3.46147,0.337,NULL,37009143074,578267860,9035435,14.9),(33384,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33384,33.67,0.2,54.2,8978,74.4,NULL,NULL,'MCG -01-10-036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33385,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33385,33.75,0.4,56.2,8978,NULL,NULL,'mean','MCG -01-10-036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33386,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33386,33.83,0.46,58.4,8978,NULL,NULL,'J','MCG -01-10-036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33387,'Tully-Fisher','2016-12-15 15:14:01','2016-12-16 11:19:05','1',NULL,NULL,33387,33.87,0.47,59.3,8978,NULL,NULL,'H','MCG -01-10-036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33388,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33388,33.92,0.44,60.7,8978,NULL,NULL,NULL,'MCG -01-10-036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33389,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33389,33.94,0.44,61.3,8978,NULL,NULL,'Malmquist cor.','MCG -01-10-036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33390,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33390,33.95,0.45,61.6,8978,NULL,NULL,'K','MCG -01-10-036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33391,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33391,33.67,0.8,54.3,8979,75,NULL,'MAT, I','NGC 1459',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000013,NULL,'13.60',1.1,'SB(s)bc?       HII',NULL,NULL,NULL,NULL,1,56.7414166667,-25.52175,0,NULL,38528294854,602004607,9406321,13.6),(33392,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33392,33,0.69,39.8,8979,100,NULL,'mid-IR','NGC 1459',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33393,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33393,33.14,0.32,42.5,8979,85,NULL,'I, raw','NGC 1459',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33394,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33394,33.18,0.43,43.2,8979,75,NULL,'MAT, I, raw','NGC 1459',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33395,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33395,33.18,0.32,43.2,8979,85,NULL,'I, inv','NGC 1459',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33396,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33396,33.35,0.43,46.7,8979,75,NULL,'MAT, I, inv','NGC 1459',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33397,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33397,33.56,0.43,51.6,8979,75,NULL,'MAT, I, cor','NGC 1459',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33398,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33398,33.61,0.2,52.7,8979,74.4,NULL,NULL,'NGC 1459',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33399,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33399,33.69,0.45,54.6,8979,NULL,NULL,'K','NGC 1459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33400,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33400,33.7,0.47,55.1,8979,NULL,NULL,'H','NGC 1459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33401,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33401,33.72,0.46,55.5,8979,NULL,NULL,'J','NGC 1459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33402,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33402,33.73,0.3,55.8,8979,NULL,NULL,'Malmquist cor.','NGC 1459',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33403,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33403,33.78,0.4,57.1,8979,NULL,NULL,'mean','NGC 1459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33404,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33404,33.84,0.28,58.6,8979,NULL,NULL,NULL,'NGC 1459',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33405,'FP','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33405,36.56,0.53,205,8980,70,NULL,NULL,'FCCB 1946',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.000093,NULL,'15.84',0.5,'E6(M32?)','Group non-member, background',NULL,NULL,NULL,1,56.755833,-34.44067,0,NULL,38569046329,602641348,9416271,15.84),(33406,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33406,34.4,0.8,75.9,8981,75,NULL,'MAT, I','ESO 302- G 007',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.00002,NULL,'15.44',0.9,'SAB(s)cd','Group non-member, background',NULL,NULL,NULL,1,56.776167,-37.37789,0,NULL,38557824935,602466014,9413531,15.44),(33407,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33407,33.92,0.32,60.8,8981,85,NULL,'I, raw','ESO 302- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33408,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33408,33.93,0.32,61,8981,85,NULL,'I, inv','ESO 302- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33409,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33409,34.38,0.43,75.3,8981,75,NULL,'MAT, I, raw','ESO 302- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33410,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33410,34.49,0.2,79.1,8981,74.4,NULL,NULL,'ESO 302- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33411,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33411,34.49,0.43,79.1,8981,75,NULL,'MAT, I, inv','ESO 302- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33412,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33412,34.55,0.6,81.5,8981,NULL,NULL,'Malmquist cor.','ESO 302- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33413,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33413,34.65,0.57,85.2,8981,NULL,NULL,NULL,'ESO 302- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33414,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33414,34.73,0.43,88.4,8981,75,NULL,'MAT, I, cor','ESO 302- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33415,'SBF','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33415,31.06,0.1,16.3,8982,NULL,NULL,NULL,'AM 0345-362',NULL,'2006AJ....132.1384D',2006,1,1.1,NULL,'G',NULL,NULL,'16.3B',0.9,'E2','Group member',NULL,NULL,NULL,1,56.7840417,-36.32675,0,NULL,38555532679,602430198,9412971,16.3),(33416,'SBF','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33416,31.25,0.18,17.8,8982,NULL,NULL,NULL,'AM 0345-362',NULL,'2006AJ....132.1384D',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33417,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33417,34.01,1.13,63.3,8983,NULL,NULL,'Malmquist cor.','ESO 482- G 044',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.00003,NULL,'15.41',0.5,'S?',NULL,NULL,NULL,NULL,1,56.793417,-26.94508,0,NULL,38526576345,601977755,9405902,15.41),(33418,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33418,34.14,1.07,67.3,8983,NULL,NULL,NULL,'ESO 482- G 044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33419,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33419,34.18,0.2,68.6,8983,74.4,NULL,NULL,'ESO 482- G 044',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33420,'FP','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,'R',33420,38,0.46,399,8984,70,NULL,NULL,'2MASX J03471595-0613543',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000091,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,56.816417,-6.23181,0.181,NULL,37029719594,578589368,9040458,17.3),(33421,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33421,31.87,0.43,23.7,8985,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0453',NULL,'2014MNRAS.444..527S',2014,1,1.2,NULL,'G',0.000057,NULL,'16.1',0.15,'Sdm',NULL,NULL,NULL,NULL,1,56.8260417,-14.69725,0.065,NULL,36891831887,576434873,9006794,16.1),(33422,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33422,32.6,NULL,33.2,8985,NULL,NULL,NULL,'FGC 0453',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33423,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33423,32.63,NULL,33.6,8985,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0453',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33424,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33424,32.64,NULL,33.7,8985,NULL,NULL,'Dipole + Quadrupole','FGC 0453',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33425,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33425,32.66,NULL,34.1,8985,NULL,NULL,'Dipole','FGC 0453',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33426,'FP','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,'R',33426,38,0.46,397,8986,70,NULL,NULL,'2MASX J03472008-0105005',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000195,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,56.8335417,-1.08358,0.441,NULL,36994383353,578037239,9031831,18.1),(33427,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33427,31.33,0.8,18.5,8987,75,NULL,'MAT, I','NGC 1473',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'13.4',0.8,'IB(s)m:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,56.859583,-68.22058,0.209,NULL,36394201626,568659400,8885303,13.4),(33428,'Tully est','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33428,30.89,0.8,15,8987,75,NULL,NULL,'NGC 1473',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33429,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33429,30.68,0.32,13.7,8987,85,NULL,'I, inv','NGC 1473',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33430,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33430,30.72,0.32,13.9,8987,85,NULL,'I, raw','NGC 1473',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33431,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33431,31.28,0.43,18.1,8987,75,NULL,'MAT, I, inv','NGC 1473',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33432,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33432,31.33,0.43,18.5,8987,75,NULL,'MAT, I, raw','NGC 1473',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33433,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33433,31.34,0.4,18.5,8987,NULL,NULL,NULL,'NGC 1473',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33434,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33434,31.34,0.4,18.5,8987,73,NULL,'opt','NGC 1473',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33435,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33435,31.45,0.43,19.5,8987,75,NULL,'MAT, I, cor','NGC 1473',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33436,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33436,30.59,0.8,13.1,8988,75,NULL,'MAT, I','ESO 302- G 009',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.000011,NULL,'15.38',0.6,'SB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,56.8921666667,-38.57653,0,NULL,38554443487,602413179,9412705,15.38),(33437,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33437,30.61,0.8,13.2,8988,75,NULL,'A82, H','ESO 302- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33438,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33438,30.87,0.32,14.9,8988,85,NULL,'I, inv','ESO 302- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33439,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33439,30.91,0.32,15.2,8988,85,NULL,'I, raw','ESO 302- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33440,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33440,31.38,0.43,18.9,8988,75,NULL,'MAT, I, inv','ESO 302- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33441,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33441,31.46,0.4,19.6,8988,NULL,NULL,NULL,'ESO 302- G 009',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33442,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33442,31.46,0.39,19.6,8988,73,NULL,'opt','ESO 302- G 009',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33443,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33443,31.49,0.43,19.8,8988,75,NULL,'MAT, I, raw','ESO 302- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33444,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33444,31.63,0.47,21.2,8988,75,NULL,'A82, H, inv','ESO 302- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33445,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33445,31.63,0.43,21.2,8988,75,NULL,'MAT, I, cor','ESO 302- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33446,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33446,31.85,0.47,23.5,8988,75,NULL,'A82, H, raw','ESO 302- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33447,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33447,31.9,0.47,24,8988,75,NULL,'A82, H, cor','ESO 302- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33448,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33448,34.06,0.69,64.9,8989,100,NULL,'mid-IR','UGC 02862',NULL,'2013ApJ...771...88L',2013,1,1.4,NULL,'G',0.00006,NULL,'15.00',1,'(R\')SAB(s)a:','Pair member (points to parent)',NULL,NULL,NULL,1,56.912333,13.25594,0.885,NULL,65128086520,1017626351,15900411,15),(33449,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33449,34.86,0.45,93.7,8989,NULL,NULL,'K','UGC 02862',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33450,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33450,34.86,0.47,93.9,8989,NULL,NULL,'H','UGC 02862',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33451,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33451,34.87,0.4,94.2,8989,NULL,NULL,'mean','UGC 02862',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33452,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33452,34.94,0.46,97.3,8989,NULL,NULL,'J','UGC 02862',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33453,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33453,34.38,0.47,75.1,8990,NULL,NULL,'H','UGC 02861',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000037,NULL,'16.0',0.7,'SA(r)b',NULL,NULL,NULL,NULL,1,56.9157917,39.34686,1.357,NULL,68350636789,1067978699,16687167,16),(33454,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33454,34.46,0.46,77.9,8990,NULL,NULL,'J','UGC 02861',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33455,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33455,34.48,0.45,78.7,8990,NULL,NULL,'K','UGC 02861',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33456,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33456,34.67,0.4,86,8990,NULL,NULL,'mean','UGC 02861',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33457,'AGN time lag','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33457,34.78,0.1,90.4,8991,NULL,NULL,NULL,'2MASX J03474022+0105143',NULL,'2014ApJ...784L..11Y',2014,1,0.28,NULL,'G',NULL,NULL,'17.48',0.27,'Sy1.5',NULL,NULL,NULL,'Sy 1.5',1,56.9174583333,1.08722,0.389,NULL,65196707151,1018698549,15917164,17.48),(33458,'FP','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,'R',33458,38.71,0.46,552,8992,70,NULL,NULL,'SDSS J034740.61-052456.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000078,NULL,'18.9g',0.1,NULL,NULL,NULL,NULL,NULL,1,56.9192083,-5.41567,0.185,NULL,36999836569,578122446,9033163,18.9),(33459,'FP','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,'R',33459,37.62,0.46,334,8993,70,NULL,NULL,'2MASX J03474323-0114033',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000183,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,56.930083,-1.23422,0.433,NULL,36994543756,578039746,9031871,18.8),(33460,'FP','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33460,37.28,0.65,285,8994,70,NULL,NULL,'2MASX J03474362-1920021',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.16',0.31,NULL,NULL,NULL,NULL,NULL,1,56.9315833333,-19.33397,0.157,NULL,38045819628,594465931,9288530,16.16),(33461,'SNIa SDSS','2016-12-15 15:14:02','2016-12-16 11:19:05','1','SDSS-II SN 14175','RN',33461,40.05,0.15,866,8995,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 14175',0.179303,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33462,'SNIa SDSS','2016-12-15 15:14:02','2016-12-16 11:19:05','1','SDSS-II SN 14175','RN',33462,40.8,0.23,1230,8995,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 14175',0.179303,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33463,'FP','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,'R',33463,35.15,0.46,107,8996,70,NULL,NULL,'2MASX J03474575+0041118',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.00009,NULL,'15.7g',0.46,'E0',NULL,NULL,NULL,NULL,1,56.940583,0.68672,0.429,NULL,65062906760,1016607918,15884498,15.7),(33464,'FP','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33464,35.71,0.57,139,8997,70,NULL,NULL,'FAIRALL 1272',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.9B',0.42,NULL,NULL,NULL,NULL,NULL,1,56.951167,-72.02683,0.177,NULL,36422416473,569100257,8892191,15.9),(33465,'FP','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33465,34.16,0.47,68,8998,70,NULL,NULL,'MCG -03-10-046',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000133,NULL,'15.14',0.4,'E',NULL,NULL,NULL,NULL,1,56.953667,-20.04244,0.117,NULL,38044935168,594452112,9288314,15.14),(33466,'FP','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,'R',33466,36.02,0.46,160,8999,70,NULL,NULL,'2MASX J03475138-0711016',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000073,NULL,'16.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,56.964083,-7.18378,0.165,NULL,37031415242,578615863,9040872,16.8),(33467,'GCLF','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33467,30.9,0.27,15.1,9000,NULL,NULL,'TOM(g) = -7.2 mag','ESO 358- G 066',NULL,'2010ApJ...717..603V',2010,1,1.2,NULL,'G',0.000097,NULL,'15.3B',0.6,'SB(s)0-:','Group member',NULL,NULL,NULL,1,56.9694583333,-36.47169,0,NULL,38556099827,602439059,9413110,15.3),(33468,'GCLF','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33468,31.48,0.27,19.8,9000,NULL,NULL,'TOM(z) = -8.53 mag','ESO 358- G 066',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33469,'SBF','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33469,31.49,0.14,19.9,9000,74.4,NULL,NULL,'ESO 358- G 066',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33470,'SBF','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33470,31.51,0.08,20.1,9000,NULL,NULL,'HST ACS FCS','ESO 358- G 066',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33471,'GC radius','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33471,31.88,0.36,23.8,9000,NULL,NULL,'HST ACS FCS','ESO 358- G 066',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33472,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33472,31.68,0.8,21.7,9001,75,NULL,'MAT, I','ESO 549- G 018',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.000023,NULL,'13.67',1.5,'SAB(rs)c','Line-of-sight pair member',NULL,NULL,NULL,1,57.058667,-21.47447,0.101,NULL,37988971920,593577686,9274651,13.67),(33473,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33473,31.63,0.09,21.2,9001,NULL,NULL,NULL,'ESO 549- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33474,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33474,31.96,0.32,24.7,9001,85,NULL,'I, raw','ESO 549- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33475,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33475,31.98,0.32,24.9,9001,85,NULL,'I, inv','ESO 549- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33476,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33476,32.13,0.2,26.7,9001,74.4,NULL,NULL,'ESO 549- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33477,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33477,32.13,0.43,26.7,9001,75,NULL,'3.6 micron, color corrected','ESO 549- G 018',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33478,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33478,32.14,0.43,26.8,9001,75,NULL,'3.6 micron, color + selection bias corrected','ESO 549- G 018',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33479,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33479,32.16,0.4,27,9001,NULL,NULL,'mean','ESO 549- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33480,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33480,32.27,0.43,28.5,9001,75,NULL,'MAT, I, raw','ESO 549- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33481,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33481,32.3,0.43,28.9,9001,75,NULL,'MAT, I, cor','ESO 549- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33482,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33482,32.39,0.43,30,9001,75,NULL,'MAT, I, inv','ESO 549- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33483,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33483,33,0.47,39.8,9001,NULL,NULL,'H','ESO 549- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33484,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33484,33.06,0.46,40.8,9001,NULL,NULL,'J','ESO 549- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33485,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33485,33.09,0.45,41.5,9001,NULL,NULL,'K','ESO 549- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33486,'SNIa','2016-12-15 15:14:02','2016-12-16 11:19:05','1','SDSS-II SN 15865','R',33486,41.08,0.26,1230,9002,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15865',0.33,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,57.067,0.49878,0.473,NULL,65063081345,1016610646,15884541,NULL),(33487,'SNIa','2016-12-15 15:14:02','2016-12-16 11:19:05','1','SDSS-II SN 15865','R',33487,41.49,0.21,1500,9002,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15865',0.33,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33488,'SNIa','2016-12-15 15:14:02','2016-12-16 11:19:05','1','SDSS-II SN 18071',NULL,33488,39.85,1.54,934,9003,70,NULL,'SN photometric redshift distance, z photo =0.248 +/- 0.361','SDSS-II SN 18071',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.4g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,57.0719166667,0.97919,0.529,NULL,65062678958,1016604358,15884443,22.4),(33489,'Sosies','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33489,30.71,0.14,13.9,9004,NULL,NULL,NULL,'UGC 02855',NULL,'2002A&A...393...57T',2002,1,4.4,NULL,'G',0.000003,NULL,'13.5',2,'SABc           HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,57.086375,70.13289,1.685,NULL,66395657024,1037432141,16209877,13.5),(33490,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33490,30.79,0.2,14.4,9004,74.4,NULL,NULL,'UGC 02855',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33491,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:05','1',NULL,NULL,33491,30.92,0.46,15.3,9004,NULL,NULL,'J','UGC 02855',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33492,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33492,30.95,0.4,15.5,9004,NULL,NULL,NULL,'UGC 02855',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33493,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33493,30.95,0.4,15.5,9004,73,NULL,'opt','UGC 02855',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33494,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33494,31.53,0.4,20.3,9004,75,NULL,'B','UGC 02855',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33495,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33495,31.57,0.4,20.6,9004,NULL,NULL,'mean','UGC 02855',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33496,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33496,37.06,0.46,259,9005,70,NULL,NULL,'2MASX J03482348-0557025',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000082,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,57.09775,-5.95067,0.241,NULL,36999601638,578118775,9033105,17.2),(33497,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33497,36.86,0.68,235,9006,70,NULL,NULL,'2MASX J03482358-1927262',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.26',0.36,NULL,NULL,NULL,NULL,NULL,1,57.0982917,-19.45722,0.133,NULL,38043011531,594422055,9287844,16.26),(33498,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33498,36.23,0.46,176,9007,70,NULL,NULL,'2MASX J03482701-0047195',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00015,NULL,'15.9g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,57.112625,-0.78869,0.453,NULL,36927079839,576985622,9015400,15.9),(33499,'Faber-Jackson','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33499,31.96,0.65,24.7,9008,95,NULL,'Weighted Mean','NGC 1461',NULL,'1984ApJS...56...91D',1984,1,3,NULL,'G',0.000043,NULL,'13.19',0.9,'SA(r)0^0^','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,57.113083,-16.39289,0.081,NULL,36882918064,576295594,9004618,13.19),(33500,'Faber-Jackson','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33500,33.9,0.81,60.3,9008,55,NULL,'Visvanathan & Sandage 1979','NGC 1461',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33501,'Tully est','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33501,31.17,0.8,17.1,9008,75,NULL,'B','NGC 1461',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33502,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33502,31.76,0.4,22.5,9008,NULL,NULL,'mean','NGC 1461',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33503,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33503,31.78,0.45,22.7,9008,NULL,NULL,'K','NGC 1461',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33504,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33504,35.14,0.65,107,9009,70,NULL,NULL,'ESO 549- G 021',NULL,'2014MNRAS.445.2677S',2014,1,1.47,NULL,'G',0.00015,NULL,'15.37',0.24,'Sa:            HII',NULL,NULL,NULL,NULL,1,57.1185833333,-18.75231,0.113,NULL,38043337139,594427142,9287924,15.37),(33505,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33505,33.96,0.49,61.8,9010,75,NULL,'IR','UGC 02868',NULL,'2011yCatp016004901K',2011,1,1.34,'The 2MASS position applies to a compact object southeast of the nucleus.','G',0.000133,NULL,'17.',0.19,'Sbc',NULL,NULL,NULL,NULL,1,57.1360417,35.15022,0.829,NULL,68482339947,1070036561,16719321,17),(33506,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33506,34.34,0.4,73.7,9010,NULL,NULL,'mean','UGC 02868',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33507,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33507,34.62,0.47,83.8,9010,NULL,NULL,'H','UGC 02868',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33508,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33508,34.64,0.43,84.8,9010,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02868',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33509,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33509,34.66,0.43,85.4,9010,75,NULL,'3.6 micron, color corrected','UGC 02868',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33510,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33510,34.67,0.2,85.9,9010,74.4,NULL,NULL,'UGC 02868',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33511,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33511,35.01,NULL,100,9010,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02868',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33512,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33512,35.02,NULL,101,9010,NULL,NULL,'Dipole + Quadrupole','UGC 02868',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33513,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33513,35.03,NULL,101,9010,NULL,NULL,'Dipole','UGC 02868',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33514,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33514,34.92,0.4,96.2,9011,NULL,NULL,'mean','UGC 02871',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000004,NULL,'15.03',0.8,'Sb','Pair member (points to parent)',NULL,NULL,NULL,1,57.1935417,13.13908,0.901,NULL,65128031436,1017625491,15900398,15.03),(33515,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33515,34.93,0.47,96.9,9011,NULL,NULL,'H','UGC 02871',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33516,'SNIa SDSS','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SDSS-II SN 15190','RN',33516,41.21,0.26,1440,9012,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 15190',0.213816,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33517,'SNIa SDSS','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SDSS-II SN 15190','RN',33517,41.71,0.26,1810,9012,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 15190',0.213816,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33518,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33518,33.74,0.8,55.9,9013,75,NULL,'MAT, I','ESO 549- G 022',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000013,NULL,'14.87',0.6,'SA(rs)b:',NULL,NULL,NULL,NULL,1,57.215917,-18.97886,0.109,NULL,38043145872,594424154,9287877,14.87),(33519,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33519,33.67,0.32,54.2,9013,85,NULL,'I, raw','ESO 549- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33520,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33520,33.69,0.32,54.7,9013,85,NULL,'I, inv','ESO 549- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33521,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33521,33.84,0.43,58.7,9013,75,NULL,'MAT, I, raw','ESO 549- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33522,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33522,33.89,0.29,60,9013,NULL,NULL,'Malmquist cor.','ESO 549- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33523,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33523,33.96,0.43,61.9,9013,75,NULL,'MAT, I, inv','ESO 549- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33524,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33524,34.09,0.43,65.9,9013,75,NULL,'MAT, I, cor','ESO 549- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33525,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33525,34.13,0.2,67,9013,74.4,NULL,NULL,'ESO 549- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33526,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33526,34.31,0.24,72.7,9013,NULL,NULL,NULL,'ESO 549- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33527,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33527,36.6,0.65,209,9014,70,NULL,NULL,'ESO 156- G 016',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'15.59',0.6,'Sb',NULL,NULL,NULL,NULL,1,57.22,-55.42636,0,NULL,35827272629,559801134,8746892,15.59),(33528,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33528,33.26,0.47,44.9,9015,NULL,NULL,'H','ESO 549- G 023',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.0001,NULL,'14.25',0.6,'(R\'_1)SB(1)a   HII',NULL,NULL,NULL,NULL,1,57.241083,-22.13133,0.081,NULL,37997173636,593705838,9276653,14.25),(33529,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33529,33.35,0.45,46.8,9015,NULL,NULL,'K','ESO 549- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33530,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33530,33.4,0.46,48,9015,NULL,NULL,'J','ESO 549- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33531,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33531,33.71,0.4,55.2,9015,NULL,NULL,'mean','ESO 549- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33532,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33532,36.44,0.83,194,9016,70,NULL,NULL,'2MASX J03485997-5841448',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.19',0.53,'S0',NULL,NULL,NULL,NULL,1,57.249833,-58.69583,0,NULL,35829563050,559836922,8747451,16.19),(33533,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33533,36.48,0.6,198,9017,70,NULL,NULL,'2MASX J03490132-1827119',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.36',0.22,NULL,NULL,NULL,NULL,NULL,1,57.255625,-18.45347,0.105,NULL,38043261246,594425956,9287905,16.36),(33534,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33534,30.59,0.8,13.1,9018,75,NULL,'MAT, I','IC 2000',NULL,'1997ApJS..109..333W',1997,1,4.1,'The APM position is east of the center of the galaxy.','G',0.000003,NULL,'12.89',0.8,'SB(s)cd: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,57.28225,-48.85819,0,NULL,37782170971,590346421,9224162,12.89),(33535,'Tully est','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33535,30.07,0.8,10.3,9018,75,NULL,NULL,'IC 2000',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33536,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33536,31.09,0.32,16.5,9018,85,NULL,'I, raw','IC 2000',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33537,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33537,31.1,0.32,16.6,9018,85,NULL,'I, inv','IC 2000',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33538,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33538,31.15,0.43,17,9018,75,NULL,'MAT, I, raw','IC 2000',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33539,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33539,31.25,0.43,17.8,9018,75,NULL,'MAT, I, inv','IC 2000',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33540,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33540,31.31,0.2,18.3,9018,74.4,NULL,NULL,'IC 2000',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33541,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33541,31.35,0.43,18.6,9018,75,NULL,'MAT, I, cor','IC 2000',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33542,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33542,31.36,0.35,18.7,9018,NULL,NULL,NULL,'IC 2000',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33543,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33543,31.36,0.39,18.7,9018,73,NULL,'opt','IC 2000',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33544,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33544,31.42,0.43,19.2,9018,75,NULL,'3.6 micron, color corrected','IC 2000',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33545,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33545,31.49,0.4,19.9,9018,NULL,NULL,'mean','IC 2000',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33546,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33546,31.52,0.43,20.2,9018,75,NULL,'3.6 micron, color + selection bias corrected','IC 2000',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33547,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33547,32.12,0.46,26.5,9018,NULL,NULL,'J','IC 2000',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33548,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33548,32.31,0.47,28.9,9018,NULL,NULL,'H','IC 2000',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33549,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33549,32.38,0.45,30,9018,NULL,NULL,'K','IC 2000',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33550,'SNII optical','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SN 2007lb',NULL,33550,35.33,0.09,110,9019,NULL,NULL,'SCM 55 SNII','SDSS J034909.44-004408.4',0.06,'2010ApJ...708..661D',2010,1,NULL,NULL,'G',NULL,NULL,'21.2g',NULL,NULL,NULL,NULL,NULL,NULL,1,57.289375,-0.73567,0.541,NULL,36927478081,576991845,9015497,21.2),(33551,'SNII optical','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SN 2007lb',NULL,33551,35.69,0.11,129,9019,NULL,NULL,'SCM 15 SDSS SNII','SDSS J034909.44-004408.4',0.06,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33552,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33552,37.07,0.54,259,9020,70,NULL,NULL,'2MASX J03491065-5606488',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'16.18',0.47,'S0',NULL,NULL,NULL,NULL,1,57.2945,-56.1135,0.033,NULL,35825613366,559775208,8746487,16.18),(33553,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33553,34.56,0.49,81.6,9021,75,NULL,'IR','FGC 0455',NULL,'2011yCatp016004901K',2011,1,0.78,NULL,'G',0.000013,NULL,'16.9',0.11,'Scd',NULL,NULL,NULL,NULL,1,57.3120416667,16.08467,1.049,NULL,65122528086,1017539501,15899054,16.9),(33554,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33554,34.56,0.43,81.8,9021,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0455',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33555,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33555,34.77,0.43,90.1,9021,75,NULL,'3.6 micron, color corrected','FGC 0455',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33556,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33556,34.78,0.2,90.4,9021,74.4,NULL,NULL,'FGC 0455',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33557,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33557,35.62,NULL,133,9021,NULL,NULL,'Dipole + Quadrupole','FGC 0455',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33558,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33558,35.63,NULL,134,9021,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0455',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33559,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33559,35.63,NULL,134,9021,NULL,NULL,'Dipole','FGC 0455',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33560,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33560,35.69,NULL,138,9021,NULL,NULL,NULL,'FGC 0455',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33561,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33561,37.15,0.46,269,9022,70,NULL,NULL,'2MASX J03492156-0510327',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000093,NULL,'16.5g',0.31,'S0^-',NULL,NULL,NULL,NULL,1,57.33975,-5.17586,0.241,NULL,37006947056,578233547,9034899,16.5),(33562,'BL Lac Luminosity','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33562,39.85,NULL,788,9023,NULL,NULL,NULL,'RBS 0476',0.185,'2005ApJ...635..173S',2005,1,NULL,'6dF DR3 has z = 0.032076 +- 0.000150. See 2010MNRAS.401.1151M.','G',0.00012,NULL,'19.1',NULL,'BLLAC',NULL,NULL,NULL,'BL Lac',1,57.346583,-11.99083,0.065,NULL,37017801406,578403146,9037549,19.1),(33563,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33563,37.19,0.89,274,9024,70,NULL,NULL,'2MASX J03492439-0848169',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.000183,NULL,'16.79',0.33,NULL,NULL,NULL,NULL,NULL,1,57.3515417,-8.80467,0.125,NULL,37028382161,578568471,9040132,16.79),(33564,'SNIa SDSS','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SDSS-II SN 18925','RN',33564,41.8,0.16,1680,9025,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 18925',0.362467,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33565,'SNIa SDSS','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SDSS-II SN 18925','RN',33565,41.95,0.22,1800,9025,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 18925',0.362467,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33566,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33566,37.11,0.8,264,9026,70,NULL,NULL,'2MASX J03492901-0801239',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,57.370917,-8.02331,0.137,NULL,37028799345,578574989,9040234,16.5),(33567,'SNIa','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SDSS-II SN 15753','R',33567,39.73,0.31,763,9027,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15753',0.159055,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,57.417125,-0.02792,0.485,NULL,36927202751,576987542,9015430,NULL),(33568,'SNIa','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SDSS-II SN 15753','R',33568,39.98,0.32,856,9027,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15753',0.159055,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33569,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33569,35.89,0.52,151,9028,70,NULL,NULL,'2MASX J03494086-0740110',NULL,'2014MNRAS.445.2677S',2014,1,0.74,NULL,'G',0.000087,NULL,'16.48',0.47,NULL,NULL,NULL,NULL,NULL,1,57.420167,-7.66989,0.141,NULL,37028653724,578572714,9040198,16.48),(33570,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33570,36.13,0.53,168,9029,70,NULL,NULL,'2MASX J03494158-5442042',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.95',0.36,'E',NULL,NULL,NULL,NULL,1,57.4232083,-54.70111,0,NULL,35824471112,559757361,8746208,16.95),(33571,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33571,31.62,0.8,21,9030,75,NULL,'MAT, I','UGCA 085',NULL,'1997ApJS..109..333W',1997,1,3.4,NULL,'G',0.000022,NULL,'14.24',0.5,'Sc: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,57.426083,-26.99342,0,NULL,38526195403,601971803,9405809,14.24),(33572,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33572,31.62,0.8,21.1,9030,75,NULL,'A82, H','UGCA 085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33573,'Tully est','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33573,31.25,0.8,17.8,9030,75,NULL,NULL,'UGCA 085',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33574,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33574,31.26,0.32,17.9,9030,85,NULL,'I, inv','UGCA 085',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33575,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33575,31.28,0.32,18,9030,85,NULL,'I, raw','UGCA 085',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33576,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33576,31.49,0.43,19.9,9030,75,NULL,'MAT, I, inv','UGCA 085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33577,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33577,31.5,0.43,19.9,9030,75,NULL,'MAT, I, raw','UGCA 085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33578,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33578,31.68,0.43,21.6,9030,75,NULL,'MAT, I, cor','UGCA 085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33579,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33579,31.68,0.39,21.7,9030,73,NULL,'IR','UGCA 085',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33580,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33580,31.68,0.4,21.7,9030,75,NULL,NULL,'UGCA 085',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33581,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33581,31.71,0.13,22,9030,NULL,NULL,NULL,'UGCA 085',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33582,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33582,31.73,0.39,22.2,9030,73,NULL,'opt','UGCA 085',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33583,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33583,31.76,0.2,22.5,9030,74.4,NULL,NULL,'UGCA 085',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33584,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33584,31.77,0.43,22.5,9030,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 085',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33585,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33585,31.77,0.38,22.6,9030,NULL,NULL,NULL,'UGCA 085',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33586,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33586,31.79,0.43,22.8,9030,75,NULL,'3.6 micron, color corrected','UGCA 085',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33587,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33587,31.83,0.47,23.2,9030,75,NULL,'A82, H, inv','UGCA 085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33588,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33588,31.9,0.47,24,9030,75,NULL,'A82, H, raw','UGCA 085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33589,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33589,31.95,0.49,24.5,9030,75,NULL,'IR','UGCA 085',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33590,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33590,31.95,0.4,24.6,9030,NULL,NULL,'mean','UGCA 085',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33591,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33591,31.98,0.47,24.9,9030,75,NULL,'A82, H, cor','UGCA 085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33592,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33592,32.42,0.47,30.5,9030,NULL,NULL,'H','UGCA 085',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33593,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33593,32.44,0.46,30.8,9030,NULL,NULL,'J','UGCA 085',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33594,'SNIa','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SN 2009kk',NULL,33594,33.89,0.24,59.1,9031,73.8,NULL,'SALT 2 (SNANA)','2MFGC 03182',0.0125,'2014ApJ...795...44R',2014,1,0.98,NULL,'G',0.00015,NULL,'16.00',0.21,NULL,NULL,NULL,NULL,NULL,1,57.430375,-3.25969,0.281,NULL,37007893494,578248335,9035130,16),(33595,'HII LF','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33595,47.12,0.44,4440,9032,71,NULL,NULL,'PKS 0347-383 C05',3.243,'2005MNRAS.356.1117S',2005,1,NULL,NULL,'QSO',NULL,NULL,'23.82',NULL,'LBG',NULL,NULL,NULL,NULL,1,57.431417,-38.16803,0,NULL,37665425236,588522269,9195660,23.82),(33596,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33596,35.26,0.6,113,9033,NULL,NULL,NULL,'ESO 156- G 017',NULL,'2009ApJS..182..474S',2009,1,1.12,'RC3 gives V = 13316 +- 88 km/sec.','G',0.000033,NULL,'15.38',0.41,'Sb',NULL,NULL,NULL,NULL,1,57.444125,-55.81869,0,NULL,35825266622,559769790,8746402,15.38),(33597,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33597,35.26,0.61,113,9033,NULL,NULL,'Malmquist cor.','ESO 156- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33598,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33598,35.3,0.2,115,9033,74.4,NULL,NULL,'ESO 156- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33599,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33599,31.36,0.8,18.7,9034,75,NULL,'A82, H','ESO 054- G 021',NULL,'1997ApJS..109..333W',1997,1,4.6,'Extended HIPASS source','G',0.00001,NULL,'12.97',2.4,'SAB(rs)dm',NULL,NULL,NULL,NULL,1,57.456,-71.63539,0.229,NULL,36423327158,569114486,8892413,12.97),(33600,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33600,31.38,0.8,18.9,9034,75,NULL,'MAT, I','ESO 054- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33601,'Tully est','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33601,31.06,0.8,16.3,9034,75,NULL,NULL,'ESO 054- G 021',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33602,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33602,30.61,0.66,13.2,9034,NULL,NULL,NULL,'ESO 054- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33603,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33603,30.71,0.35,13.9,9034,NULL,NULL,NULL,'ESO 054- G 021',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33604,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33604,30.72,0.63,13.9,9034,NULL,NULL,'Malmquist cor.','ESO 054- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33605,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33605,30.72,0.4,13.9,9034,73,NULL,'opt','ESO 054- G 021',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33606,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33606,30.74,0.2,14.1,9034,74.4,NULL,NULL,'ESO 054- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33607,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33607,30.92,0.32,15.3,9034,85,NULL,'I, raw','ESO 054- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33608,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33608,30.92,0.32,15.3,9034,85,NULL,'I, inv','ESO 054- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33609,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33609,30.95,0.47,15.5,9034,75,NULL,'A82, H, inv','ESO 054- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33610,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33610,31.03,0.47,16.1,9034,75,NULL,'A82, H, raw','ESO 054- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33611,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33611,31.06,0.43,16.3,9034,75,NULL,'3.6 micron, color corrected','ESO 054- G 021',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33612,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33612,31.18,0.43,17.2,9034,75,NULL,'MAT, I, raw','ESO 054- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33613,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33613,31.21,0.43,17.5,9034,75,NULL,'3.6 micron, color + selection bias corrected','ESO 054- G 021',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33614,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33614,31.24,0.47,17.7,9034,75,NULL,'A82, H, cor','ESO 054- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33615,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33615,31.25,0.43,17.8,9034,75,NULL,'MAT, I, inv','ESO 054- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33616,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33616,31.34,0.43,18.5,9034,75,NULL,'MAT, I, cor','ESO 054- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33617,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33617,38.04,0.46,406,9035,70,NULL,NULL,'SDSS J034950.42-071337.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00006,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,57.4600833333,-7.22719,0.157,NULL,37030156381,578596193,9040565,18.6),(33618,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33618,35.14,0.55,107,9036,70,NULL,NULL,'2MASX J03495084-0337408',NULL,'2014MNRAS.445.2677S',2014,1,0.74,NULL,'G',0.000093,NULL,'16.56',0.65,NULL,NULL,NULL,NULL,NULL,1,57.461833,-3.62789,0.305,NULL,37009680345,578276255,9035566,16.56),(33619,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33619,34.7,0.49,87.2,9037,75,NULL,'IR','UGC 02873',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000017,NULL,'16.0',0.3,'Sb',NULL,NULL,NULL,NULL,1,57.4940417,17.83369,0.833,NULL,68020024628,1062812884,16606451,16),(33620,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33620,35.26,0.4,113,9037,NULL,NULL,'mean','UGC 02873',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33621,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33621,35.5,0.47,126,9037,NULL,NULL,'H','UGC 02873',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33622,'SNIa','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SN 2005mo',NULL,33622,40.01,0.16,789,9038,74.2,NULL,'SALT 2','SDSS J035012.90-001424.8',0.274,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,57.55375,-0.24022,0.481,NULL,36927225159,576987893,9015435,NULL),(33623,'SNIa','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SDSS-II SN 11320','R',33623,40.52,0.13,994,9038,70,NULL,'SDSS CAND. zSNII; MLCS2K2; SN 2005mo','SDSS J035012.90-001424.8',0.28,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33624,'SNIa','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SDSS-II SN 11320','R',33624,40.8,0.23,1130,9038,70,NULL,'SDSS CAND. zSNII; SALT 2; SN 2005mo','SDSS J035012.90-001424.8',0.28,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33625,'SNIa','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SDSS-II SN 16946',NULL,33625,40.48,0.91,1250,9039,70,NULL,'SN photometric redshift distance, z photo =0.350 +/- 0.258','SDSS-II SN 16946',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','21.8g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,57.5614583,-0.46367,0.481,NULL,36927337719,576989651,9015463,21.8),(33626,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33626,36.29,0.8,181,9040,70,NULL,NULL,'2MASX J03503093-2251472',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.000103,NULL,'16.44',0.41,NULL,NULL,NULL,NULL,NULL,1,57.6287917,-22.86333,0.069,NULL,37996523928,593695686,9276495,16.44),(33627,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33627,37.33,0.46,292,9041,70,NULL,NULL,'2MASX J03503135-0520299',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000072,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,57.6305,-5.34181,0.229,NULL,37006515067,578226797,9034793,17.6),(33628,'SNIa','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SDSS-II SN 14907',NULL,33628,40.38,0.93,1190,9042,70,NULL,'SN photometric redshift distance, z photo =0.330 +/- 0.247','SDSS-II SN 14907',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,57.6497917,-0.67686,0.481,NULL,36930185305,577034145,9016158,NULL),(33629,'SNIa','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SDSS-II SN 14231',NULL,33629,38.57,0.54,517,9043,70,NULL,'SN photometric redshift distance, z photo =0.129 +/- 0.040','SDSS-II SN 14231',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,57.6496666667,0.78753,0.541,NULL,65065982615,1016655978,15885249,NULL),(33630,'GCLF','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33630,30.23,0.77,11.1,9044,NULL,NULL,'TOM(g) = -7.2 mag','ESO 359- G 002',NULL,'2010ApJ...717..603V',2010,1,1.3,NULL,'G',0.000007,NULL,'14.2B',0.8,'SB0-?','Group member',NULL,NULL,NULL,1,57.6530416667,-35.90933,0,NULL,38568870333,602638598,9416228,14.2),(33631,'GCLF','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33631,30.48,0.73,12.5,9044,NULL,NULL,'TOM(z) = -8.53 mag','ESO 359- G 002',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33632,'SBF','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33632,31.42,0.14,19.2,9044,74.4,NULL,NULL,'ESO 359- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33633,'SBF','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33633,31.44,0.07,19.4,9044,NULL,NULL,'HST ACS FCS','ESO 359- G 002',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33634,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33634,31.32,0.4,18.4,9044,NULL,NULL,'mean','ESO 359- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33635,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33635,31.67,0.45,21.6,9044,NULL,NULL,'K','ESO 359- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33636,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33636,36.08,0.27,164,9045,70,NULL,NULL,'2MASX J03504193+0102268',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000183,NULL,'16.1g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,57.6747083,1.04075,0.541,NULL,65065545792,1016649153,15885143,16.1),(33637,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33637,34.94,0.54,97.5,9046,70,NULL,NULL,'2MASX J03504778-0701436',NULL,'2014MNRAS.445.2677S',2014,1,0.71,NULL,'G',0.000072,NULL,'15.3g',0.46,'S0',NULL,NULL,NULL,NULL,1,57.6990416667,-7.02878,0.153,NULL,37030058337,578594661,9040541,15.3),(33638,'SNIa','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SDSS-II SN 16172','R',33638,40.36,0.25,968,9047,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J035049.23-001305.6',0.2195,'2014arXiv1401.3317S',2014,1,0.12,NULL,'G',0.0002,NULL,'19.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,57.705167,-0.21825,0.481,NULL,36930120311,577033129,9016142,19.7),(33639,'SNIa','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SDSS-II SN 16172','R',33639,40.41,0.17,991,9047,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J035049.23-001305.6',0.2195,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33640,'SNIa','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SDSS-II SN 16172',NULL,33640,40.46,0.22,1240,9047,70,NULL,'SALT 2','SDSS J035049.23-001305.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33641,'SNIa','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SDSS-II SN 16172',NULL,33641,40.47,0.22,1240,9047,70,NULL,'SALT 2, Malmquist cor.','SDSS J035049.23-001305.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33642,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33642,36.98,0.67,248,9048,70,NULL,NULL,'2MASX J03505184-5506224',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'17.10',0.28,'S0',NULL,NULL,NULL,NULL,1,57.716083,-55.10628,0,NULL,35823927713,559748870,8746076,17.1),(33643,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33643,34.92,0.49,96.5,9049,70,NULL,NULL,'2MASX J03505721-0826216',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.000083,NULL,'16.26',0.48,NULL,NULL,NULL,NULL,NULL,1,57.7384583333,-8.43953,0.133,NULL,37042886438,578795100,9043673,16.26),(33644,'GRB','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33644,47.84,0.46,7530,9050,72,NULL,NULL,'GRB 060210',3.91,'2008JCAP...07..004M',2008,1,NULL,NULL,'VisS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,57.7390417,27.02622,0.349,NULL,68462281153,1069723143,16714424,NULL),(33645,'GRB','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33645,48.08,0.46,8410,9050,70,NULL,NULL,'GRB 060210',3.91,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33646,'GRB','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33646,48.28,0.53,9230,9050,NULL,NULL,NULL,'GRB 060210',3.91,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33647,'GRB','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33647,48.3,0.45,9310,9050,69.7,NULL,'Fiducial','GRB 060210',3.91,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33648,'GRB','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33648,48.59,0.47,10600,9050,69.7,NULL,'Calibrated','GRB 060210',3.91,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33649,'SNIa','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SDSS-II SN 18454','R',33649,41.08,0.27,1220,9051,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18454',0.348546,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,57.7457083,-0.28339,0.481,NULL,36930124312,577033192,9016143,NULL),(33650,'SNIa','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SDSS-II SN 18454','R',33650,41.2,0.35,1290,9051,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18454',0.348546,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33651,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33651,35.93,0.51,153,9052,70,NULL,NULL,'2MASX J03510296-2008209',NULL,'2014MNRAS.445.2677S',2014,1,1.22,NULL,'G',0.0001,NULL,'15.72',0.53,'S0',NULL,NULL,NULL,NULL,1,57.762375,-20.13925,0.081,NULL,37991512556,593617383,9275271,15.72),(33652,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33652,38.5,0.46,501,9053,70,NULL,NULL,'2MASX J03510457-0503300',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000067,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,57.7692083,-5.05822,0.297,NULL,37007353629,578239900,9034998,18.3),(33653,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33653,34.14,0.69,67.3,9054,100,NULL,'mid-IR','CGCG 417-008',NULL,'2013ApJ...771...88L',2013,1,0.7,NULL,'G',0.000167,NULL,'15.24',0.4,'Sm','Isolated galaxy',NULL,NULL,NULL,1,57.791917,3.79508,0.685,NULL,65211737697,1018933401,15920834,15.24),(33654,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33654,34.27,0.55,71.6,9055,NULL,NULL,'Malmquist cor.','UGC 02860',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',NULL,NULL,'16.0',0.4,'Scd:',NULL,NULL,NULL,NULL,1,57.815667,78.29761,0.585,NULL,65762122435,1027533163,16055205,16),(33655,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33655,34.52,0.49,80.1,9055,NULL,NULL,NULL,'UGC 02860',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33656,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33656,34.56,0.2,81.7,9055,74.4,NULL,NULL,'UGC 02860',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33657,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33657,36,0.33,158,9056,70,NULL,NULL,'2MASX J03511737-0053070',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000171,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,57.822333,-0.88519,0.449,NULL,36930629523,577041086,9016266,17.6),(33658,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33658,36,0.33,158,9057,70,NULL,NULL,'2MASX J03511757-0053350',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00015,NULL,'16.92',0.35,NULL,NULL,NULL,NULL,NULL,1,57.8232083,-0.89297,0.449,NULL,36930628976,577041077,9016266,16.92),(33659,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33659,35.93,0.68,154,9058,70,NULL,NULL,'2MASX J03511862-4035058',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'14.8R',0.17,NULL,NULL,NULL,NULL,NULL,1,57.827583,-40.58497,0.029,NULL,37782640288,590353754,9224277,14.8),(33660,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33660,34.36,0.47,74.4,9059,70,NULL,NULL,'ESO 549- G 029',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000083,NULL,'15.18',0.3,'S0',NULL,NULL,NULL,NULL,1,57.836167,-18.30942,0.077,NULL,38042439047,594413110,9287704,15.18),(33661,'SGRB','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33661,38.73,NULL,557,9060,71,NULL,NULL,'GRB 070714B',NULL,'2010ApJ...709..664R',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,57.842625,28.29756,0.401,NULL,68463779020,1069746547,16714789,NULL),(33662,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33662,37.64,0.46,337,9061,70,NULL,NULL,'2MASX J03512358-0109339',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,57.848375,-1.1595,0.473,NULL,36930683256,577041925,9016280,18.1),(33663,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33663,33.6,0.49,52.4,9062,75,NULL,'IR','MCG -01-10-044',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.000023,NULL,'15.1b',0.3,'SBm: sp',NULL,NULL,NULL,NULL,1,57.855,-7.67808,0.157,NULL,37043101077,578798454,9043725,15.1),(33664,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33664,35.92,0.56,153,9063,70,NULL,NULL,'2MASX J03512864-2314137',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.000103,NULL,'16.04',0.48,'S0',NULL,NULL,NULL,NULL,1,57.8692917,-23.23717,0.049,NULL,37997833248,593716144,9276814,16.04),(33665,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33665,36.08,0.27,164,9064,70,NULL,NULL,'IC 1998',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.00014,NULL,'15.2g',0.62,'E0',NULL,NULL,NULL,NULL,1,57.8805,1.18981,0.529,NULL,65066125993,1016658218,15885284,15.2),(33666,'Tully est','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33666,29.83,0.8,9.3,9065,75,NULL,NULL,'ESO 302- G 014',NULL,'1988NBGC.C....0000T',1988,1,1.7,'The APMUKS position is about 4 arcsec northwest of the nucleus.','G',0.00001,NULL,'15.10',1.5,'Im pec',NULL,NULL,NULL,NULL,1,57.920417,-38.45222,0,NULL,37668335117,588567736,9196370,15.1),(33667,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33667,36.08,0.27,164,9066,70,NULL,NULL,'2MASX J03514160+0110242',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,57.9232917,1.17333,0.529,NULL,65066138106,1016658407,15885287,17.5),(33668,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33668,35.05,0.2,102,9067,74.4,NULL,NULL,'UGC 02880',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',NULL,NULL,'16.0',0.2,'Scd:',NULL,NULL,NULL,NULL,1,57.953125,24.89936,0.365,NULL,68460663510,1069697867,16714029,16),(33669,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33669,33.58,0.2,52,9068,74.4,NULL,NULL,'UGC 02878',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000037,NULL,'17.',0.3,'Scd:',NULL,NULL,NULL,NULL,1,57.97325,42.82508,NULL,NULL,68268496732,1066695261,16667113,17),(33670,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33670,33.89,0.49,60.1,9068,75,NULL,'IR','UGC 02878',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33671,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33671,36.54,0.46,203,9069,70,NULL,NULL,'2MASX J03515364-0022383',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00015,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,57.9737083333,-0.37742,0.481,NULL,36929241490,577019398,9015928,16.9),(33672,'BL Lac Luminosity','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33672,39.44,NULL,663,9070,NULL,NULL,NULL,'NVSS J035154-370341',0.165,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.003,NULL,'17.0:',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,57.9772917,-37.06225,0,NULL,37667393981,588553030,9196141,17),(33673,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33673,31.67,0.8,21.5,9071,75,NULL,'MAT, I','IC 2051',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.00002,NULL,'12.32',1.6,'SA(r)c',NULL,NULL,NULL,NULL,1,58.0034583,-83.83069,0.529,NULL,35486059341,554469677,8663588,12.32),(33674,'Sosies','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33674,31.14,0.13,16.9,9071,NULL,NULL,NULL,'IC 2051',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33675,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33675,31.82,0.47,23.2,9071,NULL,NULL,'H','IC 2051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33676,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33676,31.84,0.46,23.4,9071,NULL,NULL,'J','IC 2051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33677,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33677,31.86,0.45,23.6,9071,NULL,NULL,'K','IC 2051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33678,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33678,31.88,0.4,23.7,9071,NULL,NULL,'mean','IC 2051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33679,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33679,32.01,0.4,25.2,9071,NULL,NULL,NULL,'IC 2051',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33680,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33680,32.01,0.39,25.2,9071,73,NULL,'opt','IC 2051',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33681,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33681,32.01,0.43,25.3,9071,75,NULL,'MAT, I, raw','IC 2051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33682,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33682,32.04,0.32,25.6,9071,85,NULL,'I, raw','IC 2051',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33683,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33683,32.07,0.43,26,9071,75,NULL,'3.6 micron, color + selection bias corrected','IC 2051',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33684,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33684,32.1,0.32,26.3,9071,85,NULL,'I, inv','IC 2051',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33685,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33685,32.13,0.43,26.7,9071,75,NULL,'3.6 micron, color corrected','IC 2051',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33686,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33686,32.22,0.43,27.8,9071,75,NULL,'MAT, I, cor','IC 2051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33687,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33687,32.23,0.2,27.9,9071,74.4,NULL,NULL,'IC 2051',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33688,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33688,32.26,0.43,28.3,9071,75,NULL,'MAT, I, inv','IC 2051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33689,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33689,31.73,0.8,22.2,9072,75,NULL,'MAT, I','ESO 359- G 003',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000011,NULL,'14.02',0.7,'Sab: sp','Group member',NULL,NULL,NULL,1,58.003833,-33.46764,0,NULL,38562386969,602537296,9414645,14.02),(33690,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33690,29.93,0.32,9.72,9072,85,NULL,'I, inv','ESO 359- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33691,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33691,30,0.32,10,9072,85,NULL,'I, raw','ESO 359- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33692,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33692,30.29,0.2,11.4,9072,74.4,NULL,NULL,'ESO 359- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33693,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33693,30.47,0.43,12.4,9072,75,NULL,'MAT, I, inv','ESO 359- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33694,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33694,30.46,0.43,12.4,9072,75,NULL,'3.6 micron, color corrected','ESO 359- G 003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33695,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33695,30.56,0.43,13,9072,75,NULL,'3.6 micron, color + selection bias corrected','ESO 359- G 003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33696,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33696,30.64,0.43,13.4,9072,75,NULL,'MAT, I, raw','ESO 359- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33697,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33697,30.68,0.39,13.7,9072,73,NULL,'IR','ESO 359- G 003',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33698,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33698,30.69,0.4,13.7,9072,75,NULL,NULL,'ESO 359- G 003',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33699,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33699,30.97,0.4,15.6,9072,NULL,NULL,NULL,'ESO 359- G 003',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33700,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33700,30.97,0.43,15.6,9072,75,NULL,'MAT, I, cor','ESO 359- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33701,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33701,30.98,0.07,15.7,9072,NULL,NULL,NULL,'ESO 359- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33702,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33702,31.27,0.49,18,9072,75,NULL,'IR','ESO 359- G 003',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33703,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33703,37.98,0.46,395,9073,70,NULL,NULL,'SDSS J035203.99+000212.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,58.016667,0.03681,0.509,NULL,65063846679,1016622604,15884728,18.3),(33704,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33704,31.71,0.49,22,9074,75,NULL,'IR','NGC 1476',NULL,'2011yCatp016004901K',2011,1,1.31,NULL,'G',0.000023,NULL,'13.95',0.44,'Sa? pec',NULL,NULL,NULL,NULL,1,58.036625,-44.53247,0,NULL,37762941400,590045959,9219468,13.95),(33705,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33705,35.53,0.4,128,9075,NULL,NULL,'mean','MCG -02-10-017',NULL,'2007A&A...465...71T',2007,1,0.8,NULL,'G',0.000033,NULL,'14.79',0.3,'SBcd',NULL,NULL,NULL,NULL,1,58.047083,-9.1185,0.117,NULL,37042061754,578782214,9043472,14.79),(33706,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33706,35.59,0.47,131,9075,NULL,NULL,'H','MCG -02-10-017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33707,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33707,35.23,0.46,111,9076,70,NULL,NULL,'NGC 1468',NULL,'2015arXiv151105856S',2015,1,1.22,NULL,'G',0.000132,NULL,'14.1g',0.79,'S0-',NULL,NULL,NULL,NULL,1,58.052417,-6.34894,0.237,NULL,37041010759,578765793,9043215,14.1),(33708,'SNIa','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SDSS-II SN 15170','R',33708,41.84,0.27,1670,9077,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006jx','SN 2006jx',0.395,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ib',NULL,NULL,NULL,NULL,1,58.058583,0.29208,0.521,NULL,65063871701,1016622995,15884734,NULL),(33709,'SNIa','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SDSS-II SN 15170','R',33709,42,0.23,1800,9077,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006jx','SN 2006jx',0.395,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33710,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33710,35.9,0.5,151,9078,70,NULL,NULL,'AM 0350-321',NULL,'2014MNRAS.445.2677S',2014,1,0.79,NULL,'G',0.00015,NULL,'16.0',0.5,'E(M32?)','Group non-member, background',NULL,NULL,NULL,1,58.0683333333,-32.12308,0,NULL,38575566212,602743222,9417862,16),(33711,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33711,36.46,0.51,196,9079,70,NULL,NULL,'2MASX J03521859-5456582',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'16.29',0.48,'S0',NULL,NULL,NULL,NULL,1,58.077917,-54.95,0,NULL,35824382450,559755975,8746187,16.29),(33712,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33712,35.08,0.49,104,9080,70,NULL,NULL,'2MASX J03521869-7031099',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'15.7b',0.3,NULL,NULL,NULL,NULL,NULL,1,58.0780417,-70.51944,0.169,NULL,36417795160,569028049,8891063,15.7),(33713,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33713,36.74,0.83,223,9081,70,NULL,NULL,'2MASX J03522357-1351174',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'17.35',0.24,NULL,NULL,NULL,NULL,NULL,1,58.098125,-13.85483,0.057,NULL,36887389467,576365460,9005710,17.35),(33714,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33714,34.63,0.49,84.2,9082,75,NULL,'IR','UGC 02884',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000011,NULL,'16.5',0.12,'Sc',NULL,NULL,NULL,NULL,1,58.10025,2.35858,0.613,NULL,65064219057,1016628422,15884819,16.5),(33715,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33715,35.23,NULL,111,9082,NULL,NULL,'Dipole + Quadrupole','UGC 02884',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33716,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33716,35.23,NULL,111,9082,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02884',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33717,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33717,35.24,NULL,112,9082,NULL,NULL,'Dipole','UGC 02884',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33718,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33718,37.17,0.46,271,9083,70,NULL,NULL,'2MASX J03522582-0456232',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000083,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,58.1077917,-4.93986,0.297,NULL,37006755452,578230553,9034852,17.6),(33719,'SNIa','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SDSS-II SN 11478',NULL,33719,40.37,0.2,1180,9084,70,NULL,'SN photometric redshift distance, z photo =0.328 +/- 0.039','SDSS-II SN 11478',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','21.2g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,58.1137917,-0.80383,0.449,NULL,36930722945,577042546,9016289,21.2),(33720,'SGRB','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'N',33720,38.73,NULL,557,9085,71,NULL,NULL,'GRB 071227 HOST',NULL,'2010ApJ...709..664R',2010,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33721,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33721,36.72,0.58,221,9086,70,NULL,NULL,'2MASX J03523896-5506212',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.000103,NULL,'16.95',0.23,'S0',NULL,NULL,NULL,NULL,1,58.1624166667,-55.10594,0,NULL,35823884481,559748195,8746065,16.95),(33722,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33722,36.14,0.52,169,9087,70,NULL,NULL,'2MASX J03524525-5448543',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.85',0.4,'S0:',NULL,NULL,NULL,NULL,1,58.188625,-54.815,0,NULL,35824597565,559759336,8746239,16.85),(33723,'Tully est','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33723,30.48,0.8,12.5,9088,75,NULL,NULL,'NGC 1483',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.000003,NULL,'13.11',1.3,'SB(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,58.1985,-47.47753,0,NULL,37767530786,590117668,9220588,13.11),(33724,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33724,31.36,0.4,18.7,9088,NULL,NULL,'mean','NGC 1483',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33725,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33725,31.87,0.47,23.6,9088,NULL,NULL,'H','NGC 1483',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33726,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33726,31.93,0.45,24.4,9088,NULL,NULL,'K','NGC 1483',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33727,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33727,31.94,0.46,24.4,9088,NULL,NULL,'J','NGC 1483',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33728,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33728,35.13,0.2,106,9089,74.4,NULL,NULL,'CGCG 417-009',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',NULL,NULL,'15.34',0.5,'IB?',NULL,NULL,NULL,NULL,1,58.2205833333,7.05739,0.525,NULL,65228763223,1019199425,15924991,15.34),(33729,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33729,32.27,0.43,28.5,9090,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J03525618+4006457',NULL,'2014MNRAS.444..527S',2014,1,0.56,NULL,'G',0.00003,NULL,'10.8K',0.22,'S',NULL,NULL,NULL,NULL,1,58.234125,40.11281,2.009,NULL,68384322126,1068505033,16695391,10.8),(33730,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33730,33.3,0.69,45.6,9090,100,NULL,'mid-IR','2MASX J03525618+4006457',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33731,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33731,35.98,0.59,157,9091,70,NULL,NULL,'2MASX J03525795-1801132',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'17.23',0.24,NULL,NULL,NULL,NULL,NULL,1,58.2415,-18.02042,0.037,NULL,38008807984,593887624,9279494,17.23),(33732,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33732,37.32,0.46,292,9092,70,NULL,NULL,'2MASX J03525990-0450565',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000072,NULL,'18.2g',0.18,'NLAGN',NULL,NULL,NULL,'Sy 2',1,58.249625,-4.84911,0.221,NULL,37004800501,578200007,9034375,18.2),(33733,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33733,37.1,0.46,263,9093,70,NULL,NULL,'2MASX J03530226+0042002',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000104,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,58.259583,0.70003,0.569,NULL,65063880492,1016623132,15884736,18.3),(33734,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33734,36.82,0.46,231,9094,70,NULL,NULL,'2MASX J03530941-0652039',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000071,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,58.289125,-6.86783,0.161,NULL,37041825539,578778524,9043414,17.2),(33735,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33735,38.62,0.46,530,9095,70,NULL,NULL,'SDSS J035314.47-064331.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000077,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,58.3103333333,-6.72536,0.169,NULL,37041143133,578767861,9043247,18.2),(33736,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33736,36.7,0.46,219,9096,70,NULL,NULL,'2MASX J03531611-0510241',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000091,NULL,'16.5g',0.32,'E0',NULL,NULL,NULL,NULL,1,58.3172916667,-5.17339,0.289,NULL,37004861072,578200954,9034389,16.5),(33737,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33737,37.32,0.46,292,9097,70,NULL,NULL,'SDSS J035318.54+001531.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000197,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,58.3272917,0.25881,0.629,NULL,65063983443,1016624741,15884761,18.5),(33738,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33738,32.86,0.2,37.3,9098,74.4,NULL,NULL,'UGC 02888',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'15.0',0.7,'S?',NULL,NULL,NULL,NULL,1,58.3299583,32.33008,0.565,NULL,68476976850,1069952763,16718011,15),(33739,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33739,32.96,0.81,39,9098,NULL,NULL,NULL,'UGC 02888',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33740,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33740,33.33,0.68,46.3,9098,NULL,NULL,'Malmquist cor.','UGC 02888',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33741,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33741,33.57,0.47,51.9,9098,NULL,NULL,'H','UGC 02888',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33742,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33742,33.63,0.45,53.2,9098,NULL,NULL,'K','UGC 02888',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33743,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33743,33.66,0.4,54,9098,NULL,NULL,'mean','UGC 02888',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33744,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33744,33.71,0.46,55.3,9098,NULL,NULL,'J','UGC 02888',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33745,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33745,37.03,0.62,254,9099,70,NULL,NULL,'2MASX J03532389-1756307',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.35',0.4,'S',NULL,NULL,NULL,NULL,1,58.3495417,-17.94183,0.037,NULL,36880579562,576259055,9004047,16.35),(33746,'SGRB','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33746,42.78,NULL,3600,9100,70,NULL,'Photometric Distance, Host A, M(R) = -20 mag and spectral slope Beta = 1.0 ','GRB 060211A',NULL,'2012A&A...545A..77R',2012,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,58.385833,21.48867,0.581,NULL,67994181479,1062409085,16600141,NULL),(33747,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33747,34.39,0.4,75.5,9101,NULL,NULL,'mean','NGC 1490',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000026,NULL,'13.40',1.1,'E',NULL,NULL,NULL,NULL,1,58.392583,-66.01806,0.189,NULL,36466561484,569790023,8902969,13.4),(33748,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33748,34.43,0.45,76.8,9101,NULL,NULL,'K','NGC 1490',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33749,'Tully est','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33749,31.27,0.8,18,9102,75,NULL,NULL,'IC 2009',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.000007,NULL,'15.98',1.1,'SB(s)m',NULL,NULL,NULL,NULL,1,58.3952083,-48.98947,0,NULL,37779638778,590306855,9223544,15.98),(33750,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33750,34.37,0.4,75,9103,NULL,NULL,'mean','UGC 02889',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000033,NULL,'14.8',0.8,'SABbc:',NULL,NULL,NULL,NULL,1,58.4062917,37.26411,1.345,NULL,68352234769,1068003668,16687557,14.8),(33751,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33751,34.74,0.47,88.7,9103,NULL,NULL,'H','UGC 02889',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33752,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33752,35.99,0.53,158,9104,70,NULL,NULL,'2MASX J03534666-5532220',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.000103,NULL,'17.19',0.3,'RS',NULL,NULL,NULL,NULL,1,58.444375,-55.53936,0,NULL,35827743709,559808495,8747007,17.19),(33753,'GRB','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33753,41.9,NULL,2390,9105,70,NULL,'Pseudo z = 0.88','GRB 021104',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,58.45,37.95,1.701,NULL,68354415747,1068037746,16688089,NULL),(33754,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33754,35.69,0.52,137,9106,70,NULL,NULL,'NGC 1475',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.000093,NULL,'15.7b',0.63,'S0-:',NULL,NULL,NULL,NULL,1,58.457625,-8.1375,0.173,NULL,37044088072,578813876,9043966,15.7),(33755,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33755,34.08,NULL,65.5,9107,NULL,NULL,'B','ESO 549- G 030',NULL,'2005Ap&SS.298..577R',2005,1,1.2,NULL,'G',0.000033,NULL,'14.77',0.5,'Sb','in a pair',NULL,NULL,NULL,1,58.4730417,-17.59358,0.025,NULL,36880645419,576260084,9004063,14.77),(33756,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33756,34.08,NULL,65.5,9107,NULL,NULL,'I','ESO 549- G 030',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33757,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33757,35.16,0.37,108,9107,NULL,NULL,NULL,'ESO 549- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33758,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33758,35.2,0.2,110,9107,74.4,NULL,NULL,'ESO 549- G 030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33759,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33759,35.49,0.32,125,9107,NULL,NULL,'Malmquist cor.','ESO 549- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33760,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33760,35.34,0.49,117,9108,70,NULL,NULL,'2MASX J03535654-0704221',NULL,'2014MNRAS.445.2677S',2014,1,1.01,NULL,'G',0.000105,NULL,'15.0g',0.35,'Sa(f)',NULL,NULL,NULL,NULL,1,58.485625,-7.07297,0.157,NULL,37041562106,578774407,9043350,15),(33761,'SNIa','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SDSS-II SN 15055',NULL,33761,39.71,0.22,874,9109,70,NULL,'SN photometric redshift distance, z photo =0.230 +/- 0.029','SDSS-II SN 15055',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,58.499167,-0.05169,0.497,NULL,36928826034,577012906,9015826,NULL),(33762,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33762,36.86,0.71,236,9110,70,NULL,NULL,'6dF J0353597-234917',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'16.25',0.42,'S0',NULL,NULL,NULL,NULL,1,58.49925,-23.82128,0.069,NULL,37998104731,593720386,9276881,16.25),(33763,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33763,34.98,0.49,98.9,9111,70,NULL,NULL,'2MASX J03540687-0222324',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.000137,NULL,'16.57',0.53,NULL,NULL,NULL,NULL,NULL,1,58.528833,-2.37567,0.561,NULL,36927831572,576997368,9015583,16.57),(33764,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33764,34.05,0.69,64.6,9112,100,NULL,'mid-IR','UGC 02894',NULL,'2013ApJ...771...88L',2013,1,1,NULL,'G',0.000017,NULL,'15.14',0.7,'Scd:','Pair member (points to parent)',NULL,NULL,NULL,1,58.5320416667,15.99014,1.057,NULL,65123205588,1017550087,15899220,15.14),(33765,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33765,30.75,0.8,14.1,9113,75,NULL,'MAT, I','NGC 1484',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.00001,NULL,'13.93',0.6,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,58.583875,-36.96889,0,NULL,37667984332,588562255,9196285,13.93),(33766,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33766,30.73,0.43,14,9113,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1484',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33767,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33767,30.81,0.43,14.5,9113,75,NULL,'3.6 micron, color corrected','NGC 1484',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33768,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33768,30.85,0.2,14.8,9113,74.4,NULL,NULL,'NGC 1484',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33769,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33769,30.86,0.4,14.9,9113,NULL,NULL,NULL,'NGC 1484',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33770,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33770,30.87,0.4,14.9,9113,73,NULL,'opt','NGC 1484',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33771,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33771,30.92,0.32,15.3,9113,85,NULL,'I, inv','NGC 1484',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33772,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33772,30.95,0.32,15.5,9113,85,NULL,'I, raw','NGC 1484',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33773,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33773,31.32,0.43,18.4,9113,75,NULL,'MAT, I, inv','NGC 1484',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33774,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33774,31.34,0.43,18.6,9113,75,NULL,'MAT, I, raw','NGC 1484',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33775,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33775,31.38,0.09,18.9,9113,NULL,NULL,NULL,'NGC 1484',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33776,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33776,31.53,0.43,20.2,9113,75,NULL,'MAT, I, cor','NGC 1484',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33777,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33777,36.59,0.58,208,9114,70,NULL,NULL,'2MASX J03542313-2215000',NULL,'2014MNRAS.445.2677S',2014,1,0.27,NULL,'G',0.000083,NULL,'16.34',0.18,NULL,NULL,NULL,NULL,NULL,1,58.596417,-22.25022,0.077,NULL,38000179716,593752808,9277387,16.34),(33778,'SNIa','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SDSS-II SN 16052','R',33778,39.17,0.21,597,9115,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16052',0.1444,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,58.6002083,-0.72081,0.657,NULL,36929637857,577025591,9016024,NULL),(33779,'SNIa','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SDSS-II SN 16052','R',33779,39.18,0.11,599,9115,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16052',0.1444,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33780,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33780,33.55,0.49,51.2,9116,75,NULL,'IR','UGC 02899',NULL,'2011yCatp016004901K',2011,1,1.53,NULL,'G',0.00001,NULL,'16.0',0.17,'Scd',NULL,NULL,NULL,NULL,1,58.602625,6.58989,0.517,NULL,65220208022,1019065750,15922902,16),(33781,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33781,34.13,NULL,66.9,9116,NULL,NULL,'Dipole','UGC 02899',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33782,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33782,34.13,NULL,67.1,9116,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02899',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33783,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33783,34.13,NULL,67.1,9116,NULL,NULL,'Dipole + Quadrupole','UGC 02899',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33784,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33784,34.22,NULL,69.7,9116,NULL,NULL,NULL,'UGC 02899',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33785,'SNIa','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SN 2009D',NULL,33785,35.06,0.11,97.9,9117,72,NULL,NULL,'ESO 549- G 031',0.02467,'2013ApJ...773...53F',2013,1,1.1,NULL,'G',0.000033,NULL,'14.69',0.5,'Sb',NULL,NULL,NULL,NULL,1,58.6027917,-19.19031,0.033,NULL,37988803179,593575049,9274610,14.69),(33786,'SNIa','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SN 2009D',NULL,33786,35.06,0.2,100,9117,73.8,NULL,'SALT 2 (SNANA)','ESO 549- G 031',0.0245,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33787,'SNIa','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SN 2009D','R',33787,35.02,0.06,101,9117,NULL,NULL,'MLCS2k2, R(V) = 1.8','ESO 549- G 031',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33788,'SNIa','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SN 2009D','R',33788,35.06,0.07,103,9117,NULL,NULL,'MLCS2k2, R(V) = 3.1','ESO 549- G 031',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33789,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33789,34.16,NULL,67.9,9117,NULL,NULL,'B','ESO 549- G 031',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33790,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33790,34.16,NULL,67.9,9117,NULL,NULL,'I','ESO 549- G 031',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33791,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33791,35.04,0.49,102,9117,NULL,NULL,NULL,'ESO 549- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33792,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33792,35.18,0.2,109,9117,74.4,NULL,NULL,'ESO 549- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33793,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33793,35.4,0.42,120,9117,NULL,NULL,'Malmquist cor.','ESO 549- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33794,'GCLF','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33794,31.28,0.09,18,9118,NULL,NULL,'TOM(g) = -7.2 mag','IC 2006',NULL,'2010ApJ...717..603V',2010,1,2.1,NULL,'G',0.000011,NULL,'12.2B',1.8,'E','Possible group member',NULL,NULL,NULL,1,58.6185417,-35.96714,0,NULL,37678543637,588727244,9198863,12.2),(33795,'GCLF','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33795,31.47,0.09,19.7,9118,NULL,NULL,'TOM(z) = -8.53 mag','IC 2006',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33796,'SBF','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33796,31.43,0.29,19.3,9118,NULL,NULL,'I','IC 2006',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33797,'SBF','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33797,31.51,0.14,20,9118,74.4,NULL,NULL,'IC 2006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33798,'SBF','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33798,31.53,0.09,20.2,9118,NULL,NULL,'HST ACS FCS','IC 2006',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33799,'SBF','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33799,31.54,0.08,20.3,9118,NULL,NULL,'I','IC 2006',NULL,'2010ApJ...724..657B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33800,'SBF','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33800,31.59,0.29,20.8,9118,NULL,NULL,NULL,'IC 2006',NULL,'2001ApJ...550..503J',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33801,'SBF','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33801,31.59,0.29,20.8,9118,NULL,NULL,'I','IC 2006',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33802,'SBF','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33802,31.59,0.29,20.8,9118,NULL,NULL,NULL,'IC 2006',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33803,'SBF','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33803,31.6,0.11,20.9,9118,NULL,NULL,'KS','IC 2006',NULL,'2002ApJ...564..216L',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33804,'SBF','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33804,31.66,0.29,21.5,9118,NULL,NULL,'Malmquist cor.','IC 2006',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33805,'GC radius','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33805,31.21,0.14,17.5,9118,NULL,NULL,'HST ACS FCS','IC 2006',NULL,'2010ApJ...715.1419M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33806,'D-Sigma','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33806,31.26,0.4,17.8,9118,75,NULL,'Edat, raw','IC 2006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33807,'D-Sigma','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33807,31.29,0.4,18.1,9118,75,NULL,'Edat, cor','IC 2006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33808,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33808,31.19,0.41,17.3,9118,NULL,NULL,NULL,'IC 2006',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33809,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33809,31.4,0.41,19.1,9118,NULL,NULL,'Malmquist cor.','IC 2006',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33810,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33810,31.48,NULL,19.8,9118,NULL,NULL,NULL,'IC 2006',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33811,'Tully est','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33811,30.98,0.8,15.7,9118,75,NULL,'B','IC 2006',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33812,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33812,31.33,0.4,18.5,9118,NULL,NULL,'mean','IC 2006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33813,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33813,31.68,0.45,21.7,9118,NULL,NULL,'K','IC 2006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33814,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33814,35.7,0.5,138,9119,70,NULL,NULL,'2MASX J03543275-2704547',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,58.6365416667,-27.08183,0,NULL,38536607902,602134498,9408351,14.5),(33815,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33815,34.2,0.48,69.3,9120,70,NULL,NULL,'MCG -01-10-046',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00012,NULL,'15',0.3,NULL,NULL,NULL,NULL,NULL,1,58.63875,-2.91797,0.565,NULL,36941342817,577208481,9018882,15),(33816,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33816,36.42,0.66,193,9121,70,NULL,NULL,'2MASX J03543507-7159439',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'16.8b',0.18,NULL,NULL,NULL,NULL,NULL,1,58.6461666667,-71.99556,0.225,NULL,36422684724,569104448,8892257,16.8),(33817,'Tully est','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33817,31.46,0.8,19.6,9122,75,NULL,NULL,'NGC 1482',NULL,'1988NBGC.C....0000T',1988,1,2.5,NULL,'G',0.00013,NULL,'13.10',1.4,'SA0+ pec sp    HII','in a triple',NULL,NULL,NULL,1,58.662333,-20.50267,0.065,NULL,37991909397,593623584,9275368,13.1),(33818,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33818,34.42,0.69,76.7,9123,100,NULL,'mid-IR','CGCG 417-010',NULL,'2013ApJ...771...88L',2013,1,1,NULL,'G',0.000093,NULL,'15.13',0.6,NULL,NULL,NULL,NULL,NULL,1,58.69975,6.26292,0.589,NULL,65220258185,1019066534,15922914,15.13),(33819,'SNIa','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SDSS-II SN 19461',NULL,33819,39.82,0.26,920,9124,70,NULL,'SN photometric redshift distance, z photo =0.244 +/- 0.036','SDSS-II SN 19461',NULL,'2011ApJ...738..162S',2011,1,0.13,NULL,'G',NULL,'PHOT','20.6g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,58.7022083,-0.71144,0.657,NULL,36929642062,577025657,9016025,20.6),(33820,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33820,33.99,0.49,62.7,9125,75,NULL,'IR','ESO 083- G 012',NULL,'2011yCatp016004901K',2011,1,1.8,NULL,'G',0.0001,NULL,'14.73',0.2,'Sb?',NULL,NULL,NULL,NULL,1,58.736417,-65.94522,0.169,NULL,36466566738,569790105,8902970,14.73),(33821,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33821,34.41,0.4,76.4,9125,NULL,NULL,'mean','ESO 083- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33822,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33822,34.47,0.47,78.3,9125,NULL,NULL,'H','ESO 083- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33823,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33823,34.56,0.46,81.8,9125,NULL,NULL,'J','ESO 083- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33824,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33824,34.59,0.45,82.6,9125,NULL,NULL,'K','ESO 083- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33825,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33825,32.95,0.43,39,9126,75,NULL,'3.6 micron, color + selection bias corrected','ESO 549- G 035',NULL,'2014MNRAS.444..527S',2014,1,1.4,NULL,'G',0.0001,NULL,'15.51',1,'Sc','in a triple',NULL,NULL,NULL,1,58.7664583,-20.3835,0.065,NULL,37991924301,593623817,9275372,15.51),(33826,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33826,35.51,0.4,126,9127,NULL,NULL,'mean','ESO 549- G 036',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000013,NULL,'14.64',0.8,'SB(rs)c:;Sy2  LINER?','in a pair',NULL,NULL,'Sy 2',1,58.788667,-17.46947,0.037,NULL,36898152638,576533634,9008338,14.64),(33827,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33827,35.52,0.2,127,9127,74.4,NULL,NULL,'ESO 549- G 036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33828,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33828,35.89,0.52,150,9127,NULL,NULL,'Malmquist cor.','ESO 549- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33829,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33829,35.89,0.52,150,9127,NULL,NULL,NULL,'ESO 549- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33830,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33830,35.88,0.45,150,9127,NULL,NULL,'K','ESO 549- G 036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33831,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33831,35.89,0.47,151,9127,NULL,NULL,'H','ESO 549- G 036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33832,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33832,35.9,0.46,152,9127,NULL,NULL,'J','ESO 549- G 036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33833,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33833,37.32,0.33,290,9128,70,NULL,NULL,'2MASX J03551526-0520396',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000091,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,58.8137083,-5.34436,0.237,NULL,37005034083,578203657,9034432,17),(33834,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33834,31.71,0.4,21.9,9129,NULL,NULL,'mean','IC 2007',NULL,'2007A&A...465...71T',2007,1,1.3,'Position in 1997AJ....113.1548C is incorrect.','G',0.000017,NULL,'13.68',0.8,'SB(rs)c:       HII',NULL,NULL,NULL,NULL,1,58.8448333333,-28.15833,0,NULL,38533556833,602086825,9407606,13.68),(33835,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33835,31.74,0.47,22.3,9129,NULL,NULL,'H','IC 2007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33836,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33836,31.79,0.46,22.8,9129,NULL,NULL,'J','IC 2007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33837,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33837,31.81,0.45,23,9129,NULL,NULL,'K','IC 2007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33838,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33838,34.43,1.01,76.7,9130,NULL,NULL,NULL,'ESO 201- G 011',NULL,'2009ApJS..182..474S',2009,1,1.13,'RC3 gives V = 13820 +- 88 km/sec.','G',0.000033,NULL,'15.51',0.49,'S?',NULL,NULL,NULL,NULL,1,58.9125833333,-51.50772,0,NULL,37775730502,590245789,9222590,15.51),(33839,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33839,34.47,0.2,78.3,9130,74.4,NULL,NULL,'ESO 201- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33840,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33840,34.68,0.89,86.5,9130,NULL,NULL,'Malmquist cor.','ESO 201- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33841,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33841,37.88,0.46,377,9131,70,NULL,NULL,'2MASX J03553916-0651078',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00009,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,58.9132916667,-6.85228,0.181,NULL,37037097973,578704655,9042260,17.9),(33842,'Tully est','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33842,29.74,0.8,8.9,9132,75,NULL,'B','NGC 1487',NULL,'1988NBGC.C....0000T',1988,1,NULL,'Position in 1997AJ....113.1548C is incorrect.','GPair',0.000003,NULL,NULL,NULL,'Pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,58.942083,-42.36806,0,NULL,37783560977,590368140,9224502,NULL),(33843,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33843,36.43,0.46,194,9133,70,NULL,NULL,'2MASX J03554621-0546014',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000071,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,58.942583,-5.76714,0.153,NULL,37004762299,578199410,9034365,17.8),(33844,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33844,37.32,0.33,290,9134,70,NULL,NULL,'2MASX J03554967-0517334',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000092,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,58.957,-5.29267,0.237,NULL,37006220651,578222197,9034721,16.8),(33845,'SNII optical','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SN 2009bw',NULL,33845,30.5,0.02,12.6,9135,NULL,NULL,'EPM, H01','UGC 02890',NULL,'2014ApJ...782...98B',2014,1,2.8,NULL,'G',0.00002,NULL,'14.3',0.5,'Sdm pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,59.0171666667,72.92136,0.841,NULL,66401110767,1037517355,16211208,14.3),(33846,'SNII optical','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SN 2009bw',NULL,33846,30.78,0.05,14.3,9135,NULL,NULL,'SCM','UGC 02890',NULL,'2015ApJ...799..215P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33847,'SNII optical','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SN 2009bw',NULL,33847,31.01,0.04,15.9,9135,NULL,NULL,'EPM, D05','UGC 02890',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33848,'SNII optical','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SN 2009bw',NULL,33848,31.14,0.13,16.9,9135,NULL,NULL,'V, photospheric magnitude method','UGC 02890',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33849,'SNII optical','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SN 2009bw',NULL,33849,31.17,0.08,17.1,9135,NULL,NULL,'I, photospheric magnitude method','UGC 02890',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33850,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33850,29.88,0.2,9.46,9135,74.4,NULL,NULL,'UGC 02890',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33851,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33851,30.23,0.4,11.1,9135,NULL,NULL,NULL,'UGC 02890',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33852,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33852,30.23,0.39,11.1,9135,73,NULL,'opt','UGC 02890',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33853,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33853,35.38,0.47,119,9136,70,NULL,NULL,'2MASX J03561276-5549012',NULL,'2014MNRAS.445.2677S',2014,1,0.98,NULL,'G',0.00015,NULL,'15.08',0.57,'SAB0-:',NULL,NULL,NULL,NULL,1,59.05325,-55.817,0,NULL,35826825253,559794144,8746783,15.08),(33854,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33854,34.2,NULL,69.2,9137,NULL,NULL,'B','NGC 1486',NULL,'2005Ap&SS.298..577R',2005,1,0.9,NULL,'G',0.000033,NULL,'14.90',0.5,'Sbc: pec',NULL,NULL,NULL,NULL,1,59.077917,-21.82114,0.085,NULL,37998672528,593729258,9277019,14.9),(33855,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33855,34.2,NULL,69.2,9137,NULL,NULL,'I','NGC 1486',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33856,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33856,35.03,0.61,101,9137,NULL,NULL,NULL,'NGC 1486',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33857,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33857,35.07,0.2,103,9137,74.4,NULL,NULL,'NGC 1486',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33858,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33858,35.38,0.52,119,9137,NULL,NULL,'Malmquist cor.','NGC 1486',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33859,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33859,36.12,0.49,167,9138,70,NULL,NULL,'2MASX J03562466-7149233',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.8b',0.32,NULL,NULL,NULL,NULL,NULL,1,59.1027917,-71.82311,0.269,NULL,36422771381,569105802,8892278,15.8),(33860,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33860,34.71,1.05,87.4,9139,NULL,NULL,NULL,'ESO 549- G 038',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000033,NULL,'14.76',0.8,'SA(r)bc?',NULL,NULL,NULL,NULL,1,59.156,-18.06167,0.025,NULL,36898225696,576534776,9008355,14.76),(33861,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33861,34.75,0.2,89.1,9139,74.4,NULL,NULL,'ESO 549- G 038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33862,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33862,35.07,0.88,103,9139,NULL,NULL,'Malmquist cor.','ESO 549- G 038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33863,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33863,34.71,0.5,87.4,9140,70,NULL,NULL,'ESO 549- G 039',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000083,NULL,'15.30',0.2,'S0',NULL,NULL,NULL,NULL,1,59.175667,-18.61919,0.021,NULL,36852141618,575814712,8997104,15.3),(33864,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33864,35.51,0.71,127,9141,70,NULL,NULL,'2MASX J03564520-0129175',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,59.188417,-1.48817,0.873,NULL,36940648219,577197628,9018712,15.5),(33865,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33865,37.29,0.17,287,9142,70,NULL,NULL,'2MASX J03564734-0512585',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000071,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,59.1972917,-5.21628,0.245,NULL,37006296112,578223376,9034740,17.3),(33866,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33866,37.29,0.17,287,9143,70,NULL,NULL,'2MASX J03565261-0517041',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000087,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,59.2192917,-5.28456,0.245,NULL,37006118582,578220602,9034696,17.5),(33867,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33867,35.53,0.43,128,9144,NULL,NULL,NULL,'2MASX J03565569-5224077',NULL,'2009ApJS..182..474S',2009,1,0.75,NULL,'G',0.000023,NULL,'16.04',0.37,'Irr',NULL,NULL,NULL,NULL,1,59.232,-52.40217,0,NULL,37740935344,589702114,9214095,16.04),(33868,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33868,35.57,0.2,130,9144,74.4,NULL,NULL,'2MASX J03565569-5224077',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33869,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33869,35.72,0.39,139,9144,NULL,NULL,'Malmquist cor.','2MASX J03565569-5224077',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33870,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33870,34.32,0.2,73.1,9145,74.4,NULL,NULL,'UGC 02904',NULL,'2013AJ....146...86T',2013,1,1.9,NULL,'G',0.000013,NULL,'14.8',1.6,'Sb:','Pair member (points to parent)',NULL,NULL,NULL,1,59.2415833333,16.48461,0.985,NULL,65156065998,1018063531,15907242,14.8),(33871,'Brightest Stars','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33871,28.74,NULL,5.6,9146,NULL,NULL,'LF','UGC 02905',NULL,'1997AstL...23..514G',1997,1,0.9,'KPG lists velocity as 7740 +- 100 km/sec.','G',0.000003,NULL,'15.31',0.6,'Im:','Pair member (points to parent)',NULL,NULL,NULL,1,59.250583,16.52244,0.985,NULL,65156073325,1018063645,15907244,15.31),(33872,'Brightest Stars','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33872,28.83,0.4,5.83,9146,NULL,NULL,'3B + 3R mean','UGC 02905',NULL,'1997AstL...23..514G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33873,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33873,29.55,0.2,8.13,9146,74.4,NULL,NULL,'UGC 02905',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33874,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33874,37.29,0.17,287,9147,70,NULL,NULL,'2MASX J03570292-0520231',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000116,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,59.2622083,-5.33967,0.245,NULL,37005642483,578213163,9034580,17),(33875,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33875,32.48,0.49,31.3,9148,75,NULL,'IR','ESO 419- G 012',NULL,'2011yCatp016004901K',2011,1,1.8,NULL,'G',0.00004,NULL,'14.15',0.3,'Sa: sp',NULL,NULL,NULL,NULL,1,59.292333,-28.87719,0,NULL,38532123798,602064434,9407256,14.15),(33876,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33876,34.89,0.8,95.3,9149,75,NULL,'MAT, I','ESO 549- G 040',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'13.99',0.5,'Sb-c           HII',NULL,NULL,NULL,NULL,1,59.292875,-18.77761,0.017,NULL,36852093087,575813954,8997093,13.99),(33877,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33877,34.61,NULL,83.6,9149,NULL,NULL,'B','ESO 549- G 040',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33878,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33878,34.61,NULL,83.6,9149,NULL,NULL,'I','ESO 549- G 040',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33879,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33879,34.83,0.47,92.5,9149,NULL,NULL,'H','ESO 549- G 040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33880,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33880,34.85,0.43,93.2,9149,75,NULL,'MAT, I, raw','ESO 549- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33881,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33881,34.88,0.46,94.5,9149,NULL,NULL,'J','ESO 549- G 040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33882,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33882,34.9,0.45,95.3,9149,NULL,NULL,'K','ESO 549- G 040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33883,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33883,35.03,0.32,101,9149,85,NULL,'I, raw','ESO 549- G 040',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33884,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33884,35.07,0.4,103,9149,NULL,NULL,'mean','ESO 549- G 040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33885,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33885,35.12,0.32,106,9149,85,NULL,'I, inv','ESO 549- G 040',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33886,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33886,35.19,0.43,109,9149,75,NULL,'MAT, I, inv','ESO 549- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33887,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33887,35.23,0.43,111,9149,75,NULL,'MAT, I, cor','ESO 549- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33888,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33888,35.48,0.24,125,9149,NULL,NULL,NULL,'ESO 549- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33889,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33889,35.52,0.2,127,9149,74.4,NULL,NULL,'ESO 549- G 040',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33890,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33890,35.58,0.23,131,9149,NULL,NULL,'Malmquist cor.','ESO 549- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33891,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33891,37.29,0.17,287,9150,70,NULL,NULL,'2MASXi J0357113-052147',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000086,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,59.2974166667,-5.36314,0.245,NULL,37005655635,578213369,9034583,17.3),(33892,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33892,33.84,0.8,58.7,9151,75,NULL,'MAT, I','ESO 483- G 002',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.80',0.6,'SB(s)c',NULL,NULL,NULL,NULL,1,59.3037083333,-25.39772,0,NULL,38535355578,602114930,9408045,14.8),(33893,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33893,32.95,0.32,38.9,9151,85,NULL,'I, inv','ESO 483- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33894,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33894,32.96,0.32,39,9151,85,NULL,'I, raw','ESO 483- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33895,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33895,33.35,0.43,46.7,9151,75,NULL,'MAT, I, raw','ESO 483- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33896,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33896,33.39,0.43,47.6,9151,75,NULL,'MAT, I, inv','ESO 483- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33897,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33897,33.42,0.68,48.2,9151,NULL,NULL,'Malmquist cor.','ESO 483- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33898,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33898,33.53,0.65,50.9,9151,NULL,NULL,NULL,'ESO 483- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33899,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33899,33.57,0.2,51.8,9151,74.4,NULL,NULL,'ESO 483- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33900,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33900,33.68,0.43,54.6,9151,75,NULL,'MAT, I, cor','ESO 483- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33901,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33901,34.9,0.53,95.5,9152,70,NULL,NULL,'2MASX J03571597-6113464',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,59.3167083333,-61.22961,0.017,NULL,35788891290,559201426,8737522,14.3),(33902,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33902,37.29,0.17,287,9153,70,NULL,NULL,'2MASX J03571632-0522170',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000089,NULL,'15.8g',0.46,'E0',NULL,NULL,NULL,NULL,1,59.318,-5.37153,0.245,NULL,37005652423,578213319,9034583,15.8),(33903,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33903,30.27,0.4,11.3,9154,75,NULL,'B','NGC 1493',NULL,'1988NBGC.C....0000T',1988,1,3.5,NULL,'G',0.000003,NULL,'11.78',3.2,'SB(rs)cd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,59.3642917,-46.21069,0,NULL,37760566489,590008851,9218888,11.78),(33904,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33904,37.29,0.17,287,9155,70,NULL,NULL,'2MASX J03572755-0525458',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000086,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,59.364875,-5.42939,0.269,NULL,37005675076,578213673,9034588,17.2),(33905,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33905,32.75,0.49,35.5,9156,75,NULL,'IR','FGC 0459',NULL,'2011yCatp016004901K',2011,1,1.46,NULL,'G',0.000053,NULL,'15.7',0.19,'Sm',NULL,NULL,NULL,NULL,1,59.3655417,-3.25025,0.449,NULL,36933853136,577091455,9017053,15.7),(33906,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33906,33.14,NULL,42.4,9156,NULL,NULL,NULL,'FGC 0459',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33907,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33907,33.78,NULL,56.9,9156,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0459',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33908,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33908,33.78,NULL,57,9156,NULL,NULL,'Dipole + Quadrupole','FGC 0459',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33909,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33909,33.79,NULL,57.2,9156,NULL,NULL,'Dipole','FGC 0459',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33910,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33910,37.29,0.17,287,9157,70,NULL,NULL,'2MASX J03573452-0523379',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000071,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,59.394,-5.39397,0.269,NULL,37005683716,578213808,9034590,17.1),(33911,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33911,36.76,0.59,225,9158,70,NULL,NULL,'2MASX J03574015-6356132',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.6R',0.19,NULL,NULL,NULL,NULL,NULL,1,59.417333,-63.93708,0.093,NULL,36460830509,569700476,8901569,15.6),(33912,'SNIa','2016-12-15 15:14:02','2016-12-16 11:19:06','1','SN 2011ha',NULL,33912,38.38,0.21,475,9159,72,NULL,'M(H) = -18.317 mag','2MASX J03574051+1010130',NULL,'2014ApJ...784..105W',2013,1,NULL,NULL,'G',NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,59.418875,10.17019,0.529,NULL,65225021676,1019140963,15924077,NULL),(33913,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33913,30.96,0.8,15.5,9160,75,NULL,'MAT, I','NGC 1494',NULL,'1997ApJS..109..333W',1997,1,3.2,NULL,'G',0.000003,NULL,'12.28',1.9,'SAB(rs)cd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,59.42875,-48.90808,0,NULL,37768222398,590128474,9220757,12.28),(33914,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33914,30.97,0.8,15.6,9160,75,NULL,'A82, H','NGC 1494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33915,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33915,30.22,0.43,11.1,9160,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1494',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33916,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33916,30.35,0.43,11.7,9160,75,NULL,'3.6 micron, color corrected','NGC 1494',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33917,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33917,30.36,0.32,11.8,9160,85,NULL,'I, inv','NGC 1494',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33918,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33918,30.38,0.32,11.9,9160,85,NULL,'I, raw','NGC 1494',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33919,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33919,30.43,0.4,12.2,9160,75,NULL,'B','NGC 1494',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33920,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33920,30.44,0.2,12.3,9160,74.4,NULL,NULL,'NGC 1494',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33921,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33921,30.64,0.35,13.4,9160,NULL,NULL,NULL,'NGC 1494',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33922,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33922,30.64,0.4,13.4,9160,73,NULL,'opt','NGC 1494',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33923,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33923,30.65,0.43,13.5,9160,75,NULL,'MAT, I, inv','NGC 1494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33924,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33924,30.67,0.43,13.6,9160,75,NULL,'MAT, I, raw','NGC 1494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33925,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33925,30.67,0.4,13.6,9160,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 1494',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33926,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33926,30.92,0.08,15.3,9160,NULL,NULL,NULL,'NGC 1494',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33927,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33927,30.95,0.43,15.5,9160,75,NULL,'MAT, I, cor','NGC 1494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33928,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33928,31.18,0.47,17.3,9160,75,NULL,'A82, H, inv','NGC 1494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33929,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33929,31.25,0.47,17.7,9160,75,NULL,'A82, H, raw','NGC 1494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33930,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33930,31.44,0.47,19.4,9160,75,NULL,'A82, H, cor','NGC 1494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33931,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33931,35.46,0.55,124,9161,70,NULL,NULL,'2MASX J03574414-0222249',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.000107,NULL,'17.09',0.39,NULL,NULL,NULL,NULL,NULL,1,59.434083,-2.37367,0.621,NULL,36941674412,577213662,9018963,17.09),(33932,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33932,35.57,0.57,130,9162,70,NULL,NULL,'ESO 055- G 003',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.67',0.4,'Sa:',NULL,NULL,NULL,NULL,1,59.4559583,-71.94653,0.225,NULL,36421730516,569089539,8892024,15.67),(33933,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33933,37.38,0.46,299,9163,70,NULL,NULL,'2MASX J03575203-0512460',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000071,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,59.4669583,-5.21283,0.245,NULL,37006096619,578220259,9034691,18.6),(33934,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33934,35.87,0.4,149,9164,NULL,NULL,NULL,'AGC 430695',NULL,'2009ApJS..182..474S',2009,1,0.48,NULL,'G',0.000033,NULL,'16.33',0.43,'Sc',NULL,NULL,NULL,NULL,1,59.4890417,-52.25642,0,NULL,37743813815,589747090,9214798,16.33),(33935,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33935,35.91,0.2,152,9164,74.4,NULL,NULL,'AGC 430695',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33936,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33936,35.98,0.38,157,9164,NULL,NULL,'Malmquist cor.','AGC 430695',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33937,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33937,36.14,0.54,169,9165,70,NULL,NULL,'2MASX J03581105-5438110',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.78',0.43,'S0',NULL,NULL,NULL,NULL,1,59.5462083,-54.63636,0,NULL,35807260251,559488441,8742006,15.78),(33938,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33938,35.95,0.13,155,9166,70,NULL,NULL,'ABELL 3193',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I      [BM];RI [A]',NULL,NULL,NULL,NULL,1,59.55425,-52.3415,0,NULL,37743787131,589746673,9214791,NULL),(33939,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33939,34.59,0.52,82.8,9167,NULL,NULL,'Malmquist cor.','NGC 1492',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.02',0.7,'Sb-c',NULL,NULL,NULL,NULL,1,59.5547083333,-35.44636,0,NULL,37675209017,588675140,9198049,14.02),(33940,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33940,34.94,0.44,97.5,9167,NULL,NULL,NULL,'NGC 1492',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33941,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33941,34.99,0.2,99.5,9167,74.4,NULL,NULL,'NGC 1492',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33942,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33942,35.78,0.4,144,9168,NULL,NULL,'mean','NGC 1500',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000025,NULL,'14.87',0.9,'SA(r)0-:;E/D','Brightest group member',NULL,NULL,NULL,1,59.5582083,-52.32817,0,NULL,37743787429,589746678,9214791,14.87),(33943,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33943,35.91,0.45,152,9168,NULL,NULL,'K','NGC 1500',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33944,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33944,35.95,0.13,155,9168,70,NULL,'ABELL 3193, BGC','NGC 1500',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33945,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33945,31.26,0.8,17.9,9169,75,NULL,'MAT, I','NGC 1495',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.00002,NULL,'13.33',0.5,'Sc? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,59.590917,-44.46625,0,NULL,37758866110,589982282,9218473,13.33),(33946,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33946,30.75,0.39,14.1,9169,73,NULL,'IR','NGC 1495',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33947,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33947,30.75,0.4,14.1,9169,75,NULL,NULL,'NGC 1495',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33948,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33948,30.9,0.4,15.1,9169,NULL,NULL,NULL,'NGC 1495',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33949,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33949,30.91,0.32,15.2,9169,85,NULL,'I, inv','NGC 1495',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33950,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33950,30.92,0.32,15.3,9169,85,NULL,'I, raw','NGC 1495',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33951,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33951,31.02,0.4,16,9169,73,NULL,'IR','NGC 1495',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33952,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33952,31.02,0.4,16,9169,75,NULL,NULL,'NGC 1495',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33953,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33953,31.1,0.43,16.6,9169,75,NULL,'MAT, I, raw','NGC 1495',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33954,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33954,31.13,0.43,16.8,9169,75,NULL,'MAT, I, inv','NGC 1495',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33955,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33955,31.31,0.43,18.3,9169,75,NULL,'MAT, I, cor','NGC 1495',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33956,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33956,31.38,0.12,18.9,9169,NULL,NULL,NULL,'NGC 1495',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33957,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33957,31.57,0.49,20.6,9169,75,NULL,'IR','NGC 1495',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33958,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33958,31.81,0.49,23,9169,75,NULL,'IR','NGC 1495',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33959,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33959,36.09,0.46,165,9170,70,NULL,NULL,'2MASX J03582189-0533062',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000081,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,59.591125,-5.55183,0.237,NULL,37002868448,578169819,9033903,17.1),(33960,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33960,33.57,0.2,51.8,9171,74.4,NULL,NULL,'UGC 02910',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',NULL,NULL,'16.5',0.2,'Sbc',NULL,NULL,NULL,NULL,1,59.595083,6.71483,0.441,NULL,65220851023,1019075797,15923059,16.5),(33961,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33961,33.75,0.51,56.1,9171,NULL,NULL,NULL,'UGC 02910',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33962,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33962,33.84,0.49,58.5,9171,75,NULL,'IR','UGC 02910',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33963,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33963,33.93,0.47,61,9171,NULL,NULL,'Malmquist cor.','UGC 02910',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33964,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33964,35.88,0.71,150,9172,70,NULL,NULL,'2MFGC 03263',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.49',NULL,NULL,NULL,NULL,NULL,NULL,1,59.59875,-73.70239,0.377,NULL,35531879664,555185619,8674775,17.49),(33965,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33965,35.84,0.33,147,9173,NULL,NULL,NULL,'2MASX J03582457-5208271',NULL,'2009ApJS..182..474S',2009,1,0.83,NULL,'G',0.000023,NULL,'15.80',0.28,'Sb',NULL,NULL,NULL,NULL,1,59.602375,-52.14089,0,NULL,37743805498,589746960,9214796,15.8),(33966,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33966,35.85,0.32,148,9173,NULL,NULL,'Malmquist cor.','2MASX J03582457-5208271',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33967,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33967,35.88,0.2,150,9173,74.4,NULL,NULL,'2MASX J03582457-5208271',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33968,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33968,34.05,0.45,64.4,9174,70,NULL,NULL,'AM 0357-614 NED01',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00007,NULL,'11.7I',0.9,'S0',NULL,NULL,NULL,NULL,1,59.628,-61.54103,0.025,NULL,35788359293,559193113,8737392,11.7),(33969,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33969,33.08,0.53,41.2,9175,70,NULL,NULL,'ESO 015- G 005',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.000021,NULL,'13.36',1.5,'(R\'_2)SB(rs)bc',NULL,NULL,NULL,NULL,1,59.631333,-81.063,0.317,NULL,35680806133,557512595,8711134,13.36),(33970,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33970,36.79,0.6,228,9176,70,NULL,NULL,'2MASX J03584181-1853352',NULL,'2014MNRAS.445.2677S',2014,1,0.97,NULL,'G',0.00015,NULL,'16.07',0.45,'S0',NULL,NULL,NULL,NULL,1,59.67425,-18.89306,0.033,NULL,36851952179,575811752,8997058,16.07),(33971,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33971,35.73,0.47,140,9177,NULL,NULL,NULL,'AGC 430698',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000023,NULL,'17.36',0.17,'Sc',NULL,NULL,NULL,NULL,1,59.7311666667,-52.55536,0,NULL,37743868881,589747951,9214811,17.36),(33972,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33972,35.77,0.2,143,9177,74.4,NULL,NULL,'AGC 430698',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33973,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33973,35.99,0.41,158,9177,NULL,NULL,'Malmquist cor.','AGC 430698',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33974,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33974,30.73,0.8,14,9178,75,NULL,'MAT, I','ESO 249- G 035',NULL,'1997ApJS..109..333W',1997,1,1.31,'Doubtful identifications as \\\"Horologium Dwarf\\\" and \\\"Schuster\'s Spiral\\\".','G',0.00001,NULL,'16.24',0.22,'SBcd: sp',NULL,NULL,NULL,NULL,1,59.7357917,-45.85892,0,NULL,37760766065,590011969,9218937,16.24),(33975,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33975,31.54,0.32,20.3,9178,85,NULL,'I, inv','ESO 249- G 035',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33976,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33976,31.62,0.32,21.1,9178,85,NULL,'I, raw','ESO 249- G 035',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33977,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33977,31.73,NULL,22.2,9178,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 249- G 035',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33978,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33978,31.76,NULL,22.5,9178,NULL,NULL,'Dipole + Quadrupole','ESO 249- G 035',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33979,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33979,31.78,NULL,22.7,9178,NULL,NULL,'Dipole','ESO 249- G 035',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33980,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33980,31.87,NULL,23.7,9178,NULL,NULL,NULL,'ESO 249- G 035',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33981,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33981,31.95,0.43,24.5,9178,75,NULL,'MAT, I, inv','ESO 249- G 035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33982,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33982,32.13,0.43,26.6,9178,75,NULL,'MAT, I, cor','ESO 249- G 035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33983,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33983,32.18,0.43,27.3,9178,75,NULL,'MAT, I, raw','ESO 249- G 035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33984,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33984,33.91,0.47,60.6,9179,NULL,NULL,'H','UGC 02908',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000037,NULL,'16.0',0.8,'S?',NULL,NULL,NULL,NULL,1,59.7472917,43.34711,NULL,NULL,68393523288,1068648801,16697637,16),(33985,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33985,33.97,0.4,62.2,9179,NULL,NULL,'mean','UGC 02908',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33986,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33986,33.99,0.45,62.7,9179,NULL,NULL,'K','UGC 02908',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33987,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33987,32.86,0.4,37.4,9180,75,NULL,NULL,'UGC 02896',NULL,'2008Ap.....51..336K',2008,1,1.3,NULL,'G',0.000037,NULL,'15.36',0.3,'Scd:',NULL,NULL,NULL,NULL,1,59.7562917,79.55644,0.445,NULL,65726998295,1026984348,16046630,15.36),(33988,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33988,32.96,0.4,39.1,9180,NULL,NULL,NULL,'UGC 02896',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33989,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33989,33.05,0.2,40.7,9180,74.4,NULL,NULL,'UGC 02896',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33990,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33990,33.26,0.6,44.8,9180,NULL,NULL,NULL,'UGC 02896',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33991,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33991,33.32,0.49,46,9180,75,NULL,'IR','UGC 02896',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33992,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33992,33.56,0.52,51.5,9180,NULL,NULL,'Malmquist cor.','UGC 02896',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(33993,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33993,36.22,0.48,175,9181,70,NULL,NULL,'MC 0358-606',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.98',1,'(R\')SA(s)0-:',NULL,NULL,NULL,NULL,1,59.759375,-60.67489,0,NULL,35799872945,559373014,8740203,15.98),(33994,'GRB','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33994,41.26,NULL,1790,9182,70,NULL,'Pseudo z = 0.56','GRB 031111b',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,59.770833,34.6,1.113,NULL,68357008371,1068078255,16688722,NULL),(33995,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33995,37.7,0.33,347,9183,70,NULL,NULL,'2MASX J03590671-0645077',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.0001,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,59.7780833333,-6.75217,0.285,NULL,37039561926,578743155,9042861,16.5),(33996,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',33996,37.7,0.33,347,9184,70,NULL,NULL,'2MASX J03591000-0646207',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000074,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,59.79175,-6.77247,0.285,NULL,37039562491,578743163,9042861,17.8),(33997,'Tully est','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33997,29.87,0.8,9.4,9185,75,NULL,NULL,'Horologium Dwarf',NULL,'1988NBGC.C....0000T',1988,1,2.2,'The APM position is between the nucleus and a bright knot 15 arcsec northwest.','G',0.000003,NULL,'15.1B',2,'IB(s)m',NULL,NULL,NULL,NULL,1,59.815,-45.8725,0,NULL,37760642762,590010043,9218906,15.1),(33998,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33998,35.53,0.57,128,9186,70,NULL,NULL,'2MASX J03591579-5443439',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'16.67',0.24,'S0',NULL,NULL,NULL,NULL,1,59.8157917,-54.72892,0,NULL,35807085526,559485711,8741964,16.67),(33999,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,33999,34.19,0.55,69,9187,70,NULL,NULL,'2MASX J03592566-0040199',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000097,NULL,'16.17',NULL,NULL,NULL,NULL,NULL,NULL,1,59.857,-0.67225,0.573,NULL,36937036653,577141197,9017831,16.17),(34000,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34000,37.55,0.46,324,9188,70,NULL,NULL,'2MASX J03593138-0541169',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000082,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,59.880667,-5.68814,0.237,NULL,37003037977,578172468,9033944,18.1),(34001,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34001,35.86,0.55,149,9189,70,NULL,NULL,'2MASX J03593581-6504205',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,59.8992916667,-65.07236,0.117,NULL,36459958917,569686858,8901357,14.1),(34002,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34002,31.23,0.8,17.6,9190,75,NULL,'MAT, I','NGC 1511',NULL,'1997ApJS..109..333W',1997,1,3.5,'ESO-LV gives v= 1000+/-29 km/sec.','G',0.000017,NULL,'11.88',1.2,'SAa pec:       HII','in a triple',NULL,NULL,NULL,1,59.9040833333,-67.63425,0.197,NULL,36397789956,568715468,8886179,11.88),(34003,'Tully est','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34003,30.9,0.8,15.1,9190,75,NULL,'B','NGC 1511',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34004,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34004,30.47,0.43,12.4,9190,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1511',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34005,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34005,30.73,0.43,14,9190,75,NULL,'3.6 micron, color corrected','NGC 1511',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34006,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34006,30.79,0.32,14.4,9190,85,NULL,'I, raw','NGC 1511',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34007,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34007,30.81,0.32,14.5,9190,85,NULL,'I, inv','NGC 1511',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34008,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34008,30.95,0.43,15.5,9190,75,NULL,'MAT, I, raw','NGC 1511',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34009,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34009,30.95,0.36,15.5,9190,NULL,NULL,NULL,'NGC 1511',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34010,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34010,30.95,0.4,15.5,9190,73,NULL,'opt','NGC 1511',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34011,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34011,31.03,0.6,16.1,9190,NULL,NULL,'Malmquist cor.','NGC 1511',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34012,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34012,31.04,0.2,16.1,9190,74.4,NULL,NULL,'NGC 1511',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34013,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34013,31.07,0.43,16.3,9190,75,NULL,'MAT, I, inv','NGC 1511',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34014,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34014,31.15,0.43,17,9190,75,NULL,'MAT, I, cor','NGC 1511',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34015,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34015,31.22,0.49,17.5,9190,75,NULL,'IR','NGC 1511',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34016,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34016,31.39,0.51,19,9190,NULL,NULL,NULL,'NGC 1511',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34017,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34017,37.81,0.46,365,9191,70,NULL,NULL,'SDSS J035940.55-052739.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000079,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,59.9189583,-5.46108,0.237,NULL,37003157317,578174333,9033973,18.6),(34018,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34018,35.9,0.52,151,9192,NULL,NULL,'Malmquist cor.','IC 2023',NULL,'2009ApJS..182..474S',2009,1,0.58,NULL,'G',0.000023,NULL,'15.50',0.46,'SB0?',NULL,NULL,NULL,NULL,1,59.9192917,-52.68114,0,NULL,37743831387,589747365,9214802,15.5),(34019,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34019,35.96,0.51,156,9192,NULL,NULL,NULL,'IC 2023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34020,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34020,36,0.2,158,9192,74.4,NULL,NULL,'IC 2023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34021,'Brightest Stars','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34021,26.24,NULL,1.77,9193,NULL,NULL,'3R','UGCA 086',NULL,'1993A&AS..100..227K',1993,1,5,NULL,'G',0.000013,NULL,'13.50',3.1,'Im?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,59.95125,67.1385,3.041,0,66416372250,1037755816,16214934,13.5),(34022,'Brightest Stars','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34022,26.35,NULL,1.86,9193,NULL,NULL,'3B','UGCA 086',NULL,'1993A&AS..100..227K',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34023,'Brightest Stars','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34023,27.07,NULL,2.6,9193,NULL,NULL,NULL,'UGCA 086',NULL,'2001ASPC..240..589H',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34024,'Brightest Stars','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34024,27.12,NULL,2.65,9193,NULL,NULL,NULL,'UGCA 086',NULL,'1997A&AS..124..559K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34025,'CMD','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34025,24,NULL,0.631,9193,NULL,NULL,NULL,'UGCA 086',NULL,'1991AJ....101..465S',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34026,'TRGB','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34026,27.36,NULL,2.96,9193,NULL,NULL,NULL,'UGCA 086',NULL,'2006AJ....131.1361K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34027,'TRGB','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34027,27.37,0.1,2.98,9193,74.4,NULL,NULL,'UGCA 086',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34028,'TRGB','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34028,27.47,0.03,3.12,9193,NULL,NULL,'I','UGCA 086',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34029,'Tully est','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34029,28.19,0.8,4.4,9193,75,NULL,NULL,'UGCA 086',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34030,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34030,34.41,0.43,76,9194,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02915',NULL,'2014MNRAS.444..527S',2014,1,1.14,NULL,'G',0.000011,NULL,'17.',0.13,'Sd',NULL,NULL,NULL,NULL,1,59.979875,32.61258,0.573,NULL,68354736090,1068042751,16688167,17),(34031,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34031,34.52,0.43,80.3,9194,75,NULL,'3.6 micron, color corrected','UGC 02915',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34032,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34032,34.58,0.2,82.4,9194,74.4,NULL,NULL,'UGC 02915',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34033,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34033,34.65,0.36,85.1,9194,NULL,NULL,NULL,'UGC 02915',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34034,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34034,34.65,0.36,85.1,9194,NULL,NULL,'Malmquist cor.','UGC 02915',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34035,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34035,34.83,NULL,92.6,9194,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02915',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34036,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34036,34.83,NULL,92.6,9194,NULL,NULL,'Dipole + Quadrupole','UGC 02915',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34037,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34037,34.84,NULL,92.8,9194,NULL,NULL,'Dipole','UGC 02915',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34038,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34038,34.85,NULL,93.2,9194,NULL,NULL,NULL,'UGC 02915',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34039,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34039,34.95,0.48,97.5,9195,70,NULL,NULL,'ESO 032- G 006',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00013,NULL,'15.69',0.2,'Sa-b',NULL,NULL,NULL,NULL,1,60.0287083,-73.70731,0.345,NULL,35531911021,555186109,8674782,15.69),(34040,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34040,34.39,0.8,75.6,9196,75,NULL,'MAT, I','ESO 117- G 018',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.14',0.9,'SA(s)c',NULL,NULL,NULL,NULL,1,60.0325416667,-61.28322,0,NULL,35788706880,559198545,8737477,14.14),(34041,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34041,34.18,0.43,68.6,9196,75,NULL,'MAT, I, raw','ESO 117- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34042,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34042,34.27,0.32,71.4,9196,85,NULL,'I, raw','ESO 117- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34043,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34043,34.33,0.32,73.4,9196,85,NULL,'I, inv','ESO 117- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34044,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34044,34.42,0.47,76.4,9196,NULL,NULL,'H','ESO 117- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34045,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34045,34.43,0.43,76.9,9196,75,NULL,'MAT, I, inv','ESO 117- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34046,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34046,34.45,0.35,77.7,9196,NULL,NULL,'Malmquist cor.','ESO 117- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34047,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34047,34.47,0.43,78.2,9196,75,NULL,'MAT, I, cor','ESO 117- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34048,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34048,34.53,0.46,80.4,9196,NULL,NULL,'J','ESO 117- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34049,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34049,34.55,0.45,81.2,9196,NULL,NULL,'K','ESO 117- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34050,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34050,34.55,0.4,81.3,9196,NULL,NULL,'mean','ESO 117- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34051,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34051,34.61,0.32,83.5,9196,NULL,NULL,NULL,'ESO 117- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34052,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34052,34.65,0.2,85.1,9196,74.4,NULL,NULL,'ESO 117- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34053,'Magnitude','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34053,36.78,0.13,227,9197,100,NULL,NULL,'ABELL 3202',NULL,'1998A&A...337...31R',1998,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II     [BM];I  [A]',NULL,NULL,NULL,NULL,1,60.06225,-53.66033,0,NULL,37740831788,589700496,9214070,NULL),(34054,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34054,31.18,0.8,17.3,9198,75,NULL,'MAT, I','NGC 1511A',NULL,'1997ApJS..109..333W',1997,1,1.7,'ESO-LV gives v= 983+/-29 km/sec.','G',0.000017,NULL,'14.23',0.4,'SB0^0','in a triple',NULL,NULL,NULL,1,60.0774583,-67.80683,0.249,NULL,36394351183,568661737,8885339,14.23),(34055,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34055,30.52,0.32,12.7,9198,85,NULL,'I, inv','NGC 1511A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34056,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34056,30.55,0.32,12.9,9198,85,NULL,'I, raw','NGC 1511A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34057,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34057,30.91,0.43,15.2,9198,75,NULL,'MAT, I, inv','NGC 1511A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34058,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34058,30.99,0.43,15.8,9198,75,NULL,'MAT, I, raw','NGC 1511A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34059,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34059,31.18,0.43,17.2,9198,75,NULL,'MAT, I, cor','NGC 1511A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34060,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34060,31.66,0.4,21.5,9198,73,NULL,'opt','NGC 1511A',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34061,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34061,31.74,0.99,22.3,9198,NULL,NULL,'Malmquist cor.','NGC 1511A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34062,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34062,31.92,0.91,24.2,9198,NULL,NULL,NULL,'NGC 1511A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34063,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34063,31.96,0.2,24.7,9198,74.4,NULL,NULL,'NGC 1511A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34064,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34064,32.07,0.4,26,9198,NULL,NULL,'mean','NGC 1511A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34065,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34065,32.72,0.47,35,9198,NULL,NULL,'H','NGC 1511A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34066,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34066,32.72,0.46,35,9198,NULL,NULL,'J','NGC 1511A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34067,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34067,33.66,0.8,53.9,9199,75,NULL,'MAT, I','ESO 483- G 006',NULL,'1997ApJS..109..333W',1997,1,2.6,'A-M -50s RA error.','G',0.00001,NULL,'14.39',0.5,'(R\':)SB:(s)b',NULL,NULL,NULL,NULL,1,60.1097917,-25.18261,0,NULL,38522546291,601914785,9404918,14.39),(34068,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34068,33.3,0.43,45.7,9199,75,NULL,'MAT, I, raw','ESO 483- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34069,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34069,33.4,0.32,47.9,9199,85,NULL,'I, raw','ESO 483- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34070,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34070,33.45,0.32,48.9,9199,85,NULL,'I, inv','ESO 483- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34071,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34071,33.5,0.43,50.1,9199,75,NULL,'MAT, I, inv','ESO 483- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34072,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34072,33.66,0.43,54,9199,75,NULL,'MAT, I, cor','ESO 483- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34073,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34073,33.71,0.2,55.2,9199,74.4,NULL,NULL,'ESO 483- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34074,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34074,33.72,0.2,55.4,9199,NULL,NULL,'Malmquist cor.','ESO 483- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34075,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34075,33.76,0.4,56.6,9199,NULL,NULL,'mean','ESO 483- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34076,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34076,33.86,0.47,59.2,9199,NULL,NULL,'H','ESO 483- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34077,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34077,33.86,0.19,59.3,9199,NULL,NULL,NULL,'ESO 483- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34078,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34078,33.88,0.46,59.7,9199,NULL,NULL,'J','ESO 483- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34079,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34079,33.95,0.45,61.8,9199,NULL,NULL,'K','ESO 483- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34080,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34080,33.99,0.49,62.9,9199,75,NULL,'IR','ESO 483- G 006',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34081,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34081,36.1,0.53,166,9200,70,NULL,NULL,'ESO 549- G 046',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'15.17',0.5,'Sb',NULL,NULL,NULL,NULL,1,60.1165416667,-20.78169,0.049,NULL,37990004119,593593814,9274903,15.17),(34082,'Magnitude','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34082,36.78,0.13,227,9201,100,NULL,NULL,'2MASX J04003845-5340583',NULL,'1998A&A...337...31R',1998,1,0.67,NULL,'G',0.00019,NULL,'16.76',0.23,'S0',NULL,NULL,NULL,NULL,1,60.1603333333,-53.68289,0,NULL,37740825714,589700401,9214068,16.76),(34083,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34083,34.06,0.9,64.9,9202,NULL,NULL,NULL,'ESO 156- G 029',NULL,'2009ApJS..182..474S',2009,1,1.2,'Fairall (1984,MNRAS,210,69) gives v = 3900: +/- 200 km/sec.','G',0.000023,NULL,'15.23',0.9,'SA(rs)cd pec:',NULL,NULL,NULL,NULL,1,60.1705417,-52.73392,0,NULL,37744289259,589754519,9214914,15.23),(34084,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34084,34.25,0.82,70.8,9202,NULL,NULL,'Malmquist cor.','ESO 156- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34085,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34085,36.31,0.56,183,9203,70,NULL,NULL,'2MASX J04004247-2047141',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'16.33',0.43,'S0',NULL,NULL,NULL,NULL,1,60.1770417,-20.78731,0.049,NULL,37990006229,593593847,9274903,16.33),(34086,'GRB','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34086,46,1.56,4220,9204,NULL,NULL,NULL,'GRB 091029',2.752,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,60.177625,-55.95544,0,NULL,35826537199,559789643,8746713,NULL),(34087,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34087,34.35,0.4,74.1,9205,NULL,NULL,'mean','UGC 02922',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000007,NULL,'16.5',0.7,'Sb',NULL,NULL,NULL,NULL,1,60.1919583,17.58311,1.045,NULL,65156748550,1018074196,15907409,16.5),(34088,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34088,34.66,0.47,85.4,9205,NULL,NULL,'H','UGC 02922',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34089,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34089,35.95,0.71,155,9206,70,NULL,NULL,'2MASX J04004756-6458385',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.1I',0.3,NULL,NULL,NULL,NULL,NULL,1,60.198083,-64.97744,0.109,NULL,36459912634,569686134,8901345,14.1),(34090,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34090,33.87,0.2,59.4,9207,74.4,NULL,NULL,'UGC 02920',NULL,'2013AJ....146...86T',2013,1,2.55,NULL,'G',0.00001,NULL,'14.7',0.22,'Sd',NULL,NULL,NULL,NULL,1,60.20375,35.01375,1.049,NULL,68357354939,1068083670,16688807,14.7),(34091,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34091,33.92,0.49,60.9,9207,75,NULL,'IR','UGC 02920',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34092,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34092,33.93,NULL,61,9207,NULL,NULL,'Dipole','UGC 02920',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34093,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34093,33.94,NULL,61.3,9207,NULL,NULL,'Dipole + Quadrupole','UGC 02920',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34094,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34094,33.94,NULL,61.4,9207,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02920',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34095,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34095,34.11,0.43,66.3,9207,75,NULL,'3.6 micron, color corrected','UGC 02920',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34096,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34096,34.22,0.43,69.9,9207,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02920',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34097,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34097,29.55,NULL,8.14,9208,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 1511B',NULL,'2010Ap&SS.325..163P',2010,1,2.33,NULL,'G',0.00001,NULL,'15.12',0.31,'SBd? sp','in a triple',NULL,NULL,NULL,1,60.227917,-67.61194,0.197,NULL,36397832791,568716137,8886189,15.12),(34098,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34098,29.62,NULL,8.39,9208,NULL,NULL,'Dipole + Quadrupole','NGC 1511B',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34099,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34099,29.68,NULL,8.63,9208,NULL,NULL,'Dipole','NGC 1511B',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34100,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34100,29.76,NULL,8.96,9208,NULL,NULL,NULL,'NGC 1511B',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34101,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34101,33,0.4,39.9,9209,NULL,NULL,'mean','UGC 02906',NULL,'2007A&A...465...71T',2007,1,2.8,NULL,'G',0.000037,NULL,'13.8',1.7,'Sb:',NULL,NULL,NULL,NULL,1,60.25425,74.08383,0.817,NULL,65681091292,1026267051,16035422,13.8),(34102,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34102,33.71,0.46,55.1,9209,NULL,NULL,'J','UGC 02906',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34103,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34103,33.71,0.47,55.3,9209,NULL,NULL,'H','UGC 02906',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34104,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34104,33.74,0.45,55.9,9209,NULL,NULL,'K','UGC 02906',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34105,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34105,33.98,0.2,62.5,9209,74.4,NULL,NULL,'UGC 02906',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34106,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34106,34.05,0.43,64.6,9209,75,NULL,'3.6 micron, color corrected','UGC 02906',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34107,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34107,34.17,0.43,68.2,9209,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02906',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34108,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34108,36.14,0.5,169,9210,70,NULL,NULL,'2MASX J04010121-6113205',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'13.3I',0.8,'(R\')SABa: pec',NULL,NULL,NULL,NULL,1,60.254875,-61.22239,0,NULL,35788594241,559196785,8737449,13.3),(34109,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34109,35.5,0.49,126,9211,70,NULL,NULL,'2MASX J04010663-1606391',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.00014,NULL,'16.12',0.67,'FSRQ',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,60.277667,-16.11083,0.025,NULL,36908156008,576689937,9010780,16.12),(34110,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34110,35.69,0.41,137,9212,NULL,NULL,NULL,'IC 2028',NULL,'2009ApJS..182..474S',2009,1,0.81,NULL,'G',0.000023,NULL,'15.06',0.71,'Scd:',NULL,NULL,NULL,NULL,1,60.3259583,-52.70744,0,NULL,37744341959,589755343,9214927,15.06),(34111,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34111,35.73,0.2,140,9212,74.4,NULL,NULL,'IC 2028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34112,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34112,35.74,0.4,141,9212,NULL,NULL,'mean','IC 2028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34113,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34113,35.74,0.4,141,9212,NULL,NULL,'Malmquist cor.','IC 2028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34114,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34114,36.19,0.47,173,9212,NULL,NULL,'H','IC 2028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34115,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34115,37.2,0.46,275,9213,70,NULL,NULL,'2MASX J04013527-0518549',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00008,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,60.397,-5.31542,0.229,NULL,36930987828,577046684,9016354,17.2),(34116,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34116,33.91,0.49,60.6,9214,75,NULL,'IR','MCG +04-10-007 NED01',NULL,'2011yCatp016004901K',2011,1,0.81,'Monnier-Ragaigne et al. (2003A&A...408...67M) also give v=6673 km/sec.','G',0.000012,NULL,'16.7',0.11,'Scd',NULL,NULL,NULL,NULL,1,60.406667,24.82197,0.445,NULL,68453567384,1069586990,16712296,16.7),(34117,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34117,34.82,NULL,92.1,9214,NULL,NULL,NULL,'MCG +04-10-007 NED01',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34118,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34118,35.18,NULL,109,9214,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG +04-10-007 NED01',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34119,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34119,35.18,NULL,109,9214,NULL,NULL,'Dipole + Quadrupole','MCG +04-10-007 NED01',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34120,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34120,35.19,NULL,109,9214,NULL,NULL,'Dipole','MCG +04-10-007 NED01',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34121,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34121,36.29,0.46,181,9215,70,NULL,NULL,'2MASX J04013825-0428219',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000086,NULL,'16.5g',0.25,'E0',NULL,NULL,NULL,NULL,1,60.4095,-4.47286,0.241,NULL,36934780644,577105947,9017280,16.5),(34122,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34122,36.6,0.67,209,9215,70,NULL,NULL,'2MASX J04013825-0428219',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34123,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34123,34.29,0.49,72.2,9216,75,NULL,'IR','FGC 0465',NULL,'2011yCatp016004901K',2011,1,0.73,NULL,'G',NULL,NULL,'16.88',0.1,'Sc',NULL,NULL,NULL,NULL,1,60.409625,20.26411,0.781,NULL,65102869686,1017232338,15894255,16.88),(34124,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34124,33.95,0.69,61.7,9217,100,NULL,'mid-IR','UGC 02927',NULL,'2013ApJ...771...88L',2013,1,1.9,'The position in 1997ApJ...490..173Z refers to the southwestern end of the bar.','G',0.000027,NULL,'14.60',1.2,'(R)SB(s)a','Group member',NULL,NULL,NULL,1,60.419917,23.11272,0.645,NULL,67984672920,1062260514,16597820,14.6),(34125,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34125,33.83,0.8,58.3,9218,75,NULL,'MAT, I','ESO 302- G 027',NULL,'1997ApJS..109..333W',1997,1,1.22,NULL,'G',0.000033,NULL,'15.08',0.47,'SAB(s)c pec',NULL,NULL,NULL,NULL,1,60.465667,-41.94189,0,NULL,37797788559,590590446,9227975,15.08),(34126,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34126,33.52,0.32,50.5,9218,85,NULL,'I, inv','ESO 302- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34127,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34127,33.53,0.32,50.8,9218,85,NULL,'I, raw','ESO 302- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34128,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34128,33.79,0.43,57.2,9218,75,NULL,'MAT, I, raw','ESO 302- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34129,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34129,33.79,0.43,57.4,9218,75,NULL,'MAT, I, inv','ESO 302- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34130,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34130,33.91,0.2,60.5,9218,74.4,NULL,NULL,'ESO 302- G 027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34131,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34131,34.08,0.44,65.5,9218,NULL,NULL,NULL,'ESO 302- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34132,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34132,34.08,0.44,65.6,9218,NULL,NULL,'Malmquist cor.','ESO 302- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34133,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34133,34.12,0.43,66.6,9218,75,NULL,'MAT, I, cor','ESO 302- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34134,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34134,36.07,0.65,164,9219,70,NULL,NULL,'2MASX J04015499-6406109',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'15.2R',0.19,NULL,NULL,NULL,NULL,NULL,1,60.479333,-64.10297,0.093,NULL,36460397510,569693711,8901464,15.2),(34135,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34135,37.11,0.46,264,9220,70,NULL,NULL,'2MASX J04020058-0455350',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000075,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,60.5024583,-4.92642,0.261,NULL,36931871568,577060493,9016570,17.4),(34136,'L(H{beta})-{sigma}','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34136,46.09,NULL,1601,9221,74.3,NULL,NULL,'WISP 070_0253',2.215,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,60.510417,-5.62208,0.229,NULL,37002249880,578160154,9033752,NULL),(34137,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34137,36.11,0.77,167,9222,70,NULL,NULL,'MCG -02-11-007',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'15',0.25,NULL,NULL,NULL,NULL,NULL,1,60.51275,-9.45656,0.105,NULL,36987506260,577929785,9030152,15),(34138,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34138,34.52,0.49,80.2,9223,75,NULL,'IR','MCG -03-11-007',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.00012,NULL,'15.38',0.2,'Sc',NULL,NULL,NULL,NULL,1,60.513583,-16.44692,0.013,NULL,36909336839,576708388,9011068,15.38),(34139,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34139,37.98,0.46,394,9224,70,NULL,NULL,'2MASX J04021850-0619125',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000141,NULL,'17.5g',0.2,'NLAGN',NULL,NULL,NULL,'Sy 2',1,60.5770416667,-6.32028,0.209,NULL,37035964037,578686938,9041983,17.5),(34140,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34140,34.04,0.76,64.2,9225,NULL,NULL,NULL,'UGC 02931',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000067,NULL,'14.58',0.9,'SA(s)c',NULL,NULL,NULL,NULL,1,60.57725,25.81669,0.449,NULL,68454286285,1069598223,16712472,14.58),(34141,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34141,34.08,0.2,65.5,9225,74.4,NULL,NULL,'UGC 02931',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34142,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34142,34.4,0.65,75.9,9225,NULL,NULL,'Malmquist cor.','UGC 02931',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34143,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34143,36.1,0.54,166,9226,70,NULL,NULL,'2MASX J04022647-1933123',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.00015,NULL,'15.78',0.45,'(R\'_1)SB(rl)a',NULL,NULL,NULL,NULL,1,60.61025,-19.55358,0.049,NULL,36854494622,575851478,8997679,15.78),(34144,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34144,34.23,0.8,70,9227,75,NULL,'MAT, I','ESO 117- G 019',NULL,'1997ApJS..109..333W',1997,1,1.9,'The APM position refers to the eastern end of the galaxy.','G',0.000033,NULL,'14.58',0.3,'SBbc? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,60.634125,-62.31558,0.037,NULL,36272752317,566761754,8855652,14.58),(34145,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34145,33.73,0.43,55.7,9227,75,NULL,'MAT, I, raw','ESO 117- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34146,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34146,33.85,0.32,58.8,9227,85,NULL,'I, raw','ESO 117- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34147,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34147,33.87,0.49,59.3,9227,75,NULL,'IR','ESO 117- G 019',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34148,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34148,33.89,0.32,60.1,9227,85,NULL,'I, inv','ESO 117- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34149,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34149,33.94,0.43,61.5,9227,75,NULL,'MAT, I, inv','ESO 117- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34150,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34150,34.08,0.47,65.5,9227,NULL,NULL,'H','ESO 117- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34151,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34151,34.12,0.29,66.7,9227,NULL,NULL,NULL,'ESO 117- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34152,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34152,34.16,0.2,67.9,9227,74.4,NULL,NULL,'ESO 117- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34153,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34153,34.21,0.43,69.4,9227,75,NULL,'MAT, I, cor','ESO 117- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34154,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34154,34.22,0.46,69.9,9227,NULL,NULL,'J','ESO 117- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34155,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34155,34.22,0.45,69.9,9227,NULL,NULL,'K','ESO 117- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34156,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34156,34.27,0.27,71.5,9227,NULL,NULL,'Malmquist cor.','ESO 117- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34157,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34157,34.33,0.4,73.4,9227,NULL,NULL,'mean','ESO 117- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34158,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34158,36.41,0.46,191,9228,70,NULL,NULL,'2MASX J04024335-0612368',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000092,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,60.6805416667,-6.21028,0.209,NULL,37035756708,578683698,9041932,17),(34159,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34159,32.88,0.46,37.7,9229,NULL,NULL,'J','UGC 02936',NULL,'2007A&A...465...71T',2007,1,2.5,'Danner (1998, A&AS, 128, 331) gives z = 0.14.','G',0.000023,NULL,'15.00',0.7,'SB(s)d         Sy2','Isolated galaxy',NULL,NULL,'Sy 2',1,60.7007916667,1.96603,0.645,NULL,65067732167,1016683315,15885676,15),(34160,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34160,32.92,0.47,38.3,9229,NULL,NULL,'H','UGC 02936',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34161,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34161,32.95,0.49,39,9229,75,NULL,'IR','UGC 02936',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34162,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34162,33.02,0.45,40.1,9229,NULL,NULL,'K','UGC 02936',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34163,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34163,33.12,0.2,42.1,9229,74.4,NULL,NULL,'UGC 02936',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34164,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34164,33.34,0.44,46.5,9229,NULL,NULL,'Malmquist cor.','UGC 02936',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34165,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34165,33.37,0.43,47.2,9229,NULL,NULL,NULL,'UGC 02936',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34166,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34166,33.57,0.4,51.7,9229,NULL,NULL,'mean','UGC 02936',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34167,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34167,33.4,0.52,47.9,9230,70,NULL,NULL,'ESO 117- GA019',NULL,'2014MNRAS.445.2677S',2014,1,1.9,'The APM position refers to the eastern end of the galaxy.','G',0.000033,NULL,'14.58',0.3,'SBbc? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,60.634125,-62.31558,0.037,NULL,36272752317,566761754,8855652,14.58),(34168,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34168,34.64,0.4,84.6,9231,NULL,NULL,'mean','CGCG 466-008',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000033,NULL,'15.5',0.2,'S?',NULL,NULL,NULL,NULL,1,60.731125,21.48386,0.793,NULL,67983415475,1062240866,16597513,15.5),(34169,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34169,34.91,0.47,96,9231,NULL,NULL,'H','CGCG 466-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34170,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34170,34.98,0.46,99.2,9231,NULL,NULL,'J','CGCG 466-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34171,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34171,35,0.45,99.9,9231,NULL,NULL,'K','CGCG 466-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34172,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34172,36.31,0.56,182,9232,70,NULL,NULL,'MCG -02-11-010',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15',0.7,NULL,NULL,NULL,NULL,NULL,1,60.7372083,-9.02417,0.105,NULL,36982337785,577849027,9028891,15),(34173,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34173,34.33,0.4,73.3,9233,NULL,NULL,'mean','UGC 02938',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000033,NULL,'15.26',0.6,'SBab',NULL,NULL,NULL,NULL,1,60.764167,4.54447,0.557,NULL,65070989358,1016734208,15886472,15.26),(34174,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34174,34.35,0.47,74.2,9233,NULL,NULL,'H','UGC 02938',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34175,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34175,34.45,0.45,77.6,9233,NULL,NULL,'K','UGC 02938',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34176,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34176,34.51,0.46,79.8,9233,NULL,NULL,'J','UGC 02938',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34177,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34177,35.75,0.77,141,9234,70,NULL,NULL,'2MASX J04030361-0930527',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'16.49',0.26,NULL,NULL,NULL,NULL,NULL,1,60.764875,-9.51483,0.109,NULL,36989653903,577963342,9030677,16.49),(34178,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34178,35.19,0.51,109,9235,70,NULL,NULL,'2MASX J04031321-0922548',NULL,'2014MNRAS.445.2677S',2014,1,0.71,NULL,'G',0.00015,NULL,'16.06',0.5,NULL,NULL,NULL,NULL,NULL,1,60.805125,-9.38203,0.097,NULL,36989771006,577965171,9030705,16.06),(34179,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34179,35.16,0.59,108,9236,70,NULL,NULL,'2MASX J04031561-2023034',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'15.89',0.55,'S0',NULL,NULL,NULL,NULL,1,60.814833,-20.38419,0.045,NULL,36853158205,575830596,8997353,15.89),(34180,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34180,34.35,0.43,74,9237,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 327-013',NULL,'2014MNRAS.444..527S',2014,1,0.8,NULL,'G',0.000037,NULL,'15.60',0.2,'SB(s)c: pec',NULL,NULL,NULL,NULL,1,60.8199583,71.72036,0.953,NULL,66400303456,1037504741,16211011,15.6),(34181,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34181,34.41,0.49,76.2,9237,75,NULL,'IR','CGCG 327-013',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34182,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34182,36.07,0.49,164,9238,70,NULL,NULL,'2MASX J04032572-2153173',NULL,'2014MNRAS.445.2677S',2014,1,0.88,NULL,'G',0.00015,NULL,'15.29',0.67,'S0',NULL,NULL,NULL,NULL,1,60.8570417,-21.88806,0.057,NULL,37984762063,593511907,9273623,15.29),(34183,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34183,35.43,0.49,122,9239,70,NULL,NULL,'ESO 549- G 053',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00009,NULL,'15.86',0.2,'S0?',NULL,NULL,NULL,NULL,1,60.872125,-17.98339,0,NULL,36898515186,576539299,9008426,15.86),(34184,'Tully est','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34184,30.06,0.8,10.3,9240,75,NULL,'B','NGC 1510',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000033,NULL,'13.47',0.7,'SA0^0^ pec?;HIIBCDG','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,60.886,-43.40011,0,NULL,37789430950,590459858,9225935,13.47),(34185,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34185,30.33,0.08,11.7,9240,NULL,NULL,NULL,'NGC 1510',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34186,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34186,36.05,0.58,162,9241,70,NULL,NULL,'2MASX J04033500-6902281',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'16.3b',0.3,NULL,NULL,NULL,NULL,NULL,1,60.8959166667,-69.04122,0.345,NULL,36427204367,569175068,8893360,16.3),(34187,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34187,35.96,0.53,155,9242,70,NULL,NULL,'2MASX J04033756-1104216',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.00015,NULL,'16.50',0.21,NULL,NULL,NULL,NULL,NULL,1,60.906625,-11.07247,0.101,NULL,36989517111,577961204,9030643,16.5),(34188,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34188,36.35,0.5,187,9243,70,NULL,NULL,'2MASX J04033873-5437201',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.51',0.63,'S0',NULL,NULL,NULL,NULL,1,60.911375,-54.62228,0,NULL,35810642079,559541282,8742832,15.51),(34189,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34189,35.53,0.49,128,9244,75,NULL,'IR','IC 0358',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.07',0.4,'S0',NULL,NULL,NULL,NULL,1,60.928667,19.89494,0.921,NULL,65102663668,1017229119,15894204,15.07),(34190,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34190,33.36,0.47,47,9245,NULL,NULL,'H','IC 0357',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.00002,NULL,'14.13',1,'SB(s)ab',NULL,NULL,NULL,NULL,1,60.933333,22.15911,0.749,NULL,67984370582,1062255790,16597746,14.13),(34191,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34191,33.5,0.45,50,9245,NULL,NULL,'K','IC 0357',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34192,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34192,33.63,0.46,53.2,9245,NULL,NULL,'J','IC 0357',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34193,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34193,34.71,0.4,87.4,9245,NULL,NULL,'mean','IC 0357',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34194,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34194,31.12,0.08,16.8,9246,NULL,NULL,NULL,'NGC 1515A',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000093,NULL,'15.38',0.9,'(R\':)SB(rs)b','in a pair',NULL,NULL,NULL,1,60.957625,-54.11303,0,NULL,35810295839,559535872,8742748,15.38),(34195,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34195,34.64,0.4,84.5,9247,NULL,NULL,'mean','CGCG 487-017',NULL,'2007A&A...465...71T',2007,1,0.5,NULL,'G',0.000033,NULL,'15.55',0.4,'S?',NULL,NULL,NULL,NULL,1,60.9692083,24.39728,0.489,NULL,68453410579,1069584540,16712258,15.55),(34196,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34196,35.69,0.45,137,9247,NULL,NULL,'K','CGCG 487-017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34197,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34197,35.7,0.46,138,9247,NULL,NULL,'J','CGCG 487-017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34198,'Ring Diameter','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34198,30.6,0.76,13,9248,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 1512',NULL,'1981ApJS...45..541P',1981,1,8.9,'Extended HIPASS source','G',0.00001,NULL,'11.13',5.6,'SB(r)ab        AGN','Parent (of companion) galaxy',NULL,NULL,NULL,1,60.976167,-43.34886,0,NULL,37789393644,590459275,9225926,11.13),(34199,'Ring Diameter','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34199,30.6,0.6,13,9248,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 1512',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34200,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34200,30.35,0.8,11.7,9248,75,NULL,'MAT, I','NGC 1512',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34201,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34201,29.9,0.4,9.5,9248,75,NULL,'B','NGC 1512',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34202,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34202,30.21,0.43,11,9248,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1512',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34203,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34203,30.28,0.43,11.4,9248,75,NULL,'3.6 micron, color corrected','NGC 1512',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34204,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34204,30.32,0.08,11.6,9248,NULL,NULL,NULL,'NGC 1512',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34205,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34205,30.34,0.32,11.7,9248,85,NULL,'I, raw','NGC 1512',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34206,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34206,30.38,0.32,11.9,9248,85,NULL,'I, inv','NGC 1512',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34207,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34207,30.39,0.2,12,9248,74.4,NULL,NULL,'NGC 1512',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34208,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34208,30.47,0.43,12.4,9248,75,NULL,'MAT, I, raw','NGC 1512',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34209,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34209,30.57,0.36,13,9248,NULL,NULL,NULL,'NGC 1512',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34210,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34210,30.57,0.4,13,9248,73,NULL,'opt','NGC 1512',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34211,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34211,30.65,0.43,13.5,9248,75,NULL,'MAT, I, inv','NGC 1512',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34212,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34212,30.78,0.43,14.3,9248,75,NULL,'MAT, I, cor','NGC 1512',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34213,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34213,30.95,0.8,15.5,9249,75,NULL,'MAT, I','NGC 1515',NULL,'1997ApJS..109..333W',1997,1,5.2,NULL,'G',0.000023,NULL,'12.05',1.1,'SAB(s)bc','in a pair',NULL,NULL,NULL,1,61.0113333333,-54.10006,0,NULL,35810431097,559537985,8742781,12.05),(34214,'Tully est','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34214,30.64,0.8,13.4,9249,75,NULL,'B','NGC 1515',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34215,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34215,30.84,NULL,14.7,9249,NULL,NULL,'B','NGC 1515',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34216,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34216,30.96,0.36,15.6,9249,NULL,NULL,NULL,'NGC 1515',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34217,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34217,30.97,0.39,15.6,9249,73,NULL,'opt','NGC 1515',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34218,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34218,31.19,0.2,17.3,9249,74.4,NULL,NULL,'NGC 1515',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34219,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34219,31.24,0.43,17.7,9249,75,NULL,'3.6 micron, color corrected','NGC 1515',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34220,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34220,31.33,0.43,18.4,9249,75,NULL,'MAT, I, raw','NGC 1515',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34221,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34221,31.36,0.43,18.7,9249,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1515',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34222,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34222,31.38,0.32,18.9,9249,85,NULL,'I, raw','NGC 1515',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34223,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34223,31.44,0.32,19.4,9249,85,NULL,'I, inv','NGC 1515',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34224,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34224,31.47,0.43,19.7,9249,75,NULL,'MAT, I, cor','NGC 1515',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34225,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34225,31.58,0.43,20.7,9249,75,NULL,'MAT, I, inv','NGC 1515',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34226,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34226,36,0.71,158,9250,70,NULL,NULL,'2MASX J04040786-0349063',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,61.0327917,-3.81847,0.305,NULL,36932513190,577070518,9016726,15.8),(34227,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34227,37.79,0.46,361,9251,70,NULL,NULL,'2MASX J04041576-0521203',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000067,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,61.065625,-5.35561,0.221,NULL,36961073911,577516779,9023699,18.2),(34228,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34228,31.37,0.11,18.8,9252,NULL,NULL,NULL,'ESO 359- G 016',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000011,NULL,'14.95',0.4,'IBm? sp',NULL,NULL,NULL,NULL,1,61.1055,-36.1805,0,NULL,37681288947,588770139,9199533,14.95),(34229,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34229,32.02,0.4,25.4,9252,NULL,NULL,NULL,'ESO 359- G 016',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34230,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34230,32.02,0.4,25.4,9252,73,NULL,'opt','ESO 359- G 016',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34231,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34231,36.24,0.53,177,9253,70,NULL,NULL,'2MASX J04042545-2047566',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.000083,NULL,'16.28',0.42,NULL,NULL,NULL,NULL,NULL,1,61.1060833333,-20.79908,0.017,NULL,36856620786,575884699,8998198,16.28),(34232,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34232,31.25,0.49,17.8,9254,75,NULL,'IR','2MFGC 03330',NULL,'2011yCatp016004901K',2011,1,NULL,NULL,'G',0.00015,NULL,'9.5K',NULL,'HII',NULL,NULL,NULL,NULL,1,61.1115,-2.19622,0.373,NULL,36938124366,577158193,9018096,9.5),(34233,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34233,30.42,0.8,12.1,9255,75,NULL,'A82, H','NGC 1507',NULL,'1997ApJS..109..333W',1997,1,3.6,'Confused HIPASS source','G',0.000004,NULL,'12.89',0.9,'SB(s)m pec?    HII','Pair member (points to parent)',NULL,NULL,NULL,1,61.113375,-2.18858,0.373,NULL,36938124393,577158193,9018096,12.89),(34234,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34234,29.96,0.43,9.8,9255,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1507',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34235,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34235,30,0.4,10,9255,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 1507',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34236,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34236,30.03,0.2,10.1,9255,74.4,NULL,NULL,'NGC 1507',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34237,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34237,30.05,0.43,10.2,9255,75,NULL,'3.6 micron, color corrected','NGC 1507',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34238,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34238,30.09,0.47,10.4,9255,75,NULL,'A82, H, inv','NGC 1507',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34239,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34239,30.13,0.4,10.6,9255,75,NULL,'B','NGC 1507',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34240,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34240,30.21,0.38,11,9255,NULL,NULL,NULL,'NGC 1507',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34241,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34241,30.21,0.47,11,9255,75,NULL,'A82, H, raw','NGC 1507',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34242,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34242,30.21,0.4,11,9255,73,NULL,'opt','NGC 1507',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34243,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34243,30.58,0.47,13.1,9255,75,NULL,'A82, H, cor','NGC 1507',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34244,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34244,35.28,0.53,114,9256,70,NULL,NULL,'ESO 550- G 002',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000103,NULL,'15.28',0.3,'S?             LIRG',NULL,NULL,NULL,NULL,1,61.123625,-17.90453,0,NULL,36898581736,576540339,9008442,15.28),(34245,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34245,36.08,0.75,164,9257,70,NULL,NULL,'2MASX J04043432-0940571',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000103,NULL,'16.62',0.37,NULL,NULL,NULL,NULL,NULL,1,61.1430416667,-9.68264,0.101,NULL,36990577551,577977774,9030902,16.62),(34246,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34246,33.87,0.49,59.5,9258,75,NULL,'IR','UGC 02951',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000017,NULL,'17.',0.2,'Sc',NULL,NULL,NULL,NULL,1,61.183833,2.42531,0.713,NULL,65067496342,1016679630,15885619,17),(34247,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34247,34.09,0.47,65.9,9259,NULL,NULL,'H','UGC 02948',NULL,'2007A&A...465...71T',2007,1,1.3,'Springob et al. (2005ApJS..160..149S) give v= 6163 km/sec.','G',0.000033,NULL,'15.34',0.4,'Sab',NULL,NULL,NULL,NULL,1,61.231417,20.82983,0.805,NULL,65110486100,1017351345,15896114,15.34),(34248,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34248,34.14,0.45,67.4,9259,NULL,NULL,'K','UGC 02948',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34249,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34249,34.31,0.46,72.8,9259,NULL,NULL,'J','UGC 02948',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34250,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34250,34.35,0.4,74,9259,NULL,NULL,'mean','UGC 02948',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34251,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34251,34.38,0.49,75.1,9259,75,NULL,'IR','UGC 02948',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34252,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34252,34.69,0.47,86.8,9260,NULL,NULL,'H','UGC 02949',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.00003,NULL,'14.57',0.5,'SBab:',NULL,NULL,NULL,NULL,1,61.2595417,25.26542,0.461,NULL,68454616767,1069603386,16712552,14.57),(34253,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34253,34.77,0.45,90,9260,NULL,NULL,'K','UGC 02949',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34254,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34254,34.87,0.46,94.3,9260,NULL,NULL,'J','UGC 02949',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34255,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34255,34.91,0.4,96,9260,NULL,NULL,'mean','UGC 02949',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34256,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34256,31.1,0.46,16.6,9261,NULL,NULL,'J','NGC 1485',NULL,'2007A&A...465...71T',2007,1,2.1,NULL,'G',0.00003,NULL,'13.4',0.7,'SAb? sp',NULL,NULL,NULL,NULL,1,61.266417,70.99653,0.921,NULL,66400982680,1037515354,16211177,13.4),(34257,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34257,31.16,0.47,17.1,9261,NULL,NULL,'H','NGC 1485',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34258,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34258,31.22,0.45,17.5,9261,NULL,NULL,'K','NGC 1485',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34259,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34259,31.34,0.49,18.5,9261,75,NULL,'IR','NGC 1485',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34260,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34260,31.39,0.4,18.9,9261,75,NULL,NULL,'NGC 1485',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34261,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34261,31.63,0.4,21.2,9261,NULL,NULL,'mean','NGC 1485',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34262,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34262,34.25,0.4,70.9,9262,NULL,NULL,'mean','UGC 02950',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.00002,NULL,'17.',0.3,'S?',NULL,NULL,NULL,NULL,1,61.2762083,31.02658,0.477,NULL,68326219251,1067597175,16681205,17),(34263,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34263,34.34,0.49,73.7,9262,75,NULL,'IR','UGC 02950',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34264,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34264,34.46,0.47,78.1,9262,NULL,NULL,'H','UGC 02950',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34265,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34265,34.52,0.45,80.2,9262,NULL,NULL,'K','UGC 02950',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34266,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34266,34.61,0.46,83.4,9262,NULL,NULL,'J','UGC 02950',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34267,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34267,33.6,0.2,52.5,9263,74.4,NULL,NULL,'UGC 02954',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000017,NULL,'15.23',0.4,'Scd:','Pair member (points to parent)',NULL,NULL,NULL,1,61.376583,4.44539,0.521,NULL,65080439999,1016881874,15888779,15.23),(34268,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34268,33.8,0.39,57.5,9263,NULL,NULL,NULL,'UGC 02954',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34269,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34269,33.95,0.36,61.8,9263,NULL,NULL,'Malmquist cor.','UGC 02954',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34270,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34270,35.81,0.46,145,9264,70,NULL,NULL,'2MASX J04053743-0518543',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000087,NULL,'15.6g',0.39,'S0',NULL,NULL,NULL,NULL,1,61.4059583,-5.31528,0.185,NULL,36961012504,577515820,9023684,15.6),(34271,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34271,35.64,0.57,134,9265,70,NULL,NULL,'2MASX J04055613-1822018',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'17.35',0.17,NULL,NULL,NULL,NULL,NULL,1,61.483875,-18.36728,0.009,NULL,36855407607,575865743,8997902,17.35),(34272,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34272,32.04,0.8,25.5,9266,75,NULL,'MAT, I','UGCA 087',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.000013,NULL,'14.99',0.6,'SB(s)m','X-ray-faint group member',NULL,NULL,NULL,1,61.4997917,-17.77436,0,NULL,36905912699,576654885,9010232,14.99),(34273,'Tully est','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34273,31.78,0.8,22.7,9266,75,NULL,NULL,'UGCA 087',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34274,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34274,31.24,0.32,17.7,9266,85,NULL,'I, inv','UGCA 087',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34275,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34275,31.29,0.32,18.1,9266,85,NULL,'I, raw','UGCA 087',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34276,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34276,31.59,0.43,20.8,9266,75,NULL,'MAT, I, inv','UGCA 087',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34277,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34277,31.71,0.43,22,9266,75,NULL,'MAT, I, raw','UGCA 087',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34278,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34278,31.71,0.4,22,9266,NULL,NULL,NULL,'UGCA 087',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34279,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34279,31.71,0.4,22,9266,73,NULL,'opt','UGCA 087',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34280,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34280,31.86,0.43,23.6,9266,75,NULL,'MAT, I, cor','UGCA 087',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34281,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34281,37.42,0.57,304,9267,70,NULL,NULL,'LCRS B040416.9-381849',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.77',0.33,NULL,NULL,NULL,NULL,NULL,1,61.519125,-38.17981,0,NULL,37679648811,588744512,9199133,16.77),(34282,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34282,35.28,0.5,114,9268,70,NULL,NULL,'GALEXASC J040607.69-620321.2',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,61.5324583,-62.05569,0.029,NULL,35786505765,559164152,8736939,14.7),(34283,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34283,33.74,0.49,55.9,9269,75,NULL,'IR','UGC 02956',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.000033,NULL,'15.3',0.4,'Scd:',NULL,NULL,NULL,NULL,1,61.6187083333,31.28258,0.537,NULL,68325948468,1067592944,16681139,15.3),(34284,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34284,33.74,0.43,56,9269,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02956',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34285,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34285,33.81,0.43,57.9,9269,75,NULL,'3.6 micron, color corrected','UGC 02956',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34286,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34286,33.84,0.2,58.6,9269,74.4,NULL,NULL,'UGC 02956',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34287,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34287,34.02,0.4,63.6,9269,NULL,NULL,'mean','UGC 02956',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34288,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34288,34.03,0.38,64.1,9269,NULL,NULL,NULL,'UGC 02956',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34289,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34289,34.09,0.47,65.9,9269,NULL,NULL,'H','UGC 02956',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34290,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34290,34.22,0.45,69.7,9269,NULL,NULL,'K','UGC 02956',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34291,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34291,34.24,0.35,70.6,9269,NULL,NULL,'Malmquist cor.','UGC 02956',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34292,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34292,36.6,0.66,209,9270,70,NULL,NULL,'2MASX J04063644-0410050',NULL,'2014MNRAS.445.2677S',2014,1,0.74,NULL,'G',0.00015,NULL,'17.06',0.43,NULL,NULL,NULL,NULL,NULL,1,61.651875,-4.16794,0.205,NULL,36963133125,577548955,9024202,17.06),(34293,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34293,36.82,0.71,231,9271,70,NULL,NULL,'2MASX J04063703-7010386',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'16.5b',0.24,NULL,NULL,NULL,NULL,NULL,1,61.6544583,-70.17736,0.341,NULL,36417156160,569018065,8890907,16.5),(34294,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34294,36.91,0.46,241,9272,70,NULL,NULL,'2MASX J04064338-0506530',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000106,NULL,'15.9g',0.47,'E0',NULL,NULL,NULL,NULL,1,61.6807917,-5.11472,0.185,NULL,36963687958,577557624,9024337,15.9),(34295,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34295,30.4,0.8,12,9273,75,NULL,'MAT, I','NGC 1518',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.00001,NULL,'12.28',1.3,'SB(s)dm        HII','Line-of-sight pair member',NULL,NULL,NULL,1,61.707167,-21.17264,0.033,NULL,36845454138,575710220,8995472,12.28),(34296,'Tully est','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34296,30.11,0.8,10.5,9273,75,NULL,'B','NGC 1518',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34297,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34297,28.96,0.32,6.24,9273,85,NULL,'I, inv','NGC 1518',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34298,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34298,29.03,0.32,6.37,9273,85,NULL,'I, raw','NGC 1518',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34299,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34299,29.38,0.43,7.5,9273,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1518',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34300,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34300,29.46,0.43,7.8,9273,75,NULL,'MAT, I, inv','NGC 1518',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34301,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34301,29.51,0.43,8,9273,75,NULL,'3.6 micron, color corrected','NGC 1518',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34302,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34302,29.55,0.43,8.13,9273,75,NULL,'MAT, I, raw','NGC 1518',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34303,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34303,29.59,0.2,8.28,9273,74.4,NULL,NULL,'NGC 1518',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34304,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34304,29.9,0.43,9.55,9273,75,NULL,'MAT, I, cor','NGC 1518',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34305,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34305,34.59,0.47,82.9,9274,NULL,NULL,'H','UGC 02958',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000033,NULL,'14.98',0.3,'Sb',NULL,NULL,NULL,NULL,1,61.721125,22.86328,0.713,NULL,67984905026,1062264141,16597877,14.98),(34306,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34306,34.61,0.49,83.7,9274,75,NULL,'IR','UGC 02958',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34307,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34307,34.66,0.45,85.4,9274,NULL,NULL,'K','UGC 02958',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34308,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34308,34.69,0.4,86.6,9274,NULL,NULL,'mean','UGC 02958',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34309,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34309,34.72,0.46,87.8,9274,NULL,NULL,'J','UGC 02958',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34310,'Tully est','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34310,30.64,0.8,13.4,9275,75,NULL,NULL,'IC 2032',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000024,NULL,'14.73',0.8,'IAB(s)m pec:',NULL,NULL,NULL,NULL,1,61.762667,-55.32383,0,NULL,35808690848,559510794,8742356,14.73),(34311,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34311,35.71,0.64,139,9276,70,NULL,NULL,'MCG -02-11-016',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15',0.5,NULL,NULL,NULL,NULL,NULL,1,61.7994166667,-10.22972,0.101,NULL,36993403074,578021923,9031592,15),(34312,'Tully est','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34312,31.75,0.8,22.4,9277,75,NULL,NULL,'UGCA 088',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000017,NULL,'14.90',1.9,'SB(s)dm','X-ray-faint group member',NULL,NULL,NULL,1,61.8042917,-17.20383,0.013,NULL,36904216932,576628389,9009818,14.9),(34313,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34313,36.35,0.71,186,9278,70,NULL,NULL,'2MASX J04071325-0526133',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.000067,NULL,'16.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,61.8052083,-5.43708,0.185,NULL,36964012549,577562696,9024417,16.4),(34314,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34314,35.45,0.49,123,9279,70,NULL,NULL,'MCG +00-11-013',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.000073,NULL,'15.5',0.2,'poss. LINER',NULL,NULL,NULL,NULL,1,61.8865416667,-2.43269,0.241,NULL,36970672256,577666754,9026043,15.5),(34315,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34315,33.38,0.2,47.4,9280,74.4,NULL,NULL,'UGC 02963',NULL,'2013AJ....146...86T',2013,1,2,NULL,'G',0.000023,NULL,'14.78',0.6,'Sd',NULL,NULL,NULL,NULL,1,61.9115416667,3.96817,0.569,NULL,65080844294,1016888192,15888878,14.78),(34316,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34316,33.5,0.49,50,9280,75,NULL,'IR','UGC 02963',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34317,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34317,33.58,0.45,52.1,9280,NULL,NULL,NULL,'UGC 02963',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34318,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34318,33.7,0.47,54.9,9280,NULL,NULL,'H','UGC 02963',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34319,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34319,33.75,0.42,56.3,9280,NULL,NULL,'Malmquist cor.','UGC 02963',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34320,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34320,33.8,0.45,57.5,9280,NULL,NULL,'K','UGC 02963',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34321,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34321,33.81,0.46,57.9,9280,NULL,NULL,'J','UGC 02963',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34322,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34322,34.23,0.4,70,9280,NULL,NULL,'mean','UGC 02963',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34323,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34323,34.02,0.49,63.6,9281,75,NULL,'IR','UGC 02962',NULL,'2011yCatp016004901K',2011,1,1.38,NULL,'G',0.000013,NULL,'18.',0.15,'Scd',NULL,NULL,NULL,NULL,1,61.926583,25.77269,0.385,NULL,68454913930,1069608030,16712625,18),(34324,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34324,34.7,NULL,87,9281,NULL,NULL,'Dipole + Quadrupole','UGC 02962',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34325,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34325,34.7,NULL,87,9281,NULL,NULL,'Dipole','UGC 02962',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34326,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34326,34.7,NULL,87,9281,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 02962',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34327,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34327,34.77,NULL,89.8,9281,NULL,NULL,NULL,'UGC 02962',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34328,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34328,37.5,0.33,316,9282,70,NULL,NULL,'2MASX J04074376-0618570',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000098,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,61.932333,-6.316,0.173,NULL,36952550390,577383599,9021618,16.8),(34329,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34329,33.66,0.8,54,9283,75,NULL,'MAT, I','ESO 420- G 003',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.00003,NULL,'13.67',1.3,'SA(rs)bc       HII',NULL,NULL,NULL,NULL,1,61.94025,-29.85858,0,NULL,37655813291,588372082,9193313,13.67),(34330,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34330,33,0.69,39.8,9283,100,NULL,'mid-IR','ESO 420- G 003',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34331,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34331,33.78,0.32,56.9,9283,85,NULL,'I, raw','ESO 420- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34332,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34332,33.78,0.43,57.1,9283,75,NULL,'MAT, I, raw','ESO 420- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34333,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34333,33.83,0.32,58.3,9283,85,NULL,'I, inv','ESO 420- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34334,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34334,33.93,0.4,61,9283,NULL,NULL,'mean','ESO 420- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34335,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34335,34.01,0.43,63.4,9283,75,NULL,'MAT, I, inv','ESO 420- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34336,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34336,34.02,0.43,63.7,9283,75,NULL,'MAT, I, cor','ESO 420- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34337,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34337,34.13,0.47,67,9283,NULL,NULL,'H','ESO 420- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34338,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34338,34.15,0.46,67.7,9283,NULL,NULL,'J','ESO 420- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34339,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34339,34.24,0.45,70.5,9283,NULL,NULL,'K','ESO 420- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34340,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34340,34.25,0.4,70.7,9283,NULL,NULL,'Malmquist cor.','ESO 420- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34341,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34341,34.27,0.39,71.6,9283,NULL,NULL,NULL,'ESO 420- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34342,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34342,34.31,0.2,72.8,9283,74.4,NULL,NULL,'ESO 420- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34343,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34343,31.05,0.4,16.2,9284,75,NULL,'B','IC 0356',NULL,'1988NBGC.C....0000T',1988,1,5.2,NULL,'G',0.000003,NULL,'11.39',3.9,'SA(s)ab pec','Possible group member',NULL,NULL,NULL,1,61.9454583,69.81244,1.109,NULL,66424050994,1037875796,16216809,11.39),(34344,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34344,31.67,0.4,21.6,9284,NULL,NULL,NULL,'IC 0356',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34345,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34345,34.18,0.64,68.5,9285,NULL,NULL,'Malmquist cor.','ESO 250- G 006',NULL,'2009ApJS..182..474S',2009,1,1.12,NULL,'G',0.000033,NULL,'15.81',0.21,'S?',NULL,NULL,NULL,NULL,1,61.947417,-45.03989,0,NULL,37787386787,590427918,9225436,15.81),(34346,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34346,34.28,0.61,71.9,9285,NULL,NULL,NULL,'ESO 250- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34347,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34347,34.31,0.49,72.9,9285,75,NULL,'IR','ESO 250- G 006',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34348,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34348,34.32,0.2,73.1,9285,74.4,NULL,NULL,'ESO 250- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34349,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34349,33.08,0.43,41.3,9286,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J04075531+4549400',NULL,'2014MNRAS.444..527S',2014,1,0.34,'ZOAG G154.84-04.52a and b may both contribute to the IRAS flux.','G',0.00002,NULL,NULL,0.11,NULL,NULL,NULL,NULL,NULL,1,61.9805416667,45.82778,NULL,NULL,68270720443,1066730006,16667656,NULL),(34350,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34350,37.5,0.33,316,9287,70,NULL,NULL,'SDSS J040756.93-061338.7',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000069,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,61.98725,-6.22744,0.173,NULL,36952582351,577384099,9021626,18.5),(34351,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34351,34.62,NULL,83.8,9288,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0467',NULL,'2010Ap&SS.325..163P',2010,1,0.97,NULL,'G',0.000009,NULL,'16.9',0.09,'Scd',NULL,NULL,NULL,NULL,1,61.99125,33.43278,1.013,NULL,68373738991,1068339671,16692807,16.9),(34352,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34352,34.62,NULL,83.9,9288,NULL,NULL,'Dipole','FGC 0467',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34353,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34353,34.63,NULL,84.2,9288,NULL,NULL,'Dipole + Quadrupole','FGC 0467',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34354,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34354,34.69,NULL,86.7,9288,NULL,NULL,NULL,'FGC 0467',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34355,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34355,31.98,0.8,24.9,9289,75,NULL,'MAT, I','NGC 1519',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.00002,NULL,'13.61',0.5,'SB(r)b:','X-ray-faint group member',NULL,NULL,NULL,1,62.031667,-17.19289,0.013,NULL,36904362885,576630670,9009854,13.61),(34356,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34356,30.73,0.4,14,9289,73,NULL,'IR','NGC 1519',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34357,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34357,30.74,0.4,14,9289,75,NULL,NULL,'NGC 1519',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34358,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34358,31.11,0.39,16.7,9289,73,NULL,'opt','NGC 1519',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34359,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34359,31.11,0.43,16.7,9289,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1519',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34360,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34360,31.2,0.43,17.4,9289,75,NULL,'3.6 micron, color corrected','NGC 1519',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34361,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34361,31.22,0.49,17.6,9289,75,NULL,'IR','NGC 1519',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34362,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34362,31.26,0.2,17.9,9289,74.4,NULL,NULL,'NGC 1519',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34363,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34363,31.49,0.4,19.9,9289,NULL,NULL,NULL,'NGC 1519',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34364,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34364,31.65,0.32,21.4,9289,85,NULL,'I, raw','NGC 1519',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34365,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34365,31.65,0.32,21.4,9289,85,NULL,'I, inv','NGC 1519',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34366,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34366,31.9,0.43,24,9289,75,NULL,'MAT, I, raw','NGC 1519',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34367,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34367,31.95,0.43,24.6,9289,75,NULL,'MAT, I, inv','NGC 1519',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34368,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34368,32.02,0.43,25.3,9289,75,NULL,'MAT, I, cor','NGC 1519',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34369,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34369,32.15,0.4,26.9,9289,NULL,NULL,'mean','NGC 1519',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34370,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34370,32.21,0.47,27.7,9289,NULL,NULL,'H','NGC 1519',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34371,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34371,32.28,0.46,28.6,9289,NULL,NULL,'J','NGC 1519',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34372,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34372,32.3,0.45,28.9,9289,NULL,NULL,'K','NGC 1519',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34373,'SBF','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34373,34.12,0.38,66.8,9290,NULL,NULL,'Malmquist cor.','NGC 1521',NULL,'2001MNRAS.327.1004B',2001,1,2.8,NULL,'G',0.00004,NULL,'13.10',1.7,'E3:            LINER','Line-of-sight pair member',NULL,NULL,NULL,1,62.078875,-21.05197,0.009,NULL,36856706057,575886032,8998219,13.1),(34374,'SBF','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34374,34.14,0.38,67.3,9290,NULL,NULL,'I','NGC 1521',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34375,'SBF','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34375,34.14,0.38,67.3,9290,NULL,NULL,NULL,'NGC 1521',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34376,'SBF','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34376,34.21,0.14,69.5,9290,74.4,NULL,NULL,'NGC 1521',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34377,'D-Sigma','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34377,33.06,0.4,40.9,9290,75,NULL,'Edat, raw','NGC 1521',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34378,'D-Sigma','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34378,33.39,0.4,47.7,9290,75,NULL,'Edat, cor','NGC 1521',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34379,'Faber-Jackson','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34379,32.61,0.28,33.3,9290,95,NULL,'Weighted Mean','NGC 1521',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34380,'Faber-Jackson','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34380,32.76,0.43,35.6,9290,95,NULL,'de Vaucouleurs','NGC 1521',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34381,'Faber-Jackson','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34381,33.13,0.46,42.3,9290,95,NULL,'Michard 1979a','NGC 1521',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34382,'Faber-Jackson','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34382,33.15,0.63,42.7,9290,95,NULL,'Michard 1979b, c','NGC 1521',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34383,'Faber-Jackson','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34383,33.48,0.81,49.7,9290,55,NULL,'Visvanathan & Sandage 1979','NGC 1521',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34384,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34384,33.45,0.41,48.9,9290,NULL,NULL,NULL,'NGC 1521',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34385,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34385,33.81,0.41,57.8,9290,NULL,NULL,'Malmquist cor.','NGC 1521',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34386,'Tertiary','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34386,33.06,0.5,40.9,9290,95,NULL,NULL,'NGC 1521',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34387,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34387,33.5,0.45,50,9290,NULL,NULL,'K','NGC 1521',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34388,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34388,33.66,0.4,54.1,9290,NULL,NULL,'mean','NGC 1521',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34389,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34389,35.7,0.53,138,9291,70,NULL,NULL,'ESO 156- G 044',NULL,'2014MNRAS.445.2677S',2014,1,0.85,NULL,'G',0.00015,NULL,'15.15',0.67,'(R)SB(r)0^+',NULL,NULL,NULL,NULL,1,62.08425,-54.05142,0,NULL,35809659799,559525934,8742592,15.15),(34390,'SBF','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34390,31.16,0.12,17.1,9292,74.4,NULL,NULL,'NGC 1527',NULL,'2013AJ....146...86T',2013,1,3.7,NULL,'G',0.000057,NULL,'11.74',1.4,'SA(r)0^0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,62.100583,-47.89703,0,NULL,37736515787,589633059,9213016,11.74),(34391,'SBF','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34391,31.28,0.22,18,9292,NULL,NULL,'I','NGC 1527',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34392,'SBF','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34392,31.28,0.22,18,9292,NULL,NULL,NULL,'NGC 1527',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34393,'SBF','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34393,31.33,0.22,18.5,9292,NULL,NULL,'Malmquist cor.','NGC 1527',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34394,'Faber-Jackson','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34394,30.79,0.65,14.4,9292,95,NULL,'Weighted Mean','NGC 1527',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34395,'Faber-Jackson','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34395,31.25,NULL,17.8,9292,NULL,NULL,'LEDA [April 2006]','NGC 1527',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34396,'Faber-Jackson','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34396,31.96,0.81,24.7,9292,55,NULL,'Visvanathan & Sandage 1979','NGC 1527',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34397,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34397,31.09,0.41,16.5,9292,NULL,NULL,NULL,'NGC 1527',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34398,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34398,31.16,0.12,17.1,9292,74.4,NULL,NULL,'NGC 1527',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34399,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34399,31.27,0.41,18,9292,NULL,NULL,'Malmquist cor.','NGC 1527',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34400,'Tully est','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34400,30.22,0.8,11,9292,75,NULL,'B','NGC 1527',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34401,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34401,30.89,0.45,15.1,9292,NULL,NULL,'K','NGC 1527',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34402,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34402,31.26,0.4,17.9,9292,NULL,NULL,'mean','NGC 1527',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34403,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34403,31.41,0.4,19.2,9293,NULL,NULL,'mean','UGC 02955',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000037,NULL,'17.',0.4,'S?',NULL,NULL,NULL,NULL,1,62.122125,69.67253,1.261,NULL,66424136225,1037877128,16216830,17),(34404,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34404,31.84,0.46,23.4,9293,NULL,NULL,'J','UGC 02955',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34405,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34405,31.91,0.45,24.1,9293,NULL,NULL,'K','UGC 02955',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34406,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34406,31.92,0.47,24.2,9293,NULL,NULL,'H','UGC 02955',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34407,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34407,36.84,0.58,233,9294,70,NULL,NULL,'ESO 118-IG 006',NULL,'2014MNRAS.445.2677S',2014,1,0.91,NULL,'G',0.00015,NULL,'15.23',0.45,'E+4',NULL,NULL,NULL,NULL,1,62.1242083,-60.82394,0,NULL,35787352512,559177383,8737146,15.23),(34408,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34408,36.57,0.63,206,9295,70,NULL,NULL,'2MASX J04083884-5500141',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.28',0.45,'S0',NULL,NULL,NULL,NULL,1,62.16175,-55.00392,0,NULL,35808251525,559503930,8742248,16.28),(34409,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34409,36.97,0.87,248,9296,70,NULL,NULL,'2MASX J04084497-1037554',NULL,'2014MNRAS.445.2677S',2014,1,0.79,NULL,'G',0.00015,NULL,'16.85',0.35,NULL,NULL,NULL,NULL,NULL,1,62.1875,-10.63194,0.145,NULL,36990943351,577983489,9030992,16.85),(34410,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34410,33.18,0.2,43.3,9297,74.4,NULL,NULL,'UGC 02966',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000023,NULL,'16.5',0.5,'Scd:',NULL,NULL,NULL,NULL,1,62.196333,8.51553,0.525,NULL,65172971542,1018327680,15911370,16.5),(34411,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34411,33.48,0.46,49.7,9297,NULL,NULL,NULL,'UGC 02966',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34412,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34412,33.76,0.4,56.5,9297,NULL,NULL,'Malmquist cor.','UGC 02966',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34413,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34413,31.42,NULL,19.2,9298,NULL,NULL,NULL,'IC 2038',NULL,'2013AJ....145..101K',2013,1,1.7,'ESO-LV gives 250 +/- 100 km/sec.','G',0.000173,NULL,'14.9B',0.4,'Sd pec:','in a pair',NULL,NULL,NULL,1,62.2239583,-55.98956,0,NULL,35820417927,559694030,8745219,14.9),(34414,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34414,37.24,0.46,281,9299,70,NULL,NULL,'2MASX J04085793-0538004',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000101,NULL,'16.3g',0.35,'E0',NULL,NULL,NULL,NULL,1,62.24125,-5.63342,0.185,NULL,36964120365,577564380,9024443,16.3),(34415,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34415,33.63,0.8,53.3,9300,75,NULL,'MAT, I','ESO 201- G 022',NULL,'1997ApJS..109..333W',1997,1,2.39,NULL,'G',0.000001,NULL,'14.69',0.24,'Sbc            HII',NULL,NULL,NULL,NULL,1,62.249625,-48.727,0,NULL,37739895403,589685865,9213841,14.69),(34416,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34416,33.61,NULL,52.7,9300,NULL,NULL,NULL,'ESO 201- G 022',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34417,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34417,33.63,0.49,53.1,9300,75,NULL,'IR','ESO 201- G 022',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34418,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34418,33.64,NULL,53.4,9300,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 201- G 022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34419,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34419,33.66,NULL,54,9300,NULL,NULL,'Dipole + Quadrupole','ESO 201- G 022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34420,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34420,33.67,NULL,54.2,9300,NULL,NULL,'Dipole','ESO 201- G 022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34421,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34421,33.76,0.43,56.6,9300,75,NULL,'MAT, I, raw','ESO 201- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34422,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34422,33.82,0.32,58,9300,85,NULL,'I, raw','ESO 201- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34423,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34423,33.85,0.32,59,9300,85,NULL,'I, inv','ESO 201- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34424,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34424,33.95,0.43,61.6,9300,75,NULL,'MAT, I, inv','ESO 201- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34425,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34425,33.97,0.4,62.1,9300,NULL,NULL,'mean','ESO 201- G 022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34426,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34426,34.05,0.47,64.7,9300,NULL,NULL,'H','ESO 201- G 022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34427,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34427,34.12,0.43,66.8,9300,75,NULL,'MAT, I, cor','ESO 201- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34428,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34428,34.15,0.45,67.6,9300,NULL,NULL,'K','ESO 201- G 022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34429,'FP','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,'R',34429,37.47,0.46,312,9301,70,NULL,NULL,'2MASX J04090161-0610462',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000087,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,62.256625,-6.17958,0.173,NULL,36955232732,577425511,9022273,17),(34430,'IRAS','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34430,34.18,0.8,68.4,9302,75,NULL,'CF, r','UGC 02969',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000123,NULL,'14.64',0.4,'SB(s)bc:       HII',NULL,NULL,NULL,NULL,1,62.2565,-1.15961,0.353,NULL,36969406094,577646970,9025733,14.64),(34431,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34431,33.17,0.38,43,9302,75,NULL,'CF, r, raw','UGC 02969',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34432,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34432,33.2,0.38,43.7,9302,75,NULL,'CF, r, inv','UGC 02969',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34433,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34433,33.44,0.2,48.8,9302,74.4,NULL,NULL,'UGC 02969',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34434,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34434,33.48,0.38,49.7,9302,75,NULL,'CF, r, cor','UGC 02969',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34435,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:06','1',NULL,NULL,34435,33.61,0.39,52.8,9302,NULL,NULL,NULL,'UGC 02969',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34436,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:07','1',NULL,NULL,34436,33.89,0.34,59.9,9302,NULL,NULL,'Malmquist cor.','UGC 02969',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34437,'GCLF','2016-12-15 15:14:02','2016-12-16 11:19:07','1',NULL,NULL,34437,31.8,0.19,22.9,9303,NULL,NULL,'TOM(g) = -7.2 mag','IC 2035',NULL,'2012MNRAS.422.3591C',2012,1,1.2,NULL,'G',0.000043,NULL,'12.50',0.9,'S0 pec?','Group member',NULL,NULL,NULL,1,62.2577917,-45.51753,0,NULL,37786746755,590417918,9225279,12.5),(34438,'Faber-Jackson','2016-12-15 15:14:02','2016-12-16 11:19:07','1',NULL,NULL,34438,28.26,1.31,4.49,9303,95,NULL,'Weighted Mean','IC 2035',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34439,'Faber-Jackson','2016-12-15 15:14:02','2016-12-16 11:19:07','1',NULL,NULL,34439,28.84,1.61,5.86,9303,55,NULL,'Visvanathan & Sandage 1979','IC 2035',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34440,'FP','2016-12-15 15:14:02','2016-12-16 11:19:07','1',NULL,NULL,34440,29.91,0.25,9.59,9303,74.4,NULL,NULL,'IC 2035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34441,'Tully est','2016-12-15 15:14:02','2016-12-16 11:19:07','1',NULL,NULL,34441,31.08,0.8,16.5,9303,75,NULL,'B','IC 2035',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34442,'FP','2016-12-15 15:14:02','2016-12-16 11:19:07','1',NULL,NULL,34442,34.39,0.56,75.7,9304,70,NULL,NULL,'LSBG F118-033',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.00015,NULL,'15.30',0.63,'(R_1R\'_2)SAB(l:)0^+',NULL,NULL,NULL,NULL,1,62.2609166667,-59.10914,0,NULL,35791545185,559242893,8738170,15.3),(34443,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:07','1',NULL,'R',34443,34.39,0.49,75.7,9305,75,NULL,'IR','UGC 02968',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000017,NULL,'16.0',0.4,'Sb:',NULL,NULL,NULL,NULL,1,62.286833,17.11169,1.433,NULL,65153452622,1018022697,15906604,16),(34444,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:07','1',NULL,NULL,34444,34.91,0.47,95.8,9305,NULL,NULL,'H','UGC 02968',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34445,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:07','1',NULL,NULL,34445,34.99,0.45,99.6,9305,NULL,NULL,'K','UGC 02968',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34446,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:07','1',NULL,NULL,34446,34.99,0.46,99.7,9305,NULL,NULL,'J','UGC 02968',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34447,'Tully-Fisher','2016-12-15 15:14:02','2016-12-16 11:19:07','1',NULL,NULL,34447,35.04,0.4,102,9305,NULL,NULL,'mean','UGC 02968',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34448,'FP','2016-12-15 15:14:02','2016-12-16 11:19:07','1',NULL,NULL,34448,36.98,0.66,249,9306,70,NULL,NULL,'2MASX J04091160-7528397',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'16.9b',0.12,NULL,NULL,NULL,NULL,NULL,1,62.298625,-75.47775,0.401,NULL,35524865738,555076027,8673062,16.9),(34449,'FP','2016-12-15 15:14:02','2016-12-16 11:19:07','1',NULL,NULL,34449,35.5,0.52,126,9307,70,NULL,NULL,'ARK 105',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.000053,NULL,'15.5',0.15,NULL,NULL,NULL,NULL,NULL,1,62.299625,-1.47681,0.257,NULL,36968923615,577639431,9025616,15.5),(34450,'FP','2016-12-15 15:14:02','2016-12-16 11:19:07','1',NULL,NULL,34450,35.42,0.53,121,9308,70,NULL,NULL,'CGCG 392-004',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00006,NULL,'15.7',0.4,NULL,NULL,NULL,NULL,NULL,1,62.308,-1.47156,0.257,NULL,36969382597,577646603,9025728,15.7),(34451,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34451,35.47,0.48,124,9309,70,NULL,NULL,'2MASX J04092406-2149595',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.000083,NULL,'15.90',0.42,'S0',NULL,NULL,NULL,NULL,1,62.3500416667,-21.83339,0.037,NULL,36845980219,575718440,8995600,15.9),(34452,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34452,36.22,0.52,175,9310,70,NULL,NULL,'2MASX J04092469-5505313',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.33',0.32,'S0',NULL,NULL,NULL,NULL,1,62.3530417,-55.09197,0,NULL,35808252141,559503939,8742249,16.33),(34453,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34453,33.45,0.2,49,9311,74.4,NULL,NULL,'ESO 550- G 014',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.00001,NULL,'15.36',1,'SB(s)d',NULL,NULL,NULL,NULL,1,62.383083,-21.77281,0.037,NULL,36845988821,575718575,8995602,15.36),(34454,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34454,37.46,0.33,310,9312,70,NULL,NULL,'2MASX J04093522-0618433',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000069,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,62.39675,-6.31208,0.177,NULL,36955281604,577426275,9022285,17.7),(34455,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34455,37.46,0.33,310,9313,70,NULL,NULL,'2MASX J04094220-0618564',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000104,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,62.425833,-6.31556,0.177,NULL,36955264990,577426015,9022281,16.4),(34456,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34456,36.64,0.69,213,9314,70,NULL,NULL,'2MASX J04094370-6947235',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,62.432,-69.78992,0.357,NULL,36425367636,569146369,8892912,16.8),(34457,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34457,36.19,0.86,173,9315,70,NULL,NULL,'2MASX J04095106-1026359',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.90',0.36,NULL,NULL,NULL,NULL,NULL,1,62.46275,-10.44333,0.145,NULL,36992936630,578014634,9031478,16.9),(34458,'GCLF','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34458,31.41,0.29,19.1,9316,NULL,NULL,'TOM(I) = -8.59 mag','NGC 1533',NULL,'2007ApJ...671.1624D',2007,1,2.8,'Extended HIPASS source','G',0.000017,NULL,'11.70',2.3,'(L)SB(rs)0^0   LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,62.466,-56.11844,0,NULL,35820446922,559694483,8745226,11.7),(34459,'SBF','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34459,31.44,0.12,19.4,9316,NULL,NULL,NULL,'NGC 1533',NULL,'2007ApJ...671.1624D',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34460,'SBF','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34460,31.56,0.14,20.5,9316,74.4,NULL,NULL,'NGC 1533',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34461,'SBF','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34461,31.65,0.38,21.4,9316,NULL,NULL,'I','NGC 1533',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34462,'GC radius','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34462,31.35,0.22,18.6,9316,NULL,NULL,NULL,'NGC 1533',NULL,'2007ApJ...671.1624D',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34463,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34463,31.18,0.37,17.2,9316,95,NULL,'Weighted Mean','NGC 1533',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34464,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34464,31.29,0.63,18.1,9316,95,NULL,'Michard 1979b, c','NGC 1533',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34465,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34465,31.54,0.46,20.3,9316,95,NULL,'Michard 1979a','NGC 1533',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34466,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34466,32.39,0.81,30.1,9316,55,NULL,'Visvanathan & Sandage 1979','NGC 1533',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34467,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34467,31.91,0.84,24.1,9316,70,NULL,NULL,'NGC 1533',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34468,'Tully est','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34468,30.64,0.8,13.4,9316,75,NULL,'B','NGC 1533',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34469,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34469,35.1,0.48,104,9317,70,NULL,NULL,'2MASX J04095479-0841569',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.000103,NULL,'15.88',0.58,NULL,NULL,NULL,NULL,NULL,1,62.478167,-8.69908,0.069,NULL,36984145448,577877272,9029332,15.88),(34470,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34470,35.21,0.49,110,9318,75,NULL,'IR','UGC 02973',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.0001,NULL,'15.17',0.3,'Sab',NULL,NULL,NULL,NULL,1,62.48,-1.37414,0.353,NULL,36969315376,577645552,9025711,15.17),(34471,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34471,35.92,0.5,153,9319,70,NULL,NULL,'MCG -02-11-021',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000133,NULL,'15.11',0.5,NULL,NULL,NULL,NULL,NULL,1,62.481375,-10.26906,0.121,NULL,36992949882,578014841,9031481,15.11),(34472,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34472,36.32,0.5,183,9320,70,NULL,NULL,'6dF J0410190-245724',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.000083,NULL,'16.05',0.5,'S0',NULL,NULL,NULL,NULL,1,62.5789583,-24.95667,0.065,NULL,38521381210,601896581,9404634,16.05),(34473,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34473,38.37,0.46,472,9321,70,NULL,NULL,'SDSS J041021.50-041346.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000074,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,62.589583,-4.22967,0.137,NULL,36975970159,577749533,9027336,18.6),(34474,'IRAS','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34474,33.74,0.8,55.9,9322,75,NULL,'MAT, I','ESO 483- G 012',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'14.34',0.5,'S0/a: sp       HII',NULL,NULL,NULL,NULL,1,62.5940417,-23.61694,0.069,NULL,37984575058,593508985,9273577,14.34),(34475,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34475,32.91,0.32,38.2,9322,85,NULL,'I, raw','ESO 483- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34476,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34476,32.93,0.32,38.6,9322,85,NULL,'I, inv','ESO 483- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34477,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34477,33.03,0.43,40.4,9322,75,NULL,'MAT, I, raw','ESO 483- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34478,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34478,33.16,0.43,42.9,9322,75,NULL,'MAT, I, inv','ESO 483- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34479,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34479,33.47,0.43,49.3,9322,75,NULL,'MAT, I, cor','ESO 483- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34480,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34480,33.59,0.58,52.2,9322,NULL,NULL,'Malmquist cor.','ESO 483- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34481,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34481,33.86,0.51,59.1,9322,NULL,NULL,NULL,'ESO 483- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34482,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34482,33.9,0.2,60.3,9322,74.4,NULL,NULL,'ESO 483- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34483,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34483,36.09,0.62,165,9323,70,NULL,NULL,'2MASX J04102386-6957576',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'16.4b',0.26,NULL,NULL,NULL,NULL,NULL,1,62.599667,-69.96597,0.357,NULL,36424643405,569135053,8892735,16.4),(34484,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34484,35.63,0.71,134,9324,70,NULL,NULL,'2MASX J04103232-6918036',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'16.4b',0.16,NULL,NULL,NULL,NULL,NULL,1,62.63475,-69.30111,0.357,NULL,36424771247,569137050,8892766,16.4),(34485,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34485,35.99,0.51,158,9325,70,NULL,NULL,'LSBG F156-039',NULL,'2014MNRAS.445.2677S',2014,1,0.87,NULL,'G',0.00015,NULL,'15.37',0.55,'S0',NULL,NULL,NULL,NULL,1,62.6349583,-54.68433,0,NULL,35808112660,559501760,8742215,15.37),(34486,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34486,32.5,0.43,31.6,9326,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-11-004',NULL,'2014MNRAS.444..527S',2014,1,2.2,NULL,'G',0.000013,NULL,'14',0.22,'Sd',NULL,NULL,NULL,NULL,1,62.637917,-7.16667,0.193,NULL,36955956113,577436814,9022450,14),(34487,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34487,32.6,NULL,33.2,9326,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -01-11-004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34488,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34488,32.62,NULL,33.4,9326,NULL,NULL,'Dipole + Quadrupole','MCG -01-11-004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34489,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34489,32.62,NULL,33.4,9326,NULL,NULL,'Dipole','MCG -01-11-004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34490,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34490,36.5,0.75,200,9327,70,NULL,NULL,'2MASX J04104281-1526458',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.38',0.35,NULL,NULL,NULL,NULL,NULL,1,62.6782083333,-15.44606,0.037,NULL,36870227870,576097310,9001520,16.38),(34491,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34491,37.43,0.46,306,9328,70,NULL,NULL,'2MASX J04104601-0510557',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000124,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,62.6917917,-5.18225,0.137,NULL,36961727665,577526994,9023859,16.6),(34492,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34492,36.29,0.54,181,9329,70,NULL,NULL,'2MASX J04104860-0640413',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.70',0.4,NULL,NULL,NULL,NULL,NULL,1,62.702583,-6.67819,0.229,NULL,36955362935,577427545,9022305,16.7),(34493,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34493,35.17,0.56,108,9330,70,NULL,NULL,'MCG -02-11-023',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.00003,NULL,'14.5',0.8,'SB(s)cd:',NULL,NULL,NULL,NULL,1,62.707875,-9.62922,0.185,NULL,36992655577,578010243,9031410,14.5),(34494,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34494,35.69,0.4,138,9330,NULL,NULL,'mean','MCG -02-11-023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34495,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34495,35.85,0.47,148,9330,NULL,NULL,'H','MCG -02-11-023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34496,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34496,35.95,0.45,155,9330,NULL,NULL,'K','MCG -02-11-023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34497,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34497,35.78,0.46,143,9331,70,NULL,NULL,'2MASX J04105565-0636053',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00007,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,62.7320416667,-6.60158,0.137,NULL,36954297239,577410894,9022045,16.5),(34498,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34498,34.9,0.5,95.6,9332,70,NULL,NULL,'2MASX J04105768-6644007',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.6b',0.6,NULL,NULL,NULL,NULL,NULL,1,62.7402083,-66.73358,0.113,NULL,36395300932,568676577,8885571,15.6),(34499,'Tully est','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34499,30.64,0.8,13.4,9333,75,NULL,'B','NGC 1536',NULL,'1988NBGC.C....0000T',1988,1,2,'The ESO position is southeast of the eccentric nucleus.','G',0.000043,NULL,'13.15',1.4,'SB(s)c pec:    HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,62.749417,-56.48044,0,NULL,35821278911,559707482,8745429,13.15),(34500,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34500,36.91,0.46,241,9334,70,NULL,NULL,'SDSS J041104.08-060904.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000098,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,62.767,-6.15133,0.149,NULL,36954330531,577411414,9022053,18.5),(34501,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34501,35.98,0.58,157,9335,70,NULL,NULL,'FAIRALL 1277',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.3B',0.27,NULL,NULL,NULL,NULL,NULL,1,62.768333,-77.44058,0.337,NULL,35672585343,557384145,8709127,16.3),(34502,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34502,34.63,0.51,84.5,9336,70,NULL,NULL,'MCG -03-11-017',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000037,NULL,'14.66',0.4,'Sbc',NULL,NULL,NULL,NULL,1,62.7795,-14.86978,0.053,NULL,36873102423,576142225,9002222,14.66),(34503,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34503,35.51,0.47,126,9336,NULL,NULL,'H','MCG -03-11-017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34504,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34504,35.56,0.4,130,9336,NULL,NULL,'mean','MCG -03-11-017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34505,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34505,35.58,0.45,131,9336,NULL,NULL,'K','MCG -03-11-017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34506,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34506,35.59,0.46,131,9336,NULL,NULL,'J','MCG -03-11-017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34507,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34507,32.96,0.43,39.1,9337,75,NULL,'3.6 micron, color + selection bias corrected','MCG -03-11-018',NULL,'2014MNRAS.444..527S',2014,1,1.4,NULL,'G',0.000037,NULL,'15',0.4,'SB(s)m: sp','X-ray-faint group member',NULL,NULL,NULL,1,62.832125,-16.23006,0.013,NULL,36903169796,576612028,9009562,15),(34508,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34508,37.17,0.46,271,9338,70,NULL,NULL,'2MASX J04112091-0633074',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000085,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,62.8372917,-6.55211,0.137,NULL,36954302039,577410969,9022046,17.1),(34509,'IRAS','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34509,34.67,0.8,85.7,9339,75,NULL,'W91PP, r','UGC 02976',NULL,'1997ApJS..109..333W',1997,1,1.5,'Marzke, et al. (1996,AJ,112,1803) give v = 6345 +/- 34 km/sec.','G',0.000033,NULL,'14.40',0.7,'Scd:',NULL,NULL,NULL,NULL,1,62.844417,26.884,0.353,NULL,68319268516,1067488570,16679508,14.4),(34510,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34510,34.33,0.38,73.4,9339,75,NULL,'W91PP, r, raw','UGC 02976',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34511,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34511,34.51,0.38,79.8,9339,75,NULL,'W91PP, r, inv','UGC 02976',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34512,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34512,34.58,0.38,82.5,9339,75,NULL,'W91PP, r, cor','UGC 02976',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34513,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34513,37.81,0.46,365,9340,70,NULL,NULL,'2MASX J04113822-0618524',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000084,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,62.90925,-6.31453,0.149,NULL,36954356714,577411823,9022059,17.7),(34514,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34514,36.45,0.63,195,9341,70,NULL,NULL,'LCRS B040959.4-383454',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'16.18',0.3,'S',NULL,NULL,NULL,NULL,1,62.941667,-38.45392,0,NULL,37671619173,588619049,9197172,16.18),(34515,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34515,35.84,0.6,147,9342,70,NULL,NULL,'AM 0411-591 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.16',0.39,NULL,NULL,NULL,NULL,NULL,1,62.9815417,-59.16564,0,NULL,35793358966,559271233,8738613,16.16),(34516,'Tully est','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34516,30.57,0.8,13,9343,75,NULL,'B','NGC 1531',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000097,NULL,'12.91',0.9,'S0- pec:','in a pair',NULL,NULL,NULL,1,62.997167,-32.85081,0,NULL,37710141850,589220966,9206577,12.91),(34517,'IRAS','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34517,31.07,0.8,16.4,9344,75,NULL,'MAT, I','NGC 1532',NULL,'1997ApJS..109..333W',1997,1,12.6,'Extended HIPASS source','G',0.000017,NULL,'10.65',3.3,'SB(s)b pec sp','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,63.0180417,-32.87422,0,NULL,37710139931,589220936,9206577,10.65),(34518,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34518,30.67,0.4,13.6,9344,75,NULL,'B','NGC 1532',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34519,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34519,31.06,0.43,16.3,9344,75,NULL,'MAT, I, raw','NGC 1532',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34520,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34520,31.09,0.32,16.5,9344,85,NULL,'I, raw','NGC 1532',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34521,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34521,31.13,0.4,16.8,9344,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 3 galaxy group','NGC 1532',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34522,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34522,31.16,0.32,17.1,9344,85,NULL,'I, inv','NGC 1532',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34523,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34523,31.19,0.36,17.3,9344,NULL,NULL,NULL,'NGC 1532',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34524,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34524,31.19,0.4,17.3,9344,73,NULL,'opt','NGC 1532',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34525,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34525,31.31,0.43,18.3,9344,75,NULL,'MAT, I, cor','NGC 1532',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34526,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34526,31.37,0.43,18.8,9344,75,NULL,'MAT, I, inv','NGC 1532',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34527,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34527,31.38,0.07,18.9,9344,NULL,NULL,NULL,'NGC 1532',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34528,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34528,31.47,0.43,19.6,9344,75,NULL,'3.6 micron, color corrected','NGC 1532',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34529,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34529,31.51,0.2,20,9344,74.4,NULL,NULL,'NGC 1532',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34530,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34530,31.55,0.43,20.5,9344,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1532',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34531,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34531,33.66,0.47,53.9,9345,NULL,NULL,'H','UGC 02978',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000017,NULL,'17.',0.4,'SB?',NULL,NULL,NULL,NULL,1,63.064917,34.91636,1.349,NULL,68381838193,1068466221,16694784,17),(34532,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34532,33.67,0.45,54.1,9345,NULL,NULL,'K','UGC 02978',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34533,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34533,34.01,0.46,63.5,9345,NULL,NULL,'J','UGC 02978',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34534,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34534,34.35,0.4,74.3,9345,NULL,NULL,'mean','UGC 02978',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34535,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34535,36.25,0.51,177,9346,70,NULL,NULL,'2MASX J04121702-1312161',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.59',0.25,NULL,NULL,NULL,NULL,NULL,1,63.070875,-13.20444,0.057,NULL,36875252995,576175828,9002747,16.59),(34536,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34536,33.35,0.43,46.8,9347,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02982',NULL,'2014MNRAS.444..527S',2014,1,0.9,NULL,'G',0.000017,NULL,'15.27',0.4,'Sm;LIRG        HII','Isolated galaxy',NULL,NULL,NULL,1,63.0935417,5.54739,0.541,NULL,65081089925,1016892030,15888937,15.27),(34537,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34537,33.75,0.45,56.3,9347,NULL,NULL,'K','UGC 02982',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34538,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34538,33.84,0.47,58.6,9347,NULL,NULL,'H','UGC 02982',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34539,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34539,34,0.46,63.2,9347,NULL,NULL,'J','UGC 02982',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34540,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34540,34.24,0.4,70.4,9347,NULL,NULL,'mean','UGC 02982',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34541,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34541,38.18,0.46,433,9348,70,NULL,NULL,'SDSS J041231.91-060318.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000076,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,63.133,-6.05511,0.141,NULL,36953989631,577406087,9021970,18.6),(34542,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34542,36.28,0.55,181,9349,70,NULL,NULL,'2MASX J04123430-5413103',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.65',0.35,'E',NULL,NULL,NULL,NULL,1,63.1429583333,-54.21956,0,NULL,35809638334,559525598,8742587,16.65),(34543,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34543,29.35,NULL,7.41,9350,NULL,NULL,NULL,'ESO 483- G 013',NULL,'2013AJ....145..101K',2013,1,1.6,NULL,'G',0.000033,NULL,'14.06',0.8,'SA0-:',NULL,NULL,NULL,NULL,1,63.171333,-23.15889,0.061,NULL,36843810067,575684532,8995070,14.06),(34544,'SBF','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34544,31.46,0.14,19.6,9351,74.4,NULL,NULL,'NGC 1543',NULL,'2013AJ....146...86T',2013,1,4.9,NULL,'G',0.000024,NULL,'11.46',2.8,'(R)SB(l)0^0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,63.1802083,-57.73797,0,NULL,35823024015,559734750,8745855,11.46),(34545,'SBF','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34545,31.51,0.17,20,9351,NULL,NULL,'I','NGC 1543',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34546,'SBF','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34546,31.51,0.17,20,9351,NULL,NULL,NULL,'NGC 1543',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34547,'SBF','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34547,31.52,0.17,20.2,9351,NULL,NULL,'Malmquist cor.','NGC 1543',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34548,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34548,30.75,NULL,14.1,9351,NULL,NULL,'LEDA [April 2006]','NGC 1543',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34549,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34549,30.85,0.37,14.8,9351,95,NULL,'Weighted Mean','NGC 1543',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34550,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34550,30.87,0.63,14.9,9351,95,NULL,'Michard 1979b, c','NGC 1543',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34551,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34551,31.18,0.46,17.2,9351,95,NULL,'Michard 1979a','NGC 1543',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34552,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34552,32.02,0.81,25.4,9351,55,NULL,'Visvanathan & Sandage 1979','NGC 1543',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34553,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34553,30.89,0.41,15,9351,NULL,NULL,NULL,'NGC 1543',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34554,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34554,31.09,0.41,16.5,9351,NULL,NULL,'Malmquist cor.','NGC 1543',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34555,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34555,31.32,0.68,18.4,9351,70,NULL,NULL,'NGC 1543',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34556,'Tertiary','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34556,29.99,0.32,9.95,9351,95,NULL,NULL,'NGC 1543',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34557,'Tully est','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34557,30.64,0.8,13.4,9351,75,NULL,'B','NGC 1543',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34558,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34558,30.67,0.45,13.6,9351,NULL,NULL,'K','NGC 1543',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34559,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34559,31.38,0.4,18.9,9351,NULL,NULL,'mean','NGC 1543',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34560,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34560,33.85,0.43,59,9352,75,NULL,'3.6 micron, color + selection bias corrected','WISEP J041245.99+294612.5',NULL,'2014MNRAS.444..527S',2014,1,0.5,NULL,'G',NULL,NULL,'16.58',0.2,NULL,NULL,NULL,NULL,NULL,1,63.191625,29.77014,0.633,NULL,68327890767,1067623293,16681613,16.58),(34561,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34561,33.93,0.2,61.1,9353,74.4,NULL,NULL,'UGC 02983',NULL,'2013AJ....146...86T',2013,1,2,NULL,'G',0.000023,NULL,'14.76',0.7,'SB(s)b:',NULL,NULL,NULL,NULL,1,63.2185417,2.36964,0.573,NULL,65084873432,1016951147,15889861,14.76),(34562,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34562,33.99,0.3,62.8,9353,NULL,NULL,NULL,'UGC 02983',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34563,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34563,34.04,0.3,64.2,9353,NULL,NULL,'Malmquist cor.','UGC 02983',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34564,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34564,34.15,0.4,67.6,9353,NULL,NULL,'mean','UGC 02983',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34565,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34565,34.23,0.47,70.1,9353,NULL,NULL,'H','UGC 02983',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34566,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34566,34.27,0.46,71.4,9353,NULL,NULL,'J','UGC 02983',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34567,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34567,34.32,0.45,73.2,9353,NULL,NULL,'K','UGC 02983',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34568,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34568,35.62,0.57,133,9354,70,NULL,NULL,'2MASX J04130230-5329409',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'15.98',0.4,'S0',NULL,NULL,NULL,NULL,1,63.259583,-53.49478,0,NULL,35809123722,559517558,8742461,15.98),(34569,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34569,30.24,0.49,11.1,9355,75,NULL,'IR','UGC 02984',NULL,'2011yCatp016004901K',2011,1,1.7,'The 2MASS XSC position applies to a knot north of the galaxy\'s center.','G',0.000013,NULL,'13.1B',1.4,'SBdm: pec',NULL,NULL,NULL,NULL,1,63.3025,13.41972,0.957,NULL,65143251179,1017863299,15904114,13.1),(34570,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34570,38.21,0.82,439,9356,70,NULL,NULL,'GALEXASC J041314.13-375412.6',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'16.43',0.33,'S0',NULL,NULL,NULL,NULL,1,63.309,-37.903,0,NULL,37672674684,588635541,9197430,16.43),(34571,'SZ effect','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34571,38.08,NULL,414,9357,NULL,NULL,NULL,'ABELL 0478',NULL,'2001ApJ...555L..11M',2001,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'Compact [Zw]',NULL,NULL,NULL,NULL,1,63.356667,10.46694,1.021,NULL,65165481540,1018210649,15909541,NULL),(34572,'SZ effect','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34572,38.26,NULL,448,9357,NULL,NULL,NULL,'ABELL 0478',NULL,'2005ApJ...625..108D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34573,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34573,37.37,0.69,297,9358,70,NULL,NULL,'LCRS B041136.7-384000',NULL,'2014MNRAS.445.2677S',2014,1,0.26,NULL,'G',0.000103,NULL,'15.25',0.18,NULL,NULL,NULL,NULL,NULL,1,63.3455417,-38.54078,0,NULL,37792257579,590504024,9226625,15.25),(34574,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34574,32.91,0.47,38.2,9359,NULL,NULL,'H','UGC 02985',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000033,NULL,'16.0',0.3,'Scd:',NULL,NULL,NULL,NULL,1,63.3902083,27.54197,0.449,NULL,68319688781,1067495137,16679611,16),(34575,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34575,32.97,0.45,39.3,9359,NULL,NULL,'K','UGC 02985',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34576,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34576,33.07,0.46,41.1,9359,NULL,NULL,'J','UGC 02985',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34577,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34577,33.52,0.4,50.6,9359,NULL,NULL,'mean','UGC 02985',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34578,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34578,36.3,0.55,182,9360,70,NULL,NULL,'LSBG F303-007',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'16.39',0.3,'S0',NULL,NULL,NULL,NULL,1,63.3977083,-39.08917,0,NULL,37794463586,590538493,9227163,16.39),(34579,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34579,37.89,0.67,379,9361,70,NULL,NULL,'2MASX J04133703-6813567',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'16.4b',0.19,NULL,NULL,NULL,NULL,NULL,1,63.404167,-68.23242,0.177,NULL,36426266155,569160408,8893131,16.4),(34580,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34580,35.45,0.55,123,9362,70,NULL,NULL,'2MASX J04133818-6923367',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'16.7b',0.13,NULL,NULL,NULL,NULL,NULL,1,63.409333,-69.39353,0.357,NULL,36424819169,569137799,8892778,16.7),(34581,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34581,33.21,0.46,43.9,9363,NULL,NULL,'J','UGC 02988',NULL,'2007A&A...465...71T',2007,1,2.8,NULL,'G',0.000017,NULL,'14.90',0.6,'Sb:','Isolated galaxy',NULL,NULL,NULL,1,63.4120417,25.483,0.509,NULL,68317626899,1067462920,16679108,14.9),(34582,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34582,33.22,0.49,44.1,9363,75,NULL,'IR','UGC 02988',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34583,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34583,33.27,0.47,45.2,9363,NULL,NULL,'H','UGC 02988',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34584,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34584,33.42,0.45,48.3,9363,NULL,NULL,'K','UGC 02988',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34585,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34585,33.43,0.4,48.6,9363,NULL,NULL,'mean','UGC 02988',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34586,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34586,33.71,0.43,55.2,9363,75,NULL,'3.6 micron, color + selection bias corrected','UGC 02988',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34587,'SBF','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34587,31.82,0.14,23.1,9364,74.4,NULL,NULL,'NGC 1537',NULL,'2013AJ....146...86T',2013,1,3.9,NULL,'G',0.00006,NULL,'12.22',2.6,'SAB0- pec?','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,63.419625,-31.64542,0,NULL,37709839104,589216236,9206503,12.22),(34588,'SBF','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34588,31.83,0.19,23.2,9364,NULL,NULL,'I','NGC 1537',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34589,'SBF','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34589,31.83,0.19,23.2,9364,NULL,NULL,NULL,'NGC 1537',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34590,'SBF','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34590,31.85,0.19,23.4,9364,NULL,NULL,'Malmquist cor.','NGC 1537',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34591,'D-Sigma','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34591,30.74,0.4,14.1,9364,75,NULL,'Edat, raw','NGC 1537',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34592,'D-Sigma','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34592,31.08,0.4,16.4,9364,75,NULL,'Edat, cor','NGC 1537',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34593,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34593,31.09,NULL,16.5,9364,NULL,NULL,'LEDA [April 2006]','NGC 1537',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34594,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34594,31.1,0.41,16.6,9364,NULL,NULL,NULL,'NGC 1537',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34595,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34595,31.34,0.41,18.5,9364,NULL,NULL,'Malmquist cor.','NGC 1537',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34596,'Tully est','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34596,30.91,0.8,15.2,9364,75,NULL,'B','NGC 1537',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34597,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34597,31.13,0.4,16.8,9364,NULL,NULL,'mean','NGC 1537',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34598,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34598,31.2,0.45,17.4,9364,NULL,NULL,'K','NGC 1537',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34599,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34599,34.21,0.47,69.5,9365,NULL,NULL,'H','UGC 02989',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000023,NULL,'16.0',0.7,'SB?',NULL,NULL,NULL,NULL,1,63.4835833333,29.15753,0.449,NULL,68333099768,1067704683,16682885,16),(34600,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34600,34.29,0.46,72.1,9365,NULL,NULL,'J','UGC 02989',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34601,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34601,34.36,0.45,74.4,9365,NULL,NULL,'K','UGC 02989',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34602,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34602,34.4,0.4,75.8,9365,NULL,NULL,'mean','UGC 02989',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34603,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34603,33.46,0.47,49.2,9366,NULL,NULL,'H','UGC 02991',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000017,NULL,'16.5',1.4,'SB(r)b',NULL,NULL,NULL,NULL,1,63.50275,36.84764,1.861,NULL,68362362214,1068161909,16690029,16.5),(34604,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34604,33.63,0.45,53.2,9366,NULL,NULL,'K','UGC 02991',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34605,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34605,33.74,0.46,55.9,9366,NULL,NULL,'J','UGC 02991',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34606,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34606,34.38,0.4,75.2,9366,NULL,NULL,'mean','UGC 02991',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34607,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34607,34.4,NULL,75.8,9367,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0470',NULL,'2010Ap&SS.325..163P',2010,1,1.01,NULL,'G',0.00001,NULL,'16.37',0.11,'Sd',NULL,NULL,NULL,NULL,1,63.5055416667,26.74992,0.461,NULL,68320896747,1067514011,16679906,16.37),(34608,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34608,34.41,NULL,76.2,9367,NULL,NULL,'Dipole + Quadrupole','FGC 0470',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34609,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34609,34.43,NULL,76.8,9367,NULL,NULL,'Dipole','FGC 0470',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34610,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34610,34.47,NULL,78.3,9367,NULL,NULL,NULL,'FGC 0470',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34611,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34611,34.52,0.49,80.2,9367,75,NULL,'IR','FGC 0470',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34612,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34612,34.94,0.49,97.2,9368,70,NULL,NULL,'MCG -02-11-026',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'15.48',1.1,'S0?',NULL,NULL,NULL,NULL,1,63.5062083,-13.38994,0.073,NULL,36874768938,576168264,9002629,15.48),(34613,'SNIa','2016-12-15 15:14:03','2016-12-16 11:19:07','1','SN 1999fn','R',34613,41.15,NULL,1160,9369,65,NULL,'SALT','H-ZSNS J041403.88+041755.0',0.47,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,63.5161666667,4.29861,0.517,NULL,65095334252,1017114597,15892415,NULL),(34614,'SNIa','2016-12-15 15:14:03','2016-12-16 11:19:07','1','SN 1999fn',NULL,34614,41.34,0.19,1260,9369,74.2,NULL,'SALT 2','H-ZSNS J041403.88+041755.0',0.47,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34615,'SNIa','2016-12-15 15:14:03','2016-12-16 11:19:07','1','SN 1999fn',NULL,34615,41.98,0.4,1690,9369,65,NULL,'dm15','H-ZSNS J041403.88+041755.0',0.47,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34616,'SNIa','2016-12-15 15:14:03','2016-12-16 11:19:07','1','SN 1999fn',NULL,34616,42.01,0.15,1720,9369,70,NULL,'SALT','H-ZSNS J041403.88+041755.0',0.47,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34617,'SNIa','2016-12-15 15:14:03','2016-12-16 11:19:07','1','SN 1999fn',NULL,34617,42.17,0.17,1850,9369,65,NULL,'SALT','H-ZSNS J041403.88+041755.0',0.47,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34618,'SNIa','2016-12-15 15:14:03','2016-12-16 11:19:07','1','SN 1999fn',NULL,34618,42.19,0.23,1870,9369,65,NULL,'BATM','H-ZSNS J041403.88+041755.0',0.47,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34619,'SNIa','2016-12-15 15:14:03','2016-12-16 11:19:07','1','SN 1999fn',NULL,34619,42.28,0.24,1940,9369,65,NULL,'Final','H-ZSNS J041403.88+041755.0',0.47,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34620,'SNIa','2016-12-15 15:14:03','2016-12-16 11:19:07','1','SN 1999fn',NULL,34620,42.36,0.16,2020,9369,65,NULL,'delta m15','H-ZSNS J041403.88+041755.0',0.47,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34621,'SNIa','2016-12-15 15:14:03','2016-12-16 11:19:07','1','SN 1999fn',NULL,34621,42.38,0.21,2040,9369,65,NULL,NULL,'H-ZSNS J041403.88+041755.0',0.47,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34622,'SNIa','2016-12-15 15:14:03','2016-12-16 11:19:07','1','SN 1999fn',NULL,34622,42.69,0.26,2350,9369,65,NULL,'MLCS','H-ZSNS J041403.88+041755.0',0.47,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34623,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34623,35.9,0.55,151,9370,70,NULL,NULL,'2MASX J04140460-0843086',NULL,'2014MNRAS.445.2677S',2014,1,0.71,NULL,'G',0.00015,NULL,'16.35',0.35,NULL,NULL,NULL,NULL,NULL,1,63.5192083,-8.71914,0.121,NULL,36957272569,577457383,9022771,16.35),(34624,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34624,35.82,0.53,146,9371,70,NULL,NULL,'LCRS B041219.1-383324',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000067,NULL,'16.92',0.2,'S',NULL,NULL,NULL,NULL,1,63.5227917,-38.43153,0,NULL,37671404273,588615691,9197120,16.92),(34625,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34625,34.45,0.53,77.5,9372,70,NULL,NULL,'2MASX J04140742-1309236',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.00015,NULL,'15.94',0.41,NULL,NULL,NULL,NULL,NULL,1,63.531,-13.15653,0.077,NULL,36861002945,575953171,8999268,15.94),(34626,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34626,36.35,0.57,186,9373,70,NULL,NULL,'LCRS B041221.3-382412',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.74',0.22,NULL,NULL,NULL,NULL,NULL,1,63.5330416667,-38.27833,0,NULL,37672468222,588632315,9197379,16.74),(34627,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34627,33.65,0.49,53.7,9374,75,NULL,'IR','CGCG 487-028',NULL,'2011yCatp016004901K',2011,1,0.5,NULL,'G',0.000033,NULL,'15.47',0.4,'S?',NULL,NULL,NULL,NULL,1,63.560875,24.66075,0.621,NULL,68317084119,1067454439,16678975,15.47),(34628,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34628,34.99,0.53,99.3,9375,70,NULL,NULL,'2MASX J04141736-7512078',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'16.1b',0.19,NULL,NULL,NULL,NULL,NULL,1,63.572625,-75.20225,0.389,NULL,35523048837,555047638,8672619,16.1),(34629,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34629,33.71,NULL,55.2,9376,NULL,NULL,'B','ESO 084- G 009',NULL,'2005Ap&SS.298..577R',2005,1,1,NULL,'G',0.000033,NULL,'14.18',0.7,'SAB(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,63.59275,-62.81292,0.009,NULL,35903259142,560988424,8765444,14.18),(34630,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34630,34.12,NULL,66.7,9376,NULL,NULL,'I','ESO 084- G 009',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34631,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34631,36.02,0.72,160,9377,70,NULL,NULL,'2MASX J04142235-1304556',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'16.49',0.28,NULL,NULL,NULL,NULL,NULL,1,63.593083,-13.08203,0.077,NULL,36861108734,575954823,8999294,16.49),(34632,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34632,32.31,0.69,29,9378,100,NULL,'mid-IR','UGC 02994',NULL,'2013ApJ...771...88L',2013,1,1.5,NULL,'G',0.000029,NULL,'15.10',0.8,'SAdm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,63.597625,2.7315,0.541,NULL,65084147093,1016939798,15889684,15.1),(34633,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34633,33.42,0.2,48.3,9378,74.4,NULL,NULL,'UGC 02994',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34634,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34634,33.58,0.4,51.9,9378,NULL,NULL,NULL,'UGC 02994',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34635,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34635,33.87,0.35,59.3,9378,NULL,NULL,'Malmquist cor.','UGC 02994',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34636,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34636,36.66,0.94,215,9379,70,NULL,NULL,'2MASX J04143284-0107272',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.04',NULL,NULL,NULL,NULL,NULL,NULL,1,63.63675,-1.12422,0.273,NULL,36918206711,576846979,9013234,17.04),(34637,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34637,34.99,0.49,99.7,9380,70,NULL,NULL,'IC 2045',NULL,'2014MNRAS.445.2677S',2014,1,0.4,'This may also be NGC 1538.','G',0.000127,NULL,'15.41',0.4,'E1/S0-',NULL,NULL,NULL,NULL,1,63.6500417,-13.17492,0.073,NULL,36861073250,575954269,8999285,15.41),(34638,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34638,30.98,0.63,15.7,9381,95,NULL,'Michard 1979b, c','NGC 1546',NULL,'1984ApJS...56...91D',1984,1,3,'ESO-LV has V = 935 +- 30.','G',0.000047,NULL,'11.8',1.7,'SA0+?          HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,63.65225,-56.06081,0,NULL,35814024684,559594135,8743658,11.8),(34639,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34639,31.23,0.44,17.6,9381,95,NULL,'Weighted Mean','NGC 1546',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34640,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34640,31.78,0.46,22.7,9381,95,NULL,'Michard 1979a','NGC 1546',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34641,'Tertiary','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34641,29.99,0.32,9.95,9381,95,NULL,NULL,'NGC 1546',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34642,'Tully est','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34642,30.64,0.8,13.4,9381,75,NULL,'B','NGC 1546',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34643,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34643,36.18,0.57,172,9382,70,NULL,NULL,'2MASX J04143654-5306216',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'15.83',0.5,'S0',NULL,NULL,NULL,NULL,1,63.6521666667,-53.10597,0,NULL,37741456096,589710251,9214222,15.83),(34644,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34644,35.76,0.51,142,9383,70,NULL,NULL,'NGC 1538',NULL,'2014MNRAS.445.2677S',2014,1,0.97,'Identification as NGC 1538 is uncertain.','G',0.00009,NULL,'15.98',0.4,NULL,NULL,NULL,NULL,NULL,1,63.7336666667,-13.19172,0.073,NULL,36861095387,575954615,8999290,15.98),(34645,'SNIa','2016-12-15 15:14:03','2016-12-16 11:19:07','1','SN 2000eh',NULL,34645,42.41,0.25,2040,9384,65,NULL,NULL,'H-ZSNS J041502.44+042318.1',0.49,'2004ApJ...607..665R',2004,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,63.760167,4.38836,0.529,NULL,65095130147,1017111408,15892365,NULL),(34646,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34646,35.54,0.69,128,9385,70,NULL,NULL,'2MASX J04150434-0802570',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00014,NULL,'15.98',0.35,NULL,NULL,NULL,NULL,NULL,1,63.7680417,-8.04931,0.145,NULL,36957749183,577464830,9022887,15.98),(34647,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34647,36.03,0.49,161,9386,70,NULL,NULL,'2MASX J04150744-1307438',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'15.55',0.34,NULL,NULL,NULL,NULL,NULL,1,63.780875,-13.12894,0.073,NULL,36861090553,575954539,8999289,15.55),(34648,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34648,34.98,0.63,99.1,9387,70,NULL,NULL,'MCG +00-11-030',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.6b',0.2,NULL,NULL,NULL,NULL,NULL,1,63.798,-0.84814,0.289,NULL,36918145332,576846020,9013219,15.6),(34649,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34649,35.72,0.54,139,9388,70,NULL,NULL,'2MASX J04151352-1421098',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'16.04',0.27,NULL,NULL,NULL,NULL,NULL,1,63.806375,-14.35267,0.025,NULL,36873508982,576148577,9002321,16.04),(34650,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34650,35.67,0.5,136,9389,70,NULL,NULL,'2MASX J04152060-0703513',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00012,NULL,'16.11',0.4,NULL,NULL,NULL,NULL,NULL,1,63.8357917,-7.06414,0.105,NULL,36956961903,577452529,9022695,16.11),(34651,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34651,36.6,0.56,209,9390,70,NULL,NULL,'AM 0413-380 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.000127,NULL,'15.48',0.47,'S0',NULL,NULL,NULL,NULL,1,63.8534583,-38.028,0,NULL,37669603456,588587554,9196680,15.48),(34652,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34652,35,0.56,100,9391,70,NULL,NULL,'2MASX J04152858-1517008',NULL,'2014MNRAS.445.2677S',2014,1,0.71,NULL,'G',0.00015,NULL,'15.73',0.33,NULL,NULL,NULL,NULL,NULL,1,63.869083,-15.28356,0.077,NULL,36869292744,576082699,9001292,15.73),(34653,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34653,35.94,0.57,154,9392,70,NULL,NULL,'6dF J0415302-244148',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,63.876417,-24.69661,0.065,NULL,37648264621,588254134,9191470,15.1),(34654,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34654,36.7,0.6,219,9393,70,NULL,NULL,'2MASX J04153046-2443097',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'17.25',0.17,NULL,NULL,NULL,NULL,NULL,1,63.8769166667,-24.71931,0.065,NULL,37648263971,588254124,9191470,17.25),(34655,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34655,36.01,0.72,159,9394,70,NULL,NULL,'2MASX J04153857-0057497',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.76',0.4,NULL,NULL,NULL,NULL,NULL,1,63.9105417,-0.96372,0.273,NULL,36917341045,576833453,9013022,16.76),(34656,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34656,36.07,0.71,164,9395,70,NULL,NULL,'2MASX J04153962-1438555',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.000077,NULL,'15.86',0.37,NULL,NULL,NULL,NULL,NULL,1,63.915,-14.64883,0.037,NULL,36873878361,576154349,9002411,15.86),(34657,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34657,37.18,0.58,273,9396,70,NULL,NULL,'2MASX J04154125-6752292',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'16.6b',0.21,NULL,NULL,NULL,NULL,NULL,1,63.921917,-67.87478,0.113,NULL,36426362653,569161916,8893154,16.6),(34658,'SBF','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34658,31.04,0.06,16.1,9397,NULL,NULL,'I','NGC 1549',NULL,'1997ApJ...475..399T',1997,1,4.9,NULL,'G',0.00004,NULL,'10.72',4.1,'E0-1','in a pair',NULL,NULL,NULL,1,63.9380417,-55.59225,0,NULL,35815569569,559618274,8744035,10.72),(34659,'SBF','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34659,31.3,0.12,18.2,9397,74.4,NULL,NULL,'NGC 1549',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34660,'SBF','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34660,31.47,0.18,19.7,9397,NULL,NULL,'I','NGC 1549',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34661,'SBF','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34661,31.47,0.18,19.7,9397,NULL,NULL,NULL,'NGC 1549',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34662,'SBF','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34662,31.49,0.18,19.8,9397,NULL,NULL,'Malmquist cor.','NGC 1549',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34663,'D-Sigma','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34663,30.61,0.4,13.2,9397,75,NULL,'Edat, raw','NGC 1549',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34664,'D-Sigma','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34664,30.77,0.22,14.3,9397,72,NULL,'Dorado GROUP, 4 galaxies','NGC 1549',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34665,'D-Sigma','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34665,30.94,0.4,15.5,9397,75,NULL,'Edat, cor','NGC 1549',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34666,'D-Sigma','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34666,31.02,0.26,16,9397,NULL,NULL,'Dorado GROUP, 9 galaxies','NGC 1549',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34667,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34667,29.28,0.63,7.18,9397,95,NULL,'Michard 1979b, c','NGC 1549',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34668,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34668,29.85,0.37,9.33,9397,95,NULL,'Weighted Mean','NGC 1549',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34669,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34669,30.21,0.46,11,9397,95,NULL,'Michard 1979a','NGC 1549',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34670,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34670,30.82,NULL,14.6,9397,NULL,NULL,'LEDA [April 2006]','NGC 1549',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34671,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34671,31.02,0.81,16,9397,55,NULL,'Visvanathan & Sandage 1979','NGC 1549',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34672,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34672,30.7,0.21,13.8,9397,NULL,NULL,'Dorado GROUP, 9 galaxies','NGC 1549',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34673,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34673,30.73,0.41,14,9397,NULL,NULL,NULL,'NGC 1549',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34674,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34674,30.88,0.27,15,9397,NULL,NULL,'Dorado GROUP, 9 galaxies','NGC 1549',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34675,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34675,30.97,0.41,15.6,9397,NULL,NULL,'Malmquist cor.','NGC 1549',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34676,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34676,31.06,0.66,16.3,9397,70,NULL,NULL,'NGC 1549',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34677,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34677,31.3,0.12,18.2,9397,74.4,NULL,NULL,'NGC 1549',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34678,'Tertiary','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34678,29.99,0.32,9.95,9397,95,NULL,NULL,'NGC 1549',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34679,'Tully est','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34679,30.64,0.8,13.4,9397,75,NULL,'B','NGC 1549',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34680,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34680,35.52,0.47,127,9398,70,NULL,NULL,'MCG -02-11-028',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000137,NULL,'14.52',0.6,NULL,NULL,NULL,NULL,NULL,1,63.940375,-13.48786,0.069,NULL,36862743628,575980369,8999693,14.52),(34681,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34681,37.6,0.69,330,9399,70,NULL,NULL,'2MASX J04155187-3803548',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.75',0.27,NULL,NULL,NULL,NULL,NULL,1,63.966083,-38.06533,0,NULL,37669786294,588590410,9196725,16.75),(34682,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34682,36.2,0.53,174,9400,70,NULL,NULL,'2MASX J04160791-2332448',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.000093,NULL,'16.58',0.28,'S0',NULL,NULL,NULL,NULL,1,64.032917,-23.54575,0.065,NULL,37313567116,583024486,9109757,16.58),(34683,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34683,36.83,0.75,233,9401,70,NULL,NULL,'2MASX J04160900-6131115',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'16.76',0.34,NULL,NULL,NULL,NULL,NULL,1,64.0375833333,-61.51983,0,NULL,35905616947,561025264,8766019,16.76),(34684,'GCLF','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34684,31.8,0.6,22.9,9402,NULL,NULL,'TOM(V) = -7.3 mag','NGC 1553',NULL,'2009ApJ...690..512H',2009,1,4.5,NULL,'G',0.000037,NULL,'10.28',2.8,'SA(rl)0^0      LINER','in a pair',NULL,NULL,NULL,1,64.043625,-55.78014,0,NULL,35813953908,559593029,8743641,10.28),(34685,'SBF','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34685,31.18,0.17,17.2,9402,NULL,NULL,'I','NGC 1553',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34686,'SBF','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34686,31.32,0.14,18.4,9402,74.4,NULL,NULL,'NGC 1553',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34687,'SBF','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34687,31.34,0.17,18.5,9402,NULL,NULL,'I','NGC 1553',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34688,'SBF','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34688,31.34,0.17,18.5,9402,NULL,NULL,NULL,'NGC 1553',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34689,'SBF','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34689,31.36,0.17,18.7,9402,NULL,NULL,'Malmquist cor.','NGC 1553',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34690,'Ring Diameter','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34690,31.5,0.84,20,9402,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 1553',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34691,'D-Sigma','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34691,30.77,0.22,14.3,9402,72,NULL,'Dorado GROUP, 4 galaxies','NGC 1553',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34692,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34692,28.29,0.63,4.55,9402,95,NULL,'Michard 1979b, c','NGC 1553',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34693,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34693,29.15,0.46,6.76,9402,95,NULL,'Michard 1979a','NGC 1553',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34694,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34694,29.25,0.37,7.08,9402,95,NULL,'Weighted Mean','NGC 1553',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34695,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34695,30.06,NULL,10.3,9402,NULL,NULL,'LEDA [April 2006]','NGC 1553',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34696,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34696,31.19,0.81,17.3,9402,55,NULL,'Visvanathan & Sandage 1979','NGC 1553',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34697,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34697,29.3,0.41,7.23,9402,NULL,NULL,NULL,'NGC 1553',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34698,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34698,29.62,0.41,8.39,9402,NULL,NULL,'Malmquist cor.','NGC 1553',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34699,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34699,29.89,0.67,9.51,9402,70,NULL,NULL,'NGC 1553',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34700,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34700,30.7,0.21,13.8,9402,NULL,NULL,'Dorado GROUP, 9 galaxies','NGC 1553',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34701,'Tertiary','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34701,29.99,0.32,9.95,9402,95,NULL,NULL,'NGC 1553',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34702,'Tully est','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34702,30.64,0.8,13.4,9402,75,NULL,'B','NGC 1553',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34703,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34703,30.11,0.45,10.5,9402,NULL,NULL,'K','NGC 1553',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34704,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34704,30.96,0.4,15.5,9402,NULL,NULL,'mean','NGC 1553',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34705,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34705,32.19,0.43,27.4,9403,75,NULL,'3.6 micron, color + selection bias corrected','MCG -03-11-019',NULL,'2014MNRAS.444..527S',2014,1,1.6,NULL,'G',0.000007,NULL,'14.58',0.5,'SB(s)dm pec:','X-ray-faint group member',NULL,NULL,NULL,1,64.052333,-16.75058,0.049,NULL,36868726729,576073855,9001153,14.58),(34706,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34706,36.61,0.53,210,9404,70,NULL,NULL,'2MASX J04161287-0236358',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.38',0.5,NULL,NULL,NULL,NULL,NULL,1,64.053375,-2.60983,0.113,NULL,36915335668,576802119,9012533,16.38),(34707,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34707,37.07,0.57,259,9405,70,NULL,NULL,'2MASX J04161659-5358420',NULL,'2014MNRAS.445.2677S',2014,1,0.17,NULL,'G',0.00015,NULL,'17.1b',0.11,NULL,NULL,NULL,NULL,NULL,1,64.0691666667,-53.97825,0,NULL,35818205914,559659467,8744679,17.1),(34708,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34708,36.39,0.55,190,9406,70,NULL,NULL,'LCRS B041433.7-392645',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00015,NULL,'15.18',0.65,'(R\')SB(rl)b:',NULL,NULL,NULL,NULL,1,64.0765,-39.32331,0,NULL,37794672020,590541750,9227214,15.18),(34709,'IRAS','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34709,30.91,0.8,15.2,9407,75,NULL,'MAT, I','IC 2056',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'12.48',1.5,'SAB(r)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,64.10225,-60.20681,0,NULL,35800728411,559386381,8740412,12.48),(34710,'Tully est','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34710,30.44,0.8,12.3,9407,75,NULL,'B','IC 2056',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34711,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34711,31.58,0.32,20.7,9407,85,NULL,'I, raw','IC 2056',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34712,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34712,31.6,0.32,20.9,9407,85,NULL,'I, inv','IC 2056',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34713,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34713,31.93,0.43,24.3,9407,75,NULL,'MAT, I, raw','IC 2056',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34714,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34714,31.95,0.43,24.6,9407,75,NULL,'MAT, I, cor','IC 2056',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34715,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34715,32.08,0.43,26.1,9407,75,NULL,'MAT, I, inv','IC 2056',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34716,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34716,36.5,0.79,199,9408,70,NULL,NULL,'2MASX J04163191-2335389',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.73',0.18,NULL,NULL,NULL,NULL,NULL,1,64.1330417,-23.59414,0.057,NULL,37313562945,583024421,9109756,16.73),(34717,'SNIa','2016-12-15 15:14:03','2016-12-16 11:19:07','1','SN 2009ab',NULL,34717,33.51,0.28,49.3,9409,72,NULL,NULL,'UGC 02998',0.01087,'2013ApJ...773...53F',2013,1,1.5,'The 8th mag star HD 27039 is 2\' north.','G',0.00002,NULL,'14.35',1.3,'SB(rs)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,64.142917,2.75908,0.469,NULL,65039038801,1016234981,15878671,14.35),(34718,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34718,35,0.53,100,9410,70,NULL,NULL,'MCG -02-11-030',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000047,NULL,'14.8b',0.7,'SB(rs)b',NULL,NULL,NULL,NULL,1,64.1589583,-12.39856,0.113,NULL,36863265714,575988526,8999820,14.8),(34719,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34719,34.57,0.69,82.1,9410,100,NULL,'mid-IR','MCG -02-11-030',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34720,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34720,35.24,0.43,112,9410,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-11-030',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34721,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34721,35.43,0.56,122,9411,70,NULL,NULL,'2MASX J04164159-1309570',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.00008,NULL,'15.65',0.44,NULL,NULL,NULL,NULL,NULL,1,64.1732917,-13.16586,0.081,NULL,36862868006,575982312,8999723,15.65),(34722,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34722,35.09,0.45,104,9412,70,NULL,NULL,'IC 0362',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000073,NULL,'14.37',1.1,'E+?',NULL,NULL,NULL,NULL,1,64.1767917,-12.20011,0.113,NULL,36859812077,575934563,8998977,14.37),(34723,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34723,35.73,0.51,140,9413,70,NULL,NULL,'ESO 202- G 002',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'15.86',0.2,'S0-a',NULL,NULL,NULL,NULL,1,64.1960417,-51.55733,0,NULL,37746103106,589782861,9215357,15.86),(34724,'BL Lac Luminosity','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34724,41.05,NULL,1260,9414,NULL,NULL,NULL,'[HB89] 0414+009',0.287,'2005ApJ...635..173S',2005,1,NULL,'May contribute to the X-Ray source 1H 0414+009.','QSO',NULL,NULL,'16.38',NULL,'BLLAC',NULL,NULL,'radio jet','Flat-Spectrum Radio Source',1,64.2187083,1.08997,0.409,NULL,65038431717,1016225495,15878523,16.38),(34725,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34725,33.3,0.2,45.7,9415,74.4,NULL,NULL,'UGC 03002',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',NULL,NULL,'16.0',0.8,'SBcd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,64.2269583,3.09683,0.481,NULL,65089309909,1017020467,15890944,16),(34726,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34726,33.42,0.46,48.3,9415,NULL,NULL,NULL,'UGC 03002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34727,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34727,33.81,0.38,57.9,9415,NULL,NULL,'Malmquist cor.','UGC 03002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34728,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34728,34.96,0.71,98.4,9416,NULL,NULL,'Malmquist cor.','FGC 0471',NULL,'2009ApJS..182..474S',2009,1,1.31,NULL,'G',0.000033,NULL,'16.2',0.17,'Sbc            AGN',NULL,NULL,NULL,NULL,1,64.231375,-7.48061,0.149,NULL,36956684091,577448188,9022627,16.2),(34729,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34729,35.21,0.64,110,9416,NULL,NULL,NULL,'FGC 0471',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34730,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34730,35.46,NULL,123,9416,NULL,NULL,'Dipole','FGC 0471',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34731,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34731,35.47,NULL,124,9416,NULL,NULL,'Dipole + Quadrupole','FGC 0471',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34732,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34732,35.48,NULL,125,9416,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0471',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34733,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34733,35.53,0.2,128,9416,74.4,NULL,NULL,'FGC 0471',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34734,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34734,35.57,0.49,130,9416,75,NULL,'IR','FGC 0471',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34735,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34735,35.61,0.6,132,9417,70,NULL,NULL,'LCRS B041512.2-390357',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'17.01',0.18,NULL,NULL,NULL,NULL,NULL,1,64.239417,-38.94408,0,NULL,37791063226,590485362,9226333,17.01),(34736,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34736,33.23,0.49,44.2,9418,75,NULL,'IR','2MFGC 03474',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000037,NULL,'15.56',0.2,NULL,NULL,NULL,NULL,NULL,1,64.252667,27.74731,0.597,NULL,68332067548,1067688555,16682633,15.56),(34737,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34737,34.16,NULL,67.9,9419,NULL,NULL,'B','NGC 1547',NULL,'2005Ap&SS.298..577R',2005,1,1.3,NULL,'G',0.000033,NULL,'14.23',0.6,'SB(rs)bc pec:',NULL,NULL,NULL,NULL,1,64.3017083,-17.85747,0.041,NULL,36901514260,576586160,9009158,14.23),(34738,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34738,34.16,NULL,67.9,9419,NULL,NULL,'I','NGC 1547',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34739,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34739,35.23,0.47,111,9419,NULL,NULL,'H','NGC 1547',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34740,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34740,35.36,0.45,118,9419,NULL,NULL,'K','NGC 1547',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34741,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34741,35.39,0.46,120,9419,NULL,NULL,'J','NGC 1547',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34742,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34742,35.44,0.32,123,9419,NULL,NULL,NULL,'NGC 1547',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34743,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34743,35.49,0.2,125,9419,74.4,NULL,NULL,'NGC 1547',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34744,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34744,35.51,0.4,126,9419,NULL,NULL,'mean','NGC 1547',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34745,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34745,35.56,0.3,129,9419,NULL,NULL,'Malmquist cor.','NGC 1547',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34746,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34746,33.7,0.4,55.1,9420,NULL,NULL,'mean','NGC 1542',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000033,NULL,'14.83',0.5,'Sab','Isolated galaxy',NULL,NULL,NULL,1,64.309083,4.78164,0.541,NULL,65090573983,1017040218,15891253,14.83),(34747,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34747,34.15,0.47,67.5,9420,NULL,NULL,'H','NGC 1542',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34748,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34748,34.19,0.45,69,9420,NULL,NULL,'K','NGC 1542',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34749,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34749,34.23,0.46,70.3,9420,NULL,NULL,'J','NGC 1542',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34750,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34750,34.51,0.48,79.8,9421,70,NULL,NULL,'ESO 055- G 018',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000103,NULL,'15.04',0.4,'(R\'_2)SAB(l)0/a',NULL,NULL,NULL,NULL,1,64.314333,-70.02378,0.361,NULL,36438267679,569347932,8896061,15.04),(34751,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34751,33.57,0.4,51.9,9422,NULL,NULL,'mean','UGC 03004',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000017,NULL,'14.9',0.8,'SB?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,64.329125,2.43331,0.445,NULL,65041149384,1016267959,15879186,14.9),(34752,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34752,33.67,0.47,54.2,9422,NULL,NULL,'H','UGC 03004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34753,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34753,33.75,NULL,56.2,9423,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03005',NULL,'2010Ap&SS.325..163P',2010,1,1.21,NULL,'G',0.000018,NULL,'17.',0.12,'Scd',NULL,NULL,NULL,NULL,1,64.335417,2.45025,0.445,NULL,65041146371,1016267912,15879186,17),(34754,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34754,33.76,NULL,56.6,9423,NULL,NULL,'Dipole + Quadrupole','UGC 03005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34755,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34755,33.78,NULL,56.9,9423,NULL,NULL,'Dipole','UGC 03005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34756,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34756,33.83,NULL,58.3,9423,NULL,NULL,NULL,'UGC 03005',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34757,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34757,37.21,0.6,277,9424,70,NULL,NULL,'2MASX J04172176-0407005',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,64.3406666667,-4.11686,0.117,NULL,36965876115,577591814,9024872,15.8),(34758,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34758,37.11,0.57,265,9425,70,NULL,NULL,'FAIRALL 1122',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.00015,NULL,'15.96',0.38,'S0',NULL,NULL,NULL,NULL,1,64.351,-37.28189,0,NULL,37669399331,588584364,9196630,15.96),(34759,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34759,36.63,0.64,212,9426,70,NULL,NULL,'2MASX J04172799-5025599',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'17.33',0.21,'S0-E',NULL,NULL,NULL,NULL,1,64.366667,-50.43333,0,NULL,37747349055,589802328,9215661,17.33),(34760,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34760,36.47,0.63,197,9427,70,NULL,NULL,'2MASX J04173209-1310285',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'17.50',0.18,NULL,NULL,NULL,NULL,NULL,1,64.3837917,-13.1745,0.081,NULL,36863679658,575994994,8999921,17.5),(34761,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34761,36.45,0.71,195,9428,70,NULL,NULL,'2MASX J04173452-5253070',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.44',0.4,'S0',NULL,NULL,NULL,NULL,1,64.39375,-52.88528,0,NULL,37734100366,589595318,9212426,16.44),(34762,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34762,36.27,0.51,180,9429,70,NULL,NULL,'ESO 484- G 003',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000097,NULL,'15.39',0.4,'S0?',NULL,NULL,NULL,NULL,1,64.39825,-25.94086,0.029,NULL,37651701574,588307837,9192309,15.39),(34763,'SNIa','2016-12-15 15:14:03','2016-12-16 11:19:07','1','SN 2005df',NULL,34763,31.72,0.2,22,9430,72,NULL,'MLCS2k2, R(V) = 3.1','NGC 1559',0.00435,'2010ApJ...721.1608B',2010,1,3.5,NULL,'G',0.000013,NULL,'11.0',2,'SB(s)cd','Possible group member',NULL,NULL,NULL,1,64.3990416667,-62.78367,0,NULL,35869831215,560466112,8757283,11),(34764,'SNII optical','2016-12-15 15:14:03','2016-12-16 11:19:07','1','SN 1986L',NULL,34764,31.02,0.25,16,9430,NULL,NULL,NULL,'NGC 1559',NULL,'1994ApJ...432...42S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34765,'SNII optical','2016-12-15 15:14:03','2016-12-16 11:19:07','1','SN 1986L',NULL,34765,31.18,0.35,17.2,9430,NULL,NULL,'EPM','NGC 1559',NULL,'2015MNRAS.450.3137T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34766,'SNII optical','2016-12-15 15:14:03','2016-12-16 11:19:07','1','SN 2009ib',NULL,34766,31.48,0.29,19.8,9430,NULL,NULL,'EPM, SCM, SNIa, and TF mean','NGC 1559',NULL,'2015MNRAS.450.3137T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34767,'SNII optical','2016-12-15 15:14:03','2016-12-16 11:19:07','1','SN 2009ib',NULL,34767,31.64,0.21,21.3,9430,NULL,NULL,'EPM','NGC 1559',NULL,'2015MNRAS.450.3137T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34768,'SNII optical','2016-12-15 15:14:03','2016-12-16 11:19:07','1','SN 2009ib',NULL,34768,31.86,0.15,23.6,9430,NULL,NULL,'SCM','NGC 1559',NULL,'2015MNRAS.450.3137T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34769,'IRAS','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34769,31.21,0.8,17.5,9430,75,NULL,'MAT, I','NGC 1559',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34770,'IRAS','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34770,31.22,0.8,17.5,9430,75,NULL,'A82, H','NGC 1559',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34771,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34771,29.95,0.43,9.8,9430,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1559',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34772,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34772,30.17,0.43,10.8,9430,75,NULL,'3.6 micron, color corrected','NGC 1559',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34773,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34773,30.3,NULL,11.5,9430,NULL,NULL,'LEDA [April 2006]','NGC 1559',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34774,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34774,30.5,0.2,12.6,9430,74.4,NULL,NULL,'NGC 1559',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34775,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34775,30.5,0.38,12.6,9430,NULL,NULL,NULL,'NGC 1559',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34776,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34776,30.5,0.39,12.6,9430,73,NULL,'opt','NGC 1559',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34777,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34777,30.57,0.32,13,9430,85,NULL,'I, raw','NGC 1559',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34778,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34778,30.59,0.32,13.1,9430,85,NULL,'I, inv','NGC 1559',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34779,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34779,30.6,0.3,13.2,9430,NULL,18.45,'SN 1986L host','NGC 1559',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34780,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34780,30.67,0.4,13.6,9430,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 1559',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34781,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34781,30.68,0.43,13.7,9430,75,NULL,'MAT, I, raw','NGC 1559',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34782,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34782,30.78,0.4,14.3,9430,75,NULL,'B','NGC 1559',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34783,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34783,30.83,0.43,14.7,9430,75,NULL,'MAT, I, inv','NGC 1559',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34784,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34784,30.9,0.28,15.1,9430,NULL,NULL,NULL,'NGC 1559',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34785,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34785,30.91,0.28,15.2,9430,NULL,NULL,'Malmquist cor.','NGC 1559',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34786,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34786,30.94,0.43,15.4,9430,75,NULL,'MAT, I, cor','NGC 1559',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34787,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34787,31.01,0.47,15.9,9430,75,NULL,'A82, H, raw','NGC 1559',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34788,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34788,31.09,0.47,16.5,9430,75,NULL,'A82, H, inv','NGC 1559',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34789,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34789,31.24,0.47,17.7,9430,75,NULL,'A82, H, cor','NGC 1559',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34790,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34790,35.98,0.7,157,9431,70,NULL,NULL,'2MASX J04173641-1043224',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00008,NULL,'16.11',0.33,NULL,NULL,NULL,NULL,NULL,1,64.4017083,-10.72289,0.113,NULL,36977251724,577769558,9027649,16.11),(34791,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34791,36.26,0.81,178,9432,70,NULL,NULL,'ESO 118- G 017',NULL,'2014MNRAS.445.2677S',2014,1,1.08,NULL,'G',0.00015,NULL,'16.11',0.21,'Sbc',NULL,NULL,NULL,NULL,1,64.40325,-58.88817,0,NULL,35793569766,559274527,8738664,16.11),(34792,'IRAS','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34792,30.61,0.8,13.3,9433,75,NULL,'MAT, I','NGC 1556',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000024,NULL,'13.47',0.5,'Sab pec?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,64.4367916667,-50.16444,0,NULL,37747478488,589804351,9215692,13.47),(34793,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34793,30.68,0.07,13.7,9433,NULL,NULL,NULL,'NGC 1556',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34794,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34794,30.68,0.32,13.7,9433,85,NULL,'I, inv','NGC 1556',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34795,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34795,30.72,0.32,13.9,9433,85,NULL,'I, raw','NGC 1556',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34796,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34796,31.13,0.4,16.8,9433,NULL,NULL,NULL,'NGC 1556',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34797,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34797,31.13,0.4,16.8,9433,73,NULL,'opt','NGC 1556',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34798,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34798,31.21,0.4,17.5,9433,NULL,NULL,'mean','NGC 1556',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34799,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34799,31.26,0.43,17.8,9433,75,NULL,'MAT, I, inv','NGC 1556',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34800,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34800,31.32,0.43,18.3,9433,75,NULL,'MAT, I, raw','NGC 1556',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34801,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34801,31.47,0.43,19.7,9433,75,NULL,'MAT, I, cor','NGC 1556',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34802,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34802,31.78,0.46,22.7,9433,NULL,NULL,'J','NGC 1556',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34803,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34803,31.81,0.47,23,9433,NULL,NULL,'H','NGC 1556',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34804,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34804,31.91,0.45,24.1,9433,NULL,NULL,'K','NGC 1556',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34805,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34805,36.47,0.59,197,9434,70,NULL,NULL,'2MASX J04174567-3708319',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.74',0.35,NULL,NULL,NULL,NULL,NULL,1,64.44025,-37.14228,0,NULL,37669511640,588586119,9196658,16.74),(34806,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34806,34.69,0.46,86.6,9435,70,NULL,NULL,'2MASX J04175220-6340311',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000057,NULL,'12.8R',0.9,'SB0^-:',NULL,NULL,NULL,NULL,1,64.467417,-63.67525,0.029,NULL,36390566100,568602595,8884415,12.8),(34807,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34807,34.41,0.52,76.4,9436,70,NULL,NULL,'IC 2060',NULL,'2014MNRAS.445.2677S',2014,1,0.87,NULL,'G',0.00015,NULL,'15.17',0.55,'S0-: pec',NULL,NULL,NULL,NULL,1,64.472333,-56.61625,0,NULL,35813333817,559583340,8743489,15.17),(34808,'IRAS','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34808,31.4,0.8,19,9437,75,NULL,'A82, H','IC 2058',NULL,'1997ApJS..109..333W',1997,1,2.39,'Confused HIPASS source','G',0.000002,NULL,'13.87',0.24,'Sc:            HII','in a pair',NULL,NULL,NULL,1,64.4764583,-55.93289,0,NULL,35813877112,559591829,8743622,13.87),(34809,'IRAS','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34809,31.41,0.8,19.1,9437,75,NULL,'MAT, I','IC 2058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34810,'Tully est','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34810,30.64,0.8,13.4,9437,75,NULL,NULL,'IC 2058',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34811,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34811,31.26,0.32,17.9,9437,85,NULL,'I, inv','IC 2058',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34812,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34812,31.28,0.32,18,9437,85,NULL,'I, raw','IC 2058',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34813,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34813,31.28,0.4,18.1,9437,75,NULL,NULL,'IC 2058',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34814,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34814,31.29,0.39,18.1,9437,73,NULL,'IR','IC 2058',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34815,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34815,31.47,0.47,19.7,9437,75,NULL,'A82, H, inv','IC 2058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34816,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34816,31.47,0.4,19.7,9437,NULL,NULL,'mean','IC 2058',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34817,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34817,31.49,0.43,19.8,9437,75,NULL,'MAT, I, inv','IC 2058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34818,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34818,31.49,0.43,19.9,9437,75,NULL,'MAT, I, raw','IC 2058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34819,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34819,31.54,0.49,20.3,9437,75,NULL,'IR','IC 2058',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34820,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34820,31.59,0.47,20.8,9437,75,NULL,'A82, H, raw','IC 2058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34821,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34821,31.6,0.43,20.9,9437,75,NULL,'MAT, I, cor','IC 2058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34822,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34822,31.69,0.47,21.8,9437,75,NULL,'A82, H, cor','IC 2058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34823,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34823,31.71,NULL,21.9,9437,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 2058',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34824,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34824,31.73,NULL,22.2,9437,NULL,NULL,NULL,'IC 2058',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34825,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34825,31.73,NULL,22.2,9437,NULL,NULL,'Dipole + Quadrupole','IC 2058',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34826,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34826,31.74,NULL,22.2,9437,NULL,NULL,'Dipole','IC 2058',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34827,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34827,32.08,0.47,26.1,9437,NULL,NULL,'H','IC 2058',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34828,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34828,32.15,0.46,27,9437,NULL,NULL,'J','IC 2058',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34829,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34829,32.4,0.45,30.2,9437,NULL,NULL,'K','IC 2058',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34830,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34830,36.06,0.66,163,9438,70,NULL,NULL,'2MASX J04181248-5414063',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'17.30',0.19,NULL,NULL,NULL,NULL,NULL,1,64.552,-54.23506,0,NULL,35818058836,559657169,8744643,17.3),(34831,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34831,35.1,0.75,105,9439,70,NULL,NULL,'2MASX J04181959-1048289',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00008,NULL,'15.71',0.27,NULL,NULL,NULL,NULL,NULL,1,64.5815417,-10.80814,0.137,NULL,36943980541,577249695,9019526,15.71),(34832,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34832,34.62,0.49,84.1,9440,75,NULL,'IR','FGC 0476',NULL,'2011yCatp016004901K',2011,1,1.56,NULL,'G',0.000063,NULL,'14.72',0.32,'Scd',NULL,NULL,NULL,NULL,1,64.625083,-14.99008,0.073,NULL,36873390218,576146722,9002292,14.72),(34833,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34833,34.9,NULL,95.5,9440,NULL,NULL,'Dipole','FGC 0476',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34834,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34834,34.9,NULL,95.6,9440,NULL,NULL,'Dipole + Quadrupole','FGC 0476',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34835,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34835,34.9,NULL,95.7,9440,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0476',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34836,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34836,34.97,NULL,98.8,9440,NULL,NULL,NULL,'FGC 0476',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34837,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34837,29.97,1.03,9.84,9441,NULL,NULL,NULL,'UGC 03007',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000017,NULL,'17.',1,'SAB(s)d',NULL,NULL,NULL,NULL,1,64.625875,33.77403,1.257,NULL,68382963548,1068483805,16695059,17),(34838,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34838,30.14,0.96,10.6,9441,NULL,NULL,'Malmquist cor.','UGC 03007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34839,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34839,34.84,0.49,92.8,9442,75,NULL,'IR','FGC 0475',NULL,'2011yCatp016004901K',2011,1,1.01,NULL,'G',0.000043,NULL,'15',0.13,'Sc',NULL,NULL,NULL,NULL,1,64.698667,3.22786,0.565,NULL,65033937037,1016155266,15877426,15),(34840,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34840,35.26,0.4,113,9442,NULL,NULL,'mean','FGC 0475',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34841,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34841,35.37,0.47,119,9442,NULL,NULL,'H','FGC 0475',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34842,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34842,35.42,0.45,121,9442,NULL,NULL,'K','FGC 0475',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34843,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34843,35.79,NULL,144,9442,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0475',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34844,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34844,35.8,NULL,144,9442,NULL,NULL,'Dipole + Quadrupole','FGC 0475',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34845,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34845,35.82,NULL,146,9442,NULL,NULL,NULL,'FGC 0475',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34846,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34846,35.83,NULL,146,9442,NULL,NULL,'Dipole','FGC 0475',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34847,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34847,36.7,0.53,219,9443,70,NULL,NULL,'LCRS B041710.8-413221',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.000103,NULL,'16.26',0.43,'S0',NULL,NULL,NULL,NULL,1,64.7137916667,-41.41931,0.005,NULL,37838019935,591219061,9237797,16.26),(34848,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34848,36.16,0.53,171,9444,70,NULL,NULL,'ESO 303- G 010',NULL,'2014MNRAS.445.2677S',2014,1,1.2,'The APMUKS data are incorrect for this galaxy.','G',0.00008,NULL,'15.47',0.9,'S0',NULL,NULL,NULL,NULL,1,64.7172917,-37.46203,0.005,NULL,37670055554,588594618,9196790,15.47),(34849,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34849,33.43,0.5,48.4,9445,70,NULL,NULL,'MCG -02-11-038',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000113,NULL,'15',0.5,NULL,NULL,NULL,NULL,NULL,1,64.7253333333,-14.19603,0.061,NULL,36862633766,575978652,8999666,15),(34850,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34850,36.1,0.56,166,9446,70,NULL,NULL,'2MASX J04185676-1147197',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'17.06',0.31,NULL,NULL,NULL,NULL,NULL,1,64.7365416667,-11.78883,0.065,NULL,36977888267,577779504,9027804,17.06),(34851,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34851,33.95,0.56,61.7,9447,70,NULL,NULL,'ESO 084- G 011',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000073,NULL,'14.98',0.3,'S...',NULL,NULL,NULL,NULL,1,64.7377083,-63.48911,0.029,NULL,35870100275,560470316,8757348,14.98),(34852,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34852,35.3,0.51,115,9448,70,NULL,NULL,'2MASX J04185759-0141310',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000097,NULL,'13.6I',0.5,NULL,NULL,NULL,NULL,NULL,1,64.7399583,-1.69203,0.305,NULL,36925915716,576967433,9015116,13.6),(34853,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34853,36.53,0.7,202,9449,70,NULL,NULL,'2MASX J04185858-3712324',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'17.12',0.31,NULL,NULL,NULL,NULL,NULL,1,64.744167,-37.20897,0.013,NULL,37669485037,588585703,9196651,17.12),(34854,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34854,32.94,0.2,38.7,9450,74.4,NULL,NULL,'UGC 03009',NULL,'2013AJ....146...86T',2013,1,1.79,NULL,'G',0.000005,NULL,'16.0',0.25,'Sbc',NULL,NULL,NULL,NULL,1,64.77475,26.17994,0.537,NULL,68318653763,1067478965,16679358,16),(34855,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34855,32.99,0.49,39.6,9450,75,NULL,'IR','UGC 03009',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34856,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34856,33.08,0.53,41.2,9450,NULL,NULL,NULL,'UGC 03009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34857,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34857,33.12,0.43,42,9450,75,NULL,'3.6 micron, color corrected','UGC 03009',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34858,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34858,33.2,0.43,43.6,9450,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03009',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34859,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34859,33.28,0.48,45.2,9450,NULL,NULL,'Malmquist cor.','UGC 03009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34860,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34860,33.57,NULL,51.7,9450,NULL,NULL,'Dipole','UGC 03009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34861,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34861,33.57,NULL,51.7,9450,NULL,NULL,'Dipole + Quadrupole','UGC 03009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34862,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34862,33.57,NULL,51.9,9450,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34863,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34863,33.76,NULL,56.5,9450,NULL,NULL,NULL,'UGC 03009',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34864,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34864,33.91,0.47,60.6,9451,NULL,NULL,'H','2MASX J04191179+5552439',NULL,'2007A&A...465...71T',2007,1,2.2,NULL,'G',0.00003,NULL,'9.95K',1.4,'Sc',NULL,NULL,NULL,NULL,1,64.8009583333,55.87425,NULL,NULL,66191752623,1034246134,16160095,9.95),(34865,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34865,33.99,0.45,62.9,9451,NULL,NULL,'K','2MASX J04191179+5552439',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34866,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34866,34.15,0.4,67.7,9451,NULL,NULL,'mean','2MASX J04191179+5552439',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34867,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34867,34.17,0.46,68.1,9451,NULL,NULL,'J','2MASX J04191179+5552439',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34868,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34868,35.22,0.47,111,9452,70,NULL,NULL,'MCG -02-11-039',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000137,NULL,'14.76',0.4,NULL,NULL,NULL,NULL,NULL,1,64.818917,-14.10322,0.065,NULL,36862648936,575978889,8999670,14.76),(34869,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34869,37,0.57,252,9453,70,NULL,NULL,'2MASX J04191817-3721237',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'16.40',0.49,NULL,NULL,NULL,NULL,NULL,1,64.825583,-37.35653,0.005,NULL,37669983246,588593488,9196773,16.4),(34870,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34870,37.42,0.58,305,9454,70,NULL,NULL,'2MASX J04192439-6733295',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'16.0b',0.22,NULL,NULL,NULL,NULL,NULL,1,64.8515,-67.55814,0.125,NULL,36395240605,568675634,8885556,16),(34871,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34871,37.44,0.86,307,9455,70,NULL,NULL,'2MASX J04192479-0802575',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.68',0.31,NULL,NULL,NULL,NULL,NULL,1,64.853333,-8.04933,0.145,NULL,36958486370,577476349,9023067,16.68),(34872,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34872,35.64,0.52,134,9456,70,NULL,NULL,'ESO 484- G 006',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.38',0.5,'S0-:',NULL,NULL,NULL,NULL,1,64.8657083,-26.73186,0.093,NULL,37651196108,588299939,9192186,15.38),(34873,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34873,33.54,0.4,51.1,9457,NULL,NULL,'mean','NGC 1550',NULL,'2007A&A...465...71T',2007,1,2.2,NULL,'G',0.000077,NULL,'13.07',1.9,'SA(s)0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,64.9080417,2.40947,0.517,NULL,65041921749,1016280027,15879375,13.07),(34874,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34874,34.61,0.45,83.5,9457,NULL,NULL,'K','NGC 1550',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34875,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34875,36.05,0.65,162,9458,70,NULL,NULL,'2MASX J04194411-0015261',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.40',0.4,NULL,NULL,NULL,NULL,NULL,1,64.93375,-0.25728,0.261,NULL,36910956367,576733693,9011463,16.4),(34876,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34876,35.57,0.54,130,9459,70,NULL,NULL,'CGCG 393-003',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000097,NULL,'15.7b',0.25,NULL,NULL,NULL,NULL,NULL,1,64.948667,-0.91389,0.221,NULL,36925543856,576961622,9015025,15.7),(34877,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34877,36.67,0.67,216,9460,70,NULL,NULL,'2MFGC 03509',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.00015,NULL,'16.66',0.17,NULL,NULL,NULL,NULL,NULL,1,64.964125,-39.16761,0,NULL,37791401216,590490644,9226416,16.66),(34878,'IRAS','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34878,31.64,0.8,21.3,9461,75,NULL,'MAT, I','NGC 1566',NULL,'1997ApJS..109..333W',1997,1,8.3,'Extended HIPASS source','G',0.000007,NULL,'10.33',6.6,'(R\'_1)SAB(rs)bcSy1','Group member, radial-velocity confirmed',NULL,NULL,'Sy 1.5',1,65.00175,-54.93781,0,NULL,35819043268,559672551,8744883,10.33),(34879,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34879,28.7,0.43,5.5,9461,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1566',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34880,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34880,28.89,0.43,6,9461,75,NULL,'3.6 micron, color corrected','NGC 1566',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34881,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34881,29.1,0.2,6.61,9461,74.4,NULL,NULL,'NGC 1566',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34882,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34882,29.26,0.32,7.15,9461,85,NULL,'I, raw','NGC 1566',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34883,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34883,29.29,0.32,7.23,9461,85,NULL,'I, inv','NGC 1566',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34884,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34884,29.39,0.43,7.56,9461,75,NULL,'MAT, I, raw','NGC 1566',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34885,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34885,29.53,0.43,8.04,9461,75,NULL,'MAT, I, inv','NGC 1566',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34886,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34886,29.74,0.43,8.87,9461,75,NULL,'MAT, I, cor','NGC 1566',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34887,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34887,29.99,0.45,9.97,9461,NULL,NULL,'K','NGC 1566',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34888,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34888,30.64,0.4,13.4,9461,75,NULL,'B','NGC 1566',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34889,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34889,31.09,0.4,16.5,9461,NULL,NULL,'mean','NGC 1566',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34890,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34890,36.34,0.58,186,9462,70,NULL,NULL,'2MASX J04200239-3716292',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.70',0.42,NULL,NULL,NULL,NULL,NULL,1,65.0099583,-37.27478,0.013,NULL,37669974747,588593355,9196771,16.7),(34891,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34891,35.91,0.59,152,9463,70,NULL,NULL,'2MASX J04200310-5109448',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.54',0.37,NULL,NULL,NULL,NULL,NULL,1,65.012917,-51.16239,0,NULL,37733269672,589582338,9212224,16.54),(34892,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34892,34.89,0.2,95.1,9464,74.4,NULL,NULL,'MCG +00-12-005',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000077,NULL,'15.5',0.15,'Sc',NULL,NULL,NULL,NULL,1,65.021625,0.21764,0.301,NULL,65030804400,1016106318,15876661,15.5),(34893,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34893,37.17,0.58,271,9465,70,NULL,NULL,'2MASX J04200994-1808284',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,65.0415,-18.14114,0.101,NULL,37367217376,583862771,9122855,15),(34894,'IRAS','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34894,33.88,0.8,59.6,9466,75,NULL,'MAT, I','NGC 1558',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.00003,NULL,'13.26',1,'(R\')SA(rs)b','Pair member (points to parent)',NULL,NULL,NULL,1,65.067417,-45.03147,0,NULL,37844925773,591326965,9239483,13.26),(34895,'Sosies','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34895,33.99,0.07,62.8,9466,NULL,NULL,NULL,'NGC 1558',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34896,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34896,29.08,0.36,6.55,9466,NULL,NULL,NULL,'NGC 1558',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34897,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34897,33.86,0.46,59.2,9466,NULL,NULL,'J','NGC 1558',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34898,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34898,33.88,0.47,59.6,9466,NULL,NULL,'H','NGC 1558',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34899,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34899,33.92,0.43,60.8,9466,75,NULL,'MAT, I, raw','NGC 1558',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34900,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34900,33.95,0.29,61.7,9466,NULL,NULL,'Malmquist cor.','NGC 1558',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34901,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34901,33.98,0.4,62.6,9466,NULL,NULL,'mean','NGC 1558',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34902,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34902,33.99,0.45,62.7,9466,NULL,NULL,'K','NGC 1558',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34903,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34903,34.12,0.32,66.6,9466,85,NULL,'I, raw','NGC 1558',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34904,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34904,34.12,0.27,66.6,9466,NULL,NULL,NULL,'NGC 1558',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34905,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34905,34.15,0.43,67.6,9466,75,NULL,'MAT, I, cor','NGC 1558',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34906,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34906,34.16,0.2,67.9,9466,74.4,NULL,NULL,'NGC 1558',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34907,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34907,34.2,0.32,69.3,9466,85,NULL,'I, inv','NGC 1558',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34908,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34908,34.25,0.43,70.9,9466,75,NULL,'MAT, I, inv','NGC 1558',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34909,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34909,33.87,0.5,59.3,9467,70,NULL,NULL,'NGC 1552',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.000027,NULL,'13.93',1.2,'SAB(r)0+?      AGN',NULL,NULL,NULL,NULL,1,65.073667,-0.69272,0.221,NULL,36924743644,576949119,9014829,13.93),(34910,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34910,35.89,0.63,151,9468,70,NULL,NULL,'2MASX J04202575-1459468',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.000107,NULL,'15.67',0.38,NULL,NULL,NULL,NULL,NULL,1,65.107375,-14.99636,0.069,NULL,37347145510,583549148,9117955,15.67),(34911,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34911,36.95,0.64,246,9469,70,NULL,NULL,'2MASX J04202586-5332100',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'17.20',0.18,NULL,NULL,NULL,NULL,NULL,1,65.107833,-53.53625,0,NULL,35803707587,559432931,8741139,17.2),(34912,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34912,36.52,0.54,201,9470,70,NULL,NULL,'2MASX J04202901-0625069',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.3,NULL,NULL,NULL,NULL,NULL,1,65.120875,-6.41861,0.069,NULL,36951525813,577367590,9021368,13.9),(34913,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34913,36.4,0.7,191,9471,70,NULL,NULL,'MCG +00-12-008',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.1b',0.2,NULL,NULL,NULL,NULL,NULL,1,65.1405,-0.74919,0.221,NULL,36924696116,576948376,9014818,16.1),(34914,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34914,35.72,0.48,139,9472,70,NULL,NULL,'2MASX J04203981-0644019',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.0001,NULL,'16.04',0.5,NULL,NULL,NULL,NULL,NULL,1,65.166,-6.73383,0.065,NULL,36951420618,577365947,9021342,16.04),(34915,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34915,35.78,0.5,143,9473,70,NULL,NULL,'2MASX J04204381-0352330',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000093,NULL,'15.5b',0.5,NULL,NULL,NULL,NULL,NULL,1,65.182625,-3.87586,0.081,NULL,36920833481,576888023,9013875,15.5),(34916,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34916,35.87,0.56,150,9474,70,NULL,NULL,'2MASX J04204427-1810419',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.73',0.53,'S',NULL,NULL,NULL,NULL,1,65.1845,-18.17839,0.089,NULL,37367245328,583863208,9122862,15.73),(34917,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34917,35.47,0.56,124,9475,70,NULL,NULL,'2MASX J04205324-0309429',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000103,NULL,'15.0b',0.5,NULL,NULL,NULL,NULL,NULL,1,65.221833,-3.16189,0.117,NULL,36920992126,576890501,9013914,15),(34918,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34918,34.04,0.49,64.4,9476,75,NULL,'IR','UGC 03017',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000017,NULL,'16.5',0.2,'Sdm:',NULL,NULL,NULL,NULL,1,65.2290833333,5.67347,0.589,NULL,65087704789,1016995387,15890552,16.5),(34919,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34919,36.25,0.63,178,9477,70,NULL,NULL,'2MASX J04205753-0226279',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.1I',0.5,NULL,NULL,NULL,NULL,NULL,1,65.2397083,-2.44111,0.137,NULL,36926318431,576973725,9015214,14.1),(34920,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34920,36.12,0.54,168,9478,70,NULL,NULL,'2MASX J04210018-0359139',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.4,NULL,NULL,NULL,NULL,NULL,1,65.2507917,-3.98719,0.081,NULL,36920876820,576888700,9013885,14.2),(34921,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34921,33.99,0.4,62.7,9479,NULL,NULL,'mean','NGC 1567',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000063,NULL,'12.17',1.3,'SA(s)0^-','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,65.2864583,-48.25478,0,NULL,37809418170,590772158,9230814,12.17),(34922,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34922,34.03,0.45,64,9479,NULL,NULL,'K','NGC 1567',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34923,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34923,36.25,0.6,178,9480,70,NULL,NULL,'2MASX J04210925-0645030',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.7I',0.5,'AGN?',NULL,NULL,NULL,NULL,1,65.288583,-6.75089,0.065,NULL,36951379117,577365298,9021332,13.7),(34924,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34924,35.06,0.51,103,9481,70,NULL,NULL,'2MASX J04211352-2458399',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'16.30',0.33,'S0',NULL,NULL,NULL,NULL,1,65.30625,-24.97772,0.049,NULL,37182284054,580973188,9077706,16.3),(34925,'IRAS','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34925,30.42,0.8,12.1,9482,75,NULL,'A82, H','UGCA 090',NULL,'1997ApJS..109..333W',1997,1,5.6,NULL,'G',0.000007,NULL,'12.67',2.1,'SB(s)d:',NULL,NULL,NULL,NULL,1,65.3067916667,-21.84614,0.029,NULL,37326955333,583233677,9113026,12.67),(34926,'Tully est','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34926,30.02,0.8,10.1,9482,75,NULL,NULL,'UGCA 090',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34927,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34927,29.99,0.47,9.93,9482,75,NULL,'A82, H, inv','UGCA 090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34928,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34928,30.07,0.38,10.3,9482,NULL,NULL,NULL,'UGCA 090',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34929,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34929,30.06,0.4,10.3,9482,73,NULL,'opt','UGCA 090',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34930,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34930,30.12,0.47,10.6,9482,75,NULL,'A82, H, raw','UGCA 090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34931,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34931,30.2,0.2,11,9482,74.4,NULL,NULL,'UGCA 090',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34932,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34932,30.36,0.43,11.8,9482,75,NULL,'3.6 micron, color corrected','UGCA 090',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34933,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34933,30.39,0.08,12,9482,NULL,NULL,NULL,'UGCA 090',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34934,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34934,30.51,0.43,12.6,9482,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 090',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34935,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34935,30.54,0.47,12.8,9482,75,NULL,'A82, H, cor','UGCA 090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34936,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34936,30.95,0.4,15.5,9482,NULL,NULL,'mean','UGCA 090',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34937,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34937,31.16,0.47,17,9482,NULL,NULL,'H','UGCA 090',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34938,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34938,31.45,0.46,19.5,9482,NULL,NULL,'J','UGCA 090',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34939,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34939,31.5,0.45,19.9,9482,NULL,NULL,'K','UGCA 090',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34940,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34940,35.28,0.47,114,9483,70,NULL,NULL,'2MASX J04211719-0956450',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'15.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,65.32175,-9.94586,0.161,NULL,36947177015,577299640,9020306,15.6),(34941,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34941,35.77,0.5,143,9484,70,NULL,NULL,'2MASX J04211968-1814303',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.60',0.58,'S0',NULL,NULL,NULL,NULL,1,65.331833,-18.24192,0.089,NULL,37367913836,583873653,9123025,15.6),(34942,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34942,32.09,0.47,26.2,9485,NULL,NULL,'H','UGC 03016',NULL,'2007A&A...465...71T',2007,1,1.4,'Bottinelli, et al. (1993A&AS..102...57B) give v = 2458 +/- 14 km/sec.','G',0.000013,NULL,'17.',0.3,'Scd:',NULL,NULL,NULL,NULL,1,65.333333,36.76003,NULL,NULL,68367582395,1068243474,16691304,17),(34943,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34943,32.19,0.45,27.5,9485,NULL,NULL,'K','UGC 03016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34944,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34944,32.51,0.46,31.8,9485,NULL,NULL,'J','UGC 03016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34945,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34945,32.7,0.4,34.7,9485,NULL,NULL,'mean','UGC 03016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34946,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34946,36.26,0.52,179,9486,70,NULL,NULL,'2MASX J04212101-0638400',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.40',0.4,NULL,NULL,NULL,NULL,NULL,1,65.3373333333,-6.64447,0.065,NULL,36951497751,577367152,9021361,16.4),(34947,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34947,36.42,0.51,192,9487,70,NULL,NULL,'2MASX J04212247-0510067',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.93',0.5,NULL,NULL,NULL,NULL,NULL,1,65.3437083333,-5.16853,0.117,NULL,36964783349,577574739,9024605,15.93),(34948,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34948,34.13,NULL,67,9488,NULL,NULL,'B','ESO 550- G 026',NULL,'2005Ap&SS.298..577R',2005,1,1.5,NULL,'G',0.000033,NULL,'15.5',0.4,'Sb',NULL,NULL,NULL,NULL,1,65.403125,-17.92878,0.101,NULL,37350723997,583605062,9118829,15.5),(34949,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34949,34.13,NULL,67,9488,NULL,NULL,'I','ESO 550- G 026',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34950,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34950,34.99,0.6,99.7,9488,NULL,NULL,NULL,'ESO 550- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34951,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34951,35.03,0.2,101,9488,74.4,NULL,NULL,'ESO 550- G 026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34952,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34952,35.25,0.53,112,9488,NULL,NULL,'Malmquist cor.','ESO 550- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34953,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34953,35.67,0.63,136,9489,70,NULL,NULL,'2MASX J04213792-5731566',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'16.26',0.28,'S',NULL,NULL,NULL,NULL,1,65.407833,-57.53247,0,NULL,35819523910,559680061,8745000,16.26),(34954,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34954,34.24,0.4,70.3,9490,NULL,NULL,'mean','UGC 03019',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000013,NULL,'17.',0.7,'S',NULL,NULL,NULL,NULL,1,65.4170417,36.73164,NULL,NULL,68368090764,1068251418,16691428,17),(34955,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34955,34.25,0.47,70.7,9490,NULL,NULL,'H','UGC 03019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34956,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34956,34.29,0.45,72.3,9490,NULL,NULL,'K','UGC 03019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34957,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34957,34.32,0.46,73,9490,NULL,NULL,'J','UGC 03019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34958,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34958,35.54,0.49,128,9491,70,NULL,NULL,'NGC 1562',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000083,NULL,'15.18',0.6,'SA(s:)0o',NULL,NULL,NULL,NULL,1,65.448417,-15.75544,0.077,NULL,37352544193,583633503,9119273,15.18),(34959,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34959,35.42,0.52,121,9492,70,NULL,NULL,'CGCG 393-011 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000083,NULL,'15.7b',0.3,NULL,NULL,NULL,NULL,NULL,1,65.450167,-2.18264,0.137,NULL,36926504605,576976634,9015259,15.7),(34960,'SBF','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34960,31.43,0.12,19.3,9493,74.4,NULL,NULL,'NGC 1574',NULL,'2013AJ....146...86T',2013,1,3.4,NULL,'G',0.000053,NULL,'11.36',3.1,'SA0^-','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,65.495083,-56.97475,0,NULL,35811619519,559556554,8743071,11.36),(34961,'SBF','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34961,31.49,0.21,19.9,9493,NULL,NULL,'I','NGC 1574',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34962,'SBF','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34962,31.49,0.21,19.9,9493,NULL,NULL,NULL,'NGC 1574',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34963,'SBF','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34963,31.51,0.21,20.1,9493,NULL,NULL,'Malmquist cor.','NGC 1574',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34964,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34964,28.95,0.63,6.17,9493,95,NULL,'Michard 1979b, c','NGC 1574',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34965,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34965,29.98,0.37,9.91,9493,95,NULL,'Weighted Mean','NGC 1574',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34966,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34966,30.04,0.46,10.2,9493,95,NULL,'Michard 1979a','NGC 1574',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34967,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34967,31.57,NULL,20.6,9493,NULL,NULL,'LEDA [April 2006]','NGC 1574',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34968,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34968,32.08,0.81,26.1,9493,55,NULL,'Visvanathan & Sandage 1979','NGC 1574',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34969,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34969,31.36,0.41,18.7,9493,NULL,NULL,NULL,'NGC 1574',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34970,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34970,31.43,0.12,19.3,9493,74.4,NULL,NULL,'NGC 1574',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34971,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34971,31.45,0.41,19.5,9493,NULL,NULL,'Malmquist cor.','NGC 1574',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34972,'Tertiary','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34972,29.99,0.32,9.95,9493,95,NULL,NULL,'NGC 1574',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34973,'Tully est','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34973,30.64,0.8,13.4,9493,75,NULL,'B','NGC 1574',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34974,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34974,31.1,0.4,16.6,9493,NULL,NULL,'mean','NGC 1574',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34975,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34975,31.62,0.45,21.1,9493,NULL,NULL,'K','NGC 1574',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34976,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34976,35.55,0.51,129,9494,70,NULL,NULL,'2MASX J04220212-0340189',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000077,NULL,'15.52',0.7,NULL,NULL,NULL,NULL,NULL,1,65.5089583,-3.67192,0.073,NULL,36921484348,576898192,9014034,15.52),(34977,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34977,33.95,0.4,61.8,9495,NULL,NULL,'mean','NGC 1570',NULL,'2007A&A...465...71T',2007,1,2,NULL,'G',0.000063,NULL,'13.23',1.5,'E+ pec',NULL,NULL,NULL,NULL,1,65.53725,-43.62956,0,NULL,37844184785,591315387,9239302,13.23),(34978,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34978,34.39,0.45,75.6,9495,NULL,NULL,'K','NGC 1570',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34979,'Tully est','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34979,30.8,0.8,14.5,9496,75,NULL,NULL,'ESO 084- G 015',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000022,NULL,'15.27',0.5,'SB(s)m:',NULL,NULL,NULL,NULL,1,65.549375,-63.61108,0.029,NULL,35869955396,560468053,8757313,15.27),(34980,'BL Lac Luminosity','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34980,43.68,NULL,3600,9497,NULL,NULL,NULL,'SHBL J042218.4+195051',0.512,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.003,':','20.26',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,65.576375,19.84883,1.473,NULL,65237942101,1019342845,15927231,20.26),(34981,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34981,34.19,0.52,68.7,9498,70,NULL,NULL,'ESO 303- G 012',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.000127,NULL,'15.45',0.49,'S...',NULL,NULL,NULL,NULL,1,65.581167,-37.89328,0.029,NULL,37669082727,588579417,9196553,15.45),(34982,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34982,36.03,0.56,161,9499,70,NULL,NULL,'2MASX J04222838-0730501',NULL,'2014MNRAS.445.2677S',2014,1,0.93,NULL,'G',0.000113,NULL,'15.88',0.28,NULL,NULL,NULL,NULL,NULL,1,65.61825,-7.51394,0.121,NULL,36951166741,577361980,9021280,15.88),(34983,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34983,36.69,0.52,218,9500,70,NULL,NULL,'2MASX J04222942-0501287',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.94',NULL,NULL,NULL,NULL,NULL,NULL,1,65.6225417,-5.02481,0.065,NULL,36964888181,577576377,9024630,15.94),(34984,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34984,37.14,0.69,268,9501,70,NULL,NULL,'2MASX J04224177-1418414',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.000147,NULL,'17.18',0.2,NULL,NULL,NULL,NULL,NULL,1,65.6740416667,-14.31144,0.077,NULL,37347833867,583559904,9118123,17.18),(34985,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34985,34.17,0.5,68.2,9502,70,NULL,NULL,'IC 0368',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000103,NULL,'14.9b',0.7,NULL,NULL,NULL,NULL,NULL,1,65.678,-12.61517,0.065,NULL,37346332787,583536449,9117757,14.9),(34986,'IRAS','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34986,34.53,0.8,80.6,9503,75,NULL,'MAT, I','NGC 1572',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000033,NULL,'13.26',1.2,'(R\'_1)SB(l)a   HII',NULL,NULL,NULL,NULL,1,65.678375,-40.60092,0,NULL,37838580048,591227813,9237934,13.26),(34987,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34987,33.84,0.43,58.6,9503,75,NULL,'MAT, I, raw','NGC 1572',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34988,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34988,34.14,0.32,67.3,9503,85,NULL,'I, raw','NGC 1572',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34989,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34989,34.14,0.43,67.3,9503,75,NULL,'MAT, I, cor','NGC 1572',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34990,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34990,34.15,0.43,67.7,9503,75,NULL,'MAT, I, inv','NGC 1572',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34991,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34991,34.23,0.32,70,9503,85,NULL,'I, inv','NGC 1572',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34992,'GRB','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34992,43.1,NULL,4180,9504,NULL,NULL,NULL,'GRB 080913',NULL,'2011MNRAS.410.1611C',2011,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,65.7279583,-25.12964,0.037,NULL,37181552564,580961758,9077527,NULL),(34993,'GRB','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',34993,50.45,1.74,16000,9504,NULL,NULL,NULL,'GRB 080913',6.695,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(34994,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34994,35.74,0.59,141,9505,70,NULL,NULL,'2MASX J04225380-1138201',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.000107,NULL,'15.80',0.3,NULL,NULL,NULL,NULL,NULL,1,65.7240416667,-11.63889,0.097,NULL,37463685599,585370087,9146407,15.8),(34995,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34995,36.27,0.62,179,9506,70,NULL,NULL,'NGC 1563',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000083,NULL,'15.65',0.5,'E1?',NULL,NULL,NULL,NULL,1,65.7247917,-15.73264,0.077,NULL,37360829551,583762961,9121296,15.65),(34996,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34996,34.99,0.57,99.5,9507,70,NULL,NULL,'NGC 1564',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00009,NULL,'15.42',0.6,'(R\':)SA(s:)0o',NULL,NULL,NULL,NULL,1,65.7539583,-15.73886,0.077,NULL,37361693950,583776467,9121507,15.42),(34997,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34997,35.73,0.5,140,9508,70,NULL,NULL,'NGC 1561',NULL,'2014MNRAS.445.2677S',2014,1,0.6,'HOLM 075B does not exist (it is probably a plate defect).','G',0.00013,NULL,'15.32',0.5,'SB:0-',NULL,NULL,NULL,NULL,1,65.7545,-15.84567,0.077,NULL,37361157085,583768079,9121376,15.32),(34998,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34998,35.57,0.62,130,9509,70,NULL,NULL,'2MASX J04230195-0307407',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.14',NULL,NULL,NULL,NULL,NULL,NULL,1,65.7582083,-3.12786,0.185,NULL,36919580660,576868447,9013569,16.14),(34999,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,34999,36.06,0.66,163,9510,70,NULL,NULL,'MCG +00-12-020',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.04',0.2,NULL,NULL,NULL,NULL,NULL,1,65.7660417,-0.06078,0.213,NULL,36911681427,576745022,9011640,16.04),(35000,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35000,36.58,0.69,207,9511,70,NULL,NULL,'FGC 0481',NULL,'2014MNRAS.445.2677S',2014,1,1.23,NULL,'G',0.00015,NULL,'15.9',0.17,'Sbc',NULL,NULL,NULL,NULL,1,65.7917083,-7.21483,0.121,NULL,36951239350,577363114,9021298,15.9),(35001,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35001,35.65,0.71,135,9512,70,NULL,NULL,'2MASX J04231492-1006032',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'16.66',0.21,NULL,NULL,NULL,NULL,NULL,1,65.8122083,-10.10097,0.113,NULL,36945233026,577269266,9019832,16.66),(35002,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35002,36.03,0.67,161,9513,70,NULL,NULL,'2MASX J04232311-0215350',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,65.84625,-2.25978,0.193,NULL,36923840901,576935014,9014609,14.3),(35003,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35003,35.94,0.55,154,9514,70,NULL,NULL,'2MASX J04232360-0508590',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.39',0.4,NULL,NULL,NULL,NULL,NULL,1,65.848125,-5.14975,0.077,NULL,36964801022,577575015,9024609,16.39),(35004,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35004,34.42,0.47,76.6,9515,70,NULL,NULL,'2MASX J04232446-0722153',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00008,NULL,'15.5b',0.6,NULL,NULL,NULL,NULL,NULL,1,65.851875,-7.37094,0.121,NULL,36951256508,577363382,9021302,15.5),(35005,'Sosies','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35005,31.34,0.42,18.5,9516,NULL,NULL,NULL,'NGC 1530',NULL,'2002A&A...393...57T',2002,1,4.6,NULL,'G',0.000013,NULL,'12.25',2.4,'SB(rs)b','Isolated galaxy',NULL,NULL,NULL,1,65.862917,75.29558,0.541,NULL,65677488078,1026210751,16034542,12.25),(35006,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35006,31.38,0.4,18.9,9516,NULL,NULL,NULL,'NGC 1530',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35007,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35007,31.49,0.43,19.9,9516,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1530',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35008,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35008,31.55,0.43,20.4,9516,75,NULL,'3.6 micron, color corrected','NGC 1530',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35009,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35009,31.55,0.2,20.4,9516,74.4,NULL,NULL,'NGC 1530',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35010,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35010,31.6,0.44,20.9,9516,NULL,NULL,NULL,'NGC 1530',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35011,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35011,31.62,0.43,21.1,9516,NULL,NULL,'Malmquist cor.','NGC 1530',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35012,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35012,31.79,0.45,22.8,9516,NULL,NULL,'K','NGC 1530',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35013,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35013,31.79,0.47,22.8,9516,NULL,NULL,'H','NGC 1530',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35014,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35014,31.81,0.46,23,9516,NULL,NULL,'J','NGC 1530',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35015,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35015,32.72,0.4,34.9,9516,NULL,NULL,'mean','NGC 1530',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35016,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35016,32.82,0.4,36.6,9516,75,NULL,'B','NGC 1530',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35017,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35017,35.14,0.5,107,9517,70,NULL,NULL,'IC 0369',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00011,NULL,'15.3b',0.5,NULL,NULL,NULL,NULL,NULL,1,65.8675833333,-11.79008,0.093,NULL,37463785245,585371644,9146431,15.3),(35018,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35018,35.75,0.63,141,9518,70,NULL,NULL,'2MASX J04232975-1545551',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.2,NULL,NULL,NULL,NULL,NULL,1,65.8739583,-15.76533,0.077,NULL,37361740254,583777191,9121518,14.5),(35019,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35019,35.08,0.78,104,9519,NULL,NULL,'Malmquist cor.','IC 2066',NULL,'2009ApJS..182..474S',2009,1,0.83,NULL,'G',0.000033,NULL,'15.20',0.63,'(R\'_2)SAB(s)b',NULL,NULL,NULL,NULL,1,65.8847083,-54.73339,0,NULL,35816998607,559640603,8744384,15.2),(35020,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35020,35.16,0.75,108,9519,NULL,NULL,NULL,'IC 2066',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35021,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35021,35.2,0.2,110,9519,74.4,NULL,NULL,'IC 2066',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35022,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35022,35.44,0.7,122,9520,70,NULL,NULL,'2MASX J04233856-7421574',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.4b',0.55,NULL,NULL,NULL,NULL,NULL,1,65.9107917,-74.36594,0.317,NULL,35530023850,555156622,8674322,15.4),(35023,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35023,35.58,0.66,131,9521,70,NULL,NULL,'2MASX J04234293-7331325',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.1b',0.23,NULL,NULL,NULL,NULL,NULL,1,65.9289583,-73.52564,0.329,NULL,35529871907,555154248,8674285,16.1),(35024,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',35024,34.91,0.49,95.8,9522,75,NULL,'IR','2MFGC 03566',NULL,'2011yCatp016004901K',2011,1,NULL,NULL,'G',0.000067,NULL,'11.1K',NULL,NULL,NULL,NULL,NULL,NULL,1,65.955125,13.18169,0.909,NULL,65247617075,1019494016,15929594,11.1),(35025,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35025,35.94,0.7,154,9523,70,NULL,NULL,'2MASX J04235076-1018293',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'15.88',0.29,NULL,NULL,NULL,NULL,NULL,1,65.9614583,-10.30811,0.101,NULL,37465924975,585405077,9146954,15.88),(35026,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35026,36.43,0.51,193,9524,70,NULL,NULL,'2MASX J04235340-1402061',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00011,NULL,'16.51',0.29,NULL,NULL,NULL,NULL,NULL,1,65.9725417,-14.03494,0.109,NULL,37349846016,583591344,9118614,16.51),(35027,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35027,33.82,0.2,58.1,9525,74.4,NULL,NULL,'UGC 03029',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.00004,NULL,'15.07',0.7,'Sb',NULL,NULL,NULL,NULL,1,65.995167,-0.82692,0.249,NULL,36913155265,576768051,9012000,15.07),(35028,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35028,33.86,0.34,59.2,9525,NULL,NULL,NULL,'UGC 03029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35029,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35029,34.01,0.32,63.4,9525,NULL,NULL,'Malmquist cor.','UGC 03029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35030,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35030,35.66,NULL,136,9526,NULL,NULL,'Dipole + Quadrupole','UGC 03027',NULL,'2010Ap&SS.325..163P',2010,1,1.21,NULL,'G',0.000017,NULL,'18.',0.15,'Sc',NULL,NULL,NULL,NULL,1,66.0565,30.91531,0.857,NULL,68378080472,1068407507,16693867,18),(35031,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35031,35.66,NULL,136,9526,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03027',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35032,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35032,35.66,NULL,136,9526,NULL,NULL,'Dipole','UGC 03027',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35033,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35033,36.73,0.59,222,9527,70,NULL,NULL,'AM 0422-275 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.5',0.52,'E',NULL,NULL,NULL,NULL,1,66.0774583,-27.72886,0.045,NULL,37657599596,588399993,9193749,16.5),(35034,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35034,35.86,0.34,149,9528,NULL,NULL,NULL,'2MASX J04242582-5324067',NULL,'2009ApJS..182..474S',2009,1,0.77,NULL,'G',0.000033,NULL,'15.87',0.28,'Sc','Group member',NULL,NULL,NULL,1,66.107667,-53.40189,0,NULL,35804452621,559444572,8741321,15.87),(35035,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35035,35.88,0.34,150,9528,NULL,NULL,'Malmquist cor.','2MASX J04242582-5324067',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35036,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35036,35.9,0.2,151,9528,74.4,NULL,NULL,'2MASX J04242582-5324067',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35037,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35037,36,0.52,158,9529,70,NULL,NULL,'2MASX J04242987-1029396',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00009,NULL,'15.54',0.55,NULL,NULL,NULL,NULL,NULL,1,66.124375,-10.49439,0.089,NULL,37465902113,585404720,9146948,15.54),(35038,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35038,33.54,0.47,51,9530,NULL,NULL,'H','UGC 03028',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000017,NULL,'16.0',0.7,'Sb',NULL,NULL,NULL,NULL,1,66.1460417,33.87503,1.561,NULL,68381730278,1068464535,16694758,16),(35039,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35039,33.6,0.45,52.5,9530,NULL,NULL,'K','UGC 03028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35040,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35040,33.64,0.43,53.6,9530,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03028',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35041,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35041,33.65,0.46,53.8,9530,NULL,NULL,'J','UGC 03028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35042,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35042,34.18,0.4,68.7,9530,NULL,NULL,'mean','UGC 03028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35043,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',35043,34.9,0.49,95.6,9530,75,NULL,'IR','UGC 03028',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35044,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35044,35.88,0.64,150,9531,70,NULL,NULL,'2MASX J04244315-1221165',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'17.60',0.18,NULL,NULL,NULL,NULL,NULL,1,66.179917,-12.35464,0.049,NULL,37530844226,586419441,9162803,17.6),(35045,'BL Lac Luminosity','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35045,40.26,NULL,1130,9532,70,NULL,'nucleus-to-host flux ratio, z > 0.31','[HB89] 0422+004',NULL,'2006AJ....132....1S',2006,1,NULL,'2010ApJS..189....1A reports z = 0.476.','QSO',NULL,':','16.98',NULL,'Opt.var.       BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,66.195167,0.60175,0.269,NULL,65032069923,1016126092,15876970,16.98),(35046,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35046,35.82,0.48,146,9533,70,NULL,NULL,'MCG -02-12-013',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000087,NULL,'15.5b',0.4,NULL,NULL,NULL,NULL,NULL,1,66.25475,-9.90606,0.197,NULL,37466581370,585415333,9147114,15.5),(35047,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35047,35.4,0.4,120,9534,NULL,NULL,'mean','UGC 03038',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000033,NULL,'15.27',0.3,'Sb:',NULL,NULL,NULL,NULL,1,66.2554583333,7.171,0.493,NULL,65053960017,1016468125,15882314,15.27),(35048,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35048,35.55,0.47,129,9534,NULL,NULL,'H','UGC 03038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35049,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35049,35.66,0.45,135,9534,NULL,NULL,'K','UGC 03038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35050,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35050,34.71,NULL,87.4,9535,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0483',NULL,'2010Ap&SS.325..163P',2010,1,0.99,'Matthews(2000A&AS..143..421M) detects features at v=6408,6892,7451km/sec.','G',0.000011,NULL,'16.81',0.09,'Sd',NULL,NULL,NULL,NULL,1,66.3142083,4.98758,0.601,NULL,65033713971,1016151780,15877371,16.81),(35051,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35051,34.71,NULL,87.5,9535,NULL,NULL,'Dipole + Quadrupole','FGC 0483',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35052,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35052,34.72,NULL,88,9535,NULL,NULL,'Dipole','FGC 0483',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35053,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35053,34.75,NULL,89.3,9535,NULL,NULL,NULL,'FGC 0483',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35054,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35054,36.39,0.57,189,9536,70,NULL,NULL,'2MASX J04251581-0709191',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.3I',0.2,NULL,NULL,NULL,NULL,NULL,1,66.3159583,-7.15539,0.129,NULL,36948378121,577318408,9020600,14.3),(35055,'Brightest Stars','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',35055,26.02,NULL,1.6,9537,NULL,NULL,NULL,'Cam A',NULL,'2001ASPC..240..589H',2001,1,3.7,NULL,'G',0.000002,NULL,'14.84',2.1,'Irr (LSB)','Brightest group member',NULL,NULL,NULL,1,66.333333,72.80833,0.665,0,65670955799,1026108684,16032948,14.84),(35056,'TRGB','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35056,26.39,0.2,1.9,9537,NULL,NULL,NULL,'Cam A',NULL,'1999MNRAS.307L..37K',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35057,'TRGB','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',35057,27,NULL,2.51,9537,NULL,NULL,'I, m(I) = 23.0 mag, M(I) = -4.0 mag','Cam A',NULL,'1999IAUS..192..284G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35058,'TRGB','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35058,27.76,0.1,3.56,9537,74.4,NULL,NULL,'Cam A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35059,'TRGB','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35059,27.94,0.13,3.87,9537,NULL,NULL,'I','Cam A',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35060,'TRGB','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35060,27.97,NULL,3.93,9537,NULL,NULL,NULL,'Cam A',NULL,'2003A&A...408..111K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35061,'TRGB','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',35061,28,NULL,3.98,9537,NULL,NULL,'I, m(I) = 24.0 mag, M(I) = -4.0 mag','Cam A',NULL,'1999IAUS..192..284G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35062,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35062,36.32,0.81,184,9538,70,NULL,NULL,'2MASX J04251913-1443109',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.000087,NULL,'16.50',0.22,NULL,NULL,NULL,NULL,NULL,1,66.329667,-14.71975,0.073,NULL,37347410754,583553293,9118020,16.5),(35063,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35063,35.26,0.53,112,9539,70,NULL,NULL,'2MASX J04253072-1041370',NULL,'2014MNRAS.445.2677S',2014,1,NULL,'The APM image includes a neighboring star.','G',0.00015,NULL,'15.64',NULL,NULL,NULL,NULL,NULL,NULL,1,66.377833,-10.69356,0.165,NULL,37467112009,585423625,9147244,15.64),(35064,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35064,35.04,0.56,102,9540,70,NULL,NULL,'2MASX J04253204-0933280',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000117,NULL,'15.73',0.36,NULL,NULL,NULL,NULL,NULL,1,66.383625,-9.55794,0.189,NULL,37465775564,585402743,9146917,15.73),(35065,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35065,35.61,0.63,133,9541,70,NULL,NULL,'2MASX J04254673-4008019',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.000103,NULL,'16.94',0.26,NULL,NULL,NULL,NULL,NULL,1,66.444875,-40.13378,0,NULL,37840994548,591265539,9238524,16.94),(35066,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35066,35.98,0.64,157,9542,70,NULL,NULL,'2MASX J04254697-0831580',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'17.30',0.32,NULL,NULL,NULL,NULL,NULL,1,66.4457083,-8.53272,0.269,NULL,37473842864,585528794,9148887,17.3),(35067,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35067,35.78,0.41,143,9543,NULL,NULL,NULL,'ESO 202- G 017',NULL,'2009ApJS..182..474S',2009,1,0.93,NULL,'G',0.000033,NULL,'15.40',0.6,'SAB:(s)cd',NULL,NULL,NULL,NULL,1,66.4515,-51.64061,0,NULL,37736043443,589625678,9212901,15.4),(35068,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35068,35.82,0.2,146,9543,74.4,NULL,NULL,'ESO 202- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35069,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35069,35.84,0.4,147,9543,NULL,NULL,'Malmquist cor.','ESO 202- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35070,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35070,36.02,0.59,160,9544,70,NULL,NULL,'2MASX J04255072-1037399',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.000093,NULL,'15.97',0.38,NULL,NULL,NULL,NULL,NULL,1,66.461375,-10.62783,0.165,NULL,37467124109,585423814,9147247,15.97),(35071,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35071,35.54,0.55,128,9545,70,NULL,NULL,'2MASX J04255107-1253237',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.000093,NULL,'15.68',0.51,NULL,NULL,NULL,NULL,NULL,1,66.4629583,-12.88989,0.065,NULL,37531081436,586423147,9162861,15.68),(35072,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35072,36.91,0.56,241,9546,70,NULL,NULL,'2MASX J04255685-0837400',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.000097,NULL,'16.26',0.24,NULL,NULL,NULL,NULL,NULL,1,66.4869583,-8.62797,0.269,NULL,37473124742,585517574,9148712,16.26),(35073,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35073,35.62,0.65,133,9547,70,NULL,NULL,'2MASX J04260650-0823350',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.000093,NULL,'16.12',0.44,NULL,NULL,NULL,NULL,NULL,1,66.527167,-8.39311,0.269,NULL,37473854787,585528981,9148890,16.12),(35074,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35074,37.4,0.65,302,9548,70,NULL,NULL,'2MASX J04261378-1033240',NULL,'2014MNRAS.445.2677S',2014,1,0.32,NULL,'G',0.00009,NULL,'17.44',0.27,NULL,NULL,NULL,NULL,NULL,1,66.557417,-10.55678,0.165,NULL,37467066226,585422909,9147232,17.44),(35075,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35075,36.86,0.6,235,9549,70,NULL,NULL,'AM 0424-372 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.66',0.32,NULL,NULL,NULL,NULL,NULL,1,66.5685417,-37.23578,0.005,NULL,37690193905,588909279,9201707,16.66),(35076,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35076,36.16,0.65,171,9550,70,NULL,NULL,'2MASX J04261770-1257471',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'16.11',0.33,NULL,NULL,NULL,NULL,NULL,1,66.573875,-12.96308,0.089,NULL,37531067242,586422925,9162858,16.11),(35077,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35077,34.44,0.46,77.2,9551,70,NULL,NULL,'NGC 1576',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000103,NULL,'13.87',0.6,'S0-:',NULL,NULL,NULL,NULL,1,66.578417,-3.62108,0.073,NULL,36920205808,576878215,9013722,13.87),(35078,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35078,34.79,0.47,91,9552,70,NULL,NULL,'NGC 1575',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00006,NULL,'13.7b',1.2,'SB(rs)bc pec I-II:',NULL,NULL,NULL,NULL,1,66.585625,-10.09844,0.193,NULL,37466637655,585416213,9147128,13.7),(35079,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35079,35.98,0.65,157,9553,70,NULL,NULL,'2MASX J04262137-1151033',NULL,'2014MNRAS.445.2677S',2014,1,0.31,NULL,'G',0.00015,NULL,'16.20',0.3,NULL,NULL,NULL,NULL,NULL,1,66.589125,-11.85097,0.041,NULL,37463937045,585374016,9146469,16.2),(35080,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35080,36.76,0.74,225,9554,70,NULL,NULL,'2MASX J04262602-1251257',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.0001,NULL,'16.56',0.28,NULL,NULL,NULL,NULL,NULL,1,66.6084583333,-12.85719,0.089,NULL,37531060703,586422823,9162856,16.56),(35081,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35081,35.2,0.52,110,9555,70,NULL,NULL,'2MASX J04263314-3209527',NULL,'2014MNRAS.445.2677S',2014,1,0.85,NULL,'G',0.00015,NULL,'16.12',0.27,'S',NULL,NULL,NULL,NULL,1,66.6380416667,-32.16464,0.013,NULL,37705856949,589154014,9205531,16.12),(35082,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35082,37.4,0.64,302,9556,70,NULL,NULL,'2MASX J04263319-0819263',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.43',NULL,NULL,NULL,NULL,NULL,NULL,1,66.638375,-8.32403,0.269,NULL,37473765123,585527580,9148868,16.43),(35083,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35083,36.83,0.66,232,9557,70,NULL,NULL,'2MASX J04264613-1158268',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.32',0.27,NULL,NULL,NULL,NULL,NULL,1,66.6922083,-11.97428,0.041,NULL,37463934645,585373978,9146468,16.32),(35084,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35084,34.64,0.48,84.6,9558,70,NULL,NULL,'2MASX J04265125-1011517',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00009,NULL,'16.36',0.26,NULL,NULL,NULL,NULL,NULL,1,66.713625,-10.19767,0.161,NULL,37466342949,585411608,9147056,16.36),(35085,'IRAS','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35085,35,0.8,99.8,9559,75,NULL,'CF, r','UGC 03049',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000047,NULL,'15.13',0.5,'Sbc',NULL,NULL,NULL,NULL,1,66.7152083,1.7045,0.409,NULL,65030230229,1016097347,15876521,15.13),(35086,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35086,35.14,0.38,107,9559,75,NULL,'CF, r, raw','UGC 03049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35087,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35087,35.31,0.38,115,9559,75,NULL,'CF, r, inv','UGC 03049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35088,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35088,35.39,0.38,120,9559,75,NULL,'CF, r, cor','UGC 03049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35089,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35089,35.89,0.5,151,9560,70,NULL,NULL,'2MASX J04265215-1314248',NULL,'2014MNRAS.445.2677S',2014,1,0.69,NULL,'G',0.000077,NULL,'15.34',0.64,NULL,NULL,NULL,NULL,NULL,1,66.71725,-13.24019,0.089,NULL,37530938063,586420907,9162826,15.34),(35090,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35090,35.52,0.51,127,9561,70,NULL,NULL,'MCG -02-12-016',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.00011,NULL,'15.5b',0.25,NULL,NULL,NULL,NULL,NULL,1,66.728083,-11.98564,0.041,NULL,37463999217,585374987,9146484,15.5),(35091,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35091,35.71,0.53,138,9562,70,NULL,NULL,'2MASX J04265912-1158037',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000077,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,66.7464583,-11.96769,0.041,NULL,37464002250,585375035,9146484,16.7),(35092,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35092,35.45,0.57,123,9563,70,NULL,NULL,'2MASX J04270223-1001127',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.000077,NULL,'15.83',0.48,NULL,NULL,NULL,NULL,NULL,1,66.759167,-10.02028,0.185,NULL,37466269539,585410461,9147038,15.83),(35093,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35093,34.87,0.54,94,9564,70,NULL,NULL,'MCG -01-12-008',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00003,NULL,'14.6b',1,'SB(rs)c pec:',NULL,NULL,NULL,NULL,1,66.770167,-6.16492,0.045,NULL,37505529402,586023896,9156623,14.6),(35094,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35094,35.63,0.4,134,9564,NULL,NULL,'mean','MCG -01-12-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35095,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35095,35.68,0.47,137,9564,NULL,NULL,'H','MCG -01-12-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35096,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35096,35.04,0.48,102,9565,70,NULL,NULL,'MCG -01-12-009',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00009,NULL,'15.1b',0.3,'SB:(r)0+ pec',NULL,NULL,NULL,NULL,1,66.797125,-6.1205,0.045,NULL,37505530809,586023918,9156623,15.1),(35097,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35097,35.71,0.58,139,9566,70,NULL,NULL,'2MASX J04271812-1019054',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.000087,NULL,'16.50',0.22,'S0','Compact group member',NULL,NULL,NULL,1,66.825583,-10.31808,0.161,NULL,37466345727,585411651,9147057,16.5),(35098,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35098,35.31,0.62,115,9567,70,NULL,NULL,'2MFGC 03616',NULL,'2014MNRAS.445.2677S',2014,1,0.86,NULL,'G',0.000087,NULL,'16.17',0.19,'Sb','Compact group member',NULL,NULL,NULL,1,66.8275,-10.30631,0.161,NULL,37466346431,585411662,9147057,16.17),(35099,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35099,35.97,0.69,156,9568,70,NULL,NULL,'2MASX J04271995-1019344',NULL,'2014MNRAS.445.2677S',2014,1,0.71,NULL,'G',0.000077,NULL,'15.92',0.37,'E5','Compact group member',NULL,NULL,NULL,1,66.8331666667,-10.32622,0.161,NULL,37466398759,585412480,9147070,15.92),(35100,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',35100,33.76,0.49,56.5,9569,75,NULL,'IR','ESO 004- G 013',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000033,NULL,'14.73',0.6,'SB(s)c: pec',NULL,NULL,NULL,NULL,1,66.8695417,-83.55081,0.589,NULL,35460777952,554074655,8657416,14.73),(35101,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35101,33.86,0.26,59.3,9569,NULL,NULL,NULL,'ESO 004- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35102,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35102,33.91,0.2,60.5,9569,74.4,NULL,NULL,'ESO 004- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35103,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35103,34.06,0.24,64.8,9569,NULL,NULL,'Malmquist cor.','ESO 004- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35104,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35104,31.71,0.4,21.9,9570,NULL,NULL,'mean','ESO 157- G 030',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000093,NULL,'14.66',0.5,'E4:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,66.885833,-54.19669,0,NULL,35805431378,559459865,8741560,14.66),(35105,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35105,32.14,0.45,26.8,9570,NULL,NULL,'K','ESO 157- G 030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35106,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35106,35.79,0.47,144,9571,70,NULL,NULL,'2MASX J04273282-1209367',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.000073,NULL,'15.31',0.4,NULL,NULL,NULL,NULL,NULL,1,66.886833,-12.16025,0.021,NULL,37531180338,586424692,9162885,15.31),(35107,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35107,36.61,0.56,210,9572,70,NULL,NULL,'2MASX J04273491-1239147',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00008,NULL,'16.29',0.23,NULL,NULL,NULL,NULL,NULL,1,66.8955417,-12.65411,0.033,NULL,37531426087,586428532,9162945,16.29),(35108,'SBF','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35108,30.92,0.16,15.3,9573,NULL,NULL,'I','NGC 1596',NULL,'2001ApJ...546..681T',2001,1,3.7,NULL,'G',0.000027,NULL,'12.10',1,'SA0: sp','in a pair',NULL,NULL,NULL,1,66.9087917,-55.02781,0,NULL,35817077369,559641833,8744403,12.1),(35109,'SBF','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35109,30.92,0.16,15.3,9573,NULL,NULL,NULL,'NGC 1596',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35110,'SBF','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35110,30.93,0.14,15.4,9573,74.4,NULL,NULL,'NGC 1596',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35111,'SBF','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35111,30.96,0.16,15.6,9573,NULL,NULL,'Malmquist cor.','NGC 1596',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35112,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35112,31.07,0.37,16.4,9573,95,NULL,'Weighted Mean','NGC 1596',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35113,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35113,31.08,0.63,16.4,9573,95,NULL,'Michard 1979b, c','NGC 1596',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35114,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35114,31.3,0.46,18.2,9573,95,NULL,'Michard 1979a','NGC 1596',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35115,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35115,32.51,0.81,31.8,9573,55,NULL,'Visvanathan & Sandage 1979','NGC 1596',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35116,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35116,31.07,0.41,16.3,9573,NULL,NULL,NULL,'NGC 1596',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35117,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35117,31.24,0.41,17.7,9573,NULL,NULL,'Malmquist cor.','NGC 1596',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35118,'Tertiary','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35118,29.99,0.32,9.95,9573,95,NULL,NULL,'NGC 1596',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35119,'Tully est','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35119,30.64,0.8,13.4,9573,75,NULL,'B','NGC 1596',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35120,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',35120,30.4,0.49,12,9573,75,NULL,'IR','NGC 1596',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35121,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35121,30.86,0.45,14.8,9573,NULL,NULL,'K','NGC 1596',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35122,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35122,31.11,0.4,16.6,9573,NULL,NULL,'mean','NGC 1596',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35123,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35123,37.45,0.59,309,9574,70,NULL,NULL,'2MASX J04273898-0648105',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,66.912375,-6.803,0.073,NULL,37472794104,585512407,9148631,16),(35124,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35124,36.33,0.49,184,9575,70,NULL,NULL,'2MASX J04273980-0547011',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00008,NULL,'15.77',NULL,NULL,NULL,NULL,NULL,NULL,1,66.915833,-5.78381,0.069,NULL,37451193879,585174904,9143357,15.77),(35125,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35125,35.07,0.52,103,9576,70,NULL,NULL,'MCG -02-12-020',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.0001,NULL,'15',0.4,NULL,NULL,NULL,NULL,NULL,1,66.918,-12.59378,0.033,NULL,37531342574,586427227,9162925,15),(35126,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35126,34.75,0.45,89.2,9577,70,NULL,NULL,'MCG -02-12-021',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.3b',0.4,NULL,NULL,NULL,NULL,NULL,1,66.9367916667,-12.03381,0.025,NULL,37531182076,586424719,9162886,14.3),(35127,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35127,35.85,0.52,148,9578,70,NULL,NULL,'2MASX J04274864-5811442',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.61',0.36,NULL,NULL,NULL,NULL,NULL,1,66.9527083,-58.19561,0,NULL,35912603888,561134435,8767725,16.61),(35128,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35128,35.78,0.56,143,9579,70,NULL,NULL,'2MASX J04275094-1841571',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.92',0.25,NULL,NULL,NULL,NULL,NULL,1,66.9622083,-18.69919,0.105,NULL,37370001876,583906279,9123535,16.92),(35129,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',35129,34.85,0.49,93.2,9580,75,NULL,'IR','UGC 03036',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000037,NULL,'16.5',0.2,'S?',NULL,NULL,NULL,NULL,1,67.0009583,70.88022,0.597,NULL,66430995438,1037984303,16218504,16.5),(35130,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35130,33.38,0.2,47.4,9581,74.4,NULL,NULL,'2MFGC 03629',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000057,NULL,'14.8b',0.5,NULL,NULL,NULL,NULL,NULL,1,67.0118333333,-4.15539,0.069,NULL,37453521700,585211276,9143926,14.8),(35131,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35131,34.97,0.55,98.6,9582,70,NULL,NULL,'2MASX J04281044-1134354',NULL,'2014MNRAS.445.2677S',2014,1,0.76,NULL,'G',0.0001,NULL,'15.53',0.56,NULL,NULL,NULL,NULL,NULL,1,67.043417,-11.5765,0.077,NULL,37467433973,585428655,9147322,15.53),(35132,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35132,34.13,NULL,67,9583,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 303- G 019',NULL,'2010Ap&SS.325..163P',2010,1,1.09,NULL,'G',0.000073,NULL,'16.73',0.16,'Sd',NULL,NULL,NULL,NULL,1,67.051667,-41.68472,0,NULL,37847590548,591368602,9240134,16.73),(35133,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35133,34.15,NULL,67.5,9583,NULL,NULL,'Dipole + Quadrupole','ESO 303- G 019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35134,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35134,34.16,NULL,67.9,9583,NULL,NULL,'Dipole','ESO 303- G 019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35135,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35135,34.22,NULL,69.9,9583,NULL,NULL,NULL,'ESO 303- G 019',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35136,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',35136,33.7,0.49,55,9584,75,NULL,'IR','UGC 03054',NULL,'2011yCatp016004901K',2011,1,1.42,NULL,'G',0.000014,NULL,'17.',0.16,'Sd','X-ray-bright group member',NULL,NULL,NULL,1,67.05975,1.05303,0.289,NULL,65028993962,1016078030,15876219,17),(35137,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35137,33.8,NULL,57.6,9584,NULL,NULL,NULL,'UGC 03054',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35138,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35138,33.82,NULL,58.2,9584,NULL,NULL,'Dipole + Quadrupole','UGC 03054',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35139,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35139,33.83,NULL,58.3,9584,NULL,NULL,'Dipole','UGC 03054',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35140,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35140,33.83,NULL,58.5,9584,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03054',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35141,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35141,36.41,0.45,191,9585,NULL,NULL,'Malmquist cor.','2MASX J04281513-5306316',NULL,'2009ApJS..182..474S',2009,1,0.36,NULL,'G',0.000033,NULL,'17.50',0.24,'Sb','Group member',NULL,NULL,NULL,1,67.0632083,-53.10875,0,NULL,35806355461,559474304,8741786,17.5),(35142,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35142,36.4,0.45,191,9585,NULL,NULL,NULL,'2MASX J04281513-5306316',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (35143,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35143,36.44,0.2,194,9585,74.4,NULL,NULL,'2MASX J04281513-5306316',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35144,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35144,35.04,0.58,102,9586,70,NULL,NULL,'MCG -02-12-023',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000087,NULL,'15.1b',0.3,NULL,NULL,NULL,NULL,NULL,1,67.0683333333,-12.15467,0.061,NULL,37531211479,586425179,9162893,15.1),(35145,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35145,35.26,0.56,113,9587,70,NULL,NULL,'2MASX J04282117-1253284',NULL,'2014MNRAS.445.2677S',2014,1,0.71,NULL,'G',0.00009,NULL,'16.38',0.18,NULL,NULL,NULL,NULL,NULL,1,67.0882917,-12.89128,0.045,NULL,37534447526,586475742,9163683,16.38),(35146,'D-Sigma','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35146,32.25,0.4,28.2,9588,75,NULL,'Edat, raw','NGC 1595',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.00004,NULL,'13.69',0.9,'E+','in a triple',NULL,NULL,NULL,1,67.0906666667,-47.81589,0,NULL,37813426767,590834793,9231793,13.69),(35147,'D-Sigma','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35147,32.59,0.4,33,9588,75,NULL,'Edat, cor','NGC 1595',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35148,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35148,33.69,0.45,54.7,9588,NULL,NULL,'K','NGC 1595',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35149,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35149,34.01,0.4,63.4,9588,NULL,NULL,'mean','NGC 1595',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35150,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35150,35.27,0.46,113,9589,70,NULL,NULL,'VV 684 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'14.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,67.0977916667,-6.29797,0.081,NULL,37505675499,586026179,9156659,14.9),(35151,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35151,32.82,0.69,36.7,9590,100,NULL,'mid-IR','UGC 03052',NULL,'2013ApJ...771...88L',2013,1,1.4,NULL,'G',0.000013,NULL,'16.0',1,'SB?',NULL,NULL,NULL,NULL,1,67.109875,39.62583,NULL,NULL,68446364995,1069474453,16710538,16),(35152,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35152,33.78,0.4,57,9590,NULL,NULL,'mean','UGC 03052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35153,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35153,33.78,0.47,57.1,9590,NULL,NULL,'H','UGC 03052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35154,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35154,33.9,0.45,60.3,9590,NULL,NULL,'K','UGC 03052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35155,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35155,33.93,0.46,61.2,9590,NULL,NULL,'J','UGC 03052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35156,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35156,36.2,0.48,174,9591,NULL,NULL,'Malmquist cor.','2MASX J04282667-5343167',NULL,'2009ApJS..182..474S',2009,1,0.92,NULL,'G',0.000033,NULL,'16.49',0.23,'S','Group member',NULL,NULL,NULL,1,67.111125,-53.72142,0,NULL,35805840381,559466255,8741660,16.49),(35157,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35157,36.63,0.4,212,9591,NULL,NULL,NULL,'2MASX J04282667-5343167',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35158,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35158,36.67,0.2,216,9591,74.4,NULL,NULL,'2MASX J04282667-5343167',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35159,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35159,35.83,0.36,147,9592,NULL,NULL,'Malmquist cor.','IC 2079',NULL,'2009ApJS..182..474S',2009,1,1.28,'RC3 +1m RA error.','G',0.000033,NULL,'14.76',0.44,'SB(rs)ab','Group member',NULL,NULL,NULL,1,67.128417,-53.73792,0,NULL,35805842952,559466296,8741660,14.76),(35160,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35160,35.85,0.36,148,9592,NULL,NULL,NULL,'IC 2079',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35161,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35161,35.89,0.2,151,9592,74.4,NULL,NULL,'IC 2079',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35162,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35162,35.94,0.4,154,9592,NULL,NULL,'mean','IC 2079',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35163,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35163,36.02,0.47,160,9592,NULL,NULL,'H','IC 2079',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35164,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35164,36.83,0.66,232,9593,70,NULL,NULL,'2MASX J04283119-0309304',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,67.129917,-3.15839,0.113,NULL,37453049433,585203897,9143810,15.7),(35165,'IRAS','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35165,34.14,0.8,67.4,9594,75,NULL,'MAT, I','NGC 1598',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000017,NULL,'13.81',0.8,'(R\')SAB(s)c    LINER','in a triple',NULL,NULL,NULL,1,67.1402917,-47.78256,0,NULL,37813426439,590834788,9231793,13.81),(35166,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35166,32.86,0.32,37.4,9594,85,NULL,'I, raw','NGC 1598',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35167,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35167,32.89,0.32,37.8,9594,85,NULL,'I, inv','NGC 1598',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35168,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35168,33.11,0.43,41.8,9594,75,NULL,'MAT, I, raw','NGC 1598',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35169,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',35169,33.22,NULL,44.1,9594,NULL,NULL,'I','NGC 1598',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35170,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35170,33.23,0.43,44.3,9594,75,NULL,'MAT, I, inv','NGC 1598',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35171,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35171,33.4,0.52,48,9594,NULL,NULL,NULL,'NGC 1598',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35172,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35172,33.45,0.2,49,9594,74.4,NULL,NULL,'NGC 1598',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35173,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',35173,33.55,NULL,51.3,9594,NULL,NULL,'B','NGC 1598',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35174,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35174,33.7,0.43,55.1,9594,75,NULL,'MAT, I, cor','NGC 1598',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35175,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35175,33.73,0.45,55.8,9594,NULL,NULL,'Malmquist cor.','NGC 1598',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35176,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35176,33.89,0.47,60.1,9594,NULL,NULL,'H','NGC 1598',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35177,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35177,33.99,0.45,62.8,9594,NULL,NULL,'K','NGC 1598',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35178,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35178,34.05,0.46,64.5,9594,NULL,NULL,'J','NGC 1598',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35179,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35179,34.16,0.4,67.9,9594,NULL,NULL,'mean','NGC 1598',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35180,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35180,35.93,0.42,154,9595,NULL,NULL,'Malmquist cor.','2MASX J04283658-5324357',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000033,NULL,'15.77',0.48,'Sb','Group member',NULL,NULL,NULL,1,67.1524583,-53.40994,0,NULL,35806600812,559478137,8741845,15.77),(35181,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35181,36.04,0.4,161,9595,NULL,NULL,NULL,'2MASX J04283658-5324357',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35182,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35182,36.08,0.2,164,9595,74.4,NULL,NULL,'2MASX J04283658-5324357',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35183,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35183,32.88,0.47,37.7,9596,NULL,NULL,'H','UGC 03042',NULL,'2007A&A...465...71T',2007,1,2.1,NULL,'G',0.00002,NULL,'14.00',0.8,'SAB(s)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,67.16525,70.34722,0.641,NULL,66430820466,1037981569,16218462,14),(35184,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35184,32.91,0.46,38.2,9596,NULL,NULL,'J','UGC 03042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35185,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35185,32.95,0.45,38.9,9596,NULL,NULL,'K','UGC 03042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35186,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35186,33.17,0.4,43.1,9596,NULL,NULL,'mean','UGC 03042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35187,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35187,35.66,0.54,136,9597,70,NULL,NULL,'6dF J0428455-281941',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,67.1897083,-28.32811,0,NULL,37658099479,588407804,9193871,14.3),(35188,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35188,35.5,0.54,126,9598,70,NULL,NULL,'2MASX J04284692-1209393',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00009,NULL,'15.84',0.32,NULL,NULL,NULL,NULL,NULL,1,67.1955417,-12.16103,0.061,NULL,37534053082,586469579,9163587,15.84),(35189,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35189,36.03,0.56,161,9599,70,NULL,NULL,'2MASX J04285036-0916384',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'16.08',0.28,NULL,NULL,NULL,NULL,NULL,1,67.209917,-9.27728,0.233,NULL,37477885888,585591967,9149874,16.08),(35190,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35190,36.25,0.82,178,9600,70,NULL,NULL,'2MASX J04285184-1149074',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.000143,NULL,'17.22',0.17,NULL,NULL,NULL,NULL,NULL,1,67.216125,-11.81869,0.025,NULL,37465133490,585392710,9146761,17.22),(35191,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35191,36.22,0.51,176,9601,70,NULL,NULL,'2MASX J04285367-0918294',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.0001,NULL,'15.52',0.43,NULL,NULL,NULL,NULL,NULL,1,67.223583,-9.30819,0.233,NULL,37477889941,585592030,9149875,15.52),(35192,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35192,36.11,0.52,167,9602,70,NULL,NULL,'II Zw 011 NOTES01',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00004,NULL,'15.2b',0.8,NULL,NULL,NULL,NULL,NULL,1,67.23925,-1.86183,0.169,NULL,37448339116,585130298,9142660,15.2),(35193,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35193,35.14,0.46,107,9603,70,NULL,NULL,'MCG -02-12-026',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.0001,NULL,'14.7b',0.8,NULL,NULL,NULL,NULL,NULL,1,67.248875,-12.22478,0.061,NULL,37534095291,586470238,9163597,14.7),(35194,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35194,37.1,0.52,263,9604,NULL,NULL,'Malmquist cor.','SERSIC 40/06:[GGP90] 111',NULL,'2009ApJS..182..474S',2009,1,0.26,NULL,'G',0.000027,NULL,'17.1V',0.12,'Sc',NULL,NULL,NULL,NULL,1,67.2725,-61.21778,0,NULL,35906453446,561038335,8766223,17.1),(35195,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35195,37.34,0.47,294,9604,NULL,NULL,NULL,'SERSIC 40/06:[GGP90] 111',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35196,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35196,37.38,0.2,299,9604,74.4,NULL,NULL,'SERSIC 40/06:[GGP90] 111',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35197,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35197,36.3,0.47,182,9605,NULL,NULL,'Malmquist cor.','2MASX J04290665-5401202',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000033,NULL,'16.32',0.38,'Sc','Group member',NULL,NULL,NULL,1,67.2777917,-54.02233,0,NULL,35805404503,559459445,8741553,16.32),(35198,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35198,36.41,0.44,192,9605,NULL,NULL,NULL,'2MASX J04290665-5401202',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35199,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35199,36.45,0.2,195,9605,74.4,NULL,NULL,'2MASX J04290665-5401202',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35200,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',35200,34.94,0.49,97.1,9606,75,NULL,'IR','UGC 03043',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000023,NULL,'17.',0.1,'Scd:',NULL,NULL,NULL,NULL,1,67.2884583333,70.89744,0.681,NULL,66433075922,1038016811,16219012,17),(35201,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35201,35.06,0.44,103,9606,NULL,NULL,'Malmquist cor.','UGC 03043',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35202,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35202,35.42,0.2,121,9606,74.4,NULL,NULL,'UGC 03043',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35203,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35203,35.53,0.35,128,9606,NULL,NULL,NULL,'UGC 03043',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35204,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35204,35.48,0.5,125,9607,70,NULL,NULL,'2MASX J04291367-1807216',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.56',0.37,'E',NULL,NULL,NULL,NULL,1,67.307083,-18.12269,0.017,NULL,37369253013,583894578,9123352,15.56),(35205,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35205,33.84,0.47,58.7,9608,NULL,NULL,'H','UGC 03046',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000037,NULL,'14.7',1.2,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,67.3335,69.53117,0.845,NULL,66435301486,1038051585,16219556,14.7),(35206,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35206,33.96,0.45,62,9608,NULL,NULL,'K','UGC 03046',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35207,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35207,33.98,0.46,62.5,9608,NULL,NULL,'J','UGC 03046',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35208,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35208,34.02,0.4,63.8,9608,NULL,NULL,'mean','UGC 03046',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35209,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35209,33.7,NULL,55.1,9609,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0487',NULL,'2010Ap&SS.325..163P',2010,1,2.12,NULL,'G',0.000023,NULL,'15.74',0.2,'Sc',NULL,NULL,NULL,NULL,1,67.340917,-4.75978,0.053,NULL,37454550895,585227357,9144177,15.74),(35210,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35210,33.71,NULL,55.2,9609,NULL,NULL,'Dipole + Quadrupole','FGC 0487',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35211,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35211,33.72,NULL,55.4,9609,NULL,NULL,'Dipole','FGC 0487',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35212,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',35212,33.88,0.49,59.6,9609,75,NULL,'IR','FGC 0487',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35213,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35213,34.4,0.35,75.7,9610,NULL,NULL,'Malmquist cor.','ESO 084- G 020',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.83',0.4,'Sb: sp',NULL,NULL,NULL,NULL,1,67.344875,-62.88894,0,NULL,35873274690,560519917,8758123,14.83),(35214,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35214,34.47,0.34,78.5,9610,NULL,NULL,NULL,'ESO 084- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35215,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35215,34.51,0.2,79.8,9610,74.4,NULL,NULL,'ESO 084- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35216,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35216,34.71,0.4,87.7,9610,NULL,NULL,'mean','ESO 084- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35217,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35217,34.82,0.47,91.9,9610,NULL,NULL,'H','ESO 084- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35218,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35218,32.98,0.45,39.5,9611,NULL,NULL,'K','UGC 03048',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000037,NULL,'14.9',0.7,'SAB(rs)bc:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,67.3502917,70.42447,0.641,NULL,66431235301,1037988051,16218563,14.9),(35219,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35219,32.98,0.43,39.5,9611,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03048',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35220,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35220,32.99,0.47,39.7,9611,NULL,NULL,'H','UGC 03048',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35221,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35221,33.05,0.46,40.7,9611,NULL,NULL,'J','UGC 03048',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35222,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35222,33.16,0.4,42.9,9611,NULL,NULL,'mean','UGC 03048',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35223,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35223,35.94,0.55,154,9612,70,NULL,NULL,'2MASX J04292412-7319358',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.8b',0.24,NULL,NULL,NULL,NULL,NULL,1,67.3505417,-73.32653,0.353,NULL,35529373959,555146468,8674163,16.8),(35224,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35224,37.77,0.77,358,9613,70,NULL,NULL,'2MASX J04292482-0544556',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,67.353333,-5.74872,0.085,NULL,37451886190,585185721,9143526,17.1),(35225,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35225,35.45,0.5,123,9614,70,NULL,NULL,'2MASX J04292531-7335118',NULL,'2014MNRAS.445.2677S',2014,1,0.69,NULL,'G',0.00008,NULL,'15.4b',0.52,NULL,NULL,NULL,NULL,NULL,1,67.3554583,-73.58661,0.337,NULL,35528235381,555128677,8673885,15.4),(35226,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35226,35.65,0.52,135,9615,NULL,NULL,NULL,'2MASX J04292711-5349384',NULL,'2009ApJS..182..474S',2009,1,0.42,NULL,'G',0.000317,NULL,'16.86',0.36,'S0','Group member',NULL,NULL,NULL,1,67.362833,-53.82725,0,NULL,35805388934,559459202,8741550,16.86),(35227,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35227,35.69,0.2,137,9615,74.4,NULL,NULL,'2MASX J04292711-5349384',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35228,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35228,35.87,0.47,149,9615,NULL,NULL,'Malmquist cor.','2MASX J04292711-5349384',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35229,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35229,34.87,0.51,94.2,9616,70,NULL,NULL,'2MASX J04292723-1116071',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00008,NULL,'15.07',0.52,NULL,NULL,NULL,NULL,NULL,1,67.3635,-11.26872,0.041,NULL,37465360545,585396258,9146816,15.07),(35230,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35230,34.35,0.2,74.1,9617,74.4,NULL,NULL,'ESO 360- G 013',NULL,'2013AJ....146...86T',2013,1,1.25,NULL,'G',0.00003,NULL,'14.81',0.17,'Sc? pec sp     HII',NULL,NULL,NULL,NULL,1,67.36775,-36.70847,0,NULL,37690818250,588919035,9201859,14.81),(35231,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35231,35.14,NULL,107,9617,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 360- G 013',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35232,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35232,35.16,NULL,108,9617,NULL,NULL,'Dipole + Quadrupole','ESO 360- G 013',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35233,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35233,35.19,NULL,109,9617,NULL,NULL,'Dipole','ESO 360- G 013',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35234,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35234,35.93,0.84,153,9618,70,NULL,NULL,'2MASX J04292892-1205151',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.000087,NULL,'16.08',0.34,NULL,NULL,NULL,NULL,NULL,1,67.3705,-12.08769,0.061,NULL,37533046131,586453845,9163341,16.08),(35235,'IRAS','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35235,33.68,0.8,54.5,9619,75,NULL,'MAT, I','NGC 1591',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'13.11',0.8,'SB(r)ab pec',NULL,NULL,NULL,NULL,1,67.3772917,-26.71311,0.045,NULL,37193494998,581148359,9080443,13.11),(35236,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35236,32.9,0.32,38,9619,85,NULL,'I, raw','NGC 1591',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35237,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35237,32.93,0.32,38.5,9619,85,NULL,'I, inv','NGC 1591',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35238,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35238,33.18,0.43,43.3,9619,75,NULL,'MAT, I, raw','NGC 1591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35239,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35239,33.34,0.43,46.7,9619,75,NULL,'MAT, I, inv','NGC 1591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35240,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35240,33.41,0.4,48.1,9619,73,NULL,'opt','NGC 1591',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35241,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35241,33.49,0.47,49.8,9619,NULL,NULL,'H','NGC 1591',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35242,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35242,33.5,0.48,50.2,9619,NULL,NULL,'Malmquist cor.','NGC 1591',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35243,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35243,33.52,0.48,50.5,9619,NULL,NULL,NULL,'NGC 1591',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35244,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35244,33.55,0.45,51.2,9619,NULL,NULL,'K','NGC 1591',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35245,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35245,33.56,0.2,51.5,9619,74.4,NULL,NULL,'NGC 1591',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35246,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35246,33.57,0.46,51.7,9619,NULL,NULL,'J','NGC 1591',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35247,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35247,33.62,0.43,53,9619,75,NULL,'MAT, I, cor','NGC 1591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35248,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35248,33.8,0.4,57.4,9619,NULL,NULL,'mean','NGC 1591',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35249,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',35249,34.54,0.49,81,9620,75,NULL,'IR','ESO 303- G 022',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000143,NULL,'14.73',0.44,'SB(s)cd',NULL,NULL,NULL,NULL,1,67.387125,-41.776,0.005,NULL,37847672395,591369881,9240154,14.73),(35250,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35250,29.8,NULL,9.12,9621,NULL,NULL,NULL,'NGC 1592',NULL,'2013AJ....145..101K',2013,1,1.4,'VV notes this as a \'3+2?\' interacting system.','G',0.00001,NULL,'14.45',0.7,'Pec',NULL,NULL,NULL,NULL,1,67.4172083,-27.40853,0.089,NULL,37185304954,581020389,9078443,14.45),(35251,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35251,35.71,0.56,139,9622,70,NULL,NULL,'2MASX J04294883-1317222',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.000077,NULL,'15.6b',0.46,NULL,NULL,NULL,NULL,NULL,1,67.4534583333,-13.28947,0.089,NULL,37534394358,586474911,9163670,15.6),(35252,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35252,35.77,0.09,143,9623,NULL,NULL,NULL,'2MASX J04295136-1257212',NULL,'2009ApJS..182..474S',2009,1,0.74,NULL,'G',0.000027,NULL,'14.98',0.32,'Sc',NULL,NULL,NULL,NULL,1,67.464083,-12.95589,0.061,NULL,37534783318,586480989,9163765,14.98),(35253,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35253,36.38,0.51,189,9624,70,NULL,NULL,'2MASX J04295414-1318402',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.000093,NULL,'16.02',0.56,NULL,NULL,NULL,NULL,NULL,1,67.475417,-13.31106,0.089,NULL,37534396144,586474939,9163670,16.02),(35254,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35254,36.24,0.55,177,9625,70,NULL,NULL,'2MASX J04295754-7337228',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.5b',0.24,NULL,NULL,NULL,NULL,NULL,1,67.4896666667,-73.62308,0.329,NULL,35528230167,555128596,8673884,16.5),(35255,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35255,36.85,0.43,234,9626,NULL,NULL,'Malmquist cor.','SERSIC 40/06:[GGP90] 110',NULL,'2009ApJS..182..474S',2009,1,0.35,NULL,'G',0.000037,NULL,'17.4V',0.13,'Sc',NULL,NULL,NULL,NULL,1,67.495417,-61.41583,0,NULL,35904651798,561010184,8765784,17.4),(35256,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35256,36.86,0.43,236,9626,NULL,NULL,NULL,'SERSIC 40/06:[GGP90] 110',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35257,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35257,36.9,0.2,240,9626,74.4,NULL,NULL,'SERSIC 40/06:[GGP90] 110',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35258,'D-Sigma','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35258,33.18,0.4,43.2,9627,75,NULL,'Edat, raw','ESO 484- G 028',NULL,'1997ApJS..109..333W',1997,1,0.8,NULL,'G',0.00005,NULL,'14.69',0.5,'E?',NULL,NULL,NULL,NULL,1,67.4985,-26.83714,0.045,NULL,37193305183,581145393,9080396,14.69),(35259,'D-Sigma','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35259,33.51,0.4,50.4,9627,75,NULL,'Edat, cor','ESO 484- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35260,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35260,36.23,0.64,176,9628,70,NULL,NULL,'2MASX J04295960-1224282',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'16.12',0.4,NULL,NULL,NULL,NULL,NULL,1,67.4985,-12.40775,0.045,NULL,37534187691,586471682,9163620,16.12),(35261,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35261,36.09,0.49,166,9629,70,NULL,NULL,'2MASX J04300106-0641471',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000093,NULL,'16.29',0.6,NULL,NULL,NULL,NULL,NULL,1,67.5043333333,-6.69664,0.077,NULL,37506415669,586037744,9156839,16.29),(35262,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35262,36.71,0.86,219,9630,70,NULL,NULL,'2MASX J04300708-8430541',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,67.5297083,-84.51497,0.529,NULL,35493915777,554592434,8665506,17.1),(35263,'IRAS','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35263,34.09,0.8,65.9,9631,75,NULL,'MAT, I','ESO 251- G 006',NULL,'1997ApJS..109..333W',1997,1,1.33,NULL,'G',0.000033,NULL,'16.27',0.2,'Sb? pec sp',NULL,NULL,NULL,NULL,1,67.537917,-42.68228,0,NULL,37848433845,591381778,9240340,16.27),(35264,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35264,34.32,NULL,73.3,9631,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 251- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35265,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35265,34.34,NULL,73.7,9631,NULL,NULL,'Dipole + Quadrupole','ESO 251- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35266,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35266,34.34,NULL,73.7,9631,NULL,NULL,'Dipole','ESO 251- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35267,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35267,34.4,NULL,75.7,9631,NULL,NULL,NULL,'ESO 251- G 006',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35268,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35268,34.8,0.43,91.3,9631,75,NULL,'MAT, I, raw','ESO 251- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35269,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35269,34.82,0.32,92.2,9631,85,NULL,'I, raw','ESO 251- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35270,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35270,34.85,0.32,93.2,9631,85,NULL,'I, inv','ESO 251- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35271,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35271,34.93,0.43,96.8,9631,75,NULL,'MAT, I, inv','ESO 251- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35272,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35272,35.16,0.43,108,9631,75,NULL,'MAT, I, cor','ESO 251- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35273,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35273,35.76,0.09,142,9632,NULL,NULL,NULL,'LCSB S0735O',NULL,'2009ApJS..182..474S',2009,1,0.81,NULL,'G',0.000027,NULL,'14.74',0.35,'Sc',NULL,NULL,NULL,NULL,1,67.550417,-12.84817,0.061,NULL,37534727629,586480119,9163751,14.74),(35274,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35274,35.9,0.39,151,9633,NULL,NULL,NULL,'2MASX J04301619-5329218',NULL,'2009ApJS..182..474S',2009,1,0.53,NULL,'G',0.000033,NULL,'17.05',0.2,'S','Group member',NULL,NULL,NULL,1,67.5676666667,-53.48942,0,NULL,35806691913,559479561,8741868,17.05),(35275,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35275,35.94,0.2,154,9633,74.4,NULL,NULL,'2MASX J04301619-5329218',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35276,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35276,36.01,0.37,159,9633,NULL,NULL,'Malmquist cor.','2MASX J04301619-5329218',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35277,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35277,36.93,0.62,243,9634,70,NULL,NULL,'2MASX J04301840-1331442',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.000073,NULL,'15.9',0.29,NULL,NULL,NULL,NULL,NULL,1,67.57675,-13.52889,0.085,NULL,37534377066,586474641,9163666,15.9),(35278,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35278,37.1,0.67,263,9635,70,NULL,NULL,'2MASX J04302088-3246190',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'17.14',0.28,NULL,NULL,NULL,NULL,NULL,1,67.587083,-32.77203,0,NULL,37705675672,589151182,9205487,17.14),(35279,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35279,36.25,0.5,178,9636,70,NULL,NULL,'2MASX J04302269-1203250',NULL,'2014MNRAS.445.2677S',2014,1,0.81,NULL,'G',0.000143,NULL,'15.93',0.49,NULL,NULL,NULL,NULL,NULL,1,67.5944583,-12.05681,0.061,NULL,37533206802,586456356,9163380,15.93),(35280,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',35280,33.66,0.49,53.9,9637,75,NULL,'IR','UGC 02886A',NULL,'2011yCatp016004901K',2011,1,1.1,'Huchtmeier et al. (2005A&A...435..459H) also see a weak line at v=3928.','G',0.00006,NULL,'16.3',0.2,'Scd:',NULL,NULL,NULL,NULL,1,67.608833,88.77089,0.437,NULL,65501911640,1023467369,15991677,16.3),(35281,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',35281,35.08,0.49,104,9637,75,NULL,'IR','UGC 02886A',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35282,'IRAS','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35282,33.16,0.8,42.8,9638,75,NULL,'CF, r','NGC 1586',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000027,NULL,'13.97',0.9,'SB(s)bc','X-ray-bright group member',NULL,NULL,NULL,1,67.6592916667,-0.30417,0.133,NULL,37446790104,585106095,9142282,13.97),(35283,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35283,33.24,0.38,44.4,9638,75,NULL,'CF, r, raw','NGC 1586',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35284,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35284,33.3,0.2,45.7,9638,74.4,NULL,NULL,'NGC 1586',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35285,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35285,33.33,0.38,46.4,9638,75,NULL,'CF, r, inv','NGC 1586',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35286,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35286,33.37,0.43,47.2,9638,NULL,NULL,NULL,'NGC 1586',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35287,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35287,33.42,0.4,48.2,9638,NULL,NULL,'mean','NGC 1586',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35288,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35288,33.44,0.46,48.8,9638,NULL,NULL,'J','NGC 1586',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35289,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35289,33.45,0.47,49,9638,NULL,NULL,'H','NGC 1586',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35290,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35290,33.47,0.45,49.4,9638,NULL,NULL,'K','NGC 1586',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35291,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35291,33.57,0.38,51.8,9638,75,NULL,'CF, r, cor','NGC 1586',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35292,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35292,33.67,0.37,54.1,9638,NULL,NULL,'Malmquist cor.','NGC 1586',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35293,'D-Sigma','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35293,32.54,0.4,32.3,9639,75,NULL,'Edat, raw','NGC 1587',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00004,NULL,'12.70',1.5,'E pec','X-ray-bright group member',NULL,NULL,NULL,1,67.6664166667,0.66158,0.197,NULL,65297102829,1020267231,15941675,12.7),(35294,'D-Sigma','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35294,32.79,0.4,36.1,9639,75,NULL,'Edat, cor','NGC 1587',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35295,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35295,33.01,0.65,40,9639,95,NULL,'Weighted Mean','NGC 1587',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35296,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35296,34.7,0.81,87.1,9639,55,NULL,'Visvanathan & Sandage 1979','NGC 1587',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35297,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35297,33.19,0.45,43.4,9639,NULL,NULL,'K','NGC 1587',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35298,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35298,33.48,0.4,49.7,9639,NULL,NULL,'mean','NGC 1587',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35299,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35299,35.89,0.42,151,9640,NULL,NULL,'Malmquist cor.','2MASX J04304002-0017049',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000017,NULL,'14.6I',0.2,NULL,NULL,NULL,NULL,NULL,1,67.66675,-0.28472,0.133,NULL,37446791396,585106115,9142283,14.6),(35300,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35300,35.96,0.41,156,9640,NULL,NULL,NULL,'2MASX J04304002-0017049',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35301,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35301,36,0.2,158,9640,74.4,NULL,NULL,'2MASX J04304002-0017049',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35302,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35302,36.46,0.58,196,9641,70,NULL,NULL,'2MASX J04304136-1148316',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.000113,NULL,'16.66',0.41,NULL,NULL,NULL,NULL,NULL,1,67.672333,-11.80878,0.033,NULL,37465183264,585393488,9146773,16.66),(35303,'D-Sigma','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35303,32.54,0.4,32.3,9642,75,NULL,'Edat, raw','NGC 1588',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000023,NULL,'13.89',0.8,'E pec?','X-ray-bright group member',NULL,NULL,NULL,1,67.682375,0.66472,0.197,NULL,65297101944,1020267217,15941675,13.89),(35304,'D-Sigma','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35304,32.79,0.4,36.1,9642,75,NULL,'Edat, cor','NGC 1588',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35305,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35305,33.35,0.46,46.7,9643,NULL,NULL,'J','NGC 1589',NULL,'2007A&A...465...71T',2007,1,3.2,NULL,'G',0.00008,NULL,'12.80',1,'Sab','X-ray-bright group member',NULL,NULL,NULL,1,67.6893333333,0.86367,0.229,NULL,65297798764,1020278105,15941845,12.8),(35306,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35306,33.35,0.47,46.8,9643,NULL,NULL,'H','NGC 1589',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35307,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35307,33.43,0.45,48.5,9643,NULL,NULL,'K','NGC 1589',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35308,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35308,33.6,0.4,52.4,9643,NULL,NULL,'mean','NGC 1589',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35309,'Brightest Stars','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',35309,26.15,NULL,1.7,9644,NULL,NULL,NULL,'NGC 1569',NULL,'2001ASPC..240..589H',2001,1,3.6,NULL,'G',0.000013,NULL,'11.86',1.8,'IBm;Sbrst      Sy1','Possible group member',NULL,NULL,NULL,1,67.7044166667,64.84794,2.029,0,66419160566,1037799383,16215615,11.86),(35310,'Brightest Stars','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35310,26.19,NULL,1.73,9644,NULL,NULL,NULL,'NGC 1569',NULL,'1997A&AS..124..559K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35311,'Brightest Stars','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',35311,26.32,NULL,1.84,9644,NULL,NULL,NULL,'NGC 1569',NULL,'1999BlJPh..26...87G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35312,'Brightest Stars','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35312,26.39,NULL,1.9,9644,NULL,NULL,NULL,'NGC 1569',NULL,'1994AstL...20...84K',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35313,'Brightest Stars','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35313,26.7,0.6,2.2,9644,NULL,NULL,NULL,'NGC 1569',NULL,'1988A&A...194...24I',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35314,'Brightest Stars','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35314,29,NULL,6.31,9644,NULL,NULL,'Photographic','NGC 1569',NULL,'1985AJ.....90.1163A',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35315,'CMD','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35315,26.99,NULL,2.5,9644,NULL,NULL,'VI CMD','NGC 1569',NULL,'1994ApJ...433...65O',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35316,'CMD','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35316,27.43,0.12,3.06,9644,NULL,NULL,NULL,'NGC 1569',NULL,'2012AJ....143..117G',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35317,'CMD','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35317,27.53,0.06,3.21,9644,NULL,NULL,'HSB','NGC 1569',NULL,'2010ApJ...721..297M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35318,'CMD','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35318,27.72,0.06,3.5,9644,NULL,NULL,'LSB','NGC 1569',NULL,'2010ApJ...721..297M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35319,'TRGB','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35319,26.45,0.2,1.95,9644,NULL,NULL,NULL,'NGC 1569',NULL,'2003Ap.....46..144M',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35320,'TRGB','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35320,27.1,0.1,2.63,9644,NULL,NULL,NULL,'NGC 1569',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35321,'TRGB','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35321,27.56,0.08,3.25,9644,74.4,NULL,NULL,'NGC 1569',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35322,'TRGB','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35322,27.63,0.13,3.36,9644,NULL,NULL,'I','NGC 1569',NULL,'2008ApJ...686L..79G',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35323,'TRGB','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35323,27.66,0.12,3.4,9644,NULL,NULL,NULL,'NGC 1569',NULL,'2014A&A...566A..71L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35324,'Tully est','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35324,26.06,0.8,1.6,9644,75,NULL,'B','NGC 1569',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35325,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',35325,24.25,NULL,0.708,9644,NULL,NULL,'LEDA [April 2006]','NGC 1569',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35326,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35326,23.01,NULL,0.4,9645,75,NULL,'CO','NGC 1594',NULL,'1994A&A...283...21S',1994,1,1.8,NULL,'G',0.000033,NULL,'13.92',1.3,'SB(rs)bc',NULL,NULL,NULL,NULL,1,67.7149583,-5.79828,0.081,1,37451419949,585178436,9143413,13.92),(35327,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35327,23.49,NULL,0.5,9645,75,NULL,'HI','NGC 1594',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35328,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35328,33.81,0.47,57.9,9645,NULL,NULL,'H','NGC 1594',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35329,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35329,33.87,0.4,59.3,9645,NULL,NULL,'mean','NGC 1594',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35330,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35330,33.87,0.46,59.4,9645,NULL,NULL,'J','NGC 1594',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35331,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35331,33.9,0.45,60.1,9645,NULL,NULL,'K','NGC 1594',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35332,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35332,34.13,0.31,67.1,9645,NULL,NULL,'Malmquist cor.','NGC 1594',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35333,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35333,34.45,0.27,77.7,9645,NULL,NULL,NULL,'NGC 1594',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35334,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35334,34.49,0.2,79.1,9645,74.4,NULL,NULL,'NGC 1594',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35335,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35335,35.24,0.58,111,9646,70,NULL,NULL,'2MFGC 03671',NULL,'2014MNRAS.445.2677S',2014,1,1.09,NULL,'G',0.000057,NULL,'15.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,67.7177916667,-13.36164,0.085,NULL,37534634174,586478658,9163729,15.7),(35336,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35336,34.85,0.49,93.5,9647,70,NULL,NULL,'MCG -03-12-011',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00006,NULL,'14.52',0.9,'SAB(r)a pec:',NULL,NULL,NULL,NULL,1,67.717875,-16.30647,0.009,NULL,37362365776,583786965,9121671,14.52),(35337,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35337,35.77,0.5,143,9648,70,NULL,NULL,'2MASX J04305668-1014451',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.00015,NULL,'15.57',0.42,NULL,NULL,NULL,NULL,NULL,1,67.736125,-10.24606,0.097,NULL,37479503262,585617238,9150269,15.57),(35338,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35338,35.1,0.5,105,9649,70,NULL,NULL,'2MASX J04305695-1200572',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.000073,NULL,'15.76',0.54,NULL,NULL,NULL,NULL,NULL,1,67.737375,-12.01589,0.025,NULL,37533148002,586455437,9163366,15.76),(35339,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35339,34.01,0.27,63.5,9650,NULL,NULL,'Malmquist cor.','UGC 03066',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000023,NULL,'14.46',1.2,'SAB(r)d:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,67.742,5.54239,0.633,NULL,65308821179,1020450330,15944536,14.46),(35340,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35340,34.03,0.43,64,9650,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03066',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35341,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35341,34.1,0.43,66,9650,75,NULL,'3.6 micron, color corrected','UGC 03066',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35342,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35342,34.13,0.4,66.9,9650,NULL,NULL,'mean','UGC 03066',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35343,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35343,34.14,0.2,67.3,9650,74.4,NULL,NULL,'UGC 03066',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35344,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35344,34.25,0.25,70.7,9650,NULL,NULL,NULL,'UGC 03066',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35345,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35345,34.25,0.46,70.9,9650,NULL,NULL,'J','UGC 03066',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35346,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35346,34.26,0.47,71.2,9650,NULL,NULL,'H','UGC 03066',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35347,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35347,34.29,0.45,72.2,9650,NULL,NULL,'K','UGC 03066',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35348,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35348,32.2,0.2,27.5,9651,74.4,NULL,NULL,'UGC 03070',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.00001,NULL,'14.51',0.8,'SAB(s)b pec:','Isolated galaxy',NULL,NULL,NULL,1,67.7485417,-2.00333,0.145,NULL,37450518858,585164357,9143193,14.51),(35349,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35349,32.23,0.4,27.9,9651,73,NULL,'opt','UGC 03070',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35350,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35350,32.25,0.43,28.2,9651,75,NULL,'3.6 micron, color corrected','UGC 03070',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35351,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35351,32.34,0.43,29.4,9651,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03070',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35352,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35352,32.52,0.7,32,9651,NULL,NULL,NULL,'UGC 03070',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35353,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35353,32.71,0.64,34.9,9651,NULL,NULL,'Malmquist cor.','UGC 03070',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35354,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35354,35.17,0.47,108,9652,70,NULL,NULL,'IC 0375',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000073,NULL,'14.63',0.8,NULL,NULL,NULL,NULL,NULL,1,67.763083,-12.97397,0.033,NULL,37534733094,586480204,9163753,14.63),(35355,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35355,35.76,0.11,142,9653,NULL,NULL,NULL,'AGC 440516',NULL,'2009ApJS..182..474S',2009,1,0.44,NULL,'G',0.000043,NULL,'16.89',0.1,'Sc',NULL,NULL,NULL,NULL,1,67.76425,-13.18903,0.085,NULL,37533942097,586467845,9163560,16.89),(35356,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35356,36.04,0.62,162,9654,70,NULL,NULL,'2MASX J04310561-1210312',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00007,NULL,'15.9',0.37,NULL,NULL,NULL,NULL,NULL,1,67.7734583,-12.17536,0.021,NULL,37533173280,586455832,9163372,15.9),(35357,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35357,35.57,0.53,130,9655,70,NULL,NULL,'2MASX J04311304-2925362',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'16.31',0.28,'S',NULL,NULL,NULL,NULL,1,67.804333,-29.42669,0.005,NULL,37657469127,588397955,9193718,16.31),(35358,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35358,36.64,0.32,212,9656,70,NULL,'ABELL 3266, BGC','ESO 118-IG 030 NED02',NULL,'1999AJ....118.1489D',1999,1,0.83,NULL,'G',0.000083,NULL,'13.3V',0.45,'Part of dumbbell sys',NULL,NULL,NULL,NULL,1,67.8052083,-61.45336,0,NULL,35904786741,561012292,8765817,13.3),(35359,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35359,35.66,0.57,136,9657,70,NULL,NULL,'2MASX J04311363-7103249',NULL,'2014MNRAS.445.2677S',2014,1,0.4,'Within boundaries of LMC','G',0.00015,NULL,'15.7b',0.26,NULL,NULL,NULL,NULL,NULL,1,67.806667,-71.05694,0.461,NULL,36430964172,569233815,8894278,15.7),(35360,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35360,34.85,0.54,93.5,9658,70,NULL,NULL,'2MASX J04311580-0457030',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00003,NULL,'15.9b',0.3,NULL,NULL,NULL,NULL,NULL,1,67.815917,-4.95089,0.069,NULL,37455080001,585235625,9144306,15.9),(35361,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35361,35.35,0.47,117,9659,70,NULL,NULL,'IC 0377',NULL,'2014MNRAS.445.2677S',2014,1,0.8,'Misidentified as IC 0376 in MCG.','G',0.000077,NULL,'14.7b',0.8,NULL,NULL,NULL,NULL,NULL,1,67.818917,-12.45508,0.013,NULL,37533089392,586454521,9163351,14.7),(35362,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35362,35.18,0.49,108,9660,70,NULL,NULL,'2MASX J04311864-2937092',NULL,'2014MNRAS.445.2677S',2014,1,0.95,NULL,'G',0.00015,NULL,'15.42',0.57,'S0',NULL,NULL,NULL,NULL,1,67.827667,-29.61922,0,NULL,37657454068,588397719,9193714,15.42),(35363,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35363,37.2,0.57,275,9661,70,NULL,NULL,'2MASX J04312206-1231172',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'15.8',0.34,NULL,NULL,NULL,NULL,NULL,1,67.842,-12.52142,0.013,NULL,37533085318,586454458,9163350,15.8),(35364,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35364,37.8,0.96,363,9662,70,NULL,NULL,'2MASX J04312373-1304132',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.12',0.5,NULL,NULL,NULL,NULL,NULL,1,67.8488333333,-13.07039,0.033,NULL,37533872950,586466764,9163543,16.12),(35365,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35365,33.74,0.2,56,9663,74.4,NULL,NULL,'MCG -01-12-015',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.00015,NULL,'14.4b',1.2,'SB(r)c:',NULL,NULL,NULL,NULL,1,67.849167,-3.9255,0.089,NULL,37453680681,585213760,9143965,14.4),(35366,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35366,33.91,0.34,60.7,9663,NULL,NULL,NULL,'MCG -01-12-015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35367,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35367,34.06,0.32,64.9,9663,NULL,NULL,'Malmquist cor.','MCG -01-12-015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35368,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35368,36.64,0.32,212,9664,70,NULL,NULL,'ABELL 3266',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I-II   [BM];R  [A]','Group member, cD galaxy',NULL,NULL,NULL,1,67.850417,-61.44389,0,NULL,35904806301,561012598,8765821,NULL),(35369,'IRAS','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35369,30.6,0.8,13.2,9665,75,NULL,'MAT, I','IC 2085',NULL,'1997ApJS..109..333W',1997,1,2.4,NULL,'G',0.000033,NULL,'13.89',0.5,'S0^0^ pec sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,67.851,-54.41683,0,NULL,35804857433,559450897,8741420,13.89),(35370,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35370,30.02,0.32,10.1,9665,85,NULL,'I, inv','IC 2085',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35371,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35371,30.06,0.32,10.3,9665,85,NULL,'I, raw','IC 2085',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35372,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35372,30.5,0.43,12.6,9665,75,NULL,'MAT, I, inv','IC 2085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35373,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35373,30.6,0.43,13.2,9665,75,NULL,'MAT, I, raw','IC 2085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35374,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35374,30.88,0.43,15,9665,75,NULL,'MAT, I, cor','IC 2085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35375,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35375,31.15,0.4,17,9665,73,NULL,'opt','IC 2085',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35376,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35376,31.24,0.33,17.7,9665,NULL,NULL,'Malmquist cor.','IC 2085',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35377,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,'R',35377,31.34,0.49,18.6,9665,75,NULL,'IR','IC 2085',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35378,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35378,31.56,0.29,20.6,9665,NULL,NULL,NULL,'IC 2085',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35379,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35379,31.61,0.2,21,9665,74.4,NULL,NULL,'IC 2085',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35380,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35380,36.18,0.74,172,9666,70,NULL,NULL,'2MASX J04313161-1226552',NULL,'2014MNRAS.445.2677S',2014,1,0.69,NULL,'G',0.000087,NULL,'15.6',0.3,NULL,NULL,NULL,NULL,NULL,1,67.881625,-12.44872,0.013,NULL,37533550408,586461725,9163464,15.6),(35381,'FP','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35381,35.74,0.51,141,9667,70,NULL,NULL,'2MASX J04313304-1227473',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.000063,NULL,'15.7b',0.5,NULL,NULL,NULL,NULL,NULL,1,67.88775,-12.46308,0.013,NULL,37533549661,586461713,9163464,15.7),(35382,'Tully est','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35382,30.64,0.8,13.4,9668,75,NULL,'B','NGC 1617',NULL,'1988NBGC.C....0000T',1988,1,4.3,NULL,'G',0.00007,NULL,'11.38',2.1,'(R\')SAB(rs)a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,67.9147083,-54.60228,0,NULL,35804889260,559451394,8741428,11.38),(35383,'D-Sigma','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35383,33.41,0.4,48,9669,75,NULL,'Edat, raw','NGC 1600',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000027,NULL,'11.93',1.7,'E3','Brightest group member',NULL,NULL,NULL,1,67.9164166667,-5.08625,0.077,NULL,37454988802,585234200,9144284,11.93),(35384,'D-Sigma','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35384,33.55,0.4,51.2,9669,75,NULL,'Edat, cor','NGC 1600',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35385,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35385,32.45,0.63,30.9,9669,95,NULL,'Michard 1979b, c','NGC 1600',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35386,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35386,32.47,0.46,31.2,9669,95,NULL,'Michard 1979a','NGC 1600',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35387,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35387,32.7,0.25,34.7,9669,95,NULL,'Weighted Mean','NGC 1600',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35388,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35388,33.07,0.34,41.1,9669,95,NULL,'de Vaucouleurs','NGC 1600',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35389,'Faber-Jackson','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35389,34.16,0.81,67.9,9669,55,NULL,'Visvanathan & Sandage 1979','NGC 1600',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35390,'Tertiary','2016-12-15 15:14:03','2016-12-16 11:19:07','1',NULL,NULL,35390,32.6,0.25,33.1,9669,95,NULL,NULL,'NGC 1600',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35391,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35391,33.74,0.45,55.9,9669,NULL,NULL,'K','NGC 1600',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35392,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35392,34.02,0.4,63.7,9669,NULL,NULL,'mean','NGC 1600',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35393,'D-Sigma','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35393,33.41,0.4,48,9670,75,NULL,'Edat, raw','NGC 1601',NULL,'1997ApJS..109..333W',1997,1,0.6,NULL,'G',0.000187,NULL,'14.80',0.3,'S0: sp','Group member',NULL,NULL,NULL,1,67.923875,-5.06036,0.069,NULL,37454990715,585234229,9144284,14.8),(35394,'D-Sigma','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35394,33.55,0.4,51.2,9670,75,NULL,'Edat, cor','NGC 1601',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35395,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35395,35.21,0.48,110,9671,70,NULL,NULL,'2MASX J04314288-5710303',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'15.67',0.48,'S',NULL,NULL,NULL,NULL,1,67.92875,-57.17519,0,NULL,35941078435,561579350,8774677,15.67),(35396,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35396,35.66,0.49,136,9672,70,NULL,NULL,'2MASX J04314763-7628057',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'16.2b',0.29,NULL,NULL,NULL,NULL,NULL,1,67.9487083333,-76.46825,0.397,NULL,35551740998,555495953,8679624,16.2),(35397,'D-Sigma','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35397,33.41,0.4,48,9673,75,NULL,'Edat, raw','NGC 1603',NULL,'1997ApJS..109..333W',1997,1,0.8,NULL,'G',0.000047,NULL,'15.1b',0.5,'E?',NULL,NULL,NULL,NULL,1,67.958125,-5.09442,0.077,NULL,37454988765,585234199,9144284,15.1),(35398,'D-Sigma','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35398,33.55,0.4,51.2,9673,75,NULL,'Edat, cor','NGC 1603',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35399,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35399,36.06,0.5,163,9674,70,NULL,NULL,'2MASX J04315796-1249068',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000093,NULL,'14.2',0.5,'Sa','Group member',NULL,NULL,NULL,1,67.9914583,-12.81858,0.033,NULL,37533395945,586459311,9163426,14.2),(35400,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35400,33.84,0.47,58.5,9675,70,NULL,NULL,'NGC 1604',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000043,NULL,'14.2b',0.5,'(R\':)SB:(s?)0o pec',NULL,NULL,NULL,NULL,1,67.9940417,-5.36994,0.113,NULL,37454697274,585229644,9144213,14.2),(35401,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35401,36.62,0.55,211,9676,70,NULL,NULL,'AM 0430-423 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.36',0.43,'E',NULL,NULL,NULL,NULL,1,68.007,-42.45892,0,NULL,37847976508,591374632,9240228,16.36),(35402,'Brightest Stars','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35402,26.25,NULL,1.78,9677,NULL,NULL,NULL,'UGCA 092',NULL,'1997A&AS..124..559K',1997,1,2,NULL,'G',0.000017,NULL,'13.8',1,'Im?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,68.020417,63.61361,2.261,0,66121919506,1033154992,16143046,13.8),(35403,'Brightest Stars','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,'R',35403,26.28,NULL,1.8,9677,NULL,NULL,NULL,'UGCA 092',NULL,'2001ASPC..240..589H',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35404,'Brightest Stars','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35404,26.72,NULL,2.21,9677,NULL,NULL,NULL,'UGCA 092',NULL,'1994AstL...20...84K',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35405,'TRGB','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35405,24.5,NULL,0.794,9677,NULL,NULL,NULL,'UGCA 092',NULL,'1988PASP..100..680H',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35406,'TRGB','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35406,27.39,NULL,3.01,9677,NULL,NULL,NULL,'UGCA 092',NULL,'2006AJ....131.1361K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35407,'TRGB','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35407,27.41,0.25,3.03,9677,NULL,NULL,'I','UGCA 092',NULL,'2012MNRAS.423..294M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35408,'TRGB','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35408,27.46,0.04,3.1,9677,NULL,NULL,'I','UGCA 092',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35409,'TRGB','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35409,27.49,0.1,3.15,9677,NULL,NULL,NULL,'UGCA 092',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35410,'TRGB','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35410,27.54,0.1,3.22,9677,74.4,NULL,NULL,'UGCA 092',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35411,'Tully est','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35411,25.87,0.8,1.5,9677,75,NULL,NULL,'UGCA 092',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35412,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35412,35.68,0.11,137,9678,NULL,NULL,NULL,'2MASX J04320656-1304588',NULL,'2009ApJS..182..474S',2009,1,0.3,NULL,'G',0.000023,NULL,'17.48',0.2,'Sc',NULL,NULL,NULL,NULL,1,68.027417,-13.08306,0.085,NULL,37533892294,586467067,9163547,17.48),(35413,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35413,36.69,0.7,218,9679,70,NULL,NULL,'LCRS B043023.4-390716',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.44',0.36,NULL,NULL,NULL,NULL,NULL,1,68.0287917,-39.01556,0,NULL,37823949201,590999206,9234362,16.44),(35414,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35414,35.77,0.08,143,9680,NULL,NULL,NULL,'MCG -02-12-036',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000023,NULL,'15.5',0.4,'Sc',NULL,NULL,NULL,NULL,1,68.039917,-12.69497,0.025,NULL,37533542824,586461606,9163462,15.5),(35415,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,'R',35415,35.47,0.49,124,9681,75,NULL,'IR','UGC 03083',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000047,NULL,'16.5',0.2,'Scd:',NULL,NULL,NULL,NULL,1,68.0609166667,1.72661,0.369,NULL,65300895411,1020326490,15942601,16.5),(35416,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35416,35.79,0.45,144,9681,NULL,NULL,'Malmquist cor.','UGC 03083',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35417,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35417,36.19,0.37,173,9681,NULL,NULL,NULL,'UGC 03083',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35418,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35418,36.23,0.2,176,9681,74.4,NULL,NULL,'UGC 03083',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35419,'IRAS','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35419,32.13,0.8,26.7,9682,75,NULL,'MAT, I','ESO 202- G 035',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.000019,NULL,'13.36',0.4,'Sb: sp',NULL,NULL,NULL,NULL,1,68.0684583,-49.67583,0,NULL,37801499356,590648427,9228881,13.36),(35420,'Tully est','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35420,31.66,0.8,21.5,9682,75,NULL,NULL,'ESO 202- G 035',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35421,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35421,31.54,0.32,20.3,9682,85,NULL,'I, raw','ESO 202- G 035',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35422,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35422,31.55,0.32,20.4,9682,85,NULL,'I, inv','ESO 202- G 035',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35423,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35423,31.69,0.43,21.8,9682,75,NULL,'MAT, I, raw','ESO 202- G 035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35424,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,'R',35424,31.72,0.4,22.1,9682,75,NULL,NULL,'ESO 202- G 035',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35425,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35425,31.72,0.39,22.1,9682,73,NULL,'IR','ESO 202- G 035',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35426,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35426,31.75,0.43,22.4,9682,75,NULL,'MAT, I, cor','ESO 202- G 035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35427,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35427,31.76,0.43,22.5,9682,75,NULL,'MAT, I, inv','ESO 202- G 035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35428,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35428,31.86,0.39,23.6,9682,73,NULL,'opt','ESO 202- G 035',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35429,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35429,32.01,0.38,25.2,9682,NULL,NULL,NULL,'ESO 202- G 035',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35430,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35430,32.13,0.12,26.7,9682,NULL,NULL,NULL,'ESO 202- G 035',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35431,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35431,32.14,0.2,26.8,9682,74.4,NULL,NULL,'ESO 202- G 035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35432,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35432,32.19,0.43,27.4,9682,75,NULL,'3.6 micron, color corrected','ESO 202- G 035',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35433,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,'R',35433,32.25,0.49,28.2,9682,75,NULL,'IR','ESO 202- G 035',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35434,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35434,32.29,0.43,28.7,9682,75,NULL,'3.6 micron, color + selection bias corrected','ESO 202- G 035',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35435,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35435,33.86,0.47,59,9683,NULL,NULL,'H','UGC 03078',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000023,NULL,'17.',0.4,'Sbc',NULL,NULL,NULL,NULL,1,68.0909583,33.21897,1.933,NULL,68344169709,1067877651,16685588,17),(35436,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35436,33.92,0.45,60.8,9683,NULL,NULL,'K','UGC 03078',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35437,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,'R',35437,33.95,0.49,61.7,9683,75,NULL,'IR','UGC 03078',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35438,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35438,34,0.2,63.1,9683,74.4,NULL,NULL,'UGC 03078',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35439,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35439,34.01,0.43,63.4,9683,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03078',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35440,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35440,34.03,0.46,63.9,9683,NULL,NULL,'J','UGC 03078',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35441,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35441,34.08,0.43,65.4,9683,75,NULL,'3.6 micron, color corrected','UGC 03078',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35442,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35442,34.14,0.4,67.3,9683,NULL,NULL,'mean','UGC 03078',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35443,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35443,36.12,0.64,168,9684,70,NULL,NULL,'2MASX J04322397-1246481',NULL,'2014MNRAS.445.2677S',2014,1,0.6,'The APM image includes a neighboring star.','G',0.000077,NULL,'15.82',0.6,'SBa','Group member',NULL,NULL,NULL,1,68.0998333333,-12.78003,0.033,NULL,37533424266,586459754,9163433,15.82),(35444,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35444,36.11,0.66,167,9685,70,NULL,NULL,'2MASX J04322584-3422024',NULL,'2014MNRAS.445.2677S',2014,1,0.71,NULL,'G',0.00015,NULL,'16.74',0.23,NULL,NULL,NULL,NULL,NULL,1,68.1077083,-34.36725,0,NULL,37694329097,588973892,9202717,16.74),(35445,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35445,35.74,0.51,140,9686,70,NULL,NULL,'2MASX J04322717-1315581',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00006,NULL,'16.05',0.5,'S0','Group member',NULL,NULL,NULL,1,68.113333,-13.26594,0.097,NULL,37534019140,586469049,9163578,16.05),(35446,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35446,36.25,0.55,177,9687,70,NULL,NULL,'2MASX J04322915-1323361',NULL,'2014MNRAS.445.2677S',2014,1,0.4,'Malumuth, et al. (1992AJ....104..495M) give v = 10415+/-51 km/sec.','G',0.000087,NULL,'16.24',0.2,'S0','Group member',NULL,NULL,NULL,1,68.1214583,-13.39328,0.097,NULL,37533820648,586465947,9163530,16.24),(35447,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35447,37.61,0.71,332,9688,70,NULL,NULL,'2MASX J04323156-1312251',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00005,NULL,'15.7',0.5,'S0','Group member',NULL,NULL,NULL,1,68.1315,-13.20703,0.085,NULL,37534010317,586468911,9163576,15.7),(35448,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35448,35.69,0.69,137,9689,70,NULL,NULL,'2MFGC 03699',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00013,NULL,'11.4K',NULL,NULL,NULL,NULL,NULL,NULL,1,68.14375,-11.34886,0.073,NULL,37464651353,585385177,9146643,11.4),(35449,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35449,37.2,0.58,275,9690,70,NULL,NULL,'2MASX J04323742-1154261',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.0001,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,68.1559583,-11.90731,0.021,NULL,37464762236,585386909,9146670,14.1),(35450,'IRAS','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35450,33.85,0.8,58.8,9691,75,NULL,'MAT, I','NGC 1616',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'13.30',0.9,'S(rs?)bc:',NULL,NULL,NULL,NULL,1,68.173875,-43.71589,0,NULL,37846704172,591354752,9239918,13.3),(35451,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35451,33.56,0.32,51.6,9691,85,NULL,'I, raw','NGC 1616',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35452,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35452,33.57,0.47,51.7,9691,NULL,NULL,'H','NGC 1616',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35453,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35453,33.58,0.45,52,9691,NULL,NULL,'K','NGC 1616',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35454,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35454,33.59,0.46,52.2,9691,NULL,NULL,'J','NGC 1616',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35455,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35455,33.59,0.43,52.3,9691,75,NULL,'MAT, I, raw','NGC 1616',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35456,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35456,33.62,0.32,53,9691,85,NULL,'I, inv','NGC 1616',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35457,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35457,33.85,0.43,59,9691,75,NULL,'MAT, I, inv','NGC 1616',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35458,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35458,33.92,0.4,60.9,9691,NULL,NULL,'mean','NGC 1616',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35459,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35459,33.96,0.27,61.9,9691,NULL,NULL,NULL,'NGC 1616',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35460,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35460,33.96,0.27,61.9,9691,NULL,NULL,'Malmquist cor.','NGC 1616',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35461,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35461,33.97,0.43,62.3,9691,75,NULL,'MAT, I, cor','NGC 1616',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35462,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35462,34,0.2,63.1,9691,74.4,NULL,NULL,'NGC 1616',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35463,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35463,36.68,0.65,216,9692,70,NULL,NULL,'2MASX J04324477-1311261',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00006,NULL,'16.4',0.3,'S0','Group member',NULL,NULL,NULL,1,68.1865416667,-13.19056,0.057,NULL,37533797736,586465589,9163524,16.4),(35464,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35464,34.15,0.47,67.7,9693,70,NULL,NULL,'NGC 1609',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000077,NULL,'14.0b',0.7,'(R\')S0+ pec:',NULL,NULL,NULL,NULL,1,68.1878333333,-4.37242,0.109,NULL,37453574290,585212098,9143939,14),(35465,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,'R',35465,32.97,0.49,39.3,9694,75,NULL,'IR','UGC 03084',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.000023,NULL,'16.0',0.4,'Scd:',NULL,NULL,NULL,NULL,1,68.201375,10.39167,0.813,NULL,65347061791,1021047840,15953872,16),(35466,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35466,33.27,0.2,45.1,9694,74.4,NULL,NULL,'UGC 03084',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35467,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35467,33.33,0.43,46.3,9694,75,NULL,'3.6 micron, color corrected','UGC 03084',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35468,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35468,33.33,0.43,46.3,9694,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03084',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35469,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35469,33.46,0.45,49.2,9694,NULL,NULL,NULL,'UGC 03084',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35470,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35470,33.75,0.39,56.4,9694,NULL,NULL,'Malmquist cor.','UGC 03084',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35471,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35471,33.78,0.47,56.9,9694,NULL,NULL,'H','UGC 03084',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35472,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35472,33.85,0.4,58.8,9694,NULL,NULL,'mean','UGC 03084',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35473,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35473,33.92,0.46,60.9,9694,NULL,NULL,'J','UGC 03084',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35474,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35474,33.92,0.45,60.9,9694,NULL,NULL,'K','UGC 03084',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35475,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35475,35.05,0.49,103,9695,70,NULL,NULL,'2MASX J04324849-1223191',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.000123,NULL,'15.93',0.34,NULL,NULL,NULL,NULL,NULL,1,68.202083,-12.38881,0.013,NULL,37533726856,586464482,9163507,15.93),(35476,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35476,31.12,0.2,16.8,9696,74.4,NULL,NULL,'2MASX J04324860+2929578',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000017,NULL,'12.19',0.56,'Scd;HII         LIRG',NULL,NULL,NULL,NULL,1,68.2024166667,29.49928,1.425,NULL,68321193406,1067518646,16679978,12.19),(35477,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35477,31.42,0.69,19.3,9696,100,NULL,'mid-IR','2MASX J04324860+2929578',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35478,'Brightest Stars','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35478,27.02,NULL,2.54,9697,NULL,NULL,'Red','NGC 1560',NULL,'1993AJ....106...66L',1993,1,11.65,'RC2 is incorrect in equating IC 2062 (a Galactic star) with NGC 1560.','G',0.000017,NULL,'12.16',1.9,'SA(s)d         HII','Possible group member',NULL,NULL,NULL,1,68.2045417,71.88311,0.625,0,66396707134,1037448548,16210133,12.16),(35479,'Brightest Stars','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35479,27.11,NULL,2.64,9697,NULL,NULL,'Blue','NGC 1560',NULL,'1993AJ....106...66L',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35480,'Brightest Stars','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35480,27.37,NULL,2.98,9697,NULL,NULL,NULL,'NGC 1560',NULL,'1997A&AS..124..559K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35481,'Brightest Stars','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,'R',35481,27.39,NULL,3,9697,NULL,NULL,NULL,'NGC 1560',NULL,'2001ASPC..240..589H',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35482,'Brightest Stars','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35482,27.86,NULL,3.73,9697,NULL,NULL,'3R','NGC 1560',NULL,'1991A&AS...91..503K',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35483,'Brightest Stars','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35483,28.03,NULL,4.04,9697,NULL,NULL,'3B','NGC 1560',NULL,'1991A&AS...91..503K',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35484,'TRGB','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35484,27.38,0.1,2.99,9697,74.4,NULL,NULL,'NGC 1560',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35485,'TRGB','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35485,27.57,0.11,3.27,9697,NULL,NULL,'I','NGC 1560',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35486,'TRGB','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35486,27.6,0.15,3.31,9697,NULL,NULL,NULL,'NGC 1560',NULL,'2005AJ....129..698M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35487,'TRGB','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35487,27.69,NULL,3.45,9697,NULL,NULL,NULL,'NGC 1560',NULL,'2003A&A...408..111K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35488,'TRGB','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,'R',35488,27.71,NULL,3.48,9697,NULL,NULL,'I','NGC 1560',NULL,'2006ARep...50..517T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35489,'IRAS','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35489,28.51,0.8,5.04,9697,75,NULL,'A82, H','NGC 1560',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35490,'Mass Model','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35490,27.34,NULL,2.94,9697,NULL,NULL,'MOND','NGC 1560',NULL,'2010MNRAS.406.2493G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35491,'Mass Model','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35491,27.5,NULL,3.16,9697,NULL,NULL,'Standard','NGC 1560',NULL,'2010MNRAS.406.2493G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35492,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35492,26.86,NULL,2.36,9697,NULL,NULL,'H','NGC 1560',NULL,'1993AJ....106...66L',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35493,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35493,26.96,NULL,2.47,9697,NULL,NULL,'B','NGC 1560',NULL,'1993AJ....106...66L',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35494,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35494,26.99,0.4,2.5,9697,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 1560',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35495,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35495,27.37,0.4,3,9697,75,NULL,'B','NGC 1560',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35496,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35496,27.61,0.47,3.33,9697,75,NULL,'A82, H, inv','NGC 1560',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35497,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35497,27.69,0.4,3.5,9697,NULL,NULL,'B','NGC 1560',NULL,'1995AJ....110.1584K',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35498,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35498,27.83,0.47,3.68,9697,75,NULL,'A82, H, raw','NGC 1560',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35499,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35499,28.18,0.47,4.32,9697,75,NULL,'A82, H, cor','NGC 1560',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35500,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35500,36.08,0.64,165,9698,70,NULL,NULL,'2MASX J04325446-1258524',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000057,NULL,'16.2',0.2,'S0','Group member',NULL,NULL,NULL,1,68.2269583,-12.98125,0.057,NULL,37533507884,586461060,9163454,16.2),(35501,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35501,35.81,0.74,145,9699,70,NULL,NULL,'2MASX J04325549-6119101',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.000083,NULL,'15.4V',0.15,NULL,NULL,NULL,NULL,NULL,1,68.230833,-61.31944,0,NULL,35904779766,561012183,8765815,15.4),(35502,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35502,35.76,0.06,142,9700,NULL,NULL,NULL,'MCG -02-12-037',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.3b',0.6,'SBbc','Group member',NULL,NULL,NULL,1,68.23675,-12.77814,0.033,NULL,37533451093,586460173,9163440,15.3),(35503,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,'R',35503,33.91,0.49,60.5,9701,75,NULL,'IR','MCG -01-12-028',NULL,'2011yCatp016004901K',2011,1,1.84,NULL,'G',0.00003,NULL,'13.5R',0.2,'Scd',NULL,NULL,NULL,NULL,1,68.2542083,-4.18853,0.101,NULL,37461752890,585339888,9145935,13.5),(35504,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35504,34.2,NULL,69.3,9701,NULL,NULL,'Dipole','MCG -01-12-028',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35505,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35505,34.2,NULL,69.3,9701,NULL,NULL,'Dipole + Quadrupole','MCG -01-12-028',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35506,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35506,34.21,NULL,69.4,9701,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -01-12-028',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35507,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35507,35.34,0.52,117,9702,70,NULL,NULL,'2MASX J04330739-0731311',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'14.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,68.28075,-7.52536,0.201,NULL,37507256005,586050875,9157044,14.9),(35508,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35508,35.29,0.4,114,9703,NULL,NULL,'mean','UGC 03057',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000037,NULL,'15.00',0.6,'SAB(s)b',NULL,NULL,NULL,NULL,1,68.311125,76.56697,0.589,NULL,65683534896,1026305232,16036019,15),(35509,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35509,35.3,0.47,115,9703,NULL,NULL,'H','UGC 03057',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35510,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35510,35.34,0.45,117,9703,NULL,NULL,'K','UGC 03057',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35511,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35511,35.75,0.39,141,9704,NULL,NULL,NULL,'ESO 484- G 030',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'15.4b',0.9,'SBc',NULL,NULL,NULL,NULL,1,68.3125417,-24.67272,0.065,NULL,37188460721,581069698,9079214,15.4),(35512,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35512,35.78,0.38,143,9704,NULL,NULL,'Malmquist cor.','ESO 484- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35513,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35513,35.79,0.2,144,9704,74.4,NULL,NULL,'ESO 484- G 030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35514,'IRAS','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35514,34.57,0.8,81.9,9705,75,NULL,'MAT, I','ESO 551- G 013',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000027,NULL,'14.46',0.7,'Sc',NULL,NULL,NULL,NULL,1,68.3435417,-18.67706,0.041,NULL,37363986335,583812286,9122066,14.46),(35515,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35515,33.81,0.32,57.8,9705,85,NULL,'I, raw','ESO 551- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35516,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35516,33.85,0.32,58.8,9705,85,NULL,'I, inv','ESO 551- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35517,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35517,33.92,0.43,60.9,9705,75,NULL,'MAT, I, raw','ESO 551- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35518,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35518,34.1,0.43,66.1,9705,75,NULL,'MAT, I, inv','ESO 551- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35519,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35519,34.12,0.43,66.6,9705,75,NULL,'MAT, I, cor','ESO 551- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35520,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35520,34.32,0.49,73.1,9705,NULL,NULL,'Malmquist cor.','ESO 551- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35521,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35521,34.4,0.2,75.9,9705,74.4,NULL,NULL,'ESO 551- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35522,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35522,34.48,0.46,78.7,9705,NULL,NULL,NULL,'ESO 551- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35523,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35523,35.77,0.12,143,9706,NULL,NULL,NULL,'AGC 440535',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000027,NULL,'15.53',0.2,'Sc','Group member',NULL,NULL,NULL,1,68.34725,-13.33919,0.081,NULL,37533261919,586457217,9163394,15.53),(35524,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35524,35.8,0.14,145,9707,NULL,NULL,NULL,'2MASX J04332373-1330550',NULL,'2009ApJS..182..474S',2009,1,0.48,NULL,'G',0.000027,NULL,'15.37',0.36,'S','Group member',NULL,NULL,NULL,1,68.3495,-13.51747,0.093,NULL,37533787652,586465432,9163522,15.37),(35525,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35525,36.05,0.74,162,9708,70,NULL,NULL,'2MASX J04332563-1330560',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.000097,NULL,'16.5',0.11,'S0','Group member',NULL,NULL,NULL,1,68.3567917,-13.51553,0.093,NULL,37533787875,586465435,9163522,16.5),(35526,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35526,35.88,0.25,150,9709,74.4,NULL,NULL,'GIN 195',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.00003,NULL,'14.43',0.4,'D','Group member',NULL,NULL,NULL,1,68.3838333333,-13.17242,0.081,NULL,37533303544,586457867,9163404,14.43),(35527,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35527,36.12,0.16,167,9709,70,NULL,NULL,'GIN 195',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35528,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35528,36.4,0.64,190,9710,70,NULL,NULL,'2MASX J04333367-1229070',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.000067,NULL,'16.2',0.25,NULL,NULL,NULL,NULL,NULL,1,68.390333,-12.48525,0.025,NULL,37533607796,586462621,9163478,16.2),(35529,'BCG','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35529,36.07,0.35,159,9711,60,NULL,'ABELL 0496, BCG','MCG -02-12-039',0.0326,'1980ApJ...241..486H',1980,1,2.1,NULL,'G',0.000037,NULL,'13.32',1.7,'cD;E+?','Group member',NULL,NULL,NULL,1,68.407667,-13.26194,0.081,NULL,37533319145,586458111,9163407,13.32),(35530,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35530,35.89,0.25,151,9711,74.4,NULL,NULL,'MCG -02-12-039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35531,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35531,36.12,0.16,167,9711,70,NULL,NULL,'MCG -02-12-039',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35532,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35532,35.17,0.45,108,9711,NULL,NULL,'K','MCG -02-12-039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35533,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35533,35.53,0.4,128,9711,NULL,NULL,'mean','MCG -02-12-039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35534,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35534,35.85,0.11,148,9711,70,NULL,'ABELL 0496, BGC','MCG -02-12-039',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35535,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35535,34.83,0.7,92.4,9712,70,NULL,NULL,'2MASX J04333798-1418480',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00009,NULL,'16.1',0.39,NULL,NULL,NULL,NULL,NULL,1,68.408333,-14.31331,0.097,NULL,37546164549,586658821,9166544,16.1),(35536,'BCG','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35536,36.07,0.35,159,9713,60,NULL,NULL,'ABELL 0496',0.0326,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I:     [BM]',NULL,NULL,NULL,NULL,1,68.41,-13.25917,0.081,NULL,37533319021,586458109,9163407,NULL),(35537,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35537,35.85,0.11,148,9713,70,NULL,NULL,'ABELL 0496',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35538,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35538,36.38,0.81,188,9714,70,NULL,NULL,'MCG -02-12-040',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.8b',0.4,NULL,NULL,NULL,NULL,NULL,1,68.411375,-12.53447,0.025,NULL,37533606591,586462602,9163478,15.8),(35539,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35539,35.89,0.25,151,9715,74.4,NULL,NULL,'GIN 194',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000033,NULL,'14.27',0.4,'E','Group member',NULL,NULL,NULL,1,68.4231666667,-13.17008,0.081,NULL,37533278076,586457469,9163397,14.27),(35540,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35540,36.12,0.16,167,9715,70,NULL,NULL,'GIN 194',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35541,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35541,35.74,0.55,141,9716,70,NULL,NULL,'2MASX J04334285-0939535',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.16',0.3,NULL,NULL,NULL,NULL,NULL,1,68.428375,-9.66486,0.105,NULL,37476898248,585576535,9149633,16.16),(35542,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35542,33.45,0.43,49,9717,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J04334644+1151106',NULL,'2014MNRAS.444..527S',2014,1,NULL,NULL,'G',0.000067,NULL,'11.0K',NULL,NULL,NULL,NULL,NULL,NULL,1,68.4435417,11.85292,0.877,NULL,65332627840,1020822310,15950348,11),(35543,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35543,37.14,0.56,267,9718,70,NULL,NULL,'2MASX J04334814-1141045',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000127,NULL,'13.8I',0.4,NULL,NULL,NULL,NULL,NULL,1,68.450667,-11.68461,0.053,NULL,37464590899,585384232,9146628,13.8),(35544,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35544,35.34,0.6,117,9719,70,NULL,NULL,'2MASX J04335138-1314539',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000063,NULL,'15.91',0.4,'E/S0','Group member',NULL,NULL,NULL,1,68.464083,-13.24825,0.081,NULL,37533281152,586457518,9163398,15.91),(35545,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35545,34.35,0.4,74.2,9720,NULL,NULL,'mean','MCG -02-12-041',NULL,'2007A&A...465...71T',2007,1,3.2,NULL,'G',0.000033,NULL,'14.93',1,'(R\')SB(rs)ab:',NULL,NULL,NULL,NULL,1,68.467083,-11.70428,0.053,NULL,37464601945,585384405,9146631,14.93),(35546,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35546,34.81,0.46,91.6,9720,NULL,NULL,'J','MCG -02-12-041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35547,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35547,34.82,0.47,91.9,9720,NULL,NULL,'H','MCG -02-12-041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35548,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35548,34.95,0.45,97.6,9720,NULL,NULL,'K','MCG -02-12-041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35549,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35549,33.82,0.43,57.9,9721,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03089',NULL,'2014MNRAS.444..527S',2014,1,1.1,NULL,'G',0.000103,NULL,'15.07',0.9,'Sbc',NULL,NULL,NULL,NULL,1,68.4750833333,16.91211,1.141,NULL,65254158241,1019596222,15931190,15.07),(35550,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35550,36.47,0.62,197,9722,70,NULL,NULL,'2MASX J04335692-1043335',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000133,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,68.487083,-10.72603,0.093,NULL,37478562898,585602545,9150039,16.8),(35551,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35551,35.89,0.25,151,9723,74.4,NULL,NULL,'GIN 192',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000017,NULL,'14.32',0.5,'E','Group member',NULL,NULL,NULL,1,68.4877083,-13.46269,0.093,NULL,37533257361,586457146,9163392,14.32),(35552,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35552,36.12,0.16,167,9723,70,NULL,NULL,'GIN 192',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35553,'FP','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35553,36.31,0.64,183,9724,70,NULL,NULL,'2MASX J04340013-3205498',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.000117,NULL,'16.96',0.17,'S',NULL,NULL,NULL,NULL,1,68.5005,-32.09725,0,NULL,37689510139,588898595,9201540,16.96),(35554,'Tully-Fisher','2016-12-15 15:14:03','2016-12-16 11:19:08','1',NULL,NULL,35554,35.76,0.12,142,9725,NULL,NULL,NULL,'AGC 440541',NULL,'2009ApJS..182..474S',2009,1,0.44,NULL,'G',0.000033,NULL,'16.13',0.14,'Sc',NULL,NULL,NULL,NULL,1,68.512125,-12.98264,0.057,NULL,37533367625,586458869,9163419,16.13),(35555,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35555,36.76,0.65,225,9726,70,NULL,NULL,'2MASX J04340384-1327479',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00007,NULL,'16.4',0.2,'E','Group member',NULL,NULL,NULL,1,68.516,-13.46331,0.093,NULL,37544528224,586633253,9166144,16.4),(35556,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',35556,35.59,0.49,131,9727,75,NULL,'IR','FGC 0492',NULL,'2011yCatp016004901K',2011,1,0.92,NULL,'G',0.000041,NULL,'16.38',0.09,'Sd',NULL,NULL,NULL,NULL,1,68.524083,1.41069,0.293,NULL,65297217161,1020269018,15941703,16.38),(35557,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35557,35.77,NULL,143,9727,NULL,NULL,NULL,'FGC 0492',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35558,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35558,35.87,NULL,149,9727,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0492',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35559,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35559,35.88,NULL,150,9727,NULL,NULL,'Dipole + Quadrupole','FGC 0492',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35560,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35560,35.89,NULL,151,9727,NULL,NULL,'Dipole','FGC 0492',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35561,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35561,35.92,0.43,153,9727,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0492',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35562,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35562,35.9,0.25,151,9728,74.4,NULL,NULL,'GIN 190',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000025,NULL,'14.28',0.6,'E/S0','Group member',NULL,'NAT',NULL,1,68.5435,-13.36997,0.093,NULL,37544537862,586633404,9166146,14.28),(35563,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35563,36.12,0.16,167,9728,70,NULL,NULL,'GIN 190',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35564,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35564,36.34,0.56,185,9729,70,NULL,NULL,'2MASX J04341972-1247579',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.000083,NULL,'16.07',0.38,'S0','Group member',NULL,NULL,NULL,1,68.582125,-12.79947,0.057,NULL,37533321840,586458153,9163408,16.07),(35565,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35565,36.12,0.16,167,9730,70,NULL,NULL,'GIN 191',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,68.6640417,-13.39183,0.093,NULL,37544590964,586634233,9166159,NULL),(35566,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35566,35.54,0.63,129,9731,70,NULL,NULL,'2MASX J04344768-1023267',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000113,NULL,'13.9I',0.4,NULL,NULL,NULL,NULL,NULL,1,68.69875,-10.39083,0.069,NULL,37479552896,585618014,9150281,13.9),(35567,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35567,36.91,0.59,241,9732,70,NULL,NULL,'2MASX J04344880-1107537',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000117,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,68.7034583333,-11.13161,0.097,NULL,37479133276,585611457,9150179,16.8),(35568,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35568,35.48,0.61,124,9733,70,NULL,NULL,'2MASX J04344941-1348467',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.2',0.35,NULL,NULL,NULL,NULL,NULL,1,68.705875,-13.81303,0.113,NULL,37545885125,586654455,9166475,16.2),(35569,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35569,35.29,0.56,114,9734,70,NULL,NULL,'2MASX J04345177-1404097',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.000077,NULL,'16.2',0.4,NULL,NULL,NULL,NULL,NULL,1,68.715667,-14.06939,0.109,NULL,37546093506,586657711,9166526,16.2),(35570,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35570,36.34,0.62,185,9735,70,NULL,NULL,'2MASX J04345392-1010557',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.21',0.3,NULL,NULL,NULL,NULL,NULL,1,68.7245417,-10.18208,0.085,NULL,37479543859,585617872,9150279,16.21),(35571,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35571,36.5,0.85,200,9736,70,NULL,NULL,'2MASX J04345723-1111067',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.6b',0.4,NULL,NULL,NULL,NULL,NULL,1,68.738417,-11.18517,0.097,NULL,37479130535,585611414,9150178,15.6),(35572,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35572,35.14,0.49,106,9737,70,NULL,NULL,'2MASX J04345791-1011407',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.8b',0.4,NULL,NULL,NULL,NULL,NULL,1,68.7412917,-10.19467,0.129,NULL,37479539888,585617810,9150278,15.8),(35573,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35573,35.9,0.68,151,9738,70,NULL,NULL,'2MASX J04350301-1253517',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000077,NULL,'15.6',0.4,'SBab','Group member',NULL,NULL,NULL,1,68.7624583,-12.89761,0.057,NULL,37544665526,586635398,9166178,15.6),(35574,'D-Sigma','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35574,33.54,0.4,50.9,9739,75,NULL,'Edat, raw','NGC 1573',NULL,'1997ApJS..109..333W',1997,1,1.9,'The 2MASS position is 6 arcsec west of the nucleus.','G',0.000047,NULL,'12.81',1.3,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,68.766625,73.26242,0.449,NULL,65673943578,1026155368,16033677,12.81),(35575,'D-Sigma','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35575,33.87,0.4,59.4,9739,75,NULL,'Edat, cor','NGC 1573',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35576,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35576,33.88,0.4,59.6,9739,NULL,NULL,'mean','NGC 1573',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35577,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35577,33.95,0.45,61.7,9739,NULL,NULL,'K','NGC 1573',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35578,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',35578,34.96,0.49,98.1,9740,75,NULL,'IR','UGC 03093',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',NULL,NULL,'15.50',0.2,'Scd:',NULL,NULL,NULL,NULL,1,68.7709583,7.98867,0.629,NULL,65354556229,1021164941,15955702,15.5),(35579,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35579,36.63,0.64,212,9741,70,NULL,NULL,'2MASX J04350566-1328147',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.000063,NULL,'16.6',0.1,'S0','Group member',NULL,NULL,NULL,1,68.773583,-13.47069,0.085,NULL,37544556153,586633689,9166151,16.6),(35580,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35580,36.26,0.87,179,9742,70,NULL,NULL,'2MASX J04350670-0223096',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,68.777875,-2.38597,0.133,NULL,37449558053,585149344,9142958,16.8),(35581,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35581,35.88,0.25,150,9743,74.4,NULL,NULL,'GIN 193',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.00004,NULL,'14.65',0.2,'E','Group member',NULL,NULL,NULL,1,68.778875,-13.39428,0.093,NULL,37544549218,586633581,9166149,14.65),(35582,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35582,36.12,0.16,167,9743,70,NULL,NULL,'GIN 193',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35583,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35583,36.14,0.56,169,9743,70,NULL,NULL,'GIN 193',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35584,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',35584,32.4,0.49,30.1,9744,75,NULL,'IR','2MFGC 03737',NULL,'2011yCatp016004901K',2011,1,NULL,NULL,'G',0.00002,NULL,'16.17',NULL,'Sc',NULL,NULL,NULL,NULL,1,68.78125,25.20219,1.409,NULL,64768386797,1012006043,15812594,16.17),(35585,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35585,33.49,0.4,50,9744,NULL,NULL,'mean','2MFGC 03737',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35586,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35586,33.52,0.47,50.6,9744,NULL,NULL,'H','2MFGC 03737',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35587,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35587,33.56,0.45,51.4,9744,NULL,NULL,'K','2MFGC 03737',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35588,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35588,35.79,0.51,144,9745,70,NULL,NULL,'MCG -02-12-043',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000133,NULL,'14.8',0.6,'SBab','Group member',NULL,NULL,NULL,1,68.7962083,-13.24436,0.093,NULL,37544787108,586637298,9166207,14.8),(35589,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35589,35.36,0.64,118,9746,70,NULL,NULL,'ESO 484- G 034',NULL,'2014MNRAS.445.2677S',2014,1,1.15,NULL,'G',0.00015,NULL,'15.05',0.45,'Sa-b',NULL,NULL,NULL,NULL,1,68.8181666667,-25.99283,0.053,NULL,37189415405,581084615,9079447,15.05),(35590,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35590,35.07,0.53,103,9747,70,NULL,NULL,'II Zw 017',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.000027,NULL,'15.6',0.3,'cE pec?',NULL,NULL,NULL,NULL,1,68.822375,-1.73122,0.149,NULL,37449135710,585142745,9142855,15.6),(35591,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35591,35.08,0.47,104,9748,NULL,NULL,'H','MCG +03-12-003',NULL,'2007A&A...465...71T',2007,1,0.5,NULL,'G',0.000006,NULL,'17',0.4,NULL,NULL,NULL,NULL,NULL,1,68.828917,17.19553,1.141,NULL,65254850220,1019607034,15931359,17),(35592,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35592,35.16,0.4,108,9748,NULL,NULL,'mean','MCG +03-12-003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35593,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35593,35.18,0.45,109,9748,NULL,NULL,'K','MCG +03-12-003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35594,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35594,35.26,0.46,113,9748,NULL,NULL,'J','MCG +03-12-003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35595,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35595,35.2,0.2,110,9749,74.4,NULL,NULL,'MCG -01-12-033',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000133,NULL,'15.11',0.3,NULL,NULL,NULL,NULL,NULL,1,68.831125,-7.40547,0.193,NULL,37508801075,586075016,9157422,15.11),(35596,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35596,35.26,0.48,113,9749,NULL,NULL,'Malmquist cor.','MCG -01-12-033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35597,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35597,35.3,0.47,115,9749,NULL,NULL,NULL,'MCG -01-12-033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35598,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35598,35.72,0.56,139,9750,70,NULL,NULL,'2MASX J04352517-1225414',NULL,'2014MNRAS.445.2677S',2014,1,0.74,NULL,'G',0.00009,NULL,'16.11',0.59,NULL,NULL,NULL,NULL,NULL,1,68.854917,-12.42814,0.069,NULL,37544505572,586632899,9166139,16.11),(35599,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35599,36.69,0.58,218,9751,70,NULL,NULL,'2MASX J04352658-1151326',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000087,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,68.8607917,-11.85908,0.057,NULL,37469869065,585466704,9147917,16.5),(35600,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35600,36.87,0.55,236,9752,70,NULL,NULL,'2MASX J04352790-3130006',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.73',0.36,NULL,NULL,NULL,NULL,NULL,1,68.8662083,-31.50028,0,NULL,37686192771,588846762,9200730,16.73),(35601,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35601,34.99,0.45,99.4,9753,NULL,NULL,'K','UGC 03094',NULL,'2007A&A...465...71T',2007,1,1.1,'87GB source with large sky, narrow minor axis, or very bad confusion.','G',0.000023,NULL,'16.5',0.4,'Sbc            LIRG',NULL,NULL,NULL,NULL,1,68.890875,19.17161,1.473,NULL,65283012277,1020047066,15938235,16.5),(35602,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35602,35.06,0.47,103,9753,NULL,NULL,'H','UGC 03094',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35603,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35603,35.14,0.4,107,9753,NULL,NULL,'mean','UGC 03094',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35604,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35604,35.25,0.46,112,9753,NULL,NULL,'J','UGC 03094',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35605,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',35605,35.27,0.49,113,9753,75,NULL,'IR','UGC 03094',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35606,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35606,35.2,0.54,109,9754,70,NULL,NULL,'2MASX J04353783-0234105',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.59',0.6,NULL,NULL,NULL,NULL,NULL,1,68.907667,-2.56969,0.133,NULL,37449570589,585149540,9142961,16.59),(35607,'IRAS','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35607,31.96,0.8,24.7,9755,75,NULL,'MAT, I','ESO 551- G 016',NULL,'1997ApJS..109..333W',1997,1,1.61,'6dF DR2 has z = 0.067473.','G',0.000033,NULL,'14.76',0.32,'SBbc? pec sp',NULL,NULL,NULL,NULL,1,68.9187083,-21.98844,0.041,NULL,37375318936,583989358,9124833,14.76),(35608,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35608,30.3,0.32,11.5,9755,85,NULL,'I, inv','ESO 551- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35609,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35609,30.38,0.32,11.9,9755,85,NULL,'I, raw','ESO 551- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35610,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35610,30.77,0.43,14.2,9755,75,NULL,'MAT, I, inv','ESO 551- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35611,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35611,30.95,0.43,15.5,9755,75,NULL,'MAT, I, raw','ESO 551- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35612,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35612,31.12,0.4,16.7,9755,NULL,NULL,NULL,'ESO 551- G 016',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35613,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35613,31.11,0.39,16.7,9755,73,NULL,'opt','ESO 551- G 016',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35614,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35614,31.23,0.43,17.6,9755,75,NULL,'MAT, I, cor','ESO 551- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35615,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35615,31.99,0.09,25.1,9755,NULL,NULL,NULL,'ESO 551- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35616,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35616,36.37,0.61,188,9756,70,NULL,NULL,'2MASX J04354168-0653439',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.64',NULL,NULL,NULL,NULL,NULL,NULL,1,68.923625,-6.89542,0.145,NULL,37508731205,586073925,9157405,16.64),(35617,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35617,35.87,0.53,150,9757,70,NULL,NULL,'2MASX J04354415-1045349',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00009,NULL,'16.09',NULL,NULL,NULL,NULL,NULL,NULL,1,68.933833,-10.75994,0.097,NULL,37478499914,585601561,9150024,16.09),(35618,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35618,35.89,0.59,151,9758,70,NULL,NULL,'2MASX J04355554-0218523',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.66',0.6,NULL,NULL,NULL,NULL,NULL,1,68.9814583,-2.31442,0.133,NULL,37449693747,585151464,9142991,16.66),(35619,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35619,35.22,0.52,111,9759,70,NULL,NULL,'2MASX J04355654-2014494',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.81',0.47,'S',NULL,NULL,NULL,NULL,1,68.985583,-20.24714,0.045,NULL,37378733550,584042711,9125667,15.81),(35620,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35620,32.84,0.2,37,9760,74.4,NULL,NULL,'NGC 1618',NULL,'2013AJ....146...86T',2013,1,2.3,NULL,'G',0.00002,NULL,'13.6b',0.8,'SB(r)b:','Group member',NULL,NULL,NULL,1,69.0275,-3.14875,0.161,NULL,37460888696,585326385,9145724,13.6),(35621,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35621,33.3,0.47,45.6,9760,NULL,NULL,'H','NGC 1618',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35622,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35622,33.34,0.46,46.5,9760,NULL,NULL,'J','NGC 1618',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35623,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35623,33.38,0.45,47.4,9760,NULL,NULL,'K','NGC 1618',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35624,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35624,33.98,0.4,62.4,9760,NULL,NULL,'mean','NGC 1618',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35625,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35625,34.37,0.4,74.9,9761,NULL,NULL,'Malmquist cor.','UGC 03085',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000834,NULL,'16.5',0.3,'Scd:',NULL,NULL,NULL,NULL,1,69.035625,72.90344,0.521,NULL,65670688848,1026104513,16032883,16.5),(35626,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35626,34.48,0.38,78.7,9761,NULL,NULL,NULL,'UGC 03085',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35627,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35627,34.52,0.2,80.2,9761,74.4,NULL,NULL,'UGC 03085',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35628,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35628,35.5,0.79,126,9762,70,NULL,NULL,'2MFGC 03761',NULL,'2014MNRAS.445.2677S',2014,1,1.08,NULL,'G',0.000123,NULL,'16.4',0.19,NULL,NULL,NULL,NULL,NULL,1,69.08525,-13.90894,0.109,NULL,37546450615,586663290,9166613,16.4),(35629,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35629,34.39,0.48,75.4,9763,70,NULL,NULL,'NGC 1621',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00009,NULL,'14.2b',0.8,'E+',NULL,NULL,NULL,NULL,1,69.104417,-4.98731,0.193,NULL,37460219405,585315928,9145561,14.2),(35630,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35630,33.59,0.47,52.3,9764,NULL,NULL,'H','UGC 03102',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000016,NULL,'16.0',0.7,'S?',NULL,NULL,NULL,NULL,1,69.106125,14.33489,0.981,NULL,65479131014,1023111422,15986115,16),(35631,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35631,33.75,0.45,56.3,9764,NULL,NULL,'K','UGC 03102',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35632,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35632,33.89,0.46,59.9,9764,NULL,NULL,'J','UGC 03102',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35633,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35633,33.97,0.4,62.3,9764,NULL,NULL,'mean','UGC 03102',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35634,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35634,33.63,0.51,53.2,9765,70,NULL,NULL,'CGCG 393-045',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00008,NULL,'14.19',0.9,'(R\')SAB(rs)0+:','Compact group member',NULL,NULL,NULL,1,69.1260833333,-2.86644,0.145,NULL,37449471594,585147993,9142937,14.19),(35635,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35635,36.89,0.64,239,9766,70,NULL,NULL,'2MASX J04363072-1122574',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000077,NULL,'16.36',0.3,NULL,NULL,NULL,NULL,NULL,1,69.1280833333,-11.38256,0.093,NULL,37470725159,585480080,9148126,16.36),(35636,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35636,36.76,0.53,225,9767,70,NULL,NULL,'2MASX J04363355-3038251',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.8I',0.4,NULL,NULL,NULL,NULL,NULL,1,69.1397083333,-30.64031,0.033,NULL,37685985576,588843524,9200680,13.8),(35637,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35637,33.89,0.46,60,9768,NULL,NULL,'J','NGC 1622',NULL,'2007A&A...465...71T',2007,1,3.6,'HOLM 077B is a star.','G',0.000025,NULL,'13.4',0.7,'SAB(r)ab:','Group member',NULL,NULL,NULL,1,69.152667,-3.18883,0.149,NULL,37460842352,585325661,9145713,13.4),(35638,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35638,33.92,0.32,60.7,9768,NULL,NULL,'Malmquist cor.','NGC 1622',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35639,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35639,33.97,0.47,62.2,9768,NULL,NULL,'H','NGC 1622',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35640,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35640,33.98,0.4,62.6,9768,NULL,NULL,'mean','NGC 1622',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35641,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35641,34.03,0.3,63.9,9768,NULL,NULL,NULL,'NGC 1622',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35642,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35642,34.03,0.45,64,9768,NULL,NULL,'K','NGC 1622',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35643,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35643,34.11,0.2,66.4,9768,74.4,NULL,NULL,'NGC 1622',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35644,'IRAS','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35644,33.13,0.8,42.2,9769,75,NULL,'MAT, I','NGC 1620',NULL,'1997ApJS..109..333W',1997,1,2.9,NULL,'G',0.000003,NULL,'13.08',1,'SAB(rs)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,69.155625,-0.14361,0.201,NULL,36576753146,571511767,8929871,13.08),(35645,'IRAS','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35645,33.17,0.8,43,9769,75,NULL,'CF, r','NGC 1620',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35646,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35646,32.68,0.43,34.3,9769,75,NULL,'MAT, I, raw','NGC 1620',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35647,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35647,32.76,0.46,35.7,9769,NULL,NULL,'J','NGC 1620',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35648,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35648,32.83,0.47,36.8,9769,NULL,NULL,'H','NGC 1620',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35649,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35649,32.87,0.32,37.5,9769,85,NULL,'I, raw','NGC 1620',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35650,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35650,32.9,0.45,38.1,9769,NULL,NULL,'K','NGC 1620',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35651,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35651,32.93,0.32,38.6,9769,85,NULL,'I, inv','NGC 1620',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35652,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35652,32.94,0.43,38.7,9769,75,NULL,'MAT, I, inv','NGC 1620',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35653,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35653,32.96,0.2,39.1,9769,74.4,NULL,NULL,'NGC 1620',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35654,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35654,32.99,0.43,39.7,9769,75,NULL,'3.6 micron, color corrected','NGC 1620',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35655,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35655,33.02,0.38,40.2,9769,75,NULL,'CF, r, raw','NGC 1620',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35656,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35656,33.16,0.43,42.9,9769,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1620',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35657,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35657,33.17,0.45,43,9769,NULL,NULL,NULL,'NGC 1620',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35658,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35658,33.21,0.38,43.8,9769,75,NULL,'CF, r, inv','NGC 1620',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35659,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35659,33.22,0.43,44,9769,75,NULL,'MAT, I, cor','NGC 1620',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35660,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35660,33.22,0.44,44.1,9769,NULL,NULL,'Malmquist cor.','NGC 1620',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35661,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35661,33.38,0.4,47.4,9769,NULL,NULL,'mean','NGC 1620',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35662,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35662,33.41,0.38,48.1,9769,75,NULL,'CF, r, cor','NGC 1620',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35663,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35663,35.16,0.53,107,9770,70,NULL,NULL,'UGC 03104',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00004,NULL,'15.13',0.5,'Sa',NULL,NULL,NULL,NULL,1,69.167833,-2.29044,0.133,NULL,37449856794,585154012,9143031,15.13),(35664,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35664,35.13,0.47,106,9770,NULL,NULL,'H','UGC 03104',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35665,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35665,35.34,0.45,117,9770,NULL,NULL,'K','UGC 03104',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35666,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35666,35.34,0.46,117,9770,NULL,NULL,'J','UGC 03104',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35667,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35667,35.52,0.4,127,9770,NULL,NULL,'mean','UGC 03104',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35668,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35668,35.07,0.54,103,9771,70,NULL,NULL,'2MASX J04364830-1315300',NULL,'2014MNRAS.445.2677S',2014,1,0.74,NULL,'G',0.00007,NULL,'15.1',0.53,NULL,NULL,NULL,NULL,NULL,1,69.2012083,-13.25831,0.089,NULL,37545112294,586642379,9166287,15.1),(35669,'IRAS','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35669,31.89,0.8,23.8,9772,75,NULL,'MAT, I','ESO 202- G 041',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000019,NULL,'14.94',0.9,'SB(s)m',NULL,NULL,NULL,NULL,1,69.2362083333,-52.17367,0,NULL,37731994950,589562421,9211912,14.94),(35670,'Tully est','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35670,31.37,0.8,18.8,9772,75,NULL,NULL,'ESO 202- G 041',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35671,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35671,29.84,0.32,9.31,9772,85,NULL,'I, inv','ESO 202- G 041',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35672,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35672,29.93,0.32,9.73,9772,85,NULL,'I, raw','ESO 202- G 041',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35673,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35673,30.35,0.4,11.7,9772,NULL,NULL,NULL,'ESO 202- G 041',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35674,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35674,30.34,0.39,11.7,9772,73,NULL,'opt','ESO 202- G 041',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35675,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35675,30.75,0.43,14.1,9772,75,NULL,'MAT, I, inv','ESO 202- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35676,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35676,31,0.43,15.9,9772,75,NULL,'MAT, I, raw','ESO 202- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35677,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35677,31.21,0.43,17.5,9772,75,NULL,'MAT, I, cor','ESO 202- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35678,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35678,35.68,0.62,137,9773,70,NULL,NULL,'2MASX J04370049-1101278',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000143,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,69.252125,-11.02433,0.109,NULL,37470543555,585477243,9148081,14.4),(35679,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35679,32.8,0.47,36.4,9774,NULL,NULL,'H','UGC 03098',NULL,'2007A&A...465...71T',2007,1,0.9,'The 2MASS position refers to a superposed star.','G',0.000023,NULL,'17.',0.4,'Sbc',NULL,NULL,NULL,NULL,1,69.2594583,43.94331,NULL,NULL,68436123752,1069314433,16708038,17),(35680,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35680,32.9,0.45,38,9774,NULL,NULL,'K','UGC 03098',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35681,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35681,33.06,0.46,40.9,9774,NULL,NULL,'J','UGC 03098',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35682,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35682,33.45,0.4,49,9774,NULL,NULL,'mean','UGC 03098',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35683,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35683,35.55,0.5,129,9775,70,NULL,NULL,'2MASX J04370309-4000328',NULL,'2014MNRAS.445.2677S',2014,1,0.85,NULL,'G',0.000103,NULL,'15.51',0.5,'S',NULL,NULL,NULL,NULL,1,69.262917,-40.00917,0,NULL,37821216593,590956509,9233695,15.51),(35684,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35684,34.04,0.47,64.3,9776,70,NULL,NULL,'2MASX J04370384-1011513',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000147,NULL,'15.2b',0.6,NULL,NULL,NULL,NULL,NULL,1,69.2659583,-10.19756,0.121,NULL,37469287740,585457620,9147775,15.2),(35685,'Tully est','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35685,32.92,0.8,38.3,9777,75,NULL,'B','NGC 1625',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.000017,NULL,'12.97',0.5,'SB(rs)b:','Group member',NULL,NULL,NULL,1,69.2760833333,-3.3035,0.105,NULL,37460725302,585323832,9145684,12.97),(35686,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',35686,33.47,0.49,49.4,9777,75,NULL,'IR','NGC 1625',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35687,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35687,33.77,0.2,56.8,9777,74.4,NULL,NULL,'NGC 1625',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35688,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35688,33.94,0.3,61.3,9777,NULL,NULL,'Malmquist cor.','NGC 1625',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35689,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35689,33.94,0.3,61.4,9777,NULL,NULL,NULL,'NGC 1625',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35690,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35690,34.99,0.49,99.6,9778,70,NULL,NULL,'UGC 03105',NULL,'2014MNRAS.445.2677S',2014,1,2.5,NULL,'G',0.00015,NULL,'13.86',1.3,'S0-',NULL,NULL,NULL,NULL,1,69.281583,-2.30464,0.109,NULL,37449812263,585153316,9143020,13.86),(35691,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35691,36.96,0.58,246,9779,70,NULL,NULL,'2MASX J04371061-3825248',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,69.2942916667,-38.42356,0,NULL,37823293410,590988959,9234202,15),(35692,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35692,34.92,0.59,96.5,9780,70,NULL,NULL,'NGC 1630',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000087,NULL,'15.09',0.5,'SB0+ pec?',NULL,NULL,NULL,NULL,1,69.3145,-18.90153,0,NULL,37366139681,583845932,9122592,15.09),(35693,'IRAS','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35693,34.29,0.8,72.2,9781,75,NULL,'MAT, I','ESO 055- G 029',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'13.89',0.8,'SAB(s)d:',NULL,NULL,NULL,NULL,1,69.333083,-69.20386,0.385,NULL,36436623842,569322247,8895660,13.89),(35694,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35694,33.62,0.32,53,9781,85,NULL,'I, raw','ESO 055- G 029',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35695,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35695,33.66,0.32,53.9,9781,85,NULL,'I, inv','ESO 055- G 029',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35696,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35696,33.72,0.43,55.6,9781,75,NULL,'MAT, I, raw','ESO 055- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35697,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35697,33.89,0.43,60.1,9781,75,NULL,'MAT, I, inv','ESO 055- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35698,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35698,34.1,0.43,66.1,9781,75,NULL,'MAT, I, cor','ESO 055- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35699,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35699,34.15,0.33,67.7,9781,NULL,NULL,NULL,'ESO 055- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35700,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35700,34.19,0.2,68.9,9781,74.4,NULL,NULL,'ESO 055- G 029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35701,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35701,34.27,0.31,71.4,9781,NULL,NULL,'Malmquist cor.','ESO 055- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35702,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',35702,34.9,0.49,95.6,9782,75,NULL,'IR','UGC 03107',NULL,'2011yCatp016004901K',2011,1,1.23,NULL,'G',0.000008,NULL,'16.5',0.2,'Sbc',NULL,NULL,NULL,NULL,1,69.3409583,9.54447,0.589,NULL,65341137542,1020955274,15952426,16.5),(35703,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35703,35.45,0.4,123,9782,NULL,NULL,'mean','UGC 03107',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35704,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35704,35.59,0.47,131,9782,NULL,NULL,'H','UGC 03107',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35705,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35705,37.04,0.97,256,9783,70,NULL,NULL,'2MASX J04372555-0213493',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'14.7b',0.3,NULL,NULL,NULL,NULL,NULL,1,69.3565417,-2.23042,0.109,NULL,37449820573,585153446,9143022,14.7),(35706,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35706,33.93,NULL,61,9784,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0495',NULL,'2010Ap&SS.325..163P',2010,1,1.46,NULL,'G',0.000017,NULL,'15.8',0.18,'Sd',NULL,NULL,NULL,NULL,1,69.3803333333,-3.10403,0.105,NULL,37461353032,585333641,9145838,15.8),(35707,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35707,33.93,NULL,61,9784,NULL,NULL,'Dipole + Quadrupole','FGC 0495',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35708,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35708,33.93,NULL,61.1,9784,NULL,NULL,'Dipole','FGC 0495',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35709,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35709,33.95,NULL,61.8,9784,NULL,NULL,NULL,'FGC 0495',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35710,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',35710,33.99,0.49,62.7,9784,75,NULL,'IR','FGC 0495',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35711,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35711,34.05,0.33,64.7,9784,NULL,NULL,'Malmquist cor.','FGC 0495',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35712,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35712,34.3,0.29,72.5,9784,NULL,NULL,NULL,'FGC 0495',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35713,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35713,34.34,0.2,73.8,9784,74.4,NULL,NULL,'FGC 0495',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35714,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35714,35.71,0.53,139,9785,70,NULL,NULL,'2MASX J04373534-1326092',NULL,'2014MNRAS.445.2677S',2014,1,0.98,NULL,'G',0.00007,NULL,'16.46',0.43,NULL,NULL,NULL,NULL,NULL,1,69.397125,-13.43603,0.145,NULL,37544933865,586639591,9166243,16.46),(35715,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35715,33.77,0.55,56.8,9786,70,NULL,NULL,'NGC 1628',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.000017,NULL,'14.86',0.4,'Sb pec sp',NULL,NULL,NULL,NULL,1,69.401083,-4.71483,0.161,NULL,37460149452,585314835,9145544,14.86),(35716,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',35716,33.37,0.49,47.1,9786,75,NULL,'IR','NGC 1628',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35717,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35717,33.39,0.46,47.7,9786,NULL,NULL,'J','NGC 1628',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35718,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35718,33.41,0.47,48.1,9786,NULL,NULL,'H','NGC 1628',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35719,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35719,33.45,0.4,49.1,9786,NULL,NULL,'mean','NGC 1628',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35720,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35720,33.46,0.45,49.2,9786,NULL,NULL,'K','NGC 1628',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35721,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35721,33.78,0.33,56.9,9786,NULL,NULL,NULL,'NGC 1628',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35722,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35722,33.78,0.2,57,9786,74.4,NULL,NULL,'NGC 1628',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35723,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35723,33.87,0.32,59.4,9786,NULL,NULL,'Malmquist cor.','NGC 1628',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35724,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35724,34.04,0.57,64.2,9787,NULL,NULL,NULL,'UGC 03109',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000017,NULL,'16.5',0.8,'Sdm:',NULL,NULL,NULL,NULL,1,69.40725,-0.29319,0.145,NULL,36576941728,571514714,8929917,16.5),(35725,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35725,34.07,0.56,65.1,9787,NULL,NULL,'Malmquist cor.','UGC 03109',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35726,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35726,34.08,0.2,65.5,9787,74.4,NULL,NULL,'UGC 03109',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35727,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001fo','R',35727,41.98,NULL,1410,9788,65,NULL,'SALT','H-ZSNS J043741.45-012933.1',0.772,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,69.4227083,-1.49253,0.097,NULL,36576040612,571500634,8929697,NULL),(35728,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001fo',NULL,35728,42.81,0.22,2060,9788,74.2,NULL,'SALT 2','H-ZSNS J043741.45-012933.1',0.772,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35729,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001fo',NULL,35729,42.81,0.22,2060,9788,72,NULL,'MLCS','H-ZSNS J043741.45-012933.1',0.772,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35730,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001fo',NULL,35730,42.88,0.18,2130,9788,72,NULL,'dm15','H-ZSNS J043741.45-012933.1',0.772,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35731,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001fo',NULL,35731,43,0.2,2250,9788,72,NULL,'BATM','H-ZSNS J043741.45-012933.1',0.772,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35732,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001fo',NULL,35732,43.12,0.17,2370,9788,65,NULL,NULL,'H-ZSNS J043741.45-012933.1',0.772,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35733,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001fo',NULL,35733,43.44,0.26,2750,9788,70,NULL,'SALT','H-ZSNS J043741.45-012933.1',0.772,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35734,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001fo',NULL,35734,43.66,0.24,3040,9788,65,NULL,'SALT','H-ZSNS J043741.45-012933.1',0.772,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35735,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35735,36.1,0.78,166,9789,70,NULL,NULL,'2MASX J04374327-1147562',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000127,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,69.4302916667,-11.79889,0.093,NULL,37470742057,585480344,9148130,16.1),(35736,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35736,36.56,0.73,205,9790,70,NULL,NULL,'2MASX J04374967-3105239',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.000083,NULL,'16.50',0.32,'S',NULL,NULL,NULL,NULL,1,69.456917,-31.09,0.005,NULL,37686513483,588851773,9200808,16.5),(35737,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35737,35.4,0.56,120,9791,70,NULL,NULL,'2MASX J04375320-0211458',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.0I',0.3,NULL,NULL,NULL,NULL,NULL,1,69.4717916667,-2.19606,0.109,NULL,37449764188,585152565,9143008,14),(35738,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35738,36.48,0.49,197,9792,70,NULL,NULL,'2MASX J04375472-4258539',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.0001,NULL,'15.90',0.5,'E',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,69.478083,-42.98167,0,NULL,37835947569,591186680,9237291,15.9),(35739,'IRAS','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35739,34.16,0.8,67.8,9793,75,NULL,'MAT, I','IC 0382',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.00001,NULL,'13.4b',1.4,'SAB(rs)c:',NULL,NULL,NULL,NULL,1,69.4814583,-9.51933,0.169,NULL,37468970865,585452669,9147697,13.4),(35740,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35740,33.18,0.43,43.2,9793,75,NULL,'MAT, I, raw','IC 0382',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35741,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35741,33.28,0.32,45.3,9793,85,NULL,'I, raw','IC 0382',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35742,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35742,33.34,0.32,46.5,9793,85,NULL,'I, inv','IC 0382',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35743,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35743,33.4,0.43,47.8,9793,75,NULL,'MAT, I, inv','IC 0382',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35744,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35744,33.58,0.43,52,9793,75,NULL,'MAT, I, cor','IC 0382',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35745,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35745,33.59,0.47,52.2,9793,NULL,NULL,'H','IC 0382',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35746,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35746,33.61,0.46,52.7,9793,NULL,NULL,'J','IC 0382',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35747,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35747,33.64,0.45,53.4,9793,NULL,NULL,'K','IC 0382',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35748,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35748,33.79,0.2,57.3,9793,74.4,NULL,NULL,'IC 0382',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35749,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35749,34.05,0.3,64.6,9793,NULL,NULL,'Malmquist cor.','IC 0382',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35750,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35750,34.09,0.29,65.8,9793,NULL,NULL,NULL,'IC 0382',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35751,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35751,34.17,0.4,68.1,9793,NULL,NULL,'mean','IC 0382',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35752,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35752,36.41,0.53,191,9794,70,NULL,NULL,'2MASX J04375620-1140512',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000133,NULL,'16.20',0.5,NULL,NULL,NULL,NULL,NULL,1,69.484083,-11.68086,0.105,NULL,37470795383,585481177,9148143,16.2),(35753,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35753,35.54,0.49,128,9795,70,NULL,NULL,'CGCG 0435.5-0210 NED02',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'15.2b',0.4,NULL,NULL,NULL,NULL,NULL,1,69.5175,-2.04908,0.113,NULL,36576241313,571503770,8929746,15.2),(35754,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35754,36.56,0.6,205,9796,70,NULL,NULL,'2MASX J04380578-4143079',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'16.89',0.19,NULL,NULL,NULL,NULL,NULL,1,69.524167,-41.71883,0,NULL,37834539641,591164681,9236948,16.89),(35755,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35755,36.21,0.54,174,9797,70,NULL,NULL,'2MASX J04381244-6917173',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'15.7b',0.52,NULL,NULL,NULL,NULL,NULL,1,69.5517083,-69.28814,0.385,NULL,36436699148,569323424,8895678,15.7),(35756,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35756,35.4,0.55,120,9798,70,NULL,NULL,'2MASX J04381411-3209404',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.37',0.47,'S0',NULL,NULL,NULL,NULL,1,69.558875,-32.16125,0,NULL,37689926079,588905094,9201642,16.37),(35757,'G Lens','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35757,40.11,0.73,1050,9799,NULL,NULL,NULL,'HE 0435-1223:[WSB2002] G',NULL,'2007ApJ...660....1O',2007,1,NULL,'This galaxy lenses a z=1.69 QSO.','G',0.0002,NULL,'18.0i',NULL,NULL,NULL,NULL,NULL,NULL,1,69.56175,-12.28747,0.069,NULL,37540952652,586577385,9165271,18),(35758,'G Lens','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35758,42.5,0.51,3160,9799,NULL,NULL,NULL,'HE 0435-1223:[WSB2002] G',NULL,'2014MNRAS.437..600S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35759,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',35759,34.12,0.49,66.6,9800,75,NULL,'IR','UGC 03092',NULL,'2011yCatp016004901K',2011,1,1.37,NULL,'G',NULL,NULL,'17.',0.13,'Scd',NULL,NULL,NULL,NULL,1,69.5795417,72.28142,0.565,NULL,65670439788,1026100621,16032822,17),(35760,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35760,34.16,0.43,67.9,9800,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03092',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35761,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35761,34.36,0.43,74.3,9800,75,NULL,'3.6 micron, color corrected','UGC 03092',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35762,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35762,34.58,0.2,82.4,9800,74.4,NULL,NULL,'UGC 03092',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35763,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35763,34.59,0.46,83,9800,NULL,NULL,'Malmquist cor.','UGC 03092',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35764,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35764,34.75,NULL,89,9800,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03092',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35765,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35765,34.76,NULL,89.5,9800,NULL,NULL,'Dipole + Quadrupole','UGC 03092',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35766,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35766,34.76,NULL,89.7,9800,NULL,NULL,'Dipole','UGC 03092',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35767,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35767,34.81,NULL,91.7,9800,NULL,NULL,NULL,'UGC 03092',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35768,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35768,34.88,0.4,94.8,9800,NULL,NULL,NULL,'UGC 03092',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35769,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35769,37.29,0.63,287,9801,70,NULL,NULL,'2MASX J04382247-1107174',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00013,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,69.593625,-11.12142,0.117,NULL,37470471964,585476124,9148064,14.4),(35770,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35770,34.79,0.52,90.6,9802,70,NULL,NULL,'NGC 1631',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000023,NULL,'14.26',0.9,'(R:)SA(rs)a',NULL,NULL,NULL,NULL,1,69.6007083,-20.64986,0.033,NULL,37377529678,584023901,9125373,14.26),(35771,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2006lf',NULL,35771,32.52,0.3,31.5,9803,74.2,NULL,'SALT 2','UGC 03108',0.013206,'2010ApJ...716..712A',2010,1,1.8,'abs(b) < 10 degrees.','G',0.000023,NULL,'10.8B',1.8,'S?',NULL,NULL,NULL,NULL,1,69.6180417,44.03711,NULL,NULL,68435991146,1069312361,16708005,10.8),(35772,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2006lf',NULL,35772,33.09,0.09,41.5,9803,74.4,NULL,NULL,'UGC 03108',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35773,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2006lf',NULL,35773,33.26,0.22,44.3,9803,70,NULL,'SALT 2','UGC 03108',0.013206,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35774,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2006lf',NULL,35774,33.39,0.27,46.9,9803,65,NULL,'SALT2','UGC 03108',0.013206,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35775,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2006lf',NULL,35775,33.58,0.04,52,9803,72,NULL,'M(H) = -18.317 mag','UGC 03108',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35776,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2006lf',NULL,35776,33.72,0.25,54.8,9803,65,NULL,'MLCS31','UGC 03108',0.013206,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35777,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2006lf',NULL,35777,33.75,0.26,55.4,9803,65,NULL,'MLCS17','UGC 03108',0.013206,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35778,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2006lf',NULL,35778,33.82,0.09,57.3,9803,72,NULL,NULL,'UGC 03108',0.013206,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35779,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2006lf',NULL,35779,33.83,0.11,57.6,9803,72,NULL,NULL,'UGC 03108',0.013206,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35780,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35780,36.54,0.66,203,9804,70,NULL,NULL,'2MASX J04382877-1217041',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.29',0.39,NULL,NULL,NULL,NULL,NULL,1,69.6199166667,-12.28453,0.069,NULL,37540945840,586577278,9165269,16.29),(35781,'BCG','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35781,37.6,0.35,310,9805,60,NULL,'ABELL 0500, BCG','2MASX J04385250-2206391',0.0666,'1980ApJ...241..486H',1980,1,0.62,NULL,'G',NULL,NULL,'14.3V',0.38,'cD;E;BrClG','Brightest group member',NULL,NULL,NULL,1,69.7188333333,-22.11083,0.045,NULL,37375049311,583985145,9124767,14.3),(35782,'IRAS','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35782,35.28,0.8,114,9806,75,NULL,'MAT, I','ESO 084- G 033',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'14.17',0.5,'(R\')S(rs:)b',NULL,NULL,NULL,NULL,1,69.724167,-64.20808,0.029,NULL,35884601878,560696904,8760889,14.17),(35783,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35783,34.97,0.43,98.4,9806,75,NULL,'MAT, I, raw','ESO 084- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35784,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',35784,35.03,0.49,102,9806,75,NULL,'IR','ESO 084- G 033',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35785,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35785,35.07,0.37,103,9806,NULL,NULL,'Malmquist cor.','ESO 084- G 033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35786,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35786,35.18,0.32,108,9806,85,NULL,'I, raw','ESO 084- G 033',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35787,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35787,35.16,0.43,108,9806,75,NULL,'MAT, I, cor','ESO 084- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35788,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35788,35.27,0.32,113,9806,85,NULL,'I, inv','ESO 084- G 033',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35789,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35789,35.32,0.33,116,9806,NULL,NULL,NULL,'ESO 084- G 033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35790,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35790,35.34,0.43,117,9806,75,NULL,'MAT, I, inv','ESO 084- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35791,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35791,35.36,0.2,118,9806,74.4,NULL,NULL,'ESO 084- G 033',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35792,'BCG','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35792,37.6,0.35,310,9807,60,NULL,NULL,'ABELL 0500',0.0666,'1980ApJ...241..486H',1980,1,NULL,'Abell, Corwin, Olowin incorrectly give z=0.0066.','GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,69.727917,-22.11361,0.045,NULL,37375049716,583985151,9124767,NULL),(35793,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35793,36.28,0.66,180,9808,70,NULL,NULL,'2MASX J04385802-1336527',NULL,'2014MNRAS.445.2677S',2014,1,NULL,'The APM image includes a neighboring star.','G',0.000077,NULL,'16.36',NULL,NULL,NULL,NULL,NULL,NULL,1,69.7415833333,-13.61469,0.197,NULL,37547127517,586673867,9166779,16.36),(35794,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',35794,34.48,0.49,78.7,9809,75,NULL,'IR','UGC 03119',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000067,NULL,'16.5',0.4,'Sbc',NULL,NULL,NULL,NULL,1,69.7820416667,11.53053,0.829,NULL,65340612772,1020947074,15952298,16.5),(35795,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35795,35.17,0.47,108,9809,NULL,NULL,'H','UGC 03119',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35796,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35796,35.29,0.45,114,9809,NULL,NULL,'K','UGC 03119',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35797,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35797,35.31,0.4,115,9809,NULL,NULL,'mean','UGC 03119',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35798,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35798,35.39,0.46,120,9809,NULL,NULL,'J','UGC 03119',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35799,'SNII optical','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2003E',NULL,35799,33.91,0.42,60.5,9810,NULL,NULL,'SCM, B','ESO 485- G 004',NULL,'2010ApJ...715..833O',2010,1,1.41,NULL,'G',0.00003,NULL,'14.3B',0.17,'Sbc','Pair member (points to parent)',NULL,NULL,NULL,1,69.79625,-24.17983,0.033,NULL,37186716981,581042452,9078788,14.3),(35800,'SNII optical','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2003E',NULL,35800,34.01,0.28,63.4,9810,NULL,NULL,'SCM, BVI','ESO 485- G 004',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35801,'SNII optical','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2003E',NULL,35801,34.04,0.54,64.3,9810,NULL,NULL,'SCM, V','ESO 485- G 004',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35802,'SNII optical','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2003E',NULL,35802,34.05,0.23,64.6,9810,NULL,NULL,'V, photospheric magnitude method','ESO 485- G 004',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35803,'SNII optical','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2003E',NULL,35803,34.05,0.1,64.6,9810,NULL,NULL,'I, photospheric magnitude method','ESO 485- G 004',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35804,'SNII optical','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2003E',NULL,35804,34.1,0.54,66.1,9810,NULL,NULL,'SCM, I','ESO 485- G 004',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35805,'IRAS','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35805,33.84,0.8,58.5,9810,75,NULL,'MAT, I','ESO 485- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35806,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35806,32.46,0.32,31,9810,85,NULL,'I, raw','ESO 485- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35807,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35807,32.46,0.32,31.1,9810,85,NULL,'I, inv','ESO 485- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35808,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35808,32.73,0.43,35.1,9810,75,NULL,'MAT, I, raw','ESO 485- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35809,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35809,32.81,0.43,36.5,9810,75,NULL,'MAT, I, inv','ESO 485- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35810,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35810,33.11,0.43,41.8,9810,75,NULL,'MAT, I, cor','ESO 485- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35811,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35811,34.26,NULL,71.1,9810,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 485- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35812,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35812,34.27,NULL,71.6,9810,NULL,NULL,'Dipole + Quadrupole','ESO 485- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35813,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35813,34.28,NULL,71.9,9810,NULL,NULL,'Dipole','ESO 485- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35814,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35814,34.33,NULL,73.4,9810,NULL,NULL,NULL,'ESO 485- G 004',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35815,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001jm','R',35815,42.71,NULL,1760,9811,65,NULL,'SALT','H-ZSNS J043913.82-012318.2',0.978,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,69.807583,-1.38839,0.109,NULL,36577625557,571525399,8930084,NULL),(35816,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001jm',NULL,35816,42.78,0.3,1820,9811,74.2,NULL,'SALT 2','H-ZSNS J043913.82-012318.2',0.978,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35817,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001jm',NULL,35817,43.49,0.31,2520,9811,72,NULL,'MLCS','H-ZSNS J043913.82-012318.2',0.978,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35818,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001jm',NULL,35818,43.65,0.31,2720,9811,70,NULL,'SALT','H-ZSNS J043913.82-012318.2',0.978,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35819,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001jm',NULL,35819,43.8,0.28,2910,9811,65,NULL,'SALT','H-ZSNS J043913.82-012318.2',0.978,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35820,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001jm',NULL,35820,43.87,0.26,3000,9811,72,NULL,'BATM','H-ZSNS J043913.82-012318.2',0.978,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35821,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001jm',NULL,35821,43.91,0.26,3060,9811,65,NULL,NULL,'H-ZSNS J043913.82-012318.2',0.978,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35822,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35822,35.46,0.66,123,9812,70,NULL,NULL,'2MASX J04391450-7427002',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'15.9b',0.2,NULL,NULL,NULL,NULL,NULL,1,69.8102917,-74.45,0.333,NULL,35564778708,555699667,8682807,15.9),(35823,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35823,35.65,0.35,135,9813,NULL,NULL,NULL,'ESO 551- G 025',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.6V',0.7,'(R\')S(r)c',NULL,NULL,NULL,NULL,1,69.827875,-22.21161,0.045,NULL,37375029108,583984829,9124762,14.6),(35824,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35824,35.69,0.2,137,9813,74.4,NULL,NULL,'ESO 551- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35825,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35825,35.69,0.34,138,9813,NULL,NULL,'Malmquist cor.','ESO 551- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35826,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001hs','R',35826,42.6,NULL,1800,9814,65,NULL,'SALT','H-ZSNS J043922.39-013251.4',0.833,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,69.8432917,-1.54761,0.109,NULL,36575751396,571496115,8929626,NULL),(35827,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001hs',NULL,35827,42.97,0.53,2140,9814,74.2,NULL,'SALT 2','H-ZSNS J043922.39-013251.4',0.833,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35828,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001hs',NULL,35828,43.18,0.3,2360,9814,72,NULL,'MLCS','H-ZSNS J043922.39-013251.4',0.833,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35829,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001hs',NULL,35829,43.41,0.35,2620,9814,70,NULL,'SALT','H-ZSNS J043922.39-013251.4',0.833,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35830,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001hs',NULL,35830,43.45,0.34,2670,9814,72,NULL,'BATM','H-ZSNS J043922.39-013251.4',0.833,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35831,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001hs',NULL,35831,43.53,0.32,2770,9814,65,NULL,'SALT','H-ZSNS J043922.39-013251.4',0.833,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35832,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001hs',NULL,35832,43.55,0.29,2800,9814,65,NULL,NULL,'H-ZSNS J043922.39-013251.4',0.833,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35833,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001fs',NULL,35833,42.56,0.4,1730,9815,74.2,NULL,'SALT 2','H-ZSNS J043930.68-012821.9',0.874,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,69.877833,-1.47275,0.109,NULL,36575740629,571495947,8929624,NULL),(35834,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001fs',NULL,35834,43.18,0.36,2310,9815,72,NULL,'MLCS','H-ZSNS J043930.68-012821.9',0.874,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35835,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001fs',NULL,35835,43.39,0.46,2540,9815,70,NULL,'SALT','H-ZSNS J043930.68-012821.9',0.874,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35836,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001fs',NULL,35836,43.43,0.46,2590,9815,65,NULL,'SALT','H-ZSNS J043930.68-012821.9',0.874,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35837,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001fs',NULL,35837,43.75,0.38,3000,9815,65,NULL,NULL,'H-ZSNS J043930.68-012821.9',0.874,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35838,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001fs','R',35838,43.78,NULL,3040,9815,65,NULL,'SALT','H-ZSNS J043930.68-012821.9',0.874,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35839,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001fs',NULL,35839,43.84,0.5,3130,9815,72,NULL,'BATM','H-ZSNS J043930.68-012821.9',0.874,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35840,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35840,34.02,0.5,63.7,9816,70,NULL,NULL,'IC 0385',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000087,NULL,'15.41',0.5,'SA(rs)0^0^ pec?',NULL,NULL,NULL,NULL,1,69.8810833333,-7.09747,0.253,NULL,37510121610,586095650,9157744,15.41),(35841,'IRAS','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35841,31.89,0.8,23.9,9817,75,NULL,'MAT, I','ESO 157- G 049',NULL,'1997ApJS..109..333W',1997,1,1.9,'Position and ESO identity in SGC are incorrect.','G',0.000017,NULL,'14.33',0.4,'S?',NULL,NULL,NULL,NULL,1,69.903667,-53.01264,0,NULL,35937262620,561519728,8773745,14.33),(35842,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35842,31.35,0.39,18.6,9817,73,NULL,'IR','ESO 157- G 049',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35843,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',35843,31.35,0.4,18.6,9817,75,NULL,NULL,'ESO 157- G 049',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35844,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35844,31.52,0.32,20.1,9817,85,NULL,'I, inv','ESO 157- G 049',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35845,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35845,31.54,0.32,20.3,9817,85,NULL,'I, raw','ESO 157- G 049',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35846,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35846,31.87,0.4,23.7,9817,NULL,NULL,NULL,'ESO 157- G 049',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35847,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35847,31.89,0.43,23.9,9817,75,NULL,'MAT, I, raw','ESO 157- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35848,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35848,31.9,0.43,24,9817,75,NULL,'MAT, I, inv','ESO 157- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35849,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35849,31.92,0.43,24.2,9817,75,NULL,'MAT, I, cor','ESO 157- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35850,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35850,31.92,0.45,24.2,9817,NULL,NULL,'K','ESO 157- G 049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35851,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35851,31.96,0.47,24.7,9817,NULL,NULL,'H','ESO 157- G 049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35852,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35852,31.96,0.4,24.7,9817,NULL,NULL,'mean','ESO 157- G 049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35853,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35853,32.04,0.46,25.6,9817,NULL,NULL,'J','ESO 157- G 049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35854,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',35854,32.14,0.49,26.8,9817,75,NULL,'IR','ESO 157- G 049',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35855,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35855,34.44,0.2,77.3,9818,74.4,NULL,NULL,'ESO 485- G 005',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000027,NULL,'16.20',0.2,'Sb-c',NULL,NULL,NULL,NULL,1,69.9172917,-22.51311,0.041,NULL,37375146874,583986669,9124791,16.2),(35856,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',35856,34.53,0.49,80.5,9818,75,NULL,'IR','ESO 485- G 005',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35857,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35857,34.61,0.66,83.5,9818,NULL,NULL,NULL,'ESO 485- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35858,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35858,34.65,0.65,85.2,9818,NULL,NULL,'Malmquist cor.','ESO 485- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35859,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35859,35.71,0.5,139,9819,70,NULL,NULL,'2MASX J04394025-1315013',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000013,NULL,'16.1b',1.2,'SA(s)cd:',NULL,NULL,NULL,NULL,1,69.9177916667,-13.25033,0.201,NULL,37540368537,586568258,9165129,16.1),(35860,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35860,34.06,0.4,64.8,9820,NULL,NULL,'mean','UGC 03121',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.0001,NULL,'15.27',0.4,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,69.93775,3.03297,0.577,NULL,65311646241,1020494472,15945226,15.27),(35861,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35861,34.26,0.46,71.1,9820,NULL,NULL,'J','UGC 03121',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35862,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35862,34.28,0.47,71.7,9820,NULL,NULL,'H','UGC 03121',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35863,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',35863,34.4,0.49,75.8,9820,75,NULL,'IR','UGC 03121',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35864,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35864,34.41,0.45,76.3,9820,NULL,NULL,'K','UGC 03121',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35865,'IRAS','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35865,33.76,0.8,56.6,9821,75,NULL,'MAT, I','IC 2103',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'14.62',0.3,'Sc: sp',NULL,NULL,NULL,NULL,1,69.9502083,-76.83681,0.365,NULL,35543279673,555363744,8677558,14.62),(35866,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35866,33.77,0.43,56.8,9821,75,NULL,'MAT, I, raw','IC 2103',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35867,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35867,33.93,0.32,61,9821,85,NULL,'I, raw','IC 2103',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35868,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35868,33.93,0.47,61,9821,NULL,NULL,'H','IC 2103',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35869,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35869,33.94,0.4,61.3,9821,NULL,NULL,'mean','IC 2103',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35870,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35870,33.98,0.32,62.5,9821,85,NULL,'I, inv','IC 2103',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35871,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35871,34,0.43,63.2,9821,75,NULL,'MAT, I, inv','IC 2103',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35872,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35872,34.01,0.43,63.4,9821,75,NULL,'MAT, I, cor','IC 2103',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35873,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',35873,34.01,0.49,63.4,9821,75,NULL,'IR','IC 2103',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35874,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35874,34.03,0.46,64.1,9821,NULL,NULL,'J','IC 2103',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35875,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35875,34.12,0.45,66.6,9821,NULL,NULL,'K','IC 2103',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35876,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35876,34.19,0.33,68.8,9821,NULL,NULL,'Malmquist cor.','IC 2103',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35877,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35877,34.23,0.32,70.2,9821,NULL,NULL,NULL,'IC 2103',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35878,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35878,34.27,0.2,71.5,9821,74.4,NULL,NULL,'IC 2103',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35879,'IRAS','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35879,33.93,0.8,61.1,9822,75,NULL,'CF, r','UGC 03122',NULL,'1997ApJS..109..333W',1997,1,2.2,'HOLM 078B is a star.','G',0.000023,NULL,'14.20',1.3,'SAB(rs)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,69.9644583,7.05522,0.453,NULL,65360645470,1021260085,15957188,14.2),(35880,'Sosies','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35880,34.23,0.24,70.1,9822,NULL,NULL,NULL,'UGC 03122',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35881,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35881,33.23,0.69,44.3,9822,100,NULL,'mid-IR','UGC 03122',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35882,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35882,34.09,0.38,65.6,9822,75,NULL,'CF, r, raw','UGC 03122',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35883,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35883,34.09,0.33,65.7,9822,NULL,NULL,'Malmquist cor.','UGC 03122',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35884,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35884,34.14,0.4,67.4,9822,NULL,NULL,'mean','UGC 03122',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35885,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35885,34.21,0.38,69.6,9822,75,NULL,'CF, r, cor','UGC 03122',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35886,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35886,34.25,0.38,70.7,9822,75,NULL,'CF, r, inv','UGC 03122',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35887,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35887,34.42,0.2,76.6,9822,74.4,NULL,NULL,'UGC 03122',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35888,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35888,34.45,0.28,77.7,9822,NULL,NULL,NULL,'UGC 03122',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35889,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35889,34.55,0.47,81.1,9822,NULL,NULL,'H','UGC 03122',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35890,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35890,34.61,0.46,83.5,9822,NULL,NULL,'J','UGC 03122',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35891,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35891,34.64,0.45,84.5,9822,NULL,NULL,'K','UGC 03122',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35892,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35892,34.33,0.2,73.5,9823,74.4,NULL,NULL,'MCG -02-12-054',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.00006,NULL,'14.7b',0.8,'SA(rs)bc pec:',NULL,NULL,NULL,NULL,1,69.9937917,-8.91717,0.177,NULL,37499306925,585926670,9155104,14.7),(35893,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35893,35.13,0.59,106,9824,70,NULL,NULL,'2MASX J04395887-1039203',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00009,NULL,'15.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,69.995333,-10.65567,0.181,NULL,37471754540,585496164,9148377,15.6),(35894,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35894,32.65,0.47,33.8,9825,NULL,NULL,'H','WEIN 027',NULL,'2007A&A...465...71T',2007,1,1.12,NULL,'G',NULL,NULL,NULL,0.78,'S',NULL,NULL,NULL,NULL,1,70.010333,49.31414,NULL,NULL,68419973126,1069062080,16704095,NULL),(35895,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35895,32.68,0.45,34.4,9825,NULL,NULL,'K','WEIN 027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35896,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35896,32.86,0.46,37.4,9825,NULL,NULL,'J','WEIN 027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35897,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35897,33.27,0.4,45,9825,NULL,NULL,'mean','WEIN 027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35898,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',35898,35.1,0.49,105,9826,75,NULL,'IR','UGC 03123',NULL,'2011yCatp016004901K',2011,1,NULL,NULL,'GPair',0.000067,NULL,NULL,NULL,'DBL SYS',NULL,NULL,NULL,NULL,1,70.01125,12.51472,0.913,NULL,65471831488,1022997367,15984333,NULL),(35899,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35899,33.68,0.47,54.4,9827,NULL,NULL,'H','NGC 1633',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000033,NULL,'14.36',0.9,'SAB(s)ab','Pair member (points to parent)',NULL,NULL,NULL,1,70.0379583333,7.34944,0.453,NULL,65360552583,1021258634,15957166,14.36),(35900,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35900,33.85,0.45,59,9827,NULL,NULL,'K','NGC 1633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35901,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35901,33.87,0.46,59.4,9827,NULL,NULL,'J','NGC 1633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35902,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35902,34.19,0.4,68.9,9827,NULL,NULL,'mean','NGC 1633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35903,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001jn',NULL,35903,42.68,0.2,2090,9828,72,NULL,'dm15','H-ZSNS J044012.00-011745.9',0.645,'2004ApJ...602..571B',2004,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,70.05,-1.29608,0.109,NULL,36577537443,571524022,8930062,NULL),(35904,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001jn',NULL,35904,42.83,0.32,2240,9828,72,NULL,'MLCS','H-ZSNS J044012.00-011745.9',0.645,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35905,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001jn',NULL,35905,43,0.35,2420,9828,72,NULL,'BATM','H-ZSNS J044012.00-011745.9',0.645,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35906,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001jn','R',35906,43.37,NULL,2870,9828,65,NULL,'SALT','H-ZSNS J044012.00-011745.9',0.645,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35907,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001jn',NULL,35907,44.04,0.96,3910,9828,70,NULL,'SALT','H-ZSNS J044012.00-011745.9',0.645,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35908,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 2001jn',NULL,35908,44.17,0.91,4140,9828,65,NULL,'SALT','H-ZSNS J044012.00-011745.9',0.645,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35909,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35909,34.52,0.2,80.2,9829,74.4,NULL,NULL,'2MASX J04401376-0451572',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000057,NULL,'15.91',0.3,'S','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,70.0572917,-4.86589,0.149,NULL,37458008112,585281376,9145021,15.91),(35910,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35910,35.14,0.64,107,9830,70,NULL,NULL,'2MASX J04402386-3842500',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'15.91',0.5,'S0',NULL,NULL,NULL,NULL,1,70.099333,-38.71389,0,NULL,37831845858,591122591,9236290,15.91),(35911,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35911,32.3,0.2,28.8,9831,74.4,NULL,NULL,'UGC 03127',NULL,'2013AJ....146...86T',2013,1,2.21,'Confused HIPASS source','G',0.000017,NULL,'14.75',0.43,'SB(s)dm: sp',NULL,NULL,NULL,NULL,1,70.105833,-2.02417,0.129,NULL,36575784092,571496626,8929634,14.75),(35912,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35912,32.52,0.57,31.9,9831,NULL,NULL,NULL,'UGC 03127',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35913,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35913,32.76,0.51,35.6,9831,NULL,NULL,'Malmquist cor.','UGC 03127',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35914,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35914,32.84,0.4,37,9831,73,NULL,'opt','UGC 03127',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35915,'IRAS','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35915,33.7,0.8,54.9,9832,75,NULL,'MAT, I','ESO 084- G 034',NULL,'1997ApJS..109..333W',1997,1,2.3,'Di Nella et al. (1996,A&AS,118,311) give v = 6199 +/- 16 km/sec.','G',0.000033,NULL,'15.42',0.25,'Sb',NULL,NULL,NULL,NULL,1,70.110083,-63.10722,0,NULL,35885470064,560710469,8761101,15.42),(35916,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35916,34.38,0.43,75.1,9832,75,NULL,'MAT, I, raw','ESO 084- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35917,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35917,34.39,NULL,75.5,9832,NULL,NULL,NULL,'ESO 084- G 034',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35918,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35918,34.49,0.32,79.2,9832,85,NULL,'I, raw','ESO 084- G 034',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35919,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35919,34.54,0.32,81,9832,85,NULL,'I, inv','ESO 084- G 034',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35920,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35920,34.6,0.43,83.3,9832,75,NULL,'MAT, I, inv','ESO 084- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35921,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',35921,34.63,0.49,84.3,9832,75,NULL,'IR','ESO 084- G 034',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35922,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35922,34.69,0.43,86.7,9832,75,NULL,'MAT, I, cor','ESO 084- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35923,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35923,34.73,0.47,88.2,9832,NULL,NULL,'H','ESO 084- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35924,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35924,34.73,0.45,88.2,9832,NULL,NULL,'K','ESO 084- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35925,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35925,34.81,0.4,91.5,9832,NULL,NULL,'mean','ESO 084- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35926,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35926,34.81,NULL,91.6,9832,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 084- G 034',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35927,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35927,34.84,NULL,93,9832,NULL,NULL,'Dipole + Quadrupole','ESO 084- G 034',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35928,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35928,34.85,NULL,93.4,9832,NULL,NULL,'Dipole','ESO 084- G 034',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35929,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35929,34.9,0.6,95.4,9832,NULL,NULL,'Malmquist cor.','ESO 084- G 034',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35930,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35930,34.99,0.46,99.5,9832,NULL,NULL,'J','ESO 084- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35931,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35931,35.34,0.49,117,9832,NULL,NULL,NULL,'ESO 084- G 034',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35932,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',35932,33.6,0.49,52.6,9833,75,NULL,'IR','2MFGC 03828',NULL,'2011yCatp016004901K',2011,1,1,'abs(b) < 10 degrees.','G',0.000013,NULL,'11.1K',0.1,NULL,NULL,NULL,NULL,NULL,1,70.1110417,36.57642,NULL,NULL,68339942192,1067811596,16684556,11.1),(35933,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35933,33.66,0.2,54,9834,74.4,NULL,NULL,'UGC 03114',NULL,'2013AJ....146...86T',2013,1,1.8,NULL,'G',0.000037,NULL,'14.7',0.9,'Scd:',NULL,NULL,NULL,NULL,1,70.124667,66.63517,1.341,NULL,66410026804,1037656668,16213385,14.7),(35934,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35934,33.72,0.43,55.5,9834,75,NULL,'3.6 micron, color corrected','UGC 03114',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35935,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35935,33.75,0.4,56.3,9834,NULL,NULL,'mean','UGC 03114',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35936,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35936,33.75,0.43,56.3,9834,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03114',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35937,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35937,34.08,0.47,65.5,9834,NULL,NULL,'H','UGC 03114',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35938,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35938,34.13,0.46,67,9834,NULL,NULL,'J','UGC 03114',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35939,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35939,34.14,0.45,67.3,9834,NULL,NULL,'K','UGC 03114',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35940,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1995az','R',35940,41.06,NULL,1120,9835,65,NULL,'SALT','[PDG95a] J044033.70-053001.9',0.45,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,'Sc',NULL,NULL,NULL,NULL,1,70.1404166667,-5.50053,0.261,NULL,37457395736,585271808,9144872,NULL),(35941,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1995az',NULL,35941,41.7,0.52,1510,9835,74.2,NULL,'SALT 2','[PDG95a] J044033.70-053001.9',0.45,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35942,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1995az',NULL,35942,42.13,0.21,1840,9835,65,NULL,NULL,'[PDG95a] J044033.70-053001.9',0.45,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35943,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1995az',NULL,35943,42.21,0.38,1910,9835,70,NULL,'SALT','[PDG95a] J044033.70-053001.9',0.45,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35944,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1995az',NULL,35944,42.43,0.36,2110,9835,65,NULL,'SALT','[PDG95a] J044033.70-053001.9',0.45,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35945,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35945,34.34,1.2,73.7,9836,NULL,NULL,NULL,'ESO 551- G 026',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16',0.6,'S...',NULL,NULL,NULL,NULL,1,70.154667,-21.96694,0.045,NULL,37372909633,583951713,9124245,16),(35946,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35946,34.38,0.2,75.2,9836,74.4,NULL,NULL,'ESO 551- G 026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35947,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35947,34.78,0.98,90.5,9836,NULL,NULL,'Malmquist cor.','ESO 551- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35948,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35948,36.47,0.57,197,9837,70,NULL,NULL,'6dF J0440437-364105',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,70.182167,-36.68461,0,NULL,37691103102,588923485,9201929,14.9),(35949,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',35949,33.6,0.49,52.5,9838,75,NULL,'IR','ESO 157-IG 050',NULL,'2011yCatp016004901K',2011,1,1.74,NULL,'G',0.000027,NULL,'14.78',0.33,'Sbc: pec sp',NULL,NULL,NULL,NULL,1,70.183375,-52.75828,0,NULL,35937763583,561527555,8773868,14.78),(35950,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35950,36.06,0.5,163,9839,70,NULL,NULL,'2MASX J04405079-1216500',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000087,NULL,'15.95',NULL,NULL,NULL,NULL,NULL,NULL,1,70.211583,-12.28072,0.153,NULL,37540809122,586575142,9165236,15.95),(35951,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35951,36.84,0.44,234,9840,NULL,NULL,'Malmquist cor.','2MASX J04410665-0251016',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000013,NULL,'14.6I',NULL,NULL,NULL,NULL,NULL,NULL,1,70.2777083,-2.85044,0.117,NULL,36589019041,571703422,8932865,14.6),(35952,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35952,36.9,0.43,239,9840,NULL,NULL,NULL,'2MASX J04410665-0251016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35953,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35953,36.94,0.2,244,9840,74.4,NULL,NULL,'2MASX J04410665-0251016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35954,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35954,36.54,0.69,204,9841,70,NULL,NULL,'2MASX J04410769-4415466',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000077,NULL,'15.48',0.35,'S',NULL,NULL,NULL,NULL,1,70.2819583,-44.26294,0,NULL,37836044416,591188194,9237315,15.48),(35955,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35955,33.64,0.2,53.5,9842,74.4,NULL,NULL,'UGC 03110',NULL,'2013AJ....146...86T',2013,1,2.1,NULL,'G',0.000037,NULL,'14.6',0.9,'SBcd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,70.2859583333,73.67175,0.501,NULL,65689566243,1026399472,16037491,14.6),(35956,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35956,33.69,0.43,54.6,9842,75,NULL,'3.6 micron, color corrected','UGC 03110',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35957,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35957,33.69,0.47,54.7,9842,NULL,NULL,'H','UGC 03110',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35958,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35958,33.73,0.46,55.7,9842,NULL,NULL,'J','UGC 03110',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35959,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35959,33.78,0.45,56.9,9842,NULL,NULL,'K','UGC 03110',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35960,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35960,33.79,0.43,57.2,9842,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03110',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35961,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35961,33.96,0.4,61.8,9842,NULL,NULL,'mean','UGC 03110',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35962,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35962,32.95,0.47,38.9,9843,NULL,NULL,'H','WEIN 033',NULL,'2007A&A...465...71T',2007,1,0.4,NULL,'G',NULL,NULL,'9.88K',NULL,'S',NULL,NULL,NULL,NULL,1,70.320625,44.93511,NULL,NULL,68429509283,1069211082,16706423,9.88),(35963,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35963,32.99,0.45,39.6,9843,NULL,NULL,'K','WEIN 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35964,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35964,33.37,0.4,47.2,9843,NULL,NULL,'mean','WEIN 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35965,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35965,33.42,0.46,48.2,9843,NULL,NULL,'J','WEIN 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35966,'Brightest Stars','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35966,29.47,NULL,7.8,9844,NULL,NULL,NULL,'NGC 1637',NULL,'1998AJ....115..130S',1998,1,4,'Extended HIPASS source','G',0.000004,NULL,'11.2B',3.2,'SAB(rs)c       AGN',NULL,NULL,NULL,NULL,1,70.367417,-2.85797,0.117,NULL,36589039375,571703740,8932870,11.2),(35967,'Cepheids','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35967,30.34,0.07,11.7,9844,NULL,NULL,'18, VI, +Z','NGC 1637',NULL,'2003ApJ...594..247L',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35968,'Cepheids','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35968,30.4,0.07,12,9844,NULL,18.54,'LMC ZP','NGC 1637',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35969,'Cepheids','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',35969,30.4,NULL,12,9844,NULL,18.54,NULL,'NGC 1637',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35970,'SNII optical','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1999em',NULL,35970,29.38,0.13,7.5,9844,NULL,NULL,NULL,'NGC 1637',NULL,'2001ApJ...558..615H',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35971,'SNII optical','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1999em',NULL,35971,29.47,NULL,7.83,9844,NULL,NULL,NULL,'NGC 1637',NULL,'2003MNRAS.338..939E',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35972,'SNII optical','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1999em',NULL,35972,29.48,0.14,7.86,9844,NULL,NULL,NULL,'NGC 1637',NULL,'2003ApJ...594..247L',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35973,'SNII optical','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1999em',NULL,35973,29.57,0.15,8.2,9844,NULL,NULL,NULL,'NGC 1637',NULL,'2002PASP..114...35L',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35974,'SNII optical','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1999em',NULL,35974,29.84,0.11,9.25,9844,NULL,NULL,'SEAM','NGC 1637',0.002392,'2009ApJ...694.1067P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35975,'SNII optical','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1999em',NULL,35975,29.84,0.11,9.3,9844,NULL,NULL,'EPM E96','NGC 1637',NULL,'2009ApJ...696.1176J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35976,'SNII optical','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1999em',NULL,35976,29.93,0.17,9.7,9844,NULL,NULL,'EPM, expansion velocity modeled','NGC 1637',NULL,'2012MNRAS.419.2783T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35977,'SNII optical','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1999em',NULL,35977,29.94,0.53,9.73,9844,NULL,NULL,'SCM, I','NGC 1637',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35978,'SNII optical','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1999em',NULL,35978,29.96,0.54,9.82,9844,NULL,NULL,'SCM, V','NGC 1637',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35979,'SNII optical','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1999em',NULL,35979,30,0.28,10,9844,NULL,NULL,'SCM, BVI','NGC 1637',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35980,'SNII optical','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1999em',NULL,35980,30,0.16,10,9844,NULL,NULL,'SCM, Poznanski et al. 2009','NGC 1637',NULL,'2015A&A...580L..15P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35981,'SNII optical','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1999em',NULL,35981,30.07,0.4,10.3,9844,NULL,NULL,'SCM, B','NGC 1637',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35982,'SNII optical','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1999em',NULL,35982,30.07,0.16,10.3,9844,NULL,NULL,'SCM, Hamuy 2003','NGC 1637',NULL,'2015A&A...580L..15P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35983,'SNII optical','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1999em',NULL,35983,30.09,0.06,10.4,9844,NULL,NULL,'SCM','NGC 1637',NULL,'2015ApJ...799..215P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35984,'SNII optical','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1999em',NULL,35984,30.17,0.16,10.8,9844,NULL,NULL,'SCM, Nugent et al. 2006','NGC 1637',NULL,'2015A&A...580L..15P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35985,'SNII optical','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1999em',NULL,35985,30.18,0.16,10.9,9844,NULL,NULL,'SCM, D\'Andrea et al. 2010','NGC 1637',NULL,'2015A&A...580L..15P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35986,'SNII optical','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1999em',NULL,35986,30.3,0.17,11.5,9844,NULL,NULL,NULL,'NGC 1637',NULL,'2006A&A...447..691D',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35987,'SNII optical','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1999em',NULL,35987,30.32,0.22,11.6,9844,NULL,NULL,'SCM','NGC 1637',NULL,'2009ApJ...703.2205K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35988,'SNII optical','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1999em',NULL,35988,30.36,0.03,11.8,9844,NULL,NULL,'I, photospheric magnitude method','NGC 1637',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35989,'SNII optical','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1999em',NULL,35989,30.42,0.06,12.1,9844,NULL,NULL,'V, photospheric magnitude method','NGC 1637',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35990,'SNII optical','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1999em',NULL,35990,30.48,0.23,12.5,9844,NULL,NULL,'EPM','NGC 1637',NULL,'2012MNRAS.419.2783T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35991,'SNII optical','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1999em',NULL,35991,30.72,0.2,13.9,9844,NULL,NULL,'EPM D05','NGC 1637',NULL,'2009ApJ...696.1176J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35992,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35992,29.74,0.4,8.9,9844,75,NULL,'B','NGC 1637',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35993,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35993,29.95,0.36,9.77,9844,NULL,NULL,NULL,'NGC 1637',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35994,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35994,30.65,0.4,13.5,9844,73,NULL,'opt','NGC 1637',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35995,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35995,31.17,0.4,17.2,9844,NULL,NULL,NULL,'NGC 1637',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35996,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35996,31.21,0.2,17.5,9844,74.4,NULL,NULL,'NGC 1637',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35997,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35997,31.27,0.38,17.9,9844,NULL,NULL,'Malmquist cor.','NGC 1637',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35998,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',35998,31.43,NULL,19.3,9844,NULL,NULL,'LEDA [April 2006]','NGC 1637',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(35999,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,35999,36.34,0.64,185,9845,70,NULL,NULL,'2MASX J04413499-1235535',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'17.59',0.17,NULL,NULL,NULL,NULL,NULL,1,70.395833,-12.59825,0.205,NULL,37542817699,586606526,9165726,17.59),(36000,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36000,36.8,0.56,229,9846,70,NULL,NULL,'2MASX J04413537-2947009',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'16.13',0.53,'S0',NULL,NULL,NULL,NULL,1,70.3974583,-29.78364,0.089,NULL,37237330658,581833291,9091145,16.13),(36001,'Faber-Jackson','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36001,31.31,0.37,18.3,9847,95,NULL,'Weighted Mean','NGC 1638',NULL,'1984ApJS...56...91D',1984,1,2,'Confused HIPASS source','G',0.000035,NULL,'12.91',1.5,'SAB(rs)0^0^?',NULL,NULL,NULL,NULL,1,70.402125,-1.80903,0.089,NULL,36589781029,571715328,8933052,12.91),(36002,'Faber-Jackson','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36002,31.55,0.63,20.4,9847,95,NULL,'Michard 1979b, c','NGC 1638',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36003,'Faber-Jackson','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36003,31.62,0.81,21.1,9847,55,NULL,'Visvanathan & Sandage 1979','NGC 1638',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36004,'Faber-Jackson','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36004,32.23,0.46,27.9,9847,95,NULL,'Michard 1979a','NGC 1638',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36005,'Tertiary','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36005,32.6,0.25,33.1,9847,95,NULL,NULL,'NGC 1638',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36006,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36006,32.82,0.45,36.7,9847,NULL,NULL,'K','NGC 1638',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36007,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36007,33.11,0.48,41.8,9847,NULL,NULL,NULL,'NGC 1638',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36008,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36008,33.18,0.46,43.3,9847,NULL,NULL,'Malmquist cor.','NGC 1638',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36009,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36009,33.19,0.4,43.5,9847,NULL,NULL,'mean','NGC 1638',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36010,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36010,33.24,0.2,44.5,9847,74.4,NULL,NULL,'NGC 1638',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36011,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36011,35.98,0.49,157,9848,70,NULL,NULL,'MCG -06-11-004',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000123,NULL,'14.97',0.63,'S0',NULL,NULL,NULL,NULL,1,70.425875,-36.933,0,NULL,37822190155,590971721,9233933,14.97),(36012,'IRAS','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36012,33.87,0.8,59.4,9849,75,NULL,'MAT, I','IC 0387',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'13.9b',1.2,'SAB(rs)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,70.4342083,-7.08619,0.229,NULL,37510397223,586099956,9157811,13.9),(36013,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36013,33.97,0.4,62.1,9849,NULL,NULL,'mean','IC 0387',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36014,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36014,34.29,0.46,72.1,9849,NULL,NULL,'Malmquist cor.','IC 0387',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36015,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',36015,34.33,NULL,73.5,9849,NULL,NULL,'B','IC 0387',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36016,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36016,34.44,0.32,77.4,9849,85,NULL,'I, raw','IC 0387',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36017,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36017,34.45,0.43,77.8,9849,75,NULL,'MAT, I, raw','IC 0387',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36018,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36018,34.5,0.47,79.4,9849,NULL,NULL,'H','IC 0387',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36019,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36019,34.52,0.32,80.1,9849,85,NULL,'I, inv','IC 0387',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36020,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36020,34.54,0.43,81.1,9849,75,NULL,'MAT, I, cor','IC 0387',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36021,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36021,34.55,0.45,81.2,9849,NULL,NULL,'K','IC 0387',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36022,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36022,34.57,0.46,81.9,9849,NULL,NULL,'J','IC 0387',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36023,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',36023,34.59,NULL,82.8,9849,NULL,NULL,'I','IC 0387',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36024,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36024,34.73,0.2,88.3,9849,74.4,NULL,NULL,'IC 0387',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36025,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36025,34.77,0.43,89.9,9849,75,NULL,'MAT, I, inv','IC 0387',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36026,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36026,34.79,0.36,90.8,9849,NULL,NULL,NULL,'IC 0387',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36027,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36027,35.17,0.4,108,9850,NULL,NULL,'mean','UGC 03135',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000027,NULL,'17.',1.1,'SBcd:',NULL,NULL,NULL,NULL,1,70.5325,20.05014,1.617,NULL,65281848409,1020028881,15937951,17),(36028,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36028,35.39,0.2,120,9850,74.4,NULL,NULL,'UGC 03135',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36029,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36029,35.66,0.47,136,9850,NULL,NULL,'H','UGC 03135',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36030,'Ring Diameter','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36030,31.8,0.76,23,9851,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 1640',NULL,'1981ApJS...45..541P',1981,1,2.6,NULL,'G',0.000013,NULL,'12.42',2,'SB(r)b',NULL,NULL,NULL,NULL,1,70.5605,-20.43478,0,NULL,37365077228,583829331,9122333,12.42),(36031,'Ring Diameter','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36031,31.9,0.6,24,9851,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 1640',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36032,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36032,31.4,0.4,19.1,9851,75,NULL,'B','NGC 1640',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36033,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36033,35.31,0.66,115,9852,70,NULL,NULL,'2MASX J04421742-6801517',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'17.1b',0.3,NULL,NULL,NULL,NULL,NULL,1,70.572833,-68.03117,0.153,NULL,36434889317,569295145,8895236,17.1),(36034,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36034,36.46,0.57,196,9853,70,NULL,NULL,'2MASX J04422258-1547125',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.0001,NULL,'16.72',0.41,NULL,NULL,NULL,NULL,NULL,1,70.594083,-15.78672,0.129,NULL,37536534268,586508347,9164192,16.72),(36035,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36035,35.67,0.63,136,9854,70,NULL,NULL,'2MASX J04422367-1237525',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00007,NULL,'16.45',NULL,NULL,NULL,NULL,NULL,NULL,1,70.598667,-12.6315,0.257,NULL,37542888010,586607625,9165744,16.45),(36036,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36036,36.59,0.66,208,9855,70,NULL,NULL,'2MASX J04422530-1308315',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'17.30',0.33,NULL,NULL,NULL,NULL,NULL,1,70.605417,-13.14208,0.237,NULL,37542251035,586597672,9165588,17.3),(36037,'IRAS','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36037,31.91,0.8,24.1,9856,75,NULL,'MAT, I','ESO 551- G 031',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.99',0.39,'SB(s)d: sp',NULL,NULL,NULL,NULL,1,70.6204583,-21.69169,0.009,NULL,37339920926,583436264,9116191,14.99),(36038,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36038,31.23,0.32,17.6,9856,85,NULL,'I, inv','ESO 551- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36039,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36039,31.28,0.32,18,9856,85,NULL,'I, raw','ESO 551- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36040,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36040,31.71,0.43,22,9856,75,NULL,'MAT, I, inv','ESO 551- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36041,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36041,31.81,0.43,23,9856,75,NULL,'MAT, I, raw','ESO 551- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36042,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36042,31.87,0.08,23.7,9856,NULL,NULL,NULL,'ESO 551- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36043,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36043,31.97,0.43,24.7,9856,75,NULL,'MAT, I, cor','ESO 551- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36044,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36044,36.67,0.7,215,9857,70,NULL,NULL,'6dF J0442332-324755',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,70.638583,-32.79858,0,NULL,37688515023,588883047,9201297,15),(36045,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36045,36.47,0.59,197,9858,70,NULL,NULL,'2MASX J04424266-3651149',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,70.6777916667,-36.85419,0,NULL,37830536459,591102132,9235970,14.2),(36046,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36046,35.43,0.5,122,9859,NULL,NULL,NULL,'ESO 015- G 014',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.89',0.2,'S...',NULL,NULL,NULL,NULL,1,70.68175,-79.38186,0.333,NULL,35683842183,557560034,8711875,15.89),(36047,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36047,35.46,0.49,123,9859,NULL,NULL,'Malmquist cor.','ESO 015- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36048,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36048,35.47,0.2,124,9859,74.4,NULL,NULL,'ESO 015- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36049,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36049,36.48,0.85,198,9860,70,NULL,NULL,'2MASX J04424824-3653569',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,70.701083,-36.89917,0,NULL,37830582160,591102846,9235981,14.6),(36050,'Tully est','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36050,32.49,0.8,31.4,9861,75,NULL,NULL,'UGCA 094',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000022,NULL,'13.71',1.3,'SAB(s)dm',NULL,NULL,NULL,NULL,1,70.73875,-8.09069,0.237,NULL,37513732815,586152075,9158626,13.71),(36051,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36051,33.16,0.43,42.8,9861,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 094',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36052,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36052,36.14,0.65,169,9862,70,NULL,NULL,'MCG -02-12-058',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000033,NULL,'14.35',0.6,'SB(r)b',NULL,NULL,NULL,NULL,1,70.7455833333,-12.77106,0.337,NULL,37542976319,586609004,9165765,14.35),(36053,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36053,34.57,0.69,81.8,9862,100,NULL,'mid-IR','MCG -02-12-058',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36054,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36054,35.59,0.4,131,9862,NULL,NULL,'mean','MCG -02-12-058',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36055,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36055,35.83,0.47,146,9862,NULL,NULL,'H','MCG -02-12-058',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36056,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36056,35.38,0.48,119,9863,70,NULL,NULL,'2MASX J04430197-0918594',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.0001,NULL,'14.94',NULL,NULL,NULL,NULL,NULL,NULL,1,70.7582083,-9.31658,0.205,NULL,37500323462,585942554,9155352,14.94),(36057,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36057,36.17,0.48,171,9864,70,NULL,NULL,'2MASX J04431291-1542101',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00008,NULL,'15.43',0.37,NULL,NULL,NULL,NULL,NULL,1,70.803875,-15.70297,0.109,NULL,37536687597,586510743,9164230,15.43),(36058,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36058,35.69,0.53,138,9865,70,NULL,NULL,'2MASX J04431466-4434519',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'15.76',0.42,'S0',NULL,NULL,NULL,NULL,1,70.811083,-44.58106,0,NULL,37803763657,590683807,9229434,15.76),(36059,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36059,36.73,0.6,222,9866,70,NULL,NULL,'GALEXASC J044323.08-321740.1',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'15.87',0.53,'S0',NULL,NULL,NULL,NULL,1,70.8468333333,-32.29425,0,NULL,37688878304,588888723,9201386,15.87),(36060,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36060,34.59,NULL,82.9,9867,NULL,NULL,'Dipole','FGC 0499',NULL,'2010Ap&SS.325..163P',2010,1,1.2,NULL,'G',0.000034,NULL,'16.6',0.11,'Sc',NULL,NULL,NULL,NULL,1,70.910833,-12.05,0.257,NULL,37539434622,586553665,9164901,16.6),(36061,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36061,34.6,NULL,83,9867,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0499',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36062,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36062,34.6,NULL,83.2,9867,NULL,NULL,'Dipole + Quadrupole','FGC 0499',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36063,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36063,34.35,0.47,74,9868,NULL,NULL,'H','UGC 03139',NULL,'2007A&A...465...71T',2007,1,1.4,'abs(b) < 10 degrees.','G',0.000023,NULL,'17.',1,'S?',NULL,NULL,NULL,NULL,1,70.931,40.11781,NULL,NULL,68414068917,1068969826,16702653,17),(36064,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36064,34.38,0.45,75.1,9868,NULL,NULL,'K','UGC 03139',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36065,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36065,34.58,0.46,82.5,9868,NULL,NULL,'J','UGC 03139',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36066,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36066,34.6,0.4,83.2,9868,NULL,NULL,'mean','UGC 03139',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36067,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36067,36.15,0.25,170,9869,74.4,NULL,NULL,'GIN 200',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.00004,NULL,'14.30',0.7,'E/S0',NULL,NULL,NULL,NULL,1,70.939125,-15.81678,0.101,NULL,37536597208,586509331,9164208,14.3),(36068,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36068,36.37,0.2,188,9869,70,NULL,NULL,'GIN 200',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36069,'CMD','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'N',36069,20.3,NULL,0.114,9870,NULL,NULL,NULL,'Pictoris I',NULL,'2015ApJ...805..130K',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36070,'CMD','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'N',36070,20.5,NULL,0.126,9870,NULL,NULL,'DES J0443.8 _5017','Pictoris I',NULL,'2015ApJ...807...50B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36071,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36071,36.39,0.57,190,9871,70,NULL,NULL,'2MASX J04435326-1557004',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00011,NULL,'16.31',0.38,NULL,NULL,NULL,NULL,NULL,1,70.972,-15.95017,0.101,NULL,37536657201,586510268,9164222,16.31),(36072,'IRAS','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36072,34.2,0.8,69.1,9872,75,NULL,'MAT, I','NGC 1658',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.34',0.5,'Sbc:',NULL,NULL,NULL,NULL,1,71.0056666667,-41.46342,0,NULL,37826721680,591042526,9235039,14.34),(36073,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36073,34.1,0.43,66,9872,75,NULL,'MAT, I, raw','NGC 1658',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36074,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36074,34.12,0.32,66.7,9872,85,NULL,'I, raw','NGC 1658',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36075,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36075,34.18,0.32,68.5,9872,85,NULL,'I, inv','NGC 1658',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36076,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',36076,34.2,NULL,69.2,9872,NULL,NULL,'B','NGC 1658',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36077,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36077,34.24,0.47,70.4,9872,NULL,NULL,'H','NGC 1658',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36078,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36078,34.25,0.45,70.9,9872,NULL,NULL,'K','NGC 1658',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36079,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36079,34.28,0.46,71.7,9872,NULL,NULL,'J','NGC 1658',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36080,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36080,34.29,0.4,72.1,9872,NULL,NULL,'Malmquist cor.','NGC 1658',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36081,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36081,34.3,0.43,72.3,9872,75,NULL,'MAT, I, cor','NGC 1658',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36082,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36082,34.3,0.4,72.4,9872,NULL,NULL,'mean','NGC 1658',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36083,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36083,34.35,0.43,74.2,9872,75,NULL,'MAT, I, inv','NGC 1658',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36084,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',36084,34.36,NULL,74.5,9872,NULL,NULL,'I','NGC 1658',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36085,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36085,34.42,0.38,76.7,9872,NULL,NULL,NULL,'NGC 1658',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36086,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36086,34.46,0.2,78,9872,74.4,NULL,NULL,'NGC 1658',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36087,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36087,32.66,0.47,34,9873,NULL,NULL,'H','2MASX J04440903+2813003',NULL,'2007A&A...465...71T',2007,1,0.89,NULL,'G',0.00002,NULL,'12.6r',0.56,'S              Sy2',NULL,NULL,NULL,NULL,1,71.0375417,28.21686,1.797,NULL,64826434103,1012913032,15826766,12.6),(36088,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36088,32.66,0.45,34.1,9873,NULL,NULL,'K','2MASX J04440903+2813003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36089,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36089,32.78,0.46,35.9,9873,NULL,NULL,'J','2MASX J04440903+2813003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36090,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36090,33.17,0.4,43,9873,NULL,NULL,'mean','2MASX J04440903+2813003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36091,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36091,33.31,0.43,45.8,9873,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J04440903+2813003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36092,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36092,36.56,0.52,205,9874,70,NULL,NULL,'2MASX J04442253-1549259',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'17.31',0.26,NULL,NULL,NULL,NULL,NULL,1,71.0939166667,-15.82392,0.101,NULL,37536486701,586507604,9164181,17.31),(36093,'IRAS','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36093,32.65,0.8,33.9,9875,75,NULL,'A82, H','IC 0381',NULL,'1997ApJS..109..333W',1997,1,2.4,NULL,'G',0.00001,NULL,'13.08',1.3,'SAB(rs)bc',NULL,NULL,NULL,NULL,1,71.11875,75.63975,0.577,NULL,65686145421,1026346022,16036656,13.08),(36094,'Sosies','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36094,32.98,0.46,39.4,9875,NULL,NULL,NULL,'IC 0381',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36095,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36095,31.9,0.4,24,9875,NULL,NULL,'Virgo cluster at 15.6 Mpc','IC 0381',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36096,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36096,32.07,0.38,25.9,9875,NULL,NULL,NULL,'IC 0381',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36097,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36097,32.22,0.47,27.7,9875,75,NULL,'A82, H, raw','IC 0381',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36098,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36098,32.31,0.47,29,9875,75,NULL,'A82, H, inv','IC 0381',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36099,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36099,32.58,0.47,32.8,9875,75,NULL,'A82, H, cor','IC 0381',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36100,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36100,32.84,0.4,37,9875,75,NULL,'B','IC 0381',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36101,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36101,32.85,0.4,37.2,9875,NULL,NULL,'mean','IC 0381',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36102,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36102,33.04,0.45,40.6,9875,NULL,NULL,'K','IC 0381',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36103,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36103,33.08,0.46,41.3,9875,NULL,NULL,'J','IC 0381',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36104,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36104,33.08,0.47,41.3,9875,NULL,NULL,'H','IC 0381',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36105,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36105,36.44,0.54,194,9876,70,NULL,NULL,'2MASX J04443743-1555239',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00012,NULL,'16.07',0.39,NULL,NULL,NULL,NULL,NULL,1,71.155875,-15.92325,0.101,NULL,37536506569,586507915,9164186,16.07),(36106,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36106,34.21,0.43,69.4,9877,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03148',NULL,'2014MNRAS.444..527S',2014,1,1,NULL,'G',NULL,NULL,'16.5',0.5,'S',NULL,NULL,NULL,NULL,1,71.2565833333,18.61803,1.425,NULL,65271966066,1019874469,15935538,16.5),(36107,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36107,33.97,0.5,62.2,9878,70,NULL,NULL,'2MASX J04450285-2746224',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,71.261875,-27.77297,0,NULL,37245164867,581955701,9093057,14.3),(36108,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36108,36.14,0.66,169,9879,70,NULL,NULL,'2MASX J04450441-1608501',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'17.10',0.28,NULL,NULL,NULL,NULL,NULL,1,71.2682917,-16.14733,0.101,NULL,37536419222,586506550,9164164,17.1),(36109,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36109,35.97,0.61,156,9880,70,NULL,NULL,'2MASX J04450504-4422400',NULL,'2014MNRAS.445.2677S',2014,1,0.85,NULL,'G',0.00015,NULL,'15.41',0.55,'SBb',NULL,NULL,NULL,NULL,1,71.2710833333,-44.37783,0,NULL,37803699197,590682799,9229418,15.41),(36110,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36110,36.14,0.25,169,9881,74.4,NULL,NULL,'NGC 1650',NULL,'2013AJ....146...86T',2013,1,2.3,NULL,'G',0.000073,NULL,'13.84',1.3,'E+',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,71.2979583,-15.87003,0.101,NULL,37536473807,586507403,9164178,13.84),(36111,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36111,36.37,0.2,188,9881,70,NULL,NULL,'NGC 1650',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36112,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36112,35.78,0.49,143,9882,70,NULL,NULL,'MCG -03-13-002',NULL,'2014MNRAS.445.2677S',2014,1,0.99,NULL,'G',0.00009,NULL,'15.37',0.54,NULL,NULL,NULL,NULL,NULL,1,71.304625,-15.11431,0.125,NULL,37535926051,586498844,9164044,15.37),(36113,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36113,35.94,0.52,154,9883,70,NULL,NULL,'2MASX J04451370-1553151',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,71.3070417,-15.88758,0.101,NULL,37536473276,586507394,9164178,15.6),(36114,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36114,33.65,0.47,53.7,9884,NULL,NULL,'H','2MASX J04451775+4049326',NULL,'2007A&A...465...71T',2007,1,1.8,'abs(b) < 10 degrees.','G',0.00003,NULL,'10.2K',1,'Sbc',NULL,NULL,NULL,NULL,1,71.3240417,40.82567,NULL,NULL,68406329006,1068848890,16700763,10.2),(36115,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36115,33.71,0.45,55.3,9884,NULL,NULL,'K','2MASX J04451775+4049326',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36116,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36116,34.03,0.46,63.9,9884,NULL,NULL,'J','2MASX J04451775+4049326',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36117,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36117,34.15,0.4,67.6,9884,NULL,NULL,'mean','2MASX J04451775+4049326',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36118,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1995bd',NULL,36118,33.05,0.24,40.2,9885,74.2,NULL,'SALT 2','UGC 03151',0.0146,'2010ApJ...716..712A',2010,1,1.1,NULL,'G',0.000834,NULL,'16.5',0.25,'S',NULL,NULL,NULL,NULL,1,71.331833,11.06781,0.765,NULL,65348187485,1021065429,15954147,16.5),(36119,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1995bd',NULL,36119,33.67,0.08,54.2,9885,74.4,NULL,NULL,'UGC 03151',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36120,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1995bd',NULL,36120,33.75,0.19,55.4,9885,72,NULL,NULL,'UGC 03151',0.0146,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36121,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1995bd',NULL,36121,33.85,0.24,58,9885,70,NULL,'SALT','UGC 03151',0.0146,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36122,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1995bd',NULL,36122,33.93,0.08,60.1,9885,72,NULL,NULL,'UGC 03151',0.0146,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36123,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1995bd',NULL,36123,33.93,0.25,60.1,9885,65,NULL,'SALT2','UGC 03151',0.0146,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36124,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1995bd',NULL,36124,33.97,0.24,61.3,9885,65,NULL,'MLCS31','UGC 03151',0.0146,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36125,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1995bd',NULL,36125,34.01,0.13,61.5,9885,65,NULL,'MLCS2k2','UGC 03151',0.0146,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36126,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1995bd',NULL,36126,34,0.18,62.2,9885,65,NULL,'Template','UGC 03151',0.0146,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36127,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1995bd',NULL,36127,34.06,0.24,64,9885,65,NULL,'MLCS17','UGC 03151',0.0146,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36128,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1995bd',NULL,36128,34.08,0.14,64.6,9885,70,NULL,NULL,'UGC 03151',0.0146,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36129,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1995bd',NULL,36129,34.11,0.25,65.4,9885,65,NULL,NULL,'UGC 03151',0.0146,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36130,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1995bd',NULL,36130,34.15,0.19,66.6,9885,65,NULL,'MLCS','UGC 03151',0.0146,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36131,'SNIa','2016-12-15 15:14:04','2016-12-16 11:19:08','1','SN 1995bd',NULL,36131,34.17,0.17,68.2,9885,70.8,NULL,NULL,'UGC 03151',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36132,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',36132,33.84,0.49,58.6,9885,75,NULL,'IR','UGC 03151',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36133,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36133,33.92,0.46,60.9,9885,NULL,NULL,'J','UGC 03151',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36134,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36134,33.96,0.47,61.8,9885,NULL,NULL,'H','UGC 03151',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36135,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36135,34.05,0.45,64.4,9885,NULL,NULL,'K','UGC 03151',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36136,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36136,34.1,0.4,66.1,9885,NULL,NULL,'mean','UGC 03151',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36137,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36137,36.16,0.25,171,9886,74.4,NULL,NULL,'GIN 197',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00005,NULL,'14.23',0.4,'E/S0',NULL,NULL,NULL,NULL,1,71.340417,-15.79086,0.109,NULL,37566678151,586979346,9171552,14.23),(36138,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36138,36.37,0.2,188,9886,70,NULL,NULL,'GIN 197',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36139,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36139,35.96,0.63,156,9887,70,NULL,NULL,'2MASX J04452722-1740328',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'17.34',0.24,NULL,NULL,NULL,NULL,NULL,1,71.363375,-17.67583,0.077,NULL,37564397997,586943718,9170995,17.34),(36140,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36140,36.13,0.25,168,9888,74.4,NULL,NULL,'GIN 199',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000047,NULL,'14.65',0.4,'E/S0',NULL,NULL,NULL,NULL,1,71.3795417,-16.07108,0.101,NULL,37566708570,586979821,9171559,14.65),(36141,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36141,36.37,0.2,188,9888,70,NULL,NULL,'GIN 199',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36142,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36142,36.13,0.25,168,9889,74.4,NULL,NULL,'GIN 198',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00009,NULL,'14.33',0.5,'E/S0',NULL,NULL,NULL,NULL,1,71.396125,-16.02136,0.101,NULL,37566706545,586979789,9171559,14.33),(36143,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36143,36.37,0.2,188,9889,70,NULL,NULL,'GIN 198',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36144,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36144,35.62,0.5,133,9890,70,NULL,NULL,'2MASX J04453596-1606058',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00009,NULL,'16.72',0.26,NULL,NULL,NULL,NULL,NULL,1,71.399875,-16.10161,0.097,NULL,37566768184,586980752,9171574,16.72),(36145,'Tully est','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36145,30.81,0.8,14.5,9891,75,NULL,'B','NGC 1672',NULL,'1988NBGC.C....0000T',1988,1,6.6,'Incorrectly identified as NGC 1622 in PKSCAT90 (version 1.01).','G',0.00001,NULL,'10.28',5.5,'(R\'_1:)SB(r)bc Sy2','Possible group member',NULL,NULL,'Sy',1,71.427083,-59.24719,0,NULL,35915848618,561185134,8768517,10.28),(36146,'SBF','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36146,33.63,0.26,53.2,9892,NULL,NULL,NULL,'NGC 1653',NULL,'2001MNRAS.327.1004B',2001,1,1.5,NULL,'G',0.000047,NULL,'12.93',1.5,'E+:',NULL,NULL,NULL,NULL,1,71.4472917,-2.39283,0.125,NULL,36590559032,571727484,8933241,12.93),(36147,'SBF','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36147,33.82,0.26,57.9,9892,NULL,NULL,'Malmquist cor.','NGC 1653',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36148,'D-Sigma','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36148,32.64,0.4,33.7,9892,75,NULL,'Edat, raw','NGC 1653',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36149,'D-Sigma','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36149,33.01,0.4,40,9892,75,NULL,'Edat, cor','NGC 1653',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36150,'Faber-Jackson','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36150,31.72,0.62,22.1,9892,95,NULL,'Weighted Mean','NGC 1653',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36151,'Faber-Jackson','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36151,31.72,0.62,22.1,9892,95,NULL,'de Vaucouleurs','NGC 1653',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36152,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36152,33.54,0.41,51,9892,NULL,NULL,NULL,'NGC 1653',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36153,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36153,33.88,0.41,59.7,9892,NULL,NULL,'Malmquist cor.','NGC 1653',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36154,'Tertiary','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36154,32.69,0.35,34.5,9892,95,NULL,NULL,'NGC 1653',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36155,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36155,33.94,0.4,61.5,9892,NULL,NULL,'mean','NGC 1653',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36156,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36156,34.23,0.45,70,9892,NULL,NULL,'K','NGC 1653',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36157,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36157,35.63,0.52,134,9893,70,NULL,NULL,'ESO 552- G 001',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000103,NULL,'15.5',0.5,'Sa:',NULL,NULL,NULL,NULL,1,71.456083,-21.66019,0.029,NULL,37342858375,583482162,9116908,15.5),(36158,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36158,33.34,0.51,46.7,9894,70,NULL,NULL,'NGC 1656',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000073,NULL,'13.55',1,'S0+ pec:',NULL,NULL,NULL,NULL,1,71.4724583,-5.13672,0.121,NULL,37455922618,585248790,9144512,13.55),(36159,'IRAS','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36159,33.27,0.8,45,9895,75,NULL,'MAT, I','MCG -03-13-004',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.00001,NULL,'13.6b',1.3,'SB(rs)bc pec:',NULL,NULL,NULL,NULL,1,71.474125,-17.27892,0.057,NULL,37565075322,586954301,9171160,13.6),(36160,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36160,32.08,0.32,26.1,9895,85,NULL,'I, inv','MCG -03-13-004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36161,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36161,32.09,0.32,26.2,9895,85,NULL,'I, raw','MCG -03-13-004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36162,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36162,32.34,0.43,29.3,9895,75,NULL,'MAT, I, raw','MCG -03-13-004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36163,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36163,32.37,0.43,29.8,9895,75,NULL,'MAT, I, inv','MCG -03-13-004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36164,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36164,32.63,0.43,33.5,9895,75,NULL,'MAT, I, cor','MCG -03-13-004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36165,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36165,32.95,0.2,38.9,9895,74.4,NULL,NULL,'MCG -03-13-004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36166,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36166,34,0.47,63.1,9896,NULL,NULL,'H','MRK 1085',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000017,NULL,'16.0',0.4,'Sa/b?          HII',NULL,NULL,NULL,NULL,1,71.511125,-12.44208,0.277,NULL,37539925458,586561335,9165020,16),(36167,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36167,34.12,0.45,66.6,9896,NULL,NULL,'K','MRK 1085',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36168,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36168,34.14,0.46,67.2,9896,NULL,NULL,'J','MRK 1085',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36169,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36169,34.25,0.4,70.8,9896,NULL,NULL,'mean','MRK 1085',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36170,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36170,35.02,0.57,101,9897,70,NULL,NULL,'ESO 552- G 003',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000113,NULL,'14.73',1,'SA(rs)0/a',NULL,NULL,NULL,NULL,1,71.519625,-22.36481,0.033,NULL,37340564056,583446313,9116348,14.73),(36171,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36171,34.73,0.52,88.2,9898,70,NULL,NULL,'MCG -03-13-005',NULL,'2014MNRAS.445.2677S',2014,1,1.1,'The APM image includes a neighboring star.','G',0.00008,NULL,'15.07',0.4,NULL,NULL,NULL,NULL,NULL,1,71.532917,-17.06397,0.061,NULL,37564912551,586951758,9171121,15.07),(36172,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36172,37.54,0.74,322,9899,70,NULL,NULL,'2MASX J04461220-1437032',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00012,NULL,'16.19',0.52,NULL,NULL,NULL,NULL,NULL,1,71.550875,-14.61756,0.205,NULL,37573660506,587088445,9173256,16.19),(36173,'Tully est','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36173,30.62,0.8,13.3,9900,75,NULL,NULL,'ESO 158- G 003',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.0001,NULL,'13.84',1.5,'(R\')SB(rs)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,71.572,-57.34378,0,NULL,35960993648,561890525,8779539,13.84),(36174,'IRAS','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36174,31.11,0.8,16.6,9901,75,NULL,'A82, H','UGC 03137',NULL,'1997ApJS..109..333W',1997,1,4.59,'The 2MASS position is 9 arcsec southwest of the center of the optical bulge.','G',0.000005,NULL,'15.1',0.63,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,71.57075,76.41889,0.541,NULL,65685162534,1026330664,16036416,15.1),(36175,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36175,31.27,0.4,17.9,9901,75,NULL,'B','UGC 03137',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36176,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36176,31.49,NULL,19.9,9901,NULL,NULL,'Dipole','UGC 03137',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36177,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36177,31.5,NULL,20,9901,NULL,NULL,'Dipole + Quadrupole','UGC 03137',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36178,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36178,31.51,NULL,20,9901,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03137',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36179,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36179,31.61,0.38,21,9901,NULL,NULL,NULL,'UGC 03137',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36180,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36180,31.62,NULL,21.1,9901,NULL,NULL,NULL,'UGC 03137',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36181,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36181,31.7,0.47,21.9,9901,75,NULL,'A82, H, inv','UGC 03137',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36182,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36182,31.75,0.2,22.4,9901,74.4,NULL,NULL,'UGC 03137',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36183,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36183,31.77,0.47,22.5,9901,75,NULL,'A82, H, raw','UGC 03137',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36184,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36184,31.82,0.43,23.1,9901,75,NULL,'3.6 micron, color corrected','UGC 03137',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36185,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36185,31.84,0.43,23.4,9901,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03137',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36186,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36186,32.11,0.47,26.4,9901,75,NULL,'A82, H, cor','UGC 03137',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36187,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36187,36.43,0.55,193,9902,70,NULL,NULL,'2MASX J04462093-4348552',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.000077,NULL,'16.25',0.43,'E',NULL,NULL,NULL,NULL,1,71.5872917,-43.81542,0,NULL,37833478948,591148108,9236689,16.25),(36188,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36188,35.6,0.51,132,9903,70,NULL,NULL,'2MASX J04462807-1641418',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00008,NULL,'16.69',0.21,NULL,NULL,NULL,NULL,NULL,1,71.6169583,-16.69489,0.069,NULL,37567833010,586997390,9171834,16.69),(36189,'Ring Diameter','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36189,31.6,0.84,21,9904,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 1659',NULL,'1981ApJS...45..541P',1981,1,1.6,NULL,'G',0.000057,NULL,'13.14',1.1,'SA(r)bc pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,71.6247917,-4.78878,0.125,NULL,37455631368,585244240,9144441,13.14),(36190,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36190,33.78,0.45,56.9,9904,NULL,NULL,'K','NGC 1659',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36191,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36191,33.79,0.47,57.3,9904,NULL,NULL,'H','NGC 1659',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36192,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36192,33.82,0.46,58.2,9904,NULL,NULL,'J','NGC 1659',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36193,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36193,33.96,0.2,61.9,9904,74.4,NULL,NULL,'NGC 1659',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36194,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36194,33.96,0.4,62,9904,NULL,NULL,'mean','NGC 1659',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36195,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36195,34,0.28,63.2,9904,NULL,NULL,'Malmquist cor.','NGC 1659',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36196,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36196,34.07,0.28,65.2,9904,NULL,NULL,NULL,'NGC 1659',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36197,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',36197,33.97,0.49,62.2,9905,75,NULL,'IR','UGC 03143',NULL,'2011yCatp016004901K',2011,1,1.79,NULL,'G',0.000037,NULL,'17.',0.19,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,71.6487917,70.12064,0.549,NULL,66431988581,1037999821,16218747,17),(36198,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36198,34.1,NULL,65.9,9905,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03143',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36199,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36199,34.1,NULL,66.1,9905,NULL,NULL,'Dipole + Quadrupole','UGC 03143',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36200,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36200,34.1,0.43,66.1,9905,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03143',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36201,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36201,34.11,NULL,66.3,9905,NULL,NULL,'Dipole','UGC 03143',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36202,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36202,34.16,NULL,67.9,9905,NULL,NULL,NULL,'UGC 03143',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36203,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36203,34.26,0.43,71,9905,75,NULL,'3.6 micron, color corrected','UGC 03143',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36204,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36204,34.29,0.2,72.1,9905,74.4,NULL,NULL,'UGC 03143',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36205,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36205,34.31,0.35,72.7,9905,NULL,NULL,'Malmquist cor.','UGC 03143',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36206,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36206,34.32,0.35,73.1,9905,NULL,NULL,NULL,'UGC 03143',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36207,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',36207,35.39,0.49,120,9906,75,NULL,'IR','UGC 03161',NULL,'2011yCatp016004901K',2011,1,1.57,NULL,'G',0.000018,NULL,'16.5',0.13,'Sc',NULL,NULL,NULL,NULL,1,71.6555416667,0.62092,0.321,NULL,64565360034,1008833750,15763027,16.5),(36208,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36208,35.6,NULL,132,9906,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03161',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36209,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36209,35.62,NULL,133,9906,NULL,NULL,'Dipole + Quadrupole','UGC 03161',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36210,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36210,35.62,NULL,133,9906,NULL,NULL,'Dipole','UGC 03161',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36211,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36211,35.67,NULL,136,9906,NULL,NULL,NULL,'UGC 03161',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36212,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36212,36.47,0.43,197,9906,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03161',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36213,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36213,36.14,0.25,169,9907,74.4,NULL,NULL,'GIN 205',NULL,'2013AJ....146...86T',2013,1,0.56,NULL,'G',0.000117,NULL,'14.71',0.3,'S',NULL,NULL,NULL,NULL,1,71.657667,-16.30433,0.089,NULL,37566779999,586980937,9171577,14.71),(36214,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36214,36.37,0.2,188,9907,70,NULL,NULL,'GIN 205',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36215,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36215,35.63,0.65,133,9908,70,NULL,NULL,'2MASX J04464087-1629218',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.000083,NULL,'16.64',0.31,NULL,NULL,NULL,NULL,NULL,1,71.670333,-16.48942,0.089,NULL,37567742868,586995982,9171812,16.64),(36216,'IRAS','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36216,34.78,0.8,90.4,9909,75,NULL,'MAT, I','ESO 085- G 002',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.91',0.4,'SB(s)d pec:',NULL,NULL,NULL,NULL,1,71.6899166667,-63.03125,0.005,NULL,35886319767,560723746,8761308,14.91),(36217,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36217,34.64,0.32,84.9,9909,85,NULL,'I, raw','ESO 085- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36218,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36218,34.7,0.32,87,9909,85,NULL,'I, inv','ESO 085- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36219,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36219,34.71,0.43,87.5,9909,75,NULL,'MAT, I, raw','ESO 085- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36220,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36220,34.95,0.43,97.6,9909,75,NULL,'MAT, I, inv','ESO 085- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36221,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36221,34.96,0.58,98,9909,NULL,NULL,'Malmquist cor.','ESO 085- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36222,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36222,34.96,0.43,98.3,9909,75,NULL,'MAT, I, cor','ESO 085- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36223,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36223,35.18,0.4,109,9909,NULL,NULL,'mean','ESO 085- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36224,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36224,35.25,0.5,112,9909,NULL,NULL,NULL,'ESO 085- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36225,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36225,35.3,0.2,115,9909,74.4,NULL,NULL,'ESO 085- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36226,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36226,35.39,0.47,120,9909,NULL,NULL,'H','ESO 085- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36227,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36227,36.14,0.25,169,9910,74.4,NULL,NULL,'GIN 204',NULL,'2013AJ....146...86T',2013,1,0.51,NULL,'G',0.000057,NULL,'15.11',0.42,'S',NULL,NULL,NULL,NULL,1,71.715667,-16.33539,0.089,NULL,37566654750,586978980,9171546,15.11),(36228,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36228,36.37,0.2,188,9910,70,NULL,NULL,'GIN 204',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36229,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36229,33.75,0.2,56.2,9911,74.4,NULL,NULL,'UGC 03162',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000033,NULL,'16.0',0.7,'Scd?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,71.717875,8.27094,0.481,NULL,65361073052,1021266766,15957293,16),(36230,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36230,33.9,0.28,60.2,9911,NULL,NULL,NULL,'UGC 03162',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36231,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36231,34.01,0.26,63.3,9911,NULL,NULL,'Malmquist cor.','UGC 03162',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36232,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36232,37.59,0.55,330,9912,70,NULL,NULL,'2MASX J04465265-3915026',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000103,NULL,'16.59',0.41,NULL,NULL,NULL,NULL,NULL,1,71.7195,-39.25075,0,NULL,37832171079,591127673,9236369,16.59),(36233,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36233,37.1,0.82,263,9913,70,NULL,NULL,'2MASX J04465483-1314103',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'17.92',0.22,NULL,NULL,NULL,NULL,NULL,1,71.7284583333,-13.23619,0.345,NULL,37572845837,587075716,9173058,17.92),(36234,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36234,36.13,0.25,168,9914,74.4,NULL,NULL,'GIN 203',NULL,'2013AJ....146...86T',2013,1,0.47,NULL,'G',0.000063,NULL,'14.32',0.41,'E/S0',NULL,NULL,NULL,NULL,1,71.732917,-16.43758,0.089,NULL,37566659578,586979055,9171547,14.32),(36235,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36235,36.37,0.2,188,9914,70,NULL,NULL,'GIN 203',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36236,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36236,35.97,0.5,157,9915,70,NULL,NULL,'MCG -02-13-005',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00009,NULL,'14.94',0.3,NULL,NULL,NULL,NULL,NULL,1,71.735833,-14.86014,0.133,NULL,37573656218,587088378,9173255,14.94),(36237,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36237,34.21,0.49,69.6,9916,70,NULL,NULL,'2MASX J04465670-0558570',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000073,NULL,'15.52',NULL,NULL,NULL,NULL,NULL,NULL,1,71.7362083333,-5.98275,0.217,NULL,37501757595,585964962,9155702,15.52),(36238,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36238,35.35,0.57,118,9917,70,NULL,NULL,'MCG -03-13-008',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000043,NULL,'15.1b',0.2,'SB(r)ab',NULL,NULL,NULL,NULL,1,71.7422917,-16.47269,0.089,NULL,37567744008,586996000,9171812,15.1),(36239,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36239,37.13,0.68,267,9918,70,NULL,NULL,'2MASX J04470295-1448413',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'17.26',0.17,NULL,NULL,NULL,NULL,NULL,1,71.762333,-14.81144,0.133,NULL,37573647302,587088239,9173253,17.26),(36240,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36240,34.9,0.25,95.5,9919,74.4,NULL,NULL,'GIN 224',NULL,'2013AJ....146...86T',2013,1,0.62,NULL,'G',0.000057,NULL,'14.76',0.47,'S',NULL,NULL,NULL,NULL,1,71.7667917,-17.34919,0.065,NULL,37565038316,586953723,9171151,14.76),(36241,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36241,35.09,0.36,104,9919,70,NULL,NULL,'GIN 224',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36242,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36242,34.68,0.69,86.3,9920,100,NULL,'mid-IR','NGC 1661',NULL,'2013ApJ...771...88L',2013,1,1.4,NULL,'G',0.000013,NULL,'14.04',0.9,'SA(s)bc pec:',NULL,NULL,NULL,NULL,1,71.781833,-2.05458,0.125,NULL,36587292823,571676450,8932444,14.04),(36243,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36243,35.57,0.4,130,9920,NULL,NULL,'mean','NGC 1661',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36244,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36244,35.57,0.47,130,9920,NULL,NULL,'H','NGC 1661',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36245,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36245,35.7,0.46,138,9920,NULL,NULL,'J','NGC 1661',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36246,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36246,34.05,0.4,64.6,9921,NULL,NULL,'mean','UGC 03149',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000037,NULL,'14.4',0.9,'S?',NULL,NULL,NULL,NULL,1,71.7975,66.05439,1.169,NULL,66408767806,1037636996,16213078,14.4),(36247,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36247,34.07,0.47,65.2,9921,NULL,NULL,'H','UGC 03149',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36248,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36248,34.08,0.45,65.6,9921,NULL,NULL,'K','UGC 03149',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36249,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36249,34.1,0.46,66,9921,NULL,NULL,'J','UGC 03149',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36250,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36250,36.37,0.2,188,9922,70,NULL,NULL,'GIN 202',NULL,'2001MNRAS.321..277C',2001,1,0.65,NULL,'G',0.000073,NULL,'14.49',0.52,'E/S0',NULL,NULL,NULL,NULL,1,71.805833,-15.92314,0.117,NULL,37567327435,586989491,9171710,14.49),(36251,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36251,36.3,0.53,182,9923,70,NULL,NULL,'2MASX J04471710-1705443',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'16.34',0.33,NULL,NULL,NULL,NULL,NULL,1,71.8212917,-17.09578,0.057,NULL,37567669937,586994842,9171794,16.34),(36252,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36252,37.4,0.64,302,9924,70,NULL,NULL,'2MASX J04473372-3153478',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000103,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,71.8905,-31.89661,0,NULL,37204605359,581321958,9083155,14.5),(36253,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36253,34.9,0.25,95.5,9925,74.4,NULL,NULL,'MCG -03-13-010',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.00006,NULL,'14.56',0.7,'S',NULL,NULL,NULL,NULL,1,71.8924583333,-17.34708,0.065,NULL,37564983094,586952860,9171138,14.56),(36254,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36254,35.09,0.36,104,9925,70,NULL,NULL,'MCG -03-13-010',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36255,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',36255,35.16,0.49,107,9926,75,NULL,'IR','UGC 03169',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000027,NULL,'17.',0.2,'Scd:',NULL,NULL,NULL,NULL,1,71.9370417,9.59553,0.649,NULL,65349783322,1021090364,15954536,17),(36256,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36256,34.77,0.98,89.9,9927,NULL,NULL,'Malmquist cor.','UGC 03171',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.78',0.9,'SBcd:','Isolated galaxy',NULL,NULL,NULL,1,71.9389583,1.81928,0.357,NULL,64572067205,1008938550,15764664,14.78),(36257,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36257,35.53,0.69,128,9927,NULL,NULL,NULL,'UGC 03171',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36258,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36258,36.51,0.63,201,9928,70,NULL,NULL,'2MASX J04474890-2652113',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.26',0.4,'S',NULL,NULL,NULL,NULL,1,71.9538333333,-26.86978,0,NULL,37235533059,581805204,9090706,16.26),(36259,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36259,32.91,0.43,38.1,9929,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03147',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.000027,NULL,'14.69',0.6,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,71.957375,72.86006,0.473,NULL,65687705565,1026370399,16037037,14.69),(36260,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36260,33.14,0.4,42.4,9929,NULL,NULL,'mean','UGC 03147',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36261,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36261,33.57,0.46,51.8,9929,NULL,NULL,'J','UGC 03147',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36262,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36262,33.58,0.47,52,9929,NULL,NULL,'H','UGC 03147',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36263,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36263,33.66,0.45,53.9,9929,NULL,NULL,'K','UGC 03147',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36264,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',36264,33.57,0.49,51.9,9930,75,NULL,'IR','ESO 085- G 004',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000033,NULL,'14.85',0.3,'(R:)SAB:(r)a:',NULL,NULL,NULL,NULL,1,71.958333,-62.61106,0,NULL,35884025035,560687891,8760748,14.85),(36265,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36265,34.01,0.34,63.3,9930,NULL,NULL,NULL,'ESO 085- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36266,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36266,34.05,0.2,64.6,9930,74.4,NULL,NULL,'ESO 085- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36267,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36267,34.19,0.31,68.8,9930,NULL,NULL,'Malmquist cor.','ESO 085- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36268,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36268,34.34,0.4,73.9,9930,NULL,NULL,'mean','ESO 085- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36269,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36269,34.37,0.47,74.7,9930,NULL,NULL,'H','ESO 085- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36270,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36270,34.47,0.45,78.3,9930,NULL,NULL,'K','ESO 085- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36271,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36271,34.51,0.46,79.9,9930,NULL,NULL,'J','ESO 085- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36272,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36272,36.15,0.25,170,9931,74.4,NULL,NULL,'IC 0393',NULL,'2013AJ....146...86T',2013,1,0.25,NULL,'G',0.000063,NULL,'13.61',0.25,'E/S0',NULL,NULL,NULL,NULL,1,71.965833,-15.52519,0.117,NULL,37566475647,586976181,9171502,13.61),(36273,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36273,36.37,0.2,188,9931,70,NULL,NULL,'IC 0393',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36274,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36274,31.4,0.2,19.1,9932,74.4,NULL,NULL,'UGC 03144',NULL,'2013AJ....146...86T',2013,1,1.9,NULL,'G',0.00002,NULL,'15.0',0.8,'IBm','Dwarf, possible member',NULL,NULL,NULL,1,71.98,74.92889,0.557,NULL,65698249874,1026535154,16039611,15),(36275,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36275,31.47,0.4,19.7,9932,NULL,NULL,NULL,'UGC 03144',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36276,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36276,32.08,0.4,26.1,9932,75,NULL,'B','UGC 03144',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36277,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36277,34.91,0.25,95.9,9933,74.4,NULL,NULL,'GIN 227',NULL,'2013AJ....146...86T',2013,1,0.79,NULL,'G',0.00006,NULL,'15.68',0.68,'S',NULL,NULL,NULL,NULL,1,71.999833,-16.66411,0.081,NULL,37567763453,586996303,9171817,15.68),(36278,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36278,35.09,0.36,104,9933,70,NULL,NULL,'GIN 227',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36279,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',36279,34.12,0.49,66.7,9934,75,NULL,'IR','UGC 03172',NULL,'2011yCatp016004901K',2011,1,1.9,'Matthews (2000A&AS..143..421M) detects another feature at v=1492 km/sec.','G',0.000013,NULL,'16.5',0.15,'Sd',NULL,NULL,NULL,NULL,1,72.000375,8.71169,0.509,NULL,65361130710,1021267667,15957307,16.5),(36280,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36280,34.17,0.43,68.4,9934,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03172',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36281,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36281,34.52,NULL,80.2,9934,NULL,NULL,'Dipole','UGC 03172',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36282,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36282,34.52,NULL,80.3,9934,NULL,NULL,'Dipole + Quadrupole','UGC 03172',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36283,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36283,34.52,NULL,80.3,9934,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03172',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36284,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36284,34.55,NULL,81.4,9934,NULL,NULL,NULL,'UGC 03172',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36285,'IRAS','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36285,33.92,0.8,60.8,9935,75,NULL,'MAT, I','ESO 485- G 012',NULL,'1997ApJS..109..333W',1997,1,2.41,NULL,'G',0.000023,NULL,'14.92',0.31,'Scd',NULL,NULL,NULL,NULL,1,72.0135,-25.23025,0,NULL,37219812448,581559569,9086868,14.92),(36286,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36286,33.67,0.43,54.3,9935,75,NULL,'MAT, I, raw','ESO 485- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36287,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36287,33.71,0.32,55.1,9935,85,NULL,'I, raw','ESO 485- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36288,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36288,33.74,0.32,55.9,9935,85,NULL,'I, inv','ESO 485- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36289,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36289,33.84,0.43,58.5,9935,75,NULL,'MAT, I, inv','ESO 485- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36290,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36290,33.92,0.43,60.7,9935,75,NULL,'MAT, I, cor','ESO 485- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36291,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',36291,34.02,0.49,63.6,9935,75,NULL,'IR','ESO 485- G 012',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36292,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36292,34.04,0.2,64.3,9935,74.4,NULL,NULL,'ESO 485- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36293,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36293,34.05,0.44,64.7,9935,NULL,NULL,'Malmquist cor.','ESO 485- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36294,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36294,34.08,0.4,65.4,9935,NULL,NULL,'mean','ESO 485- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36295,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36295,34.11,0.47,66.3,9935,NULL,NULL,'H','ESO 485- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36296,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36296,34.14,0.42,67.3,9935,NULL,NULL,NULL,'ESO 485- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36297,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36297,34.19,0.45,69,9935,NULL,NULL,'K','ESO 485- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36298,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36298,34.28,NULL,71.9,9935,NULL,NULL,NULL,'ESO 485- G 012',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36299,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36299,34.29,0.46,72,9935,NULL,NULL,'J','ESO 485- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36300,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36300,34.48,NULL,78.5,9935,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 485- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36301,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36301,34.48,NULL,78.8,9935,NULL,NULL,'Dipole','ESO 485- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36302,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36302,34.49,NULL,78.9,9935,NULL,NULL,'Dipole + Quadrupole','ESO 485- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36303,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36303,36.95,0.57,245,9936,70,NULL,NULL,'2MASX J04480467-1426055',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.18',0.48,NULL,NULL,NULL,NULL,NULL,1,72.019417,-14.43481,0.205,NULL,37574619571,587103430,9173491,16.18),(36304,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36304,34.84,0.54,92.8,9937,70,NULL,NULL,'2MASX J04480557-1339525',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'16.05',0.27,NULL,NULL,NULL,NULL,NULL,1,72.0232917,-13.66478,0.261,NULL,37576262940,587129108,9173892,16.05),(36305,'BCG','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36305,37.89,0.35,354,9938,60,NULL,NULL,'ABELL 0514',0.0697,'1980ApJ...241..486H',1980,1,NULL,'Katgert (1996,A&A,310,8) identifies multiple redshift systems in this cluster.','GClstr',NULL,NULL,NULL,NULL,'II-III:[BM]',NULL,NULL,NULL,NULL,1,72.050833,-20.46972,0.049,NULL,37336850597,583388290,9115442,NULL),(36306,'Magnitude','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36306,36.08,0.13,164,9938,100,NULL,NULL,'ABELL 0514',NULL,'1998A&A...337...31R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36307,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36307,36.01,0.71,159,9939,70,NULL,NULL,'2MASX J04481883-1543315',NULL,'2014MNRAS.445.2677S',2014,1,0.74,NULL,'G',0.000127,NULL,'16.64',0.22,NULL,NULL,NULL,NULL,NULL,1,72.0785,-15.72539,0.149,NULL,37567150406,586986725,9171667,16.64),(36308,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36308,35.44,0.56,123,9940,70,NULL,NULL,'2MASX J04482110-0629254',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.97',NULL,NULL,NULL,NULL,NULL,NULL,1,72.0880417,-6.49036,0.221,NULL,37502064354,585969755,9155777,15.97),(36309,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36309,34.81,0.59,91.6,9941,70,NULL,NULL,'2MASX J04482122-0515075',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.04',NULL,NULL,NULL,NULL,NULL,NULL,1,72.0885417,-5.25222,0.153,NULL,37456090894,585251420,9144553,16.04),(36310,'IRAS','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36310,31.1,0.8,16.6,9942,75,NULL,'MAT, I','NGC 1688',NULL,'1997ApJS..109..333W',1997,1,2.4,NULL,'G',0.000019,NULL,'12.57',1.9,'SB(rs)dm','Possible group member',NULL,NULL,NULL,1,72.099125,-59.80033,0,NULL,35909460041,561085313,8766958,12.57),(36311,'Tully est','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36311,30.65,0.8,13.5,9942,75,NULL,'B','NGC 1688',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36312,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36312,30.11,0.32,10.5,9942,85,NULL,'I, inv','NGC 1688',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36313,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36313,30.13,0.32,10.6,9942,85,NULL,'I, raw','NGC 1688',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36314,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36314,30.3,0.4,11.5,9942,NULL,NULL,NULL,'NGC 1688',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36315,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36315,30.3,0.4,11.5,9942,73,NULL,'opt','NGC 1688',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36316,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36316,30.45,0.43,12.3,9942,75,NULL,'MAT, I, inv','NGC 1688',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36317,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36317,30.47,0.43,12.4,9942,75,NULL,'MAT, I, raw','NGC 1688',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36318,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36318,30.76,0.43,14.2,9942,75,NULL,'MAT, I, cor','NGC 1688',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36319,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36319,31.28,0.4,18.1,9942,NULL,NULL,'mean','NGC 1688',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36320,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36320,31.32,0.45,18.4,9942,NULL,NULL,'K','NGC 1688',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36321,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36321,31.35,0.46,18.6,9942,NULL,NULL,'J','NGC 1688',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36322,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36322,31.38,0.47,18.9,9942,NULL,NULL,'H','NGC 1688',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36323,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36323,35.86,0.7,148,9943,70,NULL,NULL,'IC 2094',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.8b',0.3,NULL,NULL,NULL,NULL,NULL,1,72.1034583,-5.35264,0.153,NULL,37456088652,585251385,9144552,15.8),(36324,'BCG','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36324,37.89,0.35,354,9944,60,NULL,'ABELL 0514, BCG','2MASX J04482511-2025028',0.0697,'1980ApJ...241..486H',1980,1,0.29,NULL,'G',0.00019,NULL,'16.82',0.12,'S0','Brightest group member',NULL,NULL,NULL,1,72.104583,-20.4175,0.049,NULL,37336763167,583386924,9115420,16.82),(36325,'Magnitude','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36325,36.08,0.13,164,9944,100,NULL,NULL,'2MASX J04482511-2025028',NULL,'1998A&A...337...31R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36326,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,'R',36326,34.7,0.49,87,9945,75,NULL,'IR','ESO 485- G 015',NULL,'2011yCatp016004901K',2011,1,1.6,NULL,'G',0.000017,NULL,'15.68',0.3,'Sb:',NULL,NULL,NULL,NULL,1,72.1302917,-23.92331,0,NULL,37339509150,583429830,9116091,15.68),(36327,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36327,35.33,0.41,116,9945,NULL,NULL,NULL,'ESO 485- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36328,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36328,35.37,0.2,119,9945,74.4,NULL,NULL,'ESO 485- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36329,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36329,35.56,0.37,129,9945,NULL,NULL,'Malmquist cor.','ESO 485- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36330,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36330,29.58,0.4,8.2,9946,75,NULL,'B','UGC 03174',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000018,NULL,'14.4',1.1,'IAB(s)m:',NULL,NULL,NULL,NULL,1,72.14375,0.24167,0.309,NULL,64563694197,1008807721,15762620,14.4),(36331,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36331,35.49,0.48,125,9947,70,NULL,NULL,'2MASX J04483593-1246256',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.000097,NULL,'16.20',0.59,NULL,NULL,NULL,NULL,NULL,1,72.149833,-12.77383,0.369,NULL,37573542623,587086603,9173228,16.2),(36332,'Ring Diameter','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36332,34.7,0.84,86,9948,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 1667',NULL,'1981ApJS...45..541P',1981,1,1.8,NULL,'G',0.000057,NULL,'12.77',1.4,'SAB(r)c        Sy2','in a pair',NULL,NULL,'Sy 2',1,72.15475,-6.31997,0.221,NULL,37502276375,585973068,9155829,12.77),(36333,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36333,33.08,0.45,41.2,9948,NULL,NULL,'K','NGC 1667',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36334,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36334,33.11,0.47,41.8,9948,NULL,NULL,'H','NGC 1667',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36335,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36335,33.17,0.46,43.1,9948,NULL,NULL,'J','NGC 1667',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36336,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36336,33.96,0.4,61.9,9948,NULL,NULL,'mean','NGC 1667',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36337,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36337,33.04,NULL,40.5,9949,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 2095',NULL,'2010Ap&SS.325..163P',2010,1,1.51,NULL,'G',0.000033,NULL,'15.5',0.12,'Scd pec sp',NULL,NULL,NULL,NULL,1,72.190125,-5.12481,0.153,NULL,37455201735,585237527,9144336,15.5),(36338,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36338,33.04,NULL,40.6,9949,NULL,NULL,'Dipole','IC 2095',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36339,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36339,33.05,NULL,40.7,9949,NULL,NULL,'Dipole + Quadrupole','IC 2095',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36340,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36340,34.67,0.46,85.8,9950,70,NULL,NULL,'MCG -02-13-010',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000097,NULL,'14.59',0.64,NULL,NULL,NULL,NULL,NULL,1,72.198875,-14.37889,0.133,NULL,37574630902,587103607,9173493,14.59),(36341,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36341,37.06,0.7,258,9951,70,NULL,NULL,'GALEXASC J044849.04-370928.1',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'16.37',0.32,'S0',NULL,NULL,NULL,NULL,1,72.2039583,-37.15675,0,NULL,37817246688,590894479,9232726,16.37),(36342,'FP','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36342,35.83,0.5,147,9952,70,NULL,NULL,'GALEXASC J044854.18-265054.1',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'16.03',0.43,'S0',NULL,NULL,NULL,NULL,1,72.2257083333,-26.84797,0,NULL,37235070352,581797974,9090593,16.03),(36343,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:08','1',NULL,NULL,36343,34.41,0.69,76.1,9953,100,NULL,'mid-IR','ESO 485-G 016',NULL,'2013ApJ...771...88L',2013,1,1.3,NULL,'G',0.000033,NULL,'15.25',0.5,'SAB(rs)ab:',NULL,NULL,NULL,NULL,1,72.233167,-23.72986,0.021,NULL,37339467101,583429173,9116080,15.25),(36344,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36344,37.13,0.57,266,9954,70,NULL,NULL,'2MASX J04490127-0649348',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,72.255333,-6.82639,0.169,NULL,37501945150,585967892,9155748,14.3),(36345,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36345,31.15,0.4,17,9955,75,NULL,'B','UGCA 095',NULL,'1988NBGC.C....0000T',1988,1,2.7,NULL,'G',0.000013,NULL,'13.1',2.4,'SAB(s)m:',NULL,NULL,NULL,NULL,1,72.3015833333,-29.20711,0,NULL,37242523675,581914432,9092413,13.1),(36346,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36346,31.25,0.43,17.8,9955,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 095',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36347,'BL Lac Luminosity','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36347,39.15,NULL,675,9956,71,NULL,'Min. z = 0.175','PKS 0447-439',NULL,'2014A&A...565A..12P',2013,1,NULL,'Perlman, et al. (1998,AJ,115,1253) give z = 0.205.','G',NULL,NULL,'14.4R',NULL,'Sy1            BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,72.352875,-43.83581,0,NULL,37803287776,590676371,9229318,14.4),(36348,'BL Lac Luminosity','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36348,40.72,NULL,1390,9956,NULL,NULL,'Photo z = 0.4','PKS 0447-439',NULL,'2013A&A...552A.118H',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36349,'GeV TeV ratio','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36349,39,0.76,631,9956,70,NULL,'z = 0.16 +/- 0.05, LP case','PKS 0447-439',NULL,'2014PASJ...66...12Z',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36350,'GeV TeV ratio','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36350,39.12,0.54,667,9956,70,NULL,'z = 0.17 +/- 0.04, BPL case','PKS 0447-439',NULL,'2014PASJ...66...12Z',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36351,'GeV TeV ratio','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36351,39.44,0.43,772,9956,NULL,NULL,NULL,'PKS 0447-439',NULL,'2012A&A...543A.111P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36352,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36352,33.76,0.45,56.4,9957,NULL,NULL,'K','UGC 03167',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000023,NULL,'17.',0.2,'Sbc',NULL,NULL,NULL,NULL,1,72.365917,63.92519,1.569,NULL,66128719086,1033261235,16144706,17),(36353,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36353,33.84,0.47,58.7,9957,NULL,NULL,'H','UGC 03167',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36354,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36354,33.97,0.43,62.4,9957,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03167',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36355,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,'R',36355,34.02,0.49,63.6,9957,75,NULL,'IR','UGC 03167',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36356,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36356,34.1,0.4,66,9957,NULL,NULL,'mean','UGC 03167',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36357,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36357,34.15,0.46,67.7,9957,NULL,NULL,'J','UGC 03167',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36358,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36358,34.4,0.43,75.9,9957,75,NULL,'3.6 micron, color corrected','UGC 03167',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36359,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36359,34.7,0.2,87.1,9957,74.4,NULL,NULL,'UGC 03167',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36360,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,'R',36360,35.33,0.49,116,9958,75,NULL,'IR','FGC 0507',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.000018,NULL,'16.6',0.11,'Sd',NULL,NULL,NULL,NULL,1,72.4144583,0.48072,0.309,NULL,64563734525,1008808351,15762630,16.6),(36361,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36361,35.46,0.43,124,9958,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0507',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36362,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36362,35.88,NULL,150,9958,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0507',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36363,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36363,35.9,NULL,152,9958,NULL,NULL,'Dipole + Quadrupole','FGC 0507',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36364,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36364,35.92,NULL,153,9958,NULL,NULL,'Dipole','FGC 0507',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36365,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36365,35.94,NULL,155,9958,NULL,NULL,NULL,'FGC 0507',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36366,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36366,36.42,0.65,193,9959,70,NULL,NULL,'ESO 552- G 009',NULL,'2014MNRAS.445.2677S',2014,1,0.97,NULL,'G',0.000097,NULL,'15.42',0.58,'SB?',NULL,NULL,NULL,NULL,1,72.4170417,-17.48836,0.077,NULL,37568115806,587001809,9171903,15.42),(36367,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36367,33.9,0.48,60.3,9960,70,NULL,NULL,'NGC 1670',NULL,'2014MNRAS.445.2677S',2014,1,2.1,'HOLM 081B is a star.','G',0.000093,NULL,'13.70',1,'SA0^0^:',NULL,NULL,NULL,NULL,1,72.427583,-2.7605,0.137,NULL,36587107835,571673559,8932399,13.7),(36368,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36368,35.02,0.52,101,9961,70,NULL,NULL,'2MASX J04494363-0553555',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.96',0.5,NULL,NULL,NULL,NULL,NULL,1,72.43175,-5.89897,0.161,NULL,37501380171,585959065,9155610,15.96),(36369,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36369,35.93,0.57,154,9962,70,NULL,NULL,'2MASX J04494564-1317577',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.000103,NULL,'16.54',0.36,NULL,NULL,NULL,NULL,NULL,1,72.440083,-13.2995,0.293,NULL,37572904265,587076629,9173072,16.54),(36370,'IRAS','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36370,34.24,0.8,70.4,9963,75,NULL,'MAT, I','ESO 361- G 012',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.00003,NULL,'15.14',0.24,'Sbc? sp',NULL,NULL,NULL,NULL,1,72.466625,-36.10417,0,NULL,37817442686,590897541,9232774,15.14),(36371,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36371,33.89,NULL,60.1,9963,NULL,NULL,NULL,'ESO 361- G 012',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36372,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,'R',36372,33.92,0.49,60.7,9963,75,NULL,'IR','ESO 361- G 012',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36373,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36373,33.96,0.2,61.9,9963,74.4,NULL,NULL,'ESO 361- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36374,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36374,33.98,NULL,62.4,9963,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 361- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36375,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36375,34,0.32,63,9963,85,NULL,'I, raw','ESO 361- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36376,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36376,34,NULL,63.1,9963,NULL,NULL,'Dipole + Quadrupole','ESO 361- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36377,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36377,34.01,0.32,63.4,9963,85,NULL,'I, inv','ESO 361- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36378,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36378,34.02,NULL,63.6,9963,NULL,NULL,'Dipole','ESO 361- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36379,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36379,34.05,0.43,64.5,9963,75,NULL,'MAT, I, raw','ESO 361- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36380,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36380,34.12,0.4,66.6,9963,NULL,NULL,NULL,'ESO 361- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36381,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36381,34.15,0.43,67.7,9963,75,NULL,'MAT, I, inv','ESO 361- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36382,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36382,34.17,0.39,68.3,9963,NULL,NULL,'Malmquist cor.','ESO 361- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36383,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36383,34.31,0.43,72.8,9963,75,NULL,'MAT, I, cor','ESO 361- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36384,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36384,33.69,0.43,54.8,9964,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-13-013',NULL,'2014MNRAS.444..527S',2014,1,1.1,NULL,'G',0.00004,NULL,'15',0.6,'SB(s)bc',NULL,NULL,NULL,NULL,1,72.475,-10.75436,0.153,NULL,37489439857,585772497,9152695,15),(36385,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36385,33.72,0.43,55.4,9964,75,NULL,'3.6 micron, color corrected','MCG -02-13-013',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36386,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36386,33.72,0.2,55.5,9964,74.4,NULL,NULL,'MCG -02-13-013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36387,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36387,33.77,0.38,56.9,9964,NULL,NULL,NULL,'MCG -02-13-013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36388,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36388,34.08,0.33,65.5,9964,NULL,NULL,'Malmquist cor.','MCG -02-13-013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36389,'IRAS','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36389,30.82,0.8,14.6,9965,75,NULL,'MAT, I','NGC 1679',NULL,'1997ApJS..109..333W',1997,1,2.7,'Position is for center of eccentric bar.','G',0.00001,NULL,'12.01',2,'SB(s)m',NULL,NULL,NULL,NULL,1,72.477667,-31.96467,0,NULL,37209750006,581402343,9084411,12.01),(36390,'Tully est','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36390,30.35,0.8,11.8,9965,75,NULL,NULL,'NGC 1679',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36391,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36391,29.56,0.43,8.1,9965,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1679',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36392,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36392,29.77,0.43,9,9965,75,NULL,'3.6 micron, color corrected','NGC 1679',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36393,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36393,29.93,0.2,9.68,9965,74.4,NULL,NULL,'NGC 1679',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36394,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36394,29.98,0.32,9.95,9965,85,NULL,'I, inv','NGC 1679',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36395,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36395,30,0.32,10,9965,85,NULL,'I, raw','NGC 1679',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36396,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36396,30.24,0.43,11.1,9965,75,NULL,'MAT, I, inv','NGC 1679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36397,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36397,30.26,0.43,11.3,9965,75,NULL,'MAT, I, raw','NGC 1679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36398,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36398,30.27,0.4,11.3,9965,NULL,NULL,NULL,'NGC 1679',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36399,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36399,30.27,0.4,11.3,9965,73,NULL,'opt','NGC 1679',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36400,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36400,30.59,0.43,13.1,9965,75,NULL,'MAT, I, cor','NGC 1679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36401,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36401,31,0.06,15.9,9965,NULL,NULL,NULL,'NGC 1679',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36402,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36402,35.26,0.47,113,9966,70,NULL,NULL,'MCG -03-13-016',NULL,'2014MNRAS.445.2677S',2014,1,2,NULL,'G',0.00004,NULL,'14.6b',0.5,'SB(r)bc? sp',NULL,NULL,NULL,NULL,1,72.556917,-17.26633,0.077,NULL,37567983204,586999737,9171870,14.6),(36403,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,'R',36403,33.66,0.49,54,9967,75,NULL,'IR','IC 2097',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000037,NULL,'15.4b',0.4,'IBm: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,72.6009166667,-5.08122,0.101,NULL,36578610387,571540787,8930324,15.4),(36404,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36404,34.43,0.5,76.9,9968,70,NULL,NULL,'2MASX J04502980-6132368',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'15.9b',0.14,NULL,NULL,NULL,NULL,NULL,1,72.62425,-61.54356,0.005,NULL,35879989238,560624831,8759762,15.9),(36405,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36405,36.06,0.71,163,9969,70,NULL,NULL,'2MASX J04503364-0538447',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,72.6402083,-5.64583,0.105,NULL,37455194703,585237417,9144334,16.3),(36406,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36406,35.09,0.36,104,9970,70,NULL,NULL,'GIN 226',NULL,'2001MNRAS.321..277C',2001,1,0.67,NULL,'G',0.000087,NULL,'14.57',0.42,'E',NULL,NULL,NULL,NULL,1,72.673,-16.75097,0.085,NULL,37567561467,586993147,9171767,14.57),(36407,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36407,36.16,0.25,171,9970,74.4,NULL,NULL,'GIN 226',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36408,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36408,32.72,0.4,35,9971,73,NULL,'IR','IC 2098',NULL,'2011A&A...532A.104N',2011,1,2.32,NULL,'G',0.00004,NULL,'14.5',0.29,'Sc',NULL,NULL,NULL,NULL,1,72.684625,-5.41867,0.105,NULL,36578566273,571540098,8930314,14.5),(36409,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36409,32.72,0.4,35,9971,73,NULL,'opt','IC 2098',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36410,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,'R',36410,32.72,0.4,35,9971,75,NULL,NULL,'IC 2098',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36411,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36411,32.97,0.43,39.3,9971,75,NULL,'3.6 micron, color + selection bias corrected','IC 2098',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36412,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36412,33.03,0.4,40.3,9971,NULL,NULL,'mean','IC 2098',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36413,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36413,33.15,0.47,42.6,9971,NULL,NULL,'H','IC 2098',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36414,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36414,33.17,0.45,43.1,9971,NULL,NULL,'K','IC 2098',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36415,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36415,33.22,0.43,44,9971,75,NULL,'3.6 micron, color corrected','IC 2098',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36416,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36416,33.27,0.46,45.1,9971,NULL,NULL,'J','IC 2098',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36417,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,'R',36417,33.29,0.49,45.5,9971,75,NULL,'IR','IC 2098',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36418,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36418,33.42,0.2,48.3,9971,74.4,NULL,NULL,'IC 2098',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36419,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36419,33.68,NULL,54.5,9971,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 2098',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36420,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36420,33.69,NULL,54.6,9971,NULL,NULL,'Dipole','IC 2098',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36421,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36421,33.69,NULL,54.7,9971,NULL,NULL,'Dipole + Quadrupole','IC 2098',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36422,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36422,35.66,0.74,135,9972,70,NULL,NULL,'2MASX J04504925-1638562',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.58',0.24,NULL,NULL,NULL,NULL,NULL,1,72.705125,-16.64894,0.101,NULL,37567377315,586990270,9171722,16.58),(36423,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36423,36.69,0.64,217,9973,70,NULL,NULL,'2MASX J04505276-3058264',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'17.31',0.19,NULL,NULL,NULL,NULL,NULL,1,72.719917,-30.97397,0,NULL,37208050678,581375791,9083996,17.31),(36424,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36424,34.91,0.25,95.9,9974,74.4,NULL,NULL,'GIN 225',NULL,'2013AJ....146...86T',2013,1,0.43,NULL,'G',0.00015,NULL,'14.79',0.36,'S',NULL,NULL,NULL,NULL,1,72.750125,-17.33172,0.093,NULL,37565897085,586967141,9171361,14.79),(36425,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36425,35.09,0.36,104,9974,70,NULL,NULL,'GIN 225',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36426,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36426,35.73,0.67,140,9975,70,NULL,NULL,'2MASX J04510744-0339063',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.16',0.4,NULL,NULL,NULL,NULL,NULL,1,72.7809583333,-3.65189,0.117,NULL,36580224543,571566008,8930718,16.16),(36427,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36427,34.06,0.4,64.9,9976,NULL,NULL,'mean','UGC 03183',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000033,NULL,'16.0',0.7,'Sb:',NULL,NULL,NULL,NULL,1,72.83225,23.20803,2.129,NULL,65278980345,1019984067,15937251,16),(36428,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36428,34.27,0.47,71.5,9976,NULL,NULL,'H','UGC 03183',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36429,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36429,34.29,0.45,72.2,9976,NULL,NULL,'K','UGC 03183',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36430,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36430,34.31,0.46,72.9,9976,NULL,NULL,'J','UGC 03183',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36431,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36431,34.91,0.25,95.9,9977,74.4,NULL,NULL,'ESO 552- G 014',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000073,NULL,'14.5b',0.7,'SA(s)0- pec:',NULL,NULL,'radio jet',NULL,1,72.8357917,-17.50339,0.105,NULL,37565912641,586967385,9171365,14.5),(36432,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36432,35.09,0.36,104,9977,70,NULL,NULL,'ESO 552- G 014',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36433,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36433,35.11,0.47,105,9977,70,NULL,NULL,'ESO 552- G 014',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36434,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36434,35.41,0.45,121,9977,NULL,NULL,'K','ESO 552- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36435,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36435,35.59,0.4,131,9977,NULL,NULL,'mean','ESO 552- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36436,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36436,33.87,0.2,59.4,9978,74.4,NULL,NULL,'NGC 1687',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.00003,NULL,'14.69',0.5,'SAB(rs)b       HII',NULL,NULL,NULL,NULL,1,72.8390417,-33.93903,0,NULL,37683428665,588803572,9200055,14.69),(36437,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36437,34.01,0.38,63.4,9978,NULL,NULL,NULL,'NGC 1687',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36438,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36438,34.14,0.36,67.2,9978,NULL,NULL,'Malmquist cor.','NGC 1687',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36439,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36439,37.36,0.62,297,9979,70,NULL,NULL,'2MASX J04512485-1847465',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'17.16',0.24,NULL,NULL,NULL,NULL,NULL,1,72.8535,-18.79625,0.045,NULL,37559779098,586871548,9169867,17.16),(36440,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,'R',36440,33.76,0.49,56.5,9980,75,NULL,'IR','MCG -01-13-022',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.00003,NULL,'14.6b',0.4,'Sb: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,72.860833,-3.12194,0.097,NULL,36579616332,571556505,8930570,14.6),(36441,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36441,33.81,0.47,57.9,9980,NULL,NULL,'H','MCG -01-13-022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36442,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36442,33.9,0.46,60.2,9980,NULL,NULL,'J','MCG -01-13-022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36443,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36443,33.91,0.45,60.5,9980,NULL,NULL,'K','MCG -01-13-022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36444,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36444,33.97,0.4,62.3,9980,NULL,NULL,'mean','MCG -01-13-022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36445,'IRAS','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36445,30.49,0.8,12.5,9981,75,NULL,'MAT, I','ESO 119- G 016',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.00002,NULL,'14.83',1,'SA(s)dm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,72.871667,-61.65094,0.017,NULL,35880024013,560625375,8759771,14.83),(36446,'Tully est','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36446,30.08,0.8,10.4,9981,75,NULL,NULL,'ESO 119- G 016',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36447,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36447,31.9,0.4,24,9981,73,NULL,'opt','ESO 119- G 016',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36448,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36448,32.27,0.32,28.4,9981,85,NULL,'I, inv','ESO 119- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36449,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36449,32.3,0.32,28.9,9981,85,NULL,'I, raw','ESO 119- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36450,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36450,32.5,0.4,31.6,9981,NULL,NULL,NULL,'ESO 119- G 016',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36451,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36451,32.57,0.43,32.7,9981,75,NULL,'MAT, I, inv','ESO 119- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36452,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36452,32.65,0.43,33.9,9981,75,NULL,'MAT, I, raw','ESO 119- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36453,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36453,32.94,0.43,38.7,9981,75,NULL,'MAT, I, cor','ESO 119- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36454,'Tully est','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36454,32.2,0.8,27.5,9982,75,NULL,NULL,'ARK 113',NULL,'1988NBGC.C....0000T',1988,1,0.5,'RC3 has V = 2100 +- 49 km/s.','G',0.00015,NULL,'15.26',0.2,'Sab',NULL,NULL,NULL,NULL,1,72.901333,-2.56028,0.149,NULL,36584840406,571638131,8931845,15.26),(36455,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36455,34.01,0.45,63.5,9983,NULL,NULL,'K','UGC 03184',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000023,NULL,'16.0',0.5,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,72.923417,5.50561,0.293,NULL,64613284491,1009582570,15774727,16),(36456,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36456,34.07,0.47,65,9983,NULL,NULL,'H','UGC 03184',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36457,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36457,34.11,0.4,66.2,9983,NULL,NULL,'mean','UGC 03184',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36458,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36458,34.27,0.46,71.4,9983,NULL,NULL,'J','UGC 03184',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36459,'IRAS','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36459,33.9,0.8,60.1,9984,75,NULL,'MAT, I','IC 2101',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'16.1b',0.4,'SB(s)c pec?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,72.926,-6.23144,0.109,NULL,37484731446,585698928,9151545,16.1),(36460,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,'R',36460,33.58,0.49,52.1,9984,75,NULL,'IR','IC 2101',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36461,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36461,33.66,0.2,54,9984,74.4,NULL,NULL,'IC 2101',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36462,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36462,33.71,0.32,55.1,9984,85,NULL,'I, raw','IC 2101',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36463,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36463,33.74,0.43,55.9,9984,75,NULL,'MAT, I, raw','IC 2101',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36464,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36464,33.75,0.32,56.2,9984,85,NULL,'I, inv','IC 2101',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36465,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36465,33.81,0.33,57.9,9984,NULL,NULL,NULL,'IC 2101',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36466,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36466,33.89,0.43,59.9,9984,75,NULL,'MAT, I, cor','IC 2101',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36467,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36467,33.93,0.43,61.2,9984,75,NULL,'MAT, I, inv','IC 2101',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36468,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36468,33.94,0.31,61.3,9984,NULL,NULL,'Malmquist cor.','IC 2101',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36469,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36469,33.94,0.2,61.4,9985,74.4,NULL,NULL,'UGC 03187',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000023,NULL,'15.11',0.8,'Sd',NULL,NULL,NULL,NULL,1,72.93875,6.83403,0.365,NULL,65322712366,1020667380,15947927,15.11),(36470,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36470,34.07,0.3,65.2,9985,NULL,NULL,'Malmquist cor.','UGC 03187',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36471,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36471,34.19,0.29,68.7,9985,NULL,NULL,NULL,'UGC 03187',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36472,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36472,33.51,0.47,50.3,9986,NULL,NULL,'H','WEIN 069',NULL,'2007A&A...465...71T',2007,1,0.56,'abs(b) < 10 degrees.','G',NULL,NULL,NULL,0.33,'S',NULL,NULL,NULL,NULL,1,72.9398333333,44.60072,NULL,NULL,68203747367,1065683552,16651305,NULL),(36473,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36473,33.53,0.45,50.9,9986,NULL,NULL,'K','WEIN 069',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36474,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36474,33.9,0.46,60.1,9986,NULL,NULL,'J','WEIN 069',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36475,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36475,34.04,0.4,64.3,9986,NULL,NULL,'mean','WEIN 069',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36476,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36476,33.32,NULL,46.2,9987,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03186',NULL,'2010Ap&SS.325..163P',2010,1,2.02,NULL,'G',0.000008,NULL,'16.0',0.2,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,72.941833,3.66817,0.261,NULL,64569607350,1008900114,15764064,16),(36477,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36477,33.33,NULL,46.4,9987,NULL,NULL,'Dipole + Quadrupole','UGC 03186',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36478,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36478,33.34,NULL,46.5,9987,NULL,NULL,'Dipole','UGC 03186',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36479,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36479,33.41,NULL,48.2,9987,NULL,NULL,NULL,'UGC 03186',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36480,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36480,33.98,0.24,62.4,9987,NULL,NULL,NULL,'UGC 03186',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36481,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36481,34,0.24,63,9987,NULL,NULL,'Malmquist cor.','UGC 03186',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36482,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36482,34,0.2,63.1,9987,74.4,NULL,NULL,'UGC 03186',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36483,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36483,34.08,0.43,65.3,9987,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03186',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36484,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36484,34.13,0.43,67.1,9987,75,NULL,'3.6 micron, color corrected','UGC 03186',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36485,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36485,33.65,NULL,53.6,9988,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0511',NULL,'2010Ap&SS.325..163P',2010,1,0.83,NULL,'G',0.000047,'?','16.68',0.08,'Sd',NULL,NULL,NULL,NULL,1,72.972917,-5.94806,0.101,NULL,37484548370,585696068,9151501,16.68),(36486,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36486,33.67,NULL,54.2,9988,NULL,NULL,'Dipole + Quadrupole','FGC 0511',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36487,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36487,33.67,NULL,54.3,9988,NULL,NULL,'Dipole','FGC 0511',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36488,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36488,33.68,NULL,54.6,9988,NULL,NULL,NULL,'FGC 0511',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36489,'IRAS','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36489,31.07,0.8,16.3,9989,75,NULL,'MAT, I','ESO 361- G 015',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000013,NULL,'13.69',0.4,'SB(s)d? sp',NULL,NULL,NULL,NULL,1,72.988917,-33.17931,0,NULL,37198120860,581220638,9081572,13.69),(36490,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36490,30.85,0.32,14.8,9989,85,NULL,'I, inv','ESO 361- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36491,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36491,30.87,0.32,14.9,9989,85,NULL,'I, raw','ESO 361- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36492,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36492,30.96,0.2,15.6,9989,74.4,NULL,NULL,'ESO 361- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36493,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36493,31,0.1,15.9,9989,NULL,NULL,NULL,'ESO 361- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36494,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36494,31.04,0.43,16.1,9989,75,NULL,'3.6 micron, color corrected','ESO 361- G 015',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36495,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36495,31.1,0.43,16.6,9989,75,NULL,'3.6 micron, color + selection bias corrected','ESO 361- G 015',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36496,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36496,31.13,0.4,16.8,9989,NULL,NULL,NULL,'ESO 361- G 015',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36497,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36497,31.13,0.4,16.8,9989,73,NULL,'opt','ESO 361- G 015',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36498,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36498,31.27,0.43,17.9,9989,75,NULL,'MAT, I, inv','ESO 361- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36499,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36499,31.27,0.43,18,9989,75,NULL,'MAT, I, raw','ESO 361- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36500,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36500,31.46,0.43,19.5,9989,75,NULL,'MAT, I, cor','ESO 361- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36501,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36501,31.58,0.4,20.7,9989,NULL,NULL,'mean','ESO 361- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36502,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36502,31.87,0.46,23.7,9989,NULL,NULL,'J','ESO 361- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36503,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36503,32.11,0.45,26.5,9989,NULL,NULL,'K','ESO 361- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36504,'IRAS','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36504,31.57,0.8,20.7,9990,75,NULL,'MAT, I','UGCA 097',NULL,'1997ApJS..109..333W',1997,1,1.2,'1996ApJS..107...97M has V_H-alpha = 10234 +- 10 and V_HI = 1462 +- 10 km/s.','G',0.000017,NULL,'14.83',0.8,'Im:',NULL,NULL,NULL,NULL,1,73.0232917,-28.59181,0,NULL,37231806944,581746983,9089796,14.83),(36505,'Tully est','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36505,31.14,0.8,16.9,9990,75,NULL,NULL,'UGCA 097',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36506,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36506,31.51,0.4,20,9990,73,NULL,'opt','UGCA 097',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36507,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36507,31.59,0.1,20.8,9990,NULL,NULL,NULL,'UGCA 097',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36508,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36508,32.2,0.32,27.5,9990,85,NULL,'I, inv','UGCA 097',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36509,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36509,32.24,0.43,28,9990,75,NULL,'MAT, I, inv','UGCA 097',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36510,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36510,32.24,0.32,28,9990,85,NULL,'I, raw','UGCA 097',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36511,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36511,32.36,0.43,29.6,9990,75,NULL,'MAT, I, raw','UGCA 097',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36512,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36512,32.48,0.43,31.4,9990,75,NULL,'MAT, I, cor','UGCA 097',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36513,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36513,32.82,0.4,36.6,9990,NULL,NULL,NULL,'UGCA 097',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36514,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36514,34.93,0.25,96.8,9991,74.4,NULL,NULL,'GIN 222',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000107,NULL,'14.02',0.5,'E',NULL,NULL,NULL,NULL,1,73.0510417,-17.40825,0.105,NULL,37566051103,586969548,9171399,14.02),(36515,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36515,35.09,0.36,104,9991,70,NULL,NULL,'GIN 222',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36516,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36516,35.28,0.49,114,9991,70,NULL,NULL,'GIN 222',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36517,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36517,34.9,NULL,95.6,9992,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 552- G 015',NULL,'2010Ap&SS.325..163P',2010,1,1.53,NULL,'G',0.000033,NULL,'16.23',0.16,'Scd',NULL,NULL,NULL,NULL,1,73.0555,-18.39286,0.053,NULL,37558257236,586847769,9169496,16.23),(36518,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36518,34.91,NULL,96.1,9992,NULL,NULL,'Dipole + Quadrupole','ESO 552- G 015',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36519,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36519,34.92,NULL,96.3,9992,NULL,NULL,'Dipole','ESO 552- G 015',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36520,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36520,34.96,NULL,98.3,9992,NULL,NULL,NULL,'ESO 552- G 015',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36521,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,'R',36521,35.21,0.49,110,9992,75,NULL,'IR','ESO 552- G 015',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36522,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36522,35.64,0.38,134,9992,NULL,NULL,NULL,'ESO 552- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36523,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36523,35.66,0.37,135,9992,NULL,NULL,'Malmquist cor.','ESO 552- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36524,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36524,35.76,0.2,142,9992,74.4,NULL,NULL,'ESO 552- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36525,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36525,36.92,0.56,242,9993,70,NULL,NULL,'2MASX J04521813-0506249',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.39',0.4,NULL,NULL,NULL,NULL,NULL,1,73.075417,-5.10689,0.093,NULL,36633958146,572405596,8943837,16.39),(36526,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36526,33.64,0.5,53.5,9994,70,NULL,NULL,'NGC 1682',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00007,NULL,'14.4b',0.3,'SA?0-: pec',NULL,NULL,NULL,NULL,1,73.0824583333,-3.10586,0.133,NULL,36635213452,572425210,8944143,14.4),(36527,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36527,35.85,0.54,148,9995,70,NULL,NULL,'2MASX J04522051-1931488',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.62',0.4,NULL,NULL,NULL,NULL,NULL,1,73.0855,-19.53042,0.041,NULL,37557509742,586836089,9169313,16.62),(36528,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36528,33.85,0.49,58.8,9996,70,NULL,NULL,'MCG -01-13-030',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000083,NULL,'14.3b',1.5,'SA(s)0^0^ pec?',NULL,NULL,NULL,NULL,1,73.104917,-3.56553,0.085,NULL,36635271774,572426121,8944158,14.3),(36529,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36529,33.94,NULL,61.3,9997,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 552- G 016',NULL,'2010Ap&SS.325..163P',2010,1,0.9,'Matthews (2000A&AS..143..421M) detects another feature at v=1884 km/sec.','G',0.000013,NULL,'16.66',0.12,'Sdm',NULL,NULL,NULL,NULL,1,73.1189583,-19.29281,0.041,NULL,37559806422,586871975,9169874,16.66),(36530,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36530,33.96,NULL,62,9997,NULL,NULL,'Dipole + Quadrupole','ESO 552- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36531,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36531,33.97,NULL,62.3,9997,NULL,NULL,'Dipole','ESO 552- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36532,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36532,34.03,NULL,63.8,9997,NULL,NULL,NULL,'ESO 552- G 016',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36533,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36533,34.08,0.47,65.5,9998,70,NULL,NULL,'NGC 1684',NULL,'2014MNRAS.445.2677S',2014,1,2.5,NULL,'G',0.000057,NULL,'12.9b',1.7,'E+ pec:',NULL,NULL,NULL,NULL,1,73.1297917,-3.10606,0.133,NULL,36635204353,572425068,8944141,12.9),(36534,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36534,33.94,0.4,61.5,9998,NULL,NULL,'mean','NGC 1684',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36535,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36535,34.39,0.45,75.7,9998,NULL,NULL,'K','NGC 1684',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36536,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36536,35.88,0.6,150,9999,70,NULL,NULL,'2MASX J04524601-1903126',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.97',0.45,NULL,NULL,NULL,NULL,NULL,1,73.1915417,-19.05369,0.041,NULL,37559940398,586874068,9169907,16.97),(36537,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36537,35.05,0.25,102,10000,74.4,NULL,NULL,'UGC 03192',NULL,'2013AJ....146...86T',2013,1,0.7,'RC3 gives v = 17700 +/- 49 km/sec.','G',0.000057,NULL,'13.34',0.6,'S0-:',NULL,NULL,NULL,NULL,1,73.2050417,1.25908,0.297,NULL,64618021394,1009656584,15775884,13.34),(36538,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36538,35.24,0.36,112,10000,70,NULL,NULL,'UGC 03192',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36539,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36539,34.42,0.49,76.5,10001,70,NULL,NULL,'ESO 251- G 038',NULL,'2014MNRAS.445.2677S',2014,1,1.41,NULL,'G',0.000127,NULL,'15.11',0.29,'Sb:',NULL,NULL,NULL,NULL,1,73.206625,-43.78119,0,NULL,37631347566,587989805,9187340,15.11),(36540,'Tully est','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36540,31.2,0.8,17.4,10002,75,NULL,NULL,'NGC 1703',NULL,'1988NBGC.C....0000T',1988,1,3,NULL,'G',0.00001,NULL,'11.9',2.6,'SA(s)c         HII','Possible group member',NULL,NULL,NULL,1,73.2172917,-59.74225,0,NULL,35909288759,561082636,8766916,11.9),(36541,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36541,33.98,0.45,62.5,10003,NULL,NULL,'K','UGC 03193',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000033,NULL,'14.43',0.6,'SB(rs)ab:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,73.2190833333,3.05719,0.213,NULL,64621697920,1009714030,15776781,14.43),(36542,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36542,34,0.47,63.1,10003,NULL,NULL,'H','UGC 03193',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36543,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36543,34.03,0.4,64.1,10003,NULL,NULL,'mean','UGC 03193',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36544,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36544,34.11,0.46,66.3,10003,NULL,NULL,'J','UGC 03193',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36545,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36545,31.02,0.4,16,10004,75,NULL,'B','UGCA 098',NULL,'1988NBGC.C....0000T',1988,1,3.9,'The APM position is 13 arcsec northwest of the nucleus.','G',0.000007,NULL,'13.25',3.2,'SB(s)m',NULL,NULL,NULL,NULL,1,73.2207083,-25.24575,0,NULL,37218706024,581542281,9086598,13.25),(36546,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36546,34.05,0.61,64.7,10005,70,NULL,NULL,'NGC 1686',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000023,NULL,'14.9b',0.3,'Sbc',NULL,NULL,NULL,NULL,1,73.22775,-15.34647,0.101,NULL,37580691681,587198307,9174973,14.9),(36547,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36547,34.45,0.47,77.5,10005,NULL,NULL,'H','NGC 1686',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36548,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,'R',36548,34.46,0.49,77.8,10005,75,NULL,'IR','NGC 1686',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36549,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36549,34.46,0.46,78,10005,NULL,NULL,'J','NGC 1686',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36550,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36550,34.49,0.45,78.9,10005,NULL,NULL,'K','NGC 1686',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36551,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36551,34.54,0.4,81,10005,NULL,NULL,'mean','NGC 1686',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36552,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36552,34.72,0.55,87.8,10005,NULL,NULL,'Malmquist cor.','NGC 1686',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36553,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36553,34.75,0.2,89.1,10005,74.4,NULL,NULL,'NGC 1686',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36554,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36554,34.97,0.49,98.7,10005,NULL,NULL,NULL,'NGC 1686',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36555,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36555,35.03,0.25,101,10006,74.4,NULL,NULL,'GIN 207',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000167,NULL,'14.99',0.6,'S',NULL,NULL,NULL,NULL,1,73.24025,1.25625,0.297,NULL,64618209282,1009659520,15775930,14.99),(36556,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36556,35.24,0.36,112,10006,70,NULL,NULL,'GIN 207',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36557,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36557,34.46,0.69,78,10007,100,NULL,'mid-IR','UGC 03194',NULL,'2013ApJ...771...88L',2013,1,1.6,NULL,'G',0.000023,NULL,'14.91',0.7,'SB(s)b pec:',NULL,NULL,NULL,NULL,1,73.245417,1.33133,0.297,NULL,64618015678,1009656494,15775882,14.91),(36558,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36558,36.85,0.66,234,10008,70,NULL,NULL,'2MASX J04530446-4524483',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.29',0.43,'E',NULL,NULL,NULL,NULL,1,73.2687083333,-45.41336,0,NULL,37623248131,587863252,9185363,16.29),(36559,'TRGB','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36559,27.52,0.1,3.19,10009,NULL,NULL,NULL,'CAMELOPARDALIS B',NULL,'2012A&A...540A..49M',2012,1,2.2,NULL,'G',0.000001,NULL,'16.1',1.1,'Irr','Brightest group member',NULL,NULL,NULL,1,73.279583,67.09917,1.037,NULL,66425565879,1037899466,16217179,16.1),(36560,'TRGB','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36560,27.62,NULL,3.34,10009,NULL,NULL,NULL,'CAMELOPARDALIS B',NULL,'2003A&A...408..111K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36561,'TRGB','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36561,27.63,0.17,3.36,10009,NULL,NULL,'I','CAMELOPARDALIS B',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36562,'TRGB','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36562,27.72,0.1,3.5,10009,74.4,NULL,NULL,'CAMELOPARDALIS B',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36563,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36563,35.59,0.39,131,10010,NULL,NULL,NULL,'ESO 552- G 018',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000033,NULL,'16.01',0.5,'Sb:',NULL,NULL,NULL,NULL,1,73.29,-17.70639,0.041,NULL,37566124320,586970692,9171417,16.01),(36564,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36564,35.63,0.2,134,10010,74.4,NULL,NULL,'ESO 552- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36565,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36565,35.64,0.38,134,10010,NULL,NULL,'Malmquist cor.','ESO 552- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36566,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,'R',36566,34.14,0.49,67.2,10011,75,NULL,'IR','2MFGC 04010',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000017,NULL,'10.3K',0.2,NULL,NULL,NULL,NULL,NULL,1,73.2927083,34.38617,NULL,NULL,68334161584,1067721274,16683144,10.3),(36567,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36567,36.57,0.61,206,10012,70,NULL,NULL,'2MASX J04531224-1329406',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00011,NULL,'16.71',NULL,NULL,NULL,NULL,NULL,NULL,1,73.301167,-13.49467,0.181,NULL,37574938643,587108416,9173569,16.71),(36568,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36568,36.91,0.6,241,10013,70,NULL,NULL,'2MASX J04531659-1844582',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'16.55',0.37,NULL,NULL,NULL,NULL,NULL,1,73.3192083333,-18.7495,0.025,NULL,37559864711,586872886,9169888,16.55),(36569,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36569,35.05,0.25,102,10014,74.4,NULL,NULL,'GIN 208',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000057,NULL,'14.69',0.3,'E',NULL,NULL,NULL,NULL,1,73.3699166667,1.28247,0.297,NULL,64618195597,1009659306,15775926,14.69),(36570,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36570,35.24,0.36,112,10014,70,NULL,NULL,'GIN 208',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36571,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36571,36.53,0.73,203,10015,70,NULL,NULL,'ESO 552- G 019',NULL,'2014MNRAS.445.2677S',2014,1,0.99,NULL,'G',0.000033,NULL,'15.22',0.49,'Sab',NULL,NULL,NULL,NULL,1,73.3927916667,-17.92283,0.057,NULL,37565827525,586966055,9171344,15.22),(36572,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36572,36.35,0.52,186,10016,70,NULL,NULL,'MCG -03-13-021',NULL,'2014MNRAS.445.2677S',2014,1,0.15,NULL,'G',0.00015,NULL,'16.4b',0.15,NULL,NULL,NULL,NULL,NULL,1,73.404833,-17.92533,0.057,NULL,37565827387,586966052,9171344,16.4),(36573,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36573,36.74,0.65,223,10017,70,NULL,NULL,'2MASX J04534466-0355103',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,73.436083,-3.9195,0.145,NULL,36636181245,572440331,8944380,16.7),(36574,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36574,34.49,0.58,79,10018,70,NULL,NULL,'6dF J0453485-322624',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,73.4523333333,-32.43997,0,NULL,37209035947,581391186,9084237,13.2),(36575,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36575,35.27,0.25,113,10019,74.4,NULL,NULL,'GIN 220',NULL,'2013AJ....146...86T',2013,1,0.55,NULL,'G',0.00006,NULL,'14.39',0.47,'S',NULL,NULL,NULL,NULL,1,73.480333,-18.3455,0.057,NULL,37558897758,586857777,9169652,14.39),(36576,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36576,35.31,0.51,116,10019,70,NULL,NULL,'GIN 220',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36577,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36577,35.43,0.41,122,10019,70,NULL,NULL,'GIN 220',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36578,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36578,36.57,0.55,206,10020,70,NULL,NULL,'2MASX J04535794-1856409',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000097,NULL,'16.73',0.28,NULL,NULL,NULL,NULL,NULL,1,73.4914583,-18.94478,0.041,NULL,37559065248,586860394,9169693,16.73),(36579,'SZ effect','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36579,40.15,NULL,1070,10021,NULL,NULL,NULL,'MACS J0454.1-0300',NULL,'2005ApJ...625..108D',2005,1,NULL,NULL,'GClstr',0.003,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,73.546375,-3.01494,0.125,NULL,36637428766,572459824,8944684,NULL),(36580,'SZ effect','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36580,40.5,0.35,1260,10021,NULL,NULL,'Isotherm.','MACS J0454.1-0300',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36581,'SZ effect','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36581,40.53,0.46,1280,10021,NULL,NULL,NULL,'MACS J0454.1-0300',NULL,'2000ApJ...533...38R',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36582,'SZ effect','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36582,40.54,NULL,1280,10021,NULL,NULL,NULL,'MACS J0454.1-0300',NULL,'2002ApJ...581...53R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36583,'SZ effect','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36583,40.76,0.37,1420,10021,NULL,NULL,'Hydrost. Eq.','MACS J0454.1-0300',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36584,'SZ effect','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36584,40.84,0.37,1470,10021,NULL,NULL,'Isotherm., r < 100 kpc','MACS J0454.1-0300',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36585,'SZ effect','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36585,41.07,NULL,1640,10021,NULL,NULL,'3.1 (red) calibration','MACS J0454.1-0300',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36586,'SZ effect','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36586,41.22,NULL,1750,10021,NULL,NULL,'4.2 (black) calibration','MACS J0454.1-0300',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36587,'SZ effect','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36587,41.49,NULL,1990,10021,NULL,NULL,'4.1 (blue) calibration','MACS J0454.1-0300',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36588,'CMD','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36588,28.5,NULL,5,10022,NULL,NULL,'VI CMD','NGC 1705',NULL,'1994ApJ...433...65O',1994,1,1.9,NULL,'G',0.000019,NULL,'12.77',1.4,'SA0- pec:;HII  BCDG','Possible group member',NULL,NULL,NULL,1,73.55625,-53.36106,0.181,NULL,35939098771,561548418,8774194,12.77),(36589,'TRGB','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36589,28.54,0.26,5.1,10022,NULL,NULL,NULL,'NGC 1705',NULL,'2001AJ....122.1271T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36590,'TRGB','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36590,28.54,0.24,5.1,10022,NULL,NULL,NULL,'NGC 1705',NULL,'2014A&A...566A..71L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36591,'TRGB','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36591,28.71,0.08,5.51,10022,74.4,NULL,NULL,'NGC 1705',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36592,'Tully est','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36592,28.87,0.8,6,10022,75,NULL,'B','NGC 1705',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36593,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36593,34.23,0.51,70.1,10023,70,NULL,NULL,'ESO 251- G 041',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000073,NULL,'14.71',0.31,'SA0+? sp',NULL,NULL,NULL,NULL,1,73.557167,-43.87386,0,NULL,37631549171,587992955,9187389,14.71),(36594,'SZ effect','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36594,37.94,NULL,387,10024,NULL,NULL,NULL,'ABELL 0520',NULL,'2005ApJ...625..108D',2005,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,73.579125,2.94689,0.197,NULL,64621762369,1009715037,15776797,NULL),(36595,'SZ effect','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36595,39.3,NULL,723,10024,NULL,NULL,NULL,'ABELL 0520',NULL,'2002ApJ...581...53R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36596,'Tully est','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36596,32.21,0.8,27.7,10025,75,NULL,'B','NGC 1690',NULL,'1988NBGC.C....0000T',1988,1,1,NULL,'G',0.0001,NULL,'14.89',1,'E:','Group member',NULL,NULL,NULL,1,73.58025,1.64036,0.293,NULL,64621060934,1009704077,15776626,14.89),(36597,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36597,36.1,0.53,166,10026,70,NULL,NULL,'2MASX J04542245-5353566',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.2,NULL,NULL,NULL,NULL,NULL,1,73.593667,-53.89914,0.197,NULL,35950513174,561726768,8776980,14.5),(36598,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36598,35.16,0.56,108,10027,70,NULL,NULL,'2MASX J04542471-1756558',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'16.52',0.25,NULL,NULL,NULL,NULL,NULL,1,73.603,-17.949,0.105,NULL,37557970380,586843287,9169426,16.52),(36599,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36599,36,0.64,158,10028,70,NULL,NULL,'2MASX J04543469-1857121',NULL,'2014MNRAS.445.2677S',2014,1,0.24,NULL,'G',0.00015,NULL,'16.9b',0.14,NULL,NULL,NULL,NULL,NULL,1,73.644583,-18.95344,0.041,NULL,37558581001,586852828,9169575,16.9),(36600,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36600,35.45,0.48,123,10029,70,NULL,NULL,'CGCG 394-032',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.0001,NULL,'15.45',0.4,'S?',NULL,NULL,NULL,NULL,1,73.650125,-1.37042,0.185,NULL,36629200792,572331262,8942675,15.45),(36601,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36601,37.17,0.81,272,10030,70,NULL,NULL,'2MASX J04543676-1759091',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.63',0.37,NULL,NULL,NULL,NULL,NULL,1,73.653167,-17.98583,0.105,NULL,37557971845,586843310,9169426,16.63),(36602,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36602,34.08,0.2,65.5,10031,74.4,NULL,NULL,'UGC 03189',NULL,'2013AJ....146...86T',2013,1,1.9,NULL,'G',0.000037,NULL,'15.0',0.5,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,73.6589583,69.71492,0.569,NULL,66376799726,1037137495,16205273,15),(36603,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36603,34.18,0.31,68.5,10031,NULL,NULL,NULL,'UGC 03189',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36604,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36604,34.22,0.31,69.9,10031,NULL,NULL,'Malmquist cor.','UGC 03189',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36605,'IRAS','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36605,34.11,0.8,66.5,10032,75,NULL,'MAT, I','MCG -02-13-019',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000027,NULL,'15.0b',0.7,'SAB(s)c:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,73.6643333333,-12.20433,0.349,NULL,37521696845,586276513,9160570,15),(36606,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36606,33.61,0.32,52.8,10032,85,NULL,'I, raw','MCG -02-13-019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36607,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36607,33.64,0.32,53.4,10032,85,NULL,'I, inv','MCG -02-13-019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36608,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36608,33.7,0.43,54.9,10032,75,NULL,'MAT, I, raw','MCG -02-13-019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36609,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36609,33.83,0.43,58.4,10032,75,NULL,'MAT, I, inv','MCG -02-13-019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36610,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36610,33.86,0.43,59.1,10032,75,NULL,'MAT, I, cor','MCG -02-13-019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36611,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36611,33.88,0.2,59.7,10032,74.4,NULL,NULL,'MCG -02-13-019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36612,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36612,34.03,0.39,63.9,10032,NULL,NULL,NULL,'MCG -02-13-019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36613,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36613,34.11,0.37,66.5,10032,NULL,NULL,'Malmquist cor.','MCG -02-13-019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36614,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36614,35.27,0.48,113,10033,70,NULL,NULL,'MCG -03-13-024 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000067,NULL,'15.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,73.6787083,-17.45247,0.101,NULL,37565352584,586958634,9171228,15),(36615,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36615,36.22,0.57,176,10034,70,NULL,NULL,'MCG -03-13-024 NED02',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,73.6807083,-17.455,0.101,NULL,37565352705,586958636,9171228,15),(36616,'Tully est','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36616,31.01,0.8,15.9,10035,75,NULL,NULL,'ESO 085- G 014',NULL,'1988NBGC.C....0000T',1988,1,2.8,NULL,'G',0.000013,NULL,'13.40',1.1,'SB(s)m','Pair member (points to parent)',NULL,NULL,NULL,1,73.685417,-62.79975,0.005,NULL,35882774774,560668355,8760443,13.4),(36617,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36617,31.31,0.43,18.3,10035,75,NULL,'3.6 micron, color + selection bias corrected','ESO 085- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36618,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36618,35.47,0.5,124,10036,70,NULL,NULL,'ESO 158- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.26',0.5,'(R\'_2)SB(rs)a',NULL,NULL,NULL,NULL,1,73.690625,-53.09931,0.081,NULL,35719932087,558123938,8720686,15.26),(36619,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36619,34.68,0.49,86.3,10037,70,NULL,NULL,'ESO 552- G 020',NULL,'2014MNRAS.445.2677S',2014,1,2.3,NULL,'G',0.000107,NULL,'13.32',1.3,'cD;E+',NULL,NULL,NULL,NULL,1,73.7165833333,-18.11561,0.105,NULL,37557988242,586843566,9169430,13.32),(36620,'FP','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36620,35.24,0.25,112,10037,74.4,NULL,NULL,'ESO 552- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36621,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36621,35.59,0.4,131,10037,NULL,NULL,'mean','ESO 552- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36622,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36622,35.75,0.45,141,10037,NULL,NULL,'K','ESO 552- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36623,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36623,30.24,0.43,11.2,10038,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J04545283-3719162',NULL,'2014MNRAS.444..527S',2014,1,NULL,NULL,'PofG',0.000183,NULL,NULL,NULL,'HII',NULL,NULL,NULL,NULL,1,73.720125,-37.32103,0,NULL,37819457056,590929016,9233265,NULL),(36624,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,'R',36624,31.62,0.49,21.1,10039,75,NULL,'IR','ESO 361- G 019',NULL,'2011yCatp016004901K',2011,1,1.8,NULL,'G',0.000017,NULL,'14.18',0.7,'SBa? pec',NULL,NULL,NULL,NULL,1,73.72375,-37.32172,0,NULL,37819453725,590928964,9233265,14.18),(36625,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,'R',36625,33.23,0.49,44.2,10040,75,NULL,'IR','MCG -01-13-035',NULL,'2011yCatp016004901K',2011,1,1.81,NULL,'G',0.00004,NULL,'14.5b',0.21,'Sc',NULL,NULL,NULL,NULL,1,73.7640833333,-4.10108,0.125,NULL,36635848414,572435131,8944298,14.5),(36626,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36626,33.48,0.43,49.7,10040,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-13-035',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36627,'Tully-Fisher','2016-12-15 15:14:04','2016-12-16 11:19:09','1',NULL,NULL,36627,33.5,0.43,50,10040,75,NULL,'3.6 micron, color corrected','MCG -01-13-035',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36628,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36628,33.51,0.2,50.4,10040,74.4,NULL,NULL,'MCG -01-13-035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36629,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36629,34.57,NULL,82,10040,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -01-13-035',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36630,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36630,34.58,NULL,82.3,10040,NULL,NULL,'Dipole + Quadrupole','MCG -01-13-035',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36631,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36631,34.58,NULL,82.4,10040,NULL,NULL,'Dipole','MCG -01-13-035',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36632,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36632,33.88,0.47,59.8,10041,NULL,NULL,'H','MCG -02-13-021',NULL,'2007A&A...465...71T',2007,1,2.9,'Confused HIPASS source','G',0.000028,NULL,'14',0.7,'SA(s)b:        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,73.77325,-10.69056,0.161,NULL,37490230494,585784851,9152888,14),(36633,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36633,33.9,0.46,60.3,10041,NULL,NULL,'J','MCG -02-13-021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36634,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36634,33.95,0.45,61.5,10041,NULL,NULL,'K','MCG -02-13-021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36635,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36635,34,0.4,63.2,10041,NULL,NULL,'mean','MCG -02-13-021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36636,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,'R',36636,34.02,0.49,63.7,10041,75,NULL,'IR','MCG -02-13-021',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36637,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36637,34.62,0.4,83.8,10042,NULL,NULL,'mean','MCG -03-13-027',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.00004,NULL,'14.5',0.5,'Sc',NULL,NULL,NULL,NULL,1,73.789583,-16.14981,0.133,NULL,37580347269,587192926,9174889,14.5),(36638,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36638,34.65,0.47,85.1,10042,NULL,NULL,'H','MCG -03-13-027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36639,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1997F','R',36639,41.86,NULL,1490,10043,65,NULL,'SALT','H-ZSNS J045514.27-055144.8',0.58,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,'SBb',NULL,NULL,NULL,NULL,1,73.8094583333,-5.86244,0.141,NULL,36600150872,571877357,8935583,NULL),(36640,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1997F',NULL,36640,42.59,0.53,2090,10043,74.2,NULL,'SALT 2','H-ZSNS J045514.27-055144.8',0.58,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36641,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1997F',NULL,36641,42.94,0.4,2450,10043,70,NULL,'SALT','H-ZSNS J045514.27-055144.8',0.58,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36642,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1997F',NULL,36642,43.04,0.21,2570,10043,65,NULL,NULL,'H-ZSNS J045514.27-055144.8',0.58,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36643,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1997F',NULL,36643,43.12,0.38,2660,10043,65,NULL,'SALT','H-ZSNS J045514.27-055144.8',0.58,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36644,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36644,34.73,0.8,88.1,10044,75,NULL,'MAT, I','ESO 485- G 024',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'15.04',0.8,'Sb-c',NULL,NULL,NULL,NULL,1,73.821333,-22.72933,0.057,NULL,37331983644,583312244,9114253,15.04),(36645,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36645,33.63,0.32,53.2,10044,85,NULL,'I, raw','ESO 485- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36646,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36646,33.64,0.32,53.5,10044,85,NULL,'I, inv','ESO 485- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36647,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36647,34.01,0.63,63.3,10044,NULL,NULL,'Malmquist cor.','ESO 485- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36648,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36648,34.02,0.62,63.7,10044,NULL,NULL,NULL,'ESO 485- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36649,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36649,34.06,0.2,64.9,10044,74.4,NULL,NULL,'ESO 485- G 024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36650,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36650,34.3,0.43,72.4,10044,75,NULL,'MAT, I, raw','ESO 485- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36651,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36651,34.45,0.43,77.8,10044,75,NULL,'MAT, I, inv','ESO 485- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36652,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36652,34.63,0.43,84.5,10044,75,NULL,'MAT, I, cor','ESO 485- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36653,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36653,37.13,0.69,266,10045,70,NULL,NULL,'2MASX J04552052-2003299',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'17.09',0.18,NULL,NULL,NULL,NULL,NULL,1,73.8355,-20.05828,0.029,NULL,37557251948,586832061,9169250,17.09),(36654,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36654,35.25,0.25,112,10046,74.4,NULL,NULL,'GIN 218',NULL,'2013AJ....146...86T',2013,1,0.58,NULL,'G',0.00008,NULL,'14.82',0.34,'S',NULL,NULL,NULL,NULL,1,73.846625,-18.38717,0.069,NULL,37558778397,586855912,9169623,14.82),(36655,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36655,35.43,0.41,122,10046,70,NULL,NULL,'GIN 218',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36656,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36656,36.1,0.51,166,10046,70,NULL,NULL,'GIN 218',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36657,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36657,36.59,0.55,208,10047,70,NULL,NULL,'2MASX J04552608-2033198',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.60',0.31,NULL,NULL,NULL,NULL,NULL,1,73.85875,-20.55561,0.033,NULL,37556945426,586827272,9169176,16.6),(36658,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36658,34.37,0.8,75,10048,75,NULL,'MAT, I','ESO 422- G 010',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.40',0.6,'SAB(rs)b',NULL,NULL,NULL,NULL,1,73.876375,-31.81017,0,NULL,37210557874,581414966,9084608,14.4),(36659,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36659,34.48,0.33,78.9,10048,NULL,NULL,'Malmquist cor.','ESO 422- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36660,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36660,34.58,0.4,82.4,10048,NULL,NULL,'mean','ESO 422- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36661,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36661,34.6,0.47,83.3,10048,NULL,NULL,'H','ESO 422- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36662,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36662,34.61,0.43,83.6,10048,75,NULL,'MAT, I, raw','ESO 422- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36663,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36663,34.65,0.46,85.1,10048,NULL,NULL,'J','ESO 422- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36664,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36664,34.66,0.32,85.7,10048,85,NULL,'I, raw','ESO 422- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36665,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36665,34.68,0.45,86.2,10048,NULL,NULL,'K','ESO 422- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36666,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36666,34.74,0.32,88.6,10048,85,NULL,'I, inv','ESO 422- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36667,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36667,34.9,0.43,95.7,10048,75,NULL,'MAT, I, inv','ESO 422- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36668,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36668,34.91,0.43,96.1,10048,75,NULL,'MAT, I, cor','ESO 422- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36669,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36669,34.97,0.27,98.5,10048,NULL,NULL,NULL,'ESO 422- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36670,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36670,35.04,0.2,102,10048,74.4,NULL,NULL,'ESO 422- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36671,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36671,35.72,0.58,139,10049,70,NULL,NULL,'2MASX J04553106-2036086',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'17.0b',0.22,NULL,NULL,NULL,NULL,NULL,1,73.879417,-20.60239,0.033,NULL,37556863057,586825985,9169156,17),(36672,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36672,36.23,0.55,176,10050,70,NULL,NULL,'2MASX J04553415-2018436',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'16.74',0.33,NULL,NULL,NULL,NULL,NULL,1,73.892333,-20.31219,0.021,NULL,37556923430,586826928,9169170,16.74),(36673,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,'R',36673,34,0.49,63.1,10051,75,NULL,'IR','UGC 03196',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000037,NULL,'16.5',0.3,'Scd:',NULL,NULL,NULL,NULL,1,73.912125,67.73272,0.745,NULL,66426997528,1037921836,16217528,16.5),(36674,'Tully est','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36674,31.55,0.8,20.4,10052,75,NULL,NULL,'ESO 158- G 015',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000021,NULL,'15.28',0.8,'Pec',NULL,NULL,NULL,NULL,1,73.919167,-56.23561,0,NULL,35954673826,561791778,8777996,15.28),(36675,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36675,36.57,0.55,206,10053,70,NULL,NULL,'AM 0454-424',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.90',0.32,'S',NULL,NULL,NULL,NULL,1,73.9342916667,-42.726,0,NULL,37602940367,587545943,9180405,15.9),(36676,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36676,35.47,0.59,124,10054,70,NULL,NULL,'2MASX J04554439-1914286',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.53',0.47,NULL,NULL,NULL,NULL,NULL,1,73.93475,-19.24142,0.037,NULL,37558476303,586851192,9169549,16.53),(36677,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36677,35.26,0.47,113,10055,70,NULL,NULL,'2MASX J04555009-2052016',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'15.65',0.49,NULL,NULL,NULL,NULL,NULL,1,73.9587917,-20.86711,0.037,NULL,37561102369,586892224,9170191,15.65),(36678,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36678,36.53,0.6,202,10056,70,NULL,NULL,'2MASX J04560073-5409288',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.8b',0.4,'(R)SB0^0',NULL,NULL,NULL,NULL,1,74.003125,-54.15781,0.205,NULL,35951289795,561738903,8777170,15.8),(36679,'Sosies','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36679,34.26,0.12,71.1,10057,NULL,NULL,NULL,'UGC 03207',NULL,'2002A&A...393...57T',2002,1,2.3,NULL,'G',0.000017,NULL,'13.94',0.7,'SAB(rs)b pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,74.04075,2.15689,0.253,NULL,64620675585,1009698056,15776532,13.94),(36680,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36680,33.97,0.46,62.3,10057,NULL,NULL,'J','UGC 03207',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36681,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36681,34.01,0.47,63.5,10057,NULL,NULL,'H','UGC 03207',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36682,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36682,34.03,0.23,63.9,10057,NULL,NULL,'Malmquist cor.','UGC 03207',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36683,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36683,34.05,0.45,64.5,10057,NULL,NULL,'K','UGC 03207',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36684,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36684,34.05,0.4,64.7,10057,NULL,NULL,'mean','UGC 03207',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36685,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36685,34.16,0.21,68,10057,NULL,NULL,NULL,'UGC 03207',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36686,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36686,34.28,0.2,71.8,10057,74.4,NULL,NULL,'UGC 03207',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36687,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36687,34.48,0.43,78.6,10057,75,NULL,'3.6 micron, color corrected','UGC 03207',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36688,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36688,34.7,0.43,87.1,10057,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03207',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36689,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1997ek','R',36689,42.87,NULL,2020,10058,65,NULL,'SALT','H-ZSNS J045611.63-034126.0',0.86,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,74.0484583333,-3.69056,0.121,NULL,36637719101,572464360,8944755,NULL),(36690,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1997ek',NULL,36690,43.21,0.17,2360,10058,74.2,NULL,'SALT 2','H-ZSNS J045611.63-034126.0',0.86,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36691,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1997ek',NULL,36691,43.75,0.16,3020,10058,70,NULL,'SALT','H-ZSNS J045611.63-034126.0',0.86,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36692,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1997ek',NULL,36692,43.89,0.13,3230,10058,65,NULL,'SALT','H-ZSNS J045611.63-034126.0',0.86,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36693,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1997ek',NULL,36693,44.03,0.3,3440,10058,65,NULL,NULL,'H-ZSNS J045611.63-034126.0',0.86,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36694,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36694,33.35,0.46,46.9,10059,NULL,NULL,'J','UGC 03205',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000033,NULL,'16.0',0.6,'Sab',NULL,NULL,NULL,NULL,1,74.062,30.05236,NULL,NULL,64804457183,1012569643,15821400,16),(36695,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36695,33.36,0.47,47,10059,NULL,NULL,'H','UGC 03205',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36696,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36696,33.41,0.45,48.1,10059,NULL,NULL,'K','UGC 03205',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36697,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36697,33.42,0.4,48.4,10059,NULL,NULL,'mean','UGC 03205',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36698,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36698,33.85,0.43,58.8,10059,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03205',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36699,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36699,36.83,0.73,232,10060,70,NULL,NULL,'2MASX J04561838-1221126',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,74.076625,-12.35347,0.273,NULL,37521595763,586274933,9160545,15.5),(36700,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36700,35.47,0.59,124,10061,70,NULL,NULL,'ESO 552- G 025',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'15.78',0.2,'S0-a',NULL,NULL,NULL,NULL,1,74.0767083,-17.99781,0.105,NULL,37557957662,586843088,9169423,15.78),(36701,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36701,36.31,0.72,183,10062,70,NULL,NULL,'2MASX J04561844-1958396',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.90',0.28,'(R)SB0^+',NULL,NULL,NULL,NULL,1,74.0769166667,-19.97772,0.029,NULL,37561676714,586901198,9170331,16.9),(36702,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36702,34.32,0.8,73.3,10063,75,NULL,'MAT, I','IC 2104',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'13.9b',1.2,'(R\')SB(s)bc',NULL,NULL,NULL,NULL,1,74.079,-15.79789,0.133,NULL,37577454525,587147726,9174183,13.9),(36703,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36703,34.26,0.2,71.1,10063,74.4,NULL,NULL,'IC 2104',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36704,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36704,34.46,0.47,77.8,10063,NULL,NULL,'H','IC 2104',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36705,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36705,34.46,0.43,78.1,10063,75,NULL,'MAT, I, raw','IC 2104',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36706,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36706,34.47,0.4,78.2,10063,NULL,NULL,'mean','IC 2104',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36707,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36707,34.49,0.56,78.9,10063,NULL,NULL,'Malmquist cor.','IC 2104',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36708,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36708,34.51,0.45,80,10063,NULL,NULL,'K','IC 2104',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36709,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36709,34.53,0.32,80.6,10063,85,NULL,'I, raw','IC 2104',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36710,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36710,34.54,0.46,80.8,10063,NULL,NULL,'J','IC 2104',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36711,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36711,34.61,0.32,83.5,10063,85,NULL,'I, inv','IC 2104',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36712,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36712,34.77,0.43,90.1,10063,75,NULL,'MAT, I, cor','IC 2104',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36713,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36713,34.78,0.43,90.2,10063,75,NULL,'MAT, I, inv','IC 2104',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36714,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36714,34.84,0.48,93,10063,NULL,NULL,NULL,'IC 2104',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36715,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36715,35.7,0.52,138,10064,70,NULL,NULL,'2MASX J04562321-2024416',NULL,'2014MNRAS.445.2677S',2014,1,0.87,NULL,'G',0.00015,NULL,'15.52',0.42,NULL,NULL,NULL,NULL,NULL,1,74.0967917,-20.41161,0.017,NULL,37561228939,586894202,9170221,15.52),(36716,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36716,35.23,0.8,111,10065,75,NULL,'CF, r','UGC 03209',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000023,NULL,'14.86',0.7,'SB(s)bc pec',NULL,NULL,NULL,NULL,1,74.1094166667,3.03192,0.233,NULL,64622130063,1009720782,15776887,14.86),(36717,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36717,34.58,0.38,82.4,10065,75,NULL,'CF, r, raw','UGC 03209',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36718,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36718,34.68,0.38,86.4,10065,75,NULL,'CF, r, inv','UGC 03209',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36719,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36719,34.86,0.38,93.6,10065,75,NULL,'CF, r, cor','UGC 03209',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36720,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36720,33.49,NULL,49.9,10066,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0516',NULL,'2010Ap&SS.325..163P',2010,1,1.36,'Matthews (2000A&AS..143..421M) detects another feature at v=2295 km/sec.','G',0.000057,NULL,'16.0',0.16,'Scd',NULL,NULL,NULL,NULL,1,74.135833,-12.40194,0.273,NULL,37521589275,586274832,9160544,16),(36721,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36721,33.49,NULL,49.9,10066,NULL,NULL,'Dipole + Quadrupole','FGC 0516',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36722,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36722,33.5,NULL,50.1,10066,NULL,NULL,'Dipole','FGC 0516',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36723,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36723,33.58,NULL,52,10066,NULL,NULL,NULL,'FGC 0516',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36724,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36724,35.6,0.6,132,10067,70,NULL,NULL,'2MASX J04563276-2009183',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'17.00',0.25,NULL,NULL,NULL,NULL,NULL,1,74.1365,-20.15519,0.021,NULL,37561688745,586901386,9170334,17),(36725,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36725,34.09,0.8,65.8,10068,75,NULL,'MAT, I','IC 2106',NULL,'1997ApJS..109..333W',1997,1,1.7,'Confused HIPASS source','G',0.000017,NULL,'13.75',0.9,'(R\')SB(r)ab',NULL,NULL,NULL,NULL,1,74.1412083,-28.50392,0,NULL,37232572263,581758941,9089983,13.75),(36726,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36726,33.98,0.43,62.6,10068,75,NULL,'MAT, I, raw','IC 2106',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36727,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36727,33.99,0.32,62.9,10068,85,NULL,'I, raw','IC 2106',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36728,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36728,34.06,0.32,64.8,10068,85,NULL,'I, inv','IC 2106',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36729,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36729,34.16,0.47,67.9,10068,NULL,NULL,'H','IC 2106',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36730,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36730,34.18,0.46,68.6,10068,NULL,NULL,'J','IC 2106',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36731,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36731,34.21,0.45,69.6,10068,NULL,NULL,'K','IC 2106',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36732,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36732,34.22,0.43,69.8,10068,75,NULL,'MAT, I, cor','IC 2106',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36733,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36733,34.22,0.35,69.9,10068,NULL,NULL,'Malmquist cor.','IC 2106',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36734,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36734,34.25,0.43,70.7,10068,75,NULL,'MAT, I, inv','IC 2106',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36735,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36735,34.26,0.4,71.2,10068,NULL,NULL,'mean','IC 2106',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36736,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36736,34.32,0.2,73.1,10068,74.4,NULL,NULL,'IC 2106',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36737,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36737,34.38,0.32,75.3,10068,NULL,NULL,NULL,'IC 2106',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36738,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36738,35.5,0.51,126,10069,70,NULL,NULL,'2MASX J04563699-2225513',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.000103,NULL,'16.41',0.32,'S0',NULL,NULL,NULL,NULL,1,74.154167,-22.43097,0.029,NULL,37330730408,583292662,9113947,16.41),(36739,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36739,33.63,0.8,53.3,10070,75,NULL,'MAT, I','MCG -02-13-025',NULL,'1997ApJS..109..333W',1997,1,2.2,'Confused HIPASS source','G',0.000017,NULL,'14.25',1,'SB(rs)bc       HII',NULL,NULL,NULL,NULL,1,74.1912083,-10.59311,0.161,NULL,37494567963,585852624,9153947,14.25),(36740,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36740,33.24,0.32,44.4,10070,85,NULL,'I, raw','MCG -02-13-025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36741,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36741,33.26,0.32,44.9,10070,85,NULL,'I, inv','MCG -02-13-025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36742,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36742,33.29,0.2,45.5,10070,74.4,NULL,NULL,'MCG -02-13-025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36743,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36743,33.46,0.49,49.3,10070,NULL,NULL,NULL,'MCG -02-13-025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36744,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36744,33.61,0.43,52.7,10070,75,NULL,'MAT, I, raw','MCG -02-13-025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36745,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36745,33.67,0.44,54.3,10070,NULL,NULL,'Malmquist cor.','MCG -02-13-025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36746,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36746,33.74,0.43,56.1,10070,75,NULL,'MAT, I, inv','MCG -02-13-025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36747,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36747,33.8,0.43,57.4,10070,75,NULL,'MAT, I, cor','MCG -02-13-025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36748,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36748,36.27,0.86,179,10071,70,NULL,NULL,'2MASX J04564787-2545181',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.000103,NULL,'16.74',0.35,NULL,NULL,NULL,NULL,NULL,1,74.1995,-25.755,0.061,NULL,37228531815,581695809,9088997,16.74),(36749,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36749,35.43,0.41,122,10072,70,NULL,NULL,'GIN 217',NULL,'2001MNRAS.321..277C',2001,1,0.65,NULL,'G',0.000123,NULL,'14.08',0.39,'E/S0',NULL,NULL,NULL,NULL,1,74.2235,-18.24544,0.069,NULL,37557928865,586842638,9169416,14.08),(36750,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36750,35.89,0.51,150,10072,70,NULL,NULL,'GIN 217',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36751,'SBF','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36751,33.23,0.16,44.3,10073,NULL,NULL,'I','NGC 1700',NULL,'2001ApJ...546..681T',2001,1,3.3,NULL,'G',0.000023,NULL,'12.20',2.1,'E4','in a pair',NULL,NULL,NULL,1,74.234625,-4.86578,0.113,NULL,36636333301,572442707,8944417,12.2),(36752,'SBF','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36752,33.23,0.16,44.3,10073,NULL,NULL,NULL,'NGC 1700',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36753,'SBF','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36753,33.29,0.14,45.5,10073,74.4,NULL,NULL,'NGC 1700',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36754,'SBF','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36754,33.33,0.16,46.4,10073,NULL,NULL,'Malmquist cor.','NGC 1700',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36755,'D-Sigma','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36755,32.64,0.4,33.7,10073,75,NULL,'Edat, raw','NGC 1700',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36756,'D-Sigma','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36756,33.01,0.4,40,10073,75,NULL,'Edat, cor','NGC 1700',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36757,'Faber-Jackson','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36757,30.78,0.63,14.3,10073,95,NULL,'Michard 1979b, c','NGC 1700',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36758,'Faber-Jackson','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36758,31.42,0.46,19.2,10073,95,NULL,'Michard 1979a','NGC 1700',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36759,'Faber-Jackson','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36759,31.54,0.25,20.3,10073,95,NULL,'Weighted Mean','NGC 1700',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36760,'Faber-Jackson','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36760,32.02,0.34,25.4,10073,95,NULL,'de Vaucouleurs','NGC 1700',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36761,'Faber-Jackson','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36761,32.31,0.81,29,10073,55,NULL,'Visvanathan & Sandage 1979','NGC 1700',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36762,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36762,32.47,0.41,31.2,10073,NULL,NULL,NULL,'NGC 1700',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36763,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36763,32.6,0.47,33.1,10073,70,NULL,NULL,'NGC 1700',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36764,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36764,32.97,0.41,39.2,10073,NULL,NULL,'Malmquist cor.','NGC 1700',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36765,'Tertiary','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36765,32.6,0.25,33.1,10073,95,NULL,NULL,'NGC 1700',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36766,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36766,32.92,0.45,38.4,10073,NULL,NULL,'K','NGC 1700',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36767,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36767,33.59,0.4,52.2,10073,NULL,NULL,'mean','NGC 1700',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36768,'TRGB','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36768,29.21,0.1,6.95,10074,74.4,NULL,NULL,'ESO 252-IG 001',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'GPair',0.000017,NULL,NULL,NULL,'Double system',NULL,NULL,NULL,NULL,1,74.244583,-42.80389,0,NULL,37602397376,587537459,9180272,NULL),(36769,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36769,29.29,NULL,7.21,10074,NULL,NULL,NULL,'ESO 252-IG 001',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36770,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2001ep',NULL,36770,32.95,0.23,38.4,10075,74.2,NULL,'SALT 2','NGC 1699',0.013012,'2010ApJ...716..712A',2010,1,0.9,NULL,'G',0.00015,NULL,'14.3b',0.5,'SA(rs)b','in a pair',NULL,NULL,NULL,1,74.2484583,-4.75686,0.141,NULL,36636357057,572443079,8944423,14.3),(36771,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2001ep',NULL,36771,33.54,0.03,50.4,10075,72,NULL,'MLCS31','NGC 1699',0.013012,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36772,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2001ep',NULL,36772,33.54,0.09,51.1,10075,74.4,NULL,NULL,'NGC 1699',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36773,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2001ep',NULL,36773,33.62,0.19,52.2,10075,73.8,NULL,'SALT 2 (SNANA)','NGC 1699',0.0133,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36774,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2001ep',NULL,36774,33.73,0.22,55.1,10075,70,NULL,'SALT 2','NGC 1699',0.013012,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36775,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2001ep',NULL,36775,33.8,0.25,56.7,10075,65,NULL,'MLCS31','NGC 1699',0.013012,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36776,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2001ep',NULL,36776,33.86,0.27,58.4,10075,65,NULL,'SALT2','NGC 1699',0.013012,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36777,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2001ep',NULL,36777,33.89,0.25,59.3,10075,65,NULL,'MLCS17','NGC 1699',0.013012,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36778,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2001ep',NULL,36778,34.53,0.03,79.4,10075,70,NULL,'SALT 2','NGC 1699',0.013012,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36779,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36779,35.24,0.25,112,10076,74.4,NULL,NULL,'GIN 216',NULL,'2013AJ....146...86T',2013,1,0.59,NULL,'G',0.00015,NULL,'14.02',0.55,'E/S0',NULL,NULL,NULL,NULL,1,74.268625,-18.28589,0.069,NULL,37560222515,586878476,9169976,14.02),(36780,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36780,35.43,0.41,122,10076,70,NULL,NULL,'GIN 216',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36781,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36781,35.95,0.49,155,10076,70,NULL,NULL,'GIN 216',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36782,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36782,36.02,0.52,160,10077,70,NULL,NULL,'2MASX J04570721-5432570',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'15.8b',0.24,NULL,NULL,NULL,NULL,NULL,1,74.2801666667,-54.54928,0.205,NULL,35946540234,561664691,8776010,15.8),(36783,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36783,35.79,0.53,144,10078,70,NULL,NULL,'2MASX J04571145-4237053',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.38',0.28,NULL,NULL,NULL,NULL,NULL,1,74.2977083,-42.61814,0,NULL,37602289797,587535778,9180246,16.38),(36784,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36784,33.83,0.46,58.2,10079,70,NULL,NULL,'NGC 1710',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000087,NULL,'12.45',1,'SA0-:',NULL,NULL,NULL,NULL,1,74.321125,-15.289,0.145,NULL,37577652012,587150812,9174231,12.45),(36785,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36785,35.43,0.41,122,10080,70,NULL,NULL,'GIN 219',NULL,'2001MNRAS.321..277C',2001,1,0.74,NULL,'G',0.000093,NULL,'15.87',0.39,'S',NULL,NULL,NULL,NULL,1,74.3238333333,-17.45414,0.157,NULL,37578965821,587171340,9174552,15.87),(36786,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36786,36.54,0.25,203,10080,74.4,NULL,NULL,'GIN 219',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36787,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36787,36.83,0.56,232,10081,70,NULL,NULL,'2MASX J04572091-1114473',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,74.3372083,-11.24656,0.233,NULL,37490690783,585792043,9153000,17),(36788,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36788,32.03,0.4,25.5,10082,75,NULL,'B','IC 0391',NULL,'1988NBGC.C....0000T',1988,1,1.1,NULL,'G',0.000027,NULL,'13.0',1.1,'SA(s)c','Isolated galaxy',NULL,NULL,NULL,1,74.3380417,78.18883,0.417,NULL,65655556448,1025868069,16029188,13),(36789,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36789,36.03,0.77,160,10083,70,NULL,NULL,'2MFGC 04056',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'11.8K',0.14,NULL,NULL,NULL,NULL,NULL,1,74.3392917,-52.78308,0,NULL,35720714594,558136165,8720877,11.8),(36790,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36790,33.7,0.2,55,10084,74.4,NULL,NULL,'UGC 03211',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000017,NULL,'15.07',0.3,'SBcd: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,74.3442083,1.89406,0.277,NULL,64621247317,1009706989,15776671,15.07),(36791,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36791,33.89,0.28,59.9,10084,NULL,NULL,NULL,'UGC 03211',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36792,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36792,33.99,0.26,62.7,10084,NULL,NULL,'Malmquist cor.','UGC 03211',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36793,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36793,36.04,0.54,161,10085,70,NULL,NULL,'2MASX J04572303-2213021',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'17.16',0.2,NULL,NULL,NULL,NULL,NULL,1,74.34575,-22.21725,0.029,NULL,37331204447,583300069,9114063,17.16),(36794,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36794,35.4,0.5,120,10086,NULL,NULL,'Malmquist cor.','2MASX J04572695-0004153',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000027,NULL,'14.1I',NULL,NULL,NULL,NULL,NULL,NULL,1,74.3622917,-0.07089,0.297,NULL,36612663147,572072861,8938638,14.1),(36795,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36795,35.39,0.5,120,10086,NULL,NULL,NULL,'2MASX J04572695-0004153',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36796,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36796,35.43,0.2,122,10086,74.4,NULL,NULL,'2MASX J04572695-0004153',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36797,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36797,36.03,0.54,161,10087,70,NULL,NULL,'2MASX J04573050-2002251',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,74.377125,-20.04025,0.029,NULL,37561768417,586902631,9170353,14),(36798,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36798,34.43,0.5,76.9,10088,70,NULL,NULL,'CGCG 394-049',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.0001,NULL,'15.3b',0.4,NULL,NULL,NULL,NULL,NULL,1,74.38625,-1.12275,0.277,NULL,36612363747,572068183,8938565,15.3),(36799,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,'R',36799,35.13,0.49,106,10089,75,NULL,'IR','FGC 0517',NULL,'2011yCatp016004901K',2011,1,1.18,NULL,'G',0.00004,NULL,'16.8',0.1,'Scd',NULL,NULL,NULL,NULL,1,74.4018333333,-11.82611,0.277,NULL,37521077880,586266841,9160419,16.8),(36800,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36800,35.58,NULL,131,10089,NULL,NULL,'Dipole','FGC 0517',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36801,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36801,35.58,NULL,131,10089,NULL,NULL,'Dipole + Quadrupole','FGC 0517',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36802,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36802,35.59,NULL,131,10089,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0517',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36803,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36803,35.65,NULL,135,10089,NULL,NULL,NULL,'FGC 0517',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36804,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36804,33.64,0.47,53.6,10090,NULL,NULL,'H','UGC 03214',NULL,'2007A&A...465...71T',2007,1,3.75,NULL,'G',0.000017,NULL,'13.96',0.62,'Sb',NULL,NULL,NULL,NULL,1,74.4860417,-0.12578,0.281,NULL,36612615647,572072119,8938626,13.96),(36805,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36805,33.64,0.45,53.6,10090,NULL,NULL,'K','UGC 03214',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36806,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36806,33.69,0.46,54.8,10090,NULL,NULL,'J','UGC 03214',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36807,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36807,33.91,0.26,60.7,10090,NULL,NULL,NULL,'UGC 03214',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36808,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36808,33.93,0.25,61.1,10090,NULL,NULL,'Malmquist cor.','UGC 03214',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36809,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,'R',36809,33.93,0.49,61.1,10090,75,NULL,'IR','UGC 03214',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36810,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36810,34.04,0.4,64.3,10090,NULL,NULL,'mean','UGC 03214',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36811,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36811,34.06,0.2,64.9,10090,74.4,NULL,NULL,'UGC 03214',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36812,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36812,34.18,0.43,68.6,10090,75,NULL,'3.6 micron, color corrected','UGC 03214',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36813,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36813,34.31,0.43,72.9,10090,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03214',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36814,'Tully est','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36814,30.79,0.8,14.4,10091,75,NULL,'B','IC 0396',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.00003,NULL,'13.0',1.4,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,74.4957917,68.32339,0.625,NULL,66381248588,1037207009,16206359,13),(36815,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36815,30.6,0.43,13.2,10091,75,NULL,'3.6 micron, color + selection bias corrected','IC 0396',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36816,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36816,30.72,0.43,13.9,10091,75,NULL,'3.6 micron, color corrected','IC 0396',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36817,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36817,30.73,0.45,14,10091,NULL,NULL,'K','IC 0396',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36818,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36818,30.75,0.47,14.2,10091,NULL,NULL,'H','IC 0396',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36819,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36819,30.79,0.2,14.4,10091,74.4,NULL,NULL,'IC 0396',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36820,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36820,30.81,0.46,14.5,10091,NULL,NULL,'J','IC 0396',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36821,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36821,31.09,0.4,16.5,10091,NULL,NULL,'mean','IC 0396',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36822,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36822,34.81,0.51,91.7,10092,70,NULL,NULL,'2MASX J04581249-0509328',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'15.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,74.5521666667,-5.15914,0.141,NULL,36634950358,572421099,8944079,15.5),(36823,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1997G','R',36823,42.88,NULL,2140,10093,65,NULL,'SALT','H-ZSNS J045830.23-031604.0',0.763,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,'Merging pair',NULL,NULL,NULL,NULL,1,74.6259583,-3.26778,0.113,NULL,36640874432,572513663,8945525,NULL),(36824,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1997G',NULL,36824,43.78,0.91,3230,10093,74.2,NULL,'SALT 2','H-ZSNS J045830.23-031604.0',0.763,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36825,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1997G',NULL,36825,44.37,0.89,4240,10093,70,NULL,'SALT','H-ZSNS J045830.23-031604.0',0.763,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36826,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1997G',NULL,36826,44.64,0.85,4810,10093,65,NULL,'SALT','H-ZSNS J045830.23-031604.0',0.763,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36827,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36827,34.13,0.25,67,10094,74.4,NULL,NULL,'CGCG 394-055',NULL,'2013AJ....146...86T',2013,1,0.3,'1999PASP..111..438F has V = 4799 +- 52 km/sec.','G',0.000087,NULL,'13.79',0.2,'SB0','Group member',NULL,NULL,NULL,1,74.6310833333,-0.57467,0.293,NULL,36615603494,572118804,8939356,13.79),(36828,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36828,34.36,0.32,74.4,10094,70,NULL,NULL,'CGCG 394-055',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36829,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36829,34.13,0.25,67,10095,74.4,NULL,NULL,'CGCG 394-056',NULL,'2013AJ....146...86T',2013,1,0.2,NULL,'G',0.000083,NULL,'15.28',0.2,'S','Group member',NULL,NULL,NULL,1,74.6386666667,-0.55325,0.293,NULL,36615603867,572118810,8939356,15.28),(36830,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36830,34.25,0.49,70.8,10095,70,NULL,NULL,'CGCG 394-056',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36831,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36831,34.36,0.32,74.4,10095,70,NULL,NULL,'CGCG 394-056',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36832,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36832,36.24,0.53,177,10096,70,NULL,NULL,'2MASX J04583342-4624432',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000087,NULL,'15.59',0.53,'E',NULL,NULL,NULL,NULL,1,74.6392083,-46.41203,0,NULL,37625707967,587901686,9185963,15.59),(36833,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36833,34.14,0.25,67.3,10097,74.4,NULL,NULL,'GIN 213',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.00013,NULL,'14.34',NULL,'S',NULL,NULL,NULL,NULL,1,74.66025,-0.29108,0.281,NULL,36615539795,572117809,8939340,14.34),(36834,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36834,34.36,0.32,74.4,10097,70,NULL,NULL,'GIN 213',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36835,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36835,34.14,0.25,67.3,10098,74.4,NULL,NULL,'NGC 1709',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000053,NULL,'15.17',0.7,'SB0^0^:','Group member',NULL,NULL,NULL,1,74.6834583,-0.47825,0.293,NULL,36615722601,572120665,8939385,15.17),(36836,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36836,34.36,0.32,74.4,10098,70,NULL,NULL,'NGC 1709',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36837,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36837,34.3,0.48,72.5,10099,70,NULL,NULL,'ESO 552- G 040',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000073,NULL,'14.26',0.7,'SB(s)ab: pec   LLAGN','in a pair',NULL,NULL,NULL,1,74.6960833333,-21.56942,0.021,NULL,37550486252,586726347,9167599,14.26),(36838,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36838,35.91,0.51,152,10100,70,NULL,NULL,'2MASX J04584878-2141328',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.71',0.4,NULL,NULL,NULL,NULL,NULL,1,74.703083,-21.69244,0.021,NULL,37550430641,586725478,9167585,16.71),(36839,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36839,35.26,0.8,113,10101,75,NULL,'CF, r','UGC 03220',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000023,NULL,'15.29',0.6,'Sd',NULL,NULL,NULL,NULL,1,74.703333,7.11386,0.317,NULL,64600074908,1009376170,15771502,15.29),(36840,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36840,35.26,0.8,113,10101,75,NULL,'HMCL, I','UGC 03220',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36841,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36841,35.26,0.8,113,10101,75,NULL,'W91CL, r','UGC 03220',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36842,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36842,34.68,0.38,86.3,10101,75,NULL,'W91CL, r, raw','UGC 03220',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36843,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36843,34.73,0.38,88.1,10101,75,NULL,'W91CL, r, inv','UGC 03220',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36844,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36844,34.74,0.38,88.5,10101,75,NULL,'CF, r, raw','UGC 03220',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36845,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36845,34.79,0.38,90.7,10101,75,NULL,'CF, r, inv','UGC 03220',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36846,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36846,35.1,0.38,105,10101,75,NULL,'W91CL, r, cor','UGC 03220',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36847,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36847,35.11,0.38,105,10101,75,NULL,'CF, r, cor','UGC 03220',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36848,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36848,35.31,0.4,115,10101,75,NULL,'HMCL, I, raw','UGC 03220',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36849,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36849,35.45,0.4,123,10101,75,NULL,'HMCL, I, inv','UGC 03220',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36850,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36850,35.57,0.4,130,10101,75,NULL,'HMCL, I, cor','UGC 03220',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36851,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36851,35.25,0.8,112,10102,75,NULL,'HMCL, I','UGC 03219',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000023,NULL,'15.30',0.5,'Sd',NULL,NULL,NULL,NULL,1,74.708125,6.9775,0.317,NULL,64600564126,1009383814,15771622,15.3),(36852,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36852,35.25,0.8,112,10102,75,NULL,'CF, r','UGC 03219',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36853,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36853,35.25,0.8,112,10102,75,NULL,'W91CL, r','UGC 03219',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36854,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36854,34.45,0.38,77.5,10102,75,NULL,'CF, r, raw','UGC 03219',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36855,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36855,34.51,0.38,80,10102,75,NULL,'CF, r, inv','UGC 03219',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36856,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36856,34.52,0.38,80.1,10102,75,NULL,'W91CL, r, raw','UGC 03219',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36857,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36857,34.57,0.58,82.1,10102,NULL,NULL,'Malmquist cor.','UGC 03219',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36858,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36858,34.58,0.38,82.5,10102,75,NULL,'W91CL, r, inv','UGC 03219',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36859,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36859,34.63,0.2,84.3,10102,74.4,NULL,NULL,'UGC 03219',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36860,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36860,34.66,0.56,85.4,10102,NULL,NULL,NULL,'UGC 03219',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36861,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36861,34.71,0.38,87.7,10102,75,NULL,'CF, r, cor','UGC 03219',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36862,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36862,34.8,0.4,91,10102,75,NULL,'HMCL, I, raw','UGC 03219',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36863,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36863,34.88,0.38,94.8,10102,75,NULL,'W91CL, r, cor','UGC 03219',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36864,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36864,34.92,0.4,96.5,10102,75,NULL,'HMCL, I, inv','UGC 03219',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36865,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36865,35.18,0.4,109,10102,75,NULL,'HMCL, I, cor','UGC 03219',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36866,'D-Sigma','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36866,34.33,0.4,73.6,10103,75,NULL,'Edat, raw','NGC 1713',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000067,NULL,'13.91',1.2,'cD;E+:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,74.7275417,-0.48892,0.293,NULL,36615747851,572121060,8939391,13.91),(36867,'D-Sigma','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36867,34.67,0.4,85.8,10103,75,NULL,'Edat, cor','NGC 1713',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36868,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36868,33.98,0.48,62.4,10103,70,NULL,NULL,'NGC 1713',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36869,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36869,34.13,0.25,67,10103,74.4,NULL,NULL,'NGC 1713',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36870,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36870,34.36,0.32,74.4,10103,70,NULL,NULL,'NGC 1713',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36871,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36871,33.97,0.4,62.3,10103,NULL,NULL,'mean','NGC 1713',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36872,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36872,34.22,0.45,69.8,10103,NULL,NULL,'K','NGC 1713',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36873,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36873,34.08,0.8,65.5,10104,75,NULL,'MAT, I','NGC 1771',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'14.16',0.5,'SAB(r)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,74.732167,-63.29822,0.005,NULL,35882410208,560662659,8760354,14.16),(36874,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36874,33.5,0.32,50.1,10104,85,NULL,'I, raw','NGC 1771',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36875,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36875,33.54,0.32,51.1,10104,85,NULL,'I, inv','NGC 1771',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36876,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36876,33.57,0.43,51.7,10104,75,NULL,'MAT, I, raw','NGC 1771',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36877,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,'R',36877,33.74,0.49,56,10104,75,NULL,'IR','NGC 1771',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36878,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36878,33.77,0.43,56.7,10104,75,NULL,'MAT, I, inv','NGC 1771',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36879,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36879,34.02,0.43,63.6,10104,75,NULL,'MAT, I, cor','NGC 1771',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36880,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36880,34.18,0.36,68.4,10104,NULL,NULL,NULL,'NGC 1771',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36881,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36881,34.2,0.47,69.1,10104,NULL,NULL,'H','NGC 1771',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36882,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36882,34.22,0.2,69.8,10104,74.4,NULL,NULL,'NGC 1771',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36883,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36883,34.24,0.35,70.5,10104,NULL,NULL,'Malmquist cor.','NGC 1771',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36884,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36884,34.28,0.4,71.7,10104,NULL,NULL,'mean','NGC 1771',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36885,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36885,34.32,0.46,73,10104,NULL,NULL,'J','NGC 1771',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36886,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36886,34.34,0.45,73.8,10104,NULL,NULL,'K','NGC 1771',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36887,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1997eq','R',36887,41.6,NULL,1360,10105,65,NULL,'SALT','H-ZSNS J045856.32-035929.4',0.54,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,74.734667,-3.9915,0.121,NULL,36640998122,572515595,8945556,NULL),(36888,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1997eq',NULL,36888,41.71,0.11,1430,10105,74.2,NULL,'SALT 2','H-ZSNS J045856.32-035929.4',0.54,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36889,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1997eq',NULL,36889,42.43,0.12,1990,10105,70,NULL,'SALT','H-ZSNS J045856.32-035929.4',0.54,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36890,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1997eq',NULL,36890,42.61,0.08,2160,10105,65,NULL,'SALT','H-ZSNS J045856.32-035929.4',0.54,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36891,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1997eq',NULL,36891,42.66,0.18,2210,10105,65,NULL,NULL,'H-ZSNS J045856.32-035929.4',0.54,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36892,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36892,35.73,0.57,140,10106,70,NULL,NULL,'2MASX J04585986-4556412',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.28',0.4,'E',NULL,NULL,NULL,NULL,1,74.749417,-45.94483,0,NULL,37625357801,587896215,9185878,16.28),(36893,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36893,34.12,0.4,66.6,10107,NULL,NULL,'mean','UGC 03223',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000043,NULL,'13.83',0.8,'SBa            Sy1','in a pair',NULL,NULL,'Sy 1.5',1,74.789125,4.975,0.397,NULL,64615999129,1009624986,15775390,13.83),(36894,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36894,34.21,0.45,69.6,10107,NULL,NULL,'K','UGC 03223',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36895,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36895,34.25,0.47,70.7,10107,NULL,NULL,'H','UGC 03223',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36896,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36896,34.34,0.46,73.7,10107,NULL,NULL,'J','UGC 03223',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36897,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36897,37.27,0.61,284,10108,70,NULL,NULL,'2MASX J04591868-2408136',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'16.85',0.36,NULL,NULL,NULL,NULL,NULL,1,74.8277917,-24.13708,0.033,NULL,37213677932,581463717,9085370,16.85),(36898,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36898,33.82,0.4,58,10109,NULL,NULL,'mean','NGC 1720',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.00002,NULL,'13',1,'SB(s)ab','in a pair',NULL,NULL,NULL,1,74.8359583,-7.85897,0.193,NULL,36601138460,571892788,8935824,13),(36899,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36899,33.91,0.45,60.6,10109,NULL,NULL,'K','NGC 1720',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36900,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36900,33.96,0.47,61.9,10109,NULL,NULL,'H','NGC 1720',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36901,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36901,34.03,0.46,63.8,10109,NULL,NULL,'J','NGC 1720',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36902,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36902,36.8,0.91,229,10110,70,NULL,NULL,'2MASX J04592064-0030254',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,74.836083,-0.50708,0.293,NULL,36615709298,572120457,8939382,16.6),(36903,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36903,34.12,0.4,66.8,10111,NULL,NULL,'mean','UGC 03224',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000023,NULL,'13.66',1.2,'Sb','in a pair',NULL,NULL,NULL,1,74.837875,5.61831,0.357,NULL,64615751953,1009621124,15775330,13.66),(36904,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36904,34.24,0.47,70.6,10111,NULL,NULL,'H','UGC 03224',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36905,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36905,34.34,0.46,73.9,10111,NULL,NULL,'J','UGC 03224',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36906,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36906,34.35,0.45,74.1,10111,NULL,NULL,'K','UGC 03224',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36907,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2009F',NULL,36907,33.66,0.2,52.6,10112,72,NULL,NULL,'NGC 1725',0.01292,'2013ApJ...773...53F',2013,1,1.23,NULL,'G',0.00014,NULL,'13.70',1.01,'S0','in a triple',NULL,NULL,NULL,1,74.845375,-11.13231,0.269,NULL,37494186676,585846666,9153854,13.7),(36908,'Sosies','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36908,32.58,0.56,32.8,10113,NULL,NULL,NULL,'NGC 1723',NULL,'2002A&A...393...57T',2002,1,3.2,NULL,'G',0.000023,NULL,'12.5',2,'SB(r)a pec',NULL,NULL,NULL,NULL,1,74.857875,-10.98069,0.265,NULL,37494132061,585845813,9153840,12.5),(36909,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36909,33.26,0.47,44.9,10113,NULL,NULL,'H','NGC 1723',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36910,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36910,33.28,0.45,45.4,10113,NULL,NULL,'K','NGC 1723',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36911,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36911,33.3,0.46,45.7,10113,NULL,NULL,'J','NGC 1723',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36912,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36912,33.54,0.4,51.1,10113,NULL,NULL,'mean','NGC 1723',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36913,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1992bh',NULL,36913,35.91,0.17,146,10114,74.2,NULL,'SALT 2','LSBG F119-024',0.045,'2010ApJ...716..712A',2010,1,0.63,NULL,'G',0.002,NULL,'17.8',0.37,'Sbc',NULL,NULL,NULL,NULL,1,74.862417,-58.82956,0,NULL,35964771186,561949549,8780461,17.8),(36914,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1992bh',NULL,36914,36.33,0.22,177,10114,72,NULL,NULL,'LSBG F119-024',0.045,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36915,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1992bh',NULL,36915,36.44,0.17,194,10114,70.8,NULL,NULL,'LSBG F119-024',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36916,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1992bh',NULL,36916,36.55,0.18,196,10114,70,NULL,'SALT 2','LSBG F119-024',0.045,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36917,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1992bh',NULL,36917,36.57,0.03,197,10114,72,NULL,NULL,'LSBG F119-024',0.045,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36918,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1992bh',NULL,36918,36.48,0.08,198,10114,74.4,NULL,NULL,'LSBG F119-024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36919,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1992bh',NULL,36919,36.57,0.19,198,10114,73.8,NULL,'SALT 2 (SNANA)','LSBG F119-024',0.0419,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36920,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1992bh',NULL,36920,36.62,0.1,202,10114,65,NULL,'SALT2','LSBG F119-024',0.045,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36921,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1992bh',NULL,36921,36.66,0.15,206,10114,70,NULL,'SALT','LSBG F119-024',0.045,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36922,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1992bh',NULL,36922,36.73,0.06,212,10114,70,NULL,NULL,'LSBG F119-024',0.045,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36923,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1992bh',NULL,36923,36.77,0.14,216,10114,65,NULL,'SALT','LSBG F119-024',0.045,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36924,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1992bh',NULL,36924,36.77,0.18,216,10114,65,NULL,'SALT2','LSBG F119-024',0.045,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36925,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1992bh',NULL,36925,36.9,0.13,220,10114,65,NULL,'MLCS2k2','LSBG F119-024',0.045,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36926,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1992bh',NULL,36926,36.87,0.17,226,10114,65,NULL,'Template','LSBG F119-024',0.045,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36927,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1992bh',NULL,36927,36.87,0.18,227,10114,65,NULL,'MLCS31','LSBG F119-024',0.045,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36928,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1992bh',NULL,36928,36.89,0.08,228,10114,65,NULL,'MLCS2k2','LSBG F119-024',0.045,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36929,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1992bh',NULL,36929,36.9,0.16,229,10114,65,NULL,'MLCS17','LSBG F119-024',0.045,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36930,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1992bh',NULL,36930,36.91,0.14,230,10114,65,NULL,'MLCS2k2','LSBG F119-024',0.045,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36931,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1992bh',NULL,36931,36.91,0.17,231,10114,65,NULL,'MLCS','LSBG F119-024',0.045,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36932,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1992bh',NULL,36932,36.97,0.18,237,10114,65,NULL,NULL,'LSBG F119-024',0.045,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36933,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1992bh',NULL,36933,36.89,0.06,239,10114,60,NULL,'M(I) = -19.19 mag','LSBG F119-024',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36934,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1992bh',NULL,36934,36.98,0.03,239,10114,65,NULL,'SALT','LSBG F119-024',0.045,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36935,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1992bh',NULL,36935,36.93,0.14,243,10114,60,NULL,NULL,'LSBG F119-024',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36936,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1992bh',NULL,36936,36.95,0.06,245,10114,60,NULL,'M(V) = -19.47 mag','LSBG F119-024',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36937,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1992bh',NULL,36937,37.08,0.03,249,10114,70,NULL,'SALT 2','LSBG F119-024',0.045,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36938,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1992bh',NULL,36938,37,0.08,251,10114,60,NULL,'M(B) = -19.48 mag','LSBG F119-024',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36939,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36939,33.02,0.97,40.2,10115,NULL,NULL,NULL,'MCG -03-13-042',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000025,NULL,'13.5',1.1,'SB(s)c',NULL,NULL,NULL,NULL,1,74.862875,-16.55953,0.145,NULL,37571550169,587055471,9172741,13.5),(36940,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36940,33.06,0.2,40.9,10115,74.4,NULL,NULL,'MCG -03-13-042',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36941,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36941,33.61,0.74,52.8,10115,NULL,NULL,'Malmquist cor.','MCG -03-13-042',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36942,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36942,33.25,0.45,44.7,10116,NULL,NULL,'K','NGC 1728',NULL,'2007A&A...465...71T',2007,1,2,NULL,'G',0.000037,NULL,'13',0.7,'Sa pec sp','in a triple',NULL,NULL,NULL,1,74.8655417,-11.12294,0.269,NULL,37494188525,585846695,9153854,13),(36943,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36943,33.26,0.47,44.8,10116,NULL,NULL,'H','NGC 1728',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36944,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36944,33.3,0.46,45.7,10116,NULL,NULL,'J','NGC 1728',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36945,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36945,33.55,0.4,51.4,10116,NULL,NULL,'mean','NGC 1728',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36946,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36946,35.33,0.52,116,10117,70,NULL,NULL,'2MASX J04592917-1601342',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.11',NULL,NULL,NULL,NULL,NULL,NULL,1,74.8714583,-16.02628,0.137,NULL,37569898591,587029665,9172338,16.11),(36947,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36947,35.65,0.64,135,10118,70,NULL,NULL,'ESO 033-IG 008 NED02',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.38',NULL,NULL,NULL,NULL,NULL,NULL,1,74.878917,-76.16225,0.429,NULL,35545554197,555399284,8678113,17.38),(36948,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36948,33.64,0.47,53.4,10119,NULL,NULL,'H','NGC 1730',NULL,'2007A&A...465...71T',2007,1,2.2,NULL,'G',0.00002,NULL,'13.3b',1,'SB(r)a',NULL,NULL,NULL,NULL,1,74.882625,-15.82364,0.137,NULL,37570365496,587036960,9172452,13.3),(36949,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36949,33.66,0.46,54,10119,NULL,NULL,'J','NGC 1730',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36950,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36950,33.69,0.4,54.8,10119,NULL,NULL,'mean','NGC 1730',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36951,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36951,33.71,0.45,55.2,10119,NULL,NULL,'K','NGC 1730',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36952,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36952,36.13,0.5,169,10120,70,NULL,NULL,'GIN 230',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.000063,NULL,'14.13',0.5,'E',NULL,NULL,NULL,NULL,1,74.888875,-18.20481,0.101,NULL,37552860958,586763452,9168178,14.13),(36953,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36953,36.14,0.38,169,10120,70,NULL,NULL,'GIN 230',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36954,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36954,32.81,0.43,36.4,10121,75,NULL,'3.6 micron, color + selection bias corrected','ESO 486- G 003',NULL,'2014MNRAS.444..527S',2014,1,1.7,NULL,'G',0.00001,NULL,'15.59',0.8,'SAB(s)m',NULL,NULL,NULL,NULL,1,74.890917,-22.697,0.025,NULL,37333184284,583331004,9114546,15.59),(36955,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36955,33.75,0.48,56.2,10122,70,NULL,NULL,'NGC 1719',NULL,'2014MNRAS.445.2677S',2014,1,1.1,'HOLM 083B is a star.','G',0.00009,NULL,'14.53',0.3,'Sa: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,74.8942917,-0.26042,0.293,NULL,36614677921,572104342,8939130,14.53),(36956,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36956,34.7,0.8,87.2,10123,75,NULL,'MAT, I','ESO 552- G 043',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.00002,NULL,'14.78',0.7,'SAB(rs)cd:',NULL,NULL,NULL,NULL,1,74.8970417,-19.19903,0.085,NULL,37560783769,586887246,9170113,14.78),(36957,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36957,34.03,0.32,63.9,10123,85,NULL,'I, raw','ESO 552- G 043',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36958,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36958,34.06,0.32,64.8,10123,85,NULL,'I, inv','ESO 552- G 043',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36959,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36959,34.18,0.43,68.5,10123,75,NULL,'MAT, I, raw','ESO 552- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36960,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36960,34.33,0.43,73.3,10123,75,NULL,'MAT, I, inv','ESO 552- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36961,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36961,34.47,0.43,78.4,10123,75,NULL,'MAT, I, cor','ESO 552- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36962,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36962,34.53,0.2,80.5,10123,74.4,NULL,NULL,'ESO 552- G 043',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36963,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36963,34.63,0.45,84.3,10123,NULL,NULL,NULL,'ESO 552- G 043',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36964,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36964,34.64,0.45,84.8,10123,NULL,NULL,'Malmquist cor.','ESO 552- G 043',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36965,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1997H',NULL,36965,41.23,0.52,1150,10124,74.2,NULL,'SALT 2','H-ZSNS J045936.57-030934.6',0.53,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'E',NULL,NULL,NULL,NULL,1,74.902375,-3.15961,0.149,NULL,36639856424,572497756,8945277,NULL),(36966,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1997H','R',36966,41.65,NULL,1400,10124,65,NULL,'SALT','H-ZSNS J045936.57-030934.6',0.53,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36967,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1997H',NULL,36967,42.01,0.4,1650,10124,70,NULL,'SALT','H-ZSNS J045936.57-030934.6',0.53,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36968,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1997H',NULL,36968,42.12,0.38,1730,10124,65,NULL,'SALT','H-ZSNS J045936.57-030934.6',0.53,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36969,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1997H',NULL,36969,42.56,0.18,2130,10124,65,NULL,NULL,'H-ZSNS J045936.57-030934.6',0.53,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36970,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36970,36.52,0.68,201,10125,70,NULL,NULL,'2MASX J04593715-2348483',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'17.06',0.3,NULL,NULL,NULL,NULL,NULL,1,74.90475,-23.81347,0.033,NULL,37331726287,583308223,9114190,17.06),(36971,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1997I',NULL,36971,38.58,0.44,441,10126,74.2,NULL,'SALT 2','H-ZSNS J045937.31-030901.6',0.18,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'Sbc',NULL,NULL,NULL,NULL,1,74.9054583333,-3.15044,0.149,NULL,36639855705,572497745,8945277,NULL),(36972,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1997I',NULL,36972,39.45,0.03,658,10126,70,NULL,'SALT','H-ZSNS J045937.31-030901.6',0.18,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36973,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1997I',NULL,36973,39.79,0.18,769,10126,65,NULL,NULL,'H-ZSNS J045937.31-030901.6',0.18,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36974,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1997I',NULL,36974,39.95,0.24,828,10126,65,NULL,'Snapshot','H-ZSNS J045937.31-030901.6',0.18,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36975,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 1997I',NULL,36975,39.95,0.24,977,10126,65,NULL,'Snapshot','H-ZSNS J045937.31-030901.6',NULL,'1998ApJ...504..935R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36976,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36976,33.51,0.4,50.3,10127,NULL,NULL,'mean','MCG -02-13-031',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.00003,NULL,'14',0.4,'SB(s)c? sp     HII',NULL,NULL,NULL,NULL,1,74.922375,-11.27153,0.269,NULL,37494153020,585846140,9153845,14),(36977,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36977,33.72,0.2,55.5,10127,74.4,NULL,NULL,'MCG -02-13-031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36978,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36978,33.75,0.47,56.3,10127,NULL,NULL,'H','MCG -02-13-031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36979,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,'R',36979,33.82,0.49,58,10127,75,NULL,'IR','MCG -02-13-031',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36980,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36980,33.85,0.45,58.9,10127,NULL,NULL,'K','MCG -02-13-031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36981,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36981,33.85,0.46,59,10127,NULL,NULL,'J','MCG -02-13-031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36982,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36982,33.92,0.41,60.7,10127,NULL,NULL,NULL,'MCG -02-13-031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36983,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36983,33.99,0.39,62.7,10127,NULL,NULL,'Malmquist cor.','MCG -02-13-031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36984,'D-Sigma','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36984,32.66,0.4,34.1,10128,75,NULL,'Edat, raw','NGC 1726',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000057,NULL,'12.66',1.1,'SA(s)0^0^:','in a pair',NULL,NULL,NULL,1,74.924583,-7.75525,0.161,NULL,36601454264,571897722,8935901,12.66),(36985,'D-Sigma','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36985,33,0.4,39.8,10128,75,NULL,'Edat, cor','NGC 1726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36986,'Faber-Jackson','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36986,31.78,0.65,22.7,10128,95,NULL,'Weighted Mean','NGC 1726',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36987,'Faber-Jackson','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36987,33.67,0.81,54.2,10128,55,NULL,'Visvanathan & Sandage 1979','NGC 1726',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36988,'Tertiary','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36988,32.6,0.25,33.1,10128,95,NULL,NULL,'NGC 1726',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36989,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36989,33.45,0.45,49.1,10128,NULL,NULL,'K','NGC 1726',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36990,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36990,33.72,0.4,55.3,10128,NULL,NULL,'mean','NGC 1726',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36991,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36991,34.36,0.32,74.4,10129,70,NULL,NULL,'GIN 214',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',NULL,NULL,'15.33',NULL,'S',NULL,NULL,NULL,NULL,1,74.9292917,-0.59969,0.305,NULL,36615669608,572119837,8939372,15.33),(36992,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36992,36.14,0.38,169,10130,70,NULL,NULL,'GIN 228',NULL,'2001MNRAS.321..277C',2001,1,1,NULL,'G',0.00015,NULL,'13.80',1,'S',NULL,NULL,NULL,NULL,1,74.947125,-18.58092,0.081,NULL,37560127258,586876988,9169952,13.8),(36993,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36993,34.87,0.46,94.1,10131,70,NULL,NULL,'MCG -02-13-032',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000107,NULL,'14.2b',1.2,'SAB0-?',NULL,NULL,NULL,NULL,1,74.97075,-12.03683,0.281,NULL,37520372812,586255825,9160247,14.2),(36994,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,'R',36994,33.85,0.49,58.8,10132,75,NULL,'IR','ESO 552- G 044',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000033,NULL,'15',0.6,'Sb',NULL,NULL,NULL,NULL,1,74.9787083,-18.54458,0.081,NULL,37552721911,586761279,9168144,15),(36995,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36995,34.27,0.43,71.6,10132,NULL,NULL,NULL,'ESO 552- G 044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36996,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36996,34.3,0.42,72.4,10132,NULL,NULL,'Malmquist cor.','ESO 552- G 044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36997,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36997,34.32,0.2,73.1,10132,74.4,NULL,NULL,'ESO 552- G 044',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(36998,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36998,36.44,0.69,194,10133,70,NULL,NULL,'6dF J0459567-454936',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,74.98625,-45.82658,0,NULL,37625464384,587897881,9185904,15.5),(36999,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,36999,30.04,0.8,10.2,10134,75,NULL,'MAT, I','NGC 1744',NULL,'1997ApJS..109..333W',1997,1,8.1,'Extended HIPASS source','G',0.000007,NULL,'11.9B',4.4,'SB(s)d','Group member',NULL,NULL,NULL,1,74.990833,-26.02222,0,NULL,37225885251,581654457,9088350,11.9),(37000,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37000,30.05,0.8,10.2,10134,75,NULL,'A82, H','NGC 1744',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37001,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37001,29.47,0.4,7.8,10134,75,NULL,'B','NGC 1744',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37002,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37002,29.72,0.4,8.8,10134,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 1744',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37003,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37003,29.77,0.32,8.99,10134,85,NULL,'I, inv','NGC 1744',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37004,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37004,29.77,0.32,9.04,10134,85,NULL,'I, raw','NGC 1744',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37005,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37005,29.84,0.35,9.29,10134,NULL,NULL,NULL,'NGC 1744',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37006,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37006,29.84,0.4,9.3,10134,73,NULL,'opt','NGC 1744',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37007,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37007,29.92,0.2,9.64,10134,74.4,NULL,NULL,'NGC 1744',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37008,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37008,30,NULL,10,10134,NULL,NULL,NULL,'NGC 1744',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37009,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37009,30.02,0.43,10.1,10134,75,NULL,'3.6 micron, color corrected','NGC 1744',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37010,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37010,30.12,0.43,10.6,10134,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1744',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37011,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37011,30.16,0.51,10.8,10134,NULL,NULL,NULL,'NGC 1744',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37012,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37012,30.21,0.43,11,10134,75,NULL,'MAT, I, raw','NGC 1744',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37013,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37013,30.23,0.43,11.1,10134,75,NULL,'MAT, I, inv','NGC 1744',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37014,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37014,30.28,0.47,11.4,10134,75,NULL,'A82, H, inv','NGC 1744',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37015,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37015,30.33,0.47,11.6,10134,75,NULL,'A82, H, raw','NGC 1744',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37016,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37016,30.45,0.45,12.3,10134,NULL,NULL,'Malmquist cor.','NGC 1744',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37017,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37017,30.54,0.43,12.8,10134,75,NULL,'MAT, I, cor','NGC 1744',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37018,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37018,30.7,0.47,13.8,10134,75,NULL,'A82, H, cor','NGC 1744',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37019,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37019,33.87,0.52,59.4,10135,70,NULL,NULL,'ESO 552- G 045',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000073,NULL,'14.30',0.7,'(R)SB(rl)a',NULL,NULL,NULL,NULL,1,74.996417,-17.45981,0.181,NULL,37571416805,587053387,9172709,14.3),(37020,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37020,34.87,0.4,94.1,10135,NULL,NULL,'mean','ESO 552- G 045',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37021,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37021,35.04,0.47,102,10135,NULL,NULL,'H','ESO 552- G 045',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37022,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37022,35.08,0.46,104,10135,NULL,NULL,'J','ESO 552- G 045',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37023,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37023,35.11,0.45,105,10135,NULL,NULL,'K','ESO 552- G 045',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37024,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37024,35.99,0.66,158,10136,70,NULL,NULL,'2MASX J05000576-1729001',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'16.62',0.36,NULL,NULL,NULL,NULL,NULL,1,75.023875,-17.4835,0.181,NULL,37571420100,587053439,9172709,16.62),(37025,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37025,35.62,0.64,133,10137,70,NULL,NULL,'2MASX J05000957-2320535',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.95',0.24,NULL,NULL,NULL,NULL,NULL,1,75.04,-23.34828,0.057,NULL,37332831289,583325488,9114460,16.95),(37026,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37026,36.66,0.58,215,10138,70,NULL,NULL,'ESO 486- G 006',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'16.13',0.6,'S(r)a',NULL,NULL,NULL,NULL,1,75.0402917,-22.45258,0.017,NULL,37333001950,583328155,9114502,16.13),(37027,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37027,36.15,0.65,170,10139,70,NULL,NULL,'ESO 552- G 046',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.6b',1,'Sa',NULL,NULL,NULL,NULL,1,75.060875,-22.18769,0.013,NULL,37549808020,586715750,9167433,15.6),(37028,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37028,32.84,0.56,37,10140,NULL,NULL,NULL,'NGC 1729',NULL,'2009ApJS..182..474S',2009,1,1.6,NULL,'G',0.000013,NULL,'13',1.3,'SA(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,75.065375,-3.3525,0.165,NULL,36639698790,572495293,8945238,13),(37029,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37029,32.88,0.2,37.7,10140,74.4,NULL,NULL,'NGC 1729',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37030,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37030,33.17,0.48,43.1,10140,NULL,NULL,'Malmquist cor.','NGC 1729',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37031,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37031,36.22,0.7,175,10141,70,NULL,NULL,'2MASX J05001781-4612458',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'17.34',0.14,NULL,NULL,NULL,NULL,NULL,1,75.0742917,-46.21267,0,NULL,37626052606,587907071,9186047,17.34),(37032,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37032,36.93,0.25,243,10142,74.4,NULL,NULL,'GIN 260',NULL,'2013AJ....146...86T',2013,1,0.81,NULL,'G',0.00009,NULL,'14.28',0.49,'E/S0',NULL,NULL,NULL,NULL,1,75.076375,-22.39403,0.017,NULL,37330932480,583295820,9113997,14.28),(37033,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37033,37.17,0.22,272,10142,70,NULL,NULL,'GIN 260',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37034,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,'R',37034,33.76,0.49,56.6,10143,75,NULL,'IR','MCG -02-13-034',NULL,'2011yCatp016004901K',2011,1,1.9,NULL,'G',0.000013,NULL,'15.05',0.6,'SAd: sp',NULL,NULL,NULL,NULL,1,75.0769166667,-12.6915,0.237,NULL,37528987041,586390422,9162350,15.05),(37035,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37035,36.14,0.38,169,10144,70,NULL,NULL,'GIN 229',NULL,'2001MNRAS.321..277C',2001,1,0.52,NULL,'G',0.00005,NULL,'16.31',0.48,'cD',NULL,NULL,NULL,NULL,1,75.1010417,-18.866,0.081,NULL,37560646793,586885106,9170079,16.31),(37036,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37036,37.24,0.55,280,10145,70,NULL,NULL,'2MASX J05002474-2114065',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.92',0.45,NULL,NULL,NULL,NULL,NULL,1,75.102917,-21.23522,0.013,NULL,37550241051,586722516,9167539,16.92),(37037,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37037,37.32,0.6,291,10146,70,NULL,NULL,'2MASX J05002538-2114315',NULL,'2014MNRAS.445.2677S',2014,1,0.31,NULL,'G',0.00015,NULL,'17.37',0.27,NULL,NULL,NULL,NULL,NULL,1,75.10575,-21.24206,0.013,NULL,37550242830,586722544,9167539,17.37),(37038,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37038,36.33,0.72,185,10147,70,NULL,NULL,'2MASX J05002859-0251238',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.8b',0.5,NULL,NULL,NULL,NULL,NULL,1,75.1192083,-2.85661,0.241,NULL,36631085915,572360717,8943136,15.8),(37039,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37039,36.86,0.59,236,10148,70,NULL,NULL,'2MASX J05002971-2214345',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.72',0.34,NULL,NULL,NULL,NULL,NULL,1,75.123875,-22.24303,0.017,NULL,37549822003,586715968,9167437,16.72),(37040,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37040,36.93,0.25,243,10149,74.4,NULL,NULL,'GIN 261',NULL,'2013AJ....146...86T',2013,1,0.54,NULL,'G',0.000073,NULL,'14.44',0.51,'E/S0',NULL,NULL,NULL,NULL,1,75.129,-22.30797,0.017,NULL,37330886374,583295099,9113985,14.44),(37041,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37041,37.17,0.22,272,10149,70,NULL,NULL,'GIN 261',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37042,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37042,33.64,0.76,53.3,10150,70,NULL,NULL,'2MASX J05003301-2156055',NULL,'2014MNRAS.445.2677S',2014,1,0.63,'2007A&A...465...71T has V = 2974 +- 13 km/s.','G',0.000043,NULL,'16.20',0.29,'SBab',NULL,NULL,NULL,NULL,1,75.137625,-21.93494,0.009,NULL,37550021443,586719085,9167485,16.2),(37043,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37043,35.6,0.5,132,10151,70,NULL,NULL,'2MASX J05003477-2034061',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.47',0.37,NULL,NULL,NULL,NULL,NULL,1,75.145083,-20.56819,0.037,NULL,37561319680,586895620,9170244,16.47),(37044,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37044,36.08,0.76,164,10152,70,NULL,NULL,'AM 0503-775',NULL,'2014MNRAS.445.2677S',2014,1,0.1,NULL,'G',0.00015,NULL,'16.8b',NULL,'COMPACT',NULL,NULL,NULL,NULL,1,75.170375,-77.76403,0.445,NULL,35544537532,555383398,8677865,16.8),(37045,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37045,36.81,0.67,230,10153,70,NULL,NULL,'2MASX J05004103-2350531',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'17.22',0.2,NULL,NULL,NULL,NULL,NULL,1,75.1709166667,-23.84806,0.009,NULL,37329839442,583278741,9113730,17.22),(37046,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2006le',NULL,37046,33.5,0.22,49.3,10154,74.2,NULL,'SALT 2','UGC 03218',0.017432,'2010ApJ...716..712A',2010,1,1.7,NULL,'G',0.000023,NULL,'12.3B',0.6,'SAb',NULL,NULL,NULL,NULL,1,75.182125,62.24403,1.613,NULL,66124636912,1033197451,16143710,12.3),(37047,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2006le',NULL,37047,34.15,0.09,67.6,10154,74.4,NULL,NULL,'UGC 03218',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37048,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2006le',NULL,37048,34.34,0.19,72.6,10154,70,NULL,'SALT 2','UGC 03218',0.017432,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37049,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2006le',NULL,37049,34.35,0.21,72.8,10154,65,NULL,'SALT','UGC 03218',0.017432,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37050,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2006le',NULL,37050,34.35,0.03,72.9,10154,72,NULL,'SALT','UGC 03218',0.017432,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37051,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2006le',NULL,37051,34.42,0.17,75.4,10154,73.8,NULL,'SALT 2 (SNANA)','UGC 03218',0.0174,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37052,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2006le',NULL,37052,34.53,0.23,79.1,10154,65,NULL,'SALT2','UGC 03218',0.017432,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37053,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2006le',NULL,37053,34.55,0.02,81.3,10154,72,NULL,'M(H) = -18.317 mag','UGC 03218',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37054,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2006le',NULL,37054,34.63,0.08,82.9,10154,72,NULL,NULL,'UGC 03218',0.017432,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37055,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2006le',NULL,37055,34.63,0.2,83,10154,65,NULL,'MLCS17','UGC 03218',0.017432,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37056,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2006le',NULL,37056,34.65,0.08,83.7,10154,72,NULL,NULL,'UGC 03218',0.017432,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37057,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2006le',NULL,37057,34.71,0.2,86.1,10154,65,NULL,'MLCS31','UGC 03218',0.017432,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37058,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37058,33.71,0.46,55.3,10154,NULL,NULL,'J','UGC 03218',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37059,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37059,33.72,0.47,55.4,10154,NULL,NULL,'H','UGC 03218',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37060,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37060,33.8,0.45,57.5,10154,NULL,NULL,'K','UGC 03218',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37061,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37061,34.16,0.4,67.9,10154,NULL,NULL,'mean','UGC 03218',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37062,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37062,34.63,0.43,84.4,10154,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03218',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37063,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37063,36.87,0.7,237,10155,70,NULL,NULL,'6dF J0500474-455225',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.3b',0.31,NULL,NULL,NULL,NULL,NULL,1,75.1975,-45.87361,0,NULL,37625949941,587905467,9186022,16.3),(37064,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37064,37.17,0.62,272,10156,70,NULL,NULL,'6dF J0500539-202405',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,75.224417,-20.40125,0.029,NULL,37563361930,586927530,9170742,17),(37065,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37065,34.27,0.46,71.4,10157,70,NULL,NULL,'MCG -02-13-037',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000103,NULL,'14.5b',0.3,'SA(s)0-',NULL,NULL,NULL,NULL,1,75.2304583333,-13.42225,0.193,NULL,37529867739,586404183,9162565,14.5),(37066,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37066,36.28,0.73,181,10158,70,NULL,NULL,'2MASX J05005905-2228012',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'17.17',0.3,NULL,NULL,NULL,NULL,NULL,1,75.246125,-22.467,0.025,NULL,37332976992,583327765,9114496,17.17),(37067,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37067,35.59,0.5,131,10159,70,NULL,NULL,'ESO 552- G 048',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'15.1b',0.9,'Sa-b',NULL,NULL,NULL,NULL,1,75.260125,-18.28764,0.097,NULL,37553690457,586776413,9168381,15.1),(37068,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37068,37.17,0.22,272,10160,70,NULL,NULL,'AM 0459-223 NED01',NULL,'2001MNRAS.321..277C',2001,1,0.7,NULL,'G',0.00008,NULL,'14.75',0.6,'E/S0',NULL,NULL,NULL,NULL,1,75.2777083,-22.58233,0.025,NULL,37332984316,583327879,9114498,14.75),(37069,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37069,37.18,0.61,273,10161,70,NULL,NULL,'2MASX J05010762-2151354',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.99',0.22,NULL,NULL,NULL,NULL,NULL,1,75.2817917,-21.85986,0.025,NULL,37549879305,586716864,9167451,16.99),(37070,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37070,35.69,0.48,137,10162,70,NULL,NULL,'GIN 254',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00012,NULL,'13.94',0.51,'S',NULL,NULL,NULL,NULL,1,75.283,-23.74097,0.009,NULL,37329873717,583279276,9113738,13.94),(37071,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37071,35.83,0.29,146,10162,70,NULL,NULL,'GIN 254',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37072,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37072,36.92,0.25,242,10162,74.4,NULL,NULL,'GIN 254',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37073,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37073,36.92,0.25,242,10163,74.4,NULL,NULL,'AM 0459-223 NED02',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000247,NULL,'13.98',NULL,'E/S0','Group member, 2nd ranked galaxy',NULL,NULL,NULL,1,75.284625,-22.58286,0.025,NULL,37332984099,583327876,9114498,13.98),(37074,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37074,37.17,0.22,272,10163,70,NULL,NULL,'AM 0459-223 NED02',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37075,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37075,35.78,0.49,143,10164,70,NULL,NULL,'2MASX J05010972-2248574',NULL,'2014MNRAS.445.2677S',2014,1,0.88,NULL,'G',0.000087,NULL,'15.35',0.62,NULL,NULL,NULL,NULL,NULL,1,75.290583,-22.81603,0.009,NULL,37329797960,583278093,9113720,15.35),(37076,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37076,35.83,0.29,146,10165,70,NULL,NULL,'GIN 255',NULL,'2001MNRAS.321..277C',2001,1,0.7,NULL,'G',0.000113,NULL,'14.08',0.59,'E/S0',NULL,NULL,NULL,NULL,1,75.2980417,-23.94258,0.009,NULL,37329834751,583278667,9113729,14.08),(37077,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37077,36.92,0.25,242,10165,74.4,NULL,NULL,'GIN 255',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37078,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37078,36.78,0.79,227,10166,70,NULL,NULL,'2MASX J05011783-4415191',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'16.92',0.27,NULL,NULL,NULL,NULL,NULL,1,75.3242917,-44.25531,0,NULL,37635246851,588050732,9188292,16.92),(37079,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37079,35.3,0.68,115,10167,70,NULL,NULL,'2MASX J05011848-2239515',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.63',0.33,NULL,NULL,NULL,NULL,NULL,1,75.3270416667,-22.66436,0.009,NULL,37329625347,583275396,9113678,16.63),(37080,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37080,34.29,0.48,72.2,10168,70,NULL,NULL,'2MASX J05011995-1639040',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00006,NULL,'15.58',NULL,NULL,NULL,NULL,NULL,NULL,1,75.333083,-16.65122,0.149,NULL,37572396638,587068697,9172948,15.58),(37081,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37081,36.14,0.38,169,10169,70,NULL,NULL,'GIN 231',NULL,'2001MNRAS.321..277C',2001,1,0.4,'May be a resolved component of PMN J0501-1816.','G',0.00015,NULL,'15.23',0.3,'E/S0',NULL,NULL,NULL,NULL,1,75.3655417,-18.30906,0.097,NULL,37553678563,586776227,9168378,15.23),(37082,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37082,35.77,0.54,142,10170,70,NULL,NULL,'2MASX J05012942-1917405',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.52',0.36,NULL,NULL,NULL,NULL,NULL,1,75.372375,-19.2945,0.053,NULL,37560564768,586883824,9170059,16.52),(37083,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37083,31.2,0.8,17.4,10171,75,NULL,'MAT, I','ESO 085- G 030',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.00001,NULL,'13.75',0.7,'S0+? pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,75.374,-63.29333,0,NULL,35882431566,560662993,8760359,13.75),(37084,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37084,32.43,0.32,30.6,10171,85,NULL,'I, raw','ESO 085- G 030',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37085,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37085,32.44,0.32,30.7,10171,85,NULL,'I, inv','ESO 085- G 030',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37086,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37086,32.51,0.2,31.8,10171,74.4,NULL,NULL,'ESO 085- G 030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37087,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37087,32.63,0.43,33.6,10171,75,NULL,'MAT, I, raw','ESO 085- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37088,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37088,32.69,0.43,34.6,10171,75,NULL,'MAT, I, inv','ESO 085- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37089,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37089,32.94,0.43,38.7,10171,75,NULL,'MAT, I, cor','ESO 085- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37090,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37090,36.42,0.52,192,10172,70,NULL,NULL,'2MASX J05013020-2306505',NULL,'2014MNRAS.445.2677S',2014,1,0.76,NULL,'G',0.000133,NULL,'15.77',0.38,NULL,NULL,NULL,NULL,NULL,1,75.3759166667,-23.11411,0,NULL,37329693451,583276460,9113694,15.77),(37091,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37091,36.89,0.93,238,10173,70,NULL,NULL,'2MASX J05013082-4439411',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.31',0.37,'S0',NULL,NULL,NULL,NULL,1,75.378417,-44.66136,0,NULL,37635074473,588048038,9188250,16.31),(37092,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37092,37.17,0.22,272,10174,70,NULL,NULL,'GIN 263',NULL,'2001MNRAS.321..277C',2001,1,0.74,NULL,'G',0.00006,NULL,'15.89',0.45,'E',NULL,NULL,NULL,NULL,1,75.3807083,-22.98267,0,NULL,37329676643,583276197,9113690,15.89),(37093,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37093,34.24,0.47,70.4,10175,NULL,NULL,'H','MCG -03-13-051',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000037,NULL,'14.4b',0.4,'(R\')SB(s)b:',NULL,NULL,NULL,NULL,1,75.3854583,-16.16639,0.145,NULL,37570095655,587032744,9172386,14.4),(37094,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37094,34.3,0.45,72.4,10175,NULL,NULL,'K','MCG -03-13-051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37095,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37095,34.33,0.46,73.5,10175,NULL,NULL,'J','MCG -03-13-051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37096,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,'R',37096,34.35,0.49,74.2,10175,75,NULL,'IR','MCG -03-13-051',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37097,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37097,34.81,0.4,91.4,10175,NULL,NULL,'mean','MCG -03-13-051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37098,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37098,35.63,0.25,134,10176,74.4,NULL,NULL,'GIN 253',NULL,'2013AJ....146...86T',2013,1,0.56,NULL,'G',0.000077,NULL,'14.49',0.52,'S',NULL,NULL,NULL,NULL,1,75.397125,-23.74628,0.009,NULL,37330076150,583282439,9113788,14.49),(37099,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37099,35.83,0.29,146,10176,70,NULL,NULL,'GIN 253',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37100,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37100,36.25,0.52,178,10176,70,NULL,NULL,'GIN 253',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37101,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37101,36.92,0.25,242,10177,74.4,NULL,NULL,'GIN 257',NULL,'2013AJ....146...86T',2013,1,0.56,NULL,'G',0.00007,NULL,'15.96',0.48,'cD','Brightest group member',NULL,NULL,NULL,1,75.400125,-22.60069,0.021,NULL,37329578957,583274671,9113666,15.96),(37102,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37102,37.17,0.22,272,10177,70,NULL,NULL,'GIN 257',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37103,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37103,36.22,0.69,175,10178,70,NULL,NULL,'2MASX J05013611-2256062',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'17.46',0.15,NULL,NULL,NULL,NULL,NULL,1,75.4005417,-22.93508,0,NULL,37329803744,583278183,9113721,17.46),(37104,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37104,36.26,0.61,179,10179,70,NULL,NULL,'2MASX J05013823-2243172',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'17.16',0.26,NULL,NULL,NULL,NULL,NULL,1,75.4092916667,-22.7215,0.013,NULL,37329619937,583275311,9113676,17.16),(37105,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37105,34.83,0.51,92.6,10180,70,NULL,NULL,'2MASX J05013981-0915530',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,75.415833,-9.26467,0.217,NULL,37495126343,585861349,9154083,16.1),(37106,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,'R',37106,34.63,0.49,84.3,10181,75,NULL,'IR','2MFGC 04118',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.00004,NULL,'10.6K',0.1,'S',NULL,NULL,NULL,NULL,1,75.417833,43.63642,NULL,NULL,68236816927,1066200264,16659379,10.6),(37107,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37107,35.12,0.4,105,10181,NULL,NULL,'mean','2MFGC 04118',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37108,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37108,35.15,0.47,107,10181,NULL,NULL,'H','2MFGC 04118',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37109,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37109,35.29,0.45,114,10181,NULL,NULL,'K','2MFGC 04118',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37110,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37110,34.91,0.68,96,10182,70,NULL,NULL,'MCG -03-13-052',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000103,NULL,'14.5b',0.8,NULL,NULL,NULL,NULL,NULL,1,75.4275417,-15.16308,0.193,NULL,37524425267,586319144,9161236,14.5),(37111,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37111,36.14,0.53,169,10183,70,NULL,NULL,'MCG -03-13-053',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.000127,NULL,'14.40',0.51,'E','Compact group member',NULL,NULL,NULL,1,75.438417,-15.44875,0.149,NULL,37525261622,586332212,9161440,14.4),(37112,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37112,36.17,0.63,172,10184,70,NULL,NULL,'2MASX J05014535-1525503',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'17.59',0.24,'S0','Compact group member',NULL,NULL,NULL,1,75.4390417,-15.43067,0.149,NULL,37525260709,586332198,9161440,17.59),(37113,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37113,35.63,0.25,134,10185,74.4,NULL,NULL,'GIN 264',NULL,'2013AJ....146...86T',2013,1,0.55,NULL,'G',0.00015,NULL,'15.00',0.52,'S              HII',NULL,NULL,NULL,NULL,1,75.4404583,-23.16122,0.057,NULL,37329658722,583275917,9113686,15),(37114,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37114,37.17,0.22,272,10185,70,NULL,NULL,'GIN 264',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37115,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37115,37,0.89,251,10186,70,NULL,NULL,'2MASX J05014867-1525503',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'17.12',0.29,'S0a','Compact group member',NULL,NULL,NULL,1,75.452583,-15.43067,0.149,NULL,37525261292,586332207,9161440,17.12),(37116,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37116,36.68,0.58,217,10187,70,NULL,NULL,'2MASX J05014870-1214243',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.69',0.2,NULL,NULL,NULL,NULL,NULL,1,75.452833,-12.24025,0.305,NULL,37528707323,586386051,9162282,16.69),(37117,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37117,35.33,0.48,117,10188,70,NULL,NULL,'2MASX J05014991-2504100',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.000107,NULL,'15.36',0.67,NULL,NULL,NULL,NULL,NULL,1,75.458,-25.06942,0.029,NULL,37215962249,581499410,9085928,15.36),(37118,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37118,33.85,0.48,59,10189,70,NULL,NULL,'NGC 1740',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000093,NULL,'13.6b',1.2,'S0-:',NULL,NULL,NULL,NULL,1,75.478333,-3.29633,0.237,NULL,36640214977,572503359,8945364,13.6),(37119,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37119,35.84,0.61,147,10190,70,NULL,NULL,'2MASX J05015559-1648543',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.58',0.4,NULL,NULL,NULL,NULL,NULL,1,75.4815833333,-16.81528,0.157,NULL,37572570901,587071420,9172990,16.58),(37120,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37120,36.68,0.77,217,10191,70,NULL,NULL,'2MASX J05015600-2154402',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'17.38',0.13,NULL,NULL,NULL,NULL,NULL,1,75.4832917,-21.91125,0.009,NULL,37551011452,586734553,9167727,17.38),(37121,'GRB','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37121,39.6,NULL,832,10192,65,NULL,'L = 10e57 photons/s','GRB 970228',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'SAX/WFC',NULL,NULL,NULL,NULL,1,75.4875,11.77333,0.917,NULL,65433262435,1022394725,15974917,NULL),(37122,'GRB','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,'R',37122,42.67,0.7,2010,10192,72,NULL,NULL,'GRB 970228',0.7,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37123,'GRB','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37123,42.72,0.68,2060,10192,69.7,NULL,'Calibrated','GRB 970228',0.7,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37124,'GRB','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37124,42.79,0.71,2130,10192,70,NULL,NULL,'GRB 970228',0.7,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37125,'GRB','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37125,43.04,0.68,2390,10192,69.7,NULL,'Fiducial','GRB 970228',0.7,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37126,'GRB','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,'R',37126,43.21,0.21,2580,10192,72,NULL,NULL,'GRB 970228',0.7,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37127,'GRB','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37127,42.08,NULL,2610,10192,65,NULL,'L = 2 x 10e58 photons/s','GRB 970228',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37128,'GRB','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,'R',37128,42.7,0.72,3470,10192,NULL,NULL,NULL,'GRB 970228',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37129,'GRB','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,'R',37129,43.15,0.05,4270,10192,NULL,NULL,NULL,'GRB 970228',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37130,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37130,35.89,0.6,151,10193,70,NULL,NULL,'2MASX J05015970-4452491',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.65',0.26,NULL,NULL,NULL,NULL,NULL,1,75.498833,-44.88028,0,NULL,37633026299,588016035,9187750,16.65),(37131,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2006hb',NULL,37131,33.73,0.1,55.7,10194,74.4,NULL,NULL,'ESO 552- G 052',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.0001,NULL,'13.92',0.7,'E?',NULL,NULL,NULL,NULL,1,75.5028333333,-21.13694,0.029,NULL,37550583409,586727865,9167622,13.92),(37132,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2006hb',NULL,37132,34.05,0.18,62.6,10194,72,NULL,NULL,'ESO 552- G 052',0.01535,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37133,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2006hb',NULL,37133,34.03,0.21,63.1,10194,70,NULL,'SALT 2','ESO 552- G 052',0.015344,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37134,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2006hb',NULL,37134,34.04,0.22,63.4,10194,65,NULL,'MLCS17','ESO 552- G 052',0.015344,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37135,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2006hb',NULL,37135,34.15,0.11,67.5,10194,72,NULL,'M(H) = -18.317 mag','ESO 552- G 052',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37136,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2006hb',NULL,37136,34.21,0.23,68.5,10194,65,NULL,'MLCS31','ESO 552- G 052',0.015344,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37137,'D-Sigma','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37137,33.8,0.4,57.4,10194,75,NULL,'Edat, raw','ESO 552- G 052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37138,'D-Sigma','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37138,34.13,0.4,67,10194,75,NULL,'Edat, cor','ESO 552- G 052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37139,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37139,33.92,0.49,60.7,10194,70,NULL,NULL,'ESO 552- G 052',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37140,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37140,34.17,0.4,68.3,10194,NULL,NULL,'mean','ESO 552- G 052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37141,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37141,34.67,0.45,85.8,10194,NULL,NULL,'K','ESO 552- G 052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37142,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37142,37.08,0.56,260,10195,70,NULL,NULL,'2MASX J05020260-5348481',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.8I',0.3,NULL,NULL,NULL,NULL,NULL,1,75.51075,-53.81328,0.281,NULL,35947093010,561673328,8776145,13.8),(37143,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37143,35.01,0.54,100,10196,70,NULL,NULL,'ESO 552- G 051',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000067,NULL,'15.37',0.6,'S0',NULL,NULL,NULL,NULL,1,75.5199583,-17.47417,0.137,NULL,37570972167,587046440,9172600,15.37),(37144,'Tully est','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37144,30.83,0.8,14.7,10197,75,NULL,NULL,'NGC 1809',NULL,'1988NBGC.C....0000T',1988,1,3.2,NULL,'G',0.000013,NULL,'13.0',0.8,'Sc:',NULL,NULL,NULL,NULL,1,75.520875,-69.56828,0.373,NULL,36384227228,568503550,8882867,13),(37145,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37145,33.25,0.8,44.7,10198,75,NULL,'MAT, I','NGC 1752',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.000013,NULL,'13.27',0.8,'SB(r)c:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,75.5395417,-8.24086,0.269,NULL,36600775581,571887118,8935736,13.27),(37146,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37146,32.84,0.46,37,10198,NULL,NULL,'J','NGC 1752',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37147,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37147,32.91,0.47,38.1,10198,NULL,NULL,'H','NGC 1752',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37148,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37148,32.98,0.45,39.5,10198,NULL,NULL,'K','NGC 1752',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37149,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37149,33.08,0.43,41.3,10198,75,NULL,'MAT, I, raw','NGC 1752',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37150,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37150,33.11,0.32,41.9,10198,85,NULL,'I, raw','NGC 1752',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37151,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37151,33.18,0.32,43.2,10198,85,NULL,'I, inv','NGC 1752',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37152,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37152,33.22,0.43,44,10198,75,NULL,'3.6 micron, color corrected','NGC 1752',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37153,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37153,33.22,0.2,44.1,10198,74.4,NULL,NULL,'NGC 1752',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37154,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37154,33.35,0.43,46.8,10198,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1752',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37155,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37155,33.36,0.43,47,10198,75,NULL,'MAT, I, inv','NGC 1752',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37156,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37156,33.39,0.4,47.7,10198,NULL,NULL,'mean','NGC 1752',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37157,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37157,33.46,0.43,49.2,10198,75,NULL,'MAT, I, cor','NGC 1752',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37158,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37158,33.49,0.42,49.8,10198,NULL,NULL,'Malmquist cor.','NGC 1752',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37159,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37159,33.5,0.42,50.1,10198,NULL,NULL,NULL,'NGC 1752',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37160,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37160,35.51,0.61,126,10199,70,NULL,NULL,'2MASX J05021498-2450460',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.2,NULL,NULL,NULL,NULL,NULL,1,75.5624583,-24.84622,0.045,NULL,37216044415,581500693,9085948,14.6),(37161,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37161,34.73,0.56,88.3,10200,70,NULL,NULL,'ESO 422- G 023',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000033,NULL,'14.15',0.8,'SB(rs)b',NULL,NULL,NULL,NULL,1,75.5739166667,-30.45467,0,NULL,37199892657,581248322,9082005,14.15),(37162,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37162,34.6,0.8,83,10200,75,NULL,'MAT, I','ESO 422- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37163,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37163,34.35,0.48,74.2,10200,NULL,NULL,'Malmquist cor.','ESO 422- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37164,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37164,34.64,0.2,84.7,10200,74.4,NULL,NULL,'ESO 422- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37165,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37165,34.67,0.41,86.1,10200,NULL,NULL,NULL,'ESO 422- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37166,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37166,34.7,0.32,87,10200,85,NULL,'I, raw','ESO 422- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37167,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37167,34.75,0.43,89.3,10200,75,NULL,'MAT, I, raw','ESO 422- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37168,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37168,34.77,0.32,89.9,10200,85,NULL,'I, inv','ESO 422- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37169,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37169,34.81,0.47,91.6,10200,NULL,NULL,'H','ESO 422- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37170,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37170,34.83,0.4,92.4,10200,NULL,NULL,'mean','ESO 422- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37171,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37171,34.91,0.45,95.9,10200,NULL,NULL,'K','ESO 422- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37172,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37172,34.94,0.46,97.1,10200,NULL,NULL,'J','ESO 422- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37173,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37173,35.07,0.43,103,10200,75,NULL,'MAT, I, inv','ESO 422- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37174,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37174,35.15,0.43,107,10200,75,NULL,'MAT, I, cor','ESO 422- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37175,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37175,33.59,0.47,52.2,10201,NULL,NULL,'H','MCG -02-13-038',NULL,'2007A&A...465...71T',2007,1,2,NULL,'G',0.000013,NULL,'13.8b',0.9,'(R\')SA(rs)a:',NULL,NULL,NULL,NULL,1,75.580375,-10.35628,0.265,NULL,37483474118,585679283,9151238,13.8),(37176,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37176,33.62,0.45,53,10201,NULL,NULL,'K','MCG -02-13-038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37177,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37177,33.66,0.46,54.1,10201,NULL,NULL,'J','MCG -02-13-038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37178,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37178,33.73,0.4,55.7,10201,NULL,NULL,'mean','MCG -02-13-038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37179,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37179,35.02,0.63,101,10202,70,NULL,NULL,'2MASX J05022811-1225453',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.1I',0.2,NULL,NULL,NULL,NULL,NULL,1,75.617167,-12.42931,0.265,NULL,37529445248,586397582,9162462,14.1),(37180,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37180,35.69,0.58,138,10203,70,NULL,NULL,'2MASX J05022827-1144004',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,75.6178333333,-11.73347,0.305,NULL,37515057363,586172771,9158949,16.4),(37181,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37181,36.9,0.25,240,10204,74.4,NULL,NULL,'GIN 262',NULL,'2013AJ....146...86T',2013,1,0.54,NULL,'G',0.000237,NULL,'15.25',0.5,'S',NULL,NULL,NULL,NULL,1,75.6187916667,-22.72764,0.013,NULL,37547952581,586686759,9166980,15.25),(37182,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37182,37.17,0.22,272,10204,70,NULL,NULL,'GIN 262',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37183,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37183,33.66,0.2,54,10205,74.4,NULL,NULL,'MCG -03-13-058',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000023,NULL,'15.1b',0.7,NULL,NULL,NULL,NULL,NULL,1,75.621667,-15.54539,0.197,NULL,37524788961,586324827,9161325,15.1),(37184,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37184,33.9,0.37,60.4,10205,NULL,NULL,NULL,'MCG -03-13-058',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37185,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37185,34.05,0.35,64.6,10205,NULL,NULL,'Malmquist cor.','MCG -03-13-058',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37186,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37186,37.17,0.57,271,10206,70,NULL,NULL,'2MASX J05022941-1218143',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,75.622583,-12.304,0.305,NULL,37528727603,586386368,9162287,17.4),(37187,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37187,36.03,0.65,160,10207,70,NULL,NULL,'2MASX J05023248-2215093',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.53',0.35,NULL,NULL,NULL,NULL,NULL,1,75.6353333333,-22.25261,0.021,NULL,37551057620,586735275,9167738,16.53),(37188,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37188,34.06,0.8,64.8,10208,75,NULL,'CF, r','UGC 03231',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000023,NULL,'14.53',0.7,'SB(s)d:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,75.64375,0.24481,0.305,NULL,64585198479,1009143726,15767870,14.53),(37189,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37189,33.79,0.38,57.2,10208,75,NULL,'CF, r, raw','UGC 03231',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37190,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37190,33.84,0.38,58.6,10208,75,NULL,'CF, r, inv','UGC 03231',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37191,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37191,33.91,0.38,60.5,10208,75,NULL,'CF, r, cor','UGC 03231',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37192,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37192,33.91,0.2,60.5,10208,74.4,NULL,NULL,'UGC 03231',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37193,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37193,33.99,0.24,62.9,10208,NULL,NULL,'Malmquist cor.','UGC 03231',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37194,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37194,34,0.24,63.1,10208,NULL,NULL,NULL,'UGC 03231',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37195,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37195,36.19,0.55,173,10209,70,NULL,NULL,'ESO 252- G 006',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'15.90',0.31,'N',NULL,NULL,NULL,NULL,1,75.6537083,-44.75392,0,NULL,37633006399,588015724,9187745,15.9),(37196,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37196,36.05,0.76,162,10210,70,NULL,NULL,'ESO 552- G 054',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000033,NULL,'15.3b',0.6,'Sb:',NULL,NULL,NULL,NULL,1,75.6557917,-20.92283,0.049,NULL,37548736227,586699003,9167171,15.3),(37197,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37197,35.25,0.45,112,10210,NULL,NULL,NULL,'ESO 552- G 054',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37198,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37198,35.29,0.2,114,10210,74.4,NULL,NULL,'ESO 552- G 054',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37199,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37199,35.41,0.41,121,10210,NULL,NULL,'Malmquist cor.','ESO 552- G 054',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37200,'Tully est','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37200,30.12,0.8,10.6,10211,75,NULL,'B','NGC 1796',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000029,NULL,'12.86',1,'(R)SB(r)dm:','Group member',NULL,NULL,NULL,1,75.6772917,-61.14006,0,NULL,35878436719,560600573,8759383,12.86),(37201,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37201,35.04,0.61,102,10212,70,NULL,NULL,'ESO 486- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00009,NULL,'14.75',0.8,'S?',NULL,NULL,NULL,NULL,1,75.6879583,-25.53681,0,NULL,37214658200,581479034,9085609,14.75),(37202,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37202,34.06,NULL,64.9,10213,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0519',NULL,'2010Ap&SS.325..163P',2010,1,1.12,NULL,'G',0.00003,NULL,'16.89',0.12,'Sd',NULL,NULL,NULL,NULL,1,75.697167,-2.28439,0.301,NULL,36613245598,572081962,8938780,16.89),(37203,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37203,34.08,NULL,65.4,10213,NULL,NULL,'Dipole + Quadrupole','FGC 0519',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37204,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37204,34.09,NULL,65.6,10213,NULL,NULL,'Dipole','FGC 0519',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37205,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37205,34.14,NULL,67.2,10213,NULL,NULL,NULL,'FGC 0519',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37206,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37206,34.9,0.46,95.6,10214,70,NULL,NULL,'ESO 552- G 057',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000047,NULL,'14.4b',0.9,'S0',NULL,NULL,NULL,NULL,1,75.726,-20.36636,0.029,NULL,37562809526,586918898,9170607,14.4),(37207,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37207,34.94,0.25,97.3,10214,74.4,NULL,NULL,'ESO 552- G 057',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37208,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37208,35.15,0.25,107,10214,70,NULL,NULL,'ESO 552- G 057',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37209,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37209,35.18,0.4,109,10214,NULL,NULL,'mean','ESO 552- G 057',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37210,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37210,35.6,0.45,132,10214,NULL,NULL,'K','ESO 552- G 057',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37211,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37211,34.25,0.48,70.6,10215,NULL,NULL,NULL,'ESO 552- G 056',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'15',0.5,'Sb:',NULL,NULL,NULL,NULL,1,75.729333,-18.76928,0.093,NULL,37553018830,586765919,9168217,15),(37212,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37212,34.29,0.2,72.1,10215,74.4,NULL,NULL,'ESO 552- G 056',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37213,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37213,34.33,0.46,73.3,10215,NULL,NULL,'Malmquist cor.','ESO 552- G 056',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37214,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37214,36.05,0.83,163,10216,70,NULL,NULL,'2MASX J05030269-2409414',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.27',0.49,NULL,NULL,NULL,NULL,NULL,1,75.7612917,-24.1615,0.049,NULL,37212331926,581442686,9085041,16.27),(37215,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37215,34.97,0.25,98.6,10217,74.4,NULL,NULL,'GIN 234',NULL,'2013AJ....146...86T',2013,1,0.41,NULL,'G',0.00015,NULL,'15.41',0.29,'S',NULL,NULL,NULL,NULL,1,75.7645417,-20.27533,0.029,NULL,37562753711,586918026,9170594,15.41),(37216,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37216,35.15,0.25,107,10217,70,NULL,NULL,'GIN 234',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37217,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37217,35.96,0.53,156,10218,70,NULL,NULL,'ESO 486- G 018',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00005,NULL,'15.57',0.4,'Sa','Pair member (points to parent)',NULL,NULL,NULL,1,75.79225,-24.00067,0.021,NULL,37212318955,581442483,9085038,15.57),(37218,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37218,34.98,0.57,99.3,10219,70,NULL,NULL,'ESO 552- G 058',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000097,NULL,'14.85',0.3,'S0',NULL,NULL,NULL,NULL,1,75.792417,-20.27244,0.029,NULL,37562880146,586920002,9170625,14.85),(37219,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37219,35.15,0.25,107,10220,70,NULL,NULL,'GIN 233',NULL,'2001MNRAS.321..277C',2001,1,0.62,NULL,'G',0.00004,NULL,'14.12',0.58,'E/S0',NULL,NULL,NULL,NULL,1,75.797875,-20.31669,0.029,NULL,37562798705,586918729,9170605,14.12),(37220,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37220,32.81,0.46,36.5,10221,70,NULL,NULL,'ESO 486- G 019',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000043,NULL,'12.45',0.5,'S0-: sp','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,75.804875,-22.83311,0.013,NULL,37548047941,586688249,9167003,12.45),(37221,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37221,37.09,0.57,262,10222,70,NULL,NULL,'2MASX J05031348-2120104',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'17.30',0.3,NULL,NULL,NULL,NULL,NULL,1,75.806125,-21.33617,0.041,NULL,37550780912,586730951,9167671,17.3),(37222,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37222,33.66,0.47,54,10223,NULL,NULL,'H','MCG +00-13-066',NULL,'2007A&A...465...71T',2007,1,2.2,NULL,'G',0.000013,NULL,'14',0.4,'Sb pec sp',NULL,NULL,NULL,NULL,1,75.822583,-2.93581,0.221,NULL,36625712731,572276761,8941824,14),(37223,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37223,33.67,0.45,54.3,10223,NULL,NULL,'K','MCG +00-13-066',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37224,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37224,33.72,0.2,55.5,10223,74.4,NULL,NULL,'MCG +00-13-066',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37225,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37225,33.8,0.46,57.6,10223,NULL,NULL,'J','MCG +00-13-066',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37226,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37226,33.91,0.4,60.5,10223,NULL,NULL,'mean','MCG +00-13-066',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37227,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37227,33.94,0.28,61.4,10223,NULL,NULL,'Malmquist cor.','MCG +00-13-066',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37228,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37228,33.97,0.27,62.3,10223,NULL,NULL,NULL,'MCG +00-13-066',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37229,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37229,34.17,0.47,68.2,10224,NULL,NULL,'H','UGC 03232',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000022,NULL,'17.',0.5,'S?',NULL,NULL,NULL,NULL,1,75.8265417,18.45256,1.753,NULL,65458746623,1022792915,15981139,17),(37230,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37230,34.23,0.4,70.1,10224,NULL,NULL,'mean','UGC 03232',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37231,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37231,34.25,0.45,70.9,10224,NULL,NULL,'K','UGC 03232',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37232,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37232,34.35,0.46,74.2,10224,NULL,NULL,'J','UGC 03232',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37233,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37233,36.25,0.62,178,10225,70,NULL,NULL,'2MASX J05032243-2113314',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.92',0.27,NULL,NULL,NULL,NULL,NULL,1,75.8434583,-21.22547,0.041,NULL,37550588729,586727948,9167624,16.92),(37234,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37234,35,0.25,100,10226,74.4,NULL,NULL,'GIN 235',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000053,NULL,'14.73',0.4,'S',NULL,NULL,NULL,NULL,1,75.8475417,-20.31142,0.029,NULL,37562900821,586920325,9170630,14.73),(37235,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37235,35.15,0.25,107,10226,70,NULL,NULL,'GIN 235',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37236,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37236,35.47,0.58,124,10226,70,NULL,NULL,'GIN 235',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37237,'Tully est','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37237,31.36,0.8,18.7,10227,75,NULL,NULL,'UGC 03234',NULL,'1988NBGC.C....0000T',1988,1,1.8,NULL,'G',0.000013,NULL,'15.01',1.8,'Im:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,75.852417,16.40433,1.525,NULL,65493491508,1023335804,15989621,15.01),(37238,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37238,34.94,0.25,97.3,10228,74.4,NULL,NULL,'ESO 552- G 059',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000083,NULL,'13.73',0.4,'S0',NULL,NULL,NULL,NULL,1,75.859625,-20.04322,0.061,NULL,37562445191,586913206,9170518,13.73),(37239,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37239,35.15,0.25,107,10228,70,NULL,NULL,'ESO 552- G 059',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37240,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37240,35.23,0.47,111,10228,70,NULL,NULL,'ESO 552- G 059',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37241,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37241,35.43,0.41,122,10228,70,NULL,NULL,'ESO 552- G 059',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37242,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37242,33.55,0.43,51.4,10229,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03237',NULL,'2014MNRAS.444..527S',2014,1,1.66,NULL,'G',0.000023,NULL,'15.02',0.31,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,75.865167,0.66028,0.325,NULL,64585008848,1009140763,15767824,15.02),(37243,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37243,33.69,0.43,54.8,10229,75,NULL,'3.6 micron, color corrected','UGC 03237',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37244,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37244,33.82,0.2,58.1,10229,74.4,NULL,NULL,'UGC 03237',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37245,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,'R',37245,33.87,0.49,59.3,10229,75,NULL,'IR','UGC 03237',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37246,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37246,33.91,0.26,60.4,10229,NULL,NULL,NULL,'UGC 03237',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37247,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37247,33.99,0.25,62.8,10229,NULL,NULL,'Malmquist cor.','UGC 03237',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37248,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37248,34.99,0.25,99.5,10230,74.4,NULL,NULL,'GIN 238',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.00008,NULL,'14.74',0.4,'E/S0',NULL,NULL,NULL,NULL,1,75.8740417,-20.45675,0.049,NULL,37562791128,586918611,9170603,14.74),(37249,'FP','2016-12-15 15:14:05','2016-12-16 11:19:09','1',NULL,NULL,37249,35.15,0.25,107,10230,70,NULL,NULL,'GIN 238',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37250,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2009ad',NULL,37250,35.38,0.41,113,10231,72,NULL,NULL,'UGC 03236',0.02834,'2013ApJ...773...53F',2013,1,1,NULL,'G',0.000007,NULL,'15.33',0.4,'Sbc','Group member, peripheral',NULL,NULL,NULL,1,75.888375,6.65736,0.413,NULL,64605754960,1009464921,15772889,15.33),(37251,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2009ad','R',37251,35.39,0.06,120,10231,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 03236',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37252,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2009ad','R',37252,35.44,0.06,122,10231,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 03236',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37253,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:09','1','SN 2009ad',NULL,37253,35.51,0.2,123,10231,73.8,NULL,'SALT 2 (SNANA)','UGC 03236',0.0286,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37254,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37254,35.25,0.8,112,10231,75,NULL,'HMCL, I','UGC 03236',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37255,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37255,35.25,0.8,112,10231,75,NULL,'CF, r','UGC 03236',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37256,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37256,35.26,0.8,113,10231,75,NULL,'W91CL, r','UGC 03236',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37257,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37257,35.18,0.38,108,10231,75,NULL,'W91CL, r, raw','UGC 03236',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37258,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37258,35.27,0.38,113,10231,75,NULL,'CF, r, raw','UGC 03236',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37259,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37259,35.34,0.38,117,10231,75,NULL,'W91CL, r, inv','UGC 03236',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37260,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37260,35.34,0.4,117,10231,75,NULL,'HMCL, I, raw','UGC 03236',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37261,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37261,35.43,0.38,122,10231,75,NULL,'W91CL, r, cor','UGC 03236',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37262,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37262,35.43,0.38,122,10231,75,NULL,'CF, r, inv','UGC 03236',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37263,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37263,35.5,0.35,126,10231,NULL,NULL,'Malmquist cor.','UGC 03236',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37264,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37264,35.52,0.38,127,10231,75,NULL,'CF, r, cor','UGC 03236',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37265,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37265,35.55,0.4,129,10231,75,NULL,'HMCL, I, inv','UGC 03236',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37266,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37266,35.61,0.4,132,10231,75,NULL,'HMCL, I, cor','UGC 03236',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37267,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37267,35.64,0.2,134,10231,74.4,NULL,NULL,'UGC 03236',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37268,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37268,35.7,0.32,138,10231,NULL,NULL,NULL,'UGC 03236',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37269,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37269,33.4,0.69,48,10232,100,NULL,'mid-IR','NGC 1762',NULL,'2013ApJ...771...88L',2013,1,1.7,NULL,'G',0.000027,NULL,'13.35',1.1,'SA(rs)c:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,75.9042917,1.57333,0.333,NULL,64588360855,1009193138,15768642,13.35),(37270,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37270,34.03,0.47,64.1,10232,NULL,NULL,'H','NGC 1762',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37271,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37271,34.05,0.46,64.4,10232,NULL,NULL,'J','NGC 1762',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37272,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37272,34.05,0.45,64.5,10232,NULL,NULL,'K','NGC 1762',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37273,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37273,34.06,0.4,64.7,10232,NULL,NULL,'mean','NGC 1762',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37274,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37274,34.88,0.59,94.5,10232,NULL,NULL,'Malmquist cor.','NGC 1762',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37275,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37275,35.01,0.43,100,10232,75,NULL,'3.6 micron, color corrected','NGC 1762',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37276,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37276,35.02,0.2,101,10232,74.4,NULL,NULL,'NGC 1762',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37277,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37277,35.07,0.54,103,10232,NULL,NULL,NULL,'NGC 1762',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37278,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37278,35.11,0.43,105,10232,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1762',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37279,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37279,36.89,0.25,239,10233,74.4,NULL,NULL,'MCG -04-12-042',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.00015,NULL,'15.5',0.4,NULL,NULL,NULL,NULL,NULL,1,75.933833,-23.32314,0.021,NULL,37330279270,583285613,9113837,15.5),(37280,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37280,37.17,0.22,272,10233,70,NULL,NULL,'MCG -04-12-042',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37281,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37281,34.94,0.25,97.3,10234,74.4,NULL,NULL,'GIN 237',NULL,'2013AJ....146...86T',2013,1,0.69,NULL,'G',0.000037,NULL,'14.82',0.55,'S',NULL,NULL,NULL,NULL,1,75.9478333333,-20.00139,0.061,NULL,37562434656,586913041,9170516,14.82),(37282,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37282,35.15,0.25,107,10234,70,NULL,NULL,'GIN 237',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37283,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37283,35.66,0.25,136,10235,74.4,NULL,NULL,'GIN 251',NULL,'2013AJ....146...86T',2013,1,0.59,NULL,'G',0.00009,NULL,'13.95',0.47,'E/S0',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,75.960875,-23.51658,0.029,NULL,37330289291,583285770,9113840,13.95),(37284,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37284,35.83,0.29,146,10235,70,NULL,NULL,'GIN 251',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37285,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37285,35.93,0.53,154,10235,70,NULL,NULL,'GIN 251',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37286,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37286,32.94,0.43,38.8,10236,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J05035410+5519138',NULL,'2014MNRAS.444..527S',2014,1,0.67,NULL,'G',0.000167,NULL,'10.5K',0.33,'S',NULL,NULL,NULL,NULL,1,75.9755,55.32053,NULL,NULL,66259026987,1035297296,16176520,10.5),(37287,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37287,36.19,0.25,173,10237,74.4,NULL,NULL,'GIN 246',NULL,'2013AJ....146...86T',2013,1,0.65,NULL,'G',0.000033,NULL,'14.19',0.43,'S',NULL,NULL,NULL,NULL,1,75.9765,-19.12814,0.089,NULL,37554987226,586796675,9168698,14.19),(37288,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37288,37.16,0.16,271,10237,70,NULL,NULL,'GIN 246',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37289,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37289,35.83,0.29,146,10238,70,NULL,NULL,'GIN 250',NULL,'2001MNRAS.321..277C',2001,1,0.33,NULL,'G',0.000087,NULL,'14.88',0.3,'E/S0',NULL,NULL,NULL,NULL,1,75.991,-24.00881,0.045,NULL,37212797640,581449963,9085155,14.88),(37290,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37290,36.37,0.63,188,10238,70,NULL,NULL,'GIN 250',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37291,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37291,35.65,0.25,135,10239,74.4,NULL,NULL,'ESO 486- G 023',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000093,NULL,'14.13',1.3,'SA(r)0-:','Pair member (points to parent)',NULL,NULL,NULL,1,76.005833,-23.99633,0.045,NULL,37212785160,581449768,9085152,14.13),(37292,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37292,35.83,0.29,146,10239,70,NULL,NULL,'ESO 486- G 023',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37293,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37293,35.71,0.55,138,10240,70,NULL,NULL,'ESO 486- G 024',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.000083,NULL,'15.53',0.4,'S0',NULL,NULL,NULL,NULL,1,76.041833,-25.1335,0,NULL,37215530607,581492665,9085822,15.53),(37294,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37294,35.15,0.25,107,10241,70,NULL,NULL,'GIN 236',NULL,'2001MNRAS.321..277C',2001,1,0.76,NULL,'G',0.000057,NULL,'13.95',0.39,'SB',NULL,NULL,NULL,NULL,1,76.0617917,-20.11619,0.057,NULL,37563089569,586923274,9170676,13.95),(37295,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,'R',37295,35.65,0.49,135,10242,75,NULL,'IR','UGC 03240',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.41',0.4,'Sbc',NULL,NULL,NULL,NULL,1,76.0739583,4.65139,0.353,NULL,64612237384,1009566209,15774472,15.41),(37296,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37296,34.01,0.8,63.5,10243,75,NULL,'MAT, I','ESO 085- G 038',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'13.49',1,'(R\'_2)SB(s)c','in a pair',NULL,NULL,NULL,1,76.0800416667,-63.58214,0.013,NULL,35875124773,560548824,8758575,13.49),(37297,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37297,33.05,0.43,40.7,10243,75,NULL,'MAT, I, raw','ESO 085- G 038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37298,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37298,33.24,0.43,44.4,10243,75,NULL,'MAT, I, inv','ESO 085- G 038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37299,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37299,33.27,0.32,45.1,10243,85,NULL,'I, raw','ESO 085- G 038',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37300,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37300,33.32,0.32,46.1,10243,85,NULL,'I, inv','ESO 085- G 038',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37301,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37301,33.52,0.43,50.5,10243,75,NULL,'MAT, I, cor','ESO 085- G 038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37302,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37302,34.06,0.47,64.8,10243,NULL,NULL,'H','ESO 085- G 038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37303,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37303,34.12,0.46,66.7,10243,NULL,NULL,'J','ESO 085- G 038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37304,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37304,34.14,0.45,67.3,10243,NULL,NULL,'K','ESO 085- G 038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37305,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37305,34.19,0.4,68.8,10243,NULL,NULL,'mean','ESO 085- G 038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37306,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37306,33.21,0.46,43.8,10244,NULL,NULL,'J','IC 0401',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.00001,NULL,'14.5',0.6,'SB(rs)b?      LINER?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,76.081833,-10.07653,0.269,NULL,37481677441,585651210,9150800,14.5),(37307,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37307,33.24,0.47,44.4,10244,NULL,NULL,'H','IC 0401',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37308,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37308,33.32,0.45,46.2,10244,NULL,NULL,'K','IC 0401',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37309,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37309,33.33,0.4,46.2,10244,NULL,NULL,'mean','IC 0401',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37310,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37310,36.19,0.25,173,10245,74.4,NULL,NULL,'GIN 243',NULL,'2013AJ....146...86T',2013,1,0.68,NULL,'G',0.000033,NULL,'14.49',0.47,'S',NULL,NULL,NULL,NULL,1,76.0932083,-19.04025,0.077,NULL,37555000501,586796882,9168701,14.49),(37311,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37311,37.16,0.16,271,10245,70,NULL,NULL,'GIN 243',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37312,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37312,37.28,0.53,285,10245,70,NULL,NULL,'GIN 243',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37313,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37313,36.23,0.77,176,10246,70,NULL,NULL,'2MASX J05042293-4337524',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.67',0.22,NULL,NULL,NULL,NULL,NULL,1,76.095583,-43.63128,0,NULL,37634506819,588039169,9188112,16.67),(37314,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37314,36.57,0.52,206,10247,70,NULL,NULL,'2MASX J05043235-2508499',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'16.73',0.32,NULL,NULL,NULL,NULL,NULL,1,76.1347917,-25.14728,0,NULL,37215491813,581492059,9085813,16.73),(37315,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37315,34.72,0.8,88,10248,75,NULL,'MAT, I','MCG -03-13-064',NULL,'1997ApJS..109..333W',1997,1,2.02,NULL,'G',0.000033,NULL,'15.2b',0.24,'Sbc',NULL,NULL,NULL,NULL,1,76.142125,-17.09158,0.145,NULL,37569173656,587018338,9172161,15.2),(37316,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37316,34.15,0.32,67.5,10248,85,NULL,'I, raw','MCG -03-13-064',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37317,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37317,34.16,0.43,68,10248,75,NULL,'MAT, I, raw','MCG -03-13-064',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37318,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37318,34.18,0.32,68.6,10248,85,NULL,'I, inv','MCG -03-13-064',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37319,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37319,34.34,0.43,73.7,10248,75,NULL,'MAT, I, inv','MCG -03-13-064',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37320,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,'R',37320,34.41,0.49,76,10248,75,NULL,'IR','MCG -03-13-064',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37321,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37321,34.44,0.43,77.2,10248,75,NULL,'MAT, I, cor','MCG -03-13-064',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37322,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37322,34.49,NULL,79.1,10248,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -03-13-064',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37323,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37323,34.5,NULL,79.4,10248,NULL,NULL,'Dipole','MCG -03-13-064',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37324,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37324,34.5,NULL,79.4,10248,NULL,NULL,'Dipole + Quadrupole','MCG -03-13-064',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37325,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37325,34.73,0.52,88.3,10248,NULL,NULL,'Malmquist cor.','MCG -03-13-064',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37326,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37326,34.77,0.2,90,10248,74.4,NULL,NULL,'MCG -03-13-064',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37327,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37327,34.92,0.47,96.3,10248,NULL,NULL,NULL,'MCG -03-13-064',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37328,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37328,34.7,0.6,87.1,10249,NULL,NULL,'Malmquist cor.','ESO 158- G 017',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.39',0.8,'SAB(rs)b',NULL,NULL,NULL,NULL,1,76.1461666667,-55.52503,0,NULL,35955151732,561799245,8778113,14.39),(37329,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37329,35.04,0.51,102,10249,NULL,NULL,NULL,'ESO 158- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37330,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37330,35.08,0.2,104,10249,74.4,NULL,NULL,'ESO 158- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37331,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37331,35.08,0.4,104,10249,NULL,NULL,'mean','ESO 158- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37332,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37332,35.25,0.47,112,10249,NULL,NULL,'H','ESO 158- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37333,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37333,35.25,0.45,112,10249,NULL,NULL,'K','ESO 158- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37334,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37334,35.29,0.46,114,10249,NULL,NULL,'J','ESO 158- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37335,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37335,35.75,0.25,141,10250,74.4,NULL,NULL,'GIN 241',NULL,'2013AJ....146...86T',2013,1,0.85,NULL,'G',0.00003,NULL,'15.34',0.56,'E/S0',NULL,NULL,NULL,NULL,1,76.1480417,-19.26947,0.045,NULL,37554848355,586794505,9168664,15.34),(37336,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37336,37.16,0.16,271,10250,70,NULL,NULL,'GIN 241',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37337,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37337,36.94,0.25,244,10251,74.4,NULL,NULL,'GIN 245',NULL,'2013AJ....146...86T',2013,1,0.52,NULL,'G',0.000037,NULL,'14.62',0.4,'E/S0',NULL,NULL,NULL,NULL,1,76.1482917,-19.32197,0.061,NULL,37554438347,586788099,9168564,14.62),(37338,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37338,37.16,0.16,271,10251,70,NULL,NULL,'GIN 245',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37339,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37339,36.94,0.25,244,10252,74.4,NULL,NULL,'GIN 244',NULL,'2013AJ....146...86T',2013,1,0.39,NULL,'G',0.000037,NULL,'14.86',0.32,'S',NULL,NULL,NULL,NULL,1,76.1815833333,-19.31008,0.045,NULL,37554373325,586787083,9168548,14.86),(37340,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37340,37.16,0.16,271,10252,70,NULL,NULL,'GIN 244',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37341,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37341,36.19,0.65,173,10253,70,NULL,NULL,'2MASX J05044427-2033282',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'17.19',0.25,NULL,NULL,NULL,NULL,NULL,1,76.184417,-20.55794,0.033,NULL,37562996761,586921824,9170653,17.19),(37342,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37342,36.27,0.53,179,10254,70,NULL,NULL,'2MASX J05044457-2510399',NULL,'2014MNRAS.445.2677S',2014,1,0.69,NULL,'G',0.00015,NULL,'15.64',0.59,NULL,NULL,NULL,NULL,NULL,1,76.1856666667,-25.17769,0,NULL,37215493400,581492084,9085813,15.64),(37343,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37343,36.63,0.62,212,10255,70,NULL,NULL,'2MASX J05044560-2055562',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.82',0.28,NULL,NULL,NULL,NULL,NULL,1,76.190083,-20.93228,0.041,NULL,37548911111,586701736,9167214,16.82),(37344,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,'R',37344,35.19,0.49,109,10256,75,NULL,'IR','UGC 03242',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.00016,NULL,'15.42',0.3,'Sb',NULL,NULL,NULL,NULL,1,76.1945,4.47931,0.353,NULL,64612439287,1009569363,15774521,15.42),(37345,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37345,35.38,0.2,119,10256,74.4,NULL,NULL,'UGC 03242',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37346,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37346,35.39,0.29,120,10256,NULL,NULL,'Malmquist cor.','UGC 03242',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37347,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37347,35.42,0.29,121,10256,NULL,NULL,NULL,'UGC 03242',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37348,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37348,36.79,0.59,228,10257,70,NULL,NULL,'2MASX J05045024-3713115',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.000103,NULL,'16.67',0.31,NULL,NULL,NULL,NULL,NULL,1,76.209375,-37.21981,0.005,NULL,37601350353,587521099,9180017,16.67),(37349,'Tully est','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37349,32.97,0.8,39.3,10258,75,NULL,'B','ARK 118',NULL,'1988NBGC.C....0000T',1988,1,0.3,NULL,'G',NULL,NULL,'15.4',0.2,NULL,NULL,NULL,NULL,NULL,1,76.2140417,1.83108,0.321,NULL,64588579108,1009196548,15768696,15.4),(37350,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37350,34.65,0.57,85.2,10259,70,NULL,NULL,'ESO 305- G 005',NULL,'2014MNRAS.445.2677S',2014,1,1.01,NULL,'G',0.00015,NULL,'15.49',0.31,'S',NULL,NULL,NULL,NULL,1,76.2246666667,-38.10858,0.041,NULL,37601118019,587517469,9179960,15.49),(37351,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37351,33.63,0.54,53.3,10260,70,NULL,NULL,'ESO 015- G 018',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000087,NULL,'14.26',0.7,'SA0-:',NULL,NULL,NULL,NULL,1,76.2417917,-81.31069,0.329,NULL,35465530236,554148909,8658576,14.26),(37352,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37352,36.2,0.25,174,10261,74.4,NULL,NULL,'GIN 248',NULL,'2013AJ....146...86T',2013,1,0.49,NULL,'G',0.00004,NULL,'15.07',0.37,'S',NULL,NULL,NULL,NULL,1,76.244917,-19.31617,0.045,NULL,37554385992,586787281,9168551,15.07),(37353,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37353,37.16,0.16,271,10261,70,NULL,NULL,'GIN 248',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37354,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37354,36.75,0.7,224,10262,70,NULL,NULL,'ESO 486- G 025',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.65',0.6,'Sb',NULL,NULL,NULL,NULL,1,76.2497917,-25.20919,0,NULL,37215316763,581489324,9085770,15.65),(37355,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37355,36.33,0.57,184,10263,70,NULL,NULL,'6dF J0505013-745743',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,76.255833,-74.96203,0.453,NULL,35566405227,555725081,8683204,16.3),(37356,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37356,33.61,0.8,52.8,10264,75,NULL,'MAT, I','ESO 422- G 027',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.21',0.9,'SAB(r)c',NULL,NULL,NULL,NULL,1,76.2794583333,-31.78425,0,NULL,37272472463,582382382,9099724,14.21),(37357,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37357,33.54,0.43,51,10264,75,NULL,'MAT, I, raw','ESO 422- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37358,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37358,33.57,0.32,51.7,10264,85,NULL,'I, raw','ESO 422- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37359,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37359,33.59,0.32,52.2,10264,85,NULL,'I, inv','ESO 422- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37360,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37360,33.66,0.43,53.9,10264,75,NULL,'MAT, I, inv','ESO 422- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37361,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37361,33.85,0.2,58.9,10264,74.4,NULL,NULL,'ESO 422- G 027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37362,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37362,33.91,0.43,60.4,10264,75,NULL,'MAT, I, cor','ESO 422- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37363,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37363,34.03,0.41,64.1,10264,NULL,NULL,NULL,'ESO 422- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37364,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37364,34.1,0.4,66.2,10264,NULL,NULL,'Malmquist cor.','ESO 422- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37365,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37365,35.09,0.51,104,10265,NULL,NULL,NULL,'ESO 552- G 065',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.00003,NULL,'15.41',0.5,'S?',NULL,NULL,NULL,NULL,1,76.2843333333,-18.9865,0.077,NULL,37555700853,586807825,9168872,15.41),(37366,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37366,35.13,0.2,106,10265,74.4,NULL,NULL,'ESO 552- G 065',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37367,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37367,35.16,0.49,108,10265,NULL,NULL,'Malmquist cor.','ESO 552- G 065',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37368,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37368,36.94,0.25,244,10266,74.4,NULL,NULL,'GIN 240',NULL,'2013AJ....146...86T',2013,1,0.74,NULL,'G',0.000033,NULL,'14.30',0.47,'E/S0',NULL,NULL,NULL,NULL,1,76.302917,-19.14281,0.045,NULL,37554878195,586794971,9168671,14.3),(37369,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37369,37.16,0.16,271,10266,70,NULL,NULL,'GIN 240',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37370,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37370,31.14,0.8,16.9,10267,75,NULL,'MAT, I','NGC 1792',NULL,'1997ApJS..109..333W',1997,1,5.2,NULL,'G',0.000007,NULL,'10.87',2.6,'SA(rs)bc       HII','X-ray-faint group member',NULL,NULL,NULL,1,76.3102083,-37.98075,0.033,NULL,37600992332,587515505,9179929,10.87),(37371,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37371,31.17,0.8,17.1,10267,75,NULL,'A82, H','NGC 1792',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37372,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37372,29.91,0.43,9.6,10267,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1792',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37373,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37373,30.02,0.4,10.1,10267,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 1792',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37374,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37374,30.08,0.43,10.4,10267,75,NULL,'3.6 micron, color corrected','NGC 1792',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37375,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37375,30.19,0.47,10.9,10267,75,NULL,'A82, H, raw','NGC 1792',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37376,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37376,30.2,0.69,10.9,10267,100,NULL,'mid-IR','NGC 1792',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37377,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37377,30.2,0.35,11,10267,NULL,NULL,NULL,'NGC 1792',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37378,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37378,30.21,0.4,11,10267,73,NULL,'opt','NGC 1792',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37379,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37379,30.27,0.32,11.3,10267,85,NULL,'I, raw','NGC 1792',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37380,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37380,30.27,0.47,11.3,10267,75,NULL,'A82, H, inv','NGC 1792',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37381,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37381,30.3,0.2,11.5,10267,74.4,NULL,NULL,'NGC 1792',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37382,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37382,30.32,0.32,11.6,10267,85,NULL,'I, inv','NGC 1792',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37383,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37383,30.41,0.43,12.1,10267,75,NULL,'MAT, I, raw','NGC 1792',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37384,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37384,30.57,0.47,13,10267,75,NULL,'A82, H, cor','NGC 1792',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37385,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37385,30.61,0.43,13.2,10267,75,NULL,'MAT, I, inv','NGC 1792',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37386,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37386,30.66,0.4,13.6,10267,75,NULL,'B','NGC 1792',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37387,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37387,30.71,0.43,13.9,10267,75,NULL,'MAT, I, cor','NGC 1792',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37388,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37388,30.92,0.07,15.3,10267,NULL,NULL,NULL,'NGC 1792',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37389,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37389,36.93,0.25,243,10268,74.4,NULL,NULL,'GIN 239',NULL,'2013AJ....146...86T',2013,1,0.57,NULL,'G',0.00004,NULL,'14.07',0.54,'cD',NULL,NULL,NULL,NULL,1,76.318125,-19.21808,0.045,NULL,37554871377,586794865,9168669,14.07),(37390,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37390,37.16,0.16,271,10268,70,NULL,NULL,'GIN 239',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37391,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37391,36.27,0.7,179,10269,70,NULL,NULL,'2MASX J05051789-2421242',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'15.93',0.4,NULL,NULL,NULL,NULL,NULL,1,76.324625,-24.35672,0.033,NULL,37212739665,581449057,9085141,15.93),(37392,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37392,32.91,0.48,38.1,10270,70,NULL,NULL,'NGC 1779',NULL,'2014MNRAS.445.2677S',2014,1,2.3,NULL,'G',0.000047,NULL,'13.02',1.3,'(R\')SAB(r)0/a?','in an interacting pair',NULL,NULL,NULL,1,76.3252917,-9.14714,0.237,NULL,36594160664,571783760,8934121,13.02),(37393,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37393,37.42,0.68,305,10271,70,NULL,NULL,'AM 0504-474 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'16.57',0.3,NULL,NULL,NULL,NULL,NULL,1,76.328875,-47.58669,0,NULL,37620169838,587815153,9184611,16.57),(37394,'Ring Diameter','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37394,31.5,0.76,20,10272,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 1784',NULL,'1981ApJS...45..541P',1981,1,4,NULL,'G',0.00001,NULL,'12.44',2.5,'SB(r)c',NULL,NULL,NULL,NULL,1,76.362917,-11.87153,0.397,NULL,37515634929,586181795,9159090,12.44),(37395,'Ring Diameter','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37395,31.9,0.6,24,10272,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 1784',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37396,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37396,32.43,0.8,30.6,10272,75,NULL,'A82, H','NGC 1784',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37397,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37397,31.63,0.4,21.2,10272,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 1784',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37398,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37398,31.69,0.69,21.8,10272,100,NULL,'mid-IR','NGC 1784',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37399,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37399,31.97,0.46,24.8,10272,NULL,NULL,'J','NGC 1784',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37400,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37400,31.99,0.47,25,10272,NULL,NULL,'H','NGC 1784',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37401,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37401,32.01,0.43,25.2,10272,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1784',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37402,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37402,32.03,0.45,25.4,10272,NULL,NULL,'K','NGC 1784',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37403,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37403,32.07,0.43,25.9,10272,75,NULL,'3.6 micron, color corrected','NGC 1784',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37404,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37404,32.15,0.2,26.9,10272,74.4,NULL,NULL,'NGC 1784',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37405,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37405,32.18,0.47,27.2,10272,75,NULL,'A82, H, raw','NGC 1784',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37406,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37406,32.29,0.4,28.7,10272,75,NULL,'B','NGC 1784',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37407,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37407,32.34,0.47,29.3,10272,75,NULL,'A82, H, inv','NGC 1784',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37408,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37408,32.42,0.38,30.5,10272,NULL,NULL,NULL,'NGC 1784',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37409,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37409,32.42,0.4,30.5,10272,73,NULL,'opt','NGC 1784',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37410,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37410,32.44,0.4,30.7,10272,NULL,NULL,'mean','NGC 1784',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37411,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37411,32.64,0.47,33.7,10272,75,NULL,'A82, H, cor','NGC 1784',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37412,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37412,35.79,0.37,144,10273,NULL,NULL,'Malmquist cor.','ESO 552- G 069',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'15.74',0.6,'S...',NULL,NULL,NULL,NULL,1,76.3697083,-20.93783,0.041,NULL,37549390767,586709230,9167331,15.74),(37413,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37413,35.87,0.36,149,10273,NULL,NULL,NULL,'ESO 552- G 069',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37414,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37414,35.91,0.2,152,10273,74.4,NULL,NULL,'ESO 552- G 069',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37415,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37415,34.01,0.2,63.4,10274,74.4,NULL,NULL,'UGC 03235',NULL,'2013AJ....146...86T',2013,1,2.3,NULL,'G',0.000037,NULL,'16.0',0.9,'SAB(s)cd:',NULL,NULL,NULL,NULL,1,76.38675,67.00953,0.553,NULL,66382535200,1037227112,16206673,16),(37416,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37416,34.14,0.37,67.4,10274,NULL,NULL,NULL,'UGC 03235',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37417,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37417,34.26,0.35,71.1,10274,NULL,NULL,'Malmquist cor.','UGC 03235',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37418,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37418,36.93,0.25,243,10275,74.4,NULL,NULL,'GIN 247',NULL,'2013AJ....146...86T',2013,1,0.46,NULL,'G',0.000043,NULL,'15.12',0.26,'E/S0',NULL,NULL,NULL,NULL,1,76.395417,-19.15653,0.045,NULL,37554823137,586794111,9168657,15.12),(37419,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37419,37.16,0.16,271,10275,70,NULL,NULL,'GIN 247',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37420,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37420,35.62,0.25,133,10276,74.4,NULL,NULL,'GIN 252',NULL,'2013AJ....146...86T',2013,1,0.48,NULL,'G',0.000057,NULL,'14.30',0.43,'E/S0',NULL,NULL,NULL,NULL,1,76.4015417,-24.33147,0.033,NULL,37212735672,581448994,9085140,14.3),(37421,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37421,35.83,0.29,146,10276,70,NULL,NULL,'GIN 252',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37422,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37422,35.9,0.54,152,10276,70,NULL,NULL,'GIN 252',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37423,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37423,35.26,0.48,112,10277,70,NULL,NULL,'GIN 256',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.00015,NULL,'14.17',0.52,'S',NULL,NULL,NULL,NULL,1,76.416125,-23.74694,0.045,NULL,37329346916,583271045,9113610,14.17),(37424,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37424,35.63,0.25,134,10277,74.4,NULL,NULL,'GIN 256',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37425,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37425,35.83,0.29,146,10277,70,NULL,NULL,'GIN 256',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37426,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37426,36.04,0.52,161,10278,70,NULL,NULL,'ESO 422- G 028',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00013,NULL,'14.58',0.8,'S0?',NULL,NULL,'GRG','LINER',1,76.455083,-28.58872,0,NULL,37250393229,582037394,9094334,14.58),(37427,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,'R',37427,33.35,0.49,46.7,10279,75,NULL,'IR','2MFGC 04168',NULL,'2011yCatp016004901K',2011,1,2.8,'abs(b) < 10 degrees.','G',0.00003,NULL,'12.1K',0.9,'Sd',NULL,NULL,NULL,NULL,1,76.465375,41.61147,NULL,NULL,68227513664,1066054901,16657107,12.1),(37428,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37428,36.54,0.61,203,10280,70,NULL,NULL,'2MASX J05055315-2836593',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,76.471417,-28.61653,0,NULL,37250395877,582037435,9094334,14.2),(37429,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,'R',37429,33.39,0.49,47.7,10281,75,NULL,'IR','2MFGC 04169',NULL,'2011yCatp016004901K',2011,1,0.89,NULL,'G',0.000067,NULL,'10.7K',0.22,'S',NULL,NULL,NULL,NULL,1,76.4734583,21.6605,2.029,NULL,65450404655,1022662572,15979102,10.7),(37430,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37430,35.31,0.57,116,10282,70,NULL,NULL,'MCG -04-13-001 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'14.4R',0.49,NULL,NULL,NULL,NULL,NULL,1,76.487625,-24.44067,0.029,NULL,37212775046,581449610,9085150,14.4),(37431,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37431,36.09,0.57,165,10283,70,NULL,NULL,'2MASX J05055783-4647356',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'16.27',0.32,'S0',NULL,NULL,NULL,NULL,1,76.4910417,-46.79325,0,NULL,37619791731,587809245,9184519,16.27),(37432,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37432,34.83,0.49,92.6,10284,70,NULL,NULL,'ESO 252- G 010',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000093,NULL,'14.17',1.3,'SB(rl)b',NULL,NULL,NULL,NULL,1,76.5402917,-45.04711,0,NULL,37632775608,588012118,9187689,14.17),(37433,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37433,33.32,0.4,46.1,10285,NULL,NULL,'mean','IC 0402',NULL,'2007A&A...465...71T',2007,1,2.3,NULL,'G',0.000023,NULL,'13.42',1.5,'SAB(rs)cd','in an interacting pair',NULL,NULL,NULL,1,76.5617917,-9.10742,0.261,NULL,36594232582,571784884,8934138,13.42),(37434,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37434,33.77,0.47,56.7,10285,NULL,NULL,'H','IC 0402',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37435,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37435,35.32,0.6,116,10286,70,NULL,NULL,'2MASX J05061653-2111151',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'16.94',0.27,NULL,NULL,NULL,NULL,NULL,1,76.568917,-21.18761,0.037,NULL,37549420057,586709688,9167338,16.94),(37436,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37436,37.16,0.16,271,10287,70,NULL,NULL,'NGC 1780',NULL,'2001MNRAS.321..277C',2001,1,0.9,'Missing ESO entry \'552- G 71\' would have pointed to this galaxy.','G',0.00003,NULL,'14.69',0.5,'(R\')SB(r)0^0^:',NULL,NULL,NULL,NULL,1,76.5862916667,-19.46667,0.045,NULL,37554546947,586789796,9168590,14.69),(37437,'Tully est','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37437,29.36,0.8,7.4,10288,75,NULL,'B','NGC 1800',NULL,'1988NBGC.C....0000T',1988,1,2,NULL,'G',0.000003,NULL,'13.13',1.1,'IB(s)m         HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,76.6071666667,-31.95422,0,NULL,37271983919,582374748,9099605,13.13),(37438,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37438,29.52,NULL,8.02,10288,NULL,NULL,NULL,'NGC 1800',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37439,'D-Sigma','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37439,34.27,0.4,71.6,10289,75,NULL,'Edat, raw','ESO 553- G 002',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000097,NULL,'13.38',1.2,'SA(r)0^0^:','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,76.638583,-17.58583,0.121,NULL,37569244741,587019449,9172178,13.38),(37440,'D-Sigma','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37440,34.61,0.4,83.5,10289,75,NULL,'Edat, cor','ESO 553- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37441,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37441,34.31,0.46,72.8,10289,70,NULL,NULL,'ESO 553- G 002',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37442,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37442,34.23,0.4,70.3,10289,NULL,NULL,'mean','ESO 553- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37443,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37443,34.52,0.45,80,10289,NULL,NULL,'K','ESO 553- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37444,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37444,36.34,0.5,185,10290,70,NULL,NULL,'ESO 252- G 011',NULL,'2014MNRAS.445.2677S',2014,1,0.69,NULL,'G',0.00015,NULL,'15.44',0.43,'N',NULL,NULL,NULL,NULL,1,76.6404166667,-45.61719,0,NULL,37632465387,588007271,9187613,15.44),(37445,'Ring Diameter','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37445,33.5,0.84,50,10291,NULL,NULL,'Published at H = 100 km/s/Mpc','ESO 553- G 003',NULL,'1981ApJS...45..541P',1981,1,1.5,NULL,'G',0.000033,NULL,'14.0b',0.9,'SAB(rs)c','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,76.656833,-17.55336,0.121,NULL,37569244101,587019439,9172178,14),(37446,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37446,33.89,0.8,59.9,10291,75,NULL,'MAT, I','ESO 553- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37447,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37447,33.2,0.69,43.6,10291,100,NULL,'mid-IR','ESO 553- G 003',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37448,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37448,33.23,0.43,44.2,10291,75,NULL,'MAT, I, raw','ESO 553- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37449,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37449,33.25,0.32,44.7,10291,85,NULL,'I, raw','ESO 553- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37450,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37450,33.28,0.32,45.3,10291,85,NULL,'I, inv','ESO 553- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37451,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37451,33.37,0.43,47.2,10291,75,NULL,'MAT, I, inv','ESO 553- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37452,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37452,33.46,0.43,49.2,10291,75,NULL,'MAT, I, cor','ESO 553- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37453,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,'R',37453,33.57,NULL,51.8,10291,NULL,NULL,'I','ESO 553- G 003',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37454,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,'R',37454,33.77,NULL,56.8,10291,NULL,NULL,'B','ESO 553- G 003',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37455,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37455,34,0.2,63.1,10291,74.4,NULL,NULL,'ESO 553- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37456,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37456,34.08,0.4,65.6,10291,NULL,NULL,'mean','ESO 553- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37457,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37457,34.12,0.47,66.8,10291,NULL,NULL,'H','ESO 553- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37458,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37458,34.14,0.64,67.4,10291,NULL,NULL,NULL,'ESO 553- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37459,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37459,34.15,0.64,67.6,10291,NULL,NULL,'Malmquist cor.','ESO 553- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37460,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37460,34.18,0.46,68.7,10291,NULL,NULL,'J','ESO 553- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37461,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37461,34.21,0.45,69.4,10291,NULL,NULL,'K','ESO 553- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37462,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37462,36.01,0.52,159,10292,70,NULL,NULL,'2MASX J05063865-1659590',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.57',NULL,NULL,NULL,NULL,NULL,NULL,1,76.6610417,-16.99964,0.081,NULL,37569356580,587021196,9172206,16.57),(37463,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37463,36.65,0.8,213,10293,70,NULL,NULL,'2MASX J05064500-2518185',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.12',0.42,'S',NULL,NULL,NULL,NULL,1,76.6875833333,-25.30522,0,NULL,37249092458,582017069,9094016,16.12),(37464,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37464,35.38,0.67,119,10294,70,NULL,NULL,'2MASX J05064566-1750290',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'16.65',0.18,NULL,NULL,NULL,NULL,NULL,1,76.6902083,-17.84136,0.113,NULL,37552008290,586750129,9167970,16.65),(37465,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37465,36.14,0.51,169,10295,70,NULL,NULL,'ESO 422- G 032',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'15.35',0.7,'S0',NULL,NULL,NULL,NULL,1,76.699125,-28.15039,0,NULL,37253172442,582080819,9095012,15.35),(37466,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37466,35.25,0.64,112,10296,70,NULL,NULL,'2MASX J05064821-2133077',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'16.84',0.35,NULL,NULL,NULL,NULL,NULL,1,76.700875,-21.55217,0.045,NULL,37549343537,586708492,9167320,16.84),(37467,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37467,35.52,0.49,127,10297,70,NULL,NULL,'IC 2119',NULL,'2014MNRAS.445.2677S',2014,1,1.1,'10 degree error in IC declination.','G',0.00009,NULL,'14.64',0.7,'(R)SB(r)b',NULL,NULL,NULL,NULL,1,76.7122917,-20.34519,0.041,NULL,37562202905,586909420,9170459,14.64),(37468,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37468,31.13,0.8,16.9,10298,75,NULL,'MAT, I','NGC 1824',NULL,'1997ApJS..109..333W',1997,1,3.2,NULL,'G',0.00001,NULL,'13.0',0.9,'SB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,76.734167,-59.72397,0.013,NULL,35962863717,561919745,8779996,13),(37469,'Tully est','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37469,30.72,0.8,13.9,10298,75,NULL,NULL,'NGC 1824',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37470,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37470,30,0.32,10,10298,85,NULL,'I, inv','NGC 1824',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37471,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37471,30.04,0.32,10.2,10298,85,NULL,'I, raw','NGC 1824',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37472,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37472,30.25,0.43,11.2,10298,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1824',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37473,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37473,30.26,0.2,11.3,10298,74.4,NULL,NULL,'NGC 1824',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37474,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37474,30.29,0.43,11.4,10298,75,NULL,'3.6 micron, color corrected','NGC 1824',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37475,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37475,30.44,0.43,12.3,10298,75,NULL,'MAT, I, inv','NGC 1824',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37476,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37476,30.47,0.4,12.4,10298,NULL,NULL,NULL,'NGC 1824',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37477,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37477,30.47,0.4,12.4,10298,73,NULL,'opt','NGC 1824',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37478,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37478,30.52,0.43,12.7,10298,75,NULL,'MAT, I, raw','NGC 1824',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37479,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37479,30.8,0.43,14.5,10298,75,NULL,'MAT, I, cor','NGC 1824',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37480,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37480,35.12,0.57,106,10299,70,NULL,NULL,'2MASX J05065733-7304540',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.4b',0.43,NULL,NULL,NULL,NULL,NULL,1,76.738667,-73.08175,0.397,NULL,35562429928,555662967,8682233,16.4),(37481,'BL Lac Luminosity','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37481,40.71,NULL,1390,10300,NULL,NULL,'Min. z = 0.4','1FGL J0506.9-5435',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,76.742,-54.599,0.305,NULL,35948992794,561703012,8776609,NULL),(37482,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37482,36.01,0.58,159,10301,70,NULL,NULL,'ESO 362- G 004',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'16.02',0.2,'Sb:',NULL,NULL,NULL,NULL,1,76.772875,-34.46103,0.009,NULL,37266247785,582285121,9098205,16.02),(37483,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37483,35.41,0.8,121,10302,75,NULL,'HMCL, I','UGC 03248',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000023,NULL,'14.55',0.8,'Sb',NULL,NULL,NULL,NULL,1,76.777125,3.97858,0.409,NULL,64611633683,1009556776,15774324,14.55),(37484,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37484,35.41,0.8,121,10302,75,NULL,'W91CL, r','UGC 03248',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37485,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37485,35.42,0.8,121,10302,75,NULL,'CF, r','UGC 03248',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37486,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37486,34.54,0.38,81,10302,75,NULL,'CF, r, raw','UGC 03248',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37487,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37487,34.56,0.38,81.7,10302,75,NULL,'W91CL, r, raw','UGC 03248',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37488,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37488,34.62,0.4,83.9,10302,75,NULL,'HMCL, I, raw','UGC 03248',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37489,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37489,34.72,0.38,88,10302,75,NULL,'CF, r, inv','UGC 03248',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37490,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37490,34.73,0.38,88.5,10302,75,NULL,'W91CL, r, inv','UGC 03248',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37491,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37491,34.8,0.59,91.1,10302,NULL,NULL,'Malmquist cor.','UGC 03248',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37492,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37492,34.83,0.4,92.6,10302,75,NULL,'HMCL, I, inv','UGC 03248',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37493,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37493,34.85,0.69,93.2,10302,100,NULL,'mid-IR','UGC 03248',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37494,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37494,34.85,0.38,93.2,10302,75,NULL,'CF, r, cor','UGC 03248',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37495,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37495,34.9,0.57,95.5,10302,NULL,NULL,NULL,'UGC 03248',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37496,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37496,34.94,0.2,97.3,10302,74.4,NULL,NULL,'UGC 03248',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37497,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37497,34.95,0.38,97.7,10302,75,NULL,'W91CL, r, cor','UGC 03248',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37498,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37498,34.98,0.4,99.2,10302,75,NULL,'HMCL, I, cor','UGC 03248',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37499,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37499,35.6,0.4,132,10302,NULL,NULL,'mean','UGC 03248',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37500,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37500,35.79,0.47,144,10302,NULL,NULL,'H','UGC 03248',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37501,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37501,35.01,0.48,100,10303,70,NULL,NULL,'2MASX J05070800-1954058',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,76.783375,-19.90156,0.053,NULL,37554693562,586792086,9168626,13.3),(37502,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37502,36.12,0.5,167,10304,70,NULL,NULL,'2MASX J05070875-1640539',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00013,NULL,'15.97',0.6,NULL,NULL,NULL,NULL,NULL,1,76.7864583,-16.68164,0.101,NULL,37522891850,586295185,9160862,15.97),(37503,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37503,36.51,0.57,201,10305,70,NULL,NULL,'2MASX J05071061-5854325',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,76.794375,-58.90903,0,NULL,35965832489,561966132,8780720,14),(37504,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37504,35.49,0.46,125,10306,70,NULL,NULL,'2MASX J05072402-4618193',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00008,NULL,'15.48',0.5,'E',NULL,NULL,NULL,NULL,1,76.85,-46.30544,0,NULL,37637640219,588088128,9188877,15.48),(37505,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,'R',37505,34.33,0.49,73.5,10307,75,NULL,'IR','2MFGC 04180',NULL,'2011yCatp016004901K',2011,1,0.6,NULL,'G',0.000033,NULL,'11.9K',0.1,'S?',NULL,NULL,NULL,NULL,1,76.873333,25.05769,NULL,NULL,64895045444,1013985085,15843516,11.9),(37506,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37506,32.44,0.4,30.8,10308,73,NULL,'IR','FGC 0523',NULL,'2011A&A...532A.104N',2011,1,2.26,NULL,'G',0.00001,NULL,'15.4',0.17,'Sd',NULL,NULL,NULL,NULL,1,76.8834583333,-11.65161,0.385,NULL,37514129618,586158275,9158723,15.4),(37507,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37507,32.44,0.4,30.8,10308,73,NULL,'opt','FGC 0523',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37508,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,'R',37508,32.44,0.4,30.8,10308,75,NULL,NULL,'FGC 0523',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37509,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,'R',37509,32.86,0.49,37.3,10308,75,NULL,'IR','FGC 0523',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37510,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37510,33.07,NULL,41.1,10308,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0523',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37511,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37511,33.08,NULL,41.3,10308,NULL,NULL,'Dipole + Quadrupole','FGC 0523',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37512,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37512,33.09,NULL,41.4,10308,NULL,NULL,'Dipole','FGC 0523',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37513,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37513,33.15,NULL,42.6,10308,NULL,NULL,NULL,'FGC 0523',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37514,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37514,35.18,0.46,109,10309,70,NULL,NULL,'ESO 486- G 029',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000097,NULL,'14.59',0.8,'S0       poss. LINER','Pair member (points to parent)',NULL,NULL,NULL,1,76.896875,-23.06697,0.033,NULL,37547803531,586684430,9166944,14.59),(37515,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37515,35.76,0.57,142,10310,70,NULL,NULL,'2MASX J05073712-1951379',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.81',0.3,NULL,NULL,NULL,NULL,NULL,1,76.90475,-19.86069,0.053,NULL,37554660253,586791566,9168618,16.81),(37516,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37516,35.43,0.55,122,10311,70,NULL,NULL,'2MASX J05073951-1932539',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.61',0.4,NULL,NULL,NULL,NULL,NULL,1,76.914583,-19.5485,0.061,NULL,37554046897,586781982,9168468,16.61),(37517,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37517,35.89,0.59,151,10312,70,NULL,NULL,'2MASX J05073954-2016309',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.3,NULL,NULL,NULL,NULL,NULL,1,76.9147917,-20.27522,0.041,NULL,37553956478,586780569,9168446,14),(37518,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37518,35,0.57,100,10313,70,NULL,NULL,'ESO 422- G 036',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.00015,NULL,'16',0.4,'Sa',NULL,NULL,NULL,NULL,1,76.919875,-28.07961,0,NULL,37252047943,582063249,9094738,16),(37519,'Tully est','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37519,30.17,0.8,10.8,10314,75,NULL,'B','NGC 1808',NULL,'1988NBGC.C....0000T',1988,1,6.5,'Extended HIPASS source','G',0.000013,NULL,'10.76',3.9,'(R\'_1)SAB(s:)b Sy2','X-ray-faint group member',NULL,NULL,'H II',1,76.926417,-37.51306,0.061,NULL,37600659825,587510309,9179848,10.76),(37520,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37520,29.16,0.43,6.8,10314,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1808',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37521,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37521,29.47,0.43,7.8,10314,75,NULL,'3.6 micron, color corrected','NGC 1808',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37522,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37522,29.79,0.2,9.08,10314,74.4,NULL,NULL,'NGC 1808',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37523,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37523,30.34,NULL,11.7,10314,75,NULL,'HI','NGC 1808',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37524,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37524,30.45,NULL,12.3,10314,75,NULL,'CO','NGC 1808',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37525,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37525,30.45,0.36,12.3,10314,NULL,NULL,NULL,'NGC 1808',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37526,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37526,30.45,0.4,12.3,10314,73,NULL,'opt','NGC 1808',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37527,'Tully est','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37527,31.11,0.8,16.7,10315,75,NULL,NULL,'ESO 085- G 047',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000007,NULL,'14.53',1.4,'SB(s)m',NULL,NULL,NULL,NULL,1,76.93275,-62.99008,0.005,NULL,35901157082,560955579,8764930,14.53),(37528,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37528,33.43,0.51,48.6,10316,70,NULL,NULL,'NGC 1799',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'14.5b',0.6,'SB0^0^ pec?',NULL,NULL,NULL,NULL,1,76.935917,-7.96928,0.185,NULL,36606915582,571983055,8937235,14.5),(37529,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37529,35.5,0.48,126,10317,NULL,NULL,NULL,'ESO 553- G 006',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.92',0.7,'Sc',NULL,NULL,NULL,NULL,1,76.936625,-19.624,0.061,NULL,37554159821,586783747,9168496,15.92),(37530,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37530,35.54,0.2,128,10317,74.4,NULL,NULL,'ESO 553- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37531,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37531,35.62,0.45,133,10317,NULL,NULL,'Malmquist cor.','ESO 553- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37532,'Sosies','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37532,34.46,0.54,78,10318,NULL,NULL,NULL,'NGC 1797',NULL,'2002A&A...393...57T',2002,1,1.1,NULL,'G',0.00015,NULL,'15.5',0.8,'(R\')SB(rs)a pecHII',NULL,NULL,NULL,'Starburst',1,76.937,-8.01908,0.209,NULL,36606957332,571983708,8937245,15.5),(37533,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37533,34.05,0.4,64.5,10318,NULL,NULL,'mean','NGC 1797',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37534,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37534,34.35,0.45,74,10318,NULL,NULL,'K','NGC 1797',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37535,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37535,34.43,0.47,76.9,10318,NULL,NULL,'H','NGC 1797',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37536,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37536,34.52,0.46,80.1,10318,NULL,NULL,'J','NGC 1797',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37537,'Tully est','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37537,31.98,0.8,24.9,10319,75,NULL,NULL,'DDO 036',NULL,'1988NBGC.C....0000T',1988,1,2.3,NULL,'G',0.000007,NULL,'13.57',1.4,'SB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,76.945417,-16.29361,0.169,NULL,37523037090,586297454,9160897,13.57),(37538,'BL Lac Luminosity','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37538,41.37,NULL,1430,10320,NULL,NULL,NULL,'87GB 050246.4+673341',0.314,'2005ApJ...635..173S',2005,1,NULL,'Landt et al. (2002MNRAS.336..945L) give z = 0.416.','QSO',NULL,NULL,'18.5',NULL,'BLLAC',NULL,NULL,NULL,'BL Lac',1,76.984375,67.62344,0.525,NULL,66382317348,1037223708,16206620,18.5),(37539,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37539,36.18,0.65,172,10321,70,NULL,NULL,'2MASX J05075769-7107071',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.5b',0.43,NULL,NULL,NULL,NULL,NULL,1,76.9902916667,-71.11872,0.349,NULL,35508248421,554816381,8669005,16.5),(37540,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37540,35.98,0.52,157,10322,70,NULL,NULL,'2MASX J05075972-2208397',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.52',NULL,NULL,NULL,NULL,NULL,NULL,1,76.998583,-22.14439,0.013,NULL,37548987198,586702924,9167233,16.52),(37541,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37541,36.24,0.61,177,10323,70,NULL,NULL,'2MASX J05080568-2011048',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.3,NULL,NULL,NULL,NULL,NULL,1,77.02375,-20.18464,0.049,NULL,37553906645,586779791,9168434,14),(37542,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37542,36.6,0.58,209,10324,70,NULL,NULL,'2MASX J05080625-4723257',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.00015,NULL,'15.72',0.4,'E',NULL,NULL,NULL,NULL,1,77.026167,-47.39047,0,NULL,37620753696,587824276,9184754,15.72),(37543,'Tully est','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37543,30.23,0.8,11.1,10325,75,NULL,NULL,'ESO 305- G 009',NULL,'1988NBGC.C....0000T',1988,1,3.5,'The APM data refer to the bright central part of the galaxy.','G',0.000007,NULL,'13.07',2.8,'SB(s)dm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,77.03175,-38.30931,0.057,NULL,37600438751,587506855,9179794,13.07),(37544,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37544,30.5,0.43,12.6,10325,75,NULL,'3.6 micron, color + selection bias corrected','ESO 305- G 009',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37545,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37545,30.7,0.43,13.8,10325,75,NULL,'3.6 micron, color corrected','ESO 305- G 009',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37546,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37546,30.8,0.2,14.5,10325,74.4,NULL,NULL,'ESO 305- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37547,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37547,30.92,0.4,15.3,10325,NULL,NULL,NULL,'ESO 305- G 009',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37548,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37548,30.92,0.4,15.3,10325,73,NULL,'opt','ESO 305- G 009',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37549,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37549,35.41,0.46,121,10326,70,NULL,NULL,'ESO 553- G 009',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000077,NULL,'14.86',0.7,'S0',NULL,NULL,NULL,NULL,1,77.036583,-22.12556,0.013,NULL,37415604433,584618819,9134669,14.86),(37550,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37550,34.78,0.46,90.3,10327,70,NULL,NULL,'ESO 553- G 010',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000087,NULL,'14.92',0.5,'S0?',NULL,NULL,NULL,NULL,1,77.0761666667,-19.83333,0.049,NULL,37554676090,586791813,9168622,14.92),(37551,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37551,35.67,0.46,136,10328,NULL,NULL,'Malmquist cor.','ESO 033- G 015',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.69',0.4,'S...',NULL,NULL,NULL,NULL,1,77.0999583333,-73.13769,0.417,NULL,35562323724,555661308,8682207,15.69),(37552,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37552,35.81,0.44,145,10328,NULL,NULL,NULL,'ESO 033- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37553,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37553,35.85,0.2,148,10328,74.4,NULL,NULL,'ESO 033- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37554,'GRB','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,'R',37554,45.9,1.67,4580,10329,100,NULL,NULL,'GRB 060124',2.3,'2009EPJC...63..139W',2009,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,77.108333,69.74089,0.453,NULL,66378033715,1037156776,16205574,NULL),(37555,'GRB','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,'R',37555,46.09,1.62,5010,10329,100,NULL,NULL,'GRB 060124',2.3,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37556,'GRB','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37556,46.35,0.4,5640,10329,69.7,NULL,'Fiducial','GRB 060124',2.3,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37557,'GRB','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37557,46.78,0.38,6880,10329,69.7,NULL,'Calibrated','GRB 060124',2.3,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37558,'GRB','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,'R',37558,46.87,0.45,7180,10329,72,NULL,NULL,'GRB 060124',2.296,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37559,'GRB','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37559,47.02,0.44,7690,10329,70,NULL,NULL,'GRB 060124',2.296,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37560,'GRB','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,'R',37560,47.22,0.52,8420,10329,NULL,NULL,NULL,'GRB 060124',2.3,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37561,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37561,35.33,0.8,116,10330,75,NULL,'MAT, I','ESO 119- G 038',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.67',0.8,'SAB(s)bc',NULL,NULL,NULL,NULL,1,77.1123333333,-61.36936,0.005,NULL,35878832371,560606755,8759480,14.67),(37562,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37562,33.64,0.32,53.5,10330,85,NULL,'I, raw','ESO 119- G 038',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37563,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37563,33.66,0.32,53.9,10330,85,NULL,'I, inv','ESO 119- G 038',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37564,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37564,33.93,0.43,61,10330,75,NULL,'MAT, I, raw','ESO 119- G 038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37565,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37565,34.06,0.43,64.9,10330,75,NULL,'MAT, I, inv','ESO 119- G 038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37566,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37566,34.27,0.43,71.3,10330,75,NULL,'MAT, I, cor','ESO 119- G 038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37567,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,'R',37567,34.5,0.47,79.4,10330,NULL,NULL,'B, Hubble-type-TF','ESO 119- G 038',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37568,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37568,37.86,0.59,372,10331,70,NULL,NULL,'2MASX J05083040-3736362',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'16.47',0.35,NULL,NULL,NULL,NULL,NULL,1,77.1267083,-37.61008,0.061,NULL,37600846441,587513225,9179894,16.47),(37569,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37569,35.01,0.65,100,10332,70,NULL,NULL,'2MASX J05084125-1812268',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3R',NULL,'poss. LINER',NULL,NULL,NULL,NULL,1,77.171833,-18.2075,0.061,NULL,37552488420,586757631,9168087,14.3),(37570,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,'R',37570,32.36,0.49,29.7,10333,75,NULL,'IR','NGC 1811',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.000053,NULL,'14.42',0.4,'Sa: pec sp','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,77.178083,-29.27597,0,NULL,37250135701,582033370,9094271,14.42),(37571,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37571,32.66,0.47,34,10333,NULL,NULL,'H','NGC 1811',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37572,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37572,32.76,0.45,35.6,10333,NULL,NULL,'K','NGC 1811',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37573,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37573,32.81,0.46,36.5,10333,NULL,NULL,'J','NGC 1811',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37574,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37574,33.26,0.4,44.9,10333,NULL,NULL,'mean','NGC 1811',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37575,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37575,35.65,0.78,135,10334,70,NULL,NULL,'2MASX J05084539-7614157',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,77.18925,-76.23764,0.429,NULL,35545486682,555398229,8678097,16.5),(37576,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37576,35.32,0.62,116,10335,70,NULL,NULL,'2MASX J05084882-2007319',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.90',NULL,NULL,NULL,NULL,NULL,NULL,1,77.2035,-20.12567,0.057,NULL,37553821300,586778457,9168413,16.9),(37577,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37577,36.14,0.63,169,10336,70,NULL,NULL,'2MASX J05084934-2248239',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.69',0.25,NULL,NULL,NULL,NULL,NULL,1,77.205667,-22.80672,0.041,NULL,37413977250,584593394,9134271,16.69),(37578,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37578,36.66,0.59,215,10337,70,NULL,NULL,'2MASX J05085150-1828089',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,77.214625,-18.46922,0.057,NULL,37552219890,586753435,9168022,15.3),(37579,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37579,36.34,0.63,186,10338,70,NULL,NULL,'2MASX J05085341-2330309',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.000103,NULL,'17.11',0.25,NULL,NULL,NULL,NULL,NULL,1,77.2225417,-23.50861,0.025,NULL,37413391065,584584235,9134128,17.11),(37580,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37580,33.98,0.46,62.6,10339,70,NULL,NULL,'ESO 553- G 012',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000073,NULL,'14.10',0.8,'S?',NULL,NULL,NULL,NULL,1,77.259125,-20.25564,0.069,NULL,37422786121,584731033,9136422,14.1),(37581,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37581,36.67,0.77,216,10340,70,NULL,NULL,'2MASX J05090792-7545369',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,77.283167,-75.76025,0.429,NULL,35544661776,555385340,8677895,16.9),(37582,'Tully est','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37582,32.63,0.8,33.6,10341,75,NULL,NULL,'UGCA 101',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.00002,NULL,'15.23',0.8,'IB(s)m',NULL,NULL,NULL,NULL,1,77.2895,-9.26067,0.249,NULL,36594454338,571788349,8934192,15.23),(37583,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37583,36.81,0.76,230,10342,70,NULL,NULL,'2MASX J05091377-1812499',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,77.3074583,-18.21378,0.057,NULL,37551790350,586746724,9167917,17.2),(37584,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37584,36.55,0.62,204,10343,70,NULL,NULL,'2MASX J05092006-1811545',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,77.333625,-18.19853,0.057,NULL,37551790687,586746729,9167917,16.2),(37585,'GRB','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37585,42.53,1.23,1590,10344,70,NULL,NULL,'GRB 991216',1.02,'2007ApJ...660...16S',2007,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'BAT/PCA',NULL,NULL,NULL,NULL,1,77.38,11.28528,1.385,NULL,65314678078,1020541844,15945966,NULL),(37586,'GRB','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37586,42.95,0.44,1930,10344,69.7,NULL,'Fiducial','GRB 991216',1.02,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37587,'GRB','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37587,43.12,0.35,2080,10344,69.7,NULL,'Calibrated','GRB 991216',1.02,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37588,'GRB','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,'R',37588,43.16,0.43,2120,10344,72,NULL,NULL,'GRB 991216',1.02,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37589,'GRB','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,'R',37589,44.02,0.83,2300,10344,73,NULL,'H const./H=100','GRB 991216',1.02,'2006astro.ph..9262M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37590,'GRB','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,'R',37590,44.29,0.21,3570,10344,70,NULL,NULL,'GRB 991216',1.02,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37591,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37591,35.56,0.55,129,10345,70,NULL,NULL,'2MASX J05093288-2022556',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.27',NULL,NULL,NULL,NULL,NULL,NULL,1,77.386917,-20.38203,0.041,NULL,37422851780,584732059,9136438,16.27),(37592,'BL Lac Luminosity','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37592,41.1,NULL,1270,10346,NULL,NULL,NULL,'SHBL J050939.0-040036',0.304,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',NULL,NULL,'19.0',NULL,'BLLAC',NULL,NULL,NULL,'BL Lac',1,77.409083,-4.01264,0.333,NULL,36619938613,572186540,8940414,19),(37593,'GRB','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,'R',37593,43.98,0.43,2480,10347,73,NULL,'H const./H=100','GRB 990705',0.8424,'2006astro.ph..9262M',2006,1,NULL,NULL,'G',0.0002,NULL,'22.7R',NULL,'SAX/WFC',NULL,NULL,NULL,NULL,1,77.478333,-72.13167,0.373,NULL,35506516705,554789323,8668583,22.7),(37594,'GRB','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37594,43.4,0.38,2600,10347,69.7,NULL,'Calibrated','GRB 990705',0.8424,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37595,'GRB','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,'R',37595,43.63,0.53,2890,10347,73,NULL,'H const./H=100','GRB 990705',0.8424,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37596,'GRB','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,'R',37596,43.69,0.47,2970,10347,72,NULL,NULL,'GRB 990705',0.8424,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37597,'GRB','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37597,43.72,0.49,3010,10347,69.7,NULL,'Fiducial','GRB 990705',0.8424,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37598,'GRB','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37598,43.77,0.46,3080,10347,70,NULL,NULL,'GRB 990705',0.8424,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37599,'GRB','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,'R',37599,43.75,0.06,5620,10347,NULL,NULL,NULL,'GRB 990705',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37600,'GRB','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,'R',37600,43.86,0.22,5920,10347,NULL,NULL,NULL,'GRB 990705',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37601,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37601,34.96,0.56,98.1,10348,70,NULL,NULL,'2MASX J05095603-0028470',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.000087,NULL,'15.33',NULL,NULL,NULL,NULL,NULL,NULL,1,77.483625,-0.47992,0.417,NULL,36611792499,572059257,8938425,15.33),(37602,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37602,31.82,0.39,23.1,10349,73,NULL,'IR','MCG -02-14-002',NULL,'2011A&A...532A.104N',2011,1,1.4,'Confused HIPASS source','G',0.000013,NULL,'14.5',0.5,'SB(s)dm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,77.519,-14.9465,0.269,NULL,37523492221,586304565,9161008,14.5),(37603,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37603,31.82,0.39,23.1,10349,73,NULL,'opt','MCG -02-14-002',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37604,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,'R',37604,31.82,0.4,23.2,10349,75,NULL,NULL,'MCG -02-14-002',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37605,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,'R',37605,32.68,0.49,34.3,10349,75,NULL,'IR','MCG -02-14-002',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37606,'Tully est','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37606,30.32,0.8,11.6,10350,75,NULL,NULL,'NGC 1827',NULL,'1988NBGC.C....0000T',1988,1,3,NULL,'G',0.000013,NULL,'13.24',0.7,'SAB(s)cd: sp   HII','X-ray-faint group member',NULL,NULL,NULL,1,77.519167,-36.96025,0.037,NULL,37079315624,579364306,9052567,13.24),(37607,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,'R',37607,30.2,0.4,11,10350,75,NULL,NULL,'NGC 1827',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37608,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37608,30.21,0.4,11,10350,73,NULL,'IR','NGC 1827',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37609,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,'R',37609,30.68,0.49,13.7,10350,75,NULL,'IR','NGC 1827',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37610,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37610,36.25,0.63,178,10351,70,NULL,NULL,'2MASX J05100473-5315387',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'15.9b',0.27,NULL,NULL,NULL,NULL,NULL,1,77.519625,-53.26075,0.325,NULL,35727007445,558234491,8722413,15.9),(37611,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37611,36.21,0.63,175,10352,70,NULL,NULL,'2MASX J05100679-2437331',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'17.41',0.15,NULL,NULL,NULL,NULL,NULL,1,77.5284166667,-24.62583,0.041,NULL,37246281559,581973149,9093330,17.41),(37612,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37612,35.72,0.62,140,10353,70,NULL,NULL,'2MASX J05100803-0049130',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,77.533375,-0.82025,0.461,NULL,36611947874,572061685,8938463,15.6),(37613,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37613,35.65,0.62,135,10354,70,NULL,NULL,'2MASX J05100922-0056470',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.8b',0.6,NULL,NULL,NULL,NULL,NULL,1,77.5385,-0.94636,0.473,NULL,36611909360,572061083,8938454,15.8),(37614,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37614,35.92,0.76,153,10355,70,NULL,NULL,'2MASX J05101129-0047023',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.59',0.5,NULL,NULL,NULL,NULL,NULL,1,77.547167,-0.78411,0.461,NULL,36611939225,572061550,8938461,16.59),(37615,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37615,36.19,0.7,173,10356,70,NULL,NULL,'2MASX J05101254-1634328',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.67',0.4,NULL,NULL,NULL,NULL,NULL,1,77.5520417,-16.57597,0.133,NULL,37522689425,586292022,9160812,16.67),(37616,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,'R',37616,34.39,0.49,75.5,10357,75,NULL,'IR','ESO 422- G 040',NULL,'2011yCatp016004901K',2011,1,1.6,NULL,'G',0.000013,NULL,'15',0.4,'Sb-c    poss. LINER?',NULL,NULL,NULL,NULL,1,77.557917,-29.40364,0,NULL,37249888641,582029510,9094211,15),(37617,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37617,34.95,0.47,97.7,10357,NULL,NULL,'H','ESO 422- G 040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37618,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37618,35.02,0.2,101,10357,74.4,NULL,NULL,'ESO 422- G 040',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37619,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37619,35.01,0.45,101,10357,NULL,NULL,'K','ESO 422- G 040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37620,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37620,35.01,0.4,101,10357,NULL,NULL,'mean','ESO 422- G 040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37621,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37621,35.02,0.46,101,10357,NULL,NULL,'J','ESO 422- G 040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37622,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37622,36.38,0.49,188,10358,70,NULL,NULL,'2MASX J05101606-1819059',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000097,NULL,'14.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,77.567,-18.31833,0.057,NULL,37421656965,584713390,9136146,14.8),(37623,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37623,36.77,0.68,226,10359,70,NULL,NULL,'2MASX J05101810-1818070',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,77.575375,-18.30189,0.057,NULL,37421700895,584714076,9136157,14.6),(37624,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37624,34.03,0.4,64.1,10360,NULL,NULL,'mean','UGC 03250',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000023,NULL,'13.9',1.4,'SBb',NULL,NULL,NULL,NULL,1,77.63175,63.16547,1.265,NULL,66166356771,1033849324,16153895,13.9),(37625,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37625,34.23,0.47,70.1,10360,NULL,NULL,'H','UGC 03250',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37626,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37626,34.27,0.46,71.4,10360,NULL,NULL,'J','UGC 03250',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37627,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37627,34.27,0.45,71.5,10360,NULL,NULL,'K','UGC 03250',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37628,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37628,34.87,0.43,94,10360,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03250',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37629,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37629,30.16,0.4,10.8,10361,75,NULL,'B','UGCA 103',NULL,'1988NBGC.C....0000T',1988,1,3,NULL,'G',0.00001,NULL,'13.13',2.5,'SB(r)dm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,77.6957083,-31.59711,0,NULL,37273506678,582398541,9099977,13.13),(37630,'Tully est','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37630,32.77,0.8,35.8,10362,75,NULL,NULL,'UGCA 102',NULL,'1988NBGC.C....0000T',1988,1,0.7,NULL,'G',0.00002,NULL,'14.10',0.6,'I0 pec?',NULL,NULL,NULL,NULL,1,77.700417,-2.68161,0.373,NULL,36622133669,572220838,8940950,14.1),(37631,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37631,35.7,0.79,138,10363,70,NULL,NULL,'2MASX J05105791-0645579',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.36',NULL,NULL,NULL,NULL,NULL,NULL,1,77.7414583,-6.76633,0.377,NULL,36599270754,571863605,8935368,16.36),(37632,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37632,36.05,0.52,162,10364,70,NULL,NULL,'2MASX J05110045-0840049',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.79',NULL,NULL,NULL,NULL,NULL,NULL,1,77.7517917,-8.66814,0.293,NULL,36593076648,571766822,8933856,15.79),(37633,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37633,35.41,0.5,121,10365,70,NULL,NULL,'2MASX J05110109-1620408',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'15.77',NULL,NULL,NULL,NULL,NULL,NULL,1,77.754667,-16.34483,0.117,NULL,37401158626,584393103,9131142,15.77),(37634,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37634,37.69,0.73,345,10366,70,NULL,NULL,'2MASX J05110403-1317559',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,77.766833,-13.29889,0.393,NULL,37516465992,586194781,9159293,17),(37635,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37635,36.17,0.49,172,10367,70,NULL,NULL,'PKS 0508-133',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.24',NULL,NULL,NULL,NULL,NULL,NULL,1,77.7700416667,-13.29186,0.393,NULL,37516466146,586194783,9159293,16.24),(37636,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37636,36.27,0.74,179,10368,70,NULL,NULL,'2MASX J05110576-1108219',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.73',NULL,NULL,NULL,NULL,NULL,NULL,1,77.7737917,-11.13961,0.477,NULL,37480534140,585633345,9150521,16.73),(37637,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37637,33.87,0.2,59.4,10369,74.4,NULL,NULL,'ESO 553- G 016',NULL,'2013AJ....146...86T',2013,1,1.8,NULL,'G',0.00002,NULL,'15.27',0.5,'SB(s)m',NULL,NULL,NULL,NULL,1,77.7747083333,-18.42694,0.053,NULL,37422536936,584727139,9136361,15.27),(37638,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37638,34.06,0.53,64.8,10369,NULL,NULL,NULL,'ESO 553- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37639,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37639,34.19,0.5,68.8,10369,NULL,NULL,'Malmquist cor.','ESO 553- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37640,'IRAS','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37640,32.68,0.8,34.3,10370,75,NULL,'MAT, I','MCG -02-14-003',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.00001,NULL,'14.1b',0.5,'SB(s)c: sp',NULL,NULL,NULL,NULL,1,77.78225,-9.38881,0.309,NULL,36592827784,571762934,8933795,14.1),(37641,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37641,32.24,0.32,28,10370,85,NULL,'I, raw','MCG -02-14-003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37642,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37642,32.24,0.32,28.1,10370,85,NULL,'I, inv','MCG -02-14-003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37643,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37643,32.34,0.43,29.4,10370,75,NULL,'MAT, I, raw','MCG -02-14-003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37644,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37644,32.42,0.4,30.5,10370,NULL,NULL,NULL,'MCG -02-14-003',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37645,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37645,32.42,0.4,30.5,10370,73,NULL,'opt','MCG -02-14-003',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37646,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37646,32.44,0.43,30.7,10370,75,NULL,'MAT, I, inv','MCG -02-14-003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37647,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37647,32.46,0.2,31.1,10370,74.4,NULL,NULL,'MCG -02-14-003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37648,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37648,32.68,0.47,34.3,10370,NULL,NULL,NULL,'MCG -02-14-003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37649,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37649,32.75,0.43,35.4,10370,75,NULL,'MAT, I, cor','MCG -02-14-003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37650,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37650,32.79,0.39,36.1,10370,73,NULL,'opt','MCG -02-14-003',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37651,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37651,32.87,0.43,37.5,10370,NULL,NULL,'Malmquist cor.','MCG -02-14-003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37652,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37652,32.94,0.47,38.7,10370,NULL,NULL,'H','MCG -02-14-003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37653,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37653,32.97,0.4,39.3,10370,NULL,NULL,'mean','MCG -02-14-003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37654,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37654,32.99,0.46,39.6,10370,NULL,NULL,'J','MCG -02-14-003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37655,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37655,33.02,0.45,40.2,10370,NULL,NULL,'K','MCG -02-14-003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37656,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37656,36.23,0.7,176,10371,70,NULL,NULL,'2MASX J05110962-2948584',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.75',0.38,NULL,NULL,NULL,NULL,NULL,1,77.7900833333,-29.81628,0,NULL,37307779279,582934051,9108344,16.75),(37657,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37657,32.57,0.2,32.7,10372,74.4,NULL,NULL,'ESO 553- G 017',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.000183,NULL,'15.40',0.5,'S...',NULL,NULL,NULL,NULL,1,77.8000417,-19.61308,0.061,NULL,37425352394,584771131,9137048,15.4),(37658,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37658,32.79,0.43,36.2,10372,75,NULL,'3.6 micron, color corrected','ESO 553- G 017',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37659,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37659,32.85,0.39,37.1,10372,73,NULL,'opt','ESO 553- G 017',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37660,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37660,32.88,0.59,37.7,10372,NULL,NULL,NULL,'ESO 553- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37661,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37661,32.94,0.58,38.7,10372,NULL,NULL,'Malmquist cor.','ESO 553- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37662,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37662,33.05,0.43,40.7,10372,75,NULL,'3.6 micron, color + selection bias corrected','ESO 553- G 017',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37663,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37663,35.12,0.52,106,10373,70,NULL,NULL,'2MASX J05112634-1653210',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.27',NULL,NULL,NULL,NULL,NULL,NULL,1,77.859625,-16.88925,0.129,NULL,37401469096,584397954,9131218,16.27),(37664,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37664,36.54,0.64,203,10374,70,NULL,NULL,'2MASX J05112746-7235208',NULL,'2014MNRAS.445.2677S',2014,1,0.27,NULL,'G',0.00015,NULL,'16.8b',0.27,NULL,NULL,NULL,NULL,NULL,1,77.864583,-72.58903,0.381,NULL,35561799734,555653120,8682080,16.8),(37665,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37665,33.79,0.49,57.4,10375,70,NULL,NULL,'UGC 03264',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00007,NULL,'14.57',0.5,'S0/a',NULL,NULL,NULL,NULL,1,77.879917,-0.58608,0.461,NULL,36611693931,572057717,8938401,14.57),(37666,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37666,37.06,0.57,258,10376,70,NULL,NULL,'2MASX J05113169-2554196',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.000103,NULL,'16.41',0.4,NULL,NULL,NULL,NULL,NULL,1,77.8821666667,-25.90556,0,NULL,37249516702,582023698,9094120,16.41),(37667,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37667,33.56,0.47,51.6,10377,NULL,NULL,'H','ESO 553- G 020',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000023,NULL,'13.55',0.9,'(R\')SB(rs)ab pec:',NULL,NULL,NULL,NULL,1,77.909875,-20.42728,0.041,NULL,37423598199,584743721,9136620,13.55),(37668,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37668,33.57,0.45,51.7,10377,NULL,NULL,'K','ESO 553- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37669,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37669,33.64,0.46,53.4,10377,NULL,NULL,'J','ESO 553- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37670,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37670,33.78,0.4,56.9,10377,NULL,NULL,'mean','ESO 553- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37671,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37671,31.91,0.4,24.1,10378,75,NULL,'B','UGCA 104',NULL,'1988NBGC.C....0000T',1988,1,2.7,'Confused HIPASS source','G',0.000021,NULL,'13.01',2,'SAB(rs)cd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,77.9202917,-14.78936,0.309,NULL,37402730891,584417670,9131526,13.01),(37672,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37672,32.19,0.4,27.4,10378,NULL,NULL,NULL,'UGCA 104',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37673,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37673,32.19,0.4,27.4,10378,73,NULL,'opt','UGCA 104',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37674,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37674,32.32,0.4,29,10378,NULL,NULL,'mean','UGCA 104',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37675,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37675,33.07,0.47,41,10378,NULL,NULL,'H','UGCA 104',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37676,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37676,33.1,0.46,41.7,10378,NULL,NULL,'J','UGCA 104',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37677,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37677,33.19,0.45,43.5,10378,NULL,NULL,'K','UGCA 104',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37678,'FP','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37678,36.33,0.64,184,10379,70,NULL,NULL,'2MASX J05114295-2724446',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00015,NULL,'16.49',0.34,NULL,NULL,NULL,NULL,NULL,1,77.9290833333,-27.41244,0,NULL,37260437724,582194339,9096786,16.49),(37679,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37679,34.15,0.47,67.7,10380,NULL,NULL,'H','UGC 03252',NULL,'2007A&A...465...71T',2007,1,2.4,NULL,'G',0.000037,NULL,'13.6',2,'SAB(s)c',NULL,NULL,NULL,NULL,1,77.938375,67.48822,0.533,NULL,66382355381,1037224302,16206629,13.6),(37680,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37680,34.19,0.45,68.9,10380,NULL,NULL,'K','UGC 03252',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37681,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37681,34.23,0.46,70.2,10380,NULL,NULL,'J','UGC 03252',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37682,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37682,34.25,0.32,70.9,10380,NULL,NULL,'Malmquist cor.','UGC 03252',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37683,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37683,34.34,0.3,73.9,10380,NULL,NULL,NULL,'UGC 03252',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37684,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37684,34.38,0.2,75.2,10380,74.4,NULL,NULL,'UGC 03252',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37685,'Tully-Fisher','2016-12-15 15:14:05','2016-12-16 11:19:10','1',NULL,NULL,37685,34.45,0.4,77.8,10380,NULL,NULL,'mean','UGC 03252',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37686,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:10','1','SN 2005el',NULL,37686,33.29,0.21,44.8,10381,74.2,NULL,'SALT 2','NGC 1819',0.01491,'2010ApJ...716..712A',2010,1,1.7,NULL,'G',0.000017,NULL,'13.1B',1.2,'SB0            Sbrst','Group member, radial-velocity confirmed',NULL,NULL,'Starburst',1,77.94225,5.20061,0.617,NULL,64609249518,1009519523,15773742,13.1),(37687,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:10','1','SN 2005el',NULL,37687,33.79,0.16,55.6,10381,72,NULL,NULL,'NGC 1819',0.0149,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37688,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:10','1','SN 2005el',NULL,37688,33.8,0.08,56.7,10381,72,NULL,NULL,'NGC 1819',0.01491,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37689,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:10','1','SN 2005el',NULL,37689,33.87,0.04,58.6,10381,72,NULL,NULL,'NGC 1819',0.01491,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37690,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:10','1','SN 2005el',NULL,37690,33.9,0.03,59.4,10381,72,NULL,NULL,'NGC 1819',0.01491,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37691,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:10','1','SN 2005el',NULL,37691,33.88,0.01,59.7,10381,72,NULL,NULL,'NGC 1819',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37692,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:10','1','SN 2005el',NULL,37692,33.88,0.09,59.7,10381,74.4,NULL,NULL,'NGC 1819',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37693,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:10','1','SN 2005el',NULL,37693,33.92,0.05,59.9,10381,72,NULL,NULL,'NGC 1819',0.01491,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37694,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:10','1','SN 2005el',NULL,37694,33.97,0.19,61.2,10381,72,NULL,NULL,'NGC 1819',0.01491,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37695,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:10','1','SN 2005el',NULL,37695,33.96,0.04,62.1,10381,72,NULL,'M(H) = -18.317 mag','NGC 1819',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37696,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:10','1','SN 2005el',NULL,37696,34.03,0.04,62.9,10381,70,NULL,'SALT 2','NGC 1819',0.01491,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37697,'SNIa','2016-12-15 15:14:05','2016-12-16 11:19:10','1','SN 2005el',NULL,37697,34.08,0.29,64.4,10381,73.8,NULL,'SALT 2 (SNANA)','NGC 1819',0.0152,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37698,'SNIa','2016-12-15 15:14:06','2016-12-16 11:19:10','1','SN 2005el',NULL,37698,34.12,0.2,65.8,10381,70,NULL,'SALT 2','NGC 1819',0.01491,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37699,'SNIa','2016-12-15 15:14:06','2016-12-16 11:19:10','1','SN 2005el',NULL,37699,34.22,0.25,68.9,10381,73.8,NULL,'SALT 2 (SNANA)','NGC 1819',0.0152,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37700,'SNIa','2016-12-15 15:14:06','2016-12-16 11:19:10','1','SN 2005el',NULL,37700,34.23,0.25,69,10381,65,NULL,'SALT2','NGC 1819',0.01491,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37701,'SNIa','2016-12-15 15:14:06','2016-12-16 11:19:10','1','SN 2005el',NULL,37701,34.24,0.22,69.5,10381,65,NULL,'MLCS17','NGC 1819',0.01491,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37702,'SNIa','2016-12-15 15:14:06','2016-12-16 11:19:10','1','SN 2005el',NULL,37702,34.29,0.22,70.9,10381,65,NULL,'MLCS31','NGC 1819',0.01491,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37703,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37703,36.63,0.5,212,10382,70,NULL,NULL,'2MASX J05114647-1705419',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'15.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,77.9437083,-17.09494,0.129,NULL,37401489849,584398278,9131223,15.7),(37704,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37704,35.41,0.65,121,10383,70,NULL,NULL,'ESO 553- G 021',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15',0.6,'Sb      poss. LINER?',NULL,NULL,NULL,NULL,1,77.943875,-17.83639,0.113,NULL,37429989611,584843587,9138181,15),(37705,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37705,35.62,0.61,133,10384,70,NULL,NULL,'2MASX J05114824-2520236',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.000103,NULL,'16.91',0.33,NULL,NULL,NULL,NULL,NULL,1,77.951083,-25.33992,0,NULL,37249070051,582016719,9094011,16.91),(37706,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37706,35.88,0.5,150,10385,70,NULL,NULL,'2MASX J05115270-2708224',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.31',0.44,NULL,NULL,NULL,NULL,NULL,1,77.9695,-27.13958,0,NULL,37260760216,582199378,9096865,16.31),(37707,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37707,30.03,0.4,10.2,10386,75,NULL,'B','UGCA 106',NULL,'1988NBGC.C....0000T',1988,1,3.5,'Extended HIPASS source','G',0.000007,NULL,'12.87',3,'SAB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,77.997167,-32.97261,0,NULL,37278590961,582477983,9101218,12.87),(37708,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,'R',37708,34.28,0.49,71.9,10387,75,NULL,'IR','UGC 03254',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.000037,NULL,'16.0',0.7,'SB?',NULL,NULL,NULL,NULL,1,77.997417,66.74158,0.445,NULL,66382974640,1037233978,16206780,16),(37709,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37709,37.24,0.5,280,10388,NULL,NULL,'Malmquist cor.','2MASX J05120032-0907591',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000037,NULL,'14.5I',NULL,NULL,NULL,NULL,NULL,NULL,1,78.001375,-9.13314,0.289,NULL,36593193559,571768649,8933885,14.5),(37710,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37710,37.34,0.48,294,10388,NULL,NULL,NULL,'2MASX J05120032-0907591',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37711,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37711,37.38,0.2,299,10388,74.4,NULL,NULL,'2MASX J05120032-0907591',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37712,'Ring Diameter','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37712,32.7,0.76,34,10389,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 1832',NULL,'1981ApJS...45..541P',1981,1,2.6,'Confused HIPASS source','G',0.000017,NULL,'10.6B',1.7,'SB(r)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,78.013875,-15.68781,0.181,NULL,37403140696,584424073,9131626,10.6),(37713,'Ring Diameter','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37713,32.8,0.6,37,10389,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 1832',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37714,'IRAS','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37714,32.1,0.8,26.3,10389,75,NULL,'MAT, I','NGC 1832',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37715,'Sosies','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37715,30.76,0.41,14.2,10389,NULL,NULL,NULL,'NGC 1832',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37716,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,'R',37716,31.17,NULL,17.1,10389,NULL,NULL,'LEDA [April 2006]','NGC 1832',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37717,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37717,31.3,0.69,18.2,10389,100,NULL,'mid-IR','NGC 1832',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37718,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37718,31.54,0.46,20.4,10389,NULL,NULL,'J','NGC 1832',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37719,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37719,31.57,0.45,20.6,10389,NULL,NULL,'K','NGC 1832',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37720,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37720,31.58,0.47,20.7,10389,NULL,NULL,'H','NGC 1832',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37721,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37721,31.74,0.2,22.3,10389,74.4,NULL,NULL,'NGC 1832',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37722,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37722,31.85,0.4,23.5,10389,75,NULL,'B','NGC 1832',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37723,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37723,32,0.4,25.1,10389,NULL,NULL,NULL,'NGC 1832',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37724,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37724,32,0.39,25.1,10389,73,NULL,'opt','NGC 1832',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37725,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37725,32.02,0.4,25.3,10389,73,NULL,'opt','NGC 1832',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37726,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37726,32.1,0.51,26.3,10389,NULL,NULL,'Malmquist cor.','NGC 1832',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37727,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37727,32.13,0.5,26.7,10389,NULL,NULL,NULL,'NGC 1832',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37728,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37728,32.25,0.32,28.2,10389,85,NULL,'I, raw','NGC 1832',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37729,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37729,32.26,0.43,28.3,10389,75,NULL,'MAT, I, raw','NGC 1832',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37730,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37730,32.3,0.32,28.9,10389,85,NULL,'I, inv','NGC 1832',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37731,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37731,32.37,0.4,29.8,10389,NULL,NULL,'mean','NGC 1832',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37732,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37732,32.5,0.43,31.7,10389,75,NULL,'MAT, I, inv','NGC 1832',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37733,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37733,32.61,0.43,33.3,10389,75,NULL,'MAT, I, cor','NGC 1832',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37734,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37734,34.81,0.4,91.8,10390,NULL,NULL,'mean','UGC 03266',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.00003,NULL,'16.0',0.6,'S?',NULL,NULL,NULL,NULL,1,78.0137917,13.87317,1.561,NULL,65432323313,1022380051,15974688,16),(37735,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37735,34.98,0.47,99.2,10390,NULL,NULL,'H','UGC 03266',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37736,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37736,35.09,0.45,104,10390,NULL,NULL,'K','UGC 03266',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37737,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37737,35.12,0.46,106,10390,NULL,NULL,'J','UGC 03266',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37738,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37738,36.16,0.58,170,10391,70,NULL,NULL,'2MASX J05120806-2659564',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00012,NULL,'15.92',0.32,NULL,NULL,NULL,NULL,NULL,1,78.0335,-26.999,0,NULL,37260774626,582199603,9096868,15.92),(37739,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,'R',37739,35.87,0.49,149,10392,75,NULL,'IR','2MFGC 04249',NULL,'2011yCatp016004901K',2011,1,0.7,NULL,'G',0.00006,NULL,'12.6K',0.2,NULL,NULL,NULL,NULL,NULL,1,78.048833,6.08781,0.701,NULL,64601544796,1009399137,15771861,12.6),(37740,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37740,35.3,0.49,115,10393,70,NULL,NULL,'2MASX J05121328-1609570',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.12',0.4,NULL,NULL,NULL,NULL,NULL,1,78.055333,-16.16594,0.153,NULL,37404062539,584438477,9131851,16.12),(37741,'IRAS','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37741,31.44,0.8,19.4,10394,75,NULL,'MAT, I','NGC 1853',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000013,NULL,'13.56',0.7,'SAB(s)c','Pair member (points to parent)',NULL,NULL,NULL,1,78.0688333333,-57.39903,0,NULL,35967234754,561988043,8781063,13.56),(37742,'Tully est','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37742,30.96,0.8,15.6,10394,75,NULL,NULL,'NGC 1853',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37743,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37743,31.56,0.4,20.5,10394,73,NULL,'opt','NGC 1853',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37744,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37744,31.74,0.43,22.3,10394,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1853',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37745,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37745,31.86,0.4,23.6,10394,NULL,NULL,'mean','NGC 1853',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37746,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37746,31.92,0.43,24.2,10394,75,NULL,'3.6 micron, color corrected','NGC 1853',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37747,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37747,31.94,0.46,24.5,10394,NULL,NULL,'J','NGC 1853',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37748,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37748,31.99,0.47,25,10394,NULL,NULL,'H','NGC 1853',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37749,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37749,32.09,0.2,26.2,10394,74.4,NULL,NULL,'NGC 1853',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37750,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37750,32.13,0.45,26.6,10394,NULL,NULL,'K','NGC 1853',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37751,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37751,32.47,0.43,31.2,10394,75,NULL,'MAT, I, raw','NGC 1853',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37752,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37752,32.49,0.32,31.5,10394,85,NULL,'I, raw','NGC 1853',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37753,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37753,32.51,0.32,31.7,10394,85,NULL,'I, inv','NGC 1853',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37754,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37754,32.52,0.4,31.9,10394,NULL,NULL,NULL,'NGC 1853',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37755,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37755,32.54,0.43,32.2,10394,75,NULL,'MAT, I, inv','NGC 1853',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37756,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37756,32.71,0.43,34.8,10394,75,NULL,'MAT, I, cor','NGC 1853',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37757,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37757,34.93,0.53,96.7,10395,70,NULL,NULL,'2MASX J05122588-1004087',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,78.107875,-10.06906,0.365,NULL,36591400723,571740636,8933447,14.2),(37758,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37758,35.94,0.61,154,10396,70,NULL,NULL,'2MASX J05122887-0753567',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.73',0.4,NULL,NULL,NULL,NULL,NULL,1,78.12025,-7.89903,0.381,NULL,36597482269,571835660,8934932,15.73),(37759,'IRAS','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37759,34.09,0.8,65.7,10397,75,NULL,'MAT, I','ESO 305- G 014',NULL,'1997ApJS..109..333W',1997,1,1.3,'Marginal HIPASS detection.','G',0.000033,NULL,'14.10',0.7,'SB(s)c         HII',NULL,NULL,NULL,NULL,1,78.1422083333,-39.86033,0.105,NULL,37607446169,587616346,9181505,14.1),(37760,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37760,33.58,0.32,52,10397,85,NULL,'I, raw','ESO 305- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37761,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37761,33.6,0.32,52.6,10397,85,NULL,'I, inv','ESO 305- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37762,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37762,33.9,0.43,60.2,10397,75,NULL,'MAT, I, raw','ESO 305- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37763,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37763,34.04,0.43,64.4,10397,75,NULL,'MAT, I, inv','ESO 305- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37764,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37764,34.09,0.38,65.7,10397,NULL,NULL,NULL,'ESO 305- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37765,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37765,34.13,0.37,66.9,10397,NULL,NULL,'Malmquist cor.','ESO 305- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37766,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37766,34.13,0.2,67,10397,74.4,NULL,NULL,'ESO 305- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37767,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37767,34.13,0.43,67,10397,75,NULL,'MAT, I, cor','ESO 305- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37768,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37768,35.57,0.51,130,10398,70,NULL,NULL,'2MASX J05124440-2327127',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.000083,NULL,'16.16',0.43,NULL,NULL,NULL,NULL,NULL,1,78.184917,-23.45358,0.013,NULL,37416895895,584638998,9134984,16.16),(37769,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37769,35.44,0.48,122,10399,70,NULL,NULL,'CGCG 395-017',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00011,NULL,'15.5b',0.5,NULL,NULL,NULL,NULL,NULL,1,78.197125,-2.23028,0.577,NULL,36610169715,572033901,8938029,15.5),(37770,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37770,35.66,0.49,135,10400,70,NULL,NULL,'2MASX J05125022-2407556',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.000103,NULL,'15.74',0.35,NULL,NULL,NULL,NULL,NULL,1,78.209375,-24.13206,0.017,NULL,37128675583,580135555,9064618,15.74),(37771,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37771,35.39,0.57,120,10401,NULL,NULL,NULL,'ESO 305- G 015',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'14.51',0.4,'Sc',NULL,NULL,NULL,NULL,1,78.213083,-41.63397,0.013,NULL,37608344979,587630390,9181724,14.51),(37772,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37772,35.43,0.2,122,10401,74.4,NULL,NULL,'ESO 305- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37773,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37773,35.5,0.54,126,10401,NULL,NULL,'Malmquist cor.','ESO 305- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37774,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37774,35.56,0.49,130,10402,70,NULL,NULL,'2MASX J05125340-2326449',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'15.50',0.64,NULL,NULL,NULL,NULL,NULL,1,78.2225833333,-23.44578,0.013,NULL,37416910710,584639229,9134987,15.5),(37775,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37775,37.25,0.64,282,10403,70,NULL,NULL,'2MFGC 04259',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'12.2K',0.11,NULL,NULL,NULL,NULL,NULL,1,78.231625,-53.40369,0.333,NULL,35726870713,558232354,8722380,12.2),(37776,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37776,36.41,0.68,191,10404,70,NULL,NULL,'2MASX J05125705-6109576',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.9I',0.4,NULL,NULL,NULL,NULL,NULL,1,78.237625,-61.16594,0.029,NULL,35886812294,560731442,8761428,13.9),(37777,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37777,37.68,0.6,344,10405,70,NULL,NULL,'2MASX J05130213-5319573',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.8b',0.4,NULL,NULL,NULL,NULL,NULL,1,78.259,-53.33258,0.333,NULL,35726842853,558231919,8722373,15.8),(37778,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37778,35.62,0.56,133,10406,70,NULL,NULL,'2MASX J05130864-1938049',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,78.286083,-19.63467,0.057,NULL,37425748481,584777320,9137145,15.2),(37779,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37779,35.88,0.34,150,10407,NULL,NULL,'Malmquist cor.','ESO 486- G 036',NULL,'2009ApJS..182..474S',2009,1,0.97,NULL,'G',0.000033,NULL,'15.69',0.32,'Sb:            HII',NULL,NULL,NULL,NULL,1,78.3207916667,-24.93903,0.025,NULL,37128269517,580129211,9064518,15.69),(37780,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37780,35.98,0.32,157,10407,NULL,NULL,NULL,'ESO 486- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37781,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37781,36.02,0.2,160,10407,74.4,NULL,NULL,'ESO 486- G 036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37782,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37782,35.61,0.8,133,10408,70,NULL,NULL,'ESO 553- G 026',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000027,NULL,'15.10',0.5,'S?',NULL,NULL,NULL,NULL,1,78.326667,-22.22575,0.037,NULL,37415846949,584622608,9134728,15.1),(37783,'IRAS','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37783,35.36,0.8,118,10408,75,NULL,'MAT, I','ESO 553- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37784,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37784,34.94,0.43,97.4,10408,75,NULL,'MAT, I, raw','ESO 553- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37785,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37785,34.99,0.32,99.5,10408,85,NULL,'I, raw','ESO 553- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37786,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37786,35.04,0.32,102,10408,85,NULL,'I, inv','ESO 553- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37787,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37787,35.18,0.43,109,10408,75,NULL,'MAT, I, inv','ESO 553- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37788,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37788,35.36,0.43,118,10408,75,NULL,'MAT, I, cor','ESO 553- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37789,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37789,35.38,0.43,119,10408,NULL,NULL,NULL,'ESO 553- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37790,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37790,35.42,0.2,121,10408,74.4,NULL,NULL,'ESO 553- G 026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37791,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37791,35.53,0.4,128,10408,NULL,NULL,'Malmquist cor.','ESO 553- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37792,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37792,33.11,0.43,41.8,10409,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J05132510+2033254',NULL,'2014MNRAS.444..527S',2014,1,0.67,NULL,'G',0.000017,NULL,'11.0K',0.56,'S',NULL,NULL,NULL,NULL,1,78.354667,20.55708,2.353,NULL,65387871654,1021685494,15963835,11),(37793,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37793,35.44,0.49,122,10410,70,NULL,NULL,'ESO 553- G 027',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000093,NULL,'15.18',0.8,'S0',NULL,NULL,NULL,NULL,1,78.397125,-17.64869,0.117,NULL,37430821507,584856586,9138384,15.18),(37794,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37794,36.12,0.5,168,10411,70,NULL,NULL,'2MASX J05133903-2810073',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'16.05',0.42,NULL,NULL,NULL,NULL,NULL,1,78.41275,-28.16878,0,NULL,37258774787,582168356,9096380,16.05),(37795,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37795,35.7,0.57,138,10412,70,NULL,NULL,'2MASX J05133987-0738276',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.00013,NULL,'15.6b',0.8,'Sbc? pec',NULL,NULL,NULL,NULL,1,78.416083,-7.64103,0.449,NULL,36597821362,571840958,8935014,15.6),(37796,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37796,34.82,0.68,92.2,10413,70,NULL,NULL,'2MASX J05135555-0835006',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,78.481417,-8.5835,0.365,NULL,36717987758,573718558,8964352,17.7),(37797,'Tully est','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37797,32.56,0.8,32.5,10414,75,NULL,NULL,'NGC 1843',NULL,'1988NBGC.C....0000T',1988,1,2,NULL,'G',0.000017,NULL,'13.0b',1.6,'SAB(s)cd:',NULL,NULL,NULL,NULL,1,78.525083,-10.62703,0.445,NULL,36709160671,573580635,8962197,13),(37798,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37798,32.54,0.46,32.2,10414,NULL,NULL,'J','NGC 1843',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37799,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37799,32.56,0.47,32.5,10414,NULL,NULL,'H','NGC 1843',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37800,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37800,32.57,0.45,32.6,10414,NULL,NULL,'K','NGC 1843',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37801,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37801,32.93,0.4,38.5,10414,NULL,NULL,'mean','NGC 1843',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37802,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37802,35.46,0.55,123,10415,70,NULL,NULL,'2MASX J05140630-1710510',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.12',NULL,NULL,NULL,NULL,NULL,NULL,1,78.52625,-17.18094,0.121,NULL,37400959554,584389993,9131093,16.12),(37803,'IRAS','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37803,35.42,0.8,121,10416,75,NULL,'HMCL, I','UGC 03269',NULL,'1997ApJS..109..333W',1997,1,0.8,NULL,'G',0.000009,NULL,'14.91',0.6,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,78.528833,6.52072,0.473,NULL,64630623344,1009853489,15778960,14.91),(37804,'IRAS','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37804,35.42,0.8,121,10416,75,NULL,'W91CL, r','UGC 03269',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37805,'IRAS','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37805,35.43,0.8,122,10416,75,NULL,'CF, r','UGC 03269',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37806,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37806,34.71,0.38,87.6,10416,75,NULL,'W91CL, r, raw','UGC 03269',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37807,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37807,34.86,0.38,93.7,10416,75,NULL,'W91CL, r, inv','UGC 03269',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37808,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37808,34.92,0.4,96.5,10416,75,NULL,'HMCL, I, raw','UGC 03269',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37809,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37809,34.95,0.38,97.6,10416,75,NULL,'CF, r, raw','UGC 03269',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37810,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37810,35.11,0.38,105,10416,75,NULL,'CF, r, inv','UGC 03269',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37811,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37811,35.11,0.4,105,10416,75,NULL,'HMCL, I, inv','UGC 03269',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37812,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37812,35.13,0.38,106,10416,75,NULL,'W91CL, r, cor','UGC 03269',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37813,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37813,35.2,0.43,110,10416,NULL,NULL,'Malmquist cor.','UGC 03269',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37814,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37814,35.22,0.43,111,10416,NULL,NULL,NULL,'UGC 03269',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37815,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37815,35.26,0.2,113,10416,74.4,NULL,NULL,'UGC 03269',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37816,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37816,35.3,0.38,115,10416,75,NULL,'CF, r, cor','UGC 03269',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37817,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37817,35.31,0.4,115,10416,75,NULL,'HMCL, I, cor','UGC 03269',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37818,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37818,35.79,0.29,144,10417,NULL,NULL,NULL,'ESO 423- G 001',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.5',0.5,'Sb             HII',NULL,NULL,NULL,NULL,1,78.535083,-27.74706,0,NULL,37261502418,582210975,9097046,15.5),(37819,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37819,35.83,0.2,147,10417,74.4,NULL,NULL,'ESO 423- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37820,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37820,35.85,0.29,148,10417,NULL,NULL,'Malmquist cor.','ESO 423- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37821,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37821,36.26,0.62,179,10418,70,NULL,NULL,'2MASX J05140987-4802524',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'16.60',0.25,NULL,NULL,NULL,NULL,NULL,1,78.5411666667,-48.04792,0,NULL,37619002460,587796913,9184326,16.6),(37822,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37822,34.27,0.67,71.4,10419,70,NULL,NULL,'FGC 0526',NULL,'2014MNRAS.445.2677S',2014,1,1.48,'Star superposed.','G',0.00015,NULL,'15.8',0.16,'Sbc',NULL,NULL,NULL,NULL,1,78.542583,-6.148,0.557,NULL,36717039583,573703743,8964120,15.8),(37823,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37823,36.26,0.79,178,10420,70,NULL,NULL,'2MASX J05141395-1219551',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.62',0.3,NULL,NULL,NULL,NULL,NULL,1,78.558167,-12.332,0.273,NULL,37397376889,584334013,9130218,16.62),(37824,'Brightest Stars','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,'R',37824,27.53,NULL,3.2,10421,NULL,NULL,NULL,'UGCA 105',NULL,'2001ASPC..240..589H',2001,1,5.5,NULL,'G',0.000017,NULL,'13.9',3.5,'Im?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,78.563875,62.58,1.373,NULL,66155252414,1033675818,16151184,13.9),(37825,'Brightest Stars','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37825,27.54,NULL,3.22,10421,NULL,NULL,NULL,'UGCA 105',NULL,'1997A&AS..124..559K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37826,'Brightest Stars','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,'R',37826,27.55,NULL,3.24,10421,NULL,NULL,'3R','UGCA 105',NULL,'1992A&AT....1..269T',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37827,'Brightest Stars','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,'R',37827,27.71,NULL,3.48,10421,NULL,NULL,'3B','UGCA 105',NULL,'1992A&AT....1..269T',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37828,'TRGB','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37828,27.49,0.22,3.15,10421,NULL,NULL,NULL,'UGCA 105',NULL,'2002A&A...389..812K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37829,'TRGB','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37829,27.65,0.1,3.39,10421,74.4,NULL,NULL,'UGCA 105',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37830,'TRGB','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37830,27.71,0.33,3.48,10421,NULL,NULL,'I','UGCA 105',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37831,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37831,27.91,0.5,3.8,10421,NULL,NULL,'B','UGCA 105',NULL,'1995AJ....110.1584K',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37832,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37832,28.01,0.43,4,10421,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 105',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37833,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37833,28.26,0.4,4.5,10421,75,NULL,'B','UGCA 105',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37834,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37834,33.68,0.37,54.4,10422,NULL,NULL,NULL,'UGC 03259',NULL,'2009ApJS..182..474S',2009,1,1.8,NULL,'G',0.000037,NULL,'15.0',1.3,'SABd',NULL,NULL,NULL,NULL,1,78.5660833333,72.33411,0.469,NULL,65643925503,1025686335,16026348,15),(37835,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37835,33.72,0.2,55.5,10422,74.4,NULL,NULL,'UGC 03259',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37836,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37836,33.99,0.32,62.9,10422,NULL,NULL,'Malmquist cor.','UGC 03259',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37837,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37837,36.39,0.83,190,10423,70,NULL,NULL,'ESO 119- G 045',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'14.86',0.9,'SA(s)bc',NULL,NULL,NULL,NULL,1,78.590625,-60.79119,0.021,NULL,35887340310,560739692,8761557,14.86),(37838,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37838,34.12,0.47,66.7,10424,NULL,NULL,'H','ESO 119- G 046',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000033,NULL,'14.99',0.4,'Sb? pec sp     HII','Pair member (points to parent)',NULL,NULL,NULL,1,78.623333,-62.17067,0.009,NULL,35887867478,560747929,8761686,14.99),(37839,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37839,34.15,0.45,67.5,10424,NULL,NULL,'K','ESO 119- G 046',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37840,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37840,34.24,0.4,70.3,10424,NULL,NULL,'mean','ESO 119- G 046',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37841,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37841,34.29,0.46,72.2,10424,NULL,NULL,'J','ESO 119- G 046',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37842,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,'R',37842,34.64,0.49,84.6,10424,75,NULL,'IR','ESO 119- G 046',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37843,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37843,34.9,0.48,95.6,10424,NULL,NULL,'Malmquist cor.','ESO 119- G 046',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37844,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37844,35.12,0.43,106,10424,NULL,NULL,NULL,'ESO 119- G 046',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37845,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37845,35.16,0.2,108,10424,74.4,NULL,NULL,'ESO 119- G 046',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37846,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37846,35.94,0.55,154,10425,70,NULL,NULL,'2MASX J05143605-4527581',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.63',0.3,NULL,NULL,NULL,NULL,NULL,1,78.650125,-45.46611,0.025,NULL,37646296444,588223381,9190990,16.63),(37847,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37847,36.09,0.69,165,10426,70,NULL,NULL,'2MASX J05143642-2348264',NULL,'2014MNRAS.445.2677S',2014,1,0.32,NULL,'G',0.00015,NULL,'17.24',0.24,NULL,NULL,NULL,NULL,NULL,1,78.6518333333,-23.80731,0.017,NULL,37130349485,580161710,9065026,17.24),(37848,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37848,36.65,0.64,214,10427,70,NULL,NULL,'2MASX J05143882-2344334',NULL,'2014MNRAS.445.2677S',2014,1,0.69,NULL,'G',0.00015,NULL,'16.03',0.37,NULL,NULL,NULL,NULL,NULL,1,78.6617916667,-23.74264,0.057,NULL,37414768679,584605760,9134465,16.03),(37849,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37849,35.34,0.57,117,10428,70,NULL,NULL,'2MASX J05144274-1046344',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000077,NULL,'15.91',0.8,NULL,NULL,NULL,NULL,NULL,1,78.678,-10.77642,0.437,NULL,36709434005,573584906,8962264,15.91),(37850,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37850,35.56,0.4,129,10429,NULL,NULL,'mean','CGCG 421-007',NULL,'2007A&A...465...71T',2007,1,0.6,NULL,'G',0.000028,NULL,'15.5',0.2,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,78.722417,5.41281,0.541,NULL,64651252283,1010175816,15783997,15.5),(37851,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37851,35.69,0.34,137,10429,NULL,NULL,'Malmquist cor.','CGCG 421-007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37852,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37852,35.79,0.47,144,10429,NULL,NULL,'H','CGCG 421-007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37853,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37853,35.91,0.45,152,10429,NULL,NULL,'K','CGCG 421-007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37854,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37854,36.05,0.29,162,10429,NULL,NULL,NULL,'CGCG 421-007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37855,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37855,36.19,0.2,173,10429,74.4,NULL,NULL,'CGCG 421-007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37856,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37856,35.19,0.6,109,10430,70,NULL,NULL,'2MASX J05145348-0330076',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000093,NULL,'16.34',0.5,NULL,NULL,NULL,NULL,NULL,1,78.7227917,-3.50208,0.521,NULL,36748519625,574195619,8971806,16.34),(37857,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37857,32,0.43,25.2,10431,75,NULL,'3.6 micron, color + selection bias corrected','ESO 305- G 017',NULL,'2014MNRAS.444..527S',2014,1,1.8,'ESO-LV has two entries for this object.','G',0.00001,NULL,'14.57',0.7,'IB(s)m','Pair member (points to parent)',NULL,NULL,NULL,1,78.7525417,-41.39247,0.013,NULL,37608660733,587635323,9181801,14.57),(37858,'IRAS','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37858,33.77,0.8,56.7,10432,75,NULL,'MAT, I','ESO 159- G 002',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000023,NULL,'13.74',1.4,'(R\')SAB(rs)c','in a triple',NULL,NULL,NULL,1,78.776875,-53.73722,0.337,NULL,35723721087,558183141,8721611,13.74),(37859,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37859,33.59,0.32,52.2,10432,85,NULL,'I, raw','ESO 159- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37860,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37860,33.61,0.43,52.7,10432,75,NULL,'MAT, I, raw','ESO 159- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37861,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37861,33.63,0.32,53.2,10432,85,NULL,'I, inv','ESO 159- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37862,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37862,33.82,0.43,58,10432,75,NULL,'MAT, I, inv','ESO 159- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37863,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37863,33.88,0.43,59.6,10432,75,NULL,'MAT, I, cor','ESO 159- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37864,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,'R',37864,33.92,NULL,60.8,10432,NULL,NULL,'I','ESO 159- G 002',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37865,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,'R',37865,33.96,NULL,61.9,10432,NULL,NULL,'B','ESO 159- G 002',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37866,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37866,33.55,0.5,51.2,10433,70,NULL,NULL,'ESO 486- G 038',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000027,NULL,'14.59',1,'S0','in a pair',NULL,NULL,NULL,1,78.807625,-22.55028,0.021,NULL,37414551942,584602374,9134412,14.59),(37867,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37867,34.94,0.49,97.2,10434,70,NULL,NULL,'MCG -01-14-006',NULL,'2014MNRAS.445.2677S',2014,1,0.18,NULL,'G',0.00009,NULL,'15.5b',0.18,NULL,NULL,NULL,NULL,NULL,1,78.8107917,-4.40206,0.717,NULL,36749770231,574215159,8972111,15.5),(37868,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,'R',37868,35.34,0.49,117,10435,75,NULL,'IR','2MFGC 04284',NULL,'2011yCatp016004901K',2011,1,0.7,NULL,'G',0.000016,NULL,'13.2K',0.2,NULL,NULL,NULL,NULL,NULL,1,78.8150833333,5.03419,0.573,NULL,64651945873,1010186654,15784166,13.2),(37869,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37869,36,0.64,158,10436,70,NULL,NULL,'2MASX J05151581-2805035',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'16.58',0.25,NULL,NULL,NULL,NULL,NULL,1,78.815833,-28.08436,0,NULL,37258795466,582168679,9096385,16.58),(37870,'IRAS','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37870,31.6,0.8,20.9,10437,75,NULL,'MAT, I','UGCA 108',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.000017,NULL,'13.09',0.8,'SB(s)d: sp',NULL,NULL,NULL,NULL,1,78.818083,-30.52647,0,NULL,37307520004,582930000,9108281,13.09),(37871,'IRAS','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37871,31.62,0.8,21.1,10437,75,NULL,'A82, H','UGCA 108',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37872,'Tully est','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37872,31.18,0.8,17.2,10437,75,NULL,NULL,'UGCA 108',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37873,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,'R',37873,31.38,0.4,18.9,10437,75,NULL,NULL,'UGCA 108',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37874,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37874,31.38,0.4,18.9,10437,73,NULL,'IR','UGCA 108',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37875,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37875,31.45,0.32,19.5,10437,85,NULL,'I, raw','UGCA 108',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37876,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37876,31.45,0.32,19.5,10437,85,NULL,'I, inv','UGCA 108',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37877,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37877,31.49,0.38,19.9,10437,NULL,NULL,NULL,'UGCA 108',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37878,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37878,31.56,0.2,20.5,10437,74.4,NULL,NULL,'UGCA 108',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37879,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37879,31.58,0.43,20.7,10437,75,NULL,'3.6 micron, color corrected','UGCA 108',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37880,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37880,31.6,0.43,20.9,10437,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 108',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37881,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37881,31.62,0.47,21.1,10437,75,NULL,'A82, H, inv','UGCA 108',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37882,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37882,31.69,0.47,21.7,10437,75,NULL,'A82, H, raw','UGCA 108',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37883,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37883,31.73,0.43,22.2,10437,75,NULL,'MAT, I, raw','UGCA 108',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37884,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37884,31.79,0.43,22.8,10437,75,NULL,'MAT, I, inv','UGCA 108',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37885,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37885,31.86,0.47,23.5,10437,75,NULL,'A82, H, cor','UGCA 108',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37886,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37886,31.87,0.43,23.7,10437,75,NULL,'MAT, I, cor','UGCA 108',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37887,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,'R',37887,31.89,0.49,23.9,10437,75,NULL,'IR','UGCA 108',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37888,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37888,36.68,0.66,217,10438,70,NULL,NULL,'2MASX J05151768-4436372',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.75',0.37,'E',NULL,NULL,NULL,NULL,1,78.823625,-44.61039,0,NULL,37647850777,588247668,9191369,15.75),(37889,'IRAS','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37889,35.3,0.8,115,10439,75,NULL,'HMCL, I','UGC 03270',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000007,NULL,'15.30',0.4,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,78.8325,6.47358,0.489,NULL,64630902591,1009857852,15779028,15.3),(37890,'IRAS','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37890,35.31,0.8,115,10439,75,NULL,'W91CL, r','UGC 03270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37891,'IRAS','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37891,35.33,0.8,116,10439,75,NULL,'CF, r','UGC 03270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37892,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37892,35,0.38,100,10439,75,NULL,'CF, r, raw','UGC 03270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37893,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37893,35.11,0.38,105,10439,75,NULL,'CF, r, inv','UGC 03270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37894,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37894,35.11,0.38,105,10439,75,NULL,'W91CL, r, raw','UGC 03270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37895,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37895,35.24,0.38,112,10439,75,NULL,'W91CL, r, inv','UGC 03270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37896,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37896,35.33,0.38,117,10439,75,NULL,'CF, r, cor','UGC 03270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37897,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37897,35.34,0.4,117,10439,75,NULL,'HMCL, I, raw','UGC 03270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37898,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37898,35.39,0.38,120,10439,75,NULL,'W91CL, r, cor','UGC 03270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37899,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37899,35.51,0.36,126,10439,NULL,NULL,'Malmquist cor.','UGC 03270',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37900,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37900,35.51,0.4,127,10439,75,NULL,'HMCL, I, inv','UGC 03270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37901,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37901,35.56,0.4,129,10439,75,NULL,'HMCL, I, cor','UGC 03270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37902,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37902,35.62,0.2,133,10439,74.4,NULL,NULL,'UGC 03270',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37903,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37903,35.66,0.34,136,10439,NULL,NULL,NULL,'UGC 03270',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37904,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37904,34.46,0.47,77.8,10440,70,NULL,NULL,'2MASX J05153235-6200023',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00006,NULL,'15.1b',0.26,NULL,NULL,NULL,NULL,NULL,1,78.884833,-62.00072,0.033,NULL,35887850971,560747671,8761682,15.1),(37905,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37905,35.57,0.59,130,10441,70,NULL,NULL,'2MASX J05153273-4426218',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'15.85',0.4,'E',NULL,NULL,NULL,NULL,1,78.886375,-44.43942,0,NULL,37647872398,588248006,9191375,15.85),(37906,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37906,35.07,0.53,103,10442,70,NULL,NULL,'2MASX J05153414-0322071',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00009,NULL,'15.8b',0.6,NULL,NULL,NULL,NULL,NULL,1,78.8922917,-3.36861,0.713,NULL,36748651233,574197675,8971838,15.8),(37907,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37907,34.85,0.23,93.3,10443,74.4,NULL,NULL,'2MASX J05153583+0615543',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000033,NULL,'14.23',NULL,'S0','Group member',NULL,NULL,NULL,1,78.899375,6.26517,0.513,NULL,64630137583,1009845899,15778842,14.23),(37908,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37908,35.29,0.45,114,10443,NULL,NULL,'K','2MASX J05153583+0615543',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37909,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37909,35.53,0.4,127,10443,NULL,NULL,'mean','2MASX J05153583+0615543',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37910,'IRAS','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37910,35.41,0.8,121,10444,75,NULL,'HMCL, I','CGCG 421-011',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000009,NULL,'15.43',0.4,'Sc','Group member',NULL,NULL,NULL,1,78.9025417,7.19875,0.489,NULL,64633539790,1009899059,15779672,15.43),(37911,'IRAS','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37911,35.41,0.8,121,10444,75,NULL,'W91CL, r','CGCG 421-011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37912,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37912,34.97,0.38,98.8,10444,75,NULL,'W91CL, r, raw','CGCG 421-011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37913,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37913,35.06,0.4,103,10444,75,NULL,'HMCL, I, raw','CGCG 421-011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37914,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37914,35.11,0.38,105,10444,75,NULL,'W91CL, r, inv','CGCG 421-011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37915,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37915,35.14,0.46,107,10444,NULL,NULL,'Malmquist cor.','CGCG 421-011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37916,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37916,35.19,0.45,109,10444,NULL,NULL,NULL,'CGCG 421-011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37917,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37917,35.19,0.2,109,10444,74.4,NULL,NULL,'CGCG 421-011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37918,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37918,35.24,0.4,112,10444,75,NULL,'HMCL, I, inv','CGCG 421-011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37919,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37919,35.32,0.38,116,10444,75,NULL,'W91CL, r, cor','CGCG 421-011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37920,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37920,35.39,0.4,119,10444,75,NULL,'HMCL, I, cor','CGCG 421-011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37921,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37921,36.62,0.63,211,10445,70,NULL,NULL,'2MASX J05153927-5637028',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,78.913667,-56.61742,0.013,NULL,35925861502,561341585,8770962,14.5),(37922,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37922,37.1,0.64,263,10446,70,NULL,NULL,'2MASX J05154155-4819264',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.91',0.27,NULL,NULL,NULL,NULL,NULL,1,78.92325,-48.32392,0,NULL,37619176983,587799640,9184369,16.91),(37923,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37923,33.99,0.46,62.8,10447,NULL,NULL,'J','2MASX J05154347+1921467',NULL,'2007A&A...465...71T',2007,1,1.56,NULL,'G',0.000013,NULL,'14.05',0.56,'Sbc',NULL,NULL,NULL,NULL,1,78.9310417,19.363,1.869,NULL,65388705482,1021698523,15964039,14.05),(37924,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37924,34,0.45,63.2,10447,NULL,NULL,'K','2MASX J05154347+1921467',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37925,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37925,34.01,0.47,63.5,10447,NULL,NULL,'H','2MASX J05154347+1921467',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37926,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37926,34.29,0.4,72,10447,NULL,NULL,'mean','2MASX J05154347+1921467',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37927,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,'R',37927,36.33,0.49,185,10448,75,NULL,'IR','2MFGC 04291',NULL,'2011yCatp016004901K',2011,1,0.5,NULL,'G',0.000053,NULL,'16',0.2,'Sc','Group member',NULL,NULL,NULL,1,78.932625,5.75972,0.541,NULL,64684655250,1010697738,15792152,16),(37928,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37928,35.26,NULL,113,10449,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 421-013',NULL,'2010Ap&SS.325..163P',2010,1,1.12,NULL,'G',0.000007,NULL,'15.7',0.13,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,78.9482083,6.77814,0.489,NULL,64631055816,1009860247,15779066,15.7),(37929,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37929,35.27,NULL,113,10449,NULL,NULL,'Dipole + Quadrupole','CGCG 421-013',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37930,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37930,35.28,NULL,114,10449,NULL,NULL,'Dipole','CGCG 421-013',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37931,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37931,35.31,NULL,116,10449,NULL,NULL,NULL,'CGCG 421-013',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37932,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37932,35.42,0.43,121,10449,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 421-013',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37933,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,'R',37933,35.49,0.49,125,10449,75,NULL,'IR','CGCG 421-013',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37934,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37934,35.49,0.43,126,10449,75,NULL,'3.6 micron, color corrected','CGCG 421-013',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37935,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37935,35.56,0.4,130,10449,NULL,NULL,'Malmquist cor.','CGCG 421-013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37936,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37936,35.62,0.2,133,10449,74.4,NULL,NULL,'CGCG 421-013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37937,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37937,35.72,0.37,140,10449,NULL,NULL,NULL,'CGCG 421-013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37938,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37938,35.03,0.23,101,10450,74.4,NULL,NULL,'2MASX J05154777+0619223',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000028,NULL,'15.0',NULL,'S0','Group member',NULL,NULL,NULL,1,78.9490416667,6.32292,0.513,NULL,64630147831,1009846059,15778844,15),(37939,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37939,35.67,0.34,136,10451,NULL,NULL,NULL,'ESO 486- G 041',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'14.81',0.7,'SA(r)b pec     HII',NULL,NULL,NULL,NULL,1,78.952083,-23.47525,0.057,NULL,37414861064,584607204,9134487,14.81),(37940,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37940,35.7,0.33,138,10451,NULL,NULL,'Malmquist cor.','ESO 486- G 041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37941,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37941,35.71,0.2,139,10451,74.4,NULL,NULL,'ESO 486- G 041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37942,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37942,35.81,0.47,145,10451,NULL,NULL,'H','ESO 486- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37943,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37943,35.9,0.4,151,10451,NULL,NULL,'mean','ESO 486- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37944,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37944,35.94,0.45,154,10451,NULL,NULL,'K','ESO 486- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37945,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37945,36.03,0.46,161,10451,NULL,NULL,'J','ESO 486- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37946,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37946,34.75,0.47,88.9,10452,70,NULL,NULL,'AM 0513-224 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.85,NULL,'G',0.000083,NULL,'15.74',0.65,NULL,NULL,NULL,NULL,NULL,1,78.9711666667,-22.73983,0.025,NULL,37414756424,584605569,9134462,15.74),(37947,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37947,35.66,0.25,136,10453,74.4,NULL,NULL,'2MASX J05155990+0625193',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000117,NULL,'15.48',NULL,'S0','Group member',NULL,NULL,NULL,1,78.9996666667,6.42211,0.513,NULL,64630121148,1009845642,15778838,15.48),(37948,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37948,33.9,0.49,60.4,10454,70,NULL,NULL,'ESO 159- G 003',NULL,'2014MNRAS.445.2677S',2014,1,2.1,NULL,'G',0.000073,NULL,'14.01',1.3,'SB0^0^: pec','in a triple',NULL,NULL,NULL,1,79.037875,-54.10467,0.337,NULL,35722971048,558171422,8721428,14.01),(37949,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37949,36.4,0.54,191,10455,70,NULL,NULL,'2MASX J05160962-5053416',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'17.00',0.15,NULL,NULL,NULL,NULL,NULL,1,79.04025,-50.89494,0,NULL,35729847354,558278864,8723107,17),(37950,'AGN time lag','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37950,34.69,0.26,86.5,10456,NULL,NULL,NULL,'ARK 120',NULL,'2014ApJ...784L..11Y',2014,1,1.1,NULL,'G',0.000057,NULL,'15.3b',0.8,'Sb/pec         Sy1',NULL,NULL,NULL,'Sy 1.0',1,79.047583,-0.14983,0.401,NULL,36524052285,570688316,8917004,15.3),(37951,'AGN time lag','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37951,36.39,0.52,190,10456,44,NULL,NULL,'ARK 120',NULL,'2007MNRAS.380..669C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37952,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37952,35.97,0.64,156,10457,70,NULL,NULL,'2MASX J05161148-2035563',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.22',NULL,NULL,NULL,NULL,NULL,NULL,1,79.0477917,-20.59906,0.065,NULL,37424229743,584753589,9136774,16.22),(37953,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37953,35.4,0.25,120,10458,74.4,NULL,NULL,'CGCG 421-015',NULL,'2013AJ....146...86T',2013,1,0.17,NULL,'G',0.000022,NULL,'15.5',0.17,'S0','Group member',NULL,NULL,NULL,1,79.057167,6.44761,0.513,NULL,64630956132,1009858689,15779042,15.5),(37954,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37954,35.68,0.45,137,10459,NULL,NULL,'K','2MASX J05161708+0619093',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'G',0.00007,NULL,'14.29',NULL,'S0','Group member',NULL,NULL,NULL,1,79.071167,6.31928,0.513,NULL,64630107964,1009845436,15778834,14.29),(37955,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37955,35.72,0.4,139,10459,NULL,NULL,'mean','2MASX J05161708+0619093',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37956,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37956,35.81,0.54,145,10460,70,NULL,NULL,'2MASX J05162025-2314433',NULL,'2014MNRAS.445.2677S',2014,1,0.69,NULL,'G',0.00015,NULL,'16.08',0.36,NULL,NULL,NULL,NULL,NULL,1,79.0844166667,-23.24542,0.009,NULL,37415279260,584613738,9134589,16.08),(37957,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37957,36.03,0.56,161,10461,70,NULL,NULL,'2MASX J05162371-1709354',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.18',NULL,NULL,NULL,NULL,NULL,NULL,1,79.098875,-17.15978,0.169,NULL,37404301379,584442209,9131909,16.18),(37958,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37958,34.72,0.47,87.9,10462,NULL,NULL,'H','2MASX J05162445+1537544',NULL,'2007A&A...465...71T',2007,1,0.56,NULL,'G',0.000113,NULL,'14.80',0.33,'Sab',NULL,NULL,NULL,NULL,1,79.1019583333,15.63178,1.713,NULL,65411774484,1022058976,15969671,14.8),(37959,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37959,34.74,0.45,88.6,10462,NULL,NULL,'K','2MASX J05162445+1537544',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37960,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37960,34.76,0.4,89.5,10462,NULL,NULL,'mean','2MASX J05162445+1537544',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37961,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37961,34.96,0.46,98.2,10462,NULL,NULL,'J','2MASX J05162445+1537544',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37962,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37962,35.57,0.23,130,10463,74.4,NULL,NULL,'2MASX J05162533+0620303',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000036,NULL,'14.48',NULL,'E','Group member',NULL,NULL,NULL,1,79.105667,6.34183,0.513,NULL,64630106103,1009845407,15778834,14.48),(37963,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37963,35.08,0.23,104,10464,74.4,NULL,NULL,'CGCG 421-016',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000031,NULL,'15.6',NULL,'S0','Group member',NULL,NULL,NULL,1,79.120833,6.40236,0.513,NULL,64630110864,1009845482,15778835,15.6),(37964,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37964,36.61,0.63,210,10465,70,NULL,NULL,'2MASX J05163297-1547300',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.24',NULL,NULL,NULL,NULL,NULL,NULL,1,79.1372083,-15.79172,0.233,NULL,37403255603,584425868,9131654,16.24),(37965,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37965,34.56,0.23,81.7,10466,74.4,NULL,NULL,'MCG +01-14-013',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000044,NULL,'15.25',NULL,'S0','Group member',NULL,NULL,NULL,1,79.1404583333,6.50414,0.513,NULL,64630960480,1009858757,15779043,15.25),(37966,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37966,35.39,0.25,120,10466,74.4,NULL,NULL,'MCG +01-14-013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37967,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37967,35.29,0.4,114,10466,NULL,NULL,'mean','MCG +01-14-013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37968,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37968,35.49,0.4,125,10466,NULL,NULL,'mean','MCG +01-14-013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37969,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37969,35.62,0.45,133,10466,NULL,NULL,'K','MCG +01-14-013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37970,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37970,36.3,0.45,182,10466,NULL,NULL,'K','MCG +01-14-013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37971,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37971,35.28,0.25,114,10467,74.4,NULL,NULL,'2MASX J05163391+0626586',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000083,NULL,'15.75',NULL,'S0','Group member',NULL,NULL,NULL,1,79.141375,6.44958,0.513,NULL,64630949918,1009858592,15779040,15.75),(37972,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37972,35.01,0.23,100,10468,74.4,NULL,NULL,'MCG +01-14-014',NULL,'2013AJ....146...86T',2013,1,0.15,'Ostriker, et al. (1988, AJ, 96, 1775) give v = 7041 +/- 66.','G',0.000025,NULL,'16',0.15,'S0','Group member',NULL,NULL,NULL,1,79.151583,6.48858,0.513,NULL,64630961933,1009858780,15779043,16),(37973,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37973,35.25,0.25,112,10469,74.4,NULL,NULL,'UGC 03274 NED01',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000117,NULL,'16',NULL,'E','Group member',NULL,NULL,NULL,1,79.1523333333,6.43758,0.513,NULL,64630097775,1009845277,15778832,16),(37974,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37974,35.32,0.25,116,10470,74.4,NULL,NULL,'UGC 03274',NULL,'2013AJ....146...86T',2013,1,NULL,'Contains the GPair Z0514.0+0623','GGroup',0.000197,NULL,NULL,NULL,'S?','Group member',NULL,NULL,NULL,1,79.15375,6.44167,0.513,NULL,64630097736,1009845277,15778832,NULL),(37975,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37975,35.48,0.25,125,10471,74.4,NULL,NULL,'UGC 03274 NED02',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000031,NULL,'15',NULL,'E','Group member',NULL,NULL,NULL,1,79.1542083,6.45178,0.513,NULL,64630950792,1009858606,15779040,15),(37976,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37976,35.28,0.25,114,10472,74.4,NULL,NULL,'UGC 03274 NED03',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000036,NULL,'14.0',NULL,'E;BrClG','Group member',NULL,NULL,NULL,1,79.15475,6.44803,0.513,NULL,64630950784,1009858606,15779040,14),(37977,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37977,33.47,0.45,49.4,10472,NULL,NULL,'K','UGC 03274 NED03',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37978,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37978,35.49,0.4,125,10472,NULL,NULL,'mean','UGC 03274 NED03',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37979,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37979,34.94,0.25,97.3,10473,74.4,NULL,NULL,'MCG +01-14-018',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.00011,NULL,'16',0.3,'S0','Group member',NULL,NULL,NULL,1,79.161417,6.51131,0.513,NULL,64630964178,1009858815,15779043,16),(37980,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37980,35.24,0.23,112,10474,74.4,NULL,NULL,'MCG +01-14-018',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.00011,NULL,'16',0.3,'S0','Group member',NULL,NULL,NULL,1,79.161417,6.51131,0.513,NULL,64630964178,1009858815,15779043,16),(37981,'IRAS','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37981,31.42,0.8,19.3,10475,75,NULL,'MAT, I','ESO 362- G 011',NULL,'1997ApJS..109..333W',1997,1,4.5,NULL,'G',0.00001,NULL,'13.04',0.7,'Sbc: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,79.161667,-37.10253,0.093,NULL,37093020637,579578447,9055913,13.04),(37982,'Tully est','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37982,30.93,0.8,15.4,10475,75,NULL,NULL,'ESO 362- G 011',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37983,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37983,30.8,0.4,14.5,10475,NULL,NULL,NULL,'ESO 362- G 011',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37984,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37984,30.81,0.4,14.5,10475,73,NULL,'opt','ESO 362- G 011',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37985,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37985,30.98,0.32,15.7,10475,85,NULL,'I, raw','ESO 362- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37986,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37986,30.99,0.32,15.8,10475,85,NULL,'I, inv','ESO 362- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37987,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37987,31.1,0.43,16.6,10475,75,NULL,'MAT, I, raw','ESO 362- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37988,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37988,31.22,0.43,17.5,10475,75,NULL,'3.6 micron, color corrected','ESO 362- G 011',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37989,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37989,31.24,0.43,17.7,10475,75,NULL,'MAT, I, inv','ESO 362- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37990,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37990,31.25,0.43,17.8,10475,75,NULL,'3.6 micron, color + selection bias corrected','ESO 362- G 011',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37991,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37991,31.3,0.43,18.2,10475,75,NULL,'MAT, I, cor','ESO 362- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37992,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37992,31.35,0.2,18.6,10475,74.4,NULL,NULL,'ESO 362- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37993,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37993,31.57,0.4,20.6,10475,NULL,NULL,'mean','ESO 362- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37994,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37994,31.59,0.4,20.8,10475,73,NULL,'opt','ESO 362- G 011',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37995,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37995,31.68,0.6,21.7,10475,NULL,NULL,'Malmquist cor.','ESO 362- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37996,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37996,31.85,0.56,23.5,10475,NULL,NULL,NULL,'ESO 362- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37997,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,'R',37997,31.95,0.49,24.5,10475,75,NULL,'IR','ESO 362- G 011',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37998,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37998,31.96,0.47,24.7,10475,NULL,NULL,'H','ESO 362- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37999,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,37999,31.97,0.46,24.7,10475,NULL,NULL,'J','ESO 362- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38000,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38000,32.05,0.45,25.7,10475,NULL,NULL,'K','ESO 362- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38001,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38001,35.07,0.23,103,10476,74.4,NULL,NULL,'2MASX J05163888+0627516',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000022,NULL,'15.03',NULL,'S0','Group member',NULL,NULL,NULL,1,79.162083,6.46433,0.513,NULL,64630950892,1009858607,15779040,15.03),(38002,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38002,35.99,0.23,158,10477,74.4,NULL,NULL,'2MASX J05164451+0632086',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000117,NULL,'15.71',NULL,'S0','Group member',NULL,NULL,NULL,1,79.1855417,6.53575,0.513,NULL,64630962579,1009858790,15779043,15.71),(38003,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,'R',38003,35.12,0.49,106,10478,75,NULL,'IR','2MFGC 04309',NULL,'2011yCatp016004901K',2011,1,0.6,NULL,'G',0.000013,NULL,'11.3K',0.1,'S',NULL,NULL,NULL,NULL,1,79.1880417,20.87019,NULL,NULL,65393960618,1021780634,15965322,11.3),(38004,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38004,35.26,0.23,113,10479,74.4,NULL,NULL,'2MASX J05164579+0622426',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000117,NULL,'15.41',NULL,'S0','Group member',NULL,NULL,NULL,1,79.190875,6.3785,0.513,NULL,64684690512,1010698289,15792160,15.41),(38005,'IRAS','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38005,35.06,0.8,103,10480,75,NULL,'HMCL, I','UGC 03275',NULL,'1997ApJS..109..333W',1997,1,2.02,NULL,'G',0.00001,NULL,'16.0',0.28,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,79.192417,6.62269,0.489,NULL,64631005254,1009859457,15779054,16),(38006,'IRAS','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38006,35.06,0.8,103,10480,75,NULL,'W91CL, r','UGC 03275',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38007,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38007,34.91,NULL,95.7,10480,NULL,NULL,'Dipole','UGC 03275',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38008,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38008,34.91,NULL,95.9,10480,NULL,NULL,'Dipole + Quadrupole','UGC 03275',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38009,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38009,34.92,NULL,96.2,10480,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03275',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38010,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38010,35.02,0.47,101,10480,NULL,NULL,'Malmquist cor.','UGC 03275',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38011,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,'R',38011,35.06,0.49,103,10480,75,NULL,'IR','UGC 03275',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38012,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38012,35.08,0.46,104,10480,NULL,NULL,NULL,'UGC 03275',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38013,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38013,35.1,NULL,105,10480,NULL,NULL,NULL,'UGC 03275',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38014,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38014,35.27,0.2,113,10480,74.4,NULL,NULL,'UGC 03275',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38015,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38015,35.4,0.4,120,10480,NULL,NULL,'mean','UGC 03275',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38016,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38016,35.45,0.4,123,10480,75,NULL,'HMCL, I, raw','UGC 03275',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38017,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38017,35.55,0.43,129,10480,75,NULL,'3.6 micron, color corrected','UGC 03275',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38018,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38018,35.61,0.47,133,10480,NULL,NULL,'H','UGC 03275',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38019,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38019,35.63,0.4,134,10480,75,NULL,'HMCL, I, cor','UGC 03275',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38020,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38020,35.66,0.38,136,10480,75,NULL,'W91CL, r, raw','UGC 03275',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38021,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38021,35.7,0.4,138,10480,75,NULL,'HMCL, I, inv','UGC 03275',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38022,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38022,35.81,0.38,145,10480,75,NULL,'W91CL, r, cor','UGC 03275',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38023,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38023,35.85,0.43,148,10480,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03275',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38024,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38024,35.89,0.38,150,10480,75,NULL,'W91CL, r, inv','UGC 03275',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38025,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38025,35.2,0.23,110,10481,74.4,NULL,NULL,'2MASX J05164954+0623186',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000044,NULL,'14.98',NULL,'S0','Group member',NULL,NULL,NULL,1,79.206375,6.38858,0.513,NULL,64684690867,1010698294,15792160,14.98),(38026,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38026,35.21,0.23,110,10482,74.4,NULL,NULL,'2MASX J05165061+0622466',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.00011,NULL,'15.25',NULL,'S0','Group member',NULL,NULL,NULL,1,79.210833,6.37956,0.513,NULL,64684689746,1010698277,15792160,15.25),(38027,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38027,35.15,0.25,107,10483,74.4,NULL,NULL,'2MASX J05165478+0637126',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.0001,NULL,'15.86',NULL,'E','Group member',NULL,NULL,NULL,1,79.22825,6.62025,0.489,NULL,64630431921,1009850498,15778914,15.86),(38028,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38028,35.49,0.23,125,10484,74.4,NULL,NULL,'CGCG 421-019',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000028,NULL,'15.6',0.3,'E','Group member',NULL,NULL,NULL,1,79.229167,6.55261,0.513,NULL,64630432872,1009850513,15778914,15.6),(38029,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38029,35.66,0.4,135,10484,NULL,NULL,'mean','CGCG 421-019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38030,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38030,35.68,0.45,137,10484,NULL,NULL,'K','CGCG 421-019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38031,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38031,35.77,0.25,143,10485,74.4,NULL,NULL,'2MASX J05170733+0629365',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000117,NULL,'14.93',NULL,'S0','Group member',NULL,NULL,NULL,1,79.280333,6.49353,0.513,NULL,64685148527,1010705445,15792272,14.93),(38032,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38032,34.16,0.5,67.8,10486,70,NULL,NULL,'ESO 159- G 004',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'14.47',0.8,'(R)SAB(r)0^+','in a triple',NULL,NULL,NULL,1,79.2829583,-54.06703,0.337,NULL,35723016188,558172127,8721439,14.47),(38033,'IRAS','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38033,31.25,0.8,17.8,10487,75,NULL,'MAT, I','NGC 1892',NULL,'1997ApJS..109..333W',1997,1,2.9,'Extended HIPASS source','G',0.000007,NULL,'12.83',0.8,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,79.2877083,-64.95975,0.117,NULL,35892233044,560816141,8762752,12.83),(38034,'IRAS','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38034,31.29,0.8,18.1,10487,75,NULL,'A82, H','NGC 1892',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38035,'Tully est','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38035,30.93,0.8,15.4,10487,75,NULL,NULL,'NGC 1892',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38036,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,'R',38036,30.34,0.4,11.7,10487,75,NULL,NULL,'NGC 1892',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38037,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38037,30.34,0.39,11.7,10487,73,NULL,'IR','NGC 1892',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38038,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38038,30.52,0.4,12.7,10487,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 1892',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38039,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38039,30.65,0.32,13.5,10487,85,NULL,'I, inv','NGC 1892',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38040,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38040,30.67,0.32,13.6,10487,85,NULL,'I, raw','NGC 1892',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38041,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38041,30.79,0.43,14.4,10487,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1892',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38042,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38042,30.82,0.38,14.6,10487,NULL,NULL,NULL,'NGC 1892',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38043,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38043,30.84,0.39,14.7,10487,73,NULL,'opt','NGC 1892',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38044,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38044,30.85,0.43,14.8,10487,75,NULL,'3.6 micron, color corrected','NGC 1892',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38045,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38045,30.87,0.2,14.9,10487,74.4,NULL,NULL,'NGC 1892',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38046,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38046,30.89,0.47,15.1,10487,75,NULL,'A82, H, inv','NGC 1892',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38047,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38047,30.97,0.4,15.6,10487,NULL,NULL,'Malmquist cor.','NGC 1892',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38048,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38048,30.97,0.47,15.6,10487,75,NULL,'A82, H, raw','NGC 1892',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38049,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,'R',38049,31.08,0.49,16.4,10487,75,NULL,'IR','NGC 1892',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38050,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38050,31.11,0.38,16.7,10487,NULL,NULL,NULL,'NGC 1892',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38051,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38051,31.14,0.43,16.9,10487,75,NULL,'MAT, I, raw','NGC 1892',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38052,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38052,31.18,0.43,17.2,10487,75,NULL,'MAT, I, inv','NGC 1892',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38053,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38053,31.2,0.47,17.4,10487,75,NULL,'A82, H, cor','NGC 1892',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38054,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38054,31.3,0.46,18.2,10487,NULL,NULL,'J','NGC 1892',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38055,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38055,31.31,0.43,18.3,10487,75,NULL,'MAT, I, cor','NGC 1892',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38056,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38056,31.36,0.4,18.7,10487,NULL,NULL,'mean','NGC 1892',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38057,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38057,31.39,0.47,18.9,10487,NULL,NULL,'H','NGC 1892',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38058,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38058,31.52,0.45,20.1,10487,NULL,NULL,'K','NGC 1892',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38059,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,'R',38059,35.08,0.49,104,10488,75,NULL,'IR','UGC 03279',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.00001,NULL,'15.16',0.2,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,79.290875,6.92742,0.621,NULL,64630389201,1009849831,15778903,15.16),(38060,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38060,35.32,0.47,116,10488,NULL,NULL,'H','UGC 03279',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38061,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38061,35.41,0.34,121,10488,NULL,NULL,'Malmquist cor.','UGC 03279',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38062,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38062,35.43,0.45,122,10488,NULL,NULL,'K','UGC 03279',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38063,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38063,35.45,0.4,123,10488,NULL,NULL,'mean','UGC 03279',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38064,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38064,35.48,0.46,124,10488,NULL,NULL,'J','UGC 03279',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38065,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38065,35.57,0.2,130,10488,74.4,NULL,NULL,'UGC 03279',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38066,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38066,35.68,0.3,137,10488,NULL,NULL,NULL,'UGC 03279',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38067,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38067,34.81,0.25,91.6,10489,74.4,NULL,NULL,'CGCG 421-021',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000022,NULL,'15.7',NULL,'S0','Group member',NULL,NULL,NULL,1,79.324583,6.13706,0.509,NULL,64685541915,1010711592,15792368,15.7),(38068,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38068,35.83,0.55,147,10490,70,NULL,NULL,'2MASX J05172613-6236346',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4b',NULL,'(R\')SB(s)a:',NULL,NULL,NULL,NULL,1,79.359083,-62.60958,0.049,NULL,35901877533,560966836,8765106,15.4),(38069,'SNIa','2016-12-15 15:14:06','2016-12-16 11:19:10','1','SN 2006is',NULL,38069,35.47,0.1,124,10491,74.4,NULL,NULL,'ESO 486- G 049',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000033,NULL,'14.63',0.4,'S?','in a pair',NULL,NULL,NULL,1,79.360333,-23.74503,0.009,NULL,37130143432,580158491,9064976,14.63),(38070,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38070,36.45,0.56,195,10492,70,NULL,NULL,'ESO 252- G 016',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'15.69',0.4,'S0',NULL,NULL,NULL,NULL,1,79.3672083,-46.21336,0.057,NULL,37638840159,588106877,9189169,15.69),(38071,'SNIa','2016-12-15 15:14:06','2016-12-16 11:19:10','1','SN 2006is',NULL,38071,34.89,0.17,92.2,10493,74.2,NULL,'SALT 2','APMUKS(BJ) B051529.79-235009.8',0.0314,'2010ApJ...716..712A',2010,1,0.17,NULL,'G',NULL,NULL,'19.44',0.11,NULL,NULL,NULL,NULL,NULL,1,79.3940417,-23.78356,0.009,NULL,37131002942,580171920,9065186,19.44),(38072,'SNIa','2016-12-15 15:14:06','2016-12-16 11:19:10','1','SN 2006is',NULL,38072,35.31,0.1,108,10493,72,NULL,NULL,'APMUKS(BJ) B051529.79-235009.8',0.0314,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38073,'SNIa','2016-12-15 15:14:06','2016-12-16 11:19:10','1','SN 2006is',NULL,38073,35.33,0.22,117,10493,72,NULL,'M(H) = -18.317 mag','APMUKS(BJ) B051529.79-235009.8',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38074,'SNIa','2016-12-15 15:14:06','2016-12-16 11:19:10','1','SN 2006is',NULL,38074,35.65,0.04,132,10493,72,NULL,'MLCS31','APMUKS(BJ) B051529.79-235009.8',NULL,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38075,'SNIa','2016-12-15 15:14:06','2016-12-16 11:19:10','1','SN 2006is',NULL,38075,35.93,0.15,154,10493,65,NULL,'MLCS31','APMUKS(BJ) B051529.79-235009.8',NULL,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38076,'D-Sigma','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38076,35.25,0.15,112,10494,NULL,NULL,'ABELL 0539, 25 galaxies','UGC 03282',NULL,'2000ApJ...529..768K',2000,1,1,'2MASS position is on southern extension.','G',0.000008,NULL,'14.51',0.7,'Sbc','Group member',NULL,NULL,NULL,1,79.406625,6.79931,0.621,NULL,64630444168,1009850690,15778917,14.51),(38077,'D-Sigma','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38077,35.26,0.12,113,10494,72,NULL,'ABELL 0539, 14 galaxies','UGC 03282',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38078,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38078,35.04,0.15,102,10494,NULL,NULL,'ABELL 0539, 25 galaxies','UGC 03282',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38079,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38079,35.15,0.16,107,10494,NULL,NULL,'ABELL 0539, 25 galaxies','UGC 03282',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38080,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38080,35.24,0.09,112,10494,75,NULL,'ABELL 0539, 22 galaxies','UGC 03282',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38081,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38081,35.24,0.09,112,10494,75,NULL,'ABELL 0539 Cluster, 22 galaxies','UGC 03282',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38082,'IRAS','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38082,35.15,0.8,107,10494,75,NULL,'HMCL, I','UGC 03282',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38083,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38083,34.49,0.2,79.1,10494,74.4,NULL,NULL,'UGC 03282',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38084,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38084,34.9,0.4,95.5,10494,75,NULL,'HMCL, I, raw','UGC 03282',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38085,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38085,35.1,0.4,105,10494,75,NULL,'HMCL, I, inv','UGC 03282',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38086,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38086,35.29,0.4,114,10494,75,NULL,'HMCL, I, cor','UGC 03282',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38087,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38087,35.42,0.15,121,10494,70,NULL,'ABELL 0539 Cluster','UGC 03282',NULL,'1992ApJ...396..453H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38088,'IRAS','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38088,32.85,0.8,37.2,10495,75,NULL,'MAT, I','IC 0407',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000017,NULL,'14',0.3,'Sc:',NULL,NULL,NULL,NULL,1,79.4275417,-15.52344,0.229,NULL,37412555334,584571177,9133924,14),(38089,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38089,32.55,0.4,32.4,10495,73,NULL,'opt','IC 0407',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38090,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,'R',38090,32.56,0.4,32.5,10495,75,NULL,NULL,'IC 0407',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38091,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38091,32.56,0.4,32.5,10495,73,NULL,'IR','IC 0407',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38092,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38092,33.02,0.46,40.2,10495,NULL,NULL,'J','IC 0407',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38093,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38093,33.07,0.4,41.2,10495,NULL,NULL,'mean','IC 0407',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38094,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38094,33.09,0.47,41.4,10495,NULL,NULL,'H','IC 0407',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38095,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,'R',38095,33.13,0.49,42.3,10495,75,NULL,'IR','IC 0407',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38096,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38096,33.18,0.45,43.3,10495,NULL,NULL,'K','IC 0407',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38097,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38097,33.19,0.43,43.4,10495,75,NULL,'MAT, I, raw','IC 0407',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38098,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38098,33.19,0.32,43.5,10495,85,NULL,'I, raw','IC 0407',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38099,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38099,33.2,0.43,43.7,10495,75,NULL,'3.6 micron, color corrected','IC 0407',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38100,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38100,33.22,0.4,44,10495,73,NULL,'opt','IC 0407',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38101,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38101,33.23,0.43,44.2,10495,75,NULL,'3.6 micron, color + selection bias corrected','IC 0407',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38102,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38102,33.24,0.32,44.4,10495,85,NULL,'I, inv','IC 0407',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38103,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38103,33.24,0.2,44.5,10495,74.4,NULL,NULL,'IC 0407',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38104,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38104,33.38,0.43,47.4,10495,75,NULL,'MAT, I, cor','IC 0407',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38105,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38105,33.39,0.43,47.7,10495,75,NULL,'MAT, I, inv','IC 0407',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38106,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38106,33.43,0.47,48.5,10495,NULL,NULL,NULL,'IC 0407',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38107,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38107,33.54,0.45,51,10495,NULL,NULL,'Malmquist cor.','IC 0407',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38108,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38108,30.29,0.4,11.4,10496,75,NULL,'B','UGC 03273',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.00002,NULL,'14.8',0.9,'Sm',NULL,NULL,NULL,NULL,1,79.435,53.55128,NULL,NULL,66077831890,1032466123,16132283,14.8),(38109,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38109,30.96,0.4,15.6,10496,NULL,NULL,NULL,'UGC 03273',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38110,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38110,30.97,0.39,15.6,10496,73,NULL,'opt','UGC 03273',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38111,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,'R',38111,33.91,0.49,60.5,10497,75,NULL,'IR','UGC 03283',NULL,'2011yCatp016004901K',2011,1,1.62,NULL,'G',0.000023,NULL,'16.5',0.12,'Scd            HII',NULL,NULL,NULL,NULL,1,79.440875,-1.18686,0.689,NULL,36742798322,574106223,8970409,16.5),(38112,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38112,34.08,0.43,65.5,10497,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03283',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38113,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38113,34.18,0.45,68.5,10497,NULL,NULL,'Malmquist cor.','UGC 03283',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38114,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38114,34.32,0.43,73,10497,75,NULL,'3.6 micron, color corrected','UGC 03283',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38115,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38115,34.39,0.2,75.5,10497,74.4,NULL,NULL,'UGC 03283',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38116,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38116,34.42,0.41,76.4,10497,NULL,NULL,NULL,'UGC 03283',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38117,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38117,34.6,NULL,83.2,10497,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03283',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38118,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38118,34.61,NULL,83.6,10497,NULL,NULL,'Dipole + Quadrupole','UGC 03283',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38119,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38119,34.61,NULL,83.7,10497,NULL,NULL,'Dipole','UGC 03283',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38120,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,'R',38120,33.01,0.49,40.1,10498,75,NULL,'IR','2MFGC 04333',NULL,'2011yCatp016004901K',2011,1,1.12,NULL,'G',0.000033,NULL,'9.8K',0.56,'S',NULL,NULL,NULL,NULL,1,79.4477917,58.23958,1.769,NULL,66276054384,1035563349,16180677,9.8),(38121,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38121,33.82,0.2,58.1,10499,74.4,NULL,NULL,'ESO 423- G 004',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.00015,NULL,'15',0.2,'Sc',NULL,NULL,NULL,NULL,1,79.491,-29.70039,0,NULL,37308433324,582944270,9108504,15),(38122,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,'R',38122,33.9,0.49,60.1,10499,75,NULL,'IR','ESO 423- G 004',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38123,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38123,34.02,0.42,63.8,10499,NULL,NULL,NULL,'ESO 423- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38124,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38124,34.03,0.42,64,10499,NULL,NULL,'Malmquist cor.','ESO 423- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38125,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38125,35.69,0.49,138,10500,70,NULL,NULL,'6dF J0517599-335444',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,79.4996666667,-33.91219,0,NULL,37269781475,582340335,9099067,14),(38126,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38126,36.35,0.59,186,10501,70,NULL,NULL,'2MASX J05181367-7234500',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'15.3b',0.39,NULL,NULL,NULL,NULL,NULL,1,79.5567916667,-72.58056,0.317,NULL,35505874455,554779288,8668426,15.3),(38127,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38127,35.21,0.5,110,10502,70,NULL,NULL,'2MASX J05181570-2455168',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.21',0.48,NULL,NULL,NULL,NULL,NULL,1,79.5654583,-24.92136,0.017,NULL,37131345539,580177274,9065269,16.21),(38128,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38128,36.76,0.54,225,10503,70,NULL,NULL,'2MASX J05181655-1532465',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,79.5690417,-15.54633,0.229,NULL,37412586076,584571657,9133932,16.9),(38129,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38129,35.95,0.72,155,10504,70,NULL,NULL,'ESO 553- G 031',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.66',0.5,'Sa',NULL,NULL,NULL,NULL,1,79.577917,-21.32769,0.081,NULL,37426564437,584790069,9137344,15.66),(38130,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38130,36.62,0.54,211,10505,70,NULL,NULL,'2MASX J05182587-1731344',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.27',0.3,NULL,NULL,NULL,NULL,NULL,1,79.607875,-17.52639,0.173,NULL,37432476037,584882438,9138788,16.27),(38131,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,'R',38131,35.66,0.49,135,10506,75,NULL,'IR','2MFGC 04349',NULL,'2011yCatp016004901K',2011,1,0.6,NULL,'G',0.000063,NULL,'13.0K',0.1,NULL,NULL,NULL,NULL,NULL,1,79.670125,5.47981,0.605,NULL,64651574860,1010180857,15784075,13),(38132,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38132,35.99,0.84,158,10507,70,NULL,NULL,'2MASX J05184298-1759444',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.98',0.4,NULL,NULL,NULL,NULL,NULL,1,79.6790417,-17.99564,0.121,NULL,37432433779,584881777,9138777,15.98),(38133,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38133,35.51,0.52,127,10508,70,NULL,NULL,'AM 0516-364 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000097,NULL,'15',0.6,'AGN?',NULL,NULL,NULL,NULL,1,79.687667,-36.63436,0.089,NULL,37094292705,579598323,9056223,15),(38134,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38134,36.8,0.56,229,10509,70,NULL,NULL,'2MASX J05184854-1839304',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.08',0.3,NULL,NULL,NULL,NULL,NULL,1,79.70225,-18.65853,0.157,NULL,37433990459,584906100,9139157,16.08),(38135,'IRAS','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38135,33.96,0.8,61.9,10510,75,NULL,'MAT, I','ESO 004- G 019',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'15.11',1,'SA(rs)cd',NULL,NULL,NULL,NULL,1,79.7042083,-86.38572,0.669,NULL,35440102838,553751606,8652368,15.11),(38136,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38136,33.2,0.32,43.7,10510,85,NULL,'I, raw','ESO 004- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38137,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38137,33.22,0.32,44,10510,85,NULL,'I, inv','ESO 004- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38138,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38138,33.73,0.43,55.7,10510,75,NULL,'MAT, I, raw','ESO 004- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38139,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38139,33.88,0.43,59.7,10510,75,NULL,'MAT, I, inv','ESO 004- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38140,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38140,33.93,0.43,61.1,10510,75,NULL,'MAT, I, cor','ESO 004- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38141,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38141,34.06,0.34,64.8,10510,NULL,NULL,NULL,'ESO 004- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38142,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38142,34.1,0.2,66.1,10510,74.4,NULL,NULL,'ESO 004- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38143,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38143,34.11,0.33,66.4,10510,NULL,NULL,'Malmquist cor.','ESO 004- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38144,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38144,36.29,0.61,182,10511,70,NULL,NULL,'2MASX J05185077-1147082',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,79.7114583,-11.78567,0.349,NULL,36675731933,573058311,8954036,14.4),(38145,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38145,35.19,0.45,109,10512,NULL,NULL,'Malmquist cor.','ESO 553- G 032',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.54',0.4,'Sb',NULL,NULL,NULL,NULL,1,79.720125,-17.51697,0.173,NULL,37432485205,584882581,9138790,15.54),(38146,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38146,35.19,0.45,109,10512,NULL,NULL,NULL,'ESO 553- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38147,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38147,35.23,0.2,111,10512,74.4,NULL,NULL,'ESO 553- G 032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38148,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,'R',38148,35.17,0.49,108,10513,75,NULL,'IR','2MFGC 04350',NULL,'2011yCatp016004901K',2011,1,0.7,NULL,'G',0.000009,NULL,'16',0.2,'S','Group member',NULL,NULL,NULL,1,79.724833,6.32336,0.601,NULL,64685407560,1010709493,15792335,16),(38149,'Tully est','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38149,31.73,0.8,22.2,10514,75,NULL,NULL,'UGCA 109',NULL,'1988NBGC.C....0000T',1988,1,1.4,NULL,'G',0.000021,NULL,'15.6',1,'IB(s)m',NULL,NULL,NULL,NULL,1,79.755417,-21.54167,0.105,NULL,37426454712,584788354,9137318,15.6),(38150,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38150,35.76,0.49,142,10515,70,NULL,NULL,'ESO 252- G 018',NULL,'2014MNRAS.445.2677S',2014,1,0.98,NULL,'G',0.00008,NULL,'14.69',0.59,'(L)SB0^0',NULL,NULL,NULL,NULL,1,79.786125,-43.15844,0.021,NULL,37642862041,588169719,9190151,14.69),(38151,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38151,34.2,0.4,69.3,10516,NULL,NULL,'mean','UGC 03277',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000017,NULL,'14.9',0.7,'Scd:',NULL,NULL,NULL,NULL,1,79.7922083333,65.46997,0.677,NULL,66110262415,1032972850,16140200,14.9),(38152,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38152,34.22,0.3,69.9,10516,NULL,NULL,'Malmquist cor.','UGC 03277',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38153,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38153,34.23,0.2,70.2,10516,74.4,NULL,NULL,'UGC 03277',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38154,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38154,34.38,0.28,75.1,10516,NULL,NULL,NULL,'UGC 03277',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38155,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38155,34.61,0.47,83.7,10516,NULL,NULL,'H','UGC 03277',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38156,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38156,36.27,0.57,179,10517,70,NULL,NULL,'2MASX J05191414-1059219',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.27',0.5,NULL,NULL,NULL,NULL,NULL,1,79.808875,-10.98925,0.437,NULL,36710281045,573598141,8962470,16.27),(38157,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38157,34.19,0.47,69,10518,NULL,NULL,NULL,'ESO 085- G 069',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'15.35',0.2,'S...',NULL,NULL,NULL,NULL,1,79.8197917,-62.53497,0.049,NULL,35901897984,560967156,8765111,15.35),(38158,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38158,34.23,0.2,70.2,10518,74.4,NULL,NULL,'ESO 085- G 069',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38159,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38159,34.33,0.44,73.3,10518,NULL,NULL,'Malmquist cor.','ESO 085- G 069',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38160,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38160,35.15,0.52,107,10519,70,NULL,NULL,'2MASX J05191816-2901244',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'16.38',0.28,NULL,NULL,NULL,NULL,NULL,1,79.825667,-29.02339,0,NULL,37256160546,582127508,9095742,16.38),(38161,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38161,34.62,0.6,84,10520,NULL,NULL,'Malmquist cor.','ESO 119- G 052',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'14.54',0.8,'SA(s)b:',NULL,NULL,NULL,NULL,1,79.825875,-61.66106,0.077,NULL,35889701906,560776592,8762134,14.54),(38162,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38162,34.75,0.56,89.2,10520,NULL,NULL,NULL,'ESO 119- G 052',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38163,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38163,34.79,0.2,90.8,10520,74.4,NULL,NULL,'ESO 119- G 052',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38164,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38164,37.03,0.57,255,10521,70,NULL,NULL,'2MASX J05191835-4141016',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'15.99',0.45,'S0',NULL,NULL,NULL,NULL,1,79.8264583,-41.68386,0.033,NULL,37643377677,588177776,9190277,15.99),(38165,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38165,37.25,0.65,281,10522,70,NULL,NULL,'2MASX J05192546-4358346',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'16.99',0.26,NULL,NULL,NULL,NULL,NULL,1,79.856125,-43.97628,0,NULL,37644293041,588192078,9190501,16.99),(38166,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38166,34.99,0.55,99.7,10523,70,NULL,NULL,'MCG -05-13-015',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16',0.3,NULL,NULL,NULL,NULL,NULL,1,79.8597083,-28.70425,0,NULL,37256817406,582137771,9095902,16),(38167,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38167,36.66,0.78,215,10524,70,NULL,NULL,'2MASX J05192770-2514054',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.73',0.34,NULL,NULL,NULL,NULL,NULL,1,79.865375,-25.23483,0,NULL,37129332939,580145827,9064778,16.73),(38168,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38168,35.01,0.62,100,10525,70,NULL,NULL,'2MASX J05192784-2321163',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'16.00',0.36,NULL,NULL,NULL,NULL,NULL,1,79.866,-23.3545,0.041,NULL,37427919804,584811246,9137675,16),(38169,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,'R',38169,35.73,0.49,140,10526,75,NULL,'IR','2MFGC 04355',NULL,'2011yCatp016004901K',2011,1,0.6,NULL,'G',0.000009,NULL,'14.7',0.1,NULL,NULL,NULL,NULL,NULL,1,79.8890416667,5.42914,0.605,NULL,64654452901,1010225826,15784778,14.7),(38170,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38170,35.69,0.71,138,10527,70,NULL,NULL,'2MASX J05193428-1438328',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.2,NULL,NULL,NULL,NULL,NULL,1,79.892917,-14.64236,0.257,NULL,37410547256,584539800,9133434,14.4),(38171,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38171,34.85,0.61,93.5,10528,70,NULL,NULL,'ESO 486- G 052',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000107,NULL,'14.94',0.7,'SA(r)a',NULL,NULL,NULL,NULL,1,79.9099583,-24.89292,0,NULL,37130612815,580165825,9065091,14.94),(38172,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38172,34.32,0.6,73.2,10529,70,NULL,NULL,'ESO 119- G 053',NULL,'2014MNRAS.445.2677S',2014,1,1.4,'ESO-LV gives v= 4334+/-29 km/sec.','G',0.000093,NULL,'14.33',1,'(R_1R\'_2)SB(rl)0/a',NULL,NULL,NULL,NULL,1,79.910875,-61.73922,0.077,NULL,35889700828,560776575,8762133,14.33),(38173,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38173,33.84,0.4,58.6,10530,NULL,NULL,'mean','UGC 03253',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000023,NULL,'13.21',1,'SB(r)b',NULL,NULL,NULL,NULL,1,79.924583,84.05258,0.285,NULL,65536503426,1024007866,16000122,13.21),(38174,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38174,33.92,0.41,60.7,10530,NULL,NULL,NULL,'UGC 03253',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38175,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38175,33.93,0.2,61.1,10530,74.4,NULL,NULL,'UGC 03253',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38176,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38176,33.97,0.43,62.3,10530,75,NULL,'3.6 micron, color corrected','UGC 03253',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38177,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38177,34.01,0.4,63.5,10530,NULL,NULL,'Malmquist cor.','UGC 03253',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38178,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38178,34.03,0.43,64,10530,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03253',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38179,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38179,34.03,0.47,64.1,10530,NULL,NULL,'H','UGC 03253',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38180,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38180,34.06,0.46,64.7,10530,NULL,NULL,'J','UGC 03253',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38181,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38181,34.08,0.45,65.3,10530,NULL,NULL,'K','UGC 03253',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38182,'FP','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38182,35.67,0.48,136,10531,70,NULL,NULL,'IC 2121',NULL,'2014MNRAS.445.2677S',2014,1,1.9,'ESO/Uppsala lists the identification with IC 0408 as doubtful.','G',0.000083,NULL,'13.78',1.1,'SAB(s)0^0^: pec','Pair member (points to parent)',NULL,NULL,NULL,1,79.936917,-25.06433,0,NULL,37129291578,580145180,9064768,13.78),(38183,'IRAS','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38183,31.22,0.8,17.5,10532,75,NULL,'MAT, I','NGC 1879',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000013,NULL,'13.16',1.7,'SB(s)m',NULL,NULL,NULL,NULL,1,79.9509583333,-32.14275,0,NULL,37297986466,582781038,9105953,13.16),(38184,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38184,30.77,0.4,14.2,10532,75,NULL,'B','NGC 1879',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38185,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38185,30.99,0.32,15.8,10532,85,NULL,'I, inv','NGC 1879',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38186,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38186,31.02,0.32,16,10532,85,NULL,'I, raw','NGC 1879',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38187,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38187,31.42,0.4,19.2,10532,NULL,NULL,NULL,'NGC 1879',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38188,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38188,31.42,0.39,19.2,10532,73,NULL,'opt','NGC 1879',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38189,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38189,31.96,0.43,24.6,10532,75,NULL,'MAT, I, raw','NGC 1879',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38190,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38190,31.98,0.43,24.9,10532,75,NULL,'MAT, I, inv','NGC 1879',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38191,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38191,32.07,0.43,25.9,10532,75,NULL,'MAT, I, cor','NGC 1879',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38192,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38192,34.8,0.43,91.1,10533,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0530',NULL,'2014MNRAS.444..527S',2014,1,0.97,NULL,'G',0.000053,NULL,'16.7',0.11,'Scd',NULL,NULL,NULL,NULL,1,79.950833,1.56111,0.505,NULL,64646324753,1010098824,15782794,16.7),(38193,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38193,35.19,0.51,109,10534,NULL,NULL,NULL,'ESO 553- G 036',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.76',0.3,'Sb:',NULL,NULL,NULL,NULL,1,79.9582083,-20.96736,0.089,NULL,37426761310,584793145,9137392,15.76),(38194,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38194,35.23,0.2,111,10534,74.4,NULL,NULL,'ESO 553- G 036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38195,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:10','1',NULL,NULL,38195,35.35,0.47,117,10534,NULL,NULL,'Malmquist cor.','ESO 553- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38196,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38196,36.5,0.62,200,10535,70,NULL,NULL,'ESO 423- G 007',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'15.48',0.3,'Sa:',NULL,NULL,NULL,NULL,1,79.982667,-30.64192,0,NULL,37308718522,582948726,9108573,15.48),(38197,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38197,35.28,0.53,114,10536,70,NULL,NULL,'2MASX J05195626-2510332',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.00015,NULL,'16.91',0.15,NULL,NULL,NULL,NULL,NULL,1,79.984333,-25.17592,0,NULL,37129298188,580145284,9064770,16.91),(38198,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38198,36,0.52,159,10537,70,NULL,NULL,'ESO 159- G 006',NULL,'2014MNRAS.445.2677S',2014,1,1,'ESO-LV has two entries for this object.','G',0.00015,NULL,'15.14',0.8,'(R\'_1)SB(r)a',NULL,NULL,NULL,NULL,1,80.0025,-53.937,0.341,NULL,35753127554,558642618,8728790,15.14),(38199,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38199,35.65,0.55,135,10538,70,NULL,NULL,'2MASX J05200399-2519592',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'16.29',0.35,NULL,NULL,NULL,NULL,NULL,1,80.0167083,-25.33308,0,NULL,37143213555,580362711,9068167,16.29),(38200,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38200,34.54,0.48,80.8,10539,NULL,NULL,'Malmquist cor.','UGC 03289',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000009,NULL,'15.39',0.3,'SBb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,80.0249583333,6.58203,0.601,NULL,64688042743,1010750667,15792979,15.39),(38201,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38201,34.61,0.46,83.5,10539,NULL,NULL,NULL,'UGC 03289',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38202,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38202,34.61,0.2,83.6,10539,74.4,NULL,NULL,'UGC 03289',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38203,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38203,35.6,0.5,132,10540,70,NULL,NULL,'2MASX J05200652-2250465',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00008,NULL,'16.21',0.33,NULL,NULL,NULL,NULL,NULL,1,80.0267083,-22.8465,0.037,NULL,37428798217,584824972,9137890,16.21),(38204,'IRAS','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38204,35.27,0.8,113,10541,75,NULL,'W91CL, r','CGCG 421-030',NULL,'1997ApJS..109..333W',1997,1,0.8,NULL,'G',0.000008,NULL,'15.27',0.4,'Sc',NULL,NULL,NULL,NULL,1,80.052375,5.83758,0.681,NULL,64688241125,1010753767,15793027,15.27),(38205,'IRAS','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38205,35.28,0.8,114,10541,75,NULL,'HMCL, I','CGCG 421-030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38206,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38206,35.19,0.44,109,10541,NULL,NULL,'Malmquist cor.','CGCG 421-030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38207,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38207,35.23,0.44,111,10541,NULL,NULL,NULL,'CGCG 421-030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38208,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38208,35.4,0.2,120,10541,74.4,NULL,NULL,'CGCG 421-030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38209,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38209,35.58,0.38,131,10541,75,NULL,'W91CL, r, raw','CGCG 421-030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38210,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38210,35.67,0.4,136,10541,75,NULL,'HMCL, I, raw','CGCG 421-030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38211,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38211,35.73,0.38,140,10541,75,NULL,'W91CL, r, cor','CGCG 421-030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38212,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38212,35.77,0.38,142,10541,75,NULL,'W91CL, r, inv','CGCG 421-030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38213,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38213,35.81,0.4,145,10541,75,NULL,'HMCL, I, cor','CGCG 421-030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38214,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38214,35.9,0.4,151,10541,75,NULL,'HMCL, I, inv','CGCG 421-030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38215,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38215,34.55,0.48,81.2,10542,70,NULL,NULL,'2MASX J05201344-2911022',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'15.94',0.43,NULL,NULL,NULL,NULL,NULL,1,80.056,-29.184,0,NULL,37256016273,582125254,9095707,15.94),(38216,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38216,36.1,0.69,166,10543,70,NULL,NULL,'2MASX J05201348-2553582',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'17.35',0.21,NULL,NULL,NULL,NULL,NULL,1,80.0562917,-25.89953,0,NULL,37142800725,580356261,9068066,17.35),(38217,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38217,35.66,0.51,136,10544,70,NULL,NULL,'2MASX J05201465-4556395',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.43',0.48,NULL,NULL,NULL,NULL,NULL,1,80.0609583333,-45.94428,0.093,NULL,37637333179,588083330,9188802,15.43),(38218,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38218,35.27,0.58,113,10545,70,NULL,NULL,'ESO 486- G 055',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.5',0.8,'Sb',NULL,NULL,NULL,NULL,1,80.0634583333,-25.71339,0,NULL,37143255691,580363370,9068177,15.5),(38219,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38219,35.13,0.54,106,10546,70,NULL,NULL,'2MASX J05201597-2450021',NULL,'2014MNRAS.445.2677S',2014,1,0.89,NULL,'G',0.00015,NULL,'16.06',0.27,NULL,NULL,NULL,NULL,NULL,1,80.0665833333,-24.83406,0,NULL,37141912716,580342386,9067849,16.06),(38220,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38220,36.92,0.84,243,10547,70,NULL,NULL,'2MASX J05201691-2526181',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.97',0.31,NULL,NULL,NULL,NULL,NULL,1,80.070375,-25.43842,0,NULL,37143427612,580366056,9068219,16.97),(38221,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38221,35.81,0.48,145,10548,70,NULL,NULL,'2MASX J05202533-2513528',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.44',0.69,NULL,NULL,NULL,NULL,NULL,1,80.1055417,-25.23133,0,NULL,37143245658,580363213,9068175,15.44),(38222,'IRAS','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38222,33.8,0.8,57.5,10549,75,NULL,'CF, r','UGC 03291',NULL,'1997ApJS..109..333W',1997,1,1,'UZC has V_sun = 4348 +- 18 km/s.','G',0.000022,NULL,'15.79',0.4,'SBcd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,80.109583,6.57094,0.721,NULL,64688500067,1010757813,15793090,15.79),(38223,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38223,33.52,0.38,50.5,10549,75,NULL,'CF, r, inv','UGC 03291',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38224,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38224,33.52,0.38,50.5,10549,75,NULL,'CF, r, raw','UGC 03291',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38225,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38225,33.81,0.38,57.9,10549,75,NULL,'CF, r, cor','UGC 03291',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38226,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38226,33.83,0.49,58.3,10549,NULL,NULL,NULL,'UGC 03291',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38227,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38227,33.87,0.2,59.4,10549,74.4,NULL,NULL,'UGC 03291',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38228,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38228,34.12,0.42,66.8,10549,NULL,NULL,'Malmquist cor.','UGC 03291',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38229,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38229,35.84,0.63,147,10550,70,NULL,NULL,'ESO 486- G 057',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00006,NULL,'14.99',1,'S0',NULL,NULL,NULL,NULL,1,80.1460417,-26.78467,0,NULL,37255075870,582110560,9095477,14.99),(38230,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38230,36.37,0.61,188,10551,70,NULL,NULL,'2MASX J05203760-4559515',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.94',0.22,NULL,NULL,NULL,NULL,NULL,1,80.156625,-45.99775,0.093,NULL,37637379110,588084048,9188813,16.94),(38231,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38231,33.89,0.45,60.1,10552,NULL,NULL,'K','UGC 03293',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000004,NULL,'16.0',0.8,'Scd:',NULL,NULL,NULL,NULL,1,80.169875,8.80867,1.513,NULL,64638986778,1009984168,15781002,16),(38232,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38232,33.9,0.47,60.2,10552,NULL,NULL,'H','UGC 03293',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38233,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38233,34.09,0.46,65.7,10552,NULL,NULL,'J','UGC 03293',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38234,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38234,34.1,0.4,66.2,10552,NULL,NULL,'mean','UGC 03293',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38235,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38235,36.48,0.56,198,10553,70,NULL,NULL,'2MASX J05204651-1746547',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.40',0.3,NULL,NULL,NULL,NULL,NULL,1,80.194,-17.782,0.245,NULL,37433028865,584891076,9138923,16.4),(38236,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38236,35.31,0.51,115,10554,70,NULL,NULL,'ESO 486- G 059',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.60',0.2,'S0',NULL,NULL,NULL,NULL,1,80.2140417,-25.17636,0,NULL,37143765668,580371338,9068302,15.6),(38237,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38237,35.91,0.5,152,10555,70,NULL,NULL,'2MASX J05205807-2218580',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.05',0.4,NULL,NULL,NULL,NULL,NULL,1,80.2419583,-22.31617,0.093,NULL,37428174267,584815222,9137737,16.05),(38238,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38238,35.59,0.62,131,10556,70,NULL,NULL,'2MASX J05205960-1912426',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.66',0.3,NULL,NULL,NULL,NULL,NULL,1,80.24825,-19.21197,0.125,NULL,37431533373,584867708,9138557,15.66),(38239,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38239,35.42,0.47,121,10557,NULL,NULL,'H','CGCG 421-036',NULL,'2007A&A...465...71T',2007,1,0.6,NULL,'G',0.00019,NULL,'15.5',0.3,NULL,NULL,NULL,NULL,NULL,1,80.251125,6.55775,0.721,NULL,64688510698,1010757979,15793093,15.5),(38240,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38240,35.55,0.4,129,10557,NULL,NULL,'mean','CGCG 421-036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38241,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38241,37.54,0.67,322,10558,70,NULL,NULL,'2MASX J05210322-1658042',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,80.2635,-16.96783,0.233,NULL,37401768807,584402637,9131291,16.9),(38242,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38242,33.64,0.47,53.4,10559,NULL,NULL,'H','UGC 03294',NULL,'2007A&A...465...71T',2007,1,3,NULL,'G',0.000013,NULL,'13.80',1.6,'SA(rs)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,80.266625,4.00636,0.525,NULL,64659117368,1010298708,15785917,13.8),(38243,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38243,33.66,0.46,53.9,10559,NULL,NULL,'J','UGC 03294',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38244,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38244,33.7,0.45,54.9,10559,NULL,NULL,'K','UGC 03294',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38245,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38245,33.89,0.4,59.9,10559,NULL,NULL,'mean','UGC 03294',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38246,'IRAS','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38246,31.29,0.8,18.1,10560,75,NULL,'MAT, I','ESO 362- G 019',NULL,'1997ApJS..109..333W',1997,1,2.2,'Confused HIPASS source','G',0.00002,NULL,'14.10',0.7,'SB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,80.2674166667,-36.95686,0.093,NULL,37094177223,579596519,9056195,14.1),(38247,'Tully est','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38247,30.85,0.8,14.8,10560,75,NULL,NULL,'ESO 362- G 019',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38248,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38248,30.4,0.32,12,10560,85,NULL,'I, inv','ESO 362- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38249,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38249,30.47,0.32,12.4,10560,85,NULL,'I, raw','ESO 362- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38250,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38250,30.91,0.43,15.2,10560,75,NULL,'MAT, I, inv','ESO 362- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38251,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38251,30.97,0.2,15.6,10560,74.4,NULL,NULL,'ESO 362- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38252,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38252,31.05,0.43,16.3,10560,75,NULL,'MAT, I, raw','ESO 362- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38253,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38253,31.14,0.4,16.9,10560,NULL,NULL,NULL,'ESO 362- G 019',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38254,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38254,31.14,0.4,16.9,10560,73,NULL,'opt','ESO 362- G 019',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38255,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38255,31.16,0.43,17.1,10560,75,NULL,'3.6 micron, color corrected','ESO 362- G 019',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38256,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38256,31.26,0.43,17.9,10560,75,NULL,'MAT, I, cor','ESO 362- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38257,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38257,31.28,0.43,18,10560,75,NULL,'3.6 micron, color + selection bias corrected','ESO 362- G 019',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38258,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38258,35.94,0.49,154,10561,70,NULL,NULL,'2MASX J05210796-5213525',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.8b',0.3,NULL,NULL,NULL,NULL,NULL,1,80.283167,-52.23117,0.013,NULL,35754462492,558663476,8729116,15.8),(38259,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38259,32.54,0.4,32.1,10562,75,NULL,NULL,'UGC 03276',NULL,'2008Ap.....51..336K',2008,1,1.85,NULL,'G',0.000037,NULL,'15.60',0.28,'Sb',NULL,NULL,NULL,NULL,1,80.3179583333,76.35572,0.485,NULL,65662622167,1025978471,16030913,15.6),(38260,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38260,32.97,0.4,39.3,10562,NULL,NULL,'mean','UGC 03276',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38261,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38261,33.04,0.49,40.6,10562,75,NULL,'IR','UGC 03276',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38262,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38262,33.26,0.47,44.9,10562,NULL,NULL,'H','UGC 03276',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38263,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38263,33.27,0.45,45.1,10562,NULL,NULL,'K','UGC 03276',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38264,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38264,33.28,0.46,45.3,10562,NULL,NULL,'J','UGC 03276',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38265,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38265,36.84,0.8,234,10563,70,NULL,NULL,'2MASX J05211649-2529300',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'15.0R',0.13,NULL,NULL,NULL,NULL,NULL,1,80.3187083333,-25.49169,0,NULL,37143406856,580365732,9068214,15),(38266,'Sosies','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38266,34.21,0.28,69.5,10564,NULL,NULL,NULL,'UGC 03296',NULL,'2002A&A...393...57T',2002,1,1.5,NULL,'G',0.00001,NULL,'13.95',1.1,'Sab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,80.3412083,4.88781,0.537,NULL,64653834108,1010216157,15784627,13.95),(38267,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38267,33.94,0.4,61.3,10564,NULL,NULL,'mean','UGC 03296',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38268,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38268,34.13,0.45,67,10564,NULL,NULL,'K','UGC 03296',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38269,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38269,34.13,0.47,67.1,10564,NULL,NULL,'H','UGC 03296',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38270,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38270,34.15,0.46,67.6,10564,NULL,NULL,'J','UGC 03296',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38271,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38271,34.13,0.2,67,10565,74.4,NULL,NULL,'UGC 03284',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000023,NULL,'16.0',1,'SAB(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,80.345375,72.70158,0.417,NULL,65645055683,1025703995,16026624,16),(38272,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38272,34.2,0.37,69.3,10565,NULL,NULL,'Malmquist cor.','UGC 03284',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38273,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38273,34.32,0.35,73.2,10565,NULL,NULL,NULL,'UGC 03284',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38274,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38274,34.53,0.4,80.6,10566,NULL,NULL,'mean','UGC 03295',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000023,NULL,'17.',0.5,'Scd?',NULL,NULL,NULL,NULL,1,80.3509166667,15.24114,2.049,NULL,65412605805,1022071965,15969874,17),(38275,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38275,34.88,0.47,94.7,10566,NULL,NULL,'H','UGC 03295',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38276,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38276,35.08,0.49,104,10567,70,NULL,NULL,'2MASX J05212850-2124326',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.49',NULL,NULL,NULL,NULL,NULL,NULL,1,80.368667,-21.40903,0.105,NULL,37418834138,584669283,9135457,15.49),(38277,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38277,34.75,0.56,89.2,10568,70,NULL,NULL,'2MASX J05213112-2123416',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.69',NULL,NULL,NULL,NULL,NULL,NULL,1,80.379667,-21.395,0.113,NULL,37418842299,584669410,9135459,15.69),(38278,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38278,31,0.43,15.9,10569,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03257',NULL,'2014MNRAS.444..527S',2014,1,1.4,NULL,'G',0.000067,NULL,'14.72',0.7,'SBa',NULL,NULL,NULL,NULL,1,80.4355417,84.48219,0.237,NULL,65553392616,1024271759,16004246,14.72),(38279,'IRAS','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38279,31.96,0.8,24.7,10570,75,NULL,'MAT, I','NGC 1886',NULL,'1997ApJS..109..333W',1997,1,3.81,NULL,'G',0.000033,NULL,'13.60',0.45,'Sab            HII',NULL,NULL,NULL,NULL,1,80.450625,-23.81014,0.041,NULL,37137445481,580272585,9066759,13.6),(38280,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38280,32.14,0.43,26.8,10570,75,NULL,'MAT, I, raw','NGC 1886',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38281,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38281,32.15,0.4,26.9,10570,NULL,NULL,'mean','NGC 1886',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38282,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38282,32.18,0.47,27.3,10570,NULL,NULL,'H','NGC 1886',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38283,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38283,32.19,0.32,27.4,10570,85,NULL,'I, raw','NGC 1886',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38284,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38284,32.22,0.32,27.8,10570,85,NULL,'I, inv','NGC 1886',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38285,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38285,32.22,0.46,27.9,10570,NULL,NULL,'J','NGC 1886',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38286,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38286,32.27,0.45,28.4,10570,NULL,NULL,'K','NGC 1886',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38287,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38287,32.28,0.49,28.6,10570,75,NULL,'IR','NGC 1886',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38288,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38288,32.28,0.43,28.6,10570,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1886',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38289,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38289,32.3,0.43,28.9,10570,75,NULL,'MAT, I, inv','NGC 1886',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38290,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38290,32.37,0.43,29.8,10570,75,NULL,'3.6 micron, color corrected','NGC 1886',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38291,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38291,32.4,0.43,30.2,10570,75,NULL,'MAT, I, cor','NGC 1886',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38292,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38292,32.41,0.4,30.4,10570,75,NULL,NULL,'NGC 1886',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38293,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38293,32.41,0.4,30.4,10570,73,NULL,'IR','NGC 1886',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38294,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38294,32.42,0.4,30.5,10570,73,NULL,'opt','NGC 1886',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38295,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38295,32.48,0.2,31.3,10570,74.4,NULL,NULL,'NGC 1886',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38296,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38296,32.7,0.39,34.6,10570,73,NULL,'opt','NGC 1886',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38297,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38297,32.7,0.52,34.7,10570,NULL,NULL,NULL,'NGC 1886',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38298,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38298,32.7,NULL,34.7,10570,NULL,NULL,NULL,'NGC 1886',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38299,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38299,32.82,0.49,36.7,10570,NULL,NULL,'Malmquist cor.','NGC 1886',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38300,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38300,33.03,NULL,40.4,10570,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 1886',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38301,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38301,33.06,NULL,40.8,10570,NULL,NULL,'Dipole + Quadrupole','NGC 1886',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38302,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38302,33.06,NULL,41,10570,NULL,NULL,'Dipole','NGC 1886',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38303,'SNIa','2016-12-15 15:14:06','2016-12-16 11:19:11','1','SN 2004gc',NULL,38303,35.39,0.13,113,10571,72,NULL,NULL,'ARP 327 NED04',0.03074,'2013ApJ...773...53F',2013,1,0.28,NULL,'G',0.000133,NULL,'17.41',0.12,'SA0-:','Compact group member',NULL,NULL,NULL,1,80.4574583,6.67703,0.781,NULL,64688739725,1010761558,15793149,17.41),(38304,'SNIa','2016-12-15 15:14:06','2016-12-16 11:19:11','1','SN 2004gc',NULL,38304,35.26,0.02,113,10571,72,NULL,NULL,'ARP 327 NED04',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38305,'SNIa','2016-12-15 15:14:06','2016-12-16 11:19:11','1','SN 2004gc',NULL,38305,35.34,0.04,113,10571,72,NULL,NULL,'ARP 327 NED04',0.032089,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38306,'SNIa','2016-12-15 15:14:06','2016-12-16 11:19:11','1','SN 2004gc',NULL,38306,35.28,0.1,114,10571,74.4,NULL,NULL,'ARP 327 NED04',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38307,'SNIa','2016-12-15 15:14:06','2016-12-16 11:19:11','1','SN 2004gc',NULL,38307,35.4,0.15,116,10571,70,NULL,'SALT 2','ARP 327 NED04',0.032089,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38308,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38308,35.58,0.7,131,10572,70,NULL,NULL,'2MASX J05215924-0240290',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.4,NULL,NULL,NULL,NULL,NULL,1,80.496917,-2.67467,1.049,NULL,36744842512,574138164,8970908,14.6),(38309,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38309,35.81,0.61,145,10573,70,NULL,NULL,'2MASX J05220805-0257320',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,80.533625,-2.95883,1.121,NULL,36756219273,574315926,8973686,14.1),(38310,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38310,37.07,0.6,259,10574,70,NULL,NULL,'2MASX J05221593-1511038',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,80.566333,-15.18436,0.249,NULL,37410750050,584542969,9133483,14.6),(38311,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38311,35.81,0.4,145,10575,NULL,NULL,'mean','ESO 487- G 004',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000017,NULL,'15.73',0.4,'Sc             HII',NULL,NULL,NULL,NULL,1,80.57175,-25.60744,0,NULL,37143368710,580365136,9068205,15.73),(38312,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38312,36.14,0.47,169,10575,NULL,NULL,'H','ESO 487- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38313,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38313,35.29,0.59,114,10576,70,NULL,NULL,'2MASX J05222191-0606463',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.45',0.4,NULL,NULL,NULL,NULL,NULL,1,80.5912917,-6.11297,0.669,NULL,36765522434,574461288,8975957,16.45),(38314,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38314,35.58,0.56,131,10577,70,NULL,NULL,'2MASX J05222525-2239335',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.14',NULL,NULL,NULL,NULL,NULL,NULL,1,80.6052917,-22.65925,0.033,NULL,37420212190,584690815,9135793,16.14),(38315,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38315,36.85,0.69,234,10578,70,NULL,NULL,'2MASX J05222677-5618107',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,80.611667,-56.30294,0.057,NULL,35927497191,561367143,8771361,16.7),(38316,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38316,35.43,0.54,122,10579,70,NULL,NULL,'2MASX J05223025-1702177',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,80.6260833333,-17.03828,0.189,NULL,37409046772,584516355,9133068,16.6),(38317,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38317,35.91,0.68,152,10580,70,NULL,NULL,'2MASX J05223232-0356267',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.3,NULL,NULL,NULL,NULL,NULL,1,80.63475,-3.94081,1.073,NULL,36758642440,574353788,8974277,14.1),(38318,'Sosies','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38318,33.06,0.14,40.9,10581,NULL,NULL,NULL,'NGC 1888',NULL,'2002A&A...393...57T',2002,1,3,NULL,'G',0.000017,NULL,'12.83',0.8,'SB(s)c pec','Pair member (points to parent)',NULL,NULL,NULL,1,80.6435417,-11.49953,0.449,NULL,36677168241,573080753,8954386,12.83),(38319,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38319,32.28,0.4,28.6,10581,75,NULL,'B','NGC 1888',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38320,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38320,32.48,0.46,31.3,10581,NULL,NULL,'J','NGC 1888',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38321,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38321,32.48,0.47,31.4,10581,NULL,NULL,'H','NGC 1888',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38322,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38322,32.51,0.45,31.8,10581,NULL,NULL,'K','NGC 1888',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38323,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38323,32.85,0.4,37.1,10581,NULL,NULL,'mean','NGC 1888',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38324,'Tully est','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38324,32.44,0.8,30.7,10582,75,NULL,NULL,'NGC 1889',NULL,'1988NBGC.C....0000T',1988,1,0.7,NULL,'G',0.000087,NULL,'14',0.5,'E+ pec:','Pair member (points to parent)',NULL,NULL,NULL,1,80.647083,-11.49694,0.449,NULL,36677169076,573080766,8954386,14),(38325,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38325,34.14,0.4,67.4,10583,NULL,NULL,'mean','NGC 2012',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000047,NULL,'13.98',0.6,'SA0-:',NULL,NULL,NULL,NULL,1,80.6472917,-79.85181,0.445,NULL,35671986720,557374792,8708981,13.98),(38326,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38326,34.44,0.45,77.4,10583,NULL,NULL,'K','NGC 2012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38327,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38327,36.76,0.73,225,10584,70,NULL,NULL,'2MASX J05224837-1543337',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,80.7015417,-15.72611,0.285,NULL,37412732664,584573947,9133967,17.3),(38328,'BL Lac Luminosity','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38328,37.03,NULL,241,10585,NULL,NULL,NULL,'ESO 362- G 021',0.056546,'2005ApJ...635..173S',2005,1,0.3,NULL,'G',0.000183,NULL,'14.5',0.3,'N galaxy;HPQ   BLLAC',NULL,NULL,'HYMORS','Sy 1',1,80.7415833333,-36.45856,0.041,NULL,37088715632,579511181,9054862,14.5),(38329,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38329,35.25,0.49,112,10586,70,NULL,NULL,'AM 0520-265',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.5I',0.6,NULL,NULL,NULL,NULL,NULL,1,80.746,-26.88589,0,NULL,37135226835,580237919,9066217,13.5),(38330,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38330,35.78,0.43,143,10587,NULL,NULL,'Malmquist cor.','ESO 553- G 039',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.75',0.3,'Sb',NULL,NULL,NULL,NULL,1,80.765375,-17.96122,0.169,NULL,37443706600,585057915,9141529,15.75),(38331,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38331,35.92,0.41,153,10587,NULL,NULL,NULL,'ESO 553- G 039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38332,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38332,35.96,0.2,156,10587,74.4,NULL,NULL,'ESO 553- G 039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38333,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38333,35.29,0.53,114,10588,70,NULL,NULL,'AM 0521-265',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00008,NULL,'13.0I',0.7,NULL,NULL,NULL,NULL,NULL,1,80.77275,-26.82394,0,NULL,37135234137,580238033,9066219,13),(38334,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38334,35.8,NULL,144,10589,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0531',NULL,'2010Ap&SS.325..163P',2010,1,1.28,NULL,'G',NULL,NULL,'16.2',0.11,'Scd',NULL,NULL,NULL,NULL,1,80.7764583,67.32869,0.413,NULL,66384489385,1037257646,16207150,16.2),(38335,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38335,35.81,NULL,145,10589,NULL,NULL,'Dipole + Quadrupole','FGC 0531',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38336,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38336,35.83,NULL,146,10589,NULL,NULL,'Dipole','FGC 0531',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38337,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38337,35.83,NULL,147,10589,NULL,NULL,NULL,'FGC 0531',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38338,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38338,35.84,0.49,147,10589,75,NULL,'IR','FGC 0531',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38339,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38339,35.82,0.56,146,10590,70,NULL,NULL,'2MASX J05231161-4534033',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.000083,NULL,'15.21',0.53,'E',NULL,NULL,NULL,NULL,1,80.7984583333,-45.56753,0.085,NULL,37637420575,588084696,9188823,15.21),(38340,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38340,33.04,0.4,40.6,10591,73,NULL,'IR','MCG -02-14-015',NULL,'2011A&A...532A.104N',2011,1,1.72,NULL,'G',0.00003,NULL,'14.5',0.2,'S0^0^: sp',NULL,NULL,NULL,NULL,1,80.811583,-11.42481,0.449,NULL,36709748375,573589818,8962340,14.5),(38341,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38341,33.04,0.4,40.6,10591,73,NULL,'opt','MCG -02-14-015',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38342,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38342,33.04,0.4,40.6,10591,75,NULL,NULL,'MCG -02-14-015',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38343,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38343,33.61,0.49,52.6,10591,75,NULL,'IR','MCG -02-14-015',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38344,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38344,34.25,NULL,70.7,10591,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -02-14-015',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38345,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38345,34.26,NULL,71,10591,NULL,NULL,'Dipole + Quadrupole','MCG -02-14-015',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38346,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38346,34.26,NULL,71,10591,NULL,NULL,'Dipole','MCG -02-14-015',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38347,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38347,34.65,NULL,85,10592,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0524',NULL,'2010Ap&SS.325..163P',2010,1,0.83,NULL,'G',0.000047,NULL,'16.9',0.09,'Sc',NULL,NULL,NULL,NULL,1,80.815,85.6725,0.329,NULL,65507430142,1023553595,15993024,16.9),(38348,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38348,34.65,NULL,85.2,10592,NULL,NULL,'Dipole + Quadrupole','FGC 0524',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38349,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38349,34.66,NULL,85.6,10592,NULL,NULL,'Dipole','FGC 0524',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38350,'Tully-Fisher','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38350,34.79,NULL,90.8,10592,NULL,NULL,NULL,'FGC 0524',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38351,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38351,35.65,0.57,135,10593,70,NULL,NULL,'2MFGC 04412',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'14.0I',0.2,NULL,NULL,NULL,NULL,NULL,1,80.8485417,-17.80278,0.169,NULL,37443844016,585060062,9141563,14),(38352,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38352,35.53,0.69,128,10594,70,NULL,NULL,'AM 0526-780 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,80.878125,-78.06186,0.541,NULL,35537275511,555269929,8676092,16.6),(38353,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38353,35.97,0.7,156,10595,70,NULL,NULL,'2MASX J05233086-2610460',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,80.878625,-26.17942,0,NULL,37143096731,580360886,9068138,14.1),(38354,'FP','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38354,35.94,0.51,154,10596,70,NULL,NULL,'2MASX J05233319-2156583',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.23',0.3,NULL,NULL,NULL,NULL,NULL,1,80.888167,-21.94961,0.113,NULL,37418817286,584669020,9135453,16.23),(38355,'AGB','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38355,18.64,0.14,0.0535,10597,NULL,NULL,NULL,'LMC',NULL,'2003ASSL..283...19W',2003,1,645,NULL,'G',0.000007,NULL,'0.9',550,'SB(s)m','Group member',NULL,NULL,NULL,1,80.893875,-69.75614,0.253,0,36386855385,568544615,8883509,0.9),(38356,'B Stars','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38356,18.3,0.2,0.046,10597,NULL,NULL,NULL,'LMC',NULL,'1987MNRAS.225..947S',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38357,'B Stars','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38357,18.8,0.3,0.0575,10597,NULL,NULL,'24','LMC',NULL,'1986MNRAS.219..495S',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38358,'Blue Supergiant','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38358,18.5,0.5,0.0501,10597,NULL,NULL,NULL,'LMC',NULL,'2003LNP...635..149B',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38359,'Brightest Stars','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38359,18.19,0.22,0.0435,10597,NULL,NULL,NULL,'LMC',NULL,'1991A&A...246..341A',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38360,'Brightest Stars','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38360,18.3,NULL,0.0457,10597,NULL,NULL,'Photographic, A and B supergiants, 10','LMC',NULL,'1982Msngr..30...28D',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38361,'Brightest Stars','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38361,18.41,0.04,0.0481,10597,NULL,NULL,NULL,'LMC',NULL,'1995ApJ...438..188M',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38362,'Brightest Stars','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38362,18.6,0.1,0.0525,10597,NULL,NULL,NULL,'LMC',NULL,'1983ApJ...269..335H',1983,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38363,'Carbon Stars','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38363,18.36,0.6,0.047,10597,NULL,NULL,'Carbon star HC35, RA 108.0770, DEC -63.6360','LMC',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38364,'Carbon Stars','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38364,18.5,0.17,0.0501,10597,NULL,NULL,NULL,'LMC',NULL,'1998A&A...332L..53B',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38365,'Carbon Stars','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38365,18.54,0.62,0.051,10597,NULL,NULL,'Carbon star HC32, RA 103.6610, DEC -71.5165','LMC',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38366,'Carbon Stars','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38366,18.7,0.25,0.055,10597,NULL,NULL,'Lithium-rich','LMC',NULL,'1999ApJ...524L.111V',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38367,'Carbon Stars','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38367,18.74,0.32,0.056,10597,NULL,NULL,'Carbon star HC31, RA 097.0253, DEC -53.1848','LMC',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38368,'Carbon Stars','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38368,18.8,NULL,0.0575,10597,NULL,NULL,'Upper limit D','LMC',NULL,'1999A&A...346..805V',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38369,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38369,17.75,0.18,0.0355,10597,NULL,NULL,'HV 12717, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38370,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38370,17.77,0.13,0.0358,10597,NULL,NULL,'HV 12202, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38371,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38371,17.89,0.07,0.0379,10597,NULL,NULL,'HV 2369, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38372,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38372,17.93,0.13,0.0385,10597,NULL,NULL,'HV 12197, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38373,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38373,17.96,0.12,0.039,10597,NULL,NULL,'HV 12815, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38374,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38374,17.99,0.08,0.0396,10597,NULL,NULL,'HV 12452, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38375,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38375,18.03,0.05,0.0403,10597,NULL,NULL,'HV 881, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38376,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38376,18.04,0.06,0.0406,10597,NULL,NULL,'HV 909, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38377,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38377,18.05,0.09,0.0408,10597,NULL,NULL,'HV 2827, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38378,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38378,18.08,0.14,0.0413,10597,NULL,NULL,'NGC 1854','LMC',NULL,'1992SvAL...18..405K',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38379,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38379,18.1,NULL,0.0417,10597,NULL,NULL,'Z','LMC',NULL,'2011ApJ...741L..36M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38380,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38380,18.1,NULL,0.0417,10597,NULL,NULL,'HV 02827','LMC',NULL,'1987A&A...175...30I',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38381,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38381,18.15,0.08,0.0426,10597,NULL,NULL,'HV 1006, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38382,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38382,18.17,0.14,0.043,10597,NULL,NULL,'HV 879, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38383,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38383,18.17,0.06,0.0431,10597,NULL,NULL,'NGC 1866, HV 12197','LMC',NULL,'2005A&A...440..487S',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38384,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38384,18.18,0.04,0.0433,10597,NULL,NULL,'HV 2338, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38385,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38385,18.2,0.04,0.0437,10597,NULL,NULL,'NGC 1866, HV 12204','LMC',NULL,'2005A&A...440..487S',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38386,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38386,18.2,NULL,0.0437,10597,NULL,NULL,'HV 00879','LMC',NULL,'1987A&A...175...30I',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38387,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38387,18.2,NULL,0.0437,10597,NULL,NULL,'HV 02338','LMC',NULL,'1987A&A...175...30I',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38388,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38388,18.22,0.09,0.0441,10597,NULL,NULL,'HV 1005, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38389,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38389,18.23,0.07,0.0443,10597,NULL,NULL,'OGLE-II, BVI(WI)','LMC',NULL,'2000AcA....50..279U',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38390,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38390,18.25,0.05,0.0447,10597,NULL,NULL,'HV 2282, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38391,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38391,18.25,0.05,0.0447,10597,NULL,NULL,'BVRI','LMC',NULL,'1998A&AT...15...75B',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38392,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38392,18.25,0.08,0.0448,10597,NULL,NULL,'HV 876, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38393,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38393,18.26,0.06,0.0448,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4154, RA-DEC 05:34:13.9-63:10:01.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38394,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38394,18.26,0.06,0.0449,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3951, RA-DEC 05:24:01.8-66:51:36.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38395,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38395,18.26,0.06,0.0449,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4381, RA-DEC 05:46:34.7-67:19:06.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38396,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38396,18.26,0.04,0.0449,10597,NULL,NULL,'IRSB, PL2','LMC',NULL,'2011A&A...534A..94S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38397,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38397,18.26,0.14,0.0449,10597,NULL,NULL,'HV 12203, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38398,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38398,18.26,0.06,0.0449,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4401, RA-DEC 05:47:35.6-67:27:03.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38399,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38399,18.26,0.06,0.045,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2500, RA-DEC 05:35:34.9-70:05:25.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38400,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38400,18.27,0.06,0.045,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1295, RA-DEC 05:13:57.7-68:59:02.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38401,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38401,18.27,0.06,0.045,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1219, RA-DEC 05:11:58.0-71:08:53.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38402,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38402,18.27,0.06,0.0451,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4190, RA-DEC 05:36:27.7-66:50:18.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38403,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38403,18.27,0.06,0.0451,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0366, RA-DEC 04:55:04.4-69:46:22.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38404,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38404,18.27,0.06,0.0451,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4056, RA-DEC 05:29:14.3-65:32:30.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38405,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38405,18.27,0.06,0.0451,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3354, RA-DEC 06:08:10.4-70:46:45.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38406,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38406,18.27,0.06,0.0451,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2745, RA-DEC 05:38:44.6-70:11:23.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38407,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38407,18.27,0.06,0.0451,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4415, RA-DEC 05:48:10.2-67:21:20.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38408,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38408,18.28,0.06,0.0452,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2849, RA-DEC 05:40:08.6-70:47:27.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38409,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38409,18.28,0.06,0.0453,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1536, RA-DEC 05:18:11.6-69:35:13.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38410,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38410,18.28,0.06,0.0453,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1572, RA-DEC 05:19:02.6-69:40:10.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38411,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38411,18.29,0.06,0.0454,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2384, RA-DEC 05:33:42.2-70:59:18.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38412,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38412,18.29,0.06,0.0454,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3612, RA-DEC 05:08:09.9-66:28:49.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38413,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38413,18.28,0.05,0.0454,10597,NULL,NULL,'HV 900, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38414,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38414,18.29,0.1,0.0454,10597,NULL,NULL,'HV 12204, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38415,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38415,18.29,0.06,0.0454,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1671, RA-DEC 05:21:04.6-69:35:05.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38416,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38416,18.29,0.06,0.0454,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2542, RA-DEC 05:36:14.0-69:56:20.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38417,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38417,18.29,0.06,0.0454,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0462, RA-DEC 04:57:04.6-68:34:18.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38418,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38418,18.29,0.06,0.0454,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4369, RA-DEC 05:45:56.6-67:06:06.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38419,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38419,18.29,0.06,0.0455,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4574, RA-DEC 06:04:20.0-68:13:46.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38420,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38420,18.29,0.06,0.0455,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4455, RA-DEC 05:49:46.4-67:11:34.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38421,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38421,18.29,0.06,0.0455,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4347, RA-DEC 05:44:48.6-67:39:51.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38422,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38422,18.29,0.06,0.0455,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4590, RA-DEC 06:08:49.8-68:34:30.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38423,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38423,18.29,0.02,0.0455,10597,NULL,NULL,'36, K, Baade-Wesselink','LMC',NULL,'2013A&A...550A..70G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38424,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38424,18.29,0.07,0.0455,10597,NULL,NULL,'NGC 1866, HV 12202','LMC',NULL,'2005A&A...440..487S',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38425,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38425,18.29,0.17,0.0455,10597,NULL,NULL,NULL,'LMC',NULL,'1998A&A...335L..81L',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38426,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38426,18.29,0.06,0.0455,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2612, RA-DEC 05:36:59.1-71:18:01.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38427,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38427,18.29,0.06,0.0455,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1539, RA-DEC 05:18:22.1-69:21:47.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38428,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38428,18.29,0.06,0.0455,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1722, RA-DEC 05:21:56.1-69:20:55.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38429,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38429,18.29,0.06,0.0456,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4207, RA-DEC 05:37:03.7-70:59:02.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38430,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38430,18.3,0.06,0.0456,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3318, RA-DEC 05:57:34.4-69:12:11.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38431,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38431,18.3,0.06,0.0457,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3932, RA-DEC 05:22:37.1-66:07:28.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38432,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38432,18.3,0.06,0.0457,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4434, RA-DEC 05:49:03.4-67:22:18.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38433,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38433,18.3,0.06,0.0457,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4386, RA-DEC 05:46:49.9-67:10:34.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38434,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38434,18.3,0.06,0.0457,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3049, RA-DEC 05:43:58.9-69:29:14.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38435,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38435,18.3,0.13,0.0457,10597,NULL,NULL,'HV 2549, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38436,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38436,18.3,0.04,0.0457,10597,NULL,NULL,NULL,'LMC',NULL,'2003AJ....125.1261D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38437,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38437,18.3,0.07,0.0457,10597,NULL,NULL,'NGC 1866, 6, JK','LMC',NULL,'2005A&A...440..487S',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38438,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38438,18.3,0.06,0.0457,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3445, RA-DEC 04:53:26.6-71:54:58.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38439,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38439,18.3,0.06,0.0457,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3163, RA-DEC 05:46:43.2-67:48:19.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38440,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38440,18.3,0.06,0.0458,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2166, RA-DEC 05:30:00.7-70:50:10.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38441,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38441,18.3,0.06,0.0458,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2387, RA-DEC 05:33:42.5-70:59:15.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38442,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38442,18.3,0.06,0.0458,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2833, RA-DEC 05:39:55.0-71:25:27.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38443,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38443,18.3,0.06,0.0458,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2741, RA-DEC 05:38:40.5-70:06:38.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38444,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38444,18.3,0.06,0.0458,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2132, RA-DEC 05:29:21.4-69:27:59.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38445,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38445,18.3,0.06,0.0458,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3007, RA-DEC 05:42:48.0-71:17:30.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38446,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38446,18.31,0.06,0.0458,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4194, RA-DEC 05:36:30.6-66:36:33.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38447,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38447,18.31,0.06,0.0458,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1827, RA-DEC 05:23:15.9-69:53:58.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38448,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38448,18.31,0.06,0.0459,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1557, RA-DEC 05:18:45.6-69:06:32.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38449,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38449,18.31,0.06,0.0459,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3319, RA-DEC 05:57:34.5-69:11:33.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38450,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38450,18.31,0.06,0.0459,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3975, RA-DEC 05:25:20.7-64:36:38.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38451,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38451,18.31,0.06,0.0459,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1079, RA-DEC 05:08:43.6-69:08:26.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38452,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38452,18.31,0.06,0.0459,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3226, RA-DEC 05:49:05.5-69:19:20.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38453,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38453,18.31,0.06,0.0459,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1613, RA-DEC 05:19:57.0-69:39:14.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38454,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38454,18.31,0.1,0.0459,10597,NULL,NULL,'HV 5655, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38455,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38455,18.31,0.03,0.0459,10597,NULL,NULL,'NGC 1866, HV 12198','LMC',NULL,'2005A&A...440..487S',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38456,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38456,18.31,0.06,0.0459,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2719, RA-DEC 05:38:20.3-70:11:40.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38457,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38457,18.31,0.06,0.046,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3815, RA-DEC 05:16:39.4-64:58:39.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38458,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38458,18.31,0.06,0.046,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4592, RA-DEC 06:10:12.9-68:05:14.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38459,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38459,18.31,0.06,0.046,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0072, RA-DEC 04:46:32.8-68:44:57.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38460,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38460,18.31,0.06,0.046,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3247, RA-DEC 05:50:08.0-69:54:36.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38461,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38461,18.31,0.09,0.046,10597,NULL,NULL,'BW','LMC',NULL,'1997PhDT........18K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38462,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38462,18.32,0.06,0.046,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4184, RA-DEC 05:36:01.8-62:55:35.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38463,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38463,18.32,0.06,0.0461,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1111, RA-DEC 05:09:18.0-69:17:56.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38464,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38464,18.32,0.06,0.0461,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3912, RA-DEC 05:21:58.6-66:15:32.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38465,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38465,18.32,0.06,0.0461,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2259, RA-DEC 05:31:27.4-71:10:05.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38466,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38466,18.32,0.06,0.0461,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4349, RA-DEC 05:44:55.6-67:04:48.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38467,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38467,18.32,0.06,0.0461,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1422, RA-DEC 05:16:03.3-69:28:28.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38468,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38468,18.32,0.01,0.0461,10597,NULL,NULL,NULL,'LMC',NULL,'2003AJ....125.1261D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38469,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38469,18.32,0.2,0.0461,10597,NULL,NULL,'NGC 2031,','LMC',NULL,'1993ApJ...412..160B',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38470,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38470,18.32,0.06,0.0461,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3735, RA-DEC 05:13:37.9-65:27:41.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38471,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38471,18.32,0.06,0.0461,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4327, RA-DEC 05:43:45.4-67:05:58.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38472,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38472,18.32,0.06,0.0461,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3194, RA-DEC 05:47:35.2-70:51:27.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38473,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38473,18.32,0.06,0.0461,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3262, RA-DEC 05:51:05.2-69:58:30.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38474,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38474,18.32,0.06,0.0461,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4566, RA-DEC 06:01:30.4-65:06:42.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38475,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38475,18.32,0.06,0.0462,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3650, RA-DEC 05:10:21.7-64:46:51.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38476,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38476,18.32,0.06,0.0462,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4287, RA-DEC 05:41:47.9-67:13:57.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38477,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38477,18.32,0.06,0.0462,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4601, RA-DEC 06:12:23.1-68:10:03.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38478,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38478,18.32,0.06,0.0462,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1932, RA-DEC 05:25:24.1-69:44:57.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38479,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38479,18.32,0.05,0.0462,10597,NULL,NULL,'HV 2257, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38480,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38480,18.32,0.06,0.0462,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1908, RA-DEC 05:24:55.2-69:29:32.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38481,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38481,18.32,0.06,0.0462,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3600, RA-DEC 05:07:25.0-66:24:00.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38482,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38482,18.33,0.06,0.0463,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2490, RA-DEC 05:35:30.8-69:58:05.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38483,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38483,18.33,0.06,0.0463,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2171, RA-DEC 05:30:04.7-70:38:46.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38484,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38484,18.33,0.06,0.0463,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3524, RA-DEC 05:02:04.5-66:34:01.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38485,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38485,18.33,0.06,0.0463,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2086, RA-DEC 05:28:23.1-69:52:03.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38486,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38486,18.33,0.06,0.0463,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4596, RA-DEC 06:10:25.2-67:20:14.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38487,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38487,18.33,0.06,0.0463,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3306, RA-DEC 05:55:53.0-70:09:38.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38488,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38488,18.33,0.06,0.0463,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2832, RA-DEC 05:39:53.6-67:50:08.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38489,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38489,18.33,0.06,0.0463,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4473, RA-DEC 05:50:59.3-63:13:45.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38490,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38490,18.33,0.06,0.0463,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4589, RA-DEC 06:08:28.5-68:45:38.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38491,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38491,18.33,0.06,0.0463,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4541, RA-DEC 05:57:11.1-65:51:16.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38492,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38492,18.33,0.06,0.0463,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1974, RA-DEC 05:25:59.2-69:49:14.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38493,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38493,18.33,0.06,0.0463,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3948, RA-DEC 05:23:49.2-67:00:18.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38494,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38494,18.33,0.06,0.0463,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3800, RA-DEC 05:16:03.8-64:59:57.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38495,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38495,18.33,0.06,0.0463,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4132, RA-DEC 05:32:59.3-65:32:26.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38496,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38496,18.33,0.06,0.0463,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4583, RA-DEC 06:06:49.3-67:49:11.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38497,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38497,18.33,0.06,0.0463,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4454, RA-DEC 05:49:45.7-64:14:38.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38498,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38498,18.33,0.06,0.0464,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4213, RA-DEC 05:37:30.3-64:41:06.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38499,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38499,18.33,0.06,0.0464,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0516, RA-DEC 04:58:15.5-68:08:38.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38500,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38500,18.33,0.06,0.0464,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3331, RA-DEC 05:58:52.5-69:10:13.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38501,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38501,18.33,0.06,0.0464,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3691, RA-DEC 05:12:04.8-65:14:32.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38502,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38502,18.33,0.06,0.0464,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1249, RA-DEC 05:12:47.0-69:06:08.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38503,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38503,18.33,0.06,0.0464,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1963, RA-DEC 05:25:44.5-69:49:46.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38504,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38504,18.33,0.06,0.0464,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2911, RA-DEC 05:41:10.5-68:25:46.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38505,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38505,18.33,0.06,0.0464,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3891, RA-DEC 05:20:55.5-66:39:43.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38506,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38506,18.33,0.06,0.0464,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4416, RA-DEC 05:48:11.2-67:26:39.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38507,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38507,18.33,0.06,0.0464,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2603, RA-DEC 05:36:54.7-70:08:10.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38508,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38508,18.33,0.06,0.0464,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1112, RA-DEC 05:09:18.4-68:17:58.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38509,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38509,18.33,0.06,0.0464,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2676, RA-DEC 05:37:44.0-69:59:06.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38510,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38510,18.33,0.06,0.0464,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3201, RA-DEC 05:48:03.2-70:43:04.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38511,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38511,18.33,0.06,0.0464,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4419, RA-DEC 05:48:13.7-67:33:02.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38512,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38512,18.33,0.06,0.0464,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4557, RA-DEC 05:59:58.1-67:40:57.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38513,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38513,18.33,0.06,0.0465,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4181, RA-DEC 05:35:55.0-66:47:34.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38514,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38514,18.33,0.06,0.0465,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4549, RA-DEC 05:58:53.4-67:05:54.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38515,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38515,18.34,0.06,0.0465,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2755, RA-DEC 05:38:50.6-70:29:39.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38516,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38516,18.34,0.06,0.0465,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0935, RA-DEC 05:06:00.9-69:06:17.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38517,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38517,18.34,0.06,0.0465,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4112, RA-DEC 05:32:31.5-66:47:25.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38518,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38518,18.34,0.06,0.0465,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4570, RA-DEC 06:03:18.8-66:52:44.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38519,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38519,18.34,0.06,0.0465,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2065, RA-DEC 05:27:54.8-71:51:54.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38520,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38520,18.34,0.06,0.0465,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3119, RA-DEC 05:45:42.5-67:53:23.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38521,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38521,18.34,0.06,0.0465,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1794, RA-DEC 05:22:51.9-69:47:30.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38522,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38522,18.34,0.06,0.0465,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4391, RA-DEC 05:47:08.6-68:17:02.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38523,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38523,18.34,0.06,0.0465,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3315, RA-DEC 05:57:29.0-69:11:25.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38524,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38524,18.34,0.06,0.0466,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4578, RA-DEC 06:05:32.2-66:56:38.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38525,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38525,18.34,0.06,0.0466,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3611, RA-DEC 05:08:02.2-71:57:38.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38526,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38526,18.34,0.06,0.0466,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3316, RA-DEC 05:57:33.0-69:11:46.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38527,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38527,18.34,0.06,0.0466,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3755, RA-DEC 05:14:16.6-71:25:56.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38528,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38528,18.34,0.06,0.0466,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2924, RA-DEC 05:41:17.4-70:16:38.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38529,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38529,18.34,0.06,0.0466,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4072, RA-DEC 05:30:10.9-66:30:37.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38530,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38530,18.34,0.06,0.0466,10597,NULL,NULL,NULL,'LMC',NULL,'2007ApJ...671.1640A',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38531,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38531,18.34,0.09,0.0466,10597,NULL,NULL,'NGC 1866, HV 12199','LMC',NULL,'2005A&A...440..487S',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38532,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38532,18.34,0.06,0.0466,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4427, RA-DEC 05:48:46.1-67:31:33.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38533,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38533,18.34,0.06,0.0466,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4559, RA-DEC 06:00:21.9-67:38:05.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38534,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38534,18.34,0.06,0.0466,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0432, RA-DEC 04:56:24.4-69:18:57.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38535,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38535,18.34,0.06,0.0466,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2925, RA-DEC 05:41:17.9-70:44:23.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38536,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38536,18.34,0.06,0.0467,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3240, RA-DEC 05:49:48.7-69:43:15.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38537,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38537,18.34,0.06,0.0467,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4120, RA-DEC 05:32:52.0-67:25:32.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38538,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38538,18.34,0.06,0.0467,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4409, RA-DEC 05:47:56.3-67:58:35.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38539,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38539,18.35,0.06,0.0467,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3863, RA-DEC 05:19:20.3-66:10:51.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38540,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38540,18.35,0.06,0.0467,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4178, RA-DEC 05:35:41.7-67:11:58.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38541,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38541,18.35,0.06,0.0467,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4526, RA-DEC 05:55:50.7-67:49:41.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38542,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38542,18.35,0.06,0.0467,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1982, RA-DEC 05:26:05.7-68:59:43.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38543,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38543,18.34,0.07,0.0467,10597,NULL,NULL,'HV 12505, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38544,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38544,18.35,0.06,0.0467,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0445, RA-DEC 04:56:40.1-68:40:22.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38545,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38545,18.35,0.06,0.0467,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4129, RA-DEC 05:32:57.5-66:44:41.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38546,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38546,18.35,0.06,0.0467,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4495, RA-DEC 05:52:23.1-66:31:30.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38547,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38547,18.35,0.06,0.0467,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4331, RA-DEC 05:43:57.5-65:26:18.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38548,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38548,18.35,0.06,0.0467,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3864, RA-DEC 05:19:21.2-67:06:49.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38549,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38549,18.35,0.06,0.0467,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4118, RA-DEC 05:32:47.2-66:15:44.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38550,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38550,18.35,0.06,0.0468,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0712, RA-DEC 05:01:54.6-68:54:14.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38551,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38551,18.35,0.06,0.0468,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1173, RA-DEC 05:10:45.2-69:06:28.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38552,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38552,18.35,0.06,0.0468,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1809, RA-DEC 05:23:04.8-69:30:21.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38553,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38553,18.35,0.06,0.0468,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3396, RA-DEC 04:46:08.5-69:02:47.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38554,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38554,18.35,0.06,0.0468,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2699, RA-DEC 05:38:07.7-69:56:22.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38555,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38555,18.35,0.06,0.0468,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2812, RA-DEC 05:39:38.4-70:23:19.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38556,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38556,18.35,0.06,0.0468,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2941, RA-DEC 05:41:34.6-70:50:53.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38557,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38557,18.35,0.06,0.0468,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3880, RA-DEC 05:20:23.2-64:08:11.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38558,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38558,18.35,0.13,0.0468,10597,NULL,NULL,'Hipparcos','LMC',NULL,'1999ASPC..167...33L',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38559,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38559,18.35,0.03,0.0468,10597,NULL,NULL,'MW GFG','LMC',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38560,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38560,18.35,0.06,0.0468,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1508, RA-DEC 05:17:50.0-69:28:29.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38561,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38561,18.35,0.06,0.0468,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0923, RA-DEC 05:05:50.9-67:31:38.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38562,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38562,18.35,0.06,0.0468,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4400, RA-DEC 05:47:34.8-67:14:51.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38563,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38563,18.35,0.06,0.0468,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2015, RA-DEC 05:26:53.6-68:24:46.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38564,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38564,18.35,0.06,0.0468,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2973, RA-DEC 05:42:12.1-71:12:08.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38565,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38565,18.35,0.06,0.0468,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2418, RA-DEC 05:34:07.5-68:43:36.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38566,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38566,18.35,0.06,0.0469,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0527, RA-DEC 04:58:31.8-68:59:07.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38567,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38567,18.35,0.06,0.0469,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2050, RA-DEC 05:27:34.0-69:51:22.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38568,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38568,18.35,0.06,0.0469,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4594, RA-DEC 06:10:21.8-68:25:38.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38569,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38569,18.35,0.06,0.0469,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3149, RA-DEC 05:46:24.4-71:06:35.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38570,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38570,18.35,0.06,0.0469,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1278, RA-DEC 05:13:37.7-67:12:41.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38571,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38571,18.35,0.06,0.0469,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3806, RA-DEC 05:16:17.1-66:18:57.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38572,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38572,18.35,0.06,0.0469,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3924, RA-DEC 05:22:24.0-66:39:14.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38573,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38573,18.36,0.06,0.0469,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4488, RA-DEC 05:52:07.7-68:11:07.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38574,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38574,18.36,0.06,0.0469,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0724, RA-DEC 05:02:09.8-68:51:31.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38575,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38575,18.36,0.06,0.0469,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2101, RA-DEC 05:28:37.4-69:40:55.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38576,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38576,18.36,0.06,0.0469,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3228, RA-DEC 05:49:13.6-69:22:40.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38577,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38577,18.36,0.06,0.0469,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3687, RA-DEC 05:11:57.2-66:11:38.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38578,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38578,18.36,0.06,0.0469,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3811, RA-DEC 05:16:26.7-65:28:56.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38579,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38579,18.36,0.06,0.0469,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4619, RA-DEC 06:21:24.6-69:27:56.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38580,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38580,18.36,0.06,0.0469,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3843, RA-DEC 05:17:59.2-74:34:25.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38581,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38581,18.36,0.06,0.0469,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1665, RA-DEC 05:20:55.0-69:09:55.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38582,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38582,18.36,0.06,0.0469,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4442, RA-DEC 05:49:18.9-67:22:10.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38583,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38583,18.36,0.06,0.0469,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1073, RA-DEC 05:08:33.5-70:26:53.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38584,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38584,18.36,0.06,0.0469,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1326, RA-DEC 05:14:41.6-70:58:11.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38585,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38585,18.36,0.06,0.0469,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4467, RA-DEC 05:50:27.2-67:11:00.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38586,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38586,18.36,0.06,0.047,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2744, RA-DEC 05:38:43.4-70:38:45.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38587,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38587,18.36,0.06,0.047,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3293, RA-DEC 05:53:35.4-69:32:06.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38588,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38588,18.36,0.06,0.047,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3175, RA-DEC 05:47:12.5-70:41:12.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38589,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38589,18.36,0.06,0.047,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3213, RA-DEC 05:48:32.2-70:24:50.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38590,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38590,18.36,0.06,0.047,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4199, RA-DEC 05:36:43.7-67:35:03.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38591,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38591,18.36,0.06,0.047,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4235, RA-DEC 05:38:36.2-66:07:33.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38592,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38592,18.36,0.06,0.047,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1252, RA-DEC 05:12:49.8-69:00:50.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38593,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38593,18.36,0.06,0.047,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2746, RA-DEC 05:38:45.5-70:36:11.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38594,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38594,18.36,0.06,0.047,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4406, RA-DEC 05:47:49.5-67:16:53.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38595,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38595,18.36,0.06,0.047,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4499, RA-DEC 05:52:40.0-68:14:26.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38596,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38596,18.36,0.03,0.047,10597,NULL,NULL,'947, VI','LMC',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38597,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38597,18.36,0.06,0.047,10597,NULL,NULL,'10, W, ISB, Z','LMC',NULL,'2007A&A...476..863F',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38598,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38598,18.36,0.06,0.047,10597,NULL,NULL,'NGC 1866, HV 12197, New PL','LMC',NULL,'2006MmSAI..77..261S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38599,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38599,18.36,0.15,0.047,10597,NULL,NULL,'HV 12816, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38600,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38600,18.36,0.06,0.047,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1143, RA-DEC 05:10:01.9-69:07:44.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38601,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38601,18.36,0.06,0.047,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3216, RA-DEC 05:48:39.9-69:57:34.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38602,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38602,18.36,0.06,0.047,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3459, RA-DEC 04:54:41.4-71:48:10.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38603,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38603,18.36,0.06,0.047,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4491, RA-DEC 05:52:13.6-67:17:53.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38604,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38604,18.36,0.06,0.047,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0832, RA-DEC 05:03:58.2-69:25:38.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38605,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38605,18.36,0.06,0.047,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4317, RA-DEC 05:43:13.4-67:27:48.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38606,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38606,18.36,0.06,0.047,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4328, RA-DEC 05:43:45.8-66:13:32.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38607,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38607,18.36,0.06,0.047,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1604, RA-DEC 05:19:41.1-69:23:49.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38608,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38608,18.36,0.06,0.047,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0103, RA-DEC 04:48:35.6-67:35:00.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38609,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38609,18.36,0.06,0.047,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1942, RA-DEC 05:25:30.3-69:52:15.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38610,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38610,18.36,0.06,0.0471,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3913, RA-DEC 05:21:59.0-66:08:20.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38611,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38611,18.36,0.06,0.0471,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4200, RA-DEC 05:36:44.8-65:41:40.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38612,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38612,18.36,0.06,0.0471,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3025, RA-DEC 05:43:07.6-71:20:07.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38613,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38613,18.36,0.06,0.0471,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3686, RA-DEC 05:11:56.3-66:16:49.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38614,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38614,18.36,0.06,0.0471,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4340, RA-DEC 05:44:31.1-66:12:18.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38615,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38615,18.36,0.06,0.0471,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1952, RA-DEC 05:25:35.4-71:08:06.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38616,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38616,18.36,0.06,0.0471,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1535, RA-DEC 05:18:10.0-69:50:55.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38617,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38617,18.37,0.06,0.0471,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0963, RA-DEC 05:06:39.9-68:25:12.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38618,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38618,18.37,0.06,0.0471,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3780, RA-DEC 05:15:31.5-66:07:39.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38619,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38619,18.37,0.06,0.0471,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4556, RA-DEC 05:59:44.3-67:30:49.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38620,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38620,18.37,0.06,0.0471,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2034, RA-DEC 05:27:11.9-69:18:17.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38621,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38621,18.37,0.06,0.0471,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3651, RA-DEC 05:10:23.8-66:24:35.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38622,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38622,18.37,0.06,0.0471,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2595, RA-DEC 05:36:53.4-70:09:43.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38623,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38623,18.37,0.06,0.0471,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3324, RA-DEC 05:58:06.1-69:16:32.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38624,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38624,18.37,0.06,0.0471,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2246, RA-DEC 05:31:15.7-71:52:12.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38625,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38625,18.37,0.06,0.0471,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2249, RA-DEC 05:31:17.5-69:54:28.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38626,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38626,18.37,0.06,0.0471,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3192, RA-DEC 05:47:34.6-70:05:11.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38627,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38627,18.37,0.06,0.0472,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1484, RA-DEC 05:17:18.1-69:32:59.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38628,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38628,18.37,0.06,0.0472,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2643, RA-DEC 05:37:27.5-71:33:07.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38629,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38629,18.37,0.06,0.0472,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3133, RA-DEC 05:46:06.6-70:11:49.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38630,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38630,18.37,0.06,0.0472,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1215, RA-DEC 05:11:56.6-69:12:11.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38631,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38631,18.37,0.06,0.0472,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2268, RA-DEC 05:31:42.6-70:26:08.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38632,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38632,18.37,0.06,0.0472,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4402, RA-DEC 05:47:39.3-66:58:03.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38633,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38633,18.37,0.06,0.0472,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1727, RA-DEC 05:22:01.1-68:51:32.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38634,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38634,18.37,0.06,0.0472,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2461, RA-DEC 05:34:59.4-71:12:33.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38635,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38635,18.37,0.06,0.0472,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4094, RA-DEC 05:31:17.4-67:17:09.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38636,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38636,18.37,0.06,0.0472,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4486, RA-DEC 05:52:05.6-66:53:14.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38637,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38637,18.37,0.06,0.0472,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3443, RA-DEC 04:53:10.1-70:53:41.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38638,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38638,18.37,0.14,0.0472,10597,NULL,NULL,'MW P02','LMC',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38639,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38639,18.37,NULL,0.0472,10597,NULL,NULL,'MW HIPP','LMC',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38640,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,NULL,38640,18.37,0.02,0.0472,10597,NULL,NULL,'36, K, Baade-Wesselink, Storm et al. method','LMC',NULL,'2013A&A...550A..70G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38641,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38641,18.37,0.06,0.0472,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2147, RA-DEC 05:29:35.6-70:02:57.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38642,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38642,18.37,0.06,0.0472,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3110, RA-DEC 05:45:32.0-67:46:56.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38643,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38643,18.37,0.06,0.0472,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3693, RA-DEC 05:12:14.6-65:40:17.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38644,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38644,18.37,0.06,0.0472,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4121, RA-DEC 05:32:52.2-66:47:51.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38645,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38645,18.37,0.06,0.0472,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4170, RA-DEC 05:35:17.0-65:12:07.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38646,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38646,18.37,0.06,0.0472,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0271, RA-DEC 04:53:10.3-70:13:08.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38647,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38647,18.37,0.06,0.0472,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4411, RA-DEC 05:48:00.1-67:55:14.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38648,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38648,18.37,0.06,0.0472,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4460, RA-DEC 05:50:06.8-67:21:21.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38649,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38649,18.37,0.06,0.0472,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2241, RA-DEC 05:31:08.9-70:05:15.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38650,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38650,18.37,0.06,0.0472,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2758, RA-DEC 05:38:51.4-70:29:36.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38651,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38651,18.37,0.06,0.0472,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3866, RA-DEC 05:19:27.6-66:06:24.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38652,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38652,18.37,0.06,0.0472,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4038, RA-DEC 05:28:21.5-65:15:48.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38653,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38653,18.37,0.06,0.0472,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4561, RA-DEC 06:00:35.2-67:36:13.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38654,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38654,18.37,0.06,0.0472,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2182, RA-DEC 05:30:16.5-70:49:29.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38655,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38655,18.37,0.06,0.0472,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4092, RA-DEC 05:31:11.2-65:32:36.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38656,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38656,18.37,0.06,0.0472,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4431, RA-DEC 05:48:57.1-65:36:42.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38657,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38657,18.37,0.06,0.0473,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0372, RA-DEC 04:55:11.1-71:01:38.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38658,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38658,18.37,0.06,0.0473,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2691, RA-DEC 05:37:59.0-69:55:27.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38659,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38659,18.37,0.06,0.0473,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0545, RA-DEC 04:58:47.1-70:03:41.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38660,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38660,18.37,0.06,0.0473,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2610, RA-DEC 05:36:58.7-71:05:33.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38661,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38661,18.37,0.06,0.0473,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3814, RA-DEC 05:16:36.0-66:07:50.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38662,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38662,18.37,0.06,0.0473,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4256, RA-DEC 05:40:06.3-66:52:22.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38663,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38663,18.37,0.06,0.0473,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4324, RA-DEC 05:43:35.2-67:18:48.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38664,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38664,18.37,0.06,0.0473,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0414, RA-DEC 04:55:58.9-66:37:19.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38665,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38665,18.37,0.06,0.0473,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1909, RA-DEC 05:24:55.9-69:43:52.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38666,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38666,18.37,0.06,0.0473,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4151, RA-DEC 05:34:09.0-65:10:29.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38667,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38667,18.37,0.06,0.0473,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0358, RA-DEC 04:54:56.2-68:42:15.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38668,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38668,18.37,0.06,0.0473,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1931, RA-DEC 05:25:23.7-70:26:36.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38669,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38669,18.37,0.06,0.0473,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2778, RA-DEC 05:39:13.4-70:09:37.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38670,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38670,18.37,0.16,0.0473,10597,NULL,NULL,'HV 6093, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38671,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38671,18.37,0.06,0.0473,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3032, RA-DEC 05:43:13.9-71:03:13.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38672,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38672,18.37,0.06,0.0473,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4100, RA-DEC 05:31:35.9-64:00:04.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38673,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38673,18.37,0.06,0.0473,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4408, RA-DEC 05:47:55.6-67:29:26.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38674,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38674,18.37,0.06,0.0473,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4509, RA-DEC 05:54:12.5-65:04:05.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38675,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38675,18.38,0.06,0.0473,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3012, RA-DEC 05:42:50.0-70:42:36.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38676,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38676,18.38,0.06,0.0473,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3301, RA-DEC 05:54:27.4-69:55:30.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38677,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38677,18.38,0.06,0.0473,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2329, RA-DEC 05:32:52.4-71:25:57.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38678,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38678,18.38,0.06,0.0473,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3709, RA-DEC 05:12:46.3-65:26:43.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38679,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38679,18.38,0.06,0.0473,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4262, RA-DEC 05:40:23.7-67:26:29.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38680,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38680,18.38,0.06,0.0473,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1717, RA-DEC 05:21:54.6-69:23:05.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38681,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38681,18.38,0.06,0.0473,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1888, RA-DEC 05:24:34.9-69:44:19.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38682,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38682,18.38,0.06,0.0473,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3123, RA-DEC 05:45:46.0-69:00:20.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38683,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38683,18.38,0.06,0.0473,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4438, RA-DEC 05:49:08.9-67:46:46.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38684,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38684,18.38,0.06,0.0473,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4445, RA-DEC 05:49:22.0-68:05:21.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38685,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38685,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0433, RA-DEC 04:56:25.8-67:53:17.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38686,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38686,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1657, RA-DEC 05:20:46.5-69:55:25.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38687,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38687,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3348, RA-DEC 06:05:46.0-73:00:30.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38688,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38688,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3679, RA-DEC 05:11:35.2-66:26:14.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38689,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38689,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2224, RA-DEC 05:30:57.5-71:49:01.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38690,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38690,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2575, RA-DEC 05:36:39.2-67:59:46.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38691,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38691,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1619, RA-DEC 05:20:03.5-69:25:01.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38692,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38692,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1977, RA-DEC 05:26:00.3-70:36:48.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38693,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38693,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3296, RA-DEC 05:54:01.1-69:50:24.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38694,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38694,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4105, RA-DEC 05:31:52.5-64:55:40.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38695,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38695,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2037, RA-DEC 05:27:15.8-69:43:43.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38696,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38696,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3732, RA-DEC 05:13:37.3-65:56:58.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38697,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38697,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3835, RA-DEC 05:17:42.4-66:38:53.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38698,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38698,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4155, RA-DEC 05:34:14.3-65:14:25.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38699,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38699,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0776, RA-DEC 05:02:57.2-68:41:43.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38700,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38700,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4111, RA-DEC 05:32:27.6-65:29:35.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38701,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38701,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4198, RA-DEC 05:36:42.4-67:40:30.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38702,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38702,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2111, RA-DEC 05:28:47.2-71:53:16.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38703,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38703,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3342, RA-DEC 06:04:42.5-68:32:09.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38704,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38704,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3682, RA-DEC 05:11:50.8-66:10:14.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38705,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38705,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4018, RA-DEC 05:27:31.1-66:30:30.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38706,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38706,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4482, RA-DEC 05:51:47.3-63:41:05.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38707,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38707,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1904, RA-DEC 05:24:45.3-69:42:00.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38708,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38708,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4255, RA-DEC 05:40:03.9-67:23:52.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38709,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38709,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2753, RA-DEC 05:38:49.6-70:01:10.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38710,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38710,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3892, RA-DEC 05:20:56.9-65:54:40.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38711,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38711,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4413, RA-DEC 05:48:03.1-67:12:28.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38712,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38712,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4443, RA-DEC 05:49:19.1-67:13:49.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38713,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38713,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0540, RA-DEC 04:58:41.4-69:31:32.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38714,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38714,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1175, RA-DEC 05:10:49.7-66:51:15.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38715,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38715,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1352, RA-DEC 05:15:09.6-66:44:32.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38716,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38716,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3812, RA-DEC 05:16:31.7-65:59:05.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38717,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38717,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4169, RA-DEC 05:35:06.6-65:16:08.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38718,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38718,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1695, RA-DEC 05:21:32.1-69:50:31.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38719,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38719,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3173, RA-DEC 05:47:09.8-69:27:20.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38720,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38720,18.38,0.06,0.0474,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3970, RA-DEC 05:25:06.4-63:51:36.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38721,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38721,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0418, RA-DEC 04:56:06.1-68:48:25.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38722,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38722,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1927, RA-DEC 05:25:21.4-69:49:01.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (38723,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38723,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2521, RA-DEC 05:35:53.3-71:15:36.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38724,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38724,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4394, RA-DEC 05:47:17.9-67:14:08.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38725,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38725,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0331, RA-DEC 04:54:28.1-68:29:54.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38726,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38726,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0819, RA-DEC 05:03:46.2-68:52:36.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38727,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38727,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3768, RA-DEC 05:14:43.7-66:15:33.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38728,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38728,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0638, RA-DEC 05:00:34.6-66:59:06.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38729,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38729,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3101, RA-DEC 05:45:16.3-70:46:35.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38730,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38730,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3947, RA-DEC 05:23:45.7-65:54:25.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38731,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38731,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2174, RA-DEC 05:30:11.1-71:46:05.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38732,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38732,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2448, RA-DEC 05:34:40.1-68:06:40.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38733,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38733,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2194, RA-DEC 05:30:33.4-70:05:09.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38734,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38734,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3097, RA-DEC 05:45:01.8-69:29:32.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38735,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38735,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4469, RA-DEC 05:50:30.8-66:42:05.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38736,'Cepheids','2016-12-15 15:14:06','2016-12-16 11:19:11','1',NULL,'R',38736,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1276, RA-DEC 05:13:33.7-68:57:07.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38737,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38737,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2811, RA-DEC 05:39:35.0-70:41:17.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38738,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38738,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4249, RA-DEC 05:39:47.7-67:22:23.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38739,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38739,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4315, RA-DEC 05:43:03.4-67:04:35.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38740,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38740,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1105, RA-DEC 05:09:08.0-68:56:42.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38741,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38741,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1587, RA-DEC 05:19:27.8-69:30:30.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38742,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38742,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3690, RA-DEC 05:12:04.5-66:27:46.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38743,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38743,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4179, RA-DEC 05:35:51.5-66:10:00.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38744,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38744,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4424, RA-DEC 05:48:27.0-67:22:06.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38745,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38745,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4470, RA-DEC 05:50:41.8-67:10:31.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38746,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38746,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4536, RA-DEC 05:56:56.8-67:39:27.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38747,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38747,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0310, RA-DEC 04:54:01.5-70:13:26.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38748,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38748,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1337, RA-DEC 05:14:54.1-69:03:15.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38749,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38749,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2410, RA-DEC 05:34:00.4-70:10:15.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38750,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38750,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2596, RA-DEC 05:36:53.7-70:06:24.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38751,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38751,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3307, RA-DEC 05:55:54.9-68:30:12.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38752,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38752,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3788, RA-DEC 05:15:51.9-66:04:15.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38753,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38753,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4152, RA-DEC 05:34:09.4-66:48:43.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38754,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38754,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4461, RA-DEC 05:50:09.5-67:49:34.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38755,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38755,18.38,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4483, RA-DEC 05:51:51.0-66:01:37.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38756,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38756,18.39,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1328, RA-DEC 05:14:42.6-69:30:56.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38757,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38757,18.39,0.06,0.0475,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1930, RA-DEC 05:25:23.4-69:52:32.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38758,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38758,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2678, RA-DEC 05:37:47.0-70:51:43.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38759,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38759,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4156, RA-DEC 05:34:17.9-67:15:04.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38760,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38760,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4353, RA-DEC 05:45:01.6-66:05:32.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38761,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38761,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4422, RA-DEC 05:48:20.9-67:05:28.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38762,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38762,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4587, RA-DEC 06:08:00.8-65:52:16.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38763,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38763,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1707, RA-DEC 05:21:48.3-70:30:25.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38764,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38764,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2002, RA-DEC 05:26:33.4-70:06:56.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38765,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38765,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4128, RA-DEC 05:32:57.0-66:47:48.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38766,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38766,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4298, RA-DEC 05:42:14.6-69:35:00.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38767,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38767,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1262, RA-DEC 05:13:10.3-69:06:54.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38768,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38768,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2017, RA-DEC 05:26:55.5-70:01:04.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38769,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38769,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4500, RA-DEC 05:52:40.8-67:15:20.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38770,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38770,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4576, RA-DEC 06:05:05.7-67:19:56.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38771,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38771,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1080, RA-DEC 05:08:44.0-68:45:28.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38772,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38772,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2853, RA-DEC 05:40:12.7-69:57:39.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38773,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38773,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4176, RA-DEC 05:35:36.1-67:15:56.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38774,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38774,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4598, RA-DEC 06:11:24.6-66:47:21.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38775,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38775,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1237, RA-DEC 05:12:26.1-69:13:56.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38776,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38776,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1507, RA-DEC 05:17:49.3-70:26:38.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38777,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38777,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2390, RA-DEC 05:33:44.0-68:22:22.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38778,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38778,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2771, RA-DEC 05:39:03.9-70:18:35.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38779,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38779,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3137, RA-DEC 05:46:10.8-71:00:06.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38780,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38780,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3355, RA-DEC 06:10:41.6-71:31:43.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38781,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,NULL,38781,18.39,0.09,0.0476,10597,NULL,NULL,'VI','LMC',NULL,'2008MNRAS.390.1539M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38782,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,NULL,38782,18.39,0.05,0.0476,10597,NULL,NULL,'LMC SC3-360128','LMC',NULL,'2005A&A...434.1077M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38783,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,NULL,38783,18.39,0.05,0.0476,10597,NULL,NULL,'VI, Z','LMC',NULL,'2007MNRAS.379..723V',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38784,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,NULL,38784,18.39,0.05,0.0476,10597,NULL,NULL,'VI+Z, GAL+LMC PL','LMC',NULL,'2007MNRAS.379..723V',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38785,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38785,18.39,0.05,0.0476,10597,NULL,NULL,NULL,'LMC',NULL,'2010vsgh.conf...45F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38786,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38786,18.39,0.03,0.0476,10597,NULL,NULL,'(Galactic + LMC) VI Wesenheit, Z','LMC',NULL,'2010ARA&A..48..673F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38787,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38787,18.39,0.04,0.0476,10597,NULL,NULL,'NGC 1866, HV 12204, New PL','LMC',NULL,'2006MmSAI..77..261S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38788,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38788,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3298, RA-DEC 05:54:09.1-68:51:52.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38789,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38789,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4297, RA-DEC 05:42:12.6-64:13:50.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38790,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38790,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4375, RA-DEC 05:46:17.9-65:26:03.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38791,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38791,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4396, RA-DEC 05:47:20.8-67:23:26.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38792,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38792,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0768, RA-DEC 05:02:50.3-68:14:12.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38793,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38793,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2779, RA-DEC 05:39:14.3-70:14:10.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38794,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38794,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3881, RA-DEC 05:20:24.2-65:56:37.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38795,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38795,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4076, RA-DEC 05:30:21.6-64:25:25.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38796,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38796,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4124, RA-DEC 05:32:53.7-65:28:51.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38797,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38797,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0978, RA-DEC 05:06:59.7-68:43:26.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38798,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38798,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1096, RA-DEC 05:08:57.6-68:50:59.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38799,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38799,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2119, RA-DEC 05:29:05.8-70:05:40.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38800,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38800,18.39,0.06,0.0476,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3345, RA-DEC 06:05:13.1-68:21:27.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38801,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38801,18.39,0.06,0.0477,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1742, RA-DEC 05:22:14.3-70:00:29.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38802,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38802,18.39,0.06,0.0477,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3044, RA-DEC 05:43:41.0-71:15:12.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38803,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38803,18.39,0.06,0.0477,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0550, RA-DEC 04:58:49.7-69:29:29.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38804,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38804,18.39,0.06,0.0477,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3834, RA-DEC 05:17:25.9-65:04:44.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38805,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38805,18.39,0.06,0.0477,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0836, RA-DEC 05:04:05.1-66:48:45.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38806,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38806,18.39,0.06,0.0477,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3791, RA-DEC 05:15:56.7-66:21:17.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38807,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38807,18.39,0.06,0.0477,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3827, RA-DEC 05:17:11.5-65:52:03.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38808,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38808,18.39,0.06,0.0477,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1887, RA-DEC 05:24:33.9-69:54:48.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38809,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38809,18.39,0.06,0.0477,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3647, RA-DEC 05:10:18.5-66:22:47.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38810,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38810,18.39,0.06,0.0477,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4423, RA-DEC 05:48:25.7-67:36:23.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38811,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38811,18.39,0.06,0.0477,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3176, RA-DEC 05:47:15.7-70:39:17.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38812,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38812,18.39,0.06,0.0477,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4387, RA-DEC 05:46:49.9-67:30:10.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38813,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38813,18.39,0.06,0.0477,10597,NULL,NULL,'HV 899, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38814,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38814,18.39,0.06,0.0477,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4231, RA-DEC 05:38:24.9-64:57:49.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38815,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38815,18.39,0.06,0.0477,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4383, RA-DEC 05:46:42.7-67:00:28.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38816,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38816,18.39,0.06,0.0477,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0690, RA-DEC 05:01:32.4-67:06:40.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38817,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38817,18.39,0.06,0.0477,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1268, RA-DEC 05:13:18.0-69:52:44.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38818,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38818,18.39,0.06,0.0477,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2763, RA-DEC 05:38:55.2-70:46:21.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38819,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38819,18.39,0.06,0.0477,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4115, RA-DEC 05:32:42.4-66:43:12.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38820,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38820,18.39,0.06,0.0477,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4293, RA-DEC 05:42:02.8-67:10:35.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38821,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38821,18.39,0.06,0.0477,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3818, RA-DEC 05:16:47.5-67:35:07.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38822,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38822,18.39,0.06,0.0477,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4418, RA-DEC 05:48:12.7-66:56:46.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38823,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38823,18.39,0.06,0.0477,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0319, RA-DEC 04:54:14.8-69:02:13.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38824,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38824,18.39,0.06,0.0477,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0915, RA-DEC 05:05:42.0-68:51:05.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38825,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38825,18.39,0.06,0.0477,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1088, RA-DEC 05:08:49.5-68:59:59.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38826,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38826,18.39,0.06,0.0477,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1857, RA-DEC 05:24:06.4-69:48:22.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38827,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38827,18.39,0.06,0.0477,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2543, RA-DEC 05:36:16.8-70:30:56.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38828,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38828,18.39,0.06,0.0477,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3766, RA-DEC 05:14:34.2-65:23:50.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38829,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38829,18.39,0.06,0.0477,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4379, RA-DEC 05:46:28.9-66:00:41.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38830,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38830,18.39,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0913, RA-DEC 05:05:41.0-67:14:45.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38831,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38831,18.39,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2039, RA-DEC 05:27:17.2-69:58:53.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38832,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38832,18.39,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2614, RA-DEC 05:36:59.2-69:57:14.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38833,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38833,18.39,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4073, RA-DEC 05:30:13.4-66:04:35.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38834,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38834,18.39,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4360, RA-DEC 05:45:23.3-66:04:53.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38835,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38835,18.39,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4551, RA-DEC 05:59:15.6-67:48:51.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38836,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38836,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1678, RA-DEC 05:21:15.0-69:49:33.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38837,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38837,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2319, RA-DEC 05:32:40.1-69:19:00.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38838,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38838,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3347, RA-DEC 06:05:40.2-69:33:49.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38839,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38839,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3954, RA-DEC 05:24:14.2-65:33:11.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38840,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38840,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4222, RA-DEC 05:38:04.3-66:35:37.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38841,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38841,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4519, RA-DEC 05:55:08.9-67:41:21.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38842,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38842,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1427, RA-DEC 05:16:06.6-69:28:25.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38843,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38843,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2003, RA-DEC 05:26:36.1-69:49:18.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38844,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38844,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3106, RA-DEC 05:45:22.2-70:50:10.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38845,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38845,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3824, RA-DEC 05:17:01.1-66:08:34.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38846,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38846,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3958, RA-DEC 05:24:30.1-66:29:38.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38847,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38847,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4257, RA-DEC 05:40:07.0-66:55:52.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38848,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38848,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0609, RA-DEC 05:00:01.7-67:17:11.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38849,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38849,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2898, RA-DEC 05:40:52.5-70:58:30.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38850,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38850,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2012, RA-DEC 05:26:50.0-69:45:52.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38851,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38851,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2623, RA-DEC 05:37:06.0-69:56:36.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38852,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38852,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3026, RA-DEC 05:43:08.5-71:38:13.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38853,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38853,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3819, RA-DEC 05:16:48.9-66:19:55.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38854,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38854,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4330, RA-DEC 05:43:56.4-67:30:25.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38855,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38855,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1040, RA-DEC 05:08:02.6-68:06:27.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38856,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38856,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3028, RA-DEC 05:43:10.5-69:28:10.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38857,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38857,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3165, RA-DEC 05:46:46.3-70:30:46.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38858,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38858,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3733, RA-DEC 05:13:37.5-65:28:00.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38859,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38859,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3820, RA-DEC 05:16:50.4-66:11:20.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38860,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38860,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4033, RA-DEC 05:28:15.6-67:03:58.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38861,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38861,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4243, RA-DEC 05:39:28.8-66:27:34.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38862,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38862,18.4,0.08,0.0478,10597,NULL,NULL,'HV 12198, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38863,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38863,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0459, RA-DEC 04:57:01.5-68:15:11.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38864,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38864,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1875, RA-DEC 05:24:25.5-69:46:19.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38865,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38865,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2884, RA-DEC 05:40:39.6-70:46:03.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38866,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38866,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3260, RA-DEC 05:51:00.4-69:25:31.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38867,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38867,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2118, RA-DEC 05:29:02.9-69:53:24.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38868,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38868,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2706, RA-DEC 05:38:13.0-69:52:39.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38869,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38869,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2724, RA-DEC 05:38:27.8-70:35:37.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38870,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38870,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3311, RA-DEC 05:56:38.9-69:16:56.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38871,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38871,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3886, RA-DEC 05:20:38.5-66:15:06.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38872,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38872,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2463, RA-DEC 05:35:01.8-69:37:00.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38873,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38873,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2953, RA-DEC 05:41:52.3-69:49:37.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38874,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38874,18.4,0.06,0.0478,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3202, RA-DEC 05:48:03.3-70:35:09.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38875,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38875,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1118, RA-DEC 05:09:25.7-69:19:07.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38876,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38876,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3273, RA-DEC 05:52:10.6-69:37:06.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38877,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38877,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3604, RA-DEC 05:07:40.4-65:45:00.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38878,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38878,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3915, RA-DEC 05:22:06.4-65:59:01.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38879,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38879,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4524, RA-DEC 05:55:30.3-68:01:54.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38880,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38880,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2946, RA-DEC 05:41:45.7-71:12:50.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38881,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38881,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4435, RA-DEC 05:49:04.3-67:10:34.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38882,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,NULL,38882,18.4,0.08,0.0479,10597,NULL,NULL,'1264, JH(W)','LMC',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38883,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38883,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1667, RA-DEC 05:20:56.0-69:48:20.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38884,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38884,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2435, RA-DEC 05:34:28.4-70:37:37.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38885,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38885,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2766, RA-DEC 05:38:57.2-70:11:14.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38886,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38886,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2818, RA-DEC 05:39:43.5-71:08:49.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38887,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38887,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3652, RA-DEC 05:10:27.8-65:41:57.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38888,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38888,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3816, RA-DEC 05:16:40.9-66:19:05.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38889,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38889,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3993, RA-DEC 05:26:08.7-64:30:34.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38890,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38890,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4535, RA-DEC 05:56:43.9-67:22:15.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38891,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38891,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0518, RA-DEC 04:58:18.5-69:22:01.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38892,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38892,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1964, RA-DEC 05:25:45.4-69:31:14.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38893,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38893,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2469, RA-DEC 05:35:11.2-70:17:06.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38894,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38894,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3667, RA-DEC 05:11:00.8-66:20:06.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38895,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38895,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2538, RA-DEC 05:36:09.9-70:09:24.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38896,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38896,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2715, RA-DEC 05:38:18.9-68:05:05.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38897,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38897,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3054, RA-DEC 05:44:02.6-68:49:14.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38898,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38898,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3343, RA-DEC 06:04:53.9-69:12:08.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38899,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38899,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3795, RA-DEC 05:15:58.6-65:53:57.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38900,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38900,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4010, RA-DEC 05:27:10.9-65:12:44.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38901,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38901,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4525, RA-DEC 05:55:42.6-65:32:15.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38902,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38902,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4553, RA-DEC 05:59:21.7-68:01:26.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38903,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38903,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0210, RA-DEC 04:51:55.4-68:40:13.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38904,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38904,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1620, RA-DEC 05:20:04.5-71:13:54.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38905,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38905,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2976, RA-DEC 05:42:15.5-71:10:53.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38906,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38906,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3684, RA-DEC 05:11:53.5-66:23:15.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38907,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38907,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3931, RA-DEC 05:22:34.6-66:09:43.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38908,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38908,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3937, RA-DEC 05:22:58.1-71:59:33.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38909,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38909,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4432, RA-DEC 05:49:01.3-68:07:25.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38910,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,NULL,38910,18.4,NULL,0.0479,10597,NULL,NULL,NULL,'LMC',NULL,'2011ApJ...741L..36M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38911,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,NULL,38911,18.4,0.1,0.0479,10597,NULL,NULL,'GAL + LMC PL','LMC',NULL,'2007A&A...476...73F',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38912,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,NULL,38912,18.4,0.05,0.0479,10597,NULL,NULL,NULL,'LMC',NULL,'2007Natur.449..872O',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38913,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,NULL,38913,18.4,0.1,0.0479,10597,NULL,NULL,NULL,'LMC',NULL,'1987A&A...175...30I',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38914,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38914,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0857, RA-DEC 05:04:30.5-67:58:21.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38915,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38915,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1843, RA-DEC 05:23:39.1-70:00:14.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38916,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38916,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3005, RA-DEC 05:42:45.1-67:55:15.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38917,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38917,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4518, RA-DEC 05:54:57.9-67:13:03.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38918,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38918,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2886, RA-DEC 05:40:40.7-71:13:20.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38919,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38919,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2919, RA-DEC 05:41:14.4-68:55:17.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38920,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38920,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3224, RA-DEC 05:48:56.1-70:30:02.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38921,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38921,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4550, RA-DEC 05:59:02.3-68:12:50.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38922,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38922,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1134, RA-DEC 05:09:47.9-66:35:46.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38923,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38923,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4496, RA-DEC 05:52:29.7-66:26:22.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38924,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38924,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4513, RA-DEC 05:54:35.5-68:03:33.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38925,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38925,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2783, RA-DEC 05:39:16.9-70:09:15.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38926,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38926,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3185, RA-DEC 05:47:29.0-70:22:51.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38927,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38927,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3888, RA-DEC 05:20:45.5-65:19:53.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38928,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38928,18.4,0.06,0.0479,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4149, RA-DEC 05:34:05.1-64:38:38.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38929,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38929,18.4,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1133, RA-DEC 05:09:47.7-68:56:44.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38930,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38930,18.4,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2666, RA-DEC 05:37:38.7-70:14:43.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38931,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38931,18.4,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2803, RA-DEC 05:39:32.1-70:28:04.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38932,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38932,18.4,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3349, RA-DEC 06:06:20.0-71:37:53.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38933,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38933,18.4,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3833, RA-DEC 05:17:24.8-66:07:55.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38934,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38934,18.4,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1284, RA-DEC 05:13:49.2-69:57:52.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38935,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38935,18.4,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1987, RA-DEC 05:26:17.5-69:40:02.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38936,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38936,18.4,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3420, RA-DEC 04:50:29.7-65:51:59.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38937,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38937,18.4,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4363, RA-DEC 05:45:30.4-65:20:54.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38938,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38938,18.4,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4614, RA-DEC 06:18:15.7-68:07:47.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38939,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38939,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1886, RA-DEC 05:24:33.9-70:09:30.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38940,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38940,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2030, RA-DEC 05:27:07.8-68:29:42.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38941,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38941,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2684, RA-DEC 05:37:50.3-70:20:42.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38942,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38942,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3089, RA-DEC 05:44:50.5-70:22:29.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38943,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38943,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3128, RA-DEC 05:45:58.7-69:29:58.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38944,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38944,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3134, RA-DEC 05:46:06.7-70:06:02.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38945,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38945,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4030, RA-DEC 05:28:06.9-64:54:59.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38946,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38946,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4444, RA-DEC 05:49:21.4-67:11:15.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38947,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38947,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0894, RA-DEC 05:05:22.7-67:11:31.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38948,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38948,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2642, RA-DEC 05:37:25.9-70:04:49.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38949,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38949,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3543, RA-DEC 05:03:43.9-65:45:09.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38950,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38950,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4062, RA-DEC 05:29:40.6-66:31:01.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38951,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38951,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4102, RA-DEC 05:31:42.1-65:20:45.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38952,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38952,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4192, RA-DEC 05:36:29.1-66:39:26.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38953,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38953,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4544, RA-DEC 05:57:31.5-67:37:29.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38954,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38954,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4571, RA-DEC 06:03:22.7-66:01:45.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38955,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38955,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2615, RA-DEC 05:37:00.9-70:08:01.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38956,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38956,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3967, RA-DEC 05:24:58.6-64:46:38.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38957,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38957,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4263, RA-DEC 05:40:27.2-67:25:15.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38958,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38958,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4579, RA-DEC 06:05:36.5-68:08:09.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38959,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,NULL,38959,18.4,0.05,0.048,10597,NULL,NULL,'W, Z','LMC',NULL,'2007AJ....133.1810B',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38960,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38960,18.41,0.15,0.048,10597,NULL,NULL,'HV 2538, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38961,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38961,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1643, RA-DEC 05:20:30.6-70:45:28.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38962,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38962,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1972, RA-DEC 05:25:58.6-70:09:49.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38963,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38963,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2942, RA-DEC 05:41:35.2-70:17:34.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38964,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38964,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3267, RA-DEC 05:51:51.5-69:44:10.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38965,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38965,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1372, RA-DEC 05:15:24.2-70:10:51.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38966,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38966,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1710, RA-DEC 05:21:50.3-69:49:59.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38967,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38967,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2180, RA-DEC 05:30:14.5-69:44:22.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38968,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38968,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3831, RA-DEC 05:17:21.3-66:21:30.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38969,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38969,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4085, RA-DEC 05:30:37.8-66:15:37.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38970,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38970,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4290, RA-DEC 05:41:55.2-67:20:52.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38971,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38971,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1792, RA-DEC 05:22:49.5-71:03:12.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38972,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38972,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2071, RA-DEC 05:28:00.0-69:37:20.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38973,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38973,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2190, RA-DEC 05:30:27.6-69:48:31.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38974,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38974,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2692, RA-DEC 05:38:00.0-69:16:54.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38975,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38975,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3205, RA-DEC 05:48:11.5-69:08:45.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38976,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38976,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3294, RA-DEC 05:53:39.9-69:55:59.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38977,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38977,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1181, RA-DEC 05:11:00.3-70:00:00.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38978,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38978,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2652, RA-DEC 05:37:34.0-69:40:28.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38979,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38979,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3476, RA-DEC 04:56:52.3-66:22:55.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38980,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38980,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3923, RA-DEC 05:22:23.9-71:59:18.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38981,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38981,18.41,0.06,0.048,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4414, RA-DEC 05:48:09.7-67:32:03.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38982,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38982,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1171, RA-DEC 05:10:40.2-67:31:57.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38983,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38983,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1847, RA-DEC 05:23:49.4-69:13:32.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38984,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38984,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1997, RA-DEC 05:26:25.5-69:53:20.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38985,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38985,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2023, RA-DEC 05:27:00.6-71:38:35.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38986,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38986,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2665, RA-DEC 05:37:38.7-70:14:15.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38987,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38987,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2998, RA-DEC 05:42:38.6-70:05:34.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38988,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38988,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1921, RA-DEC 05:25:17.1-69:41:20.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38989,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38989,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2547, RA-DEC 05:36:18.6-70:00:41.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38990,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38990,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2964, RA-DEC 05:42:05.0-68:22:24.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38991,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38991,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3926, RA-DEC 05:22:27.3-65:56:57.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38992,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38992,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3976, RA-DEC 05:25:23.2-66:35:37.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38993,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38993,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4016, RA-DEC 05:27:25.6-65:21:04.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38994,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38994,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4354, RA-DEC 05:45:04.2-64:22:04.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38995,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38995,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2971, RA-DEC 05:42:10.7-68:01:15.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38996,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38996,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3838, RA-DEC 05:17:50.0-65:35:40.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38997,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38997,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4588, RA-DEC 06:08:22.8-65:53:57.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38998,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38998,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0253, RA-DEC 04:52:50.2-69:04:19.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38999,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',38999,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1018, RA-DEC 05:07:29.3-66:57:58.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39000,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39000,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1522, RA-DEC 05:18:01.2-69:37:15.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39001,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39001,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3832, RA-DEC 05:17:22.0-69:20:07.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39002,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39002,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0534, RA-DEC 04:58:35.9-66:41:53.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39003,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39003,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1943, RA-DEC 05:25:30.3-69:50:13.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39004,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39004,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2279, RA-DEC 05:31:48.1-70:01:27.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39005,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39005,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3312, RA-DEC 05:56:39.7-69:25:18.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39006,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39006,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3358, RA-DEC 06:11:41.3-72:50:27.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39007,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39007,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4523, RA-DEC 05:55:30.3-66:05:57.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39008,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39008,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1301, RA-DEC 05:14:06.3-69:04:26.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39009,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39009,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3266, RA-DEC 05:51:44.6-69:46:02.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39010,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39010,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3790, RA-DEC 05:15:55.9-65:20:18.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39011,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39011,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4336, RA-DEC 05:44:11.0-66:59:57.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39012,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39012,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4474, RA-DEC 05:51:07.6-67:25:03.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39013,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,NULL,39013,18.41,0.13,0.0481,10597,NULL,NULL,'NGC 1866, BV, PLC','LMC',NULL,'1987MNRAS.225..627W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39014,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,NULL,39014,18.41,0.16,0.0481,10597,NULL,NULL,'NGC 4258 at 7.2 Mpc','LMC',NULL,'2007Natur.449..872O',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39015,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,NULL,39015,18.41,0.1,0.0481,10597,NULL,NULL,'W, Z','LMC',NULL,'2006ApJ...652.1133M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39016,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39016,18.41,0.08,0.0481,10597,NULL,NULL,'HV 1023, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39017,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39017,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1275, RA-DEC 05:13:31.0-69:06:27.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39018,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39018,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1802, RA-DEC 05:23:01.1-69:44:59.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39019,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39019,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1816, RA-DEC 05:23:09.9-70:28:45.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39020,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39020,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4157, RA-DEC 05:34:22.8-65:03:29.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39021,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39021,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0107, RA-DEC 04:48:51.4-69:21:22.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39022,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39022,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1443, RA-DEC 05:16:23.5-68:35:26.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39023,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39023,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3327, RA-DEC 05:58:33.7-68:36:38.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39024,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39024,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3704, RA-DEC 05:12:34.3-65:35:45.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39025,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39025,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3710, RA-DEC 05:12:46.5-66:06:47.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39026,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39026,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4123, RA-DEC 05:32:52.7-64:10:02.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39027,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39027,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4254, RA-DEC 05:40:03.2-63:51:02.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39028,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39028,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0877, RA-DEC 05:05:00.9-67:37:27.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39029,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39029,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1016, RA-DEC 05:07:27.9-67:15:49.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39030,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39030,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2093, RA-DEC 05:28:31.4-69:58:09.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39031,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39031,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2589, RA-DEC 05:36:52.4-70:15:21.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39032,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39032,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3166, RA-DEC 05:46:47.2-69:30:24.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39033,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39033,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3237, RA-DEC 05:49:33.9-71:01:30.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39034,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39034,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3776, RA-DEC 05:15:19.4-65:58:42.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39035,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39035,18.41,0.06,0.0481,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3797, RA-DEC 05:16:02.3-65:11:31.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39036,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39036,18.41,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0034, RA-DEC 04:42:01.9-70:38:49.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39037,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39037,18.41,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0735, RA-DEC 05:02:17.6-68:28:31.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39038,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39038,18.41,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1874, RA-DEC 05:24:25.2-69:36:12.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39039,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39039,18.41,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2149, RA-DEC 05:29:36.0-69:40:26.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39040,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39040,18.41,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2606, RA-DEC 05:36:55.9-69:55:18.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39041,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39041,18.41,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2879, RA-DEC 05:40:34.3-71:08:29.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39042,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39042,18.41,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3808, RA-DEC 05:16:18.6-66:46:39.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39043,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39043,18.41,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3845, RA-DEC 05:18:02.4-65:51:34.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39044,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39044,18.41,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4397, RA-DEC 05:47:21.1-67:30:08.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39045,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39045,18.41,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4501, RA-DEC 05:52:40.8-67:01:39.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39046,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39046,18.41,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3898, RA-DEC 05:21:24.1-66:20:36.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39047,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39047,18.41,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4338, RA-DEC 05:44:21.1-67:23:54.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39048,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39048,18.41,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1612, RA-DEC 05:19:56.4-68:35:50.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39049,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39049,18.41,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2701, RA-DEC 05:38:08.5-70:26:25.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39050,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39050,18.41,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2934, RA-DEC 05:41:27.0-69:10:16.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39051,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39051,18.41,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0423, RA-DEC 04:56:12.6-67:24:48.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39052,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39052,18.41,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2073, RA-DEC 05:28:03.3-69:15:31.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39053,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39053,18.41,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3249, RA-DEC 05:50:13.9-69:36:59.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39054,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39054,18.41,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3263, RA-DEC 05:51:08.1-70:13:19.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39055,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39055,18.41,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3317, RA-DEC 05:57:33.1-69:12:01.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39056,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39056,18.41,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3883, RA-DEC 05:20:27.2-64:20:58.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39057,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39057,18.41,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0661, RA-DEC 05:00:58.2-67:47:34.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39058,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39058,18.41,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2031, RA-DEC 05:27:10.8-70:14:02.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39059,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39059,18.41,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2536, RA-DEC 05:36:07.6-71:00:36.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39060,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39060,18.41,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2756, RA-DEC 05:38:51.1-69:49:21.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39061,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39061,18.41,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3328, RA-DEC 05:58:37.1-68:29:32.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39062,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39062,18.41,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4604, RA-DEC 06:12:58.5-68:15:19.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39063,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39063,18.42,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1704, RA-DEC 05:21:45.9-69:27:26.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39064,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39064,18.42,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1948, RA-DEC 05:25:33.3-69:29:44.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39065,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39065,18.42,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3299, RA-DEC 05:54:12.4-69:36:03.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39066,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39066,18.42,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3813, RA-DEC 05:16:34.5-66:35:11.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39067,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39067,18.42,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0555, RA-DEC 04:59:00.3-68:03:10.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39068,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39068,18.42,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1289, RA-DEC 05:13:53.0-69:21:37.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39069,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39069,18.42,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1569, RA-DEC 05:19:01.8-69:12:56.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39070,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39070,18.42,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2485, RA-DEC 05:35:27.3-71:08:40.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39071,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39071,18.42,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3067, RA-DEC 05:44:23.2-70:26:25.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39072,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39072,18.42,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4021, RA-DEC 05:27:36.2-65:52:57.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39073,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39073,18.42,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4188, RA-DEC 05:36:26.2-66:03:18.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39074,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39074,18.42,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1216, RA-DEC 05:11:56.8-70:18:57.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39075,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39075,18.42,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1701, RA-DEC 05:21:40.5-69:35:52.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39076,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39076,18.42,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1936, RA-DEC 05:25:27.2-69:49:29.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39077,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39077,18.42,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2687, RA-DEC 05:37:53.0-70:01:55.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39078,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39078,18.42,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2835, RA-DEC 05:39:57.2-68:35:46.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39079,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39079,18.42,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3274, RA-DEC 05:52:15.8-69:53:13.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39080,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39080,18.42,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3593, RA-DEC 05:07:05.4-66:19:13.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39081,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39081,18.42,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4322, RA-DEC 05:43:29.5-66:49:19.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39082,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39082,18.42,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2709, RA-DEC 05:38:14.9-67:45:39.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39083,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39083,18.42,0.06,0.0482,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3223, RA-DEC 05:48:52.8-70:01:03.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39084,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39084,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0578, RA-DEC 04:59:27.0-69:22:39.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39085,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39085,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1841, RA-DEC 05:23:35.3-69:27:37.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39086,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39086,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2749, RA-DEC 05:38:46.2-69:56:09.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39087,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39087,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3676, RA-DEC 05:11:23.1-66:01:42.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39088,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39088,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3971, RA-DEC 05:25:16.0-66:57:27.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39089,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39089,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4058, RA-DEC 05:29:19.0-66:38:27.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39090,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39090,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4248, RA-DEC 05:39:45.2-67:03:23.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39091,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39091,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4283, RA-DEC 05:41:34.0-66:41:48.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39092,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39092,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4374, RA-DEC 05:46:17.3-66:44:58.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39093,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39093,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1078, RA-DEC 05:08:43.1-68:45:33.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39094,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39094,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1233, RA-DEC 05:12:18.8-68:52:45.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39095,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39095,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1876, RA-DEC 05:24:26.6-68:33:41.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39096,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39096,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2651, RA-DEC 05:37:33.9-70:40:30.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39097,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39097,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2672, RA-DEC 05:37:41.9-70:14:05.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39098,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39098,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3232, RA-DEC 05:49:26.9-70:18:48.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39099,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39099,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3616, RA-DEC 05:08:27.8-71:46:40.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39100,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39100,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3786, RA-DEC 05:15:47.9-66:26:50.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39101,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39101,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3943, RA-DEC 05:23:28.0-66:38:27.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39102,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39102,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4452, RA-DEC 05:49:42.2-67:33:35.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39103,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39103,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2561, RA-DEC 05:36:27.4-68:08:16.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39104,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39104,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2677, RA-DEC 05:37:44.5-69:14:44.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39105,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39105,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3064, RA-DEC 05:44:21.1-68:32:57.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39106,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39106,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4012, RA-DEC 05:27:18.2-66:55:36.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39107,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39107,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2990, RA-DEC 05:42:28.5-69:46:56.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39108,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39108,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3264, RA-DEC 05:51:21.8-69:28:29.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39109,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39109,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3561, RA-DEC 05:04:45.6-66:19:49.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39110,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39110,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3901, RA-DEC 05:21:35.2-65:10:23.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39111,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39111,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4236, RA-DEC 05:38:40.8-67:02:05.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39112,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39112,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1967, RA-DEC 05:25:52.6-70:05:30.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39113,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39113,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3112, RA-DEC 05:45:34.5-67:58:00.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39114,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39114,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3515, RA-DEC 05:01:06.9-66:03:09.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39115,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39115,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4245, RA-DEC 05:39:37.7-66:44:39.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39116,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39116,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0974, RA-DEC 05:06:56.7-66:42:40.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39117,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39117,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3022, RA-DEC 05:43:02.8-71:06:18.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39118,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39118,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4052, RA-DEC 05:28:59.7-66:44:03.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39119,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39119,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4127, RA-DEC 05:32:56.8-66:20:41.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39120,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,NULL,39120,18.42,0.11,0.0483,10597,NULL,NULL,NULL,'LMC',NULL,'1997AJ....113...13B',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39121,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,NULL,39121,18.42,0.3,0.0483,10597,NULL,NULL,'V, PL','LMC',NULL,'1999ApJ...512..711B',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39122,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,NULL,39122,18.42,0.1,0.0483,10597,NULL,NULL,'HV 12198, BW, IR SB','LMC',NULL,'2000ApJ...533L.107G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39123,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39123,18.42,NULL,0.0483,10597,NULL,NULL,'43, PLV+PLC','LMC',NULL,'1988ASPC....4....9F',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39124,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,NULL,39124,18.42,0.04,0.0483,10597,NULL,NULL,NULL,'LMC',NULL,'1989ApJ...346..629V',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39125,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39125,18.42,0.3,0.0483,10597,NULL,NULL,'PL(V)','LMC',NULL,'1999ASPC..167..275M',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39126,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,NULL,39126,18.42,0.1,0.0483,10597,NULL,NULL,'NGC 1866, 15, K','LMC',NULL,'2007A&A...462..599T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39127,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39127,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2480, RA-DEC 05:35:23.1-71:09:17.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39128,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39128,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3565, RA-DEC 05:04:56.4-65:36:25.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39129,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39129,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4080, RA-DEC 05:30:25.7-66:52:22.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39130,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39130,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4172, RA-DEC 05:35:22.7-66:23:46.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39131,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:11','1',NULL,'R',39131,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2508, RA-DEC 05:35:40.2-70:14:19.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39132,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39132,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3685, RA-DEC 05:11:53.9-66:13:08.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39133,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39133,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4433, RA-DEC 05:49:01.6-65:44:21.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39134,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39134,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2051, RA-DEC 05:27:36.7-69:53:43.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39135,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39135,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2578, RA-DEC 05:36:43.6-71:25:25.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39136,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39136,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2782, RA-DEC 05:39:16.8-70:06:35.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39137,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39137,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3737, RA-DEC 05:13:38.2-65:27:58.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39138,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39138,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0866, RA-DEC 05:04:41.0-69:16:17.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39139,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39139,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1132, RA-DEC 05:09:45.0-67:36:23.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39140,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39140,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1392, RA-DEC 05:15:41.5-66:42:00.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39141,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39141,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1891, RA-DEC 05:24:35.2-71:07:30.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39142,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39142,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2056, RA-DEC 05:27:42.9-70:00:49.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39143,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39143,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2688, RA-DEC 05:37:53.2-69:12:28.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39144,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39144,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3508, RA-DEC 05:00:44.8-65:48:53.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39145,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39145,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3609, RA-DEC 05:07:48.9-66:29:12.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39146,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39146,18.42,0.06,0.0483,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4372, RA-DEC 05:46:09.2-66:57:56.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39147,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39147,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0481, RA-DEC 04:57:27.4-68:36:04.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39148,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39148,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1114, RA-DEC 05:09:20.3-70:32:51.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39149,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39149,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3117, RA-DEC 05:45:41.1-69:55:53.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39150,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39150,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4070, RA-DEC 05:30:07.0-65:11:19.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39151,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39151,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4465, RA-DEC 05:50:26.3-66:53:07.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39152,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39152,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0339, RA-DEC 04:54:43.8-70:50:04.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39153,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39153,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0417, RA-DEC 04:56:05.4-68:00:39.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39154,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39154,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1008, RA-DEC 05:07:25.1-70:50:52.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39155,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39155,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1855, RA-DEC 05:23:59.1-69:15:29.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39156,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39156,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1979, RA-DEC 05:26:01.2-69:30:41.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39157,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39157,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2661, RA-DEC 05:37:38.2-70:14:23.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39158,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39158,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2983, RA-DEC 05:42:21.5-70:14:57.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39159,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39159,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3118, RA-DEC 05:45:42.0-70:25:03.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39160,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39160,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3181, RA-DEC 05:47:24.5-70:45:33.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39161,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39161,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3300, RA-DEC 05:54:14.0-69:36:45.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39162,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39162,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3909, RA-DEC 05:21:57.5-65:23:15.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39163,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39163,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3925, RA-DEC 05:22:24.4-66:43:35.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39164,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39164,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4595, RA-DEC 06:10:24.1-65:33:14.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39165,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39165,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0594, RA-DEC 04:59:45.1-69:29:35.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39166,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39166,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0825, RA-DEC 05:03:51.3-68:52:59.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39167,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39167,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2394, RA-DEC 05:33:46.9-69:54:34.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39168,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39168,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2530, RA-DEC 05:35:59.2-70:04:25.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39169,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39169,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2664, RA-DEC 05:37:38.6-70:14:09.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39170,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39170,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3257, RA-DEC 05:50:55.9-69:31:05.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39171,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39171,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4279, RA-DEC 05:41:21.2-74:09:59.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39172,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39172,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4345, RA-DEC 05:44:41.9-67:20:28.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39173,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39173,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4552, RA-DEC 05:59:19.8-67:34:50.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39174,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39174,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0156, RA-DEC 04:50:20.1-69:19:49.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39175,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39175,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2460, RA-DEC 05:34:58.9-70:11:48.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39176,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39176,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2673, RA-DEC 05:37:42.1-70:39:02.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39177,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39177,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3462, RA-DEC 04:55:07.4-71:31:11.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39178,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39178,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3479, RA-DEC 04:56:54.5-66:05:01.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39179,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39179,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3496, RA-DEC 04:59:27.4-66:12:57.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39180,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39180,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1487, RA-DEC 05:17:20.6-69:09:29.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39181,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39181,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2040, RA-DEC 05:27:17.5-69:44:25.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39182,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39182,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3992, RA-DEC 05:26:06.2-63:49:15.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39183,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39183,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4240, RA-DEC 05:38:48.2-66:15:57.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39184,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39184,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4568, RA-DEC 06:02:54.6-65:22:02.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39185,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,NULL,39185,18.43,0.05,0.0484,10597,NULL,NULL,'HV 02864, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39186,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39186,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0618, RA-DEC 05:00:07.5-66:36:50.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39187,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39187,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1926, RA-DEC 05:25:21.1-69:50:17.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39188,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39188,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2527, RA-DEC 05:35:56.6-70:04:51.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39189,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39189,18.42,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4430, RA-DEC 05:48:55.9-66:52:57.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39190,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39190,18.43,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0419, RA-DEC 04:56:06.6-68:03:52.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39191,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39191,18.43,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1125, RA-DEC 05:09:29.8-68:21:19.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39192,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39192,18.43,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2298, RA-DEC 05:32:12.0-70:00:19.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39193,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39193,18.43,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2871, RA-DEC 05:40:31.8-68:47:30.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39194,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39194,18.43,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3217, RA-DEC 05:48:44.2-69:25:40.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39195,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39195,18.43,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3977, RA-DEC 05:25:23.9-62:36:09.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39196,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39196,18.43,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1540, RA-DEC 05:18:26.1-68:47:52.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39197,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39197,18.43,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1988, RA-DEC 05:26:18.0-69:48:33.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39198,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39198,18.43,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3231, RA-DEC 05:49:26.6-69:28:54.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39199,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39199,18.43,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3268, RA-DEC 05:51:52.7-71:06:28.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39200,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39200,18.43,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3821, RA-DEC 05:16:51.0-66:23:08.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39201,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39201,18.43,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4441, RA-DEC 05:49:18.3-67:14:17.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39202,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39202,18.43,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1586, RA-DEC 05:19:27.5-69:06:00.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39203,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39203,18.43,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1920, RA-DEC 05:25:15.3-69:50:59.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39204,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39204,18.43,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2520, RA-DEC 05:35:52.2-70:11:31.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39205,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39205,18.43,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3179, RA-DEC 05:47:22.0-69:48:49.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39206,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39206,18.43,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3531, RA-DEC 05:02:46.8-74:38:44.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39207,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39207,18.43,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3662, RA-DEC 05:10:53.4-66:00:35.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39208,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39208,18.43,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4185, RA-DEC 05:36:12.2-66:23:29.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39209,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39209,18.43,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4269, RA-DEC 05:40:52.4-67:19:48.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39210,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39210,18.43,0.06,0.0484,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4346, RA-DEC 05:44:46.4-63:56:11.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39211,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39211,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1428, RA-DEC 05:16:06.6-68:43:46.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39212,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39212,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2468, RA-DEC 05:35:10.7-69:40:13.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39213,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39213,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2513, RA-DEC 05:35:44.3-70:14:03.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39214,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39214,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2650, RA-DEC 05:37:33.8-70:23:07.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39215,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39215,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2767, RA-DEC 05:38:57.4-70:34:27.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39216,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39216,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3152, RA-DEC 05:46:30.6-69:29:46.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39217,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39217,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3961, RA-DEC 05:24:40.3-55:59:07.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39218,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39218,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1768, RA-DEC 05:22:30.3-70:09:17.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39219,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39219,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2654, RA-DEC 05:37:35.4-70:05:55.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39220,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39220,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2736, RA-DEC 05:38:36.7-70:27:16.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39221,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39221,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2808, RA-DEC 05:39:33.2-70:22:34.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39222,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39222,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2857, RA-DEC 05:40:17.0-70:05:20.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39223,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39223,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4446, RA-DEC 05:49:27.8-66:42:01.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39224,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39224,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1906, RA-DEC 05:24:50.3-70:03:57.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39225,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39225,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3212, RA-DEC 05:48:23.9-70:28:32.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39226,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39226,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3882, RA-DEC 05:20:24.8-65:24:27.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39227,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39227,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4616, RA-DEC 06:18:52.6-67:36:36.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39228,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39228,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0981, RA-DEC 05:07:02.4-68:53:34.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39229,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39229,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2986, RA-DEC 05:42:25.1-70:18:48.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39230,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39230,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3051, RA-DEC 05:43:59.8-68:51:25.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39231,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39231,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4036, RA-DEC 05:28:19.6-66:12:01.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39232,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39232,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4153, RA-DEC 05:34:12.1-67:23:09.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39233,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39233,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4294, RA-DEC 05:42:03.0-67:07:07.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39234,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39234,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4439, RA-DEC 05:49:12.1-67:32:24.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39235,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39235,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0097, RA-DEC 04:48:26.7-67:32:47.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39236,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39236,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0247, RA-DEC 04:52:47.0-68:44:12.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39237,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39237,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1022, RA-DEC 05:07:33.2-70:13:41.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39238,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39238,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1426, RA-DEC 05:16:04.5-68:59:50.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39239,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39239,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1463, RA-DEC 05:16:54.9-69:19:50.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39240,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39240,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2452, RA-DEC 05:34:45.1-69:14:00.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39241,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39241,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3297, RA-DEC 05:54:04.7-69:23:25.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39242,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39242,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3935, RA-DEC 05:22:44.7-64:45:38.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39243,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39243,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4163, RA-DEC 05:34:44.9-65:04:41.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39244,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39244,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1417, RA-DEC 05:16:00.2-69:32:17.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39245,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39245,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1864, RA-DEC 05:24:17.0-69:37:14.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39246,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39246,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2321, RA-DEC 05:32:43.5-70:14:48.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39247,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39247,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2704, RA-DEC 05:38:10.8-71:24:25.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39248,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39248,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3003, RA-DEC 05:42:44.1-68:35:11.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39249,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39249,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3209, RA-DEC 05:48:15.6-69:42:32.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39250,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39250,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3568, RA-DEC 05:05:02.9-66:25:09.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39251,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39251,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3767, RA-DEC 05:14:41.0-65:09:29.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39252,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39252,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3973, RA-DEC 05:25:19.3-65:57:28.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39253,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39253,18.43,0.09,0.0485,10597,NULL,NULL,'VI(W), Z','LMC',NULL,'2009MmSAI..80..141M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39254,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,NULL,39254,18.43,0.05,0.0485,10597,NULL,NULL,'HV 12078, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39255,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39255,18.43,0.06,0.0485,10597,NULL,NULL,'Z corr. = -0.09 mag','LMC',NULL,'2011rrls.conf..170F',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39256,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39256,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0293, RA-DEC 04:53:36.4-68:38:55.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39257,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39257,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0652, RA-DEC 05:00:54.8-69:34:47.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39258,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39258,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1789, RA-DEC 05:22:45.8-67:54:38.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39259,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39259,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2693, RA-DEC 05:38:02.1-70:10:09.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39260,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39260,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2786, RA-DEC 05:39:17.9-68:22:43.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39261,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39261,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4253, RA-DEC 05:40:03.1-67:04:18.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39262,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39262,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4392, RA-DEC 05:47:09.6-67:22:06.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39263,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39263,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0741, RA-DEC 05:02:21.2-69:13:17.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39264,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39264,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1493, RA-DEC 05:17:30.7-69:12:02.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39265,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39265,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1830, RA-DEC 05:23:18.1-70:14:04.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39266,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39266,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1845, RA-DEC 05:23:46.0-70:18:28.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39267,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39267,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2059, RA-DEC 05:27:46.8-68:03:32.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39268,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39268,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2621, RA-DEC 05:37:03.6-70:03:51.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39269,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39269,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3842, RA-DEC 05:17:58.8-67:33:35.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39270,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39270,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4555, RA-DEC 05:59:42.9-67:03:46.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39271,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39271,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1340, RA-DEC 05:15:01.1-68:58:45.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39272,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39272,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1753, RA-DEC 05:22:25.6-69:49:29.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39273,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39273,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1793, RA-DEC 05:22:50.6-69:53:20.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39274,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39274,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1922, RA-DEC 05:25:18.0-69:49:37.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39275,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39275,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2210, RA-DEC 05:30:47.3-69:45:42.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39276,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39276,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3162, RA-DEC 05:46:41.0-68:00:28.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39277,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39277,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3495, RA-DEC 04:59:22.4-66:19:12.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39278,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39278,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3760, RA-DEC 05:14:22.3-65:40:55.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39279,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39279,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4344, RA-DEC 05:44:41.9-67:07:53.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39280,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39280,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4410, RA-DEC 05:47:59.1-67:12:17.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39281,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39281,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4586, RA-DEC 06:07:42.7-68:17:02.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39282,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39282,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4605, RA-DEC 06:14:18.4-68:55:17.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39283,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39283,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0576, RA-DEC 04:59:25.0-69:25:38.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39284,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39284,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0844, RA-DEC 05:04:15.5-69:01:36.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39285,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39285,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2827, RA-DEC 05:39:47.6-70:03:54.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39286,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39286,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3758, RA-DEC 05:14:19.3-66:07:16.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39287,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39287,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4475, RA-DEC 05:51:08.9-67:47:30.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39288,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39288,18.43,0.06,0.0485,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4517, RA-DEC 05:54:51.1-65:37:09.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39289,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39289,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1832, RA-DEC 05:23:22.3-71:33:17.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39290,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39290,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4468, RA-DEC 05:50:28.7-65:22:45.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39291,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39291,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2229, RA-DEC 05:31:00.9-69:45:32.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39292,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39292,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2296, RA-DEC 05:32:06.7-71:51:06.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39293,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39293,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2725, RA-DEC 05:38:30.0-70:05:26.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39294,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39294,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2834, RA-DEC 05:39:55.7-70:15:12.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39295,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39295,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3341, RA-DEC 06:02:51.3-68:24:45.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39296,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39296,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3629, RA-DEC 05:09:07.2-66:28:19.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39297,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39297,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3857, RA-DEC 05:18:49.9-72:38:14.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39298,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39298,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3982, RA-DEC 05:25:39.4-64:49:20.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39299,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39299,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0754, RA-DEC 05:02:29.7-68:00:41.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39300,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39300,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1052, RA-DEC 05:08:09.9-67:20:21.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39301,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39301,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1234, RA-DEC 05:12:20.6-69:22:44.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39302,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39302,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1269, RA-DEC 05:13:18.1-68:46:37.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39303,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39303,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2010, RA-DEC 05:26:47.2-71:16:51.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39304,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39304,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3458, RA-DEC 04:54:27.8-66:24:32.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39305,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39305,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3503, RA-DEC 05:00:15.2-72:15:55.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39306,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39306,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4241, RA-DEC 05:38:56.0-66:06:05.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39307,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39307,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4366, RA-DEC 05:45:42.6-63:21:43.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39308,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39308,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0636, RA-DEC 05:00:33.6-69:00:25.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39309,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39309,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2301, RA-DEC 05:32:15.6-70:01:58.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39310,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39310,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2920, RA-DEC 05:41:16.4-70:18:25.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39311,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39311,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3930, RA-DEC 05:22:34.1-66:51:35.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39312,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39312,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0794, RA-DEC 05:03:16.1-70:28:58.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39313,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39313,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2185, RA-DEC 05:30:22.9-70:38:24.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39314,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39314,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2227, RA-DEC 05:30:59.9-69:49:16.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39315,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39315,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2729, RA-DEC 05:38:31.4-70:27:52.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39316,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39316,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3846, RA-DEC 05:18:05.4-65:56:51.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39317,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39317,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4049, RA-DEC 05:28:48.7-67:15:58.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39318,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39318,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4498, RA-DEC 05:52:36.1-67:32:06.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39319,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39319,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4545, RA-DEC 05:57:39.7-67:22:54.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39320,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39320,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4577, RA-DEC 06:05:26.3-68:09:50.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39321,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39321,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0290, RA-DEC 04:53:33.6-67:22:07.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39322,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39322,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2331, RA-DEC 05:32:54.4-71:44:36.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39323,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39323,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2877, RA-DEC 05:40:33.1-70:32:23.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39324,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39324,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3729, RA-DEC 05:13:32.7-66:27:07.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39325,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39325,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4025, RA-DEC 05:27:50.3-66:45:23.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39326,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39326,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4573, RA-DEC 06:04:15.6-66:39:33.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39327,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,NULL,39327,18.43,0.05,0.0486,10597,NULL,NULL,'HV 02827, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39328,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39328,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0607, RA-DEC 04:59:57.8-67:18:18.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39329,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39329,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0672, RA-DEC 05:01:05.7-70:49:38.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39330,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39330,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1867, RA-DEC 05:24:19.3-69:50:41.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39331,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39331,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2667, RA-DEC 05:37:38.9-69:58:34.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39332,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39332,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2802, RA-DEC 05:39:29.2-70:38:19.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39333,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39333,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3143, RA-DEC 05:46:18.1-71:09:19.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39334,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39334,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3198, RA-DEC 05:47:46.6-68:43:24.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39335,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39335,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3335, RA-DEC 06:00:23.9-68:33:22.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39336,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39336,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3918, RA-DEC 05:22:09.6-66:44:49.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39337,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39337,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0473, RA-DEC 04:57:19.5-68:49:16.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39338,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39338,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1635, RA-DEC 05:20:19.5-70:42:28.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39339,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39339,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2914, RA-DEC 05:41:11.2-69:32:34.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39340,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39340,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2963, RA-DEC 05:42:04.2-70:06:09.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39341,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39341,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3302, RA-DEC 05:54:33.0-68:59:13.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39342,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39342,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3921, RA-DEC 05:22:10.7-67:18:30.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39343,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39343,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2022, RA-DEC 05:26:59.5-69:51:10.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39344,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39344,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3330, RA-DEC 05:58:44.4-70:12:42.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39345,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39345,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4398, RA-DEC 05:47:22.3-65:29:32.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39346,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39346,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0485, RA-DEC 04:57:39.4-68:01:20.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39347,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39347,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1064, RA-DEC 05:08:21.7-66:45:09.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39348,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39348,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1162, RA-DEC 05:10:29.4-70:27:34.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39349,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39349,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2262, RA-DEC 05:31:35.3-69:19:06.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39350,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39350,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2584, RA-DEC 05:36:50.0-70:36:34.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39351,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39351,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2902, RA-DEC 05:40:59.3-70:15:54.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39352,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39352,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3922, RA-DEC 05:22:19.2-66:09:25.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39353,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39353,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4202, RA-DEC 05:36:48.3-67:28:06.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39354,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39354,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4403, RA-DEC 05:47:45.3-67:24:12.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39355,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39355,18.43,0.06,0.0486,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4464, RA-DEC 05:50:14.7-67:14:10.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39356,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39356,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0057, RA-DEC 04:44:52.7-69:01:59.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39357,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39357,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1362, RA-DEC 05:15:17.0-70:41:34.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39358,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39358,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1976, RA-DEC 05:25:59.8-69:39:36.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39359,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39359,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2620, RA-DEC 05:37:03.4-70:04:33.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39360,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39360,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2967, RA-DEC 05:42:06.4-70:47:24.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39361,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39361,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3031, RA-DEC 05:43:13.4-71:02:22.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39362,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39362,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3941, RA-DEC 05:23:22.0-66:18:24.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39363,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39363,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3955, RA-DEC 05:24:18.7-65:16:45.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39364,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39364,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4284, RA-DEC 05:41:36.7-66:20:24.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39365,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39365,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4484, RA-DEC 05:51:54.0-67:31:28.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39366,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39366,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0146, RA-DEC 04:50:02.6-67:31:28.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39367,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39367,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0780, RA-DEC 05:03:03.4-66:43:39.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39368,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39368,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0902, RA-DEC 05:05:29.3-68:05:02.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39369,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39369,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0960, RA-DEC 05:06:37.6-66:43:08.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39370,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39370,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3256, RA-DEC 05:50:42.9-69:36:00.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39371,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39371,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3541, RA-DEC 05:03:35.9-66:04:32.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39372,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39372,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3779, RA-DEC 05:15:31.0-66:25:01.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39373,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39373,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3968, RA-DEC 05:25:04.7-66:38:56.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39374,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39374,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4126, RA-DEC 05:32:56.4-66:08:10.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39375,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39375,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0305, RA-DEC 04:53:47.9-69:08:45.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39376,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39376,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0559, RA-DEC 04:59:04.9-69:35:32.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39377,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39377,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1043, RA-DEC 05:08:05.5-70:38:21.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39378,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39378,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1349, RA-DEC 05:15:06.9-70:01:49.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39379,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39379,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1679, RA-DEC 05:21:15.4-70:00:26.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39380,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39380,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2029, RA-DEC 05:27:05.8-70:19:36.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39381,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39381,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2313, RA-DEC 05:32:32.3-70:11:25.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39382,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39382,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2628, RA-DEC 05:37:12.4-70:22:23.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39383,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39383,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2663, RA-DEC 05:37:38.4-70:29:52.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39384,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39384,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3018, RA-DEC 05:42:56.1-71:04:43.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39385,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39385,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3309, RA-DEC 05:56:12.5-70:23:35.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39386,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39386,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3756, RA-DEC 05:14:18.4-65:30:36.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39387,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39387,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3965, RA-DEC 05:24:54.8-66:11:51.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39388,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39388,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4174, RA-DEC 05:35:34.1-66:26:33.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39389,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39389,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4187, RA-DEC 05:36:23.3-67:38:48.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39390,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39390,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4478, RA-DEC 05:51:17.1-67:58:15.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39391,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39391,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1104, RA-DEC 05:09:07.8-67:01:12.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39392,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39392,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1146, RA-DEC 05:10:04.4-68:53:29.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39393,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39393,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2061, RA-DEC 05:27:48.5-68:22:56.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39394,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39394,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2658, RA-DEC 05:37:37.2-70:32:01.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39395,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39395,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2695, RA-DEC 05:38:04.2-69:57:05.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39396,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39396,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2989, RA-DEC 05:42:28.2-71:06:15.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39397,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39397,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3150, RA-DEC 05:46:26.2-68:37:44.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39398,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39398,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3636, RA-DEC 05:09:42.7-65:41:12.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39399,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39399,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4367, RA-DEC 05:45:45.2-67:05:33.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39400,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39400,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4611, RA-DEC 06:17:16.4-67:39:48.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39401,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39401,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0352, RA-DEC 04:54:54.0-68:32:29.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39402,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39402,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0498, RA-DEC 04:57:49.2-68:43:11.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39403,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39403,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2075, RA-DEC 05:28:08.7-70:18:32.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39404,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39404,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2139, RA-DEC 05:29:28.2-70:08:15.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39405,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39405,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2429, RA-DEC 05:34:21.2-67:49:01.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39406,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39406,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2813, RA-DEC 05:39:38.8-70:02:31.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39407,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39407,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4420, RA-DEC 05:48:16.6-67:16:27.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39408,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39408,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0306, RA-DEC 04:53:49.8-69:34:05.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39409,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39409,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2904, RA-DEC 05:41:01.4-71:51:43.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39410,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39410,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3075, RA-DEC 05:44:32.5-70:01:32.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39411,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39411,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3339, RA-DEC 06:02:24.3-69:15:14.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39412,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39412,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4274, RA-DEC 05:41:06.1-67:11:22.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39413,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,NULL,39413,18.44,0.08,0.0487,10597,NULL,NULL,NULL,'LMC',NULL,'2013ApJ...772..130M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39414,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39414,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0467, RA-DEC 04:57:12.3-67:22:57.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39415,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39415,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1254, RA-DEC 05:12:56.8-69:01:43.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39416,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39416,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1533, RA-DEC 05:18:08.8-69:45:44.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39417,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39417,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1561, RA-DEC 05:18:51.2-69:26:41.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39418,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39418,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1631, RA-DEC 05:20:17.2-69:30:11.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39419,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39419,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1820, RA-DEC 05:23:12.0-70:58:35.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39420,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39420,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2507, RA-DEC 05:35:39.7-70:14:24.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39421,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39421,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2828, RA-DEC 05:39:50.2-70:13:26.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39422,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39422,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3006, RA-DEC 05:42:46.9-67:51:18.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39423,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39423,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3757, RA-DEC 05:14:19.2-65:26:29.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39424,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39424,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4144, RA-DEC 05:33:46.8-67:31:44.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39425,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39425,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4310, RA-DEC 05:42:48.8-66:44:36.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39426,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39426,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0220, RA-DEC 04:52:12.0-68:43:41.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39427,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39427,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0522, RA-DEC 04:58:26.5-67:55:45.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39428,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39428,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0622, RA-DEC 05:00:11.4-67:20:39.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39429,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39429,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0742, RA-DEC 05:02:21.8-70:57:06.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39430,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39430,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1564, RA-DEC 05:18:56.2-69:02:20.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39431,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39431,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2738, RA-DEC 05:38:37.8-70:38:08.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39432,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39432,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3803, RA-DEC 05:16:05.0-66:27:51.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39433,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39433,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4214, RA-DEC 05:37:33.2-67:44:40.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39434,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39434,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1224, RA-DEC 05:12:03.0-68:57:10.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39435,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39435,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1726, RA-DEC 05:22:00.4-69:17:33.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39436,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39436,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1835, RA-DEC 05:23:30.1-71:48:16.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39437,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39437,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2587, RA-DEC 05:36:52.0-69:22:10.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39438,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39438,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3764, RA-DEC 05:14:27.1-64:59:06.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39439,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39439,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3792, RA-DEC 05:15:57.0-65:30:05.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39440,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39440,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2403, RA-DEC 05:33:55.5-71:48:50.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39441,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39441,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3466, RA-DEC 04:55:13.6-65:16:38.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39442,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39442,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3663, RA-DEC 05:10:53.4-66:34:33.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39443,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39443,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3804, RA-DEC 05:16:05.6-65:41:58.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39444,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39444,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4148, RA-DEC 05:33:59.5-67:38:15.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39445,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39445,18.44,0.06,0.0487,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4512, RA-DEC 05:54:29.0-68:16:53.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39446,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39446,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1353, RA-DEC 05:15:10.4-69:22:58.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39447,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39447,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1515, RA-DEC 05:17:56.4-69:34:53.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39448,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39448,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2255, RA-DEC 05:31:22.4-69:53:23.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39449,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39449,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2867, RA-DEC 05:40:28.7-70:10:38.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39450,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39450,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2900, RA-DEC 05:40:54.5-70:32:56.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39451,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39451,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2955, RA-DEC 05:41:53.8-70:09:43.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39452,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39452,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2984, RA-DEC 05:42:22.0-68:08:38.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39453,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39453,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4032, RA-DEC 05:28:14.4-65:24:50.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39454,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39454,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4141, RA-DEC 05:33:33.9-66:09:16.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39455,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39455,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4281, RA-DEC 05:41:27.8-67:07:42.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39456,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39456,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4530, RA-DEC 05:56:13.4-66:22:33.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39457,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,NULL,39457,18.44,0.09,0.0488,10597,NULL,NULL,'1264, JKs(W)','LMC',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39458,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39458,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0338, RA-DEC 04:54:40.6-71:11:48.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39459,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39459,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1880, RA-DEC 05:24:30.1-71:54:15.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39460,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39460,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2528, RA-DEC 05:35:57.6-70:08:22.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39461,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39461,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2640, RA-DEC 05:37:24.1-70:09:43.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39462,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39462,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2743, RA-DEC 05:38:43.0-70:21:29.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39463,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39463,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3906, RA-DEC 05:21:45.5-65:13:57.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39464,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39464,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1490, RA-DEC 05:17:24.7-69:20:57.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39465,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39465,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4067, RA-DEC 05:30:02.8-66:28:23.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39466,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39466,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4196, RA-DEC 05:36:36.4-64:28:42.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39467,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39467,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4289, RA-DEC 05:41:54.3-67:34:56.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39468,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39468,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0167, RA-DEC 04:50:42.0-69:01:53.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39469,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39469,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1751, RA-DEC 05:22:23.1-68:38:10.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39470,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39470,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1811, RA-DEC 05:23:07.1-70:29:05.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39471,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39471,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1822, RA-DEC 05:23:13.0-70:16:47.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39472,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39472,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2477, RA-DEC 05:35:21.0-70:59:25.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39473,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39473,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2563, RA-DEC 05:36:28.3-70:22:05.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39474,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39474,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3120, RA-DEC 05:45:43.3-69:29:14.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39475,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39475,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3648, RA-DEC 05:10:19.3-66:07:20.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39476,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39476,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4546, RA-DEC 05:57:40.5-67:18:22.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39477,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39477,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4621, RA-DEC 06:24:59.7-71:42:13.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39478,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39478,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1220, RA-DEC 05:11:59.0-69:03:26.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39479,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39479,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2945, RA-DEC 05:41:40.3-72:07:35.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39480,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39480,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2958, RA-DEC 05:41:57.6-70:50:55.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39481,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39481,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3078, RA-DEC 05:44:35.5-68:36:16.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39482,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39482,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3122, RA-DEC 05:45:45.3-67:54:34.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39483,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39483,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3564, RA-DEC 05:04:55.4-66:00:12.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39484,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39484,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3637, RA-DEC 05:09:44.7-66:25:39.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39485,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39485,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3721, RA-DEC 05:13:20.8-65:24:57.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39486,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39486,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1035, RA-DEC 05:07:56.4-66:37:45.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39487,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39487,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1062, RA-DEC 05:08:20.7-69:10:16.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39488,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39488,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1543, RA-DEC 05:18:28.1-69:27:46.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39489,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39489,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2216, RA-DEC 05:30:50.9-71:17:03.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39490,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39490,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2637, RA-DEC 05:37:22.6-70:12:16.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39491,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39491,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4617, RA-DEC 06:19:54.7-68:14:57.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39492,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,NULL,39492,18.44,0.17,0.0488,10597,NULL,NULL,'NGC 1866, PL','LMC',NULL,'1987MNRAS.225..627W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39493,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39493,18.44,0.12,0.0488,10597,NULL,NULL,NULL,'LMC',NULL,'2010JAVSO..38..100M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39494,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39494,18.44,0.03,0.0488,10597,NULL,NULL,'(Galactic + LMC) VI Wesenheit','LMC',NULL,'2010ARA&A..48..673F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39495,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,NULL,39495,18.44,0.35,0.0488,10597,NULL,NULL,'16, BV','LMC',NULL,'1998ApJ...492..110M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39496,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,NULL,39496,18.44,0.05,0.0488,10597,NULL,NULL,'OIII 3163, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39497,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,NULL,39497,18.44,0.05,0.0488,10597,NULL,NULL,'HV 01023, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39498,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39498,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0264, RA-DEC 04:53:00.5-68:53:49.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39499,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39499,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0287, RA-DEC 04:53:29.7-69:37:16.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39500,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39500,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1488, RA-DEC 05:17:23.3-69:11:03.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39501,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39501,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1791, RA-DEC 05:22:48.3-69:42:45.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39502,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39502,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2112, RA-DEC 05:28:51.4-69:50:04.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39503,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39503,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2484, RA-DEC 05:35:25.5-68:46:30.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39504,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39504,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2785, RA-DEC 05:39:17.8-70:34:25.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39505,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39505,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2980, RA-DEC 05:42:17.3-69:59:43.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39506,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39506,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3613, RA-DEC 05:08:17.0-65:28:59.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39507,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39507,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4456, RA-DEC 05:49:47.4-67:11:19.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39508,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39508,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2734, RA-DEC 05:38:35.8-70:36:29.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39509,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39509,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2995, RA-DEC 05:42:32.2-70:07:09.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39510,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39510,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3526, RA-DEC 05:02:22.8-64:38:58.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39511,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39511,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3674, RA-DEC 05:11:21.4-66:20:53.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39512,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39512,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3884, RA-DEC 05:20:32.1-66:37:24.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39513,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39513,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0431, RA-DEC 04:56:23.3-66:41:01.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39514,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39514,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1899, RA-DEC 05:24:41.4-69:43:31.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39515,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39515,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2686, RA-DEC 05:37:51.5-70:28:39.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39516,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39516,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3789, RA-DEC 05:15:55.7-66:05:18.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39517,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39517,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3852, RA-DEC 05:18:32.5-66:16:34.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39518,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39518,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3904, RA-DEC 05:21:40.1-66:30:27.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39519,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39519,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4515, RA-DEC 05:54:47.0-75:13:24.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39520,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39520,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0807, RA-DEC 05:03:31.6-67:09:08.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39521,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39521,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1494, RA-DEC 05:17:31.8-69:25:11.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39522,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39522,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2033, RA-DEC 05:27:11.7-69:40:45.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39523,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39523,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2079, RA-DEC 05:28:19.7-69:57:59.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39524,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39524,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3700, RA-DEC 05:12:27.1-65:46:56.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39525,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39525,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4278, RA-DEC 05:41:13.4-66:27:36.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39526,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39526,18.44,0.06,0.0488,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4377, RA-DEC 05:46:24.3-67:20:36.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39527,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39527,18.44,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1136, RA-DEC 05:09:50.1-68:31:17.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39528,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39528,18.44,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2036, RA-DEC 05:27:15.0-70:00:46.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39529,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39529,18.44,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2373, RA-DEC 05:33:39.4-69:54:55.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39530,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39530,18.44,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2888, RA-DEC 05:40:43.0-70:21:54.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39531,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39531,18.44,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3353, RA-DEC 06:08:08.0-68:56:59.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39532,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39532,18.44,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3981, RA-DEC 05:25:37.2-66:24:21.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39533,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39533,18.44,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4211, RA-DEC 05:37:28.3-66:37:43.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39534,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39534,18.44,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2018, RA-DEC 05:26:55.8-70:04:47.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39535,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39535,18.44,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2285, RA-DEC 05:31:56.0-69:40:55.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39536,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39536,18.44,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2830, RA-DEC 05:39:52.6-70:25:54.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39537,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39537,18.44,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3560, RA-DEC 05:04:44.2-66:01:49.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39538,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39538,18.44,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4143, RA-DEC 05:33:45.6-67:44:39.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39539,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39539,18.44,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4246, RA-DEC 05:39:41.3-64:10:08.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39540,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39540,18.44,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4251, RA-DEC 05:39:59.0-66:50:13.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39541,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39541,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0548, RA-DEC 04:58:48.8-68:05:59.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39542,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39542,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0858, RA-DEC 05:04:31.4-69:13:50.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39543,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39543,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1211, RA-DEC 05:11:48.8-68:46:22.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39544,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39544,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1446, RA-DEC 05:16:25.7-69:29:54.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39545,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39545,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2177, RA-DEC 05:30:13.6-68:51:07.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39546,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39546,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2250, RA-DEC 05:31:18.3-69:36:26.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39547,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39547,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2446, RA-DEC 05:34:39.5-70:45:42.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39548,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39548,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3050, RA-DEC 05:43:59.0-70:24:59.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39549,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39549,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3169, RA-DEC 05:46:52.3-70:46:44.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39550,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39550,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4054, RA-DEC 05:29:04.7-66:30:01.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39551,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39551,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4458, RA-DEC 05:50:01.1-66:49:45.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39552,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39552,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0846, RA-DEC 05:04:18.1-68:33:59.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39553,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39553,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1003, RA-DEC 05:07:22.6-66:48:56.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39554,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39554,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1813, RA-DEC 05:23:09.0-70:06:37.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39555,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39555,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1894, RA-DEC 05:24:36.5-68:35:48.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39556,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39556,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1895, RA-DEC 05:24:37.2-71:55:03.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39557,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39557,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2442, RA-DEC 05:34:34.6-70:18:20.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39558,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39558,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3798, RA-DEC 05:16:03.0-66:10:04.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39559,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39559,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4013, RA-DEC 05:27:18.2-66:23:40.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39560,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39560,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4362, RA-DEC 05:45:28.5-66:33:18.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39561,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39561,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0884, RA-DEC 05:05:08.9-69:15:12.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39562,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39562,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1296, RA-DEC 05:13:59.5-66:36:47.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39563,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39563,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3519, RA-DEC 05:01:40.3-67:28:29.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39564,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39564,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3826, RA-DEC 05:17:05.8-64:50:37.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39565,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39565,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4312, RA-DEC 05:42:51.5-73:26:20.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39566,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39566,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0464, RA-DEC 04:57:08.7-69:53:13.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39567,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39567,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0822, RA-DEC 05:03:50.4-70:34:05.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39568,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39568,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1607, RA-DEC 05:19:46.7-68:34:38.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39569,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39569,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3271, RA-DEC 05:52:03.3-69:27:05.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39570,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39570,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3578, RA-DEC 05:05:47.8-65:43:40.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39571,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39571,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3928, RA-DEC 05:22:31.8-66:35:40.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39572,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39572,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4039, RA-DEC 05:28:22.6-66:14:19.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39573,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39573,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4540, RA-DEC 05:57:09.2-65:51:29.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39574,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,NULL,39574,18.45,0.05,0.0489,10597,NULL,NULL,'OIII 3284, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39575,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,NULL,39575,18.45,0.05,0.0489,10597,NULL,NULL,'HV 12815, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39576,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,NULL,39576,18.45,0.05,0.0489,10597,NULL,NULL,'HV 01002, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39577,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39577,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0691, RA-DEC 05:01:34.7-67:02:35.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39578,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39578,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0757, RA-DEC 05:02:31.0-69:23:49.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39579,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39579,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0762, RA-DEC 05:02:37.1-66:44:59.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39580,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39580,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0928, RA-DEC 05:05:53.5-69:10:36.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39581,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39581,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1467, RA-DEC 05:16:59.5-70:34:30.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39582,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39582,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1511, RA-DEC 05:17:54.8-68:25:23.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39583,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39583,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2470, RA-DEC 05:35:11.4-69:57:46.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39584,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39584,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4343, RA-DEC 05:44:35.6-67:16:14.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39585,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39585,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0641, RA-DEC 05:00:38.2-71:00:33.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39586,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39586,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0854, RA-DEC 05:04:26.6-67:24:06.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39587,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39587,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3720, RA-DEC 05:13:20.7-66:29:23.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39588,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39588,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3765, RA-DEC 05:14:27.5-72:48:28.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39589,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39589,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0679, RA-DEC 05:01:14.4-67:09:50.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39590,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39590,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1399, RA-DEC 05:15:49.0-69:04:19.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39591,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39591,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2582, RA-DEC 05:36:47.0-70:09:37.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39592,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39592,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2807, RA-DEC 05:39:33.0-70:35:15.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39593,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39593,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2837, RA-DEC 05:39:59.1-70:46:41.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39594,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39594,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3038, RA-DEC 05:43:35.7-69:07:47.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39595,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39595,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3646, RA-DEC 05:10:15.6-66:25:27.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39596,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39596,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4091, RA-DEC 05:31:07.2-66:22:55.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39597,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39597,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4119, RA-DEC 05:32:49.2-66:29:06.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39598,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39598,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0727, RA-DEC 05:02:10.2-69:32:23.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39599,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39599,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2638, RA-DEC 05:37:22.7-70:23:43.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39600,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39600,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2674, RA-DEC 05:37:42.2-69:58:50.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39601,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39601,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3259, RA-DEC 05:50:57.5-70:01:10.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39602,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39602,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4026, RA-DEC 05:27:56.9-66:54:48.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39603,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39603,18.45,0.06,0.0489,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4547, RA-DEC 05:57:44.9-65:35:30.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39604,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39604,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1849, RA-DEC 05:23:52.2-70:03:30.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39605,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39605,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2309, RA-DEC 05:32:26.5-69:46:21.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39606,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39606,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2698, RA-DEC 05:38:05.8-71:04:15.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39607,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39607,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2881, RA-DEC 05:40:35.2-69:05:57.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39608,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39608,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3127, RA-DEC 05:45:55.3-70:26:53.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39609,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39609,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3215, RA-DEC 05:48:36.5-69:44:28.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39610,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39610,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0379, RA-DEC 04:55:20.9-67:04:43.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39611,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39611,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1800, RA-DEC 05:23:00.6-69:32:17.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39612,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39612,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2957, RA-DEC 05:41:57.1-71:05:52.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39613,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39613,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3499, RA-DEC 04:59:58.4-66:12:40.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39614,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39614,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3742, RA-DEC 05:13:40.1-65:27:42.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39615,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39615,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0608, RA-DEC 04:59:59.9-66:41:17.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39616,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39616,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1579, RA-DEC 05:19:15.3-69:41:28.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39617,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39617,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1748, RA-DEC 05:22:19.4-69:37:54.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39618,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39618,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2586, RA-DEC 05:36:51.9-70:09:43.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39619,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39619,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2607, RA-DEC 05:36:56.3-70:12:36.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39620,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39620,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2804, RA-DEC 05:39:32.3-70:19:39.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39621,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39621,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2987, RA-DEC 05:42:25.3-70:38:45.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39622,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39622,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3056, RA-DEC 05:44:09.9-69:12:30.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39623,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39623,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0779, RA-DEC 05:03:00.7-69:26:39.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39624,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39624,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1164, RA-DEC 05:10:33.6-67:03:39.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39625,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39625,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1442, RA-DEC 05:16:19.6-69:18:20.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39626,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39626,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1966, RA-DEC 05:25:52.4-70:07:18.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39627,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39627,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2204, RA-DEC 05:30:40.7-69:45:09.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39628,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39628,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2324, RA-DEC 05:32:46.5-69:22:23.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39629,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39629,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2742, RA-DEC 05:38:42.4-70:33:26.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39630,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39630,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3313, RA-DEC 05:57:00.3-70:01:45.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39631,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39631,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1267, RA-DEC 05:13:14.2-67:12:21.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39632,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39632,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1297, RA-DEC 05:14:01.2-67:40:52.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39633,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39633,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1343, RA-DEC 05:15:03.9-68:08:47.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39634,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39634,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2903, RA-DEC 05:40:59.4-68:31:20.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39635,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39635,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2961, RA-DEC 05:42:02.7-70:12:49.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39636,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39636,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2975, RA-DEC 05:42:15.2-68:20:55.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39637,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39637,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3154, RA-DEC 05:46:31.7-67:46:45.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39638,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39638,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3610, RA-DEC 05:07:50.4-65:37:29.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39639,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39639,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4264, RA-DEC 05:40:27.9-67:31:13.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39640,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39640,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4521, RA-DEC 05:55:18.4-67:21:52.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39641,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39641,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4581, RA-DEC 06:05:56.2-68:17:22.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39642,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39642,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1168, RA-DEC 05:10:37.3-71:17:42.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39643,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39643,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2993, RA-DEC 05:42:30.8-71:00:00.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39644,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39644,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4252, RA-DEC 05:40:01.5-65:23:11.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39645,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39645,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4313, RA-DEC 05:42:52.5-67:31:23.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39646,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,NULL,39646,18.45,0.02,0.049,10597,NULL,NULL,'3042, W(VIHJKs), +/- 0.10 mag syst.','LMC',NULL,'2013ApJ...764...84I',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39647,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,NULL,39647,18.45,0.04,0.049,10597,NULL,NULL,'IRSB, PL4','LMC',NULL,'2011A&A...534A..94S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39648,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39648,18.45,0.04,0.049,10597,NULL,NULL,'K(W)','LMC',NULL,'2012Msngr.147...14S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39649,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,NULL,39649,18.45,NULL,0.049,10597,NULL,NULL,NULL,'LMC',NULL,'1987AJ.....93.1090C',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39650,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,NULL,39650,18.45,0.04,0.049,10597,NULL,NULL,'JK','LMC',NULL,'2007MNRAS.379..723V',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39651,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,NULL,39651,18.45,0.04,0.049,10597,NULL,NULL,'JK, GAL+LMC PL','LMC',NULL,'2007MNRAS.379..723V',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39652,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,NULL,39652,18.45,0.09,0.049,10597,NULL,NULL,NULL,'LMC',NULL,'2008ApJ...684..102B',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39653,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39653,18.45,0.09,0.049,10597,NULL,NULL,'VI(W)','LMC',NULL,'2009MmSAI..80..141M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39654,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,NULL,39654,18.45,0.11,0.049,10597,NULL,NULL,'NGC 1866, 15, J','LMC',NULL,'2007A&A...462..599T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39655,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,NULL,39655,18.45,NULL,0.049,10597,NULL,NULL,'B, V, NIR','LMC',NULL,'1986ApJ...301..664M',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39656,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,NULL,39656,18.45,0.07,0.049,10597,NULL,NULL,'OGLE, I','LMC',NULL,'2004A&A...415..531S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39657,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,NULL,39657,18.45,0.05,0.049,10597,NULL,NULL,'OIII 3091, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39658,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,NULL,39658,18.45,0.05,0.049,10597,NULL,NULL,'HV 02580, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39659,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,NULL,39659,18.45,0.05,0.049,10597,NULL,NULL,'HV 01013, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39660,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39660,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1310, RA-DEC 05:14:16.2-69:19:47.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39661,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39661,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2192, RA-DEC 05:30:31.3-69:23:26.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39662,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39662,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2302, RA-DEC 05:32:18.4-70:22:47.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39663,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39663,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2417, RA-DEC 05:34:07.1-71:29:00.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39664,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39664,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2475, RA-DEC 05:35:19.7-70:19:22.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39665,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39665,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2491, RA-DEC 05:35:31.5-71:15:43.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39666,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39666,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3113, RA-DEC 05:45:35.3-70:42:29.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39667,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39667,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4037, RA-DEC 05:28:20.6-64:56:18.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39668,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39668,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4103, RA-DEC 05:31:46.1-65:21:01.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39669,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39669,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4106, RA-DEC 05:31:52.9-67:35:02.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39670,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39670,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4318, RA-DEC 05:43:18.5-67:20:35.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39671,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39671,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0030, RA-DEC 04:41:39.6-70:05:49.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39672,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39672,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0054, RA-DEC 04:44:06.1-70:05:43.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39673,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39673,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0435, RA-DEC 04:56:27.6-70:10:12.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39674,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39674,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1260, RA-DEC 05:13:07.9-69:03:09.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39675,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39675,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2541, RA-DEC 05:36:13.3-69:26:31.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39676,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39676,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3000, RA-DEC 05:42:40.7-71:46:20.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39677,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39677,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3170, RA-DEC 05:47:00.7-71:32:56.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39678,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39678,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3957, RA-DEC 05:24:29.2-65:36:16.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39679,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39679,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4007, RA-DEC 05:26:47.8-64:40:15.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39680,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39680,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4131, RA-DEC 05:32:58.9-65:38:45.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39681,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39681,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4212, RA-DEC 05:37:28.3-67:34:43.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39682,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39682,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4282, RA-DEC 05:41:27.9-67:17:58.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39683,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39683,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4373, RA-DEC 05:46:15.8-67:15:37.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39684,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39684,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4462, RA-DEC 05:50:11.2-67:39:13.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39685,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39685,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0285, RA-DEC 04:53:28.6-69:01:47.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39686,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39686,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0316, RA-DEC 04:54:12.9-67:49:30.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39687,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39687,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1338, RA-DEC 05:14:57.0-68:56:38.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39688,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39688,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1681, RA-DEC 05:21:16.4-69:52:02.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39689,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39689,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1913, RA-DEC 05:25:02.6-69:32:08.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39690,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39690,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1944, RA-DEC 05:25:30.4-68:50:20.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39691,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39691,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2106, RA-DEC 05:28:43.5-69:50:03.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39692,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39692,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2613, RA-DEC 05:36:59.2-70:07:41.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39693,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39693,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3314, RA-DEC 05:57:24.4-69:38:24.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39694,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39694,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3984, RA-DEC 05:25:41.7-64:37:02.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39695,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39695,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4229, RA-DEC 05:38:21.4-74:06:50.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39696,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39696,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4497, RA-DEC 05:52:33.7-67:13:00.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39697,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39697,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0612, RA-DEC 05:00:05.0-69:10:49.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39698,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39698,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0777, RA-DEC 05:02:59.7-67:11:05.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39699,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39699,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0813, RA-DEC 05:03:39.0-68:48:11.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39700,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39700,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1361, RA-DEC 05:15:16.9-69:08:09.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39701,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39701,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1798, RA-DEC 05:22:56.3-69:19:58.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39702,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39702,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2510, RA-DEC 05:35:42.2-70:14:30.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39703,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39703,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2617, RA-DEC 05:37:02.4-70:10:00.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39704,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39704,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2836, RA-DEC 05:39:58.2-69:00:20.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39705,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39705,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3326, RA-DEC 05:58:30.0-69:06:37.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39706,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39706,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3660, RA-DEC 05:10:45.1-66:03:10.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39707,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39707,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3673, RA-DEC 05:11:17.6-65:31:52.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39708,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39708,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3785, RA-DEC 05:15:47.0-65:57:37.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39709,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39709,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3997, RA-DEC 05:26:22.6-65:05:35.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39710,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39710,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4083, RA-DEC 05:30:33.5-66:04:19.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39711,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39711,18.45,0.06,0.049,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4371, RA-DEC 05:46:05.6-66:56:54.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39712,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39712,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1155, RA-DEC 05:10:21.8-70:46:40.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39713,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39713,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1196, RA-DEC 05:11:23.9-66:35:46.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39714,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39714,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1916, RA-DEC 05:25:10.2-71:51:38.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39715,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39715,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2081, RA-DEC 05:28:20.6-70:51:43.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39716,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39716,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2396, RA-DEC 05:33:49.9-70:22:40.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39717,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39717,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2425, RA-DEC 05:34:19.6-67:59:34.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39718,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39718,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2781, RA-DEC 05:39:15.5-70:18:48.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39719,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39719,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3057, RA-DEC 05:44:14.2-70:41:13.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39720,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39720,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3714, RA-DEC 05:12:54.0-65:11:13.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39721,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39721,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0883, RA-DEC 05:05:08.7-70:49:44.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39722,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39722,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1506, RA-DEC 05:17:44.7-69:35:58.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39723,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39723,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1860, RA-DEC 05:24:09.4-69:38:02.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39724,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39724,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2297, RA-DEC 05:32:07.5-70:12:01.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39725,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39725,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2777, RA-DEC 05:39:12.6-70:32:56.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39726,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39726,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4116, RA-DEC 05:32:43.4-72:28:27.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39727,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39727,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4142, RA-DEC 05:33:38.7-65:22:10.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39728,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39728,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0446, RA-DEC 04:56:41.0-68:35:11.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39729,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39729,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1351, RA-DEC 05:15:09.2-68:58:49.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39730,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39730,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2202, RA-DEC 05:30:39.2-69:25:43.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39731,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39731,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2408, RA-DEC 05:33:59.6-70:10:48.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39732,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39732,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3076, RA-DEC 05:44:33.3-71:29:32.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39733,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39733,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1121, RA-DEC 05:09:27.4-66:40:05.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39734,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39734,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1308, RA-DEC 05:14:14.9-69:02:19.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39735,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39735,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1831, RA-DEC 05:23:19.3-69:53:35.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39736,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39736,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1896, RA-DEC 05:24:38.1-70:10:21.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39737,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39737,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1958, RA-DEC 05:25:41.4-70:22:56.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39738,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39738,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2349, RA-DEC 05:33:16.4-70:03:53.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39739,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39739,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3233, RA-DEC 05:49:27.6-71:32:06.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39740,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39740,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3781, RA-DEC 05:15:32.5-66:22:47.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39741,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39741,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3784, RA-DEC 05:15:45.2-66:14:01.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39742,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39742,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3960, RA-DEC 05:24:39.0-66:25:51.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39743,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39743,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4068, RA-DEC 05:30:03.4-67:33:24.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39744,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39744,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0469, RA-DEC 04:57:13.5-68:41:05.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39745,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39745,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1147, RA-DEC 05:10:05.4-68:55:31.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39746,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39746,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1449, RA-DEC 05:16:29.1-69:32:08.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39747,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39747,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1866, RA-DEC 05:24:19.0-68:02:02.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39748,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39748,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2540, RA-DEC 05:36:12.0-69:21:45.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39749,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39749,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2821, RA-DEC 05:39:44.9-70:30:47.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39750,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39750,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2829, RA-DEC 05:39:51.3-70:28:52.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39751,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39751,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2985, RA-DEC 05:42:23.0-69:51:22.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39752,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39752,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3357, RA-DEC 06:11:34.4-71:09:41.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39753,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39753,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3392, RA-DEC 04:44:30.9-65:35:34.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39754,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39754,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3451, RA-DEC 04:53:44.1-72:20:22.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39755,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39755,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3867, RA-DEC 05:19:28.5-65:16:04.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39756,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39756,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3964, RA-DEC 05:24:49.5-63:25:33.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39757,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39757,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4436, RA-DEC 05:49:06.7-67:01:36.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39758,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39758,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4477, RA-DEC 05:51:11.4-67:53:35.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39759,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39759,18.45,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4511, RA-DEC 05:54:22.5-67:25:49.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39760,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39760,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0486, RA-DEC 04:57:40.9-68:33:59.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39761,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39761,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0946, RA-DEC 05:06:14.9-68:51:56.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39762,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39762,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2052, RA-DEC 05:27:37.0-69:56:27.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39763,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39763,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3517, RA-DEC 05:01:26.9-66:16:34.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39764,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39764,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4407, RA-DEC 05:47:54.7-66:17:54.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39765,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,NULL,39765,18.46,0.05,0.0491,10597,NULL,NULL,'OIII 2911, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39766,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39766,18.46,0.09,0.0491,10597,NULL,NULL,'HV 877, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39767,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39767,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0493, RA-DEC 04:57:45.7-68:14:21.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39768,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39768,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1263, RA-DEC 05:13:11.4-71:13:28.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39769,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39769,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2393, RA-DEC 05:33:45.7-68:29:22.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39770,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39770,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2459, RA-DEC 05:34:58.6-70:26:30.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39771,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39771,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2712, RA-DEC 05:38:17.0-70:19:37.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39772,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39772,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3184, RA-DEC 05:47:26.8-69:05:25.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39773,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39773,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3949, RA-DEC 05:23:50.7-66:27:18.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39774,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39774,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4082, RA-DEC 05:30:32.7-64:54:46.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39775,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39775,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4265, RA-DEC 05:40:40.1-65:00:04.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39776,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39776,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4325, RA-DEC 05:43:41.0-67:34:33.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39777,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39777,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0015, RA-DEC 04:38:32.3-69:21:09.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39778,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39778,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2770, RA-DEC 05:39:02.2-70:26:15.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39779,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39779,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2891, RA-DEC 05:40:43.8-69:39:28.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39780,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39780,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2912, RA-DEC 05:41:11.1-70:35:48.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39781,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39781,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2938, RA-DEC 05:41:29.3-69:55:03.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39782,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39782,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3084, RA-DEC 05:44:40.8-69:55:13.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39783,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39783,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3125, RA-DEC 05:45:54.7-70:35:44.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39784,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39784,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3408, RA-DEC 04:48:58.0-72:33:26.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39785,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39785,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3688, RA-DEC 05:11:58.8-66:21:25.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39786,'Cepheids','2016-12-15 15:14:07','2016-12-16 11:19:12','1',NULL,'R',39786,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3830, RA-DEC 05:17:21.1-67:44:54.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39787,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39787,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3840, RA-DEC 05:17:55.3-65:44:17.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39788,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39788,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3978, RA-DEC 05:25:26.1-66:15:52.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39789,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39789,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3988, RA-DEC 05:25:52.5-65:06:42.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39790,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39790,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4334, RA-DEC 05:44:05.9-67:23:14.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39791,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39791,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0046, RA-DEC 04:43:20.9-69:13:47.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39792,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39792,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0475, RA-DEC 04:57:21.9-67:51:17.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39793,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39793,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0725, RA-DEC 05:02:10.1-67:30:58.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39794,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39794,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0753, RA-DEC 05:02:28.4-70:31:17.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39795,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39795,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1375, RA-DEC 05:15:26.1-68:43:02.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39796,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39796,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2697, RA-DEC 05:38:04.8-70:27:34.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39797,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39797,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3567, RA-DEC 05:05:02.9-65:37:11.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39798,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39798,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4133, RA-DEC 05:33:00.5-66:16:14.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39799,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39799,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4450, RA-DEC 05:49:37.4-66:18:41.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39800,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39800,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0566, RA-DEC 04:59:12.4-71:02:28.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39801,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39801,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1370, RA-DEC 05:15:21.7-71:02:32.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39802,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39802,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1907, RA-DEC 05:24:52.7-70:00:55.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39803,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39803,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2117, RA-DEC 05:28:54.9-70:56:01.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39804,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39804,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2453, RA-DEC 05:34:45.1-69:59:19.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39805,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39805,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2473, RA-DEC 05:35:14.3-70:09:07.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39806,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39806,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3938, RA-DEC 05:22:59.3-65:10:28.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39807,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39807,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3939, RA-DEC 05:23:01.6-66:28:35.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39808,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39808,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4101, RA-DEC 05:31:38.5-64:53:55.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39809,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39809,18.46,0.06,0.0491,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4364, RA-DEC 05:45:33.4-67:21:21.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39810,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39810,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1401, RA-DEC 05:15:49.8-69:30:28.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39811,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39811,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1499, RA-DEC 05:17:38.4-69:45:19.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39812,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39812,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2289, RA-DEC 05:32:02.5-69:38:14.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39813,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39813,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2306, RA-DEC 05:32:23.3-70:12:52.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39814,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39814,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3159, RA-DEC 05:46:36.8-70:44:00.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39815,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39815,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3171, RA-DEC 05:47:00.8-70:46:19.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39816,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39816,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3631, RA-DEC 05:09:12.8-66:10:09.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39817,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39817,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4046, RA-DEC 05:28:39.8-66:04:28.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39818,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39818,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0574, RA-DEC 04:59:19.4-66:53:35.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39819,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39819,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1094, RA-DEC 05:08:54.9-68:43:10.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39820,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39820,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1341, RA-DEC 05:15:02.4-69:07:43.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39821,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39821,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1714, RA-DEC 05:21:52.6-69:39:59.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39822,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39822,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2559, RA-DEC 05:36:26.2-70:10:10.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39823,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39823,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2569, RA-DEC 05:36:31.4-69:28:17.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39824,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39824,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2774, RA-DEC 05:39:06.9-70:07:42.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39825,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39825,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2954, RA-DEC 05:41:53.5-70:31:41.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39826,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39826,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3677, RA-DEC 05:11:26.0-66:30:08.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39827,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39827,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3738, RA-DEC 05:13:38.9-65:27:57.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39828,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39828,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2472, RA-DEC 05:35:14.2-70:06:16.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39829,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39829,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2497, RA-DEC 05:35:33.6-70:59:28.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39830,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39830,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2553, RA-DEC 05:36:23.1-70:04:07.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39831,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39831,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2629, RA-DEC 05:37:15.5-70:10:52.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39832,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39832,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2933, RA-DEC 05:41:26.4-70:19:34.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39833,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39833,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4042, RA-DEC 05:28:33.3-67:38:18.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39834,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39834,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4370, RA-DEC 05:46:03.5-66:57:38.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39835,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39835,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4597, RA-DEC 06:11:07.2-64:15:58.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39836,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39836,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0911, RA-DEC 05:05:36.4-66:52:54.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39837,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39837,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1776, RA-DEC 05:22:39.2-69:58:09.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39838,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39838,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3011, RA-DEC 05:42:49.9-68:00:35.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39839,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39839,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3696, RA-DEC 05:12:22.6-66:02:53.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39840,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39840,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4001, RA-DEC 05:26:37.3-67:22:25.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39841,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39841,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4134, RA-DEC 05:33:01.6-65:44:49.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39842,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39842,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1773, RA-DEC 05:22:34.8-69:55:43.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39843,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39843,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2238, RA-DEC 05:31:05.1-70:10:05.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39844,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39844,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3013, RA-DEC 05:42:51.1-70:08:12.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39845,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39845,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4114, RA-DEC 05:32:39.1-65:16:09.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39846,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39846,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4159, RA-DEC 05:34:27.3-65:58:23.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39847,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39847,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4321, RA-DEC 05:43:24.8-67:12:25.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39848,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39848,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4449, RA-DEC 05:49:36.7-67:36:18.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39849,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39849,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4502, RA-DEC 05:52:41.5-67:25:27.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39850,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39850,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1879, RA-DEC 05:24:29.6-71:40:05.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39851,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39851,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2565, RA-DEC 05:36:28.9-70:23:09.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39852,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39852,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2602, RA-DEC 05:36:54.7-70:10:11.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39853,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39853,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2740, RA-DEC 05:38:40.4-70:21:18.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39854,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39854,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2861, RA-DEC 05:40:22.8-70:49:48.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39855,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39855,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3653, RA-DEC 05:10:30.6-65:50:53.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39856,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39856,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3745, RA-DEC 05:13:41.8-65:28:19.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39857,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39857,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3933, RA-DEC 05:22:44.0-66:09:42.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39858,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39858,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4296, RA-DEC 05:42:05.8-66:20:24.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39859,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39859,18.46,0.1,0.0492,10597,NULL,NULL,'HV 2527, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39860,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,NULL,39860,18.46,0.02,0.0492,10597,NULL,NULL,'BW, VIJHK, Barnes-Evans ISB, MWPL','LMC',NULL,'1998ApJ...496...17G',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39861,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39861,18.46,0.02,0.0492,10597,NULL,NULL,'CP-SBF(I)','LMC',NULL,'1999IAUS..190..534G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39862,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,NULL,39862,18.46,0.07,0.0492,10597,NULL,NULL,'OGLE, W','LMC',NULL,'2004A&A...415..531S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39863,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39863,18.46,0.06,0.0492,10597,NULL,NULL,'52, JHK','LMC',NULL,'1986PhDT........22W',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39864,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,NULL,39864,18.46,0.05,0.0492,10597,NULL,NULL,'HV 00999, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39865,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,NULL,39865,18.46,0.05,0.0492,10597,NULL,NULL,'HV 02815, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39866,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,NULL,39866,18.46,0.05,0.0492,10597,NULL,NULL,'HV 02793, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39867,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39867,18.46,0.02,0.0492,10597,NULL,NULL,'28, VIJHK','LMC',NULL,'1998ASPC..135..109G',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39868,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,NULL,39868,18.46,0.07,0.0492,10597,NULL,NULL,'36, V-Ks, IRSB Period-Wesenheit ','LMC',NULL,'2012MNRAS.424.1807R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39869,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,NULL,39869,18.46,0.07,0.0492,10597,NULL,NULL,'36, V-Ks, IRSB Period-Luminosity-Color','LMC',NULL,'2012MNRAS.424.1807R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39870,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,NULL,39870,18.46,0.03,0.0492,10597,NULL,NULL,'LMC Center, Weighted Mean','LMC',NULL,'2012MNRAS.424.1807R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39871,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,NULL,39871,18.46,0.04,0.0492,10597,NULL,NULL,'53, VIH','LMC',NULL,'2014MNRAS.440.1138E',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39872,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,NULL,39872,18.46,0.06,0.0492,10597,NULL,NULL,'1264, H, GAL PL','LMC',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39873,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,NULL,39873,18.46,0.09,0.0492,10597,NULL,NULL,'1264, HKs(W)','LMC',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39874,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39874,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0750, RA-DEC 05:02:26.8-67:09:18.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39875,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39875,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1409, RA-DEC 05:15:57.2-66:57:29.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39876,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39876,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2032, RA-DEC 05:27:11.3-69:56:13.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39877,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39877,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2635, RA-DEC 05:37:22.1-68:16:49.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39878,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39878,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2937, RA-DEC 05:41:27.5-70:47:45.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39879,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39879,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3269, RA-DEC 05:51:57.9-69:52:48.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39880,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39880,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3288, RA-DEC 05:53:16.2-69:19:21.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39881,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39881,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3464, RA-DEC 04:55:10.8-65:24:03.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39882,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39882,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3607, RA-DEC 05:07:45.2-66:06:33.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39883,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39883,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4019, RA-DEC 05:27:32.4-66:18:15.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39884,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39884,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4358, RA-DEC 05:45:10.6-66:53:12.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39885,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39885,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0792, RA-DEC 05:03:13.8-66:47:30.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39886,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39886,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1023, RA-DEC 05:07:33.7-70:48:22.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39887,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39887,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1837, RA-DEC 05:23:32.5-68:40:59.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39888,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39888,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2503, RA-DEC 05:35:35.9-71:06:39.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39889,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39889,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2731, RA-DEC 05:38:33.1-70:39:07.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39890,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39890,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3829, RA-DEC 05:17:14.7-66:25:13.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39891,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39891,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3952, RA-DEC 05:24:05.6-65:07:38.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39892,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39892,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4332, RA-DEC 05:43:59.8-66:45:37.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39893,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39893,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1172, RA-DEC 05:10:43.6-70:28:51.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39894,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39894,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1404, RA-DEC 05:15:52.4-69:28:16.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39895,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39895,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2191, RA-DEC 05:30:27.8-69:56:40.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39896,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39896,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2601, RA-DEC 05:36:54.7-69:56:26.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39897,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39897,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2798, RA-DEC 05:39:26.6-70:02:19.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39898,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39898,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3095, RA-DEC 05:45:00.2-70:44:40.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39899,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39899,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3145, RA-DEC 05:46:21.9-70:21:08.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39900,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39900,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3566, RA-DEC 05:04:57.1-71:53:43.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39901,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39901,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0870, RA-DEC 05:04:45.5-68:26:20.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39902,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39902,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1056, RA-DEC 05:08:12.5-66:51:39.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39903,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39903,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1562, RA-DEC 05:18:54.3-68:50:05.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39904,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39904,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2363, RA-DEC 05:33:30.0-70:40:22.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39905,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39905,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2732, RA-DEC 05:38:34.5-70:33:11.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39906,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39906,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2850, RA-DEC 05:40:09.9-70:27:45.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39907,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39907,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3045, RA-DEC 05:43:49.7-70:26:57.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39908,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39908,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3080, RA-DEC 05:44:36.4-70:39:05.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39909,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39909,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3351, RA-DEC 06:06:31.8-71:35:32.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39910,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39910,18.46,0.06,0.0492,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3801, RA-DEC 05:16:03.8-65:21:42.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39911,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39911,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1432, RA-DEC 05:16:10.6-71:08:56.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39912,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39912,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2409, RA-DEC 05:33:59.8-70:17:11.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39913,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39913,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2571, RA-DEC 05:36:34.3-70:05:20.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39914,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39914,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3841, RA-DEC 05:17:56.6-65:32:55.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39915,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39915,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4485, RA-DEC 05:52:00.4-65:20:54.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39916,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39916,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4533, RA-DEC 05:56:35.8-65:47:42.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39917,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39917,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0470, RA-DEC 04:57:15.8-68:17:47.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39918,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39918,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0729, RA-DEC 05:02:12.5-68:46:59.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39919,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39919,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1732, RA-DEC 05:22:08.2-69:55:36.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39920,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39920,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1984, RA-DEC 05:26:07.9-69:51:31.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39921,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39921,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2839, RA-DEC 05:40:00.7-70:42:35.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39922,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39922,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3470, RA-DEC 04:55:30.3-66:19:22.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39923,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39923,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4351, RA-DEC 05:45:00.6-67:44:43.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39924,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39924,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4476, RA-DEC 05:51:09.3-67:20:18.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39925,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39925,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0276, RA-DEC 04:53:15.2-68:53:05.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39926,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39926,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0746, RA-DEC 05:02:25.7-66:51:52.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39927,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39927,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1165, RA-DEC 05:10:34.5-69:13:43.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39928,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39928,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1306, RA-DEC 05:14:11.4-69:21:26.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39929,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39929,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1836, RA-DEC 05:23:31.0-69:58:18.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39930,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39930,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2290, RA-DEC 05:32:02.9-70:10:17.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39931,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39931,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2618, RA-DEC 05:37:02.8-70:07:53.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39932,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39932,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2648, RA-DEC 05:37:30.2-70:22:34.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39933,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39933,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3053, RA-DEC 05:44:01.0-71:00:02.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39934,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39934,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3083, RA-DEC 05:44:38.2-70:37:36.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39935,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39935,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4020, RA-DEC 05:27:33.7-66:47:34.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39936,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39936,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4093, RA-DEC 05:31:16.3-66:24:38.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39937,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39937,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4582, RA-DEC 06:06:09.5-66:37:40.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39938,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39938,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1756, RA-DEC 05:22:27.3-69:53:24.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39939,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39939,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1805, RA-DEC 05:23:02.5-71:45:20.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39940,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39940,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2476, RA-DEC 05:35:20.5-69:59:10.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39941,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39941,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2775, RA-DEC 05:39:08.1-70:20:16.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39942,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39942,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4110, RA-DEC 05:32:10.3-66:46:50.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39943,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39943,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4395, RA-DEC 05:47:20.6-67:13:21.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39944,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39944,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4585, RA-DEC 06:07:30.6-66:57:35.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39945,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39945,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0891, RA-DEC 05:05:19.1-70:32:04.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39946,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39946,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1823, RA-DEC 05:23:13.9-69:36:36.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39947,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39947,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1990, RA-DEC 05:26:19.0-69:48:08.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39948,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39948,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2026, RA-DEC 05:27:03.0-70:28:15.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39949,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39949,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2145, RA-DEC 05:29:33.2-69:21:01.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39950,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39950,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2576, RA-DEC 05:36:39.2-70:16:03.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39951,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39951,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2591, RA-DEC 05:36:52.7-70:09:30.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39952,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39952,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2649, RA-DEC 05:37:32.8-68:42:40.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39953,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39953,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2906, RA-DEC 05:41:05.9-69:03:18.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39954,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39954,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3248, RA-DEC 05:50:11.1-69:41:22.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39955,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39955,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3279, RA-DEC 05:52:54.4-69:29:39.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39956,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39956,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1573, RA-DEC 05:19:07.3-69:22:56.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39957,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39957,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1590, RA-DEC 05:19:30.3-68:57:36.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39958,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39958,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1683, RA-DEC 05:21:20.1-69:40:54.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39959,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39959,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2533, RA-DEC 05:36:05.3-70:04:27.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39960,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39960,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2940, RA-DEC 05:41:34.2-70:17:22.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39961,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39961,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3002, RA-DEC 05:42:43.5-70:29:41.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39962,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39962,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3210, RA-DEC 05:48:18.2-71:27:31.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39963,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39963,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3272, RA-DEC 05:52:05.9-70:45:03.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39964,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39964,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3435, RA-DEC 04:52:50.3-71:17:57.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39965,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39965,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3491, RA-DEC 04:58:56.5-66:21:51.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39966,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39966,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4602, RA-DEC 06:12:34.5-68:44:21.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39967,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,NULL,39967,18.46,0.05,0.0493,10597,NULL,NULL,'HV 02787, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39968,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39968,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0048, RA-DEC 04:43:31.5-69:37:28.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39969,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39969,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0225, RA-DEC 04:52:14.6-66:35:32.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39970,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39970,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0956, RA-DEC 05:06:29.4-68:54:20.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39971,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39971,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0976, RA-DEC 05:06:58.6-67:40:44.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39972,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39972,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1214, RA-DEC 05:11:53.3-69:06:48.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39973,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39973,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1287, RA-DEC 05:13:50.4-69:05:01.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39974,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39974,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2341, RA-DEC 05:33:07.1-71:12:02.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39975,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39975,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2579, RA-DEC 05:36:44.9-70:39:38.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39976,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39976,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2616, RA-DEC 05:37:01.9-70:07:41.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39977,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39977,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3029, RA-DEC 05:43:11.0-70:35:05.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39978,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39978,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3481, RA-DEC 04:57:05.9-66:06:39.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39979,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39979,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3956, RA-DEC 05:24:29.1-72:17:06.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39980,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39980,18.46,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4350, RA-DEC 05:44:57.1-66:23:11.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39981,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39981,18.47,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1100, RA-DEC 05:09:04.4-70:21:54.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39982,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39982,18.47,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2523, RA-DEC 05:35:53.9-68:39:34.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39983,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39983,18.47,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2639, RA-DEC 05:37:23.5-70:11:43.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39984,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39984,18.47,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2711, RA-DEC 05:38:16.7-70:34:56.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39985,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39985,18.47,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2717, RA-DEC 05:38:19.6-70:16:19.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39986,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39986,18.47,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3404, RA-DEC 04:48:28.6-71:19:58.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39987,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39987,18.47,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4002, RA-DEC 05:26:37.7-64:13:08.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39988,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39988,18.47,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0211, RA-DEC 04:51:56.1-69:20:36.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39989,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39989,18.47,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0292, RA-DEC 04:53:35.0-66:38:55.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39990,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39990,18.47,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0373, RA-DEC 04:55:11.6-69:19:44.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39991,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39991,18.47,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0695, RA-DEC 05:01:39.4-66:57:51.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39992,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39992,18.47,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0767, RA-DEC 05:02:48.3-67:14:24.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39993,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39993,18.47,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0823, RA-DEC 05:03:50.7-69:20:47.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39994,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39994,18.47,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0906, RA-DEC 05:05:32.4-68:41:32.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39995,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39995,18.47,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2107, RA-DEC 05:28:44.4-69:50:05.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39996,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39996,18.47,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2128, RA-DEC 05:29:15.3-69:30:40.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39997,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39997,18.47,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2457, RA-DEC 05:34:56.1-69:40:46.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39998,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39998,18.47,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3235, RA-DEC 05:49:31.2-69:45:16.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(39999,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',39999,18.47,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0315, RA-DEC 04:54:11.3-69:33:47.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40000,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40000,18.47,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1655, RA-DEC 05:20:44.2-69:57:15.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40001,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40001,18.47,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2150, RA-DEC 05:29:38.5-69:47:29.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40002,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40002,18.47,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2437, RA-DEC 05:34:29.3-70:11:56.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40003,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40003,18.47,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2845, RA-DEC 05:40:05.2-70:30:11.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40004,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40004,18.47,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2913, RA-DEC 05:41:11.1-69:32:27.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40005,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40005,18.47,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3065, RA-DEC 05:44:22.5-70:43:35.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40006,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40006,18.47,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4000, RA-DEC 05:26:33.9-66:31:07.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40007,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40007,18.47,0.06,0.0493,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4028, RA-DEC 05:28:03.5-66:48:48.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40008,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40008,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1005, RA-DEC 05:07:23.6-70:32:12.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40009,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40009,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2054, RA-DEC 05:27:40.0-69:55:45.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40010,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40010,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2317, RA-DEC 05:32:37.9-70:04:57.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40011,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40011,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2689, RA-DEC 05:37:54.5-70:23:49.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40012,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40012,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3085, RA-DEC 05:44:40.9-69:41:45.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40013,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40013,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4015, RA-DEC 05:27:20.1-66:47:06.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40014,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40014,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4355, RA-DEC 05:45:08.4-66:40:51.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40015,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40015,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4565, RA-DEC 06:01:09.3-68:18:11.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40016,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40016,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1634, RA-DEC 05:20:19.1-69:26:45.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40017,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40017,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1661, RA-DEC 05:20:52.4-69:21:13.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40018,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40018,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1799, RA-DEC 05:22:59.5-70:33:24.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40019,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40019,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2060, RA-DEC 05:27:47.1-69:19:38.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40020,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40020,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2070, RA-DEC 05:27:59.0-68:46:20.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40021,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40021,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2175, RA-DEC 05:30:11.8-69:52:02.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40022,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40022,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2350, RA-DEC 05:33:18.4-70:10:03.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40023,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40023,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2633, RA-DEC 05:37:17.9-70:17:42.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40024,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40024,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2794, RA-DEC 05:39:23.4-71:00:45.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40025,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40025,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3186, RA-DEC 05:47:29.0-70:40:44.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40026,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40026,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3521, RA-DEC 05:01:43.5-66:06:22.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40027,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40027,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3633, RA-DEC 05:09:16.6-64:42:10.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40028,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40028,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3724, RA-DEC 05:13:25.1-65:29:29.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40029,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40029,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3905, RA-DEC 05:21:45.2-65:14:09.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40030,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40030,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3919, RA-DEC 05:22:09.7-65:57:08.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40031,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40031,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4487, RA-DEC 05:52:07.3-67:15:20.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40032,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40032,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1858, RA-DEC 05:24:07.2-71:10:17.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40033,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40033,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1884, RA-DEC 05:24:33.3-69:36:40.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40034,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40034,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2085, RA-DEC 05:28:22.9-69:51:36.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40035,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40035,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2276, RA-DEC 05:31:47.6-70:25:00.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40036,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40036,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2558, RA-DEC 05:36:25.6-70:05:24.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40037,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40037,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2768, RA-DEC 05:38:58.8-70:23:56.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40038,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40038,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3046, RA-DEC 05:43:55.4-71:44:38.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40039,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40039,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3705, RA-DEC 05:12:35.2-71:38:21.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40040,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40040,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3972, RA-DEC 05:25:16.5-66:51:09.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40041,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40041,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4086, RA-DEC 05:30:46.2-66:50:14.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40042,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40042,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1128, RA-DEC 05:09:37.0-68:02:43.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40043,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40043,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2784, RA-DEC 05:39:16.9-70:53:50.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40044,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40044,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3157, RA-DEC 05:46:35.7-69:07:04.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40045,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40045,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3545, RA-DEC 05:03:47.4-66:15:37.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40046,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40046,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3748, RA-DEC 05:13:45.5-65:27:37.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40047,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40047,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3959, RA-DEC 05:24:37.6-72:26:24.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40048,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40048,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3999, RA-DEC 05:26:26.6-65:05:38.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40049,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40049,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4507, RA-DEC 05:54:06.3-66:12:28.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40050,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40050,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4537, RA-DEC 05:56:57.3-66:07:32.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40051,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40051,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0177, RA-DEC 04:50:56.4-69:12:51.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40052,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40052,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0734, RA-DEC 05:02:17.4-70:29:42.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40053,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40053,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0893, RA-DEC 05:05:22.2-68:24:07.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40054,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40054,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1501, RA-DEC 05:17:40.7-69:32:43.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40055,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40055,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3015, RA-DEC 05:42:53.7-71:08:31.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40056,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40056,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3562, RA-DEC 05:04:48.4-66:21:39.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40057,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40057,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3678, RA-DEC 05:11:34.5-65:47:26.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40058,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40058,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4219, RA-DEC 05:37:53.7-66:56:48.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40059,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40059,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4234, RA-DEC 05:38:30.7-66:30:27.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40060,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40060,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4562, RA-DEC 06:00:51.5-67:25:39.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40061,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40061,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0460, RA-DEC 04:57:01.6-67:29:28.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40062,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40062,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0990, RA-DEC 05:07:14.9-68:06:44.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40063,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40063,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0997, RA-DEC 05:07:18.6-66:34:52.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40064,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40064,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1560, RA-DEC 05:18:51.1-69:39:12.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40065,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40065,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1983, RA-DEC 05:26:06.3-69:50:24.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40066,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40066,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2167, RA-DEC 05:30:02.0-69:11:38.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40067,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:12','1',NULL,'R',40067,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2646, RA-DEC 05:37:30.0-70:13:57.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40068,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40068,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2916, RA-DEC 05:41:13.4-70:47:43.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40069,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40069,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2928, RA-DEC 05:41:21.8-70:26:25.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40070,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40070,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3142, RA-DEC 05:46:16.6-71:17:29.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40071,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40071,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3320, RA-DEC 05:57:46.9-68:41:04.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40072,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40072,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3506, RA-DEC 05:00:21.5-66:25:21.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40073,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40073,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3572, RA-DEC 05:05:17.6-65:30:09.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40074,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40074,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3752, RA-DEC 05:13:57.9-65:28:39.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40075,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40075,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3995, RA-DEC 05:26:12.0-66:25:05.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40076,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40076,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4138, RA-DEC 05:33:27.1-66:09:49.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40077,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40077,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4548, RA-DEC 05:58:24.9-65:23:25.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40078,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40078,18.47,0.2,0.0494,10597,NULL,NULL,'NGC 1866, 4, VI(BW)','LMC',NULL,'1994ApJ...433L..73G',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40079,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40079,18.47,0.07,0.0494,10597,NULL,NULL,'OGLE, V','LMC',NULL,'2004A&A...415..531S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40080,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40080,18.47,0.03,0.0494,10597,NULL,NULL,'K','LMC',NULL,'2007MNRAS.379..723V',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40081,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40081,18.47,0.03,0.0494,10597,NULL,NULL,'K, GAL+LMC PL','LMC',NULL,'2007MNRAS.379..723V',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40082,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40082,18.47,0.03,0.0494,10597,NULL,NULL,NULL,'LMC',NULL,'2010vsgh.conf...45F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40083,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40083,18.47,0.15,0.0494,10597,NULL,NULL,NULL,'LMC',NULL,'1987ARA&A..25..345F',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40084,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40084,18.47,0.05,0.0494,10597,NULL,NULL,'HV 00997, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40085,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40085,18.47,0.05,0.0494,10597,NULL,NULL,'HV 01005, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40086,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40086,18.47,0.05,0.0494,10597,NULL,NULL,'HV 02789, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40087,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40087,18.47,0.05,0.0494,10597,NULL,NULL,'HV 02755, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40088,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40088,18.47,0.05,0.0494,10597,NULL,NULL,'HV 01003, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40089,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40089,18.47,0.07,0.0494,10597,NULL,NULL,'LMC Center, 9. V-Ks, Baade-Wesselink Period-Wesenheit ','LMC',NULL,'2012MNRAS.424.1807R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40090,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40090,18.47,0.07,0.0494,10597,NULL,NULL,'LMC Center, 9. V-Ks, Baade-Wesselink Period-Luminosity-Color ','LMC',NULL,'2012MNRAS.424.1807R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40091,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40091,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0376, RA-DEC 04:55:14.4-66:58:34.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40092,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40092,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3817, RA-DEC 05:16:42.0-64:45:01.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40093,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40093,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3859, RA-DEC 05:18:52.8-65:13:01.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40094,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40094,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3966, RA-DEC 05:24:58.0-65:58:13.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40095,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40095,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0011, RA-DEC 04:37:40.2-69:57:38.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40096,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40096,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0081, RA-DEC 04:47:13.4-66:39:01.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40097,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40097,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0547, RA-DEC 04:58:48.6-70:08:56.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40098,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40098,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1037, RA-DEC 05:07:59.2-67:11:56.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40099,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40099,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1354, RA-DEC 05:15:10.8-69:32:22.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40100,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40100,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1394, RA-DEC 05:15:43.7-69:02:55.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40101,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40101,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1597, RA-DEC 05:19:33.0-70:35:18.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40102,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40102,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2318, RA-DEC 05:32:38.7-71:44:24.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40103,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40103,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2454, RA-DEC 05:34:47.4-69:54:51.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40104,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40104,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3680, RA-DEC 05:11:37.1-64:34:37.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40105,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40105,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0747, RA-DEC 05:02:26.2-68:02:47.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40106,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40106,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0900, RA-DEC 05:05:28.6-67:15:48.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40107,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40107,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2057, RA-DEC 05:27:43.5-70:08:42.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40108,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40108,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2094, RA-DEC 05:28:31.9-69:50:54.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40109,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40109,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2386, RA-DEC 05:33:42.4-70:58:52.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40110,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40110,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2585, RA-DEC 05:36:51.0-70:09:52.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40111,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40111,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2594, RA-DEC 05:36:53.2-71:08:08.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40112,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40112,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2943, RA-DEC 05:41:35.3-70:57:51.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40113,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40113,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3230, RA-DEC 05:49:16.5-70:43:02.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40114,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40114,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3394, RA-DEC 04:44:56.1-66:15:33.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40115,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40115,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3942, RA-DEC 05:23:25.1-64:19:15.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40116,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40116,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4425, RA-DEC 05:48:30.1-66:39:16.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40117,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40117,18.47,0.06,0.0494,10597,NULL,NULL,'1264, H','LMC',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40118,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40118,18.47,0.06,0.0494,10597,NULL,NULL,'1264, Ks','LMC',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40119,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40119,18.47,0.07,0.0494,10597,NULL,NULL,'1264, mean of 9','LMC',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40120,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40120,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0509, RA-DEC 04:58:04.1-69:27:54.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40121,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40121,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0658, RA-DEC 05:00:57.2-70:08:32.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40122,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40122,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0979, RA-DEC 05:07:02.1-68:42:39.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40123,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40123,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1808, RA-DEC 05:23:04.7-69:16:57.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40124,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40124,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1923, RA-DEC 05:25:18.3-70:45:35.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40125,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40125,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2444, RA-DEC 05:34:38.5-70:04:43.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40126,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40126,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2824, RA-DEC 05:39:46.7-70:19:30.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40127,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40127,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2932, RA-DEC 05:41:24.8-68:43:05.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40128,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40128,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3207, RA-DEC 05:48:14.9-70:12:27.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40129,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40129,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3292, RA-DEC 05:53:32.1-69:48:44.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40130,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40130,18.47,0.06,0.0494,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3706, RA-DEC 05:12:35.9-65:31:38.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40131,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40131,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0771, RA-DEC 05:02:51.8-69:25:31.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40132,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40132,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1149, RA-DEC 05:10:12.0-68:10:13.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40133,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40133,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2046, RA-DEC 05:27:28.6-70:10:31.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40134,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40134,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2570, RA-DEC 05:36:33.7-70:09:49.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40135,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40135,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2869, RA-DEC 05:40:31.1-70:23:54.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40136,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40136,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3807, RA-DEC 05:16:17.5-65:39:43.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40137,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40137,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0343, RA-DEC 04:54:46.7-68:49:47.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40138,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40138,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0927, RA-DEC 05:05:53.4-68:07:08.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40139,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40139,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2433, RA-DEC 05:34:27.9-69:49:01.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40140,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40140,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2923, RA-DEC 05:41:17.3-70:07:30.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40141,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40141,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3513, RA-DEC 05:01:05.3-66:20:02.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40142,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40142,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3619, RA-DEC 05:08:45.6-65:39:40.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40143,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40143,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4109, RA-DEC 05:32:05.8-72:11:24.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40144,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40144,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4320, RA-DEC 05:43:19.7-67:02:55.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40145,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40145,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0478, RA-DEC 04:57:25.1-69:34:02.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40146,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40146,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0874, RA-DEC 05:04:53.0-67:11:58.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40147,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40147,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1188, RA-DEC 05:11:11.3-69:12:29.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40148,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40148,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1206, RA-DEC 05:11:39.9-68:49:57.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40149,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40149,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1939, RA-DEC 05:25:28.8-69:54:44.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40150,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40150,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2090, RA-DEC 05:28:29.6-69:52:36.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40151,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40151,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2254, RA-DEC 05:31:22.3-70:03:33.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40152,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40152,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2456, RA-DEC 05:34:51.9-69:24:06.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40153,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40153,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2514, RA-DEC 05:35:44.6-71:11:32.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40154,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40154,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2647, RA-DEC 05:37:30.2-71:47:31.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40155,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40155,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3132, RA-DEC 05:46:04.2-70:03:35.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40156,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40156,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3304, RA-DEC 05:55:20.7-68:41:20.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40157,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40157,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3716, RA-DEC 05:13:08.0-66:27:37.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40158,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40158,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4522, RA-DEC 05:55:20.0-67:35:01.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40159,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40159,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0483, RA-DEC 04:57:31.3-67:04:44.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40160,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40160,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0634, RA-DEC 05:00:32.6-70:06:09.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40161,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40161,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2198, RA-DEC 05:30:37.5-69:46:42.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40162,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40162,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2340, RA-DEC 05:33:06.7-68:45:26.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40163,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40163,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3617, RA-DEC 05:08:29.3-71:52:15.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40164,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40164,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0226, RA-DEC 04:52:15.4-68:49:44.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40165,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40165,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0778, RA-DEC 05:02:59.8-69:17:12.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40166,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40166,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1167, RA-DEC 05:10:36.3-67:51:25.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40167,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40167,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1251, RA-DEC 05:12:48.4-70:13:40.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40168,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40168,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1534, RA-DEC 05:18:09.1-69:56:30.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40169,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40169,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3457, RA-DEC 04:54:25.9-66:06:35.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40170,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40170,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4388, RA-DEC 05:46:53.0-67:44:21.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40171,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40171,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0078, RA-DEC 04:47:01.0-70:05:52.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40172,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40172,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0575, RA-DEC 04:59:20.8-68:08:52.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40173,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40173,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0649, RA-DEC 05:00:53.8-68:51:02.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40174,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40174,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1140, RA-DEC 05:09:56.3-68:59:40.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40175,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40175,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1248, RA-DEC 05:12:46.8-69:21:21.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40176,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40176,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2381, RA-DEC 05:33:41.5-71:26:29.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40177,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40177,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2609, RA-DEC 05:36:58.2-70:39:51.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40178,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40178,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2887, RA-DEC 05:40:40.8-71:08:18.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40179,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40179,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2930, RA-DEC 05:41:23.6-70:16:57.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40180,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40180,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3252, RA-DEC 05:50:22.7-68:45:47.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40181,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40181,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3576, RA-DEC 05:05:41.3-65:59:06.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40182,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40182,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3723, RA-DEC 05:13:22.1-65:30:12.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40183,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40183,18.47,0.05,0.0495,10597,NULL,NULL,'HV 01019, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40184,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40184,18.47,0.05,0.0495,10597,NULL,NULL,'HV 01006, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40185,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40185,18.48,0.05,0.0495,10597,NULL,NULL,'HV 00953, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40186,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40186,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0201, RA-DEC 04:51:31.8-68:13:32.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40187,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40187,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0258, RA-DEC 04:52:54.2-69:16:35.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40188,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40188,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0420, RA-DEC 04:56:08.5-68:06:15.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40189,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40189,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1592, RA-DEC 05:19:31.5-69:29:09.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40190,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40190,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2950, RA-DEC 05:41:50.4-70:23:36.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40191,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40191,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3141, RA-DEC 05:46:14.3-70:41:18.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40192,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40192,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3245, RA-DEC 05:50:04.9-70:36:05.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40193,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40193,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3337, RA-DEC 06:01:58.1-69:25:28.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40194,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40194,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3796, RA-DEC 05:15:58.9-65:13:24.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40195,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40195,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4167, RA-DEC 05:35:02.3-64:52:44.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40196,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40196,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4259, RA-DEC 05:40:10.4-65:34:50.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40197,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40197,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4429, RA-DEC 05:48:48.3-67:37:32.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40198,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40198,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4466, RA-DEC 05:50:27.1-67:59:33.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40199,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40199,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0917, RA-DEC 05:05:44.0-68:59:51.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40200,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40200,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0933, RA-DEC 05:05:59.2-66:47:15.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40201,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40201,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1126, RA-DEC 05:09:30.3-66:44:14.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40202,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40202,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1186, RA-DEC 05:11:10.1-66:35:58.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40203,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40203,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2271, RA-DEC 05:31:43.5-70:01:34.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40204,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40204,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2293, RA-DEC 05:32:04.2-70:43:38.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40205,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40205,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2713, RA-DEC 05:38:17.1-70:22:54.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40206,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40206,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2735, RA-DEC 05:38:35.9-70:22:07.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40207,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40207,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3180, RA-DEC 05:47:22.4-70:10:53.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40208,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40208,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3502, RA-DEC 05:00:15.2-65:43:38.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40209,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40209,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3592, RA-DEC 05:07:01.4-66:10:57.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40210,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40210,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0125, RA-DEC 04:49:32.1-67:47:37.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40211,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40211,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0828, RA-DEC 05:03:53.5-66:43:07.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40212,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40212,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0887, RA-DEC 05:05:15.4-68:19:16.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40213,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40213,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0987, RA-DEC 05:07:09.2-67:19:58.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40214,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40214,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2049, RA-DEC 05:27:32.6-69:49:14.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40215,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40215,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2315, RA-DEC 05:32:36.4-69:57:36.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40216,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40216,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2634, RA-DEC 05:37:18.7-71:06:45.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40217,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40217,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3027, RA-DEC 05:43:09.1-69:36:38.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40218,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40218,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3199, RA-DEC 05:47:53.4-70:38:38.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40219,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40219,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3669, RA-DEC 05:11:11.1-66:22:32.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40220,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40220,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4273, RA-DEC 05:41:02.1-72:34:28.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40221,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40221,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4302, RA-DEC 05:42:17.5-67:39:30.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40222,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40222,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4378, RA-DEC 05:46:27.3-67:40:50.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40223,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40223,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0051, RA-DEC 04:43:44.2-70:18:14.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40224,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40224,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0592, RA-DEC 04:59:42.1-68:07:15.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40225,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40225,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0621, RA-DEC 05:00:11.1-67:21:46.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40226,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40226,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0708, RA-DEC 05:01:51.9-69:23:22.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40227,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40227,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1292, RA-DEC 05:13:56.4-69:00:55.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40228,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40228,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1526, RA-DEC 05:18:03.8-69:25:36.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40229,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40229,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2155, RA-DEC 05:29:48.1-68:54:02.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40230,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40230,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2245, RA-DEC 05:31:13.0-69:25:59.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40231,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40231,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2555, RA-DEC 05:36:23.8-70:59:02.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40232,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40232,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2814, RA-DEC 05:39:41.0-70:20:00.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40233,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40233,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3601, RA-DEC 05:07:30.9-71:44:30.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40234,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40234,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3903, RA-DEC 05:21:39.6-65:14:07.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40235,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40235,18.47,0.06,0.0495,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4323, RA-DEC 05:43:31.7-66:52:46.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40236,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40236,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0562, RA-DEC 04:59:07.3-67:21:04.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40237,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40237,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1082, RA-DEC 05:08:46.3-68:45:39.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40238,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40238,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1414, RA-DEC 05:15:58.6-69:38:08.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40239,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40239,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1676, RA-DEC 05:21:11.5-68:57:41.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40240,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40240,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2193, RA-DEC 05:30:32.6-70:45:51.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40241,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40241,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2680, RA-DEC 05:37:47.6-70:13:48.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40242,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40242,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3203, RA-DEC 05:48:06.9-71:30:21.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40243,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40243,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3246, RA-DEC 05:50:05.8-70:35:30.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40244,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40244,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3332, RA-DEC 05:58:54.2-68:31:09.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40245,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40245,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4268, RA-DEC 05:40:48.4-67:26:08.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40246,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40246,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0260, RA-DEC 04:52:57.4-68:17:27.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40247,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40247,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1647, RA-DEC 05:20:37.4-69:30:56.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40248,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40248,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1946, RA-DEC 05:25:31.7-71:22:17.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40249,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40249,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3581, RA-DEC 05:05:56.5-64:39:27.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40250,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40250,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0323, RA-DEC 04:54:21.3-68:35:07.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40251,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40251,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0530, RA-DEC 04:58:33.1-68:46:22.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40252,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40252,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1145, RA-DEC 05:10:03.0-69:01:16.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40253,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40253,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1900, RA-DEC 05:24:42.0-70:41:17.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40254,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40254,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2248, RA-DEC 05:31:17.2-70:03:29.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40255,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40255,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2907, RA-DEC 05:41:06.5-70:24:18.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40256,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40256,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4538, RA-DEC 05:57:04.2-64:32:51.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40257,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40257,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1846, RA-DEC 05:23:47.6-70:30:13.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40258,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40258,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2573, RA-DEC 05:36:35.9-70:09:14.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40259,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40259,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2776, RA-DEC 05:39:11.7-71:13:35.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40260,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40260,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2974, RA-DEC 05:42:13.6-70:09:13.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40261,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40261,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2982, RA-DEC 05:42:21.1-70:32:40.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40262,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40262,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3434, RA-DEC 04:52:49.2-66:18:28.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40263,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40263,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3570, RA-DEC 05:05:13.8-66:06:28.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40264,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40264,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4053, RA-DEC 05:29:03.1-66:31:32.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40265,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40265,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0161, RA-DEC 04:50:29.0-68:06:53.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40266,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40266,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1318, RA-DEC 05:14:29.6-68:54:35.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40267,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40267,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1398, RA-DEC 05:15:48.0-69:55:03.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40268,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40268,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1689, RA-DEC 05:21:25.2-69:52:51.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40269,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40269,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3783, RA-DEC 05:15:38.8-65:15:29.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40270,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40270,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3860, RA-DEC 05:18:55.7-66:30:40.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40271,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40271,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3940, RA-DEC 05:23:03.5-66:51:04.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40272,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40272,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4303, RA-DEC 05:42:25.3-66:42:29.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40273,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40273,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1305, RA-DEC 05:14:11.1-68:55:34.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40274,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40274,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1919, RA-DEC 05:25:12.9-69:56:51.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40275,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40275,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2092, RA-DEC 05:28:30.5-70:20:37.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40276,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40276,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2109, RA-DEC 05:28:45.5-69:52:06.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40277,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40277,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2243, RA-DEC 05:31:10.8-71:48:58.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40278,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40278,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2506, RA-DEC 05:35:38.7-70:14:20.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40279,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40279,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2574, RA-DEC 05:36:36.5-70:09:06.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40280,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40280,18.48,0.01,0.0496,10597,NULL,NULL,'80, 3.6 micron, 0.033 mag systematic error','LMC',NULL,'2012ApJ...758...24F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40281,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40281,18.48,0.05,0.0496,10597,NULL,NULL,'OIII 2562, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40282,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40282,18.48,0.05,0.0496,10597,NULL,NULL,'HV 12656, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40283,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40283,18.48,0.05,0.0496,10597,NULL,NULL,'HV 02647, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40284,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40284,18.48,0.05,0.0496,10597,NULL,NULL,'HV 02791, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40285,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40285,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0022, RA-DEC 04:39:52.9-69:49:55.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40286,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40286,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0180, RA-DEC 04:51:02.5-69:54:49.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40287,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40287,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0472, RA-DEC 04:57:18.4-69:54:00.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40288,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40288,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0572, RA-DEC 04:59:17.5-68:33:17.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40289,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40289,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0892, RA-DEC 05:05:19.4-68:05:12.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40290,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40290,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1752, RA-DEC 05:22:23.3-69:29:49.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40291,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40291,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2479, RA-DEC 05:35:22.0-69:58:08.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40292,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40292,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2951, RA-DEC 05:41:50.6-70:25:05.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40293,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40293,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3546, RA-DEC 05:03:59.8-66:06:25.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40294,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40294,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3994, RA-DEC 05:26:11.5-64:54:14.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40295,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40295,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4136, RA-DEC 05:33:20.4-64:36:42.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40296,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40296,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4260, RA-DEC 05:40:11.5-66:41:02.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40297,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40297,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4316, RA-DEC 05:43:11.8-67:19:39.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40298,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40298,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1519, RA-DEC 05:17:59.2-71:41:52.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40299,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40299,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1577, RA-DEC 05:19:12.4-69:55:54.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40300,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40300,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2089, RA-DEC 05:28:27.7-68:56:53.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40301,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40301,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3105, RA-DEC 05:45:21.1-70:49:06.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40302,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40302,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3551, RA-DEC 05:04:12.7-65:29:38.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40303,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40303,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3936, RA-DEC 05:22:45.6-67:11:12.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40304,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40304,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4008, RA-DEC 05:26:56.4-65:08:36.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40305,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40305,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4097, RA-DEC 05:31:31.8-64:53:05.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40306,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40306,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4308, RA-DEC 05:42:47.5-67:13:57.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40307,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40307,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0666, RA-DEC 05:01:02.1-69:20:09.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40308,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40308,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1415, RA-DEC 05:15:59.9-69:47:35.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40309,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40309,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2354, RA-DEC 05:33:22.8-69:57:19.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40310,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40310,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2428, RA-DEC 05:34:20.7-70:35:48.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40311,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40311,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2703, RA-DEC 05:38:09.7-70:22:40.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40312,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40312,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3014, RA-DEC 05:42:52.9-70:40:11.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40313,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40313,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3769, RA-DEC 05:14:50.8-66:20:47.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40314,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40314,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3983, RA-DEC 05:25:40.4-66:58:10.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40315,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40315,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4003, RA-DEC 05:26:39.6-66:06:18.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40316,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40316,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0369, RA-DEC 04:55:06.6-71:04:53.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40317,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40317,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0797, RA-DEC 05:03:22.9-67:28:55.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40318,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40318,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0980, RA-DEC 05:07:02.1-69:10:17.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40319,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40319,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1148, RA-DEC 05:10:08.2-68:56:27.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40320,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40320,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1266, RA-DEC 05:13:13.4-70:18:42.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40321,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40321,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1550, RA-DEC 05:18:38.9-69:35:16.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40322,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40322,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2492, RA-DEC 05:35:31.8-69:43:22.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40323,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40323,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3523, RA-DEC 05:01:51.1-66:07:53.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40324,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40324,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3583, RA-DEC 05:06:05.2-64:50:17.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40325,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40325,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3744, RA-DEC 05:13:41.1-65:27:50.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40326,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40326,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4250, RA-DEC 05:39:57.2-66:26:30.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40327,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40327,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4311, RA-DEC 05:42:50.2-65:01:51.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40328,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40328,18.48,0.06,0.0496,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4508, RA-DEC 05:54:07.7-67:33:44.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40329,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40329,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0208, RA-DEC 04:51:47.9-69:29:25.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40330,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40330,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0409, RA-DEC 04:55:53.6-68:37:14.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40331,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40331,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0476, RA-DEC 04:57:22.0-68:12:33.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40332,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40332,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0591, RA-DEC 04:59:41.3-67:44:17.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40333,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40333,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1430, RA-DEC 05:16:08.0-69:01:51.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40334,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40334,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1473, RA-DEC 05:17:02.3-68:49:16.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40335,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40335,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1554, RA-DEC 05:18:42.3-69:11:15.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40336,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40336,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1721, RA-DEC 05:21:56.1-69:19:06.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40337,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40337,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2188, RA-DEC 05:30:25.9-70:48:49.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40338,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40338,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2883, RA-DEC 05:40:37.9-69:55:35.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40339,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40339,18.48,0.06,0.0497,10597,NULL,NULL,'1264, Ks, GAL PL','LMC',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40340,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40340,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0563, RA-DEC 04:59:09.3-67:45:01.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40341,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40341,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1300, RA-DEC 05:14:04.1-66:36:14.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40342,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40342,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1882, RA-DEC 05:24:32.5-70:19:17.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40343,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40343,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1951, RA-DEC 05:25:35.4-70:27:56.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40344,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40344,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2203, RA-DEC 05:30:39.7-69:56:39.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40345,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40345,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2330, RA-DEC 05:32:53.6-68:42:32.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40346,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40346,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2831, RA-DEC 05:39:52.9-70:04:50.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40347,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40347,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2935, RA-DEC 05:41:27.2-69:53:18.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40348,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40348,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3069, RA-DEC 05:44:24.0-71:05:37.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40349,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40349,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4572, RA-DEC 06:04:11.1-68:12:58.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40350,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40350,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2372, RA-DEC 05:33:39.2-71:16:19.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40351,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40351,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3158, RA-DEC 05:46:36.2-68:11:03.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40352,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40352,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3406, RA-DEC 04:48:33.2-71:11:40.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40353,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40353,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0047, RA-DEC 04:43:25.6-69:53:49.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40354,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40354,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0451, RA-DEC 04:56:44.4-66:52:56.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40355,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40355,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0453, RA-DEC 04:56:48.2-69:25:21.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40356,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40356,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0758, RA-DEC 05:02:31.6-66:48:18.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40357,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40357,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2929, RA-DEC 05:41:23.0-70:11:52.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40358,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40358,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3303, RA-DEC 05:54:41.9-69:10:52.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40359,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40359,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3621, RA-DEC 05:08:50.2-66:09:57.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40360,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40360,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3793, RA-DEC 05:15:57.5-65:29:42.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40361,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40361,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0393, RA-DEC 04:55:40.8-67:25:48.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40362,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40362,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0637, RA-DEC 05:00:33.8-67:36:19.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40363,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40363,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0899, RA-DEC 05:05:28.3-69:21:50.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40364,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40364,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1170, RA-DEC 05:10:37.9-71:17:42.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40365,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40365,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1416, RA-DEC 05:15:59.9-69:04:29.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40366,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40366,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1962, RA-DEC 05:25:43.9-70:21:09.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40367,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40367,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2014, RA-DEC 05:26:52.3-70:08:28.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40368,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40368,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2152, RA-DEC 05:29:41.9-69:51:54.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40369,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40369,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2478, RA-DEC 05:35:21.5-70:07:00.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40370,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40370,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2710, RA-DEC 05:38:16.7-69:43:12.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40371,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40371,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2733, RA-DEC 05:38:35.0-68:18:03.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40372,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40372,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2819, RA-DEC 05:39:44.3-70:16:28.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40373,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40373,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3047, RA-DEC 05:43:55.6-70:27:10.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40374,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40374,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3225, RA-DEC 05:48:56.6-71:04:33.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40375,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40375,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3823, RA-DEC 05:16:54.6-66:37:39.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40376,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40376,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0683, RA-DEC 05:01:24.9-70:04:18.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40377,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40377,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1504, RA-DEC 05:17:42.4-69:30:32.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40378,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40378,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1861, RA-DEC 05:24:12.7-69:16:08.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40379,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40379,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2657, RA-DEC 05:37:36.4-70:08:51.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40380,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40380,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2707, RA-DEC 05:38:13.2-70:21:05.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40381,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40381,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3183, RA-DEC 05:47:25.2-70:42:22.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40382,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40382,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3588, RA-DEC 05:06:37.5-65:59:08.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40383,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40383,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4489, RA-DEC 05:52:10.7-67:44:57.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40384,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40384,18.48,0.01,0.0497,10597,NULL,NULL,'3042, JHK, IRSB, +/- 0.10 mag syst.','LMC',NULL,'2013IAUS..289..116B',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40385,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40385,18.48,0.04,0.0497,10597,NULL,NULL,'10, 3.6 micron, Milky Way HST parallax PL','LMC',NULL,'2012ApJ...759..146M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40386,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40386,18.48,0.08,0.0497,10597,NULL,NULL,'NGC 2157, 3, CMD','LMC',NULL,'1992ApJ...385..205C',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40387,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40387,18.48,0.06,0.0497,10597,NULL,NULL,'10, W, Period-Wesenheit, Z2','LMC',NULL,'2007A&A...476..863F',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40388,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40388,18.48,0.03,0.0497,10597,NULL,NULL,'linear PL','LMC',NULL,'2008glv..book..317N',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40389,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40389,18.48,0.1,0.0497,10597,NULL,NULL,'K','LMC',NULL,'2003MNRAS.345..269H',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40390,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40390,18.48,0.09,0.0497,10597,NULL,NULL,'NGC 1866, HV 12203','LMC',NULL,'2005A&A...440..487S',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40391,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40391,18.48,0.13,0.0497,10597,NULL,NULL,'VI','LMC',NULL,'2002ApJ...574L..33B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40392,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40392,18.48,0.07,0.0497,10597,NULL,NULL,'OGLE, BVRIJK','LMC',NULL,'2004A&A...415..531S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40393,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40393,18.48,0.05,0.0497,10597,NULL,NULL,'HV 01016, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40394,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40394,18.48,0.05,0.0497,10597,NULL,NULL,'HV 13064, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40395,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40395,18.48,0.05,0.0497,10597,NULL,NULL,'HV 05979, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40396,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40396,18.48,0.05,0.0497,10597,NULL,NULL,'HV 02538, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40397,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40397,18.48,0.05,0.0497,10597,NULL,NULL,'HV 02772, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40398,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40398,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0133, RA-DEC 04:49:46.6-66:55:42.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40399,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40399,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0136, RA-DEC 04:49:53.5-69:09:00.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40400,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40400,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0295, RA-DEC 04:53:37.0-68:21:52.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40401,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40401,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0787, RA-DEC 05:03:09.1-69:13:24.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40402,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40402,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1225, RA-DEC 05:12:06.5-69:13:06.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40403,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40403,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1371, RA-DEC 05:15:23.4-69:04:46.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40404,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40404,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3596, RA-DEC 05:07:18.7-65:26:03.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40405,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40405,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0515, RA-DEC 04:58:15.2-68:58:16.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40406,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40406,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1853, RA-DEC 05:23:56.0-70:29:31.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40407,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40407,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1998, RA-DEC 05:26:28.9-69:51:20.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40408,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40408,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2189, RA-DEC 05:30:27.0-69:31:14.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40409,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40409,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2462, RA-DEC 05:34:59.9-69:53:59.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40410,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40410,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3282, RA-DEC 05:52:57.5-70:36:06.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40411,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40411,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3582, RA-DEC 05:06:01.7-65:46:29.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40412,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40412,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3655, RA-DEC 05:10:35.9-65:16:32.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40413,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40413,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4195, RA-DEC 05:36:36.1-63:59:38.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40414,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40414,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0151, RA-DEC 04:50:14.3-68:49:28.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40415,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40415,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0363, RA-DEC 04:55:01.7-69:20:25.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40416,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40416,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1656, RA-DEC 05:20:45.7-69:50:15.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40417,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40417,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1898, RA-DEC 05:24:40.0-70:15:14.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40418,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40418,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2328, RA-DEC 05:32:49.9-70:04:15.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40419,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40419,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2397, RA-DEC 05:33:50.2-70:35:59.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40420,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40420,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2641, RA-DEC 05:37:25.6-70:07:59.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40421,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40421,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2772, RA-DEC 05:39:04.9-70:13:49.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40422,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40422,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2882, RA-DEC 05:40:35.6-69:44:44.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40423,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40423,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2908, RA-DEC 05:41:07.8-70:22:55.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40424,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40424,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3144, RA-DEC 05:46:20.3-68:14:47.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40425,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40425,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3618, RA-DEC 05:08:37.7-65:59:55.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40426,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40426,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3762, RA-DEC 05:14:23.8-66:04:21.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40427,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40427,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4135, RA-DEC 05:33:03.4-65:31:00.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40428,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40428,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4319, RA-DEC 05:43:18.6-66:19:40.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40429,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40429,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4412, RA-DEC 05:48:03.0-67:41:57.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40430,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40430,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0036, RA-DEC 04:42:11.8-70:14:02.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40431,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40431,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0365, RA-DEC 04:55:02.1-67:59:59.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40432,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40432,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0375, RA-DEC 04:55:12.6-69:48:13.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40433,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40433,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0816, RA-DEC 05:03:41.4-70:39:07.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40434,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40434,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1150, RA-DEC 05:10:13.4-66:35:00.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40435,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40435,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3048, RA-DEC 05:43:58.4-68:54:10.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40436,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40436,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3280, RA-DEC 05:52:56.2-69:47:24.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40437,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40437,18.48,0.06,0.0497,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4051, RA-DEC 05:28:58.3-72:12:07.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40438,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40438,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0764, RA-DEC 05:02:44.5-68:52:44.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40439,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40439,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1067, RA-DEC 05:08:26.7-70:29:35.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40440,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40440,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1195, RA-DEC 05:11:23.8-71:18:43.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40441,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40441,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1230, RA-DEC 05:12:13.3-69:11:52.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40442,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40442,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1652, RA-DEC 05:20:42.4-70:09:50.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40443,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40443,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2545, RA-DEC 05:36:17.9-71:14:42.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40444,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40444,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2890, RA-DEC 05:40:43.7-70:20:53.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40445,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40445,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2892, RA-DEC 05:40:44.9-69:27:21.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40446,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40446,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3635, RA-DEC 05:09:32.8-72:55:05.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40447,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40447,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3707, RA-DEC 05:12:37.0-71:37:01.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40448,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40448,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3759, RA-DEC 05:14:20.9-66:03:39.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40449,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40449,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3794, RA-DEC 05:15:58.4-64:58:13.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40450,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40450,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3885, RA-DEC 05:20:35.9-72:01:14.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40451,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40451,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4027, RA-DEC 05:27:58.3-65:03:00.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40452,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40452,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4203, RA-DEC 05:36:52.6-64:42:48.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40453,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40453,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0583, RA-DEC 04:59:31.0-69:19:42.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40454,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40454,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0824, RA-DEC 05:03:51.1-67:25:04.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40455,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40455,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1182, RA-DEC 05:11:04.1-69:17:57.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40456,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40456,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1778, RA-DEC 05:22:40.2-70:00:39.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40457,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40457,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1819, RA-DEC 05:23:11.7-70:53:33.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40458,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40458,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1840, RA-DEC 05:23:35.1-70:16:05.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40459,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40459,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2860, RA-DEC 05:40:20.6-69:23:47.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40460,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40460,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3042, RA-DEC 05:43:40.2-70:27:16.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40461,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40461,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3511, RA-DEC 05:01:01.3-66:26:26.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40462,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40462,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3556, RA-DEC 05:04:26.8-66:07:43.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40463,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40463,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3914, RA-DEC 05:22:02.0-65:50:08.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40464,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40464,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4183, RA-DEC 05:36:01.2-67:25:53.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40465,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40465,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1670, RA-DEC 05:21:04.2-71:08:27.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40466,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40466,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1780, RA-DEC 05:22:40.6-69:40:28.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40467,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40467,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3518, RA-DEC 05:01:36.2-71:19:40.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40468,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40468,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3782, RA-DEC 05:15:38.5-65:38:09.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40469,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40469,18.48,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3799, RA-DEC 05:16:03.1-63:44:18.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40470,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40470,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0786, RA-DEC 05:03:07.6-69:49:33.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40471,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40471,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1309, RA-DEC 05:14:15.2-70:25:24.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40472,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40472,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2439, RA-DEC 05:34:32.7-69:19:18.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40473,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40473,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2702, RA-DEC 05:38:09.5-69:43:36.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40474,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40474,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3277, RA-DEC 05:52:32.5-69:36:14.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40475,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40475,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3670, RA-DEC 05:11:13.2-71:32:03.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40476,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40476,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3772, RA-DEC 05:15:01.2-72:25:56.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40477,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40477,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3934, RA-DEC 05:22:44.0-64:29:57.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40478,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40478,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4063, RA-DEC 05:29:49.8-67:04:15.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40479,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40479,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4232, RA-DEC 05:38:25.0-66:40:55.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40480,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40480,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4417, RA-DEC 05:48:12.2-66:47:04.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40481,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40481,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0074, RA-DEC 04:46:38.5-66:57:48.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40482,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40482,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0556, RA-DEC 04:59:01.7-69:02:36.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40483,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40483,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0731, RA-DEC 05:02:15.7-67:25:15.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40484,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40484,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0815, RA-DEC 05:03:41.1-67:10:07.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40485,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40485,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0901, RA-DEC 05:05:28.7-70:47:16.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40486,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40486,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0989, RA-DEC 05:07:13.5-70:34:00.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40487,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40487,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1747, RA-DEC 05:22:18.2-69:02:25.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40488,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40488,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2562, RA-DEC 05:36:28.2-69:49:15.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40489,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40489,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2593, RA-DEC 05:36:53.2-70:09:51.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40490,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40490,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2823, RA-DEC 05:39:46.2-69:47:27.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40491,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40491,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2865, RA-DEC 05:40:26.4-70:21:46.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40492,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40492,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4490, RA-DEC 05:52:13.0-68:06:32.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40493,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40493,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0050, RA-DEC 04:43:40.3-69:34:14.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40494,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40494,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0831, RA-DEC 05:03:57.3-68:50:24.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40495,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40495,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1339, RA-DEC 05:15:01.0-66:37:40.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40496,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40496,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2136, RA-DEC 05:29:25.6-71:23:48.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40497,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40497,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2825, RA-DEC 05:39:47.3-70:24:42.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40498,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40498,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2859, RA-DEC 05:40:18.3-68:42:23.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40499,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40499,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3190, RA-DEC 05:47:32.6-70:09:34.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40500,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40500,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3492, RA-DEC 04:59:13.0-66:22:42.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40501,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40501,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3712, RA-DEC 05:12:47.4-66:04:44.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40502,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40502,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4108, RA-DEC 05:31:58.9-66:05:16.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40503,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40503,18.49,0.05,0.0498,10597,NULL,NULL,'HV 02598, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40504,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40504,18.49,0.05,0.0498,10597,NULL,NULL,'HV 02585, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40505,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40505,18.49,0.05,0.0498,10597,NULL,NULL,'HV 00984, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40506,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40506,18.49,0.05,0.0498,10597,NULL,NULL,'HV 00934, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40507,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40507,18.49,0.05,0.0498,10597,NULL,NULL,'HV 02369, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40508,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40508,18.49,0.05,0.0498,10597,NULL,NULL,'VI(W), Z, Baade-Wesselink','LMC',NULL,'2013MNRAS.430..546D',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40509,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40509,18.49,0.06,0.0498,10597,NULL,NULL,'HV 878, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40510,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40510,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0643, RA-DEC 05:00:40.8-67:40:41.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40511,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40511,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1304, RA-DEC 05:14:10.9-68:54:31.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40512,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40512,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1395, RA-DEC 05:15:44.3-71:13:05.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40513,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40513,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1548, RA-DEC 05:18:33.5-69:32:15.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40514,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40514,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1626, RA-DEC 05:20:10.2-70:09:07.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40515,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40515,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1828, RA-DEC 05:23:16.9-70:04:00.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40516,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40516,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1892, RA-DEC 05:24:35.9-68:57:22.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40517,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40517,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2267, RA-DEC 05:31:41.3-69:57:12.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40518,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40518,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2465, RA-DEC 05:35:04.3-71:23:55.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40519,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40519,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3074, RA-DEC 05:44:31.9-70:47:47.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40520,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40520,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3093, RA-DEC 05:44:56.8-69:38:33.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40521,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40521,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3630, RA-DEC 05:09:07.5-66:09:20.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40522,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40522,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4095, RA-DEC 05:31:21.4-65:40:27.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40523,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40523,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4560, RA-DEC 06:00:34.9-67:19:32.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40524,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40524,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0395, RA-DEC 04:55:42.2-70:45:23.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40525,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40525,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1135, RA-DEC 05:09:49.5-69:17:08.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40526,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40526,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1547, RA-DEC 05:18:33.2-69:56:11.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40527,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40527,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2042, RA-DEC 05:27:21.3-69:52:19.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40528,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40528,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2483, RA-DEC 05:35:25.0-70:15:16.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40529,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40529,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2917, RA-DEC 05:41:13.7-69:03:51.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40530,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40530,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3310, RA-DEC 05:56:29.1-68:43:05.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40531,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40531,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4285, RA-DEC 05:41:42.6-63:18:08.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40532,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40532,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4505, RA-DEC 05:53:19.6-67:14:23.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40533,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40533,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0040, RA-DEC 04:42:47.3-69:49:00.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40534,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40534,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0907, RA-DEC 05:05:34.2-67:02:26.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40535,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40535,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1329, RA-DEC 05:14:43.4-69:04:26.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40536,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40536,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1968, RA-DEC 05:25:53.2-69:53:10.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40537,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40537,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2074, RA-DEC 05:28:06.9-71:23:40.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40538,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40538,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2424, RA-DEC 05:34:19.3-70:58:44.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40539,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40539,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2512, RA-DEC 05:35:44.2-70:10:20.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40540,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40540,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2910, RA-DEC 05:41:09.1-70:24:10.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40541,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40541,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3436, RA-DEC 04:52:52.9-70:56:05.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40542,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40542,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3887, RA-DEC 05:20:41.5-65:03:35.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40543,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40543,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4361, RA-DEC 05:45:28.4-66:55:05.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40544,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40544,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4584, RA-DEC 06:07:03.9-74:08:50.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40545,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40545,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0250, RA-DEC 04:52:48.1-68:38:46.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40546,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40546,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0564, RA-DEC 04:59:10.7-70:10:14.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40547,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40547,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2316, RA-DEC 05:32:37.8-70:47:38.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40548,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40548,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2761, RA-DEC 05:38:54.6-70:20:59.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40549,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40549,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3221, RA-DEC 05:48:51.2-69:23:13.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40550,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40550,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3505, RA-DEC 05:00:18.9-66:25:22.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40551,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40551,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4031, RA-DEC 05:28:11.2-66:25:52.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40552,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40552,18.49,0.06,0.0498,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4291, RA-DEC 05:41:59.7-67:14:14.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40553,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40553,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0013, RA-DEC 04:37:51.0-69:17:18.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40554,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40554,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0396, RA-DEC 04:55:42.7-71:13:06.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40555,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40555,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0790, RA-DEC 05:03:11.3-67:06:14.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40556,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40556,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0796, RA-DEC 05:03:22.2-67:28:21.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40557,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40557,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1941, RA-DEC 05:25:29.3-69:55:12.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40558,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40558,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1999, RA-DEC 05:26:29.0-69:44:18.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40559,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40559,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2496, RA-DEC 05:35:33.3-70:08:41.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40560,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40560,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2817, RA-DEC 05:39:42.1-71:01:13.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40561,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40561,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3289, RA-DEC 05:53:17.4-69:30:05.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40562,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40562,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3447, RA-DEC 04:53:28.7-71:04:49.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40563,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40563,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3469, RA-DEC 04:55:25.2-71:23:24.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40564,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40564,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3587, RA-DEC 05:06:27.6-71:46:27.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40565,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40565,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3622, RA-DEC 05:08:50.7-66:17:24.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40566,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40566,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3699, RA-DEC 05:12:26.8-64:51:12.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40567,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40567,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3911, RA-DEC 05:21:58.4-64:15:10.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40568,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40568,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4275, RA-DEC 05:41:07.0-67:07:45.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40569,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40569,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4529, RA-DEC 05:56:08.3-74:56:01.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40570,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40570,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0586, RA-DEC 04:59:33.6-70:32:41.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40571,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40571,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0838, RA-DEC 05:04:07.8-70:29:50.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40572,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40572,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0921, RA-DEC 05:05:49.2-66:51:59.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40573,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40573,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1500, RA-DEC 05:17:40.1-69:41:53.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40574,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40574,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1763, RA-DEC 05:22:29.5-69:32:59.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40575,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40575,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2682, RA-DEC 05:37:48.1-70:13:56.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40576,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40576,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3586, RA-DEC 05:06:26.8-66:12:40.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40577,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40577,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4437, RA-DEC 05:49:08.5-73:10:29.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40578,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40578,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4623, RA-DEC 06:28:50.2-68:28:08.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40579,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40579,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1989, RA-DEC 05:26:18.8-70:31:55.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40580,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40580,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2087, RA-DEC 05:28:24.0-69:41:55.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40581,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40581,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2445, RA-DEC 05:34:39.3-70:04:23.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40582,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40582,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2927, RA-DEC 05:41:20.7-71:10:57.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40583,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40583,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3512, RA-DEC 05:01:02.5-66:15:33.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40584,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40584,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3558, RA-DEC 05:04:27.4-71:54:12.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40585,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40585,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4137, RA-DEC 05:33:23.8-66:44:37.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40586,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40586,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4288, RA-DEC 05:41:53.8-67:43:52.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40587,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40587,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0272, RA-DEC 04:53:10.8-67:00:41.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40588,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40588,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0931, RA-DEC 05:05:57.4-68:26:17.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40589,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40589,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2383, RA-DEC 05:33:41.7-68:52:22.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40590,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40590,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2765, RA-DEC 05:38:56.2-70:23:02.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40591,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40591,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3204, RA-DEC 05:48:07.4-70:25:18.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40592,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40592,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4335, RA-DEC 05:44:10.5-66:55:23.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40593,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40593,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0739, RA-DEC 05:02:19.8-67:57:29.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40594,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40594,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1115, RA-DEC 05:09:20.5-68:51:05.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40595,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40595,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1527, RA-DEC 05:18:06.4-68:57:15.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40596,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40596,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1986, RA-DEC 05:26:15.7-69:42:04.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40597,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40597,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2348, RA-DEC 05:33:13.8-71:48:30.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40598,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40598,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2889, RA-DEC 05:40:43.1-70:34:09.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40599,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40599,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3697, RA-DEC 05:12:24.9-65:22:26.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40600,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40600,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3908, RA-DEC 05:21:55.6-65:14:18.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40601,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40601,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4139, RA-DEC 05:33:30.4-64:34:22.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40602,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40602,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4348, RA-DEC 05:44:48.7-66:16:39.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40603,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40603,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1009, RA-DEC 05:07:25.8-68:28:36.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40604,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40604,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1158, RA-DEC 05:10:23.6-67:52:03.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40605,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40605,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1736, RA-DEC 05:22:12.2-69:53:35.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40606,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40606,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1749, RA-DEC 05:22:20.9-69:23:36.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40607,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40607,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1848, RA-DEC 05:23:51.3-69:13:55.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40608,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40608,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2458, RA-DEC 05:34:57.1-70:55:00.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40609,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40609,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2481, RA-DEC 05:35:24.3-69:57:24.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40610,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40610,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3055, RA-DEC 05:44:02.8-68:10:07.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40611,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40611,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3530, RA-DEC 05:02:43.7-66:11:45.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40612,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40612,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3575, RA-DEC 05:05:38.1-71:47:13.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40613,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40613,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3728, RA-DEC 05:13:30.6-65:25:56.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40614,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40614,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3990, RA-DEC 05:25:53.9-66:06:23.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40615,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40615,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4043, RA-DEC 05:28:36.2-67:00:08.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40616,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40616,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4534, RA-DEC 05:56:38.4-66:03:02.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40617,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40617,18.49,0.08,0.0499,10597,NULL,NULL,'4222, VI, OGLE Cepheids mean','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40618,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40618,18.49,0.07,0.0499,10597,NULL,NULL,'NGC 1866, 9. V-Ks, Baade-Wesselink Period-Wesenheit ','LMC',NULL,'2012MNRAS.424.1807R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40619,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40619,18.49,0.07,0.0499,10597,NULL,NULL,'NGC 1866, 9. V-Ks, Baade-Wesselink Period-Luminosity-Color ','LMC',NULL,'2012MNRAS.424.1807R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40620,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40620,18.49,0.04,0.0499,10597,NULL,NULL,'non-linear PL','LMC',NULL,'2008glv..book..317N',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40621,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40621,18.49,0.07,0.0499,10597,NULL,NULL,'NGC 1866, HV 12202, New PL','LMC',NULL,'2006MmSAI..77..261S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40622,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40622,18.49,NULL,0.0499,10597,NULL,NULL,'assuming E(B-V) = 0.10 mag','LMC',NULL,'1982PhDT........42M',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40623,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40623,18.49,0.19,0.0499,10597,NULL,NULL,'VJ','LMC',NULL,'2008MNRAS.390.1539M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40624,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40624,18.49,0.05,0.0499,10597,NULL,NULL,'OIII 1784, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40625,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40625,18.49,0.05,0.0499,10597,NULL,NULL,'HV 00985, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40626,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40626,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0582, RA-DEC 04:59:30.8-68:08:55.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40627,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40627,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1187, RA-DEC 05:11:10.8-69:18:37.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40628,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40628,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2517, RA-DEC 05:35:48.9-69:56:39.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40629,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40629,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2580, RA-DEC 05:36:46.0-70:57:30.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40630,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40630,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3017, RA-DEC 05:42:55.3-69:55:50.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40631,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40631,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3036, RA-DEC 05:43:33.8-70:30:45.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40632,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40632,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3168, RA-DEC 05:46:48.9-70:09:44.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40633,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40633,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3395, RA-DEC 04:45:48.0-71:02:32.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40634,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40634,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3645, RA-DEC 05:10:14.5-65:47:30.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40635,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40635,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3675, RA-DEC 05:11:23.1-71:42:30.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40636,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40636,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3749, RA-DEC 05:13:49.3-65:33:51.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40637,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40637,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4337, RA-DEC 05:44:17.6-66:54:49.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40638,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40638,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0243, RA-DEC 04:52:39.6-69:49:17.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40639,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40639,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0416, RA-DEC 04:56:04.7-67:50:39.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40640,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40640,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1779, RA-DEC 05:22:40.3-69:30:30.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40641,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40641,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2158, RA-DEC 05:29:48.9-69:09:51.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40642,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40642,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2209, RA-DEC 05:30:45.9-68:47:27.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40643,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40643,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2645, RA-DEC 05:37:28.8-69:55:59.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40644,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40644,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2874, RA-DEC 05:40:32.5-70:23:18.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40645,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40645,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2931, RA-DEC 05:41:24.3-70:17:47.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40646,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40646,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3275, RA-DEC 05:52:19.2-70:47:45.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40647,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40647,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4356, RA-DEC 05:45:09.4-67:00:56.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40648,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40648,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0095, RA-DEC 04:48:02.0-67:48:29.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40649,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40649,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0126, RA-DEC 04:49:34.0-66:58:33.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40650,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40650,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0392, RA-DEC 04:55:35.1-68:41:23.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40651,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40651,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0597, RA-DEC 04:59:49.9-69:20:44.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40652,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40652,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0671, RA-DEC 05:01:05.1-68:27:05.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40653,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40653,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0704, RA-DEC 05:01:48.6-68:50:44.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40654,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40654,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0924, RA-DEC 05:05:51.0-69:59:04.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40655,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40655,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1190, RA-DEC 05:11:14.0-69:59:31.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40656,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40656,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1782, RA-DEC 05:22:41.8-69:35:05.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40657,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40657,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1917, RA-DEC 05:25:10.5-70:05:10.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40658,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40658,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1980, RA-DEC 05:26:02.1-69:52:10.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40659,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40659,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2322, RA-DEC 05:32:44.2-71:06:51.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40660,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40660,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2398, RA-DEC 05:33:50.9-70:59:38.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40661,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40661,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2858, RA-DEC 05:40:18.0-70:57:38.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40662,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40662,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2905, RA-DEC 05:41:05.3-70:19:36.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40663,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40663,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3001, RA-DEC 05:42:41.0-70:12:02.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40664,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40664,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3098, RA-DEC 05:45:04.0-70:27:02.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40665,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40665,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3638, RA-DEC 05:09:46.1-65:20:27.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40666,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40666,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0676, RA-DEC 05:01:09.6-67:48:56.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40667,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40667,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1285, RA-DEC 05:13:49.9-69:12:02.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40668,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40668,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1376, RA-DEC 05:15:26.3-71:24:15.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40669,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40669,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1903, RA-DEC 05:24:43.9-69:30:26.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40670,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40670,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2047, RA-DEC 05:27:30.2-70:10:46.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40671,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40671,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2068, RA-DEC 05:27:56.9-68:25:19.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40672,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40672,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2108, RA-DEC 05:28:45.2-70:22:15.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40673,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40673,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3058, RA-DEC 05:44:14.8-69:51:39.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40674,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40674,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3109, RA-DEC 05:45:28.5-70:27:01.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40675,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40675,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3191, RA-DEC 05:47:32.8-70:40:29.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40676,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40676,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3828, RA-DEC 05:17:14.1-66:19:49.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40677,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40677,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4385, RA-DEC 05:46:48.0-67:31:40.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40678,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40678,18.49,0.06,0.0499,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4510, RA-DEC 05:54:20.4-67:19:18.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40679,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40679,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0465, RA-DEC 04:57:09.2-69:37:20.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40680,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40680,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0784, RA-DEC 05:03:06.3-69:09:39.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40681,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40681,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2076, RA-DEC 05:28:08.9-70:04:53.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40682,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40682,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2826, RA-DEC 05:39:47.3-70:01:16.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40683,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40683,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3308, RA-DEC 05:55:57.2-69:32:06.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40684,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40684,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3407, RA-DEC 04:48:50.1-65:56:38.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40685,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40685,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3711, RA-DEC 05:12:47.0-65:45:21.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40686,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40686,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3944, RA-DEC 05:23:29.2-66:36:11.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40687,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40687,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3945, RA-DEC 05:23:36.8-66:57:36.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40688,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40688,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3989, RA-DEC 05:25:53.0-65:10:20.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40689,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40689,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4098, RA-DEC 05:31:32.2-66:38:32.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40690,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40690,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0032, RA-DEC 04:41:45.2-69:44:30.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40691,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40691,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0299, RA-DEC 04:53:42.7-70:23:10.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40692,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40692,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0775, RA-DEC 05:02:54.6-67:04:00.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40693,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40693,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1383, RA-DEC 05:15:34.6-66:38:48.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40694,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40694,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1497, RA-DEC 05:17:35.7-69:48:13.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40695,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40695,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1774, RA-DEC 05:22:37.4-71:53:54.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40696,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40696,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2304, RA-DEC 05:32:21.1-67:52:42.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40697,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40697,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2371, RA-DEC 05:33:38.0-70:59:41.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40698,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40698,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2966, RA-DEC 05:42:06.2-68:35:32.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40699,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40699,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3059, RA-DEC 05:44:15.1-70:33:21.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40700,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40700,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3229, RA-DEC 05:49:14.2-71:09:53.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40701,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40701,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3624, RA-DEC 05:08:57.1-65:53:47.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40702,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40702,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3778, RA-DEC 05:15:24.2-65:00:05.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40703,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40703,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4237, RA-DEC 05:38:41.3-64:50:46.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40704,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40704,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4339, RA-DEC 05:44:25.5-66:54:09.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40705,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40705,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0157, RA-DEC 04:50:23.1-67:11:48.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40706,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40706,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0364, RA-DEC 04:55:01.8-68:45:21.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40707,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40707,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0378, RA-DEC 04:55:17.1-69:20:13.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40708,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40708,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1034, RA-DEC 05:07:50.0-69:02:44.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40709,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40709,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1410, RA-DEC 05:15:58.0-69:05:13.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40710,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40710,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1457, RA-DEC 05:16:41.3-71:36:27.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40711,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40711,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1469, RA-DEC 05:17:01.1-69:30:35.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40712,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40712,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2273, RA-DEC 05:31:44.3-69:58:11.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40713,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40713,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2382, RA-DEC 05:33:41.7-70:59:17.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40714,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40714,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3325, RA-DEC 05:58:24.8-68:49:28.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40715,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40715,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3454, RA-DEC 04:54:06.2-70:48:44.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40716,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40716,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3644, RA-DEC 05:10:14.3-66:16:39.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40717,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40717,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3894, RA-DEC 05:20:59.5-65:27:35.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40718,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40718,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3974, RA-DEC 05:25:19.4-66:12:44.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40719,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40719,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0326, RA-DEC 04:54:22.3-69:24:06.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40720,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40720,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0782, RA-DEC 05:03:05.5-68:01:24.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40721,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40721,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1348, RA-DEC 05:15:06.8-69:01:39.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40722,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40722,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1663, RA-DEC 05:20:54.1-70:12:22.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40723,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40723,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2501, RA-DEC 05:35:35.0-70:14:33.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40724,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40724,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2516, RA-DEC 05:35:48.4-70:03:51.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40725,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40725,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3285, RA-DEC 05:53:07.9-69:30:22.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40726,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40726,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3352, RA-DEC 06:06:33.4-71:36:26.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40727,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40727,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3730, RA-DEC 05:13:33.0-66:28:01.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40728,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40728,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4035, RA-DEC 05:28:19.0-71:55:48.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40729,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40729,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4084, RA-DEC 05:30:35.7-66:39:29.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40730,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40730,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1000, RA-DEC 05:07:21.1-66:49:47.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40731,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40731,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1396, RA-DEC 05:15:45.5-69:22:02.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40732,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40732,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1405, RA-DEC 05:15:53.8-69:02:23.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40733,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40733,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2256, RA-DEC 05:31:23.2-70:13:01.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40734,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40734,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2270, RA-DEC 05:31:43.4-71:22:19.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40735,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40735,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2862, RA-DEC 05:40:23.6-70:25:43.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40736,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40736,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2873, RA-DEC 05:40:32.3-70:18:02.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40737,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40737,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3472, RA-DEC 04:56:01.8-71:24:22.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40738,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40738,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4191, RA-DEC 05:36:28.0-67:36:39.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40739,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40739,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4295, RA-DEC 05:42:04.2-67:18:34.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40740,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40740,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0141, RA-DEC 04:49:58.1-67:57:03.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40741,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40741,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0178, RA-DEC 04:50:58.5-70:09:09.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40742,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40742,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0532, RA-DEC 04:58:35.9-69:39:01.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40743,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40743,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0554, RA-DEC 04:58:58.5-68:19:06.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40744,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40744,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0818, RA-DEC 05:03:46.0-66:59:24.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40745,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40745,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1210, RA-DEC 05:11:46.5-70:00:01.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40746,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40746,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1746, RA-DEC 05:22:16.8-70:00:18.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40747,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40747,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2355, RA-DEC 05:33:22.9-70:59:43.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40748,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40748,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2407, RA-DEC 05:33:57.9-70:06:46.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40749,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40749,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3043, RA-DEC 05:43:40.7-70:08:08.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40750,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40750,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3082, RA-DEC 05:44:38.1-71:00:06.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40751,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40751,18.49,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4078, RA-DEC 05:30:22.4-66:11:12.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40752,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40752,18.5,0.13,0.05,10597,NULL,NULL,NULL,'LMC',NULL,'2000ApJS..128..431F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40753,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40753,18.5,0.03,0.05,10597,NULL,NULL,'W','LMC',NULL,'2007AJ....133.1810B',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40754,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40754,18.49,0.05,0.05,10597,NULL,NULL,'HV 02432, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40755,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40755,18.49,0.05,0.05,10597,NULL,NULL,'HV 00978, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40756,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40756,18.5,0.05,0.05,10597,NULL,NULL,'HV 12839, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40757,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40757,18.5,0.05,0.05,10597,NULL,NULL,'OIII 1862, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40758,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40758,18.5,0.05,0.05,10597,NULL,NULL,'HV 02463, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40759,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40759,18.5,0.05,0.05,10597,NULL,NULL,'HV 00973, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40760,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40760,18.49,0.05,0.05,10597,NULL,NULL,'HV 05594, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40761,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40761,18.5,0.05,0.05,10597,NULL,NULL,'HV 02488, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40762,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40762,18.5,0.05,0.05,10597,NULL,NULL,'HV 00886, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40763,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40763,18.5,0.05,0.05,10597,NULL,NULL,'HV 02540, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40764,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40764,18.5,0.05,0.05,10597,NULL,NULL,'HV 02294, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40765,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,NULL,40765,18.48,0.06,0.05,10597,74.4,NULL,NULL,'LMC',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40766,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40766,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0463, RA-DEC 04:57:04.8-67:07:35.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40767,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40767,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0801, RA-DEC 05:03:26.5-69:08:56.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40768,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40768,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1890, RA-DEC 05:24:35.1-71:21:20.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40769,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40769,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1914, RA-DEC 05:25:04.1-70:06:29.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40770,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40770,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2161, RA-DEC 05:29:57.6-69:50:51.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40771,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40771,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2205, RA-DEC 05:30:41.8-69:49:15.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40772,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40772,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2213, RA-DEC 05:30:48.5-69:27:15.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40773,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40773,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2260, RA-DEC 05:31:30.8-69:44:27.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40774,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40774,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2280, RA-DEC 05:31:49.1-70:08:54.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40775,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40775,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3441, RA-DEC 04:53:05.8-66:19:05.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40776,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40776,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3536, RA-DEC 05:03:02.5-71:40:41.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40777,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40777,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0168, RA-DEC 04:50:43.7-69:31:44.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40778,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40778,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0635, RA-DEC 05:00:33.4-67:14:29.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40779,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40779,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0730, RA-DEC 05:02:12.8-70:30:35.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40780,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40780,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0988, RA-DEC 05:07:09.9-66:40:07.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40781,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40781,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1235, RA-DEC 05:12:22.7-69:57:31.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40782,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40782,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1615, RA-DEC 05:19:58.9-71:46:32.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40783,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40783,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2247, RA-DEC 05:31:16.2-70:19:19.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40784,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40784,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2415, RA-DEC 05:34:04.8-68:38:28.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40785,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40785,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2557, RA-DEC 05:36:25.5-70:14:54.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40786,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40786,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3398, RA-DEC 04:47:09.7-70:47:51.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40787,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40787,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4225, RA-DEC 05:38:09.2-74:37:03.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40788,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40788,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0479, RA-DEC 04:57:26.2-66:43:24.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40789,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40789,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0588, RA-DEC 04:59:37.2-68:08:47.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40790,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40790,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0937, RA-DEC 05:06:02.7-68:06:02.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40791,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40791,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1558, RA-DEC 05:18:49.1-69:21:29.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40792,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40792,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1863, RA-DEC 05:24:13.9-68:49:33.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40793,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40793,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2113, RA-DEC 05:28:53.6-70:04:09.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40794,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40794,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2219, RA-DEC 05:30:52.8-69:46:25.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40795,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40795,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2325, RA-DEC 05:32:46.7-71:52:41.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40796,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40796,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2438, RA-DEC 05:34:31.9-69:45:14.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40797,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40797,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2548, RA-DEC 05:36:18.7-69:40:05.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40798,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40798,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2840, RA-DEC 05:40:01.8-70:31:03.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40799,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40799,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3255, RA-DEC 05:50:42.2-68:47:19.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40800,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40800,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3276, RA-DEC 05:52:28.3-72:01:29.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40801,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40801,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3500, RA-DEC 05:00:01.3-65:12:01.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40802,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40802,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3722, RA-DEC 05:13:21.5-73:11:19.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40803,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40803,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3950, RA-DEC 05:23:58.6-64:49:13.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40804,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40804,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0428, RA-DEC 04:56:21.0-68:47:36.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40805,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40805,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0513, RA-DEC 04:58:12.3-68:14:38.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40806,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40806,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0706, RA-DEC 05:01:50.6-66:36:10.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40807,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40807,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1335, RA-DEC 05:14:52.2-68:49:03.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40808,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40808,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1859, RA-DEC 05:24:07.5-68:51:14.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40809,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40809,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2028, RA-DEC 05:27:05.0-69:50:44.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40810,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40810,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2091, RA-DEC 05:28:30.2-68:38:49.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40811,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40811,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2838, RA-DEC 05:39:59.2-70:19:46.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40812,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40812,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2956, RA-DEC 05:41:56.1-70:30:21.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40813,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40813,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3061, RA-DEC 05:44:16.8-69:18:14.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40814,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40814,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3557, RA-DEC 05:04:27.2-71:58:55.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40815,'Cepheids','2016-12-15 15:14:08','2016-12-16 11:19:13','1',NULL,'R',40815,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3963, RA-DEC 05:24:48.3-66:00:48.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40816,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40816,18.5,0.06,0.05,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4575, RA-DEC 06:04:33.0-66:09:15.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40817,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40817,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0008, RA-DEC 04:36:33.1-69:18:43.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40818,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40818,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1317, RA-DEC 05:14:29.1-69:42:23.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40819,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40819,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2148, RA-DEC 05:29:35.7-69:00:21.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40820,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40820,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2282, RA-DEC 05:31:52.4-71:32:23.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40821,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40821,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2365, RA-DEC 05:33:30.7-71:09:06.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40822,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40822,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3773, RA-DEC 05:15:06.0-66:04:29.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40823,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40823,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4421, RA-DEC 05:48:20.1-67:27:16.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40824,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40824,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0793, RA-DEC 05:03:15.0-67:42:37.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40825,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40825,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0850, RA-DEC 05:04:24.1-70:39:48.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40826,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40826,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1083, RA-DEC 05:08:46.5-68:10:31.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40827,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40827,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1213, RA-DEC 05:11:51.8-68:06:44.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40828,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40828,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1391, RA-DEC 05:15:40.5-69:04:27.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40829,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40829,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1530, RA-DEC 05:18:07.1-69:49:44.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40830,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40830,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1685, RA-DEC 05:21:22.4-70:10:31.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40831,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40831,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1702, RA-DEC 05:21:42.1-69:56:21.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40832,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40832,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1737, RA-DEC 05:22:12.3-70:04:31.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40833,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40833,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2133, RA-DEC 05:29:22.0-69:18:44.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40834,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40834,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2668, RA-DEC 05:37:39.1-70:14:16.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40835,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40835,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2997, RA-DEC 05:42:33.6-70:06:58.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40836,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40836,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3104, RA-DEC 05:45:21.0-68:18:10.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40837,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40837,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3590, RA-DEC 05:06:52.1-66:21:29.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40838,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40838,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3900, RA-DEC 05:21:34.1-66:04:37.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40839,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40839,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4060, RA-DEC 05:29:20.5-66:35:22.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40840,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40840,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4104, RA-DEC 05:31:50.7-67:37:57.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40841,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40841,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3658, RA-DEC 05:10:41.8-65:45:39.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40842,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40842,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4029, RA-DEC 05:28:04.9-65:43:30.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40843,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40843,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4300, RA-DEC 05:42:16.4-67:27:53.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40844,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40844,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4554, RA-DEC 05:59:22.1-66:57:09.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40845,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40845,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1166, RA-DEC 05:10:36.1-69:08:17.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40846,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40846,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1953, RA-DEC 05:25:38.7-70:39:52.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40847,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40847,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2567, RA-DEC 05:36:29.8-70:07:06.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40848,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40848,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3160, RA-DEC 05:46:37.2-70:42:05.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40849,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40849,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3555, RA-DEC 05:04:25.6-65:49:19.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40850,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40850,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3641, RA-DEC 05:09:54.8-71:59:23.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40851,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40851,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3979, RA-DEC 05:25:33.0-67:14:24.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40852,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40852,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4306, RA-DEC 05:42:40.3-72:41:50.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40853,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40853,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0492, RA-DEC 04:57:45.1-70:36:05.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40854,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40854,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0544, RA-DEC 04:58:44.7-69:28:58.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40855,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40855,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1364, RA-DEC 05:15:18.8-69:13:32.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40856,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40856,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1412, RA-DEC 05:15:58.2-70:50:45.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40857,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40857,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2518, RA-DEC 05:35:50.4-70:15:49.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40858,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40858,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3929, RA-DEC 05:22:33.4-66:34:26.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40859,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40859,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4071, RA-DEC 05:30:09.4-63:16:17.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40860,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40860,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4182, RA-DEC 05:35:57.9-66:10:34.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40861,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40861,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0024, RA-DEC 04:40:50.6-69:44:16.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40862,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40862,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0438, RA-DEC 04:56:33.5-67:17:36.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40863,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40863,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1015, RA-DEC 05:07:27.0-70:50:42.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40864,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40864,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1529, RA-DEC 05:18:07.0-69:56:46.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40865,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40865,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1814, RA-DEC 05:23:09.4-69:58:08.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40866,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40866,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1838, RA-DEC 05:23:33.2-69:43:39.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40867,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40867,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2362, RA-DEC 05:33:29.8-70:16:35.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40868,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40868,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2412, RA-DEC 05:34:02.3-69:24:44.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40869,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40869,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3449, RA-DEC 04:53:35.3-65:49:50.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40870,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40870,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3552, RA-DEC 05:04:17.1-66:12:32.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40871,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40871,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3603, RA-DEC 05:07:38.8-66:01:13.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40872,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40872,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3620, RA-DEC 05:08:48.9-65:31:49.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40873,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40873,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4040, RA-DEC 05:28:24.8-64:57:28.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40874,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,NULL,40874,18.5,0.13,0.0501,10597,NULL,NULL,'13, BVJK','LMC',NULL,'1998ApJ...492..110M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40875,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,NULL,40875,18.5,0.13,0.0501,10597,NULL,NULL,NULL,'LMC',NULL,'2000ApJS..128..431F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40876,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,NULL,40876,18.5,0.13,0.0501,10597,NULL,NULL,'U99,V','LMC',NULL,'2002AJ....124.1695B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40877,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,NULL,40877,18.5,NULL,0.0501,10597,NULL,NULL,'34,BVRI','LMC',NULL,'2002ApJS..142...71S',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40878,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,NULL,40878,18.5,NULL,0.0501,10597,NULL,NULL,NULL,'LMC',NULL,'2003AJ....125.1261D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40879,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,NULL,40879,18.5,0.07,0.0501,10597,NULL,NULL,'OGLE, K','LMC',NULL,'2004A&A...415..531S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40880,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,NULL,40880,18.5,NULL,0.0501,10597,NULL,NULL,NULL,'LMC',NULL,'2004AJ....127.2031K',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40881,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,NULL,40881,18.5,0.05,0.0501,10597,NULL,NULL,'92, JHK','LMC',NULL,'2004AJ....128.2239P',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40882,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,NULL,40882,18.5,0.1,0.0501,10597,NULL,NULL,'VIHJK','LMC',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40883,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40883,18.5,0.05,0.0501,10597,NULL,NULL,'NGC 1866','LMC',NULL,'2006MmSAI..77..261S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40884,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40884,18.5,0.07,0.0501,10597,NULL,NULL,NULL,'LMC',NULL,'2010vsgh.conf..177D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40885,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40885,18.5,NULL,0.0501,10597,NULL,NULL,'73, PLV+PLC','LMC',NULL,'1988ASPC....4....9F',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40886,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40886,18.5,0.03,0.0501,10597,NULL,NULL,'NGC 1866, HV 12198, New PL','LMC',NULL,'2006MmSAI..77..261S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40887,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,NULL,40887,18.5,NULL,0.0501,10597,NULL,NULL,NULL,'LMC',NULL,'1985PASAu...6..140V',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40888,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,NULL,40888,18.5,0.05,0.0501,10597,NULL,NULL,'HV 00958, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40889,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,NULL,40889,18.5,0.05,0.0501,10597,NULL,NULL,'HV 00933, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40890,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,NULL,40890,18.5,0.05,0.0501,10597,NULL,NULL,'EV* LMC V0154 (= U 00011), IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40891,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,NULL,40891,18.5,0.04,0.0501,10597,NULL,NULL,'IRSB, PL1','LMC',NULL,'2011A&A...534A..94S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40892,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,NULL,40892,18.5,0.04,0.0501,10597,NULL,NULL,'IRSB, PL3','LMC',NULL,'2011A&A...534A..94S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40893,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,NULL,40893,18.5,NULL,0.0501,10597,NULL,NULL,NULL,'LMC',NULL,'2012ApJ...745..104N',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40894,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40894,18.5,0.05,0.0501,10597,NULL,NULL,'HV 873, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40895,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,NULL,40895,18.5,NULL,0.0501,10597,NULL,NULL,NULL,'LMC',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40896,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,NULL,40896,18.5,NULL,0.0501,10597,NULL,NULL,'718, VI','LMC',NULL,'2006A&A...452..423P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40897,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,NULL,40897,18.5,0.13,0.0501,10597,NULL,NULL,'HST KP Calibrated','LMC',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40898,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40898,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0023, RA-DEC 04:40:47.5-68:59:08.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40899,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40899,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0598, RA-DEC 04:59:51.6-66:54:15.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40900,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40900,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0761, RA-DEC 05:02:36.5-68:44:41.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40901,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40901,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0773, RA-DEC 05:02:53.8-68:06:25.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40902,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40902,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1087, RA-DEC 05:08:48.9-69:39:14.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40903,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40903,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1103, RA-DEC 05:09:07.3-67:01:25.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40904,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40904,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1307, RA-DEC 05:14:12.8-70:13:38.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40905,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40905,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1489, RA-DEC 05:17:23.9-68:47:34.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40906,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40906,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1491, RA-DEC 05:17:26.5-69:20:06.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40907,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40907,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2851, RA-DEC 05:40:10.8-70:24:30.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40908,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40908,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2926, RA-DEC 05:41:18.9-70:22:50.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40909,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40909,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3494, RA-DEC 04:59:20.6-72:35:27.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40910,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,NULL,40910,18.5,0.08,0.0501,10597,NULL,NULL,'57, H, PL','LMC',NULL,'1987ApJ...321..162W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40911,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40911,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0059, RA-DEC 04:44:54.9-68:38:21.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40912,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40912,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0484, RA-DEC 04:57:39.3-69:39:19.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40913,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40913,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0543, RA-DEC 04:58:43.3-68:43:49.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40914,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40914,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0633, RA-DEC 05:00:29.3-69:15:24.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40915,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40915,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0839, RA-DEC 05:04:07.9-69:12:34.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40916,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40916,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1477, RA-DEC 05:17:07.9-71:31:47.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40917,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40917,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1893, RA-DEC 05:24:36.3-70:19:50.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40918,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40918,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2277, RA-DEC 05:31:47.8-71:49:00.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40919,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40919,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2493, RA-DEC 05:35:32.0-70:08:05.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40920,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40920,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2801, RA-DEC 05:39:26.7-69:53:58.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40921,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40921,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3227, RA-DEC 05:49:07.8-70:26:01.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40922,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40922,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3431, RA-DEC 04:52:29.2-66:24:13.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40923,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40923,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3446, RA-DEC 04:53:28.4-70:49:39.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40924,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40924,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3627, RA-DEC 05:09:02.9-74:40:02.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40925,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40925,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0508, RA-DEC 04:58:01.6-68:14:51.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40926,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40926,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0772, RA-DEC 05:02:52.7-68:50:35.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40927,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40927,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0845, RA-DEC 05:04:16.2-70:36:03.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40928,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40928,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1209, RA-DEC 05:11:45.8-69:48:01.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40929,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40929,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1223, RA-DEC 05:12:02.0-68:50:39.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40930,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40930,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0083, RA-DEC 04:47:16.3-69:51:01.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40931,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40931,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0687, RA-DEC 05:01:31.7-69:23:18.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40932,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40932,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1666, RA-DEC 05:20:55.7-69:07:50.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40933,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40933,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1674, RA-DEC 05:21:08.3-69:08:29.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40934,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40934,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2058, RA-DEC 05:27:45.2-71:10:06.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40935,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40935,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2901, RA-DEC 05:40:58.0-70:17:04.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40936,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40936,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3726, RA-DEC 05:13:26.7-65:27:05.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40937,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40937,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4113, RA-DEC 05:32:38.7-67:03:46.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40938,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40938,18.5,0.06,0.0501,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4405, RA-DEC 05:47:48.5-66:57:29.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40939,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40939,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0246, RA-DEC 04:52:46.3-67:38:03.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40940,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40940,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0406, RA-DEC 04:55:51.5-66:40:14.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40941,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40941,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1119, RA-DEC 05:09:26.9-68:50:35.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40942,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40942,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1380, RA-DEC 05:15:31.1-69:18:04.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40943,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40943,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1425, RA-DEC 05:16:04.0-70:07:59.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40944,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40944,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1851, RA-DEC 05:23:53.6-69:20:50.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40945,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40945,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3487, RA-DEC 04:58:22.5-71:45:54.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40946,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40946,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3542, RA-DEC 05:03:36.2-65:55:44.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40947,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40947,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4471, RA-DEC 05:50:45.4-67:32:11.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40948,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40948,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4607, RA-DEC 06:14:25.8-66:20:02.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40949,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40949,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4622, RA-DEC 06:28:33.2-70:46:35.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40950,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40950,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0198, RA-DEC 04:51:25.9-69:33:11.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40951,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40951,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1523, RA-DEC 05:18:01.4-71:09:11.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40952,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40952,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1630, RA-DEC 05:20:15.4-71:49:29.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40953,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40953,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1660, RA-DEC 05:20:51.4-68:52:00.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40954,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40954,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1728, RA-DEC 05:22:02.0-69:22:46.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40955,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40955,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1935, RA-DEC 05:25:27.0-70:20:53.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40956,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40956,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3743, RA-DEC 05:13:40.6-65:28:26.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40957,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40957,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3862, RA-DEC 05:19:02.9-66:18:26.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40958,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40958,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4307, RA-DEC 05:42:43.4-67:11:39.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40959,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40959,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4472, RA-DEC 05:50:55.4-72:52:28.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40960,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40960,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0669, RA-DEC 05:01:04.0-70:51:07.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40961,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40961,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0722, RA-DEC 05:02:07.2-66:52:30.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40962,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40962,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2524, RA-DEC 05:35:55.4-70:00:29.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40963,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40963,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2611, RA-DEC 05:36:59.0-70:16:14.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40964,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40964,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2622, RA-DEC 05:37:04.6-70:07:56.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40965,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40965,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2856, RA-DEC 05:40:15.5-70:19:53.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40966,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40966,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4045, RA-DEC 05:28:36.8-65:15:38.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40967,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40967,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0955, RA-DEC 05:06:29.1-70:31:03.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40968,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40968,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1553, RA-DEC 05:18:41.9-69:38:23.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40969,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40969,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1581, RA-DEC 05:19:17.2-69:30:25.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40970,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40970,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2226, RA-DEC 05:30:59.5-69:35:31.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40971,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40971,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2406, RA-DEC 05:33:57.8-70:52:18.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40972,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40972,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2419, RA-DEC 05:34:10.5-70:11:44.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40973,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40973,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2739, RA-DEC 05:38:39.8-70:36:33.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40974,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40974,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2897, RA-DEC 05:40:51.9-70:22:36.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40975,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40975,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3493, RA-DEC 04:59:20.4-66:19:13.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40976,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40976,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4341, RA-DEC 05:44:34.9-66:55:06.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40977,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40977,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0309, RA-DEC 04:54:01.2-70:06:33.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40978,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40978,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0506, RA-DEC 04:57:57.5-66:57:44.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40979,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40979,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2207, RA-DEC 05:30:44.5-68:20:13.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40980,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40980,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2449, RA-DEC 05:34:41.6-68:41:26.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40981,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40981,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2659, RA-DEC 05:37:37.2-70:20:47.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40982,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40982,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3598, RA-DEC 05:07:19.7-66:16:35.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40983,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40983,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4277, RA-DEC 05:41:09.8-73:40:41.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40984,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40984,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4368, RA-DEC 05:45:56.0-67:23:11.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40985,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40985,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0085, RA-DEC 04:47:20.1-69:56:42.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40986,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40986,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0172, RA-DEC 04:50:50.6-69:05:28.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40987,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40987,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0925, RA-DEC 05:05:51.1-71:05:20.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40988,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40988,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1221, RA-DEC 05:12:00.0-68:48:43.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40989,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40989,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1459, RA-DEC 05:16:43.9-70:35:31.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40990,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40990,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1622, RA-DEC 05:20:05.0-69:42:39.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40991,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40991,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1868, RA-DEC 05:24:20.2-69:46:24.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40992,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40992,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2257, RA-DEC 05:31:24.6-70:05:57.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40993,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40993,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2549, RA-DEC 05:36:19.4-70:13:24.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40994,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40994,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2815, RA-DEC 05:39:41.8-70:22:07.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40995,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40995,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2968, RA-DEC 05:42:07.9-69:00:19.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40996,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40996,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3172, RA-DEC 05:47:03.4-69:05:34.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40997,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40997,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3206, RA-DEC 05:48:12.8-70:42:53.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40998,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',40998,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4218, RA-DEC 05:37:49.8-67:17:32.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40999,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,NULL,40999,18.51,0.05,0.0502,10597,NULL,NULL,'OIII 1539, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41000,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,NULL,41000,18.51,0.05,0.0502,10597,NULL,NULL,'HV 02453, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41001,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,NULL,41001,18.51,0.05,0.0502,10597,NULL,NULL,'HV 02251, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41002,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',41002,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0049, RA-DEC 04:43:35.6-70:41:46.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41003,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',41003,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0625, RA-DEC 05:00:14.4-68:54:32.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41004,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',41004,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0726, RA-DEC 05:02:10.2-70:33:11.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41005,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',41005,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1648, RA-DEC 05:20:38.8-69:49:00.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41006,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',41006,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1705, RA-DEC 05:21:46.9-69:59:48.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41007,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',41007,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4528, RA-DEC 05:56:08.0-67:17:50.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41008,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',41008,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0009, RA-DEC 04:36:52.1-68:03:51.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41009,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',41009,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2683, RA-DEC 05:37:49.8-70:10:17.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41010,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',41010,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3836, RA-DEC 05:17:45.5-64:38:16.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41011,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',41011,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4309, RA-DEC 05:42:48.1-66:56:33.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41012,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',41012,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0169, RA-DEC 04:50:48.6-69:05:07.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41013,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',41013,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0347, RA-DEC 04:54:51.8-68:11:48.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41014,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',41014,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0770, RA-DEC 05:02:51.5-68:47:05.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41015,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',41015,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1120, RA-DEC 05:09:27.0-68:54:12.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41016,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',41016,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1123, RA-DEC 05:09:29.0-68:03:01.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41017,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:13','1',NULL,'R',41017,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1389, RA-DEC 05:15:38.4-69:15:19.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41018,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41018,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1724, RA-DEC 05:21:59.7-69:43:08.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41019,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41019,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2566, RA-DEC 05:36:29.7-70:22:40.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41020,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41020,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2588, RA-DEC 05:36:52.3-71:06:25.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41021,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41021,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2604, RA-DEC 05:36:55.1-70:09:44.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41022,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41022,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2899, RA-DEC 05:40:54.3-70:16:06.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41023,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41023,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3896, RA-DEC 05:21:14.5-72:30:15.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41024,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41024,18.5,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4004, RA-DEC 05:26:39.7-64:39:45.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41025,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41025,18.51,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0394, RA-DEC 04:55:41.5-68:06:55.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41026,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41026,18.51,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1680, RA-DEC 05:21:16.4-70:11:25.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41027,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41027,18.51,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1829, RA-DEC 05:23:17.9-70:34:30.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41028,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41028,18.51,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2291, RA-DEC 05:32:03.3-71:41:19.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41029,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41029,18.51,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2366, RA-DEC 05:33:31.5-69:00:53.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41030,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41030,18.51,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2498, RA-DEC 05:35:34.2-70:05:58.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41031,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41031,18.51,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2660, RA-DEC 05:37:37.6-70:25:52.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41032,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41032,18.51,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3040, RA-DEC 05:43:39.5-71:59:20.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41033,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41033,18.51,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3608, RA-DEC 05:07:47.6-66:22:40.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41034,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41034,18.51,0.06,0.0502,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4503, RA-DEC 05:52:42.4-67:29:38.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41035,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41035,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0918, RA-DEC 05:05:45.3-70:15:44.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41036,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41036,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1057, RA-DEC 05:08:17.7-70:11:28.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41037,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41037,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1093, RA-DEC 05:08:54.3-69:14:33.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41038,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41038,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1139, RA-DEC 05:09:55.9-68:49:12.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41039,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41039,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1766, RA-DEC 05:22:30.2-71:49:14.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41040,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41040,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1786, RA-DEC 05:22:43.7-70:16:11.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41041,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41041,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2251, RA-DEC 05:31:19.3-70:02:59.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41042,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41042,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3052, RA-DEC 05:43:59.9-70:31:18.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41043,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41043,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3584, RA-DEC 05:06:16.6-66:13:13.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41044,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41044,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0189, RA-DEC 04:51:15.6-69:05:17.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41045,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41045,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0656, RA-DEC 05:00:56.2-70:25:19.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41046,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41046,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0740, RA-DEC 05:02:20.4-68:46:27.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41047,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41047,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0840, RA-DEC 05:04:08.5-67:35:56.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41048,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41048,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1108, RA-DEC 05:09:15.1-69:09:02.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41049,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41049,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1253, RA-DEC 05:12:56.2-68:57:52.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41050,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41050,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2025, RA-DEC 05:27:01.2-71:00:20.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41051,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41051,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2338, RA-DEC 05:33:02.2-70:15:33.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41052,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41052,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3187, RA-DEC 05:47:29.8-68:25:04.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41053,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41053,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3329, RA-DEC 05:58:39.0-69:47:46.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41054,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41054,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4089, RA-DEC 05:30:52.2-65:28:14.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41055,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41055,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0284, RA-DEC 04:53:27.4-70:10:54.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41056,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41056,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0354, RA-DEC 04:54:54.6-68:51:44.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41057,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41057,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1007, RA-DEC 05:07:25.1-69:57:50.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41058,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41058,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1402, RA-DEC 05:15:50.2-71:00:09.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41059,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41059,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1436, RA-DEC 05:16:11.8-69:15:25.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41060,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41060,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2842, RA-DEC 05:40:03.3-71:02:09.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41061,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41061,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3009, RA-DEC 05:42:49.7-70:54:40.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41062,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41062,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3126, RA-DEC 05:45:55.3-70:54:23.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41063,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41063,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3605, RA-DEC 05:07:40.8-65:52:08.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41064,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41064,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3855, RA-DEC 05:18:43.4-64:55:41.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41065,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41065,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4014, RA-DEC 05:27:18.5-67:12:31.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41066,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41066,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4193, RA-DEC 05:36:29.2-66:41:18.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41067,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41067,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0707, RA-DEC 05:01:50.8-70:42:29.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41068,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41068,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1048, RA-DEC 05:08:07.3-68:04:39.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41069,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41069,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1817, RA-DEC 05:23:10.3-70:17:10.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41070,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41070,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3400, RA-DEC 04:47:33.9-66:30:37.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41071,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41071,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3548, RA-DEC 05:04:04.3-66:16:47.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41072,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41072,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4380, RA-DEC 05:46:33.8-67:39:26.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41073,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41073,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0497, RA-DEC 04:57:48.4-68:07:29.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41074,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41074,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0827, RA-DEC 05:03:52.6-68:18:57.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41075,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41075,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0886, RA-DEC 05:05:14.5-68:46:07.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41076,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41076,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1137, RA-DEC 05:09:52.4-69:12:29.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41077,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41077,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1466, RA-DEC 05:16:58.6-69:23:38.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41078,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41078,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2308, RA-DEC 05:32:24.9-69:58:38.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41079,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41079,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2597, RA-DEC 05:36:53.7-70:09:47.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41080,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41080,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2893, RA-DEC 05:40:45.9-68:44:05.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41081,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41081,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2895, RA-DEC 05:40:47.5-70:29:28.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41082,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41082,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2978, RA-DEC 05:42:16.3-69:52:38.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41083,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41083,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3671, RA-DEC 05:11:14.1-71:43:53.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41084,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41084,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0560, RA-DEC 04:59:05.6-70:09:51.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41085,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41085,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0732, RA-DEC 05:02:16.3-69:27:03.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41086,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41086,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0744, RA-DEC 05:02:22.3-68:52:21.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41087,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41087,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1130, RA-DEC 05:09:38.3-70:14:13.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41088,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41088,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1191, RA-DEC 05:11:19.1-68:00:04.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41089,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41089,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1256, RA-DEC 05:13:00.3-70:39:00.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41090,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41090,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2021, RA-DEC 05:26:58.4-70:15:48.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41091,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41091,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2184, RA-DEC 05:30:21.1-69:34:25.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41092,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41092,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2526, RA-DEC 05:35:55.7-70:12:11.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41093,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41093,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2550, RA-DEC 05:36:19.9-70:21:27.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41094,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41094,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2797, RA-DEC 05:39:25.9-71:05:16.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41095,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41095,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2805, RA-DEC 05:39:32.4-70:26:28.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41096,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41096,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3148, RA-DEC 05:46:23.8-71:43:58.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41097,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41097,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3305, RA-DEC 05:55:30.9-69:28:22.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41098,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41098,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3654, RA-DEC 05:10:35.1-71:34:45.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41099,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41099,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4280, RA-DEC 05:41:24.9-67:13:42.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41100,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41100,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4357, RA-DEC 05:45:09.9-67:23:09.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41101,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41101,18.51,0.02,0.0503,10597,NULL,NULL,'IRAC 3.6 micron, Mean of 136','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41102,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41102,18.51,0.05,0.0503,10597,NULL,NULL,'HV 00921, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41103,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41103,18.51,0.05,0.0503,10597,NULL,NULL,'HV 02299, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41104,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41104,18.51,0.05,0.0503,10597,NULL,NULL,'HV 00932, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41105,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41105,18.51,0.05,0.0503,10597,NULL,NULL,'HV 02273, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41106,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41106,18.51,0.03,0.0503,10597,NULL,NULL,'NGC 1866, 11, U-K, Baade-Wesselink','LMC',NULL,'2012ApJ...748...69M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41107,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41107,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0087, RA-DEC 04:47:24.2-69:43:19.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41108,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41108,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0507, RA-DEC 04:58:00.4-66:54:23.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41109,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41109,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0709, RA-DEC 05:01:53.1-69:13:52.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41110,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41110,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2211, RA-DEC 05:30:48.1-71:11:32.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41111,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41111,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3695, RA-DEC 05:12:20.0-71:40:28.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41112,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41112,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3907, RA-DEC 05:21:46.0-66:59:10.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41113,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41113,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4314, RA-DEC 05:42:52.8-67:17:19.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41114,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41114,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4447, RA-DEC 05:49:28.4-67:44:53.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41115,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41115,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0190, RA-DEC 04:51:15.6-70:13:52.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41116,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41116,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0551, RA-DEC 04:58:50.6-69:04:13.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41117,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41117,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1510, RA-DEC 05:17:54.2-70:55:16.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41118,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41118,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1521, RA-DEC 05:18:00.9-69:44:11.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41119,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41119,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1687, RA-DEC 05:21:24.3-71:35:25.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41120,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41120,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1699, RA-DEC 05:21:37.4-67:49:53.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41121,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41121,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2066, RA-DEC 05:27:55.0-69:48:03.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41122,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41122,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2368, RA-DEC 05:33:35.2-70:58:30.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41123,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41123,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3719, RA-DEC 05:13:13.9-66:15:28.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41124,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41124,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0075, RA-DEC 04:46:39.1-70:15:57.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41125,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41125,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1541, RA-DEC 05:18:26.9-69:19:27.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41126,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41126,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1621, RA-DEC 05:20:04.5-69:16:50.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41127,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41127,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1715, RA-DEC 05:21:52.7-69:36:22.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41128,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41128,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1981, RA-DEC 05:26:02.2-69:18:00.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41129,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41129,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2120, RA-DEC 05:29:06.5-69:10:34.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41130,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41130,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2560, RA-DEC 05:36:27.1-69:40:47.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41131,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41131,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2751, RA-DEC 05:38:47.1-70:17:08.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41132,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41132,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3514, RA-DEC 05:01:06.0-65:08:38.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41133,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41133,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3739, RA-DEC 05:13:39.5-63:57:18.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41134,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41134,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4543, RA-DEC 05:57:28.5-68:02:51.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41135,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41135,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0967, RA-DEC 05:06:50.4-68:06:40.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41136,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41136,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1076, RA-DEC 05:08:38.4-68:30:41.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41137,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41137,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1609, RA-DEC 05:19:47.0-69:12:29.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41138,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41138,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1624, RA-DEC 05:20:07.0-70:04:09.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41139,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41139,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2001, RA-DEC 05:26:31.8-69:50:26.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41140,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41140,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2515, RA-DEC 05:35:45.8-71:01:30.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41141,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41141,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2872, RA-DEC 05:40:32.0-70:28:29.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41142,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41142,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3402, RA-DEC 04:48:22.7-66:19:20.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41143,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41143,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3623, RA-DEC 05:08:56.1-71:25:15.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41144,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41144,18.51,0.06,0.0503,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3754, RA-DEC 05:14:16.4-65:53:14.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41145,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41145,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0502, RA-DEC 04:57:51.2-68:18:15.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41146,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41146,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0964, RA-DEC 05:06:41.5-67:13:56.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41147,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41147,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1537, RA-DEC 05:18:13.7-69:42:20.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41148,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41148,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2312, RA-DEC 05:32:29.7-70:12:56.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41149,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41149,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2728, RA-DEC 05:38:31.2-68:03:44.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41150,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41150,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3020, RA-DEC 05:42:58.2-72:20:31.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41151,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41151,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3870, RA-DEC 05:19:38.6-66:15:07.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41152,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41152,18.51,0.06,0.0504,10597,NULL,NULL,'1264, J, GAL PL','LMC',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41153,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41153,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0811, RA-DEC 05:03:37.5-67:39:10.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41154,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41154,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0959, RA-DEC 05:06:35.7-68:13:01.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41155,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41155,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1198, RA-DEC 05:11:30.8-70:19:58.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41156,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41156,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1956, RA-DEC 05:25:40.6-69:50:13.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41157,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41157,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2225, RA-DEC 05:30:58.3-69:57:31.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41158,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41158,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2228, RA-DEC 05:31:00.0-70:19:02.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41159,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41159,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2447, RA-DEC 05:34:39.6-68:48:36.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41160,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41160,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2632, RA-DEC 05:37:17.7-68:40:16.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41161,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41161,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2656, RA-DEC 05:37:36.2-69:44:20.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41162,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41162,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3771, RA-DEC 05:14:59.4-76:09:38.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41163,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41163,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0179, RA-DEC 04:51:01.4-69:36:07.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41164,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41164,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0426, RA-DEC 04:56:18.0-68:16:26.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41165,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41165,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1360, RA-DEC 05:15:15.9-71:37:22.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41166,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41166,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1379, RA-DEC 05:15:28.9-70:00:55.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41167,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41167,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1437, RA-DEC 05:16:14.7-69:02:32.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41168,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41168,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1723, RA-DEC 05:21:57.9-68:40:18.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41169,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41169,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1731, RA-DEC 05:22:06.4-70:16:11.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41170,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41170,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1754, RA-DEC 05:22:26.5-70:21:45.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41171,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41171,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2138, RA-DEC 05:29:28.1-71:09:24.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41172,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41172,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0362, RA-DEC 04:55:01.4-71:02:14.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41173,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41173,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0381, RA-DEC 04:55:22.4-67:52:19.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41174,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41174,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0389, RA-DEC 04:55:33.6-70:16:07.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41175,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41175,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0851, RA-DEC 05:04:24.7-67:34:47.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41176,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41176,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0934, RA-DEC 05:06:00.2-70:27:22.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41177,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41177,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0939, RA-DEC 05:06:06.0-66:59:43.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41178,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41178,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1413, RA-DEC 05:15:58.2-68:58:13.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41179,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41179,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2918, RA-DEC 05:41:14.1-70:56:03.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41180,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41180,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3439, RA-DEC 04:53:05.2-66:13:35.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41181,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41181,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3529, RA-DEC 05:02:38.5-66:27:59.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41182,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41182,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0371, RA-DEC 04:55:10.0-69:06:54.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41183,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41183,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0745, RA-DEC 05:02:23.3-70:25:23.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41184,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41184,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0882, RA-DEC 05:05:07.5-70:08:22.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41185,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41185,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1283, RA-DEC 05:13:49.2-69:05:42.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41186,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41186,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2183, RA-DEC 05:30:18.2-69:48:14.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41187,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41187,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4125, RA-DEC 05:32:55.8-62:44:33.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41188,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41188,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0688, RA-DEC 05:01:31.8-70:40:59.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41189,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41189,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0752, RA-DEC 05:02:27.9-69:12:41.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41190,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41190,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1912, RA-DEC 05:24:59.9-68:12:02.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41191,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41191,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3338, RA-DEC 06:02:00.0-71:11:42.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41192,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41192,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3657, RA-DEC 05:10:40.0-64:50:13.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41193,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41193,18.51,0.13,0.0504,10597,NULL,NULL,'NGC 1866, VI, PLC','LMC',NULL,'1987MNRAS.225..627W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41194,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41194,18.51,0.06,0.0504,10597,NULL,NULL,NULL,'LMC',NULL,'1988ApJ...329..712S',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41195,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41195,18.51,0.21,0.0504,10597,NULL,NULL,'NGC 1866','LMC',NULL,'1993ApJ...412..160B',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41196,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41196,18.51,0.1,0.0504,10597,NULL,NULL,'VK','LMC',NULL,'2003MNRAS.345..269H',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41197,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41197,18.51,0.05,0.0504,10597,NULL,NULL,'HV 905','LMC',NULL,'1997ApJ...485L..25W',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41198,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41198,18.51,0.02,0.0504,10597,NULL,NULL,'LMC SC5-338399','LMC',NULL,'2005A&A...434.1077M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41199,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41199,18.51,0.05,0.0504,10597,NULL,NULL,'HV 00923, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41200,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41200,18.51,0.05,0.0504,10597,NULL,NULL,'HV 02371, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41201,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41201,18.51,0.05,0.0504,10597,NULL,NULL,'HV 02462, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41202,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41202,18.51,0.05,0.0504,10597,NULL,NULL,'HV 00905, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41203,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41203,18.51,0.05,0.0504,10597,NULL,NULL,'HV 12519, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41204,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41204,18.51,0.05,0.0504,10597,NULL,NULL,'HV 02527, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41205,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41205,18.51,0.05,0.0504,10597,NULL,NULL,'HV 02324, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41206,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41206,18.51,0.05,0.0504,10597,NULL,NULL,'HV 02356, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41207,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41207,18.51,0.05,0.0504,10597,NULL,NULL,'HV 12499, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41208,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41208,18.51,0.05,0.0504,10597,NULL,NULL,'HV 05497, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41209,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41209,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0150, RA-DEC 04:50:09.7-70:30:53.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41210,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41210,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0765, RA-DEC 05:02:46.5-67:24:07.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41211,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41211,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1313, RA-DEC 05:14:19.4-69:29:24.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41212,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41212,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1461, RA-DEC 05:16:52.7-69:22:04.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41213,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41213,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1549, RA-DEC 05:18:35.4-69:36:03.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41214,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41214,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2178, RA-DEC 05:30:13.9-70:03:49.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41215,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41215,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2272, RA-DEC 05:31:43.6-71:08:29.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41216,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41216,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2876, RA-DEC 05:40:33.0-70:20:27.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41217,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41217,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3196, RA-DEC 05:47:44.6-70:29:03.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41218,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41218,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3424, RA-DEC 04:51:34.5-73:31:45.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41219,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41219,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3429, RA-DEC 04:52:25.7-65:48:20.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41220,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41220,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1323, RA-DEC 05:14:40.2-70:08:11.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41221,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41221,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2416, RA-DEC 05:34:06.4-69:36:35.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41222,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41222,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2423, RA-DEC 05:34:18.6-69:53:38.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41223,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41223,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2554, RA-DEC 05:36:23.2-70:03:07.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41224,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41224,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2789, RA-DEC 05:39:19.3-70:05:32.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41225,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41225,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3092, RA-DEC 05:44:52.0-68:38:46.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41226,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41226,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3403, RA-DEC 04:48:25.2-71:25:49.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41227,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41227,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3589, RA-DEC 05:06:42.9-71:41:16.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41228,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41228,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3777, RA-DEC 05:15:20.7-66:12:44.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41229,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41229,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0176, RA-DEC 04:50:55.7-68:53:40.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41230,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41230,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0553, RA-DEC 04:58:55.7-69:15:59.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41231,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41231,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0957, RA-DEC 05:06:31.0-69:55:42.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41232,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41232,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1202, RA-DEC 05:11:35.2-69:14:59.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41233,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41233,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3222, RA-DEC 05:48:52.1-70:50:29.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41234,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41234,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4130, RA-DEC 05:32:58.7-66:43:26.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41235,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41235,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0248, RA-DEC 04:52:47.6-70:00:45.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41236,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41236,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0407, RA-DEC 04:55:52.5-68:49:16.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41237,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41237,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0408, RA-DEC 04:55:52.8-69:17:19.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41238,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41238,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0696, RA-DEC 05:01:39.9-67:27:57.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41239,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41239,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1169, RA-DEC 05:10:37.4-69:15:06.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41240,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41240,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3087, RA-DEC 05:44:46.1-70:03:06.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41241,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41241,18.51,0.06,0.0504,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4376, RA-DEC 05:46:18.5-66:18:01.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41242,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41242,18.51,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0067, RA-DEC 04:45:34.6-70:22:15.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41243,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41243,18.51,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1257, RA-DEC 05:13:04.1-68:46:17.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41244,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41244,18.51,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1605, RA-DEC 05:19:43.8-69:22:53.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41245,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41245,18.51,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1654, RA-DEC 05:20:43.4-69:58:23.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41246,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41246,18.51,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1691, RA-DEC 05:21:28.0-68:05:34.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41247,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41247,18.51,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1821, RA-DEC 05:23:12.8-70:16:48.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41248,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41248,18.51,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2413, RA-DEC 05:34:02.5-70:59:38.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41249,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41249,18.51,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2499, RA-DEC 05:35:34.8-70:06:45.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41250,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41250,18.51,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2627, RA-DEC 05:37:11.0-69:21:36.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41251,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41251,18.51,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2716, RA-DEC 05:38:19.2-70:27:48.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41252,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41252,18.51,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3220, RA-DEC 05:48:51.1-68:57:43.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41253,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41253,18.51,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3489, RA-DEC 04:58:45.3-75:01:41.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41254,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41254,18.51,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3698, RA-DEC 05:12:25.5-72:20:46.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41255,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41255,18.51,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3869, RA-DEC 05:19:32.4-64:36:51.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41256,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41256,18.51,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0140, RA-DEC 04:49:57.6-67:41:37.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41257,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41257,18.51,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0318, RA-DEC 04:54:14.0-69:47:57.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41258,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41258,18.51,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1928, RA-DEC 05:25:22.4-69:40:57.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41259,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41259,18.51,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2334, RA-DEC 05:32:57.6-70:22:35.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41260,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41260,18.51,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2556, RA-DEC 05:36:23.9-69:54:05.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41261,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41261,18.51,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3164, RA-DEC 05:46:43.8-70:40:51.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41262,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41262,18.51,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3174, RA-DEC 05:47:11.6-72:10:17.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41263,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41263,18.51,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3208, RA-DEC 05:48:15.3-70:28:19.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41264,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41264,18.51,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3413, RA-DEC 04:49:28.7-66:24:24.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41265,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41265,18.51,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4326, RA-DEC 05:43:45.2-65:06:55.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41266,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41266,18.51,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4514, RA-DEC 05:54:44.0-67:56:54.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41267,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41267,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0064, RA-DEC 04:45:29.3-69:08:49.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41268,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41268,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0377, RA-DEC 04:55:16.2-68:12:18.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41269,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41269,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0629, RA-DEC 05:00:22.5-70:25:20.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41270,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41270,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0914, RA-DEC 05:05:41.0-71:19:30.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41271,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41271,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2326, RA-DEC 05:32:47.4-69:25:30.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41272,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41272,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2730, RA-DEC 05:38:31.7-69:59:31.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41273,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41273,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3243, RA-DEC 05:49:51.2-70:00:14.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41274,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41274,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3334, RA-DEC 05:59:32.0-70:32:39.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41275,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41275,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3453, RA-DEC 04:53:59.9-71:06:34.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41276,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41276,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4055, RA-DEC 05:29:05.7-64:59:43.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41277,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41277,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0259, RA-DEC 04:52:55.0-68:48:09.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41278,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41278,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0333, RA-DEC 04:54:36.5-71:15:24.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41279,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41279,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0382, RA-DEC 04:55:22.4-68:49:18.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41280,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41280,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1419, RA-DEC 05:16:00.6-70:07:50.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41281,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41281,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2568, RA-DEC 05:36:30.2-69:57:51.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41282,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41282,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2608, RA-DEC 05:36:56.8-70:09:40.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41283,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41283,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0163, RA-DEC 04:50:32.7-68:12:49.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41284,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41284,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0443, RA-DEC 04:56:38.7-69:18:02.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41285,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41285,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0549, RA-DEC 04:58:49.6-71:19:13.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41286,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41286,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1429, RA-DEC 05:16:07.3-69:20:47.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41287,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41287,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1606, RA-DEC 05:19:44.5-69:46:34.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41288,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41288,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1826, RA-DEC 05:23:14.3-70:03:13.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41289,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41289,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2165, RA-DEC 05:30:00.4-70:46:37.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41290,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41290,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3251, RA-DEC 05:50:19.8-70:15:35.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41291,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41291,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3253, RA-DEC 05:50:36.5-70:09:41.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41292,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41292,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3920, RA-DEC 05:22:10.6-66:57:06.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41293,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41293,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4044, RA-DEC 05:28:36.6-63:48:46.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41294,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41294,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4352, RA-DEC 05:45:01.5-73:33:55.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41295,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41295,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4504, RA-DEC 05:52:42.8-67:22:22.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41296,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41296,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1272, RA-DEC 05:13:26.5-70:04:55.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41297,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41297,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1877, RA-DEC 05:24:28.4-68:57:19.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41298,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41298,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2936, RA-DEC 05:41:27.4-71:56:24.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41299,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41299,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4201, RA-DEC 05:36:46.9-66:17:22.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41300,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41300,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4205, RA-DEC 05:36:57.2-64:46:51.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41301,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41301,18.52,0.05,0.0505,10597,NULL,NULL,'OIII 0978, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41302,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41302,18.52,0.05,0.0505,10597,NULL,NULL,'HV 00906, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41303,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41303,18.52,0.05,0.0505,10597,NULL,NULL,'HV 00898, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41304,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41304,18.52,0.05,0.0505,10597,NULL,NULL,'HV 02321, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41305,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41305,18.52,0.05,0.0505,10597,NULL,NULL,'HV 00895, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41306,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41306,18.52,0.05,0.0505,10597,NULL,NULL,'HV 02339, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41307,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41307,18.52,0.05,0.0505,10597,NULL,NULL,'HV 00911, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41308,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41308,18.52,0.05,0.0505,10597,NULL,NULL,'HV 02249, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41309,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41309,18.52,0.05,0.0505,10597,NULL,NULL,'HV 02549, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41310,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41310,18.52,0.05,0.0505,10597,NULL,NULL,'HV 02319, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41311,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41311,18.52,0.05,0.0505,10597,NULL,NULL,'OIII 1080, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41312,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41312,18.52,0.05,0.0505,10597,NULL,NULL,'HV 00904, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41313,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41313,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0954, RA-DEC 05:06:22.9-67:58:33.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41314,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41314,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1368, RA-DEC 05:15:20.6-70:59:59.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41315,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41315,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2044, RA-DEC 05:27:27.2-71:52:54.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41316,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41316,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2392, RA-DEC 05:33:45.7-69:43:38.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41317,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41317,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3602, RA-DEC 05:07:32.8-66:19:42.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41318,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41318,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4428, RA-DEC 05:48:47.0-66:47:58.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41319,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41319,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0111, RA-DEC 04:49:04.1-69:18:02.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41320,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41320,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0346, RA-DEC 04:54:50.2-69:14:12.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41321,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41321,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0573, RA-DEC 04:59:18.1-69:52:51.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41322,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41322,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0720, RA-DEC 05:02:05.3-67:31:35.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41323,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41323,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1085, RA-DEC 05:08:47.4-66:51:43.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41324,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41324,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1226, RA-DEC 05:12:06.6-66:35:18.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41325,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41325,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1247, RA-DEC 05:12:46.0-69:26:18.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41326,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41326,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1299, RA-DEC 05:14:03.2-66:53:26.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41327,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41327,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1445, RA-DEC 05:16:25.3-68:49:51.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41328,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41328,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2848, RA-DEC 05:40:08.2-70:21:35.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41329,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41329,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4494, RA-DEC 05:52:17.0-67:16:25.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41330,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41330,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0673, RA-DEC 05:01:06.5-70:38:33.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41331,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41331,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0952, RA-DEC 05:06:19.6-66:35:47.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41332,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41332,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1505, RA-DEC 05:17:43.0-69:37:40.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41333,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41333,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1518, RA-DEC 05:17:58.2-68:29:47.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41334,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41334,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2233, RA-DEC 05:31:02.7-69:57:12.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41335,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41335,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2342, RA-DEC 05:33:07.3-70:55:24.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41336,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41336,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2519, RA-DEC 05:35:51.8-70:04:01.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41337,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41337,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2631, RA-DEC 05:37:16.5-70:45:04.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41338,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41338,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2894, RA-DEC 05:40:47.0-69:56:02.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41339,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41339,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3346, RA-DEC 06:05:38.6-69:32:46.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41340,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41340,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0037, RA-DEC 04:42:14.9-68:26:10.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41341,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41341,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0650, RA-DEC 05:00:54.4-67:50:35.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41342,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41342,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1020, RA-DEC 05:07:30.2-69:12:55.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41343,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41343,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1159, RA-DEC 05:10:23.8-69:10:10.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41344,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41344,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1177, RA-DEC 05:10:52.3-69:54:22.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41345,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41345,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1439, RA-DEC 05:16:15.8-68:57:42.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41346,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41346,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2004, RA-DEC 05:26:38.1-70:09:01.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41347,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41347,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2242, RA-DEC 05:31:09.7-70:59:49.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41348,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41348,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2750, RA-DEC 05:38:46.6-69:41:18.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41349,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41349,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2948, RA-DEC 05:41:47.6-70:17:51.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41350,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41350,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3250, RA-DEC 05:50:19.5-69:09:04.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41351,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41351,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3265, RA-DEC 05:51:26.5-69:03:43.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41352,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41352,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3507, RA-DEC 05:00:22.3-71:26:00.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41353,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41353,18.52,0.06,0.0505,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4286, RA-DEC 05:41:43.2-66:51:00.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41354,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41354,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1012, RA-DEC 05:07:26.3-68:29:13.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41355,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41355,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1513, RA-DEC 05:17:55.3-69:45:46.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41356,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41356,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1574, RA-DEC 05:19:08.5-69:47:20.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41357,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41357,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2385, RA-DEC 05:33:42.4-70:58:51.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41358,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41358,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2420, RA-DEC 05:34:14.1-70:59:55.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41359,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41359,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2796, RA-DEC 05:39:25.8-70:10:58.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41360,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41360,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2939, RA-DEC 05:41:31.6-68:47:39.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41361,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41361,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3322, RA-DEC 05:57:58.4-69:25:39.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41362,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41362,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3520, RA-DEC 05:01:42.6-66:14:53.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41363,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41363,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0027, RA-DEC 04:41:19.5-67:20:08.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41364,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41364,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0230, RA-DEC 04:52:19.9-69:05:29.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41365,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41365,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0330, RA-DEC 04:54:24.5-68:46:31.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41366,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41366,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1049, RA-DEC 05:08:08.5-67:56:30.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41367,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41367,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1161, RA-DEC 05:10:28.5-69:53:16.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41368,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41368,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1664, RA-DEC 05:20:54.9-69:54:59.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41369,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41369,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1949, RA-DEC 05:25:34.4-69:50:08.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41370,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41370,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2011, RA-DEC 05:26:48.8-69:51:33.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41371,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41371,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2115, RA-DEC 05:28:54.5-71:02:34.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41372,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41372,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2215, RA-DEC 05:30:48.7-69:48:48.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41373,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41373,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2295, RA-DEC 05:32:04.9-69:20:57.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41374,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41374,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2551, RA-DEC 05:36:21.5-70:06:37.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41375,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41375,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3427, RA-DEC 04:51:58.3-66:26:49.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41376,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41376,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3844, RA-DEC 05:18:01.6-64:20:09.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41377,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41377,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3991, RA-DEC 05:26:03.9-66:02:36.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41378,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41378,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4223, RA-DEC 05:38:07.0-66:47:06.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41379,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41379,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1330, RA-DEC 05:14:45.9-69:19:58.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41380,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41380,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1365, RA-DEC 05:15:20.0-69:26:24.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41381,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41381,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1971, RA-DEC 05:25:56.3-70:09:00.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41382,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41382,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2221, RA-DEC 05:30:55.8-70:10:22.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41383,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41383,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3182, RA-DEC 05:47:25.0-69:23:21.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41384,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41384,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3594, RA-DEC 05:07:08.6-71:58:55.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41385,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41385,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4022, RA-DEC 05:27:38.3-67:33:38.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41386,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41386,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4041, RA-DEC 05:28:32.6-65:58:33.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41387,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41387,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0413, RA-DEC 04:55:58.8-70:04:09.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41388,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41388,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0552, RA-DEC 04:58:53.0-68:51:07.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41389,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41389,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0733, RA-DEC 05:02:17.3-69:12:40.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41390,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41390,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2421, RA-DEC 05:34:15.6-69:34:23.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41391,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41391,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2655, RA-DEC 05:37:35.5-70:14:09.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41392,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41392,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2747, RA-DEC 05:38:45.8-69:50:33.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41393,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41393,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3094, RA-DEC 05:44:58.3-68:03:28.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41394,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41394,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3639, RA-DEC 05:09:49.4-66:22:13.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41395,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41395,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3809, RA-DEC 05:16:22.6-66:02:30.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41396,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41396,18.52,0.01,0.0506,10597,NULL,NULL,'81','LMC',NULL,'2015ApJ...815...87C',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41397,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41397,18.52,0.06,0.0506,10597,NULL,NULL,'1264, J','LMC',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41398,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41398,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0058, RA-DEC 04:44:53.3-69:11:29.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41399,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41399,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0569, RA-DEC 04:59:15.2-70:03:30.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41400,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41400,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0849, RA-DEC 05:04:24.0-70:41:09.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41401,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41401,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1387, RA-DEC 05:15:37.3-69:08:16.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41402,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41402,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1807, RA-DEC 05:23:04.5-70:31:13.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41403,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41403,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2959, RA-DEC 05:41:58.1-70:13:17.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41404,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41404,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3750, RA-DEC 05:13:50.2-65:29:09.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41405,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41405,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3810, RA-DEC 05:16:23.5-64:54:49.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41406,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41406,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3874, RA-DEC 05:19:48.3-72:01:47.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41407,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41407,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4081, RA-DEC 05:30:30.3-66:40:59.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41408,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41408,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0587, RA-DEC 04:59:35.0-70:06:08.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41409,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41409,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0855, RA-DEC 05:04:28.1-70:24:15.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41410,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41410,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1382, RA-DEC 05:15:34.0-70:17:08.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41411,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41411,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3238, RA-DEC 05:49:41.4-70:55:45.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41412,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41412,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3544, RA-DEC 05:03:45.2-65:49:22.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41413,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41413,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3694, RA-DEC 05:12:18.8-65:23:13.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41414,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41414,18.52,0.03,0.0506,10597,NULL,NULL,'VI','LMC',NULL,'2007MNRAS.379..723V',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41415,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41415,18.52,0.03,0.0506,10597,NULL,NULL,'VI, GAL+LMC PL','LMC',NULL,'2007MNRAS.379..723V',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41416,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41416,18.52,0.03,0.0506,10597,NULL,NULL,NULL,'LMC',NULL,'2010vsgh.conf...45F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41417,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41417,18.52,0.18,0.0506,10597,NULL,NULL,'K, avg of 3PL, 3PL(Z), and 3PLC','LMC',NULL,'2000A&A...356..849G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41418,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41418,18.52,0.05,0.0506,10597,NULL,NULL,'HV 00880, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41419,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41419,18.52,0.05,0.0506,10597,NULL,NULL,'HV 00892, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41420,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41420,18.52,0.05,0.0506,10597,NULL,NULL,'HV 00901, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41421,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41421,18.52,0.05,0.0506,10597,NULL,NULL,'HV 00876, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41422,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41422,18.52,0.05,0.0506,10597,NULL,NULL,'HV 00899, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41423,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41423,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0620, RA-DEC 05:00:08.2-67:48:09.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41424,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41424,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1090, RA-DEC 05:08:50.7-71:18:42.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41425,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41425,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1947, RA-DEC 05:25:32.5-70:13:02.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41426,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41426,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2252, RA-DEC 05:31:21.1-67:59:47.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41427,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41427,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2624, RA-DEC 05:37:06.1-70:39:08.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41428,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41428,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2915, RA-DEC 05:41:11.7-70:21:54.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41429,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41429,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3254, RA-DEC 05:50:39.0-70:14:05.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41430,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41430,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3426, RA-DEC 04:51:54.6-66:04:25.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41431,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41431,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3895, RA-DEC 05:21:00.4-72:00:00.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41432,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41432,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4075, RA-DEC 05:30:18.9-66:40:23.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41433,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41433,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4569, RA-DEC 06:03:03.0-63:07:33.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41434,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41434,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0119, RA-DEC 04:49:17.0-69:12:24.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41435,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41435,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0842, RA-DEC 05:04:11.6-70:15:33.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41436,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41436,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0951, RA-DEC 05:06:18.5-66:38:44.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41437,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41437,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1246, RA-DEC 05:12:45.5-69:16:03.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41438,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41438,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1293, RA-DEC 05:13:56.4-67:09:22.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41439,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41439,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2038, RA-DEC 05:27:16.3-71:02:04.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41440,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41440,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2430, RA-DEC 05:34:22.8-68:08:52.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41441,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41441,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2441, RA-DEC 05:34:34.4-69:54:06.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41442,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41442,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2790, RA-DEC 05:39:20.1-69:33:25.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41443,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41443,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3787, RA-DEC 05:15:50.3-64:27:13.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41444,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41444,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3877, RA-DEC 05:19:56.2-74:26:36.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41445,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41445,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0596, RA-DEC 04:59:49.4-68:05:07.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41446,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41446,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0896, RA-DEC 05:05:24.6-70:34:41.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41447,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41447,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2164, RA-DEC 05:29:59.1-71:03:38.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41448,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41448,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2265, RA-DEC 05:31:38.8-69:58:41.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41449,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41449,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3432, RA-DEC 04:52:30.0-71:15:57.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41450,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41450,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4564, RA-DEC 06:00:56.3-67:32:04.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41451,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41451,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1344, RA-DEC 05:15:04.6-70:07:10.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41452,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41452,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1915, RA-DEC 05:25:04.5-68:56:40.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41453,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41453,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2141, RA-DEC 05:29:29.5-71:54:53.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41454,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41454,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2404, RA-DEC 05:33:56.7-68:53:28.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41455,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41455,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2981, RA-DEC 05:42:18.1-70:22:27.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41456,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41456,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3030, RA-DEC 05:43:12.2-72:27:38.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41457,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41457,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3200, RA-DEC 05:47:53.6-70:52:39.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41458,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41458,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3553, RA-DEC 05:04:18.3-70:35:06.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41459,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41459,18.52,0.06,0.0506,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4173, RA-DEC 05:35:33.2-63:07:13.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41460,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41460,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1218, RA-DEC 05:11:57.6-67:46:37.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41461,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41461,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1451, RA-DEC 05:16:32.0-69:39:24.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41462,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41462,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3962, RA-DEC 05:24:47.8-66:22:08.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41463,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41463,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4024, RA-DEC 05:27:49.5-64:29:47.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41464,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41464,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0294, RA-DEC 04:53:36.6-67:36:50.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41465,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41465,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0439, RA-DEC 04:56:33.6-70:09:20.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41466,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41466,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0450, RA-DEC 04:56:43.5-67:39:08.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41467,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41467,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0685, RA-DEC 05:01:26.6-67:36:01.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41468,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41468,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1028, RA-DEC 05:07:37.7-67:46:47.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41469,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41469,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1060, RA-DEC 05:08:19.5-70:36:51.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41470,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41470,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1617, RA-DEC 05:20:01.6-70:51:06.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41471,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41471,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1734, RA-DEC 05:22:10.1-69:34:18.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41472,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41472,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1852, RA-DEC 05:23:55.2-71:16:46.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41473,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41473,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2179, RA-DEC 05:30:14.4-70:49:14.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41474,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41474,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2723, RA-DEC 05:38:26.7-70:23:12.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41475,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41475,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4479, RA-DEC 05:51:19.1-66:13:19.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41476,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41476,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0104, RA-DEC 04:48:45.6-70:00:21.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41477,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41477,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0390, RA-DEC 04:55:34.0-68:56:47.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41478,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41478,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0449, RA-DEC 04:56:42.8-69:29:55.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41479,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41479,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1265, RA-DEC 05:13:12.6-68:32:51.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41480,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41480,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2223, RA-DEC 05:30:57.2-71:30:07.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41481,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41481,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3008, RA-DEC 05:42:49.5-70:07:00.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41482,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41482,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3041, RA-DEC 05:43:39.8-69:44:16.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41483,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41483,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3606, RA-DEC 05:07:43.6-64:27:02.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41484,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41484,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0948, RA-DEC 05:06:16.4-68:47:20.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41485,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41485,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2007, RA-DEC 05:26:44.6-69:48:04.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41486,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41486,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2129, RA-DEC 05:29:17.0-69:00:22.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41487,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41487,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2160, RA-DEC 05:29:54.4-71:06:03.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41488,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41488,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3177, RA-DEC 05:47:17.0-70:18:57.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41489,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41489,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4457, RA-DEC 05:49:57.9-67:15:52.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41490,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41490,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1314, RA-DEC 05:14:23.1-66:36:02.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41491,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41491,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2146, RA-DEC 05:29:33.8-70:00:32.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41492,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41492,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3129, RA-DEC 05:46:00.0-70:47:07.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41493,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41493,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3632, RA-DEC 05:09:15.9-66:16:29.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41494,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41494,18.52,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4266, RA-DEC 05:40:43.1-66:49:11.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41495,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41495,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0325, RA-DEC 04:54:21.7-69:47:40.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41496,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41496,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0415, RA-DEC 04:56:00.1-68:30:04.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41497,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41497,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1250, RA-DEC 05:12:48.1-68:29:06.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41498,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41498,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1783, RA-DEC 05:22:42.8-69:52:16.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41499,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41499,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2140, RA-DEC 05:29:28.2-70:14:55.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41500,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41500,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4276, RA-DEC 05:41:07.2-65:29:54.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41501,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41501,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4516, RA-DEC 05:54:49.0-67:37:05.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41502,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41502,18.53,0.04,0.0507,10597,NULL,NULL,'115, VJHK','LMC',NULL,'1994MNRAS.266..441L',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41503,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41503,18.53,0.14,0.0507,10597,NULL,NULL,'10, BVIJK','LMC',NULL,'1998ApJ...492..110M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41504,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41504,18.53,0.08,0.0507,10597,NULL,NULL,'VI','LMC',NULL,'2002ApJ...574L..33B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41505,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41505,18.53,0.05,0.0507,10597,NULL,NULL,'OIII 0798, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41506,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41506,18.53,0.05,0.0507,10597,NULL,NULL,'HV 02280, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41507,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41507,18.53,0.05,0.0507,10597,NULL,NULL,'OIII 0812, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41508,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41508,18.52,0.05,0.0507,10597,NULL,NULL,'HV 02285, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41509,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41509,18.52,0.05,0.0507,10597,NULL,NULL,'HV 02260, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41510,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41510,18.52,0.05,0.0507,10597,NULL,NULL,'HV 02244, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41511,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41511,18.53,0.05,0.0507,10597,NULL,NULL,'HV 00891, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41512,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41512,18.52,0.05,0.0507,10597,NULL,NULL,'OIII 0847, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41513,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41513,18.52,0.05,0.0507,10597,NULL,NULL,'HV 00893, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41514,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41514,18.52,0.05,0.0507,10597,NULL,NULL,'HV 02291, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41515,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41515,18.53,0.05,0.0507,10597,NULL,NULL,'HV 00889, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41516,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41516,18.53,0.05,0.0507,10597,NULL,NULL,'HV 00877, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41517,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41517,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0114, RA-DEC 04:49:12.5-69:09:39.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41518,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41518,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1872, RA-DEC 05:24:24.7-69:42:30.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41519,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41519,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2156, RA-DEC 05:29:48.1-71:20:35.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41520,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41520,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2414, RA-DEC 05:34:04.0-68:39:11.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41521,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41521,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3060, RA-DEC 05:44:16.8-69:51:52.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41522,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41522,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4122, RA-DEC 05:32:52.5-65:53:02.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41523,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41523,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0020, RA-DEC 04:39:30.5-69:13:49.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41524,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41524,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0052, RA-DEC 04:43:54.2-68:49:14.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41525,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41525,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0788, RA-DEC 05:03:09.9-67:34:42.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41526,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41526,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1025, RA-DEC 05:07:36.0-70:17:18.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41527,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41527,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1476, RA-DEC 05:17:07.5-69:13:36.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41528,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41528,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1658, RA-DEC 05:20:46.8-70:31:06.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41529,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41529,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1842, RA-DEC 05:23:37.9-69:57:53.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41530,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41530,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2299, RA-DEC 05:32:12.3-69:00:07.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41531,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41531,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2708, RA-DEC 05:38:13.6-70:17:22.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41532,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41532,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0759, RA-DEC 05:02:33.7-69:18:49.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41533,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41533,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2357, RA-DEC 05:33:25.9-69:37:56.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41534,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41534,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2965, RA-DEC 05:42:05.7-68:52:54.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41535,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41535,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3214, RA-DEC 05:48:32.5-70:42:55.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41536,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41536,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0538, RA-DEC 04:58:40.5-67:06:03.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41537,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41537,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1042, RA-DEC 05:08:05.0-67:44:48.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41538,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41538,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1594, RA-DEC 05:19:32.2-69:04:47.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41539,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41539,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1815, RA-DEC 05:23:09.5-70:16:19.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41540,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41540,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1918, RA-DEC 05:25:11.9-70:34:19.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41541,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41541,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2104, RA-DEC 05:28:40.5-69:36:29.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41542,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41542,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2875, RA-DEC 05:40:32.6-70:01:34.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41543,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41543,18.53,0.06,0.0507,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3071, RA-DEC 05:44:27.4-70:26:09.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41544,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41544,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0505, RA-DEC 04:57:57.5-70:32:42.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41545,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41545,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0865, RA-DEC 05:04:39.9-70:05:45.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41546,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41546,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1039, RA-DEC 05:08:01.1-67:01:17.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41547,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41547,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1142, RA-DEC 05:10:00.5-66:41:56.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41548,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41548,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1163, RA-DEC 05:10:32.4-67:13:55.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41549,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41549,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2281, RA-DEC 05:31:50.4-69:54:57.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41550,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41550,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4609, RA-DEC 06:15:52.3-68:50:15.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41551,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41551,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0082, RA-DEC 04:47:14.9-69:59:47.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41552,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41552,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1160, RA-DEC 05:10:26.5-69:29:51.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41553,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41553,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1871, RA-DEC 05:24:21.9-70:53:00.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41554,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41554,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2027, RA-DEC 05:27:03.5-70:01:34.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41555,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41555,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2067, RA-DEC 05:27:55.7-68:29:04.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41556,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41556,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2131, RA-DEC 05:29:21.3-69:06:21.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41557,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41557,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2598, RA-DEC 05:36:54.0-70:08:59.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41558,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41558,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2921, RA-DEC 05:41:17.1-72:24:48.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41559,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41559,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3713, RA-DEC 05:12:50.0-71:59:39.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41560,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41560,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4580, RA-DEC 06:05:49.3-67:24:59.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41561,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41561,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0127, RA-DEC 04:49:36.0-70:37:11.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41562,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41562,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0452, RA-DEC 04:56:45.0-68:30:55.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41563,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41563,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0961, RA-DEC 05:06:39.1-68:57:47.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41564,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41564,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0975, RA-DEC 05:06:58.3-68:36:41.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41565,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41565,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2078, RA-DEC 05:28:11.4-71:22:43.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41566,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41566,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3321, RA-DEC 05:57:49.3-68:27:42.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41567,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41567,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3416, RA-DEC 04:50:03.3-69:49:49.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41568,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41568,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3681, RA-DEC 05:11:47.6-64:41:49.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41569,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41569,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0278, RA-DEC 04:53:15.8-68:57:16.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41570,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41570,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0403, RA-DEC 04:55:48.4-68:47:47.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41571,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41571,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0496, RA-DEC 04:57:47.2-68:23:25.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41572,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41572,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0719, RA-DEC 05:02:05.0-69:59:43.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41573,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41573,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0799, RA-DEC 05:03:24.3-68:51:29.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41574,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41574,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1993, RA-DEC 05:26:21.0-71:09:32.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41575,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41575,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2544, RA-DEC 05:36:16.9-69:54:15.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41576,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41576,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3283, RA-DEC 05:53:01.2-69:29:38.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41577,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41577,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4480, RA-DEC 05:51:21.5-67:19:57.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41578,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41578,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1024, RA-DEC 05:07:34.7-70:49:11.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41579,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41579,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1050, RA-DEC 05:08:09.1-66:41:49.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41580,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41580,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1431, RA-DEC 05:16:09.9-69:32:39.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41581,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41581,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2130, RA-DEC 05:29:19.2-69:49:53.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41582,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41582,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2264, RA-DEC 05:31:38.4-69:56:53.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41583,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41583,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2511, RA-DEC 05:35:42.3-70:40:03.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41584,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41584,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2844, RA-DEC 05:40:04.8-69:22:16.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41585,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41585,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2855, RA-DEC 05:40:13.0-70:26:34.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41586,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41586,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3077, RA-DEC 05:44:34.1-70:59:32.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41587,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41587,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3135, RA-DEC 05:46:08.4-67:51:13.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41588,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41588,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0159, RA-DEC 04:50:26.5-70:33:27.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41589,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41589,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0421, RA-DEC 04:56:11.3-69:49:53.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41590,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41590,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0878, RA-DEC 05:05:02.7-70:33:12.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41591,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41591,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1440, RA-DEC 05:16:16.6-70:10:07.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41592,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41592,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3096, RA-DEC 05:45:01.4-70:29:13.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41593,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41593,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3468, RA-DEC 04:55:24.6-66:12:00.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41594,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41594,18.53,NULL,0.0508,10597,NULL,NULL,'V, Hyades m-M = 3.33 mag','LMC',NULL,'1999ASSL..237..125W',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41595,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41595,18.53,0.05,0.0508,10597,NULL,NULL,NULL,'LMC',NULL,'2002ApJ...565L..83B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41596,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41596,18.53,0.05,0.0508,10597,NULL,NULL,'HV 12537, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41597,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41597,18.53,0.05,0.0508,10597,NULL,NULL,'OIII 0716, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41598,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41598,18.53,0.05,0.0508,10597,NULL,NULL,'HV 05655, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41599,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41599,18.53,0.05,0.0508,10597,NULL,NULL,'HV 02288, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41600,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41600,18.53,0.05,0.0508,10597,NULL,NULL,'HV 00885, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41601,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41601,18.53,0.05,0.0508,10597,NULL,NULL,'HV 02292, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41602,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41602,18.53,0.04,0.0508,10597,NULL,NULL,NULL,'LMC',NULL,'2012ApJ...747...50N',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41603,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41603,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0131, RA-DEC 04:49:45.0-68:52:48.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41604,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41604,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0166, RA-DEC 04:50:38.0-70:34:31.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41605,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41605,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1205, RA-DEC 05:11:38.3-66:35:11.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41606,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41606,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1937, RA-DEC 05:25:27.4-69:29:43.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41607,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41607,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1938, RA-DEC 05:25:28.4-70:11:58.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41608,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41608,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2399, RA-DEC 05:33:51.0-69:12:05.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41609,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41609,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3868, RA-DEC 05:19:31.4-65:00:34.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41610,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41610,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0531, RA-DEC 04:58:34.3-67:11:26.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41611,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41611,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0581, RA-DEC 04:59:30.0-68:58:54.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41612,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41612,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0938, RA-DEC 05:06:05.7-68:41:52.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41613,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41613,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1033, RA-DEC 05:07:48.7-68:38:02.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41614,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41614,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1271, RA-DEC 05:13:20.8-68:38:15.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41615,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41615,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1483, RA-DEC 05:17:16.5-69:15:41.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41616,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41616,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2163, RA-DEC 05:29:58.9-69:42:39.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41617,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41617,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2378, RA-DEC 05:33:40.6-70:59:15.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41618,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41618,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3039, RA-DEC 05:43:37.9-70:34:12.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41619,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41619,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3151, RA-DEC 05:46:28.1-70:38:10.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41620,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41620,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3539, RA-DEC 05:03:26.8-71:39:21.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41621,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41621,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0158, RA-DEC 04:50:23.4-69:09:17.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41622,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41622,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0300, RA-DEC 04:53:44.2-69:36:47.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41623,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41623,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0457, RA-DEC 04:56:53.6-69:37:54.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41624,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41624,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3471, RA-DEC 04:55:42.8-71:23:51.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41625,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41625,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3595, RA-DEC 05:07:13.3-66:29:53.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41626,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41626,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0440, RA-DEC 04:56:34.3-70:06:38.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41627,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41627,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0728, RA-DEC 05:02:11.4-70:20:04.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41628,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41628,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1055, RA-DEC 05:08:12.2-67:51:16.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41629,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41629,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1092, RA-DEC 05:08:54.2-70:06:07.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41630,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41630,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2153, RA-DEC 05:29:42.7-70:18:50.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41631,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41631,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2352, RA-DEC 05:33:21.7-71:29:18.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41632,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41632,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3290, RA-DEC 05:53:26.6-69:20:20.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41633,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41633,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3659, RA-DEC 05:10:44.9-66:12:07.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41634,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41634,18.53,0.06,0.0508,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4228, RA-DEC 05:38:20.0-67:20:32.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41635,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41635,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0204, RA-DEC 04:51:38.2-69:33:11.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41636,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41636,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1098, RA-DEC 05:08:58.6-68:58:17.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41637,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41637,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1517, RA-DEC 05:17:56.5-69:38:53.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41638,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41638,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2151, RA-DEC 05:29:39.1-71:40:40.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41639,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41639,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2690, RA-DEC 05:37:57.5-70:11:17.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41640,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41640,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3140, RA-DEC 05:46:14.2-69:04:23.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41641,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41641,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4606, RA-DEC 06:14:19.3-71:22:22.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41642,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41642,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0647, RA-DEC 05:00:46.1-69:04:54.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41643,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41643,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1239, RA-DEC 05:12:33.8-71:07:47.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41644,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41644,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1480, RA-DEC 05:17:09.9-70:23:49.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41645,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41645,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4117, RA-DEC 05:32:45.2-66:17:51.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41646,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41646,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2236, RA-DEC 05:31:04.2-71:19:04.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41647,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41647,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2258, RA-DEC 05:31:24.7-69:17:17.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41648,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41648,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2722, RA-DEC 05:38:25.3-68:39:26.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41649,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41649,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4244, RA-DEC 05:39:32.0-63:38:52.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41650,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41650,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0355, RA-DEC 04:54:55.0-69:14:13.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41651,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41651,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1207, RA-DEC 05:11:41.5-70:33:22.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41652,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41652,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1720, RA-DEC 05:21:55.9-70:15:41.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41653,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41653,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2169, RA-DEC 05:30:04.0-69:59:39.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41654,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41654,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2269, RA-DEC 05:31:42.8-70:28:07.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41655,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41655,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3116, RA-DEC 05:45:40.7-70:31:50.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41656,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41656,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4096, RA-DEC 05:31:27.0-64:34:47.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41657,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41657,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4426, RA-DEC 05:48:36.5-67:42:37.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41658,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41658,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1038, RA-DEC 05:07:59.4-71:17:09.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41659,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41659,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1991, RA-DEC 05:26:19.6-69:53:18.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41660,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41660,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3068, RA-DEC 05:44:23.7-71:37:18.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41661,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41661,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3428, RA-DEC 04:52:13.4-66:21:30.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41662,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41662,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3510, RA-DEC 05:01:00.5-66:10:15.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41663,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41663,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3725, RA-DEC 05:13:26.6-66:10:01.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41664,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41664,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3746, RA-DEC 05:13:42.3-65:27:30.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41665,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41665,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3879, RA-DEC 05:20:20.3-66:47:25.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41666,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41666,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4389, RA-DEC 05:46:57.8-68:12:11.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41667,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41667,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0181, RA-DEC 04:51:04.9-67:21:51.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41668,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41668,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0262, RA-DEC 04:52:57.5-67:25:02.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41669,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41669,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0454, RA-DEC 04:56:51.5-68:41:42.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41670,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41670,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0929, RA-DEC 05:05:54.3-70:52:39.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41671,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41671,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1996, RA-DEC 05:26:23.5-69:27:01.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41672,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41672,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2019, RA-DEC 05:26:55.9-69:58:48.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41673,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41673,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2100, RA-DEC 05:28:37.2-69:41:01.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41674,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41674,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3021, RA-DEC 05:43:00.9-68:00:42.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41675,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41675,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3121, RA-DEC 05:45:45.1-70:24:29.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41676,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41676,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3333, RA-DEC 05:59:21.1-69:55:20.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41677,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41677,18.53,0.2,0.0509,10597,NULL,NULL,'HV 914, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41678,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41678,18.53,0.05,0.0509,10597,NULL,NULL,'HV 02277, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41679,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41679,18.53,0.05,0.0509,10597,NULL,NULL,'HV 02352, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41680,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41680,18.53,0.05,0.0509,10597,NULL,NULL,'HV 12505, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41681,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41681,18.53,0.05,0.0509,10597,NULL,NULL,'HV 00887, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41682,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41682,18.54,0.05,0.0509,10597,NULL,NULL,'HV 00902, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41683,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41683,18.53,0.05,0.0509,10597,NULL,NULL,'HV 00909, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41684,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41684,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0542, RA-DEC 04:58:43.0-70:53:27.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41685,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41685,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0568, RA-DEC 04:59:14.0-70:15:53.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41686,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41686,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1311, RA-DEC 05:14:16.8-68:54:13.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41687,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41687,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1498, RA-DEC 05:17:35.7-69:16:01.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41688,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41688,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2124, RA-DEC 05:29:12.5-69:53:26.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41689,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41689,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2388, RA-DEC 05:33:43.0-69:51:13.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41690,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41690,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2952, RA-DEC 05:41:51.4-69:24:12.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41691,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41691,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3195, RA-DEC 05:47:36.4-70:33:10.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41692,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41692,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4463, RA-DEC 05:50:13.4-66:12:18.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41693,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41693,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0361, RA-DEC 04:55:01.3-70:10:48.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41694,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41694,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1151, RA-DEC 05:10:15.4-68:20:27.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41695,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41695,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1653, RA-DEC 05:20:42.4-70:15:25.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41696,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41696,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2127, RA-DEC 05:29:14.6-69:31:05.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41697,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41697,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2685, RA-DEC 05:37:51.3-70:17:56.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41698,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41698,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2970, RA-DEC 05:42:09.2-71:22:12.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41699,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41699,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3448, RA-DEC 04:53:33.7-70:59:05.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41700,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41700,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0084, RA-DEC 04:47:20.0-69:29:12.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41701,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41701,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0106, RA-DEC 04:48:50.6-70:14:53.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41702,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41702,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0437, RA-DEC 04:56:32.1-66:54:18.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41703,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41703,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1697, RA-DEC 05:21:37.2-69:52:51.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41704,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41704,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1856, RA-DEC 05:24:04.2-69:58:20.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41705,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41705,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2679, RA-DEC 05:37:47.3-70:23:13.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41706,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41706,18.53,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2762, RA-DEC 05:38:54.6-70:18:42.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41707,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41707,18.54,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0611, RA-DEC 05:00:04.1-67:58:06.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41708,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41708,18.54,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1053, RA-DEC 05:08:09.9-68:10:37.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41709,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41709,18.54,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1286, RA-DEC 05:13:50.4-70:26:04.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41710,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41710,18.54,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1321, RA-DEC 05:14:37.5-70:46:09.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41711,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41711,18.54,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1384, RA-DEC 05:15:35.5-68:57:07.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41712,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41712,18.54,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1502, RA-DEC 05:17:41.2-69:41:25.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41713,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41713,18.54,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1576, RA-DEC 05:19:12.4-70:10:41.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41714,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41714,18.54,0.06,0.0509,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2791, RA-DEC 05:39:21.0-70:28:54.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41715,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41715,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0026, RA-DEC 04:41:12.2-68:47:59.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41716,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41716,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0749, RA-DEC 05:02:26.7-67:25:15.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41717,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41717,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0830, RA-DEC 05:03:56.2-67:13:16.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41718,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41718,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0909, RA-DEC 05:05:34.7-70:26:52.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41719,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41719,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1447, RA-DEC 05:16:28.4-69:25:35.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41720,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41720,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1625, RA-DEC 05:20:09.1-68:36:44.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41721,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41721,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1744, RA-DEC 05:22:15.5-70:01:15.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41722,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41722,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2962, RA-DEC 05:42:03.0-70:21:18.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41723,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41723,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2972, RA-DEC 05:42:11.9-68:50:19.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41724,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41724,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0520, RA-DEC 04:58:22.9-71:02:32.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41725,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41725,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0808, RA-DEC 05:03:32.4-68:25:20.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41726,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41726,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1127, RA-DEC 05:09:33.8-70:42:39.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41727,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41727,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2008, RA-DEC 05:26:44.7-69:48:09.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41728,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41728,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0038, RA-DEC 04:42:15.9-69:13:01.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41729,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41729,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1051, RA-DEC 05:08:09.6-69:15:47.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41730,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41730,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1740, RA-DEC 05:22:13.0-69:26:25.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41731,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41731,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1885, RA-DEC 05:24:33.7-69:56:21.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41732,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41732,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3211, RA-DEC 05:48:18.9-69:10:07.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41733,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41733,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4603, RA-DEC 06:12:54.6-67:58:24.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41734,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41734,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0429, RA-DEC 04:56:22.1-70:22:53.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41735,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41735,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0644, RA-DEC 05:00:42.1-68:41:49.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41736,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41736,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0677, RA-DEC 05:01:11.3-68:41:43.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41737,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41737,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1075, RA-DEC 05:08:36.8-70:18:59.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41738,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41738,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1157, RA-DEC 05:10:23.2-67:58:22.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41739,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41739,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1183, RA-DEC 05:11:05.1-70:35:49.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41740,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41740,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2411, RA-DEC 05:34:00.9-68:40:52.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41741,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41741,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3035, RA-DEC 05:43:27.3-69:36:19.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41742,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41742,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0121, RA-DEC 04:49:20.2-69:56:58.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41743,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41743,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1044, RA-DEC 05:08:05.7-68:34:53.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41744,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41744,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1281, RA-DEC 05:13:43.7-70:33:44.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41745,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41745,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1320, RA-DEC 05:14:36.5-69:07:29.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41746,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41746,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2142, RA-DEC 05:29:31.2-71:08:36.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41747,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41747,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2395, RA-DEC 05:33:48.6-69:45:12.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41748,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41748,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3550, RA-DEC 05:04:07.8-65:47:22.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41749,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41749,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4077, RA-DEC 05:30:22.2-66:06:00.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41750,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41750,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0296, RA-DEC 04:53:38.2-68:40:02.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41751,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41751,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0662, RA-DEC 05:00:59.5-69:25:19.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41752,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41752,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1333, RA-DEC 05:14:49.5-69:12:41.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41753,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41753,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1649, RA-DEC 05:20:40.8-71:51:09.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41754,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41754,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1650, RA-DEC 05:20:41.6-69:07:34.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41755,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41755,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1735, RA-DEC 05:22:10.5-70:33:15.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41756,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41756,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3024, RA-DEC 05:43:06.0-69:29:26.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41757,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41757,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4088, RA-DEC 05:30:51.0-66:39:26.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41758,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41758,18.54,0.05,0.051,10597,NULL,NULL,'HV 02270, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41759,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41759,18.54,0.05,0.051,10597,NULL,NULL,'HV 00882, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41760,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41760,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0165, RA-DEC 04:50:37.8-69:10:26.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41761,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41761,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0399, RA-DEC 04:55:45.5-69:11:59.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41762,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41762,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1021, RA-DEC 05:07:30.4-67:28:47.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41763,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41763,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1686, RA-DEC 05:21:22.5-69:56:28.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41764,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41764,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2199, RA-DEC 05:30:38.0-70:31:42.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41765,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41765,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3107, RA-DEC 05:45:27.5-70:25:24.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41766,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41766,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0617, RA-DEC 05:00:07.1-67:11:48.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41767,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41767,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1116, RA-DEC 05:09:21.2-70:49:22.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41768,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41768,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1245, RA-DEC 05:12:44.7-70:34:35.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41769,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41769,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1327, RA-DEC 05:14:41.6-70:42:32.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41770,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41770,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2402, RA-DEC 05:33:55.2-69:54:44.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41771,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41771,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3281, RA-DEC 05:52:57.3-69:29:14.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41772,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41772,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3727, RA-DEC 05:13:29.0-72:01:15.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41773,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41773,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3849, RA-DEC 05:18:22.0-65:13:01.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41774,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41774,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0004, RA-DEC 04:35:20.2-69:48:07.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41775,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41775,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0018, RA-DEC 04:38:59.0-68:57:24.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41776,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41776,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0280, RA-DEC 04:53:19.2-66:56:00.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41777,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41777,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0781, RA-DEC 05:03:03.6-68:28:51.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41778,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41778,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1124, RA-DEC 05:09:29.8-68:58:15.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41779,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41779,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1407, RA-DEC 05:15:57.0-69:21:46.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41780,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41780,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1636, RA-DEC 05:20:23.0-70:02:33.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41781,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41781,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2822, RA-DEC 05:39:45.9-69:54:05.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41782,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41782,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3111, RA-DEC 05:45:32.7-72:22:09.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41783,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41783,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3197, RA-DEC 05:47:45.7-70:41:21.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41784,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41784,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0289, RA-DEC 04:53:31.8-69:16:53.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41785,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41785,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0614, RA-DEC 05:00:05.4-69:06:52.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41786,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41786,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0630, RA-DEC 05:00:24.1-69:14:56.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41787,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41787,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0653, RA-DEC 05:00:55.0-69:16:31.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41788,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41788,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0663, RA-DEC 05:01:00.0-70:39:51.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41789,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41789,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1456, RA-DEC 05:16:41.2-69:42:41.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41790,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41790,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1682, RA-DEC 05:21:17.4-69:55:04.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41791,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41791,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1978, RA-DEC 05:26:00.5-69:53:33.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41792,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41792,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2102, RA-DEC 05:28:38.1-69:58:01.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41793,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41793,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2300, RA-DEC 05:32:12.4-69:58:36.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41794,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41794,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2311, RA-DEC 05:32:28.8-71:01:01.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41795,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41795,18.54,0.06,0.051,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4599, RA-DEC 06:11:31.9-65:20:49.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41796,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41796,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0005, RA-DEC 04:35:31.5-69:44:05.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41797,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41797,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0244, RA-DEC 04:52:43.2-68:46:58.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41798,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41798,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0789, RA-DEC 05:03:11.2-68:51:38.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41799,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41799,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0826, RA-DEC 05:03:51.4-68:11:14.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41800,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41800,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0932, RA-DEC 05:05:59.1-67:20:42.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41801,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41801,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1097, RA-DEC 05:08:57.7-70:41:02.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41802,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41802,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1496, RA-DEC 05:17:35.3-69:09:17.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41803,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41803,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1730, RA-DEC 05:22:03.5-68:07:11.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41804,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41804,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2369, RA-DEC 05:33:36.6-69:45:17.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41805,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41805,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2600, RA-DEC 05:36:54.5-70:09:29.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41806,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41806,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2843, RA-DEC 05:40:04.6-68:51:07.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41807,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41807,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3497, RA-DEC 04:59:32.3-74:47:09.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41808,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41808,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3661, RA-DEC 05:10:50.4-65:47:21.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41809,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41809,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4448, RA-DEC 05:49:32.4-66:38:02.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41810,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41810,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0711, RA-DEC 05:01:54.4-68:01:57.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41811,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41811,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1059, RA-DEC 05:08:18.5-70:29:52.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41812,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41812,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1332, RA-DEC 05:14:48.9-68:56:01.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41813,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41813,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1865, RA-DEC 05:24:17.1-70:12:07.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41814,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41814,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3278, RA-DEC 05:52:46.1-68:47:05.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41815,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41815,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0021, RA-DEC 04:39:31.0-69:15:42.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41816,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41816,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0237, RA-DEC 04:52:27.8-66:46:09.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41817,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41817,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0405, RA-DEC 04:55:49.6-66:46:03.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41818,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41818,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1176, RA-DEC 05:10:50.5-70:12:17.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41819,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41819,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1397, RA-DEC 05:15:46.0-69:14:30.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41820,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41820,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1644, RA-DEC 05:20:31.2-69:32:13.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41821,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41821,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1745, RA-DEC 05:22:16.4-68:52:25.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41822,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41822,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1810, RA-DEC 05:23:06.7-69:59:18.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41823,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41823,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1825, RA-DEC 05:23:14.2-70:13:47.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41824,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41824,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2599, RA-DEC 05:36:54.3-69:59:08.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41825,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41825,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3153, RA-DEC 05:46:30.8-70:55:24.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41826,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41826,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3741, RA-DEC 05:13:40.0-65:28:03.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41827,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41827,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0132, RA-DEC 04:49:45.6-69:04:22.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41828,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41828,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0477, RA-DEC 04:57:23.3-69:09:20.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41829,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41829,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0863, RA-DEC 05:04:35.0-68:52:36.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41830,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41830,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1045, RA-DEC 05:08:05.7-70:22:52.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41831,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41831,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2110, RA-DEC 05:28:45.5-71:00:17.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41832,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41832,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2278, RA-DEC 05:31:47.8-71:30:28.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41833,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41833,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2581, RA-DEC 05:36:46.7-69:22:12.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41834,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41834,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2846, RA-DEC 05:40:06.3-70:23:31.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41835,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41835,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3102, RA-DEC 05:45:18.3-70:11:29.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41836,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41836,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3554, RA-DEC 05:04:23.2-66:31:30.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41837,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41837,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4615, RA-DEC 06:18:40.6-69:23:51.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41838,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41838,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0312, RA-DEC 04:54:03.5-70:30:12.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41839,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41839,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0487, RA-DEC 04:57:41.2-69:24:19.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41840,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41840,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0977, RA-DEC 05:06:59.6-69:18:20.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41841,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41841,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1131, RA-DEC 05:09:43.1-68:36:59.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41842,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41842,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1229, RA-DEC 05:12:11.3-67:45:04.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41843,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41843,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1755, RA-DEC 05:22:26.9-70:05:14.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41844,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41844,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1769, RA-DEC 05:22:31.8-69:39:55.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41845,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41845,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2795, RA-DEC 05:39:25.6-70:20:58.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41846,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41846,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3917, RA-DEC 05:22:08.2-64:31:36.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41847,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41847,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0240, RA-DEC 04:52:32.5-68:55:13.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41848,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41848,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0606, RA-DEC 04:59:57.1-70:55:18.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41849,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41849,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0834, RA-DEC 05:04:01.9-70:27:37.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41850,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41850,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1027, RA-DEC 05:07:36.7-69:12:45.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41851,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41851,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2314, RA-DEC 05:32:32.9-69:59:49.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41852,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41852,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2327, RA-DEC 05:32:48.8-70:13:58.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41853,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41853,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2426, RA-DEC 05:34:19.6-70:00:00.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41854,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41854,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2720, RA-DEC 05:38:23.2-69:53:36.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41855,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41855,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3188, RA-DEC 05:47:31.4-68:47:26.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41856,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41856,18.54,0.1,0.0511,10597,NULL,NULL,'V','LMC',NULL,'2003MNRAS.345..269H',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41857,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41857,18.54,0.02,0.0511,10597,NULL,NULL,'19, VT','LMC',NULL,'2006ApJ...642..834K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41858,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41858,18.54,0.19,0.0511,10597,NULL,NULL,'K','LMC',NULL,'2000A&A...356..849G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41859,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41859,18.54,NULL,0.0511,10597,NULL,NULL,'685, BVI','LMC',NULL,'2004A&A...424...43S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41860,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41860,18.54,0.05,0.0511,10597,NULL,NULL,'HV 05551, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41861,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41861,18.54,0.05,0.0511,10597,NULL,NULL,'HV 12475, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41862,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41862,18.54,0.05,0.0511,10597,NULL,NULL,'HV 02282, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41863,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41863,18.54,0.05,0.0511,10597,NULL,NULL,'HV 00875, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41864,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,NULL,41864,18.54,0.05,0.0511,10597,NULL,NULL,'HV 00879, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41865,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41865,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2072, RA-DEC 05:28:01.1-71:38:30.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41866,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41866,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2337, RA-DEC 05:33:01.0-68:11:27.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41867,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41867,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2522, RA-DEC 05:35:53.4-70:02:03.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41868,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41868,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3649, RA-DEC 05:10:19.4-71:37:14.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41869,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41869,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2391, RA-DEC 05:33:45.1-70:59:35.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41870,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41870,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3115, RA-DEC 05:45:39.6-71:23:15.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41871,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41871,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3535, RA-DEC 05:02:56.1-66:20:11.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41872,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41872,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3665, RA-DEC 05:10:54.9-71:33:45.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41873,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41873,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0033, RA-DEC 04:41:57.9-69:26:00.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41874,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41874,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0124, RA-DEC 04:49:25.3-69:07:50.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41875,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41875,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0580, RA-DEC 04:59:28.8-68:51:48.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41876,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41876,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1013, RA-DEC 05:07:26.7-66:36:58.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41877,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41877,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1520, RA-DEC 05:17:59.7-69:16:02.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41878,'Cepheids','2016-12-15 15:14:09','2016-12-16 11:19:14','1',NULL,'R',41878,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1738, RA-DEC 05:22:12.3-70:40:09.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41879,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41879,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1873, RA-DEC 05:24:25.1-70:10:23.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41880,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41880,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3422, RA-DEC 04:50:56.0-73:39:41.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41881,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41881,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4301, RA-DEC 05:42:17.1-67:13:16.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41882,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41882,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0116, RA-DEC 04:49:13.4-70:08:59.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41883,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41883,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0383, RA-DEC 04:55:23.1-69:35:49.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41884,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41884,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0524, RA-DEC 04:58:27.2-70:34:52.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41885,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41885,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0525, RA-DEC 04:58:28.3-68:57:58.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41886,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41886,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0674, RA-DEC 05:01:07.2-70:21:56.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41887,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41887,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1514, RA-DEC 05:17:56.3-69:47:21.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41888,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41888,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1795, RA-DEC 05:22:52.0-70:07:47.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41889,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41889,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2670, RA-DEC 05:37:40.4-68:50:42.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41890,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41890,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3701, RA-DEC 05:12:28.8-65:51:00.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41891,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41891,18.54,0.06,0.0511,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3837, RA-DEC 05:17:49.5-70:30:55.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41892,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41892,18.54,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0175, RA-DEC 04:50:54.1-69:31:41.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41893,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41893,18.54,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0996, RA-DEC 05:07:18.5-70:46:10.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41894,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41894,18.54,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1063, RA-DEC 05:08:21.2-69:07:17.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41895,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41895,18.54,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1945, RA-DEC 05:25:31.4-69:50:03.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41896,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41896,18.54,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2377, RA-DEC 05:33:40.5-70:58:56.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41897,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41897,18.54,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2434, RA-DEC 05:34:28.1-69:54:11.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41898,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41898,18.54,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3361, RA-DEC 06:15:26.1-71:06:56.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41899,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41899,18.54,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3910, RA-DEC 05:21:58.1-64:01:23.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41900,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41900,18.54,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0263, RA-DEC 04:53:00.2-68:59:58.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41901,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41901,18.54,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1109, RA-DEC 05:09:15.9-68:44:29.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41902,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41902,18.54,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1232, RA-DEC 05:12:16.1-69:20:07.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41903,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41903,18.54,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2098, RA-DEC 05:28:33.6-68:12:10.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41904,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41904,18.54,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2356, RA-DEC 05:33:23.4-71:37:46.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41905,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41905,18.54,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2949, RA-DEC 05:41:48.5-68:41:16.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41906,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41906,18.54,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3088, RA-DEC 05:44:47.6-68:53:22.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41907,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41907,18.54,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4147, RA-DEC 05:33:59.2-67:35:29.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41908,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41908,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0088, RA-DEC 04:47:31.0-69:30:47.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41909,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41909,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0209, RA-DEC 04:51:52.7-69:05:48.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41910,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41910,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0273, RA-DEC 04:53:10.9-67:36:21.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41911,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41911,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0681, RA-DEC 05:01:20.0-69:17:22.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41912,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41912,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1174, RA-DEC 05:10:45.9-70:07:03.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41913,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41913,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1201, RA-DEC 05:11:33.9-66:39:30.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41914,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41914,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2069, RA-DEC 05:27:57.7-69:53:48.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41915,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41915,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2121, RA-DEC 05:29:08.3-67:49:48.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41916,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41916,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0809, RA-DEC 05:03:32.9-70:07:01.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41917,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41917,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1101, RA-DEC 05:09:06.9-70:21:03.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41918,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41918,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1673, RA-DEC 05:21:05.3-68:23:34.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41919,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41919,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2275, RA-DEC 05:31:47.6-69:57:42.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41920,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41920,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2721, RA-DEC 05:38:24.5-70:14:04.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41921,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41921,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3528, RA-DEC 05:02:35.6-66:21:03.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41922,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41922,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1599, RA-DEC 05:19:38.0-69:37:44.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41923,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41923,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2181, RA-DEC 05:30:15.1-71:16:58.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41924,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41924,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2487, RA-DEC 05:35:27.9-71:02:42.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41925,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41925,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3527, RA-DEC 05:02:30.0-71:33:59.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41926,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41926,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3628, RA-DEC 05:09:03.7-65:46:41.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41927,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41927,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0570, RA-DEC 04:59:16.1-69:08:12.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41928,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41928,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0736, RA-DEC 05:02:18.6-67:31:16.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41929,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41929,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2380, RA-DEC 05:33:41.4-70:59:12.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41930,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41930,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2400, RA-DEC 05:33:52.6-71:07:39.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41931,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41931,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3850, RA-DEC 05:18:26.3-74:26:48.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41932,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41932,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4074, RA-DEC 05:30:16.6-67:24:03.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41933,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,NULL,41933,18.55,0.05,0.0512,10597,NULL,NULL,'OIII 0167, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41934,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,NULL,41934,18.55,0.05,0.0512,10597,NULL,NULL,'HV 02262, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41935,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,NULL,41935,18.55,0.05,0.0512,10597,NULL,NULL,'HV 02261, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41936,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,NULL,41936,18.55,0.05,0.0512,10597,NULL,NULL,'HV 02245, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41937,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,NULL,41937,18.55,0.05,0.0512,10597,NULL,NULL,'HV 00878, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41938,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,NULL,41938,18.55,0.05,0.0512,10597,NULL,NULL,'HV 02338, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41939,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41939,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0738, RA-DEC 05:02:19.3-68:06:48.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41940,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41940,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0798, RA-DEC 05:03:23.6-69:00:03.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41941,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41941,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0947, RA-DEC 05:06:14.9-68:19:03.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41942,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41942,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1071, RA-DEC 05:08:30.6-69:08:46.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41943,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41943,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1796, RA-DEC 05:22:52.8-70:07:45.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41944,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41944,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2062, RA-DEC 05:27:49.6-69:46:17.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41945,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41945,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3437, RA-DEC 04:52:56.0-71:21:07.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41946,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:14','1',NULL,'R',41946,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3861, RA-DEC 05:19:02.1-67:27:17.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41947,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41947,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0173, RA-DEC 04:50:51.4-66:59:56.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41948,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41948,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1512, RA-DEC 05:17:55.0-69:34:55.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41949,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41949,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1565, RA-DEC 05:18:56.4-69:34:02.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41950,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41950,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1739, RA-DEC 05:22:12.5-69:31:06.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41951,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41951,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4146, RA-DEC 05:33:55.5-66:05:17.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41952,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41952,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0756, RA-DEC 05:02:29.9-71:03:30.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41953,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41953,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1767, RA-DEC 05:22:30.2-70:09:21.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41954,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41954,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2292, RA-DEC 05:32:03.8-71:25:22.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41955,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41955,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2806, RA-DEC 05:39:32.4-70:21:48.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41956,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41956,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4165, RA-DEC 05:34:58.4-65:36:16.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41957,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41957,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0511, RA-DEC 04:58:07.0-67:16:27.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41958,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41958,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1709, RA-DEC 05:21:49.6-70:05:45.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41959,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41959,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2122, RA-DEC 05:29:09.0-69:24:13.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41960,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41960,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2482, RA-DEC 05:35:24.9-68:41:01.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41961,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41961,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4059, RA-DEC 05:29:19.9-67:22:39.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41962,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41962,18.55,0.06,0.0512,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4217, RA-DEC 05:37:44.4-67:18:47.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41963,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41963,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0447, RA-DEC 04:56:41.6-68:48:39.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41964,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41964,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0610, RA-DEC 05:00:03.5-69:00:44.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41965,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41965,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0667, RA-DEC 05:01:02.1-69:05:37.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41966,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41966,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1194, RA-DEC 05:11:23.6-70:56:06.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41967,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41967,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1465, RA-DEC 05:16:56.4-69:39:19.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41968,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41968,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3146, RA-DEC 05:46:22.3-69:55:20.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41969,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41969,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4069, RA-DEC 05:30:04.5-71:55:21.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41970,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41970,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4079, RA-DEC 05:30:22.4-62:08:00.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41971,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41971,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4384, RA-DEC 05:46:46.3-73:22:53.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41972,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41972,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0142, RA-DEC 04:49:59.7-69:47:06.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41973,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41973,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0164, RA-DEC 04:50:36.0-68:44:31.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41974,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41974,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1208, RA-DEC 05:11:41.8-70:44:14.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41975,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41975,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1460, RA-DEC 05:16:50.5-69:19:29.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41976,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41976,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1485, RA-DEC 05:17:18.1-69:16:38.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41977,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41977,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1589, RA-DEC 05:19:28.4-70:57:50.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41978,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41978,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2099, RA-DEC 05:28:35.1-69:51:23.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41979,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41979,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2351, RA-DEC 05:33:20.9-68:33:28.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41980,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41980,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2592, RA-DEC 05:36:52.8-70:12:07.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41981,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41981,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3344, RA-DEC 06:05:12.5-70:42:26.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41982,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41982,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4215, RA-DEC 05:37:34.6-66:17:01.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41983,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41983,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0869, RA-DEC 05:04:45.5-67:23:13.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41984,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41984,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0969, RA-DEC 05:06:52.9-68:43:25.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41985,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41985,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1479, RA-DEC 05:17:09.8-69:20:53.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41986,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41986,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1925, RA-DEC 05:25:20.2-70:15:09.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41987,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41987,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2159, RA-DEC 05:29:52.2-69:37:21.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41988,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41988,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2885, RA-DEC 05:40:39.7-70:38:28.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41989,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41989,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0701, RA-DEC 05:01:44.5-68:05:52.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41990,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41990,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1032, RA-DEC 05:07:44.4-68:35:20.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41991,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41991,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1563, RA-DEC 05:18:56.0-69:26:27.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41992,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41992,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1995, RA-DEC 05:26:23.4-71:02:18.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41993,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41993,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2757, RA-DEC 05:38:51.3-70:20:12.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41994,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41994,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3386, RA-DEC 04:42:23.3-71:12:29.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41995,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41995,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3899, RA-DEC 05:21:32.4-66:04:49.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41996,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41996,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0642, RA-DEC 05:00:38.7-68:53:55.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41997,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41997,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1319, RA-DEC 05:14:32.3-68:39:25.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41998,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41998,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2310, RA-DEC 05:32:27.8-69:34:17.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41999,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',41999,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3178, RA-DEC 05:47:21.0-69:04:01.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42000,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42000,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3717, RA-DEC 05:13:13.5-72:09:38.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42001,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42001,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3998, RA-DEC 05:26:25.5-65:47:29.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42002,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42002,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4197, RA-DEC 05:36:40.8-65:14:36.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42003,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42003,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4208, RA-DEC 05:37:17.4-66:45:11.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42004,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42004,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0442, RA-DEC 04:56:37.0-69:27:08.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42005,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42005,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1180, RA-DEC 05:10:56.3-69:01:55.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42006,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42006,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1601, RA-DEC 05:19:38.5-68:30:56.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42007,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42007,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3549, RA-DEC 05:04:05.2-66:17:49.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42008,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42008,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4481, RA-DEC 05:51:24.2-67:00:16.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42009,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42009,18.55,0.17,0.0513,10597,NULL,NULL,'K','LMC',NULL,'2000A&A...363..901G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42010,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42010,18.55,NULL,0.0513,10597,NULL,NULL,'JHKV','LMC',NULL,'1999ASSL..237..125W',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42011,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42011,18.55,0.09,0.0513,10597,NULL,NULL,'NGC 1866, HV 12199, New PL','LMC',NULL,'2006MmSAI..77..261S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42012,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42012,18.55,0.08,0.0513,10597,NULL,NULL,NULL,'LMC',NULL,'2000ApJ...533..215C',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42013,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42013,18.55,0.08,0.0513,10597,NULL,NULL,NULL,'LMC',NULL,'2000ApJ...533..215C',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42014,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42014,18.55,0.1,0.0513,10597,NULL,NULL,'BW','LMC',NULL,'2000ApJ...533..215C',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42015,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42015,18.55,0.1,0.0513,10597,NULL,NULL,'BW','LMC',NULL,'2000ApJ...533..215C',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42016,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42016,18.55,0.02,0.0513,10597,NULL,NULL,NULL,'LMC',NULL,'2002ApJ...578..144K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42017,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42017,18.55,0.06,0.0513,10597,NULL,NULL,'VIWJHK','LMC',NULL,'2003LNP...635...21F',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42018,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42018,18.55,NULL,0.0513,10597,NULL,NULL,'10, BVIK','LMC',NULL,'2004A&A...420..655G',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42019,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42019,18.55,0.05,0.0513,10597,NULL,NULL,'OIII 0114, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42020,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42020,18.55,0.05,0.0513,10597,NULL,NULL,'HV 12471, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42021,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42021,18.55,0.05,0.0513,10597,NULL,NULL,'HV 00881, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42022,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42022,18.55,0.14,0.0513,10597,NULL,NULL,'HV 12199, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42023,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42023,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0188, RA-DEC 04:51:12.7-68:44:16.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42024,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42024,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0441, RA-DEC 04:56:34.8-69:57:55.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42025,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42025,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0623, RA-DEC 05:00:11.8-67:08:49.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42026,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42026,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1070, RA-DEC 05:08:30.4-69:07:42.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42027,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42027,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1203, RA-DEC 05:11:37.6-69:45:18.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42028,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42028,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1357, RA-DEC 05:15:13.6-68:52:50.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42029,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42029,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2287, RA-DEC 05:31:58.0-71:20:48.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42030,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42030,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2947, RA-DEC 05:41:46.4-71:19:00.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42031,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42031,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3091, RA-DEC 05:44:51.8-68:28:33.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42032,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42032,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0604, RA-DEC 04:59:56.3-70:25:49.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42033,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42033,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0755, RA-DEC 05:02:29.8-68:19:31.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42034,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42034,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0920, RA-DEC 05:05:46.8-67:07:00.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42035,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42035,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0968, RA-DEC 05:06:51.4-69:36:31.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (42036,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42036,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1585, RA-DEC 05:19:25.4-69:18:26.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42037,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42037,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2043, RA-DEC 05:27:23.0-69:50:58.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42038,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42038,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3286, RA-DEC 05:53:08.8-69:30:08.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42039,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42039,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4162, RA-DEC 05:34:43.8-74:00:40.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42040,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42040,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0197, RA-DEC 04:51:24.4-68:36:46.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42041,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42041,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1797, RA-DEC 05:22:53.9-69:18:58.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42042,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42042,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1955, RA-DEC 05:25:39.8-70:01:32.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42043,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42043,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2773, RA-DEC 05:39:05.9-69:07:34.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42044,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42044,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3099, RA-DEC 05:45:07.9-71:58:49.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42045,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42045,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3442, RA-DEC 04:53:08.5-65:29:39.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42046,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42046,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0041, RA-DEC 04:42:53.7-67:25:59.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42047,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42047,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0384, RA-DEC 04:55:24.0-68:32:37.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42048,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42048,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1228, RA-DEC 05:12:08.3-68:32:10.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42049,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42049,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1905, RA-DEC 05:24:46.9-70:17:45.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42050,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42050,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2134, RA-DEC 05:29:22.4-68:50:38.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42051,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42051,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3242, RA-DEC 05:49:49.6-70:25:43.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42052,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42052,18.55,0.06,0.0513,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4065, RA-DEC 05:29:59.4-72:46:13.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42053,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42053,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0069, RA-DEC 04:45:38.7-68:39:06.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42054,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42054,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0222, RA-DEC 04:52:13.3-68:51:23.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42055,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42055,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0536, RA-DEC 04:58:36.7-70:55:52.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42056,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42056,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0852, RA-DEC 05:04:24.8-70:10:52.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42057,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42057,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1645, RA-DEC 05:20:35.8-68:39:12.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42058,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42058,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1762, RA-DEC 05:22:29.4-70:10:22.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42059,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42059,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1771, RA-DEC 05:22:32.7-71:40:46.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42060,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42060,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2537, RA-DEC 05:36:08.9-69:50:05.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42061,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42061,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0795, RA-DEC 05:03:19.2-68:45:01.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42062,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42062,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1312, RA-DEC 05:14:18.8-69:20:45.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42063,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42063,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1420, RA-DEC 05:16:00.8-71:31:08.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42064,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42064,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1772, RA-DEC 05:22:33.9-69:37:13.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42065,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42065,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1954, RA-DEC 05:25:39.1-71:06:39.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42066,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42066,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2170, RA-DEC 05:30:04.2-69:56:46.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42067,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42067,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2626, RA-DEC 05:37:10.7-69:56:54.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42068,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42068,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3336, RA-DEC 06:01:34.3-69:46:50.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42069,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42069,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4624, RA-DEC 06:29:42.0-70:35:24.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42070,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42070,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1200, RA-DEC 05:11:31.4-68:35:29.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42071,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42071,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2172, RA-DEC 05:30:06.2-71:02:18.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42072,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42072,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2263, RA-DEC 05:31:36.6-69:56:43.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42073,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42073,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3414, RA-DEC 04:49:47.3-65:56:37.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42074,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42074,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0998, RA-DEC 05:07:19.4-70:45:43.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42075,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42075,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1019, RA-DEC 05:07:29.6-68:31:14.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42076,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42076,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1688, RA-DEC 05:21:24.4-69:56:34.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42077,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42077,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2143, RA-DEC 05:29:32.1-69:13:01.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42078,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42078,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0194, RA-DEC 04:51:22.2-70:35:31.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42079,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42079,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0859, RA-DEC 05:04:31.5-69:12:49.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42080,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42080,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1725, RA-DEC 05:22:00.3-70:26:12.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42081,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42081,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2450, RA-DEC 05:34:42.1-70:33:42.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42082,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42082,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3455, RA-DEC 04:54:19.3-65:10:43.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42083,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42083,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3902, RA-DEC 05:21:38.8-66:56:51.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42084,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42084,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0489, RA-DEC 04:57:43.1-68:28:01.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42085,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42085,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1373, RA-DEC 05:15:24.7-69:06:20.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42086,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42086,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1455, RA-DEC 05:16:39.6-69:14:35.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42087,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42087,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2218, RA-DEC 05:30:52.8-68:50:24.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42088,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42088,18.55,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4145, RA-DEC 05:33:47.1-66:56:52.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42089,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42089,18.55,0.05,0.0514,10597,NULL,NULL,'OIII 0016, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42090,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42090,18.55,0.05,0.0514,10597,NULL,NULL,'HV 00874, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42091,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42091,18.56,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0261, RA-DEC 04:52:57.5-69:33:15.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42092,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42092,18.56,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1355, RA-DEC 05:15:11.2-68:11:05.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42093,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42093,18.56,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1374, RA-DEC 05:15:25.7-69:20:27.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42094,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42094,18.56,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1388, RA-DEC 05:15:37.4-69:30:29.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42095,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42095,18.56,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1441, RA-DEC 05:16:17.5-69:09:19.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42096,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42096,18.56,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1580, RA-DEC 05:19:15.8-69:14:45.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42097,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42097,18.56,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4227, RA-DEC 05:38:19.9-67:17:02.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42098,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42098,18.56,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0012, RA-DEC 04:37:48.7-67:12:51.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42099,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42099,18.56,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0774, RA-DEC 05:02:54.1-70:37:35.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42100,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42100,18.56,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2467, RA-DEC 05:35:09.8-70:14:45.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42101,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42101,18.56,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0138, RA-DEC 04:49:55.6-68:54:54.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42102,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42102,18.56,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0356, RA-DEC 04:54:55.4-70:15:22.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42103,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42103,18.56,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0627, RA-DEC 05:00:16.1-67:49:14.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42104,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42104,18.56,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0908, RA-DEC 05:05:34.7-69:20:29.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42105,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42105,18.56,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0919, RA-DEC 05:05:45.9-68:15:20.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42106,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42106,18.56,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1385, RA-DEC 05:15:35.8-69:45:48.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42107,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42107,18.56,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2364, RA-DEC 05:33:30.4-68:47:20.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42108,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42108,18.56,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0400, RA-DEC 04:55:45.7-68:55:22.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42109,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42109,18.56,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1074, RA-DEC 05:08:35.3-68:48:59.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42110,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42110,18.56,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1240, RA-DEC 05:12:34.7-69:12:34.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42111,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42111,18.56,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2196, RA-DEC 05:30:35.1-70:48:43.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42112,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42112,18.56,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2525, RA-DEC 05:35:55.6-68:59:36.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42113,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42113,18.56,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2671, RA-DEC 05:37:41.5-70:15:36.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42114,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42114,18.56,0.06,0.0514,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4166, RA-DEC 05:34:59.9-66:40:52.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42115,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42115,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0196, RA-DEC 04:51:24.1-66:57:33.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42116,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42116,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0348, RA-DEC 04:54:52.0-68:25:13.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42117,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42117,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0539, RA-DEC 04:58:41.3-68:51:54.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42118,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42118,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0626, RA-DEC 05:00:16.1-70:27:33.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42119,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42119,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0675, RA-DEC 05:01:09.0-67:28:46.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42120,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42120,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0684, RA-DEC 05:01:25.2-68:21:20.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42121,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42121,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0703, RA-DEC 05:01:48.1-67:31:22.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42122,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42122,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1280, RA-DEC 05:13:38.4-70:20:30.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42123,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42123,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3323, RA-DEC 05:58:00.0-68:26:59.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42124,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42124,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4107, RA-DEC 05:31:56.0-66:42:22.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42125,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42125,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0053, RA-DEC 04:44:04.8-69:50:29.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42126,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42126,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0387, RA-DEC 04:55:31.3-68:53:00.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42127,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42127,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0785, RA-DEC 05:03:06.8-69:59:33.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42128,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42128,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0903, RA-DEC 05:05:29.5-67:58:20.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42129,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42129,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0936, RA-DEC 05:06:01.1-68:37:38.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42130,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42130,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1178, RA-DEC 05:10:53.4-68:50:24.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42131,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42131,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1193, RA-DEC 05:11:21.2-69:01:19.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42132,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42132,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1690, RA-DEC 05:21:26.8-70:08:38.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42133,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42133,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1883, RA-DEC 05:24:33.1-71:05:05.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42134,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42134,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2041, RA-DEC 05:27:21.1-70:00:39.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42135,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42135,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4011, RA-DEC 05:27:11.7-66:08:58.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42136,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42136,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0155, RA-DEC 04:50:19.0-69:43:02.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42137,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42137,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0206, RA-DEC 04:51:45.3-66:47:29.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42138,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42138,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0905, RA-DEC 05:05:32.1-68:27:15.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42139,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42139,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1862, RA-DEC 05:24:13.5-69:30:01.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42140,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42140,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3486, RA-DEC 04:58:16.9-66:08:54.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42141,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42141,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3734, RA-DEC 05:13:37.7-65:27:14.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42142,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42142,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0599, RA-DEC 04:59:52.9-70:16:37.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42143,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42143,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0791, RA-DEC 05:03:13.3-68:16:47.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42144,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42144,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0873, RA-DEC 05:04:52.7-70:46:11.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42145,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42145,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2020, RA-DEC 05:26:57.4-68:01:04.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42146,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42146,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2235, RA-DEC 05:31:03.5-71:26:49.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42147,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42147,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0713, RA-DEC 05:01:58.3-70:29:14.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42148,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42148,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1004, RA-DEC 05:07:23.3-68:38:30.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42149,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42149,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2064, RA-DEC 05:27:53.3-71:13:37.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42150,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42150,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2494, RA-DEC 05:35:32.3-70:09:19.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42151,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42151,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0898, RA-DEC 05:05:26.4-69:11:35.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42152,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42152,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1001, RA-DEC 05:07:21.7-68:20:18.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42153,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42153,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1629, RA-DEC 05:20:14.1-70:06:26.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42154,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42154,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2234, RA-DEC 05:31:03.0-69:32:07.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42155,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42155,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2787, RA-DEC 05:39:18.9-71:11:25.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42156,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42156,18.56,NULL,0.0515,10597,NULL,NULL,'Surface Brightness','LMC',NULL,'2008MNRAS.390.1762D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42157,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42157,18.56,0.08,0.0515,10597,NULL,NULL,'20, Parallax','LMC',NULL,'1998MNRAS.294L..41O',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42158,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42158,18.56,0.03,0.0515,10597,NULL,NULL,NULL,'LMC',NULL,'2003MNRAS.342L..58K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42159,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42159,18.56,0.03,0.0515,10597,NULL,NULL,NULL,'LMC',NULL,'2003MNRAS.342L..58K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42160,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42160,18.56,0.04,0.0515,10597,NULL,NULL,'13, VIWJK','LMC',NULL,'2005ApJ...627..224G',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42161,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42161,18.56,0.04,0.0515,10597,NULL,NULL,'13, VIWJK','LMC',NULL,'2005ApJ...627..224G',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42162,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42162,18.56,0.17,0.0515,10597,NULL,NULL,NULL,'LMC',NULL,'1983ApJ...274...20S',1983,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42163,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42163,18.56,0.09,0.0515,10597,NULL,NULL,'Z = -0.29 mag dex-1','LMC',NULL,'2008ApJ...684..102B',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42164,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42164,18.56,NULL,0.0515,10597,NULL,NULL,'Photographic','LMC',NULL,'1980PASP...92..165C',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42165,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42165,18.56,0.05,0.0515,10597,NULL,NULL,'OIII 0057, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42166,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42166,18.56,0.05,0.0515,10597,NULL,NULL,'OIII 0079, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42167,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42167,18.56,0.03,0.0515,10597,NULL,NULL,'NGC 1866, 5, V, +/- 0.10 mag syst.','LMC',NULL,'2013MNRAS.428.2185M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42168,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42168,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0006, RA-DEC 04:35:42.2-69:43:29.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42169,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42169,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0202, RA-DEC 04:51:37.5-68:18:02.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42170,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42170,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0265, RA-DEC 04:53:01.0-69:22:46.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42171,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42171,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0541, RA-DEC 04:58:42.7-67:57:55.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42172,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42172,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2288, RA-DEC 05:32:01.0-69:47:53.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42173,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42173,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2466, RA-DEC 05:35:08.9-71:33:30.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42174,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42174,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4206, RA-DEC 05:36:58.3-63:53:49.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42175,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42175,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1970, RA-DEC 05:25:55.3-69:04:11.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42176,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42176,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3359, RA-DEC 06:11:51.6-72:34:24.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42177,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42177,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0631, RA-DEC 05:00:25.1-68:46:14.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42178,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42178,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0699, RA-DEC 05:01:43.4-68:39:41.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42179,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42179,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1011, RA-DEC 05:07:26.1-68:53:20.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42180,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42180,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1450, RA-DEC 05:16:29.6-71:53:04.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42181,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42181,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1642, RA-DEC 05:20:28.7-68:04:37.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42182,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42182,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1994, RA-DEC 05:26:22.6-69:36:07.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42183,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42183,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3599, RA-DEC 05:07:19.9-66:05:04.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42184,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42184,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3634, RA-DEC 05:09:31.5-65:26:56.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42185,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42185,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3740, RA-DEC 05:13:40.0-65:30:53.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42186,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42186,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0042, RA-DEC 04:43:01.6-70:10:01.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42187,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42187,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0321, RA-DEC 04:54:18.8-68:50:41.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42188,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42188,18.56,0.06,0.0515,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3747, RA-DEC 05:13:42.8-65:27:19.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42189,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42189,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2005, RA-DEC 05:26:40.5-71:54:25.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42190,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42190,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2197, RA-DEC 05:30:35.8-70:49:13.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42191,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42191,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2793, RA-DEC 05:39:23.0-69:22:06.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42192,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42192,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3072, RA-DEC 05:44:27.5-69:31:33.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42193,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42193,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3753, RA-DEC 05:14:14.3-72:12:06.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42194,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42194,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0274, RA-DEC 04:53:11.3-69:02:29.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42195,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42195,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1359, RA-DEC 05:15:15.8-70:50:37.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42196,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42196,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1824, RA-DEC 05:23:14.0-70:06:24.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42197,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42197,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0468, RA-DEC 04:57:12.8-68:40:59.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42198,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42198,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1346, RA-DEC 05:15:05.2-68:58:39.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42199,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42199,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1659, RA-DEC 05:20:49.1-69:02:05.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42200,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42200,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2361, RA-DEC 05:33:29.8-69:37:09.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42201,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42201,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2700, RA-DEC 05:38:07.8-69:09:06.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42202,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42202,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0521, RA-DEC 04:58:23.7-67:53:57.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42203,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42203,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0783, RA-DEC 05:03:06.2-68:21:37.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42204,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42204,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0092, RA-DEC 04:47:47.6-67:51:57.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42205,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42205,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2546, RA-DEC 05:36:18.1-70:13:24.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42206,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42206,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2870, RA-DEC 05:40:31.8-70:21:00.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42207,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42207,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3147, RA-DEC 05:46:22.4-69:01:40.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42208,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42208,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3218, RA-DEC 05:48:45.5-70:27:16.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42209,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42209,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3284, RA-DEC 05:53:05.6-69:29:01.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42210,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42210,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0812, RA-DEC 05:03:38.0-69:03:47.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42211,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42211,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1719, RA-DEC 05:21:55.3-67:46:49.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42212,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42212,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2053, RA-DEC 05:27:37.6-69:57:52.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42213,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42213,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2126, RA-DEC 05:29:14.4-70:17:28.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42214,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42214,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2367, RA-DEC 05:33:34.8-68:40:35.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42215,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42215,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4064, RA-DEC 05:29:58.4-65:54:20.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42216,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42216,18.56,0.05,0.0516,10597,NULL,NULL,'HV 12724, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42217,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42217,18.56,0.05,0.0516,10597,NULL,NULL,'HV 00873, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42218,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42218,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0313, RA-DEC 04:54:05.6-68:55:31.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42219,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42219,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0694, RA-DEC 05:01:38.5-68:43:45.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42220,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42220,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2333, RA-DEC 05:32:57.4-70:48:52.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42221,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42221,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2852, RA-DEC 05:40:11.9-69:22:54.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42222,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42222,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3090, RA-DEC 05:44:51.7-68:31:54.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42223,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42223,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4226, RA-DEC 05:38:11.3-73:02:25.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42224,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42224,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0029, RA-DEC 04:41:35.4-70:02:42.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42225,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42225,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0162, RA-DEC 04:50:30.8-69:30:14.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42226,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42226,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0267, RA-DEC 04:53:02.9-68:54:28.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42227,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42227,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0806, RA-DEC 05:03:30.6-68:00:02.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42228,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42228,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1356, RA-DEC 05:15:11.4-69:15:07.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42229,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42229,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1495, RA-DEC 05:17:33.0-70:02:37.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42230,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42230,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0070, RA-DEC 04:46:01.1-69:38:55.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42231,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42231,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1270, RA-DEC 05:13:18.4-67:22:21.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42232,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42232,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2353, RA-DEC 05:33:21.9-68:35:24.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42233,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42233,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2505, RA-DEC 05:35:38.5-69:43:31.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42234,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42234,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0205, RA-DEC 04:51:42.6-69:36:30.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42235,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42235,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0567, RA-DEC 04:59:13.7-67:15:49.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42236,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42236,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1418, RA-DEC 05:16:00.4-68:57:07.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42237,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42237,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2359, RA-DEC 05:33:26.6-69:56:33.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42238,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42238,18.56,0.06,0.0516,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2681, RA-DEC 05:37:47.9-70:50:07.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42239,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42239,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0035, RA-DEC 04:42:06.3-67:58:11.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42240,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42240,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0056, RA-DEC 04:44:47.0-70:13:51.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42241,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42241,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0589, RA-DEC 04:59:39.4-67:25:49.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42242,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42242,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0926, RA-DEC 05:05:52.4-69:09:29.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42243,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42243,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1046, RA-DEC 05:08:06.8-70:51:19.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42244,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42244,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1381, RA-DEC 05:15:31.5-68:50:11.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42245,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42245,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1478, RA-DEC 05:17:09.6-69:13:13.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42246,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42246,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1975, RA-DEC 05:25:59.7-70:47:14.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42247,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42247,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2343, RA-DEC 05:33:07.6-67:47:26.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42248,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42248,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2619, RA-DEC 05:37:02.9-70:07:27.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42249,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42249,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2969, RA-DEC 05:42:09.2-69:12:28.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42250,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42250,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3019, RA-DEC 05:42:56.4-70:31:51.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42251,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42251,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3124, RA-DEC 05:45:53.4-69:11:49.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42252,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42252,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0099, RA-DEC 04:48:30.9-68:33:43.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42253,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42253,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0705, RA-DEC 05:01:49.8-69:12:43.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42254,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42254,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1030, RA-DEC 05:07:40.9-70:17:50.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42255,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42255,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1556, RA-DEC 05:18:45.4-70:27:39.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42256,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42256,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1870, RA-DEC 05:24:21.3-69:48:30.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42257,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42257,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2347, RA-DEC 05:33:13.7-69:54:56.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42258,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42258,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2451, RA-DEC 05:34:44.6-68:42:08.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42259,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42259,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0275, RA-DEC 04:53:13.5-69:39:08.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42260,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42260,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1377, RA-DEC 05:15:28.2-69:13:57.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42261,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42261,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1545, RA-DEC 05:18:29.6-69:48:41.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42262,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42262,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1960, RA-DEC 05:25:43.2-71:39:15.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42263,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42263,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1492, RA-DEC 05:17:30.1-70:12:30.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42264,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42264,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1640, RA-DEC 05:20:27.1-71:54:23.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42265,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42265,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1850, RA-DEC 05:23:52.4-69:06:42.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42266,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42266,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1973, RA-DEC 05:25:59.1-69:54:49.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42267,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42267,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2013, RA-DEC 05:26:52.3-70:20:22.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42268,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42268,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2799, RA-DEC 05:39:26.6-69:15:19.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42269,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42269,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3484, RA-DEC 04:57:50.6-71:25:36.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42270,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42270,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4600, RA-DEC 06:11:58.3-68:44:45.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42271,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42271,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1692, RA-DEC 05:21:30.0-69:55:11.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42272,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42272,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3534, RA-DEC 05:02:53.8-71:47:17.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42273,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42273,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3856, RA-DEC 05:18:49.4-66:02:53.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42274,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42274,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3946, RA-DEC 05:23:38.4-72:52:27.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42275,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42275,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4329, RA-DEC 05:43:51.3-64:14:49.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42276,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42276,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0628, RA-DEC 05:00:19.2-68:52:38.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42277,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42277,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2375, RA-DEC 05:33:40.4-70:59:12.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42278,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42278,18.57,0.18,0.0517,10597,NULL,NULL,'Hipparcos','LMC',NULL,'2004Ap.....47...18A',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42279,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42279,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0615, RA-DEC 05:00:06.5-67:43:06.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42280,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42280,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1777, RA-DEC 05:22:39.9-71:18:24.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42281,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42281,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2274, RA-DEC 05:31:44.6-70:08:53.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42282,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42282,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3034, RA-DEC 05:43:20.6-71:08:47.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42283,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42283,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3969, RA-DEC 05:25:06.4-66:07:38.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42284,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42284,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0368, RA-DEC 04:55:06.5-68:47:51.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42285,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42285,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0715, RA-DEC 05:01:59.3-69:05:19.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42286,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42286,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0841, RA-DEC 05:04:10.4-69:18:14.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42287,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42287,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0994, RA-DEC 05:07:17.6-66:49:54.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42288,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42288,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1390, RA-DEC 05:15:40.0-71:41:56.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42289,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42289,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1462, RA-DEC 05:16:52.7-69:01:56.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42290,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42290,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1481, RA-DEC 05:17:10.0-68:52:19.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42291,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42291,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1698, RA-DEC 05:21:37.3-69:16:46.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42292,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42292,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0219, RA-DEC 04:52:09.5-69:04:34.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42293,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42293,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0388, RA-DEC 04:55:32.0-67:51:34.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42294,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42294,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0600, RA-DEC 04:59:53.6-68:24:31.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42295,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42295,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1403, RA-DEC 05:15:51.6-68:40:43.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42296,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42296,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2144, RA-DEC 05:29:32.5-68:08:01.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42297,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42297,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2157, RA-DEC 05:29:48.4-69:49:50.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42298,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42298,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2200, RA-DEC 05:30:38.1-69:58:06.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42299,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42299,18.57,0.06,0.0517,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3718, RA-DEC 05:13:13.7-66:10:16.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42300,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42300,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0055, RA-DEC 04:44:34.1-67:04:21.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42301,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42301,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0639, RA-DEC 05:00:37.5-67:45:34.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42302,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42302,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0876, RA-DEC 05:04:56.8-66:56:29.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42303,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42303,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2625, RA-DEC 05:37:08.4-70:27:12.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42304,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42304,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0436, RA-DEC 04:56:29.7-68:53:22.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42305,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42305,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0895, RA-DEC 05:05:24.0-68:42:02.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42306,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42306,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1614, RA-DEC 05:19:58.7-69:19:15.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42307,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42307,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2440, RA-DEC 05:34:33.0-68:50:13.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42308,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42308,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4393, RA-DEC 05:47:11.8-68:10:05.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42309,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42309,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0404, RA-DEC 04:55:49.4-69:20:58.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42310,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42310,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0632, RA-DEC 05:00:26.3-68:46:24.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42311,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42311,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0698, RA-DEC 05:01:42.2-69:30:35.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42312,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42312,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1185, RA-DEC 05:11:06.1-69:06:19.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42313,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42313,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1818, RA-DEC 05:23:11.7-69:28:41.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42314,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42314,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0410, RA-DEC 04:55:56.1-69:34:53.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42315,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42315,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0546, RA-DEC 04:58:48.3-67:19:07.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42316,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42316,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4017, RA-DEC 05:27:28.6-67:21:12.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42317,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42317,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4527, RA-DEC 05:55:55.4-66:36:09.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42318,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42318,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0148, RA-DEC 04:50:04.2-70:37:14.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42319,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42319,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0329, RA-DEC 04:54:24.4-70:55:24.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42320,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42320,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1106, RA-DEC 05:09:09.9-68:34:58.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42321,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42321,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1448, RA-DEC 05:16:28.6-69:36:32.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42322,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42322,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1464, RA-DEC 05:16:55.6-69:08:49.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42323,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42323,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1750, RA-DEC 05:22:22.7-68:57:29.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42324,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42324,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1787, RA-DEC 05:22:44.4-70:09:39.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42325,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42325,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2244, RA-DEC 05:31:12.7-70:04:27.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42326,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42326,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3597, RA-DEC 05:07:19.2-66:13:14.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42327,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42327,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3763, RA-DEC 05:14:26.8-72:02:46.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42328,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42328,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4440, RA-DEC 05:49:14.8-67:39:29.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42329,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42329,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0444, RA-DEC 04:56:39.2-68:38:04.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42330,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42330,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1244, RA-DEC 05:12:42.2-68:34:59.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42331,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42331,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2024, RA-DEC 05:27:00.7-69:47:46.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42332,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42332,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3865, RA-DEC 05:19:23.2-63:34:51.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42333,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42333,18.57,0.14,0.0518,10597,NULL,NULL,'NGC 4258 Cepheids','LMC',NULL,'2015MNRAS.450.3597F',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42334,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42334,18.57,0.1,0.0518,10597,NULL,NULL,NULL,'LMC',NULL,'1995ASPC...83..209F',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42335,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42335,18.57,0.13,0.0518,10597,NULL,NULL,'VRJHK, 216','LMC',NULL,'2004ApJ...601..260N',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42336,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42336,18.57,0.05,0.0518,10597,NULL,NULL,'57, JHK, PL+PLC','LMC',NULL,'1987ApJ...321..162W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42337,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42337,18.57,0.01,0.0518,10597,NULL,NULL,'NGC 1866, 8, BV','LMC',NULL,'1991AJ....101..490W',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42338,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42338,18.57,0.11,0.0518,10597,NULL,NULL,'7, BVIJHK','LMC',NULL,'1998ApJ...492..110M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42339,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42339,18.57,0.11,0.0518,10597,NULL,NULL,'8, VcJHK','LMC',NULL,'1998ApJ...492..110M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42340,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42340,18.57,0.05,0.0518,10597,NULL,NULL,'I','LMC',NULL,'1999ApJ...522..250S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42341,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42341,18.57,0.05,0.0518,10597,NULL,NULL,'HV 08036, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42342,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42342,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1910, RA-DEC 05:24:57.0-69:13:32.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42343,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42343,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4459, RA-DEC 05:50:06.4-66:10:08.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42344,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42344,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0322, RA-DEC 04:54:21.0-68:03:50.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42345,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42345,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0993, RA-DEC 05:07:16.4-70:47:06.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42346,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42346,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1760, RA-DEC 05:22:29.2-70:09:16.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42347,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42347,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3410, RA-DEC 04:49:07.1-67:22:29.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42348,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42348,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3475, RA-DEC 04:56:33.0-66:00:14.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42349,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42349,18.57,0.14,0.0518,10597,NULL,NULL,'NGC 4258 m-M = 29.40 mag','LMC',NULL,'2015MNRAS.450.3597F',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42350,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42350,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1054, RA-DEC 05:08:10.3-71:01:47.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42351,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42351,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1153, RA-DEC 05:10:18.7-70:05:01.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42352,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42352,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1633, RA-DEC 05:20:18.5-70:43:24.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42353,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42353,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1834, RA-DEC 05:23:30.1-68:50:45.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42354,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42354,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2240, RA-DEC 05:31:08.1-71:08:36.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42355,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42355,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3360, RA-DEC 06:13:15.9-72:35:38.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42356,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42356,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0117, RA-DEC 04:49:15.9-68:07:59.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42357,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42357,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0302, RA-DEC 04:53:46.1-67:22:43.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42358,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42358,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2083, RA-DEC 05:28:22.3-68:48:39.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42359,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42359,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3480, RA-DEC 04:57:00.0-66:27:34.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42360,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42360,18.57,0.06,0.0518,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4270, RA-DEC 05:40:54.7-67:13:54.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42361,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42361,18.57,0.06,0.0519,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2488, RA-DEC 05:35:29.7-70:04:10.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42362,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42362,18.57,0.06,0.0519,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2577, RA-DEC 05:36:43.1-70:10:30.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42363,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42363,18.57,0.06,0.0519,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4009, RA-DEC 05:27:00.1-67:27:21.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42364,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42364,18.57,0.06,0.0519,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0494, RA-DEC 04:57:45.7-69:03:45.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42365,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42365,18.57,0.06,0.0519,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1072, RA-DEC 05:08:31.0-68:12:31.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42366,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42366,18.57,0.06,0.0519,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3258, RA-DEC 05:50:57.1-69:40:31.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42367,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42367,18.57,0.06,0.0519,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0060, RA-DEC 04:44:59.6-69:49:55.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42368,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42368,18.57,0.06,0.0519,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0860, RA-DEC 05:04:31.6-68:18:20.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42369,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42369,18.57,0.06,0.0519,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0890, RA-DEC 05:05:18.4-70:44:48.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42370,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42370,18.57,0.06,0.0519,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1700, RA-DEC 05:21:40.4-70:02:01.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42371,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42371,18.57,0.06,0.0519,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3715, RA-DEC 05:13:05.3-71:52:38.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42372,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42372,18.57,0.06,0.0519,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1184, RA-DEC 05:11:05.4-70:30:34.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42373,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42373,18.57,0.06,0.0519,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1546, RA-DEC 05:18:30.7-68:40:02.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42374,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42374,18.57,0.06,0.0519,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1693, RA-DEC 05:21:31.9-69:58:49.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42375,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42375,18.58,0.06,0.0519,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1729, RA-DEC 05:22:02.2-69:53:40.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42376,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42376,18.58,0.06,0.0519,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1911, RA-DEC 05:24:59.0-69:18:15.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42377,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42377,18.58,0.06,0.0519,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2214, RA-DEC 05:30:48.6-70:10:29.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42378,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42378,18.58,0.06,0.0519,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0073, RA-DEC 04:46:38.5-67:08:43.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42379,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42379,18.58,0.06,0.0519,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0199, RA-DEC 04:51:27.8-69:29:22.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42380,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42380,18.58,0.06,0.0519,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1324, RA-DEC 05:14:40.3-68:54:33.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42381,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42381,18.58,0.06,0.0519,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2694, RA-DEC 05:38:03.7-70:31:31.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42382,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42382,18.58,0.06,0.0519,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3643, RA-DEC 05:10:05.4-64:12:44.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42383,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42383,18.58,0.06,0.0519,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0888, RA-DEC 05:05:16.0-68:43:24.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42384,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42384,18.58,0.06,0.0519,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1261, RA-DEC 05:13:10.1-70:26:44.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42385,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42385,18.58,0.06,0.0519,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2996, RA-DEC 05:42:32.6-68:30:36.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42386,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42386,18.58,0.06,0.0519,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1406, RA-DEC 05:15:54.2-70:31:52.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42387,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42387,18.58,0.06,0.0519,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1627, RA-DEC 05:20:10.4-68:54:13.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42388,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42388,18.58,0.06,0.0519,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1761, RA-DEC 05:22:29.4-70:09:14.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42389,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42389,18.58,0.06,0.0519,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2088, RA-DEC 05:28:27.5-70:41:56.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42390,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42390,18.58,0.06,0.0519,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1107, RA-DEC 05:09:12.4-70:51:49.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42391,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42391,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3450, RA-DEC 04:53:43.6-66:08:44.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42392,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42392,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0191, RA-DEC 04:51:18.0-69:45:44.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42393,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42393,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0307, RA-DEC 04:53:58.7-67:08:25.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42394,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42394,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0697, RA-DEC 05:01:41.5-68:43:56.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42395,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42395,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1298, RA-DEC 05:14:01.8-69:19:50.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42396,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42396,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0028, RA-DEC 04:41:26.9-69:37:54.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42397,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42397,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1578, RA-DEC 05:19:14.8-69:36:18.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42398,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42398,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0291, RA-DEC 04:53:33.7-69:45:33.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42399,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42399,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1570, RA-DEC 05:19:02.1-69:21:17.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42400,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42400,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2401, RA-DEC 05:33:54.4-70:02:55.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42401,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42401,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2486, RA-DEC 05:35:27.6-70:12:13.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42402,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42402,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3236, RA-DEC 05:49:33.3-71:05:03.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42403,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42403,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1315, RA-DEC 05:14:25.5-69:25:02.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42404,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42404,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2358, RA-DEC 05:33:26.1-68:09:55.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42405,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42405,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1091, RA-DEC 05:08:53.1-67:50:42.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42406,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42406,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1743, RA-DEC 05:22:14.7-70:09:29.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42407,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42407,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3483, RA-DEC 04:57:41.4-72:15:52.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42408,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42408,18.58,0.02,0.052,10597,NULL,NULL,'BW, VK','LMC',NULL,'1997ApJ...486...60D',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42409,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42409,18.58,0.15,0.052,10597,NULL,NULL,'U99,V','LMC',NULL,'2002AJ....124.1695B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42410,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42410,18.58,0.05,0.052,10597,NULL,NULL,'HV 12716, IRAC 3.6 micron','LMC',NULL,'2012ApJ...748..107P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42411,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42411,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0061, RA-DEC 04:45:00.8-68:07:01.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42412,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42412,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0297, RA-DEC 04:53:39.2-69:31:02.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42413,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42413,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0353, RA-DEC 04:54:54.3-67:13:36.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42414,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42414,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1959, RA-DEC 05:25:43.0-69:07:00.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42415,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42415,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2173, RA-DEC 05:30:09.0-68:30:36.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42416,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42416,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3485, RA-DEC 04:58:04.3-71:33:44.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42417,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42417,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0045, RA-DEC 04:43:10.7-67:16:58.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42418,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42418,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1350, RA-DEC 05:15:07.6-68:36:23.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42419,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42419,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3412, RA-DEC 04:49:21.1-71:42:45.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42420,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42420,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3571, RA-DEC 05:05:16.9-65:17:36.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42421,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42421,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0120, RA-DEC 04:49:19.2-68:28:28.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42422,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42422,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0651, RA-DEC 05:00:54.7-69:03:41.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42423,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42423,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2474, RA-DEC 05:35:15.4-70:44:24.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42424,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42424,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4359, RA-DEC 05:45:23.3-67:42:09.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42425,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42425,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4618, RA-DEC 06:20:07.1-75:21:40.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42426,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42426,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0558, RA-DEC 04:59:04.3-70:56:36.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42427,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42427,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1965, RA-DEC 05:25:46.9-67:48:31.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42428,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42428,18.58,0.06,0.052,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4304, RA-DEC 05:42:33.8-67:44:17.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42429,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42429,18.58,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0723, RA-DEC 05:02:07.9-68:29:07.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42430,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42430,18.58,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0880, RA-DEC 05:05:05.5-69:15:05.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42431,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42431,18.58,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3010, RA-DEC 05:42:49.8-70:48:05.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42432,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42432,18.58,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3086, RA-DEC 05:44:44.9-71:00:43.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42433,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42433,18.58,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4272, RA-DEC 05:40:58.0-63:14:03.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42434,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42434,18.58,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0077, RA-DEC 04:46:56.5-68:07:42.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42435,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42435,18.58,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0872, RA-DEC 05:04:48.1-70:18:19.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42436,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42436,18.58,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2864, RA-DEC 05:40:24.7-69:52:19.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42437,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42437,18.58,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0086, RA-DEC 04:47:22.8-69:26:10.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42438,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42438,18.58,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2374, RA-DEC 05:33:39.8-69:54:18.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42439,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42439,18.58,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3425, RA-DEC 04:51:54.1-65:45:26.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42440,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42440,18.58,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0171, RA-DEC 04:50:50.5-69:15:22.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42441,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42441,18.58,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0875, RA-DEC 05:04:53.7-70:34:33.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42442,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42442,18.58,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1036, RA-DEC 05:07:57.6-70:46:39.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42443,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42443,18.58,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1438, RA-DEC 05:16:15.6-68:28:30.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42444,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42444,18.58,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1453, RA-DEC 05:16:36.3-70:39:49.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42445,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42445,18.58,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3155, RA-DEC 05:46:33.1-68:25:49.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42446,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42446,18.58,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0014, RA-DEC 04:38:18.9-69:53:16.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42447,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42447,18.58,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1264, RA-DEC 05:13:12.0-70:56:15.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42448,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42448,18.58,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1758, RA-DEC 05:22:28.9-70:09:10.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42449,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42449,18.58,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3131, RA-DEC 05:46:02.3-71:11:29.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42450,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42450,18.58,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1227, RA-DEC 05:12:07.9-68:52:02.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42451,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42451,18.58,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1423, RA-DEC 05:16:03.5-67:18:25.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42452,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42452,18.58,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4271, RA-DEC 05:40:57.9-65:47:05.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42453,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42453,18.58,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0805, RA-DEC 05:03:29.8-68:03:14.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42454,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42454,18.58,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1294, RA-DEC 05:13:56.8-69:15:56.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42455,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42455,18.58,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3825, RA-DEC 05:17:02.6-73:06:16.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42456,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42456,18.58,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4168, RA-DEC 05:35:02.9-62:20:23.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42457,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42457,18.59,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0370, RA-DEC 04:55:06.8-69:04:29.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42458,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42458,18.59,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0602, RA-DEC 04:59:54.9-68:05:31.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42459,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42459,18.59,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4493, RA-DEC 05:52:16.9-74:54:33.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42460,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42460,18.59,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0255, RA-DEC 04:52:51.8-66:58:05.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42461,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42461,18.59,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2866, RA-DEC 05:40:26.7-70:19:57.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42462,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42462,18.59,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0391, RA-DEC 04:55:34.7-69:50:11.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42463,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42463,18.59,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0868, RA-DEC 05:04:44.2-70:17:50.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42464,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42464,18.59,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2436, RA-DEC 05:34:28.5-68:57:01.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42465,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42465,18.59,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2696, RA-DEC 05:38:04.5-70:17:48.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42466,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42466,18.59,0.06,0.0521,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2792, RA-DEC 05:39:22.6-71:45:38.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42467,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42467,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3415, RA-DEC 04:49:56.2-73:00:00.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42468,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42468,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3525, RA-DEC 05:02:21.9-66:20:36.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42469,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42469,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3540, RA-DEC 05:03:30.9-64:27:22.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42470,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42470,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1316, RA-DEC 05:14:26.7-69:43:01.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42471,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42471,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3474, RA-DEC 04:56:31.2-66:29:59.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42472,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42472,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4267, RA-DEC 05:40:47.8-67:43:13.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42473,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42473,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0100, RA-DEC 04:48:34.2-70:10:16.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42474,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42474,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0941, RA-DEC 05:06:07.1-66:37:49.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42475,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42475,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1334, RA-DEC 05:14:50.8-68:50:28.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42476,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42476,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2035, RA-DEC 05:27:14.1-71:49:47.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42477,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42477,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3066, RA-DEC 05:44:23.0-70:40:55.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42478,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42478,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4563, RA-DEC 06:00:51.7-67:48:32.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42479,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42479,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0214, RA-DEC 04:52:04.0-68:25:18.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42480,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42480,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0216, RA-DEC 04:52:05.6-69:23:26.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42481,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42481,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0817, RA-DEC 05:03:43.4-70:25:11.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42482,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42482,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1243, RA-DEC 05:12:41.4-66:59:19.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42483,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42483,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1434, RA-DEC 05:16:11.0-69:18:05.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42484,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42484,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1684, RA-DEC 05:21:21.8-70:02:48.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42485,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42485,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2422, RA-DEC 05:34:16.4-70:16:13.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42486,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42486,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0071, RA-DEC 04:46:06.3-68:46:31.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42487,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42487,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0991, RA-DEC 05:07:15.4-68:41:35.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42488,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42488,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1764, RA-DEC 05:22:29.9-70:08:59.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42489,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42489,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2810, RA-DEC 05:39:34.7-69:09:59.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42490,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42490,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2991, RA-DEC 05:42:29.5-69:57:58.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42491,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42491,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3161, RA-DEC 05:46:40.1-69:45:42.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42492,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42492,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3244, RA-DEC 05:49:53.1-71:40:31.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42493,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42493,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0174, RA-DEC 04:50:52.4-69:18:56.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42494,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42494,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0769, RA-DEC 05:02:50.9-66:50:35.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42495,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42495,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1393, RA-DEC 05:15:43.0-67:30:41.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42496,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42496,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1468, RA-DEC 05:16:59.9-69:20:06.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42497,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42497,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1623, RA-DEC 05:20:05.9-69:51:02.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42498,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42498,18.59,0.15,0.0522,10597,NULL,NULL,'7, K','LMC',NULL,'1998ApJ...492..110M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42499,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42499,18.59,0.04,0.0522,10597,NULL,NULL,'VI','LMC',NULL,'2002AJ....124.1213D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42500,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42500,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1061, RA-DEC 05:08:20.1-70:43:44.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42501,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42501,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1066, RA-DEC 05:08:26.6-69:21:16.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42502,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42502,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1801, RA-DEC 05:23:00.7-70:34:32.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42503,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42503,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3822, RA-DEC 05:16:52.9-66:22:11.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42504,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42504,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0128, RA-DEC 04:49:41.7-70:37:38.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42505,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42505,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0236, RA-DEC 04:52:27.4-69:30:54.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42506,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42506,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0337, RA-DEC 04:54:38.7-68:36:37.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42507,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42507,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1258, RA-DEC 05:13:06.1-70:34:41.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42508,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42508,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2863, RA-DEC 05:40:24.1-71:11:10.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42509,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42509,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3456, RA-DEC 04:54:23.9-66:20:06.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42510,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42510,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3579, RA-DEC 05:05:55.4-65:57:57.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42511,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42511,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0245, RA-DEC 04:52:44.4-68:25:44.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42512,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42512,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0670, RA-DEC 05:01:04.8-68:13:14.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42513,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42513,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0916, RA-DEC 05:05:43.6-69:06:58.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42514,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42514,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1006, RA-DEC 05:07:24.4-70:48:29.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42515,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42515,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2009, RA-DEC 05:26:46.5-71:24:01.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42516,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42516,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3770, RA-DEC 05:14:54.2-71:24:23.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42517,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42517,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3996, RA-DEC 05:26:12.9-66:09:32.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42518,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42518,18.59,0.08,0.0522,10597,NULL,NULL,'57, K, PL','LMC',NULL,'1987ApJ...321..162W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42519,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42519,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0105, RA-DEC 04:48:48.9-66:44:02.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42520,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42520,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0268, RA-DEC 04:53:07.5-68:13:00.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42521,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42521,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1141, RA-DEC 05:09:59.3-69:08:40.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42522,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42522,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1528, RA-DEC 05:18:06.6-69:39:00.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42523,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42523,18.59,0.06,0.0522,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1785, RA-DEC 05:22:43.2-70:23:04.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42524,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42524,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0129, RA-DEC 04:49:44.0-69:35:55.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42525,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42525,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0427, RA-DEC 04:56:19.4-68:33:59.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42526,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42526,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0565, RA-DEC 04:59:11.5-70:22:12.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42527,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42527,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1696, RA-DEC 05:21:36.2-69:46:30.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42528,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42528,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2443, RA-DEC 05:34:36.0-71:27:37.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42529,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42529,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2662, RA-DEC 05:37:38.2-70:16:05.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42530,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42530,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0010, RA-DEC 04:36:56.5-68:14:27.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42531,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42531,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0710, RA-DEC 05:01:53.1-70:15:48.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42532,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42532,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1854, RA-DEC 05:23:58.5-68:33:59.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42533,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42533,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0995, RA-DEC 05:07:18.4-69:01:35.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42534,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42534,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3473, RA-DEC 04:56:02.5-71:29:00.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42535,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42535,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1366, RA-DEC 05:15:20.4-71:40:23.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42536,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42536,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4539, RA-DEC 05:57:04.9-64:58:28.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42537,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42537,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1331, RA-DEC 05:14:46.1-69:20:31.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42538,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42538,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2339, RA-DEC 05:33:04.4-71:37:16.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42539,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42539,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3261, RA-DEC 05:51:03.6-70:23:54.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42540,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42540,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0043, RA-DEC 04:43:03.8-68:51:24.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42541,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42541,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0374, RA-DEC 04:55:12.4-66:45:04.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42542,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42542,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0717, RA-DEC 05:02:02.8-68:43:35.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42543,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42543,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0910, RA-DEC 05:05:36.2-70:46:13.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42544,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42544,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3672, RA-DEC 05:11:16.1-72:31:56.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42545,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42545,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4238, RA-DEC 05:38:45.3-66:37:53.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42546,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42546,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0093, RA-DEC 04:47:57.8-70:19:33.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42547,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42547,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1759, RA-DEC 05:22:29.0-70:09:35.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42548,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42548,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2464, RA-DEC 05:35:02.3-69:35:09.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42549,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42549,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2572, RA-DEC 05:36:35.0-70:15:41.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42550,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42550,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3219, RA-DEC 05:48:49.3-71:55:04.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42551,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42551,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4239, RA-DEC 05:38:46.4-67:05:06.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42552,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42552,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0090, RA-DEC 04:47:44.7-70:12:07.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42553,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42553,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0971, RA-DEC 05:06:55.3-68:38:14.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42554,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42554,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1322, RA-DEC 05:14:38.9-69:30:27.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42555,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42555,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2187, RA-DEC 05:30:25.7-71:39:38.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42556,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42556,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3399, RA-DEC 04:47:33.3-70:44:51.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42557,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42557,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0186, RA-DEC 04:51:09.6-69:08:23.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42558,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42558,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1204, RA-DEC 05:11:37.7-68:04:50.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42559,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42559,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2000, RA-DEC 05:26:30.8-70:58:26.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42560,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42560,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2114, RA-DEC 05:28:54.3-69:10:13.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42561,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42561,18.59,0.06,0.0523,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3980, RA-DEC 05:25:33.5-66:39:38.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42562,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42562,18.59,0.06,0.0524,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1303, RA-DEC 05:14:08.1-68:36:12.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42563,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42563,18.59,0.06,0.0524,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1668, RA-DEC 05:20:59.0-69:46:31.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42564,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42564,18.6,0.06,0.0524,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3516, RA-DEC 05:01:18.8-66:08:16.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42565,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42565,18.6,0.06,0.0524,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4164, RA-DEC 05:34:57.4-72:06:22.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42566,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42566,18.6,0.06,0.0524,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2232, RA-DEC 05:31:02.4-71:24:05.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42567,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42567,18.6,0.06,0.0524,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3423, RA-DEC 04:51:19.5-70:56:48.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42568,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42568,18.6,0.06,0.0524,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1524, RA-DEC 05:18:02.4-70:45:34.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42569,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42569,18.6,0.06,0.0524,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1595, RA-DEC 05:19:32.3-69:36:33.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42570,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42570,18.6,0.06,0.0524,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2186, RA-DEC 05:30:23.5-70:00:08.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42571,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42571,18.6,0.06,0.0524,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2305, RA-DEC 05:32:22.7-69:02:06.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42572,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42572,18.6,0.06,0.0524,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2212, RA-DEC 05:30:48.2-68:28:53.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42573,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42573,18.6,0.06,0.0524,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3139, RA-DEC 05:46:13.6-72:03:13.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42574,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42574,18.6,0.06,0.0524,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3538, RA-DEC 05:03:26.6-65:08:37.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42575,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42575,18.6,0.06,0.0524,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1568, RA-DEC 05:19:00.5-69:11:30.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42576,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42576,18.6,0.06,0.0524,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3533, RA-DEC 05:02:52.5-71:42:01.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42577,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42577,18.6,0.06,0.0524,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0091, RA-DEC 04:47:46.1-68:19:49.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42578,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42578,18.6,0.06,0.0524,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0648, RA-DEC 05:00:48.4-69:31:54.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42579,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42579,18.6,0.06,0.0524,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1610, RA-DEC 05:19:47.9-67:50:48.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42580,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42580,18.6,0.06,0.0524,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2816, RA-DEC 05:39:41.9-69:36:50.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42581,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42581,18.6,0.06,0.0524,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3490, RA-DEC 04:58:53.3-71:35:29.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42582,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42582,18.6,0.06,0.0524,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0645, RA-DEC 05:00:43.4-70:20:42.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42583,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42583,18.6,0.06,0.0524,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0829, RA-DEC 05:03:54.9-69:49:26.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42584,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42584,18.6,0.06,0.0524,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1628, RA-DEC 05:20:12.8-68:44:33.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42585,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42585,18.6,0.06,0.0524,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4613, RA-DEC 06:17:49.8-67:48:49.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42586,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42586,18.6,0.06,0.0525,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3853, RA-DEC 05:18:33.7-67:12:53.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42587,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42587,18.6,0.06,0.0525,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0301, RA-DEC 04:53:45.6-69:23:28.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42588,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42588,18.6,0.06,0.0525,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0561, RA-DEC 04:59:07.2-67:43:30.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42589,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42589,18.6,0.06,0.0525,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1255, RA-DEC 05:12:57.7-69:02:03.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42590,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42590,18.6,0.06,0.0525,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3703, RA-DEC 05:12:31.0-66:12:02.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42591,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42591,18.6,0.06,0.0525,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0499, RA-DEC 04:57:50.1-68:59:22.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42592,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42592,18.6,0.06,0.0525,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1084, RA-DEC 05:08:46.6-69:52:13.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42593,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42593,18.6,0.06,0.0525,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0904, RA-DEC 05:05:30.7-68:26:25.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42594,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42594,18.6,0.06,0.0525,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0970, RA-DEC 05:06:53.0-68:39:35.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42595,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42595,18.6,0.06,0.0525,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3873, RA-DEC 05:19:48.0-65:21:49.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42596,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42596,18.6,0.06,0.0525,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0514, RA-DEC 04:58:12.9-69:12:10.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42597,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42597,18.6,0.06,0.0525,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0605, RA-DEC 04:59:56.8-68:01:09.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42598,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42598,18.6,0.06,0.0525,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1600, RA-DEC 05:19:38.1-69:22:00.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42599,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42599,18.6,0.06,0.0525,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0118, RA-DEC 04:49:16.2-69:20:19.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42600,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42600,18.6,0.06,0.0525,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2809, RA-DEC 05:39:34.4-71:08:23.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42601,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42601,18.6,NULL,0.0525,10597,NULL,NULL,'NGC 1866, LMC +0.10 mag','LMC',NULL,'2006MmSAI..77..291M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42602,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42602,18.6,0.06,0.0525,10597,NULL,NULL,'U 1, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42603,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42603,18.6,0.11,0.0525,10597,NULL,NULL,'W','LMC',NULL,'2000A&A...363..901G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42604,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42604,18.6,NULL,0.0525,10597,NULL,NULL,NULL,'LMC',NULL,'2012ApJ...745..104N',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42605,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42605,18.6,0.3,0.0525,10597,NULL,NULL,'NGC 1866, Baade-Wesselink','LMC',NULL,'1991AJ....101.1681C',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42606,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42606,18.6,0.1,0.0525,10597,NULL,NULL,'V','LMC',NULL,'1993ApJ...418..135G',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42607,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42607,18.6,NULL,0.0525,10597,NULL,NULL,'NGC 1850','LMC',NULL,'1995ApJ...449..164S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42608,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42608,18.6,0.15,0.0525,10597,NULL,NULL,'7, H','LMC',NULL,'1998ApJ...492..110M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42609,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42609,18.6,NULL,0.0525,10597,NULL,NULL,'PCL','LMC',NULL,'1999IAUS..190..557M',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42610,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42610,18.6,0.11,0.0525,10597,NULL,NULL,'VIK(W) \'best\'','LMC',NULL,'2000A&A...356..849G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42611,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42611,18.6,0.06,0.0525,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0864, RA-DEC 05:04:37.2-68:16:01.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42612,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42612,18.6,0.06,0.0525,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1475, RA-DEC 05:17:07.0-70:06:24.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42613,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42613,18.6,0.06,0.0525,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1486, RA-DEC 05:17:18.5-69:41:46.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42614,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42614,18.6,0.06,0.0525,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1433, RA-DEC 05:16:10.9-70:17:36.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42615,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42615,18.6,0.06,0.0525,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1706, RA-DEC 05:21:47.3-69:20:40.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42616,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42616,18.6,0.06,0.0525,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1950, RA-DEC 05:25:35.0-68:50:19.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42617,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42617,18.6,0.06,0.0525,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1031, RA-DEC 05:07:42.1-69:14:48.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42618,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42618,18.6,0.06,0.0525,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1639, RA-DEC 05:20:26.4-68:47:17.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42619,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42619,18.6,0.06,0.0525,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2206, RA-DEC 05:30:43.9-69:06:01.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42620,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42620,18.6,0.06,0.0525,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2653, RA-DEC 05:37:34.8-69:05:30.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42621,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42621,18.6,0.06,0.0525,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3736, RA-DEC 05:13:37.9-65:27:58.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42622,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42622,18.6,0.06,0.0525,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1646, RA-DEC 05:20:36.0-68:49:20.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42623,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42623,18.6,0.06,0.0526,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0495, RA-DEC 04:57:46.2-70:17:21.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42624,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42624,18.6,0.06,0.0526,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1470, RA-DEC 05:17:01.5-69:15:14.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42625,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42625,18.6,0.06,0.0526,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0269, RA-DEC 04:53:08.9-70:08:16.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42626,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42626,18.6,0.06,0.0526,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0949, RA-DEC 05:06:16.9-68:40:33.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42627,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42627,18.6,0.06,0.0526,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0327, RA-DEC 04:54:23.1-69:11:24.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42628,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42628,18.6,0.06,0.0526,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1669, RA-DEC 05:20:59.6-69:45:28.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42629,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42629,18.6,0.06,0.0526,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2137, RA-DEC 05:29:26.9-71:33:12.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42630,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42630,18.6,0.06,0.0526,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0223, RA-DEC 04:52:13.3-69:52:02.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42631,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42631,18.6,0.06,0.0526,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0380, RA-DEC 04:55:21.4-68:39:59.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42632,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42632,18.6,0.06,0.0526,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1584, RA-DEC 05:19:23.3-69:09:54.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42633,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42633,18.6,0.06,0.0526,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0660, RA-DEC 05:00:57.6-69:36:02.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42634,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42634,18.6,0.06,0.0526,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3444, RA-DEC 04:53:25.2-70:58:45.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42635,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42635,18.6,0.06,0.0526,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1110, RA-DEC 05:09:17.8-68:39:09.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42636,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42636,18.6,0.06,0.0526,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2286, RA-DEC 05:31:56.3-69:14:33.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42637,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42637,18.61,0.06,0.0526,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2055, RA-DEC 05:27:42.8-68:36:31.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42638,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42638,18.61,0.06,0.0526,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0401, RA-DEC 04:55:46.1-68:51:20.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42639,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42639,18.61,0.06,0.0526,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0953, RA-DEC 05:06:22.1-70:48:05.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42640,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42640,18.61,0.06,0.0526,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1812, RA-DEC 05:23:07.7-69:33:49.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42641,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42641,18.61,0.06,0.0526,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1924, RA-DEC 05:25:19.3-69:27:05.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42642,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42642,18.61,0.06,0.0526,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0533, RA-DEC 04:58:35.9-68:27:04.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42643,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42643,18.61,0.06,0.0526,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1345, RA-DEC 05:15:04.7-69:13:30.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42644,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42644,18.61,0.06,0.0526,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0304, RA-DEC 04:53:46.9-69:19:13.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42645,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42645,18.61,0.06,0.0526,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0693, RA-DEC 05:01:36.5-68:59:48.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42646,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42646,18.61,0.06,0.0526,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1531, RA-DEC 05:18:08.3-71:31:30.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42647,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42647,18.61,0.06,0.0526,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1566, RA-DEC 05:18:58.2-69:16:46.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42648,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42648,18.61,0.06,0.0526,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1878, RA-DEC 05:24:29.4-70:09:58.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42649,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42649,18.61,0.06,0.0526,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2303, RA-DEC 05:32:18.8-69:46:39.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42650,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42650,18.61,0.06,0.0526,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3689, RA-DEC 05:12:00.0-71:47:41.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42651,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42651,18.61,0.06,0.0527,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0359, RA-DEC 04:55:00.5-67:14:40.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42652,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42652,18.61,0.06,0.0527,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1099, RA-DEC 05:09:03.2-71:04:38.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42653,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42653,18.61,0.06,0.0527,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3004, RA-DEC 05:42:44.1-68:33:15.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42654,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42654,18.61,0.06,0.0527,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3731, RA-DEC 05:13:36.5-65:28:04.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42655,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42655,18.61,0.06,0.0527,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4365, RA-DEC 05:45:35.4-67:17:11.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42656,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42656,18.61,0.06,0.0527,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1089, RA-DEC 05:08:50.5-70:46:47.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42657,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42657,18.61,0.06,0.0527,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2097, RA-DEC 05:28:33.5-69:35:46.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42658,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42658,18.61,0.06,0.0527,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2427, RA-DEC 05:34:20.6-69:07:23.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42659,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42659,18.61,0.06,0.0527,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0115, RA-DEC 04:49:13.0-70:09:20.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42660,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42660,18.61,0.06,0.0527,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0526, RA-DEC 04:58:28.8-69:10:31.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42661,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42661,18.61,0.06,0.0527,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3532, RA-DEC 05:02:52.1-66:24:26.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42662,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42662,18.61,0.06,0.0527,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2370, RA-DEC 05:33:36.8-69:54:16.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42663,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42663,18.61,0.06,0.0527,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3537, RA-DEC 05:03:09.9-74:46:39.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42664,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42664,18.61,0.06,0.0527,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0233, RA-DEC 04:52:24.8-70:37:33.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42665,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42665,18.61,0.06,0.0527,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0288, RA-DEC 04:53:31.1-70:01:24.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42666,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42666,18.61,0.06,0.0527,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0577, RA-DEC 04:59:25.6-69:26:33.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42667,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42667,18.61,0.06,0.0527,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1242, RA-DEC 05:12:36.6-71:09:28.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42668,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42668,18.61,0.06,0.0527,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0183, RA-DEC 04:51:07.2-70:40:05.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42669,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42669,18.61,0.06,0.0527,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1788, RA-DEC 05:22:44.6-68:27:03.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42670,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42670,18.61,0.06,0.0527,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2389, RA-DEC 05:33:43.2-70:58:51.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42671,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42671,18.61,0.06,0.0527,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2878, RA-DEC 05:40:33.4-70:01:50.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42672,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42672,18.61,0.06,0.0527,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3418, RA-DEC 04:50:15.9-71:24:35.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42673,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42673,18.61,0.06,0.0527,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3465, RA-DEC 04:55:11.4-66:27:52.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42674,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42674,18.61,0.06,0.0527,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0025, RA-DEC 04:40:54.4-69:06:54.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42675,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42675,18.61,0.06,0.0527,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0714, RA-DEC 05:01:59.2-68:26:51.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42676,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42676,18.61,0.06,0.0527,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1138, RA-DEC 05:09:53.5-68:59:03.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42677,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42677,18.61,0.06,0.0528,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0430, RA-DEC 04:56:22.7-68:57:42.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42678,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42678,18.61,0.06,0.0528,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0108, RA-DEC 04:48:56.1-68:54:06.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42679,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42679,18.61,0.06,0.0528,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0195, RA-DEC 04:51:23.1-70:38:00.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42680,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42680,18.61,0.06,0.0528,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0234, RA-DEC 04:52:26.4-68:21:42.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42681,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42681,18.61,0.06,0.0528,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0252, RA-DEC 04:52:50.1-68:11:33.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42682,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42682,18.61,0.06,0.0528,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1632, RA-DEC 05:20:17.4-67:56:53.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42683,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42683,18.61,0.06,0.0528,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2780, RA-DEC 05:39:15.2-69:19:39.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42684,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42684,18.61,0.06,0.0528,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0007, RA-DEC 04:36:30.1-68:37:35.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42685,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42685,18.61,0.06,0.0528,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0692, RA-DEC 05:01:35.7-69:43:24.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42686,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42686,18.61,0.06,0.0528,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1041, RA-DEC 05:08:02.8-68:36:32.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42687,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42687,18.61,0.06,0.0528,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3438, RA-DEC 04:52:59.5-74:04:43.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42688,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42688,18.61,0.06,0.0528,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3580, RA-DEC 05:05:56.4-66:19:59.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42689,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42689,18.61,0.06,0.0528,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0218, RA-DEC 04:52:07.7-69:36:50.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42690,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42690,18.61,0.06,0.0528,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0317, RA-DEC 04:54:13.8-68:02:05.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42691,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42691,18.61,0.06,0.0528,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0529, RA-DEC 04:58:32.9-69:02:27.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42692,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42692,18.61,0.06,0.0528,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0922, RA-DEC 05:05:49.6-67:13:11.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42693,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42693,18.61,0.06,0.0528,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1122, RA-DEC 05:09:27.4-68:04:04.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42694,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42694,18.61,0.06,0.0528,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0861, RA-DEC 05:04:33.7-69:35:13.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42695,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42695,18.61,0.06,0.0528,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1217, RA-DEC 05:11:57.3-70:40:20.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42696,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42696,18.61,0.06,0.0528,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0044, RA-DEC 04:43:10.5-67:14:00.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42697,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42697,18.61,0.06,0.0528,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0221, RA-DEC 04:52:12.5-69:25:27.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42698,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42698,18.61,0.06,0.0528,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0455, RA-DEC 04:56:52.5-70:25:48.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42699,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42699,18.61,0.06,0.0528,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0466, RA-DEC 04:57:09.3-68:53:34.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42700,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42700,18.61,0.06,0.0528,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3033, RA-DEC 05:43:14.7-67:47:26.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42701,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42701,18.61,0.06,0.0528,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0113, RA-DEC 04:49:11.2-68:54:29.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42702,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42702,18.61,0.06,0.0528,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1611, RA-DEC 05:19:53.7-69:15:26.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42703,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42703,18.61,0.06,0.0528,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2630, RA-DEC 05:37:16.4-69:54:05.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42704,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42704,18.62,0.06,0.0529,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0657, RA-DEC 05:00:56.7-70:38:21.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42705,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42705,18.62,0.06,0.0529,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0802, RA-DEC 05:03:26.6-67:52:42.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42706,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42706,18.62,0.06,0.0529,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0066, RA-DEC 04:45:34.2-69:53:54.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42707,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42707,18.62,0.06,0.0529,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0187, RA-DEC 04:51:12.3-67:15:20.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42708,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42708,18.62,0.06,0.0529,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0242, RA-DEC 04:52:35.8-67:33:15.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42709,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42709,18.62,0.06,0.0529,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0504, RA-DEC 04:57:56.7-68:48:57.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42710,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42710,18.62,0.06,0.0529,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0193, RA-DEC 04:51:20.3-68:18:12.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42711,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42711,18.62,0.06,0.0529,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0843, RA-DEC 05:04:14.1-69:06:11.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42712,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42712,18.62,0.06,0.0529,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0944, RA-DEC 05:06:11.4-70:25:45.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42713,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42713,18.62,0.06,0.0529,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1940, RA-DEC 05:25:28.9-69:50:03.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42714,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42714,18.62,0.06,0.0529,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0340, RA-DEC 04:54:44.4-68:23:49.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42715,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42715,18.62,0.06,0.0529,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0950, RA-DEC 05:06:18.3-69:31:47.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42716,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42716,18.62,0.06,0.0529,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0984, RA-DEC 05:07:04.3-70:41:35.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42717,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42717,18.62,0.06,0.0529,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1454, RA-DEC 05:16:39.1-69:21:43.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42718,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42718,18.62,0.06,0.0529,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2535, RA-DEC 05:36:07.3-71:00:40.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42719,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42719,18.62,0.06,0.0529,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3559, RA-DEC 05:04:32.9-73:09:22.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42720,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42720,18.62,0.06,0.0529,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0184, RA-DEC 04:51:07.5-68:50:25.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42721,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42721,18.62,0.06,0.0529,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1069, RA-DEC 05:08:28.4-68:29:35.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42722,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42722,18.62,0.06,0.0529,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2336, RA-DEC 05:32:58.5-69:05:04.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42723,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42723,18.62,0.06,0.0529,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0412, RA-DEC 04:55:56.7-67:17:51.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42724,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42724,18.62,0.06,0.0529,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1288, RA-DEC 05:13:52.8-69:34:48.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42725,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42725,18.62,0.06,0.0529,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3460, RA-DEC 04:54:49.7-71:47:52.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42726,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42726,18.62,0.06,0.0529,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3430, RA-DEC 04:52:26.3-71:24:18.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42727,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42727,18.62,0.06,0.0529,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0112, RA-DEC 04:49:10.2-67:51:53.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42728,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42728,18.62,0.06,0.0529,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0646, RA-DEC 05:00:44.6-68:57:15.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42729,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42729,18.62,0.06,0.0529,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1559, RA-DEC 05:18:50.2-69:16:36.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42730,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42730,18.62,0.06,0.0529,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2636, RA-DEC 05:37:22.5-69:28:59.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42731,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42731,18.62,0.06,0.0529,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3498, RA-DEC 04:59:50.7-66:28:11.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42732,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42732,18.62,0.06,0.053,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0425, RA-DEC 04:56:16.2-68:40:55.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42733,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42733,18.62,0.06,0.053,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0616, RA-DEC 05:00:06.9-68:58:02.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42734,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42734,18.62,0.06,0.053,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3189, RA-DEC 05:47:32.1-68:55:37.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42735,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42735,18.62,0.06,0.053,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2922, RA-DEC 05:41:17.1-72:11:54.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42736,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42736,18.62,0.06,0.053,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0143, RA-DEC 04:50:00.0-67:55:28.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42737,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42737,18.62,0.06,0.053,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0482, RA-DEC 04:57:28.7-69:13:36.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42738,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42738,18.62,0.06,0.053,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0537, RA-DEC 04:58:36.9-69:31:53.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42739,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42739,18.62,0.06,0.053,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1741, RA-DEC 05:22:14.0-69:54:38.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42740,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42740,18.62,0.06,0.053,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0283, RA-DEC 04:53:26.2-69:35:43.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42741,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42741,18.62,0.06,0.053,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1602, RA-DEC 05:19:39.0-68:58:40.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42742,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42742,18.62,0.06,0.053,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1803, RA-DEC 05:23:01.4-70:12:13.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42743,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42743,18.62,0.06,0.053,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2266, RA-DEC 05:31:40.9-69:45:03.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42744,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42744,18.62,0.06,0.053,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0149, RA-DEC 04:50:09.6-69:39:39.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42745,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42745,18.62,0.06,0.053,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0411, RA-DEC 04:55:56.6-68:24:33.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42746,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42746,18.62,0.06,0.053,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1672, RA-DEC 05:21:05.1-69:40:35.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42747,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42747,18.62,0.06,0.053,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2346, RA-DEC 05:33:13.4-69:52:16.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42748,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42748,18.62,0.06,0.053,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3136, RA-DEC 05:46:10.6-69:16:52.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42749,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42749,18.62,0.08,0.053,10597,NULL,NULL,NULL,'LMC',NULL,'2011AJ....142..110M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42750,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42750,18.62,0.22,0.053,10597,NULL,NULL,NULL,'LMC',NULL,'1984Ap&SS.107..167C',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42751,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42751,18.62,0.12,0.053,10597,NULL,NULL,'PL(K)','LMC',NULL,'1999ASPC..167..275M',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42752,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42752,18.62,0.17,0.053,10597,NULL,NULL,'PLC(V)','LMC',NULL,'1999ASPC..167..275M',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42753,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42753,18.62,0.18,0.053,10597,NULL,NULL,'7, J','LMC',NULL,'1998ApJ...492..110M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42754,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42754,18.62,0.12,0.053,10597,NULL,NULL,'K, PL','LMC',NULL,'1999ApJ...512..711B',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42755,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42755,18.62,0.17,0.053,10597,NULL,NULL,'V, PLC','LMC',NULL,'1999ApJ...512..711B',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42756,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42756,18.62,0.06,0.053,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0039, RA-DEC 04:42:38.0-68:30:59.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42757,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42757,18.62,0.06,0.053,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1047, RA-DEC 05:08:07.3-68:41:08.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42758,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42758,18.62,0.06,0.053,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1095, RA-DEC 05:08:55.8-70:06:08.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42759,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42759,18.62,0.06,0.0531,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0448, RA-DEC 04:56:42.8-69:15:26.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42760,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42760,18.62,0.06,0.0531,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1833, RA-DEC 05:23:29.0-69:18:37.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42761,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42761,18.62,0.06,0.0531,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2284, RA-DEC 05:31:55.2-68:35:20.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42762,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42762,18.62,0.06,0.0531,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3167, RA-DEC 05:46:48.3-69:11:50.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42763,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42763,18.62,0.06,0.0531,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0311, RA-DEC 04:54:03.5-68:52:01.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42764,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42764,18.62,0.06,0.0531,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2283, RA-DEC 05:31:53.9-70:19:13.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42765,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42765,18.62,0.06,0.0531,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1651, RA-DEC 05:20:42.3-69:35:10.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42766,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42766,18.63,0.06,0.0531,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0153, RA-DEC 04:50:17.4-68:47:50.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42767,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42767,18.63,0.06,0.0531,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3614, RA-DEC 05:08:17.1-71:54:40.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42768,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42768,18.63,0.06,0.0531,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0800, RA-DEC 05:03:25.1-68:46:21.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42769,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42769,18.63,0.06,0.0531,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1002, RA-DEC 05:07:22.5-70:44:25.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42770,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42770,18.63,0.06,0.0531,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0350, RA-DEC 04:54:52.5-69:10:27.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42771,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42771,18.63,0.06,0.0531,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0912, RA-DEC 05:05:37.5-68:57:23.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42772,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42772,18.63,0.06,0.0531,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0942, RA-DEC 05:06:08.1-70:11:16.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42773,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42773,18.63,0.06,0.0531,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2323, RA-DEC 05:32:46.1-69:52:17.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42774,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42774,18.63,0.06,0.0532,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1212, RA-DEC 05:11:50.2-68:30:59.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42775,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42775,18.63,0.06,0.0532,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2360, RA-DEC 05:33:28.1-71:00:08.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42776,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42776,18.63,0.06,0.0532,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3890, RA-DEC 05:20:51.3-66:05:24.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42777,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42777,18.63,0.06,0.0532,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0282, RA-DEC 04:53:23.9-68:32:21.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42778,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42778,18.63,0.06,0.0532,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2195, RA-DEC 05:30:33.8-70:49:04.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42779,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42779,18.63,0.06,0.0532,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4158, RA-DEC 05:34:24.9-67:25:42.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42780,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42780,18.63,0.06,0.0532,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0398, RA-DEC 04:55:45.0-69:09:32.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42781,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42781,18.63,0.06,0.0532,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0700, RA-DEC 05:01:44.0-70:42:32.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42782,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42782,18.63,0.06,0.0532,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0702, RA-DEC 05:01:46.9-68:41:40.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42783,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42783,18.63,0.06,0.0532,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1790, RA-DEC 05:22:48.0-69:20:03.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42784,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42784,18.63,0.06,0.0532,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2376, RA-DEC 05:33:40.5-69:52:59.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42785,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42785,18.63,0.06,0.0532,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0613, RA-DEC 05:00:05.1-69:31:37.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42786,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42786,18.63,0.06,0.0532,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1503, RA-DEC 05:17:41.6-69:21:31.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42787,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42787,18.63,0.06,0.0532,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2294, RA-DEC 05:32:04.5-68:37:16.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42788,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42788,18.63,NULL,0.0532,10597,NULL,NULL,'BVI','LMC',NULL,'1999ApJ...525..784C',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42789,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42789,18.63,NULL,0.0532,10597,NULL,NULL,'26, PLV+PLC','LMC',NULL,'1988ASPC....4....9F',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42790,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42790,18.63,0.06,0.0532,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0930, RA-DEC 05:05:55.0-68:05:35.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42791,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42791,18.63,0.06,0.0532,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1336, RA-DEC 05:14:53.6-71:11:27.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42792,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42792,18.63,0.06,0.0532,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0678, RA-DEC 05:01:13.4-68:16:40.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42793,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42793,18.63,0.06,0.0532,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1029, RA-DEC 05:07:38.5-70:48:26.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42794,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42794,18.63,0.06,0.0532,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1969, RA-DEC 05:25:54.9-69:54:51.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42795,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42795,18.63,0.06,0.0532,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0424, RA-DEC 04:56:15.3-69:27:03.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42796,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42796,18.63,0.06,0.0532,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3802, RA-DEC 05:16:03.9-66:25:28.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42797,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42797,18.63,0.06,0.0533,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1222, RA-DEC 05:12:00.9-71:02:25.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42798,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42798,18.63,0.06,0.0533,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2344, RA-DEC 05:33:10.9-68:54:57.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42799,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42799,18.63,0.06,0.0533,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0523, RA-DEC 04:58:26.7-70:49:50.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42800,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42800,18.63,0.06,0.0533,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0972, RA-DEC 05:06:55.6-68:14:55.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42801,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42801,18.63,0.06,0.0533,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3389, RA-DEC 04:43:29.0-71:20:49.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42802,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42802,18.63,0.06,0.0533,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4180, RA-DEC 05:35:53.2-74:02:03.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42803,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42803,18.63,0.06,0.0533,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0096, RA-DEC 04:48:04.3-69:18:25.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42804,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42804,18.63,0.06,0.0533,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0490, RA-DEC 04:57:43.2-66:48:07.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42805,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42805,18.63,0.06,0.0533,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0686, RA-DEC 05:01:31.1-67:47:18.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42806,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42806,18.63,0.06,0.0533,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0595, RA-DEC 04:59:46.5-69:11:40.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42807,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42807,18.63,0.06,0.0533,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0458, RA-DEC 04:56:54.9-70:25:49.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42808,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42808,18.63,0.06,0.0533,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0519, RA-DEC 04:58:18.8-69:07:01.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42809,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42809,18.63,0.06,0.0533,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1929, RA-DEC 05:25:23.0-69:00:56.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42810,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42810,18.63,0.06,0.0533,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4210, RA-DEC 05:37:26.2-67:20:17.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42811,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42811,18.64,0.06,0.0533,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0279, RA-DEC 04:53:16.8-69:40:17.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42812,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42812,18.64,0.06,0.0533,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0804, RA-DEC 05:03:29.5-67:53:08.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42813,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42813,18.64,0.06,0.0534,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0803, RA-DEC 05:03:27.4-68:32:22.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42814,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42814,18.64,0.06,0.0534,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1065, RA-DEC 05:08:26.5-70:35:43.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42815,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42815,18.64,0.06,0.0534,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1552, RA-DEC 05:18:41.0-69:25:16.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42816,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42816,18.64,0.06,0.0534,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1411, RA-DEC 05:15:58.0-69:42:43.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42817,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42817,18.64,0.06,0.0534,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2788, RA-DEC 05:39:19.1-70:04:28.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42818,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42818,18.64,0.06,0.0534,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3193, RA-DEC 05:47:34.7-70:31:14.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42819,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42819,18.64,0.06,0.0534,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0853, RA-DEC 05:04:25.2-69:07:38.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42820,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42820,18.64,0.06,0.0534,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2154, RA-DEC 05:29:45.4-69:36:58.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42821,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42821,18.64,0.06,0.0534,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0207, RA-DEC 04:51:47.7-67:55:56.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42822,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42822,18.64,0.06,0.0534,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0145, RA-DEC 04:50:01.5-68:35:16.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42823,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42823,18.64,0.06,0.0534,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4186, RA-DEC 05:36:13.1-64:19:28.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42824,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42824,18.64,0.06,0.0534,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0488, RA-DEC 04:57:41.2-68:48:00.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42825,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42825,18.64,0.06,0.0534,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1525, RA-DEC 05:18:03.5-69:15:14.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42826,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42826,18.64,0.06,0.0535,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0139, RA-DEC 04:49:57.1-69:07:38.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42827,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42827,18.64,0.06,0.0535,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2230, RA-DEC 05:31:01.0-69:06:30.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42828,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42828,18.64,0.06,0.0535,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2220, RA-DEC 05:30:55.1-67:47:32.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42829,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42829,18.64,0.06,0.0535,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3751, RA-DEC 05:13:51.3-71:33:22.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42830,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42830,18.64,0.06,0.0535,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4175, RA-DEC 05:35:35.7-64:28:04.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42831,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42831,18.64,0.06,0.0535,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0982, RA-DEC 05:07:03.5-69:28:02.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42832,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42832,18.64,0.06,0.0535,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0031, RA-DEC 04:41:44.9-69:06:55.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42833,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42833,18.64,0.06,0.0535,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3419, RA-DEC 04:50:16.8-74:13:57.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42834,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42834,18.64,0.06,0.0535,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0256, RA-DEC 04:52:52.1-69:14:25.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42835,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42835,18.64,0.06,0.0535,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0833, RA-DEC 05:04:00.1-68:38:54.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42836,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42836,18.64,0.02,0.0535,10597,NULL,NULL,'V, V-K','LMC',NULL,'1995ApJ...452..195D',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42837,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42837,18.64,0.06,0.0535,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0101, RA-DEC 04:48:34.2-69:20:50.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42838,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42838,18.64,0.06,0.0535,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1544, RA-DEC 05:18:29.0-69:34:01.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42839,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42839,18.64,0.06,0.0535,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0848, RA-DEC 05:04:21.1-68:43:42.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42840,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42840,18.64,0.06,0.0536,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0721, RA-DEC 05:02:05.9-69:02:55.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42841,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42841,18.64,0.06,0.0536,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1765, RA-DEC 05:22:30.1-70:09:13.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42842,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42842,18.64,0.06,0.0536,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3385, RA-DEC 04:41:44.3-74:24:53.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42843,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42843,18.64,0.06,0.0536,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0109, RA-DEC 04:48:56.6-68:57:12.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42844,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42844,18.64,0.06,0.0536,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0134, RA-DEC 04:49:51.2-70:36:53.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42845,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42845,18.64,0.06,0.0536,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0266, RA-DEC 04:53:01.1-68:32:25.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42846,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42846,18.64,0.06,0.0536,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1933, RA-DEC 05:25:25.8-68:23:51.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42847,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42847,18.65,0.06,0.0536,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0200, RA-DEC 04:51:31.3-67:48:45.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42848,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42848,18.65,0.06,0.0536,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0076, RA-DEC 04:46:47.9-69:05:43.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42849,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42849,18.65,0.06,0.0536,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1781, RA-DEC 05:22:41.1-69:58:43.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42850,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42850,18.65,0.06,0.0536,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1784, RA-DEC 05:22:42.8-68:50:57.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42851,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42851,18.65,0.06,0.0537,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3397, RA-DEC 04:46:22.0-69:14:12.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42852,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42852,18.65,0.06,0.0537,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0080, RA-DEC 04:47:11.1-67:40:02.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42853,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42853,18.65,0.1,0.0537,10597,NULL,NULL,NULL,'LMC',NULL,'1993AJ....106..734G',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42854,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42854,18.65,0.1,0.0537,10597,NULL,NULL,'NGC 1866','LMC',NULL,'2003A&A...410..887G',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42855,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42855,18.65,0.07,0.0537,10597,NULL,NULL,'73, IR','LMC',NULL,'1986MNRAS.218..223C',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42856,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42856,18.65,0.1,0.0537,10597,NULL,NULL,'57, J, PL','LMC',NULL,'1987ApJ...321..162W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42857,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42857,18.65,0.06,0.0537,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0215, RA-DEC 04:52:05.6-69:15:20.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42858,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42858,18.65,0.06,0.0537,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3411, RA-DEC 04:49:08.5-72:36:48.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42859,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42859,18.65,0.06,0.0537,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3702, RA-DEC 05:12:30.3-72:00:17.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42860,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42860,18.65,0.06,0.0538,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0277, RA-DEC 04:53:15.5-68:16:36.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42861,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42861,18.65,0.06,0.0538,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2006, RA-DEC 05:26:44.4-70:19:29.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42862,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42862,18.65,0.06,0.0538,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2531, RA-DEC 05:36:04.0-69:31:27.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42863,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42863,18.65,0.06,0.0538,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0885, RA-DEC 05:05:10.1-68:09:50.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42864,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42864,18.65,0.06,0.0538,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1844, RA-DEC 05:23:45.6-71:03:09.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42865,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42865,18.65,0.06,0.0538,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0335, RA-DEC 04:54:38.1-68:04:21.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42866,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42866,18.66,0.06,0.0538,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0351, RA-DEC 04:54:52.7-69:14:02.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42867,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42867,18.66,0.06,0.0539,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3108, RA-DEC 05:45:28.1-69:17:12.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42868,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42868,18.66,0.06,0.0539,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3625, RA-DEC 05:08:58.3-73:51:33.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42869,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42869,18.66,0.06,0.0539,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0593, RA-DEC 04:59:42.8-68:16:45.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42870,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42870,18.66,0.06,0.0539,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1716, RA-DEC 05:21:54.5-67:46:27.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42871,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42871,18.66,0.06,0.0539,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0342, RA-DEC 04:54:44.9-69:31:39.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42872,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42872,18.66,0.06,0.0539,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0154, RA-DEC 04:50:17.8-68:53:56.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42873,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,NULL,42873,18.65,0.07,0.0539,10597,NULL,NULL,'1849, VI, individual dereddening, Sandage et al. 2004 PL','LMC',NULL,'2012AJ....144..106H',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42874,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42874,18.66,0.06,0.0539,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0122, RA-DEC 04:49:21.0-67:52:18.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42875,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42875,18.66,0.06,0.0539,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1192, RA-DEC 05:11:19.8-68:33:07.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42876,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42876,18.66,0.06,0.0539,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2063, RA-DEC 05:27:49.8-69:03:58.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42877,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42877,18.66,0.06,0.054,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3401, RA-DEC 04:47:44.8-72:32:03.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42878,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:15','1',NULL,'R',42878,18.66,0.06,0.054,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1302, RA-DEC 05:14:07.5-69:01:13.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42879,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:16','1',NULL,'R',42879,18.66,0.06,0.054,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1555, RA-DEC 05:18:44.7-68:57:14.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42880,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:16','1',NULL,'R',42880,18.66,0.06,0.054,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3573, RA-DEC 05:05:24.0-74:02:06.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42881,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:16','1',NULL,'R',42881,18.66,0.06,0.054,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4390, RA-DEC 05:47:05.1-73:24:36.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42882,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:16','1',NULL,'R',42882,18.66,0.06,0.054,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0019, RA-DEC 04:39:03.3-68:18:35.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42883,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:16','1',NULL,'R',42883,18.66,0.06,0.054,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1961, RA-DEC 05:25:43.7-68:51:35.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42884,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:16','1',NULL,'R',42884,18.66,0.06,0.054,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2979, RA-DEC 05:42:16.6-70:36:12.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42885,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:16','1',NULL,NULL,42885,18.66,0.15,0.054,10597,NULL,NULL,'VIK, avg of 3PL, 3PL(Z), 3PLC','LMC',NULL,'2000A&A...356..849G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42886,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:16','1',NULL,'R',42886,18.66,0.06,0.054,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3380, RA-DEC 04:35:32.9-74:33:46.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42887,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:16','1',NULL,'R',42887,18.66,0.06,0.054,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4150, RA-DEC 05:34:07.5-67:18:58.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42888,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:16','1',NULL,'R',42888,18.66,0.06,0.054,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0422, RA-DEC 04:56:11.6-70:56:06.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42889,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:16','1',NULL,'R',42889,18.66,0.06,0.054,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1713, RA-DEC 05:21:51.9-71:07:29.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42890,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:16','1',NULL,'R',42890,18.66,0.06,0.0541,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0170, RA-DEC 04:50:49.0-69:07:04.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42891,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:16','1',NULL,'R',42891,18.66,0.06,0.0541,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0689, RA-DEC 05:01:32.4-70:17:29.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42892,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:16','1',NULL,'R',42892,18.66,0.06,0.0541,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4140, RA-DEC 05:33:30.8-72:11:31.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42893,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:16','1',NULL,'R',42893,18.67,0.06,0.0541,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0182, RA-DEC 04:51:05.2-66:50:58.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42894,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:16','1',NULL,'R',42894,18.67,0.06,0.0541,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1238, RA-DEC 05:12:28.7-68:33:54.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42895,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:16','1',NULL,'R',42895,18.67,0.06,0.0541,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3100, RA-DEC 05:45:08.5-69:39:01.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42896,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:16','1',NULL,'R',42896,18.67,0.06,0.0541,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0718, RA-DEC 05:02:02.8-68:15:06.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42897,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:16','1',NULL,'R',42897,18.67,0.06,0.0541,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0958, RA-DEC 05:06:33.7-70:44:52.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42898,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:16','1',NULL,'R',42898,18.67,0.06,0.0541,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0345, RA-DEC 04:54:49.6-69:14:29.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42899,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:16','1',NULL,'R',42899,18.67,0.06,0.0541,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1424, RA-DEC 05:16:03.8-69:14:52.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42900,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:16','1',NULL,'R',42900,18.67,0.06,0.0541,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0517, RA-DEC 04:58:16.6-70:37:47.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42901,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:16','1',NULL,'R',42901,18.67,0.06,0.0541,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4087, RA-DEC 05:30:46.4-63:58:56.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42902,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:16','1',NULL,'R',42902,18.67,0.06,0.0542,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1014, RA-DEC 05:07:26.9-70:41:41.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42903,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:16','1',NULL,'R',42903,18.67,0.06,0.0542,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1342, RA-DEC 05:15:03.2-69:25:24.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42904,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:16','1',NULL,'R',42904,18.67,0.06,0.0542,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0682, RA-DEC 05:01:20.2-67:28:01.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42905,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:16','1',NULL,'R',42905,18.67,0.06,0.0542,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0716, RA-DEC 05:02:00.9-68:55:22.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42906,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:16','1',NULL,'R',42906,18.67,0.06,0.0542,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2335, RA-DEC 05:32:58.4-69:51:55.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42907,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:16','1',NULL,'R',42907,18.67,0.06,0.0542,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1156, RA-DEC 05:10:22.4-67:08:46.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42908,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:16','1',NULL,'R',42908,18.67,0.06,0.0542,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3463, RA-DEC 04:55:08.3-72:57:46.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42909,'Cepheids','2016-12-15 15:14:10','2016-12-16 11:19:16','1',NULL,'R',42909,18.67,0.06,0.0542,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3381, RA-DEC 04:37:03.7-74:58:25.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42910,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42910,18.67,0.06,0.0542,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4216, RA-DEC 05:37:42.3-66:28:43.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42911,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42911,18.67,0.06,0.0542,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1603, RA-DEC 05:19:40.4-69:34:19.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42912,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42912,18.67,0.06,0.0542,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0251, RA-DEC 04:52:48.6-69:12:31.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42913,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42913,18.67,0.06,0.0543,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0098, RA-DEC 04:48:29.1-70:28:43.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42914,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42914,18.67,0.06,0.0543,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0940, RA-DEC 05:06:07.1-70:26:08.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42915,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42915,18.67,0.06,0.0543,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1770, RA-DEC 05:22:32.0-67:53:20.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42916,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42916,18.67,0.06,0.0543,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4451, RA-DEC 05:49:40.1-67:00:27.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42917,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42917,18.67,0.06,0.0543,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0357, RA-DEC 04:54:55.7-68:56:25.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42918,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42918,18.67,0.06,0.0543,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1117, RA-DEC 05:09:22.7-69:07:17.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42919,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42919,18.68,0.06,0.0543,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0094, RA-DEC 04:48:00.9-69:19:14.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42920,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42920,18.68,0.06,0.0543,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3668, RA-DEC 05:11:04.6-63:26:02.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42921,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42921,18.68,0.06,0.0544,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0239, RA-DEC 04:52:32.0-69:44:20.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42922,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42922,18.68,0.06,0.0544,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0212, RA-DEC 04:51:59.9-68:53:27.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42923,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42923,18.68,0.06,0.0545,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2222, RA-DEC 05:30:56.4-71:14:58.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42924,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42924,18.68,0.06,0.0545,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0123, RA-DEC 04:49:22.4-69:09:01.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42925,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42925,18.68,0.06,0.0545,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1608, RA-DEC 05:19:46.9-70:15:30.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42926,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42926,18.68,0.06,0.0545,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4221, RA-DEC 05:38:01.5-72:33:01.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42927,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42927,18.68,0.09,0.0545,10597,NULL,NULL,'NGC 1866, HV 12203, New PL','LMC',NULL,'2006MmSAI..77..261S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42928,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,42928,18.68,0.07,0.0545,10597,NULL,NULL,'VK (CPR)','LMC',NULL,'1994A&A...285..819D',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42929,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42929,18.68,0.06,0.0545,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4224, RA-DEC 05:38:09.0-66:52:52.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42930,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42930,18.68,0.06,0.0546,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0871, RA-DEC 05:04:47.6-68:35:22.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42931,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42931,18.68,0.06,0.0546,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3391, RA-DEC 04:44:24.4-72:35:47.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42932,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42932,18.69,0.06,0.0546,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0229, RA-DEC 04:52:19.4-69:23:01.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42933,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42933,18.69,0.06,0.0546,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2231, RA-DEC 05:31:01.7-69:06:21.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42934,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42934,18.69,0.06,0.0546,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1588, RA-DEC 05:19:28.0-69:11:31.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42935,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42935,18.69,0.06,0.0546,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3103, RA-DEC 05:45:20.7-69:39:05.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42936,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42936,18.69,0.06,0.0546,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1282, RA-DEC 05:13:46.5-69:08:47.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42937,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42937,18.69,0.06,0.0547,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2769, RA-DEC 05:39:01.0-69:51:35.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42938,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42938,18.69,0.06,0.0547,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4342, RA-DEC 05:44:35.3-67:17:39.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42939,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42939,18.69,0.06,0.0547,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2307, RA-DEC 05:32:23.4-68:59:43.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42940,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42940,18.69,0.06,0.0547,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0349, RA-DEC 04:54:52.3-69:14:40.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42941,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42941,18.69,0.06,0.0547,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3016, RA-DEC 05:42:54.0-69:44:01.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42942,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42942,18.69,0.06,0.0547,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3079, RA-DEC 05:44:36.3-72:09:09.0','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42943,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42943,18.69,0.06,0.0547,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3379, RA-DEC 04:35:30.2-72:31:39.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42944,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,42944,18.69,0.08,0.0547,10597,NULL,NULL,'VK (CPL)','LMC',NULL,'1994A&A...285..819D',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42945,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,42945,18.69,0.06,0.0547,10597,NULL,NULL,'10, W, Period-Wesenheit, Z1','LMC',NULL,'2007A&A...476..863F',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42946,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42946,18.69,0.06,0.0547,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0017, RA-DEC 04:38:56.8-69:41:18.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42947,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42947,18.69,0.06,0.0547,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1616, RA-DEC 05:19:59.9-69:10:25.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42948,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42948,18.69,0.06,0.0547,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0270, RA-DEC 04:53:09.3-68:12:40.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42949,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42949,18.69,0.06,0.0548,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0254, RA-DEC 04:52:50.4-68:30:36.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42950,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42950,18.69,0.06,0.0548,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0235, RA-DEC 04:52:26.6-69:10:10.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42951,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42951,18.69,0.06,0.0548,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0324, RA-DEC 04:54:21.7-69:13:42.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42952,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42952,18.69,0.06,0.0548,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1144, RA-DEC 05:10:02.0-69:27:18.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42953,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42953,18.7,0.06,0.0548,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2880, RA-DEC 05:40:34.4-69:35:54.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42954,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42954,18.7,0.06,0.0548,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0203, RA-DEC 04:51:38.0-68:27:21.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42955,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42955,18.7,0.06,0.0549,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0217, RA-DEC 04:52:06.2-69:46:09.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42956,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42956,18.7,0.06,0.0549,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2737, RA-DEC 05:38:37.1-69:34:22.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42957,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42957,18.7,0.06,0.0549,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1010, RA-DEC 05:07:25.9-70:48:36.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42958,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42958,18.7,0.06,0.0549,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1985, RA-DEC 05:26:11.9-69:19:41.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42959,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42959,18.7,0.06,0.055,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1197, RA-DEC 05:11:29.8-69:38:08.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42960,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,42960,18.7,NULL,0.055,10597,NULL,NULL,'Hipparcos','LMC',NULL,'1998MNRAS.298L..43F',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42961,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42961,18.7,0.02,0.055,10597,NULL,NULL,'BVRI+','LMC',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42962,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,42962,18.7,0.1,0.055,10597,NULL,NULL,NULL,'LMC',NULL,'1997MNRAS.286L...1F',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42963,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42963,18.7,NULL,0.055,10597,NULL,NULL,'K','LMC',NULL,'1999ASPC..167..198H',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42964,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,42964,18.7,0.16,0.055,10597,NULL,NULL,'TP','LMC',NULL,'2000ApJ...533..215C',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42965,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,42965,18.7,NULL,0.055,10597,NULL,NULL,'HV 00899','LMC',NULL,'1987A&A...175...30I',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42966,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,42966,18.7,NULL,0.055,10597,NULL,NULL,'HV 00909','LMC',NULL,'1987A&A...175...30I',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42967,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42967,18.7,0.06,0.055,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0281, RA-DEC 04:53:21.9-69:09:20.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42968,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42968,18.7,0.06,0.055,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3875, RA-DEC 05:19:50.4-66:02:54.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42969,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42969,18.7,0.06,0.0551,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2727, RA-DEC 05:38:31.0-69:29:28.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42970,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42970,18.7,0.06,0.0551,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1804, RA-DEC 05:23:01.6-71:45:25.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42971,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42971,18.7,0.06,0.0551,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3421, RA-DEC 04:50:32.4-64:44:08.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42972,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42972,18.71,0.06,0.0551,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0249, RA-DEC 04:52:47.7-68:20:55.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42973,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42973,18.71,0.06,0.0551,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2644, RA-DEC 05:37:28.4-69:11:42.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42974,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42974,18.71,0.06,0.0551,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1567, RA-DEC 05:18:58.8-69:06:32.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42975,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42975,18.71,0.06,0.0552,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2077, RA-DEC 05:28:11.4-69:28:58.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42976,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42976,18.71,0.06,0.0552,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1757, RA-DEC 05:22:28.8-70:09:23.1','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42977,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42977,18.71,0.06,0.0552,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1532, RA-DEC 05:18:08.6-69:45:22.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42978,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42978,18.71,0.06,0.0552,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0480, RA-DEC 04:57:27.2-69:21:18.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42979,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42979,18.71,0.06,0.0552,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3656, RA-DEC 05:10:36.7-65:33:31.9','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42980,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42980,18.71,0.06,0.0553,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3138, RA-DEC 05:46:12.8-70:16:00.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42981,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42981,18.71,0.06,0.0553,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3384, RA-DEC 04:40:55.2-72:34:06.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42982,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42982,18.72,0.06,0.0554,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2432, RA-DEC 05:34:27.1-71:18:43.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42983,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42983,18.72,0.06,0.0554,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3387, RA-DEC 04:42:57.2-66:10:13.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42984,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42984,18.72,0.06,0.0554,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4608, RA-DEC 06:14:26.2-79:10:54.2','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42985,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42985,18.72,0.06,0.0554,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1575, RA-DEC 05:19:09.2-71:48:42.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42986,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42986,18.72,0.06,0.0554,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2718, RA-DEC 05:38:19.6-69:09:19.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42987,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42987,18.72,0.06,0.0555,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3378, RA-DEC 04:24:03.5-69:45:35.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42988,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42988,18.72,0.06,0.0555,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-1889, RA-DEC 05:24:34.9-70:35:54.7','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42989,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42989,18.72,0.02,0.0555,10597,NULL,NULL,'BVRI','LMC',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42990,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,42990,18.72,0.09,0.0555,10597,NULL,NULL,NULL,'LMC',NULL,'1999PASP..111..775F',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42991,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42991,18.72,0.06,0.0555,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-2489, RA-DEC 05:35:30.3-69:01:24.6','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42992,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42992,18.72,0.06,0.0555,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-4230, RA-DEC 05:38:23.4-65:48:53.3','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42993,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42993,18.72,0.06,0.0555,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3291, RA-DEC 05:53:32.1-69:04:50.5','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42994,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42994,18.73,0.06,0.0556,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-3848, RA-DEC 05:18:18.1-66:37:36.4','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42995,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42995,18.73,0.06,0.0556,10597,NULL,NULL,'1, VI, OGLE-LMC-CEP-0655, RA-DEC 05:00:55.9-68:26:20.8','LMC',NULL,'2016AcA....66..149J',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42996,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,42996,18.73,0.05,0.0557,10597,NULL,NULL,'21, JHK, PLC','LMC',NULL,'1986MNRAS.222..449L',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42997,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,42997,18.74,0.06,0.056,10597,NULL,NULL,'21, JHK, PL','LMC',NULL,'1986MNRAS.222..449L',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42998,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',42998,18.74,0.13,0.056,10597,NULL,NULL,'PLC(K)','LMC',NULL,'1999ASPC..167..275M',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42999,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,42999,18.74,0.24,0.056,10597,NULL,NULL,'7, V','LMC',NULL,'1998ApJ...492..110M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43000,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43000,18.74,0.13,0.056,10597,NULL,NULL,'K, PLC','LMC',NULL,'1999ApJ...512..711B',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43001,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43001,18.77,0.24,0.0568,10597,NULL,NULL,'7, I','LMC',NULL,'1998ApJ...492..110M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43002,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43002,18.82,0.07,0.0581,10597,NULL,NULL,'14, IV, V','LMC',NULL,'1985ApJ...288..182V',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43003,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43003,18.82,NULL,0.0581,10597,NULL,NULL,'B','LMC',NULL,'1999ApJ...522..250S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43004,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43004,18.83,NULL,0.0583,10597,NULL,NULL,'V','LMC',NULL,'1999ApJ...522..250S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43005,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43005,18.85,0.08,0.0588,10597,NULL,NULL,'1849, VI, area-averaged dereddening, Sandage et al. 2004 PL','LMC',NULL,'2012AJ....144..106H',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43006,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43006,18.86,0.36,0.0592,10597,NULL,NULL,'7, B','LMC',NULL,'1998ApJ...492..110M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43007,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43007,18.87,0.07,0.0594,10597,NULL,NULL,'12, V','LMC',NULL,'2004ASPC..310...95B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43008,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43008,18.9,NULL,0.0603,10597,NULL,NULL,'HV 02257','LMC',NULL,'1987A&A...175...30I',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43009,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43009,19.01,0.18,0.0635,10597,NULL,NULL,'HV 2405, 1, VK(W)','LMC',NULL,'2013yCat..35509070G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43010,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43010,19.07,0.15,0.0652,10597,NULL,NULL,'HV 00899, VRI','LMC',NULL,'1993MNRAS.265..184G',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43011,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43011,19.09,0.15,0.0657,10597,NULL,NULL,'HV 02257, VRI','LMC',NULL,'1993MNRAS.265..184G',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43012,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43012,19.12,0.03,0.0667,10597,73,NULL,'Cepheids periods Gaussian ','LMC',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43013,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43013,19.3,0.03,0.0724,10597,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian ','LMC',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43014,'Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43014,19.48,0.03,0.0787,10597,73,NULL,'Cepheids magnitudes Gaussian ','LMC',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43015,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43015,17.88,0.12,0.0377,10597,NULL,NULL,'KMHK854','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43016,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43016,17.9,NULL,0.038,10597,NULL,NULL,'NGC 2210, Photographic, M92 m-M = 14.36','LMC',NULL,'1986A&AS...64..189A',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43017,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43017,17.99,0.02,0.0396,10597,NULL,NULL,'SL372','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43018,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43018,18.08,0.01,0.0413,10597,NULL,NULL,'BSDL2771','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43019,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43019,18.08,0.12,0.0413,10597,NULL,NULL,'DES001SC08','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43020,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43020,18.1,0.01,0.0417,10597,NULL,NULL,'SL511','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43021,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43021,18.1,0.06,0.0417,10597,NULL,NULL,'SL701','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43022,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43022,18.1,0.1,0.0417,10597,NULL,NULL,'NGC 1841','LMC',NULL,'1987MNRAS.229....1A',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43023,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43023,18.1,0.3,0.0417,10597,NULL,NULL,'ESO 356-SC 005, Fornax Dwarf Cluster 4, Hodge 4','LMC',NULL,'1986ApJS...60..893M',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43024,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43024,18.1,NULL,0.0417,10597,NULL,NULL,'Hodge 11','LMC',NULL,'1984MNRAS.211..695A',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43025,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43025,18.1,NULL,0.0417,10597,NULL,NULL,'NGC 2210','LMC',NULL,'1985A&A...150L..12A',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43026,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43026,18.12,NULL,0.0421,10597,NULL,NULL,'ESO 356-SC 005, Fornax Dwarf Cluster 4, Hodge 4','LMC',NULL,'1988ApJ...331..261M',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43027,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43027,18.13,0.01,0.0423,10597,NULL,NULL,'LW250','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43028,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43028,18.14,0.14,0.0425,10597,NULL,NULL,'DES001SC27','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43029,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43029,18.17,0.02,0.0431,10597,NULL,NULL,'SL525','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43030,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43030,18.17,0.01,0.0431,10597,NULL,NULL,'SL604','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43031,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43031,18.17,NULL,0.0431,10597,NULL,NULL,'NGC 1831','LMC',NULL,'1988ApJ...331..261M',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43032,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43032,18.19,0.1,0.0435,10597,NULL,NULL,'DES001SC09','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43033,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43033,18.2,0.12,0.0437,10597,NULL,NULL,'KMHK1278','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43034,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43034,18.2,0.06,0.0437,10597,NULL,NULL,'OHSC20','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43035,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43035,18.2,0.13,0.0437,10597,NULL,NULL,'SL726','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43036,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43036,18.2,0.2,0.0437,10597,NULL,NULL,NULL,'LMC',NULL,'1984ApJ...285L..53S',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43037,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43037,18.2,0.2,0.0437,10597,NULL,NULL,'NGC 2213','LMC',NULL,'1987AJ.....93.1081G',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43038,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43038,18.2,NULL,0.0437,10597,NULL,NULL,'NGC 2010,','LMC',NULL,'1988ApJ...331..261M',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43039,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43039,18.21,0.13,0.0439,10597,NULL,NULL,'DES001SC03','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43040,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43040,18.22,0.05,0.0441,10597,NULL,NULL,'DES001SC01','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43041,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43041,18.22,0.16,0.0441,10597,NULL,NULL,'DES001SC02','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43042,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43042,18.22,0.1,0.0441,10597,NULL,NULL,'DES001SC04','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43043,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43043,18.22,0.01,0.0441,10597,NULL,NULL,'E2','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43044,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43044,18.22,0.01,0.0441,10597,NULL,NULL,'KMHK1593','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43045,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43045,18.23,0.09,0.0443,10597,NULL,NULL,'NGC 1831','LMC',NULL,'2007A&A...462..139K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43046,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43046,18.24,0.02,0.0445,10597,NULL,NULL,'DES001SC11','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43047,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43047,18.24,0.03,0.0445,10597,NULL,NULL,'LW319','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43048,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43048,18.24,0.04,0.0445,10597,NULL,NULL,'NGC 2121,','LMC',NULL,'2007A&A...462..139K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43049,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43049,18.25,0.1,0.0447,10597,NULL,NULL,'DES001SC26','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43050,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43050,18.25,0.07,0.0447,10597,NULL,NULL,'H88-258','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43051,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43051,18.25,0.01,0.0447,10597,NULL,NULL,'SL214','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43052,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43052,18.25,0.02,0.0447,10597,NULL,NULL,'SL529','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43053,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43053,18.25,NULL,0.0447,10597,NULL,NULL,'NGC 1711','LMC',NULL,'1988ApJ...331..261M',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43054,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43054,18.26,0.04,0.0449,10597,NULL,NULL,'DES001SC12','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43055,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43055,18.26,0.02,0.0449,10597,NULL,NULL,'DES001SC17','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43056,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43056,18.27,0.06,0.0451,10597,NULL,NULL,'DES001SC18','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43057,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43057,18.27,0.01,0.0451,10597,NULL,NULL,'NGC 1900                      ','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43058,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43058,18.27,0.2,0.0451,10597,NULL,NULL,'OHSC27','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43059,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43059,18.27,0.01,0.0451,10597,NULL,NULL,'SL448','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43060,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43060,18.27,0.06,0.0451,10597,NULL,NULL,'NGC 2249','LMC',NULL,'2007A&A...462..139K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43061,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43061,18.29,0.1,0.0455,10597,NULL,NULL,'DES001SC13','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43062,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43062,18.29,0.2,0.0455,10597,NULL,NULL,'OHSC22','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43063,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43063,18.29,0.01,0.0455,10597,NULL,NULL,'OHSC28','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43064,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43064,18.29,0.02,0.0455,10597,NULL,NULL,'SL273','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43065,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43065,18.3,0.2,0.0457,10597,NULL,NULL,'ESO 120-SC 008, E2, C0535-618','LMC',NULL,'1987A&AS...67..373G',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43066,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43066,18.3,0.25,0.0457,10597,NULL,NULL,NULL,'LMC',NULL,'1987ApJ...320..626M',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43067,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43067,18.3,NULL,0.0457,10597,NULL,NULL,'NGC 2210, Photographic, E(B-V) = 0.06','LMC',NULL,'1986A&AS...64..189A',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43068,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43068,18.3,0.3,0.0457,10597,NULL,NULL,NULL,'LMC',NULL,'1986AJ.....92...48C',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43069,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43069,18.3,0.01,0.0457,10597,NULL,NULL,'DES001SC19','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43070,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43070,18.3,0.09,0.0457,10597,NULL,NULL,'DES001SC21','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43071,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43071,18.3,0.04,0.0457,10597,NULL,NULL,'DES001SC24','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43072,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43072,18.3,0.01,0.0457,10597,NULL,NULL,'SL677','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43073,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43073,18.3,0.18,0.0457,10597,NULL,NULL,'SL724','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43074,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43074,18.31,NULL,0.0459,10597,NULL,NULL,'LW 79','LMC',NULL,'1988ApJ...331..261M',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43075,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43075,18.31,0.16,0.0459,10597,NULL,NULL,'NGC 2005, O91 abundance','LMC',NULL,'1998MNRAS.300..665O',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43076,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43076,18.31,0.2,0.0459,10597,NULL,NULL,'DES001SC16','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43077,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43077,18.32,0.04,0.0461,10597,NULL,NULL,'NGC 2155,','LMC',NULL,'2007A&A...462..139K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43078,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43078,18.32,0.07,0.0461,10597,NULL,NULL,'SL 663','LMC',NULL,'2007A&A...462..139K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43079,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43079,18.32,0.01,0.0461,10597,NULL,NULL,'LW208','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43080,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43080,18.32,0.05,0.0461,10597,NULL,NULL,'LW272','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43081,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43081,18.33,0.05,0.0463,10597,NULL,NULL,'NGC 1866, Main Sequence Fitting','LMC',NULL,'2001ApJ...560L.139W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43082,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43082,18.33,0.08,0.0463,10597,NULL,NULL,'NGC 1866','LMC',NULL,'2003ApJ...588..801S',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43083,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43083,18.33,0.06,0.0463,10597,NULL,NULL,'NGC 1868','LMC',NULL,'2007A&A...462..139K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43084,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43084,18.33,0.02,0.0463,10597,NULL,NULL,'BSDL2976','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43085,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43085,18.33,0.1,0.0463,10597,NULL,NULL,'KMHK1195','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43086,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43086,18.33,0.12,0.0463,10597,NULL,NULL,'LW260','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43087,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43087,18.33,0.01,0.0463,10597,NULL,NULL,'SL738','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43088,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43088,18.34,0.02,0.0466,10597,NULL,NULL,'SL696','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43089,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43089,18.35,NULL,0.0468,10597,NULL,NULL,'NGC 1856','LMC',NULL,'2015MNRAS.450.3750M',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43090,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43090,18.35,NULL,0.0468,10597,NULL,NULL,'10 kpc tidal stream at 13.5 deg. N of center','LMC',NULL,'2016MNRAS.459..239M',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43091,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43091,18.35,NULL,0.0468,10597,NULL,NULL,'NGC 1856','LMC',NULL,'2015MNRAS.453.2637D',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43092,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43092,18.35,0.05,0.0468,10597,NULL,NULL,'Tile 8.8, Subregion G3, RA = 90.64 deg, Dec = -66.16 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43093,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43093,18.35,0.05,0.0468,10597,NULL,NULL,'Tile 8.8, Subregion G4, RA = 90.55 deg, Dec = -65.81 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43094,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43094,18.35,0.08,0.0468,10597,NULL,NULL,'NGC 2162,','LMC',NULL,'2007A&A...462..139K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43095,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43095,18.36,0.01,0.047,10597,NULL,NULL,'NGC2193','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43096,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43096,18.36,0.03,0.047,10597,NULL,NULL,'NGC 2213','LMC',NULL,'2014ApJ...797...35G',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43097,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43097,18.37,0.1,0.0472,10597,NULL,NULL,'NGC 1856','LMC',NULL,'2007A&A...462..139K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43098,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43098,18.37,0.03,0.0472,10597,NULL,NULL,'NGC 1987, Padova fit','LMC',NULL,'2011ApJ...737....3G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43099,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43099,18.37,0.03,0.0472,10597,NULL,NULL,'NGC 2173','LMC',NULL,'2014ApJ...797...35G',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43100,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43100,18.37,0.03,0.0472,10597,NULL,NULL,'NGC 2203','LMC',NULL,'2014ApJ...797...35G',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43101,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43101,18.37,0.01,0.0472,10597,NULL,NULL,'ESO121SC03','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43102,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43102,18.37,0.04,0.0472,10597,NULL,NULL,'KMHK1391','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43103,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43103,18.37,0.16,0.0472,10597,NULL,NULL,'LW230','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43104,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43104,18.37,0.01,0.0472,10597,NULL,NULL,'OHSC10','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43105,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43105,18.37,0.01,0.0472,10597,NULL,NULL,'SL720','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43106,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43106,18.38,0.05,0.0473,10597,NULL,NULL,'Tile 8.8, Subregion G4, RA = 90.55 deg, Dec = -65.81 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43107,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43107,18.38,NULL,0.0474,10597,NULL,NULL,'NGC 1978','LMC',NULL,'2009A&A...502..913L',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43108,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43108,18.38,NULL,0.0474,10597,NULL,NULL,'NGC 1978, Padua','LMC',NULL,'2007AJ....133.2053M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43109,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43109,18.38,0.05,0.0474,10597,NULL,NULL,'Tile 8.8, Subregion G3, RA = 90.64 deg, Dec = -66.16 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43110,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43110,18.38,0.04,0.0474,10597,NULL,NULL,'Tile 8.8, Subregion G8, RA = 89.73 deg, Dec = -65.84 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43111,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43111,18.38,0.16,0.0474,10597,NULL,NULL,'NGC 2019, O91 abundance','LMC',NULL,'1998MNRAS.300..665O',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43112,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43112,18.38,0.06,0.0474,10597,NULL,NULL,'Tile 8.8, Subregion G2, RA = 90.73 deg, Dec = -66.51 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43113,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43113,18.38,0.05,0.0474,10597,NULL,NULL,'Tile 8.8, Subregion G6, RA = 89.90 deg, Dec = -66.54 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43114,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43114,18.38,0.02,0.0474,10597,NULL,NULL,'NGC 1987, Teramo fit','LMC',NULL,'2011ApJ...737....3G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43115,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43115,18.38,0.02,0.0474,10597,NULL,NULL,'NGC 1987, Dartmouth fit','LMC',NULL,'2011ApJ...737....3G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43116,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43116,18.38,0.02,0.0474,10597,NULL,NULL,'NGC 1987, Mean fit','LMC',NULL,'2011ApJ...737....3G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43117,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43117,18.38,0.02,0.0474,10597,NULL,NULL,'ESO 057-SC 075, Dartmouth fit','LMC',NULL,'2011ApJ...737....3G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43118,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43118,18.38,0.02,0.0474,10597,NULL,NULL,'DES001SC20','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43119,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43119,18.38,0.04,0.0474,10597,NULL,NULL,'ESO119SC50','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43120,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43120,18.38,0.01,0.0474,10597,NULL,NULL,'LW323','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43121,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43121,18.38,0.01,0.0474,10597,NULL,NULL,'NGC2097','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43122,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43122,18.38,0.01,0.0474,10597,NULL,NULL,'SL354','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43123,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43123,18.38,0.04,0.0475,10597,NULL,NULL,'Tile 8.8, Subregion G12, RA = 88.93 deg, Dec = -65.87 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43124,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43124,18.38,0.06,0.0475,10597,NULL,NULL,'Tile 8.8, Subregion G2, RA = 90.73 deg, Dec = -66.51 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43125,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43125,18.38,0.04,0.0475,10597,NULL,NULL,'Tile 8.8, Subregion G7, RA = 89.81 deg, Dec = -66.19 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43126,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43126,18.39,0.05,0.0476,10597,NULL,NULL,'Tile 8.8, Subregion G6, RA = 89.90 deg, Dec = -66.54 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43127,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43127,18.39,0.01,0.0476,10597,NULL,NULL,'Tile 8.8, Subregion G11, RA = 89.00 deg, Dec = -66.22 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43128,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43128,18.39,0.05,0.0476,10597,NULL,NULL,'Tile 8.8, Subregion G1, RA = 90.83 deg, Dec = -66.86 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43129,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43129,18.39,0.04,0.0476,10597,NULL,NULL,'Tile 8.8, Subregion G7, RA = 89.81 deg, Dec = -66.19 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43130,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43130,18.39,0.02,0.0476,10597,NULL,NULL,'Tile 8.8, Subregion G10, RA = 89.08 deg, Dec = -66.57 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43131,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43131,18.39,NULL,0.0476,10597,NULL,NULL,'NGC 2257, Pont GC','LMC',NULL,'1999ApJ...527..199J',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43132,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43132,18.39,NULL,0.0476,10597,NULL,NULL,'NGC 1831, simple stellar populations','LMC',NULL,'2015arXiv150402571L',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43133,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43133,18.39,NULL,0.0476,10597,NULL,NULL,'NGC 1831, composite stellar populations','LMC',NULL,'2015arXiv150402571L',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43134,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43134,18.39,0.02,0.0476,10597,NULL,NULL,'BSDL3181','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43135,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43135,18.39,0.16,0.0476,10597,NULL,NULL,'DES001SC10','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43136,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43136,18.39,0.03,0.0477,10597,NULL,NULL,'Tile 8.8, Subregion G5, RA = 89.99 deg, Dec = -66.90 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43137,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43137,18.39,0.02,0.0477,10597,NULL,NULL,'Tile 8.8, Subregion G10, RA = 89.08 deg, Dec = -66.57 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43138,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43138,18.4,0.01,0.0479,10597,NULL,NULL,'SL768','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43139,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43139,18.4,0.1,0.0479,10597,NULL,NULL,'SL798','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43140,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43140,18.4,NULL,0.0479,10597,NULL,NULL,'NGC 1831','LMC',NULL,'2014ApJ...784..157L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43141,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43141,18.4,0.05,0.0479,10597,NULL,NULL,'NGC 1898','LMC',NULL,'1999AJ....117.2244O',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43142,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43142,18.4,0.16,0.0479,10597,NULL,NULL,'NGC 2005, S94 abundance','LMC',NULL,'1998MNRAS.300..665O',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43143,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43143,18.4,0.05,0.0479,10597,NULL,NULL,'Tile 8.8, Subregion G1, RA = 90.83 deg, Dec = -66.86 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43144,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43144,18.4,0.03,0.0479,10597,NULL,NULL,'Tile 8.8, Subregion G5, RA = 89.99 deg, Dec = -66.90 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43145,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43145,18.4,0.2,0.0479,10597,NULL,NULL,'LW 79','LMC',NULL,'1987ApJ...320..626M',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43146,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43146,18.4,NULL,0.0479,10597,NULL,NULL,'Hodge 11, M(V)HB = +0.6','LMC',NULL,'1984MNRAS.211..695A',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43147,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43147,18.4,NULL,0.0479,10597,NULL,NULL,'NGC 2249, NGC 2241','LMC',NULL,'1987AJ.....94..345J',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43148,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43148,18.4,NULL,0.0479,10597,NULL,NULL,'NGC 2157,','LMC',NULL,'1998AJ....115..592F',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43149,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43149,18.4,NULL,0.0479,10597,NULL,NULL,'NGC 2162,','LMC',NULL,'1989AJ.....98.1451V',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43150,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43150,18.4,NULL,0.0479,10597,NULL,NULL,'OGLE-LMC 0523','LMC',NULL,'2009arXiv0907.2890B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43151,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43151,18.4,0.2,0.0479,10597,NULL,NULL,'NGC 2004,','LMC',NULL,'1990PhDT.........5L',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43152,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43152,18.4,NULL,0.0479,10597,NULL,NULL,'NGC 1987','LMC',NULL,'2009A&A...497..755M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43153,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43153,18.4,NULL,0.0479,10597,NULL,NULL,'NGC 2108','LMC',NULL,'2009A&A...497..755M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43154,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43154,18.4,0.02,0.0479,10597,NULL,NULL,'NGC 2108, Dartmouth fit','LMC',NULL,'2011ApJ...737....3G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43155,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43155,18.4,0.02,0.0479,10597,NULL,NULL,'NGC 1806, Dartmouth fit','LMC',NULL,'2011ApJ...737....3G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43156,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43156,18.4,0.02,0.0479,10597,NULL,NULL,'NGC 1783, Dartmouth fit','LMC',NULL,'2011ApJ...737....3G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43157,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43157,18.41,0.08,0.0481,10597,NULL,NULL,'DES001SC07','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43158,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43158,18.41,0.1,0.0481,10597,NULL,NULL,'LW266','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43159,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43159,18.41,0.02,0.0481,10597,NULL,NULL,'SL649','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43160,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43160,18.41,0.04,0.0481,10597,NULL,NULL,'Tile 8.8, Subregion G8, RA = 89.73 deg, Dec = -65.84 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43161,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43161,18.41,0.01,0.0481,10597,NULL,NULL,'Tile 8.8, Subregion G11, RA = 89.00 deg, Dec = -66.22 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43162,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43162,18.41,0.04,0.0481,10597,NULL,NULL,'Tile 8.8, Subregion G12, RA = 88.93 deg, Dec = -65.87 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43163,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43163,18.41,0.02,0.0481,10597,NULL,NULL,'NGC 1846, Dartmouth fit','LMC',NULL,'2011ApJ...737....3G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43164,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43164,18.41,0.03,0.0481,10597,NULL,NULL,'NGC 1651','LMC',NULL,'2014ApJ...797...35G',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43165,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43165,18.42,0.2,0.0483,10597,NULL,NULL,'Y = 0.25, Z = 0.012','LMC',NULL,'1985MNRAS.217P..13W',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43166,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43166,18.42,0.03,0.0483,10597,NULL,NULL,'Tile 8.3, Subregion G6, RA = 76.19 deg, Dec = -66.44 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43167,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43167,18.42,0.05,0.0483,10597,NULL,NULL,'Tile 8.3, Subregion G11, RA = 75.50 deg, Dec = -66.05 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43168,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43168,18.42,NULL,0.0483,10597,NULL,NULL,'NGC 1466, Pont LMC','LMC',NULL,'1999ApJ...527..199J',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43169,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43169,18.42,0.03,0.0483,10597,NULL,NULL,'NGC 1846, Padova fit','LMC',NULL,'2011ApJ...737....3G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43170,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43170,18.42,0.03,0.0483,10597,NULL,NULL,'NGC 1718','LMC',NULL,'2014ApJ...797...35G',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43171,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43171,18.42,0.18,0.0483,10597,NULL,NULL,'DES001SC22','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43172,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43172,18.42,0.02,0.0483,10597,NULL,NULL,'KMHK1381','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43173,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43173,18.42,0.03,0.0483,10597,NULL,NULL,'LW276','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43174,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43174,18.42,0.01,0.0483,10597,NULL,NULL,'LW278','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43175,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43175,18.42,0.01,0.0483,10597,NULL,NULL,'LW332','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43176,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43176,18.42,0.01,0.0483,10597,NULL,NULL,'NGC1997','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43177,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43177,18.42,NULL,0.0484,10597,NULL,NULL,'avg 15 clusters','LMC',NULL,'2007A&A...462..139K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43178,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43178,18.43,NULL,0.0485,10597,NULL,NULL,'NGC 1978, BaSTI(2)','LMC',NULL,'2007AJ....133.2053M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43179,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43179,18.43,0.09,0.0485,10597,NULL,NULL,'NGC 2209','LMC',NULL,'2007A&A...462..139K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43180,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43180,18.43,0.05,0.0485,10597,NULL,NULL,'Tile 6.6, Subregion D1, RA = 85.64 deg, Dec = -69.92 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43181,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43181,18.43,0.03,0.0485,10597,NULL,NULL,'ESO 057-SC 075, Mean fit','LMC',NULL,'2011ApJ...737....3G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43182,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43182,18.43,0.01,0.0485,10597,NULL,NULL,'LW320','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43183,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43183,18.43,0.19,0.0485,10597,NULL,NULL,'SL540','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43184,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43184,18.44,0.05,0.0487,10597,NULL,NULL,'Tile 8.3, Subregion G4, RA = 77.20 deg, Dec = -65.77 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43185,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43185,18.44,NULL,0.0488,10597,NULL,NULL,'NGC 1856','LMC',NULL,'2015MNRAS.450.3054C',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43186,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43186,18.44,0.18,0.0488,10597,NULL,NULL,'DES001SC15','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43187,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43187,18.44,0.01,0.0488,10597,NULL,NULL,'Tile 6.6, Subregion D2, RA = 83.27 deg, Dec = -68.81 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43188,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43188,18.44,0.04,0.0488,10597,NULL,NULL,'Tile 8.3, Subregion G2, RA = 77.00 deg, Dec = -66.48 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43189,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43189,18.44,0.04,0.0488,10597,NULL,NULL,'Tile 8.3, Subregion G3, RA = 77.10 deg, Dec = -66.13 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43190,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43190,18.44,0.03,0.0488,10597,NULL,NULL,'Tile 8.3, Subregion G5, RA = 76.09 deg, Dec = -66.80 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43191,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43191,18.44,0.04,0.0488,10597,NULL,NULL,'Tile 8.3, Subregion G7, RA = 76.29 deg, Dec = -66.09 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43192,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43192,18.44,0.04,0.0488,10597,NULL,NULL,'Tile 8.3, Subregion G12, RA = 75.62 deg, Dec = -65.70 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43193,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43193,18.44,0.05,0.0488,10597,NULL,NULL,'Tile 8.3, Subregion G8, RA = 76.40 deg, Dec = -65.74 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43194,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43194,18.44,0.2,0.0488,10597,NULL,NULL,'NGC 1866, Y = 0.25, Z = 0.012','LMC',NULL,'1985MNRAS.217P..13W',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43195,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43195,18.44,NULL,0.0488,10597,NULL,NULL,'NGC 1806','LMC',NULL,'2009A&A...497..755M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43196,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43196,18.44,0.04,0.0488,10597,NULL,NULL,'Tile 8.3, Subregion G3, RA = 77.10 deg, Dec = -66.13 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43197,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43197,18.45,0.04,0.0489,10597,NULL,NULL,'Tile 8.3, Subregion G12, RA = 75.62 deg, Dec = -65.70 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43198,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43198,18.45,0.04,0.0489,10597,NULL,NULL,'Tile 8.3, Subregion G7, RA = 76.29 deg, Dec = -66.09 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43199,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43199,18.45,0.04,0.0489,10597,NULL,NULL,'Tile 8.3, Subregion G2, RA = 77.00 deg, Dec = -66.48 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43200,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43200,18.45,0.01,0.049,10597,NULL,NULL,'ESO 118- G 031, Reticulum                ','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43201,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43201,18.45,0.11,0.049,10597,NULL,NULL,'SL680','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43202,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43202,18.45,0.02,0.049,10597,NULL,NULL,'NGC 2108, Padova fit','LMC',NULL,'2011ApJ...737....3G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43203,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43203,18.45,0.03,0.049,10597,NULL,NULL,'NGC 2108, Mean fit','LMC',NULL,'2011ApJ...737....3G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43204,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43204,18.45,0.02,0.049,10597,NULL,NULL,'NGC 1806, Teramo fit','LMC',NULL,'2011ApJ...737....3G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43205,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43205,18.45,0.05,0.049,10597,NULL,NULL,'NGC 2005','LMC',NULL,'1999AJ....117.2244O',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43206,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43206,18.45,0.16,0.049,10597,NULL,NULL,'NGC 1898, O91 abundance','LMC',NULL,'1998MNRAS.300..665O',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43207,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43207,18.45,0.16,0.049,10597,NULL,NULL,'NGC 1898, S94 abundance','LMC',NULL,'1998MNRAS.300..665O',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43208,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43208,18.45,0.05,0.049,10597,NULL,NULL,'Tile 8.3, Subregion G8, RA = 76.40 deg, Dec = -65.74 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43209,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43209,18.45,0.03,0.049,10597,NULL,NULL,'Tile 8.3, Subregion G9, RA = 75.25 deg, Dec = -66.76 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43210,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43210,18.45,0.01,0.049,10597,NULL,NULL,'Tile 6.6, Subregion D2, RA = 83.27 deg, Dec = -68.81 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43211,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43211,18.45,0.05,0.049,10597,NULL,NULL,'Tile 8.3, Subregion G11, RA = 75.50 deg, Dec = -66.05 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43212,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43212,18.45,0.05,0.049,10597,NULL,NULL,'NGC 1846','LMC',NULL,'2009AJ....137.4988G',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43213,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43213,18.45,0.05,0.049,10597,NULL,NULL,'NGC 1846, Mean fit','LMC',NULL,'2011ApJ...737....3G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43214,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43214,18.45,NULL,0.049,10597,NULL,NULL,'NGC 1818','LMC',NULL,'2006A&A...452..155K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43215,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43215,18.45,NULL,0.049,10597,NULL,NULL,'NGC 1751','LMC',NULL,'2009A&A...497..755M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43216,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43216,18.45,NULL,0.049,10597,NULL,NULL,'NGC 1795','LMC',NULL,'2009A&A...497..755M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43217,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43217,18.45,0.03,0.049,10597,NULL,NULL,'Tile 8.3, Subregion G6, RA = 76.19 deg, Dec = -66.44 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43218,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43218,18.45,0.05,0.049,10597,NULL,NULL,'Tile 8.3, Subregion G1, RA = 76.90 deg, Dec = -66.83 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43219,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43219,18.45,0.03,0.049,10597,NULL,NULL,'ESO 057-SC 075, Padova fit','LMC',NULL,'2011ApJ...737....3G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43220,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43220,18.45,0.03,0.049,10597,NULL,NULL,'NGC 2154','LMC',NULL,'2014ApJ...797...35G',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43221,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43221,18.46,0.04,0.0491,10597,NULL,NULL,'Tile 8.3, Subregion G10, RA = 75.38 deg, Dec = -66.40 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43222,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43222,18.46,0.05,0.0491,10597,NULL,NULL,'Tile 6.6, Subregion D1, RA = 85.64 deg, Dec = -69.92 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43223,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43223,18.46,0.03,0.0491,10597,NULL,NULL,'Tile 8.3, Subregion G5, RA = 76.09 deg, Dec = -66.80 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43224,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43224,18.46,0.04,0.0492,10597,NULL,NULL,'NGC 1806, Mean fit','LMC',NULL,'2011ApJ...737....3G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43225,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43225,18.46,0.12,0.0492,10597,NULL,NULL,'Padova','LMC',NULL,'2009IAUS..256..391K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43226,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43226,18.46,NULL,0.0492,10597,NULL,NULL,'ESO 057-SC 075','LMC',NULL,'2009A&A...497..755M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43227,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43227,18.46,0.02,0.0492,10597,NULL,NULL,'ESO 057-SC 075, Teramo fit','LMC',NULL,'2011ApJ...737....3G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43228,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43228,18.46,NULL,0.0492,10597,NULL,NULL,'NGC 1783','LMC',NULL,'2009A&A...497..755M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43229,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43229,18.46,0.04,0.0492,10597,NULL,NULL,'NGC 1783, Mean fit','LMC',NULL,'2011ApJ...737....3G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43230,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43230,18.46,0.16,0.0492,10597,NULL,NULL,'NGC 1835, O91 abundance','LMC',NULL,'1998MNRAS.300..665O',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43231,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43231,18.46,0.16,0.0492,10597,NULL,NULL,'NGC 2019, S94 abundance','LMC',NULL,'1998MNRAS.300..665O',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43232,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43232,18.46,0.04,0.0492,10597,NULL,NULL,'Tile 8.3, Subregion G10, RA = 75.38 deg, Dec = -66.40 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43233,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43233,18.46,0.03,0.0492,10597,NULL,NULL,'Tile 8.3, Subregion G9, RA = 75.25 deg, Dec = -66.76 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43234,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43234,18.46,0.09,0.0492,10597,NULL,NULL,'Mean of 3 clusters','LMC',NULL,'1999ApJ...527..199J',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43235,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43235,18.46,0.11,0.0492,10597,NULL,NULL,'DES001SC05','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43236,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43236,18.46,0.01,0.0492,10597,NULL,NULL,'SL262','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43237,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43237,18.46,NULL,0.0493,10597,NULL,NULL,'Mean of 16 clusters','LMC',NULL,'2009A&A...497..755M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43238,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43238,18.47,0.01,0.0493,10597,NULL,NULL,'LMC center based on subregions near RA = 82.25 deg, Dec = -69.50 deg','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43239,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43239,18.47,NULL,0.0494,10597,NULL,NULL,'NGC 1978, BaSTI(1)','LMC',NULL,'2007AJ....133.2053M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43240,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43240,18.47,0.01,0.0494,10597,NULL,NULL,'LMC center based on 36 subregions','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43241,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43241,18.47,0.05,0.0494,10597,NULL,NULL,'Tile 8.3, Subregion G4, RA = 77.20 deg, Dec = -65.77 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43242,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43242,18.47,0.01,0.0494,10597,NULL,NULL,'LMC center based on subregions near RA = 79.40 deg, Dec = -69.03 deg','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43243,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43243,18.47,0.01,0.0494,10597,NULL,NULL,'LMC center based on subregions near RA = 81.90 deg, Dec = -69.87 deg','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43244,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43244,18.47,0.16,0.0494,10597,NULL,NULL,'KMHK1484','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43245,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43245,18.47,0.02,0.0494,10597,NULL,NULL,'SL 509','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43246,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43246,18.47,0.14,0.0494,10597,NULL,NULL,'SL484','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43247,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43247,18.47,0.01,0.0495,10597,NULL,NULL,'LMC center based on subregions near RA = 79.91 deg, Dec = -69.45 deg','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43248,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43248,18.48,0.18,0.0497,10597,NULL,NULL,'DES001SC14','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43249,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43249,18.48,0.14,0.0497,10597,NULL,NULL,'DES001SC25','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43250,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43250,18.48,0.15,0.0497,10597,NULL,NULL,'KMHK815','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43251,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43251,18.48,0.02,0.0497,10597,NULL,NULL,'NGC 2108, Teramo fit','LMC',NULL,'2011ApJ...737....3G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43252,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43252,18.48,0.02,0.0497,10597,NULL,NULL,'NGC 1751, Dartmouth fit','LMC',NULL,'2011ApJ...737....3G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43253,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43253,18.48,NULL,0.0497,10597,NULL,NULL,'NGC 1868','LMC',NULL,'2014ApJ...784..157L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43254,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43254,18.48,0.05,0.0497,10597,NULL,NULL,'Tile 8.3, Subregion G1, RA = 76.90 deg, Dec = -66.83 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43255,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43255,18.48,0.14,0.0497,10597,NULL,NULL,'BaSTI can','LMC',NULL,'2009IAUS..256..391K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43256,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43256,18.48,0.06,0.0497,10597,NULL,NULL,'SL 506','LMC',NULL,'2007A&A...462..139K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43257,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43257,18.48,NULL,0.0497,10597,NULL,NULL,'HODGE 7','LMC',NULL,'2009A&A...497..755M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43258,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43258,18.48,NULL,0.0497,10597,NULL,NULL,'NGC 1644','LMC',NULL,'2009A&A...497..755M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43259,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43259,18.48,NULL,0.0497,10597,NULL,NULL,'NGC 1652','LMC',NULL,'2009A&A...497..755M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43260,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43260,18.48,NULL,0.0497,10597,NULL,NULL,'NGC 1917','LMC',NULL,'2009A&A...497..755M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43261,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43261,18.48,NULL,0.0497,10597,NULL,NULL,'NGC 2154','LMC',NULL,'2009A&A...497..755M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43262,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43262,18.49,0.01,0.0499,10597,NULL,NULL,'BSDL3189','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43263,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43263,18.49,0.04,0.0499,10597,NULL,NULL,'DES001SC06','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43264,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43264,18.49,0.1,0.0499,10597,NULL,NULL,'LW340','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43265,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43265,18.49,0.04,0.0499,10597,NULL,NULL,'SL303','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43266,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43266,18.49,0.03,0.0499,10597,NULL,NULL,'NGC 1783, Padova fit','LMC',NULL,'2011ApJ...737....3G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43267,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43267,18.49,0.14,0.0499,10597,NULL,NULL,'NGC 1818','LMC',NULL,'2005A&A...435...77K',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43268,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43268,18.49,NULL,0.0499,10597,NULL,NULL,'NGC 1846','LMC',NULL,'2009A&A...497..755M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43269,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43269,18.49,NULL,0.0499,10597,NULL,NULL,'NGC 1978','LMC',NULL,'2009A&A...497..755M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43270,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43270,18.5,0.03,0.0501,10597,NULL,NULL,'NGC 1806, Padova fit','LMC',NULL,'2011ApJ...737....3G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43271,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43271,18.5,0.02,0.0501,10597,NULL,NULL,'NGC 1846, Teramo fit','LMC',NULL,'2011ApJ...737....3G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43272,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43272,18.5,0.02,0.0501,10597,NULL,NULL,'NGC 1751, Padova fit','LMC',NULL,'2011ApJ...737....3G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43273,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43273,18.5,0.03,0.0501,10597,NULL,NULL,'NGC 1751, Mean fit','LMC',NULL,'2011ApJ...737....3G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43274,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43274,18.5,0.02,0.0501,10597,NULL,NULL,'NGC 1783, Teramo fit','LMC',NULL,'2011ApJ...737....3G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43275,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43275,18.5,0.02,0.0501,10597,NULL,NULL,NULL,'LMC',NULL,'2009A&A...499..697K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43276,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43276,18.5,0.1,0.0501,10597,NULL,NULL,'NGC 2162, NGC 2190','LMC',NULL,'1986ApJ...308....1C',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43277,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43277,18.5,0.1,0.0501,10597,NULL,NULL,NULL,'LMC',NULL,'1999ASSL..237..125W',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43278,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43278,18.5,0.13,0.0501,10597,NULL,NULL,'BaSTI non','LMC',NULL,'2009IAUS..256..391K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43279,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43279,18.5,NULL,0.0501,10597,NULL,NULL,'NGC 1978, PEL(1)','LMC',NULL,'2007AJ....133.2053M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43280,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43280,18.5,NULL,0.0501,10597,NULL,NULL,'NGC 1978, PEL(2)','LMC',NULL,'2007AJ....133.2053M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43281,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43281,18.5,NULL,0.0501,10597,NULL,NULL,'NGC 1978, PEL(3)','LMC',NULL,'2007AJ....133.2053M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43282,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43282,18.5,NULL,0.0501,10597,NULL,NULL,'OGLE-LMC 0214','LMC',NULL,'2009arXiv0907.2890B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43283,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43283,18.5,NULL,0.0501,10597,NULL,NULL,'OGLE-LMC 0531','LMC',NULL,'2009arXiv0907.2890B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43284,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43284,18.5,NULL,0.0501,10597,NULL,NULL,'KMK 88-39','LMC',NULL,'2009arXiv0907.2890B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43285,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43285,18.5,NULL,0.0501,10597,NULL,NULL,'NGC 1878','LMC',NULL,'2009arXiv0907.2890B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43286,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43286,18.5,NULL,0.0501,10597,NULL,NULL,'NGC 2210, Photographic, E(B-V) = 0.00','LMC',NULL,'1986A&AS...64..189A',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43287,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43287,18.5,NULL,0.0501,10597,NULL,NULL,'IC 2146','LMC',NULL,'2009A&A...497..755M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43288,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43288,18.5,NULL,0.0501,10597,NULL,NULL,'NGC 1852','LMC',NULL,'2009A&A...497..755M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43289,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43289,18.5,0.12,0.0501,10597,NULL,NULL,NULL,'LMC',NULL,'2011MNRAS.414.2204R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43290,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43290,18.5,0.03,0.0501,10597,NULL,NULL,'Tile 4.3, Subregion G4, RA = 75.16 deg, Dec = -71.56 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43291,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43291,18.5,NULL,0.0501,10597,NULL,NULL,'Hodge 11, Pont GC','LMC',NULL,'1999ApJ...527..199J',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43292,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43292,18.5,0.02,0.0501,10597,NULL,NULL,'NGC 1805','LMC',NULL,'2013MNRAS.436.1497L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43293,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43293,18.5,0.05,0.0501,10597,NULL,NULL,'NGC 1754','LMC',NULL,'1999AJ....117.2244O',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43294,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43294,18.5,0.05,0.0501,10597,NULL,NULL,'NGC 1835','LMC',NULL,'1999AJ....117.2244O',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43295,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43295,18.5,0.05,0.0501,10597,NULL,NULL,'NGC 2019','LMC',NULL,'1999AJ....117.2244O',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43296,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43296,18.5,0.12,0.0501,10597,NULL,NULL,NULL,'LMC',NULL,'2000ApJ...542..804N',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43297,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43297,18.5,0.11,0.0501,10597,NULL,NULL,'NGC 1805','LMC',NULL,'2005A&A...435...77K',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43298,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43298,18.5,NULL,0.0501,10597,NULL,NULL,'NGC 1868, composite stellar populations','LMC',NULL,'2015arXiv150402571L',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43299,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43299,18.5,0.02,0.0501,10597,NULL,NULL,'H4','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43300,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43300,18.5,0.01,0.0501,10597,NULL,NULL,'NGC2120','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43301,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43301,18.5,0.03,0.0501,10597,NULL,NULL,'SL401','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43302,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43302,18.51,NULL,0.0504,10597,NULL,NULL,'NGC 2249, simple stellar populations','LMC',NULL,'2015arXiv150402571L',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43303,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43303,18.51,0.01,0.0504,10597,NULL,NULL,'HS317','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43304,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43304,18.51,0.09,0.0504,10597,NULL,NULL,'LW195','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43305,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43305,18.51,0.01,0.0504,10597,NULL,NULL,'SL729','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43306,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43306,18.51,0.13,0.0504,10597,NULL,NULL,'Hodge 14','LMC',NULL,'2005A&A...435...77K',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43307,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43307,18.51,0.01,0.0504,10597,NULL,NULL,'Tile 4.3, Subregion G8, RA = 74.11 deg, Dec = -71.51 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43308,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43308,18.52,0.03,0.0505,10597,NULL,NULL,'Tile 4.3, Subregion G4, RA = 75.16 deg, Dec = -71.56 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43309,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43309,18.52,0.01,0.0506,10597,NULL,NULL,'BSDL1735','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43310,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43310,18.52,0.01,0.0506,10597,NULL,NULL,'SL515','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43311,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43311,18.52,0.04,0.0506,10597,NULL,NULL,'Tile 4.3, Subregion G2, RA = 74.81 deg, Dec = -72.27 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43312,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43312,18.52,0.03,0.0506,10597,NULL,NULL,'Tile 4.3, Subregion G3, RA = 74.99 deg, Dec = -71.92 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43313,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43313,18.52,NULL,0.0506,10597,NULL,NULL,'NGC 2257, Gratton GC','LMC',NULL,'1999ApJ...527..199J',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43314,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43314,18.52,0.2,0.0506,10597,NULL,NULL,'Y = 0.273, Z = 0.016','LMC',NULL,'1985MNRAS.217P..13W',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43315,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43315,18.52,0.01,0.0506,10597,NULL,NULL,'Tile 4.3, Subregion G8, RA = 74.11 deg, Dec = -71.51 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43316,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43316,18.52,0.03,0.0507,10597,NULL,NULL,'Tile 4.3, Subregion G3, RA = 74.99 deg, Dec = -71.92 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43317,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43317,18.52,0.03,0.0507,10597,NULL,NULL,'Tile 4.3, Subregion G12, RA = 73.08 deg, Dec = -71.45 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43318,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43318,18.53,0.02,0.0507,10597,NULL,NULL,'Tile 4.3, Subregion G7, RA = 73.93 deg, Dec = -71.87 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43319,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43319,18.53,0.04,0.0507,10597,NULL,NULL,'Tile 4.3, Subregion G2, RA = 74.81 deg, Dec = -72.27 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43320,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43320,18.53,0.03,0.0508,10597,NULL,NULL,'Tile 4.3, Subregion G11, RA = 72.87 deg, Dec = -71.81 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43321,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43321,18.53,0.03,0.0508,10597,NULL,NULL,'NGC 1651','LMC',NULL,'2007A&A...462..139K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43322,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43322,18.53,0.02,0.0508,10597,NULL,NULL,'Tile 4.3, Subregion G6, RA = 73.73 deg, Dec = -72.22 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43323,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43323,18.53,0.02,0.0508,10597,NULL,NULL,'Tile 4.3, Subregion G7, RA = 73.93 deg, Dec = -71.87 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43324,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43324,18.53,0.02,0.0508,10597,NULL,NULL,'Tile 4.3, Subregion G6, RA = 73.73 deg, Dec = -72.22 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43325,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43325,18.53,0.02,0.0508,10597,NULL,NULL,NULL,'LMC',NULL,'2012ApJ...749..108P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43326,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43326,18.53,0.18,0.0508,10597,NULL,NULL,'NGC 1978','LMC',NULL,'2006ApJ...649..243F',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43327,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43327,18.53,0.01,0.0508,10597,NULL,NULL,'SL126','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43328,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43328,18.53,0.03,0.0509,10597,NULL,NULL,'Tile 4.3, Subregion G1, RA = 74.64 deg, Dec = -72.62 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43329,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43329,18.53,0.03,0.0509,10597,NULL,NULL,'Tile 4.3, Subregion G10, RA = 72.67 deg, Dec = -72.16 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43330,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43330,18.54,0.01,0.0509,10597,NULL,NULL,'Tile 4.3, Subregion G5, RA = 73.54 deg, Dec = -72.57 deg, best fit 2','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43331,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43331,18.54,0.08,0.0511,10597,NULL,NULL,'KMHK1322','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43332,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43332,18.54,0.04,0.0511,10597,NULL,NULL,'SL233','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43333,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43333,18.54,0.02,0.0511,10597,NULL,NULL,'NGC 1818','LMC',NULL,'2013MNRAS.436.1497L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43334,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43334,18.54,0.03,0.0511,10597,NULL,NULL,'Tile 4.3, Subregion G10, RA = 72.67 deg, Dec = -72.16 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43335,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43335,18.54,0.07,0.0511,10597,NULL,NULL,NULL,'LMC',NULL,'2012A&A...544A.155F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43336,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43336,18.54,0.2,0.0511,10597,NULL,NULL,'NGC 1831, Y = 0.273, Z = 0.016','LMC',NULL,'1985MNRAS.217P..13W',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43337,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43337,18.55,0.01,0.0513,10597,NULL,NULL,'KMHK1530','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43338,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43338,18.55,0.02,0.0513,10597,NULL,NULL,'SL670','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43339,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43339,18.55,0.01,0.0513,10597,NULL,NULL,'SL727','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43340,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43340,18.55,0.02,0.0513,10597,NULL,NULL,'NGC 1751, Teramo fit','LMC',NULL,'2011ApJ...737....3G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43341,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43341,18.55,0.03,0.0513,10597,NULL,NULL,'NGC 1852','LMC',NULL,'2014ApJ...797...35G',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43342,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43342,18.55,0.03,0.0513,10597,NULL,NULL,'Tile 4.3, Subregion G1, RA = 74.64 deg, Dec = -72.62 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43343,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43343,18.55,0.01,0.0513,10597,NULL,NULL,'Tile 4.3, Subregion G5, RA = 73.54 deg, Dec = -72.57 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43344,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43344,18.55,0.03,0.0513,10597,NULL,NULL,'Tile 4.3, Subregion G11, RA = 72.87 deg, Dec = -71.81 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43345,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43345,18.55,0.03,0.0513,10597,NULL,NULL,'Tile 4.3, Subregion G12, RA = 73.08 deg, Dec = -71.45 deg, best fit 1','LMC',NULL,'2012A&A...537A.106R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43346,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43346,18.55,NULL,0.0513,10597,NULL,NULL,'NGC 2257, Pont LMC','LMC',NULL,'1999ApJ...527..199J',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43347,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43347,18.55,NULL,0.0513,10597,NULL,NULL,'Hodge 14','LMC',NULL,'2006A&A...452..155K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43348,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43348,18.55,NULL,0.0513,10597,NULL,NULL,'NGC 1805','LMC',NULL,'2006A&A...452..155K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43349,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43349,18.56,0.16,0.0515,10597,NULL,NULL,'PEL STD','LMC',NULL,'2009IAUS..256..391K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43350,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43350,18.56,0.07,0.0515,10597,NULL,NULL,'NGC 1777','LMC',NULL,'2007A&A...462..139K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43351,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43351,18.56,0.08,0.0515,10597,NULL,NULL,'NGC 2213','LMC',NULL,'2007A&A...462..139K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43352,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43352,18.56,0.06,0.0515,10597,NULL,NULL,'NGC 1866','LMC',NULL,'1999AJ....118.2839T',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43353,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43353,18.56,0.01,0.0515,10597,NULL,NULL,'SL689','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43354,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43354,18.57,0.01,0.0518,10597,NULL,NULL,'OHSC26','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43355,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43355,18.57,NULL,0.0518,10597,NULL,NULL,'NGC 0330','LMC',NULL,'1988ApJ...331..261M',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43356,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43356,18.58,NULL,0.052,10597,NULL,NULL,'NGC 1466, Pont GC','LMC',NULL,'1999ApJ...527..199J',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43357,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43357,18.58,0.15,0.052,10597,NULL,NULL,'PEL OV0','LMC',NULL,'2009IAUS..256..391K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43358,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43358,18.58,0.12,0.052,10597,NULL,NULL,'NGC 2173','LMC',NULL,'2007A&A...462..139K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43359,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43359,18.58,0.08,0.052,10597,NULL,NULL,'NGC 1866, Main Sequence Fitting','LMC',NULL,'2003A&A...410..887G',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43360,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43360,18.59,NULL,0.0522,10597,NULL,NULL,'Hodge 11, Pont LMC','LMC',NULL,'1999ApJ...527..199J',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43361,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43361,18.59,0.01,0.0522,10597,NULL,NULL,'DES001SC23','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43362,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43362,18.6,0.01,0.0525,10597,NULL,NULL,'NGC 2162                      ','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43363,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43363,18.6,0.02,0.0525,10597,NULL,NULL,'SL388','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43364,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43364,18.6,0.16,0.0525,10597,NULL,NULL,'NGC 1754, S94 abundance','LMC',NULL,'1998MNRAS.300..665O',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43365,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43365,18.6,0.1,0.0525,10597,NULL,NULL,NULL,'LMC',NULL,'1987MNRAS.229....1A',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43366,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43366,18.61,0.07,0.0527,10597,NULL,NULL,'NGC 1831, Main Sequence Fitting','LMC',NULL,'2002A&A...390..121K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43367,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43367,18.63,NULL,0.0532,10597,NULL,NULL,'Hodge 11, Gratton GC','LMC',NULL,'1999ApJ...527..199J',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43368,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43368,18.64,0.04,0.0535,10597,NULL,NULL,'SL694','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43369,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43369,18.65,NULL,0.0537,10597,NULL,NULL,'KMK 88-38','LMC',NULL,'2009arXiv0907.2890B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43370,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43370,18.65,0.16,0.0537,10597,NULL,NULL,'NGC 1835, S94 abundance','LMC',NULL,'1998MNRAS.300..665O',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43371,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43371,18.65,0.16,0.0537,10597,NULL,NULL,'KMHK938','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43372,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43372,18.66,NULL,0.054,10597,NULL,NULL,'NGC 2249, composite stellar populations','LMC',NULL,'2015arXiv150402571L',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43373,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43373,18.66,0.14,0.054,10597,NULL,NULL,'LW212','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43374,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43374,18.67,0.01,0.0542,10597,NULL,NULL,'NGC 1868                      ','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43375,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43375,18.69,NULL,0.0547,10597,NULL,NULL,'NGC 1651','LMC',NULL,'2015ApJ...802...44L',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43376,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43376,18.7,0.03,0.055,10597,NULL,NULL,'NGC 1831','LMC',NULL,'2005A&A...435...77K',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43377,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43377,18.7,0.03,0.055,10597,NULL,NULL,'NGC 1868','LMC',NULL,'2005A&A...435...77K',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43378,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43378,18.7,0.16,0.055,10597,NULL,NULL,'NGC 1754, O91 abundance','LMC',NULL,'1998MNRAS.300..665O',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43379,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43379,18.7,NULL,0.055,10597,NULL,NULL,'NGC 1841','LMC',NULL,'1985A&A...150L..12A',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43380,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43380,18.7,NULL,0.055,10597,NULL,NULL,'NGC 1831','LMC',NULL,'2006A&A...452..155K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43381,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43381,18.7,NULL,0.055,10597,NULL,NULL,'NGC 1868','LMC',NULL,'2006A&A...452..155K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43382,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43382,18.71,NULL,0.0552,10597,NULL,NULL,'NGC 1466, Gratton GC','LMC',NULL,'1999ApJ...527..199J',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43383,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43383,18.72,0.01,0.0555,10597,NULL,NULL,'H88-257','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43384,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43384,18.73,0.07,0.0557,10597,NULL,NULL,'NGC 1718','LMC',NULL,'2007A&A...462..139K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43385,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43385,18.73,0.18,0.0557,10597,NULL,NULL,'BSDL818','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43386,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43386,18.75,0.01,0.0562,10597,NULL,NULL,'NGC1942','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43387,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43387,18.77,0.1,0.0568,10597,NULL,NULL,'DES001SC28','LMC',NULL,'2015arXiv151201032P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43388,'CMD','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43388,18.84,NULL,0.0586,10597,NULL,NULL,'NGC 1868, simple stellar populations','LMC',NULL,'2015arXiv150402571L',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43389,'Delta Scuti','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43389,18.46,0.19,0.0492,10597,NULL,NULL,'1, BVI, Gal PL, Delta Scuti ','LMC',NULL,'2007AJ....133.2752M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43390,'Delta Scuti','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43390,18.47,0.06,0.0494,10597,NULL,NULL,'Peak 1','LMC',NULL,'2011AJ....142..110M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43391,'Delta Scuti','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43391,18.47,0.06,0.0494,10597,NULL,NULL,'Peak 2','LMC',NULL,'2011AJ....142..110M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43392,'Delta Scuti','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43392,18.48,0.15,0.0497,10597,NULL,NULL,'1, BVI, Theory PL, Delta Scuti ','LMC',NULL,'2007AJ....133.2752M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43393,'Delta Scuti','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43393,18.49,0.07,0.0499,10597,NULL,NULL,'Z','LMC',NULL,'2011AJ....142..110M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43394,'Delta Scuti','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43394,18.5,0.22,0.0501,10597,NULL,NULL,'1, BVI, LMC PL, Delta Scuti ','LMC',NULL,'2007AJ....133.2752M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43395,'Delta Scuti','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43395,18.53,0.07,0.0508,10597,NULL,NULL,NULL,'LMC',NULL,'2011AJ....142..110M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43396,'Delta Scuti','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43396,18.55,0.06,0.0513,10597,NULL,NULL,'Peak 3','LMC',NULL,'2011AJ....142..110M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43397,'FGLR','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43397,18.5,NULL,0.0501,10597,NULL,NULL,NULL,'LMC',NULL,'2008ApJ...681..269K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43398,'Horizontal Branch','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43398,18.26,0.11,0.0449,10597,NULL,NULL,'NGC 1841, E(B-V) = 0.17 mag and R(V) = 3.2','LMC',NULL,'1996AJ....112.2020A',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43399,'Horizontal Branch','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43399,18.49,0.11,0.0499,10597,NULL,NULL,'Trigonometric Parallax','LMC',NULL,'2000ApJ...533..215C',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43400,'Horizontal Branch','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43400,18.5,NULL,0.0501,10597,NULL,NULL,'Blue HB','LMC',NULL,'2016MNRAS.456..602B',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43401,'Horizontal Branch','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43401,18.61,0.07,0.0527,10597,NULL,NULL,NULL,'LMC',NULL,'1997ESASP.402..651G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43402,'M Stars','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43402,18.34,0.09,0.0466,10597,NULL,NULL,NULL,'LMC',NULL,'2002AJ....123..473B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43403,'M Stars','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43403,18.34,0.09,0.0466,10597,NULL,NULL,NULL,'LMC',NULL,'1998AN....319..375S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43404,'M Stars','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43404,18.54,0.03,0.0511,10597,NULL,NULL,NULL,'LMC',NULL,'2010MNRAS.409..777T',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43405,'M Stars','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43405,18.89,NULL,0.0601,10597,NULL,NULL,NULL,'LMC',NULL,'2010ApJ...722..750S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43406,'Miras','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43406,18.21,NULL,0.0439,10597,NULL,NULL,NULL,'LMC',NULL,'2005A&A...443..143G',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43407,'Miras','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43407,18.31,0.2,0.0459,10597,NULL,NULL,'C Miras','LMC',NULL,'2008mear.confE...3F',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43408,'Miras','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43408,18.45,0.02,0.049,10597,NULL,NULL,'MW center m-M = 14.58, D = 8.24 kpc','LMC',NULL,'2009MNRAS.399.1709M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43409,'Miras','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43409,18.47,0.17,0.0494,10597,NULL,NULL,'Bolometric','LMC',NULL,'1997MNRAS.287..955V',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43410,'Miras','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43410,18.48,NULL,0.0497,10597,NULL,NULL,NULL,'LMC',NULL,'1988ASPC....4....9F',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43411,'Miras','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43411,18.48,0.08,0.0497,10597,NULL,NULL,'Long Period Variables','LMC',NULL,'2004ASPC..310..304F',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43412,'Miras','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43412,18.49,0.07,0.0499,10597,NULL,NULL,'O Miras','LMC',NULL,'2008mear.confE...3F',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43413,'Miras','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43413,18.5,0.3,0.0501,10597,NULL,NULL,NULL,'LMC',NULL,'1981Natur.291..303G',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43414,'Miras','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43414,18.54,0.18,0.0511,10597,NULL,NULL,'M(K) + M(Bol)','LMC',NULL,'1999ASSL..237..125W',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43415,'Miras','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43415,18.54,0.18,0.0511,10597,NULL,NULL,'Long Period Variables','LMC',NULL,'1997MNRAS.287..955V',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43416,'Miras','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43416,18.54,0.18,0.0511,10597,NULL,NULL,'Long Period Variables','LMC',NULL,'2000ApJ...533..215C',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43417,'Miras','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43417,18.6,0.1,0.0525,10597,NULL,NULL,'K','LMC',NULL,'2002MNRAS.329L...7F',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43418,'Miras','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43418,18.6,0.18,0.0525,10597,NULL,NULL,'M(K)','LMC',NULL,'1999ASSL..237..125W',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43419,'Miras','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43419,18.6,0.18,0.0525,10597,NULL,NULL,'K','LMC',NULL,'1997MNRAS.287..955V',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43420,'Miras','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43420,18.6,0.25,0.0525,10597,NULL,NULL,NULL,'LMC',NULL,'1985ApJ...290..477W',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43421,'Miras','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43421,18.64,0.14,0.0535,10597,NULL,NULL,'Long Period Variables','LMC',NULL,'2000MNRAS.319..759W',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43422,'Miras','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43422,18.66,0.05,0.054,10597,NULL,NULL,'Long Period Variables','LMC',NULL,'1990AJ.....99..784H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43423,'Novae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43423,18.4,0.15,0.0479,10597,NULL,NULL,'Photographic','LMC',NULL,'1993ApJ...415...10d',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43424,'Novae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43424,18.7,0.25,0.055,10597,NULL,NULL,'14','LMC',NULL,'1990ApJ...360...63C',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43425,'Novae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43425,18.82,1.48,0.058,10597,NULL,NULL,'XMMSL1 J060636.2-694933','LMC',NULL,'2009A&A...506.1309R',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43426,'OB Stars','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43426,18.3,0.4,0.0457,10597,NULL,NULL,'Photographic, 191','LMC',NULL,'1986AJ.....92...48C',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43427,'OB Stars','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43427,18.6,NULL,0.0525,10597,NULL,NULL,'30 Dor,30 Doradus, NGC 2070','LMC',NULL,'1997ApJS..112..457W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43428,'OB Stars','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43428,18.6,0.3,0.0525,10597,NULL,NULL,'Photographic','LMC',NULL,'1982PASP...94...31C',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43429,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43429,16.29,NULL,0.0181,10597,NULL,NULL,'SMP11','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43430,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43430,16.9,NULL,0.024,10597,NULL,NULL,'SMP83','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43431,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43431,16.92,NULL,0.0242,10597,NULL,NULL,'SMP93','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43432,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43432,17,NULL,0.0251,10597,NULL,NULL,'Sa109','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43433,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43433,17.5,NULL,0.0316,10597,NULL,NULL,'SMP13','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43434,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43434,17.63,NULL,0.0336,10597,NULL,NULL,'SMP59','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43435,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43435,17.76,NULL,0.0356,10597,NULL,NULL,'MG14','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43436,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43436,17.91,NULL,0.0382,10597,NULL,NULL,'SMP48','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43437,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43437,17.98,NULL,0.0394,10597,NULL,NULL,'SMP74','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43438,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43438,17.99,NULL,0.0396,10597,NULL,NULL,'SMP75','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43439,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43439,18.07,NULL,0.0412,10597,NULL,NULL,'SMP37','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43440,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43440,18.08,NULL,0.0413,10597,NULL,NULL,'SMP92','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43441,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43441,18.09,NULL,0.0414,10597,NULL,NULL,'SMP71','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43442,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43442,18.13,NULL,0.0422,10597,NULL,NULL,'Sa117','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43443,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43443,18.14,NULL,0.0424,10597,NULL,NULL,'SMP45','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43444,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43444,18.16,NULL,0.0428,10597,NULL,NULL,'SMP19','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43445,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43445,18.2,0.4,0.043,10597,NULL,NULL,NULL,'LMC',NULL,'1992A&AS...94..399C',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43446,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43446,18.19,NULL,0.0434,10597,NULL,NULL,'SMP63','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43447,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43447,18.3,NULL,0.0458,10597,NULL,NULL,'SMP62','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43448,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43448,18.31,NULL,0.0459,10597,NULL,NULL,'SMP52','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43449,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43449,18.31,NULL,0.046,10597,NULL,NULL,'Sa107','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43450,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43450,18.32,NULL,0.0461,10597,NULL,NULL,'SMP25','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43451,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43451,18.33,NULL,0.0463,10597,NULL,NULL,'SMP95','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43452,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43452,18.34,NULL,0.0465,10597,NULL,NULL,'SMP78','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43453,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43453,18.34,NULL,0.0466,10597,NULL,NULL,'SMP47','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43454,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43454,18.36,NULL,0.047,10597,NULL,NULL,'PNLF(CKS)','LMC',NULL,'1995A&AT....6..213A',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43455,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43455,18.37,0.15,0.0472,10597,NULL,NULL,NULL,'LMC',NULL,'1992ApJ...389...27D',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43456,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43456,18.37,NULL,0.0473,10597,NULL,NULL,'SMP91','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43457,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43457,18.38,NULL,0.0474,10597,NULL,NULL,'SMP69','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43458,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43458,18.39,NULL,0.0477,10597,NULL,NULL,'SMP16','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43459,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43459,18.43,NULL,0.0486,10597,NULL,NULL,'SMP39','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43460,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43460,18.44,NULL,0.0488,10597,NULL,NULL,'SMP29','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43461,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43461,18.44,0.18,0.0488,10597,NULL,NULL,NULL,'LMC',NULL,'1990ApJ...365..471J',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43462,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43462,18.45,NULL,0.049,10597,NULL,NULL,'SMP67','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43463,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43463,18.46,0.2,0.0492,10597,NULL,NULL,NULL,'LMC',NULL,'2010MNRAS.405.1349R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43464,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43464,18.49,NULL,0.0498,10597,NULL,NULL,'SMP58','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43465,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43465,18.49,0.3,0.05,10597,NULL,NULL,NULL,'LMC',NULL,'2008ApJ...689..194S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43466,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43466,18.5,0.18,0.0501,10597,NULL,NULL,'42','LMC',NULL,'1999ASSL..237..125W',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43467,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43467,18.51,NULL,0.0503,10597,NULL,NULL,'SMP89','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43468,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43468,18.51,NULL,0.0504,10597,NULL,NULL,'Sa115','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43469,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43469,18.52,NULL,0.0505,10597,NULL,NULL,'SMP73','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43470,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43470,18.53,0.14,0.0508,10597,NULL,NULL,'HST KP Calibrated','LMC',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43471,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43471,18.54,0.32,0.051,10597,NULL,NULL,'PNLF(AGR)','LMC',NULL,'1995A&AT....6..213A',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43472,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43472,18.55,NULL,0.0512,10597,NULL,NULL,'SMP5','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43473,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43473,18.56,NULL,0.0516,10597,NULL,NULL,'SMP34','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43474,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43474,18.6,NULL,0.0524,10597,NULL,NULL,'MG60','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43475,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43475,18.6,NULL,0.0525,10597,NULL,NULL,'SMP46','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43476,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43476,18.61,NULL,0.0527,10597,NULL,NULL,'SMP31','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43477,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43477,18.74,NULL,0.056,10597,NULL,NULL,'SMP9','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43478,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43478,18.79,NULL,0.0572,10597,NULL,NULL,'MG51','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43479,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43479,18.81,NULL,0.0577,10597,NULL,NULL,'SMP10','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43480,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43480,18.85,NULL,0.0588,10597,NULL,NULL,'SMP65','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43481,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43481,18.9,NULL,0.0602,10597,NULL,NULL,'SMP30','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43482,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43482,18.94,NULL,0.0615,10597,NULL,NULL,'SMP28','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43483,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43483,19.09,NULL,0.0658,10597,NULL,NULL,'SMP88','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43484,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43484,19.13,NULL,0.0671,10597,NULL,NULL,'SMP68','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43485,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43485,19.17,NULL,0.0683,10597,NULL,NULL,'Mo36','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43486,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43486,19.25,NULL,0.0707,10597,NULL,NULL,'SMP53','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43487,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43487,19.35,NULL,0.0743,10597,NULL,NULL,'SMP18','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43488,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43488,19.37,NULL,0.0749,10597,NULL,NULL,'SMP49','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43489,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43489,19.48,NULL,0.0786,10597,NULL,NULL,'SMP27','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43490,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43490,19.54,NULL,0.0808,10597,NULL,NULL,'SMP84','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43491,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43491,19.73,NULL,0.0883,10597,NULL,NULL,'MG40','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43492,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43492,19.82,NULL,0.092,10597,NULL,NULL,'SMP82','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43493,'PNLF','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43493,20.17,NULL,0.108,10597,NULL,NULL,'SMP80','LMC',NULL,'2013A&A...560A..85O',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43494,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43494,18.07,0.03,0.041,10597,NULL,NULL,NULL,'LMC',NULL,'1998ApJ...500L.141S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43495,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43495,18.08,0.03,0.0413,10597,NULL,NULL,NULL,'LMC',NULL,'1998AcA....48....1U',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43496,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43496,18.13,0.07,0.0427,10597,NULL,NULL,NULL,'LMC',NULL,'1998AcA....48..113U',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43497,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43497,18.18,0.06,0.0433,10597,NULL,NULL,NULL,'LMC',NULL,'1998AcA....48..383U',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43498,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43498,18.2,NULL,0.0437,10597,NULL,NULL,'NGC 2213','LMC',NULL,'1987ApJ...313..192S',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43499,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43499,18.2,NULL,0.0437,10597,NULL,NULL,'NGC 1651','LMC',NULL,'1987ApJ...313..192S',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43500,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43500,18.2,NULL,0.0437,10597,NULL,NULL,'I, M TRGB(I) = -4.05 mag','LMC',NULL,'1987ApJ...313..192S',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43501,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43501,18.24,0.08,0.0445,10597,NULL,NULL,NULL,'LMC',NULL,'2000ApJ...531L..25U',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43502,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43502,18.24,0.08,0.0445,10597,NULL,NULL,NULL,'LMC',NULL,'2000AcA....50..191S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43503,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43503,18.26,0.07,0.0449,10597,NULL,NULL,NULL,'LMC',NULL,'2000AcA....50..279U',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43504,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43504,18.27,0.07,0.0451,10597,NULL,NULL,NULL,'LMC',NULL,'2000ApJ...528L...9P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43505,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43505,18.28,0.14,0.0453,10597,NULL,NULL,NULL,'LMC',NULL,'1998MNRAS.301..149G',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43506,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43506,18.29,0.03,0.0455,10597,NULL,NULL,NULL,'LMC',NULL,'2000AJ....119.1197S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43507,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43507,18.3,NULL,0.0457,10597,NULL,NULL,NULL,'LMC',NULL,'1998AJ....116..209B',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43508,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43508,18.3,0.1,0.046,10597,NULL,NULL,'[Fe/H] = _1.1','LMC',NULL,'2014MNRAS.444.3139M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43509,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43509,18.32,0.17,0.0461,10597,NULL,NULL,NULL,'LMC',NULL,'1999AJ....117.1816T',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43510,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43510,18.33,0.07,0.0463,10597,NULL,NULL,NULL,'LMC',NULL,'2001MNRAS.321..502P',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43511,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43511,18.35,0.05,0.0468,10597,NULL,NULL,NULL,'LMC',NULL,'2008ApJ...681..269K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43512,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43512,18.35,0.05,0.0468,10597,NULL,NULL,'JK','LMC',NULL,'2008A&A...488..935G',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43513,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43513,18.36,0.17,0.047,10597,NULL,NULL,NULL,'LMC',NULL,'1998ApJ...500L.137C',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43514,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43514,18.37,NULL,0.0472,10597,NULL,NULL,'Field LMC-E4','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43515,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43515,18.37,0.07,0.0472,10597,NULL,NULL,'Udalski_2000 Red Clump','LMC',NULL,'2001MNRAS.323..109G',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43516,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43516,18.38,0.07,0.0474,10597,NULL,NULL,'SL 817, V','LMC',NULL,'2010AJ....139..878S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43517,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43517,18.39,NULL,0.0476,10597,NULL,NULL,'Field LMC-E18','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43518,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43518,18.4,0.04,0.0479,10597,NULL,NULL,NULL,'LMC',NULL,'2007AJ....134..680G',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43519,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43519,18.4,0.04,0.0479,10597,NULL,NULL,'Syst. +/- 0.08 mag','LMC',NULL,'2006PhDT........14G',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43520,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43520,18.42,0.07,0.0483,10597,NULL,NULL,NULL,'LMC',NULL,'2003AJ....125.1309C',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43521,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43521,18.42,0.17,0.0483,10597,NULL,NULL,NULL,'LMC',NULL,'1999AJ....117.1816T',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43522,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43522,18.42,0.17,0.0483,10597,NULL,NULL,NULL,'LMC',NULL,'2003AJ....125.1309C',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43523,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43523,18.43,0.06,0.0485,10597,NULL,NULL,'Z','LMC',NULL,'1998ApJ...500L.137C',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43524,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43524,18.43,NULL,0.0485,10597,NULL,NULL,'Field LMC-E12','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43525,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43525,18.44,NULL,0.0488,10597,NULL,NULL,'Field LMC-E1','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43526,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43526,18.44,0.05,0.0488,10597,NULL,NULL,NULL,'LMC',NULL,'2000ApJ...528L...9P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43527,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43527,18.44,0.07,0.0488,10597,NULL,NULL,NULL,'LMC',NULL,'2001MNRAS.321..502P',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43528,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43528,18.45,NULL,0.049,10597,NULL,NULL,'Field LMC-E14','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43529,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43529,18.45,0.07,0.049,10597,NULL,NULL,'SL 862, V','LMC',NULL,'2010AJ....139..878S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43530,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43530,18.45,0.07,0.049,10597,NULL,NULL,NULL,'LMC',NULL,'2003AJ....125.1309C',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43531,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43531,18.46,0.08,0.0492,10597,NULL,NULL,NULL,'LMC',NULL,'2015AJ....149..117M',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43532,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43532,18.46,0.11,0.0492,10597,NULL,NULL,NULL,'LMC',NULL,'2003AJ....125.1261D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43533,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43533,18.46,0.07,0.0492,10597,NULL,NULL,'mean of estimates','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43534,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43534,18.47,0.03,0.0494,10597,NULL,NULL,NULL,'LMC',NULL,'2009AIPC.1170...34L',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43535,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43535,18.47,0.07,0.0494,10597,NULL,NULL,'NGC 1900, CJ, KS','LMC',NULL,'2010AJ....139..878S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43536,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43536,18.47,0.01,0.0494,10597,NULL,NULL,NULL,'LMC',NULL,'2003MNRAS.345.1030S',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43537,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43537,18.47,0.02,0.0494,10597,NULL,NULL,'K','LMC',NULL,'2012MNRAS.419.1637L',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43538,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43538,18.47,0.04,0.0494,10597,NULL,NULL,NULL,'LMC',NULL,'2002MNRAS.337..332S',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43539,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43539,18.47,0.1,0.0494,10597,NULL,NULL,'Method 1','LMC',NULL,'2013A&A...552A.144S',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43540,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43540,18.47,0.09,0.0494,10597,NULL,NULL,NULL,'LMC',NULL,'2015MNRAS.449.1129B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43541,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43541,18.47,0.01,0.0495,10597,NULL,NULL,NULL,'LMC',NULL,'2002AJ....124.2633P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43542,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43542,18.48,0.1,0.0497,10597,NULL,NULL,'Method 2','LMC',NULL,'2013A&A...552A.144S',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43543,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43543,18.48,0.05,0.0497,10597,NULL,NULL,'SL 509, J, KS','LMC',NULL,'2010AJ....139..878S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43544,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43544,18.49,0.06,0.0499,10597,NULL,NULL,'NGC 1928, I','LMC',NULL,'2011A&A...535A..63F',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43545,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43545,18.49,0.06,0.0499,10597,NULL,NULL,'H','LMC',NULL,'2012MNRAS.419.1637L',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43546,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43546,18.49,0.04,0.0499,10597,NULL,NULL,NULL,'LMC',NULL,'2002MNRAS.337..332S',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43547,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43547,18.49,0.03,0.05,10597,NULL,NULL,NULL,'LMC',NULL,'2002ApJ...573L..51A',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43548,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43548,18.5,0.01,0.0501,10597,NULL,NULL,'K','LMC',NULL,'2003AJ....125.2494P',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43549,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43549,18.5,0.01,0.0501,10597,NULL,NULL,NULL,'LMC',NULL,'2003AJ....125.2494P',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43550,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43550,18.5,0.01,0.0501,10597,NULL,NULL,'OGLE III','LMC',NULL,'2010A&A...520A..24S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43551,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43551,18.5,0.06,0.0501,10597,NULL,NULL,'NGC 1928, K, +/- 0.09 syst.','LMC',NULL,'2011A&A...535A..63F',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43552,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43552,18.5,NULL,0.0501,10597,NULL,NULL,NULL,'LMC',NULL,'1999AJ....118.2824Z',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43553,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43553,18.51,0.06,0.0504,10597,NULL,NULL,'NGC 1928, V','LMC',NULL,'2011A&A...535A..63F',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43554,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43554,18.51,0.05,0.0504,10597,NULL,NULL,NULL,'LMC',NULL,'2002MNRAS.337..332S',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43555,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43555,18.52,0.17,0.0506,10597,NULL,NULL,'ESO 356-SC 005, Fornax Dwarf Cluster 4, Hodge 4','LMC',NULL,'2002AJ....124.2625S',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43556,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43556,18.53,0.07,0.0508,10597,NULL,NULL,'NGC 1866','LMC',NULL,'2003A&A...410..887G',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43557,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43557,18.53,0.07,0.0508,10597,NULL,NULL,'NGC 1866','LMC',NULL,'2003ApJ...588..801S',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43558,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43558,18.53,0.07,0.0508,10597,NULL,NULL,NULL,'LMC',NULL,'2002MNRAS.337..332S',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43559,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43559,18.54,0.06,0.0511,10597,NULL,NULL,NULL,'LMC',NULL,'2009AJ....138....1K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43560,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43560,18.54,NULL,0.0511,10597,NULL,NULL,'Field LMC-E7','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43561,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43561,18.54,NULL,0.0511,10597,NULL,NULL,'Field LMC-E9','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43562,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43562,18.54,0.1,0.0511,10597,NULL,NULL,NULL,'LMC',NULL,'2002AJ....124.2625S',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43563,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43563,18.55,0.04,0.0513,10597,NULL,NULL,NULL,'LMC',NULL,'2002MNRAS.337..332S',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43564,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43564,18.55,0.01,0.0513,10597,NULL,NULL,'MCPS','LMC',NULL,'2010A&A...520A..24S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43565,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43565,18.55,0.12,0.0513,10597,NULL,NULL,'NGC 1651','LMC',NULL,'2002AJ....124.2625S',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43566,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43566,18.55,0.05,0.0513,10597,NULL,NULL,'Romaniello 2000 Red Clump','LMC',NULL,'2001MNRAS.323..109G',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43567,'Red Clump','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43567,18.59,0.04,0.0522,10597,NULL,NULL,NULL,'LMC',NULL,'2000ApJ...530..738R',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43568,'RSV Stars','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43568,18.28,0.09,0.0453,10597,NULL,NULL,'K','LMC',NULL,'1993AstL...19..172D',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43569,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43569,17.9,0.3,0.038,10597,NULL,NULL,'Photographic','LMC',NULL,'1980MNRAS.190..591C',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43570,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43570,18.07,0.15,0.0411,10597,NULL,NULL,NULL,'LMC',NULL,'1998ApJ...506..259P',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43571,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43571,18.09,0.16,0.0415,10597,NULL,NULL,NULL,'LMC',NULL,'1998AcA....48..113U',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43572,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43572,18.1,NULL,0.0417,10597,NULL,NULL,'OGLE052039.40-691709.0','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43573,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43573,18.1,NULL,0.0417,10597,NULL,NULL,NULL,'LMC',NULL,'1992MmSAI..63..331L',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43574,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43574,18.13,0.25,0.0423,10597,NULL,NULL,'NGC 2257, Photographic','LMC',NULL,'1985ApJS...57..329N',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43575,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43575,18.17,0.1,0.0431,10597,NULL,NULL,'NGC 2210, M(V) = 0.77 mag','LMC',NULL,'1994MNRAS.267..821R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43576,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43576,18.18,NULL,0.0433,10597,NULL,NULL,'MACHO10.3802.339','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43577,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43577,18.19,0.04,0.0435,10597,NULL,NULL,NULL,'LMC',NULL,'1992MmSAI..63..409C',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43578,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43578,18.19,0.06,0.0435,10597,NULL,NULL,'NGC 1841, 17','LMC',NULL,'1990AJ....100.1532W',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43579,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43579,18.2,0.15,0.0437,10597,NULL,NULL,NULL,'LMC',NULL,'1998PhDT........15P',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43580,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43580,18.22,NULL,0.0441,10597,NULL,NULL,'OGLE051756.59-692803.2','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43581,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43581,18.22,0.11,0.0441,10597,NULL,NULL,NULL,'LMC',NULL,'2001AstL...27..108D',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43582,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43582,18.23,0.04,0.0443,10597,NULL,NULL,NULL,'LMC',NULL,'1998AstL...24..171F',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43583,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43583,18.23,0.07,0.0443,10597,NULL,NULL,NULL,'LMC',NULL,'2000AcA....50..279U',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43584,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43584,18.24,0.14,0.0445,10597,NULL,NULL,NULL,'LMC',NULL,'1998ApJ...508..844G',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43585,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43585,18.24,0.08,0.0445,10597,NULL,NULL,NULL,'LMC',NULL,'2001MNRAS.321..502P',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43586,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43586,18.25,NULL,0.0447,10597,NULL,NULL,'OGLE051731.19-692717.7','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43587,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43587,18.26,0.1,0.0449,10597,NULL,NULL,'M(V) = 0.77 mag','LMC',NULL,'1994MNRAS.267..821R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43588,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43588,18.26,NULL,0.0449,10597,NULL,NULL,'OGLE051813.74-692840.6','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43589,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43589,18.26,0.2,0.0449,10597,NULL,NULL,NULL,'LMC',NULL,'1989A&A...209..154C',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43590,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43590,18.26,0.15,0.0449,10597,NULL,NULL,NULL,'LMC',NULL,'1998A&A...330..515F',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43591,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43591,18.27,NULL,0.0451,10597,NULL,NULL,'MACHO10.3802.446','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43592,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43592,18.27,0.08,0.0451,10597,NULL,NULL,'MW center 7.58 kpc','LMC',NULL,'2009MNRAS.396..553D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43593,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43593,18.28,0.03,0.0453,10597,NULL,NULL,'ESO 118- G 031, Reticulum cluster','LMC',NULL,'1996ApJ...466L..17K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43594,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43594,18.28,0.1,0.0453,10597,NULL,NULL,'NGC 2210, Baade-Wesselink','LMC',NULL,'1994MNRAS.267..821R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43595,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43595,18.28,NULL,0.0453,10597,NULL,NULL,'OGLE051751.97-692741.4','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43596,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43596,18.28,NULL,0.0453,10597,NULL,NULL,'OGLE051755.55-692716.3','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43597,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43597,18.28,0.13,0.0453,10597,NULL,NULL,NULL,'LMC',NULL,'1996AJ....112.2110L',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43598,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43598,18.28,0.14,0.0453,10597,NULL,NULL,NULL,'LMC',NULL,'1998ApJ...506..259P',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43599,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43599,18.3,NULL,0.0457,10597,NULL,NULL,'PL pre-1994','LMC',NULL,'1999ASSL..237...53P',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43600,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43600,18.3,NULL,0.0457,10597,NULL,NULL,NULL,'LMC',NULL,'2010vsgh.conf..177D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43601,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43601,18.3,0.14,0.0457,10597,NULL,NULL,NULL,'LMC',NULL,'2003AJ....125.1309C',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43602,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43602,18.3,0.1,0.0457,10597,NULL,NULL,'NGC 2210','LMC',NULL,'1994MNRAS.267..821R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43603,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43603,18.3,0.2,0.0457,10597,NULL,NULL,'K','LMC',NULL,'1991ASPC...14..115C',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43604,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43604,18.3,0.1,0.0457,10597,NULL,NULL,'Baade-Wesselink, M(V) = 0.15 [Fe/H] + 1.01 mag','LMC',NULL,'1994MNRAS.267..821R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43605,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43605,18.3,NULL,0.0457,10597,NULL,NULL,'OGLE051815.14-692924.1','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43606,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43606,18.31,0.14,0.0459,10597,NULL,NULL,NULL,'LMC',NULL,'1998ApJ...506..259P',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43607,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43607,18.32,0.08,0.0461,10597,NULL,NULL,NULL,'LMC',NULL,'2005ESASP.576..707R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43608,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43608,18.32,0.25,0.0461,10597,NULL,NULL,'Photographic','LMC',NULL,'1985ApJS...57..329N',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43609,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43609,18.32,NULL,0.0461,10597,NULL,NULL,'OGLE052032.64-691701.6','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43610,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43610,18.32,0.09,0.0461,10597,NULL,NULL,'V, Ks','LMC',NULL,'2013MNRAS.435.3206D',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43611,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43611,18.33,0.08,0.0463,10597,NULL,NULL,'Best RR Lyrae','LMC',NULL,'1999ASSL..237...53P',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43612,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43612,18.35,NULL,0.0468,10597,NULL,NULL,'MACHO13.5961.623','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43613,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43613,18.35,NULL,0.0468,10597,NULL,NULL,'MACHO13.5961.720','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43614,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43614,18.35,NULL,0.0468,10597,NULL,NULL,'OGLE051825.32-692651.3','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43615,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43615,18.37,0.1,0.0472,10597,NULL,NULL,NULL,'LMC',NULL,'1997MNRAS.284..994C',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43616,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43616,18.37,0.23,0.0472,10597,NULL,NULL,NULL,'LMC',NULL,'1998A&A...335L..81L',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43617,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43617,18.37,0.15,0.0472,10597,NULL,NULL,NULL,'LMC',NULL,'1986MNRAS.221..887R',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43618,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43618,18.37,0.1,0.0472,10597,NULL,NULL,'ESO 118- G 031, Reticulum cluster, 21 RRab, 9 RRc','LMC',NULL,'2010vsgh.conf...45F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43619,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43619,18.37,0.1,0.0472,10597,NULL,NULL,'Baade-Wesselink','LMC',NULL,'1994MNRAS.267..821R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43620,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43620,18.37,NULL,0.0472,10597,NULL,NULL,'OGLE051752.63-692856.4','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43621,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43621,18.38,0.1,0.0474,10597,NULL,NULL,NULL,'LMC',NULL,'2002AJ....123..473B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43622,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43622,18.38,0.12,0.0474,10597,NULL,NULL,NULL,'LMC',NULL,'2000ApJ...533..215C',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43623,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43623,18.38,0.16,0.0474,10597,NULL,NULL,NULL,'LMC',NULL,'2003AJ....125.1309C',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43624,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43624,18.38,NULL,0.0474,10597,NULL,NULL,'ESO 118- G 031, Reticulum cluster','LMC',NULL,'1992AJ....103.1166W',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43625,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43625,18.38,0.1,0.0474,10597,NULL,NULL,'ESO 118- G 031, Reticulum cluster, 21 RRab, 9 RRc','LMC',NULL,'2010vsgh.conf...45F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43626,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43626,18.38,0.17,0.0474,10597,NULL,NULL,'Field Ne01','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43627,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43627,18.38,NULL,0.0474,10597,NULL,NULL,'MACHO13.5961.511','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43628,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43628,18.39,NULL,0.0476,10597,NULL,NULL,'MACHO13.5962.656','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43629,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43629,18.39,0.24,0.0476,10597,NULL,NULL,NULL,'LMC',NULL,'2012AJ....144..186K',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43630,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43630,18.4,0.2,0.0479,10597,NULL,NULL,'V','LMC',NULL,'2013AJ....145..160K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43631,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43631,18.4,NULL,0.0479,10597,NULL,NULL,NULL,'LMC',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43632,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43632,18.4,0.23,0.0479,10597,NULL,NULL,'13,095, Metallicity group 3','LMC',NULL,'2014MNRAS.438.2440D',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43633,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43633,18.4,NULL,0.0479,10597,NULL,NULL,'MACHO2.5628.6276','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43634,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43634,18.4,0.1,0.0479,10597,NULL,NULL,NULL,'LMC',NULL,'1994MNRAS.267..821R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43635,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43635,18.4,NULL,0.0479,10597,NULL,NULL,'PL pre-1994','LMC',NULL,'1999ASSL..237...53P',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43636,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43636,18.4,0.2,0.0479,10597,NULL,NULL,'BW','LMC',NULL,'2000ApJ...533..215C',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43637,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43637,18.41,0.08,0.0481,10597,NULL,NULL,'Field LMC-E4','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43638,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43638,18.41,0.05,0.0481,10597,NULL,NULL,'NGC 1841, for IC 4499 m-M = 16.47','LMC',NULL,'2001A&A...371..579K',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43639,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43639,18.42,0.1,0.0483,10597,NULL,NULL,'NGC 2210, 9','LMC',NULL,'1985MNRAS.212..343W',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43640,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43640,18.42,NULL,0.0483,10597,NULL,NULL,'M(V) = +0.6 mag, Fe/H = -1.9','LMC',NULL,'1985MmSAI..56..213F',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43641,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43641,18.43,0.06,0.0485,10597,NULL,NULL,NULL,'LMC',NULL,'2004AJ....127..334A',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43642,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43642,18.43,0.09,0.0485,10597,NULL,NULL,NULL,'LMC',NULL,'1988AJ.....96..872W',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43643,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43643,18.43,NULL,0.0485,10597,NULL,NULL,NULL,'LMC',NULL,'1988ASPC....4....9F',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43644,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43644,18.43,0.1,0.0485,10597,NULL,NULL,'Baade-Wesselink','LMC',NULL,'1994A&A...284L..16F',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43645,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43645,18.43,0.15,0.0485,10597,NULL,NULL,'NGC 1466','LMC',NULL,'2011AJ....142..107K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43646,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43646,18.43,NULL,0.0485,10597,NULL,NULL,'MACHO80.6468.2616','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43647,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43647,18.43,NULL,0.0485,10597,NULL,NULL,'RR Lyrae + Red Clump','LMC',NULL,'2002ASPC..259..124C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43648,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43648,18.44,0.05,0.0488,10597,NULL,NULL,'NGC 1786','LMC',NULL,'1988AJ.....96.1362W',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43649,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43649,18.44,0.11,0.0488,10597,NULL,NULL,NULL,'LMC',NULL,'2008ApJ...676L.135C',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43650,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43650,18.44,0.14,0.0488,10597,NULL,NULL,'ESO 118- G 031, Reticulum cluster, V','LMC',NULL,'2008MNRAS.384.1583S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43651,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43651,18.44,0.1,0.0488,10597,NULL,NULL,NULL,'LMC',NULL,'1997MNRAS.284..994C',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43652,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43652,18.44,0.11,0.0488,10597,NULL,NULL,NULL,'LMC',NULL,'2009Ap&SS.320..261C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43653,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43653,18.45,0.04,0.049,10597,NULL,NULL,'K','LMC',NULL,'2003LNP...635...85B',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43654,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43654,18.45,0.12,0.049,10597,NULL,NULL,'K','LMC',NULL,'1985MmSAI..56..213F',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43655,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43655,18.45,0.09,0.049,10597,NULL,NULL,NULL,'LMC',NULL,'2003AJ....125.1309C',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43656,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43656,18.46,0.03,0.0492,10597,NULL,NULL,'K','LMC',NULL,'2006MmSAI..77..214D',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43657,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43657,18.46,0.07,0.0492,10597,NULL,NULL,NULL,'LMC',NULL,'2009IAUS..256..373C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43658,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43658,18.46,0.08,0.0492,10597,NULL,NULL,NULL,'LMC',NULL,'2005AAS...20712204C',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43659,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43659,18.46,0.09,0.0492,10597,NULL,NULL,NULL,'LMC',NULL,'2003ASPC..296..381G',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43660,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43660,18.46,NULL,0.0492,10597,NULL,NULL,'Field LMC-E1','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43661,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43661,18.46,NULL,0.0492,10597,NULL,NULL,'MACHO11.8750.1827','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43662,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43662,18.46,0.04,0.0492,10597,NULL,NULL,'ESO 118- G 031, Reticulum cluster, for IC 4499 m-M = 16.47','LMC',NULL,'2001A&A...371..579K',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43663,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43663,18.47,0.22,0.0494,10597,NULL,NULL,'13,095, Metallicity group 2','LMC',NULL,'2014MNRAS.438.2440D',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43664,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43664,18.47,0.07,0.0494,10597,NULL,NULL,NULL,'LMC',NULL,'2003AJ....125.1261D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43665,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43665,18.47,0.07,0.0494,10597,NULL,NULL,'ESO 118- G 031, Reticulum cluster','LMC',NULL,'2004MmSAI..75..138D',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43666,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43666,18.47,0.19,0.0494,10597,NULL,NULL,NULL,'LMC',NULL,'2000ApJ...533..215C',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43667,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43667,18.47,NULL,0.0494,10597,NULL,NULL,'MACHO80.6468.2799','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43668,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43668,18.47,NULL,0.0494,10597,NULL,NULL,NULL,'LMC',NULL,'2004ApJS..154..633C',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43669,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43669,18.47,0.06,0.0494,10597,NULL,NULL,'I','LMC',NULL,'2013AJ....145..160K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43670,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43670,18.47,NULL,0.0494,10597,NULL,NULL,'K','LMC',NULL,'2013ApJ...776..135M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43671,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43671,18.47,NULL,0.0494,10597,NULL,NULL,'RR Lyrae + HB','LMC',NULL,'2002ASPC..259..124C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43672,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43672,18.48,0.01,0.0497,10597,NULL,NULL,'63','LMC',NULL,'2015ApJ...815...87C',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43673,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43673,18.48,0.11,0.0497,10597,NULL,NULL,'ESO 118- G 031, Reticulum cluster, K','LMC',NULL,'2008MNRAS.384.1583S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43674,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43674,18.48,0.13,0.0497,10597,NULL,NULL,'V, LMC center','LMC',NULL,'2008MNRAS.384.1583S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43675,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43675,18.48,0.08,0.0497,10597,NULL,NULL,NULL,'LMC',NULL,'2004A&A...423...97B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43676,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43676,18.49,0.31,0.0499,10597,NULL,NULL,'Field LMC-E7','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43677,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43677,18.49,NULL,0.0499,10597,NULL,NULL,'MACHO13.5840.768','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43678,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43678,18.49,0.06,0.0499,10597,NULL,NULL,'NGC 1841, 17','LMC',NULL,'1990AJ....100.1532W',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43679,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43679,18.49,0.11,0.0499,10597,NULL,NULL,NULL,'LMC',NULL,'2008AJ....135...83C',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43680,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43680,18.49,0.15,0.0499,10597,NULL,NULL,NULL,'LMC',NULL,'1983ApJ...274...20S',1983,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43681,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43681,18.5,NULL,0.0501,10597,NULL,NULL,NULL,'LMC',NULL,'1999ASSL..237..125W',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43682,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43682,18.5,0.09,0.0501,10597,NULL,NULL,NULL,'LMC',NULL,'2003A&A...408..529G',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43683,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43683,18.5,0.23,0.0501,10597,NULL,NULL,'V, all Fe/H','LMC',NULL,'1985MmSAI..56..213F',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43684,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43684,18.5,0.1,0.0501,10597,NULL,NULL,'based on small number of field stars','LMC',NULL,'1994MNRAS.267..821R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43685,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43685,18.5,NULL,0.0501,10597,NULL,NULL,'MACHO11.8871.1122','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43686,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43686,18.5,NULL,0.0501,10597,NULL,NULL,'OGLE051756.52-692934.7','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43687,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43687,18.51,NULL,0.0503,10597,NULL,NULL,'15040, Syst. +/- 0.02 mag','LMC',NULL,'2014arXiv1405.1035K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43688,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43688,18.51,NULL,0.0504,10597,NULL,NULL,'Baade-Wesselink','LMC',NULL,'1995ASPC...83..209F',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43689,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43689,18.51,0.06,0.0504,10597,NULL,NULL,'J','LMC',NULL,'2003LNP...635...85B',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43690,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43690,18.51,0.09,0.0504,10597,NULL,NULL,'125, BVI','LMC',NULL,'2004MmSAI..75..130M',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43691,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43691,18.52,0.09,0.0505,10597,NULL,NULL,NULL,'LMC',NULL,'2003AJ....125.1309C',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43692,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43692,18.52,0.09,0.0505,10597,NULL,NULL,NULL,'LMC',NULL,'2004ASPC..310...60C',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43693,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43693,18.52,0.02,0.0506,10597,NULL,NULL,'OI','LMC',NULL,'2014AJ....147...31M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43694,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43694,18.52,0.01,0.0506,10597,NULL,NULL,'ESO 118- G 031, Reticulum cluster, K, 21 RRab, 9 RRc','LMC',NULL,'2004ApJ...610..269D',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43695,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43695,18.52,0.02,0.0506,10597,NULL,NULL,NULL,'LMC',NULL,'2000A&A...363L...1K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43696,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43696,18.52,0.01,0.0507,10597,NULL,NULL,'ESO 118- G 031, Reticulum cluster','LMC',NULL,'2011rrls.conf....1B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43697,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43697,18.53,0.04,0.0508,10597,NULL,NULL,'BW','LMC',NULL,'1997MNRAS.284..761F',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43698,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43698,18.53,0.1,0.0508,10597,NULL,NULL,'BW','LMC',NULL,'1997PASP..109..857M',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43699,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43699,18.53,0.1,0.0508,10597,NULL,NULL,NULL,'LMC',NULL,'2002AJ....123..473B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43700,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43700,18.53,NULL,0.0508,10597,NULL,NULL,'Z','LMC',NULL,'1988ASPC....4....9F',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43701,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43701,18.53,NULL,0.0508,10597,NULL,NULL,NULL,'LMC',NULL,'2008ApJ...679...52T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43702,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43702,18.53,0.13,0.0508,10597,NULL,NULL,'K, 50','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43703,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43703,18.53,0.07,0.0508,10597,NULL,NULL,'RR Lyrae c','LMC',NULL,'2011AJ....142..110M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43704,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43704,18.53,NULL,0.0508,10597,NULL,NULL,'VK, reduced parallax method','LMC',NULL,'2011AJ....142..187B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43705,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43705,18.53,NULL,0.0508,10597,NULL,NULL,'MACHO13.5961.435','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43706,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43706,18.53,NULL,0.0508,10597,NULL,NULL,'OGLE052003.29-691316.1','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43707,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43707,18.53,NULL,0.0508,10597,NULL,NULL,NULL,'LMC',NULL,'2004astro.ph..5015F',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43708,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43708,18.53,0.02,0.0508,10597,NULL,NULL,'weighted mean','LMC',NULL,'2014AJ....147...31M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43709,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43709,18.54,0.15,0.051,10597,NULL,NULL,NULL,'LMC',NULL,'2006MNRAS.372.1675S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43710,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43710,18.54,NULL,0.0511,10597,NULL,NULL,NULL,'LMC',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43711,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43711,18.54,NULL,0.0511,10597,NULL,NULL,NULL,'LMC',NULL,'1993ApJ...410..526S',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43712,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43712,18.54,0.2,0.0511,10597,NULL,NULL,'Field LMC-E9','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43713,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43713,18.54,NULL,0.0511,10597,NULL,NULL,'OGLE052834.72-693326.4','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43714,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43714,18.54,0.02,0.0511,10597,NULL,NULL,'15, BV','LMC',NULL,'2005AJ....129.2257M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43715,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43715,18.55,0.03,0.0512,10597,NULL,NULL,'J, RRab+RRc, Catelan et al. (2004)','LMC',NULL,'2008AJ....136..272S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43716,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43716,18.55,0.1,0.0513,10597,NULL,NULL,NULL,'LMC',NULL,'2013MNRAS.431.1565W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43717,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43717,18.55,0.05,0.0513,10597,NULL,NULL,'VK, LHK method','LMC',NULL,'2011AJ....142..187B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43718,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43718,18.55,0.1,0.0513,10597,NULL,NULL,'Z','LMC',NULL,'1988AJ.....96..872W',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43719,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43719,18.55,0.03,0.0513,10597,NULL,NULL,NULL,'LMC',NULL,'2003MNRAS.342L..58K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43720,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43720,18.55,0.15,0.0513,10597,NULL,NULL,NULL,'LMC',NULL,'1992MmSAI..63..479W',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43721,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43721,18.56,NULL,0.0515,10597,NULL,NULL,'OGLE052005.99-691313.3','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43722,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43722,18.56,0.02,0.0515,10597,NULL,NULL,'OII','LMC',NULL,'2014AJ....147...31M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43723,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43723,18.56,0.03,0.0516,10597,NULL,NULL,'K, RRab+RRc, Sollima et al. (2008)','LMC',NULL,'2008AJ....136..272S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43724,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43724,18.57,0.03,0.0516,10597,NULL,NULL,'J, RRab, Catelan et al. (2004)','LMC',NULL,'2008AJ....136..272S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43725,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43725,18.57,0.03,0.0518,10597,NULL,NULL,'NGC 1466','LMC',NULL,'1996ApJ...466L..17K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43726,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43726,18.57,0.19,0.0518,10597,NULL,NULL,NULL,'LMC',NULL,'1997ApJ...482...89A',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43727,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43727,18.58,0.07,0.052,10597,NULL,NULL,'RR Lyrae ab','LMC',NULL,'2011AJ....142..110M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43728,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43728,18.58,NULL,0.052,10597,NULL,NULL,'OGLE053418.91-702309.6','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43729,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43729,18.58,0.03,0.052,10597,NULL,NULL,'K, RRab+RRc, Sollima et al. (2008)','LMC',NULL,'2008AJ....136..272S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43730,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43730,18.58,0.03,0.052,10597,NULL,NULL,NULL,'LMC',NULL,'2008AJ....136..272S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43731,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43731,18.58,0.1,0.052,10597,NULL,NULL,NULL,'LMC',NULL,'2004ASPC..310...60C',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43732,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43732,18.58,0.03,0.052,10597,NULL,NULL,'K, RRab, Sollima et al. (2008)','LMC',NULL,'2008AJ....136..272S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43733,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43733,18.59,NULL,0.0522,10597,NULL,NULL,'OGLE052829.20-693201.1','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43734,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43734,18.59,0.03,0.0522,10597,NULL,NULL,'K, RRab+RRc, Catelan et al. (2004)','LMC',NULL,'2008AJ....136..272S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43735,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43735,18.59,0.24,0.0523,10597,NULL,NULL,'13,095, Metallicity group 1','LMC',NULL,'2014MNRAS.438.2440D',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43736,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43736,18.6,0.03,0.0525,10597,NULL,NULL,'K, RRab, Sollima et al. (2008)','LMC',NULL,'2008AJ....136..272S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43737,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43737,18.6,0.07,0.0525,10597,NULL,NULL,'Best RR Lyrae','LMC',NULL,'1999ASSL..237...53P',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43738,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43738,18.6,NULL,0.0525,10597,NULL,NULL,NULL,'LMC',NULL,'2000MNRAS.316..819C',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43739,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43739,18.6,0.03,0.0526,10597,NULL,NULL,'K, RRab+RRc, Bono et al. (2003)','LMC',NULL,'2008AJ....136..272S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43740,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43740,18.61,0.03,0.0527,10597,NULL,NULL,'K, RRab+RRc, Catelan et al. (2004)','LMC',NULL,'2008AJ....136..272S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43741,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43741,18.61,0.03,0.0527,10597,NULL,NULL,'K, RRab, Catelan et al. (2004)','LMC',NULL,'2008AJ....136..272S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43742,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43742,18.61,0.28,0.0527,10597,NULL,NULL,NULL,'LMC',NULL,'1999A&A...348L..33G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43743,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43743,18.6,0.17,0.0527,10597,NULL,NULL,'16949, V, area-averaged dereddening','LMC',NULL,'2012AJ....144..106H',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43744,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43744,18.61,0.11,0.0527,10597,NULL,NULL,'Field LMC-E14','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43745,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43745,18.61,NULL,0.0527,10597,NULL,NULL,'MACHO11.8750.1425','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43746,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43746,18.61,0.03,0.0527,10597,NULL,NULL,'K, RRab, Catelan et al. (2004)','LMC',NULL,'2008AJ....136..272S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43747,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43747,18.62,0.03,0.0529,10597,NULL,NULL,'K, RRab, Bono et al. (2003)','LMC',NULL,'2008AJ....136..272S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43748,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43748,18.62,0.03,0.053,10597,NULL,NULL,'NGC 1841','LMC',NULL,'1996ApJ...466L..17K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43749,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43749,18.62,NULL,0.053,10597,NULL,NULL,'OGLE052011.82-691424.0','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43750,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43750,18.62,NULL,0.053,10597,NULL,NULL,'OGLE052822.65-693529.9','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43751,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43751,18.62,0.03,0.053,10597,NULL,NULL,'K, RRab, Bono et al. (2003)','LMC',NULL,'2008AJ....136..272S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43752,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43752,18.62,0.03,0.053,10597,NULL,NULL,'K, RRab+RRc, Bono et al. (2003)','LMC',NULL,'2008AJ....136..272S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43753,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43753,18.62,0.13,0.0531,10597,NULL,NULL,'16949, V, individual dereddening','LMC',NULL,'2012AJ....144..106H',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43754,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43754,18.63,NULL,0.0532,10597,NULL,NULL,'MACHO11.8623.779','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43755,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43755,18.63,NULL,0.0532,10597,NULL,NULL,'OLGE052033.36-691334.2','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43756,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43756,18.64,NULL,0.0535,10597,NULL,NULL,'OGLE053504.52-702444.9','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43757,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43757,18.64,0.04,0.0535,10597,NULL,NULL,'NGC 1466, for IC 4499 m-M = 16.47','LMC',NULL,'2001A&A...371..579K',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43758,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43758,18.64,0.04,0.0535,10597,NULL,NULL,NULL,'LMC',NULL,'2001PASP..113..335M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43759,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43759,18.65,0.1,0.0537,10597,NULL,NULL,NULL,'LMC',NULL,'1997AJ....114..161R',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43760,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43760,18.66,NULL,0.054,10597,NULL,NULL,'OGLE053443.15-702543.8','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43761,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43761,18.68,0.1,0.0545,10597,NULL,NULL,'70, K, GAL PL Benedict et al. 2011','LMC',NULL,'2015ApJ...807..127M',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43762,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43762,18.68,0.05,0.0545,10597,NULL,NULL,'Field LMC-E12','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43763,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43763,18.68,NULL,0.0545,10597,NULL,NULL,'OGLE052854.41-693403.8','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43764,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43764,18.68,NULL,0.0545,10597,NULL,NULL,'OGLE051751.38-692707.5','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43765,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43765,18.68,NULL,0.0545,10597,NULL,NULL,'OGLE051738.47-692628.8','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43766,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43766,18.69,NULL,0.0547,10597,NULL,NULL,'OGLE052030.65-691345.2','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43767,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43767,18.7,NULL,0.055,10597,NULL,NULL,'MACHO11.8623.826','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43768,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43768,18.7,NULL,0.055,10597,NULL,NULL,'OGLE052002.59-691431.1','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43769,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43769,18.71,NULL,0.0552,10597,NULL,NULL,'OGLE052027.12-691607.1','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43770,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43770,18.71,0.07,0.0552,10597,NULL,NULL,NULL,'LMC',NULL,'1998AJ....115..204R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43771,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43771,18.74,0.17,0.056,10597,NULL,NULL,'Field LMC-F1','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43772,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43772,18.75,NULL,0.0562,10597,NULL,NULL,'MACHO10.3802.311','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43773,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43773,18.75,NULL,0.0562,10597,NULL,NULL,'OGLE052044.57-691726.3','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43774,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43774,18.77,NULL,0.0568,10597,NULL,NULL,'MACHO10.3923.351','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43775,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43775,18.84,NULL,0.0586,10597,NULL,NULL,'OGLE052822.98-693310.6','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43776,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43776,18.89,NULL,0.06,10597,NULL,NULL,'OGLE052018.99-691527.0','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43777,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43777,18.94,NULL,0.0614,10597,NULL,NULL,'OGLE052829.28-693442.0','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43778,'RR Lyrae','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43778,18.96,NULL,0.0619,10597,NULL,NULL,'OGLE052827.10-693347.7','LMC',NULL,'2009A&A...502..505B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43779,'Subdwarf fitting','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43779,18.64,0.12,0.0535,10597,NULL,NULL,NULL,'LMC',NULL,'2000ApJ...533..215C',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43780,'SNII radio','2016-12-15 15:14:11','2016-12-16 11:19:16','1','SN 1987A',NULL,43780,19.26,NULL,0.071,10597,NULL,NULL,NULL,'LMC',NULL,'1998ApJ...500...51W',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43781,'TRGB','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43781,18.24,0.08,0.0445,10597,NULL,NULL,NULL,'LMC',NULL,'2000AcA....50..279U',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43782,'TRGB','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43782,18.42,0.15,0.0483,10597,NULL,NULL,'I','LMC',NULL,'1987ApJ...323..433R',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43783,'TRGB','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43783,18.42,0.1,0.0483,10597,NULL,NULL,'I','LMC',NULL,'1993ApJ...417..553L',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43784,'TRGB','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43784,18.46,0.06,0.0492,10597,NULL,NULL,'IJK','LMC',NULL,'2004A&A...424..199B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43785,'TRGB','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43785,18.46,0.12,0.0492,10597,NULL,NULL,'HST KP Calibrated','LMC',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43786,'TRGB','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43786,18.48,0.06,0.05,10597,74.4,NULL,NULL,'LMC',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43787,'TRGB','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43787,18.52,0.09,0.0506,10597,NULL,NULL,NULL,'LMC',NULL,'2003AJ....125.1261D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43788,'TRGB','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43788,18.53,NULL,0.0508,10597,NULL,NULL,'theory','LMC',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43789,'TRGB','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43789,18.54,0.04,0.0511,10597,NULL,NULL,'I','LMC',NULL,'2004A&A...424..199B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43790,'TRGB','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43790,18.55,0.04,0.0513,10597,NULL,NULL,NULL,'LMC',NULL,'2000A&A...359..601C',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43791,'TRGB','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43791,18.59,0.09,0.0522,10597,NULL,NULL,NULL,'LMC',NULL,'2000AJ....119.1197S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43792,'TRGB','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43792,18.59,0.09,0.0522,10597,NULL,NULL,NULL,'LMC',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43793,'TRGB','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43793,18.59,NULL,0.0522,10597,NULL,NULL,NULL,'LMC',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43794,'TRGB','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43794,18.6,NULL,0.0525,10597,NULL,NULL,'DA90','LMC',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43795,'TRGB','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43795,18.64,NULL,0.0535,10597,NULL,NULL,'K97','LMC',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43796,'TRGB','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43796,18.64,0.14,0.0535,10597,NULL,NULL,'Yale','LMC',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43797,'TRGB','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43797,18.69,0.25,0.0547,10597,NULL,NULL,NULL,'LMC',NULL,'2000ApJ...530..738R',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43798,'Type II Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43798,18.37,0.09,0.0472,10597,NULL,NULL,NULL,'LMC',NULL,'2008mear.confE...3F',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43799,'Type II Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43799,18.37,0.09,0.0472,10597,NULL,NULL,NULL,'LMC',NULL,'2008MNRAS.386.2115F',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43800,'Type II Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43800,18.4,0.08,0.0479,10597,NULL,NULL,'Type II Cepheids','LMC',NULL,'2011ApJ...741L..36M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43801,'Type II Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43801,18.43,0.03,0.0485,10597,NULL,NULL,'Dwarf and classical Cepheids, RR Lyrae, SX Pho, and delta Scuti','LMC',NULL,'2011JAVSO..39..122M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43802,'Type II Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43802,18.45,NULL,0.049,10597,NULL,NULL,NULL,'LMC',NULL,'1987ARA&A..25..345F',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43803,'Type II Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43803,18.46,0.04,0.0492,10597,NULL,NULL,'130, VJK, PL LMC','LMC',NULL,'2015MNRAS.446.3034R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43804,'Type II Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43804,18.46,0.1,0.0492,10597,NULL,NULL,NULL,'LMC',NULL,'2009MNRAS.397..933M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43805,'Type II Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43805,18.46,0.04,0.0492,10597,NULL,NULL,'130, VJK, PW LMC','LMC',NULL,'2015MNRAS.446.3034R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43806,'Type II Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43806,18.46,0.1,0.0492,10597,NULL,NULL,'ESO 118- G 031, Reticulum cluster, 21 RRab, 9 RRc','LMC',NULL,'2010vsgh.conf...45F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43807,'Type II Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,'R',43807,18.5,0.1,0.0501,10597,NULL,NULL,'ESO 118- G 031, Reticulum cluster, 21 RRab, 9 RRc','LMC',NULL,'2010vsgh.conf...45F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43808,'Type II Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43808,18.56,0.1,0.0515,10597,NULL,NULL,'130, VJK, PL GAL 1','LMC',NULL,'2015MNRAS.446.3034R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43809,'Type II Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43809,18.57,0.1,0.0518,10597,NULL,NULL,'130, VJK, PW GAL 1','LMC',NULL,'2015MNRAS.446.3034R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43810,'Type II Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43810,18.58,0.1,0.052,10597,NULL,NULL,'130, VJK, PL GAL 2','LMC',NULL,'2015MNRAS.446.3034R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43811,'Type II Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:16','1',NULL,NULL,43811,18.59,0.1,0.0522,10597,NULL,NULL,'130, VJK, PW GAL 2','LMC',NULL,'2015MNRAS.446.3034R',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43812,'Type II Cepheids','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43812,18.62,NULL,0.053,10597,NULL,NULL,NULL,'LMC',NULL,'2010AJ....139..878S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43813,'White Dwarfs','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43813,18.4,0.15,0.0479,10597,NULL,NULL,'cooling sequence','LMC',NULL,'2000ApJ...533..215C',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43814,'Statistical','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,'R',43814,18.41,0.34,0.0481,10597,NULL,NULL,'38 estimates','LMC',NULL,'2000MmSAI..71..693G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43815,'Statistical','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43815,18.44,0.18,0.0488,10597,NULL,NULL,'144 estimates','LMC',NULL,'2008AJ....135..112S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43816,'Statistical','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,'R',43816,18.44,0.19,0.0488,10597,NULL,NULL,'180 non-Cepheids estimates','LMC',NULL,'2010ARA&A..48..673F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43817,'Statistical','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43817,18.44,0.18,0.0488,10597,NULL,NULL,'11 estimates','LMC',NULL,'1998ApJ...500L.137C',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43818,'Statistical','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,'R',43818,18.45,0.1,0.049,10597,NULL,NULL,'40 estimates','LMC',NULL,'1997macl.book.....W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43819,'Statistical','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43819,18.47,0.04,0.0494,10597,NULL,NULL,'21 indicators, 84 estimates','LMC',NULL,'2002AJ....123..473B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43820,'Statistical','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43820,18.48,0.01,0.0497,10597,NULL,NULL,NULL,'LMC',NULL,'2013ApJ...772..130M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43821,'Statistical','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,'R',43821,18.48,0.04,0.0497,10597,NULL,NULL,'6 indicators, 11 estimates','LMC',NULL,'2003LNP...635...45F',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43822,'Statistical','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,'R',43822,18.48,0.05,0.0497,10597,NULL,NULL,'5 indicators','LMC',NULL,'2012Ap&SS.341...43W',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43823,'Statistical','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,'R',43823,18.48,NULL,0.0497,10597,NULL,NULL,'110 estimates','LMC',NULL,'2014arXiv1410.7843C',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43824,'Statistical','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43824,18.49,0.13,0.0499,10597,NULL,NULL,'232 est.','LMC',NULL,'2015ApJ...815...87C',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43825,'Statistical','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43825,18.49,0.09,0.0499,10597,NULL,NULL,'233 esrimates','LMC',NULL,'2014AJ....147..122D',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43826,'Statistical','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,'R',43826,18.52,0.1,0.0506,10597,NULL,NULL,'7 indicators','LMC',NULL,'2003LNP...635..265W',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43827,'Statistical','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43827,18.54,0.02,0.0511,10597,NULL,NULL,'13 estimates','LMC',NULL,'2003A&A...404..423T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43828,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43828,18.18,0.09,0.0432,10597,NULL,NULL,'HV 05936','LMC',NULL,'2003ApJ...587..685F',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43829,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43829,18.22,0.13,0.0441,10597,NULL,NULL,'HV 02274','LMC',NULL,'1998ApJ...509L..25U',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43830,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43830,18.23,0.09,0.0443,10597,NULL,NULL,'LMC center','LMC',NULL,'2003ApJ...587..685F',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43831,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,'R',43831,18.25,0.25,0.0447,10597,NULL,NULL,'EROS 1044','LMC',NULL,'2001AAS...198.0309M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43832,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43832,18.3,0.07,0.0457,10597,NULL,NULL,NULL,'LMC',NULL,'1998ApJ...509L..21G',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43833,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43833,18.3,0.07,0.0457,10597,NULL,NULL,NULL,'LMC',NULL,'2000ApJ...533..215C',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43834,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43834,18.31,0.1,0.0459,10597,NULL,NULL,'LMC I=38deg, PA=168deg, vs. HV 2274','LMC',NULL,'2002ApJ...564..260F',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43835,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43835,18.35,0.07,0.0468,10597,NULL,NULL,'HV 02274','LMC',NULL,'1998ApJ...509L..21G',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43836,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43836,18.36,0.1,0.047,10597,NULL,NULL,'HV 02274','LMC',NULL,'2002ApJ...564..260F',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43837,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,'R',43837,18.36,0.35,0.047,10597,NULL,NULL,'Method II','LMC',NULL,'1974AcC.....2...13D',1974,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43838,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43838,18.37,0.08,0.0473,10597,NULL,NULL,'LMC I=38deg, PA=168deg','LMC',NULL,'2002ApJ...574..771R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43839,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43839,18.38,0.08,0.0474,10597,NULL,NULL,'LMC I=34.7deg, PA=122.5deg','LMC',NULL,'2002ApJ...574..771R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43840,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43840,18.38,0.08,0.0475,10597,NULL,NULL,'EROS 1044','LMC',NULL,'2002ApJ...574..771R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43841,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43841,18.4,0.07,0.0479,10597,NULL,NULL,'HV 02274','LMC',NULL,'2000AJ....119.1205N',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43842,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,'R',43842,18.42,NULL,0.0483,10597,NULL,NULL,NULL,'LMC',NULL,'2004ASPC..310..363G',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43843,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43843,18.42,0.06,0.0483,10597,NULL,NULL,'mean of all','LMC',NULL,'2007A&A...473..847V',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43844,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43844,18.42,0.08,0.0483,10597,NULL,NULL,'LMC','LMC',NULL,'2001A&A...366..752G',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43845,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43845,18.42,0.24,0.0483,10597,NULL,NULL,'HV 00982, HV 00982 B','LMC',NULL,'2002A&A...381..440S',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43846,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43846,18.42,0.06,0.0483,10597,NULL,NULL,NULL,'LMC',NULL,'2007Natur.449..872O',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43847,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,'R',43847,18.43,0.2,0.0485,10597,NULL,NULL,'HV 02241','LMC',NULL,'1996ASPC...90..196G',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43848,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43848,18.43,0.24,0.0485,10597,NULL,NULL,'HV 00982, HV 00982 A','LMC',NULL,'2002A&A...381..440S',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43849,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43849,18.43,NULL,0.0485,10597,NULL,NULL,'LMC m-M = SMC m-M = -0.44 mag','LMC',NULL,'2012ApJ...750..144G',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43850,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,'R',43850,18.44,0.07,0.0488,10597,NULL,NULL,'HV 02274','LMC',NULL,'1998ESASP.413..315G',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43851,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,'R',43851,18.46,0.08,0.0492,10597,NULL,NULL,NULL,'LMC',NULL,'2004NewAR..48..659A',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43852,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43852,18.46,0.06,0.0492,10597,NULL,NULL,'HV 02274','LMC',NULL,'2001A&A...366..752G',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43853,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43853,18.49,0.07,0.0499,10597,NULL,NULL,'SMC - 0.458 mag','LMC',NULL,'2014ApJ...780...59G',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43854,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43854,18.49,0.01,0.05,10597,NULL,NULL,'avg. of 8 Ebs','LMC',NULL,'2013Natur.495...76P',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43855,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43855,18.5,0.06,0.0501,10597,NULL,NULL,'OGLE-051019.64-685812.3','LMC',NULL,'2009ApJ...697..862P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43856,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43856,18.5,0.02,0.0501,10597,NULL,NULL,'OGLE-LMC-CEP-0227, Syst. +/- 0.10 mag','LMC',NULL,'2013ApJ...768L...6M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43857,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43857,18.5,0.5,0.0501,10597,NULL,NULL,'HV 02241','LMC',NULL,'1998MNRAS.297..278P',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43858,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43858,18.5,0.06,0.0502,10597,NULL,NULL,'HV 00982','LMC',NULL,'2002ApJ...564..260F',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43859,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43859,18.52,0.06,0.0506,10597,NULL,NULL,'LMC I=38deg, PA=168deg, vs. HV 982','LMC',NULL,'2002ApJ...564..260F',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43860,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43860,18.52,0.07,0.0506,10597,NULL,NULL,'LMC-SC1-105','LMC',NULL,'2011ApJ...729L...9B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43861,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,'R',43861,18.54,0.08,0.0511,10597,NULL,NULL,'HV 02274','LMC',NULL,'1997AAS...191.0313G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43862,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,'R',43862,18.61,0.2,0.0527,10597,NULL,NULL,'HV 02274','LMC',NULL,'1996ASPC...90..196G',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43863,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43863,18.63,0.08,0.0532,10597,NULL,NULL,'HV 00982','LMC',NULL,'2003A&A...402..509C',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43864,'Eclipsing Binary','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,'R',43864,18.7,0.15,0.055,10597,NULL,NULL,'HV 00982','LMC',NULL,'2000fepc.conf..232P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43865,'GC radius','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43865,18.5,0.11,0.0501,10597,NULL,NULL,NULL,'LMC',NULL,'2000ApJ...533..215C',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43866,'HII region diameter','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43866,17.96,0.15,0.0391,10597,NULL,NULL,'Method 1','LMC',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43867,'HII region diameter','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43867,18.15,0.12,0.0427,10597,NULL,NULL,NULL,'LMC',NULL,'1986Ap&SS.125...43I',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43868,'HII region diameter','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43868,18.21,0.13,0.0439,10597,NULL,NULL,'Method 2','LMC',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43869,'Maser','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43869,18.3,0.15,0.0457,10597,NULL,NULL,'NGC 4258','LMC',NULL,'2002ApJ...566..833C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43870,'Maser','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43870,18.31,0.11,0.0459,10597,NULL,NULL,'NGC 4258','LMC',NULL,'2001ApJ...553..562N',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43871,'Maser','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43871,18.48,0.13,0.0495,10597,NULL,NULL,'NGC 4258','LMC',NULL,'2002ApJ...566..833C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43872,'Proper Motion','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43872,17.58,0.89,0.0328,10597,NULL,NULL,'systemic LOS velocity','LMC',NULL,'2014ApJ...781..121V',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43873,'Proper Motion','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43873,18.48,0.4,0.0497,10597,NULL,NULL,'Rotational parallax','LMC',NULL,'2014ApJ...781..121V',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43874,'Proper Motion','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43874,18.53,0.2,0.0508,10597,NULL,NULL,'LOS velocities perpendicular to the line of nodes','LMC',NULL,'2014ApJ...781..121V',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43875,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A',NULL,43875,18.12,0.1,0.0421,10597,NULL,NULL,NULL,'LMC',NULL,'1988BAAS...20..985W',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43876,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A','R',43876,18.18,0.2,0.0433,10597,NULL,NULL,NULL,'LMC',NULL,'1988LNP...305..295C',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43877,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A',NULL,43877,18.28,0.18,0.0453,10597,NULL,NULL,NULL,'LMC',NULL,'1990ApJ...355..255S',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43878,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A','R',43878,18.31,0.18,0.046,10597,NULL,NULL,NULL,'LMC',NULL,'1987LNP...287..307H',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43879,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A',NULL,43879,18.35,0.04,0.0468,10597,NULL,NULL,NULL,'LMC',NULL,'1995ApJ...452..189G',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43880,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A','R',43880,18.36,0.42,0.047,10597,NULL,NULL,NULL,'LMC',NULL,'1987ATsir1494....1C',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43881,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A',NULL,43881,18.37,0.04,0.0472,10597,NULL,NULL,NULL,'LMC',NULL,'1998ApJ...494..118G',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43882,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A',NULL,43882,18.37,0.04,0.0473,10597,NULL,NULL,NULL,'LMC',NULL,'1995ApJ...452..189G',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43883,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A','R',43883,18.38,0.07,0.0474,10597,NULL,NULL,NULL,'LMC',NULL,'1992ASPC...30..195S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43884,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A',NULL,43884,18.43,0.1,0.0486,10597,NULL,NULL,NULL,'LMC',NULL,'1997ApJ...477..848S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43885,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A',NULL,43885,18.45,0.24,0.049,10597,NULL,NULL,NULL,'LMC',NULL,'1989ApJ...347..771E',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43886,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A',NULL,43886,18.45,0.12,0.049,10597,NULL,NULL,'EPM','LMC',NULL,'1992ApJ...395..366S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43887,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A',NULL,43887,18.45,NULL,0.049,10597,NULL,NULL,NULL,'LMC',NULL,'1996ApJ...466..911E',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43888,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A',NULL,43888,18.46,0.12,0.0492,10597,NULL,NULL,NULL,'LMC',NULL,'2002ApJ...574..293M',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43889,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A',NULL,43889,18.47,0.18,0.0494,10597,NULL,NULL,NULL,'LMC',NULL,'1991A&A...249...36H',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43890,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A','R',43890,18.49,0.25,0.05,10597,NULL,NULL,NULL,'LMC',NULL,'1999IAUC.7102....1G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43891,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A',NULL,43891,18.5,0.13,0.0501,10597,NULL,NULL,NULL,'LMC',NULL,'1991ApJ...380L..23P',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43892,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A',NULL,43892,18.51,NULL,0.0504,10597,NULL,NULL,NULL,'LMC',NULL,'1998AJ....115..204R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43893,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A',NULL,43893,18.52,0.13,0.0506,10597,NULL,NULL,NULL,'LMC',NULL,'1993ApJ...417L..75M',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43894,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A',NULL,43894,18.54,0.13,0.0511,10597,NULL,NULL,'SN','LMC',NULL,'1994ApJ...434L..37M',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43895,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A',NULL,43895,18.55,0.12,0.0512,10597,NULL,NULL,NULL,'LMC',NULL,'1991ApJ...380L..23P',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43896,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A',NULL,43896,18.55,0.13,0.0513,10597,NULL,NULL,NULL,'LMC',NULL,'1993ApJ...417L..75M',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43897,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A','R',43897,18.55,0.07,0.0513,10597,NULL,NULL,NULL,'LMC',NULL,'1999ASSL..237..125W',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43898,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A',NULL,43898,18.55,0.05,0.0513,10597,NULL,NULL,NULL,'LMC',NULL,'2000ApJ...530..738R',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43899,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A','R',43899,18.55,0.05,0.0514,10597,NULL,NULL,NULL,'LMC',NULL,'1998MmSAI..69..225P',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43900,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A',NULL,43900,18.57,0.12,0.0517,10597,NULL,NULL,'SN inclined','LMC',NULL,'1995ApJ...438..724C',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43901,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A',NULL,43901,18.57,0.13,0.0518,10597,NULL,NULL,'LMC center','LMC',NULL,'1994ApJ...434L..37M',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43902,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A',NULL,43902,18.58,0.12,0.0519,10597,NULL,NULL,'SN inclined','LMC',NULL,'1995ApJ...438..724C',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43903,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A','R',43903,18.58,0.05,0.052,10597,NULL,NULL,NULL,'LMC',NULL,'1998MmSAI..69..225P',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43904,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A','R',43904,18.58,0.05,0.052,10597,NULL,NULL,NULL,'LMC',NULL,'1999IAUS..190..549P',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43905,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A',NULL,43905,18.61,0.1,0.0527,10597,NULL,NULL,'SN circular','LMC',NULL,'1995ApJ...438..724C',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43906,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A',NULL,43906,18.61,0.1,0.0527,10597,NULL,NULL,NULL,'LMC',NULL,'1994ApJ...425...51G',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43907,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A',NULL,43907,18.62,0.1,0.0529,10597,NULL,NULL,'SN circular','LMC',NULL,'1995ApJ...438..724C',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43908,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A',NULL,43908,18.63,0.1,0.0532,10597,NULL,NULL,NULL,'LMC',NULL,'1994ApJ...425...51G',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43909,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A',NULL,43909,18.67,0.08,0.0542,10597,NULL,NULL,'Lundqvist and Sonneborn (1997)','LMC',NULL,'1998A&A...330..515F',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43910,'SNII optical','2016-12-15 15:14:11','2016-12-16 11:19:17','1','SN 1987A','R',43910,18.67,0.09,0.0542,10597,NULL,NULL,NULL,'LMC',NULL,'1997astro.ph..7144L',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43911,'GC FP','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43911,18.28,NULL,0.0453,10597,NULL,NULL,'NGC 1835','LMC',NULL,'1992A&A...254...93P',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43912,'Magnitude','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43912,18.69,0.11,0.0547,10597,NULL,NULL,NULL,'LMC',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43913,'Orbital Mech.','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43913,18.36,0.22,0.047,10597,NULL,NULL,NULL,'LMC',NULL,'2008MNRAS.383.1686J',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43914,'Tully est','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43914,18.49,0.8,0.0499,10597,75,NULL,'B','LMC',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43915,'Tully-Fisher','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,'R',43915,19.42,NULL,0.0766,10597,NULL,NULL,'LEDA [April 2006]','LMC',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43916,'Mass Model','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,'RN',43916,19,0.38,0.063,10598,NULL,NULL,'100 degrees from LMC + SMC','LMC/SMC stream',NULL,'2015AAS...22525313B',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43917,'Tully-Fisher','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43917,34.61,0.63,83.5,10599,NULL,NULL,NULL,'ESO 553- G 040',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'15.49',0.6,'S...',NULL,NULL,NULL,NULL,1,80.9044583,-19.95417,0.105,NULL,37445523962,585086311,9141973,15.49),(43918,'Tully-Fisher','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43918,34.65,0.2,85.1,10599,74.4,NULL,NULL,'ESO 553- G 040',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43919,'Tully-Fisher','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43919,34.75,0.59,89.2,10599,NULL,NULL,'Malmquist cor.','ESO 553- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43920,'FP','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43920,36.28,0.52,181,10600,70,NULL,NULL,'2MASX J05233797-1259232',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000127,NULL,'15.71',0.8,NULL,NULL,NULL,NULL,NULL,1,80.9080417,-12.98981,0.413,NULL,36676544095,573071001,8954234,15.71),(43921,'FP','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43921,36.01,0.54,159,10601,70,NULL,NULL,'2MASX J05233802-4609408',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'15.5b',0.31,NULL,NULL,NULL,NULL,NULL,1,80.9085417,-46.16131,0.089,NULL,37637169461,588080772,9188762,15.5),(43922,'FP','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43922,36.72,0.56,221,10602,70,NULL,NULL,'2MASX J05234340-0107028',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.7I',0.2,NULL,NULL,NULL,NULL,NULL,1,80.930875,-1.11744,0.877,NULL,36527343006,570739734,8917808,14.7),(43923,'FP','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43923,35.43,0.55,122,10603,70,NULL,NULL,'2MASX J05234463-2858241',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.07',0.36,NULL,NULL,NULL,NULL,NULL,1,80.935917,-28.97336,0,NULL,37256190996,582127984,9095749,16.07),(43924,'FP','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43924,37.11,0.65,265,10604,70,NULL,NULL,'2MASX J05234467-0327138',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,80.936167,-3.45389,0.953,NULL,36756584276,574321629,8973775,16.9),(43925,'FP','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43925,35.29,0.63,114,10605,70,NULL,NULL,'2MASX J05234465-0941050',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000103,NULL,'15.94',0.5,NULL,NULL,NULL,NULL,NULL,1,80.936167,-9.68478,0.473,NULL,36724555912,573821186,8965956,15.94),(43926,'FP','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43926,36.33,0.98,185,10606,70,NULL,NULL,'2MASX J05234640-2835281',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.000183,NULL,'17.07',0.25,NULL,NULL,NULL,NULL,NULL,1,80.94325,-28.59108,0,NULL,37257418832,582147169,9096049,17.07),(43927,'FP','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43927,36.08,0.78,164,10607,70,NULL,NULL,'2MASX J05235087-3211312',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.85',0.19,NULL,NULL,NULL,NULL,NULL,1,80.961917,-32.19206,0,NULL,37298381674,582787213,9106050,16.85),(43928,'FP','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43928,36.32,0.78,184,10608,70,NULL,NULL,'2MASX J05235106-2442201',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,80.96275,-24.70558,0.069,NULL,37142311969,580348624,9067947,15.1),(43929,'IRAS','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43929,33.14,0.8,42.4,10609,75,NULL,'MAT, I','IC 0416',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000017,NULL,'14.1b',0.7,'SB(s)c pec:',NULL,NULL,NULL,NULL,1,80.984917,-17.26042,0.149,NULL,37406951678,584483619,9132556,14.1),(43930,'Tully-Fisher','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43930,32.45,0.69,30.9,10609,100,NULL,'mid-IR','IC 0416',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43931,'Tully-Fisher','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43931,32.64,0.32,33.7,10609,85,NULL,'I, raw','IC 0416',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43932,'Tully-Fisher','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43932,32.64,0.32,33.8,10609,85,NULL,'I, inv','IC 0416',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43933,'Tully-Fisher','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43933,32.97,0.43,39.2,10609,75,NULL,'MAT, I, raw','IC 0416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43934,'Tully-Fisher','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43934,33.05,0.43,40.8,10609,75,NULL,'MAT, I, inv','IC 0416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43935,'Tully-Fisher','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43935,33.18,0.43,43.3,10609,75,NULL,'MAT, I, cor','IC 0416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43936,'Tully-Fisher','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43936,33.29,0.5,45.5,10609,NULL,NULL,NULL,'IC 0416',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43937,'Tully-Fisher','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43937,33.38,0.48,47.3,10609,NULL,NULL,'Malmquist cor.','IC 0416',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43938,'Tully-Fisher','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43938,33.39,0.4,47.6,10609,NULL,NULL,'mean','IC 0416',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43939,'Tully-Fisher','2016-12-15 15:14:11','2016-12-16 11:19:17','1',NULL,NULL,43939,33.41,0.2,48.1,10609,74.4,NULL,NULL,'IC 0416',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43940,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43940,33.5,0.43,50.1,10609,75,NULL,'3.6 micron, color corrected','IC 0416',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43941,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43941,33.5,0.43,50.1,10609,75,NULL,'3.6 micron, color + selection bias corrected','IC 0416',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43942,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43942,33.92,0.47,60.9,10609,NULL,NULL,'H','IC 0416',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43943,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43943,36.33,0.54,184,10610,70,NULL,NULL,'ESO 553- G 041',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'15.17',0.8,'Sa-b',NULL,NULL,NULL,NULL,1,81.002083,-20.08128,0.105,NULL,37445608448,585087632,9141994,15.17),(43944,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43944,35.7,0.57,138,10611,70,NULL,NULL,'2MASX J05240109-2814231',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.00015,NULL,'15.80',0.43,NULL,NULL,NULL,NULL,NULL,1,81.004583,-28.23981,0,NULL,37257763436,582152553,9096133,15.8),(43945,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43945,37.43,0.55,307,10612,70,NULL,NULL,'2MASX J05240369-2442293',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,81.0154583,-24.70817,0.069,NULL,37142338200,580349034,9067953,15.1),(43946,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43946,37.2,0.53,275,10613,70,NULL,NULL,'2MASX J05241135-0949344',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,81.0473333333,-9.82617,0.473,NULL,36724567401,573821365,8965958,16.1),(43947,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43947,36.12,0.81,168,10614,70,NULL,NULL,'2MASX J05241273-3212077',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.6I',0.2,NULL,NULL,NULL,NULL,NULL,1,81.053167,-32.20217,0,NULL,37298902735,582795355,9106177,14.6),(43948,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43948,36.64,0.62,212,10615,70,NULL,NULL,'2MASX J05241290-0946474',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.40',NULL,NULL,NULL,NULL,NULL,NULL,1,81.053875,-9.77989,0.473,NULL,36721696186,573776502,8965257,16.4),(43949,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43949,37.44,0.8,308,10616,70,NULL,NULL,'2MASX J05241816-3204107',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'17.04',0.28,NULL,NULL,NULL,NULL,NULL,1,81.075667,-32.06964,0,NULL,37297065563,582766649,9105728,17.04),(43950,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43950,36.91,0.75,241,10617,70,NULL,NULL,'2MASX J05241867-2245482',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.51',NULL,NULL,NULL,NULL,NULL,NULL,1,81.0777917,-22.76356,0.061,NULL,37421453035,584710203,9136096,16.51),(43951,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43951,35.83,0.55,147,10618,70,NULL,NULL,'2MASX J05242103-4257185',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,81.087625,-42.95517,0,NULL,37642280213,588160628,9190009,14.5),(43952,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43952,36,0.66,158,10619,70,NULL,NULL,'FAIRALL 0793',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,81.092375,-47.95767,0.065,NULL,37590210361,587347036,9177297,14.2),(43953,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43953,37.09,0.63,262,10620,70,NULL,NULL,'2MASX J05242750-0312420',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.7I',0.2,NULL,NULL,NULL,NULL,NULL,1,81.114625,-3.21164,0.953,NULL,36756721236,574323769,8973808,14.7),(43954,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43954,35.26,0.51,113,10621,70,NULL,NULL,'IC 2125',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'14.43',0.8,'S0',NULL,NULL,NULL,NULL,1,81.117167,-27.01606,0,NULL,37135093152,580235830,9066184,14.43),(43955,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43955,35.71,0.52,139,10622,70,NULL,NULL,'2MASX J05243061-4600004',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'16.6b',0.19,NULL,NULL,NULL,NULL,NULL,1,81.127583,-46.00006,0.089,NULL,37637136568,588080258,9188754,16.6),(43956,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43956,33.79,0.49,57.3,10623,NULL,NULL,NULL,'ESO 120- G 001',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000033,NULL,'15.40',0.6,'SB(rs)cd',NULL,NULL,NULL,NULL,1,81.1302917,-61.36264,0.081,NULL,35889394354,560771786,8762059,15.4),(43957,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43957,33.83,0.2,58.3,10623,74.4,NULL,NULL,'ESO 120- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43958,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43958,34.1,0.43,66.2,10623,NULL,NULL,'Malmquist cor.','ESO 120- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43959,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43959,35.94,0.6,154,10624,70,NULL,NULL,'2MASX J05243308-2804274',NULL,'2014MNRAS.445.2677S',2014,1,0.71,NULL,'G',0.00015,NULL,'16.20',0.45,'SBab',NULL,NULL,NULL,NULL,1,81.13775,-28.07425,0,NULL,37257682592,582151290,9096113,16.2),(43960,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43960,35.84,0.62,147,10625,70,NULL,NULL,'2MASX J05243496-1053254',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.36',NULL,NULL,NULL,NULL,NULL,NULL,1,81.1457083,-10.89033,0.381,NULL,36723358650,573802478,8965663,16.36),(43961,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43961,35.3,0.45,115,10626,NULL,NULL,NULL,'ESO 423- G 012',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.29',0.3,'(R\')SB:ab      HII',NULL,NULL,NULL,NULL,1,81.153583,-28.5485,0,NULL,37257310208,582145472,9096023,15.29),(43962,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43962,35.34,0.2,117,10626,74.4,NULL,NULL,'ESO 423- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43963,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43963,35.53,0.4,128,10626,NULL,NULL,'Malmquist cor.','ESO 423- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43964,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43964,36.54,0.8,203,10627,70,NULL,NULL,'2MASX J05244053-3128148',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.000077,NULL,'14.50',0.39,'E',NULL,NULL,NULL,NULL,1,81.1689583,-31.47075,0,NULL,37311099125,582985923,9109155,14.5),(43965,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43965,35.61,0.65,133,10628,70,NULL,NULL,'2MASX J05244569-1100151',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.20',NULL,NULL,NULL,NULL,NULL,NULL,1,81.1902083,-11.00431,0.381,NULL,36723340556,573802196,8965659,16.2),(43966,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43966,31.97,0.2,24.8,10629,74.4,NULL,NULL,'NGC 1906',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000017,NULL,'14.1b',0.4,'Scd',NULL,NULL,NULL,NULL,1,81.19625,-15.94331,0.257,NULL,37408014282,584500223,9132815,14.1),(43967,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43967,33.21,0.47,43.8,10629,NULL,NULL,'H','NGC 1906',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43968,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43968,33.26,0.4,44.8,10629,NULL,NULL,'mean','NGC 1906',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43969,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43969,33.28,0.46,45.3,10629,NULL,NULL,'J','NGC 1906',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43970,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43970,33.33,0.45,46.3,10629,NULL,NULL,'K','NGC 1906',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43971,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43971,34.98,0.59,99.3,10630,70,NULL,NULL,'ESO 305-IG 023',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000047,NULL,'14.83',0.48,'S...','in a pair',NULL,NULL,NULL,1,81.2061666667,-40.02542,0,NULL,37606259130,587597798,9181215,14.83),(43972,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43972,35.9,0.55,152,10631,70,NULL,NULL,'ESO 204- G 006',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.35',0.5,'(R)SA(r)a',NULL,NULL,NULL,NULL,1,81.21,-48.45456,0.069,NULL,37589605528,587337586,9177149,15.35),(43973,'Brightest Stars','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43973,29.27,0.2,7.14,10632,NULL,NULL,NULL,'UGC 03303',NULL,'1998A&AS..133..181M',1998,1,3.6,NULL,'G',0.000017,NULL,'16.0',2.8,'Sd:','Dwarf, field object',NULL,NULL,NULL,1,81.247917,4.505,0.577,NULL,64655981299,1010249707,15785151,16),(43974,'Tully est','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43974,29.11,0.8,6.6,10632,75,NULL,NULL,'UGC 03303',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43975,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43975,35.35,0.58,117,10633,70,NULL,NULL,'2MASX J05251126-3141487',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.0001,NULL,'15.40',0.65,'E',NULL,NULL,NULL,NULL,1,81.2969583333,-31.69692,0,NULL,37311210113,582987658,9109182,15.4),(43976,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43976,37.5,0.76,316,10634,70,NULL,NULL,'2MASX J05251510-2710001',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,81.313,-27.16669,0.021,NULL,37134650812,580228918,9066076,15.1),(43977,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43977,35.98,0.76,157,10635,70,NULL,NULL,'2MASX J05251978-7843421',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,81.3325,-78.72844,0.465,NULL,35669989584,557343587,8708493,16.6),(43978,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43978,36.17,0.55,172,10636,70,NULL,NULL,'2MASX J05252779-5922522',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00013,NULL,'15.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,81.3657083,-59.38128,0.045,NULL,35859477219,560304331,8754755,15.4),(43979,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43979,36.14,0.56,169,10637,70,NULL,NULL,'6dF J0525352-363723',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,81.396875,-36.62311,0.033,NULL,37088742741,579511605,9054868,14),(43980,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43980,36.06,0.54,163,10638,70,NULL,NULL,'MCG -05-13-019',NULL,'2014MNRAS.445.2677S',2014,1,3,NULL,'G',0.00012,NULL,'15.5',2,'SA0- pec',NULL,NULL,NULL,NULL,1,81.397,-31.60147,0,NULL,37311122485,582986288,9109160,15.5),(43981,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43981,36.84,0.61,233,10639,70,NULL,NULL,'2MASX J05253761-1100558',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.50',0.4,NULL,NULL,NULL,NULL,NULL,1,81.406625,-11.01561,0.473,NULL,36715022276,573672223,8963628,16.5),(43982,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43982,36.36,0.57,187,10640,70,NULL,NULL,'2MASX J05253786-6407060',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,81.4079583,-64.11831,0.133,NULL,35891793857,560809279,8762644,16),(43983,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43983,34.87,0.56,94.1,10641,70,NULL,NULL,'2MASX J05254165-3149364',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000077,NULL,'13.69',0.5,'S0/S',NULL,NULL,NULL,NULL,1,81.423625,-31.82683,0,NULL,37311192603,582987384,9109177,13.69),(43984,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43984,36.51,0.6,200,10642,70,NULL,NULL,'2MASX J05254423-3327284',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'16.96',0.26,NULL,NULL,NULL,NULL,NULL,1,81.434417,-33.45786,0,NULL,37296436675,582756823,9105575,16.96),(43985,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43985,34.07,0.47,65.3,10643,NULL,NULL,'H','ESO 305- G 025',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.00009,NULL,'14.23',0.57,'SAB(rs)b       HII','in a pair',NULL,NULL,NULL,1,81.446333,-39.90653,0,NULL,37081994975,579406171,9053221,14.23),(43986,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43986,34.09,0.4,65.8,10643,NULL,NULL,'mean','ESO 305- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43987,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43987,34.1,0.45,66,10643,NULL,NULL,'K','ESO 305- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43988,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43988,34.18,0.43,68.6,10643,NULL,NULL,'Malmquist cor.','ESO 305- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43989,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43989,34.23,0.42,70.2,10643,NULL,NULL,NULL,'ESO 305- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43990,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43990,34.23,0.46,70.2,10643,NULL,NULL,'J','ESO 305- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43991,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43991,34.27,0.2,71.5,10643,74.4,NULL,NULL,'ESO 305- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43992,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43992,35.1,0.58,105,10644,70,NULL,NULL,'2MASX J05254719-0334566',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.0001,NULL,'13.2I',0.4,NULL,NULL,NULL,NULL,NULL,1,81.4465416667,-3.58242,0.897,NULL,36756325667,574317588,8973712,13.2),(43993,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43993,36.39,0.64,190,10645,70,NULL,NULL,'2MASX J05255008-2446591',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,81.4586666667,-24.78314,0.069,NULL,37142195611,580346806,9067918,15.7),(43994,'GRB','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'RN',43994,43.22,NULL,4400,10646,NULL,NULL,NULL,'GRB 790305',NULL,'1992grbo.book..107S',1992,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43995,'D-Sigma','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43995,33.2,0.4,43.7,10647,75,NULL,'Edat, raw','NGC 1930',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000023,NULL,'13.37',1.2,'E','in a pair',NULL,NULL,NULL,1,81.486667,-46.72847,0.101,NULL,37592808831,587387637,9177931,13.37),(43996,'D-Sigma','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43996,33.54,0.4,51,10647,75,NULL,'Edat, cor','NGC 1930',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43997,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43997,33.95,0.46,61.6,10647,70,NULL,NULL,'NGC 1930',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43998,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43998,33.62,0.45,52.9,10647,NULL,NULL,'K','NGC 1930',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43999,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,43999,33.77,0.4,56.9,10647,NULL,NULL,'mean','NGC 1930',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44000,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44000,36.2,0.53,174,10648,70,NULL,NULL,'2MASX J05260577-7415246',NULL,'2014MNRAS.445.2677S',2014,1,0.31,NULL,'G',0.00015,NULL,'16.9b',0.31,NULL,NULL,NULL,NULL,NULL,1,81.52425,-74.25686,0.469,NULL,35558334947,555598983,8681234,16.9),(44001,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44001,35.96,0.5,156,10649,70,NULL,NULL,'2MASX J05261281-6034463',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'16.3b',0.17,NULL,NULL,NULL,NULL,NULL,1,81.553417,-60.57944,0.061,NULL,35858891529,560295180,8754612,16.3),(44002,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44002,35.75,0.69,141,10650,70,NULL,NULL,'2MASX J05261656-0614250',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.36',0.6,NULL,NULL,NULL,NULL,NULL,1,81.5690417,-6.24047,0.589,NULL,36773675125,574588673,8977948,16.36),(44003,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44003,36.56,0.88,205,10651,70,NULL,NULL,'2MASX J05262767-2950178',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.4,NULL,NULL,NULL,NULL,NULL,1,81.615375,-29.83828,0,NULL,37303977490,582874648,9107416,14.5),(44004,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44004,36.05,0.61,162,10652,70,NULL,NULL,'2MASX J05263139-1458320',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.6,NULL,NULL,NULL,NULL,NULL,1,81.6307083,-14.97556,0.309,NULL,37405991776,584468621,9132322,13.9),(44005,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44005,36.86,0.8,235,10653,70,NULL,NULL,'2MASX J05263206-4609097',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,81.6335,-46.15281,0.105,NULL,37591911124,587373611,9177712,16.9),(44006,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44006,35.23,0.57,111,10654,70,NULL,NULL,'ESO 423- G 016',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000073,NULL,'14.82',0.8,'(R)SB(s)0/a',NULL,NULL,NULL,NULL,1,81.6439583,-31.84408,0,NULL,37311086095,582985720,9109151,14.82),(44007,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44007,37.54,0.61,322,10655,70,NULL,NULL,'2MASX J05263665-1308051',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.7I',0.3,NULL,NULL,NULL,NULL,NULL,1,81.6527916667,-13.13467,0.485,NULL,36690975475,573296491,8957757,14.7),(44008,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44008,34.66,0.49,85.5,10656,75,NULL,'IR','ESO 553- G 044',NULL,'2011yCatp016004901K',2011,1,1.39,'Star superposed near nucleus.','G',0.00003,NULL,'14.76',0.19,'Sc             HII',NULL,NULL,NULL,NULL,1,81.685417,-19.20983,0.149,NULL,37446596504,585103070,9142235,14.76),(44009,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44009,34.75,0.19,89.1,10656,NULL,NULL,'B, Hubble-type-TF','ESO 553- G 044',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44010,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44010,34.77,0.47,90,10656,NULL,NULL,'H','ESO 553- G 044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44011,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44011,34.86,0.46,93.8,10656,NULL,NULL,'J','ESO 553- G 044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44012,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44012,34.91,0.45,96,10656,NULL,NULL,'K','ESO 553- G 044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44013,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44013,35,0.47,99.8,10656,NULL,NULL,'Malmquist cor.','ESO 553- G 044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44014,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44014,35.06,0.46,103,10656,NULL,NULL,NULL,'ESO 553- G 044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44015,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44015,35.1,0.2,105,10656,74.4,NULL,NULL,'ESO 553- G 044',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44016,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44016,35.21,0.4,110,10656,NULL,NULL,'mean','ESO 553- G 044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44017,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44017,35.78,NULL,143,10656,NULL,NULL,'Dipole + Quadrupole','ESO 553- G 044',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44018,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44018,35.78,NULL,143,10656,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 553- G 044',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44019,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44019,35.78,NULL,144,10656,NULL,NULL,'Dipole','ESO 553- G 044',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44020,'Tully est','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44020,30.42,0.8,12.1,10657,75,NULL,'B','NGC 1947',NULL,'1988NBGC.C....0000T',1988,1,3,NULL,'G',0.00008,NULL,'11.65',2.6,'S0- pec        LINER','Group member',NULL,NULL,NULL,1,81.698375,-63.76003,0.149,NULL,35899188425,560924819,8764450,11.65),(44021,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44021,31.18,0.45,17.2,10657,NULL,NULL,'K','NGC 1947',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44022,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44022,31.46,0.4,19.6,10657,NULL,NULL,'mean','NGC 1947',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44023,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44023,35.1,0.49,105,10658,75,NULL,'IR','UGC 03305',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.00003,NULL,'17.',0.3,'DWARF',NULL,NULL,NULL,NULL,1,81.7004583,54.39689,1.941,NULL,66056944958,1032139764,16127183,17),(44024,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44024,36.77,0.62,226,10659,70,NULL,NULL,'2MASX J05265107-2007550',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.85',NULL,NULL,NULL,NULL,NULL,NULL,1,81.71275,-20.13194,0.117,NULL,37444933827,585077091,9141829,15.85),(44025,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44025,35.98,0.6,157,10660,70,NULL,NULL,'2MASX J05265212-5114352',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8b',NULL,'E/S0',NULL,NULL,NULL,NULL,1,81.71725,-51.24319,0.005,NULL,35766477508,558851211,8732050,15.8),(44026,'TRGB','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44026,29.13,0.1,6.7,10661,74.4,NULL,NULL,'ESO 553- G 046',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.00003,NULL,'14.60',0.8,'S              HII',NULL,NULL,NULL,NULL,1,81.773833,-20.67808,0.113,NULL,37437043108,584953798,9139903,14.6),(44027,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44027,37.35,0.67,296,10662,70,NULL,NULL,'2MASX J05271195-5916245',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,81.799875,-59.27353,0.045,NULL,35859507002,560304796,8754762,16.3),(44028,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44028,35.4,0.51,120,10663,70,NULL,NULL,'2MASX J05273198-3004369',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,81.88325,-30.07694,0,NULL,37304095756,582876496,9107445,14.4),(44029,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44029,36.63,0.53,212,10664,70,NULL,NULL,'AM 0525-371 NED05',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.00015,NULL,'14.8R',0.4,NULL,NULL,NULL,NULL,NULL,1,81.8896666667,-37.22153,0.081,NULL,37088350016,579505469,9054772,14.8),(44030,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44030,35.22,0.47,111,10665,NULL,NULL,'H','2MASX J05274713+1956592',NULL,'2007A&A...465...71T',2007,1,1.23,NULL,'G',NULL,NULL,'10.2K',0.33,'S',NULL,NULL,NULL,NULL,1,81.9464583,19.94978,NULL,NULL,65430839142,1022356861,15974325,10.2),(44031,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44031,35.28,0.45,114,10665,NULL,NULL,'K','2MASX J05274713+1956592',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44032,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44032,35.33,0.4,117,10665,NULL,NULL,'mean','2MASX J05274713+1956592',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44033,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44033,35.46,0.46,124,10665,NULL,NULL,'J','2MASX J05274713+1956592',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44034,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44034,36.49,0.65,198,10666,70,NULL,NULL,'2MASX J05274932-2012374',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.99',0.3,NULL,NULL,NULL,NULL,NULL,1,81.955375,-20.21061,0.117,NULL,37445971761,585093308,9142082,15.99),(44035,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44035,34.89,0.48,95.1,10667,70,NULL,NULL,'2MASX J05280039-2059414',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,82.001667,-20.99492,0.097,NULL,37436923352,584951927,9139873,14.4),(44036,'Sosies','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44036,32.5,0.27,31.6,10668,NULL,NULL,NULL,'NGC 1924',NULL,'2002A&A...393...57T',2002,1,1.6,NULL,'G',0.00015,NULL,'13.25',1.2,'SB(r)bc        HII',NULL,NULL,NULL,NULL,1,82.0080417,-5.31075,0.689,NULL,36753600139,574275002,8973046,13.25),(44037,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44037,32.76,0.4,35.6,10668,NULL,NULL,'mean','NGC 1924',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44038,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44038,32.79,0.45,36.1,10668,NULL,NULL,'K','NGC 1924',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44039,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44039,32.8,0.47,36.3,10668,NULL,NULL,'H','NGC 1924',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44040,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44040,32.84,0.46,37,10668,NULL,NULL,'J','NGC 1924',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44041,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44041,33.21,0.2,43.9,10668,74.4,NULL,NULL,'NGC 1924',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44042,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44042,33.29,0.4,45.5,10668,NULL,NULL,'Malmquist cor.','NGC 1924',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44043,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44043,33.37,0.38,47.1,10668,NULL,NULL,NULL,'NGC 1924',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44044,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44044,36.75,0.61,224,10669,70,NULL,NULL,'2MASX J05280712-1209316',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,82.029583,-12.15875,0.521,NULL,36684833818,573200528,8956258,17.4),(44045,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44045,36.5,0.53,200,10670,70,NULL,NULL,'2MASX J05281244-4831212',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,82.0519583,-48.52264,0.109,NULL,35706714959,557917421,8717459,14.3),(44046,'Tully est','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44046,32.13,0.8,26.7,10671,75,NULL,'B','MCG -03-14-017',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000013,NULL,'13.0b',1.9,'SB(s)cd',NULL,NULL,NULL,NULL,1,82.0588333333,-16.12436,0.225,NULL,37408964962,584515077,9133048,13),(44047,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44047,37.44,0.68,308,10672,70,NULL,NULL,'2MASX J05282236-2445247',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,82.09325,-24.75678,0.149,NULL,37139749077,580308579,9067321,14.5),(44048,'Ring Diameter','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44048,33.5,0.84,51,10673,NULL,NULL,'Published at H = 100 km/s/Mpc','UGC 03302',NULL,'1981ApJS...45..541P',1981,1,1,NULL,'G',0.000023,NULL,'13.59',1,'SAB(r)bc:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,82.0965,76.66375,0.457,NULL,65665966734,1026030730,16031730,13.59),(44049,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44049,35.46,0.7,124,10674,70,NULL,NULL,'2MASX J05283367-5945340',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,82.1404583333,-59.75942,0.113,NULL,35861226255,560331660,8755182,16.1),(44050,'IRAS','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44050,33.75,0.8,56.2,10675,75,NULL,'MAT, I','ESO 306- G 002',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'15.74',0.2,'Sb: sp',NULL,NULL,NULL,NULL,1,82.1519583,-41.49119,0.013,NULL,37586140798,587283449,9176303,15.74),(44051,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44051,33.4,0.32,47.8,10675,85,NULL,'I, inv','ESO 306- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44052,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44052,33.41,0.32,48.1,10675,85,NULL,'I, raw','ESO 306- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44053,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44053,33.69,0.43,54.7,10675,75,NULL,'MAT, I, raw','ESO 306- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44054,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44054,33.7,0.43,55,10675,75,NULL,'MAT, I, inv','ESO 306- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44055,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44055,33.9,0.47,60.3,10675,NULL,NULL,NULL,'ESO 306- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44056,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44056,33.94,0.2,61.4,10675,74.4,NULL,NULL,'ESO 306- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44057,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44057,33.95,0.43,61.6,10675,75,NULL,'MAT, I, cor','ESO 306- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44058,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44058,34.05,0.44,64.6,10675,NULL,NULL,'Malmquist cor.','ESO 306- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44059,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44059,34.19,0.49,68.9,10675,75,NULL,'IR','ESO 306- G 002',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44060,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44060,35.83,0.48,146,10676,NULL,NULL,'Malmquist cor.','ESO 033- G 020',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.16',0.4,'S...',NULL,NULL,NULL,NULL,1,82.207583,-76.47103,0.437,NULL,35550871937,555482374,8679412,15.16),(44061,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44061,35.99,0.45,158,10676,NULL,NULL,NULL,'ESO 033- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44062,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44062,36.03,0.2,161,10676,74.4,NULL,NULL,'ESO 033- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44063,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44063,34.63,0.16,84.3,10677,NULL,NULL,'B, Hubble-type-TF','ESO 554- G 001',NULL,'2005Ap&SS.298..577R',2005,1,1,NULL,'G',0.000033,NULL,'16.06',0.3,'S...',NULL,NULL,NULL,NULL,1,82.224333,-20.93733,0.093,NULL,37437423658,584959744,9139996,16.06),(44064,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44064,35.52,0.46,127,10677,NULL,NULL,NULL,'ESO 554- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44065,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44065,35.56,0.2,129,10677,74.4,NULL,NULL,'ESO 554- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44066,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44066,35.59,0.44,131,10677,NULL,NULL,'Malmquist cor.','ESO 554- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44067,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44067,33.06,0.82,40.8,10678,NULL,NULL,NULL,'ESO 253- G 007',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.64',0.8,'SAB:(s)c',NULL,NULL,NULL,NULL,1,82.237333,-47.39042,0.101,NULL,37593162867,587393169,9178018,14.64),(44068,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44068,33.1,0.2,41.7,10678,74.4,NULL,NULL,'ESO 253- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44069,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44069,33.43,0.69,48.5,10678,NULL,NULL,'Malmquist cor.','ESO 253- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44070,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44070,37.02,0.6,254,10679,70,NULL,NULL,'2MASX J05291051-2502252',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,82.2938333333,-25.04025,0.145,NULL,37139190154,580299846,9067185,15.5),(44071,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44071,33.81,0.48,57.8,10680,70,NULL,NULL,'2MASX J05291343-1927578',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00009,NULL,'14.92',NULL,NULL,NULL,NULL,NULL,NULL,1,82.306083,-19.46611,0.137,NULL,37442941406,585045959,9141343,14.92),(44072,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44072,35.3,0.7,115,10681,70,NULL,NULL,'2MASX J05292129-2801566',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'16.43',0.26,NULL,NULL,NULL,NULL,NULL,1,82.338625,-28.03239,0,NULL,37133058573,580204040,9065688,16.43),(44073,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44073,34.16,0.33,67.9,10682,NULL,NULL,'Malmquist cor.','ESO 004- G 020',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.81',0.6,'SAB(s)bc',NULL,NULL,NULL,NULL,1,82.353625,-85.92858,0.705,NULL,35441168607,553768259,8652629,14.81),(44074,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44074,34.22,0.4,69.7,10682,NULL,NULL,'mean','ESO 004- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44075,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44075,34.39,0.47,75.3,10682,NULL,NULL,'H','ESO 004- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44076,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44076,34.4,0.3,75.7,10682,NULL,NULL,NULL,'ESO 004- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44077,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44077,34.44,0.2,77.3,10682,74.4,NULL,NULL,'ESO 004- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44078,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44078,36.08,0.79,165,10683,70,NULL,NULL,'2MASX J05292590-2958056',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.88',0.53,'(R_1)SB(l)0^+',NULL,NULL,NULL,NULL,1,82.358,-29.96831,0,NULL,37303456618,582866509,9107289,15.88),(44079,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44079,35.12,0.65,106,10684,70,NULL,NULL,'2MASX J05292911-6302027',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,82.3712917,-63.03406,0.141,NULL,35899418929,560928420,8764506,15),(44080,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44080,35.01,0.55,100,10685,70,NULL,NULL,'2MASX J05293196-1932498',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.45',0.3,NULL,NULL,NULL,NULL,NULL,1,82.3831666667,-19.54722,0.117,NULL,37442904982,585045390,9141334,15.45),(44081,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44081,34.21,0.54,69.5,10686,70,NULL,NULL,'ESO 554- G 004',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000123,NULL,'14.72',0.7,'(R_1)SB(s)0/a:',NULL,NULL,NULL,NULL,1,82.412083,-19.56189,0.117,NULL,37443378488,585052788,9141449,14.72),(44082,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44082,36.33,0.52,184,10687,70,NULL,NULL,'2MASX J05294455-8327561',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,82.43525,-83.46558,0.765,NULL,35462631274,554103613,8657868,16.1),(44083,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44083,35.34,0.5,117,10688,70,NULL,NULL,'2MASX J05294756-2102461',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000117,NULL,'15.62',NULL,NULL,NULL,NULL,NULL,NULL,1,82.4479583,-21.04617,0.061,NULL,37437475493,584960554,9140008,15.62),(44084,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44084,35.49,0.46,125,10689,NULL,NULL,NULL,'ESO 487- G 016',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.62',0.5,'S...',NULL,NULL,NULL,NULL,1,82.471583,-23.83278,0.029,NULL,37136717711,580261214,9066581,15.62),(44085,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44085,35.53,0.2,128,10689,74.4,NULL,NULL,'ESO 487- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44086,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44086,35.59,0.44,132,10689,NULL,NULL,'Malmquist cor.','ESO 487- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44087,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44087,34.89,0.46,95.3,10690,70,NULL,NULL,'MCG -03-14-019',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.000107,NULL,'15',0.2,NULL,NULL,NULL,NULL,NULL,1,82.4746666667,-18.71447,0.129,NULL,37441530598,585023915,9140998,15),(44088,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44088,35.1,0.57,105,10691,70,NULL,NULL,'2MASX J05295811-5013222',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,82.4922083,-50.22278,0.005,NULL,35764754074,558824282,8731629,16.8),(44089,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44089,34.1,0.46,66.1,10692,70,NULL,NULL,'ESO 554- G 005',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'15',0.4,'S0-a',NULL,NULL,NULL,NULL,1,82.537167,-20.33944,0.097,NULL,37435622017,584931594,9139556,15),(44090,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44090,32.81,NULL,36.5,10693,NULL,NULL,NULL,'UGC 03314',NULL,'2000BSAO...50....5K',2000,1,1.57,NULL,'G',0.000023,NULL,'18.',0.21,'Sm',NULL,NULL,NULL,NULL,1,82.5475,55.87092,1.621,NULL,66280443540,1035631930,16181748,18),(44091,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44091,32.87,NULL,37.5,10693,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03314',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44092,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44092,32.87,NULL,37.6,10693,NULL,NULL,'Dipole + Quadrupole','UGC 03314',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44093,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44093,32.88,NULL,37.7,10693,NULL,NULL,'Dipole','UGC 03314',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44094,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44094,35.99,0.9,158,10694,70,NULL,NULL,'2MASX J05301337-2510514',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,82.5557916667,-25.181,0.049,NULL,37139484083,580304438,9067256,15),(44095,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44095,37.3,0.58,288,10695,70,NULL,NULL,'2MASX J05301490-0654570',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'14.3I',0.36,NULL,NULL,NULL,NULL,NULL,1,82.5620416667,-6.91586,0.513,NULL,36774111863,574595497,8978054,14.3),(44096,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44096,36.46,0.8,196,10696,70,NULL,NULL,'2MASX J05301901-2443294',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,82.57925,-24.72494,0.117,NULL,37139919159,580311236,9067363,15.4),(44097,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44097,36.18,0.55,172,10697,70,NULL,NULL,'2MASX J05302080-1348129',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,82.5865833333,-13.80358,0.413,NULL,36691089573,573298274,8957785,16.4),(44098,'GRB','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44098,45.69,1.47,3840,10698,NULL,NULL,NULL,'GRB 081118',2.58,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,82.59225,-43.30111,0.053,NULL,37587003349,587296927,9176514,NULL),(44099,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44099,34.58,0.22,82.4,10699,NULL,NULL,'B, Hubble-type-TF','ESO 120- G 003',NULL,'2005Ap&SS.298..577R',2005,1,1,NULL,'G',0.000033,NULL,'16.6',0.4,'S...',NULL,NULL,NULL,NULL,1,82.616417,-62.36611,0.117,NULL,35900772440,560949569,8764837,16.6),(44100,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44100,34.85,0.51,93.5,10699,NULL,NULL,'Malmquist cor.','ESO 120- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44101,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44101,34.92,0.5,96.2,10699,NULL,NULL,NULL,'ESO 120- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44102,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44102,34.96,0.2,98.2,10699,74.4,NULL,NULL,'ESO 120- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44103,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44103,36.12,0.61,167,10700,70,NULL,NULL,'2MASX J05302901-1355561',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,82.620917,-13.93228,0.413,NULL,36688315266,573254926,8957108,14.6),(44104,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44104,34.31,0.52,72.6,10701,70,NULL,NULL,'2MASX J05303191-1646311',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.0001,NULL,'15.19',NULL,NULL,NULL,NULL,NULL,NULL,1,82.633,-16.77539,0.201,NULL,37405501712,584460964,9132202,15.19),(44105,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44105,36.59,0.61,208,10702,70,NULL,NULL,'2MASX J05303575-2851078',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'16.28',0.35,NULL,NULL,NULL,NULL,NULL,1,82.648917,-28.85211,0.033,NULL,37254025386,582094146,9095221,16.28),(44106,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44106,36.07,0.49,164,10703,70,NULL,NULL,'MCG -06-13-002',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.1I',0.6,NULL,NULL,NULL,NULL,NULL,1,82.698583,-33.40431,0,NULL,37287893119,582623329,9103489,13.1),(44107,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44107,36.39,0.55,190,10704,70,NULL,NULL,'2MASX J05310060-2322243',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,82.7524583,-23.37342,0.073,NULL,37417524731,584648823,9135137,14.3),(44108,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44108,36.33,0.68,184,10705,70,NULL,NULL,'2MASX J05310218-3643272',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,82.759167,-36.72422,0.013,NULL,37096196683,579628073,9056688,14.2),(44109,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44109,37.05,0.53,257,10706,70,NULL,NULL,'2MASX J05311197-2321578',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,82.7997917,-23.36614,0.073,NULL,37417574577,584649602,9135150,15.4),(44110,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44110,35.66,0.52,135,10707,70,NULL,NULL,'2MASX J05312183-2037448',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.71',0.6,NULL,NULL,NULL,NULL,NULL,1,82.840875,-20.62922,0.125,NULL,37435638543,584931852,9139560,15.71),(44111,'CMD','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'N',44111,21.3,0.22,0.182,10708,NULL,NULL,'If object = GC, ID = DES J2204_4626','Grus II',NULL,'2015ApJ...813..109D',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44112,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44112,34.43,0.47,76.8,10709,70,NULL,NULL,'ESO 204- G 011',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000063,NULL,'14.70',0.3,'S0',NULL,NULL,NULL,NULL,1,82.8655417,-49.40089,0.037,NULL,35706375193,557912112,8717376,14.7),(44113,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44113,35.42,0.71,121,10710,70,NULL,NULL,'2MASX J05312829-3036075',NULL,'2014MNRAS.445.2677S',2014,1,0.79,NULL,'G',0.00015,NULL,'15.29',0.73,NULL,NULL,NULL,NULL,NULL,1,82.867875,-30.60214,0,NULL,37302343285,582849113,9107017,15.29),(44114,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44114,32.22,0.43,27.8,10711,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-15-001',NULL,'2014MNRAS.444..527S',2014,1,1.7,NULL,'G',0.00012,NULL,'14.9b',0.5,'SB(r)ab? sp',NULL,NULL,NULL,NULL,1,82.9162083,-10.39231,0.565,NULL,36713251624,573644556,8963196,14.9),(44115,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44115,32.4,0.43,30.1,10711,75,NULL,'3.6 micron, color corrected','MCG -02-15-001',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44116,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44116,32.51,0.2,31.8,10711,74.4,NULL,NULL,'MCG -02-15-001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44117,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44117,32.71,0.4,34.8,10711,73,NULL,'opt','MCG -02-15-001',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44118,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44118,32.71,0.4,34.9,10711,75,NULL,NULL,'MCG -02-15-001',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44119,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44119,32.71,0.4,34.9,10711,73,NULL,'IR','MCG -02-15-001',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44120,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44120,32.88,0.49,37.7,10711,75,NULL,'IR','MCG -02-15-001',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44121,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44121,33.23,0.4,44.2,10711,NULL,NULL,'mean','MCG -02-15-001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44122,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44122,34.1,0.47,66.1,10711,NULL,NULL,'H','MCG -02-15-001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44123,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44123,34.12,0.45,66.7,10711,NULL,NULL,'K','MCG -02-15-001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44124,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44124,34.13,0.46,67.1,10711,NULL,NULL,'J','MCG -02-15-001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44125,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44125,35.61,0.55,132,10712,70,NULL,NULL,'ESO 306- G 009',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'14.03',1.2,'(R\')SA(r)a',NULL,NULL,NULL,NULL,1,82.9202917,-42.16514,0.017,NULL,37589100385,587329693,9177026,14.03),(44126,'IRAS','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44126,33.79,0.8,57.3,10713,75,NULL,'MAT, I','ESO 033- G 022',NULL,'1997ApJS..109..333W',1997,1,2.69,NULL,'G',0.000033,NULL,'15.50',0.15,'Scd',NULL,NULL,NULL,NULL,1,82.922333,-73.75136,0.429,NULL,35559155968,555611812,8681434,15.5),(44127,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44127,33.38,NULL,47.5,10713,NULL,NULL,NULL,'ESO 033- G 022',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44128,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44128,33.55,0.49,51.4,10713,75,NULL,'IR','ESO 033- G 022',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44129,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44129,33.6,0.32,52.4,10713,85,NULL,'I, raw','ESO 033- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44130,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44130,33.6,0.32,52.4,10713,85,NULL,'I, inv','ESO 033- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44131,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44131,33.79,0.43,57.3,10713,75,NULL,'MAT, I, raw','ESO 033- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44132,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44132,33.85,NULL,58.8,10713,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 033- G 022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44133,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44133,33.85,NULL,59,10713,NULL,NULL,'Dipole + Quadrupole','ESO 033- G 022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44134,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44134,33.86,0.43,59,10713,75,NULL,'MAT, I, inv','ESO 033- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44135,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44135,33.86,NULL,59.2,10713,NULL,NULL,'Dipole','ESO 033- G 022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44136,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44136,33.96,0.44,62.1,10713,NULL,NULL,NULL,'ESO 033- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44137,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44137,34,0.2,63.1,10713,74.4,NULL,NULL,'ESO 033- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44138,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44138,34.06,0.43,64.8,10713,75,NULL,'MAT, I, cor','ESO 033- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44139,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44139,34.2,0.4,69.2,10713,NULL,NULL,'Malmquist cor.','ESO 033- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44140,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44140,35.46,0.55,123,10714,70,NULL,NULL,'2MASX J05314143-4656526',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.9b',0.4,NULL,NULL,NULL,NULL,NULL,1,82.92275,-46.948,0.097,NULL,37593412397,587397068,9178079,15.9),(44141,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44141,35.93,0.63,153,10715,70,NULL,NULL,'2MASX J05314458-1348340',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.07',NULL,NULL,NULL,NULL,NULL,NULL,1,82.935583,-13.80953,0.385,NULL,36688394946,573256171,8957127,16.07),(44142,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44142,34.5,0.55,79.4,10716,70,NULL,NULL,'2MASX J05314885-2704265',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,82.9535417,-27.07397,0.029,NULL,37133999809,580218747,9065917,14.8),(44143,'IRAS','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44143,32.03,0.8,25.4,10717,75,NULL,'MAT, I','IC 2129',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.00002,NULL,'13.81',0.9,'SB(s)dm',NULL,NULL,NULL,NULL,1,82.9602917,-23.14506,0.085,NULL,37417634937,584650545,9135164,13.81),(44144,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44144,30.97,0.43,15.6,10717,75,NULL,'3.6 micron, color + selection bias corrected','IC 2129',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44145,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44145,31.05,0.4,16.2,10717,NULL,NULL,NULL,'IC 2129',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44146,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44146,31.11,0.43,16.7,10717,75,NULL,'3.6 micron, color corrected','IC 2129',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44147,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44147,31.22,0.32,17.5,10717,85,NULL,'I, inv','IC 2129',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44148,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44148,31.24,0.32,17.7,10717,85,NULL,'I, raw','IC 2129',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44149,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44149,31.26,0.2,17.9,10717,74.4,NULL,NULL,'IC 2129',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44150,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44150,31.37,0.4,18.8,10717,75,NULL,NULL,'IC 2129',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44151,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44151,31.37,0.4,18.8,10717,73,NULL,'IR','IC 2129',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44152,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44152,31.6,0.65,20.9,10717,NULL,NULL,NULL,'IC 2129',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44153,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44153,31.71,0.62,22,10717,NULL,NULL,'Malmquist cor.','IC 2129',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44154,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44154,31.74,0.43,22.3,10717,75,NULL,'MAT, I, inv','IC 2129',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44155,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44155,31.75,0.43,22.4,10717,75,NULL,'MAT, I, raw','IC 2129',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44156,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44156,32.05,0.43,25.7,10717,75,NULL,'MAT, I, cor','IC 2129',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44157,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44157,31.98,0.49,24.9,10718,75,NULL,'IR','2MFGC 04506',NULL,'2011yCatp016004901K',2011,1,NULL,'Part of the galaxy IC 2129.','PofG',0.000183,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,82.965417,-23.14444,0.085,NULL,37417635757,584650558,9135164,NULL),(44158,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44158,34.63,0.49,84.3,10719,75,NULL,'IR','2MFGC 04508',NULL,'2011yCatp016004901K',2011,1,0.6,NULL,'G',0.000017,NULL,'10.9K',0.1,NULL,NULL,NULL,NULL,NULL,1,82.983375,16.89158,NULL,NULL,65402727286,1021917613,15967462,10.9),(44159,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44159,36.14,0.58,169,10720,70,NULL,NULL,'2MASX J05320310-2424582',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,83.0129583,-24.41611,0.065,NULL,37137106456,580267288,9066676,14.3),(44160,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44160,35.75,0.52,141,10721,70,NULL,NULL,'2MASX J05320856-1849339',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.08',NULL,NULL,NULL,NULL,NULL,NULL,1,83.035667,-18.82606,0.113,NULL,37441247472,585019491,9140929,16.08),(44161,'IRAS','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44161,33.33,0.8,46.4,10722,75,NULL,'MAT, I','IC 0421',NULL,'1997ApJS..109..333W',1997,1,3.2,NULL,'G',0.000013,NULL,'15',2.8,'SAB(rs)bc',NULL,NULL,NULL,NULL,1,83.03575,-7.91833,0.633,NULL,36773354229,574583659,8977869,15),(44162,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44162,32.95,0.43,38.9,10722,75,NULL,'MAT, I, raw','IC 0421',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44163,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44163,33.05,0.32,40.7,10722,85,NULL,'I, raw','IC 0421',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44164,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44164,33.11,0.32,41.9,10722,85,NULL,'I, inv','IC 0421',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44165,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44165,33.21,0.43,43.9,10722,75,NULL,'MAT, I, inv','IC 0421',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44166,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44166,33.21,0.43,43.9,10722,75,NULL,'MAT, I, cor','IC 0421',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44167,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44167,34.79,0.49,90.7,10723,70,NULL,NULL,'2MASX J05322215-2148220',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.83',0.6,NULL,NULL,NULL,NULL,NULL,1,83.092083,-21.80606,0.025,NULL,37437983132,584968486,9140132,15.83),(44168,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44168,37.28,0.74,285,10724,70,NULL,NULL,'2MASX J05322351-3829443',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,83.098,-38.49572,0.037,NULL,37101732211,579714565,9058040,14.4),(44169,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44169,33.29,0.45,45.4,10725,NULL,NULL,'K','IC 2132',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00002,NULL,'14.4b',0.7,'Sa pec:',NULL,NULL,NULL,NULL,1,83.1194583,-13.92711,0.397,NULL,36688473885,573257404,8957146,14.4),(44170,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44170,33.34,0.47,46.5,10725,NULL,NULL,'H','IC 2132',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44171,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44171,33.42,0.46,48.4,10725,NULL,NULL,'J','IC 2132',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44172,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44172,33.46,0.4,49.1,10725,NULL,NULL,'mean','IC 2132',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44173,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44173,33.66,0.2,54,10725,74.4,NULL,NULL,'IC 2132',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44174,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44174,35.26,0.61,113,10726,70,NULL,NULL,'ESO 423- G 019',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000033,NULL,'15',0.7,'Sb',NULL,NULL,NULL,NULL,1,83.1615,-29.62719,0,NULL,37283239238,582550613,9102353,15),(44175,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44175,35.71,0.31,139,10726,NULL,NULL,NULL,'ESO 423- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44176,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44176,35.75,0.2,141,10726,74.4,NULL,NULL,'ESO 423- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44177,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44177,35.8,0.3,144,10726,NULL,NULL,'Malmquist cor.','ESO 423- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44178,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44178,36.29,0.87,181,10727,70,NULL,NULL,'2MASX J05324101-1333012',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.18',0.2,NULL,NULL,NULL,NULL,NULL,1,83.170875,-13.55056,0.453,NULL,36688498740,573257792,8957153,16.18),(44179,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44179,36.24,0.53,177,10728,70,NULL,NULL,'2MASX J05324176-0838034',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.65',NULL,NULL,NULL,NULL,NULL,NULL,1,83.17425,-8.63431,0.589,NULL,36768793872,574512404,8976756,16.65),(44180,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44180,36.66,0.6,215,10729,70,NULL,NULL,'2MASX J05324692-5957267',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,83.1955833333,-59.95747,0.185,NULL,35860293441,560317085,8754954,15.9),(44181,'Tully est','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44181,32.97,0.8,39.3,10730,75,NULL,NULL,'NGC 1954',NULL,'1988NBGC.C....0000T',1988,1,4.2,NULL,'G',0.000017,NULL,'12.44',2.2,'SA(rs)bc pec:','in a pair',NULL,NULL,NULL,1,83.201375,-14.06278,0.397,NULL,36688484146,573257564,8957149,12.44),(44182,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44182,33.41,0.4,48,10730,NULL,NULL,'mean','NGC 1954',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44183,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44183,33.6,0.46,52.5,10730,NULL,NULL,'J','NGC 1954',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44184,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44184,33.61,0.47,52.8,10730,NULL,NULL,'H','NGC 1954',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44185,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44185,33.69,0.45,54.6,10730,NULL,NULL,'K','NGC 1954',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44186,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44186,34.6,0.53,83.2,10731,70,NULL,NULL,'2MASX J05325052-1652092',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.57',0.5,NULL,NULL,NULL,NULL,NULL,1,83.210375,-16.86914,0.205,NULL,37404973105,584452704,9132073,15.57),(44187,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44187,35.5,0.49,126,10732,70,NULL,NULL,'2MASX J05325196-0745404',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.45',NULL,NULL,NULL,NULL,NULL,NULL,1,83.2165833333,-7.76108,0.621,NULL,36772953724,574577401,8977771,16.45),(44188,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44188,35.19,0.7,109,10733,70,NULL,NULL,'2MASX J05325623-3035443',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.00015,NULL,'16.05',0.37,NULL,NULL,NULL,NULL,NULL,1,83.2342916667,-30.59575,0,NULL,37286866634,582607291,9103238,16.05),(44189,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44189,34.97,0.51,98.5,10734,70,NULL,NULL,'2MASX J05330760-1405097',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.70',NULL,NULL,NULL,NULL,NULL,NULL,1,83.281625,-14.086,0.305,NULL,36688434733,573256792,8957137,15.7),(44190,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44190,36.22,0.5,175,10735,70,NULL,NULL,'ESO 120- G 004',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'15.76',0.5,'(R\'_2)SB(rl:)b',NULL,NULL,NULL,NULL,1,83.2841666667,-59.85169,0.185,NULL,35860274884,560316795,8754949,15.76),(44191,'IRAS','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44191,31.34,0.8,18.5,10736,75,NULL,'MAT, I','IC 2135',NULL,'1997ApJS..109..333W',1997,1,2.8,'Sometimes incorrectly called NGC 1963 which is a star cluster.','G',0.000017,NULL,'13.25',0.6,'Scd: sp',NULL,NULL,NULL,NULL,1,83.30375,-36.39883,0,NULL,37098291966,579660811,9057200,13.25),(44192,'Tully est','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44192,30.9,0.8,15.1,10736,75,NULL,NULL,'IC 2135',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44193,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44193,30.71,0.43,13.9,10736,75,NULL,'3.6 micron, color + selection bias corrected','IC 2135',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44194,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44194,30.83,0.43,14.7,10736,75,NULL,'3.6 micron, color corrected','IC 2135',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44195,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44195,30.91,0.4,15.2,10736,NULL,NULL,NULL,'IC 2135',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44196,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44196,30.93,0.2,15.4,10736,74.4,NULL,NULL,'IC 2135',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44197,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44197,31.26,0.46,17.9,10736,NULL,NULL,'J','IC 2135',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44198,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44198,31.28,0.4,18,10736,73,NULL,'IR','IC 2135',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44199,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44199,31.28,0.4,18,10736,75,NULL,NULL,'IC 2135',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44200,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44200,31.38,0.47,18.9,10736,NULL,NULL,'H','IC 2135',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44201,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44201,31.44,0.49,19.4,10736,75,NULL,'IR','IC 2135',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44202,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44202,31.48,0.45,19.7,10736,NULL,NULL,'K','IC 2135',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44203,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44203,31.56,0.4,20.6,10736,NULL,NULL,'mean','IC 2135',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44204,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44204,32.75,0.32,35.4,10736,85,NULL,'I, inv','IC 2135',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44205,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44205,32.75,0.32,35.5,10736,85,NULL,'I, raw','IC 2135',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44206,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44206,32.98,0.43,39.4,10736,75,NULL,'MAT, I, raw','IC 2135',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44207,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44207,33.02,0.43,40.2,10736,75,NULL,'MAT, I, inv','IC 2135',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44208,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44208,33.34,0.43,46.6,10736,75,NULL,'MAT, I, cor','IC 2135',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44209,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44209,37.88,0.67,377,10737,70,NULL,NULL,'2MASX J05331479-3613556',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.00015,NULL,'15.7R',0.19,NULL,NULL,NULL,NULL,NULL,1,83.3115416667,-36.23214,0,NULL,37098266125,579660408,9057193,15.7),(44210,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44210,36.75,0.55,223,10738,70,NULL,NULL,'2MASX J05331662-3623016',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.000127,NULL,'14.5R',0.33,NULL,NULL,NULL,NULL,NULL,1,83.319583,-36.38369,0,NULL,37098292154,579660814,9057200,14.5),(44211,'IRAS','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44211,31.83,0.8,23.2,10739,75,NULL,'MAT, I','NGC 1964',NULL,'1997ApJS..109..333W',1997,1,5.6,NULL,'G',0.00001,NULL,'11.58',2.1,'SAB(s)b',NULL,NULL,NULL,NULL,1,83.3406666667,-21.94578,0.025,NULL,37434446740,584913230,9139269,11.58),(44212,'IRAS','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44212,31.86,0.8,23.5,10739,75,NULL,'A82, H','NGC 1964',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44213,'Sosies','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44213,31.79,0.04,22.8,10739,NULL,NULL,NULL,'NGC 1964',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44214,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44214,30.97,0.69,15.6,10739,100,NULL,'mid-IR','NGC 1964',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44215,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44215,30.98,0.4,15.7,10739,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 1964',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44216,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44216,31.23,0.47,17.6,10739,75,NULL,'A82, H, raw','NGC 1964',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44217,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44217,31.31,NULL,18.3,10739,NULL,NULL,'B','NGC 1964',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44218,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44218,31.4,0.47,19.1,10739,75,NULL,'A82, H, inv','NGC 1964',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44219,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44219,31.47,0.36,19.7,10739,NULL,NULL,NULL,'NGC 1964',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44220,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44220,31.47,0.39,19.7,10739,73,NULL,'opt','NGC 1964',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44221,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44221,31.51,0.4,20,10739,75,NULL,'B','NGC 1964',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44222,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44222,31.6,0.47,20.9,10739,75,NULL,'A82, H, cor','NGC 1964',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44223,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44223,31.77,0.32,22.6,10739,85,NULL,'I, raw','NGC 1964',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44224,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44224,31.78,0.48,22.7,10739,NULL,NULL,NULL,'NGC 1964',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44225,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44225,31.78,0.43,22.7,10739,75,NULL,'MAT, I, raw','NGC 1964',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44226,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44226,31.78,0.2,22.7,10739,74.4,NULL,NULL,'NGC 1964',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44227,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44227,31.8,0.48,22.9,10739,NULL,NULL,'Malmquist cor.','NGC 1964',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44228,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44228,31.82,0.43,23.1,10739,75,NULL,'3.6 micron, color corrected','NGC 1964',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44229,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44229,31.83,0.39,23.2,10739,73,NULL,'opt','NGC 1964',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44230,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44230,31.84,0.32,23.3,10739,85,NULL,'I, inv','NGC 1964',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44231,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44231,31.87,0.43,23.7,10739,75,NULL,'3.6 micron, color + selection bias corrected','NGC 1964',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44232,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44232,32.06,0.43,25.8,10739,75,NULL,'MAT, I, inv','NGC 1964',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44233,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44233,32.1,0.43,26.3,10739,75,NULL,'MAT, I, cor','NGC 1964',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44234,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44234,32.15,NULL,26.9,10739,NULL,NULL,'LEDA [April 2006]','NGC 1964',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44235,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44235,36.26,0.51,178,10740,70,NULL,NULL,'2MASX J05332364-3614466',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.4I',0.5,NULL,NULL,NULL,NULL,NULL,1,83.3485417,-36.24628,0,NULL,37098263315,579660364,9057193,13.4),(44236,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44236,36.37,0.51,188,10741,70,NULL,NULL,'2MASX J05332506-3620256',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000133,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,83.354583,-36.3405,0,NULL,37098260076,579660313,9057192,14.6),(44237,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44237,35.68,0.71,137,10742,70,NULL,NULL,'2MASX J05332964-3049327',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.3,NULL,NULL,NULL,NULL,NULL,1,83.3735,-30.82575,0,NULL,37284894829,582576481,9102757,14),(44238,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44238,36.08,0.58,164,10743,70,NULL,NULL,'MCG -06-13-005',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.5',0.3,NULL,NULL,NULL,NULL,NULL,1,83.3752917,-36.4,0,NULL,37098586301,579665410,9057272,15.5),(44239,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44239,34.51,0.69,79.8,10744,100,NULL,'mid-IR','UGC 03321',NULL,'2013ApJ...771...88L',2013,1,1,NULL,'G',0.000014,NULL,'16.0',0.4,'Sab',NULL,NULL,NULL,NULL,1,83.3952083,6.27331,1.401,NULL,64679695949,1010620249,15790941,16),(44240,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44240,34.95,0.47,97.6,10744,NULL,NULL,'H','UGC 03321',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44241,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44241,35.03,0.45,101,10744,NULL,NULL,'K','UGC 03321',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44242,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44242,35.1,0.46,105,10744,NULL,NULL,'J','UGC 03321',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44243,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44243,35.26,0.4,113,10744,NULL,NULL,'mean','UGC 03321',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44244,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44244,35.25,0.58,112,10745,70,NULL,NULL,'2MASX J05333581-3020548',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000083,NULL,'12.9I',0.6,NULL,NULL,NULL,NULL,NULL,1,83.3992083333,-30.3485,0,NULL,37283659989,582557187,9102456,12.9),(44245,'Tully est','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44245,31.62,0.8,21.1,10746,75,NULL,NULL,'UGC 03317',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.000003,NULL,'15.2',0.9,'Im','Dwarf, possible member',NULL,NULL,NULL,1,83.405833,73.72583,0.457,NULL,65695337015,1026489640,16038900,15.2),(44246,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44246,35.78,0.5,143,10747,70,NULL,NULL,'2MASX J05335202-2550056',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,83.466875,-25.83492,0.013,NULL,37171194696,580799917,9074998,14.8),(44247,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44247,36.34,0.88,185,10748,70,NULL,NULL,'2MASX J05335493-1245229',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.5I',0.2,NULL,NULL,NULL,NULL,NULL,1,83.4788333333,-12.75642,0.573,NULL,36686981140,573234080,8956782,14.5),(44248,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44248,37.05,0.57,257,10749,70,NULL,NULL,'2MASX J05335521-2550086',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,83.480167,-25.83572,0.013,NULL,37171194797,580799918,9074998,15.2),(44249,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44249,36.28,0.95,180,10750,70,NULL,NULL,'2MASX J05340103-2927446',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.47',0.36,NULL,NULL,NULL,NULL,NULL,1,83.5042916667,-29.46244,0,NULL,37283348651,582552322,9102380,16.47),(44250,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44250,32.46,0.57,31,10751,70,NULL,NULL,'NGC 1979',NULL,'2014MNRAS.445.2677S',2014,1,2.2,NULL,'G',0.00006,NULL,'12.84',1.8,'SA',NULL,NULL,NULL,NULL,1,83.504625,-23.31008,0.017,NULL,37388027461,584187929,9127936,12.84),(44251,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44251,32.25,0.4,28.1,10751,NULL,NULL,'mean','NGC 1979',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44252,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44252,32.45,0.45,31,10751,NULL,NULL,'K','NGC 1979',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44253,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44253,36.47,0.52,197,10752,70,NULL,NULL,'2MASX J05340331-3428505',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.3,NULL,NULL,NULL,NULL,NULL,1,83.5139166667,-34.48064,0,NULL,37288285003,582629453,9103585,14),(44254,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44254,36.26,0.61,179,10753,70,NULL,NULL,'2MASX J05340703-2936335',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.000077,NULL,'16.01',0.4,NULL,NULL,NULL,NULL,NULL,1,83.529375,-29.60933,0,NULL,37283333446,582552085,9102376,16.01),(44255,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44255,36.38,0.73,188,10754,70,NULL,NULL,'2MFGC 04528',NULL,'2014MNRAS.445.2677S',2014,1,0.84,NULL,'G',0.00015,NULL,'16.64',0.18,NULL,NULL,NULL,NULL,NULL,1,83.5565417,-31.08622,0,NULL,37285028500,582578570,9102790,16.64),(44256,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44256,33.92,0.43,60.8,10755,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03319',NULL,'2014MNRAS.444..527S',2014,1,1.9,NULL,'G',0.000037,NULL,'16.5',0.25,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,83.560375,70.1915,0.389,NULL,65647024312,1025734754,16027105,16.5),(44257,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44257,34.27,NULL,71.5,10755,NULL,NULL,'Dipole','UGC 03319',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44258,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44258,34.28,NULL,71.8,10755,NULL,NULL,'Dipole + Quadrupole','UGC 03319',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44259,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44259,34.29,NULL,72,10755,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03319',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44260,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44260,34.36,NULL,74.3,10755,NULL,NULL,NULL,'UGC 03319',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44261,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44261,34.43,0.43,76.9,10755,75,NULL,'3.6 micron, color corrected','UGC 03319',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44262,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44262,34.48,0.42,78.5,10755,NULL,NULL,'Malmquist cor.','UGC 03319',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44263,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44263,34.54,0.49,80.9,10755,75,NULL,'IR','UGC 03319',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44264,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44264,34.93,0.2,96.8,10755,74.4,NULL,NULL,'UGC 03319',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44265,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44265,35.09,0.31,104,10755,NULL,NULL,NULL,'UGC 03319',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44266,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44266,35.98,0.6,157,10756,70,NULL,NULL,'2MASX J05341482-3027005',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.86',0.44,NULL,NULL,NULL,NULL,NULL,1,83.5617083,-30.45019,0,NULL,37286992644,582609260,9103269,15.86),(44267,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44267,35.38,0.58,119,10757,70,NULL,NULL,'2MASX J05341655-3635348',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,83.568917,-36.59294,0,NULL,37098474767,579663668,9057244,14.3),(44268,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44268,36.67,0.64,216,10758,70,NULL,NULL,'2MASX J05341714-2421576',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.2I',0.4,NULL,NULL,NULL,NULL,NULL,1,83.5714583,-24.36594,0.065,NULL,37170405619,580787587,9074806,14.2),(44269,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44269,34.45,0.69,77.7,10759,100,NULL,'mid-IR','UGC 03322',NULL,'2013ApJ...771...88L',2013,1,1,NULL,'G',0.000013,NULL,'17.',0.6,'Scd?',NULL,NULL,NULL,NULL,1,83.582917,6.79086,1.477,NULL,64679923010,1010623797,15790996,17),(44270,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44270,35.25,0.4,112,10759,NULL,NULL,'mean','UGC 03322',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44271,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44271,35.6,0.47,132,10759,NULL,NULL,'H','UGC 03322',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44272,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44272,35.92,0.67,153,10760,70,NULL,NULL,'2MASX J05342167-2322471',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,83.5902917,-23.37969,0.029,NULL,37115409073,579928266,9061379,14.6),(44273,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44273,32.34,0.4,29.4,10761,NULL,NULL,'mean','IC 2137',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.00003,NULL,'13.88',0.8,'SAB(r)ab',NULL,NULL,NULL,NULL,1,83.590333,-23.53333,0.029,NULL,37169978095,580780907,9074701,13.88),(44274,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44274,32.66,0.46,34,10761,NULL,NULL,'J','IC 2137',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44275,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44275,32.7,0.47,34.6,10761,NULL,NULL,'H','IC 2137',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44276,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44276,32.72,0.45,35,10761,NULL,NULL,'K','IC 2137',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44277,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44277,35.76,0.47,142,10762,70,NULL,NULL,'NGC 1989',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000087,NULL,'14.10',1.1,'SA(s)0-:;E/D',NULL,NULL,NULL,NULL,1,83.597583,-30.80106,0,NULL,37286959212,582608737,9103261,14.1),(44278,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44278,35.41,0.53,121,10763,70,NULL,NULL,'ESO 423- G 022',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000123,NULL,'15.5',0.4,'S0',NULL,NULL,NULL,NULL,1,83.6215,-30.68508,0,NULL,37287043161,582610049,9103282,15.5),(44279,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44279,35.94,0.48,154,10764,70,NULL,NULL,'NGC 1992',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'14.65',0.7,'SA(rs)0/a?',NULL,NULL,NULL,NULL,1,83.632375,-30.897,0,NULL,37286912457,582608007,9103250,14.65),(44280,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44280,36.24,0.51,177,10765,70,NULL,NULL,'2MASX J05343405-3539372',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'14.5R',0.35,NULL,NULL,NULL,NULL,NULL,1,83.6420417,-35.66033,0,NULL,37095034897,579609920,9056405,14.5),(44281,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44281,36.49,0.86,199,10766,70,NULL,NULL,'2MASX J05343526-3029332',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.66',0.29,NULL,NULL,NULL,NULL,NULL,1,83.6469583333,-30.49264,0,NULL,37287019273,582609676,9103276,16.66),(44282,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44282,33.08,0.48,41.4,10767,70,NULL,NULL,'ESO 423- G 024',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.000033,NULL,'13.12',1.7,'SA0^0^? pec',NULL,NULL,NULL,NULL,1,83.6724583,-29.232,0,NULL,37153378809,580521543,9070649,13.12),(44283,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44283,36.73,0.69,222,10768,70,NULL,NULL,'2MASX J05345204-1253185',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.4,NULL,NULL,NULL,NULL,NULL,1,83.71675,-12.88853,0.509,NULL,36685843218,573216300,8956504,14.3),(44284,'IRAS','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44284,34.83,0.8,92.6,10769,75,NULL,'MAT, I','MCG -02-15-006',NULL,'1997ApJS..109..333W',1997,1,1.05,NULL,'G',0.000013,NULL,'15.5',0.15,'Sc',NULL,NULL,NULL,NULL,1,83.735125,-10.02147,0.713,NULL,36767635993,574494312,8976473,15.5),(44285,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44285,34.16,0.32,67.8,10769,85,NULL,'I, raw','MCG -02-15-006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44286,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44286,34.17,0.32,68.1,10769,85,NULL,'I, inv','MCG -02-15-006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44287,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44287,34.24,0.43,70.5,10769,75,NULL,'MAT, I, raw','MCG -02-15-006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44288,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44288,34.34,0.43,73.7,10769,75,NULL,'MAT, I, inv','MCG -02-15-006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44289,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44289,34.6,NULL,83,10769,NULL,NULL,NULL,'MCG -02-15-006',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44290,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44290,34.62,0.43,83.8,10769,75,NULL,'MAT, I, cor','MCG -02-15-006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44291,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44291,34.7,0.4,87.1,10769,NULL,NULL,NULL,'MCG -02-15-006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44292,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44292,34.75,0.49,89,10769,75,NULL,'IR','MCG -02-15-006',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44293,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44293,34.76,0.2,89.5,10769,74.4,NULL,NULL,'MCG -02-15-006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44294,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44294,34.82,0.38,92,10769,NULL,NULL,'Malmquist cor.','MCG -02-15-006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44295,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44295,34.94,NULL,97.5,10769,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -02-15-006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44296,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44296,34.96,NULL,98,10769,NULL,NULL,'Dipole + Quadrupole','MCG -02-15-006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44297,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44297,34.97,NULL,98.7,10769,NULL,NULL,'Dipole','MCG -02-15-006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44298,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44298,34.99,0.43,99.6,10769,75,NULL,'3.6 micron, color corrected','MCG -02-15-006',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44299,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44299,35.11,0.43,105,10769,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-15-006',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44300,'IRAS','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44300,33.9,0.8,60.3,10770,75,NULL,'MAT, I','NGC 2007',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000013,NULL,'13.91',0.6,'SB(rs)bc       HII','Line-of-sight pair member',NULL,NULL,NULL,1,83.7465416667,-50.92169,0.021,NULL,35765220996,558831578,8731743,13.91),(44301,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44301,33.28,0.32,45.3,10770,85,NULL,'I, raw','NGC 2007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44302,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44302,33.29,0.32,45.5,10770,85,NULL,'I, inv','NGC 2007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44303,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44303,33.51,0.43,50.3,10770,75,NULL,'MAT, I, raw','NGC 2007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44304,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44304,33.59,0.43,52.3,10770,75,NULL,'MAT, I, inv','NGC 2007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44305,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44305,33.77,0.43,56.9,10770,75,NULL,'MAT, I, cor','NGC 2007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44306,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44306,33.81,0.34,57.9,10770,NULL,NULL,NULL,'NGC 2007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44307,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44307,33.85,0.2,58.9,10770,74.4,NULL,NULL,'NGC 2007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44308,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44308,33.94,0.32,61.4,10770,NULL,NULL,'Malmquist cor.','NGC 2007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44309,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44309,36.57,0.51,206,10771,70,NULL,NULL,'2MASX J05350223-3808257',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.9I',0.3,NULL,NULL,NULL,NULL,NULL,1,83.75925,-38.1405,0.033,NULL,37109452644,579835197,9059924,13.9),(44310,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44310,35.54,0.43,128,10772,NULL,NULL,NULL,'NGC 2008',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'13.80',0.7,'SA(s)c','Line-of-sight pair member',NULL,NULL,NULL,1,83.765875,-50.96678,0.053,NULL,35765219387,558831552,8731743,13.8),(44311,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44311,35.58,0.2,131,10772,74.4,NULL,NULL,'NGC 2008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44312,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44312,35.62,0.42,133,10772,NULL,NULL,'Malmquist cor.','NGC 2008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44313,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44313,35.85,0.4,148,10772,NULL,NULL,'mean','NGC 2008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44314,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44314,35.9,0.47,151,10772,NULL,NULL,'H','NGC 2008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44315,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44315,36.85,0.58,235,10773,70,NULL,NULL,'2MASX J05350701-4846322',NULL,'2014MNRAS.445.2677S',2014,1,2.1,NULL,'G',0.00015,NULL,'15.9b',0.7,'S0-:',NULL,NULL,NULL,NULL,1,83.779167,-48.77564,0.149,NULL,35710278423,557973100,8718329,15.9),(44316,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44316,36.19,0.65,173,10774,70,NULL,NULL,'2MASX J05351003-5022062',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,83.791875,-50.36833,0.045,NULL,35763329617,558802025,8731281,14.6),(44317,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44317,36.72,0.61,221,10775,70,NULL,NULL,'2MASX J05352093-2355173',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,83.8372917,-23.92147,0.013,NULL,37170088806,580782637,9074728,15.4),(44318,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44318,33.39,0.4,47.6,10776,NULL,NULL,'mean','NGC 1993',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000063,NULL,'13.39',1.4,'SA(rs)0-:',NULL,NULL,NULL,NULL,1,83.8565417,-17.81531,0.121,NULL,37439213307,584987707,9140432,13.39),(44319,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44319,33.56,0.45,51.5,10776,NULL,NULL,'K','NGC 1993',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44320,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44320,37.07,0.57,259,10777,70,NULL,NULL,'2MASX J05352695-5212342',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,83.8623333333,-52.20953,0.069,NULL,35767825766,558872277,8732379,16),(44321,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44321,37.03,0.57,254,10778,70,NULL,NULL,'2MASX J05352888-2350055',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,83.870333,-23.83486,0.013,NULL,37170106064,580782907,9074732,14.4),(44322,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44322,36.68,0.53,217,10779,70,NULL,NULL,'2MASX J05353259-2349555',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,83.885833,-23.83217,0.013,NULL,37170106342,580782911,9074732,14.3),(44323,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44323,36.37,0.95,188,10780,70,NULL,NULL,'2MASX J05353450-3542351',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'15.3R',0.31,NULL,NULL,NULL,NULL,NULL,1,83.8937083,-35.70975,0,NULL,37094967111,579608861,9056388,15.3),(44324,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44324,37.12,0.8,265,10781,70,NULL,NULL,'2MASX J05353896-4257570',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,83.91225,-42.96589,0.045,NULL,37587974709,587312104,9176751,15.6),(44325,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44325,36.63,0.54,212,10782,70,NULL,NULL,'2MASX J05354999-2827387',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.29',NULL,'Se',NULL,NULL,NULL,NULL,1,83.958333,-28.46078,0.057,NULL,37162354452,580661788,9072840,14.29),(44326,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44326,35.93,0.54,154,10783,70,NULL,NULL,'ESO 487- G 029',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'15.44',0.4,'S0',NULL,NULL,NULL,NULL,1,83.973083,-22.59208,0.057,NULL,37389055450,584203991,9128187,15.44),(44327,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44327,37.38,0.62,300,10784,70,NULL,NULL,'2MASX J05355467-5008204',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.7I',0.2,NULL,NULL,NULL,NULL,NULL,1,83.9777916667,-50.13908,0.045,NULL,35763611037,558806422,8731350,14.7),(44328,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44328,34.85,0.63,93.3,10785,70,NULL,NULL,'2MASX J05355747-0831171',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,83.9895,-8.52147,0.781,NULL,36772550986,574571109,8977673,14.3),(44329,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44329,37.03,0.68,255,10786,70,NULL,NULL,'2MASX J05360722-3728372',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,84.0301666667,-37.47692,0.021,NULL,37109692084,579838938,9059983,15.4),(44330,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44330,35.94,0.84,154,10787,70,NULL,NULL,'ESO 424- G 002',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.81',0.7,'(R\'_1)SB(s)a',NULL,NULL,NULL,NULL,1,84.067917,-31.98439,0,NULL,37292165132,582690080,9104532,15.81),(44331,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44331,33.82,0.4,58.1,10788,NULL,NULL,'mean','UGC 03328',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000014,NULL,'15.0',0.3,'Sb',NULL,NULL,NULL,NULL,1,84.070875,7.32628,1.761,NULL,64677988103,1010593564,15790524,15),(44332,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44332,33.91,0.49,60.6,10788,75,NULL,'IR','UGC 03328',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44333,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44333,33.93,0.47,61.2,10788,NULL,NULL,'H','UGC 03328',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44334,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44334,34,0.46,63,10788,NULL,NULL,'J','UGC 03328',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44335,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44335,34.03,0.45,63.9,10788,NULL,NULL,'K','UGC 03328',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44336,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44336,34.12,0.2,66.7,10788,74.4,NULL,NULL,'UGC 03328',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44337,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44337,35.83,0.8,147,10789,70,NULL,NULL,'2MASX J05361857-3159140',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.16',0.3,NULL,NULL,NULL,NULL,NULL,1,84.077333,-31.98722,0,NULL,37292165363,582690083,9104532,16.16),(44338,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44338,35.57,0.71,130,10790,70,NULL,NULL,'ESO 120- G 007',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'16.39',0.2,'S...',NULL,NULL,NULL,NULL,1,84.095167,-61.57456,0.169,NULL,35896155947,560877436,8763709,16.39),(44339,'Tully est','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44339,30.77,0.8,14.3,10791,75,NULL,NULL,'ESO 204- G 022',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000019,NULL,'15.44',1,'SB(s)m: pec',NULL,NULL,NULL,NULL,1,84.108583,-52.18403,0.097,NULL,35767964554,558874446,8732413,15.44),(44340,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1999ek',NULL,44340,33.01,0.2,39.3,10792,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','UGC 03329',0.01752,'2011A&A...526A..81B',2011,1,1.3,NULL,'G',0.000033,NULL,'11.9B',0.6,'Sbc',NULL,NULL,NULL,NULL,1,84.13575,16.64886,NULL,NULL,64550456900,1008600889,15759388,11.9),(44341,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1999ek',NULL,44341,33.61,0.27,51.8,10792,74.2,NULL,'SALT 2','UGC 03329',0.01752,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44342,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1999ek',NULL,44342,34.1,0.03,64.9,10792,72,NULL,NULL,'UGC 03329',0.01752,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44343,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1999ek',NULL,44343,34.09,0.08,65.8,10792,74.4,NULL,NULL,'UGC 03329',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44344,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1999ek',NULL,44344,34.22,0.18,68.6,10792,70,NULL,'SALT 2','UGC 03329',0.01752,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44345,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1999ek',NULL,44345,34.2,0.03,69.2,10792,72,NULL,'M(H) = -18.317 mag','UGC 03329',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44346,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1999ek',NULL,44346,34.27,0.07,70.2,10792,72,NULL,NULL,'UGC 03329',0.01752,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44347,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1999ek',NULL,44347,34.27,0.19,70.2,10792,72,NULL,NULL,'UGC 03329',0.01752,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44348,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1999ek',NULL,44348,34.28,0.11,70.5,10792,65,NULL,'MLCS2k2','UGC 03329',0.01752,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44349,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1999ek',NULL,44349,34.32,0.21,71.8,10792,65,NULL,'MLCS31','UGC 03329',0.01752,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44350,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1999ek',NULL,44350,34.36,0.11,71.9,10792,65,NULL,'MLCS2k2','UGC 03329',0.01752,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44351,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1999ek',NULL,44351,34.36,0.07,73.2,10792,72,NULL,NULL,'UGC 03329',0.01752,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44352,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1999ek',NULL,44352,34.38,0.22,73.8,10792,65,NULL,'MLCS17','UGC 03329',0.01752,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44353,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1999ek',NULL,44353,34.39,0.31,74.2,10792,70,NULL,'SALT','UGC 03329',0.01752,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44354,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1999ek',NULL,44354,34.38,0.17,75.2,10792,70.8,NULL,NULL,'UGC 03329',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44355,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1999ek',NULL,44355,34.45,0.14,76.3,10792,72,NULL,NULL,'UGC 03329',0.01752,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44356,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1999ek',NULL,44356,34.46,0.2,76.5,10792,73.8,NULL,'SALT 2 (SNANA)','UGC 03329',0.0177,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44357,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1999ek',NULL,44357,34.49,0.12,77.7,10792,70,NULL,NULL,'UGC 03329',0.01752,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44358,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1999ek',NULL,44358,34.5,0.34,78.2,10792,65,NULL,'SALT','UGC 03329',0.01752,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44359,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1999ek',NULL,44359,34.51,0.23,78.2,10792,65,NULL,'SALT2','UGC 03329',0.01752,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44360,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1999ek',NULL,44360,34.53,0.14,80.5,10792,60,NULL,NULL,'UGC 03329',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44361,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1999ek',NULL,44361,34.74,0.01,87.3,10792,65,NULL,'SALT','UGC 03329',0.01752,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44362,'Sosies','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44362,33.61,0.13,52.7,10792,NULL,NULL,NULL,'UGC 03329',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44363,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44363,33.87,0.4,59.4,10792,75,NULL,'HOSTS SN 1999ek','UGC 03329',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44364,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44364,34.02,0.47,63.7,10792,NULL,NULL,'H','UGC 03329',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44365,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44365,34.04,0.46,64.3,10792,NULL,NULL,'J','UGC 03329',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44366,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44366,34.09,0.08,65.8,10792,74.4,NULL,NULL,'UGC 03329',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44367,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44367,34.12,0.45,66.7,10792,NULL,NULL,'K','UGC 03329',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44368,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44368,34.26,0.4,71.2,10792,NULL,NULL,'mean','UGC 03329',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44369,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44369,34.3,0.42,72.4,10792,NULL,18.48,'3.6 micron','UGC 03329',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44370,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44370,34.35,0.43,74.2,10792,75,NULL,'3.6 micron, color corrected','UGC 03329',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44371,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44371,34.76,0.43,89.4,10792,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03329',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44372,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44372,35.97,0.49,156,10793,75,NULL,'IR','UGC 03324',NULL,'2011yCatp016004901K',2011,1,1.15,NULL,'G',NULL,NULL,'17.',0.1,'Scd',NULL,NULL,NULL,NULL,1,84.1462917,63.58744,0.613,NULL,66157986260,1033718535,16151852,17),(44373,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44373,35.99,NULL,158,10793,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03324',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44374,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44374,36.01,NULL,159,10793,NULL,NULL,'Dipole + Quadrupole','UGC 03324',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44375,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44375,36.02,NULL,160,10793,NULL,NULL,NULL,'UGC 03324',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44376,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44376,36.02,NULL,160,10793,NULL,NULL,'Dipole','UGC 03324',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44377,'IRAS','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44377,34.06,0.8,64.9,10794,75,NULL,'MAT, I','ESO 554- G 019',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.33',0.7,'SA(s)b         HII',NULL,NULL,NULL,NULL,1,84.194417,-22.40642,0.057,NULL,37388697448,584198397,9128099,14.33),(44378,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44378,33.67,0.32,54.3,10794,85,NULL,'I, raw','ESO 554- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44379,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44379,33.71,0.32,55.1,10794,85,NULL,'I, inv','ESO 554- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44380,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44380,33.78,0.43,57,10794,75,NULL,'MAT, I, raw','ESO 554- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44381,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44381,33.93,0.43,61.1,10794,75,NULL,'MAT, I, inv','ESO 554- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44382,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44382,34.05,0.43,64.5,10794,75,NULL,'MAT, I, cor','ESO 554- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44383,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44383,34.22,0.5,69.9,10794,NULL,NULL,'Malmquist cor.','ESO 554- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44384,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44384,34.23,0.5,70.1,10794,NULL,NULL,NULL,'ESO 554- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44385,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44385,34.27,0.2,71.5,10794,74.4,NULL,NULL,'ESO 554- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44386,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44386,34.49,0.4,79,10794,NULL,NULL,'mean','ESO 554- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44387,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44387,34.67,0.47,85.9,10794,NULL,NULL,'H','ESO 554- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44388,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44388,33.24,0.2,44.5,10795,74.4,NULL,NULL,'ESO 554- G 018',NULL,'2013AJ....146...86T',2013,1,1.12,NULL,'G',0.000023,NULL,'15.47',0.16,'Sc',NULL,NULL,NULL,NULL,1,84.196625,-18.60536,0.153,NULL,37387538029,584180281,9127816,15.47),(44389,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44389,33.33,0.43,46.3,10795,75,NULL,'3.6 micron, color corrected','ESO 554- G 018',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44390,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44390,33.4,0.43,48,10795,75,NULL,'3.6 micron, color + selection bias corrected','ESO 554- G 018',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44391,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44391,33.46,0.55,49.1,10795,NULL,NULL,NULL,'ESO 554- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44392,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44392,33.45,0.55,49.1,10795,NULL,NULL,'Malmquist cor.','ESO 554- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44393,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44393,33.55,0.49,51.3,10795,75,NULL,'IR','ESO 554- G 018',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44394,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44394,33.85,NULL,58.8,10795,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 554- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44395,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44395,33.86,NULL,59.2,10795,NULL,NULL,'Dipole + Quadrupole','ESO 554- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44396,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44396,33.87,NULL,59.5,10795,NULL,NULL,'Dipole','ESO 554- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44397,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44397,35,0.63,100,10796,70,NULL,NULL,'AM 0535-382 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'13.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,84.20125,-38.38047,0.037,NULL,37110566018,579852594,9060196,13.9),(44398,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44398,37.16,0.69,270,10797,70,NULL,NULL,'2MASX J05365297-6043335',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,84.2205417,-60.72603,0.201,NULL,35865665617,560401025,8756266,16.7),(44399,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44399,36.24,0.53,177,10798,70,NULL,NULL,'2MASX J05370108-2216010',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.45',NULL,NULL,NULL,NULL,NULL,NULL,1,84.2544583,-22.267,0.025,NULL,37391504543,584242258,9128785,16.45),(44400,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44400,36.3,0.78,182,10799,70,NULL,NULL,'2MASX J05370473-3855598',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,84.2697917,-38.93322,0.017,NULL,37099984557,579687258,9057613,15.8),(44401,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44401,35.93,0.32,153,10800,NULL,NULL,'Malmquist cor.','ESO 253- G 016',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.14',0.2,'Sb:',NULL,NULL,NULL,NULL,1,84.295875,-45.34247,0.133,NULL,37597290085,587457657,9179025,16.14),(44402,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44402,35.96,0.31,156,10800,NULL,NULL,NULL,'ESO 253- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44403,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44403,36,0.2,158,10800,74.4,NULL,NULL,'ESO 253- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44404,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44404,36.48,0.52,198,10801,70,NULL,NULL,'2MASX J05371542-4915276',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000097,NULL,'14.9b',0.9,'SAB0-',NULL,NULL,NULL,NULL,1,84.31425,-49.25775,0.045,NULL,35708183717,557940370,8717818,14.9),(44405,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44405,35.59,0.62,131,10802,70,NULL,NULL,'2MASX J05372614-2702586',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,84.358875,-27.04964,0.017,NULL,37164267310,580691676,9073307,14.4),(44406,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44406,36.65,0.92,214,10803,70,NULL,NULL,'2MASX J05373854-2630506',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,84.4107083,-26.51414,0.013,NULL,37176199716,580878120,9076220,15.5),(44407,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44407,35.71,0.62,139,10804,70,NULL,NULL,'2MASX J05373951-2819006',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,84.414625,-28.31689,0.041,NULL,37165355043,580708672,9073573,14),(44408,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44408,36.84,0.79,233,10805,70,NULL,NULL,'2MASX J05373970-5030426',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.7I',0.2,NULL,NULL,NULL,NULL,NULL,1,84.4154583,-50.51183,0.045,NULL,35765795883,558840560,8731883,14.7),(44409,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44409,36.78,0.61,227,10806,70,NULL,NULL,'2MASX J05374953-2459516',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,84.4564583,-24.99772,0,NULL,37174075296,580844926,9075701,15.4),(44410,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44410,35.86,0.65,149,10807,70,NULL,NULL,'2MASX J05380790-3622146',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'15.3R',0.23,NULL,NULL,NULL,NULL,NULL,1,84.532875,-36.37078,0,NULL,37097019248,579640925,9056889,15.3),(44411,'BL Lac Luminosity','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44411,40.6,0.12,1320,10808,70,NULL,NULL,'1RXS J053810.0-390839',NULL,'2014ApJ...784..151S',2014,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'blazar',NULL,NULL,NULL,NULL,1,84.541667,-39.14417,0.013,NULL,37100156752,579689949,9057655,NULL),(44412,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44412,35.64,0.6,134,10809,70,NULL,NULL,'2MASX J05381142-3359098',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,84.5477083,-33.986,0,NULL,37289126197,582642596,9103790,14.2),(44413,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44413,36,0.49,158,10810,75,NULL,'IR','2MFGC 04585',NULL,'2011yCatp016004901K',2011,1,0.3,NULL,'G',0.000013,NULL,'12.5K',0.1,NULL,NULL,NULL,NULL,NULL,1,84.5917916667,12.05178,1.769,NULL,64542044571,1008469446,15757335,12.5),(44414,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44414,32.76,0.49,35.6,10811,75,NULL,'IR','UGC 03320',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000037,NULL,'15.30',0.3,'SB(s)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,84.5975,79.58692,0.397,NULL,65716777076,1026824641,16044135,15.3),(44415,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44415,34.09,0.47,65.9,10811,NULL,NULL,'H','UGC 03320',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44416,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44416,34.14,0.4,67.4,10811,NULL,NULL,'mean','UGC 03320',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44417,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44417,34.24,0.45,70.5,10811,NULL,NULL,'K','UGC 03320',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44418,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44418,34.28,0.46,71.7,10811,NULL,NULL,'J','UGC 03320',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44419,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44419,35.63,0.38,133,10812,NULL,NULL,NULL,'ESO 424- G 003',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.30',0.3,'Sb:',NULL,NULL,NULL,NULL,1,84.5992083,-28.18975,0.041,NULL,37165298530,580707789,9073559,16.3),(44420,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44420,35.67,0.2,136,10812,74.4,NULL,NULL,'ESO 424- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44421,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44421,35.79,0.35,144,10812,NULL,NULL,'Malmquist cor.','ESO 424- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44422,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44422,34.25,0.59,70.8,10813,70,NULL,NULL,'ESO 086- G 018',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000053,NULL,'14.79',0.3,'S...',NULL,NULL,NULL,NULL,1,84.629625,-64.49108,0.145,NULL,35849616673,560150260,8752347,14.79),(44423,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44423,36.27,0.6,180,10814,70,NULL,NULL,'2MASX J05383178-2625188',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,84.6324166667,-26.422,0,NULL,37175868272,580872941,9076139,15.1),(44424,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44424,36.14,0.43,169,10815,NULL,NULL,'Malmquist cor.','ESO 424- G 004',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'16.21',0.4,'Sb:',NULL,NULL,NULL,NULL,1,84.6452917,-29.40219,0,NULL,37153938335,580530286,9070785,16.21),(44425,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44425,36.52,0.36,201,10815,NULL,NULL,NULL,'ESO 424- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44426,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44426,36.56,0.2,205,10815,74.4,NULL,NULL,'ESO 424- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44427,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44427,36.02,0.72,160,10816,70,NULL,NULL,'ESO 363- G 012',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.35',0.8,'SB(r)b',NULL,NULL,NULL,NULL,1,84.6521666667,-34.39228,0,NULL,37288987215,582640425,9103756,15.35),(44428,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44428,35.34,0.51,117,10817,70,NULL,NULL,'2MASX J05384177-4122401',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000103,NULL,'13.1I',0.5,NULL,NULL,NULL,NULL,NULL,1,84.674125,-41.37775,0.041,NULL,37056224861,579003513,9046929,13.1),(44429,'GRB','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44429,48.29,0.95,5990,10818,72,NULL,NULL,'GRB 060116',6.6,'2008JCAP...07..004M',2008,1,NULL,NULL,'VisS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,84.692375,-5.43753,1.581,NULL,36557643257,571213175,8925205,NULL),(44430,'GRB','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44430,48.33,0.92,6100,10818,69.7,NULL,'Calibrated','GRB 060116',6.6,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44431,'GRB','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44431,48.42,0.95,6360,10818,70,NULL,NULL,'GRB 060116',6.6,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44432,'GRB','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44432,48.53,1.07,6680,10818,NULL,NULL,NULL,'GRB 060116',6.6,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44433,'GRB','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44433,48.67,0.77,7130,10818,69.7,NULL,'Fiducial','GRB 060116',6.6,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44434,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44434,36.64,0.56,213,10819,70,NULL,NULL,'2MASX J05385526-2535411',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,84.7302083,-25.59478,0,NULL,37173314195,580833034,9075516,15.5),(44435,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44435,36.54,0.92,203,10820,70,NULL,NULL,'2MASX J05385581-4015429',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,84.732583,-40.26192,0.037,NULL,37054992410,578984256,9046629,15),(44436,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44436,36.55,0.53,204,10821,70,NULL,NULL,'2MASX J05390095-4409057',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,84.753917,-44.15161,0.093,NULL,37596441154,587444393,9178818,14),(44437,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44437,34.03,0.49,64,10821,75,NULL,'IR','UGC 03332',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44438,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44438,34.12,0.47,66.6,10822,NULL,NULL,'H','UGC 03332',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000023,NULL,'16.5',0.3,'S?',NULL,NULL,NULL,NULL,1,84.7642083333,15.57544,NULL,NULL,64552176042,1008627750,15759808,16.5),(44439,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44439,34.18,0.45,68.6,10822,NULL,NULL,'K','UGC 03332',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44440,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44440,34.32,0.43,73.2,10822,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03332',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44441,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44441,34.33,0.46,73.5,10822,NULL,NULL,'J','UGC 03332',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44442,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44442,34.48,0.4,78.8,10822,NULL,NULL,'mean','UGC 03332',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44443,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44443,36.56,0.83,205,10823,70,NULL,NULL,'2MASX J05390358-4020339',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.4,NULL,NULL,NULL,NULL,NULL,1,84.764833,-40.34283,0.037,NULL,37055043021,578985047,9046641,14.6),(44444,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44444,36.58,0.59,207,10824,70,NULL,NULL,'2MASX J05391908-2612012',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.4,NULL,NULL,NULL,NULL,NULL,1,84.8294583,-26.20039,0,NULL,37175731686,580870807,9076106,14.2),(44445,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44445,35.85,0.69,148,10825,70,NULL,NULL,'2MASX J05391944-2243242',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.51',0.3,NULL,NULL,NULL,NULL,NULL,1,84.830917,-22.72339,0.037,NULL,37391914775,584248668,9128885,16.51),(44446,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44446,37.41,0.81,303,10826,70,NULL,NULL,'2MASX J05393154-4053208',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.6I',0.2,NULL,NULL,NULL,NULL,NULL,1,84.8815417,-40.88919,0.025,NULL,37056556424,579008694,9047010,14.6),(44447,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44447,33.83,NULL,58.3,10827,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03326',NULL,'2010Ap&SS.325..163P',2010,1,3.75,NULL,'G',0.000037,NULL,'15.30',0.3,'Scd','Isolated galaxy',NULL,NULL,NULL,1,84.904583,77.31247,0.413,NULL,65652624780,1025822262,16028472,15.3),(44448,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44448,33.83,NULL,58.3,10827,NULL,NULL,'Dipole + Quadrupole','UGC 03326',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44449,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44449,33.83,NULL,58.4,10827,NULL,NULL,'Dipole','UGC 03326',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44450,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44450,33.88,0.49,59.8,10827,75,NULL,'IR','UGC 03326',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44451,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44451,33.92,NULL,60.9,10827,NULL,NULL,NULL,'UGC 03326',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44452,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44452,34.16,0.31,68,10827,NULL,NULL,'Malmquist cor.','UGC 03326',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44453,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44453,34.43,0.27,76.9,10827,NULL,NULL,NULL,'UGC 03326',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44454,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44454,34.45,0.2,77.6,10827,74.4,NULL,NULL,'UGC 03326',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44455,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44455,34.58,0.43,82.3,10827,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03326',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44456,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44456,34.62,0.43,84.1,10827,75,NULL,'3.6 micron, color corrected','UGC 03326',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44457,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44457,37.04,0.55,256,10828,70,NULL,NULL,'2MASX J05393794-5303091',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,84.9080833333,-53.05247,0.233,NULL,35745988733,558531073,8727048,16.9),(44458,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44458,35.24,0.5,112,10829,70,NULL,NULL,'2MASX J05394079-1153363',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000107,NULL,'15.9b',0.6,NULL,NULL,NULL,NULL,NULL,1,84.9200416667,-11.89342,0.533,NULL,36663366943,572865108,8951017,15.9),(44459,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44459,35.92,0.32,153,10830,NULL,NULL,'Malmquist cor.','ESO 306- G 015',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.7',0.5,'S...',NULL,NULL,NULL,NULL,1,84.9202917,-41.445,0.041,NULL,37055758985,578996234,9046816,15.7),(44460,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44460,36,0.31,158,10830,NULL,NULL,NULL,'ESO 306- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44461,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44461,36.04,0.2,161,10830,74.4,NULL,NULL,'ESO 306- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44462,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44462,34.97,0.7,98.5,10831,NULL,NULL,NULL,'ESO 306- G 014',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.16',0.2,'S...',NULL,NULL,NULL,NULL,1,84.9217083,-39.78061,0.005,NULL,37100551537,579696117,9057751,16.16),(44463,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44463,35.01,0.2,100,10831,74.4,NULL,NULL,'ESO 306- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44464,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44464,35.19,0.64,109,10831,NULL,NULL,'Malmquist cor.','ESO 306- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44465,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44465,36.06,0.62,163,10832,70,NULL,NULL,'2MASX J05394410-4737543',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.7I',0.2,NULL,NULL,NULL,NULL,NULL,1,84.9339583,-47.63172,0.201,NULL,35708407574,557943868,8717872,14.7),(44466,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44466,35.7,0.58,138,10833,70,NULL,NULL,'2MASX J05394430-6513174',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,84.934625,-65.2215,0.193,NULL,35852889126,560201392,8753146,16.3),(44467,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44467,35.58,0.53,130,10834,70,NULL,NULL,'ESO 306- G 016',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'14.92',0.6,'S?',NULL,NULL,NULL,NULL,1,84.9726666667,-40.5125,0.045,NULL,37055404083,578990688,9046729,14.92),(44468,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44468,36.72,0.81,220,10835,70,NULL,NULL,'2MASX J05395524-4042349',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,84.980083,-40.70975,0.045,NULL,37055367953,578990124,9046720,15.1),(44469,'IRAS','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44469,31.32,0.8,18.3,10836,75,NULL,'MAT, I','ESO 120- G 012',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.00002,NULL,'14.06',1.4,'(R\')SB(rs)d',NULL,NULL,NULL,NULL,1,84.9959166667,-58.58547,0.185,NULL,35867753096,560433642,8756775,14.06),(44470,'Tully est','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44470,30.9,0.8,15.1,10836,75,NULL,NULL,'ESO 120- G 012',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44471,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44471,29.91,0.32,9.63,10836,85,NULL,'I, inv','ESO 120- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44472,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44472,29.98,0.32,9.95,10836,85,NULL,'I, raw','ESO 120- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44473,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44473,30.42,0.43,12.1,10836,75,NULL,'MAT, I, inv','ESO 120- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44474,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44474,30.53,0.4,12.8,10836,NULL,NULL,NULL,'ESO 120- G 012',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44475,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44475,30.54,0.4,12.8,10836,73,NULL,'opt','ESO 120- G 012',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44476,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44476,30.6,0.43,13.2,10836,75,NULL,'MAT, I, raw','ESO 120- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44477,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44477,30.86,0.43,14.9,10836,75,NULL,'MAT, I, cor','ESO 120- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44478,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44478,34.55,0.53,81.3,10837,70,NULL,NULL,'ESO 159- G 023',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000097,NULL,'14.38',0.8,'Sb',NULL,NULL,NULL,NULL,1,85.0400833333,-55.53967,0.229,NULL,35737626142,558400408,8725006,14.38),(44479,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44479,34.13,0.65,67,10838,NULL,NULL,NULL,'ESO 554- G 023',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000027,NULL,'14.64',0.8,'Sc',NULL,NULL,NULL,NULL,1,85.049083,-22.00314,0.093,NULL,37391326012,584239468,9128741,14.64),(44480,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44480,34.19,0.63,68.7,10838,NULL,NULL,'Malmquist cor.','ESO 554- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44481,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44481,35.36,0.57,118,10839,70,NULL,NULL,'2MASX J05401291-4053095',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000103,NULL,'13.9I',0.2,NULL,NULL,NULL,NULL,NULL,1,85.053917,-40.88597,0.025,NULL,37055705369,578995396,9046803,13.9),(44482,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44482,35.87,0.52,149,10840,70,NULL,NULL,'2MASX J05401415-3848285',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.8I',0.4,NULL,NULL,NULL,NULL,NULL,1,85.059083,-38.80797,0.033,NULL,37107671619,579807369,9059490,13.8),(44483,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44483,34.83,0.46,92.6,10841,70,NULL,NULL,'2MASX J05401515-1206589',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000097,NULL,'15.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,85.0630833333,-12.11631,0.533,NULL,36662857876,572857154,8950893,15.5),(44484,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44484,35.74,0.66,141,10842,70,NULL,NULL,'2MASX J05401840-4039575',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,85.0767083,-40.66589,0.045,NULL,37055377414,578990272,9046723,15.2),(44485,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44485,35.86,0.76,148,10843,70,NULL,NULL,'2MFGC 04611',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,85.076833,-23.14242,0.033,NULL,37115920388,579936256,9061504,15),(44486,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44486,36.4,0.51,190,10844,70,NULL,NULL,'2MASX J05402192-6023164',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,85.0912083,-60.388,0.205,NULL,35866506211,560414159,8756471,16),(44487,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44487,36.05,0.68,162,10845,70,NULL,NULL,'ESO 306- G 019',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.68',0.9,'S(r:)...',NULL,NULL,NULL,NULL,1,85.0964583,-41.4845,0.041,NULL,37053869256,578966707,9046354,15.68),(44488,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44488,36.37,0.95,188,10846,70,NULL,NULL,'2MASX J05403271-4034215',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,85.1362916667,-40.57261,0.045,NULL,37055416032,578990875,9046732,14.5),(44489,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44489,36.34,0.54,186,10847,70,NULL,NULL,'2MASX J05403504-2622341',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,85.146,-26.37619,0,NULL,37178025995,580906656,9076666,14.8),(44490,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44490,35.45,0.67,123,10848,70,NULL,NULL,'ESO 306- G 020',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.61',0.2,'S0:',NULL,NULL,NULL,NULL,1,85.1545417,-40.4415,0.037,NULL,37055594045,578993656,9046775,15.61),(44491,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44491,34.75,0.53,89.3,10849,70,NULL,NULL,'2MASX J05403895-7045118',NULL,'2014MNRAS.445.2677S',2014,1,0.89,NULL,'G',0.000103,NULL,'16.8b',0.8,NULL,NULL,NULL,NULL,NULL,1,85.1622917,-70.75331,0.265,NULL,35516499378,554945302,8671020,16.8),(44492,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44492,37.15,0.6,269,10850,70,NULL,NULL,'2MASX J05404323-2618311',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,85.1802083,-26.30867,0,NULL,37178003521,580906305,9076661,14.3),(44493,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44493,35.21,0.54,110,10851,70,NULL,NULL,'2MASX J05405680-3933450',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00008,NULL,'13.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,85.236625,-39.56256,0.045,NULL,37099788831,579684200,9057565,13.9),(44494,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44494,36.89,0.67,238,10852,70,NULL,NULL,'2MASX J05405756-5240126',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.9I',0.3,NULL,NULL,NULL,NULL,NULL,1,85.2397917,-52.67011,0.157,NULL,35740724042,558448813,8725762,13.9),(44495,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44495,36.16,0.76,170,10853,70,NULL,NULL,'2MASX J05410029-2556001',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,'S0-a',NULL,NULL,NULL,NULL,1,85.251167,-25.93342,0,NULL,37174418311,580850286,9075785,14.9),(44496,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44496,36.59,0.65,208,10854,70,NULL,NULL,'AM 0539-483',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'14.3I',0.4,'COMPACT',NULL,NULL,NULL,NULL,1,85.2517917,-48.60914,0.213,NULL,35707433948,557928655,8717635,14.3),(44497,'IRAS','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44497,31.27,0.8,17.9,10855,75,NULL,'MAT, I','ESO 363- G 015',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000013,NULL,'13.89',1.7,'SA(s)d',NULL,NULL,NULL,NULL,1,85.253625,-35.70753,0,NULL,37069068830,579204200,9050065,13.89),(44498,'Tully est','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44498,30.82,0.8,14.6,10855,75,NULL,NULL,'ESO 363- G 015',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44499,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44499,30.82,0.4,14.6,10855,NULL,NULL,NULL,'ESO 363- G 015',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44500,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44500,30.82,0.39,14.6,10855,73,NULL,'opt','ESO 363- G 015',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44501,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44501,30.9,0.2,15.1,10855,74.4,NULL,NULL,'ESO 363- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44502,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44502,30.91,0.32,15.2,10855,85,NULL,'I, inv','ESO 363- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44503,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44503,30.92,0.32,15.3,10855,85,NULL,'I, raw','ESO 363- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44504,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44504,31,0.43,15.8,10855,75,NULL,'MAT, I, inv','ESO 363- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44505,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44505,31.05,0.43,16.2,10855,75,NULL,'MAT, I, raw','ESO 363- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44506,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44506,31.26,0.43,17.9,10855,75,NULL,'MAT, I, cor','ESO 363- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44507,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44507,36.12,0.53,168,10856,70,NULL,NULL,'ESO 306- G 021',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000103,NULL,'15.21',0.6,'S0',NULL,NULL,NULL,NULL,1,85.2540416667,-41.57728,0.045,NULL,37053921202,578967518,9046367,15.21),(44508,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44508,35.61,0.25,132,10857,74.4,NULL,NULL,'GIN 291',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000033,NULL,'14.53',0.4,'E/S0',NULL,NULL,NULL,NULL,1,85.2605,-26.18692,0,NULL,37174404107,580850064,9075782,14.53),(44509,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44509,36.91,0.15,241,10857,70,NULL,NULL,'GIN 291',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44510,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44510,36.5,0.66,200,10858,70,NULL,NULL,'2MASX J05410740-5941458',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,85.28075,-59.69611,0.237,NULL,35869112111,560454876,8757107,16.1),(44511,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44511,36.12,0.63,168,10859,70,NULL,NULL,'2MASX J05410773-2522442',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,85.2822917,-25.37897,0.009,NULL,37172868277,580826066,9075407,15.7),(44512,'IRAS','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44512,33.26,0.8,44.8,10860,75,NULL,'MAT, I','ESO 554- G 024',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000013,NULL,'14.25',0.9,'SAB(rs)c',NULL,NULL,NULL,NULL,1,85.3332916667,-18.27786,0.225,NULL,36650101660,572657838,8947778,14.25),(44513,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44513,33.21,0.32,43.9,10860,85,NULL,'I, raw','ESO 554- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44514,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44514,33.23,0.32,44.2,10860,85,NULL,'I, inv','ESO 554- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44515,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44515,33.36,0.43,46.9,10860,75,NULL,'MAT, I, raw','ESO 554- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44516,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44516,33.43,0.43,48.5,10860,75,NULL,'MAT, I, cor','ESO 554- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44517,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44517,33.46,0.43,49.2,10860,75,NULL,'MAT, I, inv','ESO 554- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44518,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44518,33.69,0.2,54.7,10860,74.4,NULL,NULL,'ESO 554- G 024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44519,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44519,33.82,0.56,58,10860,NULL,NULL,NULL,'ESO 554- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44520,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44520,33.83,0.56,58.4,10860,NULL,NULL,'Malmquist cor.','ESO 554- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44521,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44521,35.6,0.25,132,10861,74.4,NULL,NULL,'GIN 290',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.00004,NULL,'14.19',NULL,'E/S0',NULL,NULL,NULL,NULL,1,85.335667,-26.25928,0,NULL,37177820107,580903439,9076616,14.19),(44522,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44522,36.91,0.15,241,10861,70,NULL,NULL,'GIN 290',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44523,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44523,35.6,0.25,132,10862,74.4,NULL,NULL,'GIN 289',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.00006,NULL,'14.92',NULL,'S',NULL,NULL,NULL,NULL,1,85.35625,-26.24172,0,NULL,37174395824,580849934,9075780,14.92),(44524,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44524,36.91,0.15,241,10862,70,NULL,NULL,'GIN 289',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44525,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44525,35.92,0.49,153,10863,70,NULL,NULL,'AM 0539-271 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.35',NULL,'INTERACTING',NULL,NULL,NULL,NULL,1,85.3644166667,-27.20867,0,NULL,37177372664,580896447,9076506,15.35),(44526,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44526,36.61,0.77,210,10864,70,NULL,NULL,'2MASX J05413133-4123397',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,85.3804583,-41.39431,0.041,NULL,37055840397,578997506,9046836,14.6),(44527,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44527,36.09,0.65,165,10865,70,NULL,NULL,'2MASX J05413166-2622092',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,85.3819583,-26.36919,0,NULL,37177948260,580905441,9076647,15.1),(44528,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44528,35.86,0.51,148,10866,70,NULL,NULL,'2MASX J05413266-1313342',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.47',NULL,NULL,NULL,NULL,NULL,NULL,1,85.386125,-13.22633,0.521,NULL,36695353585,573364899,8958826,15.47),(44529,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44529,30.64,0.43,13.4,10867,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J05413481+5059005',NULL,'2014MNRAS.444..527S',2014,1,0.78,NULL,'G',0.00004,NULL,'15.78',0.67,'S',NULL,NULL,NULL,NULL,1,85.395083,50.98344,1.665,NULL,66096701924,1032760967,16136890,15.78),(44530,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44530,36.16,0.71,171,10868,70,NULL,NULL,'2MASX J05413775-4156437',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,85.4072917,-41.94547,0.045,NULL,37054497620,578976525,9046508,15.3),(44531,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44531,35.3,0.47,115,10869,70,NULL,NULL,'ESO 424- G 007',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.50',0.2,'S...',NULL,NULL,NULL,NULL,1,85.4244583,-27.93358,0,NULL,37163030657,580672354,9073005,15.5),(44532,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44532,36.68,0.73,217,10870,70,NULL,NULL,'2MASX J05414333-2557590',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,85.4305416667,-25.96633,0,NULL,37174594970,580853046,9075828,15.9),(44533,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44533,35.6,0.25,132,10871,74.4,NULL,NULL,'GIN 301',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000053,NULL,'14.69',NULL,'E',NULL,NULL,NULL,NULL,1,85.44325,-25.86583,0,NULL,37172656645,580822760,9075355,14.69),(44534,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44534,35.74,0.5,141,10871,70,NULL,NULL,'GIN 301',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44535,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44535,36.91,0.15,241,10871,70,NULL,NULL,'GIN 301',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44536,'SNII optical','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1992ba',NULL,44536,30.73,0.2,14,10872,NULL,NULL,NULL,'NGC 2082',NULL,'1994ApJ...432...42S',1994,1,1.8,NULL,'G',0.000021,NULL,'12.62',1.7,'SAB(rs+)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,85.463,-64.30114,0.137,NULL,35849340050,560145938,8752280,12.62),(44537,'SNII optical','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1992ba',NULL,44537,31.07,0.3,16.4,10872,NULL,NULL,'EPM E96','NGC 2082',NULL,'2009ApJ...696.1176J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44538,'SNII optical','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1992ba',NULL,44538,31.31,0.54,18.3,10872,NULL,NULL,'SCM, V','NGC 2082',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44539,'SNII optical','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1992ba',NULL,44539,31.33,0.18,18.3,10872,NULL,NULL,'SEAM','NGC 2082',0.00395,'2009ApJ...694.1067P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44540,'SNII optical','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1992ba',NULL,44540,31.33,0.28,18.5,10872,NULL,NULL,'SCM, BVI','NGC 2082',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44541,'SNII optical','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1992ba',NULL,44541,31.34,0.4,18.5,10872,NULL,NULL,'SCM, B','NGC 2082',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44542,'SNII optical','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1992ba',NULL,44542,31.34,0.53,18.5,10872,NULL,NULL,'SCM, I','NGC 2082',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44543,'SNII optical','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1992ba',NULL,44543,31.47,0.07,19.7,10872,NULL,NULL,'I, photospheric magnitude method','NGC 2082',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44544,'SNII optical','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1992ba',NULL,44544,31.49,0.11,19.9,10872,NULL,NULL,'V, photospheric magnitude method','NGC 2082',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44545,'SNII optical','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1992ba',NULL,44545,32.17,0.48,27.2,10872,NULL,NULL,'EPM D05','NGC 2082',NULL,'2009ApJ...696.1176J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44546,'Tully est','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44546,30.41,0.8,12.1,10872,75,NULL,'B','NGC 2082',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44547,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 2010ju',NULL,44547,34.33,0.23,72.3,10873,70,NULL,'SiFTO+SALT2, SN 2010ju','UGC 03341',0.015244,'2012MNRAS.426.2359M',2012,1,1.8,'The 2MASS peak is 5 arcsec southeast of the optical nucleus.','G',0.000013,NULL,'15.5',1.8,'SBab',NULL,NULL,NULL,NULL,1,85.4814583,18.49236,NULL,NULL,65373998805,1021468731,15960448,15.5),(44548,'IRAS','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44548,31.93,0.8,24.4,10874,75,NULL,'MAT, I','UGCA 112',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.000013,NULL,'13.39',0.6,'SB(s)dm: sp',NULL,NULL,NULL,NULL,1,85.502375,-22.94667,0.061,NULL,37389835523,584216180,9128377,13.39),(44549,'Tully est','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44549,31.6,0.8,20.9,10874,75,NULL,NULL,'UGCA 112',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44550,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44550,30.82,0.32,14.6,10874,85,NULL,'I, inv','UGCA 112',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44551,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44551,30.85,0.32,14.8,10874,85,NULL,'I, raw','UGCA 112',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44552,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44552,31.04,0.2,16.1,10874,74.4,NULL,NULL,'UGCA 112',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44553,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44553,31.09,0.4,16.5,10874,NULL,NULL,NULL,'UGCA 112',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44554,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44554,31.09,0.4,16.5,10874,73,NULL,'opt','UGCA 112',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44555,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44555,31.23,0.43,17.6,10874,75,NULL,'MAT, I, inv','UGCA 112',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44556,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44556,31.28,0.43,18.1,10874,75,NULL,'MAT, I, raw','UGCA 112',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44557,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44557,31.6,0.43,20.9,10874,75,NULL,'MAT, I, cor','UGCA 112',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44558,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44558,35.98,0.55,157,10875,70,NULL,NULL,'2MASX J05420107-1248232',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.71',NULL,NULL,NULL,NULL,NULL,NULL,1,85.50425,-12.80642,0.501,NULL,36695193814,573362403,8958787,15.71),(44559,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44559,36.13,0.74,168,10876,70,NULL,NULL,'2MASX J05420147-3448190',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.5,NULL,NULL,NULL,NULL,NULL,1,85.506167,-34.80531,0,NULL,37068177258,579190269,9049847,14.3),(44560,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44560,35.6,0.25,132,10877,74.4,NULL,NULL,'MCG -04-14-013',NULL,'2013AJ....146...86T',2013,1,5,NULL,'G',0.000047,NULL,'13.51',3.4,'cD;SA0- pec:',NULL,NULL,NULL,NULL,1,85.518917,-26.12239,0,NULL,37174640359,580853755,9075839,13.51),(44561,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44561,36.91,0.15,241,10877,70,NULL,NULL,'MCG -04-14-013',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44562,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44562,36.18,0.4,172,10877,NULL,NULL,'mean','MCG -04-14-013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44563,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44563,36.22,0.45,176,10877,NULL,NULL,'K','MCG -04-14-013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44564,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44564,34,NULL,63.2,10878,65.2,NULL,'CO','NGC 1961',NULL,'1997A&A...326..915T',1997,1,4.6,NULL,'G',0.000003,NULL,'10.9B',3,'SAB(rs)c  LIRG;LINER','Group member, radial-velocity confirmed',NULL,NULL,'LINER',1,85.519375,69.37844,0.389,NULL,65634956808,1025546200,16024159,10.9),(44565,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44565,34.71,NULL,87.6,10878,54,NULL,'HI','NGC 1961',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44566,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44566,35.59,0.25,131,10879,74.4,NULL,NULL,'MCG -04-14-012',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000137,NULL,'14.82',0.3,'S',NULL,NULL,NULL,NULL,1,85.5197917,-26.14531,0,NULL,37174640069,580853751,9075839,14.82),(44567,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44567,36.91,0.15,241,10879,70,NULL,NULL,'MCG -04-14-012',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44568,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44568,35.29,0.46,114,10880,70,NULL,NULL,'MCG -04-14-014',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.00005,NULL,'13.43',0.25,'E/S0',NULL,NULL,NULL,NULL,1,85.5302083,-26.19817,0,NULL,37174631717,580853620,9075837,13.43),(44569,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44569,35.61,0.25,132,10880,74.4,NULL,NULL,'MCG -04-14-014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44570,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44570,36.91,0.15,241,10880,70,NULL,NULL,'MCG -04-14-014',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44571,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44571,36.33,0.4,185,10880,NULL,NULL,'mean','MCG -04-14-014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44572,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44572,36.61,0.45,210,10880,NULL,NULL,'K','MCG -04-14-014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44573,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44573,36.33,0.57,185,10881,70,NULL,NULL,'2MASX J05420754-2540243',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,85.531375,-25.67347,0,NULL,37172635285,580822426,9075350,15),(44574,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44574,37.69,0.55,346,10882,70,NULL,NULL,'2MASX J05420919-3450090',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.000103,NULL,'15.8R',0.27,NULL,NULL,NULL,NULL,NULL,1,85.5382083,-34.83589,0,NULL,37068173842,579190216,9049847,15.8),(44575,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44575,36.29,0.57,181,10883,70,NULL,NULL,'2MASX J05421176-2654033',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,85.549,-26.90097,0.021,NULL,37178304058,580911000,9076734,14.9),(44576,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44576,35.28,0.25,114,10884,74.4,NULL,NULL,'AM 0540-253 NED01',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000037,NULL,'14.87',0.4,'SB','Pair member (points to parent)',NULL,NULL,NULL,1,85.5607917,-25.54003,0,NULL,37173039623,580828744,9075449,14.87),(44577,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44577,36.91,0.15,241,10884,70,NULL,NULL,'AM 0540-253 NED01',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44578,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44578,35.76,0.54,142,10885,70,NULL,NULL,'2MASX J05421562-5520342',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.5b',0.4,NULL,NULL,NULL,NULL,NULL,1,85.565,-55.34281,0.325,NULL,35737789098,558402954,8725046,15.5),(44579,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44579,36.5,0.53,199,10886,70,NULL,NULL,'MC 0540-479',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.00015,NULL,'15.5b',1.1,'SAB(r)0^0^ pec:',NULL,NULL,NULL,NULL,1,85.577083,-47.94264,0.249,NULL,35717051957,558078936,8719983,15.5),(44580,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44580,35.56,0.47,130,10887,70,NULL,NULL,'MCG -04-14-016',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.000037,NULL,'13.74',0.2,'E/S0',NULL,NULL,NULL,NULL,1,85.5785,-26.09786,0,NULL,37174633201,580853643,9075838,13.74),(44581,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44581,35.61,0.25,132,10887,74.4,NULL,NULL,'MCG -04-14-016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44582,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44582,36.91,0.15,241,10887,70,NULL,NULL,'MCG -04-14-016',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44583,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44583,35.28,0.25,114,10888,74.4,NULL,NULL,'ESO 487- G 036',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000047,NULL,'14.42',0.9,'SA(s)0^0^ pec:','Pair member (points to parent)',NULL,NULL,NULL,1,85.5869583,-25.54103,0,NULL,37172912206,580826753,9075418,14.42),(44584,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44584,35.43,0.48,122,10888,70,NULL,NULL,'ESO 487- G 036',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44585,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44585,36.91,0.15,241,10888,70,NULL,NULL,'ESO 487- G 036',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44586,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44586,36.75,0.64,223,10889,70,NULL,NULL,'2MASX J05422120-2611524',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,85.5882917,-26.19794,0,NULL,37174586660,580852916,9075826,15.6),(44587,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44587,35.81,0.35,145,10890,NULL,NULL,NULL,'ESO 487- G 037',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'15.09',0.6,'Sb',NULL,NULL,NULL,NULL,1,85.629375,-26.78983,0.021,NULL,37178093497,580907710,9076682,15.09),(44588,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44588,35.81,0.35,145,10890,NULL,NULL,'Malmquist cor.','ESO 487- G 037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44589,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44589,35.85,0.2,148,10890,74.4,NULL,NULL,'ESO 487- G 037',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44590,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44590,37.22,0.66,278,10891,70,NULL,NULL,'2MASX J05423209-2529513',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,85.6337083,-25.49769,0,NULL,37173013953,580828343,9075442,15),(44591,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44591,34.77,0.49,90.1,10892,75,NULL,'IR','ESO 159- G 024',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'16.14',0.2,'S...',NULL,NULL,NULL,NULL,1,85.644417,-55.43856,0.325,NULL,35737775004,558402734,8725042,16.14),(44592,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44592,35.08,0.61,104,10892,NULL,NULL,NULL,'ESO 159- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44593,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44593,35.1,0.6,105,10892,NULL,NULL,'Malmquist cor.','ESO 159- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44594,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44594,35.12,0.2,106,10892,74.4,NULL,NULL,'ESO 159- G 024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44595,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44595,35.63,0.5,134,10893,70,NULL,NULL,'MCG -04-14-018',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15',0.5,NULL,NULL,NULL,NULL,NULL,1,85.6509583333,-20.99792,0.045,NULL,37396175137,584315236,9129925,15),(44596,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44596,36.34,0.54,186,10894,70,NULL,NULL,'2MASX J05424562-3331595',NULL,'2014MNRAS.445.2677S',2014,1,0.69,NULL,'G',0.00015,NULL,'14.8R',0.4,NULL,NULL,NULL,NULL,NULL,1,85.690125,-33.53319,0,NULL,37293481733,582710652,9104853,14.8),(44597,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44597,35.6,0.25,132,10895,74.4,NULL,NULL,'GIN 300',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000033,NULL,'15.34',NULL,'S',NULL,NULL,NULL,NULL,1,85.7282917,-26.31197,0,NULL,37174472971,580851140,9075799,15.34),(44598,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44598,36.91,0.15,241,10895,70,NULL,NULL,'GIN 300',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44599,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44599,36.27,0.66,180,10896,70,NULL,NULL,'2MASX J05430209-3814489',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,85.75875,-38.24697,0.093,NULL,37108627397,579822303,9059723,15.2),(44600,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44600,35.59,0.25,131,10897,74.4,NULL,NULL,'GIN 297',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.00015,NULL,'15.74',NULL,'S',NULL,NULL,NULL,NULL,1,85.7645417,-25.98503,0,NULL,37174521852,580851903,9075810,15.74),(44601,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44601,36.91,0.15,241,10897,70,NULL,NULL,'GIN 297',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44602,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44602,33.93,0.43,61,10898,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J05430552+0037134',NULL,'2014MNRAS.444..527S',2014,1,1,NULL,'G',0.000083,NULL,'12.9I',0.6,NULL,NULL,NULL,NULL,NULL,1,85.7730417,0.62033,1.493,NULL,64433227816,1006769184,15730768,12.9),(44603,'Tully est','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44603,30.36,0.8,11.8,10899,75,NULL,NULL,'ESO 159- G 025',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.00002,NULL,'15.48',0.9,'IB(s)m',NULL,NULL,NULL,NULL,1,85.7759583,-52.70044,0.157,NULL,35740949656,558452338,8725817,15.48),(44604,'GRB','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44604,37.14,NULL,268,10900,65,NULL,'L = 10e57 photons/s','4B 920723',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,85.791667,7.78,1.969,NULL,64669615141,1010462736,15788480,NULL),(44605,'GRB','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44605,40.3,NULL,1150,10900,65,NULL,'L = 2 x 10e58 photons/s','4B 920723',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44606,'IRAS','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44606,32.26,0.8,28.3,10901,75,NULL,'MAT, I','ESO 554- G 028',NULL,'1997ApJS..109..333W',1997,1,1.7,'The 2MASX position applies to a knot 19 arcsec southeast of the center.','G',0.000033,NULL,'15',0.2,'S...',NULL,NULL,NULL,NULL,1,85.807625,-18.63928,0.201,NULL,36651422425,572678475,8948101,15),(44607,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44607,31.28,0.32,18,10901,85,NULL,'I, inv','ESO 554- G 028',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44608,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44608,31.32,0.32,18.4,10901,85,NULL,'I, raw','ESO 554- G 028',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44609,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44609,31.8,0.43,22.9,10901,75,NULL,'MAT, I, inv','ESO 554- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44610,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44610,31.9,0.43,24,10901,75,NULL,'MAT, I, raw','ESO 554- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44611,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44611,31.92,0.2,24.2,10901,74.4,NULL,NULL,'ESO 554- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44612,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44612,32.27,0.43,28.5,10901,75,NULL,'MAT, I, cor','ESO 554- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44613,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44613,32.44,0.59,30.8,10901,NULL,NULL,NULL,'ESO 554- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44614,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44614,32.52,0.49,31.9,10901,75,NULL,'IR','ESO 554- G 028',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44615,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44615,32.54,0.4,32.3,10901,75,NULL,NULL,'ESO 554- G 028',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44616,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44616,32.55,0.4,32.3,10901,73,NULL,'IR','ESO 554- G 028',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44617,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44617,32.55,0.4,32.4,10901,73,NULL,'opt','ESO 554- G 028',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44618,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44618,32.63,0.39,33.6,10901,73,NULL,'opt','ESO 554- G 028',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44619,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44619,32.73,0.52,35.1,10901,NULL,NULL,'Malmquist cor.','ESO 554- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44620,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44620,35.62,0.25,133,10902,74.4,NULL,NULL,'GIN 292',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000037,NULL,'14.17',NULL,'E',NULL,NULL,NULL,NULL,1,85.8122917,-25.90311,0,NULL,37175034345,580859911,9075936,14.17),(44621,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44621,36.91,0.15,241,10902,70,NULL,NULL,'GIN 292',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44622,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44622,33.98,0.2,62.5,10903,74.4,NULL,NULL,'NGC 2049',NULL,'2013AJ....146...86T',2013,1,2,NULL,'G',0.000063,NULL,'13.65',1,'SA(s)a?',NULL,NULL,NULL,NULL,1,85.8137917,-30.07839,0,NULL,37156426314,580569161,9071393,13.65),(44623,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44623,34.06,0.43,65,10903,75,NULL,'3.6 micron, color corrected','NGC 2049',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44624,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44624,34.29,0.43,72.2,10903,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2049',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44625,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44625,35.52,0.48,127,10904,70,NULL,NULL,'2MASX J05431529-5506507',NULL,'2014MNRAS.445.2677S',2014,1,2.3,NULL,'G',0.000087,NULL,'14.7b',1.4,'SA0- pec',NULL,NULL,NULL,NULL,1,85.813833,-55.11417,0.361,NULL,35737705329,558401645,8725025,14.7),(44626,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44626,37.01,0.63,253,10905,70,NULL,NULL,'2MASX J05431795-4817284',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,85.82475,-48.29131,0.293,NULL,35716887578,558076368,8719943,17.1),(44627,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44627,36.68,0.59,217,10906,70,NULL,NULL,'2MASX J05433225-4750225',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,85.884375,-47.83956,0.249,NULL,35717543840,558086622,8720103,17),(44628,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44628,34.02,0.53,63.8,10907,70,NULL,NULL,'2MASX J05433340-3928170',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'13.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,85.8890833333,-39.47147,0.073,NULL,37107117232,579798706,9059354,13.9),(44629,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44629,35.75,0.55,141,10908,70,NULL,NULL,'2MASX J05434934-3300572',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'14.4R',0.2,NULL,NULL,NULL,NULL,NULL,1,85.955625,-33.01586,0,NULL,37293112313,582704879,9104763,14.4),(44630,'IRAS','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44630,32.86,0.8,37.4,10909,75,NULL,'MAT, I','UGCA 113',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000019,NULL,'13.99',0.8,'SB(s)cd pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,85.968167,-19.29364,0.145,NULL,37386870298,584169848,9127653,13.99),(44631,'Tully est','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44631,32.66,0.8,34.1,10909,75,NULL,NULL,'UGCA 113',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44632,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44632,32.52,0.32,31.9,10909,85,NULL,'I, raw','UGCA 113',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44633,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44633,32.53,0.32,32,10909,85,NULL,'I, inv','UGCA 113',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44634,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44634,32.58,0.2,32.8,10909,74.4,NULL,NULL,'UGCA 113',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44635,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44635,32.75,0.41,35.5,10909,NULL,NULL,NULL,'UGCA 113',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44636,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44636,32.78,0.43,36,10909,75,NULL,'MAT, I, raw','UGCA 113',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44637,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44637,32.86,0.4,37.3,10909,73,NULL,'opt','UGCA 113',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44638,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44638,32.87,0.43,37.4,10909,75,NULL,'MAT, I, inv','UGCA 113',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44639,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44639,32.95,0.38,38.9,10909,NULL,NULL,'Malmquist cor.','UGCA 113',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44640,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44640,32.98,0.43,39.4,10909,75,NULL,'MAT, I, cor','UGCA 113',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44641,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44641,33.05,0.49,40.8,10909,75,NULL,'IR','UGCA 113',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44642,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44642,35.87,0.42,149,10910,NULL,NULL,'Malmquist cor.','ESO 488- G 002',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15',0.7,'Sc',NULL,NULL,NULL,NULL,1,85.968167,-26.46617,0,NULL,37174962106,580858782,9075918,15),(44643,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44643,36.02,0.39,160,10910,NULL,NULL,NULL,'ESO 488- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44644,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44644,36.06,0.2,163,10910,74.4,NULL,NULL,'ESO 488- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44645,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44645,36.14,0.39,169,10911,NULL,NULL,'Malmquist cor.','AGC 450139',NULL,'2009ApJS..182..474S',2009,1,0.46,NULL,'G',0.000033,NULL,'15',0.18,'Sab','Group member',NULL,NULL,NULL,1,85.985417,-25.87814,0,NULL,37174194109,580846782,9075730,15),(44646,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44646,36.24,0.37,177,10911,NULL,NULL,NULL,'AGC 450139',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44647,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44647,36.28,0.2,180,10911,74.4,NULL,NULL,'AGC 450139',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44648,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44648,37.27,0.78,285,10912,70,NULL,NULL,'2MASX J05435694-4804511',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4b',NULL,'SAB(r)b',NULL,NULL,NULL,NULL,1,85.9877083,-48.08053,0.281,NULL,35717091456,558079554,8719993,15.4),(44649,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44649,36.84,0.57,233,10913,70,NULL,NULL,'2MASX J05440707-4838401',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.8b',0.5,NULL,NULL,NULL,NULL,NULL,1,86.029375,-48.64444,0.293,NULL,35715183899,558049748,8719527,15.8),(44650,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44650,37.09,0.58,262,10914,70,NULL,NULL,'ESO 204- G 033',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'16.26',0.2,'S...',NULL,NULL,NULL,NULL,1,86.047875,-48.19697,0.281,NULL,35716959772,558077496,8719960,16.26),(44651,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44651,35.8,0.57,145,10915,70,NULL,NULL,'2MASX J05441810-4940590',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,86.0755417,-49.68308,0.093,NULL,35712626180,558009784,8718902,16.1),(44652,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44652,35.65,0.23,135,10916,74.4,NULL,NULL,'GIN 299',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000047,NULL,'15.0V',NULL,'E','Group member',NULL,NULL,NULL,1,86.10825,-26.07825,0,NULL,37174207727,580846995,9075734,15),(44653,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44653,36.91,0.15,241,10916,70,NULL,NULL,'GIN 299',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44654,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44654,36.51,0.23,200,10917,74.4,NULL,NULL,'GIN 298',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000067,NULL,'14.2V',NULL,'E','Group member',NULL,NULL,NULL,1,86.1235,-26.05892,0,NULL,37174212309,580847067,9075735,14.2),(44655,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44655,36.91,0.15,241,10917,70,NULL,NULL,'GIN 298',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44656,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44656,33.14,0.49,42.4,10918,75,NULL,'IR','UGC 03342',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.00003,NULL,'15.20',0.4,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,86.123583,69.29897,0.389,NULL,65636068100,1025563564,16024430,15.2),(44657,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44657,33.79,0.4,57.3,10918,NULL,NULL,'mean','UGC 03342',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44658,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44658,33.98,0.47,62.5,10918,NULL,NULL,'H','UGC 03342',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44659,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44659,34.61,0.2,83.6,10918,74.4,NULL,NULL,'UGC 03342',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44660,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44660,36.95,0.25,245,10919,74.4,NULL,NULL,'2MASX J05443143-2611287',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.0001,NULL,'15',NULL,'E','Group member',NULL,NULL,NULL,1,86.1310417,-26.19131,0,NULL,37175100543,580860945,9075952,15),(44661,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44661,37.02,0.63,253,10919,70,NULL,NULL,'2MASX J05443143-2611287',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44662,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44662,36.52,0.25,201,10920,74.4,NULL,NULL,'PRC B-07',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000103,NULL,'15.7V',NULL,'Ep','Group member',NULL,NULL,NULL,1,86.145,-26.0885,0,NULL,37174200906,580846889,9075732,15.7),(44663,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44663,34.8,0.79,91,10921,NULL,NULL,NULL,'2MASX J05443744-2553347',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000147,NULL,'15.5V',0.4,'Sbc','Group member',NULL,NULL,NULL,1,86.1557083,-25.893,0,NULL,37174230713,580847354,9075739,15.5),(44664,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44664,34.84,0.2,92.9,10921,74.4,NULL,NULL,'2MASX J05443744-2553347',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44665,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44665,35.23,0.65,111,10921,NULL,NULL,'Malmquist cor.','2MASX J05443744-2553347',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44666,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44666,34.1,0.47,66.1,10922,NULL,NULL,'H','UGC 03352',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000023,NULL,'16.0',0.4,'SB?',NULL,NULL,NULL,NULL,1,86.203667,16.77394,NULL,NULL,64553394013,1008646781,15760105,16),(44667,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44667,34.29,0.4,72.2,10922,NULL,NULL,'mean','UGC 03352',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44668,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44668,34.29,0.45,72.3,10922,NULL,NULL,'K','UGC 03352',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44669,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44669,36.59,0.55,208,10923,70,NULL,NULL,'2MASX J05444897-4745115',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,86.2040833333,-47.75314,0.277,NULL,35717600926,558087514,8720117,16.7),(44670,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44670,35.5,0.48,126,10924,70,NULL,NULL,'ESO 488- G 004',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'14.58',0.5,'Sa       poss. LINER','Group member',NULL,NULL,NULL,1,86.2125833333,-25.09694,0.009,NULL,37117313814,579958028,9061844,14.58),(44671,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44671,36.5,0.25,200,10925,74.4,NULL,NULL,'2MASX J05445589-2556190',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000127,NULL,'15.1V',NULL,NULL,'Group member',NULL,NULL,NULL,1,86.232875,-25.93878,0,NULL,37174352362,580849255,9075769,15.1),(44672,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44672,35.62,0.25,133,10926,74.4,NULL,NULL,'GIN 295',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000037,NULL,'14.34',NULL,'E','Group member',NULL,NULL,NULL,1,86.234083,-25.92111,0,NULL,37174351954,580849249,9075769,14.34),(44673,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44673,36.91,0.15,241,10926,70,NULL,NULL,'GIN 295',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44674,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44674,32.94,0.69,38.8,10927,100,NULL,'mid-IR','UGC 03344',NULL,'2013ApJ...771...88L',2013,1,2.5,'UGC misprints dec as +60d09\'. UGC galactic coordinates are correct.','G',0.00002,NULL,'14.2',1.5,'SABbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,86.236,69.15931,0.441,NULL,65636031425,1025562991,16024421,14.2),(44675,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44675,33.8,0.47,57.5,10927,NULL,NULL,'H','UGC 03344',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44676,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44676,33.86,0.45,59.2,10927,NULL,NULL,'K','UGC 03344',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44677,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44677,33.89,0.4,59.9,10927,NULL,NULL,'mean','UGC 03344',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44678,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44678,33.9,0.46,60.2,10927,NULL,NULL,'J','UGC 03344',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44679,'Brightest Stars','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44679,29.05,0.63,6.4,10928,NULL,NULL,NULL,'Orion Dwarf',NULL,'1996A&A...315..348K',1996,1,2,NULL,'G',0.00001,NULL,'15.4B',1,'SBd:','Dwarf, field object',NULL,NULL,NULL,1,86.2567917,5.06144,2.049,NULL,64477834668,1007466166,15741658,15.4),(44680,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44680,36.83,0.56,232,10929,70,NULL,NULL,'AM 0543-480 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.36',0.4,NULL,NULL,NULL,NULL,NULL,1,86.264625,-48.08,0.277,NULL,35716977092,558077767,8719965,16.36),(44681,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44681,35.59,0.25,131,10930,74.4,NULL,NULL,'GIN 280',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000033,NULL,'14.7V',NULL,'S03p','Group member',NULL,NULL,NULL,1,86.2705,-25.79464,0,NULL,37172055775,580813371,9075208,14.7),(44682,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44682,35.79,0.09,144,10930,70,NULL,NULL,'GIN 280',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44683,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44683,35.62,0.25,133,10931,74.4,NULL,NULL,'GIN 296',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000073,NULL,'16.7V',NULL,'Sbc','Group member',NULL,NULL,NULL,1,86.2840833333,-26.09303,0,NULL,37174329312,580848895,9075763,16.7),(44684,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44684,36.91,0.15,241,10931,70,NULL,NULL,'GIN 296',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44685,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44685,36.77,0.62,225,10932,70,NULL,NULL,'ESO 363- G 021',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'16.06',0.6,'(R\'_2)SB(s)a',NULL,NULL,NULL,NULL,1,86.330625,-32.89228,0,NULL,37292870827,582701106,9104704,16.06),(44686,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44686,35.38,0.49,119,10933,70,NULL,NULL,'ESO 488- G 006',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00004,NULL,'13.8V',0.8,'SA(rs?)0^+?   LINER?','Group member',NULL,NULL,'Flat-Spectrum Radio Source',1,86.3420417,-25.79167,0,NULL,37172058365,580813411,9075209,13.8),(44687,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44687,35.6,0.25,132,10933,74.4,NULL,NULL,'ESO 488- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44688,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44688,35.79,0.09,144,10933,70,NULL,NULL,'ESO 488- G 006',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44689,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44689,30.5,0.2,12.6,10934,74.4,NULL,NULL,'UGC 03343',NULL,'2013AJ....146...86T',2013,1,2.1,NULL,'G',0.000027,NULL,'13.93',0.5,'Sb','Isolated galaxy',NULL,NULL,NULL,1,86.352667,72.35622,0.393,NULL,65640416142,1025631502,16025492,13.93),(44690,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44690,30.68,0.39,13.7,10934,73,NULL,'opt','UGC 03343',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44691,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44691,30.85,0.62,14.8,10934,NULL,NULL,NULL,'UGC 03343',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44692,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44692,31.23,0.4,17.6,10934,NULL,NULL,'mean','UGC 03343',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44693,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44693,31.23,0.52,17.6,10934,NULL,NULL,'Malmquist cor.','UGC 03343',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44694,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44694,31.51,0.46,20,10934,NULL,NULL,'J','UGC 03343',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44695,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44695,31.63,0.47,21.2,10934,NULL,NULL,'H','UGC 03343',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44696,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44696,31.68,0.45,21.7,10934,NULL,NULL,'K','UGC 03343',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44697,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44697,37.07,0.66,259,10935,70,NULL,NULL,'2MASX J05452499-4257375',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,86.354083,-42.96036,0.093,NULL,37046432808,578850512,9044539,15.2),(44698,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44698,35.79,0.09,144,10936,70,NULL,NULL,'GIN 282',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.000037,NULL,'15.5V',NULL,'S0','Group member',NULL,NULL,NULL,1,86.3630417,-25.89808,0.037,NULL,37174139898,580845935,9075717,15.5),(44699,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44699,36.67,0.25,216,10936,74.4,NULL,NULL,'GIN 282',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44700,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44700,35.91,0.56,152,10937,70,NULL,NULL,'2MASX J05452867-3903091',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000133,NULL,'14.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,86.369583,-39.05247,0.061,NULL,37105643152,579775674,9058994,14.1),(44701,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44701,36.36,0.61,187,10938,70,NULL,NULL,'2MASX J05452904-4759261',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.4,NULL,NULL,NULL,NULL,NULL,1,86.3710417,-47.99058,0.277,NULL,35716938001,558077156,8719955,13.9),(44702,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44702,35.84,0.54,147,10939,70,NULL,NULL,'2MASX J05452947-2746125',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,86.3727916667,-27.77017,0.053,NULL,37177135404,580892740,9076449,14.6),(44703,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44703,35.69,0.23,137,10940,74.4,NULL,NULL,'ESO 488- G 009',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.000067,NULL,'13.6V',1.2,'cD;S0- pec;BrClG','Group member',NULL,NULL,NULL,1,86.373417,-25.93247,0.037,NULL,37174357747,580849339,9075770,13.6),(44704,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44704,35.79,0.09,144,10940,70,NULL,NULL,'ESO 488- G 009',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44705,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44705,36.57,0.55,206,10941,70,NULL,NULL,'AM 0543-234',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.9R',NULL,'DWARF',NULL,NULL,NULL,NULL,1,86.378875,-23.69461,0.021,NULL,37118101592,579970337,9062036,14.9),(44706,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44706,35.35,0.48,118,10942,70,NULL,NULL,'2MASX J05453243-2155237',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000107,NULL,'15.92',NULL,NULL,NULL,NULL,NULL,NULL,1,86.3849583,-21.92336,0,NULL,37394277424,584285584,9129462,15.92),(44707,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44707,35.9,0.7,151,10943,70,NULL,NULL,'2MASX J05453571-2258187',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,86.3987917,-22.97194,0.017,NULL,37389108308,584204817,9128200,15.1),(44708,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44708,36.69,0.52,218,10944,70,NULL,NULL,'2MASX J05453695-6042529',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'13.3I',0.8,NULL,NULL,NULL,NULL,NULL,1,86.4040417,-60.71478,0.185,NULL,35864094401,560376475,8755882,13.3),(44709,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44709,35.79,0.59,144,10945,70,NULL,NULL,'2MASX J05453717-2933355',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,86.40475,-29.55989,0,NULL,37155874035,580560531,9071258,15.6),(44710,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44710,36.3,0.53,182,10946,70,NULL,NULL,'2MASX J05453815-3157073',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,86.4089583,-31.95206,0,NULL,37293789286,582715457,9104929,15),(44711,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44711,36.71,0.75,220,10947,70,NULL,NULL,'2MASX J05453865-3549253',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'15.6R',0.13,NULL,NULL,NULL,NULL,NULL,1,86.411083,-35.82369,0,NULL,37073985817,579281028,9051266,15.6),(44712,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44712,36,0.49,159,10948,70,NULL,NULL,'2MASX J05453931-4833291',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.9b',0.4,NULL,NULL,NULL,NULL,NULL,1,86.41375,-48.55817,0.341,NULL,35718031429,558094241,8720222,15.9),(44713,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44713,36.95,0.82,246,10949,70,NULL,NULL,'ESO 033- G 029',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.00015,NULL,'15.52',0.5,'S...',NULL,NULL,NULL,NULL,1,86.4139583,-74.56222,0.469,NULL,35542202000,555346906,8677295,15.52),(44714,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44714,33.44,0.43,48.8,10950,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03351',NULL,'2014MNRAS.444..527S',2014,1,1.6,NULL,'G',0.00003,NULL,'16.0',0.3,'Sab            HII',NULL,NULL,NULL,'Sy 2',1,86.4495,58.70108,1.145,NULL,66149713421,1033589272,16149832,16),(44715,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44715,33.68,0.45,54.4,10950,NULL,NULL,'K','UGC 03351',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44716,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44716,33.84,0.47,58.7,10950,NULL,NULL,'H','UGC 03351',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44717,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44717,33.95,0.4,61.6,10950,NULL,NULL,'mean','UGC 03351',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44718,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44718,34.04,0.46,64.3,10950,NULL,NULL,'J','UGC 03351',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44719,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,'R',44719,34.37,0.49,74.7,10950,75,NULL,'IR','UGC 03351',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44720,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44720,36.61,0.82,210,10951,70,NULL,NULL,'2MASX J05455217-2536140',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,86.4674583333,-25.60397,0,NULL,37116497990,579945281,9061645,15.4),(44721,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44721,36.35,0.77,186,10952,70,NULL,NULL,'2MASX J05455336-5310318',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,86.472375,-53.1755,0.373,NULL,35748782762,558574730,8727730,14.3),(44722,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44722,33.33,0.4,46.3,10953,NULL,NULL,'mean','NGC 2073',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000053,NULL,'13.42',1.4,'SA(rs)0-:',NULL,NULL,NULL,NULL,1,86.474625,-21.99914,0,NULL,37394207784,584284496,9129445,13.42),(44723,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44723,33.34,0.45,46.5,10953,NULL,NULL,'K','NGC 2073',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44724,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44724,36.46,0.68,196,10954,70,NULL,NULL,'2MASX J05460722-3702010',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'15.5R',0.21,NULL,NULL,NULL,NULL,NULL,1,86.530125,-37.03364,0.057,NULL,37073483217,579273175,9051143,15.5),(44725,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44725,36.49,0.47,199,10955,NULL,NULL,'Malmquist cor.','2MASX J05461691-2516111',NULL,'2009ApJS..182..474S',2009,1,0.46,NULL,'G',0.000033,NULL,'15',0.28,'Sb','Group member',NULL,NULL,NULL,1,86.5704166667,-25.26969,0,NULL,37116556209,579946190,9061659,15),(44726,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44726,36.82,0.4,231,10955,NULL,NULL,NULL,'2MASX J05461691-2516111',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44727,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44727,36.86,0.2,236,10955,74.4,NULL,NULL,'2MASX J05461691-2516111',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44728,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44728,35.97,0.4,156,10956,NULL,NULL,'Malmquist cor.','ESO 488- G 012',NULL,'2009ApJS..182..474S',2009,1,1.6,NULL,'G',0.000033,NULL,'14.82',0.4,'S pec sp       HII','Pair member (points to parent)',NULL,NULL,NULL,1,86.5876666667,-23.47167,0.021,NULL,37117678709,579963729,9061933,14.82),(44729,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44729,36.23,0.35,176,10956,NULL,NULL,NULL,'ESO 488- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44730,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44730,36.27,0.2,179,10956,74.4,NULL,NULL,'ESO 488- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44731,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44731,33.52,NULL,50.7,10957,NULL,NULL,'Dipole + Quadrupole + Octopole','FGCE 0527',NULL,'2010Ap&SS.325..163P',2010,1,1.19,NULL,'G',0.000087,'?','16.6',0.12,'Sd',NULL,NULL,NULL,NULL,1,86.587917,-17.38306,0.305,NULL,36652909240,572701706,8948464,16.6),(44732,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44732,33.55,NULL,51.2,10957,NULL,NULL,'Dipole + Quadrupole','FGCE 0527',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44733,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44733,33.56,NULL,51.6,10957,NULL,NULL,'Dipole','FGCE 0527',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44734,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44734,33.61,NULL,52.8,10957,NULL,NULL,NULL,'FGCE 0527',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44735,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44735,37.22,0.58,278,10958,70,NULL,NULL,'2MASX J05462144-5401363',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,86.5892083,-54.02669,0.449,NULL,35752195204,558628050,8728563,17.1),(44736,'Tully est','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44736,30.61,0.8,13.3,10959,75,NULL,NULL,'NGC 2101',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000007,NULL,'13.69',1.3,'IB(s)m pec',NULL,NULL,NULL,NULL,1,86.6007083,-52.08853,0.193,NULL,35741339667,558458432,8725913,13.69),(44737,'FP','2016-12-15 15:14:12','2016-12-16 11:19:17','1',NULL,NULL,44737,36.67,0.71,215,10960,70,NULL,NULL,'2MASX J05462460-4845458',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.9I',0.2,NULL,NULL,NULL,NULL,NULL,1,86.602375,-48.76275,0.281,NULL,35714842557,558044414,8719443,14.9),(44738,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1993ac',NULL,44738,36,0.18,151,10961,74.2,NULL,'SALT 2','CGCG 307-023',0.049,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,'15.7',NULL,'E',NULL,NULL,NULL,NULL,1,86.602667,63.35906,0.565,NULL,66113208417,1033018881,16140920,15.7),(44739,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1993ac',NULL,44739,36.44,0.11,194,10961,60,NULL,'M(I) = -19.19 mag','CGCG 307-023',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44740,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1993ac',NULL,44740,36.55,0.28,195,10961,72,NULL,NULL,'CGCG 307-023',0.049,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44741,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1993ac',NULL,44741,36.61,0.08,200,10961,72,NULL,NULL,'CGCG 307-023',0.049,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44742,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1993ac',NULL,44742,36.64,0.18,203,10961,70,NULL,'SALT','CGCG 307-023',0.049,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44743,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1993ac',NULL,44743,36.54,0.08,203,10961,74.4,NULL,NULL,'CGCG 307-023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44744,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1993ac',NULL,44744,36.67,0.16,205,10961,70,NULL,'SALT 2','CGCG 307-023',0.049,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44745,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1993ac',NULL,44745,36.64,0.12,213,10961,60,NULL,'M(V) = -19.47 mag','CGCG 307-023',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44746,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1993ac',NULL,44746,36.64,0.12,213,10961,70.8,NULL,NULL,'CGCG 307-023',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44747,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1993ac',NULL,44747,36.66,0.16,215,10961,60,NULL,'M(B) = -19.48 mag','CGCG 307-023',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44748,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1993ac',NULL,44748,36.88,0.19,216,10961,65,NULL,'MLCS2k2','CGCG 307-023',0.049,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44749,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1993ac',NULL,44749,36.79,0.16,217,10961,65,NULL,'SALT','CGCG 307-023',0.049,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44750,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1993ac',NULL,44750,36.88,0.22,226,10961,65,NULL,'MLCS31','CGCG 307-023',0.049,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44751,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1993ac',NULL,44751,36.89,0.19,228,10961,65,NULL,'SALT2','CGCG 307-023',0.049,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44752,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1993ac',NULL,44752,36.89,0.19,228,10961,65,NULL,'MLCS17','CGCG 307-023',0.049,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44753,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1993ac',NULL,44753,36.9,0.2,229,10961,65,NULL,NULL,'CGCG 307-023',0.049,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44754,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1993ac',NULL,44754,36.93,0.22,243,10961,65,NULL,'Snapshot','CGCG 307-023',NULL,'1996ApJ...473...88R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44755,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:17','1','SN 1993ac',NULL,44755,37.13,0.24,254,10961,65,NULL,'MLCS','CGCG 307-023',0.049,'1996ApJ...473..588R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44756,'SNIa','2016-12-15 15:14:12','2016-12-16 11:19:18','1','SN 1993ac',NULL,44756,37.09,0.14,262,10961,60,NULL,NULL,'CGCG 307-023',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44757,'GRB','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,'RN',44757,44.05,0.41,2990,10962,NULL,NULL,NULL,'GRB 061126 HOST',1.1588,'2010JCAP...08..020W',2010,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44758,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44758,35.99,0.77,158,10963,70,NULL,NULL,'2MFGC 04683',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'15.2R',0.16,NULL,NULL,NULL,NULL,NULL,1,86.6307917,-33.0015,0,NULL,37282145102,582533517,9102086,15.2),(44759,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44759,32.83,0.47,36.8,10964,NULL,NULL,'H','UGC 03349',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.00003,NULL,'14.42',0.7,'Sab','Group member',NULL,NULL,NULL,1,86.631875,69.05097,0.445,NULL,65636138979,1025564671,16024447,14.42),(44760,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44760,33.02,0.45,40.2,10964,NULL,NULL,'K','UGC 03349',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44761,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44761,33.05,0.46,40.7,10964,NULL,NULL,'J','UGC 03349',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44762,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44762,33.9,0.4,60.4,10964,NULL,NULL,'mean','UGC 03349',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44763,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44763,35.63,0.25,134,10965,74.4,NULL,NULL,'GIN 284',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.00015,NULL,'14.71',NULL,'S0','Group member',NULL,NULL,NULL,1,86.64175,-25.38114,0,NULL,37116543990,579945999,9061656,14.71),(44764,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44764,35.79,0.09,144,10965,70,NULL,NULL,'GIN 284',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44765,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44765,35.38,0.5,119,10966,70,NULL,NULL,'2MASX J05464223-6523319',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,86.676083,-65.39219,0.169,NULL,35851560372,560180630,8752822,15.7),(44766,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44766,33.16,0.2,42.9,10967,74.4,NULL,NULL,'NGC 2076',NULL,'2013AJ....146...86T',2013,1,2.2,'Extended HIPASS source','G',0.000017,NULL,'14.0',1.3,'S0+: sp',NULL,NULL,NULL,NULL,1,86.69775,-16.78261,0.197,NULL,36697043311,573391301,8959239,14),(44767,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44767,35.61,0.62,132,10968,70,NULL,NULL,'ESO 363- G 022',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.40',0.5,'SB0^0^? sp',NULL,NULL,NULL,NULL,1,86.702875,-32.57919,0,NULL,37280546700,582508542,9101695,15.4),(44768,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44768,36.03,0.58,161,10969,70,NULL,NULL,'2MASX J05465141-3338453',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'14.9R',0.31,NULL,NULL,NULL,NULL,NULL,1,86.71425,-33.646,0,NULL,37281973850,582530841,9102044,14.9),(44769,'IRAS','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44769,33.11,0.8,41.9,10970,75,NULL,'MAT, I','IC 2143',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000007,NULL,'13.39',0.8,'(R\'_2)SB(s)bc:','Pair member (points to parent)',NULL,NULL,NULL,1,86.7192083,-18.72639,0.261,NULL,36651343568,572677243,8948081,13.39),(44770,'Sosies','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44770,32.96,0.06,39.1,10970,NULL,NULL,NULL,'IC 2143',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44771,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44771,32.82,0.32,36.7,10970,85,NULL,'I, raw','IC 2143',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44772,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44772,32.87,0.32,37.5,10970,85,NULL,'I, inv','IC 2143',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44773,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44773,32.91,0.43,38.1,10970,75,NULL,'MAT, I, raw','IC 2143',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44774,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44774,32.96,0.43,39,10970,75,NULL,'3.6 micron, color corrected','IC 2143',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44775,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44775,32.96,0.43,39,10970,75,NULL,'3.6 micron, color + selection bias corrected','IC 2143',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44776,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44776,32.97,0.2,39.3,10970,74.4,NULL,NULL,'IC 2143',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44777,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44777,33,0.4,39.8,10970,73,NULL,'opt','IC 2143',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44778,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44778,33.05,0.43,40.8,10970,75,NULL,'MAT, I, cor','IC 2143',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44779,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44779,33.05,0.31,40.8,10970,NULL,NULL,NULL,'IC 2143',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44780,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44780,33.09,0.31,41.5,10970,NULL,NULL,'Malmquist cor.','IC 2143',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44781,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44781,33.11,0.43,41.9,10970,75,NULL,'MAT, I, inv','IC 2143',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44782,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44782,35.79,0.09,144,10971,70,NULL,NULL,'ESO 488- G 013',NULL,'2001MNRAS.321..277C',2001,1,1.1,NULL,'G',0.000047,NULL,'15.1',0.7,'SA(r)0+','Group member',NULL,NULL,NULL,1,86.7310417,-25.63556,0,NULL,37123839556,580059993,9063437,15.1),(44783,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44783,36.67,0.25,216,10971,74.4,NULL,NULL,'ESO 488- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44784,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44784,35.99,0.68,158,10972,70,NULL,NULL,'2MASX J05465983-2535450',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,86.7492916667,-25.59586,0,NULL,37123840595,580060009,9063437,14.9),(44785,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,'R',44785,29.88,0.1,9.46,10973,73,NULL,'Cepheids periods Gaussian, Data 2','NGC 2090',NULL,'2009RoAJ...19...35A',2009,1,4.9,'Extended HIPASS source','G',0.000007,NULL,'11.99',2.4,'SA:(rs)b',NULL,NULL,NULL,NULL,1,86.757875,-34.25061,0,NULL,37061951651,579092994,9048328,11.99),(44786,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,'R',44786,29.94,0.07,9.73,10973,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian, Data 2','NGC 2090',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44787,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,'R',44787,30.03,0.05,10.1,10973,73,NULL,'Cepheids magnitudes Gaussian, Data 2','NGC 2090',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44788,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,'R',44788,30.1,0.09,10.5,10973,73,NULL,'Cepheids magnitudes Gaussian, Data 1','NGC 2090',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44789,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,'R',44789,30.12,0.18,10.6,10973,73,NULL,'Cepheids periods Gaussian, Data 1','NGC 2090',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44790,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,'R',44790,30.12,0.13,10.6,10973,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian, Data 1','NGC 2090',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44791,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44791,30.29,0.04,11.4,10973,NULL,NULL,'30, VI, KEY PROJECT','NGC 2090',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44792,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44792,30.3,0.08,11.5,10973,NULL,NULL,'LMC W01','NGC 2090',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44793,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44793,30.32,0.04,11.6,10973,NULL,NULL,'cte LMC K03','NGC 2090',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44794,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44794,30.32,0.05,11.6,10973,NULL,NULL,'MW HIPP','NGC 2090',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44795,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44795,30.33,0.04,11.6,10973,NULL,NULL,'cte U99','NGC 2090',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44796,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44796,30.35,0.04,11.7,10973,NULL,NULL,'cte LMC STS02','NGC 2090',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44797,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44797,30.35,0.04,11.8,10973,NULL,NULL,'30, VI, +Z, KEY PROJECT','NGC 2090',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44798,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44798,30.36,0.15,11.8,10973,NULL,NULL,'MW P02','NGC 2090',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44799,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44799,30.36,0.22,11.8,10973,NULL,18.39,'VI, LMC ZP','NGC 2090',NULL,'2008MNRAS.390.1539M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44800,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44800,30.37,0.09,11.9,10973,74.4,NULL,NULL,'NGC 2090',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44801,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44801,30.39,0.04,12,10973,NULL,NULL,'cte MW FSG03','NGC 2090',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44802,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44802,30.42,0.04,12.1,10973,NULL,NULL,'cte MW GFG98','NGC 2090',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44803,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44803,30.42,0.04,12.2,10973,NULL,NULL,'cte MF91','NGC 2090',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44804,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44804,30.44,0.07,12.2,10973,NULL,NULL,'MW GFG','NGC 2090',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44805,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44805,30.44,0.07,12.2,10973,NULL,NULL,'103, VI','NGC 2090',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44806,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44806,30.45,0.08,12.3,10973,NULL,NULL,'35, VI','NGC 2090',NULL,'1998ApJ...500..763P',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44807,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44807,30.45,0.08,12.3,10973,NULL,NULL,'HST KP Calibrated','NGC 2090',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44808,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,'R',44808,30.48,NULL,12.5,10973,NULL,18.54,NULL,'NGC 2090',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44809,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44809,30.48,0.04,12.5,10973,NULL,18.54,'LMC ZP','NGC 2090',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44810,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44810,30.49,0.04,12.5,10973,NULL,NULL,'cte MW STS03','NGC 2090',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44811,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44811,30.57,0.02,13,10973,NULL,NULL,'4, H','NGC 2090',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44812,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,'R',44812,30.57,0.2,13,10973,NULL,NULL,'4, H','NGC 2090',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44813,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,'R',44813,30.66,0.13,13.6,10973,NULL,NULL,'4, I','NGC 2090',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44814,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44814,30.66,0.13,13.6,10973,NULL,NULL,'4, I','NGC 2090',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44815,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44815,30.75,0.18,14.1,10973,NULL,NULL,'4, V','NGC 2090',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44816,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,'R',44816,30.75,0.18,14.1,10973,NULL,NULL,'4, V','NGC 2090',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44817,'Cepheids','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44817,31.01,NULL,15.9,10973,NULL,NULL,'31, VI','NGC 2090',NULL,'2006A&A...452..423P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44818,'IRAS','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44818,30.5,0.8,12.6,10973,75,NULL,'MAT, I','NGC 2090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44819,'IRAS','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44819,30.58,0.8,13,10973,75,NULL,'A82, H','NGC 2090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44820,'Sosies','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44820,30.36,0.15,11.8,10973,NULL,NULL,NULL,'NGC 2090',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44821,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44821,30.04,0.4,10.2,10973,75,NULL,'B','NGC 2090',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44822,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44822,30.21,0.14,11,10973,NULL,NULL,'I','NGC 2090',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44823,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,'R',44823,30.26,NULL,11.3,10973,NULL,NULL,'I','NGC 2090',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44824,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,'R',44824,30.35,0.04,11.7,10973,75,NULL,NULL,'NGC 2090',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44825,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44825,30.37,0.09,11.9,10973,74.4,NULL,NULL,'NGC 2090',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44826,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44826,30.42,0.47,12.1,10973,75,NULL,'A82, H, raw','NGC 2090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44827,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44827,30.45,0.4,12.3,10973,73,NULL,'opt','NGC 2090',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44828,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44828,30.48,0.47,12.5,10973,75,NULL,'A82, H, inv','NGC 2090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44829,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,'R',44829,30.51,NULL,12.6,10973,NULL,NULL,'B','NGC 2090',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44830,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44830,30.54,0.35,12.8,10973,NULL,NULL,NULL,'NGC 2090',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44831,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44831,30.62,0.43,13.3,10973,75,NULL,'3.6 micron, color corrected','NGC 2090',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44832,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44832,30.64,0.4,13.4,10973,NULL,NULL,NULL,'NGC 2090',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44833,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44833,30.63,0.43,13.4,10973,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2090',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44834,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44834,30.76,0.47,14.2,10973,75,NULL,'A82, H, cor','NGC 2090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44835,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44835,30.78,0.32,14.3,10973,85,NULL,'I, raw','NGC 2090',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44836,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44836,30.81,0.32,14.5,10973,85,NULL,'I, inv','NGC 2090',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44837,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44837,30.8,0.43,14.5,10973,75,NULL,'MAT, I, raw','NGC 2090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44838,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44838,30.91,0.35,15.2,10973,NULL,NULL,'Malmquist cor.','NGC 2090',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44839,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44839,30.97,0.43,15.7,10973,75,NULL,'MAT, I, inv','NGC 2090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44840,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44840,31.05,0.7,16.2,10973,NULL,NULL,'B','NGC 2090',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44841,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44841,31.05,0.43,16.3,10973,75,NULL,'MAT, I, cor','NGC 2090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44842,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,'R',44842,31.21,NULL,17.5,10973,NULL,NULL,'LEDA [April 2006]','NGC 2090',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44843,'IRAS','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44843,31,0.8,15.9,10974,75,NULL,'MAT, I','NGC 2104',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000007,NULL,'13.18',0.9,'SAB(s)cd:',NULL,NULL,NULL,NULL,1,86.7697083,-51.55292,0.161,NULL,35760006585,558750102,8730470,13.18),(44844,'Tully est','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44844,30.53,0.8,12.7,10974,75,NULL,NULL,'NGC 2104',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44845,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44845,29.57,0.32,8.24,10974,85,NULL,'I, inv','NGC 2104',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44846,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44846,29.65,0.32,8.47,10974,85,NULL,'I, raw','NGC 2104',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44847,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44847,30.02,0.43,10.1,10974,75,NULL,'MAT, I, inv','NGC 2104',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44848,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44848,30.17,0.43,10.8,10974,75,NULL,'MAT, I, raw','NGC 2104',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44849,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44849,30.48,0.43,12.5,10974,75,NULL,'MAT, I, cor','NGC 2104',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44850,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44850,31.08,0.4,16.4,10974,NULL,NULL,NULL,'NGC 2104',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44851,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44851,31.07,0.4,16.4,10974,73,NULL,'opt','NGC 2104',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44852,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44852,31.15,0.34,17,10974,NULL,NULL,'Malmquist cor.','NGC 2104',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44853,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44853,31.23,0.33,17.6,10974,NULL,NULL,NULL,'NGC 2104',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44854,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44854,31.27,0.2,18,10974,74.4,NULL,NULL,'NGC 2104',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44855,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44855,35.16,0.53,108,10975,70,NULL,NULL,'2MASX J05470635-3236074',NULL,'2014MNRAS.445.2677S',2014,1,0.28,NULL,'G',0.00015,NULL,'15.3R',0.22,NULL,NULL,NULL,NULL,NULL,1,86.7764583,-32.60217,0,NULL,37280538104,582508407,9101693,15.3),(44856,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44856,36.15,0.55,170,10976,70,NULL,NULL,'2MASX J05471353-4645378',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,86.8063333333,-46.76044,0.177,NULL,35703878743,557873105,8716767,14.2),(44857,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44857,33.12,0.43,42.1,10977,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03354',NULL,'2014MNRAS.444..527S',2014,1,2.1,NULL,'G',0.00002,NULL,'14.70',0.6,'Sab:',NULL,NULL,NULL,NULL,1,86.8259166667,56.11236,1.129,NULL,66273450811,1035522668,16180041,14.7),(44858,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44858,33.18,0.45,43.3,10977,NULL,NULL,'K','UGC 03354',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44859,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44859,33.26,0.4,44.9,10977,NULL,NULL,'mean','UGC 03354',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44860,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44860,33.27,0.47,45.1,10977,NULL,NULL,'H','UGC 03354',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44861,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44861,33.36,0.43,47.1,10977,75,NULL,'3.6 micron, color corrected','UGC 03354',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44862,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44862,33.44,0.46,48.7,10977,NULL,NULL,'J','UGC 03354',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44863,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,'R',44863,33.6,0.49,52.4,10977,75,NULL,'IR','UGC 03354',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44864,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44864,33.6,0.2,52.5,10977,74.4,NULL,NULL,'UGC 03354',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44865,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44865,35.79,0.09,144,10978,70,NULL,NULL,'ESO 488- G 015',NULL,'2001MNRAS.321..277C',2001,1,0.7,NULL,'G',0.000063,NULL,'14.72',0.6,'E','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,86.852667,-25.25592,0,NULL,37123971397,580062053,9063469,14.72),(44866,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44866,36.66,0.25,215,10978,74.4,NULL,NULL,'ESO 488- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44867,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44867,35.62,0.25,133,10979,74.4,NULL,NULL,'ESO 488- G 016',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.00004,NULL,'15.1',0.8,'S0','Group member',NULL,NULL,NULL,1,86.8551666667,-25.57197,0,NULL,37123834029,580059906,9063436,15.1),(44868,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44868,35.79,0.09,144,10979,70,NULL,NULL,'ESO 488- G 016',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44869,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44869,35.79,0.09,144,10980,70,NULL,NULL,'ESO 488- G 019',NULL,'2001MNRAS.321..277C',2001,1,0.9,NULL,'G',0.000063,NULL,'14.78',0.7,'E/S0','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,86.860667,-25.247,0,NULL,37123972400,580062068,9063469,14.78),(44870,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44870,36.66,0.25,215,10980,74.4,NULL,NULL,'ESO 488- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44871,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44871,36.31,0.4,182,10980,NULL,NULL,'mean','ESO 488- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44872,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44872,36.61,0.45,210,10980,NULL,NULL,'K','ESO 488- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44873,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44873,35.43,0.48,122,10981,NULL,NULL,NULL,'ESO 488- G 018',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'13.99',0.5,'SB(r)bc','Group member',NULL,NULL,NULL,1,86.8613333333,-25.10539,0.033,NULL,37124647071,580072610,9063634,13.99),(44874,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44874,35.47,0.2,124,10981,74.4,NULL,NULL,'ESO 488- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44875,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44875,35.54,0.45,128,10981,NULL,NULL,'Malmquist cor.','ESO 488- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44876,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44876,35.74,0.54,140,10982,70,NULL,NULL,'2MASX J05473250-2443364',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,86.885375,-24.72672,0,NULL,37124548875,580071076,9063610,14.8),(44877,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44877,35.62,0.25,133,10983,74.4,NULL,NULL,'GIN 268',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000033,NULL,'14.37',NULL,'S0','Group member',NULL,NULL,NULL,1,86.894625,-25.54569,0,NULL,37124030926,580062983,9063484,14.37),(44878,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44878,35.79,0.09,144,10983,70,NULL,NULL,'GIN 268',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44879,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44879,37.03,0.61,254,10984,70,NULL,NULL,'2MASX J05473782-6343136',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,86.9075416667,-63.72053,0.113,NULL,35844332003,560067687,8751057,16.6),(44880,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44880,35.94,0.32,154,10985,NULL,NULL,'Malmquist cor.','ESO 424- G 021',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.47',0.2,'S              HII',NULL,NULL,NULL,NULL,1,86.9086666667,-30.40661,0,NULL,37159135037,580611484,9072054,16.47),(44881,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44881,36.07,0.31,164,10985,NULL,NULL,NULL,'ESO 424- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44882,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44882,36.11,0.2,167,10985,74.4,NULL,NULL,'ESO 424- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44883,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44883,37.15,0.66,269,10986,70,NULL,NULL,'2MASX J05473979-1400417',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,86.915833,-14.01161,0.593,NULL,36663471520,572866742,8951042,17.2),(44884,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44884,35.37,0.48,118,10987,70,NULL,NULL,'MCG -04-14-031',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.000037,NULL,'13.91',0.2,'S0','Group member',NULL,NULL,NULL,1,86.9300417,-25.91561,0.037,NULL,37121714559,580026789,9062918,13.91),(44885,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44885,35.6,0.25,132,10987,74.4,NULL,NULL,'MCG -04-14-031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44886,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44886,35.79,0.09,144,10987,70,NULL,NULL,'MCG -04-14-031',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44887,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44887,35.62,0.25,133,10988,74.4,NULL,NULL,'GIN 271',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.00003,NULL,'14.36',NULL,'Sb','Group member',NULL,NULL,NULL,1,86.948,-25.74569,0.037,NULL,37121727142,580026986,9062921,14.36),(44888,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44888,35.79,0.09,144,10988,70,NULL,NULL,'GIN 271',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44889,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44889,35.38,0.59,119,10989,70,NULL,NULL,'FAIRALL 1302',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'15.7B',0.42,NULL,NULL,NULL,NULL,NULL,1,86.9482917,-84.77633,0.701,NULL,35437916526,553717445,8651835,15.7),(44890,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44890,35.9,0.35,151,10990,NULL,NULL,'Malmquist cor.','IRAS  05457-2534',NULL,'2009ApJS..182..474S',2009,1,0.72,NULL,'G',0.000033,NULL,'14',0.3,'Sb','Group member',NULL,NULL,NULL,1,86.9505,-25.55644,0,NULL,37124025260,580062894,9063482,14),(44891,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44891,35.99,0.33,158,10990,NULL,NULL,NULL,'IRAS  05457-2534',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44892,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44892,36.03,0.2,161,10990,74.4,NULL,NULL,'IRAS  05457-2534',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44893,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44893,35.96,0.7,155,10991,70,NULL,NULL,'2MASX J05474826-2553494',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14',NULL,'SBa','Group member',NULL,NULL,NULL,1,86.9510417,-25.89703,0.037,NULL,37121745957,580027280,9062926,14),(44894,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44894,33.28,0.45,45.3,10992,NULL,NULL,'K','NGC 2089',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.00006,NULL,'12.92',1.1,'SAB0-:',NULL,NULL,NULL,NULL,1,86.9642917,-17.60239,0.297,NULL,36652071155,572688611,8948259,12.92),(44895,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44895,33.29,0.4,45.4,10992,NULL,NULL,'mean','NGC 2089',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44896,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44896,36.53,0.49,202,10993,70,NULL,NULL,'2MASX J05480074-1309034',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,87.003125,-13.15097,0.689,NULL,36663884299,572873192,8951143,16),(44897,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44897,35.52,0.41,127,10994,NULL,NULL,NULL,'ESO 363- G 026',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.53',0.2,'S...',NULL,NULL,NULL,NULL,1,87.0131666667,-33.90867,0,NULL,37282032002,582531750,9102058,16.53),(44898,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44898,35.56,0.2,129,10994,74.4,NULL,NULL,'ESO 363- G 026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44899,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44899,35.71,0.38,139,10994,NULL,NULL,'Malmquist cor.','ESO 363- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44900,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,'R',44900,33.49,0.49,49.9,10995,75,NULL,'IR','2MFGC 04706',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.00003,NULL,'12.3K',0.7,'Sc',NULL,NULL,NULL,NULL,1,87.0339583,46.25572,NULL,NULL,68184286556,1065379477,16646554,12.3),(44901,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44901,37.19,0.51,275,10996,70,NULL,NULL,'ESO 253- G 027',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00014,NULL,'14.88',0.6,'E+3',NULL,NULL,NULL,NULL,1,87.035417,-47.40531,0.245,NULL,35717221091,558081579,8720024,14.88),(44902,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44902,36.15,0.56,170,10997,70,NULL,NULL,'ESO 306- G 027',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15',0.9,'Sa-b',NULL,NULL,NULL,NULL,1,87.0455,-40.64433,0.121,NULL,37057278468,579019976,9047187,15),(44903,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44903,35.87,0.56,149,10998,70,NULL,NULL,'2MASX J05481106-3259331',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,87.046167,-32.99256,0,NULL,37282376191,582537127,9102142,15.9),(44904,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44904,36.1,0.47,166,10999,NULL,NULL,'Malmquist cor.','2MASX J05481961-2538076',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000033,NULL,'14.66',0.32,'Sbc','Group member',NULL,NULL,NULL,1,87.081667,-25.63547,0,NULL,37123885308,580060707,9063448,14.66),(44905,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44905,36.46,0.4,196,10999,NULL,NULL,NULL,'2MASX J05481961-2538076',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44906,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44906,36.5,0.2,200,10999,74.4,NULL,NULL,'2MASX J05481961-2538076',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44907,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44907,36.58,0.69,207,11000,70,NULL,NULL,'2MASX J05481966-4151548',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,87.0820417,-41.86519,0.089,NULL,37060681589,579073149,9048017,15.6),(44908,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44908,35.94,0.65,154,11001,70,NULL,NULL,'2MASX J05482312-2445426',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,87.096333,-24.76181,0.033,NULL,37124462662,580069729,9063589,15),(44909,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44909,35.65,0.47,135,11002,70,NULL,NULL,'ESO 363- G 027',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'14.17',0.9,'E+1:',NULL,NULL,'radio jet',NULL,1,87.115,-32.97722,0,NULL,37282322690,582536292,9102129,14.17),(44910,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44910,35.62,0.25,133,11003,74.4,NULL,NULL,'GIN 276',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000063,NULL,'14.71',NULL,'E','Group member',NULL,NULL,NULL,1,87.1386666667,-25.36469,0,NULL,37124738551,580074039,9063656,14.71),(44911,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44911,35.79,0.09,144,11003,70,NULL,NULL,'GIN 276',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44912,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44912,35.74,0.58,141,11004,70,NULL,NULL,'ESO 363- G 028',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'16',0.8,'SAB(rs)bc',NULL,NULL,NULL,NULL,1,87.1415833333,-32.75408,0,NULL,37282257407,582535271,9102113,16),(44913,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44913,36.85,0.7,235,11005,70,NULL,NULL,'2MASX J05483630-4715477',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,87.15125,-47.26317,0.209,NULL,35703380799,557865324,8716645,17.1),(44914,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44914,36.06,0.53,163,11006,70,NULL,NULL,'2MASX J05483634-3315016',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'14.5R',0.37,NULL,NULL,NULL,NULL,NULL,1,87.151417,-33.25047,0,NULL,37282247128,582535111,9102111,14.5),(44915,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44915,35.61,0.25,132,11007,74.4,NULL,NULL,'ESO 488- G 027',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000063,NULL,'13.99',1.1,'cD;E+1','Group member',NULL,NULL,NULL,1,87.159833,-25.47786,0,NULL,37123879240,580060613,9063447,13.99),(44916,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44916,35.79,0.09,144,11007,70,NULL,NULL,'ESO 488- G 027',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44917,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44917,35.64,0.45,134,11007,NULL,NULL,'K','ESO 488- G 027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44918,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44918,36.21,0.4,175,11007,NULL,NULL,'mean','ESO 488- G 027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44919,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44919,35.8,0.56,145,11008,70,NULL,NULL,'ESO 488- G 028',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.40',0.3,'S03','Group member',NULL,NULL,NULL,1,87.1710833333,-25.759,0,NULL,37121836418,580028694,9062948,15.4),(44920,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44920,35.61,0.25,132,11009,74.4,NULL,NULL,'MCG -04-14-035',NULL,'2013AJ....146...86T',2013,1,0.2,NULL,'G',0.000073,NULL,'13.61',0.2,'SA0:','Group member',NULL,NULL,NULL,1,87.17975,-25.47733,0,NULL,37123879170,580060612,9063447,13.61),(44921,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44921,35.79,0.09,144,11009,70,NULL,NULL,'MCG -04-14-035',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44922,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44922,36.28,0.4,181,11009,NULL,NULL,'mean','MCG -04-14-035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44923,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44923,36.71,0.45,220,11009,NULL,NULL,'K','MCG -04-14-035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44924,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44924,36.68,0.62,217,11010,70,NULL,NULL,'2MASX J05484313-1241011',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.80',NULL,NULL,NULL,NULL,NULL,NULL,1,87.1797917,-12.68389,0.713,NULL,36673219515,573019054,8953422,15.8),(44925,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,'R',44925,34.45,0.42,77.6,11011,NULL,NULL,'B, Hubble-type-TF','ESO 363- G 029',NULL,'2005Ap&SS.298..577R',2005,1,1,NULL,'G',0.000033,NULL,'15.97',0.5,'SB(rs)b:',NULL,NULL,NULL,NULL,1,87.184875,-36.73506,0.041,NULL,37073894357,579279599,9051243,15.97),(44926,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44926,35.57,0.4,130,11011,NULL,NULL,NULL,'ESO 363- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44927,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44927,35.61,0.2,132,11011,74.4,NULL,NULL,'ESO 363- G 029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44928,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44928,35.7,0.38,138,11011,NULL,NULL,'Malmquist cor.','ESO 363- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44929,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44929,36.46,0.54,196,11012,70,NULL,NULL,'ESO 488-IG 029 NED02',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000053,NULL,'14.00',NULL,'SBab','Group member',NULL,NULL,NULL,1,87.185833,-25.55822,0,NULL,37123912983,580061140,9063455,14),(44930,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,'R',44930,33.96,0.34,61.9,11013,NULL,NULL,'B, Hubble-type-TF','ESO 306- G 028',NULL,'2005Ap&SS.298..577R',2005,1,1,NULL,'G',0.000033,NULL,'15.28',0.5,'SB(r)c:',NULL,NULL,NULL,NULL,1,87.1864583,-39.05419,0.129,NULL,37106883808,579795059,9059297,15.28),(44931,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44931,34.96,0.65,98,11013,NULL,NULL,NULL,'ESO 306- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44932,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44932,35,0.2,100,11013,74.4,NULL,NULL,'ESO 306- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44933,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44933,35.12,0.61,105,11013,NULL,NULL,'Malmquist cor.','ESO 306- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44934,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44934,35.19,0.66,109,11014,70,NULL,NULL,'ESO 488- G 030',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'15',0.9,'Sc',NULL,NULL,NULL,NULL,1,87.2022083,-24.37906,0,NULL,37127418940,580115920,9064311,15),(44935,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44935,35.43,0.5,122,11015,70,NULL,NULL,'2MASX J05485618-6912406',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000133,NULL,'15.0b',0.39,NULL,NULL,NULL,NULL,NULL,1,87.234083,-69.21125,0.293,NULL,35504760271,554761879,8668154,15),(44936,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44936,36.65,0.69,214,11016,70,NULL,NULL,'2MFGC 04714',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.3I',0.2,NULL,NULL,NULL,NULL,NULL,1,87.2718333333,-53.85233,0.417,NULL,35752119235,558626863,8728544,14.3),(44937,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44937,35.79,0.09,144,11017,70,NULL,NULL,'GIN 281',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.00007,NULL,'14.41',NULL,'S0','Group member',NULL,NULL,NULL,1,87.3045,-25.61183,0,NULL,37123860621,580060322,9063442,14.41),(44938,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44938,36.66,0.25,215,11017,74.4,NULL,NULL,'GIN 281',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44939,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44939,33.92,0.47,60.8,11018,NULL,NULL,'H','UGC 03360',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000023,NULL,'16.0',0.5,'S?',NULL,NULL,NULL,NULL,1,87.337875,17.84108,NULL,NULL,64505073756,1007891777,15748309,16),(44940,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44940,33.93,0.45,61,11018,NULL,NULL,'K','UGC 03360',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44941,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44941,34.04,0.4,64.2,11018,NULL,NULL,'mean','UGC 03360',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44942,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44942,35.61,0.25,132,11019,74.4,NULL,NULL,'ESO 488- G 033',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.00006,NULL,'14.51',0.8,'E/S0','Group member',NULL,NULL,NULL,1,87.340167,-25.34656,0,NULL,37124726400,580073850,9063653,14.51),(44943,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44943,35.78,0.49,143,11019,70,NULL,NULL,'ESO 488- G 033',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44944,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44944,35.79,0.09,144,11019,70,NULL,NULL,'ESO 488- G 033',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44945,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44945,35.99,0.4,158,11019,NULL,NULL,'mean','ESO 488- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44946,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44946,36.02,0.45,160,11019,NULL,NULL,'K','ESO 488- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44947,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44947,36.45,0.58,195,11020,70,NULL,NULL,'2MASX J05492678-2330121',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,87.361625,-23.50344,0.013,NULL,37126025658,580094150,9063971,15.3),(44948,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44948,35.64,0.58,134,11021,70,NULL,NULL,'2MASX J05492793-3017357',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,87.3665,-30.29333,0.005,NULL,37161093419,580642084,9072532,15.7),(44949,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44949,36.62,0.62,211,11022,70,NULL,NULL,'2MASX J05493044-2538036',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000083,NULL,'15',0.2,'S0','Group member',NULL,NULL,NULL,1,87.37675,-25.63433,0,NULL,37123864058,580060375,9063443,15),(44950,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44950,33.92,0.47,60.8,11023,NULL,NULL,'H','UGC 03362',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00002,NULL,'16.0',0.4,'S',NULL,NULL,NULL,NULL,1,87.381125,17.64917,NULL,NULL,64504287074,1007879485,15748116,16),(44951,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44951,33.94,0.45,61.3,11023,NULL,NULL,'K','UGC 03362',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44952,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44952,33.99,0.46,62.8,11023,NULL,NULL,'J','UGC 03362',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44953,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44953,34.01,0.4,63.4,11023,NULL,NULL,'mean','UGC 03362',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44954,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44954,34.63,0.69,84.4,11024,100,NULL,'mid-IR','ESO 555- G 001',NULL,'2013ApJ...771...88L',2013,1,1.2,NULL,'G',0.000023,NULL,'14.50',0.7,'SA(r)b',NULL,NULL,NULL,NULL,1,87.382375,-19.55033,0.229,NULL,36655168707,572737011,8949015,14.5),(44955,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44955,35.36,0.47,118,11024,NULL,NULL,'H','ESO 555- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44956,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44956,35.37,0.4,118,11024,NULL,NULL,'mean','ESO 555- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44957,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44957,35.43,0.45,122,11024,NULL,NULL,'K','ESO 555- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44958,'Tully-Fisher','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44958,35.49,0.46,126,11024,NULL,NULL,'J','ESO 555- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44959,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44959,36.43,0.65,194,11025,70,NULL,NULL,'6dF J0549332-251129',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,87.3885,-25.19136,0,NULL,37124613616,580072087,9063626,15.3),(44960,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44960,36.19,0.73,173,11026,70,NULL,NULL,'6dF J0549345-250432',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,87.3938333333,-25.07561,0,NULL,37124633158,580072393,9063631,15.6),(44961,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44961,36.59,0.59,208,11027,70,NULL,NULL,'2MASX J05493642-6707477',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.0b',0.4,NULL,NULL,NULL,NULL,NULL,1,87.401583,-67.12986,0.233,NULL,35836910541,559951727,8749245,16),(44962,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44962,36.63,0.52,212,11028,70,NULL,NULL,'2MASX J05494164-2432420',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000097,NULL,'15.7',0.4,'BrClG','Brightest group member',NULL,NULL,NULL,1,87.423583,-24.545,0,NULL,37127391056,580115485,9064304,15.7),(44963,'FP','2016-12-15 15:14:12','2016-12-16 11:19:18','1',NULL,NULL,44963,36.51,0.51,201,11029,70,NULL,NULL,'2MASX J05494747-3317084',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.2,NULL,NULL,NULL,NULL,NULL,1,87.4476666667,-33.28572,0,NULL,37283089467,582548272,9102316,14.3),(44964,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44964,35.32,0.55,116,11030,70,NULL,NULL,'2MASX J05494763-5049455',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,87.4485417,-50.82933,0.125,NULL,35760303318,558754739,8730542,15.4),(44965,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44965,36.47,0.57,197,11031,70,NULL,NULL,'2MASX J05495328-3113044',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,87.471917,-31.21794,0.045,NULL,37158787011,580606047,9071969,14.4),(44966,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44966,36.06,0.55,163,11032,70,NULL,NULL,'ESO 488- G 037',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000083,NULL,'15.38',0.8,'(R)SA0^+?',NULL,NULL,NULL,NULL,1,87.4755,-24.38889,0,NULL,37127332403,580114568,9064290,15.38),(44967,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',44967,34.84,0.49,93.1,11033,75,NULL,'IR','UGC 03359',NULL,'2011yCatp016004901K',2011,1,1.65,NULL,'G',NULL,NULL,'15.2',0.18,'SBcd:',NULL,NULL,NULL,NULL,1,87.493917,51.09306,1.113,NULL,66097658186,1032775909,16137123,15.2),(44968,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44968,35.04,0.47,102,11033,NULL,NULL,'H','UGC 03359',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44969,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44969,35.11,0.45,105,11033,NULL,NULL,'K','UGC 03359',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44970,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44970,35.2,0.4,109,11033,NULL,NULL,'mean','UGC 03359',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44971,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44971,35.23,NULL,111,11033,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03359',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44972,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44972,35.24,NULL,112,11033,NULL,NULL,'Dipole + Quadrupole','UGC 03359',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44973,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44973,35.24,NULL,112,11033,NULL,NULL,'Dipole','UGC 03359',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44974,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44974,35.28,0.46,114,11033,NULL,NULL,'J','UGC 03359',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44975,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44975,35.28,NULL,114,11033,NULL,NULL,NULL,'UGC 03359',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44976,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44976,36.37,0.54,188,11034,70,NULL,NULL,'2MASX J05495891-2539310',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15',NULL,'S0','Group member',NULL,NULL,NULL,1,87.4954583,-25.65872,0,NULL,37122277383,580035584,9063056,15),(44977,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44977,35.6,0.25,132,11035,74.4,NULL,NULL,'GIN 277',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000057,NULL,'14.01',NULL,'E','Group member',NULL,NULL,NULL,1,87.4967083,-25.73914,0,NULL,37122540566,580039696,9063120,14.01),(44978,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44978,35.79,0.09,144,11035,70,NULL,NULL,'GIN 277',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44979,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44979,36.1,0.51,166,11035,70,NULL,NULL,'GIN 277',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44980,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44980,35.6,0.25,132,11036,74.4,NULL,NULL,'GIN 278',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000057,NULL,'14.16',NULL,'S0','Group member',NULL,NULL,NULL,1,87.5109583333,-25.77089,0,NULL,37122546530,580039789,9063121,14.16),(44981,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44981,35.79,0.09,144,11036,70,NULL,NULL,'GIN 278',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44982,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44982,35.38,0.53,119,11037,70,NULL,NULL,'ESO 488- G 038',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000087,NULL,'14.95',0.7,'SB(r)0/a',NULL,NULL,NULL,NULL,1,87.51525,-24.63708,0,NULL,37127749930,580121092,9064392,14.95),(44983,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44983,34.57,0.47,81.9,11038,NULL,NULL,'H','MCG +02-15-002',NULL,'2007A&A...465...71T',2007,1,0.8,NULL,'G',0.000013,NULL,'15',0.2,'S',NULL,NULL,NULL,NULL,1,87.521625,13.62656,NULL,NULL,64538790120,1008418595,15756540,15),(44984,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44984,34.62,0.45,84.1,11038,NULL,NULL,'K','MCG +02-15-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44985,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44985,34.73,0.46,88.3,11038,NULL,NULL,'J','MCG +02-15-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44986,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44986,34.93,0.4,97,11038,NULL,NULL,'mean','MCG +02-15-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44987,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44987,35.55,0.59,129,11039,70,NULL,NULL,'ESO 488- G 039',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.51',0.8,'S0',NULL,NULL,NULL,NULL,1,87.5747917,-23.80969,0.005,NULL,37126502108,580101595,9064087,15.51),(44988,'IRAS','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44988,32.57,0.8,32.7,11040,75,NULL,'MAT, I','ESO 555- G 002',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.00001,NULL,'14.43',0.3,'Sbc: sp',NULL,NULL,NULL,NULL,1,87.6112083,-19.72589,0.209,NULL,36655138236,572736534,8949008,14.43),(44989,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44989,32.51,0.4,31.8,11040,73,NULL,'opt','ESO 555- G 002',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44990,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',44990,32.52,0.4,31.9,11040,75,NULL,NULL,'ESO 555- G 002',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44991,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44991,32.52,0.4,31.9,11040,73,NULL,'IR','ESO 555- G 002',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44992,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44992,32.59,0.4,33,11040,73,NULL,'opt','ESO 555- G 002',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44993,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44993,32.84,0.32,37,11040,85,NULL,'I, raw','ESO 555- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44994,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44994,32.84,0.43,37.1,11040,75,NULL,'MAT, I, raw','ESO 555- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44995,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44995,32.86,0.32,37.4,11040,85,NULL,'I, inv','ESO 555- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44996,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44996,32.89,0.43,37.8,11040,75,NULL,'3.6 micron, color + selection bias corrected','ESO 555- G 002',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44997,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44997,32.98,0.43,39.5,11040,75,NULL,'MAT, I, inv','ESO 555- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44998,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44998,33,0.43,39.9,11040,75,NULL,'MAT, I, cor','ESO 555- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44999,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,44999,33.07,0.43,41.1,11040,75,NULL,'3.6 micron, color corrected','ESO 555- G 002',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45000,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',45000,33.17,0.49,43.1,11040,75,NULL,'IR','ESO 555- G 002',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45001,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45001,33.24,0.2,44.5,11040,74.4,NULL,NULL,'ESO 555- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45002,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45002,33.24,0.4,44.5,11040,NULL,NULL,'Malmquist cor.','ESO 555- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45003,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45003,33.39,0.37,47.7,11040,NULL,NULL,NULL,'ESO 555- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45004,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45004,33.67,NULL,54.1,11040,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 555- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45005,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45005,33.67,NULL,54.2,11040,NULL,NULL,'Dipole + Quadrupole','ESO 555- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45006,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45006,33.68,NULL,54.4,11040,NULL,NULL,'Dipole','ESO 555- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45007,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45007,35.39,0.61,120,11041,70,NULL,NULL,'2MASX J05503410-5314332',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.9b',0.4,NULL,NULL,NULL,NULL,NULL,1,87.6421666667,-53.2425,0.349,NULL,35750474062,558601157,8728143,15.9),(45008,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45008,35.97,0.67,156,11042,70,NULL,NULL,'2MASX J05503653-2621427',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,87.6522083,-26.36197,0,NULL,37122092850,580032700,9063010,15.4),(45009,'BL Lac Luminosity','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45009,37.52,NULL,299,11043,NULL,NULL,NULL,'[HB89] 0548-322',0.069,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',NULL,NULL,'15.5',NULL,'Opt.var.       BLLAC',NULL,NULL,'radio jet','USS',1,87.669,-32.27142,0.017,NULL,37280648441,582510131,9101720,15.5),(45010,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45010,35.12,0.49,106,11044,70,NULL,NULL,'ESO 364- G 003',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000123,NULL,'15.57',0.2,'S0',NULL,NULL,NULL,NULL,1,87.677125,-34.89533,0,NULL,37062378511,579099664,9048432,15.57),(45011,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45011,35.1,0.52,105,11045,70,NULL,NULL,'2MASX J05505423-3147206',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,87.7260417,-31.78903,0,NULL,37147860721,580435323,9069301,14.1),(45012,'Tully est','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45012,30.15,0.8,10.7,11046,75,NULL,NULL,'UGCA 114',NULL,'1988NBGC.C....0000T',1988,1,3,NULL,'G',0.000003,NULL,'13',2.2,'SB(s)d',NULL,NULL,NULL,NULL,1,87.7264583,-14.77908,0.509,NULL,36668771072,572949548,8952336,13),(45013,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45013,31.31,0.4,18.3,11046,NULL,NULL,'mean','UGCA 114',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45014,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45014,31.59,0.47,20.8,11046,NULL,NULL,'H','UGCA 114',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45015,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45015,31.64,0.46,21.3,11046,NULL,NULL,'J','UGCA 114',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45016,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45016,31.7,0.45,21.8,11046,NULL,NULL,'K','UGCA 114',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45017,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45017,36.73,0.78,222,11047,70,NULL,NULL,'2MASX J05505572-5530412',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,87.732083,-55.51144,0.353,NULL,35739139919,558424061,8725375,17),(45018,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45018,35.33,0.47,116,11048,70,NULL,NULL,'MCG -06-13-011',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000123,NULL,'15',0.5,NULL,NULL,NULL,NULL,NULL,1,87.733375,-34.78403,0,NULL,37062741623,579105337,9048520,15),(45019,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45019,36.48,0.56,197,11049,70,NULL,NULL,'2MFGC 04733',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,87.7364583,-23.9685,0.045,NULL,37126662380,580104099,9064126,14.9),(45020,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45020,36.44,0.57,194,11050,70,NULL,NULL,'2MASX J05505951-2525018',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,87.7480417,-25.41719,0,NULL,37124304039,580067250,9063550,14.6),(45021,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45021,36.58,0.63,207,11051,70,NULL,NULL,'ESO 205-IG 004 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.79',0.4,NULL,NULL,NULL,NULL,NULL,1,87.754583,-50.08928,0.149,NULL,35713768484,558027632,8719181,16.79),(45022,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45022,34.96,0.47,98.2,11052,70,NULL,NULL,'2MASX J05510793-6309516',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000097,NULL,'15.6b',0.5,NULL,NULL,NULL,NULL,NULL,1,87.783,-63.16433,0.125,NULL,35844187849,560065435,8751022,15.6),(45023,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45023,36.05,0.53,162,11053,70,NULL,NULL,'2MASX J05510948-5102442',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,87.7894583,-51.04569,0.189,NULL,35757108999,558704828,8729762,14),(45024,'IRAS','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45024,33.89,0.8,59.9,11054,75,NULL,'MAT, I','ESO 160- G 002',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'13.85',0.4,'Sb? sp',NULL,NULL,NULL,NULL,1,87.812083,-53.57481,0.413,NULL,35750507168,558601674,8728151,13.85),(45025,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45025,33.18,0.43,43.2,11054,75,NULL,'MAT, I, raw','ESO 160- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45026,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45026,33.22,0.47,44,11054,NULL,NULL,'H','ESO 160- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45027,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45027,33.25,0.45,44.7,11054,NULL,NULL,'K','ESO 160- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45028,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45028,33.3,0.32,45.7,11054,85,NULL,'I, raw','ESO 160- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45029,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45029,33.3,0.46,45.8,11054,NULL,NULL,'J','ESO 160- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45030,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45030,33.35,0.32,46.8,11054,85,NULL,'I, inv','ESO 160- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45031,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45031,33.4,0.43,48,11054,75,NULL,'MAT, I, inv','ESO 160- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45032,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',45032,33.51,0.49,50.3,11054,75,NULL,'IR','ESO 160- G 002',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45033,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45033,33.55,0.43,51.3,11054,75,NULL,'MAT, I, cor','ESO 160- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45034,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45034,33.73,0.4,55.8,11054,NULL,NULL,'mean','ESO 160- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45035,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45035,34.15,0.45,67.5,11054,NULL,NULL,'Malmquist cor.','ESO 160- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45036,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45036,34.46,0.39,77.8,11054,NULL,NULL,NULL,'ESO 160- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45037,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45037,34.5,0.2,79.4,11054,74.4,NULL,NULL,'ESO 160- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45038,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45038,35.34,0.49,117,11055,70,NULL,NULL,'AM 0549-345 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15',0.5,NULL,NULL,NULL,NULL,NULL,1,87.813125,-34.88856,0,NULL,37062269128,579097955,9048405,15),(45039,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45039,35.75,0.49,141,11056,70,NULL,NULL,'AM 0549-345 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000087,NULL,'15',0.7,NULL,NULL,NULL,NULL,NULL,1,87.817333,-34.90122,0,NULL,37062387535,579099805,9048434,15),(45040,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45040,35.64,0.67,134,11057,70,NULL,NULL,'2MASX J05511690-3149217',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,87.8205,-31.82264,0.041,NULL,37147684763,580432574,9069258,14.8),(45041,'IRAS','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45041,33.18,0.8,43.2,11058,75,NULL,'MAT, I','IC 2150',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.000017,NULL,'13.58',0.8,'SB(r:)bc:',NULL,NULL,NULL,NULL,1,87.827333,-38.32047,0.089,NULL,37106541509,579789711,9059214,13.58),(45042,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45042,32.81,0.32,36.4,11058,85,NULL,'I, raw','IC 2150',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45043,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45043,32.85,0.32,37.1,11058,85,NULL,'I, inv','IC 2150',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45044,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45044,32.87,0.43,37.5,11058,75,NULL,'MAT, I, raw','IC 2150',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45045,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45045,33.06,0.4,41,11058,73,NULL,'opt','IC 2150',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45046,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45046,33.07,0.43,41.1,11058,75,NULL,'MAT, I, inv','IC 2150',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45047,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45047,33.07,0.43,41.1,11058,75,NULL,'3.6 micron, color corrected','IC 2150',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45048,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45048,33.07,0.2,41.1,11058,74.4,NULL,NULL,'IC 2150',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45049,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45049,33.17,0.43,43.1,11058,75,NULL,'MAT, I, cor','IC 2150',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45050,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45050,33.24,0.43,44.4,11058,75,NULL,'3.6 micron, color + selection bias corrected','IC 2150',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45051,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45051,33.28,0.46,45.4,11058,NULL,NULL,'J','IC 2150',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45052,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45052,33.31,0.4,45.9,11058,NULL,NULL,'mean','IC 2150',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45053,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45053,33.38,0.47,47.5,11058,NULL,NULL,'H','IC 2150',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45054,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45054,33.4,0.48,47.9,11058,NULL,NULL,NULL,'IC 2150',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45055,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45055,33.4,0.45,48,11058,NULL,NULL,'K','IC 2150',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45056,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45056,33.54,0.45,51.1,11058,NULL,NULL,'Malmquist cor.','IC 2150',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45057,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45057,36.71,0.62,219,11059,70,NULL,NULL,'2MASX J05512224-2319507',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,87.8427917,-23.33081,0.021,NULL,37113260085,579894688,9060854,15.3),(45058,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45058,34.33,0.2,73.5,11060,74.4,NULL,NULL,'UGC 03366',NULL,'2013AJ....146...86T',2013,1,1.3,'UGC declination is +12 arcminutes in error.','G',0.00003,NULL,'16.5:',1,'Sc',NULL,NULL,NULL,NULL,1,87.86225,48.63825,1.337,NULL,66050115727,1032033058,16125516,16.5),(45059,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45059,36.72,0.65,221,11061,70,NULL,NULL,'2MASX J05512813-3755475',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,87.867125,-37.92992,0.109,NULL,37071856104,579247751,9050746,14.8),(45060,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45060,36.36,0.71,187,11062,70,NULL,NULL,'2MASX J05513376-3428290',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.4,NULL,NULL,NULL,NULL,NULL,1,87.890625,-34.47472,0,NULL,37062617859,579103404,9048490,14.3),(45061,'IRAS','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45061,33.46,0.8,49.1,11063,75,NULL,'MAT, I','ESO 120- G 016',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000033,NULL,'14.53',0.4,'Sb',NULL,NULL,NULL,NULL,1,87.896875,-59.04564,0.229,NULL,35866978789,560421543,8756586,14.53),(45062,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45062,32.98,0.43,39.4,11063,75,NULL,'MAT, I, raw','ESO 120- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45063,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45063,33.01,0.45,40.1,11063,NULL,NULL,'K','ESO 120- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45064,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45064,33.07,0.32,41.2,11063,85,NULL,'I, raw','ESO 120- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45065,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45065,33.08,0.47,41.3,11063,NULL,NULL,'H','ESO 120- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45066,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45066,33.11,0.32,41.9,11063,85,NULL,'I, inv','ESO 120- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45067,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45067,33.15,0.43,42.7,11063,75,NULL,'MAT, I, inv','ESO 120- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45068,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45068,33.25,0.46,44.6,11063,NULL,NULL,'J','ESO 120- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45069,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45069,33.32,0.43,46.2,11063,75,NULL,'MAT, I, cor','ESO 120- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45070,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',45070,33.37,0.49,47.2,11063,75,NULL,'IR','ESO 120- G 016',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45071,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45071,33.4,0.4,47.8,11063,NULL,NULL,'mean','ESO 120- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45072,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45072,33.55,0.39,51.2,11063,NULL,NULL,NULL,'ESO 120- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45073,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45073,33.59,0.2,52.2,11063,74.4,NULL,NULL,'ESO 120- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45074,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45074,33.68,0.37,54.4,11063,NULL,NULL,'Malmquist cor.','ESO 120- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45075,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',45075,33.97,0.49,62.2,11064,75,NULL,'IR','UGC 03368',NULL,'2011yCatp016004901K',2011,1,1.3,'abs(b) < 10 degrees.','G',0.000013,NULL,'17.',0.3,'Scd:',NULL,NULL,NULL,NULL,1,87.90075,39.82964,NULL,NULL,64703753456,1010996147,15796814,17),(45076,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45076,34.08,0.2,65.5,11064,74.4,NULL,NULL,'UGC 03368',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45077,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45077,36.27,0.6,179,11065,70,NULL,NULL,'2MASX J05513980-3136340',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.7I',0.3,NULL,NULL,NULL,NULL,NULL,1,87.9159583333,-31.60947,0.041,NULL,37147555601,580430556,9069227,14.7),(45078,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45078,35.56,0.48,130,11066,70,NULL,NULL,'MCG -05-14-022',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00009,NULL,'15',0.3,NULL,NULL,NULL,NULL,NULL,1,87.91675,-31.52308,0.041,NULL,37147580188,580430940,9069233,15),(45079,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45079,37.24,0.67,280,11067,70,NULL,NULL,'2MASX J05514499-3421120',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,87.9375833333,-34.35342,0,NULL,37062666412,579104162,9048502,15.8),(45080,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45080,34.68,0.71,86.4,11068,70,NULL,NULL,'ESO 424- G 032',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000113,NULL,'15.23',0.4,'Sb',NULL,NULL,NULL,NULL,1,87.9580417,-31.74614,0.041,NULL,37147697552,580432774,9069262,15.23),(45081,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45081,35.09,0.48,104,11069,70,NULL,NULL,'ESO 424- G 033',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000127,NULL,'15.07',0.4,'S0-a',NULL,NULL,NULL,NULL,1,87.9836666667,-31.20906,0.025,NULL,37158686894,580604482,9071945,15.07),(45082,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45082,36.61,0.57,210,11070,70,NULL,NULL,'2MFGC 04743',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'14.0I',0.3,NULL,NULL,NULL,NULL,NULL,1,87.9902083,-40.251,0.137,NULL,37049997626,578906212,9045409,14),(45083,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45083,37.37,0.72,297,11071,70,NULL,NULL,'2MASX J05520354-2551465',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,88.01475,-25.86297,0,NULL,37122413802,580037715,9063089,15),(45084,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',45084,33.14,0.49,42.5,11072,75,NULL,'IR','2MFGC 04746',NULL,'2011yCatp016004901K',2011,1,0.89,NULL,'G',0.00001,NULL,'14.83',0.22,'SBb',NULL,NULL,NULL,NULL,1,88.032375,16.19867,NULL,NULL,64550188343,1008596692,15759323,14.83),(45085,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45085,33.97,0.4,62.3,11072,NULL,NULL,'mean','2MFGC 04746',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45086,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45086,34.08,0.47,65.5,11072,NULL,NULL,'H','2MFGC 04746',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45087,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45087,35.24,0.71,112,11073,70,NULL,NULL,'ESO 424- G 034',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.55',0.5,'SB?(r)0/a',NULL,NULL,NULL,NULL,1,88.035167,-30.45094,0.069,NULL,37161413039,580647078,9072610,15.55),(45088,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45088,32.68,0.4,34.3,11074,NULL,NULL,'mean','NGC 2110',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000067,NULL,'13.4b',1.3,'SAB0-          Sy2',NULL,NULL,'radio jet','Sy 1 i',1,88.0474166667,-7.45622,1.449,NULL,36557539039,571211547,8925180,13.4),(45089,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45089,32.84,0.45,36.9,11074,NULL,NULL,'K','NGC 2110',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45090,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45090,35.35,0.72,118,11075,70,NULL,NULL,'ESO 364- G 007',NULL,'2014MNRAS.445.2677S',2014,1,1.3,'6dF DR2 has z = 0.032585.','G',0.00015,NULL,'14.11',1.1,'SB(r)c: pec',NULL,NULL,NULL,NULL,1,88.07925,-34.34767,0.045,NULL,37062657762,579104027,9048500,14.11),(45091,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45091,35.95,0.71,155,11076,70,NULL,NULL,'2MASX J05522136-2211040',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.80',0.3,NULL,NULL,NULL,NULL,NULL,1,88.0887917,-22.18436,0.061,NULL,37383301127,584114080,9126782,16.8),(45092,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45092,36.5,0.73,200,11077,70,NULL,NULL,'2MASX J05522138-5200264',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.6I',0.2,NULL,NULL,NULL,NULL,NULL,1,88.089083,-52.00742,0.225,NULL,35743538972,558492796,8726449,14.6),(45093,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45093,36.23,0.79,176,11078,70,NULL,NULL,'AM 0550-342 NED02',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,88.0905833333,-34.34647,0.045,NULL,37062478101,579101220,9048456,15.2),(45094,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',45094,35.03,0.49,102,11079,75,NULL,'IR','ESO 424- G 035',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'16.50',0.3,'S...',NULL,NULL,NULL,NULL,1,88.1202917,-28.37047,0,NULL,37168098882,580751545,9074242,16.5),(45095,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45095,35.12,0.51,106,11079,NULL,NULL,NULL,'ESO 424- G 035',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45096,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45096,35.16,0.2,108,11079,74.4,NULL,NULL,'ESO 424- G 035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45097,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45097,35.3,0.47,115,11079,NULL,NULL,'Malmquist cor.','ESO 424- G 035',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45098,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',45098,33.97,0.24,62.2,11080,NULL,NULL,'B, Hubble-type-TF','ESO 364- G 008',NULL,'2005Ap&SS.298..577R',2005,1,1.1,NULL,'G',0.000033,NULL,'14.8b',0.8,'Sc',NULL,NULL,NULL,NULL,1,88.136125,-36.96386,0.077,NULL,37072419290,579256551,9050883,14.8),(45099,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45099,34.72,0.54,87.9,11080,NULL,NULL,NULL,'ESO 364- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45100,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45100,34.76,0.2,89.5,11080,74.4,NULL,NULL,'ESO 364- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45101,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45101,34.77,0.53,89.9,11080,NULL,NULL,'Malmquist cor.','ESO 364- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45102,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45102,36.42,0.66,192,11081,70,NULL,NULL,'2MASX J05523351-4613055',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,88.1396666667,-46.21817,0.141,NULL,35705628008,557900437,8717194,16.3),(45103,'SNIa','2016-12-15 15:14:13','2016-12-16 11:19:18','1','SN 2006ke',NULL,45103,34.67,0.1,85.9,11082,74.4,NULL,NULL,'UGC 03365',NULL,'2013AJ....146...86T',2013,1,2.2,NULL,'G',0.000037,NULL,'13.4B',0.3,'Sa:',NULL,NULL,NULL,NULL,1,88.1478333333,66.81986,0.461,NULL,66103026247,1032859785,16138434,13.4),(45104,'SNIa','2016-12-15 15:14:13','2016-12-16 11:19:18','1','SN 2006ke',NULL,45104,34.98,0.22,97.5,11082,65,NULL,'MLCS17','UGC 03365',0.017182,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45105,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',45105,33.99,0.49,62.9,11082,75,NULL,'IR','UGC 03365',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45106,'IRAS','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45106,33.17,0.8,43.1,11083,75,NULL,'MAT, I','IC 2151',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.13',0.9,'(R\':)SB(s)c',NULL,NULL,NULL,NULL,1,88.1517917,-17.78728,0.229,NULL,36647148040,572611688,8947057,14.13),(45107,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45107,31.58,0.32,20.7,11083,85,NULL,'I, inv','IC 2151',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45108,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45108,31.6,0.32,20.9,11083,85,NULL,'I, raw','IC 2151',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45109,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45109,32.08,0.43,26.1,11083,75,NULL,'MAT, I, inv','IC 2151',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45110,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45110,32.09,0.43,26.1,11083,75,NULL,'MAT, I, raw','IC 2151',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45111,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45111,32.37,0.4,29.8,11083,73,NULL,'opt','IC 2151',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45112,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45112,32.39,0.73,30.1,11083,NULL,NULL,NULL,'IC 2151',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45113,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45113,32.43,0.2,30.6,11083,74.4,NULL,NULL,'IC 2151',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45114,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45114,32.44,0.43,30.8,11083,75,NULL,'MAT, I, cor','IC 2151',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45115,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45115,32.71,0.63,34.9,11083,NULL,NULL,'Malmquist cor.','IC 2151',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45116,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45116,35.45,0.52,123,11084,70,NULL,NULL,'2MASX J05524247-3041389',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'13.3I',0.6,NULL,NULL,NULL,NULL,NULL,1,88.1769583,-30.69414,0.121,NULL,37160588799,580634199,9072409,13.3),(45117,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45117,36.9,0.54,240,11085,70,NULL,NULL,'2MASX J05524297-2229463',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.3,NULL,NULL,NULL,NULL,NULL,1,88.1790417,-22.49617,0.053,NULL,37383100857,584110950,9126733,14),(45118,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45118,36.48,0.63,198,11086,70,NULL,NULL,'2MASX J05524308-4013422',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,88.179625,-40.22847,0.121,NULL,37052087339,578938864,9045919,14.1),(45119,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45119,35.61,0.36,132,11087,NULL,NULL,NULL,'ESO 364- G 009',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.92',0.2,'S...',NULL,NULL,NULL,NULL,1,88.225417,-34.72694,0,NULL,37064607302,579134489,9048976,15.92),(45120,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45120,35.65,0.2,135,11087,74.4,NULL,NULL,'ESO 364- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45121,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45121,35.76,0.33,142,11087,NULL,NULL,'Malmquist cor.','ESO 364- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45122,'IRAS','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45122,33.18,0.8,43.2,11088,75,NULL,'MAT, I','IC 0438',NULL,'1997ApJS..109..333W',1997,1,2.8,'This pair is made up of IC 0438 and IC 2151.','G',0.000019,NULL,'12.74',2.1,'SA(rs)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,88.250333,-17.87608,0.221,NULL,36647206152,572612596,8947071,12.74),(45123,'Tully est','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45123,32.95,0.8,39,11088,75,NULL,NULL,'IC 0438',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45124,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45124,32.79,0.43,36.2,11088,75,NULL,'MAT, I, raw','IC 0438',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45125,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45125,32.82,0.4,36.6,11088,NULL,NULL,NULL,'IC 0438',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45126,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45126,32.82,0.32,36.7,11088,85,NULL,'I, raw','IC 0438',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45127,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45127,32.88,0.32,37.6,11088,85,NULL,'I, inv','IC 0438',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45128,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45128,32.96,0.43,39.1,11088,75,NULL,'3.6 micron, color corrected','IC 0438',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45129,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45129,32.97,0.43,39.2,11088,75,NULL,'MAT, I, cor','IC 0438',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45130,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45130,32.97,0.43,39.2,11088,75,NULL,'3.6 micron, color + selection bias corrected','IC 0438',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45131,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45131,33.02,0.43,40.2,11088,75,NULL,'MAT, I, inv','IC 0438',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45132,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45132,33.05,0.2,40.7,11088,74.4,NULL,NULL,'IC 0438',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45133,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45133,33.16,0.32,42.9,11088,NULL,NULL,'Malmquist cor.','IC 0438',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45134,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45134,33.27,0.3,45.2,11088,NULL,NULL,NULL,'IC 0438',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45135,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45135,33.43,0.4,48.6,11088,NULL,NULL,'mean','IC 0438',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45136,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45136,33.57,0.47,51.7,11088,NULL,NULL,'H','IC 0438',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45137,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45137,33.58,0.46,51.9,11088,NULL,NULL,'J','IC 0438',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45138,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45138,33.6,0.45,52.5,11088,NULL,NULL,'K','IC 0438',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45139,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45139,35.49,0.52,125,11089,70,NULL,NULL,'2MASX J05530538-3423379',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,88.272333,-34.39381,0.045,NULL,37064782916,579137233,9049019,14.3),(45140,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45140,35.87,0.49,149,11090,70,NULL,NULL,'2MASX J05530667-3425469',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00009,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,88.2778333333,-34.42975,0.005,NULL,37064784602,579137259,9049019,14),(45141,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45141,36.25,0.78,178,11091,70,NULL,NULL,'2MASX J05530807-3940512',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,88.283667,-39.68092,0.125,NULL,37048602996,578884421,9045069,15.2),(45142,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45142,35.89,0.61,151,11092,70,NULL,NULL,'2MASX J05530876-3428179',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,88.2865416667,-34.47167,0.005,NULL,37064775781,579137121,9049017,15.3),(45143,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45143,37.19,0.8,274,11093,70,NULL,NULL,'2MASX J05530942-1405157',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.9I',0.3,NULL,NULL,NULL,NULL,NULL,1,88.28925,-14.08767,0.977,NULL,36671102503,572985976,8952905,14.9),(45144,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45144,36.11,0.55,167,11094,70,NULL,NULL,'2MASX J05531395-1342130',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.81',0.3,NULL,NULL,NULL,NULL,NULL,1,88.308375,-13.70386,0.877,NULL,36674718902,573042482,8953788,15.81),(45145,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45145,36.11,0.55,167,11095,70,NULL,NULL,'2MASX J05531636-6942564',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'15.9b',0.32,NULL,NULL,NULL,NULL,NULL,1,88.31825,-69.71572,0.309,NULL,35503524973,554742577,8667852,15.9),(45146,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45146,35.56,0.54,129,11096,70,NULL,NULL,'2MASX J05532540-1404160',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.4,NULL,NULL,NULL,NULL,NULL,1,88.355917,-14.07117,0.977,NULL,36671073085,572985516,8952898,13.9),(45147,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45147,34.69,0.5,86.5,11097,NULL,NULL,NULL,'ESO 555- G 011',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.5',0.8,'Sb',NULL,NULL,NULL,NULL,1,88.3877917,-20.2675,0.121,NULL,36644252465,572566444,8946350,15.5),(45148,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45148,34.73,0.2,88.3,11097,74.4,NULL,NULL,'ESO 555- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45149,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45149,34.82,0.47,91.9,11097,NULL,NULL,'Malmquist cor.','ESO 555- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45150,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45150,36.23,0.64,176,11098,70,NULL,NULL,'2MASX J05534682-1333311',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,88.4452083,-13.55864,0.877,NULL,36674591968,573040499,8953757,17.4),(45151,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45151,36.54,0.84,203,11099,70,NULL,NULL,'2MASX J05534687-3435520',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,88.445333,-34.59781,0.005,NULL,37064628905,579134826,9048981,15.3),(45152,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45152,34.4,0.49,75.9,11100,70,NULL,NULL,'ESO 364- G 011',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000143,NULL,'14.78',0.6,'(RL)SA0^+','Pair member (points to parent)',NULL,NULL,NULL,1,88.4550417,-32.77364,0.121,NULL,37279273610,582488650,9101385,14.78),(45153,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45153,36.21,0.59,175,11101,70,NULL,NULL,'2MASX J05535098-2207355',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,88.4625,-22.12658,0.097,NULL,37380298484,584067163,9126049,15),(45154,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45154,36.79,0.56,228,11102,70,NULL,NULL,'ESO 254- G 003',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.42',0.5,'S(r)...',NULL,NULL,NULL,NULL,1,88.48625,-46.47789,0.173,NULL,35705879594,557904368,8717255,16.42),(45155,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45155,35.02,0.55,101,11103,70,NULL,NULL,'2MASX J05541275-3810300',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,88.5530416667,-38.17497,0.077,NULL,37072765094,579261954,9050968,14.6),(45156,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45156,36.41,0.58,191,11104,70,NULL,NULL,'2MASX J05541393-4848356',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.9I',0.2,NULL,NULL,NULL,NULL,NULL,1,88.558083,-48.80989,0.257,NULL,35711820661,557997197,8718706,13.9),(45157,'GRB','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45157,37.99,NULL,396,11105,65,NULL,'L = 10e57 photons/s','GRB 790418',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,88.586125,-6.97247,1.409,NULL,36548118727,571064355,8922880,NULL),(45158,'GRB','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45158,38.58,NULL,521,11105,75,NULL,NULL,'GRB 790418',NULL,'1995ApJ...453..583W',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45159,'GRB','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45159,40.96,NULL,1550,11105,65,NULL,'L = 2 x 10e58 photons/s','GRB 790418',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45160,'GRB','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',45160,41.61,NULL,2100,11105,NULL,NULL,NULL,'GRB 790418',NULL,'1992grbo.book..107S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45161,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45161,37.12,0.87,265,11106,70,NULL,NULL,'2MFGC 04774',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'12.6K',NULL,NULL,NULL,NULL,NULL,NULL,1,88.5972083,-52.98381,0.293,NULL,35742368915,558474514,8726164,12.6),(45162,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45162,35.6,0.5,132,11107,70,NULL,NULL,'AM 0552-410 E',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.0R',NULL,'INTERACTING','in an interacting pair',NULL,NULL,NULL,1,88.618625,-41.08183,0.101,NULL,37051062315,578922848,9045669,14),(45163,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45163,35.31,0.59,115,11108,70,NULL,NULL,'2MASX J05543760-6801584',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.6b',0.22,NULL,NULL,NULL,NULL,NULL,1,88.656875,-68.03272,0.233,NULL,35500711166,554698611,8667165,16.6),(45164,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45164,35.54,0.55,128,11109,70,NULL,NULL,'2MASX J05543838-6825094',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'15.8b',0.28,NULL,NULL,NULL,NULL,NULL,1,88.659833,-68.41925,0.257,NULL,35501636793,554713074,8667391,15.8),(45165,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45165,34.83,0.51,92.6,11110,70,NULL,NULL,'2MASX J05544466-3519227',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,88.686083,-35.32297,0,NULL,37064129287,579127020,9048859,14.5),(45166,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45166,34.37,0.49,74.7,11111,70,NULL,NULL,'MCG -03-15-027',NULL,'2014MNRAS.445.2677S',2014,1,1.2,'GSC 5931-0669 (mag. 14) superposed 16\\\" northeast.','G',0.00015,NULL,'15.5',0.4,'SB(r)0/a?',NULL,NULL,NULL,NULL,1,88.6882083333,-15.13425,0.813,NULL,36670194576,572971790,8952684,15.5),(45167,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45167,36.01,0.5,160,11112,70,NULL,NULL,'2MASX J05544790-5801282',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,88.6997083,-58.02447,0.249,NULL,35856506796,560257918,8754029,16.7),(45168,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45168,37.38,0.72,299,11113,70,NULL,NULL,'2MASX J05545108-3931362',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,88.712917,-39.52675,0.109,NULL,37103459822,579741559,9058461,14.5),(45169,'AGN time lag','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45169,34.84,0.3,93.1,11114,NULL,NULL,NULL,'UGC 03374',NULL,'2014ApJ...784L..11Y',2014,1,2.1,'Bonatto and Pastoriza (1997,ApJ,486,132) give z = 0.0766.','G',0.000023,NULL,'12.7r',1.5,'SB0            Sy1.5',NULL,NULL,NULL,'Sy 1.5',1,88.723375,46.43933,1.545,NULL,66039119556,1031861243,16122831,12.7),(45170,'AGN time lag','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45170,36.97,0.39,248,11114,44,NULL,NULL,'UGC 03374',NULL,'2007MNRAS.380..669C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45171,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45171,35.45,0.65,123,11115,70,NULL,NULL,'ESO 057- G 053',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'16.09',0.4,'S...',NULL,NULL,NULL,NULL,1,88.728083,-70.88214,0.301,NULL,35510114272,554845535,8669461,16.09),(45172,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45172,34.42,0.67,76.5,11116,70,NULL,NULL,'2MASX J05550466-7130304',NULL,'2014MNRAS.445.2677S',2014,1,0.69,NULL,'G',0.000093,NULL,'15.0b',0.33,NULL,NULL,NULL,NULL,NULL,1,88.769417,-71.50839,0.445,NULL,35510723222,554855050,8669610,15),(45173,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45173,36.52,0.59,201,11117,70,NULL,NULL,'2MASX J05550682-4851432',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.5b',0.7,NULL,NULL,NULL,NULL,NULL,1,88.7785,-48.86208,0.257,NULL,35711705644,557995400,8718678,15.5),(45174,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45174,35.6,0.56,132,11118,70,NULL,NULL,'ESO 254- G 004',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00013,NULL,'15.58',0.3,'Sa-b',NULL,NULL,NULL,NULL,1,88.789167,-42.81906,0.157,NULL,37045531990,578836437,9044319,15.58),(45175,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45175,35.34,0.57,117,11119,70,NULL,NULL,'2MASX J05551071-4754395',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.9b',0.5,NULL,NULL,NULL,NULL,NULL,1,88.794667,-47.91097,0.377,NULL,35716512228,558070503,8719851,15.9),(45176,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45176,35.69,0.61,137,11120,70,NULL,NULL,'2MASX J05551469-3426414',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.5,NULL,NULL,NULL,NULL,NULL,1,88.8112917,-34.44489,0,NULL,37064696710,579135886,9048998,13.9),(45177,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45177,37.39,0.63,300,11121,70,NULL,NULL,'2MASX J05551741-4852428',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,88.8224583,-48.87861,0.257,NULL,35711737906,557995904,8718686,14.5),(45178,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45178,35.14,0.57,107,11122,70,NULL,NULL,'2MFGC 04783',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'11.8K',0.17,NULL,NULL,NULL,NULL,NULL,1,88.8537083,-69.77869,0.309,NULL,35503727411,554745740,8667902,11.8),(45179,'SNIa','2016-12-15 15:14:13','2016-12-16 11:19:18','1','SN 2001gc',NULL,45179,33.48,0.22,48.7,11123,74.2,NULL,'SALT 2','UGC 03375',0.0193,'2010ApJ...716..712A',2010,1,1.9,NULL,'G',0.000023,NULL,'13.9',1,'SA(rs)c',NULL,NULL,NULL,NULL,1,88.8554583,51.91061,0.997,NULL,66064090565,1032251415,16128928,13.9),(45180,'SNIa','2016-12-15 15:14:13','2016-12-16 11:19:18','1','SN 2001gc',NULL,45180,34.07,0.09,65.2,11123,74.4,NULL,NULL,'UGC 03375',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45181,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45181,33.75,0.69,56.2,11123,100,NULL,'mid-IR','UGC 03375',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45182,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45182,34.07,0.47,65.1,11123,NULL,NULL,'H','UGC 03375',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45183,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45183,34.07,0.09,65.2,11123,74.4,NULL,NULL,'UGC 03375',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45184,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45184,34.07,0.4,65.2,11123,75,NULL,'HOSTS SN 2001gc','UGC 03375',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45185,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45185,34.1,0.46,66,11123,NULL,NULL,'J','UGC 03375',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45186,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45186,34.14,0.45,67.2,11123,NULL,NULL,'K','UGC 03375',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45187,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45187,34.27,0.43,71.4,11123,75,NULL,'3.6 micron, color corrected','UGC 03375',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45188,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45188,34.28,0.42,71.8,11123,NULL,18.48,'3.6 micron','UGC 03375',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45189,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45189,34.49,0.43,79.2,11123,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03375',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45190,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45190,34.5,0.4,79.4,11123,NULL,NULL,'mean','UGC 03375',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45191,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45191,34.16,0.52,68,11124,70,NULL,NULL,'2MASX J05552552-1402316',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.53',0.4,NULL,NULL,NULL,NULL,NULL,1,88.856333,-14.04211,0.921,NULL,36672606145,573009471,8953272,15.53),(45192,'IRAS','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45192,33.97,0.8,62.3,11125,75,NULL,'MAT, I','IC 2160',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.00003,NULL,'13.86',0.8,'(R\':)SB(rs)bc',NULL,NULL,NULL,NULL,1,88.869,-76.92025,0.461,NULL,35535811946,555247061,8675735,13.86),(45193,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45193,33.28,0.43,45.3,11125,75,NULL,'MAT, I, raw','IC 2160',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45194,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45194,33.41,0.32,48.1,11125,85,NULL,'I, raw','IC 2160',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45195,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45195,33.46,0.32,49.1,11125,85,NULL,'I, inv','IC 2160',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45196,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45196,33.47,0.43,49.4,11125,75,NULL,'MAT, I, inv','IC 2160',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45197,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',45197,33.52,NULL,50.6,11125,NULL,NULL,'B','IC 2160',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45198,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45198,33.66,0.43,53.9,11125,75,NULL,'MAT, I, cor','IC 2160',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45199,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45199,33.7,0.47,55,11125,NULL,NULL,'H','IC 2160',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45200,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',45200,33.71,NULL,55.2,11125,NULL,NULL,'I','IC 2160',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45201,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45201,33.8,0.46,57.5,11125,NULL,NULL,'J','IC 2160',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45202,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45202,33.82,0.42,58.2,11125,NULL,NULL,NULL,'IC 2160',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45203,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45203,33.87,0.2,59.4,11125,74.4,NULL,NULL,'IC 2160',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45204,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45204,33.89,0.45,59.9,11125,NULL,NULL,'K','IC 2160',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45205,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45205,34.02,0.4,63.7,11125,NULL,NULL,'mean','IC 2160',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45206,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45206,34.06,0.38,65,11125,NULL,NULL,'Malmquist cor.','IC 2160',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45207,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45207,35.78,0.63,143,11126,70,NULL,NULL,'2MASX J05553050-6952461',NULL,'2014MNRAS.445.2677S',2014,1,0.12,NULL,'G',0.00015,NULL,'17.3b',0.12,NULL,NULL,NULL,NULL,NULL,1,88.877125,-69.87958,0.309,NULL,35503670718,554744854,8667888,17.3),(45208,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45208,36.22,0.6,175,11127,70,NULL,NULL,'2MASX J05553178-2447516',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,88.8823333333,-24.79761,0.041,NULL,37125781346,580090333,9063911,15.6),(45209,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45209,35.55,0.64,129,11128,70,NULL,NULL,'2MASX J05554177-3914353',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.6I',0.5,NULL,NULL,NULL,NULL,NULL,1,88.924125,-39.24314,0.101,NULL,37103697823,579745278,9058519,13.6),(45210,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45210,35.58,0.51,131,11129,70,NULL,NULL,'2MASX J05554213-3802423',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000107,NULL,'12.9I',0.7,NULL,NULL,NULL,NULL,NULL,1,88.925583,-38.04514,0.077,NULL,37073204323,579268817,9051075,12.9),(45211,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45211,30.07,0.4,10.3,11130,75,NULL,'B','UGCA 116',NULL,'1988NBGC.C....0000T',1988,1,0.56,NULL,'G',0.000013,NULL,'15.48',0.22,'BCD;Sbc;merger HII',NULL,NULL,NULL,NULL,1,88.9275,3.39222,2.273,NULL,64432055975,1006750874,15730482,15.48),(45212,'IRAS','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45212,33.31,0.8,46,11131,75,NULL,'MAT, I','ESO 488- G 044',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'15',0.6,'Sb',NULL,NULL,NULL,NULL,1,88.9615,-22.80686,0.105,NULL,37111615677,579868994,9060453,15),(45213,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45213,32.62,0.32,33.4,11131,85,NULL,'I, inv','ESO 488- G 044',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45214,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45214,32.63,0.32,33.5,11131,85,NULL,'I, raw','ESO 488- G 044',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45215,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45215,33.08,0.43,41.2,11131,75,NULL,'MAT, I, raw','ESO 488- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45216,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45216,33.11,0.43,41.9,11131,75,NULL,'MAT, I, inv','ESO 488- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45217,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45217,33.15,0.43,42.7,11131,75,NULL,'MAT, I, cor','ESO 488- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45218,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45218,34.03,0.85,64,11131,NULL,NULL,NULL,'ESO 488- G 044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45219,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45219,34.07,0.2,65.2,11131,74.4,NULL,NULL,'ESO 488- G 044',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45220,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45220,34.17,0.8,68.2,11131,NULL,NULL,'Malmquist cor.','ESO 488- G 044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45221,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45221,36.72,0.69,221,11132,70,NULL,NULL,'2MASX J05555750-1409220',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,88.9895,-14.15619,0.905,NULL,36668078804,572938731,8952167,17.7),(45222,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45222,35.93,0.84,154,11133,70,NULL,NULL,'2MASX J05560987-7013192',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'16.2b',0.33,NULL,NULL,NULL,NULL,NULL,1,89.041,-70.22206,0.333,NULL,35502902474,554732851,8667700,16.2),(45223,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45223,34.38,0.53,75.3,11134,70,NULL,NULL,'2MASX J05561155-1316506',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,89.048125,-13.28075,1.025,NULL,36672303551,573004742,8953199,16.9),(45224,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45224,35.1,0.61,105,11135,70,NULL,NULL,'2MASX J05561563-4139497',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'13.1I',0.7,NULL,NULL,NULL,NULL,NULL,1,89.0650833333,-41.66381,0.145,NULL,37050519415,578914365,9045536,13.1),(45225,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45225,36.02,0.71,160,11136,70,NULL,NULL,'2MASX J05561600-4023577',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.4,NULL,NULL,NULL,NULL,NULL,1,89.06675,-40.39944,0.117,NULL,37051820340,578934692,9045854,14.2),(45226,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45226,34.27,0.43,71.4,11137,75,NULL,'3.6 micron, color + selection bias corrected','VV 601',NULL,'2014MNRAS.444..527S',2014,1,1,NULL,'G',0.00003,NULL,'14.8',1,'S?',NULL,NULL,NULL,NULL,1,89.06875,48.54325,1.281,NULL,66042318440,1031911225,16123612,14.8),(45227,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45227,34.61,0.4,83.6,11137,NULL,NULL,'mean','VV 601',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45228,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45228,34.9,0.47,95.7,11137,NULL,NULL,'H','VV 601',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45229,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45229,35.56,0.43,130,11138,NULL,NULL,'Malmquist cor.','ESO 086- G 041',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.38',0.6,'Sb',NULL,NULL,NULL,NULL,1,89.09275,-62.59297,0.157,NULL,35841313338,560020520,8750320,15.38),(45230,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45230,35.63,0.41,134,11138,NULL,NULL,NULL,'ESO 086- G 041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45231,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45231,35.67,0.2,136,11138,74.4,NULL,NULL,'ESO 086- G 041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45232,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45232,36.9,0.55,240,11139,70,NULL,NULL,'2MASX J05562495-2158510',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.4I',0.6,NULL,NULL,NULL,NULL,NULL,1,89.103917,-21.98078,0.053,NULL,37380616925,584072139,9126127,13.4),(45233,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45233,33.75,0.2,56.2,11140,74.4,NULL,NULL,'ESO 555- G 013',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.00003,NULL,'14.16',1,'Sa',NULL,NULL,NULL,NULL,1,89.104667,-19.6915,0.149,NULL,36656723691,572761307,8949395,14.16),(45234,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45234,36.18,0.55,172,11141,70,NULL,NULL,'2MASX J05563777-3721388',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,89.157375,-37.36081,0.129,NULL,37071108399,579236068,9050563,14.8),(45235,'Tully est','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45235,30.97,0.8,15.6,11142,75,NULL,NULL,'UGC 03371',NULL,'1988NBGC.C....0000T',1988,1,4.6,NULL,'G',0.00002,NULL,'14.7',3.6,'Im:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,89.160833,75.31611,0.477,NULL,65659597416,1025931209,16030175,14.7),(45236,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45236,31.7,0.4,21.9,11142,NULL,NULL,NULL,'UGC 03371',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45237,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45237,35.66,0.64,136,11143,70,NULL,NULL,'2MASX J05564106-3632488',NULL,'2014MNRAS.445.2677S',2014,1,0.28,NULL,'G',0.00015,NULL,'13.56',0.24,NULL,NULL,NULL,NULL,NULL,1,89.1710833333,-36.54683,0.093,NULL,37074696602,579292134,9051439,13.56),(45238,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45238,36.31,0.61,183,11144,70,NULL,NULL,'2MASX J05564164-6308254',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,89.1735,-63.14036,0.129,NULL,35841067246,560016675,8750260,16.2),(45239,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45239,36.73,0.66,222,11145,70,NULL,NULL,'2MASX J05564496-2111219',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.62',0.3,NULL,NULL,NULL,NULL,NULL,1,89.18725,-21.18947,0.085,NULL,36642108927,572532951,8945827,16.62),(45240,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45240,36.17,0.57,171,11146,70,NULL,NULL,'2MASX J05564873-6404563',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,89.202875,-64.08233,0.129,NULL,35843392374,560053005,8750828,16.4),(45241,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45241,36.16,0.66,171,11147,70,NULL,NULL,'2MASX J05564946-6011243',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,89.2062083,-60.19011,0.161,NULL,35863047896,560360123,8755626,16.7),(45242,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45242,35.19,0.62,109,11148,70,NULL,NULL,'2MASX J05564989-6130083',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,89.207875,-61.50225,0.121,NULL,35861497344,560335896,8755248,15.7),(45243,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45243,36.04,0.56,162,11149,70,NULL,NULL,'2MASX J05565367-2200349',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.27',0.6,NULL,NULL,NULL,NULL,NULL,1,89.223625,-22.00986,0.053,NULL,37379707738,584057933,9125905,16.27),(45244,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45244,35.35,0.65,118,11150,70,NULL,NULL,'2MASX J05565511-7002148',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'16.5b',0.18,NULL,NULL,NULL,NULL,NULL,1,89.2295,-70.0375,0.317,NULL,35502944297,554733504,8667711,16.5),(45245,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45245,34.46,0.63,77.9,11151,70,NULL,NULL,'2MASX J05565727-1511248',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.8I',0.4,NULL,NULL,NULL,NULL,NULL,1,89.238625,-15.19022,0.745,NULL,36670557572,572977462,8952772,13.8),(45246,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45246,33.77,0.43,56.7,11152,75,NULL,'3.6 micron, color + selection bias corrected','2MFGC 04796',NULL,'2014MNRAS.444..527S',2014,1,0.78,NULL,'G',0.000013,NULL,'11.2K',0.22,'S',NULL,NULL,NULL,NULL,1,89.23925,11.82514,NULL,NULL,64525839738,1008216245,15753378,11.2),(45247,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',45247,34.26,0.49,71.1,11152,75,NULL,'IR','2MFGC 04796',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45248,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45248,36.6,0.57,209,11153,70,NULL,NULL,'2MASX J05570534-4104234',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.4,NULL,NULL,NULL,NULL,NULL,1,89.2722083,-41.07322,0.101,NULL,37050737478,578917773,9045590,14.4),(45249,'GRB','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',45249,47.11,1.49,7520,11154,NULL,NULL,NULL,'GRB 081121',2.512,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,89.275375,-60.60278,0.137,NULL,35865010958,560390796,8756106,NULL),(45250,'GRB','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',45250,46.9,0.24,24000,11154,NULL,NULL,NULL,'GRB 081121',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45251,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45251,36.63,0.71,212,11155,70,NULL,NULL,'2MASX J05571735-3730484',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,89.3222917,-37.514,0.113,NULL,37071024032,579234750,9050542,15.3),(45252,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45252,36.23,0.65,176,11156,70,NULL,NULL,'2MASX J05571913-3926164',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15',0.3,'SBab','Group member',NULL,NULL,NULL,1,89.3297083,-39.43783,0.125,NULL,37102974503,579733976,9058343,15),(45253,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45253,36.29,0.48,181,11157,NULL,NULL,'Malmquist cor.','2MASX J05572602-3931022',NULL,'2009ApJS..182..474S',2009,1,0.52,NULL,'G',0.000033,NULL,'15.5R',0.16,'S','Group member',NULL,NULL,NULL,1,89.358417,-39.51733,0.141,NULL,37048392853,578881138,9045017,15.5),(45254,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45254,36.54,0.43,203,11157,NULL,NULL,NULL,'2MASX J05572602-3931022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45255,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45255,36.58,0.2,207,11157,74.4,NULL,NULL,'2MASX J05572602-3931022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45256,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45256,36.3,0.64,182,11158,70,NULL,NULL,'2MASX J05572864-4231273',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,89.36925,-42.52428,0.185,NULL,37045237409,578831834,9044247,14.3),(45257,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45257,35.74,0.54,141,11159,70,NULL,NULL,'2MASX J05573314-2954140',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,89.388125,-29.90383,0,NULL,37151879971,580498124,9070283,16.3),(45258,'Brightest Stars','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45258,28.7,0.73,5.5,11160,NULL,NULL,NULL,'[KM96] 055451+072840',NULL,'1996A&A...315..348K',1996,1,0.5,NULL,'G',0.000003,NULL,'18.4',0.2,'Im','Dwarf, field object',NULL,NULL,NULL,1,89.402917,7.49194,NULL,NULL,64451733332,1007058333,15735286,18.4),(45259,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45259,34.02,NULL,63.6,11161,NULL,NULL,NULL,'FGC 0547',NULL,'2000BSAO...50....5K',2000,1,0.93,NULL,'G',0.000127,NULL,'16.4',0.12,'Sdm',NULL,NULL,NULL,NULL,1,89.405833,78.77,0.337,NULL,65716364687,1026818198,16044034,16.4),(45260,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45260,34.62,NULL,83.8,11161,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0547',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45261,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45261,34.62,NULL,83.8,11161,NULL,NULL,'Dipole + Quadrupole','FGC 0547',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45262,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45262,34.64,NULL,84.6,11161,NULL,NULL,'Dipole','FGC 0547',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45263,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45263,36.14,0.93,169,11162,70,NULL,NULL,'2MASX J05574242-1837258',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,89.4267917,-18.62389,0.161,NULL,36648567263,572633863,8947404,16.7),(45264,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45264,36.29,0.65,181,11163,70,NULL,NULL,'2MASX J05575089-6038471',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,89.4621666667,-60.64639,0.137,NULL,35865008777,560390762,8756105,16.5),(45265,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45265,32.73,0.53,35.2,11164,70,NULL,NULL,'NGC 2124',NULL,'2014MNRAS.445.2677S',2014,1,2.7,NULL,'G',0.000017,NULL,'13.42',0.9,'SA(s)b?',NULL,NULL,NULL,NULL,1,89.467625,-20.08464,0.113,NULL,36643476235,572554316,8946161,13.42),(45266,'IRAS','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45266,33.08,0.8,41.3,11164,75,NULL,'MAT, I','NGC 2124',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45267,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45267,33.04,0.4,40.6,11164,NULL,NULL,NULL,'NGC 2124',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45268,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45268,33.04,0.4,40.6,11164,73,NULL,'opt','NGC 2124',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45269,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45269,33.17,0.46,43.1,11164,NULL,NULL,'J','NGC 2124',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45270,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45270,33.19,0.32,43.5,11164,NULL,NULL,'Malmquist cor.','NGC 2124',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45271,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45271,33.21,0.43,43.8,11164,75,NULL,'MAT, I, raw','NGC 2124',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45272,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45272,33.25,0.2,44.7,11164,74.4,NULL,NULL,'NGC 2124',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45273,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45273,33.26,0.32,44.8,11164,85,NULL,'I, raw','NGC 2124',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45274,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45274,33.26,0.43,44.9,11164,75,NULL,'MAT, I, cor','NGC 2124',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45275,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45275,33.27,0.4,45.1,11164,NULL,NULL,'mean','NGC 2124',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45276,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45276,33.27,0.47,45.1,11164,NULL,NULL,'H','NGC 2124',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45277,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45277,33.32,0.32,46.2,11164,85,NULL,'I, inv','NGC 2124',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45278,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45278,33.32,0.45,46.2,11164,NULL,NULL,'K','NGC 2124',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45279,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45279,33.36,0.3,46.9,11164,NULL,NULL,NULL,'NGC 2124',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45280,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45280,33.38,0.43,47.3,11164,75,NULL,'3.6 micron, color corrected','NGC 2124',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45281,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45281,33.49,0.43,49.8,11164,75,NULL,'MAT, I, inv','NGC 2124',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45282,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45282,33.59,0.43,52.2,11164,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2124',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45283,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45283,32.11,0.43,26.4,11165,75,NULL,'3.6 micron, color + selection bias corrected','IC 2152',NULL,'2014MNRAS.444..527S',2014,1,1.7,NULL,'G',0.00003,NULL,'13.42',1.2,'(R:)SAB(l)ab:',NULL,NULL,NULL,NULL,1,89.4725417,-23.18078,0.041,NULL,37112010977,579875171,9060549,13.42),(45284,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45284,32.18,0.43,27.3,11165,75,NULL,'3.6 micron, color corrected','IC 2152',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45285,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45285,32.28,0.2,28.6,11165,74.4,NULL,NULL,'IC 2152',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45286,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45286,32.34,0.47,29.4,11165,NULL,NULL,'H','IC 2152',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45287,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45287,32.37,0.4,29.8,11165,NULL,NULL,'mean','IC 2152',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45288,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45288,32.38,0.45,30,11165,NULL,NULL,'K','IC 2152',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45289,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45289,32.41,0.46,30.3,11165,NULL,NULL,'J','IC 2152',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45290,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45290,35.75,0.61,141,11166,70,NULL,NULL,'2MASX J05575457-1644207',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.88',NULL,NULL,NULL,NULL,NULL,NULL,1,89.47725,-16.73911,0.557,NULL,36700382011,573443468,8960054,15.88),(45291,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45291,36.15,0.6,170,11167,70,NULL,NULL,'2MASX J05575872-3739273',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.2,NULL,NULL,NULL,NULL,NULL,1,89.494583,-37.65753,0.113,NULL,37070979848,579234060,9050532,14.5),(45292,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45292,35.1,0.64,104,11168,NULL,NULL,NULL,'ESO 307- G 009',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'16.20',0.3,'Sb:',NULL,NULL,NULL,NULL,1,89.5055,-38.57383,0.105,NULL,37070245892,579222592,9050353,16.2),(45293,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45293,35.14,0.2,107,11168,74.4,NULL,NULL,'ESO 307- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45294,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45294,35.45,0.55,123,11168,NULL,NULL,'Malmquist cor.','ESO 307- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45295,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45295,35.65,0.59,135,11169,70,NULL,NULL,'2MASX J05580837-4250036',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.5I',0.5,NULL,NULL,NULL,NULL,NULL,1,89.5348333333,-42.83431,0.185,NULL,37046037780,578844340,9044442,13.5),(45296,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45296,36.23,0.54,176,11170,70,NULL,NULL,'2MASX J05581402-4718206',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.4,NULL,NULL,NULL,NULL,NULL,1,89.5584166667,-47.30583,0.197,NULL,35704977558,557890274,8717035,14.3),(45297,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45297,35.73,0.74,140,11171,70,NULL,NULL,'2MASX J05582012-3453475',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,89.5837917,-34.8965,0,NULL,37061427542,579084805,9048200,15.2),(45298,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45298,36.47,0.56,197,11172,70,NULL,NULL,'2MASX J05582458-3754367',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,89.6025,-37.91028,0.093,NULL,37072979657,579265307,9051020,14.8),(45299,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45299,33.66,0.43,53.9,11173,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03379',NULL,'2014MNRAS.444..527S',2014,1,1.8,NULL,'G',0.000037,NULL,'13.68',1.2,'(R\')SABb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,89.60575,68.46103,0.393,NULL,65632912687,1025514260,16023660,13.68),(45300,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45300,33.74,0.46,55.9,11173,NULL,NULL,'J','UGC 03379',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45301,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45301,33.74,0.47,56.1,11173,NULL,NULL,'H','UGC 03379',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45302,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45302,33.78,0.45,57,11173,NULL,NULL,'K','UGC 03379',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45303,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45303,33.83,0.4,58.2,11173,NULL,NULL,'mean','UGC 03379',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45304,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45304,35.64,0.52,134,11174,70,NULL,NULL,'2MASX J05583383-5605167',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,89.6410417,-56.08789,0.285,NULL,35735513363,558367396,8724490,14.3),(45305,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45305,36.17,0.59,172,11175,70,NULL,NULL,'2MASX J05583427-3744457',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,89.6427916667,-37.74611,0.093,NULL,37070878908,579232482,9050507,14.8),(45306,'IRAS','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45306,32.01,0.8,25.3,11176,75,NULL,'MAT, I','ESO 488- G 049',NULL,'1997ApJS..109..333W',1997,1,1.7,'Confused and extended HIPASS source','G',0.00001,NULL,'14.96',0.7,'SB(s)dm',NULL,NULL,NULL,NULL,1,89.6640417,-25.41481,0.081,NULL,37120657182,580010268,9062660,14.96),(45307,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45307,31.72,0.32,22.1,11176,85,NULL,'I, inv','ESO 488- G 049',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45308,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45308,31.78,0.32,22.7,11176,85,NULL,'I, raw','ESO 488- G 049',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45309,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45309,32.09,0.43,26.2,11176,75,NULL,'MAT, I, inv','ESO 488- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45310,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45310,32.21,0.43,27.7,11176,75,NULL,'MAT, I, raw','ESO 488- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45311,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45311,32.45,0.2,30.9,11176,74.4,NULL,NULL,'ESO 488- G 049',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45312,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45312,32.5,0.43,31.7,11176,75,NULL,'MAT, I, cor','ESO 488- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45313,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45313,32.56,0.4,32.5,11176,NULL,NULL,NULL,'ESO 488- G 049',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45314,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45314,32.56,0.4,32.5,11176,73,NULL,'opt','ESO 488- G 049',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45315,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45315,36.15,0.75,170,11177,70,NULL,NULL,'2MASX J05584083-5200397',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,89.67025,-52.011,0.201,NULL,35743129680,558486401,8726350,14.3),(45316,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45316,36.89,0.63,239,11178,70,NULL,NULL,'2MASX J05584386-5835377',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,89.682833,-58.59386,0.197,NULL,35855136640,560236510,8753695,16.7),(45317,'BL Lac Luminosity','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45317,41.51,NULL,2000,11179,70,NULL,'min.','PKS 0600-749',NULL,'2014ApJ...784..151S',2014,1,NULL,NULL,'QSO',NULL,'PHOT','17.2V',NULL,'blazar',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,89.692,-74.98472,0.489,NULL,35540859824,555325934,8676967,17.2),(45318,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45318,34.25,0.5,70.6,11180,70,NULL,NULL,'ESO 488- G 051',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.000034,NULL,'14.21',0.8,'SAB(r)a',NULL,NULL,NULL,NULL,1,89.718,-23.33958,0.037,NULL,37111815001,579872109,9060501,14.21),(45319,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45319,33.66,0.69,53.8,11180,100,NULL,'mid-IR','ESO 488- G 051',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45320,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45320,34.8,0.4,91.4,11180,NULL,NULL,'mean','ESO 488- G 051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45321,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45321,35.41,0.46,121,11180,NULL,NULL,'J','ESO 488- G 051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45322,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45322,35.41,0.45,121,11180,NULL,NULL,'K','ESO 488- G 051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45323,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45323,35.41,0.47,121,11180,NULL,NULL,'H','ESO 488- G 051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45324,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45324,36.86,1.01,236,11181,70,NULL,NULL,'2MASX J05585702-3730542',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,89.7375833333,-37.51511,0.113,NULL,37071084904,579235701,9050557,15.2),(45325,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45325,35.87,0.63,149,11182,70,NULL,NULL,'2MASX J05590254-4526199',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,89.7605416667,-45.43894,0.173,NULL,35702140242,557845941,8716342,16.5),(45326,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45326,36.7,0.57,219,11183,70,NULL,NULL,'ESO 120- G 025',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'16.32',0.4,'S...',NULL,NULL,NULL,NULL,1,89.7622917,-58.81058,0.201,NULL,35855030724,560234855,8753669,16.32),(45327,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45327,36.33,0.42,184,11184,NULL,NULL,NULL,'AGC 450147',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000033,NULL,'16',0.24,'Sc','Group member',NULL,NULL,NULL,1,89.76325,-40.19394,0.137,NULL,37048935631,578889619,9045150,16),(45328,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45328,36.32,0.42,184,11184,NULL,NULL,'Malmquist cor.','AGC 450147',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45329,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45329,36.37,0.2,188,11184,74.4,NULL,NULL,'AGC 450147',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45330,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45330,33.86,0.43,59.2,11185,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03373',NULL,'2014MNRAS.444..527S',2014,1,1.4,NULL,'G',0.000033,NULL,'13.81',0.9,'SABc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,89.781833,78.50967,0.345,NULL,65649293643,1025770213,16027659,13.81),(45331,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45331,33.94,0.43,61.3,11185,75,NULL,'3.6 micron, color corrected','UGC 03373',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45332,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45332,34.03,0.2,64,11185,74.4,NULL,NULL,'UGC 03373',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45333,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45333,34.08,0.32,65.6,11185,NULL,NULL,'Malmquist cor.','UGC 03373',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45334,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45334,34.11,0.31,66.4,11185,NULL,NULL,NULL,'UGC 03373',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45335,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45335,34.17,0.4,68.1,11185,NULL,NULL,'mean','UGC 03373',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45336,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45336,34.57,0.47,82.1,11185,NULL,NULL,'H','UGC 03373',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45337,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45337,33.85,0.53,58.9,11186,70,NULL,NULL,'ESO 205- G 013',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.00015,NULL,'14.19',0.9,'Sa:',NULL,NULL,NULL,NULL,1,89.789625,-51.46889,0.165,NULL,35740260049,558441563,8725649,14.19),(45338,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45338,36.45,0.58,195,11187,70,NULL,NULL,'2MASX J05591537-2552079',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,89.814125,-25.86889,0,NULL,37120778380,580012162,9062690,14.9),(45339,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45339,34.34,0.47,73.7,11188,NULL,NULL,'H','UGC 03383',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000197,NULL,'16.0',0.7,'S',NULL,NULL,NULL,NULL,1,89.8527917,54.41914,0.837,NULL,66054419166,1032100299,16126567,16),(45340,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45340,34.36,0.4,74.5,11188,NULL,NULL,'mean','UGC 03383',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45341,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45341,34.39,0.45,75.3,11188,NULL,NULL,'K','UGC 03383',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45342,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45342,34.49,0.46,78.9,11188,NULL,NULL,'J','UGC 03383',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45343,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45343,36.06,0.55,163,11189,70,NULL,NULL,'2MASX J05592518-5002418',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.5I',0.4,NULL,NULL,NULL,NULL,NULL,1,89.8550416667,-50.04494,0.077,NULL,35710382817,557974731,8718355,14.5),(45344,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45344,35.67,0.54,136,11190,70,NULL,NULL,'2MASX J05592951-1948356',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,89.872875,-19.80997,0.137,NULL,36642553843,572539903,8945935,16.7),(45345,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45345,35.42,0.57,121,11191,70,NULL,NULL,'2MASX J05593163-5221538',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.8b',0.6,'SB(rl)0^0',NULL,NULL,NULL,NULL,1,89.881875,-52.36503,0.189,NULL,35742058566,558469665,8726088,15.8),(45346,'TRGB','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45346,28.32,NULL,4.61,11192,NULL,NULL,NULL,'kkh 034',NULL,'2003A&A...398..479K',2003,1,0.6,NULL,'G',0.000001,NULL,'17.1',0.5,'Ir',NULL,NULL,NULL,NULL,1,89.918333,73.42778,0.537,NULL,65657653899,1025900842,16029700,17.1),(45347,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45347,35.37,0.49,118,11193,70,NULL,NULL,'2MASX J05594207-3544502',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'13.2I',0.6,NULL,NULL,NULL,NULL,NULL,1,89.9252083,-35.74728,0.065,NULL,37063376222,579115253,9048675,13.2),(45348,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45348,35.61,0.62,132,11194,70,NULL,NULL,'AM 0602-600 NED02',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.05',NULL,NULL,NULL,NULL,NULL,NULL,1,89.9257083333,-60.08436,0.161,NULL,35862974387,560358974,8755608,16.05),(45349,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45349,36.57,0.52,206,11195,70,NULL,NULL,'2MASX J05594552-4325087',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'13.9I',0.5,NULL,NULL,NULL,NULL,NULL,1,89.939625,-43.41906,0.201,NULL,37045723862,578839435,9044366,13.9),(45350,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45350,35.16,0.6,108,11196,70,NULL,NULL,'2MASX J05594618-4015449',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000083,NULL,'14.9V',0.4,'SBb','Group member',NULL,NULL,NULL,1,89.9422917,-40.26253,0.153,NULL,37048930822,578889544,9045149,14.9),(45351,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45351,34.39,0.54,75.5,11197,70,NULL,NULL,'ESO 205- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.00015,NULL,'14.84',0.4,'(R)SB(s)0/a:',NULL,NULL,NULL,NULL,1,89.955667,-52.40858,0.189,NULL,35742171562,558471430,8726116,14.84),(45352,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45352,36.24,0.54,177,11198,70,NULL,NULL,'2MASX J05595289-3827366',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,89.9705,-38.46025,0.105,NULL,37069677318,579213708,9050214,14),(45353,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45353,36.73,0.56,222,11199,70,NULL,NULL,'2MASX J05595301-6426540',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,89.97075,-64.44842,0.137,NULL,35842451403,560038303,8750598,16.7),(45354,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45354,35.93,0.51,153,11200,70,NULL,NULL,'2MASX J05595980-4552261',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,89.999083,-45.87389,0.173,NULL,35702513668,557851776,8716434,14.4),(45355,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45355,37.05,0.61,257,11201,70,NULL,NULL,'2MASX J06000049-3914476',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.4,NULL,NULL,NULL,NULL,NULL,1,90.002125,-39.24661,0.101,NULL,38960899589,608764056,9511938,14.3),(45356,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45356,36.67,0.57,216,11202,70,NULL,NULL,'2MASX J06000484-2633418',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,90.020125,-26.56167,0,NULL,39063921640,610373775,9537090,13.9),(45357,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45357,36.39,0.52,190,11203,70,NULL,NULL,'2MASX J06000650-2225423',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.60',NULL,NULL,NULL,NULL,NULL,NULL,1,90.027,-22.42853,0.101,NULL,38721817271,605028394,9453568,16.6),(45358,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45358,36.15,0.66,170,11204,70,NULL,NULL,'2MASX J06000933-1827453',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,90.0387917,-18.46267,0.217,NULL,38731801149,605184392,9456006,16.9),(45359,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45359,35.79,0.3,144,11205,NULL,NULL,'Malmquist cor.','ESO 307- G 012',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'15',0.6,'SAB(s)b',NULL,NULL,NULL,NULL,1,90.0777083,-42.10864,0.209,NULL,38932593173,608321768,9505027,15),(45360,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45360,35.87,0.29,149,11205,NULL,NULL,NULL,'ESO 307- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45361,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45361,35.91,0.2,152,11205,74.4,NULL,NULL,'ESO 307- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45362,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45362,35.95,0.4,155,11205,NULL,NULL,'mean','ESO 307- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45363,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45363,36.03,0.47,161,11205,NULL,NULL,'H','ESO 307- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45364,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45364,34,0.69,63,11206,100,NULL,'mid-IR','MCG -03-16-006',NULL,'2013ApJ...771...88L',2013,1,0.6,NULL,'G',0.000027,NULL,'15.1b',0.4,'Sb',NULL,NULL,NULL,NULL,1,90.085417,-16.16672,0.669,NULL,38760416501,605631507,9462992,15.1),(45365,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45365,34.23,0.47,70,11206,NULL,NULL,'H','MCG -03-16-006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45366,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45366,34.34,0.45,73.8,11206,NULL,NULL,'K','MCG -03-16-006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45367,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45367,34.42,0.46,76.7,11206,NULL,NULL,'J','MCG -03-16-006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45368,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45368,34.67,0.4,85.7,11206,NULL,NULL,'mean','MCG -03-16-006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45369,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45369,34.85,0.47,93.3,11207,NULL,NULL,'H','ESO 555- G 018',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000033,NULL,'14.28',0.6,'SABb?',NULL,NULL,NULL,NULL,1,90.099375,-19.70919,0.181,NULL,38723920965,605061265,9454082,14.28),(45370,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45370,34.92,0.45,96.4,11207,NULL,NULL,'K','ESO 555- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45371,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45371,34.95,0.46,97.9,11207,NULL,NULL,'J','ESO 555- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45372,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45372,35.24,0.4,112,11207,NULL,NULL,'mean','ESO 555- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45373,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45373,35.28,0.45,114,11207,NULL,NULL,'Malmquist cor.','ESO 555- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45374,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45374,35.39,0.2,120,11207,74.4,NULL,NULL,'ESO 555- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45375,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45375,35.55,0.4,129,11207,NULL,NULL,NULL,'ESO 555- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45376,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45376,37.04,0.66,256,11208,70,NULL,NULL,'2MASX J06002746-5851460',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.7I',0.2,NULL,NULL,NULL,NULL,NULL,1,90.114375,-58.86275,0.153,NULL,40367069161,630735455,9855241,14.7),(45377,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45377,36.44,0.52,194,11209,70,NULL,NULL,'2MASX J06002887-3850297',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.5I',0.7,NULL,NULL,NULL,NULL,NULL,1,90.120333,-38.84156,0.097,NULL,38961079685,608766870,9511982,13.5),(45378,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45378,35.18,0.56,109,11210,70,NULL,NULL,'2MASX J06002979-5610549',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6b',NULL,'SA(r?)0/a?',NULL,NULL,NULL,NULL,1,90.1242083,-56.18186,0.285,NULL,40282111902,629407998,9834499,15.6),(45379,'IRAS','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45379,31.49,0.8,19.9,11211,75,NULL,'MAT, I','UGCA 117',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.000013,NULL,'14.1',1.4,'SB(s)d:',NULL,NULL,NULL,NULL,1,90.1444583333,-28.99183,0.017,NULL,39082980825,610671575,9541743,14.1),(45380,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45380,31.07,0.4,16.4,11211,75,NULL,'B','UGCA 117',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45381,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45381,31.95,0.32,24.6,11211,85,NULL,'I, inv','UGCA 117',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45382,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45382,31.98,0.32,24.9,11211,85,NULL,'I, raw','UGCA 117',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45383,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45383,32.04,0.39,25.6,11211,73,NULL,'opt','UGCA 117',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45384,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45384,32.34,0.4,29.4,11211,NULL,NULL,NULL,'UGCA 117',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45385,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45385,32.36,0.39,29.7,11211,73,NULL,'opt','UGCA 117',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45386,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45386,32.45,0.59,30.8,11211,NULL,NULL,'Malmquist cor.','UGCA 117',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45387,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45387,32.44,0.59,30.8,11211,NULL,NULL,NULL,'UGCA 117',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45388,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45388,32.46,0.2,31.1,11211,74.4,NULL,NULL,'UGCA 117',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45389,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45389,32.93,0.43,38.6,11211,75,NULL,'MAT, I, raw','UGCA 117',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45390,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45390,32.95,0.43,39,11211,75,NULL,'MAT, I, inv','UGCA 117',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45391,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45391,33.07,0.43,41.1,11211,75,NULL,'MAT, I, cor','UGCA 117',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45392,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45392,35.96,0.5,155,11212,70,NULL,NULL,'2MASX J06003972-5823429',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.7I',0.4,NULL,NULL,NULL,NULL,NULL,1,90.1657083333,-58.39522,0.149,NULL,40367883774,630748183,9855440,13.7),(45393,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45393,35.99,0.59,157,11213,70,NULL,NULL,'2MASX J06004047-2614051',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,90.1686666667,-26.23481,0.017,NULL,39064064789,610376012,9537125,14.6),(45394,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45394,35.1,0.59,105,11214,70,NULL,NULL,'2MASX J06004121-5355382',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.8I',0.3,NULL,NULL,NULL,NULL,NULL,1,90.171625,-53.92728,0.293,NULL,40284302148,629442221,9835034,13.8),(45395,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45395,35.91,0.54,152,11215,70,NULL,NULL,'2MASX J06004344-5704195',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.0I',0.2,NULL,NULL,NULL,NULL,NULL,1,90.181,-57.07219,0.225,NULL,40366385675,630724776,9855074,14),(45396,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45396,36.17,0.66,172,11216,70,NULL,NULL,'2MASX J06004536-6031223',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,90.1890417,-60.52286,0.137,NULL,40373584970,630837265,9856832,16.2),(45397,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45397,33.55,0.58,51.3,11217,70,NULL,NULL,'2MFGC 04848',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'15.43',0.3,NULL,NULL,NULL,NULL,NULL,1,90.200417,-15.39928,0.861,NULL,38763031377,605672365,9463630,15.43),(45398,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45398,35.82,0.49,146,11218,70,NULL,NULL,'2MASX J06004903-5835296',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000117,NULL,'14.2b',1.3,'SB(s)0^0^ pec;E/D',NULL,NULL,NULL,NULL,1,90.205,-58.5915,0.149,NULL,40367224770,630737887,9855279,14.2),(45399,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45399,36.33,0.53,184,11219,70,NULL,NULL,'2MASX J06010147-5608007',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,90.256083,-56.13353,0.285,NULL,40282157312,629408708,9834511,15.9),(45400,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45400,36.21,0.52,174,11220,70,NULL,NULL,'2MASX J06010553-5837167',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,90.2735,-58.62139,0.149,NULL,40367213952,630737718,9855276,16.8),(45401,'IRAS','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45401,31.97,0.8,24.8,11221,75,NULL,'MAT, I','ESO 555- G 022',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.00001,NULL,'13.47',0.7,'SB(s)bc?',NULL,NULL,NULL,NULL,1,90.2832083,-21.73861,0.141,NULL,38722693370,605042083,9453782,13.47),(45402,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45402,31.3,0.2,18.2,11221,74.4,NULL,NULL,'ESO 555- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45403,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45403,31.54,0.32,20.3,11221,85,NULL,'I, raw','ESO 555- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45404,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45404,31.54,0.32,20.3,11221,85,NULL,'I, inv','ESO 555- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45405,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45405,31.9,0.61,24,11221,NULL,NULL,NULL,'ESO 555- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45406,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45406,31.96,0.43,24.7,11221,75,NULL,'MAT, I, raw','ESO 555- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45407,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45407,32,0.43,25.1,11221,75,NULL,'MAT, I, inv','ESO 555- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45408,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45408,32.01,0.39,25.2,11221,73,NULL,'opt','ESO 555- G 022',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45409,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45409,32.09,0.56,26.2,11221,NULL,NULL,'Malmquist cor.','ESO 555- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45410,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45410,32.31,0.43,28.9,11221,75,NULL,'MAT, I, cor','ESO 555- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45411,'SNII optical','2016-12-15 15:14:13','2016-12-16 11:19:18','1','SN 1995ad',NULL,45411,32.11,0.2,26.4,11222,NULL,NULL,'SCM','NGC 2139',NULL,'2015ApJ...799..215P',2015,1,2.6,NULL,'G',0.000017,NULL,'11.99',1.9,'SAB(rs)cd      HII','Group member',NULL,NULL,NULL,1,90.2825416667,-23.67264,0.033,NULL,39057651392,610275803,9535559,11.99),(45412,'IRAS','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45412,32.05,0.8,25.8,11222,75,NULL,'MAT, I','NGC 2139',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45413,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45413,31.75,0.4,22.4,11222,75,NULL,'B','NGC 2139',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45414,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45414,31.79,0.43,22.8,11222,75,NULL,'MAT, I, raw','NGC 2139',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45415,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45415,31.93,0.43,24.3,11222,75,NULL,'MAT, I, inv','NGC 2139',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45416,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45416,32.13,0.43,26.7,11222,75,NULL,'MAT, I, cor','NGC 2139',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45417,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45417,32.2,0.32,27.6,11222,85,NULL,'I, raw','NGC 2139',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45418,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45418,32.24,0.32,28.1,11222,85,NULL,'I, inv','NGC 2139',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45419,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45419,32.32,0.4,29.1,11222,NULL,NULL,'mean','NGC 2139',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45420,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45420,32.51,0.4,31.8,11222,73,NULL,'opt','NGC 2139',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45421,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45421,32.53,0.45,32.1,11222,NULL,NULL,'K','NGC 2139',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45422,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45422,32.57,0.46,32.7,11222,NULL,NULL,'J','NGC 2139',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45423,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45423,32.6,0.47,33.1,11222,NULL,NULL,'H','NGC 2139',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45424,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45424,32.61,0.56,33.2,11222,NULL,NULL,'Malmquist cor.','NGC 2139',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45425,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45425,32.8,0.52,36.3,11222,NULL,NULL,NULL,'NGC 2139',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45426,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45426,32.84,0.2,37,11222,74.4,NULL,NULL,'NGC 2139',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45427,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45427,36.87,0.6,237,11223,70,NULL,NULL,'2MASX J06010913-5825447',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,90.2880416667,-58.42906,0.149,NULL,40367887645,630748244,9855441,16.7),(45428,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45428,35.64,0.43,134,11224,NULL,NULL,NULL,'ESO 488- G 055',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.31',0.3,'Sb:',NULL,NULL,NULL,NULL,1,90.3490833333,-26.05494,0.017,NULL,39064587159,610384174,9537252,15.31),(45429,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45429,35.64,0.43,134,11224,NULL,NULL,'Malmquist cor.','ESO 488- G 055',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45430,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45430,35.68,0.2,137,11224,74.4,NULL,NULL,'ESO 488- G 055',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45431,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45431,35.93,0.58,154,11225,70,NULL,NULL,'2MASX J06012410-5838297',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,90.350333,-58.64153,0.149,NULL,40367210995,630737671,9855276,16.8),(45432,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45432,37.79,0.62,361,11226,70,NULL,NULL,'2MASX J06012665-3959210',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00007,NULL,'15.7V',NULL,'E/S0','Group member',NULL,NULL,NULL,1,90.360833,-39.98906,0.129,NULL,38932511599,608320493,9505007,15.7),(45433,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45433,35.9,0.53,151,11227,70,NULL,NULL,'2MASX J06013157-2008157',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.26',NULL,NULL,NULL,NULL,NULL,NULL,1,90.3814166667,-20.13778,0.165,NULL,38724864031,605076000,9454312,16.26),(45434,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45434,35.12,0.47,105,11228,70,NULL,NULL,'ESO 555- G 023',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.06',0.2,'S0-a',NULL,NULL,NULL,NULL,1,90.4005,-20.34167,0.145,NULL,38724913967,605076780,9454324,15.06),(45435,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45435,33.07,NULL,41.1,11229,NULL,NULL,'Dipole + Quadrupole + Octopole','FGCE 0553',NULL,'2010Ap&SS.325..163P',2010,1,0.9,NULL,'G',0.000017,NULL,'17.1',0.11,'Sd',NULL,NULL,NULL,NULL,1,90.430833,-34.945,0,NULL,38960401031,608756266,9511816,17.1),(45436,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45436,33.1,NULL,41.7,11229,NULL,NULL,'Dipole + Quadrupole','FGCE 0553',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45437,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45437,33.11,NULL,42,11229,NULL,NULL,'Dipole','FGCE 0553',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45438,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45438,33.15,NULL,42.6,11229,NULL,NULL,NULL,'FGCE 0553',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45439,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45439,36.86,0.57,236,11230,70,NULL,NULL,'2MASX J06015199-4829517',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.5I',0.4,NULL,NULL,NULL,NULL,NULL,1,90.466625,-48.49772,0.161,NULL,40272575882,629258998,9832171,14.5),(45440,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45440,35.81,0.53,145,11231,70,NULL,NULL,'2MASX J06015616-5025117',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.8b',0.4,NULL,NULL,NULL,NULL,NULL,1,90.483917,-50.41994,0.061,NULL,40269755162,629214924,9831483,15.8),(45441,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45441,35.16,0.47,108,11232,70,NULL,NULL,'MCG -03-16-007',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00013,NULL,'14.8b',0.3,NULL,NULL,NULL,NULL,NULL,1,90.486875,-20.13703,0.165,NULL,38724905203,605076643,9454322,14.8),(45442,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45442,35.99,0.71,158,11233,70,NULL,NULL,'2MASX J06020074-5812536',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,90.503125,-58.21486,0.153,NULL,40367642827,630744419,9855381,16.2),(45443,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45443,36.39,0.49,190,11234,NULL,NULL,'Malmquist cor.','2MASX J06020216-3950147',NULL,'2009ApJS..182..474S',2009,1,0.34,NULL,'G',0.000033,NULL,'16.2V',0.16,'S','Group member',NULL,NULL,NULL,1,90.508875,-39.83725,0.129,NULL,38932513265,608320519,9505008,16.2),(45444,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45444,36.72,0.43,221,11234,NULL,NULL,NULL,'2MASX J06020216-3950147',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45445,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45445,36.76,0.2,225,11234,74.4,NULL,NULL,'2MASX J06020216-3950147',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45446,'Tully est','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45446,31.71,0.8,22,11235,75,NULL,NULL,'UGC 03390',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000013,NULL,'16.5',1.4,'SABdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,90.5217917,36.10444,NULL,NULL,62832951983,981764874,15340076,16.5),(45447,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45447,35.17,0.57,108,11236,70,NULL,NULL,'ESO 121- G 002',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.16',0.9,'(R\'_1)SB(r)ab',NULL,NULL,NULL,NULL,1,90.5279583,-58.61189,0.149,NULL,40367209497,630737648,9855275,15.16),(45448,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45448,36.37,0.57,188,11237,70,NULL,NULL,'2MASX J06021297-2425301',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.0I',0.5,NULL,NULL,NULL,NULL,NULL,1,90.5540417,-24.42503,0.233,NULL,39059454561,610303977,9535999,14),(45449,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45449,36.87,0.55,237,11238,70,NULL,NULL,'2MFGC 04866',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000133,NULL,'15',0.5,'E','Group member',NULL,NULL,NULL,1,90.572,-39.94294,0.129,NULL,38932572470,608321444,9505022,15),(45450,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45450,36.83,0.57,232,11239,70,NULL,NULL,'2MASX J06021862-3906087',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.4,NULL,NULL,NULL,NULL,NULL,1,90.5775417,-39.10242,0.133,NULL,38977816263,609028379,9516068,14.3),(45451,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45451,35.78,0.56,143,11240,70,NULL,NULL,'ESO 254- G 009',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000123,NULL,'15.19',0.4,'(R_1R\'_2)SABa',NULL,NULL,NULL,NULL,1,90.608083,-44.89772,0.249,NULL,42413020416,662703444,10354741,15.19),(45452,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45452,35.21,0.59,110,11241,70,NULL,NULL,'2MASX J06023651-5356003',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,90.6522917,-53.93339,0.205,NULL,40284366349,629443224,9835050,16.3),(45453,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45453,33.16,NULL,42.9,11242,NULL,NULL,NULL,'FGCE 0554',NULL,'2000BSAO...50....5K',2000,1,0.76,NULL,'G',0.00009,'?','17.6',0.08,'Sd',NULL,NULL,NULL,NULL,1,90.6625,-28.07028,0,NULL,39116194122,611190533,9549852,17.6),(45454,'GRB','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',45454,42.99,0.2,2280,11243,NULL,NULL,NULL,'GRB 090328',0.736,'2010JCAP...08..020W',2010,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,90.6654583,-41.88272,0.213,NULL,38936935640,608389619,9506087,NULL),(45455,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45455,36.08,0.56,164,11244,70,NULL,NULL,'2MASX J06023948-5843334',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,90.664583,-58.72594,0.153,NULL,40367241198,630738143,9855283,15.9),(45456,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45456,36.49,0.66,199,11245,70,NULL,NULL,'2MASX J06024190-2218538',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.91',NULL,NULL,NULL,NULL,NULL,NULL,1,90.6744583,-22.315,0.085,NULL,39594435666,618663057,9666610,16.91),(45457,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45457,31.94,1.17,24.4,11246,NULL,NULL,NULL,'IC 0441',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000023,NULL,'14.3b',1.1,'SB(rs)c',NULL,NULL,NULL,NULL,1,90.677625,-12.49914,1.201,NULL,38759131588,605611431,9462678,14.3),(45458,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45458,31.98,0.2,24.9,11246,74.4,NULL,NULL,'IC 0441',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45459,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45459,32.13,0.39,26.7,11246,73,NULL,'opt','IC 0441',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45460,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45460,32.28,1,28.5,11246,NULL,NULL,'Malmquist cor.','IC 0441',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45461,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45461,35.83,0.7,147,11247,70,NULL,NULL,'ESO 121- G 004',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'16.46',0.2,'Sa:',NULL,NULL,NULL,NULL,1,90.691667,-58.79597,0.153,NULL,40367235946,630738061,9855282,16.46),(45462,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45462,37.64,0.66,337,11248,70,NULL,NULL,'2MASX J06025039-5238489',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,90.710125,-52.64697,0.193,NULL,40292337923,629567780,9836996,16.9),(45463,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45463,36.59,0.53,208,11249,70,NULL,NULL,'MCG -04-15-006',NULL,'2014MNRAS.445.2677S',2014,1,2.2,NULL,'G',0.000117,NULL,'15.5',1.8,'SA0-',NULL,NULL,NULL,NULL,1,90.7130417,-23.69097,0.061,NULL,39061240564,610331883,9536435,15.5),(45464,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45464,36.98,0.64,249,11250,70,NULL,NULL,'2MASX J06030453-2644152',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.6I',0.2,NULL,NULL,NULL,NULL,NULL,1,90.768875,-26.73764,0.021,NULL,39065032077,610391126,9537361,14.6),(45465,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45465,36.69,0.53,217,11251,70,NULL,NULL,'2MASX J06030521-3252088',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,90.7717083,-32.86908,0,NULL,39075149149,610549205,9539831,14.4),(45466,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45466,35.17,0.7,108,11252,70,NULL,NULL,'2MASX J06032185-6449112',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,90.8412083,-64.81975,0.145,NULL,40346080040,630407500,9850117,15.3),(45467,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45467,35.81,0.55,145,11253,70,NULL,NULL,'2MASX J06032683-6637064',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.5b',0.15,NULL,NULL,NULL,NULL,NULL,1,90.86175,-66.61844,0.197,NULL,40333155043,630205547,9846961,16.5),(45468,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45468,36.5,0.58,199,11254,70,NULL,NULL,'2MASX J06032806-2633350',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,90.867,-26.55964,0,NULL,39065532559,610398946,9537483,15.1),(45469,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45469,36.54,0.59,203,11255,70,NULL,NULL,'2MASX J06033214-2749150',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,90.883917,-27.82089,0.057,NULL,39116950223,611202347,9550036,14.6),(45470,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45470,37.04,0.76,256,11256,70,NULL,NULL,'2MASX J06033625-2639270',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.4I',0.4,NULL,NULL,NULL,NULL,NULL,1,90.9010417,-26.65756,0,NULL,39065542367,610399099,9537485,14.4),(45471,'Tully est','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45471,31.93,0.8,24.3,11257,75,NULL,NULL,'UGCA 118',NULL,'1988NBGC.C....0000T',1988,1,2.3,NULL,'G',0.000001,NULL,'13.53',1.9,'SB(s)d pec',NULL,NULL,NULL,NULL,1,90.903333,-20.65419,0.193,NULL,38725900566,605092196,9454565,13.53),(45472,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45472,37.41,0.72,303,11258,70,NULL,NULL,'2MASX J06033961-2641550',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,90.915083,-26.69861,0,NULL,39065496182,610398377,9537474,15.8),(45473,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45473,36.47,0.7,197,11259,70,NULL,NULL,'2MASX J06034113-1835322',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.49',0.3,NULL,NULL,NULL,NULL,NULL,1,90.9212083,-18.59231,0.481,NULL,38731723707,605183182,9455987,16.49),(45474,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45474,36.18,0.55,172,11260,70,NULL,NULL,'2MASX J06034185-4518185',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,90.9244583,-45.30522,0.201,NULL,42412929899,662702029,10354719,14.1),(45475,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45475,36.01,0.58,159,11261,70,NULL,NULL,'2MASX J06034225-3209422',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,90.926083,-32.16181,0,NULL,39078104901,610595389,9540552,15.4),(45476,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45476,35.53,0.59,127,11262,70,NULL,NULL,'2MASX J06034326-3446492',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,90.9302916667,-34.78039,0,NULL,38960652295,608760192,9511878,15),(45477,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45477,37.7,0.59,347,11263,70,NULL,NULL,'2MASX J06035693-4917254',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.4,NULL,NULL,NULL,NULL,NULL,1,90.987125,-49.29044,0.157,NULL,40273096543,629267133,9832298,14.5),(45478,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45478,35.37,0.44,119,11264,NULL,NULL,NULL,'ESO 364- G 027',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.21',0.5,'Sc',NULL,NULL,NULL,NULL,1,91.015583,-35.69383,0.037,NULL,38958172787,608721449,9511272,15.21),(45479,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45479,35.41,0.2,121,11264,74.4,NULL,NULL,'ESO 364- G 027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45480,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45480,35.53,0.41,128,11264,NULL,NULL,'Malmquist cor.','ESO 364- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45481,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45481,35.87,0.75,150,11265,70,NULL,NULL,'2MASX J06040742-1255008',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'14.2I',0.21,NULL,NULL,NULL,NULL,NULL,1,91.0310417,-12.91686,1.097,NULL,38756928262,605577004,9462140,14.2),(45482,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45482,34.84,0.51,92.7,11266,70,NULL,NULL,'2MASX J06040952-5437220',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000087,NULL,'15.6b',0.5,NULL,NULL,NULL,NULL,NULL,1,91.039625,-54.62275,0.213,NULL,40284526026,629445719,9835089,15.6),(45483,'BL Lac Luminosity','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45483,40.58,NULL,1310,11267,NULL,NULL,'Min. z = 0.37','1FGL J0604.2-4817',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,91.052,-48.284,0.245,NULL,40280066919,629376045,9834000,NULL),(45484,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45484,36.96,0.61,246,11268,70,NULL,NULL,'2MASX J06041493-5939360',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,91.0620416667,-59.66,0.157,NULL,40372441963,630819405,9856553,16.8),(45485,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45485,35.93,0.57,154,11269,70,NULL,NULL,'2MASX J06041905-2704538',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.3,NULL,NULL,NULL,NULL,NULL,1,91.0793333333,-27.08156,0,NULL,39062068938,610344827,9536637,14.1),(45486,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45486,36.43,0.66,193,11270,70,NULL,NULL,'2MASX J06042409-2217275',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,91.100417,-22.291,0.085,NULL,39595178125,618674658,9666791,15),(45487,'IRAS','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45487,33.04,0.8,40.6,11271,75,NULL,'MAT, I','ESO 555- G 029',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.00002,NULL,'15.29',0.21,'Sc',NULL,NULL,NULL,NULL,1,91.1144166667,-20.35375,0.333,NULL,38725056803,605079012,9454359,15.29),(45488,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45488,33.06,0.4,40.9,11271,73,NULL,'opt','ESO 555- G 029',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45489,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45489,33.06,0.4,41,11271,73,NULL,'IR','ESO 555- G 029',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45490,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',45490,33.06,0.4,41,11271,75,NULL,NULL,'ESO 555- G 029',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45491,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45491,33.11,0.32,41.9,11271,85,NULL,'I, raw','ESO 555- G 029',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45492,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45492,33.12,0.32,42.1,11271,85,NULL,'I, inv','ESO 555- G 029',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45493,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45493,33.17,0.43,43,11271,75,NULL,'MAT, I, raw','ESO 555- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45494,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45494,33.22,0.43,44.1,11271,75,NULL,'MAT, I, cor','ESO 555- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45495,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45495,33.27,0.43,45.1,11271,75,NULL,'MAT, I, inv','ESO 555- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45496,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',45496,33.39,0.49,47.7,11271,75,NULL,'IR','ESO 555- G 029',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45497,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45497,33.4,0.2,47.9,11271,74.4,NULL,NULL,'ESO 555- G 029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45498,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45498,33.44,0.43,48.7,11271,75,NULL,'3.6 micron, color corrected','ESO 555- G 029',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45499,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45499,33.5,0.43,50.1,11271,75,NULL,'3.6 micron, color + selection bias corrected','ESO 555- G 029',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45500,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45500,33.5,0.55,50.2,11271,NULL,NULL,'Malmquist cor.','ESO 555- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45501,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45501,33.57,0.53,51.9,11271,NULL,NULL,NULL,'ESO 555- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45502,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45502,33.73,NULL,55.8,11271,NULL,NULL,NULL,'ESO 555- G 029',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45503,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45503,33.77,NULL,56.7,11271,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 555- G 029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45504,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45504,33.78,NULL,56.9,11271,NULL,NULL,'Dipole','ESO 555- G 029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45505,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45505,33.78,NULL,57,11271,NULL,NULL,'Dipole + Quadrupole','ESO 555- G 029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45506,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45506,34.67,0.58,85.9,11272,70,NULL,NULL,'2MASX J06043032-1911275',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.97',NULL,'(R)SAB(r)0^+',NULL,NULL,NULL,NULL,1,91.1262083333,-19.19089,0.373,NULL,38736470826,605257356,9457146,15.97),(45507,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45507,35.62,0.51,133,11273,70,NULL,NULL,'ESO 160- G 011',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'14.83',0.7,'(R\')SA(rs)a pec:',NULL,NULL,NULL,NULL,1,91.129917,-53.09708,0.137,NULL,40292510288,629570473,9837038,14.83),(45508,'SNIa','2016-12-15 15:14:13','2016-12-16 11:19:18','1','SN 2003kf',NULL,45508,31.85,0.33,23.3,11274,74.2,NULL,'SALT 2','MCG -02-16-002',0.0077,'2010ApJ...716..712A',2010,1,2.5,NULL,'G',0.000017,NULL,'12.5B',0.5,'Sb? sp',NULL,NULL,NULL,NULL,1,91.1454583,-12.62486,1.341,NULL,38758730911,605605170,9462580,12.5),(45509,'SNIa','2016-12-15 15:14:13','2016-12-16 11:19:18','1','SN 2003kf',NULL,45509,32.43,0.1,30.6,11274,74.4,NULL,NULL,'MCG -02-16-002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45510,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45510,31.69,0.4,21.8,11274,73,NULL,'IR','MCG -02-16-002',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45511,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',45511,31.7,0.4,21.8,11274,75,NULL,NULL,'MCG -02-16-002',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45512,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45512,31.78,0.4,22.7,11274,75,NULL,'HOSTS SN 2003kf','MCG -02-16-002',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45513,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45513,31.79,0.4,22.8,11274,75,NULL,'HOSTS SN 2003kf','MCG -02-16-002',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45514,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45514,31.84,0.42,23.3,11274,NULL,18.48,'3.6 micron','MCG -02-16-002',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45515,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45515,31.84,0.43,23.3,11274,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-16-002',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45516,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',45516,32.4,0.49,30.3,11274,75,NULL,'IR','MCG -02-16-002',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45517,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45517,36.06,0.51,163,11275,70,NULL,NULL,'2MASX J06043766-6505593',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,91.1567917,-65.09986,0.153,NULL,40334683241,630229425,9847334,15.9),(45518,'IRAS','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45518,32.04,0.8,25.6,11276,75,NULL,'MAT, I','UGCA 119',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.00001,NULL,'13.61',1.2,'SB(rs)cd',NULL,NULL,NULL,NULL,1,91.1790417,-26.12494,0,NULL,39064796847,610387450,9537303,13.61),(45519,'Tully est','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45519,31.7,0.8,21.9,11276,75,NULL,NULL,'UGCA 119',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45520,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45520,31.87,0.2,23.7,11276,74.4,NULL,NULL,'UGCA 119',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45521,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45521,31.92,0.32,24.2,11276,85,NULL,'I, raw','UGCA 119',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45522,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45522,31.93,0.32,24.3,11276,85,NULL,'I, inv','UGCA 119',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45523,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45523,32.03,0.4,25.5,11276,NULL,NULL,NULL,'UGCA 119',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45524,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45524,32.03,0.4,25.5,11276,73,NULL,'opt','UGCA 119',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45525,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45525,32.15,0.43,27,11276,75,NULL,'MAT, I, raw','UGCA 119',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45526,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45526,32.22,0.43,27.7,11276,75,NULL,'MAT, I, inv','UGCA 119',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45527,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45527,32.23,0.47,28,11276,NULL,NULL,NULL,'UGCA 119',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45528,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45528,32.26,0.4,28.3,11276,73,NULL,'opt','UGCA 119',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45529,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45529,32.35,0.45,29.5,11276,NULL,NULL,'Malmquist cor.','UGCA 119',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45530,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45530,32.45,0.43,30.9,11276,75,NULL,'MAT, I, cor','UGCA 119',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45531,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45531,35.98,0.67,157,11277,70,NULL,NULL,'2MASX J06044377-2245546',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,91.182417,-22.76517,0.093,NULL,39058126327,610283223,9535675,15.1),(45532,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45532,33.17,0.56,43.1,11278,70,NULL,NULL,'NGC 2199',NULL,'2014MNRAS.445.2677S',2014,1,1.9,NULL,'G',0.000033,NULL,'13.73',0.8,'(R_1R\'_2)SAB(r)a',NULL,NULL,NULL,NULL,1,91.1872917,-73.39983,0.365,NULL,39921405561,623771961,9746436,13.73),(45533,'IRAS','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45533,33.89,0.8,60.1,11278,75,NULL,'MAT, I','NGC 2199',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45534,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45534,33.39,0.47,47.6,11278,NULL,NULL,'H','NGC 2199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45535,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45535,33.44,0.46,48.7,11278,NULL,NULL,'J','NGC 2199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45536,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45536,33.44,0.45,48.8,11278,NULL,NULL,'K','NGC 2199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45537,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45537,33.95,0.4,61.6,11278,NULL,NULL,'mean','NGC 2199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45538,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45538,34.18,0.43,68.5,11278,75,NULL,'MAT, I, raw','NGC 2199',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45539,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45539,34.18,0.39,68.6,11278,NULL,NULL,'Malmquist cor.','NGC 2199',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45540,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45540,34.3,0.32,72.3,11278,85,NULL,'I, raw','NGC 2199',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45541,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45541,34.37,0.36,74.7,11278,NULL,NULL,NULL,'NGC 2199',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45542,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45542,34.38,0.32,75.3,11278,85,NULL,'I, inv','NGC 2199',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45543,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45543,34.41,0.2,76.2,11278,74.4,NULL,NULL,'NGC 2199',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45544,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45544,34.46,0.43,78,11278,75,NULL,'MAT, I, cor','NGC 2199',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45545,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45545,34.53,0.43,80.4,11278,75,NULL,'MAT, I, inv','NGC 2199',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45546,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45546,35.6,0.49,132,11279,70,NULL,NULL,'ESO 160- G 012',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.49',0.2,'Sa:',NULL,NULL,NULL,NULL,1,91.228667,-54.22631,0.209,NULL,40285092201,629454565,9835227,15.49),(45547,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45547,35.59,0.58,131,11280,70,NULL,NULL,'2MASX J06050462-2631430',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,91.26925,-26.52867,0,NULL,39065583767,610399746,9537496,14.4),(45548,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45548,34.91,1.05,96.1,11281,NULL,NULL,NULL,'ESO 205- G 018',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'14.38',1.1,'Sb-c',NULL,NULL,NULL,NULL,1,91.2947083333,-49.29975,0.117,NULL,40273604711,629275073,9832423,14.38),(45549,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45549,34.95,0.2,97.7,11281,74.4,NULL,NULL,'ESO 205- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45550,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45550,35.13,0.95,106,11281,NULL,NULL,'Malmquist cor.','ESO 205- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45551,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45551,31.84,0.4,23.3,11282,NULL,NULL,'mean','IC 2158',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.00003,NULL,'12.89',1.3,'SB(rs)ab',NULL,NULL,NULL,NULL,1,91.3248333333,-27.85697,0,NULL,39116912428,611201756,9550027,12.89),(45552,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45552,31.87,0.45,23.7,11282,NULL,NULL,'K','IC 2158',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45553,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45553,31.92,0.47,24.3,11282,NULL,NULL,'H','IC 2158',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45554,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45554,31.95,0.46,24.6,11282,NULL,NULL,'J','IC 2158',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45555,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',45555,34.34,0.31,73.8,11283,NULL,NULL,'B, Hubble-type-TF','ESO 254- G 012',NULL,'2005Ap&SS.298..577R',2005,1,0.9,NULL,'G',0.000033,NULL,'15.13',0.7,'SAB(r)c',NULL,NULL,NULL,NULL,1,91.344417,-45.82569,0.189,NULL,40265958215,629155597,9830556,15.13),(45556,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45556,35.27,0.55,113,11283,NULL,NULL,NULL,'ESO 254- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45557,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45557,35.31,0.2,115,11283,74.4,NULL,NULL,'ESO 254- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45558,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45558,35.47,0.5,124,11283,NULL,NULL,'Malmquist cor.','ESO 254- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45559,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45559,35.4,0.58,120,11284,70,NULL,NULL,'2MASX J06052721-1348563',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.10',NULL,NULL,NULL,NULL,NULL,NULL,1,91.363125,-13.81542,1.001,NULL,38770556096,605789939,9465467,16.1),(45560,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45560,35.91,0.34,152,11285,NULL,NULL,'Malmquist cor.','ESO 254- G 013',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'15.14',0.6,'Sc',NULL,NULL,NULL,NULL,1,91.364625,-45.18017,0.201,NULL,42413740503,662714695,10354917,15.14),(45561,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45561,36.06,0.32,163,11285,NULL,NULL,NULL,'ESO 254- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45562,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45562,36.1,0.2,166,11285,74.4,NULL,NULL,'ESO 254- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45563,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',45563,35.15,0.49,107,11286,75,NULL,'IR','ESO 555- G 033',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.000033,NULL,'15',0.3,'S...',NULL,NULL,NULL,NULL,1,91.3732083,-19.03356,0.437,NULL,38736110027,605251719,9457058,15),(45564,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45564,35.34,0.46,117,11286,NULL,NULL,'Malmquist cor.','ESO 555- G 033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45565,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45565,35.66,0.4,135,11286,NULL,NULL,NULL,'ESO 555- G 033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45566,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45566,35.7,0.2,138,11286,74.4,NULL,NULL,'ESO 555- G 033',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45567,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45567,35.3,0.68,115,11287,70,NULL,NULL,'2MFGC 04910',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'11.5K',NULL,NULL,NULL,NULL,NULL,NULL,1,91.3980417,-55.45319,0.257,NULL,40282426520,629412914,9834576,11.5),(45568,'Tully est','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45568,31.75,0.8,22.4,11288,75,NULL,NULL,'ESO 005- G 004',NULL,'1988NBGC.C....0000T',1988,1,3.8,NULL,'G',0.000013,NULL,'13.53',0.8,'Sb: sp         Sy2',NULL,NULL,NULL,NULL,1,91.4234583,-86.63186,0.629,NULL,39738028424,620906694,9701667,13.53),(45569,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45569,31.92,0.43,24.2,11288,75,NULL,'3.6 micron, color + selection bias corrected','ESO 005- G 004',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45570,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45570,32.12,0.43,26.6,11288,75,NULL,'3.6 micron, color corrected','ESO 005- G 004',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45571,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45571,32.34,0.2,29.4,11288,74.4,NULL,NULL,'ESO 005- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45572,'TRGB','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45572,29.78,0.1,9.02,11289,74.4,NULL,NULL,'ESO 364- G?029',NULL,'2013AJ....146...86T',2013,1,2.6,NULL,'G',0.00001,NULL,'13.5B',1.9,'IB(s)m',NULL,NULL,NULL,NULL,1,91.438417,-33.08083,0.037,NULL,39141976972,611593390,9556146,13.5),(45573,'Tully est','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45573,29.58,0.8,8.3,11289,75,NULL,NULL,'ESO 364- G?029',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45574,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45574,36.91,0.54,241,11290,70,NULL,NULL,'2MASX J06054592-6008263',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,91.441375,-60.14061,0.113,NULL,40373117277,630829957,9856718,16.7),(45575,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45575,36.07,0.63,164,11291,70,NULL,NULL,'2MASX J06054691-4453400',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'13.9I',0.4,NULL,NULL,NULL,NULL,NULL,1,91.4455417,-44.89439,0.245,NULL,42413823572,662715993,10354937,13.9),(45576,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45576,37.87,0.56,375,11292,70,NULL,NULL,'2MASX J06054950-4928362',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,91.4562083,-49.47681,0.117,NULL,40273663693,629275995,9832437,16.8),(45577,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45577,34.9,0.48,95.4,11293,NULL,NULL,NULL,'ESO 160- G 013',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'15.27',0.7,'Sc',NULL,NULL,NULL,NULL,1,91.468,-53.59892,0.249,NULL,40296601686,629634401,9838037,15.27),(45578,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45578,34.94,0.2,97.3,11293,74.4,NULL,NULL,'ESO 160- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45579,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45579,35.18,0.42,109,11293,NULL,NULL,'Malmquist cor.','ESO 160- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45580,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45580,35.83,0.55,147,11294,70,NULL,NULL,'2MASX J06061291-2428220',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.0I',0.5,NULL,NULL,NULL,NULL,NULL,1,91.5537917,-24.47286,0.073,NULL,39072609282,610509520,9539211,14),(45581,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45581,36.05,0.61,162,11295,70,NULL,NULL,'2MASX J06061564-3449212',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,91.5651666667,-34.82258,0,NULL,38960823582,608762868,9511919,15.3);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (45582,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45582,34.69,0.55,86.8,11296,NULL,NULL,'Malmquist cor.','UGC 03398',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000037,NULL,'16.0',0.6,'Scd:',NULL,NULL,NULL,NULL,1,91.59625,60.56806,0.545,NULL,61635141512,963049086,15047641,16),(45583,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45583,34.86,0.5,94,11296,NULL,NULL,NULL,'UGC 03398',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45584,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45584,35.03,0.2,101,11296,74.4,NULL,NULL,'UGC 03398',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45585,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45585,35.72,0.54,139,11297,70,NULL,NULL,'2MASX J06062324-6107365',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,91.5969583,-61.12681,0.097,NULL,40370518269,630789347,9856083,16.5),(45586,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45586,36.06,0.59,163,11298,70,NULL,NULL,'2MASX J06062547-4503519',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.2,NULL,NULL,NULL,NULL,NULL,1,91.60625,-45.06442,0.265,NULL,42413809043,662715766,10354933,14.1),(45587,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45587,34.46,0.4,78,11299,NULL,NULL,'mean','ESO 307- G 017',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.00001,NULL,'15.28',0.4,'Sa? pec sp     HII',NULL,NULL,NULL,NULL,1,91.61375,-39.86453,0.177,NULL,38932102022,608314094,9504907,15.28),(45588,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',45588,34.58,0.49,82.3,11299,75,NULL,'IR','ESO 307- G 017',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45589,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45589,34.65,0.45,84.9,11299,NULL,NULL,'K','ESO 307- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45590,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45590,34.66,0.47,85.4,11299,NULL,NULL,'H','ESO 307- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45591,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45591,36.99,0.66,250,11300,70,NULL,NULL,'2MASX J06062858-2257378',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,91.619083,-22.96044,0.209,NULL,39060807061,610325110,9536329,15.7),(45592,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',45592,34.03,0.49,64.1,11301,75,NULL,'IR','2MFGC 04923',NULL,'2011yCatp016004901K',2011,1,0.7,NULL,'G',0.000013,NULL,'13.3K',0.1,'S',NULL,NULL,NULL,NULL,1,91.62175,26.39386,NULL,NULL,62892938589,982702165,15354721,13.3),(45593,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45593,36.65,0.51,214,11302,70,NULL,NULL,'2MASX J06064277-3302162',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14',NULL,'E/S0','Group member',NULL,NULL,NULL,1,91.678167,-33.03789,0.037,NULL,39141922918,611592545,9556133,14),(45594,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45594,35.82,0.33,146,11303,NULL,NULL,'Malmquist cor.','ESO 086- G 059',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.20',0.5,'S...',NULL,NULL,NULL,NULL,1,91.686917,-67.11728,0.245,NULL,40333366332,630208848,9847013,15.2),(45595,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45595,36.11,0.29,166,11303,NULL,NULL,NULL,'ESO 086- G 059',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45596,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45596,36.15,0.2,170,11303,74.4,NULL,NULL,'ESO 086- G 059',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45597,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45597,35.3,0.23,115,11304,74.4,NULL,NULL,'2MASX J06064749-3348522',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000117,NULL,'13',1,'E/S0','Group member',NULL,NULL,NULL,1,91.697917,-33.81453,0.033,NULL,39141528920,611586389,9556037,13),(45598,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45598,35.51,0.47,127,11304,70,NULL,NULL,'2MASX J06064749-3348522',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45599,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45599,36.33,0.59,185,11305,70,NULL,NULL,'ESO 254-IG 018 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000137,NULL,'16.87',NULL,NULL,NULL,NULL,NULL,NULL,1,91.702125,-45.04325,0.265,NULL,42413631828,662712997,10354890,16.87),(45600,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45600,34.95,0.49,97.8,11306,70,NULL,NULL,'IC 2164',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'14.52',0.9,'SA(rs)b','Pair member (points to parent)',NULL,NULL,NULL,1,91.71775,-75.36469,0.457,NULL,39889907878,623279810,9738747,14.52),(45601,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45601,34.52,0.55,80,11307,70,NULL,NULL,'2MASX J06070178-6921180',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.000087,NULL,'15.4b',0.3,NULL,NULL,NULL,NULL,NULL,1,91.757167,-69.35494,0.325,NULL,39866462664,622913479,9733023,15.4),(45602,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45602,38.16,0.58,428,11308,70,NULL,NULL,'2MASX J06070288-4929163',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,91.762125,-49.48789,0.097,NULL,40273649722,629275776,9832434,17.1),(45603,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45603,36.86,0.66,236,11309,70,NULL,NULL,'2MASX J06070346-4236137',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,91.7645,-42.60378,0.277,NULL,38925819308,608215926,9503373,15.9),(45604,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45604,36.33,0.6,184,11310,70,NULL,NULL,'2MASX J06070736-4511087',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,91.780583,-45.18572,0.237,NULL,42413155373,662705552,10354774,17.2),(45605,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45605,34.96,0.65,98,11311,70,NULL,NULL,'2MASX J06070733-4456347',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.8I',0.5,NULL,NULL,NULL,NULL,NULL,1,91.780667,-44.94306,0.265,NULL,42413651807,662713309,10354895,13.8),(45606,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45606,34.92,0.66,96.3,11312,70,NULL,NULL,'ESO 254- G 019',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.79',1,'SA(r)0^+',NULL,NULL,NULL,NULL,1,91.7929583,-45.18194,0.237,NULL,42413155505,662705554,10354774,15.79),(45607,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45607,36.12,0.53,168,11313,70,NULL,NULL,'FAIRALL 0804',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,91.8242917,-53.14703,0.137,NULL,40292010478,629562663,9836916,13.6),(45608,'TRGB','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45608,29.92,0.1,9.64,11314,74.4,NULL,NULL,'AM 0605-341',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000023,NULL,'14.09',0.7,'SBdm','Group member',NULL,NULL,NULL,1,91.832083,-34.20444,0.041,NULL,38960111813,608751747,9511746,14.09),(45609,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45609,35.86,0.48,149,11315,70,NULL,NULL,'ESO 489- G 005',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00012,NULL,'14.93',0.6,'S0','Pair member (points to parent)',NULL,NULL,NULL,1,91.834,-23.36753,0.181,NULL,39060252820,610316450,9536194,14.93),(45610,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45610,37.52,0.79,319,11316,70,NULL,NULL,'2MASX J06072051-4511568',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.8I',0.2,NULL,NULL,NULL,NULL,NULL,1,91.835417,-45.19917,0.237,NULL,42413157531,662705586,10354774,14.8),(45611,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45611,36.51,0.67,200,11317,70,NULL,NULL,'2MASX J06072525-2317468',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.0I',0.5,NULL,NULL,NULL,NULL,NULL,1,91.8552917,-23.29633,0.181,NULL,39060295882,610317123,9536205,14),(45612,'IRAS','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45612,31.01,0.8,15.9,11318,75,NULL,'MAT, I','ESO 121- G 006',NULL,'1997ApJS..109..333W',1997,1,5.38,NULL,'G',0.00001,NULL,'13.4B',0.67,'Scpec: sp',NULL,NULL,NULL,NULL,1,91.874417,-61.80758,0.141,NULL,40387549780,631055465,9860241,13.4),(45613,'Tully est','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45613,30.65,0.8,13.5,11318,75,NULL,NULL,'ESO 121- G 006',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45614,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45614,30.97,0.43,15.6,11318,75,NULL,'3.6 micron, color + selection bias corrected','ESO 121- G 006',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45615,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',45615,31.09,0.4,16.6,11318,75,NULL,NULL,'ESO 121- G 006',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45616,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45616,31.1,0.39,16.6,11318,73,NULL,'IR','ESO 121- G 006',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45617,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45617,31.35,0.39,18.6,11318,73,NULL,'opt','ESO 121- G 006',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45618,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45618,31.35,0.43,18.6,11318,75,NULL,'3.6 micron, color corrected','ESO 121- G 006',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45619,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45619,31.35,0.32,18.6,11318,85,NULL,'I, raw','ESO 121- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45620,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45620,31.37,0.32,18.8,11318,85,NULL,'I, inv','ESO 121- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45621,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45621,31.44,0.43,19.4,11318,75,NULL,'MAT, I, raw','ESO 121- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45622,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45622,31.44,0.48,19.4,11318,NULL,NULL,'Malmquist cor.','ESO 121- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45623,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45623,31.49,0.36,19.9,11318,NULL,NULL,NULL,'ESO 121- G 006',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45624,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45624,31.5,0.4,20,11318,NULL,NULL,'mean','ESO 121- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45625,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45625,31.57,0.43,20.6,11318,75,NULL,'MAT, I, inv','ESO 121- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45626,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45626,31.59,0.43,20.8,11318,75,NULL,'MAT, I, cor','ESO 121- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45627,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45627,31.66,0.2,21.5,11318,74.4,NULL,NULL,'ESO 121- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45628,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45628,31.66,0.45,21.5,11318,NULL,NULL,'K','ESO 121- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45629,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45629,31.68,0.47,21.7,11318,NULL,NULL,'H','ESO 121- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45630,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45630,31.75,NULL,22.4,11318,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 121- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45631,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45631,31.75,0.46,22.4,11318,NULL,NULL,'J','ESO 121- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45632,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45632,31.76,NULL,22.5,11318,NULL,NULL,'Dipole + Quadrupole','ESO 121- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45633,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45633,31.78,NULL,22.7,11318,NULL,NULL,'Dipole','ESO 121- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45634,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45634,31.8,0.41,23,11318,NULL,NULL,NULL,'ESO 121- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45635,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45635,31.82,NULL,23.1,11318,NULL,NULL,NULL,'ESO 121- G 006',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45636,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',45636,32.1,0.49,26.3,11318,75,NULL,'IR','ESO 121- G 006',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45637,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45637,35.74,0.52,140,11319,NULL,NULL,NULL,'AGC 460093',NULL,'2009ApJS..182..474S',2009,1,0.28,NULL,'G',0.000033,NULL,'15',0.22,'SBb','Group member',NULL,NULL,NULL,1,91.8922083333,-33.20389,0.073,NULL,39144734707,611636479,9556819,15),(45638,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45638,35.78,0.2,143,11319,74.4,NULL,NULL,'AGC 460093',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45639,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45639,35.96,0.47,156,11319,NULL,NULL,'Malmquist cor.','AGC 460093',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45640,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45640,35.59,0.58,131,11320,70,NULL,NULL,'2MASX J06073442-2838232',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.6I',0.4,NULL,NULL,NULL,NULL,NULL,1,91.8934583,-28.63978,0,NULL,39085124858,610705075,9542266,13.6),(45641,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45641,37.47,0.63,311,11321,70,NULL,NULL,'2MASX J06073986-4935457',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.9I',0.2,NULL,NULL,NULL,NULL,NULL,1,91.916125,-49.59611,0.097,NULL,40273555995,629274312,9832411,14.9),(45642,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',45642,34.26,0.49,71.1,11322,75,NULL,'IR','ESO 555- G 036',NULL,'2011yCatp016004901K',2011,1,1.93,NULL,'G',0.000023,NULL,'15.54',0.12,'SB(s)c? sp     HII',NULL,NULL,NULL,NULL,1,91.924125,-19.91222,0.433,NULL,38723277398,605051209,9453925,15.54),(45643,'IRAS','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45643,32.49,0.8,31.5,11323,75,NULL,'MAT, I','ESO 489- G 006',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.00002,NULL,'13.41',1.1,'SB(s)d:','Pair member (points to parent)',NULL,NULL,NULL,1,91.9362083333,-23.48664,0.177,NULL,39060158561,610314977,9536171,13.41),(45644,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45644,31.82,0.43,23.2,11323,75,NULL,'3.6 micron, color + selection bias corrected','ESO 489- G 006',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45645,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45645,31.93,0.43,24.3,11323,75,NULL,'3.6 micron, color corrected','ESO 489- G 006',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45646,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45646,32,0.4,25.1,11323,NULL,NULL,NULL,'ESO 489- G 006',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45647,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45647,32,0.39,25.1,11323,73,NULL,'opt','ESO 489- G 006',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45648,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45648,32.05,0.2,25.7,11323,74.4,NULL,NULL,'ESO 489- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45649,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45649,32.08,0.32,26.1,11323,85,NULL,'I, raw','ESO 489- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45650,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45650,32.09,0.32,26.2,11323,85,NULL,'I, inv','ESO 489- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45651,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45651,32.29,0.48,28.6,11323,NULL,NULL,NULL,'ESO 489- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45652,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45652,32.34,0.43,29.4,11323,75,NULL,'MAT, I, raw','ESO 489- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45653,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45653,32.34,0.4,29.4,11323,73,NULL,'opt','ESO 489- G 006',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45654,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45654,32.42,0.43,30.5,11323,75,NULL,'MAT, I, inv','ESO 489- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45655,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45655,32.43,0.45,30.7,11323,NULL,NULL,'Malmquist cor.','ESO 489- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45656,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45656,32.62,0.43,33.4,11323,75,NULL,'MAT, I, cor','ESO 489- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45657,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45657,32.68,0.4,34.4,11323,NULL,NULL,'mean','ESO 489- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45658,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45658,33.18,0.47,43.2,11323,NULL,NULL,'H','ESO 489- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45659,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',45659,34.44,0.35,77.3,11324,NULL,NULL,'B, Hubble-type-TF','ESO 254- G 022',NULL,'2005Ap&SS.298..577R',2005,1,1.3,NULL,'G',0.000033,NULL,'14.57',0.7,'SA(r)c',NULL,NULL,NULL,NULL,1,91.9362917,-47.41628,0.173,NULL,40266691496,629167054,9830735,14.57),(45660,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',45660,34.44,0.35,77.3,11324,NULL,NULL,'B, Hubble-type-TF','ESO 254- G 022',NULL,'2005Ap&SS.299..387R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45661,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',45661,34.44,NULL,77.3,11324,NULL,NULL,'B, Hubble-type-TF','ESO 254- G 022',NULL,'2005Ap&SS.299..405R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45662,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45662,35.6,0.33,132,11324,NULL,NULL,NULL,'ESO 254- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45663,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45663,35.63,0.32,133,11324,NULL,NULL,'Malmquist cor.','ESO 254- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45664,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45664,35.64,0.2,134,11324,74.4,NULL,NULL,'ESO 254- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45665,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45665,37.12,0.79,265,11325,70,NULL,NULL,'AM 0605-332 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15',0.3,'S0/a','Group member',NULL,NULL,NULL,1,91.9417083,-33.50286,0.049,NULL,39145108525,611642320,9556911,15),(45666,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45666,36.42,0.51,192,11326,70,NULL,NULL,'ESO 254- G 023',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.27',0.6,'S0',NULL,NULL,NULL,NULL,1,91.976625,-45.64078,0.209,NULL,42413085399,662704459,10354757,15.27),(45667,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45667,35.81,0.58,145,11327,70,NULL,NULL,'2MASX J06075582-1149163',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,91.9827083,-11.82114,1.213,NULL,38758506281,605601660,9462525,17.8),(45668,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45668,36.16,0.52,170,11328,70,NULL,NULL,'2MASX J06075636-4459156',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.6I',0.6,NULL,NULL,NULL,NULL,NULL,1,91.984875,-44.98767,0.265,NULL,42413604839,662712575,10354883,13.6),(45669,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45669,37.03,0.67,254,11329,70,NULL,NULL,'2MASX J06075661-4318496',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.4,NULL,NULL,NULL,NULL,NULL,1,91.985917,-43.31378,0.241,NULL,38926889695,608232651,9503635,14.4),(45670,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45670,35.13,0.54,106,11330,70,NULL,NULL,'2MASX J06080004-3134071',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.5b',0.6,NULL,NULL,NULL,NULL,NULL,1,92.000167,-31.56864,0.033,NULL,39075532805,610555200,9539925,15.5),(45671,'Tully est','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45671,32.67,0.8,34.2,11331,75,NULL,'B','NGC 2179',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000017,NULL,'13.22',1.2,'(R)SA(r)0^+?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,92.00925,-21.74669,0.265,NULL,39598383057,618724735,9667573,13.22),(45672,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,'R',45672,34.59,0.49,83,11332,75,NULL,'IR','ESO 555- G 037',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'15.77',0.3,'S...',NULL,NULL,NULL,NULL,1,92.012167,-19.22425,0.385,NULL,38737672354,605276130,9457439,15.77),(45673,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45673,34.86,0.41,93.6,11332,NULL,NULL,NULL,'ESO 555- G 037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45674,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45674,34.9,0.2,95.5,11332,74.4,NULL,NULL,'ESO 555- G 037',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45675,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45675,34.9,0.4,95.6,11332,NULL,NULL,'Malmquist cor.','ESO 555- G 037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45676,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45676,35.47,0.54,124,11333,70,NULL,NULL,'ESO 254- G 024',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000123,NULL,'15.80',0.3,'(R)SB(r)0/a',NULL,NULL,NULL,NULL,1,92.0407083333,-45.14819,0.237,NULL,42413142598,662705353,10354771,15.8),(45677,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45677,36.2,0.58,174,11334,70,NULL,NULL,'2MASX J06081065-6536477',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,92.0444583,-65.61328,0.153,NULL,40335248198,630238253,9847472,16.5),(45678,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45678,33.13,0.46,42.3,11335,70,NULL,NULL,'NGC 2191',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000097,NULL,'12.33',0.9,'SB(r)0^0^:',NULL,NULL,NULL,NULL,1,92.0994583,-52.51231,0.149,NULL,40293727949,629589499,9837335,12.33),(45679,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45679,35.11,0.57,105,11336,NULL,NULL,'Malmquist cor.','ESO 057- G 069',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.12',0.5,'S...',NULL,NULL,NULL,NULL,1,92.125583,-71.28781,0.441,NULL,39869972779,622968324,9733880,15.12),(45680,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45680,35.24,0.54,112,11336,NULL,NULL,NULL,'ESO 057- G 069',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45681,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45681,35.28,0.2,114,11336,74.4,NULL,NULL,'ESO 057- G 069',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45682,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45682,35.83,0.47,147,11336,NULL,NULL,'H','ESO 057- G 069',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45683,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45683,35.9,0.4,151,11336,NULL,NULL,'mean','ESO 057- G 069',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45684,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45684,36.04,0.46,161,11336,NULL,NULL,'J','ESO 057- G 069',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45685,'SNIa','2016-12-15 15:14:13','2016-12-16 11:19:18','1','SN 2006N',NULL,45685,33.35,0.22,46.1,11337,74.2,NULL,'SALT 2','CGCG 308-009',0.014277,'2010ApJ...716..712A',2010,1,0.75,NULL,'G',0.000083,NULL,'14.7',0.5,NULL,NULL,NULL,NULL,NULL,1,92.126625,64.72369,0.377,NULL,61621595472,962837429,15044334,14.7),(45686,'SNIa','2016-12-15 15:14:13','2016-12-16 11:19:18','1','SN 2006N',NULL,45686,33.95,0.15,60.8,11337,72,NULL,NULL,'CGCG 308-009',0.014277,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45687,'SNIa','2016-12-15 15:14:13','2016-12-16 11:19:18','1','SN 2006N',NULL,45687,33.98,0.15,61.6,11337,72,NULL,NULL,'CGCG 308-009',0.014277,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45688,'SNIa','2016-12-15 15:14:13','2016-12-16 11:19:18','1','SN 2006N',NULL,45688,33.96,0.09,61.9,11337,74.4,NULL,NULL,'CGCG 308-009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45689,'SNIa','2016-12-15 15:14:13','2016-12-16 11:19:18','1','SN 2006N',NULL,45689,34,0.21,62.2,11337,70,NULL,'SALT 2','CGCG 308-009',0.014277,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45690,'SNIa','2016-12-15 15:14:13','2016-12-16 11:19:18','1','SN 2006N',NULL,45690,34.01,0.19,62.6,11337,73.8,NULL,'SALT 2 (SNANA)','CGCG 308-009',0.0143,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45691,'SNIa','2016-12-15 15:14:13','2016-12-16 11:19:18','1','SN 2006N',NULL,45691,34.03,0.04,63.1,11337,72,NULL,NULL,'CGCG 308-009',0.014277,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45692,'SNIa','2016-12-15 15:14:13','2016-12-16 11:19:18','1','SN 2006N',NULL,45692,34.17,0.23,67.2,11337,65,NULL,'MLCS31','CGCG 308-009',0.014277,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45693,'SNIa','2016-12-15 15:14:13','2016-12-16 11:19:18','1','SN 2006N',NULL,45693,34.17,0.23,67.4,11337,65,NULL,'MLCS17','CGCG 308-009',0.014277,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45694,'SNIa','2016-12-15 15:14:13','2016-12-16 11:19:18','1','SN 2006N',NULL,45694,34.29,0.25,71.2,11337,65,NULL,'SALT2','CGCG 308-009',0.014277,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45695,'SNIa','2016-12-15 15:14:13','2016-12-16 11:19:18','1','SN 2006N',NULL,45695,34.45,0.12,77.6,11337,72,NULL,'M(H) = -18.317 mag','CGCG 308-009',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45696,'SNIa','2016-12-15 15:14:13','2016-12-16 11:19:18','1','SN 2006N',NULL,45696,34.53,0.04,79.2,11337,70,NULL,'SALT 2','CGCG 308-009',0.014277,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45697,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45697,36.25,0.67,178,11338,70,NULL,NULL,'2MASX J06083163-3320590',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15',NULL,'S0','Group member',NULL,NULL,NULL,1,92.131833,-33.34964,0.073,NULL,39145203360,611643802,9556934,15),(45698,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45698,37.96,0.61,391,11339,70,NULL,NULL,'2MASX J06084186-4930242',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.5,NULL,NULL,NULL,NULL,NULL,1,92.1745,-49.50672,0.137,NULL,40273516639,629273697,9832401,14.3),(45699,'FP','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45699,37.1,0.6,263,11340,70,NULL,NULL,'2MASX J06084413-4812132',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,92.1837917,-48.20364,0.137,NULL,40280327293,629380113,9834064,16.3),(45700,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45700,35.83,0.44,146,11341,NULL,NULL,NULL,'2MASX J06084517-3346324',NULL,'2009ApJS..182..474S',2009,1,0.36,NULL,'G',0.000033,NULL,'16',0.2,'Sc','Group member',NULL,NULL,NULL,1,92.188417,-33.77547,0.033,NULL,39144933923,611639592,9556868,16),(45701,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:18','1',NULL,NULL,45701,35.87,0.2,149,11341,74.4,NULL,NULL,'2MASX J06084517-3346324',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45702,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45702,35.97,0.41,157,11341,NULL,NULL,'Malmquist cor.','2MASX J06084517-3346324',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45703,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45703,36.83,0.6,232,11342,70,NULL,NULL,'2MASX J06085101-2825599',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,92.212667,-28.43339,0,NULL,39117751834,611214872,9550232,14.3),(45704,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45704,33.57,0.82,51.8,11343,NULL,NULL,'Malmquist cor.','ESO 489- G 008',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.00015,NULL,'14.62',0.5,'SB(s)d',NULL,NULL,NULL,NULL,1,92.22125,-25.14442,0,NULL,39073454585,610522727,9539417,14.62),(45705,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45705,33.77,0.74,56.8,11343,NULL,NULL,NULL,'ESO 489- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45706,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45706,33.81,0.2,57.8,11343,74.4,NULL,NULL,'ESO 489- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45707,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45707,36.97,0.56,248,11344,70,NULL,NULL,'2MASX J06085337-6137529',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.4I',0.4,NULL,NULL,NULL,NULL,NULL,1,92.222417,-61.63131,0.121,NULL,40370587004,630790421,9856100,14.4),(45708,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,'R',45708,33.77,0.49,56.7,11345,75,NULL,'IR','ESO 425- G 011',NULL,'2011yCatp016004901K',2011,1,1.88,NULL,'G',0.000023,NULL,'15.58',0.2,'Scd',NULL,NULL,NULL,NULL,1,92.235875,-29.15744,0,NULL,39085231078,610706735,9542292,15.58),(45709,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45709,33.82,0.43,58,11345,75,NULL,'3.6 micron, color + selection bias corrected','ESO 425- G 011',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45710,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45710,33.83,NULL,58.3,11345,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 425- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45711,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45711,33.84,NULL,58.7,11345,NULL,NULL,'Dipole','ESO 425- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45712,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45712,33.84,NULL,58.7,11345,NULL,NULL,'Dipole + Quadrupole','ESO 425- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45713,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45713,35.69,0.5,137,11346,70,NULL,NULL,'2MASX J06085846-5707093',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000123,NULL,'12.5I',0.9,NULL,NULL,NULL,NULL,NULL,1,92.2436666667,-57.11928,0.141,NULL,40500495712,632820245,9887816,12.5),(45714,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45714,35.68,0.48,136,11347,70,NULL,NULL,'2MASX J06090561-6313159',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000137,NULL,'14.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,92.273333,-63.22111,0.153,NULL,40344354029,630380531,9849695,14.8),(45715,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45715,32.81,0.47,36.5,11348,NULL,NULL,'H','UGC 03407',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000037,NULL,'13.7',0.9,'Sa',NULL,NULL,NULL,NULL,1,92.28375,42.08519,1.421,NULL,62829867849,981716685,15339323,13.7),(45716,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45716,32.83,0.45,36.9,11348,NULL,NULL,'K','UGC 03407',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45717,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45717,32.96,0.46,39,11348,NULL,NULL,'J','UGC 03407',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45718,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45718,33.26,0.4,44.9,11348,NULL,NULL,'mean','UGC 03407',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45719,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45719,35.91,0.7,152,11349,70,NULL,NULL,'ESO 205- G 025',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'16.07',0.1,'Sc:',NULL,NULL,NULL,NULL,1,92.312375,-51.07567,0.133,NULL,40324379399,630068428,9844819,16.07),(45720,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45720,35.4,0.58,120,11350,70,NULL,NULL,'2MASX J06091993-6609271',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.1b',0.17,NULL,NULL,NULL,NULL,NULL,1,92.3329583,-66.15753,0.177,NULL,40336529120,630258267,9847785,16.1),(45721,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45721,36.75,0.87,224,11351,70,NULL,NULL,'2MASX J06091997-4904400',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,92.33325,-49.07783,0.157,NULL,40272695882,629260873,9832201,16.7),(45722,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45722,36.39,0.84,190,11352,70,NULL,NULL,'ESO 121- G 008',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'16.26',0.8,'(R)SB0^0',NULL,NULL,NULL,NULL,1,92.3455417,-61.51742,0.121,NULL,40370655933,630791498,9856117,16.26),(45723,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45723,36.05,0.43,162,11353,NULL,NULL,'Malmquist cor.','2MASX J06092949-3337408',NULL,'2009ApJS..182..474S',2009,1,0.66,NULL,'G',0.000023,NULL,'15',0.24,'Sb','Group member',NULL,NULL,NULL,1,92.3727916667,-33.62797,0.013,NULL,39145028955,611641077,9556891,15),(45724,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45724,36.39,0.36,190,11353,NULL,NULL,NULL,'2MASX J06092949-3337408',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45725,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45725,36.43,0.2,193,11353,74.4,NULL,NULL,'2MASX J06092949-3337408',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45726,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45726,36.23,0.47,176,11354,NULL,NULL,'Malmquist cor.','2MASX J06093029-3333098',NULL,'2009ApJS..182..474S',2009,1,0.46,NULL,'G',0.000027,NULL,'15',0.2,'Sbc','Group member',NULL,NULL,NULL,1,92.3781666667,-33.55208,0,NULL,39145031037,611641109,9556892,15),(45727,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45727,36.49,0.41,199,11354,NULL,NULL,NULL,'2MASX J06093029-3333098',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45728,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45728,36.53,0.2,202,11354,74.4,NULL,NULL,'2MASX J06093029-3333098',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45729,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45729,35.55,0.55,129,11355,70,NULL,NULL,'2MASX J06093181-6549212',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,92.382667,-65.82264,0.177,NULL,40335201775,630237527,9847461,16.6),(45730,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45730,36.42,0.25,192,11356,74.4,NULL,NULL,'2MASX J06093294-3350318',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000117,NULL,'15',NULL,'S0','Group member',NULL,NULL,NULL,1,92.38725,-33.84211,0.013,NULL,39143043928,611610061,9556407,15),(45731,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45731,36.65,0.63,214,11357,70,NULL,NULL,'2MASX J06093388-1823184',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,92.3912083,-18.38842,0.425,NULL,38737880939,605279389,9457490,16.7),(45732,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45732,34.47,0.46,78.5,11358,NULL,NULL,NULL,'ESO 555- G 040',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000027,NULL,'16.13',0.3,'Scd? pec sp',NULL,NULL,NULL,NULL,1,92.403875,-20.10292,0.421,NULL,38723074806,605048043,9453875,16.13),(45733,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45733,34.65,0.43,85.1,11358,NULL,NULL,'Malmquist cor.','ESO 555- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45734,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45734,34.78,0.2,90.4,11358,74.4,NULL,NULL,'ESO 555- G 040',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45735,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,'R',45735,34.98,0.49,99,11358,75,NULL,'IR','ESO 555- G 040',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45736,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45736,35.1,0.54,105,11359,NULL,NULL,NULL,'FAIRALL 1138',NULL,'2009ApJS..182..474S',2009,1,0.76,NULL,'G',0.000023,NULL,'14',0.42,'(R\')SB(s)a','Group member',NULL,NULL,NULL,1,92.4115416667,-33.58772,0,NULL,39145018584,611640915,9556889,14),(45737,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45737,35.14,0.2,107,11359,74.4,NULL,NULL,'FAIRALL 1138',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45738,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45738,35.35,0.48,118,11359,NULL,NULL,'Malmquist cor.','FAIRALL 1138',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45739,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45739,36.18,0.5,172,11360,70,NULL,NULL,'2MASX J06094571-4138310',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,92.4404583,-41.642,0.269,NULL,38939767672,608433869,9506779,14.7),(45740,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45740,35.72,0.48,140,11361,70,NULL,NULL,'2MASX J06094659-2419310',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.0I',0.6,NULL,NULL,NULL,NULL,NULL,1,92.444125,-24.32536,0.125,NULL,39073942248,610530347,9539536,13),(45741,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45741,35.6,0.47,132,11362,NULL,NULL,NULL,'2MASX J06094692-3352267',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.00015,NULL,'15',NULL,'Sa','Group member',NULL,NULL,NULL,1,92.4455833333,-33.87406,0.013,NULL,39143079540,611610617,9556415,15),(45742,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45742,35.64,0.2,134,11362,74.4,NULL,NULL,'2MASX J06094692-3352267',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45743,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45743,35.73,0.44,140,11362,NULL,NULL,'Malmquist cor.','2MASX J06094692-3352267',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45744,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45744,35.68,0.47,136,11363,70,NULL,NULL,'ESO 489- G 010',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00012,NULL,'14.94',0.2,'S0',NULL,NULL,NULL,NULL,1,92.450417,-24.69028,0.101,NULL,39073904070,610529751,9539527,14.94),(45745,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45745,36.39,0.23,190,11364,74.4,NULL,NULL,'2MASX J06094881-3335508',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000117,NULL,'14.8R',NULL,'S0','Group member, 2nd ranked galaxy',NULL,NULL,NULL,1,92.453417,-33.59744,0,NULL,39145020972,611640952,9556889,14.8),(45746,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45746,36.64,0.52,213,11364,70,NULL,NULL,'2MASX J06094881-3335508',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45747,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45747,35.59,0.58,131,11365,70,NULL,NULL,'2MASX J06095185-3551598',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,92.465917,-35.86661,0.173,NULL,38973293689,608957713,9514964,15.5),(45748,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45748,36.01,0.48,159,11366,70,NULL,NULL,'2MASX J06095181-4346594',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,92.4659583333,-43.78308,0.269,NULL,42415199777,662737496,10355273,14.4),(45749,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45749,35.67,0.25,136,11367,74.4,NULL,NULL,'2MASX J06095263-3341288',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000117,NULL,'15',NULL,'S0','Group member',NULL,NULL,NULL,1,92.46925,-33.69133,0.013,NULL,39142977995,611609031,9556391,15),(45750,'D-Sigma','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45750,35.83,0.18,146,11368,72,NULL,'ABELL 3381, 6 galaxies','MCG -06-14-005',NULL,'2002AJ....123.2159B',2002,1,0.2,NULL,'G',0.000117,NULL,'15.5',0.2,'D/S0','Group member',NULL,NULL,NULL,1,92.474583,-33.59242,0,NULL,39145017755,611640902,9556889,15.5),(45751,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45751,35.81,0.11,145,11368,75,NULL,'ABELL 3381, 14 galaxies','MCG -06-14-005',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45752,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45752,35.97,0.23,156,11368,74.4,NULL,NULL,'MCG -06-14-005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45753,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45753,36.17,0.15,171,11368,70,NULL,'ABELL 3381, BGC','MCG -06-14-005',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45754,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45754,36.57,0.68,206,11369,70,NULL,NULL,'2MASX J06095527-5003352',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,92.480167,-50.05981,0.113,NULL,40271131233,629236425,9831819,17.1),(45755,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45755,36.17,0.15,171,11370,70,NULL,NULL,'ABELL 3381',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I      [BM];RI [A]',NULL,NULL,NULL,NULL,1,92.4807917,-33.59425,0,NULL,39145017741,611640902,9556889,NULL),(45756,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45756,35.02,0.25,101,11371,74.4,NULL,NULL,'PGC 018531',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000117,NULL,'16',NULL,'E/S0','Group member',NULL,NULL,NULL,1,92.496125,-33.54958,0,NULL,39145037408,611641209,9556893,16),(45757,'IRAS','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45757,32.98,0.8,39.5,11372,75,NULL,'MAT, I','ESO 489- G 011',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.89',1,'SAB(s)dm',NULL,NULL,NULL,NULL,1,92.5072083,-22.62564,0.317,NULL,39596187501,618690429,9667037,14.89),(45758,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45758,32.36,0.32,29.6,11372,85,NULL,'I, inv','ESO 489- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45759,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45759,32.38,0.32,29.9,11372,85,NULL,'I, raw','ESO 489- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45760,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45760,32.92,0.43,38.3,11372,75,NULL,'MAT, I, raw','ESO 489- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45761,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45761,32.92,0.43,38.3,11372,75,NULL,'MAT, I, inv','ESO 489- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45762,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45762,33.01,0.4,40,11372,73,NULL,'opt','ESO 489- G 011',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45763,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45763,33.02,0.43,40.1,11372,75,NULL,'MAT, I, cor','ESO 489- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45764,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45764,33.1,0.98,41.7,11372,NULL,NULL,'Malmquist cor.','ESO 489- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45765,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45765,33.44,0.84,48.7,11372,NULL,NULL,NULL,'ESO 489- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45766,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45766,33.48,0.2,49.7,11372,74.4,NULL,NULL,'ESO 489- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45767,'TRGB','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45767,29.62,0.1,8.41,11373,74.4,NULL,NULL,'NGC 2188',NULL,'2013AJ....146...86T',2013,1,4.4,'The 2MASX source may be a superposed star in southern part of NGC 2188.','G',0.000013,NULL,'12.14',1.1,'SB(s)m',NULL,NULL,NULL,NULL,1,92.5397083,-34.10619,0.017,NULL,39142937316,611608395,9556381,12.14),(45768,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45768,29.35,NULL,7.41,11373,NULL,NULL,NULL,'NGC 2188',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45769,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45769,29.49,0.4,7.9,11373,75,NULL,'B','NGC 2188',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45770,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45770,30,0.4,10,11373,73,NULL,'IR','NGC 2188',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45771,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,'R',45771,30,0.4,10,11373,75,NULL,NULL,'NGC 2188',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45772,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,'R',45772,30.56,0.49,12.9,11373,75,NULL,'IR','NGC 2188',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45773,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45773,36.09,0.23,165,11374,74.4,NULL,NULL,'2MASX J06101082-3328529',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000117,NULL,'15',NULL,'E','Group member',NULL,NULL,NULL,1,92.5452083,-33.48136,0,NULL,39144986010,611640406,9556881,15),(45774,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45774,35.84,0.61,147,11375,70,NULL,NULL,'2MASX J06101359-5757188',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.4,NULL,NULL,NULL,NULL,NULL,1,92.5565417,-57.95525,0.093,NULL,40369529241,630773894,9855842,13.9),(45775,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45775,36.36,0.64,187,11376,70,NULL,NULL,'2MASX J06101983-7008315',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'16.3b',0.38,NULL,NULL,NULL,NULL,NULL,1,92.5824166667,-70.14206,0.413,NULL,39864170381,622877662,9732463,16.3),(45776,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45776,34.76,NULL,89.6,11377,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0554',NULL,'2010Ap&SS.325..163P',2010,1,1.38,NULL,'G',0.000167,NULL,'15.8',0.17,'Sbc',NULL,NULL,NULL,NULL,1,92.589375,50.78547,0.993,NULL,61530068113,961407314,15021989,15.8),(45777,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45777,34.77,NULL,90.1,11377,NULL,NULL,'Dipole + Quadrupole','FGC 0554',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45778,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45778,34.78,NULL,90.2,11377,NULL,NULL,'Dipole','FGC 0554',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45779,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,'R',45779,34.82,0.49,91.9,11377,75,NULL,'IR','FGC 0554',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45780,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45780,34.83,NULL,92.3,11377,NULL,NULL,NULL,'FGC 0554',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45781,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45781,35.31,0.53,115,11378,70,NULL,NULL,'2MASX J06102158-6235174',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,92.589917,-62.58819,0.145,NULL,40387471085,631054235,9860222,16.3),(45782,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45782,35.77,0.35,142,11379,NULL,NULL,'Malmquist cor.','2MASX J06102172-3341278',NULL,'2009ApJS..182..474S',2009,1,0.66,NULL,'G',0.000023,NULL,'14.5R',0.42,'Sbc','Group member',NULL,NULL,NULL,1,92.5904583333,-33.69106,0.013,NULL,39143013107,611609579,9556399,14.5),(45783,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45783,35.76,0.35,142,11379,NULL,NULL,NULL,'2MASX J06102172-3341278',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45784,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45784,35.81,0.2,145,11379,74.4,NULL,NULL,'2MASX J06102172-3341278',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45785,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45785,35.8,0.65,144,11380,70,NULL,NULL,'2MASX J06102589-6400384',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,92.607875,-64.01069,0.157,NULL,40344184537,630377883,9849654,16.8),(45786,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45786,35.94,0.62,154,11381,70,NULL,NULL,'ESO 489- G 013',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.80',0.2,'S0-a',NULL,NULL,NULL,NULL,1,92.6225,-26.22633,0,NULL,39062745715,610355401,9536803,15.8),(45787,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45787,36.97,0.67,247,11382,70,NULL,NULL,'2MASX J06103182-1430565',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,92.632667,-14.51578,0.841,NULL,38778670358,605916724,9467448,17.8),(45788,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45788,34.51,0.45,79.7,11383,70,NULL,NULL,'NGC 2205',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00005,NULL,'13.69',0.9,'(R\')SAB(rs)0-:',NULL,NULL,NULL,NULL,1,92.636375,-62.53842,0.145,NULL,40387471563,631054243,9860222,13.69),(45789,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45789,31.14,0.2,16.9,11384,74.4,NULL,NULL,'UGC 03403',NULL,'2013AJ....146...86T',2013,1,2.3,NULL,'G',0.000023,NULL,'14.30',0.7,'SBcd?',NULL,NULL,NULL,NULL,1,92.651375,71.38611,0.481,NULL,61280304658,957504760,14961011,14.3),(45790,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45790,31.17,0.43,17.1,11384,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03403',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45791,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45791,31.21,0.43,17.4,11384,75,NULL,'3.6 micron, color corrected','UGC 03403',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45792,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45792,31.25,0.4,17.8,11384,NULL,NULL,NULL,'UGC 03403',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45793,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45793,31.29,0.41,18.1,11384,NULL,NULL,NULL,'UGC 03403',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45794,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,'R',45794,31.45,0.4,19.5,11384,75,NULL,NULL,'UGC 03403',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45795,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45795,31.61,0.36,21,11384,NULL,NULL,'Malmquist cor.','UGC 03403',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45796,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45796,31.73,0.4,22.2,11384,NULL,NULL,'mean','UGC 03403',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45797,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45797,31.98,0.46,24.9,11384,NULL,NULL,'J','UGC 03403',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45798,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45798,32.07,0.47,26,11384,NULL,NULL,'H','UGC 03403',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45799,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,'R',45799,32.07,0.49,26,11384,75,NULL,'IR','UGC 03403',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45800,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45800,32.14,0.45,26.8,11384,NULL,NULL,'K','UGC 03403',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45801,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45801,35.65,0.25,135,11385,74.4,NULL,NULL,'2MASX J06103396-3331417',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000117,NULL,'15',NULL,'S0','Group member',NULL,NULL,NULL,1,92.6429583333,-33.52697,0,NULL,39142963355,611608802,9556387,15),(45802,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45802,34.19,0.43,68.8,11386,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03406',NULL,'2014MNRAS.444..527S',2014,1,1.46,NULL,'G',0.00008,NULL,'17.',0.11,'Sd',NULL,NULL,NULL,NULL,1,92.6832917,67.25247,0.381,NULL,61606562376,962602537,15040664,17),(45803,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,'R',45803,34.2,0.49,69.1,11386,75,NULL,'IR','UGC 03406',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45804,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45804,34.42,NULL,76.7,11386,NULL,NULL,'Dipole','UGC 03406',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45805,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45805,34.42,NULL,76.7,11386,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03406',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45806,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45806,34.43,NULL,76.8,11386,NULL,NULL,'Dipole + Quadrupole','UGC 03406',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45807,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45807,34.44,NULL,77.3,11386,NULL,NULL,NULL,'UGC 03406',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45808,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45808,36.63,0.25,212,11387,74.4,NULL,NULL,'2MASX J06104918-3343547',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000117,NULL,'15',0.4,'S0','Group member',NULL,NULL,NULL,1,92.7049583333,-33.73186,0.013,NULL,39142996968,611609327,9556395,15),(45809,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45809,36.81,0.52,230,11387,70,NULL,NULL,'2MASX J06104918-3343547',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45810,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45810,35.28,0.6,114,11388,NULL,NULL,NULL,'ESO 121- G 010',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.57',0.8,'SA(rs)c',NULL,NULL,NULL,NULL,1,92.707667,-60.82269,0.097,NULL,40374233321,630847395,9856990,15.57),(45811,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45811,35.32,0.2,116,11388,74.4,NULL,NULL,'ESO 121- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45812,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45812,35.37,0.58,119,11388,NULL,NULL,'Malmquist cor.','ESO 121- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45813,'D-Sigma','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45813,35.73,0.18,140,11389,NULL,NULL,'ABELL 3381, 14 galaxies','ESO 364- G 039',NULL,'2000ApJ...529..768K',2000,1,1.7,NULL,'G',0.00003,NULL,'13.78',1.3,'SA(r)ab:','Group member',NULL,NULL,NULL,1,92.714,-33.88236,0.017,NULL,39142902418,611607850,9556372,13.78),(45814,'D-Sigma','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45814,35.83,0.18,146,11389,72,NULL,'ABELL 3381, 6 galaxies','ESO 364- G 039',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45815,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45815,34.61,0.45,83.7,11389,70,NULL,NULL,'ESO 364- G 039',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45816,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45816,35.57,0.18,130,11389,NULL,NULL,'ABELL 3381, 14 galaxies','ESO 364- G 039',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45817,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45817,35.68,0.18,137,11389,NULL,NULL,'ABELL 3381, 14 galaxies','ESO 364- G 039',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45818,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45818,35.81,0.11,145,11389,75,NULL,'ABELL 3381, 14 galaxies','ESO 364- G 039',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45819,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45819,35.81,0.11,145,11389,75,NULL,'ABELL 3381 Cluster, 14 galaxies','ESO 364- G 039',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45820,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45820,36.86,0.56,236,11390,70,NULL,NULL,'2MASX J06105242-2658087',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.4I',0.4,NULL,NULL,NULL,NULL,NULL,1,92.7185,-26.96906,0,NULL,39118843880,611231935,9550498,14.4),(45821,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45821,35.21,1.08,110,11391,NULL,NULL,'Malmquist cor.','UGC 03411',NULL,'2009ApJS..182..474S',2009,1,1.7,NULL,'G',0.000037,NULL,'15.1',1.1,'Scd?',NULL,NULL,NULL,NULL,1,92.728667,62.02017,0.561,NULL,61665008868,963515763,15054933,15.1),(45822,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45822,36.21,0.68,175,11391,NULL,NULL,NULL,'UGC 03411',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45823,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45823,36.25,0.2,178,11391,74.4,NULL,NULL,'UGC 03411',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45824,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45824,35.14,0.68,106,11392,70,NULL,NULL,'2MASX J06105518-0958121',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.9I',0.2,NULL,NULL,NULL,NULL,NULL,1,92.730083,-9.97008,1.353,NULL,38892737609,607699025,9495297,14.9),(45825,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45825,35.03,0.23,101,11393,74.4,NULL,NULL,'2MASX J06105527-3344186',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000117,NULL,'14',0.3,'S0','Group member',NULL,NULL,NULL,1,92.73025,-33.73853,0.013,NULL,39142982748,611609105,9556392,14),(45826,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45826,36.76,0.51,225,11394,70,NULL,NULL,'2MASX J06110000-4345263',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.8I',0.4,NULL,NULL,NULL,NULL,NULL,1,92.7500417,-43.75728,0.269,NULL,42415390388,662740474,10355319,13.8),(45827,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45827,36.38,0.91,188,11395,70,NULL,NULL,'2MASX J06110296-4343233',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,92.762375,-43.72314,0.269,NULL,42415388432,662740444,10355319,15.3),(45828,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45828,35.84,0.52,147,11396,70,NULL,NULL,'2MASX J06110576-4510513',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000127,NULL,'13.3I',0.7,NULL,NULL,NULL,NULL,NULL,1,92.774125,-45.18094,0.229,NULL,42416967252,662765113,10355704,13.3),(45829,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45829,35.47,0.44,124,11397,NULL,NULL,NULL,'ESO 364-IG 042 NED01',NULL,'2009ApJS..182..474S',2009,1,1.24,NULL,'G',0.000023,NULL,'15.00',0.26,'Sb','Group member',NULL,NULL,NULL,1,92.775833,-33.29956,0,NULL,39144533916,611633342,9556770,15),(45830,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45830,35.51,0.2,126,11397,74.4,NULL,NULL,'ESO 364-IG 042 NED01',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45831,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45831,35.58,0.41,131,11397,NULL,NULL,'Malmquist cor.','ESO 364-IG 042 NED01',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45832,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45832,32.05,0.43,25.7,11398,75,NULL,'3.6 micron, color + selection bias corrected','MCG -03-16-018',NULL,'2014MNRAS.444..527S',2014,1,0.8,NULL,'G',0.00003,NULL,'14',0.45,'Sc',NULL,NULL,NULL,NULL,1,92.7777083,-15.49353,0.797,NULL,38779007144,605921986,9467531,14),(45833,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45833,32.15,0.43,26.9,11398,75,NULL,'3.6 micron, color corrected','MCG -03-16-018',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45834,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45834,32.17,0.2,27.2,11398,74.4,NULL,NULL,'MCG -03-16-018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45835,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45835,35.55,0.25,129,11399,74.4,NULL,NULL,'ESO 364-IG 042',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'GPair',NULL,NULL,NULL,NULL,'Double system',NULL,NULL,NULL,NULL,1,92.777917,-33.30306,0,NULL,39144533942,611633342,9556770,NULL),(45836,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,'R',45836,33.88,0.49,59.7,11400,75,NULL,'IR','FGC 0556',NULL,'2011yCatp016004901K',2011,1,0.87,NULL,'G',0.000027,NULL,'16.4',0.11,'Sd',NULL,NULL,NULL,NULL,1,92.783125,55.33828,0.745,NULL,61507711281,961057988,15016531,16.4),(45837,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45837,34.38,NULL,75,11400,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0556',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45838,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45838,34.39,NULL,75.5,11400,NULL,NULL,'Dipole + Quadrupole','FGC 0556',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45839,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45839,34.41,NULL,76.2,11400,NULL,NULL,'Dipole','FGC 0556',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45840,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45840,34.44,NULL,77.4,11400,NULL,NULL,NULL,'FGC 0556',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45841,'Tully est','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45841,29.94,0.8,9.7,11401,75,NULL,NULL,'UGCA 120',NULL,'1988NBGC.C....0000T',1988,1,2,NULL,'G',0.000003,NULL,'14.24',1.7,'IA(s)m',NULL,NULL,NULL,NULL,1,92.818,-21.59906,0.389,NULL,39597422352,618709724,9667339,14.24),(45842,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45842,36.39,0.56,190,11402,70,NULL,NULL,'2MASX J06111779-2703507',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,92.8242083,-27.06406,0,NULL,39118859699,611232182,9550502,16),(45843,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45843,36.81,0.63,231,11403,70,NULL,NULL,'2MASX J06112717-1224445',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.79',0.4,NULL,NULL,NULL,NULL,NULL,1,92.863125,-12.41244,1.289,NULL,38769756135,605777439,9465272,16.79),(45844,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45844,36.53,0.54,203,11404,70,NULL,NULL,'2MASX J06112951-6655140',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,92.873125,-66.92053,0.273,NULL,40336245643,630253838,9847716,16.3),(45845,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45845,36.47,0.64,197,11405,70,NULL,NULL,'2MASX J06113167-4204222',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,92.881917,-42.07278,0.269,NULL,38938481042,608413766,9506465,15.4),(45846,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45846,36.15,0.52,170,11406,70,NULL,NULL,'2MASX J06113636-6610579',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'16.3b',0.39,NULL,NULL,NULL,NULL,NULL,1,92.9015,-66.18275,0.177,NULL,40335772216,630246440,9847600,16.3),(45847,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45847,35.68,0.25,137,11407,74.4,NULL,NULL,'AM 0609-330',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000117,NULL,'13',NULL,'E/S0p','Group member',NULL,NULL,NULL,1,92.9179583333,-33.12447,0.217,NULL,39144563626,611633806,9556778,13),(45848,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45848,36.33,0.53,185,11408,70,NULL,NULL,'2MASX J06114845-5534177',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.1I',0.3,NULL,NULL,NULL,NULL,NULL,1,92.9518333333,-55.57156,0.145,NULL,40283890948,629435796,9834934,14.1),(45849,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45849,36.27,0.53,179,11409,70,NULL,NULL,'2MASX J06115453-2809471',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,92.97725,-28.16314,0,NULL,39118111545,611220492,9550320,15.5),(45850,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45850,36.67,0.51,216,11410,70,NULL,NULL,'2MASX J06115712-3231281',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,92.988125,-32.52456,0.129,NULL,39144154872,611627419,9556678,14.6),(45851,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45851,35.2,0.54,110,11411,70,NULL,NULL,'FAIRALL 1303',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'15.6B',0.67,NULL,NULL,NULL,NULL,NULL,1,92.9997917,-77.26222,0.461,NULL,39881871076,623154235,9736784,15.6),(45852,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45852,36.08,0.63,165,11412,70,NULL,NULL,'2MASX J06120166-4408018',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,93.0070416667,-44.13383,0.189,NULL,42415291622,662738931,10355295,14.4),(45853,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45853,37.29,0.59,286,11413,70,NULL,NULL,'2MASX J06120478-4500328',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,93.019917,-45.00903,0.229,NULL,42416942155,662764721,10355698,15.2),(45854,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45854,35.64,0.59,134,11414,NULL,NULL,NULL,'2MASX J06120492-3304202',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000033,NULL,'16',0.16,'Sb','Group member',NULL,NULL,NULL,1,93.0205416667,-33.07242,0.217,NULL,39144614288,611634598,9556790,16),(45855,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45855,35.68,0.2,137,11414,74.4,NULL,NULL,'2MASX J06120492-3304202',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45856,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45856,35.93,0.51,154,11414,NULL,NULL,'Malmquist cor.','2MASX J06120492-3304202',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45857,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45857,32.3,0.4,28.8,11415,75,NULL,'B','NGC 2196',NULL,'1988NBGC.C....0000T',1988,1,2.8,NULL,'G',0.00002,NULL,'11.82',2.2,'(R\':)SA(rs)ab  HII','Group member',NULL,NULL,NULL,1,93.0402083,-21.80594,0.421,NULL,39595766335,618683848,9666935,11.82),(45858,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45858,37.77,0.62,357,11416,70,NULL,NULL,'2MASX J06120998-4705527',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,93.0415833333,-47.09797,0.129,NULL,40268308430,629192319,9831129,16.6),(45859,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45859,36.1,0.61,166,11417,70,NULL,NULL,'2MASX J06121813-4439177',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,93.0755417,-44.65497,0.229,NULL,42416927734,662764495,10355695,15.6),(45860,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45860,35.12,0.55,106,11418,70,NULL,NULL,'2MASX J06122159-2803281',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,'Sa(r)',NULL,NULL,NULL,NULL,1,93.0900417,-28.05786,0,NULL,39118090928,611220170,9550315,16.6),(45861,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45861,35.93,0.51,154,11419,70,NULL,NULL,'ESO 254- G 036',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000117,NULL,'14.51',1,'S0',NULL,NULL,NULL,NULL,1,93.1087083,-44.66075,0.229,NULL,42416919969,662764374,10355693,14.51),(45862,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45862,35.84,0.52,147,11420,70,NULL,NULL,'2MASX J06122668-5531564',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.6I',0.6,NULL,NULL,NULL,NULL,NULL,1,93.111083,-55.53231,0.177,NULL,40283869510,629435461,9834929,13.6),(45863,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45863,35.79,0.37,144,11421,NULL,NULL,'Malmquist cor.','ESO 160- G 018',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.33',0.2,'S0+: sp',NULL,NULL,NULL,NULL,1,93.112625,-56.27128,0.129,NULL,40503853425,632872709,9888636,15.33),(45864,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45864,35.97,0.34,156,11421,NULL,NULL,NULL,'ESO 160- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45865,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45865,36.01,0.2,159,11421,74.4,NULL,NULL,'ESO 160- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45866,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45866,36.83,0.59,232,11422,70,NULL,NULL,'2MASX J06122727-4739278',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,93.1135833333,-47.65775,0.141,NULL,40279462823,629366606,9833853,16.8),(45867,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45867,36.18,0.6,172,11423,70,NULL,NULL,'2MASX J06122947-4703248',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.4,NULL,NULL,NULL,NULL,NULL,1,93.1227916667,-47.05686,0.121,NULL,40268317763,629192465,9831132,14.3),(45868,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45868,36.46,0.53,196,11424,70,NULL,NULL,'2MASX J06123043-3558520',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,93.1267083,-35.98108,0.225,NULL,38973102353,608954724,9514917,15),(45869,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45869,35.07,0.49,103,11425,NULL,NULL,NULL,'ESO 121- G 013',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.73',0.8,'Sb',NULL,NULL,NULL,NULL,1,93.1272917,-62.41642,0.149,NULL,40387291559,631051430,9860178,15.73),(45870,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45870,35.11,0.2,105,11425,74.4,NULL,NULL,'ESO 121- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45871,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45871,35.17,0.47,108,11425,NULL,NULL,'Malmquist cor.','ESO 121- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45872,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45872,36.07,0.6,164,11426,70,NULL,NULL,'2MASX J06123298-6753044',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.000103,NULL,'16.1b',0.35,NULL,NULL,NULL,NULL,NULL,1,93.1372083,-67.88461,0.257,NULL,40601701335,634401583,9912524,16.1),(45873,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45873,35.68,0.72,137,11427,70,NULL,NULL,'2MASX J06123301-4739478',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.2I',0.5,NULL,NULL,NULL,NULL,NULL,1,93.1375833333,-47.66328,0.141,NULL,40279417006,629365890,9833842,14.2),(45874,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45874,36.1,0.49,166,11428,70,NULL,NULL,'ESO 254-IG 037 NED02',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000087,NULL,'15.32',NULL,'SE COMP',NULL,NULL,NULL,NULL,1,93.141333,-45.07519,0.229,NULL,42416830847,662762981,10355671,15.32),(45875,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45875,35.79,0.57,144,11429,70,NULL,NULL,'2MASX J06124066-5000486',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,93.1692917,-50.01344,0.121,NULL,40271214194,629237721,9831839,16.5),(45876,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45876,35.56,0.53,130,11430,70,NULL,NULL,'2MASX J06124442-4147350',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,93.1851666667,-41.793,0.261,NULL,38939276285,608426191,9506659,14.5),(45877,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45877,34.76,NULL,89.7,11431,NULL,NULL,'Dipole + Quadrupole + Octopole','FGCE 0569',NULL,'2010Ap&SS.325..163P',2010,1,0.9,NULL,'G',0.000033,NULL,'16',0.11,'Sd','Group member',NULL,NULL,NULL,1,93.2074583,-34.25231,0.105,NULL,38959022155,608734721,9511480,16),(45878,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45878,34.78,NULL,90.2,11431,NULL,NULL,'Dipole + Quadrupole','FGCE 0569',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45879,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45879,34.81,NULL,91.5,11431,NULL,NULL,'Dipole','FGCE 0569',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45880,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45880,34.83,NULL,92.3,11431,NULL,NULL,NULL,'FGCE 0569',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45881,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,'R',45881,35.03,0.49,101,11431,75,NULL,'IR','FGCE 0569',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45882,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45882,35.11,0.51,105,11431,NULL,NULL,NULL,'FGCE 0569',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45883,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45883,35.15,0.2,107,11431,74.4,NULL,NULL,'FGCE 0569',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45884,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45884,35.47,0.43,124,11431,NULL,NULL,'Malmquist cor.','FGCE 0569',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45885,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45885,36.69,0.72,218,11432,70,NULL,NULL,'2MASX J06124995-4448447',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,93.2080833333,-44.81239,0.201,NULL,42416912505,662764257,10355691,15.4),(45886,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45886,36.63,0.82,212,11433,70,NULL,NULL,'2MASX J06130469-6754013',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'17.0b',0.47,NULL,NULL,NULL,NULL,NULL,1,93.2694583,-67.90033,0.257,NULL,40601712377,634401755,9912527,17),(45887,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45887,36.36,0.5,187,11434,70,NULL,NULL,'2MASX J06130776-4526165',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.7I',0.4,NULL,NULL,NULL,NULL,NULL,1,93.2823333333,-45.43794,0.217,NULL,42416079411,662751240,10355488,13.7),(45888,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45888,35.83,0.64,146,11435,70,NULL,NULL,'2MASX J06130891-6643212',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.000103,NULL,'17.1b',0.35,NULL,NULL,NULL,NULL,NULL,1,93.2870416667,-66.72261,0.273,NULL,40336302285,630254723,9847730,17.1),(45889,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45889,37.4,0.62,303,11436,70,NULL,NULL,'2MASX J06131793-5729556',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.7I',0.3,NULL,NULL,NULL,NULL,NULL,1,93.324667,-57.49878,0.097,NULL,40501799910,632840623,9888134,14.7),(45890,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45890,35.66,0.52,136,11437,70,NULL,NULL,'2MASX J06132068-6553294',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,93.336083,-65.89142,0.177,NULL,40335633707,630244276,9847566,15.9),(45891,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45891,35.73,0.62,140,11438,70,NULL,NULL,'2MASX J06132074-5000426',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.5,NULL,NULL,NULL,NULL,NULL,1,93.3365417,-50.01192,0.121,NULL,40271158703,629236854,9831825,14.3),(45892,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45892,35.57,0.47,130,11439,70,NULL,NULL,'MCG -06-14-012',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'13.6R',0.4,'E','Group member',NULL,NULL,NULL,1,93.33975,-33.68306,0.073,NULL,39143275482,611613679,9556463,13.6),(45893,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45893,34.06,0.49,65,11440,70,NULL,NULL,'2MASX J06132163-1156451',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.33',NULL,NULL,NULL,NULL,NULL,NULL,1,93.340125,-11.94594,1.493,NULL,38765819548,605715930,9464311,16.33),(45894,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45894,35.63,0.54,134,11441,70,NULL,NULL,'ESO 307- G 024',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000033,NULL,'15.28',0.9,'SA(s)b',NULL,NULL,NULL,NULL,1,93.3644166667,-42.45317,0.221,NULL,38938730967,608417671,9506526,15.28),(45895,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45895,35.76,0.37,142,11441,NULL,NULL,'Malmquist cor.','ESO 307- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45896,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45896,35.88,0.35,150,11441,NULL,NULL,NULL,'ESO 307- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45897,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45897,35.92,0.2,153,11441,74.4,NULL,NULL,'ESO 307- G 024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45898,'GRB','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,'R',45898,47.06,0.44,3430,11442,73,NULL,'H const./H=100','GRB 000131',4.5,'2006astro.ph..9262M',2006,1,NULL,NULL,'G',0.015,NULL,'25.7',NULL,'Ulysses/KO/NE',NULL,NULL,NULL,NULL,1,93.3795,-51.94492,0.165,NULL,40325721452,630089397,9845146,25.7),(45899,'GRB','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,'R',45899,46.54,1.72,3690,11442,100,NULL,NULL,'GRB 000131',4.5,'2009EPJC...63..139W',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45900,'GRB','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,'R',45900,46.74,1.67,4050,11442,73,NULL,'H const./H=100','GRB 000131',4.5,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45901,'GRB','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45901,47.14,0.68,4870,11442,69.7,NULL,'Calibrated','GRB 000131',4.5,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45902,'GRB','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45902,47.21,0.68,5030,11442,69.7,NULL,'Fiducial','GRB 000131',4.5,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45903,'GRB','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,'R',45903,47.58,0.69,5970,11442,72,NULL,NULL,'GRB 000131',4.5,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45904,'GRB','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45904,47.72,0.69,6360,11442,70,NULL,NULL,'GRB 000131',4.5,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45905,'GRB','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,'R',45905,47.98,0.84,7160,11442,NULL,NULL,NULL,'GRB 000131',4.5,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45906,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45906,34.07,0.47,65.1,11443,70,NULL,NULL,'NGC 2201',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'14.21',1,'SB(r)bc','Pair member (points to parent)',NULL,NULL,NULL,1,93.3817083,-43.70472,0.245,NULL,42415837500,662747460,10355429,14.21),(45907,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45907,36.27,0.65,180,11444,70,NULL,NULL,'ESO 121- G 016',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.83',0.6,'(R)SA(l)0^0',NULL,NULL,NULL,NULL,1,93.39575,-58.14994,0.109,NULL,40368928216,630764503,9855695,15.83),(45908,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45908,33.36,0.2,47,11445,74.4,NULL,NULL,'UGC 03416',NULL,'2013AJ....146...86T',2013,1,2.1,NULL,'G',0.000037,NULL,'14.7',1.1,'Scd:','Isolated galaxy',NULL,NULL,NULL,1,93.4165417,69.72925,0.437,NULL,61273797291,957403082,14959423,14.7),(45909,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45909,33.43,0.42,48.5,11445,NULL,NULL,NULL,'UGC 03416',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45910,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45910,33.75,0.36,56.3,11445,NULL,NULL,'Malmquist cor.','UGC 03416',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45911,'BL Lac Luminosity','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45911,41.08,NULL,1300,11446,NULL,NULL,NULL,'87GB 060751.7+710809',0.267,'2005ApJ...635..173S',2005,1,NULL,'Brighter 2MASS object 3\\\" NW.','QSO',0.003,NULL,'19.61',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,93.428625,71.12481,0.453,NULL,61284799340,957574989,14962109,19.61),(45912,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45912,34.7,0.45,87,11447,70,NULL,NULL,'ESO 254- G 041',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000103,NULL,'14.59',0.5,'N',NULL,NULL,NULL,NULL,1,93.4325,-42.79453,0.221,NULL,38924299959,608192186,9503002,14.59),(45913,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45913,35.95,0.56,155,11448,70,NULL,NULL,'2MASX J06134407-6108164',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,93.4337917,-61.13794,0.081,NULL,40371932553,630811446,9856428,16.1),(45914,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45914,36.46,0.65,196,11449,70,NULL,NULL,'2MASX J06134411-4114394',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,93.433875,-41.24442,0.269,NULL,38936405380,608381334,9505958,15.8),(45915,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45915,36.23,0.85,176,11450,70,NULL,NULL,'2MASX J06134519-7255464',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'16.2b',0.38,NULL,NULL,NULL,NULL,NULL,1,93.438333,-72.92964,0.329,NULL,39867350653,622927353,9733239,16.2),(45916,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45916,35.38,0.47,119,11451,70,NULL,NULL,'2MASX J06134795-6755146',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.000103,NULL,'15.2b',0.62,NULL,NULL,NULL,NULL,NULL,1,93.4499583,-67.92069,0.257,NULL,40601655111,634400861,9912513,15.2),(45917,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45917,36.5,0.61,200,11452,70,NULL,NULL,'2MASX J06135066-3611124',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,93.461125,-36.18683,0.149,NULL,38969797514,608903086,9514110,14.3),(45918,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,'R',45918,33.68,0.49,54.5,11453,75,NULL,'IR','UGC 03405',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000017,NULL,'15.32',0.4,'Sbc','Pair member (points to parent)',NULL,NULL,NULL,1,93.49,80.47633,0.317,NULL,61223672095,956619876,14947185,15.32),(45919,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45919,33.75,0.4,56.2,11453,NULL,NULL,'mean','UGC 03405',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45920,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45920,33.98,0.45,62.4,11453,NULL,NULL,'K','UGC 03405',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45921,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45921,34.03,0.47,63.9,11453,NULL,NULL,'H','UGC 03405',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45922,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45922,34.09,0.46,65.9,11453,NULL,NULL,'J','UGC 03405',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45923,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45923,36.31,0.62,183,11454,70,NULL,NULL,'2MASX J06140222-6624145',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.000103,NULL,'16.7b',0.29,NULL,NULL,NULL,NULL,NULL,1,93.5092917,-66.404,0.189,NULL,40335713553,630245524,9847586,16.7),(45924,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45924,35.13,0.55,106,11455,NULL,NULL,NULL,'ESO 254- G 043',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.05',0.6,'(R\')SA(rs)bc',NULL,NULL,NULL,NULL,1,93.5147917,-42.85783,0.189,NULL,38924441655,608194400,9503037,15.05),(45925,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45925,35.17,0.2,108,11455,74.4,NULL,NULL,'ESO 254- G 043',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45926,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45926,35.25,0.52,112,11455,NULL,NULL,'Malmquist cor.','ESO 254- G 043',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45927,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45927,34.68,0.53,86.1,11456,70,NULL,NULL,'ESO 121- G 018',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000117,NULL,'15.15',0.4,'S0^+',NULL,NULL,NULL,NULL,1,93.535833,-58.69486,0.121,NULL,40368621881,630759716,9855620,15.15),(45928,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45928,36.71,0.54,220,11457,70,NULL,NULL,'2MASX J06140873-3601294',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,93.536417,-36.02486,0.149,NULL,38969561100,608899392,9514053,14.8),(45929,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45929,36.75,0.62,224,11458,70,NULL,NULL,'2MASX J06140933-7458004',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,93.5392083,-74.96686,0.433,NULL,39892016460,623312757,9739261,16.9),(45930,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45930,35.83,0.66,147,11459,70,NULL,NULL,'2MASX J06141010-5720286',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,93.542083,-57.34131,0.093,NULL,40501987307,632843551,9888180,17),(45931,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45931,35.74,0.56,141,11460,70,NULL,NULL,'2MASX J06141076-6113294',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,93.5447083333,-61.22483,0.085,NULL,40372003292,630812551,9856446,16.8),(45932,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45932,35.98,0.52,157,11461,70,NULL,NULL,'2MASX J06141223-7005195',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.000123,NULL,'14.7r',0.27,NULL,NULL,NULL,NULL,NULL,1,93.550875,-70.08872,0.413,NULL,39864041195,622875643,9732431,14.7),(45933,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45933,37.1,0.57,263,11462,70,NULL,NULL,'2MASX J06141393-3128222',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,93.558125,-31.47289,0,NULL,39154878329,611794973,9559296,15),(45934,'IRAS','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45934,33.72,0.8,55.3,11463,75,NULL,'CF, r','UGC 03410',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000007,NULL,'14.99',0.4,'Sb             LIRG','Pair member (points to parent)',NULL,NULL,NULL,1,93.6234583,80.44989,0.317,NULL,61223680990,956620015,14947187,14.99),(45935,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45935,33.7,0.45,54.9,11463,NULL,NULL,'K','UGC 03410',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45936,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45936,33.76,0.47,56.5,11463,NULL,NULL,'H','UGC 03410',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45937,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45937,33.77,0.4,56.8,11463,NULL,NULL,'mean','UGC 03410',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45938,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45938,33.85,0.46,58.8,11463,NULL,NULL,'J','UGC 03410',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45939,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45939,34.13,0.38,67.1,11463,75,NULL,'CF, r, raw','UGC 03410',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45940,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45940,34.21,0.38,69.5,11463,75,NULL,'CF, r, cor','UGC 03410',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45941,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45941,34.33,0.38,73.3,11463,75,NULL,'CF, r, inv','UGC 03410',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45942,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,'R',45942,34.48,0.49,78.7,11463,75,NULL,'IR','UGC 03410',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45943,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45943,35.28,0.5,114,11464,70,NULL,NULL,'ESO 160- G 020',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000113,NULL,'14.89',0.6,'(R_1)SB(r)0/a',NULL,NULL,NULL,NULL,1,93.627167,-53.94144,0.265,NULL,40298836950,629669327,9838583,14.89),(45944,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45944,36.23,0.69,176,11465,70,NULL,NULL,'2MFGC 05035',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'12.5K',NULL,NULL,NULL,NULL,NULL,NULL,1,93.642125,-57.98358,0.109,NULL,40369013502,630765835,9855716,12.5),(45945,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45945,35.88,0.48,150,11466,70,NULL,NULL,'2MASX J06143705-6617052',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.000103,NULL,'15.8b',0.46,NULL,NULL,NULL,NULL,NULL,1,93.654375,-66.28478,0.189,NULL,40335732634,630245822,9847590,15.8),(45946,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45946,36.76,0.6,225,11467,70,NULL,NULL,'2MASX J06144216-5459385',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,93.675625,-54.99411,0.229,NULL,40283547681,629430432,9834850,16.6),(45947,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45947,36.54,0.66,203,11468,70,NULL,NULL,'2MASX J06144369-4801432',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,93.6820416667,-48.02869,0.161,NULL,40279610753,629368918,9833889,17),(45948,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45948,35.8,0.63,144,11469,70,NULL,NULL,'2MASX J06144658-1215275',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,93.694167,-12.25758,1.585,NULL,38767780558,605746571,9464790,17.2),(45949,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,'R',45949,33.35,0.49,46.9,11470,75,NULL,'IR','UGC 03425',NULL,'2011yCatp016004901K',2011,1,2.5,NULL,'G',0.000037,NULL,'15.00',0.3,'Sb',NULL,NULL,NULL,NULL,1,93.6978333333,66.5675,0.377,NULL,61609477426,962648084,15041376,15),(45950,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45950,33.43,0.45,48.5,11470,NULL,NULL,'K','UGC 03425',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45951,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45951,33.46,0.47,49.2,11470,NULL,NULL,'H','UGC 03425',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45952,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45952,33.54,0.46,51.1,11470,NULL,NULL,'J','UGC 03425',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45953,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45953,33.79,0.4,57.2,11470,NULL,NULL,'mean','UGC 03425',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45954,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45954,35.55,0.43,129,11471,NULL,NULL,NULL,'ESO 307- G 027',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.96',0.4,'Sb:',NULL,NULL,NULL,NULL,1,93.735833,-39.82469,0.205,NULL,38978770944,609043296,9516301,15.96),(45955,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45955,35.59,0.2,131,11471,74.4,NULL,NULL,'ESO 307- G 027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45956,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45956,35.64,0.41,134,11471,NULL,NULL,'Malmquist cor.','ESO 307- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45957,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45957,36.23,0.61,176,11472,70,NULL,NULL,'2MASX J06150299-6938393',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'16.6b',0.3,NULL,NULL,NULL,NULL,NULL,1,93.7622917,-69.64436,0.409,NULL,39865926929,622905108,9732892,16.6),(45958,'IRAS','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45958,34.31,0.8,72.7,11473,75,NULL,'MAT, I','ESO 556- G 005',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.53',0.7,'SB(s)bc?','Pair member (points to parent)',NULL,NULL,NULL,1,93.78,-19.41842,0.405,NULL,39603846406,618810100,9668907,14.53),(45959,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45959,33.65,0.69,53.8,11473,100,NULL,'mid-IR','ESO 556- G 005',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45960,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45960,33.89,0.32,60,11473,85,NULL,'I, raw','ESO 556- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45961,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45961,33.93,0.32,61.1,11473,85,NULL,'I, inv','ESO 556- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45962,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45962,33.96,0.43,62,11473,75,NULL,'MAT, I, raw','ESO 556- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45963,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45963,34.15,0.43,67.5,11473,75,NULL,'MAT, I, inv','ESO 556- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45964,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45964,34.49,0.43,79,11473,75,NULL,'MAT, I, cor','ESO 556- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45965,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45965,34.55,0.42,81.4,11473,NULL,NULL,NULL,'ESO 556- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45966,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45966,34.59,0.2,82.8,11473,74.4,NULL,NULL,'ESO 556- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45967,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45967,34.63,0.4,84.4,11473,NULL,NULL,'Malmquist cor.','ESO 556- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45968,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45968,34.75,0.4,89.2,11473,NULL,NULL,'mean','ESO 556- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45969,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45969,34.89,0.47,94.9,11473,NULL,NULL,'H','ESO 556- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45970,'Sosies','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45970,34.13,0.39,67,11474,NULL,NULL,NULL,'UGC 03422',NULL,'2002A&A...393...57T',2002,1,2,NULL,'G',0.000017,NULL,'14.1',1.6,'SAB(rs)b','in a pair',NULL,NULL,NULL,1,93.7839166667,71.13669,0.453,NULL,61284803865,957575060,14962110,14.1),(45971,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45971,33.85,0.4,58.8,11474,NULL,NULL,'mean','UGC 03422',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45972,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45972,34.64,0.46,84.5,11474,NULL,NULL,'J','UGC 03422',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45973,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45973,34.71,0.47,87.3,11474,NULL,NULL,'H','UGC 03422',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45974,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45974,34.73,0.45,88.2,11474,NULL,NULL,'K','UGC 03422',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45975,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45975,36.99,0.58,250,11475,70,NULL,NULL,'2MASX J06151098-5734042',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,93.7959166667,-57.56786,0.097,NULL,40502009497,632843898,9888185,16.3),(45976,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45976,36.56,0.61,205,11476,70,NULL,NULL,'2MASX J06151463-5756542',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,93.811125,-57.94844,0.109,NULL,40368511465,630757991,9855593,16.3),(45977,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45977,37.08,0.56,261,11477,70,NULL,NULL,'2MASX J06151543-6149539',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,93.8144583,-61.83164,0.129,NULL,40390396940,631099952,9860936,15.8),(45978,'Tully est','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45978,31.69,0.8,21.8,11478,75,NULL,NULL,'UGCA 122',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000024,NULL,'15.01',1.2,'IAB(s)m',NULL,NULL,NULL,NULL,1,93.829167,-26.58028,0.193,NULL,39120618925,611259670,9550932,15.01),(45979,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45979,36.96,0.89,247,11479,70,NULL,NULL,'2MFGC 05048',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'12.5K',NULL,NULL,NULL,NULL,NULL,NULL,1,93.854,-52.24753,0.153,NULL,40325220010,630081562,9845024,12.5),(45980,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45980,35.52,0.51,127,11480,70,NULL,NULL,'2MASX J06152893-5137261',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,93.870417,-51.62389,0.149,NULL,40325885025,630091953,9845186,16.6),(45981,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45981,35.85,0.53,148,11481,70,NULL,NULL,'2MASX J06153208-3204000',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,93.883667,-32.06664,0.045,NULL,39155857086,611810266,9559535,14.5),(45982,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45982,33.81,0.4,57.9,11482,NULL,NULL,'mean','UGC 03426',NULL,'2007A&A...465...71T',2007,1,1.8,'One of two 6cm sources associated with [WB92] 0609+7103','G',0.000017,NULL,'14.03',1.6,'S0:            Sy2','in a pair',NULL,'radio jet','Sy 2',1,93.9015,71.03753,0.453,NULL,61284730611,957573915,14962092,14.03),(45983,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45983,34.18,0.45,68.5,11482,NULL,NULL,'K','UGC 03426',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45984,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45984,34.26,0.39,71.2,11483,NULL,NULL,'Malmquist cor.','UGC 03412',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000037,NULL,'16.0',0.5,'Scd:',NULL,NULL,NULL,NULL,1,93.913625,79.70894,0.401,NULL,61220997569,956578087,14946532,16),(45985,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45985,34.44,0.2,77.3,11483,74.4,NULL,NULL,'UGC 03412',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45986,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45986,34.58,0.34,82.5,11483,NULL,NULL,NULL,'UGC 03412',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45987,'Tully est','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45987,30.84,0.8,14.7,11484,75,NULL,NULL,'UKS 0616-708',NULL,'1988NBGC.C....0000T',1988,1,2,NULL,'G',0.000013,NULL,'15.5',0.8,'SB(s)dm',NULL,NULL,NULL,NULL,1,93.955,-70.895,0.381,NULL,39878143646,623095994,9735874,15.5),(45988,'TRGB','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45988,28.86,0.1,5.92,11485,NULL,NULL,NULL,'ESO 121- G 020',NULL,'2012A&A...540A..49M',2012,1,2.2,NULL,'G',0.000007,NULL,'15.8B',1.7,'Im pec:',NULL,NULL,NULL,NULL,1,93.9757916667,-57.72544,0.105,NULL,40501894316,632842098,9888157,15.8),(45989,'TRGB','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45989,28.9,0.05,6.03,11485,NULL,NULL,'I','ESO 121- G 020',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45990,'TRGB','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45990,28.91,NULL,6.05,11485,NULL,NULL,NULL,'ESO 121- G 020',NULL,'2006AJ....131.1361K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45991,'TRGB','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45991,28.92,0.1,6.08,11485,74.4,NULL,NULL,'ESO 121- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45992,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45992,37.21,0.54,277,11486,70,NULL,NULL,'2MASX J06155497-5726568',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,93.979167,-57.44919,0.097,NULL,40501975509,632843367,9888177,16.9),(45993,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45993,35.87,0.38,149,11487,NULL,NULL,'Malmquist cor.','ESO 160- G 021',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.30',0.4,'SAB(s)b',NULL,NULL,NULL,NULL,1,93.9959166667,-54.81583,0.229,NULL,40297665168,629651018,9838297,15.3),(45994,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45994,35.96,0.37,156,11487,NULL,NULL,NULL,'ESO 160- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45995,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45995,36,0.2,158,11487,74.4,NULL,NULL,'ESO 160- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45996,'IRAS','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45996,34.51,0.8,79.7,11488,75,NULL,'MAT, I','NGC 2206',NULL,'1997ApJS..109..333W',1997,1,2.4,NULL,'G',0.00001,NULL,'12.91',1.3,'SAB(rs)bc:',NULL,NULL,NULL,NULL,1,93.999333,-26.76547,0.097,NULL,39124102500,611314101,9551782,12.91),(45997,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45997,33.85,0.69,58.9,11488,100,NULL,'mid-IR','NGC 2206',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45998,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45998,33.98,0.43,62.5,11488,75,NULL,'MAT, I, raw','NGC 2206',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45999,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,45999,34.07,0.32,65.3,11488,85,NULL,'I, raw','NGC 2206',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46000,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,46000,34.07,0.46,65.3,11488,NULL,NULL,'J','NGC 2206',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46001,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,46001,34.1,0.47,66.1,11488,NULL,NULL,'H','NGC 2206',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46002,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,46002,34.13,0.45,67,11488,NULL,NULL,'K','NGC 2206',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46003,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,46003,34.16,0.32,67.9,11488,85,NULL,'I, inv','NGC 2206',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46004,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,46004,34.33,0.43,73.4,11488,75,NULL,'MAT, I, inv','NGC 2206',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46005,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,46005,34.46,0.2,78,11488,74.4,NULL,NULL,'NGC 2206',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46006,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,46006,34.49,0.43,78.9,11488,75,NULL,'MAT, I, cor','NGC 2206',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46007,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,46007,34.56,0.4,81.7,11488,NULL,NULL,NULL,'NGC 2206',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46008,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,46008,34.59,0.39,82.9,11488,NULL,NULL,'Malmquist cor.','NGC 2206',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46009,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,46009,34.66,0.4,85.4,11488,NULL,NULL,'mean','NGC 2206',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46010,'IRAS','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,46010,34.35,0.8,74,11489,75,NULL,'CF, r','UGC 03420',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.000017,NULL,'14.10',0.8,'Sb','Isolated galaxy',NULL,NULL,NULL,1,94.005875,75.9365,0.361,NULL,61319047276,958110113,14970470,14.1),(46011,'Sosies','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,46011,34.52,0.42,80.2,11489,NULL,NULL,NULL,'UGC 03420',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46012,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,46012,33.98,0.47,62.5,11489,NULL,NULL,'H','UGC 03420',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46013,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,46013,34,0.46,63.1,11489,NULL,NULL,'J','UGC 03420',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46014,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,46014,34.08,0.45,65.3,11489,NULL,NULL,'K','UGC 03420',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46015,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,46015,34.31,0.4,72.7,11489,NULL,NULL,'mean','UGC 03420',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46016,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,46016,34.36,0.38,74.4,11489,75,NULL,'CF, r, raw','UGC 03420',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46017,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,46017,34.39,0.38,75.7,11489,75,NULL,'CF, r, cor','UGC 03420',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46018,'Tully-Fisher','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,46018,34.59,0.38,82.7,11489,75,NULL,'CF, r, inv','UGC 03420',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46019,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,46019,35.84,0.76,148,11490,70,NULL,NULL,'2MASX J06160666-4749457',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.6I',0.5,NULL,NULL,NULL,NULL,NULL,1,94.0277083,-47.82933,0.161,NULL,40279837321,629372458,9833944,13.6),(46020,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,46020,36.01,0.6,159,11491,70,NULL,NULL,'2MASX J06160783-5116253',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,94.032667,-51.27372,0.145,NULL,40327406317,630115723,9845558,16.6),(46021,'FP','2016-12-15 15:14:13','2016-12-16 11:19:19','1',NULL,NULL,46021,37.02,0.64,254,11492,70,NULL,NULL,'2MASX J06161354-3428114',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,94.056417,-34.46981,0.221,NULL,38966360341,608849380,9513271,14.8),(46022,'SNIa','2016-12-15 15:14:13','2016-12-16 11:19:19','1','SN 1996bv',NULL,46022,33.49,0.21,49.1,11493,74.2,NULL,'SALT 2','UGC 03432',0.01667,'2010ApJ...716..712A',2010,1,1.7,NULL,'G',0.000037,NULL,'15.28',0.4,'Scd:',NULL,NULL,NULL,NULL,1,94.0567916667,57.0515,0.585,NULL,61693899559,963967180,15061987,15.28),(46023,'SNIa','2016-12-15 15:14:13','2016-12-16 11:19:19','1','SN 1996bv',NULL,46023,33.9,0.04,59.2,11493,72,NULL,NULL,'UGC 03432',0.01667,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46024,'SNIa','2016-12-15 15:14:13','2016-12-16 11:19:19','1','SN 1996bv',NULL,46024,33.96,0.08,61.9,11493,74.4,NULL,NULL,'UGC 03432',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46025,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:19','1','SN 1996bv',NULL,46025,34.04,0.19,63.2,11493,70,NULL,'SALT 2','UGC 03432',0.01667,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46026,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:19','1','SN 1996bv',NULL,46026,34.08,0.09,65.5,11493,60,NULL,'M(I) = -19.19 mag','UGC 03432',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46027,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:19','1','SN 1996bv',NULL,46027,34.15,0.24,66.5,11493,72,NULL,NULL,'UGC 03432',0.01667,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46028,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:19','1','SN 1996bv',NULL,46028,34.16,0.21,66.8,11493,70,NULL,'SALT','UGC 03432',0.01667,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46029,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:19','1','SN 1996bv',NULL,46029,34.17,0.16,67.1,11493,65,NULL,'MLCS2k2','UGC 03432',0.01667,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46030,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:19','1','SN 1996bv',NULL,46030,34.21,0.16,67.3,11493,65,NULL,'MLCS2k2','UGC 03432',0.01667,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46031,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:19','1','SN 1996bv',NULL,46031,34.18,0.24,67.4,11493,65,NULL,'MLCS31','UGC 03432',0.01667,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46032,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:19','1','SN 1996bv',NULL,46032,34.21,0.23,68.4,11493,65,NULL,NULL,'UGC 03432',0.01667,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46033,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:19','1','SN 1996bv',NULL,46033,34.26,0.25,69.9,11493,65,NULL,'SALT','UGC 03432',0.01667,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46034,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:19','1','SN 1996bv',NULL,46034,34.26,0.17,71.1,11493,70.8,NULL,NULL,'UGC 03432',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46035,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:19','1','SN 1996bv',NULL,46035,34.31,0.22,71.7,11493,65,NULL,'MLCS17','UGC 03432',0.01667,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46036,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:19','1','SN 1996bv',NULL,46036,34.32,0.13,71.9,11493,70,NULL,NULL,'UGC 03432',0.01667,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46037,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:19','1','SN 1996bv',NULL,46037,34.31,0.1,72.8,11493,60,NULL,'M(V) = -19.47 mag','UGC 03432',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46038,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:19','1','SN 1996bv',NULL,46038,34.35,0.24,72.8,11493,65,NULL,'SALT2','UGC 03432',0.01667,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46039,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:19','1','SN 1996bv',NULL,46039,34.46,0.13,78,11493,60,NULL,'M(B) = -19.48 mag','UGC 03432',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46040,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:19','1','SN 1996bv',NULL,46040,34.59,0.03,81.3,11493,65,NULL,'SALT','UGC 03432',0.01667,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46041,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:19','1','SN 1996bv',NULL,46041,34.62,0.14,83.9,11493,60,NULL,NULL,'UGC 03432',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46042,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:19','1','SN 1996bv',NULL,46042,34.98,0.05,97.6,11493,70,NULL,'SALT 2','UGC 03432',0.01667,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46043,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46043,33.96,0.08,61.9,11493,74.4,NULL,NULL,'UGC 03432',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46044,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46044,34.01,0.4,63.4,11493,75,NULL,'HOSTS SN 1996bv','UGC 03432',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46045,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,'R',46045,34.1,0.49,66.1,11493,75,NULL,'IR','UGC 03432',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46046,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46046,34.13,0.43,67.1,11493,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03432',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46047,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46047,34.14,0.43,67.3,11493,75,NULL,'3.6 micron, color corrected','UGC 03432',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46048,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46048,34.17,0.42,68.2,11493,NULL,18.48,'3.6 micron','UGC 03432',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46049,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46049,34.22,0.46,69.9,11493,NULL,NULL,NULL,'UGC 03432',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46050,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46050,34.35,0.43,74.2,11493,NULL,NULL,'Malmquist cor.','UGC 03432',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46051,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:19','1','SN 1975A',NULL,46051,32.78,0.58,36,11494,75,NULL,'Photographic, kinematic','NGC 2207',NULL,'1982ApJ...254....1A',1982,1,4.3,'HOLM 085B is part of the inner ring of NGC 2207.','G',0.00005,NULL,'11.3B',2.8,'SAB(rs)bc pec','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,94.0917916667,-21.37267,0.493,NULL,39610882171,618920033,9670625,11.3),(46052,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:19','1','SN 1975A',NULL,46052,32.99,0.3,39.6,11494,75,NULL,'Photographic, dynamic','NGC 2207',NULL,'1982ApJ...254....1A',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46053,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:19','1','SN 1975A','R',46053,33.33,NULL,46.3,11494,NULL,NULL,'Photographic','NGC 2207',NULL,'1988SSRv...48....1R',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46054,'Tully est','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46054,32.61,0.8,33.3,11494,75,NULL,'B','NGC 2207',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46055,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46055,31.07,NULL,16.4,11494,75,NULL,'B','NGC 2207',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46056,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46056,31.12,0.46,16.8,11494,NULL,NULL,'J','NGC 2207',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46057,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46057,31.14,0.47,16.9,11494,NULL,NULL,'H','NGC 2207',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46058,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46058,31.14,0.45,16.9,11494,NULL,NULL,'K','NGC 2207',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46059,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46059,32.79,0.4,36.1,11494,NULL,NULL,'mean','NGC 2207',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46060,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46060,37.78,0.9,360,11495,70,NULL,NULL,'LCSB S0947P',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,94.0935417,-13.45456,1.765,NULL,38773915938,605842436,9466288,17.3),(46061,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46061,35.86,0.54,148,11496,70,NULL,NULL,'2MASX J06162382-5145373',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.9I',0.3,NULL,NULL,NULL,NULL,NULL,1,94.0992917,-51.76031,0.153,NULL,40325915958,630092436,9845194,13.9),(46062,'GRB','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,'N',46062,38.21,NULL,438,11497,65,NULL,'L = 10e57 photons/s','GRB 790313',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46063,'GRB','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,'N',46063,41.07,NULL,1640,11497,65,NULL,'L = 2 x 10e58 photons/s','GRB 790313',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46064,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46064,31.61,0.47,21,11498,NULL,NULL,'H','IC 2163',NULL,'2007A&A...465...71T',2007,1,3,NULL,'G',0.000067,NULL,'11.6',1.2,'SB(rs)c pec','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,94.116583,-21.37586,0.493,NULL,39610361657,618911900,9670498,11.6),(46065,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46065,31.62,0.45,21.1,11498,NULL,NULL,'K','IC 2163',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46066,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46066,31.64,0.46,21.3,11498,NULL,NULL,'J','IC 2163',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46067,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46067,32.75,0.4,35.4,11498,NULL,NULL,'mean','IC 2163',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46068,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46068,36.04,0.59,162,11499,70,NULL,NULL,'2MASX J06163363-5144484',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,94.1402083,-51.74681,0.153,NULL,40325920103,630092501,9845195,15.6),(46069,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46069,36.96,0.64,247,11500,70,NULL,NULL,'ESO 121-IG 021',NULL,'2014MNRAS.445.2677S',2014,1,0.7,'ESO-LV has V = 9329 +- 98 km/s.','G',0.00015,NULL,'15.84',0.7,'S...',NULL,NULL,NULL,NULL,1,94.152583,-60.1425,0.105,NULL,40379241569,630925649,9858213,15.84),(46070,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46070,37.19,0.56,274,11501,70,NULL,NULL,'2MASX J06164035-4334427',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.3,NULL,NULL,NULL,NULL,NULL,1,94.168125,-43.57858,0.161,NULL,42415088319,662735754,10355246,14),(46071,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46071,35.95,0.51,155,11502,70,NULL,NULL,'ESO 206- G 003',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.28',0.2,'S0/N',NULL,NULL,NULL,NULL,1,94.173625,-51.60042,0.149,NULL,40325466224,630085409,9845084,16.28),(46072,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46072,36.71,0.56,220,11503,70,NULL,NULL,'2MASX J06164817-2354548',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,94.200667,-23.91531,0.249,NULL,39069804173,610465690,9538526,15.3),(46073,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46073,35.71,0.56,139,11504,70,NULL,NULL,'2MASX J06164878-6616047',NULL,'2014MNRAS.445.2677S',2014,1,0.27,NULL,'G',0.000103,NULL,'16.9b',0.27,NULL,NULL,NULL,NULL,NULL,1,94.2034583333,-66.26797,0.197,NULL,40333971892,630218310,9847161,16.9),(46074,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46074,36.74,0.56,223,11505,70,NULL,NULL,'2MASX J06165219-3410572',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,94.2175,-34.18247,0.149,NULL,39147783724,611684120,9557564,15.5),(46075,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46075,36.19,0.62,173,11506,70,NULL,NULL,'ESO 206- G 004',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.95',0.7,'(R)SB(l)0/a:',NULL,NULL,NULL,NULL,1,94.227917,-48.31947,0.173,NULL,40279513554,629367399,9833865,15.95),(46076,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46076,34.94,0.4,97.5,11507,NULL,NULL,'mean','MCG -02-16-008',NULL,'2007A&A...465...71T',2007,1,0.6,'6dF DR1 has z = 0.021770.','G',0.000017,NULL,'15',0.25,'Sc             HII',NULL,NULL,NULL,NULL,1,94.239125,-13.08669,1.713,NULL,38773770544,605840164,9466252,15),(46077,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46077,34.98,0.47,99,11507,NULL,NULL,'H','MCG -02-16-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46078,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46078,35.09,0.45,104,11507,NULL,NULL,'K','MCG -02-16-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46079,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46079,33.2,0.43,43.7,11508,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03413',NULL,'2014MNRAS.444..527S',2014,1,2.1,NULL,'G',0.000023,NULL,'13.50',1.6,'SB(r)bc',NULL,NULL,NULL,NULL,1,94.253667,81.13775,0.369,NULL,61223177681,956612151,14947064,13.5),(46080,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46080,33.27,0.43,45,11508,75,NULL,'3.6 micron, color corrected','UGC 03413',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46081,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46081,33.35,0.2,46.8,11508,74.4,NULL,NULL,'UGC 03413',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46082,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46082,33.42,0.83,48.2,11508,NULL,NULL,NULL,'UGC 03413',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46083,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46083,33.43,0.47,48.6,11508,NULL,NULL,'H','UGC 03413',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46084,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46084,33.48,0.45,49.6,11508,NULL,NULL,'K','UGC 03413',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46085,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46085,33.5,0.46,50.1,11508,NULL,NULL,'J','UGC 03413',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46086,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46086,33.53,0.79,50.7,11508,NULL,NULL,'Malmquist cor.','UGC 03413',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46087,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46087,33.88,0.4,59.6,11508,NULL,NULL,'mean','UGC 03413',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46088,'IRAS','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46088,31.93,0.8,24.4,11509,75,NULL,'MAT, I','UGCA 126',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000021,NULL,'13.33',0.5,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,94.2700416667,-27.38858,0.125,NULL,39121656797,611275887,9551185,13.33),(46089,'Tully est','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46089,31.56,0.8,20.5,11509,75,NULL,NULL,'UGCA 126',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46090,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,'R',46090,31.92,0.4,24.2,11509,75,NULL,NULL,'UGCA 126',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46091,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46091,31.92,0.39,24.2,11509,73,NULL,'IR','UGCA 126',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46092,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46092,31.95,0.4,24.5,11509,73,NULL,'opt','UGCA 126',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46093,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46093,31.95,0.32,24.5,11509,85,NULL,'I, raw','UGCA 126',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46094,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46094,31.97,0.4,24.8,11509,NULL,NULL,NULL,'UGCA 126',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46095,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46095,31.97,0.32,24.8,11509,85,NULL,'I, inv','UGCA 126',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46096,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46096,32.04,0.46,25.6,11509,NULL,NULL,'J','UGCA 126',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46097,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46097,32.07,0.4,26,11509,NULL,NULL,'mean','UGCA 126',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46098,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46098,32.08,0.47,26,11509,NULL,NULL,'H','UGCA 126',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46099,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46099,32.08,0.43,26,11509,75,NULL,'MAT, I, raw','UGCA 126',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46100,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46100,32.1,0.45,26.3,11509,NULL,NULL,'K','UGCA 126',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46101,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46101,32.12,0.43,26.5,11509,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 126',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46102,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46102,32.21,0.43,27.6,11509,75,NULL,'3.6 micron, color corrected','UGCA 126',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46103,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46103,32.23,0.43,27.9,11509,75,NULL,'MAT, I, inv','UGCA 126',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46104,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,'R',46104,32.29,0.49,28.7,11509,75,NULL,'IR','UGCA 126',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46105,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46105,32.32,0.2,29.1,11509,74.4,NULL,NULL,'UGCA 126',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46106,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46106,32.38,0.43,29.9,11509,75,NULL,'MAT, I, cor','UGCA 126',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46107,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46107,32.44,0.39,30.7,11509,73,NULL,'opt','UGCA 126',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46108,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46108,32.47,0.41,31.3,11509,NULL,NULL,NULL,'UGCA 126',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46109,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46109,32.53,0.4,32.1,11509,NULL,NULL,'Malmquist cor.','UGCA 126',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46110,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46110,36.26,0.77,179,11510,70,NULL,NULL,'2MASX J06170706-5102269',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,94.279333,-51.04089,0.145,NULL,40326873170,630107393,9845428,14.2),(46111,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46111,35.67,0.59,136,11511,70,NULL,NULL,'2MASX J06171406-5059419',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,94.308583,-50.995,0.145,NULL,40326875860,630107435,9845428,16.5),(46112,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,'R',46112,34.12,0.49,66.8,11512,75,NULL,'IR','2MFGC 05069',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.000013,NULL,'11.5K',0.2,NULL,NULL,NULL,NULL,NULL,1,94.315875,28.45336,NULL,NULL,62933264033,983332250,15364566,11.5),(46113,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46113,35.16,0.46,108,11513,70,NULL,NULL,'ESO 160- G 022',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'14.07',0.8,'(R\')SB(r)b',NULL,NULL,NULL,NULL,1,94.3205833333,-55.54942,0.201,NULL,40283327689,629426995,9834796,14.07),(46114,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46114,34.57,0.61,82,11514,70,NULL,NULL,'2MASX J06174134-0647419',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,94.422375,-6.795,1.861,NULL,38676253256,604316457,9442444,17.3),(46115,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46115,33.55,NULL,51.3,11515,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03423',NULL,'2010Ap&SS.325..163P',2010,1,1.46,'The KUG position is for the bright knot or superposed star on the south end.','G',0.000023,NULL,'16.5',0.2,'Sdm',NULL,NULL,NULL,NULL,1,94.42725,78.82178,0.373,NULL,61438566682,959977604,14999650,16.5),(46116,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46116,33.57,NULL,51.7,11515,NULL,NULL,'Dipole + Quadrupole','UGC 03423',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46117,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46117,33.57,NULL,51.8,11515,NULL,NULL,'Dipole','UGC 03423',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46118,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46118,33.72,NULL,55.4,11515,NULL,NULL,NULL,'UGC 03423',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46119,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46119,33.99,0.43,62.8,11515,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03423',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46120,'IRAS','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46120,32.81,0.8,36.4,11516,75,NULL,'MAT, I','ESO 556- G 012',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000007,NULL,'14.91',0.9,'SB(s)m',NULL,NULL,NULL,NULL,1,94.455167,-21.06056,0.541,NULL,39610315795,618911184,9670487,14.91),(46121,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46121,32.84,0.32,37,11516,85,NULL,'I, inv','ESO 556- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46122,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46122,32.85,0.32,37.1,11516,85,NULL,'I, raw','ESO 556- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46123,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46123,33.01,0.43,39.9,11516,75,NULL,'MAT, I, raw','ESO 556- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46124,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46124,33.04,0.43,40.5,11516,75,NULL,'MAT, I, inv','ESO 556- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46125,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46125,33.07,0.43,41.2,11516,75,NULL,'MAT, I, cor','ESO 556- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46126,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46126,33.49,0.2,49.9,11516,74.4,NULL,NULL,'ESO 556- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46127,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46127,33.52,0.86,50.6,11516,NULL,NULL,'Malmquist cor.','ESO 556- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46128,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46128,33.76,0.77,56.4,11516,NULL,NULL,NULL,'ESO 556- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46129,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46129,34.58,0.66,82.3,11517,70,NULL,NULL,'2MASX J06175102-3251186',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,94.4625833333,-32.85514,0.049,NULL,39157045050,611828828,9559825,14.8),(46130,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46130,36,0.75,159,11518,70,NULL,NULL,'2MASX J06180711-7020348',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.7b',0.23,NULL,NULL,NULL,NULL,NULL,1,94.5295,-70.34308,0.389,NULL,39878406366,623100099,9735939,16.7),(46131,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46131,33.73,NULL,55.7,11519,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 489- G 033',NULL,'2010Ap&SS.325..163P',2010,1,1.02,'Star superposed.','G',0.000027,NULL,'16.59',0.14,'Sd',NULL,NULL,NULL,NULL,1,94.542917,-24.92111,0.181,NULL,39113558663,611149354,9549208,16.59),(46132,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46132,33.76,NULL,56.5,11519,NULL,NULL,'Dipole + Quadrupole','ESO 489- G 033',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46133,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46133,33.77,NULL,56.7,11519,NULL,NULL,'Dipole','ESO 489- G 033',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46134,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46134,33.84,NULL,58.6,11519,NULL,NULL,NULL,'ESO 489- G 033',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46135,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46135,35.97,0.5,156,11520,70,NULL,NULL,'2MASX J06181136-4856040',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.5I',0.6,NULL,NULL,NULL,NULL,NULL,1,94.54725,-48.93444,0.189,NULL,40278324119,629348814,9833575,13.5),(46136,'IRAS','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46136,35.12,0.8,106,11521,75,NULL,'MAT, I','ESO 087- G 003',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'14.61',0.4,'(R\'_2)SAB(rs)ab',NULL,NULL,NULL,NULL,1,94.5863333333,-66.01753,0.189,NULL,40347651650,630432057,9850500,14.61),(46137,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46137,34.35,0.43,74,11521,75,NULL,'MAT, I, raw','ESO 087- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46138,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46138,34.54,0.32,80.8,11521,85,NULL,'I, raw','ESO 087- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46139,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46139,34.61,0.32,83.5,11521,85,NULL,'I, inv','ESO 087- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46140,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46140,34.65,0.43,85,11521,75,NULL,'MAT, I, inv','ESO 087- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46141,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46141,34.74,0.43,88.5,11521,75,NULL,'MAT, I, cor','ESO 087- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46142,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46142,34.8,0.47,91.3,11521,NULL,NULL,'Malmquist cor.','ESO 087- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46143,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46143,34.93,0.45,96.6,11521,NULL,NULL,NULL,'ESO 087- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46144,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46144,34.97,0.2,98.6,11521,74.4,NULL,NULL,'ESO 087- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46145,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46145,36.5,0.57,200,11522,70,NULL,NULL,'2MASX J06182121-6031066',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,94.588333,-60.51853,0.113,NULL,40379179176,630924674,9858198,14.2),(46146,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46146,36.57,0.6,206,11523,70,NULL,NULL,'2MASX J06183089-5458239',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.4I',0.3,'(R\')SA(s)a:',NULL,NULL,NULL,NULL,1,94.6287083,-54.9735,0.229,NULL,40296943007,629639734,9838120,14.4),(46147,'TRGB','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46147,31.28,NULL,18,11524,NULL,NULL,NULL,'NGC 2146',NULL,'2012MNRAS.426.1185A',2012,1,6,NULL,'G',0.000013,NULL,'11.38',3.4,'SB(s)ab p; HII;LIRG','Pair member (points to parent)',NULL,NULL,NULL,1,94.657125,78.35703,0.305,NULL,61304693459,957885835,14966966,11.38),(46148,'GC radius','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46148,31.28,NULL,18,11524,NULL,NULL,NULL,'NGC 2146',NULL,'2012MNRAS.426.1185A',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46149,'Sosies','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46149,32.21,0.4,27.7,11524,NULL,NULL,NULL,'NGC 2146',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46150,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,'R',46150,30.89,NULL,15.1,11524,NULL,NULL,'LEDA [April 2006]','NGC 2146',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46151,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46151,31.18,0.4,17.2,11524,75,NULL,'B','NGC 2146',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46152,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46152,31.82,NULL,23.1,11524,65.2,NULL,'CO','NGC 2146',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46153,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46153,32.18,NULL,27.3,11524,54,NULL,'HI','NGC 2146',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46154,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46154,32.42,NULL,30.5,11524,75,NULL,'CO','NGC 2146',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46155,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46155,32.99,NULL,39.7,11524,75,NULL,'HI','NGC 2146',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46156,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46156,34.61,0.57,83.5,11525,70,NULL,NULL,'2MASX J06183926-5428139',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.2I',0.6,NULL,NULL,NULL,NULL,NULL,1,94.6637083,-54.47053,0.253,NULL,40297243935,629644436,9838194,13.2),(46157,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46157,35.85,0.5,148,11526,70,NULL,NULL,'2MASX J06183950-5024416',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.7I',0.4,NULL,NULL,NULL,NULL,NULL,1,94.6645,-50.41156,0.089,NULL,40326326999,630098859,9845294,13.7),(46158,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46158,32.39,0.46,30,11527,NULL,NULL,'J','2MASX J06190264+0309512',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000007,NULL,'13.14',0.56,'Sb',NULL,NULL,NULL,NULL,1,94.7610833333,3.16428,NULL,NULL,62341882706,974091917,15220186,13.14),(46159,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46159,32.42,0.47,30.4,11527,NULL,NULL,'H','2MASX J06190264+0309512',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46160,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46160,32.47,0.45,31.2,11527,NULL,NULL,'K','2MASX J06190264+0309512',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46161,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46161,33.02,0.4,40.2,11527,NULL,NULL,'mean','2MASX J06190264+0309512',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46162,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46162,33.06,0.4,40.9,11527,NULL,NULL,NULL,'2MASX J06190264+0309512',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46163,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46163,33.19,0.2,43.5,11527,74.4,NULL,NULL,'2MASX J06190264+0309512',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46164,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46164,33.28,0.43,45.3,11527,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J06190264+0309512',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46165,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46165,33.32,0.43,46.1,11527,75,NULL,'3.6 micron, color corrected','2MASX J06190264+0309512',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46166,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46166,34.04,0.49,64.2,11528,70,NULL,NULL,'2MASX J06190373-0838130',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000103,NULL,'12.5I',1.1,NULL,NULL,NULL,NULL,NULL,1,94.765583,-8.63692,1.837,NULL,38902614765,607853355,9497708,12.5),(46167,'IRAS','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46167,34.5,0.8,79.5,11529,75,NULL,'MAT, I','MCG -03-16-023',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000027,NULL,'15',0.3,'SBbc?',NULL,NULL,NULL,NULL,1,94.767625,-16.94728,1.005,NULL,38781122160,605955033,9468047,15),(46168,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46168,33.79,0.32,57.4,11529,85,NULL,'I, raw','MCG -03-16-023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46169,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46169,33.81,0.43,57.9,11529,75,NULL,'MAT, I, raw','MCG -03-16-023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46170,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46170,33.84,0.32,58.6,11529,85,NULL,'I, inv','MCG -03-16-023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46171,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46171,34.01,0.43,63.4,11529,75,NULL,'MAT, I, inv','MCG -03-16-023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46172,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46172,34.34,0.43,73.8,11529,75,NULL,'MAT, I, cor','MCG -03-16-023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46173,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46173,34.46,0.2,78,11529,74.4,NULL,NULL,'MCG -03-16-023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46174,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46174,34.72,0.47,88.1,11529,NULL,NULL,'H','MCG -03-16-023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46175,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46175,34.83,0.45,92.5,11529,NULL,NULL,'K','MCG -03-16-023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46176,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46176,34.83,0.4,92.7,11529,NULL,NULL,'mean','MCG -03-16-023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46177,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46177,34.92,0.46,96.5,11529,NULL,NULL,'J','MCG -03-16-023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46178,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46178,36.33,0.58,185,11530,70,NULL,NULL,'AM 0617-274',NULL,'2014MNRAS.445.2677S',2014,1,0.1,NULL,'G',0.00015,NULL,'15.3R',NULL,'COMPACT',NULL,NULL,NULL,NULL,1,94.7953333333,-27.72367,0.153,NULL,39110555494,611102429,9548475,15.3),(46179,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46179,33.52,0.47,50.6,11531,NULL,NULL,'H','IC 0440',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000033,NULL,'14.16',0.9,'SA(r)ab','Pair member (points to parent)',NULL,NULL,NULL,1,94.8054583,80.06847,0.405,NULL,61220400531,956568758,14946386,14.16),(46180,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46180,33.54,0.46,51.1,11531,NULL,NULL,'J','IC 0440',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46181,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46181,33.57,0.45,51.8,11531,NULL,NULL,'K','IC 0440',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46182,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46182,33.95,0.4,61.6,11531,NULL,NULL,'mean','IC 0440',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46183,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46183,37.7,0.82,347,11532,70,NULL,NULL,'2MASX J06191833-4843303',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,94.826333,-48.72511,0.169,NULL,40276380498,629318445,9833100,16.7),(46184,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46184,35.68,0.72,137,11533,70,NULL,NULL,'2MASX J06192078-1001268',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'18.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,94.8365,-10.02417,2.289,NULL,38897117039,607767453,9496366,18.2),(46185,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46185,35.45,0.58,123,11534,70,NULL,NULL,'2MASX J06192231-6953065',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.00015,NULL,'15.5b',0.2,NULL,NULL,NULL,NULL,NULL,1,94.842917,-69.88514,0.417,NULL,39865543905,622899123,9732798,15.5),(46186,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46186,35.87,0.7,149,11535,70,NULL,NULL,'2MFGC 05087',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.00015,NULL,'11.4K',0.19,NULL,NULL,NULL,NULL,NULL,1,94.8495417,-68.55933,0.249,NULL,40604774970,634449608,9913275,11.4),(46187,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46187,34.25,0.45,70.9,11536,NULL,NULL,'K','WEIN 171',NULL,'2007A&A...465...71T',2007,1,1.12,NULL,'G',0.000013,NULL,'9.91K',0.45,'S',NULL,NULL,NULL,NULL,1,94.859375,18.4195,NULL,NULL,63154205229,986784456,15418507,9.91),(46188,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46188,34.28,0.47,71.9,11536,NULL,NULL,'H','WEIN 171',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46189,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46189,34.36,0.43,74.5,11536,75,NULL,'3.6 micron, color + selection bias corrected','WEIN 171',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46190,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46190,34.45,0.46,77.5,11536,NULL,NULL,'J','WEIN 171',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46191,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46191,34.45,0.4,77.5,11536,NULL,NULL,'mean','WEIN 171',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46192,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46192,34.9,0.59,95.7,11537,70,NULL,NULL,'2MASX J06192790-0929018',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,94.866375,-9.48386,2.249,NULL,38895250213,607738284,9495910,17.7),(46193,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,'R',46193,34.31,0.49,72.7,11538,75,NULL,'IR','2MFGC 05093',NULL,'2011yCatp016004901K',2011,1,0.6,NULL,'G',0.000027,NULL,'10.2K',NULL,'S',NULL,NULL,NULL,NULL,1,94.91375,14.21622,NULL,NULL,62463042561,975985040,15249766,10.2),(46194,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46194,34.38,0.47,75,11538,NULL,NULL,'H','2MFGC 05093',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46195,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46195,34.42,0.45,76.4,11538,NULL,NULL,'K','2MFGC 05093',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46196,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46196,34.45,0.4,77.6,11538,NULL,NULL,'mean','2MFGC 05093',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46197,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46197,34.61,0.46,83.7,11538,NULL,NULL,'J','2MFGC 05093',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46198,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46198,36.05,0.83,162,11539,70,NULL,NULL,'2MASX J06194062-6425199',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,94.9192917,-64.42214,0.165,NULL,40345454215,630397722,9849964,15.7),(46199,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46199,35.9,0.55,151,11540,70,NULL,NULL,'2MASX J06194222-5019033',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,94.925917,-50.31758,0.089,NULL,40328344781,630130387,9845787,16),(46200,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46200,35.7,0.48,138,11541,70,NULL,NULL,'2MASX J06194474-6814547',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'15.7b',0.39,NULL,NULL,NULL,NULL,NULL,1,94.9362917,-68.24853,0.249,NULL,40604812833,634450200,9913284,15.7),(46201,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46201,36.09,0.65,166,11542,70,NULL,NULL,'2MASX J06194792-6344249',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,94.9495,-63.74031,0.141,NULL,40343868489,630372945,9849577,16.8),(46202,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46202,34.59,0.51,82.8,11543,70,NULL,NULL,'2MASX J06195038-6527029',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,94.9600833333,-65.45083,0.181,NULL,40349113966,630454905,9850857,15.9),(46203,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46203,36.24,0.51,177,11544,70,NULL,NULL,'2MASX J06195417-7143097',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'15.9b',0.48,NULL,NULL,NULL,NULL,NULL,1,94.9755,-71.71939,0.413,NULL,39868182378,622940349,9733442,15.9),(46204,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46204,35.44,0.48,122,11545,70,NULL,NULL,'2MASX J06200224-6915376',NULL,'2014MNRAS.445.2677S',2014,1,0.69,NULL,'G',0.000097,NULL,'12.3I',0.58,NULL,NULL,NULL,NULL,NULL,1,95.0094583,-69.26053,0.357,NULL,39865279341,622894989,9732734,12.3),(46205,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,'R',46205,33.8,0.49,57.6,11546,75,NULL,'IR','2MFGC 05099',NULL,'2011yCatp016004901K',2011,1,0.6,NULL,'G',NULL,NULL,'12.4K',NULL,'S',NULL,NULL,NULL,NULL,1,95.011667,6.25447,NULL,NULL,62319049490,973735148,15214611,12.4),(46206,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46206,33.2,NULL,43.7,11547,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0559',NULL,'2010Ap&SS.325..163P',2010,1,0.86,NULL,'G',NULL,NULL,'16.8',0.09,'Sdm',NULL,NULL,NULL,NULL,1,95.16125,67.49389,0.357,NULL,62144603344,971009427,15172022,16.8),(46207,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46207,33.24,NULL,44.5,11547,NULL,NULL,'Dipole + Quadrupole','FGC 0559',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46208,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46208,33.25,NULL,44.7,11547,NULL,NULL,'Dipole','FGC 0559',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46209,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46209,33.71,NULL,55.2,11547,NULL,NULL,NULL,'FGC 0559',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46210,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46210,34.96,0.43,98.3,11547,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0559',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46211,'Tully est','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46211,32.77,0.8,35.7,11548,75,NULL,'B','MCG -03-17-001',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.000026,NULL,'14.5',1,'SA(rs)cd:',NULL,NULL,NULL,NULL,1,95.178417,-16.06117,1.401,NULL,38784485224,606007581,9468868,14.5),(46212,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46212,32.04,0.4,25.6,11548,NULL,NULL,NULL,'MCG -03-17-001',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46213,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46213,32.04,0.39,25.6,11548,73,NULL,'opt','MCG -03-17-001',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46214,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46214,33.19,0.4,43.4,11548,NULL,NULL,'mean','MCG -03-17-001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46215,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46215,33.54,0.47,51,11548,NULL,NULL,'H','MCG -03-17-001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46216,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46216,35.17,0.44,108,11549,NULL,NULL,NULL,'ESO 365- G 007',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.95',0.5,'Sc',NULL,NULL,NULL,NULL,1,95.1822083333,-33.42544,0.065,NULL,39148302057,611692219,9557690,14.95),(46217,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46217,35.21,0.2,110,11549,74.4,NULL,NULL,'ESO 365- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46218,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46218,35.27,0.42,113,11549,NULL,NULL,'Malmquist cor.','ESO 365- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46219,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46219,37.01,0.57,252,11550,70,NULL,NULL,'2MASX J06204601-6721380',NULL,'2014MNRAS.445.2677S',2014,1,0.27,NULL,'G',0.00015,NULL,'16.9b',0.27,NULL,NULL,NULL,NULL,NULL,1,95.1917083,-67.36061,0.293,NULL,40603484100,634429439,9912959,16.9),(46220,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46220,35.94,0.51,154,11551,70,NULL,NULL,'2MASX J06204637-7012070',NULL,'2014MNRAS.445.2677S',2014,1,0.71,NULL,'G',0.000103,NULL,'15.3b',0.6,NULL,NULL,NULL,NULL,NULL,1,95.1932083,-70.20194,0.389,NULL,39876605203,623071956,9735499,15.3),(46221,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46221,35.45,0.54,123,11552,70,NULL,NULL,'2MASX J06205213-6429068',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15',NULL,'S0','Group member',NULL,NULL,NULL,1,95.217167,-64.48531,0.165,NULL,40345450609,630397665,9849963,15),(46222,'Sosies','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46222,30.67,0.16,13.6,11553,NULL,NULL,NULL,'UGCA 127',NULL,'2002A&A...393...57T',2002,1,3.9,'Extended HIPASS source','G',0.000007,NULL,'14.1B',1.1,'Scd?',NULL,NULL,NULL,NULL,1,95.23225,-8.49561,2.281,NULL,38900261838,607816591,9497134,14.1),(46223,'Tully est','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46223,29.71,0.8,8.7,11553,75,NULL,NULL,'UGCA 127',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46224,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46224,29.65,NULL,8.51,11553,NULL,NULL,NULL,'UGCA 127',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46225,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46225,30.09,0.2,10.4,11553,74.4,NULL,NULL,'UGCA 127',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46226,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46226,30.13,0.43,10.6,11553,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 127',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46227,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46227,30.25,0.4,11.2,11553,NULL,NULL,NULL,'UGCA 127',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46228,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46228,30.25,0.39,11.2,11553,73,NULL,'opt','UGCA 127',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46229,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46229,30.28,0.43,11.4,11553,75,NULL,'3.6 micron, color corrected','UGCA 127',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46230,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46230,37.28,0.74,286,11554,70,NULL,NULL,'2MASX J06205846-5008039',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,95.2435,-50.1345,0.085,NULL,40328268456,630129194,9845768,14.4),(46231,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46231,35.89,0.57,151,11555,70,NULL,NULL,'FAIRALL 1306',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.0B',0.39,NULL,NULL,NULL,NULL,NULL,1,95.252417,-72.59217,0.353,NULL,39868587733,622946683,9733541,16),(46232,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46232,31.07,NULL,16.3,11556,NULL,NULL,NULL,'FGC 0563',NULL,'2000BSAO...50....5K',2000,1,1.79,NULL,'G',0.00001,NULL,'15.4',0.22,'Sm',NULL,NULL,NULL,NULL,1,95.262917,-5.86639,NULL,NULL,38675926965,604311358,9442364,15.4),(46233,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46233,31.17,NULL,17.1,11556,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0563',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46234,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46234,31.19,NULL,17.3,11556,NULL,NULL,'Dipole + Quadrupole','FGC 0563',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46235,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46235,31.2,NULL,17.4,11556,NULL,NULL,'Dipole','FGC 0563',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46236,'Sosies','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46236,32.22,0.51,27.8,11557,NULL,NULL,NULL,'UGCA 128',NULL,'2002A&A...393...57T',2002,1,2.6,'Extended HIPASS source','G',0.000013,NULL,'12.63',1.9,'SB(s)a pec     HII','in a triple',NULL,NULL,NULL,1,95.2731666667,-20.04842,0.717,NULL,39605342613,618833478,9669273,12.63),(46237,'Tully est','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46237,31.94,0.8,24.4,11557,75,NULL,NULL,'UGCA 128',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46238,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46238,32.5,0.4,31.6,11557,NULL,NULL,'mean','UGCA 128',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46239,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46239,32.62,0.45,33.4,11557,NULL,NULL,'K','UGCA 128',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46240,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46240,32.64,0.47,33.7,11557,NULL,NULL,'H','UGCA 128',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46241,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46241,32.68,0.46,34.3,11557,NULL,NULL,'J','UGCA 128',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46242,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46242,36.4,0.56,191,11558,70,NULL,NULL,'2MASX J06211077-7034300',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'16.4b',0.37,NULL,NULL,NULL,NULL,NULL,1,95.294917,-70.57492,0.377,NULL,39878620830,623103450,9735991,16.4),(46243,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46243,35.95,0.66,155,11559,70,NULL,NULL,'ESO 556- G 016',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.17',0.7,'Sb-c',NULL,NULL,NULL,NULL,1,95.3017917,-22.50653,0.377,NULL,39601928577,618780134,9668439,15.17),(46244,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46244,34.79,0.4,90.8,11560,NULL,NULL,'mean','UGC 03450',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000033,NULL,'15.30',0.5,'SBb',NULL,NULL,NULL,NULL,1,95.3027083,27.85625,NULL,NULL,62934678323,983354348,15364911,15.3),(46245,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46245,34.82,0.47,91.9,11560,NULL,NULL,'H','UGC 03450',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46246,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46246,34.86,0.45,93.9,11560,NULL,NULL,'K','UGC 03450',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46247,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46247,34.94,0.46,97.2,11560,NULL,NULL,'J','UGC 03450',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46248,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46248,35.63,0.51,133,11561,70,NULL,NULL,'2MASX J06211287-5217009',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'13.1I',0.6,NULL,NULL,NULL,NULL,NULL,1,95.3035,-52.28356,0.157,NULL,40329462197,630147846,9846060,13.1),(46249,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46249,34.51,0.25,79.8,11562,74.4,NULL,NULL,'2MASX J06211399-6500579',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000014,NULL,'14.6R',NULL,'E','Group member',NULL,NULL,NULL,1,95.3082083,-65.01603,0.161,NULL,40348955811,630452434,9850819,14.6),(46250,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46250,34.94,0.54,97.1,11562,70,NULL,NULL,'2MASX J06211399-6500579',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46251,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46251,37.15,0.66,270,11563,70,NULL,NULL,'2MASX J06211871-2508209',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,95.3279583333,-25.13919,0.293,NULL,39115933088,611186454,9549788,15.6),(46252,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46252,34.37,0.45,74.8,11564,70,NULL,NULL,'2MASX J06212649-2806411',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00012,NULL,'12.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,95.360333,-28.11142,0.125,NULL,39111266309,611113536,9548649,12.6),(46253,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46253,34.74,0.48,88.9,11565,70,NULL,NULL,'NGC 2230',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000031,NULL,'14.05',0.9,'(R\')SA0-?','Group member, 2nd ranked galaxy',NULL,NULL,NULL,1,95.364833,-64.99278,0.161,NULL,40348485238,630445081,9850704,14.05),(46254,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46254,35.08,0.25,104,11565,74.4,NULL,NULL,'NGC 2230',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46255,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,'R',46255,34.26,0.49,71,11566,75,NULL,'IR','UGC 03449',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000023,NULL,'15.6',0.2,'Scd:',NULL,NULL,NULL,NULL,1,95.3745417,51.11086,0.685,NULL,61535386252,961490410,15023287,15.6),(46256,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46256,34.87,0.59,94.3,11567,70,NULL,NULL,'2MASX J06213029-5102343',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.7I',0.5,'(R\'_2)SB(s)a',NULL,NULL,NULL,NULL,1,95.3764583,-51.04328,0.145,NULL,40328730237,630136409,9845881,13.7),(46257,'GRB','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46257,42.55,0.89,2100,11568,69.7,NULL,'Fiducial','GRB 060729',0.54,'2009MNRAS.400..775C',2009,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,95.3824583333,-62.37011,0.157,NULL,40390208530,631097008,9860890,NULL),(46258,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46258,36.7,0.63,218,11569,70,NULL,NULL,'2MASX J06213251-5821535',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,95.3853333333,-58.36489,0.221,NULL,40368140390,630752193,9855503,16.9),(46259,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46259,35.38,0.48,119,11570,70,NULL,NULL,'2MASX J06213371-2210276',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,95.3904166667,-22.17433,0.449,NULL,39602617385,618790896,9668607,14.7),(46260,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46260,34.25,0.46,70.9,11571,NULL,NULL,'Malmquist cor.','ESO 255- G 005',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.51',0.7,'SAB(rs)ab:',NULL,NULL,NULL,NULL,1,95.3972083333,-44.70753,0.221,NULL,42429408398,662959506,10358742,14.51),(46261,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46261,34.37,0.43,74.7,11571,NULL,NULL,NULL,'ESO 255- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46262,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46262,34.41,0.2,76.2,11571,74.4,NULL,NULL,'ESO 255- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46263,'IRAS','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46263,32.45,0.8,30.9,11572,75,NULL,'MAT, I','ESO 121- G 026',NULL,'1997ApJS..109..333W',1997,1,3.2,NULL,'G',0.000013,NULL,'12.58',2,'SB(rs)c',NULL,NULL,NULL,NULL,1,95.4114583,-59.73992,0.129,NULL,40382286648,630973228,9858956,12.58),(46264,'Sosies','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46264,32.82,0.17,36.6,11572,NULL,NULL,NULL,'ESO 121- G 026',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46265,'Tully est','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46265,32.16,0.8,27,11572,75,NULL,NULL,'ESO 121- G 026',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46266,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46266,32.81,0.4,36.4,11572,NULL,NULL,'mean','ESO 121- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46267,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46267,32.84,0.4,37,11572,NULL,NULL,NULL,'ESO 121- G 026',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46268,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46268,32.84,0.4,37,11572,73,NULL,'opt','ESO 121- G 026',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46269,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46269,32.93,0.45,38.5,11572,NULL,NULL,'K','ESO 121- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46270,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46270,32.93,0.47,38.5,11572,NULL,NULL,'H','ESO 121- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46271,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46271,32.95,0.46,38.9,11572,NULL,NULL,'J','ESO 121- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46272,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46272,33.03,0.2,40.4,11572,74.4,NULL,NULL,'ESO 121- G 026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46273,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46273,33.07,0.32,41.2,11572,85,NULL,'I, raw','ESO 121- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46274,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46274,33.14,0.32,42.4,11572,85,NULL,'I, inv','ESO 121- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46275,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46275,33.14,0.4,42.5,11572,NULL,NULL,NULL,'ESO 121- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46276,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46276,33.27,0.43,45,11572,75,NULL,'MAT, I, raw','ESO 121- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46277,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46277,33.34,0.36,46.5,11572,NULL,NULL,'Malmquist cor.','ESO 121- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46278,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46278,33.47,0.43,49.5,11572,75,NULL,'MAT, I, cor','ESO 121- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46279,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46279,33.57,0.43,51.8,11572,75,NULL,'MAT, I, inv','ESO 121- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46280,'Faber-Jackson','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46280,31.2,0.63,17.4,11573,95,NULL,'Michard 1979b, c','NGC 2217',NULL,'1984ApJS...56...91D',1984,1,4.5,'Confused HIPASS source','G',0.000017,NULL,'11.71',4.2,'(R)SB(rs)0/a  LINER?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,95.41575,-27.23375,0.137,NULL,39109039159,611078736,9548105,11.71),(46281,'Faber-Jackson','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46281,31.26,0.46,17.9,11573,95,NULL,'Michard 1979a','NGC 2217',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46282,'Faber-Jackson','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46282,31.3,0.29,18.2,11573,95,NULL,'Weighted Mean','NGC 2217',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46283,'Faber-Jackson','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46283,31.57,0.48,20.6,11573,95,NULL,'de Vaucouleurs','NGC 2217',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46284,'Faber-Jackson','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46284,33.25,0.81,44.7,11573,55,NULL,'Visvanathan & Sandage 1979','NGC 2217',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46285,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46285,32.04,0.57,25.6,11573,70,NULL,NULL,'NGC 2217',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46286,'Tertiary','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46286,30.92,0.25,15.3,11573,95,NULL,NULL,'NGC 2217',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46287,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46287,31.45,0.4,19.5,11573,75,NULL,'B','NGC 2217',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46288,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46288,36.56,0.86,205,11574,70,NULL,NULL,'2MASX J06215288-5129043',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.7I',0.3,NULL,NULL,NULL,NULL,NULL,1,95.470333,-51.4845,0.149,NULL,40331922640,630186291,9846660,14.7),(46289,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46289,34.59,0.49,82.8,11575,70,NULL,NULL,'ESO 365-G 010',NULL,'2014MNRAS.445.2677S',2014,1,1.9,NULL,'G',0.000023,NULL,'14.70',0.6,'SA(s)b: pec',NULL,NULL,NULL,NULL,1,95.486333,-36.55594,0.201,NULL,38975232341,608988005,9515437,14.7),(46290,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46290,34.64,0.69,84.6,11575,100,NULL,'mid-IR','ESO 365-G 010',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46291,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46291,36.7,0.7,219,11576,70,NULL,NULL,'ESO 206-IG 010 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.62',0.4,NULL,NULL,NULL,NULL,NULL,1,95.4907917,-47.74089,0.157,NULL,40275671588,629307368,9832927,16.62),(46292,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,'R',46292,34.51,0.49,79.8,11577,75,NULL,'IR','2MFGC 05127',NULL,'2011yCatp016004901K',2011,1,0.5,NULL,'G',NULL,NULL,'15.81',NULL,'Sab',NULL,NULL,NULL,NULL,1,95.4909583333,19.12881,NULL,NULL,63157430516,986834851,15419294,15.81),(46293,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46293,35.2,0.67,110,11578,70,NULL,NULL,'2MASX J06215821-6422591',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,95.4924583333,-64.38311,0.165,NULL,40345982169,630405971,9850093,15.9),(46294,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46294,34.18,0.53,68.7,11579,70,NULL,NULL,'2MASX J06220168-6447421',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000067,NULL,'13',NULL,'Sa','Group member',NULL,NULL,NULL,1,95.506917,-64.795,0.161,NULL,40345851897,630403935,9850061,13),(46295,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46295,34.78,0.25,90.4,11580,74.4,NULL,NULL,'2MASX J06220477-6457350',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000011,NULL,'15.1R',0.4,'E','Group member',NULL,NULL,NULL,1,95.520125,-64.95981,0.161,NULL,40345667328,630401052,9850016,15.1),(46296,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46296,35.82,0.48,146,11581,70,NULL,NULL,'ESO 489- G 043',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000123,NULL,'15.52',0.4,'S0',NULL,NULL,NULL,NULL,1,95.52875,-23.37067,0.265,NULL,39066194887,610409295,9537645,15.52),(46297,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46297,29.62,NULL,8.39,11582,NULL,NULL,NULL,'WHI B0619-07',NULL,'2013AJ....145..101K',2013,1,NULL,'Superposed foreground star.','G',0.000003,NULL,'14.6B',NULL,NULL,NULL,NULL,NULL,NULL,1,95.557083,-7.8405,2.353,NULL,38901047922,607828873,9497326,14.6),(46298,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46298,34.23,0.25,70.2,11583,74.4,NULL,NULL,'2MASX J06221975-6414044',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000011,NULL,'12',NULL,'E','Group member',NULL,NULL,NULL,1,95.5822083,-64.23458,0.141,NULL,40345087049,630391985,9849874,12),(46299,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46299,34.69,0.47,86.6,11583,70,NULL,NULL,'2MASX J06221975-6414044',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46300,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46300,34.68,0.25,86.3,11584,74.4,NULL,NULL,'NGC 2235',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000039,NULL,'13.97',1,'E2:;BrClG','Group member',NULL,NULL,NULL,1,95.5912917,-64.93442,0.161,NULL,40345679772,630401246,9850019,13.97),(46301,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46301,33.2,0.47,43.6,11585,NULL,NULL,'H','2MASX J06222633+0431236',NULL,'2007A&A...465...71T',2007,1,0.78,NULL,'G',0.000013,NULL,'10.0K',0.33,'S',NULL,NULL,NULL,NULL,1,95.6097083,4.52322,NULL,NULL,62327914174,973873658,15216775,10),(46302,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46302,33.23,0.45,44.2,11585,NULL,NULL,'K','2MASX J06222633+0431236',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46303,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46303,33.27,0.4,45.1,11585,NULL,NULL,'mean','2MASX J06222633+0431236',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46304,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46304,33.39,0.46,47.7,11585,NULL,NULL,'J','2MASX J06222633+0431236',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46305,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46305,36.77,0.56,226,11586,70,NULL,NULL,'2MASX J06222702-5544266',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,95.6125,-55.74075,0.225,NULL,40513894086,633029595,9891087,16.8),(46306,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46306,35.54,0.63,129,11587,70,NULL,NULL,'2MASX J06223430-6355535',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,95.6430416667,-63.93161,0.141,NULL,40343172022,630362062,9849407,15.9),(46307,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46307,35.61,0.63,133,11588,70,NULL,NULL,'2MASX J06225145-6749133',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,95.714375,-67.82031,0.249,NULL,40604404529,634443820,9913184,15.4),(46308,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46308,36.27,0.67,179,11589,70,NULL,NULL,'2MASX J06225233-2438121',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.8I',0.3,NULL,NULL,NULL,NULL,NULL,1,95.718,-24.63669,0.281,NULL,39115687134,611182611,9549728,14.8),(46309,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46309,36.25,0.57,178,11590,70,NULL,NULL,'2MASX J06225925-6625024',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,95.7467083,-66.41728,0.225,NULL,40333556329,630211817,9847059,14.1),(46310,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46310,36.45,0.78,195,11591,70,NULL,NULL,'2MASX J06230213-5344074',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,95.759083,-53.73547,0.257,NULL,40287811007,629497046,9835891,17.4),(46311,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46311,35.29,0.25,114,11592,74.4,NULL,NULL,'2MASX J06230740-6455501',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000017,NULL,'14.7R',0.4,'E','Group member',NULL,NULL,NULL,1,95.7809583333,-64.93056,0.161,NULL,40345676036,630401188,9850018,14.7),(46312,'IRAS','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46312,33.79,0.8,57.3,11593,75,NULL,'MAT, I','ESO 057- G 080',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'14.98',0.3,'Sb? sp',NULL,NULL,NULL,NULL,1,95.788583,-68.73289,0.249,NULL,40602628104,634416064,9912751,14.98),(46313,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46313,33.27,0.43,45,11593,75,NULL,'MAT, I, raw','ESO 057- G 080',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46314,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46314,33.29,0.32,45.4,11593,85,NULL,'I, raw','ESO 057- G 080',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46315,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46315,33.31,0.32,46,11593,85,NULL,'I, inv','ESO 057- G 080',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46316,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46316,33.42,0.43,48.3,11593,75,NULL,'MAT, I, inv','ESO 057- G 080',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46317,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46317,33.58,0.43,52,11593,75,NULL,'MAT, I, cor','ESO 057- G 080',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46318,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46318,33.77,0.47,56.7,11593,NULL,NULL,'H','ESO 057- G 080',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46319,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46319,33.86,0.4,59.3,11593,NULL,NULL,'mean','ESO 057- G 080',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46320,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46320,33.89,0.45,59.9,11593,NULL,NULL,'K','ESO 057- G 080',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46321,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46321,33.94,0.46,61.4,11593,NULL,NULL,'J','ESO 057- G 080',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46322,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46322,34.03,0.43,63.9,11593,NULL,NULL,NULL,'ESO 057- G 080',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46323,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46323,34.07,0.2,65.2,11593,74.4,NULL,NULL,'ESO 057- G 080',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46324,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46324,34.08,0.42,65.4,11593,NULL,NULL,'Malmquist cor.','ESO 057- G 080',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46325,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46325,36.58,0.89,207,11594,70,NULL,NULL,'2MASX J06231656-6212082',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,95.8192917,-62.20228,0.173,NULL,40389832076,631091126,9860798,16.9),(46326,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46326,36.92,0.57,242,11595,70,NULL,NULL,'2MASX J06232506-6602035',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,95.854667,-66.03428,0.197,NULL,40348138416,630439662,9850619,16.9),(46327,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46327,37.12,0.64,265,11596,70,NULL,NULL,'2MASX J06232572-5409397',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.4,NULL,NULL,NULL,NULL,NULL,1,95.85725,-54.16103,0.265,NULL,40289477033,629523078,9836298,14.3),(46328,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46328,36.89,0.55,239,11597,70,NULL,NULL,'2MASX J06232582-3315429',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,95.857583,-33.26192,0.069,NULL,39148814070,611700219,9557815,15.3),(46329,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46329,37.29,0.63,288,11598,70,NULL,NULL,'2MASX J06232633-6434223',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15',NULL,'E','Group member',NULL,NULL,NULL,1,95.859583,-64.57292,0.169,NULL,40345999086,630406235,9850097,15),(46330,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46330,35.89,0.49,151,11599,70,NULL,NULL,'AM 0623-371 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15',0.4,NULL,NULL,NULL,NULL,NULL,1,95.8627917,-37.03322,0.237,NULL,38976664706,609010386,9515787,15),(46331,'GRB','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,'R',46331,48.62,0.99,8980,11600,72,NULL,NULL,'GRB 060510A',4.9,'2008JCAP...07..004M',2008,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,95.866583,-1.16283,NULL,NULL,38692742953,604574108,9446470,NULL),(46332,'GRB','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46332,48.71,0.95,9360,11600,70,NULL,NULL,'GRB 060510A',4.9,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46333,'GRB','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,'R',46333,48.86,1.14,10000,11600,NULL,NULL,NULL,'GRB 060510A',4.9,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46334,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46334,36.2,0.66,174,11601,70,NULL,NULL,'2MASX J06233263-5134522',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,95.885875,-51.58119,0.129,NULL,40332032137,630188002,9846687,16.3),(46335,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46335,35.62,0.48,133,11602,NULL,NULL,'Malmquist cor.','ESO 489- G 046',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.35',0.4,'Sb',NULL,NULL,NULL,NULL,1,95.933375,-23.40819,0.305,NULL,39065862921,610404108,9537564,15.35),(46336,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46336,35.71,0.46,139,11602,NULL,NULL,NULL,'ESO 489- G 046',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46337,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46337,35.75,0.2,141,11602,74.4,NULL,NULL,'ESO 489- G 046',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46338,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46338,35.14,0.25,107,11603,74.4,NULL,NULL,'2MASX J06234894-6457153',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000014,NULL,'14.8R',NULL,'E','Group member',NULL,NULL,NULL,1,95.954,-64.95419,0.161,NULL,40345721420,630401897,9850029,14.8),(46339,'IRAS','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46339,34.87,0.8,94.3,11604,75,NULL,'MAT, I','ESO 489- G 047',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.00003,NULL,'14.36',0.9,'SA(r)bc:       AGN?',NULL,NULL,NULL,NULL,1,95.962625,-23.19356,0.369,NULL,39598615997,618728374,9667630,14.36),(46340,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46340,34.24,0.43,70.3,11604,75,NULL,'MAT, I, raw','ESO 489- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46341,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46341,34.49,0.43,78.9,11604,75,NULL,'MAT, I, inv','ESO 489- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46342,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46342,34.53,0.32,80.7,11604,85,NULL,'I, raw','ESO 489- G 047',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46343,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46343,34.57,0.48,82.2,11604,NULL,NULL,NULL,'ESO 489- G 047',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46344,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46344,34.6,0.32,83.1,11604,85,NULL,'I, inv','ESO 489- G 047',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46345,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46345,34.62,0.2,84,11604,74.4,NULL,NULL,'ESO 489- G 047',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46346,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46346,34.67,0.43,85.9,11604,75,NULL,'MAT, I, cor','ESO 489- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46347,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46347,34.69,0.46,86.7,11604,NULL,NULL,'Malmquist cor.','ESO 489- G 047',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46348,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46348,35.23,0.4,111,11604,NULL,NULL,'mean','ESO 489- G 047',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46349,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46349,35.29,0.47,114,11604,NULL,NULL,'H','ESO 489- G 047',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46350,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46350,35.42,0.45,121,11604,NULL,NULL,'K','ESO 489- G 047',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46351,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46351,35.46,0.46,124,11604,NULL,NULL,'J','ESO 489- G 047',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46352,'IRAS','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46352,31.79,0.8,22.8,11605,75,NULL,'A82, H','NGC 2146A',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000013,NULL,'13.5',1.1,'SAB(s)c:','Pair member (points to parent)',NULL,NULL,NULL,1,95.98,78.53011,0.385,NULL,61304536902,957883389,14966927,13.5),(46353,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46353,31.28,0.4,18,11605,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 2146A',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46354,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46354,31.34,0.56,18.6,11605,NULL,NULL,NULL,'NGC 2146A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46355,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46355,31.38,0.2,18.9,11605,74.4,NULL,NULL,'NGC 2146A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46356,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46356,31.55,0.51,20.4,11605,NULL,NULL,'Malmquist cor.','NGC 2146A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46357,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46357,31.65,0.47,21.4,11605,75,NULL,'A82, H, inv','NGC 2146A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46358,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46358,31.7,0.47,21.9,11605,75,NULL,'A82, H, raw','NGC 2146A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46359,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46359,31.7,0.38,21.9,11605,NULL,NULL,NULL,'NGC 2146A',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46360,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46360,31.97,0.4,24.7,11605,75,NULL,'B','NGC 2146A',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46361,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46361,32.04,0.47,25.6,11605,75,NULL,'A82, H, cor','NGC 2146A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46362,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46362,32.23,0.4,28,11605,NULL,NULL,'mean','NGC 2146A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46363,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46363,32.86,0.47,37.3,11605,NULL,NULL,'H','NGC 2146A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46364,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46364,32.92,0.46,38.3,11605,NULL,NULL,'J','NGC 2146A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46365,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46365,32.97,0.45,39.2,11605,NULL,NULL,'K','NGC 2146A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46366,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46366,35.83,0.49,147,11606,70,NULL,NULL,'AM 0623-371 NED03',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,95.982333,-37.22381,0.253,NULL,38976103341,609001614,9515650,14.7),(46367,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46367,36.01,0.78,159,11607,70,NULL,NULL,'ESO 308-IG 003 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.06',NULL,NULL,NULL,NULL,NULL,NULL,1,95.990333,-38.91861,0.369,NULL,38985068494,609141695,9517838,17.06),(46368,'Sosies','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46368,33.43,0.2,48.5,11608,NULL,NULL,NULL,'UGC 03459',NULL,'2002A&A...393...57T',2002,1,1.1,NULL,'G',0.000023,NULL,'17.',0.8,'Scd?',NULL,NULL,NULL,NULL,1,95.999583,4.71075,NULL,NULL,62298937977,973420905,15209701,17),(46369,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46369,33.22,0.4,44.1,11608,NULL,NULL,'mean','UGC 03459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46370,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46370,33.34,0.2,46.6,11608,74.4,NULL,NULL,'UGC 03459',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46371,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46371,33.57,0.45,51.7,11608,NULL,NULL,'K','UGC 03459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46372,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46372,33.61,0.47,52.7,11608,NULL,NULL,'H','UGC 03459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46373,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46373,33.66,0.46,54,11608,NULL,NULL,'J','UGC 03459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46374,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46374,36.24,0.77,177,11609,70,NULL,NULL,'2MASX J06240687-3900395',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,96.028625,-39.01097,0.369,NULL,38985038303,609141223,9517831,15.5),(46375,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46375,34.87,0.59,94,11610,70,NULL,NULL,'AM 0623-371 NED05',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.0R',NULL,'AGN',NULL,NULL,NULL,NULL,1,96.102125,-37.29011,0.293,NULL,38976157545,609002461,9515663,14),(46376,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46376,36.43,0.56,193,11611,70,NULL,NULL,'2MASX J06242507-6350377',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,96.104417,-63.84389,0.169,NULL,40342932102,630358314,9849348,16.6),(46377,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46377,37.67,0.72,342,11612,70,NULL,NULL,'AM 0624-620 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.4,NULL,NULL,NULL,NULL,NULL,1,96.1457083,-62.16044,0.173,NULL,40389682141,631088783,9860762,14.4),(46378,'Ring Diameter','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46378,31.9,0.84,24,11613,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 2223',NULL,'1981ApJS...45..541P',1981,1,3.2,NULL,'G',0.00002,NULL,'12.35',2.8,'SB(rs)bc','Group member',NULL,NULL,NULL,1,96.149625,-22.83825,0.349,NULL,39599378111,618740282,9667816,12.35),(46379,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46379,32.94,0.53,38.8,11613,70,NULL,NULL,'NGC 2223',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46380,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46380,32.64,0.4,33.7,11613,75,NULL,'B','NGC 2223',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46381,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46381,32.8,0.4,36.3,11613,NULL,NULL,'mean','NGC 2223',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46382,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46382,33.42,0.46,48.4,11613,NULL,NULL,'J','NGC 2223',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46383,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46383,33.43,0.47,48.5,11613,NULL,NULL,'H','NGC 2223',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46384,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46384,33.45,0.45,49.1,11613,NULL,NULL,'K','NGC 2223',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46385,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46385,36.31,0.54,183,11614,70,NULL,NULL,'2MASX J06243619-5700450',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,96.150833,-57.0125,0.217,NULL,40515979068,633062172,9891596,16.7),(46386,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46386,35.64,0.57,134,11615,70,NULL,NULL,'2MASX J06243811-5940430',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,96.15875,-59.67861,0.177,NULL,40375736306,630870879,9857357,15.7),(46387,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46387,33.74,NULL,55.9,11616,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 489- G 050',NULL,'2010Ap&SS.325..163P',2010,1,1.77,NULL,'G',0.000013,NULL,'15.78',0.22,'S0: sp',NULL,NULL,NULL,NULL,1,96.162125,-22.59714,0.393,NULL,39599370982,618740171,9667815,15.78),(46388,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46388,33.75,NULL,56.3,11616,NULL,NULL,'Dipole','ESO 489- G 050',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46389,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46389,33.75,NULL,56.3,11616,NULL,NULL,'Dipole + Quadrupole','ESO 489- G 050',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46390,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46390,33.81,0.2,57.8,11616,74.4,NULL,NULL,'ESO 489- G 050',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46391,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,'R',46391,33.9,0.49,60.2,11616,75,NULL,'IR','ESO 489- G 050',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46392,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46392,34.21,0.63,69.4,11616,NULL,NULL,NULL,'ESO 489- G 050',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46393,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46393,34.43,0.56,77,11616,NULL,NULL,'Malmquist cor.','ESO 489- G 050',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46394,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46394,36.6,0.54,209,11617,70,NULL,NULL,'2MASX J06244335-6738126',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,96.180667,-67.63686,0.249,NULL,40603810614,634434540,9913039,15.6),(46395,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46395,34.2,0.4,69.2,11618,NULL,NULL,'mean','2MFGC 05158',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000037,NULL,'10.8K',NULL,'S',NULL,NULL,NULL,NULL,1,96.1939583,15.96833,NULL,NULL,62449508684,975773573,15246462,10.8),(46396,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,'R',46396,34.95,0.49,97.9,11618,75,NULL,'IR','2MFGC 05158',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46397,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46397,35.37,0.47,118,11618,NULL,NULL,'H','2MFGC 05158',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46398,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46398,35.53,0.45,128,11618,NULL,NULL,'K','2MFGC 05158',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46399,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46399,34.2,0.4,69.2,11619,NULL,NULL,'mean','2MFGC 05159',NULL,'2007A&A...465...71T',2007,1,0.3,NULL,'G',0.000167,NULL,'10.7K',NULL,'S',NULL,NULL,NULL,NULL,1,96.196333,15.97925,NULL,NULL,62449509345,975773583,15246462,10.7),(46400,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46400,35.73,0.47,140,11619,NULL,NULL,'H','2MFGC 05159',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46401,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46401,35.8,0.45,145,11619,NULL,NULL,'K','2MFGC 05159',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46402,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46402,32.42,0.43,30.4,11620,75,NULL,'3.6 micron, color + selection bias corrected','MCG +11-08-042',NULL,'2014MNRAS.444..527S',2014,1,0.6,NULL,'G',0.000033,NULL,'15',0.4,NULL,NULL,NULL,NULL,NULL,1,96.2072917,65.73058,0.365,NULL,61620274204,962816784,15044012,15),(46403,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46403,35.75,0.51,141,11621,70,NULL,NULL,'2MASX J06245095-6321178',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,96.2124166667,-63.35489,0.169,NULL,40388959757,631077496,9860585,16.2),(46404,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46404,36.37,0.52,188,11622,70,NULL,NULL,'2MASX J06245885-2718092',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,96.2452083,-27.30261,0.305,NULL,39109434950,611084921,9548201,14.4),(46405,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46405,35.83,0.52,147,11623,70,NULL,NULL,'2MASX J06250982-6319024',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,96.290917,-63.31742,0.169,NULL,40388974442,631077725,9860589,16.1),(46406,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46406,35.18,0.49,109,11624,70,NULL,NULL,'ESO 308- G 005',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000077,NULL,'15.08',0.5,'SB(rs)0^+      AGN',NULL,NULL,NULL,NULL,1,96.3199166667,-37.80114,0.357,NULL,38988107389,609189177,9518580,15.08),(46407,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46407,35.42,0.55,121,11625,70,NULL,NULL,'2MASX J06251787-6447546',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.0001,NULL,'15.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,96.324583,-64.79853,0.161,NULL,40345896311,630404629,9850072,15.7),(46408,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46408,36.43,0.63,193,11626,70,NULL,NULL,'2MASX J06252475-5647292',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,96.3530833333,-56.79142,0.221,NULL,40514206939,633034483,9891163,14.9),(46409,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46409,36.07,0.54,163,11627,70,NULL,NULL,'2MASX J06252714-3904018',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.7I',0.5,NULL,NULL,NULL,NULL,NULL,1,96.363125,-39.06722,0.369,NULL,38985210576,609143915,9517873,13.7),(46410,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46410,36.51,0.59,201,11628,70,NULL,NULL,'2MASX J06252742-5535121',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,96.364167,-55.58672,0.321,NULL,40509894648,632967103,9890110,16.9),(46411,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46411,35.86,0.88,148,11629,70,NULL,NULL,'2MASX J06252796-1134356',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'18.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,96.366583,-11.57661,2.785,NULL,38742974353,605358974,9458733,18.6),(46412,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46412,35.96,0.57,155,11630,70,NULL,NULL,'2MASX J06252946-4323349',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,96.3727083,-43.39306,0.189,NULL,42424377239,662880894,10357513,14.3),(46413,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46413,34.68,0.43,86.2,11631,NULL,NULL,NULL,'ESO 556- G 022',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.00002,NULL,'15.10',0.6,'Sb             HII',NULL,NULL,NULL,NULL,1,96.4029583,-19.813,1.065,NULL,39650023730,619531620,9680181,15.1),(46414,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46414,34.72,0.2,87.9,11631,74.4,NULL,NULL,'ESO 556- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46415,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46415,34.84,0.4,93.1,11631,NULL,NULL,'Malmquist cor.','ESO 556- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46416,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46416,34.93,0.45,96.8,11632,NULL,NULL,'K','CGCG 144-005',NULL,'2007A&A...465...71T',2007,1,0.5,'abs(b) < 10 degrees.','G',0.000013,NULL,'15.2',0.3,'S',NULL,NULL,NULL,NULL,1,96.4247917,30.65633,NULL,NULL,63056892556,985263946,15394749,15.2),(46417,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46417,34.95,0.47,97.9,11632,NULL,NULL,'H','CGCG 144-005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46418,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46418,35,0.4,100,11632,NULL,NULL,'mean','CGCG 144-005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46419,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46419,35.02,0.46,101,11632,NULL,NULL,'J','CGCG 144-005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46420,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46420,36.36,0.69,187,11633,70,NULL,NULL,'2MASX J06254715-8505517',NULL,'2014MNRAS.445.2677S',2014,1,4.85,NULL,'G',0.00015,NULL,'1.41',NULL,'Elliptical',NULL,NULL,NULL,NULL,1,96.44725,-85.09775,0.773,NULL,39737749153,620902330,9701598,1.41),(46421,'IRAS','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46421,34.79,0.8,90.7,11634,75,NULL,'MAT, I','ESO 426- G 008',NULL,'1997ApJS..109..333W',1997,1,2.58,NULL,'G',0.000033,NULL,'15.87',0.22,'Sbc',NULL,NULL,NULL,NULL,1,96.4682917,-27.98692,0.157,NULL,39108190078,611065469,9547897,15.87),(46422,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46422,34.4,0.32,75.7,11634,85,NULL,'I, raw','ESO 426- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46423,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46423,34.42,0.43,76.6,11634,75,NULL,'MAT, I, raw','ESO 426- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46424,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46424,34.44,0.32,77.1,11634,85,NULL,'I, inv','ESO 426- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46425,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46425,34.44,NULL,77.4,11634,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 426- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46426,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46426,34.45,NULL,77.5,11634,NULL,NULL,'Dipole','ESO 426- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46427,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46427,34.45,NULL,77.8,11634,NULL,NULL,'Dipole + Quadrupole','ESO 426- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46428,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46428,34.61,0.43,83.4,11634,75,NULL,'MAT, I, inv','ESO 426- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46429,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,'R',46429,34.7,0.49,87.3,11634,75,NULL,'IR','ESO 426- G 008',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46430,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46430,34.79,0.43,90.7,11634,75,NULL,'MAT, I, cor','ESO 426- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46431,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46431,35.07,0.43,103,11634,75,NULL,'3.6 micron, color corrected','ESO 426- G 008',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46432,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46432,35.08,0.2,104,11634,74.4,NULL,NULL,'ESO 426- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46433,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46433,35.16,0.43,108,11634,75,NULL,'3.6 micron, color + selection bias corrected','ESO 426- G 008',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46434,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46434,35.33,0.45,116,11634,NULL,NULL,NULL,'ESO 426- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46435,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46435,35.35,0.44,118,11634,NULL,NULL,'Malmquist cor.','ESO 426- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46436,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46436,35.05,0.66,102,11635,70,NULL,NULL,'2MASX J06255473-7343335',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,96.4782917,-73.72592,0.441,NULL,39925532591,623836446,9747444,15.8),(46437,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46437,33.88,0.4,59.7,11636,NULL,NULL,'mean','UGC 03458',NULL,'2007A&A...465...71T',2007,1,2.4,NULL,'G',0.000027,NULL,'14.70',0.6,'Sb',NULL,NULL,NULL,NULL,1,96.4811666667,64.74067,0.357,NULL,61619496526,962804633,15043822,14.7),(46438,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46438,34.02,0.47,63.8,11636,NULL,NULL,'H','UGC 03458',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46439,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46439,34.05,0.45,64.5,11636,NULL,NULL,'K','UGC 03458',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46440,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46440,34.1,0.46,66.1,11636,NULL,NULL,'J','UGC 03458',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46441,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46441,36.68,0.61,217,11637,70,NULL,NULL,'ESO 087- G 019',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.92',0.4,'Sa','Group member',NULL,NULL,NULL,1,96.487667,-65.48878,0.193,NULL,40348452123,630444564,9850696,15.92),(46442,'IRAS','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46442,32.53,0.8,32.1,11638,75,NULL,'MAT, I','NGC 2227',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.00001,NULL,'13.20',1.1,'SB(rs)c',NULL,NULL,NULL,NULL,1,96.4915833333,-22.00483,0.349,NULL,39653501999,619585968,9681030,13.2),(46443,'Tully est','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46443,32.19,0.8,27.5,11638,75,NULL,'B','NGC 2227',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46444,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46444,31.74,0.69,22.3,11638,100,NULL,'mid-IR','NGC 2227',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46445,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46445,31.87,0.32,23.7,11638,85,NULL,'I, raw','NGC 2227',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46446,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46446,31.89,0.32,23.9,11638,85,NULL,'I, inv','NGC 2227',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46447,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46447,32.18,0.43,27.3,11638,75,NULL,'MAT, I, raw','NGC 2227',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46448,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46448,32.31,0.43,28.9,11638,75,NULL,'MAT, I, inv','NGC 2227',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46449,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46449,32.39,0.2,30.1,11638,74.4,NULL,NULL,'NGC 2227',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46450,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46450,32.49,0.43,31.5,11638,75,NULL,'MAT, I, cor','NGC 2227',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46451,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46451,32.57,0.42,32.6,11638,NULL,NULL,NULL,'NGC 2227',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46452,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46452,32.57,0.39,32.6,11638,73,NULL,'opt','NGC 2227',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46453,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46453,32.65,0.4,33.9,11638,NULL,NULL,'Malmquist cor.','NGC 2227',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46454,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46454,32.66,0.4,34.1,11638,NULL,NULL,'mean','NGC 2227',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46455,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46455,32.74,0.46,35.3,11638,NULL,NULL,'J','NGC 2227',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46456,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46456,32.75,0.47,35.4,11638,NULL,NULL,'H','NGC 2227',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46457,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46457,32.8,0.45,36.3,11638,NULL,NULL,'K','NGC 2227',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46458,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46458,36.47,0.6,197,11639,70,NULL,NULL,'2MASX J06255862-6330202',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,96.4942083,-63.50558,0.165,NULL,40388131577,631064555,9860383,16.7),(46459,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,'R',46459,34.31,0.49,72.8,11640,75,NULL,'IR','ESO 489- G 055',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000087,NULL,'15.14',0.3,'Sc',NULL,NULL,NULL,NULL,1,96.501875,-27.52003,0.249,NULL,39109297208,611082768,9548168,15.14),(46460,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46460,37.25,0.63,282,11641,70,NULL,NULL,'2MASX J06260219-3717285',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,96.509083,-37.29119,0.325,NULL,38976212697,609003323,9515676,15.8),(46461,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46461,36.05,0.61,162,11642,70,NULL,NULL,'2MASX J06260344-3907045',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,96.51425,-39.118,0.369,NULL,38985878442,609154350,9518036,15.6),(46462,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46462,35.71,0.38,138,11643,NULL,NULL,NULL,'ESO 365- G 019',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'15.98',0.5,'Sb-c',NULL,NULL,NULL,NULL,1,96.516333,-36.60872,0.253,NULL,38977601355,609025021,9516015,15.98),(46463,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46463,35.71,0.37,139,11643,NULL,NULL,'Malmquist cor.','ESO 365- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46464,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46464,35.75,0.2,141,11643,74.4,NULL,NULL,'ESO 365- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46465,'TRGB','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46465,28.49,NULL,4.99,11644,NULL,NULL,NULL,'ESO 489- G?056',NULL,'2003A&A...398..479K',2003,1,0.9,NULL,'G',0.000002,NULL,'15.6',0.6,'Dwarf irr or nebula?',NULL,NULL,NULL,NULL,1,96.57075,-26.26561,0.433,NULL,39122379242,611287175,9551362,15.6),(46466,'TRGB','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46466,29,0.1,6.31,11644,74.4,NULL,NULL,'ESO 489- G?056',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46467,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46467,35.62,0.7,133,11645,70,NULL,NULL,'2MASX J06262277-5952059',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,96.594875,-59.86842,0.177,NULL,40377580092,630899688,9857807,16.7),(46468,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46468,36.05,0.75,162,11646,70,NULL,NULL,'2MASX J06264863-5556480',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,96.7024583,-55.94664,0.317,NULL,40509715942,632964311,9890067,14.4),(46469,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46469,32.04,0.69,25.6,11647,100,NULL,'mid-IR','IC 2166',NULL,'2013ApJ...771...88L',2013,1,3,NULL,'G',0.000013,NULL,'13.20',2.1,'SAB(s)bc','Isolated galaxy',NULL,NULL,NULL,1,96.731833,59.08008,0.397,NULL,61629990371,962968599,15046384,13.2),(46470,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46470,32.24,0.34,28,11647,NULL,NULL,'Malmquist cor.','IC 2166',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46471,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46471,32.31,0.4,29,11647,NULL,NULL,NULL,'IC 2166',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46472,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46472,32.47,0.43,31.1,11647,75,NULL,'3.6 micron, color corrected','IC 2166',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46473,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46473,32.47,0.2,31.2,11647,74.4,NULL,NULL,'IC 2166',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46474,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46474,32.49,0.43,31.5,11647,75,NULL,'3.6 micron, color + selection bias corrected','IC 2166',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46475,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46475,32.62,0.29,33.4,11647,NULL,NULL,NULL,'IC 2166',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46476,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46476,32.95,0.4,38.9,11647,75,NULL,'B','IC 2166',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46477,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46477,32.98,0.46,39.4,11647,NULL,NULL,'J','IC 2166',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46478,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46478,32.99,0.4,39.7,11647,NULL,NULL,'mean','IC 2166',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46479,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46479,33.02,0.47,40.1,11647,NULL,NULL,'H','IC 2166',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46480,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46480,33.03,0.45,40.4,11647,NULL,NULL,'K','IC 2166',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46481,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46481,36.15,0.53,170,11648,70,NULL,NULL,'2MASX J06265974-5642540',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'13.0I',0.7,NULL,NULL,NULL,NULL,NULL,1,96.7487917,-56.71506,0.297,NULL,40514173520,633033961,9891155,13),(46482,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46482,35.04,0.58,102,11649,70,NULL,NULL,'2MASX J06270073-1711393',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.5I',0.5,NULL,NULL,NULL,NULL,NULL,1,96.753083,-17.19419,1.229,NULL,39648889154,619513893,9679904,13.5),(46483,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46483,35.62,0.38,133,11650,NULL,NULL,'Malmquist cor.','ESO 121- G 032',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.17',0.3,'S...',NULL,NULL,NULL,NULL,1,96.7605416667,-61.17839,0.177,NULL,40383845175,630997580,9859337,15.17),(46484,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46484,35.68,0.37,137,11650,NULL,NULL,NULL,'ESO 121- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46485,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46485,35.72,0.2,139,11650,74.4,NULL,NULL,'ESO 121- G 032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46486,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46486,34.69,0.4,86.7,11651,NULL,NULL,'mean','UGC 03467',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000057,NULL,'14.30',1.1,'Sab',NULL,NULL,NULL,NULL,1,96.825083,49.61364,0.745,NULL,61532849220,961450769,15022668,14.3),(46487,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46487,34.87,0.47,94.2,11651,NULL,NULL,'H','UGC 03467',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46488,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46488,34.94,0.46,97.3,11651,NULL,NULL,'J','UGC 03467',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46489,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46489,34.95,0.45,97.6,11651,NULL,NULL,'K','UGC 03467',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46490,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46490,35.61,0.72,133,11652,70,NULL,NULL,'2MASX J06272120-5809596',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,96.8385417,-58.1665,0.357,NULL,40514955291,633046176,9891346,17.3),(46491,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46491,37.52,0.58,319,11653,70,NULL,NULL,'2MASX J06272563-3220162',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,96.8567917,-32.33789,0.101,NULL,39146739604,611667806,9557309,14.4),(46492,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:19','1','SN 1999ao',NULL,46492,36.22,0.09,166,11654,74.2,NULL,'SALT 2','2MASX J06272658-3550242',0.054,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,96.860833,-35.84011,0.253,NULL,38974287269,608973238,9515206,NULL),(46493,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:19','1','SN 1999ao',NULL,46493,36.8,0.1,229,11654,74.4,NULL,NULL,'2MASX J06272658-3550242',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46494,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:19','1','SN 1999ao',NULL,46494,36.97,0.08,235,11654,70,NULL,'SALT','2MASX J06272658-3550242',0.054,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46495,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:19','1','SN 1999ao',NULL,46495,37.12,0.11,252,11654,65,NULL,'SALT','2MASX J06272658-3550242',0.054,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46496,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:19','1','SN 1999ao',NULL,46496,37.13,0.04,253,11654,70,NULL,'SALT 2','2MASX J06272658-3550242',0.054,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46497,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46497,35.42,0.54,121,11655,70,NULL,NULL,'2MASX J06273403-5713017',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'13.9I',0.2,NULL,NULL,NULL,NULL,NULL,1,96.8919166667,-57.21717,0.293,NULL,40516023226,633062862,9891607,13.9),(46498,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46498,35.85,0.59,148,11656,70,NULL,NULL,'2MASX J06274914-2723267',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,96.9547083,-27.39072,0.249,NULL,39101721015,610964390,9546318,15.6),(46499,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46499,35.55,0.69,129,11657,70,NULL,NULL,'2MASX J06280230-5810549',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.8I',0.5,NULL,NULL,NULL,NULL,NULL,1,97.0097083,-58.18194,0.397,NULL,40514958642,633046228,9891347,13.8),(46500,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46500,36.29,0.55,181,11658,70,NULL,NULL,'2MASX J06280423-5612559',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,97.0175,-56.21561,0.313,NULL,40514480853,633038763,9891230,14.2),(46501,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46501,37.15,0.57,269,11659,70,NULL,NULL,'2MASX J06280624-4847000',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.4,NULL,NULL,NULL,NULL,NULL,1,97.025917,-48.78342,0.161,NULL,40274363026,629286922,9832608,14.6),(46502,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46502,36.04,0.53,161,11660,70,NULL,NULL,'2MASX J06280778-6720374',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,97.032417,-67.34381,0.249,NULL,40603126483,634423851,9912872,16.5),(46503,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46503,34.79,0.5,90.9,11661,70,NULL,NULL,'FAIRALL 0816',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'12.6I',0.7,NULL,NULL,NULL,NULL,NULL,1,97.0515416667,-57.29914,0.293,NULL,40516853810,633075840,9891810,12.6),(46504,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46504,36.29,0.5,181,11662,70,NULL,NULL,'2MASX J06281783-5113300',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.4I',0.5,NULL,NULL,NULL,NULL,NULL,1,97.074417,-51.22506,0.097,NULL,40331866042,630185406,9846646,13.4),(46505,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46505,34.39,0.53,75.6,11663,70,NULL,NULL,'ESO 034- G 008',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'15.12',0.2,'Sa-b',NULL,NULL,NULL,NULL,1,97.0817917,-74.26111,0.533,NULL,39925177330,623830895,9747357,15.12),(46506,'Orbital Mech.','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,'RN',46506,21.9,0.5,0.24,11664,NULL,NULL,NULL,'Anti-center Dwarf Galaxy',NULL,'2013pdmg.conf30302S',2013,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46507,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46507,36.38,0.54,189,11665,70,NULL,NULL,'2MASX J06283715-5603010',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'13.1I',0.6,NULL,NULL,NULL,NULL,NULL,1,97.154875,-56.05028,0.313,NULL,40510040283,632969379,9890146,13.1),(46508,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46508,35.45,0.64,123,11666,70,NULL,NULL,'2MASX J06283798-6237132',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.3,NULL,NULL,NULL,NULL,NULL,1,97.1582083,-62.62042,0.197,NULL,40398788474,631231069,9862985,14.1),(46509,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46509,36.24,0.55,177,11667,70,NULL,NULL,'AM 0627-471',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'13.9I',0.5,'(R\')SAB(s)0/a',NULL,NULL,NULL,NULL,1,97.205,-47.36739,0.145,NULL,42420606462,662821975,10356593,13.9),(46510,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46510,34.31,NULL,72.6,11668,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03469',NULL,'2010Ap&SS.325..163P',2010,1,1.2,NULL,'G',NULL,NULL,'16.5',0.1,'Scd:',NULL,NULL,NULL,NULL,1,97.207125,56.06728,0.553,NULL,61696766203,964011971,15062687,16.5),(46511,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46511,34.32,NULL,73,11668,NULL,NULL,'Dipole + Quadrupole','UGC 03469',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46512,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46512,34.33,NULL,73.6,11668,NULL,NULL,'Dipole','UGC 03469',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46513,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46513,34.38,NULL,75.1,11668,NULL,NULL,NULL,'UGC 03469',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46514,'Mass Model','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,'R',46514,19.89,1.26,0.095,11669,NULL,NULL,'small galaxy','2MASX J06285524+1459426',NULL,'1993AAS...182.5402S',1993,1,0.17,NULL,'G',NULL,NULL,'15.53',0.17,NULL,NULL,NULL,NULL,NULL,1,97.230083,14.99536,NULL,0,62453092740,975829574,15247337,15.53),(46515,'Mass Model','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,'R',46515,20.3,1.2,0.11,11669,NULL,NULL,NULL,'2MASX J06285524+1459426',NULL,'2002AAS...201.1320S',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46516,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46516,36.63,0.52,212,11670,70,NULL,NULL,'2MASX J06290149-5634157',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.6I',0.5,NULL,NULL,NULL,NULL,NULL,1,97.256333,-56.57103,0.297,NULL,40514537876,633039654,9891244,13.6),(46517,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,'R',46517,34.75,0.49,88.9,11671,75,NULL,'IR','ESO 490- G 005',NULL,'2011yCatp016004901K',2011,1,1.68,NULL,'G',0.000057,NULL,'15.29',0.22,'Sbc',NULL,NULL,NULL,NULL,1,97.2682917,-27.32739,0.373,NULL,39102938052,610983407,9546615,15.29),(46518,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46518,34.86,NULL,93.6,11671,NULL,NULL,NULL,'ESO 490- G 005',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46519,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46519,35.02,NULL,101,11671,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 490- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46520,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46520,35.04,NULL,102,11671,NULL,NULL,'Dipole + Quadrupole','ESO 490- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46521,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46521,35.04,NULL,102,11671,NULL,NULL,'Dipole','ESO 490- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46522,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46522,35.38,0.43,119,11671,75,NULL,'3.6 micron, color + selection bias corrected','ESO 490- G 005',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46523,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46523,36.08,0.54,164,11672,70,NULL,NULL,'2MASX J06290771-3623424',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.4I',0.5,NULL,NULL,NULL,NULL,NULL,1,97.2822083,-36.39503,0.369,NULL,38975864420,608997881,9515591,13.4),(46524,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46524,35.94,0.52,154,11673,70,NULL,NULL,'2MASX J06290920-1331396',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00013,NULL,'13.9I',0.5,'S',NULL,NULL,NULL,NULL,1,97.2882917,-13.52767,1.833,NULL,38751839743,605497495,9460898,13.9),(46525,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46525,35.01,0.42,100,11674,NULL,NULL,NULL,'ESO 426- G 015',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15',0.5,'Sb             HII',NULL,NULL,NULL,NULL,1,97.3054583,-30.33944,0.185,NULL,39186919784,612295621,9567119,15),(46526,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46526,35.05,0.2,102,11674,74.4,NULL,NULL,'ESO 426- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46527,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46527,35.12,0.4,106,11674,NULL,NULL,'Malmquist cor.','ESO 426- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46528,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46528,32.83,0.51,36.8,11675,70,NULL,NULL,'MCG -03-17-005',NULL,'2014MNRAS.445.2677S',2014,1,1.9,'2MASXi position not centered on galaxy.','G',0.000063,NULL,'14',0.8,'SAB0-: sp',NULL,NULL,NULL,NULL,1,97.323125,-17.35892,1.185,NULL,39649332269,619520816,9680012,14),(46529,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46529,36.11,0.65,167,11676,70,NULL,NULL,'2MASX J06292078-1209156',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,97.3365833333,-12.15447,2.769,NULL,38745997347,605406208,9459472,17.7),(46530,'BL Lac Luminosity','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46530,41.44,NULL,1940,11677,70,NULL,'nucleus-to-host flux ratio, z > 0.63','PKS 0627-199',NULL,'2006AJ....132....1S',2006,1,NULL,'Stellar Object.','QSO',NULL,NULL,'18.7',NULL,'BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,97.349,-19.98881,1.293,NULL,39658094453,619657725,9682151,18.7),(46531,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46531,36.09,0.79,165,11678,70,NULL,NULL,'2MASX J06292497-3917386',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.6I',0.2,NULL,NULL,NULL,NULL,NULL,1,97.354083,-39.29403,0.325,NULL,38985682302,609151285,9517988,14.6),(46532,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46532,34.59,0.51,82.6,11679,70,NULL,NULL,'2MASX J06293622-2639191',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.4I',0.5,NULL,NULL,NULL,NULL,NULL,1,97.400875,-26.65542,0.565,NULL,39102432264,610975504,9546492,13.4),(46533,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46533,36.38,0.59,189,11680,70,NULL,NULL,'2MASX J06294296-6628039',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,97.429,-66.46769,0.193,NULL,40347340486,630427195,9850424,14),(46534,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46534,35.93,0.54,153,11681,70,NULL,NULL,'2MASX J06294772-2237204',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.9I',0.3,NULL,NULL,NULL,NULL,NULL,1,97.448917,-22.62239,0.381,NULL,39619991717,619062370,9672849,13.9),(46535,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46535,35.61,0.52,133,11682,70,NULL,NULL,'ESO 121-IG 034',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.28',0.5,'(R)SAB0^0:',NULL,NULL,NULL,NULL,1,97.4625,-57.88342,0.357,NULL,40515343696,633052245,9891441,15.28),(46536,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46536,35.38,0.47,119,11683,70,NULL,NULL,'AM 0628-325',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00014,NULL,'15',0.5,NULL,NULL,NULL,NULL,NULL,1,97.5022083,-32.90542,0.309,NULL,39177406736,612146980,9564796,15),(46537,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46537,29.67,0.4,8.6,11684,75,NULL,'B','UGC 03475',NULL,'1988NBGC.C....0000T',1988,1,2.3,NULL,'G',0.000003,NULL,'14.5',1.2,'Sm:',NULL,NULL,NULL,NULL,1,97.6202083,39.50378,1.161,NULL,62869155350,982330552,15348914,14.5),(46538,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46538,31.51,NULL,20,11684,NULL,NULL,NULL,'UGC 03475',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46539,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46539,36.94,0.59,244,11685,70,NULL,NULL,'2MASX J06302710-6225114',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,97.6127917,-62.41994,0.193,NULL,40397822075,631215969,9862749,16.7),(46540,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46540,36.32,0.65,183,11686,70,NULL,NULL,'2MASX J06302868-6833197',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,97.619583,-68.55539,0.265,NULL,40602236065,634409938,9912655,16.1),(46541,'Brightest Stars','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46541,29.23,0.2,7.01,11687,NULL,NULL,NULL,'UGC 03476',NULL,'1998A&AS..133..181M',1998,1,1,NULL,'G',0.000013,NULL,'14.9',0.3,'Im:','Dwarf, field object',NULL,NULL,NULL,1,97.617917,33.30056,1.905,NULL,63069265013,985457265,15397769,14.9),(46542,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46542,36.97,0.59,248,11688,70,NULL,NULL,'2MASX J06303661-5543135',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,97.6527083,-55.72047,0.409,NULL,40510485674,632976338,9890255,17.2),(46543,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46543,35.86,0.53,149,11689,70,NULL,NULL,'2MASX J06304250-7416579',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00011,NULL,'15.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,97.6774166667,-74.28272,0.533,NULL,39925123665,623830057,9747344,15.4),(46544,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46544,36.56,0.84,205,11690,70,NULL,NULL,'2MASX J06304317-6848247',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.8I',0.3,NULL,NULL,NULL,NULL,NULL,1,97.6802083,-68.80694,0.289,NULL,40602398502,634412476,9912694,14.8),(46545,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46545,36.8,0.85,229,11691,70,NULL,NULL,'2MASX J06305019-7435490',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000183,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,97.7089583,-74.59703,0.545,NULL,39923170048,623799532,9746867,16.9),(46546,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46546,36.29,0.5,181,11692,70,NULL,NULL,'2MASX J06305495-7435530',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,97.7292917,-74.598,0.545,NULL,39923169930,623799530,9746867,15.9),(46547,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46547,32.39,0.4,30.1,11693,NULL,NULL,NULL,'ESO 490- G 007',NULL,'2009AJ....138..323T',2009,1,1.6,NULL,'G',0.000022,NULL,'14.50',1,'SB(s)m',NULL,NULL,NULL,NULL,1,97.7425,-23.72861,0.449,NULL,39095857480,610872773,9544887,14.5),(46548,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46548,32.39,0.39,30.1,11693,73,NULL,'opt','ESO 490- G 007',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46549,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46549,32.63,0.2,33.6,11693,74.4,NULL,NULL,'ESO 490- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46550,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46550,32.7,0.39,34.7,11693,73,NULL,'opt','ESO 490- G 007',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46551,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46551,32.8,0.45,36.2,11693,NULL,NULL,'Malmquist cor.','ESO 490- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46552,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46552,32.89,0.43,37.8,11693,NULL,NULL,NULL,'ESO 490- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46553,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46553,36.74,0.65,223,11694,70,NULL,NULL,'2MASX J06305993-6401500',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,97.749875,-64.03053,0.213,NULL,40393286858,631145107,9861642,16.8),(46554,'IRAS','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46554,33.76,0.8,56.4,11695,75,NULL,'MAT, I','ESO 058- G 003',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'15.96',0.16,'Sc',NULL,NULL,NULL,NULL,1,97.7537083,-71.50161,0.421,NULL,39875624713,623056636,9735259,15.96),(46555,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46555,33.8,0.32,57.5,11695,85,NULL,'I, raw','ESO 058- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46556,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46556,33.8,0.32,57.6,11695,85,NULL,'I, inv','ESO 058- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46557,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,'R',46557,33.82,0.49,58,11695,75,NULL,'IR','ESO 058- G 003',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46558,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46558,33.9,0.43,60.3,11695,75,NULL,'MAT, I, raw','ESO 058- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46559,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46559,33.97,0.43,62.1,11695,75,NULL,'MAT, I, inv','ESO 058- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46560,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46560,34.03,NULL,64,11695,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 058- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46561,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46561,34.04,NULL,64.4,11695,NULL,NULL,'Dipole + Quadrupole','ESO 058- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46562,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46562,34.05,NULL,64.5,11695,NULL,NULL,'Dipole','ESO 058- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46563,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46563,34.11,NULL,66.3,11695,NULL,NULL,NULL,'ESO 058- G 003',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46564,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46564,34.19,0.43,69,11695,75,NULL,'MAT, I, cor','ESO 058- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46565,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46565,34.24,0.44,70.4,11695,NULL,NULL,NULL,'ESO 058- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46566,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46566,34.28,0.2,71.8,11695,74.4,NULL,NULL,'ESO 058- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46567,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46567,34.29,0.43,72.2,11695,NULL,NULL,'Malmquist cor.','ESO 058- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46568,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46568,35.81,0.53,145,11696,70,NULL,NULL,'2MASX J06310214-6613078',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000103,NULL,'14.0I',0.5,NULL,NULL,NULL,NULL,NULL,1,97.758833,-66.21881,0.177,NULL,40338859949,630294686,9848354,14),(46569,'Tully est','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46569,30.63,0.8,13.4,11697,75,NULL,NULL,'ESO 206- G 016',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000021,NULL,'17.05',1.1,'IAB(s)m',NULL,NULL,NULL,NULL,1,97.7905,-52.41869,0.177,NULL,40318852769,629982074,9843469,17.05),(46570,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46570,34.64,0.48,84.6,11698,70,NULL,NULL,'ESO 365- G 025',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000087,NULL,'14.54',0.4,'S0',NULL,NULL,NULL,NULL,1,97.7957917,-36.82058,0.325,NULL,38946029440,608531710,9508307,14.54),(46571,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,'R',46571,34.6,0.49,83,11699,75,NULL,'IR','UGC 03477',NULL,'2011yCatp016004901K',2011,1,1.9,NULL,'G',0.000017,NULL,'15.40',0.4,'Sd',NULL,NULL,NULL,NULL,1,97.842125,50.09364,0.677,NULL,61534586188,961477909,15023092,15.4),(46572,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46572,34.64,0.2,84.7,11699,74.4,NULL,NULL,'UGC 03477',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46573,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46573,34.75,0.31,89.2,11699,NULL,NULL,'Malmquist cor.','UGC 03477',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46574,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46574,34.77,0.3,90,11699,NULL,NULL,NULL,'UGC 03477',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46575,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46575,35.51,0.82,127,11700,70,NULL,NULL,'2MASX J06312484-5537302',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,97.8535417,-55.62503,0.409,NULL,40510348500,632974195,9890221,14.2),(46576,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46576,35.15,0.56,107,11701,70,NULL,NULL,'ESO 121- G 035',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'15.29',0.4,'(R)S(r)0/a:',NULL,NULL,NULL,NULL,1,97.922167,-58.94514,0.293,NULL,40506934721,632920855,9889388,15.29),(46577,'IRAS','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46577,32.07,0.8,26,11702,75,NULL,'MAT, I','ESO 490- G 010',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000007,NULL,'13.67',1.2,'SB(rs)d? pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,97.9895,-26.76911,0.517,NULL,39102556806,610977450,9546522,13.67),(46578,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46578,31.53,0.2,20.2,11702,74.4,NULL,NULL,'ESO 490- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46579,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46579,31.64,0.4,21.3,11702,NULL,NULL,NULL,'ESO 490- G 010',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46580,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46580,31.64,0.4,21.3,11702,73,NULL,'opt','ESO 490- G 010',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46581,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46581,31.77,0.32,22.6,11702,85,NULL,'I, inv','ESO 490- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46582,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46582,31.78,0.32,22.7,11702,85,NULL,'I, raw','ESO 490- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46583,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46583,31.85,0.4,23.4,11702,73,NULL,'opt','ESO 490- G 010',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46584,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46584,31.95,0.66,24.6,11702,NULL,NULL,NULL,'ESO 490- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46585,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46585,32.18,0.59,27.3,11702,NULL,NULL,'Malmquist cor.','ESO 490- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46586,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46586,32.22,0.43,27.9,11702,75,NULL,'MAT, I, raw','ESO 490- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46587,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46587,32.26,0.43,28.4,11702,75,NULL,'MAT, I, inv','ESO 490- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46588,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46588,32.52,0.43,31.9,11702,75,NULL,'MAT, I, cor','ESO 490- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46589,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46589,35.14,0.6,107,11703,70,NULL,NULL,'2MASX J06321250-2838157',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.8I',0.4,NULL,NULL,NULL,NULL,NULL,1,98.052083,-28.63775,0.213,NULL,39129708250,611401691,9553151,13.8),(46590,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,'R',46590,34.2,0.49,69,11704,75,NULL,'IR','UGC 03482',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000013,NULL,'17.',0.3,'S',NULL,NULL,NULL,NULL,1,98.0780833333,19.20703,NULL,NULL,63216228815,987753575,15433649,17),(46591,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46591,34.43,0.57,76.9,11705,70,NULL,NULL,'2MASX J06322050-1425201',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.3I',0.7,'E',NULL,NULL,NULL,NULL,1,98.085417,-14.42233,2.125,NULL,38748959740,605452495,9460195,13.3),(46592,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46592,35.09,0.5,104,11706,70,NULL,NULL,'2MASX J06323112-6442260',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000087,NULL,'15.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,98.129833,-64.70717,0.197,NULL,40338666918,630291670,9848307,15),(46593,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46593,32.94,0.47,38.7,11707,NULL,NULL,'H','UGC 03474',NULL,'2007A&A...465...71T',2007,1,2.41,NULL,'G',0.000037,NULL,'15.40',0.25,'Scd            AGN?','Isolated galaxy',NULL,NULL,NULL,1,98.156667,71.56097,0.309,NULL,61283724016,957558187,14961846,15.4),(46594,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,'R',46594,33.04,0.49,40.6,11707,75,NULL,'IR','UGC 03474',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46595,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46595,33.11,0.45,41.9,11707,NULL,NULL,'K','UGC 03474',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46596,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46596,33.24,0.46,44.4,11707,NULL,NULL,'J','UGC 03474',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46597,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46597,33.32,0.43,46.2,11707,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03474',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46598,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46598,33.61,0.4,52.7,11707,NULL,NULL,'mean','UGC 03474',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46599,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46599,33.84,NULL,58.7,11707,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03474',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46600,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46600,33.85,NULL,58.8,11707,NULL,NULL,'Dipole + Quadrupole','UGC 03474',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46601,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46601,33.85,NULL,58.9,11707,NULL,NULL,'Dipole','UGC 03474',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46602,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46602,33.91,NULL,60.6,11707,NULL,NULL,NULL,'UGC 03474',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46603,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46603,33.16,0.45,42.9,11708,NULL,NULL,'K','UGC 03478',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000067,NULL,'13.60',0.5,'Sb             Sy1.2',NULL,NULL,NULL,NULL,1,98.1965416667,63.67367,0.341,NULL,61669764602,963590071,15056094,13.6),(46604,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46604,33.18,0.47,43.2,11708,NULL,NULL,'H','UGC 03478',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46605,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46605,33.24,0.46,44.6,11708,NULL,NULL,'J','UGC 03478',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46606,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46606,33.61,0.4,52.8,11708,NULL,NULL,'mean','UGC 03478',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46607,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46607,35.27,0.4,113,11709,NULL,NULL,'mean','ESO 365- G 027',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00002,NULL,'14.58',1,'SAB(rs)bc',NULL,NULL,NULL,NULL,1,98.202375,-34.12858,0.413,NULL,39174866288,612107285,9564176,14.58),(46608,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46608,35.42,0.47,122,11709,NULL,NULL,'H','ESO 365- G 027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46609,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46609,35.47,0.45,124,11709,NULL,NULL,'K','ESO 365- G 027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46610,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46610,35.52,0.46,127,11709,NULL,NULL,'J','ESO 365- G 027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46611,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46611,35.64,0.49,134,11710,70,NULL,NULL,'2MASX J06325641-3602084',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,98.2350833333,-36.03567,0.373,NULL,38948033124,608563017,9508797,14.5),(46612,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46612,35.41,0.55,121,11711,70,NULL,NULL,'2MASX J06325705-4515567',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000127,NULL,'15.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,98.2377083,-45.26581,0.197,NULL,42418295259,662785863,10356029,15.2),(46613,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46613,35.27,0.51,113,11712,70,NULL,NULL,'ESO 087- G 028',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00005,NULL,'14.5',0.7,'S0^0^ pec',NULL,NULL,NULL,NULL,1,98.327583,-62.99428,0.189,NULL,40398821680,631231588,9862993,14.5),(46614,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46614,36.52,0.76,202,11713,70,NULL,NULL,'2MASX J06332122-1350069',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.8I',0.3,NULL,NULL,NULL,NULL,NULL,1,98.3385,-13.83531,2.545,NULL,38753261721,605519714,9461245,14.8),(46615,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46615,34.34,NULL,73.8,11714,NULL,NULL,'Dipole','UGC 03489',NULL,'2010Ap&SS.325..163P',2010,1,2.07,NULL,'G',0.000013,NULL,'17.',0.24,'Sbc',NULL,NULL,NULL,NULL,1,98.389625,21.03711,NULL,NULL,63206891778,987607684,15431370,17),(46616,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46616,34.36,NULL,74.5,11714,NULL,NULL,'Dipole + Quadrupole','UGC 03489',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46617,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46617,34.36,NULL,74.6,11714,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03489',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46618,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46618,34.44,0.45,77.3,11714,NULL,NULL,'K','UGC 03489',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46619,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46619,34.45,0.47,77.8,11714,NULL,NULL,'H','UGC 03489',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46620,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46620,34.5,0.4,79.6,11714,NULL,NULL,'mean','UGC 03489',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46621,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46621,34.53,NULL,80.5,11714,NULL,NULL,NULL,'UGC 03489',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46622,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46622,34.56,0.43,81.8,11714,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03489',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46623,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46623,34.69,0.46,86.9,11714,NULL,NULL,'J','UGC 03489',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46624,'IRAS','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46624,34.76,0.8,89.4,11715,75,NULL,'MAT, I','ESO 365- G 028',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'14.44',0.9,'SAB(s)c: pec   HII','Pair member (points to parent)',NULL,NULL,NULL,1,98.3990416667,-34.26108,0.353,NULL,39167324086,611989438,9562334,14.44),(46625,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46625,34.33,0.32,73.3,11715,85,NULL,'I, raw','ESO 365- G 028',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46626,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46626,34.38,0.32,75.2,11715,85,NULL,'I, inv','ESO 365- G 028',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46627,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46627,34.42,0.43,76.6,11715,75,NULL,'MAT, I, raw','ESO 365- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46628,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46628,34.56,0.42,81.6,11715,NULL,NULL,NULL,'ESO 365- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46629,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46629,34.6,0.2,83.2,11715,74.4,NULL,NULL,'ESO 365- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46630,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46630,34.65,0.43,85.3,11715,75,NULL,'MAT, I, inv','ESO 365- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46631,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46631,34.71,0.39,87.7,11715,NULL,NULL,'Malmquist cor.','ESO 365- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46632,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46632,34.9,0.43,95.6,11715,75,NULL,'MAT, I, cor','ESO 365- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46633,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46633,35.27,0.4,113,11715,NULL,NULL,'mean','ESO 365- G 028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46634,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46634,35.48,0.47,125,11715,NULL,NULL,'H','ESO 365- G 028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46635,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46635,35.69,0.2,137,11716,74.4,NULL,NULL,'UGC 03487',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000023,NULL,'14.8',0.8,'Sd',NULL,NULL,NULL,NULL,1,98.4157083333,40.68781,0.937,NULL,63409511207,990773612,15480837,14.8),(46636,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,'R',46636,34.98,0.49,99.1,11717,75,NULL,'IR','UGC 03487 NOTES01',NULL,'2011yCatp016004901K',2011,1,0.7,NULL,'G',0.00006,NULL,'17',0.13,'S',NULL,NULL,NULL,NULL,1,98.4165,40.66694,0.937,NULL,63409511156,990773611,15480837,17),(46637,'FP','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46637,34.6,0.49,83.3,11718,70,NULL,NULL,'ESO 365- G 029',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000133,NULL,'15',0.5,'S0             AGN?','Pair member (points to parent)',NULL,NULL,NULL,1,98.423083,-34.27158,0.353,NULL,39167321594,611989399,9562334,15),(46638,'IRAS','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46638,32.93,0.8,38.5,11719,75,NULL,'MAT, I','ESO 490- G 014',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00001,NULL,'13.66',1.2,'SB(s)bc:',NULL,NULL,NULL,NULL,1,98.427875,-24.98594,0.517,NULL,39106916586,611045571,9547587,13.66),(46639,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46639,31.67,0.32,21.6,11719,85,NULL,'I, inv','ESO 490- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46640,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46640,31.68,0.32,21.7,11719,85,NULL,'I, raw','ESO 490- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46641,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46641,32.12,0.43,26.6,11719,75,NULL,'MAT, I, raw','ESO 490- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46642,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46642,32.17,0.43,27.2,11719,75,NULL,'MAT, I, inv','ESO 490- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46643,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46643,32.44,0.43,30.7,11719,75,NULL,'MAT, I, cor','ESO 490- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46644,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46644,32.56,0.43,32.4,11719,75,NULL,'3.6 micron, color + selection bias corrected','ESO 490- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46645,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46645,32.59,0.43,32.9,11719,75,NULL,'3.6 micron, color corrected','ESO 490- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46646,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46646,32.62,0.2,33.4,11719,74.4,NULL,NULL,'ESO 490- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46647,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:19','1',NULL,NULL,46647,32.64,0.39,33.7,11719,73,NULL,'opt','ESO 490- G 014',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46648,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46648,32.78,0.52,36,11719,NULL,NULL,'Malmquist cor.','ESO 490- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46649,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46649,32.8,0.52,36.3,11719,NULL,NULL,NULL,'ESO 490- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46650,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46650,36.84,0.71,234,11720,70,NULL,NULL,'2MASX J06334940-3506459',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,98.4559583,-35.11281,0.229,NULL,38944722139,608511283,9507988,14.1),(46651,'IRAS','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46651,34.7,0.8,86.9,11721,75,NULL,'MAT, I','NGC 2255',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000023,NULL,'14.13',0.7,'SA(r:)c:       HII',NULL,NULL,NULL,NULL,1,98.4942917,-34.81258,0.261,NULL,39166819188,611981549,9562211,14.13),(46652,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46652,34.04,0.32,64.4,11721,85,NULL,'I, raw','NGC 2255',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46653,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46653,34.09,0.32,65.9,11721,85,NULL,'I, inv','NGC 2255',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46654,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46654,34.17,0.43,68.1,11721,75,NULL,'MAT, I, raw','NGC 2255',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46655,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46655,34.38,0.43,75.1,11721,75,NULL,'MAT, I, inv','NGC 2255',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46656,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46656,34.65,0.41,85.2,11721,NULL,NULL,NULL,'NGC 2255',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46657,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46657,34.68,0.2,86.3,11721,74.4,NULL,NULL,'NGC 2255',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46658,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46658,34.73,0.43,88.4,11721,75,NULL,'MAT, I, cor','NGC 2255',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46659,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46659,34.75,0.39,89.2,11721,NULL,NULL,'Malmquist cor.','NGC 2255',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46660,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46660,36.14,0.55,169,11722,70,NULL,NULL,'MCG -06-15-012',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.5',0.5,NULL,NULL,NULL,NULL,NULL,1,98.501167,-34.17236,0.413,NULL,39167316325,611989317,9562333,15.5),(46661,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,'R',46661,34.31,0.49,72.6,11723,75,NULL,'IR','UGC 03484',NULL,'2011yCatp016004901K',2011,1,1.83,NULL,'G',0.000053,NULL,'15.50',0.25,'Sbc',NULL,NULL,NULL,NULL,1,98.509083,58.86144,0.293,NULL,61699968151,964062002,15063468,15.5),(46662,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46662,35.08,0.43,104,11723,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03484',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46663,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46663,35.94,0.53,154,11724,70,NULL,NULL,'2MASX J06340629-3512564',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000137,NULL,'13.0I',0.6,NULL,NULL,NULL,NULL,NULL,1,98.526167,-35.21569,0.253,NULL,38944814924,608512733,9508011,13),(46664,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46664,36.53,0.53,202,11725,70,NULL,NULL,'2MASX J06340913-3627302',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,98.538125,-36.45833,0.377,NULL,38945987947,608531061,9508297,14.3),(46665,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46665,36.72,0.8,221,11726,70,NULL,NULL,'2MFGC 05253',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,98.538667,-34.15344,0.413,NULL,39167299649,611989057,9562329,15.5),(46666,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46666,37.17,0.59,271,11727,70,NULL,NULL,'2MASX J06341101-5609281',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.7I',0.3,NULL,NULL,NULL,NULL,NULL,1,98.5459166667,-56.15786,0.417,NULL,40511957981,632999343,9890614,14.7),(46667,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46667,38.05,0.62,407,11728,70,NULL,NULL,'2MASX J06341588-5517012',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,98.566125,-55.28367,0.417,NULL,40512292276,633004566,9890696,14.5),(46668,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46668,36.19,0.59,173,11729,70,NULL,NULL,'2MASX J06341591-1604597',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,98.566333,-16.08319,1.645,NULL,39635379268,619302801,9676606,14.6),(46669,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46669,36,0.54,159,11730,70,NULL,NULL,'2MASX J06341760-1431437',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,98.573417,-14.52878,2.137,NULL,38748075817,605438684,9459979,15.3),(46670,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46670,36.08,0.71,164,11731,70,NULL,NULL,'2MASX J06342090-2753047',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.5,NULL,NULL,NULL,NULL,NULL,1,98.587125,-27.88469,0.361,NULL,39132128123,611439501,9553742,14),(46671,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46671,35.97,0.55,156,11732,70,NULL,NULL,'2MASX J06344688-3711083',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,98.6954583,-37.18556,0.441,NULL,38953383593,608646618,9510103,15),(46672,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46672,35,0.63,99.8,11733,70,NULL,NULL,'2MASX J06344865-3704233',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,98.7027916667,-37.07308,0.393,NULL,38953412910,608647076,9510110,14.8),(46673,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46673,35.69,0.53,137,11734,70,NULL,NULL,'ESO 034- G 009',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.71',1,'SB(r)c',NULL,NULL,NULL,NULL,1,98.7104583,-74.89222,0.453,NULL,39923345577,623802274,9746910,14.71),(46674,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46674,36.42,0.65,192,11735,70,NULL,NULL,'2MASX J06345156-3717113',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.3I',0.4,NULL,NULL,NULL,NULL,NULL,1,98.7149583,-37.2865,0.441,NULL,38953484655,608648197,9510128,14.3),(46675,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46675,32.01,NULL,25.3,11736,NULL,NULL,NULL,'UGC 03485',NULL,'2000BSAO...50....5K',2000,1,1.21,NULL,'G',0.000023,NULL,'18.',0.1,'Sdm',NULL,NULL,NULL,NULL,1,98.734375,65.8355,0.249,NULL,61615758997,962746234,15042909,18),(46676,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46676,32.15,NULL,26.9,11736,NULL,NULL,'Dipole + Quadrupole','UGC 03485',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46677,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46677,32.16,NULL,27,11736,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03485',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46678,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46678,32.2,NULL,27.5,11736,NULL,NULL,'Dipole','UGC 03485',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46679,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46679,36.35,0.59,186,11737,70,NULL,NULL,'ESO 557- G 005',NULL,'2014MNRAS.445.2677S',2014,1,2.13,'Star superposed.','G',0.00003,NULL,'16.07',0.22,'Sbc',NULL,NULL,NULL,NULL,1,98.7602083,-19.46353,1.829,NULL,39660481363,619695021,9682734,16.07),(46680,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46680,35.62,NULL,133,11737,NULL,NULL,'Dipole','ESO 557- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46681,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46681,35.62,NULL,133,11737,NULL,NULL,'Dipole + Quadrupole','ESO 557- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46682,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46682,35.62,NULL,133,11737,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 557- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46683,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46683,36.49,0.43,198,11737,75,NULL,'3.6 micron, color + selection bias corrected','ESO 557- G 005',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46684,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,'R',46684,34.58,0.49,82.6,11738,75,NULL,'IR','FGC 0576',NULL,'2011yCatp016004901K',2011,1,1.55,NULL,'G',0.000027,NULL,'15.71',0.1,'Sd',NULL,NULL,NULL,NULL,1,98.8017917,53.47814,0.561,NULL,61522388836,961287325,15020114,15.71),(46685,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46685,34.59,NULL,82.9,11738,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0576',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46686,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46686,34.6,NULL,83.3,11738,NULL,NULL,'Dipole + Quadrupole','FGC 0576',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46687,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46687,34.61,NULL,83.5,11738,NULL,NULL,'Dipole','FGC 0576',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46688,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46688,34.65,NULL,85.3,11738,NULL,NULL,NULL,'FGC 0576',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46689,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46689,33.36,0.43,47,11739,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03498',NULL,'2014MNRAS.444..527S',2014,1,1.1,NULL,'G',0.00002,NULL,'17.',0.3,'S',NULL,NULL,NULL,NULL,1,98.834625,14.97878,NULL,NULL,63175780776,987121574,15423774,17),(46690,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,'R',46690,33.66,0.49,53.9,11739,75,NULL,'IR','UGC 03498',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46691,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46691,33.87,0.47,59.5,11739,NULL,NULL,'H','UGC 03498',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46692,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46692,33.88,0.4,59.6,11739,NULL,NULL,'mean','UGC 03498',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46693,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46693,33.91,0.45,60.5,11739,NULL,NULL,'K','UGC 03498',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46694,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46694,35.28,0.56,114,11740,70,NULL,NULL,'2MASX J06352212-3434365',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'13.9I',0.5,NULL,NULL,NULL,NULL,NULL,1,98.8422083,-34.57675,0.413,NULL,39166870964,611982358,9562224,13.9),(46695,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46695,34.71,0.4,87.5,11741,NULL,NULL,'mean','UGC 03493',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000037,NULL,'14.50',0.9,'S?',NULL,NULL,NULL,NULL,1,98.862375,48.84386,0.573,NULL,61475962345,960561911,15008779,14.5),(46696,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46696,34.83,0.47,92.4,11741,NULL,NULL,'H','UGC 03493',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46697,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46697,34.9,0.46,95.3,11741,NULL,NULL,'J','UGC 03493',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46698,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46698,34.92,0.45,96.2,11741,NULL,NULL,'K','UGC 03493',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46699,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46699,36.45,0.54,195,11742,70,NULL,NULL,'ESO 161-IG 018',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.62',0.4,NULL,NULL,NULL,NULL,NULL,1,98.8972917,-55.18256,0.417,NULL,40509110365,632954849,9889919,15.62),(46700,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,'R',46700,34.24,0.49,70.6,11743,75,NULL,'IR','FGC 0575',NULL,'2011yCatp016004901K',2011,1,0.91,NULL,'G',NULL,NULL,'16.7',0.09,'Sd',NULL,NULL,NULL,NULL,1,98.907,64.68881,0.269,NULL,61616824898,962762889,15043170,16.7),(46701,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46701,34.79,NULL,90.7,11743,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0575',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46702,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46702,34.81,NULL,91.4,11743,NULL,NULL,'Dipole + Quadrupole','FGC 0575',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46703,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46703,34.82,NULL,92,11743,NULL,NULL,'Dipole','FGC 0575',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46704,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46704,34.85,NULL,93.3,11743,NULL,NULL,NULL,'FGC 0575',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46705,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46705,34.75,0.48,89.3,11744,70,NULL,NULL,'2MASX J06360828-1547073',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000123,NULL,'13.4R',NULL,'E',NULL,NULL,NULL,NULL,1,99.0344583,-15.78533,2.057,NULL,39634601656,619290650,9676416,13.4),(46706,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46706,35.39,0.55,120,11745,70,NULL,NULL,'2MASX J06361564-2924323',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,99.0650833333,-29.40903,0.485,NULL,39185804524,612278195,9566846,14.7),(46707,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46707,36.86,0.56,236,11746,70,NULL,NULL,'2MASX J06362176-5531420',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,99.090833,-55.52844,0.417,NULL,40512443502,633006929,9890733,15.8),(46708,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,'R',46708,35.81,0.49,145,11747,75,NULL,'IR','ESO 308- G 018',NULL,'2011yCatp016004901K',2011,1,1.55,NULL,'G',0.00006,NULL,'16.08',0.13,'Sbc',NULL,NULL,NULL,NULL,1,99.1279583333,-37.78417,0.369,NULL,38951173358,608612083,9509563,16.08),(46709,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46709,36.1,NULL,166,11747,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 308- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46710,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46710,36.12,NULL,168,11747,NULL,NULL,'Dipole + Quadrupole','ESO 308- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46711,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46711,36.14,NULL,169,11747,NULL,NULL,'Dipole','ESO 308- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46712,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46712,35.99,0.69,158,11748,70,NULL,NULL,'2MASX J06364440-7748162',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,99.184833,-77.80447,0.777,NULL,39880921767,623139402,9736553,17),(46713,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46713,34.47,0.46,78.3,11749,70,NULL,NULL,'ESO 365- G 035',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.0001,NULL,'14.77',0.8,'(R_1R\'_2)SAB(l)0/a',NULL,NULL,NULL,NULL,1,99.188833,-35.07081,0.301,NULL,38947526516,608555101,9508673,14.77),(46714,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46714,36.07,0.85,164,11750,70,NULL,NULL,'2MASX J06364774-3728271',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,99.198875,-37.47419,0.413,NULL,38952964470,608640069,9510001,15.7),(46715,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46715,36.63,0.52,212,11751,70,NULL,NULL,'2MASX J06370676-3359481',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,99.278125,-33.99667,0.425,NULL,39169941258,612030332,9562973,14.9),(46716,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:20','1','SN 2002kf',NULL,46716,32.68,0.2,33.7,11752,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','CGCG 233-023',0.0193,'2011A&A...526A..81B',2011,1,NULL,NULL,'G',NULL,NULL,'15.6',NULL,NULL,NULL,NULL,NULL,NULL,1,99.3196666667,49.84989,0.505,NULL,61530895861,961420247,15022191,15.6),(46717,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:20','1','SN 2002kf',NULL,46717,34.03,0.19,62.8,11752,74.2,NULL,'SALT 2','CGCG 233-023',0.0193,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46718,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:20','1','SN 2002kf',NULL,46718,34.6,0.09,83.2,11752,74.4,NULL,NULL,'CGCG 233-023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46719,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:20','1','SN 2002kf',NULL,46719,34.71,0.04,85.8,11752,72,NULL,'SALT2','CGCG 233-023',0.0193,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46720,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:20','1','SN 2002kf',NULL,46720,34.74,0.18,87,11752,70,NULL,'SALT 2','CGCG 233-023',0.0193,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46721,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:20','1','SN 2002kf',NULL,46721,34.74,0.17,87.1,11752,73.8,NULL,'SALT 2 (SNANA)','CGCG 233-023',0.0196,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46722,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:20','1','SN 2002kf',NULL,46722,34.89,0.22,93.4,11752,65,NULL,'SALT2','CGCG 233-023',0.0193,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46723,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:20','1','SN 2002kf',NULL,46723,34.91,0.2,94.2,11752,65,NULL,'SALT','CGCG 233-023',0.0193,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46724,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:20','1','SN 2002kf',NULL,46724,34.97,0.05,96.6,11752,70,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','CGCG 233-023',0.0193,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46725,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:20','1','SN 2002kf',NULL,46725,34.98,0.19,97.1,11752,65,NULL,'MLCS17','CGCG 233-023',0.0193,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46726,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:20','1','SN 2002kf',NULL,46726,35.03,0.19,99.2,11752,65,NULL,'MLCS31','CGCG 233-023',0.0193,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46727,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46727,35.9,0.52,151,11753,70,NULL,NULL,'ESO 161- G 019',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'14.76',1,'(R\')SB(r)b',NULL,NULL,NULL,NULL,1,99.3245,-55.36136,0.397,NULL,40508976903,632952764,9889886,14.76),(46728,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46728,35.71,0.78,139,11754,70,NULL,NULL,'2MASX J06372056-3720430',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,99.33575,-37.34533,0.481,NULL,38952852761,608638324,9509973,15.4),(46729,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46729,36.57,0.59,206,11755,70,NULL,NULL,'2MASX J06373232-1717218',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.4I',0.3,'E',NULL,NULL,NULL,NULL,1,99.38475,-17.28942,2.161,NULL,39638280972,619348140,9677314,14.4),(46730,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46730,33.49,0.51,49.9,11756,70,NULL,NULL,'2MASX J06373426-7108143',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000127,NULL,'15.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,99.393,-71.13728,0.437,NULL,39872406326,623006348,9734474,15),(46731,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46731,36.57,0.58,206,11757,70,NULL,NULL,'2MASX J06375486-5133390',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,99.4784583333,-51.56086,0.085,NULL,40321990300,630031098,9844235,14.4),(46732,'TRGB','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46732,28.13,0.23,4.23,11758,NULL,NULL,NULL,'ESO 490- G 017',NULL,'2003A&A...398..479K',2003,1,1.7,NULL,'G',0.000002,NULL,'14.0B',1.3,'IAB(s)m?',NULL,NULL,NULL,NULL,1,99.487875,-26.00086,0.621,NULL,39105584954,611024764,9547261,14),(46733,'TRGB','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46733,29.01,0.1,6.34,11758,74.4,NULL,NULL,'ESO 490- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46734,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46734,30.17,NULL,10.8,11759,NULL,NULL,NULL,'2MASX J06380016-1501229',NULL,'2013AJ....145..101K',2013,1,2.2,'The 2MASX position is for a superposed star.','G',0.00001,NULL,NULL,1.1,'SAB(s)dm?',NULL,NULL,NULL,NULL,1,99.503375,-15.02467,NULL,NULL,39643299345,619426552,9678539,NULL),(46735,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46735,30.55,0.43,12.9,11759,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J06380016-1501229',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46736,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46736,36.82,0.58,231,11760,70,NULL,NULL,'2MASX J06381252-6443589',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,99.5520417,-64.73303,0.233,NULL,40338294262,630285847,9848216,16.9),(46737,'IRAS','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46737,30.64,0.8,13.4,11761,75,NULL,'MAT, I','ESO 206- G 017',NULL,'1997ApJS..109..333W',1997,1,2.55,NULL,'G',0.00003,NULL,'15.49',0.32,'Sd',NULL,NULL,NULL,NULL,1,99.5815417,-51.95283,0.121,NULL,40316722395,629948787,9842949,15.49),(46738,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46738,31.11,0.32,16.7,11761,85,NULL,'I, inv','ESO 206- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46739,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46739,31.16,0.32,17.1,11761,85,NULL,'I, raw','ESO 206- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46740,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46740,31.23,0.39,17.6,11761,73,NULL,'opt','ESO 206- G 017',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46741,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46741,31.32,0.52,18.4,11761,NULL,NULL,'Malmquist cor.','ESO 206- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46742,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46742,31.34,0.51,18.5,11761,NULL,NULL,NULL,'ESO 206- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46743,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46743,31.38,0.2,18.9,11761,74.4,NULL,NULL,'ESO 206- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46744,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46744,31.49,NULL,19.9,11761,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 206- G 017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46745,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46745,31.49,0.43,19.9,11761,75,NULL,'MAT, I, inv','ESO 206- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46746,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46746,31.52,NULL,20.1,11761,NULL,NULL,'Dipole + Quadrupole','ESO 206- G 017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46747,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46747,31.52,NULL,20.2,11761,NULL,NULL,'Dipole','ESO 206- G 017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46748,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46748,31.63,0.43,21.2,11761,75,NULL,'MAT, I, raw','ESO 206- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46749,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46749,31.81,0.43,23,11761,75,NULL,'MAT, I, cor','ESO 206- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46750,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46750,31.88,NULL,23.8,11761,NULL,NULL,NULL,'ESO 206- G 017',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46751,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46751,32.16,0.43,27.1,11762,75,NULL,'3.6 micron, color corrected','NGC 2263',NULL,'2014MNRAS.444..527S',2014,1,2.6,NULL,'G',0.000007,NULL,'12.85',1.5,'(R\'_2)SB(r)ab',NULL,NULL,NULL,NULL,1,99.620167,-24.84869,0.829,NULL,39106341222,611036581,9547446,12.85),(46752,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46752,32.17,0.43,27.1,11762,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2263',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46753,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46753,32.19,0.2,27.4,11762,74.4,NULL,NULL,'NGC 2263',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46754,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46754,30.95,NULL,15.5,11763,NULL,NULL,NULL,'UGC 03501',NULL,'2013AJ....145..101K',2013,1,1.1,NULL,'G',0.00002,NULL,'18.',0.3,'Im:',NULL,NULL,NULL,NULL,1,99.66,49.25833,0.521,NULL,61496926330,960889473,15013898,18),(46755,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46755,32.18,0.69,27.3,11764,100,NULL,'mid-IR','ESO 557-G 009',NULL,'2013ApJ...771...88L',2013,1,1.9,NULL,'G',0.00001,NULL,'14.31',0.9,'SB(s)c',NULL,NULL,NULL,NULL,1,99.676083,-20.28681,1.905,NULL,39646723585,619480056,9679375,14.31),(46756,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46756,32.33,0.2,29.2,11764,74.4,NULL,NULL,'ESO 557-G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46757,'IRAS','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46757,34.78,0.8,90.4,11765,75,NULL,'MAT, I','ESO 366- G 004',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'15.23',0.3,'SB(r)cd        HII',NULL,NULL,NULL,NULL,1,99.6856666667,-35.25836,0.293,NULL,38946680007,608541875,9508466,15.23),(46758,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46758,32.98,0.32,39.4,11765,85,NULL,'I, raw','ESO 366- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46759,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46759,32.99,0.32,39.6,11765,85,NULL,'I, inv','ESO 366- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46760,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46760,33.26,0.43,44.9,11765,75,NULL,'MAT, I, raw','ESO 366- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46761,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46761,33.35,0.43,46.9,11765,75,NULL,'MAT, I, inv','ESO 366- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46762,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46762,33.36,0.43,47.1,11765,75,NULL,'MAT, I, cor','ESO 366- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46763,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46763,33.88,0.57,59.8,11765,NULL,NULL,NULL,'ESO 366- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46764,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46764,34.1,0.51,66,11765,NULL,NULL,'Malmquist cor.','ESO 366- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46765,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46765,34.11,0.2,66.4,11765,74.4,NULL,NULL,'ESO 366- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46766,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46766,35.71,0.41,139,11766,NULL,NULL,'Malmquist cor.','ESO 366- G 005',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.82',0.7,'Sc:            HII',NULL,NULL,NULL,NULL,1,99.7377083,-36.68606,0.469,NULL,38956143342,608689739,9510777,14.82),(46767,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46767,35.9,0.38,151,11766,NULL,NULL,NULL,'ESO 366- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46768,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46768,35.94,0.2,154,11766,74.4,NULL,NULL,'ESO 366- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46769,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,'R',46769,35.09,0.49,104,11767,75,NULL,'IR','FGC 0578',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',NULL,NULL,'16.4',0.12,'Sc',NULL,NULL,NULL,NULL,1,99.751917,57.38269,0.369,NULL,61703369824,964115153,15064299,16.4),(46770,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46770,35.42,NULL,121,11767,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0578',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46771,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46771,35.43,NULL,122,11767,NULL,NULL,'Dipole + Quadrupole','FGC 0578',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46772,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46772,35.45,NULL,123,11767,NULL,NULL,'Dipole','FGC 0578',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46773,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46773,35.46,NULL,124,11767,NULL,NULL,NULL,'FGC 0578',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46774,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46774,36,0.52,158,11768,70,NULL,NULL,'2MASX J06392427-2852569',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00013,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,99.8510417,-28.88239,0.369,NULL,39130703231,611417237,9553394,14.7),(46775,'TRGB','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46775,29.86,0.1,9.36,11769,74.4,NULL,NULL,'ESO 308- G 022',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000017,NULL,'16.0B',1.3,'dwarf Irr',NULL,NULL,NULL,NULL,1,99.88625,-40.72083,0.333,NULL,42451048009,663297625,10364025,16),(46776,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,'R',46776,34.21,0.49,69.5,11770,75,NULL,'IR','UGC 03505',NULL,'2011yCatp016004901K',2011,1,1.4,'abs(b) < 10 degrees.','G',0.00002,NULL,'17.',0.3,'Scd:',NULL,NULL,NULL,NULL,1,99.902583,20.74261,NULL,NULL,63195830657,987434854,15428669,17),(46777,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46777,34.24,0.2,70.5,11770,74.4,NULL,NULL,'UGC 03505',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46778,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46778,36.93,0.7,243,11771,70,NULL,NULL,'2MASX J06393714-2858203',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,99.9047917,-28.97236,0.369,NULL,39130581919,611415342,9553364,15.8),(46779,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46779,36.93,0.65,243,11772,70,NULL,NULL,'2MASX J06394777-7651400',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,99.9490416667,-76.86103,0.597,NULL,39895608014,623368875,9740138,17.2),(46780,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46780,35.65,0.62,135,11773,70,NULL,NULL,'2MASX J06394824-3756301',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.6I',0.4,NULL,NULL,NULL,NULL,NULL,1,99.951125,-37.94181,0.385,NULL,38949863496,608591617,9509244,13.6),(46781,'IRAS','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46781,34.22,0.8,69.8,11774,75,NULL,'MAT, I','ESO 308- G 023',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'14.48',0.6,'SB(r)b:',NULL,NULL,NULL,NULL,1,99.9577917,-38.24428,0.405,NULL,38949744406,608589756,9509214,14.48),(46782,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46782,34.04,0.43,64.2,11774,75,NULL,'MAT, I, raw','ESO 308- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46783,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46783,34.06,0.32,64.9,11774,85,NULL,'I, raw','ESO 308- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46784,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46784,34.1,0.32,66,11774,85,NULL,'I, inv','ESO 308- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46785,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46785,34.22,0.43,69.7,11774,75,NULL,'MAT, I, inv','ESO 308- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46786,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46786,34.49,0.45,79.2,11774,NULL,NULL,NULL,'ESO 308- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46787,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46787,34.51,0.45,79.8,11774,NULL,NULL,'Malmquist cor.','ESO 308- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46788,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46788,34.53,0.2,80.5,11774,74.4,NULL,NULL,'ESO 308- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46789,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46789,34.61,0.43,83.7,11774,75,NULL,'MAT, I, cor','ESO 308- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46790,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46790,35.89,0.7,150,11775,70,NULL,NULL,'2MASX J06395260-6112115',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,99.9689583,-61.20322,0.293,NULL,40386680281,631041879,9860029,16.5),(46791,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46791,36.97,0.54,248,11776,70,NULL,NULL,'2MASX J06400546-3445133',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.1I',0.3,NULL,NULL,NULL,NULL,NULL,1,100.022875,-34.75375,0.321,NULL,39168189199,612002956,9562546,14.1),(46792,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46792,31.56,0.4,20.5,11777,NULL,NULL,NULL,'NGC 2273A',NULL,'2009AJ....138..323T',2009,1,2.7,NULL,'G',0.00001,NULL,'13.00',2.2,'SAB(s)cd','in a pair',NULL,NULL,NULL,1,100.0295417,60.08067,0.329,NULL,61627937101,962936517,15045883,13),(46793,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46793,32.5,0.4,31.6,11777,75,NULL,'B','NGC 2273A',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46794,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46794,32.72,0.4,34.9,11777,NULL,NULL,'mean','NGC 2273A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46795,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46795,33.29,0.46,45.4,11777,NULL,NULL,'J','NGC 2273A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46796,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46796,33.43,0.47,48.6,11777,NULL,NULL,'H','NGC 2273A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46797,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46797,33.46,0.45,49.2,11777,NULL,NULL,'K','NGC 2273A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46798,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46798,36.45,0.6,195,11778,70,NULL,NULL,'2MASX J06401102-3536283',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.4,NULL,NULL,NULL,NULL,NULL,1,100.0457917,-35.60783,0.441,NULL,38947110223,608548597,9508571,14.2),(46799,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46799,35.21,0.55,110,11779,70,NULL,NULL,'2MASX J06401774-1922570',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,100.073916667,-19.38247,1.857,NULL,39647486724,619491980,9679562,15.3),(46800,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46800,36.37,0.51,188,11780,70,NULL,NULL,'2MASX J06401955-1835550',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,100.081375,-18.59872,2.085,NULL,39647873774,619498027,9679656,14.3),(46801,'IRAS','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46801,32.42,0.8,30.4,11781,75,NULL,'MAT, I','ESO 490- G 028',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000013,NULL,'15.5',0.2,'S...',NULL,NULL,NULL,NULL,1,100.0864583,-27.09758,0.721,NULL,39130901351,611420333,9553442,15.5),(46802,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46802,29.77,0.32,8.97,11781,85,NULL,'I, inv','ESO 490- G 028',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46803,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46803,29.84,0.32,9.28,11781,85,NULL,'I, raw','ESO 490- G 028',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46804,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46804,30.3,0.43,11.5,11781,75,NULL,'MAT, I, inv','ESO 490- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46805,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46805,30.48,0.43,12.5,11781,75,NULL,'MAT, I, raw','ESO 490- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46806,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46806,30.78,0.43,14.3,11781,75,NULL,'MAT, I, cor','ESO 490- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46807,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46807,31.94,0.4,24.4,11781,NULL,NULL,NULL,'ESO 490- G 028',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46808,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46808,31.94,0.4,24.4,11781,73,NULL,'opt','ESO 490- G 028',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46809,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,'R',46809,32.31,0.49,29,11781,75,NULL,'IR','ESO 490- G 028',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46810,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46810,36.16,0.55,171,11782,70,NULL,NULL,'2MASX J06402972-2728536',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,100.123833333,-27.48161,0.665,NULL,39131393241,611428019,9553562,15),(46811,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46811,35.52,0.53,127,11783,70,NULL,NULL,'2MASX J06403531-3651243',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,100.147083,-36.85678,0.501,NULL,38956682288,608698160,9510908,15),(46812,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46812,35.98,0.55,157,11784,70,NULL,NULL,'2MASX J06403958-1828106',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,100.164916667,-18.46964,2.085,NULL,39648587090,619509173,9679830,15.4),(46813,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46813,35.33,0.51,117,11785,NULL,NULL,NULL,'ESO 058- G 008',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.63',0.4,'Sb:',NULL,NULL,NULL,NULL,1,100.16875,-69.2355,0.381,NULL,40616377945,634630905,9916107,15.63),(46814,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46814,35.36,0.51,118,11785,NULL,NULL,'Malmquist cor.','ESO 058- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46815,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46815,35.37,0.2,119,11785,74.4,NULL,NULL,'ESO 058- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46816,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46816,36.07,0.57,163,11786,70,NULL,NULL,'2MASX J06404121-1739073',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,100.171667,-17.65214,2.697,NULL,39646251883,619472685,9679260,15.7),(46817,'IRAS','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46817,32.76,0.8,35.6,11787,75,NULL,'A82, H','ESO 122-IG 001',NULL,'1997ApJS..109..333W',1997,1,2.7,NULL,'G',0.0001,NULL,'13.10',1.3,'(R\')SAB(s)bc','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,100.1800417,-58.52458,0.357,NULL,40508401615,632943775,9889746,13.1),(46818,'Tully est','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46818,32.48,0.8,31.4,11787,75,NULL,NULL,'ESO 122-IG 001',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46819,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46819,31.8,0.47,22.9,11787,75,NULL,'A82, H, raw','ESO 122-IG 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46820,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46820,31.87,0.47,23.7,11787,75,NULL,'A82, H, inv','ESO 122-IG 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46821,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46821,32.12,0.47,26.6,11787,75,NULL,'A82, H, cor','ESO 122-IG 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46822,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46822,32.15,0.43,26.9,11787,75,NULL,'3.6 micron, color + selection bias corrected','ESO 122-IG 001',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46823,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46823,32.27,0.47,28.4,11787,NULL,NULL,'H','ESO 122-IG 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46824,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46824,32.29,0.45,28.7,11787,NULL,NULL,'K','ESO 122-IG 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46825,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46825,32.32,0.46,29.2,11787,NULL,NULL,'J','ESO 122-IG 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46826,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46826,32.35,0.43,29.5,11787,75,NULL,'3.6 micron, color corrected','ESO 122-IG 001',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46827,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46827,32.55,0.2,32.4,11787,74.4,NULL,NULL,'ESO 122-IG 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46828,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46828,32.6,0.4,33.2,11787,NULL,NULL,'mean','ESO 122-IG 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46829,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46829,35.35,0.65,117,11788,70,NULL,NULL,'2MASX J06404784-1724003',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,'E/S',NULL,NULL,NULL,NULL,1,100.19925,-17.40008,2.697,NULL,39638668526,619354195,9677409,15.7),(46830,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46830,35.92,0.51,153,11789,70,NULL,NULL,'2MASX J06404799-2152387',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,100.1999583,-21.87739,1.405,NULL,39627520518,619180008,9674687,14.1),(46831,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,'R',46831,35.41,0.49,121,11790,75,NULL,'IR','ESO 366- G 006',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000037,NULL,'15.61',0.2,'Sc',NULL,NULL,NULL,NULL,1,100.230667,-37.06375,0.517,NULL,38956538843,608695919,9510873,15.61),(46832,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:20','1','SN 2008bq',NULL,46832,35.66,0.07,127,11791,72,NULL,NULL,'ESO 308- G 025',0.03446,'2013ApJ...773...53F',2013,1,1.5,NULL,'G',0.000143,NULL,'15',0.6,'Sa',NULL,NULL,NULL,NULL,1,100.262917,-38.03567,0.405,NULL,38949784070,608590376,9509224,15),(46833,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:20','1','SN 2008bq',NULL,46833,35.67,0.13,132,11791,73.8,NULL,'SALT 2 (SNANA)','ESO 308- G 025',0.0344,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46834,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:20','1','SN 2008bq',NULL,46834,35.84,0.13,147,11791,72,NULL,'M(H) = -18.317 mag','ESO 308- G 025',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46835,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46835,36.31,0.77,183,11792,70,NULL,NULL,'2MFGC 05341',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,100.2732917,-28.72256,0.617,NULL,39129782941,611402858,9553169,15.2),(46836,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46836,35.98,0.52,157,11793,70,NULL,NULL,'ESO 366- G 007',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'15.40',0.3,'N',NULL,NULL,NULL,NULL,1,100.3114583,-34.2255,0.425,NULL,39167803225,611996925,9562451,15.4),(46837,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46837,35.06,0.48,103,11794,70,NULL,NULL,'ESO 206- G 019',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000117,NULL,'15.21',0.6,'(R\'_2)SAB(s)ab',NULL,NULL,NULL,NULL,1,100.339,-51.41275,0.093,NULL,40304322721,629755042,9839922,15.21),(46838,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46838,36.98,0.55,249,11795,70,NULL,NULL,'2MASX J06412466-2929424',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,100.3527083,-29.49522,0.545,NULL,39187442605,612303790,9567246,15.4),(46839,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46839,34.94,NULL,97.5,11796,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0580',NULL,'2010Ap&SS.325..163P',2010,1,1.34,NULL,'G',0.000073,NULL,'16.3',0.12,'Sc',NULL,NULL,NULL,NULL,1,100.3572083,45.61917,0.701,NULL,63406853314,990732083,15480188,16.3),(46840,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46840,34.96,NULL,98.1,11796,NULL,NULL,'Dipole','FGC 0580',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46841,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46841,34.96,NULL,98.3,11796,NULL,NULL,'Dipole + Quadrupole','FGC 0580',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46842,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,'R',46842,35.15,0.49,107,11796,75,NULL,'IR','FGC 0580',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46843,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46843,35.32,NULL,116,11796,NULL,NULL,NULL,'FGC 0580',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46844,'Carbon Stars','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46844,19.87,0.57,0.094,11797,NULL,NULL,'Carbon star S21, RA 100.3062, DEC -50.9068','Carina Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,1,23.4,NULL,'G',0.0002,NULL,'11.3B',15.5,'E3','Group member',NULL,NULL,NULL,1,100.402875,-50.96619,0.101,0,40305132277,629767691,9840120,11.3),(46845,'Carbon Stars','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46845,20.21,0.57,0.11,11797,NULL,NULL,'Carbon star S24, RA 100.5431, DEC -50.9400','Carina Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46846,'Carbon Stars','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46846,20.3,0.57,0.115,11797,NULL,NULL,'Carbon star S23, RA 100.4353, DEC -51.0058','Carina Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46847,'Carbon Stars','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46847,20.38,0.57,0.119,11797,NULL,NULL,'Carbon star S22, RA 100.4230, DEC -50.9689','Carina Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46848,'CMD','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46848,19.87,0.11,0.094,11797,NULL,NULL,NULL,'Carina Dwarf Spheroidal',NULL,'1997AJ....114.1458M',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46849,'CMD','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46849,20.06,NULL,0.103,11797,NULL,NULL,NULL,'Carina Dwarf Spheroidal',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46850,'CMD','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46850,20.11,NULL,0.105,11797,NULL,NULL,NULL,'Carina Dwarf Spheroidal',NULL,'2015ApJ...805..103V',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46851,'CMD','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46851,20.19,0.13,0.109,11797,NULL,NULL,NULL,'Carina Dwarf Spheroidal',NULL,'2002MNRAS.332...91D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46852,'CMD','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46852,20.24,NULL,0.112,11797,NULL,NULL,NULL,'Carina Dwarf Spheroidal',NULL,'2003AJ....126..218M',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46853,'Delta Scuti','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46853,20.22,0.05,0.111,11797,NULL,NULL,NULL,'Carina Dwarf Spheroidal',NULL,'2011AJ....142..110M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46854,'Delta Scuti','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46854,20.47,NULL,0.124,11797,NULL,NULL,NULL,'Carina Dwarf Spheroidal',NULL,'2000PASP..112.1096M',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46855,'Horizontal Branch','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46855,19.6,NULL,0.085,11797,NULL,NULL,'Photographic','Carina Dwarf Spheroidal',NULL,'1981MNRAS.196P...1C',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46856,'Horizontal Branch','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46856,19.64,0.15,0.085,11797,NULL,NULL,NULL,'Carina Dwarf Spheroidal',NULL,'1995MNRAS.277.1354I',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46857,'Horizontal Branch','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46857,19.8,NULL,0.0912,11797,NULL,NULL,NULL,'Carina Dwarf Spheroidal',NULL,'1983ApJ...273..530M',1983,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46858,'Horizontal Branch','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46858,19.82,NULL,0.092,11797,NULL,NULL,NULL,'Carina Dwarf Spheroidal',NULL,'1985IAUS..113..541W',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46859,'Horizontal Branch','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46859,20.12,0.08,0.106,11797,NULL,NULL,NULL,'Carina Dwarf Spheroidal',NULL,'1994AJ....108..507S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46860,'Red Clump','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,'R',46860,19.84,0.07,0.0929,11797,NULL,NULL,NULL,'Carina Dwarf Spheroidal',NULL,'1998AcA....48..113U',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46861,'Red Clump','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46861,19.94,0.2,0.0973,11797,NULL,NULL,NULL,'Carina Dwarf Spheroidal',NULL,'2002MNRAS.332...91D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46862,'Red Clump','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,'R',46862,19.96,0.08,0.098,11797,NULL,NULL,NULL,'Carina Dwarf Spheroidal',NULL,'2000AcA....50..279U',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46863,'Red Clump','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46863,19.96,0.23,0.098,11797,NULL,NULL,'[Fe/H] = -1.3 to -1.5','Carina Dwarf Spheroidal',NULL,'2014MNRAS.444.3139M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46864,'Red Clump','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46864,19.96,0.06,0.0982,11797,NULL,NULL,NULL,'Carina Dwarf Spheroidal',NULL,'2001MNRAS.323..109G',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46865,'Red Clump','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46865,20.17,0.02,0.108,11797,NULL,NULL,'K','Carina Dwarf Spheroidal',NULL,'2003AJ....125.2494P',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46866,'Red Clump','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46866,20.17,0.02,0.108,11797,NULL,NULL,NULL,'Carina Dwarf Spheroidal',NULL,'2003AJ....125.2494P',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46867,'RR Lyrae','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,'R',46867,19.93,0.08,0.097,11797,NULL,NULL,'V','Carina Dwarf Spheroidal',NULL,'2000AcA....50..279U',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46868,'RR Lyrae','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46868,20.01,0.02,0.1,11797,NULL,NULL,'92, mean of BV, BI, VI, and BVI','Carina Dwarf Spheroidal',NULL,'2015ApJ...814...71C',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46869,'RR Lyrae','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46869,20.06,0.06,0.103,11797,NULL,NULL,'92, BI','Carina Dwarf Spheroidal',NULL,'2015ApJ...814...71C',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46870,'RR Lyrae','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46870,20.06,0.06,0.103,11797,NULL,NULL,'92, BVI','Carina Dwarf Spheroidal',NULL,'2015ApJ...814...71C',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46871,'RR Lyrae','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46871,20.07,0.08,0.103,11797,NULL,NULL,'92, VI','Carina Dwarf Spheroidal',NULL,'2015ApJ...814...71C',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46872,'RR Lyrae','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46872,20.08,0.02,0.104,11797,NULL,18.493,'33, JK, Sollima, syst. +/- 0.09 mag','Carina Dwarf Spheroidal',NULL,'2015AJ....150...90K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46873,'RR Lyrae','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46873,20.08,0.07,0.104,11797,NULL,NULL,'92, BV','Carina Dwarf Spheroidal',NULL,'2015ApJ...814...71C',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46874,'RR Lyrae','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46874,20.09,NULL,0.104,11797,NULL,NULL,NULL,'Carina Dwarf Spheroidal',NULL,'2008ApJ...679...52T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46875,'RR Lyrae','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46875,20.09,0.1,0.104,11797,NULL,NULL,'period-luminosity-amplitude relation','Carina Dwarf Spheroidal',NULL,'2003AJ....126..197D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46876,'RR Lyrae','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46876,20.09,0.1,0.104,11797,NULL,NULL,'8','Carina Dwarf Spheroidal',NULL,'2013ApJ...775....6C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46877,'RR Lyrae','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46877,20.1,NULL,0.105,11797,NULL,NULL,'Photographic','Carina Dwarf Spheroidal',NULL,'1986AJ.....92..302S',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46878,'RR Lyrae','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,'R',46878,20.1,0.12,0.105,11797,NULL,NULL,NULL,'Carina Dwarf Spheroidal',NULL,'2003MmSAI..74..894D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46879,'RR Lyrae','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46879,20.12,0.02,0.106,11797,NULL,18.493,'33, JK, D _eka _ny, syst. +/- 0.10 mag','Carina Dwarf Spheroidal',NULL,'2015AJ....150...90K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46880,'RR Lyrae','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46880,20.12,0.02,0.106,11797,NULL,18.493,'33, JK, Catelan (a), syst. +/- 0.10 mag','Carina Dwarf Spheroidal',NULL,'2015AJ....150...90K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46881,'RR Lyrae','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46881,20.12,0.02,0.106,11797,NULL,18.493,'33, JK, Weighted mean, syst. +/- 0.11 mag','Carina Dwarf Spheroidal',NULL,'2015AJ....150...90K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46882,'RR Lyrae','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46882,20.14,0.02,0.107,11797,NULL,18.493,'33, JK, Bono, syst. +/- 0.11 mag','Carina Dwarf Spheroidal',NULL,'2015AJ....150...90K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46883,'RR Lyrae','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46883,20.14,0.02,0.107,11797,NULL,18.493,'33, JK, Catelan (b), syst. +/- 0.10 mag','Carina Dwarf Spheroidal',NULL,'2015AJ....150...90K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46884,'RR Lyrae','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46884,20.18,0.05,0.109,11797,NULL,NULL,NULL,'Carina Dwarf Spheroidal',NULL,'2011AJ....142..110M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46885,'RR Lyrae','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,'R',46885,20.19,0.12,0.109,11797,NULL,NULL,NULL,'Carina Dwarf Spheroidal',NULL,'2004MmSAI..75..194F',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46886,'RR Lyrae','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46886,20.19,0.04,0.109,11797,NULL,NULL,'first-overtone blue edge','Carina Dwarf Spheroidal',NULL,'2003AJ....126..197D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46887,'RR Lyrae','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46887,20.19,0.12,0.109,11797,NULL,NULL,'period-luminosity-color relation','Carina Dwarf Spheroidal',NULL,'2003AJ....126..197D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46888,'RR Lyrae','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46888,20.19,0.12,0.109,11797,NULL,NULL,'Mean of 3 RR Lyrae methods','Carina Dwarf Spheroidal',NULL,'2003AJ....126..197D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46889,'SX Phe Stars','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46889,20.01,0.05,0.1,11797,NULL,NULL,'SX Phe stars','Carina Dwarf Spheroidal',NULL,'1995AJ....109.1751M',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46890,'TRGB','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,'R',46890,19.94,0.08,0.097,11797,NULL,NULL,NULL,'Carina Dwarf Spheroidal',NULL,'2000AcA....50..279U',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46891,'TRGB','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46891,19.94,0.2,0.0973,11797,NULL,NULL,NULL,'Carina Dwarf Spheroidal',NULL,'2002MNRAS.332...91D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46892,'TRGB','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,'R',46892,20,NULL,0.1,11797,NULL,NULL,NULL,'Carina Dwarf Spheroidal',NULL,'2000glg..book.....V',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46893,'TRGB','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46893,20.04,0.1,0.102,11797,NULL,NULL,NULL,'Carina Dwarf Spheroidal',NULL,'2011A&A...531A.152L',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46894,'TRGB','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46894,20.05,0.09,0.102,11797,NULL,NULL,'I','Carina Dwarf Spheroidal',NULL,'1994AJ....108..507S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46895,'TRGB','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46895,20.09,0.03,0.104,11797,NULL,NULL,'J','Carina Dwarf Spheroidal',NULL,'2009AJ....138..459P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46896,'TRGB','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,'R',46896,20.12,0.04,0.106,11797,NULL,NULL,'TRGB and Horizontal Branch','Carina Dwarf Spheroidal',NULL,'1996ASPC...98..328S',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46897,'TRGB','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46897,20.13,0.04,0.106,11797,NULL,NULL,'K','Carina Dwarf Spheroidal',NULL,'2009AJ....138..459P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46898,'TRGB','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46898,20.14,0.08,0.11,11797,74.4,NULL,NULL,'Carina Dwarf Spheroidal',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46899,'Type II Cepheids','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46899,20.06,0.12,0.103,11797,NULL,NULL,'20, V','Carina Dwarf Spheroidal',NULL,'1998AJ....115.1856M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46900,'Type II Cepheids','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46900,20.17,0.1,0.108,11797,NULL,NULL,'340','Carina Dwarf Spheroidal',NULL,'2013AJ....146..141V',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46901,'Orbital Mech.','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,'R',46901,19.8,NULL,0.0913,11797,NULL,NULL,'Cusp model','Carina Dwarf Spheroidal',NULL,'2015NatCo...6E7599U',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46902,'Orbital Mech.','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,'R',46902,19.96,NULL,0.0982,11797,NULL,NULL,'Cusp model (fixed v)','Carina Dwarf Spheroidal',NULL,'2015NatCo...6E7599U',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46903,'Orbital Mech.','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,'R',46903,19.97,NULL,0.0986,11797,NULL,NULL,'Core model','Carina Dwarf Spheroidal',NULL,'2015NatCo...6E7599U',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46904,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46904,35.39,0.5,119,11798,70,NULL,NULL,'ESO 122-IG 003',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000123,NULL,'14.79',0.6,'S0',NULL,NULL,NULL,NULL,1,100.410917,-60.26222,0.477,NULL,40375243577,630863180,9857237,14.79),(46905,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,'R',46905,34.42,0.49,76.4,11799,75,NULL,'IR','2MFGC 05353',NULL,'2011yCatp016004901K',2011,1,0.3,NULL,'G',0.00009,NULL,'11.4K',NULL,NULL,NULL,NULL,NULL,NULL,1,100.425125,5.54114,NULL,NULL,62516609538,976822024,15262844,11.4),(46906,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46906,35.28,0.64,114,11800,70,NULL,NULL,'2MASX J06414696-5443514',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,100.445667,-54.73097,0.349,NULL,40508642783,632947543,9889805,15.3),(46907,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,'R',46907,34.86,0.49,93.9,11801,75,NULL,'IR','2MFGC 05358',NULL,'2011yCatp016004901K',2011,1,0.8,'abs(b) < 10 degrees.','G',0.000013,NULL,'12.5K',0.1,NULL,NULL,NULL,NULL,NULL,1,100.5152917,21.14297,NULL,NULL,63195966165,987436971,15428702,12.5),(46908,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46908,36.94,0.84,245,11802,70,NULL,NULL,'2MASX J06421053-3549582',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,100.543875,-35.83286,0.477,NULL,38955580456,608680944,9510639,15.9),(46909,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46909,36.01,0.6,159,11803,70,NULL,NULL,'AM 0641-522',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'16.3b',NULL,'COMPACT',NULL,NULL,NULL,NULL,1,100.5589583,-52.54311,0.117,NULL,40310338587,629849040,9841391,16.3),(46910,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46910,36.77,0.65,226,11804,70,NULL,NULL,'2MASX J06421423-7507246',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,100.5592083,-75.12344,0.553,NULL,39922669386,623791709,9746745,17.3),(46911,'Tully est','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46911,30.93,0.8,15.3,11805,75,NULL,NULL,'UGCA 130',NULL,'1988NBGC.C....0000T',1988,1,0.7,NULL,'G',0.000017,NULL,'15.6',0.5,'I?             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,100.5647083,75.62572,0.333,NULL,61316578158,958071533,14969867,15.6),(46912,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46912,35.18,0.53,108,11806,70,NULL,NULL,'2MASX J06422838-3129190',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,100.618375,-31.48864,0.477,NULL,39190412114,612350189,9567971,14.9),(46913,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46913,32.57,0.4,32.6,11807,NULL,NULL,'mean','NGC 2272',NULL,'2007A&A...465...71T',2007,1,2.5,NULL,'G',0.000032,NULL,'12.74',1.6,'SAB(s)0-',NULL,NULL,NULL,NULL,1,100.672083,-27.4595,0.665,NULL,39139645529,611556961,9555577,12.74),(46914,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46914,32.68,0.45,34.3,11807,NULL,NULL,'K','NGC 2272',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46915,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46915,36.48,0.52,198,11808,70,NULL,NULL,'2MASX J06424204-6658375',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,100.6752083,-66.97711,0.273,NULL,40611117940,634548717,9914823,16.4),(46916,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46916,34.66,0.52,85.5,11809,70,NULL,NULL,'ESO 087- G 034',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000103,NULL,'14.94',0.6,'Sa',NULL,NULL,NULL,NULL,1,100.676333,-64.59089,0.225,NULL,40394706894,631167295,9861988,14.94),(46917,'IRAS','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46917,32.18,0.8,27.3,11810,75,NULL,'MAT, I','ESO 366- G 009',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.00001,NULL,'14.17',0.9,'(R\'_2)SAB(s)c',NULL,NULL,NULL,NULL,1,100.7082917,-35.57222,0.373,NULL,38954714483,608667413,9510428,14.17),(46918,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46918,32.41,0.32,30.3,11810,85,NULL,'I, inv','ESO 366- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46919,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46919,32.41,0.32,30.4,11810,85,NULL,'I, raw','ESO 366- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46920,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46920,32.42,0.4,30.5,11810,73,NULL,'opt','ESO 366- G 009',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46921,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46921,32.5,0.69,31.7,11810,NULL,NULL,'Malmquist cor.','ESO 366- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46922,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46922,32.54,0.43,32.2,11810,75,NULL,'MAT, I, raw','ESO 366- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46923,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46923,32.56,0.43,32.5,11810,75,NULL,'MAT, I, inv','ESO 366- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46924,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46924,32.68,0.63,34.3,11810,NULL,NULL,NULL,'ESO 366- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46925,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46925,32.72,0.2,35,11810,74.4,NULL,NULL,'ESO 366- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46926,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46926,32.74,0.43,35.3,11810,75,NULL,'MAT, I, cor','ESO 366- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46927,'SBF','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46927,32.51,0.28,31.8,11811,NULL,NULL,'I','NGC 2271',NULL,'2001ApJ...546..681T',2001,1,2.1,NULL,'G',0.000123,NULL,'13.16',1.4,'SAB0-',NULL,NULL,NULL,NULL,1,100.7207917,-23.476,0.953,NULL,39614075478,618969929,9671405,13.16),(46928,'SBF','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46928,32.51,0.28,31.8,11811,NULL,NULL,NULL,'NGC 2271',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46929,'SBF','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46929,32.53,0.14,32.1,11811,74.4,NULL,NULL,'NGC 2271',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46930,'SBF','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46930,32.64,0.28,33.7,11811,NULL,NULL,'Malmquist cor.','NGC 2271',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46931,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46931,32.03,0.41,25.5,11811,NULL,NULL,NULL,'NGC 2271',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46932,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46932,32.33,0.41,29.3,11811,NULL,NULL,'Malmquist cor.','NGC 2271',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46933,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46933,32,0.45,25.1,11811,NULL,NULL,'K','NGC 2271',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46934,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46934,32.74,0.4,35.3,11811,NULL,NULL,'mean','NGC 2271',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46935,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46935,34.76,0.49,89.7,11812,70,NULL,NULL,'2MASX J06432557-7415255',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00011,NULL,'14.81',NULL,NULL,'Pair member (points to parent)',NULL,NULL,NULL,1,100.856,-74.25728,0.573,NULL,39927168501,623862007,9747843,14.81),(46936,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46936,35.68,0.36,137,11813,NULL,NULL,'Malmquist cor.','ESO 366- G 012',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.63',0.4,'Sb-c',NULL,NULL,NULL,NULL,1,100.873791667,-35.76675,0.477,NULL,38955470706,608679229,9510612,15.63),(46937,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46937,35.76,0.35,142,11813,NULL,NULL,NULL,'ESO 366- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46938,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46938,35.8,0.2,145,11813,74.4,NULL,NULL,'ESO 366- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46939,'IRAS','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46939,34.31,0.8,72.8,11814,75,NULL,'MAT, I','ESO 034- G 012',NULL,'1997ApJS..109..333W',1997,1,1.8,'ESO-Uppsala catalog gives v=33,100 km/sec.','G',0.000023,NULL,'13.88',0.9,'SAB(rs)c',NULL,NULL,NULL,NULL,1,100.8782083,-72.59461,0.485,NULL,39873381585,623021587,9734712,13.88),(46940,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46940,34.01,0.32,63.5,11814,85,NULL,'I, raw','ESO 034- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46941,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46941,34.06,0.43,64.8,11814,75,NULL,'MAT, I, raw','ESO 034- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46942,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46942,34.08,0.32,65.4,11814,85,NULL,'I, inv','ESO 034- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46943,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46943,34.21,0.47,69.4,11814,NULL,NULL,'H','ESO 034- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46944,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46944,34.28,0.45,71.7,11814,NULL,NULL,'K','ESO 034- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46945,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46945,34.29,0.46,72,11814,NULL,NULL,'J','ESO 034- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46946,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46946,34.34,0.43,73.8,11814,75,NULL,'MAT, I, inv','ESO 034- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46947,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46947,34.35,0.43,74,11814,75,NULL,'MAT, I, cor','ESO 034- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46948,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46948,34.41,0.4,76,11814,NULL,NULL,'mean','ESO 034- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46949,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46949,34.43,0.46,76.9,11814,NULL,NULL,'Malmquist cor.','ESO 034- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46950,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46950,34.66,0.41,85.5,11814,NULL,NULL,NULL,'ESO 034- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46951,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46951,34.7,0.2,87.1,11814,74.4,NULL,NULL,'ESO 034- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46952,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46952,33.51,0.4,50.3,11815,NULL,NULL,'mean','NGC 2253',NULL,'2007A&A...465...71T',2007,1,1.5,'Identification as NGC 2253 is very uncertain.','G',0.000017,NULL,'13.15',1.1,'Scd:',NULL,NULL,NULL,NULL,1,100.924333,65.20628,0.221,NULL,61614890953,962732671,15042697,13.15),(46953,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46953,33.73,0.45,55.6,11815,NULL,NULL,'K','NGC 2253',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46954,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46954,33.75,0.38,56.2,11815,NULL,NULL,'Malmquist cor.','NGC 2253',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46955,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46955,33.77,0.47,56.8,11815,NULL,NULL,'H','NGC 2253',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46956,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46956,33.78,0.46,57,11815,NULL,NULL,'J','NGC 2253',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46957,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46957,33.8,0.38,57.7,11815,NULL,NULL,NULL,'NGC 2253',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46958,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46958,33.94,0.2,61.4,11815,74.4,NULL,NULL,'NGC 2253',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46959,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46959,31.71,0.48,22,11816,70,NULL,NULL,'ESO 490- G 035',NULL,'2014MNRAS.445.2677S',2014,1,1,'6dF DR1 has z = 0.023321.','G',0.000037,NULL,'15',0.8,'Sb:',NULL,NULL,NULL,NULL,1,100.93525,-27.26653,0.757,NULL,39139482169,611554408,9555537,15),(46960,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46960,35.01,0.52,101,11817,NULL,NULL,NULL,'ESO 087- G 039',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'15.83',0.6,'S...',NULL,NULL,NULL,NULL,1,100.937416667,-66.86283,0.269,NULL,40611000186,634546877,9914794,15.83),(46961,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46961,35.05,0.2,102,11817,74.4,NULL,NULL,'ESO 087- G 039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46962,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46962,35.09,0.5,104,11817,NULL,NULL,'Malmquist cor.','ESO 087- G 039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46963,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46963,34.78,0.53,90.2,11818,NULL,NULL,'Malmquist cor.','ESO 034- G 013',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'14.65',0.5,'SA(rs)c',NULL,NULL,NULL,NULL,1,100.947583333,-73.67539,0.549,NULL,39926016060,623844000,9747562,14.65),(46964,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46964,35.04,0.47,102,11818,NULL,NULL,NULL,'ESO 034- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46965,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46965,35.08,0.2,104,11818,74.4,NULL,NULL,'ESO 034- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46966,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46966,35.89,0.63,151,11819,70,NULL,NULL,'2MASX J06435891-2947493',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,100.9954583,-29.79703,0.469,NULL,39181039861,612203747,9565683,14.9),(46967,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46967,35.56,0.56,129,11820,70,NULL,NULL,'2MASX J06435917-2905333',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,100.9964583,-29.09264,0.725,NULL,39135176707,611487136,9554486,15.2),(46968,'Sosies','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46968,33.44,0.14,48.8,11821,NULL,NULL,NULL,'UGC 03524',NULL,'2002A&A...393...57T',2002,1,1.3,NULL,'G',0.000007,NULL,'16.0',0.6,'S?',NULL,NULL,NULL,NULL,1,101.0025,12.40194,NULL,NULL,63166833356,986981771,15421590,16),(46969,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46969,33.14,0.43,42.5,11821,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03524',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46970,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46970,33.6,0.47,52.5,11821,NULL,NULL,'H','UGC 03524',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46971,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46971,33.65,0.46,53.7,11821,NULL,NULL,'J','UGC 03524',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46972,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46972,33.7,0.45,55,11821,NULL,NULL,'K','UGC 03524',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46973,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46973,33.76,0.4,56.4,11821,NULL,NULL,'mean','UGC 03524',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46974,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46974,34.81,0.51,91.7,11822,70,NULL,NULL,'FAIRALL 1310',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.1B',0.75,NULL,NULL,NULL,NULL,NULL,1,101.025375,-75.08156,0.553,NULL,39922548187,623789815,9746715,15.1),(46975,'IRAS','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46975,32.21,0.8,27.7,11823,75,NULL,'MAT, I','ESO 490- G 036',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000023,NULL,'14.92',0.3,'Scd: sp',NULL,NULL,NULL,NULL,1,101.0290417,-27.17536,0.757,NULL,39139949242,611561706,9555651,14.92),(46976,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46976,32.13,0.39,26.7,11823,73,NULL,'IR','ESO 490- G 036',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46977,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,'R',46977,32.13,0.4,26.7,11823,75,NULL,NULL,'ESO 490- G 036',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46978,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46978,32.35,0.4,29.5,11823,73,NULL,'opt','ESO 490- G 036',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46979,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46979,32.35,0.32,29.5,11823,85,NULL,'I, raw','ESO 490- G 036',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46980,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46980,32.35,0.32,29.5,11823,85,NULL,'I, inv','ESO 490- G 036',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46981,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46981,32.57,0.4,32.7,11823,NULL,NULL,NULL,'ESO 490- G 036',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46982,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46982,32.62,0.43,33.4,11823,75,NULL,'MAT, I, raw','ESO 490- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46983,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46983,32.69,0.43,34.4,11823,75,NULL,'MAT, I, inv','ESO 490- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46984,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,'R',46984,32.7,0.49,34.6,11823,75,NULL,'IR','ESO 490- G 036',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46985,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46985,32.82,0.43,36.6,11823,75,NULL,'MAT, I, cor','ESO 490- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46986,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46986,35.17,0.59,108,11824,70,NULL,NULL,'2MASX J06440719-4310174',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,101.029875,-43.17147,0.261,NULL,42478110472,663720476,10370632,16.1),(46987,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46987,35.49,0.54,125,11825,70,NULL,NULL,'2MASX J06441970-3653509',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,101.082166667,-36.89744,0.533,NULL,38954047456,608656991,9510265,14.9),(46988,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46988,32.94,0.52,38.7,11826,70,NULL,NULL,'ESO 490-G 037',NULL,'2014MNRAS.445.2677S',2014,1,2.1,'Confused HIPASS source','G',0.00001,NULL,'12.95',1.3,'SA(r)0/a',NULL,NULL,NULL,NULL,1,101.093833,-26.10883,0.825,NULL,39126515428,611351803,9552371,12.95),(46989,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46989,32.05,0.69,25.7,11826,100,NULL,'mid-IR','ESO 490-G 037',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46990,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46990,29.98,NULL,9.91,11827,NULL,NULL,NULL,'IC 2171',NULL,'2013AJ....145..101K',2013,1,1.7,'Visvanathan, et al. (1996,ApJS,107,521) give v = 3395 km/sec.','G',0.000007,NULL,'15.13',0.5,'IB(s)m:','Pair member (points to parent)',NULL,NULL,NULL,1,101.115375,-17.93247,NULL,NULL,39645032093,619453626,9678962,15.13),(46991,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,'R',46991,30.2,0.4,11,11827,75,NULL,NULL,'IC 2171',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46992,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46992,30.21,0.4,11,11827,73,NULL,'IR','IC 2171',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46993,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,'R',46993,30.4,0.49,12,11827,75,NULL,'IR','IC 2171',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46994,'IRAS','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46994,33.66,0.8,53.9,11828,75,NULL,'MAT, I','ESO 058- G 013',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.000033,NULL,'14.66',0.31,'Sc',NULL,NULL,NULL,NULL,1,101.169583,-71.45739,0.497,NULL,39874377347,623037146,9734955,14.66),(46995,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46995,33.59,0.47,52.2,11828,NULL,NULL,'H','ESO 058- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46996,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46996,33.61,0.45,52.7,11828,NULL,NULL,'K','ESO 058- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46997,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,'R',46997,33.67,0.49,54.1,11828,75,NULL,'IR','ESO 058- G 013',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46998,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46998,33.71,0.46,55.2,11828,NULL,NULL,'J','ESO 058- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46999,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,46999,33.75,0.4,56.2,11828,NULL,NULL,'mean','ESO 058- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47000,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47000,33.79,0.43,57.2,11828,75,NULL,'MAT, I, raw','ESO 058- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47001,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47001,34.03,0.32,63.9,11828,85,NULL,'I, raw','ESO 058- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47002,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47002,34.06,0.43,64.8,11828,75,NULL,'MAT, I, inv','ESO 058- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47003,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47003,34.08,0.43,65.5,11828,75,NULL,'MAT, I, cor','ESO 058- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47004,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47004,34.09,0.32,65.8,11828,85,NULL,'I, inv','ESO 058- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47005,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47005,34.51,NULL,79.9,11828,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 058- G 013',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47006,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47006,34.53,NULL,80.5,11828,NULL,NULL,NULL,'ESO 058- G 013',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47007,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47007,34.54,NULL,80.8,11828,NULL,NULL,'Dipole + Quadrupole','ESO 058- G 013',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47008,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47008,34.54,NULL,81,11828,NULL,NULL,'Dipole','ESO 058- G 013',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47009,'IRAS','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47009,32.15,0.8,26.9,11829,75,NULL,'MAT, I','NGC 2280',NULL,'1997ApJS..109..333W',1997,1,6.3,'Extended HIPASS source','G',0.00001,NULL,'9.97B',3.1,'SA(s)cd        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,101.204625,-27.63861,0.765,NULL,39141018338,611578411,9555912,9.97),(47010,'IRAS','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47010,32.15,0.8,27,11829,75,NULL,'A82, H','NGC 2280',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47011,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47011,30.83,NULL,14.7,11829,NULL,NULL,'B','NGC 2280',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47012,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47012,31.19,0.4,17.3,11829,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 2280',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47013,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47013,31.49,0.47,19.9,11829,75,NULL,'A82, H, raw','NGC 2280',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47014,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47014,31.66,0.47,21.5,11829,75,NULL,'A82, H, inv','NGC 2280',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47015,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47015,31.77,0.38,22.6,11829,NULL,NULL,NULL,'NGC 2280',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47016,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47016,31.77,0.39,22.6,11829,73,NULL,'opt','NGC 2280',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47017,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47017,31.83,0.4,23.2,11829,75,NULL,'B','NGC 2280',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47018,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47018,31.9,0.47,24,11829,75,NULL,'A82, H, cor','NGC 2280',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47019,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47019,32.01,0.32,25.2,11829,85,NULL,'I, raw','NGC 2280',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47020,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47020,32.05,0.43,25.7,11829,75,NULL,'MAT, I, raw','NGC 2280',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47021,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47021,32.07,0.32,25.9,11829,85,NULL,'I, inv','NGC 2280',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47022,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47022,32.1,0.43,26.3,11829,75,NULL,'3.6 micron, color corrected','NGC 2280',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47023,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47023,32.11,0.43,26.4,11829,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2280',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47024,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47024,32.13,0.46,26.6,11829,NULL,NULL,'J','NGC 2280',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47025,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47025,32.15,0.2,26.9,11829,74.4,NULL,NULL,'NGC 2280',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47026,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47026,32.17,0.47,27.2,11829,NULL,NULL,'H','NGC 2280',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47027,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47027,32.22,0.45,27.8,11829,NULL,NULL,'K','NGC 2280',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47028,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47028,32.3,0.4,28.8,11829,NULL,NULL,'mean','NGC 2280',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47029,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47029,32.33,0.43,29.2,11829,75,NULL,'MAT, I, inv','NGC 2280',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47030,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47030,32.37,0.43,29.8,11829,75,NULL,'MAT, I, cor','NGC 2280',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47031,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47031,36.04,0.58,161,11830,70,NULL,NULL,'2MASX J06451729-3015521',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,101.322125,-30.26444,0.481,NULL,39182278164,612223096,9565985,14.9),(47032,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47032,36.11,0.66,167,11831,70,NULL,NULL,'2MASX J06451995-6908230',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,101.333417,-69.13975,0.457,NULL,40617002899,634640670,9916260,17),(47033,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47033,35.8,0.38,145,11832,NULL,NULL,'Malmquist cor.','ESO 427- G 003',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.66',0.3,'Sb:',NULL,NULL,NULL,NULL,1,101.345583,-30.387,0.481,NULL,39182321635,612223775,9565996,15.66),(47034,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47034,36.01,0.34,159,11832,NULL,NULL,NULL,'ESO 427- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47035,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47035,36.05,0.2,162,11832,74.4,NULL,NULL,'ESO 427- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47036,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47036,34.08,0.47,65.6,11833,NULL,NULL,'H','UGC 03529',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000033,NULL,'14.7',0.4,'S?',NULL,NULL,NULL,NULL,1,101.357917,34.48619,0.905,NULL,63046797613,985106212,15392284,14.7),(47037,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47037,34.18,0.45,68.5,11833,NULL,NULL,'K','UGC 03529',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47038,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47038,34.22,0.46,69.9,11833,NULL,NULL,'J','UGC 03529',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47039,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47039,34.53,0.4,80.7,11833,NULL,NULL,'mean','UGC 03529',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47040,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47040,36.52,0.6,201,11834,70,NULL,NULL,'2MASX J06452691-3325141',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,101.362125,-33.42064,0.473,NULL,39174323648,612098807,9564043,15.7),(47041,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47041,36.39,0.74,189,11835,70,NULL,NULL,'2MASX J06453438-7420390',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,101.393083,-74.34425,0.609,NULL,39927191363,623862365,9747849,16.9),(47042,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47042,34.4,0.4,76,11836,NULL,NULL,'mean','CGCG 145-006',NULL,'2007A&A...465...71T',2007,1,0.6,NULL,'G',0.000017,NULL,'15.4',0.6,'S',NULL,NULL,NULL,NULL,1,101.396667,29.22283,0.813,NULL,63021325855,984708216,15386065,15.4),(47043,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47043,34.58,0.47,82.6,11836,NULL,NULL,'H','CGCG 145-006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47044,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47044,37.64,0.75,337,11837,70,NULL,NULL,'2MASX J06453749-3047331',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,101.4062917,-30.79258,0.489,NULL,39182217076,612222141,9565970,15.8),(47045,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47045,35.87,0.34,150,11838,NULL,NULL,'Malmquist cor.','ESO 366- G 017',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.60',0.4,'S...',NULL,NULL,NULL,NULL,1,101.422,-37.52069,0.565,NULL,38953786335,608652911,9510201,15.6),(47046,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47046,36.21,0.29,175,11838,NULL,NULL,NULL,'ESO 366- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47047,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47047,36.25,0.2,178,11838,74.4,NULL,NULL,'ESO 366- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47048,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47048,36.46,0.73,196,11839,70,NULL,NULL,'2MASX J06454650-3522322',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,101.4437083,-35.37564,0.301,NULL,38941201899,608456279,9507129,15.2),(47049,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:20','1','SN 2004S',NULL,47049,32.96,0.13,38.7,11840,72,NULL,NULL,'ESO 427- G 006',0.00937,'2008ApJ...689..377W',2008,1,1.3,NULL,'G',0.000013,NULL,'14.21',0.4,'Sc',NULL,NULL,NULL,NULL,1,101.4445,-31.23039,0.509,NULL,39182106083,612220407,9565943,14.21),(47050,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:20','1','SN 2004S',NULL,47050,33.01,0.06,39.6,11840,72,NULL,NULL,'ESO 427- G 006',0.00937,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47051,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:20','1','SN 2004S',NULL,47051,33,0.17,39.8,11840,70.8,NULL,NULL,'ESO 427- G 006',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47052,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:20','1','SN 2004S',NULL,47052,33.01,0.04,40,11840,72,NULL,'M(H) = -18.317 mag','ESO 427- G 006',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47053,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:20','1','SN 2004S',NULL,47053,33.05,0.19,40.4,11840,72,NULL,NULL,'ESO 427- G 006',0.00937,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47054,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:20','1','SN 2004S',NULL,47054,33.25,0.03,44.3,11840,72,NULL,NULL,'ESO 427- G 006',0.00937,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47055,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:20','1','SN 2004S',NULL,47055,33.32,0.17,46.1,11840,72,NULL,NULL,'ESO 427- G 006',0.00937,'2007AJ....133...58K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47056,'SNIa','2016-12-15 15:14:14','2016-12-16 11:19:20','1','SN 2004S',NULL,47056,33.54,0.04,50.6,11840,70,NULL,NULL,'ESO 427- G 006',0.00937,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47057,'Tully est','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47057,30.35,0.8,11.8,11841,75,NULL,NULL,'ESO 255- G 019',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000003,NULL,'14.17',1.3,'SA(s)m',NULL,NULL,NULL,NULL,1,101.4499583,-47.53139,0.237,NULL,42473105296,663642270,10369410,14.17),(47058,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47058,36.16,0.53,171,11842,70,NULL,NULL,'2MASX J06454867-6222554',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000143,NULL,'13.1I',0.5,NULL,NULL,NULL,NULL,NULL,1,101.452833,-62.38214,0.277,NULL,40385471717,631022995,9859734,13.1),(47059,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47059,29.97,0.4,9.86,11843,NULL,NULL,NULL,'NGC 2283',NULL,'2009AJ....138..323T',2009,1,3.6,'The identification as IC 2171 is questionable.','G',0.00001,NULL,'12.93',2.8,'SB(s)cd','Pair member (points to parent)',NULL,NULL,NULL,1,101.469541667,-18.21033,NULL,NULL,39645454685,619460229,9679066,12.93),(47060,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47060,29.98,0.4,9.9,11843,73,NULL,'opt','NGC 2283',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47061,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47061,30,NULL,10,11843,NULL,NULL,NULL,'NGC 2283',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47062,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47062,34.9,0.48,95.6,11844,70,NULL,NULL,'2MASX J06455634-5524525',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000127,NULL,'12.9I',0.4,NULL,NULL,NULL,NULL,NULL,1,101.484833,-55.41458,0.329,NULL,40517985506,633093523,9892086,12.9),(47063,'FP','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47063,33.77,0.53,56.8,11845,70,NULL,NULL,'2MASX J06460300-7329579',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,101.512375,-73.49933,0.549,NULL,39926570455,623852663,9747697,15.9),(47064,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47064,35.77,NULL,143,11846,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0583',NULL,'2010Ap&SS.325..163P',2010,1,1.04,NULL,'G',NULL,NULL,'16.5',0.1,'Sc',NULL,NULL,NULL,NULL,1,101.544708333,68.10211,0.165,NULL,62158849115,971232017,15175500,16.5),(47065,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47065,35.79,NULL,144,11846,NULL,NULL,'Dipole + Quadrupole','FGC 0583',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47066,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47066,35.8,NULL,145,11846,NULL,NULL,NULL,'FGC 0583',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47067,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47067,35.8,NULL,145,11846,NULL,NULL,'Dipole','FGC 0583',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47068,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,'R',47068,35.97,0.49,156,11846,75,NULL,'IR','FGC 0583',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47069,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47069,34.82,0.4,92.2,11847,NULL,NULL,'mean','UGC 03532',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000067,NULL,'15.00',0.6,'SB(s)b','Pair member (points to parent)',NULL,NULL,NULL,1,101.551541667,43.79253,0.589,NULL,63417429593,990897337,15482770,15),(47070,'Tully-Fisher','2016-12-15 15:14:14','2016-12-16 11:19:20','1',NULL,NULL,47070,35.01,0.47,100,11847,NULL,NULL,'H','UGC 03532',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47071,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47071,35.06,0.45,103,11847,NULL,NULL,'K','UGC 03532',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47072,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47072,36.78,0.63,227,11848,70,NULL,NULL,'2MASX J06461369-7407202',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,101.556708333,-74.12225,0.625,NULL,39929289226,623895144,9748361,17.3),(47073,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47073,35.65,0.72,135,11849,70,NULL,NULL,'2MASX J06461363-6125424',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,101.556791667,-61.42844,0.337,NULL,40386270331,631035473,9859929,14.1),(47074,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47074,35.48,0.49,125,11850,70,NULL,NULL,'2MASX J06462524-6538266',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000133,NULL,'14.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,101.605083333,-65.64067,0.237,NULL,40337446400,630272600,9848009,14.8),(47075,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47075,35.45,0.72,123,11851,70,NULL,NULL,'2MASX J06462791-2132488',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,101.6162917,-21.54692,1.889,NULL,39626409404,619162646,9674416,15.6),(47076,'IRAS','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47076,32.37,0.8,29.8,11852,75,NULL,'A82, H','NGC 2273B',NULL,'1997ApJS..109..333W',1997,1,2.7,NULL,'G',0.000013,NULL,'13.10',1.5,'SB(rs)cd:','in a pair',NULL,NULL,NULL,1,101.631583,60.34039,0.317,NULL,61626941358,962920958,15045639,13.1),(47077,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47077,31.59,0.38,20.8,11852,NULL,NULL,NULL,'NGC 2273B',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47078,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47078,31.94,0.4,24.4,11852,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 2273B',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47079,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47079,32.21,0.47,27.7,11852,75,NULL,'A82, H, inv','NGC 2273B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47080,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47080,32.26,0.47,28.3,11852,75,NULL,'A82, H, raw','NGC 2273B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47081,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47081,32.5,0.4,31.6,11852,75,NULL,'B','NGC 2273B',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47082,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47082,32.66,0.47,34.1,11852,75,NULL,'A82, H, cor','NGC 2273B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47083,'Quasar spectrum','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47083,42.93,NULL,3860,11853,NULL,NULL,NULL,'[HB89] 0642+449',NULL,'2002A&A...381L..57D',2002,1,NULL,NULL,'QSO',0.001,NULL,'18.49',NULL,'Opt.var.;LPQ   FSRQ',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,101.633458333,44.85461,0.685,NULL,63417276682,990894948,15482733,18.49),(47084,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47084,35.81,0.65,145,11854,70,NULL,NULL,'2MASX J06463410-6540367',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,101.642208333,-65.67692,0.237,NULL,40337464047,630272875,9848013,16.4),(47085,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47085,35.56,0.52,129,11855,70,NULL,NULL,'AM 0645-430 NED02',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,101.684875,-43.12436,0.281,NULL,42478759123,663730611,10370790,16.4),(47086,'IRAS','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47086,31.92,0.8,24.2,11856,75,NULL,'MAT, I','ESO 490- G 045',NULL,'1997ApJS..109..333W',1997,1,2.5,'Confused HIPASS source','G',0.000007,NULL,'14.01',0.9,'SB(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,101.69475,-26.47547,1.041,NULL,39125843386,611341302,9552207,14.01),(47087,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47087,31.59,0.32,20.8,11856,85,NULL,'I, inv','ESO 490- G 045',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47088,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47088,31.6,0.32,20.9,11856,85,NULL,'I, raw','ESO 490- G 045',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47089,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47089,31.68,0.43,21.7,11856,75,NULL,'MAT, I, inv','ESO 490- G 045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47090,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47090,31.68,0.43,21.7,11856,75,NULL,'MAT, I, raw','ESO 490- G 045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47091,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47091,31.9,0.4,24,11856,NULL,NULL,NULL,'ESO 490- G 045',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47092,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47092,31.9,0.4,24,11856,73,NULL,'opt','ESO 490- G 045',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47093,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47093,31.96,0.2,24.7,11856,74.4,NULL,NULL,'ESO 490- G 045',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47094,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47094,32.03,0.43,25.5,11856,75,NULL,'MAT, I, cor','ESO 490- G 045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47095,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47095,35.88,0.54,150,11857,70,NULL,NULL,'2MASX J06464775-6718047',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,101.699083,-67.30136,0.277,NULL,40612532759,634570824,9915169,15.1),(47096,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47096,37.17,0.72,271,11858,70,NULL,NULL,'2MASX J06465267-5539453',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,101.719375,-55.66258,0.341,NULL,40517366807,633083856,9891935,16.6),(47097,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47097,35.66,0.55,135,11859,70,NULL,NULL,'2MASX J06470727-6736138',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,101.780333,-67.60381,0.285,NULL,40610581399,634540334,9914692,16.6),(47098,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47098,35.84,0.66,148,11860,70,NULL,NULL,'2MASX J06471055-6544177',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,101.793917,-65.73831,0.237,NULL,40337460160,630272815,9848012,14.1),(47099,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47099,36.23,0.7,176,11861,70,NULL,NULL,'2MASX J06472929-5549073',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,101.8719583,-55.81864,0.341,NULL,40520802791,633137543,9892774,14.4),(47100,'D-Sigma','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47100,32.17,0.4,27.1,11862,75,NULL,'Edat, raw','NGC 2292',NULL,'1997ApJS..109..333W',1997,1,4.1,NULL,'G',0.000013,NULL,'11.83',3.6,'SAB0^0^ pec','Pair member (points to parent)',NULL,NULL,NULL,1,101.9152083,-26.74625,1.129,NULL,39138366365,611536974,9555265,11.83),(47101,'D-Sigma','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47101,32.5,0.4,31.6,11862,75,NULL,'Edat, cor','NGC 2292',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47102,'SBF','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47102,31.16,0.14,17.1,11863,74.4,NULL,NULL,'NGC 2293',NULL,'2013AJ....146...86T',2013,1,4.2,NULL,'G',0.00002,NULL,'12.28',3.3,'SAB(s)0+ pec','Pair member (points to parent)',NULL,NULL,NULL,1,101.9287917,-26.75436,1.129,NULL,39138419293,611537801,9555278,12.28),(47103,'SBF','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47103,31.16,0.41,17.1,11863,NULL,NULL,'I','NGC 2293',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47104,'SBF','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47104,31.16,0.41,17.1,11863,NULL,NULL,NULL,'NGC 2293',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47105,'SBF','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47105,31.48,0.41,19.8,11863,NULL,NULL,'Malmquist cor.','NGC 2293',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47106,'D-Sigma','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47106,32.54,0.4,32.2,11863,75,NULL,'Edat, raw','NGC 2293',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47107,'D-Sigma','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47107,32.88,0.4,37.6,11863,75,NULL,'Edat, cor','NGC 2293',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47108,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47108,32.96,0.41,39,11863,NULL,NULL,NULL,'NGC 2293',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47109,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47109,32.96,0.41,39.2,11863,NULL,NULL,'Malmquist cor.','NGC 2293',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47110,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 1997E',NULL,47110,33.21,0.27,43.3,11864,74.2,NULL,'SALT 2','NGC 2258',0.01354,'2010ApJ...716..712A',2010,1,2.3,NULL,'G',0.00012,NULL,'13.0',1.5,'SA(r)0^0^','in a pair',NULL,NULL,NULL,1,101.940833,74.48167,0.361,NULL,61335912447,958373631,14974587,13),(47111,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 1997E',NULL,47111,33.77,0.19,56,11864,72,NULL,NULL,'NGC 2258',0.01354,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47112,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 1997E',NULL,47112,33.77,0.08,56.8,11864,74.4,NULL,NULL,'NGC 2258',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47113,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 1997E',NULL,47113,33.78,0.12,57,11864,70.8,NULL,NULL,'NGC 2258',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47114,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 1997E',NULL,47114,33.87,0.03,58.7,11864,72,NULL,NULL,'NGC 2258',0.01354,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47115,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 1997E',NULL,47115,33.88,0.21,58.8,11864,70,NULL,'SALT 2','NGC 2258',0.01354,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47116,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 1997E',NULL,47116,33.95,0.2,60.9,11864,73.8,NULL,'SALT 2 (SNANA)','NGC 2258',0.0133,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47117,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 1997E',NULL,47117,33.97,0.31,61.4,11864,70,NULL,'SALT','NGC 2258',0.01354,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47118,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 1997E',NULL,47118,34.02,0.26,62.8,11864,65,NULL,NULL,'NGC 2258',0.01354,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47119,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 1997E',NULL,47119,34.06,0.24,63.8,11864,65,NULL,NULL,'NGC 2258',0.01354,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47120,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 1997E',NULL,47120,34.11,0.09,64.5,11864,65,NULL,'MLCS2k2','NGC 2258',0.01354,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47121,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 1997E',NULL,47121,34.1,0.24,65.2,11864,65,NULL,NULL,'NGC 2258',0.01354,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47122,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 1997E',NULL,47122,34.12,0.27,65.9,11864,65,NULL,NULL,'NGC 2258',0.01354,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47123,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 1997E',NULL,47123,34.38,0.14,75.2,11864,60,NULL,NULL,'NGC 2258',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47124,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 1997E',NULL,47124,34.69,0.04,85.7,11864,70,NULL,'SALT 2','NGC 2258',0.01354,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47125,'SBF','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47125,33.56,0.15,51.5,11864,NULL,NULL,'I','NGC 2258',NULL,'2001ApJ...559..584A',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47126,'CMD','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47126,27.66,NULL,3.4,11865,NULL,NULL,NULL,'kkh 037',NULL,'2012ApJ...748...47M',2012,1,0.7,NULL,'G',0.000001,NULL,'16.4',0.5,'S/Irr',NULL,NULL,NULL,NULL,1,101.940833,80.12389,0.309,NULL,61440611608,960009556,15000149,16.4),(47127,'TRGB','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47127,27.57,0.08,3.26,11865,NULL,NULL,'I','kkh 037',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47128,'TRGB','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47128,27.64,0.08,3.38,11865,74.4,NULL,NULL,'kkh 037',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47129,'TRGB','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47129,27.65,0.04,3.39,11865,NULL,NULL,'I','kkh 037',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47130,'TRGB','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47130,27.65,NULL,3.39,11865,NULL,NULL,NULL,'kkh 037',NULL,'2006AJ....131.1361K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47131,'SZ effect','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47131,38.85,0.58,590,11866,NULL,NULL,'Isotherm.','MACS J0647.7+7015',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,101.9602917,70.24858,0.265,NULL,62153056175,971141502,15174085,NULL),(47132,'SZ effect','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47132,39.32,0.55,730,11866,NULL,NULL,'Isotherm., r < 100 kpc','MACS J0647.7+7015',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47133,'SZ effect','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47133,39.43,0.55,770,11866,NULL,NULL,'Hydrost. Eq.','MACS J0647.7+7015',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47134,'SZ effect','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47134,39.67,NULL,858,11866,NULL,NULL,'3.1 (red) calibration','MACS J0647.7+7015',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47135,'SZ effect','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47135,39.77,NULL,899,11866,NULL,NULL,'4.2 (black) calibration','MACS J0647.7+7015',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47136,'SZ effect','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47136,40.27,NULL,1130,11866,NULL,NULL,'4.1 (blue) calibration','MACS J0647.7+7015',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47137,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47137,33.32,0.43,46.2,11867,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03500',NULL,'2014MNRAS.444..527S',2014,1,1.7,NULL,'G',0.000037,NULL,'14.70',0.3,'S?',NULL,NULL,NULL,NULL,1,101.977833,84.16192,0.225,NULL,61229034163,956703658,14948494,14.7),(47138,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47138,31.43,NULL,19.3,11868,NULL,NULL,NULL,'kkh 038',NULL,'2013AJ....145..101K',2013,1,1.2,NULL,'G',0.000007,NULL,'17.4',0.65,'Ir',NULL,NULL,NULL,NULL,1,101.978667,47.51389,0.401,NULL,63390119993,990470624,15476103,17.4),(47139,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,'R',47139,34.93,0.49,96.8,11869,75,NULL,'IR','UGC 03544',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'16.5',0.2,'Scd:',NULL,NULL,NULL,NULL,1,102.035208333,33.57375,0.781,NULL,63048662546,985135352,15392739,16.5),(47140,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47140,37.08,0.78,261,11870,70,NULL,NULL,'2MASX J06481267-6237032',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,102.0529583,-62.61756,0.261,NULL,40385044469,631016319,9859629,16.9),(47141,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47141,34.97,0.54,98.8,11871,70,NULL,NULL,'2MASX J06481924-6149238',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,102.080083333,-61.82325,0.385,NULL,40385347687,631021057,9859704,16.3),(47142,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47142,36.55,0.65,205,11872,70,NULL,NULL,'2MASX J06481974-5524298',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,102.082375,-55.40833,0.329,NULL,40517783404,633090365,9892036,17),(47143,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47143,34.81,0.57,91.4,11873,70,NULL,NULL,'2MASX J06482413-2937561',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00012,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,102.100625,-29.63233,0.533,NULL,39182721746,612230027,9566094,14.3),(47144,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,'R',47144,34.93,0.49,96.7,11874,75,NULL,'IR','CGCG 085-001',NULL,'2011yCatp016004901K',2011,1,NULL,NULL,'G',0.000017,NULL,'15.7',NULL,NULL,NULL,NULL,NULL,NULL,1,102.127375,15.41228,NULL,NULL,63172906123,987076658,15423072,15.7),(47145,'D-Sigma','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47145,32.56,0.4,32.5,11875,75,NULL,'Edat, raw','NGC 2305',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000067,NULL,'12.74',1.5,'E2: pec','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,102.1557083,-64.27319,0.285,NULL,40395192828,631174887,9862107,12.74),(47146,'D-Sigma','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47146,32.9,0.4,38,11875,75,NULL,'Edat, cor','NGC 2305',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47147,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47147,33.39,0.4,47.6,11875,NULL,NULL,'mean','NGC 2305',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47148,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47148,33.39,0.45,47.7,11875,NULL,NULL,'K','NGC 2305',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47149,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47149,32.86,NULL,37.4,11876,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 427- G 008',NULL,'2010Ap&SS.325..163P',2010,1,1.68,'Stars superposed.','G',0.00002,NULL,'16.47',0.12,'Sd',NULL,NULL,NULL,NULL,1,102.185,-32.09722,0.653,NULL,39163728027,611933250,9561457,16.47),(47150,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47150,32.87,NULL,37.5,11876,NULL,NULL,'Dipole + Quadrupole','ESO 427- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47151,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47151,32.88,NULL,37.6,11876,NULL,NULL,'Dipole','ESO 427- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47152,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47152,32.91,NULL,38.2,11876,NULL,NULL,NULL,'ESO 427- G 008',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47153,'BL Lac Luminosity','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47153,38.58,NULL,521,11877,NULL,NULL,'Min. z = 0.13','1FGL J0648.8+1516',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,102.207,15.273,NULL,NULL,63293229977,988956718,15452448,NULL),(47154,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47154,35.54,0.65,128,11878,70,NULL,NULL,'2MASX J06485000-3346398',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,102.208333,-33.77775,0.517,NULL,39172019295,612062801,9563481,15.3),(47155,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47155,33.26,0.43,44.9,11879,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03539',NULL,'2014MNRAS.444..527S',2014,1,2.24,NULL,'G',0.00001,NULL,'15.24',0.22,'SBbc?',NULL,NULL,NULL,NULL,1,102.225167,66.26136,0.189,NULL,62147543991,971055374,15172740,15.24),(47156,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47156,33.54,0.43,51.1,11879,75,NULL,'3.6 micron, color corrected','UGC 03539',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47157,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,'R',47157,33.68,0.49,54.4,11879,75,NULL,'IR','UGC 03539',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47158,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47158,33.81,NULL,57.8,11879,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03539',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47159,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47159,33.81,NULL,57.9,11879,NULL,NULL,'Dipole','UGC 03539',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47160,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47160,33.82,NULL,58,11879,NULL,NULL,'Dipole + Quadrupole','UGC 03539',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47161,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47161,33.85,NULL,59,11879,NULL,NULL,NULL,'UGC 03539',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47162,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47162,33.86,0.2,59.2,11879,74.4,NULL,NULL,'UGC 03539',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47163,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47163,33.94,0.33,61.4,11879,NULL,NULL,'Malmquist cor.','UGC 03539',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47164,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47164,34.05,0.32,64.5,11879,NULL,NULL,NULL,'UGC 03539',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47165,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47165,36.49,0.61,199,11880,70,NULL,NULL,'2MASX J06490043-3301188',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,102.25175,-33.02197,0.573,NULL,39174573759,612102714,9564104,15.7),(47166,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47166,35.73,0.62,140,11881,70,NULL,NULL,'2MASX J06490156-4356373',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'15.0b',NULL,'SA(r)0^+',NULL,NULL,NULL,NULL,1,102.256333,-43.94369,0.225,NULL,42478501035,663726578,10370727,15),(47167,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47167,33.76,0.57,56.5,11882,70,NULL,NULL,'ESO 058- G 016',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000097,NULL,'15.16',0.4,'Sa',NULL,NULL,NULL,NULL,1,102.2589583,-71.68978,0.577,NULL,39875207488,623050117,9735158,15.16),(47168,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47168,35.22,0.49,111,11883,70,NULL,NULL,'2MASX J06490900-6440210',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.0001,NULL,'15.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,102.2872917,-64.67261,0.249,NULL,40395082544,631173164,9862080,15.6),(47169,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47169,37.79,0.62,361,11884,70,NULL,NULL,'2MASX J06492766-5550441',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,102.3652083,-55.8455,0.345,NULL,40520916028,633139312,9892801,15.5),(47170,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47170,34.72,0.54,88,11885,NULL,NULL,NULL,'ESO 058- G 017',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'16.15',0.4,'S...',NULL,NULL,NULL,NULL,1,102.379875,-70.15628,0.469,NULL,40607998575,634499977,9914062,16.15),(47171,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47171,34.76,0.2,89.5,11885,74.4,NULL,NULL,'ESO 058- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47172,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47172,34.8,0.52,91,11885,NULL,NULL,'Malmquist cor.','ESO 058- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47173,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47173,37.11,0.68,265,11886,70,NULL,NULL,'2MASX J06493611-5356531',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.9I',0.2,NULL,NULL,NULL,NULL,NULL,1,102.4005417,-53.94806,0.269,NULL,40307547628,629805431,9840709,14.9),(47174,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47174,34.58,0.5,82.4,11887,70,NULL,NULL,'2MASX J06493785-7142525',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000087,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,102.407833,-71.71467,0.577,NULL,39875208630,623050134,9735158,15.8),(47175,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47175,35.53,0.72,128,11888,70,NULL,NULL,'2MASX J06493886-7416431',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,102.411875,-74.27867,0.609,NULL,39929510890,623898607,9748415,16.6),(47176,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47176,34.27,0.2,71.5,11889,74.4,NULL,NULL,'UGC 03553',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'15.25',0.5,'Scd:',NULL,NULL,NULL,NULL,1,102.430541667,20.0815,NULL,NULL,63193348256,987396066,15428063,15.25),(47177,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47177,36.72,0.72,221,11890,70,NULL,NULL,'2MASX J06494558-3707240',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,102.44,-37.12331,0.709,NULL,38942940269,608483441,9507553,14.5),(47178,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,'R',47178,34.89,0.49,95.2,11891,75,NULL,'IR','UGC 03551',NULL,'2011yCatp016004901K',2011,1,1.29,NULL,'G',0.000013,NULL,'15.6',0.11,'Sd',NULL,NULL,NULL,NULL,1,102.442,29.52603,0.757,NULL,63074528694,985539510,15399054,15.6),(47179,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47179,35.23,NULL,111,11891,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03551',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47180,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47180,35.23,NULL,111,11891,NULL,NULL,'Dipole','UGC 03551',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47181,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47181,35.23,NULL,111,11891,NULL,NULL,'Dipole + Quadrupole','UGC 03551',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47182,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47182,35.3,NULL,115,11891,NULL,NULL,NULL,'UGC 03551',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47183,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47183,34.69,0.49,86.6,11892,70,NULL,NULL,'2MASX J06495436-7742143',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000123,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,102.476417,-77.70394,0.753,NULL,39894218292,623347160,9739799,16.3),(47184,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47184,35.19,0.63,109,11893,70,NULL,NULL,'2MASX J06500234-6648343',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,102.509875,-66.8095,0.317,NULL,40613073016,634579265,9915301,15.9),(47185,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47185,37.07,0.54,259,11894,70,NULL,NULL,'2MASX J06500431-2615083',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,'E',NULL,NULL,NULL,NULL,1,102.517958333,-26.25236,1.297,NULL,39127261752,611363464,9552554,15.4),(47186,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47186,35.59,0.52,131,11895,70,NULL,NULL,'2MASX J06500734-3414233',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.9I',0.3,NULL,NULL,NULL,NULL,NULL,1,102.530625,-34.23986,0.517,NULL,39160894317,611888973,9560765,14.9),(47187,'Sosies','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47187,32.5,0.39,31.6,11896,NULL,NULL,NULL,'NGC 2273',NULL,'2002A&A...393...57T',2002,1,3.2,NULL,'G',0.000013,NULL,'12.55',2.5,'SB(r)a:      Sy1/Sy2','in a pair',NULL,NULL,'Sy 2',1,102.536083,60.84581,0.285,NULL,61648018757,963250293,15050785,12.55),(47188,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47188,32.26,0.4,28.4,11896,75,NULL,'B','NGC 2273',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47189,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47189,32.3,0.4,28.9,11896,NULL,NULL,'mean','NGC 2273',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47190,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47190,32.51,0.45,31.8,11896,NULL,NULL,'K','NGC 2273',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47191,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47191,32.54,0.47,32.2,11896,NULL,NULL,'H','NGC 2273',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47192,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47192,32.59,0.46,32.9,11896,NULL,NULL,'J','NGC 2273',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47193,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47193,36.97,0.89,248,11897,70,NULL,NULL,'2MASX J06501019-6311117',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,102.5425417,-63.1865,0.237,NULL,40396538213,631195909,9862436,14.6),(47194,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47194,36.17,0.71,172,11898,70,NULL,NULL,'ESO 161-IG 027 NED02',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'15.13',0.7,NULL,NULL,NULL,NULL,NULL,1,102.589583,-55.82575,0.345,NULL,40520917107,633139329,9892802,15.13),(47195,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47195,36.38,0.62,189,11899,70,NULL,NULL,'2MASX J06502232-4633061',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.1I',0.5,NULL,NULL,NULL,NULL,NULL,1,102.593083,-46.55172,0.225,NULL,42472775514,663637117,10369329,14.1),(47196,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47196,34.58,0.47,82.5,11900,NULL,NULL,'H','UGC 03554',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000027,NULL,'14.61',0.6,'SBb?',NULL,NULL,NULL,NULL,1,102.6075417,43.05333,0.509,NULL,63414812330,990856442,15482131,14.61),(47197,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47197,34.66,0.45,85.5,11900,NULL,NULL,'K','UGC 03554',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47198,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47198,34.7,0.46,87.2,11900,NULL,NULL,'J','UGC 03554',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47199,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47199,34.74,0.4,88.9,11900,NULL,NULL,'mean','UGC 03554',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47200,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47200,35.6,0.76,132,11901,70,NULL,NULL,'ESO 161- G 028',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.88',0.2,'S...',NULL,NULL,NULL,NULL,1,102.616875,-57.11689,0.261,NULL,40518946281,633108535,9892320,15.88),(47201,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47201,35.72,0.5,139,11902,70,NULL,NULL,'2MASX J06502820-3712267',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'13.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,102.6174583,-37.20744,0.697,NULL,42447997493,663249960,10363280,13.9),(47202,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,'R',47202,34.97,0.49,98.4,11903,75,NULL,'IR','UGC 03565',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000033,NULL,'17.',0.2,'Scd:',NULL,NULL,NULL,NULL,1,102.622167,9.66317,NULL,NULL,62365071452,974454241,15225847,17),(47203,'Tully est','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47203,32.09,0.8,26.2,11904,75,NULL,NULL,'UGC 03496',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.000013,NULL,'17.',1.5,'Im:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,102.6500417,85.795,0.277,NULL,61211341532,956427211,14944175,17),(47204,'Tully est','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47204,30.4,0.8,12,11905,75,NULL,NULL,'ESO 207- G 007',NULL,'1988NBGC.C....0000T',1988,1,2.2,NULL,'G',0.000003,NULL,'14.06',1.5,'SAB(s)m',NULL,NULL,NULL,NULL,1,102.66625,-52.14033,0.149,NULL,40315319442,629926866,9842607,14.06),(47205,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,'R',47205,34.43,0.49,77,11906,75,NULL,'IR','UGC 03559',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'16.0',0.3,'Scd:',NULL,NULL,NULL,NULL,1,102.673917,34.04186,0.729,NULL,63033354619,984896165,15389002,16),(47206,'BL Lac Luminosity','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47206,40.76,0.22,1420,11907,NULL,NULL,NULL,'2MASS J06504649+2502596',NULL,'2011A&A...534L...2K',2011,1,NULL,NULL,'QSO',NULL,NULL,'15.7V',NULL,'BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,102.6937083,25.04989,0.697,NULL,63016066738,984626042,15384781,15.7),(47207,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47207,35.08,0.48,104,11908,70,NULL,NULL,'ESO 366-IG 025 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.5',0.1,'SAb     poss. LINER?',NULL,NULL,NULL,NULL,1,102.7267083,-35.34892,0.453,NULL,38941535033,608461484,9507210,15.5),(47208,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47208,34.43,0.4,77,11909,NULL,NULL,'mean','NGC 2290',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00003,NULL,'14.16',0.7,'(R)SAa:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,102.737166667,33.43758,0.713,NULL,63047943516,985124117,15392564,14.16),(47209,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47209,34.67,0.45,85.8,11909,NULL,NULL,'K','NGC 2290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47210,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47210,34.67,0.47,85.9,11909,NULL,NULL,'H','NGC 2290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47211,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47211,34.7,0.46,86.9,11909,NULL,NULL,'J','NGC 2290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47212,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47212,36.85,0.66,235,11910,70,NULL,NULL,'ESO 161- G 029',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.44',0.6,'SAB(s)cd:',NULL,NULL,NULL,NULL,1,102.771125,-56.57317,0.265,NULL,40518407901,633100123,9892189,15.44),(47213,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47213,32.97,0.69,39.3,11911,100,NULL,'mid-IR','IC 0454',NULL,'2013ApJ...771...88L',2013,1,1.7,NULL,'G',0.00002,NULL,'14.5',0.9,'SBab',NULL,NULL,NULL,NULL,1,102.77625,12.92203,NULL,NULL,63287733503,988870835,15451106,14.5),(47214,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47214,33.63,0.47,53.3,11911,NULL,NULL,'H','IC 0454',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47215,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47215,33.64,0.45,53.5,11911,NULL,NULL,'K','IC 0454',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47216,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47216,33.67,0.46,54.3,11911,NULL,NULL,'J','IC 0454',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47217,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47217,33.76,0.4,56.4,11911,NULL,NULL,'mean','IC 0454',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47218,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47218,35.17,0.66,108,11912,70,NULL,NULL,'2MASX J06510867-7349578',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,102.786167,-73.83269,0.609,NULL,39926372283,623849566,9747649,16.3),(47219,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47219,35.37,0.48,119,11913,NULL,NULL,'Malmquist cor.','ESO 427- G 013',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000033,NULL,'14.95',0.6,'SA?(rs)b',NULL,NULL,NULL,NULL,1,102.7959583,-30.4175,0.589,NULL,39179768345,612183880,9565373,14.95),(47220,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47220,35.43,0.47,122,11913,NULL,NULL,NULL,'ESO 427- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47221,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47221,35.47,0.2,124,11913,74.4,NULL,NULL,'ESO 427- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47222,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47222,36.16,0.56,170,11914,70,NULL,NULL,'2MASX J06511100-4321068',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000103,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,102.795833,-43.35181,0.377,NULL,42464582238,663509097,10367329,14.1),(47223,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47223,35.46,0.49,123,11915,70,NULL,NULL,'2MASX J06511568-6134238',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.3I',0.5,NULL,NULL,NULL,NULL,NULL,1,102.815375,-61.57331,0.385,NULL,40353670224,630526097,9851970,13.3),(47224,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47224,34.65,0.43,85,11916,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03561',NULL,'2014MNRAS.444..527S',2014,1,0.7,NULL,'G',0.000057,NULL,'14.70',0.4,'S?',NULL,NULL,NULL,NULL,1,102.833667,49.88581,0.417,NULL,63391056105,990485251,15476332,14.7),(47225,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47225,34.67,0.43,86,11916,75,NULL,'3.6 micron, color corrected','UGC 03561',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47226,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47226,34.77,0.2,90,11916,74.4,NULL,NULL,'UGC 03561',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47227,'IRAS','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47227,32.29,0.8,28.7,11917,75,NULL,'MAT, I','ESO 427- G 014',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'15.48',0.4,'(R\'?)SB(s)ab?',NULL,NULL,NULL,NULL,1,102.837666667,-29.59292,0.753,NULL,39179449582,612178899,9565295,15.48),(47228,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47228,32.55,0.32,32.4,11917,85,NULL,'I, inv','ESO 427- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47229,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47229,32.57,0.32,32.7,11917,85,NULL,'I, raw','ESO 427- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47230,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47230,33.01,0.43,40,11917,75,NULL,'MAT, I, raw','ESO 427- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47231,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47231,33.01,0.43,40,11917,75,NULL,'MAT, I, inv','ESO 427- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47232,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47232,33.08,0.43,41.2,11917,75,NULL,'MAT, I, cor','ESO 427- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47233,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47233,33.09,0.2,41.5,11917,74.4,NULL,NULL,'ESO 427- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47234,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47234,36.37,0.66,188,11918,70,NULL,NULL,'2MASX J06513266-2729506',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.3,'E',NULL,NULL,NULL,NULL,1,102.886125,-27.49733,1.137,NULL,39134829999,611481718,9554401,14.6),(47235,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47235,35.36,0.82,118,11919,70,NULL,NULL,'2MASX J06513289-6440190',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.6I',0.5,NULL,NULL,NULL,NULL,NULL,1,102.8872083,-64.67197,0.249,NULL,40391528571,631117633,9861213,13.6),(47236,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,'R',47236,34.22,0.49,69.7,11920,75,NULL,'IR','UGC 03573',NULL,'2011yCatp016004901K',2011,1,2.77,NULL,'G',0.000008,NULL,'14.6',0.21,'Sc',NULL,NULL,NULL,NULL,1,102.949666667,27.48142,0.645,NULL,63022377065,984724641,15386322,14.6),(47237,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47237,34.36,0.4,74.4,11920,NULL,NULL,'mean','UGC 03573',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47238,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47238,34.37,NULL,74.7,11920,NULL,NULL,'Dipole','UGC 03573',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47239,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47239,34.39,NULL,75.4,11920,NULL,NULL,'Dipole + Quadrupole','UGC 03573',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47240,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47240,34.39,NULL,75.5,11920,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03573',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47241,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47241,34.49,0.47,78.9,11920,NULL,NULL,'H','UGC 03573',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47242,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47242,34.54,0.46,81,11920,NULL,NULL,'J','UGC 03573',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47243,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47243,34.57,0.45,82.1,11920,NULL,NULL,'K','UGC 03573',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47244,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47244,34.58,NULL,82.4,11920,NULL,NULL,NULL,'UGC 03573',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47245,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47245,34.9,0.43,95.6,11921,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J06514948+2958458',NULL,'2014MNRAS.444..527S',2014,1,0.89,NULL,'G',0.00002,NULL,'11.6K',0.22,'S',NULL,NULL,NULL,NULL,1,102.956125,29.97942,0.689,NULL,63074988510,985546695,15399167,11.6),(47246,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47246,36.2,0.88,174,11922,70,NULL,NULL,'2MASX J06515245-6641246',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,102.9687083,-66.69017,0.301,NULL,40609634995,634525546,9914461,16.6),(47247,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47247,36.81,0.61,230,11923,70,NULL,NULL,'2MASX J06515343-5551217',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.2I',0.4,NULL,NULL,NULL,NULL,NULL,1,102.9727083,-55.85597,0.269,NULL,40520467496,633132304,9892692,14.2),(47248,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47248,36.06,0.56,163,11924,70,NULL,NULL,'2MASX J06520358-4624359',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.8I',0.4,NULL,NULL,NULL,NULL,NULL,1,103.0150417,-46.40994,0.225,NULL,42472622934,663634733,10369292,13.8),(47249,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47249,36.69,0.62,218,11925,70,NULL,NULL,'2MASX J06520823-2548253',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.9I',0.3,'S',NULL,NULL,NULL,NULL,1,103.034375,-25.80703,1.465,NULL,39126941914,611358467,9552476,14.9),(47250,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47250,34.82,0.48,92.2,11926,70,NULL,NULL,'2MASX J06521100-5901408',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000073,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,103.046,-59.02797,0.437,NULL,40524694259,633198347,9893724,14),(47251,'AGN time lag','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47251,34.89,0.6,95,11927,44,NULL,NULL,'IC 0450',NULL,'2007MNRAS.380..669C',2007,1,0.8,'One of two 6cm sources associated with [WB92] 0645+7429','G',0.000033,NULL,'15.0',0.5,'SAB0+:         Sy1.5','in a pair',NULL,'radio jet','Sy 2',1,103.0510417,74.42708,0.337,NULL,61336897432,958389022,14974828,15),(47252,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47252,35.46,0.54,124,11928,70,NULL,NULL,'2MASX J06521364-6405275',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,103.057,-64.09092,0.285,NULL,40392942010,631139718,9861558,16.4),(47253,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47253,36.77,0.83,226,11929,70,NULL,NULL,'2MASX J06521887-5532378',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,103.0787083,-55.54381,0.273,NULL,40520410332,633131411,9892678,15.5),(47254,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47254,34.23,0.4,70.2,11930,NULL,NULL,'mean','UGC 03578',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000013,NULL,'13.93',0.8,'SB(s)ab','Pair member (points to parent)',NULL,NULL,NULL,1,103.085583333,15.24911,NULL,NULL,63293435615,988959931,15452498,13.93),(47255,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47255,34.4,0.46,75.9,11930,NULL,NULL,'J','UGC 03578',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47256,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47256,34.41,0.47,76.1,11930,NULL,NULL,'H','UGC 03578',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47257,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47257,34.43,0.45,76.8,11930,NULL,NULL,'K','UGC 03578',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47258,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47258,36.31,0.79,183,11931,70,NULL,NULL,'2MASX J06525079-5131474',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.5I',0.4,NULL,NULL,NULL,NULL,NULL,1,103.211708333,-51.52978,0.133,NULL,40315020079,629922188,9842534,14.5),(47259,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47259,35.85,0.65,148,11932,70,NULL,NULL,'2MASX J06525181-4518135',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,103.2157917,-45.30372,0.177,NULL,42465820752,663528449,10367632,15.1),(47260,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47260,36.15,0.55,170,11933,70,NULL,NULL,'ESO 256- G 005',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.71',0.5,'S0?',NULL,NULL,NULL,NULL,1,103.2300417,-44.32292,0.233,NULL,42466283856,663535685,10367745,15.71),(47261,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47261,34.16,0.47,68.1,11934,70,NULL,NULL,'ESO 058- G 019',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000073,NULL,'13.57',1.1,'SAB0-',NULL,NULL,NULL,NULL,1,103.2377083,-71.76178,0.573,NULL,39875023487,623047241,9735113,13.57),(47262,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47262,36.23,0.52,176,11935,70,NULL,NULL,'2MASX J06530261-7017324',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000133,NULL,'15.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,103.260791667,-70.29231,0.501,NULL,40609121472,634517523,9914336,15.3),(47263,'IRAS','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47263,32.15,0.8,27,11936,75,NULL,'MAT, I','ESO 309- G 005',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000027,NULL,'14.35',0.8,'SAB(r)b:',NULL,NULL,NULL,NULL,1,103.262,-39.27036,0.497,NULL,42462214558,663472102,10366751,14.35),(47264,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47264,31.56,0.32,20.5,11936,85,NULL,'I, inv','ESO 309- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47265,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47265,31.58,0.32,20.7,11936,85,NULL,'I, raw','ESO 309- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47266,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47266,32,0.43,25.1,11936,75,NULL,'MAT, I, inv','ESO 309- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47267,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47267,32.02,0.43,25.3,11936,75,NULL,'MAT, I, raw','ESO 309- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47268,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47268,32.21,0.39,27.7,11936,73,NULL,'opt','ESO 309- G 005',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47269,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47269,32.24,0.88,28.1,11936,NULL,NULL,NULL,'ESO 309- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47270,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47270,32.27,0.43,28.4,11936,75,NULL,'MAT, I, cor','ESO 309- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47271,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47271,32.27,0.2,28.4,11936,74.4,NULL,NULL,'ESO 309- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47272,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47272,32.29,0.86,28.7,11936,NULL,NULL,'Malmquist cor.','ESO 309- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47273,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47273,35.49,0.63,125,11937,70,NULL,NULL,'2MASX J06530564-4335095',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,103.273583,-43.586,0.413,NULL,42464652008,663510187,10367346,15.1),(47274,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 1998ec',NULL,47274,34.02,0.24,62.4,11938,74.2,NULL,'SALT 2','UGC 03576',0.0199,'2010ApJ...716..712A',2010,1,1.6,NULL,'G',0.000013,NULL,'14.35',0.9,'SB(s)b',NULL,NULL,NULL,NULL,1,103.279167,50.03406,0.361,NULL,63391536214,990492753,15476449,14.35),(47275,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 1998ec',NULL,47275,34.62,0.08,84,11938,74.4,NULL,NULL,'UGC 03576',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47276,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 1998ec',NULL,47276,34.66,0.17,85.5,11938,70.8,NULL,NULL,'UGC 03576',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47277,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 1998ec',NULL,47277,34.74,0.2,87.1,11938,70,NULL,'SALT 2','UGC 03576',0.0199,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47278,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 1998ec',NULL,47278,34.75,0.05,87.5,11938,72,NULL,NULL,'UGC 03576',0.0199,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47279,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 1998ec',NULL,47279,35.08,0.16,99.8,11938,65,NULL,'MLCS2k2','UGC 03576',0.0199,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47280,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 1998ec',NULL,47280,35.05,0.12,100,11938,70,NULL,'SALT','UGC 03576',0.0199,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47281,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 1998ec',NULL,47281,35.17,0.14,108,11938,60,NULL,NULL,'UGC 03576',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47282,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47282,34.27,0.4,71.4,11938,75,NULL,'HOSTS SN 1998ec','UGC 03576',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47283,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47283,34.34,0.42,73.8,11938,NULL,18.48,'3.6 micron','UGC 03576',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47284,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47284,34.47,0.43,78.2,11938,75,NULL,'3.6 micron, color corrected','UGC 03576',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47285,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47285,34.55,0.43,81.2,11938,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03576',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47286,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47286,34.62,0.08,84,11938,74.4,NULL,NULL,'UGC 03576',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47287,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47287,34.71,0.4,87.5,11938,NULL,NULL,'mean','UGC 03576',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47288,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47288,34.73,0.47,88.2,11938,NULL,NULL,'H','UGC 03576',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47289,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47289,34.84,0.45,92.7,11938,NULL,NULL,'K','UGC 03576',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47290,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47290,34.88,0.46,94.6,11938,NULL,NULL,'J','UGC 03576',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47291,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47291,31.16,0.4,17.1,11939,NULL,NULL,NULL,'UGC 03574',NULL,'2009AJ....138..323T',2009,1,4.2,NULL,'G',0.000004,NULL,'13.2',3.6,'SA(s)cd','Pair member (points to parent)',NULL,NULL,NULL,1,103.2935,57.17778,0.201,NULL,61737454753,964647730,15072620,13.2),(47292,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47292,31.16,0.39,17.1,11939,73,NULL,'opt','UGC 03574',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47293,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47293,31.47,0.49,19.7,11939,NULL,NULL,NULL,'UGC 03574',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47294,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47294,31.51,0.2,20,11939,74.4,NULL,NULL,'UGC 03574',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47295,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47295,31.81,0.42,23,11939,NULL,NULL,'Malmquist cor.','UGC 03574',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47296,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47296,31.82,0.4,23.1,11939,75,NULL,'B','UGC 03574',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47297,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,'R',47297,33.52,0.49,50.5,11940,75,NULL,'IR','UGC 03584',NULL,'2011yCatp016004901K',2011,1,1.9,NULL,'G',0.000033,NULL,'14.9',0.19,'Scd',NULL,NULL,NULL,NULL,1,103.299333,27.08017,0.613,NULL,63021729276,984714519,15386164,14.9),(47298,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47298,33.82,0.43,58.2,11940,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03584',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47299,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47299,33.84,NULL,58.6,11940,NULL,NULL,'Dipole','UGC 03584',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47300,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47300,33.85,NULL,58.9,11940,NULL,NULL,'Dipole + Quadrupole','UGC 03584',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47301,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47301,33.85,NULL,58.9,11940,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03584',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47302,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47302,33.99,NULL,62.9,11940,NULL,NULL,NULL,'UGC 03584',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47303,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47303,35.46,0.46,124,11941,NULL,NULL,NULL,'ESO 309- G 006',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.74',0.5,'Sb:',NULL,NULL,NULL,NULL,1,103.299916667,-39.58472,0.469,NULL,42463048025,663485125,10366955,15.74),(47304,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47304,35.5,0.2,126,11941,74.4,NULL,NULL,'ESO 309- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47305,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47305,35.54,0.44,128,11941,NULL,NULL,'Malmquist cor.','ESO 309- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47306,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47306,36.65,0.56,214,11942,70,NULL,NULL,'2MASX J06531547-6448532',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,103.314625,-64.81486,0.241,NULL,40391498451,631117163,9861205,15.7),(47307,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47307,34.22,1.11,69.9,11943,NULL,NULL,NULL,'ESO 427- G 015',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000025,NULL,'15.36',1.1,'Sb:',NULL,NULL,NULL,NULL,1,103.321625,-28.61961,1.205,NULL,39133224781,611456637,9554009,15.36),(47308,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47308,34.26,0.2,71.1,11943,74.4,NULL,NULL,'ESO 427- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47309,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47309,34.45,1,77.6,11943,NULL,NULL,'Malmquist cor.','ESO 427- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47310,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,'R',47310,34.89,0.49,94.9,11944,75,NULL,'IR','ESO 122- G 009',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.78',0.2,'S...',NULL,NULL,NULL,NULL,1,103.3275,-59.17781,0.389,NULL,40524658965,633197796,9893715,15.78),(47311,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47311,35.13,0.39,106,11944,NULL,NULL,NULL,'ESO 122- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47312,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47312,35.18,0.2,109,11944,74.4,NULL,NULL,'ESO 122- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47313,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47313,35.27,0.37,113,11944,NULL,NULL,'Malmquist cor.','ESO 122- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47314,'GRB','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47314,41.48,NULL,1970,11945,65,NULL,'L = 10e57 photons/s','GRB 970508',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'SAX/WFC',NULL,NULL,NULL,NULL,1,132.41,80.62,0.045,NULL,61458706674,960292291,15004567,NULL),(47315,'GRB','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,'R',47315,43.26,0.48,2440,11945,69.7,NULL,'Calibrated','GRB 970508',0.84,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47316,'GRB','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47316,43.76,0.35,3070,11945,69.7,NULL,'Calibrated','GRB 970508',0.84,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47317,'GRB','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,'R',47317,43.77,0.43,3080,11945,72,NULL,NULL,'GRB 970508',0.84,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47318,'GRB','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47318,43.79,0.44,3110,11945,69.7,NULL,'Fiducial','GRB 970508',0.84,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47319,'GRB','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47319,43.92,0.43,3310,11945,70,NULL,NULL,'GRB 970508',0.84,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47320,'GRB','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47320,43,NULL,3980,11945,65,NULL,'L = 2 x 10e58 photons/s','GRB 970508',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47321,'GRB','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,'R',47321,45.1,0.47,4150,11945,73,NULL,'H const./H=100','GRB 970508',0.84,'2006astro.ph..9262M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47322,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47322,35.41,0.52,121,11946,70,NULL,NULL,'2MASX J06533088-7501356',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,103.3784583,-75.02653,0.749,NULL,39927636663,623869322,9747958,16),(47323,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47323,34.94,NULL,97.5,11947,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0588',NULL,'2010Ap&SS.325..163P',2010,1,0.9,NULL,'G',NULL,NULL,'16.6',0.1,'Sc',NULL,NULL,NULL,NULL,1,103.46,68.07139,0.145,NULL,62148567366,971071365,15172990,16.6),(47324,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47324,34.96,NULL,98.2,11947,NULL,NULL,'Dipole + Quadrupole','FGC 0588',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47325,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47325,34.98,NULL,99,11947,NULL,NULL,'Dipole','FGC 0588',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47326,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47326,35,NULL,100,11947,NULL,NULL,NULL,'FGC 0588',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47327,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47327,35.05,0.43,102,11947,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0588',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47328,'Faber-Jackson','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47328,29.27,0.65,7.14,11948,95,NULL,'Weighted Mean','NGC 2310',NULL,'1984ApJS...56...91D',1984,1,4.4,NULL,'G',0.00015,NULL,'12.74',0.8,'S0',NULL,NULL,NULL,NULL,1,103.474833,-40.86261,0.425,NULL,42459409577,663428274,10366066,12.74),(47329,'Faber-Jackson','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47329,30.57,0.81,13,11948,55,NULL,'Visvanathan & Sandage 1979','NGC 2310',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47330,'Tully est','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47330,30.67,0.8,13.6,11948,75,NULL,'B','NGC 2310',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47331,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47331,31.27,0.4,18,11949,75,NULL,'B','UGC 03587',NULL,'1988NBGC.C....0000T',1988,1,2.8,NULL,'G',0.000004,NULL,'13.84',0.7,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,103.478583,19.29967,NULL,NULL,63324163765,989440058,15460000,13.84),(47332,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47332,31.9,0.4,24,11949,NULL,NULL,NULL,'UGC 03587',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47333,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47333,31.9,0.4,24,11949,73,NULL,'opt','UGC 03587',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47334,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47334,31.97,0.4,24.8,11949,NULL,NULL,'mean','UGC 03587',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47335,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47335,32.08,0.2,26.1,11949,74.4,NULL,NULL,'UGC 03587',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47336,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47336,32.74,0.47,35.3,11949,NULL,NULL,'H','UGC 03587',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47337,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47337,36.86,0.81,236,11950,70,NULL,NULL,'2MASX J06535947-4606107',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,103.49775,-46.10297,0.229,NULL,42465287241,663520113,10367501,16.8),(47338,'IRAS','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47338,33.39,0.8,47.6,11951,75,NULL,'MAT, I','ESO 087- G 050',NULL,'1997ApJS..109..333W',1997,1,1.79,NULL,'G',0.000033,NULL,'15.77',0.22,'Sc',NULL,NULL,NULL,NULL,1,103.5,-63.21889,0.341,NULL,40392204532,631128195,9861378,15.77),(47339,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47339,32.89,0.32,37.8,11951,85,NULL,'I, inv','ESO 087- G 050',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47340,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47340,32.91,0.32,38.2,11951,85,NULL,'I, raw','ESO 087- G 050',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47341,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47341,33.11,0.43,41.9,11951,75,NULL,'MAT, I, inv','ESO 087- G 050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47342,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47342,33.13,0.43,42.3,11951,75,NULL,'MAT, I, raw','ESO 087- G 050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47343,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47343,33.31,0.43,46,11951,75,NULL,'MAT, I, cor','ESO 087- G 050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47344,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47344,33.33,NULL,46.3,11951,NULL,NULL,'Dipole + Quadrupole','ESO 087- G 050',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47345,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47345,33.33,NULL,46.3,11951,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 087- G 050',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47346,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47346,33.33,NULL,46.4,11951,NULL,NULL,'Dipole','ESO 087- G 050',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47347,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47347,33.48,NULL,49.6,11951,NULL,NULL,NULL,'ESO 087- G 050',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47348,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47348,35.75,0.77,141,11952,70,NULL,NULL,'2MASX J06540071-2754545',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.6I',0.3,'S',NULL,NULL,NULL,NULL,1,103.5030417,-27.91519,1.321,NULL,39134688662,611479510,9554367,14.6),(47349,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47349,36.45,0.75,195,11953,70,NULL,NULL,'2MASX J06540106-5540581',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,103.5045,-55.68275,0.269,NULL,40520433009,633131765,9892683,14.1),(47350,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47350,36.36,0.82,187,11954,70,NULL,NULL,'2MASX J06541247-7021152',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,103.5517083,-70.35422,0.493,NULL,40609125191,634517581,9914337,16.9),(47351,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47351,33.31,0.69,45.9,11955,100,NULL,'mid-IR','UGC 03577',NULL,'2013ApJ...771...88L',2013,1,1.2,NULL,'G',0.000037,NULL,'15.00',0.8,'SB(r)b',NULL,NULL,NULL,NULL,1,103.553708333,65.20275,0.213,NULL,61661448366,963460130,15054064,15),(47352,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47352,35.9,0.58,151,11956,70,NULL,NULL,'2MASX J06541438-5533330',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.5I',0.5,NULL,NULL,NULL,NULL,NULL,1,103.5597917,-55.55911,0.273,NULL,40520394285,633131160,9892674,13.5),(47353,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47353,35.74,0.62,140,11957,70,NULL,NULL,'2MASX J06542193-6549106',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,103.591375,-65.81961,0.277,NULL,40336876963,630263702,9847870,16.2),(47354,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47354,35.67,0.65,136,11958,70,NULL,NULL,'2MASX J06542308-5934333',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,103.5962917,-59.57594,0.449,NULL,40521518066,633148719,9892948,14.6),(47355,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47355,35.52,0.63,127,11959,70,NULL,NULL,'ESO 427- G 018',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.96',0.2,'N',NULL,NULL,NULL,NULL,1,103.634083,-29.18464,1.081,NULL,39132940156,611452189,9553940,15.96),(47356,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47356,32.2,0.2,27.5,11960,74.4,NULL,NULL,'UGC 03540',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000037,NULL,'15.50',0.3,'Scd:',NULL,NULL,NULL,NULL,1,103.646583,82.47944,0.269,NULL,61236487183,956820112,14950314,15.5),(47357,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47357,32.38,0.61,29.9,11960,NULL,NULL,NULL,'UGC 03540',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47358,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47358,32.39,0.61,30,11960,NULL,NULL,'Malmquist cor.','UGC 03540',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47359,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47359,32.44,0.4,30.8,11960,NULL,NULL,NULL,'UGC 03540',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47360,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47360,34.21,0.4,69.3,11961,NULL,NULL,'mean','UGC 03594',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000033,NULL,'14.3',0.6,'SAB(s)b',NULL,NULL,NULL,NULL,1,103.7037083,23.50189,0.737,NULL,63099216988,985925265,15405082,14.3),(47361,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47361,34.44,0.47,77.4,11961,NULL,NULL,'H','UGC 03594',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47362,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,'R',47362,33.59,0.49,52.3,11962,75,NULL,'IR','UGC 03575',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.000037,NULL,'16.5',0.12,'Sd',NULL,NULL,NULL,NULL,1,103.714417,70.74825,0.285,NULL,62154887952,971170124,15174533,16.5),(47363,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47363,33.72,NULL,55.5,11962,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03575',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47364,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47364,33.73,NULL,55.7,11962,NULL,NULL,'Dipole + Quadrupole','UGC 03575',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47365,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47365,33.74,NULL,55.9,11962,NULL,NULL,'Dipole','UGC 03575',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47366,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47366,33.8,NULL,57.5,11962,NULL,NULL,NULL,'UGC 03575',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47367,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47367,33.88,0.43,59.8,11962,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03575',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47368,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47368,36.69,0.52,218,11963,70,NULL,NULL,'2MASX J06545155-5531045',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,103.714666667,-55.51792,0.225,NULL,40519349978,633114843,9892419,15.8),(47369,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47369,34.21,0.42,69.5,11964,NULL,NULL,NULL,'UGC 03521',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000037,NULL,'15.20',0.6,'S?',NULL,NULL,NULL,NULL,1,103.749666667,84.04186,0.221,NULL,61230813769,956731465,14948929,15.2),(47370,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47370,34.25,0.2,70.8,11964,74.4,NULL,NULL,'UGC 03521',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47371,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47371,34.25,0.42,70.9,11964,NULL,NULL,'Malmquist cor.','UGC 03521',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47372,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47372,34.27,0.49,71.6,11965,NULL,NULL,NULL,'ESO 309- G 010',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.55',0.4,'Sb:','Pair member (points to parent)',NULL,NULL,NULL,1,103.775167,-38.07294,0.721,NULL,42449664188,663276002,10363687,15.55),(47373,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47373,34.32,0.2,73.1,11965,74.4,NULL,NULL,'ESO 309- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47374,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47374,34.33,0.47,73.4,11965,NULL,NULL,'Malmquist cor.','ESO 309- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47375,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47375,36.54,0.67,203,11966,70,NULL,NULL,'2MASX J06551057-5819154',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,103.7940417,-58.32106,0.413,NULL,40524012109,633187689,9893557,15.5),(47376,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47376,33.85,0.47,59,11967,NULL,NULL,'H','UGC 03599',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000107,NULL,'13.9',0.9,'S?',NULL,NULL,NULL,NULL,1,103.798083,24.22931,0.645,NULL,62982633039,984103641,15376619,13.9),(47377,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47377,34.06,0.45,64.8,11967,NULL,NULL,'K','UGC 03599',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47378,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47378,34.08,0.46,65.3,11967,NULL,NULL,'J','UGC 03599',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47379,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47379,34.86,0.4,93.9,11967,NULL,NULL,'mean','UGC 03599',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47380,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47380,34.68,0.34,86.3,11968,NULL,NULL,'Malmquist cor.','UGC 03593',NULL,'2009ApJS..182..474S',2009,1,1.7,NULL,'G',0.000037,NULL,'14.40',0.8,'SABc:',NULL,NULL,NULL,NULL,1,103.80925,40.96072,0.445,NULL,63380891166,990326424,15473850,14.4),(47381,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47381,34.79,0.2,90.8,11968,74.4,NULL,NULL,'UGC 03593',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47382,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47382,34.8,0.32,91.3,11968,NULL,NULL,NULL,'UGC 03593',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47383,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47383,34.95,0.4,97.6,11968,NULL,NULL,'mean','UGC 03593',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47384,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47384,35.01,0.47,100,11968,NULL,NULL,'H','UGC 03593',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47385,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47385,35.11,0.45,105,11968,NULL,NULL,'K','UGC 03593',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47386,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47386,35.12,0.46,106,11968,NULL,NULL,'J','UGC 03593',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47387,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47387,36.48,0.52,198,11969,70,NULL,NULL,'2MASX J06551809-5533250',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00012,NULL,'14.5R',NULL,'E/D',NULL,NULL,NULL,NULL,1,103.825333,-55.55692,0.225,NULL,40519390725,633115480,9892429,14.5),(47388,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47388,32.67,0.43,34.1,11970,75,NULL,'3.6 micron, color + selection bias corrected','ESO 491- G 009',NULL,'2014MNRAS.444..527S',2014,1,1.7,'Confused HIPASS source','G',0.000013,NULL,'14.79',0.6,'SAB(s)dm',NULL,NULL,NULL,NULL,1,103.854875,-26.60733,1.809,NULL,39021769243,609715144,9526799,14.79),(47389,'IRAS','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47389,31.44,0.8,19.4,11971,75,NULL,'A82, H','UGC 03580',NULL,'1997ApJS..109..333W',1997,1,3.4,NULL,'G',0.00002,NULL,'12.71',1.8,'SA(s)a pec:','Isolated galaxy',NULL,NULL,NULL,1,103.878583,69.56306,0.193,NULL,62154038798,971156856,15174325,12.71),(47390,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47390,30.57,0.4,13,11971,NULL,NULL,'Virgo cluster at 15.6 Mpc','UGC 03580',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47391,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47391,31.42,0.47,19.3,11971,75,NULL,'A82, H, inv','UGC 03580',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47392,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47392,31.44,0.47,19.4,11971,75,NULL,'A82, H, raw','UGC 03580',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47393,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47393,31.57,0.4,20.6,11971,75,NULL,'B','UGC 03580',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47394,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47394,31.76,0.47,22.5,11971,75,NULL,'A82, H, cor','UGC 03580',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47395,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47395,31.76,0.4,22.5,11971,NULL,NULL,'mean','UGC 03580',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47396,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47396,32,0.38,25.1,11971,NULL,NULL,NULL,'UGC 03580',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47397,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47397,32.39,0.45,30.1,11971,NULL,NULL,'K','UGC 03580',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47398,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47398,32.45,0.46,30.8,11971,NULL,NULL,'J','UGC 03580',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47399,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47399,32.46,0.47,31,11971,NULL,NULL,'H','UGC 03580',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47400,'Brightest Stars','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47400,29.3,0.2,7.2,11972,NULL,NULL,NULL,'UGC 03600',NULL,'1998A&AS..133..181M',1998,1,1.1,NULL,'G',0.000013,NULL,'18.',0.5,'Im:','Field galaxy',NULL,NULL,NULL,1,103.916667,39.09522,0.577,NULL,63382796502,990356195,15474315,18),(47401,'TRGB','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47401,30.04,0.1,10.2,11972,74.4,NULL,NULL,'UGC 03600',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47402,'TRGB','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47402,30.08,0.2,10.4,11972,NULL,NULL,NULL,'UGC 03600',NULL,'2015ApJ...805..144K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47403,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,'R',47403,35.25,0.49,112,11973,75,NULL,'IR','UGC 03605',NULL,'2011yCatp016004901K',2011,1,1.15,NULL,'G',0.000033,NULL,'16.5',0.09,'Scd',NULL,NULL,NULL,NULL,1,103.9657917,13.90603,NULL,NULL,63300272298,989066754,15454168,16.5),(47404,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47404,35.36,NULL,118,11973,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03605',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47405,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47405,35.37,NULL,118,11973,NULL,NULL,'Dipole + Quadrupole','UGC 03605',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47406,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47406,35.38,NULL,119,11973,NULL,NULL,'Dipole','UGC 03605',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47407,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47407,35.44,NULL,122,11973,NULL,NULL,NULL,'UGC 03605',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47408,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47408,35.77,0.43,143,11973,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03605',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47409,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47409,36.79,0.57,228,11974,70,NULL,NULL,'2MASX J06555281-5523361',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,103.970125,-55.39344,0.225,NULL,40489245087,632644454,9885069,14.5),(47410,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47410,34.67,0.53,85.9,11975,NULL,NULL,NULL,'ESO 366- G 027',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.31',0.3,'S...',NULL,NULL,NULL,NULL,1,103.987667,-36.46447,0.745,NULL,42446878260,663232472,10363007,16.31),(47411,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47411,34.71,0.2,87.5,11975,74.4,NULL,NULL,'ESO 366- G 027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47412,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47412,34.82,0.49,92,11975,NULL,NULL,'Malmquist cor.','ESO 366- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47413,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47413,33.58,NULL,52.1,11976,NULL,NULL,'Dipole','ESO 491- G 011',NULL,'2010Ap&SS.325..163P',2010,1,1.62,NULL,'G',0.000037,NULL,'17.20',0.1,'Sc',NULL,NULL,NULL,NULL,1,104.020833,-26.28056,1.633,NULL,39008187726,609502933,9523483,17.2),(47414,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47414,33.59,NULL,52.2,11976,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 491- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47415,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47415,33.59,NULL,52.3,11976,NULL,NULL,'Dipole + Quadrupole','ESO 491- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47416,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47416,32.61,0.4,33.2,11977,75,NULL,'B','UGC 03522',NULL,'1988NBGC.C....0000T',1988,1,2,NULL,'G',0.000017,NULL,'15.2',0.6,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,104.025291667,84.91775,0.225,NULL,61262815247,957231488,14956742,15.2),(47417,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47417,33.65,0.58,53.6,11978,NULL,NULL,NULL,'UGC 03528',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000107,NULL,'14.38',0.8,'SBab',NULL,NULL,NULL,NULL,1,104.045333333,84.07892,0.197,NULL,61230816006,956731500,14948929,14.38),(47418,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47418,33.69,0.2,54.7,11978,74.4,NULL,NULL,'UGC 03528',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47419,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47419,33.7,0.56,54.9,11978,NULL,NULL,'Malmquist cor.','UGC 03528',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47420,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47420,36.79,0.58,228,11979,70,NULL,NULL,'2MASX J06561739-4743554',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,104.0725,-47.73208,0.177,NULL,42442606180,663165721,10361964,16.3),(47421,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47421,35.65,0.61,135,11980,70,NULL,NULL,'2MASX J06562136-8610215',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,104.089917,-86.17258,0.617,NULL,39741019967,620953436,9702397,16.1),(47422,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47422,36.09,0.56,166,11981,70,NULL,NULL,'2MASX J06562793-4531464',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,104.116375,-45.5295,0.225,NULL,42466204670,663534447,10367725,14.1),(47423,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47423,30.58,0.4,13.1,11982,NULL,NULL,NULL,'UGC 03598',NULL,'2009AJ....138..323T',2009,1,2,'MCG notes this as possibly interacting.','G',0.000013,NULL,'14.9',1.2,'IBm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,104.127083,60.65167,0.313,NULL,61678094926,963720233,15058128,14.9),(47424,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47424,32.41,0.4,30.3,11982,75,NULL,'B','UGC 03598',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47425,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47425,35.08,0.54,104,11983,70,NULL,NULL,'ESO 162- G 003',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.2R',0.2,'Sa:',NULL,NULL,NULL,NULL,1,104.133625,-55.80939,0.233,NULL,40519597852,633118716,9892479,15.2),(47426,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47426,35.76,0.54,142,11984,70,NULL,NULL,'2MASX J06563357-4538513',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.7I',0.5,NULL,NULL,NULL,NULL,NULL,1,104.139791667,-45.64753,0.225,NULL,42465300648,663520322,10367505,13.7),(47427,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47427,36.05,0.49,162,11985,70,NULL,NULL,'2MASX J06563417-5233070',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.4I',0.5,NULL,NULL,NULL,NULL,NULL,1,104.1422917,-52.55189,0.217,NULL,40313343089,629895985,9842124,13.4),(47428,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47428,34.27,NULL,71.5,11986,NULL,NULL,'Dipole + Quadrupole + Octopole','FGCE 0632',NULL,'2010Ap&SS.325..163P',2010,1,0.92,NULL,'G',0.00007,NULL,'16.8',0.11,'Sd',NULL,NULL,NULL,NULL,1,104.14375,-28.72,1.145,NULL,39012127222,609564487,9524445,16.8),(47429,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47429,34.29,NULL,72.3,11986,NULL,NULL,'Dipole + Quadrupole','FGCE 0632',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47430,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47430,34.31,NULL,72.7,11986,NULL,NULL,'Dipole','FGCE 0632',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47431,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47431,34.34,NULL,73.9,11986,NULL,NULL,NULL,'FGCE 0632',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47432,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47432,34.97,0.54,98.4,11987,70,NULL,NULL,'2MASX J06563589-2538165',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'13.22',0.22,NULL,NULL,NULL,NULL,NULL,1,104.149583,-25.63789,1.505,NULL,39008905512,609514148,9523658,13.22),(47433,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47433,35.74,0.83,141,11988,70,NULL,NULL,'2MASX J06563982-4549431',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,104.166,-45.82861,0.213,NULL,42465351182,663521112,10367517,14),(47434,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47434,34.96,0.54,98.3,11989,70,NULL,NULL,'ESO 256- G 010',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.37',0.6,'(R\'_2)SAB(s)a',NULL,NULL,NULL,NULL,1,104.283791667,-45.54897,0.229,NULL,42466154390,663533662,10367713,15.37),(47435,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 2008C',NULL,47435,34.14,0.13,65.1,11990,72,NULL,NULL,'UGC 03611',0.01708,'2013ApJ...773...53F',2013,1,0.9,NULL,'G',0.000013,NULL,'14.3',0.5,'S0/a',NULL,NULL,NULL,NULL,1,104.298875,20.43736,0.577,NULL,63332572344,989571442,15462053,14.3),(47436,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 2008C',NULL,47436,34.25,0.19,69.5,11990,70,NULL,'SALT 2','UGC 03611',0.016621,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47437,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 2008C',NULL,47437,34.29,0.22,70.9,11990,73.8,NULL,'SALT 2 (SNANA)','UGC 03611',0.0172,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47438,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 2008C',NULL,47438,34.38,0.04,75.1,11990,72,NULL,'M(H) = -18.317 mag','UGC 03611',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47439,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47439,35.65,0.55,135,11991,70,NULL,NULL,'2MASX J06571970-4659049',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000123,NULL,'15.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,104.3322083,-46.98464,0.177,NULL,42442332894,663161451,10361897,15.6),(47440,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47440,32.76,0.39,35.6,11992,73,NULL,'opt','ESO 491- G 012',NULL,'2011A&A...532A.104N',2011,1,1.9,'abs(b) < 10 degrees.','G',0.000023,NULL,'14.75',0.4,'Sc? sp',NULL,NULL,NULL,NULL,1,104.352875,-24.72694,NULL,NULL,39011014689,609547104,9524173,14.75),(47441,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47441,32.76,0.39,35.7,11992,73,NULL,'IR','ESO 491- G 012',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47442,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,'R',47442,32.76,0.4,35.7,11992,75,NULL,NULL,'ESO 491- G 012',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47443,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47443,33.14,0.43,42.4,11992,75,NULL,'3.6 micron, color + selection bias corrected','ESO 491- G 012',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47444,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,'R',47444,33.27,0.49,45.1,11992,75,NULL,'IR','ESO 491- G 012',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47445,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47445,36.59,0.79,208,11993,70,NULL,NULL,'CGMW 2-0232',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3R',NULL,'E',NULL,NULL,NULL,NULL,1,104.3807083,-26.84192,1.637,NULL,39013451833,609585184,9524768,16.3),(47446,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47446,34.05,0.47,64.6,11994,NULL,NULL,'H','UGC 03608',NULL,'2007A&A...465...71T',2007,1,1.9,'87GB source with large sky, narrow minor axis, or very bad confusion.','G',0.000053,NULL,'13.61',1,'S pec      HII;LIRG',NULL,NULL,NULL,NULL,1,104.3935417,46.403,0.305,NULL,63394983673,990546619,15477290,13.61),(47447,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47447,34.21,0.46,69.6,11994,NULL,NULL,'J','UGC 03608',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47448,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47448,34.23,0.45,70.1,11994,NULL,NULL,'K','UGC 03608',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47449,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47449,34.81,0.4,91.6,11994,NULL,NULL,'mean','UGC 03608',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47450,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47450,36.5,0.58,200,11995,70,NULL,NULL,'2MASX J06573663-4550070',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,104.402625,-45.83528,0.165,NULL,42434956029,663046187,10360096,15),(47451,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47451,34.59,0.4,82.6,11996,NULL,NULL,'mean','UGC 03612',NULL,'2007A&A...465...71T',2007,1,0.8,NULL,'G',0.000043,NULL,'14.30',0.6,'SB(s)b',NULL,NULL,NULL,NULL,1,104.41525,39.08728,0.457,NULL,63382857262,990357144,15474330,14.3),(47452,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47452,35.14,0.45,106,11996,NULL,NULL,'K','UGC 03612',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47453,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47453,35.16,0.47,108,11996,NULL,NULL,'H','UGC 03612',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47454,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47454,35.19,0.46,109,11996,NULL,NULL,'J','UGC 03612',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47455,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47455,33.82,0.2,58.1,11997,74.4,NULL,NULL,'UGC 03606',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.00002,NULL,'14.70',0.9,'Sdm',NULL,NULL,NULL,NULL,1,104.459333,63.69164,0.201,NULL,61645619176,963212799,15050199,14.7),(47456,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47456,36.99,0.57,251,11998,70,NULL,NULL,'2MASX J06575146-5325453',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,104.4645,-53.42933,0.225,NULL,40308514467,629820538,9840945,14.3),(47457,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47457,35.81,0.67,145,11999,70,NULL,NULL,'2MASX J06575638-2535227',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,'S',NULL,NULL,NULL,NULL,1,104.484917,-25.58964,1.649,NULL,39008545271,609508519,9523570,15.4),(47458,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47458,36.51,0.62,200,12000,70,NULL,NULL,'2MASX J06575661-4110460',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,104.485875,-41.1795,0.433,NULL,42457920271,663405004,10365703,15.8),(47459,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47459,36.36,0.65,187,12001,70,NULL,NULL,'2MASX J06584025-6452148',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,104.6677083,-64.87078,0.329,NULL,40358227497,630597304,9853082,17.1),(47460,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47460,36.22,0.55,176,12002,70,NULL,NULL,'ESO 207- G 011',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'15.69',0.2,'N',NULL,NULL,NULL,NULL,1,104.690625,-49.92767,0.117,NULL,42443411594,663178306,10362161,15.69),(47461,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47461,34.19,0.32,68.8,12003,NULL,NULL,'Malmquist cor.','UGC 03581',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000023,NULL,'13.74',1.1,'SAB(rs)c:','Isolated galaxy',NULL,NULL,NULL,1,104.76175,80.00347,0.313,NULL,61440988732,960015448,15000241,13.74),(47462,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47462,34.35,0.4,74.2,12003,NULL,NULL,'mean','UGC 03581',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47463,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47463,34.4,0.29,75.9,12003,NULL,NULL,NULL,'UGC 03581',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47464,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47464,34.44,0.2,77.3,12003,74.4,NULL,NULL,'UGC 03581',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47465,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47465,34.65,0.47,85,12003,NULL,NULL,'H','UGC 03581',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47466,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47466,34.7,0.45,87.2,12003,NULL,NULL,'K','UGC 03581',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47467,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47467,34.73,0.46,88.4,12003,NULL,NULL,'J','UGC 03581',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47468,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47468,36.18,0.77,172,12004,70,NULL,NULL,'2MASX J06590279-6542089',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,104.761667,-65.70256,0.305,NULL,40391154120,631111783,9861121,16.8),(47469,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,'R',47469,33.91,0.49,60.5,12005,75,NULL,'IR','UGC 03622',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000033,NULL,'15.5',0.3,'S?',NULL,NULL,NULL,NULL,1,104.89175,33.02408,0.665,NULL,62966854113,983857095,15372767,15.5),(47470,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 2001C',NULL,47470,32.63,0.29,33.2,12006,74.2,NULL,'SALT 2','CGCG 285-012',0.0111,'2010ApJ...716..712A',2010,1,0.8,NULL,'G',0.000117,NULL,'15.2',0.31,'Sb','Isolated galaxy',NULL,NULL,NULL,1,104.8925,59.51858,0.253,NULL,61735228818,964612950,15072077,15.2),(47471,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 2001C',NULL,47471,33.21,0.1,43.9,12006,74.4,NULL,NULL,'CGCG 285-012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47472,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47472,32.98,0.43,39.5,12006,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 285-012',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47473,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,'R',47473,35.28,0.49,114,12007,75,NULL,'IR','UGC 03624',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',NULL,NULL,'16.0',0.2,'Sb',NULL,NULL,NULL,NULL,1,104.948625,27.56878,0.481,NULL,62994189252,984284207,15379440,16),(47474,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47474,36.53,0.67,202,12008,70,NULL,NULL,'2MASX J06595019-2824295',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,104.959167,-28.40814,1.221,NULL,39011733867,609558341,9524349,15.7),(47475,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47475,35.77,0.65,143,12009,70,NULL,NULL,'2MASX J06595933-6917580',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,104.997083,-69.29944,0.501,NULL,40607034588,634484915,9913826,16.9),(47476,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47476,35.9,0.56,151,12010,70,NULL,NULL,'2MASX J07000530-3708427',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,105.022083,-37.14522,0.861,NULL,42446916911,663233076,10363016,15.4),(47477,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47477,36.57,0.69,206,12011,70,NULL,NULL,'2MASX J07000546-7818420',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,105.02275,-78.31169,0.885,NULL,39956001104,624312517,9754883,16.9),(47478,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47478,35.04,0.53,102,12012,70,NULL,NULL,'AM 0702-772',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.00015,NULL,'15.6B',0.42,NULL,NULL,NULL,NULL,NULL,1,105.089667,-77.49653,0.837,NULL,39886422064,623225344,9737896,15.6),(47479,'TRGB','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47479,26.12,0.14,1.69,12013,NULL,NULL,'K','HIZSS 003',NULL,'2005ApJ...623..148S',2005,1,2,NULL,'G',NULL,NULL,'18. B',1.2,NULL,NULL,NULL,NULL,NULL,1,105.122083,-4.20833,NULL,0,38855388071,607115438,9486178,18),(47480,'BL Lac Luminosity','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47480,41.29,NULL,1810,12014,70,NULL,'min.','PKS 0700-661',NULL,'2014ApJ...784..151S',2014,1,NULL,NULL,'QSO',NULL,NULL,'15.8V',NULL,'AGN',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,105.130166667,-66.17939,0.373,NULL,40655408675,635240760,9925636,15.8),(47481,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47481,35.55,0.53,129,12015,70,NULL,NULL,'2MASX J07004108-6323247',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,105.1712917,-63.39025,0.405,NULL,40361866743,630654167,9853971,16.4),(47482,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,'R',47482,32.51,0.4,31.8,12016,75,NULL,NULL,'ESO 491- G 015',NULL,'2008Ap.....51..336K',2008,1,2,NULL,'G',0.00001,NULL,'14.30',0.4,'SABc: sp       HII',NULL,NULL,NULL,NULL,1,105.177333333,-27.36864,1.353,NULL,39014540084,609602188,9525034,14.3),(47483,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47483,32.51,0.4,31.8,12016,73,NULL,'IR','ESO 491- G 015',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47484,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47484,32.51,0.4,31.8,12016,73,NULL,'opt','ESO 491- G 015',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47485,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47485,32.66,0.2,34,12016,74.4,NULL,NULL,'ESO 491- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47486,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47486,32.76,0.46,35.6,12016,NULL,NULL,'J','ESO 491- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47487,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47487,32.76,0.43,35.6,12016,75,NULL,'3.6 micron, color corrected','ESO 491- G 015',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47488,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47488,32.8,0.47,36.3,12016,NULL,NULL,'H','ESO 491- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47489,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47489,32.81,0.4,36.6,12016,NULL,NULL,'mean','ESO 491- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47490,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47490,32.87,0.43,37.4,12016,75,NULL,'3.6 micron, color + selection bias corrected','ESO 491- G 015',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47491,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47491,32.88,0.45,37.7,12016,NULL,NULL,'K','ESO 491- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47492,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,'R',47492,32.93,0.49,38.6,12016,75,NULL,'IR','ESO 491- G 015',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47493,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47493,35.68,0.65,137,12017,70,NULL,NULL,'2MASX J07004427-3718043',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,105.184583,-37.30114,0.881,NULL,42449789686,663277963,10363718,15.3),(47494,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47494,36.45,0.56,195,12018,70,NULL,NULL,'2MASX J07005704-2745482',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,105.2377917,-27.76333,1.273,NULL,39014984361,609609130,9525142,16),(47495,'Sosies','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47495,32.1,0.09,26.3,12019,NULL,NULL,NULL,'UGC 03630',NULL,'2002A&A...393...57T',2002,1,1.7,NULL,'G',0.000004,NULL,'15.5',0.9,'SAB(r)b?',NULL,NULL,NULL,NULL,1,105.26375,1.91128,NULL,NULL,62401275460,975019929,15234686,15.5),(47496,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47496,31.23,0.69,17.6,12019,100,NULL,'mid-IR','UGC 03630',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47497,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47497,32.16,0.4,27.1,12019,NULL,NULL,'mean','UGC 03630',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47498,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47498,32.18,0.47,27.3,12019,NULL,NULL,'H','UGC 03630',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47499,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47499,32.19,0.45,27.4,12019,NULL,NULL,'K','UGC 03630',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47500,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47500,32.2,0.46,27.6,12019,NULL,NULL,'J','UGC 03630',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47501,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47501,34.33,0.43,73.3,12020,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03627',NULL,'2014MNRAS.444..527S',2014,1,1.2,NULL,'G',0.00013,NULL,'14.54',0.8,'Sd',NULL,NULL,NULL,NULL,1,105.271083333,51.26969,0.313,NULL,61491477854,960804341,15012567,14.54),(47502,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47502,34.4,0.43,75.9,12020,75,NULL,'3.6 micron, color corrected','UGC 03627',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47503,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47503,34.52,0.2,80.2,12020,74.4,NULL,NULL,'UGC 03627',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47504,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47504,34.81,0.07,91.8,12020,NULL,NULL,NULL,'UGC 03627',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47505,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47505,36.72,0.6,221,12021,70,NULL,NULL,'2MASX J07011472-4841117',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,105.311417,-48.68661,0.245,NULL,42446171026,663221422,10362834,15.8),(47506,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 2005na',NULL,47506,34.58,0.17,80.3,12022,74.2,NULL,'SALT 2','UGC 03634',0.026322,'2010ApJ...716..712A',2010,1,1,NULL,'G',0.000083,NULL,'15.5',0.9,'SB(r)a',NULL,NULL,NULL,NULL,1,105.403167,14.13525,NULL,NULL,63288989417,988890459,15451413,15.5),(47507,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 2005na',NULL,47507,34.97,0.03,96,12022,70,NULL,'SALT 2','UGC 03634',0.026322,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47508,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 2005na',NULL,47508,35.12,0.15,103,12022,72,NULL,NULL,'UGC 03634',0.026322,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47509,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 2005na',NULL,47509,35.15,0.03,104,12022,72,NULL,NULL,'UGC 03634',0.026322,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47510,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 2005na',NULL,47510,35.12,0.02,106,12022,72,NULL,NULL,'UGC 03634',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47511,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 2005na',NULL,47511,35.15,0.04,107,12022,72,NULL,'M(H) = -18.317 mag','UGC 03634',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47512,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 2005na',NULL,47512,35.21,0.14,107,12022,72,NULL,NULL,'UGC 03634',0.026322,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47513,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 2005na',NULL,47513,35.16,0.09,108,12022,74.4,NULL,NULL,'UGC 03634',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47514,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 2005na',NULL,47514,35.23,0.22,108,12022,73.8,NULL,'SALT 2 (SNANA)','UGC 03634',0.0269,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47515,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 2005na',NULL,47515,35.3,0.21,109,12022,72,NULL,NULL,'UGC 03634',0.02683,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47516,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 2005na',NULL,47516,35.24,0.11,109,12022,72,NULL,NULL,'UGC 03634',0.026322,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47517,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 2005na',NULL,47517,35.24,0.05,109,12022,72,NULL,NULL,'UGC 03634',0.026322,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47518,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 2005na',NULL,47518,35.27,0.2,110,12022,73.8,NULL,'SALT 2 (SNANA)','UGC 03634',0.0269,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47519,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 2005na',NULL,47519,35.36,0.16,115,12022,65,NULL,'MLCS17','UGC 03634',0.026322,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47520,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 2005na',NULL,47520,35.42,0.17,118,12022,65,NULL,'SALT','UGC 03634',0.026322,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47521,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 2005na',NULL,47521,35.44,0.19,119,12022,65,NULL,'SALT2','UGC 03634',0.026322,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47522,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:20','1','SN 2005na',NULL,47522,35.46,0.17,121,12022,65,NULL,'MLCS31','UGC 03634',0.026322,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47523,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47523,36.24,0.7,177,12023,70,NULL,NULL,'2MASX J07014284-2833561',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,105.428583,-28.56553,1.121,NULL,39041147046,610017922,9531530,15.2),(47524,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47524,32.68,0.43,34.4,12024,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03637',NULL,'2014MNRAS.444..527S',2014,1,1.1,NULL,'G',0.000017,NULL,'16.5',0.4,'Sdm:',NULL,NULL,NULL,NULL,1,105.45675,4.91897,NULL,NULL,62404254084,975066470,15235413,16.5),(47525,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47525,35.6,0.53,132,12025,70,NULL,NULL,'2MASX J07020120-3742363',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,105.504958333,-37.71006,0.817,NULL,42448754449,663261788,10363465,15.5),(47526,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47526,36.78,0.6,227,12026,70,NULL,NULL,'2MASX J07021623-4943046',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,105.567666667,-49.71789,0.129,NULL,42443612768,663181449,10362210,14.1),(47527,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,'R',47527,35.22,0.49,111,12027,75,NULL,'IR','UGC 03639',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000033,NULL,'15.0',0.2,'S?',NULL,NULL,NULL,NULL,1,105.608583,19.97017,0.529,NULL,63331590347,989556099,15461814,15),(47528,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47528,36.28,0.81,180,12028,70,NULL,NULL,'2MFGC 05596',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'11.8K',NULL,NULL,NULL,NULL,NULL,NULL,1,105.6517917,-70.74239,0.609,NULL,40605385124,634459142,9913424,11.8),(47529,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47529,35.84,0.76,147,12029,70,NULL,NULL,'2MASX J07023661-5102375',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,105.652667,-51.04383,0.141,NULL,40300063860,629688497,9838882,14),(47530,'SBF','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47530,32.04,0.16,25.6,12030,NULL,NULL,'I','NGC 2325',NULL,'2001ApJ...546..681T',2001,1,3.3,NULL,'G',0.000073,NULL,'12.38',1.9,'E4',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,105.668333,-28.69722,1.121,NULL,39044094600,610063978,9532249,12.38),(47531,'SBF','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47531,32.04,0.16,25.6,12030,NULL,NULL,NULL,'NGC 2325',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47532,'SBF','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47532,32.06,0.14,25.8,12030,74.4,NULL,NULL,'NGC 2325',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47533,'SBF','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47533,32.09,0.16,26.1,12030,NULL,NULL,'Malmquist cor.','NGC 2325',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47534,'D-Sigma','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47534,31.16,0.4,17.1,12030,75,NULL,'Edat, raw','NGC 2325',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47535,'D-Sigma','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47535,31.49,0.4,19.9,12030,75,NULL,'Edat, cor','NGC 2325',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47536,'Faber-Jackson','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47536,30.29,0.65,11.4,12030,95,NULL,'Weighted Mean','NGC 2325',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47537,'Faber-Jackson','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47537,31.34,0.63,18.5,12030,95,NULL,'Michard 1979b, c','NGC 2325',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47538,'Faber-Jackson','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47538,31.72,0.46,22.1,12030,95,NULL,'Michard 1979a','NGC 2325',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47539,'Faber-Jackson','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47539,31.84,0.81,23.3,12030,55,NULL,'Visvanathan & Sandage 1979','NGC 2325',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47540,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47540,31.35,0.41,18.6,12030,NULL,NULL,NULL,'NGC 2325',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47541,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47541,31.69,0.41,21.7,12030,NULL,NULL,'Malmquist cor.','NGC 2325',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47542,'Tully est','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47542,32.08,0.8,26.1,12030,75,NULL,'B','NGC 2325',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47543,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47543,32.06,0.45,25.8,12030,NULL,NULL,'K','NGC 2325',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47544,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47544,32.36,0.4,29.7,12030,NULL,NULL,'mean','NGC 2325',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47545,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47545,35.99,0.59,158,12031,70,NULL,NULL,'2MASX J07025618-4917442',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,105.734041667,-49.29556,0.205,NULL,42443723433,663183178,10362237,17),(47546,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47546,35.59,0.54,131,12032,70,NULL,NULL,'2MASX J07030766-3641258',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,105.782,-36.69047,0.889,NULL,42631375407,666115240,10408050,15.4),(47547,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47547,35.1,0.61,105,12033,70,NULL,NULL,'2MASX J07031710-6702028',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,105.821333,-67.03414,0.581,NULL,40655870963,635247983,9925749,16.1),(47548,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47548,35.97,0.66,156,12034,70,NULL,NULL,'2MASX J07032158-6445061',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,105.840083,-64.75161,0.421,NULL,40361076209,630641815,9853778,17),(47549,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47549,36.79,0.55,228,12035,NULL,NULL,'Malmquist cor.','2MASX J07032682-4859432',NULL,'2009ApJS..182..474S',2009,1,0.43,NULL,'G',0.00003,NULL,'15.85',NULL,'Sc',NULL,NULL,NULL,NULL,1,105.861667,-48.99528,0.253,NULL,42445456805,663210262,10362660,15.85),(47550,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47550,37.21,0.45,276,12035,NULL,NULL,NULL,'2MASX J07032682-4859432',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47551,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47551,37.25,0.2,282,12035,74.4,NULL,NULL,'2MASX J07032682-4859432',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47552,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47552,35.71,0.53,139,12036,70,NULL,NULL,'2MASX J07032838-7024589',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,105.868083,-70.41633,0.613,NULL,40608931507,634514554,9914289,16.4),(47553,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47553,35.1,0.47,105,12037,NULL,NULL,'H','CGCG 085-026',NULL,'2007A&A...465...71T',2007,1,0.7,NULL,'G',0.00002,NULL,'15.1',0.25,'2MASS Extended Ver.2',NULL,NULL,NULL,NULL,1,105.8939583,18.95653,0.461,NULL,63328322982,989505046,15461016,15.1),(47554,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47554,35.16,0.45,108,12037,NULL,NULL,'K','CGCG 085-026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47555,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47555,35.26,0.4,113,12037,NULL,NULL,'mean','CGCG 085-026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47556,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47556,35.27,0.46,113,12037,NULL,NULL,'J','CGCG 085-026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47557,'IRAS','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47557,33.9,0.8,60.2,12038,75,NULL,'CF, r','UGC 03652',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000023,NULL,'13.9',0.6,'Scd:',NULL,NULL,NULL,NULL,1,105.96325,22.36953,0.409,NULL,63100664159,985947877,15405435,13.9),(47558,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47558,33.62,0.38,53,12038,75,NULL,'CF, r, raw','UGC 03652',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47559,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47559,33.75,0.2,56.2,12038,74.4,NULL,NULL,'UGC 03652',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47560,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47560,33.75,0.38,56.3,12038,75,NULL,'CF, r, inv','UGC 03652',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47561,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47561,33.9,0.47,60.3,12038,NULL,NULL,'H','UGC 03652',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47562,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47562,33.92,0.26,60.9,12038,NULL,NULL,NULL,'UGC 03652',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47563,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47563,33.96,0.46,61.8,12038,NULL,NULL,'J','UGC 03652',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47564,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47564,34.01,0.38,63.4,12038,75,NULL,'CF, r, cor','UGC 03652',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47565,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47565,34.02,0.45,63.8,12038,NULL,NULL,'K','UGC 03652',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47566,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47566,34.08,0.25,65.3,12038,NULL,NULL,'Malmquist cor.','UGC 03652',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47567,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47567,34.18,0.4,68.5,12038,NULL,NULL,'mean','UGC 03652',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47568,'FP','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47568,36.18,0.55,172,12039,70,NULL,NULL,'2MASX J07035143-5419122',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,105.9642083,-54.32006,0.273,NULL,40498554738,632789917,9887342,15.1),(47569,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47569,36.09,0.52,165,12040,NULL,NULL,NULL,'AGC 470034',NULL,'2009ApJS..182..474S',2009,1,0.29,NULL,'G',0.000037,NULL,'16.52',NULL,'Sc',NULL,NULL,NULL,NULL,1,105.979583,-49.06083,0.253,NULL,42445521187,663211268,10362676,16.52),(47570,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47570,36.13,0.2,168,12040,74.4,NULL,NULL,'AGC 470034',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47571,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47571,36.35,0.46,186,12040,NULL,NULL,'Malmquist cor.','AGC 470034',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47572,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47572,36.23,0.38,177,12041,NULL,NULL,NULL,'AGC 470035',NULL,'2009ApJS..182..474S',2009,1,0.49,NULL,'G',0.000037,NULL,'15.90',NULL,'Scd',NULL,NULL,NULL,NULL,1,105.987875,-49.06978,0.253,NULL,42445341439,663208459,10362632,15.9),(47573,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47573,36.27,0.2,179,12041,74.4,NULL,NULL,'AGC 470035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47574,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:20','1',NULL,NULL,47574,36.35,0.36,186,12041,NULL,NULL,'Malmquist cor.','AGC 470035',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47575,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47575,36.38,0.55,189,12042,70,NULL,NULL,'2MASX J07035803-4904502',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,105.99175,-49.08058,0.253,NULL,42445341350,663208458,10362632,15.7),(47576,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',47576,34.46,0.49,78.1,12043,75,NULL,'IR','UGC 03645',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.000173,NULL,'15.5',0.21,'Sbc',NULL,NULL,NULL,NULL,1,106.005,50.68017,0.289,NULL,63386274428,990410537,15475164,15.5),(47577,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47577,35.32,NULL,116,12043,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03645',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47578,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47578,35.33,NULL,116,12043,NULL,NULL,'Dipole + Quadrupole','UGC 03645',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47579,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47579,35.34,NULL,117,12043,NULL,NULL,'Dipole','UGC 03645',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47580,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47580,35.36,NULL,118,12043,NULL,NULL,NULL,'UGC 03645',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47581,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47581,35.86,0.61,148,12044,70,NULL,NULL,'2MASX J07040325-5344042',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,106.013625,-53.73444,0.293,NULL,40498350724,632786730,9887292,16.6),(47582,'IRAS','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47582,34.17,0.8,68.3,12045,75,NULL,'MAT, I','ESO 309- G 017',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000027,NULL,'14.60',0.3,'Sb? sp','Pair member (points to parent)',NULL,NULL,NULL,1,106.0202083,-41.87972,0.421,NULL,42458630201,663416096,10365876,14.6),(47583,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47583,34.41,0.47,76.3,12045,NULL,NULL,'H','ESO 309- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47584,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47584,34.42,0.43,76.5,12045,75,NULL,'MAT, I, raw','ESO 309- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47585,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47585,34.45,0.4,77.6,12045,NULL,NULL,'mean','ESO 309- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47586,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47586,34.45,0.45,77.7,12045,NULL,NULL,'K','ESO 309- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47587,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',47587,34.53,0.49,80.6,12045,75,NULL,'IR','ESO 309- G 017',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47588,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47588,34.54,0.32,80.9,12045,85,NULL,'I, raw','ESO 309- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47589,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47589,34.59,0.46,82.7,12045,NULL,NULL,'J','ESO 309- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47590,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47590,34.61,0.32,83.5,12045,85,NULL,'I, inv','ESO 309- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47591,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47591,34.7,0.43,87,12045,75,NULL,'MAT, I, inv','ESO 309- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47592,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47592,34.72,0.46,88.1,12045,NULL,NULL,'Malmquist cor.','ESO 309- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47593,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47593,34.78,0.45,90.3,12045,NULL,NULL,NULL,'ESO 309- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47594,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47594,34.82,0.2,92,12045,74.4,NULL,NULL,'ESO 309- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47595,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47595,34.87,0.43,94,12045,75,NULL,'MAT, I, cor','ESO 309- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47596,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47596,33.98,0.4,62.6,12046,NULL,NULL,'mean','UGC 03642',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00002,NULL,'13.3',1.1,'SA0^0^','in a pair',NULL,NULL,NULL,1,106.084583,64.02028,0.185,NULL,61645117922,963204967,15050077,13.3),(47597,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47597,34.29,0.45,72.1,12046,NULL,NULL,'K','UGC 03642',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47598,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47598,35.68,0.5,137,12047,70,NULL,NULL,'2MASX J07042302-4442285',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,106.095875,-44.70786,0.317,NULL,42434188463,663034194,10359909,14.9),(47599,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47599,36.61,0.58,209,12048,70,NULL,NULL,'2MASX J07042608-5544214',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,106.1085417,-55.73922,0.305,NULL,40488783171,632637237,9884956,15.4),(47600,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47600,35.12,0.55,106,12049,70,NULL,NULL,'2MASX J07043737-6011136',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000143,NULL,'15.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,106.1557917,-60.18711,0.501,NULL,40478638350,632478724,9882480,15.7),(47601,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47601,35.82,0.6,146,12050,70,NULL,NULL,'2MASX J07043819-7032002',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,106.159375,-70.53344,0.609,NULL,40608881209,634513768,9914277,16.5),(47602,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47602,36.14,0.63,169,12051,70,NULL,NULL,'2MASX J07043911-7023072',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,106.163125,-70.38533,0.613,NULL,40608986622,634515415,9914303,16.5),(47603,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47603,35.67,0.41,136,12052,NULL,NULL,'Malmquist cor.','ESO 088- G 002',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'15.83',0.6,'S...',NULL,NULL,NULL,NULL,1,106.1644583,-65.72686,0.433,NULL,40638764676,634980698,9921573,15.83),(47604,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47604,35.77,0.39,143,12052,NULL,NULL,NULL,'ESO 088- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47605,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47605,35.81,0.2,145,12052,74.4,NULL,NULL,'ESO 088- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47606,'Tully est','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47606,31.14,0.8,16.9,12053,75,NULL,'B','UGC 03658',NULL,'1988NBGC.C....0000T',1988,1,1.8,NULL,'G',0.000013,NULL,'17.',0.7,'Im:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,106.167083,17.58333,0.489,NULL,63335284065,989613813,15462715,17),(47607,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',47607,32.77,NULL,35.8,12053,NULL,NULL,NULL,'UGC 03658',NULL,'2015AstBu..70....1K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47608,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47608,31.73,0.4,22.2,12054,75,NULL,'B','UGC 03647',NULL,'1988NBGC.C....0000T',1988,1,1.4,NULL,'G',0.000003,NULL,'14.54',1,'IBm','Dwarf, possible member',NULL,NULL,NULL,1,106.21,56.52028,0.145,NULL,61738312759,964661136,15072830,14.54),(47609,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47609,36.36,0.85,187,12055,70,NULL,NULL,'2MASX J07045374-5335154',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,106.2239583,-53.58764,0.289,NULL,40484701008,632573453,9883960,15.9),(47610,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47610,37.36,0.66,296,12056,70,NULL,NULL,'2MASX J07045789-5417585',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,106.241083,-54.29961,0.297,NULL,40498540864,632789701,9887339,14.3),(47611,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47611,36.2,0.53,174,12057,70,NULL,NULL,'2MASX J07045855-4921365',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.3,NULL,NULL,NULL,NULL,NULL,1,106.2440417,-49.36025,0.205,NULL,42443527426,663180116,10362189,14),(47612,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47612,36.22,0.21,175,12058,70,NULL,'ABELL 3407, BGC','ESO 207- G 019',NULL,'1999AJ....118.1489D',1999,1,1,NULL,'G',0.000474,NULL,'14.31',0.9,'S0',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,106.246875,-49.08319,0.197,NULL,42445364143,663208814,10362637,14.31),(47613,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47613,36.22,0.21,175,12059,70,NULL,NULL,'ABELL 3407',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I      [BM];RI [A]',NULL,NULL,NULL,NULL,1,106.257375,-49.07717,0.197,NULL,42445364082,663208813,10362637,NULL),(47614,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47614,34.92,0.66,96.5,12060,NULL,NULL,NULL,'ESO 256- G 015',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.98',0.4,'Sb:',NULL,NULL,NULL,NULL,1,106.298167,-47.17397,0.193,NULL,42436455549,663069617,10360462,15.98),(47615,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47615,34.96,0.2,98.2,12060,74.4,NULL,NULL,'ESO 256- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47616,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47616,35.16,0.59,108,12060,NULL,NULL,'Malmquist cor.','ESO 256- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47617,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47617,36.12,0.57,167,12061,70,NULL,NULL,'2MFGC 05621',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'11.9K',NULL,NULL,NULL,NULL,NULL,NULL,1,106.303666667,-69.39556,0.621,NULL,40606281616,634473150,9913642,11.9),(47618,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47618,36.14,0.69,169,12062,70,NULL,NULL,'ESO 207- G 020',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'15.76',1.1,'(R)SB(r)a',NULL,NULL,NULL,NULL,1,106.304917,-49.22214,0.197,NULL,42443477810,663179340,10362177,15.76),(47619,'CMD','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47619,27.39,0.62,3,12063,NULL,NULL,NULL,'Argo Dwarf Irregular',NULL,'2002ApJS..141..123W',2002,1,3.5,NULL,'G',0.000007,NULL,'14.2',1.7,'SB(s)m',NULL,NULL,NULL,NULL,1,106.328333,-58.52028,0.341,0,40530465981,633288530,9895133,14.2),(47620,'TRGB','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47620,28.45,NULL,4.9,12063,NULL,NULL,NULL,'Argo Dwarf Irregular',NULL,'2003A&A...398..479K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47621,'TRGB','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47621,28.62,0.1,5.29,12063,74.4,NULL,NULL,'Argo Dwarf Irregular',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47622,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',47622,34.42,0.49,76.5,12064,75,NULL,'IR','UGC 03648',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.00016,NULL,'15.37',0.3,'Sbc','Group member',NULL,NULL,NULL,1,106.348625,64.09239,0.185,NULL,61646990190,963234221,15050534,15.37),(47623,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47623,35.42,0.67,121,12065,70,NULL,NULL,'2MASX J07052749-6957051',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,106.364375,-69.9515,0.617,NULL,40606832033,634481750,9913777,15.6),(47624,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47624,36.49,0.53,198,12066,70,NULL,NULL,'2MASX J07052899-4907405',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,106.370917,-49.12794,0.197,NULL,42445319078,663208110,10362626,16.2),(47625,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47625,35.75,0.6,142,12067,70,NULL,NULL,'2MASX J07052945-6601481',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,106.372791667,-66.03003,0.433,NULL,40638720318,634980004,9921562,15.5),(47626,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47626,36.71,0.62,220,12068,70,NULL,NULL,'2MASX J07052988-7500223',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,106.3742917,-75.00628,0.921,NULL,39928737063,623886516,9748226,16.8),(47627,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2000B',NULL,47627,33.57,0.25,50.8,12069,74.2,NULL,'SALT 2','NGC 2320',0.01983,'2010ApJ...716..712A',2010,1,1.4,NULL,'G',0.00005,NULL,'12.9',0.8,'E',NULL,NULL,NULL,NULL,1,106.425125,50.58106,0.301,NULL,63386175286,990408988,15475140,12.9),(47628,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2000B',NULL,47628,34.25,0.09,70.8,12069,74.4,NULL,NULL,'NGC 2320',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47629,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2000B',NULL,47629,34.47,0.04,76.8,12069,72,NULL,NULL,'NGC 2320',0.01983,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47630,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2000B',NULL,47630,34.49,0.14,77.5,12069,70,NULL,'SALT','NGC 2320',0.01983,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47631,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2000B',NULL,47631,34.63,0.22,81,12069,65,NULL,'MLCS2k2','NGC 2320',0.01983,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47632,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2000B',NULL,47632,34.59,0.23,81.2,12069,65,NULL,NULL,'NGC 2320',0.01983,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47633,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2000B',NULL,47633,34.58,0.12,82.4,12069,70.8,NULL,NULL,'NGC 2320',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47634,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2000B',NULL,47634,34.82,0.14,92,12069,60,NULL,NULL,'NGC 2320',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47635,'D-Sigma','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47635,34.53,0.4,80.7,12069,75,NULL,'Edat, raw','NGC 2320',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47636,'D-Sigma','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47636,34.74,0.4,88.5,12069,75,NULL,'Edat, cor','NGC 2320',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47637,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47637,34.33,0.45,73.4,12069,NULL,NULL,'K','NGC 2320',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47638,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47638,34.63,0.4,84.2,12069,NULL,NULL,'mean','NGC 2320',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47639,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47639,35.08,0.52,104,12070,NULL,NULL,NULL,'ESO 309- G 018',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.36',0.5,'Sc',NULL,NULL,NULL,NULL,1,106.474916667,-37.8745,0.793,NULL,42632748314,666136692,10408385,15.36),(47640,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47640,35.12,0.2,106,12070,74.4,NULL,NULL,'ESO 309- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47641,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47641,35.18,0.5,108,12070,NULL,NULL,'Malmquist cor.','ESO 309- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47642,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47642,34.77,0.47,89.9,12071,NULL,NULL,'H','NGC 2321',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000043,NULL,'14.50',1.1,'SBa',NULL,NULL,NULL,NULL,1,106.495833,50.75603,0.289,NULL,63386094708,990407729,15475120,14.5),(47643,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47643,34.77,0.4,90,12071,NULL,NULL,'mean','NGC 2321',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47644,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47644,34.82,0.45,92.2,12071,NULL,NULL,'K','NGC 2321',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47645,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47645,34.9,0.46,95.5,12071,NULL,NULL,'J','NGC 2321',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47646,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47646,36.52,0.89,201,12072,70,NULL,NULL,'2MASX J07060464-5449113',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,106.519375,-54.81978,0.349,NULL,40499477136,632804330,9887567,15.5),(47647,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47647,36.35,0.74,186,12073,70,NULL,NULL,'2MASX J07061339-3737471',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,106.555708333,-37.62983,0.817,NULL,42634656486,666166507,10408851,15.7),(47648,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47648,33.08,0.47,41.3,12074,NULL,NULL,'H','UGC 03660',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000037,NULL,'13.62',0.9,'SABa:','in a pair',NULL,NULL,NULL,1,106.645,63.84889,0.177,NULL,61645048670,963203885,15050060,13.62),(47649,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47649,33.14,0.45,42.5,12074,NULL,NULL,'K','UGC 03660',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47650,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47650,33.19,0.46,43.4,12074,NULL,NULL,'J','UGC 03660',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47651,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47651,33.91,0.4,60.5,12074,NULL,NULL,'mean','UGC 03660',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47652,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47652,35.05,0.25,102,12075,74.4,NULL,NULL,'CGCG 234-053',NULL,'2013AJ....146...86T',2013,1,0.35,NULL,'G',0.000042,NULL,'15.1',0.25,'S0:',NULL,NULL,NULL,NULL,1,106.667458333,48.49053,0.337,NULL,63398303394,990598490,15478101,15.1),(47653,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47653,35.67,0.42,136,12076,NULL,NULL,NULL,'2MASX J07065094-4904095',NULL,'2009ApJS..182..474S',2009,1,0.68,NULL,'G',0.000027,NULL,'14.47',NULL,'Sc',NULL,NULL,NULL,NULL,1,106.7122917,-49.06928,0.197,NULL,42444843087,663200673,10362510,14.47),(47654,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47654,35.71,0.2,139,12076,74.4,NULL,NULL,'2MASX J07065094-4904095',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47655,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47655,35.8,0.4,144,12076,NULL,NULL,'Malmquist cor.','2MASX J07065094-4904095',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47656,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47656,35.86,0.61,148,12077,70,NULL,NULL,'2MASX J07065247-6530353',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,106.7185,-65.50986,0.429,NULL,40639203661,634987557,9921680,16.1),(47657,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47657,35.06,0.5,103,12078,70,NULL,NULL,'2MASX J07065593-6109173',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'15.2b',0.8,'SAB(s)0-',NULL,NULL,NULL,NULL,1,106.732917,-61.15492,0.457,NULL,40476846730,632450730,9882042,15.2),(47658,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47658,29.62,NULL,8.39,12079,NULL,NULL,NULL,'ESO 558-PN?011',NULL,'2013AJ....145..101K',2013,1,1.8,NULL,'G',0.000026,NULL,'14.4B',1,'IB(s)m',NULL,NULL,NULL,NULL,1,106.736667,-22.04056,NULL,NULL,39507572138,617305814,9645403,14.4),(47659,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47659,35.65,0.59,135,12080,70,NULL,NULL,'2MASX J07070168-6703399',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,106.757125,-67.06117,0.677,NULL,40655779866,635246560,9925727,16.6),(47660,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',47660,35.72,0.49,139,12081,75,NULL,'IR','ESO 207- G 021',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.00003,NULL,'15.45',0.1,'Sbc',NULL,NULL,NULL,NULL,1,106.769541667,-49.17681,0.197,NULL,42430899792,662982809,10359106,15.45),(47661,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47661,36.19,0.35,173,12081,NULL,NULL,'Malmquist cor.','ESO 207- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47662,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47662,36.44,0.31,194,12081,NULL,NULL,NULL,'ESO 207- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47663,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47663,36.48,0.2,198,12081,74.4,NULL,NULL,'ESO 207- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47664,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47664,34.17,NULL,68.4,12082,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0598',NULL,'2010Ap&SS.325..163P',2010,1,0.95,NULL,'G',0.000067,'?','16.77',0.11,'Sd',NULL,NULL,NULL,NULL,1,106.775,44.66278,0.381,NULL,63393703132,990526611,15476978,16.77),(47665,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47665,34.18,NULL,68.7,12082,NULL,NULL,'Dipole + Quadrupole','FGC 0598',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47666,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47666,34.19,NULL,68.7,12082,NULL,NULL,'Dipole','FGC 0598',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47667,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47667,34.21,NULL,69.5,12082,NULL,NULL,NULL,'FGC 0598',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47668,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47668,34.86,0.5,93.7,12083,70,NULL,NULL,'2MASX J07070979-4643297',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,106.79075,-46.72489,0.249,NULL,42436586111,663071657,10360494,16),(47669,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',47669,35.14,0.49,107,12084,75,NULL,'IR','UGC 03682',NULL,'2011yCatp016004901K',2011,1,0.95,NULL,'G',0.00002,NULL,'17.',0.08,'Sd',NULL,NULL,NULL,NULL,1,106.8025,14.17931,NULL,NULL,63345145868,989767904,15465123,17),(47670,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47670,35.41,NULL,121,12084,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03682',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47671,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47671,35.42,NULL,121,12084,NULL,NULL,'Dipole + Quadrupole','UGC 03682',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47672,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47672,35.43,NULL,122,12084,NULL,NULL,'Dipole','UGC 03682',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47673,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47673,35.52,NULL,127,12084,NULL,NULL,NULL,'UGC 03682',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47674,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47674,35.19,0.41,109,12085,NULL,NULL,NULL,'ESO 122- G 013',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.24',0.5,'S...',NULL,NULL,NULL,NULL,1,106.8472917,-58.39403,0.469,NULL,40530548933,633289827,9895153,16.24),(47675,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47675,35.23,0.2,111,12085,74.4,NULL,NULL,'ESO 122- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47676,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47676,35.39,0.37,119,12085,NULL,NULL,'Malmquist cor.','ESO 122- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47677,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47677,33.07,NULL,41.1,12086,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03657',NULL,'2010Ap&SS.325..163P',2010,1,0.93,NULL,'G',NULL,NULL,'16.5',0.11,'Scd',NULL,NULL,NULL,NULL,1,106.8502917,71.19239,0.249,NULL,62152190967,971127983,15173874,16.5),(47678,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47678,33.1,NULL,41.7,12086,NULL,NULL,'Dipole + Quadrupole','UGC 03657',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47679,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47679,33.12,NULL,42.1,12086,NULL,NULL,'Dipole','UGC 03657',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47680,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47680,33.18,NULL,43.3,12086,NULL,NULL,NULL,'UGC 03657',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47681,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47681,32.29,0.39,28.7,12087,73,NULL,'IR','ESO 427- G 034',NULL,'2011A&A...532A.104N',2011,1,1.9,'abs(b) < 10 degrees.','G',0.00001,NULL,'14.42',1.2,'SB(s)dm',NULL,NULL,NULL,NULL,1,106.8565,-28.22644,NULL,NULL,39043418554,610053414,9532084,14.42),(47682,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47682,32.29,0.39,28.7,12087,73,NULL,'opt','ESO 427- G 034',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47683,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',47683,32.29,0.4,28.7,12087,75,NULL,NULL,'ESO 427- G 034',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47684,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',47684,33.29,0.49,45.5,12087,75,NULL,'IR','ESO 427- G 034',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47685,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47685,35.92,0.51,153,12088,70,NULL,NULL,'2MASX J07072586-4912507',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.5,NULL,NULL,NULL,NULL,NULL,1,106.8577917,-49.21408,0.197,NULL,42430901155,662982830,10359106,13.9),(47686,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47686,34.78,0.4,90.3,12089,NULL,NULL,'mean','UGC 03679',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000023,NULL,'15.20',0.7,'Sa','in a triple',NULL,NULL,NULL,1,106.867125,44.78992,0.413,NULL,63393699407,990526553,15476977,15.2),(47687,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47687,35.14,0.45,107,12089,NULL,NULL,'K','UGC 03679',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47688,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47688,35.26,0.47,113,12089,NULL,NULL,'H','UGC 03679',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47689,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47689,35.44,0.46,122,12089,NULL,NULL,'J','UGC 03679',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47690,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47690,34.64,0.09,84.9,12090,NULL,NULL,NULL,'CGCG 234-056',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000023,NULL,'14.8',0.4,'Sb pec',NULL,NULL,NULL,NULL,1,106.884833,48.90011,0.317,NULL,63398258604,990597790,15478090,14.8),(47691,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47691,36.11,0.58,166,12091,70,NULL,NULL,'2MASX J07073521-4843136',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,106.896667,-48.72047,0.197,NULL,42445036541,663203695,10362557,16.4),(47692,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47692,35.44,0.4,122,12092,NULL,NULL,'mean','UGC 03688',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000033,NULL,'15.25',0.4,'Sb',NULL,NULL,NULL,NULL,1,106.978083,13.08756,NULL,NULL,63342932675,989733323,15464583,15.25),(47693,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47693,35.55,0.47,129,12092,NULL,NULL,'H','UGC 03688',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47694,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47694,34.5,0.25,79.4,12093,74.4,NULL,NULL,'CGCG 234-059',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000033,NULL,'14.47',0.9,'S?','Group member',NULL,NULL,NULL,1,106.998333,48.66631,0.337,NULL,63398416396,990600256,15478129,14.47),(47695,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47695,35.83,0.57,146,12094,70,NULL,NULL,'2MASX J07075982-6627179',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,106.999083,-66.455,0.557,NULL,40656294249,635254597,9925853,16.5),(47696,'IRAS','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47696,32.52,0.8,32,12095,75,NULL,'A82, H','UGC 03691',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000017,NULL,'12.6',1.1,'SAcd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,107.005333,15.17842,0.625,NULL,63348181324,989815333,15465864,12.6),(47697,'Sosies','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47697,32.45,0.13,30.9,12095,NULL,NULL,NULL,'UGC 03691',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47698,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47698,31.72,0.69,22,12095,100,NULL,'mid-IR','UGC 03691',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47699,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47699,32.13,0.4,26.7,12095,NULL,NULL,'Virgo cluster at 15.6 Mpc','UGC 03691',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47700,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47700,32.14,0.43,26.8,12095,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03691',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47701,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47701,32.18,0.43,27.3,12095,75,NULL,'3.6 micron, color corrected','UGC 03691',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47702,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47702,32.22,0.2,27.8,12095,74.4,NULL,NULL,'UGC 03691',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47703,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47703,32.39,0.4,30,12095,75,NULL,'B','UGC 03691',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47704,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47704,32.69,0.47,34.5,12095,75,NULL,'A82, H, raw','UGC 03691',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47705,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47705,32.7,0.47,34.7,12095,75,NULL,'A82, H, inv','UGC 03691',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47706,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47706,32.81,0.4,36.5,12095,NULL,NULL,'mean','UGC 03691',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47707,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47707,33.05,0.47,40.7,12095,75,NULL,'A82, H, cor','UGC 03691',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47708,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47708,33.2,0.47,43.6,12095,NULL,NULL,'H','UGC 03691',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47709,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47709,33.23,0.46,44.2,12095,NULL,NULL,'J','UGC 03691',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47710,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47710,33.42,0.45,48.3,12095,NULL,NULL,'K','UGC 03691',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47711,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47711,34.71,0.4,87.4,12096,NULL,NULL,'mean','UGC 03683',NULL,'2007A&A...465...71T',2007,1,2,NULL,'G',0.000067,NULL,'13.76',1.3,'S0',NULL,NULL,NULL,NULL,1,107.0582083,46.11586,0.373,NULL,63396499195,990570299,15477660,13.76),(47712,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47712,34.99,0.45,99.4,12096,NULL,NULL,'K','UGC 03683',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47713,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47713,36.48,0.63,198,12097,70,NULL,NULL,'2MASX J07081507-5243325',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.5I',0.5,NULL,NULL,NULL,NULL,NULL,1,107.0627083,-52.72564,0.341,NULL,40301472145,629710502,9839226,13.5),(47714,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47714,35.96,0.52,156,12098,70,NULL,NULL,'2MASX J07081676-4911445',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.5,NULL,NULL,NULL,NULL,NULL,1,107.0697917,-49.19572,0.197,NULL,42430942842,662983481,10359116,13.9),(47715,'Sosies','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47715,32.46,0.23,31,12099,NULL,NULL,NULL,'NGC 2339',NULL,'2002A&A...393...57T',2002,1,2.7,NULL,'G',0.000017,NULL,'12.51',2,'SAB(rs)bc      AGN','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,107.085583333,18.78025,0.569,NULL,63329569225,989524519,15461320,12.51),(47716,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47716,32.16,NULL,27,12099,75,NULL,'CO','NGC 2339',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47717,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47717,32.26,NULL,28.3,12099,75,NULL,'HI','NGC 2339',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47718,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47718,32.43,0.45,30.6,12099,NULL,NULL,'K','NGC 2339',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47719,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47719,32.45,0.47,30.8,12099,NULL,NULL,'H','NGC 2339',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47720,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47720,32.45,0.4,30.9,12099,75,NULL,'B','NGC 2339',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47721,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47721,32.46,0.43,31.1,12099,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2339',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47722,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47722,32.52,0.46,32,12099,NULL,NULL,'J','NGC 2339',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47723,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47723,32.55,0.4,32.4,12099,NULL,NULL,'mean','NGC 2339',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47724,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47724,32.58,0.55,32.8,12099,NULL,NULL,'Malmquist cor.','NGC 2339',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47725,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47725,32.59,0.43,33,12099,75,NULL,'3.6 micron, color corrected','NGC 2339',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47726,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47726,32.82,0.2,36.6,12099,74.4,NULL,NULL,'NGC 2339',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47727,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47727,32.89,0.4,37.8,12099,NULL,NULL,NULL,'NGC 2339',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47728,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47728,33.08,0.43,41.4,12099,NULL,NULL,NULL,'NGC 2339',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47729,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47729,34.33,0.4,73.4,12100,NULL,NULL,'mean','NGC 2333',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000033,NULL,'14.17',0.7,'Sa',NULL,NULL,NULL,NULL,1,107.088917,35.17003,0.597,NULL,63454966373,991483849,15491935,14.17),(47730,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47730,34.35,0.47,74.2,12100,NULL,NULL,'H','NGC 2333',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47731,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47731,34.36,0.45,74.4,12100,NULL,NULL,'K','NGC 2333',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47732,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47732,34.4,0.46,76,12100,NULL,NULL,'J','NGC 2333',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47733,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',47733,36.73,0.49,222,12101,75,NULL,'IR','2MFGC 05660',NULL,'2011yCatp016004901K',2011,1,0.39,NULL,'G',0.00003,NULL,'16.53',NULL,'Sab:',NULL,NULL,NULL,NULL,1,107.096083,-49.43878,0.197,NULL,42432772281,663012066,10359563,16.53),(47734,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47734,37.27,0.59,285,12101,NULL,NULL,'Malmquist cor.','2MFGC 05660',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47735,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47735,37.53,0.52,321,12101,NULL,NULL,NULL,'2MFGC 05660',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47736,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47736,34.81,0.25,91.6,12102,74.4,NULL,NULL,'CGCG 234-064',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000017,NULL,'15.5',0.4,NULL,NULL,NULL,NULL,NULL,1,107.10075,50.13658,0.277,NULL,63387652355,990432068,15475501,15.5),(47737,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47737,34.69,0.08,86.9,12103,NULL,NULL,NULL,'MCG +08-13-066',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000023,NULL,'16',0.3,'Sbc',NULL,NULL,NULL,NULL,1,107.1097083,48.99717,0.317,NULL,63387173379,990424584,15475384,16),(47738,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47738,35.72,0.64,139,12104,70,NULL,NULL,'2MASX J07082715-6127561',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.7I',0.5,NULL,NULL,NULL,NULL,NULL,1,107.1132083,-61.46558,0.473,NULL,40355951308,630561739,9852527,13.7),(47739,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47739,34.93,0.51,96.7,12105,NULL,NULL,'Malmquist cor.','UGC 03694',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'14.60',0.8,'Sd',NULL,NULL,NULL,NULL,1,107.151417,32.68036,0.313,NULL,62967853345,983872708,15373011,14.6),(47740,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47740,35.05,0.49,102,12105,NULL,NULL,NULL,'UGC 03694',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47741,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47741,35.06,0.2,103,12105,74.4,NULL,NULL,'UGC 03694',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47742,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47742,34.46,0.08,78.1,12106,NULL,NULL,NULL,'2MASX J07084401+4818132',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000023,NULL,'15.61',NULL,'Scd',NULL,NULL,NULL,NULL,1,107.183375,48.30375,0.333,NULL,63398893070,990607704,15478245,15.61),(47743,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47743,37.21,0.53,277,12107,NULL,NULL,'Malmquist cor.','2MASX J07084710-4917296',NULL,'2009ApJS..182..474S',2009,1,0.53,NULL,'G',0.000037,NULL,'15.38',NULL,'Sc',NULL,NULL,NULL,NULL,1,107.196375,-49.29161,0.197,NULL,42430912904,662983014,10359109,15.38),(47744,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47744,37.47,0.47,312,12107,NULL,NULL,NULL,'2MASX J07084710-4917296',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47745,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47745,37.51,0.2,318,12107,74.4,NULL,NULL,'2MASX J07084710-4917296',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47746,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47746,34.69,0.08,86.9,12108,NULL,NULL,NULL,'CGCG 234-067',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000027,NULL,'15.1',0.35,'Sa:',NULL,NULL,NULL,NULL,1,107.19725,48.99472,0.317,NULL,63387174226,990424597,15475384,15.1),(47747,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47747,36.68,0.44,217,12109,NULL,NULL,'Malmquist cor.','2MASX J07085102+4841202',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000023,NULL,'14.42',NULL,'Sb',NULL,NULL,NULL,NULL,1,107.212625,48.68894,0.337,NULL,63398405532,990600086,15478126,14.42),(47748,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47748,36.95,0.39,246,12109,NULL,NULL,NULL,'2MASX J07085102+4841202',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47749,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47749,36.99,0.2,250,12109,74.4,NULL,NULL,'2MASX J07085102+4841202',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47750,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47750,34.42,0.25,76.6,12110,74.4,NULL,NULL,'CGCG 234-068',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000031,NULL,'15.1',0.35,'S0/a:','Group member',NULL,NULL,NULL,1,107.21975,48.45,0.333,NULL,63398896383,990607755,15478246,15.1),(47751,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47751,34.62,0.1,84.1,12111,NULL,NULL,NULL,'2MASX J07085345+4849532',NULL,'2009ApJS..182..474S',2009,1,0.78,NULL,'G',0.000023,NULL,'14.48',NULL,'Sb',NULL,NULL,NULL,NULL,1,107.22275,48.8315,0.337,NULL,63398372569,990599571,15478118,14.48),(47752,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',47752,35.59,0.49,131,12112,75,NULL,'IR','2MFGC 05666',NULL,'2011yCatp016004901K',2011,1,0.4,NULL,'G',0.000037,NULL,'12.1K',0.1,'S',NULL,NULL,NULL,NULL,1,107.2272917,2.53967,NULL,NULL,62354663215,974291612,15223306,12.1),(47753,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47753,34.68,0.11,86.5,12113,NULL,NULL,NULL,'2MASX J07085858+4832432',NULL,'2009ApJS..182..474S',2009,1,0.42,NULL,'G',0.000023,NULL,'15.88',NULL,'Sc',NULL,NULL,NULL,NULL,1,107.244083333,48.54531,0.333,NULL,63398400461,990600007,15478125,15.88),(47754,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47754,34.6,0.08,83.3,12114,NULL,NULL,NULL,'CGCG 234-069',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000023,NULL,'15.6',0.4,'Sc','Group member',NULL,NULL,NULL,1,107.264833,48.57344,0.333,NULL,63398401597,990600024,15478125,15.6),(47755,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47755,32.23,0.4,27.9,12115,75,NULL,'B','UGC 03685',NULL,'1988NBGC.C....0000T',1988,1,3.3,NULL,'G',0.000013,NULL,'12.80',2.8,'SB(rs)b','in a pair',NULL,NULL,NULL,1,107.27475,61.59556,0.305,NULL,61649836322,963278692,15051229,12.8),(47756,'D-Sigma','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47756,34.53,0.4,80.7,12116,75,NULL,'Edat, raw','NGC 2329',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000039,NULL,'13.48',1.1,'S0-:','in a pair',NULL,NULL,NULL,1,107.283375,48.61542,0.337,NULL,63398401059,990600016,15478125,13.48),(47757,'D-Sigma','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47757,34.74,0.4,88.5,12116,75,NULL,'Edat, cor','NGC 2329',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47758,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47758,34.23,0.25,70.2,12116,74.4,NULL,NULL,'NGC 2329',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47759,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47759,34.61,0.1,83.4,12116,70,NULL,'ABELL 0569, BGC','NGC 2329',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47760,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47760,34.66,0.45,85.5,12116,NULL,NULL,'K','NGC 2329',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47761,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47761,34.69,0.4,86.6,12116,NULL,NULL,'mean','NGC 2329',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47762,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47762,34.61,0.1,83.4,12117,70,NULL,NULL,'ABELL 0569',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II:    [BM]',NULL,NULL,NULL,NULL,1,107.293417,48.61944,0.337,NULL,63398357055,990599328,15478114,NULL),(47763,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47763,34.69,0.08,86.9,12118,NULL,NULL,NULL,'2MASX J07091235+4843548',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000027,NULL,'15.80',NULL,'Sc',NULL,NULL,NULL,NULL,1,107.3015,48.73189,0.337,NULL,63398405109,990600079,15478126,15.8),(47764,'Brightest Stars','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47764,29.3,0.2,7.2,12119,NULL,NULL,NULL,'UGC 03698',NULL,'1998A&AS..133..181M',1998,1,1,NULL,'G',0.000001,NULL,'17.',0.6,'Im:','Group member',NULL,NULL,NULL,1,107.328125,44.38006,0.405,NULL,63392824614,990512884,15476763,17),(47765,'TRGB','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47765,30.25,0.2,11.2,12119,NULL,NULL,NULL,'UGC 03698',NULL,'2015ApJ...805..144K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47766,'TRGB','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47766,30.26,0.1,11.3,12119,74.4,NULL,NULL,'UGC 03698',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47767,'D-Sigma','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47767,34.53,0.4,80.7,12120,75,NULL,'Edat, raw','UGC 03696',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000022,NULL,'13.81',0.7,'E?','in a pair',NULL,NULL,NULL,1,107.346125,48.63553,0.337,NULL,63398359639,990599369,15478115,13.81),(47768,'D-Sigma','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47768,34.74,0.4,88.5,12120,75,NULL,'Edat, cor','UGC 03696',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47769,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47769,34.44,0.25,77.3,12120,74.4,NULL,NULL,'UGC 03696',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47770,'D-Sigma','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47770,34.53,0.4,80.7,12121,75,NULL,'Edat, raw','2MASXi J0709255+483801',NULL,'1997ApJS..109..333W',1997,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,107.356333,48.63367,0.337,NULL,63398359800,990599371,15478115,NULL),(47771,'D-Sigma','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47771,34.74,0.4,88.5,12121,75,NULL,'Edat, cor','2MASXi J0709255+483801',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47772,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47772,34.52,0.25,80.2,12122,74.4,NULL,NULL,'NGC 2330',NULL,'2013AJ....146...86T',2013,1,0.4,'Identification as NGC 2330 is uncertain; N2330 may be a star.','G',0.000014,NULL,'15.7',0.3,'E','Group member',NULL,NULL,NULL,1,107.368333,50.15253,0.277,NULL,63388349193,990442956,15475671,15.7),(47773,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47773,34.34,0.25,73.8,12123,74.4,NULL,NULL,'NGC 2332',NULL,'2013AJ....146...86T',2013,1,1.5,'Wegner et al. (2003AJ....126.2268W) give v = 4842 +/- 28 km/sec.','G',0.000025,NULL,'13.82',1,'S0:           blazar','Group member',NULL,NULL,'Flat-Spectrum Radio Source',1,107.392333,50.18228,0.277,NULL,63388341643,990442838,15475669,13.82),(47774,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47774,34.58,0.45,82.5,12123,NULL,NULL,'K','NGC 2332',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47775,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47775,34.64,0.4,84.5,12123,NULL,NULL,'mean','NGC 2332',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47776,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47776,32.37,0.43,29.8,12124,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J07093459-0525404',NULL,'2014MNRAS.444..527S',2014,1,2.1,'abs(b) < 10 degrees.','G',0.000013,NULL,NULL,1.5,'IAB(s)m:',NULL,NULL,NULL,NULL,1,107.394125,-5.42792,NULL,NULL,38797343593,606208493,9472007,NULL),(47777,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47777,32.45,0.2,30.9,12124,74.4,NULL,NULL,'2MASX J07093459-0525404',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47778,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47778,32.49,0.43,31.5,12124,75,NULL,'3.6 micron, color corrected','2MASX J07093459-0525404',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47779,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47779,34.25,0.25,70.8,12125,74.4,NULL,NULL,'CGCG 234-078',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000017,NULL,'14.95',0.8,'S0?','Group member',NULL,NULL,NULL,1,107.436875,48.69047,0.273,NULL,63387018396,990422162,15475346,14.95),(47780,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47780,34.68,0.08,86.5,12126,NULL,NULL,NULL,'2MASX J07094626+4855469',NULL,'2009ApJS..182..474S',2009,1,0.38,NULL,'G',0.000023,NULL,'15.30',NULL,'Sc',NULL,NULL,NULL,NULL,1,107.442791667,48.92969,0.289,NULL,63387061406,990422834,15475356,15.3),(47781,'Sosies','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47781,33.53,0.37,50.8,12127,NULL,NULL,NULL,'ESO 491- G 020',NULL,'2002A&A...393...57T',2002,1,1.3,NULL,'G',0.000024,NULL,'13.79',0.9,'SB(rs)b: pec   HII','Pair member (points to parent)',NULL,NULL,NULL,1,107.4504583,-27.57089,NULL,NULL,39055159290,610236863,9534950,13.79),(47782,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47782,34.5,NULL,79.3,12128,NULL,NULL,'Dipole','FGC 0603',NULL,'2010Ap&SS.325..163P',2010,1,0.9,NULL,'G',0.000013,NULL,'17.0',0.11,'Sc',NULL,NULL,NULL,NULL,1,107.455833,23.71667,0.285,NULL,63109423012,986084734,15407573,17),(47783,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47783,34.5,NULL,79.5,12128,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0603',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47784,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47784,34.52,NULL,80.3,12128,NULL,NULL,'Dipole + Quadrupole','FGC 0603',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47785,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47785,34.53,0.43,80.6,12128,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0603',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47786,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47786,34.72,NULL,87.9,12128,NULL,NULL,NULL,'FGC 0603',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47787,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47787,35.42,0.51,121,12129,70,NULL,NULL,'FAIRALL 1315',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.9B',0.42,NULL,NULL,NULL,NULL,NULL,1,107.518708333,-83.92683,0.529,NULL,39767887766,621373246,9708956,15.9),(47788,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47788,36.33,0.48,185,12130,NULL,NULL,NULL,'AGC 470056',NULL,'2009ApJS..182..474S',2009,1,0.26,NULL,'G',0.00003,NULL,'17.56',NULL,'Sc',NULL,NULL,NULL,NULL,1,107.535458333,-49.40894,0.305,NULL,42430998570,662984352,10359130,17.56),(47789,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47789,36.37,0.2,188,12130,74.4,NULL,NULL,'AGC 470056',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47790,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47790,36.46,0.45,196,12130,NULL,NULL,'Malmquist cor.','AGC 470056',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47791,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47791,35.98,0.61,157,12131,70,NULL,NULL,'2MASX J07101052-4930512',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000103,NULL,'13.8I',0.6,NULL,NULL,NULL,NULL,NULL,1,107.543917,-49.51417,0.305,NULL,42430993176,662984268,10359129,13.8),(47792,'Brightest Stars','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',47792,29,NULL,6.31,12132,NULL,NULL,NULL,'NGC 2337',NULL,'1999BlJPh..26...87G',1999,1,2.2,NULL,'G',0.000003,NULL,'12.95',1.7,'IBm','Group member',NULL,NULL,NULL,1,107.556583,44.45731,0.377,NULL,63573257271,993332144,15520814,12.95),(47793,'Brightest Stars','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47793,29.48,0.2,7.87,12132,NULL,NULL,NULL,'NGC 2337',NULL,'1998A&AS..133..181M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47794,'TRGB','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47794,30.26,0.11,11.3,12132,NULL,NULL,NULL,'NGC 2337',NULL,'2015ApJ...805..144K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47795,'TRGB','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47795,30.36,0.1,11.8,12132,74.4,NULL,NULL,'NGC 2337',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47796,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47796,29.58,0.4,8.2,12132,75,NULL,'B','NGC 2337',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47797,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47797,34.99,0.65,99.6,12133,NULL,NULL,NULL,'AGC 470058',NULL,'2009ApJS..182..474S',2009,1,0.88,NULL,'G',0.000027,NULL,'15.68',NULL,'Sc',NULL,NULL,NULL,NULL,1,107.582625,-49.56083,0.305,NULL,42432913645,663014275,10359598,15.68),(47798,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47798,35.33,0.56,117,12133,NULL,NULL,'Malmquist cor.','AGC 470058',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47799,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',47799,33.48,0.49,49.6,12134,75,NULL,'IR','UGC 03675',NULL,'2011yCatp016004901K',2011,1,1.81,NULL,'G',0.000023,NULL,'15.49',0.22,'Sbc',NULL,NULL,NULL,NULL,1,107.600417,74.89106,0.209,NULL,61334835642,958356806,14974325,15.49),(47800,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47800,33.91,0.43,60.5,12134,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03675',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47801,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47801,34,0.43,63.1,12134,75,NULL,'3.6 micron, color corrected','UGC 03675',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47802,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47802,34.09,0.2,65.8,12134,74.4,NULL,NULL,'UGC 03675',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47803,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47803,34.11,0.32,66.5,12134,NULL,NULL,'Malmquist cor.','UGC 03675',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47804,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47804,34.16,0.31,68,12134,NULL,NULL,NULL,'UGC 03675',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47805,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47805,34.18,NULL,68.5,12134,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03675',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47806,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47806,34.19,NULL,68.8,12134,NULL,NULL,'Dipole + Quadrupole','UGC 03675',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47807,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47807,34.19,NULL,68.9,12134,NULL,NULL,'Dipole','UGC 03675',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47808,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47808,34.24,NULL,70.6,12134,NULL,NULL,NULL,'UGC 03675',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47809,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47809,35.65,NULL,135,12135,NULL,NULL,NULL,'UGC 03718 NOTES01',NULL,'2000BSAO...50....5K',2000,1,0.91,NULL,'G',0.00005,'?','16.8',0.1,'Sd',NULL,NULL,NULL,NULL,1,107.603667,39.70656,0.265,NULL,63599892309,993748317,15527317,16.8),(47810,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47810,35.66,NULL,135,12135,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03718 NOTES01',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47811,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47811,35.67,NULL,136,12135,NULL,NULL,'Dipole + Quadrupole','UGC 03718 NOTES01',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47812,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47812,35.67,NULL,136,12135,NULL,NULL,'Dipole','UGC 03718 NOTES01',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47813,'BL Lac Luminosity','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47813,38.88,NULL,531,12136,NULL,NULL,NULL,'2MASX J07103005+5908202',0.125,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',NULL,NULL,'18.4',NULL,'BLLAC',NULL,NULL,NULL,'BL Lac',1,107.6252917,59.139,0.205,NULL,61678342749,963724105,15058189,18.4),(47814,'GeV TeV ratio','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',47814,39.47,0.48,784,12136,72,NULL,NULL,'2MASX J07103005+5908202',NULL,'2011arXiv1111.0913P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47815,'D-Sigma','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47815,33.71,0.4,55.1,12137,75,NULL,'Edat, raw','NGC 2314',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'13.18',1.4,'E3','in a pair',NULL,NULL,NULL,1,107.635625,75.32667,0.209,NULL,61323934138,958186470,14971663,13.18),(47816,'D-Sigma','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47816,34.04,0.4,64.3,12137,75,NULL,'Edat, cor','NGC 2314',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47817,'Faber-Jackson','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47817,32.54,0.63,32.2,12137,95,NULL,'Michard 1979b, c','NGC 2314',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47818,'Faber-Jackson','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47818,32.81,0.46,36.5,12137,95,NULL,'Michard 1979a','NGC 2314',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47819,'Faber-Jackson','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47819,33.05,0.29,40.7,12137,95,NULL,'Weighted Mean','NGC 2314',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47820,'Faber-Jackson','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47820,33.58,0.38,52,12137,95,NULL,'de Vaucouleurs','NGC 2314',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47821,'Tertiary','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47821,32.7,0.29,34.7,12137,95,NULL,NULL,'NGC 2314',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47822,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47822,33.73,0.4,55.7,12137,NULL,NULL,'mean','NGC 2314',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47823,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47823,34.26,0.45,71.1,12137,NULL,NULL,'K','NGC 2314',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47824,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47824,35.72,NULL,139,12138,NULL,NULL,NULL,'FGC 0606',NULL,'2000BSAO...50....5K',2000,1,1.15,NULL,'G',NULL,NULL,'16.88',0.1,'Scd',NULL,NULL,NULL,NULL,1,107.638291667,38.08897,0.289,NULL,63588283867,993566935,15524483,16.88),(47825,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',47825,36.29,0.49,181,12138,75,NULL,'IR','FGC 0606',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47826,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47826,34.09,0.25,65.8,12139,74.4,NULL,NULL,'IC 0458',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000019,NULL,'14.49',0.4,'S0-:','Group member',NULL,NULL,NULL,1,107.6422917,50.11892,0.277,NULL,63388456374,990444630,15475697,14.49),(47827,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47827,34.78,0.4,90.2,12139,NULL,NULL,'mean','IC 0458',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47828,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47828,34.97,0.45,98.8,12139,NULL,NULL,'K','IC 0458',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47829,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47829,32.81,0.45,36.4,12140,NULL,NULL,'K','UGC 03723',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000017,NULL,'14.12',0.9,'SB0',NULL,NULL,NULL,NULL,1,107.675417,34.421,0.565,NULL,63455443323,991491301,15492051,14.12),(47830,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47830,34.35,0.4,74.1,12140,NULL,NULL,'mean','UGC 03723',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47831,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47831,35.38,0.51,119,12141,70,NULL,NULL,'2MASX J07104330-4910184',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,107.680417,-49.17178,0.313,NULL,42430973686,662983963,10359124,16.5),(47832,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',47832,34.16,0.49,67.8,12142,75,NULL,'IR','MCG +08-13-093',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.000023,NULL,'15.5',0.3,'Sc',NULL,NULL,NULL,NULL,1,107.699041667,48.22386,0.313,NULL,63398072260,990594879,15478044,15.5),(47833,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47833,34.68,0.13,86.5,12142,NULL,NULL,NULL,'MCG +08-13-093',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47834,'IRAS','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47834,33.75,0.8,56.3,12143,75,NULL,'MAT, I','ESO 310- G 002',NULL,'1997ApJS..109..333W',1997,1,2.3,'Mathewson et al. (1992, ApJS, 81, 413) give v = 4114 +/- 10 km/sec.','G',0.000023,NULL,'15.67',0.5,'Sc:',NULL,NULL,NULL,NULL,1,107.7024583,-38.21867,0.897,NULL,42646124926,666345701,10411651,15.67),(47835,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',47835,34.34,0.49,73.8,12143,75,NULL,'IR','ESO 310- G 002',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47836,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47836,34.64,0.47,84.8,12143,NULL,NULL,'H','ESO 310- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47837,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47837,34.66,0.4,85.7,12143,NULL,NULL,'mean','ESO 310- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47838,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47838,34.7,0.45,86.9,12143,NULL,NULL,'K','ESO 310- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47839,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47839,34.73,0.2,88.3,12143,74.4,NULL,NULL,'ESO 310- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47840,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47840,34.85,0.46,93.3,12143,NULL,NULL,'J','ESO 310- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47841,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47841,34.87,0.43,94.3,12143,75,NULL,'MAT, I, raw','ESO 310- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47842,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47842,34.98,0.32,99.1,12143,85,NULL,'I, raw','ESO 310- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47843,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47843,35.05,0.32,102,12143,85,NULL,'I, inv','ESO 310- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47844,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47844,35.16,0.43,108,12143,75,NULL,'MAT, I, inv','ESO 310- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47845,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47845,35.25,0.43,112,12143,75,NULL,'MAT, I, cor','ESO 310- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47846,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47846,35.24,0.47,112,12144,70,NULL,NULL,'2MASX J07104907-6751363',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000107,NULL,'15.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,107.704416667,-67.86019,0.605,NULL,40657230769,635269230,9926081,15.7),(47847,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47847,34.3,0.59,72.5,12145,70,NULL,NULL,'ESO 207- G 025',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00012,NULL,'14.65',0.7,'(R\'_1)SB(r)0/a',NULL,NULL,NULL,NULL,1,107.718,-51.80675,0.337,NULL,40299242382,629675662,9838682,14.65),(47848,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47848,34.18,0.25,68.6,12146,74.4,NULL,NULL,'IC 0462',NULL,'2013AJ....146...86T',2013,1,NULL,'IC 0462 is a Galactic star 13 arcsec southeast of 2MASX J07105477+5010569.','*',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,107.732541667,50.18083,0.277,NULL,63388511232,990445488,15475710,NULL),(47849,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47849,34.69,0.1,86.9,12147,NULL,NULL,NULL,'CGCG 234-090',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000027,NULL,'15.2',0.25,'Sbc',NULL,NULL,NULL,NULL,1,107.742833,49.02269,0.289,NULL,63387305644,990426650,15475416,15.2),(47850,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47850,36.04,0.85,162,12148,70,NULL,NULL,'2MASX J07110294-5336225',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,107.76225,-53.60622,0.377,NULL,40484828885,632575451,9883991,15.3),(47851,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47851,35.95,0.57,155,12149,70,NULL,NULL,'2MASX J07110565-4744517',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,107.773666667,-47.74769,0.265,NULL,42444360331,663193130,10362392,14.6),(47852,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47852,34.94,0.47,97.2,12150,NULL,NULL,'H','UGC 03726',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000007,NULL,'14.8',0.4,'S?',NULL,NULL,NULL,NULL,1,107.779333,25.9155,0.341,NULL,62987530614,984180165,15377815,14.8),(47853,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47853,34.98,0.45,99,12150,NULL,NULL,'K','UGC 03726',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47854,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47854,35.02,0.46,101,12150,NULL,NULL,'J','UGC 03726',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47855,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47855,35.14,0.4,107,12150,NULL,NULL,'mean','UGC 03726',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47856,'D-Sigma','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47856,34.53,0.4,80.7,12151,75,NULL,'Edat, raw','NGC 2340',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000025,NULL,'12.7',1.2,'E','Group member',NULL,NULL,NULL,1,107.795125,50.17475,0.277,NULL,63388510075,990445469,15475710,12.7),(47857,'D-Sigma','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47857,34.74,0.4,88.5,12151,75,NULL,'Edat, cor','NGC 2340',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47858,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47858,34.52,0.25,80.2,12151,74.4,NULL,NULL,'NGC 2340',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47859,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47859,33.76,0.45,56.5,12151,NULL,NULL,'K','NGC 2340',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47860,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47860,34.64,0.4,84.6,12151,NULL,NULL,'mean','NGC 2340',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47861,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47861,35.67,0.49,136,12152,70,NULL,NULL,'2MASX J07111410-6715202',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000127,NULL,'13.1I',0.6,NULL,NULL,NULL,NULL,NULL,1,107.808583,-67.25564,0.669,NULL,40659379989,635302812,9926606,13.1),(47862,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',47862,32.32,0.49,29.1,12153,75,NULL,'IR','UGC 03697',NULL,'2011yCatp016004901K',2011,1,3.23,NULL,'G',0.000017,NULL,'13.5',0.29,'Sd: pec','in a pair',NULL,NULL,NULL,1,107.843875,71.83636,0.149,NULL,61274633084,957416141,14959627,13.5),(47863,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47863,32.59,NULL,32.9,12153,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03697',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47864,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47864,32.61,NULL,33.2,12153,NULL,NULL,'Dipole','UGC 03697',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47865,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47865,32.61,NULL,33.2,12153,NULL,NULL,'Dipole + Quadrupole','UGC 03697',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47866,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47866,32.64,NULL,33.7,12153,NULL,NULL,NULL,'UGC 03697',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47867,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47867,35.02,0.54,101,12154,70,NULL,NULL,'2MASX J07112406-6032503',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,107.850375,-60.54733,0.525,NULL,40478396325,632474942,9882420,16.2),(47868,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47868,36.4,0.62,191,12155,70,NULL,NULL,'FAIRALL 0827',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.9I',0.2,NULL,NULL,NULL,NULL,NULL,1,107.8554583,-49.24253,0.313,NULL,42431461713,662991589,10359243,14.9),(47869,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',47869,35.59,0.49,131,12156,75,NULL,'IR','2MFGC 05698',NULL,'2011yCatp016004901K',2011,1,NULL,NULL,'G',NULL,NULL,'12.4K',NULL,NULL,NULL,NULL,NULL,NULL,1,107.860083,30.18753,0.449,NULL,62975572159,983993314,15374895,12.4),(47870,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47870,33.67,0.69,54.2,12157,100,NULL,'mid-IR','UGC 03724',NULL,'2013ApJ...771...88L',2013,1,1.4,NULL,'G',0.00001,NULL,'14.27',1,'SBb',NULL,NULL,NULL,NULL,1,107.8665,48.24011,0.313,NULL,63398065846,990594778,15478043,14.27),(47871,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47871,34.72,0.4,88.1,12157,NULL,NULL,'mean','UGC 03724',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47872,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47872,34.81,0.06,91.8,12157,NULL,NULL,NULL,'UGC 03724',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47873,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47873,34.87,0.2,94.2,12157,74.4,NULL,NULL,'UGC 03724',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47874,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47874,34.9,0.47,95.7,12157,NULL,NULL,'H','UGC 03724',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47875,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47875,34.97,0.45,98.8,12157,NULL,NULL,'K','UGC 03724',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47876,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47876,34.98,0.46,99.2,12157,NULL,NULL,'J','UGC 03724',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47877,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47877,34.62,0.08,84.1,12158,NULL,NULL,NULL,'CGCG 234-094',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000027,NULL,'15.4',0.5,'Scd',NULL,NULL,NULL,NULL,1,107.876208333,49.08067,0.289,NULL,63387436525,990428695,15475448,15.4),(47878,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',47878,36.4,0.49,191,12159,75,NULL,'IR','UGC 03721',NULL,'2011yCatp016004901K',2011,1,0.97,NULL,'G',NULL,NULL,'16.5',0.11,'Sc',NULL,NULL,NULL,NULL,1,107.876833,59.71147,0.201,NULL,61679260919,963738451,15058413,16.5),(47879,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47879,36.43,NULL,193,12159,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03721',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47880,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47880,36.44,NULL,194,12159,NULL,NULL,NULL,'UGC 03721',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47881,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47881,36.45,NULL,195,12159,NULL,NULL,'Dipole + Quadrupole','UGC 03721',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47882,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47882,36.48,NULL,198,12159,NULL,NULL,'Dipole','UGC 03721',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47883,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',47883,34.13,0.49,67,12160,75,NULL,'IR','UGC 03731',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000033,NULL,'14.73',0.5,'Sdm:',NULL,NULL,NULL,NULL,1,107.9082083,29.17089,0.361,NULL,63012249913,984566404,15383850,14.73),(47884,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47884,34.15,0.43,67.6,12160,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03731',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47885,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47885,32.16,0.47,27,12161,NULL,NULL,'H','ESO 492- G 002',NULL,'2007A&A...465...71T',2007,1,2.1,'abs(b) < 10 degrees.','G',0.000007,NULL,'11.6B',1.5,'SA(r)b','Pair member (points to parent)',NULL,NULL,NULL,1,107.9185,-26.70506,NULL,NULL,39050993458,610171772,9533933,11.6),(47886,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47886,32.16,0.46,27,12161,NULL,NULL,'J','ESO 492- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47887,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47887,32.2,0.45,27.5,12161,NULL,NULL,'K','ESO 492- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47888,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47888,32.78,0.4,36,12161,NULL,NULL,'mean','ESO 492- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47889,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2007au',NULL,47889,33.96,0.19,60.7,12162,74.2,NULL,'SALT 2','UGC 03725',0.020584,'2010ApJ...716..712A',2010,1,1.4,NULL,'G',0.000036,NULL,'14.03',0.8,'S0-:','Group member',NULL,NULL,NULL,1,107.92425,49.86667,0.253,NULL,63388390963,990443608,15475681,14.03),(47890,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2007au',NULL,47890,34.56,0.09,81.7,12162,74.4,NULL,NULL,'UGC 03725',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47891,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2007au',NULL,47891,34.62,0.18,82.4,12162,65,NULL,'MLCS17','UGC 03725',0.020584,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47892,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2007au',NULL,47892,34.67,0.17,84.2,12162,73.8,NULL,'SALT 2 (SNANA)','UGC 03725',0.0203,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47893,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2007au',NULL,47893,34.67,0.19,84.2,12162,65,NULL,'MLCS31','UGC 03725',0.020584,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47894,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2007au',NULL,47894,34.83,0.18,90.4,12162,70,NULL,'SALT 2','UGC 03725',0.020584,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47895,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2007au',NULL,47895,34.89,0.23,93.1,12162,65,NULL,'SALT2','UGC 03725',0.020584,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47896,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2007au',NULL,47896,34.92,0.2,94.3,12162,65,NULL,'SALT','UGC 03725',0.020584,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47897,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47897,36.75,0.58,224,12163,70,NULL,NULL,'2MASX J07114827-5024540',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,107.9510417,-50.41503,0.189,NULL,42433563857,663024435,10359756,14.3),(47898,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47898,36.52,0.95,201,12164,70,NULL,NULL,'2MFGC 05709',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'11.6K',NULL,NULL,NULL,NULL,NULL,NULL,1,107.991083,-60.65381,0.525,NULL,40476575304,632446489,9881976,11.6),(47899,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47899,35.63,0.59,134,12165,70,NULL,NULL,'2MASX J07115939-6027104',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,107.997417,-60.45294,0.525,NULL,40478222839,632472231,9882378,15.8),(47900,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47900,35.63,0.67,134,12166,70,NULL,NULL,'2MASX J07120685-6147034',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,108.028416667,-61.78431,0.465,NULL,40355706842,630557919,9852467,16.3),(47901,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47901,37.2,0.61,276,12167,70,NULL,NULL,'2MASX J07121085-5323323',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,108.0452083,-53.39231,0.389,NULL,40485127661,632580119,9884064,15.1),(47902,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47902,36.15,0.37,170,12168,NULL,NULL,'Malmquist cor.','2MASX J07121547+4849293',NULL,'2009ApJS..182..474S',2009,1,0.2,NULL,'G',0.000023,NULL,'15.28',NULL,'Sc',NULL,NULL,NULL,NULL,1,108.0644583,48.82478,0.273,NULL,63387302317,990426598,15475415,15.28),(47903,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47903,36.15,0.37,170,12168,NULL,NULL,NULL,'2MASX J07121547+4849293',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47904,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47904,36.19,0.2,173,12168,74.4,NULL,NULL,'2MASX J07121547+4849293',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47905,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',47905,35.38,0.49,119,12169,75,NULL,'IR','UGC 03736',NULL,'2011yCatp016004901K',2011,1,1.88,NULL,'G',0.000007,NULL,'15.7',0.34,'S',NULL,NULL,NULL,NULL,1,108.0837917,23.38036,0.293,NULL,63109205784,986081340,15407520,15.7),(47906,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47906,35.39,0.31,120,12169,NULL,NULL,'Malmquist cor.','UGC 03736',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47907,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47907,35.46,0.3,124,12169,NULL,NULL,NULL,'UGC 03736',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47908,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47908,35.62,0.2,133,12169,74.4,NULL,NULL,'UGC 03736',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47909,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47909,35.96,0.66,156,12170,70,NULL,NULL,'2MASX J07122470-4709556',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.4,NULL,NULL,NULL,NULL,NULL,1,108.1030417,-47.16539,0.333,NULL,42436000614,663062509,10360351,14.5),(47910,'Tully est','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47910,31.01,0.8,16,12171,75,NULL,'B','NGC 2344',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.00002,NULL,'12.81',1.7,'SA(rs)c:','Isolated galaxy',NULL,NULL,NULL,1,108.119417,47.16669,0.393,NULL,63393953696,990530526,15477039,12.81),(47911,'CMD','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',47911,13.9,0.9,0.006,12172,NULL,NULL,'Blue Plume stars','CMa Dwarf',NULL,'2008AAS...212.5205P',2008,1,NULL,'This object may be a Milky Way structure. See 2004A&A...421L..29M.','G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,108.145833,-27.66667,NULL,0,39057176076,610268376,9535443,NULL),(47912,'CMD','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47912,14.3,NULL,0.006,12172,NULL,NULL,NULL,'CMa Dwarf',NULL,'2008MNRAS.385.1597C',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47913,'CMD','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47913,14.35,0.08,0.0074,12172,NULL,NULL,NULL,'CMa Dwarf',NULL,'2007ApJ...662..259D',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47914,'CMD','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47914,14.5,0.29,0.0079,12172,NULL,NULL,NULL,'CMa Dwarf',NULL,'2005ApJ...633..205M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47915,'CMD','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47915,14.5,0.3,0.008,12172,NULL,NULL,NULL,'CMa Dwarf',NULL,'2004MNRAS.354.1263B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47916,'Red Clump','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47916,15.6,NULL,0.013,12172,NULL,NULL,NULL,'CMa Dwarf',NULL,'2006MNRAS.366..865B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47917,'RR Lyrae','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',47917,13.9,NULL,0.006,12172,NULL,NULL,'6','CMa Dwarf',NULL,'2006RMxAC..25...18M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47918,'TRGB','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47918,14.26,0.37,0.0071,12172,NULL,NULL,NULL,'CMa Dwarf',NULL,'2004MNRAS.348...12M',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47919,'TRGB','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47919,14.29,0.09,0.0072,12172,NULL,NULL,NULL,'CMa Dwarf',NULL,'2004MNRAS.355L..33M',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47920,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47920,36.63,0.81,212,12173,70,NULL,NULL,'2MFGC 05720',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'12.1K',NULL,NULL,NULL,NULL,NULL,NULL,1,108.204333,-53.02106,0.377,NULL,40487113514,632611148,9884549,12.1),(47921,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47921,37.96,0.62,390,12174,70,NULL,NULL,'FGCE 0645',NULL,'2014MNRAS.445.2677S',2014,1,1.46,NULL,'G',0.00015,NULL,'16.3',0.17,'Sc',NULL,NULL,NULL,NULL,1,108.2140417,-35.07594,0.657,NULL,42567102211,665110972,10392358,16.3),(47922,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',47922,32.51,NULL,31.8,12175,NULL,NULL,NULL,'NGC 2350',NULL,'2015AstBu..70....1K',2015,1,1.3,NULL,'G',0.000029,NULL,'13.3',0.7,'S0/a',NULL,NULL,NULL,NULL,1,108.3007917,12.26608,0.689,NULL,63309005473,989203210,15456300,13.3),(47923,'IRAS','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47923,33.86,0.8,59.1,12176,75,NULL,'CF, r','UGC 03717',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000027,NULL,'13.83',0.8,'Sbc',NULL,NULL,NULL,NULL,1,108.310167,73.84314,0.193,NULL,61330506530,958289164,14973268,13.83),(47924,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47924,33,0.38,39.9,12176,75,NULL,'CF, r, raw','UGC 03717',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47925,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47925,33.1,0.38,41.7,12176,75,NULL,'CF, r, inv','UGC 03717',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47926,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47926,33.28,0.38,45.3,12176,75,NULL,'CF, r, cor','UGC 03717',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47927,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47927,33.59,0.47,52.4,12176,NULL,NULL,'H','UGC 03717',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47928,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47928,33.6,0.43,52.5,12176,75,NULL,'3.6 micron, color corrected','UGC 03717',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47929,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47929,33.62,0.46,53.1,12176,NULL,NULL,'J','UGC 03717',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47930,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47930,33.63,0.43,53.3,12176,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03717',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47931,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47931,33.66,0.2,54,12176,74.4,NULL,NULL,'UGC 03717',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47932,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47932,33.71,0.45,55.3,12176,NULL,NULL,'K','UGC 03717',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47933,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47933,33.78,0.38,57,12176,NULL,NULL,NULL,'UGC 03717',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47934,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47934,33.86,0.37,59.1,12176,NULL,NULL,'Malmquist cor.','UGC 03717',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47935,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47935,33.93,0.4,61,12176,NULL,NULL,'mean','UGC 03717',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47936,'IRAS','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47936,34.87,0.8,94.4,12177,75,NULL,'MAT, I','ESO 058- G 025',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.84',0.6,'SAB(rs)bc',NULL,NULL,NULL,NULL,1,108.350916667,-68.35883,0.609,NULL,40657379555,635271555,9926118,14.84),(47937,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47937,34.34,0.32,73.7,12177,85,NULL,'I, raw','ESO 058- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47938,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47938,34.34,0.43,73.8,12177,75,NULL,'MAT, I, raw','ESO 058- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47939,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',47939,34.37,0.49,74.7,12177,75,NULL,'IR','ESO 058- G 025',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47940,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47940,34.4,0.32,75.7,12177,85,NULL,'I, inv','ESO 058- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47941,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47941,34.53,0.45,80.6,12177,NULL,NULL,'Malmquist cor.','ESO 058- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47942,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47942,34.6,0.43,83,12177,75,NULL,'MAT, I, inv','ESO 058- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47943,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47943,34.61,0.44,83.4,12177,NULL,NULL,NULL,'ESO 058- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47944,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47944,34.65,0.2,85.1,12177,74.4,NULL,NULL,'ESO 058- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47945,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47945,34.67,0.43,86,12177,75,NULL,'MAT, I, cor','ESO 058- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47946,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47946,34.86,0.47,93.8,12177,NULL,NULL,'H','ESO 058- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47947,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47947,35.01,0.45,100,12177,NULL,NULL,'K','ESO 058- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47948,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47948,35.02,0.4,101,12177,NULL,NULL,'mean','ESO 058- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47949,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47949,35.04,0.46,102,12177,NULL,NULL,'J','ESO 058- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47950,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47950,35.7,0.5,138,12178,70,NULL,NULL,'ESO 367- G 005',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'15.26',0.5,'SAB(r)a? sp   LINER?',NULL,NULL,NULL,NULL,1,108.379125,-36.23869,1.065,NULL,42565698977,665089046,10392016,15.26),(47951,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',47951,35.1,0.49,105,12179,75,NULL,'IR','ESO 058- G 026',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.000033,NULL,'16.34',0.5,'S...',NULL,NULL,NULL,NULL,1,108.431333333,-69.79575,0.765,NULL,40662682142,635354408,9927412,16.34),(47952,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47952,35.48,0.54,125,12179,NULL,NULL,NULL,'ESO 058- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47953,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47953,35.48,0.54,125,12179,NULL,NULL,'Malmquist cor.','ESO 058- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47954,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47954,35.53,0.2,128,12179,74.4,NULL,NULL,'ESO 058- G 026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47955,'IRAS','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47955,34.24,0.8,70.6,12180,75,NULL,'CF, r','UGC 03741',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000037,NULL,'15.31',0.5,'Scd:',NULL,NULL,NULL,NULL,1,108.448375,50.25711,0.277,NULL,63387844659,990435072,15475548,15.31),(47956,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47956,34.45,0.38,77.8,12180,75,NULL,'CF, r, raw','UGC 03741',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47957,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47957,34.52,0.38,80.1,12180,75,NULL,'CF, r, inv','UGC 03741',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47958,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47958,34.66,0.38,85.6,12180,75,NULL,'CF, r, cor','UGC 03741',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47959,'Brightest Stars','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47959,28.06,NULL,4.09,12181,NULL,NULL,'LF','UGC 03755',NULL,'1997AstL...23..514G',1997,1,1.7,NULL,'G',0.000001,NULL,'14.10',1,'Im',NULL,NULL,NULL,NULL,1,108.465,10.52194,NULL,NULL,63267213361,988550208,15446097,14.1),(47960,'Brightest Stars','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47960,28.08,0.4,4.13,12181,NULL,NULL,'3B + 3R mean','UGC 03755',NULL,'1997AstL...23..514G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47961,'TRGB','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47961,28.49,0.07,4.98,12181,NULL,NULL,NULL,'UGC 03755',NULL,'2002AJ....124..213M',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47962,'TRGB','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47962,28.59,NULL,5.22,12181,NULL,NULL,NULL,'UGC 03755',NULL,'2003A&A...398..479K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47963,'TRGB','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47963,29.12,0.08,6.66,12181,74.4,NULL,NULL,'UGC 03755',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47964,'TRGB','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47964,29.35,0.06,7.4,12181,NULL,NULL,NULL,'UGC 03755',NULL,'2006AJ....132.2729M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47965,'TRGB','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47965,29.35,0.06,7.41,12181,NULL,NULL,NULL,'UGC 03755',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47966,'TRGB','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47966,29.36,0.1,7.45,12181,NULL,NULL,NULL,'UGC 03755',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47967,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47967,33.97,0.25,62.2,12182,74.4,NULL,NULL,'ARK 125',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000033,NULL,'14.6',0.4,'E/S0',NULL,NULL,NULL,NULL,1,108.4667083,50.40261,0.277,NULL,63387851341,990435177,15475549,14.6),(47968,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',47968,32.1,0.4,26.3,12183,75,NULL,NULL,'UGC 03751',NULL,'2008Ap.....51..336K',2008,1,1.3,'The 2MASS position is southwest of the optical nucleus.','G',0.000033,NULL,'14.7',0.4,'S?',NULL,NULL,NULL,NULL,1,108.474583,23.08014,0.329,NULL,63111519167,986117486,15408085,14.7),(47969,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47969,32.1,0.4,26.3,12183,73,NULL,'IR','UGC 03751',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47970,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47970,32.61,0.4,33.3,12183,NULL,NULL,'mean','UGC 03751',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47971,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',47971,32.83,0.49,36.8,12183,75,NULL,'IR','UGC 03751',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47972,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47972,32.96,0.47,39.2,12183,NULL,NULL,'H','UGC 03751',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47973,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47973,32.99,0.46,39.6,12183,NULL,NULL,'J','UGC 03751',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47974,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47974,33.05,0.45,40.8,12183,NULL,NULL,'K','UGC 03751',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47975,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47975,34.58,0.4,82.4,12184,NULL,NULL,'mean','UGC 03753',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000033,NULL,'14.7',0.5,'Sa:',NULL,NULL,NULL,NULL,1,108.4837083,23.23931,0.329,NULL,63111537735,986117777,15408090,14.7),(47976,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47976,34.8,0.47,91,12184,NULL,NULL,'H','UGC 03753',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47977,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47977,34.93,0.45,96.9,12184,NULL,NULL,'K','UGC 03753',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47978,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47978,34.99,0.46,99.4,12184,NULL,NULL,'J','UGC 03753',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47979,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47979,36.15,0.51,170,12185,70,NULL,NULL,'PKS 0712-349',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8',NULL,'Elliptical',NULL,NULL,NULL,NULL,1,108.486,-35.02394,0.657,NULL,42565339844,665083435,10391928,15.8),(47980,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47980,35.6,0.62,132,12186,70,NULL,NULL,'2MASX J07141264-6726182',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,108.552666667,-67.43844,0.645,NULL,40659578016,635305906,9926654,17.3),(47981,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47981,36.97,0.72,248,12187,70,NULL,NULL,'2MASX J07141568-5305383',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,108.565333,-53.09406,0.377,NULL,40487346466,632614788,9884606,17.1),(47982,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 1982B','R',47982,32.34,NULL,29.4,12188,NULL,NULL,'Photographic','NGC 2268',NULL,'1988SSRv...48....1R',1988,1,3.2,NULL,'G',0.000023,NULL,'12.24',2,'SAB(r)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,108.572667,84.38228,0.205,NULL,61263793752,957246777,14956980,12.24),(47983,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 1982B',NULL,47983,32.53,0.14,32.1,12188,60,NULL,NULL,'NGC 2268',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47984,'IRAS','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47984,32.57,0.8,32.6,12188,75,NULL,'A82, H','NGC 2268',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47985,'Sosies','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47985,32.34,0.23,29.4,12188,NULL,NULL,NULL,'NGC 2268',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47986,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47986,31.76,0.69,22.5,12188,100,NULL,'mid-IR','NGC 2268',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47987,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47987,32.3,0.35,28.8,12188,NULL,NULL,NULL,'NGC 2268',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47988,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47988,32.37,0.43,29.8,12188,75,NULL,'3.6 micron, color corrected','NGC 2268',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47989,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47989,32.4,0.43,30.2,12188,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2268',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47990,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47990,32.41,0.46,30.4,12188,NULL,NULL,'Malmquist cor.','NGC 2268',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47991,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47991,32.43,0.2,30.6,12188,74.4,NULL,NULL,'NGC 2268',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47992,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47992,32.47,0.46,31.1,12188,NULL,NULL,'J','NGC 2268',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47993,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47993,32.48,0.45,31.3,12188,NULL,NULL,'K','NGC 2268',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47994,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47994,32.48,0.47,31.3,12188,NULL,NULL,'H','NGC 2268',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47995,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47995,32.54,0.4,32.3,12188,NULL,NULL,'mean','NGC 2268',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47996,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47996,32.6,0.42,33.2,12188,NULL,NULL,NULL,'NGC 2268',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47997,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47997,32.68,0.4,34.4,12188,75,NULL,NULL,'NGC 2268',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47998,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47998,32.69,0.4,34.5,12188,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 2268',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(47999,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,47999,32.81,0.47,36.5,12188,75,NULL,'A82, H, raw','NGC 2268',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48000,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48000,33.02,0.47,40.2,12188,75,NULL,'A82, H, inv','NGC 2268',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48001,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48001,33.12,0.47,42.1,12188,75,NULL,'A82, H, cor','NGC 2268',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48002,'IRAS','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48002,33.77,0.8,56.7,12189,75,NULL,'MAT, I','ESO 035- G 003',NULL,'1997ApJS..109..333W',1997,1,1.79,'Star superposed.','G',0.000033,NULL,'16.43',0.22,'Sc',NULL,NULL,NULL,NULL,1,108.572958333,-74.737,1.009,NULL,39928569298,623883895,9748185,16.43),(48003,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48003,33.34,0.32,46.6,12189,85,NULL,'I, inv','ESO 035- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48004,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48004,33.36,0.32,46.9,12189,85,NULL,'I, raw','ESO 035- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48005,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48005,33.4,0.6,47.9,12189,NULL,NULL,NULL,'ESO 035- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48006,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48006,33.44,0.2,48.8,12189,74.4,NULL,NULL,'ESO 035- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48007,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48007,33.5,0.43,50.2,12189,75,NULL,'MAT, I, raw','ESO 035- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48008,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48008,33.51,0.43,50.4,12189,75,NULL,'MAT, I, inv','ESO 035- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48009,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48009,33.53,NULL,50.8,12189,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 035- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48010,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48010,33.54,NULL,51.2,12189,NULL,NULL,'Dipole + Quadrupole','ESO 035- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48011,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48011,33.55,NULL,51.3,12189,NULL,NULL,'Dipole','ESO 035- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48012,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48012,33.61,NULL,52.7,12189,NULL,NULL,NULL,'ESO 035- G 003',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48013,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48013,33.76,0.51,56.4,12189,NULL,NULL,'Malmquist cor.','ESO 035- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48014,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48014,33.84,0.43,58.7,12189,75,NULL,'MAT, I, cor','ESO 035- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48015,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48015,36.43,0.66,193,12190,70,NULL,NULL,'2MASX J07141825-5047143',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.2I',0.5,NULL,NULL,NULL,NULL,NULL,1,108.576083333,-50.78739,0.321,NULL,42430374588,662974602,10358978,14.2),(48016,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48016,33.01,0.4,40,12191,75,NULL,'B','UGC 03730',NULL,'1988NBGC.C....0000T',1988,1,NULL,NULL,'GPair',0.000037,NULL,NULL,NULL,NULL,'Group member, radial-velocity confirmed',NULL,NULL,NULL,1,108.585,73.47694,0.197,NULL,61330821308,958294082,14973345,NULL),(48017,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48017,36.62,0.66,211,12192,70,NULL,NULL,'2MASX J07142879-5302224',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,108.619875,-53.03953,0.377,NULL,40487245919,632613217,9884581,14),(48018,'IRAS','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48018,34.17,0.8,68.2,12193,75,NULL,'CF, r','UGC 03766',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'14.8',0.5,'Scd:',NULL,NULL,NULL,NULL,1,108.709833,16.98158,0.465,NULL,63334751204,989605487,15462585,14.8),(48019,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48019,34.38,0.4,75.2,12193,NULL,NULL,'mean','UGC 03766',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48020,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48020,34.41,0.47,76.1,12193,NULL,NULL,'H','UGC 03766',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48021,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48021,34.54,0.38,81.1,12193,75,NULL,'CF, r, raw','UGC 03766',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48022,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48022,34.56,0.45,81.6,12193,NULL,NULL,'K','UGC 03766',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48023,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48023,34.57,0.46,82.2,12193,NULL,NULL,'J','UGC 03766',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48024,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48024,34.68,0.38,86.5,12193,75,NULL,'CF, r, inv','UGC 03766',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48025,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48025,34.76,0.38,89.6,12193,75,NULL,'CF, r, cor','UGC 03766',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48026,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48026,34.97,0.54,98.5,12194,70,NULL,NULL,'2MASX J07145056-3637479',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,108.710666667,-36.62994,1.097,NULL,42633110007,666142343,10408474,14.5),(48027,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48027,34.99,0.48,99.5,12195,NULL,NULL,'Malmquist cor.','UGC 03763',NULL,'2009ApJS..182..474S',2009,1,1.09,NULL,'G',0.000027,NULL,'17.',0.13,'Sd',NULL,NULL,NULL,NULL,1,108.745875,34.81433,0.205,NULL,63454064772,991469762,15491715,17),(48028,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48028,35.11,NULL,105,12195,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03763',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48029,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48029,35.12,NULL,106,12195,NULL,NULL,'Dipole + Quadrupole','UGC 03763',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48030,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48030,35.13,NULL,106,12195,NULL,NULL,'Dipole','UGC 03763',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48031,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48031,35.16,NULL,108,12195,NULL,NULL,NULL,'UGC 03763',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48032,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48032,35.3,0.41,115,12195,NULL,NULL,NULL,'UGC 03763',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48033,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',48033,35.36,0.49,118,12195,75,NULL,'IR','UGC 03763',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48034,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48034,35.4,0.2,120,12195,74.4,NULL,NULL,'UGC 03763',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48035,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48035,35.49,0.43,126,12195,75,NULL,'3.6 micron, color corrected','UGC 03763',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48036,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48036,35.59,0.43,131,12195,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03763',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48037,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48037,32.99,NULL,39.6,12196,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03761',NULL,'2010Ap&SS.325..163P',2010,1,1.66,NULL,'G',0.000017,NULL,'16.0',0.22,'Sdm',NULL,NULL,NULL,NULL,1,108.76775,38.14517,0.209,NULL,63601039644,993766244,15527597,16),(48038,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48038,33,NULL,39.8,12196,NULL,NULL,'Dipole','UGC 03761',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48039,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48039,33.01,NULL,39.9,12196,NULL,NULL,'Dipole + Quadrupole','UGC 03761',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48040,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48040,33.09,NULL,41.4,12196,NULL,NULL,NULL,'UGC 03761',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48041,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',48041,34.27,0.49,71.5,12197,75,NULL,'IR','UGC 03757',NULL,'2011yCatp016004901K',2011,1,1.55,NULL,'G',0.000017,NULL,'17.',0.1,'Scd',NULL,NULL,NULL,NULL,1,108.781917,48.74889,0.333,NULL,63386496969,990414015,15475218,17),(48042,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48042,34.55,0.15,81.5,12197,NULL,NULL,NULL,'UGC 03757',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48043,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48043,34.82,NULL,91.9,12197,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03757',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48044,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48044,34.83,NULL,92.3,12197,NULL,NULL,'Dipole + Quadrupole','UGC 03757',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48045,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48045,34.83,NULL,92.7,12197,NULL,NULL,'Dipole','UGC 03757',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48046,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48046,35.12,0.43,106,12197,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03757',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48047,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48047,35.13,NULL,106,12197,NULL,NULL,NULL,'UGC 03757',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48048,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48048,35.26,0.43,113,12197,75,NULL,'3.6 micron, color corrected','UGC 03757',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48049,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48049,35.31,0.2,115,12197,74.4,NULL,NULL,'UGC 03757',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48050,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48050,35.48,0.5,125,12198,70,NULL,NULL,'ESO 207-IG 030 NED02',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'15.87',NULL,NULL,NULL,NULL,NULL,NULL,1,108.782083,-51.49664,0.377,NULL,42430490776,662976418,10359006,15.87),(48051,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48051,32.71,0.4,34.9,12199,NULL,NULL,'mean','ESO 428- G 009',NULL,'2007A&A...465...71T',2007,1,1.9,'abs(b) < 10 degrees.','G',0.000033,NULL,'15.15',0.4,'Sc',NULL,NULL,NULL,NULL,1,108.815,-29.28147,NULL,NULL,39047704174,610120377,9533130,15.15),(48052,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48052,32.75,0.43,35.5,12199,75,NULL,'3.6 micron, color + selection bias corrected','ESO 428- G 009',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48053,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48053,32.81,0.4,36.4,12199,73,NULL,'IR','ESO 428- G 009',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48054,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',48054,32.81,0.4,36.4,12199,75,NULL,NULL,'ESO 428- G 009',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48055,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48055,32.81,0.4,36.5,12199,73,NULL,'opt','ESO 428- G 009',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48056,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48056,32.87,0.43,37.6,12199,75,NULL,'3.6 micron, color corrected','ESO 428- G 009',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48057,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48057,32.94,0.2,38.7,12199,74.4,NULL,NULL,'ESO 428- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48058,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',48058,32.97,0.49,39.2,12199,75,NULL,'IR','ESO 428- G 009',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48059,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48059,33.39,0.47,47.6,12199,NULL,NULL,'H','ESO 428- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48060,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48060,33.4,0.46,47.8,12199,NULL,NULL,'J','ESO 428- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48061,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48061,33.46,0.45,49.1,12199,NULL,NULL,'K','ESO 428- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48062,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48062,36.04,0.66,162,12200,70,NULL,NULL,'ESO 162- G 014',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.4R',0.5,'S(r:)...',NULL,NULL,NULL,NULL,1,108.817791667,-53.11856,0.401,NULL,40487287528,632613867,9884591,15.4),(48063,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48063,37.15,0.56,270,12201,70,NULL,NULL,'2MASX J07152324-4923456',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,108.8469583,-49.39597,0.425,NULL,42431387959,662990436,10359225,15.1),(48064,'IRAS','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48064,32.96,0.8,39,12202,75,NULL,'MAT, I','ESO 162- G 015',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'13.58',1,'SB(s)c',NULL,NULL,NULL,NULL,1,108.848875,-55.07636,0.393,NULL,40499780232,632809066,9887641,13.58),(48065,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48065,31.98,0.32,24.9,12202,85,NULL,'I, inv','ESO 162- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48066,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48066,32.02,0.32,25.3,12202,85,NULL,'I, raw','ESO 162- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48067,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48067,32.46,0.43,31.1,12202,75,NULL,'MAT, I, inv','ESO 162- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48068,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48068,32.51,0.43,31.8,12202,75,NULL,'MAT, I, raw','ESO 162- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48069,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48069,32.7,0.39,34.6,12202,73,NULL,'opt','ESO 162- G 015',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48070,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48070,32.79,0.43,36.2,12202,75,NULL,'MAT, I, cor','ESO 162- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48071,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48071,32.93,0.56,38.6,12202,NULL,NULL,'Malmquist cor.','ESO 162- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48072,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48072,33.12,0.51,42.1,12202,NULL,NULL,NULL,'ESO 162- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48073,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48073,33.16,0.2,42.9,12202,74.4,NULL,NULL,'ESO 162- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48074,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2000fa',NULL,48074,34.24,0.23,69,12203,74.2,NULL,'SALT 2','UGC 03770',0.02127,'2010ApJ...716..712A',2010,1,1,NULL,'G',0.000017,NULL,'14.9',0.6,'Im',NULL,NULL,NULL,NULL,1,108.8732083,23.42625,0.321,NULL,63107828677,986059823,15407184,14.9),(48075,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2000fa','R',48075,34.63,0.06,84.3,12203,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 03770',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48076,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2000fa','R',48076,34.69,0.05,86.7,12203,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 03770',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48077,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2000fa',NULL,48077,34.71,0.08,87.5,12203,74.4,NULL,NULL,'UGC 03770',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48078,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2000fa',NULL,48078,34.81,0.25,89.7,12203,72,NULL,NULL,'UGC 03770',0.02127,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48079,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2000fa',NULL,48079,34.86,0.17,91.8,12203,70,NULL,'SALT 2','UGC 03770',0.02127,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48080,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2000fa',NULL,48080,34.9,0.28,93.5,12203,70,NULL,'SALT','UGC 03770',0.02127,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48081,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2000fa',NULL,48081,34.9,0.12,93.6,12203,65,NULL,'MLCS2k2','UGC 03770',0.02127,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48082,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2000fa',NULL,48082,34.92,0.17,94.5,12203,73.8,NULL,'SALT 2 (SNANA)','UGC 03770',0.0218,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48083,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2000fa',NULL,48083,34.93,0.2,94.6,12203,65,NULL,'MLCS31','UGC 03770',0.02127,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48084,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2000fa',NULL,48084,34.93,0.03,94.6,12203,72,NULL,NULL,'UGC 03770',0.02127,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48085,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2000fa',NULL,48085,34.94,0.1,95.3,12203,70,NULL,NULL,'UGC 03770',0.02127,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48086,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2000fa',NULL,48086,34.97,0.08,96.7,12203,65,NULL,'SALT2','UGC 03770',0.02127,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48087,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2000fa',NULL,48087,34.99,0.19,97.3,12203,65,NULL,'MLCS17','UGC 03770',0.02127,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48088,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2000fa',NULL,48088,35,0.09,98,12203,65,NULL,'MLCS2k2','UGC 03770',0.02127,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48089,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2000fa',NULL,48089,35.05,0.3,100,12203,65,NULL,'SALT','UGC 03770',0.02127,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48090,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2000fa',NULL,48090,35.06,0.21,101,12203,65,NULL,NULL,'UGC 03770',0.02127,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48091,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2000fa',NULL,48091,35.12,0.13,102,12203,65,NULL,'MLCS2k2','UGC 03770',0.02127,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48092,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2000fa',NULL,48092,35.1,0.21,102,12203,65,NULL,'SALT2','UGC 03770',0.02127,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48093,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2000fa',NULL,48093,35.23,0.02,109,12203,65,NULL,'SALT','UGC 03770',0.02127,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48094,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2000fa',NULL,48094,35.29,0.14,114,12203,60,NULL,NULL,'UGC 03770',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48095,'SNIa','2016-12-15 15:14:15','2016-12-16 11:19:21','1','SN 2000fa',NULL,48095,35.51,0.2,124,12203,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','UGC 03770',0.02127,'2011A&A...526A..81B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48096,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48096,34.28,0.43,71.6,12203,75,NULL,'3.6 micron, color corrected','UGC 03770',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48097,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48097,34.36,0.43,74.6,12203,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03770',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48098,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48098,34.61,0.4,83.6,12203,75,NULL,'HOSTS SN 2000fa','UGC 03770',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48099,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48099,34.61,0.42,83.6,12203,NULL,18.48,'3.6 micron','UGC 03770',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48100,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48100,34.71,0.08,87.5,12203,74.4,NULL,NULL,'UGC 03770',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48101,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48101,33.81,0.45,57.8,12204,NULL,NULL,'K','IC 2179',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000163,NULL,'13.45',1.1,'E1-2','Pair member (points to parent)',NULL,NULL,NULL,1,108.884625,64.92619,0.149,NULL,61646267827,963222934,15050358,13.45),(48102,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48102,34.03,0.4,64.1,12204,NULL,NULL,'mean','IC 2179',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48103,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48103,36.18,0.6,172,12205,70,NULL,NULL,'2MASX J07153518-3632165',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,108.8967083,-36.53792,1.097,NULL,42633233014,666144265,10408504,15.6),(48104,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48104,32.15,0.43,26.9,12206,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03749',NULL,'2014MNRAS.444..527S',2014,1,2.02,NULL,'G',0.000023,NULL,'15.19',0.22,'Sc',NULL,NULL,NULL,NULL,1,108.974291667,67.98378,0.161,NULL,62204299560,971942180,15186596,15.19),(48105,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',48105,32.16,0.4,27,12206,75,NULL,NULL,'UGC 03749',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48106,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48106,32.21,0.43,27.7,12206,75,NULL,'3.6 micron, color corrected','UGC 03749',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48107,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48107,32.22,0.2,27.8,12206,74.4,NULL,NULL,'UGC 03749',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48108,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,'R',48108,32.37,0.49,29.8,12206,75,NULL,'IR','UGC 03749',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48109,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48109,32.44,0.65,30.7,12206,NULL,NULL,NULL,'UGC 03749',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48110,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48110,32.52,0.62,32,12206,NULL,NULL,'Malmquist cor.','UGC 03749',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48111,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48111,32.54,NULL,32.2,12206,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03749',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48112,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48112,32.55,NULL,32.4,12206,NULL,NULL,'Dipole + Quadrupole','UGC 03749',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48113,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48113,32.56,NULL,32.5,12206,NULL,NULL,'Dipole','UGC 03749',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48114,'FP','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48114,36.83,0.64,233,12207,70,NULL,NULL,'2MASX J07155387-6033013',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,108.974333,-60.55047,0.525,NULL,40480855278,632513363,9883021,16.8),(48115,'IRAS','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48115,30.69,0.8,13.7,12208,75,NULL,'MAT, I','ESO 162- G 017',NULL,'1997ApJS..109..333W',1997,1,2,'Confused HIPASS source','G',0.000018,NULL,'13.65',0.8,'Sb? pec sp',NULL,NULL,NULL,NULL,1,108.9772083,-57.3435,0.465,NULL,40529158997,633268109,9894814,13.65),(48116,'Tully est','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48116,30.43,0.8,12.2,12208,75,NULL,NULL,'ESO 162- G 017',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48117,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48117,29.4,0.32,7.63,12208,85,NULL,'I, inv','ESO 162- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48118,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48118,29.46,0.32,7.8,12208,85,NULL,'I, raw','ESO 162- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48119,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48119,29.8,0.43,9.11,12208,75,NULL,'MAT, I, inv','ESO 162- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48120,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48120,29.91,0.43,9.6,12208,75,NULL,'MAT, I, raw','ESO 162- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48121,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48121,30.19,0.2,10.9,12208,74.4,NULL,NULL,'ESO 162- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48122,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48122,30.22,0.43,11.1,12208,75,NULL,'MAT, I, cor','ESO 162- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48123,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48123,30.37,0.4,11.9,12208,NULL,NULL,NULL,'ESO 162- G 017',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48124,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48124,30.38,0.4,11.9,12208,73,NULL,'opt','ESO 162- G 017',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48125,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48125,30.58,0.58,13.1,12208,NULL,NULL,NULL,'ESO 162- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48126,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48126,30.77,0.46,14.3,12208,NULL,NULL,'J','ESO 162- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48127,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48127,30.8,0.47,14.4,12208,NULL,NULL,'H','ESO 162- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48128,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48128,30.88,0.45,15,12208,NULL,NULL,'K','ESO 162- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48129,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48129,30.9,0.5,15.1,12208,NULL,NULL,'Malmquist cor.','ESO 162- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48130,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48130,30.96,0.4,15.6,12208,NULL,NULL,'mean','ESO 162- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48131,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48131,35.69,0.41,138,12209,NULL,NULL,'Malmquist cor.','ESO 058- G 027',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.46',0.2,'S...',NULL,NULL,NULL,NULL,1,108.996875,-70.56283,0.737,NULL,40663223044,635362860,9927544,16.46),(48132,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48132,35.74,0.4,141,12209,NULL,NULL,NULL,'ESO 058- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48133,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48133,35.79,0.2,144,12209,74.4,NULL,NULL,'ESO 058- G 027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48134,'Ring Diameter','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48134,32.2,0.84,27,12210,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 2347',NULL,'1981ApJS...45..541P',1981,1,1.8,NULL,'G',0.000033,NULL,'13.21',1.3,'(R\')SA(r)b:','Pair member (points to parent)',NULL,NULL,NULL,1,109.015375,64.70892,0.149,NULL,61646719863,963229997,15050468,13.21),(48135,'Tully-Fisher','2016-12-15 15:14:15','2016-12-16 11:19:21','1',NULL,NULL,48135,34.04,0.4,64.4,12210,NULL,NULL,'mean','NGC 2347',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48136,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48136,34.17,0.45,68.3,12210,NULL,NULL,'K','NGC 2347',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48137,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48137,34.18,0.47,68.7,12210,NULL,NULL,'H','NGC 2347',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48138,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48138,34.22,0.46,69.9,12210,NULL,NULL,'J','NGC 2347',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48139,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48139,34.48,0.51,78.6,12210,NULL,NULL,'Malmquist cor.','NGC 2347',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48140,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48140,34.7,0.43,87.2,12210,75,NULL,'3.6 micron, color corrected','NGC 2347',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48141,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48141,34.73,0.2,88.3,12210,74.4,NULL,NULL,'NGC 2347',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48142,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48142,34.74,0.45,88.9,12210,NULL,NULL,NULL,'NGC 2347',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48143,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48143,34.77,0.43,89.8,12210,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2347',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48144,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48144,34.53,0.48,80.4,12211,NULL,NULL,'Malmquist cor.','UGC 03774',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.00003,NULL,'15.17',0.3,'Sab',NULL,NULL,NULL,NULL,1,109.058083,32.93711,0.285,NULL,63466192647,991659260,15494675,15.17),(48145,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48145,34.68,0.44,86.4,12211,NULL,NULL,NULL,'UGC 03774',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48146,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48146,34.72,0.2,87.9,12211,74.4,NULL,NULL,'UGC 03774',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48147,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48147,35.16,0.4,108,12211,NULL,NULL,'mean','UGC 03774',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48148,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48148,35.23,0.47,111,12211,NULL,NULL,'H','UGC 03774',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48149,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48149,35.29,0.45,114,12211,NULL,NULL,'K','UGC 03774',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48150,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48150,36.36,0.66,187,12212,70,NULL,NULL,'2MASX J07162374-5317502',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,109.0989583,-53.29733,0.401,NULL,40487406151,632615721,9884620,15.3),(48151,'SNIa','2016-12-15 15:14:16','2016-12-16 11:19:21','1','SN 2008fp',NULL,48151,31.82,0.01,23.2,12213,72,NULL,'M(H) = -18.317 mag','ESO 428- G 014',NULL,'2014ApJ...784..105W',2013,1,1.9,'Initially classified as a planetary nebula. ESO-LV has v=14100+/-100km/sec.','G',0.000067,NULL,'13.26',1.1,'SA:(l)0^+      Sy2',NULL,NULL,'radio jet','Sy 2',1,109.130041667,-29.32472,NULL,NULL,39047264495,610113507,9533023,13.26),(48152,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48152,35.14,0.48,106,12214,70,NULL,NULL,'2MASX J07163189-5934574',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'15.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,109.13275,-59.58261,0.505,NULL,40480213906,632503342,9882864,15.5),(48153,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48153,35.07,0.52,103,12215,70,NULL,NULL,'2MASX J07163529-5848184',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5b',NULL,'(RL)SB0^0:',NULL,NULL,NULL,NULL,1,109.1470417,-58.80517,0.509,NULL,40472078397,632376224,9880878,15.5),(48154,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48154,34.75,NULL,89.2,12216,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0613',NULL,'2010Ap&SS.325..163P',2010,1,1.03,NULL,'G',0.000014,NULL,'16.4',0.13,'Scd',NULL,NULL,NULL,NULL,1,109.1552083,32.95675,0.285,NULL,63466178249,991659035,15494672,16.4),(48155,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48155,34.75,NULL,89.3,12216,NULL,NULL,'Dipole + Quadrupole','FGC 0613',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48156,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48156,34.75,NULL,89.3,12216,NULL,NULL,'Dipole','FGC 0613',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48157,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48157,34.83,NULL,92.6,12216,NULL,NULL,NULL,'FGC 0613',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48158,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48158,34.99,0.56,99.6,12216,NULL,NULL,'Malmquist cor.','FGC 0613',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48159,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48159,35.18,0.2,109,12216,74.4,NULL,NULL,'FGC 0613',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48160,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48160,35.19,0.51,109,12216,NULL,NULL,NULL,'FGC 0613',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48161,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48161,35.2,0.43,110,12216,75,NULL,'3.6 micron, color corrected','FGC 0613',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48162,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48162,35.23,0.43,111,12216,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0613',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48163,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48163,32.58,0.45,32.8,12217,NULL,NULL,'K','NGC 2369',NULL,'2007A&A...465...71T',2007,1,3.5,NULL,'G',0.00003,NULL,'13.21',1.1,'(R\')SAB(s)ab   LIRG','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,109.157208333,-62.34372,0.509,NULL,40364049569,630688274,9854504,13.21),(48164,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48164,32.6,0.43,33,12217,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2369',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48165,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48165,32.62,0.43,33.5,12217,75,NULL,'3.6 micron, color corrected','NGC 2369',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48166,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48166,32.66,0.47,34,12217,NULL,NULL,'H','NGC 2369',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48167,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48167,32.71,0.2,34.8,12217,74.4,NULL,NULL,'NGC 2369',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48168,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48168,32.72,0.46,35,12217,NULL,NULL,'J','NGC 2369',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48169,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48169,33.29,0.4,45.6,12217,NULL,NULL,'mean','NGC 2369',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48170,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48170,34.35,0.46,74.2,12218,70,NULL,NULL,'ESO 035- G 004',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00011,NULL,'14.94',0.7,'(RL)SAB0^+',NULL,NULL,NULL,NULL,1,109.157625,-75.56594,0.917,NULL,39916317827,623692466,9745194,14.94),(48171,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48171,33.2,0.43,43.7,12219,75,NULL,'3.6 micron, color corrected','UGC 03776',NULL,'2014MNRAS.444..527S',2014,1,1.7,NULL,'G',0.000033,NULL,'14.30',0.4,'Sb','in a triple',NULL,NULL,NULL,1,109.162083,33.98789,0.197,NULL,63466819193,991669049,15494828,14.3),(48172,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48172,33.21,0.2,43.9,12219,74.4,NULL,NULL,'UGC 03776',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48173,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48173,33.22,0.43,44,12219,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03776',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48174,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48174,33.32,0.37,46.1,12219,NULL,NULL,NULL,'UGC 03776',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48175,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48175,33.35,0.49,46.7,12219,75,NULL,'IR','UGC 03776',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48176,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48176,33.66,0.32,53.9,12219,NULL,NULL,'Malmquist cor.','UGC 03776',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48177,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48177,33.84,0.47,58.6,12219,NULL,NULL,'H','UGC 03776',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48178,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48178,33.94,0.4,61.3,12219,NULL,NULL,'mean','UGC 03776',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48179,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48179,33.98,0.46,62.5,12219,NULL,NULL,'J','UGC 03776',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48180,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48180,33.99,0.45,62.8,12219,NULL,NULL,'K','UGC 03776',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48181,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48181,34.22,NULL,69.7,12220,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0614',NULL,'2010Ap&SS.325..163P',2010,1,0.91,NULL,'G',0.000011,NULL,'16.69',0.09,'Sd',NULL,NULL,NULL,NULL,1,109.172917,30.26444,0.621,NULL,62976941115,984014704,15375229,16.69),(48182,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48182,34.23,NULL,70,12220,NULL,NULL,'Dipole + Quadrupole','FGC 0614',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48183,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48183,34.23,NULL,70.2,12220,NULL,NULL,'Dipole','FGC 0614',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48184,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48184,34.23,0.43,70.2,12220,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0614',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48185,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48185,34.29,NULL,72.1,12220,NULL,NULL,NULL,'FGC 0614',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48186,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48186,32.73,0.2,35.2,12221,74.4,NULL,NULL,'UGC 03777',NULL,'2013AJ....146...86T',2013,1,2.24,NULL,'G',0.000027,NULL,'14.57',0.32,'Sc',NULL,NULL,NULL,NULL,1,109.1787083,29.85497,0.641,NULL,62975652545,983994571,15374915,14.57),(48187,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48187,32.76,0.76,35.6,12221,NULL,NULL,NULL,'UGC 03777',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48188,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48188,32.82,0.43,36.6,12221,75,NULL,'3.6 micron, color corrected','UGC 03777',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48189,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48189,32.84,0.43,37,12221,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03777',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48190,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48190,32.87,0.49,37.5,12221,75,NULL,'IR','UGC 03777',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48191,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48191,32.9,0.71,38.1,12221,NULL,NULL,'Malmquist cor.','UGC 03777',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48192,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48192,33.11,NULL,42,12221,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03777',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48193,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48193,33.12,NULL,42.1,12221,NULL,NULL,'Dipole + Quadrupole','UGC 03777',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48194,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48194,33.12,NULL,42.1,12221,NULL,NULL,'Dipole','UGC 03777',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48195,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48195,33.22,NULL,44,12221,NULL,NULL,NULL,'UGC 03777',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48196,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48196,33.61,0.4,52.8,12221,NULL,NULL,'mean','UGC 03777',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48197,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48197,33.77,0.47,56.7,12221,NULL,NULL,'H','UGC 03777',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48198,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48198,36.64,0.62,213,12222,70,NULL,NULL,'2MASX J07164838-3614150',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,109.201625,-36.23747,1.097,NULL,42564863202,665075987,10391812,15.8),(48199,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48199,33.39,0.2,47.6,12223,74.4,NULL,NULL,'UGC 03764',NULL,'2013AJ....146...86T',2013,1,1.2,'The 2MASS position refers to a knot 9 arcsec northwest of the nucleus.','G',0.000037,NULL,'14.14',0.8,'Sa             AGN?','Isolated galaxy',NULL,NULL,NULL,1,109.219833,67.11117,0.165,NULL,62205442126,971960033,15186875,14.14),(48200,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48200,33.48,0.47,49.6,12223,NULL,NULL,NULL,'UGC 03764',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48201,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48201,33.72,0.42,55.4,12223,NULL,NULL,'Malmquist cor.','UGC 03764',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48202,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48202,33.92,0.4,60.9,12223,NULL,NULL,'mean','UGC 03764',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48203,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48203,34.16,0.47,68,12223,NULL,NULL,'H','UGC 03764',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48204,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48204,36.8,0.58,229,12224,70,NULL,NULL,'2MASX J07165648-5051563',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,109.2352083,-50.86569,0.325,NULL,42430012653,662968947,10358889,14.2),(48205,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48205,36.63,0.8,212,12225,70,NULL,NULL,'2MFGC 05796',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'11.8K',NULL,NULL,NULL,NULL,NULL,NULL,1,109.260833,-58.11667,0.517,NULL,40527844846,633247575,9894493,11.8),(48206,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48206,35.9,0.54,151,12226,70,NULL,NULL,'PKS 0715-36',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.00015,NULL,'17.8',1.3,'SA0-',NULL,NULL,NULL,NULL,1,109.283875,-36.36683,1.097,NULL,42564872676,665076135,10391814,17.8),(48207,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48207,31.76,0.4,22.5,12227,73,NULL,'IR','ESO 428- G 015',NULL,'2011A&A...532A.104N',2011,1,1.5,'abs(b) < 10 degrees.','G',0.000019,NULL,'15.67',0.2,'S...',NULL,NULL,NULL,NULL,1,109.285458333,-29.38133,NULL,NULL,39048334977,610130234,9533284,15.67),(48208,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48208,31.76,0.4,22.5,12227,75,NULL,NULL,'ESO 428- G 015',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48209,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48209,32.77,0.49,35.8,12227,75,NULL,'IR','ESO 428- G 015',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48210,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48210,32.69,0.4,34.5,12228,73,NULL,'IR','ESO 428- G 018',NULL,'2011A&A...532A.104N',2011,1,1.4,'abs(b) < 10 degrees.','G',0.00002,NULL,'15.97',0.3,'S...',NULL,NULL,NULL,NULL,1,109.3022083,-29.58086,NULL,NULL,39048221510,610128461,9533257,15.97),(48211,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48211,32.69,0.4,34.5,12228,73,NULL,'opt','ESO 428- G 018',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48212,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48212,32.69,0.4,34.5,12228,75,NULL,NULL,'ESO 428- G 018',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48213,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48213,33.16,0.49,42.8,12228,75,NULL,'IR','ESO 428- G 018',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48214,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48214,32.69,0.43,34.5,12229,75,NULL,'3.6 micron, color + selection bias corrected','ESO 428- G 017',NULL,'2014MNRAS.444..527S',2014,1,1.6,'abs(b) < 10 degrees.','G',0.000033,NULL,'15.51',0.3,'Sc',NULL,NULL,NULL,NULL,1,109.3072917,-28.91689,NULL,NULL,39047994963,610124921,9533201,15.51),(48215,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48215,32.73,0.4,35.1,12229,75,NULL,NULL,'ESO 428- G 017',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48216,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48216,32.73,0.39,35.1,12229,73,NULL,'IR','ESO 428- G 017',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48217,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48217,32.73,0.39,35.2,12229,73,NULL,'opt','ESO 428- G 017',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48218,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48218,32.91,0.49,38.1,12229,75,NULL,'IR','ESO 428- G 017',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48219,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48219,34.37,0.61,74.8,12230,70,NULL,NULL,'2MASX J07171907-7622572',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000117,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,109.329167,-76.38261,0.873,NULL,39916462451,623694725,9745230,16.2),(48220,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48220,35.69,NULL,137,12231,NULL,NULL,'Dipole + Quadrupole','FGC 0618',NULL,'2010Ap&SS.325..163P',2010,1,1.24,NULL,'G',0.000011,NULL,'16.2',0.15,'Sbc',NULL,NULL,NULL,NULL,1,109.350583,22.51322,0.297,NULL,63109888950,986092014,15407687,16.2),(48221,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48221,35.69,NULL,137,12231,NULL,NULL,'Dipole','FGC 0618',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48222,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48222,35.69,NULL,137,12231,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0618',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48223,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48223,35.85,NULL,148,12231,NULL,NULL,NULL,'FGC 0618',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48224,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48224,35.9,0.49,151,12231,75,NULL,'IR','FGC 0618',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48225,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48225,36.05,0.43,162,12231,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0618',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48226,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48226,33.95,0.4,61.7,12232,NULL,NULL,'mean','UGC 03780',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000033,NULL,'14.89',0.4,'S?','in a triple',NULL,NULL,NULL,1,109.3679583,34.07772,0.197,NULL,63466770639,991668291,15494817,14.89),(48227,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48227,34.11,0.45,66.4,12232,NULL,NULL,'K','UGC 03780',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48228,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48228,34.15,0.47,67.5,12232,NULL,NULL,'H','UGC 03780',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48229,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48229,34.27,0.36,71.5,12232,NULL,NULL,'Malmquist cor.','UGC 03780',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48230,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48230,34.3,0.36,72.3,12232,NULL,NULL,NULL,'UGC 03780',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48231,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48231,34.32,0.49,73.2,12232,75,NULL,'IR','UGC 03780',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48232,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48232,34.34,0.2,73.8,12232,74.4,NULL,NULL,'UGC 03780',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48233,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48233,34.05,NULL,64.6,12233,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03779',NULL,'2010Ap&SS.325..163P',2010,1,1.46,NULL,'G',0.000033,NULL,'15.44',0.15,'Sd','in a triple',NULL,NULL,NULL,1,109.38275,33.97508,0.197,NULL,63466779283,991668426,15494819,15.44),(48234,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48234,34.06,0.49,65,12233,75,NULL,'IR','UGC 03779',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48235,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48235,34.08,NULL,65.3,12233,NULL,NULL,'Dipole + Quadrupole','UGC 03779',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48236,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48236,34.09,NULL,65.6,12233,NULL,NULL,'Dipole','UGC 03779',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48237,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48237,34.15,0.35,67.5,12233,NULL,NULL,NULL,'UGC 03779',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48238,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48238,34.18,NULL,68.5,12233,NULL,NULL,NULL,'UGC 03779',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48239,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48239,34.19,0.2,68.9,12233,74.4,NULL,NULL,'UGC 03779',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48240,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48240,34.2,0.35,69.3,12233,NULL,NULL,'Malmquist cor.','UGC 03779',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48241,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48241,34.88,0.46,94.7,12234,NULL,NULL,NULL,'ESO 162- G 018',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'13.50',0.3,'Sbc:',NULL,NULL,NULL,NULL,1,109.4205417,-55.9765,0.437,NULL,40495069552,632735461,9886491,13.5),(48242,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48242,34.92,0.2,96.4,12234,74.4,NULL,NULL,'ESO 162- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48243,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48243,35.06,0.43,103,12234,NULL,NULL,'Malmquist cor.','ESO 162- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48244,'IRAS','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48244,32.58,0.8,32.8,12235,75,NULL,'A82, H','NGC 2357',NULL,'1997ApJS..109..333W',1997,1,4.26,NULL,'G',0.000008,NULL,'14.0',0.35,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,109.4207917,23.35675,0.421,NULL,63108106681,986064166,15407252,14),(48245,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48245,32.07,0.4,26,12235,73,NULL,'IR','NGC 2357',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48246,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48246,32.08,0.4,26,12235,75,NULL,NULL,'NGC 2357',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48247,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48247,32.13,0.4,26.7,12235,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 2357',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48248,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48248,32.3,0.43,28.8,12235,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2357',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48249,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48249,32.43,0.46,30.7,12235,NULL,NULL,'J','NGC 2357',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48250,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48250,32.43,0.43,30.7,12235,75,NULL,'3.6 micron, color corrected','NGC 2357',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48251,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48251,32.45,0.47,30.9,12235,NULL,NULL,'H','NGC 2357',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48252,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48252,32.49,0.49,31.5,12235,75,NULL,'IR','NGC 2357',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48253,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48253,32.49,0.47,31.5,12235,75,NULL,'A82, H, raw','NGC 2357',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48254,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48254,32.49,0.38,31.5,12235,NULL,NULL,NULL,'NGC 2357',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48255,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48255,32.49,0.4,31.5,12235,75,NULL,'B','NGC 2357',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48256,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48256,32.53,0.45,32.1,12235,NULL,NULL,'K','NGC 2357',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48257,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48257,32.57,0.47,32.7,12235,75,NULL,'A82, H, inv','NGC 2357',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48258,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48258,32.64,0.2,33.7,12235,74.4,NULL,NULL,'NGC 2357',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48259,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48259,32.66,NULL,34.1,12235,NULL,NULL,'Dipole','NGC 2357',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48260,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48260,32.67,NULL,34.2,12235,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 2357',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48261,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48261,32.67,NULL,34.3,12235,NULL,NULL,'Dipole + Quadrupole','NGC 2357',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48262,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48262,32.72,0.73,35.1,12235,NULL,NULL,'Malmquist cor.','NGC 2357',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48263,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48263,32.76,NULL,35.7,12235,NULL,NULL,NULL,'NGC 2357',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48264,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48264,32.79,0.4,36.1,12235,NULL,NULL,'mean','NGC 2357',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48265,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48265,32.91,0.47,38.2,12235,75,NULL,'A82, H, cor','NGC 2357',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48266,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48266,33.05,0.63,40.7,12235,NULL,NULL,NULL,'NGC 2357',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48267,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48267,34.77,0.49,89.9,12236,75,NULL,'IR','UGC 03783',NULL,'2011yCatp016004901K',2011,1,1.21,NULL,'G',0.000005,NULL,'15.9',0.11,'Sd','Field galaxy',NULL,NULL,NULL,1,109.472125,24.75603,0.305,NULL,63002809545,984418899,15381545,15.9),(48268,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48268,35.1,0.43,105,12236,75,NULL,'3.6 micron, color corrected','UGC 03783',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48269,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48269,35.1,0.43,105,12236,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03783',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48270,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48270,35.1,0.2,105,12236,74.4,NULL,NULL,'UGC 03783',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48271,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48271,35.12,0.5,106,12236,NULL,NULL,'Malmquist cor.','UGC 03783',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48272,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48272,35.18,0.49,109,12236,NULL,NULL,NULL,'UGC 03783',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48273,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48273,35.34,NULL,117,12236,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03783',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48274,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48274,35.34,NULL,117,12236,NULL,NULL,'Dipole + Quadrupole','UGC 03783',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48275,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48275,35.34,NULL,117,12236,NULL,NULL,NULL,'UGC 03783',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48276,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48276,35.35,NULL,117,12236,NULL,NULL,'Dipole','UGC 03783',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48277,'SNIa','2016-12-15 15:14:16','2016-12-16 11:19:21','1','SN 2003ch',NULL,48277,33.43,0.2,47.4,12237,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','UGC 03787',0.025,'2011A&A...526A..81B',2011,1,1.2,NULL,'G',0.00012,NULL,'15.6P',0.6,'E-S0',NULL,NULL,NULL,NULL,1,109.489833333,9.68933,0.801,NULL,63269367562,988583868,15446622,15.6),(48278,'SNIa','2016-12-15 15:14:16','2016-12-16 11:19:21','1','SN 2003ch',NULL,48278,34.95,0.18,95.3,12237,74.2,NULL,'SALT 2','UGC 03787',0.025,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48279,'SNIa','2016-12-15 15:14:16','2016-12-16 11:19:21','1','SN 2003ch','R',48279,35.36,0.09,118,12237,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 03787',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48280,'SNIa','2016-12-15 15:14:16','2016-12-16 11:19:21','1','SN 2003ch','R',48280,35.41,0.09,121,12237,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 03787',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48281,'SNIa','2016-12-15 15:14:16','2016-12-16 11:19:21','1','SN 2003ch',NULL,48281,35.55,0.09,129,12237,74.4,NULL,NULL,'UGC 03787',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48282,'SNIa','2016-12-15 15:14:16','2016-12-16 11:19:21','1','SN 2003ch',NULL,48282,35.66,0.16,132,12237,70,NULL,'SALT 2','UGC 03787',0.025,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48283,'SNIa','2016-12-15 15:14:16','2016-12-16 11:19:21','1','SN 2003ch',NULL,48283,35.72,0.16,135,12237,73.8,NULL,'SALT 2 (SNANA)','UGC 03787',0.0304,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48284,'SNIa','2016-12-15 15:14:16','2016-12-16 11:19:21','1','SN 2003ch',NULL,48284,35.83,0.17,143,12237,65,NULL,'SALT','UGC 03787',0.025,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48285,'SNIa','2016-12-15 15:14:16','2016-12-16 11:19:21','1','SN 2003ch',NULL,48285,35.88,0.19,146,12237,65,NULL,'SALT2','UGC 03787',0.025,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48286,'SNIa','2016-12-15 15:14:16','2016-12-16 11:19:21','1','SN 2003ch',NULL,48286,35.97,0.16,153,12237,65,NULL,'MLCS31','UGC 03787',0.025,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48287,'SNIa','2016-12-15 15:14:16','2016-12-16 11:19:21','1','SN 2003ch',NULL,48287,35.98,0.16,153,12237,65,NULL,'MLCS17','UGC 03787',0.025,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48288,'SNIa','2016-12-15 15:14:16','2016-12-16 11:19:21','1','SN 2003ch',NULL,48288,36.15,0.03,166,12237,70,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','UGC 03787',0.025,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48289,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48289,33.45,NULL,49,12238,NULL,NULL,'Dipole','UGC 03784',NULL,'2010Ap&SS.325..163P',2010,1,1.79,NULL,'G',0.000007,NULL,'16.71',0.12,'Sc',NULL,NULL,NULL,NULL,1,109.49425,26.64744,0.369,NULL,63004117311,984439332,15381864,16.71),(48290,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48290,33.46,NULL,49.2,12238,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03784',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48291,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48291,33.46,NULL,49.2,12238,NULL,NULL,'Dipole + Quadrupole','UGC 03784',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48292,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48292,33.64,NULL,53.6,12238,NULL,NULL,NULL,'UGC 03784',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48293,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48293,34.07,0.43,65.2,12238,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03784',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48294,'BL Lac Luminosity','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48294,42.94,NULL,2640,12239,NULL,NULL,NULL,'PMN J0718-2608',0.465,'2005ApJ...635..173S',2005,1,NULL,'Within 10 degrees of the galactic plane.','QSO',0.002,NULL,'18.0',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,109.519875,-26.13656,NULL,NULL,39052524616,610195697,9534307,18),(48295,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48295,36.45,0.61,195,12240,70,NULL,NULL,'2MASX J07180651-6935314',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,109.527125,-69.59203,0.765,NULL,40662299311,635348426,9927319,17.8),(48296,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48296,35.86,0.51,148,12241,70,NULL,NULL,'2MASX J07181196-7025314',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000137,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,109.5499583,-70.42542,0.737,NULL,40663203074,635362548,9927539,16.1),(48297,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48297,35.46,0.48,124,12242,70,NULL,NULL,'ESO 257- G 004',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00013,NULL,'15.36',0.8,'S0',NULL,NULL,NULL,NULL,1,109.560833,-47.19231,0.409,NULL,42661904769,666592262,10415504,15.36),(48298,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48298,36.27,0.52,180,12243,70,NULL,NULL,'2MASX J07181606-7638038',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,109.566625,-76.63436,0.873,NULL,39883955249,623186800,9737293,16.9),(48299,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48299,35.47,0.67,124,12244,70,NULL,NULL,'FAIRALL 0829',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,109.571625,-52.61633,0.441,NULL,40484374727,632568355,9883880,14),(48300,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48300,36.87,0.62,237,12245,70,NULL,NULL,'2MASX J07182368-4951390',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,109.59875,-49.86078,0.377,NULL,42651147970,666424187,10412877,15.7),(48301,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48301,37.24,0.33,280,12246,70,NULL,NULL,'2MASX J07183167+4018343',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',NULL,NULL,'15.8g',0.45,NULL,NULL,NULL,NULL,NULL,1,109.632125,40.30961,0.229,NULL,63599161385,993736896,15527139,15.8),(48302,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48302,34.38,0.49,75,12247,75,NULL,'IR','UGC 03791',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000023,NULL,'15.38',0.2,'Sdm:','Isolated galaxy',NULL,NULL,NULL,1,109.632625,27.15797,0.261,NULL,63011906407,984561037,15383766,15.38),(48303,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48303,34.66,0.2,85.5,12247,74.4,NULL,NULL,'UGC 03791',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48304,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48304,34.73,0.59,88.5,12247,NULL,NULL,'Malmquist cor.','UGC 03791',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48305,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48305,34.85,0.56,93.3,12247,NULL,NULL,NULL,'UGC 03791',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48306,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48306,34.92,0.6,96.3,12248,70,NULL,NULL,'2MASX J07183182-3539431',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,109.632667,-35.66192,1.237,NULL,42579469353,665304208,10395378,15.8),(48307,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48307,37.05,0.46,258,12249,70,NULL,NULL,'2MASX J07183322+4041033',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,109.6385,40.68425,0.209,NULL,63596275558,993691805,15526434,16.8),(48308,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48308,32.25,NULL,28.1,12250,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 428- G 020',NULL,'2010Ap&SS.325..163P',2010,1,1.62,'Star superposed.','G',0.000033,NULL,'15.77',0.22,'Scd',NULL,NULL,NULL,NULL,1,109.6562083,-29.37425,NULL,NULL,39048414619,610131478,9533304,15.77),(48309,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48309,32.27,NULL,28.4,12250,NULL,NULL,'Dipole + Quadrupole','ESO 428- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48310,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48310,32.27,NULL,28.5,12250,NULL,NULL,'Dipole','ESO 428- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48311,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48311,37.24,0.33,280,12251,70,NULL,NULL,'2MASX J07184199+4020363',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,109.675083333,40.34336,0.229,NULL,63599159986,993736874,15527138,16.9),(48312,'IRAS','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48312,33.15,0.8,42.6,12252,75,NULL,'MAT, I','NGC 2369A',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'13.66',1.2,'SA(rs)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,109.681417,-62.93628,0.537,NULL,40364451368,630694552,9854602,13.66),(48313,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48313,33.11,0.32,41.9,12252,85,NULL,'I, raw','NGC 2369A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48314,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48314,33.17,0.32,43,12252,85,NULL,'I, inv','NGC 2369A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48315,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48315,33.2,0.43,43.6,12252,75,NULL,'MAT, I, raw','NGC 2369A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48316,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48316,33.33,0.4,46.3,12252,NULL,NULL,'mean','NGC 2369A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48317,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48317,33.35,0.43,46.7,12252,75,NULL,'MAT, I, cor','NGC 2369A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48318,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48318,33.44,0.43,48.8,12252,75,NULL,'MAT, I, inv','NGC 2369A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48319,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48319,33.47,0.47,49.4,12252,NULL,NULL,'H','NGC 2369A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48320,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48320,33.49,0.46,49.8,12252,NULL,NULL,'J','NGC 2369A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48321,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48321,33.53,0.45,50.8,12252,NULL,NULL,'K','NGC 2369A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48322,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48322,33.8,0.49,57.4,12252,NULL,NULL,'Malmquist cor.','NGC 2369A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48323,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48323,33.93,0.46,61.1,12252,NULL,NULL,NULL,'NGC 2369A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48324,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48324,33.97,0.2,62.2,12252,74.4,NULL,NULL,'NGC 2369A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48325,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48325,35.84,0.58,147,12253,70,NULL,NULL,'FAIRALL 1316',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'15.7B',0.5,NULL,NULL,NULL,NULL,NULL,1,109.6877083,-77.65778,0.849,NULL,39887100366,623235943,9738061,15.7),(48326,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48326,34.11,NULL,66.3,12254,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0623',NULL,'2010Ap&SS.325..163P',2010,1,0.88,'Matthews (2000A&AS..143..421M) detects another feature at v=1053 km/sec.','G',0.000117,NULL,'16.6',0.1,'Sdm',NULL,NULL,NULL,NULL,1,109.712083,13.52472,0.581,NULL,63311456358,989241505,15456898,16.6),(48327,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48327,34.13,NULL,66.9,12254,NULL,NULL,'Dipole + Quadrupole','FGC 0623',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48328,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48328,34.14,NULL,67.2,12254,NULL,NULL,'Dipole','FGC 0623',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48329,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48329,34.19,NULL,68.9,12254,NULL,NULL,NULL,'FGC 0623',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48330,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48330,34.73,NULL,88.3,12255,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 367- G 015',NULL,'2010Ap&SS.325..163P',2010,1,1.66,NULL,'G',0.00004,NULL,'16.73',0.17,'Sc',NULL,NULL,NULL,NULL,1,109.7145417,-35.05044,0.789,NULL,42579144661,665299135,10395298,16.73),(48331,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48331,34.74,NULL,88.8,12255,NULL,NULL,'Dipole + Quadrupole','ESO 367- G 015',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48332,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48332,34.74,NULL,88.9,12255,NULL,NULL,'Dipole','ESO 367- G 015',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48333,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48333,37.17,0.46,272,12256,70,NULL,NULL,'2MASX J07185329+4023462',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,109.722167,40.39622,0.229,NULL,63598303698,993723495,15526929,16.3),(48334,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48334,36.34,0.59,185,12257,70,NULL,NULL,'2MASX J07190229-7701376',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,109.759417,-77.02719,0.833,NULL,39883975484,623187116,9737298,16.7),(48335,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48335,34.92,0.46,96.5,12258,70,NULL,NULL,'2MASX J07190260+4109163',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000083,NULL,'15.23',0.46,NULL,NULL,NULL,NULL,NULL,1,109.760667,41.15458,0.261,NULL,63597085897,993704467,15526632,15.23),(48336,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48336,35.83,0.52,147,12259,70,NULL,NULL,'2MASX J07190372-5025101',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,109.765583,-50.41944,0.377,NULL,42648447931,666381998,10412218,16.7),(48337,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48337,34.2,0.59,69.3,12260,70,NULL,NULL,'ESO 123-IG 002',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000093,NULL,'15.21',0.2,NULL,NULL,NULL,NULL,NULL,1,109.7712083,-59.00936,0.509,NULL,40472883540,632388805,9881075,15.21),(48338,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48338,37.25,0.46,281,12261,70,NULL,NULL,'2MASX J07190726+4012313',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,109.7802083,40.20875,0.229,NULL,63599194292,993737410,15527147,NULL),(48339,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48339,35.25,0.42,112,12262,NULL,NULL,NULL,'ESO 123- G 003',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'16.41',0.3,'S...',NULL,NULL,NULL,NULL,1,109.786916667,-58.84233,0.509,NULL,40472785108,632387267,9881051,16.41),(48340,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48340,35.29,0.2,114,12262,74.4,NULL,NULL,'ESO 123- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48341,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48341,35.41,0.39,121,12262,NULL,NULL,'Malmquist cor.','ESO 123- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48342,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48342,37.63,0.46,336,12263,70,NULL,NULL,'2MASX J07191328+4010093',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,109.805333,40.16928,0.229,NULL,63599197748,993737464,15527147,17.3),(48343,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48343,32.27,0.4,28.4,12264,73,NULL,'opt','ESO 367- G 017',NULL,'2011A&A...532A.104N',2011,1,2.4,NULL,'G',0.000017,NULL,'13.85',1,'(R\':)SB(rl)a   HII',NULL,NULL,NULL,NULL,1,109.8592917,-35.65653,1.157,NULL,42579436462,665303694,10395370,13.85),(48344,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48344,32.27,0.4,28.5,12264,75,NULL,NULL,'ESO 367- G 017',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48345,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48345,32.27,0.4,28.5,12264,73,NULL,'IR','ESO 367- G 017',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48346,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48346,32.46,0.46,31,12264,NULL,NULL,'J','ESO 367- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48347,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48347,32.47,0.47,31.1,12264,NULL,NULL,'H','ESO 367- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48348,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48348,32.52,0.49,31.9,12264,75,NULL,'IR','ESO 367- G 017',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48349,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48349,32.52,0.45,32,12264,NULL,NULL,'K','ESO 367- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48350,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48350,33.02,0.4,40.2,12264,NULL,NULL,'mean','ESO 367- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48351,'SNIa','2016-12-15 15:14:16','2016-12-16 11:19:21','1','SN PTF11qzq',NULL,48351,36.95,0.38,246,12265,72,NULL,'M(H) = -18.317 mag','2MASX J07192718+5413454',NULL,'2014ApJ...784..105W',2013,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,109.863333,54.22928,0.249,NULL,61708596285,964196816,15065575,NULL),(48352,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48352,35.7,0.25,138,12266,74.4,NULL,NULL,'CGCG 261-048',NULL,'2013AJ....146...86T',2013,1,0.13,NULL,'G',0.000028,NULL,'15.7',0.13,NULL,NULL,NULL,NULL,NULL,1,109.868875,55.60883,0.149,NULL,61713635563,964275555,15066805,15.7),(48353,'Maser','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48353,33.3,NULL,46,12267,NULL,NULL,NULL,'UGC 03789',NULL,'2009AAS...21430203B',2009,1,1.6,NULL,'G',0.000053,NULL,'13.30',1.4,'(R)SA(r)ab     Sy2','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,109.878833,59.35511,0.165,NULL,61684136671,963814635,15059603,13.3),(48354,'Maser','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48354,33.45,NULL,49,12267,NULL,NULL,NULL,'UGC 03789',NULL,'2008ASPC..395..103B',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48355,'Maser','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48355,33.48,0.21,49.6,12267,NULL,NULL,NULL,'UGC 03789',NULL,'2013ApJ...767..154R',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48356,'Maser','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48356,33.49,0.29,49.9,12267,NULL,NULL,NULL,'UGC 03789',NULL,'2010ApJ...718..657B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48357,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48357,35.55,0.47,129,12268,NULL,NULL,'H','2MASX J07193355-0104004',NULL,'2007A&A...465...71T',2007,1,0.78,'abs(b) < 10 degrees.','G',0.00003,NULL,'16.8',0.33,'S',NULL,NULL,NULL,NULL,1,109.889791667,-1.06681,NULL,NULL,38790451868,606100810,9470325,16.8),(48358,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48358,35.56,0.45,130,12268,NULL,NULL,'K','2MASX J07193355-0104004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48359,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48359,35.73,0.4,140,12268,NULL,NULL,'mean','2MASX J07193355-0104004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48360,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48360,35.76,0.46,142,12268,NULL,NULL,'J','2MASX J07193355-0104004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48361,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48361,37.31,0.46,290,12269,70,NULL,NULL,'2MASX J07193748+4058044',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,109.906125,40.96797,0.233,NULL,63596345809,993692903,15526451,17),(48362,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48362,35.59,0.52,131,12270,70,NULL,NULL,'2MASX J07194495-5525559',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,109.937333,-55.43214,0.401,NULL,40493348582,632708571,9886071,14.2),(48363,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48363,34.26,0.4,71.1,12271,NULL,NULL,'mean','UGC 03802',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.00003,NULL,'15.34',0.2,'Sa:',NULL,NULL,NULL,NULL,1,109.944875,30.91553,0.329,NULL,62973576322,983962130,15374408,15.34),(48364,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48364,34.42,0.49,76.5,12271,75,NULL,'IR','UGC 03802',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48365,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48365,34.56,0.47,81.6,12271,NULL,NULL,'H','UGC 03802',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48366,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48366,34.65,0.45,85.1,12271,NULL,NULL,'K','UGC 03802',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48367,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48367,34.66,0.46,85.4,12271,NULL,NULL,'J','UGC 03802',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48368,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48368,36.65,0.46,214,12272,70,NULL,NULL,'2MASX J07194971+4021085',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,109.957,40.35258,0.229,NULL,63598326596,993723853,15526935,16.3),(48369,'Tully est','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48369,31.22,0.8,17.6,12273,75,NULL,'B','AM 0720-723',NULL,'1988NBGC.C....0000T',1988,1,2,NULL,'G',0.000024,NULL,'16.1',1.2,'IB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,109.961667,-72.72444,0.749,NULL,39900812725,623450198,9741409,16.1),(48370,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48370,37.36,0.46,296,12274,70,NULL,NULL,'2MASX J07195716+4052035',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',NULL,NULL,'16.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,109.98825,40.86781,0.233,NULL,63596355718,993693058,15526454,16.1),(48371,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48371,36.95,0.46,245,12275,70,NULL,NULL,'2MASX J07195927+3928015',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,109.996791667,39.46719,0.249,NULL,63598961460,993733772,15527090,17.2),(48372,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48372,35.35,0.47,117,12276,NULL,NULL,'H','UGC 03805',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000033,NULL,'14.7',0.4,'S?',NULL,NULL,NULL,NULL,1,110.0034583,17.94572,0.341,NULL,63124924492,986326945,15411358,14.7),(48373,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48373,35.42,0.45,121,12276,NULL,NULL,'K','UGC 03805',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48374,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48374,35.44,0.4,122,12276,NULL,NULL,'mean','UGC 03805',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48375,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48375,35.49,0.46,126,12276,NULL,NULL,'J','UGC 03805',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48376,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48376,34.69,0.1,86.9,12277,NULL,NULL,NULL,'UGC 03799',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000023,NULL,'14.67',0.9,'SAB(s)d',NULL,NULL,NULL,NULL,1,110.027041667,53.01011,0.277,NULL,61707075518,964173054,15065203,14.67),(48377,'GRB','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'RN',48377,41.57,NULL,2060,12278,70,NULL,'Pseudo z = 0.69','GRB 001225',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48378,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48378,34.73,0.25,88.3,12279,74.4,NULL,NULL,'2MASX J07201997+5553051',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000017,NULL,'15.06',NULL,NULL,NULL,NULL,NULL,NULL,1,110.083333,55.88489,0.149,NULL,61714055896,964282123,15066908,15.06),(48379,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48379,36.3,0.46,182,12280,70,NULL,NULL,'2MASX J07202462+3939533',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,110.102583,39.66478,0.245,NULL,63598846685,993731979,15527062,16.5),(48380,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48380,36.45,0.66,195,12281,70,NULL,NULL,'2MASX J07203331-6548021',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,110.138833,-65.80067,0.425,NULL,40642737651,635042775,9922543,14.6),(48381,'IRAS','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48381,33.41,0.8,48.1,12282,75,NULL,'MAT, I','ESO 058- G 028',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'15.63',0.3,'SB(s)d',NULL,NULL,NULL,NULL,1,110.141667,-67.71083,0.625,NULL,40658168422,635283881,9926310,15.63),(48382,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48382,32.3,0.32,28.8,12282,85,NULL,'I, raw','ESO 058- G 028',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48383,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48383,32.57,0.43,32.6,12282,75,NULL,'MAT, I, inv','ESO 058- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48384,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48384,32.67,0.43,34.3,12282,75,NULL,'MAT, I, raw','ESO 058- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48385,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48385,33.02,0.43,40.1,12282,75,NULL,'MAT, I, cor','ESO 058- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48386,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48386,33.25,0.68,44.7,12282,NULL,NULL,NULL,'ESO 058- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48387,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48387,33.29,0.2,45.5,12282,74.4,NULL,NULL,'ESO 058- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48388,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48388,33.51,0.6,50.5,12282,NULL,NULL,'Malmquist cor.','ESO 058- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48389,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48389,37.56,0.46,325,12283,70,NULL,NULL,'2MASX J07204635+4112433',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000175,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,110.193125,41.21197,0.261,NULL,63596246356,993691349,15526427,17.3),(48390,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48390,36.81,0.46,230,12284,70,NULL,NULL,'2MASX J07205120+4141505',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000147,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,110.21325,41.69728,0.265,NULL,63604384126,993818501,15528414,17.7),(48391,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48391,37.49,0.46,314,12285,70,NULL,NULL,'2MASX J07205321+4126595',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00014,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,110.2215,41.44981,0.265,NULL,63603666064,993807282,15528238,17.1),(48392,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48392,35.39,0.42,120,12286,NULL,NULL,NULL,'ESO 123- G 006',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.60',0.2,'S...',NULL,NULL,NULL,NULL,1,110.22575,-58.21603,0.497,NULL,40528781890,633262217,9894722,16.6),(48393,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48393,35.43,0.2,122,12286,74.4,NULL,NULL,'ESO 123- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48394,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48394,35.51,0.4,126,12286,NULL,NULL,'Malmquist cor.','ESO 123- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48395,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48395,32.6,0.4,33.1,12287,75,NULL,'B','UGC 03808',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000017,NULL,'14.6',0.9,'SB(s)d:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,110.258333,25.17861,0.309,NULL,62957268584,983707321,15370426,14.6),(48396,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48396,33.48,0.4,49.7,12287,NULL,NULL,NULL,'UGC 03808',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48397,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48397,33.57,0.2,51.8,12287,74.4,NULL,NULL,'UGC 03808',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48398,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48398,37.38,0.46,299,12288,70,NULL,NULL,'2MASX J07210415+4103085',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,110.26725,41.05236,0.233,NULL,63596373948,993693342,15526458,17.2),(48399,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48399,35.19,0.47,109,12289,NULL,NULL,'H','ESO 367- G 018',NULL,'2007A&A...465...71T',2007,1,1.2,'abs(b) < 10 degrees.','G',0.000037,NULL,'15.18',0.7,'SAB(s)bc?',NULL,NULL,NULL,NULL,1,110.2872083,-34.39394,NULL,NULL,42580356075,665318063,10395594,15.18),(48400,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48400,35.31,0.4,115,12289,NULL,NULL,'mean','ESO 367- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48401,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48401,35.35,0.45,117,12289,NULL,NULL,'K','ESO 367- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48402,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48402,35.39,0.46,120,12289,NULL,NULL,'J','ESO 367- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48403,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48403,37.18,0.57,273,12290,70,NULL,NULL,'2MASX J07210920-4905172',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000103,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,110.288458333,-49.08806,0.549,NULL,42650446880,666413232,10412706,14.4),(48404,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48404,37.39,0.46,301,12291,70,NULL,NULL,'2MASX J07211710+4117535',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000174,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,110.3214583,41.29828,0.261,NULL,63603625174,993806643,15528228,18.5),(48405,'IRAS','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48405,31.14,0.8,16.9,12292,75,NULL,'MAT, I','NGC 2397',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000033,NULL,'12.68',1.2,'SAB(rs)b','in a pair',NULL,NULL,NULL,1,110.33325,-69.00147,0.761,NULL,40664620104,635384689,9927885,12.68),(48406,'Tully est','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48406,30.87,0.8,14.9,12292,75,NULL,'B','NGC 2397',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48407,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48407,31.36,0.43,18.7,12292,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2397',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48408,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48408,31.48,0.43,19.8,12292,75,NULL,'3.6 micron, color corrected','NGC 2397',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48409,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48409,31.54,0.4,20.3,12292,NULL,NULL,NULL,'NGC 2397',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48410,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48410,31.54,0.4,20.3,12292,73,NULL,'opt','NGC 2397',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48411,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48411,31.68,0.32,21.7,12292,85,NULL,'I, raw','NGC 2397',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48412,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48412,31.73,0.32,22.2,12292,85,NULL,'I, inv','NGC 2397',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48413,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48413,31.74,0.2,22.3,12292,74.4,NULL,NULL,'NGC 2397',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48414,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48414,31.82,0.43,23.1,12292,75,NULL,'MAT, I, raw','NGC 2397',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48415,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48415,32.03,0.43,25.5,12292,75,NULL,'MAT, I, inv','NGC 2397',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48416,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48416,32.07,0.4,25.9,12292,73,NULL,'opt','NGC 2397',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48417,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48417,32.07,0.43,26,12292,75,NULL,'MAT, I, cor','NGC 2397',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48418,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48418,32.08,0.5,26,12292,NULL,NULL,'Malmquist cor.','NGC 2397',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48419,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48419,32.28,0.46,28.6,12292,NULL,NULL,NULL,'NGC 2397',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48420,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48420,36.38,0.25,189,12293,74.4,NULL,NULL,'2MASX J07212160+5548397',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000067,NULL,'14.37',0.8,'D',NULL,NULL,NULL,NULL,1,110.340167,55.81111,0.149,NULL,61714015087,964281485,15066898,14.37),(48421,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48421,35.91,0.25,152,12294,74.4,NULL,NULL,'2MASX J07212207+5547547',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000025,NULL,'14.17',NULL,NULL,NULL,NULL,NULL,NULL,1,110.3419583,55.79858,0.149,NULL,61714014298,964281473,15066898,14.17),(48422,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48422,34.98,0.25,99.1,12295,74.4,NULL,NULL,'2MASX J07213702+5610196',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000019,NULL,'15.25',NULL,NULL,NULL,NULL,NULL,NULL,1,110.4040417,56.172,0.149,NULL,61714983714,964296620,15067134,15.25),(48423,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48423,37.16,0.46,271,12296,70,NULL,NULL,'2MASX J07214817+4217108',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000188,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,110.450625,42.28628,0.273,NULL,63604304094,993817251,15528394,16.8),(48424,'BL Lac Luminosity','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48424,38.54,1.16,510,12297,70,NULL,NULL,'[HB89] 0716+714',NULL,'2014ApJ...784..151S',2014,1,NULL,'2008ApJ...672..115L quotes z = 2.06 from an unknown source.','QSO',NULL,':','15.5V',NULL,'HPQ;blazar     BLLAC',NULL,NULL,'radio jet','Flat-Spectrum Radio Source',1,110.4727083,71.34344,0.069,NULL,62198236392,971847443,15185116,15.5),(48425,'BL Lac Luminosity','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48425,40,0.27,998,12297,70,NULL,'Pseudo redshift z = 0.268 +/- 0.036','[HB89] 0716+714',NULL,'2013ApJ...764...57D',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48426,'GeV TeV ratio','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48426,38.26,NULL,448,12297,72,NULL,NULL,'[HB89] 0716+714',NULL,'2010MNRAS.405L..76P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48427,'GeV TeV ratio','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48427,39.65,0.67,850,12297,72,NULL,NULL,'[HB89] 0716+714',NULL,'2011arXiv1111.0913P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48428,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48428,36.85,0.65,234,12298,70,NULL,NULL,'2MASX J07220220-4958278',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.4,NULL,NULL,NULL,NULL,NULL,1,110.5092917,-49.97447,0.493,NULL,42651184368,666424755,10412886,14.2),(48429,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48429,32.23,0.45,27.9,12299,NULL,NULL,'K','ESO 428- G 023',NULL,'2007A&A...465...71T',2007,1,2,'abs(b) < 10 degrees.','G',0.00002,NULL,'13.41',1.1,'(R\':)SB(rl)a',NULL,NULL,NULL,NULL,1,110.53925,-29.23556,NULL,NULL,39045714656,610089291,9532645,13.41),(48430,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48430,32.23,0.46,28,12299,NULL,NULL,'J','ESO 428- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48431,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48431,32.23,0.47,28,12299,NULL,NULL,'H','ESO 428- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48432,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48432,33.01,0.4,40,12299,NULL,NULL,'mean','ESO 428- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48433,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48433,30.93,0.46,15.4,12300,NULL,NULL,'J','MCG -01-19-001',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.00006,NULL,'15',0.2,'Sb: sp',NULL,NULL,NULL,NULL,1,110.545333333,-5.92967,NULL,NULL,39582735818,618480247,9663753,15),(48434,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48434,31.03,0.47,16.1,12300,NULL,NULL,'H','MCG -01-19-001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48435,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48435,31.09,0.4,16.5,12300,73,NULL,'IR','MCG -01-19-001',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48436,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48436,31.09,0.4,16.5,12300,75,NULL,NULL,'MCG -01-19-001',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48437,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48437,31.14,0.45,16.9,12300,NULL,NULL,'K','MCG -01-19-001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48438,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48438,31.45,0.49,19.5,12300,75,NULL,'IR','MCG -01-19-001',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48439,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48439,31.63,0.4,21.1,12300,NULL,NULL,'mean','MCG -01-19-001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48440,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48440,34.61,0.43,83.5,12301,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 086-018',NULL,'2014MNRAS.444..527S',2014,1,NULL,NULL,'G',0.000067,NULL,'15.6',NULL,NULL,NULL,NULL,NULL,NULL,1,110.546791667,18.89086,0.269,NULL,63136672189,986510502,15414226,15.6),(48441,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48441,34.9,0.43,95.7,12301,75,NULL,'3.6 micron, color corrected','CGCG 086-018',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48442,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48442,35.24,0.2,112,12301,74.4,NULL,NULL,'CGCG 086-018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48443,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48443,32.84,0.4,37.1,12302,75,NULL,NULL,'UGC 03820',NULL,'2008Ap.....51..336K',2008,1,1.68,NULL,'G',0.000004,NULL,'14.9',0.21,'Sbc',NULL,NULL,NULL,NULL,1,110.583583,17.28686,0.305,NULL,63128210508,986378289,15412160,14.9),(48444,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48444,32.89,0.43,37.9,12302,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03820',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48445,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48445,33.12,0.43,42.2,12302,75,NULL,'3.6 micron, color corrected','UGC 03820',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48446,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48446,33.35,0.49,46.7,12302,75,NULL,'IR','UGC 03820',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48447,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48447,33.38,0.2,47.4,12302,74.4,NULL,NULL,'UGC 03820',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48448,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48448,33.56,0.48,51.6,12302,NULL,NULL,NULL,'UGC 03820',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48449,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48449,33.92,NULL,60.9,12302,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03820',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48450,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48450,33.93,NULL,61.1,12302,NULL,NULL,'Dipole + Quadrupole','UGC 03820',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48451,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48451,33.93,NULL,61.2,12302,NULL,NULL,'Dipole','UGC 03820',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48452,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48452,33.99,0.39,62.8,12302,NULL,NULL,'Malmquist cor.','UGC 03820',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48453,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48453,34.04,NULL,64.4,12302,NULL,NULL,NULL,'UGC 03820',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48454,'Sosies','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48454,33.06,0.11,40.9,12303,NULL,NULL,NULL,'NGC 2365',NULL,'2002A&A...393...57T',2002,1,2.4,NULL,'G',0.000023,NULL,'13.3',1.3,'SABa',NULL,NULL,NULL,NULL,1,110.5939583,22.08328,0.269,NULL,63145219018,986644047,15416313,13.3),(48455,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48455,32.38,0.34,29.9,12303,NULL,NULL,'Malmquist cor.','NGC 2365',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48456,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48456,32.61,0.31,33.2,12303,NULL,NULL,NULL,'NGC 2365',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48457,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48457,32.65,0.2,33.9,12303,74.4,NULL,NULL,'NGC 2365',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48458,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48458,32.93,0.4,38.5,12303,NULL,NULL,'mean','NGC 2365',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48459,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48459,33.12,0.47,42.1,12303,NULL,NULL,'H','NGC 2365',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48460,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48460,33.16,0.45,42.9,12303,NULL,NULL,'K','NGC 2365',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48461,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48461,33.18,0.46,43.3,12303,NULL,NULL,'J','NGC 2365',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48462,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48462,32.21,0.69,27.6,12304,100,NULL,'mid-IR','UGC 03804',NULL,'2013ApJ...771...88L',2013,1,1.8,NULL,'G',0.00003,NULL,'13.10',1.1,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,110.644541667,71.59894,0.073,NULL,62197479914,971835623,15184931,13.1),(48463,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48463,33.1,0.43,41.6,12304,75,NULL,'3.6 micron, color corrected','UGC 03804',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48464,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48464,33.11,0.2,41.9,12304,74.4,NULL,NULL,'UGC 03804',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48465,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48465,33.14,0.43,42.4,12304,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03804',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48466,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48466,33.2,0.4,43.7,12304,NULL,NULL,'mean','UGC 03804',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48467,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48467,33.22,0.51,44.1,12304,NULL,NULL,NULL,'UGC 03804',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48468,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48468,33.3,0.45,45.6,12304,NULL,NULL,'K','UGC 03804',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48469,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48469,33.33,0.46,46.4,12304,NULL,NULL,'J','UGC 03804',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48470,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48470,33.34,0.47,46.6,12304,NULL,NULL,'H','UGC 03804',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48471,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48471,33.35,0.49,46.7,12304,NULL,NULL,'Malmquist cor.','UGC 03804',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48472,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48472,37.44,0.46,308,12305,70,NULL,NULL,'2MASX J07223570+4112124',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,110.648917,41.20361,0.249,NULL,63603527276,993805113,15528204,17.5),(48473,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48473,35.65,0.6,135,12306,70,NULL,NULL,'2MASX J07223729-4956353',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.3,NULL,NULL,NULL,NULL,NULL,1,110.655291667,-49.94311,0.493,NULL,42651653429,666432084,10413001,14),(48474,'Brightest Stars','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48474,29.66,0.2,8.55,12307,NULL,NULL,NULL,'UGC 03817',NULL,'1998A&AS..133..181M',1998,1,1.8,NULL,'G',0.000001,NULL,'17.',0.9,'Im:','Group member',NULL,NULL,NULL,1,110.685333333,45.10853,0.337,NULL,63575131313,993361426,15521272,17),(48475,'Tully est','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48475,29.6,0.8,8.3,12307,75,NULL,NULL,'UGC 03817',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48476,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48476,35.78,0.53,143,12308,70,NULL,NULL,'2MASX J07224472-5932285',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,110.686333,-59.54139,0.625,NULL,40472184478,632377882,9880904,16.9),(48477,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48477,37.33,0.46,293,12309,70,NULL,NULL,'2MASX J07224657+3816484',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000188,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,110.694125,38.28019,0.265,NULL,63593095128,993642111,15525657,17.9),(48478,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48478,35.54,0.4,128,12310,NULL,NULL,'mean','UGC 03823',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000033,NULL,'14.7',0.7,'Sb',NULL,NULL,NULL,NULL,1,110.6984583,18.92756,0.237,NULL,63135955971,986499312,15414051,14.7),(48479,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48479,35.58,0.47,131,12310,NULL,NULL,'H','UGC 03823',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48480,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48480,35.7,0.45,138,12310,NULL,NULL,'K','UGC 03823',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48481,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48481,35.74,0.46,140,12310,NULL,NULL,'J','UGC 03823',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48482,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48482,38.02,0.27,402,12311,70,NULL,NULL,'2MASX J07224841+4129214',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000198,NULL,'16.8g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,110.7017917,41.48928,0.241,NULL,63603727714,993808245,15528253,16.8),(48483,'IRAS','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48483,33.2,0.8,43.7,12312,75,NULL,'MAT, I','ESO 123- G 009',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.00001,NULL,'14.38',1,'SA(r)bc',NULL,NULL,NULL,NULL,1,110.710083333,-62.02903,0.617,NULL,40350410729,630475167,9851174,14.38),(48484,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48484,32.67,0.43,34.2,12312,75,NULL,'3.6 micron, color + selection bias corrected','ESO 123- G 009',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48485,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48485,32.74,0.32,35.3,12312,85,NULL,'I, raw','ESO 123- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48486,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48486,32.76,0.32,35.6,12312,85,NULL,'I, inv','ESO 123- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48487,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48487,32.86,0.43,37.3,12312,75,NULL,'3.6 micron, color corrected','ESO 123- G 009',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48488,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48488,32.93,0.43,38.5,12312,75,NULL,'MAT, I, raw','ESO 123- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48489,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48489,33.05,0.43,40.7,12312,75,NULL,'MAT, I, inv','ESO 123- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48490,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48490,33.13,0.43,42.2,12312,75,NULL,'MAT, I, cor','ESO 123- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48491,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48491,33.18,0.2,43.3,12312,74.4,NULL,NULL,'ESO 123- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48492,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48492,33.26,0.4,44.8,12312,NULL,NULL,'mean','ESO 123- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48493,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48493,33.28,0.47,45.2,12312,NULL,NULL,'H','ESO 123- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48494,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48494,33.32,0.46,46,12312,NULL,NULL,'J','ESO 123- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48495,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48495,33.42,0.45,48.4,12312,NULL,NULL,'K','ESO 123- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48496,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48496,33.6,0.5,52.6,12312,NULL,NULL,'Malmquist cor.','ESO 123- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48497,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48497,33.71,0.47,55.1,12312,NULL,NULL,NULL,'ESO 123- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48498,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48498,37.94,0.46,386,12313,70,NULL,NULL,'2MASX J07225276+4145054',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,110.719875,41.75142,0.241,NULL,63603566487,993805726,15528214,17.9),(48499,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48499,38.03,0.46,404,12314,70,NULL,NULL,'2MASX J07225473+4048394',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000143,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,110.72825,40.81111,0.233,NULL,63598232009,993722375,15526912,17.7),(48500,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48500,36.57,0.68,207,12315,70,NULL,NULL,'2MASX J07225796-5044375',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,110.741583333,-50.74381,0.389,NULL,42648516181,666383065,10412235,15.5),(48501,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48501,38.02,0.27,402,12316,70,NULL,NULL,'2MASX J07225980+4132334',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000182,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,110.749333,41.54272,0.241,NULL,63603580940,993805952,15528218,17.5),(48502,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48502,38.02,0.27,402,12317,70,NULL,NULL,'SDSS J072300.14+412633.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,110.750625,41.44253,0.241,NULL,63603709296,993807957,15528249,18.6),(48503,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48503,34.05,0.47,64.5,12318,70,NULL,NULL,'ESO 257- G 013',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000137,NULL,'15.47',1,'(R\'_2)SB(s)0/a:',NULL,NULL,NULL,NULL,1,110.757333,-45.58642,0.497,NULL,42659053630,666547712,10414808,15.47),(48504,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48504,38.37,0.27,473,12319,70,NULL,NULL,'2MASX J07230626+4247163',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,110.7760417,42.78778,0.281,NULL,63605722221,993839409,15528740,17.9),(48505,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48505,35.7,0.46,138,12320,70,NULL,NULL,'2MASX J07230649+3904054',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,110.777041667,39.06822,0.261,NULL,63591261671,993613463,15525210,16.9),(48506,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48506,33.89,0.44,60.1,12321,NULL,NULL,NULL,'UGC 03827',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.00002,NULL,'14.48',0.9,'SB?',NULL,NULL,NULL,NULL,1,110.7807083,22.20803,0.269,NULL,63145198899,986643732,15416308,14.48),(48507,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48507,33.93,0.2,61.1,12321,74.4,NULL,NULL,'UGC 03827',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48508,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48508,34.15,0.4,67.5,12321,NULL,NULL,'Malmquist cor.','UGC 03827',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48509,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48509,35.04,0.61,102,12322,70,NULL,NULL,'ESO 123- G 010',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'15.47',0.7,'SAB(rs)b:',NULL,NULL,NULL,NULL,1,110.79,-60.49878,0.645,NULL,40483246683,632550729,9883605,15.47),(48510,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48510,33.45,0.4,48.9,12323,NULL,NULL,'mean','UGC 03816',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.00008,NULL,'13.81',0.8,'S0','in a pair',NULL,NULL,NULL,1,110.801667,58.06478,0.157,NULL,61727884259,964498191,15070284,13.81),(48511,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48511,34.35,0.45,74.3,12323,NULL,NULL,'K','UGC 03816',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48512,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48512,34.73,0.51,88.5,12324,NULL,NULL,'Malmquist cor.','UGC 03822',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.00011,NULL,'14.70',0.8,'SB(rs)bc',NULL,NULL,NULL,NULL,1,110.80375,37.45925,0.297,NULL,63592366607,993630728,15525480,14.7),(48513,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48513,35.17,0.2,108,12324,74.4,NULL,NULL,'UGC 03822',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48514,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,NULL,48514,35.25,0.4,112,12324,NULL,NULL,NULL,'UGC 03822',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48515,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48515,35.93,0.46,154,12325,70,NULL,NULL,'2MASX J07232235+4200342',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000166,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,110.843,42.00933,0.265,NULL,63604453208,993819581,15528430,16.8),(48516,'FP','2016-12-15 15:14:16','2016-12-16 11:19:21','1',NULL,'R',48516,38.37,0.27,473,12326,70,NULL,NULL,'2MASX J07232778+4303058',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000183,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,110.865875,43.05164,0.281,NULL,63605820643,993840947,15528764,17.4),(48517,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48517,37.67,0.46,343,12327,70,NULL,NULL,'2MASX J07232961+3759228',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,110.8734583,37.98975,0.245,NULL,63592726903,993636357,15525568,17.1),(48518,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48518,30.79,0.4,14.4,12328,73,NULL,'IR','UGC 03830',NULL,'2011A&A...532A.104N',2011,1,1.2,NULL,'G',0.000013,NULL,'14.86',0.4,'SBd?',NULL,NULL,NULL,NULL,1,110.87725,2.61581,NULL,NULL,63219533716,987805214,15434456,14.86),(48519,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48519,30.8,0.4,14.5,12328,75,NULL,NULL,'UGC 03830',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48520,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48520,31.01,0.47,15.9,12328,NULL,NULL,'H','UGC 03830',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48521,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48521,31.05,0.45,16.2,12328,NULL,NULL,'K','UGC 03830',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48522,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48522,31.11,0.49,16.7,12328,75,NULL,'IR','UGC 03830',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48523,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48523,31.11,0.46,16.7,12328,NULL,NULL,'J','UGC 03830',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48524,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48524,31.51,0.4,20.1,12328,NULL,NULL,'mean','UGC 03830',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48525,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48525,34.54,0.47,80.9,12329,70,NULL,NULL,'FAIRALL 0830',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,110.901875,-52.63628,0.473,NULL,40417278762,631519980,9867499,15.3),(48526,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48526,36.49,0.46,199,12330,70,NULL,NULL,'2MASX J07233697+4141439',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.0002,NULL,'15.9g',0.4,NULL,NULL,NULL,NULL,NULL,1,110.9042083,41.69553,0.241,NULL,63603602365,993806286,15528223,15.9),(48527,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48527,32.29,0.43,28.7,12331,75,NULL,'3.6 micron, color + selection bias corrected','ESO 428- G 028',NULL,'2014MNRAS.444..527S',2014,1,3.25,'abs(b) < 10 degrees.','G',0.000027,NULL,'14.51',0.45,'Sd',NULL,NULL,NULL,NULL,1,110.9107917,-30.05111,NULL,NULL,42572214269,665190847,10393606,14.51),(48528,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48528,32.45,0.4,30.9,12331,NULL,NULL,NULL,'ESO 428- G 028',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48529,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48529,32.49,0.47,31.5,12331,NULL,NULL,'H','ESO 428- G 028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48530,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48530,32.49,0.45,31.5,12331,NULL,NULL,'K','ESO 428- G 028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48531,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48531,32.5,0.46,31.6,12331,NULL,NULL,'J','ESO 428- G 028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48532,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48532,32.5,0.39,31.6,12331,73,NULL,'opt','ESO 428- G 028',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48533,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48533,32.53,0.43,32.1,12331,75,NULL,'3.6 micron, color corrected','ESO 428- G 028',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48534,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48534,32.55,0.4,32.4,12331,73,NULL,'IR','ESO 428- G 028',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48535,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48535,32.55,0.4,32.4,12331,75,NULL,NULL,'ESO 428- G 028',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48536,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48536,32.72,0.2,35,12331,74.4,NULL,NULL,'ESO 428- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48537,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48537,32.74,0.4,35.3,12331,NULL,NULL,'mean','ESO 428- G 028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48538,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48538,32.75,0.49,35.5,12331,75,NULL,'IR','ESO 428- G 028',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48539,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48539,33.29,NULL,45.5,12331,NULL,NULL,'Dipole','ESO 428- G 028',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48540,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48540,33.3,NULL,45.6,12331,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 428- G 028',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48541,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48541,33.3,NULL,45.8,12331,NULL,NULL,'Dipole + Quadrupole','ESO 428- G 028',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48542,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48542,38.17,0.46,431,12332,70,NULL,NULL,'SDSS J072339.98+384121.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000152,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,110.916625,38.68933,0.237,NULL,63593190090,993643595,15525681,18.6),(48543,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48543,32.02,0.47,25.4,12333,NULL,NULL,'H','ESO 428- G 029',NULL,'2007A&A...465...71T',2007,1,1.77,'abs(b) < 10 degrees.','G',0.00001,NULL,'13.42',1.38,'SA(r)ab',NULL,NULL,NULL,NULL,1,110.925,-29.65233,NULL,NULL,39044827772,610075433,9532428,13.42),(48544,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48544,32.03,0.45,25.4,12333,NULL,NULL,'K','ESO 428- G 029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48545,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48545,32.1,0.46,26.3,12333,NULL,NULL,'J','ESO 428- G 029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48546,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48546,32.46,0.4,31.1,12333,NULL,NULL,'mean','ESO 428- G 029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48547,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48547,35.54,0.56,128,12334,70,NULL,NULL,'2MASX J07234207-6047093',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,110.9252083,-60.78589,0.633,NULL,40482562571,632540040,9883438,16.6),(48548,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48548,38.12,0.46,422,12335,70,NULL,NULL,'2MASX J07234214+4057519',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000149,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,110.925667,40.96431,0.233,NULL,63617121603,994017525,15531523,18.2),(48549,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48549,38.37,0.27,473,12336,70,NULL,NULL,'2MASX J07234557+4301339',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,110.939833333,43.02603,0.281,NULL,63605817933,993840905,15528764,18.1),(48550,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48550,36.62,0.66,210,12337,70,NULL,NULL,'2MASX J07235240-5050536',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,110.9682917,-50.84817,0.389,NULL,42648109919,666376717,10412136,17),(48551,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48551,37.63,0.46,335,12338,70,NULL,NULL,'2MASX J07235452+4157217',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,110.9770417,41.95617,0.265,NULL,63604406748,993818855,15528419,18.2),(48552,'SBF','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48552,32.05,0.35,25.7,12339,NULL,NULL,'I','NGC 2380',NULL,'2001ApJ...546..681T',2001,1,2.43,'abs(b) < 10 degrees.','G',0.000123,NULL,'12.27',2.33,'SAB0^0^:',NULL,NULL,NULL,NULL,1,110.978125,-27.52906,NULL,NULL,39001703093,609401610,9521900,12.27),(48553,'SBF','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48553,32.05,0.35,25.7,12339,NULL,NULL,NULL,'NGC 2380',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48554,'SBF','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48554,32.07,0.14,25.9,12339,74.4,NULL,NULL,'NGC 2380',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48555,'SBF','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48555,32.27,0.35,28.5,12339,NULL,NULL,'Malmquist cor.','NGC 2380',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48556,'D-Sigma','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48556,31.2,0.4,17.4,12339,75,NULL,'Edat, raw','NGC 2380',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48557,'D-Sigma','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48557,31.54,0.4,20.3,12339,75,NULL,'Edat, cor','NGC 2380',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48558,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48558,31.2,0.41,17.4,12339,NULL,NULL,NULL,'NGC 2380',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48559,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48559,31.56,0.41,20.5,12339,NULL,NULL,'Malmquist cor.','NGC 2380',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48560,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48560,37.44,0.46,308,12340,70,NULL,NULL,'2MASX J07240078+4105048',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00014,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,111.003333,41.08472,0.249,NULL,63617169701,994018276,15531535,17.7),(48561,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48561,37.59,0.46,330,12341,70,NULL,NULL,'2MASX J07240113+4003117',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.72',0.39,NULL,NULL,NULL,NULL,NULL,1,111.004667,40.05336,0.201,NULL,63591091246,993610800,15525168,16.72),(48562,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48562,38.42,0.46,484,12342,70,NULL,NULL,'2MASX J07240146+4127328',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000194,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,111.0059583,41.45914,0.241,NULL,63617256369,994019630,15531556,17.7),(48563,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48563,36.44,0.46,194,12343,70,NULL,NULL,'CGCG 176-044',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000143,NULL,'15.4g',0.44,'S0/a',NULL,NULL,NULL,NULL,1,111.0217917,37.95314,0.185,NULL,63593383164,993646611,15525728,15.4),(48564,'SGRB','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'N',48564,38.73,NULL,557,12344,71,NULL,NULL,'GRB 061006 HOST',NULL,'2010ApJ...709..664R',2010,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48565,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48565,38.15,0.46,426,12345,70,NULL,NULL,'2MASX J07242663+4237114',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,111.111,42.61992,0.305,NULL,63603757147,993808705,15528261,17.8),(48566,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48566,32.17,0.4,27.2,12346,75,NULL,'B','UGC 03826',NULL,'1988NBGC.C....0000T',1988,1,3.5,NULL,'G',0.000003,NULL,'14.1',3,'SAB(s)d','Isolated galaxy',NULL,NULL,NULL,1,111.1162083,61.69389,0.193,NULL,61675059443,963672803,15057387,14.1),(48567,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48567,32.43,0.72,30.6,12347,NULL,NULL,'Malmquist cor.','UGC 03828',NULL,'2009ApJS..182..474S',2009,1,1.7,NULL,'G',0.00002,NULL,'12.90',0.9,'SAB(rs)b','in a pair',NULL,NULL,NULL,1,111.149041667,57.96756,0.157,NULL,61728056231,964500878,15070326,12.9),(48568,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48568,32.44,0.47,30.8,12347,NULL,NULL,'H','UGC 03828',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48569,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48569,32.48,0.45,31.4,12347,NULL,NULL,'K','UGC 03828',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48570,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48570,32.5,0.2,31.6,12347,74.4,NULL,NULL,'UGC 03828',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48571,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48571,32.52,0.46,31.8,12347,NULL,NULL,'J','UGC 03828',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48572,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48572,32.63,0.69,33.6,12347,100,NULL,'mid-IR','UGC 03828',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48573,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48573,32.73,0.62,35.2,12347,NULL,NULL,NULL,'UGC 03828',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48574,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48574,33.41,0.4,48.1,12347,NULL,NULL,'mean','UGC 03828',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48575,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48575,34.1,NULL,66.2,12348,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03460A',NULL,'2010Ap&SS.325..163P',2010,1,1.12,'UGC Addenda incorrectly has 06h21.9m.','G',0.000014,NULL,'16.5',0.08,'Sd',NULL,NULL,NULL,NULL,1,111.149875,6.14914,0.709,NULL,63277798158,988715596,15448681,16.5),(48576,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48576,34.11,NULL,66.5,12348,NULL,NULL,'Dipole + Quadrupole','UGC 03460A',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48577,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48577,34.13,NULL,67,12348,NULL,NULL,'Dipole','UGC 03460A',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48578,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48578,34.13,NULL,67.1,12348,NULL,NULL,NULL,'UGC 03460A',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48579,'D-Sigma','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48579,33.46,0.4,49.3,12349,75,NULL,'Edat, raw','ESO 005- G 007',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',NULL,NULL,'15.23',1,'S0',NULL,NULL,NULL,NULL,1,111.151875,-85.49708,0.573,NULL,39784583514,621634117,9713033,15.23),(48580,'D-Sigma','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48580,33.75,0.4,56.3,12349,75,NULL,'Edat, cor','ESO 005- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48581,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48581,38.09,0.46,416,12350,70,NULL,NULL,'2MASX J07244262+4222186',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,111.1774583,42.37183,0.297,NULL,63603951630,993811744,15528308,17.4),(48582,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48582,36.6,0.46,209,12351,70,NULL,NULL,'2MASX J07244979+4118171',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000146,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,111.2075,41.30461,0.249,NULL,63617324058,994020688,15531573,17),(48583,'Tully est','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48583,32.51,0.8,31.8,12352,75,NULL,NULL,'NGC 2377',NULL,'1988NBGC.C....0000T',1988,1,1.7,'Not the radio source 3C 178.','G',0.00001,NULL,'13.54',1.3,'SA(s)c:        HII','Group member, radial-velocity confirmed',NULL,NULL,'H II',1,111.23675,-9.65931,NULL,NULL,39574207491,618346992,9661671,13.54),(48584,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48584,31,0.45,15.9,12352,NULL,NULL,'K','NGC 2377',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48585,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48585,31.01,0.47,15.9,12352,NULL,NULL,'H','NGC 2377',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48586,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48586,31.11,0.46,16.7,12352,NULL,NULL,'J','NGC 2377',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48587,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48587,32.32,0.4,29.1,12352,NULL,NULL,'mean','NGC 2377',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48588,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48588,36.27,0.46,179,12353,70,NULL,NULL,'CGCG 205-042',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000103,NULL,'15.7',0.3,NULL,NULL,NULL,NULL,NULL,1,111.244541667,40.10997,0.201,NULL,63591078013,993610593,15525165,15.7),(48589,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48589,38.51,0.33,505,12354,70,NULL,NULL,'2MASX J07245877+3754561',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,111.245,37.91547,0.185,NULL,63593444977,993647577,15525743,17.4),(48590,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48590,32.33,0.4,29.3,12355,NULL,NULL,'mean','ESO 428- G 031',NULL,'2007A&A...465...71T',2007,1,1.9,'abs(b) < 10 degrees.','G',0.000013,NULL,'14.46',0.4,'Scd: sp',NULL,NULL,NULL,NULL,1,111.2565417,-32.49903,NULL,NULL,42574623613,665228493,10394195,14.46),(48591,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48591,32.37,0.47,29.8,12355,NULL,NULL,'H','ESO 428- G 031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48592,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48592,32.39,0.46,30.1,12355,NULL,NULL,'J','ESO 428- G 031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48593,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48593,32.52,0.45,32,12355,NULL,NULL,'K','ESO 428- G 031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48594,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48594,34.4,0.42,75.9,12356,NULL,NULL,'Malmquist cor.','NGC 2370',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.00003,NULL,'14.60',0.5,'SB?',NULL,NULL,NULL,NULL,1,111.256917,23.78322,0.225,NULL,63087252389,985738318,15402161,14.6),(48595,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48595,34.49,0.45,79.1,12356,NULL,NULL,'K','NGC 2370',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48596,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48596,34.5,0.47,79.5,12356,NULL,NULL,'H','NGC 2370',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48597,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48597,34.57,0.46,82.2,12356,NULL,NULL,'J','NGC 2370',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48598,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48598,34.61,0.4,83.5,12356,NULL,NULL,'mean','NGC 2370',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48599,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48599,34.65,0.38,85.1,12356,NULL,NULL,NULL,'NGC 2370',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48600,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48600,34.69,0.2,86.7,12356,74.4,NULL,NULL,'NGC 2370',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48601,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48601,38.51,0.33,505,12357,70,NULL,NULL,'SDSS J072504.70+375504.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000158,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,111.269625,37.91778,0.185,NULL,63593445368,993647583,15525743,18.4),(48602,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48602,35.68,0.45,137,12358,NULL,NULL,'Malmquist cor.','ESO 088- G 013',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000033,NULL,'15.42',0.6,'S?',NULL,NULL,NULL,NULL,1,111.2785417,-63.53397,0.701,NULL,40352077633,630501213,9851581,15.42),(48603,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48603,35.93,0.4,154,12358,NULL,NULL,NULL,'ESO 088- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48604,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48604,35.97,0.2,156,12358,74.4,NULL,NULL,'ESO 088- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48605,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48605,37.49,0.23,315,12359,70,NULL,NULL,'SDSS J072507.08+413908.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000155,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,111.2795,41.65247,0.261,NULL,63617294196,994020221,15531565,18.4),(48606,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48606,37.49,0.23,315,12360,70,NULL,NULL,'2MASX J07250980+4131057',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000183,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,111.29075,41.51825,0.261,NULL,63617287711,994020120,15531564,17.5),(48607,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48607,34.59,0.4,82.6,12361,NULL,NULL,'mean','UGC 03839',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000023,NULL,'14.1',0.9,'SBb',NULL,NULL,NULL,NULL,1,111.293125,9.51578,0.405,NULL,63246947146,988233549,15441149,14.1),(48608,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48608,34.79,0.47,90.6,12361,NULL,NULL,'H','UGC 03839',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48609,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48609,38.84,0.46,587,12362,70,NULL,NULL,'2MASX J07251136+3803176',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000174,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,111.2972917,38.05492,0.185,NULL,63593420462,993647194,15525737,17.8),(48610,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48610,38.15,0.46,427,12363,70,NULL,NULL,'2MASX J07251393+4216028',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,111.308125,42.26739,0.297,NULL,63617742933,994027233,15531675,18.3),(48611,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48611,37.22,0.27,277,12364,70,NULL,NULL,'2MASX J07251884+4200058',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,111.328375,42.00158,0.317,NULL,63617701164,994026580,15531665,17.8),(48612,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48612,37.49,0.23,315,12365,70,NULL,NULL,'2MASX J07252059+4139006',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000015,NULL,'16.8g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,111.335667,41.65025,0.261,NULL,63617290783,994020168,15531565,16.8),(48613,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48613,36.85,0.46,235,12366,70,NULL,NULL,'2MASX J07252303+4114266',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000191,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,111.346083,41.24078,0.273,NULL,63617357999,994021218,15531581,16.1),(48614,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48614,38.25,0.33,446,12367,70,NULL,NULL,'SDSS J072523.26+412501.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000139,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,111.3469583,41.41714,0.261,NULL,63617310689,994020479,15531569,18.6),(48615,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48615,37.49,0.23,315,12368,70,NULL,NULL,'2MASX J07252890+4142036',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,111.370333,41.70092,0.293,NULL,63617982526,994030976,15531734,17.6),(48616,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48616,38.75,0.46,561,12369,70,NULL,NULL,'2MASX J07253134+4355029',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,111.3805,43.91758,0.281,NULL,63605423151,993834736,15528667,18.2),(48617,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48617,34.09,0.2,65.8,12370,74.4,NULL,NULL,'UGC 03843',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.00003,NULL,'15.7',0.2,'Scd:','Field galaxy',NULL,NULL,NULL,1,111.4325,20.10222,0.209,NULL,63149430155,986709846,15417341,15.7),(48618,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48618,34.3,0.34,72.6,12370,NULL,NULL,'Malmquist cor.','UGC 03843',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48619,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48619,34.35,0.34,74.2,12370,NULL,NULL,NULL,'UGC 03843',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48620,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48620,35.4,0.25,120,12371,74.4,NULL,NULL,'2MASX J07254846+5529413',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000025,NULL,'15.26',NULL,NULL,NULL,NULL,NULL,NULL,1,111.451125,55.49464,0.173,NULL,61713874352,964279286,15066863,15.26),(48621,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48621,38.55,0.46,514,12372,70,NULL,NULL,'2MASX J07255054+4407028',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00018,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,111.460417,44.11747,0.289,NULL,63605397210,993834331,15528661,17.9),(48622,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48622,38.25,0.33,446,12373,70,NULL,NULL,'2MASX J07255161+4126499',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000159,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,111.465125,41.44731,0.261,NULL,63617304022,994020375,15531568,17.5),(48623,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48623,36.65,0.55,214,12374,70,NULL,NULL,'2MASX J07255666-5019550',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000133,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,111.486083,-50.33206,0.529,NULL,42651581523,666430961,10412983,15.8),(48624,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48624,37.22,0.27,277,12375,70,NULL,NULL,'2MASX J07255680+4201218',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000184,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,111.486541667,42.02264,0.317,NULL,63617723673,994026932,15531670,16.6),(48625,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48625,37.68,0.46,343,12376,70,NULL,NULL,'2MASX J07255962+4128039',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,111.498333,41.46794,0.261,NULL,63617306469,994020413,15531568,17.6),(48626,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48626,37.22,0.27,277,12377,70,NULL,NULL,'2MASX J07260084+4206432',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,111.5034583,42.11183,0.317,NULL,63617747171,994027299,15531676,18.2),(48627,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48627,36.15,0.46,170,12378,70,NULL,NULL,'2MASX J07260395+4033289',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,111.5164583,40.55794,0.201,NULL,63608922169,993889408,15529522,16.8),(48628,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48628,35.92,0.57,153,12379,70,NULL,NULL,'ESO 208- G 013',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'15.48',0.3,'Compact or N',NULL,NULL,NULL,NULL,1,111.5719583,-50.57914,0.465,NULL,42647977037,666374641,10412103,15.48),(48629,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48629,34.12,0.47,66.5,12380,NULL,NULL,'H','ESO 005- G 006',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000033,NULL,'14.44',0.5,'Sb pec?',NULL,NULL,NULL,NULL,1,111.5772917,-84.51975,0.529,NULL,39785409492,621647023,9713234,14.44),(48630,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48630,34.15,0.4,67.5,12380,NULL,NULL,'mean','ESO 005- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48631,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48631,34.15,0.29,67.5,12380,NULL,NULL,'Malmquist cor.','ESO 005- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48632,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48632,34.23,0.46,70.2,12380,NULL,NULL,'J','ESO 005- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48633,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48633,34.24,0.45,70.5,12380,NULL,NULL,'K','ESO 005- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48634,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48634,34.3,0.27,72.5,12380,NULL,NULL,NULL,'ESO 005- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48635,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48635,34.34,0.2,73.8,12380,74.4,NULL,NULL,'ESO 005- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48636,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48636,33.17,0.4,43.1,12381,NULL,NULL,'mean','ESO 368- G 001',NULL,'2007A&A...465...71T',2007,1,1.1,'abs(b) < 10 degrees.','G',0.000023,NULL,'16.4',0.7,'Sb             NELG',NULL,NULL,NULL,NULL,1,111.581208333,-35.32986,NULL,NULL,42569534567,665148977,10392952,16.4),(48637,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48637,33.45,0.47,49,12381,NULL,NULL,'H','ESO 368- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48638,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48638,33.56,0.45,51.4,12381,NULL,NULL,'K','ESO 368- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48639,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48639,33.57,0.46,51.7,12381,NULL,NULL,'J','ESO 368- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48640,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48640,36.82,0.46,231,12382,70,NULL,NULL,'2MASX J07262068+4331583',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'17.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,111.58625,43.53292,0.261,NULL,63605291261,993832675,15528635,17),(48641,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48641,37.92,0.46,383,12383,70,NULL,NULL,'SDSS J072624.23+441754.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000142,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,111.6009583,44.29858,0.333,NULL,63604701925,993823467,15528491,18.4),(48642,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48642,35.75,0.61,141,12384,70,NULL,NULL,'2MASX J07262484-5149311',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,111.603625,-51.82528,0.565,NULL,42514461538,664288461,10379507,16.1),(48643,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48643,37.39,0.17,301,12385,70,NULL,NULL,'2MASX J07263302+3754509',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,111.63775,37.91414,0.205,NULL,63593503449,993648491,15525757,17.6),(48644,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48644,38.34,0.33,466,12386,70,NULL,NULL,'2MASX J07263315+3811209',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,111.6382083,38.18911,0.185,NULL,63593335630,993645869,15525716,18.4),(48645,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48645,33.83,0.4,58.2,12387,NULL,NULL,NULL,'NGC 2373',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.00003,NULL,'14.70',0.5,'S?','Group member',NULL,NULL,NULL,1,111.6539583,33.82369,0.225,NULL,63464195172,991628049,15494188,14.7),(48646,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48646,33.87,0.2,59.4,12387,74.4,NULL,NULL,'NGC 2373',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48647,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48647,34.09,0.36,65.8,12387,NULL,NULL,'Malmquist cor.','NGC 2373',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48648,'SNIa','2016-12-15 15:14:16','2016-12-16 11:19:22','1','SN 1997do',NULL,48648,32.55,0.3,32,12388,74.2,NULL,'SALT 2','UGC 03845',0.01012,'2010ApJ...716..712A',2010,1,1.5,NULL,'G',0.000023,NULL,'13.56',1.1,'SB(s)bc',NULL,NULL,NULL,NULL,1,111.6779583,47.09397,0.333,NULL,63585450839,993522669,15523791,13.56),(48649,'SNIa','2016-12-15 15:14:16','2016-12-16 11:19:22','1','SN 1997do',NULL,48649,33.17,0.08,43.1,12388,74.4,NULL,NULL,'UGC 03845',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48650,'SNIa','2016-12-15 15:14:16','2016-12-16 11:19:22','1','SN 1997do',NULL,48650,33.27,0.23,44.6,12388,73.8,NULL,'SALT 2 (SNANA)','UGC 03845',0.0105,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48651,'SNIa','2016-12-15 15:14:16','2016-12-16 11:19:22','1','SN 1997do',NULL,48651,33.27,0.26,44.6,12388,72,NULL,NULL,'UGC 03845',0.01012,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48652,'SNIa','2016-12-15 15:14:16','2016-12-16 11:19:22','1','SN 1997do',NULL,48652,33.25,0.17,44.7,12388,70.8,NULL,NULL,'UGC 03845',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48653,'SNIa','2016-12-15 15:14:16','2016-12-16 11:19:22','1','SN 1997do',NULL,48653,33.28,0.33,44.8,12388,70,NULL,'SALT','UGC 03845',0.01012,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48654,'SNIa','2016-12-15 15:14:16','2016-12-16 11:19:22','1','SN 1997do',NULL,48654,33.41,0.31,47.6,12388,65,NULL,'SALT2','UGC 03845',0.01012,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48655,'SNIa','2016-12-15 15:14:16','2016-12-16 11:19:22','1','SN 1997do',NULL,48655,33.51,0.06,49.8,12388,72,NULL,NULL,'UGC 03845',0.01012,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48656,'SNIa','2016-12-15 15:14:16','2016-12-16 11:19:22','1','SN 1997do',NULL,48656,33.56,0.3,51,12388,65,NULL,'MLCS31','UGC 03845',0.01012,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48657,'SNIa','2016-12-15 15:14:16','2016-12-16 11:19:22','1','SN 1997do',NULL,48657,33.6,0.12,51.4,12388,65,NULL,'MLCS2k2','UGC 03845',0.01012,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48658,'SNIa','2016-12-15 15:14:16','2016-12-16 11:19:22','1','SN 1997do',NULL,48658,33.58,0.29,51.5,12388,65,NULL,'MLCS17','UGC 03845',0.01012,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48659,'SNIa','2016-12-15 15:14:16','2016-12-16 11:19:22','1','SN 1997do',NULL,48659,33.73,0.04,55.1,12388,70,NULL,'SALT 2','UGC 03845',0.01012,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48660,'SNIa','2016-12-15 15:14:16','2016-12-16 11:19:22','1','SN 1997do',NULL,48660,33.73,0.33,55.2,12388,65,NULL,NULL,'UGC 03845',0.01012,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48661,'SNIa','2016-12-15 15:14:16','2016-12-16 11:19:22','1','SN 1997do',NULL,48661,33.74,0.14,56,12388,60,NULL,NULL,'UGC 03845',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48662,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48662,32.85,0.43,37.1,12388,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03845',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48663,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48663,32.9,0.43,38,12388,75,NULL,'3.6 micron, color corrected','UGC 03845',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48664,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48664,32.93,0.42,38.5,12388,NULL,18.48,'3.6 micron','UGC 03845',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48665,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48665,32.94,0.4,38.7,12388,75,NULL,'HOSTS SN 1997do','UGC 03845',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48666,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48666,33.17,0.08,43.1,12388,74.4,NULL,NULL,'UGC 03845',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48667,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48667,38.34,0.33,466,12389,70,NULL,NULL,'2MASX J07264784+3808390',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000175,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,111.6994583,38.14428,0.249,NULL,63593345351,993646021,15525719,17.6),(48668,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48668,36.81,0.46,230,12390,70,NULL,NULL,'2MASX J07265055+4229113',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,111.710625,42.48647,0.261,NULL,63617847967,994028874,15531701,17),(48669,'Sosies','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48669,33.9,0.49,60.3,12391,NULL,NULL,NULL,'MCG -01-19-002',NULL,'2002A&A...393...57T',2002,1,0.8,'Takata, et al. (1994A&AS..104..529T) give v = 12190 +/- 50 km/sec.','G',0.00001,NULL,'17',0.7,'S',NULL,NULL,NULL,NULL,1,111.723417,-7.5475,NULL,NULL,39584238568,618503727,9664120,17),(48670,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48670,33.05,0.4,40.8,12391,NULL,NULL,'mean','MCG -01-19-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48671,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48671,33.7,0.47,55,12391,NULL,NULL,'H','MCG -01-19-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48672,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48672,33.71,0.45,55.1,12391,NULL,NULL,'K','MCG -01-19-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48673,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48673,33.74,0.46,56.1,12391,NULL,NULL,'J','MCG -01-19-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48674,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48674,34.07,0.33,65.2,12392,NULL,NULL,NULL,'UGC 03856',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.5',0.8,'Scd:',NULL,NULL,NULL,NULL,1,111.7379583,20.37097,0.249,NULL,63149048530,986703883,15417248,16.5),(48675,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48675,34.11,0.2,66.4,12392,74.4,NULL,NULL,'UGC 03856',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48676,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48676,34.2,0.31,69.3,12392,NULL,NULL,'Malmquist cor.','UGC 03856',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48677,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48677,37.39,0.17,301,12393,70,NULL,NULL,'2MASX J07265936+3800450',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000193,NULL,'16.1g',0.43,'E0',NULL,NULL,NULL,NULL,1,111.7475417,38.01253,0.245,NULL,63593366406,993646350,15525724,16.1),(48678,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48678,37.97,0.46,393,12394,70,NULL,NULL,'2MASX J07265971+4104360',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,111.748708333,41.07683,0.249,NULL,63608853193,993888331,15529505,17.8),(48679,'Ring Diameter','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48679,31.9,0.84,24,12395,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 2336',NULL,'1981ApJS...45..541P',1981,1,7.1,NULL,'G',0.000003,NULL,'11.05',3.9,'SAB(r)bc;RET   Sy2','Pair member (points to parent)',NULL,NULL,NULL,1,111.766875,80.17808,0.125,NULL,61452452939,960194577,15003040,11.05),(48680,'IRAS','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48680,32.52,0.8,31.9,12395,75,NULL,'A82, H','NGC 2336',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48681,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48681,32.17,0.4,27.2,12395,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 2336',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48682,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48682,32.31,0.35,29,12395,NULL,NULL,NULL,'NGC 2336',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48683,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48683,32.45,0.46,30.9,12395,NULL,NULL,'J','NGC 2336',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48684,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48684,32.53,0.45,32.1,12395,NULL,NULL,'K','NGC 2336',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48685,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48685,32.56,0.47,32.5,12395,75,NULL,'A82, H, raw','NGC 2336',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48686,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48686,32.59,0.2,33,12395,74.4,NULL,NULL,'NGC 2336',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48687,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48687,32.63,0.43,33.5,12395,75,NULL,'3.6 micron, color corrected','NGC 2336',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48688,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48688,32.65,0.4,33.9,12395,75,NULL,'B','NGC 2336',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48689,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48689,32.66,0.4,34,12395,NULL,NULL,'mean','NGC 2336',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48690,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48690,32.8,0.47,36.4,12395,75,NULL,'A82, H, inv','NGC 2336',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48691,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48691,32.81,0.43,36.4,12395,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2336',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48692,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48692,32.9,0.47,38,12395,75,NULL,'A82, H, cor','NGC 2336',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48693,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48693,38.8,0.46,574,12396,70,NULL,NULL,'2MASX J07270487+4438554',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,111.770417,44.64867,0.349,NULL,63604770632,993824541,15528508,18.5),(48694,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48694,37.39,0.17,301,12397,70,NULL,NULL,'2MASX J07270766+3804230',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,111.7817917,38.07303,0.249,NULL,63593368684,993646385,15525724,18),(48695,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48695,34.25,0.34,71,12398,NULL,NULL,'Malmquist cor.','NGC 2375',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000023,NULL,'14.44',1,'SB(s)b','Group member',NULL,NULL,NULL,1,111.7895,33.83181,0.225,NULL,63464166024,991627594,15494181,14.44),(48696,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48696,34.4,0.32,75.9,12398,NULL,NULL,NULL,'NGC 2375',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48697,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48697,34.44,0.2,77.3,12398,74.4,NULL,NULL,'NGC 2375',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48698,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48698,35.39,0.4,120,12398,NULL,NULL,'mean','NGC 2375',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48699,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48699,35.45,0.47,123,12398,NULL,NULL,'H','NGC 2375',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48700,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48700,34.83,0.47,92.5,12399,70,NULL,NULL,'ESO 208- G 015',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00012,NULL,'14.58',0.9,'(R_1)SB(r)a',NULL,NULL,NULL,NULL,1,111.798833,-51.37206,0.497,NULL,42514085949,664282592,10379415,14.58),(48701,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48701,30.4,NULL,12,12400,75,NULL,'CO','NGC 2276',NULL,'1994A&A...283...21S',1994,1,2.8,NULL,'G',0.000007,NULL,'11.93',2.7,'SAB(rs)c','Pair member (points to parent)',NULL,NULL,NULL,1,111.809833333,85.75456,0.217,NULL,61209103281,956392238,14943628,11.93),(48702,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48702,31.72,NULL,22.1,12400,75,NULL,'HI','NGC 2276',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48703,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48703,32.83,0.4,36.8,12400,75,NULL,'B','NGC 2276',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48704,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48704,37.9,0.46,381,12401,70,NULL,NULL,'2MASX J07271708+4213143',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000178,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,111.821333,42.22075,0.205,NULL,63617833435,994028647,15531697,17.6),(48705,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48705,38.3,0.46,456,12402,70,NULL,NULL,'SDSS J072718.87+375524.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000185,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,111.828667,37.9235,0.245,NULL,63593362631,993646291,15525723,18.3),(48706,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48706,35.39,0.63,120,12403,70,NULL,NULL,'2MASX J07272214-6737562',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,111.8422083,-67.63236,0.665,NULL,40658396686,635287448,9926366,15.6),(48707,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48707,36.08,0.65,165,12404,70,NULL,NULL,'2MASX J07272291-6631152',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.6I',0.5,NULL,NULL,NULL,NULL,NULL,1,111.845417,-66.52086,0.633,NULL,40640481233,635007519,9921992,13.6),(48708,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48708,38.65,0.46,538,12405,70,NULL,NULL,'2MASX J07272649+3955528',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,111.8605,39.93125,0.217,NULL,63609135256,993892738,15529574,17.7),(48709,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48709,37.71,0.46,348,12406,70,NULL,NULL,'2MASX J07272730+4201458',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000142,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,111.86375,42.02953,0.245,NULL,63617912740,994029886,15531716,18.2),(48710,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48710,33.32,0.49,46.1,12407,75,NULL,'IR','2MFGC 05932',NULL,'2011yCatp016004901K',2011,1,0.5,'Incorrectly refered to as ESO 492-016 in Chamaraux (1999,MNRAS,307,236).','G',0.000017,NULL,'10.4K',0.1,'S',NULL,NULL,NULL,NULL,1,111.871667,-23.95928,NULL,NULL,39470024416,616719131,9636236,10.4),(48711,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48711,33.86,0.47,59.3,12407,NULL,NULL,'H','2MFGC 05932',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48712,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48712,33.89,0.45,59.9,12407,NULL,NULL,'K','2MFGC 05932',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48713,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48713,34,0.4,63.2,12407,NULL,NULL,'mean','2MFGC 05932',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48714,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48714,37.82,0.46,366,12408,70,NULL,NULL,'2MASX J07272985+4112588',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,111.87425,41.21644,0.273,NULL,63617186648,994018541,15531539,17),(48715,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48715,36.28,0.71,180,12409,70,NULL,NULL,'2MASX J07273110-8115380',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.7b',NULL,'SBa(r)',NULL,NULL,NULL,NULL,1,111.879625,-81.26064,0.685,NULL,39952943558,624264743,9754136,16.7),(48716,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48716,37.39,0.17,301,12410,70,NULL,NULL,'SDSS J072733.27+381541.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,111.888666667,38.26164,0.249,NULL,63593322854,993645669,15525713,18.2),(48717,'Tully est','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48717,30.26,0.8,11.3,12411,75,NULL,NULL,'ESO 257- G?017',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000007,NULL,'16.80',1,'SB(s)m',NULL,NULL,NULL,NULL,1,111.888583,-45.68461,0.765,NULL,42660384032,666568500,10415132,16.8),(48718,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48718,32.52,NULL,31.9,12412,NULL,NULL,NULL,'UGC 03853',NULL,'2000BSAO...50....5K',2000,1,1.06,NULL,'G',0.000013,NULL,'17.',0.13,'Sdm',NULL,NULL,NULL,NULL,1,111.913583,48.44594,0.369,NULL,63583011673,993484557,15523196,17),(48719,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48719,32.53,NULL,32,12412,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03853',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48720,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48720,32.55,NULL,32.3,12412,NULL,NULL,'Dipole + Quadrupole','UGC 03853',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48721,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48721,32.56,NULL,32.6,12412,NULL,NULL,'Dipole','UGC 03853',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48722,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48722,35.74,0.5,141,12413,70,NULL,NULL,'2MASX J07273999-4930025',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,111.916583333,-49.50064,0.601,NULL,42649527789,666398871,10412482,14.9),(48723,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48723,37.91,0.46,382,12414,70,NULL,NULL,'SDSS J072740.81+381431.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000143,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,111.920083,38.24206,0.249,NULL,63593323059,993645672,15525713,18.7),(48724,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48724,36.99,0.46,250,12415,70,NULL,NULL,'2MASX J07274118+4147127',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000173,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,111.9215,41.78678,0.241,NULL,63618141580,994033462,15531772,17.4),(48725,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48725,37.35,0.46,296,12416,70,NULL,NULL,'2MASX J07274173+3930277',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000185,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,111.923667,39.50769,0.213,NULL,63591653966,993619593,15525306,16.7),(48726,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48726,35.81,0.49,145,12417,70,NULL,NULL,'2MASX J07274366-5129345',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,111.931833,-51.49297,0.497,NULL,42514153816,664283653,10379432,16.3),(48727,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48727,35.4,0.31,120,12418,NULL,NULL,'Malmquist cor.','UGC 03862',NULL,'2009ApJS..182..474S',2009,1,1.6,NULL,'G',0.000033,NULL,'15.10',0.4,'S?',NULL,NULL,NULL,NULL,1,111.9495417,20.39825,0.213,NULL,63146037524,986656836,15416513,15.1),(48728,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48728,35.45,0.3,123,12418,NULL,NULL,NULL,'UGC 03862',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48729,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48729,35.49,0.2,125,12418,74.4,NULL,NULL,'UGC 03862',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48730,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48730,37.39,0.46,301,12419,70,NULL,NULL,'2MASX J07275116+4440028',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,111.963083,44.66742,0.349,NULL,63604567866,993821372,15528458,17.9),(48731,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48731,32.59,NULL,33,12420,NULL,NULL,NULL,'AGC 171494',NULL,'2015AstBu..70....1K',2015,1,NULL,NULL,'G',0.000034,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,111.975417,4.70472,0.789,NULL,63224150285,987877348,15435583,NULL),(48732,'IRAS','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48732,33.42,0.8,48.2,12421,75,NULL,'MAT, I','IC 2202',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000033,NULL,'13.61',0.7,'SAB(s)bc',NULL,NULL,NULL,'Sy 2',1,111.978083,-67.57422,0.665,NULL,40657655996,635275874,9926185,13.61),(48733,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48733,33.06,0.43,40.9,12421,75,NULL,'MAT, I, raw','IC 2202',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48734,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48734,33.12,0.46,42.1,12421,NULL,NULL,'J','IC 2202',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48735,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48735,33.13,0.47,42.2,12421,NULL,NULL,'H','IC 2202',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48736,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48736,33.18,0.32,43.3,12421,85,NULL,'I, raw','IC 2202',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48737,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48737,33.22,0.45,44.1,12421,NULL,NULL,'K','IC 2202',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48738,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48738,33.24,0.32,44.5,12421,85,NULL,'I, inv','IC 2202',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48739,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48739,33.31,0.43,46,12421,75,NULL,'MAT, I, inv','IC 2202',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48740,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48740,33.31,0.43,46,12421,75,NULL,'MAT, I, cor','IC 2202',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48741,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48741,33.48,0.4,49.6,12421,NULL,NULL,'mean','IC 2202',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48742,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48742,33.6,0.44,52.5,12421,NULL,NULL,NULL,'IC 2202',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48743,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48743,33.61,0.44,52.6,12421,NULL,NULL,'Malmquist cor.','IC 2202',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48744,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48744,33.64,0.2,53.5,12421,74.4,NULL,NULL,'IC 2202',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48745,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48745,38.07,0.46,411,12422,70,NULL,NULL,'2MASX J07275895+4446121',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,111.9955,44.77008,0.349,NULL,63604587523,993821680,15528463,17.2),(48746,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48746,37.02,0.23,254,12423,70,NULL,NULL,'2MASX J07275992+4151514',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,111.9994583,41.86436,0.245,NULL,63617941603,994030337,15531724,17.8),(48747,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48747,37.82,0.46,366,12424,70,NULL,NULL,'2MASXi J0727599+401415',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,112,40.23764,0.201,NULL,63609663338,993900989,15529702,18.4),(48748,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48748,37.02,0.23,254,12425,70,NULL,NULL,'2MASX J07280080+4155074',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.0002,NULL,'14.5',0.56,NULL,NULL,NULL,NULL,NULL,1,112.003416667,41.91878,0.245,NULL,63617942030,994030344,15531724,14.5),(48749,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48749,36.24,0.56,177,12426,70,NULL,NULL,'2MASX J07280084-6341072',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.4,NULL,NULL,NULL,NULL,NULL,1,112.0037083,-63.68536,0.709,NULL,40352110971,630501733,9851589,14.2),(48750,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48750,37.69,0.46,345,12427,70,NULL,NULL,'2MASX J07280379+4457061',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,112.0160417,44.95169,0.393,NULL,63574122596,993345665,15521026,17.7),(48751,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48751,36.23,0.59,176,12428,70,NULL,NULL,'2MASX J07280386-5257181',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,112.0162083,-52.95511,0.505,NULL,40416981614,631515337,9867427,15),(48752,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48752,37.02,0.23,254,12429,70,NULL,NULL,'2MASX J07280429+4155264',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,'PHOT','16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,112.0177917,41.92406,0.245,NULL,63617944879,994030388,15531724,16.1),(48753,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48753,37.02,0.23,254,12430,70,NULL,NULL,'2MASX J07280473+4157474',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000205,NULL,'15.9g',0.42,NULL,NULL,NULL,NULL,NULL,1,112.019833333,41.96331,0.245,NULL,63617943668,994030369,15531724,15.9),(48754,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48754,36.08,0.46,164,12431,70,NULL,NULL,'2MASX J07280603+3759215',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000166,NULL,'16.1g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,112.025,37.98944,0.245,NULL,63590526035,993601969,15525030,16.1),(48755,'GRB','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48755,43.51,0.16,5040,12432,NULL,NULL,NULL,'GRB 110422A',NULL,'2012arXiv1205.2954T',2012,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,112.0472083,75.10678,0.113,NULL,61322914915,958170545,14971414,NULL),(48756,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48756,37.39,0.17,301,12433,70,NULL,NULL,'2MASX J07281168+3820065',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000181,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,112.048833,38.33508,0.249,NULL,63593775978,993652749,15525824,17.2),(48757,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48757,37.39,0.17,301,12434,70,NULL,NULL,'2MASX J07281202+3814575',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000219,NULL,'16.1g',0.41,'BrClG',NULL,NULL,NULL,NULL,1,112.05025,38.24939,0.249,NULL,63593318854,993645607,15525712,16.1),(48758,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48758,32.39,0.69,30.1,12435,100,NULL,'mid-IR','UGC 03855',NULL,'2013ApJ...771...88L',2013,1,2,NULL,'G',0.000027,NULL,'14.22',0.4,'Sab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,112.0542083,58.50669,0.145,NULL,61682095189,963782737,15059105,14.22),(48759,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48759,33.06,0.47,41,12435,NULL,NULL,'H','UGC 03855',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48760,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48760,33.21,0.46,43.8,12435,NULL,NULL,'J','UGC 03855',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48761,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48761,33.26,0.4,45,12435,NULL,NULL,'mean','UGC 03855',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48762,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48762,33.3,0.45,45.7,12435,NULL,NULL,'K','UGC 03855',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48763,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48763,36.94,0.46,245,12436,70,NULL,NULL,'2MASX J07281642+3933435',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,112.068583,39.56203,0.245,NULL,63591445245,993616331,15525255,16.8),(48764,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48764,36.41,0.46,192,12437,70,NULL,NULL,'CGCG 206-009',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000204,NULL,'15.3g',0.53,'E0',NULL,NULL,NULL,NULL,1,112.07075,40.08408,0.217,NULL,63609154501,993893039,15529578,15.3),(48765,'Brightest Stars','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48765,28.79,0.2,5.73,12438,NULL,NULL,NULL,'UGC 03860',NULL,'1998A&AS..133..181M',1998,1,1.3,NULL,'G',0.000001,NULL,'15.07',0.9,'Im','Isolated galaxy',NULL,NULL,NULL,1,112.0724583,40.76978,0.217,NULL,63609621907,993900342,15529692,15.07),(48766,'Brightest Stars','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48766,29.23,0.4,7.01,12438,NULL,NULL,'3B + 3R mean','UGC 03860',NULL,'1997AstL...23..514G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48767,'Brightest Stars','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48767,29.83,NULL,9.25,12438,NULL,NULL,'LF','UGC 03860',NULL,'1997AstL...23..514G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48768,'TRGB','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48768,29.46,NULL,7.81,12438,NULL,NULL,NULL,'UGC 03860',NULL,'2004AJ....127.2031K',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48769,'TRGB','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48769,30.1,0.1,10.5,12438,74.4,NULL,NULL,'UGC 03860',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48770,'TRGB','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48770,30.18,0.25,10.9,12438,NULL,NULL,NULL,'UGC 03860',NULL,'2015ApJ...805..144K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48771,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48771,29.3,0.4,7.2,12438,75,NULL,'B','UGC 03860',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48772,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48772,35.81,0.58,145,12439,70,NULL,NULL,'2MASX J07283492-5059301',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.7I',0.2,NULL,NULL,NULL,NULL,NULL,1,112.1454583,-50.99178,0.445,NULL,42514032789,664281762,10379402,14.7),(48773,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48773,38.22,0.46,440,12440,70,NULL,NULL,'2MASX J07283701+3842561',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000181,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,112.154375,38.71553,0.277,NULL,63593676315,993651192,15525799,17.5),(48774,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48774,38,0.46,398,12441,70,NULL,NULL,'2MASX J07283778+3755371',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,112.1572917,37.92708,0.245,NULL,63590519094,993601860,15525029,17.9),(48775,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48775,38.2,0.33,437,12442,70,NULL,NULL,'2MASX J07283941+4108581',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,112.164167,41.14964,0.253,NULL,63609321458,993895647,15529619,18.2),(48776,'Tully est','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48776,30.55,0.8,12.9,12443,75,NULL,NULL,'ESO 035- G 009',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.000022,NULL,'15.96',0.4,'IB(s)m',NULL,NULL,NULL,NULL,1,112.169167,-75.05556,0.913,NULL,39914227485,623659804,9744684,15.96),(48777,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48777,38.2,0.33,437,12444,70,NULL,NULL,'SDSS J072842.03+411230.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000143,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,112.175167,41.20836,0.253,NULL,63617505486,994023523,15531617,18.2),(48778,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48778,37.28,0.46,286,12445,70,NULL,NULL,'2MASX J07284389+4324065',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,112.1827917,43.40194,0.233,NULL,63616570897,994008920,15531389,17.8),(48779,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48779,38.03,0.33,403,12446,70,NULL,NULL,'SDSS J072845.70+440701.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,112.1904583,44.11719,0.277,NULL,63616183771,994002871,15531294,18.5),(48780,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48780,37.48,0.46,313,12447,70,NULL,NULL,'SDSS J072846.00+382834.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,112.1917083,38.47614,0.261,NULL,63590184672,993596635,15524947,18),(48781,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48781,36.88,0.46,238,12448,70,NULL,NULL,'2MASX J07284764+4016232',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000176,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,112.1984583,40.27319,0.201,NULL,63609652142,993900814,15529700,16.5),(48782,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48782,37.4,0.46,302,12449,70,NULL,NULL,'2MASX J07284943+3935542',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000187,NULL,'16.9g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,112.2059583,39.59836,0.245,NULL,63609016889,993890888,15529545,16.9),(48783,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48783,37.37,0.46,298,12450,70,NULL,NULL,'2MASX J07284965+3845522',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000174,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,112.206958333,38.76442,0.277,NULL,63593663251,993650988,15525796,17.1),(48784,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48784,34.78,NULL,90.5,12451,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0632',NULL,'2010Ap&SS.325..163P',2010,1,0.88,NULL,'G',0.000011,NULL,'16.7',0.11,'Sc',NULL,NULL,NULL,NULL,1,112.209167,28.38889,0.181,NULL,62955742225,983683472,15370054,16.7),(48785,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48785,34.81,NULL,91.6,12451,NULL,NULL,'Dipole + Quadrupole','FGC 0632',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48786,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48786,34.81,NULL,91.6,12451,NULL,NULL,'Dipole','FGC 0632',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48787,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48787,34.86,NULL,93.7,12451,NULL,NULL,NULL,'FGC 0632',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48788,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48788,34.9,0.43,95.4,12451,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0632',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48789,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48789,37.37,0.33,298,12452,70,NULL,NULL,'2MASX J07285092+4502565',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000163,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,112.212375,45.04917,0.393,NULL,63574117556,993345586,15521024,17.4),(48790,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48790,37.37,0.33,298,12453,70,NULL,NULL,'2MASX J07285290+4501345',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'17.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,112.220625,45.02614,0.393,NULL,63574117807,993345590,15521024,17.9),(48791,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48791,35.53,0.57,128,12454,70,NULL,NULL,'2MASX J07285320-5316274',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.3,'(R\'_2)SB(s)a',NULL,NULL,NULL,NULL,1,112.222,-53.27419,0.517,NULL,40420267163,631566674,9868229,14.1),(48792,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48792,33.86,0.35,59,12455,NULL,NULL,NULL,'NGC 2388',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000017,NULL,'14.67',0.6,'S?;LIRG        HII','in a pair',NULL,NULL,NULL,1,112.222666667,33.81908,0.221,NULL,63464067871,991626060,15494157,14.67),(48793,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48793,33.9,0.2,60.3,12455,74.4,NULL,NULL,'NGC 2388',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48794,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48794,34.01,0.32,63.4,12455,NULL,NULL,'Malmquist cor.','NGC 2388',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48795,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48795,33.84,0.2,58.6,12456,74.4,NULL,NULL,'UGC 03873',NULL,'2013AJ....146...86T',2013,1,1.9,NULL,'G',0.000031,NULL,'14.47',0.4,'Scd:',NULL,NULL,NULL,NULL,1,112.225625,20.59178,0.213,NULL,63146238428,986659975,15416562,14.47),(48796,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48796,33.94,0.47,61.3,12456,NULL,NULL,'H','UGC 03873',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48797,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48797,34.04,0.25,64.4,12456,NULL,NULL,NULL,'UGC 03873',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48798,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48798,34.08,0.4,65.5,12456,NULL,NULL,'mean','UGC 03873',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48799,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48799,34.09,0.45,65.7,12456,NULL,NULL,'K','UGC 03873',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48800,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48800,34.09,0.46,65.7,12456,NULL,NULL,'J','UGC 03873',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48801,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48801,34.17,0.23,68.3,12456,NULL,NULL,'Malmquist cor.','UGC 03873',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48802,'Brightest Stars','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48802,27.3,NULL,2.9,12457,NULL,NULL,NULL,'NGC 2366',NULL,'1995AJ....110..212A',1995,1,8.1,'Contains the HII region MRK 0071.  May also contain UGC 03847.','G',0.000003,NULL,'11.43',3.3,'IB(s)m         HII','Possible group member',NULL,NULL,NULL,1,112.22775,69.21578,0.165,0,62209328495,972020757,15187824,11.43),(48803,'Brightest Stars','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48803,27.62,NULL,3.34,12457,NULL,NULL,'3V','NGC 2366',NULL,'1991A&AS...89....1T',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48804,'Cepheids','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48804,27.62,0.06,3.34,12457,74.4,NULL,NULL,'NGC 2366',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48805,'Cepheids','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48805,27.68,0.2,3.44,12457,NULL,NULL,'6, r','NGC 2366',NULL,'1995AJ....110.1640T',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48806,'Cepheids','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48806,27.7,NULL,3.47,12457,NULL,NULL,'HST KP Calibrated, max. D','NGC 2366',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48807,'CMD','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48807,27.44,0.07,3.08,12457,NULL,NULL,'Field 2','NGC 2366',NULL,'2010ApJ...721..297M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48808,'CMD','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48808,27.48,0.06,3.13,12457,NULL,NULL,'Field 1','NGC 2366',NULL,'2010ApJ...721..297M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48809,'RSV Stars','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48809,27.86,0.2,3.73,12457,NULL,NULL,'RSV','NGC 2366',NULL,'1998PhDT.........5J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48810,'TRGB','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48810,27.48,NULL,3.13,12457,NULL,NULL,NULL,'NGC 2366',NULL,'2006Ap.....49....3K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48811,'TRGB','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48811,27.48,0.17,3.13,12457,NULL,NULL,'I','NGC 2366',NULL,'2008ARep...52...19T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48812,'TRGB','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48812,27.52,0.28,3.19,12457,NULL,NULL,'I','NGC 2366',NULL,'2002A&A...383..125K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48813,'TRGB','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48813,27.53,0.26,3.2,12457,NULL,NULL,NULL,'NGC 2366',NULL,'2014A&A...566A..71L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48814,'TRGB','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48814,27.54,0.03,3.21,12457,NULL,NULL,'I','NGC 2366',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48815,'TRGB','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48815,27.57,0.03,3.27,12457,NULL,NULL,'I','NGC 2366',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48816,'TRGB','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48816,27.62,0.06,3.34,12457,74.4,NULL,NULL,'NGC 2366',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48817,'TRGB','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48817,27.67,0.1,3.42,12457,NULL,NULL,'I','NGC 2366',NULL,'2005ApJ...627..739T',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48818,'HII region diameter','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48818,26.22,0.15,1.75,12457,NULL,NULL,'Method 1','NGC 2366',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48819,'HII region diameter','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48819,26.46,0.13,1.96,12457,NULL,NULL,'Method 2','NGC 2366',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48820,'IRAS','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48820,28.94,0.8,6.15,12457,75,NULL,'A82, H','NGC 2366',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48821,'Magnitude','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48821,27.11,0.11,2.64,12457,NULL,NULL,NULL,'NGC 2366',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48822,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48822,27.16,0.4,2.7,12457,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 2366',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48823,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48823,27.35,0.4,2.9,12457,75,NULL,'B','NGC 2366',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48824,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48824,27.62,0.06,3.34,12457,74.4,NULL,NULL,'NGC 2366',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48825,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48825,27.77,0.47,3.57,12457,75,NULL,'A82, H, inv','NGC 2366',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48826,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48826,27.82,0.35,3.66,12457,NULL,NULL,NULL,'NGC 2366',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48827,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48827,27.98,NULL,3.94,12457,NULL,NULL,'IR','NGC 2366',NULL,'1980ApJ...237..655A',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48828,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48828,28.11,0.47,4.19,12457,75,NULL,'A82, H, raw','NGC 2366',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48829,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48829,28.46,0.47,4.92,12457,75,NULL,'A82, H, cor','NGC 2366',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48830,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48830,38.03,0.33,403,12458,70,NULL,NULL,'2MASX J07285588+4400275',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000178,NULL,'16.7g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,112.232875,44.00767,0.285,NULL,63617028432,994016069,15531501,16.7),(48831,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48831,37.39,0.17,301,12459,70,NULL,NULL,'2MASX J07285902+3815392',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000192,NULL,'16.2g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,112.246,38.26075,0.249,NULL,63590644191,993603815,15525059,16.2),(48832,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48832,34.86,0.74,93.6,12460,NULL,NULL,NULL,'ESO 208- G 017',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.02',0.5,'S...',NULL,NULL,NULL,NULL,1,112.246541667,-51.44803,0.497,NULL,42514184673,664284135,10379439,16.02),(48833,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48833,34.9,0.72,95.4,12460,NULL,NULL,'Malmquist cor.','ESO 208- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48834,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48834,34.9,0.2,95.5,12460,74.4,NULL,NULL,'ESO 208- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48835,'IRAS','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48835,34.17,0.8,68.2,12461,75,NULL,'MAT, I','ESO 088- G 017',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'13.67',0.6,'SAB(rs)bc','Pair member (points to parent)',NULL,NULL,NULL,1,112.248708333,-66.89831,0.693,NULL,40640532000,635008312,9922004,13.67),(48836,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48836,34.03,0.47,64,12461,NULL,NULL,'H','ESO 088- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48837,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48837,34.05,0.46,64.5,12461,NULL,NULL,'J','ESO 088- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48838,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48838,34.08,0.45,65.4,12461,NULL,NULL,'K','ESO 088- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48839,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48839,34.25,0.4,70.8,12461,NULL,NULL,'mean','ESO 088- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48840,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48840,34.39,0.43,75.7,12461,75,NULL,'MAT, I, raw','ESO 088- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48841,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48841,34.55,0.32,81.2,12461,85,NULL,'I, raw','ESO 088- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48842,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48842,34.6,0.46,83.4,12461,NULL,NULL,'Malmquist cor.','ESO 088- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48843,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48843,34.64,0.32,84.8,12461,85,NULL,'I, inv','ESO 088- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48844,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48844,34.72,0.43,88,12461,75,NULL,'MAT, I, cor','ESO 088- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48845,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48845,34.77,0.43,89.8,12461,75,NULL,'MAT, I, inv','ESO 088- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48846,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48846,34.81,0.42,91.6,12461,NULL,NULL,NULL,'ESO 088- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48847,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48847,37.9,0.46,379,12462,70,NULL,NULL,'2MASX J07290134+3829262',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,112.255541667,38.49075,0.261,NULL,63590183031,993596609,15524947,17.1),(48848,'Sosies','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48848,34.01,0.29,63.4,12463,NULL,NULL,NULL,'NGC 2389',NULL,'2002A&A...393...57T',2002,1,2,NULL,'G',0.000013,NULL,'13.40',1.4,'SAB(rs)c       HII','in a pair',NULL,NULL,NULL,1,112.269375,33.86097,0.221,NULL,63464024476,991625382,15494146,13.4),(48849,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48849,32.91,0.69,38.1,12463,100,NULL,'mid-IR','NGC 2389',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48850,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48850,33.92,0.4,60.7,12463,NULL,NULL,'mean','NGC 2389',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48851,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48851,34.14,0.3,67.2,12463,NULL,NULL,'Malmquist cor.','NGC 2389',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48852,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48852,34.2,0.29,69.2,12463,NULL,NULL,NULL,'NGC 2389',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48853,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48853,34.24,0.2,70.5,12463,74.4,NULL,NULL,'NGC 2389',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48854,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48854,34.52,0.47,80.1,12463,NULL,NULL,'H','NGC 2389',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48855,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48855,34.53,0.45,80.6,12463,NULL,NULL,'K','NGC 2389',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48856,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48856,34.54,0.46,81,12463,NULL,NULL,'J','NGC 2389',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48857,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48857,34.85,0.2,93.3,12464,74.4,NULL,NULL,'ESO 088- G 018',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00005,NULL,'14.86',0.2,'E5 pec','Pair member (points to parent)',NULL,NULL,NULL,1,112.274958333,-66.91189,0.709,NULL,40640529159,635008268,9922004,14.86),(48858,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48858,38.22,0.46,440,12465,70,NULL,NULL,'2MASX J07291337+3845478',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000155,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,112.305625,38.76342,0.253,NULL,63590206566,993596977,15524952,17.7),(48859,'IRAS','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48859,30.95,0.8,15.5,12466,75,NULL,'CF, r','UGC 03876',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000007,NULL,'13.70',1.3,'SA(s)d','Isolated galaxy',NULL,NULL,NULL,1,112.323083333,27.89953,0.193,NULL,62955908179,983686065,15370094,13.7),(48860,'Sosies','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48860,32.56,0.49,32.5,12466,NULL,NULL,NULL,'UGC 03876',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48861,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48861,31.9,0.4,24,12466,NULL,NULL,NULL,'UGC 03876',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48862,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48862,31.9,0.4,24,12466,73,NULL,'opt','UGC 03876',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48863,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48863,32.51,0.38,31.8,12466,75,NULL,'CF, r, raw','UGC 03876',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48864,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48864,32.55,0.38,32.4,12466,75,NULL,'CF, r, inv','UGC 03876',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48865,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48865,32.83,0.38,36.9,12466,75,NULL,'CF, r, cor','UGC 03876',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48866,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48866,37.66,0.46,341,12467,70,NULL,NULL,'2MASX J07292804+4014389',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,112.366875,40.24408,0.201,NULL,63609074993,993891796,15529559,17.9),(48867,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48867,37.91,0.46,382,12468,70,NULL,NULL,'2MASX J07293425+4517165',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,112.392958333,45.28811,0.401,NULL,63581511880,993461123,15522830,17.3),(48868,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48868,37.52,0.27,318,12469,70,NULL,NULL,'2MASX J07293481+4346065',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,112.395375,43.76856,0.253,NULL,63616998337,994015599,15531493,18),(48869,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48869,37.46,0.46,310,12470,70,NULL,NULL,'2MASX J07294004+4104198',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00016,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,112.4167083,41.07231,0.253,NULL,63609359509,993896242,15529628,16.9),(48870,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48870,37.65,0.46,339,12471,70,NULL,NULL,'2MASX J07294282+4154045',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000177,NULL,'17.0g',0.24,'BrClG',NULL,NULL,NULL,NULL,1,112.428333,41.90122,0.245,NULL,63617498628,994023416,15531615,17),(48871,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48871,33.25,NULL,44.7,12472,NULL,NULL,NULL,'UGC 03879',NULL,'2000BSAO...50....5K',2000,1,2.35,NULL,'G',0.000017,NULL,'15.04',0.32,'Sbc',NULL,NULL,NULL,NULL,1,112.433167,33.69003,0.245,NULL,63456683801,991510684,15492354,15.04),(48872,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48872,33.69,0.2,54.7,12472,74.4,NULL,NULL,'UGC 03879',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48873,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48873,33.76,0.38,56.6,12472,NULL,NULL,NULL,'UGC 03879',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48874,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48874,33.8,0.43,57.5,12472,75,NULL,'3.6 micron, color corrected','UGC 03879',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48875,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48875,33.92,0.43,60.9,12472,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03879',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48876,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48876,34.03,0.34,64,12472,NULL,NULL,'Malmquist cor.','UGC 03879',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48877,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48877,37.51,0.33,318,12473,70,NULL,NULL,'2MASX J07295325+4532015',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,112.472125,45.53367,0.401,NULL,63581684347,993463817,15522872,17.6),(48878,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48878,37.52,0.27,318,12474,70,NULL,NULL,'2MASX J07295506+4354055',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000196,NULL,'16.3g',0.43,NULL,NULL,NULL,NULL,NULL,1,112.4792917,43.90136,0.285,NULL,63617045356,994016333,15531505,16.3),(48879,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48879,36.43,0.52,193,12475,70,NULL,NULL,'2MASX J07295652-6659258',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,112.485333333,-66.99044,0.709,NULL,40639857908,634997779,9921840,16.6),(48880,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48880,30.23,NULL,11.1,12476,NULL,NULL,NULL,'2MASX J07300813-2201060',NULL,'2000AJ....120.1876H',2000,1,NULL,'abs(b) < 10 degrees.','G',0.000017,NULL,'9.17K',NULL,'Scd-Sd',NULL,NULL,NULL,NULL,1,112.517667,-22.04481,NULL,NULL,39471402752,616740668,9636572,9.17),(48881,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48881,34,0.43,63.1,12477,75,NULL,'3.6 micron, color corrected','NGC 2393',NULL,'2014MNRAS.444..527S',2014,1,1.2,NULL,'G',0.000017,NULL,'14.68',0.8,'Sc',NULL,NULL,NULL,NULL,1,112.5192917,34.02778,0.221,NULL,63461923845,991592560,15493633,14.68),(48882,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48882,34.01,0.43,63.5,12477,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2393',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48883,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48883,34.05,0.2,64.6,12477,74.4,NULL,NULL,'NGC 2393',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48884,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48884,34.16,0.32,67.8,12477,NULL,NULL,'Malmquist cor.','NGC 2393',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48885,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48885,34.19,0.31,68.8,12477,NULL,NULL,NULL,'NGC 2393',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48886,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48886,37.18,0.46,273,12478,70,NULL,NULL,'2MASX J07300572+4412191',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00019,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,112.5240417,44.20533,0.277,NULL,63616257981,994004030,15531312,16.5),(48887,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48887,37.78,0.46,359,12479,70,NULL,NULL,'SDSS J073008.55+405501.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000171,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,112.535625,40.917,0.249,NULL,63609452252,993897691,15529651,18),(48888,'IRAS','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48888,33.19,0.8,43.5,12480,75,NULL,'MAT, I','NGC 2417',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.000013,NULL,'12.84',1.9,'SAB(rs)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,112.550375,-62.25264,0.657,NULL,40469050840,632328919,9880139,12.84),(48889,'Tully est','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48889,32.96,0.8,39,12480,75,NULL,'B','NGC 2417',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48890,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48890,32.59,0.36,33,12480,NULL,NULL,NULL,'NGC 2417',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48891,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48891,32.59,0.4,33,12480,73,NULL,'opt','NGC 2417',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48892,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48892,33.06,0.32,41,12480,85,NULL,'I, raw','NGC 2417',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48893,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48893,33.09,0.46,41.6,12480,NULL,NULL,'J','NGC 2417',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48894,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48894,33.11,0.45,41.8,12480,NULL,NULL,'K','NGC 2417',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48895,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48895,33.12,0.43,42.1,12480,75,NULL,'MAT, I, raw','NGC 2417',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48896,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48896,33.13,0.32,42.3,12480,85,NULL,'I, inv','NGC 2417',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48897,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48897,33.2,0.47,43.6,12480,NULL,NULL,'H','NGC 2417',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48898,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48898,33.24,0.4,44.5,12480,NULL,NULL,'mean','NGC 2417',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48899,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48899,33.27,0.43,45,12480,75,NULL,'MAT, I, cor','NGC 2417',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48900,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48900,33.32,0.65,46.1,12480,NULL,NULL,'Malmquist cor.','NGC 2417',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48901,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48901,33.42,0.43,48.3,12480,75,NULL,'MAT, I, inv','NGC 2417',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48902,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48902,33.6,0.57,52.4,12480,NULL,NULL,NULL,'NGC 2417',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48903,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48903,33.64,0.2,53.5,12480,74.4,NULL,NULL,'NGC 2417',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48904,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48904,37.24,0.46,280,12481,70,NULL,NULL,'2MASX J07301473+3756123',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000178,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,112.561167,37.93669,0.245,NULL,63590731460,993605179,15525080,17.3),(48905,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48905,37.52,0.27,318,12482,70,NULL,NULL,'2MASX J07301476+4405041',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000199,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,112.5615,44.08444,0.285,NULL,63617041199,994016268,15531504,16.3),(48906,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48906,38.22,0.46,440,12483,70,NULL,NULL,'SDSS J073015.33+393059.3',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000147,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,112.563917,39.5165,0.249,NULL,63610041881,993906904,15529795,18.6),(48907,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48907,36.93,0.46,243,12484,70,NULL,NULL,'2MASX J07301688+4330041',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000154,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,112.5702917,43.50128,0.233,NULL,63616884349,994013817,15531465,17.1),(48908,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48908,31.54,0.69,20.3,12485,100,NULL,'mid-IR','ESO 428- G 037',NULL,'2013ApJ...771...88L',2013,1,1.65,NULL,'G',0.000007,NULL,'14.17',0.8,'SA(s)b:',NULL,NULL,NULL,NULL,1,112.576875,-31.59903,NULL,NULL,42609607710,665775120,10402736,14.17),(48909,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48909,32.45,0.46,31,12485,NULL,NULL,'J','ESO 428- G 037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48910,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48910,32.46,0.47,31,12485,NULL,NULL,'H','ESO 428- G 037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48911,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48911,32.48,0.45,31.3,12485,NULL,NULL,'K','ESO 428- G 037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48912,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48912,32.59,0.4,33,12485,NULL,NULL,'mean','ESO 428- G 037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48913,'IRAS','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48913,32.38,0.8,29.9,12486,75,NULL,'A82, H','IC 0467',NULL,'1997ApJS..109..333W',1997,1,3.2,NULL,'G',0.000017,NULL,'13.21',1.3,'SAB(s)c:','Pair member (points to parent)',NULL,NULL,NULL,1,112.576625,79.87253,0.141,NULL,61454925327,960233208,15003643,13.21),(48914,'IRAS','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48914,32.42,0.8,30.4,12486,75,NULL,'CF, r','IC 0467',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48915,'Sosies','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48915,31.97,0.23,24.8,12486,NULL,NULL,NULL,'IC 0467',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48916,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48916,32.07,0.4,26,12486,NULL,NULL,'Virgo cluster at 15.6 Mpc','IC 0467',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48917,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48917,32.12,0.38,26.5,12486,75,NULL,'CF, r, raw','IC 0467',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48918,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48918,32.16,0.38,27,12486,75,NULL,'CF, r, inv','IC 0467',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48919,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48919,32.32,0.36,29.1,12486,NULL,NULL,NULL,'IC 0467',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48920,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48920,32.34,0.38,29.4,12486,75,NULL,'CF, r, cor','IC 0467',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48921,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48921,32.46,0.48,31,12486,NULL,NULL,'Malmquist cor.','IC 0467',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48922,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48922,32.51,0.4,31.7,12486,75,NULL,'B','IC 0467',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48923,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48923,32.52,0.2,31.9,12486,74.4,NULL,NULL,'IC 0467',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48924,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48924,32.57,0.4,32.6,12486,NULL,NULL,'mean','IC 0467',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48925,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48925,32.58,0.43,32.8,12486,75,NULL,'3.6 micron, color corrected','IC 0467',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48926,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48926,32.6,0.45,33.1,12486,NULL,NULL,NULL,'IC 0467',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48927,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48927,32.63,0.43,33.6,12486,75,NULL,'3.6 micron, color + selection bias corrected','IC 0467',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48928,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48928,32.65,0.47,33.9,12486,75,NULL,'A82, H, raw','IC 0467',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48929,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48929,32.71,0.47,34.9,12486,75,NULL,'A82, H, inv','IC 0467',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48930,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48930,33,0.47,39.8,12486,75,NULL,'A82, H, cor','IC 0467',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48931,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48931,33.16,0.46,42.8,12486,NULL,NULL,'J','IC 0467',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48932,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48932,33.27,0.45,45.1,12486,NULL,NULL,'K','IC 0467',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48933,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48933,33.29,0.47,45.4,12486,NULL,NULL,'H','IC 0467',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48934,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48934,37.51,0.33,318,12487,70,NULL,NULL,'2MASX J07301881+4535232',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,112.578333,45.58967,0.385,NULL,63579508089,993429813,15522340,17.5),(48935,'IRAS','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48935,33.21,0.8,43.9,12488,75,NULL,'MAT, I','ESO 123- G 016',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'14.64',0.6,'Sdm',NULL,NULL,NULL,NULL,1,112.600166667,-61.78994,0.661,NULL,40469537948,632336530,9880258,14.64),(48936,'Tully est','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48936,32.98,0.8,39.4,12488,75,NULL,NULL,'ESO 123- G 016',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48937,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48937,32.35,0.43,29.6,12488,75,NULL,'3.6 micron, color + selection bias corrected','ESO 123- G 016',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48938,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48938,32.71,0.49,34.9,12488,75,NULL,'IR','ESO 123- G 016',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48939,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48939,32.74,0.43,35.3,12488,75,NULL,'3.6 micron, color corrected','ESO 123- G 016',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48940,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48940,32.75,0.32,35.4,12488,85,NULL,'I, raw','ESO 123- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48941,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48941,32.75,0.32,35.5,12488,85,NULL,'I, inv','ESO 123- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48942,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48942,32.9,0.43,38,12488,75,NULL,'MAT, I, raw','ESO 123- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48943,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48943,32.98,0.43,39.5,12488,75,NULL,'MAT, I, inv','ESO 123- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48944,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48944,33.1,0.2,41.7,12488,74.4,NULL,NULL,'ESO 123- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48945,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48945,33.1,0.43,41.7,12488,75,NULL,'MAT, I, cor','ESO 123- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48946,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48946,33.32,0.54,46.2,12488,NULL,NULL,'Malmquist cor.','ESO 123- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48947,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48947,33.37,0.53,47.1,12488,NULL,NULL,NULL,'ESO 123- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48948,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48948,32.71,0.49,34.9,12489,75,NULL,'IR','UGC 03887',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000083,NULL,'14.90',1,'SB(s)cd',NULL,NULL,NULL,NULL,1,112.602625,36.11353,0.217,NULL,63463477665,991616838,15494013,14.9),(48949,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48949,35.97,0.6,156,12490,70,NULL,NULL,'2MASX J07302661-4906560',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000103,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,112.610917,-49.1155,0.825,NULL,42649711613,666401743,10412527,14.4),(48950,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48950,36.68,0.46,217,12491,70,NULL,NULL,'2MASX J07303713+4512440',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000189,NULL,'16.0g',0.32,NULL,NULL,NULL,NULL,NULL,1,112.654667,45.21217,0.365,NULL,63579416461,993428382,15522318,16),(48951,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48951,36.7,0.55,219,12492,70,NULL,NULL,'2MASX J07303844-5031440',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,112.66025,-50.52883,0.501,NULL,42515877716,664310589,10379852,17),(48952,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48952,37.14,0.33,268,12493,70,NULL,NULL,'2MASX J07304266+4456490',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000172,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,112.677625,44.94689,0.361,NULL,63611928554,993936383,15530255,17),(48953,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48953,35.83,0.37,147,12494,NULL,NULL,'Malmquist cor.','UGC 03882',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000023,NULL,'16.0',0.6,'SA(r)cd:',NULL,NULL,NULL,NULL,1,112.6792083,55.53581,0.149,NULL,61582842729,962231917,15034873,16),(48954,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48954,36.13,0.32,168,12494,NULL,NULL,NULL,'UGC 03882',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48955,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48955,36.17,0.2,171,12494,74.4,NULL,NULL,'UGC 03882',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48956,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48956,35.76,0.44,142,12495,NULL,NULL,'Malmquist cor.','ESO 059- G 002',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.82',0.3,'SAB(r)b',NULL,NULL,NULL,NULL,1,112.681125,-72.382,0.677,NULL,40626480672,634788760,9918574,15.82),(48957,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48957,35.94,0.4,154,12495,NULL,NULL,NULL,'ESO 059- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48958,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48958,35.98,0.2,157,12495,74.4,NULL,NULL,'ESO 059- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48959,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48959,37.46,0.46,311,12496,70,NULL,NULL,'2MASX J07304360+4006188',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,112.681833,40.10517,0.217,NULL,63609085753,993891964,15529561,17.9),(48960,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48960,37.08,0.46,261,12497,70,NULL,NULL,'2MASX J07304463+4200050',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,112.685917,42.0015,0.217,NULL,63618575696,994040245,15531878,16.5),(48961,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48961,37.54,0.46,321,12498,70,NULL,NULL,'2MASX J07304608+4440201',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,112.6922083,44.67236,0.337,NULL,63616093882,994001466,15531272,17.5),(48962,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48962,34.56,0.4,81.6,12499,NULL,NULL,'mean','UGC 03858',NULL,'2007A&A...465...71T',2007,1,1.2,'Misidentified as MCG +12-07-043 in UGC','G',0.00007,NULL,'13.8',1,'Sa','in a pair',NULL,NULL,NULL,1,112.693375,73.63014,0.089,NULL,61298048820,957782012,14965343,13.8),(48963,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48963,35.35,0.45,117,12499,NULL,NULL,'K','UGC 03858',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48964,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48964,35.39,0.47,119,12499,NULL,NULL,'H','UGC 03858',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48965,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48965,35.43,0.46,122,12499,NULL,NULL,'J','UGC 03858',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48966,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48966,36.64,0.46,213,12500,70,NULL,NULL,'2MASX J07304709+3628418',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00007,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,112.696166667,36.47839,0.225,NULL,63460482642,991570041,15493281,17.5),(48967,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48967,33.92,0.41,60.9,12501,NULL,NULL,'Malmquist cor.','UGC 03859',NULL,'2009ApJS..182..474S',2009,1,1,'Misidentified as MCG +12-07-045 in UGC','G',0.000037,NULL,'13.60',0.8,'Sa','in a pair',NULL,NULL,NULL,1,112.7025417,73.70642,0.089,NULL,61298010770,957781418,14965334,13.6),(48968,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48968,34.06,0.47,64.9,12501,NULL,NULL,'H','UGC 03859',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48969,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48969,34.09,0.45,65.6,12501,NULL,NULL,'K','UGC 03859',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48970,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48970,34.14,0.46,67.2,12501,NULL,NULL,'J','UGC 03859',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48971,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48971,34.22,0.36,69.8,12501,NULL,NULL,NULL,'UGC 03859',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48972,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48972,34.26,0.2,71.1,12501,74.4,NULL,NULL,'UGC 03859',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48973,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48973,34.56,0.4,81.5,12501,NULL,NULL,'mean','UGC 03859',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48974,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48974,38.22,0.46,440,12502,70,NULL,NULL,'SDSS J073048.89+380336.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00018,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,112.7037083,38.06025,0.245,NULL,63590866935,993607295,15525113,18.2),(48975,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48975,37.14,0.33,268,12503,70,NULL,NULL,'2MASX J07305067+4456011',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000211,NULL,'16.6g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,112.711125,44.93358,0.361,NULL,63611925778,993936340,15530255,16.6),(48976,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48976,38.42,0.33,483,12504,70,NULL,NULL,'2MASX J07305569+3839278',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,112.732167,38.65775,0.237,NULL,63590308275,993598566,15524977,17.9),(48977,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48977,37.79,0.46,362,12505,70,NULL,NULL,'2MASX J07305702+3918008',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000183,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,112.737583333,39.30028,0.253,NULL,63607206837,993862606,15529103,17.7),(48978,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48978,36.71,0.71,220,12506,70,NULL,NULL,'2MASX J07305761-4957428',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.4,NULL,NULL,NULL,NULL,NULL,1,112.739916667,-49.962,0.557,NULL,42649386946,666396671,10412447,14.6),(48979,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48979,37.24,0.46,280,12507,70,NULL,NULL,'2MASX J07310295+4408540',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000178,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,112.7622083,44.14831,0.293,NULL,63616935824,994014622,15531478,17.3),(48980,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48980,34.77,0.49,89.8,12508,75,NULL,'IR','UGC 03892',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.000033,NULL,'14.6',0.4,'Scd?','Group member',NULL,NULL,NULL,1,112.79075,13.05961,0.193,NULL,63304275430,989129303,15455145,14.6),(48981,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48981,35.09,0.2,104,12508,74.4,NULL,NULL,'UGC 03892',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48982,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48982,35.16,0.39,108,12508,NULL,NULL,NULL,'UGC 03892',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48983,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48983,35.2,0.38,110,12508,NULL,NULL,'Malmquist cor.','UGC 03892',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48984,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48984,36.89,0.46,238,12509,70,NULL,NULL,'2MASX J07311142+3623459',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00008,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,112.797458333,36.396,0.225,NULL,63460502645,991570353,15493286,17.1),(48985,'TRGB','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48985,28.21,0.1,4.39,12510,NULL,NULL,NULL,'ESO 059- G 001',NULL,'2012A&A...540A..49M',2012,1,2.1,NULL,'G',0.00001,NULL,'13.9B',1.7,'IB(s)m',NULL,NULL,NULL,NULL,1,112.825833,-68.188,0.621,NULL,40666887911,635420123,9928439,13.9),(48986,'TRGB','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48986,28.26,0.03,4.49,12510,NULL,NULL,'I','ESO 059- G 001',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48987,'TRGB','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48987,28.3,NULL,4.57,12510,NULL,NULL,NULL,'ESO 059- G 001',NULL,'2006AJ....131.1361K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48988,'TRGB','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48988,28.33,0.1,4.63,12510,74.4,NULL,NULL,'ESO 059- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48989,'Tully est','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,48989,28.2,0.8,4.4,12510,75,NULL,NULL,'ESO 059- G 001',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(48990,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48990,37.26,0.46,283,12511,70,NULL,NULL,'2MASX J07313208+3638099',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000089,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,112.883667,36.63608,0.233,NULL,63460515666,991570557,15493289,16.7),(48991,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48991,38.42,0.33,483,12512,70,NULL,NULL,'2MASX J07313545+3838528',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,112.89775,38.64789,0.237,NULL,63590291627,993598306,15524973,17.8),(48992,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48992,37.9,0.46,380,12513,70,NULL,NULL,'2MASX J07313756+2817303',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,112.906625,28.29189,0.169,NULL,63427887837,991060747,15485324,17.5),(48993,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48993,36.84,0.46,233,12514,70,NULL,NULL,'2MASX J07313871+4612165',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'17.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,112.911375,46.20472,0.405,NULL,63579959732,993436870,15522451,17.2),(48994,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48994,36.7,0.46,219,12515,70,NULL,NULL,'2MASX J07314258+4305595',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000154,NULL,'17.6g',NULL,NULL,NULL,NULL,NULL,NULL,1,112.927583,43.09994,0.225,NULL,63619016441,994047131,15531986,17.6),(48995,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48995,37.26,0.46,283,12516,70,NULL,NULL,'2MASX J07314641+4534275',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000188,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,112.943333,45.57439,0.401,NULL,63579561544,993430649,15522353,16.4),(48996,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48996,37.97,0.46,393,12517,70,NULL,NULL,'2MASX J07315348+4054102',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,112.9729583,40.90283,0.249,NULL,63609389328,993896708,15529636,17.6),(48997,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48997,37.58,0.46,328,12518,70,NULL,NULL,'2MASX J07315376+4510192',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,112.9737917,45.17192,0.365,NULL,63579455489,993428992,15522328,17.3),(48998,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48998,37.69,0.46,345,12519,70,NULL,NULL,'2MASX J07315513+3908242',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000184,NULL,'16.6g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,112.9797083,39.14014,0.209,NULL,63607387687,993865432,15529147,16.6),(48999,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',48999,37.52,0.46,320,12520,70,NULL,NULL,'SDSS J073155.17+393244.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00014,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,112.979917,39.54561,0.241,NULL,63610048272,993907004,15529796,18.5),(49000,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49000,32.73,0.4,35.2,12521,75,NULL,NULL,'ESO 429- G 001',NULL,'2008Ap.....51..336K',2008,1,1.2,'abs(b) < 10 degrees.','G',0.000033,NULL,'11.0K',0.3,'S...',NULL,NULL,NULL,NULL,1,113.001917,-31.79761,NULL,NULL,42609789868,665777966,10402780,11),(49001,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49001,32.73,0.39,35.2,12521,73,NULL,'IR','ESO 429- G 001',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49002,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49002,32.73,0.39,35.2,12521,73,NULL,'opt','ESO 429- G 001',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49003,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49003,33.28,0.49,45.2,12521,75,NULL,'IR','ESO 429- G 001',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49004,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49004,35.59,0.71,131,12522,70,NULL,NULL,'2MASX J07320407-6311048',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,113.0167917,-63.18464,0.645,NULL,40353364082,630521313,9851895,17.1),(49005,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49005,37.37,0.46,298,12523,70,NULL,NULL,'2MASX J07320553+2523138',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,113.023,25.38714,0.181,NULL,62962095718,983782745,15371605,17.7),(49006,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49006,36.86,0.46,236,12524,70,NULL,NULL,'2MASX J07321171+2853438',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000173,NULL,'16.8g',0.34,NULL,NULL,NULL,NULL,NULL,1,113.0487083,28.89547,0.165,NULL,63430136877,991095888,15485873,16.8),(49007,'SZ effect','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49007,38.58,0.58,520,12525,NULL,NULL,'Hydrost. Eq.','ABELL 0586',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I      [BM]',NULL,NULL,NULL,NULL,1,113.091667,31.62972,0.189,NULL,63476544339,991821005,15497203,NULL),(49008,'SZ effect','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49008,38.88,NULL,598,12525,NULL,NULL,'3.1 (red) calibration','ABELL 0586',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49009,'SZ effect','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49009,38.93,0.59,610,12525,NULL,NULL,'Isotherm.','ABELL 0586',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49010,'SZ effect','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49010,39.09,NULL,658,12525,NULL,NULL,'4.2 (black) calibration','ABELL 0586',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49011,'SZ effect','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49011,39.23,NULL,700,12525,NULL,NULL,'4.1 (blue) calibration','ABELL 0586',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49012,'SZ effect','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49012,39.35,0.59,740,12525,NULL,NULL,'Isotherm., r < 100 kpc','ABELL 0586',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49013,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49013,36.32,0.46,184,12526,70,NULL,NULL,'2MASX J07321837+3832123',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000087,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,113.0765417,38.53667,0.257,NULL,63590767845,993605747,15525089,16.2),(49014,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49014,38.01,0.46,400,12527,70,NULL,NULL,'2MASX J07322001+2843338',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,113.083375,28.72597,0.165,NULL,63430171726,991096433,15485881,18),(49015,'D-Sigma','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49015,32.74,0.4,35.3,12528,75,NULL,'Edat, raw','NGC 2300',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.000023,NULL,'12.07',2,'SA0^0^','Pair member (points to parent)',NULL,NULL,NULL,1,113.083208333,85.7095,0.217,NULL,61209069805,956391715,14943620,12.07),(49016,'D-Sigma','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49016,33.07,0.4,41.2,12528,75,NULL,'Edat, cor','NGC 2300',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49017,'Faber-Jackson','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49017,31.34,0.46,18.5,12528,95,NULL,'de Vaucouleurs','NGC 2300',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49018,'Faber-Jackson','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49018,31.92,0.38,24.2,12528,95,NULL,'Weighted Mean','NGC 2300',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49019,'Faber-Jackson','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49019,34.8,0.81,91.2,12528,55,NULL,'Visvanathan & Sandage 1979','NGC 2300',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49020,'Tertiary','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49020,31.38,0.29,18.9,12528,95,NULL,NULL,'NGC 2300',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49021,'Tully est','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49021,32.46,0.8,31,12528,75,NULL,'B','NGC 2300',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49022,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49022,32.36,0.4,29.7,12528,NULL,NULL,'mean','NGC 2300',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49023,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49023,32.83,0.45,36.8,12528,NULL,NULL,'K','NGC 2300',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49024,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49024,37.01,0.46,253,12529,70,NULL,NULL,'2MASX J07322070+4336033',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,113.0864583,43.60078,0.281,NULL,63616756744,994011824,15531434,16.5),(49025,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49025,38.06,0.46,410,12530,70,NULL,NULL,'2MASX J07322323+4210492',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,113.096916667,42.18028,0.217,NULL,63618624007,994041000,15531890,18),(49026,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49026,36.96,0.46,246,12531,70,NULL,NULL,'SDSS J073225.83+395348.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000143,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,113.107625,39.89694,0.261,NULL,63610237427,993909959,15529843,18.1),(49027,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49027,35.61,0.52,133,12532,70,NULL,NULL,'2MASX J07322976-8351055',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,113.124083333,-83.85153,0.541,NULL,39767394764,621365543,9708836,15.9),(49028,'D-Sigma','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49028,33.46,0.4,49.3,12533,75,NULL,'Edat, raw','ESO 005- G 010',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',NULL,NULL,'13.79',1,'E4',NULL,NULL,NULL,NULL,1,113.132125,-84.07233,0.509,NULL,39785161721,621643151,9713174,13.79),(49029,'D-Sigma','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49029,33.75,0.4,56.3,12533,75,NULL,'Edat, cor','ESO 005- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49030,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49030,34.38,0.4,75.1,12533,NULL,NULL,'mean','ESO 005- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49031,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49031,34.58,0.45,82.4,12533,NULL,NULL,'K','ESO 005- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49032,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49032,35.65,0.6,135,12534,70,NULL,NULL,'2MASX J07323548-5159486',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,113.147917,-51.99683,0.769,NULL,42517391668,664334244,10380222,15),(49033,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49033,37.17,0.46,272,12535,70,NULL,NULL,'2MASX J07323825+4309200',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000149,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,113.1595,43.1555,0.245,NULL,63618809001,994043890,15531935,16.9),(49034,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49034,38.14,0.27,425,12536,70,NULL,NULL,'2MASX J07323946+3929403',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000183,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,113.1642917,39.49472,0.273,NULL,63607295191,993863987,15529124,17.7),(49035,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49035,38.14,0.27,425,12537,70,NULL,NULL,'2MASX J07323997+3928243',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.7g',0.17,'BrClG',NULL,NULL,NULL,NULL,1,113.16675,39.47344,0.273,NULL,63607293360,993863958,15529124,17.7),(49036,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49036,37.11,0.46,264,12538,70,NULL,NULL,'2MASX J07324355+3940203',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000164,NULL,'16.8g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,113.1815,39.67225,0.241,NULL,63610137090,993908392,15529818,16.8),(49037,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49037,38.14,0.27,425,12539,70,NULL,NULL,'2MASX J07324803+3932496',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,113.200167,39.54706,0.241,NULL,63607293998,993863968,15529124,18),(49038,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49038,36.89,0.46,239,12540,70,NULL,NULL,'2MASX J07325150+2927318',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00018,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,113.214583,29.45894,0.241,NULL,63430238014,991097468,15485897,17),(49039,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49039,35.47,0.46,124,12541,70,NULL,NULL,'2MASX J07330124+4225300',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000183,NULL,'15.4g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,113.25525,42.42511,0.241,NULL,63618981245,994046581,15531977,15.4),(49040,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49040,37.61,0.33,333,12542,70,NULL,NULL,'2MASX J07330597+3828287',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000075,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,113.274708333,38.47458,0.237,NULL,63589923182,993592549,15524883,17.1),(49041,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49041,37.91,0.46,382,12543,70,NULL,NULL,'2MASX J07330973+3934577',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,113.290667,39.58275,0.241,NULL,63610131005,993908296,15529817,17.8),(49042,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49042,36.98,0.46,249,12544,70,NULL,NULL,'2MASX J07331156+3218528',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000175,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,113.298333,32.31481,0.137,NULL,63475186811,991799793,15496871,17.6),(49043,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49043,37.85,0.46,372,12545,70,NULL,NULL,'SDSS J073313.27+383807.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000072,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,113.305333,38.63544,0.237,NULL,63606752077,993855501,15528992,18.6),(49044,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49044,37.61,0.33,333,12546,70,NULL,NULL,'SDSS J073319.75+382400.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000071,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,113.3322917,38.40017,0.237,NULL,63589962769,993593168,15524893,18.6),(49045,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49045,37.05,0.46,258,12547,70,NULL,NULL,'2MASX J07331988+4051396',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,113.3327083,40.86097,0.225,NULL,63610026900,993906670,15529791,16.9),(49046,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49046,37.21,0.46,277,12548,70,NULL,NULL,'2MASX J07332273+4036006',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00014,NULL,'17.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,113.344666667,40.60008,0.253,NULL,63609849316,993903895,15529748,17.6),(49047,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49047,34.36,0.4,74.3,12549,NULL,NULL,'mean','IC 2193',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00003,NULL,'14.20',0.9,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,113.348791667,31.48356,0.189,NULL,63476461987,991819718,15497183,14.2),(49048,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49048,34.38,0.5,75.1,12549,NULL,NULL,'Malmquist cor.','IC 2193',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49049,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49049,34.64,0.47,84.6,12549,NULL,NULL,'H','IC 2193',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49050,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49050,34.67,0.45,86,12549,NULL,NULL,'K','IC 2193',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49051,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49051,34.71,0.43,87.5,12549,NULL,NULL,NULL,'IC 2193',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49052,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49052,34.71,0.46,87.7,12549,NULL,NULL,'J','IC 2193',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49053,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49053,34.75,0.2,89.1,12549,74.4,NULL,NULL,'IC 2193',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49054,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49054,36.22,0.69,175,12550,70,NULL,NULL,'2MASX J07332434-5232309',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,113.351417,-52.54181,0.573,NULL,42515095495,664298367,10379661,17.5),(49055,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49055,35.83,0.49,147,12551,75,NULL,'IR','FGC 0634',NULL,'2011yCatp016004901K',2011,1,0.64,NULL,'G',0.000018,NULL,'17.1',0.08,'Sd',NULL,NULL,NULL,NULL,1,113.354,20.45458,0.857,NULL,63092885755,985826339,15403536,17.1),(49056,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49056,35.95,NULL,155,12551,NULL,NULL,NULL,'FGC 0634',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49057,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49057,35.96,NULL,155,12551,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0634',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49058,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49058,35.98,NULL,157,12551,NULL,NULL,'Dipole + Quadrupole','FGC 0634',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49059,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49059,36.01,NULL,159,12551,NULL,NULL,'Dipole','FGC 0634',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49060,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49060,36.49,0.43,199,12551,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0634',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49061,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49061,36.58,0.46,207,12552,70,NULL,NULL,'2MASX J07332529+4411114',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000173,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,113.3552917,44.18647,0.293,NULL,63612263292,993941613,15530337,16.6),(49062,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49062,38.46,0.46,492,12553,70,NULL,NULL,'2MASX J07332532+4217114',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,113.355375,42.28658,0.217,NULL,63618547305,994039801,15531871,18.1),(49063,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49063,38,0.46,398,12554,70,NULL,NULL,'2MASX J07332957+3753564',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,113.3732083,37.89917,0.221,NULL,63590067370,993594802,15524918,17.2),(49064,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49064,37.4,0.33,302,12555,70,NULL,NULL,'2MASX J07333049+4359264',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000174,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,113.377167,43.99067,0.269,NULL,63616702543,994010977,15531421,18.5),(49065,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49065,37.2,0.46,275,12556,70,NULL,NULL,'2MASX J07333654+2636167',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,113.4022917,26.6045,0.221,NULL,62963663014,983807234,15371988,17.3),(49066,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49066,35.13,0.48,106,12557,70,NULL,NULL,'2MASX J07333674-5609266',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00013,NULL,'13.7I',0.4,NULL,NULL,NULL,NULL,NULL,1,113.40325,-56.15739,0.533,NULL,40424123333,631626927,9869170,13.7),(49067,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49067,36.84,0.46,233,12558,70,NULL,NULL,'2MASX J07334558+4316073',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000152,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,113.43975,43.26872,0.237,NULL,63618923026,994045672,15531963,16.8),(49068,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49068,36.14,0.54,169,12559,70,NULL,NULL,'2MASX J07334687-5045277',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,113.44525,-50.75769,0.593,NULL,42515897371,664310896,10379857,16.4),(49069,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49069,36.89,0.46,239,12560,70,NULL,NULL,'2MASXi J0733500+413532',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000154,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,113.458666667,41.59242,0.201,NULL,63615538340,993992786,15531137,17.7),(49070,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49070,37.28,0.33,285,12561,70,NULL,NULL,'2MASX J07335227+2652386',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,113.4677083,26.87739,0.193,NULL,62963030162,983797346,15371833,18.1),(49071,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49071,34.23,0.49,70.1,12562,75,NULL,'IR','UGC 03889',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.00008,NULL,'15.30',0.2,'Sab',NULL,NULL,NULL,NULL,1,113.483,73.64386,0.101,NULL,61297984410,957781006,14965328,15.3),(49072,'SBF','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49072,30.62,0.14,13.3,12563,74.4,NULL,NULL,'ESO 208- G 021',NULL,'2013AJ....146...86T',2013,1,3,NULL,'G',0.00006,NULL,'12.19',2.1,'SAB0-',NULL,NULL,NULL,NULL,1,113.484375,-50.44303,0.601,NULL,42516384725,664318511,10379976,12.19),(49073,'SBF','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49073,30.66,0.2,13.6,12563,NULL,NULL,'I','ESO 208- G 021',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49074,'SBF','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49074,30.66,0.2,13.6,12563,NULL,NULL,NULL,'ESO 208- G 021',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49075,'SBF','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49075,30.72,0.2,13.9,12563,NULL,NULL,'Malmquist cor.','ESO 208- G 021',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49076,'D-Sigma','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49076,31.31,0.4,18.3,12563,75,NULL,'Edat, raw','ESO 208- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49077,'D-Sigma','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49077,31.65,0.4,21.3,12563,75,NULL,'Edat, cor','ESO 208- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49078,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49078,31.34,0.41,18.5,12563,NULL,NULL,NULL,'ESO 208- G 021',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49079,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49079,31.5,0.41,20,12563,NULL,NULL,'Malmquist cor.','ESO 208- G 021',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49080,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49080,31.13,0.4,16.8,12563,NULL,NULL,'mean','ESO 208- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49081,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49081,31.2,0.45,17.4,12563,NULL,NULL,'K','ESO 208- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49082,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49082,36.91,0.46,241,12564,70,NULL,NULL,'2MASX J07335834+3702373',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000097,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,113.493,37.04367,0.193,NULL,63459958907,991561857,15493154,16.6),(49083,'TRGB','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49083,27.36,0.09,2.96,12565,NULL,NULL,'I','UGCA 133',NULL,'2009AJ....138..332J',2009,1,3,NULL,'G',NULL,NULL,'15.64',2,'Im:','Dwarf, possible member',NULL,NULL,NULL,1,113.547917,66.87972,0.141,1,62172288709,971442011,15178781,15.64),(49084,'TRGB','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49084,27.39,NULL,3.01,12565,NULL,NULL,NULL,'UGCA 133',NULL,'2006PASP..118..580A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49085,'TRGB','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49085,27.45,NULL,3.1,12565,NULL,NULL,NULL,'UGCA 133',NULL,'2010ApJ...724.1030G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49086,'TRGB','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49086,27.45,0.03,3.1,12565,NULL,NULL,'I','UGCA 133',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49087,'TRGB','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49087,27.5,0.08,3.17,12565,74.4,NULL,NULL,'UGCA 133',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49088,'TRGB','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49088,27.52,0.15,3.2,12565,NULL,NULL,NULL,'UGCA 133',NULL,'1999A&A...352..399K',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49089,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49089,31.16,0.4,17.1,12566,75,NULL,'B','UGC 03912',NULL,'1988NBGC.C....0000T',1988,1,1.8,NULL,'G',0.000017,NULL,'13.3',1.1,'IBm:',NULL,NULL,NULL,NULL,1,113.552666667,4.54644,0.433,NULL,62688559680,979508745,15304824,13.3),(49090,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49090,31.51,NULL,20,12566,NULL,NULL,NULL,'UGC 03912',NULL,'2015AstBu..70....1K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49091,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49091,38.27,0.46,451,12567,70,NULL,NULL,'2MASX J07341614+2800116',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,113.5672083,28.00336,0.153,NULL,63428214839,991065856,15485404,17.7),(49092,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49092,37.28,0.33,285,12568,70,NULL,NULL,'2MASX J07342223+2651446',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000207,NULL,'15.7g',0.5,'BrClG',NULL,NULL,NULL,NULL,1,113.592541667,26.86247,0.193,NULL,62962817429,983794022,15371781,15.7),(49093,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49093,37.4,0.33,302,12569,70,NULL,NULL,'2MASX J07342239+4353289',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000167,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,113.593167,43.89128,0.269,NULL,63616811404,994012678,15531448,16.6),(49094,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49094,37.89,0.46,378,12570,70,NULL,NULL,'2MASX J07342448+2832316',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,113.601916667,28.54219,0.173,NULL,63428116369,991064318,15485379,17.5),(49095,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49095,37.99,0.46,396,12571,70,NULL,NULL,'2MASX J07342712+3800198',NULL,'2015arXiv151105856S',2015,1,0.11,NULL,'G',0.000095,NULL,'18.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,113.613167,38.00547,0.221,NULL,63589892677,993592073,15524876,18.1),(49096,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49096,37.96,0.46,391,12572,70,NULL,NULL,'2MASX J07343361+3910130',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00006,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,113.6402083,39.17033,0.209,NULL,63607646132,993869470,15529210,17.9),(49097,'SBF','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49097,31.63,0.14,21.2,12573,74.4,NULL,NULL,'NGC 2434',NULL,'2013AJ....146...86T',2013,1,2.5,NULL,'G',0.00009,NULL,'12.33',2.3,'E0-1','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,113.713167,-69.28414,0.709,NULL,40667055958,635422749,9928480,12.33),(49098,'SBF','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49098,31.67,0.29,21.6,12573,NULL,NULL,'I','NGC 2434',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49099,'SBF','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49099,31.67,0.29,21.6,12573,NULL,NULL,NULL,'NGC 2434',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49100,'SBF','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49100,31.73,0.29,22.2,12573,NULL,NULL,'Malmquist cor.','NGC 2434',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49101,'D-Sigma','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49101,31.66,0.4,21.5,12573,75,NULL,'Edat, raw','NGC 2434',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49102,'D-Sigma','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49102,32,0.4,25.1,12573,75,NULL,'Edat, cor','NGC 2434',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49103,'Faber-Jackson','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49103,31.3,0.63,18.2,12573,95,NULL,'Michard 1979b, c','NGC 2434',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49104,'Faber-Jackson','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49104,31.79,0.37,22.8,12573,95,NULL,'Weighted Mean','NGC 2434',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49105,'Faber-Jackson','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49105,31.86,0.46,23.6,12573,95,NULL,'Michard 1979a','NGC 2434',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49106,'Faber-Jackson','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49106,34.29,0.81,72.1,12573,55,NULL,'Visvanathan & Sandage 1979','NGC 2434',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49107,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49107,31.77,0.41,22.6,12573,NULL,NULL,NULL,'NGC 2434',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49108,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49108,31.96,0.41,24.6,12573,NULL,NULL,'Malmquist cor.','NGC 2434',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49109,'Tully est','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49109,31.08,0.8,16.4,12573,75,NULL,'B','NGC 2434',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49110,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49110,32.3,0.45,28.8,12573,NULL,NULL,'K','NGC 2434',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49111,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49111,32.75,0.4,35.5,12573,NULL,NULL,'mean','NGC 2434',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49112,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49112,37.46,0.46,310,12574,70,NULL,NULL,'2MASX J07345170+4211479',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,113.7155,42.19658,0.237,NULL,63615729640,993995775,15531183,17.7),(49113,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49113,33.79,0.43,57.3,12575,75,NULL,'3.6 micron, color + selection bias corrected','IC 2199',NULL,'2014MNRAS.444..527S',2014,1,1.1,NULL,'G',0.000033,NULL,'14.10',0.6,'SB?','in a pair',NULL,NULL,NULL,1,113.73225,31.27625,0.161,NULL,63474116310,991783067,15496610,14.1),(49114,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49114,33.92,0.43,61,12575,75,NULL,'3.6 micron, color corrected','IC 2199',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49115,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49115,34.1,0.2,66.1,12575,74.4,NULL,NULL,'IC 2199',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49116,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49116,34.15,0.4,67.7,12575,NULL,NULL,'mean','IC 2199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49117,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49117,34.16,0.47,67.9,12575,NULL,NULL,'H','IC 2199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49118,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49118,34.16,0.28,67.9,12575,NULL,NULL,'Malmquist cor.','IC 2199',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49119,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49119,34.16,0.28,67.9,12575,NULL,NULL,NULL,'IC 2199',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49120,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49120,34.19,0.45,69,12575,NULL,NULL,'K','IC 2199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49121,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49121,34.2,0.46,69.2,12575,NULL,NULL,'J','IC 2199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49122,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49122,37.82,0.46,367,12576,70,NULL,NULL,'2MASX J07345608+4200528',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000175,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,113.73375,42.01458,0.205,NULL,63615755077,993996173,15531190,17.4),(49123,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49123,37.63,0.46,335,12577,70,NULL,NULL,'2MASX J07345694+3659481',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000077,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,113.7374583,36.99669,0.193,NULL,63468287168,991691987,15495187,17.4),(49124,'Sosies','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49124,34.05,0.4,64.6,12578,NULL,NULL,NULL,'NGC 2410',NULL,'2002A&A...393...57T',2002,1,2.37,NULL,'G',0.00002,NULL,'13.5g',0.69,'SBb?           NLAGN','Group member, radial-velocity confirmed',NULL,NULL,'Sy 2',1,113.759417,32.82211,0.153,NULL,63483377727,991927776,15498871,13.5),(49125,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49125,33.94,0.46,61.5,12578,NULL,NULL,'J','NGC 2410',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49126,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49126,33.96,0.47,62.1,12578,NULL,NULL,'H','NGC 2410',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49127,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49127,33.98,0.45,62.6,12578,NULL,NULL,'K','NGC 2410',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49128,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49128,33.99,0.29,62.9,12578,NULL,NULL,NULL,'NGC 2410',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49129,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49129,34.03,0.2,64,12578,74.4,NULL,NULL,'NGC 2410',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49130,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49130,34.05,0.28,64.7,12578,NULL,NULL,'Malmquist cor.','NGC 2410',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49131,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49131,34.17,0.4,68.1,12578,NULL,NULL,'mean','NGC 2410',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49132,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49132,38.01,0.46,400,12579,70,NULL,NULL,'2MASX J07350472+4711378',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000168,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,113.769667,47.19375,0.353,NULL,63580442219,993444409,15522568,18.5),(49133,'IRAS','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49133,33.04,0.8,40.6,12580,75,NULL,'MAT, I','ESO 257- G 019',NULL,'1997ApJS..109..333W',1997,1,4.09,NULL,'G',0.000017,NULL,'14.44',0.58,'SB(s)cd? sp',NULL,NULL,NULL,NULL,1,113.7785417,-46.92597,0.693,NULL,42655240672,666488135,10413877,14.44),(49134,'Tully est','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49134,32.75,0.8,35.5,12580,75,NULL,NULL,'ESO 257- G 019',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49135,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49135,32.48,0.4,31.4,12580,73,NULL,'IR','ESO 257- G 019',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49136,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49136,32.49,0.4,31.4,12580,75,NULL,NULL,'ESO 257- G 019',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49137,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49137,32.55,NULL,32.3,12580,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 257- G 019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49138,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49138,32.56,NULL,32.5,12580,NULL,NULL,'Dipole','ESO 257- G 019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49139,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49139,32.56,NULL,32.5,12580,NULL,NULL,'Dipole + Quadrupole','ESO 257- G 019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49140,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49140,32.58,0.32,32.8,12580,85,NULL,'I, raw','ESO 257- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49141,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49141,32.59,0.43,32.9,12580,75,NULL,'MAT, I, raw','ESO 257- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49142,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49142,32.6,0.39,33.1,12580,73,NULL,'opt','ESO 257- G 019',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49143,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49143,32.61,0.32,33.2,12580,85,NULL,'I, inv','ESO 257- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49144,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49144,32.71,0.4,34.8,12580,NULL,NULL,NULL,'ESO 257- G 019',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49145,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49145,32.74,0.43,35.3,12580,75,NULL,'MAT, I, inv','ESO 257- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49146,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49146,32.75,0.2,35.5,12580,74.4,NULL,NULL,'ESO 257- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49147,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49147,32.76,NULL,35.6,12580,NULL,NULL,NULL,'ESO 257- G 019',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49148,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49148,32.79,0.53,36.1,12580,NULL,NULL,NULL,'ESO 257- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49149,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49149,32.79,0.43,36.2,12580,75,NULL,'MAT, I, cor','ESO 257- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49150,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49150,32.79,0.39,36.2,12580,73,NULL,'opt','ESO 257- G 019',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49151,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49151,32.81,0.43,36.4,12580,75,NULL,'3.6 micron, color + selection bias corrected','ESO 257- G 019',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49152,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49152,32.82,0.43,36.7,12580,75,NULL,'3.6 micron, color corrected','ESO 257- G 019',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49153,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49153,32.86,0.49,37.3,12580,75,NULL,'IR','ESO 257- G 019',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49154,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49154,32.88,0.51,37.7,12580,NULL,NULL,'Malmquist cor.','ESO 257- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49155,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49155,33.12,0.47,42,12580,NULL,NULL,'H','ESO 257- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49156,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49156,33.2,0.46,43.6,12580,NULL,NULL,'J','ESO 257- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49157,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49157,33.2,0.4,43.6,12580,NULL,NULL,'mean','ESO 257- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (49158,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49158,33.21,0.45,43.8,12580,NULL,NULL,'K','ESO 257- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49159,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49159,37.59,0.46,330,12581,70,NULL,NULL,'2MASX J07351034+4703044',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,113.7930417,47.05122,0.345,NULL,63580625398,993447271,15522613,18.4),(49160,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49160,37.8,0.46,363,12582,70,NULL,NULL,'2MASX J07351302+4103241',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,113.804167,41.05675,0.229,NULL,63608042850,993875669,15529307,17.2),(49161,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49161,33.45,0.57,49,12583,70,NULL,NULL,'ESO 035- G 011',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00014,NULL,'14.59',0.9,'SB(r)a',NULL,NULL,NULL,NULL,1,113.820625,-76.91875,0.893,NULL,39913187004,623643546,9744430,14.59),(49162,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49162,37.96,0.46,391,12584,70,NULL,NULL,'2MASX J07351852+4407515',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000179,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,113.827375,44.131,0.193,NULL,63612382805,993943481,15530366,17.6),(49163,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49163,37.06,0.46,259,12585,70,NULL,NULL,'2MASX J07351889+2651524',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000175,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,113.828667,26.86456,0.193,NULL,62962806668,983793854,15371778,16.7),(49164,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49164,37.66,0.27,341,12586,70,NULL,NULL,'2MASXi J0735249+394430',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,113.8537083,39.74194,0.269,NULL,63610428164,993912940,15529889,18.1),(49165,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49165,37.76,0.46,356,12587,70,NULL,NULL,'2MASX J07352493+3138238',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,113.854041667,31.64003,0.157,NULL,63473844111,991778814,15496543,17.8),(49166,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49166,36.5,0.46,199,12588,70,NULL,NULL,'2MASX J07352767+4442066',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000181,NULL,'16.1g',0.49,NULL,NULL,NULL,NULL,NULL,1,113.8652917,44.70192,0.225,NULL,63612899279,993951551,15530492,16.1),(49167,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49167,37.86,0.46,373,12589,70,NULL,NULL,'2MASX J07353395+4424166',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,113.8912917,44.40461,0.193,NULL,63612208057,993940750,15530324,17.5),(49168,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49168,38.77,0.33,568,12590,70,NULL,NULL,'SDSS J073536.41+393122.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000079,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,113.90175,39.523,0.321,NULL,63607005878,993859466,15529054,18.5),(49169,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49169,37.66,0.27,341,12591,70,NULL,NULL,'MCG +07-16-007',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000106,NULL,'15.9g',0.38,'BrClG',NULL,NULL,NULL,NULL,1,113.901875,39.76489,0.269,NULL,63610429083,993912954,15529889,15.9),(49170,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49170,33.79,1.14,57.3,12592,NULL,NULL,NULL,'UGC 03924',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000017,NULL,'14.7',0.9,'Sm:','Group member',NULL,NULL,NULL,1,113.9092083,11.52247,0.113,NULL,63234363657,988036932,15438077,14.7),(49171,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49171,33.83,0.2,58.3,12592,74.4,NULL,NULL,'UGC 03924',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49172,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49172,34.4,0.86,75.8,12592,NULL,NULL,'Malmquist cor.','UGC 03924',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49173,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49173,37.82,0.46,366,12593,70,NULL,NULL,'2MASX J07354112+3804251',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000067,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,113.92125,38.07356,0.221,NULL,63606629114,993853579,15528962,18),(49174,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49174,33.71,0.56,55.3,12594,NULL,NULL,NULL,'NGC 2416',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.1',0.7,'Scd:','Group member',NULL,NULL,NULL,1,113.923,11.61203,0.113,NULL,63234323769,988036308,15438067,14.1),(49175,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49175,33.75,0.2,56.2,12594,74.4,NULL,NULL,'NGC 2416',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49176,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49176,33.91,0.51,60.5,12594,NULL,NULL,'Malmquist cor.','NGC 2416',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49177,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49177,37.42,0.46,305,12595,70,NULL,NULL,'2MASX J07354175+4219166',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,113.9237917,42.32131,0.237,NULL,63615852837,993997700,15531214,17.3),(49178,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49178,37.66,0.27,341,12596,70,NULL,NULL,'2MASX J07354241+3946041',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000076,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,113.926875,39.76794,0.269,NULL,63610425754,993912902,15529889,18),(49179,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49179,37.39,0.46,301,12597,70,NULL,NULL,'2MASX J07354294+3148348',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000174,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,113.929083333,31.80956,0.157,NULL,63473949662,991780463,15496569,16.9),(49180,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49180,37.64,0.46,338,12598,70,NULL,NULL,'2MASX J07354451+1758054',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,113.935417,17.96822,0.109,NULL,63123761025,986308766,15411074,17.3),(49181,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49181,37.4,0.46,302,12599,70,NULL,NULL,'2MASX J07355136+4211392',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,113.963833,42.19414,0.205,NULL,63615698155,993995283,15531176,17.2),(49182,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49182,37.15,0.46,269,12600,70,NULL,NULL,'2MASX J07355431+3323078',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,113.976291667,33.38544,0.177,NULL,63483720206,991933128,15498955,17.6),(49183,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49183,37.59,0.46,330,12601,70,NULL,NULL,'2MASX J07360051+3914003',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000091,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,114.002166667,39.23353,0.249,NULL,63607623582,993869118,15529204,16.9),(49184,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49184,37.53,0.46,321,12602,70,NULL,NULL,'2MASX J07360084+2739259',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000204,NULL,'16.6g',0.23,'AGN',NULL,NULL,NULL,NULL,1,114.003625,27.65725,0.197,NULL,63427422586,991053477,15485210,16.6),(49185,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49185,37.72,0.46,351,12603,70,NULL,NULL,'2MASX J07360192+3744163',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000089,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,114.007875,37.73789,0.233,NULL,63468214377,991690849,15495169,17.3),(49186,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49186,37.33,0.46,293,12604,70,NULL,NULL,'2MASX J07360195+3006158',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,114.008125,30.10444,0.249,NULL,63428720964,991073765,15485527,17.9),(49187,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49187,34.9,0.54,95.6,12605,70,NULL,NULL,'2MASX J07360278-7650076',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,114.0115417,-76.8355,0.893,NULL,39913171961,623643311,9744426,16.3),(49188,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49188,37.29,0.46,287,12606,70,NULL,NULL,'2MASX J07360440+2933549',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,114.01825,29.56519,0.245,NULL,63429490296,991085785,15485715,17.2),(49189,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49189,36.42,0.46,192,12607,70,NULL,NULL,'2MASX J07360774+2714369',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,114.032333333,27.24344,0.177,NULL,63431545252,991117894,15486217,17.2),(49190,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49190,37.75,0.46,355,12608,70,NULL,NULL,'2MASX J07360856+2347358',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,114.035583,23.79333,0.165,NULL,63084253175,985691455,15401428,17.2),(49191,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49191,37.43,0.46,307,12609,70,NULL,NULL,'2MASX J07360975+1819428',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,114.040708333,18.32844,0.081,NULL,63137424897,986522264,15414410,17.1),(49192,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49192,37.04,0.46,256,12610,70,NULL,NULL,'2MASX J07361027+4530383',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000083,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,114.042875,45.51078,0.313,NULL,63579779274,993434051,15522407,17.3),(49193,'TRGB','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49193,29.49,0.05,7.89,12611,NULL,NULL,'I','GALEXASC J073610.24+095910.4',NULL,'2014ApJ...785....3M',2014,1,NULL,NULL,'G',0.000035,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,114.042917,9.98639,0.209,NULL,63235877178,988060580,15438446,NULL),(49194,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49194,37.58,0.46,328,12612,70,NULL,NULL,'2MASX J07361447+4720223',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000183,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,114.0602083,47.33967,0.353,NULL,63578681861,993416904,15522139,16.9),(49195,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49195,38.31,0.46,459,12613,70,NULL,NULL,'SDSS J073614.56+371240.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000073,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,114.060667,37.21142,0.241,NULL,63468458027,991694656,15495229,18.6),(49196,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49196,37.23,0.46,279,12614,70,NULL,NULL,'2MASX J07361523+4223483',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,114.063458333,42.39681,0.237,NULL,63615847670,993997619,15531212,17.3),(49197,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49197,37.41,0.46,303,12615,70,NULL,NULL,'2MASX J07361891+2316157',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,114.078833,23.27117,0.181,NULL,63083781289,985684082,15401313,17.3),(49198,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49198,38.63,0.46,533,12616,70,NULL,NULL,'SDSS J073618.91+380506.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000077,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,114.078833,38.08508,0.221,NULL,63606627508,993853554,15528961,18.8),(49199,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49199,38.77,0.33,568,12617,70,NULL,NULL,'SDSS J073619.46+392935.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000076,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,114.081083333,39.49317,0.321,NULL,63606971574,993858930,15529045,18.6),(49200,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49200,37.01,0.46,252,12618,70,NULL,NULL,'2MASX J07361993+4024423',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000189,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,114.083166667,40.41169,0.257,NULL,63610414341,993912724,15529886,16.5),(49201,'SNIa','2016-12-15 15:14:16','2016-12-16 11:19:22','1','SN 2015F',NULL,49201,31.89,0.04,23.9,12619,NULL,NULL,'MLCS2k2; SNANA','NGC 2442',NULL,'2015ApJS..221...22I',2015,1,5.5,'Confused HIPASS source','G',0.000018,NULL,'11.24',4.9,'SAB(s)bc pec','Group member, radial-velocity confirmed',NULL,NULL,'LINER',1,114.099333,-69.53083,0.697,NULL,40665675752,635401183,9928143,11.24),(49202,'Tully est','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49202,31.16,0.8,17.1,12619,75,NULL,'B','NGC 2442',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49203,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49203,35.56,0.46,129,12620,70,NULL,NULL,'2MASX J07362481+4626272',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000161,NULL,'16.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,114.103583,46.44094,0.337,NULL,63580473186,993444893,15522576,16.6),(49204,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49204,37.27,0.46,285,12621,70,NULL,NULL,'2MASX J07362671+2838401',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000142,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,114.111291667,28.64453,0.193,NULL,63427810814,991059543,15485305,17.7),(49205,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49205,38.12,0.46,422,12622,70,NULL,NULL,'2MASX J07362695+4758085',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,114.112083,47.96908,0.349,NULL,63579248273,993425754,15522277,18.6),(49206,'IRAS','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49206,30.44,0.8,12.2,12623,75,NULL,'A82, H','NGC 2427',NULL,'1997ApJS..109..333W',1997,1,5.2,NULL,'G',0.00001,NULL,'12.33',2.2,'SAB(s)c pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,114.117417,-47.63556,0.733,NULL,42654676226,666479316,10413739,12.33),(49207,'IRAS','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49207,30.44,0.8,12.3,12623,75,NULL,'MAT, I','NGC 2427',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49208,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49208,29.89,0.4,9.5,12623,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 2427',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49209,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49209,29.94,0.43,9.7,12623,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2427',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49210,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49210,30.06,0.43,10.3,12623,75,NULL,'3.6 micron, color corrected','NGC 2427',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49211,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49211,30.1,0.2,10.5,12623,74.4,NULL,NULL,'NGC 2427',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49212,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49212,30.13,0.35,10.6,12623,NULL,NULL,NULL,'NGC 2427',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49213,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49213,30.13,0.39,10.6,12623,73,NULL,'opt','NGC 2427',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49214,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49214,30.19,0.4,10.9,12623,75,NULL,'B','NGC 2427',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49215,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49215,30.19,0.32,10.9,12623,85,NULL,'I, raw','NGC 2427',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49216,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49216,30.21,0.32,11,12623,85,NULL,'I, inv','NGC 2427',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49217,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49217,30.23,0.47,11.1,12623,75,NULL,'A82, H, raw','NGC 2427',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49218,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49218,30.23,0.47,11.1,12623,75,NULL,'A82, H, inv','NGC 2427',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49219,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49219,30.46,0.43,12.3,12623,75,NULL,'MAT, I, raw','NGC 2427',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49220,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49220,30.54,0.47,12.8,12623,75,NULL,'A82, H, cor','NGC 2427',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49221,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49221,30.56,0.43,13,12623,75,NULL,'MAT, I, inv','NGC 2427',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49222,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49222,30.71,0.43,13.8,12623,75,NULL,'MAT, I, cor','NGC 2427',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49223,'FP','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,'R',49223,37.27,0.46,284,12624,70,NULL,NULL,'2MASX J07363576+2900151',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000169,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,114.149167,29.00408,0.197,NULL,63429630725,991087980,15485749,17.4),(49224,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49224,34.38,0.45,75.1,12625,NULL,NULL,'K','NGC 2418',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000003,NULL,'13.16',1.8,'E',NULL,NULL,NULL,NULL,1,114.1562917,17.88392,0.109,NULL,63120365546,986255711,15410245,13.16),(49225,'Tully-Fisher','2016-12-15 15:14:16','2016-12-16 11:19:22','1',NULL,NULL,49225,34.45,0.4,77.8,12625,NULL,NULL,'mean','NGC 2418',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49226,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49226,37.09,0.46,262,12626,70,NULL,NULL,'2MASX J07363898+2749451',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000185,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,114.162375,27.82931,0.197,NULL,63427388678,991052948,15485202,16.8),(49227,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49227,38.11,0.46,419,12627,70,NULL,NULL,'SDSS J073640.31+262404.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,114.167958333,26.40122,0.197,NULL,62949367228,983583862,15368497,17.7),(49228,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49228,37.14,0.46,268,12628,70,NULL,NULL,'2MASX J07364345+3128350',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000162,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,114.181166667,31.47639,0.161,NULL,63474454454,991788350,15496692,16.6),(49229,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49229,38,0.46,398,12629,70,NULL,NULL,'2MASX J07364666+3932556',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000087,NULL,'18.1g',0.16,'BLAGN',NULL,NULL,NULL,'Sy 1',1,114.194417,39.54872,0.321,NULL,63607132333,993861442,15529085,18.1),(49230,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49230,34.98,NULL,99,12630,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03922',NULL,'2010Ap&SS.325..163P',2010,1,1.94,NULL,'G',0.000023,NULL,'16.0',0.22,'Sc',NULL,NULL,NULL,NULL,1,114.196083333,55.041,0.161,NULL,61586765459,962293210,15035831,16),(49231,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49231,34.99,NULL,99.4,12630,NULL,NULL,NULL,'UGC 03922',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49232,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49232,34.99,NULL,99.4,12630,NULL,NULL,'Dipole + Quadrupole','UGC 03922',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49233,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49233,34.99,NULL,99.5,12630,NULL,NULL,'Dipole','UGC 03922',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49234,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49234,35.38,0.49,119,12630,75,NULL,'IR','UGC 03922',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49235,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49235,35.66,0.43,136,12630,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03922',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49236,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49236,35.72,0.43,139,12630,75,NULL,'3.6 micron, color corrected','UGC 03922',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49237,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49237,35.85,0.36,148,12630,NULL,NULL,'Malmquist cor.','UGC 03922',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49238,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49238,35.95,0.2,155,12630,74.4,NULL,NULL,'UGC 03922',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49239,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49239,36.05,0.33,162,12630,NULL,NULL,NULL,'UGC 03922',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49240,'Brightest Stars','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49240,27.6,NULL,3.31,12631,NULL,NULL,'Photographic','NGC 2403',NULL,'1980ApJ...241..598H',1980,1,21.9,NULL,'G',0.000001,NULL,'8.11B',12.3,'SAB(s)cd;HII   LINER','Isolated galaxy',NULL,NULL,NULL,1,114.214167,65.60256,0.157,NULL,62176165936,971502592,15179728,8.11),(49241,'Cepheids','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49241,27.24,0.25,2.81,12631,NULL,NULL,NULL,'NGC 2403',NULL,'1985cdld.book.....R',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49242,'Cepheids','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49242,27.3,0.12,2.88,12631,NULL,NULL,'BV','NGC 2403',NULL,'1991MNRAS.250..438M',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49243,'Cepheids','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49243,27.3,0.13,2.88,12631,NULL,18.47,'17, B, Photographic','NGC 2403',NULL,'1987SAAOC..11..125W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49244,'Cepheids','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49244,27.43,0.15,3.06,12631,NULL,18.54,'LMC ZP','NGC 2403',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49245,'Cepheids','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49245,27.48,0.24,3.13,12631,NULL,NULL,'10, VI, KEY PROJECT','NGC 2403',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49246,'Cepheids','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49246,27.5,NULL,3.16,12631,NULL,NULL,NULL,'NGC 2403',NULL,'1986AJ.....91..808H',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49247,'Cepheids','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49247,27.5,NULL,3.16,12631,NULL,NULL,'HST KP Calibrated, max. D','NGC 2403',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49248,'Cepheids','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49248,27.51,0.24,3.18,12631,NULL,NULL,'8, I','NGC 2403',NULL,'1991PASP..103..933M',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49249,'Cepheids','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49249,27.51,0.06,3.18,12631,74.4,NULL,NULL,'NGC 2403',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49250,'Cepheids','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49250,27.54,0.24,3.22,12631,NULL,NULL,'10, VI, +Z, KEY PROJECT','NGC 2403',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49251,'Cepheids','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49251,27.59,0.25,3.3,12631,NULL,NULL,NULL,'NGC 2403',NULL,'1988ApJ...332L..63F',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49252,'Cepheids','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49252,27.9,NULL,3.8,12631,NULL,18.47,'5, J, Photographic','NGC 2403',NULL,'1987SAAOC..11..125W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49253,'Cepheids','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49253,28.15,0.2,4.27,12631,NULL,NULL,'5, J','NGC 2403',NULL,'1984ApJ...282..101M',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49254,'CMD','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49254,27.51,NULL,3.18,12631,NULL,NULL,NULL,'NGC 2403',NULL,'2012ApJ...748...47M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49255,'PNLF','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49255,27.57,0.19,3.26,12631,NULL,NULL,'40','NGC 2403',NULL,'1999AAS...195.1103K',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49256,'PNLF','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49256,27.65,0.17,3.39,12631,NULL,NULL,NULL,'NGC 2403',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49257,'RSV Stars','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49257,27.67,0.16,3.42,12631,NULL,NULL,'RSV','NGC 2403',NULL,'1998PhDT.........5J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49258,'S Doradus Stars','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49258,27.7,NULL,3.47,12631,NULL,NULL,NULL,'NGC 2403',NULL,'1989A&A...217...87W',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49259,'TRGB','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49259,27.43,NULL,3.06,12631,NULL,18.54,NULL,'NGC 2403',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49260,'TRGB','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49260,27.45,0.04,3.09,12631,NULL,NULL,'I','NGC 2403',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49261,'TRGB','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49261,27.5,0.05,3.16,12631,NULL,NULL,'I','NGC 2403',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49262,'TRGB','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49262,27.51,0.24,3.18,12631,NULL,NULL,'I','NGC 2403',NULL,'2003AJ....125.3046D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49263,'TRGB','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49263,27.51,0.06,3.18,12631,74.4,NULL,NULL,'NGC 2403',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49264,'TRGB','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49264,27.52,0.02,3.19,12631,NULL,NULL,'I','NGC 2403',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49265,'TRGB','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49265,27.52,0.08,3.2,12631,NULL,NULL,'I','NGC 2403',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49266,'TRGB','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49266,27.51,0.07,3.2,12631,NULL,NULL,'I','NGC 2403',NULL,'2011ApJS..195...18R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49267,'HII region diameter','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49267,26.53,NULL,2.02,12631,NULL,NULL,'Photographic','NGC 2403',NULL,'1981AN....302..251I',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49268,'HII region diameter','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49268,27.24,0.15,2.81,12631,NULL,NULL,'Method 1','NGC 2403',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49269,'HII region diameter','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49269,27.25,0.13,2.82,12631,NULL,NULL,'Method 2','NGC 2403',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49270,'SNII optical','2016-12-15 15:14:17','2016-12-16 11:19:22','1','SN 2004dj',NULL,49270,27.68,0.11,3.44,12631,NULL,NULL,'V, photospheric magnitude method','NGC 2403',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49271,'SNII optical','2016-12-15 15:14:17','2016-12-16 11:19:22','1','SN 2004dj',NULL,49271,27.72,NULL,3.5,12631,NULL,NULL,'SCM','NGC 2403',NULL,'2006MNRAS.369.1780V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49272,'SNII optical','2016-12-15 15:14:17','2016-12-16 11:19:22','1','SN 2004dj',NULL,49272,27.76,0.16,3.56,12631,NULL,NULL,'SCM, Poznanski et al. 2009','NGC 2403',NULL,'2015A&A...580L..15P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49273,'SNII optical','2016-12-15 15:14:17','2016-12-16 11:19:22','1','SN 2004dj',NULL,49273,27.78,0.16,3.6,12631,NULL,NULL,'SCM, Hamuy 2003','NGC 2403',NULL,'2015A&A...580L..15P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49274,'SNII optical','2016-12-15 15:14:17','2016-12-16 11:19:22','1','SN 2004dj',NULL,49274,27.78,0.33,3.6,12631,NULL,NULL,'EPM','NGC 2403',NULL,'2012MNRAS.419.2783T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49275,'SNII optical','2016-12-15 15:14:17','2016-12-16 11:19:22','1','SN 2004dj',NULL,49275,27.79,0.05,3.61,12631,NULL,NULL,'I, photospheric magnitude method','NGC 2403',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49276,'SNII optical','2016-12-15 15:14:17','2016-12-16 11:19:22','1','SN 2004dj',NULL,49276,27.82,NULL,3.66,12631,NULL,NULL,'EPM','NGC 2403',NULL,'2006MNRAS.369.1780V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49277,'SNII optical','2016-12-15 15:14:17','2016-12-16 11:19:22','1','SN 2004dj',NULL,49277,27.84,0.43,3.7,12631,NULL,NULL,'EPM, expansion velocity modeled','NGC 2403',NULL,'2012MNRAS.419.2783T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49278,'SNII optical','2016-12-15 15:14:17','2016-12-16 11:19:22','1','SN 2004dj',NULL,49278,27.87,0.16,3.75,12631,NULL,NULL,'SCM, Nugent et al. 2006','NGC 2403',NULL,'2015A&A...580L..15P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49279,'SNII optical','2016-12-15 15:14:17','2016-12-16 11:19:22','1','SN 2004dj',NULL,49279,27.9,0.14,3.8,12631,NULL,NULL,'SCM','NGC 2403',NULL,'2015ApJ...799..215P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49280,'SNII optical','2016-12-15 15:14:17','2016-12-16 11:19:22','1','SN 2004dj',NULL,49280,27.97,0.16,3.93,12631,NULL,NULL,'SCM, D\'Andrea et al. 2010','NGC 2403',NULL,'2015A&A...580L..15P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49281,'SNII optical','2016-12-15 15:14:17','2016-12-16 11:19:22','1','SN 2004dj',NULL,49281,28.06,0.43,4.09,12631,NULL,NULL,'SCM, B','NGC 2403',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49282,'SNII optical','2016-12-15 15:14:17','2016-12-16 11:19:22','1','SN 2004dj',NULL,49282,28.14,0.29,4.25,12631,NULL,NULL,'SCM, BVI','NGC 2403',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49283,'SNII optical','2016-12-15 15:14:17','2016-12-16 11:19:22','1','SN 2004dj',NULL,49283,28.19,0.54,4.35,12631,NULL,NULL,'SCM, I','NGC 2403',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49284,'SNII optical','2016-12-15 15:14:17','2016-12-16 11:19:22','1','SN 2004dj',NULL,49284,28.22,0.55,4.41,12631,NULL,NULL,'SCM, V','NGC 2403',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49285,'IRAS','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49285,29.04,0.8,6.43,12631,75,NULL,'A82, H','NGC 2403',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49286,'Magnitude','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49286,27.06,0.11,2.58,12631,NULL,NULL,NULL,'NGC 2403',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49287,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49287,27.54,NULL,3.22,12631,NULL,NULL,'IR','NGC 2403',NULL,'1980ApJ...237..655A',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49288,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49288,27.59,NULL,3.3,12631,NULL,NULL,'B','NGC 2403',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49289,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49289,27.69,0.15,3.45,12631,NULL,NULL,'I','NGC 2403',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49290,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49290,27.72,0.35,3.5,12631,NULL,NULL,NULL,'NGC 2403',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49291,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49291,27.74,0.47,3.53,12631,75,NULL,'A82, H, raw','NGC 2403',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49292,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49292,27.75,0.21,3.55,12631,NULL,NULL,'B','NGC 2403',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49293,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49293,27.75,NULL,3.55,12631,NULL,NULL,'LEDA [April 2006]','NGC 2403',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49294,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49294,27.76,0.47,3.56,12631,75,NULL,'A82, H, inv','NGC 2403',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49295,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49295,27.93,NULL,3.85,12631,NULL,NULL,'I','NGC 2403',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49296,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49296,28.1,0.47,4.16,12631,75,NULL,'A82, H, cor','NGC 2403',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49297,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49297,28.14,0.4,4.2,12631,75,NULL,'B','NGC 2403',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49298,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49298,31.77,0.2,22.6,12632,74.4,NULL,NULL,'UGC 03909',NULL,'2013AJ....146...86T',2013,1,2.6,'MCG misprints R.A. as 07h32.1m and dec as +73d53m. See CGCG 0732.0+7351.','G',0.000037,NULL,'14.81',0.5,'SBcd:',NULL,NULL,NULL,NULL,1,114.240708333,73.71353,0.093,NULL,61298316025,957786187,14965409,14.81),(49299,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49299,31.85,0.4,23.4,12632,NULL,NULL,NULL,'UGC 03909',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49300,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49300,31.93,0.48,24.3,12632,NULL,NULL,NULL,'UGC 03909',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49301,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49301,31.98,0.47,24.9,12632,NULL,NULL,'Malmquist cor.','UGC 03909',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49302,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49302,34.29,0.4,72,12633,NULL,NULL,'mean','UGC 03936',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000033,NULL,'13.8',1,'SBbc',NULL,NULL,NULL,NULL,1,114.261917,13.60106,0.309,NULL,63119770137,986246408,15410100,13.8),(49303,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49303,34.5,0.47,79.3,12633,NULL,NULL,'H','UGC 03936',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49304,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49304,34.54,0.45,80.7,12633,NULL,NULL,'K','UGC 03936',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49305,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49305,34.54,0.46,80.9,12633,NULL,NULL,'J','UGC 03936',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49306,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49306,34.13,0.4,67,12634,NULL,NULL,'mean','UGC 03932',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000033,NULL,'15.03',0.3,'Sab',NULL,NULL,NULL,NULL,1,114.26325,22.35267,0.153,NULL,63098311717,985911120,15404861,15.03),(49307,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49307,34.22,0.26,69.7,12634,NULL,NULL,'Malmquist cor.','UGC 03932',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49308,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49308,34.24,0.26,70.3,12634,NULL,NULL,NULL,'UGC 03932',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49309,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49309,34.28,0.2,71.8,12634,74.4,NULL,NULL,'UGC 03932',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49310,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49310,34.38,0.49,75.2,12634,75,NULL,'IR','UGC 03932',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49311,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49311,34.56,0.47,81.6,12634,NULL,NULL,'H','UGC 03932',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49312,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49312,33.1,0.43,41.7,12635,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03919',NULL,'2014MNRAS.444..527S',2014,1,1.72,NULL,'G',NULL,NULL,'16.5',0.11,'Scd',NULL,NULL,NULL,NULL,1,114.269917,64.55283,0.181,NULL,62162492264,971288941,15176389,16.5),(49313,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49313,33.86,0.43,59.2,12635,75,NULL,'3.6 micron, color corrected','UGC 03919',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49314,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49314,34.22,0.49,70,12635,75,NULL,'IR','UGC 03919',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49315,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49315,34.37,NULL,74.9,12635,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03919',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49316,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49316,34.38,NULL,75.3,12635,NULL,NULL,'Dipole + Quadrupole','UGC 03919',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49317,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49317,34.39,NULL,75.4,12635,NULL,NULL,'Dipole','UGC 03919',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49318,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49318,34.49,NULL,79.2,12635,NULL,NULL,NULL,'UGC 03919',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49319,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49319,34.5,0.2,79.4,12635,74.4,NULL,NULL,'UGC 03919',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49320,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49320,34.52,0.61,80.3,12635,NULL,NULL,'Malmquist cor.','UGC 03919',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49321,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49321,34.56,0.6,81.8,12635,NULL,NULL,NULL,'UGC 03919',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49322,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49322,37.08,0.46,261,12636,70,NULL,NULL,'2MASX J07370917+4807177',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,114.2882917,48.12161,0.265,NULL,63579306082,993426657,15522291,17.8),(49323,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49323,38.59,0.46,522,12637,70,NULL,NULL,'2MASX J07371182+4621306',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000162,NULL,'18.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,114.299375,46.35856,0.317,NULL,63580808653,993450135,15522658,18.8),(49324,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49324,38.22,0.46,440,12638,70,NULL,NULL,'2MASX J07371782+4236346',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000141,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,114.3242083,42.60981,0.177,NULL,63615943081,993999110,15531236,17.9),(49325,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49325,37.64,0.46,337,12639,70,NULL,NULL,'2MASX J07371888+2945261',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00013,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,114.3285,29.75736,0.177,NULL,63429057118,991079017,15485609,18.7),(49326,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49326,38.12,0.46,421,12640,70,NULL,NULL,'2MASX J07371928+2634231',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,114.330375,26.57294,0.169,NULL,63420073296,990938645,15483416,18.4),(49327,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49327,33.9,0.2,60.3,12641,74.4,NULL,NULL,'UGC 03941',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000033,NULL,'14.9',0.4,'SBcd:',NULL,NULL,NULL,NULL,1,114.345833,14.0775,0.221,NULL,63117613790,986212715,15409573,14.9),(49328,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49328,34.07,0.37,65.2,12641,NULL,NULL,NULL,'UGC 03941',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49329,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49329,34.23,0.34,70.2,12641,NULL,NULL,'Malmquist cor.','UGC 03941',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49330,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49330,37.08,0.46,260,12642,70,NULL,NULL,'2MASX J07372389+3807406',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000056,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,114.3495417,38.12789,0.273,NULL,63560547334,993133552,15517711,18),(49331,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49331,36.71,0.46,220,12643,70,NULL,NULL,'2MASX J07372551+2025559',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,114.356375,20.43217,0.177,NULL,63093937274,985842769,15403793,NULL),(49332,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49332,30.98,NULL,15.7,12644,NULL,NULL,NULL,'LV J0737+4724',NULL,'2013AJ....145..101K',2013,1,0.35,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,114.368708333,47.40914,0.293,NULL,63578651808,993416434,15522131,18),(49333,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49333,38.4,0.46,479,12645,70,NULL,NULL,'2MASX J07373205+4245547',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,114.3835,42.76528,0.177,NULL,63615448667,993991385,15531115,17.6),(49334,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49334,37.92,0.46,384,12646,70,NULL,NULL,'SDSS J073732.27+280118.6',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.6g',0.34,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,114.3845,28.02183,0.205,NULL,63432098929,991126545,15486352,16.6),(49335,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49335,37.07,0.46,259,12647,70,NULL,NULL,'2MASX J07373409+4349177',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000149,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,114.392333,43.82161,0.209,NULL,63614010963,993968921,15530764,17.4),(49336,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49336,33.14,0.43,42.5,12648,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03937',NULL,'2014MNRAS.444..527S',2014,1,2,'The 2MASS position is 7 arcsec south of the center of the short bar.','G',0.000017,NULL,'14.12',0.5,'SB?','in a pair',NULL,NULL,NULL,1,114.396791667,35.60575,0.201,NULL,63472382648,991755978,15496187,14.12),(49337,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49337,33.25,0.43,44.6,12648,75,NULL,'3.6 micron, color corrected','UGC 03937',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49338,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49338,33.31,0.47,46,12648,NULL,NULL,'H','UGC 03937',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49339,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49339,33.4,0.2,47.9,12648,74.4,NULL,NULL,'UGC 03937',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49340,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49340,33.43,0.46,48.4,12648,NULL,NULL,'J','UGC 03937',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49341,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49341,33.43,0.45,48.5,12648,NULL,NULL,'K','UGC 03937',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49342,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49342,33.86,0.4,59.1,12648,NULL,NULL,'mean','UGC 03937',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49343,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49343,34.05,0.46,64.5,12649,70,NULL,NULL,'ESO 088- G 026',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'14.44',0.2,'Sa',NULL,NULL,NULL,NULL,1,114.401083,-66.11964,0.561,NULL,40650536099,635164626,9924447,14.44),(49344,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49344,35.18,0.64,109,12650,70,NULL,NULL,'ESO 059- G 010',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.20',0.5,'SA(rs)cd',NULL,NULL,NULL,NULL,1,114.402791667,-69.75367,0.665,NULL,40665848306,635403879,9928185,15.2),(49345,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49345,37.37,0.46,298,12651,70,NULL,NULL,'2MASX J07373697+2936052',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,114.403875,29.60153,0.149,NULL,63429087386,991079490,15485617,17.5),(49346,'IRAS','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49346,33.15,0.8,42.6,12652,75,NULL,'MAT, I','ESO 208- G 031',NULL,'1997ApJS..109..333W',1997,1,1.79,NULL,'G',0.000023,NULL,'15.42',0.2,'Scd',NULL,NULL,NULL,NULL,1,114.4040417,-52.30525,0.845,NULL,42515323216,664301925,10379717,15.42),(49347,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49347,33.37,0.73,47.3,12652,NULL,NULL,'Malmquist cor.','ESO 208- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49348,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49348,33.62,0.65,52.9,12652,NULL,NULL,NULL,'ESO 208- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49349,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49349,33.66,0.2,54,12652,74.4,NULL,NULL,'ESO 208- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49350,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49350,33.67,0.43,54.1,12652,75,NULL,'MAT, I, raw','ESO 208- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49351,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49351,33.78,0.32,57.1,12652,85,NULL,'I, raw','ESO 208- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49352,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49352,33.82,0.32,58.1,12652,85,NULL,'I, inv','ESO 208- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49353,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49353,33.85,0.49,59,12652,75,NULL,'IR','ESO 208- G 031',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49354,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49354,33.85,0.43,59,12652,75,NULL,'MAT, I, inv','ESO 208- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49355,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49355,33.87,0.43,59.6,12652,75,NULL,'MAT, I, cor','ESO 208- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49356,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49356,34.45,NULL,77.6,12652,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 208- G 031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49357,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49357,34.47,NULL,78.4,12652,NULL,NULL,'Dipole + Quadrupole','ESO 208- G 031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49358,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49358,34.48,NULL,78.6,12652,NULL,NULL,NULL,'ESO 208- G 031',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49359,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49359,34.49,NULL,78.9,12652,NULL,NULL,'Dipole','ESO 208- G 031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49360,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49360,34.57,0.45,82.2,12653,NULL,NULL,'Malmquist cor.','UGC 03933',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.00002,NULL,'14.6g',0.77,'SAB(s)bc',NULL,NULL,NULL,NULL,1,114.404667,41.94706,0.181,NULL,63615871066,993997985,15531218,14.6),(49361,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49361,34.64,0.44,84.9,12653,NULL,NULL,NULL,'UGC 03933',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49362,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49362,34.67,0.2,85.9,12653,74.4,NULL,NULL,'UGC 03933',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49363,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49363,34.84,0.4,92.8,12653,NULL,NULL,'mean','UGC 03933',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49364,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49364,35.09,0.47,104,12653,NULL,NULL,'H','UGC 03933',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49365,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49365,37.83,0.15,369,12654,70,NULL,NULL,'2MASX J07374082+2357072',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,114.42025,23.95208,0.165,NULL,63084019893,985687810,15401372,18),(49366,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49366,37.83,0.15,369,12655,70,NULL,NULL,'2MASX J07374092+2416152',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00018,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,114.420625,24.27092,0.169,NULL,62950699365,983604677,15368823,17.2),(49367,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49367,35.17,NULL,108,12656,NULL,NULL,NULL,'MCG +10-11-101',NULL,'2000BSAO...50....5K',2000,1,1.21,NULL,'G',NULL,NULL,'17',0.12,'Sdm',NULL,NULL,NULL,NULL,1,114.4214583,59.84653,0.225,NULL,61682635335,963791177,15059237,17),(49368,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49368,38.33,0.46,464,12657,70,NULL,NULL,'2MASX J07374125+3759598',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000085,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,114.421791667,38.00008,0.277,NULL,63560511328,993132989,15517702,17.8),(49369,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49369,37.4,0.46,302,12658,70,NULL,NULL,'2MASX J07374385+3931209',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000089,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,114.432667,39.52258,0.253,NULL,63607101254,993860957,15529077,16.8),(49370,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49370,37.83,0.15,369,12659,70,NULL,NULL,'2MASX J07374489+2347498',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,114.437125,23.79706,0.165,NULL,63084105164,985689143,15401392,17.9),(49371,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49371,35.45,0.49,123,12660,75,NULL,'IR','UGC 03942',NULL,'2011yCatp016004901K',2011,1,1.31,NULL,'G',0.000049,NULL,'15.2g',0.28,'Sb',NULL,NULL,NULL,NULL,1,114.4462083,27.03647,0.177,NULL,63420189778,990940465,15483444,15.2),(49372,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49372,35.46,0.4,123,12660,NULL,NULL,'mean','UGC 03942',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49373,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49373,35.72,0.47,139,12660,NULL,NULL,'H','UGC 03942',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49374,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49374,37.51,0.46,318,12661,70,NULL,NULL,'2MASX J07374811+2710492',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000181,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,114.4505,27.18042,0.185,NULL,63431740928,991120952,15486264,16.5),(49375,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49375,37.28,0.33,286,12662,70,NULL,NULL,'2MASX J07374841+4822081',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000172,NULL,'16.8g',0.35,NULL,NULL,NULL,NULL,NULL,1,114.451583,48.36897,0.265,NULL,63578486137,993413845,15522091,16.8),(49376,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49376,35.3,0.43,115,12663,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0645',NULL,'2014MNRAS.444..527S',2014,1,1.12,NULL,'G',0.000009,NULL,'16.3',0.15,'Scd(f)',NULL,NULL,NULL,NULL,1,114.453333,32.21322,0.137,NULL,63481556115,991899314,15498426,16.3),(49377,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49377,35.54,NULL,128,12663,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0645',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49378,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49378,35.54,NULL,128,12663,NULL,NULL,'Dipole + Quadrupole','FGC 0645',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49379,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49379,35.54,NULL,128,12663,NULL,NULL,'Dipole','FGC 0645',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49380,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49380,35.55,0.43,129,12663,75,NULL,'3.6 micron, color corrected','FGC 0645',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49381,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49381,35.65,NULL,135,12663,NULL,NULL,NULL,'FGC 0645',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49382,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49382,35.81,0.49,145,12663,75,NULL,'IR','FGC 0645',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49383,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49383,35.85,0.2,148,12663,74.4,NULL,NULL,'FGC 0645',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49384,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49384,37.34,0.46,293,12664,70,NULL,NULL,'2MASX J07375002+2847192',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000137,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,114.4582917,28.78864,0.193,NULL,63427630199,991056721,15485261,18.3),(49385,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49385,37.83,0.15,369,12665,70,NULL,NULL,'2MASX J07375356+2353338',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,114.473083,23.89269,0.165,NULL,63084113352,985689271,15401394,16.7),(49386,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49386,37.98,0.46,394,12666,70,NULL,NULL,'2MASX J07375762+4240192',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,114.489875,42.67197,0.177,NULL,63615952474,993999257,15531238,17.4),(49387,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49387,37.83,0.15,369,12667,70,NULL,NULL,'2MASX J07375926+2357548',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'15.9g',0.45,NULL,NULL,NULL,NULL,NULL,1,114.497,23.96533,0.165,NULL,63084142196,985689721,15401401,15.9),(49388,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49388,30.52,NULL,12.7,12668,NULL,NULL,NULL,'UGC 03946',NULL,'2015AstBu..70....1K',2015,1,1.3,NULL,'G',0.000013,NULL,'13.6',0.8,'Im',NULL,NULL,NULL,NULL,1,114.49875,3.31611,0.413,NULL,62690724779,979542574,15305352,13.6),(49389,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49389,31.09,0.4,16.5,12668,75,NULL,'B','UGC 03946',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49390,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49390,37.28,0.33,286,12669,70,NULL,NULL,'SDSS J073759.92+481938.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,114.499666667,48.32728,0.265,NULL,63578487745,993413871,15522091,17.9),(49391,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49391,37.83,0.15,369,12670,70,NULL,NULL,'2MASX J07380024+2358522',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000203,NULL,'16.0g',0.42,'BrClG',NULL,NULL,NULL,NULL,1,114.501083333,23.98119,0.165,NULL,63084139872,985689685,15401401,16),(49392,'Sosies','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49392,34.46,0.46,78,12671,NULL,NULL,NULL,'IRAS  07357-1651',NULL,'2002A&A...393...57T',2002,1,0.45,NULL,'G',0.000023,NULL,'16.1',0.11,'S',NULL,NULL,NULL,NULL,1,114.50175,-16.97917,NULL,NULL,39489015604,617015868,9640872,16.1),(49393,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49393,33.57,0.4,51.7,12671,NULL,NULL,'mean','IRAS  07357-1651',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49394,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49394,34.39,0.47,75.4,12671,NULL,NULL,'H','IRAS  07357-1651',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49395,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49395,37.83,0.15,369,12672,70,NULL,NULL,'2MASX J07380440+2401232',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000176,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,114.518333,24.02314,0.165,NULL,63084149957,985689843,15401403,17.5),(49396,'IRAS','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49396,32.95,0.8,38.9,12673,75,NULL,'MAT, I','ESO 163- G 011',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.000033,NULL,'11.85',0.6,'SB(s)b? sp',NULL,NULL,NULL,NULL,1,114.522958333,-55.19078,0.469,NULL,40431280523,631738758,9870918,11.85),(49397,'Tully est','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49397,32.7,0.8,34.6,12673,75,NULL,NULL,'ESO 163- G 011',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49398,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49398,32.84,0.45,36.9,12673,NULL,NULL,'K','ESO 163- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49399,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49399,32.87,0.47,37.5,12673,NULL,NULL,'H','ESO 163- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49400,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49400,32.93,0.46,38.6,12673,NULL,NULL,'J','ESO 163- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49401,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49401,32.96,0.4,39,12673,NULL,NULL,'mean','ESO 163- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49402,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49402,32.96,0.49,39,12673,75,NULL,'IR','ESO 163- G 011',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49403,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49403,33.19,0.63,43.5,12673,NULL,NULL,'Malmquist cor.','ESO 163- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49404,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49404,33.23,0.32,44.3,12673,85,NULL,'I, raw','ESO 163- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49405,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49405,33.29,0.32,45.4,12673,85,NULL,'I, inv','ESO 163- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49406,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49406,33.47,0.43,49.4,12673,75,NULL,'MAT, I, raw','ESO 163- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49407,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49407,33.48,0.55,49.6,12673,NULL,NULL,NULL,'ESO 163- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49408,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49408,33.52,0.2,50.6,12673,74.4,NULL,NULL,'ESO 163- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49409,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49409,33.53,0.43,50.9,12673,75,NULL,'MAT, I, cor','ESO 163- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49410,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49410,33.71,0.43,55.2,12673,75,NULL,'MAT, I, inv','ESO 163- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49411,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49411,37.87,0.46,375,12674,70,NULL,NULL,'2MASX J07380631+2938382',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000139,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,114.526291667,29.64397,0.149,NULL,63429096353,991079630,15485619,18.2),(49412,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49412,37.45,0.46,309,12675,70,NULL,NULL,'2MASX J07380677+2316378',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,114.5282917,23.27708,0.145,NULL,63083730133,985683283,15401301,17),(49413,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49413,37.94,0.46,388,12676,70,NULL,NULL,'2MASX J07380736+1916418',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,114.5307917,19.27831,0.437,NULL,63091490743,985804542,15403195,17.6),(49414,'BL Lac Luminosity','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49414,40.91,0.27,1520,12677,70,NULL,'Pseudo redshift z = 0.45 +/- 0.06','[HB89] 0735+178',NULL,'2012A&A...547A...1N',2012,1,NULL,'Literature redshift of 0.424 is a lower limit based on absorption features.','QSO',NULL,'?','14.85',NULL,'blazar         BLLAC',NULL,NULL,'radio jet','Flat-Spectrum Radio Source',1,114.5307917,17.70528,0.121,NULL,63120426601,986256665,15410260,14.85),(49415,'CMD','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49415,19.8,NULL,0.0912,12678,NULL,NULL,NULL,'NGC 2419',NULL,'2011MNRAS.416.2903D',2011,1,NULL,NULL,'!*Cl',NULL,NULL,NULL,NULL,'GC',NULL,NULL,NULL,NULL,1,114.533125,38.87997,0.237,1,63561338475,993145913,15517904,NULL),(49416,'RR Lyrae','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49416,19.71,0.08,0.0875,12678,NULL,NULL,NULL,'NGC 2419',NULL,'2011AJ....141...81D',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49417,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49417,36.47,0.46,197,12679,70,NULL,NULL,'2MASX J07380821+3856009',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00006,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,114.534083333,38.93353,0.237,NULL,63561335297,993145864,15517904,17.4),(49418,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49418,37.41,0.46,304,12680,70,NULL,NULL,'2MASX J07381189+2055287',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,114.549416667,20.92453,0.133,NULL,63092088849,985813888,15403342,17),(49419,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49419,33.65,NULL,53.8,12681,NULL,NULL,NULL,'UGC 03921',NULL,'2000BSAO...50....5K',2000,1,1.23,NULL,'G',0.000047,NULL,'16.5',0.11,'Sd',NULL,NULL,NULL,NULL,1,114.54975,70.85211,0.057,NULL,62199885209,971873206,15185518,16.5),(49420,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49420,33.72,NULL,55.4,12681,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03921',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49421,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49421,33.73,NULL,55.8,12681,NULL,NULL,'Dipole + Quadrupole','UGC 03921',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49422,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49422,33.74,NULL,56.1,12681,NULL,NULL,'Dipole','UGC 03921',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49423,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49423,33.85,0.43,58.9,12681,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03921',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49424,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49424,38.05,0.46,408,12682,70,NULL,NULL,'2MASX J07381311+1927357',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,114.55475,19.46006,0.153,NULL,63091473680,985804276,15403191,17.2),(49425,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49425,38.1,0.33,417,12683,70,NULL,NULL,'2MASX J07381402+4619532',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000144,NULL,'18.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,114.5585417,46.33139,0.317,NULL,63580844150,993450689,15522667,18.9),(49426,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49426,36.95,0.46,245,12684,70,NULL,NULL,'2MASX J07381774+4403262',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,114.57375,44.05717,0.233,NULL,63614184730,993971636,15530806,17.3),(49427,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49427,38.1,0.33,417,12685,70,NULL,NULL,'2MASX J07381875+4619452',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,114.5782083,46.32908,0.317,NULL,63580842565,993450665,15522666,17.1),(49428,'Tully est','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49428,30.42,0.8,12.1,12686,75,NULL,NULL,'ESO 208- G 033',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.00002,NULL,'14.55',1.3,'SB(s)m',NULL,NULL,NULL,NULL,1,114.593333,-50.75681,0.649,NULL,42516325789,664317590,10379962,14.55),(49429,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49429,37.83,0.15,369,12687,70,NULL,NULL,'2MASX J07382370+2412551',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000175,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,114.598875,24.21528,0.137,NULL,62950518830,983601856,15368779,18.3),(49430,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49430,37.83,0.15,369,12688,70,NULL,NULL,'2MASX J07383203+2410306',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,114.633458333,24.17525,0.137,NULL,62950514198,983601784,15368777,17.9),(49431,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49431,36.27,0.46,179,12689,70,NULL,NULL,'CGCG 147-048',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000185,NULL,'15.5g',0.5,NULL,NULL,NULL,NULL,NULL,1,114.6355,29.18553,0.153,NULL,63428892505,991076445,15485569,15.5),(49432,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49432,37.72,0.46,350,12690,70,NULL,NULL,'2MASX J07383344+4027442',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000071,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,114.639375,40.46222,0.257,NULL,63608419284,993881551,15529399,18),(49433,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49433,38.27,0.46,450,12691,70,NULL,NULL,'2MASX J07383433+2335370',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,114.643125,23.59378,0.133,NULL,63084090697,985688917,15401389,18.1),(49434,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49434,37.81,0.46,364,12692,70,NULL,NULL,'2MASX J07383526+4513206',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000183,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,114.6470417,45.22233,0.273,NULL,63612434145,993944283,15530379,17.1),(49435,'IRAS','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49435,33.59,0.8,52.3,12693,75,NULL,'CF, r','UGC 03944',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000023,NULL,'14.3g',0.67,'Scd:','Isolated galaxy',NULL,NULL,NULL,1,114.652083,37.6335,0.253,NULL,63439083279,991235676,15488057,14.3),(49436,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49436,33.71,0.2,55.2,12693,74.4,NULL,NULL,'UGC 03944',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49437,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49437,33.84,0.38,58.7,12693,75,NULL,'CF, r, raw','UGC 03944',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49438,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49438,33.93,0.38,61.1,12693,75,NULL,'CF, r, inv','UGC 03944',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49439,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49439,33.95,0.37,61.6,12693,NULL,NULL,NULL,'UGC 03944',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49440,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49440,34.03,0.38,63.9,12693,75,NULL,'CF, r, cor','UGC 03944',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49441,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49441,34.04,0.35,64.2,12693,NULL,NULL,'Malmquist cor.','UGC 03944',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49442,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49442,37.1,0.46,263,12694,70,NULL,NULL,'2MASX J07384024+2344420',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000183,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,114.667583,23.74492,0.117,NULL,63084057120,985688392,15401381,16.7),(49443,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49443,32.65,0.4,33.8,12695,NULL,NULL,'mean','ESO 429- G?006',NULL,'2007A&A...465...71T',2007,1,0.9,'abs(b) < 10 degrees.','G',0.00002,NULL,'15.7',0.7,'S',NULL,NULL,NULL,NULL,1,114.672625,-31.19511,NULL,NULL,42608048564,665750758,10402355,15.7),(49444,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49444,32.68,0.47,34.3,12695,NULL,NULL,'H','ESO 429- G?006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49445,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49445,37.86,0.46,373,12696,70,NULL,NULL,'SDSS J073841.64+291625.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000133,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,114.6735,29.27386,0.149,NULL,63428945613,991077275,15485582,18.5),(49446,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,NULL,49446,34.85,0.53,93.2,12697,70,NULL,NULL,'2MASX J07384189-5418443',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,114.674666667,-54.31228,0.609,NULL,40432194428,631753037,9871141,15.9),(49447,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49447,37.89,0.46,379,12698,70,NULL,NULL,'2MASX J07384230+1948490',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,114.676291667,19.81367,0.193,NULL,63094221441,985847210,15403862,17.2),(49448,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49448,36.48,0.46,197,12699,70,NULL,NULL,'2MASX J07384643+4157456',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000183,NULL,'16.2g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,114.6935,41.96272,0.181,NULL,63615196315,993987442,15531053,16.2),(49449,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49449,37.83,0.46,367,12700,70,NULL,NULL,'2MASX J07384840+3258314',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,114.70175,32.97531,0.153,NULL,63484282468,991941913,15499092,17.6),(49450,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49450,36.87,0.46,237,12701,70,NULL,NULL,'2MASX J07384965+2236354',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,114.706958333,22.60969,0.153,NULL,63084956626,985702447,15401600,17.6),(49451,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49451,37.17,0.33,271,12702,70,NULL,NULL,'2MASX J07385224+3748533',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000085,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,114.71775,37.815,0.253,NULL,63439071335,991235489,15488054,16.7),(49452,'FP','2016-12-15 15:14:17','2016-12-16 11:19:22','1',NULL,'R',49452,37.34,0.46,294,12703,70,NULL,NULL,'2MASX J07385365+1600351',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,114.723417,16.00972,0.137,NULL,63123144861,986299138,15410924,17.4),(49453,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49453,36.55,0.46,204,12704,70,NULL,NULL,'2MASX J07385535+3244142',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,114.730583,32.73728,0.153,NULL,63484314862,991942419,15499100,17.2),(49454,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49454,37.99,0.46,397,12705,70,NULL,NULL,'2MASX J07385789+3748503',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000093,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,114.74125,37.81392,0.253,NULL,63439103603,991235993,15488062,17.5),(49455,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49455,37.3,0.46,288,12706,70,NULL,NULL,'2MASX J07385874+2829168',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000192,NULL,'16.7g',0.25,'AGN',NULL,NULL,NULL,NULL,1,114.7449583,28.48814,0.201,NULL,63432281450,991129397,15486396,16.7),(49456,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49456,37.38,0.46,300,12707,70,NULL,NULL,'2MASX J07390041+4609585',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,114.751583,46.16625,0.249,NULL,63580923812,993451934,15522686,18),(49457,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49457,32.43,0.46,30.6,12708,NULL,NULL,'J','ESO 560- G 004',NULL,'2007A&A...465...71T',2007,1,1.7,'abs(b) < 10 degrees.','G',0.000033,NULL,'9.3K',0.3,'S...',NULL,NULL,NULL,NULL,1,114.751875,-22.04631,NULL,NULL,39475417343,616803395,9637553,9.3),(49458,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49458,32.48,0.47,31.4,12708,NULL,NULL,'H','ESO 560- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49459,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49459,32.55,0.4,32.4,12708,NULL,NULL,'mean','ESO 560- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49460,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49460,32.59,0.45,33,12708,NULL,NULL,'K','ESO 560- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49461,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49461,32.79,0.49,36.2,12708,75,NULL,'IR','ESO 560- G 004',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49462,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49462,32.87,0.43,37.6,12708,75,NULL,'3.6 micron, color + selection bias corrected','ESO 560- G 004',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49463,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49463,33.16,0.4,42.8,12708,75,NULL,NULL,'ESO 560- G 004',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49464,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49464,36.03,0.46,161,12709,70,NULL,NULL,'CGCG 147-049',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.00014,NULL,'15.4g',0.5,'SB0',NULL,NULL,NULL,NULL,1,114.7560417,31.91472,0.157,NULL,63481385330,991896645,15498385,15.4),(49465,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49465,37.64,0.46,337,12710,70,NULL,NULL,'2MASX J07390286+2744078',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,114.762083,27.73561,0.205,NULL,63432503981,991132874,15486451,17.3),(49466,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49466,38.08,0.46,413,12711,70,NULL,NULL,'2MASX J07390633+2905218',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,114.776375,29.08928,0.153,NULL,63430737678,991105276,15486019,17.6),(49467,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49467,37.3,0.46,289,12712,70,NULL,NULL,'2MASX J07390653+4623107',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000149,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,114.7772917,46.3865,0.269,NULL,63580867627,993451056,15522672,17.6),(49468,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49468,37,0.46,251,12713,70,NULL,NULL,'2MASX J07390879+3916013',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,114.786625,39.26703,0.277,NULL,63561117673,993142463,15517850,NULL),(49469,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49469,34.22,0.49,69.9,12714,75,NULL,'IR','UGC 03952',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.00003,NULL,'15.64',0.2,'Sbc',NULL,NULL,NULL,NULL,1,114.791667,19.49731,0.153,NULL,63091437815,985803715,15403183,15.64),(49470,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49470,34.24,0.28,70.5,12714,NULL,NULL,NULL,'UGC 03952',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49471,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49471,34.28,0.2,71.8,12714,74.4,NULL,NULL,'UGC 03952',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49472,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49472,34.3,0.27,72.3,12714,NULL,NULL,'Malmquist cor.','UGC 03952',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49473,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49473,33.76,0.2,56.5,12715,74.4,NULL,NULL,'UGC 03943',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.000017,NULL,'14.70',0.7,'SB(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,114.7955417,59.16122,0.245,NULL,61562406780,961912605,15029884,14.7),(49474,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49474,33.88,0.44,59.6,12715,NULL,NULL,NULL,'UGC 03943',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49475,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49475,34.05,0.41,64.5,12715,NULL,NULL,'Malmquist cor.','UGC 03943',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49476,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49476,37.89,0.46,379,12716,70,NULL,NULL,'2MASX J07391234+4811140',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000172,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,114.8012917,48.18725,0.265,NULL,63579215192,993425237,15522269,17.8),(49477,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49477,38.4,0.46,480,12717,70,NULL,NULL,'SDSS J073912.38+422252.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000126,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,114.801583333,42.38131,0.177,NULL,63615104866,993986013,15531031,18.7),(49478,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49478,37.74,0.46,352,12718,70,NULL,NULL,'2MASX J07391540+4334198',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,114.814167,43.57206,0.217,NULL,63613662214,993963472,15530679,17.3),(49479,'SNII optical','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 1993A',NULL,49479,35.68,0.17,129,12719,NULL,NULL,'SEAM','2MASX J07391822-6203095',0.029237,'2009ApJ...694.1067P',2009,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,114.8259583,-62.05261,0.589,NULL,40467435082,632303673,9879744,16.5),(49480,'SNII optical','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 1993A',NULL,49480,35.62,0.08,133,12719,NULL,NULL,'I, photospheric magnitude method','2MASX J07391822-6203095',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49481,'SNII optical','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 1993A',NULL,49481,35.69,0.11,137,12719,NULL,NULL,'V, photospheric magnitude method','2MASX J07391822-6203095',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49482,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49482,37.91,0.33,381,12720,70,NULL,NULL,'2MASX J07391984+3946003',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000106,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,114.83275,39.76664,0.253,NULL,63561013571,993140837,15517825,16.9),(49483,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49483,37.98,0.46,395,12721,70,NULL,NULL,'2MASX J07392144+2448077',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,114.8395,24.80222,0.209,NULL,62951615766,983618996,15369046,18.1),(49484,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49484,37.36,0.46,296,12722,70,NULL,NULL,'2MASX J07392254+4507038',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',NULL,NULL,'16.81',0.39,NULL,NULL,NULL,NULL,NULL,1,114.844083,45.11772,0.273,NULL,63614502755,993976605,15530884,16.81),(49485,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49485,33.62,0.43,52.9,12723,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03955',NULL,'2014MNRAS.444..527S',2014,1,1.58,'Galaxy superposed on western end of disk.','G',0.000033,NULL,'15.1',0.16,'Sd',NULL,NULL,NULL,NULL,1,114.856625,8.89833,0.189,NULL,62728563930,980133811,15314590,15.1),(49486,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49486,34.35,0.49,74.3,12723,75,NULL,'IR','UGC 03955',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49487,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49487,34.42,NULL,76.7,12723,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03955',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49488,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49488,34.43,NULL,77.1,12723,NULL,NULL,'Dipole + Quadrupole','UGC 03955',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49489,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49489,34.44,NULL,77.1,12723,NULL,NULL,'Dipole','UGC 03955',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49490,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49490,34.51,NULL,79.9,12723,NULL,NULL,NULL,'UGC 03955',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49491,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49491,38.27,0.46,451,12724,70,NULL,NULL,'2MASX J07392761+4526028',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000144,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,114.8652083,45.43422,0.313,NULL,63612397538,993943711,15530370,18.2),(49492,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49492,37.64,0.46,338,12725,70,NULL,NULL,'2MASX J07392769+4747578',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000169,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,114.865333,47.79947,0.289,NULL,63578998944,993421858,15522216,17.9),(49493,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49493,37.74,0.46,352,12726,70,NULL,NULL,'2MASX J07392807+4617177',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,114.866917,46.28839,0.269,NULL,63580875208,993451175,15522674,17.4),(49494,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49494,37.17,0.33,271,12727,70,NULL,NULL,'2MASX J07392946+3749138',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000082,NULL,'16.3g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,114.872583,37.8205,0.253,NULL,63439020468,991234694,15488042,16.3),(49495,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49495,36.97,0.46,248,12728,70,NULL,NULL,'2MASX J07392996+1847048',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,114.8747917,18.78464,0.105,NULL,63090853371,985794583,15403040,16.9),(49496,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49496,37,0.46,251,12729,70,NULL,NULL,'2MASX J07393006+2908157',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000197,NULL,'16.1g',0.34,'E0',NULL,NULL,NULL,NULL,1,114.875375,29.13758,0.153,NULL,63430781686,991105963,15486030,16.1),(49497,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49497,37.57,0.46,326,12730,70,NULL,NULL,'2MASX J07393013+3813078',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000079,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,114.875375,38.21897,0.269,NULL,63560612846,993134575,15517727,17.1),(49498,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49498,37.94,0.27,388,12731,70,NULL,NULL,'2MASX J07393107+3049593',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,114.879291667,30.83331,0.145,NULL,63473483833,991773184,15496456,17.7),(49499,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49499,36.62,0.46,211,12732,70,NULL,NULL,'2MASX J07393331+2936347',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000178,NULL,'16.0g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,114.88875,29.60969,0.149,NULL,63430878240,991107472,15486054,16),(49500,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49500,35.32,0.78,116,12733,70,NULL,NULL,'2MASX J07393454-6953552',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,114.894167,-69.89878,0.653,NULL,40665703688,635401620,9928150,16.8),(49501,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49501,34.72,0.2,87.9,12734,74.4,NULL,NULL,'ARK 138',NULL,'2013AJ....146...86T',2013,1,0.79,NULL,'G',0.000111,NULL,'14.9g',0.57,'Sab','Group member',NULL,NULL,NULL,1,114.894458333,49.35622,0.229,NULL,63516544031,992446000,15506968,14.9),(49502,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49502,36.36,0.56,187,12735,70,NULL,NULL,'2MASX J07393559-6632352',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,114.898417,-66.54311,0.637,NULL,40647842190,635122534,9923789,16.9),(49503,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49503,37.91,0.33,381,12736,70,NULL,NULL,'2MASX J07394192+3943589',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000076,NULL,'17.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,114.9245417,39.73294,0.253,NULL,63561017352,993140896,15517826,17.2),(49504,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49504,37.61,0.46,333,12737,70,NULL,NULL,'SDSS J073942.47+491959.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,114.9269583,49.33314,0.229,NULL,63516542874,992445982,15506968,18.4),(49505,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49505,33.27,0.83,45.2,12738,NULL,NULL,NULL,'UGC 03949',NULL,'2009ApJS..182..474S',2009,1,1.02,NULL,'G',0.000033,NULL,'14.8g',0.9,'SB(s)d',NULL,NULL,NULL,NULL,1,114.938625,48.742,0.241,NULL,63508171819,992315184,15504924,14.8),(49506,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49506,33.31,0.2,45.9,12738,74.4,NULL,NULL,'UGC 03949',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49507,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49507,33.46,0.76,49.2,12738,NULL,NULL,'Malmquist cor.','UGC 03949',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49508,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49508,37.9,0.46,381,12739,70,NULL,NULL,'2MASX J07394631+2409187',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000134,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,114.942791667,24.15544,0.137,NULL,62948642687,983572541,15368320,18),(49509,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49509,35,0.51,100,12740,70,NULL,NULL,'2MASX J07394636-7142122',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,114.9432917,-71.70347,0.705,NULL,40629633534,634838023,9919344,16.4),(49510,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49510,37.68,0.46,344,12741,70,NULL,NULL,'2MASX J07394675+1839590',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,114.94475,18.66636,0.145,NULL,63136931948,986514561,15414290,17.6),(49511,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49511,37.94,0.27,388,12742,70,NULL,NULL,'2MASX J07394707+3052023',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,114.946083333,30.86742,0.145,NULL,63473487460,991773241,15496456,17.4),(49512,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49512,36.86,0.96,235,12743,70,NULL,NULL,'2MASX J07394780-8150404',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,114.949625,-81.84467,0.745,NULL,39772248882,621441388,9710021,17.5),(49513,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49513,38.54,0.46,510,12744,70,NULL,NULL,'2MASX J07394875+4837285',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000181,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,114.95325,48.62469,0.241,NULL,63508174067,992315219,15504925,17.8),(49514,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49514,38.06,0.46,409,12745,70,NULL,NULL,'2MASX J07395069+4341344',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000148,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,114.96125,43.69306,0.217,NULL,63613595219,993962425,15530662,17.7),(49515,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49515,37.2,0.46,275,12746,70,NULL,NULL,'2MASX J07395083+4448154',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000186,NULL,'16.1g',0.37,NULL,NULL,NULL,NULL,NULL,1,114.961833,44.80433,0.249,NULL,63614573742,993977714,15530901,16.1),(49516,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49516,38.48,0.46,496,12747,70,NULL,NULL,'2MASX J07395091+4411314',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,114.9620417,44.19192,0.233,NULL,63614943343,993983489,15530992,17.9),(49517,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49517,34.71,0.46,87.5,12748,70,NULL,NULL,'2MASX J07395516+4907036',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000073,NULL,'15.4g',0.63,NULL,NULL,NULL,NULL,NULL,1,114.979833,49.11761,0.225,NULL,63508275625,992316806,15504950,15.4),(49518,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49518,38.27,0.46,450,12749,70,NULL,NULL,'SDSS J073958.27+193804.6',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'18.0g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,114.992833,19.63461,0.153,NULL,63094536939,985852139,15403939,18),(49519,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49519,37.19,0.46,274,12750,70,NULL,NULL,'2MASX J07395928+2238431',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000069,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,114.997,22.64528,0.153,NULL,63085494645,985710853,15401732,17.9),(49520,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49520,37.94,0.27,388,12751,70,NULL,NULL,'SDSS J074003.26+305032.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000133,NULL,'18.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,115.013583,30.84247,0.145,NULL,63428392132,991068627,15485447,18.7),(49521,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49521,35.78,0.45,143,12752,NULL,NULL,'Malmquist cor.','ESO 088- G 027',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.78',0.3,'S...',NULL,NULL,NULL,NULL,1,115.023875,-66.50764,0.637,NULL,40647839805,635122496,9923789,16.78),(49522,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49522,35.85,0.44,148,12752,NULL,NULL,NULL,'ESO 088- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49523,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49523,35.89,0.2,151,12752,74.4,NULL,NULL,'ESO 088- G 027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49524,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49524,37.8,0.46,364,12753,70,NULL,NULL,'SDSS J074008.66+220135.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000138,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,115.036125,22.02656,0.113,NULL,63096408646,985881385,15404396,18.3),(49525,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49525,38.15,0.46,426,12754,70,NULL,NULL,'2MASX J07401257+4455593',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000169,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,115.05225,44.93331,0.257,NULL,63614736036,993980250,15530941,18.6),(49526,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49526,37.69,0.27,345,12755,70,NULL,NULL,'2MASX J07401725+4217533',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000142,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,115.07175,42.298,0.205,NULL,63615242607,993988165,15531065,18),(49527,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49527,31.46,0.4,19.6,12756,75,NULL,'B','UGC 03964',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000024,NULL,'13.6',1.1,'SAB(s)dm:',NULL,NULL,NULL,NULL,1,115.0747917,-1.57439,0.701,NULL,39275049640,613672650,9588635,13.6),(49528,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49528,37.72,0.46,350,12757,70,NULL,NULL,'2MASX J07401928+2311283',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,115.08025,23.19131,0.109,NULL,63086381342,985724708,15401948,17.6),(49529,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49529,33.77,NULL,56.9,12758,NULL,NULL,'Dipole','ESO 429- G 009',NULL,'2010Ap&SS.325..163P',2010,1,1.57,'abs(b) < 10 degrees.','G',0.000013,NULL,'16.7',0.2,'Sc',NULL,NULL,NULL,NULL,1,115.085375,-30.95356,NULL,NULL,42607864208,665747878,10402310,16.7),(49530,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49530,33.78,NULL,57.1,12758,NULL,NULL,'Dipole + Quadrupole','ESO 429- G 009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49531,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49531,33.79,NULL,57.2,12758,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 429- G 009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49532,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49532,33.83,0.49,58.5,12758,75,NULL,'IR','ESO 429- G 009',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49533,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49533,37.15,0.46,269,12759,70,NULL,NULL,'2MASXi J0740223+411741',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000073,NULL,'17.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,115.0932917,41.29497,0.221,NULL,63607845630,993872587,15529259,17.8),(49534,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49534,37.49,0.46,314,12760,70,NULL,NULL,'2MASX J07402390+4131349',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000157,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,115.0997083,41.5265,0.177,NULL,63607875591,993873056,15529266,17.3),(49535,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49535,37.93,0.46,385,12761,70,NULL,NULL,'2MASX J07402542+2409308',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,115.106083333,24.15864,0.137,NULL,62948696471,983573382,15368334,17.3),(49536,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49536,34.44,0.38,77.2,12762,NULL,NULL,'Malmquist cor.','UGC 03962',NULL,'2009ApJS..182..474S',2009,1,2.1,NULL,'G',0.000033,NULL,'14.00',0.8,'SABb',NULL,NULL,NULL,NULL,1,115.123417,13.87175,0.229,NULL,62631790536,978621727,15290964,14),(49537,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49537,34.59,0.36,82.7,12762,NULL,NULL,NULL,'UGC 03962',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49538,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49538,34.63,0.2,84.3,12762,74.4,NULL,NULL,'UGC 03962',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49539,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49539,35.09,0.47,104,12762,NULL,NULL,'H','UGC 03962',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49540,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49540,35.14,0.46,107,12762,NULL,NULL,'J','UGC 03962',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49541,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49541,35.15,0.45,107,12762,NULL,NULL,'K','UGC 03962',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49542,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49542,35.38,0.4,119,12762,NULL,NULL,'mean','UGC 03962',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49543,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49543,37.32,0.46,291,12763,70,NULL,NULL,'2MASX J07403005+4229062',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000141,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,115.1252917,42.48519,0.201,NULL,63615112575,993986133,15531033,17.6),(49544,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49544,37.04,0.46,256,12764,70,NULL,NULL,'2MASX J07403063+4421352',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000172,NULL,'17.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,115.1275,44.35975,0.229,NULL,63614953565,993983649,15530994,17.2),(49545,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49545,36.43,0.46,193,12765,70,NULL,NULL,'2MASX J07403083+3226261',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000155,NULL,'16.5g',0.25,'NLAGN',NULL,NULL,NULL,NULL,1,115.128625,32.44069,0.149,NULL,63481639333,991900614,15498447,16.5),(49546,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49546,38.01,0.46,400,12766,70,NULL,NULL,'2MASX J07403245+1843433',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,115.135125,18.72861,0.145,NULL,63090896121,985795251,15403050,17.8),(49547,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49547,35.42,NULL,121,12767,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 117-064',NULL,'2010Ap&SS.325..163P',2010,1,1.23,NULL,'G',0.000009,NULL,'15.6',0.13,'Sc',NULL,NULL,NULL,NULL,1,115.1462083,26.135,0.185,NULL,63420494601,990945228,15483519,15.6),(49548,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49548,35.44,NULL,122,12767,NULL,NULL,'Dipole + Quadrupole','CGCG 117-064',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49549,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49549,35.44,NULL,123,12767,NULL,NULL,'Dipole','CGCG 117-064',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49550,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49550,35.46,NULL,124,12767,NULL,NULL,NULL,'CGCG 117-064',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49551,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49551,35.54,0.49,128,12767,75,NULL,'IR','CGCG 117-064',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49552,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49552,36.02,0.43,160,12767,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 117-064',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49553,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49553,37.46,0.46,310,12768,70,NULL,NULL,'SDSS J074038.61+250409.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000132,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,115.160917,25.06936,0.149,NULL,62948481650,983570025,15368281,18.3),(49554,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49554,33.08,0.49,41.2,12769,75,NULL,'IR','NGC 2424',NULL,'2011yCatp016004901K',2011,1,3.49,NULL,'G',0.00001,NULL,'13.5g',0.55,'SB(r)b: sp',NULL,NULL,NULL,NULL,1,115.1637083,39.23331,0.277,NULL,63561182788,993143481,15517866,13.5),(49555,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49555,33.24,NULL,44.4,12769,NULL,NULL,'Dipole','NGC 2424',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49556,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49556,33.24,NULL,44.5,12769,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 2424',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49557,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49557,33.24,NULL,44.5,12769,NULL,NULL,'Dipole + Quadrupole','NGC 2424',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49558,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49558,33.27,NULL,45.1,12769,NULL,NULL,NULL,'NGC 2424',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49559,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49559,33.29,0.2,45.5,12769,74.4,NULL,NULL,'NGC 2424',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49560,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49560,33.38,0.43,47.3,12769,75,NULL,'3.6 micron, color corrected','NGC 2424',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49561,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49561,33.38,0.4,47.4,12769,NULL,NULL,NULL,'NGC 2424',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49562,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49562,33.5,0.38,50.2,12769,NULL,NULL,'Malmquist cor.','NGC 2424',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49563,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49563,33.54,0.43,51,12769,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2424',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49564,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49564,37.63,0.33,336,12770,70,NULL,NULL,'2MASX J07404096+4557473',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,115.170583333,45.96328,0.229,NULL,63577832373,993403630,15521931,17.4),(49565,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49565,35.89,0.46,151,12771,70,NULL,NULL,'2MASX J07404145+4423232',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,115.1727083,44.38989,0.229,NULL,63614997945,993984342,15531005,16.7),(49566,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49566,37.34,0.46,293,12772,70,NULL,NULL,'SDSS J074041.97+373925.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000075,NULL,'18.3g',0.14,'NLAGN',NULL,NULL,NULL,NULL,1,115.174875,37.657,0.277,NULL,63439845279,991247582,15488243,18.3),(49567,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49567,36.96,0.46,246,12773,70,NULL,NULL,'2MASX J07404213+4610312',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000188,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,115.1754583,46.17525,0.249,NULL,63580770095,993449532,15522648,16.3),(49568,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49568,37.63,0.23,336,12774,70,NULL,NULL,'2MASX J07404256+4300512',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000178,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,115.1775,43.01422,0.201,NULL,63613827583,993966055,15530719,17.2),(49569,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49569,35.31,0.46,116,12775,70,NULL,NULL,'CGCG 117-065',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000113,NULL,'15.1g',0.57,'E0',NULL,NULL,NULL,NULL,1,115.177667,23.62625,0.097,NULL,63086227388,985722302,15401910,15.1),(49570,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49570,37.63,0.33,336,12776,70,NULL,NULL,'2MASX J07404460+4555362',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,115.1857083,45.92675,0.229,NULL,63577824308,993403504,15521929,18.3),(49571,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49571,38.41,0.46,481,12777,70,NULL,NULL,'2MASX J07404542+3456455',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000078,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,115.189083,34.94611,0.161,NULL,63471054812,991735231,15495862,17.5),(49572,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49572,37.23,0.46,279,12778,70,NULL,NULL,'2MASX J07404735+1833212',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,115.1972917,18.55589,0.145,NULL,63090944514,985796008,15403062,17.1),(49573,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49573,36.16,0.79,171,12779,70,NULL,NULL,'2MASX J07404960-5706031',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'15.3I',0.2,NULL,NULL,NULL,NULL,NULL,1,115.206667,-57.10094,0.709,NULL,40450645993,632041343,9875645,15.3),(49574,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49574,37.63,0.23,336,12780,70,NULL,NULL,'2MASX J07405106+4305562',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000165,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,115.212667,43.09903,0.201,NULL,63613807460,993965741,15530714,17),(49575,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49575,38.05,0.46,407,12781,70,NULL,NULL,'2MASX J07405137+1605061',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,115.214083,16.085,0.137,NULL,62639416395,978740881,15292826,17.5),(49576,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49576,37.45,0.46,309,12782,70,NULL,NULL,'2MASX J07405180+2230479',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000137,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,115.215917,22.51317,0.101,NULL,63085106261,985704785,15401637,17.1),(49577,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49577,37.64,0.46,338,12783,70,NULL,NULL,'2MASX J07405536+1833289',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,115.230625,18.55817,0.117,NULL,63090944219,985796003,15403062,17.4),(49578,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49578,36.9,0.46,240,12784,70,NULL,NULL,'2MASXi J0740567+160801',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.3g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,115.236625,16.13356,0.137,NULL,62639553213,978743018,15292859,17.3),(49579,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49579,33.13,0.4,42.2,12785,NULL,NULL,'mean','ESO 429- G 012',NULL,'2007A&A...465...71T',2007,1,1.4,'abs(b) < 10 degrees.','G',0.000029,NULL,'15.6',0.5,'S...',NULL,NULL,NULL,NULL,1,115.245041667,-32.07269,NULL,NULL,42610972613,665796447,10403069,15.6),(49580,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49580,33.18,0.47,43.3,12785,NULL,NULL,'H','ESO 429- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49581,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49581,33.37,0.45,47.2,12785,NULL,NULL,'K','ESO 429- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49582,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49582,33.4,0.46,48,12785,NULL,NULL,'J','ESO 429- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49583,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49583,38.1,0.46,417,12786,70,NULL,NULL,'2MASX J07405891+4912031',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000172,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,115.245375,49.20094,0.225,NULL,63508239859,992316247,15504941,17.5),(49584,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49584,37.67,0.46,342,12787,70,NULL,NULL,'2MASX J07410064+4319341',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000184,NULL,'16.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,115.2527083,43.32614,0.205,NULL,63613716331,993964317,15530692,16.4),(49585,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49585,37.63,0.23,336,12788,70,NULL,NULL,'2MASX J07410206+4259111',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,115.258666667,42.98642,0.201,NULL,63613826999,993966046,15530719,17.5),(49586,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49586,38.06,0.46,409,12789,70,NULL,NULL,'2MASX J07410230+2146269',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,115.2597083,21.77408,0.153,NULL,63096895192,985888987,15404515,18),(49587,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49587,35.76,NULL,142,12790,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0647',NULL,'2010Ap&SS.325..163P',2010,1,0.83,NULL,'G',NULL,NULL,'16.6',0.1,'Sd',NULL,NULL,NULL,NULL,1,115.2822917,62.64786,0.169,NULL,61673963973,963655687,15057120,16.6),(49588,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49588,35.78,NULL,143,12790,NULL,NULL,'Dipole + Quadrupole','FGC 0647',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49589,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49589,35.8,NULL,145,12790,NULL,NULL,'Dipole','FGC 0647',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49590,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49590,35.81,NULL,145,12790,NULL,NULL,NULL,'FGC 0647',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49591,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49591,38.25,0.46,448,12791,70,NULL,NULL,'2MASX J07411140+2929148',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000183,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,115.297625,29.4875,0.113,NULL,63430931629,991108306,15486067,17.2),(49592,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49592,37.15,0.46,269,12792,70,NULL,NULL,'2MASX J07411150+3240130',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,115.297833333,32.67044,0.157,NULL,63481129591,991892649,15498322,16.8),(49593,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49593,35.21,0.46,110,12793,70,NULL,NULL,'CGCG 206-016',NULL,'2015arXiv151105856S',2015,1,0.91,NULL,'G',0.000167,NULL,'14.6g',0.61,'Sa',NULL,NULL,NULL,NULL,1,115.302,42.74939,0.213,NULL,63613098847,993954669,15530541,14.6),(49594,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49594,37.37,0.46,299,12794,70,NULL,NULL,'2MASX J07411303+3430500',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000078,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,115.304375,34.51394,0.157,NULL,63482135103,991908360,15498568,17.4),(49595,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49595,37.67,0.46,341,12795,70,NULL,NULL,'2MASX J07411411+1855148',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,115.308875,18.92067,0.105,NULL,63091683362,985807552,15403243,17.5),(49596,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49596,35.2,0.49,110,12796,75,NULL,'IR','UGC 03969',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.68',0.2,'Scd:',NULL,NULL,NULL,NULL,1,115.3097917,27.61414,0.185,NULL,63431971793,991124559,15486321,15.68),(49597,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49597,35.29,0.29,114,12796,NULL,NULL,'Malmquist cor.','UGC 03969',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49598,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49598,35.47,0.27,124,12796,NULL,NULL,NULL,'UGC 03969',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49599,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49599,35.53,0.4,127,12796,NULL,NULL,'mean','UGC 03969',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49600,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49600,35.52,0.2,127,12796,74.4,NULL,NULL,'UGC 03969',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49601,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49601,35.72,0.47,139,12796,NULL,NULL,'H','UGC 03969',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49602,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49602,37.69,0.27,345,12797,70,NULL,NULL,'2MASX J07411530+4219452',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000157,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,115.3139583,42.32922,0.205,NULL,63615028788,993984824,15531012,17.7),(49603,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49603,37.61,0.46,332,12798,70,NULL,NULL,'2MASX J07411549+1632531',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,115.3145417,16.54814,0.089,NULL,62641420151,978772189,15293315,17.1),(49604,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49604,37.92,0.46,383,12799,70,NULL,NULL,'2MASX J07411686+4835059',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,115.320208333,48.58494,0.241,NULL,63509033328,992328645,15505135,17.1),(49605,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49605,37.26,0.46,283,12800,70,NULL,NULL,'2MASX J07411701+3730396',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000069,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,115.321083333,37.51108,0.277,NULL,63439890011,991248281,15488254,17.6),(49606,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49606,37.69,0.27,345,12801,70,NULL,NULL,'2MASXi J0741181+421625',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,115.325625,42.27361,0.205,NULL,63615040116,993985001,15531015,17.5),(49607,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49607,37.26,0.46,283,12802,70,NULL,NULL,'2MASX J07411918+3736317',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000111,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,115.3297917,37.60875,0.277,NULL,63439893233,991248331,15488255,17.4),(49608,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49608,37.63,0.23,336,12803,70,NULL,NULL,'2MASX J07412047+4306272',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,115.33525,43.10764,0.201,NULL,63613804562,993965696,15530714,17.9),(49609,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49609,38.48,0.46,496,12804,70,NULL,NULL,'2MASX J07412116+2143303',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,115.338125,21.72494,0.153,NULL,63096043811,985875684,15404307,17.8),(49610,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49610,38.12,0.46,420,12805,70,NULL,NULL,'2MASX J07412240+4440232',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00018,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,115.343375,44.67314,0.189,NULL,63614779210,993980925,15530951,17.8),(49611,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49611,37.47,0.46,311,12806,70,NULL,NULL,'2MASX J07412447+2709278',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,115.351916667,27.15783,0.177,NULL,63420613595,990947087,15483548,16.6),(49612,'Brightest Stars','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49612,29.18,0.4,6.85,12807,NULL,NULL,'1B','UGC 03966',NULL,'1997AstL...23..514G',1997,1,1.7,NULL,'G',0.000017,NULL,'13.9',1.7,'Im','Field galaxy',NULL,NULL,NULL,1,115.358333,40.11222,0.205,NULL,63562861071,993169704,15518276,13.9),(49613,'Brightest Stars','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49613,30.41,NULL,12.1,12807,NULL,NULL,'LF','UGC 03966',NULL,'1997AstL...23..514G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49614,'TRGB','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49614,30.08,0.1,10.4,12807,74.4,NULL,NULL,'UGC 03966',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49615,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49615,29.36,0.4,7.4,12807,75,NULL,'B','UGC 03966',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49616,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49616,36.54,0.46,203,12808,70,NULL,NULL,'2MASX J07412702+3246460',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000153,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,115.362625,32.77933,0.145,NULL,63484649619,991947650,15499182,16.6),(49617,'Sosies','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49617,32.19,0.23,27.4,12809,NULL,NULL,NULL,'2MASX J07412825-3006436',NULL,'2002A&A...393...57T',2002,1,0.6,NULL,'G',0.000033,NULL,'16.1',0.5,'S',NULL,NULL,NULL,NULL,1,115.367625,-30.11219,NULL,NULL,42559772001,664996437,10390569,16.1),(49618,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49618,32.64,0.4,33.8,12809,NULL,NULL,'mean','2MASX J07412825-3006436',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49619,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49619,33.08,0.47,41.4,12809,NULL,NULL,'H','2MASX J07412825-3006436',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49620,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49620,33.08,0.45,41.4,12809,NULL,NULL,'K','2MASX J07412825-3006436',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49621,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49621,33.1,0.46,41.7,12809,NULL,NULL,'J','2MASX J07412825-3006436',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49622,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49622,37.76,0.46,356,12810,70,NULL,NULL,'2MASX J07413172+1622065',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,115.3822917,16.36842,0.381,NULL,62641431431,978772366,15293318,17.4),(49623,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49623,37.7,0.46,347,12811,70,NULL,NULL,'2MASX J07413333+3108550',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000182,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,115.388791667,31.14861,0.157,NULL,63480804202,991887565,15498243,16.7),(49624,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49624,37.31,0.46,289,12812,70,NULL,NULL,'2MASX J07413537+3947277',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00008,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,115.397333,39.79092,0.193,NULL,63564128854,993189513,15518586,16.9),(49625,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49625,37.5,0.46,317,12813,70,NULL,NULL,'2MASX J07413878+3959596',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00009,NULL,'17.2g',0.25,'BLAGN',NULL,NULL,NULL,'Sy 1',1,115.411625,39.99981,0.205,NULL,63563926291,993186348,15518536,17.2),(49626,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49626,38.25,0.46,447,12814,70,NULL,NULL,'2MASX J07413942+2746278',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,115.414333333,27.7745,0.165,NULL,63432020746,991125324,15486333,18.2),(49627,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49627,33.41,0.4,48.2,12815,NULL,NULL,'mean','2MFGC 06092',NULL,'2007A&A...465...71T',2007,1,1.2,'abs(b) < 10 degrees.','G',0.000019,NULL,'9.5K',0.11,'S',NULL,NULL,NULL,NULL,1,115.421541667,-22.52044,NULL,NULL,39461402855,616584419,9634131,9.5),(49628,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49628,33.62,0.49,53,12815,75,NULL,'IR','2MFGC 06092',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49629,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49629,33.78,0.45,57.1,12815,NULL,NULL,'K','2MFGC 06092',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49630,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49630,33.92,0.47,60.8,12815,NULL,NULL,'H','2MFGC 06092',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49631,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49631,34.06,0.46,64.7,12815,NULL,NULL,'J','2MFGC 06092',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49632,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49632,37.88,0.46,377,12816,70,NULL,NULL,'2MASX J07414155+4520236',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,115.4230417,45.34008,0.201,NULL,63611107480,993923554,15530055,17.4),(49633,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49633,37.5,0.46,316,12817,70,NULL,NULL,'2MASX J07414185+3021080',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,115.424333,30.35231,0.161,NULL,63430711557,991104868,15486013,17.4),(49634,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49634,37.93,0.33,385,12818,70,NULL,NULL,'2MASX J07414504+2034103',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,115.4375417,20.56961,0.137,NULL,63092809410,985825147,15403517,17.5),(49635,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49635,36.87,0.46,236,12819,70,NULL,NULL,'2MASX J07414548+4021286',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000075,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,115.4395,40.35806,0.201,NULL,63563102545,993173477,15518335,16.5),(49636,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49636,37.78,0.46,359,12820,70,NULL,NULL,'2MASX J07414576+2319053',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000177,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,115.4407917,23.31828,0.109,NULL,63086272096,985723001,15401921,17.1),(49637,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49637,37.95,0.46,389,12821,70,NULL,NULL,'2MASX J07414700+4249156',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,115.445583333,42.82103,0.213,NULL,63613089031,993954516,15530539,17.9),(49638,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49638,34.46,0.49,78,12822,75,NULL,'IR','2MFGC 06099',NULL,'2011yCatp016004901K',2011,1,NULL,'abs(b) < 10 degrees.','G',NULL,NULL,'11.0K',NULL,NULL,NULL,NULL,NULL,NULL,1,115.4497083,-30.47261,NULL,NULL,42559823597,664997243,10390581,11),(49639,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49639,38.03,0.33,404,12823,70,NULL,NULL,'2MASX J07414970+4113256',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000067,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,115.457083,41.22383,0.225,NULL,63562699561,993167180,15518237,18.4),(49640,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49640,37.94,0.33,388,12824,70,NULL,NULL,'2MASX J07415071+1641342',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,115.4612917,16.69286,0.089,NULL,62638021258,978719082,15292485,17.1),(49641,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49641,36.69,0.46,217,12825,70,NULL,NULL,'2MASXi J0741518+444137',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,115.4662083,44.69386,0.189,NULL,63614805567,993981336,15530958,17.6),(49642,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49642,37.93,0.33,385,12826,70,NULL,NULL,'2MASX J07415214+2034086',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,115.467375,20.56892,0.137,NULL,63092761335,985824395,15403506,17.2),(49643,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49643,38.03,0.33,404,12827,70,NULL,NULL,'SDSS J074154.45+411323.1',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,115.476917,41.22308,0.225,NULL,63562702595,993167228,15518237,17.1),(49644,'Brightest Stars','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49644,28.15,0.4,4.27,12828,NULL,NULL,'1B','UGC 03974',NULL,'1997AstL...23..514G',1997,1,3.1,NULL,'G',0.000003,NULL,'13.6',3,'IB(s)m','Field galaxy',NULL,NULL,NULL,1,115.480833,16.8025,0.089,NULL,62638245357,978722583,15292540,13.6),(49645,'TRGB','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49645,28.57,0.25,5.18,12828,NULL,NULL,NULL,'UGC 03974',NULL,'2003A&A...398..479K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49646,'TRGB','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49646,29.52,0.1,8.02,12828,NULL,NULL,NULL,'UGC 03974',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49647,'TRGB','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49647,29.53,0.04,8.04,12828,NULL,NULL,NULL,'UGC 03974',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49648,'TRGB','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49648,29.56,0.1,8.17,12828,74.4,NULL,NULL,'UGC 03974',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49649,'TRGB','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49649,29.62,0.03,8.39,12828,NULL,NULL,'I','UGC 03974',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49650,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49650,26.58,0.4,2.1,12828,75,NULL,'B','UGC 03974',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49651,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49651,38.32,0.46,462,12829,70,NULL,NULL,'2MASX J07415571+2405498',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,115.482083,24.09731,0.165,NULL,63082753703,985668026,15401062,18.1),(49652,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 1992bg',NULL,49652,35.18,0.17,105,12830,74.2,NULL,'SALT 2','2MASX J07415700-6231144',0.036,'2010ApJ...716..712A',2010,1,0.76,NULL,'G',0.00015,NULL,'15.25',0.29,'Sa',NULL,NULL,NULL,NULL,1,115.4875,-62.52072,0.593,NULL,40467556919,632305576,9879774,15.25),(49653,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 1992bg',NULL,49653,35.47,0.08,124,12830,60,NULL,'M(B) = -19.48 mag','2MASX J07415700-6231144',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49654,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 1992bg',NULL,49654,35.52,0.07,127,12830,60,NULL,'M(V) = -19.47 mag','2MASX J07415700-6231144',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49655,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 1992bg',NULL,49655,35.57,0.06,130,12830,60,NULL,'M(I) = -19.19 mag','2MASX J07415700-6231144',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49656,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 1992bg',NULL,49656,35.78,0.08,143,12830,74.4,NULL,NULL,'2MASX J07415700-6231144',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49657,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 1992bg',NULL,49657,35.89,0.06,146,12830,72,NULL,NULL,'2MASX J07415700-6231144',0.036,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49658,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 1992bg',NULL,49658,35.9,0.08,146,12830,70,NULL,'SALT 2','2MASX J07415700-6231144',0.036,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49659,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 1992bg',NULL,49659,35.91,0.18,146,12830,70,NULL,'SALT 2','2MASX J07415700-6231144',0.036,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49660,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 1992bg',NULL,49660,35.94,0.19,149,12830,72,NULL,NULL,'2MASX J07415700-6231144',0.036,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49661,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 1992bg',NULL,49661,35.95,0.08,149,12830,70,NULL,'SALT','2MASX J07415700-6231144',0.036,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49662,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 1992bg',NULL,49662,35.89,0.17,151,12830,70.8,NULL,NULL,'2MASX J07415700-6231144',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49663,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 1992bg',NULL,49663,36.13,0.13,157,12830,65,NULL,'MLCS2k2','2MASX J07415700-6231144',0.036,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49664,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 1992bg',NULL,49664,36.13,0.17,162,12830,65,NULL,'MLCS17','2MASX J07415700-6231144',0.036,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49665,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 1992bg',NULL,49665,36.15,0.17,164,12830,65,NULL,'MLCS31','2MASX J07415700-6231144',0.036,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49666,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 1992bg',NULL,49666,36.17,0.19,165,12830,65,NULL,NULL,'2MASX J07415700-6231144',0.036,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49667,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 1992bg',NULL,49667,36.26,0.21,172,12830,65,NULL,'MLCS','2MASX J07415700-6231144',0.036,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49668,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 1992bg',NULL,49668,36.31,0.14,183,12830,60,NULL,NULL,'2MASX J07415700-6231144',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49669,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 1992bg',NULL,49669,36.49,0.21,192,12830,65,NULL,'Template','2MASX J07415700-6231144',0.036,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49670,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49670,35.58,0.46,130,12831,70,NULL,NULL,'CGCG 117-066',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000189,NULL,'15.3g',0.49,'E/S0',NULL,NULL,NULL,NULL,1,115.4942917,23.17639,0.097,NULL,63086319907,985723748,15401933,15.3),(49671,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49671,37.74,0.46,353,12832,70,NULL,NULL,'2MASX J07420007+2504018',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000184,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,115.5004583,25.06706,0.149,NULL,62948601220,983571894,15368310,17.5),(49672,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49672,37.79,0.46,361,12833,70,NULL,NULL,'2MASX J07420036+1806046',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,115.5014583,18.10133,0.125,NULL,62616768167,978387002,15287296,17.8),(49673,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49673,36.92,0.27,242,12834,70,NULL,NULL,'SDSS J074202.05+342728.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000091,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,115.508541667,34.45794,0.221,NULL,63482257261,991910269,15498597,17.8),(49674,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49674,37.94,0.33,388,12835,70,NULL,NULL,'2MASX J07420418+1637412',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,115.5175417,16.62822,0.089,NULL,62638018368,978719037,15292484,17.4),(49675,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49675,37.98,0.46,394,12836,70,NULL,NULL,'2MASX J07420551+3127172',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,115.522958333,31.45486,0.157,NULL,63481022966,991890983,15498296,16.7),(49676,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49676,37.77,0.46,357,12837,70,NULL,NULL,'2MASX J07420819+2448527',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000202,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,115.534125,24.81467,0.169,NULL,62949049002,983578890,15368420,16.9),(49677,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49677,37.57,0.46,327,12838,70,NULL,NULL,'2MASX J07421557+3920047',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000091,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,115.565041667,39.33458,0.189,NULL,63563965900,993186967,15518546,16.8),(49678,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49678,38.05,0.46,407,12839,70,NULL,NULL,'2MASX J07421571+2807040',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,115.5655,28.11786,0.145,NULL,63433797474,991153085,15486766,18),(49679,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49679,38.04,0.46,405,12840,70,NULL,NULL,'2MASX J07421644+2047356',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000171,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,115.568375,20.79311,0.137,NULL,63091980170,985812190,15403315,17.9),(49680,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49680,37.8,0.46,363,12841,70,NULL,NULL,'2MASX J07421652+4609516',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00018,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,115.568875,46.16453,0.249,NULL,63577985967,993406030,15521969,17.9),(49681,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49681,37.47,0.23,312,12842,70,NULL,NULL,'2MASX J07421873+4034326',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000066,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,115.5780417,40.57561,0.197,NULL,63563008073,993172001,15518312,18.2),(49682,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49682,36.57,0.46,206,12843,70,NULL,NULL,'2MASX J07422246+2423369',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000104,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,115.593708333,24.39375,0.165,NULL,62949016786,983578387,15368412,18),(49683,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49683,37.37,0.46,297,12844,70,NULL,NULL,'2MASX J07422295+2801459',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000188,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,115.5955417,28.02933,0.145,NULL,63433762303,991152535,15486758,17),(49684,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49684,38.19,0.46,434,12845,70,NULL,NULL,'SDSS J074226.94+205803.8',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,115.61225,20.96775,0.165,NULL,63092013535,985812711,15403323,17.8),(49685,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49685,37.69,0.46,346,12846,70,NULL,NULL,'2MASX J07422843+2246141',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,115.618583333,22.77056,0.113,NULL,63085921673,985717526,15401836,17.2),(49686,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49686,33.88,0.2,59.7,12847,74.4,NULL,NULL,'UGC 03967',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000037,NULL,'16.5',0.9,'SBd?',NULL,NULL,NULL,NULL,1,115.622083,62.94669,0.153,NULL,61639658718,963119667,15048744,16.5),(49687,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49687,34.21,0.84,69.6,12847,NULL,NULL,NULL,'UGC 03967',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49688,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49688,34.3,0.81,72.6,12847,NULL,NULL,'Malmquist cor.','UGC 03967',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49689,'TRGB','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49689,28.27,NULL,4.51,12848,NULL,NULL,NULL,'CGCG 087-033',NULL,'2003A&A...398..479K',2003,1,0.6,NULL,'G',0.000002,NULL,'15.6',0.3,'dwarf Irr',NULL,NULL,NULL,NULL,1,115.63325,16.56119,0.089,NULL,62641557283,978774332,15293348,15.6),(49690,'TRGB','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49690,29.5,0.1,7.94,12848,NULL,NULL,NULL,'CGCG 087-033',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49691,'TRGB','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49691,29.51,0.1,7.98,12848,74.4,NULL,NULL,'CGCG 087-033',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49692,'TRGB','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49692,29.52,0.07,8.01,12848,NULL,NULL,NULL,'CGCG 087-033',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49693,'TRGB','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49693,29.55,0.04,8.13,12848,NULL,NULL,'I','CGCG 087-033',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49694,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49694,37.59,0.46,329,12849,70,NULL,NULL,'2MASX J07423210+3125237',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00019,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,115.6337917,31.42333,0.157,NULL,63478727419,991855115,15497736,17),(49695,'AGN time lag','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49695,34.78,0.1,90.5,12850,NULL,NULL,NULL,'UGC 03973',NULL,'2014ApJ...784L..11Y',2014,1,1.2,NULL,'G',0.000027,NULL,'13.5r',1.2,'SBb            Sy1.2',NULL,NULL,NULL,'Sy 1',1,115.636666667,49.80964,0.225,NULL,63517389900,992459217,15507175,13.5),(49696,'AGN time lag','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49696,36.28,0.47,180,12850,44,NULL,NULL,'UGC 03973',NULL,'2007MNRAS.380..669C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49697,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49697,35.53,0.65,128,12851,70,NULL,NULL,'2MASX J07423501-5228020',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,115.6457917,-52.46728,0.945,NULL,42528301907,664504717,10382886,17),(49698,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49698,35.26,0.55,113,12852,70,NULL,NULL,'2MASX J07423637-6516544',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,115.651625,-65.28186,0.609,NULL,40650161573,635158774,9924355,16.6),(49699,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49699,35.05,0.49,102,12853,75,NULL,'IR','UGC 03970',NULL,'2011yCatp016004901K',2011,1,1.34,'Possible star superposed.','G',NULL,NULL,'16.0',0.15,'Sbc',NULL,NULL,NULL,NULL,1,115.659458333,61.56153,0.185,NULL,61676510754,963695480,15057741,16),(49700,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49700,35.27,NULL,113,12853,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03970',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49701,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49701,35.28,NULL,114,12853,NULL,NULL,'Dipole + Quadrupole','UGC 03970',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49702,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49702,35.29,NULL,114,12853,NULL,NULL,'Dipole','UGC 03970',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49703,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49703,35.32,NULL,116,12853,NULL,NULL,NULL,'UGC 03970',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49704,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49704,38.42,0.46,483,12854,70,NULL,NULL,'2MASX J07424199+1430424',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,115.6749583,14.51189,0.117,NULL,62643952473,978811757,15293933,17.5),(49705,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49705,37.66,0.46,340,12855,70,NULL,NULL,'2MASX J07424223+3106147',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000188,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,115.675958333,31.104,0.157,NULL,63478755326,991855551,15497742,16.8),(49706,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49706,35.24,0.49,112,12856,75,NULL,'IR','UGC 03980',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000033,NULL,'15.28',0.2,'S?',NULL,NULL,NULL,NULL,1,115.683125,18.32667,0.109,NULL,62616985343,978390395,15287349,15.28),(49707,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49707,35.39,0.3,120,12856,NULL,NULL,'Malmquist cor.','UGC 03980',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49708,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49708,35.5,0.4,126,12856,NULL,NULL,'mean','UGC 03980',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49709,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49709,35.54,0.28,128,12856,NULL,NULL,NULL,'UGC 03980',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49710,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49710,35.58,0.2,131,12856,74.4,NULL,NULL,'UGC 03980',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49711,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49711,35.58,0.47,131,12856,NULL,NULL,'H','UGC 03980',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49712,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49712,35.69,0.45,137,12856,NULL,NULL,'K','UGC 03980',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49713,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49713,36.78,0.46,227,12857,70,NULL,NULL,'2MASX J07424448+3939526',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000075,NULL,'17.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,115.6852917,39.66453,0.201,NULL,63563978818,993187169,15518549,17),(49714,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49714,37.02,0.46,253,12858,70,NULL,NULL,'2MASX J07424509+3947566',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000065,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,115.6880417,39.79914,0.193,NULL,63564094674,993188979,15518577,18.2),(49715,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49715,37.59,0.46,329,12859,70,NULL,NULL,'2MASX J07425013+4345535',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,'PRED','17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,115.70875,43.76483,0.177,NULL,63613295626,993957744,15530589,17),(49716,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49716,38.01,0.46,399,12860,70,NULL,NULL,'2MASX J07425014+1723404',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,115.708917,17.39447,0.113,NULL,62637936355,978717755,15292464,17.4),(49717,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49717,36.23,0.46,176,12861,70,NULL,NULL,'2MASX J07425028+2732168',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'17.65',0.21,NULL,NULL,NULL,NULL,NULL,1,115.709667,27.53794,0.185,NULL,63431826191,991122284,15486285,17.65),(49718,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49718,38.56,0.33,515,12862,70,NULL,NULL,'SDSS J074251.84+345001.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000082,NULL,'18.6g',0.14,'Cand.grav.lens',NULL,NULL,NULL,NULL,1,115.716,34.83389,0.213,NULL,63470899571,991732805,15495825,18.6),(49719,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49719,38.04,0.46,406,12863,70,NULL,NULL,'2MASX J07425197+1737404',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,115.7165417,17.62794,0.105,NULL,62637962784,978718168,15292471,17.6),(49720,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49720,37.47,0.23,312,12864,70,NULL,NULL,'2MASX J07425240+4032345',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.5g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,115.71825,40.54283,0.229,NULL,63562927484,993170741,15518292,16.5),(49721,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49721,34.75,0.5,89.2,12865,70,NULL,NULL,'ESO 059- G 016',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00012,NULL,'15.09',0.4,'Sa-b',NULL,NULL,NULL,NULL,1,115.7285417,-71.21933,0.689,NULL,40628948550,634827321,9919176,15.09),(49722,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49722,37.09,0.46,262,12866,70,NULL,NULL,'2MASX J07425678+2402588',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000134,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,115.73675,24.04961,0.165,NULL,63083251384,985675802,15401184,17.3),(49723,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49723,37.23,0.46,279,12867,70,NULL,NULL,'2MASX J07425745+5019341',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,115.7392917,50.32625,0.217,NULL,63517234457,992456788,15507137,17.7),(49724,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49724,37.24,0.46,280,12868,70,NULL,NULL,'2MASX J07425767+2202467',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000193,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,115.74025,22.04631,0.101,NULL,63085470557,985710477,15401726,16.3),(49725,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49725,38.56,0.33,515,12869,70,NULL,NULL,'2MASX J07425881+3450180',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000076,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,115.745041667,34.83847,0.213,NULL,63470899922,991732811,15495825,18.1),(49726,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49726,37.85,0.33,371,12870,70,NULL,NULL,'2MASX J07425949+4529021',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000185,NULL,'16.7g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,115.7480417,45.484,0.201,NULL,63611333820,993927090,15530110,16.7),(49727,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49727,37.47,0.23,312,12871,70,NULL,NULL,'2MASX J07430211+4029001',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000094,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,115.75875,40.4835,0.229,NULL,63562938260,993170910,15518295,17),(49728,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49728,37.85,0.33,371,12872,70,NULL,NULL,'2MASX J07430359+4527062',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,115.7647917,45.45186,0.201,NULL,63611333312,993927083,15530110,18.4),(49729,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49729,38.21,0.46,439,12873,70,NULL,NULL,'2MASX J07430512+1730424',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,115.77125,17.51183,0.113,NULL,62637917130,978717455,15292460,17.6),(49730,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49730,37.02,0.46,254,12874,70,NULL,NULL,'2MASX J07430578+2114057',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000175,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,115.774,21.23489,0.157,NULL,63096022272,985875348,15404302,18.1),(49731,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49731,31.79,NULL,22.8,12875,NULL,NULL,NULL,'CGCG 030-012',NULL,'2015AstBu..70....1K',2015,1,0.9,'The position in 1996A&AS..117..467G is incorrect.','G',0.00004,NULL,'15.5',0.4,NULL,NULL,NULL,NULL,NULL,1,115.786541667,3.95,0.197,NULL,62736175315,980252739,15316449,15.5),(49732,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49732,35.83,0.46,147,12876,70,NULL,NULL,'CGCG 235-032',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000179,NULL,'15.9g',0.42,'S0/a',NULL,NULL,NULL,NULL,1,115.786583,45.35978,0.201,NULL,63611283837,993926309,15530098,15.9),(49733,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49733,36.32,0.46,183,12877,70,NULL,NULL,'2MASX J07431150+2832187',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000144,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,115.797833333,28.53844,0.105,NULL,63434599433,991165616,15486962,17.3),(49734,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49734,35.33,0.66,117,12878,70,NULL,NULL,'2MASX J07431334-5112030',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.4,NULL,NULL,NULL,NULL,NULL,1,115.8055,-51.20089,0.713,NULL,42529438540,664522477,10383163,14.3),(49735,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49735,37.27,0.46,284,12879,70,NULL,NULL,'2MASX J07431362+4311342',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,115.806833333,43.19297,0.181,NULL,63613880419,993966881,15530732,17.6),(49736,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49736,37.31,0.46,290,12880,70,NULL,NULL,'SDSS J074314.21+224211.0',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000137,NULL,'18.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,115.8092083,22.70308,0.129,NULL,63085967256,985718238,15401847,18.8),(49737,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49737,37.64,0.46,337,12881,70,NULL,NULL,'SDSS J074314.26+225449.7',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,115.809458333,22.91381,0.109,NULL,63085975464,985718366,15401849,17.4),(49738,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49738,36.92,0.27,242,12882,70,NULL,NULL,'2MASX J07431548+3424369',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000107,NULL,'15.8g',0.43,'E0',NULL,NULL,NULL,NULL,1,115.8145,34.41033,0.185,NULL,63482782369,991918474,15498726,15.8),(49739,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49739,38.17,0.33,430,12883,70,NULL,NULL,'2MASX J07431726+2806274',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000173,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,115.821833333,28.10764,0.113,NULL,63433862874,991154107,15486782,17.6),(49740,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49740,37.35,0.46,296,12884,70,NULL,NULL,'2MASX J07431940+2242376',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000145,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,115.830833,22.71047,0.129,NULL,63085968620,985718259,15401847,17.6),(49741,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49741,35.51,0.68,127,12885,70,NULL,NULL,'2MASX J07432176-4952226',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,115.840666667,-49.87297,0.621,NULL,42527820459,664497194,10382768,14.3),(49742,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49742,38.17,0.33,430,12886,70,NULL,NULL,'2MASXi J0743221+280134',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,115.842083,28.02614,0.109,NULL,63433830555,991153602,15486775,17.8),(49743,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49743,36.84,0.46,233,12887,70,NULL,NULL,'2MASX J07432355+2725174',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,115.848167,27.42161,0.177,NULL,63420503334,990945364,15483521,16.9),(49744,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49744,36.48,0.33,197,12888,70,NULL,NULL,'2MASX J07432536+3756432',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000099,NULL,'16.1g',0.41,'S0/a',NULL,NULL,NULL,NULL,1,115.8557917,37.94539,0.173,NULL,63439629308,991244207,15488190,16.1),(49745,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49745,36.48,0.33,197,12889,70,NULL,NULL,'2MASX J07432586+3754242',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000073,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,115.857917,37.90681,0.173,NULL,63439576582,991243384,15488177,17.3),(49746,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49746,37.47,0.23,312,12890,70,NULL,NULL,'2MASX J07432771+4032072',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000068,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,115.8655,40.53542,0.229,NULL,63563414829,993178356,15518411,17.7),(49747,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49747,36.44,0.54,194,12891,70,NULL,NULL,'2MASX J07432797-5254297',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'13.2I',0.6,NULL,NULL,NULL,NULL,NULL,1,115.866541667,-52.90825,0.609,NULL,42528183065,664502860,10382857,13.2),(49748,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49748,34.54,0.55,81.1,12892,NULL,NULL,'Malmquist cor.','UGC 03987',NULL,'2009ApJS..182..474S',2009,1,1.18,NULL,'G',0.00003,NULL,'15.3g',0.3,'Sc',NULL,NULL,NULL,NULL,1,115.876583,22.93053,0.109,NULL,63085984768,985718512,15401851,15.3),(49749,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49749,34.63,0.49,84.3,12892,75,NULL,'IR','UGC 03987',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49750,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49750,34.77,0.5,90,12892,NULL,NULL,NULL,'UGC 03987',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49751,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49751,34.81,0.2,91.6,12892,74.4,NULL,NULL,'UGC 03987',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49752,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49752,33.31,NULL,45.8,12893,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03986',NULL,'2010Ap&SS.325..163P',2010,1,1.18,NULL,'G',0.000008,NULL,'16.6g',0.15,'Sb(f)',NULL,NULL,NULL,NULL,1,115.887083,31.53528,0.161,NULL,63478865923,991857280,15497770,16.6),(49753,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49753,33.31,NULL,46,12893,NULL,NULL,'Dipole + Quadrupole','UGC 03986',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49754,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49754,33.31,NULL,46,12893,NULL,NULL,'Dipole','UGC 03986',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49755,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49755,33.5,NULL,50.1,12893,NULL,NULL,NULL,'UGC 03986',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49756,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49756,33.88,0.34,59.6,12893,NULL,NULL,NULL,'UGC 03986',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49757,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49757,33.92,0.2,60.8,12893,74.4,NULL,NULL,'UGC 03986',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49758,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49758,34.06,0.31,64.8,12893,NULL,NULL,'Malmquist cor.','UGC 03986',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49759,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49759,37.86,0.46,374,12894,70,NULL,NULL,'SDSS J074333.48+490301.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000158,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,115.8895,49.05036,0.201,NULL,63508939559,992327180,15505112,18.6),(49760,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49760,39.02,0.46,637,12895,70,NULL,NULL,'SDSS J074336.19+284103.8',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000177,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,115.900833,28.68442,0.105,NULL,63434647293,991166363,15486974,18.7),(49761,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49761,34.42,0.46,76.7,12896,70,NULL,NULL,'IC 0471',NULL,'2015arXiv151105856S',2015,1,1.05,NULL,'G',0.000047,NULL,'14.0g',0.92,'E','in a pair',NULL,NULL,NULL,1,115.901875,49.66756,0.225,NULL,63516888533,992451383,15507052,14),(49762,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49762,37.55,0.46,324,12897,70,NULL,NULL,'2MASX J07433735+1429112',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,115.90575,14.48642,0.169,NULL,62643993863,978812404,15293943,17.1),(49763,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49763,37.35,0.46,295,12898,70,NULL,NULL,'2MASX J07434128+3824567',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000071,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,115.922083,38.41575,0.205,NULL,63560792037,993137375,15517771,17.4),(49764,'IRAS','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49764,32.93,0.8,38.6,12899,75,NULL,'MAT, I','ESO 163- G 014',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'12.25',0.5,'SB(s)c',NULL,NULL,NULL,NULL,1,115.932041667,-56.76786,0.709,NULL,40452231971,632066124,9876033,12.25),(49765,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49765,32.29,0.32,28.7,12899,85,NULL,'I, raw','ESO 163- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49766,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49766,32.31,0.32,29,12899,85,NULL,'I, inv','ESO 163- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49767,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49767,32.4,0.43,30.2,12899,75,NULL,'MAT, I, raw','ESO 163- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49768,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49768,32.52,0.43,32,12899,75,NULL,'MAT, I, inv','ESO 163- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49769,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49769,32.64,0.47,33.7,12899,NULL,NULL,'H','ESO 163- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49770,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49770,32.69,0.45,34.5,12899,NULL,NULL,'K','ESO 163- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49771,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49771,32.71,0.46,34.9,12899,NULL,NULL,'J','ESO 163- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49772,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49772,32.73,0.43,35.1,12899,75,NULL,'MAT, I, cor','ESO 163- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49773,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49773,32.86,0.43,37.4,12899,75,NULL,'3.6 micron, color + selection bias corrected','ESO 163- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49774,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49774,32.92,0.43,38.4,12899,75,NULL,'3.6 micron, color corrected','ESO 163- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49775,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49775,32.93,0.4,38.5,12899,73,NULL,'opt','ESO 163- G 014',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49776,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49776,32.95,0.2,38.9,12899,74.4,NULL,NULL,'ESO 163- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49777,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49777,33.01,0.4,40,12899,NULL,NULL,'mean','ESO 163- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49778,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49778,33.02,0.47,40.2,12899,NULL,NULL,'Malmquist cor.','ESO 163- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49779,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49779,33.09,0.46,41.5,12899,NULL,NULL,NULL,'ESO 163- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49780,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49780,36.81,0.46,231,12900,70,NULL,NULL,'2MASX J07434416+4427322',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000133,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,115.934125,44.45881,0.185,NULL,63614340625,993974072,15530844,17.4),(49781,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49781,36.95,0.85,245,12901,70,NULL,NULL,'ESO 035- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'16.65',0.9,'Sc',NULL,NULL,NULL,NULL,1,115.93475,-73.61492,0.989,NULL,39903803472,623496929,9742139,16.65),(49782,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49782,34.56,0.47,81.6,12902,NULL,NULL,'H','IC 0472',NULL,'2007A&A...465...71T',2007,1,1.41,NULL,'G',0.000037,NULL,'14.1g',1,'SAB(rs)b','in a pair',NULL,NULL,NULL,1,115.95975,49.61419,0.225,NULL,63516857808,992450903,15507045,14.1),(49783,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49783,34.57,0.4,82,12902,NULL,NULL,'mean','IC 0472',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49784,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49784,34.62,0.45,84.1,12902,NULL,NULL,'K','IC 0472',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49785,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49785,34.63,0.46,84.4,12902,NULL,NULL,'J','IC 0472',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49786,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49786,34.92,0.37,96.6,12902,NULL,NULL,'Malmquist cor.','IC 0472',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49787,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49787,35.17,0.33,108,12902,NULL,NULL,NULL,'IC 0472',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49788,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49788,35.48,0.2,125,12902,74.4,NULL,NULL,'IC 0472',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49789,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49789,36.16,0.76,171,12903,70,NULL,NULL,'2MASX J07435072-7126076',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,115.961208333,-71.43553,0.689,NULL,40628925649,634826963,9919171,17.1),(49790,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49790,38.1,0.46,417,12904,70,NULL,NULL,'2MASX J07435190+2229529',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,115.966083,22.49808,0.133,NULL,63084714004,985698656,15401541,17.6),(49791,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49791,37.61,0.46,332,12905,70,NULL,NULL,'2MASX J07435696+4029567',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00007,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,115.9872917,40.49914,0.229,NULL,63563422239,993178472,15518413,17.8),(49792,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49792,38,0.46,399,12906,70,NULL,NULL,'2MASX J07435757+2508346',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,115.989916667,25.14297,0.201,NULL,63418494889,990913982,15483030,18.3),(49793,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49793,37.74,0.46,353,12907,70,NULL,NULL,'2MASX J07440177+1919194',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000192,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,116.0074583,19.32206,0.173,NULL,62620202259,978440660,15288135,17.7),(49794,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49794,36.62,0.46,211,12908,70,NULL,NULL,'2MASX J07440260+3406455',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000082,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,116.0107083,34.11256,0.177,NULL,63482888071,991920126,15498751,17.1),(49795,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49795,36.92,0.27,242,12909,70,NULL,NULL,'2MASX J07440450+3424395',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000084,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,116.018875,34.411,0.185,NULL,63482812572,991918946,15498733,16.9),(49796,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49796,37.67,0.46,343,12910,70,NULL,NULL,'2MASX J07440519+3025545',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,116.021625,30.43175,0.105,NULL,63423195638,990987431,15484178,17.7),(49797,'BL Lac Luminosity','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49797,41.04,NULL,1230,12911,NULL,NULL,NULL,'SHBL J074405.6+743358',0.315,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.003,NULL,'16.89',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,116.021916667,74.566,0.097,NULL,61300795234,957824925,14966014,16.89),(49798,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49798,37.68,0.27,344,12912,70,NULL,NULL,'2MASX J07440564+3943276',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000072,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,116.023625,39.72439,0.217,NULL,63564641512,993197523,15518711,18.1),(49799,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49799,33.77,0.45,56.7,12913,NULL,NULL,'K','UGC 03995',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'GPair',0.000017,NULL,NULL,NULL,'Sy2',NULL,NULL,NULL,NULL,1,116.03875,29.24667,0.085,NULL,63433988542,991156070,15486813,NULL),(49800,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49800,33.81,0.47,57.7,12913,NULL,NULL,'H','UGC 03995',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49801,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49801,33.87,0.46,59.5,12913,NULL,NULL,'J','UGC 03995',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49802,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49802,34.17,0.4,68.4,12913,NULL,NULL,'mean','UGC 03995',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49803,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49803,36.78,0.92,227,12914,70,NULL,NULL,'AM 0744-675 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,116.03925,-68.02994,0.597,NULL,40653115749,635204933,9925077,16.7),(49804,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49804,38.21,0.46,438,12915,70,NULL,NULL,'SDSS J074411.69+424844.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,116.04875,42.81233,0.185,NULL,63613030808,993953606,15530525,18.8),(49805,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49805,36.91,0.76,241,12916,70,NULL,NULL,'2MASX J07441250-0201045',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,116.052125,-2.01789,0.549,NULL,39270209997,613597031,9587453,15.6),(49806,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49806,37.18,0.46,272,12917,70,NULL,NULL,'2MASX J07441252+2833246',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000159,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,116.05225,28.55678,0.105,NULL,63434586158,991165408,15486959,16.8),(49807,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49807,33.25,0.2,44.7,12918,74.4,NULL,NULL,'NGC 2435',NULL,'2013AJ....146...86T',2013,1,2.1,NULL,'G',0.00003,NULL,'13.74',0.5,'Sa(f)',NULL,NULL,NULL,NULL,1,116.056583,31.65111,0.141,NULL,63478859160,991857174,15497768,13.74),(49808,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49808,33.32,0.41,46.1,12918,NULL,NULL,NULL,'NGC 2435',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49809,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49809,33.34,0.46,46.5,12918,NULL,NULL,'J','NGC 2435',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49810,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49810,33.35,0.45,46.7,12918,NULL,NULL,'K','NGC 2435',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49811,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49811,33.35,0.47,46.8,12918,NULL,NULL,'H','NGC 2435',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49812,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49812,33.58,0.36,52,12918,NULL,NULL,'Malmquist cor.','NGC 2435',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49813,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49813,33.61,0.49,52.6,12918,75,NULL,'IR','NGC 2435',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49814,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49814,33.91,0.4,60.5,12918,NULL,NULL,'mean','NGC 2435',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49815,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49815,37.36,0.46,296,12919,70,NULL,NULL,'2MASX J07441588+3400545',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000071,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,116.066333,34.01508,0.177,NULL,63482860824,991919700,15498745,18.1),(49816,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49816,34.4,0.52,75.7,12920,70,NULL,NULL,'2MASX J07442211-5745332',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000127,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,116.09225,-57.75925,0.805,NULL,40450372974,632037077,9875579,15.8),(49817,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49817,37.92,0.46,383,12921,70,NULL,NULL,'2MASX J07442281+3405385',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000072,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,116.094916667,34.09406,0.177,NULL,63482879356,991919989,15498749,17.8),(49818,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49818,38.05,0.46,407,12922,70,NULL,NULL,'2MASX J07442376+4923275',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,116.09925,49.39083,0.213,NULL,63508685987,992323218,15505050,17.4),(49819,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49819,37.81,0.46,365,12923,70,NULL,NULL,'SDSS J074425.00+220520.9',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000181,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,116.104208333,22.08914,0.137,NULL,63084881904,985701279,15401582,17.1),(49820,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49820,36.28,0.46,180,12924,70,NULL,NULL,'CGCG 206-019',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000095,NULL,'15.5g',0.46,'E0',NULL,NULL,NULL,NULL,1,116.10775,39.64267,0.217,NULL,63564640310,993197504,15518711,15.5),(49821,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49821,35.58,0.46,131,12925,70,NULL,NULL,'CGCG 147-063 NED01',NULL,'2015arXiv151105856S',2015,1,0.69,'SDSS has z = 0.039594 +- 0.000184.','G',0.000033,NULL,'15.5g',0.34,'S0',NULL,NULL,NULL,NULL,1,116.110417,29.26939,0.085,NULL,63433981284,991155957,15486811,15.5),(49822,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49822,34.83,0.49,92.4,12926,75,NULL,'IR','UGC 03988',NULL,'2011yCatp016004901K',2011,1,1.33,NULL,'G',0.000106,NULL,'15.7g',0.2,'Sc',NULL,NULL,NULL,NULL,1,116.1159583,47.73108,0.229,NULL,63509379349,992334052,15505219,15.7),(49823,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49823,35.14,NULL,106,12926,NULL,NULL,NULL,'UGC 03988',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49824,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49824,35.18,NULL,108,12926,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 03988',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49825,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49825,35.2,NULL,110,12926,NULL,NULL,'Dipole + Quadrupole','UGC 03988',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49826,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49826,35.23,NULL,111,12926,NULL,NULL,'Dipole','UGC 03988',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49827,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49827,38.1,0.46,417,12927,70,NULL,NULL,'2MASX J07442895+4357371',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,116.120708333,43.96031,0.181,NULL,63614256748,993972761,15530824,18),(49828,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49828,37.43,0.46,306,12928,70,NULL,NULL,'2MASX J07442921+2310231',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000107,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,116.121708333,23.17319,0.109,NULL,63083064617,985672884,15401138,18.4),(49829,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49829,37.68,0.27,344,12929,70,NULL,NULL,'2MASX J07443084+3948506',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000087,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,116.1285,39.81414,0.217,NULL,63564566795,993196356,15518693,17),(49830,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49830,33.93,0.4,61,12930,NULL,NULL,'mean','UGC 03979',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000037,NULL,'14.78',0.3,'Sbc','Isolated galaxy',NULL,NULL,NULL,1,116.12925,67.27358,0.169,NULL,62165796039,971340563,15177196,14.78),(49831,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49831,34.03,0.43,64,12930,75,NULL,'3.6 micron, color + selection bias corrected','UGC 03979',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49832,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49832,34.04,0.38,64.3,12930,NULL,NULL,'Malmquist cor.','UGC 03979',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49833,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49833,34.05,0.43,64.7,12930,75,NULL,'3.6 micron, color corrected','UGC 03979',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49834,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49834,34.15,0.2,67.6,12930,74.4,NULL,NULL,'UGC 03979',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49835,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49835,34.16,0.47,67.8,12930,NULL,NULL,'H','UGC 03979',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49836,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49836,34.18,0.49,68.6,12930,75,NULL,'IR','UGC 03979',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49837,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49837,34.21,0.45,69.6,12930,NULL,NULL,'K','UGC 03979',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49838,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49838,34.24,0.46,70.4,12930,NULL,NULL,'J','UGC 03979',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49839,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49839,34.27,0.34,71.6,12930,NULL,NULL,NULL,'UGC 03979',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49840,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49840,36.67,0.46,216,12931,70,NULL,NULL,'2MASX J07443208+1520076',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,116.13375,15.33533,0.357,NULL,62639070325,978735473,15292741,17.4),(49841,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49841,36.4,0.46,191,12932,70,NULL,NULL,'2MASX J07443407+4614471',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000159,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,116.142083,46.24653,0.241,NULL,63578156953,993408702,15522010,17),(49842,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49842,37.83,0.46,369,12933,70,NULL,NULL,'SDSS J074434.73+300729.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,'FoF','17.8g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,116.14475,30.12492,0.093,NULL,63431063013,991110359,15486099,17.8),(49843,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49843,38.05,0.46,408,12934,70,NULL,NULL,'2MASX J07443568+2945409',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000187,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,116.148625,29.76139,0.069,NULL,63431189203,991112331,15486130,17.3),(49844,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49844,37.36,0.46,297,12935,70,NULL,NULL,'2MASX J07443758+5043204',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000166,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,116.1565,50.72222,0.189,NULL,63518449429,992475772,15507433,17),(49845,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49845,37.23,0.33,279,12936,70,NULL,NULL,'2MASX J07443788+3837026',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000069,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,116.157833,38.6175,0.205,NULL,63560773101,993137079,15517766,17.3),(49846,'IRAS','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49846,33,0.8,39.9,12937,75,NULL,'MAT, I','ESO 123- G 023',NULL,'1997ApJS..109..333W',1997,1,2.91,NULL,'G',0.00002,NULL,'14.92',0.34,'SB(s)cd? sp',NULL,NULL,NULL,NULL,1,116.162083,-58.15369,0.889,NULL,40442060158,631907189,9873549,14.92),(49847,'Tully est','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49847,32.76,0.8,35.6,12937,75,NULL,NULL,'ESO 123- G 023',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49848,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49848,32.59,0.4,33,12937,75,NULL,NULL,'ESO 123- G 023',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49849,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49849,32.59,0.4,33,12937,73,NULL,'IR','ESO 123- G 023',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49850,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49850,32.82,0.39,36.6,12937,73,NULL,'opt','ESO 123- G 023',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49851,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49851,33.03,0.43,40.4,12937,75,NULL,'MAT, I, raw','ESO 123- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49852,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49852,33.05,0.4,40.7,12937,NULL,NULL,NULL,'ESO 123- G 023',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49853,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49853,33.12,0.32,42.1,12937,85,NULL,'I, raw','ESO 123- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49854,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49854,33.14,0.43,42.5,12937,75,NULL,'MAT, I, cor','ESO 123- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49855,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49855,33.15,0.32,42.7,12937,85,NULL,'I, inv','ESO 123- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49856,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49856,33.17,0.4,43.1,12937,NULL,NULL,'mean','ESO 123- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49857,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49857,33.19,0.49,43.4,12937,NULL,NULL,'Malmquist cor.','ESO 123- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49858,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49858,33.19,0.43,43.4,12937,75,NULL,'MAT, I, inv','ESO 123- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49859,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49859,33.31,0.49,45.9,12937,75,NULL,'IR','ESO 123- G 023',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49860,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49860,33.34,0.46,46.5,12937,NULL,NULL,NULL,'ESO 123- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49861,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49861,33.38,0.2,47.4,12937,74.4,NULL,NULL,'ESO 123- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49862,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49862,33.46,0.46,49.3,12937,NULL,NULL,'J','ESO 123- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49863,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49863,33.47,0.45,49.4,12937,NULL,NULL,'K','ESO 123- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49864,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49864,33.53,0.47,50.8,12937,NULL,NULL,'H','ESO 123- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49865,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49865,33.77,NULL,56.8,12937,NULL,NULL,'Dipole','ESO 123- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49866,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49866,33.77,NULL,56.8,12937,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 123- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49867,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49867,33.78,NULL,57.1,12937,NULL,NULL,'Dipole + Quadrupole','ESO 123- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49868,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49868,33.87,NULL,59.4,12937,NULL,NULL,NULL,'ESO 123- G 023',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49869,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49869,38.12,0.33,421,12938,70,NULL,NULL,'SDSS J074442.13+284503.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,116.1755417,28.75094,0.081,NULL,63434548786,991164824,15486950,18.4),(49870,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49870,37.16,0.46,270,12939,70,NULL,NULL,'2MASX J07444302+2240391',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000136,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,116.1792917,22.67767,0.129,NULL,63085755299,985714926,15401795,16.9),(49871,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49871,38.22,0.46,440,12940,70,NULL,NULL,'2MASX J07444333+3946056',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000097,NULL,'16.8g',0.34,NULL,NULL,NULL,NULL,NULL,1,116.180458333,39.76828,0.217,NULL,63564615685,993197120,15518705,16.8),(49872,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49872,37.84,0.46,370,12941,70,NULL,NULL,'2MASX J07444432+4455141',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000175,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,116.184583,44.92061,0.177,NULL,63611626432,993931663,15530182,17.1),(49873,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49873,38.12,0.33,421,12942,70,NULL,NULL,'2MASX J07444582+2844408',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.9g',0.24,'BrClG',NULL,NULL,NULL,NULL,1,116.190875,28.74453,0.081,NULL,63434035719,991156808,15486825,16.9),(49874,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49874,37.61,0.46,333,12943,70,NULL,NULL,'2MASX J07444647+2151111',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000177,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,116.193625,21.85317,0.157,NULL,62614210192,978347034,15286672,17.4),(49875,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49875,33.76,NULL,56.5,12944,NULL,NULL,'Dipole + Quadrupole + Octopole','KUG 0740+591',NULL,'2010Ap&SS.325..163P',2010,1,1.08,NULL,'G',0.000147,':','17.5:',0.11,'Sdm',NULL,NULL,NULL,NULL,1,116.2037917,58.98053,0.161,NULL,61563911641,961936119,15030251,17.5),(49876,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49876,33.79,NULL,57.2,12944,NULL,NULL,'Dipole + Quadrupole','KUG 0740+591',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49877,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49877,33.79,NULL,57.3,12944,NULL,NULL,'Dipole','KUG 0740+591',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49878,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49878,34.08,NULL,65.5,12944,NULL,NULL,NULL,'KUG 0740+591',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49879,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49879,34.58,0.43,82.5,12944,75,NULL,'3.6 micron, color + selection bias corrected','KUG 0740+591',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49880,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49880,37.28,0.46,286,12945,70,NULL,NULL,'2MASX J07444928+2700425',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,116.205417,27.01189,0.113,NULL,63421246073,990956969,15483702,NULL),(49881,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49881,37.79,0.46,362,12946,70,NULL,NULL,'2MASX J07444964+3424535',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000068,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,116.207041667,34.41492,0.185,NULL,63481924520,991905070,15498516,18.5),(49882,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49882,37.18,0.46,273,12947,70,NULL,NULL,'2MASX J07445013+2252211',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000159,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,116.209,22.87253,0.129,NULL,63082918982,985670609,15401103,17),(49883,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49883,35.74,0.49,141,12948,75,NULL,'IR','FGC 0653',NULL,'2011yCatp016004901K',2011,1,0.81,NULL,'G',NULL,NULL,'16.6',0.1,'Sd',NULL,NULL,NULL,NULL,1,116.209417,60.12369,0.173,NULL,61570491374,962038927,15031858,16.6),(49884,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49884,35.81,NULL,145,12948,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0653',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49885,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49885,35.83,NULL,146,12948,NULL,NULL,'Dipole + Quadrupole','FGC 0653',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49886,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49886,35.85,NULL,148,12948,NULL,NULL,NULL,'FGC 0653',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49887,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49887,35.85,NULL,148,12948,NULL,NULL,'Dipole','FGC 0653',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49888,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49888,37.34,0.46,294,12949,70,NULL,NULL,'2MASX J07445101+1655394',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,116.2125,16.92753,0.101,NULL,62638513698,978726776,15292605,17.1),(49889,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49889,37.68,0.27,344,12950,70,NULL,NULL,'2MASX J07445108+3951465',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.0001,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,116.212875,39.86289,0.217,NULL,63564589446,993196710,15518698,16.3),(49890,'SZ effect','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49890,41.07,0.5,1640,12951,NULL,NULL,'Isotherm.','MACS J0744.9+3927',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,116.218625,39.45758,0.217,NULL,63564659852,993197810,15518715,NULL),(49891,'SZ effect','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49891,41.11,NULL,1670,12951,NULL,NULL,'3.1 (red) calibration','MACS J0744.9+3927',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49892,'SZ effect','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49892,41.13,0.57,1680,12951,NULL,NULL,'Hydrost. Eq.','MACS J0744.9+3927',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49893,'SZ effect','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49893,41.24,NULL,1770,12951,NULL,NULL,'4.2 (black) calibration','MACS J0744.9+3927',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49894,'SZ effect','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49894,41.31,0.47,1830,12951,NULL,NULL,'Isotherm., r < 100 kpc','MACS J0744.9+3927',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49895,'SZ effect','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49895,41.43,NULL,1930,12951,NULL,NULL,'4.1 (blue) calibration','MACS J0744.9+3927',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49896,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49896,37.93,0.46,385,12952,70,NULL,NULL,'SDSS J074455.95+233923.5',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000123,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,116.233167,23.65656,0.161,NULL,63082508737,985664199,15401003,18.8),(49897,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49897,37.85,0.46,372,12953,70,NULL,NULL,'2MASX J07445755+4932070',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,116.239625,49.53536,0.213,NULL,63508595553,992321805,15505028,17.4),(49898,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49898,32.85,0.4,37.2,12954,75,NULL,'B','UGC 03975',NULL,'1988NBGC.C....0000T',1988,1,1.4,NULL,'G',0.000003,NULL,'14.7',1.2,'SBdm',NULL,NULL,NULL,NULL,1,116.24875,72.81111,0.097,NULL,62182949175,971608580,15181384,14.7),(49899,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49899,35.31,0.56,115,12955,70,NULL,NULL,'2MASX J07450102-5146086',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,116.2542083,-51.769,0.945,NULL,42528960696,664515010,10383047,14.3),(49900,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49900,38.68,0.46,545,12956,70,NULL,NULL,'SDSS J074501.41+413836.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000084,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,116.255875,41.64347,0.189,NULL,63564778394,993199662,15518744,18.6),(49901,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49901,37.23,0.33,279,12957,70,NULL,NULL,'2MASX J07450321+3837265',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000099,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,116.263333,38.62414,0.205,NULL,63564161166,993190018,15518594,16.8),(49902,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49902,37.64,0.46,337,12958,70,NULL,NULL,'2MASX J07450491+3512046',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000111,NULL,'16.8g',0.3,'NLAGN',NULL,NULL,NULL,NULL,1,116.270541667,35.20125,0.253,NULL,63470516070,991726813,15495731,16.8),(49903,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49903,37.9,0.46,380,12959,70,NULL,NULL,'2MASX J07450832+3824155',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000087,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,116.284666667,38.40425,0.177,NULL,63560747240,993136675,15517760,17.6),(49904,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49904,37.63,0.46,335,12960,70,NULL,NULL,'2MASX J07450903+5024200',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000162,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,116.28775,50.40569,0.217,NULL,63517939434,992467803,15507309,17.1),(49905,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49905,36.89,0.46,239,12961,70,NULL,NULL,'2MASX J07450954+2930554',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000189,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,116.2897917,29.51533,0.081,NULL,63431211106,991112673,15486135,17.3),(49906,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49906,34.4,0.47,75.8,12962,NULL,NULL,'H','UGC 04005',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000025,NULL,'14.6',0.4,'Sbc','Pair member (points to parent)',NULL,NULL,NULL,1,116.295667,7.93331,0.117,NULL,62727602645,980118791,15314356,14.6),(49907,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49907,34.47,0.45,78.2,12962,NULL,NULL,'K','UGC 04005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49908,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49908,34.47,0.4,78.3,12962,NULL,NULL,'mean','UGC 04005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49909,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49909,34.53,0.49,80.6,12962,75,NULL,'IR','UGC 04005',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49910,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49910,34.58,0.46,82.6,12962,NULL,NULL,'J','UGC 04005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49911,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49911,36.39,0.19,189,12963,70,NULL,NULL,'2MASX J07451144+2145342',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000168,NULL,'16.0g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,116.297667,21.75964,0.157,NULL,62614483118,978351298,15286739,16),(49912,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49912,33.82,0.4,58.2,12964,NULL,NULL,'mean','UGC 03984',NULL,'2007A&A...465...71T',2007,1,2,NULL,'G',0.000033,NULL,'14.04',0.9,'SB(s)b','Isolated galaxy',NULL,NULL,NULL,1,116.306583,70.03244,0.105,NULL,62208048232,972000753,15187511,14.04),(49913,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49913,33.84,0.47,58.6,12964,NULL,NULL,'H','UGC 03984',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49914,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49914,33.9,0.46,60.3,12964,NULL,NULL,'J','UGC 03984',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49915,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49915,33.97,0.45,62.4,12964,NULL,NULL,'K','UGC 03984',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49916,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49916,37.89,0.46,379,12965,70,NULL,NULL,'SDSS J074513.99+213328.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000158,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,116.3082917,21.55778,0.125,NULL,62613795672,978340557,15286571,18.6),(49917,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49917,38.11,0.46,418,12966,70,NULL,NULL,'2MASX J07451481+2705223',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,116.3117917,27.08956,0.125,NULL,63421237538,990956836,15483700,17.8),(49918,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49918,38.19,0.46,435,12967,70,NULL,NULL,'SDSS J074515.40+244616.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000119,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,116.3142083,24.77122,0.113,NULL,63418052000,990907062,15482922,18.6),(49919,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49919,38.62,0.46,531,12968,70,NULL,NULL,'SDSS J074515.85+465336.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,116.316083333,46.89347,0.245,NULL,63577699242,993401550,15521899,18.3),(49920,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49920,37.77,0.46,359,12969,70,NULL,NULL,'2MASX J07451665+4607585',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,116.3195,46.13289,0.229,NULL,63578173348,993408958,15522014,17.1),(49921,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49921,37.41,0.16,303,12970,70,NULL,NULL,'2MASX J07451682+3354187',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000061,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,116.320208333,33.90531,0.165,NULL,63482728703,991917635,15498713,17.8),(49922,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49922,35.78,NULL,143,12971,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0656',NULL,'2010Ap&SS.325..163P',2010,1,0.81,NULL,'G',0.000103,NULL,'16.4g',0.19,'Sb(f)',NULL,NULL,NULL,NULL,1,116.3295,38.57981,0.217,NULL,63564162414,993190037,15518594,16.4),(49923,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49923,35.81,NULL,145,12971,NULL,NULL,'Dipole','FGC 0656',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49924,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49924,35.81,NULL,145,12971,NULL,NULL,'Dipole + Quadrupole','FGC 0656',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49925,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49925,35.82,NULL,146,12971,NULL,NULL,NULL,'FGC 0656',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49926,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49926,37.3,0.46,289,12972,70,NULL,NULL,'2MASX J07452083+3825515',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000095,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,116.33675,38.43103,0.177,NULL,63560748456,993136694,15517760,17.2),(49927,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49927,38.18,0.46,433,12973,70,NULL,NULL,'2MASX J07452288+4345145',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,116.345417,43.75397,0.173,NULL,63613217752,993956527,15530570,17.8),(49928,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49928,38.56,0.46,515,12974,70,NULL,NULL,'2MASX J07452436+4916289',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,116.3515,49.27458,0.201,NULL,63508826487,992325413,15505084,18.1),(49929,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49929,38.73,0.46,557,12975,70,NULL,NULL,'2MASX J07452446+2330132',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,116.352041667,23.50353,0.145,NULL,63082475964,985663686,15400995,18.4),(49930,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49930,36.55,0.16,204,12976,70,NULL,NULL,'2MASX J07452744+1807429',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000159,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,116.364333,18.12861,0.101,NULL,62617165142,978393205,15287393,17.1),(49931,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49931,36.39,0.19,189,12977,70,NULL,NULL,'2MASX J07453319+2202429',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000172,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,116.388416667,22.04528,0.157,NULL,62614393763,978349902,15286717,16.4),(49932,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49932,37.57,0.23,327,12978,70,NULL,NULL,'2MASX J07453322+4011248',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000106,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,116.388416667,40.19014,0.221,NULL,63563748676,993183573,15518493,16.8),(49933,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49933,36.39,0.19,189,12979,70,NULL,NULL,'2MASX J07453384+2153149',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000165,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,116.3909583,21.88744,0.157,NULL,62614236204,978347440,15286678,16.9),(49934,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49934,37.41,0.16,303,12980,70,NULL,NULL,'2MASX J07453417+3355166',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000124,NULL,'16.3g',0.32,'AGN',NULL,NULL,NULL,NULL,1,116.392333,33.92131,0.157,NULL,63482700285,991917191,15498706,16.3),(49935,'IRAS','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49935,33.83,0.8,58.3,12981,75,NULL,'CF, r','UGC 03991',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000053,NULL,'14.9',0.6,'Sc',NULL,NULL,NULL,NULL,1,116.397875,65.75972,0.129,NULL,62174925152,971483205,15179425,14.9),(49936,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49936,33.17,0.2,43.1,12981,74.4,NULL,NULL,'UGC 03991',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49937,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49937,33.27,0.5,45.1,12981,NULL,NULL,NULL,'UGC 03991',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49938,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49938,33.51,0.45,50.4,12981,NULL,NULL,'Malmquist cor.','UGC 03991',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49939,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49939,34.03,0.38,64,12981,75,NULL,'CF, r, raw','UGC 03991',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49940,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49940,34.08,0.38,65.6,12981,75,NULL,'CF, r, inv','UGC 03991',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49941,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49941,34.12,0.38,66.7,12981,75,NULL,'CF, r, cor','UGC 03991',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49942,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49942,37.41,0.16,303,12982,70,NULL,NULL,'2MASX J07453571+3357466',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000105,NULL,'16.2g',0.39,'BrClG          AGN',NULL,NULL,NULL,NULL,1,116.398875,33.96294,0.157,NULL,63482703768,991917246,15498706,16.2),(49943,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49943,36.55,0.16,204,12983,70,NULL,NULL,'2MASX J07453635+1822099',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000162,NULL,'16.1g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,116.401583,18.36936,0.137,NULL,62617230290,978394223,15287409,16.1),(49944,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49944,37.41,0.16,303,12984,70,NULL,NULL,'2MASX J07453723+3356515',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000068,NULL,'17.6g',0.2,'AGN',NULL,NULL,NULL,NULL,1,116.405125,33.94775,0.157,NULL,63482703842,991917247,15498706,17.6),(49945,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49945,36.78,0.46,227,12985,70,NULL,NULL,'2MASX J07453806+3314127',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,116.408666667,33.23681,0.169,NULL,63477963193,991843174,15497549,17.4),(49946,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49946,37.41,0.16,303,12986,70,NULL,NULL,'2MASX J07453851+3354487',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000097,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,116.4102917,33.91364,0.157,NULL,63482436878,991913076,15498641,17.4),(49947,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49947,36.55,0.16,204,12987,70,NULL,NULL,'2MASX J07453860+1807359',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000197,NULL,'15.4g',0.55,'E0',NULL,NULL,NULL,NULL,1,116.4109583,18.12672,0.101,NULL,62617215228,978393987,15287406,15.4),(49948,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49948,37.41,0.16,303,12988,70,NULL,NULL,'2MASX J07453913+3401477',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000081,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,116.4129583,34.02997,0.165,NULL,63482704018,991917250,15498707,16.9),(49949,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49949,36.55,0.16,204,12989,70,NULL,NULL,'2MASX J07454007+1815149',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,'FoF','15.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,116.417,18.254,0.137,NULL,62617210766,978393918,15287404,15.5),(49950,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49950,36.18,0.46,172,12990,70,NULL,NULL,'2MASX J07454096+4616526',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000155,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,116.4207083,46.28117,0.241,NULL,63578143956,993408499,15522007,16.8),(49951,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49951,36.13,0.46,168,12991,70,NULL,NULL,'2MASX J07454309+3005148',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00017,NULL,'16.2g',0.35,'E0',NULL,NULL,NULL,NULL,1,116.4294583,30.08733,0.105,NULL,63423534100,990992720,15484261,16.2),(49952,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49952,33.38,0.41,47.5,12992,NULL,NULL,NULL,'UGC 04010',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000023,NULL,'14.6',0.4,'Sa?',NULL,NULL,NULL,NULL,1,116.4352083,4.98133,0.145,NULL,62745626944,980400421,15318756,14.6),(49953,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49953,33.42,0.2,48.3,12992,74.4,NULL,NULL,'UGC 04010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49954,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49954,33.65,0.37,53.7,12992,NULL,NULL,'Malmquist cor.','UGC 04010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49955,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49955,35.9,0.46,152,12993,70,NULL,NULL,'SDSS J074547.59+255143.5',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.1g',0.33,'E0',NULL,NULL,NULL,NULL,1,116.448333,25.86208,0.153,NULL,63421684655,990963822,15483809,16.1),(49956,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49956,37.41,0.16,303,12994,70,NULL,NULL,'SDSS J074548.07+340029.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000079,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,116.4502917,34.00819,0.157,NULL,63482707587,991917306,15498707,18.5),(49957,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49957,37.77,0.46,358,12995,70,NULL,NULL,'SDSS J074548.14+345932.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000067,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,116.450583,34.99228,0.277,NULL,63470534008,991727093,15495735,18.3),(49958,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49958,37.41,0.16,303,12996,70,NULL,NULL,'2MASX J07454887+3352368',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00008,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,116.4535417,33.877,0.157,NULL,63482436106,991913064,15498641,17.6),(49959,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49959,35.33,0.46,116,12997,70,NULL,NULL,'2MASX J07454953+3122418',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000074,NULL,'16.0g',0.24,'S0',NULL,NULL,NULL,NULL,1,116.45625,31.37836,0.161,NULL,63479627281,991869176,15497955,16),(49960,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49960,37.64,0.46,337,12998,70,NULL,NULL,'2MASX J07455239+2830582',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,116.4682917,28.51619,0.085,NULL,63433346501,991146039,15486656,17.7),(49961,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49961,37.3,0.46,289,12999,70,NULL,NULL,'2MASX J07455260+1747077',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000196,NULL,'16.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,116.469083333,17.78561,0.105,NULL,62672176460,979252757,15300824,16.5),(49962,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49962,37.92,0.46,384,13000,70,NULL,NULL,'2MASX J07455264+3550138',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000085,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,116.4692083,35.83714,0.205,NULL,63440761286,991261895,15488467,17.5),(49963,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49963,36.89,0.46,239,13001,70,NULL,NULL,'SDSS J074552.65+314510.2',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,116.469375,31.75283,0.153,NULL,63479703940,991870374,15497974,16.9),(49964,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49964,37.57,0.23,327,13002,70,NULL,NULL,'2MASX J07455372+4010137',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000084,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,116.473708333,40.17042,0.217,NULL,63563757736,993183714,15518495,16.9),(49965,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49965,37.57,0.23,327,13003,70,NULL,NULL,'2MASX J07455618+4013217',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000104,NULL,'17.4g',0.24,'NLAGN',NULL,NULL,NULL,NULL,1,116.4842083,40.22275,0.221,NULL,63563732940,993183327,15518489,17.4),(49966,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49966,36.94,0.46,244,13004,70,NULL,NULL,'2MASX J07455640+2322264',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000166,NULL,'16.0g',0.37,'E0',NULL,NULL,NULL,NULL,1,116.484917,23.37389,0.145,NULL,62612637128,978322455,15286288,16),(49967,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49967,36.55,0.16,204,13005,70,NULL,NULL,'SDSS J074556.76+180816.3',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'16.1g',0.39,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,116.486541667,18.13789,0.121,NULL,62617183626,978393494,15287398,16.1),(49968,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49968,39.39,0.46,754,13006,70,NULL,NULL,'SDSS J074558.50+282812.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,116.493917,28.47031,0.085,NULL,63433344445,991146006,15486656,18.5),(49969,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49969,36.13,0.46,168,13007,70,NULL,NULL,'CGCG 206-021',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.0001,NULL,'15.3g',0.61,'E0',NULL,NULL,NULL,NULL,1,116.494708333,41.11939,0.201,NULL,63563184175,993174752,15518355,15.3),(49970,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49970,37.57,0.23,327,13008,70,NULL,NULL,'2MASX J07455896+4010557',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,116.4955,40.182,0.221,NULL,63563744311,993183504,15518492,16.9),(49971,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49971,36.55,0.16,204,13009,70,NULL,NULL,'2MASX J07460093+1809574',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000167,NULL,'16.0g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,116.504041667,18.16597,0.137,NULL,62617189624,978393587,15287399,16),(49972,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49972,36.58,0.1,207,13010,70,NULL,NULL,'2MASX J07460241+1843014',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000172,NULL,'15.6g',0.45,'AGN+SF',NULL,NULL,NULL,NULL,1,116.51,18.71714,0.125,NULL,62620569980,978446405,15288225,15.6),(49973,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49973,36.66,0.46,215,13011,70,NULL,NULL,'2MASX J07460307+3226168',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,116.512917,32.438,0.181,NULL,63479372695,991865198,15497893,16.7),(49974,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49974,35.84,0.46,147,13012,70,NULL,NULL,'CGCG 235-037',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000097,NULL,'15.3g',0.53,'E',NULL,NULL,NULL,NULL,1,116.523,48.84797,0.217,NULL,63509176648,992330885,15505170,15.3),(49975,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49975,38.91,0.46,606,13013,70,NULL,NULL,'SDSS J074605.83+260957.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,116.524333,26.16592,0.097,NULL,63421726321,990964473,15483819,18.5),(49976,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49976,38.75,0.46,563,13014,70,NULL,NULL,'SDSS J074606.03+290405.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000175,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,116.525167,29.06806,0.093,NULL,63434081952,991157530,15486836,18.2),(49977,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49977,37.19,0.15,274,13015,70,NULL,NULL,'2MASX J07460829+3101117',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00018,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,116.534375,31.01994,0.141,NULL,63423976511,990999632,15484369,16.8),(49978,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49978,36.39,0.19,189,13016,70,NULL,NULL,'2MASX J07461034+2200234',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,116.5430417,22.00644,0.157,NULL,62614347114,978349173,15286705,17),(49979,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49979,37.77,0.46,358,13017,70,NULL,NULL,'2MASX J07461185+3035393',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000141,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,116.549416667,30.59436,0.129,NULL,63424163413,991002553,15484414,17.6),(49980,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49980,38.08,0.46,413,13018,70,NULL,NULL,'2MASX J07461310+2601348',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000147,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,116.554708333,26.02653,0.097,NULL,63421740397,990964693,15483823,18.3),(49981,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49981,37.4,0.46,302,13019,70,NULL,NULL,'2MASX J07461421+3525463',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00009,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,116.559083,35.42964,0.253,NULL,63470410591,991725165,15495705,17),(49982,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49982,38.94,0.46,613,13020,70,NULL,NULL,'2MASX J07461465+4330214',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000177,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,116.561125,43.50586,0.177,NULL,63558105835,993095403,15517115,18.2),(49983,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49983,37.41,0.33,303,13021,70,NULL,NULL,'2MASX J07461727+2753418',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00013,NULL,'16.29',0.5,NULL,NULL,NULL,NULL,NULL,1,116.571833333,27.89497,0.085,NULL,63433331213,991145800,15486653,16.29),(49984,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49984,38.15,0.33,427,13022,70,NULL,NULL,'2MASX J07461772+3629466',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000093,NULL,'17.5g',0.24,'AGN',NULL,NULL,NULL,NULL,1,116.5739583,36.49631,0.249,NULL,63440606768,991259480,15488429,17.5),(49985,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49985,37.63,0.46,336,13023,70,NULL,NULL,'2MASX J07461849+4649036',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000182,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,116.577167,46.81761,0.245,NULL,63578184059,993409125,15522017,16.9),(49986,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49986,36.55,0.16,204,13024,70,NULL,NULL,'LSBC F560-04',NULL,'2015arXiv151105856S',2015,1,1.07,NULL,'G',0.000097,NULL,'14.4g',0.72,'BrClG;E_p_/shells',NULL,NULL,NULL,NULL,1,116.5775,18.36869,0.137,NULL,62617274239,978394909,15287420,14.4),(49987,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49987,38.13,0.46,423,13025,70,NULL,NULL,'2MASX J07462117+2547108',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,116.588125,25.78644,0.153,NULL,63418260175,990910315,15482973,17.7),(49988,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49988,37.19,0.15,274,13026,70,NULL,NULL,'2MASX J07462323+3055013',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000175,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,116.596875,30.91706,0.113,NULL,63424021568,991000337,15484380,16.9),(49989,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49989,38.15,0.33,427,13027,70,NULL,NULL,'2MASX J07462427+3628276',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,116.601125,36.47431,0.249,NULL,63440605625,991259462,15488429,18.3),(49990,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49990,35.92,0.7,153,13028,70,NULL,NULL,'2MASX J07462412-8600205',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,116.601166667,-86.00569,0.557,NULL,39739361989,620927531,9701992,16.9),(49991,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49991,37.03,0.46,255,13029,70,NULL,NULL,'2MASX J07462504+1857033',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000158,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,116.604167,18.95097,0.137,NULL,62620725847,978448841,15288263,17.1),(49992,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49992,33.29,0.43,45.5,13030,75,NULL,'3.6 micron, color + selection bias corrected','ESO 560- G 012',NULL,'2014MNRAS.444..527S',2014,1,1.8,'abs(b) < 10 degrees.','G',0.00001,NULL,'15.8',0.5,'SB(s)cd? sp',NULL,NULL,NULL,NULL,1,116.605667,-18.54708,NULL,NULL,39334857503,614607148,9603236,15.8),(49993,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49993,33.48,0.47,49.6,13030,NULL,NULL,'H','ESO 560- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49994,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49994,33.5,0.45,50.2,13030,NULL,NULL,'K','ESO 560- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49995,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49995,33.54,0.4,51,13030,NULL,NULL,'mean','ESO 560- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49996,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49996,33.55,0.46,51.4,13030,NULL,NULL,'J','ESO 560- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(49997,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49997,36.39,0.19,189,13031,70,NULL,NULL,'2MASX J07462643+2202025',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000179,NULL,'16.1g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,116.610291667,22.03403,0.157,NULL,62614323926,978348811,15286700,16.1),(49998,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',49998,36.55,0.16,204,13032,70,NULL,NULL,'2MASX J07462768+1811555',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000181,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,116.615417,18.19881,0.137,NULL,62617240792,978394387,15287412,16.8),(49999,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,49999,35.05,0.4,103,13033,NULL,NULL,'mean','UGC 04003',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.00004,NULL,'14.64',0.7,'Sa:','in a triple',NULL,NULL,NULL,1,116.6189583,58.96256,0.161,NULL,61563112240,961923628,15030056,14.64),(50000,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50000,35.21,0.47,110,13033,NULL,NULL,'H','UGC 04003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50001,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50001,35.26,0.45,113,13033,NULL,NULL,'K','UGC 04003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50002,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50002,35.3,0.46,115,13033,NULL,NULL,'J','UGC 04003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50003,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50003,35.58,0.2,131,13033,74.4,NULL,NULL,'UGC 04003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50004,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50004,37.19,0.15,274,13034,70,NULL,NULL,'2MASX J07463077+3056563',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000164,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,116.628166667,30.94881,0.141,NULL,63424026825,991000419,15484381,17.6),(50005,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50005,37.11,0.46,264,13035,70,NULL,NULL,'2MASX J07463244+3029263',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000218,NULL,'15.8g',0.44,'E0',NULL,NULL,NULL,NULL,1,116.635291667,30.49078,0.129,NULL,63424134172,991002096,15484407,15.8),(50006,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50006,37.19,0.15,274,13036,70,NULL,NULL,'2MASX J07463255+3053403',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000199,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,116.63575,30.8945,0.113,NULL,63424015311,991000239,15484378,16.4),(50007,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50007,37.73,0.46,352,13037,70,NULL,NULL,'2MASX J07463451+3448183',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000099,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,116.6437917,34.80511,0.197,NULL,63481872120,991904251,15498503,17.7),(50008,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 2007R',NULL,50008,35.15,0.17,104,13038,74.2,NULL,'SALT 2','UGC 04008 NED01',0.03088,'2010ApJ...716..712A',2010,1,1.08,NULL,'G',0.00012,NULL,'14.2g',0.68,'S0/a','Pair member (points to parent)',NULL,NULL,NULL,1,116.657125,44.79053,0.169,NULL,63611544477,993930382,15530162,14.2),(50009,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 2007R',NULL,50009,35.52,0.04,123,13038,72,NULL,'MLCS17','UGC 04008 NED01',0.03088,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50010,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 2007R','R',50010,35.63,0.07,134,13038,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 04008 NED01',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50011,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 2007R','R',50011,35.68,0.07,137,13038,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 04008 NED01',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50012,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 2007R',NULL,50012,35.72,0.09,139,13038,74.4,NULL,NULL,'UGC 04008 NED01',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50013,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 2007R',NULL,50013,35.88,0.16,145,13038,65,NULL,'MLCS17','UGC 04008 NED01',0.03088,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50014,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 2007R',NULL,50014,35.9,0.16,147,13038,73.8,NULL,'SALT 2 (SNANA)','UGC 04008 NED01',0.0312,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50015,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 2007R',NULL,50015,35.91,0.16,148,13038,70,NULL,'SALT 2','UGC 04008 NED01',0.03088,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50016,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 2007R',NULL,50016,35.97,0.16,151,13038,65,NULL,'MLCS31','UGC 04008 NED01',0.03088,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50017,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 2007R',NULL,50017,36.03,0.2,156,13038,65,NULL,'SALT2','UGC 04008 NED01',0.03088,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50018,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 2007R',NULL,50018,36.09,0.18,160,13038,65,NULL,'SALT','UGC 04008 NED01',0.03088,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50019,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50019,37.98,0.46,394,13039,70,NULL,NULL,'2MASX J07463823+1750551',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000181,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,116.6592083,17.84875,0.133,NULL,62672072877,979251138,15300799,17.8),(50020,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50020,37.94,0.46,388,13040,70,NULL,NULL,'2MASX J07463831+2729043',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,116.659667,27.48447,0.105,NULL,63419409181,990928268,15483254,17.3),(50021,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50021,37.41,0.33,303,13041,70,NULL,NULL,'2MASX J07463988+2752573',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,116.666333333,27.88275,0.085,NULL,63433195967,991143686,15486620,17.6),(50022,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50022,36.85,0.46,234,13042,70,NULL,NULL,'2MASX J07464293+3604239',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000105,NULL,'16.1g',0.46,'S0^-',NULL,NULL,NULL,NULL,1,116.67875,36.07333,0.225,NULL,63440920021,991264375,15488505,16.1),(50023,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50023,37.08,0.46,261,13043,70,NULL,NULL,'2MASX J07464366+3311522',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,116.681917,33.19783,0.153,NULL,63478146053,991846032,15497594,17.9),(50024,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50024,36.58,0.1,207,13044,70,NULL,NULL,'2MASX J07464370+1835335',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000181,NULL,'16.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,116.682208333,18.59275,0.125,NULL,62620596247,978446816,15288231,16.6),(50025,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50025,37.37,0.46,298,13045,70,NULL,NULL,'SDSS J074644.76+363651.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00007,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,116.686541667,36.61419,0.249,NULL,63440554784,991258668,15488416,18.6),(50026,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50026,37.19,0.15,274,13046,70,NULL,NULL,'2MASX J07464537+3100114',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000186,NULL,'16.2g',0.39,'E0',NULL,NULL,NULL,NULL,1,116.689083,31.00322,0.141,NULL,63424009018,991000140,15484377,16.2),(50027,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50027,37.94,0.46,387,13047,70,NULL,NULL,'2MASX J07464669+2813473',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,116.694667,28.22994,0.073,NULL,63433361752,991146277,15486660,17.9),(50028,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50028,34.31,0.5,72.8,13048,70,NULL,NULL,'ESO 089- G 002',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000087,NULL,'15.6b',0.4,'S0/N',NULL,NULL,NULL,NULL,1,116.700333333,-67.31483,0.641,NULL,40645931660,635092682,9923323,15.6),(50029,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50029,38.17,0.46,431,13049,70,NULL,NULL,'SDSS J074648.14+363738.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00008,NULL,'19.0g',0.1,NULL,NULL,NULL,NULL,NULL,1,116.700583,36.62744,0.237,NULL,63440554268,991258660,15488416,19),(50030,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50030,37.3,0.46,289,13050,70,NULL,NULL,'2MASX J07464976+3154374',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,116.707375,31.91039,0.193,NULL,63479525917,991867592,15497931,17.8),(50031,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50031,37.19,0.15,274,13051,70,NULL,NULL,'2MASX J07464981+3059504',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.0002,NULL,'17.1g',NULL,NULL,NULL,NULL,NULL,NULL,1,116.707625,30.99733,0.141,NULL,63424011746,991000183,15484377,17.1),(50032,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50032,38.02,0.46,403,13052,70,NULL,NULL,'2MASX J07465306+4244475',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000073,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,116.7212083,42.74669,0.201,NULL,63558335536,993098992,15517171,17.8),(50033,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50033,34.6,0.46,83.2,13053,70,NULL,NULL,'IC 2205',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.00015,NULL,'15.2',0.5,NULL,'Group member',NULL,NULL,NULL,1,116.727375,26.87233,0.121,NULL,63419713866,990933029,15483328,15.2),(50034,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50034,34.1,0.4,66,13054,NULL,NULL,'Malmquist cor.','UGC 04025',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.6',0.4,'SBb:',NULL,NULL,NULL,NULL,1,116.733083333,7.29633,0.121,NULL,62724284302,980066942,15313545,14.6),(50035,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50035,34.17,0.38,68.3,13054,NULL,NULL,NULL,'UGC 04025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50036,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50036,34.21,0.2,69.5,13054,74.4,NULL,NULL,'UGC 04025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50037,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50037,34.46,0.47,78.1,13054,NULL,NULL,'H','UGC 04025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50038,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50038,34.5,0.4,79.5,13054,NULL,NULL,'mean','UGC 04025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50039,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50039,34.6,0.45,83.1,13054,NULL,NULL,'K','UGC 04025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50040,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50040,34.61,0.46,83.6,13054,NULL,NULL,'J','UGC 04025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50041,'TRGB','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50041,29.83,0.1,9.25,13055,74.4,NULL,NULL,'MCG +09-13-052',NULL,'2013AJ....146...86T',2013,1,1,'Multiple SDSS entries describe this source.','G',0.000007,NULL,'16.6',0.8,'Ir',NULL,NULL,NULL,NULL,1,116.737333,51.29647,0.201,NULL,63518141715,992470964,15507358,16.6),(50042,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50042,37.84,0.46,369,13056,70,NULL,NULL,'2MASX J07465781+3107584',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000178,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,116.7407917,31.13292,0.189,NULL,63423769366,990996396,15484318,17.3),(50043,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50043,37.19,0.15,274,13057,70,NULL,NULL,'2MASX J07465782+3100264',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000167,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,116.741083,31.00733,0.189,NULL,63423735504,990995867,15484310,17.1),(50044,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50044,36.58,0.1,207,13058,70,NULL,NULL,'2MASX J07470004+1856071',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000183,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,116.750167,18.93539,0.137,NULL,62620927573,978451993,15288312,16.2),(50045,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50045,37.19,0.15,274,13059,70,NULL,NULL,'2MASX J07470046+3059415',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000186,NULL,'16.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,116.751917,30.99492,0.189,NULL,63423735651,990995869,15484310,16.3),(50046,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50046,37.53,0.46,320,13060,70,NULL,NULL,'2MASX J07470151+4959569',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000161,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,116.756375,49.99928,0.253,NULL,63517804485,992465695,15507276,17.3),(50047,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50047,34.08,0.49,65.5,13061,75,NULL,'IR','UGC 04011',NULL,'2011yCatp016004901K',2011,1,1.32,NULL,'G',NULL,NULL,'16.0',0.15,'Scd',NULL,NULL,NULL,NULL,1,116.757083,52.2275,0.193,NULL,63516303094,992442235,15506909,16),(50048,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50048,34.48,NULL,78.7,13061,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50049,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50049,34.51,NULL,79.7,13061,NULL,NULL,'Dipole + Quadrupole','UGC 04011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50050,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50050,34.52,NULL,80.2,13061,NULL,NULL,'Dipole','UGC 04011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50051,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50051,34.53,NULL,80.7,13061,NULL,NULL,NULL,'UGC 04011',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50052,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50052,35.75,0.46,141,13062,70,NULL,NULL,'UGC 04018',NULL,'2015arXiv151105856S',2015,1,0.98,NULL,'G',0.000126,NULL,'14.6g',0.67,'S0','Pair member (points to parent)',NULL,NULL,NULL,1,116.758541667,41.53622,0.197,NULL,63565633113,993213017,15518953,14.6),(50053,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50053,37.74,0.46,353,13063,70,NULL,NULL,'SDSS J074702.58+360426.8',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000079,NULL,'18.9g',0.08,NULL,NULL,NULL,NULL,NULL,1,116.760791667,36.07411,0.205,NULL,63440936440,991264631,15488509,18.9),(50054,'IRAS','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50054,35.29,0.8,114,13064,75,NULL,'A82, H','CGCG 148-016',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000027,NULL,'14.1',0.8,'Sbc',NULL,NULL,NULL,NULL,1,116.7704583,27.94747,0.085,NULL,63433175044,991143360,15486615,14.1),(50055,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50055,34.56,0.33,81.8,13064,91,NULL,'H','CGCG 148-016',NULL,'1984ApJ...278..475B',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50056,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50056,35.47,0.47,124,13064,75,NULL,'A82, H, raw','CGCG 148-016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50057,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50057,35.7,0.47,138,13064,75,NULL,'A82, H, inv','CGCG 148-016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50058,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50058,35.71,0.47,139,13064,75,NULL,'A82, H, cor','CGCG 148-016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50059,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50059,37.19,0.15,274,13065,70,NULL,NULL,'2MASX J07470520+3056125',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000179,NULL,'17.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,116.771625,30.93683,0.129,NULL,63424005318,991000083,15484376,17.2),(50060,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50060,34.29,0.58,72,13066,70,NULL,NULL,'2MASX J07470558-4950236',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,116.77325,-49.83994,0.589,NULL,42529725568,664526962,10383233,15.6),(50061,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50061,35.86,0.46,148,13067,70,NULL,NULL,'CGCG 206-026',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000107,NULL,'15.1g',0.6,'E0',NULL,NULL,NULL,NULL,1,116.782625,43.31403,0.189,NULL,63558073959,993094905,15517107,15.1),(50062,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50062,37.2,0.46,275,13068,70,NULL,NULL,'2MASX J07470861+4023349',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000086,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,116.7857083,40.39297,0.221,NULL,63563140682,993174073,15518344,16.9),(50063,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50063,38.56,0.46,516,13069,70,NULL,NULL,'2MASX J07471270+1537520',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,116.803125,15.63111,0.105,NULL,62640645427,978760084,15293126,17.5),(50064,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50064,36.39,0.19,189,13070,70,NULL,NULL,'2MASX J07471272+2219421',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,116.803208333,22.32833,0.205,NULL,62616498320,978382786,15287231,17.2),(50065,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50065,37.88,0.33,376,13071,70,NULL,NULL,'2MASX J07471664+3923106',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000077,NULL,'17.0g',0.31,NULL,NULL,NULL,NULL,NULL,1,116.819541667,39.38647,0.225,NULL,63564221735,993190964,15518608,17),(50066,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50066,37.79,0.46,361,13072,70,NULL,NULL,'SDSS J074716.78+264823.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000135,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,116.819916667,26.80639,0.121,NULL,63419594617,990931165,15483299,18.2),(50067,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50067,38.21,0.46,439,13073,70,NULL,NULL,'SDSS J074718.15+275619.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.1g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,116.825625,27.93889,0.085,NULL,63433205406,991143834,15486622,18.1),(50068,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50068,37.33,0.46,292,13074,70,NULL,NULL,'2MASX J07471889+2938497',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,116.828667,29.64733,0.129,NULL,63423395949,990990561,15484227,18.1),(50069,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50069,33.02,0.47,40.1,13075,NULL,NULL,'H','NGC 2449',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00001,NULL,'14.26',0.6,'Sab','Group member',NULL,NULL,NULL,1,116.8345,26.93017,0.121,NULL,63419724658,990933197,15483331,14.26),(50070,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50070,33.18,0.46,43.3,13075,NULL,NULL,'J','NGC 2449',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50071,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50071,33.2,0.45,43.7,13075,NULL,NULL,'K','NGC 2449',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50072,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50072,34.18,0.4,68.5,13075,NULL,NULL,'mean','NGC 2449',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50073,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50073,36.57,0.62,206,13076,70,NULL,NULL,'2MASX J07472282-5328197',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,116.844958333,-53.47208,0.705,NULL,40425902665,631654729,9869605,17.4),(50074,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50074,38.38,0.27,474,13077,70,NULL,NULL,'SDSS J074723.27+330340.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.00015,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,116.8469583,33.06128,0.153,NULL,63479893571,991873337,15498020,18.8),(50075,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50075,35.42,0.46,121,13078,70,NULL,NULL,'2MASX J07472348+3911447',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000072,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,116.84775,39.19592,0.225,NULL,63562246523,993160101,15518126,16.4),(50076,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50076,38.04,0.46,405,13079,70,NULL,NULL,'2MASX J07472371+1425135',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,116.848875,14.42047,0.121,NULL,62645788294,978840442,15294381,17.4),(50077,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50077,37.35,0.46,295,13080,70,NULL,NULL,'2MASX J07472413+2902127',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,116.850667,29.03678,0.105,NULL,63433064921,991141639,15486588,17.7),(50078,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50078,37.76,0.46,356,13081,70,NULL,NULL,'2MASX J07472464+3941307',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000074,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,116.852625,39.69192,0.205,NULL,63563819956,993184686,15518510,18.2),(50079,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50079,35.05,0.46,102,13082,70,NULL,NULL,'2MASX J07472514+4355072',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000175,NULL,'15.8g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,116.854917,43.91861,0.173,NULL,63559963417,993124428,15517569,15.8),(50080,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50080,36.06,0.68,163,13083,70,NULL,NULL,'ESO 017- G 006',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'15.0b',1,'SB(rs)b',NULL,NULL,NULL,NULL,1,116.8595,-78.15053,0.633,NULL,39955639605,624306868,9754794,15),(50081,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50081,38.38,0.27,474,13084,70,NULL,NULL,'2MASX J07472669+3256454',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00017,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,116.861416667,32.946,0.161,NULL,63479966901,991874482,15498038,17.9),(50082,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50082,38.38,0.27,474,13085,70,NULL,NULL,'SDSS J074728.62+325551.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,116.8692917,32.93086,0.161,NULL,63479967706,991874495,15498038,18.7),(50083,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50083,35.32,0.47,116,13086,NULL,NULL,'H','UGC 04013',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.00001,NULL,'13.6r',0.7,'SBbc           Sy1.2',NULL,NULL,NULL,'Sy 1',1,116.871375,60.9335,0.181,NULL,61557481520,961835648,15028682,13.6),(50084,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50084,35.38,0.46,119,13086,NULL,NULL,'J','UGC 04013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50085,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50085,35.38,0.45,119,13086,NULL,NULL,'K','UGC 04013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50086,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50086,35.45,0.4,123,13086,NULL,NULL,'mean','UGC 04013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50087,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50087,37.71,0.46,349,13087,70,NULL,NULL,'2MASX J07472916+2934524',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,116.8715,29.58128,0.129,NULL,63425219819,991019059,15484672,17.6),(50088,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50088,39.39,0.46,757,13088,70,NULL,NULL,'2MASX J07472940+4037137',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000088,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,116.872583,40.62044,0.217,NULL,63563125026,993173828,15518341,18.3),(50089,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50089,36.58,0.1,207,13089,70,NULL,NULL,'2MASX J07472960+1834304',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00017,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,116.8732083,18.57517,0.137,NULL,62620681380,978448146,15288252,17.6),(50090,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50090,36.58,0.1,207,13090,70,NULL,NULL,'2MASX J07472960+1822424',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000166,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,116.8732917,18.3785,0.137,NULL,62620498364,978445286,15288207,17.4),(50091,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50091,36.58,0.1,207,13091,70,NULL,NULL,'2MASX J07472974+1845144',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000167,NULL,'16.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,116.873916667,18.75403,0.153,NULL,62620524453,978445694,15288213,16.6),(50092,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50092,37.42,0.46,305,13092,70,NULL,NULL,'SDSS J074731.90+161432.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000096,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,116.882917,16.24225,0.069,NULL,62640314665,978754916,15293045,18.3),(50093,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50093,37.58,0.46,327,13093,70,NULL,NULL,'2MASX J07473223+1516475',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,116.884166667,15.27989,0.101,NULL,62640475800,978757434,15293084,17.1),(50094,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50094,37.06,0.46,259,13094,70,NULL,NULL,'2MASX J07473320+3720457',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000083,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,116.8885417,37.34614,0.213,NULL,63442959872,991296248,15489003,16.6),(50095,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50095,37.58,0.46,327,13095,70,NULL,NULL,'2MASX J07473349+2030274',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000158,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,116.8895417,20.50761,0.133,NULL,62628191588,978565493,15290085,17.4),(50096,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50096,37.6,0.46,331,13096,70,NULL,NULL,'2MASX J07473416+1800544',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,116.892417,18.01517,0.121,NULL,62671825019,979247265,15300738,17.2),(50097,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50097,37.47,0.46,311,13097,70,NULL,NULL,'2MASX J07473631+3730157',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000083,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,116.901167,37.5045,0.197,NULL,63442976297,991296504,15489007,17),(50098,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50098,37.88,0.33,376,13098,70,NULL,NULL,'2MASX J07474111+3911357',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000088,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,116.921417,39.19344,0.201,NULL,63562248825,993160137,15518127,18.1),(50099,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50099,37.44,0.33,307,13099,70,NULL,NULL,'2MASX J07474206+3101314',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000159,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,116.9252083,31.0255,0.129,NULL,63423850072,990997657,15484338,17.1),(50100,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50100,38.56,0.46,516,13100,70,NULL,NULL,'2MASX J07474912+1531516',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,116.9547083,15.53092,0.065,NULL,62640864109,978763501,15293179,17.7),(50101,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50101,36.58,0.1,207,13101,70,NULL,NULL,'2MASX J07475119+1833073',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000179,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,116.963208333,18.55203,0.153,NULL,62620679226,978448112,15288251,16.3),(50102,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50102,32.8,0.46,36.4,13102,NULL,NULL,'J','ESO 560- G 013',NULL,'2007A&A...465...71T',2007,1,2.7,'abs(b) < 10 degrees.','G',0.00001,NULL,'14.5',0.4,'SB(s)bc?',NULL,NULL,NULL,NULL,1,116.966875,-18.749,NULL,NULL,39337786463,614652913,9603951,14.5),(50103,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50103,32.86,0.49,37.4,13102,75,NULL,'IR','ESO 560- G 013',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50104,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50104,32.9,0.47,38,13102,NULL,NULL,'H','ESO 560- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50105,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50105,33.01,0.45,40,13102,NULL,NULL,'K','ESO 560- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50106,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50106,33.5,0.4,50.1,13102,NULL,NULL,'mean','ESO 560- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50107,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50107,33.56,0.43,51.6,13102,75,NULL,'3.6 micron, color + selection bias corrected','ESO 560- G 013',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50108,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50108,39.14,0.46,672,13103,70,NULL,NULL,'2MASX J07475260+4820501',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000166,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,116.9692083,48.34714,0.293,NULL,63510116875,992345576,15505399,18.3),(50109,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50109,37.44,0.33,307,13104,70,NULL,NULL,'2MASX J07475270+3104097',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,116.96975,31.06931,0.189,NULL,63423849142,990997642,15484338,17.1),(50110,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50110,36.58,0.1,207,13105,70,NULL,NULL,'SDSS J074754.92+182542.1',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.2g',0.37,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,116.978875,18.42839,0.153,NULL,62620466878,978444794,15288199,16.2),(50111,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50111,34.39,0.46,75.5,13106,70,NULL,NULL,'CGCG 148-023',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00015,NULL,'15.5',0.3,NULL,NULL,NULL,NULL,NULL,1,116.990708333,28.16939,0.073,NULL,63433458154,991147783,15486684,15.5),(50112,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50112,35,0.4,100,13107,NULL,NULL,'mean','UGC 04020',NULL,'2007A&A...465...71T',2007,1,2,NULL,'G',0.000033,NULL,'14.15',1,'SABb','in a triple',NULL,NULL,NULL,1,116.994625,59.0145,0.125,NULL,61563100519,961923445,15030053,14.15),(50113,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50113,35.3,0.47,115,13107,NULL,NULL,'H','UGC 04020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50114,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50114,36.58,0.1,207,13108,70,NULL,NULL,'2MASX J07475896+1834010',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000175,NULL,'16.3g',0.41,NULL,NULL,NULL,NULL,NULL,1,116.9957083,18.56692,0.153,NULL,62620665716,978447901,15288248,16.3),(50115,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50115,36.58,0.1,207,13109,70,NULL,NULL,'2MASX J07480078+1837200',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,117.0032083,18.62217,0.153,NULL,62620546694,978446042,15288219,16.9),(50116,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50116,33.74,NULL,56.1,13110,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 148-025',NULL,'2010Ap&SS.325..163P',2010,1,1.23,NULL,'G',0.000007,NULL,'15.6',0.12,'Sd',NULL,NULL,NULL,NULL,1,117.010833,28.40556,0.081,NULL,63433598434,991149975,15486718,15.6),(50117,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50117,33.77,NULL,56.9,13110,NULL,NULL,'Dipole + Quadrupole','CGCG 148-025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50118,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50118,33.79,NULL,57.2,13110,NULL,NULL,'Dipole','CGCG 148-025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50119,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50119,33.88,0.43,59.7,13110,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 148-025',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50120,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50120,33.89,NULL,60,13110,NULL,NULL,NULL,'CGCG 148-025',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50121,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50121,38.36,0.46,470,13111,70,NULL,NULL,'2MASX J07480502+4727393',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,117.020875,47.46086,0.245,NULL,63506649003,992291390,15504552,18.5),(50122,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50122,35.42,0.46,122,13112,70,NULL,NULL,'CGCG 118-008',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.00017,NULL,'15.5g',0.62,'S0/a',NULL,NULL,NULL,NULL,1,117.0222083,22.90078,0.201,NULL,62613378052,978334032,15286469,15.5),(50123,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50123,37.45,0.46,309,13113,70,NULL,NULL,'2MASX J07480652+2534062',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000167,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,117.027167,25.56836,0.129,NULL,63418353829,990911778,15482996,16.9),(50124,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50124,36.68,0.46,217,13114,70,NULL,NULL,'2MASX J07480652+4005065',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000064,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,117.027333333,40.08514,0.217,NULL,63563675609,993182431,15518475,17.6),(50125,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50125,36.24,0.46,177,13115,70,NULL,NULL,'2MASX J07480847+4706512',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,117.03525,47.11419,0.253,NULL,63506865274,992294769,15504605,17.3),(50126,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50126,37.83,0.46,368,13116,70,NULL,NULL,'2MASX J07480866+3247177',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000161,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,117.036083,32.78836,0.161,NULL,63479941060,991874079,15498032,18.5),(50127,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50127,37.52,0.46,319,13117,70,NULL,NULL,'2MASX J07480921+5025141',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,117.03825,50.42044,0.237,NULL,63517869347,992466708,15507292,17.8),(50128,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50128,36.58,0.1,207,13118,70,NULL,NULL,'2MASX J07480930+1845230',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000176,NULL,'16.0g',0.42,'S0',NULL,NULL,NULL,NULL,1,117.0387917,18.75628,0.153,NULL,62620510650,978445478,15288210,16),(50129,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50129,36.58,0.1,207,13119,70,NULL,NULL,'2MASX J07480965+1831330',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000173,NULL,'15.9g',0.42,'E0',NULL,NULL,NULL,NULL,1,117.040083333,18.526,0.153,NULL,62620532873,978445826,15288216,15.9),(50130,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50130,38.24,0.46,444,13120,70,NULL,NULL,'2MASX J07481129+3256187',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000152,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,117.0470417,32.93847,0.161,NULL,63479924301,991873817,15498028,17.6),(50131,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50131,36.58,0.1,207,13121,70,NULL,NULL,'2MASX J07481126+1829460',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000203,NULL,'16.1g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,117.047083,18.49617,0.153,NULL,62620451069,978444547,15288196,16.1),(50132,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50132,37.6,0.46,331,13122,70,NULL,NULL,'2MASX J07481461+1759240',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,117.0610417,17.99,0.133,NULL,62674707736,979292308,15301442,17.8),(50133,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50133,35.18,0.2,109,13123,74.4,NULL,NULL,'FGC 0661',NULL,'2013AJ....146...86T',2013,1,0.72,NULL,'G',0.000012,NULL,'17.0',0.1,'Scd',NULL,NULL,NULL,NULL,1,117.065833,28.71528,0.085,NULL,63432997804,991140590,15486571,17),(50134,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50134,35.19,NULL,109,13123,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0661',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50135,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50135,35.21,NULL,110,13123,NULL,NULL,'Dipole + Quadrupole','FGC 0661',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50136,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50136,35.21,NULL,110,13123,NULL,NULL,'Dipole','FGC 0661',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50137,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50137,35.28,NULL,114,13123,NULL,NULL,NULL,'FGC 0661',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50138,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50138,35.5,0.43,126,13123,75,NULL,'3.6 micron, color corrected','FGC 0661',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50139,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50139,35.87,0.43,149,13123,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0661',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50140,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50140,36.58,0.1,207,13124,70,NULL,NULL,'2MASX J07481668+1834430',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00018,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,117.0695,18.57856,0.153,NULL,62620533894,978445842,15288216,16.6),(50141,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50141,36.58,0.1,207,13125,70,NULL,NULL,'2MASX J07481790+1857330',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000169,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,117.074583,18.95922,0.153,NULL,62620044235,978438191,15288096,16.7),(50142,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50142,36.75,0.46,224,13126,70,NULL,NULL,'2MASX J07481886+1835340',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00018,NULL,'16.2g',0.38,'E0',NULL,NULL,NULL,NULL,1,117.078583,18.59286,0.153,NULL,62618498104,978414032,15287719,16.2),(50143,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50143,33.66,0.2,54,13127,74.4,NULL,NULL,'UGC 04029',NULL,'2013AJ....146...86T',2013,1,2.3,NULL,'G',0.000033,NULL,'14.42',0.5,'SBbc:          LLIRG',NULL,NULL,NULL,NULL,1,117.079,34.33231,0.157,NULL,63477899255,991842175,15497533,14.42),(50144,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50144,33.69,0.49,54.7,13127,75,NULL,'IR','UGC 04029',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50145,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50145,33.89,0.31,59.9,13127,NULL,NULL,NULL,'UGC 04029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50146,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50146,33.91,0.47,60.4,13127,NULL,NULL,'H','UGC 04029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50147,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50147,33.96,0.45,61.9,13127,NULL,NULL,'K','UGC 04029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50148,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50148,33.97,0.3,62.3,13127,NULL,NULL,'Malmquist cor.','UGC 04029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50149,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50149,33.99,0.4,62.9,13127,NULL,NULL,'mean','UGC 04029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50150,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50150,34.02,0.46,63.6,13127,NULL,NULL,'J','UGC 04029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50151,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50151,38.11,0.46,420,13128,70,NULL,NULL,'2MASX J07482028+2542342',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,117.0845,25.70961,0.129,NULL,63418185419,990909147,15482955,18),(50152,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50152,36.58,0.1,207,13129,70,NULL,NULL,'SDSS J074820.38+182802.5',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.9g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,117.0849583,18.46739,0.153,NULL,62618370577,978412040,15287688,16.9),(50153,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50153,36.58,0.1,207,13130,70,NULL,NULL,'SDSS J074820.40+183229.9',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,117.085,18.54164,0.153,NULL,62618488226,978413878,15287716,17.6),(50154,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50154,37.17,0.46,271,13131,70,NULL,NULL,'2MASXi J0748216+175433',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00017,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,117.0902917,17.90919,0.133,NULL,62674754711,979293042,15301453,17.4),(50155,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50155,35.82,0.27,146,13132,70,NULL,NULL,'2MASX J07482250+4346502',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000068,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,117.093791667,43.78047,0.177,NULL,63559976944,993124639,15517572,17),(50156,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50156,36.58,0.1,207,13133,70,NULL,NULL,'2MASX J07482272+1830100',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000198,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,117.0947083,18.50289,0.153,NULL,62618550814,978414856,15287732,17.1),(50157,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50157,37.89,0.46,378,13134,70,NULL,NULL,'SDSS J074826.32+314505.4',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000135,NULL,'18.9g',0.11,NULL,NULL,NULL,NULL,NULL,1,117.1097083,31.7515,0.153,NULL,63479198365,991862474,15497851,18.9),(50158,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50158,38.01,0.46,400,13135,70,NULL,NULL,'SDSS J074827.27+503836.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000168,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,117.113625,50.64358,0.265,NULL,63518289606,992473275,15507394,18),(50159,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50159,38.48,0.46,496,13136,70,NULL,NULL,'2MASX J07482729+1718410',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,117.113708333,17.31133,0.129,NULL,62675261326,979300958,15301577,17.8),(50160,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50160,37.12,0.46,265,13137,70,NULL,NULL,'2MASX J07482753+3001549',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000178,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,117.114833,30.03197,0.141,NULL,63425431785,991022371,15484724,17.2),(50161,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50161,38.33,0.46,464,13138,70,NULL,NULL,'2MASX J07482852+2232560',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,117.118708333,22.54883,0.205,NULL,62616504756,978382886,15287232,17.5),(50162,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50162,37.84,0.46,371,13139,70,NULL,NULL,'2MASX J07482931+2706432',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000162,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,117.1222083,27.11186,0.081,NULL,63419951433,990936741,15483386,18.4),(50163,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50163,38.11,0.46,418,13140,70,NULL,NULL,'2MASX J07482978+1650200',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000047,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,117.12425,16.83897,0.117,NULL,62675047235,979297613,15301525,17.9),(50164,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50164,36.76,0.46,225,13141,70,NULL,NULL,'2MASX J07483054+1751430',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000178,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,117.1272917,17.86197,0.133,NULL,62674736338,979292755,15301449,16.6),(50165,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50165,37.07,0.46,260,13142,70,NULL,NULL,'2MASX J07483067+2245401',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000175,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,117.127833,22.76125,0.165,NULL,62613234397,978331787,15286434,16.7),(50166,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50166,37.17,0.46,272,13143,70,NULL,NULL,'2MASX J07483152+2942441',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000142,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,117.131416667,29.71239,0.129,NULL,63425238263,991019347,15484677,17.7),(50167,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50167,36.34,0.46,185,13144,70,NULL,NULL,'2MASX J07483279+4602292',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000182,NULL,'16.0g',0.38,'E0',NULL,NULL,NULL,NULL,1,117.13675,46.04139,0.225,NULL,63577307307,993395426,15521803,16),(50168,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50168,32.33,0.4,29.2,13145,NULL,NULL,NULL,'UGC 04024',NULL,'2009AJ....138..323T',2009,1,1.5,NULL,'G',0.000037,NULL,'14.78',0.4,'Scd:',NULL,NULL,NULL,NULL,1,117.138625,62.20739,0.157,NULL,61556583369,961821615,15028462,14.78),(50169,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50169,32.58,0.2,32.8,13145,74.4,NULL,NULL,'UGC 04024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50170,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50170,32.63,0.43,33.6,13145,75,NULL,'3.6 micron, color corrected','UGC 04024',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50171,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50171,32.63,0.43,33.6,13145,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04024',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50172,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50172,32.71,0.55,34.8,13145,NULL,NULL,NULL,'UGC 04024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50173,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50173,32.73,0.4,35.2,13145,75,NULL,NULL,'UGC 04024',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50174,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50174,32.75,0.54,35.6,13145,NULL,NULL,'Malmquist cor.','UGC 04024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50175,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50175,33.04,0.49,40.6,13145,75,NULL,'IR','UGC 04024',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50176,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50176,37.27,0.46,285,13146,70,NULL,NULL,'2MASX J07483491+2725521',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,117.145417,27.43111,0.093,NULL,63419895525,990935867,15483372,16.8),(50177,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50177,35.07,NULL,103,13147,NULL,NULL,'Dipole','UGC 04032',NULL,'2010Ap&SS.325..163P',2010,1,1.27,NULL,'G',0.000009,NULL,'16.2g',0.21,'Sc',NULL,NULL,NULL,NULL,1,117.1462917,30.15439,0.141,NULL,63425377152,991021518,15484711,16.2),(50178,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50178,35.07,NULL,103,13147,NULL,NULL,'Dipole + Quadrupole','UGC 04032',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50179,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50179,35.07,NULL,103,13147,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04032',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50180,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50180,35.16,NULL,108,13147,NULL,NULL,NULL,'UGC 04032',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50181,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50181,35.32,0.49,116,13147,75,NULL,'IR','UGC 04032',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50182,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50182,35.39,0.41,120,13147,NULL,NULL,'Malmquist cor.','UGC 04032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50183,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50183,35.43,0.43,122,13147,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04032',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50184,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50184,35.45,0.43,123,13147,75,NULL,'3.6 micron, color corrected','UGC 04032',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50185,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50185,35.53,0.2,128,13147,74.4,NULL,NULL,'UGC 04032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50186,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50186,35.64,0.37,134,13147,NULL,NULL,NULL,'UGC 04032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50187,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50187,37.54,0.46,322,13148,70,NULL,NULL,'2MASX J07483553+2546231',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000132,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,117.148125,25.77294,0.129,NULL,63418176862,990909013,15482953,17.6),(50188,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50188,37.45,0.15,309,13149,70,NULL,NULL,'2MASX J07483678+5213198',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000205,NULL,'16.0g',0.42,'E',NULL,NULL,NULL,NULL,1,117.153125,52.22222,0.169,NULL,63516037465,992438085,15506845,16),(50189,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50189,37.06,0.46,259,13150,70,NULL,NULL,'2MASX J07483777+4647052',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000138,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,117.15725,46.78489,0.245,NULL,63506153122,992283642,15504431,18),(50190,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50190,35.82,0.27,146,13151,70,NULL,NULL,'2MASX J07483813+4356422',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000066,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,117.158875,43.94514,0.141,NULL,63560008643,993125135,15517580,16.9),(50191,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50191,37.93,0.46,385,13152,70,NULL,NULL,'2MASX J07483869+3450420',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000143,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,117.16125,34.84508,0.181,NULL,63445145990,991330406,15489537,18.2),(50192,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50192,38.53,0.46,508,13153,70,NULL,NULL,'2MASX J07483905+2934491',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000191,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,117.1627083,29.58042,0.117,NULL,63424731944,991011436,15484553,17.7),(50193,'IRAS','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50193,34.46,0.8,77.9,13154,75,NULL,'CF, r','NGC 2446',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.00002,NULL,'13.73',1,'Sb',NULL,NULL,NULL,NULL,1,117.1635,54.61192,0.137,NULL,61577895843,962154622,15033665,13.73),(50194,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50194,34.05,0.38,64.6,13154,75,NULL,'CF, r, raw','NGC 2446',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50195,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50195,34.11,0.45,66.4,13154,NULL,NULL,'K','NGC 2446',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50196,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50196,34.12,0.47,66.6,13154,NULL,NULL,'H','NGC 2446',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50197,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50197,34.16,0.46,67.8,13154,NULL,NULL,'J','NGC 2446',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50198,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50198,34.25,0.38,70.8,13154,75,NULL,'CF, r, inv','NGC 2446',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50199,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50199,34.43,0.38,76.9,13154,75,NULL,'CF, r, cor','NGC 2446',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50200,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50200,34.49,0.4,79.2,13154,NULL,NULL,'mean','NGC 2446',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50201,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50201,37.61,0.46,333,13155,70,NULL,NULL,'2MASX J07483993+1916561',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00014,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,117.166375,19.28219,0.129,NULL,62620123563,978439430,15288116,18),(50202,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50202,36.58,0.1,207,13156,70,NULL,NULL,'2MASX J07484048+1837241',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,117.168875,18.62333,0.153,NULL,62618526791,978414481,15287726,17.1),(50203,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50203,37.1,0.46,262,13157,70,NULL,NULL,'SDSS J074840.65+432139.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000064,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,117.169417,43.36092,0.189,NULL,63558054756,993094605,15517103,18.2),(50204,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50204,38.5,0.46,501,13158,70,NULL,NULL,'2MASX J07484151+2826471',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,117.173,28.44636,0.081,NULL,63433519095,991148735,15486698,17.4),(50205,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50205,36.63,0.33,212,13159,70,NULL,NULL,'2MASX J07484177+1919201',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000178,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,117.1739583,19.32208,0.129,NULL,62619946945,978436671,15288072,17.1),(50206,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50206,37.42,0.46,305,13160,70,NULL,NULL,'SDSS J074842.58+173450.6',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,117.1774583,17.58075,0.145,NULL,62674954435,979296163,15301502,17.2),(50207,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50207,38.27,0.46,450,13161,70,NULL,NULL,'2MASX J07484263+2128331',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000171,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,117.177667,21.47592,0.149,NULL,62614112038,978345500,15286648,18),(50208,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50208,31.36,0.47,18.7,13162,NULL,NULL,'H','ESO 493- G 016',NULL,'2007A&A...465...71T',2007,1,0.9,'abs(b) < 10 degrees.','G',0.00001,':','16.0',0.4,'Sb-c',NULL,NULL,NULL,NULL,1,117.182833,-26.24642,NULL,NULL,42549383202,664834112,10388033,16),(50209,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50209,31.37,0.45,18.8,13162,NULL,NULL,'K','ESO 493- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50210,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50210,31.71,0.46,21.9,13162,NULL,NULL,'J','ESO 493- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50211,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50211,32.81,0.4,36.5,13162,NULL,NULL,'mean','ESO 493- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50212,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50212,36.85,0.46,234,13163,70,NULL,NULL,'2MASX J07484437+3903329',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,117.185,39.05917,0.197,NULL,63562220143,993159689,15518120,17.3),(50213,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50213,36.58,0.1,207,13164,70,NULL,NULL,'2MASX J07484488+1757581',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000158,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,117.186917,17.96608,0.153,NULL,62673710717,979276729,15301198,16.8),(50214,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 2002aa','R',50214,42.9,NULL,1960,13165,65,NULL,'SALT','H-ZSNS J074845.28+101800.8',0.946,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,117.188667,10.30022,0.029,NULL,62762044560,980656946,15322764,NULL),(50215,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 2002aa',NULL,50215,43.16,0.81,2200,13165,70,NULL,'SALT','H-ZSNS J074845.28+101800.8',0.946,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50216,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 2002aa',NULL,50216,43.24,0.88,2280,13165,65,NULL,'SALT','H-ZSNS J074845.28+101800.8',0.946,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50217,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 2002aa',NULL,50217,43.86,0.2,3040,13165,72,NULL,'BATM','H-ZSNS J074845.28+101800.8',0.946,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50218,'SNIa','2016-12-15 15:14:17','2016-12-16 11:19:23','1','SN 2002aa',NULL,50218,43.89,0.55,3080,13165,72,NULL,'MLCS','H-ZSNS J074845.28+101800.8',0.946,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50219,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50219,38.32,0.46,461,13166,70,NULL,NULL,'SDSS J074845.94+254205.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000137,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,117.1914583,25.70153,0.129,NULL,64290845696,1004544464,15696007,18.3),(50220,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50220,38.04,0.46,406,13167,70,NULL,NULL,'SDSS J074846.59+464714.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000167,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,117.194125,46.78725,0.329,NULL,63506152703,992283635,15504431,18.6),(50221,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50221,37.82,0.46,367,13168,70,NULL,NULL,'SDSS J074847.16+153731.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000131,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,117.196541667,15.62547,0.065,NULL,62640797317,978762458,15293163,18.5),(50222,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50222,36.73,0.23,222,13169,70,NULL,NULL,'2MASX J07484881+3150459',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00017,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,117.203208333,31.84606,0.161,NULL,63479185703,991862276,15497848,16.3),(50223,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50223,36.58,0.1,207,13170,70,NULL,NULL,'2MASX J07485141+1806280',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000193,NULL,'15.9g',0.42,NULL,NULL,NULL,NULL,NULL,1,117.2142083,18.10775,0.153,NULL,62673686911,979276357,15301193,15.9),(50224,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50224,35.35,0.49,117,13171,75,NULL,'IR','FGC 0663',NULL,'2011yCatp016004901K',2011,1,1.07,NULL,'G',0.000036,NULL,'16.1g',0.19,'Sd(f)',NULL,NULL,NULL,NULL,1,117.215167,36.39036,0.241,NULL,63440356818,991255575,15488368,16.1),(50225,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50225,35.58,NULL,131,13171,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0663',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50226,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50226,35.6,NULL,132,13171,NULL,NULL,'Dipole + Quadrupole','FGC 0663',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50227,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50227,35.61,NULL,132,13171,NULL,NULL,'Dipole','FGC 0663',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50228,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50228,35.63,0.43,134,13171,75,NULL,'3.6 micron, color corrected','FGC 0663',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50229,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50229,35.63,NULL,134,13171,NULL,NULL,NULL,'FGC 0663',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50230,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50230,35.66,0.2,136,13171,74.4,NULL,NULL,'FGC 0663',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50231,'Tully-Fisher','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50231,35.68,0.43,137,13171,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0663',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50232,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50232,37.19,0.46,274,13172,70,NULL,NULL,'2MASXi J0748518+174545',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,117.216167,17.76269,0.145,NULL,62674733182,979292705,15301448,17.8),(50233,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,NULL,50233,35.41,0.53,121,13173,70,NULL,NULL,'2MASX J07485295-6947580',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.7I',0.5,NULL,NULL,NULL,NULL,NULL,1,117.2205,-69.79956,0.601,NULL,40653470369,635210474,9925163,13.7),(50234,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50234,34.57,0.33,81.9,13174,70,NULL,NULL,'CGCG 118-010',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.00015,NULL,'14.6g',0.49,'S0',NULL,NULL,NULL,NULL,1,117.22175,21.74753,0.149,NULL,62615897708,978373401,15287084,14.6),(50235,'FP','2016-12-15 15:14:17','2016-12-16 11:19:23','1',NULL,'R',50235,37.25,0.46,282,13175,70,NULL,NULL,'2MASX J07485358+3014459',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000173,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,117.2232083,30.24611,0.141,NULL,63425409452,991022022,15484719,17.4),(50236,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50236,38.8,0.46,577,13176,70,NULL,NULL,'2MASX J07485469+5016438',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,117.227833,50.27892,0.237,NULL,63515030729,992422355,15506599,NULL),(50237,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50237,37.45,0.15,309,13177,70,NULL,NULL,'2MASX J07485524+5204488',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00019,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,117.230125,52.08017,0.169,NULL,63516032611,992438009,15506843,16.8),(50238,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:23','1','SN 2002ab',NULL,50238,40.85,0.25,1040,13178,74.2,NULL,'SALT 2','H-ZSNS J074855.70+100606.3',0.423,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,117.232083,10.10175,0.029,NULL,62762253385,980660209,15322815,NULL),(50239,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:23','1','SN 2002ab','R',50239,41.1,NULL,1170,13178,65,NULL,'SALT','H-ZSNS J074855.70+100606.3',0.423,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50240,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:23','1','SN 2002ab',NULL,50240,41.55,0.15,1430,13178,72,NULL,'BATM','H-ZSNS J074855.70+100606.3',0.423,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50241,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:23','1','SN 2002ab',NULL,50241,41.61,0.24,1480,13178,70,NULL,'SALT','H-ZSNS J074855.70+100606.3',0.423,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50242,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:23','1','SN 2002ab',NULL,50242,41.76,0.22,1580,13178,65,NULL,'SALT','H-ZSNS J074855.70+100606.3',0.423,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50243,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:23','1','SN 2002ab',NULL,50243,41.78,0.19,1600,13178,72,NULL,'dm15','H-ZSNS J074855.70+100606.3',0.423,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50244,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:23','1','SN 2002ab',NULL,50244,41.87,0.19,1660,13178,72,NULL,'MLCS','H-ZSNS J074855.70+100606.3',0.423,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50245,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:23','1','SN 2002ab',NULL,50245,42.02,0.17,1780,13178,65,NULL,NULL,'H-ZSNS J074855.70+100606.3',0.423,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50246,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50246,36.58,0.1,207,13179,70,NULL,NULL,'2MASX J07485723+1806590',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000188,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,117.2385,18.11631,0.153,NULL,62673689988,979276406,15301193,16.7),(50247,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50247,38.15,0.46,427,13180,70,NULL,NULL,'SDSS J074857.85+185920.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000134,NULL,'18.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,117.241083,18.989,0.153,NULL,62618195040,978409297,15287645,18.9),(50248,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50248,37.45,0.15,309,13181,70,NULL,NULL,'2MASX J07490044+5202557',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00017,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,117.2517917,52.04878,0.173,NULL,63516030120,992437970,15506843,16.9),(50249,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50249,32.6,0.47,33.1,13182,NULL,NULL,'H','ESO 493- G 017',NULL,'2007A&A...465...71T',2007,1,0.45,'Forms a pair with CGMW 2-1310.','G',0.000033,NULL,'16.8',0.28,'Sa-b',NULL,NULL,NULL,NULL,1,117.2557083,-26.24531,NULL,NULL,42549387086,664834173,10388033,16.8),(50250,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50250,32.62,0.45,33.4,13182,NULL,NULL,'K','ESO 493- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50251,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50251,32.66,0.4,34,13182,NULL,NULL,'mean','ESO 493- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50252,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50252,32.72,0.46,35,13182,NULL,NULL,'J','ESO 493- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50253,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50253,35.47,0.33,124,13183,70,NULL,NULL,'2MASX J07490147+2857340',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.91',0.4,NULL,NULL,NULL,NULL,NULL,1,117.2562917,28.95939,0.089,NULL,63432974962,991140233,15486566,16.91),(50254,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50254,37.16,0.11,271,13184,70,NULL,NULL,'SDSS J074903.37+293612.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,117.264083333,29.6035,0.117,NULL,63424728688,991011385,15484552,18.1),(50255,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50255,37.71,0.46,349,13185,70,NULL,NULL,'2MASX J07490427+1758187',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,117.2677917,17.97178,0.153,NULL,62673702790,979276606,15301196,17.6),(50256,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50256,37.45,0.15,309,13186,70,NULL,NULL,'2MASX J07490555+5210128',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,117.272875,52.17028,0.169,NULL,63516023597,992437868,15506841,17),(50257,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50257,36.73,0.23,222,13187,70,NULL,NULL,'2MASX J07490621+3156220',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,117.275791667,31.93942,0.161,NULL,63480153759,991877402,15498084,17.2),(50258,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50258,38.19,0.46,435,13188,70,NULL,NULL,'SDSS J074906.53+291818.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000121,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,117.27725,29.30517,0.105,NULL,63424932719,991014573,15484602,18.6),(50259,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50259,39.02,0.46,637,13189,70,NULL,NULL,'SDSS J074907.51+255125.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000144,NULL,'18.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,117.281333,25.85717,0.129,NULL,64290820876,1004544076,15696001,18.9),(50260,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50260,34.94,0.19,97.5,13190,70,NULL,NULL,'KUG 0745+502',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'15.8g',0.42,'Compact',NULL,NULL,NULL,NULL,1,117.284083333,50.07778,0.253,NULL,63515097211,992423393,15506615,15.8),(50261,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50261,36.97,0.46,248,13191,70,NULL,NULL,'2MASX J07491031+3313021',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000196,NULL,'16.0g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,117.2929583,33.21714,0.153,NULL,63479873933,991873030,15498016,16),(50262,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50262,36.98,0.46,248,13192,70,NULL,NULL,'2MASX J07491081+3450201',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000079,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,117.295083,34.83908,0.181,NULL,63445200803,991331262,15489550,17.3),(50263,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50263,36.73,0.23,222,13193,70,NULL,NULL,'2MASX J07491210+3154380',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000197,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,117.300625,31.91067,0.161,NULL,63480221027,991878453,15498100,16.5),(50264,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50264,32.45,0.47,30.9,13194,NULL,NULL,'H','ESO 493- G 018',NULL,'2007A&A...465...71T',2007,1,0.6,'abs(b) < 10 degrees.','G',0.00008,NULL,'16.1',0.4,'Sa-b',NULL,NULL,NULL,NULL,1,117.301333,-26.39317,NULL,NULL,42549443305,664835051,10388047,16.1),(50265,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50265,32.5,0.45,31.6,13194,NULL,NULL,'K','ESO 493- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50266,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50266,32.51,0.46,31.8,13194,NULL,NULL,'J','ESO 493- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50267,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50267,32.82,0.4,36.6,13194,NULL,NULL,'mean','ESO 493- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50268,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50268,38.32,0.46,461,13195,70,NULL,NULL,'2MASX J07491235+1802486',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,117.301333,18.04678,0.153,NULL,62673698310,979276536,15301195,18.3),(50269,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50269,37.11,0.46,265,13196,70,NULL,NULL,'2MASX J07491397+1814426',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000161,NULL,'18.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,117.30825,18.24517,0.129,NULL,62618580985,978415327,15287739,18.1),(50270,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50270,35.47,0.33,124,13197,70,NULL,NULL,'CGCG 148-035',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000157,NULL,'15.6',0.2,NULL,NULL,NULL,NULL,NULL,1,117.3105417,28.61156,0.085,NULL,63433485223,991148206,15486690,15.6),(50271,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50271,37.21,0.46,277,13198,70,NULL,NULL,'2MASX J07491557+1754566',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00016,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,117.314833,17.91558,0.153,NULL,62673670878,979276107,15301189,17),(50272,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50272,37.93,0.46,386,13199,70,NULL,NULL,'2MASX J07491577+1519267',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,117.315541667,15.32406,0.045,NULL,62640007218,978750112,15292970,17.3),(50273,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50273,36.76,0.46,225,13200,70,NULL,NULL,'2MASX J07491658+4926249',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000144,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,117.319333333,49.44033,0.229,NULL,63507299809,992301559,15504711,17.3),(50274,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50274,36.58,0.1,207,13201,70,NULL,NULL,'2MASX J07491771+1830196',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000175,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,117.323667,18.50531,0.153,NULL,62618540120,978414689,15287729,16.2),(50275,'Tully est','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50275,30.36,0.8,11.8,13202,75,NULL,NULL,'ESO 163-IG 019',NULL,'1988NBGC.C....0000T',1988,1,NULL,NULL,'GPair',0.000007,NULL,NULL,NULL,'IB(s)m pec',NULL,NULL,NULL,NULL,1,117.3277917,-54.47053,0.649,NULL,40427903138,631685986,9870093,NULL),(50276,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50276,34.15,0.35,67.6,13203,NULL,NULL,'Malmquist cor.','UGC 04034',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.0g',0.31,'Sd',NULL,NULL,NULL,NULL,1,117.329625,30.90175,0.129,NULL,63423793732,990996777,15484324,16),(50277,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50277,34.27,0.33,71.4,13203,NULL,NULL,NULL,'UGC 04034',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50278,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50278,34.31,0.2,72.8,13203,74.4,NULL,NULL,'UGC 04034',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50279,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50279,34.57,0.33,81.9,13204,70,NULL,NULL,'CGCG 118-011',NULL,'2015arXiv151105856S',2015,1,0.98,NULL,'G',0.000183,NULL,'14.4g',0.74,'E0',NULL,NULL,NULL,NULL,1,117.331375,21.83331,0.173,NULL,62615913148,978373642,15287088,14.4),(50280,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50280,38.19,0.46,435,13205,70,NULL,NULL,'SDSS J074920.01+513512.3',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000177,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,117.333375,51.58675,0.177,NULL,63515952297,992436754,15506824,17.8),(50281,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50281,38.73,0.46,556,13206,70,NULL,NULL,'2MASX J07492180+2204315',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00018,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,117.341,22.07553,0.173,NULL,62616723678,978386307,15287286,18.4),(50282,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50282,35.82,0.27,146,13207,70,NULL,NULL,'KUG 0745+439',NULL,'2015arXiv151105856S',2015,1,0.88,NULL,'G',0.000121,NULL,'14.7g',0.62,'Spiral',NULL,NULL,NULL,NULL,1,117.341541667,43.76722,0.161,NULL,63560192381,993128005,15517625,14.7),(50283,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50283,36.4,0.46,191,13208,70,NULL,NULL,'2MASX J07492535+1505153',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,117.35575,15.08761,0.041,NULL,62642007305,978781364,15293458,17),(50284,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50284,33.83,0.49,58.4,13209,75,NULL,'IR','ESO 429- G 019',NULL,'2011yCatp016004901K',2011,1,0.78,'abs(b) < 10 degrees.','G',0.000023,NULL,'16.4',0.33,'S...',NULL,NULL,NULL,NULL,1,117.362,-29.35481,NULL,NULL,42556980392,664952818,10389887,16.4),(50285,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50285,34.46,0.4,78,13209,NULL,NULL,'mean','ESO 429- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50286,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50286,34.64,0.47,84.9,13209,NULL,NULL,'H','ESO 429- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50287,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50287,34.72,0.45,88.1,13209,NULL,NULL,'K','ESO 429- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50288,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50288,36.53,0.46,202,13210,70,NULL,NULL,'2MASX J07493051+2021355',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000194,NULL,'15.6g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,117.377167,20.35981,0.145,NULL,62627581579,978555962,15289936,15.6),(50289,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50289,37.45,0.15,309,13211,70,NULL,NULL,'2MASX J07493074+5200129',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,117.3782083,52.00367,0.173,NULL,63516151120,992439861,15506872,17.7),(50290,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50290,36.88,0.33,237,13212,70,NULL,NULL,'2MASX J07493549+3025002',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000204,NULL,'15.5g',0.45,'E0',NULL,NULL,NULL,NULL,1,117.3977917,30.41664,0.149,NULL,63426074488,991032413,15484881,15.5),(50291,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50291,37.14,0.46,268,13213,70,NULL,NULL,'2MASX J07493557+4932249',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000183,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,117.398083,49.54014,0.241,NULL,63507317516,992301836,15504716,16.5),(50292,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50292,37.16,0.11,271,13214,70,NULL,NULL,'2MASX J07493588+2917352',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,117.399375,29.29311,0.113,NULL,63424945991,991014781,15484605,17),(50293,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50293,35.2,0.4,110,13215,NULL,NULL,'mean','UGC 04038',NULL,'2007A&A...465...71T',2007,1,1.23,NULL,'G',0.000033,NULL,'14.6g',0.5,'SABc',NULL,NULL,NULL,NULL,1,117.4000417,26.90578,0.081,NULL,63419542107,990930345,15483286,14.6),(50294,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50294,35.33,0.47,116,13215,NULL,NULL,'H','UGC 04038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50295,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50295,35.46,0.45,124,13215,NULL,NULL,'K','UGC 04038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50296,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50296,37.16,0.11,271,13216,70,NULL,NULL,'2MASX J07493734+2914482',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000153,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,117.405458333,29.24681,0.113,NULL,63424943033,991014734,15484605,16.8),(50297,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50297,35.33,0.46,116,13217,70,NULL,NULL,'CGCG 206-030',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000081,NULL,'15.3g',0.56,'E0',NULL,NULL,NULL,NULL,1,117.4124583,42.96706,0.185,NULL,63557691810,993088934,15517014,15.3),(50298,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50298,33.73,0.49,55.7,13218,75,NULL,'IR','UGC 04039',NULL,'2011yCatp016004901K',2011,1,1.23,NULL,'G',0.000033,NULL,'15.1g',0.31,'Sb:',NULL,NULL,NULL,NULL,1,117.42025,29.94425,0.165,NULL,63425424709,991022261,15484722,15.1),(50299,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50299,33.75,0.4,56.2,13218,NULL,NULL,'mean','UGC 04039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50300,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50300,33.87,0.3,59.5,13218,NULL,NULL,NULL,'UGC 04039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50301,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50301,33.91,0.2,60.5,13218,74.4,NULL,NULL,'UGC 04039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50302,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50302,34.05,0.28,64.7,13218,NULL,NULL,'Malmquist cor.','UGC 04039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50303,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50303,34.09,0.47,65.6,13218,NULL,NULL,'H','UGC 04039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50304,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50304,36.84,0.46,233,13219,70,NULL,NULL,'2MASX J07494147+5202059',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,117.4227083,52.035,0.173,NULL,63516147886,992439810,15506872,NULL),(50305,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50305,36.73,0.23,222,13220,70,NULL,NULL,'2MASX J07494294+3151332',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000171,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,117.429125,31.85939,0.161,NULL,63480051297,991875801,15498059,16.9),(50306,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50306,38.12,0.46,420,13221,70,NULL,NULL,'2MASX J07494708+1757545',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,117.446125,17.96522,0.153,NULL,62673873880,979279279,15301238,17.9),(50307,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50307,37.63,0.46,335,13222,70,NULL,NULL,'2MASX J07494770+1617138',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,117.448875,16.28725,0.113,NULL,62673143135,979267861,15301060,17.5),(50308,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50308,35.1,0.6,105,13223,70,NULL,NULL,'ESO 059- G 021',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000033,NULL,'16.00',0.2,'Sb:',NULL,NULL,NULL,NULL,1,117.454958333,-69.78881,0.597,NULL,40654160488,635221257,9925332,16),(50309,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50309,35.15,0.49,107,13223,75,NULL,'IR','ESO 059- G 021',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50310,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50310,35.68,0.43,137,13223,NULL,NULL,'Malmquist cor.','ESO 059- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50311,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50311,35.74,0.42,140,13223,NULL,NULL,NULL,'ESO 059- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50312,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50312,35.78,0.2,143,13223,74.4,NULL,NULL,'ESO 059- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50313,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50313,37.45,0.15,309,13224,70,NULL,NULL,'2MASX J07494990+5159555',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,117.457667,51.99889,0.173,NULL,63515938433,992436538,15506820,18.5),(50314,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50314,34.16,0.4,67.9,13225,NULL,NULL,'mean','IC 2207',NULL,'2007A&A...465...71T',2007,1,2.16,NULL,'G',0.000023,NULL,'14.7g',0.37,'Sb(f)',NULL,NULL,NULL,NULL,1,117.4620417,33.96228,0.149,NULL,63478547803,991852309,15497692,14.7),(50315,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50315,34.25,0.47,70.8,13225,NULL,NULL,'H','IC 2207',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50316,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50316,34.25,0.45,70.8,13225,NULL,NULL,'K','IC 2207',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50317,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50317,34.3,0.43,72.5,13225,75,NULL,'3.6 micron, color + selection bias corrected','IC 2207',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50318,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50318,34.44,0.46,77.1,13225,NULL,NULL,'J','IC 2207',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50319,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50319,34.48,NULL,78.8,13225,NULL,NULL,NULL,'IC 2207',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50320,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50320,34.49,NULL,79.1,13225,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 2207',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50321,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50321,34.5,NULL,79.3,13225,NULL,NULL,'Dipole + Quadrupole','IC 2207',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50322,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50322,34.5,NULL,79.4,13225,NULL,NULL,'Dipole','IC 2207',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50323,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50323,34.55,0.43,81.2,13225,75,NULL,'3.6 micron, color corrected','IC 2207',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50324,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50324,34.61,0.49,83.7,13225,75,NULL,'IR','IC 2207',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50325,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50325,34.9,0.2,95.5,13225,74.4,NULL,NULL,'IC 2207',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50326,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50326,34.91,0.5,96,13225,NULL,NULL,'Malmquist cor.','IC 2207',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50327,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50327,35.05,0.47,102,13225,NULL,NULL,NULL,'IC 2207',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50328,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50328,33.77,0.2,56.8,13226,74.4,NULL,NULL,'UGC 04044',NULL,'2013AJ....146...86T',2013,1,1.17,NULL,'G',0.000033,NULL,'15.2g',0.63,'SBd',NULL,NULL,NULL,NULL,1,117.4635,18.82897,0.153,NULL,62618634849,978416169,15287752,15.2),(50329,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50329,34.21,0.13,69.6,13226,NULL,NULL,NULL,'UGC 04044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50330,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50330,36.63,0.33,212,13227,70,NULL,NULL,'2MASX J07495245+1924025',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000179,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,117.4687083,19.40067,0.121,NULL,62625703477,978526616,15289478,16.3),(50331,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50331,35.15,0.46,107,13228,70,NULL,NULL,'2MASX J07495339+4514543',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000088,NULL,'15.8g',0.34,'S0a',NULL,NULL,NULL,NULL,1,117.472417,45.2485,0.153,NULL,63556414685,993068979,15516702,15.8),(50332,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50332,37.16,0.11,271,13229,70,NULL,NULL,'2MASX J07495408+2928052',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,'FoF','16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,117.475375,29.46811,0.141,NULL,63424914337,991014286,15484598,16.5),(50333,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50333,35,0.46,100,13230,70,NULL,NULL,'2MASX J07495638+1605508',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000162,NULL,'15.9g',0.4,NULL,NULL,NULL,NULL,NULL,1,117.485083333,16.09747,0.101,NULL,62673235374,979269302,15301082,15.9),(50334,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50334,37.45,0.15,309,13231,70,NULL,NULL,'2MASX J07495658+5205496',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00016,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,117.485833,52.09697,0.173,NULL,63511675594,992369931,15505780,17.2),(50335,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50335,37.16,0.11,271,13232,70,NULL,NULL,'2MASX J07495806+2925492',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,117.49175,29.43031,0.113,NULL,63424893005,991013953,15484593,17.5),(50336,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50336,37.56,0.46,325,13233,70,NULL,NULL,'2MASX J07495830+4507583',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000139,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,117.493041667,45.13289,0.157,NULL,63557259412,993082178,15516909,17.6),(50337,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50337,35.41,0.4,121,13234,NULL,NULL,'Malmquist cor.','UGC 04042',NULL,'2009ApJS..182..474S',2009,1,0.97,NULL,'G',0.000033,NULL,'14.5g',0.75,'(R)SB(r)b:',NULL,NULL,NULL,NULL,1,117.500083,30.02494,0.165,NULL,63425299709,991020307,15484692,14.5),(50338,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50338,35.86,0.33,149,13234,NULL,NULL,NULL,'UGC 04042',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50339,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50339,35.9,0.2,151,13234,74.4,NULL,NULL,'UGC 04042',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50340,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50340,37.07,0.46,260,13235,70,NULL,NULL,'2MASX J07500278+3246461',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,117.5115417,32.77944,0.169,NULL,63480765171,991886955,15498233,17.2),(50341,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50341,37.42,0.33,305,13236,70,NULL,NULL,'2MASX J07500314+3723197',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00009,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,117.513083,37.38869,0.185,NULL,63441620388,991275318,15488676,18),(50342,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50342,37.88,0.46,376,13237,70,NULL,NULL,'2MASX J07500619+5103396',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,117.525875,51.06106,0.181,NULL,63518176601,992471509,15507367,17.7),(50343,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50343,35.31,0.46,115,13238,70,NULL,NULL,'2MASX J07500707+4009547',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000081,NULL,'15.9g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,117.529583,40.16528,0.249,NULL,63561840952,993153764,15518027,15.9),(50344,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50344,37.45,0.15,309,13239,70,NULL,NULL,'2MASX J07500819+5209576',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000183,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,117.534125,52.16597,0.169,NULL,63511677081,992369954,15505780,17.4),(50345,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50345,36.48,0.46,198,13240,70,NULL,NULL,'2MASX J07500895+1738408',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000173,NULL,'16.1g',0.33,NULL,NULL,NULL,NULL,NULL,1,117.5372917,17.64478,0.145,NULL,62673780296,979277817,15301215,16.1),(50346,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50346,33.37,0.43,47.1,13241,NULL,NULL,NULL,'UGC 04047',NULL,'2009ApJS..182..474S',2009,1,0.63,NULL,'G',0.00002,NULL,'14.2g',0.51,'SBb',NULL,NULL,NULL,NULL,1,117.538458333,30.73239,0.125,NULL,63425828449,991028569,15484821,14.2),(50347,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50347,33.41,0.2,48.1,13241,74.4,NULL,NULL,'UGC 04047',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50348,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50348,33.8,0.35,57.5,13241,NULL,NULL,'Malmquist cor.','UGC 04047',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50349,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50349,33.93,0.4,61,13241,NULL,NULL,'mean','UGC 04047',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50350,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50350,33.98,0.47,62.4,13241,NULL,NULL,'H','UGC 04047',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50351,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50351,34.07,0.46,65.2,13241,NULL,NULL,'J','UGC 04047',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50352,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50352,34.08,0.45,65.6,13241,NULL,NULL,'K','UGC 04047',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50353,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50353,32.91,0.66,38.2,13242,NULL,NULL,NULL,'UGC 04046',NULL,'2009ApJS..182..474S',2009,1,0.58,NULL,'G',0.000023,NULL,'16.6g',0.44,'SB?',NULL,NULL,NULL,NULL,1,117.543917,30.68508,0.125,NULL,63425835206,991028675,15484823,16.6),(50354,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50354,32.95,0.2,38.9,13242,74.4,NULL,NULL,'UGC 04046',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50355,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50355,33.71,0.46,55.3,13242,NULL,NULL,'Malmquist cor.','UGC 04046',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50356,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50356,37.42,0.33,305,13243,70,NULL,NULL,'2MASX J07501104+3726486',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000093,NULL,'16.2g',0.34,'E0',NULL,NULL,NULL,NULL,1,117.545833,37.44703,0.185,NULL,63441632016,991275500,15488679,16.2),(50357,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50357,37.84,0.46,370,13244,70,NULL,NULL,'2MASX J07501204+3936174',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000081,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,117.55,39.60478,0.205,NULL,63561958955,993155608,15518056,17.2),(50358,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:23','1','SN 2001iv',NULL,50358,40.77,0.21,1020,13245,74.2,NULL,'SALT 2','H-ZSNS J075013.53+101710.4',0.3965,'2010ApJ...716..712A',2010,1,0.06,NULL,'G',0.0003,NULL,'22.1g',0.03,NULL,NULL,NULL,NULL,NULL,1,117.556417,10.28636,0.037,NULL,62762770408,980668287,15322941,22.1),(50359,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:23','1','SN 2001iv',NULL,50359,40.89,0.3,1080,13245,65,NULL,NULL,'H-ZSNS J075013.53+101710.4',0.3965,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50360,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:23','1','SN 2001iv','R',50360,40.99,NULL,1130,13245,65,NULL,'SALT','H-ZSNS J075013.53+101710.4',0.3965,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50361,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:23','1','SN 2001iv',NULL,50361,41.2,0.22,1240,13245,72,NULL,'BATM','H-ZSNS J075013.53+101710.4',0.3965,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50362,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:23','1','SN 2001iv',NULL,50362,41.31,0.25,1310,13245,72,NULL,'dm15','H-ZSNS J075013.53+101710.4',0.3965,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50363,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:23','1','SN 2001iv',NULL,50363,41.41,0.24,1370,13245,70,NULL,'SALT','H-ZSNS J075013.53+101710.4',0.3965,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50364,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:23','1','SN 2001iv',NULL,50364,41.45,0.17,1400,13245,72,NULL,'MLCS','H-ZSNS J075013.53+101710.4',0.3965,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50365,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:23','1','SN 2001iv',NULL,50365,41.52,0.22,1440,13245,65,NULL,'SALT','H-ZSNS J075013.53+101710.4',0.3965,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50366,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50366,37.45,0.15,309,13246,70,NULL,NULL,'SDSS J075016.42+521047.7',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000184,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,117.568417,52.17992,0.169,NULL,63511689061,992370141,15505783,17.8),(50367,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50367,37.76,0.46,356,13247,70,NULL,NULL,'2MASX J07501859+2310420',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000202,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,117.577625,23.17822,0.233,NULL,63753838450,996153725,15564901,16.4),(50368,'TRGB','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50368,29.91,0.1,9.6,13248,74.4,NULL,NULL,'GALEXASC J075021.71+074740.3',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.00004,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,117.590417,7.79444,0.069,NULL,62723442148,980053783,15313340,NULL),(50369,'TRGB','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50369,29.91,0.04,9.6,13248,NULL,NULL,NULL,'GALEXASC J075021.71+074740.3',NULL,'2015ApJ...805..144K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50370,'TRGB','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50370,30.19,0.05,10.9,13248,NULL,NULL,'I','GALEXASC J075021.71+074740.3',NULL,'2014ApJ...785....3M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50371,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50371,34.81,0.47,91.6,13249,70,NULL,NULL,'ESO 209-*N?003',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000147,NULL,'15.7b',0.3,'Star in neb,',NULL,NULL,NULL,NULL,1,117.596125,-50.00297,0.549,NULL,42526534079,664477094,10382454,15.7),(50372,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50372,38.14,0.46,424,13250,70,NULL,NULL,'SDSS J075023.93+320727.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000165,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,117.5997083,32.12436,0.173,NULL,63480257900,991879029,15498109,18.3),(50373,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50373,37.45,0.15,309,13251,70,NULL,NULL,'2MASX J07502396+5211115',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000188,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,117.599833333,52.18664,0.169,NULL,63511688741,992370136,15505783,17.4),(50374,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50374,35.59,0.55,131,13252,70,NULL,NULL,'2MASX J07502401-5305316',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,117.600041667,-53.09219,0.765,NULL,42520726642,664386353,10381036,14.1),(50375,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50375,37.59,0.46,330,13253,70,NULL,NULL,'2MASX J07502487+2418068',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00016,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,117.60375,24.30194,0.257,NULL,64290359172,1004536862,15695888,17.1),(50376,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50376,35.13,0.46,106,13254,70,NULL,NULL,'CGCG 148-046',NULL,'2015arXiv151105856S',2015,1,1.08,'The UGC position is for a superposed star.','G',0.000153,NULL,'14.3g',0.69,'E0',NULL,NULL,NULL,NULL,1,117.605,30.22569,0.141,NULL,63426202201,991034409,15484912,14.3),(50377,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50377,37.96,0.46,391,13255,70,NULL,NULL,'2MASX J07502607+5015269',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,117.6085417,50.25753,0.193,NULL,63515043613,992422556,15506602,17.2),(50378,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50378,36.94,0.33,244,13256,70,NULL,NULL,'2MASX J07502617+4448577',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,117.6090417,44.81603,0.141,NULL,63557223673,993081619,15516900,17.1),(50379,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50379,37.92,0.46,384,13257,70,NULL,NULL,'2MASX J07502756+1454009',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000164,NULL,'17.6g',NULL,NULL,NULL,NULL,NULL,NULL,1,117.615,14.90033,0.065,NULL,62642191664,978784244,15293503,17.6),(50380,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50380,37.16,0.11,271,13258,70,NULL,NULL,'2MASX J07502926+2916358',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000166,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,117.621875,29.27667,0.113,NULL,63424889542,991013899,15484592,16.3),(50381,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50381,37.67,0.81,341,13259,70,NULL,NULL,'2MASX J07503023-0401489',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,117.625875,-4.03033,0.425,NULL,39324483547,614445055,9600703,16.1),(50382,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50382,36.25,0.46,178,13260,70,NULL,NULL,'2MASX J07503033+2112552',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,117.6265,21.21522,0.173,NULL,62615207678,978362619,15286915,17.4),(50383,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50383,36.94,0.33,244,13261,70,NULL,NULL,'2MASX J07503106+4450267',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000177,NULL,'16.6g',0.29,'AGN',NULL,NULL,NULL,NULL,1,117.629625,44.84083,0.141,NULL,63557228568,993081696,15516901,16.6),(50384,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:23','1','SN 2001kd',NULL,50384,42.58,0.72,1690,13262,74.2,NULL,'SALT 2','H-ZSNS J075031.24+102107.3',0.936,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,117.630166667,10.35203,0.037,NULL,62762721223,980667519,15322929,NULL),(50385,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:23','1','SN 2001kd','R',50385,43.45,NULL,2530,13262,65,NULL,'SALT','H-ZSNS J075031.24+102107.3',0.936,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50386,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:23','1','SN 2001kd',NULL,50386,43.73,0.42,2880,13262,72,NULL,'BATM','H-ZSNS J075031.24+102107.3',0.936,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50387,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:23','1','SN 2001kd',NULL,50387,43.79,0.44,2960,13262,72,NULL,'MLCS','H-ZSNS J075031.24+102107.3',0.936,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50388,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:23','1','SN 2001kd',NULL,50388,43.99,0.38,3240,13262,65,NULL,NULL,'H-ZSNS J075031.24+102107.3',0.936,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50389,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:23','1','SN 2001kd',NULL,50389,44.15,0.52,3490,13262,70,NULL,'SALT','H-ZSNS J075031.24+102107.3',0.936,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50390,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:23','1','SN 2001kd',NULL,50390,44.37,0.49,3860,13262,65,NULL,'SALT','H-ZSNS J075031.24+102107.3',0.936,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50391,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,NULL,50391,35.88,0.2,150,13263,74.4,NULL,NULL,'CGCG 058-038',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.00005,NULL,'15.4',0.4,NULL,NULL,NULL,NULL,NULL,1,117.63475,10.31394,0.037,NULL,62762725921,980667592,15322931,15.4),(50392,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50392,38.34,0.21,466,13264,70,NULL,NULL,'2MASX J07503273+1444449',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000147,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,117.636333333,14.74586,0.065,NULL,62642106033,978782906,15293482,17.9),(50393,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50393,37.77,0.46,359,13265,70,NULL,NULL,'2MASX J07503338+2341462',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,117.639125,23.69611,0.269,NULL,63754409755,996162652,15565041,17.9),(50394,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50394,38.23,0.46,442,13266,70,NULL,NULL,'2MASX J07503409+1423469',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000148,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,117.641916667,14.39633,0.049,NULL,62642790706,978793604,15293650,17.7),(50395,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50395,37.44,0.33,308,13267,70,NULL,NULL,'2MASX J07503463+3356500',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,117.644458333,33.94722,0.149,NULL,63478259832,991847809,15497622,17.4),(50396,'FP','2016-12-15 15:14:18','2016-12-16 11:19:23','1',NULL,'R',50396,37.44,0.33,308,13268,70,NULL,NULL,'2MASX J07503487+3354270',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000172,NULL,'18.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,117.645333,33.90747,0.149,NULL,63478263493,991847867,15497622,18.1),(50397,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:23','1','SN 2001hu',NULL,50397,42.64,0.6,1790,13269,74.2,NULL,'SALT 2','H-ZSNS J075035.90+095814.2',0.882,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,117.649583,9.97061,0.025,NULL,62762598392,980665599,15322899,NULL),(50398,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:23','1','SN 2001hu',NULL,50398,42.9,0.47,2020,13269,65,NULL,'SALT','H-ZSNS J075035.90+095814.2',0.882,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50399,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 2001hu',NULL,50399,42.93,0.32,2050,13269,70,NULL,'SALT','H-ZSNS J075035.90+095814.2',0.882,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50400,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 2001hu',NULL,50400,43.46,0.38,2610,13269,72,NULL,'MLCS','H-ZSNS J075035.90+095814.2',0.882,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50401,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 2001hu','R',50401,43.47,NULL,2620,13269,65,NULL,'SALT','H-ZSNS J075035.90+095814.2',0.882,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50402,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 2001hu',NULL,50402,43.74,0.51,2970,13269,72,NULL,'BATM','H-ZSNS J075035.90+095814.2',0.882,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50403,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 2001hu',NULL,50403,43.9,0.3,3200,13269,65,NULL,NULL,'H-ZSNS J075035.90+095814.2',0.882,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50404,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50404,38.34,0.21,466,13270,70,NULL,NULL,'SDSS J075036.09+144554.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000174,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,117.650417,14.76503,0.065,NULL,62642102339,978782849,15293482,18.8),(50405,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50405,35.47,0.46,124,13271,70,NULL,NULL,'2MASX J07503649+3912185',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000081,NULL,'16.7g',0.24,'NLAGN',NULL,NULL,NULL,NULL,1,117.652166667,39.20525,0.197,NULL,63562528317,993164504,15518195,16.7),(50406,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50406,37.16,0.11,271,13272,70,NULL,NULL,'2MASX J07503715+2921567',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000135,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,117.654625,29.36564,0.113,NULL,63424859370,991013427,15484584,17.1),(50407,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50407,37.83,0.46,368,13273,70,NULL,NULL,'2MASX J07503837+3135199',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000198,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,117.6599583,31.58894,0.169,NULL,63477123153,991830049,15497344,17),(50408,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50408,37.21,0.46,276,13274,70,NULL,NULL,'SDSS J075038.67+193834.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000175,NULL,'17.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,117.661125,19.64289,0.117,NULL,62628659219,978572800,15290200,17.9),(50409,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 2001iw',NULL,50409,40.37,0.23,885,13275,74.2,NULL,'SALT 2','H-ZSNS J075039.32+102019.1',0.3396,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.0001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,117.663833,10.33864,0.037,NULL,62762719327,980667489,15322929,NULL),(50410,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 2001iw','R',50410,40.65,NULL,1010,13275,65,NULL,'SALT','H-ZSNS J075039.32+102019.1',0.3396,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50411,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 2001iw',NULL,50411,40.71,0.27,1040,13275,65,NULL,NULL,'H-ZSNS J075039.32+102019.1',0.3396,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50412,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 2001iw',NULL,50412,40.78,0.32,1070,13275,72,NULL,'BATM','H-ZSNS J075039.32+102019.1',0.3396,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50413,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 2001iw',NULL,50413,40.88,0.21,1120,13275,72,NULL,'dm15','H-ZSNS J075039.32+102019.1',0.3396,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50414,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 2001iw',NULL,50414,41.1,0.26,1240,13275,70,NULL,'SALT','H-ZSNS J075039.32+102019.1',0.3396,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50415,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 2001iw',NULL,50415,41.24,0.17,1320,13275,72,NULL,'MLCS','H-ZSNS J075039.32+102019.1',0.3396,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50416,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 2001iw',NULL,50416,41.25,0.23,1330,13275,65,NULL,'SALT','H-ZSNS J075039.32+102019.1',0.3396,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50417,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50417,37.69,0.46,344,13276,70,NULL,NULL,'2MASXi J0750401+153317',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,117.667167,15.55494,0.085,NULL,62672555211,979258675,15300916,18.2),(50418,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50418,36.88,0.33,237,13277,70,NULL,NULL,'2MASX J07504536+3023397',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000187,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,117.689083,30.39433,0.149,NULL,63426236816,991034950,15484921,16.7),(50419,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50419,37.29,0.46,287,13278,70,NULL,NULL,'2MASX J07504547+1710198',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'17.84',0.38,'E/S0',NULL,NULL,NULL,NULL,1,117.6895417,17.17219,0.133,NULL,62674563808,979290059,15301407,17.84),(50420,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50420,33.6,0.4,52.5,13279,NULL,NULL,'mean','UGC 04043',NULL,'2007A&A...465...71T',2007,1,2.13,NULL,'G',0.000023,NULL,'14.79',0.3,'Sc',NULL,NULL,NULL,NULL,1,117.692791667,54.36222,0.121,NULL,61579830852,962184857,15034138,14.79),(50421,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50421,33.67,0.47,54.2,13279,NULL,NULL,'H','UGC 04043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50422,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50422,33.68,0.46,54.5,13279,NULL,NULL,'J','UGC 04043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50423,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50423,33.72,0.45,55.4,13279,NULL,NULL,'K','UGC 04043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50424,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50424,33.94,0.49,61.4,13279,75,NULL,'IR','UGC 04043',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50425,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50425,34.44,0.2,77.3,13279,74.4,NULL,NULL,'UGC 04043',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50426,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50426,34.45,NULL,77.7,13279,NULL,NULL,NULL,'UGC 04043',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50427,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50427,34.5,NULL,79.5,13279,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04043',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50428,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50428,34.51,NULL,79.7,13279,NULL,NULL,'Dipole + Quadrupole','UGC 04043',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50429,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50429,34.51,NULL,79.8,13279,NULL,NULL,'Dipole','UGC 04043',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50430,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50430,34.62,0.31,84.1,13279,NULL,NULL,NULL,'UGC 04043',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50431,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50431,34.72,0.3,88,13279,NULL,NULL,'Malmquist cor.','UGC 04043',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50432,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50432,36.6,0.46,209,13280,70,NULL,NULL,'2MASX J07504681+2032172',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000171,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,117.695083,20.53803,0.129,NULL,62628507228,978570425,15290162,16.8),(50433,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50433,36.93,0.33,243,13281,70,NULL,NULL,'2MASXi J0750478+164213',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000191,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,117.699333,16.70369,0.113,NULL,62674596311,979290567,15301415,16.3),(50434,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50434,33.78,0.4,57,13282,NULL,NULL,'mean','UGC 04028',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.00002,NULL,'13.1',0.9,'SAB(s)c?       Sbrst','in a pair',NULL,NULL,'Starburst',1,117.7079583,74.35769,0.093,NULL,61303583921,957868498,14966695,13.1),(50435,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50435,33.88,0.45,59.8,13282,NULL,NULL,'K','UGC 04028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50436,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50436,33.9,0.46,60.4,13282,NULL,NULL,'J','UGC 04028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50437,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50437,33.93,0.47,61.2,13282,NULL,NULL,'H','UGC 04028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50438,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50438,38.18,0.33,433,13283,70,NULL,NULL,'SDSS J075050.48+242244.7',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000132,NULL,'19.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,117.710333333,24.37908,0.257,NULL,64291224352,1004550380,15696099,19),(50439,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50439,37.2,0.33,276,13284,70,NULL,NULL,'2MASX J07505163+2947497',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000132,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,117.7152083,29.79706,0.141,NULL,63425298124,991020283,15484691,18),(50440,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50440,37.56,0.46,325,13285,70,NULL,NULL,'2MASX J07505179+2927227',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00014,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,117.715875,29.45636,0.113,NULL,63424863625,991013494,15484585,16.8),(50441,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50441,37.2,0.33,276,13286,70,NULL,NULL,'SDSS J075052.12+294627.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000136,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,117.717167,29.77444,0.141,NULL,63425296075,991020251,15484691,18.1),(50442,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50442,37.32,0.46,291,13287,70,NULL,NULL,'2MASX J07505287+2505387',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,117.720333,25.09414,0.225,NULL,64291107268,1004548551,15696071,17),(50443,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50443,37.69,0.46,344,13288,70,NULL,NULL,'2MASX J07505292+1459175',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,117.720417,14.98833,0.041,NULL,62641980117,978780939,15293452,16.3),(50444,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50444,38.34,0.21,466,13289,70,NULL,NULL,'SDSS J075052.96+144532.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,117.7207083,14.75894,0.065,NULL,62642085170,978782580,15293477,18.4),(50445,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50445,38.13,0.46,422,13290,70,NULL,NULL,'2MASX J07505593+2937337',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000149,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,117.73325,29.62597,0.141,NULL,63424835996,991013062,15484579,17.4),(50446,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50446,32.15,0.4,26.9,13291,75,NULL,NULL,'UGC 04054',NULL,'2008Ap.....51..336K',2008,1,2.11,NULL,'G',0.000023,NULL,'14.7g',0.46,'Sb','Isolated galaxy',NULL,NULL,NULL,1,117.7335417,23.89592,0.269,NULL,63754325975,996161343,15565020,14.7),(50447,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50447,32.93,0.49,38.6,13291,75,NULL,'IR','UGC 04054',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50448,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50448,38.34,0.21,466,13292,70,NULL,NULL,'2MASX J07505638+1446045',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000148,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,117.7350417,14.76783,0.065,NULL,62642084248,978782566,15293477,16.9),(50449,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50449,37.34,0.46,294,13293,70,NULL,NULL,'2MASX J07510072+1814381',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,117.752917,18.24408,0.189,NULL,62618679330,978416864,15287763,17.9),(50450,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50450,38.11,0.46,419,13294,70,NULL,NULL,'2MASX J07510074+5006129',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,117.753,50.10361,0.193,NULL,63515076113,992423064,15506610,18),(50451,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50451,37.36,0.33,296,13295,70,NULL,NULL,'2MASX J07510083+4357506',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000092,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,117.753583,43.96417,0.141,NULL,63560129099,993127017,15517609,17.1),(50452,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50452,36.45,0.46,195,13296,70,NULL,NULL,'2MASX J07510300+3657240',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000101,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,117.7627083,36.95667,0.201,NULL,63442007955,991281374,15488771,16.6),(50453,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50453,37.2,0.46,275,13297,70,NULL,NULL,'SDSS J075105.04+432531.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00007,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,117.7710417,43.42544,0.169,NULL,63560347073,993130423,15517662,18.3),(50454,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50454,38.32,0.33,462,13298,70,NULL,NULL,'SDSS J075105.85+324103.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000138,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,117.774417,32.68422,0.181,NULL,63480557468,991883710,15498182,18.5),(50455,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50455,37.12,0.46,265,13299,70,NULL,NULL,'2MASX J07510627+4719596',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,117.7759583,47.33344,0.341,NULL,63506903318,992295364,15504615,NULL),(50456,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50456,38.32,0.33,462,13300,70,NULL,NULL,'2MASX J07510720+3241466',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000175,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,117.780125,32.69628,0.181,NULL,63480557543,991883711,15498182,18.1),(50457,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50457,34.94,0.19,97.5,13301,70,NULL,NULL,'2MASX J07510722+5024278',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00017,NULL,'15.9g',0.39,NULL,NULL,NULL,NULL,NULL,1,117.780333,50.40772,0.205,NULL,63515162396,992424412,15506631,15.9),(50458,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50458,38.34,0.21,466,13302,70,NULL,NULL,'2MASX J07510782+1441185',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,117.782625,14.68842,0.065,NULL,62642090339,978782661,15293479,18),(50459,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50459,37.08,0.46,261,13303,70,NULL,NULL,'2MASX J07511202+4215386',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,'FoF','16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,117.800167,42.26067,0.173,NULL,63565225314,993206645,15518853,16.6),(50460,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50460,36.7,0.27,219,13304,70,NULL,NULL,'2MASX J07511244+4546596',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000161,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,117.8017917,45.78311,0.261,NULL,63556331580,993067680,15516682,16.5),(50461,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50461,36.64,0.46,212,13305,70,NULL,NULL,'2MASX J07511248+2312014',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,117.801917,23.20036,0.261,NULL,63753941996,996155343,15564927,17.2),(50462,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50462,37.18,0.46,273,13306,70,NULL,NULL,'2MASX J07511322+3718140',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000093,NULL,'16.2g',0.34,'E0',NULL,NULL,NULL,NULL,1,117.804917,37.30378,0.193,NULL,63441520361,991273755,15488652,16.2),(50463,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50463,34.94,0.19,97.5,13307,70,NULL,NULL,'CGCG 235-049',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.00008,NULL,'14.9g',0.44,NULL,'Group member',NULL,NULL,NULL,1,117.805791667,50.19328,0.193,NULL,63514953317,992421145,15506580,14.9),(50464,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50464,37.41,0.46,304,13308,70,NULL,NULL,'2MASX J07511370+3839170',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000071,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,117.807167,38.65481,0.181,NULL,63441023289,991265988,15488531,17.5),(50465,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50465,36.04,0.46,162,13309,70,NULL,NULL,'2MASX J07511460+2354133',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000153,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,117.810958333,23.90369,0.269,NULL,63754316574,996161196,15565018,16.4),(50466,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50466,34.94,0.19,97.5,13310,70,NULL,NULL,'UGC 04051',NULL,'2015arXiv151105856S',2015,1,1.01,NULL,'G',0.000093,NULL,'14.2g',0.79,'E?','in a pair',NULL,NULL,NULL,1,117.8235417,50.17931,0.193,NULL,63514953713,992421151,15506580,14.2),(50467,'GRB','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50467,44.47,1.56,3070,13311,100,NULL,NULL,'GRB 070125',1.5477,'2009EPJC...63..139W',2009,1,NULL,NULL,'VisS',NULL,NULL,'18.5V',NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,117.82425,31.15117,0.129,NULL,63425788974,991027952,15484811,18.5),(50468,'GRB','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50468,44.67,1.49,3370,13311,100,NULL,NULL,'GRB 070125',1.5477,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50469,'GRB','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50469,45.39,0.25,12000,13311,NULL,NULL,NULL,'GRB 070125',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50470,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50470,37.54,0.33,322,13312,70,NULL,NULL,'2MASX J07511856+3740050',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000081,NULL,'16.6g',0.36,'BrClG',NULL,NULL,NULL,NULL,1,117.8272917,37.66808,0.185,NULL,63441679899,991276248,15488691,16.6),(50471,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50471,36.47,0.17,196,13313,70,NULL,NULL,'2MASX J07511981+2314383',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.80',0.44,NULL,NULL,NULL,NULL,NULL,1,117.8327083,23.244,0.261,NULL,63753890694,996154542,15564914,16.8),(50472,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50472,38.4,0.46,480,13314,70,NULL,NULL,'SDSS J075120.92+284902.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,117.8372083,28.81722,0.049,NULL,63424339005,991005296,15484457,18.2),(50473,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50473,36.2,0.46,173,13315,70,NULL,NULL,'2MASX J07512099+2230153',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000164,NULL,'16.2g',0.31,'E0',NULL,NULL,NULL,NULL,1,117.837375,22.50414,0.221,NULL,62614935903,978358373,15286849,16.2),(50474,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50474,37.54,0.33,322,13316,70,NULL,NULL,'2MASX J07512209+3738130',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000077,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,117.841917,37.63692,0.185,NULL,63441676940,991276202,15488690,17.3),(50475,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50475,36.44,0.46,194,13317,70,NULL,NULL,'2MASX J07512260+1817193',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000194,NULL,'15.8g',0.42,NULL,NULL,NULL,NULL,NULL,1,117.844083,18.28875,0.189,NULL,62617998978,978406234,15287597,15.8),(50476,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50476,38.05,0.27,406,13318,70,NULL,NULL,'2MASX J07512297+3954320',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000087,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,117.845917,39.90883,0.241,NULL,63561950148,993155471,15518054,17.7),(50477,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50477,35.52,0.2,127,13319,74.4,NULL,NULL,'CGCG 058-045',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000137,NULL,'15.1',0.8,NULL,NULL,NULL,NULL,NULL,1,117.847791667,10.51094,0.037,NULL,62763383549,980677867,15323091,15.1),(50478,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50478,38.05,0.27,406,13320,70,NULL,NULL,'2MASX J07512476+3954549',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,'FoF','17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,117.853166667,39.91531,0.241,NULL,63561950092,993155470,15518054,17.6),(50479,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50479,38.18,0.33,433,13321,70,NULL,NULL,'SDSS J075125.65+242140.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000127,NULL,'18.9g',0.11,NULL,NULL,NULL,NULL,NULL,1,117.856875,24.36119,0.257,NULL,64290697608,1004542150,15695971,18.9),(50480,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50480,38.32,0.46,461,13322,70,NULL,NULL,'2MASX J07512581+1337367',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,117.857667,13.62683,0.065,NULL,62636725131,978698830,15292169,17.3),(50481,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50481,37.48,0.46,314,13323,70,NULL,NULL,'2MASX J07512610+2455532',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000126,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,117.858833,24.93158,0.237,NULL,64291123407,1004548803,15696075,18.2),(50482,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50482,34.07,0.47,65,13324,NULL,NULL,'H','UGC 04060',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000033,NULL,'14.68',0.4,'S?',NULL,NULL,NULL,NULL,1,117.859167,14.02047,0.085,NULL,62635075072,978673048,15291766,14.68),(50483,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50483,34.09,0.2,65.8,13324,74.4,NULL,NULL,'UGC 04060',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50484,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50484,34.11,0.46,66.3,13324,NULL,NULL,'J','UGC 04060',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50485,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50485,34.12,0.45,66.8,13324,NULL,NULL,'K','UGC 04060',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50486,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50486,34.12,0.43,66.8,13324,75,NULL,'3.6 micron, color corrected','UGC 04060',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50487,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50487,34.21,0.4,69.5,13324,NULL,NULL,'mean','UGC 04060',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50488,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50488,34.28,0.43,71.7,13324,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04060',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50489,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50489,37.76,0.46,357,13325,70,NULL,NULL,'2MASX J07512751+2902022',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000131,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,117.864583,29.03397,0.081,NULL,63425043953,991016311,15484629,17.5),(50490,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50490,37.43,0.46,306,13326,70,NULL,NULL,'2MASX J07512765+3717340',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,'PHOT','16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,117.865167,37.29269,0.193,NULL,63441521341,991273770,15488652,16.7),(50491,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50491,34.03,0.49,63.9,13327,75,NULL,'IR','ESO 429- G 021',NULL,'2011yCatp016004901K',2011,1,1.48,'abs(b) < 10 degrees.','G',0.000033,NULL,'16.8',0.17,'Spiral edge-on',NULL,NULL,NULL,NULL,1,117.8662917,-29.64086,NULL,NULL,42557257616,664957150,10389955,16.8),(50492,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50492,34.41,0.45,76.4,13327,NULL,NULL,'K','ESO 429- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50493,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50493,34.43,0.47,76.9,13327,NULL,NULL,'H','ESO 429- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50494,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50494,34.43,0.4,76.9,13327,NULL,NULL,'mean','ESO 429- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50495,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50495,38.26,0.46,449,13328,70,NULL,NULL,'2MASX J07512883+2712072',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000179,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,117.87,27.20214,0.113,NULL,64292465406,1004569771,15696402,17),(50496,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50496,38.55,0.46,513,13329,70,NULL,NULL,'2MASX J07513008+4946579',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000153,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,117.8752917,49.78281,0.205,NULL,63507427110,992303548,15504742,17.6),(50497,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50497,38.05,0.27,406,13330,70,NULL,NULL,'2MASX J07513075+3959450',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000097,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,117.878125,39.99583,0.241,NULL,63566353760,993224277,15519129,17),(50498,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50498,37.75,0.46,355,13331,70,NULL,NULL,'SDSS J075130.79+482046.2',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000141,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,117.878333,48.34617,0.209,NULL,63509878115,992341845,15505341,17.8),(50499,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50499,35.22,0.51,111,13332,70,NULL,NULL,'2MASX J07513111-6950085',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,117.87975,-69.83572,0.629,NULL,40654242863,635222544,9925352,16.2),(50500,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50500,38.09,0.46,414,13333,70,NULL,NULL,'SDSS J075136.93+103951.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,117.903875,10.66417,0.013,NULL,62761089667,980642026,15322531,17.7),(50501,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50501,37.57,0.46,327,13334,70,NULL,NULL,'2MASX J07513812+5135499',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000174,NULL,'17.0g',0.24,'BrClG',NULL,NULL,NULL,NULL,1,117.9087917,51.59728,0.177,NULL,63514611428,992415803,15506496,17),(50502,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50502,37.21,0.46,277,13335,70,NULL,NULL,'SDSS J075139.71+150506.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000139,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,117.9155,15.08508,0.085,NULL,62641932701,978780198,15293440,18.1),(50503,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50503,37.46,0.46,311,13336,70,NULL,NULL,'SDSS J075140.17+382451.5',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000082,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,117.917417,38.41433,0.177,NULL,63441040476,991266257,15488535,17.2),(50504,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50504,36.89,0.46,239,13337,70,NULL,NULL,'2MASX J07514096+5018009',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000182,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,117.9205,50.30022,0.205,NULL,63515361553,992427524,15506680,17),(50505,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50505,36.76,0.46,225,13338,70,NULL,NULL,'2MASX J07514103+2404511',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000143,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,117.921083333,24.08094,0.269,NULL,63754071814,996157372,15564958,17.3),(50506,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50506,35.31,0.2,115,13339,74.4,NULL,NULL,'CGCG 058-051',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00006,NULL,'15.3',0.6,NULL,NULL,NULL,NULL,NULL,1,117.921833,11.16789,0.025,NULL,62761308754,980645449,15322585,15.3),(50507,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50507,36.47,0.17,196,13340,70,NULL,NULL,'2MASX J07514128+2314257',NULL,'2015arXiv151105856S',2015,1,0.1,NULL,'G',0.000162,NULL,'18.2g',0.1,NULL,NULL,NULL,NULL,NULL,1,117.922167,23.24056,0.261,NULL,63753933053,996155203,15564925,18.2),(50508,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50508,37.7,0.46,346,13341,70,NULL,NULL,'2MASX J07514179+5303259',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000169,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,117.924125,53.05706,0.121,NULL,63512085236,992376331,15505880,17.5),(50509,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50509,38.33,0.46,463,13342,70,NULL,NULL,'2MASX J07514184+3345100',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000231,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,117.9244583,33.75289,0.141,NULL,63478404369,991850068,15497657,17),(50510,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50510,38.21,0.46,439,13343,70,NULL,NULL,'2MASX J07514192+1537186',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,117.924833,15.62172,0.085,NULL,62672450612,979257040,15300891,18),(50511,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50511,36.93,0.33,243,13344,70,NULL,NULL,'2MASX J07514427+1631236',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000176,NULL,'16.1g',0.43,NULL,NULL,NULL,NULL,NULL,1,117.9345,16.52331,0.105,NULL,62672840277,979263129,15300986,16.1),(50512,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50512,37.16,0.11,271,13345,70,NULL,NULL,'2MASX J07514588+2934533',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000073,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,117.941083,29.58147,0.113,NULL,63424965608,991015087,15484610,16.8),(50513,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50513,38.27,0.46,450,13346,70,NULL,NULL,'2MASX J07514618+1851027',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000189,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,117.942417,18.85075,0.145,NULL,62625285853,978520091,15289376,17.5),(50514,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50514,36.36,0.46,187,13347,70,NULL,NULL,'2MASX J07514785+1955217',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'15.9g',0.36,NULL,NULL,NULL,NULL,NULL,1,117.949375,19.92278,0.137,NULL,62629149749,978580464,15290319,15.9),(50515,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50515,37.32,0.46,291,13348,70,NULL,NULL,'2MASX J07514838+2303367',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000188,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,117.95175,23.06022,0.277,NULL,63753925686,996155088,15564923,17.1),(50516,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50516,37.3,0.46,288,13349,70,NULL,NULL,'SDSS J075148.61+200434.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000167,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,117.952583,20.07617,0.125,NULL,62629325477,978583210,15290362,18.3),(50517,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50517,38.78,0.46,569,13350,70,NULL,NULL,'SDSS J075150.05+152230.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,117.9585417,15.37506,0.085,NULL,62672363863,979255685,15300870,18.2),(50518,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50518,37.36,0.33,296,13351,70,NULL,NULL,'2MASX J07515113+4357569',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000102,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,117.963167,43.96572,0.225,NULL,63560271917,993129248,15517644,16.5),(50519,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50519,36.7,0.27,219,13352,70,NULL,NULL,'2MASX J07515144+4604099',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000107,NULL,'15.8g',0.44,'E0',NULL,NULL,NULL,NULL,1,117.9644583,46.06944,0.261,NULL,63526983665,992609119,15509517,15.8),(50520,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50520,36.48,0.58,198,13353,70,NULL,NULL,'2MASX J07515232-5246405',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,117.968083,-52.77789,0.765,NULL,42520595549,664384305,10381004,17.5),(50521,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50521,36.82,0.46,231,13354,70,NULL,NULL,'2MASX J07515278+2947123',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000147,NULL,'17.0g',0.31,NULL,NULL,NULL,NULL,NULL,1,117.9697917,29.78667,0.117,NULL,63424498106,991007782,15484496,17),(50522,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50522,37.65,0.46,340,13355,70,NULL,NULL,'2MASX J07515307+2111587',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,117.971083333,21.19958,0.149,NULL,62615292708,978363948,15286936,17.4),(50523,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 1995E',NULL,50523,32.93,0.05,38.1,13356,72,NULL,NULL,'NGC 2441',0.01158,'2006ApJ...647..501P',2006,1,2,NULL,'G',0.000057,NULL,'13.0',1.7,'SAB(r)b:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,117.978083,73.01569,0.085,NULL,61297463285,957772863,14965200,13),(50524,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 1995E',NULL,50524,32.96,0.29,38.6,13356,65,NULL,NULL,'NGC 2441',0.01158,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50525,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 1995E',NULL,50525,33.09,0.25,41,13356,74.2,NULL,'SALT 2','NGC 2441',0.01158,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50526,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 1995E',NULL,50526,33.14,0.06,42,13356,72,NULL,NULL,'NGC 2441',0.01158,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50527,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 1995E',NULL,50527,33.2,0.18,42.6,13356,65,NULL,'MLCS2k2','NGC 2441',0.01158,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50528,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 1995E',NULL,50528,33.25,0.08,44.7,13356,74.4,NULL,NULL,'NGC 2441',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50529,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 1995E',NULL,50529,33.49,0.24,49.3,13356,72,NULL,NULL,'NGC 2441',0.01158,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50530,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 1995E',NULL,50530,33.49,0.17,49.9,13356,70.8,NULL,NULL,'NGC 2441',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50531,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 1995E',NULL,50531,33.6,0.17,51.9,13356,65,NULL,'MLCS','NGC 2441',0.01158,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50532,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 1995E',NULL,50532,33.73,0.17,55.1,13356,65,NULL,'Template','NGC 2441',0.01158,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50533,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 1995E',NULL,50533,33.76,0.06,56.5,13356,65,NULL,'Snapshot','NGC 2441',NULL,'1996ApJ...473...88R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50534,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 1995E',NULL,50534,33.82,0.14,58.1,13356,60,NULL,NULL,'NGC 2441',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50535,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 1995E',NULL,50535,33.89,0.27,59.2,13356,65,NULL,'MLCS17','NGC 2441',0.01158,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50536,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 1995E',NULL,50536,34.13,0.25,66.2,13356,70,NULL,'SALT','NGC 2441',0.01158,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50537,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 1995E',NULL,50537,35.52,0.04,125,13356,65,NULL,'MLCS','NGC 2441',0.01158,'1996ApJ...473..588R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50538,'Ring Diameter','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50538,33.3,0.84,46,13356,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 2441',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50539,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50539,36.51,0.46,201,13357,70,NULL,NULL,'2MASX J07515512+2959298',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000052,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,117.979625,29.99147,0.121,NULL,63425618125,991025283,15484770,17.5),(50540,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50540,35.67,0.49,136,13358,75,NULL,'IR','UGC 04061',NULL,'2011yCatp016004901K',2011,1,1.06,NULL,'G',0.000033,NULL,'15.9g',0.2,'Sbc','Group member',NULL,NULL,NULL,1,117.982083,27.30297,0.113,NULL,64292518140,1004570595,15696415,15.9),(50541,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50541,35.68,NULL,137,13358,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04061',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50542,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50542,35.69,NULL,137,13358,NULL,NULL,'Dipole + Quadrupole','UGC 04061',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50543,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50543,35.71,NULL,138,13358,NULL,NULL,'Dipole','UGC 04061',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50544,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50544,35.75,NULL,141,13358,NULL,NULL,NULL,'UGC 04061',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50545,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50545,37.88,0.46,376,13359,70,NULL,NULL,'2MASX J07515763+5211071',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00017,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,117.99025,52.18533,0.153,NULL,63511705372,992370396,15505787,17.6),(50546,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50546,37.99,0.46,396,13360,70,NULL,NULL,'2MASX J07515838+4034080',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000075,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,117.993083,40.56881,0.249,NULL,63566401272,993225019,15519140,17.3),(50547,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50547,37.68,0.46,343,13361,70,NULL,NULL,'2MASXi J0751591+275009',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,117.9962917,27.83597,0.069,NULL,63418978604,990921540,15483149,17.4),(50548,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50548,36.47,0.17,196,13362,70,NULL,NULL,'2MASX J07515981+2325576',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,'FoF','16.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,117.999375,23.43272,0.261,NULL,63753776922,996152764,15564886,16.6),(50549,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50549,38.02,0.46,402,13363,70,NULL,NULL,'2MASX J07520040+1026378',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.7g',NULL,NULL,NULL,NULL,NULL,NULL,1,118.0017917,10.44394,0.013,NULL,62763163992,980674437,15323038,17.7),(50550,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50550,38.21,0.46,439,13364,70,NULL,NULL,'2MASX J07520055+1400387',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000137,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,118.002375,14.01064,0.085,NULL,62635063539,978672867,15291763,18),(50551,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50551,37.9,0.46,381,13365,70,NULL,NULL,'SDSS J075200.79+282902.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,118.003333,28.48411,0.097,NULL,63424388439,991006069,15484469,18.7),(50552,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50552,34.94,0.19,97.5,13366,70,NULL,NULL,'2MASX J07520416+5007512',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00018,NULL,'16.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,118.01725,50.13083,0.193,NULL,63515234816,992425544,15506649,16.1),(50553,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50553,37.1,0.33,264,13367,70,NULL,NULL,'2MASX J07520438+1527367',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000182,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,118.018375,15.46011,0.085,NULL,62676570101,979321407,15301896,17.4),(50554,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50554,37.1,0.46,263,13368,70,NULL,NULL,'2MASX J07520463+2750063',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000177,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,118.01925,27.83506,0.069,NULL,63418934114,990920845,15483138,16.3),(50555,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50555,37.41,0.46,304,13369,70,NULL,NULL,'2MASX J07520602+2145573',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000166,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,118.025083,21.76589,0.181,NULL,62615498155,978367158,15286986,16.9),(50556,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50556,36.47,0.17,196,13370,70,NULL,NULL,'2MASX J07520634+2328223',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,118.0265,23.47272,0.261,NULL,63754244989,996160077,15565001,17.7),(50557,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50557,37.02,0.33,253,13371,70,NULL,NULL,'2MASX J07520686+2256233',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000141,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,118.0285,22.93983,0.281,NULL,63757129854,996205153,15565705,17.6),(50558,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50558,36.47,0.17,196,13372,70,NULL,NULL,'IC 0477',NULL,'2015arXiv151105856S',2015,1,0.96,NULL,'G',0.00016,NULL,'16.11',0.7,NULL,NULL,NULL,NULL,NULL,1,118.028875,23.48303,0.261,NULL,63754245040,996160078,15565001,16.11),(50559,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50559,35.28,0.46,114,13373,70,NULL,NULL,'IC 2208',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.000187,NULL,'14.5g',0.61,'S0^-','Group member',NULL,NULL,NULL,1,118.032667,27.48392,0.085,NULL,64292620184,1004572190,15696440,14.5),(50560,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50560,37.99,0.46,397,13374,70,NULL,NULL,'2MASX J07520969+3102277',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000195,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,118.0405,31.04094,0.121,NULL,63422445615,990975712,15483995,17.4),(50561,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50561,37.1,0.33,264,13375,70,NULL,NULL,'2MASX J07521164+1527097',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000169,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,118.048375,15.45281,0.085,NULL,62676568988,979321390,15301896,17.7),(50562,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50562,37.1,0.46,263,13376,70,NULL,NULL,'2MASX J07521309+2845303',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,'FoF','16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,118.0545,28.75847,0.097,NULL,63424380442,991005944,15484467,16.2),(50563,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50563,38.07,0.46,412,13377,70,NULL,NULL,'2MASX J07521369+3802097',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000094,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,118.057167,38.03603,0.177,NULL,63441862193,991279096,15488735,17.2),(50564,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50564,37.9,0.46,380,13378,70,NULL,NULL,'SDSS J075215.39+224407.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,118.064167,22.73531,0.281,NULL,63757096827,996204637,15565697,18.1),(50565,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50565,37.4,0.46,302,13379,70,NULL,NULL,'SDSS J075215.80+360604.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00007,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,118.065833,36.10133,0.197,NULL,63447924918,991373826,15490216,18),(50566,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50566,37.45,0.46,309,13380,70,NULL,NULL,'SDSS J075217.93+475025.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000157,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,118.07475,47.84036,0.221,NULL,63506459830,992288434,15504506,18.5),(50567,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50567,33.32,0.69,46.2,13381,100,NULL,'mid-IR','ESO 493- G 024',NULL,'2013ApJ...771...88L',2013,1,1.23,'abs(b) < 10 degrees.','G',0.00001,NULL,'15.0',0.57,'Sb:',NULL,NULL,NULL,NULL,1,118.085917,-25.14464,NULL,NULL,42681896403,666904631,10420384,15),(50568,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50568,37.09,0.46,262,13382,70,NULL,NULL,'2MASX J07522095+2927122',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000077,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,118.0872917,29.4535,0.101,NULL,63425002123,991015658,15484619,17),(50569,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50569,36.76,0.46,225,13383,70,NULL,NULL,'2MASX J07522196+2322282',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,118.091625,23.37461,0.261,NULL,63753808491,996153257,15564894,17.6),(50570,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50570,36.47,0.17,196,13384,70,NULL,NULL,'2MASX J07522227+2332372',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000173,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,118.0927917,23.54381,0.261,NULL,63754262110,996160345,15565005,17),(50571,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50571,36.88,0.33,238,13385,70,NULL,NULL,'2MASX J07522371+2244042',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,118.098875,22.73464,0.281,NULL,63757150570,996205477,15565710,17.1),(50572,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50572,36.7,0.52,219,13386,70,NULL,NULL,'2MASX J07522451-4915353',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,118.102083,-49.25975,0.617,NULL,42524769065,664449516,10382023,16.7),(50573,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50573,37.35,0.46,296,13387,70,NULL,NULL,'2MASX J07522482+2845202',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,118.10325,28.75567,0.097,NULL,63424376408,991005881,15484466,16.9),(50574,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50574,37.77,0.46,358,13388,70,NULL,NULL,'2MASX J07522572+3029375',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000178,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,118.107375,30.49378,0.121,NULL,63426058556,991032164,15484877,17.3),(50575,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50575,38.35,0.46,467,13389,70,NULL,NULL,'2MASX J07522661+1324314',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,118.1109583,13.40875,0.069,NULL,62636949212,978702331,15292223,18.2),(50576,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50576,36.88,0.33,238,13390,70,NULL,NULL,'2MASX J07522862+2244202',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,118.11925,22.73906,0.281,NULL,63757152179,996205502,15565710,17.6),(50577,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50577,36.71,0.33,220,13391,70,NULL,NULL,'2MASX J07523041+5220382',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000177,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,118.1267917,52.34383,0.153,NULL,63511572985,992368327,15505755,16.4),(50578,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50578,34.89,NULL,95.3,13392,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0667',NULL,'2010Ap&SS.325..163P',2010,1,0.9,NULL,'G',NULL,NULL,'16.8',0.1,'Scd',NULL,NULL,NULL,NULL,1,118.127083,60.60361,0.161,NULL,61570838895,962044357,15031943,16.8),(50579,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50579,34.92,NULL,96.4,13392,NULL,NULL,'Dipole + Quadrupole','FGC 0667',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50580,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50580,34.92,NULL,96.5,13392,NULL,NULL,'Dipole','FGC 0667',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50581,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50581,34.97,NULL,98.7,13392,NULL,NULL,NULL,'FGC 0667',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50582,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50582,36.65,0.46,214,13393,70,NULL,NULL,'2MASX J07523125+2252462',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000175,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,118.130041667,22.87958,0.281,NULL,63757134077,996205219,15565706,17.3),(50583,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50583,37.36,0.46,296,13394,70,NULL,NULL,'2MASX J07523259+3206245',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000159,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,118.135875,32.10678,0.161,NULL,63477296625,991832759,15497386,17),(50584,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50584,37.16,0.11,271,13395,70,NULL,NULL,'2MASX J07523512+2926562',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000144,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,118.146375,29.44903,0.101,NULL,63424988868,991015451,15484616,17.6),(50585,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50585,34.73,0.2,88.3,13396,74.4,NULL,NULL,'UGC 04059',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000037,NULL,'15.20',0.6,'Scd:',NULL,NULL,NULL,NULL,1,118.1514583,62.54664,0.137,NULL,61555795348,961809302,15028270,15.2),(50586,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50586,34.85,0.51,93.5,13396,NULL,NULL,NULL,'UGC 04059',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50587,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50587,34.93,0.49,96.8,13396,NULL,NULL,'Malmquist cor.','UGC 04059',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50588,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50588,38.17,0.33,430,13397,70,NULL,NULL,'SDSS J075236.98+280139.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000167,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,118.154125,28.02753,0.085,NULL,64303923319,1004748801,15699200,18.5),(50589,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50589,37.16,0.11,271,13398,70,NULL,NULL,'2MASX J07523742+2934162',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000083,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,118.156083,29.57108,0.101,NULL,63424522977,991008171,15484502,16.8),(50590,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50590,38.17,0.33,430,13399,70,NULL,NULL,'2MASX J07523808+2801352',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000207,NULL,'15.8g',0.47,'E0',NULL,NULL,NULL,NULL,1,118.158583333,28.02658,0.085,NULL,64303923269,1004748801,15699200,15.8),(50591,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50591,37.72,0.33,350,13400,70,NULL,NULL,'SDSS J075239.20+284742.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000135,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,118.163375,28.79522,0.097,NULL,63424258038,991004031,15484437,18.5),(50592,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50592,38.12,0.46,420,13401,70,NULL,NULL,'SDSS J075239.35+280404.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000174,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,118.164,28.06781,0.085,NULL,64299729866,1004683279,15698176,18.2),(50593,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50593,36.16,0.46,170,13402,70,NULL,NULL,'2MASX J07524051+1824320',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00017,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,118.1687917,18.40881,0.189,NULL,62618052343,978407067,15287610,16.7),(50594,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50594,36.09,0.49,166,13403,75,NULL,'IR','FGC 0672',NULL,'2011yCatp016004901K',2011,1,1.14,NULL,'G',0.000016,NULL,'16.5g',0.17,'Sc',NULL,NULL,NULL,NULL,1,118.18125,24.12217,0.237,NULL,63754179304,996159051,15564985,16.5),(50595,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50595,36.19,NULL,173,13403,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0672',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50596,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50596,36.21,NULL,174,13403,NULL,NULL,'Dipole + Quadrupole','FGC 0672',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50597,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50597,36.22,NULL,176,13403,NULL,NULL,NULL,'FGC 0672',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50598,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50598,36.23,NULL,176,13403,NULL,NULL,'Dipole','FGC 0672',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50599,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50599,36.71,0.2,220,13403,74.4,NULL,NULL,'FGC 0672',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50600,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50600,36.74,0.43,223,13403,75,NULL,'3.6 micron, color corrected','FGC 0672',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50601,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50601,36.81,0.43,230,13403,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0672',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50602,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50602,37.21,0.46,277,13404,70,NULL,NULL,'2MASX J07524425+1642343',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000173,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,118.1845,16.70953,0.125,NULL,62673915376,979279927,15301248,16.6),(50603,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50603,37.02,0.33,253,13405,70,NULL,NULL,'SDSS J075246.21+231225.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000144,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,118.192583,23.20697,0.277,NULL,63757248160,996207002,15565734,18.1),(50604,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50604,37.78,0.46,360,13406,70,NULL,NULL,'2MASX J07524674+2936131',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000113,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,118.19475,29.60372,0.101,NULL,63424517227,991008081,15484501,17.4),(50605,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50605,35.36,0.52,118,13407,70,NULL,NULL,'2MASX J07524689-6359015',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.3,NULL,NULL,NULL,NULL,NULL,1,118.195375,-63.98389,0.673,NULL,40635174756,634924605,9920696,14),(50606,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50606,38.19,0.46,434,13408,70,NULL,NULL,'2MASX J07524734+1516299',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,118.197125,15.27503,0.085,NULL,62676556200,979321190,15301893,17.9),(50607,'Brightest Stars','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50607,30.4,1,12,13409,NULL,NULL,NULL,'KDG 050',NULL,'2002PASP..114.1206D',2002,1,0.7,NULL,'G',NULL,NULL,'17.88',0.6,'dImV','Dwarf, field object',NULL,NULL,NULL,1,118.1975,61.38972,0.169,NULL,61559745810,961871028,15029234,17.88),(50608,'TRGB','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50608,29.4,NULL,7.59,13409,NULL,NULL,NULL,'KDG 050',NULL,'2002PASP..114.1206D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50609,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50609,37.12,0.27,265,13410,70,NULL,NULL,'2MASX J07524748+4414588',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',NULL,'FoF','16.86',0.49,NULL,NULL,NULL,NULL,NULL,1,118.197875,44.24969,0.237,NULL,63559774344,993121474,15517523,16.86),(50610,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50610,36.96,0.46,247,13411,70,NULL,NULL,'2MASX J07524919+2937512',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000077,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,118.2050417,29.63106,0.101,NULL,63424547750,991008558,15484508,17.6),(50611,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50611,37.12,0.27,265,13412,70,NULL,NULL,'2MASX J07524933+4418488',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000075,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,118.205375,44.31358,0.237,NULL,63559773429,993121459,15517522,17.7),(50612,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50612,37.87,0.46,375,13413,70,NULL,NULL,'2MASX J07524974+4344488',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'16.5r',NULL,NULL,NULL,NULL,NULL,NULL,1,118.20725,43.74697,0.225,NULL,63560445316,993131958,15517686,16.5),(50613,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50613,37.96,0.46,391,13414,70,NULL,NULL,'2MASX J07525088+2531172',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000125,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,118.211917,25.52144,0.165,NULL,64293790013,1004590468,15696726,18.4),(50614,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50614,37.12,0.27,265,13415,70,NULL,NULL,'2MASX J07525129+4415528',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00009,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,118.213791667,44.26453,0.237,NULL,63559774314,993121473,15517523,16.7),(50615,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50615,37.2,0.23,275,13416,70,NULL,NULL,'2MASX J07525192+2622012',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,118.2162917,26.367,0.109,NULL,64292777106,1004574642,15696478,16.9),(50616,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50616,36.7,0.27,219,13417,70,NULL,NULL,'2MASX J07525342+4557208',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,118.2224583,45.95583,0.261,NULL,63527174267,992612097,15509564,17.5),(50617,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50617,36.95,0.46,246,13418,70,NULL,NULL,'2MASX J07525580+4108541',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000066,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,118.2324583,41.14844,0.193,NULL,63568842417,993263162,15519736,17.6),(50618,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50618,32.47,NULL,31.2,13419,NULL,NULL,NULL,'UGC 04068',NULL,'2000BSAO...50....5K',2000,1,0.84,NULL,'G',0.000098,NULL,'16.8g',0.2,'Sc(f)          NLAGN',NULL,NULL,NULL,'Sy 2',1,118.238458333,40.17397,0.225,NULL,63566335659,993223994,15519124,16.8),(50619,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50619,37.87,0.46,375,13420,70,NULL,NULL,'SDSS J075258.47+255951.5',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000146,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,118.243666667,25.99767,0.105,NULL,64293894479,1004592101,15696751,17.2),(50620,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50620,37.87,0.46,375,13421,70,NULL,NULL,'2MASX J07530128+3217273',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,118.2552083,32.29089,0.185,NULL,63477408442,991834506,15497414,18.2),(50621,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50621,37.16,0.11,271,13422,70,NULL,NULL,'2MASX J07530353+2927522',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000063,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,118.264625,29.46458,0.101,NULL,63424630156,991009846,15484528,17.5),(50622,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50622,37.52,0.46,319,13423,70,NULL,NULL,'2MASX J07530454+4552038',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,118.269167,45.86767,0.261,NULL,63527170166,992612033,15509563,17.5),(50623,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50623,37.73,0.46,351,13424,70,NULL,NULL,'2MASX J07530492+3638320',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000094,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,118.270541667,36.64231,0.197,NULL,63450664643,991416635,15490884,16.5),(50624,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50624,34.9,0.49,95.6,13425,75,NULL,'IR','UGC 04065',NULL,'2011yCatp016004901K',2011,1,1.81,NULL,'G',0.000037,NULL,'15.41',0.21,'Sdm',NULL,NULL,NULL,NULL,1,118.272,55.24006,0.129,NULL,61578622711,962165979,15033843,15.41),(50625,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50625,35.12,NULL,106,13425,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04065',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50626,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50626,35.13,NULL,106,13425,NULL,NULL,'Dipole + Quadrupole','UGC 04065',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50627,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50627,35.14,NULL,107,13425,NULL,NULL,'Dipole','UGC 04065',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50628,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50628,35.34,NULL,117,13425,NULL,NULL,NULL,'UGC 04065',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50629,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50629,35.36,0.44,118,13425,NULL,NULL,'Malmquist cor.','UGC 04065',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50630,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50630,35.59,0.4,131,13425,NULL,NULL,NULL,'UGC 04065',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50631,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50631,35.65,0.2,135,13425,74.4,NULL,NULL,'UGC 04065',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50632,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50632,37.77,0.46,359,13426,70,NULL,NULL,'2MASX J07530656+5118060',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000176,NULL,'18.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,118.27725,51.30167,0.161,NULL,63514644475,992416319,15506504,18),(50633,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50633,37.31,0.46,290,13427,70,NULL,NULL,'2MASX J07530888+2919252',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00008,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,118.286916667,29.32358,0.081,NULL,63424595163,991009299,15484520,17.2),(50634,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50634,37.72,0.33,350,13428,70,NULL,NULL,'2MASX J07530966+2836002',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000143,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,118.290375,28.59994,0.097,NULL,63424268764,991004199,15484440,17.5),(50635,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50635,37.54,0.46,323,13429,70,NULL,NULL,'2MASX J07530993+2814072',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,118.2914583,28.23542,0.085,NULL,64299783738,1004684120,15698189,18.1),(50636,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50636,36.47,0.17,196,13430,70,NULL,NULL,'2MASX J07531121+2329321',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000178,NULL,'16.0g',0.38,'E0',NULL,NULL,NULL,NULL,1,118.296625,23.49236,0.189,NULL,63753748895,996152326,15564880,16),(50637,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50637,37.02,0.46,253,13431,70,NULL,NULL,'2MASX J07531146+3704482',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000075,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,118.297917,37.08014,0.201,NULL,63449623565,991400368,15490630,16.9),(50638,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50638,35.32,0.61,116,13432,70,NULL,NULL,'2MASX J07531298-7129382',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,118.303708333,-71.494,0.709,NULL,40628882353,634826286,9919160,17.5),(50639,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50639,37.54,0.46,322,13433,70,NULL,NULL,'2MASX J07531432+1834371',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,118.309875,18.57686,0.209,NULL,62625373208,978521456,15289397,17.9),(50640,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50640,38,0.46,399,13434,70,NULL,NULL,'SDSS J075315.73+372414.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000074,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,118.315583,37.40414,0.189,NULL,63449821551,991403461,15490679,18),(50641,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50641,37.16,0.11,271,13435,70,NULL,NULL,'2MASX J07531662+2924051',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000073,NULL,'16.2g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,118.319208333,29.40139,0.081,NULL,63424596843,991009325,15484520,16.2),(50642,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50642,36.73,0.46,222,13436,70,NULL,NULL,'2MASX J07532006+1921051',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000187,NULL,'16.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,118.333667,19.35153,0.113,NULL,62625501002,978523453,15289428,16.3),(50643,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50643,37.06,0.46,258,13437,70,NULL,NULL,'2MASX J07532119+4754238',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,118.3384583,47.90647,0.221,NULL,63506284508,992285695,15504463,17.2),(50644,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50644,37.89,0.33,378,13438,70,NULL,NULL,'2MASX J07532122+3539283',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000203,NULL,'16.4g',0.32,'AGN',NULL,NULL,NULL,NULL,1,118.338583333,35.65789,0.181,NULL,63448174566,991377727,15490276,16.4),(50645,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50645,36.71,0.33,220,13439,70,NULL,NULL,'2MASX J07532163+5224289',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000162,NULL,'17.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,118.340167,52.40803,0.153,NULL,63513452576,992397696,15506214,17.1),(50646,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50646,37.85,0.46,372,13440,70,NULL,NULL,'2MASX J07532356+2632441',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,118.348083333,26.54567,0.109,NULL,64293220410,1004581568,15696587,17.5),(50647,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50647,37.33,0.46,292,13441,70,NULL,NULL,'2MASX J07532373+1912180',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00016,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,118.348833333,19.20489,0.113,NULL,62626088922,978532639,15289572,16.9),(50648,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50648,36.77,0.46,226,13442,70,NULL,NULL,'SDSS J075327.01+441133.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000061,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,118.362541667,44.19275,0.225,NULL,63559813746,993122089,15517532,17.9),(50649,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50649,36.87,0.23,237,13443,70,NULL,NULL,'2MASX J07532811+2815441',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000174,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,118.3670417,28.26239,0.085,NULL,64299792850,1004684263,15698191,17),(50650,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50650,36.7,0.46,218,13444,70,NULL,NULL,'2MASX J07532993+2054420',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,118.374667,20.91172,0.125,NULL,62627177948,978549655,15289838,17.1),(50651,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50651,37.16,0.11,271,13445,70,NULL,NULL,'2MASX J07533044+2919241',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00008,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,118.376875,29.32331,0.081,NULL,63424599505,991009367,15484521,17.1),(50652,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50652,36.87,0.23,237,13446,70,NULL,NULL,'2MASX J07533076+2818501',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,118.3782083,28.314,0.077,NULL,64299766788,1004683856,15698185,NULL),(50653,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50653,36.78,0.33,227,13447,70,NULL,NULL,'CGCG 206-037',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.000173,NULL,'14.8g',0.75,'E0',NULL,NULL,NULL,NULL,1,118.3819583,38.73328,0.189,NULL,63440977176,991265268,15488519,14.8),(50654,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50654,38.17,0.46,430,13448,70,NULL,NULL,'2MASX J07533168+1322015',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,118.382083,13.36703,0.077,NULL,62637569570,978712024,15292375,17.8),(50655,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50655,35.52,0.46,127,13449,70,NULL,NULL,'UGC 04071',NULL,'2015arXiv151105856S',2015,1,0.99,NULL,'G',0.000087,NULL,'14.6g',0.68,NULL,NULL,NULL,NULL,NULL,1,118.3917083,51.78017,0.153,NULL,63513324721,992395698,15506182,14.6),(50656,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50656,38.14,0.46,425,13450,70,NULL,NULL,'SDSS J075334.21+504801.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,118.392583,50.80042,0.173,NULL,63515291312,992426426,15506662,18),(50657,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50657,37.92,0.46,385,13451,70,NULL,NULL,'2MASX J07533494+1506225',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000154,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,118.3957083,15.10628,0.089,NULL,62665161777,979143152,15299111,17.2),(50658,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50658,37.69,0.46,346,13452,70,NULL,NULL,'2MASX J07533510+3547114',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000176,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,118.3962083,35.78656,0.181,NULL,63448059728,991375933,15490248,16.9),(50659,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50659,35.48,0.46,125,13453,70,NULL,NULL,'2MASX J07533603+2502071',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000159,NULL,'16.5g',0.33,'S0^-',NULL,NULL,NULL,NULL,1,118.40025,25.03525,0.237,NULL,64294152097,1004596126,15696814,16.5),(50660,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50660,37.71,0.46,348,13454,70,NULL,NULL,'2MASX J07533686+3756042',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000111,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,118.40375,37.93447,0.197,NULL,63450251981,991410187,15490784,16.4),(50661,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50661,37.41,0.46,304,13455,70,NULL,NULL,'2MASX J07533811+1946511',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,118.40875,19.781,0.153,NULL,62629050795,978578918,15290295,17.6),(50662,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50662,38.17,0.33,430,13456,70,NULL,NULL,'SDSS J075338.14+213248.0',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000164,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,118.408917,21.54669,0.209,NULL,62615617636,978369025,15287016,18.8),(50663,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50663,36.78,0.33,227,13457,70,NULL,NULL,'2MASX J07533815+3847492',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,118.409125,38.79692,0.189,NULL,63440971036,991265172,15488518,16.9),(50664,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50664,38.17,0.33,430,13458,70,NULL,NULL,'2MASX J07533829+2136141',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000169,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,118.409583,21.60386,0.209,NULL,62615619432,978369053,15287016,17.4),(50665,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50665,37.3,0.46,288,13459,70,NULL,NULL,'2MASX J07534080+3948352',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00009,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,118.42,39.80978,0.213,NULL,63566602905,993228170,15519190,16.9),(50666,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50666,36.67,0.46,216,13460,70,NULL,NULL,'2MASX J07534136+5336006',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,118.422208333,53.60025,0.081,NULL,61578970507,962171414,15033928,16.5),(50667,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50667,37.2,0.23,275,13461,70,NULL,NULL,'2MASX J07534180+2625061',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000151,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,118.424291667,26.41825,0.109,NULL,64293186467,1004581038,15696578,16.9),(50668,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50668,36.14,0.46,169,13462,70,NULL,NULL,'2MASX J07534302+2130021',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000169,NULL,'15.9g',0.48,'S0/a',NULL,NULL,NULL,NULL,1,118.4294583,21.50056,0.209,NULL,62614831732,978356745,15286824,15.9),(50669,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50669,33.75,NULL,56.1,13463,NULL,NULL,NULL,'FGC 0675',NULL,'2000BSAO...50....5K',2000,1,0.03,NULL,'G',0.000017,NULL,'22.5g',0.03,'Sd(f)',NULL,NULL,NULL,NULL,1,118.438625,39.78261,0.213,NULL,63566602519,993228164,15519190,22.5),(50670,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50670,33.85,NULL,58.8,13463,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0675',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50671,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50671,33.87,NULL,59.4,13463,NULL,NULL,'Dipole + Quadrupole','FGC 0675',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50672,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50672,33.88,NULL,59.8,13463,NULL,NULL,'Dipole','FGC 0675',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50673,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50673,33.97,0.43,62.3,13463,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0675',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50674,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50674,36.9,0.46,240,13464,70,NULL,NULL,'2MASX J07534552+2255051',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,118.439625,22.91794,0.281,NULL,63757343136,996208486,15565757,17.3),(50675,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50675,37.55,0.46,324,13465,70,NULL,NULL,'2MASX J07534563+2639121',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000184,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,118.440125,26.65336,0.145,NULL,64293196738,1004581199,15696581,16.7),(50676,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50676,36.81,0.33,230,13466,70,NULL,NULL,'2MASX J07534670+1424431',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000168,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,118.444625,14.41206,0.113,NULL,62634723378,978667552,15291680,16.4),(50677,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50677,38.17,0.46,431,13467,70,NULL,NULL,'2MASX J07534724+1512491',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000179,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,118.4467083,15.21358,0.085,NULL,62676654375,979322724,15301917,17.1),(50678,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50678,31.32,NULL,18.4,13468,NULL,NULL,NULL,'AGC 174616',NULL,'2015AstBu..70....1K',2015,1,NULL,NULL,'RadioS',0.000092,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,118.44875,10.15139,0.005,NULL,62763201679,980675026,15323047,NULL),(50679,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50679,37.89,0.33,378,13469,70,NULL,NULL,'SDSS J075347.70+353509.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,118.4487917,35.58594,0.181,NULL,63447676246,991369941,15490155,18.5),(50680,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50680,37.1,0.46,263,13470,70,NULL,NULL,'2MASX J07534800+4439469',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000098,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,118.4499583,44.66303,0.193,NULL,63557067594,993079181,15516862,16.3),(50681,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50681,36.2,0.46,174,13471,70,NULL,NULL,'2MASX J07534821+1550081',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000179,NULL,'15.5g',0.4,NULL,NULL,NULL,NULL,NULL,1,118.450833,15.83558,0.097,NULL,62677550898,979336732,15302136,15.5),(50682,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50682,37.2,0.23,275,13472,70,NULL,NULL,'2MASX J07534935+2636550',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000171,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,118.4555,26.61522,0.145,NULL,64293199369,1004581240,15696581,17),(50683,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50683,36.45,0.46,195,13473,70,NULL,NULL,'2MASX J07535101+2803231',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,118.4625,28.05639,0.085,NULL,64303961017,1004749390,15699209,16.6),(50684,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50684,35.78,0.49,143,13474,70,NULL,NULL,'ESO 059- G 022',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'15.36',0.3,'Sbc',NULL,NULL,NULL,NULL,1,118.468,-72.21583,0.773,NULL,40627592874,634806138,9918845,15.36),(50685,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50685,36.57,0.33,206,13475,70,NULL,NULL,'2MASX J07535238+1315231',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000171,NULL,'16.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,118.468416667,13.25628,0.077,NULL,62637682663,978713791,15292402,16.1),(50686,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50686,37.71,0.46,348,13476,70,NULL,NULL,'2MASX J07535319+5200186',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000179,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,118.47175,52.00508,0.165,NULL,63513543474,992399116,15506236,17.2),(50687,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50687,37.16,0.11,271,13477,70,NULL,NULL,'2MASX J07535375+2915111',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000073,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,118.474041667,29.25319,0.081,NULL,63424616423,991009631,15484525,16.9),(50688,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50688,37.33,0.46,293,13478,70,NULL,NULL,'2MASX J07535412+1626160',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000133,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,118.4754583,16.43783,0.101,NULL,62679184156,979362252,15302535,17.4),(50689,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50689,36.57,0.33,206,13479,70,NULL,NULL,'2MASX J07535498+1309171',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000233,NULL,'15.4g',0.51,NULL,NULL,NULL,NULL,NULL,1,118.479083333,13.15458,0.077,NULL,62637676055,978713688,15292401,15.4),(50690,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50690,37.41,0.46,304,13480,70,NULL,NULL,'2MASX J07535596+5216056',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000156,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,118.483125,52.26828,0.153,NULL,63513452049,992397688,15506213,17.4),(50691,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50691,37.87,0.46,375,13481,70,NULL,NULL,'2MASX J07535619+1422010',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00017,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,118.4842083,14.367,0.121,NULL,62635445480,978678835,15291856,17),(50692,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50692,37.08,0.46,261,13482,70,NULL,NULL,'2MASX J07535711+2309001',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,118.4880417,23.15003,0.237,NULL,63757264337,996207255,15565738,18),(50693,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50693,37.7,0.46,347,13483,70,NULL,NULL,'2MASX J07535768+2521151',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000145,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,118.490333,25.35428,0.213,NULL,64294253326,1004597708,15696839,17.5),(50694,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50694,36.87,0.23,237,13484,70,NULL,NULL,'CGCG 148-056',NULL,'2015arXiv151105856S',2015,1,1.2,NULL,'G',0.00014,NULL,'15.6',0.5,NULL,NULL,NULL,NULL,NULL,1,118.495125,28.05022,0.085,NULL,64303963784,1004749434,15699209,15.6),(50695,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50695,36.81,0.33,230,13485,70,NULL,NULL,'2MASX J07535909+1431250',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.0002,NULL,'16.1g',0.39,NULL,NULL,NULL,NULL,NULL,1,118.496375,14.52378,0.113,NULL,62665080001,979141875,15299091,16.1),(50696,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50696,38.21,0.23,439,13486,70,NULL,NULL,'2MASX J07540243+4345035',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000066,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,118.510083,43.75092,0.225,NULL,63560377101,993130892,15517670,18.3),(50697,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50697,35.45,0.2,123,13487,74.4,NULL,NULL,'CGCG 058-065',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.00006,NULL,'15.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,118.518708333,13.95411,0.149,NULL,62635280478,978676257,15291816,15.4),(50698,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50698,38.21,0.23,439,13488,70,NULL,NULL,'2MASX J07540452+4346079',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,'PHOT','17.1g',0.26,'BrClG',NULL,NULL,NULL,NULL,1,118.518708333,43.76881,0.225,NULL,63560376598,993130884,15517670,17.1),(50699,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50699,33.52,0.47,50.5,13489,NULL,NULL,'H','UGC 04057',NULL,'2007A&A...465...71T',2007,1,2.5,NULL,'G',0.00003,NULL,'13.40',0.8,'Sa','in a pair',NULL,NULL,NULL,1,118.52,74.38625,0.093,NULL,61303598503,957868726,14966698,13.4),(50700,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50700,33.53,0.45,50.7,13489,NULL,NULL,'K','UGC 04057',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50701,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50701,33.53,0.46,50.8,13489,NULL,NULL,'J','UGC 04057',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50702,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50702,33.72,0.4,55.4,13489,NULL,NULL,'mean','UGC 04057',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50703,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50703,36.87,0.23,237,13490,70,NULL,NULL,'2MASX J07540560+2810401',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000175,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,118.523333,28.17792,0.085,NULL,64299758368,1004683724,15698183,16.4),(50704,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50704,38.21,0.23,439,13491,70,NULL,NULL,'2MASX J07540584+4346345',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000079,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,118.524375,43.77644,0.225,NULL,63560376628,993130884,15517670,17.7),(50705,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50705,37.16,0.11,271,13492,70,NULL,NULL,'SDSS J075405.88+291656.5',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000093,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,118.5245417,29.28239,0.081,NULL,63424622988,991009734,15484527,16.6),(50706,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50706,36.81,0.46,230,13493,70,NULL,NULL,'SDSS J075406.45+203929.8',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,118.526917,20.65828,0.121,NULL,62627239347,978550614,15289853,17),(50707,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50707,38.75,0.46,562,13494,70,NULL,NULL,'SDSS J075407.43+161003.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000174,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,118.531,16.16753,0.089,NULL,62677219753,979331558,15302055,18.1),(50708,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50708,37.32,0.46,291,13495,70,NULL,NULL,'2MASX J07540745+2741301',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000182,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,118.531167,27.69178,0.061,NULL,64303943392,1004749115,15699204,16.6),(50709,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50709,37.16,0.11,271,13496,70,NULL,NULL,'2MASX J07540857+2915521',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000077,NULL,'16.4g',0.33,'Sa',NULL,NULL,NULL,NULL,1,118.53575,29.26453,0.081,NULL,63424620624,991009697,15484526,16.4),(50710,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50710,38.39,0.46,476,13497,70,NULL,NULL,'SDSS J075409.17+312929.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000147,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,118.53825,31.49142,0.137,NULL,63422520606,990976884,15484013,18.8),(50711,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50711,38.07,0.46,411,13498,70,NULL,NULL,'SDSS J075409.63+513018.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000147,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,118.540166667,51.50525,0.153,NULL,63513010306,992390786,15506106,18.5),(50712,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50712,37.62,0.46,334,13499,70,NULL,NULL,'SDSS J075409.76+484232.0',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.6g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,118.540667,48.70889,0.217,NULL,63507791827,992309247,15504831,16.6),(50713,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50713,37.04,0.33,255,13500,70,NULL,NULL,'2MASX J07541035+2554251',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000173,NULL,'17.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,118.543333,25.90697,0.141,NULL,64294420140,1004600314,15696879,17.6),(50714,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50714,37.2,0.23,275,13501,70,NULL,NULL,'2MASX J07541122+2621471',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00013,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,118.546667,26.36322,0.125,NULL,64293182387,1004580974,15696577,17.3),(50715,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50715,36.85,0.46,235,13502,70,NULL,NULL,'2MASX J07541365+1958007',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,118.556917,19.96683,0.145,NULL,62626759817,978543122,15289736,17.1),(50716,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50716,38.21,0.23,439,13503,70,NULL,NULL,'SDSS J075415.02+434843.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000076,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,118.562625,43.81211,0.225,NULL,63559868388,993122943,15517545,18.6),(50717,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50717,38.07,0.46,410,13504,70,NULL,NULL,'SDSS J075417.72+181441.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.0001,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,118.573875,18.24478,0.165,NULL,62623071851,978485497,15288835,18.4),(50718,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50718,37.57,0.46,327,13505,70,NULL,NULL,'2MASX J07541792+2954341',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000104,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,118.574583,29.9095,0.117,NULL,63424455801,991007121,15484486,18.2),(50719,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50719,36.9,0.46,240,13506,70,NULL,NULL,'2MASX J07541807+2947570',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000083,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,118.57525,29.79928,0.117,NULL,63424453850,991007091,15484485,17.4),(50720,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50720,37.87,0.46,375,13507,70,NULL,NULL,'2MASX J07541810+2609060',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000161,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,118.5754583,26.15181,0.105,NULL,64293504655,1004586010,15696656,17),(50721,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50721,36.78,0.46,227,13508,70,NULL,NULL,'2MASX J07541833+5309162',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00018,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,118.5765417,53.15461,0.121,NULL,63511939285,992374051,15505844,16.5),(50722,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50722,37.83,0.46,367,13509,70,NULL,NULL,'2MASX J07541872+3526081',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000179,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,118.5780417,35.43556,0.181,NULL,63447651969,991369562,15490149,17.3),(50723,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50723,37.21,0.46,277,13510,70,NULL,NULL,'2MASX J07541963+1834427',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,118.5817083,18.57844,0.153,NULL,62625251832,978519559,15289368,NULL),(50724,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50724,37.04,0.33,255,13511,70,NULL,NULL,'2MASX J07541961+2551290',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,'FoF','17.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,118.58175,25.85814,0.141,NULL,64294405586,1004600087,15696876,17.6),(50725,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50725,37.88,0.46,376,13512,70,NULL,NULL,'2MASX J07542029+3326441',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,118.584583,33.44558,0.165,NULL,63443581995,991305968,15489155,17.4),(50726,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50726,34.37,0.2,74.8,13513,74.4,NULL,NULL,'FGC 0677',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000014,NULL,'16.4g',0.16,'Sc',NULL,NULL,NULL,NULL,1,118.5849583,32.77464,0.177,NULL,63477071132,991829236,15497331,16.4),(50727,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50727,34.48,0.43,78.8,13513,75,NULL,'3.6 micron, color corrected','FGC 0677',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50728,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50728,34.58,0.43,82.3,13513,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0677',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50729,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50729,34.75,0.49,89.1,13513,75,NULL,'IR','FGC 0677',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50730,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50730,34.76,NULL,89.5,13513,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0677',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50731,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50731,34.78,NULL,90.3,13513,NULL,NULL,'Dipole + Quadrupole','FGC 0677',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50732,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50732,34.79,NULL,90.8,13513,NULL,NULL,'Dipole','FGC 0677',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50733,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50733,34.92,NULL,96.2,13513,NULL,NULL,NULL,'FGC 0677',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50734,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50734,34.68,0.49,86.4,13514,75,NULL,'IR','NGC 2470',NULL,'2011yCatp016004901K',2011,1,1.9,NULL,'G',0.00004,NULL,'13.64',0.6,'Sab',NULL,NULL,NULL,NULL,1,118.5865417,4.45969,0.049,NULL,62732602294,980196910,15315576,13.64),(50735,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50735,37.56,0.33,326,13515,70,NULL,NULL,'2MASX J07542170+3146351',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'16.9g',0.28,'AGN',NULL,NULL,NULL,NULL,1,118.590458333,31.77653,0.161,NULL,63477201946,991831280,15497363,16.9),(50736,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50736,37.62,0.27,335,13516,70,NULL,NULL,'2MASX J07542426+3722084',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000069,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,118.6009583,37.36903,0.189,NULL,63449804417,991403194,15490674,18.1),(50737,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50737,35.49,0.46,125,13517,70,NULL,NULL,'2MASX J07542428+3430481',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000106,NULL,'16.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,118.601083333,34.51331,0.173,NULL,63445980468,991343444,15489741,16.4),(50738,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50738,38.66,0.46,540,13518,70,NULL,NULL,'2MASX J07542609+1439551',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,118.6085417,14.66528,0.113,NULL,62665963910,979155686,15299307,17.8),(50739,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50739,37.88,0.46,376,13519,70,NULL,NULL,'2MASX J07542623+3448571',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000189,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,118.60925,34.81581,0.177,NULL,63445831450,991341116,15489704,17.3),(50740,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50740,37.56,0.33,326,13520,70,NULL,NULL,'2MASX J07542734+3138521',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000163,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,118.613875,31.64775,0.137,NULL,63422477801,990976215,15484003,18.3),(50741,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50741,37.94,0.33,388,13521,70,NULL,NULL,'2MASX J07543014+5107172',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000193,NULL,'16.9g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,118.625583,51.12144,0.185,NULL,63512875399,992388678,15506073,16.9),(50742,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50742,37.08,0.46,261,13522,70,NULL,NULL,'SDSS J075431.39+131951.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'17.8g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,118.630833,13.33092,0.109,NULL,62637576006,978712125,15292376,17.8),(50743,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50743,36.26,0.46,179,13523,70,NULL,NULL,'2MASX J07543193+1808086',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,118.6329583,18.13575,0.165,NULL,62668154335,979189911,15299842,16.6),(50744,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50744,36.78,0.46,227,13524,70,NULL,NULL,'2MASX J07543543+2903153',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000067,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,118.6474583,29.05431,0.077,NULL,64300320622,1004692509,15698320,17.1),(50745,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50745,35.73,0.46,140,13525,70,NULL,NULL,'CGCG 206-039',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000105,NULL,'15.2g',0.57,'E0',NULL,NULL,NULL,NULL,1,118.6489583,44.15181,0.225,NULL,63559957792,993124340,15517567,15.2),(50746,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50746,38.69,0.46,548,13526,70,NULL,NULL,'SDSS J075438.19+391038.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000153,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,118.659167,39.17742,0.193,NULL,63565779469,993215304,15518989,18.7),(50747,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50747,35.18,0.49,109,13527,75,NULL,'IR','UGC 04075',NULL,'2011yCatp016004901K',2011,1,1.12,NULL,'G',NULL,NULL,'16.0',0.11,'Sbc',NULL,NULL,NULL,NULL,1,118.660375,60.19689,0.145,NULL,61571458173,962054033,15032094,16),(50748,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50748,35.5,NULL,126,13527,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04075',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50749,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50749,35.51,NULL,126,13527,NULL,NULL,'Dipole + Quadrupole','UGC 04075',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50750,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50750,35.53,NULL,128,13527,NULL,NULL,'Dipole','UGC 04075',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50751,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50751,35.54,NULL,128,13527,NULL,NULL,NULL,'UGC 04075',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50752,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50752,38.39,0.46,476,13528,70,NULL,NULL,'2MASX J07543938+3519369',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000172,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,118.664,35.32706,0.177,NULL,63447649057,991369516,15490148,18.1),(50753,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50753,37.38,0.46,299,13529,70,NULL,NULL,'SDSS J075441.18+123433.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.3g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,118.671583,12.57583,0.069,NULL,62637169857,978705779,15292277,18.3),(50754,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50754,36.8,0.21,229,13530,70,NULL,NULL,'2MASX J07544327+4541325',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000096,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,118.680125,45.69242,0.193,NULL,63527884945,992623202,15509737,18),(50755,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50755,35.95,0.33,155,13531,70,NULL,NULL,'2MASX J07544343+1836036',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000169,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,118.681083,18.60086,0.153,NULL,62623216170,978487752,15288871,16.3),(50756,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50756,37.42,0.23,305,13532,70,NULL,NULL,'2MASX J07544443+5058532',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000176,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,118.6849583,50.98142,0.185,NULL,63514744964,992417890,15506529,17.6),(50757,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50757,37.42,0.46,305,13533,70,NULL,NULL,'2MASX J07544474+3715567',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000088,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,118.686417,37.26586,0.189,NULL,63449712443,991401756,15490652,16.8),(50758,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50758,37.62,0.27,335,13534,70,NULL,NULL,'2MASX J07544632+3709247',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000076,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,118.693167,37.157,0.189,NULL,63449701552,991401586,15490649,17.5),(50759,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50759,36.8,0.21,229,13535,70,NULL,NULL,'2MASX J07544899+4542555',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000197,NULL,'16.3g',0.27,'E0',NULL,NULL,NULL,NULL,1,118.7042083,45.71531,0.193,NULL,63527879759,992623121,15509736,16.3),(50760,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50760,37.92,0.46,383,13536,70,NULL,NULL,'2MASX J07544998+2524013',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00014,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,118.7082083,25.40031,0.213,NULL,64294454294,1004600848,15696888,18.2),(50761,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50761,37.76,0.21,356,13537,70,NULL,NULL,'SDSS J075450.12+410939.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000067,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,118.708833,41.16103,0.193,NULL,63568694390,993260849,15519700,18.1),(50762,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50762,34.94,0.19,97.5,13538,70,NULL,NULL,'UGC 04082',NULL,'2015arXiv151105856S',2015,1,0.95,NULL,'G',0.00009,NULL,'14.1g',0.91,'E:',NULL,NULL,NULL,NULL,1,118.710333333,50.03881,0.153,NULL,63514503236,992414113,15506470,14.1),(50763,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50763,36.8,0.21,229,13539,70,NULL,NULL,'2MASX J07545148+4542185',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000105,NULL,'16.0g',0.45,'E0',NULL,NULL,NULL,NULL,1,118.714666667,45.70506,0.193,NULL,63527893878,992623341,15509739,16),(50764,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50764,37.94,0.33,388,13540,70,NULL,NULL,'2MASX J07545218+5112137',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000178,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,118.717625,51.20386,0.161,NULL,63512902495,992389101,15506079,17.3),(50765,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50765,34.55,0.4,81.2,13541,NULL,NULL,'mean','2MASX J07545226-2434463',NULL,'2007A&A...465...71T',2007,1,0.8,'abs(b) < 10 degrees.','G',0.000033,NULL,'10.9K',0.5,'S',NULL,NULL,NULL,NULL,1,118.71775,-24.5795,NULL,NULL,42684649775,666947652,10421057,10.9),(50766,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50766,35.06,0.47,103,13541,NULL,NULL,'H','2MASX J07545226-2434463',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50767,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50767,33.93,0.2,61.1,13542,74.4,NULL,NULL,'UGC 04067',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000037,NULL,'15.10',0.7,'SBcd:',NULL,NULL,NULL,NULL,1,118.725333333,72.61186,0.085,NULL,62183648709,971619511,15181554,15.1),(50768,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50768,33.95,0.41,61.6,13542,NULL,NULL,'Malmquist cor.','UGC 04067',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50769,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50769,34.08,0.38,65.3,13542,NULL,NULL,NULL,'UGC 04067',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50770,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50770,37.62,0.27,335,13543,70,NULL,NULL,'2MASX J07545444+3711077',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000074,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,118.7267917,37.18561,0.189,NULL,63449699938,991401561,15490649,17.5),(50771,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 1997K',NULL,50771,43.44,0.73,3060,13544,74.2,NULL,'SALT 2','H-ZSNS J075455.09+041901.3',0.592,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'Irr',NULL,NULL,NULL,NULL,1,118.7295417,4.31703,0.113,NULL,62732414741,980193980,15315530,NULL),(50772,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50772,38.76,0.46,564,13545,70,NULL,NULL,'2MASX J07545659+2927570',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000127,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,118.7357917,29.46583,0.081,NULL,64300351801,1004692996,15698328,17.9),(50773,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50773,37.78,0.46,360,13546,70,NULL,NULL,'2MASX J07545705+2459300',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000128,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,118.7375417,24.99158,0.237,NULL,64294223230,1004597237,15696831,17.9),(50774,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50774,37.52,0.46,319,13547,70,NULL,NULL,'SDSS J075459.13+400301.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000069,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,118.746417,40.05047,0.225,NULL,63566713172,993229893,15519217,18.3),(50775,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50775,37.34,0.46,293,13548,70,NULL,NULL,'SDSS J075459.34+375102.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000183,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,118.7472917,37.85075,0.205,NULL,63450302217,991410972,15490796,18),(50776,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50776,34.76,NULL,89.6,13549,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0683',NULL,'2010Ap&SS.325..163P',2010,1,1.05,NULL,'G',0.000016,NULL,'16.9g',0.14,'Scd(f)',NULL,NULL,NULL,NULL,1,118.7522083,36.46317,0.205,NULL,63451205790,991425090,15491017,16.9),(50777,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50777,34.77,NULL,89.8,13549,NULL,NULL,'Dipole + Quadrupole','FGC 0683',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50778,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50778,34.77,NULL,90,13549,NULL,NULL,'Dipole','FGC 0683',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50779,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50779,34.92,NULL,96.3,13549,NULL,NULL,NULL,'FGC 0683',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50780,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50780,34.93,0.2,96.8,13549,74.4,NULL,NULL,'FGC 0683',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50781,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50781,35.08,0.43,104,13549,75,NULL,'3.6 micron, color corrected','FGC 0683',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50782,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50782,35.25,0.43,112,13549,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0683',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50783,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50783,37.42,0.23,305,13550,70,NULL,NULL,'2MASX J07550149+5051197',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,118.7560417,50.85556,0.173,NULL,63515266738,992426042,15506656,17.1),(50784,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50784,37.74,0.46,352,13551,70,NULL,NULL,'SDSS J075503.21+142127.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000141,NULL,'18.0g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,118.763416667,14.35769,0.121,NULL,62665447713,979147620,15299181,18),(50785,'IRAS','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50785,31.68,0.8,21.7,13552,75,NULL,'MAT, I','ESO 035- G 018',NULL,'1997ApJS..109..333W',1997,1,3.2,NULL,'G',0.000017,NULL,'14.05',0.7,'SA(s)c: sp',NULL,NULL,NULL,NULL,1,118.7675417,-76.41253,0.857,NULL,39904963830,623515059,9742422,14.05),(50786,'Tully est','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50786,31.61,0.8,21,13552,75,NULL,NULL,'ESO 035- G 018',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50787,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50787,31.66,0.32,21.5,13552,85,NULL,'I, raw','ESO 035- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50788,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50788,31.68,0.32,21.7,13552,85,NULL,'I, inv','ESO 035- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50789,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50789,31.72,0.43,22.1,13552,75,NULL,'MAT, I, raw','ESO 035- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50790,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50790,31.84,0.43,23.3,13552,75,NULL,'MAT, I, inv','ESO 035- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50791,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50791,31.88,0.43,23.8,13552,75,NULL,'MAT, I, cor','ESO 035- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50792,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50792,31.92,0.36,24.2,13552,NULL,NULL,NULL,'ESO 035- G 018',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50793,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50793,32.01,0.39,25.2,13552,73,NULL,'opt','ESO 035- G 018',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50794,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50794,32.09,0.39,26.2,13552,73,NULL,'IR','ESO 035- G 018',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50795,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50795,32.09,0.4,26.2,13552,75,NULL,NULL,'ESO 035- G 018',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50796,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50796,32.1,0.2,26.3,13552,74.4,NULL,NULL,'ESO 035- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50797,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50797,32.24,0.4,28,13552,NULL,NULL,'mean','ESO 035- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50798,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50798,32.24,0.43,28,13552,75,NULL,'3.6 micron, color corrected','ESO 035- G 018',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50799,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50799,32.32,0.47,29.1,13552,NULL,NULL,'H','ESO 035- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50800,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50800,32.35,0.43,29.5,13552,75,NULL,'3.6 micron, color + selection bias corrected','ESO 035- G 018',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50801,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50801,32.36,0.46,29.6,13552,NULL,NULL,'J','ESO 035- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50802,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50802,32.43,0.45,30.7,13552,NULL,NULL,'K','ESO 035- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50803,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50803,32.52,0.49,32,13552,75,NULL,'IR','ESO 035- G 018',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50804,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50804,35.52,NULL,127,13553,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0681',NULL,'2010Ap&SS.325..163P',2010,1,0.83,NULL,'G',0.000051,NULL,'16.7g',0.15,'Sd(f)',NULL,NULL,NULL,NULL,1,118.7785417,42.95781,0.233,NULL,63559169028,993112016,15517375,16.7),(50805,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50805,35.54,NULL,128,13553,NULL,NULL,'Dipole + Quadrupole','FGC 0681',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50806,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50806,35.56,NULL,130,13553,NULL,NULL,'Dipole','FGC 0681',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50807,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50807,35.57,NULL,130,13553,NULL,NULL,NULL,'FGC 0681',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50808,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50808,36.98,0.46,249,13554,70,NULL,NULL,'2MASX J07550873+4627126',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000172,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,118.786417,46.45356,0.221,NULL,63535390486,992740476,15511569,16.7),(50809,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50809,35.19,0.7,109,13555,70,NULL,NULL,'2MASX J07550900-7238081',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,118.7875417,-72.63561,0.765,NULL,40628066969,634813546,9918961,16.2),(50810,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50810,37.83,0.33,369,13556,70,NULL,NULL,'2MASX J07551321+3639202',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000086,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,118.805125,36.65553,0.189,NULL,63450727171,991417612,15490900,17.1),(50811,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50811,36.85,0.46,235,13557,70,NULL,NULL,'2MASX J07551327+2349076',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,118.805291667,23.81889,0.201,NULL,63757080997,996204390,15565693,18.1),(50812,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50812,38.01,0.46,400,13558,70,NULL,NULL,'2MASX J07551425+2622200',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000143,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,118.809375,26.37233,0.141,NULL,64293106771,1004579793,15696559,17.4),(50813,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50813,36.79,0.46,228,13559,70,NULL,NULL,'2MASX J07551426+3321120',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000111,NULL,'16.5g',0.29,'S0',NULL,NULL,NULL,NULL,1,118.8095417,33.35319,0.177,NULL,63443618610,991306540,15489164,16.5),(50814,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50814,37.86,0.46,373,13560,70,NULL,NULL,'2MASX J07551483+2046366',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000196,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,118.8117917,20.77692,0.181,NULL,62626374435,978537100,15289642,17.1),(50815,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50815,37.07,0.46,260,13561,70,NULL,NULL,'2MASX J07551525+2837250',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000174,NULL,'16.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,118.8135,28.62353,0.073,NULL,64299895501,1004685867,15698216,16.6),(50816,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50816,37.29,0.46,286,13562,70,NULL,NULL,'2MASX J07551665+5149317',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000161,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,118.819333333,51.82536,0.153,NULL,63513409723,992397026,15506203,17.5),(50817,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50817,37.51,0.21,318,13563,70,NULL,NULL,'2MASX J07551779+3358270',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,118.824167,33.97411,0.177,NULL,63446677341,991354333,15489911,17.7),(50818,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50818,36.76,0.33,225,13564,70,NULL,NULL,'2MASX J07551911+1345015',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00015,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,118.829625,13.75042,0.097,NULL,62635163185,978674424,15291787,17.2),(50819,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50819,36.92,0.46,242,13565,70,NULL,NULL,'2MASX J07551987+1954316',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000179,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,118.832833,19.90878,0.153,NULL,62626754219,978543034,15289734,16.5),(50820,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50820,37.92,0.46,384,13566,70,NULL,NULL,'2MASX J07552019+4042192',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,'FoF','16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,118.834375,40.70544,0.245,NULL,63566108195,993220440,15519069,16.9),(50821,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50821,33.33,0.43,46.4,13567,75,NULL,'3.6 micron, color + selection bias corrected','IC 0480',NULL,'2014MNRAS.444..527S',2014,1,1.93,'Multiple SDSS entries describe this object.','G',0.000008,NULL,'14.7g',0.38,'Sbc','Group member',NULL,NULL,NULL,1,118.846625,26.74333,0.145,NULL,64293010356,1004578286,15696535,14.7),(50822,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50822,33.59,0.43,52.1,13567,75,NULL,'3.6 micron, color corrected','IC 0480',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50823,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50823,33.87,0.2,59.4,13567,74.4,NULL,NULL,'IC 0480',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50824,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50824,33.97,0.49,62.1,13567,75,NULL,'IR','IC 0480',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50825,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50825,34.2,0.11,69.3,13567,NULL,NULL,NULL,'IC 0480',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50826,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50826,35.55,0.33,129,13568,70,NULL,NULL,'2MASX J07552334+1257115',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000153,NULL,'16.0g',0.37,'AGN+SF',NULL,NULL,NULL,NULL,1,118.847167,12.95322,0.097,NULL,62637485136,978710705,15292354,16),(50827,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50827,36.28,NULL,180,13569,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04083',NULL,'2010Ap&SS.325..163P',2010,1,0.96,NULL,'G',NULL,NULL,'17.',0.11,'Sc',NULL,NULL,NULL,NULL,1,118.850333,56.16753,0.121,NULL,61603926982,962561359,15040021,17),(50828,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50828,36.29,NULL,181,13569,NULL,NULL,NULL,'UGC 04083',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50829,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50829,36.32,NULL,184,13569,NULL,NULL,'Dipole + Quadrupole','UGC 04083',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50830,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50830,36.33,NULL,185,13569,NULL,NULL,'Dipole','UGC 04083',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50831,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50831,37.78,0.46,360,13570,70,NULL,NULL,'SDSS J075525.20+164920.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000142,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,118.855041667,16.82228,0.121,NULL,62676279575,979316868,15301826,18.5),(50832,'Black Hole','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50832,35.29,0.75,114,13571,NULL,NULL,NULL,'MRK 0382',NULL,'2014ApJ...793..108W',2014,1,0.75,'Darling and Wegner (1994, AJ, 108, 2025) give z=0.029.','G',0.000053,NULL,'14.9g',0.69,'Sc(r);Sy1      Sbrst','Isolated galaxy',NULL,NULL,'Sy 1',1,118.855417,39.18614,0.193,NULL,63565786454,993215413,15518990,14.9),(50833,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50833,37.21,0.46,276,13572,70,NULL,NULL,'2MASX J07552570+3611182',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,118.85725,36.18844,0.201,NULL,63451048256,991422629,15490978,17.5),(50834,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50834,37.83,0.33,369,13573,70,NULL,NULL,'2MASX J07552576+3641292',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000091,NULL,'16.9g',0.32,NULL,NULL,NULL,NULL,NULL,1,118.857458333,36.69144,0.189,NULL,63451381763,991427840,15491060,16.9),(50835,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50835,37.76,0.21,356,13574,70,NULL,NULL,'2MASX J07552687+4114212',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000061,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,118.862,41.23914,0.209,NULL,63568020023,993250312,15519536,17.9),(50836,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50836,36.89,0.46,238,13575,70,NULL,NULL,'2MASX J07552731+2925472',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000063,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,118.863708333,29.42981,0.077,NULL,64300497145,1004695267,15698363,17),(50837,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50837,35.74,0.46,141,13576,70,NULL,NULL,'2MASX J07552791+4604146',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000083,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,118.866333,46.07061,0.185,NULL,63527804966,992621952,15509718,16.5),(50838,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50838,36.01,0.46,159,13577,70,NULL,NULL,'2MASX J07552798+4025532',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000079,NULL,'16.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,118.866417,40.43139,0.241,NULL,63566072654,993219885,15519060,16.7),(50839,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50839,37.09,0.46,262,13578,70,NULL,NULL,'2MASX J07552913+1049203',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,118.871417,10.82222,0.029,NULL,62758563845,980602560,15321915,17.2),(50840,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50840,33.29,0.49,45.4,13579,75,NULL,'IR','ESO 494- G 004',NULL,'2011yCatp016004901K',2011,1,1.96,'Star superposed near the center.','G',0.000067,NULL,'15.17',0.22,'Scd',NULL,NULL,NULL,NULL,1,118.8755,-22.72958,NULL,NULL,42213903328,659592239,10306128,15.17),(50841,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50841,33.44,NULL,48.7,13579,NULL,NULL,'Dipole','ESO 494- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50842,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50842,33.45,NULL,49,13579,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 494- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50843,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50843,33.46,NULL,49.2,13579,NULL,NULL,'Dipole + Quadrupole','ESO 494- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50844,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50844,37.32,0.46,292,13580,70,NULL,NULL,'2MASX J07553085+3955342',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00008,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,118.8785,39.92597,0.213,NULL,63566681584,993229399,15519209,17.6),(50845,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50845,38.05,0.46,408,13581,70,NULL,NULL,'2MASX J07553125+2100186',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00018,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,118.880333333,21.00508,0.169,NULL,62626222478,978534726,15289605,17.2),(50846,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50846,36.99,0.46,250,13582,70,NULL,NULL,'SDSS J075531.34+125926.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.001123,NULL,'18.1g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,118.880625,12.99061,0.097,NULL,62637489590,978710774,15292355,18.1),(50847,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50847,38.2,0.33,438,13583,70,NULL,NULL,'2MASX J07553142+4336496',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000077,NULL,'18.0g',0.18,'NLAGN',NULL,NULL,NULL,NULL,1,118.880875,43.61383,0.169,NULL,63558714637,993104916,15517264,18),(50848,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50848,37.08,0.46,261,13584,70,NULL,NULL,'CGCG 148-064',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000117,NULL,'15.7',0.41,NULL,NULL,NULL,NULL,NULL,1,118.885625,27.73617,0.073,NULL,64304130651,1004752041,15699250,15.7),(50849,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50849,37.21,0.33,276,13585,70,NULL,NULL,'2MASX J07553448+2106466',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000164,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,118.8935417,21.11294,0.169,NULL,62626228726,978534823,15289606,16.5),(50850,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50850,36.07,NULL,164,13586,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04088',NULL,'2010Ap&SS.325..163P',2010,1,1.14,NULL,'G',NULL,NULL,'17.',0.11,'Scd',NULL,NULL,NULL,NULL,1,118.896375,56.15747,0.121,NULL,61603955415,962561803,15040028,17),(50851,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50851,36.09,NULL,165,13586,NULL,NULL,'Dipole + Quadrupole','UGC 04088',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50852,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50852,36.09,NULL,166,13586,NULL,NULL,NULL,'UGC 04088',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50853,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50853,36.11,NULL,167,13586,NULL,NULL,'Dipole','UGC 04088',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50854,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50854,35.51,0.46,127,13587,70,NULL,NULL,'2MASX J07553522+1858136',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'17.80',0.32,NULL,NULL,NULL,NULL,NULL,1,118.89675,18.97044,0.089,NULL,62623672884,978494888,15288982,17.8),(50855,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50855,36.76,0.33,225,13588,70,NULL,NULL,'SDSS J075536.21+135159.6',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000195,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,118.900875,13.86656,0.097,NULL,62635141282,978674082,15291782,16.2),(50856,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50856,38.2,0.33,438,13589,70,NULL,NULL,'2MASX J07553685+4338147',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.0001,NULL,'18.0g',0.2,'NLAGN',NULL,NULL,NULL,'Sy 2',1,118.903667,43.63744,0.169,NULL,63558728877,993105138,15517267,18),(50857,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50857,38.18,0.46,432,13590,70,NULL,NULL,'SDSS J075538.65+192608.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000122,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,118.9110417,19.43569,0.121,NULL,62623636014,978494312,15288973,18.6),(50858,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50858,37.76,0.21,356,13591,70,NULL,NULL,'2MASXi J0755390+411351',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000079,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,118.91275,41.23092,0.209,NULL,63568022503,993250351,15519536,18.1),(50859,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50859,37.96,0.33,391,13592,70,NULL,NULL,'2MASXi J0755391+205112',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,118.913208333,20.85344,0.181,NULL,62626430954,978537983,15289655,17.6),(50860,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50860,34.08,NULL,65.5,13593,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0684',NULL,'2010Ap&SS.325..163P',2010,1,0.96,NULL,'G',0.000013,NULL,'16.68',0.08,'Sd',NULL,NULL,NULL,NULL,1,118.92,28.74194,0.081,NULL,64300612228,1004697066,15698391,16.68),(50861,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50861,34.1,NULL,65.9,13593,NULL,NULL,'Dipole + Quadrupole','FGC 0684',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50862,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50862,34.1,NULL,66,13593,NULL,NULL,'Dipole','FGC 0684',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50863,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50863,34.15,NULL,67.8,13593,NULL,NULL,NULL,'FGC 0684',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50864,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50864,37.76,0.21,356,13594,70,NULL,NULL,'MCG +07-17-002',NULL,'2015arXiv151105856S',2015,1,0.84,'MCG declination is +10 arcmin in error.','G',0.0001,NULL,'15.5g',0.48,'BrClG',NULL,NULL,NULL,NULL,1,118.934875,41.20394,0.209,NULL,63568033249,993250519,15519539,15.5),(50865,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50865,37.21,0.46,276,13595,70,NULL,NULL,'2MASX J07554490+2634592',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,118.9372083,26.58306,0.125,NULL,64293169256,1004580769,15696574,17.4),(50866,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50866,37.73,0.33,351,13596,70,NULL,NULL,'SDSS J075546.64+502751.1',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000173,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,118.944417,50.46422,0.181,NULL,63514452140,992413314,15506458,17.8),(50867,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50867,38.43,0.46,486,13597,70,NULL,NULL,'2MASX J07554669+5228256',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,118.944625,52.47369,0.125,NULL,63514170826,992408919,15506389,17.9),(50868,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50868,37.21,0.33,277,13598,70,NULL,NULL,'2MASX J07554675+2722252',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000207,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,118.944667,27.37358,0.089,NULL,64303996297,1004749942,15699217,16.3),(50869,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50869,37.42,0.23,305,13599,70,NULL,NULL,'2MASX J07554684+5117546',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000199,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,118.945167,51.29858,0.161,NULL,63512870836,992388606,15506071,17.2),(50870,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50870,38.24,0.46,445,13600,70,NULL,NULL,'2MASX J07554710+2049307',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000171,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,118.94625,20.82517,0.181,NULL,62626417388,978537771,15289652,17.4),(50871,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50871,38.3,0.46,456,13601,70,NULL,NULL,'2MASX J07555041+1145005',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000142,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,118.96,11.75017,0.045,NULL,62759092696,980610823,15322044,18.1),(50872,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50872,37.96,0.33,391,13602,70,NULL,NULL,'2MASX J07555067+2047187',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000176,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,118.96125,20.78861,0.181,NULL,62626350921,978536733,15289636,17.3),(50873,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50873,30.55,0.45,12.9,13603,NULL,NULL,'K','NGC 2502',NULL,'2007A&A...465...71T',2007,1,2,NULL,'G',0.00002,NULL,'13.19',1.3,'SB(rs)0^+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,118.964666667,-52.30678,0.953,NULL,42521789375,664402958,10381296,13.19),(50874,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50874,30.85,0.4,14.8,13603,NULL,NULL,'mean','NGC 2502',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50875,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50875,37.05,0.46,257,13604,70,NULL,NULL,'2MASX J07555163+4056297',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000074,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,118.965083,40.94161,0.265,NULL,63567976245,993249628,15519525,16.8),(50876,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50876,38.12,0.46,421,13605,70,NULL,NULL,'2MASX J07555251+4325158',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000079,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,118.96875,43.42114,0.177,NULL,63559179866,993112185,15517377,18.2),(50877,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50877,36.17,0.6,171,13606,70,NULL,NULL,'2MASX J07555259-8052261',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'17.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,118.9687917,-80.87383,0.801,NULL,39953998821,624281231,9754394,17.8),(50878,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50878,37.21,0.33,277,13607,70,NULL,NULL,'2MASX J07555350+2722002',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,118.9730417,27.36664,0.089,NULL,64303995191,1004749924,15699217,18),(50879,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50879,37.12,0.46,265,13608,70,NULL,NULL,'2MASX J07555357+4617438',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,118.973083,46.29556,0.209,NULL,63527781250,992621582,15509712,17.5),(50880,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50880,37.27,0.33,284,13609,70,NULL,NULL,'2MASX J07555414+3404081',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00018,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,118.975667,34.06903,0.177,NULL,63446622820,991353481,15489898,17.1),(50881,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50881,38.14,0.46,424,13610,70,NULL,NULL,'2MASX J07555460+3823167',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,118.977375,38.38792,0.173,NULL,63449588744,991399824,15490622,17.9),(50882,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50882,38.23,0.46,443,13611,70,NULL,NULL,'2MASX J07555574+4531068',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000085,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,118.98225,45.5185,0.181,NULL,63527877071,992623079,15509735,17.9),(50883,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50883,36.79,0.46,228,13612,70,NULL,NULL,'2MASX J07555783+1403388',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,118.9907917,14.06083,0.101,NULL,62665479161,979148111,15299189,17.6),(50884,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50884,38.14,0.46,425,13613,70,NULL,NULL,'SDSS J075559.77+234755.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000145,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,118.999083,23.79875,0.181,NULL,63757082960,996204421,15565694,18.2),(50885,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50885,35.55,0.33,129,13614,70,NULL,NULL,'CGCG 058-073',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000083,NULL,'15.0g',0.57,NULL,'Group member',NULL,NULL,NULL,1,118.999833,12.98147,0.097,NULL,62637344365,978708505,15292320,15),(50886,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50886,37.18,0.46,273,13615,70,NULL,NULL,'2MASX J07560004+1210178',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,119.000125,12.17153,0.081,NULL,62634070624,978657353,15291521,17),(50887,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50887,37.51,0.21,318,13616,70,NULL,NULL,'2MASX J07560009+3346151',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,119.000333,33.77083,0.189,NULL,63446692637,991354572,15489915,17.5),(50888,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50888,37.47,0.46,311,13617,70,NULL,NULL,'2MASX J07560046+3722247',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000072,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,119.001917,37.37342,0.189,NULL,63450131236,991408300,15490754,17.6),(50889,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50889,34.92,0.46,96.3,13618,70,NULL,NULL,'CGCG 058-072',NULL,'2015arXiv151105856S',2015,1,0.94,NULL,'G',0.000177,NULL,'14.7g',0.47,NULL,NULL,NULL,NULL,NULL,1,119.002625,14.19575,0.101,NULL,62665514192,979148659,15299197,14.7),(50890,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50890,37.73,0.33,351,13619,70,NULL,NULL,'2MASX J07560218+5020587',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,119.009,50.34964,0.169,NULL,63514597618,992415587,15506493,17.6),(50891,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50891,36.67,0.59,216,13620,70,NULL,NULL,'2MASX J07560235-0609282',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.6I',0.5,NULL,NULL,NULL,NULL,NULL,1,119.0097917,-6.15789,0.513,NULL,39279667995,613744812,9589762,13.6),(50892,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50892,34.4,NULL,75.8,13621,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0685',NULL,'2010Ap&SS.325..163P',2010,1,0.81,NULL,'G',0.000011,NULL,'16.89',0.11,'Scd',NULL,NULL,NULL,NULL,1,119.019167,34.35389,0.173,NULL,63447112669,991361135,15490017,16.89),(50893,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50893,34.41,NULL,76.1,13621,NULL,NULL,'Dipole + Quadrupole','FGC 0685',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50894,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50894,34.42,NULL,76.4,13621,NULL,NULL,'Dipole','FGC 0685',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50895,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50895,34.5,NULL,79.3,13621,NULL,NULL,NULL,'FGC 0685',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50896,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50896,37.51,0.21,318,13622,70,NULL,NULL,'2MASX J07560555+3344401',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000186,NULL,'15.9g',0.5,'BrClG',NULL,NULL,NULL,NULL,1,119.0230417,33.74453,0.189,NULL,63446694244,991354597,15489915,15.9),(50897,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50897,37.7,0.46,346,13623,70,NULL,NULL,'2MASX J07560565+2729299',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000175,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,119.023625,27.49158,0.089,NULL,64304013628,1004750212,15699222,16.8),(50898,'IRAS','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50898,34.2,0.8,69.3,13624,75,NULL,'MAT, I','ESO 059- G 023',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.79',0.7,'SAB(r)c',NULL,NULL,NULL,NULL,1,119.025625,-68.27803,0.601,NULL,40654905010,635232890,9925513,14.79),(50899,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50899,33.81,0.32,57.8,13624,85,NULL,'I, raw','ESO 059- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50900,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50900,33.85,0.32,58.8,13624,85,NULL,'I, inv','ESO 059- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50901,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50901,33.9,0.43,60.3,13624,75,NULL,'MAT, I, raw','ESO 059- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50902,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50902,34.09,0.43,65.8,13624,75,NULL,'MAT, I, inv','ESO 059- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50903,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50903,34.19,0.43,68.9,13624,75,NULL,'MAT, I, cor','ESO 059- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50904,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50904,34.32,0.4,73.1,13624,NULL,NULL,'mean','ESO 059- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50905,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50905,34.35,0.4,74.1,13624,NULL,NULL,NULL,'ESO 059- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50906,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50906,34.37,0.4,74.9,13624,NULL,NULL,'Malmquist cor.','ESO 059- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50907,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50907,34.39,0.2,75.5,13624,74.4,NULL,NULL,'ESO 059- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50908,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50908,34.65,0.47,85.2,13624,NULL,NULL,'H','ESO 059- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50909,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50909,38.35,0.46,468,13625,70,NULL,NULL,'2MASX J07560860+4345588',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000093,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,119.035916667,43.76647,0.169,NULL,63558777151,993105892,15517279,17.8),(50910,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50910,35.27,0.46,113,13626,70,NULL,NULL,'2MASX J07560866+1722508',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000089,NULL,'15.7g',0.32,'SF',NULL,NULL,NULL,NULL,1,119.036083,17.38069,0.125,NULL,62676351310,979317989,15301843,15.7),(50911,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50911,37.43,0.46,306,13627,70,NULL,NULL,'2MASX J07560893+4647458',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000142,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,119.037,46.79614,0.181,NULL,63536325765,992755090,15511798,18.2),(50912,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50912,37.27,0.33,284,13628,70,NULL,NULL,'2MASX J07560943+3407021',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,119.0395417,34.11719,0.173,NULL,63446624873,991353513,15489898,17.6),(50913,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50913,34.82,0.2,92,13629,74.4,NULL,NULL,'CGCG 058-074',NULL,'2013AJ....146...86T',2013,1,0.64,NULL,'G',0.000175,NULL,'15.9g',0.4,NULL,NULL,NULL,NULL,NULL,1,119.041333,14.26061,0.101,NULL,62665347966,979146061,15299157,15.9),(50914,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50914,37.76,0.21,356,13630,70,NULL,NULL,'2MASX J07561057+4109106',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000089,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,119.044083,41.15292,0.265,NULL,63568078902,993251232,15519550,17.3),(50915,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50915,37.51,0.21,318,13631,70,NULL,NULL,'2MASX J07561155+3340431',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000178,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,119.048125,33.67856,0.189,NULL,63446681332,991354395,15489912,16.7),(50916,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50916,37.55,0.46,323,13632,70,NULL,NULL,'2MASX J07561231+3904558',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,119.051167,39.08214,0.193,NULL,63554250936,993035170,15516174,17.4),(50917,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50917,37.51,0.21,318,13633,70,NULL,NULL,'2MASX J07561328+3328051',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000164,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,119.055291667,33.46794,0.193,NULL,63443795073,991309298,15489207,17.7),(50918,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50918,37.87,0.46,374,13634,70,NULL,NULL,'2MASX J07561366+2942159',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,119.056875,29.70431,0.093,NULL,64300317009,1004692453,15698319,17.2),(50919,'Tully est','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50919,31.98,0.8,24.9,13635,75,NULL,'B','IC 2209',NULL,'1988NBGC.C....0000T',1988,1,1.1,NULL,'G',0.000005,NULL,'14.28',0.9,'SB(rs)b:       Sbrst','in a pair',NULL,NULL,'Starburst',1,119.0592083,60.30408,0.145,NULL,61571536827,962055262,15032113,14.28),(50920,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50920,37.91,0.21,383,13636,70,NULL,NULL,'2MASX J07561516+3702198',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00008,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,119.0632917,37.039,0.189,NULL,63451314594,991426790,15491043,17.6),(50921,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50921,37.21,0.33,276,13637,70,NULL,NULL,'2MASX J07561522+2102220',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,119.063417,21.03953,0.169,NULL,62626213620,978534587,15289602,17.1),(50922,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50922,37.91,0.21,383,13638,70,NULL,NULL,'2MASX J07561800+3700428',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000074,NULL,'18.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,119.075,37.01181,0.189,NULL,63451312647,991426760,15491043,18.2),(50923,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50923,37.91,0.21,383,13639,70,NULL,NULL,'2MASX J07561890+3706308',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,119.078833,37.10867,0.189,NULL,63451303512,991426617,15491040,17.8),(50924,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50924,36.22,0.33,176,13640,70,NULL,NULL,'2MASX J07562131+5100175',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000101,NULL,'17.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,119.089,51.00489,0.157,NULL,63513106373,992392287,15506129,17),(50925,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50925,37.02,0.46,253,13641,70,NULL,NULL,'2MASX J07562209+3043295',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000135,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,119.092083,30.72472,0.101,NULL,63422711465,990979866,15484060,16.8),(50926,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50926,37.57,0.46,327,13642,70,NULL,NULL,'2MASX J07562237+5004585',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000181,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,119.0930417,50.08281,0.153,NULL,63514381152,992412205,15506440,16.4),(50927,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50927,35.13,0.49,106,13643,75,NULL,'IR','ESO 124- G 002',NULL,'2011yCatp016004901K',2011,1,1.25,NULL,'G',0.000033,NULL,'16.82',0.17,'Sbc',NULL,NULL,NULL,NULL,1,119.096667,-59.367,0.849,NULL,40446020153,631969064,9874516,16.82),(50928,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50928,35.65,0.42,135,13643,NULL,NULL,'Malmquist cor.','ESO 124- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50929,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50929,35.68,0.42,137,13643,NULL,NULL,NULL,'ESO 124- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50930,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50930,35.72,0.2,139,13643,74.4,NULL,NULL,'ESO 124- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50931,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50931,35.79,NULL,144,13643,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 124- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50932,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50932,35.79,NULL,144,13643,NULL,NULL,'Dipole','ESO 124- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50933,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50933,35.8,NULL,144,13643,NULL,NULL,'Dipole + Quadrupole','ESO 124- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50934,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50934,35.97,NULL,156,13643,NULL,NULL,NULL,'ESO 124- G 002',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50935,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50935,37.3,0.46,289,13644,70,NULL,NULL,'2MASX J07562415+4457089',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000076,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,119.1007083,44.95239,0.165,NULL,63527233318,992613020,15509578,17.3),(50936,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50936,35.05,0.4,102,13645,NULL,NULL,'mean','UGC 04105',NULL,'2007A&A...465...71T',2007,1,1.14,NULL,'G',0.000033,NULL,'14.5g',0.61,'S?','Group member',NULL,NULL,NULL,1,119.1045417,27.01256,0.101,NULL,64304320954,1004755014,15699297,14.5),(50937,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50937,35.15,0.47,107,13645,NULL,NULL,'H','UGC 04105',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50938,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50938,37.33,0.62,292,13646,70,NULL,NULL,'2MASX J07562569-0249334',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.97',NULL,NULL,NULL,NULL,NULL,NULL,1,119.1070417,-2.82603,0.189,NULL,39305073234,614141769,9595965,16.97),(50939,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50939,37.47,0.46,312,13647,70,NULL,NULL,'2MASX J07562601+1515178',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000166,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,119.108417,15.25503,0.113,NULL,62676842180,979325659,15301963,17),(50940,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50940,37.42,0.23,305,13648,70,NULL,NULL,'2MASX J07562622+5116335',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.00012,NULL,'15.2g',0.57,NULL,NULL,NULL,NULL,NULL,1,119.1094583,51.27603,0.149,NULL,63513134558,992392727,15506136,15.2),(50941,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50941,37.05,0.76,257,13649,70,NULL,NULL,'2MASX J07562692-0650287',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,119.112083,-6.84133,0.469,NULL,39402201671,615659401,9619678,16.1),(50942,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50942,37.35,0.46,295,13650,70,NULL,NULL,'2MASX J07562822+3445085',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000209,NULL,'15.9g',0.47,'E0',NULL,NULL,NULL,NULL,1,119.117541667,34.7525,0.177,NULL,63446292396,991348318,15489817,15.9),(50943,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50943,34.83,0.46,92.5,13651,70,NULL,NULL,'2MASX J07562992+3006215',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000131,NULL,'15.7g',0.29,'S0^-',NULL,NULL,NULL,NULL,1,119.124833333,30.10608,0.089,NULL,64298958176,1004671221,15697987,15.7),(50944,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50944,37.22,0.46,277,13652,70,NULL,NULL,'2MASX J07563043+4102099',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000095,NULL,'16.1g',0.39,'AGN            LINER',NULL,NULL,NULL,NULL,1,119.12675,41.03625,0.265,NULL,63568048197,993250753,15519543,16.1),(50945,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50945,37.7,0.46,346,13653,70,NULL,NULL,'SDSS J075632.02+130020.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000168,NULL,'18.1g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,119.133416667,13.00575,0.097,NULL,62633929410,978655147,15291486,18.1),(50946,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50946,37.91,0.21,383,13654,70,NULL,NULL,'SDSS J075633.05+365851.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000084,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,119.13775,36.98086,0.189,NULL,63451310167,991426721,15491042,18.6),(50947,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50947,37.81,0.46,365,13655,70,NULL,NULL,'2MASX J07563321+3614389',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,119.138583,36.24428,0.201,NULL,63451073208,991423018,15490984,17.3),(50948,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50948,36.21,0.46,174,13656,70,NULL,NULL,'2MASX J07563416+3010325',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000158,NULL,'16.1g',0.34,'E0',NULL,NULL,NULL,NULL,1,119.1425,30.17569,0.089,NULL,64298952781,1004671137,15697986,16.1),(50949,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50949,37.69,0.46,345,13657,70,NULL,NULL,'2MASX J07563452+4706488',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,119.143875,47.11356,0.189,NULL,63536166387,992752599,15511759,17.9),(50950,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50950,37.91,0.21,383,13658,70,NULL,NULL,'2MASX J07563512+3708469',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000084,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,119.1462083,37.14636,0.177,NULL,63450451686,991413307,15490832,16.9),(50951,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50951,38.17,0.33,430,13659,70,NULL,NULL,'2MASX J07563532+1620377',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000149,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,119.1472917,16.34392,0.113,NULL,62679463482,979366616,15302603,17.7),(50952,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50952,35.95,0.33,155,13660,70,NULL,NULL,'2MASX J07563635+1844180',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000101,NULL,'15.6g',0.43,'SF',NULL,NULL,NULL,NULL,1,119.151333,18.73825,0.097,NULL,62624088364,978501380,15289084,15.6),(50953,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50953,37.54,0.46,323,13661,70,NULL,NULL,'2MASX J07563723+2756324',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,119.1552083,27.94222,0.073,NULL,64304108215,1004751690,15699245,17.2),(50954,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50954,36.77,0.46,226,13662,70,NULL,NULL,'2MASX J07563889+4407408',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000122,NULL,'15.5g',0.48,'E0',NULL,NULL,NULL,NULL,1,119.161917,44.12808,0.165,NULL,63558679187,993104362,15517255,15.5),(50955,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50955,37,0.46,252,13663,70,NULL,NULL,'2MASX J07563943+1837226',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,119.164375,18.62306,0.097,NULL,62624097857,978501529,15289086,17.4),(50956,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50956,37.02,0.46,254,13664,70,NULL,NULL,'2MASX J07564012+1901506',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000176,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,119.167083,19.03078,0.089,NULL,62623774802,978496481,15289007,17.1),(50957,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50957,37.4,0.46,302,13665,70,NULL,NULL,'2MASX J07564033+3919329',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,119.167958333,39.32589,0.197,NULL,63554410702,993037667,15516213,17.3),(50958,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 1994C',NULL,50958,36.67,0.16,206,13666,65,NULL,NULL,'CGCG 236-015 NED01',0.05024,'2004ApJ...607..665R',2004,1,0.58,NULL,'G',0.000073,NULL,'15.6g',0.5,'Sb             AGN',NULL,NULL,NULL,NULL,1,119.168167,44.86981,0.165,NULL,63527254259,992613347,15509583,15.6),(50959,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 1994C',NULL,50959,36.72,0.15,221,13666,65,NULL,'Snapshot','CGCG 236-015 NED01',NULL,'1998ApJ...504..935R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50960,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50960,37.91,0.46,382,13667,70,NULL,NULL,'2MASX J07564101+3123475',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,119.170833,31.3965,0.121,NULL,63422268627,990972947,15483952,17.8),(50961,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50961,37.25,0.46,281,13668,70,NULL,NULL,'2MASX J07564174+1225097',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000183,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,119.173875,12.41947,0.081,NULL,62634317203,978661206,15291581,16.6),(50962,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50962,36.84,0.46,233,13669,70,NULL,NULL,'2MASX J07564300+1509347',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000167,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,119.17925,15.15981,0.093,NULL,62665549587,979149212,15299206,16.6),(50963,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50963,37.9,0.33,381,13670,70,NULL,NULL,'SDSS J075643.83+273011.1',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,'FoF','17.3g',0.28,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,119.182667,27.50308,0.089,NULL,64304884261,1004763816,15699434,17.3),(50964,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50964,37.9,0.33,381,13671,70,NULL,NULL,'2MASX J07564423+2733064',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,'FoF','17.1g',0.23,'BrClG',NULL,NULL,NULL,NULL,1,119.184333,27.55186,0.089,NULL,64304886951,1004763858,15699435,17.1),(50965,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50965,36.8,0.21,229,13672,70,NULL,NULL,'CGCG 236-016',NULL,'2015arXiv151105856S',2015,1,0.7,'Position from 1988BoPos.M...000V is incorrect.','G',0.000121,NULL,'15.3g',0.58,'BrClG',NULL,NULL,NULL,NULL,1,119.1845,45.87692,0.149,NULL,63527951132,992624236,15509753,15.3),(50966,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50966,38.86,0.46,591,13673,70,NULL,NULL,'SDSS J075644.32+190614.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000147,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,119.184667,19.10389,0.089,NULL,62623769831,978496403,15289006,18.8),(50967,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50967,33.72,0.4,55.4,13674,NULL,NULL,'mean','NGC 2476',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.00006,NULL,'13.58',0.8,'E?','in a pair',NULL,NULL,NULL,1,119.18825,39.92789,0.225,NULL,63566645673,993228838,15519200,13.58),(50968,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50968,33.94,0.45,61.4,13674,NULL,NULL,'K','NGC 2476',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50969,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50969,38.09,0.46,415,13675,70,NULL,NULL,'2MASX J07564561+1455423',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000147,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,119.190125,14.92842,0.085,NULL,62665771472,979152679,15299260,17.5),(50970,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50970,36.8,0.21,229,13676,70,NULL,NULL,'SDSS J075646.61+455344.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000073,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,119.19425,45.89569,0.149,NULL,63527950424,992624225,15509753,17.8),(50971,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50971,38.38,0.46,475,13677,70,NULL,NULL,'SDSS J075647.41+421248.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000085,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,119.1975417,42.21342,0.209,NULL,63567120025,993236250,15519316,18.5),(50972,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50972,37.48,0.33,314,13678,70,NULL,NULL,'2MASX J07564874+5312566',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000184,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,119.2029583,53.21561,0.097,NULL,63514038955,992406858,15506357,16.6),(50973,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50973,36,0.46,159,13679,70,NULL,NULL,'2MASX J07564928+1353493',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000168,NULL,'15.8g',0.41,'AGN+SF',NULL,NULL,NULL,NULL,1,119.205291667,13.89717,0.077,NULL,62666350506,979161726,15299401,15.8),(50974,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50974,36.59,0.46,208,13680,70,NULL,NULL,'SDSS J075649.51+195349.8',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00019,NULL,'15.9g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,119.206333333,19.89719,0.109,NULL,62622474846,978476169,15288690,15.9),(50975,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50975,37.9,0.46,381,13681,70,NULL,NULL,'2MASX J07564980+2650033',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000175,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,119.2075,26.83422,0.101,NULL,64293013321,1004578333,15696536,16.9),(50976,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50976,35.51,0.46,126,13682,70,NULL,NULL,'2MASX J07564982+1722493',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000154,NULL,'15.9g',0.26,'S0a',NULL,NULL,NULL,NULL,1,119.207583,17.38033,0.081,NULL,62668553230,979196144,15299939,15.9),(50977,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50977,34.96,0.46,98,13683,70,NULL,NULL,'2MASX J07564984+3449524',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000083,NULL,'16.1g',0.3,'AGN+SF',NULL,NULL,NULL,NULL,1,119.20775,34.83128,0.213,NULL,63446296525,991348383,15489818,16.1),(50978,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50978,37.43,0.46,306,13684,70,NULL,NULL,'2MASX J07565006+3532254',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,119.20875,35.54044,0.205,NULL,63447505496,991367273,15490113,17.1),(50979,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50979,36.15,0.46,170,13685,70,NULL,NULL,'2MASX J07565065+1758506',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000178,NULL,'16.0g',0.41,NULL,NULL,NULL,NULL,NULL,1,119.211083,17.98064,0.149,NULL,62668313540,979192399,15299881,16),(50980,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50980,36.41,0.46,191,13686,70,NULL,NULL,'2MASX J07565163+1124506',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.0002,NULL,'16.0g',0.31,NULL,NULL,NULL,NULL,NULL,1,119.215083,11.41397,0.057,NULL,62759014952,980609608,15322025,16),(50981,'Sosies','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50981,33.02,0.35,40.2,13687,NULL,NULL,NULL,'NGC 2460',NULL,'2002A&A...393...57T',2002,1,2.5,NULL,'G',0.000005,NULL,'12.72',1.9,'SA(s)a         AGN','in a pair',NULL,NULL,NULL,1,119.217875,60.34939,0.129,NULL,61571555475,962055554,15032118,12.72),(50982,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50982,31.87,0.4,23.6,13687,75,NULL,'B','NGC 2460',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50983,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50983,36.16,0.19,171,13688,70,NULL,NULL,'2MASX J07565235+3749144',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000089,NULL,'16.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,119.21825,37.82069,0.173,NULL,63450228488,991409820,15490778,16.6),(50984,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50984,37.43,0.46,306,13689,70,NULL,NULL,'2MASX J07565256+1658523',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000174,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,119.219,16.98128,0.109,NULL,62676215874,979315873,15301810,17.1),(50985,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50985,37.48,0.33,314,13690,70,NULL,NULL,'2MASX J07565339+5309575',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'17.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,119.222833333,53.16603,0.097,NULL,63514040012,992406875,15506357,17.4),(50986,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50986,31.17,NULL,17.2,13691,NULL,NULL,'Dipole','ESO 494- G 007',NULL,'2010Ap&SS.325..163P',2010,1,3.14,'abs(b) < 10 degrees.','G',0.000003,NULL,'14.06',0.39,'Sc','Pair member (points to parent)',NULL,NULL,NULL,1,119.226375,-24.90608,NULL,NULL,42683704690,666932885,10420826,14.06),(50987,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50987,31.22,NULL,17.5,13691,NULL,NULL,'Dipole + Quadrupole','ESO 494- G 007',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50988,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50988,31.22,NULL,17.5,13691,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 494- G 007',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50989,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50989,32.05,0.39,25.7,13691,73,NULL,'IR','ESO 494- G 007',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50990,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50990,32.05,0.4,25.7,13691,75,NULL,NULL,'ESO 494- G 007',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50991,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50991,32.62,0.4,33.4,13691,NULL,NULL,'mean','ESO 494- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50992,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50992,32.71,0.49,34.9,13691,75,NULL,'IR','ESO 494- G 007',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50993,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50993,33.13,0.47,42.3,13691,NULL,NULL,'H','ESO 494- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50994,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50994,33.32,0.45,46.1,13691,NULL,NULL,'K','ESO 494- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(50995,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50995,38.17,0.33,430,13692,70,NULL,NULL,'2MASX J07565594+1613252',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000189,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,119.233167,16.22375,0.113,NULL,62679644079,979369438,15302647,16.9),(50996,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50996,38.52,0.46,507,13693,70,NULL,NULL,'2MASX J07565725+1610472',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000179,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,119.238667,16.17989,0.101,NULL,62679639751,979369371,15302646,17.9),(50997,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50997,38.43,0.46,485,13694,70,NULL,NULL,'SDSS J075657.38+304603.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,119.239083,30.76772,0.101,NULL,63422714669,990979916,15484061,18.6),(50998,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',50998,38,0.46,398,13695,70,NULL,NULL,'2MASX J07570154+2608595',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000131,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,119.2565,26.14981,0.177,NULL,64293461138,1004585330,15696645,18),(50999,'Brightest Stars','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,50999,28.61,0.4,5.27,13696,NULL,NULL,'3B + 3R mean','UGC 04115',NULL,'1997AstL...23..514G',1997,1,1.8,NULL,'G',0.000017,NULL,'15.2',1,'IAm','Dwarf, field object',NULL,NULL,NULL,1,119.2575,14.39083,0.101,NULL,62665330030,979145781,15299152,15.2),(51000,'Brightest Stars','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51000,28.84,NULL,5.86,13696,NULL,NULL,'LF','UGC 04115',NULL,'1997AstL...23..514G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51001,'TRGB','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51001,28.7,0.23,5.49,13696,NULL,NULL,NULL,'UGC 04115',NULL,'2003A&A...398..479K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51002,'TRGB','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51002,29.44,0.05,7.72,13696,NULL,NULL,NULL,'UGC 04115',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51003,'TRGB','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51003,29.44,0.1,7.73,13696,NULL,NULL,NULL,'UGC 04115',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51004,'TRGB','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51004,29.48,0.1,7.87,13696,74.4,NULL,NULL,'UGC 04115',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51005,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51005,27.51,0.4,3.2,13696,75,NULL,'B','UGC 04115',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51006,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51006,36.69,0.46,218,13697,70,NULL,NULL,'2MASX J07570235+3416254',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000174,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,119.259916667,34.27361,0.173,NULL,63447127312,991361364,15490021,16.6),(51007,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51007,34.12,0.46,66.6,13698,70,NULL,NULL,'CGCG 178-006',NULL,'2015arXiv151105856S',2015,1,0.93,NULL,'G',0.000183,NULL,'14.3g',0.76,'E0',NULL,NULL,NULL,NULL,1,119.266333,33.08331,0.197,NULL,63443658174,991307158,15489174,14.3),(51008,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51008,37.51,0.21,318,13699,70,NULL,NULL,'2MASX J07570457+4059425',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000086,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,119.269,40.99517,0.265,NULL,63567865840,993247903,15519498,16.4),(51009,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51009,38.78,0.46,570,13700,70,NULL,NULL,'SDSS J075705.89+122245.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'18.1g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,119.2745417,12.37939,0.081,NULL,62634152744,978658636,15291541,18.1),(51010,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51010,36.07,0.46,163,13701,70,NULL,NULL,'2MASX J07570849+2815265',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,119.285333,28.2575,0.077,NULL,64300650370,1004697662,15698400,17.1),(51011,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51011,37.98,0.33,395,13702,70,NULL,NULL,'2MASX J07571211+2703235',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,119.300375,27.05661,0.101,NULL,64304367363,1004755740,15699308,17.4),(51012,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51012,37.4,0.46,302,13703,70,NULL,NULL,'2MASX J07571258+5025202',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,119.302375,50.42239,0.149,NULL,63514365846,992411966,15506436,17.2),(51013,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51013,38.02,0.17,402,13704,70,NULL,NULL,'SDSS J075713.88+391631.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000143,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,119.307833333,39.27544,0.241,NULL,63554440785,993038137,15516220,18.7),(51014,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51014,37.42,0.46,304,13705,70,NULL,NULL,'2MASX J07571440+5159412',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000175,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,119.309875,51.99478,0.141,NULL,63514227799,992409809,15506403,17.4),(51015,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51015,37.83,0.46,368,13706,70,NULL,NULL,'2MASX J07571435+4719543',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000144,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,119.3100417,47.33167,0.165,NULL,63535986542,992749789,15511715,17.9),(51016,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51016,35.53,0.46,128,13707,70,NULL,NULL,'CGCG 148-073',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000107,NULL,'15.1g',0.71,'E0',NULL,NULL,NULL,NULL,1,119.314375,27.496,0.089,NULL,64304964419,1004765069,15699454,15.1),(51017,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51017,36.01,0.46,160,13708,70,NULL,NULL,'CGCG 059-006',NULL,'2015arXiv151105856S',2015,1,0.98,NULL,'G',0.00007,NULL,'14.8g',0.56,NULL,NULL,NULL,NULL,NULL,1,119.316208333,11.04653,0.013,NULL,62759325015,980614453,15322100,14.8),(51018,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51018,38.02,0.17,402,13709,70,NULL,NULL,'2MASX J07571652+3912216',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,119.318917,39.20581,0.241,NULL,63554432862,993038013,15516218,18),(51019,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51019,37.47,0.46,312,13710,70,NULL,NULL,'2MASX J07571663+5213122',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00018,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,119.3195,52.22019,0.133,NULL,63514264885,992410388,15506412,17.2),(51020,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51020,36.49,0.46,199,13711,70,NULL,NULL,'KUG 0753+500',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000167,NULL,'16.3g',0.34,'S0',NULL,NULL,NULL,NULL,1,119.322125,49.92133,0.141,NULL,63507068100,992297939,15504655,16.3),(51021,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51021,34.48,NULL,78.9,13712,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04113',NULL,'2010Ap&SS.325..163P',2010,1,1.25,NULL,'G',0.000005,NULL,'16.7g',0.14,'Sd',NULL,NULL,NULL,NULL,1,119.32375,31.47011,0.121,NULL,63422325545,990973836,15483966,16.7),(51022,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51022,34.49,NULL,79.1,13712,NULL,NULL,'Dipole','UGC 04113',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51023,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51023,34.49,NULL,79.2,13712,NULL,NULL,'Dipole + Quadrupole','UGC 04113',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51024,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51024,34.53,NULL,80.4,13712,NULL,NULL,NULL,'UGC 04113',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51025,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51025,34.96,0.43,98.1,13712,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04113',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51026,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51026,38.02,0.17,402,13713,70,NULL,NULL,'2MASX J07571911+3921536',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,119.329583,39.36492,0.245,NULL,63554450562,993038290,15516223,18.1),(51027,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51027,37.51,0.21,318,13714,70,NULL,NULL,'2MASX J07571922+4053205',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000065,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,119.33025,40.889,0.257,NULL,63567870063,993247969,15519499,18.3),(51028,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51028,36.87,0.46,236,13715,70,NULL,NULL,'2MASX J07571928+3029303',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00017,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,119.330375,30.49186,0.093,NULL,64299169728,1004674527,15698039,16.5),(51029,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51029,36.31,0.46,182,13716,70,NULL,NULL,'2MASX J07572025+4906502',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000167,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,119.3342917,49.11406,0.145,NULL,63538333855,992786466,15512288,16.4),(51030,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51030,36.58,0.33,207,13717,70,NULL,NULL,'CGCG 118-028',NULL,'2015arXiv151105856S',2015,1,0.43,'CGCG notes \\\"brightest of 3\\\"; the northern-most is brightest.','G',NULL,'FoF','15.6',0.42,NULL,NULL,NULL,NULL,NULL,1,119.338833,25.895,0.161,NULL,64293651745,1004588308,15696692,15.6),(51031,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51031,34.4,0.4,76,13718,NULL,NULL,'mean','UGC 04098',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000033,NULL,'14.60',0.5,'S?','in a pair',NULL,NULL,NULL,1,119.339083,66.43714,0.129,NULL,62166772317,971355817,15177434,14.6),(51032,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51032,34.69,0.47,86.6,13718,NULL,NULL,'H','UGC 04098',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51033,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51033,34.77,0.46,90.1,13718,NULL,NULL,'J','UGC 04098',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51034,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51034,34.79,0.45,90.7,13718,NULL,NULL,'K','UGC 04098',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51035,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51035,38.09,0.46,416,13719,70,NULL,NULL,'2MASX J07572314+2947415',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,119.3465,29.79483,0.093,NULL,64302372825,1004724575,15698821,17.6),(51036,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51036,38.02,0.17,402,13720,70,NULL,NULL,'2MASX J07572348+3920272',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,119.347667,39.34089,0.245,NULL,63554450759,993038293,15516223,17.8),(51037,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51037,37.35,0.46,295,13721,70,NULL,NULL,'2MASX J07572481+4122422',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00007,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,119.3532083,41.37856,0.209,NULL,63567924887,993248826,15519512,18.1),(51038,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51038,37.98,0.33,395,13722,70,NULL,NULL,'2MASX J07572656+2705005',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000136,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,119.360625,27.08344,0.101,NULL,64304361405,1004755646,15699306,17.7),(51039,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51039,38.02,0.17,402,13723,70,NULL,NULL,'SDSS J075726.63+392222.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,119.361,39.37286,0.245,NULL,63554451000,993038296,15516223,18.4),(51040,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51040,33.14,0.43,42.4,13724,75,NULL,'3.6 micron, color + selection bias corrected','ESO 561- G 003',NULL,'2014MNRAS.444..527S',2014,1,2.13,'abs(b) < 10 degrees.','G',0.000017,NULL,'15.5',0.22,'SB(s)cd pec sp',NULL,NULL,NULL,NULL,1,119.3629583,-19.24297,NULL,NULL,39333308838,614582950,9602858,15.5),(51041,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51041,33.16,0.49,42.9,13724,75,NULL,'IR','ESO 561- G 003',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51042,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51042,33.65,NULL,53.6,13724,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 561- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51043,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51043,33.66,NULL,53.9,13724,NULL,NULL,'Dipole','ESO 561- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51044,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51044,33.67,NULL,54.3,13724,NULL,NULL,'Dipole + Quadrupole','ESO 561- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51045,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51045,36.76,0.46,225,13725,70,NULL,NULL,'2MASX J07572757+1403501',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000173,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,119.364917,14.06403,0.077,NULL,62666462199,979163471,15299429,16.3),(51046,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51046,34.56,0.43,81.7,13726,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0689',NULL,'2014MNRAS.444..527S',2014,1,1.19,NULL,'G',0.000057,NULL,'17.01',0.1,'Sd',NULL,NULL,NULL,NULL,1,119.366541667,35.72072,0.205,NULL,63450967201,991421362,15490958,17.01),(51047,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51047,34.57,NULL,81.9,13726,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0689',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51048,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51048,34.58,NULL,82.5,13726,NULL,NULL,'Dipole + Quadrupole','FGC 0689',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51049,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51049,34.59,NULL,82.7,13726,NULL,NULL,'Dipole','FGC 0689',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51050,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51050,34.64,NULL,84.6,13726,NULL,NULL,NULL,'FGC 0689',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51051,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51051,36.18,0.64,172,13727,70,NULL,NULL,'2MASX J07572837-7154460',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,119.368083,-71.91278,0.729,NULL,40631811353,634872052,9919875,16.8),(51052,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51052,37.9,0.46,380,13728,70,NULL,NULL,'SDSS J075728.88+160831.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000901,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,119.370375,16.14219,0.069,NULL,62679576531,979368383,15302630,18.1),(51053,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51053,38.57,0.46,519,13729,70,NULL,NULL,'2MASX J07573002+3612362',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00018,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,119.375083,36.20997,0.201,NULL,63450995795,991421809,15490965,17.8),(51054,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51054,35.82,0.46,146,13730,70,NULL,NULL,'CGCG 262-051',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000097,NULL,'15.0g',0.61,NULL,NULL,NULL,NULL,NULL,1,119.3807083,52.68283,0.125,NULL,63514105985,992407906,15506373,15),(51055,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51055,37.34,0.46,294,13731,70,NULL,NULL,'2MASX J07573144+3311145',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,119.380917,33.18736,0.197,NULL,63443927641,991311369,15489240,17.7),(51056,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51056,36.22,0.33,176,13732,70,NULL,NULL,'2MASX J07573140+5108162',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000177,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,119.380917,51.13792,0.157,NULL,63513124152,992392564,15506133,16.2),(51057,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51057,37.99,0.46,397,13733,70,NULL,NULL,'SDSS J075731.92+115912.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000195,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,119.3830417,11.98678,0.073,NULL,62755618890,980556545,15321196,17.9),(51058,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51058,36.69,0.46,218,13734,70,NULL,NULL,'2MASX J07573422+2818223',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,119.392583,28.30611,0.077,NULL,64300131443,1004689553,15698274,16.1),(51059,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51059,36.58,0.33,207,13735,70,NULL,NULL,'2MASX J07573554+2548263',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000072,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,119.3980417,25.80728,0.161,NULL,64293588612,1004587322,15696676,17.2),(51060,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51060,35.06,0.46,103,13736,70,NULL,NULL,'2MASX J07573738+2513163',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000165,NULL,'16.1g',0.38,'SBa',NULL,NULL,NULL,NULL,1,119.405833,25.22114,0.165,NULL,64292134004,1004564593,15696321,16.1),(51061,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51061,36.62,0.63,211,13737,70,NULL,NULL,'2MASX J07573753-0437349',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.75',NULL,NULL,NULL,NULL,NULL,NULL,1,119.4062083,-4.62639,0.329,NULL,39301343975,614083499,9595054,16.75),(51062,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51062,37.7,0.46,347,13738,70,NULL,NULL,'SDSS J075739.36+330941.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,119.4140417,33.16147,0.197,NULL,63443929553,991311399,15489240,18.2),(51063,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51063,38.35,0.46,468,13739,70,NULL,NULL,'2MASX J07573964+2616553',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000139,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,119.41525,26.28192,0.117,NULL,64293442332,1004585036,15696641,18.3),(51064,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51064,37.51,0.21,318,13740,70,NULL,NULL,'2MASX J07573986+4056453',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000065,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,119.4160417,40.94611,0.257,NULL,63567861295,993247832,15519497,17),(51065,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51065,36.98,0.46,248,13741,70,NULL,NULL,'2MASX J07574018+2512323',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000156,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,119.4175,25.20911,0.165,NULL,64292134855,1004564607,15696321,17.4),(51066,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51066,37.7,0.46,346,13742,70,NULL,NULL,'2MASX J07574196+3805183',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000068,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,119.424875,38.08853,0.181,NULL,63450201107,991409392,15490771,17.8),(51067,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51067,38.02,0.17,402,13743,70,NULL,NULL,'2MASX J07574209+3924293',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000176,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,119.4254583,39.40814,0.245,NULL,63554447434,993038241,15516222,17.5),(51068,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51068,37.26,0.46,284,13744,70,NULL,NULL,'2MASX J07574379+2007153',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000189,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,119.432583,20.12108,0.109,NULL,62623043500,978485054,15288828,16.5),(51069,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51069,38.29,0.33,454,13745,70,NULL,NULL,'2MASX J07574491+1558146',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000171,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,119.437166667,15.97075,0.113,NULL,62679559408,979368115,15302626,18.2),(51070,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51070,37.24,0.46,281,13746,70,NULL,NULL,'2MASX J07574553+3840443',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,119.4397917,38.67889,0.213,NULL,63435954520,991186789,15487293,17.6),(51071,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51071,37.08,0.46,260,13747,70,NULL,NULL,'2MASX J07574565+1140336',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,119.440333,11.67617,0.057,NULL,62755531533,980555180,15321174,17.2),(51072,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51072,34.38,0.4,75.3,13748,NULL,NULL,'mean','IC 2211',NULL,'2007A&A...465...71T',2007,1,0.94,NULL,'G',0.000033,NULL,'14.4g',0.54,'Sa',NULL,NULL,NULL,NULL,1,119.44025,32.55811,0.197,NULL,63443200253,991300003,15489062,14.4),(51073,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51073,34.39,0.47,75.6,13748,NULL,NULL,'H','IC 2211',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51074,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51074,34.45,0.45,77.8,13748,NULL,NULL,'K','IC 2211',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51075,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51075,34.54,0.46,80.8,13748,NULL,NULL,'J','IC 2211',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51076,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51076,36.69,0.46,218,13749,70,NULL,NULL,'2MASX J07574909+4237212',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000086,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,119.454625,42.6225,0.185,NULL,63567176815,993237137,15519330,16.4),(51077,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51077,38.02,0.17,402,13750,70,NULL,NULL,'2MASX J07575021+3924553',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,119.4592083,39.41553,0.245,NULL,63554400391,993037506,15516211,17.6),(51078,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51078,38.15,0.16,427,13751,70,NULL,NULL,'2MASX J07575252+2659314',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000141,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,119.468917,26.99197,0.101,NULL,64304442773,1004756918,15699326,18.6),(51079,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51079,37.25,0.46,281,13752,70,NULL,NULL,'2MASX J07575360+2809143',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000188,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,119.4734583,28.15397,0.077,NULL,64304527307,1004758239,15699347,17.9),(51080,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51080,37.25,0.46,282,13753,70,NULL,NULL,'2MASX J07575525+2932513',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000172,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,119.480333,29.54758,0.081,NULL,64302462245,1004725972,15698843,17.2),(51081,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51081,33.27,0.69,45,13754,100,NULL,'mid-IR','NGC 2486',NULL,'2013ApJ...771...88L',2013,1,1.78,NULL,'G',0.000007,NULL,'14.0g',0.88,'S(r)b','Pair member (points to parent)',NULL,NULL,NULL,1,119.485375,25.16086,0.129,NULL,64292184386,1004565381,15696334,14),(51082,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51082,34.13,0.4,66.9,13754,NULL,NULL,'mean','NGC 2486',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51083,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51083,34.42,0.07,76.7,13754,NULL,NULL,NULL,'NGC 2486',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51084,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51084,34.74,0.47,88.8,13754,NULL,NULL,'H','NGC 2486',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51085,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51085,34.79,0.46,90.8,13754,NULL,NULL,'J','NGC 2486',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51086,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51086,34.81,0.45,91.6,13754,NULL,NULL,'K','NGC 2486',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51087,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51087,34.94,0.2,97.3,13754,74.4,NULL,NULL,'NGC 2486',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51088,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51088,38.83,0.46,582,13755,70,NULL,NULL,'2MASX J07575670+3901599',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000141,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,119.486208333,39.03339,0.221,NULL,63435853161,991185205,15487268,18.5),(51089,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51089,37.31,0.46,289,13756,70,NULL,NULL,'2MASX J07575907+2035563',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,119.4962917,20.59906,0.133,NULL,62622196824,978471825,15288622,17),(51090,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51090,36.38,0.46,189,13757,70,NULL,NULL,'2MASX J07575973+4106079',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000104,NULL,'15.8g',0.4,'E0',NULL,NULL,NULL,NULL,1,119.49875,41.10231,0.265,NULL,63567881560,993248149,15519502,15.8),(51091,'AGN time lag','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51091,40.55,0.21,1290,13758,44,NULL,NULL,'FBQS J075800.0+392029',NULL,'2007MNRAS.380..669C',2007,1,0.27,NULL,'G',0.003,NULL,'14.36',0.26,'Sy1.5',NULL,NULL,NULL,'Sy 1.5',1,119.5002083,39.34142,0.241,NULL,63554396724,993037448,15516210,14.36),(51092,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51092,38.12,0.46,420,13759,70,NULL,NULL,'2MASX J07580093+1457005',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,119.5039583,14.95022,0.069,NULL,62666109616,979157962,15299343,17.2),(51093,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51093,37.15,0.46,269,13760,70,NULL,NULL,'2MASX J07580130+2325263',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000185,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,119.505458333,23.42408,0.181,NULL,63756686388,996198224,15565597,16.5),(51094,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51094,37.08,0.46,261,13761,70,NULL,NULL,'2MASX J07580242+3602200',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000154,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,119.51,36.03889,0.169,NULL,63451007118,991421986,15490968,16.9),(51095,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51095,37.51,0.21,318,13762,70,NULL,NULL,'2MASX J07580316+4052050',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000077,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,119.51325,40.868,0.257,NULL,63565992370,993218630,15519041,17.6),(51096,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51096,33.63,0.2,53.2,13763,74.4,NULL,NULL,'NGC 2469',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000037,NULL,'13.50',0.8,'Sbc pec:','Group member',NULL,NULL,NULL,1,119.51425,56.68047,0.101,NULL,61604652582,962572696,15040198,13.5),(51097,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51097,33.68,0.4,54.3,13763,NULL,NULL,'mean','NGC 2469',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51098,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51098,33.86,0.47,59.1,13763,NULL,NULL,'H','NGC 2469',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51099,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51099,33.89,0.46,60,13763,NULL,NULL,'J','NGC 2469',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51100,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51100,33.9,0.45,60.3,13763,NULL,NULL,'K','NGC 2469',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51101,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51101,36.09,0.53,166,13764,70,NULL,NULL,'2MASX J07580500-5315224',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,119.5209583,-53.25625,0.909,NULL,42521166070,664393219,10381144,17.4),(51102,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51102,36.36,0.33,187,13765,70,NULL,NULL,'2MASX J07580639+1929113',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'16.36',0.38,NULL,NULL,NULL,NULL,NULL,1,119.526583,19.48658,0.105,NULL,62624272597,978504259,15289129,16.36),(51103,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51103,37.67,0.46,341,13766,70,NULL,NULL,'2MASX J07581107+2801162',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,119.546291667,28.02125,0.065,NULL,64304572697,1004758948,15699358,17.4),(51104,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51104,36.38,0.46,189,13767,70,NULL,NULL,'2MASX J07581116+1203525',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,119.5467083,12.06456,0.073,NULL,62755579668,980555932,15321186,17.3),(51105,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51105,37.22,0.33,278,13768,70,NULL,NULL,'SDSS J075812.01+114156.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000144,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,119.550083333,11.699,0.057,NULL,62756009251,980562644,15321291,18.2),(51106,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51106,37.9,0.27,380,13769,70,NULL,NULL,'2MASX J07581282+3832071',NULL,'2015arXiv151105856S',2015,1,0.57,'May be a resolved component of B3 0754+386.','G',0.000217,NULL,'16.0g',0.39,'BrClG',NULL,NULL,NULL,NULL,1,119.5532917,38.53528,0.229,NULL,63435790159,991184221,15487253,16),(51107,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51107,37.51,0.21,318,13770,70,NULL,NULL,'2MASX J07581330+4049181',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000095,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,119.555583,40.82175,0.257,NULL,63565993098,993218642,15519041,17),(51108,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51108,37.22,0.33,278,13771,70,NULL,NULL,'2MASX J07581390+1137069',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000176,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,119.558,11.61853,0.057,NULL,62756008083,980562626,15321291,16.7),(51109,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51109,37.9,0.27,380,13772,70,NULL,NULL,'2MASX J07581402+3829381',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000149,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,119.558333,38.49386,0.229,NULL,63435830491,991184851,15487263,17.6),(51110,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51110,36.16,0.19,171,13773,70,NULL,NULL,'2MASX J07581480+3729501',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00019,NULL,'15.7g',0.44,'AGN',NULL,NULL,NULL,NULL,1,119.561625,37.49731,0.165,NULL,63450079754,991407496,15490742,15.7),(51111,'IRAS','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51111,30.73,0.8,14,13774,75,NULL,'A82, H','ESO 209- G 009',NULL,'1997ApJS..109..333W',1997,1,7.5,NULL,'G',0.00001,NULL,'12.68',0.9,'SB(s)cd: sp',NULL,NULL,NULL,NULL,1,119.5642917,-49.85425,0.681,NULL,42524008476,664437632,10381838,12.68),(51112,'Tully est','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51112,30.54,0.8,12.8,13774,75,NULL,NULL,'ESO 209- G 009',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51113,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51113,30.4,0.43,12,13774,75,NULL,'3.6 micron, color + selection bias corrected','ESO 209- G 009',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51114,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51114,30.46,0.35,12.4,13774,NULL,NULL,NULL,'ESO 209- G 009',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51115,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51115,30.47,0.4,12.4,13774,73,NULL,'opt','ESO 209- G 009',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51116,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51116,30.65,0.47,13.5,13774,75,NULL,'A82, H, raw','ESO 209- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51117,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51117,30.65,0.43,13.5,13774,75,NULL,'3.6 micron, color corrected','ESO 209- G 009',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51118,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51118,30.7,0.47,13.8,13774,75,NULL,'A82, H, inv','ESO 209- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51119,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51119,30.73,0.2,14,13774,74.4,NULL,NULL,'ESO 209- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51120,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51120,30.74,0.46,14.1,13774,NULL,NULL,'J','ESO 209- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51121,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51121,30.8,0.47,14.4,13774,NULL,NULL,'H','ESO 209- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51122,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51122,30.88,0.45,15,13774,NULL,NULL,'K','ESO 209- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51123,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51123,30.91,0.4,15.2,13774,NULL,NULL,'mean','ESO 209- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51124,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51124,30.92,0.47,15.3,13774,75,NULL,'A82, H, cor','ESO 209- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51125,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51125,31.14,NULL,16.9,13774,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 209- G 009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51126,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51126,31.15,NULL,17,13774,NULL,NULL,'Dipole','ESO 209- G 009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51127,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51127,31.16,NULL,17,13774,NULL,NULL,'Dipole + Quadrupole','ESO 209- G 009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51128,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51128,31.27,NULL,17.9,13774,NULL,NULL,NULL,'ESO 209- G 009',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51129,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51129,31.32,0.49,18.4,13774,75,NULL,'IR','ESO 209- G 009',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51130,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51130,36.16,0.19,171,13775,70,NULL,NULL,'2MASX J07581674+3730071',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000063,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,119.569875,37.50208,0.165,NULL,63450081539,991407524,15490742,16.7),(51131,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51131,38.51,0.46,505,13776,70,NULL,NULL,'2MASX J07581857+1800059',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000129,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,119.577333,18.00175,0.061,NULL,62668784234,979199753,15299996,18.6),(51132,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51132,38.11,0.46,420,13777,70,NULL,NULL,'SDSS J075818.70+164617.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000131,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,119.577958333,16.77161,0.081,NULL,62676021412,979312834,15301763,18.4),(51133,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51133,38.01,0.17,400,13778,70,NULL,NULL,'2MASX J07581883+5357376',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,119.578417,53.96047,0.085,NULL,61577319496,962145617,15033525,18),(51134,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51134,37.88,0.27,377,13779,70,NULL,NULL,'2MASX J07581931+3053350',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000154,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,119.5805417,30.89306,0.101,NULL,64299603413,1004681303,15698145,17.4),(51135,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51135,37.31,0.46,290,13780,70,NULL,NULL,'2MASX J07582041+2907523',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000157,NULL,'18.0g',NULL,NULL,NULL,NULL,NULL,NULL,1,119.585,29.13108,0.073,NULL,64300529688,1004695776,15698371,18),(51136,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 1975O','R',51136,34.26,NULL,71.1,13781,NULL,NULL,'Photographic','NGC 2487',NULL,'1988SSRv...48....1R',1988,1,1.63,NULL,'G',0.00001,NULL,'13.5g',1.37,'SB(r)c','Pair member (points to parent)',NULL,NULL,NULL,1,119.58525,25.14922,0.129,NULL,64292177973,1004565280,15696332,13.5),(51137,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 1975O',NULL,51137,34.26,0.4,71.1,13781,60,NULL,'M(V) = -19.47 mag','NGC 2487',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51138,'SNIa','2016-12-15 15:14:18','2016-12-16 11:19:24','1','SN 1975O',NULL,51138,34.38,0.4,75.2,13781,60,NULL,'M(B) = -19.48 mag','NGC 2487',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51139,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51139,34.11,0.47,66.3,13781,NULL,NULL,'H','NGC 2487',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51140,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51140,34.12,0.45,66.5,13781,NULL,NULL,'K','NGC 2487',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51141,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51141,34.19,0.46,68.7,13781,NULL,NULL,'J','NGC 2487',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51142,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51142,34.23,0.4,70.1,13781,NULL,NULL,'mean','NGC 2487',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51143,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51143,34.35,0.06,74.3,13781,NULL,NULL,NULL,'NGC 2487',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51144,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51144,38.29,0.33,454,13782,70,NULL,NULL,'2MASX J07582082+1558192',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,119.586875,15.97211,0.049,NULL,62677910073,979342344,15302224,18.2),(51145,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51145,36.9,0.46,239,13783,70,NULL,NULL,'2MASX J07582236+1757589',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000178,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,119.5932917,17.96628,0.061,NULL,62668755677,979199307,15299989,17.3),(51146,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51146,36.36,0.33,187,13784,70,NULL,NULL,'2MASX J07582250+1930249',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'16.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,119.593875,19.50694,0.105,NULL,62624962241,978515035,15289297,16.9),(51147,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51147,37.4,0.46,302,13785,70,NULL,NULL,'2MASX J07582421+3225220',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,119.6009583,32.42267,0.189,NULL,63443270391,991301099,15489079,17.3),(51148,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51148,35.64,0.46,134,13786,70,NULL,NULL,'MCG +09-13-098',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.00011,NULL,'15.3g',0.55,NULL,NULL,NULL,NULL,NULL,1,119.6017917,52.76858,0.109,NULL,63514144389,992408506,15506382,15.3),(51149,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51149,37.9,0.27,380,13787,70,NULL,NULL,'SDSS J075825.94+382810.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000141,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,119.608083,38.46964,0.229,NULL,63435826717,991184792,15487262,18.5),(51150,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51150,38.15,0.16,427,13788,70,NULL,NULL,'2MASX J07582637+2700372',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00013,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,119.609875,27.01042,0.101,NULL,64304438997,1004756859,15699325,17.7),(51151,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51151,38.64,0.46,536,13789,70,NULL,NULL,'SDSS J075827.06+202733.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000143,NULL,'19.0g',0.09,NULL,NULL,NULL,NULL,NULL,1,119.6127917,20.45928,0.097,NULL,62622152564,978471133,15288611,19),(51152,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51152,36.16,0.19,171,13790,70,NULL,NULL,'NGC 2484',NULL,'2015arXiv151105856S',2015,1,1.36,'SDSS has z = 0.040855 +- 0.000230.','G',0.000087,NULL,'14.1g',0.89,'S0:            LERG',NULL,NULL,'radio jet',NULL,1,119.617125,37.78661,0.173,NULL,63449973096,991405829,15490716,14.1),(51153,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51153,36.84,0.46,233,13791,70,NULL,NULL,'2MASX J07583017+4609506',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000096,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,119.625875,46.16408,0.149,NULL,63527706506,992620414,15509693,16.6),(51154,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51154,38.15,0.16,427,13792,70,NULL,NULL,'2MASX J07583081+2713332',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000122,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,119.6284583,27.22597,0.077,NULL,64304280999,1004754390,15699287,18.6),(51155,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51155,38.28,0.46,453,13793,70,NULL,NULL,'2MASX J07583121+2020169',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000179,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,119.630125,20.33814,0.097,NULL,62622871627,978482369,15288787,18.3),(51156,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51156,37.39,0.33,300,13794,70,NULL,NULL,'2MASX J07583210+2749412',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000228,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,119.6337083,27.82822,0.065,NULL,64304532412,1004758318,15699348,16.7),(51157,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51157,36.4,0.8,190,13795,70,NULL,NULL,'2MASX J07583212-6642474',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,119.633917,-66.71322,0.669,NULL,40644696626,635073384,9923021,17),(51158,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51158,38,0.46,398,13796,70,NULL,NULL,'2MASX J07583291+2013429',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000149,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,119.6370417,20.22847,0.097,NULL,62622899814,978482809,15288793,17.5),(51159,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51159,38,0.46,398,13797,70,NULL,NULL,'2MASX J07583357+1519192',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,119.639791667,15.32203,0.093,NULL,62678157582,979346212,15302284,17.5),(51160,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51160,37.62,0.46,334,13798,70,NULL,NULL,'SDSS J075833.69+235856.1',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,119.640416667,23.98225,0.145,NULL,63755864594,996185384,15565396,17.3),(51161,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51161,37.96,0.46,391,13799,70,NULL,NULL,'SDSS J075836.00+423901.4',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000089,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,119.650167,42.65044,0.185,NULL,63566845983,993231968,15519249,17),(51162,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51162,37.67,0.46,343,13800,70,NULL,NULL,'2MASX J07583736+1544251',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000185,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,119.6557083,15.74036,0.089,NULL,62678292292,979348317,15302317,17),(51163,'GRB','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51163,47.81,1.56,11600,13801,100,NULL,NULL,'GRB 071020',2.145,'2009EPJC...63..139W',2009,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,119.665291667,32.86092,0.201,NULL,63443911646,991311119,15489236,NULL),(51164,'GRB','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51164,48.02,1.49,12700,13801,100,NULL,NULL,'GRB 071020',2.145,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51165,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51165,37.34,0.46,294,13802,70,NULL,NULL,'2MASX J07583993+4720008',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,119.666333333,47.33353,0.165,NULL,63539131423,992798928,15512483,17.2),(51166,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51166,36.88,0.46,238,13803,70,NULL,NULL,'2MASX J07584132+0737528',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,119.672208333,7.63133,0.009,NULL,62807895049,981373360,15333958,17.1),(51167,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51167,37.95,0.46,389,13804,70,NULL,NULL,'2MASX J07584167+5023118',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,119.6735417,50.38669,0.145,NULL,63512313480,992379898,15505935,17),(51168,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51168,37.88,0.27,377,13805,70,NULL,NULL,'2MASX J07584316+3046256',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000185,NULL,'16.3g',0.39,'BrClG',NULL,NULL,NULL,NULL,1,119.6797083,30.77383,0.101,NULL,64299624810,1004681637,15698150,16.3),(51169,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51169,37.46,0.46,310,13806,70,NULL,NULL,'2MASX J07584317+3007166',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000144,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,119.680167,30.12144,0.093,NULL,64299042238,1004672534,15698008,16.9),(51170,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51170,37.84,0.46,370,13807,70,NULL,NULL,'2MASX J07584430+2226338',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,119.684667,22.44261,0.169,NULL,63754953867,996171154,15565174,18.3),(51171,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51171,36.83,0.46,233,13808,70,NULL,NULL,'2MASX J07584442+4030592',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000058,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,119.685166667,40.51653,0.301,NULL,63554747158,993042924,15516295,17.6),(51172,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51172,36.16,0.19,171,13809,70,NULL,NULL,'2MASX J07584500+3715422',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000159,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,119.6875417,37.26169,0.177,NULL,63450612576,991415821,15490872,17.4),(51173,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51173,36.16,0.19,171,13810,70,NULL,NULL,'2MASX J07584599+3736552',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000073,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,119.6915,37.61525,0.165,NULL,63450104949,991407889,15490748,17.3),(51174,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51174,38.14,0.33,425,13811,70,NULL,NULL,'2MASX J07584667+2734518',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,119.6945,27.58108,0.069,NULL,64304740845,1004761575,15699399,17),(51175,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51175,37.18,0.46,273,13812,70,NULL,NULL,'2MASX J07584746+4344549',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000063,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,119.697666667,43.74864,0.117,NULL,63558816043,993106500,15517289,17.8),(51176,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51176,38.15,0.16,427,13813,70,NULL,NULL,'2MASX J07584795+2717058',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000133,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,119.699833,27.285,0.069,NULL,64304749857,1004761716,15699401,17.5),(51177,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51177,37.39,0.33,300,13814,70,NULL,NULL,'2MASX J07584840+2752158',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,119.70175,27.87111,0.065,NULL,64304544350,1004758505,15699351,17.6),(51178,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51178,36.27,0.46,179,13815,70,NULL,NULL,'2MASX J07584911+2326488',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,119.704583,23.44689,0.157,NULL,63756230921,996191108,15565486,17.5),(51179,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51179,38.2,0.46,436,13816,70,NULL,NULL,'2MASX J07584968+2727558',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000117,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,119.706958333,27.46553,0.069,NULL,64304761566,1004761899,15699404,18.5),(51180,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51180,37.93,0.46,385,13817,70,NULL,NULL,'2MASX J07584979+1436243',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,119.707583,14.60672,0.097,NULL,62666227799,979159809,15299372,17.6),(51181,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51181,37.35,0.46,295,13818,70,NULL,NULL,'2MASX J07585227+3502336',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00016,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,119.71775,35.04267,0.213,NULL,63444451768,991319558,15489368,16.7),(51182,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51182,38.01,0.17,400,13819,70,NULL,NULL,'SDSS J075853.11+535817.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000144,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,119.721333,53.97164,0.085,NULL,61577362991,962146296,15033535,18.7),(51183,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51183,36.64,0.46,212,13820,70,NULL,NULL,'2MASX J07585334+4223519',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000077,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,119.722333,42.39789,0.181,NULL,63567737105,993245892,15519467,16.7),(51184,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51184,37.53,0.46,320,13821,70,NULL,NULL,'SDSS J075854.19+123204.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.1g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,119.725791667,12.53467,0.041,NULL,62633741061,978652204,15291440,18.1),(51185,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51185,31.38,0.4,18.9,13822,75,NULL,'B','UGC 04121',NULL,'1988NBGC.C....0000T',1988,1,2.3,NULL,'G',0.00002,NULL,'15.20',0.7,'Sm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,119.725833,58.0425,0.101,NULL,61602912559,962545508,15039773,15.2),(51186,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51186,38.14,0.33,425,13823,70,NULL,NULL,'2MASX J07585630+2733248',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000188,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,119.734625,27.55686,0.069,NULL,64304739115,1004761548,15699399,17.5),(51187,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51187,35.16,0.46,108,13824,70,NULL,NULL,'IC 2212',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000113,NULL,'14.9g',0.74,'SBa',NULL,NULL,NULL,NULL,1,119.738333,32.61225,0.197,NULL,63443300594,991301571,15489087,14.9),(51188,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51188,37.64,0.46,338,13825,70,NULL,NULL,'2MASX J07585815+2709368',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000174,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,119.7425,27.16031,0.077,NULL,64304309277,1004754832,15699294,16.9),(51189,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51189,38.31,0.46,459,13826,70,NULL,NULL,'SDSS J075858.93+163835.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,119.745583333,16.64308,0.093,NULL,62677844671,979341322,15302208,18.3),(51190,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51190,38.15,0.16,427,13827,70,NULL,NULL,'SDSS J075859.32+271256.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000141,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,119.747208333,27.21578,0.077,NULL,64304277819,1004754340,15699286,17.9),(51191,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51191,36.47,0.46,197,13828,70,NULL,NULL,'2MASX J07590062+1516133',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000186,NULL,'15.8g',0.43,NULL,NULL,NULL,NULL,NULL,1,119.7527083,15.27044,0.093,NULL,62678338428,979349037,15302328,15.8),(51192,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51192,37.41,0.46,303,13829,70,NULL,NULL,'SDSS J075900.98+443740.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000068,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,119.754125,44.62797,0.097,NULL,63530624035,992666000,15510406,18.7),(51193,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51193,38.15,0.16,427,13830,70,NULL,NULL,'2MASX J07590099+2707118',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000108,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,119.754333333,27.12003,0.077,NULL,64304302717,1004754729,15699292,18.4),(51194,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51194,38.24,0.46,444,13831,70,NULL,NULL,'SDSS J075902.02+130701.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'18.2g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,119.758458333,13.11722,0.061,NULL,62663495706,979117120,15298705,18.2),(51195,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51195,34.24,0.4,70.4,13832,NULL,NULL,'mean','IC 0481',NULL,'2007A&A...465...71T',2007,1,1.38,NULL,'G',0.000012,NULL,'14.9g',0.32,'S',NULL,NULL,NULL,NULL,1,119.761917,24.16064,0.141,NULL,63755959116,996186861,15565419,14.9),(51196,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51196,34.29,0.1,72.3,13832,NULL,NULL,NULL,'IC 0481',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51197,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51197,34.36,0.49,74.4,13832,75,NULL,'IR','IC 0481',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51198,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51198,34.4,0.2,75.9,13832,74.4,NULL,NULL,'IC 0481',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51199,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51199,34.48,0.47,78.5,13832,NULL,NULL,'H','IC 0481',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51200,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51200,34.6,0.45,83,13832,NULL,NULL,'K','IC 0481',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51201,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51201,37.1,0.23,263,13833,70,NULL,NULL,'2MASX J07590308+4606439',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000099,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,119.7627917,46.11225,0.149,NULL,63527711912,992620498,15509695,17),(51202,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51202,37.99,0.46,396,13834,70,NULL,NULL,'2MASX J07590358+2653097',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000159,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,119.765125,26.88603,0.061,NULL,64304416167,1004756502,15699320,18.1),(51203,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51203,37.43,0.46,307,13835,70,NULL,NULL,'2MASX J07590495+4858347',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000185,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,119.7705,48.97628,0.133,NULL,63538401474,992787523,15512305,17.3),(51204,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51204,38.34,0.46,465,13836,70,NULL,NULL,'SDSS J075904.94+484438.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000116,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,119.770625,48.74406,0.133,NULL,63538414617,992787728,15512308,18),(51205,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51205,37.1,0.23,263,13837,70,NULL,NULL,'2MASXi J0759084+460418',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000084,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,119.785125,46.07197,0.149,NULL,63527676857,992619950,15509686,16.5),(51206,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51206,37.99,0.46,397,13838,70,NULL,NULL,'SDSS J075908.83+490104.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000142,NULL,'18.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,119.7867917,49.01794,0.133,NULL,63538404669,992787572,15512305,18.4),(51207,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51207,38.03,0.46,403,13839,70,NULL,NULL,'2MASX J07590930+1446343',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000184,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,119.7887917,14.77622,0.097,NULL,62664314786,979129918,15298904,17.4),(51208,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51208,37.41,0.46,304,13840,70,NULL,NULL,'2MASX J07590995+2248237',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000141,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,119.791333,22.80658,0.221,NULL,63754756616,996168072,15565126,18.1),(51209,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51209,38.27,0.27,451,13841,70,NULL,NULL,'SDSS J075909.96+294651.7',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.0g',0.26,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,119.7915417,29.78106,0.081,NULL,64302554509,1004727414,15698865,17),(51210,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51210,38.27,0.27,451,13842,70,NULL,NULL,'2MASX J07591001+2944169',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000146,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,119.791875,29.73814,0.081,NULL,64302561567,1004727524,15698867,18),(51211,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51211,37.76,0.46,356,13843,70,NULL,NULL,'2MASX J07591163+4942376',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000155,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,119.7985,49.71044,0.137,NULL,63537463627,992772869,15512076,17.5),(51212,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51212,37.88,0.27,377,13844,70,NULL,NULL,'2MASX J07591290+3047183',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,119.803833,30.78839,0.121,NULL,64299619984,1004681562,15698149,17.5),(51213,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51213,37.1,0.23,263,13845,70,NULL,NULL,'2MASX J07591292+4614449',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000054,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,119.8040417,46.24575,0.149,NULL,63527691059,992620172,15509690,17.8),(51214,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51214,34.01,0.46,63.4,13846,NULL,NULL,'J','UGC 04132',NULL,'2007A&A...465...71T',2007,1,2.01,NULL,'G',0.000033,NULL,'13.9g',0.52,'Sbc',NULL,NULL,NULL,NULL,1,119.804375,32.91469,0.229,NULL,63443993866,991312404,15489256,13.9),(51215,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51215,34.01,0.45,63.5,13846,NULL,NULL,'K','UGC 04132',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51216,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51216,34.02,0.47,63.8,13846,NULL,NULL,'H','UGC 04132',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51217,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51217,34.09,0.49,65.8,13846,75,NULL,'IR','UGC 04132',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51218,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51218,34.29,0.4,72,13846,NULL,NULL,'mean','UGC 04132',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51219,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51219,34.52,0.52,80,13846,NULL,NULL,'Malmquist cor.','UGC 04132',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51220,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51220,34.57,0.43,82,13846,75,NULL,'3.6 micron, color corrected','UGC 04132',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51221,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51221,34.58,0.43,82.3,13846,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04132',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51222,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51222,34.69,0.2,86.7,13846,74.4,NULL,NULL,'UGC 04132',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51223,'Tully-Fisher','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,NULL,51223,34.77,0.46,90,13846,NULL,NULL,NULL,'UGC 04132',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51224,'FP','2016-12-15 15:14:18','2016-12-16 11:19:24','1',NULL,'R',51224,37.6,0.46,331,13847,70,NULL,NULL,'SDSS J075914.82+510618.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,119.8117917,51.10522,0.157,NULL,63513204628,992393822,15506153,18.5),(51225,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51225,34.42,0.49,76.4,13848,75,NULL,'IR','UGC 04135',NULL,'2011yCatp016004901K',2011,1,1.36,NULL,'G',0.000033,NULL,'15.3g',0.27,'S?',NULL,NULL,NULL,NULL,1,119.821667,24.45206,0.141,NULL,63755917392,996186209,15565409,15.3),(51226,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51226,34.67,0.12,86.1,13848,NULL,NULL,NULL,'UGC 04135',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51227,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51227,36.48,0.46,197,13849,70,NULL,NULL,'2MASX J07591742+4200308',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000106,NULL,'15.7g',0.42,'NLAGN',NULL,NULL,NULL,NULL,1,119.8225,42.0085,0.165,NULL,63567669982,993244843,15519450,15.7),(51228,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51228,37.35,0.46,295,13850,70,NULL,NULL,'SDSS J075918.82+513854.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000151,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,119.8284583,51.64856,0.145,NULL,63512608095,992384501,15506007,18.4),(51229,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51229,38.13,0.27,422,13851,70,NULL,NULL,'2MASX J07591895+1814565',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,119.828917,18.24911,0.053,NULL,62623374929,978490233,15288909,18.1),(51230,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51230,36.63,0.46,212,13852,70,NULL,NULL,'2MASX J07591970+4920494',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000147,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,119.832,49.347,0.137,NULL,63537626691,992775417,15512115,17.3),(51231,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51231,38.15,0.16,427,13853,70,NULL,NULL,'2MASX J07592005+2709499',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000176,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,119.8335417,27.164,0.077,NULL,64304312757,1004754886,15699295,17.7),(51232,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51232,35.38,0.56,119,13854,70,NULL,NULL,'2MASX J07592017-0445522',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'16.25',0.4,NULL,NULL,NULL,NULL,NULL,1,119.834167,-4.76469,0.285,NULL,39301144153,614080377,9595005,16.25),(51233,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51233,37.72,0.46,350,13855,70,NULL,NULL,'2MASX J07592048+0847533',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,119.835458333,8.79817,0.033,NULL,62807658093,981369657,15333900,17.1),(51234,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51234,33.85,0.2,58.9,13856,74.4,NULL,NULL,'UGC 04140',NULL,'2013AJ....146...86T',2013,1,1.55,NULL,'G',0.000033,NULL,'15.2g',0.28,'Sbc',NULL,NULL,NULL,NULL,1,119.842583333,18.11019,0.061,NULL,62668728286,979198879,15299982,15.2),(51235,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51235,33.93,0.49,61.1,13856,75,NULL,'IR','UGC 04140',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51236,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51236,34.25,0.12,70.9,13856,NULL,NULL,NULL,'UGC 04140',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51237,'GRB','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51237,47.79,1.52,6760,13857,NULL,NULL,NULL,'GRB 080916C',4.35,'2010JCAP...08..020W',2010,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,119.8472917,-56.63842,1.033,NULL,40464291143,632254549,9878977,NULL),(51238,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51238,38.13,0.27,422,13858,70,NULL,NULL,'2MASX J07592324+1815095',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000214,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,119.846833333,18.25269,0.053,NULL,62623373030,978490203,15288909,16.2),(51239,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51239,37.97,0.46,392,13859,70,NULL,NULL,'SDSS J075925.00+270748.8',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,119.854167,27.13025,0.077,NULL,64304312941,1004754889,15699295,16.9),(51240,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51240,38.13,0.27,422,13860,70,NULL,NULL,'2MASX J07592604+1805345',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000198,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,119.8585,18.093,0.061,NULL,62668731926,979198936,15299983,16.9),(51241,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51241,38.22,0.33,441,13861,70,NULL,NULL,'2MASX J07592711+1415433',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,119.8629583,14.26219,0.097,NULL,62666950430,979171100,15299548,18.1),(51242,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51242,38.28,0.46,454,13862,70,NULL,NULL,'2MASX J07592773+5352425',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000176,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,119.8655417,53.87867,0.085,NULL,61577337640,962145900,15033529,18),(51243,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51243,34.77,0.46,89.9,13863,70,NULL,NULL,'NGC 2492',NULL,'2015arXiv151105856S',2015,1,1.12,NULL,'G',0.0001,NULL,'13.7g',0.98,'S0-:',NULL,NULL,NULL,NULL,1,119.873791667,27.02644,0.061,NULL,64304289572,1004754524,15699289,13.7),(51244,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51244,37.53,0.46,321,13864,70,NULL,NULL,'2MASX J07593174+3148182',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,119.8822083,31.80508,0.149,NULL,64298692890,1004667076,15697923,18.2),(51245,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51245,37.24,0.46,280,13865,70,NULL,NULL,'2MASX J07593221+2638179',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000138,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,119.884083,26.63833,0.049,NULL,64306066068,1004782282,15699723,17),(51246,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51246,37.38,0.46,300,13866,70,NULL,NULL,'2MASX J07593455+1821004',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,119.894,18.35011,0.049,NULL,62623322952,978489421,15288897,17.6),(51247,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51247,38.22,0.33,441,13867,70,NULL,NULL,'2MASX J07593460+1405483',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000138,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,119.894333,14.09664,0.097,NULL,62667067251,979172925,15299576,18.5),(51248,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51248,37.54,0.46,322,13868,70,NULL,NULL,'2MASX J07593484+1444543',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,119.89525,14.74831,0.097,NULL,62664321447,979130022,15298906,17.2),(51249,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51249,37.81,0.27,366,13869,70,NULL,NULL,'SDSS J075935.50+382001.6',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000161,NULL,'18.7g',0.09,NULL,NULL,NULL,NULL,NULL,1,119.8979583,38.33381,0.225,NULL,63436646416,991197600,15487462,18.7),(51250,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51250,38.02,0.46,401,13870,70,NULL,NULL,'2MASX J07593768+5416530',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000173,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,119.907167,54.28139,0.069,NULL,61577425807,962147278,15033551,18.2),(51251,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51251,36.78,0.46,227,13871,70,NULL,NULL,'2MASX J07593768+3030588',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000057,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,119.907208333,30.51636,0.117,NULL,64299514377,1004679912,15698123,16.8),(51252,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51252,34.39,0.33,75.6,13872,70,NULL,NULL,'2MASX J07593778+1326003',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000173,NULL,'15.1g',0.46,NULL,NULL,NULL,NULL,NULL,1,119.907541667,13.43356,0.061,NULL,62663747544,979121055,15298766,15.1),(51253,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51253,37.42,0.46,305,13873,70,NULL,NULL,'2MASX J07593879+2021584',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,119.911541667,20.36633,0.097,NULL,63760118735,996251855,15566435,17.5),(51254,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51254,35.88,0.46,150,13874,70,NULL,NULL,'2MASX J07593884+4536034',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000081,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,119.911917,45.60103,0.141,NULL,63530403304,992662551,15510352,16.6),(51255,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51255,33.7,0.47,54.9,13875,NULL,NULL,'H','NGC 2498',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000033,NULL,'14.32',0.8,'SBa:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,119.911875,24.98233,0.129,NULL,64292377501,1004568398,15696381,14.32),(51256,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51256,33.73,0.45,55.8,13875,NULL,NULL,'K','NGC 2498',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51257,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51257,33.87,0.46,59.4,13875,NULL,NULL,'J','NGC 2498',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51258,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51258,34.18,0.4,68.6,13875,NULL,NULL,'mean','NGC 2498',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51259,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51259,34.28,0.07,71.9,13875,NULL,NULL,NULL,'NGC 2498',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51260,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51260,34.88,0.49,94.5,13876,75,NULL,'IR','CGCG 148-081',NULL,'2011yCatp016004901K',2011,1,1.01,NULL,'G',0.000057,NULL,'16.0g',0.2,'Scd','Group member',NULL,NULL,NULL,1,119.913833,26.55272,0.049,NULL,64306084812,1004782575,15699727,16),(51261,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51261,35.02,0.48,101,13876,NULL,NULL,'Malmquist cor.','CGCG 148-081',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51262,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51262,35.09,NULL,104,13876,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 148-081',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51263,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51263,35.11,NULL,105,13876,NULL,NULL,'Dipole + Quadrupole','CGCG 148-081',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51264,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51264,35.13,NULL,106,13876,NULL,NULL,NULL,'CGCG 148-081',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51265,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51265,35.14,NULL,107,13876,NULL,NULL,'Dipole','CGCG 148-081',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51266,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51266,35.19,0.2,109,13876,74.4,NULL,NULL,'CGCG 148-081',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51267,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51267,35.2,0.43,110,13876,75,NULL,'3.6 micron, color corrected','CGCG 148-081',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51268,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51268,35.21,0.44,110,13876,NULL,NULL,NULL,'CGCG 148-081',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51269,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51269,35.23,0.43,111,13876,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 148-081',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51270,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51270,37.44,0.46,308,13877,70,NULL,NULL,'2MASX J07594010+4551464',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000078,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,119.917,45.86283,0.149,NULL,63527612407,992618943,15509670,17.7),(51271,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51271,33.61,0.45,52.8,13878,NULL,NULL,'K','UGC 04145',NULL,'2007A&A...465...71T',2007,1,1.43,NULL,'G',0.000033,NULL,'13.9g',0.73,'Sa             Sy2','Group member, radial-velocity confirmed',NULL,NULL,'Sy 2',1,119.917167,15.38681,0.093,NULL,62678193236,979346769,15302293,13.9),(51272,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51272,33.62,0.47,52.9,13878,NULL,NULL,'H','UGC 04145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51273,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51273,33.71,0.46,55.1,13878,NULL,NULL,'J','UGC 04145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51274,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51274,34.17,0.4,68.4,13878,NULL,NULL,'mean','UGC 04145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51275,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51275,37.69,0.46,345,13879,70,NULL,NULL,'2MASX J07594084+1613162',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000149,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,119.9202083,16.22128,0.069,NULL,62678069307,979344832,15302263,17.3),(51276,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51276,37.93,0.46,385,13880,70,NULL,NULL,'2MASX J07594086+2735455',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,119.920417,27.59589,0.069,NULL,64304634149,1004759908,15699373,17.7),(51277,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51277,38.27,0.27,451,13881,70,NULL,NULL,'2MASX J07594274+2943105',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000159,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,119.928041667,29.71972,0.081,NULL,64302518163,1004726846,15698856,16.5),(51278,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51278,35.69,0.46,138,13882,70,NULL,NULL,'2MASX J07594346+4048279',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000077,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,119.9312083,40.80786,0.205,NULL,63555247362,993050740,15516417,16.2),(51279,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51279,37.96,0.46,391,13883,70,NULL,NULL,'2MASX J07594351+2933585',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,119.9312917,29.56619,0.085,NULL,64302712538,1004729883,15698904,17.3),(51280,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51280,38.29,0.46,456,13884,70,NULL,NULL,'2MASX J07594429+3940299',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000147,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,119.934458333,39.67489,0.245,NULL,63555235260,993050550,15516414,18.1),(51281,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51281,37.62,0.46,334,13885,70,NULL,NULL,'2MASX J07594434+3952109',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000161,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,119.934583,39.86972,0.181,NULL,63555220446,993050319,15516411,17.1),(51282,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51282,37.8,0.46,363,13886,70,NULL,NULL,'SDSS J075944.87+191811.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000159,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,119.937,19.30311,0.085,NULL,62624795107,978512423,15289256,18.4),(51283,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51283,37.08,0.46,260,13887,70,NULL,NULL,'2MASX J07594546+1826401',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000184,NULL,'16.5g',0.3,'AGN',NULL,NULL,NULL,NULL,1,119.939333333,18.44444,0.049,NULL,62624431495,978506742,15289167,16.5),(51284,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51284,36.59,0.46,208,13888,70,NULL,NULL,'2MASX J07594673+5246044',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000186,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,119.944833,52.768,0.073,NULL,63513626535,992400414,15506256,16.8),(51285,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51285,37.6,0.46,331,13889,70,NULL,NULL,'SDSS J075946.91+275755.4',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000167,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,119.9455,27.96542,0.065,NULL,64304708507,1004761070,15699391,16.8),(51286,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51286,37.2,0.46,275,13890,70,NULL,NULL,'2MASX J07594701+3531119',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000198,NULL,'16.2g',0.37,'AGN',NULL,NULL,NULL,NULL,1,119.945916667,35.51994,0.177,NULL,63444566763,991321355,15489396,16.2),(51287,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51287,38.11,0.27,418,13891,70,NULL,NULL,'2MASX J07594796+5006334',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,119.95,50.10931,0.141,NULL,63548958686,992952479,15514882,18.4),(51288,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51288,37.81,0.27,366,13892,70,NULL,NULL,'2MASX J07594892+3813422',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,119.953875,38.22842,0.225,NULL,63436135382,991189615,15487337,17.8),(51289,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51289,36.52,0.59,201,13893,70,NULL,NULL,'2MASX J07594897-0935538',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.4,NULL,NULL,NULL,NULL,NULL,1,119.954083333,-9.59831,0.449,NULL,39453836597,616466196,9632284,13.9),(51290,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51290,38.49,0.46,498,13894,70,NULL,NULL,'SDSS J075950.23+413505.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000054,NULL,'18.6g',0.12,'NLAGN',NULL,NULL,NULL,NULL,1,119.959333,41.58483,0.181,NULL,63567406197,993240721,15519386,18.6),(51291,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51291,37.83,0.46,369,13895,70,NULL,NULL,'SDSS J075950.40+103937.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000149,NULL,'18.1g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,119.9600417,10.66031,0.037,NULL,62758586795,980602918,15321920,18.1),(51292,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51292,36.83,0.46,232,13896,70,NULL,NULL,'2MASX J07595177+1907571',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000177,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,119.965667,19.13247,0.089,NULL,62624917936,978514342,15289286,16.7),(51293,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51293,37.81,0.27,366,13897,70,NULL,NULL,'2MASX J07595283+3813212',NULL,'2015arXiv151105856S',2015,1,0.43,'FIRST source may be a sidelobe of another radio source.','G',NULL,'FoF','16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,119.97,38.22264,0.225,NULL,63436135284,991189613,15487337,16.3),(51294,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51294,37.95,0.46,389,13898,70,NULL,NULL,'2MASX J07595314+1212322',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,119.971417,12.20892,0.073,NULL,62633575073,978649610,15291400,17.6),(51295,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51295,37,0.33,251,13899,70,NULL,NULL,'2MASX J07595324+4023272',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000147,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,119.9717083,40.39078,0.193,NULL,63554939823,993045934,15516342,18.4),(51296,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51296,37.3,0.46,289,13900,70,NULL,NULL,'2MASX J07595348+1100036',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,119.972875,11.00111,0.041,NULL,62755725257,980558207,15321221,17.3),(51297,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51297,35.65,0.45,135,13901,NULL,NULL,'K','CGCG 118-036',NULL,'2007A&A...465...71T',2007,1,1.03,NULL,'G',0.000097,NULL,'14.4g',0.51,'Sy2',NULL,NULL,NULL,NULL,1,119.972833333,23.39008,0.157,NULL,63756266415,996191662,15565494,14.4),(51298,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51298,35.67,0.4,136,13901,NULL,NULL,'mean','CGCG 118-036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51299,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51299,35.72,0.47,139,13901,NULL,NULL,'H','CGCG 118-036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51300,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51300,35.86,0.46,148,13901,NULL,NULL,'J','CGCG 118-036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51301,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51301,37.99,0.46,396,13902,70,NULL,NULL,'2MASX J07595390+3157559',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000207,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,119.97475,31.96561,0.161,NULL,64344831067,1005387985,15709187,16.5),(51302,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51302,38.01,0.17,400,13903,70,NULL,NULL,'2MASX J07595442+5401011',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000194,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,119.9767083,54.017,0.085,NULL,61577311481,962145491,15033523,17.3),(51303,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51303,38.01,0.17,400,13904,70,NULL,NULL,'2MASX J07595556+5358372',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000147,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,119.9812083,53.97697,0.085,NULL,61577189639,962143588,15033493,18.4),(51304,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51304,37.11,0.33,264,13905,70,NULL,NULL,'2MASX J07595551+3827492',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,119.981417,38.46364,0.229,NULL,63436710134,991198595,15487478,17.8),(51305,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51305,38.01,0.17,400,13906,70,NULL,NULL,'2MASX J07595679+5403032',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'18.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,119.986791667,54.05103,0.085,NULL,61577301888,962145342,15033520,18.5),(51306,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51306,38.11,0.27,418,13907,70,NULL,NULL,'2MASX J07595715+5004504',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,119.988125,50.08061,0.141,NULL,63548959416,992952490,15514882,18),(51307,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51307,37.11,0.33,264,13908,70,NULL,NULL,'2MASX J07595780+3834202',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,119.990875,38.57222,0.229,NULL,63436691398,991198303,15487473,17.1),(51308,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51308,37,0.33,251,13909,70,NULL,NULL,'2MASX J07595806+4024212',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,119.992083,40.40581,0.193,NULL,63554939476,993045929,15516342,17.5),(51309,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51309,38.01,0.46,400,13910,70,NULL,NULL,'2MASX J07595830+3446020',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000179,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,119.992917,34.76717,0.193,NULL,63444420946,991319077,15489360,18.3),(51310,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51310,37.01,0.46,252,13911,70,NULL,NULL,'2MASX J07595845+4932124',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,119.993375,49.53692,0.141,NULL,63537639335,992775614,15512118,17.1),(51311,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51311,37.3,0.46,288,13912,70,NULL,NULL,'2MASX J07595914+2027071',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000176,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,119.996583,20.45217,0.097,NULL,63760113711,996251776,15566434,17.7),(51312,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51312,37.8,0.33,363,13913,70,NULL,NULL,'2MASX J07595937+3913022',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,119.997333,39.21728,0.241,NULL,63555112398,993048631,15516384,18),(51313,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51313,38.11,0.27,418,13914,70,NULL,NULL,'2MASX J07595943+5005494',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000199,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,119.9977083,50.09697,0.141,NULL,63548960728,992952511,15514882,17),(51314,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51314,38.28,0.46,452,13915,70,NULL,NULL,'2MASX J08000004+2733265',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,120.000083,27.5575,0.069,NULL,64304633769,1004759902,15699373,17.5),(51315,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51315,36.4,0.46,191,13916,70,NULL,NULL,'2MASX J08000102+4035403',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,120.004125,40.59447,0.209,NULL,63554763966,993043186,15516299,17.2),(51316,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51316,36.22,0.46,176,13917,70,NULL,NULL,'2MASX J08000113+2844305',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000178,NULL,'16.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,120.004667,28.74175,0.073,NULL,64300092176,1004688940,15698264,16.7),(51317,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51317,37.47,0.46,312,13918,70,NULL,NULL,'2MASX J08000232+5136084',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000208,NULL,'16.0g',0.4,NULL,NULL,NULL,NULL,NULL,1,120.009417,51.60244,0.137,NULL,63512723145,992386299,15506035,16),(51318,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51318,36.9,0.46,240,13919,70,NULL,NULL,'2MASX J08000376+3859272',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000187,NULL,'16.2g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,120.0157917,38.99092,0.221,NULL,63436569899,991196404,15487443,16.2),(51319,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51319,36.63,0.46,212,13920,70,NULL,NULL,'2MASX J08000462+4004402',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000137,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,120.019375,40.07794,0.185,NULL,63554881353,993045021,15516328,17.2),(51320,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51320,38.7,0.46,549,13921,70,NULL,NULL,'SDSS J080005.15+323140.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000177,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,120.0215,32.52786,0.229,NULL,63443144136,991299127,15489048,18.5),(51321,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51321,35.06,0.46,103,13922,70,NULL,NULL,'2MASX J08000561+1344152',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000163,NULL,'15.6g',0.37,NULL,NULL,NULL,NULL,NULL,1,120.0235417,13.73761,0.057,NULL,62666762505,979168164,15299502,15.6),(51322,'IRAS','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51322,34.12,0.8,66.8,13923,75,NULL,'CF, r','UGC 04154',NULL,'1997ApJS..109..333W',1997,1,1.22,NULL,'G',0.000033,NULL,'14.8g',0.54,'Sd',NULL,NULL,NULL,NULL,1,120.0262083,13.15211,0.057,NULL,62663946820,979124169,15298815,14.8),(51323,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51323,33.87,0.2,59.4,13923,74.4,NULL,NULL,'UGC 04154',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51324,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51324,34,0.28,63.1,13923,NULL,NULL,NULL,'UGC 04154',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51325,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51325,34.08,0.27,65.5,13923,NULL,NULL,'Malmquist cor.','UGC 04154',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51326,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51326,34.19,0.38,68.8,13923,75,NULL,'CF, r, raw','UGC 04154',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51327,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51327,34.26,0.38,71.3,13923,75,NULL,'CF, r, inv','UGC 04154',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51328,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,NULL,51328,34.32,0.38,73.3,13923,75,NULL,'CF, r, cor','UGC 04154',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51329,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51329,37.85,0.27,372,13924,70,NULL,NULL,'2MASX J08000664+1749262',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,120.02775,17.82394,0.041,NULL,62670783660,979230994,15300484,16.7),(51330,'FP','2016-12-15 15:14:19','2016-12-16 11:19:24','1',NULL,'R',51330,36.68,0.46,217,13925,70,NULL,NULL,'2MASX J08000672+4816014',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00017,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,120.027917,48.26722,0.121,NULL,63539380574,992802821,15512544,16.8),(51331,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51331,37.72,0.46,350,13926,70,NULL,NULL,'2MASX J08000707+0610258',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,120.0295417,6.17375,0.049,NULL,62805966454,981343225,15333487,17.5),(51332,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51332,36.31,0.46,183,13927,70,NULL,NULL,'2MASX J08000795+2642245',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000144,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,120.033167,26.70678,0.049,NULL,64306240573,1004785008,15699765,16.9),(51333,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51333,35.49,0.55,125,13928,70,NULL,NULL,'ESO 209- G?010',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.21',0.4,'SA(r)0/a:',NULL,NULL,NULL,NULL,1,120.03525,-50.66075,0.897,NULL,42518857984,664357156,10380580,16.21),(51334,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 2006qo',NULL,51334,34.85,0.16,90.6,13929,74.2,NULL,'SALT 2','UGC 04133',0.030455,'2010ApJ...716..712A',2010,1,2.33,NULL,'G',0.00003,NULL,'16.0',0.22,'Sc','Pair member (points to parent)',NULL,NULL,NULL,1,120.035625,56.36561,0.105,NULL,61604306107,962567282,15040113,16),(51335,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 2006qo',NULL,51335,35.38,0.03,116,13929,72,NULL,'MLCS31','UGC 04133',0.030455,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51336,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 2006qo',NULL,51336,35.43,0.15,118,13929,73.8,NULL,'SALT 2 (SNANA)','UGC 04133',0.0295,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51337,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 2006qo',NULL,51337,35.45,0.16,119,13929,70,NULL,'SALT 2','UGC 04133',0.030455,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51338,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 2006qo',NULL,51338,35.41,0.09,121,13929,74.4,NULL,NULL,'UGC 04133',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51339,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 2006qo',NULL,51339,35.53,0.17,124,13929,65,NULL,'MLCS31','UGC 04133',0.030455,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51340,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 2006qo',NULL,51340,35.7,0.16,134,13929,65,NULL,'MLCS17','UGC 04133',0.030455,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51341,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 2006qo',NULL,51341,35.71,0.19,135,13929,65,NULL,'SALT2','UGC 04133',0.030455,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51342,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 2006qo',NULL,51342,35.75,0.17,137,13929,65,NULL,'SALT','UGC 04133',0.030455,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51343,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 2006qo',NULL,51343,36.61,0.03,204,13929,70,NULL,'SALT 2','UGC 04133',0.030455,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51344,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51344,35.06,0.49,103,13929,75,NULL,'IR','UGC 04133',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51345,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51345,37.64,0.46,337,13930,70,NULL,NULL,'2MASX J08000962+1624012',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000184,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,120.040166667,16.40022,0.057,NULL,62669735132,979214611,15300228,17.2),(51346,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51346,33.94,0.48,61.3,13931,70,NULL,NULL,'2MASX J08001030-0954062',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00009,NULL,'15.32',0.4,NULL,NULL,NULL,NULL,NULL,1,120.042917,-9.90175,0.421,NULL,39454122153,616470658,9632354,15.32),(51347,'IRAS','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51347,34.61,0.8,83.4,13932,75,NULL,'CF, r','UGC 04128',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000023,NULL,'13.82',1,'Scd:',NULL,NULL,NULL,NULL,1,120.053625,60.28853,0.129,NULL,61570023538,962031617,15031744,13.82),(51348,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51348,33.85,0.69,58.9,13932,100,NULL,'mid-IR','UGC 04128',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51349,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51349,34.17,0.38,68.1,13932,75,NULL,'CF, r, raw','UGC 04128',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51350,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51350,34.31,0.38,72.9,13932,75,NULL,'CF, r, inv','UGC 04128',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51351,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51351,34.42,0.2,76.6,13932,74.4,NULL,NULL,'UGC 04128',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51352,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51352,34.42,0.38,76.6,13932,75,NULL,'CF, r, cor','UGC 04128',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51353,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51353,34.48,0.45,78.9,13932,NULL,NULL,NULL,'UGC 04128',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51354,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51354,34.58,0.43,82.4,13932,NULL,NULL,'Malmquist cor.','UGC 04128',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51355,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51355,34.81,0.4,91.5,13932,NULL,NULL,'mean','UGC 04128',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51356,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51356,34.89,0.47,94.8,13932,NULL,NULL,'H','UGC 04128',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51357,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51357,34.95,0.46,97.9,13932,NULL,NULL,'J','UGC 04128',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51358,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51358,35,0.45,100,13932,NULL,NULL,'K','UGC 04128',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51359,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51359,36.59,0.46,208,13933,70,NULL,NULL,'2MASX J08001259+3424285',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000186,NULL,'15.9g',0.38,'E0',NULL,NULL,NULL,NULL,1,120.052625,34.40792,0.209,NULL,63446843114,991356923,15489951,15.9),(51360,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51360,36.58,0.46,207,13934,70,NULL,NULL,'SDSS J080014.85+520727.8',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000173,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,120.061916667,52.12442,0.121,NULL,63513786059,992402907,15506295,17.5),(51361,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51361,37.85,0.27,372,13935,70,NULL,NULL,'2MASX J08001528+1747079',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000149,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,120.0637917,17.78544,0.041,NULL,62671009633,979234525,15300539,17.4),(51362,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51362,37.23,0.46,279,13936,70,NULL,NULL,'2MASX J08001591+3045135',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000138,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,120.06625,30.75381,0.121,NULL,64299728289,1004683254,15698175,17.5),(51363,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51363,38.01,0.17,400,13937,70,NULL,NULL,'2MASX J08001702+5405041',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,120.071083333,54.08458,0.069,NULL,61577183476,962143491,15033492,17.8),(51364,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51364,37.1,0.23,263,13938,70,NULL,NULL,'2MASX J08001856+4611125',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000084,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,120.07725,46.18675,0.141,NULL,63527500284,992617191,15509643,16.5),(51365,'GRB','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51365,42.65,NULL,3380,13939,70,NULL,'Pseudo z = 1.92','GRB 020418',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,120.08,-48.65,NULL,NULL,42532115666,664564307,10383817,NULL),(51366,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51366,35.59,0.4,132,13940,NULL,NULL,'mean','IC 0485',NULL,'2007A&A...465...71T',2007,1,1.35,NULL,'G',0.000033,NULL,'15.1g',0.32,'Sa:            AGN','Group member',NULL,NULL,NULL,1,120.082375,26.70144,0.049,NULL,64306239324,1004784989,15699765,15.1),(51367,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51367,35.76,0.47,142,13940,NULL,NULL,'H','IC 0485',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51368,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51368,35.82,0.45,146,13940,NULL,NULL,'K','IC 0485',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51369,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51369,35.95,0.46,155,13941,70,NULL,NULL,'2MASX J08002005+2226351',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000177,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,120.0835417,22.44303,0.177,NULL,63768866143,996388533,15568570,16.6),(51370,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51370,37.78,0.46,359,13942,70,NULL,NULL,'SDSS J080020.52+170936.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000148,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,120.085541667,17.16006,0.045,NULL,62670420043,979225313,15300395,18.4),(51371,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51371,34.13,0.46,67,13943,70,NULL,NULL,'2MASX J08002096+1119098',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000077,NULL,'14.8g',0.55,NULL,NULL,NULL,NULL,NULL,1,120.087417,11.31944,0.045,NULL,62755777354,980559021,15321234,14.8),(51372,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51372,34.99,0.5,99.3,13944,NULL,NULL,'Malmquist cor.','IC 0486',NULL,'2009ApJS..182..474S',2009,1,1.11,NULL,'G',0.00003,NULL,'14.1g',0.73,'Sy1','Group member',NULL,NULL,'Sy 1',1,120.087417,26.61353,0.049,NULL,64306267061,1004785422,15699772,14.1),(51373,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51373,35.25,0.45,112,13944,NULL,NULL,NULL,'IC 0486',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51374,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51374,35.29,0.2,114,13944,74.4,NULL,NULL,'IC 0486',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51375,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51375,35.37,0.4,119,13944,NULL,NULL,'mean','IC 0486',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51376,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51376,35.42,0.45,121,13944,NULL,NULL,'K','IC 0486',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51377,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51377,35.42,0.47,121,13944,NULL,NULL,'H','IC 0486',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51378,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51378,35.54,0.46,128,13944,NULL,NULL,'J','IC 0486',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51379,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51379,37.05,0.46,257,13945,70,NULL,NULL,'2MASX J08002190+4632105',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000108,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,120.091417,46.53642,0.145,NULL,63535590617,992743603,15511618,16.4),(51380,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51380,38.15,0.16,427,13946,70,NULL,NULL,'2MASX J08002220+2707523',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000145,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,120.092583333,27.13125,0.077,NULL,64306164374,1004783818,15699747,17.4),(51381,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51381,36.25,0.46,178,13947,70,NULL,NULL,'2MASX J08002345+5457501',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000186,NULL,'15.8g',0.4,NULL,NULL,NULL,NULL,NULL,1,120.0975417,54.96394,0.101,NULL,61593878919,962404358,15037568,15.8),(51382,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51382,33.7,0.45,55,13948,NULL,NULL,'K','NGC 2493',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.00005,NULL,'12.9g',1.9,'SB0','in a pair',NULL,NULL,NULL,1,120.0984583,39.83042,0.181,NULL,63555195045,993049922,15516405,12.9),(51383,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51383,33.77,0.4,56.6,13948,NULL,NULL,'mean','NGC 2493',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51384,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51384,30.54,0.4,12.8,13949,75,NULL,'B','UGC 04148',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.00001,NULL,'16.0g',0.31,'Sc(f)',NULL,NULL,NULL,NULL,1,120.099333,42.19375,0.133,NULL,63566943097,993233485,15519273,16),(51385,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51385,31.15,NULL,17,13949,NULL,NULL,NULL,'UGC 04148',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51386,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51386,31.21,NULL,17.4,13949,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04148',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51387,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51387,31.22,NULL,17.5,13949,NULL,NULL,'Dipole + Quadrupole','UGC 04148',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51388,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51388,31.23,NULL,17.6,13949,NULL,NULL,'Dipole','UGC 04148',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51389,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51389,31.93,0.2,24.3,13949,74.4,NULL,NULL,'UGC 04148',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51390,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51390,32.18,0.43,27.3,13949,75,NULL,'3.6 micron, color corrected','UGC 04148',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51391,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51391,32.36,0.43,29.7,13949,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04148',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51392,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51392,37.43,0.46,307,13950,70,NULL,NULL,'2MASX J08002403+4812424',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,120.100125,48.21183,0.121,NULL,63539382415,992802850,15512544,17.7),(51393,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51393,37.05,0.33,257,13951,70,NULL,NULL,'2MASX J08002540+0946388',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,120.105875,9.77753,0.017,NULL,62803278200,981301221,15332831,16.9),(51394,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51394,37.99,0.46,396,13952,70,NULL,NULL,'2MASX J08002599+3930574',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,120.108125,39.51614,0.169,NULL,63555137950,993049030,15516391,17.5),(51395,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51395,37.85,0.27,372,13953,70,NULL,NULL,'2MASX J08002677+1752139',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,120.111667,17.8705,0.041,NULL,62670818580,979231540,15300492,17.5),(51396,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51396,38.07,0.46,412,13954,70,NULL,NULL,'2MASX J08002723+3041535',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000155,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,120.113583333,30.69808,0.117,NULL,64299714397,1004683037,15698172,17.4),(51397,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51397,37.59,0.27,330,13955,70,NULL,NULL,'2MASX J08002897+3708354',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00017,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,120.120666667,37.14325,0.237,NULL,63450420062,991412813,15490825,18),(51398,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51398,36.31,0.46,183,13956,70,NULL,NULL,'2MASX J08003199+4650594',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.0g',0.32,NULL,NULL,NULL,NULL,NULL,1,120.13325,46.84978,0.153,NULL,63539032668,992797385,15512459,16),(51399,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51399,37.45,0.46,309,13957,70,NULL,NULL,'2MASX J08003294+3734465',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,120.137291667,37.57981,0.221,NULL,63435972991,991187077,15487298,18.1),(51400,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51400,35.97,0.17,156,13958,70,NULL,NULL,'SBS 0756+553',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000035,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,120.139041667,55.21639,0.085,NULL,61595742514,962433476,15038023,17),(51401,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51401,38.03,0.46,404,13959,70,NULL,NULL,'2MASX J08003451+2804513',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000152,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,120.14375,28.08078,0.069,NULL,64304500112,1004757814,15699340,18.7),(51402,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51402,37.73,0.46,351,13960,70,NULL,NULL,'2MASX J08003648+3019455',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,120.1520417,30.3295,0.113,NULL,64299479679,1004679369,15698115,17.4),(51403,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51403,34.33,0.33,73.3,13961,70,NULL,NULL,'CGCG 088-016',NULL,'2015arXiv151105856S',2015,1,0.88,NULL,'G',0.0001,NULL,'14.6g',0.44,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,120.1529583,15.68419,0.093,NULL,62678571444,979352678,15302385,14.6),(51404,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51404,37.16,0.46,270,13962,70,NULL,NULL,'2MASX J08003733+1552099',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000199,NULL,'16.0g',0.39,NULL,NULL,NULL,NULL,NULL,1,120.155541667,15.86947,0.089,NULL,62678559883,979352498,15302382,16),(51405,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51405,34.39,0.33,75.6,13963,70,NULL,NULL,'CGCG 059-013',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000057,NULL,'14.3g',0.73,NULL,NULL,NULL,NULL,NULL,1,120.156333333,13.69733,0.057,NULL,62666732572,979167696,15299495,14.3),(51406,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51406,38.41,0.46,480,13964,70,NULL,NULL,'SDSS J080037.72+143143.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,120.157208333,14.52889,0.065,NULL,62664796351,979137442,15299022,18.5),(51407,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51407,37.63,0.46,336,13965,70,NULL,NULL,'SDSS J080038.35+082108.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,120.159833,8.35242,0.065,NULL,62808461915,981382217,15334097,17.8),(51408,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51408,37.06,0.46,258,13966,70,NULL,NULL,'2MASX J08003942+3211194',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000058,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,120.1642917,32.18881,0.213,NULL,64328092772,1005126449,15705100,17.5),(51409,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51409,37.05,0.33,257,13967,70,NULL,NULL,'2MASX J08003964+0947526',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',NULL,NULL,'16.69',0.5,NULL,NULL,NULL,NULL,NULL,1,120.165083,9.79811,0.017,NULL,62803259806,981300934,15332827,16.69),(51410,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51410,36.14,0.46,169,13968,70,NULL,NULL,'CGCG 148-089',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000186,NULL,'15.7g',0.46,'E0',NULL,NULL,NULL,NULL,1,120.1672917,28.4765,0.077,NULL,64300053746,1004688339,15698255,15.7),(51411,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51411,35.05,0.55,102,13969,70,NULL,NULL,'2MASX J08004096-7231207',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,120.170625,-72.5225,0.757,NULL,40632123622,634876931,9919952,17.1),(51412,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51412,37.59,0.27,330,13970,70,NULL,NULL,'2MASX J08004118+3710455',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000184,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,120.171667,37.17947,0.237,NULL,63448551511,991383617,15490369,17.3),(51413,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51413,36.92,0.33,242,13971,70,NULL,NULL,'2MASX J08004242+4001385',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000184,NULL,'15.8g',0.46,'E0',NULL,NULL,NULL,NULL,1,120.1767917,40.02731,0.185,NULL,63555036897,993047451,15516366,15.8),(51414,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51414,37.72,0.46,349,13972,70,NULL,NULL,'2MASX J08004321+4012055',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,120.18,40.20164,0.185,NULL,63554902699,993045354,15516333,16.9),(51415,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51415,37.8,0.46,363,13973,70,NULL,NULL,'2MASX J08004493+3948495',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000148,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,120.187333,39.81381,0.181,NULL,63555020129,993047189,15516362,18.6),(51416,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 1999Q',NULL,51416,42.56,0.27,2230,13974,65,NULL,NULL,'H-ZSNS J080045.31+053127.4',0.46,'2004ApJ...607..665R',2004,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,120.188791667,5.52428,0.041,NULL,62772762067,980824407,15325381,NULL),(51417,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 1999Q',NULL,51417,42.62,0.21,2290,13974,65,NULL,NULL,'H-ZSNS J080045.31+053127.4',0.46,'2006ApJ...642....1C',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51418,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 1999Q',NULL,51418,42.63,0.14,2300,13974,65,NULL,NULL,'H-ZSNS J080045.31+053127.4',0.46,'2006ApJ...642....1C',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51419,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51419,34.03,0.4,64,13975,NULL,NULL,'mean','UGC 04162',NULL,'2007A&A...465...71T',2007,1,1.14,NULL,'G',0.000033,NULL,'14.5g',0.38,'S?',NULL,NULL,NULL,NULL,1,120.1917917,16.54728,0.057,NULL,62669941896,979217842,15300278,14.5),(51420,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51420,34.03,0.47,64,13975,NULL,NULL,'H','UGC 04162',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51421,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51421,34.1,0.46,66.1,13975,NULL,NULL,'J','UGC 04162',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51422,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51422,34.13,0.45,67,13975,NULL,NULL,'K','UGC 04162',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51423,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51423,34.24,0.49,70.4,13975,75,NULL,'IR','UGC 04162',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51424,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51424,35.51,0.7,127,13976,70,NULL,NULL,'2MASX J08004653-7229087',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,120.1942083,-72.48575,0.757,NULL,40631865054,634872891,9919888,17.8),(51425,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51425,36.44,0.46,194,13977,70,NULL,NULL,'2MASX J08004772+3006260',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00019,NULL,'15.7g',0.4,'E0',NULL,NULL,NULL,NULL,1,120.198708333,30.10736,0.113,NULL,64302154122,1004721158,15698768,15.7),(51426,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51426,33.9,NULL,60.2,13978,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0699',NULL,'2010Ap&SS.325..163P',2010,1,0.97,NULL,'G',0.000053,NULL,'16.33',0.1,'Sd',NULL,NULL,NULL,NULL,1,120.2,8.63972,0.009,NULL,62809831677,981403619,15334431,16.33),(51427,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51427,33.93,NULL,61,13978,NULL,NULL,'Dipole','FGC 0699',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51428,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51428,33.93,NULL,61.1,13978,NULL,NULL,'Dipole + Quadrupole','FGC 0699',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51429,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51429,34,NULL,63,13978,NULL,NULL,NULL,'FGC 0699',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51430,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51430,34.12,0.43,66.7,13978,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0699',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51431,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51431,37.59,0.27,330,13979,70,NULL,NULL,'2MASX J08004930+3711555',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000174,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,120.20525,37.19881,0.237,NULL,63448555192,991383674,15490369,17.2),(51432,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51432,37.68,0.33,344,13980,70,NULL,NULL,'2MASX J08004950+4441285',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000105,NULL,'16.5g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,120.206333333,44.69117,0.097,NULL,63528657330,992635270,15509926,16.5),(51433,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51433,34.35,0.47,74,13981,NULL,NULL,'H','IC 2217',NULL,'2007A&A...465...71T',2007,1,0.6,NULL,'G',0.000033,NULL,'14.9',0.4,'S?',NULL,NULL,NULL,NULL,1,120.207208333,27.50031,0.069,NULL,64306619027,1004790922,15699858,14.9),(51434,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51434,34.39,0.4,75.5,13981,NULL,NULL,'mean','IC 2217',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51435,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51435,34.49,0.46,79.1,13981,NULL,NULL,'J','IC 2217',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51436,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51436,36.92,0.33,242,13982,70,NULL,NULL,'2MASX J08004965+4002495',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000176,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,120.207125,40.04714,0.185,NULL,63555038879,993047482,15516366,16.9),(51437,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51437,37.1,0.46,263,13983,70,NULL,NULL,'SDSS J080049.83+145432.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000122,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,120.207625,14.909,0.073,NULL,62664894500,979138976,15299046,18.3),(51438,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51438,37.68,0.33,344,13984,70,NULL,NULL,'2MASX J08005071+4445075',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000107,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,120.211417,44.75228,0.097,NULL,63530717696,992667464,15510429,16.7),(51439,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51439,37.96,0.21,391,13985,70,NULL,NULL,'2MASX J08005124+3440291',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,120.2135417,34.67492,0.193,NULL,63444760117,991324376,15489443,17.1),(51440,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51440,38.89,0.46,600,13986,70,NULL,NULL,'2MASX J08005216+1411413',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00018,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,120.2172917,14.19492,0.057,NULL,62666676523,979166820,15299481,18.1),(51441,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51441,35.39,NULL,120,13987,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0692',NULL,'2010Ap&SS.325..163P',2010,1,0.87,NULL,'G',NULL,NULL,'16.7',0.1,'Scd',NULL,NULL,NULL,NULL,1,120.22,66.44972,0.129,NULL,62166838358,971356849,15177450,16.7),(51442,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51442,35.41,NULL,121,13987,NULL,NULL,'Dipole + Quadrupole','FGC 0692',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51443,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51443,35.43,NULL,122,13987,NULL,NULL,'Dipole','FGC 0692',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51444,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51444,35.45,NULL,123,13987,NULL,NULL,NULL,'FGC 0692',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51445,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51445,37.44,0.46,308,13988,70,NULL,NULL,'2MASX J08005291+1120196',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000152,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,120.220625,11.33869,0.045,NULL,62801709908,981276717,15332448,16.8),(51446,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51446,36.85,0.46,235,13989,70,NULL,NULL,'2MASX J08005324+1028356',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.2g',0.21,'AGN',NULL,NULL,NULL,NULL,1,120.221791667,10.47647,0.029,NULL,62805042898,981328795,15333262,17.2),(51447,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51447,35.97,0.17,156,13990,70,NULL,NULL,'CGCG 262-056',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000117,NULL,'15.0g',0.64,NULL,NULL,NULL,NULL,NULL,1,120.221917,55.56311,0.077,NULL,61595837014,962434953,15038046,15),(51448,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51448,37.99,0.46,397,13991,70,NULL,NULL,'SDSS J080053.38+175841.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,120.2224583,17.97808,0.041,NULL,62667386520,979177914,15299654,18.3),(51449,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51449,37.38,0.46,299,13992,70,NULL,NULL,'2MASX J08005355+2002014',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000151,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,120.223,20.03367,0.097,NULL,63760018458,996250288,15566410,17.5),(51450,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51450,37.99,0.27,397,13993,70,NULL,NULL,'SDSS J080054.29+392435.3',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000187,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,120.2262083,39.40983,0.177,NULL,63554641191,993041268,15516269,17.7),(51451,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51451,38.03,0.46,404,13994,70,NULL,NULL,'2MASXi J0800548+493558',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,120.228458333,49.59972,0.129,NULL,63537563783,992774434,15512100,18),(51452,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51452,37.96,0.21,391,13995,70,NULL,NULL,'2MASX J08005644+3436401',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000146,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,120.235125,34.61125,0.209,NULL,63444752295,991324254,15489441,18.2),(51453,'SZ effect','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51453,39.4,0.47,760,13996,NULL,NULL,'Isotherm.','ABELL 0611',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'Compact [Zw]',NULL,NULL,NULL,NULL,1,120.245417,36.04722,0.189,NULL,63449172294,991393317,15490520,NULL),(51454,'SZ effect','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51454,39.46,0.46,780,13996,NULL,NULL,'Hydrost. Eq.','ABELL 0611',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51455,'SZ effect','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51455,39.6,0.53,830,13996,NULL,NULL,'Isotherm., r < 100 kpc','ABELL 0611',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51456,'SZ effect','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51456,39.65,NULL,852,13996,NULL,NULL,'3.1 (red) calibration','ABELL 0611',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51457,'SZ effect','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51457,39.66,NULL,857,13996,NULL,NULL,'4.2 (black) calibration','ABELL 0611',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51458,'SZ effect','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51458,39.85,NULL,934,13996,NULL,NULL,NULL,'ABELL 0611',NULL,'2005ApJ...625..108D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51459,'SZ effect','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51459,39.99,NULL,995,13996,NULL,NULL,NULL,'ABELL 0611',NULL,'2002ApJ...581...53R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51460,'SZ effect','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51460,40,NULL,999,13996,NULL,NULL,'4.1 (blue) calibration','ABELL 0611',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51461,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51461,35.97,0.17,156,13997,70,NULL,NULL,'SBS 0757+555',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000089,NULL,'15.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,120.24375,55.40917,0.077,NULL,61595824402,962434756,15038043,15.9),(51462,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51462,38.59,0.23,523,13998,70,NULL,NULL,'2MASX J08010135+1349523',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000176,NULL,'16.6g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,120.255625,13.83117,0.057,NULL,62666792323,979168630,15299509,16.6),(51463,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51463,36.02,NULL,160,13999,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04146',NULL,'2010Ap&SS.325..163P',2010,1,1.36,NULL,'G',0.00005,NULL,'16.0',0.1,'Scd',NULL,NULL,NULL,NULL,1,120.258625,59.13969,0.113,NULL,61569114608,962017415,15031522,16),(51464,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51464,36.04,NULL,161,13999,NULL,NULL,'Dipole + Quadrupole','UGC 04146',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51465,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51465,36.05,NULL,162,13999,NULL,NULL,NULL,'UGC 04146',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51466,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51466,36.05,NULL,163,13999,NULL,NULL,'Dipole','UGC 04146',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51467,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51467,36.26,0.48,178,13999,NULL,NULL,'Malmquist cor.','UGC 04146',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51468,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51468,36.68,0.4,217,13999,NULL,NULL,NULL,'UGC 04146',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51469,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51469,36.72,0.2,221,13999,74.4,NULL,NULL,'UGC 04146',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51470,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51470,36.26,0.46,178,14000,70,NULL,NULL,'2MASX J08010373+2304334',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,120.2655417,23.07603,0.185,NULL,63767368600,996365134,15568205,17.4),(51471,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51471,38.59,0.23,523,14001,70,NULL,NULL,'2MASX J08010375+1350393',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,120.2657083,13.84411,0.057,NULL,62666792303,979168629,15299509,17.3),(51472,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51472,36.46,0.33,196,14002,70,NULL,NULL,'2MASX J08010395+1627153',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,120.266417,16.45428,0.057,NULL,62669921972,979217530,15300273,17.1),(51473,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51473,38.59,0.23,523,14003,70,NULL,NULL,'SDSS J080103.97+135153.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000176,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,120.266583,13.86481,0.057,NULL,62666789851,979168591,15299509,18.5),(51474,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51474,37.99,0.27,397,14004,70,NULL,NULL,'2MASX J08010438+3924243',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000174,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,120.268125,39.40678,0.177,NULL,63554640726,993041261,15516269,17.4),(51475,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51475,37.82,0.46,366,14005,70,NULL,NULL,'SDSS J080104.97+464342.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000068,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,120.2707083,46.72844,0.141,NULL,63538997438,992796834,15512450,18.5),(51476,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51476,38.13,0.46,423,14006,70,NULL,NULL,'2MASX J08010520+2607021',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000144,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,120.2717083,26.11714,0.057,NULL,64305755531,1004777430,15699647,17.5),(51477,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51477,37.17,0.46,271,14007,70,NULL,NULL,'2MASX J08010531+1127522',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000172,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,120.2720417,11.46439,0.025,NULL,62801393956,981271780,15332371,17),(51478,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51478,37.52,0.46,320,14008,70,NULL,NULL,'2MASX J08010746+4330235',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000091,NULL,'16.5g',0.35,'NLAGN',NULL,NULL,NULL,NULL,1,120.281167,43.5065,0.121,NULL,63558491478,993101429,15517209,16.5),(51479,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51479,38.01,0.17,400,14009,70,NULL,NULL,'2MASX J08010778+5359449',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000151,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,120.282541667,53.99597,0.085,NULL,61577191847,962143622,15033494,17.6),(51480,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51480,36.6,0.6,209,14010,70,NULL,NULL,'2MASX J08010797-0534380',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.000127,NULL,'16.17',0.2,NULL,NULL,NULL,NULL,NULL,1,120.283333,-5.57736,0.329,NULL,39431007295,616109488,9626710,16.17),(51481,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51481,38.03,0.46,404,14011,70,NULL,NULL,'2MASX J08010945+3014111',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000138,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,120.289417,30.23647,0.113,NULL,64299351630,1004677369,15698083,17.4),(51482,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51482,36.29,0.46,182,14012,70,NULL,NULL,'2MASX J08011093+3024471',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000187,NULL,'15.7g',0.45,'E0',NULL,NULL,NULL,NULL,1,120.2955417,30.41292,0.113,NULL,64299373134,1004677705,15698089,15.7),(51483,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51483,37.77,0.46,358,14013,70,NULL,NULL,'2MASX J08011236+2957221',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000181,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,120.301667,29.95614,0.113,NULL,64302624415,1004728506,15698882,17.2),(51484,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51484,37.96,0.21,391,14014,70,NULL,NULL,'2MASX J08011329+3440311',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000183,NULL,'16.8g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,120.305333,34.67525,0.193,NULL,63444803168,991325049,15489453,16.8),(51485,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51485,37.41,0.46,303,14015,70,NULL,NULL,'SDSS J080115.96+465722.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00006,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,120.3165,46.95628,0.153,NULL,63539008271,992797004,15512453,18.5),(51486,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51486,37.2,0.46,275,14016,70,NULL,NULL,'2MASX J08011594+1101563',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000143,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,120.3165417,11.03236,0.041,NULL,62801777357,981277771,15332465,17.3),(51487,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51487,37.96,0.21,391,14017,70,NULL,NULL,'2MASX J08011746+3441078',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000143,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,120.322791667,34.68542,0.193,NULL,63444803237,991325050,15489453,18.7),(51488,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51488,37.6,0.46,331,14018,70,NULL,NULL,'2MASX J08011812+2841562',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,120.3255,28.69914,0.073,NULL,64301870288,1004716723,15698698,18),(51489,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51489,36.79,0.46,228,14019,70,NULL,NULL,'2MASX J08011864+0935503',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,120.327625,9.59736,0,NULL,62803405885,981303216,15332862,16.3),(51490,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51490,36.82,0.46,231,14020,70,NULL,NULL,'2MASX J08011883+2059592',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,120.328417,20.99972,0.093,NULL,63760602162,996259408,15566553,16.8),(51491,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51491,35.84,0.46,147,14021,70,NULL,NULL,'CGCG 148-095',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000137,NULL,'15.3g',0.53,'E/S0',NULL,NULL,NULL,NULL,1,120.331416667,29.17936,0.117,NULL,64302023612,1004719118,15698736,15.3),(51492,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51492,37.65,0.46,340,14022,70,NULL,NULL,'2MASX J08011977+5354135',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000176,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,120.3322083,53.90372,0.085,NULL,61577179734,962143433,15033491,17.3),(51493,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51493,35.98,0.51,157,14023,70,NULL,NULL,'2MASX J08012039-0903507',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.09',NULL,NULL,NULL,NULL,NULL,NULL,1,120.335125,-9.06439,0.417,NULL,39455893926,616498342,9632786,16.09),(51494,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51494,36.33,0.46,184,14024,70,NULL,NULL,'CGCG 118-046',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000172,NULL,'15.9g',0.38,'E0','Group member',NULL,NULL,NULL,1,120.3392917,26.26811,0.057,NULL,64305718311,1004776848,15699638,15.9),(51495,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51495,37.26,0.46,283,14025,70,NULL,NULL,'2MASX J08012200+2351052',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000142,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,120.341667,23.85142,0.141,NULL,63756435192,996194299,15565535,17.9),(51496,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51496,36.65,0.33,214,14026,70,NULL,NULL,'2MASX J08012202+2712052',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000149,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,120.341833333,27.20156,0.073,NULL,64306933852,1004795841,15699935,17.2),(51497,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51497,37.13,0.46,267,14027,70,NULL,NULL,'2MASX J08012238+2610342',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000174,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,120.34325,26.17617,0.057,NULL,64305720784,1004776887,15699638,16.3),(51498,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51498,34.33,0.33,73.3,14028,70,NULL,NULL,'UGC 04170',NULL,'2015arXiv151105856S',2015,1,1.22,NULL,'G',0.000117,NULL,'13.8g',0.8,'E:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,120.346375,15.36925,0.069,NULL,62677763780,979340059,15302188,13.8),(51499,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51499,37.57,0.46,327,14029,70,NULL,NULL,'SDSS J080125.93+335144.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000143,NULL,'18.5g',0.09,NULL,NULL,NULL,NULL,NULL,1,120.358083,33.86244,0.225,NULL,63443330618,991302040,15489094,18.5),(51500,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51500,37.91,0.46,382,14030,70,NULL,NULL,'2MASX J08012615+3942183',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000172,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,120.359208333,39.70517,0.169,NULL,63554538626,993039666,15516244,17.1),(51501,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51501,37.99,0.27,397,14031,70,NULL,NULL,'2MASX J08012648+3929043',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,120.360417,39.48456,0.177,NULL,63554629571,993041087,15516266,17.5),(51502,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51502,36.06,0.68,163,14032,70,NULL,NULL,'2MASX J08012652-0748047',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,120.3605,-7.80125,0.465,NULL,39448826821,616387919,9631061,15.5),(51503,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51503,37.22,0.46,279,14033,70,NULL,NULL,'2MASX J08012699+2548052',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000197,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,120.3622917,25.8015,0.049,NULL,64305624573,1004775383,15699615,16.4),(51504,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51504,37.96,0.21,391,14034,70,NULL,NULL,'2MASX J08012744+3440430',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,120.364416667,34.67869,0.193,NULL,63444801876,991325029,15489453,18),(51505,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51505,37.44,0.46,308,14035,70,NULL,NULL,'2MASX J08012994+4043323',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,120.3747083,40.72567,0.209,NULL,63555486768,993054480,15516476,18),(51506,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51506,34,0.47,63.2,14036,NULL,NULL,'H','UGC 04171',NULL,'2007A&A...465...71T',2007,1,2.8,NULL,'G',0.000033,NULL,'14.40',0.36,'Sbc','Group member',NULL,NULL,NULL,1,120.3782083,9.70764,0.061,NULL,62803386581,981302915,15332858,14.4),(51507,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51507,34.01,0.49,63.5,14036,75,NULL,'IR','UGC 04171',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51508,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51508,34.04,0.46,64.4,14036,NULL,NULL,'J','UGC 04171',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51509,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51509,34.08,0.45,65.3,14036,NULL,NULL,'K','UGC 04171',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51510,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51510,34.16,0.31,67.9,14036,NULL,NULL,'Malmquist cor.','UGC 04171',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51511,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51511,34.25,NULL,70.8,14036,NULL,NULL,'Dipole','UGC 04171',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51512,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51512,34.25,NULL,70.8,14036,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04171',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51513,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51513,34.26,NULL,71,14036,NULL,NULL,'Dipole + Quadrupole','UGC 04171',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51514,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51514,34.31,0.4,72.6,14036,NULL,NULL,'mean','UGC 04171',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51515,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51515,34.31,0.29,72.7,14036,NULL,NULL,NULL,'UGC 04171',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51516,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51516,34.34,NULL,73.7,14036,NULL,NULL,NULL,'UGC 04171',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51517,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51517,34.35,0.2,74.1,14036,74.4,NULL,NULL,'UGC 04171',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51518,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51518,37.64,0.33,337,14037,70,NULL,NULL,'2MASX J08013097+2932342',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000181,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,120.379167,29.54292,0.117,NULL,64302836613,1004731822,15698934,16.4),(51519,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51519,35.96,0.46,156,14038,70,NULL,NULL,'2MASX J08013231+4200084',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000126,NULL,'15.0g',0.63,'E0',NULL,NULL,NULL,NULL,1,120.384625,42.00231,0.121,NULL,63553212016,993018937,15515920,15),(51520,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51520,38.59,0.23,523,14039,70,NULL,NULL,'2MASX J08013424+1351025',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,120.39275,13.85083,0.057,NULL,62666635120,979166173,15299471,18),(51521,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51521,36.87,0.46,237,14040,70,NULL,NULL,'2MASX J08013452+5457451',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000185,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,120.394167,54.96253,0.101,NULL,61593888883,962404513,15037570,16.8),(51522,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51522,36.62,0.46,211,14041,70,NULL,NULL,'2MASX J08013534+5216256',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000179,NULL,'16.0g',0.37,NULL,NULL,NULL,NULL,NULL,1,120.397167,52.27381,0.121,NULL,63513581187,992399706,15506245,16),(51523,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51523,38.22,0.46,441,14042,70,NULL,NULL,'SDSS J080136.00+144449.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000153,NULL,'18.7g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,120.4000417,14.74719,0.065,NULL,62664949414,979139834,15299059,18.7),(51524,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51524,37.8,0.33,363,14043,70,NULL,NULL,'2MASX J08013636+3916173',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000145,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,120.4014583,39.27147,0.177,NULL,63554612345,993040817,15516262,17.6),(51525,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51525,38.28,0.46,454,14044,70,NULL,NULL,'2MASX J08013684+2654212',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,120.4035417,26.90589,0.061,NULL,64306184533,1004784133,15699752,18),(51526,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51526,36.24,0.46,177,14045,70,NULL,NULL,'2MASX J08013695+1853062',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000214,NULL,'15.5g',0.42,NULL,NULL,NULL,NULL,NULL,1,120.4040417,18.88517,0.053,NULL,62621801905,978465654,15288525,15.5),(51527,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51527,37.64,0.33,337,14046,70,NULL,NULL,'SDSS J080137.15+292659.5',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,120.4047917,29.44986,0.117,NULL,64302814086,1004731470,15698929,17.9),(51528,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51528,36.65,0.33,214,14047,70,NULL,NULL,'2MASX J08013747+2721332',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000176,NULL,'15.9g',0.34,'S0/a',NULL,NULL,NULL,NULL,1,120.406166667,27.35931,0.073,NULL,64306635738,1004791183,15699862,15.9),(51529,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51529,38.37,0.46,472,14048,70,NULL,NULL,'SDSS J080137.96+382855.8',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,120.4082083,38.48219,0.185,NULL,63436553302,991196145,15487439,18.1),(51530,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51530,34.69,0.49,86.8,14049,75,NULL,'IR','CGCG 059-017',NULL,'2011yCatp016004901K',2011,1,1.06,NULL,'G',0.000028,NULL,'14.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,120.4145,10.73272,0.037,NULL,62801676381,981276193,15332440,14.9),(51531,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51531,38.26,0.46,449,14050,70,NULL,NULL,'2MASX J08014193+3902251',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,120.42475,39.04028,0.181,NULL,63436345334,991192895,15487388,18.3),(51532,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51532,37.76,0.46,356,14051,70,NULL,NULL,'2MASX J08014267+0716414',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,120.427875,7.27814,0.085,NULL,62808739260,981386550,15334164,17.3),(51533,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51533,36.74,0.46,222,14052,70,NULL,NULL,'2MASX J08014374+1448532',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000146,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,120.432083,14.81481,0.065,NULL,62664933638,979139588,15299056,16.8),(51534,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51534,36.44,0.46,194,14053,70,NULL,NULL,'2MASX J08014473+3150181',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,120.436417,31.83836,0.189,NULL,64345036237,1005391191,15709237,16.6),(51535,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51535,38.2,0.46,437,14054,70,NULL,NULL,'2MASX J08014511+4419505',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,120.4379583,44.33075,0.133,NULL,63528781059,992637204,15509956,17.7),(51536,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51536,37.46,0.46,310,14055,70,NULL,NULL,'2MASX J08014591+4039311',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00016,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,120.441167,40.65856,0.209,NULL,63555490546,993054539,15516477,17.1),(51537,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51537,38.55,0.46,513,14056,70,NULL,NULL,'SDSS J080151.79+225911.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,120.4657917,22.98661,0.185,NULL,63767341929,996364717,15568198,18.3),(51538,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51538,30.01,0.4,10.1,14057,75,NULL,'B','NGC 2500',NULL,'1988NBGC.C....0000T',1988,1,2.9,NULL,'G',0.000003,NULL,'12.20',2.6,'SB(rs)d        HII','Isolated galaxy',NULL,NULL,NULL,1,120.4717083,50.73711,0.129,NULL,63544928868,992889513,15513898,12.2),(51539,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51539,38.21,0.46,438,14058,70,NULL,NULL,'2MASX J08015534+2647079',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,120.480625,26.78539,0.049,NULL,64306105416,1004782897,15699732,17.7),(51540,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51540,36.39,0.33,189,14059,70,NULL,NULL,'2MASX J08015573+2916109',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000169,NULL,'16.2g',0.37,'E0',NULL,NULL,NULL,NULL,1,120.482333,29.26978,0.117,NULL,64302791646,1004731119,15698923,16.2),(51541,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51541,38.12,0.46,420,14060,70,NULL,NULL,'2MASXi J0801570+305730',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,120.4875417,30.95881,0.153,NULL,64299543717,1004680370,15698130,18),(51542,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51542,34.4,0.33,75.7,14061,70,NULL,NULL,'NGC 2508',NULL,'2015arXiv151105856S',2015,1,1.31,NULL,'G',0.00008,NULL,'13.2g',1.1,'S0^0^ pec',NULL,NULL,NULL,NULL,1,120.488417,8.55189,0,NULL,62810672654,981416760,15334636,13.2),(51543,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51543,37.46,0.46,310,14062,70,NULL,NULL,'2MASX J08015729+2726209',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000184,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,120.4887083,27.43928,0.073,NULL,64306642246,1004791285,15699863,16.5),(51544,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51544,37.92,0.46,385,14063,70,NULL,NULL,'2MASX J08015736+3956011',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,120.489,39.93372,0.181,NULL,63554524906,993039451,15516241,17.8),(51545,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51545,37.24,0.46,280,14064,70,NULL,NULL,'2MASX J08015811+3109389',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.00019,NULL,'16.1g',0.39,'E0',NULL,NULL,NULL,NULL,1,120.492125,31.16078,0.177,NULL,64298814516,1004668976,15697952,16.1),(51546,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51546,36.9,0.33,240,14065,70,NULL,NULL,'2MASX J08015835+4829234',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00019,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,120.493333,48.48997,0.085,NULL,63538099011,992782797,15512231,16.3),(51547,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51547,35.97,0.17,156,14066,70,NULL,NULL,'2MASX J08015906+5537178',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000176,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,120.496,55.62175,0.105,NULL,61595782658,962434104,15038032,16.4),(51548,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51548,37.91,0.46,382,14067,70,NULL,NULL,'2MASX J08020322+4945284',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,120.513333,49.75797,0.117,NULL,63549198346,992956224,15514941,17.7),(51549,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51549,35.97,0.17,156,14068,70,NULL,NULL,'2MASX J08020399+5551028',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000202,NULL,'16.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,120.5164583,55.85086,0.105,NULL,61596158699,962439979,15038124,16.1),(51550,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51550,36.69,0.46,218,14069,70,NULL,NULL,'2MASX J08020592+0625149',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,120.524708333,6.42089,0.037,NULL,62809199049,981393735,15334277,17.2),(51551,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51551,35.6,0.46,132,14070,70,NULL,NULL,'2MASX J08020738+1623263',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000168,NULL,'15.7g',0.45,NULL,NULL,NULL,NULL,NULL,1,120.530875,16.39064,0.069,NULL,62670002011,979218781,15300293,15.7),(51552,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51552,37.27,0.46,285,14071,70,NULL,NULL,'2MASX J08020969+4457068',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000081,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,120.540166667,44.95181,0.129,NULL,63530936475,992670882,15510482,17.7),(51553,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51553,37.77,0.46,358,14072,70,NULL,NULL,'2MASX J08021009+2852469',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,120.542208333,28.87972,0.105,NULL,64302068229,1004719816,15698747,18.3),(51554,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51554,37.67,0.46,342,14073,70,NULL,NULL,'2MASX J08021106+2513279',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,120.5460417,25.22453,0.057,NULL,64291460048,1004554063,15696157,17.9),(51555,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51555,38,0.46,398,14074,70,NULL,NULL,'2MASX J08021131+2633309',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000129,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,120.547333333,26.55853,0.061,NULL,64306148246,1004783566,15699743,17.7),(51556,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51556,36.89,0.46,238,14075,70,NULL,NULL,'2MASX J08021135+5144060',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000162,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,120.547375,51.73486,0.137,NULL,63512559469,992383741,15505995,16.8),(51557,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51557,37.73,0.33,352,14076,70,NULL,NULL,'2MASX J08021199+2851369',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000155,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,120.5500417,28.86022,0.105,NULL,64302071242,1004719863,15698747,18.5),(51558,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51558,37.37,0.46,298,14077,70,NULL,NULL,'2MASX J08021232+2004329',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,120.5512917,20.07583,0.069,NULL,63759991329,996249864,15566404,16.5),(51559,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51559,37.73,0.33,352,14078,70,NULL,NULL,'2MASX J08021283+2852239',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000186,NULL,'16.8g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,120.553417,28.87325,0.105,NULL,64302071079,1004719860,15698747,16.8),(51560,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51560,36.14,0.46,169,14079,70,NULL,NULL,'2MASX J08021582+1824081',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000196,NULL,'15.4g',0.44,NULL,NULL,NULL,NULL,NULL,1,120.565833,18.40231,0.041,NULL,62621576151,978462127,15288470,15.4),(51561,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51561,38.02,0.46,402,14080,70,NULL,NULL,'2MASX J08021776+4939250',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,120.573791667,49.657,0.129,NULL,63549066090,992954157,15514908,17.6),(51562,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51562,36.46,0.33,196,14081,70,NULL,NULL,'2MASX J08021942+1628225',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000087,NULL,'15.6g',0.44,NULL,NULL,NULL,NULL,NULL,1,120.5809583,16.473,0.057,NULL,62670036191,979219315,15300301,15.6),(51563,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51563,34.78,0.52,90.3,14082,NULL,NULL,'Malmquist cor.','UGC 04183',NULL,'2009ApJS..182..474S',2009,1,1.7,NULL,'G',0.000033,NULL,'14.00',1.1,'SB(r)ab',NULL,NULL,NULL,NULL,1,120.5897917,6.87856,0.117,NULL,62809517471,981398710,15334354,14),(51564,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51564,34.98,0.47,98.9,14082,NULL,NULL,NULL,'UGC 04183',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51565,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51565,35.02,0.2,101,14082,74.4,NULL,NULL,'UGC 04183',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51566,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51566,35.75,0.4,141,14082,NULL,NULL,'mean','UGC 04183',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51567,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51567,35.8,0.47,144,14082,NULL,NULL,'H','UGC 04183',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51568,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51568,35.83,0.45,147,14082,NULL,NULL,'K','UGC 04183',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51569,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51569,35.9,0.46,151,14082,NULL,NULL,'J','UGC 04183',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51570,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51570,35.03,0.46,101,14083,70,NULL,NULL,'CGCG 148-099',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.00008,NULL,'15.4g',0.4,'E0',NULL,NULL,NULL,NULL,1,120.5985417,31.18775,0.177,NULL,64344887277,1005388863,15709200,15.4),(51571,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51571,38.49,0.46,498,14084,70,NULL,NULL,'SDSS J080223.80+465848.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000082,NULL,'18.9g',0.1,NULL,NULL,NULL,NULL,NULL,1,120.599167,46.98006,0.153,NULL,63536923632,992764431,15511944,18.9),(51572,'D-Sigma','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51572,33.53,0.4,50.8,14085,75,NULL,'Edat, raw','NGC 2513',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000031,NULL,'12.7g',1.3,'E3','Group member',NULL,NULL,NULL,1,120.6027917,9.41356,0.101,NULL,62802801684,981293776,15332715,12.7),(51573,'D-Sigma','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51573,33.87,0.4,59.3,14085,75,NULL,'Edat, cor','NGC 2513',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51574,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51574,34.16,0.45,67.9,14085,NULL,NULL,'K','NGC 2513',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51575,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51575,34.25,0.4,70.7,14085,NULL,NULL,'mean','NGC 2513',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51576,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51576,35.97,0.17,156,14086,70,NULL,NULL,'2MASX J08022549+5527045',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000157,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,120.606291667,55.45133,0.121,NULL,61596951827,962452372,15038318,16.6),(51577,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51577,37.65,0.46,338,14087,70,NULL,NULL,'SDSS J080226.58+480104.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000061,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,120.610833,48.01797,0.109,NULL,63538675686,992791807,15512371,18.2),(51578,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51578,37.87,0.46,375,14088,70,NULL,NULL,'2MASX J08022698+2934379',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,120.612375,29.57733,0.117,NULL,64302774164,1004730846,15698919,17.7),(51579,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51579,38.27,0.46,451,14089,70,NULL,NULL,'2MASX J08022737+2822319',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,120.614167,28.37561,0.105,NULL,64301317270,1004708082,15698563,17.9),(51580,'IRAS','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51580,35.22,0.8,111,14090,75,NULL,'MAT, I','ESO 059- G 024',NULL,'1997ApJS..109..333W',1997,1,1.4,'1992MNRAS.255..581S gives V = 13733 +- 81 km/sec.','G',0.000033,NULL,'15.42',0.3,'(R\')SB(s)a',NULL,NULL,NULL,NULL,1,120.6150417,-72.42492,0.757,NULL,40632132445,634877069,9919954,15.42),(51581,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51581,34.53,0.39,80.6,14090,NULL,NULL,'Malmquist cor.','ESO 059- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51582,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51582,34.63,0.43,84.4,14090,75,NULL,'MAT, I, raw','ESO 059- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51583,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51583,34.65,0.32,85.3,14090,85,NULL,'I, raw','ESO 059- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51584,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51584,34.71,0.36,87.7,14090,NULL,NULL,NULL,'ESO 059- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51585,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51585,34.72,0.32,87.8,14090,85,NULL,'I, inv','ESO 059- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51586,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51586,34.75,0.2,89.1,14090,74.4,NULL,NULL,'ESO 059- G 024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51587,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51587,34.89,0.43,94.9,14090,75,NULL,'MAT, I, cor','ESO 059- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51588,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51588,34.9,0.43,95.6,14090,75,NULL,'MAT, I, inv','ESO 059- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51589,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51589,35.31,0.47,115,14090,NULL,NULL,'H','ESO 059- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51590,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51590,35.41,0.45,121,14090,NULL,NULL,'K','ESO 059- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51591,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51591,35.44,0.4,123,14090,NULL,NULL,'mean','ESO 059- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51592,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51592,35.57,0.46,130,14090,NULL,NULL,'J','ESO 059- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51593,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51593,36.45,0.54,195,14091,70,NULL,NULL,'2MASX J08022990-0925124',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,120.624667,-9.42008,0.385,NULL,39454454937,616475858,9632435,15.3),(51594,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51594,37.88,0.46,376,14092,70,NULL,NULL,'2MASX J08023114+3621347',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000171,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,120.629875,36.35967,0.217,NULL,63449246983,991394484,15490538,17.3),(51595,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51595,37.99,0.46,397,14093,70,NULL,NULL,'2MASX J08023117+5028510',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000147,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,120.629875,50.48072,0.125,NULL,63544840978,992888140,15513877,17.6),(51596,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51596,36.39,0.33,189,14094,70,NULL,NULL,'2MASX J08023289+2910320',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00019,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,120.637125,29.17561,0.113,NULL,64301952682,1004718010,15698718,16.4),(51597,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51597,32.41,0.2,30.3,14095,74.4,NULL,NULL,'UGC 04169',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000007,NULL,'13.63',0.7,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,120.637167,61.38819,0.169,NULL,61558641600,961853775,15028965,13.63),(51598,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51598,32.46,0.43,31.1,14095,75,NULL,'3.6 micron, color corrected','UGC 04169',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51599,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51599,32.46,0.43,31.1,14095,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04169',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51600,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51600,32.53,0.54,32,14095,NULL,NULL,NULL,'UGC 04169',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51601,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51601,32.53,0.54,32,14095,NULL,NULL,'Malmquist cor.','UGC 04169',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51602,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51602,32.65,0.4,33.9,14095,NULL,NULL,NULL,'UGC 04169',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51603,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51603,37.02,0.46,254,14096,70,NULL,NULL,'2MASX J08023579+5055210',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000172,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,120.649041667,50.92247,0.113,NULL,63545665394,992901021,15514078,16.5),(51604,'IRAS','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51604,34.33,0.8,73.3,14097,75,NULL,'CF, r','IC 2219',NULL,'1997ApJS..109..333W',1997,1,1.42,NULL,'G',0.000006,NULL,'14.1g',0.62,'Sc',NULL,NULL,NULL,NULL,1,120.6522083,27.4375,0.073,NULL,64306745136,1004792892,15699888,14.1),(51605,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51605,33.61,0.69,52.7,14097,100,NULL,'mid-IR','IC 2219',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51606,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51606,34.08,0.38,65.4,14097,75,NULL,'CF, r, raw','IC 2219',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51607,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51607,34.1,0.43,66.1,14097,75,NULL,'3.6 micron, color + selection bias corrected','IC 2219',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51608,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51608,34.13,0.43,66.9,14097,75,NULL,'3.6 micron, color corrected','IC 2219',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51609,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51609,34.2,0.38,69.3,14097,75,NULL,'CF, r, inv','IC 2219',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51610,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51610,34.23,0.2,70.2,14097,74.4,NULL,NULL,'IC 2219',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51611,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51611,34.28,0.38,71.7,14097,75,NULL,'CF, r, cor','IC 2219',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51612,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51612,34.34,0.47,73.9,14097,NULL,NULL,'H','IC 2219',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51613,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51613,34.43,0.4,76.8,14097,NULL,NULL,'mean','IC 2219',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51614,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51614,34.43,0.46,76.9,14097,NULL,NULL,'J','IC 2219',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51615,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51615,34.45,0.07,77.8,14097,NULL,NULL,NULL,'IC 2219',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51616,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51616,34.47,0.45,78.4,14097,NULL,NULL,'K','IC 2219',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51617,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51617,37.94,0.46,387,14098,70,NULL,NULL,'2MASX J08023728+1012181',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,120.655417,10.20519,0.057,NULL,62805067967,981329186,15333268,17.4),(51618,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51618,37.53,0.46,321,14099,70,NULL,NULL,'2MASX J08023726+1833280',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000143,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,120.655458333,18.55769,0.041,NULL,62621852456,978466444,15288538,17.7),(51619,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51619,36.9,0.33,240,14100,70,NULL,NULL,'2MASX J08023759+4847009',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000175,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,120.6567083,48.78367,0.109,NULL,63538191954,992784249,15512253,17),(51620,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51620,34.4,0.33,75.7,14101,70,NULL,NULL,'CGCG 059-027',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000057,NULL,'15.2',0.36,NULL,'Group member',NULL,NULL,NULL,1,120.65775,9.50008,0.057,NULL,62802831340,981294239,15332722,15.2),(51621,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51621,38.2,0.46,437,14102,70,NULL,NULL,'2MASX J08023905+1344035',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,120.662583333,13.73431,0.089,NULL,62656875615,979013681,15297088,18),(51622,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51622,37.24,0.46,281,14103,70,NULL,NULL,'2MASX J08024100+3141501',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000151,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,120.670667,31.69728,0.185,NULL,64345028880,1005391076,15709235,17.2),(51623,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51623,36.67,0.46,216,14104,70,NULL,NULL,'2MASX J08024100+2346010',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000175,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,120.6709583,23.76706,0.149,NULL,63767118147,996361221,15568144,16.4),(51624,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51624,37.71,0.46,348,14105,70,NULL,NULL,'2MASX J08024227+1623310',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000188,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,120.676125,16.39189,0.069,NULL,62670028687,979219198,15300299,16.9),(51625,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51625,33.3,0.2,45.7,14106,74.4,NULL,NULL,'UGC 04176',NULL,'2013AJ....146...86T',2013,1,1.8,NULL,'G',0.000023,NULL,'14.90',0.5,'SBd',NULL,NULL,NULL,NULL,1,120.6800417,40.67892,0.141,NULL,63555440003,993053750,15516464,14.9),(51626,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51626,38.49,0.46,498,14107,70,NULL,NULL,'2MASX J08024451+3635567',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000166,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,120.685417,36.59911,0.217,NULL,63448686616,991385728,15490402,18.3),(51627,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51627,38.88,0.46,596,14108,70,NULL,NULL,'2MASX J08024600+1521300',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,120.691625,15.35847,0.061,NULL,62677645249,979338207,15302159,18.1),(51628,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51628,37.81,0.46,364,14109,70,NULL,NULL,'2MASX J08024681+4011049',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,120.6952083,40.18481,0.133,NULL,63555642621,993056915,15516514,18.1),(51629,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51629,36.2,0.33,174,14110,70,NULL,NULL,'CGCG 207-021',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000183,NULL,'15.1g',0.55,'BrClG',NULL,NULL,NULL,NULL,1,120.7047917,40.45739,0.133,NULL,63556197697,993065589,15516649,15.1),(51630,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51630,35.67,0.46,136,14111,70,NULL,NULL,'CGCG 178-020',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000195,NULL,'15.3g',0.49,'E/S0',NULL,NULL,NULL,NULL,1,120.7115,35.77356,0.249,NULL,63448422024,991381594,15490337,15.3),(51631,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51631,35.37,0.59,119,14112,70,NULL,NULL,'2MASX J08025084-0836574',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,120.711875,-8.61597,0.453,NULL,39456824827,616512887,9633013,15.3),(51632,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51632,35.93,0.6,153,14113,70,NULL,NULL,'2MASX J08025154-0455562',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.0001,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,120.71475,-4.93233,0.213,NULL,39434142653,616158478,9627476,14.3),(51633,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51633,36.68,0.46,217,14114,70,NULL,NULL,'2MASX J08025162+4609250',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000087,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,120.7150417,46.157,0.141,NULL,63529304921,992645389,15510084,16.7),(51634,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51634,37.2,0.46,275,14115,70,NULL,NULL,'SDSS J080251.88+334415.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000136,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,120.7162083,33.73756,0.217,NULL,64328570314,1005133911,15705217,18.5),(51635,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51635,36.71,0.46,220,14116,70,NULL,NULL,'2MASX J08025224+2914121',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000205,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,120.717791667,29.23664,0.113,NULL,64301899053,1004717172,15698705,16.5),(51636,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51636,36.62,0.46,211,14117,70,NULL,NULL,'2MASX J08025311+1629371',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000185,NULL,'16.0g',0.34,NULL,NULL,NULL,NULL,NULL,1,120.72125,16.49369,0.069,NULL,62669547652,979211682,15300182,16),(51637,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51637,37.87,0.46,374,14118,70,NULL,NULL,'2MASX J08025624+1726401',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000186,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,120.734291667,17.44464,0.033,NULL,62667760644,979183760,15299746,16.4),(51638,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51638,37.62,0.33,334,14119,70,NULL,NULL,'SDSS J080256.46+332939.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000167,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,120.7352917,33.49439,0.225,NULL,64328588661,1005134197,15705221,18.4),(51639,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51639,37.43,0.23,306,14120,70,NULL,NULL,'2MASX J08025677+5157262',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.0002,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,120.7364583,51.95719,0.141,NULL,63512524542,992383195,15505987,16.7),(51640,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51640,37.45,0.33,308,14121,70,NULL,NULL,'2MASX J08025808+3454391',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000181,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,120.742125,34.91094,0.233,NULL,63444991840,991327997,15489499,17),(51641,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51641,37.38,0.46,299,14122,70,NULL,NULL,'2MASX J08025836+2531281',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000182,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,120.743041667,25.52444,0.053,NULL,64305852160,1004778940,15699670,16.6),(51642,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51642,36.23,0.64,176,14123,70,NULL,NULL,'2MASX J08025947-7318424',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,120.747875,-73.31186,0.581,NULL,39902519342,623476864,9741826,17.3),(51643,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51643,38.14,0.46,425,14124,70,NULL,NULL,'2MASX J08025958+5008182',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000155,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,120.748375,50.13842,0.117,NULL,63549138139,992955283,15514926,17.7),(51644,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51644,34.97,0.49,98.4,14125,75,NULL,'IR','ESO 124- G 008',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'16.61',0.2,'S...',NULL,NULL,NULL,NULL,1,120.750875,-58.70578,0.973,NULL,40438553405,631852396,9872693,16.61),(51645,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51645,35.56,0.46,129,14125,NULL,NULL,'Malmquist cor.','ESO 124- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51646,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51646,35.55,0.46,129,14125,NULL,NULL,NULL,'ESO 124- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51647,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51647,35.59,0.2,131,14125,74.4,NULL,NULL,'ESO 124- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51648,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51648,36.2,0.33,174,14126,70,NULL,NULL,'2MASX J08030049+4024590',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000177,NULL,'16.3g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,120.752166667,40.41644,0.133,NULL,63556213087,993065829,15516653,16.3),(51649,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51649,36.24,0.46,177,14127,70,NULL,NULL,'2MASX J08030086+3509335',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000204,NULL,'15.6g',0.32,'S0',NULL,NULL,NULL,NULL,1,120.7537083,35.15914,0.225,NULL,63445083207,991329425,15489522,15.6),(51650,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51650,37.62,0.33,334,14128,70,NULL,NULL,'2MASX J08030156+3329275',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00021,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,120.7565,33.49089,0.225,NULL,64328586006,1005134156,15705221,16.4),(51651,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51651,33.54,0.4,51.1,14129,NULL,NULL,'mean','ESO 561- G 009',NULL,'2007A&A...465...71T',2007,1,1.8,'abs(b) < 10 degrees.','G',0.000022,NULL,'15',0.7,'(R\')SB(r)a',NULL,NULL,NULL,NULL,1,120.76025,-18.70206,NULL,NULL,39330981617,614546587,9602290,15),(51652,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51652,33.61,0.47,52.7,14129,NULL,NULL,'H','ESO 561- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51653,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51653,33.64,0.45,53.4,14129,NULL,NULL,'K','ESO 561- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51654,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51654,33.67,0.46,54.1,14129,NULL,NULL,'J','ESO 561- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51655,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51655,36.25,0.46,178,14130,70,NULL,NULL,'2MASX J08030362+3012255',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000197,NULL,'16.0g',0.28,'S0',NULL,NULL,NULL,NULL,1,120.765167,30.20686,0.133,NULL,64299417822,1004678403,15698100,16),(51656,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51656,37.25,0.46,282,14131,70,NULL,NULL,'2MASX J08030472+0815142',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,120.7697083,8.25394,0.021,NULL,62810052730,981407073,15334485,17.4),(51657,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51657,37.98,0.46,394,14132,70,NULL,NULL,'2MASX J08030586+1420480',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000179,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,120.7745,14.34661,0.097,NULL,62657018028,979015906,15297123,17.8),(51658,'Ring Diameter','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51658,33.5,0.84,50,14133,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 2512',NULL,'1981ApJS...45..541P',1981,1,1.4,NULL,'G',0.00002,NULL,'13.85',0.9,'SBb            Sbrst','Group member, radial-velocity confirmed',NULL,NULL,'Starburst',1,120.7827083,23.39183,0.161,NULL,63767492382,996367068,15568235,13.85),(51659,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51659,33.31,0.69,45.9,14133,100,NULL,'mid-IR','NGC 2512',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51660,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51660,33.68,0.47,54.4,14133,NULL,NULL,'H','NGC 2512',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51661,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51661,33.7,0.45,55,14133,NULL,NULL,'K','NGC 2512',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51662,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51662,33.79,0.46,57.3,14133,NULL,NULL,'J','NGC 2512',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51663,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51663,33.82,0.43,58,14133,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2512',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51664,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51664,33.93,0.43,61,14133,75,NULL,'3.6 micron, color corrected','NGC 2512',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51665,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51665,34.12,0.2,66.7,14133,74.4,NULL,NULL,'NGC 2512',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51666,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51666,34.19,0.4,68.9,14133,NULL,NULL,'mean','NGC 2512',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51667,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51667,37.39,0.46,301,14134,70,NULL,NULL,'2MASX J08030784+4013350',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00018,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,120.782667,40.22636,0.133,NULL,63556162541,993065039,15516641,16.4),(51668,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51668,35.69,0.51,137,14135,70,NULL,NULL,'2MASX J08030797-7120307',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'18.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,120.783125,-71.34181,0.701,NULL,40630554124,634852408,9919568,18),(51669,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51669,38.46,0.46,491,14136,70,NULL,NULL,'2MASX J08030795+3325085',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,120.7832083,33.41911,0.225,NULL,64328810764,1005137668,15705276,18.2),(51670,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51670,37.93,0.46,385,14137,70,NULL,NULL,'2MASX J08031078+5242052',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,120.794917,52.70144,0.133,NULL,63510934204,992358346,15505599,17.6),(51671,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51671,36.24,0.27,177,14138,70,NULL,NULL,'2MASX J08031182+3953090',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000093,NULL,'11.3K',NULL,NULL,NULL,NULL,NULL,NULL,1,120.79925,39.88581,0.133,NULL,63555658863,993057169,15516518,11.3),(51672,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51672,37.45,0.33,308,14139,70,NULL,NULL,'2MASX J08031242+3457255',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000174,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,120.80175,34.95703,0.233,NULL,63444985917,991327904,15489498,17),(51673,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51673,37.98,0.46,395,14140,70,NULL,NULL,'2MASX J08031277+3122465',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,120.803417,31.37961,0.177,NULL,64345773614,1005402712,15709417,17.3),(51674,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51674,37.43,0.23,306,14141,70,NULL,NULL,'2MASX J08031289+5154572',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00017,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,120.8037917,51.91594,0.141,NULL,63545285587,992895087,15513985,17.4),(51675,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51675,38.64,0.46,534,14142,70,NULL,NULL,'SDSS J080312.91+270530.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000131,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,120.803833,27.09175,0.065,NULL,64307056091,1004797751,15699964,18.6),(51676,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51676,37.43,0.23,306,14143,70,NULL,NULL,'2MASX J08031322+5155572',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000198,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,120.805167,51.93267,0.141,NULL,63545284695,992895073,15513985,16.8),(51677,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51677,35.06,0.46,103,14144,70,NULL,NULL,'2MASX J08031327+3307565',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000172,NULL,'16.3g',0.29,'E0',NULL,NULL,NULL,NULL,1,120.8052083,33.13236,0.233,NULL,64328774679,1005137104,15705267,16.3),(51678,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51678,38.62,0.46,531,14145,70,NULL,NULL,'2MASX J08031435+1637292',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000182,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,120.809625,16.62469,0.057,NULL,62669567957,979211999,15300187,18.4),(51679,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51679,37.86,0.46,374,14146,70,NULL,NULL,'2MASX J08031477+1632532',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000184,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,120.8117083,16.54819,0.069,NULL,62669562665,979211916,15300186,17),(51680,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51680,37.33,0.46,292,14147,70,NULL,NULL,'2MASX J08031597+0838402',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,120.816583333,8.64464,0,NULL,62810518735,981414355,15334599,17.8),(51681,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51681,36.33,0.46,185,14148,70,NULL,NULL,'CGCG 118-054',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.00019,NULL,'15.7g',0.41,'E',NULL,NULL,'NAT',NULL,1,120.818833333,24.67678,0.089,NULL,64291396124,1004553064,15696141,15.7),(51682,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51682,35.6,0.53,132,14149,70,NULL,NULL,'2MASX J08031663-1016577',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.08',NULL,NULL,NULL,NULL,NULL,NULL,1,120.8192917,-10.28267,0.417,NULL,39455774984,616496484,9632757,16.08),(51683,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51683,37.63,0.46,336,14150,70,NULL,NULL,'SDSS J080316.98+512235.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000135,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,120.820791667,51.37658,0.125,NULL,63545483488,992898179,15514034,18.7),(51684,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51684,38.35,0.46,469,14151,70,NULL,NULL,'2MASX J08031731+1428522',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000144,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,120.822041667,14.48122,0.097,NULL,62656679091,979010610,15297040,18.3),(51685,'Tully est','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51685,31.59,0.8,20.8,14152,75,NULL,NULL,'ESO 035- G 020',NULL,'1988NBGC.C....0000T',1988,1,2.8,NULL,'G',0.00001,NULL,'15.81',2.5,'IB(s)m',NULL,NULL,NULL,NULL,1,120.8275417,-77.07186,0.521,NULL,39934841383,623981896,9749717,15.81),(51686,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51686,36.68,0.46,217,14153,70,NULL,NULL,'2MASX J08031900+0846512',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.86',0.29,NULL,NULL,NULL,NULL,NULL,1,120.829125,8.78094,0.069,NULL,62810438516,981413101,15334579,16.86),(51687,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51687,37.58,0.46,329,14154,70,NULL,NULL,'2MASX J08032001+1206172',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000131,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,120.833417,12.10472,0.037,NULL,62784696456,981010882,15328295,17.9),(51688,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51688,38.04,0.46,406,14155,70,NULL,NULL,'2MASX J08032155+0655032',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,120.839833,6.91753,0.117,NULL,62806897658,981357775,15333715,17.7),(51689,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51689,36.92,0.33,242,14156,70,NULL,NULL,'2MASX J08032308+4531520',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000107,NULL,'16.2g',0.35,'E0',NULL,NULL,NULL,NULL,1,120.8462083,45.53108,0.129,NULL,63531056408,992672756,15510511,16.2),(51690,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51690,32.97,NULL,39.2,14157,NULL,NULL,NULL,'SDSS J080324.66+150819.5',NULL,'2015AstBu..70....1K',2015,1,1,NULL,'G',0.000013,NULL,'18.4g',0.5,'dwarf Irr',NULL,NULL,NULL,NULL,1,120.85275,15.13878,0.033,NULL,62663966663,979124479,15298819,18.4),(51691,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51691,37.79,0.46,361,14158,70,NULL,NULL,'2MASX J08032516+0948422',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,120.854917,9.81175,0.057,NULL,62804646141,981322595,15333165,17.7),(51692,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51692,34.27,0.2,71.5,14159,74.4,NULL,NULL,'UGC 04197',NULL,'2013AJ....146...86T',2013,1,2.07,NULL,'G',0.000162,NULL,'14.3g',0.35,'Sb:','Group member',NULL,NULL,NULL,1,120.856375,10.05053,0.029,NULL,62805332722,981333323,15333333,14.3),(51693,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51693,34.3,0.49,72.4,14159,75,NULL,'IR','UGC 04197',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51694,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51694,37.44,0.46,307,14160,70,NULL,NULL,'SDSS J080325.69+350904.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000151,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,120.857083,35.15131,0.225,NULL,63444975529,991327742,15489495,18.5),(51695,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51695,35.4,0.5,120,14161,70,NULL,NULL,'ESO 059- G 025',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00015,NULL,'15.13',0.3,'SB(s)c: sp',NULL,NULL,NULL,NULL,1,120.863416667,-70.36686,0.677,NULL,40623706104,634745407,9917896,15.13),(51696,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51696,37.78,0.46,359,14162,70,NULL,NULL,'2MASX J08032750+1957153',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000134,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,120.8645,19.95419,0.061,NULL,63761270014,996269843,15566716,18.3),(51697,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51697,37.71,0.46,349,14163,70,NULL,NULL,'2MASX J08032863+3828162',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000182,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,120.8692083,38.47111,0.181,NULL,63438404833,991225075,15487891,17.5),(51698,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51698,38.53,0.46,509,14164,70,NULL,NULL,'SDSS J080329.00+371247.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000161,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,120.870833,37.21317,0.181,NULL,63437536060,991211500,15487679,18.8),(51699,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51699,36.44,0.27,195,14165,70,NULL,NULL,'2MASX J08033071+2629583',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000155,NULL,'16.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,120.8780417,26.49964,0.057,NULL,64306417073,1004787766,15699808,16.5),(51700,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51700,36.61,0.46,210,14166,70,NULL,NULL,'2MASX J08033093+3729192',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000192,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,120.879041667,37.48861,0.173,NULL,63437488763,991210761,15487668,16.8),(51701,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51701,37.07,0.46,260,14167,70,NULL,NULL,'2MASXi J0803315+443831',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00007,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,120.8815,44.64211,0.121,NULL,63528366494,992630726,15509855,17.3),(51702,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51702,37.74,0.33,352,14168,70,NULL,NULL,'2MASX J08033540+1734242',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000178,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,120.8975,17.57344,0.049,NULL,62667905355,979186021,15299781,17.1),(51703,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51703,37.15,0.46,269,14169,70,NULL,NULL,'2MASX J08033548+1151493',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,120.897833333,11.86383,0.033,NULL,62784748559,981011696,15328307,17.1),(51704,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51704,36.56,0.46,205,14170,70,NULL,NULL,'2MASX J08033690+0735253',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,120.903833333,7.59036,0.073,NULL,62806818851,981356544,15333696,17.3),(51705,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51705,36.91,0.46,241,14171,70,NULL,NULL,'2MASX J08033732+3929373',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000182,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,120.905375,39.49361,0.121,NULL,63554516782,993039324,15516239,16.4),(51706,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51706,34.36,NULL,74.3,14172,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04192',NULL,'2010Ap&SS.325..163P',2010,1,1.48,NULL,'G',0.000061,NULL,'16.0g',0.2,'Sd(f)',NULL,NULL,NULL,NULL,1,120.9085,43.34303,0.153,NULL,63528006609,992625103,15509767,16),(51707,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51707,34.37,NULL,74.9,14172,NULL,NULL,'Dipole + Quadrupole','UGC 04192',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51708,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51708,34.38,NULL,75.2,14172,NULL,NULL,'Dipole','UGC 04192',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51709,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51709,34.44,NULL,77.2,14172,NULL,NULL,NULL,'UGC 04192',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51710,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51710,37.7,0.46,347,14173,70,NULL,NULL,'2MASX J08033853+2531013',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000195,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,120.910625,25.517,0.053,NULL,64305843463,1004778804,15699668,17.1),(51711,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51711,37.29,0.46,287,14174,70,NULL,NULL,'2MASX J08033903+2438213',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,120.9127917,24.63922,0.089,NULL,64291351353,1004552364,15696130,17.1),(51712,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51712,37.43,0.23,306,14175,70,NULL,NULL,'2MASX J08034040+5200003',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000166,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,120.9182083,52,0.173,NULL,63545282432,992895038,15513984,16.7),(51713,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51713,36.92,0.46,242,14176,70,NULL,NULL,'2MASX J08034054+4643380',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000061,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,120.918833333,46.72736,0.109,NULL,63537132783,992767699,15511995,16.9),(51714,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51714,36.44,0.27,195,14177,70,NULL,NULL,'2MASX J08034241+2627193',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000196,NULL,'15.5g',0.5,'E0',NULL,NULL,NULL,NULL,1,120.92675,26.45542,0.057,NULL,64306415173,1004787737,15699808,15.5),(51715,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51715,37.81,0.46,364,14178,70,NULL,NULL,'2MASX J08034322+0748313',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,120.9300417,7.80861,0.025,NULL,62809989361,981406083,15334470,17.3),(51716,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51716,35.17,0.2,108,14179,74.4,NULL,NULL,'CGCG 059-030',NULL,'2013AJ....146...86T',2013,1,0.62,NULL,'G',0.000108,NULL,'15.9g',0.38,NULL,'Group member',NULL,NULL,NULL,1,120.933,10.05172,0.029,NULL,62805455652,981335244,15333363,15.9),(51717,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51717,35.61,0.46,132,14180,70,NULL,NULL,'CGCG 178-022',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000147,NULL,'15.1g',0.58,'E0',NULL,NULL,NULL,NULL,1,120.935417,35.34286,0.237,NULL,63444288887,991317013,15489328,15.1),(51718,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51718,37.74,0.33,352,14181,70,NULL,NULL,'2MASX J08034850+1735596',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,120.9522083,17.59983,0.049,NULL,62668124460,979189444,15299835,17.3),(51719,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51719,36.44,0.27,195,14182,70,NULL,NULL,'2MASX J08034971+2630463',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000183,NULL,'16.2g',0.4,'E0',NULL,NULL,NULL,NULL,1,120.95725,26.51272,0.057,NULL,64306428545,1004787946,15699811,16.2),(51720,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51720,37.53,0.46,320,14183,70,NULL,NULL,'SDSS J080349.84+121557.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,120.9577083,12.266,0.037,NULL,62654593667,978978026,15296531,18.2),(51721,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51721,33.55,0.2,51.3,14184,74.4,NULL,NULL,'CGCG 059-031',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000267,NULL,'15.7',0.3,NULL,NULL,NULL,NULL,NULL,1,120.959083,10.5485,0.033,NULL,62804849454,981325772,15333215,15.7),(51722,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51722,34.08,0.49,65.4,14185,75,NULL,'IR','CGCG 059-031',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000267,NULL,'15.7',0.3,NULL,NULL,NULL,NULL,NULL,1,120.959083,10.5485,0.033,NULL,62804849454,981325772,15333215,15.7),(51723,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51723,36.04,0.61,161,14186,70,NULL,NULL,'2MASX J08035039-0124549',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.49',0.3,NULL,NULL,NULL,NULL,NULL,1,120.96,-1.41539,0.117,NULL,39307488269,614179504,9596554,16.49),(51724,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51724,35.97,0.17,156,14187,70,NULL,NULL,'2MASX J08035070+5536487',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000092,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,120.961167,55.61361,0.105,NULL,61597471913,962460498,15038445,16.2),(51725,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51725,37.34,0.46,293,14188,70,NULL,NULL,'2MASX J08035158+3306460',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,120.964875,33.11275,0.213,NULL,64328731460,1005136429,15705256,17.7),(51726,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51726,37.7,0.46,346,14189,70,NULL,NULL,'2MASX J08035168+3939203',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,120.965167,39.6555,0.121,NULL,63554479129,993038736,15516230,18),(51727,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51727,37.23,0.27,280,14190,70,NULL,NULL,'2MASX J08035239+3043400',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,120.9682083,30.72767,0.145,NULL,64345228026,1005394187,15709284,17.7),(51728,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51728,36.41,0.46,192,14191,70,NULL,NULL,'2MASX J08035287+2159161',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000176,NULL,'16.2g',0.37,'E0',NULL,NULL,NULL,NULL,1,120.9702083,21.98792,0.209,NULL,63769603649,996400057,15568750,16.2),(51729,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51729,38.24,0.46,444,14192,70,NULL,NULL,'2MASX J08035383+4346495',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00008,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,120.974333,43.78067,0.141,NULL,63528104986,992626640,15509791,18),(51730,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51730,37.6,0.46,331,14193,70,NULL,NULL,'2MASX J08035672+2856205',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000174,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,120.9865,28.93917,0.105,NULL,64301497554,1004710899,15698607,17.6),(51731,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51731,36.92,0.33,242,14194,70,NULL,NULL,'2MASX J08035822+4530336',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.0001,NULL,'16.3g',0.35,'E0',NULL,NULL,NULL,NULL,1,120.992375,45.50933,0.129,NULL,63530999934,992671873,15510498,16.3),(51732,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51732,37.98,0.46,395,14195,70,NULL,NULL,'SDSS J080359.08+363525.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000139,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,120.9962083,36.59047,0.177,NULL,63448354303,991380535,15490320,18.7),(51733,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51733,35.23,0.46,111,14196,70,NULL,NULL,'2MASX J08035923+2345201',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000024,NULL,'15.3g',0.55,'E/S0           Sy',NULL,NULL,NULL,NULL,1,120.996667,23.75569,0.125,NULL,63768009029,996375141,15568361,15.3),(51734,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51734,36.09,0.46,165,14197,70,NULL,NULL,'2MASX J08035920+1503436',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000187,NULL,'16.0g',0.45,NULL,NULL,NULL,NULL,NULL,1,120.9967083,15.06197,0.057,NULL,62656619835,979009684,15297026,16),(51735,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51735,37.06,0.46,258,14198,70,NULL,NULL,'2MASX J08035927+1324186',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00016,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,120.996958333,13.40531,0.045,NULL,62658163028,979033797,15297403,17.1),(51736,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51736,37.72,0.46,350,14199,70,NULL,NULL,'2MASX J08040133+3655490',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00018,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,121.005458333,36.93047,0.181,NULL,63437401227,991209394,15487646,17),(51737,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51737,37.85,0.46,372,14200,70,NULL,NULL,'2MASX J08040207+1735306',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000144,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,121.008625,17.59181,0.049,NULL,62668118739,979189355,15299833,17.7),(51738,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51738,37.86,0.46,374,14201,70,NULL,NULL,'2MASX J08040409+1419396',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,121.017166667,14.32753,0.057,NULL,62657592007,979024875,15297263,17.9),(51739,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51739,37.12,0.46,265,14202,70,NULL,NULL,'2MASX J08040465+5053582',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000154,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,121.019333,50.89958,0.153,NULL,63545791759,992902996,15514109,17.5),(51740,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51740,36.22,0.52,175,14203,70,NULL,NULL,'2MASX J08040556-7117542',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,121.023,-71.29836,0.701,NULL,40630882141,634857533,9919648,15.8),(51741,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51741,39.27,0.46,713,14204,70,NULL,NULL,'SDSS J080405.63+251439.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,121.0234583,25.24439,0.057,NULL,64305230815,1004769231,15699519,18.7),(51742,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51742,37.37,0.46,298,14205,70,NULL,NULL,'2MASX J08040572+3358309',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000159,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,121.023708333,33.97519,0.229,NULL,64330403857,1005162560,15705665,17.2),(51743,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51743,37.48,0.46,313,14206,70,NULL,NULL,'2MASX J08040833+5142542',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000182,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,121.034583333,51.71522,0.141,NULL,63545322454,992895663,15513994,17.3),(51744,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51744,34.02,0.38,63.8,14207,NULL,NULL,'Malmquist cor.','NGC 2523A',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000037,NULL,'14.49',0.7,'SB(s)c:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,121.03525,74.04778,0.093,NULL,61301637044,957838078,14966219,14.49),(51745,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51745,34.08,0.37,65.3,14207,NULL,NULL,NULL,'NGC 2523A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51746,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51746,34.12,0.2,66.7,14207,74.4,NULL,NULL,'NGC 2523A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51747,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51747,37.15,0.46,270,14208,70,NULL,NULL,'2MASX J08040864+3126132',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000161,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,121.035875,31.43697,0.161,NULL,64345805255,1005403207,15709425,16.7),(51748,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51748,36.24,0.27,177,14209,70,NULL,NULL,'2MASX J08041269+3957420',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000166,NULL,'16.0g',0.32,'S0/a',NULL,NULL,NULL,NULL,1,121.0527917,39.96183,0.133,NULL,63555725575,993058212,15516534,16),(51749,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51749,34.9,0.49,95.5,14210,75,NULL,'IR','UGC 04186',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000057,NULL,'15.5',0.19,'Sb',NULL,NULL,NULL,NULL,1,121.05775,62.98161,0.137,NULL,62042818780,969419043,15147172,15.5),(51750,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51750,37.63,0.46,336,14211,70,NULL,NULL,'2MASX J08041400+3647120',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,121.058625,36.78672,0.181,NULL,63437612123,991212689,15487698,17.5),(51751,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51751,36.25,0.46,178,14212,70,NULL,NULL,'2MASX J08041573+0751119',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'16.94',0.4,NULL,NULL,NULL,NULL,NULL,1,121.065625,7.85319,0.025,NULL,62813415157,981459611,15335306,16.94),(51752,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51752,35.43,0.33,122,14213,70,NULL,NULL,'CGCG 207-025',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.00017,NULL,'15.2g',0.5,'S0','Group member',NULL,NULL,NULL,1,121.07625,40.19572,0.133,NULL,63555668345,993057317,15516520,15.2),(51753,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51753,36.14,0.46,169,14214,70,NULL,NULL,'2MASX J08041916+3301363',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000181,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,121.0797083,33.02667,0.213,NULL,64328852655,1005138322,15705286,16.5),(51754,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51754,37.55,0.46,324,14215,70,NULL,NULL,'2MASX J08042044+2751096',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000126,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,121.085125,27.85264,0.093,NULL,64303244938,1004738202,15699034,18.3),(51755,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51755,36.21,0.46,174,14216,70,NULL,NULL,'2MASX J08042096+2400456',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,121.087333333,24.01272,0.133,NULL,63767305537,996364149,15568189,16.7),(51756,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51756,38.16,0.46,429,14217,70,NULL,NULL,'2MASX J08042163+1134018',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,121.090083,11.56717,0.037,NULL,62785506039,981023531,15328492,17.8),(51757,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51757,38.17,0.46,431,14218,70,NULL,NULL,'SDSS J080422.09+351217.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000141,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,121.092083,35.20489,0.225,NULL,63444285515,991316961,15489327,18.5),(51758,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51758,34.81,0.51,91.6,14219,NULL,NULL,NULL,'ESO 124- G 010',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.48',0.2,'S...',NULL,NULL,NULL,NULL,1,121.0974583,-61.52208,0.733,NULL,40435006609,631796978,9871827,16.48),(51759,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51759,34.82,0.5,92.2,14219,NULL,NULL,'Malmquist cor.','ESO 124- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51760,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51760,34.85,0.2,93.3,14219,74.4,NULL,NULL,'ESO 124- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51761,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51761,32.01,0.43,25.3,14220,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04078',NULL,'2014MNRAS.444..527S',2014,1,2.49,'The UZC position refers to a superposed star.','G',0.000037,NULL,'15.10',0.32,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,121.103125,84.6415,0.193,NULL,61263529570,957242649,14956916,15.1),(51762,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51762,32.25,0.43,28.2,14220,75,NULL,'3.6 micron, color corrected','UGC 04078',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51763,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51763,32.44,0.2,30.8,14220,74.4,NULL,NULL,'UGC 04078',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51764,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51764,32.5,0.68,31.7,14220,NULL,NULL,'Malmquist cor.','UGC 04078',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51765,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51765,32.51,0.4,31.8,14220,75,NULL,NULL,'UGC 04078',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51766,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51766,32.65,0.64,33.9,14220,NULL,NULL,NULL,'UGC 04078',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51767,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51767,32.79,NULL,36.1,14220,NULL,NULL,'Dipole','UGC 04078',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51768,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51768,32.79,NULL,36.2,14220,NULL,NULL,'Dipole + Quadrupole','UGC 04078',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51769,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51769,32.8,NULL,36.3,14220,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04078',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51770,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51770,32.88,NULL,37.6,14220,NULL,NULL,NULL,'UGC 04078',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51771,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51771,32.89,0.49,37.8,14220,75,NULL,'IR','UGC 04078',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51772,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51772,36.24,0.27,177,14221,70,NULL,NULL,'2MASX J08042538+3955500',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000183,NULL,'17.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,121.105583,39.93061,0.133,NULL,63555761185,993058768,15516543,17.1),(51773,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51773,37.68,0.46,343,14222,70,NULL,NULL,'2MASX J08042650+3952520',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000152,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,121.110458333,39.88103,0.121,NULL,63555721069,993058141,15516533,17.4),(51774,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51774,37.74,0.46,354,14223,70,NULL,NULL,'2MASX J08042692+3337563',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,121.1122083,33.63222,0.233,NULL,64331479766,1005179371,15705927,18.1),(51775,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51775,38.64,0.46,534,14224,70,NULL,NULL,'2MASX J08042727+2112576',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,121.113708333,21.21611,0.141,NULL,63760292412,996254568,15566477,18.4),(51776,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51776,39.24,0.46,705,14225,70,NULL,NULL,'SDSS J080427.56+510339.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000166,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,121.114875,51.06089,0.149,NULL,63545783433,992902866,15514107,18.3),(51777,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51777,37.63,0.46,336,14226,70,NULL,NULL,'2MASX J08043067+1433297',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,121.1277917,14.55814,0.057,NULL,62656821930,979012842,15297075,17.8),(51778,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51778,36.09,0.46,165,14227,70,NULL,NULL,'CGCG 088-028',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00011,NULL,'15.7',0.5,NULL,NULL,NULL,NULL,NULL,1,121.1287083,15.48381,0.041,NULL,62651593222,978931144,15295799,15.7),(51779,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51779,37.93,0.33,386,14228,70,NULL,NULL,'2MASX J08043126+0608113',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,121.130375,6.13653,0.105,NULL,62807203813,981362559,15333789,17.4),(51780,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51780,35.43,0.33,122,14229,70,NULL,NULL,'2MASX J08043251+4015099',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000144,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,121.1355,40.25278,0.133,NULL,63555698927,993057795,15516528,16.6),(51781,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51781,38.59,0.46,523,14230,70,NULL,NULL,'SDSS J080432.92+393332.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000153,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,121.137167,39.55903,0.121,NULL,63555513845,993054903,15516482,18.5),(51782,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51782,37.89,0.27,379,14231,70,NULL,NULL,'2MASX J08043347+2547048',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,121.1395,25.78464,0.041,NULL,64305910129,1004779845,15699685,17.4),(51783,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51783,37.25,0.46,282,14232,70,NULL,NULL,'2MASX J08043353+4815465',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000076,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,121.1395417,48.26278,0.109,NULL,63538518900,992789357,15512333,17.1),(51784,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51784,37.93,0.33,386,14233,70,NULL,NULL,'2MASX J08043361+0602463',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,121.14025,6.04628,0.105,NULL,62774469197,980851081,15325798,17.4),(51785,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51785,36.79,0.46,228,14234,70,NULL,NULL,'2MASX J08043465+0636063',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,121.144458333,6.60164,0.097,NULL,62807592146,981368627,15333884,16.9),(51786,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51786,34.31,NULL,72.8,14235,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0706',NULL,'2010Ap&SS.325..163P',2010,1,0.96,NULL,'G',0.000016,NULL,'17.23',0.09,'Sd(f)',NULL,NULL,NULL,NULL,1,121.14625,35.99775,0.169,NULL,63448502653,991382853,15490357,17.23),(51787,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51787,34.33,NULL,73.3,14235,NULL,NULL,'Dipole + Quadrupole','FGC 0706',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51788,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51788,34.34,NULL,73.9,14235,NULL,NULL,'Dipole','FGC 0706',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51789,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51789,34.45,NULL,77.6,14235,NULL,NULL,NULL,'FGC 0706',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51790,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51790,35.14,0.43,107,14235,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0706',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51791,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51791,37.66,0.46,341,14236,70,NULL,NULL,'2MASX J08043612+5114074',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'18.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,121.1505417,51.23542,0.149,NULL,63545443709,992897557,15514024,18.2),(51792,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51792,37.51,0.46,317,14237,70,NULL,NULL,'2MASX J08043842+4325241',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,121.1600417,43.42336,0.153,NULL,63532387945,992693561,15510836,17.4),(51793,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51793,36.64,0.33,213,14238,70,NULL,NULL,'2MASX J08043892+2433358',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000181,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,121.162083,24.55986,0.081,NULL,63767052910,996360201,15568128,17),(51794,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51794,37.89,0.27,379,14239,70,NULL,NULL,'2MASX J08043992+2546348',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,121.166375,25.77625,0.041,NULL,64305911350,1004779864,15699685,17.5),(51795,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51795,38.22,0.46,441,14240,70,NULL,NULL,'2MASX J08044050+5239344',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,121.168583,52.65969,0.133,NULL,63510776924,992355889,15505560,17.9),(51796,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51796,37.82,0.23,366,14241,70,NULL,NULL,'SDSS J080440.50+363228.1',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,121.1687917,36.54117,0.177,NULL,63436887751,991201371,15487521,17.5),(51797,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51797,37.5,0.46,316,14242,70,NULL,NULL,'2MASX J08044077+1130083',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,121.1699583,11.50225,0.025,NULL,62785486743,981023230,15328487,17.3),(51798,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51798,37.69,0.46,345,14243,70,NULL,NULL,'2MASX J08044183+4014281',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,121.17425,40.24125,0.133,NULL,63555584435,993056006,15516500,17.5),(51799,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51799,37.94,0.46,387,14244,70,NULL,NULL,'2MASX J08044186+4036161',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,121.174375,40.60447,0.133,NULL,63556273390,993066771,15516668,17.3),(51800,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51800,34.93,NULL,96.7,14245,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04201',NULL,'2010Ap&SS.325..163P',2010,1,1.19,NULL,'G',0.00003,NULL,'15.8g',0.25,'Sc',NULL,NULL,NULL,NULL,1,121.1777083,35.40053,0.237,NULL,63444315633,991317431,15489334,15.8),(51801,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51801,34.94,NULL,97.3,14245,NULL,NULL,'Dipole + Quadrupole','UGC 04201',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51802,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51802,34.94,NULL,97.4,14245,NULL,NULL,'Dipole','UGC 04201',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51803,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51803,34.99,NULL,99.6,14245,NULL,NULL,NULL,'UGC 04201',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51804,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51804,35.17,0.49,108,14245,75,NULL,'IR','UGC 04201',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51805,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51805,38.2,0.27,437,14246,70,NULL,NULL,'2MASX J08044270+1700399',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000158,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,121.1779583,17.01119,0.077,NULL,62667671950,979182374,15299724,17.4),(51806,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51806,37.23,0.27,280,14247,70,NULL,NULL,'2MASX J08044432+3045481',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000178,NULL,'16.5g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,121.1845417,30.76339,0.145,NULL,64345298239,1005395284,15709301,16.5),(51807,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51807,38.52,0.46,506,14248,70,NULL,NULL,'2MASX J08044426+3814322',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000183,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,121.184583,38.24231,0.145,NULL,63438672782,991229262,15487957,17.6),(51808,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51808,36.57,0.46,206,14249,70,NULL,NULL,'2MASX J08044520+3033042',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000159,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,121.188333,30.55122,0.137,NULL,64345120579,1005392509,15709257,17),(51809,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51809,36.64,0.33,213,14250,70,NULL,NULL,'2MASX J08044515+2433068',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00017,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,121.188375,24.552,0.081,NULL,63762861616,996294712,15567104,16.2),(51810,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51810,35.92,0.56,153,14251,70,NULL,NULL,'2MASX J08044625-7110183',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,121.192875,-71.17172,0.701,NULL,40630941194,634858456,9919663,16.8),(51811,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51811,37.99,0.33,397,14252,70,NULL,NULL,'2MASX J08044678+3615252',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000161,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,121.195,36.25703,0.169,NULL,63448385630,991381025,15490328,17.8),(51812,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51812,38.2,0.27,437,14253,70,NULL,NULL,'2MASX J08044974+1703079',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000146,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,121.207333,17.05214,0.077,NULL,62667643479,979181929,15299717,17.6),(51813,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 1998I',NULL,51813,42.91,0.81,2020,14254,65,NULL,NULL,'H-ZSNS J080451.56+051547.7',0.89,'2004ApJ...607..665R',2004,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,121.214833333,5.26325,0.073,NULL,62774707712,980854808,15325856,NULL),(51814,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51814,36.62,0.46,211,14255,70,NULL,NULL,'2MASX J08045284+2049014',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,121.220333,20.81708,0.141,NULL,63760867730,996263558,15566618,16.8),(51815,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51815,37.91,0.46,381,14256,70,NULL,NULL,'2MASX J08045501+2342414',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,121.22925,23.71156,0.141,NULL,63768038380,996375599,15568368,17.5),(51816,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51816,38.06,0.33,409,14257,70,NULL,NULL,'2MASX J08045509+3941242',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,121.2294583,39.69008,0.121,NULL,63555565349,993055708,15516495,18.3),(51817,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51817,37.47,0.46,312,14258,70,NULL,NULL,'2MASX J08045515+1840384',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,121.2297917,18.67742,0.053,NULL,63757765138,996215080,15565860,17.4),(51818,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51818,37.1,0.46,263,14259,70,NULL,NULL,'2MASX J08045642+3115342',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000184,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,121.235125,31.2595,0.145,NULL,64345818815,1005403418,15709428,16.3),(51819,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51819,37.23,0.27,280,14260,70,NULL,NULL,'2MASX J08045673+3045522',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000167,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,121.236583,30.76461,0.137,NULL,64345298478,1005395288,15709301,16.5),(51820,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51820,37.77,0.46,357,14261,70,NULL,NULL,'2MASX J08045683+3247502',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,121.236625,32.79733,0.229,NULL,64328870040,1005138594,15705290,17.9),(51821,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51821,36.88,0.46,237,14262,70,NULL,NULL,'2MASX J08045744+2901338',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000155,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,121.239333333,29.02592,0.153,NULL,64301591288,1004712363,15698630,16.9),(51822,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51822,37.81,0.33,365,14263,70,NULL,NULL,'2MASX J08045786+3723152',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000188,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,121.241083,37.38753,0.181,NULL,63437462968,991210358,15487661,17.1),(51823,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51823,37.99,0.33,397,14264,70,NULL,NULL,'2MASX J08045869+3617352',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,121.244625,36.293,0.169,NULL,63448387561,991381055,15490328,18),(51824,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51824,37.73,0.46,351,14265,70,NULL,NULL,'2MASX J08050036+0644560',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00018,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,121.2515,6.74894,0.033,NULL,62807503692,981367245,15333863,18.1),(51825,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51825,37.36,0.46,296,14266,70,NULL,NULL,'2MASX J08050203+4135491',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,121.258458333,41.59692,0.157,NULL,63553948051,993030438,15516100,17.6),(51826,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51826,38.06,0.33,409,14267,70,NULL,NULL,'2MASX J08050461+3938091',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000181,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,121.269125,39.63597,0.121,NULL,63555563401,993055678,15516494,17.5),(51827,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51827,38.12,0.46,420,14268,70,NULL,NULL,'2MASX J08050484+2457215',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000186,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,121.2702917,24.95597,0.069,NULL,64304997479,1004765585,15699462,17.2),(51828,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51828,34.5,0.49,79.3,14269,75,NULL,'IR','UGC 04210',NULL,'2011yCatp016004901K',2011,1,1.54,NULL,'G',0.000033,NULL,'15.4g',0.25,'Scd:',NULL,NULL,NULL,NULL,1,121.2725,25.06258,0.069,NULL,64304991773,1004765496,15699460,15.4),(51829,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51829,38.24,0.46,444,14270,70,NULL,NULL,'SDSS J080505.88+374414.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000143,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,121.2745,37.7375,0.173,NULL,63437872970,991216765,15487761,18.5),(51830,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 2000ce',NULL,51830,34.03,0.15,62.9,14271,74.2,NULL,'SALT 2','UGC 04195',0.01631,'2010ApJ...716..712A',2010,1,1.8,NULL,'G',0.000037,NULL,'14.40',0.9,'SB(r)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,121.278625,66.78292,0.169,NULL,62166365363,971349458,15177335,14.4),(51831,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 2000ce',NULL,51831,34.14,0.09,66.2,14271,72,NULL,NULL,'UGC 04195',0.01631,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51832,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 2000ce',NULL,51832,34.17,0.04,67.1,14271,72,NULL,NULL,'UGC 04195',0.01631,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51833,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 2000ce',NULL,51833,34.2,0.09,69,14271,72,NULL,'M(H) = -18.317 mag','UGC 04195',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51834,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 2000ce',NULL,51834,34.21,0.17,69.5,14271,70.8,NULL,NULL,'UGC 04195',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51835,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 2000ce',NULL,51835,34.28,0.12,70.6,14271,72,NULL,NULL,'UGC 04195',0.01631,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51836,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 2000ce',NULL,51836,34.38,0.18,72.6,14271,65,NULL,'MLCS2k2','UGC 04195',0.01631,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51837,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 2000ce',NULL,51837,34.35,0.04,72.9,14271,72,NULL,NULL,'UGC 04195',0.01631,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51838,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 2000ce',NULL,51838,34.32,0.14,73.1,14271,65,NULL,'LC','UGC 04195',NULL,'2001AJ....122.1616K',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51839,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 2000ce',NULL,51839,34.4,0.08,75.9,14271,74.4,NULL,NULL,'UGC 04195',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51840,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 2000ce',NULL,51840,34.45,0.28,76.4,14271,72,NULL,NULL,'UGC 04195',0.01631,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51841,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 2000ce',NULL,51841,34.47,0.23,77.1,14271,65,NULL,NULL,'UGC 04195',0.01631,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51842,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 2000ce',NULL,51842,34.69,0.22,86.7,14271,65,NULL,'MLCS','UGC 04195',NULL,'2001AJ....122.1616K',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51843,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 2000ce',NULL,51843,34.84,0.14,92.9,14271,60,NULL,NULL,'UGC 04195',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51844,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 2000ce',NULL,51844,34.9,0.21,93.8,14271,65,NULL,'MLCS17','UGC 04195',0.01631,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51845,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 2000ce',NULL,51845,35.08,0.24,102,14271,65,NULL,'SALT2','UGC 04195',0.01631,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51846,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 2000ce',NULL,51846,35.1,0.14,103,14271,70,NULL,'SALT','UGC 04195',0.01631,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51847,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51847,34.4,0.08,75.9,14271,74.4,NULL,NULL,'UGC 04195',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51848,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51848,34.4,0.4,75.9,14271,NULL,NULL,'mean','UGC 04195',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51849,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51849,34.47,0.47,78.2,14271,NULL,NULL,'H','UGC 04195',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51850,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51850,34.53,0.45,80.5,14271,NULL,NULL,'K','UGC 04195',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51851,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51851,34.53,0.46,80.6,14271,NULL,NULL,'J','UGC 04195',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51852,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51852,34.62,0.43,84.1,14271,75,NULL,'3.6 micron, color corrected','UGC 04195',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51853,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51853,34.74,0.43,88.7,14271,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04195',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51854,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51854,38.2,0.27,437,14272,70,NULL,NULL,'2MASX J08050752+1656469',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000209,NULL,'16.5g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,121.281208333,16.94639,0.049,NULL,62667646518,979181976,15299718,16.5),(51855,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51855,37.29,0.46,287,14273,70,NULL,NULL,'2MASX J08050764+3447341',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000169,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,121.281875,34.79275,0.217,NULL,64330540057,1005164688,15705698,16.6),(51856,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51856,37.81,0.33,365,14274,70,NULL,NULL,'IC 2221',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000192,NULL,'16.1g',0.4,'E0',NULL,NULL,NULL,NULL,1,121.283125,37.45064,0.181,NULL,63437416901,991209639,15487650,16.1),(51857,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51857,35.73,0.49,140,14275,70,NULL,NULL,'ESO 089- G 009',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00015,NULL,'14.6b',1.1,'SAB(s)0^0^',NULL,NULL,NULL,NULL,1,121.2874583,-67.58669,0.657,NULL,40643185225,635049769,9922652,14.6),(51858,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51858,37.82,0.23,366,14276,70,NULL,NULL,'2MASX J08051163+3625501',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,121.2985,36.43061,0.169,NULL,63436913984,991201781,15487527,18),(51859,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51859,39.01,0.46,634,14277,70,NULL,NULL,'2MASX J08051238+0631570',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,121.301541667,6.53247,0.049,NULL,62807554381,981368037,15333875,18),(51860,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51860,37.89,0.27,379,14278,70,NULL,NULL,'2MASX J08051356+2549116',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000168,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,121.3065417,25.81994,0.041,NULL,64305917719,1004779964,15699686,18),(51861,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51861,35.57,0.46,130,14279,70,NULL,NULL,'2MASX J08051386+4619540',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000082,NULL,'15.9g',0.39,'S0',NULL,NULL,NULL,NULL,1,121.307791667,46.33167,0.141,NULL,63529464873,992647888,15510123,15.9),(51862,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51862,38.29,0.33,454,14280,70,NULL,NULL,'SDSS J080516.77+165005.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00013,NULL,'18.7g',0.09,NULL,NULL,NULL,NULL,NULL,1,121.319875,16.83481,0.049,NULL,62650591523,978915492,15295554,18.7),(51863,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51863,36.58,0.46,207,14281,70,NULL,NULL,'2MASX J08051695+4424020',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000135,NULL,'15.8g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,121.320708333,44.40064,0.153,NULL,63528390815,992631106,15509861,15.8),(51864,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51864,37.04,0.33,255,14282,70,NULL,NULL,'2MASX J08051973+1510447',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000168,NULL,'16.0g',0.42,NULL,NULL,NULL,NULL,NULL,1,121.3322083,15.17908,0.049,NULL,62658855251,979044613,15297572,16),(51865,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51865,38.29,0.33,454,14283,70,NULL,NULL,'2MASX J08052024+1647437',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000184,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,121.33425,16.79536,0.049,NULL,62650593406,978915521,15295555,17.8),(51866,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51866,37.31,0.33,290,14284,70,NULL,NULL,'2MASX J08052112+3307090',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,121.337875,33.11914,0.257,NULL,64328711782,1005136121,15705251,17.8),(51867,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51867,37.04,0.46,256,14285,70,NULL,NULL,'2MASX J08052112+3920151',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,121.3380417,39.33769,0.153,NULL,63434919165,991170611,15487040,17.5),(51868,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51868,37.41,0.46,304,14286,70,NULL,NULL,'2MASX J08052243+3236260',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,121.3434583,32.60725,0.213,NULL,64328384970,1005131015,15705172,17.5),(51869,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51869,38.7,0.46,549,14287,70,NULL,NULL,'SDSS J080522.97+263711.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,121.345708333,26.61975,0.081,NULL,64306509743,1004789214,15699831,18.7),(51870,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51870,36.89,0.23,239,14288,70,NULL,NULL,'2MASX J08052341+2410066',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000172,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,121.3475417,24.16853,0.133,NULL,63767266617,996363540,15568180,17.6),(51871,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51871,35.8,0.46,145,14289,70,NULL,NULL,'2MASX J08052422+1040103',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,121.350916667,10.66939,0.053,NULL,62804726302,981323848,15333185,16.4),(51872,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51872,37.31,0.33,290,14290,70,NULL,NULL,'2MASX J08052724+3311350',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000179,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,121.3634583,33.19303,0.257,NULL,64328702670,1005135979,15705249,17.2),(51873,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51873,37.26,0.46,283,14291,70,NULL,NULL,'2MASX J08052756+2734556',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000145,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,121.3647917,27.582,0.085,NULL,64303673212,1004744893,15699138,17.5),(51874,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51874,32.01,NULL,25.2,14292,NULL,NULL,'Dipole','ESO 494- G 021',NULL,'2010Ap&SS.325..163P',2010,1,2.18,NULL,'G',0.000013,NULL,'16.38',0.2,'Sd',NULL,NULL,NULL,NULL,1,121.37125,-22.925,NULL,NULL,42227611275,659806426,10309475,16.38),(51875,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51875,32.03,NULL,25.5,14292,NULL,NULL,'Dipole + Quadrupole','ESO 494- G 021',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51876,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51876,32.03,NULL,25.5,14292,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 494- G 021',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51877,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51877,32.82,0.43,36.6,14292,75,NULL,'3.6 micron, color + selection bias corrected','ESO 494- G 021',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51878,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51878,37.73,0.46,351,14293,70,NULL,NULL,'SDSS J080529.12+335902.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000165,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,121.371333,33.98406,0.229,NULL,64331596015,1005181187,15705956,18.3),(51879,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51879,37.58,0.46,329,14294,70,NULL,NULL,'2MASX J08052980+3702012',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,121.3742917,37.03367,0.181,NULL,63437774031,991215219,15487737,17.9),(51880,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51880,36.89,0.23,239,14295,70,NULL,NULL,'2MASX J08052991+2410046',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000186,NULL,'16.6g',0.27,'AGN',NULL,NULL,NULL,NULL,1,121.3745,24.16789,0.133,NULL,63767268473,996363569,15568180,16.6),(51881,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51881,36.46,0.46,196,14296,70,NULL,NULL,'2MASX J08053008+3936392',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000167,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,121.375166667,39.61103,0.121,NULL,63552671773,993010496,15515789,17.1),(51882,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51882,38.08,0.16,412,14297,70,NULL,NULL,'2MASX J08053009+1614287',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,121.375333,16.24139,0.053,NULL,62652140040,978939688,15295932,17),(51883,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51883,35.76,NULL,142,14298,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0710',NULL,'2010Ap&SS.325..163P',2010,1,1.11,NULL,'G',0.000209,NULL,'16.5g',0.17,'Sd(f)',NULL,NULL,NULL,NULL,1,121.382667,39.54628,0.121,NULL,63552630687,993009854,15515778,16.5),(51884,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51884,35.77,0.49,142,14298,75,NULL,'IR','FGC 0710',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51885,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51885,35.78,NULL,143,14298,NULL,NULL,'Dipole + Quadrupole','FGC 0710',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51886,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51886,35.8,NULL,145,14298,NULL,NULL,NULL,'FGC 0710',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51887,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51887,35.8,NULL,145,14298,NULL,NULL,'Dipole','FGC 0710',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51888,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51888,38.77,0.46,567,14299,70,NULL,NULL,'SDSS J080535.00+105917.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,121.395833,10.98819,0.005,NULL,62784851532,981013305,15328332,18.7),(51889,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51889,36.89,0.23,239,14300,70,NULL,NULL,'3C 192',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00004,NULL,'16.3g',0.36,'BrClG;NLRG;Sy2;HEG',NULL,NULL,'FR II','Sy 2',1,121.395833,24.16397,0.133,NULL,63767267681,996363557,15568180,16.3),(51890,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51890,37.82,0.23,366,14301,70,NULL,NULL,'2MASX J08053758+3623541',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000197,NULL,'16.2g',0.41,'E0',NULL,NULL,NULL,NULL,1,121.4065417,36.39831,0.169,NULL,63436973130,991202705,15487542,16.2),(51891,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51891,36.17,0.46,171,14302,70,NULL,NULL,'2MASX J08053767+2452058',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000165,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,121.407041667,24.86842,0.085,NULL,64296626338,1004634786,15697418,16.7),(51892,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51892,37.94,0.46,388,14303,70,NULL,NULL,'SDSS J080537.74+094004.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,121.40725,9.66797,0.053,NULL,62804128100,981314501,15333039,18.2),(51893,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51893,30.93,0.37,15.3,14304,NULL,NULL,NULL,'NGC 2525',NULL,'2009AJ....138..323T',2009,1,2.9,NULL,'G',0.000017,NULL,'12.26',1.9,'SB(s)c         HII',NULL,NULL,NULL,NULL,1,121.4085,-11.42703,0.373,NULL,39418763749,615918183,9623721,12.26),(51894,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51894,30.92,0.4,15.3,14304,73,NULL,'opt','NGC 2525',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51895,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51895,31.12,0.2,16.8,14304,74.4,NULL,NULL,'NGC 2525',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51896,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51896,31.27,0.45,18,14304,NULL,NULL,'K','NGC 2525',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51897,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51897,31.28,0.45,18,14304,NULL,NULL,NULL,'NGC 2525',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51898,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51898,31.31,0.46,18.3,14304,NULL,NULL,'J','NGC 2525',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51899,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51899,31.34,0.47,18.5,14304,NULL,NULL,'H','NGC 2525',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51900,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51900,31.46,0.42,19.6,14304,NULL,NULL,'Malmquist cor.','NGC 2525',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51901,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51901,31.62,0.4,21.1,14304,75,NULL,'B','NGC 2525',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51902,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51902,31.71,0.4,21.9,14304,NULL,NULL,'mean','NGC 2525',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51903,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51903,38.49,0.46,500,14305,70,NULL,NULL,'2MASX J08053871+2438478',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,121.411333,24.64658,0.089,NULL,64296640676,1004635010,15697422,18.1),(51904,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51904,37.04,0.46,256,14306,70,NULL,NULL,'2MASX J08053896+2313306',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00016,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,121.41225,23.22528,0.121,NULL,63767745501,996371023,15568297,16.6),(51905,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51905,38.08,0.16,412,14307,70,NULL,NULL,'2MASX J08053898+1613466',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000174,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,121.4125,16.2295,0.053,NULL,62652151027,978939859,15295935,17.8),(51906,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51906,38.06,0.33,409,14308,70,NULL,NULL,'SDSS J080539.13+500757.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000155,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,121.413083,50.13269,0.137,NULL,63549596267,992962441,15515038,18.6),(51907,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51907,37.87,0.46,376,14309,70,NULL,NULL,'SDSS J080540.24+503506.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,121.417667,50.58517,0.145,NULL,63545188165,992893565,15513961,18.5),(51908,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51908,36.74,0.46,223,14310,70,NULL,NULL,'2MASX J08054050+4907525',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000183,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,121.41875,49.13131,0.133,NULL,63549463676,992960369,15515005,16.5),(51909,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51909,35.51,0.47,126,14311,70,NULL,NULL,'2MASX J08054157-0949002',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000097,NULL,'15.44',NULL,NULL,NULL,NULL,NULL,NULL,1,121.422917,-9.81689,0.441,NULL,39453471801,616460496,9632195,15.44),(51910,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51910,38.08,0.16,412,14312,70,NULL,NULL,'2MASX J08054311+1613561',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.9g',0.27,'BrClG',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,121.4295417,16.23225,0.053,NULL,62652114995,978939296,15295926,16.9),(51911,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51911,37.37,0.46,298,14313,70,NULL,NULL,'2MASX J08054331+2527108',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,121.430541667,25.45306,0.061,NULL,64305053228,1004766456,15699475,16.7),(51912,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51912,38.08,0.16,412,14314,70,NULL,NULL,'2MASX J08054484+1614051',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000133,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,121.436791667,16.23481,0.053,NULL,62652115098,978939298,15295926,18.4),(51913,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51913,39.12,0.46,668,14315,70,NULL,NULL,'2MASX J08054506+1530501',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,121.437833333,15.514,0.041,NULL,62652319615,978942493,15295976,17.6),(51914,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51914,38.08,0.16,412,14316,70,NULL,NULL,'2MASX J08054839+1614391',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000171,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,121.451625,16.24414,0.053,NULL,62652117499,978939335,15295927,17.5),(51915,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51915,38.08,0.16,412,14317,70,NULL,NULL,'SDSS J080548.76+161902.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000156,NULL,'18.7g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,121.453208333,16.31739,0.053,NULL,62652105839,978939153,15295924,18.7),(51916,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51916,36.21,0.46,175,14318,70,NULL,NULL,'2MASX J08054903+1225021',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000173,NULL,'16.1g',0.39,NULL,NULL,NULL,NULL,NULL,1,121.454416667,12.41742,0.041,NULL,62655013836,978984591,15296634,16.1),(51917,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51917,36.28,0.46,180,14319,70,NULL,NULL,'IC 2223',NULL,'2015arXiv151105856S',2015,1,0.43,'The identification as IC 2223 is very uncertain.','G',0.000183,NULL,'15.9g',0.39,'S0',NULL,NULL,NULL,NULL,1,121.459625,37.46006,0.161,NULL,63437550237,991211722,15487683,15.9),(51918,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51918,38.08,0.16,412,14320,70,NULL,NULL,'2MASX J08055047+1615381',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000176,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,121.460333333,16.26058,0.053,NULL,62652120848,978939388,15295927,17.4),(51919,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51919,35.03,0.47,102,14321,NULL,NULL,'H','ESO 494- G 024',NULL,'2007A&A...465...71T',2007,1,1.13,'abs(b) < 10 degrees.','G',0.000033,NULL,'14.65',0.57,'Sa:',NULL,NULL,NULL,NULL,1,121.461208333,-25.97997,NULL,NULL,42695479604,667116868,10423701,14.65),(51920,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51920,35.14,0.45,106,14321,NULL,NULL,'K','ESO 494- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51921,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51921,35.2,0.4,110,14321,NULL,NULL,'mean','ESO 494- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51922,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51922,35.22,0.46,111,14321,NULL,NULL,'J','ESO 494- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51923,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51923,37.13,0.46,267,14322,70,NULL,NULL,'2MASX J08055090+5052419',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000195,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,121.461791667,50.87836,0.153,NULL,63545576597,992899634,15514056,16.6),(51924,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51924,37.37,0.46,298,14323,70,NULL,NULL,'2MASX J08055099+0638123',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,121.4622917,6.63664,0.049,NULL,62806680513,981354383,15333662,17.7),(51925,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51925,37.28,0.46,285,14324,70,NULL,NULL,'2MASX J08055096+1414381',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000188,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,121.4622917,14.24392,0.061,NULL,62657500000,979023437,15297241,16.8),(51926,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51926,37.83,0.46,368,14325,70,NULL,NULL,'2MASX J08055124+5347529',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,121.463625,53.79811,0.097,NULL,63510391855,992349872,15505466,17.7),(51927,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51927,36.55,0.46,204,14326,70,NULL,NULL,'2MASX J08055215+2221012',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,121.4675,22.35025,0.161,NULL,63769979177,996405924,15568842,16.2),(51928,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51928,36.89,0.23,239,14327,70,NULL,NULL,'2MASX J08055248+2407058',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,121.468833333,24.11817,0.133,NULL,63767213356,996362708,15568167,16.9),(51929,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51929,37.87,0.46,376,14328,70,NULL,NULL,'2MASX J08055301+1644281',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,121.470916667,16.74114,0.069,NULL,62650608809,978915762,15295558,18.2),(51930,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51930,38.05,0.33,408,14329,70,NULL,NULL,'2MASX J08055330+3804514',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,121.47225,38.08106,0.157,NULL,63438810677,991231416,15487990,18.1),(51931,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51931,37.37,0.46,297,14330,70,NULL,NULL,'2MASX J08055422+4156224',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,121.475791667,41.93958,0.161,NULL,63553737615,993027150,15516049,17.8),(51932,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51932,38.08,0.16,412,14331,70,NULL,NULL,'2MASX J08055427+1629191',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000193,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,121.4762083,16.48861,0.053,NULL,62654017980,978969030,15296391,17.2),(51933,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51933,36.38,0.46,189,14332,70,NULL,NULL,'2MASX J08055591+5322409',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000162,NULL,'16.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,121.4830417,53.37817,0.081,NULL,63510345024,992349141,15505455,16.8),(51934,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51934,38.48,0.16,496,14333,70,NULL,NULL,'2MASX J08055681+1723391',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000184,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,121.48675,17.39417,0.077,NULL,62651251350,978925802,15295715,17.4),(51935,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51935,36.74,0.46,223,14334,70,NULL,NULL,'2MASX J08055797+0813430',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.57',0.24,NULL,NULL,NULL,NULL,NULL,1,121.4914583,8.22864,0.109,NULL,62813858965,981466546,15335414,17.57),(51936,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51936,37.49,0.46,315,14335,70,NULL,NULL,'2MASX J08055827+3832274',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000195,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,121.492958333,38.54106,0.145,NULL,63438502137,991226595,15487915,16.9),(51937,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51937,37.82,0.23,366,14336,70,NULL,NULL,'2MASX J08055849+3630134',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000172,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,121.4937083,36.50378,0.169,NULL,63437005502,991203210,15487550,18),(51938,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51938,37.91,0.46,382,14337,70,NULL,NULL,'2MASX J08055980+2621177',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000143,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,121.499333,26.35481,0.081,NULL,64305473445,1004773022,15699578,18.1),(51939,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51939,37.26,0.46,283,14338,70,NULL,NULL,'2MASX J08060000+2918477',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000172,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,121.5000417,29.31333,0.165,NULL,64301597578,1004712462,15698632,16.7),(51940,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51940,37.89,0.46,378,14339,70,NULL,NULL,'2MASX J08060028+1517321',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,121.501125,15.29231,0.049,NULL,62651487275,978929488,15295773,17.7),(51941,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51941,38.05,0.33,408,14340,70,NULL,NULL,'2MASX J08060084+3801334',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000211,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,121.5035417,38.02597,0.157,NULL,63438740514,991230320,15487973,16.6),(51942,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51942,36.75,0.54,224,14341,70,NULL,NULL,'2MASX J08060141-0723532',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,121.505833,-7.39819,0.493,NULL,39458271316,616535489,9633367,15),(51943,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51943,35.97,0.46,156,14342,70,NULL,NULL,'2MASX J08060137+3957524',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000179,NULL,'16.0g',0.35,'S0',NULL,NULL,NULL,NULL,1,121.505875,39.96461,0.165,NULL,63555601733,993056277,15516504,16),(51944,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51944,37.71,0.46,348,14343,70,NULL,NULL,'SDSS J080602.51+312637.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000113,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,121.5105,31.44378,0.161,NULL,64345630948,1005400483,15709382,18.6),(51945,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51945,37.09,0.33,262,14344,70,NULL,NULL,'2MASX J08060534+2022112',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000197,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,121.5222917,20.36983,0.093,NULL,63761797653,996278088,15566845,16.2),(51946,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51946,37.04,0.33,255,14345,70,NULL,NULL,'2MASX J08060692+1514471',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,121.5289583,15.24628,0.049,NULL,62651444311,978928817,15295762,17.2),(51947,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51947,37,0.46,252,14346,70,NULL,NULL,'2MASX J08060708+3920324',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000218,NULL,'15.9g',0.44,'AGN',NULL,NULL,NULL,NULL,1,121.529625,39.34244,0.153,NULL,63434972791,991171449,15487053,15.9),(51948,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51948,37.84,0.46,370,14347,70,NULL,NULL,'2MASX J08060946+5223279',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,121.539417,52.39111,0.137,NULL,63544215149,992878361,15513724,17.8),(51949,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51949,37.48,0.46,314,14348,70,NULL,NULL,'2MASX J08061010+2021472',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,121.542083,20.36322,0.093,NULL,63761781103,996277829,15566841,17.3),(51950,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51950,37.64,0.46,337,14349,70,NULL,NULL,'2MASX J08061010+4228520',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000076,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,121.542166667,42.48111,0.153,NULL,63520767858,992511997,15507999,17.7),(51951,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51951,37.99,0.46,397,14350,70,NULL,NULL,'2MASX J08061019+4256410',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,121.542208333,42.94486,0.153,NULL,63520863419,992513490,15508023,16.6),(51952,'SNIa','2016-12-15 15:14:19','2016-12-16 11:19:25','1','SN 2006mq',NULL,51952,29.06,0.61,6.46,14351,74.2,NULL,'SALT 2','ESO 494- G 026',0.004,'2010ApJ...716..712A',2010,1,4,'abs(b) < 10 degrees.','G',0.000003,NULL,'12.47',2.78,'SAB(s)b pec:','Pair member (points to parent)',NULL,NULL,NULL,1,121.5462083,-27.52842,NULL,NULL,42694664123,667104126,10423501,12.47),(51953,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51953,29.42,0.69,7.67,14351,100,NULL,'mid-IR','ESO 494- G 026',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51954,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51954,30.43,0.4,12.2,14351,NULL,NULL,'mean','ESO 494- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51955,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51955,30.54,0.46,12.8,14351,NULL,NULL,'J','ESO 494- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51956,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51956,30.59,0.45,13.1,14351,NULL,NULL,'K','ESO 494- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51957,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51957,38.48,0.16,496,14352,70,NULL,NULL,'SDSS J080613.94+172520.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000172,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,121.558083,17.42247,0.121,NULL,62651247977,978925749,15295714,18.7),(51958,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51958,38.07,0.15,411,14353,70,NULL,NULL,'2MASX J08061438+1532151',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000132,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,121.56,15.53758,0.041,NULL,62652334397,978942724,15295980,18),(51959,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51959,36.52,0.61,201,14354,70,NULL,NULL,'2MASX J08061518-0744532',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,121.5632917,-7.74811,0.537,NULL,39459895560,616560868,9633763,15),(51960,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51960,38.48,0.33,498,14355,70,NULL,NULL,'SDSS J080616.99+102812.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,121.570833,10.47008,0.033,NULL,62803727441,981308241,15332941,18.7),(51961,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51961,37.78,0.46,359,14356,70,NULL,NULL,'2MASX J08061842+1557322',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,121.576667,15.95886,0.065,NULL,62652062085,978938470,15295913,18.2),(51962,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51962,38.17,0.46,430,14357,70,NULL,NULL,'2MASX J08061880+2013475',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000175,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,121.578417,20.22989,0.093,NULL,63761778842,996277794,15566840,17.5),(51963,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51963,37.89,0.46,378,14358,70,NULL,NULL,'2MASX J08061892+0715150',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,121.5789583,7.25403,0.089,NULL,62811557198,981430581,15334852,17.5),(51964,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51964,38.16,0.27,429,14359,70,NULL,NULL,'2MASX J08061907+5309508',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,121.5795417,53.16431,0.113,NULL,63543773269,992871457,15513616,17.4),(51965,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51965,38.22,0.46,440,14360,70,NULL,NULL,'2MASX J08061909+4806258',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,121.579583,48.10711,0.141,NULL,63536672705,992760511,15511882,16.7),(51966,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51966,38.15,0.46,426,14361,70,NULL,NULL,'2MASX J08062006+1647472',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000172,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,121.583417,16.79653,0.069,NULL,62650812936,978918952,15295608,18.3),(51967,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51967,38.07,0.15,411,14362,70,NULL,NULL,'2MASX J08062027+1531452',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000177,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,121.584416667,15.52928,0.041,NULL,62652337529,978942773,15295980,16.8),(51968,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51968,38.59,0.46,523,14363,70,NULL,NULL,'2MASX J08062032+1619442',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000149,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,121.584583,16.32914,0.053,NULL,62654089484,978970148,15296408,18.1),(51969,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51969,36.91,0.46,241,14364,70,NULL,NULL,'2MASX J08062044+5101288',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,121.585375,51.02478,0.153,NULL,63545577573,992899649,15514057,17.9),(51970,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51970,38.48,0.33,498,14365,70,NULL,NULL,'2MASX J08062182+1028118',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,121.590917,10.46989,0.033,NULL,62803728020,981308250,15332941,18.1),(51971,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51971,37.4,0.46,302,14366,70,NULL,NULL,'2MASX J08062257+3513209',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,121.5940417,35.22239,0.173,NULL,64330371690,1005162057,15705657,17.8),(51972,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51972,38.28,0.46,454,14367,70,NULL,NULL,'2MASX J08062309+1539492',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,121.5962917,15.66372,0.041,NULL,62652379245,978943425,15295991,17.7),(51973,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51973,38.48,0.16,496,14368,70,NULL,NULL,'2MASX J08062495+1725042',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000191,NULL,'17.3g',0.24,'BrClG',NULL,NULL,NULL,NULL,1,121.603917,17.41769,0.121,NULL,62651290363,978926411,15295725,17.3),(51974,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51974,37.34,0.46,293,14369,70,NULL,NULL,'2MASX J08062694+0941458',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'17.12',0.32,NULL,NULL,NULL,NULL,NULL,1,121.612125,9.69597,0.053,NULL,62804219793,981315934,15333061,17.12),(51975,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51975,38.48,0.16,496,14370,70,NULL,NULL,'2MASX J08062739+1725062',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000161,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,121.614125,17.41833,0.121,NULL,62651273511,978926148,15295721,18.8),(51976,'IRAS','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51976,34.86,0.8,93.7,14371,75,NULL,'CF, r','UGC 04213',NULL,'1997ApJS..109..333W',1997,1,0.95,NULL,'G',0.000093,NULL,'15.3g',0.5,'SA(s)c',NULL,NULL,NULL,NULL,1,121.6142083,50.95481,0.153,NULL,63545110375,992892349,15513942,15.3),(51977,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51977,34.7,0.38,87.2,14371,75,NULL,'CF, r, raw','UGC 04213',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51978,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51978,34.78,0.38,90.5,14371,75,NULL,'CF, r, inv','UGC 04213',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51979,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51979,34.92,0.38,96.2,14371,75,NULL,'CF, r, cor','UGC 04213',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51980,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51980,36.48,0.46,197,14372,70,NULL,NULL,'2MASX J08062778+3610567',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000127,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,121.615875,36.18253,0.169,NULL,63436816264,991200254,15487503,18.2),(51981,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51981,38.48,0.16,496,14373,70,NULL,NULL,'2MASX J08062816+1728342',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000189,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,121.617375,17.47603,0.121,NULL,62650412733,978912698,15295510,17.7),(51982,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51982,35.4,0.46,120,14374,70,NULL,NULL,'2MASX J08062832+2457141',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000155,NULL,'16.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,121.6180417,24.95378,0.085,NULL,64296842673,1004638166,15697471,16.3),(51983,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51983,38.48,0.16,496,14375,70,NULL,NULL,'SDSS J080628.86+172525.6',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000149,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,121.6202917,17.42378,0.121,NULL,62651273696,978926151,15295721,18.8),(51984,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51984,37.88,0.27,377,14376,70,NULL,NULL,'2MASX J08062942+3316484',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,121.6227083,33.28014,0.257,NULL,64331981247,1005187206,15706050,17.7),(51985,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51985,38.48,0.16,496,14377,70,NULL,NULL,'2MASX J08063005+1725412',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000151,NULL,'17.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,121.6252083,17.42803,0.121,NULL,62651276986,978926202,15295721,17.5),(51986,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51986,34.89,0.46,94.8,14378,70,NULL,NULL,'CGCG 148-113',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000103,NULL,'15.0g',0.54,'S0^-',NULL,NULL,NULL,NULL,1,121.62575,26.89892,0.077,NULL,64306302796,1004785981,15699780,15),(51987,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51987,37.75,0.46,355,14379,70,NULL,NULL,'2MASX J08063313+1710562',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,121.638333333,17.18225,0.137,NULL,62651266954,978926046,15295719,18.2),(51988,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51988,38.48,0.16,496,14380,70,NULL,NULL,'2MASX J08063438+1726352',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000172,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,121.643416667,17.44322,0.121,NULL,62651275638,978926181,15295721,17.2),(51989,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51989,37.97,0.21,393,14381,70,NULL,NULL,'SDSS J080634.43+160751.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.00015,NULL,'18.8g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,121.6435,16.13086,0.081,NULL,62652083922,978938811,15295918,18.8),(51990,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51990,38.14,0.46,424,14382,70,NULL,NULL,'2MASX J08063449+2547596',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,121.643875,25.79975,0.089,NULL,64305369171,1004771393,15699553,18),(51991,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51991,38.06,0.33,409,14383,70,NULL,NULL,'SDSS J080635.86+501115.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000125,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,121.6494583,50.18756,0.137,NULL,63549589128,992962330,15515036,18.4),(51992,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51992,37.26,0.46,283,14384,70,NULL,NULL,'SDSS J080636.46+252712.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,121.651917,25.45361,0.061,NULL,64296723514,1004636304,15697442,18.2),(51993,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51993,37.37,0.46,298,14385,70,NULL,NULL,'2MASX J08063698+5533325',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000191,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,121.653875,55.55908,0.113,NULL,61597521661,962461275,15038457,16.5),(51994,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51994,36.77,0.46,226,14386,70,NULL,NULL,'2MASX J08063857+4623474',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000077,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,121.6605,46.39647,0.141,NULL,63530006388,992656349,15510255,16.9),(51995,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51995,34.36,0.49,74.4,14387,75,NULL,'IR','UGC 04206',NULL,'2011yCatp016004901K',2011,1,2.04,NULL,'G',0.000027,NULL,'16.0',0.24,'Sbc',NULL,NULL,NULL,NULL,1,121.661083,67.04825,0.149,NULL,62166144074,971346001,15177281,16),(51996,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,51996,35.9,0.56,151,14388,70,NULL,NULL,'2MASX J08063887-0741047',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.95',NULL,NULL,NULL,NULL,NULL,NULL,1,121.662,-7.68478,0.537,NULL,39459030082,616547345,9633552,16.95),(51997,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51997,38.37,0.46,473,14389,70,NULL,NULL,'2MASXi J0806394+475118',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000086,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,121.66425,47.85508,0.133,NULL,63536881834,992763778,15511934,18.3),(51998,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51998,37.97,0.21,393,14390,70,NULL,NULL,'2MASX J08064075+1604204',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000174,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,121.6697917,16.07236,0.081,NULL,62652028750,978937949,15295905,16.8),(51999,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',51999,37.82,0.33,367,14391,70,NULL,NULL,'2MASX J08064088+0638009',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,121.6702917,6.63356,0.049,NULL,62810910036,981420469,15334694,18.3),(52000,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52000,37.88,0.27,377,14392,70,NULL,NULL,'SDSS J080642.02+331212.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000153,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,121.675083333,33.20336,0.257,NULL,64331985374,1005187271,15706051,18.3),(52001,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52001,35.77,0.2,143,14393,74.4,NULL,NULL,'UGC 04219',NULL,'2013AJ....146...86T',2013,1,1.07,NULL,'G',0.000037,NULL,'15.0g',0.88,'SA(rs)b',NULL,NULL,NULL,NULL,1,121.6782917,39.09022,0.153,NULL,63435158652,991174353,15487099,15),(52002,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52002,36.83,0.46,233,14394,70,NULL,NULL,'2MASX J08064309+0753519',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,121.679625,7.89786,0.085,NULL,62813725703,981464464,15335382,17.2),(52003,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52003,38.07,0.15,411,14395,70,NULL,NULL,'2MASX J08064337+1526094',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,121.6809583,15.43603,0.041,NULL,62652310072,978942344,15295974,17.5),(52004,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52004,38.07,0.15,411,14396,70,NULL,NULL,'2MASX J08064386+1532464',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000146,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,121.682917,15.54619,0.065,NULL,62652316398,978942443,15295975,17.8),(52005,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52005,38.54,0.46,510,14397,70,NULL,NULL,'2MASX J08064496+4956354',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000149,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,121.687375,49.94331,0.125,NULL,63549673411,992963647,15515056,17.6),(52006,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52006,38.63,0.46,532,14398,70,NULL,NULL,'2MASX J08064525+1545474',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,121.688583,15.76325,0.065,NULL,62652197107,978940579,15295946,17.4),(52007,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52007,38.1,0.46,417,14399,70,NULL,NULL,'2MASX J08064605+2451136',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000149,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,121.691916667,24.85381,0.085,NULL,64296824966,1004637890,15697467,18.6),(52008,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52008,37.38,0.33,299,14400,70,NULL,NULL,'2MASX J08064705+5156484',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,121.695916667,51.94681,0.173,NULL,63547630814,992931731,15514558,17.4),(52009,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52009,37.97,0.46,392,14401,70,NULL,NULL,'2MASX J08064743+5426335',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000152,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,121.697625,54.44261,0.101,NULL,61593535217,962398987,15037484,17.7),(52010,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52010,34.8,0.46,91.4,14402,70,NULL,NULL,'CGCG 088-032',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000083,NULL,'14.6g',0.43,NULL,NULL,NULL,NULL,NULL,1,121.717125,18.73778,0.101,NULL,63757722768,996214418,15565850,14.6),(52011,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52011,36.37,0.46,188,14403,70,NULL,NULL,'2MASX J08065222+4319245',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000078,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,121.717791667,43.32353,0.157,NULL,63532288909,992692014,15510812,16.6),(52012,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52012,36.12,0.27,167,14404,70,NULL,NULL,'CGCG 088-033',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.0002,NULL,'15.4',0.6,NULL,NULL,NULL,NULL,NULL,1,121.7199583,19.84414,0.077,NULL,63761473685,996273026,15566766,15.4),(52013,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52013,36.61,0.46,210,14405,70,NULL,NULL,'2MASX J08065323+5201134',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000184,NULL,'16.3g',0.33,'E0',NULL,NULL,NULL,NULL,1,121.721833,52.02044,0.173,NULL,63547598127,992931220,15514550,16.3),(52014,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52014,38.15,0.46,426,14406,70,NULL,NULL,'2MASX J08065442+5238234',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000175,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,121.726833333,52.63978,0.133,NULL,63544140986,992877202,15513706,17.3),(52015,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52015,37.79,0.46,361,14407,70,NULL,NULL,'SDSS J080655.86+321120.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000116,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,121.7327917,32.18897,0.229,NULL,64328335686,1005130245,15705160,18.5),(52016,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52016,36.49,0.46,199,14408,70,NULL,NULL,'2MASX J08065640+3754197',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,121.734917,37.90558,0.157,NULL,63438235692,991222432,15487850,16.9),(52017,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52017,38.16,0.27,429,14409,70,NULL,NULL,'2MASX J08065682+5303004',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,121.736708333,53.05,0.109,NULL,63544637153,992884955,15513827,17.7),(52018,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52018,38.68,0.46,544,14410,70,NULL,NULL,'2MASX J08065681+3817087',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,121.73675,38.28567,0.145,NULL,63438625312,991228520,15487945,18.3),(52019,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52019,37.3,0.46,288,14411,70,NULL,NULL,'2MASX J08065758+3934187',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000194,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,121.7399583,39.57194,0.165,NULL,63552641247,993010019,15515781,16.4),(52020,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52020,35.64,0.46,134,14412,70,NULL,NULL,'CGCG 262-072',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000077,NULL,'15.3g',0.52,'E','Isolated galaxy',NULL,NULL,NULL,1,121.740167,55.90306,0.117,NULL,61596682491,962448163,15038252,15.3),(52021,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52021,38.07,0.15,411,14413,70,NULL,NULL,'2MASX J08065783+1524384',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000156,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,121.740917,15.41067,0.053,NULL,62651797850,978934341,15295849,16.7),(52022,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52022,37.69,0.46,345,14414,70,NULL,NULL,'2MASX J08065780+0814208',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,121.741,8.23911,0.073,NULL,62813777459,981465272,15335394,17.2),(52023,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52023,37.97,0.21,393,14415,70,NULL,NULL,'2MASX J08065817+1608084',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,121.742417,16.13572,0.081,NULL,62654065125,978969767,15296402,17.1),(52024,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52024,34.26,0.4,71,14416,NULL,NULL,'mean','NGC 2526',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.00003,NULL,'14.70',0.5,'S?','Pair member (points to parent)',NULL,NULL,NULL,1,121.7442917,8.00394,0.085,NULL,62812933694,981452088,15335188,14.7),(52025,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52025,34.64,0.47,84.7,14416,NULL,NULL,'H','NGC 2526',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52026,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52026,34.72,0.45,87.8,14416,NULL,NULL,'K','NGC 2526',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52027,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52027,34.76,0.46,89.7,14416,NULL,NULL,'J','NGC 2526',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52028,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52028,36.12,0.27,167,14417,70,NULL,NULL,'2MASX J08065912+1951055',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000187,NULL,'15.5g',0.52,'AGN',NULL,NULL,NULL,NULL,1,121.746375,19.85167,0.077,NULL,63761441601,996272525,15566758,15.5),(52029,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52029,38.22,0.27,442,14418,70,NULL,NULL,'2MASX J08065930+0916558',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,121.7470417,9.28208,0.077,NULL,62804060842,981313450,15333022,17.1),(52030,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52030,37.88,0.27,377,14419,70,NULL,NULL,'2MASX J08065947+3313364',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000182,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,121.74775,33.22675,0.257,NULL,64332034269,1005188035,15706063,17.4),(52031,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52031,37.96,0.46,391,14420,70,NULL,NULL,'2MASX J08070197+0649428',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,121.758333,6.82878,0.073,NULL,62810929368,981420771,15334699,18.2),(52032,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52032,36.12,0.27,167,14421,70,NULL,NULL,'2MASX J08070252+1943076',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000169,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,121.7605,19.71889,0.077,NULL,63758006688,996218854,15565919,16.6),(52033,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52033,37.46,0.46,310,14422,70,NULL,NULL,'2MASX J08070286+1702303',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,121.7617917,17.04172,0.137,NULL,62651141340,978924083,15295688,17.2),(52034,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52034,37.22,0.46,277,14423,70,NULL,NULL,'2MASX J08070277+5315073',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000174,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,121.761875,53.252,0.105,NULL,63543826400,992872287,15513629,17.2),(52035,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52035,37.09,0.33,262,14424,70,NULL,NULL,'2MASX J08070427+2015196',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00018,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,121.767958333,20.2555,0.093,NULL,63761370798,996271418,15566740,17),(52036,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52036,38.47,0.46,493,14425,70,NULL,NULL,'SDSS J080706.70+262149.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000147,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,121.7779583,26.36383,0.081,NULL,64305288668,1004770135,15699533,18.8),(52037,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52037,36.61,0.19,210,14426,70,NULL,NULL,'2MASX J08070720+3857061',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,121.780083,38.95178,0.189,NULL,63435030059,991172344,15487067,16.9),(52038,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52038,36.71,0.46,220,14427,70,NULL,NULL,'2MASX J08070786+1720323',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000194,NULL,'16.3g',0.23,'BrClG',NULL,NULL,NULL,NULL,1,121.782875,17.34231,0.121,NULL,62651317025,978926828,15295731,16.3),(52039,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52039,30.29,0.46,11.4,14428,NULL,NULL,'J','ESO 430- G 020',NULL,'2007A&A...465...71T',2007,1,1.9,'MCG position is -0.6 minutes and +9 arcmin in error.','G',0.000007,NULL,'13.8',0.78,'SAB(s)d?',NULL,NULL,NULL,NULL,1,121.785625,-28.05244,NULL,NULL,42694724417,667105069,10423516,13.8),(52040,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52040,30.31,0.47,11.5,14428,NULL,NULL,'H','ESO 430- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52041,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52041,30.4,0.45,12,14428,NULL,NULL,'K','ESO 430- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52042,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52042,30.98,0.4,15.7,14428,NULL,NULL,'mean','ESO 430- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52043,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52043,37.61,0.46,332,14429,70,NULL,NULL,'2MASX J08070856+1808066',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000217,NULL,'16.0g',0.39,NULL,NULL,NULL,NULL,NULL,1,121.785667,18.13528,0.101,NULL,63778640980,996541265,15570957,16),(52044,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52044,37.53,0.46,320,14430,70,NULL,NULL,'2MASX J08070879+2906035',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000122,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,121.78675,29.10108,0.173,NULL,64301736488,1004714632,15698666,18.2),(52045,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52045,38.22,0.27,442,14431,70,NULL,NULL,'2MASX J08070889+0912549',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,121.7872083,9.21536,0.077,NULL,62804013450,981312710,15333011,17),(52046,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52046,37.01,0.46,252,14432,70,NULL,NULL,'2MASX J08070903+1747592',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000181,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,121.7875417,17.79989,0.113,NULL,62650533335,978914583,15295540,16.3),(52047,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52047,31.11,0.4,16.7,14433,75,NULL,'B','UGC 04173',NULL,'1988NBGC.C....0000T',1988,1,1.9,'Noted in MCG as possibly interacting.','G',0.000003,NULL,'15.3',0.6,'Im:',NULL,NULL,NULL,NULL,1,121.800417,80.125,0.097,NULL,61448839034,960138109,15002157,15.3),(52048,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52048,37.55,0.33,324,14434,70,NULL,NULL,'2MASX J08071283+1415582',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,121.803583333,14.26619,0.061,NULL,62659124737,979048824,15297637,17.5),(52049,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52049,38.07,0.15,411,14435,70,NULL,NULL,'SDSS J080714.62+152700.2',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000172,NULL,'16.8g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,121.810958333,15.45008,0.053,NULL,62651807268,978934488,15295851,16.8),(52050,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52050,38.22,0.27,442,14436,70,NULL,NULL,'SDSS J080715.18+090829.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,121.8132917,9.14144,0.077,NULL,62812199307,981440614,15335009,18.3),(52051,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52051,37.85,0.46,371,14437,70,NULL,NULL,'2MASX J08071553+2826176',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000134,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,121.814625,28.43831,0.133,NULL,64300909632,1004701713,15698464,17.6),(52052,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52052,37.54,0.46,322,14438,70,NULL,NULL,'2MASX J08071648+5004219',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000194,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,121.818708333,50.07289,0.137,NULL,63549724267,992964441,15515069,17.4),(52053,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52053,36.15,0.33,170,14439,70,NULL,NULL,'CGCG 088-035',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000153,NULL,'14.6g',0.76,'AGN',NULL,NULL,NULL,NULL,1,121.819125,14.95092,0.061,NULL,62659597985,979056218,15297753,14.6),(52054,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52054,38.33,0.46,463,14440,70,NULL,NULL,'SDSS J080717.14+525529.2',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,121.8214583,52.92481,0.109,NULL,63544684469,992885694,15513838,18.2),(52055,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52055,35.32,0.49,116,14441,75,NULL,'IR','UGC 04233',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000153,NULL,'15.1',0.2,'S',NULL,NULL,NULL,NULL,1,121.8219583,8.86914,0.057,NULL,62812240939,981441264,15335019,15.1),(52056,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52056,35.43,0.35,122,14441,NULL,NULL,NULL,'UGC 04233',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52057,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52057,35.47,0.35,124,14441,NULL,NULL,'Malmquist cor.','UGC 04233',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52058,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52058,35.53,0.2,128,14441,74.4,NULL,NULL,'UGC 04233',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52059,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52059,38.07,0.15,411,14442,70,NULL,NULL,'SDSS J080717.69+152845.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000128,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,121.8237083,15.47942,0.053,NULL,62651802643,978934416,15295850,18.3),(52060,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52060,37.81,0.33,364,14443,70,NULL,NULL,'2MASX J08071804+3106274',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000198,NULL,'16.4g',0.4,'AGN',NULL,NULL,NULL,NULL,1,121.825166667,31.10769,0.185,NULL,64348633724,1005447401,15710115,16.4),(52061,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52061,37.88,0.23,377,14444,70,NULL,NULL,'2MASX J08071902+5325149',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'18.1g',0.1,NULL,NULL,NULL,NULL,NULL,1,121.829417,53.42097,0.097,NULL,63543819381,992872177,15513627,18.1),(52062,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52062,38.07,0.15,411,14445,70,NULL,NULL,'2MASX J08071961+1527072',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,121.8317083,15.45217,0.053,NULL,62651803425,978934428,15295850,18),(52063,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52063,34.52,0.46,80,14446,70,NULL,NULL,'NGC 2518',NULL,'2015arXiv151105856S',2015,1,1.21,'NGC 2519 is a Galactic star.','G',0.0001,NULL,'13.9g',0.95,'S0-:',NULL,NULL,NULL,NULL,1,121.834375,51.13161,0.149,NULL,63545095893,992892123,15513939,13.9),(52064,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52064,37.97,0.21,393,14447,70,NULL,NULL,'SDSS J080720.29+155713.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,121.834583,15.95369,0.065,NULL,62653595652,978962432,15296288,18.4),(52065,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52065,36.56,0.46,205,14448,70,NULL,NULL,'2MASX J08072063+3034394',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,121.835875,30.57756,0.113,NULL,64348736831,1005449012,15710140,17.5),(52066,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52066,35.47,0.42,124,14449,NULL,NULL,'Malmquist cor.','UGC 04226',NULL,'2009ApJS..182..474S',2009,1,1.26,NULL,'G',0.00002,NULL,'14.9g',0.78,'SA(r)cd',NULL,NULL,NULL,NULL,1,121.83925,40.39822,0.173,NULL,63552425501,993006648,15515728,14.9),(52067,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52067,35.7,0.2,138,14449,74.4,NULL,NULL,'UGC 04226',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52068,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52068,35.73,0.38,140,14449,NULL,NULL,NULL,'UGC 04226',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52069,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52069,37.38,0.33,299,14450,70,NULL,NULL,'2MASX J08072151+5154569',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000178,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,121.839458333,51.91564,0.137,NULL,63547576599,992930884,15514545,16.8),(52070,'IRAS','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52070,34.31,0.8,72.8,14451,75,NULL,'CF, r','UGC 04232',NULL,'1997ApJS..109..333W',1997,1,1.31,NULL,'G',0.000012,NULL,'15.5g',0.32,'Sbc',NULL,NULL,NULL,NULL,1,121.840791667,17.75197,0.113,NULL,62650467526,978913555,15295524,15.5),(52071,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52071,33.11,0.2,41.9,14451,74.4,NULL,NULL,'UGC 04232',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52072,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52072,33.38,0.38,47.5,14451,75,NULL,'CF, r, inv','UGC 04232',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52073,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52073,33.41,0.38,48.1,14451,75,NULL,'CF, r, raw','UGC 04232',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52074,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52074,33.85,0.38,59,14451,75,NULL,'CF, r, cor','UGC 04232',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52075,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52075,34.31,0.09,72.9,14451,NULL,NULL,NULL,'UGC 04232',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52076,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52076,37.6,0.46,332,14452,70,NULL,NULL,'2MASX J08072236+2623526',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,121.843167,26.39783,0.081,NULL,64305244957,1004769452,15699522,17.7),(52077,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52077,37.55,0.33,324,14453,70,NULL,NULL,'2MASX J08072343+1419082',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,121.8477083,14.31892,0.057,NULL,62659145425,979049147,15297642,17.4),(52078,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52078,36.61,0.19,210,14454,70,NULL,NULL,'2MASX J08072366+3901562',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000176,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,121.848791667,39.03233,0.189,NULL,63435149939,991174217,15487097,16.5),(52079,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52079,38.18,0.46,433,14455,70,NULL,NULL,'SDSS J080724.65+345123.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,121.85275,34.85644,0.177,NULL,64331123212,1005173800,15705840,18.1),(52080,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52080,34.94,0.4,97.1,14456,NULL,NULL,'mean','IC 0493',NULL,'2007A&A...465...71T',2007,1,0.8,NULL,'G',0.000035,NULL,'14.4g',0.59,'Sbc',NULL,NULL,NULL,NULL,1,121.8649583,25.13403,0.105,NULL,64296747540,1004636680,15697448,14.4),(52081,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52081,35.01,0.47,101,14456,NULL,NULL,'H','IC 0493',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52082,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52082,37.88,0.23,377,14457,70,NULL,NULL,'2MASX J08072764+5324199',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000177,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,121.8652083,53.40547,0.097,NULL,63543819970,992872187,15513627,17.7),(52083,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52083,38.04,0.33,406,14458,70,NULL,NULL,'2MASX J08072917+1727531',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,121.87175,17.46483,0.121,NULL,62650488852,978913888,15295529,18),(52084,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52084,38.3,0.46,457,14459,70,NULL,NULL,'2MASX J08073037+2517155',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,121.8765417,25.28764,0.105,NULL,64297467503,1004647929,15697623,18.4),(52085,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52085,38.04,0.33,406,14460,70,NULL,NULL,'SDSS J080730.68+172529.4',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,121.877833,17.42486,0.121,NULL,62651201302,978925020,15295703,18.2),(52086,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52086,37.97,0.21,393,14461,70,NULL,NULL,'2MASX J08073120+1555091',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,'PHOT','16.7g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,121.880166667,15.91936,0.065,NULL,62653599316,978962489,15296288,16.7),(52087,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52087,36.36,0.46,187,14462,70,NULL,NULL,'2MASX J08073150+1610551',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000149,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,121.881208333,16.18186,0.081,NULL,62654354153,978974283,15296473,16.7),(52088,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52088,38.07,0.15,411,14463,70,NULL,NULL,'SDSS J080731.80+153147.0',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000135,NULL,'18.8g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,121.8825,15.52975,0.065,NULL,62651838777,978934980,15295859,18.8),(52089,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52089,36.15,0.33,170,14464,70,NULL,NULL,'2MASX J08073229+1456041',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000162,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,121.884625,14.93439,0.061,NULL,62659598359,979056224,15297753,16.6),(52090,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52090,37.48,0.46,313,14465,70,NULL,NULL,'2MASX J08073268+3048449',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000177,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,121.886125,30.81244,0.125,NULL,64348668668,1005447947,15710124,16.8),(52091,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52091,37.64,0.46,337,14466,70,NULL,NULL,'2MASX J08073431+3411209',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000141,NULL,'18.2g',0.1,NULL,NULL,NULL,NULL,NULL,1,121.893041667,34.18922,0.177,NULL,64330934196,1005170846,15705794,18.2),(52092,'GRB','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52092,45.53,1.65,3160,14467,NULL,NULL,NULL,'GRB 081028',3.038,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,121.894667,2.30825,0.121,NULL,62697647306,979650739,15307042,NULL),(52093,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52093,37.65,0.46,338,14468,70,NULL,NULL,'2MASX J08073701+4214526',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,121.9045,42.24792,0.173,NULL,63521579147,992524674,15508198,17.5),(52094,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52094,36.94,0.46,244,14469,70,NULL,NULL,'2MASX J08073706+2854335',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00018,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,121.9045417,28.90925,0.153,NULL,64301727943,1004714499,15698664,16.4),(52095,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52095,37.88,0.23,377,14470,70,NULL,NULL,'2MASX J08073850+5327339',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'17.11',0.24,NULL,NULL,NULL,NULL,NULL,1,121.9105417,53.45936,0.097,NULL,63543806171,992871971,15513624,17.11),(52096,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52096,32.66,0.49,34.1,14471,75,NULL,'IR','UGC 04202',NULL,'2011yCatp016004901K',2011,1,1.21,NULL,'G',NULL,NULL,'16.0',0.12,'Sc',NULL,NULL,NULL,NULL,1,121.912625,74.58469,0.097,NULL,61303148557,957861696,14966589,16),(52097,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52097,32.98,NULL,39.5,14471,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04202',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52098,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52098,33,NULL,39.9,14471,NULL,NULL,NULL,'UGC 04202',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52099,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52099,33.02,NULL,40.2,14471,NULL,NULL,'Dipole + Quadrupole','UGC 04202',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52100,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52100,33.05,NULL,40.7,14471,NULL,NULL,'Dipole','UGC 04202',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52101,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52101,37.81,0.33,364,14472,70,NULL,NULL,'2MASX J08073952+3113559',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,121.9144583,31.23208,0.201,NULL,64348753164,1005449268,15710144,17.4),(52102,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52102,38.23,0.33,443,14473,70,NULL,NULL,'SDSS J080739.49+161034.9',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',NULL,NULL,'16.2g',0.32,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,121.9145417,16.17639,0.081,NULL,62654357369,978974333,15296473,16.2),(52103,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52103,36.92,0.46,242,14474,70,NULL,NULL,'2MASX J08073973+0524503',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000174,NULL,'16.1g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,121.9155,5.41403,0.101,NULL,62774196262,980846816,15325731,16.1),(52104,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52104,35.75,0.46,141,14475,70,NULL,NULL,'2MASX J08073994+4713496',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000072,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,121.9164583,47.23036,0.149,NULL,63537349043,992771078,15512048,16.7),(52105,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52105,37.82,0.33,367,14476,70,NULL,NULL,'2MASX J08074005+0648268',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,121.916916667,6.8075,0.073,NULL,62810835993,981419312,15334676,17.2),(52106,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52106,37.26,0.46,283,14477,70,NULL,NULL,'2MASX J08074083+0958298',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,121.9202083,9.97481,0.045,NULL,62803815314,981309614,15332962,17.9),(52107,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52107,38.16,0.27,429,14478,70,NULL,NULL,'2MASX J08074234+5252598',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,121.926417,52.88328,0.109,NULL,63544651789,992885184,15513831,NULL),(52108,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52108,37.39,0.46,301,14479,70,NULL,NULL,'2MASX J08074321+3934347',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000194,NULL,'17.1g',0.26,'AGN',NULL,NULL,NULL,NULL,1,121.930167,39.57639,0.165,NULL,63552718980,993011234,15515800,17.1),(52109,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52109,38.23,0.33,443,14480,70,NULL,NULL,'2MASX J08074342+1614512',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000134,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,121.931,16.24761,0.081,NULL,62654350616,978974228,15296472,18.7),(52110,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52110,38.13,0.46,423,14481,70,NULL,NULL,'SDSS J080745.56+501730.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000127,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,121.939875,50.29183,0.137,NULL,63549704978,992964140,15515064,18.6),(52111,'SGRB','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52111,38.01,0.48,400,14482,NULL,NULL,NULL,'GRB 021201',NULL,'2006ApJ...640..849N',2006,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'IPN',NULL,NULL,NULL,NULL,1,121.941667,21.23333,0.133,NULL,63759180925,996237201,15566206,NULL),(52112,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52112,37.1,0.46,263,14483,70,NULL,NULL,'2MASX J08074906+1647422',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000151,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,121.9545,16.79514,0.101,NULL,62651108060,978923563,15295680,17),(52113,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52113,38.13,0.46,422,14484,70,NULL,NULL,'SDSS J080750.37+135119.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000136,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,121.959875,13.85536,0.049,NULL,62657139145,979017799,15297153,18.2),(52114,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52114,35.29,0.46,114,14485,70,NULL,NULL,'MCG +08-15-042',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.00009,NULL,'15.4g',0.45,'E0',NULL,NULL,NULL,NULL,1,121.964666667,45.91819,0.141,NULL,63529926014,992655093,15510235,15.4),(52115,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52115,37.81,0.46,364,14486,70,NULL,NULL,'2MASXi J0807519+175127',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,121.9665,17.85761,0.113,NULL,63778817110,996544017,15571000,17.8),(52116,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52116,37.99,0.46,395,14487,70,NULL,NULL,'2MASX J08075446+0658200',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000187,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,121.977,6.97211,0.073,NULL,62811733066,981433329,15334895,17),(52117,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52117,37.94,0.46,388,14488,70,NULL,NULL,'2MASX J08075476+4829273',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000076,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,121.9779583,48.49092,0.157,NULL,63550570361,992977661,15515275,17.9),(52118,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52118,36.88,0.46,238,14489,70,NULL,NULL,'2MASX J08075498+0851349',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,121.9792083,8.85975,0.057,NULL,62812779622,981449681,15335151,16.8),(52119,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52119,36.63,0.46,212,14490,70,NULL,NULL,'2MASX J08075704+1129279',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,121.987583333,11.49106,0.037,NULL,62788144482,981064757,15329136,16.1),(52120,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52120,36.54,0.27,203,14491,70,NULL,NULL,'2MASX J08075761+4538146',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000098,NULL,'15.8g',0.51,'E0',NULL,NULL,NULL,NULL,1,121.9902083,45.63731,0.133,NULL,63529664659,992651010,15510172,15.8),(52121,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52121,37.73,0.46,351,14492,70,NULL,NULL,'2MASX J08075895+4226306',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000146,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,121.9955,42.44186,0.149,NULL,63521604420,992525069,15508204,17.1),(52122,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52122,38.12,0.33,421,14493,70,NULL,NULL,'SDSS J080759.58+354524.4',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,121.9982917,35.75678,0.141,NULL,64338591407,1005290490,15707663,18.3),(52123,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52123,36.56,0.46,205,14494,70,NULL,NULL,'SDSS J080800.33+544123.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000158,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,122.001416667,54.68997,0.101,NULL,61594317861,962411216,15037675,17.8),(52124,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52124,36.77,0.46,226,14495,70,NULL,NULL,'2MASX J08080131+4623246',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000083,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,122.005625,46.39008,0.125,NULL,63529110450,992642350,15510036,17.3),(52125,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52125,37.91,0.33,381,14496,70,NULL,NULL,'2MASX J08080200+0941479',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.9g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,122.0085,9.69653,0.041,NULL,62804369179,981318268,15333097,16.9),(52126,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52126,38.01,0.46,400,14497,70,NULL,NULL,'2MASX J08080241+2731518',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000176,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,122.010083,27.53106,0.097,NULL,64303774096,1004746470,15699163,17.6),(52127,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52127,37.88,0.23,377,14498,70,NULL,NULL,'2MASX J08080363+5334334',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00017,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,122.015083333,53.57611,0.097,NULL,63543937039,992874016,15513656,17.9),(52128,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52128,34.79,0.43,91,14499,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0717',NULL,'2014MNRAS.444..527S',2014,1,1.68,'abs(b) < 10 degrees.','G',0.000027,NULL,'10.6K',0.24,'Sc',NULL,NULL,NULL,NULL,1,122.0192083,-14.87747,NULL,NULL,39355616319,614931504,9608304,10.6),(52129,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52129,37.47,0.46,312,14500,70,NULL,NULL,'2MASX J08080541+3904046',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,122.0224583,39.06808,0.189,NULL,63435121857,991173779,15487090,17.8),(52130,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52130,35.62,0.49,133,14501,75,NULL,'IR','UGC 04240',NULL,'2011yCatp016004901K',2011,1,1.43,NULL,'G',0.000033,NULL,'15.2g',0.34,'S?',NULL,NULL,NULL,NULL,1,122.0255417,14.83775,0.041,NULL,62659430126,979053595,15297712,15.2),(52131,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52131,35.63,0.4,134,14501,NULL,NULL,'mean','UGC 04240',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52132,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52132,35.83,0.47,147,14501,NULL,NULL,'H','UGC 04240',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52133,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52133,35.89,0.45,150,14501,NULL,NULL,'K','UGC 04240',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52134,'Tully-Fisher','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52134,36.06,0.2,163,14501,74.4,NULL,NULL,'UGC 04240',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52135,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52135,38.3,0.17,456,14502,70,NULL,NULL,'SDSS J080806.73+071715.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000139,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,122.0280417,7.28758,0.073,NULL,62811215349,981425239,15334769,18.7),(52136,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52136,37.3,0.46,288,14503,70,NULL,NULL,'2MASX J08080730+2818067',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000157,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,122.0305,28.30186,0.125,NULL,64303004100,1004734439,15698975,16.9),(52137,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52137,38.24,0.33,444,14504,70,NULL,NULL,'2MASX J08080778+1716062',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,122.032541667,17.26844,0.137,NULL,62651208894,978925138,15295705,17.7),(52138,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52138,38.24,0.33,444,14505,70,NULL,NULL,'SDSS J080808.10+171641.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,122.033791667,17.27814,0.137,NULL,62651227017,978925422,15295709,18.6),(52139,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52139,33.73,0.46,55.6,14506,70,NULL,NULL,'NGC 2524',NULL,'2015arXiv151105856S',2015,1,1.4,NULL,'G',0.000173,NULL,'13.7g',1,'S0/a','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,122.0399583,39.15744,0.189,NULL,63435128112,991173876,15487091,13.7),(52140,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52140,37.47,0.46,311,14507,70,NULL,NULL,'2MASX J08081194+3937292',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000139,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,122.049916667,39.62478,0.165,NULL,63552727252,993011363,15515802,17.4),(52141,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52141,36.25,0.23,178,14508,70,NULL,NULL,'2MASX J08081227+0900529',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'16.53',NULL,NULL,NULL,NULL,NULL,NULL,1,122.051125,9.0145,0.033,NULL,62811872706,981435511,15334929,16.53),(52142,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52142,36.61,0.19,210,14509,70,NULL,NULL,'2MASX J08081319+3900232',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000182,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,122.055125,39.00656,0.189,NULL,63435012419,991172069,15487063,16.9),(52143,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52143,36.61,0.19,210,14510,70,NULL,NULL,'2MASX J08081329+3854342',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000184,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,122.055417,38.90958,0.177,NULL,63435009442,991172022,15487062,16.7),(52144,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52144,38.22,0.46,440,14511,70,NULL,NULL,'2MASX J08081361+2512295',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000143,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,122.056583,25.20811,0.105,NULL,64297582473,1004649726,15697651,18.5),(52145,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52145,37.5,0.46,316,14512,70,NULL,NULL,'2MASX J08081356+3432176',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,122.056625,34.53819,0.193,NULL,64331166931,1005174483,15705851,16.7),(52146,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52146,38.35,0.46,467,14513,70,NULL,NULL,'2MASX J08081376+4751534',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000077,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,122.0574583,47.86492,0.133,NULL,63536763770,992761933,15511905,18.4),(52147,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52147,38.12,0.33,421,14514,70,NULL,NULL,'2MASX J08081409+3544236',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000176,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,122.058625,35.73992,0.141,NULL,64338577935,1005290280,15707660,16.9),(52148,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52148,37.39,0.46,300,14515,70,NULL,NULL,'2MASX J08081478+5508318',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000167,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,122.061417,55.14211,0.109,NULL,61593736630,962402134,15037533,17.3),(52149,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52149,37.1,0.46,263,14516,70,NULL,NULL,'2MASX J08081581+2050505',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000198,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,122.065833,20.84744,0.101,NULL,63758995625,996234306,15566161,16.2),(52150,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52150,35.84,0.46,147,14517,70,NULL,NULL,'CGCG 031-056',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.0001,NULL,'15.3g',0.43,'S0/a',NULL,NULL,NULL,NULL,1,122.0685,5.21611,0.077,NULL,62777124921,980892576,15326446,15.3),(52151,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52151,38.3,0.17,456,14518,70,NULL,NULL,'2MASX J08081646+0716358',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000172,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,122.068625,7.27653,0.073,NULL,62811267644,981426056,15334782,17.7),(52152,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52152,35.03,0.46,101,14519,70,NULL,NULL,'2MASX J08081699+2525325',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000172,NULL,'16.0g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,122.070625,25.42581,0.105,NULL,64297606416,1004650100,15697657,16),(52153,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52153,38.29,0.46,455,14520,70,NULL,NULL,'SDSS J080817.48+395050.4',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000155,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,122.072833,39.84733,0.173,NULL,63552714941,993011170,15515799,18.8),(52154,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52154,37.91,0.33,381,14521,70,NULL,NULL,'2MASX J08081770+0945108',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,122.073667,9.75294,0.041,NULL,62803484455,981304444,15332881,17.3),(52155,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52155,37.32,0.46,291,14522,70,NULL,NULL,'SDSS J080819.11+090217.5',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,122.079667,9.03822,0.033,NULL,62811871057,981435485,15334929,17.1),(52156,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52156,36.25,0.23,178,14523,70,NULL,NULL,'IC 0495',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000183,NULL,'15.4',0.55,NULL,NULL,NULL,NULL,NULL,1,122.080917,9.01389,0.033,NULL,62811870769,981435480,15334929,15.4),(52157,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52157,36.25,0.23,178,14524,70,NULL,NULL,'SDSS J080819.82+090102.2',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'17.7g',0.27,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,122.082625,9.01731,0.033,NULL,62811870953,981435483,15334929,17.7),(52158,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52158,37.69,0.46,345,14525,70,NULL,NULL,'2MASX J08082214+2616325',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000182,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,122.092417,26.27567,0.081,NULL,64297164024,1004643187,15697549,16.6),(52159,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52159,36.25,0.23,178,14526,70,NULL,NULL,'2MASX J08082337+0856539',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,122.09725,8.94833,0.033,NULL,62811890523,981435789,15334934,16.9),(52160,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52160,36.83,0.33,233,14527,70,NULL,NULL,'2MASX J08082360+1724131',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00017,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,122.0985,17.40361,0.121,NULL,62651184419,978924756,15295699,16.7),(52161,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52161,37.6,0.46,331,14528,70,NULL,NULL,'2MASX J08082399+0629189',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,122.100041667,6.48875,0.073,NULL,62810981155,981421580,15334712,17.8),(52162,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52162,37.84,0.12,370,14529,70,NULL,NULL,'2MASX J08082422+3456367',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,122.100875,34.94353,0.129,NULL,64331017707,1005172151,15705814,17.8),(52163,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52163,38.3,0.17,456,14530,70,NULL,NULL,'2MASX J08082426+0715489',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00021,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,122.101166667,7.26369,0.073,NULL,62811267510,981426054,15334782,17.1),(52164,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52164,38.25,0.46,447,14531,70,NULL,NULL,'2MASX J08082459+4244475',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000077,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,122.1025,42.74653,0.157,NULL,63521509662,992523588,15508181,17.8),(52165,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,NULL,52165,36.42,0.74,192,14532,70,NULL,NULL,'2MASX J08082540-8559459',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,122.105333333,-85.99608,0.609,NULL,39739005311,620921957,9701905,17.3),(52166,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52166,38.3,0.17,456,14533,70,NULL,NULL,'SDSS J080825.65+072527.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000151,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,122.106875,7.42425,0.089,NULL,62811251302,981425801,15334778,18.7),(52167,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52167,37.09,0.46,262,14534,70,NULL,NULL,'2MASX J08082674+4026323',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000139,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,122.1114583,40.44247,0.173,NULL,63552447385,993006990,15515734,17.9),(52168,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52168,38.3,0.17,456,14535,70,NULL,NULL,'2MASX J08082755+0723509',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,122.114833,7.39733,0.089,NULL,62811259530,981425930,15334780,17.4),(52169,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52169,38.3,0.17,456,14536,70,NULL,NULL,'SDSS J080828.21+071351.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000158,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,122.117583333,7.23103,0.073,NULL,62811164804,981424450,15334757,18.6),(52170,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52170,37.88,0.46,376,14537,70,NULL,NULL,'2MASX J08082876+0801219',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,122.12,8.02292,0.057,NULL,62812538179,981445909,15335092,16.7),(52171,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52171,38.3,0.17,456,14538,70,NULL,NULL,'2MASX J08082937+0719039',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,122.1225,7.31789,0.073,NULL,62811236394,981425568,15334774,17.3),(52172,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52172,37.59,0.46,329,14539,70,NULL,NULL,'2MASX J08082950+3435217',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,122.123125,34.58925,0.193,NULL,64331154796,1005174293,15705848,18),(52173,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52173,38.01,0.46,401,14540,70,NULL,NULL,'2MASX J08082953+4008463',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000134,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,122.1232917,40.14628,0.165,NULL,63552912696,993014260,15515847,18),(52174,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52174,38.04,0.46,405,14541,70,NULL,NULL,'2MASX J08082973+3837003',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000025,NULL,'16.2g',0.38,'AGN',NULL,NULL,NULL,NULL,1,122.124167,38.61667,0.181,NULL,63435318475,991176851,15487138,16.2),(52175,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52175,37.48,0.46,314,14542,70,NULL,NULL,'2MASX J08083051+1629361',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000174,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,122.12725,16.49328,0.089,NULL,62654304879,978973513,15296461,17.3),(52176,'FP','2016-12-15 15:14:19','2016-12-16 11:19:25','1',NULL,'R',52176,37.58,0.33,328,14543,70,NULL,NULL,'2MASX J08083122+1456111',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,122.1299583,14.93658,0.041,NULL,62659491375,979054552,15297727,17.6),(52177,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52177,37.04,0.46,256,14544,70,NULL,NULL,'2MASX J08083234+2930315',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,122.134916667,29.50872,0.189,NULL,64346471082,1005413610,15709587,17.2),(52178,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52178,37.9,0.46,381,14545,70,NULL,NULL,'SDSS J080832.80+161545.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000133,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,122.136708333,16.2625,0.089,NULL,62654499633,978976556,15296508,18.1),(52179,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52179,37.84,0.46,369,14546,70,NULL,NULL,'2MASX J08083339+4829543',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000092,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,122.138875,48.49844,0.157,NULL,63550737604,992980275,15515316,17.3),(52180,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52180,36.73,0.46,222,14547,70,NULL,NULL,'2MASX J08083414+5317363',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000166,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,122.142083,53.29336,0.105,NULL,63543912030,992873625,15513650,16.4),(52181,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52181,36.3,0.46,182,14548,70,NULL,NULL,'2MASX J08083481+1802248',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,122.145125,18.04017,0.117,NULL,63778842544,996544414,15571006,16.9),(52182,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52182,38,0.46,398,14549,70,NULL,NULL,'2MASX J08083736+5303222',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000175,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,122.155541667,53.05603,0.109,NULL,63544669607,992885462,15513835,17.8),(52183,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52183,37.26,0.46,284,14550,70,NULL,NULL,'2MASX J08083787+1918159',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,122.1577083,19.30433,0.073,NULL,63758033638,996219275,15565926,16.9),(52184,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52184,37.58,0.33,328,14551,70,NULL,NULL,'2MASX J08083798+1445017',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000175,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,122.158083333,14.75033,0.041,NULL,62659413917,979053342,15297708,16.9),(52185,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52185,36.89,0.46,239,14552,70,NULL,NULL,'2MASX J08083825+0745389',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,122.1595,7.76083,0.041,NULL,62812908547,981451696,15335182,16.6),(52186,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52186,34.84,0.46,92.9,14553,70,NULL,NULL,'CGCG 088-043',NULL,'2015arXiv151105856S',2015,1,0.94,NULL,'G',0.000163,NULL,'14.7g',0.65,NULL,NULL,NULL,NULL,NULL,1,122.1702917,18.08642,0.117,NULL,63778811782,996543934,15570998,14.7),(52187,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52187,37.13,0.46,267,14554,70,NULL,NULL,'2MASX J08084130+2442320',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,122.172125,24.70897,0.121,NULL,64296651751,1004635183,15697424,17.4),(52188,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,NULL,52188,34.87,0.64,94.2,14555,70,NULL,NULL,'2MFGC 06459',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'11.7K',NULL,NULL,NULL,NULL,NULL,NULL,1,122.17425,-67.54217,0.813,NULL,40643292188,635051440,9922678,11.7),(52189,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52189,38.16,0.46,429,14556,70,NULL,NULL,'SDSS J080842.42+482120.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000072,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,122.1767917,48.35583,0.157,NULL,63550776557,992980883,15515326,18.5),(52190,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52190,38.36,0.46,469,14557,70,NULL,NULL,'2MASX J08084385+0543586',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,122.182625,5.73306,0.101,NULL,62776189595,980877962,15326218,18.2),(52191,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52191,38.36,0.46,469,14558,70,NULL,NULL,'2MASX J08084480+3102097',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'18.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,122.186791667,31.03614,0.185,NULL,64348801062,1005450016,15710156,18),(52192,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,NULL,52192,34.57,0.47,82.2,14559,NULL,NULL,'H','UGC 04245',NULL,'2007A&A...465...71T',2007,1,1.58,NULL,'G',0.000033,NULL,'14.4g',0.48,'SBb',NULL,NULL,NULL,NULL,1,122.190958333,18.19422,0.117,NULL,63778735540,996542742,15570980,14.4),(52193,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,NULL,52193,34.58,0.4,82.4,14559,NULL,NULL,'mean','UGC 04245',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52194,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,NULL,52194,34.71,0.45,87.5,14559,NULL,NULL,'K','UGC 04245',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52195,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,NULL,52195,34.74,0.46,88.7,14559,NULL,NULL,'J','UGC 04245',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52196,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52196,38.74,0.46,559,14560,70,NULL,NULL,'2MASX J08084685+4905132',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000083,NULL,'17.6g',0.22,'AGN',NULL,NULL,NULL,NULL,1,122.195,49.08711,0.149,NULL,63551219056,992987797,15515434,17.6),(52197,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52197,36.6,0.46,209,14561,70,NULL,NULL,'2MASX J08084765+5657244',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000179,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,122.1985,56.95686,0.093,NULL,61602583276,962540363,15039693,16.6),(52198,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52198,38.73,0.46,557,14562,70,NULL,NULL,'SDSS J080847.83+120936.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,122.199333,12.16025,0.045,NULL,62787046926,981047608,15328868,18.1),(52199,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52199,38.15,0.46,427,14563,70,NULL,NULL,'2MASX J08084801+1321458',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,122.1999583,13.36275,0.061,NULL,62655874039,978998031,15296844,18),(52200,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52200,37.54,0.33,323,14564,70,NULL,NULL,'2MASX J08084866+4228330',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000165,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,122.202833,42.47603,0.149,NULL,63521641553,992525649,15508213,16.8),(52201,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52201,37.79,0.46,362,14565,70,NULL,NULL,'2MASX J08084910+3515327',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000196,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,122.2045417,35.25911,0.093,NULL,64330293890,1005160842,15705638,16.9),(52202,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52202,38.06,0.33,410,14566,70,NULL,NULL,'2MASX J08084931+1619278',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,122.205375,16.32436,0.089,NULL,62654465128,978976017,15296500,18.2),(52203,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52203,38.84,0.46,587,14567,70,NULL,NULL,'SDSS J080851.40+063716.4',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000143,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,122.2142083,6.62122,0.073,NULL,62799408839,981240763,15331886,18.3),(52204,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,NULL,52204,37.24,0.67,280,14568,70,NULL,NULL,'2MASX J08085253-0230067',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.84',NULL,NULL,NULL,NULL,NULL,NULL,1,122.218875,-2.50197,0.165,NULL,39428497702,616070276,9626098,16.84),(52205,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52205,37.85,0.46,372,14569,70,NULL,NULL,'2MASX J08085345+1409568',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,122.2227083,14.16581,0.061,NULL,62662539200,979102175,15298471,17.5),(52206,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52206,37.54,0.33,323,14570,70,NULL,NULL,'SDSS J080855.32+422225.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000146,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,122.2305,42.37381,0.173,NULL,63521638327,992525598,15508212,18.6),(52207,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52207,36.61,0.19,210,14571,70,NULL,NULL,'2MASX J08085573+3848587',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000174,NULL,'17.0g',0.31,NULL,NULL,NULL,NULL,NULL,1,122.232208333,38.81636,0.177,NULL,63435504386,991179756,15487183,17),(52208,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52208,36.85,0.33,235,14572,70,NULL,NULL,'2MASX J08085784+1437298',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000199,NULL,'15.7g',0.44,NULL,NULL,NULL,NULL,NULL,1,122.2410417,14.62497,0.057,NULL,62659368743,979052636,15297697,15.7),(52209,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52209,38.06,0.33,410,14573,70,NULL,NULL,'SDSS J080858.22+162550.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000154,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,122.242625,16.43058,0.089,NULL,62653811310,978965801,15296340,18.6),(52210,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52210,37.76,0.46,356,14574,70,NULL,NULL,'2MASX J08085851+1248278',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000181,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,122.2437917,12.80767,0.049,NULL,62656397617,979006212,15296972,16.9),(52211,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52211,37.71,0.46,348,14575,70,NULL,NULL,'SDSS J080858.85+495117.3',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000144,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,122.2452083,49.85483,0.137,NULL,63551669249,992994832,15515544,18.8),(52212,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52212,35.11,0.46,105,14576,70,NULL,NULL,'CGCG 178-030',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000097,NULL,'14.9g',0.69,'S0^-',NULL,NULL,NULL,NULL,1,122.2474583,36.6875,0.149,NULL,64325037205,1005078706,15704354,14.9),(52213,'GRB','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,NULL,52213,42.32,1.02,1620,14577,70,NULL,NULL,'GRB 021211',0.8,'2007ApJ...660...16S',2007,1,NULL,NULL,'G',0.001,NULL,'25.2R',NULL,'HETE',NULL,NULL,NULL,NULL,1,122.249417,6.72708,0.073,NULL,62799363913,981240061,15331875,25.2),(52214,'GRB','2016-12-15 15:14:20','2016-12-16 11:19:25','1','SN 2002lt',NULL,52214,43.49,0.55,2770,14577,69.7,NULL,'Calibrated','GRB 021211',0.8,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52215,'GRB','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52215,43.51,0.61,2800,14577,72,NULL,NULL,'GRB 021211',0.8,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52216,'GRB','2016-12-15 15:14:20','2016-12-16 11:19:25','1','SN 2002lt',NULL,52216,43.94,0.61,3410,14577,69.7,NULL,'Fiducial','GRB 021211',0.8,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52217,'GRB','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52217,44.04,0.38,3570,14577,70,NULL,NULL,'GRB 021211',0.8,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52218,'GRB','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52218,41.87,NULL,2360,14578,70,NULL,'Pseudo z = 0.86','GRB 021211',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'G',0.001,NULL,'25.2R',NULL,'HETE',NULL,NULL,NULL,NULL,1,122.249417,6.72708,0.073,NULL,62799363913,981240061,15331875,25.2),(52219,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52219,36.83,0.33,233,14579,70,NULL,NULL,'2MASX J08085992+1721248',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000172,NULL,'16.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,122.2497917,17.357,0.133,NULL,63778986914,996546670,15571041,16.3),(52220,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52220,37.73,0.46,352,14580,70,NULL,NULL,'2MASX J08090087+1443058',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,122.2537083,14.71836,0.057,NULL,62659389862,979052966,15297702,17.2),(52221,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52221,36.45,0.46,195,14581,70,NULL,NULL,'2MASX J08090153+4452069',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000097,NULL,'15.7g',0.46,'E0',NULL,NULL,NULL,NULL,1,122.25625,44.86856,0.141,NULL,63534848739,992732011,15511437,15.7),(52222,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52222,37.79,0.46,362,14582,70,NULL,NULL,'2MASX J08090303+2902240',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000118,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,122.2627917,29.04006,0.153,NULL,64300898357,1004701536,15698461,18.4),(52223,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,NULL,52223,33.57,NULL,51.7,14583,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04247',NULL,'2010Ap&SS.325..163P',2010,1,1.43,NULL,'G',0.000033,NULL,'16.00',0.1,'SBd?',NULL,NULL,NULL,NULL,1,122.265,16.6775,0.113,NULL,62653839761,978966246,15296347,16),(52224,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,NULL,52224,33.59,NULL,52.1,14583,NULL,NULL,'Dipole + Quadrupole','UGC 04247',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52225,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,NULL,52225,33.59,NULL,52.3,14583,NULL,NULL,'Dipole','UGC 04247',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52226,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,NULL,52226,33.65,NULL,53.8,14583,NULL,NULL,NULL,'UGC 04247',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52227,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,NULL,52227,34.11,0.2,66.4,14583,74.4,NULL,NULL,'UGC 04247',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52228,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,NULL,52228,34.18,0.41,68.4,14583,NULL,NULL,'Malmquist cor.','UGC 04247',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52229,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,NULL,52229,34.2,0.4,69.3,14583,NULL,NULL,NULL,'UGC 04247',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52230,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,NULL,52230,34.44,0.43,77.3,14583,75,NULL,'3.6 micron, color corrected','UGC 04247',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52231,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,NULL,52231,34.67,0.43,86.1,14583,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04247',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52232,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52232,38.59,0.46,522,14584,70,NULL,NULL,'SDSS J080903.62+171845.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000147,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,122.265125,17.31264,0.133,NULL,62650917167,978920580,15295634,18.1),(52233,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52233,37.31,0.46,290,14585,70,NULL,NULL,'2MASX J08090398+0152582',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,122.2664583,1.88286,0.113,NULL,62698260181,979660315,15307192,17.4),(52234,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52234,36.85,0.33,235,14586,70,NULL,NULL,'2MASX J08090466+1436598',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000187,NULL,'15.8g',0.41,NULL,NULL,NULL,NULL,NULL,1,122.269375,14.61669,0.057,NULL,62659370790,979052668,15297697,15.8),(52235,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52235,38.13,0.46,422,14587,70,NULL,NULL,'2MASX J08090492+2644509',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000183,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,122.270625,26.74747,0.113,NULL,64295860889,1004622826,15697231,18),(52236,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52236,37.08,0.46,261,14588,70,NULL,NULL,'2MASX J08090576+4935062',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000076,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,122.274083,49.58506,0.145,NULL,63551641393,992994396,15515537,17.2),(52237,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52237,37.84,0.12,370,14589,70,NULL,NULL,'SDSS J080906.44+344329.1',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.7g',0.27,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,122.276875,34.72475,0.121,NULL,64331030463,1005172350,15705817,16.7),(52238,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52238,36.54,0.27,203,14590,70,NULL,NULL,'2MASX J08090662+4533159',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000088,NULL,'16.1g',0.33,'E0',NULL,NULL,NULL,NULL,1,122.2777083,45.55431,0.133,NULL,63531542452,992680350,15510630,16.1),(52239,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52239,37.84,0.12,370,14591,70,NULL,NULL,'2MASX J08090888+3456137',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,122.287041667,34.93728,0.129,NULL,64331002414,1005171912,15705811,18),(52240,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52240,36.54,0.27,203,14592,70,NULL,NULL,'2MASX J08091062+4540494',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000087,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,122.294375,45.68036,0.133,NULL,63529668708,992651073,15510173,16.6),(52241,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,NULL,52241,34.42,0.46,76.7,14593,NULL,NULL,NULL,'MCG +10-12-078',NULL,'2009ApJS..182..474S',2009,1,0.85,NULL,'G',0.00003,NULL,'13.65',0.4,'Sb',NULL,NULL,NULL,NULL,1,122.297458333,57.68517,0.097,NULL,61598875072,962482423,15038787,13.65),(52242,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,NULL,52242,34.46,0.2,78,14593,74.4,NULL,NULL,'MCG +10-12-078',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52243,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,NULL,52243,34.59,0.43,82.7,14593,NULL,NULL,'Malmquist cor.','MCG +10-12-078',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52244,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,NULL,52244,34.27,0.2,71.5,14594,74.4,NULL,NULL,'UGC 04249',NULL,'2013AJ....146...86T',2013,1,1.43,NULL,'G',0.000014,NULL,'15.1g',0.28,'S?',NULL,NULL,NULL,NULL,1,122.30825,16.98756,0.101,NULL,62651104186,978923502,15295679,15.1),(52245,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52245,34.15,0.49,67.5,14595,75,NULL,'IR','UGC 04249',NULL,'2011yCatp016004901K',2011,1,1.43,NULL,'G',0.000014,NULL,'15.1g',0.28,'S?',NULL,NULL,NULL,NULL,1,122.30825,16.98756,0.101,NULL,62651104186,978923502,15295679,15.1),(52246,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52246,37.88,0.46,376,14596,70,NULL,NULL,'2MASX J08091428+3531253',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,122.30975,35.52372,0.121,NULL,64338763353,1005293177,15707705,17.2),(52247,'SNIa','2016-12-15 15:14:20','2016-12-16 11:19:25','1','SN 2008hu',NULL,52247,36.44,0.19,176,14597,72,NULL,NULL,'ESO 561- G 018',0.05056,'2013ApJ...773...53F',2013,1,1.3,NULL,'G',0.000137,NULL,'10.8K',0.7,'S...',NULL,NULL,NULL,NULL,1,122.313167,-18.66475,NULL,NULL,42266198611,660409353,10318896,10.8),(52248,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52248,34.2,0.49,69.1,14598,75,NULL,'IR','UGC 04253',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000033,NULL,'14.48',0.4,'Sbc:           HII',NULL,NULL,NULL,NULL,1,122.316208333,-0.36661,0.113,NULL,39295952097,613999251,9593738,14.48),(52249,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,NULL,52249,34.55,0.47,81.3,14598,NULL,NULL,'H','UGC 04253',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52250,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,NULL,52250,34.6,0.4,83,14598,NULL,NULL,'mean','UGC 04253',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52251,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,NULL,52251,34.7,0.45,87.1,14598,NULL,NULL,'K','UGC 04253',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52252,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,NULL,52252,34.76,0.46,89.4,14598,NULL,NULL,'J','UGC 04253',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52253,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,NULL,52253,34.96,0.58,98.2,14599,70,NULL,NULL,'2MASX J08091877-7121561',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,122.3284583,-71.36561,0.641,NULL,40633836588,634903696,9920370,16.8),(52254,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52254,36.61,0.19,210,14600,70,NULL,NULL,'2MASX J08091972+3858397',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000186,NULL,'15.7g',0.47,'S0',NULL,NULL,NULL,NULL,1,122.3322917,38.97769,0.177,NULL,63435660286,991182191,15487221,15.7),(52255,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52255,37.58,0.46,329,14601,70,NULL,NULL,'SDSS J080920.58+481321.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000056,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,122.3357917,48.22264,0.149,NULL,63550734068,992980219,15515315,18.7),(52256,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52256,37.56,0.46,324,14602,70,NULL,NULL,'2MASX J08092282+3054033',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000172,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,122.3450417,30.90086,0.189,NULL,64348995173,1005453049,15710203,17.5),(52257,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,NULL,52257,31.57,0.4,20.6,14603,NULL,NULL,'mean','UGC 04241',NULL,'2007A&A...465...71T',2007,1,1,'2MRSS (2012ApJS..199...26H) gives v= 7633 +/- 21 km/sec.','G',0.000023,NULL,'14.90',0.4,'Sab','Group member',NULL,NULL,NULL,1,122.349083333,57.76314,0.097,NULL,61598920642,962483135,15038798,14.9),(52258,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,NULL,52258,31.74,0.47,22.3,14603,NULL,NULL,'H','UGC 04241',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52259,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,NULL,52259,31.77,0.45,22.6,14603,NULL,NULL,'K','UGC 04241',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52260,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,NULL,52260,31.84,0.46,23.4,14603,NULL,NULL,'J','UGC 04241',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52261,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52261,31.92,NULL,24.2,14604,NULL,NULL,NULL,'UGC 04254',NULL,'2015AstBu..70....1K',2015,1,1.3,NULL,'G',0.000017,NULL,'14.12',0.7,'SB(rs)m pec?',NULL,NULL,NULL,NULL,1,122.35,0.60944,0.133,NULL,62699993572,979687399,15307615,14.12),(52262,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52262,36.87,0.33,236,14605,70,NULL,NULL,'2MASX J08092512+1931315',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000193,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,122.35475,19.52542,0.081,NULL,63812685297,997073207,15579268,16.5),(52263,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52263,37.92,0.46,383,14606,70,NULL,NULL,'2MASX J08092536+1022221',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,122.355625,10.37289,0.049,NULL,62786414709,981037729,15328714,17.6),(52264,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52264,38.06,0.46,409,14607,70,NULL,NULL,'2MASX J08092942+2425113',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000184,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,122.3727083,24.41986,0.133,NULL,63763765498,996308835,15567325,17.9),(52265,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52265,36.87,0.33,236,14608,70,NULL,NULL,'2MASX J08093071+1917045',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,122.37775,19.28456,0.073,NULL,63812774182,997074596,15579290,17.4),(52266,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52266,38.07,0.46,411,14609,70,NULL,NULL,'2MASX J08093152+2629503',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000131,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,122.38125,26.49725,0.113,NULL,64297670588,1004651102,15697673,18.4),(52267,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52267,37.27,0.46,285,14610,70,NULL,NULL,'2MASX J08093171+3031413',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,122.382125,30.52806,0.141,NULL,64348611298,1005447051,15710110,17),(52268,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52268,37.39,0.46,300,14611,70,NULL,NULL,'2MASX J08093225+3953161',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00018,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,122.384291667,39.88797,0.169,NULL,63553010624,993015791,15515871,16.7),(52269,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52269,37.84,0.12,370,14612,70,NULL,NULL,'SDSS J080932.32+350346.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000147,NULL,'18.7g',0.08,NULL,NULL,NULL,NULL,NULL,1,122.3847083,35.06283,0.129,NULL,64330272613,1005160509,15705632,18.7),(52270,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52270,36.24,0.46,177,14613,70,NULL,NULL,'2MASX J08093357+0518143',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000176,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,122.389875,5.30403,0.077,NULL,62777026344,980891036,15326422,16.8),(52271,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52271,37.7,0.46,347,14614,70,NULL,NULL,'2MASX J08093408+1241533',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,122.392083,12.69803,0.057,NULL,62656609630,979009525,15297023,17.3),(52272,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52272,37.83,0.46,368,14615,70,NULL,NULL,'2MASX J08093432+0625192',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000176,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,122.393041667,6.42189,0.073,NULL,62799420419,981240944,15331889,17),(52273,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52273,37.85,0.46,372,14616,70,NULL,NULL,'2MASX J08093546+1518373',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000147,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,122.397917,15.31036,0.037,NULL,62653479485,978960616,15296259,17.8),(52274,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52274,37.48,0.46,314,14617,70,NULL,NULL,'2MASX J08093619+2930193',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000183,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,122.40075,29.5055,0.177,NULL,64346778366,1005418411,15709662,16.7),(52275,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52275,38.29,0.46,456,14618,70,NULL,NULL,'SDSS J080938.24+173602.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00013,NULL,'18.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,122.409375,17.60061,0.121,NULL,63779569308,996555770,15571183,18.6),(52276,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52276,37.84,0.12,370,14619,70,NULL,NULL,'SDSS J080938.60+351148.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000143,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,122.410875,35.19675,0.093,NULL,64338604338,1005290692,15707667,18.4),(52277,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52277,35.59,0.46,131,14620,70,NULL,NULL,'2MASX J08093951+5731288',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00016,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,122.414875,57.52467,0.093,NULL,61602007878,962531373,15039552,16.2),(52278,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52278,37.32,0.46,291,14621,70,NULL,NULL,'2MASX J08094046+1922125',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000183,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,122.418583,19.37006,0.073,NULL,63812901881,997076591,15579321,16.9),(52279,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52279,37.13,0.23,267,14622,70,NULL,NULL,'2MASX J08094053+0601233',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000174,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,122.4187917,6.02308,0.101,NULL,62769022609,980765978,15324468,16.6),(52280,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52280,36.29,0.46,181,14623,70,NULL,NULL,'2MASX J08094225+4753058',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000083,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,122.425917,47.885,0.153,NULL,63550857766,992982152,15515346,16.4),(52281,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52281,37.74,0.46,353,14624,70,NULL,NULL,'SDSS J080942.62+074107.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,122.427583,7.68544,0.045,NULL,62798446440,981225725,15331651,17.7),(52282,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52282,37.91,0.27,382,14625,70,NULL,NULL,'2MASX J08094512+5140268',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000146,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,122.43825,51.67406,0.141,NULL,63547898645,992935916,15514623,18.7),(52283,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52283,37.84,0.12,370,14626,70,NULL,NULL,'SDSS J080946.67+352017.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000152,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,122.4445,35.33831,0.093,NULL,64338654901,1005291482,15707679,18.7),(52284,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52284,37.91,0.27,382,14627,70,NULL,NULL,'SDSS J080947.78+514013.8',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.0g',0.26,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,122.449083,51.67053,0.141,NULL,63547898625,992935916,15514623,17),(52285,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52285,37.3,0.46,289,14628,70,NULL,NULL,'2MASX J08094777+1750422',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000179,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,122.449125,17.84503,0.125,NULL,63779573282,996555832,15571184,16.6),(52286,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52286,38.32,0.46,461,14629,70,NULL,NULL,'SDSS J080947.93+442937.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000093,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,122.44975,44.49383,0.157,NULL,63534906956,992732921,15511451,18.3),(52287,'FP','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,'R',52287,36.85,0.46,235,14630,70,NULL,NULL,'2MASX J08094817+2549234',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000184,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,122.450667,25.82303,0.129,NULL,64297298471,1004645288,15697582,16.4),(52288,'BL Lac Luminosity','2016-12-15 15:14:20','2016-12-16 11:19:25','1',NULL,NULL,52288,39.12,NULL,586,14631,NULL,NULL,NULL,'SDSS J080949.18+521858.2',0.138,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',NULL,NULL,'15.3',NULL,'BLLAC',NULL,NULL,NULL,'BL Lac',1,122.454958333,52.31619,0.129,NULL,63544364337,992880692,15513760,15.3),(52289,'GeV TeV ratio','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52289,38.46,NULL,492,14631,72,NULL,NULL,'SDSS J080949.18+521858.2',NULL,'2010MNRAS.405L..76P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52290,'GeV TeV ratio','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52290,39.65,0.92,850,14631,72,NULL,NULL,'SDSS J080949.18+521858.2',NULL,'2011arXiv1111.0913P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52291,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52291,38.48,0.46,498,14632,70,NULL,NULL,'SDSS J080949.67+143628.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000136,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,122.456958333,14.60786,0.057,NULL,62662233526,979097398,15298396,18.5),(52292,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52292,37.71,0.46,348,14633,70,NULL,NULL,'2MASX J08095240+4033340',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000141,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,122.4682917,40.55942,0.161,NULL,63552522952,993008171,15515752,18.3),(52293,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52293,35.88,0.46,150,14634,70,NULL,NULL,'CGCG 031-060',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.00013,NULL,'15.3g',0.52,'E0',NULL,NULL,NULL,NULL,1,122.4689583,5.27939,0.069,NULL,62777057981,980891530,15326430,15.3),(52294,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52294,37.91,0.27,382,14635,70,NULL,NULL,'2MASX J08095297+5141597',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000186,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,122.47075,51.69986,0.141,NULL,63547884800,992935700,15514620,17.8),(52295,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52295,37.84,0.12,370,14636,70,NULL,NULL,'2MASX J08095381+3534596',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,122.47425,35.58325,0.121,NULL,64338735221,1005292737,15707699,17.5),(52296,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52296,37.84,0.12,370,14637,70,NULL,NULL,'2MASX J08095423+3509366',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00018,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,122.475875,35.16033,0.093,NULL,64338606876,1005290732,15707667,16.8),(52297,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52297,37.84,0.12,370,14638,70,NULL,NULL,'SDSS J080954.83+351413.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000157,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,122.4785,35.237,0.093,NULL,64338597867,1005290591,15707665,18.7),(52298,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52298,36.35,0.46,187,14639,70,NULL,NULL,'2MASX J08095494+5126137',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000148,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,122.479167,51.43717,0.141,NULL,63547837829,992934966,15514608,17),(52299,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52299,36.61,0.46,210,14640,70,NULL,NULL,'2MASX J08095535+1644452',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000181,NULL,'15.8g',0.38,NULL,NULL,NULL,NULL,NULL,1,122.480625,16.74592,0.113,NULL,62650883174,978920049,15295625,15.8),(52300,'Tully est','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52300,30.8,0.8,14.4,14641,75,NULL,NULL,'ESO 035- G 021',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.000022,NULL,'17.07',0.5,'IB(s)m',NULL,NULL,NULL,NULL,1,122.4812083,-74.51161,0.693,NULL,39912165971,623627593,9744181,17.07),(52301,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52301,38.23,0.46,443,14642,70,NULL,NULL,'SDSS J080955.55+484209.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000077,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,122.4815,48.70256,0.145,NULL,63551168482,992987007,15515421,18.2),(52302,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52302,37.84,0.12,370,14643,70,NULL,NULL,'2MASX J08095557+3450016',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000174,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,122.4817083,34.83383,0.121,NULL,64330740424,1005167819,15705747,16.9),(52303,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52303,37.16,0.33,270,14644,70,NULL,NULL,'2MASX J08095644+5205147',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,122.4852083,52.08744,0.137,NULL,63547649046,992932016,15514562,16.2),(52304,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52304,37.95,0.46,389,14645,70,NULL,NULL,'SDSS J080956.77+322413.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000162,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,122.486541667,32.40386,0.173,NULL,64329670160,1005151096,15705485,18.5),(52305,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52305,37.59,0.46,330,14646,70,NULL,NULL,'SDSS J080957.32+354824.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000137,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,122.488875,35.80689,0.141,NULL,64338681781,1005291902,15707685,18.4),(52306,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52306,37.16,0.46,270,14647,70,NULL,NULL,'2MASX J08095771+2029576',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,122.490375,20.49939,0.097,NULL,63759390286,996240473,15566257,17.4),(52307,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52307,37.55,0.46,324,14648,70,NULL,NULL,'2MASX J08095888+3655405',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000143,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,122.4954583,36.92792,0.169,NULL,64325542303,1005086598,15704478,18.2),(52308,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52308,34.89,0.2,95.1,14649,74.4,NULL,NULL,'UGC 04252',NULL,'2013AJ....146...86T',2013,1,1.33,NULL,'G',0.000027,NULL,'15.3g',0.4,'Scd:',NULL,NULL,NULL,NULL,1,122.4997917,40.10319,0.193,NULL,63553088174,993017002,15515890,15.3),(52309,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52309,34.98,0.49,99,14649,NULL,NULL,NULL,'UGC 04252',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52310,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52310,35.02,0.48,101,14649,NULL,NULL,'Malmquist cor.','UGC 04252',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52311,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52311,37.83,0.46,368,14650,70,NULL,NULL,'SDSS J081000.66+414948.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000147,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,122.5027917,41.83,0.165,NULL,63520919169,992514362,15508036,18.3),(52312,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52312,34.08,0.5,65.6,14651,70,NULL,NULL,'ESO 089- G 012',NULL,'2014MNRAS.445.2677S',2014,1,2.3,NULL,'G',0.000029,NULL,'12.44',0.4,'(R\')SB(s)b',NULL,NULL,NULL,NULL,1,122.503167,-64.93661,0.625,NULL,40769992626,637031134,9953611,12.44),(52313,'IRAS','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52313,34.45,0.8,77.8,14651,75,NULL,'MAT, I','ESO 089- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52314,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52314,33.91,0.43,60.5,14651,75,NULL,'MAT, I, raw','ESO 089- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52315,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52315,34.03,0.47,64,14651,NULL,NULL,'H','ESO 089- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52316,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52316,34.12,0.45,66.7,14651,NULL,NULL,'K','ESO 089- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52317,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52317,34.13,0.46,67.1,14651,NULL,NULL,'J','ESO 089- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52318,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52318,34.14,0.32,67.4,14651,85,NULL,'I, raw','ESO 089- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52319,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52319,34.18,0.49,68.5,14651,75,NULL,'IR','ESO 089- G 012',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52320,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52320,34.19,0.43,68.8,14651,75,NULL,'MAT, I, inv','ESO 089- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52321,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52321,34.21,0.32,69.5,14651,85,NULL,'I, inv','ESO 089- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52322,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52322,34.23,0.43,70,14651,75,NULL,'MAT, I, cor','ESO 089- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52323,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52323,34.4,0.39,75.8,14651,NULL,NULL,'Malmquist cor.','ESO 089- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52324,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52324,34.42,0.4,76.6,14651,NULL,NULL,'mean','ESO 089- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52325,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52325,34.46,0.38,78.2,14651,NULL,NULL,NULL,'ESO 089- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52326,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52326,34.51,0.2,79.8,14651,74.4,NULL,NULL,'ESO 089- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52327,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52327,37.97,0.46,393,14652,70,NULL,NULL,'2MASX J08100231+0646276',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,122.50975,6.77442,0.049,NULL,62800115352,981251802,15332059,17.5),(52328,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52328,36.97,0.46,248,14653,70,NULL,NULL,'2MASX J08100242+5043147',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000197,NULL,'16.0g',0.41,'E0',NULL,NULL,NULL,NULL,1,122.51025,50.72083,0.145,NULL,63546908610,992920447,15514381,16),(52329,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52329,35.95,0.46,155,14654,70,NULL,NULL,'CGCG 119-003',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000073,NULL,'15.1g',0.62,'SB0a','Group non-member, background',NULL,NULL,NULL,1,122.510375,22.86158,0.105,NULL,63766303039,996348484,15567945,15.1),(52330,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52330,37.84,0.12,370,14655,70,NULL,NULL,'2MASX J08100263+3508545',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000186,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,122.510875,35.14839,0.093,NULL,64338606293,1005290723,15707667,17.4),(52331,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52331,37.84,0.12,370,14656,70,NULL,NULL,'2MASX J08100280+3510225',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,122.511667,35.17292,0.093,NULL,64338598727,1005290605,15707665,16.8),(52332,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52332,35.96,0.46,156,14657,70,NULL,NULL,'2MASX J08100291+2001446',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000154,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,122.512167,20.02922,0.089,NULL,63759201905,996237529,15566211,16.5),(52333,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52333,37.25,0.46,281,14658,70,NULL,NULL,'2MASX J08100505+3821515',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000179,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,122.520917,38.36433,0.181,NULL,63435437068,991178704,15487167,17.1),(52334,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52334,37.48,0.46,314,14659,70,NULL,NULL,'2MASX J08100518+3000215',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000149,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,122.5214583,30.00606,0.165,NULL,64346680009,1005416875,15709638,16.9),(52335,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52335,39.29,0.46,723,14660,70,NULL,NULL,'SDSS J081005.75+380218.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000141,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,122.524,38.03836,0.173,NULL,63435231657,991175494,15487117,18.6),(52336,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52336,36.5,0.46,200,14661,70,NULL,NULL,'2MASX J08100591+2517194',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000164,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,122.524667,25.28881,0.141,NULL,64297404331,1004646942,15697608,16.7),(52337,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52337,38.86,0.46,592,14662,70,NULL,NULL,'2MASX J08100602+2546414',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,122.525,25.77819,0.129,NULL,64297244084,1004644438,15697569,17.9),(52338,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52338,33.89,0.4,60.1,14663,NULL,NULL,'mean','IC 0497',NULL,'2007A&A...465...71T',2007,1,0.94,NULL,'G',0.000006,NULL,'14.7g',0.49,'Sa             LLIRG','in a triple',NULL,NULL,NULL,1,122.525291667,24.92208,0.121,NULL,64297039939,1004641249,15697519,14.7),(52339,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52339,34.17,0.47,68.3,14663,NULL,NULL,'H','IC 0497',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52340,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52340,37.84,0.12,370,14664,70,NULL,NULL,'2MASX J08100633+3515545',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,'FoF','16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,122.526375,35.26522,0.093,NULL,64338649835,1005291403,15707678,16.6),(52341,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52341,35.97,0.33,156,14665,70,NULL,NULL,'CGCG 178-031',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000113,NULL,'15.4g',0.51,'S0^-',NULL,NULL,NULL,NULL,1,122.527417,38.01711,0.173,NULL,63435186881,991174795,15487106,15.4),(52342,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52342,37.73,0.15,352,14666,70,NULL,NULL,'2MASX J08100708+3608525',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,122.529375,36.14808,0.177,NULL,64325013329,1005078333,15704348,17.5),(52343,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52343,37.68,0.21,343,14667,70,NULL,NULL,'2MASX J08100765+4026205',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000133,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,122.53175,40.43908,0.161,NULL,63553043589,993016306,15515879,18.3),(52344,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52344,37.84,0.12,370,14668,70,NULL,NULL,'2MASX J08100854+3516315',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000196,NULL,'16.1g',0.4,'BrClG',NULL,NULL,NULL,NULL,1,122.5355,35.27528,0.093,NULL,64338649762,1005291402,15707678,16.1),(52345,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52345,36.81,0.33,230,14669,70,NULL,NULL,'2MASX J08100890+5152505',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,122.537,51.88081,0.137,NULL,63547681093,992932517,15514570,17),(52346,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52346,38.73,0.46,556,14670,70,NULL,NULL,'SDSS J081009.32+130712.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000144,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,122.538833,13.12003,0.033,NULL,62655959943,978999374,15296865,18.7),(52347,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52347,35.62,0.46,133,14671,70,NULL,NULL,'2MASX J08100948+4700073',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'16.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,122.539417,47.00194,0.145,NULL,63536415021,992756484,15511820,16),(52348,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52348,37.64,0.46,337,14672,70,NULL,NULL,'2MASX J08101014+1110426',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,122.542208333,11.17839,0.069,NULL,62787787946,981059186,15329049,17.8),(52349,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52349,37.22,0.15,278,14673,70,NULL,NULL,'2MASXi J0810103+421107',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,122.54325,42.1855,0.173,NULL,63521026534,992516039,15508063,17.9),(52350,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52350,33.53,NULL,50.8,14674,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04257',NULL,'2010Ap&SS.325..163P',2010,1,2.26,NULL,'G',0.000006,NULL,'15.5g',0.25,'Sd','in a triple',NULL,NULL,NULL,1,122.546667,24.89297,0.121,NULL,64297040960,1004641265,15697519,15.5),(52351,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52351,33.54,NULL,51,14674,NULL,NULL,'Dipole','UGC 04257',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52352,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52352,33.54,NULL,51.1,14674,NULL,NULL,'Dipole + Quadrupole','UGC 04257',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52353,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52353,33.56,0.49,51.6,14674,75,NULL,'IR','UGC 04257',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52354,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52354,33.58,NULL,52,14674,NULL,NULL,NULL,'UGC 04257',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52355,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52355,33.69,0.2,54.7,14674,74.4,NULL,NULL,'UGC 04257',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52356,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52356,33.84,0.43,58.6,14674,75,NULL,'3.6 micron, color corrected','UGC 04257',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52357,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52357,33.93,0.43,61,14674,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04257',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52358,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52358,33.96,0.14,62.1,14674,NULL,NULL,NULL,'UGC 04257',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52359,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52359,37.57,0.46,326,14675,70,NULL,NULL,'2MASX J08101362+2947563',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000156,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,122.556667,29.79881,0.149,NULL,64346894710,1005420229,15709691,16.5),(52360,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52360,37.12,0.46,266,14676,70,NULL,NULL,'2MASX J08101444+1229174',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'17.43',0.32,NULL,NULL,NULL,NULL,NULL,1,122.56,12.48833,0.057,NULL,62656439685,979006870,15296982,17.43),(52361,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52361,36.81,0.33,230,14677,70,NULL,NULL,'2MASX J08101441+5152216',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000163,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,122.5602083,51.87253,0.137,NULL,63547681907,992932529,15514570,16.6),(52362,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52362,33.2,0.47,43.7,14678,NULL,NULL,'H','NGC 2532',NULL,'2007A&A...465...71T',2007,1,1.74,NULL,'G',0.00001,NULL,'13.5g',1.47,'SAB(rs)c       AGN?','Isolated galaxy',NULL,NULL,NULL,1,122.56325,33.95664,0.145,NULL,64331421788,1005178465,15705913,13.5),(52363,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52363,33.29,0.45,45.4,14678,NULL,NULL,'K','NGC 2532',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52364,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52364,33.36,0.46,46.9,14678,NULL,NULL,'J','NGC 2532',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52365,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52365,34.24,0.4,70.5,14678,NULL,NULL,'mean','NGC 2532',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52366,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52366,37.87,0.46,375,14679,70,NULL,NULL,'2MASX J08101543+3813585',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000186,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,122.56425,38.233,0.173,NULL,63435219742,991175308,15487114,17.5),(52367,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52367,35.14,0.09,107,14680,NULL,NULL,NULL,'SBS 0806+579B',NULL,'2009ApJS..182..474S',2009,1,0.48,NULL,'G',0.000027,NULL,'17.5',NULL,'Sb',NULL,NULL,NULL,NULL,1,122.564417,57.81928,0.097,NULL,61600733397,962511459,15039241,17.5),(52368,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52368,37.04,0.46,256,14681,70,NULL,NULL,'2MASX J08101548+3316133',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000156,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,122.564666667,33.27047,0.197,NULL,64332051307,1005188301,15706067,17.1),(52369,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52369,37.95,0.46,389,14682,70,NULL,NULL,'2MASX J08101602+0550003',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000204,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,122.56675,5.83331,0.121,NULL,62769012325,980765817,15324465,17.3),(52370,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52370,35.8,0.46,145,14683,70,NULL,NULL,'2MASX J08101736+0740235',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000168,NULL,'16.1g',0.32,NULL,NULL,NULL,NULL,NULL,1,122.572333,7.67331,0.045,NULL,62798457605,981225900,15331654,16.1),(52371,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52371,35.97,0.33,156,14684,70,NULL,NULL,'2MASX J08101747+3804386',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000174,NULL,'16.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,122.572667,38.07739,0.173,NULL,63435234451,991175538,15487117,16.9),(52372,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52372,37.22,0.15,278,14685,70,NULL,NULL,'2MASX J08101791+4224202',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000193,NULL,'15.6g',0.41,'E0',NULL,NULL,NULL,NULL,1,122.57475,42.4055,0.193,NULL,63521433726,992522401,15508162,15.6),(52373,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52373,35.81,0.46,145,14686,70,NULL,NULL,'2MASX J08101882+0901565',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'15.7g',0.4,NULL,NULL,NULL,NULL,NULL,1,122.578333,9.0325,0.057,NULL,62811810214,981434534,15334914,15.7),(52374,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52374,35.32,0.46,116,14687,70,NULL,NULL,'2MASX J08102140+2507202',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000161,NULL,'15.4g',0.56,'E',NULL,NULL,NULL,NULL,1,122.5892083,25.12231,0.141,NULL,64297043748,1004641308,15697520,15.4),(52375,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52375,39.19,0.46,688,14688,70,NULL,NULL,'SDSS J081022.01+344624.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000152,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,122.591708333,34.7735,0.121,NULL,64330784450,1005168507,15705757,18.7),(52376,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52376,37.13,0.23,267,14689,70,NULL,NULL,'2MASX J08102223+0558085',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,122.592625,5.969,0.121,NULL,62768990375,980765474,15324460,16.8),(52377,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52377,37.57,0.46,326,14690,70,NULL,NULL,'2MASX J08102249+0725555',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000182,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,122.593791667,7.43211,0.045,NULL,62800327686,981255120,15332111,16.6),(52378,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52378,37.82,0.19,367,14691,70,NULL,NULL,'2MASX J08102288+1651134',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000147,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,122.5954583,16.85364,0.097,NULL,62650850963,978919546,15295617,17.5),(52379,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52379,37.68,0.21,343,14692,70,NULL,NULL,'2MASX J08102315+4025125',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,122.596417,40.42022,0.161,NULL,63553041293,993016270,15515879,17.6),(52380,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52380,37.22,0.15,278,14693,70,NULL,NULL,'CGCG 207-040',NULL,'2015arXiv151105856S',2015,1,0.86,NULL,'G',NULL,NULL,'15.3g',0.51,'BrClG',NULL,NULL,NULL,NULL,1,122.5969583,42.27389,0.193,NULL,63520972659,992515197,15508049,15.3),(52381,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52381,37.94,0.46,387,14694,70,NULL,NULL,'2MASX J08102524+3003192',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000166,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,122.605125,30.05533,0.165,NULL,64346715660,1005417432,15709647,17.1),(52382,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52382,33.53,0.69,50.9,14695,100,NULL,'mid-IR','UGC 04243',NULL,'2013ApJ...771...88L',2013,1,1.3,NULL,'G',0.000037,NULL,'14.42',0.7,'Sab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,122.605625,67.24292,0.169,NULL,62235404665,972428197,15194190,14.42),(52383,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52383,34.02,0.43,63.7,14695,NULL,NULL,'Malmquist cor.','UGC 04243',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52384,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52384,34.27,0.38,71.5,14695,NULL,NULL,NULL,'UGC 04243',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52385,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52385,34.43,0.4,77,14695,NULL,NULL,'mean','UGC 04243',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52386,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52386,34.49,0.47,78.9,14695,NULL,NULL,'H','UGC 04243',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52387,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52387,34.53,0.2,80.5,14695,74.4,NULL,NULL,'UGC 04243',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52388,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52388,34.55,0.45,81.4,14695,NULL,NULL,'K','UGC 04243',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52389,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52389,34.6,0.46,83,14695,NULL,NULL,'J','UGC 04243',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52390,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52390,37.57,0.46,327,14696,70,NULL,NULL,'2MASX J08102549+4231554',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000126,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,122.606167,42.532,0.201,NULL,63521481630,992523150,15508174,17.7),(52391,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52391,38.03,0.46,404,14697,70,NULL,NULL,'2MASXi J0810263+165225',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000143,NULL,'17.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,122.609667,16.87378,0.097,NULL,62650848072,978919501,15295617,17.9),(52392,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52392,38.01,0.46,400,14698,70,NULL,NULL,'SDSS J081026.99+385840.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000158,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,122.6125,38.978,0.173,NULL,63435693660,991182713,15487229,18.5),(52393,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52393,37.68,0.21,343,14699,70,NULL,NULL,'SDSS J081027.71+402550.2',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000175,NULL,'16.9g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,122.6155,40.43064,0.161,NULL,63553039190,993016237,15515878,16.9),(52394,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52394,37.68,0.33,344,14700,70,NULL,NULL,'2MASX J08102805+1903359',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00018,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,122.616875,19.05994,0.077,NULL,63813157659,997080588,15579384,17.1),(52395,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52395,37.4,0.46,302,14701,70,NULL,NULL,'2MASX J08103068+5300196',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,122.6280417,53.00553,0.109,NULL,63544609939,992884530,15513820,NULL),(52396,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52396,37.13,0.23,267,14702,70,NULL,NULL,'2MASX J08103199+0555338',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000154,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,122.633541667,5.92594,0.121,NULL,62769003082,980765673,15324463,16.7),(52397,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52397,37.27,0.46,285,14703,70,NULL,NULL,'2MASX J08103207+1913449',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,122.6337083,19.22919,0.077,NULL,63812877089,997076204,15579315,17.6),(52398,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52398,36.89,0.73,239,14704,70,NULL,NULL,'2MASX J08103349-0259089',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.5,NULL,NULL,NULL,NULL,NULL,1,122.639625,-2.98586,0.205,NULL,39427816554,616059633,9625931,14.1),(52399,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52399,37.68,0.21,343,14705,70,NULL,NULL,'2MASX J08103567+4020274',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,122.6487917,40.34108,0.193,NULL,63553064169,993016627,15515884,17.7),(52400,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52400,37.77,0.46,357,14706,70,NULL,NULL,'2MASX J08103633+3117402',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000175,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,122.6515417,31.29461,0.133,NULL,64348907128,1005451673,15710182,16.6),(52401,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52401,36,0.46,158,14707,70,NULL,NULL,'2MASX J08103690+4817296',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000063,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,122.6539583,48.29156,0.149,NULL,63550814149,992981471,15515335,16.8),(52402,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52402,38.6,0.46,525,14708,70,NULL,NULL,'SDSS J081038.52+065330.2',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,122.6605417,6.89175,0.049,NULL,62799919557,981248743,15332011,18.1),(52403,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52403,37.73,0.15,352,14709,70,NULL,NULL,'2MASX J08103855+3611075',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,122.660833,36.1855,0.177,NULL,64325019315,1005078426,15704350,17.6),(52404,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52404,37.55,0.46,324,14710,70,NULL,NULL,'2MASX J08103883+1631168',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000146,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,122.6619583,16.52133,0.089,NULL,62653763891,978965060,15296329,17.7),(52405,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52405,37.68,0.33,343,14711,70,NULL,NULL,'SDSS J081039.25+055559.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,122.663583,5.93328,0.121,NULL,62768994846,980765544,15324461,17.9),(52406,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52406,36.99,0.46,251,14712,70,NULL,NULL,'2MASX J08104072+1516548',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000156,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,122.669708333,15.28203,0.085,NULL,62652972801,978952700,15296135,16.9),(52407,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52407,38,0.46,398,14713,70,NULL,NULL,'2MASX J08104089+1614268',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,122.670333,16.24089,0.105,NULL,62652791421,978949865,15296091,17.7),(52408,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52408,37.68,0.33,343,14714,70,NULL,NULL,'2MASX J08104288+0604075',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,122.6787083,6.06892,0.101,NULL,62768946034,980764781,15324449,18.1),(52409,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52409,35.64,0.46,134,14715,70,NULL,NULL,'2MASX J08104299+4632545',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000091,NULL,'15.4g',0.46,'E0',NULL,NULL,NULL,NULL,1,122.679167,46.54833,0.145,NULL,63529072135,992641752,15510027,15.4),(52410,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52410,37.99,0.46,396,14716,70,NULL,NULL,'2MASX J08104387+1324027',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00016,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,122.682875,13.40083,0.073,NULL,62660491902,979070185,15297971,17.3),(52411,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52411,37.22,0.15,278,14717,70,NULL,NULL,'2MASX J08104403+4218195',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,122.6832917,42.30544,0.193,NULL,63520979134,992515298,15508051,18.1),(52412,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52412,37.68,0.21,343,14718,70,NULL,NULL,'2MASX J08104510+4026325',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00014,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,122.688083,40.44242,0.161,NULL,63553073021,993016765,15515886,17.7),(52413,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52413,37.16,0.33,270,14719,70,NULL,NULL,'2MASX J08104560+5203295',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000174,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,122.690083,52.05833,0.137,NULL,63547204335,992925067,15514454,17),(52414,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52414,36.94,0.46,244,14720,70,NULL,NULL,'2MASX J08104613+2611242',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000164,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,122.6922083,26.19,0.117,NULL,64297840086,1004653751,15697714,16.7),(52415,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52415,37.13,0.23,267,14721,70,NULL,NULL,'2MASX J08104652+0555410',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000174,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,122.6937917,5.92814,0.121,NULL,62768996328,980765567,15324461,17.4),(52416,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52416,37.34,0.46,294,14722,70,NULL,NULL,'2MASX J08104692+3902405',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000194,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,122.695625,39.04447,0.173,NULL,63435646405,991181975,15487218,16.5),(52417,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52417,35.86,0.46,149,14723,70,NULL,NULL,'2MASX J08104732+5125135',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000177,NULL,'15.9g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,122.6972917,51.4205,0.141,NULL,63547816959,992934639,15514603,15.9),(52418,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52418,37.73,0.15,352,14724,70,NULL,NULL,'2MASX J08104734+3546391',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000153,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,122.6974583,35.7775,0.177,NULL,64338713191,1005292393,15707693,18.3),(52419,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52419,38.53,0.46,508,14725,70,NULL,NULL,'2MASXi J0810474+124407',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.6g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,122.69775,12.73533,0.057,NULL,62655688545,978995133,15296798,17.6),(52420,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52420,33.67,0.2,54.2,14726,74.4,NULL,NULL,'UGC 04258',NULL,'2013AJ....146...86T',2013,1,1.46,NULL,'G',0.000106,NULL,'15.7g',0.36,'Sd',NULL,NULL,NULL,NULL,1,122.699125,46.91228,0.145,NULL,63536422493,992756601,15511821,15.7),(52421,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52421,33.8,0.62,57.5,14726,NULL,NULL,NULL,'UGC 04258',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52422,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52422,34.03,0.56,63.9,14726,NULL,NULL,'Malmquist cor.','UGC 04258',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52423,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52423,34.38,0.49,75.3,14726,75,NULL,'IR','UGC 04258',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52424,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52424,37.22,0.15,278,14727,70,NULL,NULL,'2MASX J08104818+4220404',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000961,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,122.70075,42.34458,0.193,NULL,63521425488,992522273,15508160,16.7),(52425,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52425,37.84,0.12,370,14728,70,NULL,NULL,'2MASX J08104820+3512331',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,122.700875,35.20939,0.093,NULL,64339498471,1005304663,15707885,17.7),(52426,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52426,37.39,0.46,300,14729,70,NULL,NULL,'2MASX J08105085+5440022',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000139,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,122.71225,54.66722,0.101,NULL,61547348883,961677326,15026208,18),(52427,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52427,37.19,0.46,274,14730,70,NULL,NULL,'2MASX J08105421+2842110',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000158,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,122.725917,28.70306,0.129,NULL,64345875392,1005404303,15709442,16.7),(52428,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52428,37.4,0.46,302,14731,70,NULL,NULL,'2MASX J08105518+2926030',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000107,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,122.7300417,29.43431,0.181,NULL,64346734617,1005417728,15709652,17.8),(52429,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52429,38.84,0.46,587,14732,70,NULL,NULL,'2MASX J08105648+4913229',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000117,NULL,'18.3g',0.15,'NLAGN',NULL,NULL,NULL,'Sy 2',1,122.735375,49.223,0.149,NULL,63552088696,993001385,15515646,18.3),(52430,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52430,35.23,0.46,111,14733,70,NULL,NULL,'IC 2230',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000177,NULL,'15.3g',0.47,'S0',NULL,NULL,NULL,NULL,1,122.735625,25.68469,0.129,NULL,64298549496,1004664835,15697888,15.3),(52431,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52431,36.71,0.33,219,14734,70,NULL,NULL,'2MASX J08105731+1520096',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000188,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,122.738791667,15.33603,0.085,NULL,62653183667,978955994,15296187,16.1),(52432,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52432,36.8,0.46,229,14735,70,NULL,NULL,'2MASX J08105754+5653092',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,122.739583,56.88586,0.105,NULL,61602784814,962543512,15039742,17.5),(52433,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52433,37.22,0.15,278,14736,70,NULL,NULL,'2MASX J08105784+4221554',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000184,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,122.740875,42.3655,0.193,NULL,63521427355,992522302,15508160,17.1),(52434,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52434,36.23,0.46,176,14737,70,NULL,NULL,'2MASX J08105805+4832189',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000075,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,122.7417917,48.53869,0.149,NULL,63550661875,992979091,15515298,16.9),(52435,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52435,37.73,0.46,351,14738,70,NULL,NULL,'2MASX J08105811+1447166',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000148,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,122.7422083,14.78792,0.081,NULL,62662266133,979097908,15298404,16.9),(52436,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52436,36.8,0.46,229,14739,70,NULL,NULL,'2MASX J08105884+1839114',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000183,NULL,'17.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,122.745125,18.65317,0.097,NULL,63813087796,997079496,15579367,17.1),(52437,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52437,37.73,0.15,352,14740,70,NULL,NULL,'2MASXi J0810589+355610',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000179,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,122.74575,35.93625,0.177,NULL,64338664561,1005291633,15707681,17.8),(52438,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52438,38.44,0.46,487,14741,70,NULL,NULL,'2MASX J08105941+1831134',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,122.747417,18.52044,0.097,NULL,63813116779,997079949,15579374,18.2),(52439,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52439,38.12,0.46,422,14742,70,NULL,NULL,'2MASX J08110076+0643100',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,122.753083,6.71953,0.049,NULL,62800054983,981250859,15332044,17.2),(52440,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52440,37.74,0.46,352,14743,70,NULL,NULL,'SDSS J081101.10+525512.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000142,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,122.754583,52.92022,0.105,NULL,63544596992,992884328,15513817,18.5),(52441,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52441,38.63,0.46,531,14744,70,NULL,NULL,'SDSS J081101.14+265003.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000155,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,122.75475,26.83419,0.129,NULL,64295911969,1004623624,15697244,18.7),(52442,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52442,37.95,0.46,389,14745,70,NULL,NULL,'2MASX J08110227+3055302',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,122.759625,30.92503,0.129,NULL,64348948033,1005452313,15710192,17.3),(52443,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52443,38.15,0.46,426,14746,70,NULL,NULL,'SDSS J081103.31+304841.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000131,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,122.763833,30.81153,0.133,NULL,64348835502,1005450554,15710164,18.4),(52444,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52444,37.73,0.15,352,14747,70,NULL,NULL,'2MASX J08110429+3559085',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000173,NULL,'16.1g',0.39,'BrClG          AGN',NULL,NULL,NULL,NULL,1,122.767958333,35.98564,0.177,NULL,64324969654,1005077650,15704338,16.1),(52445,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52445,37.73,0.15,352,14748,70,NULL,NULL,'2MASX J08110433+3558092',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,122.7680417,35.96917,0.177,NULL,64338663513,1005291617,15707681,17.5),(52446,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52446,37.47,0.46,313,14749,70,NULL,NULL,'2MASX J08110492+2456190',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000164,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,122.770333,24.93864,0.153,NULL,64297070476,1004641726,15697526,17.2),(52447,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52447,37.68,0.33,344,14750,70,NULL,NULL,'SDSS J081105.41+190941.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,122.7725417,19.16153,0.077,NULL,63812843839,997075684,15579307,17.8),(52448,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52448,37.4,0.46,302,14751,70,NULL,NULL,'2MASX J08110637+3129382',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,122.776791667,31.49397,0.129,NULL,64348417079,1005444016,15710062,17.7),(52449,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52449,32.61,0.4,33.3,14752,75,NULL,'B','UGC 04260',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.000033,NULL,'13.9B',1.5,'Im:','Dwarf, possible member',NULL,NULL,NULL,1,122.7865,46.46539,0.141,NULL,63531141411,992674084,15510532,13.9),(52450,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52450,37.22,0.15,278,14753,70,NULL,NULL,'2MASX J08110963+4221273',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,122.790041667,42.35756,0.193,NULL,63521424328,992522255,15508160,17.9),(52451,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52451,37.69,0.46,345,14754,70,NULL,NULL,'2MASX J08111059+5223219',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000176,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,122.794291667,52.38953,0.097,NULL,63544419649,992881557,15513774,16.7),(52452,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52452,36.82,0.58,232,14755,70,NULL,NULL,'2MASX J08111072-6421176',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,122.7947917,-64.35492,0.741,NULL,40771406463,637053225,9953956,17.5),(52453,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52453,38.26,0.46,448,14756,70,NULL,NULL,'2MASX J08111147+0158503',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,122.797667,1.98061,0.097,NULL,62767155427,980736803,15324012,17.1),(52454,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52454,37.82,0.19,367,14757,70,NULL,NULL,'2MASX J08111147+1632132',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,122.797875,16.537,0.089,NULL,62652688418,978948256,15296066,17.1),(52455,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52455,37.82,0.19,367,14758,70,NULL,NULL,'2MASX J08111203+1629552',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,122.80025,16.49867,0.089,NULL,62652740548,978949071,15296079,17.6),(52456,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52456,38.37,0.46,472,14759,70,NULL,NULL,'2MASX J08111288+1711532',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,122.8035417,17.19806,0.125,NULL,63779090503,996548289,15571067,17.8),(52457,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52457,37.14,0.46,268,14760,70,NULL,NULL,'2MASX J08111295+2016304',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000169,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,122.8039583,20.27522,0.093,NULL,63814533600,997102087,15579720,16.7),(52458,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52458,36.71,0.33,219,14761,70,NULL,NULL,'SDSS J081113.07+151630.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'17.4g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,122.8045,15.27514,0.081,NULL,62653171299,978955801,15296184,17.4),(52459,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52459,37.37,0.46,297,14762,70,NULL,NULL,'2MASX J08111306+1519482',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000142,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,122.8045417,15.33003,0.085,NULL,62653175970,978955874,15296185,17.5),(52460,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52460,37.35,0.46,295,14763,70,NULL,NULL,'2MASX J08111330+2948119',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000137,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,122.805417,29.80339,0.149,NULL,64346878765,1005419980,15709687,17.8),(52461,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52461,37.75,0.46,354,14764,70,NULL,NULL,'2MASX J08111350+0626300',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,122.806166667,6.44161,0.049,NULL,62800151908,981252373,15332068,17.8),(52462,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52462,37.22,0.15,278,14765,70,NULL,NULL,'2MASX J08111345+4215423',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,122.8062083,42.26194,0.193,NULL,63522080423,992532506,15508320,17.9),(52463,'Ring Diameter','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52463,32.8,0.84,37,14766,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 2535',NULL,'1981ApJS...45..541P',1981,1,2.5,NULL,'G',0.000004,NULL,'13.3B',1.2,'SA(r)c pec     LLIRG','Pair member (points to parent)',NULL,NULL,NULL,1,122.8062083,25.20681,0.141,NULL,64297078819,1004641856,15697529,13.3),(52464,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52464,33,0.69,39.7,14766,100,NULL,'mid-IR','NGC 2535',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52465,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52465,33.09,0.47,41.5,14766,NULL,NULL,'H','NGC 2535',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52466,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52466,33.28,0.46,45.2,14766,NULL,NULL,'J','NGC 2535',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52467,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52467,33.32,0.45,46.2,14766,NULL,NULL,'K','NGC 2535',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52468,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52468,33.86,0.4,59.2,14766,NULL,NULL,'mean','NGC 2535',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52469,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52469,37.73,0.46,352,14767,70,NULL,NULL,'2MASX J08111413+0651220',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,122.808916667,6.85608,0.049,NULL,62799881952,981248155,15332002,17.2),(52470,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52470,37.22,0.15,278,14768,70,NULL,NULL,'2MASX J08111568+4220254',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,122.81525,42.34044,0.193,NULL,63520964628,992515072,15508048,17.4),(52471,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52471,38.01,0.46,400,14769,70,NULL,NULL,'SDSS J081116.79+192112.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000178,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,122.8199583,19.35344,0.061,NULL,63812820150,997075314,15579301,17.9),(52472,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52472,35.1,0.46,105,14770,70,NULL,NULL,'CGCG 149-001',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000163,NULL,'15.0g',0.55,'E0',NULL,NULL,NULL,NULL,1,122.822917,29.50892,0.181,NULL,64346819187,1005419049,15709672,15),(52473,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52473,37.34,0.46,294,14771,70,NULL,NULL,'2MASX J08111909+2156174',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000157,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,122.8295,21.93806,0.117,NULL,63766087259,996345113,15567892,17.5),(52474,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52474,37.6,0.46,332,14772,70,NULL,NULL,'2MASX J08111979+4307194',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000133,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,122.8325,43.12203,0.225,NULL,63521399828,992521872,15508154,17.8),(52475,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52475,37.82,0.19,367,14773,70,NULL,NULL,'SDSS J081119.80+164241.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000162,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,122.8325417,16.71144,0.089,NULL,63780161987,996565031,15571328,18.3),(52476,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52476,36.69,0.46,217,14774,70,NULL,NULL,'2MASX J08112182+3434541',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000169,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,122.841083,34.58167,0.117,NULL,64330891370,1005170177,15705784,16.6),(52477,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52477,37.73,0.15,352,14775,70,NULL,NULL,'2MASX J08112237+3556445',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00017,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,122.843125,35.94578,0.177,NULL,64338658778,1005291543,15707680,18.1),(52478,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52478,37.02,0.46,254,14776,70,NULL,NULL,'2MASX J08112267+1431521',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000147,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,122.8445,14.53111,0.101,NULL,62662257570,979097774,15298402,17.4),(52479,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52479,37.73,0.15,352,14777,70,NULL,NULL,'2MASX J08112270+3558325',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,122.844666667,35.97564,0.177,NULL,64338659191,1005291549,15707680,17.7),(52480,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52480,38.11,0.46,419,14778,70,NULL,NULL,'2MASX J08112424+1646401',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000158,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,122.850916667,16.77792,0.089,NULL,63782272050,996598000,15571843,16.7),(52481,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52481,36.63,0.46,212,14779,70,NULL,NULL,'2MASX J08112559+1123250',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,122.856667,11.39033,0.069,NULL,62787255899,981050873,15328919,16.7),(52482,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52482,38.69,0.46,548,14780,70,NULL,NULL,'SDSS J081125.69+172437.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000196,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,122.8570417,17.41047,0.133,NULL,63778936293,996545879,15571029,18.3),(52483,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52483,34.69,0.2,86.7,14781,74.4,NULL,NULL,'CGCG 059-051',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000047,NULL,'15.3',0.2,NULL,NULL,NULL,NULL,NULL,1,122.8627917,8.94103,0.029,NULL,62790856108,981107126,15329798,15.3),(52484,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52484,37.82,0.19,367,14782,70,NULL,NULL,'2MASX J08112897+1624331',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000144,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,122.870875,16.40925,0.117,NULL,62652722094,978948782,15296074,17.7),(52485,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52485,38.05,0.46,408,14783,70,NULL,NULL,'SDSS J081129.14+510409.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,122.8714583,51.06942,0.137,NULL,63546963034,992921297,15514395,18.1),(52486,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52486,37.98,0.46,394,14784,70,NULL,NULL,'SDSS J081132.61+040031.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,122.885916667,4.00864,0.081,NULL,62780236799,980941199,15327206,18.1),(52487,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52487,37.52,0.46,319,14785,70,NULL,NULL,'2MASX J08113348+4912078',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000076,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,122.8895417,49.20214,0.149,NULL,63552056052,993000875,15515638,17.7),(52488,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52488,36.14,0.53,169,14786,70,NULL,NULL,'2MASX J08113404-1140204',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.69',0.4,NULL,NULL,NULL,NULL,NULL,1,122.8917083,-11.67244,0.501,NULL,39420073233,615938644,9624041,16.69),(52489,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52489,37.82,0.19,367,14787,70,NULL,NULL,'2MASX J08113438+1639120',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000165,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,122.89325,16.65342,0.089,NULL,63780175625,996565244,15571331,17.1),(52490,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52490,37.7,0.46,347,14788,70,NULL,NULL,'2MASX J08113511+2718212',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000174,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,122.8962083,27.30594,0.117,NULL,64296472761,1004632386,15697381,16.6),(52491,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52491,37.73,0.46,352,14789,70,NULL,NULL,'SDSS J081136.33+032902.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,122.901417,3.48411,0.049,NULL,62779538030,980930281,15327035,17.9),(52492,'IRAS','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52492,31.89,0.8,23.9,14790,75,NULL,'A82, H','UGC 04238',NULL,'1997ApJS..109..333W',1997,1,2.4,NULL,'G',0.000023,NULL,'13.33',1.4,'SBd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,122.903208333,76.42164,0.117,NULL,61414577224,959602769,14993793,13.33),(52493,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52493,31.07,0.2,16.4,14790,74.4,NULL,NULL,'UGC 04238',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52494,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52494,31.3,0.43,18.2,14790,75,NULL,'3.6 micron, color corrected','UGC 04238',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52495,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52495,31.51,0.43,20.1,14790,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04238',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52496,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52496,31.75,0.47,22.4,14790,75,NULL,'A82, H, inv','UGC 04238',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52497,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52497,31.85,0.47,23.5,14790,75,NULL,'A82, H, raw','UGC 04238',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52498,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52498,32.03,0.4,25.5,14790,75,NULL,'B','UGC 04238',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52499,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52499,32.21,0.47,27.6,14790,75,NULL,'A82, H, cor','UGC 04238',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52500,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52500,37.93,0.46,386,14791,70,NULL,NULL,'2MASX J08113765+0957120',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,122.907041667,9.95339,0.065,NULL,62793529750,981148902,15330451,17.9),(52501,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52501,36.39,0.33,189,14792,70,NULL,NULL,'2MASX J08113767+1041040',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'16.86',0.35,NULL,NULL,NULL,NULL,NULL,1,122.907041667,10.68447,0.081,NULL,62787684652,981057572,15329024,16.86),(52502,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52502,36.26,0.46,179,14793,70,NULL,NULL,'CGCG 149-002',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000153,NULL,'15.6g',0.45,'S0','Isolated galaxy',NULL,NULL,NULL,1,122.907417,27.53819,0.105,NULL,64296486835,1004632606,15697384,15.6),(52503,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52503,35.51,0.58,127,14794,70,NULL,NULL,'2MASX J08113849-0219485',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.32',NULL,NULL,NULL,NULL,NULL,NULL,1,122.91025,-2.33014,0.149,NULL,39429791450,616090491,9626413,16.32),(52504,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52504,37.4,0.46,302,14795,70,NULL,NULL,'2MASX J08113969+2122359',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000124,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,122.915541667,21.37653,0.113,NULL,63758770634,996230791,15566106,17.2),(52505,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52505,37.73,0.15,352,14796,70,NULL,NULL,'2MASX J08114110+3606564',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000199,NULL,'16.4g',0.35,'AGN',NULL,NULL,NULL,NULL,1,122.921375,36.11578,0.177,NULL,64325826047,1005091031,15704547,16.4),(52506,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52506,37.37,0.46,298,14797,70,NULL,NULL,'2MASX J08114322+2321279',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,122.930125,23.35772,0.145,NULL,63765215443,996331491,15567679,18.1),(52507,'SNIa','2016-12-15 15:14:20','2016-12-16 11:19:26','1','SN 2006te',NULL,52507,35.14,0.17,103,14798,74.2,NULL,'SALT 2','CGCG 207-042',0.031592,'2010ApJ...716..712A',2010,1,0.74,NULL,'G',0.000089,NULL,'15.5g',0.46,'SBbc',NULL,NULL,NULL,NULL,1,122.931166667,41.55497,0.185,NULL,63522178392,992534037,15508344,15.5),(52508,'SNIa','2016-12-15 15:14:20','2016-12-16 11:19:26','1','SN 2006te',NULL,52508,35.63,0.02,130,14798,72,NULL,'SALT2','CGCG 207-042',0.031592,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52509,'SNIa','2016-12-15 15:14:20','2016-12-16 11:19:26','1','SN 2006te',NULL,52509,35.7,0.09,138,14798,74.4,NULL,NULL,'CGCG 207-042',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52510,'SNIa','2016-12-15 15:14:20','2016-12-16 11:19:26','1','SN 2006te',NULL,52510,35.85,0.16,143,14798,70,NULL,'SALT 2','CGCG 207-042',0.031592,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52511,'SNIa','2016-12-15 15:14:20','2016-12-16 11:19:26','1','SN 2006te',NULL,52511,35.87,0.15,145,14798,73.8,NULL,'SALT 2 (SNANA)','CGCG 207-042',0.032,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52512,'SNIa','2016-12-15 15:14:20','2016-12-16 11:19:26','1','SN 2006te',NULL,52512,35.99,0.18,153,14798,65,NULL,'SALT2','CGCG 207-042',0.031592,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52513,'SNIa','2016-12-15 15:14:20','2016-12-16 11:19:26','1','SN 2006te',NULL,52513,35.99,0.16,153,14798,65,NULL,'MLCS17','CGCG 207-042',0.031592,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52514,'SNIa','2016-12-15 15:14:20','2016-12-16 11:19:26','1','SN 2006te',NULL,52514,36,0.17,153,14798,65,NULL,'SALT','CGCG 207-042',0.031592,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52515,'SNIa','2016-12-15 15:14:20','2016-12-16 11:19:26','1','SN 2006te',NULL,52515,36.05,0.15,157,14798,65,NULL,'MLCS31','CGCG 207-042',0.031592,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52516,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52516,36.39,0.33,189,14799,70,NULL,NULL,'2MASX J08114364+1041170',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,122.93175,10.68808,0.081,NULL,62787682906,981057545,15329024,17),(52517,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52517,36.9,0.46,240,14800,70,NULL,NULL,'2MASX J08114400+1430489',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000176,NULL,'17.0g',0.32,'AGN',NULL,NULL,NULL,NULL,1,122.9334583,14.51344,0.101,NULL,62662247918,979097623,15298400,17),(52518,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52518,37.95,0.46,389,14801,70,NULL,NULL,'2MASX J08114578+5015499',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000084,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,122.9407917,50.26394,0.141,NULL,63548188945,992940452,15514694,17.1),(52519,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52519,37.82,0.33,366,14802,70,NULL,NULL,'2MASX J08114837+1511338',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000194,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,122.9514583,15.19275,0.081,NULL,62661223171,979081612,15298150,16.5),(52520,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52520,37.98,0.46,394,14803,70,NULL,NULL,'2MASX J08114909+5324599',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,122.9545,53.41672,0.101,NULL,63489257396,992019646,15500306,17.3),(52521,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52521,32.92,0.49,38.3,14804,75,NULL,'IR','ESO 561- G 023',NULL,'2011yCatp016004901K',2011,1,2.21,'Springob et al. (2005ApJS..160..149S) give v= 2578 km/sec.','G',0.00005,NULL,'15.1',0.27,'Sbc',NULL,NULL,NULL,NULL,1,122.9687917,-18.30033,NULL,NULL,42249642576,660150665,10314854,15.1),(52522,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52522,34.24,NULL,70.4,14804,NULL,NULL,'Dipole','ESO 561- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52523,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52523,34.24,NULL,70.5,14804,NULL,NULL,'Dipole + Quadrupole','ESO 561- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52524,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52524,34.25,NULL,70.8,14804,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 561- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52525,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52525,37.21,0.46,277,14805,70,NULL,NULL,'2MASX J08115254+0352275',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000126,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,122.968917,3.87419,0.065,NULL,62780226400,980941037,15327203,17.5),(52526,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52526,37.82,0.33,366,14806,70,NULL,NULL,'2MASX J08115265+1509448',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,122.9692917,15.16233,0.081,NULL,62661256709,979082136,15298158,17.8),(52527,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52527,37.94,0.27,388,14807,70,NULL,NULL,'SDSS J081152.70+154748.9',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,122.969625,15.79694,0.085,NULL,62653421319,978959708,15296245,18.1),(52528,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52528,37.08,0.46,260,14808,70,NULL,NULL,'2MASX J08115296+2304419',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000141,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,122.9707917,23.07822,0.141,NULL,63764647354,996322614,15567540,17.4),(52529,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52529,37.62,0.46,334,14809,70,NULL,NULL,'2MASX J08115443+2812139',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000171,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,122.976833333,28.20369,0.141,NULL,64295590640,1004618603,15697165,16.6),(52530,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52530,37.5,0.33,316,14810,70,NULL,NULL,'2MASX J08115494+3019561',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000141,NULL,'17.7g',0.2,'AGN',NULL,NULL,NULL,NULL,1,122.9787917,30.33231,0.125,NULL,64346234490,1005409913,15709529,17.7),(52531,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52531,37.4,0.46,302,14811,70,NULL,NULL,'2MASX J08115996+2909009',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00013,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,122.999875,29.15019,0.189,NULL,64345974457,1005405850,15709466,18.2),(52532,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52532,37.45,0.46,309,14812,70,NULL,NULL,'2MASX J08120011+2556139',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000188,NULL,'17.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,123.0005,25.93733,0.141,NULL,64298592351,1004665505,15697898,17.5),(52533,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52533,37.51,0.46,318,14813,70,NULL,NULL,'2MASX J08120128+2935459',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000112,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,123.005333,29.59614,0.177,NULL,64346849166,1005419518,15709679,17.8),(52534,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52534,34.94,0.44,97.2,14814,NULL,NULL,'Malmquist cor.','UGC 04269',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.57',0.6,'Sb','Isolated galaxy',NULL,NULL,NULL,1,123.006667,19.36467,0.061,NULL,63815652222,997119565,15579993,14.57),(52535,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52535,35.23,0.38,111,14814,NULL,NULL,NULL,'UGC 04269',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52536,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52536,35.28,0.2,114,14814,74.4,NULL,NULL,'UGC 04269',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52537,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52537,35.6,0.4,132,14814,NULL,NULL,'mean','UGC 04269',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52538,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52538,35.69,0.47,137,14814,NULL,NULL,'H','UGC 04269',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52539,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52539,35.72,0.45,139,14814,NULL,NULL,'K','UGC 04269',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52540,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52540,35.72,0.46,140,14814,NULL,NULL,'J','UGC 04269',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52541,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52541,37.81,0.46,365,14815,70,NULL,NULL,'2MASX J08120327+1755428',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000171,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,123.013583,17.92842,0.121,NULL,63779275321,996551176,15571112,17.8),(52542,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52542,37.5,0.33,316,14816,70,NULL,NULL,'2MASX J08120352+3015511',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000176,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,123.01475,30.26433,0.125,NULL,64346237141,1005409955,15709530,16.7),(52543,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52543,36.41,0.46,191,14817,70,NULL,NULL,'CGCG 031-070',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.0001,NULL,'15.7g',0.43,'E0',NULL,NULL,NULL,NULL,1,123.0165,5.47508,0.077,NULL,62769814847,980778356,15324661,15.7),(52544,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52544,37.5,0.46,316,14818,70,NULL,NULL,'2MASX J08120577+0309315',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00016,NULL,'17.7g',NULL,NULL,NULL,NULL,NULL,NULL,1,123.024125,3.15875,0.069,NULL,62778831691,980919245,15326863,17.7),(52545,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52545,37.59,0.27,330,14819,70,NULL,NULL,'2MASX J08120675+3122311',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.00021,NULL,'15.9g',0.38,'E0',NULL,NULL,NULL,NULL,1,123.0280417,31.3755,0.133,NULL,64348357073,1005443079,15710048,15.9),(52546,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52546,38.24,0.46,445,14820,70,NULL,NULL,'SDSS J081207.26+540442.6',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000154,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,123.0302917,54.0785,0.089,NULL,63489328789,992020762,15500324,17.6),(52547,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52547,37.99,0.33,396,14821,70,NULL,NULL,'2MASX J08120754+1032459',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,123.031625,10.54603,0.041,NULL,62793459156,981147799,15330434,17.2),(52548,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52548,38.15,0.33,426,14822,70,NULL,NULL,'SDSS J081208.13+404725.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000134,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,123.033875,40.79033,0.173,NULL,63519135439,992486491,15507601,18.5),(52549,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52549,38.15,0.33,426,14823,70,NULL,NULL,'2MASX J08120837+4047400',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000186,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,123.0350417,40.79453,0.173,NULL,63519135460,992486491,15507601,16.9),(52550,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52550,36.26,0.17,179,14824,70,NULL,NULL,'2MASX J08120855+1659168',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000186,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,123.035625,16.98792,0.097,NULL,63782305280,996598520,15571851,16.3),(52551,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52551,35.29,0.1,115,14825,NULL,NULL,NULL,'SBS 0807+580B',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',NULL,NULL,'16.5:',0.2,'Sc',NULL,NULL,NULL,NULL,1,123.035667,57.90778,0.093,NULL,61600951822,962514872,15039294,16.5),(52552,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52552,37.86,0.46,374,14826,70,NULL,NULL,'SDSS J081209.59+032956.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000136,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,123.0399583,3.49914,0.049,NULL,62778930823,980920794,15326887,17.9),(52553,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52553,36.12,0.46,167,14827,70,NULL,NULL,'2MASX J08121016+2219506',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000165,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,123.0424583,22.33078,0.129,NULL,63764038280,996313098,15567392,16.8),(52554,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52554,35.67,0.49,136,14828,75,NULL,'IR','CGCG 059-052',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000193,NULL,'15.4',0.2,NULL,NULL,NULL,NULL,NULL,1,123.0454583,11.26436,0.053,NULL,62787277678,981051213,15328925,15.4),(52555,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52555,35.95,0.2,155,14829,74.4,NULL,NULL,'CGCG 059-052',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000193,NULL,'15.4',0.2,NULL,NULL,NULL,NULL,NULL,1,123.0454583,11.26436,0.053,NULL,62787277678,981051213,15328925,15.4),(52556,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52556,38.19,0.46,434,14830,70,NULL,NULL,'2MASX J08121258+1552258',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000183,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,123.052375,15.87381,0.085,NULL,62653364623,978958822,15296231,16.7),(52557,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52557,38.38,0.46,474,14831,70,NULL,NULL,'2MASX J08121391+1113481',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,123.0580417,11.23003,0.053,NULL,62787261088,981050954,15328921,NULL),(52558,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52558,34.92,0.74,96.5,14832,70,NULL,NULL,'2MASX J08121540-6740263',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6b',NULL,'(RL)SA(r)0^+',NULL,NULL,NULL,NULL,1,123.063917,-67.67389,0.721,NULL,40773473527,637085523,9954461,15.6),(52559,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52559,37.36,0.46,297,14833,70,NULL,NULL,'2MASX J08121695+4922392',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000092,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,123.070583333,49.37744,0.153,NULL,63551875458,992998054,15515594,16.7),(52560,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52560,36.26,0.17,179,14834,70,NULL,NULL,'2MASX J08121824+1658497',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000083,NULL,'15.2g',0.67,NULL,NULL,NULL,NULL,NULL,1,123.0760417,16.98042,0.101,NULL,63782301551,996598461,15571850,15.2),(52561,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52561,38.3,0.46,457,14835,70,NULL,NULL,'2MASX J08122046+0712541',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000176,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,123.085333,7.21494,0.041,NULL,62801250978,981269546,15332336,17.8),(52562,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52562,37.94,0.27,388,14836,70,NULL,NULL,'2MASX J08122229+1552107',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,123.093,15.86978,0.085,NULL,62653355397,978958678,15296229,17.1),(52563,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52563,34.23,NULL,70,14837,NULL,NULL,'Dipole','ESO 561- G 025',NULL,'2010Ap&SS.325..163P',2010,1,1.9,'abs(b) < 10 degrees.','G',0.000033,NULL,'15.9',0.22,'Sbc',NULL,NULL,NULL,NULL,1,123.0935417,-21.53108,NULL,NULL,42221997755,659718714,10308104,15.9),(52564,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52564,34.24,NULL,70.5,14837,NULL,NULL,'Dipole + Quadrupole','ESO 561- G 025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52565,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52565,34.24,NULL,70.6,14837,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 561- G 025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52566,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52566,36.26,0.17,179,14838,70,NULL,NULL,'2MASX J08122319+1702227',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000182,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,123.096833333,17.03972,0.101,NULL,63782475909,996601186,15571893,16.3),(52567,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52567,38.05,0.46,408,14839,70,NULL,NULL,'SDSS J081224.29+184748.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00014,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,123.10125,18.79667,0.089,NULL,63812490741,997070167,15579221,18.7),(52568,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52568,37.19,0.46,274,14840,70,NULL,NULL,'2MASX J08122587+3427321',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000153,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,123.1079583,34.45903,0.153,NULL,64338826818,1005294169,15707721,17.5),(52569,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52569,37.74,0.27,354,14841,70,NULL,NULL,'2MASX J08122666+2501209',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,'FoF','16.4g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,123.11125,25.02247,0.153,NULL,64296874185,1004638659,15697479,16.4),(52570,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52570,37.94,0.27,388,14842,70,NULL,NULL,'2MASX J08122796+1542077',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000198,NULL,'16.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,123.116541667,15.70208,0.133,NULL,62653406386,978959474,15296241,16.4),(52571,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52571,37.74,0.27,354,14843,70,NULL,NULL,'2MASX J08122835+2502269',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000147,NULL,'18.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,123.11825,25.04072,0.153,NULL,64296874403,1004638662,15697479,18),(52572,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52572,38.26,0.46,449,14844,70,NULL,NULL,'2MASX J08122883+5023473',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00018,NULL,'17.7g',0.2,'BrClG',NULL,NULL,NULL,NULL,1,123.12025,50.39661,0.157,NULL,63548205303,992940707,15514698,17.7),(52573,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52573,38.41,0.46,482,14845,70,NULL,NULL,'2MASX J08122917+3933502',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,123.1215417,39.56397,0.165,NULL,63434896771,991170262,15487035,18.4),(52574,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52574,38.3,0.46,457,14846,70,NULL,NULL,'SDSS J081229.30+472034.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000075,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,123.122083,47.343,0.149,NULL,63550235783,992972434,15515194,18.6),(52575,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52575,37.99,0.33,396,14847,70,NULL,NULL,'2MASX J08122959+1031221',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,123.1232083,10.52294,0.041,NULL,62796391130,981193611,15331150,17.7),(52576,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52576,38.07,0.46,411,14848,70,NULL,NULL,'SDSS J081229.75+175800.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000128,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,123.124,17.96686,0.121,NULL,63779314257,996551785,15571121,18.7),(52577,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52577,37.74,0.27,354,14849,70,NULL,NULL,'SDSS J081229.88+250137.8',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,123.1245,25.02719,0.153,NULL,64296874051,1004638657,15697479,17.3),(52578,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52578,37.76,0.27,356,14850,70,NULL,NULL,'2MASX J08123037+4912343',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000087,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,123.1262917,49.2095,0.161,NULL,63551865526,992997898,15515592,17.4),(52579,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52579,37.76,0.27,356,14851,70,NULL,NULL,'2MASX J08123037+4911363',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000087,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,123.126417,49.19347,0.161,NULL,63551865726,992997901,15515592,17.2),(52580,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52580,36.99,0.46,250,14852,70,NULL,NULL,'2MASX J08123059+2128493',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,123.1274583,21.48042,0.113,NULL,63758694978,996229609,15566087,17.1),(52581,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52581,38.31,0.46,459,14853,70,NULL,NULL,'2MASX J08123359+0631031',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,123.1399583,6.51744,0.017,NULL,62799590664,981243604,15331931,17.8),(52582,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52582,37.96,0.46,391,14854,70,NULL,NULL,'2MASX J08123420+2102443',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000175,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,123.142625,21.04567,0.105,NULL,63758821609,996231587,15566118,16.9),(52583,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52583,37.76,0.27,356,14855,70,NULL,NULL,'2MASX J08123527+4912513',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,'FoF','16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,123.146791667,49.21422,0.161,NULL,63551865212,992997893,15515592,16.9),(52584,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52584,38.17,0.46,431,14856,70,NULL,NULL,'SDSS J081236.47+303026.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000127,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,123.1519583,30.50744,0.137,NULL,64348179325,1005440301,15710004,18.7),(52585,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52585,36.16,0.21,171,14857,70,NULL,NULL,'2MASX J08123726+5413298',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000169,NULL,'16.1g',0.31,NULL,NULL,NULL,NULL,NULL,1,123.155541667,54.225,0.089,NULL,61547327873,961676998,15026203,16.1),(52586,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52586,37.93,0.46,386,14858,70,NULL,NULL,'2MASX J08123813+0352535',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000149,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,123.1589583,3.8815,0.065,NULL,62778585226,980915394,15326803,17.2),(52587,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52587,37.45,0.46,309,14859,70,NULL,NULL,'2MASX J08123843+5702198',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000176,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,123.1602917,57.03889,0.089,NULL,61602665963,962541655,15039713,17.1),(52588,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52588,38,0.46,398,14860,70,NULL,NULL,'2MASX J08123918+2559190',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,123.163208333,25.98878,0.141,NULL,64298675691,1004666807,15697918,17.6),(52589,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52589,36.74,0.46,223,14861,70,NULL,NULL,'2MASX J08123921+1024420',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,123.163333,10.41158,0.041,NULL,62793488509,981148257,15330441,17.3),(52590,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52590,36.26,0.17,179,14862,70,NULL,NULL,'2MASXi J0812410+165912',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,123.171,16.98678,0.101,NULL,63782502942,996601608,15571900,16.7),(52591,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52591,35.62,0.57,133,14863,70,NULL,NULL,'2MASX J08124134-6843596',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,123.1720417,-68.73317,0.633,NULL,40651407865,635178247,9924660,16.9),(52592,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52592,37.95,0.27,389,14864,70,NULL,NULL,'2MASX J08124146+4024523',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000176,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,123.1729583,40.41458,0.165,NULL,63518675754,992479308,15507489,16.9),(52593,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52593,38.29,0.46,454,14865,70,NULL,NULL,'2MASX J08124253+3423306',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000171,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,123.1772083,34.39194,0.161,NULL,64338843503,1005294429,15707725,17.8),(52594,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52594,34.4,0.2,75.9,14866,74.4,NULL,NULL,'KUG 0809+230',NULL,'2013AJ....146...86T',2013,1,0.89,NULL,'G',0.000006,NULL,'16.6g',0.21,'Spiral',NULL,NULL,NULL,NULL,1,123.184667,22.90736,0.133,NULL,63764604274,996321941,15567530,16.6),(52595,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52595,36.26,0.17,179,14867,70,NULL,NULL,'CGCG 088-050',NULL,'2015arXiv151105856S',2015,1,1.7,NULL,'G',0.000157,NULL,'15.4',0.8,NULL,NULL,NULL,NULL,NULL,1,123.1855,16.88825,0.093,NULL,63782279458,996598116,15571845,15.4),(52596,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52596,37.59,0.27,330,14868,70,NULL,NULL,'2MASX J08124490+3116336',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000187,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,123.186917,31.27606,0.133,NULL,64347571494,1005430804,15709856,16.8),(52597,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52597,37.72,0.46,349,14869,70,NULL,NULL,'2MASX J08124501+3951282',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000175,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,123.187416667,39.85792,0.133,NULL,63552135448,993002116,15515658,17.3),(52598,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52598,36.55,0.46,204,14870,70,NULL,NULL,'2MASX J08124512+1137566',NULL,'2015arXiv151105856S',2015,1,0.61,'Star superposed 11\\\" to the northeast.','G',0.00011,NULL,'15.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,123.188083,11.63244,0.057,NULL,62795141864,981174091,15330845,15.6),(52599,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52599,36.16,0.21,171,14871,70,NULL,NULL,'2MASX J08124599+5408228',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.00019,NULL,'15.6g',0.51,NULL,NULL,NULL,NULL,NULL,1,123.191583333,54.13972,0.089,NULL,63489337317,992020895,15500326,15.6),(52600,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52600,34.32,0.41,73.2,14872,NULL,NULL,'Malmquist cor.','NGC 2540',NULL,'2009ApJS..182..474S',2009,1,1.44,NULL,'G',0.000033,NULL,'14.0g',0.74,'SB(rs)cd:      HII','Group non-member, background',NULL,NULL,NULL,1,123.1935417,26.36178,0.137,NULL,64298545493,1004664773,15697887,14),(52601,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52601,34.39,0.2,75.5,14872,74.4,NULL,NULL,'NGC 2540',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52602,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52602,34.49,0.38,78.9,14872,NULL,NULL,NULL,'NGC 2540',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52603,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52603,34.97,0.4,98.6,14872,NULL,NULL,'mean','NGC 2540',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52604,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52604,35.01,0.47,100,14872,NULL,NULL,'H','NGC 2540',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52605,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52605,35.12,0.46,106,14872,NULL,NULL,'J','NGC 2540',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52606,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52606,35.17,0.45,108,14872,NULL,NULL,'K','NGC 2540',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52607,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52607,37.89,0.46,379,14873,70,NULL,NULL,'2MASX J08124643+1705565',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,123.1935417,17.09911,0.101,NULL,63782480536,996601258,15571894,17.4),(52608,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52608,34.8,0.46,91.2,14874,70,NULL,NULL,'UGC 04272',NULL,'2015arXiv151105856S',2015,1,0.88,NULL,'G',0.000089,NULL,'14.9g',0.58,'S0:',NULL,NULL,NULL,NULL,1,123.197875,44.35739,0.181,NULL,63535261444,992738460,15511538,14.9),(52609,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52609,37.65,0.46,340,14875,70,NULL,NULL,'SDSS J081249.42+150929.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000113,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,123.205916667,15.15814,0.101,NULL,62661724459,979089444,15298272,18),(52610,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52610,37.95,0.27,389,14876,70,NULL,NULL,'SDSS J081250.43+403133.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000141,NULL,'18.7g',0.09,NULL,NULL,NULL,NULL,NULL,1,123.210166667,40.52589,0.169,NULL,63518683538,992479430,15507491,18.7),(52611,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52611,37.36,0.46,296,14877,70,NULL,NULL,'2MASX J08125107+0651336',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000188,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,123.212875,6.85925,0.041,NULL,62801201208,981268768,15332324,16.2),(52612,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52612,38.06,0.46,410,14878,70,NULL,NULL,'2MASX J08125275+1438345',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00016,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,123.2199583,14.64303,0.101,NULL,62661640389,979088131,15298252,17.5),(52613,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52613,36.16,0.21,171,14879,70,NULL,NULL,'2MASX J08125306+5414501',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000173,NULL,'15.9g',0.44,NULL,NULL,NULL,NULL,NULL,1,123.221,54.24733,0.089,NULL,61547332682,961677073,15026204,15.9),(52614,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52614,37.95,0.27,389,14880,70,NULL,NULL,'2MASX J08125328+4027112',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000191,NULL,'17.8g',0.19,'Candidate      BLAGN',NULL,NULL,NULL,NULL,1,123.222167,40.45319,0.165,NULL,63518730680,992480166,15507502,17.8),(52615,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52615,37.78,0.46,359,14881,70,NULL,NULL,'SDSS J081253.93+245755.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000149,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,123.2247083,24.96542,0.153,NULL,64296903381,1004639115,15697486,18.5),(52616,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52616,38.18,0.46,433,14882,70,NULL,NULL,'2MASX J08125407+3418376',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000142,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,123.22525,34.31039,0.161,NULL,64338804304,1005293817,15707715,18.6),(52617,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52617,37.31,0.46,290,14883,70,NULL,NULL,'SDSS J081254.59+220115.8',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000141,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,123.2274583,22.02106,0.121,NULL,63766103719,996345370,15567896,18.5),(52618,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52618,38.17,0.46,430,14884,70,NULL,NULL,'2MASX J08125468+3101065',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,123.227833,31.01853,0.129,NULL,64348067688,1005438557,15709977,17.8),(52619,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52619,36.57,0.46,206,14885,70,NULL,NULL,'2MASX J08125580+5221562',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,123.232417,52.36556,0.121,NULL,63544263039,992879109,15513736,16.1),(52620,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52620,36.16,0.21,171,14886,70,NULL,NULL,'2MASX J08125624+5416352',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'16.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,123.234375,54.27644,0.089,NULL,61547334182,961677096,15026204,16.1),(52621,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52621,32.64,0.2,33.7,14887,74.4,NULL,NULL,'UGC 04267',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000183,NULL,'14.3g',0.54,'S?','in a pair',NULL,NULL,NULL,1,123.234833,54.969,0.097,NULL,61547986232,961687284,15026363,14.3),(52622,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52622,33.57,0.46,51.7,14888,NULL,NULL,'J','NGC 2523B',NULL,'2007A&A...465...71T',2007,1,2.1,NULL,'G',0.000037,NULL,'14.74',0.3,'SA(s)b: sp','Pair member (points to parent)',NULL,NULL,NULL,1,123.237875,73.56325,0.097,NULL,61289480028,957648125,14963251,14.74),(52623,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52623,33.57,0.47,51.9,14888,NULL,NULL,'H','NGC 2523B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52624,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52624,33.69,0.49,54.7,14888,75,NULL,'IR','NGC 2523B',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52625,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52625,33.71,0.4,55.3,14888,NULL,NULL,'mean','NGC 2523B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52626,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52626,33.75,0.45,56.2,14888,NULL,NULL,'K','NGC 2523B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52627,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52627,38.06,0.46,409,14889,70,NULL,NULL,'2MASX J08125748+1930053',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,123.239333333,19.50147,0.061,NULL,63815636255,997119316,15579989,17.3),(52628,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52628,32.1,0.4,26.3,14890,NULL,NULL,NULL,'NGC 2543',NULL,'2009AJ....138..323T',2009,1,2.24,NULL,'G',0.00003,NULL,'13.2g',1.05,'SB(s)b','Isolated galaxy (6 Mpc isolation)',NULL,NULL,NULL,1,123.241333333,36.25464,0.197,NULL,64325325850,1005083216,15704425,13.2),(52629,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52629,32.53,0.43,32,14890,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2543',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52630,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52630,32.58,0.43,32.8,14890,75,NULL,'3.6 micron, color corrected','NGC 2543',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52631,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52631,32.67,0.2,34.2,14890,74.4,NULL,NULL,'NGC 2543',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52632,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52632,32.7,0.47,34.7,14890,NULL,NULL,'H','NGC 2543',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52633,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52633,32.71,0.45,34.9,14890,NULL,NULL,'K','NGC 2543',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52634,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52634,32.77,0.46,35.8,14890,NULL,NULL,'J','NGC 2543',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52635,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52635,32.81,0.4,36.5,14890,NULL,NULL,'mean','NGC 2543',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52636,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52636,35.61,0.17,132,14891,70,NULL,NULL,'MCG +10-12-092',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000163,NULL,'15.6g',0.47,'AGN',NULL,NULL,NULL,NULL,1,123.243041667,57.88364,0.085,NULL,61600901323,962514083,15039282,15.6),(52637,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52637,38.08,0.46,413,14892,70,NULL,NULL,'2MASX J08125846+2306522',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000153,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,123.243666667,23.11472,0.141,NULL,63764622716,996322229,15567534,18.6),(52638,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52638,36.85,0.46,235,14893,70,NULL,NULL,'2MASX J08125946+1013336',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.39',0.35,NULL,NULL,NULL,NULL,NULL,1,123.247917,10.22608,0.041,NULL,62793598829,981149981,15330468,17.39),(52639,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52639,37.96,0.46,391,14894,70,NULL,NULL,'2MASX J08130056+2312002',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,123.2522917,23.20003,0.141,NULL,63765074308,996329286,15567645,18.1),(52640,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52640,38.09,0.46,416,14895,70,NULL,NULL,'2MASX J08130274+1301094',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,123.261417,13.01922,0.069,NULL,62660684225,979073191,15298018,17.4),(52641,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52641,35.88,NULL,150,14896,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 119-011 NED01',NULL,'2010Ap&SS.325..163P',2010,1,0.78,NULL,'G',0.000008,NULL,'16.9g',0.17,'Sc',NULL,NULL,NULL,NULL,1,123.265333,24.567,0.173,NULL,63763420095,996303438,15567241,16.9),(52642,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52642,35.88,NULL,150,14896,NULL,NULL,'Dipole + Quadrupole','CGCG 119-011 NED01',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52643,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52643,35.89,NULL,151,14896,NULL,NULL,'Dipole','CGCG 119-011 NED01',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52644,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52644,38.45,0.46,491,14897,70,NULL,NULL,'2MASX J08130467+2627234',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,123.269417,26.45667,0.137,NULL,64298495977,1004663999,15697874,17.4),(52645,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52645,36.43,0.46,193,14898,70,NULL,NULL,'2MASX J08130687+0259557',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000147,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,123.278667,2.99872,0.085,NULL,62765089545,980704524,15323508,16.4),(52646,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52646,36.26,0.17,179,14899,70,NULL,NULL,'2MASX J08130780+1652321',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000192,NULL,'16.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,123.282417,16.87572,0.093,NULL,63782501626,996601587,15571899,16.3),(52647,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52647,37.47,0.46,311,14900,70,NULL,NULL,'2MASX J08130793+3817366',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000177,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,123.282875,38.29364,0.137,NULL,64324309294,1005067332,15704177,17.4),(52648,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52648,34.55,0.46,81.2,14901,70,NULL,NULL,'CGCG 263-016',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000087,NULL,'15.0g',0.55,NULL,NULL,NULL,NULL,NULL,1,123.288083333,54.63742,0.101,NULL,61548121623,961689400,15026396,15),(52649,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52649,37.59,0.27,330,14902,70,NULL,NULL,'2MASX J08131081+3120189',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000173,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,123.2949583,31.33853,0.089,NULL,64347581969,1005430968,15709858,17.9),(52650,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52650,38.01,0.46,400,14903,70,NULL,NULL,'2MASX J08131241+0209082',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,123.301833,2.15219,0.153,NULL,62767614572,980743977,15324124,17.4),(52651,'Brightest Stars','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52651,29.19,NULL,6.88,14904,NULL,NULL,NULL,'NGC 2537',NULL,'1999AstL...25..322S',1999,1,1.7,NULL,'G',0.000003,NULL,'12.32',1.5,'SB(s)m pec     HII','Pair member (points to parent)',NULL,NULL,'H II',1,123.311,45.98981,0.149,NULL,63532000372,992687505,15510742,12.32),(52652,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52652,29.78,0.4,9,14904,75,NULL,'B','NGC 2537',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (52653,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52653,36.26,0.21,178,14905,70,NULL,NULL,'2MASX J08131699+5507352',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00018,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,123.321,55.12658,0.097,NULL,61547804586,961684446,15026319,16.4),(52654,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52654,35.3,0.07,115,14906,NULL,NULL,NULL,'CGCG 287-053',NULL,'2009ApJS..182..474S',2009,1,0.86,NULL,'G',0.000023,NULL,'15.4g',0.4,'Sc','Group member',NULL,NULL,NULL,1,123.3217917,58.01053,0.093,NULL,61600873486,962513648,15039275,15.4),(52655,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52655,36.12,NULL,167,14907,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0729',NULL,'2010Ap&SS.325..163P',2010,1,0.95,NULL,'G',0.00003,NULL,'16.7g',0.16,'Sd',NULL,NULL,NULL,NULL,1,123.322333,20.96586,0.097,NULL,63814359141,997099361,15579677,16.7),(52656,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52656,36.14,NULL,169,14907,NULL,NULL,'Dipole + Quadrupole','FGC 0729',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52657,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52657,36.17,NULL,171,14907,NULL,NULL,'Dipole','FGC 0729',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52658,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52658,36.27,0.49,180,14907,75,NULL,'IR','FGC 0729',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52659,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52659,36.54,0.43,203,14907,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0729',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52660,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52660,36.63,0.43,212,14907,75,NULL,'3.6 micron, color corrected','FGC 0729',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52661,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52661,36.78,0.2,227,14907,74.4,NULL,NULL,'FGC 0729',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52662,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52662,36.26,0.17,179,14908,70,NULL,NULL,'2MASX J08131783+1649091',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000168,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,123.324375,16.81919,0.093,NULL,63782487578,996601368,15571896,16.6),(52663,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52663,36.67,0.33,216,14909,70,NULL,NULL,'2MASX J08131786+0947487',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,123.3244583,9.79694,0.041,NULL,62793733794,981152090,15330501,16.9),(52664,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52664,36.98,0.46,249,14910,70,NULL,NULL,'2MASX J08131846+0936067',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,123.327,9.60192,0.029,NULL,62793937304,981155270,15330551,17.3),(52665,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52665,37.85,0.46,372,14911,70,NULL,NULL,'2MASX J08132148+3352579',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,123.339458333,33.88294,0.165,NULL,64329405910,1005146967,15705421,17.9),(52666,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52666,35.84,0.46,147,14912,70,NULL,NULL,'2MASX J08132163+3721185',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,123.340167,37.35514,0.157,NULL,64327625187,1005119143,15704986,16.8),(52667,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52667,37.81,0.27,365,14913,70,NULL,NULL,'SDSS J081322.08+401524.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,123.3420417,40.25672,0.165,NULL,63518690503,992479539,15507492,18.4),(52668,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52668,34.95,0.5,97.9,14914,70,NULL,NULL,'2MASX J08132368-5717142',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000123,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,123.348625,-57.28719,1.349,NULL,40455569182,632118268,9876847,16),(52669,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52669,37.66,0.46,341,14915,70,NULL,NULL,'2MASX J08132450+5144213',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000181,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,123.35225,51.73919,0.133,NULL,63547303458,992926616,15514478,17.1),(52670,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52670,36.38,0.6,189,14916,70,NULL,NULL,'2MASX J08132490-1020099',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,123.35375,-10.33608,0.533,NULL,39426155985,616033687,9625526,15.3),(52671,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52671,38.44,0.46,488,14917,70,NULL,NULL,'2MASX J08132656+3548419',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00018,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,123.3607083,35.81178,0.209,NULL,64339168247,1005299503,15707804,17.8),(52672,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52672,36.32,0.46,184,14918,70,NULL,NULL,'2MASX J08132696+4049575',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,123.362333333,40.83272,0.173,NULL,63519444506,992491320,15507676,16.4),(52673,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52673,37.16,0.33,271,14919,70,NULL,NULL,'2MASX J08133013+3022518',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000154,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,123.3757083,30.38117,0.125,NULL,64346158949,1005408733,15709511,16.7),(52674,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52674,37.67,0.46,343,14920,70,NULL,NULL,'2MASX J08133078+4940542',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000087,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,123.3782083,49.68169,0.173,NULL,63551704746,992995386,15515552,17.1),(52675,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52675,38.15,0.17,426,14921,70,NULL,NULL,'2MASX J08133170+2256380',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,'FoF','16.6g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,123.382125,22.94392,0.161,NULL,63764718559,996323727,15567558,16.6),(52676,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52676,37.81,0.27,365,14922,70,NULL,NULL,'2MASX J08133180+4014594',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000151,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,123.382625,40.24983,0.165,NULL,63518688968,992479515,15507492,17.5),(52677,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52677,37.16,0.33,271,14923,70,NULL,NULL,'2MASX J08133244+3021278',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000149,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,123.385166667,30.35789,0.125,NULL,64346160738,1005408761,15709511,17.5),(52678,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52678,37.06,0.46,259,14924,70,NULL,NULL,'2MASX J08133317+2701326',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000179,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,123.38825,27.02572,0.101,NULL,64296224225,1004628503,15697320,16.8),(52679,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52679,38.15,0.17,426,14925,70,NULL,NULL,'SDSS J081334.09+225636.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000181,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,123.3920417,22.94356,0.161,NULL,63764718573,996323727,15567558,18.2),(52680,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52680,37.81,0.27,365,14926,70,NULL,NULL,'2MASX J08133448+4012014',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000189,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,123.3937083,40.20042,0.157,NULL,63518753592,992480524,15507508,16.8),(52681,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52681,36.71,0.46,220,14927,70,NULL,NULL,'2MASX J08133579+4551415',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000098,NULL,'16.0g',0.43,'E0',NULL,NULL,NULL,NULL,1,123.399083,45.86167,0.149,NULL,63532026642,992687916,15510748,16),(52682,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52682,36.76,0.46,225,14928,70,NULL,NULL,'2MASX J08133608+3748341',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000164,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,123.4002917,37.8095,0.137,NULL,64327665234,1005119769,15704996,16.7),(52683,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52683,37.68,0.46,344,14929,70,NULL,NULL,'2MASX J08133630+2016160',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000136,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,123.401167,20.27111,0.085,NULL,63814584848,997102888,15579732,18.5),(52684,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52684,37.9,0.27,380,14930,70,NULL,NULL,'2MASX J08133722+3425258',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000176,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,123.405125,34.42386,0.161,NULL,64339874639,1005310541,15707977,17.6),(52685,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52685,36.16,0.21,171,14931,70,NULL,NULL,'2MASX J08133866+5422311',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000191,NULL,'15.7g',0.52,NULL,NULL,NULL,NULL,NULL,1,123.410875,54.37519,0.089,NULL,61548173775,961690215,15026409,15.7),(52686,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52686,37.74,0.33,354,14932,70,NULL,NULL,'2MASX J08133889+4121541',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000184,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,123.412083,41.36503,0.173,NULL,63519207110,992487611,15507618,16.7),(52687,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52687,38.54,0.46,510,14933,70,NULL,NULL,'SDSS J081339.14+301319.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000116,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,123.413083,30.22203,0.125,NULL,64346178120,1005409033,15709516,18.7),(52688,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52688,38.26,0.46,449,14934,70,NULL,NULL,'2MASX J08134042+0209178',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,123.418375,2.15506,0.153,NULL,62767574943,980743358,15324114,17.6),(52689,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52689,35.76,0.2,142,14935,74.4,NULL,NULL,'KUG 0810+222',NULL,'2013AJ....146...86T',2013,1,0.56,NULL,'G',0.000013,NULL,'15.8g',0.36,NULL,'Group member, radial-velocity confirmed',NULL,NULL,NULL,1,123.421125,22.07031,0.121,NULL,63764133421,996314584,15567415,15.8),(52690,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52690,37.23,0.33,280,14936,70,NULL,NULL,'2MASX J08134169+1840060',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00019,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,123.423875,18.66825,0.121,NULL,63812420712,997069073,15579204,16.6),(52691,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52691,37.75,0.33,355,14937,70,NULL,NULL,'2MASX J08134178+3414320',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000192,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,123.424041667,34.24225,0.161,NULL,64339852634,1005310197,15707971,16.7),(52692,'CMD','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52692,15.7,0.22,0.0138,14938,NULL,NULL,NULL,'SDSS J081343.36+510531.6',NULL,'2008A&A...477..139L',2008,1,0.13,NULL,'G',NULL,NULL,'22.6g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,123.430667,51.09214,0.137,1,63546503604,992914118,15514283,22.6),(52693,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52693,37.23,0.33,280,14939,70,NULL,NULL,'2MASX J08134345+1840580',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000177,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,123.4309583,18.68281,0.121,NULL,63812421488,997069085,15579204,16.9),(52694,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52694,37.32,0.46,291,14940,70,NULL,NULL,'2MASX J08134425+1905340',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000181,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,123.434375,19.09292,0.077,NULL,63815999298,997124989,15580077,16.9),(52695,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52695,37.74,0.33,354,14941,70,NULL,NULL,'SDSS J081344.97+412229.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,123.437375,41.37478,0.173,NULL,63519205105,992487579,15507618,18.3),(52696,'GRB','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52696,37.99,NULL,396,14942,65,NULL,'L = 10e57 photons/s','2B 920501',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,123.429167,-35,NULL,NULL,42712357566,667380586,10427821,NULL),(52697,'GRB','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52697,40.92,NULL,1530,14942,65,NULL,'L = 2 x 10e58 photons/s','2B 920501',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52698,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52698,37.46,0.46,311,14943,70,NULL,NULL,'2MASX J08134499+3554590',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000137,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,123.437583333,35.91619,0.209,NULL,64339161530,1005299398,15707803,18.3),(52699,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52699,37.9,0.27,380,14944,70,NULL,NULL,'2MASX J08134507+3422030',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000195,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,123.437917,34.36756,0.161,NULL,64339890553,1005310789,15707981,17.2),(52700,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52700,35.25,0.08,112,14945,NULL,NULL,NULL,'SBS 0809+582',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000023,NULL,'15.7',0.25,'Sbc:',NULL,NULL,NULL,NULL,1,123.445833,58.0805,0.093,NULL,61601578587,962524665,15039447,15.7),(52701,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52701,35.29,0.09,115,14946,NULL,NULL,NULL,'SBS 0809+577',NULL,'2009ApJS..182..474S',2009,1,0.75,NULL,'G',0.000027,NULL,'16.1g',0.24,'Sbc',NULL,NULL,NULL,NULL,1,123.4542917,57.567,0.081,NULL,61600322504,962505039,15039141,16.1),(52702,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52702,36.51,0.46,200,14947,70,NULL,NULL,'2MASX J08135065+3402090',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000171,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,123.4609583,34.03594,0.173,NULL,64336958832,1005264981,15707265,16.3),(52703,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52703,36.76,0.46,225,14948,70,NULL,NULL,'IC 2234',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000194,NULL,'15.6g',0.55,'E0',NULL,NULL,NULL,NULL,1,123.465083,35.49292,0.193,NULL,64339216336,1005300255,15707816,15.6),(52704,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52704,37.82,0.46,366,14949,70,NULL,NULL,'2MASX J08135173+5334050',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,123.465291667,53.56822,0.101,NULL,63490143768,992033496,15500523,17.3),(52705,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52705,37.75,0.33,355,14950,70,NULL,NULL,'2MASX J08135226+3418360',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,123.467625,34.31014,0.161,NULL,64339891388,1005310802,15707981,17.8),(52706,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52706,38.63,0.46,532,14951,70,NULL,NULL,'2MASX J08135236+4156171',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00021,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,123.46825,41.93808,0.177,NULL,63522513643,992539275,15508426,17),(52707,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52707,36.44,0.46,194,14952,70,NULL,NULL,'2MASX J08135321+4242202',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000174,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,123.471667,42.70561,0.197,NULL,63521943818,992530372,15508287,17.1),(52708,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52708,38.15,0.17,426,14953,70,NULL,NULL,'2MASX J08135332+2245390',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,123.472208333,22.76081,0.165,NULL,63764934310,996327098,15567610,17.9),(52709,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52709,37.97,0.46,393,14954,70,NULL,NULL,'SDSS J081355.53+284941.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000136,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,123.481417,28.82811,0.117,NULL,64353458727,1005522792,15711293,18.7),(52710,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52710,33.97,NULL,62.4,14955,NULL,NULL,'Dipole','UGC 04277',NULL,'2010Ap&SS.325..163P',2010,1,3.9,NULL,'G',0.000037,NULL,'14.9g',0.4,'Sc','Isolated galaxy',NULL,NULL,NULL,1,123.4885,52.64847,0.105,NULL,63544259315,992879051,15513735,14.9),(52711,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52711,33.99,NULL,62.8,14955,NULL,NULL,'Dipole + Quadrupole','UGC 04277',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52712,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52712,34,NULL,63,14955,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04277',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52713,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52713,34.05,NULL,64.6,14955,NULL,NULL,NULL,'UGC 04277',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52714,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52714,34.38,0.47,75.1,14955,NULL,NULL,'H','UGC 04277',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52715,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52715,34.4,0.46,75.8,14955,NULL,NULL,'J','UGC 04277',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52716,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52716,34.41,0.45,76.1,14955,NULL,NULL,'K','UGC 04277',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52717,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52717,34.47,0.4,78.2,14955,NULL,NULL,'mean','UGC 04277',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52718,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52718,34.59,0.49,82.7,14955,75,NULL,'IR','UGC 04277',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52719,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52719,35,0.2,100,14955,74.4,NULL,NULL,'UGC 04277',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52720,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52720,35.02,0.4,101,14955,NULL,NULL,'Malmquist cor.','UGC 04277',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52721,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52721,35.16,0.38,108,14955,NULL,NULL,NULL,'UGC 04277',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52722,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52722,37.9,0.27,380,14956,70,NULL,NULL,'2MASX J08135839+3420170',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000153,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,123.4932083,34.33811,0.161,NULL,64339891685,1005310807,15707981,17.2),(52723,'TRGB','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52723,30.09,0.08,10.4,14957,NULL,NULL,NULL,'IC 2233',NULL,'2006astro.ph..3457T',2006,1,5.17,'Many SDSS entries strung out along the plane of this galaxy.','G',0.000003,NULL,'13.07',0.58,'SB(s)d: sp     HII','Possible group member',NULL,NULL,NULL,1,123.4954583,45.74214,0.145,NULL,63532023130,992687861,15510747,13.07),(52724,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52724,30.12,0.4,10.6,14957,75,NULL,'B','IC 2233',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52725,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52725,30.43,NULL,12.2,14957,NULL,NULL,NULL,'IC 2233',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52726,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52726,30.5,0.2,12.6,14957,74.4,NULL,NULL,'IC 2233',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52727,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52727,30.56,NULL,13,14957,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 2233',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52728,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52728,30.57,NULL,13,14957,NULL,NULL,'Dipole','IC 2233',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52729,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52729,30.57,NULL,13,14957,NULL,NULL,'Dipole + Quadrupole','IC 2233',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52730,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52730,30.64,0.49,13.4,14957,NULL,NULL,NULL,'IC 2233',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52731,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52731,30.68,0.4,13.7,14957,NULL,NULL,NULL,'IC 2233',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52732,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52732,30.69,NULL,13.8,14957,NULL,NULL,NULL,'IC 2233',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52733,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52733,30.74,0.43,14,14957,75,NULL,'3.6 micron, color corrected','IC 2233',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52734,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52734,30.82,0.43,14.6,14957,75,NULL,'3.6 micron, color + selection bias corrected','IC 2233',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52735,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52735,30.89,0.39,15.1,14957,73,NULL,'opt','IC 2233',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52736,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52736,30.98,0.42,15.7,14957,NULL,NULL,'Malmquist cor.','IC 2233',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52737,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52737,35.83,0.42,147,14958,NULL,NULL,'Malmquist cor.','ESO 060- G 001',NULL,'2009ApJS..182..474S',2009,1,1.1,'1981A&AS...46...57W has V = 5639 +- 156 km/sec.','G',0.000033,NULL,'15.95',0.7,'Sc',NULL,NULL,NULL,NULL,1,123.495875,-70.58869,0.653,NULL,40625212038,634768938,9918264,15.95),(52738,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52738,36.16,0.36,171,14958,NULL,NULL,NULL,'ESO 060- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52739,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52739,36.2,0.2,174,14958,74.4,NULL,NULL,'ESO 060- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52740,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52740,36.67,0.33,216,14959,70,NULL,NULL,'2MASX J08135977+0942036',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',NULL,NULL,'17.06',0.48,NULL,NULL,NULL,NULL,NULL,1,123.4989583,9.70103,0.029,NULL,62793749069,981152329,15330505,17.06),(52741,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52741,37.05,0.46,256,14960,70,NULL,NULL,'2MASX J08140001+4645352',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000073,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,123.50025,46.75997,0.149,NULL,63523835422,992559928,15508748,17.6),(52742,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52742,38.26,0.46,449,14961,70,NULL,NULL,'2MASX J08140049+0000591',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,123.5020417,0.01644,0.101,NULL,62696496119,979632751,15306761,17.8),(52743,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52743,38.12,0.46,421,14962,70,NULL,NULL,'2MASX J08140121+1045346',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,123.504958333,10.75981,0.057,NULL,62795405108,981178204,15330909,17.5),(52744,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52744,36.69,0.46,218,14963,70,NULL,NULL,'2MASX J08140147+5245090',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,123.506167,52.75247,0.105,NULL,63544250365,992878911,15513732,16.3),(52745,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52745,37.78,0.46,361,14964,70,NULL,NULL,'2MASX J08140221+0558328',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,123.509125,5.97569,0.033,NULL,62771444608,980803822,15325059,17.9),(52746,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52746,37.4,0.46,302,14965,70,NULL,NULL,'2MASX J08140300+4058411',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00014,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,123.512667,40.97808,0.173,NULL,63519565830,992493216,15507706,17.7),(52747,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52747,37.84,0.46,369,14966,70,NULL,NULL,'2MASX J08140348+4114251',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000152,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,123.51425,41.24022,0.181,NULL,63519384979,992490390,15507662,17.2),(52748,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52748,38.15,0.17,426,14967,70,NULL,NULL,'2MASX J08140499+2251538',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000172,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,123.520791667,22.86492,0.161,NULL,63764745286,996324145,15567564,17.1),(52749,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52749,38.15,0.17,426,14968,70,NULL,NULL,'2MASX J08140716+2249238',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000205,NULL,'16.8g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,123.529833,22.82333,0.161,NULL,63764743143,996324111,15567564,16.8),(52750,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52750,37.83,0.27,368,14969,70,NULL,NULL,'2MASX J08140790+3721031',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,123.532833,37.35075,0.157,NULL,64327611131,1005118923,15704983,16.3),(52751,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52751,37.18,0.46,273,14970,70,NULL,NULL,'2MASX J08140867+5659022',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00018,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,123.5362083,56.984,0.089,NULL,61601819488,962528429,15039506,16.9),(52752,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52752,35.35,NULL,117,14971,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0728',NULL,'2010Ap&SS.325..163P',2010,1,0.92,NULL,'G',0.000201,NULL,'17.1g',0.12,'Scd',NULL,NULL,NULL,NULL,1,123.541333,57.41194,0.081,NULL,61600368685,962505760,15039152,17.1),(52753,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52753,35.37,NULL,118,14971,NULL,NULL,'Dipole + Quadrupole','FGC 0728',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52754,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52754,35.38,NULL,119,14971,NULL,NULL,'Dipole','FGC 0728',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52755,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52755,35.4,NULL,120,14971,NULL,NULL,NULL,'FGC 0728',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52756,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52756,37.5,0.46,317,14972,70,NULL,NULL,'2MASX J08141106+0557074',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000137,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,123.546167,5.95194,0.053,NULL,62771445069,980803829,15325059,18.2),(52757,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52757,37.26,0.46,283,14973,70,NULL,NULL,'2MASX J08141250+2208528',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,123.552,22.14808,0.121,NULL,63764165119,996315079,15567423,17.2),(52758,'Ring Diameter','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52758,33.5,0.84,50,14974,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 2545',NULL,'1981ApJS...45..541P',1981,1,1.23,NULL,'G',0.000011,NULL,'13.4g',1.09,'(R)SB(r)ab     LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,123.559,21.35547,0.113,NULL,63814298743,997098417,15579662,13.4),(52759,'IRAS','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52759,33.38,0.8,47.4,14974,75,NULL,'HMCL, I','NGC 2545',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52760,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52760,33.54,0.4,51,14974,NULL,NULL,'mean','NGC 2545',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52761,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52761,33.68,0.47,54.5,14974,NULL,NULL,'H','NGC 2545',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52762,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52762,33.7,0.46,55,14974,NULL,NULL,'J','NGC 2545',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52763,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52763,33.7,0.45,55.1,14974,NULL,NULL,'K','NGC 2545',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52764,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52764,33.7,0.06,55.1,14974,NULL,NULL,NULL,'NGC 2545',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52765,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52765,33.78,0.4,57.1,14974,75,NULL,'HMCL, I, raw','NGC 2545',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52766,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52766,34.02,0.4,63.7,14974,75,NULL,'HMCL, I, inv','NGC 2545',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52767,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52767,34.13,0.4,67,14974,75,NULL,'HMCL, I, cor','NGC 2545',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52768,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52768,34.14,0.2,67.3,14974,74.4,NULL,NULL,'NGC 2545',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52769,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52769,37.93,0.46,385,14975,70,NULL,NULL,'2MASX J08141422+1453153',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,123.559417,14.88769,0.097,NULL,62661016832,979078388,15298099,17.2),(52770,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52770,37.31,0.46,289,14976,70,NULL,NULL,'2MASX J08141518+1414304',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000182,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,123.563333,14.24181,0.081,NULL,62661439126,979084986,15298202,16.2),(52771,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52771,34.55,0.4,81.1,14977,NULL,NULL,'mean','UGC 04286',NULL,'2007A&A...465...71T',2007,1,1.35,NULL,'G',0.000033,NULL,'14.4g',0.43,'SBb','Pair member (points to parent)',NULL,NULL,NULL,1,123.568666667,18.44067,0.125,NULL,63812414075,997068969,15579202,14.4),(52772,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52772,34.72,0.47,87.7,14977,NULL,NULL,'H','UGC 04286',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52773,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52773,34.84,0.45,92.9,14977,NULL,NULL,'K','UGC 04286',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52774,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52774,34.85,0.46,93.3,14977,NULL,NULL,'J','UGC 04286',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52775,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52775,36.04,NULL,162,14978,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0732',NULL,'2010Ap&SS.325..163P',2010,1,1.05,NULL,'G',0.00005,NULL,'16.7g',0.14,'Sd(f)',NULL,NULL,NULL,NULL,1,123.571083333,40.74717,0.169,NULL,63519525750,992492589,15507696,16.7),(52776,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52776,36.06,NULL,163,14978,NULL,NULL,'Dipole + Quadrupole','FGC 0732',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52777,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52777,36.08,NULL,164,14978,NULL,NULL,NULL,'FGC 0732',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52778,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52778,36.09,NULL,165,14978,NULL,NULL,'Dipole','FGC 0732',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52779,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52779,37.13,0.46,266,14979,70,NULL,NULL,'2MASX J08141733+2617010',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,123.572333,26.28372,0.129,NULL,64298355609,1004661806,15697840,17.2),(52780,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52780,36.26,0.21,178,14980,70,NULL,NULL,'2MASX J08141788+5508352',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,123.574583,55.14325,0.113,NULL,61547779330,961684052,15026313,17.4),(52781,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52781,35.34,0.07,117,14981,NULL,NULL,NULL,'SBS 0810+585',NULL,'2009ApJS..182..474S',2009,1,0.67,NULL,'G',0.000027,NULL,'14.42',NULL,'Sb',NULL,NULL,NULL,NULL,1,123.575833,58.38242,0.097,NULL,61601308592,962520446,15039381,14.42),(52782,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52782,37.75,0.46,355,14982,70,NULL,NULL,'2MASX J08141840+1312564',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,123.576625,13.21567,0.053,NULL,62648854456,978888350,15295130,NULL),(52783,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52783,35.61,0.17,132,14983,70,NULL,NULL,'2MASX J08142045+5752302',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000031,NULL,'15.9g',0.42,NULL,NULL,NULL,NULL,NULL,1,123.585417,57.87519,0.085,NULL,61600788884,962512326,15039255,15.9),(52784,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52784,38.2,0.46,437,14984,70,NULL,NULL,'2MASX J08142078+1830108',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,123.5865417,18.50314,0.125,NULL,63812409038,997068891,15579201,18.5),(52785,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52785,38.15,0.17,426,14985,70,NULL,NULL,'2MASX J08142076+2252448',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000135,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,123.586583333,22.87914,0.161,NULL,63764743357,996324114,15567564,18),(52786,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52786,37.72,0.46,349,14986,70,NULL,NULL,'SDSS J081421.19+343232.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00013,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,123.588333,34.54244,0.153,NULL,64339871853,1005310497,15707976,18.7),(52787,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52787,37.36,0.33,296,14987,70,NULL,NULL,'2MASX J08142123+3822525',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000167,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,123.5884583,38.38136,0.113,NULL,64324845721,1005075714,15704308,16.8),(52788,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52788,37.96,0.46,391,14988,70,NULL,NULL,'2MASX J08142161+5826042',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,123.5899583,58.43439,0.097,NULL,61601468488,962522945,15039421,16.8),(52789,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52789,37.46,0.46,310,14989,70,NULL,NULL,'2MASX J08142194+2038328',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,123.591583,20.64242,0.117,NULL,63815228123,997112939,15579889,17.7),(52790,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52790,37.33,0.46,292,14990,70,NULL,NULL,'SDSS J081421.99+040348.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000136,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,123.591625,4.06342,0.089,NULL,62770485658,980788838,15324825,18.1),(52791,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52791,37.69,0.46,346,14991,70,NULL,NULL,'2MASX J08142303+1627133',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,123.595833,16.45383,0.097,NULL,63780326981,996567609,15571368,17.3),(52792,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52792,38.34,0.46,465,14992,70,NULL,NULL,'2MASX J08142504+2949449',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00012,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,123.6044583,29.82922,0.133,NULL,64353844443,1005528819,15711387,18.6),(52793,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52793,36.26,0.21,178,14993,70,NULL,NULL,'2MASX J08142581+5508281',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,123.6077083,55.14117,0.113,NULL,61547788793,961684199,15026315,16.9),(52794,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52794,38.77,0.46,567,14994,70,NULL,NULL,'2MASX J08142719+5454011',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,123.613333,54.90025,0.097,NULL,61547942609,961686603,15026353,18.2),(52795,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52795,34.82,0.46,92.2,14995,70,NULL,NULL,'CGCG 207-047',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.00015,NULL,'14.8g',0.61,'S0',NULL,NULL,NULL,NULL,1,123.625125,43.14342,0.209,NULL,63519911556,992498618,15507790,14.8),(52796,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52796,37.46,0.46,311,14996,70,NULL,NULL,'SDSS J081431.92+403745.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,123.633083,40.62928,0.169,NULL,63518736519,992480258,15507504,18.1),(52797,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52797,37.56,0.46,325,14997,70,NULL,NULL,'2MASX J08143212+3515327',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000144,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,123.633833333,35.25914,0.181,NULL,64339319168,1005301862,15707841,17.5),(52798,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52798,35.56,0.46,130,14998,70,NULL,NULL,'2MASX J08143318+0400594',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000149,NULL,'16.0g',0.36,'E0',NULL,NULL,NULL,NULL,1,123.638291667,4.01661,0.089,NULL,62770483306,980788801,15324825,16),(52799,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52799,33.7,0.4,55.1,14999,NULL,NULL,'mean','UGC 04280',NULL,'2007A&A...465...71T',2007,1,1.43,NULL,'G',0.000033,NULL,'14.3g',0.42,'Sa','in a pair',NULL,NULL,NULL,1,123.6389583,54.79958,0.101,NULL,61547906822,961686044,15026344,14.3),(52800,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52800,33.99,0.47,62.9,14999,NULL,NULL,'H','UGC 04280',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52801,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52801,34,0.45,63.1,14999,NULL,NULL,'K','UGC 04280',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52802,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52802,34.06,0.46,64.9,14999,NULL,NULL,'J','UGC 04280',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52803,'BCG','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52803,36,0.35,154,15000,60,NULL,NULL,'ABELL 0634',0.0266,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,123.640416667,58.04786,0.093,NULL,61601691038,962526422,15039475,NULL),(52804,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52804,35.21,0.13,110,15000,70,NULL,NULL,'ABELL 0634',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52805,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52805,37.47,0.46,312,15001,70,NULL,NULL,'2MASX J08143381+5601009',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000177,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,123.641083,56.01706,0.137,NULL,61595267794,962426059,15037907,17.1),(52806,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52806,37.8,0.46,364,15002,70,NULL,NULL,'2MASX J08143554+3005357',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000121,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,123.648125,30.09333,0.097,NULL,64353756222,1005527440,15711366,17.7),(52807,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52807,36.21,0.46,175,15003,70,NULL,NULL,'2MASX J08143692+0659325',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000159,NULL,'16.1g',0.39,'E0',NULL,NULL,NULL,NULL,1,123.653875,6.9925,0.041,NULL,62800935377,981264615,15332259,16.1),(52808,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52808,36.58,0.46,207,15004,70,NULL,NULL,'2MASX J08143787+3429597',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,123.657875,34.49983,0.161,NULL,64340056412,1005313381,15708021,16.6),(52809,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52809,30.69,NULL,13.8,15005,NULL,NULL,'Dipole','ESO 430- G 026',NULL,'2010Ap&SS.325..163P',2010,1,2.8,'abs(b) < 10 degrees.','G',0.00001,NULL,'16.0',0.39,'Sd',NULL,NULL,NULL,NULL,1,123.6635,-31.34669,NULL,NULL,42741350842,667833606,10434900,16),(52810,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52810,30.75,NULL,14.1,15005,NULL,NULL,'Dipole + Quadrupole','ESO 430- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52811,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52811,30.75,NULL,14.1,15005,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 430- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52812,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52812,32.6,0.39,33.1,15005,73,NULL,'IR','ESO 430- G 026',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52813,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52813,32.6,0.39,33.1,15005,73,NULL,'opt','ESO 430- G 026',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52814,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52814,32.6,0.4,33.1,15005,75,NULL,NULL,'ESO 430- G 026',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52815,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52815,32.67,0.49,34.2,15005,75,NULL,'IR','ESO 430- G 026',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52816,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52816,36.33,0.46,184,15006,70,NULL,NULL,'2MASX J08143928+5536330',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,123.663875,55.60936,0.145,NULL,61549611457,961712679,15026760,16.9),(52817,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52817,37.83,0.27,368,15007,70,NULL,NULL,'2MASX J08143938+3711345',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,123.6639583,37.19303,0.157,NULL,64327897817,1005123403,15705053,17.4),(52818,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52818,37.88,0.46,378,15008,70,NULL,NULL,'2MASX J08143970+2103211',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000165,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,123.665541667,21.05586,0.113,NULL,63814497822,997101528,15579711,18.3),(52819,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52819,37.83,0.27,368,15009,70,NULL,NULL,'2MASX J08143972+3714165',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000185,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,123.665625,37.23803,0.157,NULL,64327884570,1005123196,15705049,17.2),(52820,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52820,36.02,0.46,160,15010,70,NULL,NULL,'2MASX J08143992+3811465',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000174,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,123.6664583,38.19628,0.117,NULL,64324199906,1005065623,15704150,16.4),(52821,'Cepheids','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52821,30.15,0.07,10.7,15011,73,NULL,'Cepheids magnitudes Gaussian ','NGC 2541',NULL,'2009RoAJ...19...35A',2009,1,6.3,NULL,'G',0.000003,NULL,'12.26',3.2,'SA(s)cd        LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,123.667167,49.06172,0.165,NULL,63551548889,992992951,15515514,12.26),(52822,'Cepheids','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52822,30.15,0.08,10.7,15011,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian ','NGC 2541',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52823,'Cepheids','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52823,30.16,0.1,10.8,15011,73,NULL,'Cepheids periods Gaussian ','NGC 2541',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52824,'Cepheids','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52824,30.25,0.05,11.2,15011,NULL,NULL,'29, VI, +Z, KEY PROJECT','NGC 2541',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52825,'Cepheids','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52825,30.25,0.05,11.2,15011,NULL,NULL,'29, VI, KEY PROJECT','NGC 2541',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52826,'Cepheids','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52826,30.31,0.09,11.5,15011,74.4,NULL,NULL,'NGC 2541',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52827,'Cepheids','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52827,30.32,0.08,11.6,15011,NULL,NULL,'LMC W01','NGC 2541',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52828,'Cepheids','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52828,30.33,0.06,11.6,15011,NULL,NULL,'MW HIPP','NGC 2541',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52829,'Cepheids','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52829,30.35,0.07,11.7,15011,NULL,NULL,'cte LMC K03','NGC 2541',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52830,'Cepheids','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52830,30.36,0.07,11.8,15011,NULL,NULL,'cte U99','NGC 2541',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52831,'Cepheids','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52831,30.38,0.07,11.9,15011,NULL,NULL,'cte LMC STS02','NGC 2541',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52832,'Cepheids','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52832,30.39,0.16,12,15011,NULL,NULL,'MW P02','NGC 2541',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52833,'Cepheids','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52833,30.43,0.07,12.2,15011,NULL,NULL,'cte MW FSG03','NGC 2541',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52834,'Cepheids','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52834,30.46,0.07,12.4,15011,NULL,NULL,'cte MF91','NGC 2541',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52835,'Cepheids','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52835,30.46,0.08,12.4,15011,NULL,NULL,'cte MW GFG98','NGC 2541',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52836,'Cepheids','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52836,30.47,0.08,12.4,15011,NULL,NULL,'27, VI','NGC 2541',NULL,'1998ApJ...507..655F',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52837,'Cepheids','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52837,30.47,0.07,12.4,15011,NULL,NULL,'MW GFG','NGC 2541',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52838,'Cepheids','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52838,30.47,0.07,12.4,15011,NULL,NULL,'88, VI','NGC 2541',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52839,'Cepheids','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52839,30.47,0.08,12.4,15011,NULL,NULL,'HST KP Calibrated','NGC 2541',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52840,'Cepheids','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52840,30.5,0.06,12.6,15011,NULL,18.54,'LMC ZP','NGC 2541',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52841,'Cepheids','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52841,30.54,0.08,12.8,15011,NULL,NULL,'cte MW STS03','NGC 2541',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52842,'Cepheids','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52842,31.05,NULL,16.2,15011,NULL,NULL,'28, VI','NGC 2541',NULL,'2006A&A...452..423P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52843,'TRGB','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52843,30.5,NULL,12.6,15011,NULL,18.54,NULL,'NGC 2541',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52844,'IRAS','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52844,30.33,0.8,11.7,15011,75,NULL,'A82, H','NGC 2541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52845,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52845,28.46,0.69,4.91,15011,100,NULL,'mid-IR','NGC 2541',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52846,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52846,29.82,0.4,9.2,15011,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 2541',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52847,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52847,30.13,0.4,10.6,15011,75,NULL,'B','NGC 2541',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52848,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52848,30.25,NULL,11.2,15011,NULL,NULL,'B','NGC 2541',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52849,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52849,30.25,0.05,11.2,15011,75,NULL,NULL,'NGC 2541',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52850,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52850,30.31,0.09,11.5,15011,74.4,NULL,NULL,'NGC 2541',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52851,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52851,30.32,NULL,11.6,15011,NULL,NULL,'I','NGC 2541',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52852,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52852,30.35,NULL,11.7,15011,NULL,NULL,'B','NGC 2541',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52853,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52853,30.35,0.1,11.7,15011,NULL,NULL,'I','NGC 2541',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52854,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52854,30.38,0.4,11.9,15011,73,NULL,'opt','NGC 2541',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52855,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52855,30.47,NULL,12.4,15011,NULL,NULL,NULL,'NGC 2541',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52856,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52856,30.49,0.35,12.5,15011,NULL,NULL,NULL,'NGC 2541',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52857,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52857,30.62,0.47,13.3,15011,75,NULL,'A82, H, inv','NGC 2541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52858,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52858,30.69,0.47,13.7,15011,75,NULL,'A82, H, raw','NGC 2541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52859,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52859,30.77,0.43,14.3,15011,75,NULL,'3.6 micron, color corrected','NGC 2541',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52860,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52860,30.81,0.43,14.5,15011,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2541',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52861,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52861,30.86,0.43,14.8,15011,NULL,NULL,NULL,'NGC 2541',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52862,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52862,30.94,0.47,15.4,15011,75,NULL,'A82, H, cor','NGC 2541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52863,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52863,31.14,0.38,16.9,15011,NULL,NULL,'Malmquist cor.','NGC 2541',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52864,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52864,38.16,0.46,428,15012,70,NULL,NULL,'SDSS J081442.75+334343.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000141,NULL,'18.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,123.678125,33.72886,0.173,NULL,64337182815,1005268481,15707320,18.8),(52865,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52865,37.24,0.46,280,15013,70,NULL,NULL,'2MASX J08144333+4235416',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'17.0g',0.31,NULL,NULL,NULL,NULL,NULL,1,123.680625,42.59494,0.197,NULL,63521867609,992529181,15508268,17),(52866,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52866,37.38,0.46,299,15014,70,NULL,NULL,'2MASX J08144421+4627256',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000101,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,123.6845,46.45731,0.129,NULL,63523892641,992560822,15508762,16.5),(52867,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52867,37.65,0.46,339,15015,70,NULL,NULL,'2MASX J08144538+3413534',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000169,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,123.689167,34.23164,0.173,NULL,64339862812,1005310356,15707974,18),(52868,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52868,37.36,0.33,296,15016,70,NULL,NULL,'2MASX J08144792+3826374',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,123.6997917,38.44361,0.113,NULL,64324859360,1005075927,15704311,17.9),(52869,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52869,37.83,0.46,368,15017,70,NULL,NULL,'2MASX J08144807+3331104',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000185,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,123.7002917,33.51953,0.173,NULL,64329511299,1005148614,15705447,16.8),(52870,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52870,37.88,0.46,376,15018,70,NULL,NULL,'SDSS J081448.37+565021.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000166,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,123.7015417,56.83922,0.109,NULL,61601851208,962528925,15039514,18.6),(52871,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52871,37.57,0.46,326,15019,70,NULL,NULL,'2MASX J08145147+5204104',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,123.714417,52.06961,0.121,NULL,63546091426,992907678,15514182,17.4),(52872,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52872,36.28,0.46,181,15020,70,NULL,NULL,'MCG +08-15-055',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000096,NULL,'15.5g',0.5,'E0',NULL,NULL,NULL,NULL,1,123.72175,45.79203,0.141,NULL,63531773614,992683962,15510686,15.5),(52873,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52873,38.03,0.46,404,15021,70,NULL,NULL,'2MASX J08145381+1811531',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000175,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,123.724167,18.19808,0.125,NULL,63782000299,996593754,15571777,17),(52874,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52874,33.84,0.49,58.7,15022,75,NULL,'IR','ESO 561- G 032',NULL,'2011yCatp016004901K',2011,1,1.93,'abs(b) < 10 degrees.','G',0.00002,NULL,'16.0',0.17,'Scd',NULL,NULL,NULL,NULL,1,123.7345417,-22.01806,NULL,NULL,42216932464,659639569,10306868,16),(52875,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52875,34.38,NULL,75.1,15022,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 561- G 032',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52876,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52876,34.38,NULL,75.1,15022,NULL,NULL,'Dipole','ESO 561- G 032',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52877,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52877,34.39,NULL,75.5,15022,NULL,NULL,'Dipole + Quadrupole','ESO 561- G 032',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52878,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52878,35.4,0.58,120,15023,70,NULL,NULL,'2MFGC 06530',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000133,NULL,'11.2K',NULL,NULL,NULL,NULL,NULL,NULL,1,123.738167,-61.73514,0.685,NULL,40565092369,633829568,9903587,11.2),(52879,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52879,35.98,0.46,157,15024,70,NULL,NULL,'2MASX J08145953+5805580',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,123.747833333,58.0995,0.109,NULL,61601688467,962526382,15039474,16.4),(52880,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52880,37.93,0.46,385,15025,70,NULL,NULL,'2MASX J08145985+5018244',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000079,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,123.749333,50.30672,0.149,NULL,63548338511,992942789,15514731,17.7),(52881,'Ring Diameter','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52881,32.3,0.84,29,15026,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 2523',NULL,'1981ApJS...45..541P',1981,1,3,NULL,'G',0.00004,NULL,'12.63',1.8,'SB(r)bc','Pair member (points to parent)',NULL,NULL,NULL,1,123.750375,73.57897,0.097,NULL,61289352180,957646127,14963220,12.63),(52882,'Sosies','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52882,32.92,0.28,38.4,15026,NULL,NULL,NULL,'NGC 2523',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52883,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52883,33.5,0.4,50.1,15026,NULL,NULL,'mean','NGC 2523',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52884,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52884,33.89,0.46,60,15026,NULL,NULL,'J','NGC 2523',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52885,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52885,33.89,0.45,60.1,15026,NULL,NULL,'K','NGC 2523',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52886,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52886,33.92,0.47,60.8,15026,NULL,NULL,'H','NGC 2523',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52887,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52887,38.08,0.46,413,15027,70,NULL,NULL,'2MASX J08150185+3000104',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000136,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,123.757667,30.00292,0.097,NULL,64353753974,1005527405,15711365,17.5),(52888,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52888,38.18,0.46,433,15028,70,NULL,NULL,'2MASX J08150414+4040095',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,123.767333333,40.66933,0.165,NULL,63519491074,992492048,15507688,17.8),(52889,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52889,34.8,0.46,91.2,15029,70,NULL,NULL,'CGCG 119-017',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000165,NULL,'15.2g',0.52,NULL,NULL,NULL,NULL,NULL,1,123.7685417,25.60867,0.153,NULL,64297970831,1004655794,15697746,15.2),(52890,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52890,37.49,0.46,315,15030,70,NULL,NULL,'2MASX J08150486+3859545',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00014,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,123.770417,38.99831,0.141,NULL,64324056808,1005063387,15704115,18.1),(52891,'GRB','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52891,46.41,1.61,6600,15031,NULL,NULL,NULL,'GRB 020127',1.9,'2010JCAP...08..020W',2010,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,123.775,36.73333,0.177,NULL,64327149939,1005111717,15704870,NULL),(52892,'GRB','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52892,42.84,NULL,3690,15032,70,NULL,'Pseudo z = 2.67','GRB 020127',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,123.775,36.73333,0.177,NULL,64327149939,1005111717,15704870,NULL),(52893,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52893,35.82,0.46,146,15033,70,NULL,NULL,'CGCG 088-054',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000198,NULL,'15.3g',0.45,NULL,NULL,NULL,NULL,NULL,1,123.783916667,17.89131,0.101,NULL,63782241545,996597524,15571836,15.3),(52894,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52894,37.81,0.46,364,15034,70,NULL,NULL,'2MASX J08150823+1744052',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000182,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,123.7842083,17.73472,0.077,NULL,63782207147,996596986,15571827,17.2),(52895,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52895,36.98,0.46,249,15035,70,NULL,NULL,'SDSS J081508.30+200949.8',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000171,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,123.784583333,20.16386,0.109,NULL,63815029473,997109835,15579841,17.2),(52896,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52896,36.07,0.46,164,15036,70,NULL,NULL,'2MASX J08150839+5418359',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000166,NULL,'16.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,123.7847917,54.30997,0.117,NULL,61548141419,961689709,15026401,16.4),(52897,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52897,35.61,0.17,132,15037,70,NULL,NULL,'2MASX J08150842+5840569',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'15.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,123.785417,58.6825,0.125,NULL,61601274102,962519907,15039373,15.9),(52898,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52898,37.16,0.46,270,15038,70,NULL,NULL,'2MASX J08150994+4804507',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000099,NULL,'16.5g',0.31,'AGN',NULL,NULL,NULL,NULL,1,123.791625,48.08061,0.157,NULL,63542206687,992846979,15513234,16.5),(52899,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52899,37.65,0.21,339,15039,70,NULL,NULL,'2MASX J08151042+0339068',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000148,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,123.7935,3.65181,0.121,NULL,62778317980,980911218,15326737,16.5),(52900,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52900,37.53,0.33,321,15040,70,NULL,NULL,'2MASX J08151162+1155032',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,123.798583,11.91756,0.037,NULL,62781600296,980962504,15327539,16.9),(52901,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52901,37.65,0.21,339,15041,70,NULL,NULL,'2MASX J08151389+0349208',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000134,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,123.8080417,3.82236,0.093,NULL,62770708819,980792325,15324880,17.1),(52902,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52902,38.6,0.46,525,15042,70,NULL,NULL,'2MASX J08151442+3516114',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,123.810333333,35.26975,0.181,NULL,64339187878,1005299810,15707809,18.2),(52903,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52903,38.82,0.46,581,15043,70,NULL,NULL,'2MASX J08151452+1441222',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000177,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,123.810625,14.68958,0.073,NULL,62647279087,978863735,15294745,17.8),(52904,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52904,37.65,0.21,339,15044,70,NULL,NULL,'2MASX J08151523+0343408',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000161,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,123.8135417,3.72806,0.121,NULL,62778313372,980911146,15326736,17.4),(52905,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52905,37.49,0.46,315,15045,70,NULL,NULL,'SDSS J081515.26+210838.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000149,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,123.813625,21.14403,0.113,NULL,63814453988,997100843,15579700,18.5),(52906,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52906,34.24,NULL,70.6,15046,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0725',NULL,'2010Ap&SS.325..163P',2010,1,0.94,NULL,'G',0.000073,':','16.7',0.09,'Sd',NULL,NULL,NULL,NULL,1,123.815,71.03806,0.085,NULL,62190540434,971727194,15183237,16.7),(52907,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52907,34.27,NULL,71.4,15046,NULL,NULL,'Dipole + Quadrupole','FGC 0725',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52908,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52908,34.28,NULL,71.7,15046,NULL,NULL,'Dipole','FGC 0725',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52909,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52909,34.32,NULL,73.2,15046,NULL,NULL,NULL,'FGC 0725',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52910,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52910,37.74,0.46,353,15047,70,NULL,NULL,'2MASX J08151608+3458594',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,123.817167,34.98322,0.165,NULL,64339982110,1005312220,15708003,18),(52911,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52911,36.88,0.46,238,15048,70,NULL,NULL,'2MASX J08151931+4503333',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000089,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,123.830583,45.05928,0.153,NULL,63534761061,992730641,15511416,16.7),(52912,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52912,34.02,0.43,63.7,15049,75,NULL,'3.6 micron, color + selection bias corrected','LSBC F561-02',NULL,'2014MNRAS.444..527S',2014,1,1.31,NULL,'G',0.000012,NULL,'15.9g',0.26,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,123.838917,21.55817,0.117,NULL,63816345914,997130404,15580162,15.9),(52913,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52913,34.11,0.43,66.2,15049,75,NULL,'3.6 micron, color corrected','LSBC F561-02',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52914,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52914,34.18,0.49,68.6,15049,75,NULL,'IR','LSBC F561-02',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52915,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52915,34.19,0.2,68.9,15049,74.4,NULL,NULL,'LSBC F561-02',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52916,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52916,34.26,0.13,71.3,15049,NULL,NULL,NULL,'LSBC F561-02',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52917,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52917,34.5,NULL,79.5,15049,NULL,NULL,'Dipole','LSBC F561-02',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52918,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52918,34.5,NULL,79.6,15049,NULL,NULL,'Dipole + Quadrupole','LSBC F561-02',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52919,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52919,34.5,NULL,79.6,15049,NULL,NULL,'Dipole + Quadrupole + Octopole','LSBC F561-02',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52920,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52920,34.56,NULL,81.7,15049,NULL,NULL,NULL,'LSBC F561-02',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52921,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52921,37.77,0.46,358,15050,70,NULL,NULL,'2MASX J08152152+1220032',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,123.839708333,12.33433,0.081,NULL,62648347066,978880422,15295006,16.7),(52922,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52922,36.96,0.46,247,15051,70,NULL,NULL,'2MASX J08152172+1146366',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,123.840458333,11.77689,0.037,NULL,62781488575,980960758,15327511,16.9),(52923,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52923,37.34,0.46,294,15052,70,NULL,NULL,'2MASX J08152178+2930404',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000136,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,123.841,29.51133,0.081,NULL,64354092610,1005532697,15711448,17.2),(52924,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52924,38.03,0.33,404,15053,70,NULL,NULL,'2MASX J08152201+0756206',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,123.841667,7.93892,0.037,NULL,62791120217,981111253,15329863,18.1),(52925,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52925,37.77,0.46,358,15054,70,NULL,NULL,'2MASX J08152201+5605348',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00017,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,123.841708333,56.09303,0.133,NULL,61594547195,962414799,15037731,18.2),(52926,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52926,38.15,0.17,426,15055,70,NULL,NULL,'2MASX J08152228+2243460',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.00021,NULL,'16.2g',0.5,'BrClG',NULL,NULL,NULL,NULL,1,123.842917,22.72931,0.165,NULL,63764843185,996325674,15567588,16.2),(52927,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52927,37.53,0.33,321,15056,70,NULL,NULL,'2MASX J08152321+1157152',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.5g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,123.84675,11.95419,0.037,NULL,62781564850,980961950,15327530,16.5),(52928,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52928,37.65,0.21,339,15057,70,NULL,NULL,'2MASX J08152325+0355458',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000158,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,123.8469583,3.92953,0.093,NULL,62770720649,980792510,15324882,17.2),(52929,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52929,36.94,0.46,244,15058,70,NULL,NULL,'2MASX J08152396+1811129',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000178,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,123.849833333,18.18692,0.125,NULL,63782048027,996594500,15571789,17.5),(52930,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52930,36.62,0.46,210,15059,70,NULL,NULL,'2MASX J08152439+2547294',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000169,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,123.851625,25.79161,0.141,NULL,64298418565,1004662790,15697856,16.8),(52931,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52931,37.53,0.46,321,15060,70,NULL,NULL,'2MASX J08152456+2518484',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,123.852333,25.31336,0.149,NULL,64295164236,1004611941,15697061,16.7),(52932,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52932,36.22,0.46,176,15061,70,NULL,NULL,'2MASX J08152484+5319158',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000185,NULL,'16.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,123.853375,53.32092,0.121,NULL,63489999082,992031235,15500488,16.6),(52933,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52933,35.61,0.17,132,15062,70,NULL,NULL,'CGCG 287-060',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000334,NULL,'14.7',0.25,'E','Group member',NULL,NULL,NULL,1,123.8567083,58.17894,0.129,NULL,61601715275,962526801,15039481,14.7),(52934,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52934,37.97,0.46,393,15063,70,NULL,NULL,'2MASX J08152684+1323042',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,123.8620417,13.3845,0.085,NULL,62649286976,978895109,15295236,17.8),(52935,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52935,34.67,NULL,85.9,15064,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04296',NULL,'2010Ap&SS.325..163P',2010,1,1.3,'Bright star superposed.','G',0.000007,NULL,'15.9',0.11,'Sd',NULL,NULL,NULL,NULL,1,123.871083,8.34525,0.013,NULL,62791170318,981112036,15329875,15.9),(52936,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52936,34.69,NULL,86.5,15064,NULL,NULL,'Dipole + Quadrupole','UGC 04296',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52937,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52937,34.69,NULL,86.7,15064,NULL,NULL,'Dipole','UGC 04296',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52938,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52938,34.74,NULL,88.6,15064,NULL,NULL,NULL,'UGC 04296',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52939,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52939,35.3,0.2,115,15064,74.4,NULL,NULL,'UGC 04296',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52940,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52940,35.41,0.43,121,15064,75,NULL,'3.6 micron, color corrected','UGC 04296',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52941,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52941,35.49,0.49,126,15064,75,NULL,'IR','UGC 04296',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52942,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52942,35.52,0.43,127,15064,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04296',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52943,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52943,37.5,0.46,316,15065,70,NULL,NULL,'2MASX J08152954+1247482',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,123.872958333,12.79669,0.105,NULL,62649248064,978894501,15295226,17.5),(52944,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52944,36.68,0.46,217,15066,70,NULL,NULL,'2MASX J08152968+2533133',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000195,NULL,'16.0g',0.45,'E0',NULL,NULL,NULL,NULL,1,123.87375,25.55381,0.153,NULL,64295147408,1004611678,15697057,16),(52945,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52945,38.15,0.46,426,15067,70,NULL,NULL,'2MASX J08153047+0912015',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,123.877083,9.20056,0.005,NULL,62793227404,981144178,15330377,17.8),(52946,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52946,36.42,0.46,193,15068,70,NULL,NULL,'2MASX J08153127+4420073',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000163,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,123.880125,44.33531,0.189,NULL,63535187606,992737306,15511520,16.4),(52947,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52947,37.32,0.46,291,15069,70,NULL,NULL,'2MASX J08153144+4007367',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,123.8809583,40.12675,0.157,NULL,63518569534,992477648,15507463,18),(52948,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52948,37.65,0.21,339,15070,70,NULL,NULL,'2MASX J08153173+0350398',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000163,NULL,'16.5g',0.39,'BrClG',NULL,NULL,NULL,NULL,1,123.882375,3.8445,0.093,NULL,62770715373,980792427,15324881,16.5),(52949,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52949,36.95,0.46,246,15071,70,NULL,NULL,'2MASX J08153684+4050147',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000192,NULL,'16.1g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,123.903625,40.83744,0.165,NULL,63519522722,992492542,15507695,16.1),(52950,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52950,37.89,0.33,378,15072,70,NULL,NULL,'2MASX J08153707+2518058',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000132,NULL,'18.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,123.9045,25.30161,0.149,NULL,64295162740,1004611917,15697061,18.8),(52951,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52951,37.65,0.46,339,15073,70,NULL,NULL,'2MASX J08153794+2136324',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,123.908083333,21.60914,0.129,NULL,63816372389,997130818,15580169,17.5),(52952,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52952,37.91,0.46,381,15074,70,NULL,NULL,'2MASX J08153857+0810478',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,123.910625,8.18,0,NULL,62791193372,981112396,15329881,16.6),(52953,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52953,38.8,0.46,576,15075,70,NULL,NULL,'2MASX J08154142+3026294',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000184,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,123.922666667,30.44144,0.061,NULL,64356616541,1005572133,15712064,17.7),(52954,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52954,36.69,0.62,217,15076,70,NULL,NULL,'2MASX J08154159-1548314',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.4,NULL,NULL,NULL,NULL,NULL,1,123.9232917,-15.80869,0.085,NULL,42251577739,660180902,10315326,14.2),(52955,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52955,36.91,0.46,241,15077,70,NULL,NULL,'2MASX J08154193+4626591',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000107,NULL,'16.0g',0.43,'E0',NULL,NULL,NULL,NULL,1,123.9249583,46.44992,0.129,NULL,63523880755,992560636,15508759,16),(52956,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52956,36.77,0.57,226,15078,70,NULL,NULL,'2MASX J08154333-0416069',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.54',0.4,'poss. LINER',NULL,NULL,NULL,NULL,1,123.930667,-4.26864,0.261,NULL,39436729704,616198901,9628107,16.54),(52957,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52957,38.03,0.33,404,15079,70,NULL,NULL,'2MASX J08154396+0752008',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000175,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,123.9332917,7.86692,0.005,NULL,62792184128,981127877,15330123,17),(52958,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52958,37.17,0.33,272,15080,70,NULL,NULL,'2MASX J08154452+5518459',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000172,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,123.935417,55.31275,0.117,NULL,61550669012,961729203,15027018,17.7),(52959,'BCG','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52959,36,0.35,154,15081,60,NULL,'ABELL 0634, BCG','UGC 04289',0.0266,'1980ApJ...241..486H',1980,1,1,NULL,'G',0.000031,NULL,'13.09',0.8,'E','Group member',NULL,NULL,NULL,1,123.936833,58.321,0.129,NULL,61601385989,962521656,15039400,13.09),(52960,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52960,35.61,0.17,132,15081,70,NULL,NULL,'UGC 04289',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52961,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52961,35.09,0.45,104,15081,NULL,NULL,'K','UGC 04289',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52962,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52962,35.21,0.13,110,15081,70,NULL,'ABELL 0634, BGC','UGC 04289',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52963,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52963,35.21,0.4,110,15081,NULL,NULL,'mean','UGC 04289',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52964,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52964,38.3,0.46,457,15082,70,NULL,NULL,'2MASX J08154483+0826508',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,123.93675,8.4475,0.013,NULL,62791486767,981116980,15329952,17.6),(52965,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52965,37.37,0.46,298,15083,70,NULL,NULL,'2MASX J08154516+0351593',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00013,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,123.938125,3.86636,0.093,NULL,62770769354,980793271,15324894,17.5),(52966,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52966,35.01,0.46,101,15084,70,NULL,NULL,'2MASX J08155048+4748391',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000071,NULL,'15.8g',0.46,'NLAGN',NULL,NULL,NULL,NULL,1,123.960333333,47.811,0.157,NULL,63542517364,992851833,15513309,15.8),(52967,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52967,37.05,0.46,257,15085,70,NULL,NULL,'2MASX J08155081+3557536',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000172,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,123.961833,35.96486,0.209,NULL,64339110934,1005298608,15707790,17),(52968,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52968,37.89,0.33,378,15086,70,NULL,NULL,'2MASX J08155219+2522278',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,123.967417,25.37447,0.149,NULL,64295192284,1004612379,15697068,17.5),(52969,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52969,37.7,0.46,347,15087,70,NULL,NULL,'2MASX J08155235+4311131',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000186,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,123.968,43.187,0.209,NULL,63520071258,992501113,15507829,17.8),(52970,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52970,38.32,0.46,461,15088,70,NULL,NULL,'SDSS J081553.13+134017.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000175,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,123.971417,13.67158,0.093,NULL,62649483959,978898186,15295284,18.4),(52971,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52971,35.96,0.46,156,15089,70,NULL,NULL,'2MASX J08155313+5145450',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00018,NULL,'16.1g',0.39,NULL,NULL,NULL,NULL,NULL,1,123.9714583,51.76258,0.149,NULL,63546315892,992911185,15514237,16.1),(52972,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52972,38.29,0.46,455,15090,70,NULL,NULL,'2MASX J08155363+0626258',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,123.973417,6.44064,0.025,NULL,62797726462,981214475,15331476,17.7),(52973,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52973,37.85,0.46,371,15091,70,NULL,NULL,'SDSS J081554.86+153829.9',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'17.9g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,123.978625,15.64167,0.093,NULL,63779874435,996560538,15571258,17.9),(52974,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52974,38.09,0.46,416,15092,70,NULL,NULL,'2MASX J08155521+3836106',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000181,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,123.9800417,38.603,0.121,NULL,64324882791,1005076293,15704317,18.1),(52975,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52975,36.53,0.75,202,15093,70,NULL,NULL,'2MASX J08155713-1627504',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,123.988083,-16.46394,0.333,NULL,42252138818,660189669,10315463,14.2),(52976,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52976,36.74,0.46,223,15094,70,NULL,NULL,'2MASX J08155824+4441041',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000086,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,123.9927083,44.68458,0.165,NULL,63534685772,992729465,15511397,17.2),(52977,'IRAS','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52977,33.83,0.8,58.3,15095,75,NULL,'CF, r','IC 2247',NULL,'1997ApJS..109..333W',1997,1,1.92,NULL,'G',0.000013,NULL,'14.6g',0.34,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,123.99625,23.19961,0.153,NULL,63764270209,996316722,15567448,14.6),(52978,'IRAS','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52978,33.84,0.8,58.6,15095,75,NULL,'HMCL, I','IC 2247',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52979,'IRAS','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52979,33.87,0.8,59.4,15095,75,NULL,'W91CL, r','IC 2247',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52980,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52980,33.67,0.4,54.3,15095,75,NULL,'HMCL, I, raw','IC 2247',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52981,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52981,33.74,0.43,55.9,15095,75,NULL,'3.6 micron, color + selection bias corrected','IC 2247',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52982,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52982,33.75,0.47,56.4,15095,NULL,NULL,'H','IC 2247',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52983,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52983,33.76,0.38,56.4,15095,75,NULL,'CF, r, raw','IC 2247',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52984,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52984,33.77,0.38,56.9,15095,75,NULL,'W91CL, r, raw','IC 2247',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52985,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52985,33.79,0.45,57.2,15095,NULL,NULL,'K','IC 2247',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52986,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52986,33.82,0.43,58,15095,75,NULL,'3.6 micron, color corrected','IC 2247',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52987,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52987,33.84,0.4,58.7,15095,75,NULL,'HMCL, I, inv','IC 2247',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52988,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52988,33.87,0.46,59.5,15095,NULL,NULL,'J','IC 2247',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52989,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52989,33.88,0.38,59.6,15095,75,NULL,'CF, r, inv','IC 2247',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52990,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',52990,33.88,0.49,59.8,15095,75,NULL,'IR','IC 2247',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52991,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52991,33.9,0.38,60.3,15095,75,NULL,'W91CL, r, inv','IC 2247',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52992,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52992,33.92,0.2,60.8,15095,74.4,NULL,NULL,'IC 2247',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52993,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52993,33.99,0.4,62.7,15095,NULL,NULL,'mean','IC 2247',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52994,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52994,34.06,0.4,64.9,15095,75,NULL,'HMCL, I, cor','IC 2247',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52995,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52995,34.1,0.38,66,15095,75,NULL,'CF, r, cor','IC 2247',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52996,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52996,34.12,0.38,66.6,15095,75,NULL,'W91CL, r, cor','IC 2247',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52997,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52997,34.26,0.11,71.3,15095,NULL,NULL,NULL,'IC 2247',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52998,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52998,34.31,NULL,72.7,15095,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 2247',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52999,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,52999,34.31,NULL,72.8,15095,NULL,NULL,'Dipole + Quadrupole','IC 2247',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53000,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53000,34.31,NULL,72.9,15095,NULL,NULL,'Dipole','IC 2247',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53001,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53001,34.37,NULL,74.8,15095,NULL,NULL,NULL,'IC 2247',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53002,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53002,36.76,0.46,224,15096,70,NULL,NULL,'2MASX J08155926+0825008',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,123.997,8.41692,0.013,NULL,62791945987,981124156,15330064,17.5),(53003,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53003,35.74,0.46,141,15097,70,NULL,NULL,'2MASX J08160068+2140343',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000173,NULL,'15.8g',0.42,'S0',NULL,NULL,NULL,NULL,1,124.0027083,21.67608,0.129,NULL,63809027809,997016059,15578375,15.8),(53004,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53004,35.39,0.13,120,15098,NULL,NULL,NULL,'SBS 0811+584',NULL,'2009ApJS..182..474S',2009,1,0.11,NULL,'G',0.000033,NULL,'18.6g',0.07,'LINER          Sy2',NULL,NULL,NULL,'Sy 2',1,124.005875,58.33431,0.129,NULL,61601383513,962521617,15039400,18.6),(53005,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53005,35.6,0.49,132,15098,75,NULL,'IR','SBS 0811+584',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53006,'IRAS','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53006,34.63,0.8,84.5,15099,75,NULL,'CF, r','UGC 04301',NULL,'1997ApJS..109..333W',1997,1,1.38,NULL,'G',0.000033,NULL,'14.3g',0.55,'Sbc',NULL,NULL,NULL,NULL,1,124.0090417,28.62475,0.109,NULL,64353275665,1005519932,15711248,14.3),(53007,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53007,34.4,0.38,75.9,15099,75,NULL,'CF, r, raw','UGC 04301',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53008,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53008,34.52,0.2,80.2,15099,74.4,NULL,NULL,'UGC 04301',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53009,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53009,34.53,0.38,80.5,15099,75,NULL,'CF, r, inv','UGC 04301',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53010,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53010,34.54,0.38,81.1,15099,75,NULL,'CF, r, cor','UGC 04301',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53011,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53011,34.58,0.49,82.3,15099,NULL,NULL,'Malmquist cor.','UGC 04301',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53012,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53012,34.76,0.45,89.7,15099,NULL,NULL,NULL,'UGC 04301',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53013,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53013,34.81,0.4,91.6,15099,NULL,NULL,'mean','UGC 04301',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53014,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53014,35.12,0.47,106,15099,NULL,NULL,'H','UGC 04301',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53015,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53015,38.19,0.46,435,15100,70,NULL,NULL,'2MASX J08160227+3604186',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,124.009583,36.07183,0.209,NULL,64325165351,1005080708,15704386,17.1),(53016,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53016,37.91,0.46,382,15101,70,NULL,NULL,'2MASX J08160308+4853081',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00007,NULL,'17.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,124.0127083,48.88564,0.141,NULL,63551320456,992989382,15515459,17.7),(53017,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53017,36.55,0.63,205,15102,70,NULL,NULL,'2MASX J08160488-0648480',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.38',0.3,NULL,NULL,NULL,NULL,NULL,1,124.020375,-6.81342,0.337,NULL,39444253965,616316468,9629944,16.38),(53018,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53018,36.73,0.46,221,15103,70,NULL,NULL,'2MASX J08160549+5548240',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000156,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,124.022666667,55.80656,0.137,NULL,61549763644,961715056,15026797,17),(53019,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53019,37.14,0.46,267,15104,70,NULL,NULL,'2MASX J08160576+5859567',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,124.0239583,58.99919,0.125,NULL,61564583488,961946617,15030415,16.9),(53020,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53020,36.26,0.21,178,15105,70,NULL,NULL,'2MASX J08160680+5510387',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00016,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,124.0285,55.17731,0.117,NULL,61550866849,961732294,15027067,16.9),(53021,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53021,37.15,0.46,269,15106,70,NULL,NULL,'2MASX J08160733+2041589',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000153,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,124.030583,20.69964,0.117,NULL,63815101403,997110959,15579858,16.8),(53022,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53022,38.08,0.46,414,15107,70,NULL,NULL,'2MASX J08160771+2500229',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000178,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,124.03225,25.00642,0.145,NULL,64295246398,1004613224,15697081,16.9),(53023,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53023,37.14,0.46,268,15108,70,NULL,NULL,'2MASX J08160797+1042242',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.2g',NULL,NULL,NULL,NULL,NULL,NULL,1,124.033125,10.70669,0.033,NULL,62795694995,981182734,15330980,17.2),(53024,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53024,37.73,0.17,351,15109,70,NULL,NULL,'2MASX J08161023+3712507',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,124.0427083,37.21425,0.133,NULL,64327985958,1005124780,15705074,18.1),(53025,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53025,35.94,0.59,154,15110,70,NULL,NULL,'ESO 060-IG 002 NED02',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000143,NULL,'15.5',NULL,NULL,NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,124.049625,-70.66247,0.669,NULL,40624682106,634760657,9918135,15.5),(53026,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53026,38.31,0.46,460,15111,70,NULL,NULL,'2MASX J08161328+5431431',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000164,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,124.055333,54.52869,0.125,NULL,61547675807,961682434,15026288,18.7),(53027,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53027,37.71,0.46,349,15112,70,NULL,NULL,'2MASX J08161337+2014179',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00019,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,124.055791667,20.23844,0.109,NULL,63814935516,997108367,15579818,17.2),(53028,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53028,37.83,0.46,368,15113,70,NULL,NULL,'2MASX J08161411+5856241',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,124.058625,58.94025,0.125,NULL,61564576223,961946503,15030414,17),(53029,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53029,38.21,0.46,438,15114,70,NULL,NULL,'2MASX J08161478+1529149',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000172,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,124.0615,15.48764,0.097,NULL,63779663584,996557243,15571206,17.8),(53030,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53030,35.61,0.17,132,15115,70,NULL,NULL,'2MASX J08161517+5835231',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000025,NULL,'16.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,124.063041667,58.58975,0.121,NULL,61601435545,962522430,15039412,16.3),(53031,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53031,38.06,0.46,410,15116,70,NULL,NULL,'2MASX J08161738+0644591',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000167,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,124.072417,6.74972,0.069,NULL,62798132548,981220821,15331575,18.1),(53032,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53032,38.06,0.46,408,15117,70,NULL,NULL,'2MASX J08161816+0556306',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000194,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,124.075833,5.94197,0.041,NULL,62768203220,980753175,15324268,18),(53033,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53033,34.89,0.46,95.2,15118,70,NULL,NULL,'CGCG 207-049',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000157,NULL,'15.4g',0.49,NULL,NULL,NULL,NULL,NULL,1,124.082833,43.44761,0.213,NULL,63533846011,992716343,15511192,15.4),(53034,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53034,37.68,0.46,343,15119,70,NULL,NULL,'2MASX J08162169+1259079',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,124.090333,12.9855,0.105,NULL,62648879782,978888746,15295136,16.8),(53035,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53035,36.94,0.46,244,15120,70,NULL,NULL,'SDSS J081621.82+344132.4',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000051,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,124.0909583,34.69233,0.165,NULL,64340001479,1005312523,15708008,17.5),(53036,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53036,36.91,0.46,240,15121,70,NULL,NULL,'2MASXi J0816224+234757',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,124.093667,23.79953,0.169,NULL,63765337556,996333399,15567709,17.6),(53037,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53037,37.69,0.46,345,15122,70,NULL,NULL,'2MASX J08162396+2450419',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000182,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,124.0997917,24.84508,0.145,NULL,64295110380,1004611099,15697048,17),(53038,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53038,37.86,0.46,374,15123,70,NULL,NULL,'SDSS J081624.41+031535.7',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000137,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,124.1017083,3.25994,0.113,NULL,62778267531,980910430,15326725,18),(53039,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53039,38.19,0.46,435,15124,70,NULL,NULL,'2MASX J08162567+2821039',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000164,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,124.107083,28.35103,0.101,NULL,64352020533,1005500320,15710942,18.4),(53040,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53040,37.17,0.33,272,15125,70,NULL,NULL,'2MASX J08162618+5521132',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000169,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,124.109167,55.35369,0.117,NULL,61550840974,961731890,15027060,16.9),(53041,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53041,38,0.46,399,15126,70,NULL,NULL,'2MASX J08162666+4133437',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000141,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,124.110875,41.56211,0.169,NULL,63518903806,992482871,15507544,18.4),(53042,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53042,39.17,0.46,682,15127,70,NULL,NULL,'2MASX J08162693+1345109',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000192,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,124.112167,13.75306,0.093,NULL,62647554588,978868040,15294813,17.4),(53043,'BL Lac Luminosity','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53043,40.35,NULL,1170,15128,71,NULL,'Min. z = 0.33','2MASS J08162719-1311524',NULL,'2014A&A...565A..12P',2013,1,NULL,NULL,'QSO',0.000183,NULL,'18.5b',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,124.1132917,-13.19789,0.413,NULL,39345913115,614779892,9605935,18.5),(53044,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53044,37.91,0.33,383,15129,70,NULL,NULL,'2MASX J08162789+3322362',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,124.1160417,33.37681,0.117,NULL,64337283207,1005270050,15707344,17.7),(53045,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53045,37.28,0.46,286,15130,70,NULL,NULL,'2MASX J08162793+2042008',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000161,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,124.1162917,20.70017,0.117,NULL,63815099982,997110937,15579858,17),(53046,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53046,35.78,0.46,143,15131,70,NULL,NULL,'2MASX J08162821+1151131',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.79',0.35,NULL,NULL,NULL,NULL,NULL,1,124.117417,11.85367,0.109,NULL,62782284408,980973193,15327706,16.79),(53047,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53047,37.73,0.17,351,15132,70,NULL,NULL,'2MASX J08162934+3721566',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,124.122125,37.36578,0.129,NULL,64328026973,1005125421,15705084,17.4),(53048,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53048,37.73,0.17,351,15133,70,NULL,NULL,'2MASX J08162984+3720256',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,124.12425,37.34042,0.129,NULL,64328038313,1005125598,15705087,18.2),(53049,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53049,36.26,0.21,178,15134,70,NULL,NULL,'2MASX J08163075+5517512',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000181,NULL,'15.7g',0.37,NULL,NULL,NULL,NULL,NULL,1,124.128166667,55.29764,0.117,NULL,61550850811,961732043,15027063,15.7),(53050,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53050,37.59,0.46,329,15135,70,NULL,NULL,'2MASX J08163144+3507253',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000148,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,124.1309583,35.12367,0.165,NULL,64340529963,1005320780,15708137,17.8),(53051,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53051,39.3,0.46,723,15136,70,NULL,NULL,'2MASX J08163233+1327209',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,124.134667,13.45586,0.077,NULL,62649473351,978898021,15295281,17.9),(53052,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53052,37.91,0.33,383,15137,70,NULL,NULL,'2MASX J08163260+3321502',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000129,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,124.135833,33.36392,0.117,NULL,64337294742,1005270230,15707347,18.3),(53053,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53053,35.61,0.17,132,15138,70,NULL,NULL,'2MASX J08163267+5816292',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,124.136,58.27486,0.129,NULL,61601510323,962523598,15039431,16.4),(53054,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53054,38.49,0.46,499,15139,70,NULL,NULL,'SDSS J081632.72+384053.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000156,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,124.136375,38.68142,0.121,NULL,64324750423,1005074225,15704284,18.5),(53055,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53055,38.18,0.46,433,15140,70,NULL,NULL,'2MASX J08163299+1030401',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,124.1374583,10.51106,0.033,NULL,62796311358,981192364,15331130,18),(53056,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53056,37.28,0.46,286,15141,70,NULL,NULL,'2MASX J08163355+3515313',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,124.139791667,35.25883,0.181,NULL,64339698696,1005307792,15707934,17.8),(53057,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53057,37.73,0.17,351,15142,70,NULL,NULL,'SDSS J081633.66+371939.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000174,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,124.14025,37.32778,0.129,NULL,64328038211,1005125597,15705087,18.6),(53058,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53058,34.56,0.46,81.5,15143,70,NULL,NULL,'IC 2253',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.000073,NULL,'14.3g',0.68,'E?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,124.141166667,21.40989,0.129,NULL,63816584041,997134125,15580220,14.3),(53059,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53059,33.96,NULL,61.9,15143,77,NULL,'BRIK, Cancer cluster, 15 galaxies','IC 2253',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53060,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53060,33.96,0.38,61.9,15143,77,NULL,'Cancer cluster, 15 galaxies','IC 2253',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53061,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53061,34.04,0.12,64.2,15143,74.4,NULL,'Cancer CLUSTER, 13 galaxies, WISE W2 (4.6 micro-meter), color corrected','IC 2253',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53062,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53062,34.04,0.12,64.2,15143,74.4,NULL,'Cancer CLUSTER, 13 galaxies, WISE W1 (3.4 micro-meter), color corrected','IC 2253',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53063,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53063,34.06,0.1,64.9,15143,75,NULL,'Cancer CLUSTER','IC 2253',NULL,'2012ApJ...749...78T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53064,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53064,34.07,0.13,65.2,15143,71,NULL,'Cancer Cluster','IC 2253',NULL,'1982PASAu...4..419V',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53065,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53065,34.08,0.11,65.5,15143,75,NULL,'Cancer cluster, avg. of 11 spiral galaxies','IC 2253',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53066,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53066,34.09,0.11,65.7,15143,74.4,NULL,'Cancer CLUSTER, 13 galaxies, WISE I-band','IC 2253',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53067,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53067,34.1,0.08,66.1,15143,74.4,NULL,'Cancer CLUSTER, 13 galaxies, WISE W1 (3.4 micro-meter), curved','IC 2253',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53068,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53068,34.11,0.08,66.3,15143,74.4,NULL,'Cancer CLUSTER, 13 galaxies, WISE W2 (4.6 micro-meter), curved','IC 2253',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53069,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53069,34.14,0.13,67.3,15143,75,NULL,'Cancer cluster, avg. of 11 spiral galaxies','IC 2253',NULL,'2013ApJ...765...94S',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53070,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53070,34.33,0.15,73.5,15143,70,NULL,'Cancer Cluster','IC 2253',NULL,'1992ApJ...396..453H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53071,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53071,34.35,NULL,74.3,15143,71,NULL,'Cancer CLUSTER, 80 galaxies','IC 2253',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53072,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53072,34.36,0.4,74.5,15143,NULL,NULL,'mean','IC 2253',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53073,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53073,34.4,0.3,75.8,15143,NULL,NULL,'Cancer CLUSTER, 17 galaxies','IC 2253',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53074,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53074,35.06,0.45,103,15143,NULL,NULL,'K','IC 2253',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53075,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53075,38.05,0.33,408,15144,70,NULL,NULL,'2MASX J08163397+2121236',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00017,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,124.141625,21.35669,0.129,NULL,63816596128,997134314,15580223,17.3),(53076,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53076,37.11,0.46,265,15145,70,NULL,NULL,'2MASX J08163778+1704252',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000152,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,124.157417,17.07369,0.081,NULL,63781905761,996592277,15571754,17.1),(53077,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53077,35.51,0.5,126,15146,70,NULL,NULL,'CGCG 003-022',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.000113,NULL,'15.3',0.24,NULL,NULL,NULL,NULL,NULL,1,124.159625,-0.40325,0.161,NULL,39208435842,612631810,9572372,15.3),(53078,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53078,37.53,0.46,321,15147,70,NULL,NULL,'2MASX J08163839+2819119',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,124.159875,28.31994,0.101,NULL,64352015852,1005500247,15710941,17.5),(53079,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53079,37.65,0.46,339,15148,70,NULL,NULL,'2MASX J08163896+2149476',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,124.1622917,21.82989,0.129,NULL,63809229885,997019216,15578425,17.4),(53080,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53080,37.35,0.46,295,15149,70,NULL,NULL,'SDSS J081641.04+465315.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000071,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,124.171,46.88778,0.149,NULL,63523924182,992561315,15508770,18.4),(53081,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53081,37.73,0.17,351,15150,70,NULL,NULL,'SDSS J081642.49+371953.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000147,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,124.177083,37.33153,0.129,NULL,64328033420,1005125522,15705086,18.4),(53082,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53082,35.16,0.46,108,15151,70,NULL,NULL,'2MASX J08164468+4115597',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'16.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,124.1860417,41.2665,0.165,NULL,63519058961,992485296,15507582,16.2),(53083,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53083,38.36,0.33,469,15152,70,NULL,NULL,'2MASX J08164533+3735488',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,124.189083,37.597,0.117,NULL,64327816660,1005122135,15705033,17.2),(53084,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53084,38.11,0.46,418,15153,70,NULL,NULL,'SDSS J081647.89+200121.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000132,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,124.1995417,20.02269,0.109,NULL,63815385526,997115398,15579928,18.6),(53085,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53085,38.06,0.46,410,15154,70,NULL,NULL,'SDSS J081649.93+533918.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000131,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,124.2080417,53.65522,0.121,NULL,63489998669,992031229,15500487,18.2),(53086,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53086,38.26,0.46,448,15155,70,NULL,NULL,'2MASX J08165005+2617453',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000134,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,124.2087083,26.29589,0.097,NULL,64294766064,1004605719,15696964,17.9),(53087,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53087,38.36,0.33,469,15156,70,NULL,NULL,'SDSS J081650.58+373138.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000139,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,124.2107917,37.52736,0.117,NULL,64327825060,1005122266,15705035,18.7),(53088,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53088,37.43,0.46,307,15157,70,NULL,NULL,'2MASX J08165085+2245356',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000157,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,124.211917,22.75975,0.161,NULL,63764329463,996317647,15567463,17.6),(53089,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53089,35.3,0.06,115,15158,NULL,NULL,NULL,'SDSS J081651.83+581417.4',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.00003,NULL,'17.4g',0.24,'Sc',NULL,NULL,NULL,NULL,1,124.216,58.23819,0.129,NULL,61601532611,962523947,15039436,17.4),(53090,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53090,37.73,0.17,351,15159,70,NULL,NULL,'2MASX J08165242+3720288',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000117,NULL,'17.12',NULL,'BrClG',NULL,NULL,NULL,NULL,1,124.218416667,37.34142,0.129,NULL,64328002215,1005125034,15705078,17.12),(53091,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53091,37.61,0.46,333,15160,70,NULL,NULL,'2MASX J08165263+4938322',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000083,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,124.219458333,49.64228,0.169,NULL,63548623655,992947244,15514800,17.8),(53092,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53092,36.78,0.46,227,15161,70,NULL,NULL,'2MASX J08165361+4513376',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.0001,NULL,'16.3g',0.36,'E0',NULL,NULL,NULL,NULL,1,124.2234583,45.22708,0.157,NULL,63531655385,992682115,15510658,16.3),(53093,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53093,32.73,0.2,35.2,15162,74.4,NULL,NULL,'IC 2256',NULL,'2013AJ....146...86T',2013,1,0.85,NULL,'G',0.000023,NULL,'14.7g',0.41,'Sd','Group non-member, foreground',NULL,NULL,NULL,1,124.2267917,24.17683,0.161,NULL,63762606512,996290726,15567042,14.7),(53094,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53094,37.64,0.46,338,15163,70,NULL,NULL,'2MASX J08165555+3922208',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,124.2315,39.37242,0.141,NULL,64357631437,1005587991,15712312,18.3),(53095,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53095,36.6,0.53,209,15164,70,NULL,NULL,'2MASX J08165637-0715272',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,124.234917,-7.25758,0.353,NULL,39414361630,615849400,9622646,15.2),(53096,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53096,38.05,0.33,408,15165,70,NULL,NULL,'SDSS J081657.34+212347.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000124,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,124.2389583,21.39664,0.129,NULL,63816592473,997134257,15580222,18.8),(53097,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53097,36.97,0.46,247,15166,70,NULL,NULL,'2MASX J08165736+4427498',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,124.239,44.46372,0.189,NULL,63533609624,992712650,15511135,17.2),(53098,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53098,35.59,0.47,131,15167,70,NULL,NULL,'2MASX J08165818-0949172',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00012,NULL,'16.15',NULL,NULL,NULL,NULL,NULL,NULL,1,124.242417,-9.8215,0.345,NULL,39425808529,616028258,9625441,16.15),(53099,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53099,36.1,0.46,166,15168,70,NULL,NULL,'2MASX J08165909+2737402',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00018,NULL,'15.9g',0.46,'S0/a',NULL,NULL,NULL,NULL,1,124.246375,27.62783,0.097,NULL,64351453639,1005491463,15710804,15.9),(53100,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53100,37.65,0.46,339,15169,70,NULL,NULL,'2MASX J08165917+0716040',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,124.246583,7.26789,0,NULL,62789489282,981085770,15329465,18.1),(53101,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53101,38.06,0.46,410,15170,70,NULL,NULL,'SDSS J081659.55+034801.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000108,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,124.248166667,3.80031,0.033,NULL,62769947878,980780435,15324694,18.6),(53102,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53102,37.24,0.46,280,15171,70,NULL,NULL,'2MASX J08165996+0321198',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000144,NULL,'16.5g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,124.249875,3.35558,0.053,NULL,62769907689,980779807,15324684,16.5),(53103,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53103,36.47,0.46,197,15172,70,NULL,NULL,'2MASX J08170001+3834158',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000183,NULL,'16.2g',0.31,'E0',NULL,NULL,NULL,NULL,1,124.2499583,38.57094,0.129,NULL,64324746709,1005074167,15704283,16.2),(53104,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53104,38.05,0.46,407,15173,70,NULL,NULL,'2MASX J08170059+1349283',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,124.252667,13.82461,0.081,NULL,62647968872,978874513,15294914,17.4),(53105,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53105,35.29,0.07,115,15174,NULL,NULL,NULL,'SDSS J081700.85+582902.2',NULL,'2009ApJS..182..474S',2009,1,0.3,NULL,'G',0.000027,NULL,'18.4g',0.12,'Sc',NULL,NULL,NULL,NULL,1,124.253583,58.48394,0.121,NULL,61601408170,962522002,15039406,18.4),(53106,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53106,36.62,0.46,211,15175,70,NULL,NULL,'2MASX J08170497+3435169',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000142,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,124.270667,34.58797,0.173,NULL,64340408526,1005318883,15708107,18),(53107,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53107,38.25,0.33,447,15176,70,NULL,NULL,'2MASX J08170604+2205561',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,124.275333,22.09892,0.141,NULL,63809175162,997018361,15578411,17.6),(53108,'Sosies','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53108,31.09,0.25,16.5,15177,NULL,NULL,NULL,'NGC 2559',NULL,'2002A&A...393...57T',2002,1,4.13,NULL,'G',0.000017,NULL,'11.73',2.07,'SB(s)bc pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,124.275291667,-27.45583,NULL,NULL,42737538857,667774044,10433969,11.73),(53109,'Tully est','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53109,31.5,0.8,20,15177,75,NULL,NULL,'NGC 2559',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53110,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53110,31.17,0.46,17.2,15177,NULL,NULL,'J','NGC 2559',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53111,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53111,31.23,0.45,17.6,15177,NULL,NULL,'K','NGC 2559',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53112,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53112,31.66,NULL,21.5,15177,NULL,NULL,'LEDA [April 2006]','NGC 2559',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53113,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53113,31.87,0.4,23.7,15177,NULL,NULL,'mean','NGC 2559',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53114,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53114,37.84,0.46,370,15178,70,NULL,NULL,'2MASX J08170787+0321523',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,'FoF','17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,124.2827083,3.36456,0.053,NULL,62769908040,980779813,15324684,17.3),(53115,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53115,36.53,0.46,202,15179,70,NULL,NULL,'2MASX J08170902+2555212',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000181,NULL,'16.2g',0.33,'S0^-',NULL,NULL,NULL,NULL,1,124.287583333,25.92239,0.141,NULL,64294835552,1004606805,15696981,16.2),(53116,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53116,36.32,0.46,184,15180,70,NULL,NULL,'2MASX J08170973+4548489',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000082,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,124.290583,45.81353,0.141,NULL,63524267692,992566682,15508854,16.7),(53117,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53117,37.47,0.46,312,15181,70,NULL,NULL,'2MASX J08170994+0359533',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000145,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,124.291333,3.99817,0.033,NULL,62770832574,980794258,15324910,17.5),(53118,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53118,37.87,0.46,376,15182,70,NULL,NULL,'SDSS J081711.63+552404.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000136,NULL,'18.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,124.2985,55.40136,0.145,NULL,61550785962,961731030,15027047,18.9),(53119,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53119,35.85,0.5,148,15183,70,NULL,NULL,'2MASX J08171228-0032315',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'15.0R',0.3,NULL,NULL,NULL,NULL,NULL,1,124.301083,-0.54203,0.165,NULL,39209399931,612646873,9572607,15),(53120,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53120,37.7,0.46,346,15184,70,NULL,NULL,'2MASX J08171260+2704458',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,124.302583333,27.07953,0.097,NULL,64351434016,1005491156,15710799,18),(53121,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53121,37.73,0.46,351,15185,70,NULL,NULL,'2MASX J08171357+4215120',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000185,NULL,'17.0g',0.3,'AGN',NULL,NULL,NULL,NULL,1,124.306625,42.25339,0.161,NULL,63522312763,992536136,15508377,17),(53122,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53122,37.92,0.46,384,15186,70,NULL,NULL,'2MASX J08171512+2953059',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000121,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,124.313125,29.88506,0.081,NULL,64356719440,1005573741,15712089,17.5),(53123,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53123,36.96,0.46,247,15187,70,NULL,NULL,'2MASX J08171617+2637399',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000198,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,124.3172083,26.62781,0.105,NULL,64294750160,1004605471,15696960,16.5),(53124,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53124,36.76,0.46,225,15188,70,NULL,NULL,'SDSS J081717.00+282833.1',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,124.320875,28.47586,0.089,NULL,64351758358,1005496224,15710878,17.1),(53125,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53125,38.25,0.33,447,15189,70,NULL,NULL,'2MASX J08171735+2222510',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,124.3225417,22.38075,0.113,NULL,63809858170,997029033,15578578,17.3),(53126,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53126,37.48,0.27,313,15190,70,NULL,NULL,'SDSS J081717.59+510733.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000059,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,124.3232917,51.12594,0.165,NULL,63546789286,992918582,15514352,18.4),(53127,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53127,37.48,0.27,313,15191,70,NULL,NULL,'2MASX J08171857+5104470',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.81',0.41,'BrClG',NULL,NULL,NULL,NULL,1,124.32725,51.07972,0.165,NULL,63546674793,992916793,15514324,16.81),(53128,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53128,37.37,0.46,297,15192,70,NULL,NULL,'2MASXi J0817198+165646',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,124.332917,16.94644,0.081,NULL,63781958908,996593107,15571767,17.6),(53129,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53129,37.82,0.46,366,15193,70,NULL,NULL,'SDSS J081721.66+452622.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000077,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,124.3402917,45.43967,0.149,NULL,63531704543,992682883,15510670,18.3),(53130,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53130,37.92,0.46,385,15194,70,NULL,NULL,'2MASX J08172277+2307140',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000161,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,124.344875,23.12061,0.153,NULL,63764231652,996316119,15567439,17.2),(53131,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53131,37.48,0.27,313,15195,70,NULL,NULL,'2MASX J08172344+5103480',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000082,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,124.347625,51.06331,0.165,NULL,63546674988,992916796,15514324,17.7),(53132,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53132,37.85,0.46,372,15196,70,NULL,NULL,'2MASX J08172431+0418253',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000184,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,124.351417,4.30692,0.037,NULL,62770377520,980787148,15324799,16.3),(53133,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53133,37.35,0.46,295,15197,70,NULL,NULL,'2MASX J08172432+4733440',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000077,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,124.3515,47.56211,0.221,NULL,63542651997,992853937,15513342,17.2),(53134,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53134,38.17,0.33,430,15198,70,NULL,NULL,'2MASX J08172438+2756089',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,124.3515417,27.93578,0.085,NULL,64351916635,1005498697,15710917,17.6),(53135,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53135,36.45,0.54,195,15199,70,NULL,NULL,'2MASX J08172573-0953575',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.74',NULL,NULL,NULL,NULL,NULL,NULL,1,124.357083,-9.89931,0.345,NULL,39425148811,616017950,9625280,16.74),(53136,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53136,32.9,NULL,38,15200,NULL,NULL,'I','UGC 04308',NULL,'2005Ap&SS.298..577R',2005,1,2.2,NULL,'G',0.000004,NULL,'13.5',1.8,'SB(rs)c        AGN','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,124.3575,21.68547,0.129,NULL,63809100884,997017201,15578393,13.5),(53137,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53137,33.54,0.47,51.1,15200,NULL,NULL,'H','UGC 04308',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53138,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53138,33.58,0.46,52.1,15200,NULL,NULL,'J','UGC 04308',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53139,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53139,33.61,0.45,52.6,15200,NULL,NULL,'K','UGC 04308',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53140,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53140,33.63,0.4,53.2,15200,NULL,NULL,'mean','UGC 04308',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53141,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53141,33.7,0.07,55.1,15200,NULL,NULL,NULL,'UGC 04308',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53142,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53142,33.84,NULL,58.6,15200,NULL,NULL,'B','UGC 04308',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53143,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53143,36.89,0.46,239,15201,70,NULL,NULL,'2MASX J08172642+1012101',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.01',0.23,NULL,NULL,NULL,NULL,NULL,1,124.360083,10.20281,0.053,NULL,62794349173,981161705,15330651,17.01),(53144,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53144,38.18,0.46,433,15202,70,NULL,NULL,'2MASX J08172688+4430300',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000141,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,124.3620417,44.50825,0.189,NULL,63533600197,992712503,15511132,17.8),(53145,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53145,35.69,0.57,137,15203,70,NULL,NULL,'2MASX J08172776-1001085',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.52',NULL,NULL,NULL,NULL,NULL,NULL,1,124.36575,-10.01922,0.345,NULL,39425021053,616015953,9625249,16.52),(53146,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53146,37.42,0.46,305,15204,70,NULL,NULL,'2MASX J08172790+4914290',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000082,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,124.366333,49.24153,0.193,NULL,63548455210,992944612,15514759,17.2),(53147,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53147,35.85,0.5,148,15205,70,NULL,NULL,'2MASX J08172807-0041015',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.98',NULL,NULL,NULL,NULL,NULL,NULL,1,124.366833333,-0.68367,0.165,NULL,39209189023,612643578,9572555,15.98),(53148,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53148,36.61,0.46,210,15206,70,NULL,NULL,'2MASX J08172999+5007400',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000088,NULL,'17.3g',0.26,'BLAGN',NULL,NULL,NULL,'Sy 1',1,124.374958333,50.12781,0.165,NULL,63548896553,992951508,15514867,17.3),(53149,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53149,37.77,0.46,358,15207,70,NULL,NULL,'2MASX J08173180+0606051',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000175,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,124.382458333,6.10156,0.065,NULL,62797255394,981207115,15331361,16.4),(53150,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53150,37.95,0.1,388,15208,70,NULL,NULL,'2MASX J08173201+2253170',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000182,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,124.38325,22.88808,0.161,NULL,63764202486,996315663,15567432,17.8),(53151,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53151,38.13,0.46,424,15209,70,NULL,NULL,'2MASX J08173220+2618389',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000154,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,124.384333,26.31089,0.097,NULL,64294798097,1004606220,15696972,17.9),(53152,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53152,38.01,0.46,399,15210,70,NULL,NULL,'2MASX J08173263+2906489',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000191,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,124.385875,29.11361,0.085,NULL,64353554206,1005524284,15711316,16.7),(53153,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53153,37.73,0.46,352,15211,70,NULL,NULL,'2MASX J08173370+1553508',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000158,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,124.390458333,15.89753,0.089,NULL,63783967241,996624488,15572257,18.3),(53154,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53154,37.67,0.46,341,15212,70,NULL,NULL,'2MASXi J0817336+374422',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,124.390458333,37.73972,0.137,NULL,64327371723,1005115183,15704924,17.8),(53155,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53155,38.09,0.27,416,15213,70,NULL,NULL,'SDSS J081734.23+494700.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000076,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,124.392625,49.78336,0.169,NULL,63548791527,992949867,15514841,18.3),(53156,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53156,31.57,0.43,20.7,15214,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04306',NULL,'2014MNRAS.444..527S',2014,1,0.9,'Multiple SDSS entries describe this object.','G',0.000033,NULL,'15.06',0.4,'S?',NULL,NULL,NULL,NULL,1,124.403333,35.44581,0.193,NULL,64339831346,1005309864,15707966,15.06),(53157,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53157,32.06,0.43,25.8,15214,75,NULL,'3.6 micron, color corrected','UGC 04306',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53158,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53158,32.46,0.47,31,15214,NULL,NULL,'H','UGC 04306',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53159,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53159,32.46,0.2,31.1,15214,74.4,NULL,NULL,'UGC 04306',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53160,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53160,32.49,0.45,31.5,15214,NULL,NULL,'K','UGC 04306',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53161,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53161,32.57,0.43,32.7,15214,NULL,NULL,NULL,'UGC 04306',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53162,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53162,32.69,0.46,34.5,15214,NULL,NULL,'J','UGC 04306',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53163,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53163,32.78,0.4,35.9,15214,NULL,NULL,'mean','UGC 04306',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53164,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53164,32.77,0.39,35.9,15214,NULL,NULL,'Malmquist cor.','UGC 04306',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53165,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53165,38.16,0.46,429,15215,70,NULL,NULL,'2MASX J08173746+2029256',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000154,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,124.406,20.49053,0.145,NULL,63814863923,997107248,15579800,18),(53166,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53166,38.09,0.27,416,15216,70,NULL,NULL,'2MASX J08173831+4945321',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000084,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,124.409667,49.75892,0.169,NULL,63548791698,992949870,15514841,17.7),(53167,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53167,37.03,0.46,255,15217,70,NULL,NULL,'2MASX J08174028+1615109',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000145,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,124.417917,16.25311,0.069,NULL,63780089860,996563904,15571311,17.7),(53168,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53168,36.36,0.51,187,15218,70,NULL,NULL,'CGCG 003-027',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00003,NULL,'15.5',NULL,'Sa',NULL,NULL,NULL,NULL,1,124.421166667,-0.88136,0.185,NULL,39208743777,612636621,9572447,15.5),(53169,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53169,38.17,0.33,430,15219,70,NULL,NULL,'2MASX J08174235+2800219',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,124.426291667,28.00611,0.085,NULL,64351927282,1005498863,15710919,18.3),(53170,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53170,37.04,0.33,256,15220,70,NULL,NULL,'2MASX J08174242+4725000',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,'FoF','17.51',0.39,NULL,NULL,NULL,NULL,NULL,1,124.426625,47.41678,0.205,NULL,63542548205,992852315,15513317,17.51),(53171,'Tully est','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53171,31.6,0.8,20.9,15221,75,NULL,NULL,'UGCA 137',NULL,'1988NBGC.C....0000T',1988,1,3.17,'abs(b) < 10 degrees.','G',0.00001,NULL,'12.1',2.33,'SB(rs)c',NULL,NULL,NULL,NULL,1,124.430291667,-30.13058,NULL,NULL,42748077250,667938707,10436542,12.1),(53172,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53172,31.83,0.4,23.2,15221,NULL,NULL,'mean','UGCA 137',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53173,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53173,31.86,0.46,23.5,15221,NULL,NULL,'J','UGCA 137',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53174,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53174,31.87,0.47,23.7,15221,NULL,NULL,'H','UGCA 137',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53175,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53175,31.9,0.45,24,15221,NULL,NULL,'K','UGCA 137',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53176,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53176,36.8,0.46,229,15222,70,NULL,NULL,'2MASX J08174329+0906299',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,124.430417,9.10842,0.013,NULL,62790075648,981094932,15329608,16.7),(53177,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53177,36.74,0.46,223,15223,70,NULL,NULL,'2MASX J08174566+0230085',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,124.44025,2.50244,0.113,NULL,62581363463,977833804,15278653,17),(53178,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53178,37.73,0.46,351,15224,70,NULL,NULL,'2MASX J08174588+1141450',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.79',0.24,NULL,NULL,NULL,NULL,NULL,1,124.44125,11.69597,0.117,NULL,62782084651,980970072,15327657,17.79),(53179,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53179,35.7,0.23,138,15225,70,NULL,NULL,'2MASX J08174710+5627536',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000166,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,124.4462917,56.465,0.117,NULL,61549318426,961708100,15026689,16.3),(53180,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53180,36.59,0.98,208,15226,70,NULL,NULL,'2MASX J08174851-1338589',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'15.4R',0.37,NULL,NULL,NULL,NULL,NULL,1,124.452083,-13.64975,0.373,NULL,39346123417,614783178,9605987,15.4),(53181,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53181,38.08,0.46,414,15227,70,NULL,NULL,'2MASX J08174886+2044146',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000111,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,124.4535,20.73744,0.141,NULL,63816790984,997137359,15580271,17.9),(53182,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53182,37.95,0.46,389,15228,70,NULL,NULL,'SDSS J081749.12+151420.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000137,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,124.4547083,15.23908,0.093,NULL,63772508389,996445443,15569460,18.4),(53183,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53183,36.83,0.46,232,15229,70,NULL,NULL,'2MASX J08175052+5531266',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000151,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,124.460417,55.52414,0.145,NULL,61549705584,961714149,15026783,17.1),(53184,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53184,35.72,0.46,139,15230,NULL,NULL,'Malmquist cor.','UGC 04317',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000033,NULL,'15.05',0.4,'SB(s)b',NULL,NULL,NULL,NULL,1,124.469167,12.89806,0.089,NULL,62649711803,978901746,15295339,15.05),(53185,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53185,35.81,0.44,145,15230,NULL,NULL,NULL,'UGC 04317',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53186,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53186,35.85,0.2,148,15230,74.4,NULL,NULL,'UGC 04317',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53187,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53187,38.1,0.46,418,15231,70,NULL,NULL,'2MASX J08175272+3924351',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000141,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,124.4697917,39.40986,0.141,NULL,64357650943,1005588295,15712317,18.1),(53188,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53188,36.54,0.46,204,15232,70,NULL,NULL,'2MASX J08175300+4052231',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,124.470833,40.87311,0.137,NULL,64240604206,1003759440,15683741,17.1),(53189,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53189,36.67,0.46,215,15233,70,NULL,NULL,'2MASX J08175361+4359031',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000167,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,124.473166667,43.98419,0.217,NULL,63534251668,992722682,15511291,17.8),(53190,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53190,38.56,0.46,515,15234,70,NULL,NULL,'2MASX J08175464+2128115',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000179,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,124.477875,21.46997,0.129,NULL,63816521901,997133154,15580205,17.7),(53191,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53191,36.05,0.46,162,15235,70,NULL,NULL,'2MASX J08175593+3722131',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000187,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,124.483083333,37.37042,0.145,NULL,64327939109,1005124048,15705063,16.7),(53192,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53192,36.14,0.46,169,15236,70,NULL,NULL,'KUG 0814+472',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000095,NULL,'16.1g',0.35,'SF',NULL,NULL,NULL,NULL,1,124.4845417,47.12208,0.173,NULL,63542004569,992843821,15513184,16.1),(53193,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53193,37.04,0.33,256,15237,70,NULL,NULL,'[YSS2008] 671',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,124.484917,47.3175,0.205,NULL,63542587107,992852923,15513326,NULL),(53194,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53194,34.33,0.4,73.4,15238,NULL,NULL,'mean','NGC 2555',NULL,'2007A&A...465...71T',2007,1,1.9,'HOLM 095B,C are stars.','G',0.00009,NULL,'13.14',1.4,'SB(rs)ab',NULL,NULL,NULL,NULL,1,124.4850417,0.74569,0.085,NULL,62579808612,977809509,15278273,13.14),(53195,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53195,34.61,0.47,83.5,15238,NULL,NULL,'H','NGC 2555',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53196,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53196,34.65,0.45,85.3,15238,NULL,NULL,'K','NGC 2555',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53197,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53197,34.67,0.46,85.7,15238,NULL,NULL,'J','NGC 2555',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53198,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53198,32.15,0.4,27,15239,75,NULL,NULL,'KUG 0815+225',NULL,'2008Ap.....51..336K',2008,1,0.95,NULL,'G',0.000012,NULL,'15.4g',0.29,'Sbc            HII','Group non-member, foreground',NULL,NULL,NULL,1,124.4865,22.43542,0.113,NULL,63809888155,997029502,15578585,15.4),(53199,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53199,32.49,0.49,31.5,15239,75,NULL,'IR','KUG 0815+225',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53200,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53200,37.02,0.46,253,15240,70,NULL,NULL,'2MASX J08175688+1909495',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000186,NULL,'15.8g',0.45,NULL,NULL,NULL,NULL,NULL,1,124.487083,19.16383,0.117,NULL,63813986483,997093538,15579586,15.8),(53201,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53201,36.35,0.46,186,15241,70,NULL,NULL,'2MASX J08175884+3004555',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000155,NULL,'15.9g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,124.495125,30.08214,0.125,NULL,64356864379,1005576005,15712125,15.9),(53202,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53202,37.32,0.46,292,15242,70,NULL,NULL,'2MASX J08175912+1022509',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,124.496417,10.38097,0.053,NULL,62794287782,981160746,15330636,17.1),(53203,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53203,37.73,0.17,351,15243,70,NULL,NULL,'2MASX J08175994+3716161',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000187,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,124.4997917,37.27119,0.153,NULL,64327936283,1005124004,15705062,16.7),(53204,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53204,36.27,0.6,179,15244,70,NULL,NULL,'2MASX J08180059-1613599',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00012,NULL,'13.8R',0.65,NULL,NULL,NULL,NULL,NULL,1,124.5025,-16.23336,0.069,NULL,42251920009,660186250,10315410,13.8),(53205,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53205,37.45,0.33,309,15245,70,NULL,NULL,'2MASX J08180147+0333436',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000156,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,124.5060417,3.56197,0.045,NULL,62588611051,977947047,15280422,17.2),(53206,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53206,32.48,0.39,31.3,15246,NULL,NULL,NULL,'IC 2267',NULL,'2009ApJS..182..474S',2009,1,2.98,'The CGCG/UGC \\\"companion\\\" is a giant HII region at the south end.','G',0.000004,NULL,'14.9g',0.29,'SBcd?','Group non-member, foreground',NULL,NULL,NULL,1,124.506708333,24.73533,0.157,NULL,63762733479,996292710,15567073,14.9),(53207,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53207,32.59,0.37,32.9,15246,NULL,NULL,'Malmquist cor.','IC 2267',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53208,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53208,32.74,0.2,35.3,15246,74.4,NULL,NULL,'IC 2267',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53209,'Tully-Fisher','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53209,33.11,0.4,41.9,15246,NULL,NULL,NULL,'IC 2267',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53210,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53210,36.73,0.46,221,15247,70,NULL,NULL,'2MASX J08180192+2454349',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,124.508083333,24.90975,0.145,NULL,64295079925,1004610623,15697040,17.5),(53211,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53211,38.07,0.46,412,15248,70,NULL,NULL,'2MASX J08180210+1523489',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,124.508708333,15.39686,0.097,NULL,63784065731,996626027,15572281,17.4),(53212,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53212,38.57,0.33,517,15249,70,NULL,NULL,'SDSS J081802.23+214841.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000129,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,124.509333,21.81164,0.113,NULL,63809122176,997017534,15578398,18.6),(53213,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53213,36.99,0.46,250,15250,70,NULL,NULL,'2MASX J08180248+3537405',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000177,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,124.5102083,35.62797,0.185,NULL,64339788829,1005309200,15707956,16.7),(53214,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53214,37.73,0.33,351,15251,70,NULL,NULL,'2MASX J08180524+1755298',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,124.5217083,17.92508,0.085,NULL,63781037937,996578717,15571542,17.7),(53215,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53215,38.44,0.46,487,15252,70,NULL,NULL,'SDSS J081805.59+364213.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000156,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,124.5232917,36.70367,0.169,NULL,64327105179,1005111018,15704859,18.5),(53216,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53216,36.9,0.46,240,15253,70,NULL,NULL,'2MASX J08180655+0324486',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000131,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,124.5272917,3.41361,0.053,NULL,62588679336,977948114,15280439,17.6),(53217,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53217,37.09,0.46,261,15254,70,NULL,NULL,'2MASX J08180679+2155258',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,124.528416667,21.92389,0.113,NULL,63809087201,997016987,15578390,17.6),(53218,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53218,37.15,0.46,269,15255,70,NULL,NULL,'2MASX J08180750+5754517',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,124.531208333,57.91439,0.109,NULL,61601138361,962517786,15039340,16.6),(53219,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53219,38.12,0.27,421,15256,70,NULL,NULL,'2MASX J08180836+2225398',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,124.534833333,22.42778,0.113,NULL,63809894824,997029606,15578587,18.3),(53220,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53220,37.8,0.46,364,15257,70,NULL,NULL,'2MASX J08180838+2936189',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000133,NULL,'18.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,124.534833333,29.60525,0.097,NULL,64356680276,1005573129,15712080,18.1),(53221,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53221,37.83,0.46,367,15258,70,NULL,NULL,'2MASX J08180949+0325376',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000168,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,124.539625,3.42719,0.053,NULL,62588675208,977948050,15280438,17),(53222,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53222,38.57,0.33,517,15259,70,NULL,NULL,'2MASX J08181046+2147368',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000182,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,124.543625,21.79364,0.113,NULL,63809066696,997016667,15578385,17.9),(53223,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53223,37.53,0.46,320,15260,70,NULL,NULL,'2MASX J08181085+4251399',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000032,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,124.5452083,42.86108,0.181,NULL,63520595887,992509310,15507957,17.7),(53224,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53224,37.28,0.46,285,15261,70,NULL,NULL,'2MASX J08181175+3508588',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000176,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,124.5487917,35.14969,0.181,NULL,64340445314,1005319458,15708116,16.9),(53225,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53225,35.77,0.46,143,15262,70,NULL,NULL,'2MASX J08181281+4131030',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000179,NULL,'15.7g',0.38,'Sa',NULL,NULL,NULL,NULL,1,124.553417,41.51744,0.149,NULL,63518857098,992482142,15507533,15.7),(53226,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,NULL,53226,36.87,0.57,236,15263,70,NULL,NULL,'2MASX J08181357-0226042',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,124.5565,-2.43444,0.261,NULL,39209610428,612650162,9572658,14.9),(53227,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53227,36.65,0.27,214,15264,70,NULL,NULL,'2MASX J08181514+5625587',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000167,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,124.5632083,56.43314,0.117,NULL,61549379256,961709050,15026703,17.2),(53228,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53228,37.9,0.46,380,15265,70,NULL,NULL,'2MASX J08181549+2155148',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000149,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,124.564666667,21.92064,0.113,NULL,63809953136,997030517,15578601,17.5),(53229,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53229,37.18,0.46,273,15266,70,NULL,NULL,'2MASX J08181765+4147149',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,124.5737083,41.78761,0.153,NULL,63522215105,992534611,15508353,17.2),(53230,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53230,37.45,0.33,309,15267,70,NULL,NULL,'2MASX J08181917+0336476',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000133,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,124.5797917,3.61319,0.045,NULL,62588639068,977947485,15280429,17.5),(53231,'FP','2016-12-15 15:14:20','2016-12-16 11:19:26','1',NULL,'R',53231,38.13,0.46,423,15268,70,NULL,NULL,'2MASX J08181971+0411596',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,124.582125,4.2,0.029,NULL,62770151429,980783616,15324744,17.8),(53232,'FP','2016-12-15 15:14:21','2016-12-16 11:19:26','1',NULL,'R',53232,38.16,0.46,428,15269,70,NULL,NULL,'2MASX J08182016+3742379',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,124.584083,37.71044,0.137,NULL,64327504644,1005117260,15704957,17.7),(53233,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:26','1',NULL,NULL,53233,35.53,0.3,128,15270,NULL,NULL,NULL,'UGC 04321',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000087,NULL,'15.67',0.2,'Sab',NULL,NULL,NULL,NULL,1,124.5910417,11.6265,0.117,NULL,62782050765,980969543,15327649,15.67),(53234,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:26','1',NULL,NULL,53234,35.55,0.3,129,15270,NULL,NULL,'Malmquist cor.','UGC 04321',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53235,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:26','1',NULL,NULL,53235,35.57,0.2,130,15270,74.4,NULL,NULL,'UGC 04321',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53236,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:26','1',NULL,'R',53236,35.69,0.49,137,15270,75,NULL,'IR','UGC 04321',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53237,'FP','2016-12-15 15:14:21','2016-12-16 11:19:26','1',NULL,NULL,53237,34.59,0.46,82.7,15271,70,NULL,NULL,'ESO 089- G 016',NULL,'2014MNRAS.445.2677S',2014,1,2,NULL,'G',0.000097,NULL,'14.39',1.8,'E2:','in a triple',NULL,NULL,NULL,1,124.5975,-67.61119,0.565,NULL,40773660418,637088444,9954506,14.39),(53238,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:26','1',NULL,NULL,53238,35.81,0.71,145,15272,NULL,NULL,NULL,'2MASX J08182497+1137079',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.00005,NULL,'14.7I',NULL,NULL,NULL,NULL,NULL,NULL,1,124.604041667,11.61886,0.117,NULL,62782051300,980969551,15327649,14.7),(53239,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:26','1',NULL,NULL,53239,35.85,0.2,148,15272,74.4,NULL,NULL,'2MASX J08182497+1137079',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53240,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:26','1',NULL,NULL,53240,35.86,0.69,149,15272,NULL,NULL,'Malmquist cor.','2MASX J08182497+1137079',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53241,'FP','2016-12-15 15:14:21','2016-12-16 11:19:26','1',NULL,'R',53241,37.51,0.46,317,15273,70,NULL,NULL,'2MASX J08182505+1232510',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,124.604333333,12.54742,0.069,NULL,62649576897,978899639,15295306,17.9),(53242,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:26','1',NULL,NULL,53242,37.77,0.47,358,15274,NULL,NULL,'Malmquist cor.','2MASX J08182776+1137509',NULL,'2009ApJS..182..474S',2009,1,0.47,NULL,'G',0.000023,NULL,'17.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,124.615791667,11.63072,0.117,NULL,62782050341,980969536,15327649,17.5),(53243,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:26','1',NULL,NULL,53243,37.8,0.46,363,15274,NULL,NULL,NULL,'2MASX J08182776+1137509',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53244,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53244,37.84,0.2,370,15274,74.4,NULL,NULL,'2MASX J08182776+1137509',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53245,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53245,37.47,0.46,312,15275,70,NULL,NULL,'2MASX J08182814+1545460',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,124.617417,15.76275,0.089,NULL,63784007783,996625121,15572267,17.7),(53246,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53246,37.73,0.33,351,15276,70,NULL,NULL,'2MASX J08182835+1753248',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,124.618083,17.89019,0.085,NULL,63781516054,996586188,15571659,17.6),(53247,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53247,37.95,0.1,388,15277,70,NULL,NULL,'SDSS J081829.36+225102.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,124.622375,22.85075,0.165,NULL,63809757518,997027461,15578554,17.6),(53248,'IRAS','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53248,34.13,0.8,66.9,15278,75,NULL,'CF, r','UGC 04324',NULL,'1997ApJS..109..333W',1997,1,1.31,NULL,'G',0.000019,NULL,'14.7g',0.48,'Sab: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,124.623125,20.76139,0.141,NULL,63816772103,997137064,15580266,14.7),(53249,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53249,33.74,0.43,56,15278,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04324',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53250,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53250,33.85,0.43,58.9,15278,75,NULL,'3.6 micron, color corrected','UGC 04324',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53251,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53251,33.92,0.38,60.7,15278,75,NULL,'CF, r, raw','UGC 04324',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53252,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53252,34,0.38,63,15278,75,NULL,'CF, r, inv','UGC 04324',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53253,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53253,34.01,0.2,63.4,15278,74.4,NULL,NULL,'UGC 04324',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53254,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53254,34.2,0.38,69.3,15278,75,NULL,'CF, r, cor','UGC 04324',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53255,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53255,34.26,0.08,71.3,15278,NULL,NULL,NULL,'UGC 04324',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53256,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53256,34.32,0.4,73.3,15278,NULL,NULL,'mean','UGC 04324',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53257,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53257,34.36,0.47,74.5,15278,NULL,NULL,'H','UGC 04324',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53258,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53258,34.48,0.45,78.6,15278,NULL,NULL,'K','UGC 04324',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53259,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53259,37.95,0.1,388,15279,70,NULL,NULL,'2MASX J08183150+2251547',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,124.631167,22.86533,0.165,NULL,63809757607,997027462,15578554,17.9),(53260,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53260,36.92,0.46,242,15280,70,NULL,NULL,'2MASX J08183294+3901332',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,124.637291667,39.02581,0.133,NULL,64358328216,1005598878,15712482,17.6),(53261,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53261,37.82,0.33,366,15281,70,NULL,NULL,'2MASX J08183399+2236207',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000132,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,124.641667,22.60575,0.165,NULL,63809730159,997027033,15578547,18.1),(53262,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53262,37.3,0.46,289,15282,70,NULL,NULL,'2MASX J08183561+0545371',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000176,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,124.648417,5.76022,0.037,NULL,62767964026,980749437,15324209,17.3),(53263,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53263,38.12,0.27,421,15283,70,NULL,NULL,'2MASX J08183578+2220143',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000171,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,124.6489583,22.33739,0.113,NULL,63810017893,997031529,15578617,16.9),(53264,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53264,36.65,0.27,214,15284,70,NULL,NULL,'2MASX J08183668+5634226',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000188,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,124.652917,56.57311,0.117,NULL,61551412644,961740822,15027200,16.2),(53265,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53265,37.95,0.1,388,15285,70,NULL,NULL,'2MASX J08183696+2256153',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,124.653916667,22.93758,0.161,NULL,63809572264,997024566,15578508,17.3),(53266,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53266,37.87,0.46,374,15286,70,NULL,NULL,'2MASX J08183808+1611082',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000161,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,124.6587917,16.18575,0.093,NULL,63784481773,996632527,15572383,17.2),(53267,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53267,38.05,0.46,407,15287,70,NULL,NULL,'2MASX J08183937+0723486',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,124.664125,7.39694,0,NULL,62789574141,981087095,15329485,17.3),(53268,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53268,37.95,0.1,388,15288,70,NULL,NULL,'2MASX J08183993+2255443',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,124.6662917,22.92911,0.161,NULL,63809572167,997024565,15578508,17.7),(53269,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53269,38.18,0.46,432,15289,70,NULL,NULL,'2MASX J08184084+0236361',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,124.670333,2.61014,0.085,NULL,62581262632,977832228,15278628,17.4),(53270,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53270,37.29,0.33,287,15290,70,NULL,NULL,'2MASX J08184307+3309481',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000188,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,124.679416667,33.16325,0.097,NULL,64336641440,1005260022,15707187,16.7),(53271,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53271,38.09,0.27,416,15291,70,NULL,NULL,'SDSS J081843.15+495012.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000072,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,124.6797917,49.83669,0.169,NULL,63548767798,992949496,15514835,18.7),(53272,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53272,36.11,0.52,167,15292,70,NULL,NULL,'2MASX J08184360-0348526',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.34',0.4,NULL,NULL,NULL,NULL,NULL,1,124.6817917,-3.81481,0.281,NULL,39215046659,612735104,9573986,16.34),(53273,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53273,38.24,0.46,445,15293,70,NULL,NULL,'2MASX J08184367+0605577',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000149,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,124.681917,6.09928,0.053,NULL,62767777811,980746528,15324164,17.4),(53274,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53274,37.8,0.46,363,15294,70,NULL,NULL,'2MASX J08184377+4044042',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000166,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,124.6822917,40.73442,0.141,NULL,64240852947,1003763327,15683801,16.9),(53275,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53275,37.95,0.1,388,15295,70,NULL,NULL,'2MASX J08184529+2257113',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,124.688625,22.95328,0.161,NULL,63809570115,997024533,15578508,17.9),(53276,'Tully est','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53276,31.62,0.8,21.1,15296,75,NULL,NULL,'NGC 2566',NULL,'1988NBGC.C....0000T',1988,1,4.05,NULL,'G',0.00001,NULL,'11.82',2.93,'(R\')SB(r)ab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,124.69025,-25.49953,NULL,NULL,42690618972,667040921,10422514,11.82),(53277,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53277,29.44,0.45,7.73,15296,NULL,NULL,'K','NGC 2566',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53278,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53278,29.48,0.47,7.89,15296,NULL,NULL,'H','NGC 2566',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53279,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53279,29.51,0.46,7.99,15296,NULL,NULL,'J','NGC 2566',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53280,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53280,31.25,0.4,17.8,15296,NULL,NULL,'mean','NGC 2566',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53281,'SBF','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53281,31.84,0.2,23.3,15297,NULL,NULL,'I','IC 2311',NULL,'2001ApJ...546..681T',2001,1,2.07,'abs(b) < 10 degrees.','G',0.000123,NULL,'12.50',1.85,'E0:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,124.691583333,-25.36975,NULL,NULL,42690611118,667040798,10422512,12.5),(53282,'SBF','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53282,31.85,0.14,23.4,15297,74.4,NULL,NULL,'IC 2311',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53283,'D-Sigma','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53283,32.03,0.4,25.4,15297,75,NULL,'Edat, raw','IC 2311',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53284,'D-Sigma','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53284,32.36,0.4,29.7,15297,75,NULL,'Edat, cor','IC 2311',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53285,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53285,32.27,0.4,28.5,15297,NULL,NULL,'mean','IC 2311',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53286,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53286,33.05,0.45,40.7,15297,NULL,NULL,'K','IC 2311',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53287,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53287,37.57,0.46,327,15298,70,NULL,NULL,'2MASX J08184626+0817417',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,124.692875,8.29497,0.017,NULL,62792480921,981132514,15330195,17.3),(53288,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53288,35.61,0.77,133,15299,70,NULL,NULL,'2MASX J08184634-1447268',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'15.0R',0.38,NULL,NULL,NULL,NULL,NULL,1,124.693167,-14.79075,0.329,NULL,42246948961,660108577,10314196,15),(53289,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53289,37.49,0.46,315,15300,70,NULL,NULL,'SDSS J081847.01+203131.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000143,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,124.695916667,20.52547,0.145,NULL,63816816076,997137751,15580277,18.6),(53290,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53290,36.28,0.46,181,15301,70,NULL,NULL,'2MASX J08184700+4623141',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000089,NULL,'16.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,124.6959583,46.38739,0.173,NULL,63524589876,992571716,15508933,16.4),(53291,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53291,37.73,0.46,351,15302,70,NULL,NULL,'2MASX J08184734+5510211',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,124.697208333,55.17258,0.117,NULL,61551296990,961739015,15027172,18),(53292,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53292,37.82,0.33,366,15303,70,NULL,NULL,'2MASX J08184753+2233403',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,124.698166667,22.56119,0.113,NULL,63809719442,997026866,15578544,17.5),(53293,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53293,37.29,0.33,287,15304,70,NULL,NULL,'SDSS J081849.51+330807.9',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000141,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,124.706333333,33.13556,0.125,NULL,64336638368,1005259974,15707187,18),(53294,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53294,37.81,0.46,365,15305,70,NULL,NULL,'2MASX J08184973+0406311',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000159,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,124.7072917,4.10875,0.037,NULL,62589219532,977956555,15280571,16.9),(53295,'IRAS','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53295,33.44,0.8,48.8,15306,75,NULL,'HMCL, I','CGCG 119-044',NULL,'1997ApJS..109..333W',1997,1,0.76,NULL,'G',0.000005,NULL,'15.8g',0.51,'S0/a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,124.709041667,22.11539,0.137,NULL,63810036531,997031820,15578622,15.8),(53296,'IRAS','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53296,33.45,0.8,49.1,15306,75,NULL,'W91CL, r','CGCG 119-044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53297,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53297,32.55,0.2,32.4,15306,74.4,NULL,NULL,'CGCG 119-044',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53298,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53298,33.13,0.4,42.2,15306,75,NULL,'HMCL, I, inv','CGCG 119-044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53299,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53299,33.16,0.4,42.9,15306,75,NULL,'HMCL, I, raw','CGCG 119-044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53300,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53300,33.38,0.38,47.3,15306,75,NULL,'W91CL, r, inv','CGCG 119-044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53301,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53301,33.46,0.38,49.3,15306,75,NULL,'W91CL, r, raw','CGCG 119-044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53302,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53302,33.63,0.4,53.3,15306,75,NULL,'HMCL, I, cor','CGCG 119-044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53303,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53303,33.88,0.38,59.8,15306,75,NULL,'W91CL, r, cor','CGCG 119-044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53304,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53304,37.07,0.46,260,15307,70,NULL,NULL,'2MASX J08185108+1124407',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,124.7127917,11.41119,0.065,NULL,62784351379,981005490,15328210,16.4),(53305,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53305,37.95,0.1,388,15308,70,NULL,NULL,'SDSS J081854.09+224744.8',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.26,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,124.725375,22.79581,0.165,NULL,63809768359,997027630,15578556,17),(53306,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53306,39,0.46,632,15309,70,NULL,NULL,'SDSS J081854.65+400556.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000173,NULL,'18.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,124.72775,40.09908,0.149,NULL,64240052431,1003750819,15683606,18.6),(53307,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53307,37.32,0.46,292,15310,70,NULL,NULL,'2MASX J08185490+2006213',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000174,NULL,'17.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,124.7287083,20.10583,0.149,NULL,63814766450,997105725,15579776,17.5),(53308,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53308,36.56,0.46,205,15311,70,NULL,NULL,'2MASX J08185596+4857421',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000066,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,124.7332917,48.96167,0.193,NULL,63540851601,992825806,15512903,17.1),(53309,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53309,37.96,0.46,391,15312,70,NULL,NULL,'SDSS J081857.85+054017.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,124.7410417,5.67158,0.037,NULL,62767942912,980749108,15324204,18.3),(53310,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53310,33.81,0.58,57.8,15313,70,NULL,NULL,'ESO 089- G 017',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000083,NULL,'13.67',0.7,'SA0^0','in a triple',NULL,NULL,NULL,1,124.7412083,-67.50286,0.565,NULL,40773669686,637088588,9954509,13.67),(53311,'SBF','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53311,30.5,0.14,12.6,15314,74.4,NULL,NULL,'NGC 2549',NULL,'2013AJ....146...86T',2013,1,3.74,NULL,'G',0.000017,NULL,'12.1g',0.88,'SA(r)0^0^      PAS','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,124.743125,57.80306,0.117,NULL,61601106165,962517283,15039332,12.1),(53312,'SBF','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53312,30.51,0.28,12.6,15314,NULL,NULL,'I','NGC 2549',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53313,'Faber-Jackson','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53313,30.65,0.62,13.5,15314,95,NULL,'de Vaucouleurs','NGC 2549',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53314,'Faber-Jackson','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53314,30.93,0.32,15.3,15314,95,NULL,'Weighted Mean','NGC 2549',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53315,'Faber-Jackson','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53315,31.04,0.63,16.1,15314,95,NULL,'Michard 1979b, c','NGC 2549',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53316,'Faber-Jackson','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53316,31.36,0.46,18.7,15314,95,NULL,'Michard 1979a','NGC 2549',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53317,'Faber-Jackson','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53317,32.79,0.81,36.1,15314,55,NULL,'Visvanathan & Sandage 1979','NGC 2549',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53318,'Tertiary','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53318,30.65,0.71,13.5,15314,95,NULL,NULL,'NGC 2549',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53319,'Tully est','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53319,31.38,0.8,18.8,15314,75,NULL,'B','NGC 2549',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53320,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53320,30.48,0.45,12.5,15314,NULL,NULL,'K','NGC 2549',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53321,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53321,30.87,0.4,14.9,15314,NULL,NULL,'mean','NGC 2549',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53322,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53322,38.02,0.46,402,15315,70,NULL,NULL,'2MASX J08185844+3029172',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000133,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,124.743375,30.48811,0.109,NULL,64356802720,1005575042,15712110,17.9),(53323,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53323,37.75,0.46,355,15316,70,NULL,NULL,'SDSS J081859.39+410131.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000144,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,124.7475,41.02539,0.137,NULL,64240735041,1003761485,15683773,18.8),(53324,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53324,37.4,0.46,302,15317,70,NULL,NULL,'2MASX J08190059+1545221',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,124.7525417,15.75603,0.109,NULL,63784699733,996635933,15572436,17.8),(53325,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53325,34.42,0.21,76.4,15318,70,NULL,NULL,'NGC 2556',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000073,NULL,'15.1g',0.48,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,124.7535417,20.93697,0.141,NULL,63817338770,997145918,15580404,15.1),(53326,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53326,37.92,0.46,384,15319,70,NULL,NULL,'2MASX J08190102+2627566',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000133,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,124.754333333,26.46569,0.097,NULL,64349559150,1005461861,15710341,18.4),(53327,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53327,37.95,0.1,388,15320,70,NULL,NULL,'SDSS J081901.78+230236.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000138,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,124.7574583,23.04347,0.165,NULL,63809576423,997024631,15578509,18.3),(53328,'IRAS','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53328,33.75,0.8,56.3,15321,75,NULL,'HMCL, I','UGC 04329',NULL,'1997ApJS..109..333W',1997,1,2,'The 2MASS position refers to a knot 14 arcsec northeast of the nucleus.','G',0.000004,NULL,'14.15',1.5,'SA(r)cd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,124.757833,21.18586,0.153,NULL,63817374737,997146480,15580413,14.15),(53329,'IRAS','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53329,33.75,0.8,56.3,15321,75,NULL,'CF, r','UGC 04329',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53330,'IRAS','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53330,33.76,0.8,56.4,15321,75,NULL,'W91CL, r','UGC 04329',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53331,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53331,33.64,0.38,53.6,15321,75,NULL,'W91CL, r, raw','UGC 04329',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53332,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53332,33.75,0.38,56.3,15321,75,NULL,'W91CL, r, inv','UGC 04329',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53333,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53333,34.02,0.38,63.8,15321,75,NULL,'W91CL, r, cor','UGC 04329',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53334,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53334,34.26,0.38,71.1,15321,75,NULL,'CF, r, raw','UGC 04329',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53335,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53335,34.32,0.4,73,15321,75,NULL,'HMCL, I, raw','UGC 04329',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53336,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53336,34.4,0.38,75.9,15321,75,NULL,'CF, r, inv','UGC 04329',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53337,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53337,34.4,0.4,76,15321,75,NULL,'HMCL, I, inv','UGC 04329',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53338,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53338,34.43,0.38,77,15321,75,NULL,'CF, r, cor','UGC 04329',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53339,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53339,34.49,0.4,79,15321,75,NULL,'HMCL, I, cor','UGC 04329',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53340,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53340,34.28,0.46,71.7,15322,70,NULL,NULL,'CGCG 031-079',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000077,NULL,'14.9g',0.63,'E0',NULL,NULL,NULL,NULL,1,124.760333,3.63414,0.029,NULL,62589356482,977958695,15280604,14.9),(53341,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53341,34.78,0.4,90.5,15323,NULL,NULL,'mean','UGC 04262',NULL,'2007A&A...465...71T',2007,1,2.1,NULL,'G',0.000037,NULL,'13.90',1.4,'Sb',NULL,NULL,NULL,NULL,1,124.76175,83.26636,0.157,NULL,61256128030,957127000,14955109,13.9),(53342,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53342,34.94,0.47,97.2,15323,NULL,NULL,'H','UGC 04262',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53343,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53343,34.99,0.45,99.7,15323,NULL,NULL,'K','UGC 04262',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53344,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53344,35.02,0.46,101,15323,NULL,NULL,'J','UGC 04262',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53345,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53345,35.51,0.49,127,15324,75,NULL,'IR','FGC 0740',NULL,'2011yCatp016004901K',2011,1,0.93,NULL,'G',NULL,NULL,'15.79',0.1,'Scd','Field galaxy',NULL,NULL,NULL,1,124.76225,63.685,0.125,NULL,62227893915,972310842,15192356,15.79),(53346,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53346,35.79,NULL,144,15324,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0740',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53347,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53347,35.81,NULL,145,15324,NULL,NULL,'Dipole + Quadrupole','FGC 0740',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53348,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53348,35.83,NULL,147,15324,NULL,NULL,NULL,'FGC 0740',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53349,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53349,35.83,NULL,147,15324,NULL,NULL,'Dipole','FGC 0740',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53350,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53350,37.6,0.46,331,15325,70,NULL,NULL,'2MASX J08190443+3917314',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,124.7685,39.29206,0.141,NULL,64358352871,1005599263,15712488,17.2),(53351,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53351,38.13,0.46,422,15326,70,NULL,NULL,'SDSS J081904.62+085126.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.2g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,124.7692917,8.85747,0.013,NULL,62790207378,981096990,15329640,18.2),(53352,'Brightest Stars','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53352,26.05,NULL,1.62,15327,NULL,NULL,'LF','Holmberg II',NULL,'1997AstL...23..656G',1997,1,7.9,'Position in 1999ApJS..125..409C refers to a knot east of the center.','G',0.000003,NULL,'11.10',6.3,'Im','Probable group member',NULL,NULL,NULL,1,124.77075,70.72003,0.089,0,62186272425,971660506,15182195,11.1),(53353,'Brightest Stars','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53353,27.29,NULL,2.87,15327,NULL,NULL,'3R','Holmberg II',NULL,'1992A&AT....1..269T',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53354,'Brightest Stars','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53354,27.92,NULL,3.84,15327,NULL,NULL,'Red','Holmberg II',NULL,'1997AstL...23..644G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53355,'Brightest Stars','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53355,27.96,NULL,3.91,15327,NULL,NULL,'3B','Holmberg II',NULL,'1992A&AT....1..269T',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53356,'Brightest Stars','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53356,28.02,NULL,4.02,15327,NULL,NULL,'Red + Blue','Holmberg II',NULL,'1997AstL...23..644G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53357,'Brightest Stars','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53357,28.02,0.4,4.02,15327,NULL,NULL,'3B + 3R mean','Holmberg II',NULL,'1997AstL...23..656G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53358,'Brightest Stars','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53358,28.29,NULL,4.55,15327,NULL,NULL,'Blue','Holmberg II',NULL,'1997AstL...23..644G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53359,'Cepheids','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53359,27.42,NULL,3.05,15327,NULL,NULL,'HST KP Calibrated, max. D','Holmberg II',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53360,'Cepheids','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53360,27.42,NULL,3.05,15327,NULL,NULL,'7','Holmberg II',NULL,'1998AJ....115..573H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53361,'Cepheids','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53361,27.57,0.06,3.27,15327,74.4,NULL,NULL,'Holmberg II',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53362,'CMD','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53362,27.64,NULL,3.37,15327,NULL,NULL,NULL,'Holmberg II',NULL,'2012ApJ...748...47M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53363,'TRGB','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53363,27.57,0.06,3.27,15327,74.4,NULL,NULL,'Holmberg II',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53364,'TRGB','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53364,27.59,0.1,3.3,15327,NULL,NULL,NULL,'Holmberg II',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53365,'TRGB','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53365,27.65,0.03,3.38,15327,NULL,NULL,'I','Holmberg II',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53366,'TRGB','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53366,27.65,0.13,3.39,15327,NULL,NULL,'I','Holmberg II',NULL,'2002A&A...383..125K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53367,'TRGB','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53367,27.67,0.02,3.42,15327,NULL,NULL,'I','Holmberg II',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53368,'HII region diameter','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53368,26.62,0.13,2.11,15327,NULL,NULL,'Method 2','Holmberg II',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53369,'HII region diameter','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53369,26.95,0.15,2.45,15327,NULL,NULL,'Method 1','Holmberg II',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53370,'Magnitude','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53370,26.92,0.11,2.42,15327,NULL,NULL,NULL,'Holmberg II',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53371,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53371,27.15,NULL,2.69,15327,NULL,NULL,'LEDA [April 2006]','Holmberg II',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53372,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53372,28.26,0.4,4.5,15327,75,NULL,'B','Holmberg II',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53373,'IRAS','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53373,33.97,0.8,62.3,15328,75,NULL,'HMCL, I','CGCG 119-047',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000006,NULL,'14.5g',0.73,'Sab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,124.77125,21.79139,0.117,NULL,63809927251,997030113,15578595,14.5),(53374,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53374,34.66,0.4,85.5,15328,75,NULL,'HMCL, I, raw','CGCG 119-047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53375,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53375,34.79,0.4,90.6,15328,75,NULL,'HMCL, I, cor','CGCG 119-047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53376,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53376,34.86,0.4,93.9,15328,75,NULL,'HMCL, I, inv','CGCG 119-047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53377,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53377,36.65,0.27,214,15329,70,NULL,NULL,'2MASX J08190545+5632042',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.00009,NULL,'15.7g',0.41,NULL,NULL,NULL,NULL,NULL,1,124.7725417,56.53453,0.149,NULL,61551418962,961740921,15027201,15.7),(53378,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1995ba','R',53378,41.11,NULL,1200,15330,65,NULL,'SALT','[PDG95a] J081906.45+074321.0',0.388,'2010arXiv1006.2112L',2010,1,0.05,NULL,'G',0.001,NULL,'23.0g',0.03,'E/S0',NULL,NULL,NULL,NULL,1,124.777417,7.72258,0.017,NULL,62792561251,981133769,15330215,23),(53379,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1995ba',NULL,53379,41.5,0.47,1440,15330,74.2,NULL,'SALT 2','[PDG95a] J081906.45+074321.0',0.388,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53380,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1995ba',NULL,53380,42.07,0.19,1870,15330,65,NULL,NULL,'[PDG95a] J081906.45+074321.0',0.388,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53381,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1995ba',NULL,53381,42.1,0.37,1900,15330,70,NULL,'SALT','[PDG95a] J081906.45+074321.0',0.388,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53382,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1995ba',NULL,53382,42.32,0.35,2090,15330,65,NULL,'SALT','[PDG95a] J081906.45+074321.0',0.388,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53383,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53383,37.3,0.46,289,15331,70,NULL,NULL,'2MASX J08190773+3349542',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,124.7824583,33.83183,0.157,NULL,64337261976,1005269718,15707339,17.5),(53384,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53384,37.12,0.75,266,15332,70,NULL,NULL,'2MASX J08190789-0208457',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,124.782917,-2.14597,0.245,NULL,39210384925,612662264,9572847,15.9),(53385,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53385,37.86,0.46,373,15333,70,NULL,NULL,'2MASX J08190900+0901292',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,124.7875417,9.02483,0.037,NULL,62790184353,981096630,15329634,17.6),(53386,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53386,34.23,0.45,70.3,15334,NULL,NULL,'K','NGC 2557',NULL,'2007A&A...465...71T',2007,1,1.18,'The 2MASS position is 5 arcsec east of the nucleus.','G',0.00007,NULL,'13.7g',0.95,'SB0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,124.7947917,21.43578,0.121,NULL,63817243902,997144435,15580381,13.7),(53387,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53387,34.35,0.4,74,15334,NULL,NULL,'mean','NGC 2557',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53388,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53388,38.82,0.46,581,15335,70,NULL,NULL,'SDSS J081912.09+042024.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000141,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,124.800417,4.34017,0.029,NULL,62589014381,977953349,15280521,18.5),(53389,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53389,37.65,0.46,339,15336,70,NULL,NULL,'2MASX J08191232+2729145',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000177,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,124.8015,27.48742,0.081,NULL,64352556971,1005508702,15711073,16.9),(53390,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53390,37.44,0.46,308,15337,70,NULL,NULL,'2MASX J08191242+1526330',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000187,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,124.80175,15.44247,0.097,NULL,63783955792,996624309,15572254,16.7),(53391,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53391,37.28,0.46,286,15338,70,NULL,NULL,'2MASX J08191282+5329201',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,124.80325,53.48892,0.125,NULL,63492669100,992072954,15501139,17),(53392,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53392,33.5,0.69,50,15339,100,NULL,'mid-IR','NGC 2558',NULL,'2013ApJ...771...88L',2013,1,1.59,NULL,'G',0.00001,NULL,'13.7g',1.04,'SAB(rs)ab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,124.803167,20.51075,0.145,NULL,63816843670,997138182,15580284,13.7),(53393,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53393,34.45,0.4,77.6,15339,NULL,NULL,'mean','NGC 2558',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53394,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53394,34.7,0.47,86.9,15339,NULL,NULL,'H','NGC 2558',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53395,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53395,34.71,0.45,87.5,15339,NULL,NULL,'K','NGC 2558',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53396,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53396,34.75,0.46,88.9,15339,NULL,NULL,'J','NGC 2558',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53397,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53397,34.93,0.2,96.8,15339,74.4,NULL,NULL,'NGC 2558',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53398,'IRAS','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53398,34.23,0.8,70.3,15340,75,NULL,'W91CL, r','CGCG 119-051',NULL,'1997ApJS..109..333W',1997,1,0.84,NULL,'G',0.000012,NULL,'15.5g',0.49,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,124.804417,20.75747,0.141,NULL,63816808435,997137631,15580275,15.5),(53399,'IRAS','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53399,34.24,0.8,70.3,15340,75,NULL,'HMCL, I','CGCG 119-051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53400,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53400,34.16,0.13,68.1,15340,NULL,NULL,NULL,'CGCG 119-051',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53401,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53401,34.36,0.2,74.5,15340,74.4,NULL,NULL,'CGCG 119-051',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53402,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53402,34.42,0.43,76.6,15340,75,NULL,'3.6 micron, color corrected','CGCG 119-051',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53403,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53403,34.52,0.43,80.2,15340,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 119-051',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53404,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53404,34.82,0.38,92,15340,75,NULL,'W91CL, r, raw','CGCG 119-051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53405,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53405,34.83,0.4,92.6,15340,75,NULL,'HMCL, I, raw','CGCG 119-051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53406,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53406,34.87,0.38,94.3,15340,75,NULL,'W91CL, r, inv','CGCG 119-051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53407,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53407,34.94,0.4,97.1,15340,75,NULL,'HMCL, I, inv','CGCG 119-051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53408,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53408,34.95,0.38,97.6,15340,75,NULL,'W91CL, r, cor','CGCG 119-051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53409,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53409,35,0.4,99.8,15340,75,NULL,'HMCL, I, cor','CGCG 119-051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53410,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53410,38.04,0.46,405,15341,70,NULL,NULL,'2MASX J08191340+0018115',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,124.805875,0.30308,0.129,NULL,62579523227,977805050,15278203,17.2),(53411,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53411,34.68,0.46,86.2,15342,70,NULL,NULL,'ESO 018- G 002',NULL,'2014MNRAS.445.2677S',2014,1,2.2,NULL,'G',0.00005,NULL,'11.68',1.1,'SA(s)b',NULL,NULL,NULL,NULL,1,124.809083,-78.69614,0.345,NULL,39990329557,624848899,9763264,11.68),(53412,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53412,37.53,0.46,320,15343,70,NULL,NULL,'SDSS J081914.64+563936.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00013,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,124.8110417,56.66019,0.141,NULL,61544079303,961626239,15025409,18.3),(53413,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53413,35.1,0.13,105,15344,NULL,NULL,NULL,'IC 2290',NULL,'2009ApJS..182..474S',2009,1,0.62,NULL,'G',0.000033,NULL,'15.3g',0.43,'SBc(r)','Isolated galaxy',NULL,NULL,NULL,1,124.816083333,19.31325,0.149,NULL,63813649110,997088267,15579504,15.3),(53414,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53414,38.01,0.46,401,15345,70,NULL,NULL,'2MASX J08191649+1820285',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,124.81875,18.34114,0.125,NULL,63781607607,996587618,15571681,17.8),(53415,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53415,37.08,0.46,260,15346,70,NULL,NULL,'2MASX J08191693+0402285',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000181,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,124.8205417,4.04131,0.037,NULL,62589233687,977956776,15280574,16.2),(53416,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53416,37.8,0.27,363,15347,70,NULL,NULL,'2MASX J08191803+2013045',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,124.82525,20.21792,0.149,NULL,63816613172,997134580,15580227,18),(53417,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53417,37.86,0.46,374,15348,70,NULL,NULL,'2MASX J08191822+1033301',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,124.825875,10.55847,0.045,NULL,62783193030,980987391,15327927,17.8),(53418,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53418,38.11,0.46,418,15349,70,NULL,NULL,'2MASX J08191943+2145185',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,124.830875,21.75506,0.117,NULL,63809402274,997021910,15578467,18.2),(53419,'IRAS','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53419,34.14,0.8,67.4,15350,75,NULL,'HMCL, I','CGCG 119-053',NULL,'1997ApJS..109..333W',1997,1,0.58,NULL,'G',0.00002,NULL,'15.2g',0.44,'S0a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,124.832458333,21.05886,0.153,NULL,63817342632,997145978,15580405,15.2),(53420,'IRAS','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53420,34.15,0.8,67.5,15350,75,NULL,'W91CL, r','CGCG 119-053',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53421,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53421,33.62,0.43,53,15350,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 119-053',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53422,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53422,33.82,0.43,58.2,15350,75,NULL,'3.6 micron, color corrected','CGCG 119-053',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53423,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53423,34.01,0.2,63.4,15350,74.4,NULL,NULL,'CGCG 119-053',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53424,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53424,34.16,0.13,68.1,15350,NULL,NULL,NULL,'CGCG 119-053',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53425,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53425,34.27,0.38,71.5,15350,75,NULL,'W91CL, r, raw','CGCG 119-053',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53426,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53426,34.29,0.38,72.2,15350,75,NULL,'W91CL, r, inv','CGCG 119-053',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53427,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53427,34.44,0.38,77.4,15350,75,NULL,'W91CL, r, cor','CGCG 119-053',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53428,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53428,34.61,0.4,83.7,15350,75,NULL,'HMCL, I, raw','CGCG 119-053',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53429,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53429,34.71,0.4,87.5,15350,75,NULL,'HMCL, I, inv','CGCG 119-053',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53430,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53430,34.74,0.4,88.9,15350,75,NULL,'HMCL, I, cor','CGCG 119-053',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53431,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53431,37.8,0.27,363,15351,70,NULL,NULL,'SDSS J081919.87+201610.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000143,NULL,'19.2g',0.1,NULL,NULL,NULL,NULL,NULL,1,124.832833,20.26967,0.149,NULL,63816603207,997134425,15580225,19.2),(53432,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53432,37.95,0.46,389,15352,70,NULL,NULL,'2MASX J08191989+1331140',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,124.832875,13.52056,0.093,NULL,62650040341,978906880,15295420,17.2),(53433,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53433,36.97,0.46,248,15353,70,NULL,NULL,'2MASX J08191987+4232386',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.0002,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,124.832875,42.54411,0.177,NULL,63520197876,992503091,15507860,16.3),(53434,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53434,29.91,0.43,9.6,15354,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2552',NULL,'2014MNRAS.444..527S',2014,1,3.5,NULL,'G',0.000003,NULL,'12.5B',2.3,'SA(s)m?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,124.835541667,50.00964,0.165,NULL,63548042119,992938158,15514658,12.5),(53435,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53435,30.01,0.4,10,15354,75,NULL,'B','NGC 2552',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53436,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53436,30.01,0.43,10.1,15354,75,NULL,'3.6 micron, color corrected','NGC 2552',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53437,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53437,30.04,0.2,10.2,15354,74.4,NULL,NULL,'NGC 2552',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53438,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53438,30.34,0.66,11.7,15354,NULL,NULL,NULL,'NGC 2552',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53439,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53439,30.62,0.4,13.3,15354,73,NULL,'opt','NGC 2552',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53440,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53440,30.71,0.56,13.9,15354,NULL,NULL,'Malmquist cor.','NGC 2552',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53441,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53441,38.12,0.27,421,15355,70,NULL,NULL,'2MASX J08192064+2223035',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00017,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,124.836167,22.38425,0.137,NULL,63809804801,997028200,15578565,17.4),(53442,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53442,37.8,0.27,363,15356,70,NULL,NULL,'2MASX J08192066+2016075',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000214,NULL,'15.8g',0.56,NULL,NULL,NULL,NULL,NULL,1,124.83625,20.26872,0.149,NULL,63816603257,997134425,15580225,15.8),(53443,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53443,38.05,0.33,408,15357,70,NULL,NULL,'2MASX J08192128+5056580',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000068,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,124.838375,50.94953,0.137,NULL,63546062208,992907222,15514175,18.2),(53444,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53444,37.85,0.23,372,15358,70,NULL,NULL,'2MASX J08192187+2140555',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000143,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,124.8412083,21.68194,0.117,NULL,63816927309,997139489,15580304,18.1),(53445,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53445,36.23,0.46,176,15359,70,NULL,NULL,'2MASX J08192198+5159180',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00008,NULL,'16.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,124.841667,51.98831,0.137,NULL,63490839921,992044373,15500693,16.4),(53446,'IRAS','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53446,34,0.8,63.2,15360,75,NULL,'HMCL, I','IC 2288',NULL,'1997ApJS..109..333W',1997,1,0.64,'Position in 1997AJ....113...22G is incorrect.','G',0.000033,NULL,'15.7g',0.36,'Sb','Isolated galaxy',NULL,NULL,NULL,1,124.84325,23.74731,0.185,NULL,63762564441,996290069,15567032,15.7),(53447,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53447,34.2,0.13,69.3,15360,NULL,NULL,NULL,'IC 2288',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53448,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53448,34.7,0.4,87.3,15360,75,NULL,'HMCL, I, raw','IC 2288',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53449,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53449,34.78,0.4,90.3,15360,75,NULL,'HMCL, I, inv','IC 2288',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53450,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53450,34.83,0.4,92.3,15360,75,NULL,'HMCL, I, cor','IC 2288',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53451,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53451,37.67,0.46,343,15361,70,NULL,NULL,'2MASX J08192346+3723095',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,124.848041667,37.38608,0.145,NULL,64327411796,1005115809,15704934,17.8),(53452,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53452,37.85,0.23,372,15362,70,NULL,NULL,'2MASX J08192503+2143465',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,124.85425,21.72964,0.117,NULL,63809403609,997021931,15578467,17.4),(53453,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53453,38.51,0.46,503,15363,70,NULL,NULL,'2MASX J08192525+3213594',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000115,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,124.85525,32.23319,0.101,NULL,64355317257,1005551832,15711747,18.4),(53454,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53454,37.85,0.23,372,15364,70,NULL,NULL,'2MASX J08192710+2141554',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,124.8627917,21.69875,0.117,NULL,63809403027,997021922,15578467,17.6),(53455,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53455,38.07,0.27,411,15365,70,NULL,NULL,'SDSS J081928.19+210125.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000153,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,124.8674583,21.02361,0.153,NULL,63817164343,997143192,15580362,18.7),(53456,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53456,37.72,0.46,350,15366,70,NULL,NULL,'2MASX J08193009+4626168',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000069,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,124.8755417,46.438,0.173,NULL,63524597718,992571839,15508934,18.3),(53457,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53457,37.95,0.1,388,15367,70,NULL,NULL,'2MASX J08193038+2253144',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000181,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,124.876667,22.88731,0.173,NULL,63809734170,997027096,15578548,16.8),(53458,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53458,35.64,NULL,134,15368,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0741',NULL,'2010Ap&SS.325..163P',2010,1,1.12,NULL,'G',NULL,NULL,'16.25',0.11,'Sc','Field galaxy',NULL,NULL,NULL,1,124.877375,66.67947,0.109,NULL,62238429125,972475455,15194928,16.25),(53459,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53459,35.66,NULL,136,15368,NULL,NULL,'Dipole + Quadrupole','FGC 0741',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53460,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53460,35.67,NULL,136,15368,NULL,NULL,'Dipole','FGC 0741',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53461,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53461,35.69,NULL,137,15368,NULL,NULL,NULL,'FGC 0741',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53462,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53462,37.17,0.33,272,15369,70,NULL,NULL,'2MASX J08193074+4648346',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000094,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,124.877875,46.80978,0.177,NULL,63524396307,992568692,15508885,16.5),(53463,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53463,36.08,0.55,164,15370,70,NULL,NULL,'2MASX J08193135-0917149',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.64',0.3,NULL,NULL,NULL,NULL,NULL,1,124.880625,-9.28764,0.249,NULL,39424432426,616006756,9625105,16.64),(53464,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53464,36.72,0.51,221,15371,70,NULL,NULL,'2MASX J08193191-0309440',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,124.8829583,-3.16225,0.257,NULL,39214838621,612731853,9573935,14.3),(53465,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53465,34.31,0.07,72.9,15372,NULL,NULL,NULL,'IC 2293',NULL,'2009ApJS..182..474S',2009,1,1.03,NULL,'G',0.000033,NULL,'14.7g',0.76,'Sa','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,124.8837917,21.39431,0.121,NULL,63817227313,997144176,15580377,14.7),(53466,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53466,36.71,0.46,220,15373,70,NULL,NULL,'2MASX J08193260+3807494',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000205,NULL,'15.6g',0.49,'E0',NULL,NULL,NULL,NULL,1,124.885833,38.13036,0.125,NULL,64324421570,1005069087,15704204,15.6),(53467,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53467,37.95,0.1,388,15374,70,NULL,NULL,'2MASX J08193544+2333064',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000172,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,124.89775,23.55169,0.185,NULL,63808256282,997004004,15578187,17.9),(53468,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53468,38.05,0.33,408,15375,70,NULL,NULL,'2MASX J08193569+5058138',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000084,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,124.898667,50.97058,0.137,NULL,63546052434,992907069,15514172,17.8),(53469,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53469,38.07,0.27,411,15376,70,NULL,NULL,'2MASX J08193609+2102274',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000155,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,124.900375,21.04106,0.153,NULL,63817163583,997143180,15580362,18.6),(53470,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53470,38.35,0.46,467,15377,70,NULL,NULL,'SDSS J081937.74+263516.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000122,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,124.9072917,26.58789,0.105,NULL,64349754628,1005464916,15710389,18.3),(53471,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53471,34.4,0.2,75.9,15378,74.4,NULL,NULL,'UGC 04332',NULL,'2013AJ....146...86T',2013,1,1.23,NULL,'G',0.000013,NULL,'14.6g',0.71,'Irr/Pec        Sy2','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,124.907833,21.11431,0.153,NULL,63817360315,997146254,15580410,14.6),(53472,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53472,34.69,0.4,86.6,15378,NULL,NULL,'mean','UGC 04332',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53473,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53473,35.3,0.45,115,15378,NULL,NULL,'K','UGC 04332',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53474,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53474,35.39,0.47,120,15378,NULL,NULL,'H','UGC 04332',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53475,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53475,35.51,0.46,126,15378,NULL,NULL,'J','UGC 04332',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53476,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53476,35.63,0.43,134,15378,75,NULL,'3.6 micron, color corrected','UGC 04332',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53477,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53477,35.67,0.43,136,15378,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04332',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53478,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53478,37.22,0.46,277,15379,70,NULL,NULL,'2MASX J08193854+3418364',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000167,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,124.910666667,34.31025,0.173,NULL,64340258152,1005316533,15708070,16.8),(53479,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53479,37.28,0.63,286,15380,70,NULL,NULL,'2MASX J08193892-0315020',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.4,NULL,NULL,NULL,NULL,NULL,1,124.912166667,-3.25064,0.257,NULL,39214813398,612731459,9573929,14.4),(53480,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53480,37.95,0.1,388,15381,70,NULL,NULL,'2MASX J08193945+2309281',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,124.9142083,23.15786,0.165,NULL,63811678698,997057479,15579023,17.5),(53481,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53481,35.5,0.72,126,15382,70,NULL,NULL,'2MASX J08193944-6258438',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,124.91425,-62.97886,0.809,NULL,40565810915,633840795,9903762,16.8),(53482,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53482,37.85,0.23,372,15383,70,NULL,NULL,'2MASX J08194010+2141581',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000144,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,124.917083,21.69944,0.117,NULL,63809395139,997021799,15578465,18.2),(53483,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53483,36.94,0.46,244,15384,70,NULL,NULL,'2MASX J08194020+4315289',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'17.17',0.39,NULL,NULL,NULL,NULL,NULL,1,124.917667,43.25819,0.257,NULL,63519679022,992494984,15507734,17.17),(53484,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53484,37.94,0.46,388,15385,70,NULL,NULL,'2MASX J08194022+1112308',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,124.9177083,11.20861,0.061,NULL,62784479564,981007493,15328242,17.3),(53485,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53485,38.4,0.46,479,15386,70,NULL,NULL,'2MASX J08194066+0159138',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,124.919541667,1.98714,0.121,NULL,62581732338,977839567,15278743,17.3),(53486,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53486,37.38,0.46,299,15387,70,NULL,NULL,'2MASX J08194127+2643090',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000166,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,124.921875,26.71928,0.105,NULL,64349749629,1005464837,15710388,17),(53487,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53487,37.34,0.46,293,15388,70,NULL,NULL,'2MASX J08194179+5437383',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000173,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,124.924083,54.62731,0.125,NULL,61551103857,961735997,15027124,16.2),(53488,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53488,35.67,0.46,136,15389,70,NULL,NULL,'2MASX J08194279+1040378',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'16.7g',NULL,NULL,NULL,NULL,NULL,NULL,1,124.92825,10.67717,0.045,NULL,62783120906,980986264,15327910,16.7),(53489,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53489,35.82,0.46,146,15390,70,NULL,NULL,'2MASX J08194285+4547029',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000081,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,124.928583,45.78411,0.209,NULL,63526030425,992594225,15509284,16.2),(53490,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53490,38.07,0.27,411,15391,70,NULL,NULL,'2MASX J08194351+2102121',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000267,NULL,'15.0',0.4,NULL,'Group non-member, background',NULL,NULL,NULL,1,124.93125,21.03678,0.153,NULL,63817163279,997143176,15580362,15),(53491,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53491,38.34,0.46,466,15392,70,NULL,NULL,'2MASX J08194476+3450544',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000196,NULL,'18.4g',0.14,'Candidate      BLAGN',NULL,NULL,NULL,NULL,1,124.9364583,34.84844,0.161,NULL,64340194818,1005315544,15708055,18.4),(53492,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53492,37.02,0.46,253,15393,70,NULL,NULL,'2MASX J08194489+5740274',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000147,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,124.937166667,57.67417,0.181,NULL,61600143198,962502237,15039097,17.3),(53493,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53493,37.74,0.46,353,15394,70,NULL,NULL,'SDSS J081944.93+305456.4',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000161,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,124.93725,30.91567,0.101,NULL,64356133262,1005564582,15711946,16.6),(53494,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53494,37.26,0.46,283,15395,70,NULL,NULL,'2MASX J08194546+0727428',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000169,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,124.9395417,7.46194,0,NULL,62789227907,981081686,15329401,17.5),(53495,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53495,36.69,0.46,217,15396,70,NULL,NULL,'2MASX J08194551+5142378',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000103,NULL,'17.2g',0.23,'NLAGN',NULL,NULL,NULL,NULL,1,124.939625,51.71069,0.125,NULL,63491096091,992048376,15500755,17.2),(53496,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53496,38.46,0.46,492,15397,70,NULL,NULL,'SDSS J081945.91+325815.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,124.9412917,32.97103,0.121,NULL,64336672920,1005260514,15707195,18.4),(53497,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53497,37.57,0.46,327,15398,70,NULL,NULL,'SDSS J081946.20+453240.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000096,NULL,'17.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,124.9425,45.5445,0.197,NULL,63525924655,992592572,15509258,17.8),(53498,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53498,37.95,0.1,388,15399,70,NULL,NULL,'2MASX J08194639+2327411',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.8g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,124.943333,23.46147,0.161,NULL,63808273262,997004269,15578191,16.8),(53499,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53499,37.95,0.1,388,15400,70,NULL,NULL,'2MASX J08194647+2319311',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000149,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,124.9435,23.32536,0.161,NULL,63808267204,997004175,15578190,18.3),(53500,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53500,36.65,0.46,214,15401,70,NULL,NULL,'2MASX J08194651+4607150',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.0001,NULL,'15.7g',0.45,'S0',NULL,NULL,NULL,NULL,1,124.944,46.12094,0.185,NULL,63524123174,992564424,15508819,15.7),(53501,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53501,36.78,0.23,227,15402,70,NULL,NULL,'2MASX J08194695+4716120',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000086,NULL,'16.2g',0.35,'E0',NULL,NULL,NULL,NULL,1,124.945583333,47.27014,0.205,NULL,63542092267,992845191,15513206,16.2),(53502,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53502,37.11,0.46,264,15403,70,NULL,NULL,'2MASX J08194712+5648144',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00014,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,124.946667,56.80411,0.141,NULL,61544114521,961626789,15025418,17.6),(53503,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53503,37.53,0.46,320,15404,70,NULL,NULL,'2MASX J08194727+2756130',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000143,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,124.946958333,27.93675,0.085,NULL,64352276730,1005504323,15711005,17.3),(53504,'IRAS','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53504,33.5,0.8,50.1,15405,75,NULL,'W91CL, r','NGC 2565',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000006,NULL,'13.40',0.9,'(R\')SBbc;RET   Sbrst','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,124.951333,22.03144,0.113,NULL,63809931729,997030183,15578596,13.4),(53505,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53505,33.41,0.46,48.1,15405,NULL,NULL,'J','NGC 2565',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53506,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53506,33.41,0.38,48.1,15405,75,NULL,'W91CL, r, raw','NGC 2565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53507,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53507,33.44,0.47,48.7,15405,NULL,NULL,'H','NGC 2565',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53508,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53508,33.47,0.45,49.5,15405,NULL,NULL,'K','NGC 2565',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53509,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53509,33.58,0.38,52.1,15405,75,NULL,'W91CL, r, inv','NGC 2565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53510,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53510,33.64,0.4,53.6,15405,NULL,NULL,'mean','NGC 2565',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53511,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53511,33.7,0.2,55,15405,74.4,NULL,NULL,'NGC 2565',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53512,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53512,33.72,0.43,55.6,15405,75,NULL,'3.6 micron, color corrected','NGC 2565',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53513,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53513,33.84,0.38,58.6,15405,75,NULL,'W91CL, r, cor','NGC 2565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53514,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53514,33.84,0.06,58.7,15405,NULL,NULL,NULL,'NGC 2565',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53515,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53515,33.86,0.43,59.1,15405,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2565',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53516,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53516,38.26,0.46,448,15406,70,NULL,NULL,'2MASX J08195029+1600123',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,124.9595417,16.00356,0.089,NULL,63784846710,996638229,15572472,17.7),(53517,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53517,37.95,0.1,388,15407,70,NULL,NULL,'2MASX J08195359+2327091',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,124.973417,23.45253,0.161,NULL,63808259335,997004052,15578188,17.7),(53518,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53518,37.95,0.1,388,15408,70,NULL,NULL,'2MASX J08195518+2311161',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000149,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,124.979958333,23.18778,0.165,NULL,63811681178,997057518,15579023,17),(53519,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53519,37.91,0.46,382,15409,70,NULL,NULL,'SDSS J081955.44+533530.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00014,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,124.9810417,53.59181,0.125,NULL,63492717322,992073708,15501151,18.3),(53520,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53520,36.47,0.64,197,15410,70,NULL,NULL,'ESO 036-IG 003 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,'ESO-LV has V = 4794 +- 107 km/s.','G',0.00015,NULL,'16.57',NULL,NULL,NULL,NULL,NULL,NULL,1,124.982833,-75.43022,0.537,NULL,39910074885,623594920,9743670,16.57),(53521,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53521,37.03,0.46,255,15411,70,NULL,NULL,'2MASX J08195622+0547310',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000201,NULL,'15.9g',0.4,'E0',NULL,NULL,NULL,NULL,1,124.984375,5.792,0.021,NULL,62587433828,977928653,15280135,15.9),(53522,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53522,37.3,0.46,289,15412,70,NULL,NULL,'2MASX J08195809+5206388',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,'FoF','16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,124.992083,52.11081,0.137,NULL,63490952363,992046130,15500720,16.9),(53523,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53523,38.21,0.46,439,15413,70,NULL,NULL,'2MASX J08195867+5903504',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,124.994583,59.06414,0.185,NULL,61564645606,961947587,15030431,18.2),(53524,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53524,38.14,0.46,425,15414,70,NULL,NULL,'2MASX J08195876+2355281',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,124.995,23.92442,0.201,NULL,63762455928,996288373,15567005,18),(53525,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53525,37.6,0.46,331,15415,70,NULL,NULL,'2MASX J08195885+2226411',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000147,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,124.99525,22.44486,0.173,NULL,63809842531,997028789,15578574,17.6),(53526,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53526,34.09,0.09,65.9,15416,NULL,NULL,NULL,'CGCG 119-059',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000017,NULL,'15.7',0.2,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,124.99525,21.06628,0.153,NULL,63817173816,997143340,15580364,15.7),(53527,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53527,34.79,0.2,90.8,15416,74.4,NULL,NULL,'CGCG 119-059',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53528,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53528,34.85,0.43,93.2,15416,75,NULL,'3.6 micron, color corrected','CGCG 119-059',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53529,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53529,34.94,0.43,97.2,15416,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 119-059',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53530,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53530,36.29,0.55,181,15417,70,NULL,NULL,'2MASX J08195917-1211450',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.92',NULL,NULL,NULL,NULL,NULL,NULL,1,124.9964583,-12.19589,0.297,NULL,39410231232,615784863,9621638,16.92),(53531,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53531,37.15,0.46,269,15418,70,NULL,NULL,'2MASX J08195978+1554003',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000172,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,124.999083,15.90008,0.089,NULL,63784855756,996638371,15572474,17.1),(53532,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53532,37.68,0.46,344,15419,70,NULL,NULL,'2MASX J08200071+5043248',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000087,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,125.003167,50.72356,0.145,NULL,63545836768,992903699,15514120,17.2),(53533,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53533,37.17,0.46,272,15420,70,NULL,NULL,'2MASX J08200085+0744366',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000236,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,125.0037083,7.74339,0.005,NULL,62792451205,981132050,15330188,16.3),(53534,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53534,36.76,0.46,225,15421,70,NULL,NULL,'2MASX J08200147+2918339',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,125.006333,29.30956,0.097,NULL,64357031193,1005578612,15712165,17.5),(53535,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 2002he',NULL,53535,34.53,0.18,78.6,15422,74.2,NULL,'SALT 2','UGC 04322',0.024564,'2010ApJ...716..712A',2010,1,1.1,NULL,'G',0.00008,NULL,'14.70',0.8,'E',NULL,NULL,NULL,NULL,1,125.00725,62.83058,0.125,NULL,62056191299,969627989,15150437,14.7),(53536,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 2002he',NULL,53536,35.11,0.09,105,15422,74.4,NULL,NULL,'UGC 04322',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53537,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 2002he',NULL,53537,35.17,0.03,106,15422,72,NULL,'MLCS17','UGC 04322',0.024564,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53538,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 2002he',NULL,53538,35.19,0.16,107,15422,70,NULL,'SALT 2','UGC 04322',0.024564,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53539,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 2002he',NULL,53539,35.25,0.19,109,15422,65,NULL,'MLCS17','UGC 04322',0.024564,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53540,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 2002he',NULL,53540,35.25,0.16,110,15422,73.8,NULL,'SALT 2 (SNANA)','UGC 04322',0.0247,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53541,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 2002he',NULL,53541,35.29,0.2,111,15422,65,NULL,'MLCS31','UGC 04322',0.024564,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53542,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 2002he',NULL,53542,35.31,0.18,113,15422,65,NULL,'SALT','UGC 04322',0.024564,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53543,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 2002he',NULL,53543,35.42,0.21,119,15422,65,NULL,'SALT2','UGC 04322',0.024564,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53544,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 2002he',NULL,53544,35.69,0.04,134,15422,70,NULL,'SALT 2','UGC 04322',0.024564,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53545,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53545,37.95,0.1,388,15423,70,NULL,NULL,'2MASX J08200192+2310411',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,125.008167,23.17792,0.165,NULL,63811667068,997057297,15579020,17.9),(53546,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53546,38.04,0.46,405,15424,70,NULL,NULL,'2MASX J08200326+0552410',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000162,NULL,'16.9g',0.33,NULL,NULL,NULL,NULL,NULL,1,125.013666667,5.87814,0.021,NULL,62587466156,977929158,15280143,16.9),(53547,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53547,38.54,0.46,511,15425,70,NULL,NULL,'2MASX J08200433+4120197',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000175,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,125.0182083,41.33894,0.137,NULL,64240532805,1003758325,15683723,17.7),(53548,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53548,37.68,0.46,343,15426,70,NULL,NULL,'2MASX J08200483+2035131',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,125.020125,20.58703,0.149,NULL,63816697989,997135906,15580248,17.9),(53549,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53549,37.95,0.46,389,15427,70,NULL,NULL,'2MASX J08200587+5011417',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000078,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,125.0247917,50.19481,0.153,NULL,63548062996,992938484,15514663,17.5),(53550,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53550,36.45,0.46,195,15428,70,NULL,NULL,'2MASX J08200641+0913386',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'15.8g',0.44,NULL,NULL,NULL,NULL,NULL,1,125.026833333,9.22756,0.037,NULL,62794163980,981158812,15330606,15.8),(53551,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53551,38.07,0.46,412,15429,70,NULL,NULL,'2MASX J08200679+1955093',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,125.028333,19.91933,0.153,NULL,63817969503,997155773,15580558,17.6),(53552,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53552,38.42,0.46,483,15430,70,NULL,NULL,'SDSS J082007.10+153318.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000151,NULL,'18.7g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,125.029625,15.55519,0.097,NULL,63784810007,996637656,15572463,18.7),(53553,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53553,37.81,0.46,364,15431,70,NULL,NULL,'2MASX J08200719+2427569',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000172,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,125.03,24.46575,0.113,NULL,63761987362,996281052,15566891,18),(53554,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53554,37.63,0.46,336,15432,70,NULL,NULL,'2MASX J08200851+3735547',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,125.035583,37.59842,0.145,NULL,64327290306,1005113911,15704904,17.7),(53555,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53555,37.89,0.46,379,15433,70,NULL,NULL,'2MASX J08200872+5829054',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,125.036583,58.48494,0.173,NULL,61598396566,962474946,15038671,17.6),(53556,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53556,34.29,0.2,72.1,15434,74.4,NULL,NULL,'UGC 04340',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000006,NULL,'14.80',0.8,'SABd:',NULL,NULL,NULL,NULL,1,125.052833,26.02294,0.057,NULL,64349614598,1005462728,15710355,14.8),(53557,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53557,37.16,0.23,270,15435,70,NULL,NULL,'2MASX J08201292+3533327',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000174,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,125.05375,35.55903,0.197,NULL,64337856699,1005279010,15707484,18.4),(53558,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53558,37.97,0.46,393,15436,70,NULL,NULL,'2MASX J08201379+2538569',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000183,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,125.057583,25.64925,0.101,NULL,64294564719,1004602573,15696915,17.8),(53559,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53559,36.78,0.23,227,15437,70,NULL,NULL,'2MASX J08201499+4716012',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000091,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,125.062416667,47.26708,0.205,NULL,63542096244,992845253,15513207,17.2),(53560,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53560,37.17,0.33,272,15438,70,NULL,NULL,'2MASX J08201667+4652212',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000114,NULL,'16.6g',0.32,'AGN',NULL,NULL,NULL,NULL,1,125.0694583,46.87269,0.177,NULL,63524558948,992571233,15508925,16.6),(53561,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53561,35.64,0.46,134,15439,70,NULL,NULL,'2MASX J08201716+2050323',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000163,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,125.071583,20.84219,0.141,NULL,63816723741,997136308,15580254,16.3),(53562,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53562,38.49,0.46,499,15440,70,NULL,NULL,'2MASX J08201730+3516597',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000185,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,125.072041667,35.28317,0.185,NULL,64337806995,1005278234,15707472,17.6),(53563,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53563,36.87,0.46,237,15441,70,NULL,NULL,'2MASX J08201795+1842513',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000177,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,125.0747083,18.71436,0.165,NULL,63813361655,997083775,15579433,16.7),(53564,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53564,37.64,0.46,337,15442,70,NULL,NULL,'2MASX J08201794+2040273',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,125.0747083,20.67433,0.149,NULL,63816701045,997135953,15580249,17.5),(53565,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53565,35.7,0.23,138,15443,70,NULL,NULL,'2MASX J08201797+5628249',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000161,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,125.0747083,56.47356,0.149,NULL,61551434451,961741163,15027205,16.2),(53566,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53566,37.26,0.33,284,15444,70,NULL,NULL,'2MASX J08201877+4918563',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000077,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,125.077958333,49.31567,0.157,NULL,63541025299,992828520,15512945,16.9),(53567,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53567,37.58,0.46,328,15445,70,NULL,NULL,'2MASX J08201908+0632195',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,125.079417,6.53878,0.025,NULL,62566582981,977602859,15275044,17.8),(53568,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53568,37.37,0.46,297,15446,70,NULL,NULL,'2MASX J08201911+2944209',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,125.079583,29.73922,0.097,NULL,64357377139,1005584017,15712250,17.6),(53569,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53569,36.78,0.23,227,15447,70,NULL,NULL,'2MASX J08202216+4713393',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000094,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,125.0922917,47.22756,0.205,NULL,63542098590,992845290,15513207,16.5),(53570,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53570,36.5,0.61,199,15448,70,NULL,NULL,'2MFGC 06585',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.4I',0.2,NULL,NULL,NULL,NULL,NULL,1,125.096708333,-9.56844,0.221,NULL,39424541650,616008463,9625132,14.4),(53571,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53571,38.83,0.46,585,15449,70,NULL,NULL,'2MASX J08202329+3250393',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,125.097083,32.84417,0.113,NULL,64334545390,1005227271,15706676,17.5),(53572,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53572,37.52,0.46,318,15450,70,NULL,NULL,'SDSS J082023.65+162111.3',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.5g',0.34,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,125.098583,16.35317,0.089,NULL,63784578879,996634044,15572406,16.5),(53573,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53573,37.58,0.23,329,15451,70,NULL,NULL,'2MASX J08202450+4918324',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000125,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,125.101875,49.30925,0.157,NULL,63541033329,992828645,15512947,17.9),(53574,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53574,38.02,0.46,401,15452,70,NULL,NULL,'SDSS J082025.25+362358.8',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,125.1052083,36.39969,0.181,NULL,64326554382,1005102412,15704725,17.9),(53575,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53575,37.73,0.46,351,15453,70,NULL,NULL,'2MASX J08202557+0728064',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,125.1065,7.46847,0,NULL,62789043686,981078807,15329356,17.6),(53576,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53576,37.58,0.23,329,15454,70,NULL,NULL,'SDSS J082027.12+492358.1',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000077,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,125.113,49.3995,0.157,NULL,63541000187,992828127,15512939,18),(53577,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53577,37.95,0.1,388,15455,70,NULL,NULL,'2MASX J08202719+2329183',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000164,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,125.1132083,23.48833,0.161,NULL,63808447474,997006991,15578234,17.2),(53578,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53578,37.95,0.1,388,15456,70,NULL,NULL,'2MASX J08202828+2329433',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,125.11775,23.49533,0.161,NULL,63808447330,997006989,15578234,17.4),(53579,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53579,38.2,0.46,436,15457,70,NULL,NULL,'SDSS J082028.65+395441.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000132,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,125.119375,39.91147,0.125,NULL,64240354141,1003755533,15683680,18.8),(53580,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53580,37.86,0.46,374,15458,70,NULL,NULL,'2MASX J08202887+2722360',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,125.1202917,27.37658,0.085,NULL,64353105330,1005517270,15711207,17.6),(53581,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53581,35.5,0.51,126,15459,70,NULL,NULL,'2MASX J08202909-8128597',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,125.121667,-81.48331,0.673,NULL,39951456118,624241501,9753773,15.7),(53582,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53582,37.07,0.46,259,15460,70,NULL,NULL,'2MASX J08202927+1958093',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,125.122041667,19.96947,0.149,NULL,63817972706,997155823,15580559,17.8),(53583,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53583,37.42,0.46,304,15461,70,NULL,NULL,'2MASX J08203098+1727249',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,125.129167,17.45686,0.109,NULL,63781318569,996583102,15571610,17.2),(53584,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53584,35.7,0.23,138,15462,70,NULL,NULL,'2MASX J08203257+5628360',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,125.1357917,56.47678,0.149,NULL,61551434007,961741156,15027205,16.9),(53585,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53585,37.41,0.46,303,15463,70,NULL,NULL,'2MASX J08203370+5846220',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,125.140333,58.77289,0.145,NULL,61598495759,962476496,15038695,17.1),(53586,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53586,37.73,0.46,351,15464,70,NULL,NULL,'2MASX J08203404+2107363',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,125.14175,21.12678,0.153,NULL,63817146705,997142917,15580358,17.2),(53587,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53587,38.06,0.46,410,15465,70,NULL,NULL,'2MASX J08203441+2241563',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,125.1434583,22.69903,0.173,NULL,63811691352,997057677,15579026,17.8),(53588,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53588,37.26,0.33,284,15466,70,NULL,NULL,'2MASX J08203442+4918184',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000074,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,125.1437083,49.30506,0.157,NULL,63541034006,992828656,15512947,17.6),(53589,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53589,36,0.49,158,15467,70,NULL,NULL,'2MASX J08203455-0315357',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.91',0.6,NULL,NULL,NULL,NULL,NULL,1,125.143833333,-3.26022,0.193,NULL,39215263130,612738486,9574038,15.91),(53590,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53590,34.27,0.4,71.3,15468,NULL,NULL,'mean','UGC 04349',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00004,NULL,'15.03',0.3,'SB(s)c:','in a triple',NULL,NULL,NULL,1,125.146125,-1.37631,0.265,NULL,39211725621,612683212,9573175,15.03),(53591,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53591,34.42,0.49,76.5,15468,75,NULL,'IR','UGC 04349',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53592,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53592,35,0.47,100,15468,NULL,NULL,'H','UGC 04349',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53593,'IRAS','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53593,34.14,0.8,67.2,15469,75,NULL,'CF, r','UGC 04326',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00007,NULL,'13.95',0.5,'Sbc','Isolated galaxy',NULL,NULL,NULL,1,125.146541667,68.60031,0.117,NULL,62214130494,972095788,15188996,13.95),(53594,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53594,34,0.43,63,15469,NULL,NULL,'Malmquist cor.','UGC 04326',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53595,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53595,34.19,0.2,68.9,15469,74.4,NULL,NULL,'UGC 04326',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53596,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53596,34.2,0.38,69.2,15469,75,NULL,'CF, r, raw','UGC 04326',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53597,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53597,34.29,0.38,72.1,15469,75,NULL,'CF, r, cor','UGC 04326',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53598,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53598,34.29,0.37,72.2,15469,NULL,NULL,NULL,'UGC 04326',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53599,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53599,34.37,0.38,75,15469,75,NULL,'CF, r, inv','UGC 04326',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53600,'D-Sigma','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53600,34.03,0.4,64.1,15470,75,NULL,'Edat, raw','NGC 2563',NULL,'1997ApJS..109..333W',1997,1,1.51,NULL,'G',0.00006,NULL,'13.2g',1.02,'S0^0:;BrClG','in a pair',NULL,NULL,NULL,1,125.148708333,21.06781,0.141,NULL,63817179895,997143435,15580366,13.2),(53601,'D-Sigma','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53601,34.37,0.4,74.8,15470,75,NULL,'Edat, cor','NGC 2563',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53602,'Faber-Jackson','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53602,33.11,0.44,41.9,15470,95,NULL,'Weighted Mean','NGC 2563',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53603,'Faber-Jackson','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53603,33.44,0.46,48.8,15470,95,NULL,'Michard 1979a','NGC 2563',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53604,'Faber-Jackson','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53604,33.77,0.63,56.8,15470,95,NULL,'Michard 1979b, c','NGC 2563',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53605,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53605,34.42,0.21,76.4,15470,70,NULL,NULL,'NGC 2563',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53606,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53606,34.16,0.4,67.8,15470,NULL,NULL,'mean','NGC 2563',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53607,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53607,34.31,0.45,72.8,15470,NULL,NULL,'K','NGC 2563',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53608,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53608,37.95,0.1,388,15471,70,NULL,NULL,'2MASX J08203638+2314572',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,125.1514583,23.24919,0.165,NULL,63811652257,997057066,15579016,17.8),(53609,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53609,36.89,0.46,239,15472,70,NULL,NULL,'2MASX J08203690+3703435',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000188,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,125.15375,37.06222,0.161,NULL,64326766764,1005105730,15704777,16.4),(53610,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53610,37.38,0.46,299,15473,70,NULL,NULL,'2MASX J08203844+0633144',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000165,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,125.16025,6.55411,0.025,NULL,62566586200,977602909,15275045,16.8),(53611,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1994B',NULL,53611,38.5,0.17,460,15474,65,NULL,NULL,'[P94a] 081751.35+155320.5',0.089,'2004ApJ...607..665R',2004,1,NULL,NULL,'G',NULL,NULL,'17.5',NULL,NULL,NULL,NULL,NULL,NULL,1,125.16925,15.729,0.101,NULL,63784831625,996637994,15572468,17.5),(53612,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1994B',NULL,53612,38.51,0.1,504,15474,65,NULL,'Snapshot','[P94a] 081751.35+155320.5',NULL,'1998ApJ...504..935R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53613,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53613,37.58,0.23,329,15475,70,NULL,NULL,'2MASX J08204148+4922304',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000099,NULL,'16.1g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,125.1730417,49.37508,0.157,NULL,63540988336,992827942,15512936,16.1),(53614,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53614,38.19,0.46,434,15476,70,NULL,NULL,'SDSS J082041.93+403603.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00016,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,125.17475,40.601,0.145,NULL,64240795835,1003762434,15683788,18.6),(53615,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53615,37.57,0.46,326,15477,70,NULL,NULL,'2MASX J08204218+0557084',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000182,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,125.175833,5.9525,0.021,NULL,62595856044,978060250,15282191,17.2),(53616,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53616,37.87,0.46,374,15478,70,NULL,NULL,'2MASX J08204261+5611511',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000129,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,125.1772917,56.19742,0.165,NULL,61549505783,961711027,15026734,17.8),(53617,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53617,38.11,0.46,418,15479,70,NULL,NULL,'2MASX J08204475+5045364',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000127,NULL,'17.2g',0.24,'BLAGN',NULL,NULL,NULL,'Sy 1',1,125.186541667,50.76025,0.145,NULL,63545856887,992904013,15514125,17.2),(53618,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53618,35.51,0.2,126,15480,74.4,NULL,NULL,'IC 2308',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'GTrpl',0.000014,NULL,NULL,NULL,'S?             NELG?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,125.1885417,19.36228,0.153,NULL,63813593968,997087405,15579490,NULL),(53619,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53619,35.7,0.23,138,15481,70,NULL,NULL,'CGCG 287-072',NULL,'2015arXiv151105856S',2015,1,0.94,NULL,'G',0.00016,NULL,'14.5g',0.67,NULL,NULL,NULL,NULL,NULL,1,125.190625,56.49094,0.149,NULL,61551649105,961744517,15027258,14.5),(53620,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53620,37.83,0.46,369,15482,70,NULL,NULL,'2MASX J08204595+1944324',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000164,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,125.191583333,19.74225,0.153,NULL,63818140722,997158448,15580600,18.2),(53621,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53621,37.84,0.46,369,15483,70,NULL,NULL,'2MASX J08204667+0155232',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,125.194458333,1.92303,0.093,NULL,62593123161,978017549,15281524,17.2),(53622,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53622,37.77,0.33,357,15484,70,NULL,NULL,'2MASX J08204775+2649251',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,125.199041667,26.82372,0.105,NULL,64352539214,1005508425,15711069,17.2),(53623,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53623,37.36,0.46,296,15485,70,NULL,NULL,'2MASX J08204806+5524591',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,125.200083333,55.41644,0.137,NULL,61550434090,961725532,15026961,17.8),(53624,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53624,32.29,0.69,28.8,15486,100,NULL,'mid-IR','NGC 2574',NULL,'2013ApJ...771...88L',2013,1,2.2,NULL,'G',0.00002,NULL,'13.34',1.2,'SB(rs)ab:',NULL,NULL,NULL,NULL,1,125.200667,-8.91847,0.237,NULL,39416173037,615877703,9623089,13.34),(53625,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53625,33.39,0.4,47.6,15486,NULL,NULL,'mean','NGC 2574',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53626,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53626,33.48,0.46,49.8,15486,NULL,NULL,'J','NGC 2574',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53627,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53627,33.51,0.45,50.4,15486,NULL,NULL,'K','NGC 2574',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53628,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53628,33.52,0.47,50.5,15486,NULL,NULL,'H','NGC 2574',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53629,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53629,33.68,0.2,54.5,15486,74.4,NULL,NULL,'NGC 2574',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53630,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53630,37.3,0.46,288,15487,70,NULL,NULL,'2MASX J08204817+4811294',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000073,NULL,'17.0g',0.32,NULL,NULL,NULL,NULL,NULL,1,125.200875,48.19156,0.173,NULL,63543583402,992868490,15513570,17),(53631,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53631,36.94,0.46,244,15488,70,NULL,NULL,'2MASX J08204842+5117294',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000081,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,125.2015417,51.29142,0.125,NULL,63490377092,992037142,15500580,17),(53632,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53632,37.95,0.1,388,15489,70,NULL,NULL,'2MASX J08204882+2336574',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,125.203458333,23.61606,0.141,NULL,63808464172,997007252,15578238,17.6),(53633,'IRAS','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53633,33.77,0.8,56.8,15490,75,NULL,'HMCL, I','KUG 0817+228',NULL,'1997ApJS..109..333W',1997,1,1.01,NULL,'G',0.000004,NULL,'14.3g',0.63,'Sb             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,125.2055,22.65775,0.173,NULL,63811691806,997057684,15579026,14.3),(53634,'IRAS','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53634,33.79,0.8,57.3,15490,75,NULL,'W91CL, r','KUG 0817+228',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53635,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53635,33.41,0.38,48.1,15490,75,NULL,'W91CL, r, raw','KUG 0817+228',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53636,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53636,33.43,0.38,48.6,15490,75,NULL,'W91CL, r, inv','KUG 0817+228',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53637,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53637,33.72,0.43,55.5,15490,75,NULL,'3.6 micron, color + selection bias corrected','KUG 0817+228',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53638,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53638,33.75,0.43,56.2,15490,75,NULL,'3.6 micron, color corrected','KUG 0817+228',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53639,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53639,33.8,0.4,57.4,15490,75,NULL,'HMCL, I, raw','KUG 0817+228',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53640,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53640,33.8,0.2,57.5,15490,74.4,NULL,NULL,'KUG 0817+228',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53641,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53641,33.84,0.38,58.5,15490,75,NULL,'W91CL, r, cor','KUG 0817+228',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53642,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53642,33.9,0.4,60.2,15490,75,NULL,'HMCL, I, inv','KUG 0817+228',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53643,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53643,34.16,0.4,67.8,15490,75,NULL,'HMCL, I, cor','KUG 0817+228',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53644,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53644,34.21,0.13,69.6,15490,NULL,NULL,NULL,'KUG 0817+228',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53645,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53645,37.77,0.33,357,15491,70,NULL,NULL,'2MASX J08204948+2652531',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,125.206083,26.88136,0.105,NULL,64352541777,1005508465,15711069,17.1),(53646,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53646,37.56,0.46,325,15492,70,NULL,NULL,'2MASX J08205107+0705333',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000172,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,125.213,7.09247,0.009,NULL,62567060785,977610324,15275161,17.5),(53647,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53647,38.35,0.33,468,15493,70,NULL,NULL,'2MASX J08205139+0751213',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000143,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,125.2142917,7.85586,0.005,NULL,62790365521,981099461,15329679,18.5),(53648,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53648,37.58,0.23,329,15494,70,NULL,NULL,'2MASX J08205151+4923094',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000094,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,125.214625,49.38589,0.157,NULL,63540986576,992827915,15512936,16.9),(53649,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53649,37.57,0.46,326,15495,70,NULL,NULL,'2MASX J08205174+1000043',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,125.2155,10.00111,0.033,NULL,62783320080,980989376,15327959,16.7),(53650,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53650,37.67,0.21,341,15496,70,NULL,NULL,'2MASX J08205314+5500420',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000165,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,125.2215,55.01178,0.141,NULL,61551256704,961738386,15027162,17.1),(53651,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53651,36.62,0.46,210,15497,70,NULL,NULL,'2MASX J08205482+5323314',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000169,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,125.228625,53.39206,0.101,NULL,63493159650,992080619,15501259,16.2),(53652,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53652,36.37,0.61,188,15498,70,NULL,NULL,'2MASX J08205523-7024475',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,125.230333,-70.41328,0.589,NULL,40624726094,634761345,9918146,17.2),(53653,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53653,38.12,0.46,420,15499,70,NULL,NULL,'2MASX J08205548+2257374',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000168,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,125.231166667,22.96044,0.173,NULL,63811867292,997060426,15579069,18),(53654,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53654,35.76,0.53,142,15500,70,NULL,NULL,'2MASX J08205593-0116279',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.38',0.5,NULL,NULL,NULL,NULL,NULL,1,125.233,-1.2745,0.265,NULL,39211746915,612683545,9573180,16.38),(53655,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53655,38,0.33,399,15501,70,NULL,NULL,'2MASX J08205731+2011323',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000146,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,125.238791667,20.19222,0.149,NULL,63820036602,997188071,15581063,18.3),(53656,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53656,37.57,0.46,326,15502,70,NULL,NULL,'2MASX J08205787+3618440',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000174,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,125.241125,36.31236,0.185,NULL,64326598345,1005103099,15704735,17),(53657,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53657,37.81,0.46,364,15503,70,NULL,NULL,'2MASX J08205816+5545590',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,125.24225,55.76644,0.109,NULL,61550002981,961718796,15026856,17.6),(53658,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53658,36.99,0.46,250,15504,70,NULL,NULL,'2MASX J08205956+3943470',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,125.2482917,39.72969,0.125,NULL,64357997837,1005593716,15712401,17.7),(53659,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53659,31.19,NULL,17.3,15505,NULL,NULL,NULL,'ESO 495- G 008',NULL,'2013AJ....145..101K',2013,1,1,NULL,'G',0.000023,NULL,'16.08',0.2,'S...',NULL,NULL,NULL,NULL,1,125.252917,-23.78128,NULL,NULL,42270837139,660481830,10320028,16.08),(53660,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53660,35.89,0.46,150,15506,70,NULL,NULL,'CGCG 263-026',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000083,NULL,'15.2g',0.52,NULL,NULL,NULL,NULL,NULL,1,125.253583,55.20017,0.141,NULL,61551360135,961740002,15027187,15.2),(53661,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53661,36.34,0.33,185,15507,70,NULL,NULL,'2MASX J08210134+3841500',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000181,NULL,'15.9g',0.48,'S0^-',NULL,NULL,NULL,NULL,1,125.255625,38.69725,0.133,NULL,64357920925,1005592514,15712383,15.9),(53662,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53662,36.57,0.46,206,15508,70,NULL,NULL,'2MASX J08210307+5351156',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.89',0.31,NULL,NULL,NULL,NULL,NULL,1,125.2627917,53.85444,0.125,NULL,63492829140,992075455,15501178,16.89),(53663,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53663,37.24,0.46,280,15509,70,NULL,NULL,'2MASX J08210318+1101109',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,125.2632083,11.01975,0.097,NULL,62783914516,980998664,15328104,NULL),(53664,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53664,37.77,0.46,358,15510,70,NULL,NULL,'2MASX J08210340+0855359',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.44',NULL,NULL,NULL,NULL,NULL,NULL,1,125.264041667,8.9265,0.033,NULL,62790039958,981094374,15329599,17.44),(53665,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53665,36.24,0.46,177,15511,70,NULL,NULL,'2MASX J08210340+0812509',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,125.264333,8.21406,0.037,NULL,62790420246,981100316,15329692,16.9),(53666,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53666,38.37,0.46,473,15512,70,NULL,NULL,'SDSS J082103.60+421241.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000185,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,125.2650417,42.21144,0.213,NULL,64242482103,1003788782,15684199,18.1),(53667,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53667,38.02,0.46,402,15513,70,NULL,NULL,'SDSS J082104.17+065828.4',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000175,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,125.267416667,6.97458,0.033,NULL,62567087850,977610747,15275167,17.6),(53668,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53668,37.38,0.46,300,15514,70,NULL,NULL,'2MASX J08210445+5629410',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000171,NULL,'18.2g',0.1,NULL,NULL,NULL,NULL,NULL,1,125.2685417,56.49453,0.149,NULL,61551660598,961744696,15027260,18.2),(53669,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53669,37.85,0.33,372,15515,70,NULL,NULL,'2MASX J08210505+0408560',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,125.2710417,4.149,0.093,NULL,62591159598,977986868,15281044,17.2),(53670,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53670,37.99,0.33,397,15516,70,NULL,NULL,'2MASX J08210550+0914499',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,125.272958333,9.24714,0.037,NULL,62794020379,981156568,15330571,16.7),(53671,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53671,37.16,0.23,270,15517,70,NULL,NULL,'2MASX J08210560+3548183',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000166,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,125.27325,35.80508,0.197,NULL,64337917342,1005279958,15707499,17.5),(53672,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53672,37.67,0.21,341,15518,70,NULL,NULL,'2MASX J08210638+5512354',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,125.276625,55.20983,0.141,NULL,61551347551,961739805,15027184,17.7),(53673,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53673,35.92,0.33,153,15519,70,NULL,NULL,'2MASX J08210753+4650552',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00008,NULL,'15.8g',0.36,'S0',NULL,NULL,NULL,NULL,1,125.281208333,46.84875,0.185,NULL,63524524829,992570700,15508917,15.8),(53674,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53674,38,0.33,399,15520,70,NULL,NULL,'2MASX J08210837+2010535',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000138,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,125.284958333,20.18142,0.149,NULL,63820022879,997187857,15581060,18.6),(53675,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53675,37.98,0.46,395,15521,70,NULL,NULL,'2MASX J08210863+2355328',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000132,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,125.285875,23.92581,0.133,NULL,63808348712,997005448,15578210,17.4),(53676,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53676,37.51,0.46,317,15522,70,NULL,NULL,'2MASX J08210876+1243533',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,125.286541667,12.73142,0.093,NULL,62647160667,978861885,15294716,17.2),(53677,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53677,36.78,0.23,227,15523,70,NULL,NULL,'2MASX J08210897+4716382',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000071,NULL,'16.6g',0.28,NULL,'Group member',NULL,NULL,NULL,1,125.2875,47.27739,0.181,NULL,63541913906,992842404,15513162,16.6),(53678,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53678,36.86,0.46,235,15524,70,NULL,NULL,'2MASX J08210930+2854138',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000173,NULL,'16.8g',NULL,NULL,NULL,NULL,NULL,NULL,1,125.288667,28.90389,0.081,NULL,64356881551,1005576274,15712129,16.8),(53679,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53679,37.78,0.46,360,15525,70,NULL,NULL,'SDSS J082109.88+400835.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,125.291208333,40.14322,0.149,NULL,64240390648,1003756103,15683689,18.1),(53680,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53680,37.16,0.23,270,15526,70,NULL,NULL,'UGC 04351',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.00011,NULL,'15.4g',0.52,'AGN',NULL,NULL,NULL,NULL,1,125.2934583,35.79267,0.197,NULL,64337906715,1005279792,15707496,15.4),(53681,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53681,35.81,0.53,145,15527,70,NULL,NULL,'2MASX J08211051-1046298',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,125.29375,-10.77492,0.293,NULL,39413470592,615835478,9622429,15.2),(53682,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53682,38.17,0.46,430,15528,70,NULL,NULL,'SDSS J082110.76+262843.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.00015,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,125.294833,26.47867,0.033,NULL,64349714893,1005464295,15710379,18.7),(53683,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53683,37.95,0.46,388,15529,70,NULL,NULL,'2MASX J08211089+0839359',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,125.295583,8.66003,0.037,NULL,62789948570,981092946,15329577,18.5),(53684,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53684,38.35,0.33,468,15530,70,NULL,NULL,'2MASX J08211108+0751049',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,125.2962083,7.85131,0.025,NULL,62790329313,981098895,15329670,18.3),(53685,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53685,37.1,0.46,263,15531,70,NULL,NULL,'2MASX J08211152+2902368',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,125.297917,29.0435,0.081,NULL,64356927589,1005576993,15712140,17.8),(53686,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53686,36.77,0.46,226,15532,70,NULL,NULL,'2MASX J08211173+0358120',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000142,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,125.298917,3.96997,0.093,NULL,62591459088,977991548,15281117,16.9),(53687,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53687,36.8,0.46,229,15533,70,NULL,NULL,'2MASX J08211206+2353048',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000143,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,125.30025,23.88469,0.133,NULL,63808396641,997006197,15578221,17.4),(53688,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53688,38.79,0.46,572,15534,70,NULL,NULL,'2MASX J08211211+2315485',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,125.300458333,23.26361,0.165,NULL,63811766023,997058844,15579044,18),(53689,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53689,38.07,0.33,411,15535,70,NULL,NULL,'2MASX J08211342+0706499',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000177,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,125.3060417,7.11378,0.009,NULL,62567194075,977612407,15275193,17.1),(53690,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53690,37.99,0.46,397,15536,70,NULL,NULL,'2MASX J08211371+1942085',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,125.30725,19.70244,0.149,NULL,63818016259,997156504,15580570,18),(53691,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53691,37.45,0.46,309,15537,70,NULL,NULL,'2MASX J08211580+1031549',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,125.315708333,10.53203,0.049,NULL,62782824969,980981640,15327838,17.3),(53692,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53692,35.94,0.59,154,15538,70,NULL,NULL,'2MASX J08211720-0826318',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,125.321667,-8.44214,0.253,NULL,39416905608,615889150,9623267,14.4),(53693,'CMD','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53693,15.7,0.22,0.0138,15539,NULL,NULL,NULL,'SDSS J082117.25+560813.5',NULL,'2008A&A...477..139L',2008,1,0.05,NULL,'G',NULL,NULL,'21.7g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,125.321875,56.13708,0.165,1,61549461350,961710333,15026723,21.7),(53694,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53694,37.85,0.46,371,15540,70,NULL,NULL,'2MASX J08211729+2529308',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000186,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,125.322167,25.49186,0.089,NULL,64349161580,1005455649,15710244,16.5),(53695,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53695,38.07,0.33,411,15541,70,NULL,NULL,'2MASX J08211731+0703139',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000168,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,125.3222917,7.05392,0.033,NULL,62567071969,977610499,15275164,18.1),(53696,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53696,31.23,0.4,17.7,15542,75,NULL,NULL,'ESO 495- G 009',NULL,'2008Ap.....51..336K',2008,1,1.9,NULL,'G',0.000033,NULL,'15.00',0.4,'Sb: sp',NULL,NULL,NULL,NULL,1,125.3227083,-25.77506,NULL,NULL,42735888719,667748261,10433566,15),(53697,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53697,31.24,0.39,17.7,15542,73,NULL,'IR','ESO 495- G 009',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53698,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53698,31.94,0.49,24.4,15542,75,NULL,'IR','ESO 495- G 009',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53699,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53699,37.99,0.33,397,15543,70,NULL,NULL,'2MASX J08211772+0917319',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,125.323791667,9.29222,0.037,NULL,62794024430,981156631,15330572,18.3),(53700,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53700,37.42,0.46,305,15544,70,NULL,NULL,'2MASX J08211788+5348597',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000158,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,125.324667,53.81667,0.125,NULL,63492835002,992075546,15501180,17),(53701,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53701,37.29,0.46,287,15545,70,NULL,NULL,'2MASX J08211831+1446473',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000199,NULL,'16.4g',0.32,'AGN',NULL,NULL,NULL,NULL,1,125.326375,14.77981,0.105,NULL,63773111854,996454872,15569607,16.4),(53702,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53702,37.61,0.46,332,15546,70,NULL,NULL,'2MASX J08211869+0601399',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000182,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,125.327958333,6.02767,0.021,NULL,62596007244,978062613,15282228,16.4),(53703,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53703,38.29,0.46,454,15547,70,NULL,NULL,'2MASX J08212002+2846238',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000179,NULL,'18.0g',0.17,'AGN',NULL,NULL,NULL,NULL,1,125.333458333,28.77342,0.069,NULL,64356877466,1005576210,15712128,18),(53704,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53704,38.12,0.46,421,15548,70,NULL,NULL,'SDSS J082120.36+202352.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000105,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,125.334875,20.39786,0.157,NULL,63820265209,997191643,15581119,18.7),(53705,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53705,37.16,0.23,270,15549,70,NULL,NULL,'2MASX J08212079+3525143',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,125.3367917,35.42067,0.197,NULL,64338328505,1005286382,15707599,17.4),(53706,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53706,34.42,0.21,76.4,15550,70,NULL,NULL,'NGC 2569',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.000073,NULL,'14.6g',0.6,'E?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,125.338083,20.8675,0.149,NULL,63820137140,997189642,15581088,14.6),(53707,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53707,38.14,0.46,425,15551,70,NULL,NULL,'2MASX J08212139+0416364',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,125.339167,4.27669,0.065,NULL,62591366929,977990108,15281095,17.5),(53708,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53708,36.77,0.59,226,15552,70,NULL,NULL,'2MASX J08212206-1350065',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,125.341875,-13.83517,0.197,NULL,42248763676,660136932,10314639,15.3),(53709,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53709,35.92,0.33,153,15553,70,NULL,NULL,'2MASX J08212213+4644372',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000074,NULL,'16.1g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,125.342417,46.74372,0.185,NULL,63524521434,992570647,15508916,16.1),(53710,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53710,37.67,0.21,341,15554,70,NULL,NULL,'2MASX J08212228+5508005',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000185,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,125.342917,55.13353,0.141,NULL,61551237196,961738081,15027157,17.1),(53711,'IRAS','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53711,34.8,0.8,91.2,15555,75,NULL,'W91CL, r','NGC 2570',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000015,NULL,'15.1',0.6,'Sab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,125.343916667,20.91056,0.141,NULL,63820267567,997191680,15581120,15.1),(53712,'IRAS','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53712,34.8,0.8,91.2,15555,75,NULL,'HMCL, I','NGC 2570',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53713,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53713,34.76,0.4,89.4,15555,75,NULL,'HMCL, I, raw','NGC 2570',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53714,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53714,34.8,0.38,91.4,15555,75,NULL,'W91CL, r, raw','NGC 2570',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53715,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53715,34.9,0.4,95.4,15555,75,NULL,'HMCL, I, cor','NGC 2570',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53716,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53716,34.9,0.08,95.7,15555,NULL,NULL,NULL,'NGC 2570',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53717,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53717,34.91,0.38,95.7,15555,75,NULL,'W91CL, r, inv','NGC 2570',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53718,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53718,34.91,0.4,95.8,15555,75,NULL,'HMCL, I, inv','NGC 2570',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53719,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53719,34.93,0.38,96.8,15555,75,NULL,'W91CL, r, cor','NGC 2570',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53720,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53720,35.04,0.2,102,15555,74.4,NULL,NULL,'NGC 2570',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53721,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53721,37.94,0.33,388,15556,70,NULL,NULL,'2MASX J08212418+0116304',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,125.35075,1.27508,0.109,NULL,62582210519,977847039,15278859,17.2),(53722,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53722,33.36,0.69,47,15557,100,NULL,'mid-IR','NGC 2578',NULL,'2013ApJ...771...88L',2013,1,2,NULL,'G',0.000033,NULL,'13.45',1.2,'SB(r)0/a pec   AGN',NULL,NULL,NULL,NULL,1,125.351125,-13.31786,0.249,NULL,39343194271,614737410,9605272,13.45),(53723,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53723,36.61,0.46,210,15558,70,NULL,NULL,'2MASX J08212447+4515522',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00007,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,125.351916667,45.26447,0.165,NULL,63525518582,992586227,15509159,16.7),(53724,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53724,34.52,0.69,80.2,15559,100,NULL,'mid-IR','NGC 2572',NULL,'2013ApJ...771...88L',2013,1,1.32,NULL,'G',0.000013,NULL,'14.5g',0.48,'Sa?',NULL,NULL,NULL,NULL,1,125.352625,19.14778,0.165,NULL,63813262571,997082227,15579409,14.5),(53725,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53725,35.46,0.4,123,15559,NULL,NULL,'mean','NGC 2572',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53726,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53726,35.52,0.47,127,15559,NULL,NULL,'H','NGC 2572',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53727,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53727,35.58,0.45,130,15559,NULL,NULL,'K','NGC 2572',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53728,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53728,35.61,0.46,132,15559,NULL,NULL,'J','NGC 2572',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53729,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53729,35.81,0.2,145,15559,74.4,NULL,NULL,'NGC 2572',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53730,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53730,36.65,0.53,214,15560,70,NULL,NULL,'2MASX J08212511-1130468',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.61',NULL,NULL,NULL,NULL,NULL,NULL,1,125.354833,-11.51319,0.285,NULL,39410481742,615788777,9621699,16.61),(53731,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53731,37.02,0.46,253,15561,70,NULL,NULL,'2MASX J08212556+3541593',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000139,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,125.3567083,35.69972,0.197,NULL,64338412443,1005287694,15707620,17.6),(53732,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53732,34.42,0.21,76.4,15562,70,NULL,NULL,'CGCG 119-069',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000073,NULL,'15.7g',0.44,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,125.359875,21.13086,0.141,NULL,63817051093,997141423,15580334,15.7),(53733,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53733,38.59,0.46,523,15563,70,NULL,NULL,'2MASX J08212682+2246595',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,125.361875,22.78311,0.173,NULL,63811709206,997057956,15579030,17.3),(53734,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53734,37.94,0.46,387,15564,70,NULL,NULL,'SDSS J082127.66+263829.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000146,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,125.36525,26.64161,0.033,NULL,64349679006,1005463734,15710370,18.7),(53735,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53735,37.85,0.33,372,15565,70,NULL,NULL,'SDSS J082127.76+040616.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000122,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,125.3657083,4.10469,0.093,NULL,62591580183,977993440,15281147,18.3),(53736,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53736,33.56,0.4,51.5,15566,NULL,NULL,'mean','IC 2327',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00002,NULL,'14.20',0.4,'Sa?','in a pair',NULL,NULL,NULL,1,125.366541667,3.16928,0.069,NULL,62588942138,977952220,15280503,14.2),(53737,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53737,33.56,0.43,51.5,15566,75,NULL,'3.6 micron, color corrected','IC 2327',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53738,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53738,33.58,0.2,52,15566,74.4,NULL,NULL,'IC 2327',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53739,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53739,33.59,0.43,52.2,15566,75,NULL,'3.6 micron, color + selection bias corrected','IC 2327',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53740,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53740,34.03,0.47,63.9,15566,NULL,NULL,'H','IC 2327',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53741,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53741,37.48,0.33,314,15567,70,NULL,NULL,'2MASX J08212833+1556342',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,125.368125,15.94278,0.101,NULL,63784669583,996635462,15572429,17.1),(53742,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53742,37.94,0.33,388,15568,70,NULL,NULL,'2MASX J08212871+0121194',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,125.3697083,1.35531,0.109,NULL,62582218155,977847158,15278861,NULL),(53743,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53743,37.48,0.33,314,15569,70,NULL,NULL,'2MASX J08212915+1552322',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000168,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,125.371583,15.87553,0.101,NULL,63784182236,996627847,15572310,17.1),(53744,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53744,36.76,0.46,225,15570,70,NULL,NULL,'2MASX J08213009+2533572',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000173,NULL,'16.1g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,125.37525,25.56597,0.089,NULL,64349175108,1005455861,15710247,16.1),(53745,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53745,37.67,0.21,341,15571,70,NULL,NULL,'2MASX J08213043+5458585',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,125.3767917,54.98286,0.141,NULL,61551260262,961738441,15027163,17.7),(53746,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53746,37.95,0.46,389,15572,70,NULL,NULL,'2MASX J08213106+2730512',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000169,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,125.3795417,27.51411,0.065,NULL,64353146455,1005517913,15711217,17.2),(53747,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53747,37.66,0.46,340,15573,70,NULL,NULL,'2MASX J08213167+2706472',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000183,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,125.3819583,27.11317,0.069,NULL,64352999836,1005515622,15711181,17.3),(53748,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53748,37.97,0.33,393,15574,70,NULL,NULL,'2MASX J08213371+0109424',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,125.390458333,1.16189,0.109,NULL,62580342965,977817858,15278404,17.7),(53749,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53749,37.77,0.46,357,15575,70,NULL,NULL,'2MASX J08213412+0714037',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00021,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,125.3922917,7.23453,0.009,NULL,62567175104,977612111,15275189,16.7),(53750,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53750,30.81,NULL,14.5,15576,NULL,NULL,NULL,'AGC 188955',NULL,'2015AstBu..70....1K',2015,1,NULL,NULL,'RadioS',0.000063,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,125.395417,4.31611,0.065,NULL,62591395764,977990558,15281102,NULL),(53751,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53751,35.53,0.46,127,15577,70,NULL,NULL,'2MASX J08213552+5850276',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,125.3982917,58.84111,0.185,NULL,61598526198,962476971,15038702,16.5),(53752,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53752,37.1,0.46,264,15578,70,NULL,NULL,'2MASX J08213568+4217310',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000173,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,125.3987917,42.292,0.221,NULL,64242502343,1003789099,15684204,17.9),(53753,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53753,34.96,0.46,98.1,15579,70,NULL,NULL,'2MASX J08213593+1629483',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000095,NULL,'16.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,125.399666667,16.49692,0.109,NULL,63786559483,996664991,15572890,16),(53754,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53754,36.97,0.46,247,15580,70,NULL,NULL,'2MASX J08213715+0825178',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,125.40475,8.42147,0.037,NULL,62789911165,981092361,15329568,17),(53755,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53755,37.98,0.27,394,15581,70,NULL,NULL,'2MASX J08213736+2311284',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,125.405583,23.19131,0.133,NULL,63811770014,997058906,15579045,18),(53756,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1997ez','R',53756,42.69,NULL,1940,15582,65,NULL,'SALT','H-ZSNS J082138.13+032510.5',0.78,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,125.408875,3.41958,0.049,NULL,62588958930,977952483,15280507,NULL),(53757,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1997ez',NULL,53757,42.88,0.17,2120,15582,74.2,NULL,'SALT 2','H-ZSNS J082138.13+032510.5',0.78,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53758,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1997ez',NULL,53758,43.49,0.15,2800,15582,70,NULL,'SALT','H-ZSNS J082138.13+032510.5',0.78,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53759,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1997ez',NULL,53759,43.63,0.12,2990,15582,65,NULL,'SALT','H-ZSNS J082138.13+032510.5',0.78,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53760,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1997ez',NULL,53760,43.81,0.35,3250,15582,65,NULL,NULL,'H-ZSNS J082138.13+032510.5',0.78,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53761,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53761,37.98,0.27,394,15583,70,NULL,NULL,'2MASX J08213984+2314467',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,125.416083,23.24636,0.133,NULL,63811777428,997059022,15579047,NULL),(53762,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53762,37.1,0.46,263,15584,70,NULL,NULL,'2MASX J08214014+1900547',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000134,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,125.417167,19.01519,0.165,NULL,63813319215,997083112,15579423,18.1),(53763,'Tully est','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53763,33.08,0.8,41.3,15585,75,NULL,'B','NGC 2544',NULL,'1988NBGC.C....0000T',1988,1,1.1,NULL,'G',0.000083,NULL,'13.8',0.8,'(R\')SB(s)a     Sbrst','Pair member (points to parent)',NULL,NULL,'Starburst',1,125.418083,73.98836,0.033,NULL,61289932438,957655194,14963362,13.8),(53764,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53764,33.03,0.47,40.4,15585,NULL,NULL,'H','NGC 2544',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53765,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53765,33.05,0.45,40.7,15585,NULL,NULL,'K','NGC 2544',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53766,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53766,33.13,0.46,42.2,15585,NULL,NULL,'J','NGC 2544',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53767,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53767,33.57,0.4,51.9,15585,NULL,NULL,'mean','NGC 2544',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53768,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53768,37.98,0.27,394,15586,70,NULL,NULL,'2MASX J08214065+2305567',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,125.419541667,23.09897,0.133,NULL,63811789137,997059205,15579050,18.3),(53769,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53769,37.85,0.46,371,15587,70,NULL,NULL,'2MASX J08214122+2626292',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,125.421625,26.44142,0.033,NULL,64349827347,1005466052,15710407,17.4),(53770,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53770,37.66,0.46,341,15588,70,NULL,NULL,'2MASX J08214322+0632478',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000176,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,125.430291667,6.54667,0.033,NULL,62567418723,977615917,15275248,17.7),(53771,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53771,38.26,0.46,449,15589,70,NULL,NULL,'2MASX J08214517+1023038',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,125.438208333,10.38444,0.029,NULL,62782784967,980981015,15327828,NULL),(53772,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53772,37.53,0.46,320,15590,70,NULL,NULL,'2MASX J08214578+5005525',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00007,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,125.44075,50.09803,0.109,NULL,63540793464,992824897,15512889,17.6),(53773,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53773,36.25,0.46,178,15591,70,NULL,NULL,'2MASX J08214936+2821542',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000179,NULL,'15.8g',0.42,'E/S0',NULL,NULL,NULL,NULL,1,125.455667,28.36497,0.057,NULL,64352198223,1005503097,15710985,15.8),(53774,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53774,38.71,0.46,552,15592,70,NULL,NULL,'2MASX J08215112+5621454',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000181,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,125.4629583,56.36247,0.149,NULL,61551526665,961742604,15027228,17.9),(53775,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53775,36.81,0.46,230,15593,70,NULL,NULL,'2MASX J08215113+3841383',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000165,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,125.463125,38.69414,0.113,NULL,64357769718,1005590151,15712346,17),(53776,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53776,38.16,0.46,429,15594,70,NULL,NULL,'2MASX J08215146+1117238',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,125.464375,11.28994,0.097,NULL,62781002018,980953156,15327393,16.9),(53777,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53777,37.99,0.46,396,15595,70,NULL,NULL,'2MASX J08215347+1601563',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00017,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,125.4727083,16.03244,0.101,NULL,63784158459,996627475,15572304,17.6),(53778,'IRAS','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53778,33.57,0.8,51.8,15596,75,NULL,'HMCL, I','UGC 04361',NULL,'1997ApJS..109..333W',1997,1,1.16,NULL,'G',0.000006,NULL,'15.4g',0.39,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,125.476125,22.64133,0.173,NULL,63811998953,997062483,15579101,15.4),(53779,'IRAS','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53779,33.58,0.8,52.1,15596,75,NULL,'W91CL, r','UGC 04361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53780,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53780,33.2,0.2,43.7,15596,74.4,NULL,NULL,'UGC 04361',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53781,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53781,33.2,0.4,43.7,15596,75,NULL,'HMCL, I, inv','UGC 04361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53782,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53782,33.21,0.4,43.8,15596,75,NULL,'HMCL, I, raw','UGC 04361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53783,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53783,33.22,0.43,44.1,15596,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04361',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53784,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53784,33.23,0.43,44.2,15596,75,NULL,'3.6 micron, color corrected','UGC 04361',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53785,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53785,33.25,0.38,44.6,15596,75,NULL,'W91CL, r, inv','UGC 04361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53786,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53786,33.3,0.38,45.7,15596,75,NULL,'W91CL, r, raw','UGC 04361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53787,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53787,33.67,0.4,54.1,15596,75,NULL,'HMCL, I, cor','UGC 04361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53788,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53788,33.7,0.12,55.1,15596,NULL,NULL,NULL,'UGC 04361',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53789,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53789,33.73,0.38,55.8,15596,75,NULL,'W91CL, r, cor','UGC 04361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53790,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53790,36.34,0.33,185,15597,70,NULL,NULL,'CGCG 207-061',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000167,NULL,'15.5g',0.45,'E0',NULL,NULL,NULL,NULL,1,125.481125,38.37744,0.129,NULL,64357688722,1005588886,15712326,15.5),(53791,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1997L',NULL,53791,43.65,1.02,3460,15598,74.2,NULL,'SALT 2','H-ZSNS J082157.14+035335.7',0.55,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'Irr',NULL,NULL,NULL,NULL,1,125.488083,3.89325,0.065,NULL,62591432884,977991138,15281111,NULL),(53792,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53792,36.41,0.46,191,15599,70,NULL,NULL,'2MASX J08215761+5101386',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.0001,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,125.490125,51.0275,0.137,NULL,63490284784,992035699,15500557,16.3),(53793,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53793,37.58,0.27,328,15600,70,NULL,NULL,'2MASX J08215840+4900036',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000077,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,125.49325,49.00103,0.161,NULL,63540901507,992826586,15512915,18),(53794,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53794,37.7,0.27,347,15601,70,NULL,NULL,'2MASX J08215884+0638476',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,125.4952917,6.64653,0.033,NULL,62567473060,977616766,15275261,17.2),(53795,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53795,37.52,0.46,319,15602,70,NULL,NULL,'2MASX J08215917+5041136',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000087,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,125.496541667,50.68719,0.145,NULL,63547902303,992935973,15514624,17.3),(53796,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53796,37.63,0.46,336,15603,70,NULL,NULL,'2MASX J08215957+3311463',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00015,NULL,'17.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,125.498375,33.19625,0.121,NULL,64335188333,1005237317,15706833,17.4),(53797,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53797,38.08,0.17,414,15604,70,NULL,NULL,'SDSS J082159.81+320829.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000134,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,125.49925,32.1415,0.109,NULL,64341930303,1005342660,15708479,18.8),(53798,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53798,38.02,0.46,402,15605,70,NULL,NULL,'SDSS J082200.70+142258.2',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'18.1g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,125.502917,14.38286,0.105,NULL,63773744529,996464758,15569761,18.1),(53799,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53799,37.82,0.27,367,15606,70,NULL,NULL,'2MASX J08220166+2208497',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000144,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,125.506917,22.14714,0.137,NULL,63809356472,997021194,15578456,18.2),(53800,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53800,37.72,0.46,349,15607,70,NULL,NULL,'2MASX J08220194+0318055',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,125.5082083,3.30161,0.069,NULL,62588747216,977949175,15280455,17.3),(53801,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53801,35.98,0.46,157,15608,70,NULL,NULL,'2MASX J08220246+4427251',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000091,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,125.510417,44.45697,0.225,NULL,63525687816,992588872,15509201,16.3),(53802,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53802,37.61,0.46,333,15609,70,NULL,NULL,'2MASX J08220390+3446553',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,125.516083,34.78217,0.173,NULL,64338218544,1005284664,15707572,17.3),(53803,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53803,37.2,0.46,275,15610,70,NULL,NULL,'2MASX J08220383+1838027',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,125.516125,18.63406,0.161,NULL,63813232460,997081757,15579402,17.6),(53804,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53804,37.83,0.46,369,15611,70,NULL,NULL,'2MASX J08220456+0617326',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000133,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,125.519,6.29242,0.045,NULL,62566555772,977602433,15275038,18),(53805,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53805,37.96,0.23,391,15612,70,NULL,NULL,'SDSS J082205.04+054816.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000147,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,125.5210417,5.80453,0.049,NULL,62596004018,978062562,15282227,18.5),(53806,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53806,37.12,0.46,265,15613,70,NULL,NULL,'2MASX J08220657+4130331',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000181,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,125.527625,41.50911,0.177,NULL,64243615994,1003806499,15684476,16.6),(53807,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53807,36.45,0.33,195,15614,70,NULL,NULL,'2MASX J08220673+1534594',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000117,NULL,'15.6g',0.43,NULL,NULL,NULL,NULL,NULL,1,125.5282083,15.58328,0.097,NULL,63784353384,996630521,15572351,15.6),(53808,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53808,37.96,0.23,391,15615,70,NULL,NULL,'2MASX J08220697+0554475',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000186,NULL,'17.3g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,125.529083,5.91314,0.049,NULL,62595967051,978061985,15282218,17.3),(53809,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53809,36.98,0.46,249,15616,70,NULL,NULL,'SDSS J082207.05+115106.4',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.5g',0.35,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,125.529416667,11.85178,0.097,NULL,62781284154,980957564,15327461,16.5),(53810,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53810,38.27,0.46,452,15617,70,NULL,NULL,'2MASX J08220760+2710430',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,125.5317083,27.17853,0.069,NULL,64352995437,1005515553,15711180,17.5),(53811,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53811,37.58,0.27,328,15618,70,NULL,NULL,'2MASX J08220765+4900107',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000088,NULL,'16.4g',0.38,'BrClG',NULL,NULL,NULL,NULL,1,125.531875,49.00303,0.161,NULL,63540901125,992826580,15512915,16.4),(53812,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53812,38.43,0.46,485,15619,70,NULL,NULL,'2MASX J08220965+0624476',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000182,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,125.540417,6.41303,0.045,NULL,62567393422,977615522,15275242,17.1),(53813,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53813,37.62,0.46,335,15620,70,NULL,NULL,'2MASX J08221003+3157563',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000142,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,125.541583333,31.96575,0.093,NULL,64341758715,1005339979,15708437,18.1),(53814,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53814,35.73,0.48,140,15621,70,NULL,NULL,'CGCG 004-003',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6',NULL,NULL,NULL,NULL,NULL,NULL,1,125.550333,-2.04672,0.177,NULL,39223715506,612870554,9576102,15.6),(53815,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53815,37.97,0.33,393,15622,70,NULL,NULL,'2MASX J08221246+0115115',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,125.552,1.25322,0.109,NULL,62580390885,977818607,15278415,17.2),(53816,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53816,36.52,0.46,201,15623,70,NULL,NULL,'2MASX J08221248+3942381',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.0002,NULL,'15.7g',0.37,'SABab',NULL,NULL,NULL,NULL,1,125.552083,39.71075,0.141,NULL,64358043098,1005594423,15712412,15.7),(53817,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53817,36.01,0.46,159,15624,70,NULL,NULL,'2MASX J08221564+5617367',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000103,NULL,'15.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,125.56525,56.29353,0.165,NULL,61551537185,961742768,15027230,15.9),(53818,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53818,38.46,0.46,492,15625,70,NULL,NULL,'2MASX J08221747+3301053',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,125.57275,33.01811,0.113,NULL,64334510114,1005226720,15706667,18.4),(53819,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53819,37.53,0.46,321,15626,70,NULL,NULL,'2MASX J08221876+3802361',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000176,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,125.5782083,38.04328,0.113,NULL,64361078057,1005641844,15713153,17),(53820,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53820,38.04,0.33,405,15627,70,NULL,NULL,'2MASX J08221878+3838381',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000139,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,125.578417,38.64406,0.113,NULL,64357774710,1005590229,15712347,18.1),(53821,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53821,36.78,0.46,227,15628,70,NULL,NULL,'2MASX J08221950+3948451',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,125.581125,39.81239,0.165,NULL,64358033543,1005594274,15712410,17.1),(53822,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53822,32.37,NULL,29.8,15629,NULL,NULL,NULL,'IC 2329',NULL,'2015AstBu..70....1K',2015,1,2.26,'Position in 1986AJ.....91..705B is incorrect.','G',0.000025,NULL,'15.0g',0.36,'Sdm:',NULL,NULL,NULL,NULL,1,125.581167,19.41597,0.141,NULL,63818248297,997160129,15580627,15),(53823,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53823,37.08,0.46,260,15630,70,NULL,NULL,'2MASX J08222097+5020566',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000074,NULL,'17.4g',0.2,'NLAGN',NULL,NULL,NULL,'Sy 2',1,125.587458333,50.34914,0.153,NULL,63540609890,992822029,15512844,17.4),(53824,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53824,37.55,0.46,324,15631,70,NULL,NULL,'2MASX J08222250+3918561',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000142,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,125.593667,39.31569,0.141,NULL,64358212734,1005597073,15712454,17.5),(53825,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53825,36.45,0.33,195,15632,70,NULL,NULL,'CGCG 089-009',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000163,NULL,'15.0g',0.62,NULL,NULL,NULL,NULL,NULL,1,125.59625,15.51914,0.089,NULL,63784310423,996629850,15572341,15),(53826,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53826,37.31,0.46,290,15633,70,NULL,NULL,'2MASX J08222317+1144386',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,125.596583,11.744,0.097,NULL,62781385979,980959155,15327486,NULL),(53827,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53827,38.04,0.33,405,15634,70,NULL,NULL,'2MASX J08222697+3836191',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000145,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,125.612458333,38.60544,0.113,NULL,64357764245,1005590066,15712344,17.5),(53828,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53828,37.08,0.46,260,15635,70,NULL,NULL,'2MASX J08222816+2718570',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000194,NULL,'16.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,125.617375,27.31589,0.093,NULL,64353187721,1005518558,15711227,16.8),(53829,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53829,37.82,0.27,367,15636,70,NULL,NULL,'2MASX J08222843+2208544',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000163,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,125.6185,22.14856,0.137,NULL,63811305832,997051653,15578932,16.9),(53830,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53830,37.7,0.27,347,15637,70,NULL,NULL,'2MASX J08222845+0626259',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000187,NULL,'16.1g',0.36,'E0',NULL,NULL,NULL,NULL,1,125.618625,6.44061,0.045,NULL,62567374355,977615224,15275237,16.1),(53831,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53831,37.6,0.46,332,15638,70,NULL,NULL,'2MASX J08222873+0813519',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,125.61975,8.23097,0.037,NULL,62569506155,977648533,15275758,17.7),(53832,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53832,37.98,0.46,395,15639,70,NULL,NULL,'SDSS J082228.78+092313.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,125.619916667,9.38719,0.037,NULL,62782464286,980976004,15327750,18),(53833,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53833,33.02,0.2,40.2,15640,74.4,NULL,NULL,'UGC 04370',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.00003,NULL,'14.49',0.7,'SB(rs)d?       HII',NULL,NULL,NULL,NULL,1,125.6197917,-1.04558,0.129,NULL,39211235542,612675555,9573055,14.49),(53834,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53834,33.13,0.31,42.3,15640,NULL,NULL,NULL,'UGC 04370',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53835,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53835,33.68,0.24,54.4,15640,NULL,NULL,'Malmquist cor.','UGC 04370',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53836,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53836,33.83,0.49,58.5,15641,75,NULL,'IR','MCG -02-22-005',NULL,'2011yCatp016004901K',2011,1,2,'GSC 5435-1075 (mag. 13) superposed 25\\\" southeast.','G',0.000027,NULL,'14.59',0.4,'Sbc: sp',NULL,NULL,NULL,NULL,1,125.621708333,-11.41775,0.285,NULL,39410027282,615781676,9621588,14.59),(53837,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53837,33.88,0.2,59.7,15641,74.4,NULL,NULL,'MCG -02-22-005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53838,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53838,34.04,0.4,64.4,15641,NULL,NULL,NULL,'MCG -02-22-005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53839,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53839,34.11,0.39,66.3,15641,NULL,NULL,'Malmquist cor.','MCG -02-22-005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53840,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53840,34.18,0.47,68.6,15641,NULL,NULL,'H','MCG -02-22-005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53841,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53841,34.24,0.45,70.4,15641,NULL,NULL,'K','MCG -02-22-005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53842,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53842,34.25,0.46,70.7,15641,NULL,NULL,'J','MCG -02-22-005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53843,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53843,34.28,0.4,71.7,15641,NULL,NULL,'mean','MCG -02-22-005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53844,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53844,37.9,0.46,380,15642,70,NULL,NULL,'2MASX J08222993+0618359',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000187,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,125.624583,6.30992,0.045,NULL,62567411949,977615811,15275247,17.2),(53845,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53845,37.05,0.46,256,15643,70,NULL,NULL,'2MASX J08223015+5320529',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000174,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,125.625833,53.34803,0.101,NULL,63493264815,992082262,15501285,16.4),(53846,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53846,37.96,0.23,391,15644,70,NULL,NULL,'3C 198',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000102,NULL,'17.3g',0.22,'E;NLRG;BrClG   HII',NULL,NULL,NULL,'AGN',1,125.633125,5.95189,0.041,NULL,62595932611,978061447,15282210,17.3),(53847,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53847,37.07,0.46,259,15645,70,NULL,NULL,'2MASX J08223205+0734219',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,125.633667,7.57281,0.033,NULL,62570057413,977657147,15275892,17.7),(53848,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53848,37.22,0.46,278,15646,70,NULL,NULL,'2MASX J08223219+1844394',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000179,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,125.634208333,18.74433,0.165,NULL,63813213785,997081465,15579397,16.8),(53849,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53849,37.17,0.46,272,15647,70,NULL,NULL,'2MASX J08223225+0730469',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,125.634417,7.51294,0.025,NULL,62570068894,977657326,15275895,16.8),(53850,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53850,37.1,0.23,264,15648,70,NULL,NULL,'SDSS J082232.53+065346.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,125.635583333,6.89611,0.033,NULL,62567142216,977611597,15275181,17.9),(53851,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53851,37.67,0.21,341,15649,70,NULL,NULL,'2MASX J08223289+5501116',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000175,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,125.637125,55.01978,0.141,NULL,61551227082,961737923,15027155,17.7),(53852,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53852,37.69,0.33,345,15650,70,NULL,NULL,'SDSS J082233.25+223133.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.00016,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,125.638583,22.52589,0.145,NULL,63811262920,997050983,15578921,18.7),(53853,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53853,37.82,0.27,367,15651,70,NULL,NULL,'2MASX J08223369+2207414',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000166,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,125.640375,22.12817,0.137,NULL,63811128615,997048884,15578888,17.3),(53854,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53854,38,0.46,398,15652,70,NULL,NULL,'2MASX J08223528+1839284',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,125.647167,18.65792,0.161,NULL,63813240260,997081879,15579404,17.9),(53855,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53855,37.7,0.27,347,15653,70,NULL,NULL,'2MASX J08223583+0631379',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000175,NULL,'16.8g',0.33,NULL,NULL,NULL,NULL,NULL,1,125.649291667,6.52717,0.045,NULL,62567446299,977616348,15275255,16.8),(53856,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53856,38.63,0.46,533,15654,70,NULL,NULL,'SDSS J082236.80+034024.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000137,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,125.653333,3.67344,0.081,NULL,62590756504,977980570,15280946,18.6),(53857,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53857,37.2,0.46,275,15655,70,NULL,NULL,'2MASX J08223796+3329380',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000164,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,125.65825,33.49389,0.137,NULL,64334980200,1005234065,15706782,17.6),(53858,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53858,38.08,0.17,414,15656,70,NULL,NULL,'2MASX J08223815+3205510',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000192,NULL,'16.1g',0.38,'BrClG',NULL,NULL,NULL,NULL,1,125.65875,32.09758,0.109,NULL,64341883782,1005341934,15708467,16.1),(53859,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53859,37.85,0.46,371,15657,70,NULL,NULL,'2MASX J08223834+2431513',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000165,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,125.659708333,24.53089,0.069,NULL,63808186019,997002906,15578170,17),(53860,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53860,36.91,0.46,241,15658,70,NULL,NULL,'2MASX J08223878+0614059',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000199,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,125.661625,6.23511,0.049,NULL,62567365100,977615079,15275235,16.4),(53861,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53861,38.08,0.17,414,15659,70,NULL,NULL,'2MASX J08223970+3215270',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,125.665583,32.25756,0.109,NULL,64341855576,1005341493,15708460,17.5),(53862,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53862,37.69,0.33,345,15660,70,NULL,NULL,'2MASX J08224023+2226389',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000147,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,125.6675417,22.44414,0.145,NULL,63811269055,997051078,15578923,17.5),(53863,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53863,38.08,0.17,414,15661,70,NULL,NULL,'2MASX J08224168+3211100',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000149,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,125.673583,32.18611,0.109,NULL,64341847814,1005341372,15708458,17.2),(53864,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53864,35.42,0.27,121,15662,70,NULL,NULL,'CGCG 032-009',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000063,NULL,'14.7g',0.75,'E0','Group member',NULL,NULL,NULL,1,125.673708333,4.32786,0.093,NULL,62591018516,977984664,15281010,14.7),(53865,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53865,37.43,0.46,306,15663,70,NULL,NULL,'2MASX J08224183+0424443',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000077,NULL,'16.5g',0.38,NULL,NULL,NULL,NULL,NULL,1,125.674208333,4.4125,0.093,NULL,62590919619,977983119,15280986,16.5),(53866,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53866,37.58,0.27,328,15664,70,NULL,NULL,'2MASX J08224184+4854510',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00007,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,125.674333,48.91408,0.185,NULL,63543509796,992867340,15513552,17.8),(53867,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53867,38.63,0.46,533,15665,70,NULL,NULL,'2MASX J08224286+3414520',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00013,NULL,'17.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,125.678417,34.24794,0.165,NULL,64336706647,1005261041,15707203,17.9),(53868,'Tully est','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53868,32.44,0.8,30.8,15666,75,NULL,'B','NGC 2577',NULL,'1988NBGC.C....0000T',1988,1,1.8,NULL,'G',0.000017,NULL,'13.4',1.1,'S0-:','Group non-member, foreground',NULL,NULL,NULL,1,125.6810417,22.55308,0.145,NULL,63811970272,997062035,15579094,13.4),(53869,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53869,32.88,0.4,37.7,15666,NULL,NULL,'mean','NGC 2577',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53870,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53870,33.12,0.45,42.2,15666,NULL,NULL,'K','NGC 2577',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53871,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53871,35.29,0.56,114,15667,70,NULL,NULL,'2MASX J08224461-8117598',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,125.68575,-81.29994,0.561,NULL,39951086753,624235730,9753683,16.9),(53872,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53872,37.96,0.23,391,15668,70,NULL,NULL,'2MASX J08224495+0559303',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000163,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,125.68725,5.99181,0.041,NULL,62596660019,978072812,15282387,17.4),(53873,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53873,33.85,0.05,59,15669,NULL,NULL,NULL,'NGC 2575',NULL,'2009ApJS..182..474S',2009,1,2.3,NULL,'G',0.000004,NULL,'14.2g',1.9,'SA(rs)cd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,125.687333,24.29692,0.073,NULL,63808155209,997002425,15578162,14.2),(53874,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53874,36.61,0.52,210,15670,70,NULL,NULL,'2MASX J08224535-1316042',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.7I',0.4,NULL,NULL,NULL,NULL,NULL,1,125.6890417,-13.26783,0.233,NULL,42245466129,660085408,10313834,13.7),(53875,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53875,38.08,0.17,414,15671,70,NULL,NULL,'2MASX J08224570+3202210',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,125.690541667,32.03911,0.093,NULL,64341871835,1005341747,15708464,18.1),(53876,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53876,37.1,0.23,264,15672,70,NULL,NULL,'2MASX J08224704+0659599',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000174,NULL,'16.1g',0.38,'BrClG',NULL,NULL,NULL,NULL,1,125.6959583,6.99983,0.033,NULL,62567096011,977610875,15275169,16.1),(53877,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53877,37.52,0.46,319,15673,70,NULL,NULL,'2MASX J08224855+2805494',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00013,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,125.702333333,28.09703,0.065,NULL,64352319394,1005504990,15711015,18),(53878,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53878,38.03,0.21,404,15674,70,NULL,NULL,'2MASX J08224913+2010589',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,125.704833,20.18297,0.149,NULL,63820081483,997188773,15581074,17.4),(53879,'IRAS','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53879,33.82,0.8,58.1,15675,75,NULL,'CF, r','UGC 04353',NULL,'1997ApJS..109..333W',1997,1,1.2,'The 2MASS position is 5 arcsec southwest of the nucleus.','G',0.000417,NULL,'15.15',0.5,'Scd:','Field galaxy',NULL,NULL,NULL,1,125.709083,66.97047,0.113,NULL,62238659211,972479050,15194985,15.15),(53880,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53880,34.08,0.38,65.5,15675,75,NULL,'CF, r, raw','UGC 04353',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53881,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53881,34.14,0.38,67.3,15675,75,NULL,'CF, r, inv','UGC 04353',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53882,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53882,34.21,0.38,69.4,15675,75,NULL,'CF, r, cor','UGC 04353',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53883,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53883,36.61,0.59,210,15676,70,NULL,NULL,'2MASX J08225022-0053523',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.8I',0.5,NULL,NULL,NULL,NULL,NULL,1,125.709333,-0.89783,0.149,NULL,39211065127,612672892,9573013,13.8),(53884,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53884,37.1,0.23,264,15677,70,NULL,NULL,'2MASX J08225059+0651269',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000154,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,125.7109583,6.85756,0.033,NULL,62567225803,977612903,15275201,17),(53885,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53885,36.56,0.46,205,15678,70,NULL,NULL,'2MASX J08225079+5631181',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000139,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,125.7115,56.52178,0.149,NULL,61551584926,961743514,15027242,17.1),(53886,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53886,37.68,0.46,344,15679,70,NULL,NULL,'2MASX J08225144+3649352',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000147,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,125.7142917,36.82647,0.165,NULL,64326905561,1005107899,15704810,18),(53887,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53887,37.2,0.33,276,15680,70,NULL,NULL,'SDSS J082251.80+102401.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.6g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,125.715875,10.40033,0.029,NULL,62782921587,980983149,15327861,17.6),(53888,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53888,37.6,0.46,331,15681,70,NULL,NULL,'2MASX J08225223+0747329',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00019,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,125.717667,7.79264,0.033,NULL,62568910814,977639231,15275612,16.8),(53889,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53889,37.74,0.46,354,15682,70,NULL,NULL,'2MASX J08225254+3844502',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000158,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,125.718917,38.74736,0.133,NULL,64357766024,1005590094,15712345,16.8),(53890,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53890,35.21,0.46,110,15683,70,NULL,NULL,'2MASX J08225255+2533303',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000169,NULL,'15.8g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,125.719,25.55839,0.089,NULL,64349272968,1005457390,15710271,15.8),(53891,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53891,38.03,0.21,404,15684,70,NULL,NULL,'2MASX J08225268+2011539',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000186,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,125.719541667,20.19836,0.149,NULL,63820082029,997188781,15581074,17.1),(53892,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53892,32.76,0.2,35.7,15685,74.4,NULL,NULL,'UGC 04374',NULL,'2013AJ....146...86T',2013,1,1.25,NULL,'G',0.000033,NULL,'14.0g',1.01,'SB(s)cd',NULL,NULL,NULL,NULL,1,125.721958333,3.57119,0.081,NULL,62590786936,977981045,15280953,14),(53893,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53893,32.84,0.75,36.9,15685,NULL,NULL,NULL,'UGC 04374',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53894,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53894,33.26,0.62,44.8,15685,NULL,NULL,'Malmquist cor.','UGC 04374',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53895,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53895,34.12,0.4,66.8,15685,NULL,NULL,'mean','UGC 04374',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53896,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53896,34.43,0.47,76.8,15685,NULL,NULL,'H','UGC 04374',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53897,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53897,37.8,0.23,363,15686,70,NULL,NULL,'2MASX J08225455+0625589',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,125.727333333,6.43292,0.045,NULL,62567369052,977615141,15275236,17.9),(53898,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53898,37.32,0.46,291,15687,70,NULL,NULL,'2MASX J08225461+2036099',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000135,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,125.727583,20.60289,0.133,NULL,63820510680,997195479,15581179,18.1),(53899,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53899,36.83,0.46,233,15688,70,NULL,NULL,'SDSS J082255.51+303137.6',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000169,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,125.731333333,30.52714,0.109,NULL,64356372082,1005568313,15712004,17.7),(53900,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53900,35.14,0.2,107,15689,74.4,NULL,NULL,'CGCG 060-003',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000187,NULL,'15.2',0.4,NULL,NULL,NULL,NULL,NULL,1,125.731375,13.62286,0.097,NULL,63770877373,996419958,15569061,15.2),(53901,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53901,34.41,0.48,76.4,15690,70,NULL,NULL,'CGCG 004-008',NULL,'2014MNRAS.445.2677S',2014,1,0.86,NULL,'G',0.00009,NULL,'15.2',0.7,NULL,NULL,NULL,NULL,NULL,1,125.733625,-0.36989,0.141,NULL,39211389635,612677963,9573093,15.2),(53902,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53902,38.03,0.21,404,15691,70,NULL,NULL,'2MASX J08225609+2012419',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000191,NULL,'17.1g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,125.733833,20.21183,0.149,NULL,63820084106,997188814,15581075,17.1),(53903,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53903,38.1,0.33,417,15692,70,NULL,NULL,'2MASX J08225608+1753339',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,125.733875,17.89269,0.141,NULL,63782910957,996607983,15571999,17.3),(53904,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53904,36.49,0.46,198,15693,70,NULL,NULL,'2MASX J08225665+4529091',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000126,NULL,'15.5g',0.43,'BrClG',NULL,NULL,NULL,NULL,1,125.736167,45.48594,0.165,NULL,63525952329,992593005,15509265,15.5),(53905,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53905,38.35,0.27,467,15694,70,NULL,NULL,'SDSS J082257.67+041356.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000159,NULL,'18.5g',0.09,NULL,NULL,NULL,NULL,NULL,1,125.740291667,4.23236,0.093,NULL,62591015441,977984616,15281009,18.5),(53906,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53906,35.33,0.42,117,15695,NULL,NULL,'Malmquist cor.','NGC 2576',NULL,'2009ApJS..182..474S',2009,1,2.56,NULL,'G',0.000009,NULL,'14.9g',0.35,'Sb',NULL,NULL,NULL,NULL,1,125.740417,25.73872,0.081,NULL,64349100417,1005454694,15710229,14.9),(53907,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53907,35.38,0.2,119,15695,74.4,NULL,NULL,'NGC 2576',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53908,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53908,35.59,0.37,131,15695,NULL,NULL,NULL,'NGC 2576',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53909,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53909,38.08,0.17,414,15696,70,NULL,NULL,'2MASX J08225798+3208240',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000132,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,125.741667,32.14011,0.109,NULL,64341849777,1005341402,15708459,17.5),(53910,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53910,33.73,0.2,55.7,15697,74.4,NULL,NULL,'UGC 04373',NULL,'2013AJ....146...86T',2013,1,1.18,NULL,'G',0.000006,NULL,'15.3g',0.5,'SBcd:',NULL,NULL,NULL,NULL,1,125.744083333,27.70769,0.065,NULL,64353014029,1005515844,15711185,15.3),(53911,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53911,37.8,0.23,363,15698,70,NULL,NULL,'2MASX J08225882+0612218',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,125.745083,6.20603,0.049,NULL,62566836786,977606824,15275106,17.5),(53912,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53912,37.76,0.46,357,15699,70,NULL,NULL,'2MASX J08225967+5236199',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000077,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,125.74875,52.60558,0.177,NULL,63492463992,992069749,15501089,17.6),(53913,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53913,38.35,0.27,467,15700,70,NULL,NULL,'SDSS J082259.94+041106.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,125.74975,4.18503,0.093,NULL,62590985408,977984147,15281002,18.4),(53914,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53914,37.53,0.33,320,15701,70,NULL,NULL,'2MASX J08230091+1752109',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000161,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,125.7537917,17.86972,0.141,NULL,63782911185,996607987,15571999,16.7),(53915,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53915,38.32,0.27,461,15702,70,NULL,NULL,'2MASX J08230276+2154139',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000182,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,125.7615,21.90389,0.153,NULL,63811104290,997048504,15578882,17.2),(53916,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53916,37.55,0.46,323,15703,70,NULL,NULL,'2MASX J08230318+2632282',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000168,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,125.763125,26.54131,0.057,NULL,64349367900,1005458873,15710294,17.1),(53917,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53917,37.92,0.46,384,15704,70,NULL,NULL,'SDSS J082303.27+413427.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000146,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,125.763625,41.57433,0.177,NULL,64243548872,1003805451,15684460,18.6),(53918,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53918,37.1,0.23,264,15705,70,NULL,NULL,'2MASX J08230397+0700408',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,125.766625,7.01131,0.017,NULL,62569915662,977654932,15275858,16.8),(53919,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53919,37.8,0.23,363,15706,70,NULL,NULL,'2MASX J08230459+0627258',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,125.769,6.45719,0.045,NULL,62566859352,977607177,15275112,17.5),(53920,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53920,37.95,0.46,389,15707,70,NULL,NULL,'2MASX J08230472+1016038',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,125.7697917,10.26778,0.065,NULL,62782852990,980982077,15327844,17.6),(53921,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53921,38.08,0.17,414,15708,70,NULL,NULL,'SDSS J082304.96+320441.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000138,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,125.770667,32.07828,0.093,NULL,64341839752,1005341246,15708456,18),(53922,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53922,38.1,0.46,417,15709,70,NULL,NULL,'2MASX J08230608+1956069',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000182,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,125.775291667,19.93517,0.157,NULL,63818092576,997157696,15580589,17.1),(53923,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53923,37.33,0.33,292,15710,70,NULL,NULL,'2MASX J08230646+5411591',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000171,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,125.777167,54.19981,0.113,NULL,63491590888,992056107,15500876,17.5),(53924,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53924,38.32,0.27,461,15711,70,NULL,NULL,'2MASX J08230714+2152528',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.7g',0.2,'AGN',NULL,NULL,NULL,NULL,1,125.779667,21.88139,0.153,NULL,63811102560,997048477,15578882,17.7),(53925,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53925,37.2,0.33,276,15712,70,NULL,NULL,'2MASX J08230729+1035538',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000133,NULL,'16.22',0.44,NULL,NULL,NULL,NULL,NULL,1,125.7805,10.59828,0.029,NULL,62782706794,980979793,15327809,16.22),(53926,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53926,37.84,0.46,370,15713,70,NULL,NULL,'2MASX J08230749+2145228',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,125.78125,21.75636,0.141,NULL,63809260003,997019687,15578432,17.9),(53927,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53927,38.1,0.33,417,15714,70,NULL,NULL,'2MASX J08230832+1801374',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000128,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,125.7847083,18.02689,0.149,NULL,63782892607,996607696,15571995,18.5),(53928,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53928,37.65,0.46,340,15715,70,NULL,NULL,'2MASX J08230843+4551231',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,125.785083,45.85656,0.141,NULL,63526870712,992607354,15509489,17),(53929,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53929,38.35,0.27,467,15716,70,NULL,NULL,'2MASX J08230921+0418326',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.0001,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,125.788417,4.30919,0.033,NULL,62591074042,977985531,15281023,17.6),(53930,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53930,38.41,0.46,481,15717,70,NULL,NULL,'2MASX J08230940+4109261',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,125.789167,41.15744,0.161,NULL,64243462120,1003804095,15684438,17.9),(53931,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53931,37.87,0.46,374,15718,70,NULL,NULL,'2MASX J08231025+3006160',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,125.792917,30.10456,0.105,NULL,64356506939,1005570420,15712037,18.1),(53932,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53932,36.46,0.46,196,15719,70,NULL,NULL,'2MASX J08231034+1514531',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,125.7929583,15.24817,0.105,NULL,63772878720,996451230,15569550,17.4),(53933,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53933,38.15,0.14,427,15720,70,NULL,NULL,'2MASX J08231030+1922274',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,125.793,19.37433,0.141,NULL,63818266346,997160411,15580631,17.4),(53934,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53934,31.57,0.69,20.6,15721,100,NULL,'mid-IR','UGC 04375',NULL,'2013ApJ...771...88L',2013,1,2.5,NULL,'G',0.000015,NULL,'12.79',1.6,'SABc:','Group non-member, foreground',NULL,NULL,NULL,1,125.797,22.66458,0.145,NULL,63812089813,997063903,15579123,12.79),(53935,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53935,32.88,0.4,37.7,15721,NULL,NULL,NULL,'UGC 04375',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53936,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53936,32.94,0.4,38.7,15721,NULL,NULL,'mean','UGC 04375',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53937,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53937,33.05,0.2,40.7,15721,74.4,NULL,NULL,'UGC 04375',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53938,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53938,33.08,0.43,41.2,15721,75,NULL,'3.6 micron, color corrected','UGC 04375',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53939,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53939,33.14,0.47,42.4,15721,NULL,NULL,'H','UGC 04375',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53940,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53940,33.15,0.46,42.7,15721,NULL,NULL,'J','UGC 04375',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53941,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53941,33.17,0.43,43.1,15721,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04375',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53942,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53942,33.18,0.45,43.2,15721,NULL,NULL,'K','UGC 04375',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53943,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53943,37.42,0.33,304,15722,70,NULL,NULL,'SDSS J082311.78+033222.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000134,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,125.799125,3.53947,0.113,NULL,62590662081,977979095,15280923,18.3),(53944,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53944,37.46,0.46,310,15723,70,NULL,NULL,'2MASX J08231216+1506141',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000174,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,125.8007917,15.10394,0.105,NULL,63772862983,996450984,15569546,17.1),(53945,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53945,37.41,0.46,304,15724,70,NULL,NULL,'2MASX J08231226+3040490',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000147,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,125.8010417,30.68031,0.109,NULL,64355876604,1005560571,15711883,17.5),(53946,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53946,38.03,0.21,404,15725,70,NULL,NULL,'2MASX J08231267+2014494',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000182,NULL,'16.6g',0.26,'BrClG',NULL,NULL,NULL,NULL,1,125.8027083,20.24697,0.141,NULL,63820077769,997188715,15581073,16.6),(53947,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53947,33.61,0.43,52.8,15726,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04381',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.000017,NULL,'14.77',0.3,'Sc: sp         HII',NULL,NULL,NULL,NULL,1,125.804833,-0.86481,0.149,NULL,39211103780,612673496,9573023,14.77),(53948,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53948,33.68,0.43,54.3,15726,75,NULL,'3.6 micron, color corrected','UGC 04381',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53949,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53949,33.77,0.2,56.8,15726,74.4,NULL,NULL,'UGC 04381',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53950,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53950,33.79,0.49,57.3,15726,75,NULL,'IR','UGC 04381',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53951,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53951,33.82,0.26,58,15726,NULL,NULL,NULL,'UGC 04381',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53952,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53952,33.91,0.25,60.5,15726,NULL,NULL,'Malmquist cor.','UGC 04381',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53953,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53953,34.01,0.47,63.4,15726,NULL,NULL,'H','UGC 04381',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53954,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53954,34.13,0.45,67.1,15726,NULL,NULL,'K','UGC 04381',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53955,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53955,34.21,0.46,69.3,15726,NULL,NULL,'J','UGC 04381',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53956,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53956,34.23,0.4,70.1,15726,NULL,NULL,'mean','UGC 04381',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53957,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53957,36.75,0.46,224,15727,70,NULL,NULL,'2MASX J08231407+1607092',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000157,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,125.808583,16.11936,0.109,NULL,63786111117,996657986,15572781,17.1),(53958,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53958,37.8,0.23,363,15728,70,NULL,NULL,'2MASX J08231431+0622508',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,125.809625,6.38075,0.045,NULL,62566872224,977607378,15275115,17.7),(53959,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53959,37.46,0.46,310,15729,70,NULL,NULL,'2MASX J08231516+0413426',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000067,NULL,'17.0g',0.32,NULL,NULL,NULL,NULL,NULL,1,125.81325,4.22856,0.033,NULL,62591067099,977985423,15281022,17),(53960,'IRAS','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53960,34.86,0.8,93.6,15730,75,NULL,'MAT, I','NGC 2584',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.00002,NULL,'14.5',0.6,'SB(s)bc?       HII','Group member',NULL,NULL,NULL,1,125.814375,-4.9705,0.145,NULL,39242662740,613166605,9580728,14.5),(53961,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53961,34.05,0.32,64.6,15730,85,NULL,'I, raw','NGC 2584',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53962,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53962,34.08,0.32,65.4,15730,85,NULL,'I, inv','NGC 2584',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53963,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53963,34.22,0.43,69.8,15730,75,NULL,'MAT, I, raw','NGC 2584',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53964,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53964,34.37,0.43,74.8,15730,75,NULL,'MAT, I, inv','NGC 2584',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53965,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53965,34.43,0.43,76.9,15730,75,NULL,'MAT, I, cor','NGC 2584',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53966,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53966,34.91,0.55,95.9,15730,NULL,NULL,'Malmquist cor.','NGC 2584',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53967,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53967,35.13,0.5,106,15730,NULL,NULL,NULL,'NGC 2584',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53968,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53968,35.17,0.2,108,15730,74.4,NULL,NULL,'NGC 2584',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(53969,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53969,38.17,0.46,430,15731,70,NULL,NULL,'2MASX J08231684+0558267',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000163,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,125.820083,5.97417,0.041,NULL,62596388401,978068568,15282321,17.4),(53970,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53970,37.53,0.27,321,15732,70,NULL,NULL,'2MASX J08231864+0829098',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000191,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,125.827625,8.48611,0.053,NULL,62568707657,977636057,15275563,17.2),(53971,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53971,38.11,0.46,418,15733,70,NULL,NULL,'2MASX J08231976+3810380',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000179,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,125.8325417,38.17733,0.145,NULL,64361093668,1005642088,15713157,18.3),(53972,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53972,37.49,0.46,314,15734,70,NULL,NULL,'2MASX J08232274+5620261',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,125.844958333,56.34061,0.153,NULL,61552376780,961755887,15027435,17.5),(53973,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53973,38.32,0.27,461,15735,70,NULL,NULL,'2MASX J08232360+2147274',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,125.848167,21.79106,0.141,NULL,63811093189,997048331,15578880,18.6),(53974,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53974,38.12,0.27,420,15736,70,NULL,NULL,'SDSS J082323.66+182656.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000162,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,125.848583,18.44903,0.125,NULL,63780699903,996573435,15571459,18.6),(53975,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53975,37.46,0.46,311,15737,70,NULL,NULL,'2MASX J08232523+1825224',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000165,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,125.855125,18.42283,0.145,NULL,63780695073,996573360,15571458,17.1),(53976,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53976,38.12,0.27,420,15738,70,NULL,NULL,'2MASX J08232531+1827334',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,125.8554583,18.45931,0.125,NULL,63780700004,996573437,15571459,17.7),(53977,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53977,37.47,0.46,312,15739,70,NULL,NULL,'2MASX J08232535+3515460',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00019,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,125.855625,35.26278,0.189,NULL,64338376741,1005287136,15707611,16.9),(53978,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53978,37.33,0.33,292,15740,70,NULL,NULL,'2MASX J08232548+5410391',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,125.856291667,54.17761,0.113,NULL,63491588856,992056075,15500876,17.3),(53979,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53979,37.82,0.46,366,15741,70,NULL,NULL,'SDSS J082327.32+063845.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000143,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,125.863875,6.64597,0.045,NULL,62566820572,977606571,15275102,18.6),(53980,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53980,37.91,0.46,381,15742,70,NULL,NULL,'SDSS J082328.56+401020.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000144,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,125.8690417,40.17233,0.165,NULL,64240439806,1003756871,15683701,18.6),(53981,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53981,37.96,0.33,391,15743,70,NULL,NULL,'SDSS J082328.97+104402.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.5g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,125.870708333,10.73392,0.061,NULL,62780870433,980951100,15327360,18.5),(53982,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53982,38.68,0.46,544,15744,70,NULL,NULL,'2MASX J08232915+2453563',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000172,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,125.8715417,24.89906,0.033,NULL,63791185100,996737267,15574019,18),(53983,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53983,39.39,0.46,755,15745,70,NULL,NULL,'SDSS J082329.60+032659.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000121,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,125.873333,3.44994,0.113,NULL,62590173541,977971461,15280804,18.5),(53984,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53984,34.49,0.46,79.2,15746,70,NULL,NULL,'IC 2340',NULL,'2015arXiv151105856S',2015,1,1.02,NULL,'G',0.000153,NULL,'14.2g',0.77,NULL,NULL,NULL,NULL,NULL,1,125.8752083,18.74944,0.141,NULL,63817438175,997147471,15580429,14.2),(53985,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53985,35.42,0.27,121,15747,70,NULL,NULL,'IC 0506',NULL,'2015arXiv151105856S',2015,1,0.95,NULL,'G',0.000057,NULL,'14.5g',0.68,'E0','Group member',NULL,NULL,NULL,1,125.8780417,4.2995,0.033,NULL,62591032359,977984880,15281013,14.5),(53986,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53986,38.12,0.27,420,15748,70,NULL,NULL,'2MASX J08233128+1826534',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000195,NULL,'16.9g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,125.880375,18.44817,0.125,NULL,63780698086,996573407,15571459,16.9),(53987,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53987,37.67,0.46,342,15749,70,NULL,NULL,'2MASX J08233225+1951294',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,125.884375,19.85825,0.137,NULL,63818233014,997159890,15580623,17.5),(53988,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53988,38.15,0.14,427,15750,70,NULL,NULL,'SDSS J082332.66+190123.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000177,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,125.886083,19.02306,0.157,NULL,63817609362,997150146,15580471,18.4),(53989,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53989,36.41,0.46,191,15751,70,NULL,NULL,'2MASX J08233285+4946561',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000084,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,125.886917,49.78233,0.133,NULL,63541440751,992835011,15513047,16.7),(53990,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53990,37.42,0.46,305,15752,70,NULL,NULL,'2MASX J08233288+2529292',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.2g',0.1,NULL,NULL,NULL,NULL,NULL,1,125.887083,25.49144,0.069,NULL,64349242750,1005456917,15710264,18.2),(53991,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53991,37.53,0.27,321,15753,70,NULL,NULL,'2MASX J08233356+0833011',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,125.889708333,8.55025,0.053,NULL,62568712857,977636138,15275564,16.4),(53992,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53992,34.25,0.09,70.9,15754,NULL,NULL,NULL,'IC 2399',NULL,'2009ApJS..182..474S',2009,1,0.6,'IC identification is not certain.','G',0.000162,NULL,'15.7g',0.51,NULL,'Group member',NULL,NULL,NULL,1,131.957208333,18.91189,0.049,NULL,63825138770,997267793,15582309,15.7),(53993,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53993,37.42,0.33,304,15755,70,NULL,NULL,'2MASX J08233553+0332077',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,125.898125,3.53547,0.113,NULL,62590182677,977971604,15280806,17.6),(53994,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53994,39.67,0.46,859,15756,70,NULL,NULL,'SDSS J082336.31+413916.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000146,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,125.901333,41.65456,0.177,NULL,64243560731,1003805636,15684463,18.7),(53995,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53995,38.97,0.46,621,15757,70,NULL,NULL,'2MASX J08233685+1104161',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,125.903625,11.07128,0.081,NULL,62781098785,980954668,15327416,17.7),(53996,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53996,36.32,0.46,184,15758,70,NULL,NULL,'SDSS J082337.15+275636.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,125.9047917,27.94344,0.065,NULL,64350398223,1005474972,15710546,17.6),(53997,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53997,35.42,0.27,121,15759,70,NULL,NULL,'2MASX J08233787+0415337',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00004,NULL,'15.8g',0.41,'E0',NULL,NULL,NULL,NULL,1,125.907875,4.2595,0.033,NULL,62591040158,977985002,15281015,15.8),(53998,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',53998,36.58,0.46,207,15760,70,NULL,NULL,'2MASX J08233895+5557460',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000193,NULL,'16.0g',0.38,NULL,NULL,NULL,NULL,NULL,1,125.9124583,55.96292,0.153,NULL,61551832669,961747385,15027302,16),(53999,'IRAS','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,53999,32.66,0.8,34.1,15761,75,NULL,'MAT, I','ESO 124- G 015',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000021,NULL,'14.30',0.9,'SB(s)bc',NULL,NULL,NULL,NULL,1,125.917458333,-60.87656,0.841,NULL,40562202821,633784419,9902881,14.3),(54000,'Tully est','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54000,32.51,0.8,31.8,15761,75,NULL,NULL,'ESO 124- G 015',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54001,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54001,32.34,0.32,29.4,15761,85,NULL,'I, raw','ESO 124- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54002,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54002,32.34,0.32,29.4,15761,85,NULL,'I, inv','ESO 124- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54003,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54003,32.6,0.43,33.1,15761,75,NULL,'MAT, I, raw','ESO 124- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54004,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54004,32.67,0.43,34.2,15761,75,NULL,'MAT, I, inv','ESO 124- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54005,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54005,32.84,0.4,36.9,15761,73,NULL,'opt','ESO 124- G 015',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54006,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54006,32.88,0.43,37.6,15761,75,NULL,'MAT, I, cor','ESO 124- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54007,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54007,32.91,0.47,38.1,15761,NULL,NULL,NULL,'ESO 124- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54008,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54008,32.93,0.47,38.5,15761,NULL,NULL,'Malmquist cor.','ESO 124- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54009,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54009,32.95,0.2,38.9,15761,74.4,NULL,NULL,'ESO 124- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54010,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54010,37.53,0.27,321,15762,70,NULL,NULL,'2MASX J08234057+0832551',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,125.9192083,8.5485,0.053,NULL,62568724464,977636319,15275567,17.2),(54011,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54011,34.42,0.21,76.4,15763,70,NULL,NULL,'IC 2341',NULL,'2015arXiv151105856S',2015,1,1.29,NULL,'G',0.000167,NULL,'14.1g',0.63,'S0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,125.922666667,21.43489,0.133,NULL,63819794267,997184285,15581004,14.1),(54012,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54012,34.33,0.45,73.5,15763,NULL,NULL,'K','IC 2341',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54013,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54013,34.36,0.4,74.5,15763,NULL,NULL,'mean','IC 2341',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54014,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54014,37.64,0.21,337,15764,70,NULL,NULL,'2MASX J08234244+2103409',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000202,NULL,'16.2g',0.39,'BrClG',NULL,NULL,NULL,NULL,1,125.926917,21.0615,0.145,NULL,63819955056,997186797,15581043,16.2),(54015,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54015,38.22,0.23,441,15765,70,NULL,NULL,'SDSS J082342.66+154026.8',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000201,NULL,'17.3g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,125.927791667,15.67414,0.105,NULL,63785974539,996655852,15572747,17.3),(54016,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54016,38.09,0.46,415,15766,70,NULL,NULL,'SDSS J082343.22+073310.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000164,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,125.930125,7.55286,0.025,NULL,62569985700,977656026,15275875,18.4),(54017,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54017,38.27,0.46,451,15767,70,NULL,NULL,'2MASX J08234330+3948240',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000164,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,125.930333,39.80667,0.165,NULL,64357947834,1005592934,15712389,17.6),(54018,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54018,37.64,0.21,337,15768,70,NULL,NULL,'2MASX J08234337+2102569',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,125.930625,21.04922,0.145,NULL,63819940941,997186577,15581040,18.2),(54019,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54019,37.53,0.46,321,15769,70,NULL,NULL,'2MASX J08234438+3815340',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000122,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,125.934917,38.25953,0.145,NULL,64361310874,1005645482,15713210,18.1),(54020,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54020,35.7,0.6,138,15770,70,NULL,NULL,'2MASX J08234506-0050092',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.21',0.4,NULL,NULL,NULL,NULL,NULL,1,125.9375417,-0.836,0.125,NULL,39211054147,612672721,9573011,16.21),(54021,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54021,37.9,0.27,380,15771,70,NULL,NULL,'2MASX J08234588+1841289',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000145,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,125.94125,18.69125,0.141,NULL,63817395201,997146800,15580418,18.5),(54022,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54022,37.64,0.21,337,15772,70,NULL,NULL,'SDSS J082346.34+210210.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000145,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,125.943083,21.03631,0.145,NULL,63819941041,997186578,15581040,18.7),(54023,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54023,36.81,0.46,230,15773,70,NULL,NULL,'2MASXi J0823465+352751',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000172,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,125.94375,35.46414,0.189,NULL,64338381626,1005287212,15707612,16.5),(54024,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54024,38,0.46,397,15774,70,NULL,NULL,'2MASX J08234669+2335219',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000181,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,125.9445,23.58931,0.105,NULL,63808758705,997011854,15578310,17),(54025,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54025,37.96,0.33,391,15775,70,NULL,NULL,'2MASX J08234690+1053221',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,125.945333,10.88958,0.077,NULL,62562538339,977539661,15274057,16.2),(54026,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54026,38.42,0.46,483,15776,70,NULL,NULL,'2MASX J08234719+2722523',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000152,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,125.9467083,27.38111,0.069,NULL,64352769426,1005512022,15711125,18.6),(54027,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54027,38.04,0.46,406,15777,70,NULL,NULL,'2MASX J08234746+5021559',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000075,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,125.947875,50.36556,0.145,NULL,63495487622,992116994,15501828,18.1),(54028,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54028,37.64,0.21,337,15778,70,NULL,NULL,'2MASX J08234787+2102009',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000173,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,125.949417,21.03364,0.145,NULL,63819941016,997186578,15581040,16.7),(54029,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1997N',NULL,54029,39.49,0.45,670,15779,74.2,NULL,'SALT 2','H-ZSNS J082350.03+032852.8',0.18,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'Irr; poss. merger',NULL,NULL,NULL,NULL,1,125.9584583,3.48133,0.113,NULL,62590180486,977971570,15280805,NULL),(54030,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1997N',NULL,54030,39.76,0.05,759,15779,70,NULL,'SALT','H-ZSNS J082350.03+032852.8',0.18,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54031,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1997N',NULL,54031,39.98,0.18,840,15779,65,NULL,NULL,'H-ZSNS J082350.03+032852.8',0.18,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54032,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54032,35.45,0.46,123,15780,70,NULL,NULL,'CGCG 060-005',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.00011,NULL,'15.2',0.9,'S0','Pair member (points to parent)',NULL,NULL,NULL,1,125.958875,11.55036,0.085,NULL,62781200505,980956257,15327441,15.2),(54033,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54033,36.97,0.46,248,15781,70,NULL,NULL,'SDSS J082350.75+420759.4',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000185,NULL,'16.2g',0.31,'S0^-',NULL,NULL,NULL,NULL,1,125.9615,42.13319,0.149,NULL,64242891676,1003795182,15684299,16.2),(54034,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54034,37.53,0.33,320,15782,70,NULL,NULL,'2MASX J08235088+1804339',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00018,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,125.9619583,18.07606,0.149,NULL,63783028455,996609819,15572028,16.9),(54035,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54035,37.35,0.46,295,15783,70,NULL,NULL,'2MASX J08235087+4825325',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000066,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,125.9622083,48.42567,0.141,NULL,63543686197,992870096,15513595,17.9),(54036,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54036,37.64,0.21,337,15784,70,NULL,NULL,'SDSS J082350.95+210214.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000136,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,125.9622917,21.03728,0.145,NULL,63819909363,997186083,15581032,18.3),(54037,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54037,38.27,0.46,451,15785,70,NULL,NULL,'2MASX J08235116+1843119',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,125.963333,18.72008,0.141,NULL,63817396297,997146817,15580419,18.2),(54038,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54038,34.1,0.2,66.1,15786,74.4,NULL,NULL,'2MASX J08235222+2125079',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000011,NULL,'16.3g',0.23,'Sc',NULL,NULL,NULL,NULL,1,125.9677083,21.41867,0.133,NULL,63819786859,997184169,15581002,16.3),(54039,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54039,34.17,0.43,68.2,15786,75,NULL,'3.6 micron, color corrected','2MASX J08235222+2125079',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54040,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54040,34.23,0.43,70.1,15786,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J08235222+2125079',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54041,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54041,34.26,0.11,71.3,15786,NULL,NULL,NULL,'2MASX J08235222+2125079',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54042,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1997af','R',54042,42.08,NULL,1650,15787,65,NULL,'SALT','SCP J082352.67+040844.0',0.579,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,'Irr',NULL,NULL,NULL,NULL,1,125.969458333,4.14556,0.045,NULL,62590962044,977983781,15280996,NULL),(54043,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1997af',NULL,54043,42.48,0.65,1980,15787,74.2,NULL,'SALT 2','SCP J082352.67+040844.0',0.579,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54044,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1997af',NULL,54044,42.86,0.19,2360,15787,65,NULL,NULL,'SCP J082352.67+040844.0',0.579,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54045,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1997af',NULL,54045,43.11,0.56,2650,15787,70,NULL,'SALT','SCP J082352.67+040844.0',0.579,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54046,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1997af',NULL,54046,43.33,0.53,2930,15787,65,NULL,'SALT','SCP J082352.67+040844.0',0.579,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54047,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54047,38.12,0.46,422,15788,70,NULL,NULL,'2MASX J08235397+1624339',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000177,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,125.974916667,16.40953,0.109,NULL,63786965494,996671335,15572989,18.1),(54048,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54048,37.81,0.46,366,15789,70,NULL,NULL,'SDSS J082354.16+132003.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,125.975667,13.33433,0.093,NULL,63771217094,996425267,15569144,17.9),(54049,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54049,37.9,0.27,380,15790,70,NULL,NULL,'2MASX J08235433+1842309',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000175,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,125.9765417,18.70856,0.141,NULL,63817397241,997146831,15580419,17.5),(54050,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54050,35.86,0.56,148,15791,70,NULL,NULL,'2MASX J08235445-0208072',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.11',0.4,NULL,NULL,NULL,NULL,NULL,1,125.976833333,-2.13556,0.089,NULL,39225093344,612892083,9576438,16.11),(54051,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54051,38.22,0.23,441,15792,70,NULL,NULL,'2MASX J08235445+1535099',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,125.977,15.58608,0.105,NULL,63785980540,996655945,15572749,17.2),(54052,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54052,37.2,0.46,276,15793,70,NULL,NULL,'2MASX J08235504+4755134',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00009,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,125.9792917,47.92053,0.129,NULL,63543036269,992859941,15513436,17.2),(54053,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54053,36.39,0.59,190,15794,70,NULL,NULL,'2MASX J08235598-0202222',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,125.9832917,-2.03961,0.109,NULL,39225125677,612892588,9576446,15.8),(54054,'Brightest Stars','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54054,27.35,NULL,3,15795,NULL,NULL,'3B','MESSIER 081 DWARF A',NULL,'1993A&A...275...39T',1993,1,1.3,NULL,'G',0.000001,NULL,'16.5:',0.7,'I?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,125.979583,71.03222,0.085,0,62185869299,971654207,15182096,16.5),(54055,'TRGB','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54055,27.66,0.06,3.4,15795,NULL,NULL,'I','MESSIER 081 DWARF A',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54056,'TRGB','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54056,27.67,0.08,3.43,15795,74.4,NULL,NULL,'MESSIER 081 DWARF A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54057,'TRGB','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54057,27.68,0.05,3.44,15795,NULL,NULL,'I','MESSIER 081 DWARF A',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54058,'TRGB','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54058,27.75,0.16,3.55,15795,NULL,NULL,'I','MESSIER 081 DWARF A',NULL,'2002A&A...383..125K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54059,'Tully est','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54059,28.17,0.8,4.3,15795,75,NULL,NULL,'MESSIER 081 DWARF A',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54060,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54060,37.99,0.33,396,15796,70,NULL,NULL,'SDSS J082356.72+503236.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000073,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,125.986375,50.54356,0.145,NULL,63495493516,992117086,15501829,17.7),(54061,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54061,37.79,0.46,362,15797,70,NULL,NULL,'2MASX J08235707+2038399',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,125.987875,20.64456,0.133,NULL,63820476439,997194944,15581171,17.6),(54062,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54062,38.03,0.21,404,15798,70,NULL,NULL,'2MASX J08235727+2018359',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,125.9885417,20.30994,0.141,NULL,63820341169,997192830,15581137,17.9),(54063,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54063,38.22,0.23,441,15799,70,NULL,NULL,'2MASX J08235736+1537039',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000189,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,125.988917,15.61775,0.105,NULL,63785965084,996655704,15572745,17.2),(54064,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54064,37.4,0.46,302,15800,70,NULL,NULL,'2MASX J08235845+3138175',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000139,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,125.9935417,31.63819,0.097,NULL,64342621488,1005353460,15708647,17.4),(54065,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54065,38.24,0.46,445,15801,70,NULL,NULL,'2MASX J08240038+2348029',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,126.0015417,23.80072,0.105,NULL,63808966644,997015103,15578360,17.7),(54066,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54066,37.69,0.21,346,15802,70,NULL,NULL,'2MASX J08240105+0723227',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000185,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,126.004291667,7.38964,0.017,NULL,62570555151,977664924,15276014,17.5),(54067,'IRAS','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54067,34.04,0.8,64.3,15803,75,NULL,'W91CL, r','UGC 04386',NULL,'1997ApJS..109..333W',1997,1,2.15,'Multiple SDSS entries describe this object.','G',0.000008,NULL,'14.0g',0.56,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,126.0065,21.02731,0.145,NULL,63819920761,997186261,15581035,14),(54068,'IRAS','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54068,34.04,0.8,64.4,15803,75,NULL,'HMCL, I','UGC 04386',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54069,'IRAS','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54069,34.04,0.8,64.4,15803,75,NULL,'CF, r','UGC 04386',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54070,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54070,33.67,0.4,54.1,15803,75,NULL,'HMCL, I, raw','UGC 04386',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54071,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54071,33.89,0.4,59.9,15803,75,NULL,'HMCL, I, inv','UGC 04386',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54072,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54072,33.92,0.47,60.8,15803,NULL,NULL,'H','UGC 04386',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54073,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54073,33.95,0.45,61.6,15803,NULL,NULL,'K','UGC 04386',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54074,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54074,33.95,0.46,61.7,15803,NULL,NULL,'J','UGC 04386',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54075,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54075,33.98,0.38,62.6,15803,75,NULL,'W91CL, r, raw','UGC 04386',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54076,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54076,34.07,0.4,65,15803,75,NULL,'HMCL, I, cor','UGC 04386',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54077,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54077,34.07,0.2,65.2,15803,74.4,NULL,NULL,'UGC 04386',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54078,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54078,34.11,0.49,66.3,15803,75,NULL,'IR','UGC 04386',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54079,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54079,34.12,0.43,66.7,15803,75,NULL,'3.6 micron, color corrected','UGC 04386',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54080,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54080,34.17,0.38,68.3,15803,75,NULL,'W91CL, r, inv','UGC 04386',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54081,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54081,34.19,0.38,69,15803,75,NULL,'CF, r, raw','UGC 04386',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54082,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54082,34.24,0.4,70.6,15803,NULL,NULL,'mean','UGC 04386',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54083,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54083,34.26,0.38,71,15803,75,NULL,'W91CL, r, cor','UGC 04386',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54084,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54084,34.31,0.43,72.9,15803,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04386',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54085,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54085,34.39,0.38,75.4,15803,75,NULL,'CF, r, inv','UGC 04386',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54086,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54086,34.39,0.38,75.6,15803,75,NULL,'CF, r, cor','UGC 04386',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54087,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54087,34.4,0.15,76,15803,NULL,NULL,NULL,'UGC 04386',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54088,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1997O','R',54088,42.15,NULL,1970,15804,65,NULL,'SALT','H-ZSNS J082402.51+040733.1',0.37,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,126.0104583,4.12586,0.045,NULL,62589865817,977966653,15280728,NULL),(54089,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1997O',NULL,54089,42.48,0.94,2290,15804,74.2,NULL,'SALT 2','H-ZSNS J082402.51+040733.1',0.37,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54090,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1997O',NULL,54090,43.12,0.69,3070,15804,70,NULL,'SALT','H-ZSNS J082402.51+040733.1',0.37,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54091,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1997O',NULL,54091,43.33,0.86,3380,15804,65,NULL,'SALT','H-ZSNS J082402.51+040733.1',0.37,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54092,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54092,38.15,0.14,427,15805,70,NULL,NULL,'2MASX J08240410+1931598',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000157,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,126.01725,19.53342,0.141,NULL,63818374899,997162107,15580657,17.3),(54093,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54093,38.15,0.14,427,15806,70,NULL,NULL,'SDSS J082404.29+192544.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000144,NULL,'18.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,126.017917,19.42897,0.173,NULL,63818336500,997161507,15580648,18.8),(54094,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54094,38.22,0.23,441,15807,70,NULL,NULL,'2MASX J08240491+1532439',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,126.0204583,15.54556,0.105,NULL,63785938410,996655287,15572738,17.9),(54095,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1997ac','R',54095,40.43,NULL,925,15808,65,NULL,'SALT','SCP J082405.21+041122.6',0.32,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,'E/comp',NULL,NULL,NULL,NULL,1,126.0217083,4.18961,0.045,NULL,62589993828,977968653,15280760,NULL),(54096,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1997ac',NULL,54096,40.53,0.43,967,15808,74.2,NULL,'SALT 2','SCP J082405.21+041122.6',0.32,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54097,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1997ac',NULL,54097,41.19,0.34,1310,15808,70,NULL,'SALT','SCP J082405.21+041122.6',0.32,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54098,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1997ac',NULL,54098,41.34,0.33,1400,15808,65,NULL,'SALT','SCP J082405.21+041122.6',0.32,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54099,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1997ac',NULL,54099,41.45,0.18,1480,15808,65,NULL,NULL,'SCP J082405.21+041122.6',0.32,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54100,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54100,37.48,0.46,313,15809,70,NULL,NULL,'SDSS J082406.08+280133.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,126.025333,28.02592,0.065,NULL,64350448117,1005475751,15710558,18.5),(54101,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54101,38.15,0.14,427,15810,70,NULL,NULL,'2MASX J08240643+1923328',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,126.02675,19.39242,0.173,NULL,63818338184,997161534,15580648,18.6),(54102,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54102,37.71,0.46,348,15811,70,NULL,NULL,'2MASX J08240788+1051437',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,126.032833,10.86225,0.077,NULL,62562551004,977539859,15274060,17.3),(54103,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54103,37.89,0.46,378,15812,70,NULL,NULL,'2MASX J08240888+1640468',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,126.037125,16.67964,0.141,NULL,63786777730,996668402,15572943,18),(54104,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54104,34.76,0.51,89.7,15813,70,NULL,NULL,'2MASX J08240900-0346172',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000083,NULL,'15.53',0.7,NULL,NULL,NULL,NULL,NULL,1,126.0375417,-3.77158,0.153,NULL,39214397707,612724964,9573827,15.53),(54105,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1997as',NULL,54105,41.64,0.35,1410,15814,65,NULL,NULL,'H-ZSNS J082409.46-004808.2',0.51,'2004ApJ...607..665R',2004,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,126.039417,-0.80228,0.125,NULL,39222906463,612857913,9575904,NULL),(54106,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54106,38.15,0.14,427,15815,70,NULL,NULL,'2MASX J08240961+1924438',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00019,NULL,'16.8g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,126.040083333,19.41222,0.173,NULL,63818336880,997161513,15580648,16.8),(54107,'Sosies','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54107,31.99,0.33,25,15816,NULL,NULL,NULL,'IC 2367',NULL,'2002A&A...393...57T',2002,1,2.4,NULL,'G',0.00001,NULL,'13.5',1.7,'SB(r)b',NULL,NULL,NULL,NULL,1,126.042,-18.77556,0.233,NULL,42276544363,660571005,10321421,13.5),(54108,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54108,32,0.69,25.1,15816,100,NULL,'mid-IR','IC 2367',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54109,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54109,32.02,0.47,25.3,15816,NULL,NULL,'H','IC 2367',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54110,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54110,32.06,0.46,25.8,15816,NULL,NULL,'J','IC 2367',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54111,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54111,32.08,0.45,26,15816,NULL,NULL,'K','IC 2367',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54112,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54112,32.65,0.4,33.9,15816,NULL,NULL,'mean','IC 2367',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54113,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54113,36.56,0.56,205,15817,70,NULL,NULL,'2MASX J08241013-0209412',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.9I',0.5,NULL,NULL,NULL,NULL,NULL,1,126.042208333,-2.16142,0.089,NULL,39225089022,612892015,9576437,13.9),(54114,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54114,36.08,0.53,164,15818,70,NULL,NULL,'2MASX J08241033-0322592',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.14',NULL,NULL,NULL,NULL,NULL,NULL,1,126.042833,-3.38331,0.137,NULL,39214112479,612720507,9573757,16.14),(54115,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54115,37.4,0.46,301,15819,70,NULL,NULL,'SDSS J082410.52+541745.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,126.043875,54.29589,0.113,NULL,63491752982,992058640,15500916,18.3),(54116,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54116,38.13,0.46,422,15820,70,NULL,NULL,'2MASX J08241065+0101275',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,126.044333333,1.02447,0.097,NULL,62594311810,978036122,15281814,17.2),(54117,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54117,37.94,0.46,388,15821,70,NULL,NULL,'2MASX J08241079+5419300',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,126.044833,54.32489,0.113,NULL,63491574154,992055846,15500872,17.5),(54118,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54118,39.01,0.46,635,15822,70,NULL,NULL,'2MASX J08241076+2023064',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000167,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,126.044917,20.38511,0.141,NULL,63820358516,997193101,15581142,18.3),(54119,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54119,34.95,0.2,97.7,15823,74.4,NULL,NULL,'CGCG 060-009',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000137,NULL,'15.5',0.3,NULL,NULL,NULL,NULL,NULL,1,126.048333,12.11575,0.093,NULL,62780402719,980943792,15327246,15.5),(54120,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54120,37.29,0.46,287,15824,70,NULL,NULL,'2MASX J08241259+2325414',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000141,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,126.0525,23.42822,0.125,NULL,63808661808,997010340,15578286,17.3),(54121,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1996cg',NULL,54121,41.06,0.45,1090,15825,74.2,NULL,'SALT 2','H-ZSNS J082413.33+032458.5',0.49,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,'Sab',NULL,NULL,NULL,NULL,1,126.0555417,3.41625,0.113,NULL,62590227082,977972298,15280817,NULL),(54122,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1996cg','R',54122,41.58,NULL,1390,15825,65,NULL,'SALT','H-ZSNS J082413.33+032458.5',0.49,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54123,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1996cg',NULL,54123,41.82,0.36,1550,15825,70,NULL,'SALT','H-ZSNS J082413.33+032458.5',0.49,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54124,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1996cg',NULL,54124,41.91,0.35,1620,15825,65,NULL,'SALT','H-ZSNS J082413.33+032458.5',0.49,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54125,'SNIa','2016-12-15 15:14:21','2016-12-16 11:19:27','1','SN 1996cg',NULL,54125,42.58,0.19,2200,15825,65,NULL,NULL,'H-ZSNS J082413.33+032458.5',0.49,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54126,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54126,37.7,0.21,347,15826,70,NULL,NULL,'2MASX J08241360+1450318',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000169,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,126.056875,14.84222,0.113,NULL,63773596484,996462445,15569725,16.9),(54127,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54127,38.15,0.14,427,15827,70,NULL,NULL,'2MASX J08241463+1926404',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000183,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,126.0610417,19.44458,0.173,NULL,63818348152,997161689,15580651,17.8),(54128,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54128,34.2,NULL,69.2,15828,NULL,NULL,'Dipole + Quadrupole','KUG 0821+344A',NULL,'2010Ap&SS.325..163P',2010,1,1.05,NULL,'G',0.000018,NULL,'17.0g',0.15,'Sd',NULL,NULL,NULL,NULL,1,126.0615,34.32767,0.173,NULL,64335392264,1005240504,15706882,17),(54129,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54129,34.2,NULL,69.3,15828,NULL,NULL,'Dipole + Quadrupole + Octopole','KUG 0821+344A',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54130,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54130,34.22,NULL,69.9,15828,NULL,NULL,NULL,'KUG 0821+344A',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54131,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54131,34.22,NULL,69.9,15828,NULL,NULL,'Dipole','KUG 0821+344A',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54132,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54132,34.56,0.2,81.7,15828,74.4,NULL,NULL,'KUG 0821+344A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54133,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54133,34.66,0.64,85.4,15828,NULL,NULL,NULL,'KUG 0821+344A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54134,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54134,34.67,0.64,85.9,15828,NULL,NULL,'Malmquist cor.','KUG 0821+344A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54135,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54135,38.02,0.46,402,15829,70,NULL,NULL,'2MASX J08241502+0402456',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000169,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,126.062667,4.046,0.045,NULL,62589873183,977966768,15280730,17.1),(54136,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54136,33.92,0.43,60.8,15830,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-22-009',NULL,'2014MNRAS.444..527S',2014,1,1.06,NULL,'G',0.00003,NULL,'15.5',0.1,'Sdm',NULL,NULL,NULL,NULL,1,126.067917,-14.50194,0.285,NULL,42249045878,660141341,10314708,15.5),(54137,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54137,36.12,0.68,168,15831,70,NULL,NULL,'2MASX J08241868-5742418',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,126.0777917,-57.71158,1.185,NULL,40410312008,631411125,9865798,17.8),(54138,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54138,38.27,0.33,451,15832,70,NULL,NULL,'SDSS J082419.17+194254.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000152,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,126.079917,19.71506,0.165,NULL,63818398504,997162476,15580663,18.7),(54139,'IRAS','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54139,34.62,0.8,84.1,15833,75,NULL,'W91CL, r','IC 2348',NULL,'1997ApJS..109..333W',1997,1,0.76,NULL,'G',0.00001,NULL,'15.4g',0.38,'Sa             AGN','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,126.084375,20.53325,0.141,NULL,63820351379,997192990,15581140,15.4),(54140,'IRAS','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54140,34.62,0.8,84.1,15833,75,NULL,'HMCL, I','IC 2348',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54141,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54141,34.89,0.12,95.3,15833,NULL,NULL,NULL,'IC 2348',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54142,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54142,35.15,0.43,107,15833,75,NULL,'3.6 micron, color corrected','IC 2348',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54143,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54143,35.16,0.2,108,15833,74.4,NULL,NULL,'IC 2348',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54144,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54144,35.23,0.43,111,15833,75,NULL,'3.6 micron, color + selection bias corrected','IC 2348',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54145,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54145,35.26,0.4,113,15833,75,NULL,'HMCL, I, raw','IC 2348',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54146,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54146,35.37,0.38,119,15833,75,NULL,'W91CL, r, raw','IC 2348',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54147,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54147,35.43,0.4,122,15833,75,NULL,'HMCL, I, inv','IC 2348',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54148,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54148,35.49,0.4,125,15833,75,NULL,'HMCL, I, cor','IC 2348',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54149,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54149,35.49,0.38,125,15833,75,NULL,'W91CL, r, inv','IC 2348',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54150,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54150,35.58,0.38,131,15833,75,NULL,'W91CL, r, cor','IC 2348',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54151,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54151,36.37,0.46,188,15834,70,NULL,NULL,'2MASX J08242043+4733201',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000076,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,126.0852083,47.55567,0.133,NULL,63540071557,992813618,15512712,17),(54152,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54152,38.19,0.46,434,15835,70,NULL,NULL,'SDSS J082420.96+500141.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000066,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,126.087375,50.02822,0.141,NULL,63540696272,992823379,15512865,18.2),(54153,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54153,37.69,0.21,346,15836,70,NULL,NULL,'2MASX J08242169+0729147',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000192,NULL,'16.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,126.0905,7.4875,0.025,NULL,62570504450,977664132,15276002,16.4),(54154,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54154,38.08,0.21,414,15837,70,NULL,NULL,'2MASX J08242323+0423567',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000083,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,126.096916667,4.39903,0.033,NULL,62589769584,977965149,15280705,17.9),(54155,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54155,38.06,0.46,409,15838,70,NULL,NULL,'2MASX J08242398+0339587',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000137,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,126.099875,3.66631,0.061,NULL,62590348534,977974195,15280846,17.6),(54156,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54156,37.69,0.21,346,15839,70,NULL,NULL,'2MASX J08242418+0722427',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,126.100625,7.37861,0.017,NULL,62570552214,977664878,15276013,17.9),(54157,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54157,36.35,0.46,187,15840,70,NULL,NULL,'2MASX J08242428+5357055',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000169,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,126.101166667,53.95158,0.101,NULL,63491645560,992056961,15500890,16.5),(54158,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54158,37.84,0.46,369,15841,70,NULL,NULL,'2MASX J08242475+5617276',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,126.103,56.29094,0.153,NULL,61552378058,961755907,15027436,17.6),(54159,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54159,36.33,0.74,185,15842,70,NULL,NULL,'2MASX J08242510-0204432',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.53',0.2,NULL,NULL,NULL,NULL,NULL,1,126.1045,-2.07875,0.089,NULL,39225106602,612892290,9576442,16.53),(54160,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54160,37.99,0.33,396,15843,70,NULL,NULL,'SDSS J082425.71+502913.9',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000075,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,126.107125,50.48722,0.145,NULL,63495710506,992120476,15501882,18.5),(54161,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54161,33.73,0.33,55.8,15844,70,NULL,NULL,'CGCG 032-019',NULL,'2015arXiv151105856S',2015,1,0.93,NULL,'G',0.000033,NULL,'14.6g',0.46,'Sa',NULL,NULL,NULL,NULL,1,126.107625,4.24769,0.045,NULL,62589785457,977965397,15280709,14.6),(54162,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54162,37.21,0.27,277,15845,70,NULL,NULL,'2MASX J08242694+4214471',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,126.1125,42.24622,0.149,NULL,64242885048,1003795078,15684298,17.3),(54163,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54163,37.69,0.21,346,15846,70,NULL,NULL,'SDSS J082427.97+072544.2',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,126.116541667,7.42897,0.017,NULL,62570549424,977664834,15276013,17.7),(54164,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54164,38.33,0.46,463,15847,70,NULL,NULL,'2MASX J08242900+3800591',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000175,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,126.120958333,38.01633,0.177,NULL,64359124127,1005611314,15712676,17.7),(54165,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54165,37.93,0.46,386,15848,70,NULL,NULL,'2MASX J08242962+3108078',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000117,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,126.123333,31.13564,0.097,NULL,64342152575,1005346133,15708533,18.5),(54166,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54166,37.9,0.27,380,15849,70,NULL,NULL,'2MASX J08243056+1848124',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000162,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,126.127417,18.80356,0.141,NULL,63817412255,997147066,15580422,16.9),(54167,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54167,37.9,0.46,380,15850,70,NULL,NULL,'2MASX J08243143+1911504',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000179,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,126.1309583,19.19725,0.173,NULL,63817499140,997148424,15580444,17.5),(54168,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54168,37.91,0.33,383,15851,70,NULL,NULL,'2MASX J08243193+1528278',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000179,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,126.133166667,15.47431,0.105,NULL,63785941156,996655330,15572739,17),(54169,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54169,35.88,0.61,150,15852,70,NULL,NULL,'2MASX J08243215-1346525',NULL,'2014MNRAS.445.2677S',2014,1,0.09,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,126.1339583,-13.78136,0.233,NULL,42245357712,660083714,10313808,15.1),(54170,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54170,38.24,0.33,445,15853,70,NULL,NULL,'SDSS J082432.25+035913.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000122,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,126.134417,3.98711,0.085,NULL,62589849715,977966401,15280725,18.6),(54171,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54171,37.21,0.27,277,15854,70,NULL,NULL,'2MASX J08243352+4215551',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000183,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,126.139708333,42.26528,0.149,NULL,64243060823,1003797825,15684341,16.7),(54172,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54172,32.01,0.43,25.2,15855,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2550',NULL,'2014MNRAS.444..527S',2014,1,1,NULL,'G',0.00001,NULL,'13.6',0.4,'Sb:',NULL,NULL,NULL,NULL,1,126.141083,74.01228,0.089,NULL,61291233345,957675521,14963680,13.6),(54173,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54173,32.17,0.43,27.1,15855,75,NULL,'3.6 micron, color corrected','NGC 2550',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54174,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54174,32.45,0.2,30.9,15855,74.4,NULL,NULL,'NGC 2550',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54175,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54175,32.78,0.61,35.9,15855,NULL,NULL,'Malmquist cor.','NGC 2550',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54176,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54176,32.87,0.58,37.5,15855,NULL,NULL,NULL,'NGC 2550',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54177,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54177,37.55,0.46,324,15856,70,NULL,NULL,'2MASX J08243440+0207477',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,126.143416667,2.12994,0.133,NULL,62595583831,978055997,15282124,17),(54178,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54178,38.14,0.46,424,15857,70,NULL,NULL,'SDSS J082434.63+174358.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,126.144333,17.73289,0.129,NULL,63783662715,996619729,15572183,18.5),(54179,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54179,38.97,0.46,622,15858,70,NULL,NULL,'SDSS J082434.79+133701.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,126.145,13.61697,0.101,NULL,63770997339,996421833,15569091,18.2),(54180,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54180,37.29,0.46,287,15859,70,NULL,NULL,'2MASX J08243493+2348044',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,126.1454583,23.80136,0.105,NULL,63808557037,997008703,15578260,17.7),(54181,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54181,36.94,0.46,244,15860,70,NULL,NULL,'2MASX J08243527+0843539',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,126.147083,8.73156,0.073,NULL,62577015474,977765866,15277591,17.1),(54182,'FP','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54182,38.2,0.46,436,15861,70,NULL,NULL,'2MASX J08243535+2015184',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,126.147375,20.25517,0.153,NULL,63819671766,997182371,15580974,17.7),(54183,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54183,33.63,0.43,53.2,15862,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0749',NULL,'2014MNRAS.444..527S',2014,1,0.95,NULL,'G',0.000012,NULL,'16.8g',0.14,'Sc',NULL,NULL,NULL,NULL,1,126.1505,22.01883,0.141,NULL,63810616987,997040890,15578763,16.8),(54184,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54184,33.68,0.43,54.6,15862,75,NULL,'3.6 micron, color corrected','FGC 0749',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54185,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54185,33.73,0.2,55.7,15862,74.4,NULL,NULL,'FGC 0749',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54186,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,'R',54186,33.86,0.49,59,15862,75,NULL,'IR','FGC 0749',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54187,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54187,34.46,NULL,77.8,15862,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0749',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54188,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54188,34.47,NULL,78.4,15862,NULL,NULL,'Dipole + Quadrupole','FGC 0749',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54189,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:27','1',NULL,NULL,54189,34.48,NULL,78.7,15862,NULL,NULL,'Dipole','FGC 0749',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54190,'Tully-Fisher','2016-12-15 15:14:21','2016-12-16 11:19:28','1',NULL,NULL,54190,34.49,NULL,79.1,15862,NULL,NULL,NULL,'FGC 0749',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54191,'FP','2016-12-15 15:14:21','2016-12-16 11:19:28','1',NULL,'R',54191,37.59,0.46,330,15863,70,NULL,NULL,'SDSS J082436.53+065430.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,126.15225,6.90847,0.017,NULL,62570381589,977662212,15275972,18.1),(54192,'FP','2016-12-15 15:14:21','2016-12-16 11:19:28','1',NULL,'R',54192,38.08,0.21,414,15864,70,NULL,NULL,'2MASX J08243694+0420467',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000093,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,126.1539583,4.34633,0.045,NULL,62589818165,977965908,15280717,17.5),(54193,'FP','2016-12-15 15:14:21','2016-12-16 11:19:28','1',NULL,NULL,54193,36.78,0.53,226,15865,70,NULL,NULL,'2MASX J08243769-1124162',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.83',0.5,NULL,NULL,NULL,NULL,NULL,1,126.156917,-11.40464,0.185,NULL,39225997738,612906214,9576659,16.83),(54194,'FP','2016-12-15 15:14:21','2016-12-16 11:19:28','1',NULL,'R',54194,37.59,0.33,330,15866,70,NULL,NULL,'2MASX J08243796+3715241',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000206,NULL,'15.9g',0.43,'E0',NULL,NULL,NULL,NULL,1,126.158125,37.25664,0.185,NULL,64359053510,1005610211,15712659,15.9),(54195,'FP','2016-12-15 15:14:21','2016-12-16 11:19:28','1',NULL,'R',54195,37.75,0.46,354,15867,70,NULL,NULL,'2MASX J08243920+3326588',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000139,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,126.163458333,33.44981,0.133,NULL,64335028218,1005234815,15706793,17.5),(54196,'FP','2016-12-15 15:14:21','2016-12-16 11:19:28','1',NULL,'R',54196,38.15,0.46,426,15868,70,NULL,NULL,'2MASX J08243935+3906211',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00018,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,126.164125,39.10603,0.137,NULL,64360879981,1005638749,15713105,17.7),(54197,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54197,37.22,0.21,278,15869,70,NULL,NULL,'B3 0821+412',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00019,NULL,'16.1g',0.36,'AGN',NULL,NULL,NULL,NULL,1,126.1672917,41.05156,0.161,NULL,64243916554,1003811196,15684549,16.1),(54198,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54198,38.49,0.46,499,15870,70,NULL,NULL,'2MASX J08244025+2014353',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,126.16775,20.24306,0.153,NULL,63819672573,997182383,15580974,17.9),(54199,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54199,36.47,0.54,197,15871,70,NULL,NULL,'2MASX J08244123-0256572',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.25',NULL,NULL,NULL,NULL,NULL,NULL,1,126.171791667,-2.94925,0.165,NULL,39221704878,612839138,9575611,16.25),(54200,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54200,37.7,0.21,347,15872,70,NULL,NULL,'SDSS J082441.42+145024.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000158,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,126.172583333,14.84006,0.113,NULL,63773599137,996462486,15569726,18.3),(54201,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54201,38.15,0.14,427,15873,70,NULL,NULL,'2MASX J08244232+1914082',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,126.1764583,19.23564,0.173,NULL,63817500862,997148450,15580444,17.4),(54202,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54202,36.82,0.63,231,15874,70,NULL,NULL,'2MASX J08244235-0255101',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,126.1765,-2.91944,0.165,NULL,39221705002,612839140,9575611,15.7),(54203,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 1996K','R',54203,41.23,NULL,1280,15875,65,NULL,'SALT','[GC96] J082443.49-002106.2',0.38,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,':',NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,126.1812083,-0.35172,0.141,NULL,39210673520,612666773,9572918,NULL),(54204,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 1996K',NULL,54204,41.36,0.33,1360,15875,74.2,NULL,'SALT 2','[GC96] J082443.49-002106.2',0.38,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54205,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 1996K',NULL,54205,41.63,0.2,1540,15875,65,NULL,'MLCS','[GC96] J082443.49-002106.2',0.38,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54206,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 1996K',NULL,54206,41.98,0.29,1800,15875,70,NULL,'SALT','[GC96] J082443.49-002106.2',0.38,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54207,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 1996K',NULL,54207,42.02,0.22,1840,15875,65,NULL,NULL,'[GC96] J082443.49-002106.2',0.38,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54208,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 1996K',NULL,54208,42.18,0.27,1980,15875,65,NULL,'SALT','[GC96] J082443.49-002106.2',0.38,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54209,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 1996K',NULL,54209,42.21,0.18,2010,15875,65,NULL,'Template','[GC96] J082443.49-002106.2',0.38,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54210,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54210,38.18,0.33,433,15876,70,NULL,NULL,'2MASX J08244354+2644251',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000138,NULL,'17.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,126.181667,26.74025,0.069,NULL,64349505576,1005461024,15710328,17.4),(54211,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54211,36.53,0.46,202,15877,70,NULL,NULL,'2MASX J08244369+0806149',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,126.182167,8.10414,0.065,NULL,62569171158,977643299,15275676,17.5),(54212,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54212,38.23,0.46,442,15878,70,NULL,NULL,'SDSS J082443.84+410457.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,126.182667,41.08256,0.153,NULL,64243913287,1003811145,15684549,18.5),(54213,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54213,37.7,0.21,347,15879,70,NULL,NULL,'2MASX J08244603+1451147',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000203,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,126.19175,14.85417,0.113,NULL,63773598903,996462482,15569726,16.4),(54214,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54214,38.15,0.14,427,15880,70,NULL,NULL,'2MASX J08244741+1902062',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,126.197666667,19.03497,0.157,NULL,63817485194,997148206,15580440,18),(54215,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54215,38.27,0.33,451,15881,70,NULL,NULL,'2MASX J08244775+1942172',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000196,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,126.199041667,19.70486,0.165,NULL,63818321456,997161272,15580644,17.2),(54216,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54216,37.69,0.21,346,15882,70,NULL,NULL,'2MASX J08244886+0732309',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,126.2035,7.542,0.057,NULL,62569699967,977651561,15275805,17.9),(54217,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54217,38.24,0.33,445,15883,70,NULL,NULL,'2MASX J08244889+0359401',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,126.2037083,3.99458,0.085,NULL,62589971368,977968302,15280754,17.6),(54218,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54218,36.45,0.54,195,15884,70,NULL,NULL,'2MASX J08244951-1351336',NULL,'2014MNRAS.445.2677S',2014,1,0.14,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,126.206333333,-13.85936,0.225,NULL,42248505159,660132893,10314576,14.6),(54219,'Tully est','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54219,32.66,0.8,34.1,15885,75,NULL,'B','NGC 2551',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000037,NULL,'13.1',1.1,'SA(s)0/a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,126.2095,73.41203,0.069,NULL,62178179292,971534051,15180219,13.1),(54220,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54220,37.23,0.46,280,15886,70,NULL,NULL,'2MASX J08245047+0733379',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000123,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,126.210333333,7.56061,0.057,NULL,62569700228,977651566,15275805,17.7),(54221,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54221,38.08,0.46,413,15887,70,NULL,NULL,'2MASX J08245057+1418207',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,126.210625,14.30578,0.117,NULL,63774382200,996474721,15569917,17.1),(54222,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54222,37.91,0.33,383,15888,70,NULL,NULL,'2MASX J08245171+1526436',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000131,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,126.2154583,15.44569,0.105,NULL,63785417858,996647154,15572611,18),(54223,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54223,38.1,0.46,416,15889,70,NULL,NULL,'2MASX J08245170+1835562',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,126.2155,18.59897,0.125,NULL,63805857322,996966520,15577601,18),(54224,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54224,37.8,0.46,363,15890,70,NULL,NULL,'2MASX J08245331+1801022',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,126.222083,18.01736,0.145,NULL,63782935209,996608362,15572005,17.6),(54225,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54225,37.74,0.33,354,15891,70,NULL,NULL,'2MASX J08245363+1724276',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,126.223375,17.40769,0.129,NULL,63783799985,996621874,15572216,17.3),(54226,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54226,37.7,0.21,347,15892,70,NULL,NULL,'2MASX J08245464+1445426',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,126.227625,14.76194,0.113,NULL,63773545303,996461645,15569713,17.8),(54227,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54227,38.18,0.33,433,15893,70,NULL,NULL,'2MASX J08245481+2643032',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,126.2285,26.7175,0.069,NULL,64349297577,1005457774,15710277,18.2),(54228,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54228,38.22,0.23,441,15894,70,NULL,NULL,'2MASX J08245564+1109353',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,126.231875,11.15975,0.081,NULL,62562671224,977541737,15274089,17.2),(54229,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54229,37.7,0.21,347,15895,70,NULL,NULL,'2MASX J08245701+1457016',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,126.2377083,14.95042,0.109,NULL,63773572026,996462062,15569719,16.9),(54230,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54230,36.84,0.46,234,15896,70,NULL,NULL,'2MASX J08245711+2943242',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000177,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,126.237917,29.72336,0.093,NULL,64354612586,1005540821,15711575,17.4),(54231,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54231,37.59,0.33,330,15897,70,NULL,NULL,'2MASX J08245821+3711460',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'18.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,126.242625,37.19606,0.185,NULL,64359316492,1005614320,15712723,18),(54232,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54232,37.95,0.46,389,15898,70,NULL,NULL,'2MASX J08245849+3149519',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000102,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,126.2434583,31.83114,0.109,NULL,64342704447,1005354756,15708668,18.3),(54233,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54233,37.49,0.46,314,15899,70,NULL,NULL,'2MASX J08245866+0329031',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00015,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,126.244375,3.48428,0.105,NULL,62590519820,977976872,15280888,16.9),(54234,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54234,35.27,0.52,113,15900,70,NULL,NULL,'2MASX J08245927-0437132',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.4,NULL,NULL,NULL,NULL,NULL,1,126.246917,-4.62028,0.089,NULL,39245370024,613208906,9581389,13.9),(54235,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54235,38.15,0.14,427,15901,70,NULL,NULL,'2MASX J08250053+1904321',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,126.2522083,19.07547,0.157,NULL,63817497698,997148401,15580443,17.6),(54236,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54236,36.12,0.2,167,15902,74.4,NULL,NULL,'CGCG 060-010',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.00014,NULL,'15.1',0.7,NULL,NULL,NULL,NULL,NULL,1,126.255541667,13.53711,0.101,NULL,63771040053,996422500,15569101,15.1),(54237,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54237,37.39,0.46,300,15903,70,NULL,NULL,'2MASX J08250164+2718071',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000166,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,126.256958333,27.30189,0.085,NULL,64352913156,1005514268,15711160,16.8),(54238,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54238,33.74,0.45,56,15904,NULL,NULL,'K','NGC 2590',NULL,'2007A&A...465...71T',2007,1,2.29,NULL,'G',0.000027,NULL,'13.7g',0.6,'SA(s)bc:       HII',NULL,NULL,NULL,NULL,1,126.258333,-0.59139,0.097,NULL,39222101811,612845340,9575708,13.7),(54239,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54239,33.74,0.46,56.1,15904,NULL,NULL,'J','NGC 2590',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54240,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54240,33.75,0.47,56.3,15904,NULL,NULL,'H','NGC 2590',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54241,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54241,33.92,0.49,60.7,15904,75,NULL,'IR','NGC 2590',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54242,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54242,33.98,0.26,62.5,15904,NULL,NULL,'Malmquist cor.','NGC 2590',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54243,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54243,34,0.43,63,15904,75,NULL,'3.6 micron, color corrected','NGC 2590',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54244,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54244,34.06,0.2,64.9,15904,74.4,NULL,NULL,'NGC 2590',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54245,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54245,34.08,0.43,65.3,15904,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2590',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54246,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54246,34.19,0.24,69,15904,NULL,NULL,NULL,'NGC 2590',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54247,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54247,34.28,0.4,71.8,15904,NULL,NULL,'mean','NGC 2590',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54248,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54248,37.9,0.21,380,15905,70,NULL,NULL,'SDSS J082502.15+082614.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000272,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,126.259,8.43747,0.053,NULL,62577843383,977778802,15277793,18.5),(54249,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54249,36.7,0.46,219,15906,70,NULL,NULL,'2MASX J08250249+1141123',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,126.26025,11.68664,0.093,NULL,62562475713,977538683,15274041,17.3),(54250,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54250,37.75,0.33,355,15907,70,NULL,NULL,'2MASX J08250246+5238407',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000073,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,126.26025,52.64456,0.177,NULL,63492359011,992068109,15501064,17.9),(54251,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54251,37.44,0.27,308,15908,70,NULL,NULL,'2MASX J08250275+0909293',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,126.2615,9.15817,0.077,NULL,62563353107,977552392,15274256,17.8),(54252,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54252,38.08,0.21,414,15909,70,NULL,NULL,'2MASX J08250279+0416301',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000135,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,126.261583333,4.27519,0.045,NULL,62589811710,977965807,15280715,16.8),(54253,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54253,36.05,NULL,162,15910,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0751',NULL,'2010Ap&SS.325..163P',2010,1,1.21,NULL,'G',0.000042,NULL,'15.7g',0.25,'Sc',NULL,NULL,NULL,NULL,1,126.2652917,32.50269,0.129,NULL,64334731618,1005230181,15706721,15.7),(54254,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54254,36.05,NULL,162,15910,NULL,NULL,'Dipole + Quadrupole','FGC 0751',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54255,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54255,36.06,NULL,163,15910,NULL,NULL,'Dipole','FGC 0751',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54256,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54256,36.11,NULL,167,15910,NULL,NULL,NULL,'FGC 0751',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54257,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54257,38.22,0.23,441,15911,70,NULL,NULL,'SDSS J082503.77+105932.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,126.26575,10.9925,0.077,NULL,62562713467,977542397,15274099,18.5),(54258,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54258,35.44,0.57,123,15912,70,NULL,NULL,'CGCG 004-019',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.5',0.15,NULL,NULL,NULL,NULL,NULL,1,126.27,-1.21664,0.121,NULL,39222823837,612856622,9575884,15.5),(54259,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54259,37.21,0.27,277,15913,70,NULL,NULL,'SDSS J082504.87+422030.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000163,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,126.270333,42.34183,0.141,NULL,64243083843,1003798185,15684346,18.2),(54260,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54260,36.82,0.46,231,15914,70,NULL,NULL,'SDSS J082505.46+353754.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000135,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,126.2727917,35.63194,0.225,NULL,64337659308,1005275926,15707436,17.9),(54261,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54261,37.56,0.46,325,15915,70,NULL,NULL,'2MASX J08250572+2558251',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,126.2737917,25.97353,0.061,NULL,64316050877,1004938294,15702160,17.3),(54262,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54262,37.88,0.46,376,15916,70,NULL,NULL,'SDSS J082506.36+395612.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,126.2765417,39.93689,0.125,NULL,64357931559,1005592680,15712385,18.2),(54263,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54263,37.46,0.46,311,15917,70,NULL,NULL,'2MASX J08250634+1628213',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,126.276583,16.47256,0.137,NULL,63786861593,996669712,15572964,16.9),(54264,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54264,37.3,0.46,289,15918,70,NULL,NULL,'2MASX J08250705+2842131',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,126.279167,28.70356,0.069,NULL,64350461323,1005475958,15710561,17.8),(54265,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54265,38.15,0.14,427,15919,70,NULL,NULL,'2MASX J08250709+1903361',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00016,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,126.279625,19.05997,0.173,NULL,63817484163,997148190,15580440,16.9),(54266,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54266,38.22,0.23,441,15920,70,NULL,NULL,'2MASX J08250861+1101093',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,126.2860417,11.01919,0.077,NULL,62562700535,977542195,15274096,17.5),(54267,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54267,37.32,0.46,291,15921,70,NULL,NULL,'2MASX J08250909+1036513',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,126.287875,10.61425,0.065,NULL,62566123880,977595685,15274932,16.7),(54268,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54268,38.7,0.46,549,15922,70,NULL,NULL,'SDSS J082509.20+104326.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,126.288333,10.724,0.065,NULL,62562602060,977540657,15274072,18.2),(54269,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54269,36.09,0.66,165,15923,70,NULL,NULL,'CGCG 004-021',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.4',0.5,NULL,NULL,NULL,NULL,NULL,1,126.29025,-2.56897,0.085,NULL,39221647419,612838240,9575597,15.4),(54270,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54270,37.37,0.46,298,15924,70,NULL,NULL,'2MASX J08251011+1132023',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,126.29225,11.53411,0.093,NULL,62562333185,977536456,15274007,17.2),(54271,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54271,37.49,0.33,314,15925,70,NULL,NULL,'2MASX J08251039+5438416',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000181,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,126.293083,54.64486,0.113,NULL,61549000564,961703133,15026611,16.4),(54272,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54272,36.88,0.46,237,15926,70,NULL,NULL,'2MASX J08251056+1804411',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00014,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,126.294,18.07811,0.145,NULL,63782931093,996608298,15572004,17.5),(54273,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54273,34.24,0.12,70.6,15927,NULL,NULL,NULL,'NGC 2582',NULL,'2009ApJS..182..474S',2009,1,1.15,NULL,'G',0.000017,NULL,'13.9g',1.03,'(R\')SAB(s)ab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,126.3002917,20.33475,0.153,NULL,63819662045,997182219,15580972,13.9),(54274,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54274,29.35,NULL,7.41,15928,NULL,NULL,NULL,'CGMW 2-3473',NULL,'2013AJ....145..101K',2013,1,0.78,NULL,'G',0.00002,NULL,'15.5',0.45,'Spiral edge-on',NULL,NULL,NULL,NULL,1,126.303917,-28.14047,NULL,NULL,42738677942,667791842,10434247,15.5),(54275,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54275,37.75,0.33,355,15929,70,NULL,NULL,'2MASX J08251452+5235556',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000089,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,126.310625,52.59867,0.177,NULL,63490510283,992039223,15500612,16.9),(54276,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54276,37.3,0.46,288,15930,70,NULL,NULL,'2MASX J08251685+3404569',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000183,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,126.3202917,34.08247,0.193,NULL,64335619006,1005244046,15706938,16.5),(54277,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54277,33.73,0.33,55.8,15931,70,NULL,NULL,'CGCG 032-022',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000037,NULL,'14.7g',0.74,'S0',NULL,NULL,NULL,NULL,1,126.322791667,3.93358,0.085,NULL,62589938824,977967794,15280746,14.7),(54278,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54278,38.22,0.23,441,15932,70,NULL,NULL,'SDSS J082517.96+110630.4',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,126.324833333,11.10847,0.077,NULL,62563176091,977549626,15274212,17.8),(54279,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54279,37.44,0.27,308,15933,70,NULL,NULL,'SDSS J082519.41+091733.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,126.330875,9.29275,0.077,NULL,62563690020,977557656,15274338,17.9),(54280,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54280,35.75,0.53,141,15934,70,NULL,NULL,'2MASX J08251946-0108048',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.89',0.5,NULL,NULL,NULL,NULL,NULL,1,126.3310417,-1.13492,0.121,NULL,39223011178,612859549,9575930,15.89),(54281,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54281,37.74,0.33,354,15935,70,NULL,NULL,'2MASX J08251984+1728553',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000173,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,126.33275,17.48206,0.129,NULL,63783680872,996620013,15572187,16.8),(54282,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54282,37.9,0.21,380,15936,70,NULL,NULL,'2MASX J08252081+0816033',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00018,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,126.33675,8.26753,0.065,NULL,62577373550,977771461,15277679,16.9),(54283,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54283,37.44,0.27,308,15937,70,NULL,NULL,'2MASX J08252085+0914333',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,126.3369583,9.24269,0.077,NULL,62563694418,977557725,15274339,16.9),(54284,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54284,37.91,0.46,381,15938,70,NULL,NULL,'2MASX J08252108+3612121',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,126.3379583,36.20344,0.153,NULL,64337496470,1005273382,15707396,18.2),(54285,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54285,37.98,0.33,394,15939,70,NULL,NULL,'2MASX J08252113+0725253',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,126.338,7.42383,0.049,NULL,62569829127,977653580,15275837,17.6),(54286,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54286,36.19,0.46,173,15940,70,NULL,NULL,'CGCG 060-011',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000103,NULL,'15.6',0.48,NULL,NULL,NULL,NULL,NULL,1,126.338167,9.71667,0.053,NULL,62564111588,977564243,15274441,15.6),(54287,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54287,35.84,0.46,147,15941,70,NULL,NULL,'2MASX J08252124+0425512',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000167,NULL,'15.6g',0.44,'S0',NULL,NULL,NULL,NULL,1,126.338375,4.43097,0.045,NULL,62597418610,978084665,15282572,15.6),(54288,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54288,37.9,0.21,380,15942,70,NULL,NULL,'2MASX J08252135+0815363',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,126.338917,8.26011,0.065,NULL,62577376809,977771512,15277679,17.7),(54289,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54289,38.74,0.46,561,15943,70,NULL,NULL,'2MASX J08252150+1943373',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00016,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,126.339667,19.72717,0.165,NULL,63817823703,997153495,15580523,18.4),(54290,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54290,37.77,0.46,358,15944,70,NULL,NULL,'2MASX J08252164+0748231',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000148,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,126.34025,7.80656,0.057,NULL,62569275132,977644923,15275701,17.4),(54291,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54291,38.03,0.46,404,15945,70,NULL,NULL,'SDSS J082522.47+242837.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,126.343625,24.477,0.085,NULL,63791299622,996739056,15574047,18.2),(54292,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54292,38,0.46,398,15946,70,NULL,NULL,'2MASX J08252327+0718371',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,126.347125,7.31028,0.049,NULL,62569790922,977652983,15275827,17.3),(54293,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54293,37.51,0.46,317,15947,70,NULL,NULL,'2MASX J08252381+5319099',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,126.349167,53.31944,0.153,NULL,63492399228,992068737,15501074,17.5),(54294,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54294,35.12,NULL,105,15948,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0754',NULL,'2010Ap&SS.325..163P',2010,1,0.92,NULL,'G',0.00001,NULL,'16.8g',0.14,'Scd',NULL,NULL,NULL,NULL,1,126.350041667,30.27311,0.105,NULL,64354581374,1005540333,15711567,16.8),(54295,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54295,35.12,NULL,106,15948,NULL,NULL,'Dipole + Quadrupole','FGC 0754',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54296,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54296,35.13,NULL,106,15948,NULL,NULL,'Dipole','FGC 0754',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54297,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54297,35.22,NULL,110,15948,NULL,NULL,NULL,'FGC 0754',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54298,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54298,35.39,0.2,120,15948,74.4,NULL,NULL,'FGC 0754',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54299,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54299,37.98,0.33,394,15949,70,NULL,NULL,'2MASX J08252414+0728261',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000146,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,126.350833,7.47392,0.049,NULL,62569815226,977653362,15275833,17.5),(54300,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54300,37.73,0.46,352,15950,70,NULL,NULL,'2MASX J08252570+1918493',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000169,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,126.357083,19.31383,0.165,NULL,63817465310,997147895,15580435,17.7),(54301,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54301,37.91,0.46,382,15951,70,NULL,NULL,'SDSS J082526.45+553232.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000135,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,126.36025,55.5425,0.133,NULL,61550378323,961724661,15026947,18.2),(54302,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54302,37.9,0.21,380,15952,70,NULL,NULL,'2MASX J08252823+0821521',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,126.36775,8.36433,0.065,NULL,62577352471,977771132,15277673,17.7),(54303,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54303,37.14,0.46,268,15953,70,NULL,NULL,'2MASX J08252986+4129131',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00017,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,126.3744583,41.48711,0.161,NULL,64244078832,1003813731,15684589,16.8),(54304,'Tully est','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54304,33.01,0.8,40,15954,75,NULL,NULL,'NGC 2601',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.00015,NULL,'13.40',1.1,'(R\'L)SAB(rs)a',NULL,NULL,NULL,NULL,1,126.37775,-68.11767,0.493,NULL,40790521958,637351905,9958623,13.4),(54305,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54305,33.53,0.4,50.8,15954,NULL,NULL,'mean','NGC 2601',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54306,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54306,33.68,0.45,54.5,15954,NULL,NULL,'K','NGC 2601',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54307,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54307,33.72,0.47,55.5,15954,NULL,NULL,'H','NGC 2601',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54308,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54308,33.75,0.46,56.3,15954,NULL,NULL,'J','NGC 2601',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54309,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54309,37.62,0.46,334,15955,70,NULL,NULL,'2MASX J08253162+2021073',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000144,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,126.381917,20.35203,0.153,NULL,63819703077,997182860,15580982,17.3),(54310,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54310,38.43,0.46,486,15956,70,NULL,NULL,'SDSS J082532.15+101513.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,126.384,10.25367,0.061,NULL,62566023692,977594120,15274908,17.9),(54311,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54311,34.65,0.46,84.9,15957,70,NULL,NULL,'2MASX J08253342+1126571',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000117,NULL,'15.9g',0.37,NULL,NULL,NULL,NULL,NULL,1,126.3892083,11.44908,0.101,NULL,62562320558,977536258,15274004,15.9),(54312,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54312,37.3,0.46,288,15958,70,NULL,NULL,'2MASX J08253342+5922541',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,126.3892917,59.38158,0.153,NULL,61564101696,961939089,15030298,17.5),(54313,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54313,37.8,0.23,364,15959,70,NULL,NULL,'2MASX J08253361+1749311',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,126.389917,17.82517,0.113,NULL,63782924553,996608196,15572003,18),(54314,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54314,37.4,0.46,302,15960,70,NULL,NULL,'2MASX J08253639+4815149',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000095,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,126.4017917,48.25408,0.141,NULL,63543326078,992864469,15513507,17),(54315,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54315,36.94,0.46,244,15961,70,NULL,NULL,'SDSS J082536.69+164024.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.9g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,126.402875,16.67361,0.137,NULL,63786398779,996662480,15572851,17.9),(54316,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54316,37.95,0.46,390,15962,70,NULL,NULL,'2MASX J08253841+4826179',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000071,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,126.410166667,48.43831,0.141,NULL,63543376982,992865265,15513519,18.2),(54317,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54317,37.35,0.46,296,15963,70,NULL,NULL,'2MASX J08253855+1456051',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,126.4107917,14.93475,0.113,NULL,63773494590,996460852,15569700,17.6),(54318,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54318,37.24,0.46,280,15964,70,NULL,NULL,'2MASX J08253883+1502581',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00018,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,126.411708333,15.04936,0.109,NULL,63771526703,996430104,15569220,16.9),(54319,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54319,37.22,0.21,278,15965,70,NULL,NULL,'2MASX J08254298+4101394',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000174,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,126.429167,41.02747,0.161,NULL,64244135986,1003814624,15684603,18.2),(54320,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54320,38.14,0.46,426,15966,70,NULL,NULL,'SDSS J082543.51+380514.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000145,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,126.431333333,38.0875,0.145,NULL,64359109166,1005611080,15712673,18.5),(54321,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54321,36.12,0.46,168,15967,70,NULL,NULL,'2MASX J08254387+3230467',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000149,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,126.4327083,32.51297,0.129,NULL,64334753493,1005230523,15706726,16.9),(54322,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54322,38.08,0.21,414,15968,70,NULL,NULL,'2MASX J08254558+0429130',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000141,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,126.439916667,4.48692,0.049,NULL,62597580243,978087191,15282612,17.3),(54323,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54323,38.04,0.46,405,15969,70,NULL,NULL,'2MASX J08254637+1346531',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,126.443333,13.78144,0.101,NULL,63770562631,996415041,15568985,NULL),(54324,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54324,37.98,0.46,395,15970,70,NULL,NULL,'2MASX J08254674+0247440',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,126.4447917,2.79561,0.121,NULL,62592544625,978008509,15281382,17.3),(54325,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54325,38.71,0.46,551,15971,70,NULL,NULL,'SDSS J082546.85+253713.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,126.44525,25.62044,0.061,NULL,64316335727,1004942745,15702230,18.2),(54326,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54326,32.87,0.2,37.5,15972,74.4,NULL,NULL,'UGC 04395',NULL,'2013AJ....146...86T',2013,1,2.28,NULL,'G',0.000009,NULL,'15.5g',0.25,'Sc',NULL,NULL,NULL,NULL,1,126.448333,28.11814,0.069,NULL,64351065850,1005485403,15710709,15.5),(54327,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54327,32.92,0.52,38.3,15972,NULL,NULL,'Malmquist cor.','UGC 04395',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54328,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54328,32.95,0.51,38.9,15972,NULL,NULL,NULL,'UGC 04395',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54329,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54329,33.02,NULL,40.2,15972,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04395',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54330,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54330,33.03,NULL,40.5,15972,NULL,NULL,'Dipole + Quadrupole','UGC 04395',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54331,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54331,33.04,NULL,40.5,15972,NULL,NULL,'Dipole','UGC 04395',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54332,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54332,33.07,NULL,41.1,15972,NULL,NULL,NULL,'UGC 04395',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54333,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54333,33.27,0.49,45.1,15972,75,NULL,'IR','UGC 04395',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54334,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54334,33.47,0.4,49.5,15972,75,NULL,NULL,'UGC 04395',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54335,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54335,37.3,0.46,289,15973,70,NULL,NULL,'2MASX J08254843+5352359',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,126.451875,53.87667,0.089,NULL,63492097076,992064016,15501000,17.4),(54336,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54336,36.77,0.46,226,15974,70,NULL,NULL,'2MASX J08254988+1805076',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,126.457875,18.08553,0.145,NULL,63775552337,996493005,15570203,17.1),(54337,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54337,37.97,0.46,393,15975,70,NULL,NULL,'2MASX J08254989+5840061',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,126.4582083,58.66822,0.177,NULL,61597741479,962464710,15038511,18.1),(54338,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54338,35.44,0.49,122,15976,75,NULL,'IR','FGC 0750',NULL,'2011yCatp016004901K',2011,1,1.04,NULL,'G',NULL,NULL,'16.4',0.11,'Scd',NULL,NULL,NULL,NULL,1,126.461833,61.12544,0.121,NULL,62049723393,969526928,15148858,16.4),(54339,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54339,35.69,NULL,137,15976,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0750',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54340,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54340,35.7,NULL,138,15976,NULL,NULL,'Dipole + Quadrupole','FGC 0750',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54341,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54341,35.72,NULL,139,15976,NULL,NULL,'Dipole','FGC 0750',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54342,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54342,35.72,NULL,140,15976,NULL,NULL,NULL,'FGC 0750',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54343,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54343,38.36,0.46,469,15977,70,NULL,NULL,'SDSS J082551.16+102419.5',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.8g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,126.463167,10.40544,0.069,NULL,62566081566,977595024,15274922,17.8),(54344,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54344,37.56,0.46,325,15978,70,NULL,NULL,'2MASX J08255126+1428240',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000191,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,126.463625,14.47339,0.117,NULL,63774250075,996472657,15569885,16.8),(54345,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54345,37.52,0.46,319,15979,70,NULL,NULL,'2MASX J08255215+0931563',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,126.4672083,9.53239,0.061,NULL,62563759157,977558736,15274355,16.8),(54346,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54346,37.8,0.23,364,15980,70,NULL,NULL,'2MASX J08255356+1745110',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00017,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,126.4732917,17.75297,0.113,NULL,63783634696,996619292,15572176,18.2),(54347,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54347,36.09,0.46,165,15981,70,NULL,NULL,'2MASX J08255612+2346287',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000177,NULL,'16.1g',0.41,NULL,NULL,NULL,NULL,NULL,1,126.4839583,23.77472,0.105,NULL,63808707419,997011053,15578297,16.1),(54348,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54348,37.7,0.46,347,15982,70,NULL,NULL,'2MASX J08255745+3923294',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,126.4894583,39.39164,0.145,NULL,64361068641,1005641697,15713151,17.3),(54349,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54349,38.19,0.46,434,15983,70,NULL,NULL,'SDSS J082559.76+405807.0',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000169,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,126.499,40.96864,0.161,NULL,64244005378,1003812584,15684571,18.6),(54350,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54350,37.69,0.46,345,15984,70,NULL,NULL,'2MASX J08260006+1242441',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,126.500333,12.71214,0.097,NULL,63770297418,996410897,15568920,17.8),(54351,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54351,37.22,0.21,278,15985,70,NULL,NULL,'CGCG 208-003',NULL,'2015arXiv151105856S',2015,1,0.98,NULL,'G',0.000157,NULL,'14.9g',0.62,'BrClG',NULL,NULL,NULL,NULL,1,126.502333,40.98106,0.161,NULL,64244005921,1003812592,15684571,14.9),(54352,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54352,37.8,0.23,364,15986,70,NULL,NULL,'2MASX J08260062+1754007',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000175,NULL,'17.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,126.5024583,17.90028,0.113,NULL,63775515771,996492433,15570194,17.1),(54353,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54353,37.8,0.23,364,15987,70,NULL,NULL,'2MASX J08260184+1742471',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000148,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,126.507583,17.71297,0.113,NULL,63783635870,996619310,15572176,16.9),(54354,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54354,38.11,0.33,419,15988,70,NULL,NULL,'2MASX J08260194+3100570',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,126.508167,31.01597,0.117,NULL,64343805537,1005371961,15708936,17.1),(54355,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54355,37.08,0.46,261,15989,70,NULL,NULL,'2MASX J08260317+2844021',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,126.5132083,28.73386,0.069,NULL,64350126330,1005470723,15710480,17.5),(54356,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54356,38.11,0.46,418,15990,70,NULL,NULL,'2MASX J08260352+1414021',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,126.5145417,14.23392,0.121,NULL,63773951480,996467991,15569812,17.5),(54357,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54357,38.33,0.46,463,15991,70,NULL,NULL,'2MASX J08260368+1158124',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,126.515125,11.97008,0.101,NULL,63652786700,994574792,15540231,17.9),(54358,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54358,37.4,0.46,302,15992,70,NULL,NULL,'2MASX J08260387+5451531',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,126.516166667,54.86478,0.145,NULL,61549072843,961704263,15026629,17),(54359,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54359,29.9,0.43,9.6,15993,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04393',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.000004,NULL,'14.1g',0.66,'SBc?           HII','Isolated galaxy',NULL,NULL,NULL,1,126.5182917,45.96764,0.137,NULL,63526260681,992597823,15509340,14.1),(54360,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54360,30.16,0.43,10.7,15993,75,NULL,'3.6 micron, color corrected','UGC 04393',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54361,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54361,30.65,0.4,13.5,15993,NULL,NULL,NULL,'UGC 04393',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54362,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54362,30.65,0.4,13.5,15993,73,NULL,'opt','UGC 04393',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54363,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54363,30.91,0.41,15.2,15993,NULL,NULL,NULL,'UGC 04393',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54364,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54364,31.13,0.37,16.8,15993,NULL,NULL,'Malmquist cor.','UGC 04393',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54365,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54365,32.52,0.4,31.9,15993,75,NULL,'B','UGC 04393',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54366,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54366,37.74,0.46,353,15994,70,NULL,NULL,'2MASX J08260454+3314230',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,126.518833,33.23972,0.165,NULL,64334667600,1005229181,15706705,18),(54367,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54367,38.11,0.33,419,15995,70,NULL,NULL,'2MASX J08260528+3100560',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,126.521833333,31.01564,0.117,NULL,64343805529,1005371961,15708936,17.6),(54368,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54368,37.52,0.17,319,15996,70,NULL,NULL,'2MASX J08260547+1734111',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000157,NULL,'17.1g',NULL,NULL,NULL,NULL,NULL,NULL,1,126.522875,17.56967,0.129,NULL,63783430603,996616103,15572126,17.1),(54369,'IRAS','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54369,33.91,0.8,60.6,15997,75,NULL,'W91CL, r','UGC 04400',NULL,'1997ApJS..109..333W',1997,1,1.26,NULL,'G',0.000004,NULL,'16.0g',0.2,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,126.523333,21.66758,0.129,NULL,63818848322,997169505,15580773,16),(54370,'IRAS','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54370,33.91,0.8,60.6,15997,75,NULL,'HMCL, I','UGC 04400',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54371,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54371,33.72,NULL,55.5,15997,NULL,NULL,'Dipole','UGC 04400',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54372,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54372,33.72,NULL,55.5,15997,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04400',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54373,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54373,33.72,NULL,55.6,15997,NULL,NULL,'Dipole + Quadrupole','UGC 04400',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54374,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54374,33.86,NULL,59.1,15997,NULL,NULL,NULL,'UGC 04400',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54375,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54375,34.08,0.4,65.5,15997,75,NULL,'HMCL, I, raw','UGC 04400',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54376,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54376,34.12,0.4,66.6,15997,75,NULL,'HMCL, I, inv','UGC 04400',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54377,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54377,34.2,0.38,69.1,15997,75,NULL,'W91CL, r, inv','UGC 04400',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54378,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54378,34.22,0.38,69.7,15997,75,NULL,'W91CL, r, raw','UGC 04400',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54379,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54379,34.26,0.12,71.3,15997,NULL,NULL,NULL,'UGC 04400',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54380,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54380,34.29,0.2,72.1,15997,74.4,NULL,NULL,'UGC 04400',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54381,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54381,34.34,0.4,73.9,15997,75,NULL,'HMCL, I, cor','UGC 04400',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54382,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54382,34.41,0.38,76.1,15997,75,NULL,'W91CL, r, cor','UGC 04400',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54383,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54383,34.42,0.43,76.5,15997,75,NULL,'3.6 micron, color corrected','UGC 04400',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54384,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54384,34.56,0.43,81.5,15997,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04400',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54385,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54385,37.9,0.46,380,15998,70,NULL,NULL,'SDSS J082605.86+345015.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000133,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,126.524417,34.83761,0.165,NULL,64333719382,1005214365,15706474,18.6),(54386,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54386,38.76,0.46,564,15999,70,NULL,NULL,'2MASX J08260689+0709314',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,126.52875,7.15867,0.049,NULL,62569736324,977652130,15275814,17.5),(54387,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54387,36.52,0.46,202,16000,70,NULL,NULL,'2MASX J08260741+1209591',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.0g',0.35,NULL,NULL,NULL,NULL,NULL,1,126.53075,12.16647,0.093,NULL,63652798187,994574971,15540233,16),(54388,'IRAS','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54388,33.97,0.8,62.1,16001,75,NULL,'W91CL, r','UGC 04399',NULL,'1997ApJS..109..333W',1997,1,1.14,NULL,'G',0.000007,NULL,'15.2g',0.33,'Sdm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,126.531,21.45672,0.121,NULL,63818902138,997170345,15580786,15.2),(54389,'IRAS','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54389,33.97,0.8,62.1,16001,75,NULL,'HMCL, I','UGC 04399',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54390,'IRAS','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54390,33.97,0.8,62.2,16001,75,NULL,'CF, r','UGC 04399',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54391,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54391,33.63,0.4,53.3,16001,75,NULL,'HMCL, I, raw','UGC 04399',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54392,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54392,33.66,0.38,54,16001,75,NULL,'W91CL, r, raw','UGC 04399',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54393,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54393,33.66,0.38,54,16001,75,NULL,'W91CL, r, inv','UGC 04399',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54394,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54394,33.69,0.4,54.6,16001,75,NULL,'HMCL, I, inv','UGC 04399',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54395,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54395,33.75,0.38,56.2,16001,75,NULL,'CF, r, raw','UGC 04399',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54396,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54396,33.75,0.38,56.2,16001,75,NULL,'CF, r, inv','UGC 04399',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54397,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54397,33.8,0.2,57.5,16001,74.4,NULL,NULL,'UGC 04399',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54398,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54398,33.81,0.43,57.8,16001,75,NULL,'3.6 micron, color corrected','UGC 04399',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54399,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54399,33.83,0.43,58.4,16001,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04399',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54400,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54400,34.04,0.38,64.2,16001,75,NULL,'W91CL, r, cor','UGC 04399',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54401,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54401,34.04,0.4,64.4,16001,75,NULL,'HMCL, I, cor','UGC 04399',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54402,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54402,34.1,0.38,66.1,16001,75,NULL,'CF, r, cor','UGC 04399',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54403,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54403,34.25,0.1,70.9,16001,NULL,NULL,NULL,'UGC 04399',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54404,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54404,35.55,0.54,129,16002,70,NULL,NULL,'ESO 060- G 006',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.51',0.5,'N',NULL,NULL,NULL,NULL,1,126.53525,-71.8195,1.177,NULL,40632963522,634890055,9920157,15.51),(54405,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54405,37.22,0.21,278,16003,70,NULL,NULL,'2MASXi J0826085+405841',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000168,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,126.535541667,40.97831,0.161,NULL,64244006795,1003812606,15684571,18),(54406,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54406,37.16,0.27,270,16004,70,NULL,NULL,'2MASX J08260934+3704204',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,'FoF','16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,126.539,37.07244,0.209,NULL,64358619005,1005603421,15712553,16.3),(54407,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54407,37.89,0.46,379,16005,70,NULL,NULL,'2MASX J08261022+1148304',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.7E',NULL,NULL,NULL,NULL,NULL,NULL,1,126.5427083,11.80853,0.093,NULL,63652856469,994575882,15540248,16.7),(54408,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54408,38.8,0.46,574,16006,70,NULL,NULL,'SDSS J082610.50+162126.7',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000169,NULL,'18.9g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,126.5437917,16.35744,0.129,NULL,63786332146,996661439,15572834,18.9),(54409,'Tully est','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54409,30.39,0.8,12,16007,75,NULL,NULL,'ESO 164- G?010',NULL,'1988NBGC.C....0000T',1988,1,1.5,'abs(b) < 10 degrees.','G',0.000007,NULL,'14.0',1.5,'SABm:',NULL,NULL,NULL,NULL,1,126.553083,-54.03606,NULL,NULL,42489955014,663905547,10373524,14),(54410,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54410,37.81,0.46,365,16008,70,NULL,NULL,'2MASX J08261376+1832127',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000149,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,126.55725,18.53692,0.185,NULL,63775654645,996494603,15570228,18.5),(54411,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54411,37.16,0.27,270,16009,70,NULL,NULL,'2MASX J08261415+3705054',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00018,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,126.559,37.08489,0.209,NULL,64358618560,1005603415,15712553,16.5),(54412,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54412,38.36,0.46,470,16010,70,NULL,NULL,'2MASX J08261441+0411260',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,126.559958333,4.19047,0.077,NULL,62597452533,978085195,15282581,17.4),(54413,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54413,37.04,0.46,256,16011,70,NULL,NULL,'2MASX J08261455+1048564',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,126.5605417,10.81567,0.085,NULL,62563040790,977547512,15274179,16.2),(54414,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54414,37.44,0.46,307,16012,70,NULL,NULL,'2MASX J08261877+1444530',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,126.578375,14.74828,0.117,NULL,63771584222,996431003,15569234,17.4),(54415,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54415,39.05,0.46,645,16013,70,NULL,NULL,'SDSS J082619.98+111617.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,126.583291667,11.27144,0.113,NULL,62563143354,977549114,15274204,18.4),(54416,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54416,37.64,0.46,338,16014,70,NULL,NULL,'2MASX J08262092+5639033',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000134,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,126.587125,56.651,0.125,NULL,61552061660,961750963,15027358,17.6),(54417,'IRAS','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54417,34.39,0.8,75.5,16015,75,NULL,'HMCL, I','KUG 0823+230B',NULL,'1997ApJS..109..333W',1997,1,1.17,NULL,'G',0.000033,NULL,'15.7g',0.21,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,126.587917,22.89969,0.165,NULL,63811515550,997054930,15578983,15.7),(54418,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54418,35.72,0.4,140,16015,75,NULL,'HMCL, I, raw','KUG 0823+230B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54419,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54419,35.91,0.4,152,16015,75,NULL,'HMCL, I, inv','KUG 0823+230B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54420,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54420,35.97,0.4,156,16015,75,NULL,'HMCL, I, cor','KUG 0823+230B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54421,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54421,38.1,0.46,417,16016,70,NULL,NULL,'2MASX J08262155+0737589',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000188,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,126.589917,7.63306,0.049,NULL,62569584719,977649761,15275777,17.2),(54422,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54422,35.75,0.49,141,16017,75,NULL,'IR','CGCG 089-027',NULL,'2011yCatp016004901K',2011,1,1.18,'This is not IC 2369; that is a nearby star.','G',0.000013,NULL,'15.5g',0.25,NULL,'Group member, radial-velocity confirmed',NULL,NULL,NULL,1,126.590083,20.27061,0.125,NULL,63819528190,997180127,15580939,15.5),(54423,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54423,38.08,0.21,414,16018,70,NULL,NULL,'2MASX J08262176+0431460',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,126.5905,4.52947,0.049,NULL,62597523772,978086308,15282598,17.5),(54424,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54424,37.61,0.33,332,16019,70,NULL,NULL,'2MASX J08262189+4838426',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000077,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,126.591417,48.64508,0.133,NULL,63543407945,992865749,15513527,17.5),(54425,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54425,36.25,0.46,178,16020,70,NULL,NULL,'2MASX J08262216+4604366',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000068,NULL,'17.2g',0.19,'NLAGN',NULL,NULL,NULL,NULL,1,126.59225,46.07694,0.117,NULL,63526264774,992597887,15509341,17.2),(54426,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54426,36.5,0.56,200,16021,70,NULL,NULL,'2MASX J08262253-1341453',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,126.593875,-13.69586,0.225,NULL,42245708778,660089199,10313893,15.4),(54427,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54427,37.69,0.46,345,16022,70,NULL,NULL,'2MASX J08262344+5700333',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000175,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,126.597583,57.00944,0.133,NULL,61544499685,961632807,15025512,17.5),(54428,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54428,38.24,0.27,444,16023,70,NULL,NULL,'2MASX J08262357+3114091',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000158,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,126.5982083,31.23578,0.105,NULL,64342038629,1005344353,15708505,17.2),(54429,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54429,38.26,0.46,450,16024,70,NULL,NULL,'SDSS J082623.69+032828.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,126.5987083,3.4745,0.105,NULL,62589586470,977962288,15280660,17.7),(54430,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54430,36.23,0.46,176,16025,70,NULL,NULL,'CGCG 287-076',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00011,NULL,'15.5',0.2,NULL,NULL,NULL,NULL,NULL,1,126.603667,59.8955,0.133,NULL,62047226025,969487906,15148248,15.5),(54431,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54431,37.52,0.17,319,16026,70,NULL,NULL,'2MASX J08262655+1716410',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.00016,NULL,'16.0g',0.37,NULL,NULL,NULL,NULL,NULL,1,126.6107083,17.27794,0.097,NULL,63783565729,996618214,15572159,16),(54432,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54432,37.26,0.46,284,16027,70,NULL,NULL,'2MASX J08262749+5439122',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,126.614541667,54.65342,0.113,NULL,61549157344,961705583,15026649,17.6),(54433,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54433,38.24,0.27,444,16028,70,NULL,NULL,'2MASX J08262879+3111541',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000141,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,126.620083,31.19847,0.117,NULL,64343930787,1005373918,15708967,17.3),(54434,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54434,36.6,0.46,209,16029,70,NULL,NULL,'2MASX J08262897+2641494',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00018,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,126.620666667,26.69694,0.057,NULL,64315989310,1004937332,15702145,16.8),(54435,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54435,35.03,0.49,101,16030,75,NULL,'IR','UGC 04404',NULL,'2011yCatp016004901K',2011,1,0.99,NULL,'G',0.000023,NULL,'15.4g',0.27,'Sdm:           HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,126.621583,22.26117,0.157,NULL,63810733968,997042718,15578792,15.4),(54436,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54436,37.75,0.46,354,16031,70,NULL,NULL,'2MASX J08262965+5534293',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,126.623667,55.57489,0.133,NULL,61548528132,961695752,15026496,17.3),(54437,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54437,38.98,0.46,625,16032,70,NULL,NULL,'SDSS J082629.99+064657.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000167,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,126.625,6.78267,0.041,NULL,62568282218,977629409,15275459,18.4),(54438,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54438,36.41,0.57,192,16033,70,NULL,NULL,'2MASX J08263008-0222436',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.12',NULL,NULL,NULL,NULL,NULL,NULL,1,126.62525,-2.37875,0.085,NULL,39221938106,612842782,9575668,16.12),(54439,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54439,36.61,0.46,209,16034,70,NULL,NULL,'2MASX J08263176+3340184',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000126,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,126.632375,33.67169,0.137,NULL,64335503894,1005242248,15706910,16.9),(54440,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54440,36.45,0.67,195,16035,70,NULL,NULL,'2MASX J08263228-1331316',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.2I',0.4,NULL,NULL,NULL,NULL,NULL,1,126.634583333,-13.52553,0.213,NULL,42245810197,660090784,10313918,14.2),(54441,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54441,37.9,0.21,380,16036,70,NULL,NULL,'2MASX J08263236+0841449',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,126.63475,8.69569,0.065,NULL,62577723501,977776929,15277764,16.5),(54442,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54442,37.61,0.33,332,16037,70,NULL,NULL,'2MASX J08263259+4839057',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000078,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,126.635916667,48.65164,0.133,NULL,63543395591,992865556,15513524,17.1),(54443,'IRAS','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54443,34.5,0.8,79.5,16038,75,NULL,'HMCL, I','UGC 04405',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000005,NULL,'14.4g',0.54,'S0/a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,126.637,23.19275,0.093,NULL,63811398583,997053102,15578954,14.4),(54444,'IRAS','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54444,34.51,0.8,79.9,16038,75,NULL,'W91CL, r','UGC 04405',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54445,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54445,34.7,0.2,87.1,16038,74.4,NULL,NULL,'UGC 04405',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54446,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54446,34.73,0.12,88.5,16038,NULL,NULL,NULL,'UGC 04405',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54447,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54447,34.77,0.4,90,16038,75,NULL,'HMCL, I, raw','UGC 04405',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54448,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54448,34.79,0.38,90.6,16038,75,NULL,'W91CL, r, raw','UGC 04405',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54449,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54449,34.9,0.4,95.6,16038,75,NULL,'HMCL, I, cor','UGC 04405',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54450,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54450,34.91,0.38,95.9,16038,75,NULL,'W91CL, r, cor','UGC 04405',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54451,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54451,34.99,0.38,99.4,16038,75,NULL,'W91CL, r, inv','UGC 04405',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54452,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54452,35.01,0.4,101,16038,75,NULL,'HMCL, I, inv','UGC 04405',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54453,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54453,37.59,0.46,329,16039,70,NULL,NULL,'SDSS J082636.35+095548.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,126.6514583,9.93003,0.073,NULL,62566261676,977597838,15274966,17.9),(54454,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54454,35.35,0.46,118,16040,70,NULL,NULL,'CGCG 119-098',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000073,NULL,'15.5g',0.46,'S..','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,126.6529583,22.42233,0.157,NULL,63810889526,997045148,15578830,15.5),(54455,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54455,37.47,0.46,313,16041,70,NULL,NULL,'SDSS J082639.04+301010.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000169,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,126.66275,30.16958,0.101,NULL,64343474266,1005366785,15708856,18),(54456,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54456,38.24,0.27,444,16042,70,NULL,NULL,'2MASXi J0826402+311201',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,126.6675,31.20036,0.117,NULL,64343932657,1005373947,15708967,18.3),(54457,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54457,38.34,0.46,466,16043,70,NULL,NULL,'2MASX J08264025+4234445',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000153,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,126.66775,42.57897,0.121,NULL,64242920792,1003795637,15684306,17.9),(54458,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54458,37.95,0.46,389,16044,70,NULL,NULL,'SDSS J082640.38+095852.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,126.6682917,9.98111,0.073,NULL,62566263648,977597869,15274966,17.8),(54459,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54459,37.23,0.46,279,16045,70,NULL,NULL,'2MASX J08264120+4431575',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000073,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,126.671791667,44.53272,0.137,NULL,64250252739,1003910199,15686096,17.1),(54460,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54460,37.52,0.17,319,16046,70,NULL,NULL,'2MASX J08264153+1724486',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'16.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,126.673125,17.41353,0.097,NULL,63783413557,996615836,15572122,16.4),(54461,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54461,36.6,0.46,209,16047,70,NULL,NULL,'2MASX J08264168+0932189',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,126.673708333,9.53864,0.081,NULL,62563780196,977559065,15274360,17.1),(54462,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54462,35.84,0.46,148,16048,70,NULL,NULL,'2MASX J08264236+1201036',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000087,NULL,'16.08',0.41,NULL,NULL,NULL,NULL,NULL,1,126.6765,12.01764,0.097,NULL,63653003798,994578184,15540284,16.08),(54463,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54463,36.57,0.27,206,16049,70,NULL,NULL,'2MASX J08264294+1738406',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000181,NULL,'16.0g',0.43,NULL,NULL,NULL,NULL,NULL,1,126.6787917,17.64461,0.129,NULL,63775841544,996497524,15570273,16),(54464,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54464,37.52,0.17,319,16050,70,NULL,NULL,'2MASX J08264321+1732546',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000183,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,126.680125,17.54839,0.129,NULL,63783424571,996616008,15572125,16.8),(54465,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54465,37.3,0.46,288,16051,70,NULL,NULL,'2MASX J08264357+1850378',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000146,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,126.6815,18.84392,0.181,NULL,63806058153,996969658,15577650,17),(54466,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54466,37.92,0.27,384,16052,70,NULL,NULL,'2MASX J08264399+1812129',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,126.68325,18.20369,0.129,NULL,63775650975,996494546,15570227,18),(54467,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54467,36.6,0.46,209,16053,70,NULL,NULL,'2MASX J08264409+4657143',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000083,NULL,'17.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,126.683833,46.95411,0.121,NULL,63523199263,992549988,15508593,17.1),(54468,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54468,37.45,0.46,309,16054,70,NULL,NULL,'SDSS J082647.04+034535.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00012,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,126.6960417,3.75978,0.061,NULL,62596974037,978077719,15282464,17.9),(54469,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54469,37.52,0.17,319,16055,70,NULL,NULL,'2MASX J08264734+1733066',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,126.697375,17.55189,0.129,NULL,63783408069,996615751,15572121,17.7),(54470,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54470,36.83,0.46,233,16056,70,NULL,NULL,'2MASX J08264749+3624318',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000178,NULL,'16.2g',0.36,'E0',NULL,NULL,NULL,NULL,1,126.6977917,36.40889,0.141,NULL,64325948197,1005092940,15704577,16.2),(54471,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54471,38.04,0.27,405,16057,70,NULL,NULL,'SDSS J082648.52+042830.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000122,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,126.7022083,4.47514,0.049,NULL,62597507939,978086061,15282594,18.5),(54472,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54472,37.77,0.46,358,16058,70,NULL,NULL,'2MASX J08264852+3059495',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000111,NULL,'18.0g',0.19,NULL,'Group member',NULL,NULL,NULL,1,126.702333333,30.99722,0.117,NULL,64343994915,1005374920,15708983,18),(54473,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54473,37.18,0.46,273,16059,70,NULL,NULL,'2MASX J08264979+2940082',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000155,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,126.707333,29.669,0.085,NULL,64355176525,1005549633,15711713,17.2),(54474,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54474,37.49,0.33,314,16060,70,NULL,NULL,'2MASX J08264985+5439251',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000181,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,126.7074583,54.65692,0.113,NULL,61549156348,961705567,15026649,17.4),(54475,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54475,38.27,0.33,450,16061,70,NULL,NULL,'2MASX J08265072+1243476',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,126.711333,12.72989,0.097,NULL,63837500871,997460951,15585327,17.9),(54476,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54476,37.24,0.46,281,16062,70,NULL,NULL,'2MASX J08265131+3126125',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,126.713791667,31.43681,0.105,NULL,64343906543,1005373539,15708961,17.1),(54477,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54477,37.92,0.27,384,16063,70,NULL,NULL,'2MASX J08265182+1809376',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000183,NULL,'17.0g',0.24,'BrClG',NULL,NULL,NULL,NULL,1,126.7160417,18.16036,0.129,NULL,63775524229,996492566,15570196,17),(54478,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54478,36.65,0.46,213,16064,70,NULL,NULL,'2MASX J08265273+4200454',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000187,NULL,'15.9g',0.47,'S0^-',NULL,NULL,NULL,NULL,1,126.719708333,42.01261,0.125,NULL,64242733374,1003792708,15684261,15.9),(54479,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54479,38.04,0.27,405,16065,70,NULL,NULL,'2MASX J08265349+0429065',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,126.722917,4.48508,0.049,NULL,62597506312,978086036,15282594,17.2),(54480,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54480,37.37,0.46,298,16066,70,NULL,NULL,'2MASX J08265375+5011314',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000069,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,126.724041667,50.192,0.137,NULL,63496431774,992131746,15502058,17.8),(54481,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54481,37.48,0.33,314,16067,70,NULL,NULL,'2MASX J08265421+5240424',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000082,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,126.725708333,52.67858,0.141,NULL,63492335373,992067740,15501058,16.8),(54482,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54482,37.45,0.46,310,16068,70,NULL,NULL,'2MASX J08265421+1027268',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,126.725833,10.45744,0.101,NULL,62566227285,977597301,15274957,17.4),(54483,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54483,37.94,0.46,387,16069,70,NULL,NULL,'SDSS J082654.93+433259.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000128,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,126.728916667,43.54975,0.141,NULL,64253807640,1003965744,15686964,18.8),(54484,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54484,37.28,0.46,286,16070,70,NULL,NULL,'2MASX J08265635+1157338',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,126.734875,11.95933,0.097,NULL,63653018258,994578410,15540287,17.5),(54485,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54485,37.22,0.46,278,16071,70,NULL,NULL,'2MASX J08265728+1927436',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000165,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,126.738625,19.46217,0.165,NULL,63806445135,996975705,15577745,17.9),(54486,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54486,37.92,0.27,384,16072,70,NULL,NULL,'2MASX J08265744+1808316',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000179,NULL,'16.3g',0.38,'BrClG',NULL,NULL,NULL,NULL,1,126.739333333,18.14214,0.129,NULL,63775525914,996492592,15570196,16.3),(54487,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54487,36.01,0.46,160,16073,70,NULL,NULL,'2MASX J08265818+3610428',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000175,NULL,'15.9g',0.34,'S0',NULL,NULL,NULL,NULL,1,126.742333,36.17844,0.153,NULL,64337492649,1005273322,15707395,15.9),(54488,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54488,37.74,0.46,353,16074,70,NULL,NULL,'2MASX J08265864+1528555',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,126.74425,15.48217,0.113,NULL,63785514960,996648671,15572635,17.1),(54489,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54489,37.94,0.46,387,16075,70,NULL,NULL,'2MASX J08265871+1756506',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,126.744541667,17.94742,0.117,NULL,63776415281,996506488,15570413,17.7),(54490,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54490,37.96,0.46,390,16076,70,NULL,NULL,'2MASX J08265991+2857272',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000222,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,126.749666667,28.95775,0.073,NULL,64354449806,1005538278,15711535,17.1),(54491,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54491,36.01,0.46,159,16077,70,NULL,NULL,'2MASX J08270029+5352194',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,126.75125,53.87214,0.113,NULL,63492283543,992066930,15501045,16.3),(54492,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54492,36.97,0.46,247,16078,70,NULL,NULL,'2MASX J08270073+3103304',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000142,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,126.753167,31.05828,0.117,NULL,64343993427,1005374897,15708982,17.6),(54493,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54493,37.65,0.46,338,16079,70,NULL,NULL,'2MASX J08270088+1216111',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,126.7537083,12.26983,0.093,NULL,63837540097,997461564,15585336,17),(54494,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54494,38.27,0.33,450,16080,70,NULL,NULL,'2MASX J08270259+1244241',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,126.7607083,12.74003,0.097,NULL,63837502230,997460972,15585327,18),(54495,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54495,38.04,0.27,405,16081,70,NULL,NULL,'SDSS J082703.13+043010.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00013,NULL,'18.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,126.763083,4.50297,0.049,NULL,62597498988,978085921,15282592,18.1),(54496,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54496,36.38,0.46,189,16082,70,NULL,NULL,'2MASX J08270433+5112414',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000071,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,126.7680417,51.21169,0.137,NULL,63498519658,992164369,15502568,17.3),(54497,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 2005mc',NULL,54497,34.63,0.18,82.3,16083,74.2,NULL,'SALT 2','UGC 04414',0.025221,'2010ApJ...716..712A',2010,1,1.21,NULL,'G',0.000033,NULL,'14.3g',1.04,'S0a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,126.774833,21.64528,0.113,NULL,63818882303,997170035,15580781,14.3),(54498,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 2005mc',NULL,54498,35.25,0.17,109,16083,70,NULL,'SALT 2','UGC 04414',0.025221,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54499,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 2005mc',NULL,54499,35.26,0.2,110,16083,73.8,NULL,'SALT 2 (SNANA)','UGC 04414',0.0263,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54500,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 2005mc',NULL,54500,35.26,0.23,110,16083,73.8,NULL,'SALT 2 (SNANA)','UGC 04414',0.0264,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54501,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 2005mc',NULL,54501,35.25,0.09,112,16083,74.4,NULL,NULL,'UGC 04414',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54502,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 2005mc',NULL,54502,35.36,0.17,115,16083,65,NULL,'MLCS31','UGC 04414',0.025221,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54503,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 2005mc',NULL,54503,35.43,0.16,119,16083,65,NULL,'MLCS17','UGC 04414',0.025221,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54504,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 2005mc',NULL,54504,35.52,0.18,124,16083,65,NULL,'SALT','UGC 04414',0.025221,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54505,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 2005mc',NULL,54505,35.6,0.2,128,16083,65,NULL,'SALT2','UGC 04414',0.025221,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54506,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54506,37.7,0.27,347,16084,70,NULL,NULL,'2MASX J08270674+1659131',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,126.778166667,16.98711,0.149,NULL,63786215085,996659610,15572806,17.3),(54507,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54507,36.57,0.27,206,16085,70,NULL,NULL,'2MASX J08270698+1759196',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000181,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,126.779083,17.98872,0.117,NULL,63776414003,996506468,15570413,16.6),(54508,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54508,38.26,0.46,449,16086,70,NULL,NULL,'2MASXi J0827071+150335',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000137,NULL,'18.0g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,126.7800417,15.05972,0.125,NULL,63771719324,996433114,15569267,18),(54509,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54509,37.34,0.46,293,16087,70,NULL,NULL,'2MASX J08270745+1506241',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000174,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,126.781167,15.10664,0.125,NULL,63771718206,996433096,15569267,16.8),(54510,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54510,36.57,0.27,206,16088,70,NULL,NULL,'2MASX J08270782+1758080',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000195,NULL,'15.6g',0.44,NULL,NULL,NULL,NULL,NULL,1,126.782541667,17.96897,0.117,NULL,63776415617,996506494,15570413,15.6),(54511,'SBF','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54511,32.05,0.43,25.7,16089,NULL,NULL,'I','NGC 2592',NULL,'2001ApJ...546..681T',2001,1,1.7,NULL,'G',0.000017,NULL,'13.28',1.4,'E','Group non-member, foreground',NULL,NULL,NULL,1,126.783541667,25.97031,0.121,NULL,64316178584,1004940290,15702192,13.28),(54512,'SBF','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54512,32.1,0.14,26.3,16089,74.4,NULL,NULL,'NGC 2592',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54513,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54513,33.06,0.4,40.8,16089,NULL,NULL,'mean','NGC 2592',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54514,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54514,34.26,0.45,71,16089,NULL,NULL,'K','NGC 2592',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54515,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54515,37.5,0.46,316,16090,70,NULL,NULL,'2MASX J08270861+3420573',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000175,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,126.786083,34.34942,0.141,NULL,64335569072,1005243266,15706926,16.8),(54516,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54516,37.52,0.17,319,16091,70,NULL,NULL,'2MASX J08270871+1726270',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,126.7864583,17.44078,0.097,NULL,63783407477,996615741,15572120,17.2),(54517,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54517,37.7,0.27,347,16092,70,NULL,NULL,'2MASX J08270883+1650000',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000173,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,126.786875,16.83344,0.137,NULL,63786241404,996660021,15572812,16.9),(54518,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54518,37.08,0.46,261,16093,70,NULL,NULL,'2MASX J08271017+2027356',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,126.792208333,20.45983,0.125,NULL,63819511338,997179864,15580935,17.4),(54519,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54519,37.16,0.46,270,16094,70,NULL,NULL,'2MASXi J0827112+402731',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000174,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,126.796875,40.45886,0.133,NULL,64241565912,1003774467,15683976,17.3),(54520,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54520,37.41,0.46,304,16095,70,NULL,NULL,'2MASX J08271203+1410080',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,126.8002083,14.16889,0.121,NULL,63774113058,996470516,15569851,17.2),(54521,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54521,36.27,0.33,180,16096,70,NULL,NULL,'2MASX J08271310+3553103',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000176,NULL,'15.8g',0.43,'E0',NULL,NULL,NULL,NULL,1,126.8045417,35.88633,0.157,NULL,64333310799,1005207981,15706374,15.8),(54522,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54522,37,0.54,251,16097,NULL,NULL,'Malmquist cor.','2MASX J08271349+2558021',NULL,'2009ApJS..182..474S',2009,1,0.59,NULL,'G',0.00001,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,126.806083,25.96725,0.121,NULL,64316178531,1004940289,15702192,17.6),(54523,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54523,37.26,0.48,283,16097,NULL,NULL,NULL,'2MASX J08271349+2558021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54524,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54524,37.3,0.2,288,16097,74.4,NULL,NULL,'2MASX J08271349+2558021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54525,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54525,37.7,0.46,346,16098,70,NULL,NULL,'2MASX J08271372+2807231',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000149,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,126.807083,28.12303,0.069,NULL,64350935772,1005483371,15710677,17.1),(54526,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54526,37.49,0.46,315,16099,70,NULL,NULL,'2MASX J08271500+4708194',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000081,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,126.812416667,47.13861,0.117,NULL,63523192335,992549880,15508591,17.5),(54527,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54527,38.15,0.21,426,16100,70,NULL,NULL,'2MASX J08271539+1559150',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,126.8142917,15.98744,0.117,NULL,63785689743,996651402,15572678,17.4),(54528,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54528,35.76,0.46,142,16101,70,NULL,NULL,'2MASX J08271599+5620124',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000162,NULL,'15.7g',0.5,NULL,NULL,NULL,NULL,NULL,1,126.8164583,56.33689,0.137,NULL,61552256968,961754015,15027406,15.7),(54529,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54529,37.67,0.46,341,16102,70,NULL,NULL,'2MASX J08271669+1449320',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000146,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,126.8194583,14.82558,0.137,NULL,63772070090,996438595,15569353,17.8),(54530,'IRAS','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54530,34.46,0.8,78,16103,75,NULL,'W91CL, r','UGC 04416',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000004,NULL,'13.75',1,'SB(s)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,126.8199583,22.87758,0.165,NULL,63810543576,997039743,15578745,13.75),(54531,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54531,33.81,0.38,57.9,16103,75,NULL,'W91CL, r, raw','UGC 04416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54532,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54532,33.97,0.2,62.2,16103,74.4,NULL,NULL,'UGC 04416',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54533,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54533,33.97,0.38,62.3,16103,75,NULL,'W91CL, r, inv','UGC 04416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54534,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54534,34.14,0.38,67.4,16103,75,NULL,'W91CL, r, cor','UGC 04416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54535,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54535,34.5,0.47,79.4,16103,NULL,NULL,'H','UGC 04416',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54536,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54536,34.6,0.46,83.3,16103,NULL,NULL,'J','UGC 04416',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54537,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54537,34.6,0.45,83.3,16103,NULL,NULL,'K','UGC 04416',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54538,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54538,34.7,0.4,87.2,16103,NULL,NULL,'mean','UGC 04416',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54539,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54539,34.97,0.07,98.8,16103,NULL,NULL,NULL,'UGC 04416',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54540,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54540,37.22,0.21,278,16104,70,NULL,NULL,'2MASX J08271711+4103138',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000178,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,126.82125,41.05394,0.161,NULL,64243963119,1003811923,15684561,16.7),(54541,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54541,34.65,0.49,85.1,16105,75,NULL,'IR','UGC 04412',NULL,'2011yCatp016004901K',2011,1,1.24,NULL,'G',0.000108,NULL,'15.1g',0.31,'Sc',NULL,NULL,NULL,NULL,1,126.826417,37.78125,0.101,NULL,64359273510,1005613648,15712713,15.1),(54542,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54542,37.16,0.27,270,16106,70,NULL,NULL,'2MASX J08272068+3659117',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000167,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,126.836167,36.98664,0.209,NULL,64358658523,1005604039,15712563,16.9),(54543,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54543,37.39,0.46,300,16107,70,NULL,NULL,'2MASX J08272078+3009113',NULL,'2015arXiv151105856S',2015,1,0.16,'SDSS DR3 gives z = 0.1043 +/- 0.00013.','G',0.000047,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,126.836583333,30.15303,0.101,NULL,64343353107,1005364892,15708826,18.5),(54544,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54544,38.15,0.21,426,16108,70,NULL,NULL,'SDSS J082721.12+155805.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000152,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,126.838,15.96819,0.117,NULL,63785692326,996651442,15572678,18.6),(54545,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54545,37.87,0.46,375,16109,70,NULL,NULL,'SDSS J082721.66+480305.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000074,NULL,'18.2g',0.12,'NLAGN',NULL,NULL,NULL,NULL,1,126.8402917,48.05153,0.145,NULL,63540353202,992818018,15512781,18.2),(54546,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54546,37.52,0.17,319,16110,70,NULL,NULL,'2MASX J08272179+1732390',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,126.840833,17.54406,0.129,NULL,63775866545,996497914,15570279,17.2),(54547,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54547,37.86,0.46,373,16111,70,NULL,NULL,'2MASX J08272231+2018417',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000188,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,126.8429583,20.3115,0.125,NULL,63819486241,997179472,15580929,17),(54548,'IRAS','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54548,34.35,0.8,74,16112,75,NULL,'HMCL, I','CGCG 119-107',NULL,'1997ApJS..109..333W',1997,1,0.96,NULL,'G',0.000013,NULL,'15.7g',0.22,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,126.8497083,23.18006,0.109,NULL,63810363899,997036935,15578702,15.7),(54549,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54549,34.56,0.15,81.8,16112,NULL,NULL,NULL,'CGCG 119-107',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54550,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54550,34.91,0.43,95.8,16112,75,NULL,'3.6 micron, color corrected','CGCG 119-107',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54551,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54551,34.93,0.2,96.8,16112,74.4,NULL,NULL,'CGCG 119-107',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54552,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54552,34.95,0.43,97.7,16112,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 119-107',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54553,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54553,34.96,0.49,98.4,16112,75,NULL,'IR','CGCG 119-107',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54554,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54554,35.05,0.4,102,16112,75,NULL,'HMCL, I, raw','CGCG 119-107',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54555,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54555,35.19,0.4,109,16112,75,NULL,'HMCL, I, inv','CGCG 119-107',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54556,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54556,35.21,0.4,110,16112,75,NULL,'HMCL, I, cor','CGCG 119-107',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54557,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54557,37.4,0.46,302,16113,70,NULL,NULL,'SDSS J082725.65+162716.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,126.856917,16.45464,0.121,NULL,63785251340,996644552,15572571,18.3),(54558,'IRAS','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54558,34.59,0.8,83,16114,75,NULL,'W91CL, r','NGC 2596',NULL,'1997ApJS..109..333W',1997,1,1.71,NULL,'G',0.000006,NULL,'14.1g',0.57,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,126.8605,17.28408,0.097,NULL,63783337157,996614643,15572103,14.1),(54559,'IRAS','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54559,34.6,0.8,83.3,16114,75,NULL,'HMCL, I','NGC 2596',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54560,'IRAS','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54560,34.62,0.8,84,16114,75,NULL,'CF, r','NGC 2596',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54561,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54561,34.18,0.4,68.6,16114,75,NULL,'HMCL, I, raw','NGC 2596',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54562,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54562,34.3,0.38,72.6,16114,75,NULL,'W91CL, r, raw','NGC 2596',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54563,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54563,34.39,0.4,75.5,16114,75,NULL,'HMCL, I, inv','NGC 2596',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54564,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54564,34.39,0.4,75.5,16114,75,NULL,'HMCL, I, cor','NGC 2596',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54565,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54565,34.47,0.38,78.2,16114,75,NULL,'W91CL, r, cor','NGC 2596',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54566,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54566,34.47,0.38,78.3,16114,75,NULL,'W91CL, r, inv','NGC 2596',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54567,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54567,34.59,0.2,82.8,16114,74.4,NULL,NULL,'NGC 2596',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54568,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54568,34.62,0.38,83.8,16114,75,NULL,'CF, r, raw','NGC 2596',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54569,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54569,34.72,0.47,87.8,16114,NULL,NULL,'H','NGC 2596',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54570,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54570,34.75,0.45,89.3,16114,NULL,NULL,'K','NGC 2596',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54571,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54571,34.8,0.4,91.3,16114,NULL,NULL,'mean','NGC 2596',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54572,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54572,34.81,0.38,91.4,16114,75,NULL,'CF, r, inv','NGC 2596',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54573,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54573,34.81,0.38,91.5,16114,75,NULL,'CF, r, cor','NGC 2596',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54574,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54574,34.83,0.46,92.6,16114,NULL,NULL,'J','NGC 2596',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54575,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54575,34.87,0.12,94.4,16114,NULL,NULL,NULL,'NGC 2596',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54576,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54576,38.15,0.21,426,16115,70,NULL,NULL,'2MASX J08272669+1559580',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000206,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,126.8612083,15.99947,0.117,NULL,63785692062,996651438,15572678,16.7),(54577,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54577,38.06,0.46,409,16116,70,NULL,NULL,'2MASX J08272752+5053384',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000076,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,126.864583,50.89397,0.133,NULL,63497648078,992150751,15502355,17.6),(54578,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54578,32.73,0.2,35.2,16117,74.4,NULL,NULL,'UGC 04418',NULL,'2013AJ....146...86T',2013,1,0.99,NULL,'G',0.000007,NULL,'15.8g',0.39,'Sd',NULL,NULL,NULL,NULL,1,126.865333,25.72442,0.121,NULL,64316484021,1004945062,15702266,15.8),(54579,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54579,33.24,0.65,44.4,16117,NULL,NULL,NULL,'UGC 04418',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54580,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54580,33.64,0.54,53.6,16117,NULL,NULL,'Malmquist cor.','UGC 04418',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54581,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54581,37.91,0.46,382,16118,70,NULL,NULL,'2MASX J08272890+3815198',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000161,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,126.8704583,38.2555,0.097,NULL,64360688179,1005635752,15713058,16.8),(54582,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54582,36.27,0.33,180,16119,70,NULL,NULL,'2MASX J08272945+3600218',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000099,NULL,'16.5g',0.26,'AGN+HII',NULL,NULL,NULL,NULL,1,126.872875,36.00614,0.157,NULL,64333289292,1005207645,15706369,16.5),(54583,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54583,37.16,0.46,271,16120,70,NULL,NULL,'2MASX J08273043+2438411',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,126.877,24.64475,0.085,NULL,63792042410,996750662,15574229,17.4),(54584,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54584,37.64,0.46,337,16121,70,NULL,NULL,'2MASX J08273075+2202417',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,126.8780417,22.04492,0.133,NULL,63810949743,997046089,15578845,17.5),(54585,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54585,38.03,0.46,404,16122,70,NULL,NULL,'2MASX J08273082+4037068',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000136,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,126.8785,40.61872,0.133,NULL,64241689787,1003776402,15684006,18),(54586,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54586,35.82,0.46,146,16123,70,NULL,NULL,'CGCG 263-031',NULL,'2015arXiv151105856S',2015,1,0.88,NULL,'G',0.00008,NULL,'14.7g',0.67,NULL,NULL,NULL,NULL,NULL,1,126.878833,54.90467,0.129,NULL,61549275417,961707428,15026678,14.7),(54587,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54587,34.88,0.53,94.8,16124,70,NULL,NULL,'CGCG 004-030',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000107,NULL,'15.5',0.4,NULL,NULL,NULL,NULL,NULL,1,126.885833,-1.55967,0.109,NULL,39219364334,612802567,9575040,15.5),(54588,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54588,36.71,0.46,220,16125,70,NULL,NULL,'2MASX J08273292+4532481',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000105,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,126.887167,45.54664,0.161,NULL,63526198905,992596857,15509325,16.2),(54589,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54589,37.96,0.19,391,16126,70,NULL,NULL,'2MASX J08273338+2816561',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,126.889083333,28.28211,0.069,NULL,64350225250,1005472269,15710504,18.2),(54590,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54590,38.15,0.21,426,16127,70,NULL,NULL,'2MASX J08273364+1600542',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000188,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,126.890125,16.01492,0.113,NULL,63785722934,996651920,15572686,16.5),(54591,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54591,37.45,0.46,310,16128,70,NULL,NULL,'2MASX J08273408+1947327',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,126.8920417,19.79228,0.129,NULL,63806606254,996978222,15577784,18.1),(54592,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54592,39.12,0.46,667,16129,70,NULL,NULL,'SDSS J082735.36+575208.6',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,126.897375,57.86908,0.157,NULL,61546846964,961669483,15026085,NULL),(54593,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54593,37.68,0.46,343,16130,70,NULL,NULL,'2MASX J08273643+3333183',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000141,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,126.9017083,33.55492,0.157,NULL,64336356774,1005255574,15707118,17.1),(54594,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54594,38.2,0.46,436,16131,70,NULL,NULL,'SDSS J082736.60+390209.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000143,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,126.9025417,39.03597,0.097,NULL,64361488943,1005648264,15713254,18),(54595,'SNII optical','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 2002hx',NULL,54595,35.38,0.08,119,16132,NULL,NULL,'I, photospheric magnitude method','2MASX J08273975-1446551',NULL,'2014AJ....148..107R',2014,1,1.6,NULL,'G',0.000037,NULL,'15.6b',0.8,'SB(r)b?',NULL,NULL,NULL,NULL,1,126.915625,-14.78197,0.193,NULL,42247976685,660124635,10314447,15.6),(54596,'SNII optical','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 2002hx',NULL,54596,35.45,0.54,123,16132,NULL,NULL,'SCM, I','2MASX J08273975-1446551',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54597,'SNII optical','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 2002hx',NULL,54597,35.49,0.28,125,16132,NULL,NULL,'SCM, BVI','2MASX J08273975-1446551',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54598,'SNII optical','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 2002hx',NULL,54598,35.49,0.42,125,16132,NULL,NULL,'SCM, B','2MASX J08273975-1446551',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54599,'SNII optical','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 2002hx',NULL,54599,35.5,0.17,126,16132,NULL,NULL,'V, photospheric magnitude method','2MASX J08273975-1446551',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54600,'SNII optical','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 2002hx',NULL,54600,35.53,0.54,128,16132,NULL,NULL,'SCM, V','2MASX J08273975-1446551',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54601,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 1999aa',NULL,54601,33.43,0.16,47.8,16133,74.2,NULL,'SALT 2','NGC 2595',0.01444,'2010ApJ...716..712A',2010,1,1.65,NULL,'G',0.000013,NULL,'13.7g',1.33,'SAB(rs)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,126.925083333,21.47911,0.113,NULL,63819371959,997177686,15580901,13.7),(54602,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 1999aa',NULL,54602,33.61,0.02,51.9,16133,70,NULL,'SALT 2','NGC 2595',0.01444,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54603,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 1999aa',NULL,54603,34.04,0.08,64.3,16133,74.4,NULL,NULL,'NGC 2595',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54604,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 1999aa',NULL,54604,34.06,0.17,64.9,16133,70.8,NULL,NULL,'NGC 2595',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54605,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 1999aa',NULL,54605,34.1,0.15,65.1,16133,70,NULL,'SALT','NGC 2595',0.01444,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54606,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 1999aa',NULL,54606,34.2,0.19,68.2,16133,72,NULL,NULL,'NGC 2595',0.01444,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54607,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 1999aa',NULL,54607,34.21,0.2,68.4,16133,70,NULL,'SALT 2','NGC 2595',0.01444,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54608,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 1999aa',NULL,54608,34.22,0.02,68.7,16133,72,NULL,NULL,'NGC 2595',0.01444,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54609,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 1999aa',NULL,54609,34.27,0.22,70.4,16133,65,NULL,'SALT','NGC 2595',0.01444,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54610,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 1999aa',NULL,54610,34.28,0.24,70.7,16133,65,NULL,'SALT2','NGC 2595',0.01444,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54611,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 1999aa',NULL,54611,34.43,0.21,75.6,16133,65,NULL,'MLCS17','NGC 2595',0.01444,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54612,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 1999aa',NULL,54612,34.47,0.04,76.1,16133,65,NULL,'MLCS2k2','NGC 2595',0.01444,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54613,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 1999aa',NULL,54613,34.46,0.2,76.9,16133,65,NULL,'MLCS31','NGC 2595',0.01444,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54614,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 1999aa',NULL,54614,34.53,0.16,79.4,16133,70,NULL,NULL,'NGC 2595',0.01444,'2000ApJ...539..658K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54615,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 1999aa',NULL,54615,34.53,0.3,80.5,16133,60,NULL,NULL,'NGC 2595',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54616,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 1999aa',NULL,54616,34.58,0.24,81.1,16133,65,NULL,NULL,'NGC 2595',0.01444,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54617,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 1999aa',NULL,54617,35.4,0.2,119,16133,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','NGC 2595',0.01444,'2011A&A...526A..81B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54618,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54618,34.07,0.4,65,16133,NULL,NULL,'mean','NGC 2595',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54619,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54619,34.25,0.11,70.9,16133,NULL,NULL,NULL,'NGC 2595',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54620,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54620,34.38,0.46,75.3,16133,NULL,NULL,'J','NGC 2595',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54621,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54621,34.41,0.45,76.1,16133,NULL,NULL,'K','NGC 2595',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54622,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54622,34.44,0.47,77.1,16133,NULL,NULL,'H','NGC 2595',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54623,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54623,37.7,0.27,347,16134,70,NULL,NULL,'2MASX J08274225+1640242',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,126.926083,16.67353,0.137,NULL,63785159070,996643110,15572548,17.2),(54624,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54624,37.74,0.46,354,16135,70,NULL,NULL,'2MASX J08274324+2508571',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,126.9302083,25.14922,0.117,NULL,64316389582,1004943587,15702243,17.8),(54625,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54625,37.71,0.23,349,16136,70,NULL,NULL,'2MASX J08274458+2433311',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000146,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,126.935917,24.55861,0.097,NULL,63792209363,996753271,15574269,17.8),(54626,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54626,38.21,0.21,439,16137,70,NULL,NULL,'2MASX J08274478+1749442',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000139,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,126.936667,17.82903,0.117,NULL,63776384776,996506012,15570406,17.8),(54627,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54627,38.15,0.21,426,16138,70,NULL,NULL,'2MASX J08274606+1559382',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,126.941916667,15.99394,0.113,NULL,63785686846,996651356,15572677,17.5),(54628,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54628,38.16,0.46,429,16139,70,NULL,NULL,'SDSS J082747.25+504029.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000075,NULL,'18.7g',0.09,NULL,NULL,NULL,NULL,NULL,1,126.946917,50.67481,0.137,NULL,63496331019,992130172,15502033,18.7),(54629,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54629,36.49,0.46,199,16140,70,NULL,NULL,'2MASX J08274824+1506232',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000186,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,126.950875,15.10644,0.125,NULL,63771674401,996432412,15569256,16.4),(54630,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54630,38.58,0.46,521,16141,70,NULL,NULL,'SDSS J082748.33+294809.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000134,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,126.951417,29.80264,0.097,NULL,64343313173,1005364268,15708816,18.8),(54631,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54631,37.88,0.46,377,16142,70,NULL,NULL,'2MASX J08274875+3055042',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'17.2g',0.24,NULL,'Group member',NULL,NULL,NULL,1,126.953,30.91792,0.121,NULL,64344022716,1005375354,15708989,17.2),(54632,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54632,37.96,0.19,391,16143,70,NULL,NULL,'2MASX J08275042+2819399',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,126.959917,28.32792,0.069,NULL,64350259097,1005472798,15710512,17.4),(54633,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54633,38,0.27,397,16144,70,NULL,NULL,'2MASX J08275045+2645459',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,126.9602083,26.76286,0.121,NULL,64318926929,1004983233,15702863,18.2),(54634,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54634,36.21,0.46,175,16145,70,NULL,NULL,'2MASX J08275072+1103276',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',NULL,NULL,'15.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,126.961375,11.05778,0.085,NULL,62563006468,977546976,15274171,15.9),(54635,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54635,37.57,0.46,327,16146,70,NULL,NULL,'2MASX J08275077+3756268',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000019,NULL,'17.9g',0.11,NULL,NULL,NULL,NULL,NULL,1,126.961583,37.94081,0.117,NULL,64358838049,1005606844,15712606,17.9),(54636,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54636,37.54,0.33,322,16147,70,NULL,NULL,'2MASX J08275133+4811536',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000083,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,126.964083,48.19825,0.145,NULL,63539869620,992810462,15512663,17.4),(54637,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54637,32.62,0.4,33.5,16148,75,NULL,'B','UGC 04390',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.00002,NULL,'14.9',1.6,'SBd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,126.965,73.51694,0.061,NULL,62177963544,971530680,15180166,14.9),(54638,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54638,37.54,0.46,323,16149,70,NULL,NULL,'2MASX J08275172+0221355',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,126.965583,2.35983,0.161,NULL,62592452472,978007069,15281360,17.4),(54639,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54639,38.39,0.46,477,16150,70,NULL,NULL,'SDSS J082752.17+320823.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000134,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,126.967417,32.13975,0.117,NULL,64342411074,1005350173,15708596,18.2),(54640,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54640,37.61,0.46,332,16151,70,NULL,NULL,'2MASX J08275287+2605019',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,'Post Starburst (E+A) or (a+k) Galaxy',1,126.970167,26.08403,0.101,NULL,64316156795,1004939949,15702186,18.1),(54641,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54641,37.6,0.46,332,16152,70,NULL,NULL,'2MASXi J0827536+335810',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,126.973417,33.96953,0.121,NULL,64336263871,1005254122,15707095,17.5),(54642,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54642,38.21,0.21,439,16153,70,NULL,NULL,'2MASX J08275373+1739082',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.22,'BrClG',NULL,NULL,NULL,NULL,1,126.9737917,17.65242,0.149,NULL,63775875732,996498058,15570282,17.5),(54643,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54643,37.96,0.19,391,16154,70,NULL,NULL,'SDSS J082754.02+281404.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,126.975083333,28.23461,0.069,NULL,64350239794,1005472496,15710507,18.3),(54644,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54644,37.81,0.46,364,16155,70,NULL,NULL,'2MASX J08275799+2800220',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000194,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,126.9917917,28.006,0.101,NULL,64350920193,1005483128,15710673,16.5),(54645,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54645,37.9,0.46,379,16156,70,NULL,NULL,'2MASX J08275856+3637119',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,126.994083333,36.62,0.117,NULL,64358478148,1005601221,15712519,17.5),(54646,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54646,37.28,0.46,286,16157,70,NULL,NULL,'2MASX J08275936+2914340',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000174,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,126.997333,29.24292,0.085,NULL,64354341493,1005536585,15711509,16.7),(54647,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54647,37.98,0.46,394,16158,70,NULL,NULL,'SDSS J082759.72+035103.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000123,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,126.998875,3.85103,0.041,NULL,62597792402,978090506,15282664,18.4),(54648,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54648,32.77,0.2,35.8,16159,74.4,NULL,NULL,'UGC 04415',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000005,NULL,'15.0g',0.64,'SB(s)d',NULL,NULL,NULL,NULL,1,127.008,54.44703,0.113,NULL,63491345789,992052277,15500816,15),(54649,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54649,36.47,0.11,197,16160,70,NULL,NULL,'2MASX J08280238+3011302',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000188,NULL,'17.1g',0.18,NULL,'Group member',NULL,NULL,NULL,1,127.01,30.19175,0.101,NULL,64343453231,1005366456,15708850,17.1),(54650,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54650,37.07,0.46,260,16161,70,NULL,NULL,'2MASX J08280250+5544069',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,127.0105,55.73517,0.137,NULL,61555143974,961799124,15028111,17.6),(54651,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54651,38.06,0.46,409,16162,70,NULL,NULL,'2MASX J08280377+1041316',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,127.015625,10.69203,0.097,NULL,62562799165,977543736,15274120,17.5),(54652,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54652,37.96,0.19,391,16163,70,NULL,NULL,'2MASX J08280465+2816189',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,127.019333,28.27206,0.069,NULL,64350233987,1005472406,15710506,17.4),(54653,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54653,36.96,0.46,247,16164,70,NULL,NULL,'2MASX J08280561+3004172',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000191,NULL,'18.1g',0.17,NULL,'Group member',NULL,NULL,NULL,1,127.023333,30.07142,0.101,NULL,64343331876,1005364560,15708821,18.1),(54654,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54654,36.47,0.11,197,16165,70,NULL,NULL,'2MASX J08280564+3027082',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000168,NULL,'16.2g',0.39,'E0','Group member',NULL,NULL,NULL,1,127.0235417,30.45214,0.109,NULL,64343466492,1005366663,15708854,16.2),(54655,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54655,38.21,0.46,439,16166,70,NULL,NULL,'2MASX J08280653+3218492',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000133,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,127.027125,32.31375,0.117,NULL,64342251653,1005347682,15708557,18.3),(54656,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54656,37.47,0.33,312,16167,70,NULL,NULL,'2MASX J08280654+5522479',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000183,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,127.02725,55.37986,0.133,NULL,61553003794,961765684,15027588,17.4),(54657,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54657,38,0.27,397,16168,70,NULL,NULL,'2MASX J08280659+2654429',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000171,NULL,'16.5g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,127.0275,26.91183,0.085,NULL,64317842345,1004966286,15702598,16.5),(54658,'IRAS','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54658,33.93,0.8,61.1,16169,75,NULL,'W91CL, r','UGC 04424',NULL,'1997ApJS..109..333W',1997,1,1.13,NULL,'G',0.000004,NULL,'16.2g',0.24,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,127.0314583,20.26214,0.125,NULL,63818960224,997171253,15580800,16.2),(54659,'IRAS','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54659,33.95,0.8,61.6,16169,75,NULL,'HMCL, I','UGC 04424',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54660,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54660,34.08,0.13,65.6,16169,NULL,NULL,NULL,'UGC 04424',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54661,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54661,34.1,0.4,66.1,16169,75,NULL,'HMCL, I, raw','UGC 04424',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54662,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54662,34.13,0.2,67,16169,74.4,NULL,NULL,'UGC 04424',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54663,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54663,34.13,0.4,67.1,16169,75,NULL,'HMCL, I, inv','UGC 04424',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54664,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54664,34.28,0.38,71.9,16169,75,NULL,'W91CL, r, inv','UGC 04424',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54665,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54665,34.28,0.43,71.9,16169,75,NULL,'3.6 micron, color corrected','UGC 04424',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54666,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54666,34.3,0.38,72.5,16169,75,NULL,'W91CL, r, raw','UGC 04424',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54667,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54667,34.35,0.4,74.1,16169,75,NULL,'HMCL, I, cor','UGC 04424',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54668,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54668,34.45,0.43,77.6,16169,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04424',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54669,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54669,34.47,0.38,78.2,16169,75,NULL,'W91CL, r, cor','UGC 04424',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54670,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54670,35.12,0.48,106,16170,70,NULL,NULL,'UGC 04430',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000147,NULL,'14.88',0.6,'S0/a',NULL,NULL,NULL,NULL,1,127.033291667,-1.53864,0.081,NULL,39219372182,612802690,9575042,14.88),(54671,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54671,38.52,0.33,506,16171,70,NULL,NULL,'SDSS J082808.76+320850.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000142,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,127.0365,32.14744,0.117,NULL,64342232247,1005347378,15708552,18.2),(54672,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54672,35.13,0.46,106,16172,70,NULL,NULL,'2MASX J08280883+2605419',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000163,NULL,'15.6g',0.48,'S0',NULL,NULL,NULL,NULL,1,127.0367917,26.09497,0.101,NULL,64316177350,1004940271,15702191,15.6),(54673,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54673,38.25,0.46,448,16173,70,NULL,NULL,'2MASX J08280992+1156294',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.3E',NULL,NULL,NULL,NULL,NULL,NULL,1,127.041375,11.94147,0.097,NULL,63652936228,994577128,15540267,16.3),(54674,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54674,36.02,0.45,160,16174,NULL,NULL,NULL,'SDSS J082809.98+302351.9',NULL,'2009ApJS..182..474S',2009,1,0.44,NULL,'G',0.00003,NULL,'17.1g',0.17,'Scd','Group member',NULL,NULL,NULL,1,127.041583333,30.39775,0.109,NULL,64343499602,1005367181,15708862,17.1),(54675,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54675,36.07,0.2,164,16174,74.4,NULL,NULL,'SDSS J082809.98+302351.9',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54676,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54676,36.08,0.44,164,16174,NULL,NULL,'Malmquist cor.','SDSS J082809.98+302351.9',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54677,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54677,37.82,0.46,366,16175,70,NULL,NULL,'2MASX J08281088+1250464',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,127.045375,12.84619,0.129,NULL,63838211027,997472047,15585500,16.8),(54678,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54678,36.22,0.46,176,16176,70,NULL,NULL,'2MASX J08281125+0809076',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.0001,NULL,'15.5g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,127.046958333,8.15225,0.149,NULL,62578910926,977795483,15278054,15.5),(54679,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54679,37.19,0.46,274,16177,70,NULL,NULL,'2MASX J08281162-0010551',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,127.048458333,-0.18189,0.145,NULL,39217977389,612780896,9574701,17.2),(54680,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54680,37.96,0.19,391,16178,70,NULL,NULL,'2MASX J08281224+2823229',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000164,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,127.051083,28.38961,0.093,NULL,64350263223,1005472862,15710513,17.2),(54681,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54681,37.71,0.23,349,16179,70,NULL,NULL,'2MASX J08281545+2438209',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,127.0642917,24.63917,0.097,NULL,63792056530,996750883,15574232,17.3),(54682,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54682,38.52,0.33,506,16180,70,NULL,NULL,'2MASX J08281578+3207532',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,127.06575,32.13156,0.117,NULL,64342230571,1005347352,15708552,17.3),(54683,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54683,37.71,0.23,349,16181,70,NULL,NULL,'2MASX J08281604+2441169',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,127.067,24.68803,0.097,NULL,63792069835,996751091,15574235,17.8),(54684,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54684,38.29,0.46,455,16182,70,NULL,NULL,'2MASX J08281626+1443414',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000199,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,127.067833333,14.72825,0.137,NULL,63772062268,996438472,15569351,17),(54685,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54685,34.42,0.2,76.6,16183,74.4,NULL,NULL,'KUG 0825+222',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000021,NULL,'16.5g',0.16,'Sbc',NULL,NULL,NULL,NULL,1,127.068083,22.03475,0.133,NULL,63810956777,997046199,15578846,16.5),(54686,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54686,34.45,0.43,77.6,16183,75,NULL,'3.6 micron, color corrected','KUG 0825+222',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54687,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54687,34.47,0.43,78.4,16183,75,NULL,'3.6 micron, color + selection bias corrected','KUG 0825+222',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54688,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54688,34.6,0.12,83.3,16183,NULL,NULL,NULL,'KUG 0825+222',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54689,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54689,34.97,0.49,98.5,16183,75,NULL,'IR','KUG 0825+222',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54690,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54690,36.87,0.46,237,16184,70,NULL,NULL,'2MASX J08281652+1845452',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000179,NULL,'16.1g',0.38,NULL,NULL,NULL,NULL,NULL,1,127.068875,18.76269,0.185,NULL,63806779668,996980932,15577827,16.1),(54691,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54691,37.98,0.46,395,16185,70,NULL,NULL,'2MASX J08281706+1650414',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00017,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,127.070958333,16.84492,0.137,NULL,63785148219,996642940,15572545,17.9),(54692,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54692,38.33,0.33,463,16186,70,NULL,NULL,'2MASX J08281714+0609226',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,127.071375,6.15622,0.065,NULL,62568333872,977630216,15275472,17.8),(54693,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54693,37.01,0.46,253,16187,70,NULL,NULL,'2MASX J08281768+1707254',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000123,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,127.073625,17.12381,0.149,NULL,63775712314,996495504,15570242,18),(54694,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54694,38.31,0.46,459,16188,70,NULL,NULL,'2MASX J08281889+1240454',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,127.0787083,12.67942,0.125,NULL,63838293889,997473342,15585520,17.8),(54695,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54695,37.6,0.23,331,16189,70,NULL,NULL,'2MASX J08281900+3246462',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000148,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,127.079167,32.7795,0.149,NULL,64334619591,1005228431,15706694,16.9),(54696,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54696,36.91,0.33,241,16190,70,NULL,NULL,'2MASX J08281952+2122492',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000197,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,127.08125,21.38036,0.141,NULL,63819423596,997178493,15580913,16.3),(54697,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54697,37.54,0.33,322,16191,70,NULL,NULL,'2MASX J08281962+4807391',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00008,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,127.081583,48.12761,0.145,NULL,63540333831,992817716,15512776,16.3),(54698,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54698,38.33,0.33,463,16192,70,NULL,NULL,'2MASX J08281977+0606379',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000187,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,127.082416667,6.11042,0.065,NULL,62598283390,978098177,15282784,17.9),(54699,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54699,37.63,0.33,336,16193,70,NULL,NULL,'2MASX J08282175+6048532',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,127.0902083,60.81492,0.125,NULL,62050366089,969536970,15149015,18.2),(54700,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54700,37.67,0.46,342,16194,70,NULL,NULL,'2MASX J08282223+1608094',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,127.092541667,16.13608,0.113,NULL,63785710816,996651731,15572683,18.2),(54701,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54701,37.96,0.19,391,16195,70,NULL,NULL,'2MASX J08282270+2816030',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,'FoF','17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,127.094583,28.26747,0.093,NULL,64350236022,1005472437,15710506,17.9),(54702,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54702,37.13,0.17,266,16196,70,NULL,NULL,'2MASX J08282310+1344244',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,127.0964583,13.74028,0.129,NULL,63770470971,996413608,15568962,17.1),(54703,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54703,36.7,0.46,219,16197,70,NULL,NULL,'2MASX J08282349+1450304',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000182,NULL,'16.0g',0.4,NULL,NULL,NULL,NULL,NULL,1,127.097958333,14.84178,0.137,NULL,63772278879,996441857,15569404,16),(54704,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54704,36.47,0.11,197,16198,70,NULL,NULL,'2MASX J08282365+3022513',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000162,NULL,'16.5g',0.28,NULL,'Group member',NULL,NULL,NULL,1,127.0984583,30.38092,0.109,NULL,64343417242,1005365894,15708842,16.5),(54705,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54705,37.63,0.33,336,16199,70,NULL,NULL,'2MASX J08282375+6053022',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,127.098791667,60.88411,0.125,NULL,62049655802,969525871,15148841,17.6),(54706,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54706,37.64,0.46,338,16200,70,NULL,NULL,'2MASX J08282474+5525198',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000143,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,127.103125,55.42225,0.133,NULL,61553014927,961765858,15027591,17.3),(54707,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54707,37.9,0.46,380,16201,70,NULL,NULL,'2MASX J08282525+2738500',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,127.1052083,27.64719,0.081,NULL,64317952724,1004968011,15702625,17.2),(54708,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54708,37.71,0.23,349,16202,70,NULL,NULL,'2MASX J08282541+2437230',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000209,NULL,'16.8g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,127.10575,24.62306,0.097,NULL,63792187109,996752923,15574264,16.8),(54709,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54709,35.49,0.46,125,16203,70,NULL,NULL,'CGCG 208-005',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.000163,NULL,'14.9g',0.48,'E0',NULL,NULL,NULL,NULL,1,127.106375,40.63058,0.145,NULL,64241726826,1003776981,15684015,14.9),(54710,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54710,37.13,0.17,266,16204,70,NULL,NULL,'2MASX J08282592+1342144',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,127.108125,13.70406,0.129,NULL,63770472213,996413628,15568962,16.6),(54711,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54711,36.47,0.11,197,16205,70,NULL,NULL,'IC 2376',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000087,NULL,'15.50',0.47,NULL,'Group member',NULL,NULL,NULL,1,127.108875,30.40769,0.117,NULL,64343417718,1005365901,15708842,15.5),(54712,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54712,36.54,0.46,204,16206,70,NULL,NULL,'2MASX J08282626+1735554',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000166,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,127.109583,17.59881,0.149,NULL,63775959231,996499362,15570302,17),(54713,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54713,37.48,0.33,314,16207,70,NULL,NULL,'2MASX J08282638+5242001',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000083,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,127.1099583,52.7,0.141,NULL,63499929252,992186394,15502912,17.3),(54714,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54714,38.3,0.46,456,16208,70,NULL,NULL,'SDSS J082826.84+430207.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,127.111833,43.03531,0.149,NULL,64254547306,1003977301,15687145,18.4),(54715,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54715,36.91,0.33,241,16209,70,NULL,NULL,'2MASX J08282725+2125023',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,127.113583333,21.41725,0.141,NULL,63819422088,997178470,15580913,16.6),(54716,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54716,36.47,0.11,197,16210,70,NULL,NULL,'CGCG 149-029 NED02',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000192,NULL,'16.7g',0.24,NULL,'Group member',NULL,NULL,NULL,1,127.113583333,30.41422,0.117,NULL,64343417468,1005365897,15708842,16.7),(54717,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54717,37.67,0.46,343,16211,70,NULL,NULL,'2MASX J08282817+3649179',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000168,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,127.11725,36.82175,0.121,NULL,64358550442,1005602350,15712536,17.3),(54718,'Brightest Stars','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54718,28.76,0.2,5.6,16212,NULL,NULL,NULL,'UGC 04426',NULL,'1998A&AS..133..181M',1998,1,2,NULL,'G',0.000013,NULL,'15.0',1,'Im:','Field galaxy',NULL,NULL,NULL,1,127.1185,41.85669,0.117,NULL,64243124470,1003798819,15684356,15),(54719,'TRGB','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54719,29.97,0.1,9.86,16212,74.4,NULL,NULL,'UGC 04426',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54720,'TRGB','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54720,30.06,NULL,10.3,16212,NULL,NULL,NULL,'UGC 04426',NULL,'2006AJ....131.1361K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54721,'TRGB','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54721,30.08,0.04,10.4,16212,NULL,NULL,'I','UGC 04426',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54722,'Tully est','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54722,28.99,0.8,6.3,16212,75,NULL,NULL,'UGC 04426',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54723,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54723,36.55,0.33,204,16213,70,NULL,NULL,'2MASX J08282867+5610468',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000173,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,127.119375,56.17961,0.145,NULL,61551741617,961745962,15027280,16.6),(54724,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54724,37.13,0.17,266,16214,70,NULL,NULL,'2MASX J08282871+1341117',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'16.98',0.45,NULL,NULL,NULL,NULL,NULL,1,127.1194583,13.68653,0.129,NULL,63770468808,996413575,15568962,16.98),(54725,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54725,38.16,0.46,429,16215,70,NULL,NULL,'2MASX J08282882+1800583',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000197,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,127.1200417,18.01631,0.117,NULL,63776475141,996507424,15570428,17),(54726,'BCG','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54726,36.6,0.35,199,16216,60,NULL,NULL,'ABELL 0671',0.0497,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III:[BM]',NULL,NULL,NULL,NULL,1,127.122,30.41683,0.117,NULL,64343417442,1005365897,15708842,NULL),(54727,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54727,36.64,0.12,213,16216,70,NULL,NULL,'ABELL 0671',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54728,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54728,36.47,0.11,197,16217,70,NULL,NULL,'CGCG 149-030',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000189,NULL,'15.3g',0.48,'E0',NULL,NULL,NULL,NULL,1,127.122333,30.83442,0.137,NULL,64343886891,1005373232,15708956,15.3),(54729,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54729,38.42,0.46,484,16218,70,NULL,NULL,'2MASX J08283091+3048383',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000165,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,127.128625,30.81058,0.137,NULL,64343898734,1005373417,15708959,18.5),(54730,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54730,37.9,0.46,379,16219,70,NULL,NULL,'2MASX J08283099+2424090',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000177,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,127.129,24.40256,0.085,NULL,63792009007,996750140,15574220,17.7),(54731,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54731,36.47,0.11,197,16220,70,NULL,NULL,'CGCG 149-031 NED02',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000267,NULL,'14.2',0.5,NULL,'Pair member (points to parent)',NULL,NULL,NULL,1,127.13,30.43403,0.117,NULL,64343425379,1005366021,15708844,14.2),(54732,'BCG','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54732,36.6,0.35,199,16221,60,NULL,'ABELL 0671, BCG','IC 2378',0.0497,'1980ApJ...241..486H',1980,1,1.13,NULL,'G',0.000107,NULL,'14.5g',0.78,'cD;BrClG','Pair member (points to parent)',NULL,NULL,NULL,1,127.131875,30.43133,0.117,NULL,64343425297,1005366020,15708844,14.5),(54733,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54733,36.47,0.11,197,16221,70,NULL,NULL,'IC 2378',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54734,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54734,36.64,0.12,213,16221,70,NULL,'ABELL 0671, BGC','IC 2378',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54735,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54735,37.13,0.17,266,16222,70,NULL,NULL,'SDSS J082832.19+134227.5',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.1g',0.38,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,127.134166667,13.70767,0.129,NULL,63770470099,996413595,15568962,16.1),(54736,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54736,37.42,0.46,305,16223,70,NULL,NULL,'SDSS J082834.42+120601.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,127.1434583,12.10042,0.097,NULL,63652899180,994576549,15540258,18.4),(54737,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54737,36.47,0.11,197,16224,70,NULL,NULL,'2MASX J08283454+3015583',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000087,NULL,'15.9g',0.43,'S0^-','Group member',NULL,NULL,NULL,1,127.1437917,30.26639,0.101,NULL,64343442827,1005366294,15708848,15.9),(54738,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54738,38.2,0.46,436,16225,70,NULL,NULL,'2MASX J08283497+4002099',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000134,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,127.14575,40.03619,0.121,NULL,64359793091,1005621767,15712840,18.5),(54739,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54739,37.46,0.46,310,16226,70,NULL,NULL,'2MASX J08283659+3236333',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000153,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,127.152416667,32.60931,0.133,NULL,64334609535,1005228273,15706691,16.9),(54740,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54740,37.88,0.23,376,16227,70,NULL,NULL,'2MASX J08283677+4013429',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000123,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,127.153,40.22858,0.129,NULL,64241775088,1003777735,15684027,18.3),(54741,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54741,37.6,0.23,331,16228,70,NULL,NULL,'2MASX J08283717+3258423',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000136,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,127.1550417,32.9785,0.129,NULL,64335685276,1005245082,15706954,17.2),(54742,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54742,37.52,0.46,320,16229,70,NULL,NULL,'2MASX J08283730+5703529',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,127.155541667,57.06472,0.157,NULL,61544577499,961634023,15025531,17.8),(54743,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54743,34,0.47,63.2,16230,NULL,NULL,'H','ESO 370- G 015',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00002,NULL,NULL,0.7,'S...',NULL,NULL,NULL,NULL,1,127.15575,-37.22128,NULL,NULL,42919071834,670610497,10478289,NULL),(54744,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54744,34.06,0.45,64.8,16230,NULL,NULL,'K','ESO 370- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54745,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54745,34.06,0.46,64.9,16230,NULL,NULL,'J','ESO 370- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54746,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54746,34.31,0.4,72.8,16230,NULL,NULL,'mean','ESO 370- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54747,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54747,37.6,0.23,331,16231,70,NULL,NULL,'2MASX J08283756+3256413',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,127.1564583,32.94472,0.129,NULL,64335686885,1005245107,15706954,17.5),(54748,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54748,36.47,0.11,197,16232,70,NULL,NULL,'SDSS J082837.61+302047.3',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.7g',0.27,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,127.1567083,30.34647,0.117,NULL,64343418846,1005365919,15708842,16.7),(54749,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54749,37.13,0.17,266,16233,70,NULL,NULL,'2MASX J08283893+1337517',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,127.162166667,13.63108,0.129,NULL,63837889202,997467018,15585422,17.1),(54750,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54750,37.18,0.46,273,16234,70,NULL,NULL,'2MASX J08283917+3310383',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000124,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,127.163167,33.17728,0.117,NULL,64335899824,1005248434,15707006,17.7),(54751,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54751,37.47,0.33,312,16235,70,NULL,NULL,'2MASX J08284012+5519169',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000178,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,127.167167,55.32133,0.137,NULL,61553086042,961766969,15027608,17.5),(54752,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54752,38.06,0.23,408,16236,70,NULL,NULL,'2MASX J08284058+5821309',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,127.169125,58.35856,0.181,NULL,61544031757,961625496,15025398,NULL),(54753,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54753,36.53,0.46,203,16237,70,NULL,NULL,'2MASX J08284063+0728216',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,127.169375,7.47258,0.077,NULL,62575567271,977743238,15277238,17.2),(54754,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54754,34.62,0.47,84.1,16238,NULL,NULL,'H','ESO 562- G 007',NULL,'2007A&A...465...71T',2007,1,2.4,'abs(b) < 10 degrees.','G',0.000017,NULL,'16',0.8,'(R\')SB(rs)ab?',NULL,NULL,NULL,NULL,1,127.169917,-21.73644,NULL,NULL,42275582370,660555974,10321187,16),(54755,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54755,34.64,0.4,84.6,16238,NULL,NULL,'mean','ESO 562- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54756,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54756,34.73,0.46,88.3,16238,NULL,NULL,'J','ESO 562- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54757,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54757,34.81,0.45,91.8,16238,NULL,NULL,'K','ESO 562- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54758,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54758,37.98,0.46,395,16239,70,NULL,NULL,'SDSS J082841.29+283636.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000131,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,127.172083,28.61008,0.077,NULL,64350299620,1005473431,15710522,18.5),(54759,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54759,37.52,0.46,319,16240,70,NULL,NULL,'2MASX J08284160+4403135',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,127.173375,44.05381,0.145,NULL,64250362531,1003911914,15686123,17.7),(54760,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54760,36.36,0.5,187,16241,70,NULL,NULL,'2MASX J08284270-0838211',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.08',0.5,NULL,NULL,NULL,NULL,NULL,1,127.177875,-8.63931,0.189,NULL,39241112075,613142376,9580349,16.08),(54761,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54761,36.47,0.11,197,16242,70,NULL,NULL,'IC 2380',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000083,NULL,'15.0g',0.59,'E0','Group member',NULL,NULL,NULL,1,127.182875,30.40453,0.117,NULL,64343419897,1005365935,15708842,15),(54762,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54762,35.66,0.52,136,16243,70,NULL,NULL,'2MASX J08284469-2035053',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.2,NULL,NULL,NULL,NULL,NULL,1,127.186208333,-20.58481,NULL,NULL,42275747792,660558559,10321227,14.3),(54763,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54763,37.37,0.46,297,16244,70,NULL,NULL,'2MASX J08284561+5036451',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000089,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,127.190083,50.61267,0.137,NULL,63496376871,992130888,15502045,16.8),(54764,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54764,36.37,0.46,188,16245,70,NULL,NULL,'2MASX J08284589+3457243',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,127.1912083,34.95667,0.149,NULL,64334314774,1005223668,15706619,17.2),(54765,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54765,37.4,0.46,302,16246,70,NULL,NULL,'2MASX J08284599+5029241',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00008,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,127.1915417,50.48992,0.137,NULL,63496367111,992130736,15502042,17.6),(54766,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54766,34.57,0.46,82.1,16247,70,NULL,NULL,'IC 2382',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.000063,NULL,'14.3g',0.56,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,127.192167,22.05347,0.117,NULL,63810215554,997034618,15578665,14.3),(54767,'IRAS','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54767,35.05,0.8,102,16248,75,NULL,'CF, r','UGC 04429',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000145,NULL,'15.0g',0.51,'Scd:',NULL,NULL,NULL,NULL,1,127.194833,40.66589,0.145,NULL,64241720015,1003776875,15684013,15),(54768,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54768,35.18,0.38,108,16248,75,NULL,'CF, r, raw','UGC 04429',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54769,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54769,35.34,0.38,117,16248,75,NULL,'CF, r, inv','UGC 04429',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54770,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54770,35.38,0.38,119,16248,75,NULL,'CF, r, cor','UGC 04429',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54771,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54771,37.37,0.33,298,16249,70,NULL,NULL,'2MASX J08284696+1227237',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'17.66',0.27,'AGN',NULL,NULL,NULL,NULL,1,127.195625,12.45669,0.125,NULL,63838278418,997473100,15585517,17.66),(54772,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54772,35.27,0.46,113,16250,70,NULL,NULL,'MRK 1216',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.5',0.25,'E        poss. LINER',NULL,NULL,NULL,NULL,1,127.1962917,-6.94014,0.089,NULL,39236209627,613065775,9579152,15.5),(54773,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54773,37.12,0.46,265,16251,70,NULL,NULL,'2MASX J08284799+2930519',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000164,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,127.2000417,29.51433,0.085,NULL,64342909522,1005357961,15708718,16.6),(54774,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54774,37.64,0.46,337,16252,70,NULL,NULL,'2MASX J08284923+3158383',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,127.2052083,31.97725,0.129,NULL,64344538912,1005383420,15709115,17.3),(54775,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54775,37.06,0.46,259,16253,70,NULL,NULL,'2MASX J08284928+3721460',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000162,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,127.205291667,37.36278,0.125,NULL,64359427067,1005616047,15712750,17.6),(54776,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54776,37.88,0.23,376,16254,70,NULL,NULL,'SDSS J082850.66+401155.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,127.211125,40.19878,0.129,NULL,64241776975,1003777765,15684027,17.7),(54777,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54777,37.13,0.17,266,16255,70,NULL,NULL,'SDSS J082850.81+134020.9',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,127.21175,13.6725,0.129,NULL,63837836704,997466198,15585409,17.8),(54778,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54778,37.37,0.33,298,16256,70,NULL,NULL,'2MASXi J0828509+122923',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,127.2124583,12.49008,0.125,NULL,63838280136,997473127,15585517,17.1),(54779,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54779,37.2,0.46,275,16257,70,NULL,NULL,'2MASX J08285110+4956350',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000085,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,127.213125,49.94317,0.137,NULL,63495817770,992122152,15501908,16.5),(54780,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54780,38.35,0.33,467,16258,70,NULL,NULL,'SDSS J082851.27+575740.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,127.213625,57.96128,0.177,NULL,61546828520,961669195,15026081,18.3),(54781,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54781,36.47,0.11,197,16259,70,NULL,NULL,'2MASX J08285167+3009194',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000161,NULL,'16.4g',0.31,NULL,'Group member',NULL,NULL,NULL,1,127.2154583,30.1555,0.117,NULL,64343327318,1005364489,15708820,16.4),(54782,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54782,35.57,0.46,130,16260,70,NULL,NULL,'CGCG 089-032',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000173,NULL,'15.0g',0.53,NULL,NULL,NULL,NULL,NULL,1,127.220667,17.55128,0.153,NULL,63775938165,996499033,15570297,15),(54783,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54783,37.6,0.23,331,16261,70,NULL,NULL,'2MASX J08285310+3249514',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000154,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,127.221125,32.83089,0.129,NULL,64335698436,1005245288,15706957,17),(54784,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54784,36.23,0.46,177,16262,70,NULL,NULL,'SDSS J082853.19+100004.0',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.3g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,127.221667,10.00114,0.121,NULL,62564677619,977573087,15274579,17.3),(54785,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54785,38.06,0.23,408,16263,70,NULL,NULL,'2MASX J08285328+5825580',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,127.222417,58.43289,0.181,NULL,61543981540,961624711,15025386,18),(54786,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54786,36.49,0.46,198,16264,70,NULL,NULL,'2MASX J08285405+0634370',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000175,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,127.22525,6.57686,0.061,NULL,62567577570,977618399,15275287,16.9),(54787,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54787,38.26,0.46,448,16265,70,NULL,NULL,'2MASX J08285446+2207385',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,127.2270417,22.12742,0.121,NULL,63810222231,997034722,15578667,17.4),(54788,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54788,36.47,0.11,197,16266,70,NULL,NULL,'2MASX J08285594+3030104',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,'FoF','17.33',0.32,NULL,'Group member',NULL,NULL,NULL,1,127.233125,30.50297,0.117,NULL,64343440759,1005366261,15708847,17.33),(54789,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54789,36.47,0.11,197,16267,70,NULL,NULL,'CGCG 149-035 NED01',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000083,NULL,'16.00',0.3,'S COMPONENT','Group member',NULL,NULL,NULL,1,127.236917,30.44936,0.117,NULL,64343431309,1005366114,15708845,16),(54790,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54790,37.52,0.46,319,16268,70,NULL,NULL,'2MASX J08285769+1120341',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,127.2402083,11.34261,0.105,NULL,63653192856,994581138,15540330,17.7),(54791,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54791,38.21,0.21,439,16269,70,NULL,NULL,'2MASX J08285868+1735315',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,127.244667,17.59211,0.153,NULL,63775936952,996499014,15570297,17.4),(54792,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54792,36.76,0.62,225,16270,NULL,NULL,'Malmquist cor.','CGCG 149-035 NED02',NULL,'2009ApJS..182..474S',2009,1,0.43,NULL,'G',0.000033,NULL,'16.6g',0.23,'Sb:','Group member',NULL,NULL,NULL,1,127.245333,30.458,0.117,NULL,64343431807,1005366121,15708845,16.6),(54793,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54793,37.18,0.51,273,16270,NULL,NULL,NULL,'CGCG 149-035 NED02',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54794,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54794,37.22,0.2,278,16270,74.4,NULL,NULL,'CGCG 149-035 NED02',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54795,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54795,35.13,0.49,106,16271,75,NULL,'IR','FGC 0758',NULL,'2011yCatp016004901K',2011,1,1.08,NULL,'G',0.000084,NULL,'16.6g',0.16,'Sd',NULL,NULL,NULL,NULL,1,127.248375,56.09311,0.145,NULL,61555217507,961800273,15028129,16.6),(54796,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54796,35.49,NULL,125,16271,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0758',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54797,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54797,35.5,NULL,126,16271,NULL,NULL,'Dipole + Quadrupole','FGC 0758',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54798,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54798,35.52,NULL,127,16271,NULL,NULL,'Dipole','FGC 0758',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54799,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54799,35.53,NULL,128,16271,NULL,NULL,NULL,'FGC 0758',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54800,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54800,36.47,0.11,197,16272,70,NULL,NULL,'2MASX J08290029+3019394',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000057,NULL,'16.4g',0.3,NULL,'Group member',NULL,NULL,NULL,1,127.25125,30.32764,0.117,NULL,64343423670,1005365994,15708843,16.4),(54801,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54801,38.35,0.33,467,16273,70,NULL,NULL,'SDSS J082901.14+575638.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,127.25475,57.94397,0.177,NULL,61546831789,961669246,15026081,18.5),(54802,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54802,37.04,0.46,255,16274,70,NULL,NULL,'2MASX J08290133+1239295',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,127.2555,12.65825,0.125,NULL,63838294934,997473358,15585521,16.8),(54803,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54803,37.03,0.33,255,16275,70,NULL,NULL,'2MASX J08290288+2636482',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000179,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,127.261958333,26.61339,0.129,NULL,64319112678,1004986135,15702908,17.1),(54804,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54804,37.84,0.27,369,16276,70,NULL,NULL,'SDSS J082903.30+175308.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00014,NULL,'18.7g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,127.2637917,17.88558,0.149,NULL,63776276432,996504319,15570379,18.7),(54805,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54805,37.92,0.46,383,16277,70,NULL,NULL,'2MASX J08290450+1656155',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000189,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,127.268875,16.93764,0.145,NULL,63777028606,996516071,15570563,17.1),(54806,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54806,37.84,0.27,369,16278,70,NULL,NULL,'2MASX J08290478+1754155',NULL,'2015arXiv151105856S',2015,1,0.42,'One of two 6cm sources associated with [WB92] 0826+1810','G',0.000178,NULL,'13.9',0.32,'Candidate      BLLAC',NULL,NULL,'radio jet',NULL,1,127.270125,17.90442,0.149,NULL,63776272756,996504261,15570379,13.9),(54807,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54807,37.94,0.46,388,16279,70,NULL,NULL,'2MASX J08290507+3049004',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000151,NULL,'17.4g',0.26,NULL,'Group member',NULL,NULL,NULL,1,127.2712083,30.81692,0.165,NULL,64343894454,1005373350,15708958,17.4),(54808,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54808,37.56,0.46,324,16280,70,NULL,NULL,'2MASX J08290512+0642491',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,127.271417,6.71358,0.093,NULL,62567552341,977618005,15275281,17.7),(54809,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54809,36.55,0.33,204,16281,70,NULL,NULL,'2MASX J08290691+5613560',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,127.278583,56.23219,0.145,NULL,61554885505,961795086,15028048,16.9),(54810,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54810,38.62,0.46,529,16282,70,NULL,NULL,'SDSS J082906.99+081154.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000129,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,127.279125,8.19847,0.081,NULL,62579004616,977796947,15278077,18),(54811,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54811,36.48,0.51,198,16283,NULL,NULL,'Malmquist cor.','SDSS J082907.44+302539.6',NULL,'2009ApJS..182..474S',2009,1,0.43,NULL,'G',0.000027,NULL,'18.1g',0.09,'Sc','Group member',NULL,NULL,NULL,1,127.281,30.42769,0.117,NULL,64343431457,1005366116,15708845,18.1),(54812,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54812,36.72,0.46,220,16283,NULL,NULL,NULL,'SDSS J082907.44+302539.6',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54813,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54813,36.76,0.2,225,16283,74.4,NULL,NULL,'SDSS J082907.44+302539.6',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54814,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54814,37.84,0.27,369,16284,70,NULL,NULL,'2MASX J08290875+1756135',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,127.2865,17.93717,0.117,NULL,63776271335,996504239,15570378,17.9),(54815,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54815,37.5,0.21,316,16285,70,NULL,NULL,'2MASX J08290924+3903038',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000182,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,127.288375,39.05117,0.101,NULL,64360612196,1005634565,15713040,16.5),(54816,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54816,37.61,0.46,332,16286,70,NULL,NULL,'2MASX J08290986+1616585',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,127.291208333,16.28294,0.101,NULL,63785319071,996645610,15572587,17.4),(54817,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54817,38.21,0.21,439,16287,70,NULL,NULL,'2MASXi J0829117+172038',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000155,NULL,'17.7g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,127.299167,17.34411,0.149,NULL,63775733534,996495836,15570247,17.7),(54818,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54818,37.13,0.17,266,16288,70,NULL,NULL,'2MASX J08291201+1335195',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,127.300125,13.58881,0.153,NULL,63837887222,997466987,15585421,17.4),(54819,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54819,37.39,0.46,301,16289,70,NULL,NULL,'SDSS J082912.79+323728.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000104,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,127.303333,32.6245,0.125,NULL,64335646542,1005244477,15706944,18.4),(54820,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54820,36.83,0.46,232,16290,70,NULL,NULL,'2MASX J08291385+3104124',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000177,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,127.307875,31.07006,0.137,NULL,64344735311,1005386489,15709163,16.6),(54821,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54821,37.18,0.46,272,16291,70,NULL,NULL,'2MASX J08291467+1505295',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000186,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,127.311083,15.09167,0.141,NULL,63772210698,996440792,15569387,16.2),(54822,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54822,36.76,0.46,225,16292,70,NULL,NULL,'2MASX J08291523+1006083',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.62',0.29,NULL,NULL,NULL,NULL,NULL,1,127.313458333,10.10239,0.121,NULL,62564713697,977573651,15274588,17.62),(54823,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54823,37.38,0.46,299,16293,70,NULL,NULL,'2MASX J08291654+1513405',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,127.3190417,15.22783,0.121,NULL,63772217493,996440898,15569389,17.5),(54824,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54824,36.26,0.42,179,16294,NULL,NULL,'Malmquist cor.','SDSS J082917.39+301842.5',NULL,'2009ApJS..182..474S',2009,1,0.41,NULL,'G',0.000027,NULL,'17.5g',0.15,'Sc','Group member',NULL,NULL,NULL,1,127.3224583,30.31181,0.117,NULL,64343532569,1005367696,15708870,17.5),(54825,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54825,36.35,0.4,186,16294,NULL,NULL,NULL,'SDSS J082917.39+301842.5',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54826,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54826,36.39,0.2,190,16294,74.4,NULL,NULL,'SDSS J082917.39+301842.5',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54827,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54827,38.21,0.21,439,16295,70,NULL,NULL,'2MASX J08291825+1720155',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000174,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,127.326125,17.33778,0.149,NULL,63775732979,996495827,15570247,17.5),(54828,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54828,37.67,0.46,342,16296,70,NULL,NULL,'2MASX J08291904+2911113',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000162,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,127.329333333,29.1865,0.085,NULL,64354275049,1005535547,15711492,16.8),(54829,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54829,37.5,0.21,316,16297,70,NULL,NULL,'2MASX J08291934+3906523',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000163,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,127.330667,39.11447,0.101,NULL,64360284234,1005629441,15712960,17.1),(54830,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54830,36.47,0.11,197,16298,70,NULL,NULL,'2MASX J08292049+3022382',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.3g',0.19,NULL,'Group member',NULL,NULL,NULL,1,127.335291667,30.37722,0.117,NULL,64343416120,1005365876,15708841,17.3),(54831,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54831,37.5,0.21,316,16299,70,NULL,NULL,'SDSS J082922.37+391115.5',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.8g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,127.34325,39.18764,0.101,NULL,64360286608,1005629478,15712960,16.8),(54832,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54832,38,0.27,397,16300,70,NULL,NULL,'2MASX J08292304+2704373',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000154,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,127.345875,27.07697,0.085,NULL,64318053140,1004969580,15702649,16.9),(54833,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54833,37.15,0.46,270,16301,70,NULL,NULL,'2MASX J08292319+3023422',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00018,NULL,'16.8g',NULL,NULL,'Group member',NULL,NULL,NULL,1,127.346583,30.39511,0.117,NULL,64343413362,1005365833,15708841,16.8),(54834,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54834,37.69,0.33,345,16302,70,NULL,NULL,'SDSS J082923.94+225107.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000149,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,127.3497917,22.85219,0.121,NULL,63810462381,997038474,15578726,18.4),(54835,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54835,37.5,0.21,316,16303,70,NULL,NULL,'2MASX J08292449+3910543',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,'PHOT','17.07',0.46,'BrClG',NULL,NULL,NULL,NULL,1,127.351875,39.18194,0.101,NULL,64360286705,1005629479,15712960,17.07),(54836,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54836,36.54,0.46,204,16304,70,NULL,NULL,'2MASX J08292474+2949452',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000142,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,127.3530417,29.82911,0.117,NULL,64343599120,1005368736,15708886,17.4),(54837,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54837,36.47,0.11,197,16305,70,NULL,NULL,'2MASX J08292557+3030432',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000026,NULL,'17.3g',0.23,NULL,'Group member',NULL,NULL,NULL,1,127.356583,30.51194,0.117,NULL,64343388083,1005365438,15708834,17.3),(54838,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54838,37.69,0.46,345,16306,70,NULL,NULL,'2MASX J08292562+3139202',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00013,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,127.3567917,31.65544,0.121,NULL,64344375564,1005380868,15709076,17.9),(54839,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54839,35.83,0.47,146,16307,NULL,NULL,'Malmquist cor.','KUG 0826+305',NULL,'2009ApJS..182..474S',2009,1,0.99,NULL,'G',0.000027,NULL,'15.6g',0.25,'Irr            HII','Group member',NULL,NULL,NULL,1,127.358667,30.42469,0.117,NULL,64343412759,1005365824,15708841,15.6),(54840,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54840,36,0.44,158,16307,NULL,NULL,NULL,'KUG 0826+305',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54841,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54841,36.04,0.2,161,16307,74.4,NULL,NULL,'KUG 0826+305',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54842,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54842,37.74,0.46,353,16308,70,NULL,NULL,'2MASX J08292618+4256555',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,127.359167,42.94894,0.137,NULL,64254533401,1003977084,15687141,18.1),(54843,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54843,38.06,0.23,408,16309,70,NULL,NULL,'2MASX J08292643+5826369',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'16.9r',NULL,NULL,NULL,NULL,NULL,NULL,1,127.3602083,58.44356,0.181,NULL,61544012815,961625200,15025393,16.9),(54844,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54844,37.69,0.33,345,16310,70,NULL,NULL,'2MASX J08292644+2244363',NULL,'2015arXiv151105856S',2015,1,0.43,'One of two 6cm sources associated with [WB92] 0826+2254','G',0.000186,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,127.360291667,22.74342,0.121,NULL,63810442362,997038161,15578721,16.7),(54845,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54845,36.69,0.54,217,16311,NULL,NULL,'Malmquist cor.','SDSS J082927.36+303255.5',NULL,'2009ApJS..182..474S',2009,1,0.36,NULL,'G',0.000027,NULL,'15.82',0.13,'Sc',NULL,NULL,NULL,NULL,1,127.364,30.54878,0.117,NULL,64343389697,1005365464,15708835,15.82),(54846,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54846,36.98,0.47,249,16311,NULL,NULL,NULL,'SDSS J082927.36+303255.5',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54847,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54847,37.02,0.2,254,16311,74.4,NULL,NULL,'SDSS J082927.36+303255.5',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54848,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54848,34.05,0.46,64.5,16312,70,NULL,NULL,'CGCG 149-037',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000088,NULL,'14.6g',0.43,'Sa',NULL,NULL,NULL,NULL,1,127.374958333,31.67547,0.121,NULL,64344493511,1005382711,15709104,14.6),(54849,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54849,37.96,0.46,391,16313,70,NULL,NULL,'2MASX J08293223+2637541',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,127.384166667,26.63164,0.129,NULL,64319122520,1004986289,15702910,17.7),(54850,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54850,37.97,0.46,393,16314,70,NULL,NULL,'2MASX J08293350+2721311',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000143,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,127.3895417,27.35867,0.097,NULL,64318027870,1004969185,15702643,17.6),(54851,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54851,37.32,0.46,290,16315,70,NULL,NULL,'2MASX J08293619+2754002',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,127.401,27.90008,0.101,NULL,64317627585,1004962931,15702545,17.4),(54852,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54852,37.58,0.46,328,16316,70,NULL,NULL,'2MASX J08293637+2436482',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,127.4015,24.61358,0.097,NULL,63791869816,996747965,15574186,17.6),(54853,'Tully est','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54853,32.16,0.8,27.1,16317,75,NULL,NULL,'UGCA 140',NULL,'1988NBGC.C....0000T',1988,1,0.62,NULL,'G',0.000014,NULL,'15.1g',0.33,'S0^0^ pec?',NULL,NULL,NULL,NULL,1,127.4114583,52.07636,0.133,NULL,63498252783,992160199,15502503,15.1),(54854,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54854,38.35,0.46,469,16318,70,NULL,NULL,'2MASX J08293912+2025053',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000175,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,127.4130417,20.41822,0.089,NULL,63805112701,996954885,15577420,18.1),(54855,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54855,37.03,0.33,255,16319,70,NULL,NULL,'2MASX J08293984+2634572',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000175,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,127.415833,26.58272,0.129,NULL,64319067307,1004985426,15702897,16.2),(54856,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54856,36.47,0.11,197,16320,70,NULL,NULL,'IC 2383',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000229,NULL,'15.2g',0.54,'S0^-',NULL,NULL,NULL,NULL,1,127.4222917,30.68797,0.165,NULL,64343838204,1005372471,15708944,15.2),(54857,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54857,36.24,0.6,177,16321,70,NULL,NULL,'2MASX J08294618-1224147',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.90',NULL,NULL,NULL,NULL,NULL,NULL,1,127.442333,-12.40414,0.245,NULL,42379842449,662185038,10346641,16.9),(54858,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54858,32.57,0.43,32.7,16322,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04413',NULL,'2014MNRAS.444..527S',2014,1,1.7,NULL,'G',NULL,NULL,'15.42',0.22,'Scd',NULL,NULL,NULL,NULL,1,127.443,73.85736,0.053,NULL,61290806800,957668856,14963575,15.42),(54859,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54859,32.87,NULL,37.5,16322,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04413',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54860,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54860,32.88,NULL,37.6,16322,NULL,NULL,'Dipole','UGC 04413',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54861,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54861,32.88,NULL,37.6,16322,NULL,NULL,'Dipole + Quadrupole','UGC 04413',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54862,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54862,37.23,0.33,279,16323,70,NULL,NULL,'2MASX J08294669+3142403',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000143,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,127.444667,31.71111,0.121,NULL,64344491207,1005382675,15709104,18.1),(54863,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54863,37.56,0.46,326,16324,70,NULL,NULL,'SDSS J082947.06+072825.8',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000167,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,127.446083333,7.47386,0.093,NULL,62575620931,977744077,15277251,18.5),(54864,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54864,36.46,0.48,196,16325,NULL,NULL,'Malmquist cor.','2MASX J08294717+3039203',NULL,'2009ApJS..182..474S',2009,1,0.34,NULL,'G',0.000027,NULL,'17.6g',0.15,'Sc','Group member',NULL,NULL,NULL,1,127.446333,30.65597,0.165,NULL,64343376373,1005365255,15708832,17.6),(54865,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54865,36.67,0.43,216,16325,NULL,NULL,NULL,'2MASX J08294717+3039203',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54866,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54866,36.71,0.2,220,16325,74.4,NULL,NULL,'2MASX J08294717+3039203',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54867,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54867,37.23,0.33,279,16326,70,NULL,NULL,'2MASX J08294786+3143523',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000163,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,127.4495,31.73119,0.113,NULL,64344504532,1005382883,15709107,16.8),(54868,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54868,37.88,0.23,376,16327,70,NULL,NULL,'2MASX J08294911+4021437',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00014,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,127.4547083,40.362,0.129,NULL,64241621747,1003775339,15683989,18.3),(54869,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54869,37.4,0.46,302,16328,70,NULL,NULL,'SDSS J082950.04+111226.4',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,127.4585,11.20736,0.093,NULL,63653257195,994582143,15540345,NULL),(54870,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54870,38.83,0.46,583,16329,70,NULL,NULL,'2MASX J08295522+0049494',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,127.48,0.8305,0.149,NULL,62587288713,977926386,15280099,17.7),(54871,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54871,38.14,0.46,424,16330,70,NULL,NULL,'SDSS J082956.16+095616.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,127.484041667,9.93781,0.121,NULL,62564683248,977573175,15274580,18.3),(54872,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54872,37.41,0.46,303,16331,70,NULL,NULL,'2MASX J08295660+0920311',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,127.4857917,9.34194,0.145,NULL,62564977581,977577774,15274652,17),(54873,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54873,37.88,0.23,376,16332,70,NULL,NULL,'SDSS J082956.95+402125.4',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000174,NULL,'17.2g',0.26,'BrClG',NULL,NULL,NULL,NULL,1,127.487333,40.35706,0.129,NULL,64241630488,1003775476,15683991,17.2),(54874,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54874,35.88,0.46,150,16333,70,NULL,NULL,'2MASX J08295736+2501129',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,127.4889583,25.02025,0.053,NULL,63791923782,996748809,15574200,16.8),(54875,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54875,36.79,0.51,228,16334,NULL,NULL,'Malmquist cor.','2MASX J08295740+3035298',NULL,'2009ApJS..182..474S',2009,1,0.41,NULL,'G',0.00003,NULL,'16.9g',0.21,'Sb:','Group member',NULL,NULL,NULL,1,127.489167,30.5915,0.117,NULL,64343510646,1005367353,15708864,16.9),(54876,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54876,37.11,0.44,264,16334,NULL,NULL,NULL,'2MASX J08295740+3035298',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54877,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54877,37.15,0.2,269,16334,74.4,NULL,NULL,'2MASX J08295740+3035298',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54878,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54878,36.19,0.46,173,16335,70,NULL,NULL,'KUG 0826+451',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000098,NULL,'15.2g',0.51,'Compact',NULL,NULL,NULL,NULL,1,127.489333333,44.94011,0.137,NULL,64250144018,1003908500,15686070,15.2),(54879,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54879,37.89,0.46,378,16336,70,NULL,NULL,'SDSS J082957.57+075524.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000163,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,127.489875,7.92336,0.061,NULL,62578669755,977791714,15277995,18),(54880,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54880,36.97,0.46,247,16337,70,NULL,NULL,'2MASX J08295825+3858458',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000163,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,127.492583,38.97947,0.101,NULL,64360160447,1005627506,15712929,16.8),(54881,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54881,38.21,0.46,438,16338,70,NULL,NULL,'2MASX J08295824+1811124',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,127.492791667,18.18675,0.101,NULL,63776142605,996502228,15570347,17.7),(54882,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54882,37.6,0.46,331,16339,70,NULL,NULL,'2MASX J08295847+5921179',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,127.49375,59.35503,0.153,NULL,62046364915,969474451,15148038,18),(54883,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54883,36.79,0.46,228,16340,70,NULL,NULL,'2MASX J08295930+1452178',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,127.496958333,14.87169,0.125,NULL,63772125362,996439458,15569366,17.1),(54884,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54884,37.42,0.46,305,16341,70,NULL,NULL,'2MASX J08295927+3917517',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000198,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,127.4970417,39.29778,0.125,NULL,64360294658,1005629604,15712962,16.3),(54885,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54885,38.76,0.46,564,16342,70,NULL,NULL,'2MASX J08295974+2755419',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000147,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,127.4989583,27.92819,0.101,NULL,64317681356,1004963771,15702558,17.7),(54886,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54886,37.5,0.21,316,16343,70,NULL,NULL,'SDSS J082959.92+391519.4',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000161,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,127.499666667,39.25542,0.125,NULL,64360295280,1005629613,15712962,16.9),(54887,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54887,36.24,0.46,177,16344,70,NULL,NULL,'2MASX J08300006+3003378',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.0g',0.2,NULL,'Group member',NULL,NULL,NULL,1,127.500375,30.06042,0.117,NULL,64343759039,1005371234,15708925,17),(54888,'IRAS','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54888,32.54,0.8,32.2,16345,75,NULL,'HMCL, I','UGC 04444',NULL,'1997ApJS..109..333W',1997,1,1.35,NULL,'G',0.000006,NULL,'14.2g',0.75,'SB(s)cd?',NULL,NULL,NULL,NULL,1,127.507041667,17.25986,0.149,NULL,63777579833,996524684,15570698,14.2),(54889,'IRAS','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54889,32.55,0.8,32.3,16345,75,NULL,'A82, H','UGC 04444',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54890,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54890,30.99,0.47,15.7,16345,75,NULL,'A82, H, inv','UGC 04444',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54891,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54891,31.06,0.47,16.3,16345,75,NULL,'A82, H, raw','UGC 04444',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54892,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54892,31.38,0.47,18.8,16345,75,NULL,'A82, H, cor','UGC 04444',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54893,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54893,31.48,0.4,19.8,16345,NULL,NULL,NULL,'UGC 04444',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54894,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54894,31.48,0.4,19.8,16345,73,NULL,'opt','UGC 04444',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54895,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54895,31.71,0.4,22,16345,75,NULL,'HMCL, I, inv','UGC 04444',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54896,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54896,31.72,0.4,22.1,16345,75,NULL,'HMCL, I, raw','UGC 04444',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54897,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54897,31.97,0.4,24.8,16345,75,NULL,'HMCL, I, cor','UGC 04444',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54898,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54898,32.17,0.2,27.2,16345,74.4,NULL,NULL,'UGC 04444',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54899,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54899,33.85,0.47,58.9,16346,NULL,NULL,'H','NGC 2598',NULL,'2007A&A...465...71T',2007,1,1.41,NULL,'G',0.000033,NULL,'14.3g',0.5,'SBa?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,127.5105,21.48867,0.093,NULL,63818637128,997166205,15580721,14.3),(54900,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54900,33.99,0.45,62.9,16346,NULL,NULL,'K','NGC 2598',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54901,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54901,34.02,0.46,63.6,16346,NULL,NULL,'J','NGC 2598',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54902,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54902,34.24,0.4,70.4,16346,NULL,NULL,'mean','NGC 2598',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54903,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54903,37.96,0.46,390,16347,70,NULL,NULL,'2MASX J08300323+1628248',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,127.5135417,16.47378,0.117,NULL,63785299767,996645308,15572582,17.7),(54904,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54904,36.71,0.46,220,16348,70,NULL,NULL,'2MASX J08300336+1048091',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,127.514,10.80256,0.105,NULL,63656437849,994631841,15541122,17.1),(54905,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54905,37.84,0.46,369,16349,70,NULL,NULL,'SDSS J083004.66+315646.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00014,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,127.519417,31.94617,0.125,NULL,64344517872,1005383091,15709110,18.8),(54906,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54906,36.89,0.46,239,16350,70,NULL,NULL,'2MASX J08300546+4345331',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000151,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,127.522583,43.75919,0.133,NULL,64249793942,1003903030,15685984,16.7),(54907,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54907,36.83,0.56,233,16351,70,NULL,NULL,'2MASX J08300639-0421225',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,'HII',NULL,NULL,NULL,NULL,1,127.526625,-4.35625,0.097,NULL,39255856405,613372756,9583949,15.4),(54908,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54908,35.99,0.46,157,16352,70,NULL,NULL,'2MASX J08300775+0938421',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000103,NULL,'16.71',0.39,NULL,NULL,NULL,NULL,NULL,1,127.532375,9.64492,0.153,NULL,62565362290,977583785,15274746,16.71),(54909,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54909,37.7,0.46,346,16353,70,NULL,NULL,'2MASX J08300879+1919284',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000138,NULL,'18.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,127.5367083,19.32453,0.073,NULL,63806646176,996978846,15577794,18.1),(54910,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54910,38.21,0.46,439,16354,70,NULL,NULL,'2MASX J08301079+5049569',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000079,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,127.545083,50.83261,0.133,NULL,63496106599,992126665,15501979,18),(54911,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54911,37.75,0.46,355,16355,70,NULL,NULL,'2MASX J08301119+1725548',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00018,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,127.546625,17.43203,0.149,NULL,63777764403,996527568,15570743,17.5),(54912,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54912,37.56,0.46,326,16356,70,NULL,NULL,'2MASX J08301263+2409329',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000137,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,127.552875,24.15928,0.085,NULL,63794972922,996796451,15574944,17.8),(54913,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54913,38.71,0.46,553,16357,70,NULL,NULL,'2MASX J08301430+4020107',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,127.5595417,40.33636,0.129,NULL,64241625685,1003775401,15683990,18.1),(54914,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54914,38.22,0.46,441,16358,70,NULL,NULL,'2MASX J08301435+4009187',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000174,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,127.55975,40.15506,0.121,NULL,64241655668,1003775869,15683997,17.8),(54915,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54915,37.54,0.46,322,16359,70,NULL,NULL,'2MASX J08301503+5227059',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000084,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,127.56275,52.45172,0.145,NULL,63501214635,992206478,15503226,17.3),(54916,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54916,36.87,0.46,237,16360,70,NULL,NULL,'2MASX J08301670+1408188',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,127.569708333,14.13856,0.161,NULL,63839708242,997495441,15585866,17),(54917,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54917,38.11,0.23,419,16361,70,NULL,NULL,'2MASX J08301763+2615359',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,127.573417,26.25986,0.145,NULL,64319430634,1004991103,15702985,17.9),(54918,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54918,37.24,0.46,280,16362,70,NULL,NULL,'2MASX J08301787+0354300',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000159,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,127.5745,3.90828,0.049,NULL,62611094808,978298356,15285911,17),(54919,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54919,36.82,0.46,232,16363,70,NULL,NULL,'SDSS J083017.92+174516.1',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000195,NULL,'15.8g',0.47,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,127.5747083,17.75447,0.093,NULL,63775782857,996496607,15570259,15.8),(54920,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54920,37.1,0.46,264,16364,70,NULL,NULL,'2MASX J08301833+0312130',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,127.576375,3.20372,0.081,NULL,62610579833,978290309,15285786,17.3),(54921,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54921,37.28,0.46,286,16365,70,NULL,NULL,'2MASX J08302166+2355249',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000176,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,127.590167,23.92353,0.085,NULL,63795014517,996797101,15574954,16.8),(54922,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54922,37.8,0.46,362,16366,70,NULL,NULL,'2MASX J08302232+1214568',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,127.592875,12.24908,0.109,NULL,63837724885,997464451,15585382,17.2),(54923,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54923,37.85,0.46,371,16367,70,NULL,NULL,'SDSS J083023.45+172303.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000131,NULL,'18.6g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,127.59775,17.38439,0.149,NULL,63777762021,996527531,15570742,18.6),(54924,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54924,38.42,0.46,482,16368,70,NULL,NULL,'2MASX J08302728+3200026',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,127.613666667,32.00089,0.125,NULL,64344508807,1005382950,15709108,18.4),(54925,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54925,37.83,0.83,368,16369,70,NULL,NULL,'2MASX J08302818-0405024',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.4,NULL,NULL,NULL,NULL,NULL,1,127.6174583,-4.08403,0.093,NULL,39256063150,613375986,9583999,14.4),(54926,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54926,37.82,0.2,366,16370,74.4,NULL,NULL,'2MASX J08302832+3032006',NULL,'2013AJ....146...86T',2013,1,0.41,NULL,'G',0.000023,NULL,'17.4g',0.15,'Sc','Group member',NULL,NULL,NULL,1,127.6180417,30.53347,0.117,NULL,64343055242,1005360238,15708753,17.4),(54927,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54927,38.08,0.42,414,16370,NULL,NULL,'Malmquist cor.','2MASX J08302832+3032006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54928,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54928,38.09,0.42,415,16370,NULL,NULL,NULL,'2MASX J08302832+3032006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54929,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54929,37.71,0.45,348,16371,NULL,NULL,'Malmquist cor.','2MASX J08302827+3050296',NULL,'2009ApJS..182..474S',2009,1,0.48,NULL,'G',0.000027,NULL,'16.7g',0.17,'Sbc','Group member',NULL,NULL,NULL,1,127.61775,30.84142,0.165,NULL,64344174334,1005377723,15709026,16.7),(54930,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54930,37.78,0.44,359,16371,NULL,NULL,NULL,'2MASX J08302827+3050296',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54931,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54931,38.13,0.2,423,16371,74.4,NULL,NULL,'2MASX J08302827+3050296',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54932,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54932,38.11,0.23,419,16372,70,NULL,NULL,'2MASX J08302868+2612528',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,127.6195417,26.21456,0.141,NULL,64319445935,1004991342,15702989,17.4),(54933,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54933,37.43,0.46,306,16373,70,NULL,NULL,'2MASX J08302937+2300549',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000143,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,127.6222917,23.01533,0.081,NULL,63792831689,996762995,15574421,18.1),(54934,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54934,37.78,0.33,360,16374,70,NULL,NULL,'2MASX J08302965+0925270',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,127.623583,9.42417,0.145,NULL,62565243736,977581933,15274717,17),(54935,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54935,36.18,0.46,172,16375,70,NULL,NULL,'2MASX J08303024+4248321',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'17.36',0.34,NULL,NULL,NULL,NULL,NULL,1,127.6259583,42.80906,0.129,NULL,64254411189,1003975174,15687112,17.36),(54936,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54936,37.67,0.33,342,16376,70,NULL,NULL,'2MASX J08303093+1013490',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,127.628875,10.23031,0.121,NULL,62564748458,977574194,15274596,17.8),(54937,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54937,37.62,0.46,334,16377,70,NULL,NULL,'2MASX J08303143+1244094',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,127.630917,12.73589,0.125,NULL,63837653035,997463328,15585364,17),(54938,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54938,37.67,0.33,342,16378,70,NULL,NULL,'SDSS J083031.94+101549.6',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,127.633125,10.26381,0.121,NULL,62564745944,977574155,15274596,17.1),(54939,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54939,34.1,NULL,66,16379,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 089-036',NULL,'2010Ap&SS.325..163P',2010,1,0.83,NULL,'G',0.000007,NULL,'16.6g',0.15,'Sc',NULL,NULL,NULL,NULL,1,127.634125,19.73981,0.077,NULL,63807026481,996984788,15577887,16.6),(54940,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54940,34.12,NULL,66.7,16379,NULL,NULL,'Dipole + Quadrupole','CGCG 089-036',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54941,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54941,34.13,NULL,66.9,16379,NULL,NULL,'Dipole','CGCG 089-036',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54942,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54942,34.22,NULL,69.9,16379,NULL,NULL,NULL,'CGCG 089-036',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54943,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54943,34.53,0.2,80.5,16379,74.4,NULL,NULL,'CGCG 089-036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54944,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54944,37.38,0.46,299,16380,70,NULL,NULL,'2MASX J08303285+5705276',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,127.6370417,57.091,0.157,NULL,61546215162,961659611,15025931,17.4),(54945,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54945,37.1,0.46,263,16381,70,NULL,NULL,'2MASX J08303396+2422509',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000209,NULL,'15.8g',0.41,NULL,NULL,NULL,NULL,NULL,1,127.641458333,24.38072,0.085,NULL,63794654290,996791473,15574866,15.8),(54946,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54946,37.75,0.46,355,16382,70,NULL,NULL,'2MASX J08303424+1612514',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,127.6427083,16.21442,0.121,NULL,63785798749,996653105,15572704,17.2),(54947,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54947,37.95,0.46,388,16383,70,NULL,NULL,'SDSS J083035.12+040742.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,127.646375,4.12861,0.049,NULL,62611215498,978300242,15285941,17.9),(54948,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54948,36.9,0.46,239,16384,70,NULL,NULL,'2MASX J08303527+0528054',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,127.647,5.468,0.053,NULL,62598036409,978094318,15282723,17.4),(54949,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54949,37.14,0.46,268,16385,70,NULL,NULL,'2MASX J08303550+4705394',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000073,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,127.648125,47.09444,0.137,NULL,63522820202,992544065,15508501,16.8),(54950,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54950,37.17,0.58,272,16386,70,NULL,NULL,'2MASX J08303583-1101402',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.72',NULL,NULL,NULL,NULL,NULL,NULL,1,127.649291667,-11.02775,0.269,NULL,42164783595,658824743,10294136,16.72),(54951,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54951,38.06,0.23,408,16387,70,NULL,NULL,'2MASX J08303596+5824246',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,127.6497083,58.40694,0.181,NULL,61544042584,961625665,15025401,18.2),(54952,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54952,38.23,0.46,442,16388,70,NULL,NULL,'2MASX J08303604+0056264',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,127.650167,0.94078,0.089,NULL,62587363422,977927553,15280118,17.2),(54953,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54953,37.07,0.94,260,16389,70,NULL,NULL,'2MASX J08303714-6408204',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,127.65475,-64.13903,0.713,NULL,40778940853,637170950,9955796,16.9),(54954,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54954,37.12,0.46,266,16390,70,NULL,NULL,'2MASX J08303751+5328474',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000087,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,127.6562917,53.48003,0.129,NULL,63500064955,992188514,15502945,16.6),(54955,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54955,37.94,0.46,387,16391,70,NULL,NULL,'2MASX J08303783+3147467',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000161,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,127.657583,31.79619,0.113,NULL,64344487179,1005382612,15709103,16.9),(54956,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54956,37.95,0.33,389,16392,70,NULL,NULL,'2MASX J08303857+5039074',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00008,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,127.6607917,50.65197,0.121,NULL,63496245740,992128839,15502013,17.7),(54957,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54957,38.11,0.23,419,16393,70,NULL,NULL,'2MASX J08303901+2612489',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00014,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,127.662583333,26.21342,0.141,NULL,64319439968,1004991249,15702988,18.6),(54958,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54958,37.05,0.46,257,16394,70,NULL,NULL,'2MASX J08304005+3250286',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000137,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,127.6669583,32.84133,0.129,NULL,64332803660,1005200057,15706250,18.3),(54959,'IRAS','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54959,34.63,0.8,84.3,16395,75,NULL,'HMCL, I','UGC 04446',NULL,'1997ApJS..109..333W',1997,1,1.12,'Multiple SDSS entries describe this object.','G',0.000007,NULL,'16.10',0.11,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,127.66875,20.59969,0.117,NULL,63805267522,996957305,15577457,16.1),(54960,'IRAS','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54960,34.63,0.8,84.4,16395,75,NULL,'W91CL, r','UGC 04446',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54961,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54961,34.56,0.43,81.5,16395,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04446',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54962,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54962,34.61,0.19,83.7,16395,NULL,NULL,NULL,'UGC 04446',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54963,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54963,34.68,0.4,86.1,16395,75,NULL,'HMCL, I, raw','UGC 04446',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54964,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54964,34.74,0.43,88.7,16395,75,NULL,'3.6 micron, color corrected','UGC 04446',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54965,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54965,34.8,0.49,91,16395,75,NULL,'IR','UGC 04446',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54966,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54966,34.8,0.4,91.3,16395,75,NULL,'HMCL, I, inv','UGC 04446',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54967,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54967,34.81,0.38,91.8,16395,75,NULL,'W91CL, r, raw','UGC 04446',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54968,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54968,34.83,0.4,92.5,16395,75,NULL,'HMCL, I, cor','UGC 04446',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54969,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54969,34.89,0.38,95.3,16395,75,NULL,'W91CL, r, inv','UGC 04446',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54970,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54970,34.94,0.38,97.4,16395,75,NULL,'W91CL, r, cor','UGC 04446',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54971,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54971,34.97,0.2,98.6,16395,74.4,NULL,NULL,'UGC 04446',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54972,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54972,35.35,NULL,117,16395,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04446',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54973,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54973,35.37,NULL,118,16395,NULL,NULL,'Dipole + Quadrupole','UGC 04446',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54974,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54974,35.38,NULL,119,16395,NULL,NULL,'Dipole','UGC 04446',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54975,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54975,35.41,NULL,121,16395,NULL,NULL,NULL,'UGC 04446',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54976,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54976,37.95,0.33,389,16396,70,NULL,NULL,'SDSS J083041.50+504019.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000065,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,127.673,50.67194,0.121,NULL,63496246040,992128844,15502013,18.7),(54977,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54977,36.69,0.33,218,16397,70,NULL,NULL,'SBS 0826+582A',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'18.5',0.2,NULL,NULL,NULL,NULL,NULL,1,127.6745417,58.03947,0.177,NULL,61543680867,961620013,15025312,18.5),(54978,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54978,38.04,0.46,406,16398,70,NULL,NULL,'SDSS J083042.36+103439.3',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,127.6765417,10.57758,0.109,NULL,63654380751,994599699,15540620,NULL),(54979,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54979,38.25,0.46,446,16399,70,NULL,NULL,'2MASX J08304277+0340594',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,127.678375,3.68317,0.037,NULL,62611495733,978304620,15286009,17.3),(54980,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54980,36.69,0.33,218,16400,70,NULL,NULL,'2MASX J08304316+5804286',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'16.0g',0.37,NULL,NULL,NULL,NULL,NULL,1,127.6800417,58.07464,0.177,NULL,61543687336,961620114,15025314,16),(54981,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54981,38.06,0.46,410,16401,70,NULL,NULL,'2MASX J08304458+0545454',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000138,NULL,'17.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,127.685875,5.76247,0.053,NULL,62598106884,978095420,15282740,17.7),(54982,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54982,37.68,0.46,343,16402,70,NULL,NULL,'2MASX J08304481+2443339',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,127.68675,24.72608,0.077,NULL,63791908763,996748574,15574196,17.9),(54983,'SZ effect','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54983,38.27,NULL,451,16403,NULL,NULL,NULL,'ABELL 0665',NULL,'2005ApJ...625..108D',2005,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III:   [BM]',NULL,NULL,NULL,NULL,1,127.688291667,65.88203,0.125,NULL,62240321892,972505029,15195391,NULL),(54984,'SZ effect','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54984,38.34,NULL,466,16403,NULL,NULL,NULL,'ABELL 0665',NULL,'2002ApJ...581...53R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54985,'SZ effect','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54985,39.1,0.3,660,16403,NULL,NULL,'Hydrost. Eq.','ABELL 0665',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54986,'SZ effect','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54986,39.4,0.42,760,16403,NULL,NULL,'Isotherm., r < 100 kpc','ABELL 0665',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54987,'SZ effect','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54987,39.63,NULL,845,16403,NULL,NULL,'3.1 (red) calibration','ABELL 0665',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54988,'SZ effect','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54988,39.83,NULL,923,16403,NULL,NULL,'4.2 (black) calibration','ABELL 0665',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54989,'SZ effect','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54989,40.02,0.44,1010,16403,NULL,NULL,'Isotherm.','ABELL 0665',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54990,'SZ effect','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54990,40.13,NULL,1060,16403,NULL,NULL,'4.1 (blue) calibration','ABELL 0665',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54991,'SZ effect','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54991,40.47,0.44,1240,16403,NULL,NULL,NULL,'ABELL 0665',NULL,'1991ApJ...379..466B',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(54992,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54992,37.87,0.46,375,16404,70,NULL,NULL,'2MASX J08304568+5803286',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,127.690291667,58.05786,0.177,NULL,61543691471,961620179,15025315,17.4),(54993,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54993,37.78,0.33,360,16405,70,NULL,NULL,'SDSS J083046.25+092850.9',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.8g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,127.69275,9.48081,0.145,NULL,62565210102,977581407,15274709,17.8),(54994,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54994,36.22,0.59,175,16406,70,NULL,NULL,'2MASX J08304642-0429336',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,127.6935417,-4.49267,0.097,NULL,39257697282,613401520,9584398,15.5),(54995,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54995,37.44,0.46,308,16407,70,NULL,NULL,'SDSS J083047.05+042034.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,127.696083333,4.34286,0.057,NULL,62611547497,978305429,15286022,18.2),(54996,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,54996,33.8,0.2,57.5,16408,74.4,NULL,NULL,'ESO 562- G 010',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.00003,NULL,'15',0.9,'SBb',NULL,NULL,NULL,NULL,1,127.6985,-17.68003,0.265,NULL,42256642676,660260041,10316563,15),(54997,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54997,37.31,0.46,289,16409,70,NULL,NULL,'SDSS J083048.42+132301.7',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.5g',0.33,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,127.70175,13.38383,0.153,NULL,63840825695,997512901,15586139,16.5),(54998,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54998,35.97,0.46,156,16410,70,NULL,NULL,'CGCG 119-119',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000073,NULL,'15.6g',0.36,'Sc','Isolated galaxy',NULL,NULL,NULL,1,127.702333333,24.61517,0.085,NULL,63791845260,996747582,15574180,15.6),(54999,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',54999,38.03,0.46,404,16411,70,NULL,NULL,'2MASX J08304911+5013594',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000073,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,127.7047917,50.23331,0.129,NULL,63496138014,992127156,15501986,17.5),(55000,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55000,38.48,0.46,497,16412,70,NULL,NULL,'SDSS J083049.37+131038.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.6g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,127.7057083,13.17747,0.161,NULL,63837969207,997468268,15585441,18.6),(55001,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55001,37.07,0.33,259,16413,70,NULL,NULL,'2MASX J08305122+3626465',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00018,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,127.713291667,36.44622,0.121,NULL,64372191226,1005815487,15715866,16.8),(55002,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55002,36.87,0.46,237,16414,70,NULL,NULL,'2MASX J08305161+4926193',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000094,NULL,'16.1g',0.39,'E0',NULL,NULL,NULL,NULL,1,127.715,49.43875,0.129,NULL,63497029758,992141089,15502204,16.1),(55003,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55003,36.53,0.56,202,16415,70,NULL,NULL,'2MASX J08305277-0501306',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.71',NULL,NULL,NULL,NULL,NULL,NULL,1,127.7199583,-5.02539,0.125,NULL,39257231082,613394235,9584284,16.71),(55004,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55004,35.69,0.33,137,16416,70,NULL,NULL,'MCG +07-18-012',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000182,NULL,'15.5g',0.43,'S0',NULL,NULL,NULL,NULL,1,127.720417,39.84656,0.105,NULL,64359927927,1005623873,15712873,15.5),(55005,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55005,37.07,0.33,259,16417,70,NULL,NULL,'2MASX J08305288+3625375',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000185,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,127.7204583,36.42719,0.121,NULL,64372190446,1005815475,15715866,17.1),(55006,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55006,36.31,0.52,183,16418,70,NULL,NULL,'2MASX J08305299-0325386',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.25',NULL,NULL,NULL,NULL,NULL,NULL,1,127.720583333,-3.42744,0.101,NULL,39256415148,613381486,9584085,16.25),(55007,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55007,32.9,0.4,38,16419,75,NULL,NULL,'ESO 431- G 013',NULL,'2008Ap.....51..336K',2008,1,1.17,NULL,'G',0.00003,NULL,'15.5',0.28,'Spiral edge-on',NULL,NULL,NULL,NULL,1,127.725875,-30.09797,NULL,NULL,42733648182,667713252,10433019,15.5),(55008,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55008,33.59,0.49,52.2,16419,75,NULL,'IR','ESO 431- G 013',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55009,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55009,36.79,0.46,228,16420,70,NULL,NULL,'2MASX J08305559+3400566',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,127.731625,34.01583,0.081,NULL,64336107032,1005251672,15707057,17.3),(55010,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55010,34.28,0.54,71.6,16421,70,NULL,NULL,'2MASX J08305688-6621527',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000097,NULL,'15.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,127.7372083,-66.36472,0.577,NULL,40773950402,637092975,9954577,15.2),(55011,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55011,37.31,0.27,290,16422,70,NULL,NULL,'2MASX J08305755+5358273',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.0001,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,127.7397083,53.97419,0.113,NULL,63491460205,992054065,15500844,16.5),(55012,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55012,37.24,0.46,280,16423,70,NULL,NULL,'2MASX J08305854+2046270',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,127.7439583,20.77411,0.093,NULL,63805234290,996956785,15577449,16.5),(55013,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55013,37.82,0.46,366,16424,70,NULL,NULL,'SDSS J083058.74+072150.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,127.7447917,7.36397,0.069,NULL,62575289837,977738903,15277170,18.1),(55014,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55014,35.69,0.33,137,16425,70,NULL,NULL,'MCG +07-18-013',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000187,NULL,'15.5g',0.45,'E0',NULL,NULL,NULL,NULL,1,127.746541667,39.83972,0.105,NULL,64360439837,1005631872,15712998,15.5),(55015,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55015,37.31,0.27,290,16426,70,NULL,NULL,'2MASX J08310034+5400235',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000225,NULL,'16.4g',0.29,'BrClG          BLLAC',NULL,NULL,NULL,NULL,1,127.7515,54.00647,0.113,NULL,63491460581,992054071,15500844,16.4),(55016,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55016,38.11,0.23,419,16427,70,NULL,NULL,'2MASX J08310247+2611396',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000171,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,127.760417,26.19425,0.117,NULL,64319439578,1004991243,15702988,17.9),(55017,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55017,37.37,0.46,298,16428,70,NULL,NULL,'2MASX J08310296+4032366',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00019,NULL,'16.3g',0.39,'BrClG',NULL,NULL,NULL,NULL,1,127.762125,40.5435,0.133,NULL,64242030848,1003781732,15684089,16.3),(55018,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55018,37.06,0.46,258,16429,70,NULL,NULL,'2MASX J08310531+0656014',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,127.772,6.93369,0.093,NULL,62575796004,977746812,15277293,17.3),(55019,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55019,38.27,0.46,451,16430,70,NULL,NULL,'SDSS J083106.13+310039.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000159,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,127.7755417,31.01106,0.125,NULL,64344210636,1005378291,15709035,18.1),(55020,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55020,37.31,0.27,290,16431,70,NULL,NULL,'2MASX J08310613+5359135',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000104,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,127.775583,53.98719,0.117,NULL,63491459411,992054053,15500844,16.6),(55021,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55021,37.89,0.46,379,16432,70,NULL,NULL,'2MASX J08310659+3716396',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000155,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,127.7775417,37.27772,0.097,NULL,64372675004,1005823046,15715985,17.4),(55022,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55022,35.93,0.67,153,16433,70,NULL,NULL,'2MASX J08310686-7120267',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,127.7785,-71.34078,0.665,NULL,40632362836,634880669,9920010,17.1),(55023,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55023,38.16,0.33,429,16434,70,NULL,NULL,'2MASX J08310687+3149179',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000126,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,127.778583,31.82164,0.113,NULL,64344485692,1005382588,15709102,17.6),(55024,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55024,38.55,0.46,513,16435,70,NULL,NULL,'2MASX J08310944+5205335',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000079,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,127.789041667,52.09261,0.129,NULL,63501103557,992204743,15503199,18.3),(55025,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55025,37.42,0.46,305,16436,70,NULL,NULL,'KUG 0828+299',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000188,NULL,'16.6g',0.34,'Compact',NULL,NULL,NULL,NULL,1,127.790917,29.79469,0.109,NULL,64343677479,1005369960,15708905,16.6),(55026,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55026,36.97,0.46,248,16437,70,NULL,NULL,'2MASXi J0831098+174108',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000179,NULL,'17.1g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,127.791166667,17.68558,0.093,NULL,63777677722,996526214,15570722,17.1),(55027,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55027,37.94,0.46,387,16438,70,NULL,NULL,'2MASX J08311114+1347409',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,127.7965,13.79483,0.153,NULL,63840931783,997514559,15586164,17.6),(55028,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55028,37.91,0.46,381,16439,70,NULL,NULL,'2MASX J08311270+2532026',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000173,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,127.802875,25.53394,0.093,NULL,64319342109,1004989720,15702964,17.5),(55029,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55029,37.76,0.46,357,16440,70,NULL,NULL,'2MASX J08311283+0955177',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,127.8035417,9.92147,0.141,NULL,62565267471,977582304,15274723,17.8),(55030,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55030,36.72,0.46,221,16441,70,NULL,NULL,'2MASX J08311396+1013467',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,127.8082083,10.22972,0.121,NULL,63654439065,994600610,15540634,16.7),(55031,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55031,37.77,0.46,358,16442,70,NULL,NULL,'2MASX J08311453+1606059',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000187,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,127.810625,16.10183,0.117,NULL,63784955542,996639930,15572498,16.8),(55032,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55032,36.63,0.46,212,16443,70,NULL,NULL,'2MASX J08311845+3109460',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000179,NULL,'16.0g',0.37,'E0',NULL,NULL,NULL,NULL,1,127.827041667,31.16269,0.125,NULL,64344113436,1005376772,15709012,16),(55033,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55033,36.52,0.46,202,16444,70,NULL,NULL,'2MASX J08311925+3535490',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000201,NULL,'15.8g',0.41,'E0',NULL,NULL,NULL,NULL,1,127.8304583,35.59689,0.113,NULL,64364647353,1005697614,15714025,15.8),(55034,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55034,36.64,0.46,213,16445,70,NULL,NULL,'2MASX J08311934+1406369',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.92',0.22,NULL,NULL,NULL,NULL,NULL,1,127.8305,14.11028,0.169,NULL,63839919338,997498739,15585917,17.92),(55035,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55035,36.73,0.46,222,16446,70,NULL,NULL,'2MASX J08312099+4613144',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000081,NULL,'15.9g',0.45,'E0',NULL,NULL,NULL,NULL,1,127.837625,46.22072,0.137,NULL,64248747590,1003886681,15685729,15.9),(55036,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55036,32.36,NULL,29.7,16447,NULL,NULL,NULL,'CGCG 032-035',NULL,'2015AstBu..70....1K',2015,1,0.7,NULL,'G',0.000025,NULL,'16.0g',0.4,NULL,NULL,NULL,NULL,NULL,1,127.840167,7.00003,0.077,NULL,62575746885,977746045,15277281,16),(55037,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55037,36.31,0.53,182,16448,70,NULL,NULL,'2MASX J08312211-0407384',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.24',NULL,NULL,NULL,NULL,NULL,NULL,1,127.8422083,-4.12736,0.125,NULL,39257797711,613403089,9584423,16.24),(55038,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55038,37.04,0.46,256,16449,70,NULL,NULL,'2MASX J08312364+4455274',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000103,NULL,'15.9g',0.42,'S0',NULL,NULL,NULL,NULL,1,127.8485,44.92419,0.137,NULL,64252124616,1003939447,15686553,15.9),(55039,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55039,35.47,0.5,124,16450,70,NULL,NULL,'MCG -01-22-017',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000087,NULL,'15.5',0.6,'(R\')SAB0^0^ pec?',NULL,NULL,NULL,NULL,1,127.851125,-4.03608,0.125,NULL,39255908198,613373565,9583961,15.5),(55040,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55040,38.45,0.46,490,16451,70,NULL,NULL,'2MASX J08312429+2633255',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000197,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,127.8512917,26.55725,0.093,NULL,64319543109,1004992861,15703013,17.3),(55041,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55041,37.9,0.46,380,16452,70,NULL,NULL,'SDSS J083124.41+430539.4',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000141,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,127.85175,43.09428,0.137,NULL,64254401575,1003975024,15687109,17.9),(55042,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55042,36.83,0.46,233,16453,70,NULL,NULL,'2MASX J08312469+0500485',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000176,NULL,'16.3g',0.4,NULL,NULL,NULL,NULL,NULL,1,127.852833,5.01333,0.049,NULL,62609853500,978278960,15285608,16.3),(55043,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55043,34.05,0.2,64.6,16454,74.4,NULL,NULL,'UGC 04450',NULL,'2013AJ....146...86T',2013,1,1.38,NULL,'G',0.000033,NULL,'15.6g',0.25,'Scd:',NULL,NULL,NULL,NULL,1,127.853166667,27.58003,0.097,NULL,64318601475,1004978148,15702783,15.6),(55044,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55044,34.12,0.49,66.8,16454,75,NULL,'IR','UGC 04450',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55045,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55045,34.12,0.44,66.8,16454,NULL,NULL,NULL,'UGC 04450',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55046,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55046,34.21,0.42,69.4,16454,NULL,NULL,'Malmquist cor.','UGC 04450',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55047,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55047,38.16,0.33,429,16455,70,NULL,NULL,'2MASX J08312633+3142210',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000176,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,127.859833,31.70572,0.109,NULL,64344440795,1005381887,15709091,17.6),(55048,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55048,37.32,0.33,291,16456,70,NULL,NULL,'2MASX J08312684+0940287',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,127.8617917,9.67481,0.137,NULL,62564429664,977569213,15274518,16.7),(55049,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55049,36.98,0.78,249,16457,70,NULL,NULL,'2MASX J08312703-0235315',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,127.862583,-2.592,0.053,NULL,39252214941,613315858,9583060,15.6),(55050,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55050,36.56,0.46,205,16458,70,NULL,NULL,'4C +32.25',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000182,NULL,'15.7g',0.48,'E              WLAGN',NULL,NULL,NULL,NULL,1,127.864541667,32.32411,0.121,NULL,64341131786,1005330184,15708284,15.7),(55051,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55051,38.27,0.46,451,16459,70,NULL,NULL,'2MASX J08313146+1524414',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,127.881125,15.41133,0.121,NULL,63771279202,996426237,15569159,17.8),(55052,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55052,37.73,0.46,351,16460,70,NULL,NULL,'2MASX J08313233+2910039',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000142,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,127.88475,29.16767,0.093,NULL,64342750214,1005355472,15708679,17.4),(55053,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 2007bd',NULL,55053,34.85,0.17,90.5,16461,74.2,NULL,'SALT 2','UGC 04455',0.031018,'2010ApJ...716..712A',2010,1,0.9,'RC3 has V = 1347 +- 54 km/s.  6dF agrees with UZC.','G',0.00015,NULL,'14.60',0.8,'SB(r)a','Isolated galaxy',NULL,NULL,NULL,1,127.887,-1.19772,0.081,NULL,39220348391,612817943,9575280,14.6),(55054,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 2007bd',NULL,55054,35.52,0.11,119,16461,72,NULL,NULL,'UGC 04455',0.03196,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55055,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 2007bd','R',55055,35.43,0.07,122,16461,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 04455',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55056,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 2007bd',NULL,55056,35.46,0.09,124,16461,74.4,NULL,NULL,'UGC 04455',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55057,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 2007bd','R',55057,35.48,0.07,125,16461,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 04455',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55058,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 2007bd',NULL,55058,35.59,0.16,128,16461,70,NULL,'SALT 2','UGC 04455',0.031018,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55059,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 2007bd',NULL,55059,35.64,0.21,130,16461,73.8,NULL,'SALT 2 (SNANA)','UGC 04455',0.0316,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55060,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 2007bd',NULL,55060,35.63,0.04,130,16461,72,NULL,'MLCS17','UGC 04455',0.031018,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55061,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 2007bd',NULL,55061,35.71,0.19,134,16461,73.8,NULL,'SALT 2 (SNANA)','UGC 04455',0.0316,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55062,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 2007bd',NULL,55062,35.72,0.17,135,16461,65,NULL,'MLCS17','UGC 04455',0.031018,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55063,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 2007bd',NULL,55063,35.66,0.05,136,16461,72,NULL,'M(H) = -18.317 mag','UGC 04455',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55064,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 2007bd',NULL,55064,35.74,0.16,136,16461,65,NULL,'SALT','UGC 04455',0.031018,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55065,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 2007bd',NULL,55065,35.8,0.19,140,16461,65,NULL,'SALT2','UGC 04455',0.031018,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55066,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 2007bd',NULL,55066,35.84,0.16,143,16461,65,NULL,'MLCS31','UGC 04455',0.031018,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55067,'SNIa','2016-12-15 15:14:22','2016-12-16 11:19:28','1','SN 2007bd',NULL,55067,35.98,0.02,152,16461,70,NULL,'SALT 2','UGC 04455',0.031018,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55068,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55068,35.79,0.58,144,16461,70,NULL,NULL,'UGC 04455',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55069,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55069,38.09,0.33,414,16462,70,NULL,NULL,'2MASX J08313361+5030336',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,'FoF','16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,127.890333,50.50933,0.121,NULL,63496220240,992128441,15502006,16.8),(55070,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55070,36.4,0.63,191,16463,70,NULL,NULL,'2MASX J08313485-1101478',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,127.89525,-11.02992,0.201,NULL,42164805354,658825083,10294141,14.6),(55071,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55071,38.09,0.33,414,16464,70,NULL,NULL,'2MASX J08313508+5031186',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000078,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,127.896,50.52172,0.121,NULL,63496220621,992128447,15502006,18.4),(55072,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55072,37.7,0.46,346,16465,70,NULL,NULL,'2MASX J08313620+2636329',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000174,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,127.900958333,26.60925,0.093,NULL,64319585425,1004993522,15703023,17.2),(55073,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55073,36.31,0.58,183,16466,70,NULL,NULL,'2MASX J08313724-6425105',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,127.905291667,-64.41953,0.693,NULL,40779007351,637171989,9955812,16.6),(55074,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55074,38.96,0.46,618,16467,70,NULL,NULL,'SDSS J083138.61+272222.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000766,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,127.910917,27.37294,0.097,NULL,64318365689,1004974463,15702725,18.4),(55075,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55075,37.63,0.27,336,16468,70,NULL,NULL,'2MASX J08313883+2234226',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000215,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,127.911833,22.57306,0.081,NULL,63792394295,996756160,15574315,16.6),(55076,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55076,35.68,0.46,137,16469,70,NULL,NULL,'CGCG 089-039',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000175,NULL,'15.7g',0.36,NULL,NULL,NULL,NULL,NULL,1,127.919708333,19.38553,0.073,NULL,63807348670,996989822,15577965,15.7),(55077,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55077,36.45,0.46,195,16470,70,NULL,NULL,'2MASX J08314117+5555525',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000168,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,127.921541667,55.93128,0.141,NULL,61555457137,961804017,15028187,16.4),(55078,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55078,37.63,0.46,336,16471,70,NULL,NULL,'2MASX J08314149+2517499',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,127.922833333,25.29719,0.105,NULL,64319136629,1004986509,15702914,17.6),(55079,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55079,37.63,0.27,336,16472,70,NULL,NULL,'2MASX J08314180+2239286',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000173,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,127.924041667,22.65797,0.081,NULL,63792388556,996756071,15574313,17),(55080,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55080,35.95,0.46,155,16473,70,NULL,NULL,'2MASX J08314235+4859005',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000079,NULL,'16.1g',0.38,'E0',NULL,NULL,NULL,NULL,1,127.9264583,48.98347,0.129,NULL,63494121155,992095643,15501494,16.1),(55081,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55081,36.97,0.8,247,16474,70,NULL,NULL,'2MASX J08314344-0834201',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,127.931,-8.57222,0.113,NULL,39240822210,613137847,9580278,15.7),(55082,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55082,36.63,0.72,212,16475,70,NULL,NULL,'2MASX J08314397-0326166',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.7I',0.3,NULL,NULL,NULL,NULL,NULL,1,127.933167,-3.43797,0.101,NULL,39256425057,613381641,9584088,14.7),(55083,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55083,37.68,0.46,343,16476,70,NULL,NULL,'2MASX J08314478+1324464',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,127.936625,13.41292,0.153,NULL,63840812443,997512694,15586135,17.8),(55084,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55084,36.96,0.46,246,16477,70,NULL,NULL,'2MASX J08314611+0813279',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,127.94225,8.22425,0.021,NULL,62576596696,977759323,15277489,17.3),(55085,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55085,37.52,0.46,320,16478,70,NULL,NULL,'SDSS J083146.16+062422.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000138,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,127.942333,6.40614,0.089,NULL,62572759189,977699362,15276552,18.4),(55086,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55086,37.63,0.27,336,16479,70,NULL,NULL,'2MASX J08314786+2239056',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000222,NULL,'16.1g',0.38,NULL,NULL,NULL,NULL,NULL,1,127.949333,22.65164,0.081,NULL,63792388955,996756077,15574313,16.1),(55087,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55087,37.38,0.85,300,16480,70,NULL,NULL,'2MASX J08314822-0509456',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,127.9510417,-5.16272,0.125,NULL,39257489519,613398273,9584348,14.5),(55088,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55088,38.51,0.46,504,16481,70,NULL,NULL,'2MASX J08314848+3333332',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000137,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,127.952083,33.55939,0.073,NULL,64332577846,1005196528,15706195,17.8),(55089,'BL Lac Luminosity','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55089,39.71,NULL,746,16482,NULL,NULL,NULL,'[HB89] 0829+046',0.173683,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.000232,NULL,'15.8g',NULL,'blazar         BLLAC',NULL,NULL,'radio jet','BL Lac',1,127.953667,4.49419,0.045,NULL,62611683646,978307556,15286055,15.8),(55090,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55090,38.44,0.46,489,16483,70,NULL,NULL,'SDSS J083151.05+095842.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,127.96275,9.97844,0.141,NULL,63654660749,994604074,15540688,18.1),(55091,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55091,38.57,0.46,518,16484,70,NULL,NULL,'2MASX J08315373+4014158',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,127.973833,40.23781,0.121,NULL,64241866928,1003779170,15684049,18.4),(55092,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55092,37.32,0.33,291,16485,70,NULL,NULL,'2MASX J08315418+0940059',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,127.975833,9.66842,0.137,NULL,62564465023,977569765,15274527,17.7),(55093,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55093,36.39,0.46,190,16486,70,NULL,NULL,'2MASX J08315417+3400332',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000147,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,127.975958333,34.00914,0.077,NULL,64336120379,1005251880,15707060,16.8),(55094,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55094,39.58,0.46,824,16487,70,NULL,NULL,'SDSS J083154.42+515904.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000095,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,127.9767917,51.98461,0.129,NULL,63501512100,992211126,15503298,18.6),(55095,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55095,36.02,0.65,160,16488,70,NULL,NULL,'2MASX J08315585-0821131',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,127.9827917,-8.35361,0.109,NULL,39240239434,613128741,9580136,15.4),(55096,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55096,37.88,0.27,376,16489,70,NULL,NULL,'SDSS J083157.05+304137.9',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000154,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,127.98775,30.69389,0.109,NULL,64344180837,1005377825,15709028,18.8),(55097,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55097,36.1,0.46,166,16490,70,NULL,NULL,'2MASX J08315858+5620520',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.00008,NULL,'15.5g',0.49,NULL,NULL,NULL,NULL,NULL,1,127.9937083,56.34789,0.145,NULL,61555029902,961797342,15028083,15.5),(55098,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55098,38.15,0.46,426,16491,70,NULL,NULL,'2MASXi J0831595+131321',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,127.9980417,13.22267,0.161,NULL,63841295906,997520248,15586253,17.6),(55099,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55099,37.88,0.27,376,16492,70,NULL,NULL,'2MASX J08315972+3039302',NULL,'2015arXiv151105856S',2015,1,0.48,'May be a resolved component of 87GB 082854.2+304907.','G',0.000179,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,127.99875,30.6585,0.109,NULL,64343082410,1005360662,15708760,16.7),(55100,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55100,35.37,NULL,119,16493,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0765',NULL,'2010Ap&SS.325..163P',2010,1,0.45,NULL,'G',0.000011,NULL,'17.7g',0.13,'Scd',NULL,NULL,NULL,NULL,1,128.0014583,19.56647,0.073,NULL,63807837297,996997457,15578085,17.7),(55101,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55101,35.38,NULL,119,16493,NULL,NULL,'Dipole + Quadrupole','FGC 0765',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55102,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55102,35.38,NULL,119,16493,NULL,NULL,'Dipole','FGC 0765',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55103,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55103,36.47,0.2,197,16493,74.4,NULL,NULL,'FGC 0765',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55104,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55104,37.75,0.46,355,16494,70,NULL,NULL,'2MASX J08320492+1303482',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,128.0204583,13.06353,0.157,NULL,63841245495,997519460,15586241,17.7),(55105,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55105,36.76,0.46,225,16495,70,NULL,NULL,'2MASX J08320742+3047372',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000185,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,128.030833,30.79358,0.121,NULL,64344179925,1005377811,15709028,16.4),(55106,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55106,37.79,0.27,362,16496,70,NULL,NULL,'2MASX J08320966+2635461',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,128.0402083,26.59614,0.093,NULL,64319566355,1004993224,15703019,17.6),(55107,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55107,37.58,0.46,328,16497,70,NULL,NULL,'2MASX J08321063+3102210',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000204,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,128.044375,31.03917,0.125,NULL,64344290122,1005379533,15709055,16.4),(55108,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55108,37.88,0.27,376,16498,70,NULL,NULL,'SDSS J083211.36+303726.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,128.047375,30.62417,0.109,NULL,64343083825,1005360684,15708760,18.3),(55109,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55109,36.15,0.58,170,16499,70,NULL,NULL,'2MASX J08321146-0411504',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.99',NULL,NULL,NULL,NULL,NULL,NULL,1,128.047625,-4.19739,0.141,NULL,39257802998,613403171,9584424,16.99),(55110,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55110,37.63,0.46,335,16500,70,NULL,NULL,'SDSS J083213.38+385709.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000158,NULL,'18.8g',0.09,NULL,NULL,NULL,NULL,NULL,1,128.055791667,38.95278,0.109,NULL,64360229539,1005628586,15712946,18.8),(55111,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55111,39.08,0.46,656,16501,70,NULL,NULL,'SDSS J083215.86+524131.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000078,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,128.066083333,52.69217,0.133,NULL,63501135355,992205239,15503206,18.4),(55112,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55112,37.98,0.33,394,16502,70,NULL,NULL,'2MASX J08321637+2500441',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00016,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,128.068083,25.01228,0.077,NULL,63794580913,996790326,15574848,16.8),(55113,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55113,36.15,0.46,170,16503,70,NULL,NULL,'2MASX J08321682+1150487',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.00009,NULL,'15.5g',0.5,NULL,NULL,NULL,NULL,NULL,1,128.070125,11.84686,0.101,NULL,63653433000,994584890,15540388,15.5),(55114,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55114,36.57,0.46,206,16504,70,NULL,NULL,'2MASX J08321762+3420310',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000179,NULL,'16.2g',0.3,'E0',NULL,NULL,NULL,NULL,1,128.0735,34.34208,0.113,NULL,64335966119,1005249470,15707022,16.2),(55115,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55115,35.16,0.48,107,16505,70,NULL,NULL,'2MASX J08321780-0012034',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'16.27',0.51,NULL,NULL,NULL,NULL,NULL,1,128.0742917,-0.20092,0.105,NULL,39217032097,612766126,9574470,16.27),(55116,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55116,37.27,0.46,285,16506,70,NULL,NULL,'2MASX J08321785+2504561',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,128.0745,25.08225,0.053,NULL,64317030513,1004953601,15702400,18.2),(55117,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55117,38.41,0.46,480,16507,70,NULL,NULL,'2MASX J08321978+2727230',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,128.082416667,27.4565,0.117,NULL,64318570980,1004977671,15702776,18.1),(55118,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55118,38.44,0.46,488,16508,70,NULL,NULL,'SDSS J083220.16+482457.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000081,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,128.084,48.41597,0.133,NULL,63494280893,992098138,15501533,18.6),(55119,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55119,37.2,0.27,276,16509,70,NULL,NULL,'2MASX J08322101+3959532',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00018,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,128.087625,39.998,0.113,NULL,64359577912,1005618404,15712787,16.3),(55120,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55120,35.04,NULL,102,16510,NULL,NULL,NULL,'FGC 0767',NULL,'2000BSAO...50....5K',2000,1,0.8,NULL,'G',0.00003,NULL,'17.9g',0.08,'Sdm',NULL,NULL,NULL,NULL,1,128.09325,3.49958,0.053,NULL,62610822760,978294105,15285845,17.9),(55121,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55121,35.12,NULL,105,16510,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0767',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55122,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55122,35.13,NULL,106,16510,NULL,NULL,'Dipole + Quadrupole','FGC 0767',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55123,'Tully-Fisher','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55123,35.14,NULL,107,16510,NULL,NULL,'Dipole','FGC 0767',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55124,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55124,36.95,0.33,245,16511,70,NULL,NULL,'2MASX J08322278+0433191',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00017,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,128.094875,4.55528,0.045,NULL,62611659414,978307178,15286049,16.8),(55125,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55125,37.94,0.46,387,16512,70,NULL,NULL,'2MASX J08322280+3734232',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000176,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,128.095125,37.57322,0.113,NULL,64372866336,1005826036,15716031,17.3),(55126,'BL Lac Luminosity','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55126,42.5,NULL,2040,16513,NULL,NULL,NULL,'[HB89] 0828+493',0.548,'2005ApJ...635..173S',2005,1,NULL,'SDSS DR1 has z = 1.2640.','QSO',NULL,NULL,'19.9g',NULL,'Opt.var.       BLLAC',NULL,NULL,'radio jet','BL Lac',1,128.09675,49.2225,0.129,NULL,63496886241,992138847,15502169,19.9),(55127,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55127,38.04,0.33,405,16514,70,NULL,NULL,'2MASX J08322412+1649491',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.0002,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,128.1005417,16.83033,0.089,NULL,63777300966,996520327,15570630,17),(55128,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55128,34.85,0.49,93.5,16515,70,NULL,NULL,'CGCG 004-047 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000073,NULL,'16.13',NULL,NULL,NULL,NULL,NULL,NULL,1,128.10325,-3.20922,0.069,NULL,39256171215,613377675,9584026,16.13),(55129,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55129,37.79,0.27,362,16516,70,NULL,NULL,'2MASX J08322494+2636350',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000181,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,128.104041667,26.60986,0.109,NULL,64319559849,1004993122,15703017,17.3),(55130,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55130,37.22,0.46,278,16517,70,NULL,NULL,'2MASX J08322534+3626182',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,128.1057917,36.43833,0.117,NULL,64372152509,1005814882,15715857,17.7),(55131,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55131,36.62,0.46,210,16518,70,NULL,NULL,'2MASX J08322655+1302598',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,128.110667,13.04986,0.157,NULL,63841144931,997517889,15586217,NULL),(55132,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55132,37.1,0.27,263,16519,70,NULL,NULL,'2MASX J08322721+5226358',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000083,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,128.113375,52.44317,0.137,NULL,63501155942,992205561,15503211,16.6),(55133,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55133,35.8,0.73,145,16520,70,NULL,NULL,'2MASX J08322742-0320498',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'17.09',0.2,NULL,NULL,NULL,NULL,NULL,1,128.1139583,-3.34708,0.069,NULL,39256272946,613379264,9584051,17.09),(55134,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55134,37.79,0.27,362,16521,70,NULL,NULL,'2MASX J08322770+2637560',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,128.1152917,26.63219,0.093,NULL,64318695237,1004979613,15702806,18),(55135,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55135,36.31,0.67,183,16522,70,NULL,NULL,'2MASX J08322802-0321548',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.65',NULL,NULL,NULL,NULL,NULL,NULL,1,128.116708333,-3.36514,0.069,NULL,39256265890,613379154,9584049,16.65),(55136,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55136,35.52,0.46,127,16523,70,NULL,NULL,'MRK 0091',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000067,NULL,'14.7g',0.66,'S?;NELG        HII',NULL,NULL,NULL,NULL,1,128.11725,52.60622,0.137,NULL,63501170317,992205786,15503215,14.7),(55137,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55137,37.17,0.46,272,16524,70,NULL,NULL,'2MASX J08322833+1827507',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,128.118083,18.46428,0.081,NULL,63778120293,996533129,15570830,18),(55138,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55138,37.24,0.46,280,16525,70,NULL,NULL,'2MASX J08322842+1033547',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,128.118333,10.56531,0.113,NULL,63654524171,994601940,15540655,17),(55139,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55139,37.5,0.33,316,16526,70,NULL,NULL,'2MASX J08322883+2541210',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,128.12025,25.68917,0.093,NULL,64319362382,1004990037,15702969,17.1),(55140,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55140,37.14,0.46,268,16527,70,NULL,NULL,'2MASX J08323005+3513340',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000169,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,128.125417,35.22594,0.129,NULL,64364129030,1005689516,15713898,16.7),(55141,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55141,38.04,0.33,405,16528,70,NULL,NULL,'2MASX J08323103+1650118',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,128.129208333,16.83669,0.089,NULL,63777301189,996520331,15570630,17.8),(55142,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55142,37.2,0.46,276,16529,70,NULL,NULL,'2MASX J08323116+1753427',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,128.1299583,17.89531,0.029,NULL,63778147096,996533548,15570836,17.3),(55143,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55143,38.01,0.46,400,16530,70,NULL,NULL,'2MASX J08323126+0948437',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,128.13025,9.81206,0.137,NULL,63653999507,994593742,15540527,17.2),(55144,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55144,36.95,0.33,245,16531,70,NULL,NULL,'2MASX J08323411+0424363',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',NULL,NULL,'15.9g',0.44,NULL,NULL,NULL,NULL,NULL,1,128.14225,4.41011,0.041,NULL,62611706787,978307918,15286061,15.9),(55145,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55145,36.89,0.46,239,16532,70,NULL,NULL,'2MASX J08323546+0953207',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,128.1477917,9.88922,0.137,NULL,63653990890,994593607,15540525,17.5),(55146,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55146,37.73,0.46,351,16533,70,NULL,NULL,'2MASX J08323634+1904588',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000165,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,128.151417,19.08308,0.085,NULL,63807378094,996990282,15577973,16.8),(55147,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,NULL,55147,37.42,0.84,305,16534,70,NULL,NULL,'2MASX J08323655-5940344',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,128.152333333,-59.67619,0.885,NULL,40592554932,634258670,9910291,17.6),(55148,'FP','2016-12-15 15:14:22','2016-12-16 11:19:28','1',NULL,'R',55148,36.96,0.46,247,16535,70,NULL,NULL,'2MASX J08323941+5314000',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000077,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,128.164417,53.23325,0.133,NULL,63500599706,992196870,15503076,17),(55149,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55149,36.83,0.67,233,16536,70,NULL,NULL,'2MASX J08324087-1911317',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,128.17025,-19.19206,0.385,NULL,42265738037,660402156,10318783,15.5),(55150,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55150,37.28,0.46,286,16537,70,NULL,NULL,'SDSS J083241.53+165520.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,128.173083,16.92247,0.093,NULL,63777283500,996520054,15570625,18),(55151,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55151,37.37,0.56,297,16538,70,NULL,NULL,'2MASX J08324282-0017018',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'15.6R',0.31,NULL,NULL,NULL,NULL,NULL,1,128.178458333,-0.28394,0.117,NULL,39217244750,612769449,9574522,15.6),(55152,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55152,37.54,0.46,321,16539,70,NULL,NULL,'SDSS J083243.47+170702.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,128.181166667,17.11736,0.093,NULL,63777607535,996525117,15570704,18.2),(55153,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55153,36.57,0.46,206,16540,70,NULL,NULL,'2MASX J08324450+0632479',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,128.185375,6.54672,0.081,NULL,62572889410,977701397,15276584,17.1),(55154,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55154,37.1,0.27,263,16541,70,NULL,NULL,'2MASX J08324470+5235210',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000093,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,128.186167,52.58919,0.137,NULL,63501169189,992205768,15503215,17.1),(55155,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55155,35.53,0.59,128,16542,70,NULL,NULL,'2MASX J08324598-5941457',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,128.1917083,-59.69608,0.885,NULL,40593393675,634271776,9910496,17.3),(55156,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55156,37.58,0.46,328,16543,70,NULL,NULL,'2MASX J08324665+2841146',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000155,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,128.194375,28.68742,0.129,NULL,64319694827,1004995231,15703050,17.6),(55157,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55157,36.55,0.62,204,16544,70,NULL,NULL,'2MASX J08324708-1855457',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.58',NULL,NULL,NULL,NULL,NULL,NULL,1,128.1960417,-18.92956,0.321,NULL,42265542429,660399100,10318735,16.58),(55158,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55158,38.17,0.46,430,16545,70,NULL,NULL,'SDSS J083248.28+303927.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,128.2012083,30.65764,0.109,NULL,64343003085,1005359423,15708740,18.5),(55159,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55159,37.53,0.46,321,16546,70,NULL,NULL,'2MASX J08324872+6112352',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,128.202833,61.20969,0.125,NULL,62047732315,969495817,15148372,17.8),(55160,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55160,38.08,0.46,413,16547,70,NULL,NULL,'2MASX J08324900+4349545',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000018,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,128.2040417,43.83183,0.093,NULL,64249876312,1003904317,15686004,16.9),(55161,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55161,37.07,0.33,259,16548,70,NULL,NULL,'2MASX J08325096+3052454',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,128.2122917,30.87925,0.121,NULL,64344248834,1005378888,15709045,16.8),(55162,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55162,37.07,0.33,259,16549,70,NULL,NULL,'2MASX J08325103+3053494',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,128.2127917,30.89714,0.121,NULL,64344249077,1005378891,15709045,17.8),(55163,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55163,37.82,0.23,367,16550,70,NULL,NULL,'2MASX J08325250+1532277',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000134,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,128.2187917,15.54097,0.121,NULL,63784881730,996638777,15572480,17.9),(55164,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55164,37.5,0.33,316,16551,70,NULL,NULL,'2MASX J08325326+2536216',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000177,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,128.222083,25.60594,0.093,NULL,64319360841,1004990013,15702968,16.7),(55165,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55165,37.1,0.27,263,16552,70,NULL,NULL,'2MASX J08325402+5233320',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000107,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,128.225,52.55897,0.137,NULL,63501164471,992205694,15503213,16.6),(55166,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55166,37.53,0.46,320,16553,70,NULL,NULL,'2MASX J08325402+5046350',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000083,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,128.22525,50.77631,0.141,NULL,63496051732,992125808,15501965,17.2),(55167,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55167,35.48,0.56,124,16554,70,NULL,NULL,'2MASX J08325728-0351295',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'16.38',0.6,NULL,NULL,NULL,NULL,NULL,1,128.23875,-3.85822,0.125,NULL,39258525968,613414468,9584601,16.38),(55168,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55168,38.69,0.46,546,16555,70,NULL,NULL,'2MASX J08325766+2301189',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,128.24025,23.02192,0.085,NULL,63793233312,996769270,15574519,17.9),(55169,'GRB','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55169,46.53,1.49,7940,16556,NULL,NULL,NULL,'GRB 090102',1.547,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,128.244,33.11417,0.089,NULL,64333253080,1005207079,15706360,NULL),(55170,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55170,34.16,0.2,67.9,16557,74.4,NULL,NULL,'UGC 04464',NULL,'2013AJ....146...86T',2013,1,1.77,NULL,'G',0.000033,NULL,'15.3g',0.29,'SBcd?','Group member, peripheral',NULL,NULL,NULL,1,128.250833,26.01403,0.105,NULL,64319217700,1004987776,15702934,15.3),(55171,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55171,34.31,0.49,72.9,16557,75,NULL,'IR','UGC 04464',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55172,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55172,34.49,0.13,79.2,16557,NULL,NULL,NULL,'UGC 04464',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55173,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55173,38.15,0.27,426,16558,70,NULL,NULL,'2MASX J08330045+1347209',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000185,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,128.251833,13.78931,0.141,NULL,63840860096,997513439,15586147,17.3),(55174,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55174,36.98,0.46,249,16559,70,NULL,NULL,'2MASX J08330052+1431259',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000166,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,128.2522083,14.52394,0.165,NULL,63840395187,997506174,15586033,16.9),(55175,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55175,39.02,0.46,635,16560,70,NULL,NULL,'2MASX J08330279+2531136',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.9g',0.1,NULL,NULL,NULL,NULL,NULL,1,128.261625,25.52056,0.093,NULL,64319144646,1004986635,15702916,18.9),(55176,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55176,37.52,0.46,320,16561,70,NULL,NULL,'2MASX J08330304+6052061',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,128.262667,60.86844,0.125,NULL,62048098190,969501534,15148461,17.2),(55177,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55177,38.15,0.27,426,16562,70,NULL,NULL,'2MASX J08330326+1348309',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,128.2635417,13.80872,0.141,NULL,63840848507,997513257,15586144,18),(55178,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55178,37.92,0.46,384,16563,70,NULL,NULL,'2MASX J08330347+6013111',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,128.264583,60.21981,0.129,NULL,62046651333,969478927,15148108,18.2),(55179,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55179,38.15,0.27,426,16564,70,NULL,NULL,'2MASX J08330381+1348429',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,128.265875,13.81197,0.141,NULL,63840848479,997513257,15586144,18.1),(55180,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55180,34.03,0.48,64,16565,70,NULL,NULL,'IC 0513',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000063,NULL,'14.29',0.7,'SB(rs)0^0^?',NULL,NULL,NULL,NULL,1,128.271083333,-12.35556,0.281,NULL,42379785791,662184152,10346627,14.29),(55181,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55181,37.78,0.46,360,16566,70,NULL,NULL,'2MASXi J0833066+153748',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.6g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,128.277417,15.63011,0.121,NULL,63776505837,996507903,15570435,17.6),(55182,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55182,37.05,0.46,257,16567,70,NULL,NULL,'2MASX J08330754+1200189',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000191,NULL,'17.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,128.28125,12.00511,0.105,NULL,63656193473,994628023,15541062,17.3),(55183,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55183,37.9,0.46,380,16568,70,NULL,NULL,'2MASX J08330991+4709305',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000088,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,128.2912917,47.15853,0.137,NULL,63522787872,992543560,15508493,17.6),(55184,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55184,36.86,0.33,235,16569,70,NULL,NULL,'2MASX J08331016+4940059',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000108,NULL,'15.5g',0.47,'AGN',NULL,NULL,NULL,NULL,1,128.292375,49.66814,0.129,NULL,63497521710,992148776,15502324,15.5),(55185,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55185,38.3,0.46,457,16570,70,NULL,NULL,'2MASX J08331026+3028343',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,128.2929583,30.47617,0.109,NULL,64343003141,1005359424,15708741,17.3),(55186,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55186,37.03,0.46,255,16571,70,NULL,NULL,'2MASX J08331074+5159539',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000088,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,128.294667,51.99836,0.129,NULL,63501522625,992211291,15503301,16.4),(55187,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55187,38.01,0.46,400,16572,70,NULL,NULL,'2MASX J08331181+4642065',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000076,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,128.299125,46.70169,0.145,NULL,64248457714,1003882151,15685658,17.6),(55188,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55188,35.01,0.46,101,16573,70,NULL,NULL,'CGCG 208-015',NULL,'2015arXiv151105856S',2015,1,0.94,NULL,'G',0.000163,NULL,'14.4g',0.79,'E0',NULL,NULL,NULL,NULL,1,128.30225,41.09486,0.133,NULL,64241417971,1003772155,15683939,14.4),(55189,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55189,37.38,0.46,299,16574,70,NULL,NULL,'2MASX J08331417+2701160',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,128.309125,27.02117,0.113,NULL,64318242371,1004972537,15702695,17.5),(55190,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55190,37.6,0.46,330,16575,70,NULL,NULL,'2MASX J08331441+5147508',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000072,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,128.31,51.79744,0.137,NULL,63501417772,992209652,15503275,17.7),(55191,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55191,37.13,0.91,266,16576,70,NULL,NULL,'2MASX J08331463-5759517',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,128.311125,-57.99775,0.893,NULL,40411745518,631433523,9866148,17.7),(55192,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55192,37.2,0.27,276,16577,70,NULL,NULL,'2MASX J08331489+4004172',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00019,NULL,'16.1g',0.37,'E0',NULL,NULL,NULL,NULL,1,128.312,40.07147,0.121,NULL,64359600443,1005618756,15712793,16.1),(55193,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55193,37.2,0.27,276,16578,70,NULL,NULL,'SDSS J083314.97+400526.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000162,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,128.312416667,40.09058,0.121,NULL,64359600478,1005618757,15712793,18.2),(55194,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55194,37.4,0.46,302,16579,70,NULL,NULL,'SDSS J083315.74+150105.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'17.9g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,128.315583,15.01811,0.141,NULL,63839653775,997494590,15585852,17.9),(55195,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55195,36.81,0.46,231,16580,70,NULL,NULL,'2MASX J08331601+5009288',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00009,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,128.3165417,50.15797,0.133,NULL,63496614672,992134604,15502103,17.1),(55196,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55196,37.81,0.46,365,16581,70,NULL,NULL,'2MASX J08331695+3058492',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,128.320833,30.98039,0.121,NULL,64344055802,1005375871,15708997,17),(55197,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55197,37.67,0.46,342,16582,70,NULL,NULL,'2MASX J08331717+2317308',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000185,NULL,'17.1g',0.25,'AGN',NULL,NULL,NULL,NULL,1,128.321625,23.29197,0.089,NULL,63792604734,996759448,15574366,17.1),(55198,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55198,38.26,0.46,449,16583,70,NULL,NULL,'SDSS J083317.36+135048.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000153,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,128.322375,13.84678,0.141,NULL,63840846439,997513225,15586144,18.2),(55199,'IRAS','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55199,33.98,0.8,62.7,16584,75,NULL,'MAT, I','ESO 562- G 014',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000017,NULL,'15.0b',0.3,'SBb pec sp',NULL,NULL,NULL,NULL,1,128.3205,-17.95894,0.201,NULL,42256923519,660264429,10316631,15),(55200,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55200,34.21,0.4,69.4,16584,NULL,NULL,'mean','ESO 562- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55201,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55201,34.28,0.32,71.7,16584,85,NULL,'I, raw','ESO 562- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55202,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55202,34.33,0.32,73.6,16584,85,NULL,'I, inv','ESO 562- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55203,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55203,34.39,0.38,75.5,16584,NULL,NULL,'Malmquist cor.','ESO 562- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55204,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55204,34.44,0.47,77.2,16584,NULL,NULL,'H','ESO 562- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55205,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55205,34.48,0.45,78.7,16584,NULL,NULL,'K','ESO 562- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55206,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55206,34.57,0.43,81.9,16584,75,NULL,'MAT, I, raw','ESO 562- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55207,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55207,34.65,0.34,85,16584,NULL,NULL,NULL,'ESO 562- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55208,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55208,34.66,0.2,85.5,16584,74.4,NULL,NULL,'ESO 562- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55209,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55209,34.78,0.43,90.3,16584,75,NULL,'MAT, I, cor','ESO 562- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55210,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55210,34.83,0.43,92.6,16584,75,NULL,'MAT, I, inv','ESO 562- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55211,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55211,35.85,0.48,148,16585,70,NULL,NULL,'2MASX J08331852-0230535',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000127,NULL,'16.26',0.7,NULL,NULL,NULL,NULL,NULL,1,128.327333,-2.51506,0.065,NULL,39251734301,613308348,9582942,16.26),(55212,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55212,38.13,0.46,423,16586,70,NULL,NULL,'2MASX J08331884+2427360',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000175,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,128.328667,24.46003,0.081,NULL,63794760319,996793129,15574892,18.3),(55213,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55213,37.28,0.46,285,16587,70,NULL,NULL,'SDSS J083318.96+082502.7',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000178,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,128.329,8.41742,0.021,NULL,62571745011,977683515,15276304,17.5),(55214,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55214,37.83,0.46,368,16588,70,NULL,NULL,'2MASX J08331928+0426416',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000207,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,128.33025,4.44492,0.041,NULL,62612119182,978314362,15286161,17),(55215,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55215,38.29,0.46,455,16589,70,NULL,NULL,'2MASX J08332016+2657490',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000142,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,128.333917,26.96364,0.113,NULL,64318228499,1004972320,15702692,18.1),(55216,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55216,36.92,0.46,243,16590,70,NULL,NULL,'2MASX J08332054+3033412',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00018,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,128.335667,30.56147,0.109,NULL,64343005004,1005359453,15708741,16.7),(55217,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55217,37.76,0.46,357,16591,70,NULL,NULL,'2MASX J08332109+6104094',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,128.338083,61.06919,0.125,NULL,62048224677,969503510,15148492,17.4),(55218,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55218,37.98,0.33,394,16592,70,NULL,NULL,'SDSS J083321.42+250624.7',NULL,'2015arXiv151105856S',2015,1,0.11,NULL,'G',0.000149,NULL,'19.0g',0.09,NULL,NULL,NULL,NULL,NULL,1,128.33925,25.10686,0.081,NULL,64317087978,1004954499,15702414,19),(55219,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55219,37.64,0.46,337,16593,70,NULL,NULL,'SDSS J083322.40+395357.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00012,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,128.343375,39.89928,0.113,NULL,64359614922,1005618983,15712796,18.6),(55220,'IRAS','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55220,34.23,0.8,70.1,16594,75,NULL,'CF, r','UGC 04461',NULL,'1997ApJS..109..333W',1997,1,1.79,NULL,'G',0.000013,NULL,'14.2g',0.49,'Sbc',NULL,NULL,NULL,NULL,1,128.3445,52.53225,0.137,NULL,63501635590,992213056,15503329,14.2),(55221,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55221,33.94,0.38,61.5,16594,75,NULL,'CF, r, raw','UGC 04461',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55222,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55222,34.04,0.38,64.4,16594,75,NULL,'CF, r, inv','UGC 04461',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55223,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55223,34.18,0.38,68.5,16594,75,NULL,'CF, r, cor','UGC 04461',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55224,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55224,34.34,0.4,73.6,16594,NULL,NULL,'mean','UGC 04461',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55225,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55225,34.53,0.47,80.6,16594,NULL,NULL,'H','UGC 04461',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55226,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55226,30.57,0.56,13,16595,70,NULL,NULL,'NGC 2613',NULL,'2014MNRAS.445.2677S',2014,1,7.2,NULL,'G',0.00001,NULL,'11.16',1.8,'SA(s)b         HII',NULL,NULL,NULL,NULL,1,128.345167,-22.97367,0.341,NULL,42239636641,659994322,10312411,11.16),(55227,'IRAS','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55227,31.88,0.8,23.8,16595,75,NULL,'A82, H','NGC 2613',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55228,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55228,31.16,NULL,17.1,16595,NULL,NULL,'B','NGC 2613',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55229,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55229,31.66,0.4,21.5,16595,75,NULL,NULL,'NGC 2613',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55230,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55230,31.66,0.4,21.5,16595,73,NULL,'IR','NGC 2613',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55231,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55231,31.71,0.4,21.9,16595,75,NULL,NULL,'NGC 2613',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55232,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55232,31.91,0.35,24.1,16595,NULL,NULL,NULL,'NGC 2613',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55233,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55233,31.96,0.4,24.7,16595,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 2613',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55234,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55234,32.2,0.2,27.5,16595,74.4,NULL,NULL,'NGC 2613',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55235,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55235,32.28,0.43,28.6,16595,75,NULL,'3.6 micron, color corrected','NGC 2613',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55236,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55236,32.3,0.47,28.9,16595,75,NULL,'A82, H, raw','NGC 2613',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55237,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55237,32.4,0.49,30.2,16595,75,NULL,'IR','NGC 2613',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55238,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55238,32.49,0.43,31.5,16595,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2613',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55239,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55239,32.56,0.47,32.5,16595,75,NULL,'A82, H, cor','NGC 2613',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55240,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55240,32.62,0.47,33.3,16595,75,NULL,'A82, H, inv','NGC 2613',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55241,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55241,37.45,0.46,309,16596,70,NULL,NULL,'2MASX J08332281+0411087',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000177,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,128.345167,4.18586,0.041,NULL,62612544883,978321013,15286265,17.9),(55242,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55242,36.83,0.33,232,16597,70,NULL,NULL,'2MASX J08332359+3556302',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,128.348333,35.94189,0.177,NULL,64364587870,1005696685,15714010,17.4),(55243,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55243,37.82,0.23,367,16598,70,NULL,NULL,'2MASX J08332663+1536249',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,128.361,15.60703,0.121,NULL,63846753325,997605520,15587586,17.8),(55244,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55244,38.18,0.46,432,16599,70,NULL,NULL,'2MASX J08332837+2643330',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000171,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,128.3684583,26.72592,0.041,NULL,64318853306,1004982082,15702845,18.1),(55245,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55245,38.47,0.46,494,16600,70,NULL,NULL,'2MASX J08332908+3927323',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000177,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,128.3712917,39.45906,0.113,NULL,64360377440,1005630897,15712982,17.7),(55246,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55246,37.82,0.23,367,16601,70,NULL,NULL,'2MASX J08332926+1535069',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.00017,NULL,'15.8g',0.5,'BrClG',NULL,NULL,NULL,NULL,1,128.372041667,15.58531,0.121,NULL,63846757463,997605585,15587587,15.8),(55247,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55247,36.86,0.33,235,16602,70,NULL,NULL,'2MASX J08333003+4942296',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000077,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,128.3752083,49.70819,0.129,NULL,63497531772,992148933,15502327,17.6),(55248,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','SN 2006bb',NULL,55248,34.51,0.18,77.8,16603,74.2,NULL,'SALT 2','UGC 04468',0.0258,'2010ApJ...716..712A',2010,1,1.55,NULL,'G',0.00016,NULL,'14.2g',0.73,'S0','Group member',NULL,NULL,NULL,1,128.3782083,41.52544,0.109,NULL,64255401750,1003990652,15687353,14.2),(55249,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','SN 2006bb',NULL,55249,35.09,0.1,104,16603,74.4,NULL,NULL,'UGC 04468',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55250,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','SN 2006bb',NULL,55250,35.36,0.2,115,16603,70,NULL,'SALT 2','UGC 04468',0.0258,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55251,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55251,36.76,0.46,225,16604,70,NULL,NULL,'2MASX J08333267+5158576',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000068,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,128.386167,51.98278,0.129,NULL,63501523838,992211309,15503301,17.5),(55252,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55252,37.29,0.46,288,16605,70,NULL,NULL,'2MASX J08333276+4041503',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000169,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,128.3864583,40.69736,0.133,NULL,64241101369,1003767208,15683862,16.5),(55253,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55253,37.83,0.46,367,16606,70,NULL,NULL,'2MASX J08333320+1248039',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,128.388333333,12.80106,0.125,NULL,63841239003,997519359,15586239,17.2),(55254,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55254,37.37,0.46,298,16607,70,NULL,NULL,'2MASX J08333403+0728482',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,128.391791667,7.48006,0.065,NULL,62573826012,977716031,15276812,17),(55255,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55255,37.5,0.46,317,16608,70,NULL,NULL,'2MASX J08333603+2807269',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000166,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,128.400125,28.124,0.141,NULL,64319723390,1004995677,15703057,17.6),(55256,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55256,36.81,0.33,230,16609,70,NULL,NULL,'2MASX J08333638+0344297',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000163,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,128.40175,3.74153,0.061,NULL,62611982125,978312220,15286128,16.9),(55257,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55257,38.09,0.46,416,16610,70,NULL,NULL,'2MASX J08333801+5700342',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,128.408333,57.00947,0.173,NULL,61545696977,961651515,15025804,17.9),(55258,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55258,37.82,0.23,367,16611,70,NULL,NULL,'2MASX J08333805+1532039',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000172,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,128.4084583,15.53442,0.133,NULL,63846758997,997605609,15587587,18.2),(55259,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55259,35.56,0.46,129,16612,70,NULL,NULL,'CGCG 060-024',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000097,NULL,'15.5',0.48,NULL,NULL,NULL,NULL,NULL,1,128.417125,9.96369,0.133,NULL,63654674818,994604294,15540692,15.5),(55260,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55260,36.58,0.46,207,16613,70,NULL,NULL,'2MASX J08334075+3336242',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000164,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,128.419833,33.60681,0.165,NULL,64332696560,1005198383,15706224,16.5),(55261,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55261,35.64,0.46,134,16614,70,NULL,NULL,'CGCG 263-048',NULL,'2015arXiv151105856S',2015,1,0.98,NULL,'G',0.00008,NULL,'14.5g',0.71,'E0',NULL,NULL,NULL,NULL,1,128.422208333,54.54933,0.097,NULL,63491280444,992051256,15500800,14.5),(55262,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55262,36.83,0.33,232,16615,70,NULL,NULL,'2MASX J08334380+3601193',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000152,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,128.432583,36.02206,0.177,NULL,64364584851,1005696638,15714009,17),(55263,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55263,36.16,0.33,170,16616,70,NULL,NULL,'2MASX J08334402+5536252',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00018,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,128.433625,55.60703,0.133,NULL,61552792208,961762378,15027537,16.2),(55264,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55264,36.84,0.46,234,16617,70,NULL,NULL,'2MASX J08334440+3621173',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000182,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,128.435083333,36.35478,0.117,NULL,64372481013,1005820015,15715937,16.8),(55265,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55265,36.81,0.33,230,16618,70,NULL,NULL,'2MASX J08334486+0346537',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,128.436875,3.78167,0.061,NULL,62611869228,978310456,15286100,17.6),(55266,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55266,34.34,0.4,73.8,16619,NULL,NULL,'mean','MCG -01-22-020',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000033,NULL,'15',0.4,'Sc             HII',NULL,NULL,NULL,NULL,1,128.443416667,-4.65317,0.117,NULL,39256964440,613390069,9584219,15),(55267,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55267,34.41,0.47,76.2,16619,NULL,NULL,'H','MCG -01-22-020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55268,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55268,34.43,0.45,76.8,16619,NULL,NULL,'K','MCG -01-22-020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55269,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55269,34.5,0.46,79.3,16619,NULL,NULL,'J','MCG -01-22-020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55270,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55270,36.69,0.46,218,16620,70,NULL,NULL,'2MASX J08334701+1959389',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,128.445875,19.99411,0.089,NULL,63807518184,996992471,15578007,17.4),(55271,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55271,37.02,0.46,253,16621,70,NULL,NULL,'2MASX J08334737+3500021',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000215,NULL,'16.0g',0.37,'E0',NULL,NULL,NULL,NULL,1,128.44725,35.00064,0.117,NULL,64364196284,1005690566,15713915,16),(55272,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55272,37.47,0.46,312,16622,70,NULL,NULL,'2MASX J08334816+2556119',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,128.450708333,25.93664,0.105,NULL,64319207316,1004987614,15702931,17.3),(55273,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55273,38.28,0.33,453,16623,70,NULL,NULL,'2MASX J08334888+5804453',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,128.453916667,58.07911,0.213,NULL,61543763550,961621305,15025332,18.1),(55274,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55274,37.86,0.46,372,16624,70,NULL,NULL,'2MASX J08334917+0900023',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,128.454875,9.00069,0.073,NULL,62571683663,977682557,15276289,17.8),(55275,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55275,37.78,0.33,359,16625,70,NULL,NULL,'2MASX J08334940+0955113',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,128.456,9.91992,0.133,NULL,63653888078,994592001,15540500,17.8),(55276,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55276,35.33,0.46,116,16626,70,NULL,NULL,'2MASX J08335194+1407088',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'16.98',0.39,NULL,NULL,NULL,NULL,NULL,1,128.4665417,14.11908,0.177,NULL,63840215906,997503373,15585990,16.98),(55277,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55277,34.2,NULL,69.2,16627,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 562- G 018',NULL,'2010Ap&SS.325..163P',2010,1,1.29,NULL,'G',0.000047,NULL,'16.8',0.1,'Sd',NULL,NULL,NULL,NULL,1,128.472083,-21.38194,0.145,NULL,42264017757,660375277,10318363,16.8),(55278,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55278,34.21,NULL,69.4,16627,NULL,NULL,'Dipole + Quadrupole','ESO 562- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55279,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55279,34.21,NULL,69.5,16627,NULL,NULL,'Dipole','ESO 562- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55280,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55280,34.21,NULL,69.6,16627,NULL,NULL,NULL,'ESO 562- G 018',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55281,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55281,34.83,0.43,92.3,16627,75,NULL,'3.6 micron, color + selection bias corrected','ESO 562- G 018',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55282,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55282,37.78,0.46,359,16628,70,NULL,NULL,'2MASX J08335333+0252067',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,128.472333,2.86836,0.093,NULL,62602663964,978166624,15283853,17.3),(55283,'Tully est','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55283,31.83,0.8,23.3,16629,75,NULL,'B','UGCA 142',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000037,NULL,'15',0.4,'SB(s)dm: sp',NULL,NULL,NULL,NULL,1,128.486417,-21.88556,NULL,NULL,42233523748,659898808,10310918,15),(55284,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55284,32.22,0.2,27.8,16629,74.4,NULL,NULL,'UGCA 142',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55285,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55285,32.26,0.4,28.3,16629,73,NULL,'opt','UGCA 142',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55286,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55286,32.35,0.46,29.5,16629,NULL,NULL,'Malmquist cor.','UGCA 142',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55287,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55287,32.4,0.44,30.2,16629,NULL,NULL,NULL,'UGCA 142',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55288,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55288,37.48,0.46,313,16630,70,NULL,NULL,'2MASX J08335783+5419252',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000092,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,128.4910417,54.32367,0.097,NULL,63499724993,992183203,15502862,16.4),(55289,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55289,37.86,0.46,374,16631,70,NULL,NULL,'2MASX J08335793+1922360',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000178,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,128.4915,19.37667,0.073,NULL,63807287756,996988871,15577951,17.4),(55290,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55290,37.78,0.33,359,16632,70,NULL,NULL,'2MASX J08335833+1002483',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,128.493,10.04678,0.133,NULL,63654803693,994606307,15540723,16.8),(55291,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55291,38.6,0.46,525,16633,70,NULL,NULL,'SDSS J083359.81+154044.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000137,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,128.49925,15.67897,0.109,NULL,63846800779,997606262,15587597,18.5),(55292,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55292,37.21,0.46,276,16634,70,NULL,NULL,'2MASX J08340034+3146210',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000167,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,128.5015,31.77247,0.089,NULL,64341432947,1005334889,15708357,16.6),(55293,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55293,38.07,0.46,411,16635,70,NULL,NULL,'SDSS J083401.09+423543.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000141,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,128.5045417,42.59533,0.109,NULL,64255857033,1003997766,15687465,18.4),(55294,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55294,37.48,0.46,313,16636,70,NULL,NULL,'2MASX J08340133+4605492',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000086,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,128.505458333,46.09708,0.117,NULL,64249364369,1003896318,15685879,17.4),(55295,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55295,36.74,0.46,223,16637,70,NULL,NULL,'2MASX J08340204+2608569',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000186,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,128.508417,26.14908,0.093,NULL,64318736968,1004980265,15702816,16.6),(55296,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55296,37.77,0.46,358,16638,70,NULL,NULL,'2MASX J08340228+3602016',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000118,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,128.5097083,36.03397,0.177,NULL,64364308261,1005692316,15713942,18.3),(55297,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55297,37.97,0.46,393,16639,70,NULL,NULL,'2MASX J08340320+2427279',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,128.5132917,24.45767,0.077,NULL,63794713295,996792395,15574881,17.4),(55298,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55298,35.79,0.46,144,16640,70,NULL,NULL,'2MASX J08340355+0316227',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'16.2g',NULL,NULL,NULL,NULL,NULL,NULL,1,128.51475,3.27311,0.061,NULL,62611838290,978309973,15286093,16.2),(55299,'Brightest Stars','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55299,27.44,0.4,3.08,16641,NULL,NULL,'3B','UGC 04459',NULL,'1994A&AS..106..555K',1994,1,1.5,NULL,'G',0.000001,NULL,'14.48',1.3,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,128.53,66.18167,0.097,NULL,62239384463,972490382,15195162,14.48),(55300,'Brightest Stars','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55300,27.8,NULL,3.63,16641,NULL,NULL,NULL,'UGC 04459',NULL,'1998AJ....116.2886S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55301,'CMD','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55301,27.79,NULL,3.61,16641,NULL,NULL,NULL,'UGC 04459',NULL,'2012ApJ...748...47M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55302,'TRGB','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55302,26.95,NULL,2.45,16641,NULL,NULL,NULL,'UGC 04459',NULL,'2000ASPC..209..345D',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55303,'TRGB','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55303,27.76,0.15,3.56,16641,NULL,NULL,'I','UGC 04459',NULL,'2002A&A...383..125K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55304,'TRGB','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55304,27.79,0.03,3.61,16641,NULL,NULL,'I','UGC 04459',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55305,'TRGB','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55305,27.82,0.03,3.66,16641,NULL,NULL,'I','UGC 04459',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55306,'TRGB','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55306,27.83,0.1,3.68,16641,74.4,NULL,NULL,'UGC 04459',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55307,'Tully est','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55307,26.53,0.8,2,16641,75,NULL,'B','UGC 04459',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55308,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55308,37.44,0.46,308,16642,70,NULL,NULL,'2MASX J08340755+4625482',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000088,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,128.531291667,46.43011,0.141,NULL,64249302245,1003895347,15685864,17.4),(55309,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55309,38.06,0.46,410,16643,70,NULL,NULL,'2MASX J08340896+1833531',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,128.5374583,18.56472,0.065,NULL,63774718798,996479981,15569999,17.9),(55310,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55310,32.5,0.4,31.6,16644,75,NULL,NULL,'ESO 431- G 016',NULL,'2008Ap.....51..336K',2008,1,1.3,NULL,'G',0.00002,NULL,'15.0',0.35,'E6',NULL,NULL,NULL,NULL,1,128.538041667,-30.08997,NULL,NULL,42725694071,667588969,10431077,15),(55311,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55311,32.5,0.39,31.6,16644,73,NULL,'IR','ESO 431- G 016',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55312,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55312,32.5,0.39,31.6,16644,73,NULL,'opt','ESO 431- G 016',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55313,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55313,33.24,0.49,44.4,16644,75,NULL,'IR','ESO 431- G 016',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55314,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55314,37.04,0.46,256,16645,70,NULL,NULL,'2MASX J08340954+0509486',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,128.53975,5.1635,0.065,NULL,62605680907,978213764,15284590,17),(55315,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55315,38.78,0.33,570,16646,70,NULL,NULL,'SDSS J083410.36+404158.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,128.543208333,40.69958,0.129,NULL,64241125946,1003767592,15683868,17.9),(55316,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55316,37.72,0.46,350,16647,70,NULL,NULL,'2MASX J08341072+5103097',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000094,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,128.544708333,51.05297,0.141,NULL,63501242234,992206909,15503232,17.2),(55317,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55317,36.86,0.33,236,16648,70,NULL,NULL,'2MASX J08341083+4713472',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000079,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,128.545083,47.22972,0.137,NULL,64248364368,1003880693,15685635,16.5),(55318,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55318,38.28,0.33,453,16649,70,NULL,NULL,'2MASX J08341107+5803212',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00012,NULL,'15.93',NULL,'BrClG',NULL,NULL,NULL,NULL,1,128.54625,58.05589,0.213,NULL,61543583506,961618492,15025288,15.93),(55319,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55319,36.16,0.33,170,16650,70,NULL,NULL,'2MASX J08341197+5549022',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.0001,NULL,'15.6g',0.41,NULL,NULL,NULL,NULL,NULL,1,128.5497083,55.81719,0.145,NULL,61554750065,961792969,15028015,15.6),(55320,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55320,37.24,0.46,280,16651,70,NULL,NULL,'2MASX J08341203+2756098',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000183,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,128.5500417,27.93619,0.109,NULL,64320576333,1005009005,15703265,16.6),(55321,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55321,36.4,0.27,190,16652,70,NULL,NULL,'2MASX J08341405+4803128',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000096,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,128.558625,48.05358,0.153,NULL,63493625055,992087891,15501373,16.3),(55322,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55322,37.96,0.33,392,16653,70,NULL,NULL,'2MASX J08341442+2652098',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000198,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,128.559958333,26.86947,0.041,NULL,64318634129,1004978658,15702791,17.2),(55323,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55323,38.17,0.46,430,16654,70,NULL,NULL,'2MASX J08341571+3659306',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,128.5654583,36.99175,0.121,NULL,64372906508,1005826664,15716041,18.5),(55324,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55324,37.71,0.27,348,16655,70,NULL,NULL,'2MASX J08341583+5621081',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000136,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,128.566,56.35228,0.149,NULL,61554961301,961796270,15028066,18.5),(55325,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55325,37.69,0.46,346,16656,70,NULL,NULL,'2MASX J08341627+1828241',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,128.5677083,18.47344,0.065,NULL,63774678673,996479354,15569989,17.5),(55326,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55326,37.38,0.46,299,16657,70,NULL,NULL,'2MASX J08341724+3129360',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000185,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,128.571875,31.4935,0.109,NULL,64341351378,1005333615,15708337,16.8),(55327,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55327,34.53,0.49,80.6,16658,75,NULL,'IR','CGCG 089-048',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000437,NULL,'15.6',0.5,NULL,NULL,NULL,NULL,NULL,1,128.5725,14.54792,0.165,NULL,63840320561,997505008,15586015,15.6),(55328,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55328,34.21,0.2,69.5,16659,74.4,NULL,NULL,'CGCG 089-048',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000437,NULL,'15.6',0.5,NULL,NULL,NULL,NULL,NULL,1,128.5725,14.54792,0.165,NULL,63840320561,997505008,15586015,15.6),(55329,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55329,37.71,0.27,348,16660,70,NULL,NULL,'2MASX J08341738+5630277',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000183,NULL,'16.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,128.572625,56.50781,0.161,NULL,61553875879,961779310,15027801,16.6),(55330,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55330,38.78,0.33,570,16661,70,NULL,NULL,'2MASX J08341750+4046436',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,128.572833,40.77881,0.129,NULL,64241136230,1003767753,15683871,17.9),(55331,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55331,38.1,0.33,416,16662,70,NULL,NULL,'2MASX J08341787+5803311',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,128.5747083,58.05856,0.213,NULL,61543583553,961618493,15025288,18.4),(55332,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55332,37.71,0.27,348,16663,70,NULL,NULL,'2MASX J08341842+5615481',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000139,NULL,'18.5g',0.09,NULL,NULL,NULL,NULL,NULL,1,128.57675,56.26342,0.149,NULL,61555480284,961804379,15028193,18.5),(55333,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55333,36.37,0.65,188,16664,70,NULL,NULL,'2MASX J08341954-0223145',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.96',NULL,NULL,NULL,NULL,NULL,NULL,1,128.581375,-2.38778,0.065,NULL,39253628196,613337940,9583405,16.96),(55334,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55334,36.4,0.27,190,16665,70,NULL,NULL,'SDSS J083419.70+480514.2',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000077,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,128.582125,48.08731,0.133,NULL,63493581584,992087212,15501362,17),(55335,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55335,37.65,0.46,339,16666,70,NULL,NULL,'2MASX J08342083+4804228',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000086,NULL,'16.7g',0.34,'AGN',NULL,NULL,NULL,NULL,1,128.58675,48.07311,0.133,NULL,63493581726,992087214,15501362,16.7),(55336,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55336,37.06,0.46,258,16667,70,NULL,NULL,'2MASX J08342119+1508121',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,128.5882083,15.13678,0.141,NULL,63850955203,997671175,15588612,17),(55337,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55337,36.4,0.27,190,16668,70,NULL,NULL,'MCG +08-16-013',NULL,'2015arXiv151105856S',2015,1,0.99,NULL,'G',0.0001,NULL,'14.9g',0.72,'E0',NULL,NULL,NULL,NULL,1,128.594583,48.08814,0.133,NULL,63493581575,992087212,15501362,14.9),(55338,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55338,37.76,0.33,356,16669,70,NULL,NULL,'2MASX J08342297+0501281',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,128.595791667,5.02436,0.113,NULL,62610048573,978282008,15285656,17.5),(55339,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55339,37.75,0.46,354,16670,70,NULL,NULL,'2MASX J08342315+0345361',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'16.8g',0.34,NULL,NULL,NULL,NULL,NULL,1,128.596625,3.76011,0.061,NULL,62611910545,978311102,15286110,16.8),(55340,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55340,35.94,0.46,154,16671,70,NULL,NULL,'2MASX J08342319+5658468',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',NULL,NULL,'16.34',0.38,NULL,NULL,NULL,NULL,NULL,1,128.5967917,56.97961,0.173,NULL,61545883255,961654425,15025850,16.34),(55341,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55341,32.24,0.47,28,16672,NULL,NULL,'H','ESO 431- G 017',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000033,NULL,'10.4K',0.5,'SA(rs)ab',NULL,NULL,NULL,NULL,1,128.601375,-31.82225,NULL,NULL,42732584212,667696628,10432759,10.4),(55342,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55342,32.31,0.46,28.9,16672,NULL,NULL,'J','ESO 431- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55343,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55343,32.37,0.45,29.8,16672,NULL,NULL,'K','ESO 431- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55344,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55344,32.4,0.4,30.2,16672,NULL,NULL,'mean','ESO 431- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55345,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55345,38.1,0.33,416,16673,70,NULL,NULL,'2MASX J08342467+5758508',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,128.602625,57.98064,0.213,NULL,61546461367,961663458,15025991,17.8),(55346,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55346,37.27,0.17,284,16674,70,NULL,NULL,'SDSS J083426.38+382730.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000169,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,128.609917,38.45844,0.113,NULL,64371532740,1005805199,15715706,18.4),(55347,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55347,37.18,0.46,273,16675,70,NULL,NULL,'2MASX J08342643+5410438',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00008,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,128.61025,54.179,0.125,NULL,63499708798,992182949,15502858,17.1),(55348,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55348,38.04,0.33,406,16676,70,NULL,NULL,'2MASX J08342683+2527238',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,128.6117917,25.45653,0.093,NULL,64317286942,1004957608,15702462,18),(55349,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55349,37.6,0.46,332,16677,70,NULL,NULL,'2MASX J08342755+3526066',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000175,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,128.615,35.43514,0.153,NULL,64364532293,1005695817,15713997,17.7),(55350,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55350,38.04,0.33,406,16678,70,NULL,NULL,'SDSS J083429.17+252659.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000151,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,128.621583,25.44992,0.093,NULL,64317288860,1004957638,15702463,18.7),(55351,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55351,37.67,0.33,343,16679,70,NULL,NULL,'2MASX J08342943+0945469',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,128.622791667,9.76308,0.129,NULL,63653921118,994592517,15540508,18.1),(55352,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55352,37.27,0.17,284,16680,70,NULL,NULL,'2MASX J08343245+3833215',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000154,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,128.6350417,38.556,0.113,NULL,64371542445,1005805350,15715708,16.7),(55353,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55353,36.73,0.46,222,16681,70,NULL,NULL,'2MASX J08343265+5314047',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000085,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,128.636125,53.23461,0.133,NULL,63500690976,992198296,15503098,16.5),(55354,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55354,33.16,0.69,42.8,16682,100,NULL,'mid-IR','NGC 2615',NULL,'2013ApJ...771...88L',2013,1,1.9,NULL,'G',0.000033,NULL,'13.30',1,'SB(rs)b        HII',NULL,NULL,NULL,NULL,1,128.6389583,-2.54681,0.093,NULL,39253667801,613338559,9583414,13.3),(55355,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55355,34.06,0.47,64.9,16682,NULL,NULL,'H','NGC 2615',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55356,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55356,34.08,0.45,65.3,16682,NULL,NULL,'K','NGC 2615',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55357,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55357,34.08,0.46,65.5,16682,NULL,NULL,'J','NGC 2615',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55358,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55358,34.12,0.4,66.6,16682,NULL,NULL,'mean','NGC 2615',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55359,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55359,35.41,0.46,121,16683,70,NULL,NULL,'2MASX J08343576+1027109',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.91',0.35,NULL,NULL,NULL,NULL,NULL,1,128.648875,10.45294,0.129,NULL,63654160258,994596254,15540566,16.91),(55360,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55360,38.87,0.46,594,16684,70,NULL,NULL,'2MASX J08343622+1543532',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000144,NULL,'18.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,128.6510417,15.7315,0.109,NULL,63846785800,997606028,15587594,18),(55361,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55361,35.45,0.46,123,16685,70,NULL,NULL,'2MASX J08343733+1724192',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000161,NULL,'17.39',NULL,NULL,NULL,NULL,NULL,NULL,1,128.655541667,17.40533,0.073,NULL,63778012423,996531444,15570803,17.39),(55362,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55362,36.45,0.33,195,16686,70,NULL,NULL,'2MASX J08343740+4437092',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000169,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,128.6557917,44.61925,0.101,NULL,64251674011,1003932406,15686443,16.3),(55363,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55363,37.79,0.46,361,16687,70,NULL,NULL,'2MASX J08343838+2956166',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,128.659875,29.93808,0.105,NULL,64312926105,1004889470,15701397,17.7),(55364,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55364,37.53,0.46,320,16688,70,NULL,NULL,'SDSS J083438.96+112224.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000139,NULL,'18.3g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,128.662333,11.37336,0.113,NULL,63656884007,994638812,15541231,18.3),(55365,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55365,36.45,0.33,195,16689,70,NULL,NULL,'2MASX J08343936+2335163',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000173,NULL,'16.0g',0.38,NULL,NULL,NULL,NULL,NULL,1,128.6640417,23.58778,0.081,NULL,63794531571,996789555,15574836,16),(55366,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55366,37.51,0.46,317,16690,70,NULL,NULL,'2MASX J08343942+3135066',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000184,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,128.6642917,31.58506,0.109,NULL,64341347788,1005333559,15708336,16.8),(55367,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55367,37.76,0.33,356,16691,70,NULL,NULL,'2MASX J08344144+0503141',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000141,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,128.67275,5.05381,0.113,NULL,62605718615,978214353,15284599,18),(55368,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55368,38.01,0.46,400,16692,70,NULL,NULL,'2MASX J08344239+2911208',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,128.6765,29.18911,0.097,NULL,64313269117,1004894829,15701481,17.4),(55369,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55369,35.89,0.46,150,16693,70,NULL,NULL,'CGCG 179-012',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00018,NULL,'15.6g',0.42,'E0',NULL,NULL,NULL,NULL,1,128.6767917,34.89617,0.133,NULL,64365036493,1005703695,15714120,15.6),(55370,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55370,37.96,0.33,392,16694,70,NULL,NULL,'2MASX J08344277+2703378',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000175,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,128.678083,27.06047,0.113,NULL,64318117837,1004970591,15702665,18.3),(55371,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55371,36.86,0.33,236,16695,70,NULL,NULL,'2MASX J08344304+4708282',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000074,NULL,'17.5g',NULL,NULL,NULL,NULL,NULL,NULL,1,128.6794583,47.14119,0.161,NULL,64248405686,1003881338,15685645,17.5),(55372,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55372,37.69,0.46,345,16696,70,NULL,NULL,'SDSS J083443.50+201230.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,128.6812917,20.20861,0.073,NULL,63807653113,996994579,15578040,17.9),(55373,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55373,36.69,0.46,218,16697,70,NULL,NULL,'2MASX J08344426+3541406',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000143,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,128.6845,35.69456,0.121,NULL,64364506261,1005695410,15713990,17.4),(55374,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55374,36.45,0.33,195,16698,70,NULL,NULL,'2MASX J08344503+2330443',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,128.6877083,23.51239,0.081,NULL,63794348235,996786691,15574792,16.9),(55375,'IRAS','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55375,36.32,0.8,184,16699,75,NULL,'CF, r','NGC 2600',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000076,NULL,'14.8g',0.44,'Sb','Group member',NULL,NULL,NULL,1,128.6877083,52.71569,0.141,NULL,63500794929,992199920,15503123,14.8),(55376,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55376,35.76,0.38,142,16699,75,NULL,'CF, r, raw','NGC 2600',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55377,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55377,36,0.38,158,16699,75,NULL,'CF, r, inv','NGC 2600',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55378,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55378,36,0.38,158,16699,75,NULL,'CF, r, cor','NGC 2600',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55379,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55379,35.68,0.46,137,16700,70,NULL,NULL,'2MASX J08344608+3051276',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.02',0.31,NULL,NULL,NULL,NULL,NULL,1,128.691916667,30.85761,0.085,NULL,64341161780,1005330652,15708291,17.02),(55380,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55380,38.02,0.46,401,16701,70,NULL,NULL,'2MASX J08344724+2829335',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000177,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,128.6967083,28.49281,0.109,NULL,64319816712,1004997136,15703080,16.9),(55381,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55381,37.44,0.46,307,16702,70,NULL,NULL,'2MASX J08344727+1340022',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000195,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,128.696958333,13.66744,0.213,NULL,63840542455,997508475,15586069,16.2),(55382,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55382,38.14,0.46,425,16703,70,NULL,NULL,'2MASX J08344743+2324003',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000185,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,128.6975417,23.40003,0.089,NULL,63792723338,996761302,15574395,18.3),(55383,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55383,36.84,0.46,233,16704,70,NULL,NULL,'2MASX J08344866+5231257',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000096,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,128.7029583,52.52383,0.149,NULL,63501668422,992213569,15503337,16.6),(55384,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55384,37.39,0.46,301,16705,70,NULL,NULL,'2MASX J08344909+2457155',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00015,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,128.7045,24.95447,0.081,NULL,63793753920,996777405,15574646,17.5),(55385,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55385,37.22,0.46,279,16706,70,NULL,NULL,'2MASX J08344918+2602135',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000191,NULL,'16.0g',0.4,'E0',NULL,NULL,NULL,NULL,1,128.7047917,26.037,0.093,NULL,64317301809,1004957840,15702466,16),(55386,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55386,37.01,0.27,253,16707,70,NULL,NULL,'2MASX J08344922+0501100',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000175,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,128.705167,5.01953,0.113,NULL,62605720686,978214385,15284599,17.1),(55387,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55387,37.01,0.27,253,16708,70,NULL,NULL,'2MASX J08344929+0457360',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,128.70525,4.96014,0.113,NULL,62605527959,978211374,15284552,17.9),(55388,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55388,37.8,0.33,363,16709,70,NULL,NULL,'2MASX J08345000+5301097',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000083,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,128.7080417,53.01931,0.137,NULL,63500476573,992194946,15503046,17.5),(55389,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55389,37.67,0.33,343,16710,70,NULL,NULL,'2MASX J08345091+0942591',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'16.1g',0.32,NULL,NULL,NULL,NULL,NULL,1,128.712333,9.71642,0.129,NULL,63653917652,994592463,15540507,16.1),(55390,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55390,37.54,0.33,323,16711,70,NULL,NULL,'2MASX J08345096+1042501',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,128.7125,10.71392,0.117,NULL,63654170664,994596416,15540569,17.4),(55391,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55391,37.73,0.46,352,16712,70,NULL,NULL,'2MASX J08345139+6133246',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,128.714125,61.55689,0.121,NULL,62055579887,969618435,15150288,17.9),(55392,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55392,37.01,0.27,253,16713,70,NULL,NULL,'2MASX J08345163+0502560',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000168,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,128.715083,5.04903,0.113,NULL,62605717876,978214341,15284599,16.7),(55393,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55393,35.59,0.49,131,16714,70,NULL,NULL,'MCG -01-22-024 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.0001,NULL,'15.39',NULL,NULL,NULL,NULL,NULL,NULL,1,128.717083,-4.40411,0.117,NULL,39257949047,613405453,9584460,15.39),(55394,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55394,36.98,0.46,249,16715,70,NULL,NULL,'2MASX J08345260+0949161',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,128.719333,9.82128,0.129,NULL,63653936957,994592764,15540511,16.7),(55395,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55395,37.89,0.46,378,16716,70,NULL,NULL,'2MASX J08345403+3425265',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000142,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,128.7249583,34.42397,0.097,NULL,64362173256,1005658957,15713421,17.7),(55396,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55396,37.27,0.17,284,16717,70,NULL,NULL,'2MASX J08345842+3836558',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000162,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,128.74325,38.61564,0.113,NULL,64371550766,1005805480,15715710,16.8),(55397,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55397,36.73,0.46,222,16718,70,NULL,NULL,'2MASX J08345900+5326327',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000079,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,128.74575,53.44253,0.137,NULL,63500558590,992196227,15503066,17.2),(55398,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','SN 2007H',NULL,55398,35.74,0.18,135,16719,74.2,NULL,'SALT 2','LOSS J083502.19-082012.8',0.0436,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,128.759125,-8.33689,0.113,NULL,39232388917,613006076,9578219,NULL),(55399,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','SN 2007H',NULL,55399,36.5,0.19,192,16719,70,NULL,'SALT 2','LOSS J083502.19-082012.8',0.0436,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55400,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','SN 2007H',NULL,55400,36.74,0.27,223,16719,65,NULL,'SALT2','LOSS J083502.19-082012.8',NULL,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55401,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55401,37.54,0.33,323,16720,70,NULL,NULL,'2MASX J08350257+1044081',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000143,NULL,'16.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,128.7607083,10.73567,0.117,NULL,63656062609,994625978,15541030,16.4),(55402,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55402,36.16,0.33,171,16721,70,NULL,NULL,'NGC 2602',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000078,NULL,'15.4g',0.41,'S0/a','Group member',NULL,NULL,NULL,1,128.7677083,52.83153,0.141,NULL,63500327438,992192616,15503009,15.4),(55403,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55403,35.65,0.48,135,16722,70,NULL,NULL,'CGCG 004-063',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.0001,NULL,'15.6',0.7,'poss. LINER','Group member',NULL,NULL,NULL,1,128.768875,-2.96589,0.069,NULL,39252977845,613327778,9583246,15.6),(55404,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55404,37.8,0.33,363,16723,70,NULL,NULL,'2MASX J08350463+5301077',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000077,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,128.7692083,53.01883,0.137,NULL,63500358596,992193103,15503017,18.3),(55405,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55405,37.85,0.46,371,16724,70,NULL,NULL,'2MASX J08350477+5226238',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000083,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,128.770125,52.43981,0.149,NULL,63501679490,992213742,15503339,17.6),(55406,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55406,36.95,0.46,245,16725,70,NULL,NULL,'2MASX J08350568+0850407',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,128.77375,8.84475,0.057,NULL,63659280858,994676263,15541816,17.1),(55407,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55407,36.33,0.58,185,16726,70,NULL,NULL,'2MASX J08350574-0151023',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.55',0.3,NULL,NULL,NULL,NULL,NULL,1,128.7737917,-1.85069,0.101,NULL,39254248208,613347628,9583556,16.55),(55408,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55408,36.66,0.46,215,16727,70,NULL,NULL,'2MASX J08350588+4950507',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.0001,NULL,'16.1g',0.31,'NLAGN',NULL,NULL,NULL,'Sy 2',1,128.7745417,49.84756,0.149,NULL,63497413281,992147082,15502298,16.1),(55409,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55409,37.9,0.46,379,16728,70,NULL,NULL,'2MASX J08350819+3310395',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000074,NULL,'18.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,128.784166667,33.17783,0.101,NULL,64333198776,1005206230,15706347,18.1),(55410,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55410,37.26,0.46,283,16729,70,NULL,NULL,'2MASX J08350843+6005097',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,128.785167,60.08619,0.125,NULL,62063879354,969748114,15152314,17.5),(55411,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55411,37.37,0.46,298,16730,70,NULL,NULL,'2MASX J08350890+1752203',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000192,NULL,'17.78',0.37,NULL,NULL,NULL,NULL,NULL,1,128.787167,17.87247,0.029,NULL,63777866600,996529165,15570768,17.78),(55412,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55412,36.71,0.8,220,16731,70,NULL,NULL,'2MASX J08350955-7923099',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.000103,NULL,'13.78',0.15,NULL,NULL,NULL,NULL,NULL,1,128.7902083,-79.38608,0.337,NULL,39994634681,624916166,9764315,13.78),(55413,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55413,38.21,0.27,439,16732,70,NULL,NULL,'2MASX J08350973+5040018',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,128.790625,50.66714,0.141,NULL,63496558693,992133729,15502089,17.1),(55414,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55414,36.92,0.46,242,16733,70,NULL,NULL,'2MASX J08351106+2806026',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000152,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,128.7960417,28.10083,0.113,NULL,64320590324,1005009223,15703269,17.2),(55415,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55415,37.64,0.46,338,16734,70,NULL,NULL,'2MASX J08351139+5016528',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000102,NULL,'17.9g',0.16,'NLAGN',NULL,NULL,NULL,'Sy 2',1,128.797625,50.28122,0.145,NULL,63496703806,992135996,15502124,17.9),(55416,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55416,37.76,0.46,356,16735,70,NULL,NULL,'2MASX J08351151+0714037',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000177,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,128.7980417,7.23433,0.041,NULL,62574756171,977730565,15277040,17.4),(55417,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55417,38.21,0.27,439,16736,70,NULL,NULL,'2MASX J08351184+5041077',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000081,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,128.799125,50.68556,0.141,NULL,63494711148,992104861,15501638,18.1),(55418,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55418,36.4,0.46,191,16737,70,NULL,NULL,'2MASX J08351196+0518291',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000201,NULL,'15.5g',0.45,'E0',NULL,NULL,NULL,NULL,1,128.7999583,5.30814,0.077,NULL,62605587770,978212308,15284567,15.5),(55419,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55419,37.46,0.46,310,16738,70,NULL,NULL,'2MASX J08351225+3142155',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000205,NULL,'16.0g',0.41,'E0',NULL,NULL,NULL,NULL,1,128.801,31.70425,0.089,NULL,64341523232,1005336300,15708379,16),(55420,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55420,33.13,0.4,42.2,16739,75,NULL,NULL,'UGC 04482',NULL,'2008Ap.....51..336K',2008,1,1.02,NULL,'G',0.00002,NULL,'15.9g',0.27,'Sdm:',NULL,NULL,NULL,NULL,1,128.807625,28.75331,0.105,NULL,64319796310,1004996817,15703075,15.9),(55421,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55421,33.57,0.49,51.7,16739,75,NULL,'IR','UGC 04482',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55422,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55422,37.08,0.46,261,16740,70,NULL,NULL,'2MASX J08351399+5237378',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000069,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,128.8082083,52.62706,0.141,NULL,63500839715,992200620,15503134,17.8),(55423,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55423,38,0.46,398,16741,70,NULL,NULL,'2MASX J08351476+1154067',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,128.8114583,11.90181,0.093,NULL,63655360666,994615010,15540859,17.8),(55424,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55424,37.92,0.33,383,16742,70,NULL,NULL,'2MASX J08351482+1852356',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000173,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,128.811833,18.87664,0.037,NULL,63804511872,996945498,15577273,16.8),(55425,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55425,37.19,0.46,274,16743,70,NULL,NULL,'2MASX J08351518+2706546',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000139,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,128.813125,27.11503,0.113,NULL,64318138579,1004970915,15702670,17.4),(55426,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55426,37.47,0.46,312,16744,70,NULL,NULL,'2MASX J08351568+1801396',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,128.815375,18.02767,0.069,NULL,63774735249,996480238,15570003,17.8),(55427,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55427,36.01,0.33,159,16745,70,NULL,NULL,'2MASX J08351660+1913306',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000164,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,128.8192917,19.22519,0.053,NULL,63804463279,996944738,15577261,16.8),(55428,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55428,36.45,0.33,195,16746,70,NULL,NULL,'2MASX J08351686+4423348',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000176,NULL,'16.0g',0.44,'E0',NULL,NULL,NULL,NULL,1,128.820375,44.39308,0.101,NULL,64251749845,1003933591,15686462,16),(55429,'Tully est','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55429,32.46,0.8,31,16747,75,NULL,'B','NGC 2608',NULL,'1988NBGC.C....0000T',1988,1,2.3,NULL,'G',0.000027,NULL,'13.01',1.4,'SB(s)b:','Group non-member, foreground',NULL,NULL,NULL,1,128.8222083,28.47342,0.109,NULL,64320533081,1005008329,15703255,13.01),(55430,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55430,31.02,0.43,16,16747,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2608',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55431,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55431,31.21,0.43,17.5,16747,75,NULL,'3.6 micron, color corrected','NGC 2608',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55432,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55432,31.43,0.2,19.3,16747,74.4,NULL,NULL,'NGC 2608',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55433,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55433,31.68,0.89,21.6,16747,NULL,NULL,NULL,'NGC 2608',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55434,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55434,31.67,0.69,21.6,16747,100,NULL,'mid-IR','NGC 2608',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55435,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55435,31.89,0.4,23.9,16747,NULL,NULL,NULL,'NGC 2608',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55436,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55436,31.95,0.47,24.6,16747,NULL,NULL,'H','NGC 2608',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55437,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55437,31.96,0.45,24.7,16747,NULL,NULL,'K','NGC 2608',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55438,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55438,32,0.46,25.1,16747,NULL,NULL,'J','NGC 2608',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55439,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55439,32.04,0.76,25.6,16747,NULL,NULL,'Malmquist cor.','NGC 2608',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55440,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55440,32.75,0.4,35.6,16747,NULL,NULL,'mean','NGC 2608',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55441,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55441,39.07,0.46,651,16748,70,NULL,NULL,'SDSS J083517.49+404040.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000147,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,128.822875,40.67781,0.129,NULL,64241108978,1003767327,15683864,18.6),(55442,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55442,36.07,0.52,164,16749,70,NULL,NULL,'CGCG 004-064',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000077,NULL,'15.6',0.4,NULL,NULL,NULL,NULL,NULL,1,128.8252083,-2.244,0.105,NULL,39254395139,613349924,9583592,15.6),(55443,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55443,36.96,0.46,247,16750,70,NULL,NULL,'2MASX J08351824+4013547',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00013,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,128.826166667,40.23186,0.125,NULL,64241054414,1003766475,15683851,17.9),(55444,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55444,37.44,0.23,307,16751,70,NULL,NULL,'2MASX J08351863+3948278',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000174,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,128.82775,39.80775,0.109,NULL,64359717411,1005620584,15712821,18),(55445,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55445,35.66,0.2,136,16752,74.4,NULL,NULL,'FGC 100A',NULL,'2013AJ....146...86T',2013,1,0.73,NULL,'G',0.000021,NULL,'17.55',0.11,NULL,NULL,NULL,NULL,NULL,1,128.831416667,27.48758,0.085,NULL,64320128404,1005002006,15703156,17.55),(55446,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55446,37.27,0.17,284,16753,70,NULL,NULL,'2MASX J08352037+3827078',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000189,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,128.8350417,38.45228,0.113,NULL,64371531773,1005805183,15715705,16.6),(55447,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55447,37.94,0.33,387,16754,70,NULL,NULL,'2MASX J08352051+5803160',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,128.835417,58.05458,0.213,NULL,61543584582,961618509,15025289,17.9),(55448,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55448,38,0.33,399,16755,70,NULL,NULL,'2MASX J08352117+3558228',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000183,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,128.8382083,35.973,0.133,NULL,64364418980,1005694046,15713969,17.3),(55449,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55449,36.16,0.33,171,16756,70,NULL,NULL,'2MASX J08352151+5247337',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000095,NULL,'16.1g',0.3,'E0',NULL,NULL,NULL,NULL,1,128.839625,52.79281,0.141,NULL,63500325618,992192587,15503009,16.1),(55450,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55450,35.87,0.69,149,16757,70,NULL,NULL,'2MASX J08352275-0139432',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,128.844875,-1.66197,0.053,NULL,39254109473,613345460,9583522,15.5),(55451,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55451,37.24,0.46,281,16758,70,NULL,NULL,'2MASX J08352351+1735582',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000173,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,128.848125,17.59944,0.073,NULL,63777915937,996529936,15570780,17.9),(55452,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55452,37.11,0.46,264,16759,70,NULL,NULL,'2MASX J08352364+2233006',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000175,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,128.8484583,22.55006,0.057,NULL,63800414717,996881479,15576273,16.6),(55453,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55453,36.92,NULL,243,16760,NULL,NULL,NULL,'FGC 0768',NULL,'2000BSAO...50....5K',2000,1,0.73,NULL,'G',0.000096,NULL,'17.4g',0.11,'Sb(f)',NULL,NULL,NULL,'Sy 2',1,128.851,54.99308,0.121,NULL,61552570959,961758921,15027483,17.4),(55454,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55454,37.03,NULL,254,16760,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0768',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55455,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55455,37.1,NULL,264,16760,NULL,NULL,'Dipole + Quadrupole','FGC 0768',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55456,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55456,37.19,NULL,274,16760,NULL,NULL,'Dipole','FGC 0768',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55457,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55457,37.85,0.46,372,16761,70,NULL,NULL,'2MASX J08352434+4731508',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000078,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,128.8515417,47.53078,0.157,NULL,64227438763,1003553730,15680527,17.6),(55458,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55458,37.79,0.33,361,16762,70,NULL,NULL,'2MASX J08352471+2930066',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,128.852875,29.50172,0.085,NULL,64313359004,1004896234,15701503,17.7),(55459,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55459,36.82,0.46,231,16763,70,NULL,NULL,'2MASX J08352628+1230377',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,128.859625,12.51036,0.105,NULL,63839128947,997486389,15585724,17.5),(55460,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55460,38.13,0.27,423,16764,70,NULL,NULL,'SDSS J083526.32+272827.1',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000179,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,128.859667,27.47419,0.085,NULL,64320141480,1005002210,15703159,17.4),(55461,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55461,37.15,0.46,269,16765,70,NULL,NULL,'2MASX J08352635+3138374',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000123,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,128.8597917,31.64386,0.109,NULL,64341239452,1005331866,15708310,17.9),(55462,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55462,36.01,0.33,159,16766,70,NULL,NULL,'2MASX J08352707+1912545',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000164,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,128.862917,19.21506,0.053,NULL,63804446622,996944478,15577257,16.2),(55463,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55463,38,0.33,399,16767,70,NULL,NULL,'2MASX J08352834+3557338',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,128.868,35.95944,0.133,NULL,64364418804,1005694043,15713969,18.1),(55464,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55464,34.29,0.2,72.1,16768,74.4,NULL,NULL,'CGCG 119-128',NULL,'2013AJ....146...86T',2013,1,0.59,NULL,'G',0.000016,NULL,'15.4g',0.32,NULL,'Group member, radial-velocity confirmed',NULL,NULL,NULL,1,128.8757917,23.67622,0.085,NULL,63794368503,996787007,15574796,15.4),(55465,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55465,36.46,0.46,196,16769,70,NULL,NULL,'2MASX J08353105+2456076',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000097,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,128.879417,24.93561,0.077,NULL,63793710892,996776732,15574636,16.5),(55466,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55466,39.02,0.46,636,16770,70,NULL,NULL,'SDSS J083531.63+404844.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000143,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,128.881833,40.81228,0.129,NULL,64254797956,1003981218,15687206,18.8),(55467,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55467,38.14,0.46,426,16771,70,NULL,NULL,'2MASX J08353171+5746340',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,128.882166667,57.77606,0.213,NULL,61546644150,961666314,15026036,17.9),(55468,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55468,35.1,0.47,105,16772,70,NULL,NULL,'NGC 2616',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000143,NULL,'13.5',1.3,'SAB(rs)0^0^?','Group member',NULL,NULL,'Flat-Spectrum Radio Source',1,128.8919583,-1.85014,0.101,NULL,39254281640,613348150,9583564,13.5),(55469,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55469,36.75,0.46,224,16773,70,NULL,NULL,'2MASX J08353422+0925458',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'17.72',0.32,NULL,NULL,NULL,NULL,NULL,1,128.892458333,9.42928,0.129,NULL,63667656209,994807128,15543861,17.72),(55470,'Tully est','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55470,31.47,0.8,19.7,16774,75,NULL,NULL,'UGCA 143',NULL,'1988NBGC.C....0000T',1988,1,2.9,'MCG position is -0.8 minutes and +10 arcmin in error.','G',0.000018,NULL,NULL,0.7,'SB(s)m:',NULL,NULL,NULL,NULL,1,128.897,-32.14503,NULL,NULL,42732437536,667694336,10432724,NULL),(55471,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55471,36.8,0.46,230,16775,70,NULL,NULL,'SDSS J083535.36+435549.8',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,128.897333,43.9305,0.121,NULL,64251508395,1003929818,15686403,17.6),(55472,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55472,38.4,0.46,478,16776,70,NULL,NULL,'2MASX J08353595+0238327',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,128.8997917,2.64242,0.133,NULL,62601396734,978146823,15283544,17.6),(55473,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55473,37.79,0.33,361,16777,70,NULL,NULL,'2MASX J08353612+2926366',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.00012,NULL,'15.6g',0.52,'E',NULL,NULL,NULL,NULL,1,128.900625,29.4435,0.085,NULL,64313357520,1004896211,15701503,15.6),(55474,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55474,37.92,0.33,383,16778,70,NULL,NULL,'SDSS J083536.20+184925.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,128.900875,18.82375,0.037,NULL,63804386506,996943539,15577242,18),(55475,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55475,34.95,NULL,97.7,16779,NULL,NULL,NULL,'FGC 0769',NULL,'2000BSAO...50....5K',2000,1,0.76,'Two stars superposed.','G',NULL,NULL,'16.25',0.09,'Sd',NULL,NULL,NULL,NULL,1,128.9035,58.92206,0.169,NULL,62017964149,969030689,15141104,16.25),(55476,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55476,38.02,0.46,401,16780,70,NULL,NULL,'2MASX J08353772+4218219',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000143,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,128.907125,42.30619,0.101,NULL,64256645662,1004010088,15687657,18),(55477,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55477,34.93,0.52,96.8,16781,70,NULL,NULL,'CGCG 004-070',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.7',0.3,NULL,'Group member',NULL,NULL,NULL,1,128.910625,-2.95422,0.069,NULL,39252941658,613327213,9583237,15.7),(55478,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55478,37.94,0.33,387,16782,70,NULL,NULL,'2MASX J08353876+5758540',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,128.9114583,57.98164,0.213,NULL,61546492163,961663940,15025999,18.6),(55479,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55479,36.49,0.46,198,16783,70,NULL,NULL,'2MASX J08353965+3323462',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000172,NULL,'16.1g',0.39,'E0',NULL,NULL,NULL,NULL,1,128.915375,33.39619,0.101,NULL,64333163493,1005205679,15706338,16.1),(55480,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55480,37.99,0.46,397,16784,70,NULL,NULL,'2MASX J08354036+3956347',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,128.91825,39.94306,0.109,NULL,64359548556,1005617946,15712780,17.1),(55481,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55481,36.01,0.46,159,16785,70,NULL,NULL,'2MASX J08354046+4022457',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000173,NULL,'16.0g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,128.9187083,40.37919,0.137,NULL,64241059945,1003766561,15683852,16),(55482,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55482,38.09,0.46,415,16786,70,NULL,NULL,'2MASX J08354056+1237416',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,128.919,12.62831,0.121,NULL,63839133977,997486468,15585726,17.5),(55483,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55483,37.03,0.46,255,16787,70,NULL,NULL,'2MASX J08354054+3104312',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00017,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,128.919125,31.07525,0.089,NULL,64341173307,1005330832,15708294,16.7),(55484,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55484,37.81,0.46,366,16788,70,NULL,NULL,'2MASX J08354243+3600037',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,128.926833333,36.00111,0.133,NULL,64364473349,1005694896,15713982,18.2),(55485,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55485,36.11,0.46,167,16789,70,NULL,NULL,'2MASX J08354669+4703299',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000083,NULL,'15.9g',0.47,'S0^-',NULL,NULL,NULL,NULL,1,128.944458333,47.05839,0.133,NULL,64281922135,1004405033,15693828,15.9),(55486,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55486,37.44,0.23,307,16790,70,NULL,NULL,'SDSS J083547.29+395232.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,128.947083,39.87572,0.109,NULL,64359541268,1005617832,15712778,18.2),(55487,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55487,37.27,0.17,284,16791,70,NULL,NULL,'2MASX J08354779+3843230',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000186,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,128.949208333,38.72314,0.113,NULL,64371492719,1005804573,15715696,17.2),(55488,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55488,38.65,0.46,538,16792,70,NULL,NULL,'2MASX J08354810+5359390',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000086,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,128.950625,53.99411,0.121,NULL,63499826819,992184794,15502887,18),(55489,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55489,33.64,0.47,53.5,16793,NULL,NULL,'H','UGC 04491',NULL,'2007A&A...465...71T',2007,1,2.4,NULL,'G',0.00003,NULL,'13.48',0.9,'(R\')SB(rs)a:','in a pair',NULL,NULL,NULL,1,128.952125,1.72169,0.089,NULL,62603978871,978187169,15284174,13.48),(55490,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55490,33.66,0.45,54.1,16793,NULL,NULL,'K','UGC 04491',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55491,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55491,33.74,0.46,55.9,16793,NULL,NULL,'J','UGC 04491',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55492,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55492,33.96,0.4,62,16793,NULL,NULL,'mean','UGC 04491',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55493,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55493,38.21,0.27,439,16794,70,NULL,NULL,'2MASX J08354882+5041086',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000092,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,128.953458333,50.68567,0.141,NULL,63494716306,992104942,15501639,17.4),(55494,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55494,37.17,0.33,272,16795,70,NULL,NULL,'2MASX J08355026+1123142',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,128.959458333,11.38739,0.117,NULL,63655984358,994624755,15541011,17.6),(55495,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55495,35.66,0.59,135,16796,70,NULL,NULL,'IC 0516',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000083,NULL,'15.7',0.3,NULL,'Group member',NULL,NULL,NULL,1,128.961541667,-1.87122,0.101,NULL,39254271258,613347988,9583562,15.7),(55496,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55496,37.81,0.46,365,16797,70,NULL,NULL,'2MASX J08355216+3526462',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000198,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,128.967458333,35.44614,0.125,NULL,64364347587,1005692931,15713952,16.8),(55497,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55497,37.73,0.46,352,16798,70,NULL,NULL,'2MASX J08355283+0100199',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,128.970125,1.00547,0.141,NULL,62600881434,978138772,15283418,17.2),(55498,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55498,38.27,0.46,450,16799,70,NULL,NULL,'2MASX J08355299+6011299',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,128.971,60.19169,0.125,NULL,62063706054,969745407,15152271,18.1),(55499,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55499,33.94,0.46,61.4,16800,NULL,NULL,'J','NGC 2618',NULL,'2007A&A...465...71T',2007,1,2.4,NULL,'G',0.000023,NULL,'13.0',1.9,'(R\')SA(rs)ab','in a pair',NULL,NULL,NULL,1,128.973083,0.70711,0.117,NULL,62600129342,978127020,15283234,13),(55500,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55500,33.96,0.45,62.1,16800,NULL,NULL,'K','NGC 2618',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55501,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55501,33.99,0.47,62.8,16800,NULL,NULL,'H','NGC 2618',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55502,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55502,33.99,0.4,62.9,16800,NULL,NULL,'mean','NGC 2618',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55503,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55503,37.93,0.46,386,16801,70,NULL,NULL,'2MASX J08355403+5804029',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,128.975083333,58.06758,0.213,NULL,61543555437,961618053,15025282,18.1),(55504,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55504,38.97,0.46,623,16802,70,NULL,NULL,'2MASX J08355462+2941327',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000195,NULL,'17.3g',0.24,'S0',NULL,NULL,NULL,NULL,1,128.9774583,29.69244,0.089,NULL,64313130262,1004892660,15701447,17.3),(55505,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55505,37.44,0.23,307,16803,70,NULL,NULL,'2MASX J08355505+3954240',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000182,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,128.9795,39.90653,0.109,NULL,64359543010,1005617859,15712779,17.5),(55506,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55506,37.62,0.46,335,16804,70,NULL,NULL,'2MASX J08355643+1320066',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000131,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,128.9850417,13.33519,0.185,NULL,63840644929,997510077,15586094,18.3),(55507,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55507,37.43,0.46,306,16805,70,NULL,NULL,'2MASXi J0835564+122348',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000141,NULL,'17.6g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,128.985083333,12.39681,0.105,NULL,63839124441,997486319,15585723,17.6),(55508,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','PS1 SN PS11e','N',55508,41.12,0.19,1270,16806,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11e HOST',0.3206,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55509,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55509,39.04,0.46,643,16807,70,NULL,NULL,'2MASX J08355671+3007322',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,128.986417,30.12572,0.093,NULL,64313059163,1004891549,15701430,17.8),(55510,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55510,38.13,0.46,423,16808,70,NULL,NULL,'2MASX J08355794+3612210',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000171,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,128.99125,36.20594,0.121,NULL,64364455890,1005694623,15713978,17.7),(55511,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55511,37.44,0.23,307,16809,70,NULL,NULL,'2MASX J08355930+3943040',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00017,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,128.997083,39.71775,0.109,NULL,64359531345,1005617677,15712776,16.8),(55512,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55512,36.98,0.58,249,16810,70,NULL,NULL,'2MASX J08355951-0045231',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.3I',0.4,NULL,NULL,NULL,NULL,NULL,1,128.998,-0.75647,0.109,NULL,39250366487,613286976,9582609,14.3),(55513,'RR Lyrae','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'N',55513,19.43,0.15,0.077,16811,NULL,NULL,'heliocentric','Cancer Group A',NULL,'2012ApJ...755..134S',2012,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55514,'RR Lyrae','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'N',55514,19.91,0.15,0.096,16812,NULL,NULL,'heliocentric','Cancer Group B',NULL,'2012ApJ...755..134S',2012,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55515,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55515,37.14,0.46,267,16813,70,NULL,NULL,'2MASX J08360023+1531325',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,129.0009583,15.52572,0.117,NULL,63846848708,997607011,15587609,17.4),(55516,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55516,37.13,0.46,267,16814,70,NULL,NULL,'2MASX J08360031+6114248',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,129.00125,61.24036,0.125,NULL,62048385449,969506022,15148531,17),(55517,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55517,34.18,0.46,68.5,16815,70,NULL,NULL,'CGCG 149-058',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000087,NULL,'14.9g',0.58,'E','Isolated galaxy',NULL,NULL,NULL,1,129.0062917,30.26642,0.085,NULL,64312869388,1004888584,15701384,14.9),(55518,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55518,35.61,0.53,132,16816,70,NULL,NULL,'2MASX J08360204-0310451',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.64',0.3,NULL,NULL,NULL,NULL,NULL,1,129.008333,-3.17942,0.077,NULL,39254908766,613357949,9583717,16.64),(55519,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55519,38.22,0.46,440,16817,70,NULL,NULL,'SDSS J083602.38+265001.7',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000202,NULL,'18.8g',0.08,NULL,NULL,NULL,NULL,NULL,1,129.0099583,26.83383,0.085,NULL,64316775037,1004949609,15702337,18.8),(55520,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55520,36.05,0.57,162,16818,70,NULL,NULL,'2MASX J08360250-0348271',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,129.0105,-3.80758,0.081,NULL,39255303258,613364113,9583814,15.2),(55521,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55521,37.62,0.46,335,16819,70,NULL,NULL,'2MASX J08360383+2320122',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000142,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,129.015875,23.33667,0.085,NULL,63792537017,996758390,15574349,17.5),(55522,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55522,37.17,0.33,272,16820,70,NULL,NULL,'2MASX J08360399+1124114',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000167,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,129.016541667,11.40331,0.129,NULL,63655982096,994624720,15541011,16.6),(55523,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55523,36.65,0.46,214,16821,70,NULL,NULL,'2MASX J08360440+2715357',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000174,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,129.0185,27.25989,0.081,NULL,64319976311,1004999629,15703119,16.4),(55524,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55524,36,0.82,158,16822,70,NULL,NULL,'2MASX J08360518-1845440',NULL,'2014MNRAS.445.2677S',2014,1,0.22,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,129.0215417,-18.76231,0.341,NULL,42262261457,660347835,10317934,15.4),(55525,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55525,37.4,0.46,302,16823,70,NULL,NULL,'2MASX J08360539+2849297',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000123,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,129.0224583,28.82478,0.081,NULL,64320244326,1005003817,15703184,16.9),(55526,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55526,36.82,0.46,232,16824,70,NULL,NULL,'2MASX J08360774+0835484',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000152,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,129.0322083,8.59678,0.125,NULL,63659119746,994673746,15541777,17.1),(55527,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55527,37.64,0.46,337,16825,70,NULL,NULL,'2MASX J08360781+2648437',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000184,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,129.032541667,26.81206,0.085,NULL,64316773634,1004949588,15702337,16.7),(55528,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55528,35.89,0.48,151,16826,70,NULL,NULL,'MCG -01-22-028',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000113,NULL,'15.5',0.3,'poss. LINER',NULL,NULL,NULL,NULL,1,129.038833,-7.055,0.069,NULL,39233498596,613023415,9578490,15.5),(55529,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55529,37.69,0.46,345,16827,70,NULL,NULL,'2MASX J08360971+2708237',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000148,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,129.0404583,27.13986,0.081,NULL,64319930307,1004998911,15703107,17.1),(55530,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55530,37.27,0.17,284,16828,70,NULL,NULL,'2MASX J08361116+3832049',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000185,NULL,'15.7g',0.54,'BrClG',NULL,NULL,NULL,NULL,1,129.0465,38.53475,0.129,NULL,64371381667,1005802838,15715669,15.7),(55531,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','PS1 SN PS10z',NULL,55531,39.18,0.13,601,16829,73.8,NULL,'SALT 2 (SNANA)','PS1 J083612.60+440025.5',0.1406,'2014ApJ...795...44R',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,129.052541667,44.00708,0.109,NULL,64251498956,1003929671,15686401,NULL),(55532,'TRGB','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55532,29.58,0.1,8.23,16830,74.4,NULL,NULL,'ESO 495- G 021',NULL,'2013AJ....146...86T',2013,1,1.93,NULL,'G',0.000003,NULL,'12.45',1.35,'I0? pec        Sbrst',NULL,NULL,NULL,NULL,1,129.063041667,-26.40939,NULL,NULL,42721855618,667528994,10430140,12.45),(55533,'Tully est','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55533,30.1,0.8,10.5,16830,75,NULL,NULL,'ESO 495- G 021',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55534,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55534,37.55,0.46,323,16831,70,NULL,NULL,'SDSS J083615.25+381920.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000175,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,129.0635417,38.32231,0.117,NULL,64371413510,1005803336,15715677,17.7),(55535,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','SN 2009kq',NULL,55535,33.64,0.24,52.8,16832,73.8,NULL,'SALT 2 (SNANA)','MCG +05-21-001',0.0126,'2014ApJ...795...44R',2014,1,0.7,NULL,'G',0.00002,NULL,'14.9',0.7,'Spiral',NULL,NULL,NULL,NULL,1,129.0642083,28.06033,0.097,NULL,64320480448,1005007507,15703242,14.9),(55536,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55536,38.13,0.27,423,16833,70,NULL,NULL,'2MASX J08361552+2723047',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,129.0647083,27.38472,0.085,NULL,64319965650,1004999463,15703116,17.6),(55537,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55537,38.94,0.46,615,16834,70,NULL,NULL,'2MASX J08361659+3101333',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000184,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,129.069166667,31.02597,0.089,NULL,64311567712,1004868245,15701066,18.7),(55538,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55538,36.43,0.59,193,16835,70,NULL,NULL,'2MASX J08361686-0302440',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,129.07025,-3.04558,0.077,NULL,39253023057,613328485,9583257,14.3),(55539,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55539,36.91,0.46,241,16836,70,NULL,NULL,'2MASX J08361799+1034204',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,129.074875,10.57242,0.129,NULL,63654306069,994598532,15540602,NULL),(55540,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55540,37.78,0.46,360,16837,70,NULL,NULL,'2MASX J08361988+1141374',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000189,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,129.0830417,11.69389,0.113,NULL,63655186449,994612288,15540817,16.9),(55541,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55541,36.2,0.46,174,16838,70,NULL,NULL,'CGCG 120-003',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00019,NULL,'15.6g',0.41,'S0',NULL,NULL,NULL,NULL,1,129.087417,23.76236,0.085,NULL,63793828665,996778572,15574665,15.6),(55542,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55542,37.48,0.46,313,16839,70,NULL,NULL,'2MASX J08362155+2637549',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00019,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,129.089708333,26.63189,0.085,NULL,64316818713,1004950292,15702348,16.4),(55543,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55543,37.11,0.46,264,16840,70,NULL,NULL,'2MASX J08362307+4328240',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000206,NULL,'15.7g',0.53,'E',NULL,NULL,NULL,NULL,1,129.096,43.47353,0.105,NULL,64256268391,1004004193,15687565,15.7),(55544,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55544,36.95,0.46,246,16841,70,NULL,NULL,'2MASX J08362376+5242540',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'15.9g',0.46,NULL,NULL,NULL,NULL,NULL,1,129.09875,52.715,0.141,NULL,63500828442,992200444,15503131,15.9),(55545,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55545,36.58,0.46,207,16842,70,NULL,NULL,'2MASX J08362401+5635505',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.55',0.34,NULL,NULL,NULL,NULL,NULL,1,129.10025,56.59736,0.161,NULL,61553853894,961778967,15027796,16.55),(55546,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55546,37.79,0.46,361,16843,70,NULL,NULL,'2MASX J08362475+2709429',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,129.103125,27.16192,0.081,NULL,64319920810,1004998762,15703105,17.8),(55547,'GRB','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55547,44.38,0.53,3760,16844,NULL,NULL,NULL,'GRB 980326',1,'2010JCAP...08..020W',2010,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'SAX/WFC',NULL,NULL,NULL,NULL,1,129.108333,-18.88333,0.341,NULL,42262257621,660347775,10317933,NULL),(55548,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55548,35.76,0.67,142,16845,70,NULL,NULL,'CGCG 004-083',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6',NULL,NULL,NULL,NULL,NULL,NULL,1,129.111125,-3.58497,0.081,NULL,39255526689,613367604,9583868,15.6),(55549,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55549,37.51,0.46,318,16846,70,NULL,NULL,'2MASX J08362807+2431079',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,129.117,24.51881,0.093,NULL,63794291322,996785801,15574778,17),(55550,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55550,36.11,0.46,167,16847,70,NULL,NULL,'CGCG 089-053',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000087,NULL,'15.5g',0.44,NULL,NULL,NULL,NULL,NULL,1,129.1224583,19.42994,0.053,NULL,63804584098,996946626,15577291,15.5),(55551,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55551,33.93,0.49,61,16848,75,NULL,'IR','MCG -02-22-022',NULL,'2011yCatp016004901K',2011,1,2.02,NULL,'G',0.000017,NULL,'15',0.17,'Scd',NULL,NULL,NULL,NULL,1,129.124083333,-11.83108,0.237,NULL,42162895395,658795240,10293675,15),(55552,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55552,33.93,NULL,61,16848,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -02-22-022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55553,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55553,33.93,NULL,61.2,16848,NULL,NULL,'Dipole','MCG -02-22-022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55554,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55554,33.94,NULL,61.2,16848,NULL,NULL,'Dipole + Quadrupole','MCG -02-22-022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55555,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55555,34.44,0.43,77.4,16848,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-22-022',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55556,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55556,36.3,0.33,182,16849,70,NULL,NULL,'CGCG 179-014',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000113,NULL,'15.1g',0.54,'E0',NULL,NULL,NULL,NULL,1,129.125125,38.14342,0.133,NULL,64373322010,1005833156,15716143,15.1),(55557,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55557,36.74,0.46,222,16850,70,NULL,NULL,'2MASX J08363136+5128080',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000099,NULL,'15.9g',0.4,'E0',NULL,NULL,NULL,NULL,1,129.130583,51.46897,0.125,NULL,63499295569,992176493,15502757,15.9),(55558,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55558,35.93,0.46,153,16851,70,NULL,NULL,'CGCG 263-061',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000087,NULL,'15.1g',0.63,'E0',NULL,NULL,NULL,NULL,1,129.1379583,54.04147,0.121,NULL,63486145067,991971016,15499547,15.1),(55559,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55559,32.27,NULL,28.5,16852,NULL,NULL,NULL,'SDSS J083633.22+051042.3',NULL,'2015AstBu..70....1K',2015,1,NULL,NULL,'G',0.000102,NULL,'23.5g',NULL,NULL,NULL,NULL,NULL,NULL,1,129.138416667,5.17842,0.089,NULL,62607469564,978241711,15285026,23.5),(55560,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55560,37.78,0.46,359,16853,70,NULL,NULL,'2MASX J08363360+1258293',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000118,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,129.140125,12.97489,0.133,NULL,63839201325,997487520,15585742,17.8),(55561,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55561,37.57,0.46,327,16854,70,NULL,NULL,'2MASX J08363436+2627389',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,129.1432917,26.46067,0.089,NULL,64316986908,1004952920,15702389,17.9),(55562,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55562,35.71,0.49,139,16855,75,NULL,'IR','UGC 04496',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000016,NULL,'15.7',0.12,'Sc',NULL,NULL,NULL,NULL,1,129.150875,25.137,0.073,NULL,64317096699,1004954635,15702416,15.7),(55563,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55563,36.14,NULL,169,16855,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04496',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55564,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55564,36.16,NULL,171,16855,NULL,NULL,'Dipole + Quadrupole','UGC 04496',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55565,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55565,36.18,NULL,173,16855,NULL,NULL,'Dipole','UGC 04496',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55566,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55566,36.21,0.2,175,16855,74.4,NULL,NULL,'UGC 04496',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55567,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55567,35.93,0.2,153,16856,74.4,NULL,NULL,'CGCG 060-028',NULL,'2013AJ....146...86T',2013,1,0.53,NULL,'G',0.000077,NULL,'16.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,129.152125,12.18919,0.089,NULL,63655276572,994613696,15540839,16.8),(55568,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55568,37.06,0.46,258,16857,70,NULL,NULL,'B3 0833+442',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000063,NULL,'16.4g',0.34,'AGN',NULL,NULL,NULL,NULL,1,129.157667,44.01931,0.109,NULL,64251023498,1003922242,15686285,16.4),(55569,'IRAS','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55569,34.22,0.8,69.7,16858,75,NULL,'MAT, I','ESO 006- G 003',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'15.35',0.2,'SAB(s)cd?',NULL,NULL,NULL,NULL,1,129.158583333,-83.46361,0.449,NULL,39780492907,621570201,9712034,15.35),(55570,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55570,33.74,0.32,55.9,16858,85,NULL,'I, raw','ESO 006- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55571,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55571,33.77,0.32,56.7,16858,85,NULL,'I, inv','ESO 006- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55572,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55572,33.86,0.43,59.2,16858,75,NULL,'MAT, I, raw','ESO 006- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55573,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55573,34.02,0.43,63.6,16858,75,NULL,'MAT, I, inv','ESO 006- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55574,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55574,34.08,0.43,65.4,16858,75,NULL,'MAT, I, cor','ESO 006- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55575,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55575,34.08,0.3,65.5,16858,NULL,NULL,NULL,'ESO 006- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55576,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55576,34.08,0.3,65.6,16858,NULL,NULL,'Malmquist cor.','ESO 006- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55577,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55577,34.12,0.2,66.7,16858,74.4,NULL,NULL,'ESO 006- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55578,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55578,37.15,0.46,269,16859,70,NULL,NULL,'2MASX J08363818+2934009',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000173,NULL,'16.5g',0.32,'E',NULL,NULL,NULL,NULL,1,129.15925,29.56683,0.085,NULL,64313136286,1004892754,15701449,16.5),(55579,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55579,38.13,0.27,423,16860,70,NULL,NULL,'2MASX J08363999+2727268',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,129.1667917,27.45756,0.085,NULL,64319944712,1004999136,15703111,18.1),(55580,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55580,35.87,0.67,149,16861,70,NULL,NULL,'2MASX J08364005-0449011',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,129.166916667,-4.817,0.057,NULL,39249497942,613273405,9582396,15.9),(55581,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55581,37.08,0.46,260,16862,70,NULL,NULL,'2MASX J08364079+2604488',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000174,NULL,'16.6g',0.37,NULL,NULL,NULL,NULL,NULL,1,129.170041667,26.08014,0.085,NULL,64316933079,1004952079,15702376,16.6),(55582,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55582,36.91,0.46,241,16863,70,NULL,NULL,'2MASX J08364177+2534548',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,129.173875,25.58197,0.089,NULL,64317407276,1004959488,15702492,16.8),(55583,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55583,37.01,0.46,253,16864,70,NULL,NULL,'2MASX J08364234+6224236',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,129.176583,62.40642,0.129,NULL,62053254866,969582107,15149720,17.8),(55584,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55584,37.9,0.46,380,16865,70,NULL,NULL,'2MASX J08364241+5101419',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000085,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,129.177,51.02817,0.137,NULL,63499161000,992174390,15502724,17.4),(55585,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55585,38.03,0.46,404,16866,70,NULL,NULL,'2MASX J08364284+5334319',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000098,NULL,'17.0g',0.29,'AGN',NULL,NULL,NULL,NULL,1,129.178417,53.57572,0.125,NULL,63500526675,992195729,15503058,17),(55586,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55586,36.3,0.33,182,16867,70,NULL,NULL,'2MASX J08364424+3802576',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,129.184417,38.04925,0.133,NULL,64373316042,1005833063,15716141,17.2),(55587,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55587,36.2,0.33,173,16868,70,NULL,NULL,'2MASX J08364465+4716219',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000083,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,129.18625,47.27292,0.161,NULL,64281947721,1004405433,15693834,17),(55588,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55588,36.6,0.33,209,16869,70,NULL,NULL,'2MASX J08364660+2839558',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000168,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,129.1940417,28.66556,0.069,NULL,64320304960,1005004765,15703199,16.7),(55589,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55589,36.89,0.56,238,16870,70,NULL,NULL,'2MASX J08364675-0707444',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.77',NULL,NULL,NULL,NULL,NULL,NULL,1,129.19475,-7.12917,0.065,NULL,39233297173,613020268,9578441,16.77),(55590,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55590,36.76,0.46,225,16871,70,NULL,NULL,'2MASX J08364674+0828523',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,129.194833,8.48131,0.141,NULL,63659971654,994687057,15541985,17.3),(55591,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55591,37.82,0.46,366,16872,70,NULL,NULL,'2MASX J08364792+4004576',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000193,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,129.1995417,40.08261,0.109,NULL,64359511457,1005617366,15712771,16.6),(55592,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55592,36.5,0.46,200,16873,70,NULL,NULL,'2MASX J08364872+3940356',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000164,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,129.203,39.67639,0.109,NULL,64371270783,1005801105,15715642,16.7),(55593,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55593,37.33,0.27,292,16874,70,NULL,NULL,'2MASX J08364875+3052264',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,129.203083,30.87394,0.101,NULL,64311548582,1004867946,15701061,17.9),(55594,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55594,36.6,0.33,209,16875,70,NULL,NULL,'2MASX J08364918+2840078',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000173,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,129.204875,28.66872,0.069,NULL,64320304986,1005004765,15703199,16.3),(55595,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55595,36.75,0.46,224,16876,70,NULL,NULL,'2MASX J08364980+2632438',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000207,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,129.207667,26.5455,0.089,NULL,64316811200,1004950175,15702346,16.8),(55596,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55596,37.72,0.46,350,16877,70,NULL,NULL,'2MASX J08365004+0156536',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,129.208416667,1.94825,0.129,NULL,62603743511,978183492,15284117,17.7),(55597,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55597,37.63,0.46,336,16878,70,NULL,NULL,'2MASX J08365059+0916053',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000193,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,129.2109583,9.26822,0.129,NULL,63667558629,994805603,15543837,16.7),(55598,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55598,37.74,0.46,353,16879,70,NULL,NULL,'SDSS J083652.57+174216.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000132,NULL,'18.6g',0.09,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,129.219083333,17.70467,0.101,NULL,63775170638,996487041,15570110,18.6),(55599,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55599,36.69,0.59,218,16880,70,NULL,NULL,'2MASX J08365324-0555065',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.78',NULL,NULL,NULL,NULL,NULL,NULL,1,129.221791667,-5.91847,0.097,NULL,39249564066,613274438,9582413,16.78),(55600,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55600,37.31,0.46,290,16881,70,NULL,NULL,'2MASX J08365358+3306544',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000118,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,129.22325,33.11525,0.165,NULL,64332345169,1005192893,15706138,18.2),(55601,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55601,36.46,0.56,196,16882,70,NULL,NULL,'2MASX J08365403-0601505',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.31',NULL,NULL,NULL,NULL,NULL,NULL,1,129.2250417,-6.03089,0.097,NULL,39249512618,613273634,9582400,17.31),(55602,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55602,38.01,0.46,401,16883,70,NULL,NULL,'SDSS J083654.75+613407.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,129.228125,61.56867,0.117,NULL,62047506432,969492288,15148317,18.6),(55603,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55603,35.04,0.52,102,16884,70,NULL,NULL,'2MFGC 06784',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,129.230375,-3.20961,0.073,NULL,39255416053,613365875,9583841,15.3),(55604,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55604,38.23,0.46,443,16885,70,NULL,NULL,'SDSS J083655.39+311139.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,129.2307917,31.19428,0.121,NULL,64311750191,1004871096,15701110,18.3),(55605,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55605,35.58,0.53,131,16886,70,NULL,NULL,'2MASX J08365571-0601045',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.28',NULL,NULL,NULL,NULL,NULL,NULL,1,129.232167,-6.01786,0.097,NULL,39249524616,613273822,9582403,16.28),(55606,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55606,37.63,0.46,335,16887,70,NULL,NULL,'2MASX J08365662+5129435',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000068,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,129.2357917,51.49536,0.125,NULL,63499293183,992176455,15502757,18),(55607,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55607,33.23,NULL,44.3,16888,NULL,NULL,'Dipole + Quadrupole + Octopole','FGCE 0709',NULL,'2010Ap&SS.325..163P',2010,1,1.62,NULL,'G',0.000017,NULL,'16.1',0.21,'Sd',NULL,NULL,NULL,NULL,1,129.245,-20.87889,0.317,NULL,42234272821,659910512,10311101,16.1),(55608,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55608,33.24,NULL,44.4,16888,NULL,NULL,'Dipole','FGCE 0709',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55609,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55609,33.24,NULL,44.4,16888,NULL,NULL,'Dipole + Quadrupole','FGCE 0709',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55610,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55610,38.36,0.46,470,16889,70,NULL,NULL,'2MASX J08365888+2820493',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,129.245333,28.34714,0.065,NULL,64320455303,1005007114,15703236,17.6),(55611,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55611,36.56,0.66,205,16890,70,NULL,NULL,'2MASX J08365951-1143405',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,129.247875,-11.72789,0.237,NULL,42163008331,658797005,10293703,15.4),(55612,'Brightest Stars','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55612,27.8,NULL,3.6,16891,NULL,NULL,'3B','UGC 04483',NULL,'1993A&A...275...39T',1993,1,1.4,NULL,'G',0.000001,NULL,'15.1g',0.7,'BlueCG         HII','Group member',NULL,NULL,NULL,1,129.2625,69.77528,0.137,NULL,62218238720,972159980,15189999,15.1),(55613,'CMD','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55613,27.86,0.07,3.73,16891,NULL,NULL,NULL,'UGC 04483',NULL,'2010ApJ...721..297M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55614,'TRGB','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55614,27.53,0.12,3.2,16891,NULL,NULL,NULL,'UGC 04483',NULL,'2001MNRAS.324..249D',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55615,'TRGB','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55615,27.53,0.13,3.2,16891,NULL,NULL,NULL,'UGC 04483',NULL,'2014A&A...566A..71L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55616,'TRGB','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55616,27.62,0.2,3.34,16891,NULL,NULL,'I','UGC 04483',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55617,'TRGB','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55617,27.63,0.12,3.36,16891,NULL,NULL,'I','UGC 04483',NULL,'2002ApJ...567..875I',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55618,'TRGB','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55618,27.67,0.07,3.41,16891,NULL,NULL,'I','UGC 04483',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55619,'TRGB','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55619,27.74,0.1,3.53,16891,NULL,NULL,NULL,'UGC 04483',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55620,'TRGB','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55620,27.74,0.08,3.53,16891,74.4,NULL,NULL,'UGC 04483',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55621,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55621,36.2,0.33,173,16892,70,NULL,NULL,'2MASX J08370486+4708299',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000072,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,129.27025,47.14169,0.161,NULL,64282152515,1004408633,15693884,16.5),(55622,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55622,37.85,0.46,371,16893,70,NULL,NULL,'2MASX J08370662+4511418',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000194,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,129.2775,45.19483,0.105,NULL,64251957232,1003936831,15686512,17),(55623,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55623,36.2,0.67,173,16894,70,NULL,NULL,'2MASX J08370672-0551025',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,129.278083333,-5.85067,0.097,NULL,39249574869,613274607,9582415,15.1),(55624,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55624,37.27,0.17,284,16895,70,NULL,NULL,'2MASX J08370683+3834516',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,129.2782917,38.58094,0.129,NULL,64371859163,1005810299,15715785,17.2),(55625,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55625,38.51,0.46,503,16896,70,NULL,NULL,'2MASX J08370700+0532376',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,129.279208333,5.54383,0.101,NULL,62607966434,978249475,15285148,17.8),(55626,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55626,36.05,0.59,162,16897,70,NULL,NULL,'2MASX J08370741-0715564',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.62',NULL,NULL,NULL,NULL,NULL,NULL,1,129.280875,-7.26567,0.065,NULL,39232938091,613014657,9578354,16.62),(55627,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55627,37.77,0.46,359,16898,70,NULL,NULL,'2MASX J08370838+1139105',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,129.2850417,11.65297,0.113,NULL,63655693331,994620208,15540940,17),(55628,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55628,38.61,0.46,527,16899,70,NULL,NULL,'2MASX J08370892+1504554',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000167,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,129.287,15.08203,0.133,NULL,63851935591,997686493,15588851,18.1),(55629,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55629,38.25,0.46,446,16900,70,NULL,NULL,'2MASX J08370892+0142106',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,129.2872917,1.703,0.129,NULL,62603882596,978185665,15284151,17.4),(55630,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55630,37.14,0.68,268,16901,70,NULL,NULL,'2MASX J08370945-0218076',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,129.289333,-2.30208,0.101,NULL,39253189062,613331079,9583298,14.5),(55631,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55631,31.86,0.43,23.6,16902,75,NULL,'3.6 micron, color + selection bias corrected','ESO 563- G 002',NULL,'2014MNRAS.444..527S',2014,1,2.49,NULL,'G',0.00002,NULL,'15.1',0.31,'SB(s)c? sp',NULL,NULL,NULL,NULL,1,129.295833,-22.24917,0.117,NULL,42241738722,660027167,10312924,15.1),(55632,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55632,31.9,NULL,24,16902,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 563- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55633,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55633,31.91,NULL,24.1,16902,NULL,NULL,'Dipole + Quadrupole','ESO 563- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55634,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55634,31.92,NULL,24.3,16902,NULL,NULL,'Dipole','ESO 563- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55635,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55635,36.18,0.76,172,16903,70,NULL,NULL,'2MASX J08371119-0210176',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.60',NULL,NULL,NULL,NULL,NULL,NULL,1,129.296583,-2.17172,0.101,NULL,39252776514,613324633,9583197,16.6),(55636,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55636,38.06,0.46,408,16904,70,NULL,NULL,'2MASX J08371243+2943442',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00011,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,129.301917,29.72914,0.085,NULL,64313111909,1004892373,15701443,17.6),(55637,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55637,36.94,0.46,245,16905,70,NULL,NULL,'2MASX J08371248+3537308',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000186,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,129.302,35.62528,0.125,NULL,64364870317,1005701098,15714079,16.3),(55638,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55638,38.15,0.46,427,16906,70,NULL,NULL,'2MASX J08371309+5237475',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000094,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,129.304666667,52.62994,0.141,NULL,63500956455,992202444,15503163,17.2),(55639,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55639,37.6,0.46,331,16907,70,NULL,NULL,'2MASX J08371363+3318548',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000112,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,129.306791667,33.31517,0.117,NULL,64361783423,1005652865,15713326,18.1),(55640,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55640,36.11,0.48,167,16908,70,NULL,NULL,'CGCG 004-087',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000127,NULL,'15.5',NULL,NULL,NULL,NULL,NULL,NULL,1,129.307625,-3.36175,0.073,NULL,39255457126,613366517,9583851,15.5),(55641,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55641,35.55,0.46,129,16909,70,NULL,NULL,'2MASX J08371543+5554293',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000152,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,129.314333,55.90819,0.165,NULL,61554577714,961790276,15027973,16.2),(55642,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55642,37.43,0.46,306,16910,70,NULL,NULL,'2MASX J08371743+4131056',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,129.3225,41.51808,0.117,NULL,64255646677,1003994479,15687413,17.7),(55643,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','PS1 SN PS10c','N',55643,39.28,0.11,622,16911,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10c HOST',0.1526,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55644,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55644,36.76,0.27,225,16912,70,NULL,NULL,'CGCG 150-007',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000183,NULL,'15.4g',0.54,'E0',NULL,NULL,NULL,NULL,1,129.341625,28.21508,0.065,NULL,64320466609,1005007290,15703238,15.4),(55645,'TRGB','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55645,28.21,0.1,4.39,16913,74.4,NULL,NULL,'ESO 165- G 003',NULL,'2013AJ....146...86T',2013,1,1.1,'abs(b) < 10 degrees.','G',0.00067,NULL,'16.1',0.2,'Sb',NULL,NULL,NULL,NULL,1,129.3430417,-57.55394,NULL,NULL,40409663656,631400994,9865640,16.1),(55646,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55646,34.29,0.49,72.2,16914,70,NULL,NULL,'2MFGC 06790',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,129.345375,-20.49847,0.321,NULL,42234031178,659906737,10311042,14.5),(55647,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55647,37.2,0.46,276,16915,70,NULL,NULL,'2MASX J08372390+3038098',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00015,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,129.3494583,30.63594,0.113,NULL,64315149365,1004924208,15701940,17.1),(55648,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55648,36.66,0.46,215,16916,70,NULL,NULL,'2MASX J08372408+1823103',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.0002,NULL,'15.3g',0.49,NULL,NULL,NULL,NULL,NULL,1,129.350333,18.38619,0.061,NULL,63775362590,996490040,15570156,15.3),(55649,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55649,35.68,0.63,137,16917,70,NULL,NULL,'2MASX J08372434-0316208',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,129.3514583,-3.27247,0.057,NULL,39254582158,613352846,9583638,14.7),(55650,'IRAS','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55650,31.65,0.8,21.4,16918,75,NULL,'A82, H','NGC 2591',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000017,NULL,'12.95',0.6,'Scd: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,129.356375,78.02642,0.033,NULL,61461202655,960331291,15005176,12.95),(55651,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55651,30.94,0.4,15.4,16918,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 2591',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55652,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55652,31.33,0.43,18.4,16918,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2591',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55653,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55653,31.4,0.47,19.1,16918,75,NULL,'A82, H, inv','NGC 2591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55654,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55654,31.42,0.38,19.2,16918,NULL,NULL,NULL,'NGC 2591',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55655,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55655,31.42,0.47,19.2,16918,75,NULL,'A82, H, raw','NGC 2591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55656,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55656,31.44,0.4,19.4,16918,75,NULL,NULL,'NGC 2591',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55657,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55657,31.45,0.43,19.5,16918,75,NULL,'3.6 micron, color corrected','NGC 2591',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55658,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55658,31.57,0.2,20.6,16918,74.4,NULL,NULL,'NGC 2591',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55659,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55659,31.65,0.46,21.4,16918,NULL,NULL,'J','NGC 2591',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55660,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55660,31.69,0.4,21.8,16918,NULL,NULL,'mean','NGC 2591',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55661,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55661,31.71,0.47,22,16918,NULL,NULL,'H','NGC 2591',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55662,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55662,31.75,0.45,22.4,16918,NULL,NULL,'K','NGC 2591',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55663,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55663,31.76,0.45,22.5,16918,NULL,NULL,NULL,'NGC 2591',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55664,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55664,31.77,0.47,22.6,16918,75,NULL,'A82, H, cor','NGC 2591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55665,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55665,31.78,0.45,22.7,16918,NULL,NULL,'Malmquist cor.','NGC 2591',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55666,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55666,31.8,0.4,22.9,16918,75,NULL,'B','NGC 2591',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55667,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55667,31.81,0.49,23,16918,75,NULL,'IR','NGC 2591',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55668,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55668,37.19,0.46,274,16919,70,NULL,NULL,'2MASX J08372553+3020398',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00014,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,129.356583,30.34431,0.109,NULL,64315186686,1004924791,15701949,17.8),(55669,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55669,38.95,0.46,617,16920,70,NULL,NULL,'2MASX J08372571+5752363',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,129.3570417,57.87678,0.213,NULL,61545447233,961647613,15025743,NULL),(55670,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55670,37.89,0.46,379,16921,70,NULL,NULL,'2MASX J08372591+1342333',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000136,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,129.3580417,13.70925,0.153,NULL,63838622623,997478478,15585601,18),(55671,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55671,36.76,0.27,225,16922,70,NULL,NULL,'2MASX J08372626+2806157',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000172,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,129.359375,28.10456,0.065,NULL,64320497954,1005007780,15703246,17),(55672,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55672,37.31,0.46,290,16923,70,NULL,NULL,'SDSS J083727.99+124453.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000153,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,129.366667,12.74819,0.137,NULL,63839387125,997490423,15585787,18.3),(55673,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55673,35.17,0.49,108,16924,75,NULL,'IR','NGC 2620',NULL,'2011yCatp016004901K',2011,1,2.13,NULL,'G',0.000033,NULL,'14.2g',0.48,'S?',NULL,NULL,NULL,NULL,1,129.367666667,24.94694,0.077,NULL,63793389727,996771714,15574558,14.2),(55674,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55674,35.4,0.47,120,16924,NULL,NULL,'H','NGC 2620',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55675,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55675,35.4,0.46,120,16924,NULL,NULL,'J','NGC 2620',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55676,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55676,35.4,0.4,120,16924,NULL,NULL,'mean','NGC 2620',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55677,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55677,35.53,0.45,128,16924,NULL,NULL,'K','NGC 2620',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55678,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55678,35.86,0.46,148,16925,70,NULL,NULL,'2MASX J08372825+2042145',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'16.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,129.3677083,20.70397,0.109,NULL,63797747640,996839806,15575621,16.6),(55679,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55679,36.56,0.76,205,16926,70,NULL,NULL,'2MASX J08372840-5809240',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,129.368375,-58.15678,0.849,NULL,40538486749,633413855,9897091,17.2),(55680,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55680,36.31,0.61,183,16927,70,NULL,NULL,'2MASX J08372981-0347478',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.93',NULL,NULL,NULL,NULL,NULL,NULL,1,129.374167,-3.79669,0.105,NULL,39255357258,613364957,9583827,16.93),(55681,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55681,37.97,0.46,392,16928,70,NULL,NULL,'2MASX J08373179-0027428',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,129.3825,-0.46181,0.085,NULL,39250523238,613289425,9582647,17.3),(55682,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55682,37.31,0.46,290,16929,70,NULL,NULL,'SDSS J083732.19+551504.8',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000073,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,129.384166667,55.25133,0.121,NULL,61541531189,961586424,15024787,17.4),(55683,'Sosies','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55683,33.69,0.16,54.7,16930,NULL,NULL,NULL,'NGC 2619',NULL,'2002A&A...393...57T',2002,1,2.3,NULL,'G',0.000023,NULL,'13.19',1.4,'Sbc','Isolated galaxy (6 Mpc isolation)',NULL,NULL,NULL,1,129.386291667,28.70519,0.069,NULL,64320286262,1005004472,15703194,13.19),(55684,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55684,32.68,0.69,34.4,16930,100,NULL,'mid-IR','NGC 2619',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55685,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55685,33.63,0.06,53.3,16930,NULL,NULL,NULL,'NGC 2619',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55686,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55686,33.76,0.4,56.6,16930,NULL,NULL,'mean','NGC 2619',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55687,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55687,33.96,0.46,61.9,16930,NULL,NULL,'J','NGC 2619',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55688,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55688,33.96,0.45,62,16930,NULL,NULL,'K','NGC 2619',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55689,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55689,33.97,0.2,62.2,16930,74.4,NULL,NULL,'NGC 2619',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55690,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55690,34.01,0.47,63.5,16930,NULL,NULL,'H','NGC 2619',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55691,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55691,36.99,0.46,250,16931,70,NULL,NULL,'2MASX J08373283+4500198',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000189,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,129.386917,45.00536,0.101,NULL,64251927890,1003936373,15686505,16.8),(55692,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55692,37.4,0.33,302,16932,70,NULL,NULL,'2MASX J08373292+3555488',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000167,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,129.3872083,35.93017,0.113,NULL,64364759011,1005699359,15714052,17),(55693,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55693,36.24,0.46,177,16933,70,NULL,NULL,'2MASX J08373336+3345068',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000155,NULL,'16.0g',0.46,'E/S0',NULL,NULL,NULL,NULL,1,129.388917,33.75192,0.125,NULL,64362510726,1005664230,15713503,16),(55694,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55694,38.03,0.33,404,16934,70,NULL,NULL,'2MASXi J0837338+400327',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000138,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,129.390708333,40.05769,0.109,NULL,64371045482,1005797585,15715587,18),(55695,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55695,36.19,0.46,173,16935,70,NULL,NULL,'2MASX J08373473+0951363',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,129.394583,9.86011,0.181,NULL,63668333581,994817712,15544026,16.7),(55696,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55696,33.25,NULL,44.6,16936,NULL,NULL,NULL,'2MASX J08373545+0748303',NULL,'2015AstBu..70....1K',2015,1,0.39,NULL,'G',0.000064,NULL,'16.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,129.397833333,7.80864,0.133,NULL,62572257958,977691530,15276430,16.3),(55697,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55697,38.38,0.46,474,16937,70,NULL,NULL,'2MASX J08373547+2251285',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000176,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,129.3979583,22.85806,0.097,NULL,63800258469,996879038,15576234,18.5),(55698,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55698,38.03,0.33,404,16938,70,NULL,NULL,'2MASX J08373596+4009078',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,129.399583,40.15217,0.117,NULL,64366841159,1005731893,15714560,17.9),(55699,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55699,36.93,0.53,243,16939,70,NULL,NULL,'2MASX J08373591-0140298',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.6I',0.6,NULL,NULL,NULL,NULL,NULL,1,129.399625,-1.67489,0.073,NULL,39253725549,613339461,9583429,13.6),(55700,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55700,36.92,0.94,242,16940,70,NULL,NULL,'2MASX J08373603-0323058',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.5I',0.2,NULL,NULL,NULL,NULL,NULL,1,129.4002083,-3.38494,0.125,NULL,39254576923,613352764,9583636,14.5),(55701,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55701,36,0.5,158,16941,70,NULL,NULL,'2MASX J08373724-0212458',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.44',NULL,NULL,NULL,NULL,NULL,NULL,1,129.405125,-2.21275,0.061,NULL,39252751310,613324239,9583191,16.44),(55702,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55702,35.53,0.4,127,16942,NULL,NULL,'mean','MCG -01-22-029',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000043,NULL,'14',0.6,'HII',NULL,NULL,NULL,NULL,1,129.410166667,-6.71839,0.057,NULL,39229663913,612963498,9577554,14),(55703,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55703,35.65,0.47,135,16942,NULL,NULL,'H','MCG -01-22-029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55704,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55704,30.11,0.43,10.5,16943,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04499',NULL,'2014MNRAS.444..527S',2014,1,1.99,NULL,'G',0.000003,NULL,'14.7g',0.71,'SABdm          AGN?','Isolated galaxy',NULL,NULL,NULL,1,129.422833333,51.65239,0.125,NULL,63499326165,992176971,15502765,14.7),(55705,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55705,30.54,0.4,12.8,16943,75,NULL,'B','UGC 04499',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55706,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55706,37.4,0.33,302,16944,70,NULL,NULL,'2MASX J08374199+3557008',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000204,NULL,'15.9g',0.43,'E0',NULL,NULL,NULL,NULL,1,129.4249583,35.95025,0.113,NULL,64364772220,1005699565,15714055,15.9),(55707,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55707,37.33,0.27,292,16945,70,NULL,NULL,'2MASX J08374259+3046238',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,129.427416667,30.77319,0.113,NULL,64311627386,1004869177,15701080,17.6),(55708,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55708,33.46,0.2,49.2,16946,74.4,NULL,NULL,'UGC 04504',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000011,NULL,'14.70',0.7,'Sd','Isolated galaxy',NULL,NULL,NULL,1,129.4290417,20.50386,0.093,NULL,63798780843,996855950,15575874,14.7),(55709,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55709,34.27,0.1,71.6,16946,NULL,NULL,NULL,'UGC 04504',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55710,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55710,36.95,0.46,246,16947,70,NULL,NULL,'2MASX J08374537+1423273',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000127,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,129.4390417,14.39092,0.133,NULL,63851449595,997678899,15588732,17.9),(55711,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55711,37.6,0.46,331,16948,70,NULL,NULL,'2MASX J08374542+4816030',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000075,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,129.43925,48.26744,0.137,NULL,64228244652,1003566322,15680723,17.8),(55712,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55712,35.51,0.5,127,16949,70,NULL,NULL,'2MASX J08374605-1851240',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.3I',0.5,NULL,NULL,NULL,NULL,NULL,1,129.441833,-18.85661,0.277,NULL,42261880705,660341886,10317841,13.3),(55713,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55713,37.45,0.46,309,16950,70,NULL,NULL,'2MASX J08374645+1049094',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,129.443625,10.81922,0.129,NULL,63655904483,994623507,15540992,17.1),(55714,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55714,37.3,0.46,289,16951,70,NULL,NULL,'2MASX J08374677+2054526',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000175,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,129.445,20.91472,0.109,NULL,63797829754,996841089,15575642,16.9),(55715,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55715,37.33,0.27,292,16952,70,NULL,NULL,'2MASX J08374758+3050104',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000157,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,129.448166667,30.83628,0.101,NULL,64311637904,1004869342,15701083,17),(55716,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55716,35.55,0.59,129,16953,70,NULL,NULL,'AM 0843-721',NULL,'2014MNRAS.445.2677S',2014,1,0.83,'+5m 39s, +1.1m error in A-M position.','G',0.00015,NULL,'15.8B',0.42,'COMPACT',NULL,NULL,NULL,NULL,1,129.452375,-72.46861,0.677,NULL,40621420580,634709696,9917339,15.8),(55717,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55717,36.73,0.46,222,16954,70,NULL,NULL,'2MASX J08374867+2946556',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000157,NULL,'16.8g',0.27,'S0',NULL,NULL,NULL,NULL,1,129.45275,29.78228,0.129,NULL,64314540453,1004914694,15701792,16.8),(55718,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55718,37.8,0.46,363,16955,70,NULL,NULL,'2MASX J08374899+1544323',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000187,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,129.45425,15.74233,0.117,NULL,63847722393,997620662,15587822,16.8),(55719,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55719,37.89,0.46,378,16956,70,NULL,NULL,'2MASX J08374913+4011158',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00016,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,129.454667,40.18772,0.117,NULL,64246253391,1003847709,15685120,17.1),(55720,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55720,36.38,0.72,189,16957,70,NULL,NULL,'CGCG 004-090 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.33',0.4,NULL,NULL,NULL,NULL,NULL,1,129.457333,-0.25161,0.085,NULL,39195796894,612434326,9569286,16.33),(55721,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55721,36.49,0.46,198,16958,70,NULL,NULL,'2MASX J08375069+1743523',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000182,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,129.461125,17.73111,0.101,NULL,63775166698,996486979,15570109,16.2),(55722,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55722,37.57,0.23,327,16959,70,NULL,NULL,'2MASX J08375148+2635556',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000175,NULL,'16.1g',0.34,'E0',NULL,NULL,NULL,NULL,1,129.4644583,26.59883,0.089,NULL,64321456795,1005022762,15703480,16.1),(55723,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55723,37.89,0.46,379,16960,70,NULL,NULL,'2MASX J08375256+5743231',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,129.46925,57.72308,0.193,NULL,61545630580,961650477,15025788,18.1),(55724,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55724,34.95,0.2,97.7,16961,74.4,NULL,NULL,'CGCG 060-031',NULL,'2013AJ....146...86T',2013,1,0.98,NULL,'G',0.000105,NULL,'15.6g',0.29,'Sb','Isolated galaxy',NULL,NULL,NULL,1,129.47225,12.78053,0.137,NULL,63839394522,997490539,15585789,15.6),(55725,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55725,35,0.49,99.9,16961,75,NULL,'IR','CGCG 060-031',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55726,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55726,37.14,0.46,267,16962,70,NULL,NULL,'2MASX J08375345+3309464',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,129.472917,33.16297,0.129,NULL,64361746036,1005652281,15713316,17.7),(55727,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55727,38.67,0.33,542,16963,70,NULL,NULL,'2MASX J08375397+3036074',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,129.4749583,30.60197,0.113,NULL,64315087193,1004923237,15701925,18.5),(55728,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55728,37.9,0.46,380,16964,70,NULL,NULL,'SDSS J083754.17+184537.4',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000183,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,129.47575,18.76042,0.053,NULL,63803898252,996935910,15577123,17.3),(55729,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55729,35.59,0.59,131,16965,70,NULL,NULL,'2MASX J08375500-1847090',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,129.479167,-18.78589,0.309,NULL,42261888532,660342008,10317843,15.4),(55730,'Tully est','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55730,32.13,0.8,26.7,16966,75,NULL,'B','UGC 04508',NULL,'1988NBGC.C....0000T',1988,1,0.4,NULL,'G',0.000022,NULL,'15.0',0.4,'cE?            HII',NULL,NULL,NULL,NULL,1,129.484167,-2.46322,0.077,NULL,39253404421,613334444,9583350,15),(55731,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55731,38.5,0.33,501,16967,70,NULL,NULL,'SDSS J083756.19+554203.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,129.484167,55.70103,0.137,NULL,61552782399,961762224,15027534,18.3),(55732,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55732,36.32,0.46,184,16968,70,NULL,NULL,'2MASX J08375646+3147294',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000174,NULL,'16.2g',0.38,'E0',NULL,NULL,NULL,NULL,1,129.485166667,31.79156,0.117,NULL,64311333948,1004864592,15701009,16.2),(55733,'TRGB','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55733,27.92,0.1,3.84,16969,74.4,NULL,NULL,'KK 0197',NULL,'2013AJ....146...86T',2013,1,0.57,NULL,'G',0.000414,NULL,'16.9',0.28,NULL,NULL,NULL,NULL,NULL,1,129.488208333,-57.97381,0.873,NULL,40409504109,631398501,9865601,16.9),(55734,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55734,35.51,0.23,126,16970,70,NULL,NULL,'CGCG 120-009',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.000093,NULL,'14.7g',0.8,NULL,'Group member',NULL,NULL,NULL,1,129.4932917,25.17389,0.085,NULL,64316695541,1004948367,15702318,14.7),(55735,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55735,37.66,0.46,341,16971,70,NULL,NULL,'2MASX J08375854+4825101',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000078,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,129.4939583,48.41942,0.113,NULL,64227980142,1003562189,15680659,17.8),(55736,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55736,38.01,0.46,399,16972,70,NULL,NULL,'SDSS J083758.86+255055.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,129.4952917,25.84872,0.085,NULL,64317479423,1004960615,15702509,18.6),(55737,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55737,36.16,0.51,170,16973,70,NULL,NULL,'ESO 563- G 005',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'13.8R',0.9,'Sa:',NULL,NULL,NULL,NULL,1,129.497417,-18.83356,0.309,NULL,42261877834,660341841,10317841,13.8),(55738,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55738,36.77,0.46,226,16974,70,NULL,NULL,'2MASX J08375942+0418135',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000164,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,129.4975,4.30383,0.065,NULL,62606980482,978234070,15284907,16.3),(55739,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55739,37.73,0.46,352,16975,70,NULL,NULL,'SDSS J083800.38+133332.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'18.7g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,129.501625,13.55892,0.157,NULL,63838668315,997479192,15585612,18.7),(55740,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55740,37.36,0.46,297,16976,70,NULL,NULL,'SDSS J083801.12+091826.3',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000186,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,129.5047083,9.30733,0.197,NULL,63668369171,994818268,15544035,16.7),(55741,'IRAS','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55741,33.91,0.8,60.6,16977,75,NULL,'MAT, I','MCG -02-22-023',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000017,NULL,'13.7B',0.5,'SAB(r)bc       HII',NULL,NULL,NULL,NULL,1,129.505458333,-9.81964,0.125,NULL,42175790647,658996728,10296823,13.7),(55742,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55742,34.11,0.32,66.3,16977,85,NULL,'I, raw','MCG -02-22-023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55743,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55743,34.15,0.32,67.6,16977,85,NULL,'I, inv','MCG -02-22-023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55744,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55744,34.23,0.4,70,16977,NULL,NULL,'mean','MCG -02-22-023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55745,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55745,34.26,0.43,71.1,16977,75,NULL,'MAT, I, raw','MCG -02-22-023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55746,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55746,34.45,0.43,77.6,16977,75,NULL,'MAT, I, inv','MCG -02-22-023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55747,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55747,34.5,0.43,79.4,16977,75,NULL,'MAT, I, cor','MCG -02-22-023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55748,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55748,34.57,0.47,81.9,16977,NULL,NULL,'H','MCG -02-22-023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55749,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55749,35.09,0.2,104,16977,74.4,NULL,NULL,'MCG -02-22-023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55750,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55750,35.51,0.23,126,16978,70,NULL,NULL,'CGCG 120-010 NED01',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000073,NULL,'15.5g',0.47,NULL,NULL,NULL,NULL,NULL,1,129.505666667,25.32753,0.085,NULL,64316701409,1004948459,15702319,15.5),(55751,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55751,37.53,0.46,320,16979,70,NULL,NULL,'2MASX J08380147+4050068',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000156,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,129.5062917,40.83528,0.101,NULL,64254750336,1003980474,15687194,17),(55752,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55752,38.03,0.46,403,16980,70,NULL,NULL,'2MASX J08380194+2954304',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,129.508125,29.90844,0.129,NULL,64315274310,1004926161,15701971,18.4),(55753,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55753,36.76,0.27,225,16981,70,NULL,NULL,'2MASX J08380224+2825187',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000173,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,129.5092083,28.42197,0.065,NULL,64320377080,1005005891,15703217,17.2),(55754,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55754,37.57,0.23,327,16982,70,NULL,NULL,'2MASX J08380260+2630077',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000192,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,129.510791667,26.50222,0.089,NULL,64321336731,1005020886,15703451,16.4),(55755,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55755,38.5,0.33,501,16983,70,NULL,NULL,'2MASX J08380333+5542491',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,129.5137917,55.71381,0.137,NULL,61552782093,961762220,15027534,18.1),(55756,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55756,35.51,0.23,126,16984,70,NULL,NULL,'CGCG 120-011 NED01',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000083,NULL,'16.4g',NULL,NULL,NULL,NULL,NULL,NULL,1,129.520625,24.89092,0.053,NULL,63793361442,996771272,15574551,16.4),(55757,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55757,38.29,0.46,455,16985,70,NULL,NULL,'2MASX J08380528+2701007',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,129.522083,27.01683,0.069,NULL,64323340409,1005052193,15703940,17.8),(55758,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55758,38.67,0.33,542,16986,70,NULL,NULL,'SDSS J083805.36+304435.4',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.6g',0.33,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,129.522375,30.74317,0.113,NULL,64315090097,1004923282,15701926,16.6),(55759,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55759,37.55,0.46,324,16987,70,NULL,NULL,'2MASX J08380565+2313589',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000161,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,129.523708333,23.23308,0.133,NULL,63802984971,996921640,15576900,16.7),(55760,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55760,35.51,0.23,126,16988,70,NULL,NULL,'CGCG 120-012',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000067,NULL,'14.8g',0.72,NULL,'Group member',NULL,NULL,NULL,1,129.528083333,25.27261,0.085,NULL,64316700609,1004948447,15702319,14.8),(55761,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55761,37.95,0.46,390,16989,70,NULL,NULL,'2MASX J08380756+0024345',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,129.531625,0.40967,0.109,NULL,62554012530,977406445,15271975,17.2),(55762,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55762,37.76,0.46,357,16990,70,NULL,NULL,'2MASX J08380878+1925559',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,129.536625,19.43217,0.073,NULL,63804732637,996948947,15577327,17.9),(55763,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55763,36.85,0.46,235,16991,70,NULL,NULL,'2MASX J08380955+1713397',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00018,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,129.54,17.22783,0.081,NULL,63845970096,997593282,15587395,16.6),(55764,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55764,35.63,0.71,134,16992,70,NULL,NULL,'2MASX J08381000-1846038',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,129.54175,-18.76778,0.309,NULL,42261884250,660341941,10317842,15.6),(55765,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55765,34.92,NULL,96.5,16993,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0774',NULL,'2010Ap&SS.325..163P',2010,1,0.87,NULL,'G',NULL,NULL,'16.5',0.1,'Scd(f)',NULL,NULL,NULL,NULL,1,129.546125,45.88206,0.129,NULL,64249121366,1003892521,15685820,16.5),(55766,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55766,34.93,NULL,97,16993,NULL,NULL,'Dipole + Quadrupole','FGC 0774',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55767,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55767,34.96,NULL,98.2,16993,NULL,NULL,'Dipole','FGC 0774',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55768,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55768,34.98,NULL,99.1,16993,NULL,NULL,NULL,'FGC 0774',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55769,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55769,35.28,0.49,114,16993,75,NULL,'IR','FGC 0774',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55770,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55770,37.58,0.46,328,16994,70,NULL,NULL,'SDSS J083811.74+392903.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,129.5489583,39.48419,0.109,NULL,64371253306,1005800832,15715638,18.1),(55771,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55771,37.69,0.46,345,16995,70,NULL,NULL,'2MASX J08381203+4448256',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000195,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,129.5502917,44.80717,0.105,NULL,64251890617,1003935790,15686496,16.4),(55772,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55772,37.46,0.46,310,16996,70,NULL,NULL,'2MASX J08381253+0024591',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,129.552166667,0.41639,0.109,NULL,62554004193,977406315,15271973,17.4),(55773,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55773,37.69,0.33,346,16997,70,NULL,NULL,'2MASX J08381264+0805522',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000164,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,129.55275,8.09789,0.133,NULL,63659560905,994680639,15541884,18.3),(55774,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55774,36.23,0.46,176,16998,70,NULL,NULL,'2MASX J08381265+5243280',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000074,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,129.5527917,52.72453,0.141,NULL,63500743586,992199118,15503111,16.6),(55775,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55775,37.08,0.46,261,16999,70,NULL,NULL,'2MASX J08381297+0436491',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00018,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,129.5539583,4.61375,0.065,NULL,62607395495,978240554,15285008,16.3),(55776,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55776,37.71,0.46,348,17000,70,NULL,NULL,'2MASX J08381350+4347486',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,129.556417,43.79694,0.121,NULL,64252839849,1003950622,15686728,17),(55777,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55777,35.71,0.46,139,17001,70,NULL,NULL,'2MASX J08381535+3529384',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00016,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,129.564041667,35.49397,0.105,NULL,64364826274,1005700410,15714068,16.6),(55778,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55778,36.65,0.46,214,17002,70,NULL,NULL,'2MASX J08381617+3505223',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000182,NULL,'15.9g',0.4,'E0',NULL,NULL,NULL,NULL,1,129.567458333,35.08964,0.081,NULL,64365752375,1005714880,15714295,15.9),(55779,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55779,37.23,0.46,279,17003,70,NULL,NULL,'2MASX J08381699+0149041',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,129.57075,1.81783,0.133,NULL,62601605173,978150080,15283595,17.4),(55780,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55780,37.57,0.23,327,17004,70,NULL,NULL,'2MASX J08381706+2633117',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,129.5710417,26.55319,0.089,NULL,64321461147,1005022830,15703481,17.6),(55781,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55781,35.77,0.46,143,17005,70,NULL,NULL,'KUG 0834+427',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000141,NULL,'16.4g',0.23,'Compact',NULL,NULL,NULL,NULL,1,129.572917,42.62106,0.093,NULL,64256514365,1004008036,15687625,16.4),(55782,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55782,37.21,0.33,276,17006,70,NULL,NULL,'2MASX J08382003+1504337',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,129.5835,15.07603,0.093,NULL,63851969083,997687016,15588859,17.1),(55783,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55783,37.51,0.46,317,17007,70,NULL,NULL,'SDSS J083821.26+560031.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000146,NULL,'18.9g',0.11,NULL,NULL,NULL,NULL,NULL,1,129.588583333,56.00875,0.169,NULL,61554080399,961782506,15027851,18.9),(55784,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55784,37.83,0.46,368,17008,70,NULL,NULL,'2MASX J08382140+1409477',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,129.5889583,14.16333,0.137,NULL,63851228853,997675450,15588678,17.9),(55785,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55785,34.68,0.46,86.4,17009,70,NULL,NULL,'CGCG 150-010',NULL,'2015arXiv151105856S',2015,1,0.66,'SDSS DR4 has z = 0.025200 +- 0.000180.','G',0.000093,NULL,'15.1g',0.36,'S0',NULL,NULL,NULL,NULL,1,129.58975,28.14856,0.065,NULL,64320312782,1005004887,15703201,15.1),(55786,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55786,35.89,0.46,151,17010,70,NULL,NULL,'2MASX J08382254+0421211',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000178,NULL,'15.5g',0.4,'E0',NULL,NULL,NULL,NULL,1,129.594,4.356,0.065,NULL,62607090437,978235788,15284934,15.5),(55787,'TRGB','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55787,27.88,0.1,3.77,17011,74.4,NULL,NULL,'KK 0213',NULL,'2013AJ....146...86T',2013,1,0.63,'abs(b) < 10 degrees.','G',0.00026,NULL,'16.4',0.4,NULL,NULL,NULL,NULL,NULL,1,129.595917,-55.17814,NULL,NULL,40401559729,631274370,9863662,16.4),(55788,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55788,38.05,0.46,408,17012,70,NULL,NULL,'2MASX J08382323+2945217',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000143,NULL,'17.0g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,129.597,29.75597,0.129,NULL,64314556137,1004914939,15701795,17),(55789,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55789,37.69,0.33,346,17013,70,NULL,NULL,'2MASX J08382328+0804383',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00017,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,129.597041667,8.07736,0.133,NULL,63659552046,994680500,15541882,17.5),(55790,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','SN 2004gs',NULL,55790,35.46,0.16,117,17014,72,NULL,NULL,'ARK 174',0.02752,'2013ApJ...773...53F',2013,1,0.74,NULL,'G',0.000168,NULL,'14.8g',0.64,'S0?','Pair member (points to parent)',NULL,NULL,NULL,1,129.599375,17.63133,0.057,NULL,63775017640,996484650,15570072,14.8),(55791,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','SN 2004gs',NULL,55791,35.48,0.14,122,17014,72,NULL,NULL,'ARK 174',0.026645,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55792,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','SN 2004gs',NULL,55792,35.51,0.03,123,17014,72,NULL,NULL,'ARK 174',0.026645,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55793,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','SN 2004gs',NULL,55793,35.45,0.1,123,17014,74.4,NULL,NULL,'ARK 174',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55794,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','SN 2004gs',NULL,55794,35.47,0.01,124,17014,72,NULL,NULL,'ARK 174',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55795,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','SN 2004gs',NULL,55795,35.53,0.16,124,17014,70,NULL,'SALT 2','ARK 174',0.026645,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55796,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','SN 2004gs',NULL,55796,35.6,0.14,128,17014,73.8,NULL,'SALT 2 (SNANA)','ARK 174',0.0274,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55797,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','SN 2004gs',NULL,55797,35.69,0.12,137,17014,72,NULL,'M(H) = -18.317 mag','ARK 174',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55798,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','SN 2004gs',NULL,55798,37.21,0.02,269,17014,70,NULL,NULL,'ARK 174',0.026645,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55799,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55799,34.6,0.46,83.2,17014,70,NULL,NULL,'ARK 174',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55800,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','SN 1999gd',NULL,55800,33.7,0.2,53.9,17015,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','NGC 2623',0.01846,'2011A&A...526A..81B',2011,1,2.4,'Position for J-band nucleus.','G',0.000003,NULL,'13.1B',0.7,'Pec;LINER;LIRG Sy2',NULL,NULL,NULL,NULL,1,129.600333,25.75464,0.085,NULL,64316599384,1004946865,15702294,13.1),(55801,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','SN 1999gd',NULL,55801,34.2,0.24,67.9,17015,74.2,NULL,'SALT 2','NGC 2623',0.01846,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55802,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','SN 1999gd',NULL,55802,34.45,0.07,76.3,17015,72,NULL,NULL,'NGC 2623',0.01846,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55803,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','SN 1999gd',NULL,55803,34.53,0.21,78.9,17015,65,NULL,'MLCS31','NGC 2623',0.01846,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55804,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','SN 1999gd',NULL,55804,34.55,0.25,79.8,17015,72,NULL,NULL,'NGC 2623',0.01846,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55805,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','SN 1999gd',NULL,55805,34.61,0.17,80.4,17015,65,NULL,'MLCS2k2','NGC 2623',0.01846,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55806,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','SN 1999gd',NULL,55806,34.54,0.08,80.9,17015,74.4,NULL,NULL,'NGC 2623',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55807,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','SN 1999gd',NULL,55807,34.57,0.17,82,17015,70.8,NULL,NULL,'NGC 2623',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55808,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','SN 1999gd',NULL,55808,34.97,0.2,96.8,17015,65,NULL,'MLCS17','NGC 2623',0.01846,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55809,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','SN 1999gd',NULL,55809,35.05,0.14,102,17015,60,NULL,NULL,'NGC 2623',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55810,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','SN 1999gd',NULL,55810,35.1,0.22,103,17015,65,NULL,'SALT2','NGC 2623',0.01846,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55811,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','SN 1999gd',NULL,55811,35.16,0.29,106,17015,70,NULL,'SALT','NGC 2623',0.01846,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55812,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','SN 1999gd',NULL,55812,35.19,0.31,107,17015,65,NULL,'SALT','NGC 2623',0.01846,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55813,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55813,33.49,NULL,50,17015,75,NULL,'HI','NGC 2623',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55814,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55814,33.93,NULL,61.1,17015,75,NULL,'CO','NGC 2623',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55815,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55815,38,0.46,398,17016,70,NULL,NULL,'2MASX J08382471+4806133',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000078,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,129.603083333,48.10364,0.109,NULL,64228256202,1003566503,15680726,17.7),(55816,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55816,36.2,0.57,173,17017,70,NULL,NULL,'CGCG 004-096',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.6',0.4,NULL,NULL,NULL,NULL,NULL,1,129.603667,-1.60642,0.073,NULL,39253718832,613339356,9583427,15.6),(55817,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55817,36.5,0.33,199,17018,70,NULL,NULL,'2MASX J08382494+2356549',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.5g',0.22,'AGN',NULL,NULL,NULL,NULL,1,129.604083,23.94867,0.097,NULL,63802066674,996907291,15576676,17.5),(55818,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55818,38.58,0.46,521,17019,70,NULL,NULL,'2MASX J08382499+2734416',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,129.604291667,27.57833,0.073,NULL,64323505302,1005054770,15703980,17.8),(55819,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55819,36.77,0.59,226,17020,70,NULL,NULL,'2MASX J08382503-0323074',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.91',0.5,NULL,NULL,NULL,NULL,NULL,1,129.604333333,-3.38528,0.125,NULL,39254714838,613354919,9583670,16.91),(55820,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55820,35.39,0.46,120,17021,70,NULL,NULL,'2MASX J08382547+1244300',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,129.606208333,12.74158,0.137,NULL,63839352355,997489880,15585779,16.5),(55821,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55821,36.5,0.33,199,17022,70,NULL,NULL,'2MASX J08382575+2358119',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000181,NULL,'16.3g',0.38,'AGN',NULL,NULL,NULL,NULL,1,129.607333333,23.96994,0.097,NULL,63802068102,996907314,15576676,16.3),(55822,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55822,37.58,0.46,328,17023,70,NULL,NULL,'2MASX J08382712+2027369',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000155,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,129.612875,20.46039,0.093,NULL,63798835095,996856798,15575887,17),(55823,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55823,37.59,0.46,330,17024,70,NULL,NULL,'2MASX J08382707+6202440',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,129.613,62.0455,0.137,NULL,62054798790,969606231,15150097,18.2),(55824,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55824,34.25,NULL,70.8,17025,NULL,NULL,'Dipole + Quadrupole','ESO 431- G 023',NULL,'2010Ap&SS.325..163P',2010,1,1.4,'Stars superposed.','G',0.00002,NULL,'16.1',0.09,'Sc',NULL,NULL,NULL,NULL,1,129.616,-29.68956,NULL,NULL,42726402923,667600045,10431250,16.1),(55825,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55825,34.25,NULL,71,17025,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 431- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55826,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55826,34.26,NULL,71.1,17025,NULL,NULL,'Dipole','ESO 431- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55827,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55827,37.82,0.33,366,17026,70,NULL,NULL,'2MASX J08382808+1433240',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000137,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,129.617,14.55669,0.081,NULL,63851318550,997676852,15588700,18.5),(55828,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55828,37.67,0.46,341,17027,70,NULL,NULL,'2MASX J08382867+2635332',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000171,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,129.619417,26.59272,0.089,NULL,64321462011,1005022843,15703481,17.7),(55829,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55829,37.21,0.33,276,17028,70,NULL,NULL,'2MASX J08383091+1501500',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000189,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,129.628833,15.0305,0.093,NULL,63851956252,997686816,15588856,16.1),(55830,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55830,38.07,0.46,412,17029,70,NULL,NULL,'2MASX J08383145+1738220',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000134,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,129.631125,17.63956,0.057,NULL,63775016404,996484631,15570072,18.1),(55831,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55831,36.52,0.46,201,17030,70,NULL,NULL,'2MASX J08383197+5257104',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'16.61',NULL,NULL,NULL,NULL,NULL,NULL,1,129.633166667,52.95286,0.137,NULL,63500254046,992191469,15502991,16.61),(55832,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55832,36.96,0.46,247,17031,70,NULL,NULL,'2MASX J08383322+4529375',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,129.638625,45.49364,0.105,NULL,64251995386,1003937427,15686522,17.3),(55833,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55833,38.01,0.46,400,17032,70,NULL,NULL,'2MASX J08383381+3351384',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000153,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,129.6409583,33.86072,0.117,NULL,64362633591,1005666149,15713533,17),(55834,'IRAS','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55834,35.17,0.8,108,17033,75,NULL,'CF, r','IC 2387',NULL,'1997ApJS..109..333W',1997,1,1.21,NULL,'G',0.000033,NULL,'14.5g',0.58,'Scd:',NULL,NULL,NULL,NULL,1,129.641667,30.79869,0.113,NULL,64311644948,1004869452,15701085,14.5),(55835,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55835,34.75,0.41,89.3,17033,NULL,NULL,NULL,'IC 2387',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55836,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55836,34.77,0.38,90.1,17033,75,NULL,'CF, r, raw','IC 2387',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55837,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55837,34.79,0.2,90.8,17033,74.4,NULL,NULL,'IC 2387',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55838,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55838,34.79,0.4,90.8,17033,NULL,NULL,'Malmquist cor.','IC 2387',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55839,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55839,34.93,0.38,96.6,17033,75,NULL,'CF, r, inv','IC 2387',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55840,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55840,34.99,0.38,99.4,17033,75,NULL,'CF, r, cor','IC 2387',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55841,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55841,37.82,0.33,366,17034,70,NULL,NULL,'2MASX J08383414+1430510',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000182,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,129.64225,14.51417,0.081,NULL,63851309312,997676708,15588698,17.8),(55842,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55842,37.98,0.46,395,17035,70,NULL,NULL,'2MASX J08383528+5355514',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000095,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,129.647125,53.93094,0.121,NULL,63487007177,991984487,15499757,16.8),(55843,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55843,38.29,0.46,455,17036,70,NULL,NULL,'2MASX J08383577+4039273',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000147,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,129.649125,40.6575,0.101,NULL,64246399185,1003849987,15685156,17.7),(55844,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55844,38.11,0.21,418,17037,70,NULL,NULL,'2MASX J08383858+2550212',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00013,NULL,'16.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,129.66075,25.83919,0.085,NULL,64316632330,1004947380,15702302,16.4),(55845,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55845,36.05,0.79,162,17038,70,NULL,NULL,'2MASX J08383897-1856056',NULL,'2014MNRAS.445.2677S',2014,1,0.1,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,129.6624583,-18.93492,0.325,NULL,42261925129,660342580,10317852,15.5),(55846,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55846,38.54,0.46,509,17039,70,NULL,NULL,'SDSS J083840.93+184707.8',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000183,NULL,'17.2g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,129.670583333,18.78553,0.061,NULL,63803911239,996936113,15577126,17.2),(55847,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55847,37.67,0.46,341,17040,70,NULL,NULL,'2MASX J08384183+4249246',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000159,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,129.674417,42.82353,0.077,NULL,64256489397,1004007646,15687619,16.9),(55848,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55848,37.24,0.46,281,17041,70,NULL,NULL,'2MASX J08384203+4619486',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000082,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,129.675125,46.33006,0.085,NULL,64282353799,1004411778,15693934,16.8),(55849,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55849,37.92,0.46,384,17042,70,NULL,NULL,'2MASX J08384009+2747522',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,129.675333333,27.80111,0.073,NULL,64323462733,1005054105,15703970,18.4),(55850,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55850,38.24,0.33,445,17043,70,NULL,NULL,'2MASX J08384280+1220180',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,129.678458333,12.33842,0.129,NULL,63838493707,997476464,15585569,17.7),(55851,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55851,38.24,0.33,445,17044,70,NULL,NULL,'2MASX J08384390+1223060',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,129.682833,12.38494,0.133,NULL,63838498928,997476545,15585571,17.4),(55852,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55852,36.55,0.46,204,17045,70,NULL,NULL,'2MASX J08384573+2514112',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000107,NULL,'16.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,129.690541667,25.23647,0.085,NULL,64316668038,1004947938,15702311,16.1),(55853,'Tully est','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55853,31.01,0.8,15.9,17046,75,NULL,NULL,'ESO 036- G 006',NULL,'1988NBGC.C....0000T',1988,1,3.2,NULL,'G',0.000007,NULL,'14.16',1.4,'SAB(rs)m',NULL,NULL,NULL,NULL,1,129.6962083,-75.1565,0.589,NULL,39931418834,623928419,9748881,14.16),(55854,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55854,37.73,0.13,352,17047,70,NULL,NULL,'2MASX J08384732+2846192',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000171,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,129.6970417,28.77203,0.069,NULL,64320204934,1005003202,15703175,18),(55855,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55855,36.43,0.46,193,17048,70,NULL,NULL,'2MASX J08384806+2922112',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000158,NULL,'16.3g',0.32,'E',NULL,NULL,NULL,NULL,1,129.700375,29.36989,0.121,NULL,64312672984,1004885515,15701336,16.3),(55856,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55856,36.47,0.46,197,17049,70,NULL,NULL,'2MASX J08384927+0939095',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,129.70525,9.65267,0.201,NULL,63668452195,994819565,15544055,16.9),(55857,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55857,37.86,0.46,374,17050,70,NULL,NULL,'2MASX J08384925+2639132',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00017,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,129.705375,26.65367,0.069,NULL,64321476530,1005023070,15703485,18.1),(55858,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55858,38.17,0.46,430,17051,70,NULL,NULL,'2MASX J08385000+2855172',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000167,NULL,'16.6g',0.32,'E',NULL,NULL,NULL,NULL,1,129.7085,28.92128,0.133,NULL,64312614843,1004884606,15701321,16.6),(55859,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55859,38.04,0.46,406,17052,70,NULL,NULL,'2MASX J08385123+0338540',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000138,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,129.7135,3.64844,0.077,NULL,62606461742,978225964,15284780,17.8),(55860,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55860,37.08,0.46,261,17053,70,NULL,NULL,'2MASX J08385230+0826135',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00019,NULL,'16.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,129.717875,8.43722,0.137,NULL,63659875306,994685551,15541961,16.4),(55861,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55861,34.8,0.54,91.2,17054,70,NULL,NULL,'2MASX J08385312-2033596',NULL,'2014MNRAS.445.2677S',2014,1,0.15,NULL,'G',0.00015,NULL,'15.67',NULL,'E?',NULL,NULL,NULL,NULL,1,129.7212083,-20.56647,0.349,NULL,42236354743,659943042,10311610,15.67),(55862,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55862,37.25,0.46,282,17055,70,NULL,NULL,'2MASX J08385474+3144499',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000184,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,129.728125,31.74719,0.105,NULL,64311358794,1004864981,15701015,16.9),(55863,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55863,37.45,0.46,310,17056,70,NULL,NULL,'SDSS J083855.03+372022.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,129.729333,37.33956,0.113,NULL,64373483379,1005835677,15716182,18),(55864,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55864,37.57,0.23,327,17057,70,NULL,NULL,'SDSS J083855.60+263953.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000142,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,129.731667,26.66481,0.069,NULL,64321475611,1005023056,15703485,18.6),(55865,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55865,37.9,0.46,381,17058,70,NULL,NULL,'SDSS J083857.66+101938.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,129.74025,10.32747,0.149,NULL,63668178693,994815292,15543988,18),(55866,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55866,34.97,0.46,98.5,17059,70,NULL,NULL,'UGC 04513',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.00017,NULL,'14.5g',0.86,'COMPACT',NULL,NULL,NULL,NULL,1,129.752833333,40.34611,0.117,NULL,64246303738,1003848495,15685132,14.5),(55867,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55867,35.29,0.49,114,17060,70,NULL,NULL,'2MASX J08390129-0157139',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,129.755375,-1.95394,0.061,NULL,39252803952,613325061,9583204,14.6),(55868,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55868,37.55,0.46,324,17061,70,NULL,NULL,'2MASXi J0839023+471453',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000075,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,129.7597083,47.24806,0.141,NULL,64282097825,1004407778,15693871,17.9),(55869,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55869,37.73,0.13,352,17062,70,NULL,NULL,'2MASX J08390266+2849149',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00011,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,129.760916667,28.82089,0.141,NULL,64320235029,1005003672,15703182,17.6),(55870,'IRAS','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55870,33.86,0.8,59.3,17063,75,NULL,'MAT, I','MCG -02-22-025',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000023,NULL,'15',0.6,'SA(s)c:',NULL,NULL,NULL,NULL,1,129.76925,-14.73986,0.277,NULL,42394721620,662417525,10350273,15),(55871,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55871,32.02,0.32,25.4,17063,85,NULL,'I, raw','MCG -02-22-025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55872,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55872,32.07,0.32,25.9,17063,85,NULL,'I, inv','MCG -02-22-025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55873,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55873,32.43,0.43,30.6,17063,75,NULL,'MAT, I, raw','MCG -02-22-025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55874,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55874,32.62,0.43,33.4,17063,75,NULL,'MAT, I, cor','MCG -02-22-025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55875,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55875,32.63,0.43,33.6,17063,75,NULL,'MAT, I, inv','MCG -02-22-025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55876,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55876,35.6,0.61,132,17064,70,NULL,NULL,'CGCG 004-100 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.4I',0.7,NULL,NULL,NULL,NULL,NULL,1,129.770125,-2.28019,0.057,NULL,39252800748,613325011,9583203,13.4),(55877,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55877,37.6,0.46,331,17065,70,NULL,NULL,'2MASX J08390602+2839429',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000176,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,129.774917,28.66192,0.141,NULL,64320227151,1005003549,15703180,16.9),(55878,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55878,37.85,0.46,371,17066,70,NULL,NULL,'2MASX J08390777+3158599',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000136,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,129.7822917,31.98333,0.117,NULL,64311516227,1004867441,15701053,18.1),(55879,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55879,37.77,0.46,358,17067,70,NULL,NULL,'2MASX J08390809+5050154',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000099,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,129.783667,50.8375,0.109,NULL,63494869970,992107343,15501677,17),(55880,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55880,37.52,0.46,319,17068,70,NULL,NULL,'2MASX J08390892+2657049',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,129.787167,26.95144,0.065,NULL,64321387686,1005021682,15703463,18.2),(55881,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55881,36.3,0.51,182,17069,70,NULL,NULL,'2MASX J08390926-0133417',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.26',0.3,NULL,NULL,NULL,NULL,NULL,1,129.788667,-1.56164,0.061,NULL,39197353369,612458646,9569666,16.26),(55882,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55882,37.35,0.46,295,17070,70,NULL,NULL,'SDSS J083909.31+605511.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,129.7887917,60.91994,0.121,NULL,62065621918,969775342,15152739,18.2),(55883,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55883,38.11,0.21,418,17071,70,NULL,NULL,'2MASX J08391007+2555469',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,129.792083,25.92983,0.085,NULL,64316581780,1004946590,15702290,17.9),(55884,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55884,36.75,0.46,224,17072,70,NULL,NULL,'2MASX J08391026+3703167',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,129.792625,37.05469,0.125,NULL,64373499206,1005835925,15716186,17.3),(55885,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55885,37.73,0.13,352,17073,70,NULL,NULL,'SDSS J083910.72+285102.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,129.794667,28.85067,0.133,NULL,64320234460,1005003663,15703182,18.3),(55886,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55886,36.24,0.69,177,17074,70,NULL,NULL,'2MASX J08391087-1012050',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,129.795291667,-10.20147,0.125,NULL,42175148839,658986700,10296667,15.8),(55887,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55887,35.48,0.46,125,17075,70,NULL,NULL,'CGCG 120-017',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000093,NULL,'15.0g',0.56,NULL,NULL,NULL,NULL,NULL,1,129.795875,26.22064,0.085,NULL,64321561790,1005024402,15703506,15),(55888,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55888,38.11,0.21,418,17076,70,NULL,NULL,'2MASX J08391274+2553489',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,129.803083,25.89692,0.085,NULL,64316583786,1004946621,15702290,17.3),(55889,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55889,37.49,0.46,315,17077,70,NULL,NULL,'2MASX J08391302+1228295',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000144,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,129.8042083,12.47494,0.133,NULL,63838537721,997477151,15585580,17.7),(55890,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55890,36.54,0.46,204,17078,70,NULL,NULL,'2MASX J08391378+2704329',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00017,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,129.807333,27.07572,0.065,NULL,64323434782,1005053668,15703963,16.6),(55891,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55891,38.1,0.46,418,17079,70,NULL,NULL,'2MASX J08391424+5847368',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,129.8092083,58.79361,0.173,NULL,62017826765,969028543,15141070,17.7),(55892,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55892,37.73,0.13,352,17080,70,NULL,NULL,'2MASX J08391468+2850109',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00009,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,129.8112083,28.83639,0.141,NULL,64320234138,1005003658,15703182,17.7),(55893,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55893,37.02,0.33,254,17081,70,NULL,NULL,'2MASX J08391535+5306584',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000081,NULL,'16.2g',0.36,'E0',NULL,NULL,NULL,NULL,1,129.8139583,53.11617,0.109,NULL,63500215958,992190874,15502982,16.2),(55894,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55894,37.73,0.13,352,17082,70,NULL,NULL,'B2 0836+29',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.00009,NULL,'15.3g',0.64,'cD;BrClG       WLRG',NULL,NULL,'radio jet','Flat-Spectrum Radio Source',1,129.8159583,28.84411,0.133,NULL,64320234234,1005003659,15703182,15.3),(55895,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55895,37.73,0.13,352,17083,70,NULL,NULL,'2MASX J08391621+2857469',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,129.817417,28.96308,0.133,NULL,64312630803,1004884856,15701325,17.8),(55896,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55896,37.42,0.46,305,17084,70,NULL,NULL,'2MASX J08391879+1332515',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,129.828375,13.54761,0.157,NULL,63852743922,997699123,15589048,17.6),(55897,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55897,36.58,0.58,207,17085,70,NULL,NULL,'2MASX J08392146-0123107',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.72',0.3,NULL,NULL,NULL,NULL,NULL,1,129.839416667,-1.38644,0.061,NULL,39199451392,612491428,9570178,16.72),(55898,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55898,36.17,0.72,171,17086,70,NULL,NULL,'2MASX J08392150-2337174',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,'S',NULL,NULL,NULL,NULL,1,129.839583,-23.62144,NULL,NULL,42242623839,660040997,10313140,15.6),(55899,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55899,38.22,0.46,441,17087,70,NULL,NULL,'2MASX J08392335+3358127',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000137,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,129.847333,33.97031,0.121,NULL,64362607338,1005665739,15713527,17.6),(55900,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55900,36.67,0.46,216,17088,70,NULL,NULL,'2MASX J08392342+6002243',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,129.847917,60.04022,0.125,NULL,62066645902,969791342,15152989,17.2),(55901,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55901,36.49,0.46,199,17089,70,NULL,NULL,'2MASX J08392391+2951379',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000156,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,129.849583,29.86067,0.129,NULL,64315291202,1004926425,15701975,17.1),(55902,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55902,37.58,0.33,328,17090,70,NULL,NULL,'2MASX J08392492+3040231',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,129.85375,30.67331,0.113,NULL,64315078552,1004923102,15701923,18.2),(55903,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55903,36.43,0.46,193,17091,70,NULL,NULL,'2MASX J08392600+5141154',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000109,NULL,'15.5g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,129.85825,51.68756,0.093,NULL,63499641004,992181890,15502842,15.5),(55904,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55904,37.45,0.46,309,17092,70,NULL,NULL,'2MASX J08392719+5415487',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00008,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,129.863167,54.26347,0.093,NULL,63486916504,991983070,15499735,16.9),(55905,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55905,38.22,0.46,440,17093,70,NULL,NULL,'2MASX J08392741+5050014',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000078,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,129.864416667,50.83372,0.109,NULL,63495344990,992114765,15501793,17.9),(55906,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55906,35.97,0.46,156,17094,70,NULL,NULL,'CGCG 263-065',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000101,NULL,'15.3g',0.54,'E0',NULL,NULL,NULL,NULL,1,129.8682083,52.25106,0.085,NULL,63499115717,992173683,15502713,15.3),(55907,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55907,35.84,0.53,148,17095,70,NULL,NULL,'2MASX J08392916-1745492',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,129.8715417,-17.76367,0.285,NULL,42384042190,662250659,10347666,14.9),(55908,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55908,38.13,0.46,423,17096,70,NULL,NULL,'SDSS J083930.05+050044.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,129.8752083,5.01233,0.061,NULL,62607704412,978245381,15285084,18.2),(55909,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55909,37.58,0.33,328,17097,70,NULL,NULL,'2MASX J08393010+3045182',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000151,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,129.875625,30.75508,0.113,NULL,64315067962,1004922936,15701920,17.3),(55910,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55910,37.84,0.46,370,17098,70,NULL,NULL,'2MASX J08393066+6040223',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,129.877958333,60.67281,0.113,NULL,62065733202,969777081,15152766,17.7),(55911,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55911,37.73,0.13,352,17099,70,NULL,NULL,'2MASX J08393148+2909145',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000187,NULL,'16.7g',0.3,'E',NULL,NULL,NULL,NULL,1,129.8809583,29.15392,0.125,NULL,64312599338,1004884364,15701318,16.7),(55912,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55912,37.73,0.13,352,17100,70,NULL,NULL,'2MASX J08393243+2841275',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000149,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,129.885208333,28.69106,0.141,NULL,64320233424,1005003647,15703181,17),(55913,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55913,37.15,0.46,269,17101,70,NULL,NULL,'2MASX J08393371+1418422',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000147,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,129.8905,14.31167,0.113,NULL,63853258572,997707165,15589174,17),(55914,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55914,37.77,0.46,357,17102,70,NULL,NULL,'SDSS J083933.94+215213.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,129.891416667,21.87036,0.101,NULL,63798002830,996843794,15575684,18.7),(55915,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55915,37.96,0.46,390,17103,70,NULL,NULL,'2MASX J08393442+2359055',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000142,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,129.893333,23.98489,0.077,NULL,63802092733,996907698,15576682,17.7),(55916,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55916,34.88,0.53,94.6,17104,NULL,NULL,'Malmquist cor.','ESO 090- G 005',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'12.89',0.3,'S...',NULL,NULL,NULL,NULL,1,129.895375,-63.12936,0.773,NULL,40557966337,633718224,9901847,12.89),(55917,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55917,35.07,0.49,103,17104,NULL,NULL,NULL,'ESO 090- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55918,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55918,35.11,0.2,105,17104,74.4,NULL,NULL,'ESO 090- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55919,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55919,38.11,0.21,418,17105,70,NULL,NULL,'2MASX J08393537+2554375',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000174,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,129.897417,25.91047,0.085,NULL,64320835867,1005013060,15703329,18),(55920,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55920,37.73,0.13,352,17106,70,NULL,NULL,'2MASX J08393714+2848355',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,129.904875,28.80975,0.141,NULL,64320189048,1005002953,15703171,17.5),(55921,'IRAS','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55921,30.67,0.8,13.6,17107,75,NULL,'A82, H','UGC 04514',NULL,'1997ApJS..109..333W',1997,1,1.46,'MCG misprints dec as +53d57.m.','G',0.000003,NULL,'14.1g',0.71,'SBcd?          HII','Group member',NULL,NULL,NULL,1,129.907083,53.4565,0.097,NULL,63486517899,991976842,15499638,14.1),(55922,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55922,30.56,0.4,13,17107,75,NULL,'B','UGC 04514',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55923,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55923,30.94,0.4,15.4,17107,NULL,NULL,'Virgo cluster at 15.6 Mpc','UGC 04514',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55924,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55924,31.11,0.38,16.7,17107,NULL,NULL,NULL,'UGC 04514',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55925,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55925,31.11,0.39,16.7,17107,73,NULL,'opt','UGC 04514',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55926,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55926,31.11,0.43,16.7,17107,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04514',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55927,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55927,31.16,0.43,17,17107,75,NULL,'3.6 micron, color corrected','UGC 04514',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55928,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55928,31.24,0.2,17.7,17107,74.4,NULL,NULL,'UGC 04514',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55929,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55929,31.28,0.47,18,17107,75,NULL,'A82, H, inv','UGC 04514',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55930,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55930,31.46,0.47,19.6,17107,75,NULL,'A82, H, raw','UGC 04514',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55931,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55931,31.65,0.49,21.4,17107,NULL,NULL,NULL,'UGC 04514',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55932,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55932,31.67,0.49,21.6,17107,NULL,NULL,'Malmquist cor.','UGC 04514',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55933,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55933,31.73,0.47,22.2,17107,75,NULL,'A82, H, cor','UGC 04514',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55934,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55934,38.11,0.21,418,17108,70,NULL,NULL,'2MASX J08393804+2554125',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,129.908416667,25.90344,0.085,NULL,64320889403,1005013896,15703342,17.1),(55935,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55935,35.22,0.37,111,17109,NULL,NULL,'Malmquist cor.','UGC 04512',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000037,NULL,'15.10',0.6,'Scd:','Isolated galaxy',NULL,NULL,NULL,1,129.916333333,60.96889,0.121,NULL,62065609000,969775140,15152736,15.1),(55936,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55936,35.28,0.35,114,17109,NULL,NULL,NULL,'UGC 04512',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55937,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55937,35.32,0.2,116,17109,74.4,NULL,NULL,'UGC 04512',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55938,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55938,35.99,0.46,158,17110,70,NULL,NULL,'CGCG 263-067',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.00012,NULL,'15.3g',0.48,'E0',NULL,NULL,NULL,NULL,1,129.918333,55.72928,0.165,NULL,61541452877,961585201,15024768,15.3),(55939,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55939,37.43,0.46,307,17111,70,NULL,NULL,'2MASX J08394074+1209191',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000158,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,129.919917,12.15522,0.109,NULL,63654965048,994608828,15540762,17.3),(55940,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55940,37.14,0.46,268,17112,70,NULL,NULL,'SDSS J083941.38+181740.2',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000165,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,129.922417,18.29453,0.061,NULL,63774574887,996477732,15569964,17),(55941,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55941,37.44,0.46,307,17113,70,NULL,NULL,'SDSS J083942.39+283457.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,129.926625,28.58267,0.117,NULL,64323086052,1005048219,15703878,18.5),(55942,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55942,37.39,0.46,300,17114,70,NULL,NULL,'2MASXi J0839430-002012',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.9g',0.26,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,129.929333,-0.33697,0.089,NULL,39196646414,612447600,9569493,16.9),(55943,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55943,37.04,0.46,256,17115,70,NULL,NULL,'2MASX J08394313+3139312',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000183,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,129.929958333,31.65883,0.105,NULL,64312131949,1004877061,15701204,16.8),(55944,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55944,37.74,0.46,353,17116,70,NULL,NULL,'SDSS J083944.30+024901.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,129.934625,2.81711,0.093,NULL,62601075389,978141802,15283465,18.1),(55945,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55945,36.53,0.46,202,17117,70,NULL,NULL,'2MASX J08394459+3613421',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000158,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,129.9359583,36.22844,0.117,NULL,64362968405,1005671381,15713615,16.7),(55946,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55946,32.8,0.57,36.3,17118,70,NULL,NULL,'ESO 496- G 003',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000067,NULL,'15',1.1,'S0',NULL,NULL,NULL,NULL,1,129.9385,-23.45878,0.169,NULL,42244617971,660072155,10313627,15),(55947,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55947,36.8,0.46,230,17119,70,NULL,NULL,'2MASX J08394620+1448141',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000136,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,129.942625,14.80389,0.089,NULL,63851596760,997681199,15588768,17.5),(55948,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55948,38.64,0.46,534,17120,70,NULL,NULL,'2MASX J08394658+3347492',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000171,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,129.944083333,33.79714,0.125,NULL,64362562533,1005665039,15713516,18.1),(55949,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55949,34.39,0.56,75.4,17121,70,NULL,NULL,'2MASX J08394681-6550139',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00011,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,129.945083,-65.83728,0.505,NULL,40779293738,637176464,9955882,15.8),(55950,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55950,36.17,0.54,171,17122,70,NULL,NULL,'2MASX J08394697-1903554',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,129.9457083,-19.06542,0.325,NULL,42262030550,660344227,10317878,15.2),(55951,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55951,37.71,0.46,349,17123,70,NULL,NULL,'2MASX J08394772+2636015',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,129.948917,26.60028,0.069,NULL,64321389160,1005021705,15703464,17),(55952,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55952,38.11,0.46,419,17124,70,NULL,NULL,'2MASX J08394777+5807378',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,129.949375,58.12728,0.205,NULL,62020676825,969073075,15141766,17.8),(55953,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55953,37.49,0.46,315,17125,70,NULL,NULL,'2MASX J08394886+4858294',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000071,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,129.953583,48.97481,0.133,NULL,64227963150,1003561924,15680655,17.7),(55954,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55954,37.11,0.33,265,17126,70,NULL,NULL,'2MASX J08394887+3316502',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000191,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,129.95375,33.2805,0.129,NULL,64361831710,1005653620,15713337,16.9),(55955,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55955,37.11,0.33,265,17127,70,NULL,NULL,'2MASX J08395031+3317232',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000068,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,129.959417,33.28989,0.121,NULL,64361828925,1005653576,15713337,17.4),(55956,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55956,37.77,0.46,359,17128,70,NULL,NULL,'2MASX J08395081+3041462',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000151,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,129.961708333,30.69628,0.109,NULL,64315199269,1004924988,15701952,17.5),(55957,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55957,36.79,0.46,228,17129,70,NULL,NULL,'2MASX J08395183+3000152',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,129.9660417,30.00439,0.129,NULL,64315401477,1004928148,15702002,17.2),(55958,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55958,37.33,0.33,293,17130,70,NULL,NULL,'2MASX J08395269+1045124',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'17.11',0.32,NULL,NULL,NULL,NULL,NULL,1,129.969583,10.75358,0.165,NULL,63666670491,994791726,15543620,17.11),(55959,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55959,37.41,0.46,303,17131,70,NULL,NULL,'2MASX J08395415+4055420',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000148,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,129.97575,40.9285,0.121,NULL,64246395857,1003849935,15685155,17.4),(55960,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55960,33.21,0.2,43.9,17132,74.4,NULL,NULL,'UGC 04502',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.000037,NULL,'15.44',0.3,'SBcd:',NULL,NULL,NULL,NULL,1,129.979875,73.75453,0.025,NULL,61287944850,957624138,14962877,15.44),(55961,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55961,33.32,0.57,46.2,17132,NULL,NULL,NULL,'UGC 04502',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55962,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55962,33.6,0.5,52.4,17132,NULL,NULL,'Malmquist cor.','UGC 04502',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55963,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55963,37.87,0.46,376,17133,70,NULL,NULL,'2MASX J08395601+3009442',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,129.9832917,30.16236,0.121,NULL,64315456187,1004929002,15702015,18),(55964,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55964,36.72,0.46,220,17134,70,NULL,NULL,'2MASX J08395649+3440543',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000145,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,129.9852083,34.68175,0.113,NULL,64365458075,1005710282,15714223,17.6),(55965,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55965,34.96,0.52,98.1,17135,70,NULL,NULL,'CGCG 004-103',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.6',0.5,NULL,NULL,NULL,NULL,NULL,1,129.985417,-2.77664,0.085,NULL,39196859113,612450923,9569545,15.6),(55966,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55966,37.65,0.46,340,17136,70,NULL,NULL,'2MASX J08395982+2800364',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000181,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,129.999375,28.01006,0.121,NULL,64323155662,1005049307,15703895,17.2),(55967,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55967,36.97,0.33,248,17137,70,NULL,NULL,'2MASX J08400131+0341264',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000073,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,130.005458333,3.69069,0.077,NULL,62606406954,978225108,15284767,16.6),(55968,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55968,37.36,0.27,296,17138,70,NULL,NULL,'2MASX J08400225+5148365',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000066,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,130.0095,51.81017,0.093,NULL,63499631417,992181740,15502839,17.8),(55969,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55969,37.62,0.46,334,17139,70,NULL,NULL,'2MASX J08400284+0323524',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,130.0117917,3.398,0.081,NULL,62606309703,978223589,15284743,17.5),(55970,'SNIa','2016-12-15 15:14:23','2016-12-16 11:19:29','1','PS1 SN PS10bzp','N',55970,42.27,0.29,1850,17140,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10bzp HOST',0.5406,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55971,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55971,38.47,0.33,494,17141,70,NULL,NULL,'2MASX J08400414+3215303',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000135,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,130.017166667,32.25839,0.109,NULL,64311311114,1004864236,15701003,17.3),(55972,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55972,36.61,0.33,210,17142,70,NULL,NULL,'2MASX J08400491+2459277',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000175,NULL,'17.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,130.020333,24.99111,0.065,NULL,63793319082,996770610,15574540,17.4),(55973,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55973,37.38,0.46,299,17143,70,NULL,NULL,'2MASX J08400494+2527117',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,130.020583333,25.45325,0.085,NULL,64316538123,1004945908,15702279,17.7),(55974,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55974,37.08,0.46,261,17144,70,NULL,NULL,'2MASX J08400806+1129222',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000188,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,130.033625,11.48956,0.105,NULL,63655445103,994616329,15540880,16.2),(55975,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55975,37.41,0.33,303,17145,70,NULL,NULL,'2MASX J08400914+0859562',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,130.0382083,8.99906,0.209,NULL,63659825556,994684774,15541949,17.4),(55976,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55976,34.29,0.37,72.3,17146,NULL,NULL,'Malmquist cor.','UGC 04515',NULL,'2009ApJS..182..474S',2009,1,1.53,NULL,'G',0.000023,NULL,'14.3g',0.6,'SB(r)b:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,130.039417,52.45606,0.097,NULL,63498931697,992170807,15502668,14.3),(55977,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55977,34.3,0.36,72.5,17146,NULL,NULL,NULL,'UGC 04515',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55978,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55978,34.31,0.4,72.9,17146,NULL,NULL,'mean','UGC 04515',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55979,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55979,34.36,0.2,74.5,17146,74.4,NULL,NULL,'UGC 04515',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55980,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55980,34.57,0.47,81.9,17146,NULL,NULL,'H','UGC 04515',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55981,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55981,34.6,0.46,83,17146,NULL,NULL,'J','UGC 04515',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55982,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55982,34.67,0.45,85.7,17146,NULL,NULL,'K','UGC 04515',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55983,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55983,37.41,0.33,303,17147,70,NULL,NULL,'2MASX J08400981+0900052',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000203,NULL,'16.2g',0.4,'E0',NULL,NULL,NULL,NULL,1,130.041,9.00144,0.209,NULL,63659825593,994684774,15541949,16.2),(55984,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55984,36.61,0.33,210,17148,70,NULL,NULL,'2MASX J08401094+2503397',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,130.0455417,25.06119,0.081,NULL,63793325450,996770710,15574542,17.2),(55985,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55985,37.33,0.33,293,17149,70,NULL,NULL,'2MASX J08401235+1041342',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,130.0514583,10.69283,0.165,NULL,63668702969,994823483,15544116,17.1),(55986,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55986,36.16,0.46,171,17150,70,NULL,NULL,'2MASX J08401279+0810442',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000154,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,130.0534583,8.179,0.233,NULL,63660549386,994696084,15542126,16.6),(55987,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55987,36.87,0.46,237,17151,70,NULL,NULL,'2MASX J08401319+1538448',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000173,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,130.055083,15.64589,0.097,NULL,63847049121,997610142,15587658,16.8),(55988,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55988,32.57,0.43,32.6,17152,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04524',NULL,'2014MNRAS.444..527S',2014,1,1.68,'Multiple SDSS entries describe this object.','G',0.000006,NULL,'15.17',0.18,'Sdm','Isolated galaxy',NULL,NULL,NULL,1,130.0597917,5.6345,0.093,NULL,62605227562,978206680,15284479,15.17),(55989,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55989,32.6,NULL,33.1,17152,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04524',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55990,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55990,32.62,NULL,33.4,17152,NULL,NULL,'Dipole + Quadrupole','UGC 04524',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55991,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55991,32.62,NULL,33.5,17152,NULL,NULL,'Dipole','UGC 04524',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55992,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55992,32.65,0.43,33.8,17152,75,NULL,'3.6 micron, color corrected','UGC 04524',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55993,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55993,32.67,0.2,34.2,17152,74.4,NULL,NULL,'UGC 04524',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55994,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55994,32.68,NULL,34.4,17152,NULL,NULL,NULL,'UGC 04524',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55995,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55995,32.87,0.65,37.4,17152,NULL,NULL,NULL,'UGC 04524',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55996,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55996,33.11,0.58,41.8,17152,NULL,NULL,'Malmquist cor.','UGC 04524',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(55997,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,55997,36.8,0.53,229,17153,70,NULL,NULL,'2MASX J08401468-0227109',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.57',0.5,NULL,NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,130.0612083,-2.45319,0.077,NULL,39197000093,612453126,9569580,16.57),(55998,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55998,37.36,0.27,296,17154,70,NULL,NULL,'2MASX J08401499+5153035',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000079,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,130.0624583,51.88428,0.073,NULL,63499619688,992181557,15502836,18.1),(55999,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',55999,37.55,0.46,323,17155,70,NULL,NULL,'2MASX J08401510+2925177',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000183,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,130.062917,29.4215,0.121,NULL,64314655098,1004916485,15701820,17.4),(56000,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56000,36.58,0.46,207,17156,70,NULL,NULL,'2MASX J08401513+1153312',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000193,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,130.063041667,11.89208,0.133,NULL,63655035031,994609922,15540780,17.5),(56001,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,56001,36.03,0.54,161,17157,70,NULL,NULL,'2MASX J08401586-1839430',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.24',NULL,NULL,NULL,NULL,NULL,NULL,1,130.066,-18.66206,0.325,NULL,42253463783,660210371,10315787,16.24),(56002,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56002,37.73,0.13,352,17158,70,NULL,NULL,'2MASX J08401648+2849137',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000087,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,130.068666667,28.82058,0.141,NULL,64323061424,1005047834,15703872,18.1),(56003,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56003,38.32,0.46,462,17159,70,NULL,NULL,'2MASX J08401807+2601367',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000172,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,130.075375,26.02678,0.085,NULL,64320870060,1005013594,15703337,17.4),(56004,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56004,37.36,0.27,296,17160,70,NULL,NULL,'2MASX J08401833+5152285',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00008,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,130.0765417,51.87456,0.073,NULL,63499619742,992181558,15502836,17.4),(56005,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56005,37.67,0.46,341,17161,70,NULL,NULL,'2MASX J08402005+2352380',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000176,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,130.0835,23.87733,0.065,NULL,63802002621,996906290,15576660,17.4),(56006,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56006,37.6,0.46,332,17162,70,NULL,NULL,'2MASX J08402065+2800447',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000177,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,130.086,28.01236,0.121,NULL,64323145587,1005049149,15703892,16.7),(56007,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56007,38.47,0.33,494,17163,70,NULL,NULL,'SDSS J084020.80+321755.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000188,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,130.086667,32.29867,0.109,NULL,64382596347,1005978067,15718407,18.8),(56008,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56008,36.75,0.46,224,17164,70,NULL,NULL,'2MASX J08402155+3351563',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000142,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,130.0897917,33.86575,0.125,NULL,64362541520,1005664711,15713511,16.5),(56009,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56009,37.65,0.46,339,17165,70,NULL,NULL,'2MASX J08402261+4129484',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,130.0940417,41.49686,0.093,NULL,64255066078,1003985407,15687271,17),(56010,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56010,37.31,0.46,290,17166,70,NULL,NULL,'SDSS J084022.60+293728.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000153,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,130.0942083,29.62467,0.121,NULL,64314616132,1004915877,15701810,18.3),(56011,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56011,32.98,NULL,39.4,17167,NULL,NULL,NULL,'AGC 182493',NULL,'2015AstBu..70....1K',2015,1,NULL,NULL,'RadioS',0.000157,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,130.097083,7.88972,0.241,NULL,63660620555,994697196,15542143,NULL),(56012,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56012,37.38,0.46,299,17168,70,NULL,NULL,'2MASX J08402357+0833422',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,130.098333,8.56186,0.217,NULL,63659720030,994683125,15541923,18.2),(56013,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56013,36.93,0.46,243,17169,70,NULL,NULL,'2MASX J08402588+6017175',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,130.108083,60.28819,0.121,NULL,62066778415,969793412,15153022,17.5),(56014,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56014,37.16,0.46,270,17170,70,NULL,NULL,'2MASX J08402815+3101093',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00019,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,130.1172083,31.01931,0.109,NULL,64311956416,1004874319,15701161,16.8),(56015,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56015,38.12,0.46,421,17171,70,NULL,NULL,'2MASX J08402826+4118343',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,130.117666667,41.30953,0.129,NULL,64246850549,1003857039,15685266,17.8),(56016,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56016,37.63,0.46,336,17172,70,NULL,NULL,'2MASXi J0840285+253942',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,130.118916667,25.66197,0.085,NULL,64320917373,1005014333,15703348,18),(56017,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56017,36.07,0.46,163,17173,70,NULL,NULL,'2MASX J08402890+5536001',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00009,NULL,'16.6g',0.21,'NLAGN',NULL,NULL,NULL,NULL,1,130.120333,55.60008,0.109,NULL,61541490540,961585789,15024777,16.6),(56018,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56018,38.77,0.46,567,17174,70,NULL,NULL,'SDSS J084029.32+194422.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000162,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,130.1222083,19.73953,0.069,NULL,63796271240,996816738,15575261,18.4),(56019,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,56019,34.13,0.54,67,17175,70,NULL,NULL,'2MASX J08403053-6111586',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000107,NULL,'15.4b',NULL,'(R_1)SB(l)0^+',NULL,NULL,NULL,NULL,1,130.127083,-61.19958,0.785,NULL,40561119768,633767496,9902617,15.4),(56020,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56020,37.79,0.46,362,17176,70,NULL,NULL,'2MASX J08403134+3436413',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000141,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,130.1305417,34.6115,0.109,NULL,64365425052,1005709766,15714215,17.3),(56021,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56021,38.98,0.46,625,17177,70,NULL,NULL,'SDSS J084032.08+362204.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00016,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,130.133667,36.36781,0.101,NULL,64362941450,1005670960,15713608,18.7),(56022,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56022,37.6,0.46,330,17178,70,NULL,NULL,'2MASX J08403287+1735447',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,130.1370417,17.59583,0.057,NULL,63846125090,997595704,15587432,17.7),(56023,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56023,36.66,0.46,214,17179,70,NULL,NULL,'2MASX J08403351+5546231',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000098,NULL,'16.2g',0.26,'NLAGN',NULL,NULL,NULL,NULL,1,130.139875,55.77308,0.113,NULL,61541983665,961593494,15024898,16.2),(56024,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56024,36.61,0.33,210,17180,70,NULL,NULL,'IC 0519',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000167,NULL,'15.0g',0.69,'E0',NULL,NULL,NULL,NULL,1,130.143375,2.61133,0.101,NULL,62556195176,977440549,15272508,15),(56025,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56025,37.61,0.16,333,17181,70,NULL,NULL,'2MASX J08403573+2639480',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00018,NULL,'16.8g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,130.1489583,26.66331,0.069,NULL,64321516538,1005023695,15703495,16.8),(56026,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56026,37.54,0.46,323,17182,70,NULL,NULL,'2MASX J08403595+2721490',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000188,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,130.149916667,27.36367,0.065,NULL,64323713142,1005058017,15704031,17.1),(56027,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56027,38.21,0.46,438,17183,70,NULL,NULL,'2MASX J08403619+2752350',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000197,NULL,'16.8g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,130.150833,27.87656,0.093,NULL,64323798337,1005059349,15704052,16.8),(56028,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56028,36.79,0.33,228,17184,70,NULL,NULL,'UGC 04520 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000209,NULL,'15.9g',0.35,'AGN',NULL,NULL,NULL,NULL,1,130.1517083,36.90486,0.105,NULL,64370659889,1005791560,15715493,15.9),(56029,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56029,37.09,0.46,262,17185,70,NULL,NULL,'2MASX J08403718+3039433',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,130.1550417,30.66192,0.117,NULL,64314749764,1004917965,15701843,17),(56030,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56030,37.73,0.13,352,17186,70,NULL,NULL,'SDSS J084037.37+283122.6',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00019,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,130.1557083,28.52297,0.117,NULL,64323110574,1005048602,15703884,17.2),(56031,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56031,36.61,0.33,210,17187,70,NULL,NULL,'SDSS J084037.80+023710.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000179,NULL,'17.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,130.157541667,2.61967,0.101,NULL,62556165834,977440091,15272501,17.2),(56032,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56032,36.79,0.33,228,17188,70,NULL,NULL,'2MASX J08403792+3644351',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,130.158167,36.74311,0.097,NULL,64370756478,1005793069,15715516,17.2),(56033,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56033,36.62,0.46,211,17189,70,NULL,NULL,'CGCG 150-015',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000208,NULL,'15.5g',0.55,'E0',NULL,NULL,NULL,NULL,1,130.159417,30.16872,0.133,NULL,64315419806,1004928434,15702006,15.5),(56034,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56034,37.73,0.13,352,17190,70,NULL,NULL,'2MASX J08403839+2827130',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,130.160417,28.45022,0.117,NULL,64323101602,1005048462,15703882,18.1),(56035,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56035,37.14,0.46,268,17191,70,NULL,NULL,'2MASX J08403880+2958053',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,130.161667,29.96817,0.133,NULL,64315370541,1004927664,15701994,17.4),(56036,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56036,37.47,0.46,311,17192,70,NULL,NULL,'2MASX J08403982+0527192',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000183,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,130.165875,5.45533,0.073,NULL,62605075690,978204307,15284442,16.3),(56037,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56037,37.85,0.46,371,17193,70,NULL,NULL,'2MASX J08403977+2901060',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000147,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,130.165917,29.01842,0.133,NULL,64313897999,1004904656,15701635,17.9),(56038,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56038,38.22,0.46,441,17194,70,NULL,NULL,'2MASX J08404053+5159370',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000084,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,130.168583,51.99372,0.073,NULL,63499046136,992172595,15502696,18),(56039,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56039,37.73,0.46,351,17195,70,NULL,NULL,'2MASX J08404149+2736170',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000142,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,130.17275,27.60467,0.089,NULL,64323836667,1005059947,15704061,18.1),(56040,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56040,38.37,0.46,472,17196,70,NULL,NULL,'SDSS J084041.53+234503.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,130.173083,23.75097,0.069,NULL,63802040605,996906884,15576670,18.3),(56041,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56041,37.56,0.46,325,17197,70,NULL,NULL,'2MASX J08404179+4304378',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,'FoF','16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,130.174125,43.07703,0.153,NULL,64253392195,1003959253,15686863,16.5),(56042,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56042,37.61,0.16,333,17198,70,NULL,NULL,'SDSS J084042.62+263843.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000161,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,130.177625,26.64547,0.069,NULL,64321509298,1005023582,15703493,17.6),(56043,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56043,37.65,0.33,338,17199,70,NULL,NULL,'2MASX J08404329+0733521',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000163,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,130.180458333,7.56461,0.237,NULL,63657638128,994650595,15541415,16.8),(56044,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56044,36.97,0.33,248,17200,70,NULL,NULL,'2MASX J08404337+0350112',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000167,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,130.180625,3.83639,0.085,NULL,62551294120,977363970,15271312,16.6),(56045,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56045,37.35,0.46,295,17201,70,NULL,NULL,'2MASX J08404395+5736310',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,130.183,57.60872,0.193,NULL,61545519310,961648739,15025761,17.4),(56046,'Ring Diameter','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,56046,32.6,0.84,33,17202,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 2642',NULL,'1981ApJS...45..541P',1981,1,2,NULL,'G',0.000028,NULL,'13.35',1.9,'SB(r)bc        HII',NULL,NULL,NULL,NULL,1,130.184875,-4.12172,0.069,NULL,39247789360,613246708,9581979,13.35),(56047,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56047,36.92,0.46,242,17203,70,NULL,NULL,'2MASX J08404474+3007143',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,130.186208333,30.12061,0.133,NULL,64315416870,1004928388,15702006,17.2),(56048,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56048,38.16,0.46,428,17204,70,NULL,NULL,'2MASX J08404541+4721248',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000069,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,130.1892917,47.35697,0.125,NULL,64282757737,1004418089,15694032,18.1),(56049,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56049,36,0.46,159,17205,70,NULL,NULL,'2MASX J08404629+5702110',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.74',0.26,NULL,NULL,NULL,NULL,NULL,1,130.192917,57.03642,0.185,NULL,61545273302,961644895,15025701,16.74),(56050,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56050,37.53,0.46,320,17206,70,NULL,NULL,'2MASX J08404701+3205083',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000193,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,130.196,32.08575,0.117,NULL,64311413075,1004865829,15701028,16.8),(56051,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56051,37.74,0.46,353,17207,70,NULL,NULL,'2MASX J08404727+1754544',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000194,NULL,'16.8g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,130.197083,17.91528,0.057,NULL,63846666803,997604168,15587565,16.8),(56052,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56052,37.65,0.33,338,17208,70,NULL,NULL,'SDSS J084047.35+073341.0',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,130.1972917,7.56142,0.237,NULL,63657637958,994650593,15541415,17.9),(56053,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56053,39.01,0.46,634,17209,70,NULL,NULL,'SDSS J084047.56+114744.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000174,NULL,'18.2g',0.16,'AGN',NULL,NULL,NULL,NULL,1,130.1982083,11.79561,0.133,NULL,63655013544,994609586,15540774,18.2),(56054,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56054,37.61,0.16,333,17210,70,NULL,NULL,'2MASX J08404871+2649080',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,130.2029583,26.81881,0.069,NULL,64321492758,1005023324,15703489,17.6),(56055,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56055,38.5,0.46,501,17211,70,NULL,NULL,'SDSS J084049.47+304058.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00014,NULL,'18.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,130.206125,30.68283,0.117,NULL,64314746946,1004917921,15701842,18.8),(56056,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56056,38.02,0.46,401,17212,70,NULL,NULL,'2MASX J08405062+1223576',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000136,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,130.210917,12.39944,0.157,NULL,63838400920,997475014,15585547,18.1),(56057,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56057,32.76,0.4,35.7,17213,75,NULL,NULL,'ESO 432- G 002',NULL,'2008Ap.....51..336K',2008,1,2.91,'Visvanathan, et al. (1996,ApJS,107,521) give v = 900 km/sec.','G',0.000017,NULL,'14.0',0.22,'SB(s)c? sp',NULL,NULL,NULL,NULL,1,130.2122917,-32.04647,NULL,NULL,42723293357,667551458,10430491,14),(56058,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56058,32.95,0.49,38.9,17213,75,NULL,'IR','ESO 432- G 002',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56059,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,56059,33.16,NULL,42.8,17213,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 432- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56060,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,56060,33.16,NULL,42.8,17213,NULL,NULL,'Dipole','ESO 432- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56061,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,56061,33.16,NULL,42.9,17213,NULL,NULL,'Dipole + Quadrupole','ESO 432- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56062,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,56062,33.39,0.4,47.7,17213,NULL,NULL,'mean','ESO 432- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56063,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,56063,33.47,0.47,49.5,17213,NULL,NULL,'H','ESO 432- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56064,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,56064,33.57,0.45,51.7,17213,NULL,NULL,'K','ESO 432- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56065,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,56065,33.58,0.46,52.1,17213,NULL,NULL,'J','ESO 432- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56066,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56066,36.72,0.46,221,17214,70,NULL,NULL,'2MASX J08405117+3158532',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000212,NULL,'15.8g',0.38,'E0',NULL,NULL,NULL,NULL,1,130.213083,31.98153,0.117,NULL,64311421650,1004865963,15701030,15.8),(56067,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56067,37.74,0.46,352,17215,70,NULL,NULL,'2MASX J08405270+3953460',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000223,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,130.21975,39.89603,0.129,NULL,64367042389,1005735037,15714609,17.7),(56068,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56068,38.11,0.46,419,17216,70,NULL,NULL,'2MASX J08405275+2651280',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,130.219875,26.85786,0.069,NULL,64321499686,1005023432,15703491,17.8),(56069,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56069,35.47,0.46,124,17217,70,NULL,NULL,'2MASX J08405315+3955210',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000171,NULL,'15.9g',0.39,'S0',NULL,NULL,NULL,NULL,1,130.221583,39.92264,0.129,NULL,64367038787,1005734981,15714609,15.9),(56070,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,56070,34.16,0.4,67.8,17218,NULL,NULL,'mean','UGC 04526',NULL,'2007A&A...465...71T',2007,1,1.36,NULL,'G',0.000033,NULL,'14.7g',0.43,'Sab',NULL,NULL,NULL,NULL,1,130.224083,19.35489,0.061,NULL,63795515673,996804932,15575077,14.7),(56071,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56071,34.26,0.49,71,17218,75,NULL,'IR','UGC 04526',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56072,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,56072,34.46,0.47,78,17218,NULL,NULL,'H','UGC 04526',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56073,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56073,37.02,0.23,253,17219,70,NULL,NULL,'2MASX J08405383+3223462',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000169,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,130.224208333,32.39617,0.113,NULL,64382590513,1005977976,15718405,17),(56074,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56074,37.91,0.46,382,17220,70,NULL,NULL,'SDSS J084055.53+423719.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000151,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,130.231375,42.62225,0.141,NULL,64253229858,1003956716,15686823,18.5),(56075,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,56075,34.15,0.4,67.6,17221,NULL,NULL,'mean','ESO 496- G 004',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000043,NULL,'15',0.4,'Sb:            HII',NULL,NULL,NULL,NULL,1,130.2377917,-23.91353,0.205,NULL,42242701635,660042213,10313159,15),(56076,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,56076,34.62,0.47,84,17221,NULL,NULL,'H','ESO 496- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56077,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,56077,34.7,0.46,87,17221,NULL,NULL,'J','ESO 496- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56078,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,56078,34.71,0.45,87.6,17221,NULL,NULL,'K','ESO 496- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56079,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56079,37.99,0.46,396,17222,70,NULL,NULL,'SDSS J084058.23+363414.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000093,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,130.242667,36.57075,0.101,NULL,64370752719,1005793011,15715515,18.6),(56080,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56080,38.7,0.46,549,17223,70,NULL,NULL,'SDSS J084059.01+375730.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,130.245875,37.95853,0.161,NULL,64373876763,1005841824,15716278,18.2),(56081,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,NULL,56081,36.58,0.55,207,17224,70,NULL,NULL,'2MASX J08405922-7854236',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,130.24725,-78.90658,0.417,NULL,39996365198,624943206,9764737,17.1),(56082,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56082,37.02,0.33,254,17225,70,NULL,NULL,'2MASX J08410057+5301220',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000114,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,130.252375,53.02297,0.109,NULL,63488139759,992002183,15500034,16.6),(56083,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56083,37.57,0.46,326,17226,70,NULL,NULL,'2MASX J08410235+2903390',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000159,NULL,'16.6g',0.29,'Pec',NULL,NULL,NULL,NULL,1,130.25975,29.061,0.133,NULL,64313895269,1004904613,15701634,16.6),(56084,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56084,38.03,0.46,403,17227,70,NULL,NULL,'2MASX J08410374+1748554',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,130.265583,17.81539,0.049,NULL,63846663895,997604123,15587564,18.1),(56085,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56085,38.08,0.23,413,17228,70,NULL,NULL,'2MASX J08410494+0729384',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,130.2704583,7.49389,0.237,NULL,63657657083,994650891,15541420,18),(56086,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56086,38.03,0.46,404,17229,70,NULL,NULL,'2MASX J08410535+1406594',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000172,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,130.272417,14.11642,0.125,NULL,63853152308,997705504,15589148,17.3),(56087,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56087,37.02,0.23,253,17230,70,NULL,NULL,'2MASX J08410621+3225065',NULL,'2015arXiv151105856S',2015,1,0.19,'FIRST source may be a sidelobe of another radio source.','G',0.000148,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,130.275917,32.41856,0.113,NULL,64382615720,1005978370,15718412,18.1),(56088,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56088,37.17,0.33,272,17231,70,NULL,NULL,'2MASX J08410703+3152085',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000163,NULL,'16.8g',0.33,NULL,NULL,NULL,NULL,NULL,1,130.279208333,31.86919,0.105,NULL,64311454162,1004866471,15701038,16.8),(56089,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56089,38.48,0.46,496,17232,70,NULL,NULL,'2MASX J08410740+0449168',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000154,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,130.2807917,4.82142,0.053,NULL,62604767572,978199493,15284367,17.3),(56090,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56090,37.84,0.33,370,17233,70,NULL,NULL,'2MASX J08410738+2521037',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00018,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,130.280833,25.35114,0.097,NULL,64320712533,1005011133,15703298,17.5),(56091,'FP','2016-12-15 15:14:23','2016-12-16 11:19:29','1',NULL,'R',56091,37.17,0.33,272,17234,70,NULL,NULL,'2MASX J08410844+3155255',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,130.285,31.92372,0.105,NULL,64311452629,1004866447,15701038,17.6),(56092,'FP','2016-12-15 15:14:23','2016-12-16 11:19:30','1',NULL,'R',56092,38.08,0.23,413,17235,70,NULL,NULL,'2MASX J08410891+0726424',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00017,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,130.287167,7.44514,0.237,NULL,63657648826,994650762,15541418,17.2),(56093,'FP','2016-12-15 15:14:23','2016-12-16 11:19:30','1',NULL,'R',56093,38.08,0.23,413,17236,70,NULL,NULL,'2MASX J08410978+0724144',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,130.290625,7.40408,0.233,NULL,63657649869,994650779,15541418,17.6),(56094,'FP','2016-12-15 15:14:23','2016-12-16 11:19:30','1',NULL,'R',56094,38.76,0.33,566,17237,70,NULL,NULL,'SDSS J084110.85+052755.9',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000175,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,130.29525,5.46556,0.073,NULL,62605095579,978204618,15284447,18.2),(56095,'FP','2016-12-15 15:14:23','2016-12-16 11:19:30','1',NULL,'R',56095,37.93,0.46,386,17238,70,NULL,NULL,'SDSS J084110.86+010337.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000066,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,130.295291667,1.06047,0.133,NULL,62557341757,977458464,15272788,18.6),(56096,'FP','2016-12-15 15:14:23','2016-12-16 11:19:30','1',NULL,'R',56096,37.12,0.46,266,17239,70,NULL,NULL,'2MASX J08411339+4400207',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,130.3059583,44.00572,0.117,NULL,64251042085,1003922532,15686289,17.9),(56097,'FP','2016-12-15 15:14:23','2016-12-16 11:19:30','1',NULL,'R',56097,37.94,0.46,387,17240,70,NULL,NULL,'2MASX J08411356+2844017',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,130.3065417,28.73369,0.141,NULL,64322070808,1005032356,15703630,17.4),(56098,'FP','2016-12-15 15:14:23','2016-12-16 11:19:30','1',NULL,'R',56098,38.06,0.27,409,17241,70,NULL,NULL,'2MASX J08411376+3205306',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,130.307167,32.09181,0.137,NULL,64382681018,1005979390,15718427,17.1),(56099,'FP','2016-12-15 15:14:23','2016-12-16 11:19:30','1',NULL,'R',56099,36.41,0.46,192,17242,70,NULL,NULL,'2MASX J08411381+2754287',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000172,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,130.3075,27.90781,0.093,NULL,64323746993,1005058546,15704039,16.5),(56100,'FP','2016-12-15 15:14:23','2016-12-16 11:19:30','1',NULL,'R',56100,38.08,0.23,413,17243,70,NULL,NULL,'2MASX J08411448+0731374',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,130.310417,7.52697,0.237,NULL,63657659245,994650925,15541420,17.8),(56101,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:30','1',NULL,NULL,56101,35.34,NULL,117,17244,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0782',NULL,'2010Ap&SS.325..163P',2010,1,0.94,NULL,'G',0.000088,NULL,'17.2g',0.12,'Scd',NULL,NULL,NULL,NULL,1,130.314333,41.97133,0.137,NULL,64254908121,1003982939,15687233,17.2),(56102,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:30','1',NULL,NULL,56102,35.36,NULL,118,17244,NULL,NULL,'Dipole + Quadrupole','FGC 0782',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56103,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:30','1',NULL,NULL,56103,35.38,NULL,119,17244,NULL,NULL,'Dipole','FGC 0782',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56104,'Tully-Fisher','2016-12-15 15:14:23','2016-12-16 11:19:30','1',NULL,NULL,56104,35.39,NULL,120,17244,NULL,NULL,NULL,'FGC 0782',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56105,'FP','2016-12-15 15:14:23','2016-12-16 11:19:30','1',NULL,'R',56105,38.02,0.46,401,17245,70,NULL,NULL,'2MASX J08411683+2739337',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.0002,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,130.320083,27.65931,0.089,NULL,64323788408,1005059193,15704049,16.9),(56106,'FP','2016-12-15 15:14:23','2016-12-16 11:19:30','1',NULL,'R',56106,37.61,0.16,333,17246,70,NULL,NULL,'2MASX J08411727+2649527',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000148,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,130.321916667,26.83128,0.081,NULL,64321498448,1005023413,15703490,17.9),(56107,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56107,37.73,0.13,352,17247,70,NULL,NULL,'2MASX J08411774+2915177',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,130.323916667,29.25489,0.133,NULL,64313931964,1004905186,15701643,17.2),(56108,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56108,37.69,0.46,345,17248,70,NULL,NULL,'2MASX J08411810+0830074',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,130.325417,8.50203,0.221,NULL,63660222881,994690982,15542046,17.8),(56109,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56109,33.84,0.49,58.7,17249,75,NULL,'IR','UGC 04516',NULL,'2011yCatp016004901K',2011,1,1.6,NULL,'G',0.00002,NULL,'15.13',0.3,'Sdm:','Field galaxy',NULL,NULL,NULL,1,130.325833,66.86039,0.089,NULL,62269800992,972965640,15202588,15.13),(56110,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56110,33.25,0.69,44.7,17250,100,NULL,'mid-IR','MCG -01-22-034',NULL,'2013ApJ...771...88L',2013,1,1.5,NULL,'G',0.000017,NULL,'14.5',1,'(R\')SB(r)a',NULL,NULL,NULL,NULL,1,130.326375,-4.71417,0.057,NULL,39246378600,613224665,9581635,14.5),(56111,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56111,34.2,0.4,69.2,17250,NULL,NULL,'mean','MCG -01-22-034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56112,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56112,34.64,0.47,84.6,17250,NULL,NULL,'H','MCG -01-22-034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56113,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56113,38.33,0.33,462,17251,70,NULL,NULL,'2MASX J08411922+2710367',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,130.330083333,27.17672,0.089,NULL,64322938855,1005045919,15703842,18.2),(56114,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56114,37.78,0.46,360,17252,70,NULL,NULL,'SDSS J084119.42+440848.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,130.3309583,44.14669,0.101,NULL,64251354076,1003927407,15686365,18),(56115,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56115,38.06,0.27,409,17253,70,NULL,NULL,'2MASX J08411974+3203466',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,130.3322083,32.06292,0.137,NULL,64382677530,1005979336,15718427,17.4),(56116,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56116,37.78,0.33,360,17254,70,NULL,NULL,'2MASX J08411996+4134523',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000173,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,130.333125,41.58119,0.093,NULL,64246792600,1003856134,15685252,17.8),(56117,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56117,37.14,0.46,268,17255,70,NULL,NULL,'2MASX J08412124+3447566',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000173,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,130.3384583,34.79922,0.113,NULL,64365524220,1005711315,15714239,17),(56118,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56118,37.61,0.16,333,17256,70,NULL,NULL,'2MASX J08412146+2647567',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,130.339541667,26.79914,0.081,NULL,64321540574,1005024071,15703501,17.6),(56119,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56119,38.33,0.33,462,17257,70,NULL,NULL,'2MASX J08412222+2712017',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000179,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,130.3424583,27.20033,0.085,NULL,64322940642,1005045947,15703842,17.3),(56120,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56120,37.84,0.33,370,17258,70,NULL,NULL,'2MASX J08412250+2519587',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000165,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,130.343708333,25.33303,0.097,NULL,64320716460,1005011194,15703299,17.9),(56121,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56121,33.2,0.49,43.6,17259,75,NULL,'IR','ESO 563- G 010',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000033,NULL,'17',0.2,'Sc:',NULL,NULL,NULL,NULL,1,130.344,-20.26322,0.441,NULL,42232780814,659887200,10310737,17),(56122,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56122,33.88,0.2,59.7,17259,74.4,NULL,NULL,'ESO 563- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56123,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56123,33.92,0.46,60.7,17259,NULL,NULL,NULL,'ESO 563- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56124,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56124,34.14,0.42,67.2,17259,NULL,NULL,'Malmquist cor.','ESO 563- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56125,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56125,37.61,0.16,333,17260,70,NULL,NULL,'2MASX J08412294+2633547',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000179,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,130.3455,26.56514,0.065,NULL,64321706298,1005026660,15703541,16.5),(56126,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56126,38.76,0.33,566,17261,70,NULL,NULL,'2MASX J08412300+0532268',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,130.345708333,5.54081,0.073,NULL,62605091053,978204547,15284446,17.7),(56127,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56127,38.14,0.27,424,17262,70,NULL,NULL,'2MASX J08412299+3120536',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,130.345875,31.34817,0.109,NULL,64311883471,1004873179,15701143,17.6),(56128,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56128,37.18,0.46,273,17263,70,NULL,NULL,'2MASX J08412322+1900560',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000179,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,130.346916667,19.01544,0.061,NULL,63795420575,996803446,15575053,16.7),(56129,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56129,38.22,0.46,441,17264,70,NULL,NULL,'2MASX J08412362+1239208',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000138,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,130.3482917,12.65586,0.157,NULL,63838372354,997474568,15585540,18),(56130,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56130,38.64,0.46,535,17265,70,NULL,NULL,'SDSS J084123.84+373544.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000146,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,130.349375,37.59561,0.165,NULL,64370319464,1005786241,15715410,18.4),(56131,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56131,37.47,0.46,312,17266,70,NULL,NULL,'2MASX J08412382+2953367',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,130.3494583,29.89361,0.129,NULL,64315380011,1004927812,15701997,18.1),(56132,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56132,36.5,0.46,200,17267,70,NULL,NULL,'2MASX J08412389+0829184',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00016,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,130.349583,8.48844,0.221,NULL,63660223951,994690999,15542046,16.7),(56133,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56133,37.43,0.46,306,17268,70,NULL,NULL,'2MASX J08412422+2429427',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000105,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,130.3509583,24.49508,0.065,NULL,63801865862,996904154,15576627,17.2),(56134,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56134,37.4,0.46,302,17269,70,NULL,NULL,'2MASX J08412502+3129476',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000191,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,130.354208333,31.49667,0.105,NULL,64312123611,1004876931,15701202,16.9),(56135,'BL Lac Luminosity','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56135,38.87,NULL,595,17270,NULL,NULL,'Min. z = 0.15','2FGL J0841.3-3556',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,130.358,-35.98,NULL,NULL,42927332863,670739575,10480305,NULL),(56136,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56136,37.02,0.23,253,17271,70,NULL,NULL,'2MASX J08412730+3228326',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,130.363917,32.47583,0.129,NULL,64382785901,1005981029,15718453,17.4),(56137,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56137,37.78,0.33,360,17272,70,NULL,NULL,'2MASX J08412905+4135243',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000136,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,130.371,41.59014,0.093,NULL,64246795800,1003856184,15685252,18.2),(56138,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56138,37.8,0.46,362,17273,70,NULL,NULL,'2MASX J08412924+6233326',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,130.3717917,62.559,0.137,NULL,62053447400,969585115,15149767,16.8);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (56139,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56139,38.06,0.27,409,17274,70,NULL,NULL,'2MASX J08412926+3203406',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000179,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,130.371833333,32.06133,0.137,NULL,64382669924,1005979217,15718425,17.6),(56140,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56140,37.36,0.66,297,17275,70,NULL,NULL,'2MASX J08413050-1530318',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,130.377167,-15.50892,0.245,NULL,42394204104,662409439,10350147,15.8),(56141,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56141,39.66,0.46,854,17276,70,NULL,NULL,'2MASX J08413089+3737563',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00018,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,130.378917,37.63228,0.165,NULL,64370348231,1005786691,15715417,18.4),(56142,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56142,37.26,0.46,284,17277,70,NULL,NULL,'2MASX J08413107+2714516',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00018,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,130.3794583,27.24783,0.085,NULL,64322936966,1005045890,15703842,17.2),(56143,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56143,31.67,NULL,21.6,17278,NULL,NULL,NULL,'NGC 2644',NULL,'2015AstBu..70....1K',2015,1,2.1,NULL,'G',0.000023,NULL,'13.31',0.8,'Sdm','Isolated galaxy',NULL,NULL,NULL,1,130.38275,4.98033,0.053,NULL,62604935762,978202121,15284408,13.31),(56144,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56144,36.96,0.46,247,17279,70,NULL,NULL,'2MASX J08413188+6013066',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,130.382833,60.2185,0.117,NULL,62066690250,969792035,15153000,17.7),(56145,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56145,38.14,0.27,424,17280,70,NULL,NULL,'2MASX J08413266+3117426',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,130.386333333,31.29522,0.109,NULL,64311884119,1004873189,15701143,18),(56146,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56146,38.27,0.46,452,17281,70,NULL,NULL,'2MASX J08413288+1441438',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,130.386875,14.69558,0.097,NULL,63853935020,997717734,15589339,17.3),(56147,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56147,37.31,0.6,289,17282,70,NULL,NULL,'2MASX J08413320-1002350',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,130.388416667,-10.04311,0.137,NULL,42177780118,659027814,10297309,15.8),(56148,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56148,37.29,0.46,287,17283,70,NULL,NULL,'2MASX J08413467+2450186',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000152,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,130.394417,24.83856,0.057,NULL,63801706172,996901658,15576588,17.4),(56149,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56149,37.63,0.46,336,17284,70,NULL,NULL,'2MASX J08413464+3040436',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,130.394541667,30.67864,0.117,NULL,64314782047,1004918469,15701851,17.6),(56150,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56150,37.61,0.16,333,17285,70,NULL,NULL,'2MASX J08413499+2653326',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,130.395833,26.89247,0.081,NULL,64321036121,1005016189,15703377,17.6),(56151,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56151,33.9,0.68,60.2,17286,70,NULL,NULL,'ESO 563- G 011',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000033,NULL,'15',0.8,'SB(r)b?',NULL,NULL,NULL,NULL,1,130.397125,-20.31503,0.441,NULL,42233236753,659894324,10310848,15),(56152,'IRAS','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56152,34.47,0.8,78.2,17286,75,NULL,'MAT, I','ESO 563- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56153,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56153,34.2,0.47,69.2,17286,NULL,NULL,'H','ESO 563- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56154,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56154,34.21,0.46,69.6,17286,NULL,NULL,'J','ESO 563- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56155,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56155,34.23,0.45,70.1,17286,NULL,NULL,'K','ESO 563- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56156,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56156,34.25,0.37,70.9,17286,NULL,NULL,'Malmquist cor.','ESO 563- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56157,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56157,34.33,0.43,73.4,17286,75,NULL,'MAT, I, raw','ESO 563- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56158,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56158,34.49,0.32,79.2,17286,85,NULL,'I, raw','ESO 563- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56159,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56159,34.5,0.33,79.5,17286,NULL,NULL,NULL,'ESO 563- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56160,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56160,34.53,0.4,80.7,17286,NULL,NULL,'mean','ESO 563- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56161,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56161,34.54,0.2,80.9,17286,74.4,NULL,NULL,'ESO 563- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56162,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56162,34.58,0.43,82.2,17286,75,NULL,'MAT, I, cor','ESO 563- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56163,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56163,34.58,0.32,82.3,17286,85,NULL,'I, inv','ESO 563- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56164,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56164,34.66,0.43,85.5,17286,75,NULL,'MAT, I, inv','ESO 563- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56165,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56165,38.14,0.27,424,17287,70,NULL,NULL,'2MASX J08413673+3122466',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,130.403167,31.37975,0.109,NULL,64311880684,1004873135,15701142,17.3),(56166,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56166,37.43,0.46,306,17288,70,NULL,NULL,'2MASX J08413706+2346115',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000176,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,130.40425,23.76978,0.069,NULL,63802501221,996914081,15576782,17.2),(56167,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56167,35.01,0.56,100,17289,70,NULL,NULL,'FAIRALL 1335',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.00015,NULL,'15.3B',0.67,NULL,NULL,NULL,NULL,NULL,1,130.411,-75.15942,0.565,NULL,39931440981,623928765,9748886,15.3),(56168,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56168,36.89,0.46,239,17290,70,NULL,NULL,'2MASX J08413906+3221096',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000142,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,130.4127917,32.35253,0.113,NULL,64382813463,1005981460,15718460,17.3),(56169,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56169,36.51,0.46,200,17291,70,NULL,NULL,'2MASX J08413941+5316523',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000067,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,130.414333333,53.28111,0.109,NULL,63486313227,991973644,15499588,17.2),(56170,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56170,36.81,0.46,230,17292,70,NULL,NULL,'2MASX J08414110+1057567',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,130.421333,10.96586,0.165,NULL,63666741892,994792842,15543638,16.5),(56171,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56171,33.95,NULL,61.7,17293,NULL,NULL,'Dipole','UGC 04532',NULL,'2010Ap&SS.325..163P',2010,1,1.45,NULL,'G',0.000007,NULL,'15.7g',0.24,'Sc',NULL,NULL,NULL,NULL,1,130.421917,18.85992,0.061,NULL,63795366434,996802600,15575040,15.7),(56172,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56172,33.96,NULL,62.1,17293,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04532',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56173,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56173,33.97,NULL,62.1,17293,NULL,NULL,'Dipole + Quadrupole','UGC 04532',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56174,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56174,34.07,NULL,65,17293,NULL,NULL,NULL,'UGC 04532',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56175,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56175,34.07,0.49,65.2,17293,75,NULL,'IR','UGC 04532',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56176,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56176,34.16,0.2,67.9,17293,74.4,NULL,NULL,'UGC 04532',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56177,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56177,34.18,0.12,68.7,17293,NULL,NULL,NULL,'UGC 04532',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56178,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56178,35.27,0.46,113,17294,70,NULL,NULL,'2MASX J08414131+6000376',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,130.422125,60.01061,0.117,NULL,62067086974,969798233,15153097,16.2),(56179,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56179,33.01,NULL,39.9,17295,NULL,NULL,NULL,'FGC 0781',NULL,'2000BSAO...50....5K',2000,1,0.72,'Multiple SDSS entries describe this source.','G',0.00008,'?','17.1',0.09,'Sd',NULL,NULL,NULL,NULL,1,130.424167,57.65139,0.193,NULL,62018624740,969041011,15141265,17.1),(56180,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56180,33.02,NULL,40.2,17295,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0781',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56181,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56181,33.03,NULL,40.4,17295,NULL,NULL,'Dipole + Quadrupole','FGC 0781',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56182,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56182,33.06,NULL,40.9,17295,NULL,NULL,'Dipole','FGC 0781',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56183,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56183,38.67,0.46,542,17296,70,NULL,NULL,'SDSS J084142.24+031041.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,130.426,3.17825,0.097,NULL,62550813789,977356465,15271194,18.1),(56184,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56184,36.83,0.46,232,17297,70,NULL,NULL,'2MASX J08414423+0708427',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000183,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,130.4342083,7.14517,0.217,NULL,63657846677,994653854,15541466,16.6),(56185,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56185,37.3,0.46,289,17298,70,NULL,NULL,'2MASX J08414624+3615007',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00019,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,130.442625,36.25022,0.093,NULL,64363057492,1005672773,15713637,16.8),(56186,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56186,37.27,0.33,285,17299,70,NULL,NULL,'2MASX J08414761+0049097',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000078,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,130.4485,0.81933,0.105,NULL,62557809317,977465770,15272902,16.5),(56187,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56187,38.3,0.46,458,17300,70,NULL,NULL,'2MASX J08414844+0945047',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,130.451917,9.75136,0.229,NULL,63668900594,994826571,15544165,17),(56188,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56188,37.61,0.16,333,17301,70,NULL,NULL,'2MASX J08414908+2641364',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000136,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,130.4544583,26.6935,0.093,NULL,64321525919,1005023842,15703497,17.3),(56189,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56189,36.8,0.33,229,17302,70,NULL,NULL,'SDSS J084150.25+102739.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,130.459417,10.46092,0.193,NULL,63669368429,994833881,15544279,17.7),(56190,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56190,38.05,0.46,407,17303,70,NULL,NULL,'2MASX J08415122+6014005',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,130.463625,60.23342,0.117,NULL,62066701572,969792212,15153003,17.7),(56191,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56191,36.8,0.33,229,17304,70,NULL,NULL,'2MASX J08415173+1026367',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'16.12',0.43,NULL,NULL,NULL,NULL,NULL,1,130.4655,10.44367,0.193,NULL,63669368454,994833882,15544279,16.12),(56192,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56192,35.34,0.46,117,17305,70,NULL,NULL,'2MASX J08415191+5458397',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000072,NULL,'16.2g',0.32,NULL,NULL,NULL,NULL,NULL,1,130.466416667,54.97769,0.121,NULL,61541748044,961589813,15024840,16.2),(56193,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56193,38.83,0.46,584,17306,70,NULL,NULL,'2MASX J08415195+4020577',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000173,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,130.466583333,40.34944,0.101,NULL,64246376505,1003849632,15685150,17.6),(56194,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56194,35.46,0.4,124,17307,NULL,NULL,'mean','UGC 04531',NULL,'2007A&A...465...71T',2007,1,1.23,NULL,'G',0.000033,NULL,'14.4g',0.49,'Sb','Isolated galaxy',NULL,NULL,NULL,1,130.471083333,32.86814,0.149,NULL,64416356261,1006505566,15726649,14.4),(56195,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56195,35.75,0.47,141,17307,NULL,NULL,'H','UGC 04531',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56196,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56196,37.87,0.46,375,17308,70,NULL,NULL,'SDSS J084154.38+603349.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,130.476625,60.56364,0.129,NULL,62065604123,969775064,15152735,18.5),(56197,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56197,36.79,0.46,228,17309,70,NULL,NULL,'SDSS J084154.82+351102.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000172,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,130.478458333,35.18403,0.085,NULL,64365371166,1005708924,15714201,17.3),(56198,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56198,37.75,0.46,355,17310,70,NULL,NULL,'SDSS J084155.65+332635.8',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000135,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,130.481917,33.44331,0.121,NULL,64416262047,1006504094,15726626,17.8),(56199,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56199,38.83,0.46,584,17311,70,NULL,NULL,'SDSS J084156.45+050945.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000131,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,130.48525,5.16256,0.061,NULL,62550053264,977344582,15271009,18.5),(56200,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56200,38.06,0.46,410,17312,70,NULL,NULL,'2MASX J08415671+2743154',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,130.486333,27.72092,0.089,NULL,64323760307,1005058754,15704043,17.8),(56201,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56201,37.03,0.46,254,17313,70,NULL,NULL,'2MASX J08415671+5053222',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000071,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,130.4864583,50.88961,0.109,NULL,63494541158,992102205,15501596,17.2),(56202,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56202,37.79,0.46,361,17314,70,NULL,NULL,'SDSS J084156.93+195619.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000125,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,130.4872083,19.93881,0.069,NULL,63796371440,996818303,15575285,18.6),(56203,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56203,37.86,0.46,374,17315,70,NULL,NULL,'2MASX J08415734+0953252',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,130.489,9.89036,0.265,NULL,63668928024,994827000,15544171,18.1),(56204,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56204,37.27,0.33,285,17316,70,NULL,NULL,'2MASX J08415908+0101017',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000098,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,130.4962917,1.01728,0.105,NULL,62558030434,977469225,15272956,16.6),(56205,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56205,36.97,0.46,248,17317,70,NULL,NULL,'2MASX J08415926+1359089',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000171,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,130.49675,13.98583,0.105,NULL,63853103072,997704735,15589136,17.2),(56206,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56206,36.74,0.46,223,17318,70,NULL,NULL,'2MASX J08420035+2300314',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000181,NULL,'16.2g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,130.5015417,23.00894,0.081,NULL,63803740449,996933444,15577085,16.2),(56207,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56207,36.86,0.46,236,17319,70,NULL,NULL,'2MASX J08420053+1140202',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000172,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,130.502333,11.67228,0.117,NULL,63666478338,994788724,15543573,16.5),(56208,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56208,37.86,0.46,373,17320,70,NULL,NULL,'2MASX J08420074+2825354',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000182,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,130.502958333,28.42664,0.109,NULL,64322113014,1005033015,15703640,17.1),(56209,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56209,37.43,0.46,306,17321,70,NULL,NULL,'SDSS J084201.37+323028.2',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,130.50575,32.50783,0.129,NULL,64382793569,1005981149,15718455,17.7),(56210,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56210,37.21,0.46,276,17322,70,NULL,NULL,'2MASX J08420253+1901004',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000139,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,130.5104583,19.01669,0.065,NULL,63795424852,996803513,15575054,16.9),(56211,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56211,38.24,0.46,444,17323,70,NULL,NULL,'SDSS J084202.63+005556.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000083,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,130.511,0.93225,0.105,NULL,62558023049,977469110,15272954,18.3),(56212,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56212,36.26,0.46,179,17324,70,NULL,NULL,'2MASX J08420349+4041148',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00018,NULL,'15.6g',0.47,'E0',NULL,NULL,NULL,NULL,1,130.514625,40.6875,0.113,NULL,64247235645,1003863056,15685360,15.6),(56213,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56213,38.18,0.46,433,17325,70,NULL,NULL,'2MASX J08420516+4050458',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000187,NULL,'17.5g',0.22,'AGN',NULL,NULL,NULL,NULL,1,130.521375,40.84594,0.125,NULL,64247246200,1003863221,15685362,17.5),(56214,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56214,37.01,0.46,252,17326,70,NULL,NULL,'2MASX J08420525+5220243',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000086,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,130.5220417,52.34017,0.097,NULL,63487706717,991995417,15499928,17),(56215,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56215,38.69,0.27,547,17327,70,NULL,NULL,'2MASX J08420587+3057055',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,130.524583,30.95167,0.109,NULL,64312016445,1004875256,15701175,17.9),(56216,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56216,37.43,0.46,306,17328,70,NULL,NULL,'2MASX J08420721+1833377',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000183,NULL,'16.2g',0.43,NULL,NULL,NULL,NULL,NULL,1,130.530125,18.56036,0.065,NULL,63845749196,997589831,15587341,16.2),(56217,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56217,37.76,0.46,356,17329,70,NULL,NULL,'SDSS J084207.47+260454.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,130.531125,26.08172,0.085,NULL,64320794293,1005012410,15703318,17.9),(56218,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56218,36.24,0.33,177,17330,70,NULL,NULL,'CGCG 263-074',NULL,'2015arXiv151105856S',2015,1,1.09,NULL,'G',0.00011,NULL,'14.6g',0.64,'E0',NULL,NULL,NULL,NULL,1,130.548875,52.77308,0.125,NULL,63487644849,991994450,15499913,14.6),(56219,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56219,37.76,0.46,356,17331,70,NULL,NULL,'2MASX J08421185+5232363',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000089,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,130.5492917,52.54342,0.097,NULL,63487629553,991994211,15499909,17.4),(56220,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56220,37.02,0.23,253,17332,70,NULL,NULL,'SDSS J084213.23+321711.0',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000161,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,130.555167,32.28642,0.113,NULL,64382773461,1005980835,15718450,16.7),(56221,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56221,37.19,0.46,274,17333,70,NULL,NULL,'2MASX J08421441+2402186',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000181,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,130.560167,24.03844,0.049,NULL,63802686181,996916971,15576827,16.8),(56222,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56222,36.6,0.21,209,17334,70,NULL,NULL,'2MASX J08421442+3606437',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000165,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,130.560167,36.11222,0.097,NULL,64363083758,1005673183,15713643,16.7),(56223,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56223,37.02,0.46,254,17335,70,NULL,NULL,'2MASX J08421556+0323357',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,130.56475,3.39333,0.065,NULL,62551670286,977369848,15271403,17.4),(56224,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56224,38.69,0.27,547,17336,70,NULL,NULL,'2MASX J08421560+3057515',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,130.564875,30.96431,0.105,NULL,64312013488,1004875210,15701175,18.2),(56225,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56225,37.8,0.46,364,17337,70,NULL,NULL,'2MASX J08421700+5107404',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000086,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,130.570833,51.12794,0.085,NULL,63498780276,992168441,15502631,17.6),(56226,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56226,37.94,0.46,387,17338,70,NULL,NULL,'2MASX J08421873+3530575',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,130.577958333,35.51594,0.093,NULL,64363434662,1005678666,15713729,17.6),(56227,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56227,37.32,0.46,292,17339,70,NULL,NULL,'SDSS J084219.68+104829.6',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.0E',NULL,NULL,NULL,NULL,NULL,NULL,1,130.582,10.80822,0.165,NULL,63667177742,994799652,15543744,17),(56228,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56228,38.04,0.46,406,17340,70,NULL,NULL,'SDSS J084221.37+233109.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000136,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,130.5890417,23.51925,0.085,NULL,63802780348,996918442,15576850,18.2),(56229,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56229,34.5,0.49,79.4,17341,75,NULL,'IR','ESO 036- G 007',NULL,'2011yCatp016004901K',2011,1,1.6,NULL,'G',0.000033,NULL,'15.51',0.4,'Sc:',NULL,NULL,NULL,NULL,1,130.6005417,-73.87969,0.689,NULL,39897153683,623393026,9740516,15.51),(56230,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56230,34.63,0.38,84.3,17341,NULL,NULL,'Malmquist cor.','ESO 036- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56231,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56231,34.87,0.34,94.1,17341,NULL,NULL,NULL,'ESO 036- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56232,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56232,34.91,0.2,95.9,17341,74.4,NULL,NULL,'ESO 036- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56233,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56233,36.24,0.33,177,17342,70,NULL,NULL,'2MASX J08422601+5246594',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000084,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,130.6085,52.78319,0.125,NULL,63487652545,991994571,15499915,16.9),(56234,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56234,38,0.33,398,17343,70,NULL,NULL,'2MASX J08422627+0522567',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,130.6094583,5.38247,0.061,NULL,62549729160,977339518,15270929,17.2),(56235,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56235,37.44,0.46,307,17344,70,NULL,NULL,'2MASX J08422756+1039452',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,130.614708333,10.6625,0.193,NULL,63669341186,994833456,15544272,16.9),(56236,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56236,37.12,0.46,266,17345,70,NULL,NULL,'2MASX J08422780+1142362',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000194,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,130.615917,11.71014,0.117,NULL,63666598034,994790594,15543603,16.6),(56237,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56237,38.69,0.27,547,17346,70,NULL,NULL,'SDSS J084229.57+305659.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000167,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,130.62325,30.94994,0.105,NULL,64312007449,1004875116,15701173,18.6),(56238,'IRAS','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56238,34.84,0.8,92.9,17347,75,NULL,'MAT, I','ESO 563- G 013',NULL,'1997ApJS..109..333W',1997,1,1.5,'RC3 gives v=1623 km/sec.','G',0.000033,NULL,'16',0.4,'SB(rs)c:       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,130.63525,-19.87225,0.389,NULL,42233345036,659896016,10310875,16),(56239,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56239,34.16,0.32,67.9,17347,85,NULL,'I, raw','ESO 563- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56240,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56240,34.18,0.43,68.7,17347,75,NULL,'MAT, I, raw','ESO 563- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56241,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56241,34.19,0.32,69,17347,85,NULL,'I, inv','ESO 563- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56242,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56242,34.35,0.36,74.1,17347,NULL,NULL,'Malmquist cor.','ESO 563- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56243,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56243,34.35,0.43,74.3,17347,75,NULL,'MAT, I, inv','ESO 563- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56244,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56244,34.42,0.35,76.7,17347,NULL,NULL,NULL,'ESO 563- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56245,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56245,34.43,0.43,77,17347,75,NULL,'MAT, I, cor','ESO 563- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56246,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56246,34.46,0.2,78,17347,74.4,NULL,NULL,'ESO 563- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56247,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56247,37.41,0.46,304,17348,70,NULL,NULL,'2MASX J08423355+3431325',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,130.639583,34.52558,0.093,NULL,64361882387,1005654412,15713350,16.8),(56248,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56248,37.38,0.46,300,17349,70,NULL,NULL,'2MASX J08423452+1425448',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000151,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,130.64375,14.42906,0.113,NULL,63854047418,997719490,15589367,17.2),(56249,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56249,38.25,0.46,448,17350,70,NULL,NULL,'SDSS J084234.54+422308.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00014,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,130.6439583,42.38561,0.137,NULL,64253118608,1003954978,15686796,18.1),(56250,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56250,37.8,0.46,363,17351,70,NULL,NULL,'SDSS J084234.86+120622.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,130.6452917,12.10631,0.133,NULL,63666443866,994788185,15543565,18),(56251,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56251,38,0.33,398,17352,70,NULL,NULL,'2MASX J08423514+0520237',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000173,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,130.6465,5.33986,0.109,NULL,62550582225,977352847,15271138,17.1),(56252,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56252,37.21,0.46,277,17353,70,NULL,NULL,'2MASX J08423615+3436545',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,130.65075,34.61519,0.093,NULL,64365321499,1005708148,15714189,17.4),(56253,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56253,31.98,0.49,24.9,17354,75,NULL,'IR','FGCE 0717',NULL,'2011yCatp016004901K',2011,1,0.94,'abs(b) < 10 degrees.','G',NULL,NULL,'17.1',0.1,'Sc',NULL,NULL,NULL,NULL,1,130.6535,-55.39331,NULL,NULL,40402871060,631294860,9863982,17.1),(56254,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56254,32.67,NULL,34.3,17354,NULL,NULL,'Dipole + Quadrupole + Octopole','FGCE 0717',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56255,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56255,32.69,NULL,34.5,17354,NULL,NULL,'Dipole + Quadrupole','FGCE 0717',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56256,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56256,32.71,NULL,34.8,17354,NULL,NULL,'Dipole','FGCE 0717',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56257,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56257,38.48,0.46,497,17355,70,NULL,NULL,'2MASX J08423735+2824225',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000138,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,130.655667,28.40628,0.117,NULL,64322121648,1005033150,15703642,18.3),(56258,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56258,37.71,0.46,348,17356,70,NULL,NULL,'2MASX J08423743+4024521',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,130.655916667,40.4145,0.101,NULL,64247180485,1003862195,15685346,17.5),(56259,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56259,36.8,0.46,229,17357,70,NULL,NULL,'2MASX J08423800+4140101',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000168,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,130.6584583,41.6695,0.093,NULL,64246828660,1003856697,15685260,16.7),(56260,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56260,36.36,0.46,187,17358,70,NULL,NULL,'CGCG 120-023',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000176,NULL,'15.3g',0.52,NULL,NULL,NULL,NULL,NULL,1,130.6625417,22.27175,0.093,NULL,63801178848,996893419,15576459,15.3),(56261,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56261,38.61,0.46,527,17359,70,NULL,NULL,'2MASX J08423910+5939315',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,130.663083,59.65867,0.101,NULL,62066939937,969795936,15153061,18.6),(56262,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56262,38.55,0.46,512,17360,70,NULL,NULL,'2MASX J08423972+1813183',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,130.665541667,18.22169,0.057,NULL,63845849733,997591402,15587365,17.7),(56263,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56263,32.66,0.4,34.1,17361,NULL,NULL,'mean','NGC 2648',NULL,'2007A&A...465...71T',2007,1,3.37,NULL,'G',0.000033,NULL,'12.6g',0.8,'S(s)b          RET','Pair member (points to parent)',NULL,NULL,NULL,1,130.665833,14.28561,0.113,NULL,63853984049,997718500,15589351,12.6),(56264,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56264,32.67,0.47,34.2,17361,NULL,NULL,'H','NGC 2648',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56265,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56265,32.67,0.45,34.2,17361,NULL,NULL,'K','NGC 2648',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56266,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56266,32.7,0.46,34.6,17361,NULL,NULL,'J','NGC 2648',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56267,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56267,37.98,0.46,394,17362,70,NULL,NULL,'2MASX J08424058+1310458',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,130.669083333,13.1795,0.201,NULL,63852939881,997702185,15589096,17.2),(56268,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56268,37.39,0.46,300,17363,70,NULL,NULL,'2MASX J08424085+0207107',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,130.670375,2.11964,0.141,NULL,62556545961,977446030,15272594,17.5),(56269,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56269,37.67,0.46,342,17364,70,NULL,NULL,'2MASX J08424175+2710232',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,130.673917,27.17311,0.089,NULL,64322951717,1005046120,15703845,17.9),(56270,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56270,34.86,0.53,93.5,17365,70,NULL,NULL,'ESO 060- G 011',NULL,'2014MNRAS.445.2677S',2014,1,2.2,NULL,'G',0.000033,NULL,'14.31',1.6,'(R\')SB(r)b',NULL,NULL,NULL,NULL,1,130.679416667,-67.81508,0.513,NULL,40792960178,637390002,9959218,14.31),(56271,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56271,34.77,0.57,89.9,17365,NULL,NULL,'Malmquist cor.','ESO 060- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56272,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56272,35.06,0.49,103,17365,NULL,NULL,NULL,'ESO 060- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56273,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56273,35.1,0.2,105,17365,74.4,NULL,NULL,'ESO 060- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56274,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56274,35.24,0.4,112,17365,NULL,NULL,'mean','ESO 060- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56275,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56275,35.39,0.47,120,17365,NULL,NULL,'H','ESO 060- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56276,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56276,35.42,0.45,121,17365,NULL,NULL,'K','ESO 060- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56277,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56277,35.45,0.46,123,17365,NULL,NULL,'J','ESO 060- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56278,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56278,36.6,0.21,209,17366,70,NULL,NULL,'2MASX J08424443+3554431',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000167,NULL,'15.9g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,130.685166667,35.91194,0.093,NULL,64363644570,1005681946,15713780,15.9),(56279,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56279,33.64,NULL,53.5,17367,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04537',NULL,'2010Ap&SS.325..163P',2010,1,0.94,NULL,'G',0.00003,NULL,'16.8g',0.15,'Sd',NULL,NULL,NULL,NULL,1,130.68725,35.75764,0.093,NULL,64363473270,1005679269,15713738,16.8),(56280,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56280,33.66,NULL,53.9,17367,NULL,NULL,'Dipole + Quadrupole','UGC 04537',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56281,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56281,33.67,NULL,54.1,17367,NULL,NULL,'Dipole','UGC 04537',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56282,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56282,33.72,NULL,55.5,17367,NULL,NULL,NULL,'UGC 04537',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56283,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56283,37.14,0.46,268,17368,70,NULL,NULL,'2MASX J08424490+0234597',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,130.6872083,2.58308,0.109,NULL,62558996615,977484322,15273192,17.2),(56284,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56284,36.95,0.46,245,17369,70,NULL,NULL,'2MASX J08424506+2555232',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000187,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,130.6877083,25.92311,0.105,NULL,64320822976,1005012859,15703325,16.7),(56285,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56285,36.53,0.46,202,17370,70,NULL,NULL,'SDSS J084245.13+122310.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000153,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,130.688083,12.38633,0.221,NULL,63843611718,997556433,15586819,18.3),(56286,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56286,38.06,0.46,410,17371,70,NULL,NULL,'2MASX J08424529+0416007',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000142,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,130.6887083,4.26669,0.077,NULL,62553570760,977399543,15271867,17.4),(56287,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56287,37.33,0.33,292,17372,70,NULL,NULL,'2MASX J08424598+1257258',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000209,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,130.691583333,12.95714,0.221,NULL,63852192055,997690500,15588914,16.6),(56288,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56288,36.78,0.46,227,17373,70,NULL,NULL,'2MASX J08424774+0459577',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000153,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,130.698833,4.99944,0.053,NULL,62550084284,977345066,15271016,16.7),(56289,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56289,38.04,0.46,406,17374,70,NULL,NULL,'2MASX J08424955+0121047',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,130.706375,1.35131,0.133,NULL,62557102312,977454723,15272730,17.3),(56290,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56290,37.4,0.46,303,17375,70,NULL,NULL,'2MASX J08424974+5501198',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000069,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,130.7072917,55.02203,0.121,NULL,61541280374,961582505,15024726,18.2),(56291,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56291,36.98,0.46,249,17376,70,NULL,NULL,'2MASX J08425079+2405332',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000191,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,130.711791667,24.09258,0.049,NULL,63802554457,996914913,15576795,16.5),(56292,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56292,38.04,0.46,406,17377,70,NULL,NULL,'2MASX J08425084+1056291',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,130.7120417,10.94144,0.145,NULL,63667180446,994799694,15543745,17.5),(56293,'SZ effect','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56293,39.43,0.52,770,17378,NULL,NULL,'Isotherm.','ABELL 0697',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III [BM]',NULL,NULL,NULL,NULL,1,130.73625,36.3625,0.093,NULL,64363049601,1005672650,15713635,NULL),(56294,'SZ effect','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56294,39.43,0.55,770,17378,NULL,NULL,'Isotherm., r < 100 kpc','ABELL 0697',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56295,'SZ effect','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56295,39.7,NULL,871,17378,NULL,NULL,'4.2 (black) calibration','ABELL 0697',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56296,'SZ effect','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56296,39.7,NULL,872,17378,NULL,NULL,'3.1 (red) calibration','ABELL 0697',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56297,'SZ effect','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56297,39.72,0.68,880,17378,NULL,NULL,'Hydrost. Eq.','ABELL 0697',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56298,'SZ effect','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56298,40,NULL,998,17378,NULL,NULL,NULL,'ABELL 0697',NULL,'2002ApJ...581...53R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56299,'SZ effect','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56299,40.11,NULL,1050,17378,NULL,NULL,'4.1 (blue) calibration','ABELL 0697',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56300,'SZ effect','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56300,40.2,NULL,1100,17378,NULL,NULL,NULL,'ABELL 0697',NULL,'2005ApJ...625..108D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56301,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56301,36.6,0.21,209,17379,70,NULL,NULL,'2MASX J08425525+3603071',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00019,NULL,'16.1g',0.4,'E0',NULL,NULL,NULL,NULL,1,130.73025,36.05203,0.097,NULL,64363591125,1005681111,15713767,16.1),(56302,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56302,34.88,0.48,94.5,17380,70,NULL,NULL,'ESO 060- G 012',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000107,NULL,'14.67',0.5,'S0',NULL,NULL,NULL,NULL,1,130.7342083,-68.08564,0.477,NULL,40792891889,637388935,9959202,14.67),(56303,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56303,37.1,0.46,263,17381,70,NULL,NULL,'2MASX J08425652+2331432',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000175,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,130.7355,23.52881,0.057,NULL,63802809935,996918905,15576857,16.9),(56304,'IRAS','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56304,31.95,0.8,24.6,17382,75,NULL,'MAT, I','ESO 563- G 014',NULL,'1997ApJS..109..333W',1997,1,2.46,NULL,'G',0.000007,NULL,'14',0.34,'SBd? sp        HII',NULL,NULL,NULL,NULL,1,130.7380417,-20.05114,0.421,NULL,42233137583,659892774,10310824,14),(56305,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56305,31.6,0.4,20.9,17382,75,NULL,NULL,'ESO 563- G 014',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56306,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56306,31.6,0.4,20.9,17382,73,NULL,'IR','ESO 563- G 014',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56307,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56307,31.92,0.43,24.3,17382,75,NULL,'3.6 micron, color + selection bias corrected','ESO 563- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56308,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56308,32.03,0.49,25.5,17382,75,NULL,'IR','ESO 563- G 014',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56309,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56309,32.13,0.43,26.7,17382,75,NULL,'3.6 micron, color corrected','ESO 563- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56310,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56310,32.13,0.32,26.7,17382,85,NULL,'I, raw','ESO 563- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56311,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56311,32.16,0.32,27,17382,85,NULL,'I, inv','ESO 563- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56312,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56312,32.16,0.39,27.1,17382,73,NULL,'opt','ESO 563- G 014',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56313,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56313,32.24,0.2,28.1,17382,74.4,NULL,NULL,'ESO 563- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56314,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56314,32.27,0.49,28.4,17382,NULL,NULL,'Malmquist cor.','ESO 563- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56315,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56315,32.31,0.48,29,17382,NULL,NULL,NULL,'ESO 563- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56316,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56316,32.32,0.43,29.2,17382,75,NULL,'MAT, I, raw','ESO 563- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56317,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56317,32.48,0.43,31.3,17382,75,NULL,'MAT, I, inv','ESO 563- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56318,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56318,32.54,0.43,32.3,17382,75,NULL,'MAT, I, cor','ESO 563- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56319,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56319,32.94,NULL,38.8,17382,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 563- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56320,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56320,32.95,NULL,38.9,17382,NULL,NULL,'Dipole + Quadrupole','ESO 563- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56321,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56321,32.95,NULL,38.9,17382,NULL,NULL,'Dipole','ESO 563- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56322,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56322,37.13,0.46,267,17383,70,NULL,NULL,'2MASX J08425734+1207100',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000202,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,130.738833,12.11956,0.141,NULL,63662198795,994721856,15542529,16.3),(56323,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56323,38.04,0.46,406,17384,70,NULL,NULL,'2MASX J08425738+2939402',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00012,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,130.739083,29.66133,0.141,NULL,64314027709,1004906682,15701666,17.6),(56324,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56324,38.08,0.46,412,17385,70,NULL,NULL,'2MASX J08425823+1629380',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000179,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,130.742625,16.49381,0.049,NULL,63849822761,997653480,15588335,17),(56325,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56325,36.73,0.64,222,17386,70,NULL,NULL,'2MASX J08425850-7609040',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,130.743666667,-76.15119,0.533,NULL,39945467296,624147926,9752311,17.2),(56326,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56326,36.6,0.21,209,17387,70,NULL,NULL,'2MASX J08425912+3603143',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000185,NULL,'16.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,130.7462083,36.05386,0.097,NULL,64363592857,1005681138,15713767,16.9),(56327,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56327,38.45,0.46,490,17388,70,NULL,NULL,'2MASX J08425935+0602348',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000144,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,130.747417,6.04314,0.129,NULL,63627606911,994181357,15534083,17.5),(56328,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56328,37.03,0.46,255,17389,70,NULL,NULL,'2MASX J08430056+1455310',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,130.752333,14.92528,0.073,NULL,63853743504,997714742,15589292,17.1),(56329,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56329,37.53,0.46,321,17390,70,NULL,NULL,'2MASX J08430480+5114518',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000082,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,130.770041667,51.24764,0.093,NULL,63498842435,992169413,15502647,17.4),(56330,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56330,34.8,0.71,91.2,17391,NULL,NULL,'Malmquist cor.','ESO 563- G 015',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.17',0.2,'S...',NULL,NULL,NULL,NULL,1,130.775875,-17.88142,0.257,NULL,42384414660,662256479,10347757,15.17),(56331,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56331,34.88,0.69,94.7,17391,NULL,NULL,NULL,'ESO 563- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56332,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56332,34.92,0.2,96.4,17391,74.4,NULL,NULL,'ESO 563- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56333,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56333,37.08,0.46,260,17392,70,NULL,NULL,'2MASX J08430742+3254411',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,130.780917,32.91147,0.105,NULL,64416213207,1006503331,15726614,17.8),(56334,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56334,34.8,0.49,91.1,17393,75,NULL,'IR','UGC 04548',NULL,'2011yCatp016004901K',2011,1,1.39,NULL,'G',0.000033,NULL,'15.3g',0.26,'S?',NULL,NULL,NULL,NULL,1,130.781417,18.22261,0.057,NULL,63845852435,997591444,15587366,15.3),(56335,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56335,37.61,0.46,333,17394,70,NULL,NULL,'2MASX J08430851+2526220',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000172,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,130.785417,25.43936,0.093,NULL,64309383262,1004834113,15700533,17.6),(56336,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56336,36.46,0.46,196,17395,70,NULL,NULL,'2MASX J08430853+3715443',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,130.785417,37.26225,0.089,NULL,64370812063,1005793938,15715530,17.4),(56337,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56337,37.33,0.33,292,17396,70,NULL,NULL,'2MASX J08430874+1247450',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000178,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,130.786541667,12.79583,0.237,NULL,63852217445,997690897,15588920,16.9),(56338,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56338,38.3,0.46,457,17397,70,NULL,NULL,'2MASX J08430910+2921110',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000171,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,130.787917,29.35308,0.133,NULL,64314088054,1004907625,15701681,18),(56339,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56339,35.82,0.53,146,17398,70,NULL,NULL,'2MASX J08430920-0144211',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00007,NULL,'15.81',0.4,NULL,NULL,NULL,NULL,NULL,1,130.78825,-1.73931,0.053,NULL,39197298867,612457794,9569653,15.81),(56340,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56340,35.92,0.49,153,17399,70,NULL,NULL,'2MASX J08431419-1735473',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,130.809125,-17.59642,0.237,NULL,42383871805,662247996,10347624,15.3),(56341,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56341,36.92,0.46,243,17400,70,NULL,NULL,'2MASX J08431439+2534139',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00017,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,130.8100417,25.57064,0.125,NULL,64309391871,1004834247,15700535,16.7),(56342,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56342,35.96,0.73,155,17401,70,NULL,NULL,'2MASX J08431528-2010594',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,130.8137083,-20.18314,0.421,NULL,42233151594,659892993,10310828,14.4),(56343,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56343,32.24,0.4,28.1,17402,75,NULL,NULL,'UGC 04550',NULL,'2008Ap.....51..336K',2008,1,2.19,NULL,'G',0.000021,NULL,'14.6g',0.48,'Sbc',NULL,NULL,NULL,NULL,1,130.816333,13.08581,0.221,NULL,63852077717,997688714,15588886,14.6),(56344,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56344,32.56,NULL,32.6,17402,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04550',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56345,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56345,32.57,NULL,32.6,17402,NULL,NULL,'Dipole + Quadrupole','UGC 04550',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56346,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56346,32.57,NULL,32.7,17402,NULL,NULL,'Dipole','UGC 04550',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56347,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56347,32.64,NULL,33.8,17402,NULL,NULL,NULL,'UGC 04550',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56348,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56348,32.86,0.43,37.4,17402,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04550',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56349,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56349,32.92,0.43,38.3,17402,75,NULL,'3.6 micron, color corrected','UGC 04550',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56350,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56350,32.99,0.2,39.6,17402,74.4,NULL,NULL,'UGC 04550',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56351,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56351,33.18,0.48,43.3,17402,NULL,NULL,NULL,'UGC 04550',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56352,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56352,33.19,0.49,43.5,17402,75,NULL,'IR','UGC 04550',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56353,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56353,33.55,0.4,51.3,17402,NULL,NULL,'Malmquist cor.','UGC 04550',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56354,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56354,35.79,0.46,144,17403,70,NULL,NULL,'CGCG 263-076',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000095,NULL,'15.2g',0.62,'E0',NULL,NULL,NULL,NULL,1,130.821667,52.75794,0.097,NULL,63487834851,991997419,15499959,15.2),(56355,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56355,37.81,0.46,365,17404,70,NULL,NULL,'SDSS J084317.68+204507.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000136,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,130.8237083,20.75197,0.105,NULL,63799244725,996863198,15575987,18.1),(56356,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56356,38.31,0.46,460,17405,70,NULL,NULL,'2MASX J08431820+3440571',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000203,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,130.826,34.68244,0.093,NULL,64365270316,1005707348,15714177,17.1),(56357,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56357,37.67,0.46,341,17406,70,NULL,NULL,'2MASX J08432127+4434124',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000152,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,130.838666667,44.57003,0.109,NULL,64251419396,1003928428,15686381,17.4),(56358,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56358,32.38,0.4,30,17407,75,NULL,'B','UGC 04543',NULL,'1988NBGC.C....0000T',1988,1,3.3,NULL,'G',0.000003,NULL,'14.3',1.9,'SAdm','Group member',NULL,NULL,NULL,1,130.841,45.736,0.105,NULL,64285605387,1004462584,15694727,14.3),(56359,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56359,37.79,0.46,361,17408,70,NULL,NULL,'2MASX J08432223+3459461',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000148,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,130.842625,34.99597,0.089,NULL,64363214426,1005675225,15713675,17.8),(56360,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56360,37.36,0.46,296,17409,70,NULL,NULL,'2MASX J08432337+4921367',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,130.8474583,49.36036,0.117,NULL,64229967575,1003593243,15681144,17.1),(56361,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56361,38.01,0.46,400,17410,70,NULL,NULL,'2MASX J08432456+0057056',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000085,NULL,'16.8g',0.34,NULL,NULL,NULL,NULL,NULL,1,130.852167,0.95156,0.113,NULL,62557138184,977455284,15272738,16.8),(56362,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56362,38.38,0.46,473,17411,70,NULL,NULL,'SDSS J084324.59+284914.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000149,NULL,'18.9g',0.11,NULL,NULL,NULL,NULL,NULL,1,130.8525,28.82083,0.129,NULL,64322174256,1005033972,15703655,18.9),(56363,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56363,37.89,0.46,379,17412,70,NULL,NULL,'2MASX J08432492+4248094',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000183,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,130.853917,42.80261,0.113,NULL,64253184736,1003956011,15686812,17.5),(56364,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56364,36.6,0.21,209,17413,70,NULL,NULL,'CGCG 179-021',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000103,NULL,'15.4g',0.45,'BrClG',NULL,NULL,NULL,NULL,1,130.855333333,36.18875,0.089,NULL,64363621795,1005681590,15713774,15.4),(56365,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56365,36.6,0.46,209,17414,70,NULL,NULL,'2MASX J08432945+2242396',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,130.872791667,22.71092,0.101,NULL,63803296325,996926505,15576976,17.4),(56366,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56366,36.61,0.46,210,17415,70,NULL,NULL,'2MASX J08432982+3958073',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00017,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,130.8742917,39.9685,0.129,NULL,64367743642,1005745994,15714781,16.9),(56367,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56367,37.26,0.46,283,17416,70,NULL,NULL,'2MASX J08433008+0318483',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,130.875333,3.31333,0.077,NULL,62551140330,977361567,15271274,17),(56368,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56368,38.34,0.33,465,17417,70,NULL,NULL,'2MASX J08433092+1435343',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000164,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,130.878833,14.59286,0.061,NULL,63853876592,997716821,15589325,17.3),(56369,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56369,36.65,0.46,213,17418,70,NULL,NULL,'2MASX J08433121+2846359',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,130.88025,28.77672,0.117,NULL,64322164362,1005033818,15703653,17.4),(56370,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56370,37.52,0.46,319,17419,70,NULL,NULL,'2MASX J08433137+3042391',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,130.8807917,30.711,0.149,NULL,64314732456,1004917694,15701838,18.1),(56371,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56371,36.72,0.46,221,17420,70,NULL,NULL,'2MASX J08433182+0305103',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000144,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,130.88275,3.08625,0.093,NULL,62551155546,977361805,15271278,17.5),(56372,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56372,37.53,0.46,321,17421,70,NULL,NULL,'2MASX J08433212+2843329',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,130.88375,28.72569,0.117,NULL,64322191989,1005034249,15703660,17.2),(56373,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56373,37.02,0.46,253,17422,70,NULL,NULL,'2MASX J08433258+6225208',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,130.885875,62.42244,0.133,NULL,62053641205,969588143,15149814,17.7),(56374,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56374,37.93,0.33,385,17423,70,NULL,NULL,'2MASX J08433370+1123534',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,130.8905,11.39803,0.129,NULL,63667305894,994801654,15543775,17.9),(56375,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56375,38.22,0.46,442,17424,70,NULL,NULL,'2MASX J08433624+3136021',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000167,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,130.900958333,31.60056,0.105,NULL,64383009818,1005984528,15718508,17.4),(56376,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56376,36.36,0.46,187,17425,70,NULL,NULL,'2MASX J08433633+2210130',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000165,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,130.901583,22.17033,0.093,NULL,63801370898,996896420,15576506,16.7),(56377,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56377,38.58,0.46,519,17426,70,NULL,NULL,'2MASX J08433657+4316564',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,130.902333333,43.28228,0.113,NULL,64253425021,1003959765,15686871,17.5),(56378,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56378,36.84,0.46,234,17427,70,NULL,NULL,'2MASX J08433860+1543574',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,130.9107917,15.7325,0.073,NULL,63848366244,997630722,15587980,17.4),(56379,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56379,36.5,0.64,199,17428,70,NULL,NULL,'2MASX J08433886-1008207',NULL,'2014MNRAS.445.2677S',2014,1,0.28,NULL,'G',0.00015,NULL,'14.7I',0.2,NULL,NULL,NULL,NULL,NULL,1,130.912,-10.13903,0.149,NULL,42177722867,659026919,10297295,14.7),(56380,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56380,36.51,0.46,201,17429,70,NULL,NULL,'2MASX J08433928+3047221',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,130.913791667,30.78939,0.149,NULL,64314675788,1004916809,15701825,16.5),(56381,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56381,33.77,0.12,56.9,17430,NULL,NULL,NULL,'UGC 04554',NULL,'2009ApJS..182..474S',2009,1,0.96,NULL,'G',0.000033,NULL,'15.6g',0.36,'Scd:',NULL,NULL,NULL,NULL,1,130.919875,22.09411,0.089,NULL,63801374544,996896477,15576507,15.6),(56382,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56382,34.14,0.2,67.3,17430,74.4,NULL,NULL,'UGC 04554',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56383,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56383,35.86,0.46,149,17431,70,NULL,NULL,'2MASX J08434086+0819014',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000091,NULL,'17.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,130.920417,8.31711,0.229,NULL,63661014798,994703356,15542239,17.1),(56384,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56384,36.74,0.46,223,17432,70,NULL,NULL,'2MASX J08434436+1430244',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,130.934833,14.50681,0.061,NULL,63853859442,997716553,15589321,17.5),(56385,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56385,37.32,0.46,291,17433,70,NULL,NULL,'SDSS J084346.33+043432.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000118,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,130.943083,4.57556,0.069,NULL,62553462963,977397858,15271841,18.2),(56386,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56386,37.64,0.46,337,17434,70,NULL,NULL,'2MASX J08434665+0506263',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,130.944417,5.10736,0.105,NULL,62550694599,977354603,15271165,17.5),(56387,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56387,34.42,0.71,76.7,17435,70,NULL,NULL,'ESO 018- G 013',NULL,'2014MNRAS.445.2677S',2014,1,1.9,'Marginal HIPASS detection.','G',0.000033,NULL,'12.07',0.7,'SB(s)c',NULL,NULL,NULL,NULL,1,130.952625,-78.94939,0.417,NULL,39996417937,624944030,9764750,12.07),(56388,'IRAS','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56388,34.31,0.8,72.7,17435,75,NULL,'MAT, I','ESO 018- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56389,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56389,33.79,0.43,57.4,17435,75,NULL,'MAT, I, raw','ESO 018- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56390,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56390,33.91,0.32,60.4,17435,85,NULL,'I, raw','ESO 018- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56391,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56391,33.97,0.32,62.2,17435,85,NULL,'I, inv','ESO 018- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56392,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56392,34.06,0.43,65,17435,75,NULL,'MAT, I, inv','ESO 018- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56393,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56393,34.1,0.43,66,17435,75,NULL,'MAT, I, cor','ESO 018- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56394,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56394,34.24,0.38,70.5,17435,NULL,NULL,'Malmquist cor.','ESO 018- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56395,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56395,34.29,0.46,72,17435,NULL,NULL,'J','ESO 018- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56396,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56396,34.33,0.47,73.5,17435,NULL,NULL,'H','ESO 018- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56397,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56397,34.34,0.45,73.8,17435,NULL,NULL,'K','ESO 018- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56398,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56398,34.43,0.4,76.8,17435,NULL,NULL,'mean','ESO 018- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56399,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56399,34.46,0.34,77.9,17435,NULL,NULL,NULL,'ESO 018- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56400,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56400,34.5,0.2,79.4,17435,74.4,NULL,NULL,'ESO 018- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56401,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56401,38.62,0.46,529,17436,70,NULL,NULL,'2MASX J08434888+0830044',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,130.953833333,8.50114,0.229,NULL,63660239254,994691238,15542050,17.8),(56402,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56402,36.96,0.46,247,17437,70,NULL,NULL,'2MASX J08434899+0433533',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000149,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,130.954167,4.56494,0.069,NULL,62553471918,977397998,15271843,17.2),(56403,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56403,37.46,0.21,311,17438,70,NULL,NULL,'SDSS J084349.51+020844.6',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,130.956333333,2.14575,0.141,NULL,62558515685,977476807,15273075,18),(56404,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56404,36.56,0.46,206,17439,70,NULL,NULL,'2MASX J08435086+4204185',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00017,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,130.961708333,42.07169,0.113,NULL,64245522646,1003836291,15684942,16.9),(56405,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56405,33.84,0.69,58.6,17440,100,NULL,'mid-IR','MCG -02-23-001',NULL,'2013ApJ...771...88L',2013,1,1.6,'The NPM1G position is for a superposed star.','G',0.000017,NULL,'14.5',0.9,'SB(r)b:',NULL,NULL,NULL,NULL,1,130.985833,-12.84753,0.233,NULL,42388790666,662324854,10348825,14.5),(56406,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56406,34.7,0.4,87.1,17440,NULL,NULL,'mean','MCG -02-23-001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56407,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56407,34.72,0.47,87.8,17440,NULL,NULL,'H','MCG -02-23-001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56408,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56408,34.77,0.46,89.9,17440,NULL,NULL,'J','MCG -02-23-001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56409,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56409,34.8,0.45,91.2,17440,NULL,NULL,'K','MCG -02-23-001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56410,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56410,37.15,0.46,269,17441,70,NULL,NULL,'2MASX J08435742+3554498',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000188,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,130.9892917,35.91372,0.089,NULL,64363686165,1005682596,15713790,17),(56411,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56411,38.53,0.46,509,17442,70,NULL,NULL,'2MASX J08435833+2747242',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000083,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,130.993041667,27.78994,0.109,NULL,64322465553,1005038524,15703726,17.7),(56412,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56412,37.93,0.33,385,17443,70,NULL,NULL,'2MASX J08435871+1131009',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000172,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,130.994625,11.51692,0.145,NULL,63667247999,994800749,15543761,16.7),(56413,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56413,38.48,0.21,496,17444,70,NULL,NULL,'2MASX J08435998+5126433',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00008,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,130.999833,51.44525,0.081,NULL,63498860292,992169692,15502651,18.2),(56414,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56414,39.48,0.46,786,17445,70,NULL,NULL,'2MASX J08440206+2502242',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000173,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,131.0087917,25.04,0.057,NULL,63788246399,996691349,15573302,18.2),(56415,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56415,38.09,0.46,414,17446,70,NULL,NULL,'SDSS J084402.44+093631.6',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000148,NULL,'18.9g',0.1,NULL,NULL,NULL,NULL,NULL,1,131.010167,9.60881,0.245,NULL,63666013353,994781458,15543460,18.9),(56416,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56416,37.18,0.46,273,17447,70,NULL,NULL,'2MASX J08440301+3108077',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000171,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,131.0125417,31.13556,0.117,NULL,64382866717,1005982292,15718473,16.7),(56417,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56417,38.16,0.46,428,17448,70,NULL,NULL,'2MASX J08440399+4817432',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000077,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,131.016875,48.29544,0.101,NULL,64231192825,1003612387,15681443,17.7),(56418,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56418,36.95,0.46,246,17449,70,NULL,NULL,'2MASX J08440458+3431327',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000189,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,131.019041667,34.52567,0.093,NULL,64416646114,1006510095,15726720,16.5),(56419,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56419,37.46,0.21,311,17450,70,NULL,NULL,'2MASX J08440646+0153469',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000102,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,131.026917,1.89642,0.141,NULL,62558327721,977473870,15273029,16.6),(56420,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56420,37.35,0.46,294,17451,70,NULL,NULL,'2MASX J08440656+5203262',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000066,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,131.0272917,52.05711,0.081,NULL,63487950193,991999221,15499987,17.8),(56421,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56421,37.51,0.46,318,17452,70,NULL,NULL,'2MASX J08440686+5322242',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000083,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,131.028416667,53.3735,0.093,NULL,63488304421,992004756,15500074,17.1),(56422,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56422,36.9,0.46,240,17453,70,NULL,NULL,'2MASX J08440692+3459067',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,131.029,34.98511,0.089,NULL,64363217423,1005675272,15713676,17.2),(56423,'IRAS','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56423,32.56,0.8,32.5,17454,75,NULL,'A82, H','UGC 04559',NULL,'1997ApJS..109..333W',1997,1,4.2,NULL,'G',0.000006,NULL,'14.10',0.67,'Sab',NULL,NULL,NULL,NULL,1,131.0317083,30.11914,0.165,NULL,64313730011,1004902031,15701594,14.1),(56424,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56424,32.33,0.4,29.2,17454,NULL,NULL,'Virgo cluster at 15.6 Mpc','UGC 04559',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56425,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56425,32.44,0.4,30.7,17454,75,NULL,'B','UGC 04559',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56426,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56426,32.77,0.4,35.8,17454,NULL,NULL,'mean','UGC 04559',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56427,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56427,32.79,0.4,36.1,17454,75,NULL,NULL,'UGC 04559',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56428,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56428,32.8,0.47,36.3,17454,75,NULL,'A82, H, raw','UGC 04559',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56429,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56429,32.88,0.47,37.7,17454,75,NULL,'A82, H, inv','UGC 04559',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56430,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56430,33.04,0.47,40.5,17454,75,NULL,'A82, H, cor','UGC 04559',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56431,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56431,33.1,0.58,41.8,17454,NULL,NULL,'Malmquist cor.','UGC 04559',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56432,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56432,33.19,0.55,43.5,17454,NULL,NULL,NULL,'UGC 04559',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56433,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56433,33.2,0.2,43.7,17454,74.4,NULL,NULL,'UGC 04559',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56434,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56434,33.21,0.43,43.9,17454,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04559',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56435,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56435,33.23,0.43,44.2,17454,75,NULL,'3.6 micron, color corrected','UGC 04559',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56436,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56436,33.23,0.47,44.3,17454,NULL,NULL,'H','UGC 04559',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56437,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56437,33.24,0.46,44.4,17454,NULL,NULL,'J','UGC 04559',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56438,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56438,33.24,0.45,44.4,17454,NULL,NULL,'K','UGC 04559',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56439,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56439,33.32,0.49,46.1,17454,75,NULL,'IR','UGC 04559',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56440,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56440,35.72,0.69,139,17455,70,NULL,NULL,'2MASX J08440786-0615530',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,131.0327083,-6.26483,0.061,NULL,42203131141,659423924,10303498,15.3),(56441,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56441,35.03,0.49,101,17456,75,NULL,'IR','UGC 04558',NULL,'2011yCatp016004901K',2011,1,1.87,NULL,'G',0.00003,NULL,'14.9g',0.34,'Sbc',NULL,NULL,NULL,NULL,1,131.037125,33.51572,0.105,NULL,64417138125,1006517783,15726840,14.9),(56442,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56442,35.32,0.4,116,17456,NULL,NULL,'Malmquist cor.','UGC 04558',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56443,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56443,35.47,0.37,124,17456,NULL,NULL,NULL,'UGC 04558',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56444,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56444,35.51,0.2,126,17456,74.4,NULL,NULL,'UGC 04558',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56445,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56445,36.03,0.46,161,17457,70,NULL,NULL,'2MASX J08441074+5358507',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000075,NULL,'16.1g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,131.044708333,53.98075,0.085,NULL,63486694191,991979596,15499681,16.1),(56446,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56446,37.46,0.21,311,17458,70,NULL,NULL,'SDSS J084411.47+020711.3',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000076,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,131.047833333,2.11983,0.129,NULL,62558392422,977474881,15273045,18.7),(56447,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56447,37.22,0.46,278,17459,70,NULL,NULL,'2MASX J08441164+2332043',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000183,NULL,'16.0g',0.45,NULL,NULL,NULL,NULL,NULL,1,131.048625,23.53469,0.057,NULL,63802721565,996917524,15576836,16),(56448,'SNIa','2016-12-15 15:14:24','2016-12-16 11:19:30','1','PS1 SN PS10cbu','N',56448,41.8,0.23,1630,17460,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10cbu HOST',0.4006,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56449,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56449,36.46,0.46,196,17461,70,NULL,NULL,'2MASX J08441716-0025298',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000089,NULL,'16.1g',0.38,'E0',NULL,NULL,NULL,NULL,1,131.071375,-0.42492,0.041,NULL,39198220103,612472189,9569877,16.1),(56450,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56450,36.64,0.66,213,17461,70,NULL,NULL,'2MASX J08441716-0025298',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56451,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56451,38.15,0.46,426,17462,70,NULL,NULL,'2MASX J08441787+4253345',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,131.074333,42.89308,0.113,NULL,64253148511,1003955445,15686803,17.7),(56452,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56452,37.71,0.33,348,17463,70,NULL,NULL,'SDSS J084418.68+225448.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00018,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,131.077833,22.91339,0.069,NULL,63800944266,996889754,15576402,18.7),(56453,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56453,38.48,0.21,496,17464,70,NULL,NULL,'2MASX J08442105+5124217',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000097,NULL,'16.8g',0.36,'BrClG          AGN',NULL,NULL,NULL,NULL,1,131.0877083,51.40592,0.081,NULL,63498647674,992166369,15502599,16.8),(56454,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56454,37.46,0.21,311,17465,70,NULL,NULL,'2MASX J08442147+0155389',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000089,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,131.0895,1.92736,0.141,NULL,62558549233,977477331,15273083,17.9),(56455,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56455,34.22,NULL,69.9,17466,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04565',NULL,'2010Ap&SS.325..163P',2010,1,1.23,NULL,'G',0.000011,NULL,'16.0',0.1,'Scd',NULL,NULL,NULL,NULL,1,131.09125,9.53728,0.229,NULL,63666088806,994782637,15543478,16),(56456,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56456,34.24,NULL,70.5,17466,NULL,NULL,'Dipole + Quadrupole','UGC 04565',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56457,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56457,34.25,NULL,70.7,17466,NULL,NULL,'Dipole','UGC 04565',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56458,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56458,34.36,0.79,74.6,17466,NULL,NULL,'Malmquist cor.','UGC 04565',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56459,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56459,34.47,NULL,78.4,17466,NULL,NULL,NULL,'UGC 04565',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56460,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56460,34.5,0.49,79.5,17466,75,NULL,'IR','UGC 04565',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56461,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56461,34.7,0.43,87,17466,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04565',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56462,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56462,34.7,0.2,87.1,17466,74.4,NULL,NULL,'UGC 04565',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56463,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56463,34.72,0.67,87.7,17466,NULL,NULL,NULL,'UGC 04565',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56464,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56464,34.75,0.43,89.2,17466,75,NULL,'3.6 micron, color corrected','UGC 04565',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56465,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56465,36.64,0.46,213,17467,70,NULL,NULL,'2MASX J08442252+1610415',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000177,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,131.093791667,16.17811,0.077,NULL,63848459113,997632173,15588002,16.6),(56466,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56466,36.72,0.23,221,17468,70,NULL,NULL,'2MASX J08442284+4316339',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,131.0952083,43.27619,0.113,NULL,64252712587,1003948634,15686697,NULL),(56467,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56467,36.27,0.46,180,17469,70,NULL,NULL,'2MASX J08442406+4607379',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000092,NULL,'17.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,131.100417,46.12733,0.101,NULL,64285774706,1004465229,15694769,17.1),(56468,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56468,38.34,0.33,465,17470,70,NULL,NULL,'2MASX J08442419+1432015',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000143,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,131.10075,14.53372,0.061,NULL,63853424652,997709760,15589215,17.9),(56469,'BL Lac Luminosity','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56469,42.8,NULL,3630,17471,70,NULL,'nucleus-to-host flux ratio, z > 2.48','2MASS J08442426+1245464',NULL,'2006AJ....132....1S',2006,1,NULL,'2008A&A...481..327N has z = 2.50.','QSO',0.003,NULL,'18.0',NULL,'DLA;RQQ        BLLAC',NULL,NULL,NULL,'BL Lac',1,131.101083333,12.76289,0.133,NULL,63843753527,997558648,15586853,18),(56470,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56470,37.46,0.21,311,17472,70,NULL,NULL,'2MASX J08442474+0203249',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000097,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,131.103166667,2.05686,0.153,NULL,62558416001,977475250,15273050,16.9),(56471,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56471,38.25,0.46,448,17473,70,NULL,NULL,'2MASX J08442530+4146482',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,131.1055,41.78003,0.105,NULL,64247323950,1003864436,15685381,17.9),(56472,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56472,38.17,0.17,430,17474,70,NULL,NULL,'SDSS J084425.57+292343.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000137,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,131.106583,29.39531,0.161,NULL,64314247226,1004910112,15701720,18.8),(56473,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56473,38.53,0.46,509,17475,70,NULL,NULL,'2MASX J08442581+2424293',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,131.1075417,24.40808,0.049,NULL,63788955720,996702433,15573475,17.5),(56474,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56474,37.11,0.46,264,17476,70,NULL,NULL,'2MASX J08442588+5115238',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000069,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,131.107917,51.25656,0.093,NULL,63498681359,992166896,15502607,17.3),(56475,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56475,38.17,0.17,430,17477,70,NULL,NULL,'2MASX J08442648+2919533',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,131.11025,29.33156,0.145,NULL,64314260645,1004910322,15701723,18.3),(56476,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56476,38.48,0.21,496,17478,70,NULL,NULL,'2MASX J08442650+5123198',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000098,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,131.110541667,51.389,0.081,NULL,63498648062,992166375,15502599,17),(56477,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56477,36.52,0.46,201,17479,70,NULL,NULL,'MCG +09-15-010',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000106,NULL,'15.5g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,131.113,53.48781,0.093,NULL,63488302377,992004724,15500073,15.5),(56478,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56478,35.74,0.46,140,17480,70,NULL,NULL,'CGCG 263-079',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00008,NULL,'15.2g',0.55,'E0',NULL,NULL,NULL,NULL,1,131.115167,55.62853,0.129,NULL,61542152045,961596125,15024939,15.2),(56479,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56479,37.9,0.19,380,17481,70,NULL,NULL,'2MASX J08442786+2723243',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000184,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,131.116167,27.39022,0.097,NULL,64322827643,1005044181,15703815,17),(56480,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56480,38.51,0.46,503,17482,70,NULL,NULL,'2MASX J08442804+3034306',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000197,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,131.11675,30.57506,0.145,NULL,64313630265,1004900472,15701569,17.6),(56481,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56481,37.67,0.27,342,17483,70,NULL,NULL,'SDSS J084429.72+191751.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,131.123875,19.29753,0.073,NULL,63824893213,997263956,15582249,18.3),(56482,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56482,35.05,0.46,102,17484,70,NULL,NULL,'CGCG 061-002',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000177,NULL,'15.5',0.53,NULL,NULL,NULL,NULL,NULL,1,131.125125,11.18267,0.165,NULL,63666999797,994796871,15543701,15.5),(56483,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56483,37.75,0.46,355,17485,70,NULL,NULL,'2MASX J08443008+4658259',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,131.125417,46.97397,0.113,NULL,64282580383,1004415318,15693989,17.6),(56484,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56484,38.37,0.46,472,17486,70,NULL,NULL,'2MASX J08443011+1442005',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,131.1255,14.70039,0.061,NULL,63850545446,997664772,15588512,17.4),(56485,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56485,37.86,0.46,373,17487,70,NULL,NULL,'2MASX J08443024+3231176',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,131.1259583,32.52164,0.093,NULL,64383434311,1005991161,15718611,17.9),(56486,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56486,37.82,0.46,366,17488,70,NULL,NULL,'2MASX J08443032+1546575',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00019,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,131.126333,15.78269,0.073,NULL,63848569926,997633905,15588029,16.7),(56487,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56487,36,0.46,158,17489,70,NULL,NULL,'2MASX J08443068+0217420',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000189,NULL,'15.4g',0.52,'BrClG',NULL,NULL,NULL,NULL,1,131.127917,2.29492,0.129,NULL,62558376449,977474632,15273041,15.4),(56488,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56488,35.18,0.46,109,17490,70,NULL,NULL,'2MASX J08443074+2317442',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000172,NULL,'15.6g',0.47,'E/S0',NULL,NULL,NULL,NULL,1,131.128166667,23.29561,0.053,NULL,63802923609,996920681,15576885,15.6),(56489,'IRAS','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56489,33.47,0.8,49.4,17491,75,NULL,'MAT, I','ESO 563- G 017',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000027,NULL,'14',1,'SA(rs)a?       HII',NULL,NULL,NULL,NULL,1,131.129,-20.3505,0.429,NULL,42233018817,659890919,10310795,14),(56490,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56490,33.44,0.47,48.9,17491,NULL,NULL,'H','ESO 563- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56491,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56491,33.45,0.46,49,17491,NULL,NULL,'J','ESO 563- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56492,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56492,33.47,0.45,49.3,17491,NULL,NULL,'K','ESO 563- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56493,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56493,33.61,0.4,52.8,17491,NULL,NULL,'mean','ESO 563- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56494,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56494,33.68,0.43,54.4,17491,75,NULL,'MAT, I, raw','ESO 563- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56495,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56495,33.76,0.47,56.5,17491,NULL,NULL,NULL,'ESO 563- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56496,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56496,33.82,0.46,58.2,17491,NULL,NULL,'Malmquist cor.','ESO 563- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56497,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56497,33.83,0.32,58.3,17491,85,NULL,'I, raw','ESO 563- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56498,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56498,33.86,0.2,59.2,17491,74.4,NULL,NULL,'ESO 563- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56499,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56499,33.91,0.32,60.4,17491,85,NULL,'I, inv','ESO 563- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56500,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56500,33.94,0.43,61.5,17491,75,NULL,'3.6 micron, color corrected','ESO 563- G 017',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56501,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56501,33.98,0.43,62.6,17491,75,NULL,'MAT, I, cor','ESO 563- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56502,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56502,33.98,0.43,62.6,17491,75,NULL,'3.6 micron, color + selection bias corrected','ESO 563- G 017',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56503,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56503,33.99,0.43,62.9,17491,75,NULL,'MAT, I, inv','ESO 563- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56504,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56504,37.88,0.33,377,17492,70,NULL,NULL,'2MASX J08443117+1017091',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,131.1299583,10.28603,0.189,NULL,63669192586,994831134,15544236,17.2),(56505,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56505,37.9,0.19,380,17493,70,NULL,NULL,'SDSS J084432.06+273720.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000136,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,131.133583333,27.62239,0.097,NULL,64322421896,1005037842,15703716,18.5),(56506,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56506,34.72,0.49,87.8,17494,75,NULL,'IR','CGCG 061-003',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000086,NULL,'16.1g',0.2,'Scd',NULL,NULL,NULL,NULL,1,131.1347917,9.16592,0.213,NULL,63658297614,994660900,15541576,16.1),(56507,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56507,34.37,0.2,74.8,17495,74.4,NULL,NULL,'CGCG 061-003',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000086,NULL,'16.1g',0.2,'Scd',NULL,NULL,NULL,NULL,1,131.1347917,9.16592,0.213,NULL,63658297614,994660900,15541576,16.1),(56508,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56508,36.77,0.46,226,17496,70,NULL,NULL,'2MASX J08443241+2837093',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000185,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,131.135,28.61933,0.117,NULL,64322692758,1005042074,15703782,16.2),(56509,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56509,37.71,0.33,348,17497,70,NULL,NULL,'2MASX J08443244+2255112',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000183,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,131.135208333,22.91975,0.069,NULL,63800945143,996889767,15576402,16.4),(56510,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56510,38.37,0.33,471,17498,70,NULL,NULL,'2MASX J08443343+2606153',NULL,'2015arXiv151105856S',2015,1,0.44,'TXS codes: model(W);confusion(C);lobes(W)','G',0.000188,NULL,'16.8g',0.29,'BrClG',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,131.139167,26.10419,0.105,NULL,64310027251,1004844175,15700690,16.8),(56511,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56511,37.66,0.46,340,17499,70,NULL,NULL,'2MASX J08443351+2917343',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,131.139666667,29.29297,0.145,NULL,64314258169,1004910283,15701723,17.7),(56512,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56512,37.46,0.46,311,17500,70,NULL,NULL,'2MASX J08443544+5513007',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000069,NULL,'17.6g',0.16,'NLAGN',NULL,NULL,NULL,NULL,1,131.147875,55.21681,0.113,NULL,61542379392,961599678,15024994,17.6),(56513,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56513,36.68,0.33,216,17501,70,NULL,NULL,'2MASX J08443625+4910418',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000078,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,131.151333,49.17839,0.117,NULL,64230978803,1003609043,15681391,18),(56514,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56514,38.17,0.17,430,17502,70,NULL,NULL,'2MASX J08443650+2921123',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000197,NULL,'16.9g',0.3,'BrClG;E',NULL,NULL,NULL,NULL,1,131.1522083,29.35353,0.145,NULL,64314254635,1004910228,15701722,16.9),(56515,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56515,36.96,0.46,247,17503,70,NULL,NULL,'2MASX J08443662+2857123',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000141,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,131.1525,28.95353,0.145,NULL,64313963626,1004905681,15701651,17.7),(56516,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56516,36.72,0.23,221,17504,70,NULL,NULL,'SDSS J084436.77+430706.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,131.153208333,43.11853,0.113,NULL,64252684135,1003948189,15686690,18),(56517,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56517,37.93,0.46,385,17505,70,NULL,NULL,'2MASX J08443724+1620545',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000176,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,131.155291667,16.34839,0.077,NULL,63848581536,997634086,15588032,17.5),(56518,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56518,35.14,0.46,107,17506,70,NULL,NULL,'CGCG 179-024',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000087,NULL,'15.5g',0.35,'Sa;LINER       Sy',NULL,NULL,NULL,NULL,1,131.157541667,32.90644,0.105,NULL,64417043988,1006516312,15726817,15.5),(56519,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56519,35.14,0.27,106,17507,70,NULL,NULL,'CGCG 263-080',NULL,'2015arXiv151105856S',2015,1,1.17,NULL,'G',0.000097,NULL,'14.2g',0.69,'E0','Group member',NULL,NULL,NULL,1,131.1584583,55.01892,0.109,NULL,61541300355,961582818,15024731,14.2),(56520,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56520,37.65,0.46,339,17508,70,NULL,NULL,'2MASX J08443874+2629223',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000146,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,131.1615,26.48956,0.113,NULL,64309791760,1004840496,15700632,17.8),(56521,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56521,37.3,0.46,289,17509,70,NULL,NULL,'2MASX J08443914+2427053',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000175,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,131.163125,24.45142,0.077,NULL,63788947243,996702300,15573473,16.8),(56522,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56522,37.88,0.33,377,17510,70,NULL,NULL,'SDSS J084439.54+101542.9',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,131.16475,10.26194,0.189,NULL,63669206218,994831347,15544239,NULL),(56523,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56523,38.37,0.33,471,17511,70,NULL,NULL,'2MASX J08444027+2610483',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000137,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,131.167917,26.18,0.105,NULL,64309813899,1004840842,15700638,18.6),(56524,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56524,37.12,0.46,265,17512,70,NULL,NULL,'2MASXi J0844404+253925',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000142,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,131.168583,25.65683,0.125,NULL,64309363584,1004833806,15700528,17.7),(56525,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56525,38.48,0.21,496,17513,70,NULL,NULL,'2MASX J08444145+5120508',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000079,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,131.172625,51.34744,0.093,NULL,63498646401,992166350,15502599,18.3),(56526,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56526,38.24,0.46,445,17514,70,NULL,NULL,'2MASX J08444268+5820067',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,131.177625,58.33539,0.181,NULL,62021042077,969078782,15141855,18.5),(56527,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56527,33.98,0.24,62.5,17515,NULL,NULL,'Malmquist cor.','UGC 04567',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000033,NULL,'15.50',0.2,'S?',NULL,NULL,NULL,NULL,1,131.1777083,9.80086,0.197,NULL,63666006079,994781344,15543458,15.5),(56528,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56528,34.31,0.2,72.8,17515,NULL,NULL,NULL,'UGC 04567',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56529,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56529,34.35,0.2,74.1,17515,74.4,NULL,NULL,'UGC 04567',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56530,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56530,37.42,0.46,305,17516,70,NULL,NULL,'2MASX J08444269+2405363',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000181,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,131.178125,24.0935,0.049,NULL,63788446781,996694480,15573351,17.1),(56531,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56531,32.88,0.49,37.7,17517,75,NULL,'IR','UGC 04568',NULL,'2011yCatp016004901K',2011,1,1.6,NULL,'G',0.000017,NULL,'14.65',0.4,'Irr','Isolated galaxy',NULL,NULL,NULL,1,131.1810417,10.47203,0.189,NULL,63669265873,994832279,15544254,14.65),(56532,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56532,34.94,0.5,97.1,17518,70,NULL,NULL,'2MASX J08444379-0528285',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00009,NULL,'16.45',0.8,NULL,NULL,NULL,NULL,NULL,1,131.1822917,-5.47467,0.077,NULL,42148707712,658573558,10290211,16.45),(56533,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56533,37.34,0.46,294,17519,70,NULL,NULL,'SDSS J084444.40+361712.6',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,131.185,36.28683,0.093,NULL,64362770304,1005668286,15713566,17.5),(56534,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56534,38.48,0.21,496,17520,70,NULL,NULL,'2MASX J08444445+5122598',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000079,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,131.1854583,51.38333,0.081,NULL,63498649321,992166395,15502599,18.2),(56535,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56535,39.03,0.46,639,17521,70,NULL,NULL,'2MASX J08444601+3059017',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,131.1917083,30.98397,0.105,NULL,64382841587,1005981899,15718467,18.4),(56536,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56536,36.58,0.46,207,17522,70,NULL,NULL,'2MASX J08444691+0516000',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000152,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,131.1954583,5.26672,0.105,NULL,62550246489,977347601,15271056,16.5),(56537,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56537,37.57,0.46,326,17523,70,NULL,NULL,'2MASX J08444773+0935462',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000178,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,131.19875,9.59628,0.193,NULL,63666065575,994782274,15543473,17.3),(56538,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56538,38.38,0.46,474,17524,70,NULL,NULL,'2MASX J08444783+1910243',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00017,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,131.199333,19.17328,0.073,NULL,63824924269,997264441,15582256,17.5),(56539,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56539,38.54,0.46,510,17525,70,NULL,NULL,'2MASX J08444868+0841587',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00018,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,131.202917,8.69958,0.229,NULL,63658391185,994662362,15541599,17.4),(56540,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56540,36.72,0.23,221,17526,70,NULL,NULL,'2MASX J08444906+4256419',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000172,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,131.2045,42.94503,0.113,NULL,64253133134,1003955205,15686800,16.8),(56541,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56541,36.08,0.46,164,17527,70,NULL,NULL,'2MASX J08444917+5325227',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000077,NULL,'16.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,131.205125,53.42297,0.093,NULL,63489002376,992015662,15500244,16.3),(56542,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56542,38.31,0.17,459,17528,70,NULL,NULL,'2MASX J08445036+2741038',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,131.209917,27.68433,0.109,NULL,64322498168,1005039033,15703734,18),(56543,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56543,37.97,0.46,392,17529,70,NULL,NULL,'2MASX J08445047+1047177',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,131.2102083,10.78833,0.169,NULL,63666946831,994796044,15543688,17.7),(56544,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56544,37.9,0.19,380,17530,70,NULL,NULL,'2MASX J08445181+2732568',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000083,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,131.2160417,27.54903,0.097,NULL,64322487422,1005038865,15703732,17.4),(56545,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56545,35.68,0.27,137,17531,70,NULL,NULL,'2MASX J08445203+4121295',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000163,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,131.2167917,41.35836,0.093,NULL,64246911106,1003857986,15685281,16.7),(56546,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56546,35.38,0.5,119,17532,70,NULL,NULL,'2MASX J08445266-1000590',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.79',NULL,NULL,NULL,NULL,NULL,NULL,1,131.2195,-10.01653,0.149,NULL,42174385792,658974778,10296480,15.79),(56547,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56547,35.14,0.27,106,17533,70,NULL,NULL,'MCG +09-15-013',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000087,NULL,'15.7g',0.31,'BLAGN',NULL,NULL,NULL,'Sy 1',1,131.223083,55.05403,0.109,NULL,61542397807,961599965,15024999,15.7),(56548,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56548,35.05,0.2,102,17534,74.4,NULL,NULL,'UGC 04562',NULL,'2013AJ....146...86T',2013,1,1.11,NULL,'G',0.000075,NULL,'14.9g',0.61,'SB(s)c',NULL,NULL,NULL,NULL,1,131.229917,47.74581,0.097,NULL,64227663570,1003557243,15680581,14.9),(56549,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56549,36.72,0.23,221,17535,70,NULL,NULL,'CGCG 208-042',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.00018,NULL,'15.0g',0.61,'E0',NULL,NULL,NULL,NULL,1,131.2359583,42.97658,0.113,NULL,64253395134,1003959298,15686864,15),(56550,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56550,37.15,0.55,270,17536,70,NULL,NULL,'2MASX J08445813-1004370',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.17',0.5,NULL,NULL,NULL,NULL,NULL,1,131.242167,-10.077,0.149,NULL,42174383123,658974736,10296480,16.17),(56551,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56551,37.63,0.46,336,17537,70,NULL,NULL,'FBQS J084458.3+305638',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000174,NULL,'18.5g',0.12,'Sy?',NULL,NULL,NULL,'Sy ?',1,131.242917,30.94397,0.105,NULL,64382834865,1005981794,15718465,18.5),(56552,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56552,37.28,0.46,286,17538,70,NULL,NULL,'2MASX J08445866+1540066',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000175,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,131.244458333,15.66853,0.073,NULL,63848426479,997631663,15587994,16.8),(56553,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56553,36.2,0.46,174,17539,70,NULL,NULL,'2MASX J08445945+0946418',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000182,NULL,'15.6g',0.5,'S0',NULL,NULL,NULL,NULL,1,131.2477083,9.77825,0.197,NULL,63666052795,994782074,15543469,15.6),(56554,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56554,38.31,0.17,459,17540,70,NULL,NULL,'2MASX J08445976+2749039',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,131.248917,27.81772,0.109,NULL,64322445579,1005038212,15703722,18),(56555,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56555,38.31,0.17,459,17541,70,NULL,NULL,'2MASX J08450082+2747209',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000083,NULL,'16.7g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,131.253375,27.78911,0.109,NULL,64322474982,1005038671,15703729,16.7),(56556,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56556,36.68,0.33,216,17542,70,NULL,NULL,'KUG 0841+494',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.84',0.2,'Spiral',NULL,NULL,NULL,NULL,1,131.2537083,49.31231,0.117,NULL,64229810378,1003590787,15681106,16.84),(56557,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56557,35.09,0.5,104,17543,70,NULL,NULL,'2MASX J08450125-7233090',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000117,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,131.255417,-72.55247,0.541,NULL,40621321539,634708149,9917314,16),(56558,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56558,37.73,0.33,352,17544,70,NULL,NULL,'2MASX J08450175+0217480',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,131.2572083,2.29667,0.129,NULL,62558830603,977481728,15273152,17.5),(56559,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56559,38.17,0.46,430,17545,70,NULL,NULL,'2MASX J08450229+1906342',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000179,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,131.259375,19.10956,0.073,NULL,63824807236,997262613,15582228,18.1),(56560,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56560,36.19,0.57,173,17546,70,NULL,NULL,'2MASX J08450297-0937271',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.24',0.5,NULL,NULL,NULL,NULL,NULL,1,131.262417,-9.62425,0.117,NULL,42174077749,658969964,10296405,16.24),(56561,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56561,38.51,0.46,503,17547,70,NULL,NULL,'2MASX J08450412+4341081',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00017,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,131.267083333,43.68575,0.117,NULL,64252783306,1003949739,15686714,16.8),(56562,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56562,37.67,0.27,342,17548,70,NULL,NULL,'2MASX J08450416+1924212',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000174,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,131.267375,19.40594,0.053,NULL,63825638621,997275603,15582431,17.5),(56563,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56563,36.7,0.21,219,17549,70,NULL,NULL,'MCG +08-16-026',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000169,NULL,'15.9g',0.3,'Ellip          AGN',NULL,NULL,NULL,NULL,1,131.2755,44.58869,0.109,NULL,64250523273,1003914426,15686162,15.9),(56564,'D-Sigma','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56564,31.94,0.4,24.4,17550,75,NULL,'Edat, raw','NGC 2663',NULL,'1997ApJS..109..333W',1997,1,3.5,NULL,'G',0.000087,NULL,'11.86',2.4,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,131.284375,-33.79475,NULL,NULL,42933274961,670832421,10481756,11.86),(56565,'D-Sigma','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56565,32.27,0.4,28.5,17550,75,NULL,'Edat, cor','NGC 2663',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56566,'Tully est','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56566,32.35,0.8,29.6,17550,75,NULL,NULL,'NGC 2663',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56567,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56567,35.14,0.27,106,17551,70,NULL,NULL,'CGCG 263-082',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000074,NULL,'15.3g',0.5,'E0','Group member',NULL,NULL,NULL,1,131.28775,54.97831,0.109,NULL,61542383839,961599747,15024996,15.3),(56568,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56568,37.01,0.46,252,17552,70,NULL,NULL,'2MASX J08451114+3307024',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,131.296375,33.11742,0.105,NULL,64417056118,1006516501,15726820,17.3),(56569,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56569,37.34,0.33,293,17553,70,NULL,NULL,'2MASX J08451203+0202290',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000087,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,131.300167,2.04119,0.153,NULL,62561908454,977529819,15273903,17.2),(56570,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56570,36.95,0.46,245,17554,70,NULL,NULL,'2MASX J08451211+3541494',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000196,NULL,'16.2g',0.33,'E0',NULL,NULL,NULL,NULL,1,131.3002917,35.69697,0.081,NULL,64363560517,1005680633,15713759,16.2),(56571,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56571,37.67,0.46,342,17555,70,NULL,NULL,'2MASX J08451236+2900499',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,131.301583333,29.01389,0.145,NULL,64314216294,1004909629,15701712,18.2),(56572,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56572,37.74,0.46,354,17556,70,NULL,NULL,'SDSS J084513.24+574651.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,131.305167,57.78106,0.193,NULL,62019073924,969048030,15141375,18.4),(56573,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56573,37.73,0.46,351,17557,70,NULL,NULL,'2MASX J08451367+5745065',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,131.3072917,57.75172,0.185,NULL,62019075591,969048056,15141375,17.8),(56574,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56574,33.95,0.36,61.6,17558,NULL,NULL,'Malmquist cor.','NGC 2657',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'13.61',1.3,'SA(rs)d:',NULL,NULL,NULL,NULL,1,131.315875,9.6455,0.193,NULL,63666042206,994781909,15543467,13.61),(56575,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56575,34.04,0.34,64.2,17558,NULL,NULL,NULL,'NGC 2657',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56576,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56576,34.08,0.2,65.5,17558,74.4,NULL,NULL,'NGC 2657',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56577,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56577,37.67,0.27,342,17559,70,NULL,NULL,'2MASX J08451606+1926204',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000149,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,131.3170417,19.43906,0.053,NULL,63825628223,997275440,15582428,17.8),(56578,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56578,37.9,0.19,380,17560,70,NULL,NULL,'2MASX J08451619+2743539',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,131.317583333,27.73158,0.109,NULL,64322530377,1005039537,15703742,17.1),(56579,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56579,37.06,0.46,258,17561,70,NULL,NULL,'2MASX J08451664+0929249',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000174,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,131.319375,9.49031,0.193,NULL,63666072728,994782386,15543474,16.5),(56580,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56580,33.62,0.43,53,17562,75,NULL,'3.6 micron, color + selection bias corrected','IC 0499',NULL,'2014MNRAS.444..527S',2014,1,2.1,NULL,'G',0.00016,NULL,'13.37',1.3,'Sa','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,131.322083,85.74003,0.237,NULL,61264249432,957253897,14957092,13.37),(56581,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56581,38.03,0.46,403,17563,70,NULL,NULL,'SDSS J084517.83+303027.4',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.2g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,131.324333,30.50761,0.145,NULL,64313663021,1004900984,15701577,17.2),(56582,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56582,35.68,0.27,137,17564,70,NULL,NULL,'2MASX J08451843+4128365',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000169,NULL,'16.1g',0.4,'S0/a',NULL,NULL,NULL,NULL,1,131.32675,41.47675,0.093,NULL,64247430097,1003866095,15685407,16.1),(56583,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56583,37.73,0.33,352,17565,70,NULL,NULL,'2MASX J08451850+0205020',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000088,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,131.327083,2.08383,0.153,NULL,62561899590,977529681,15273901,17.9),(56584,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56584,36.53,0.46,202,17566,70,NULL,NULL,'2MASX J08451946+4116205',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000189,NULL,'15.7g',0.41,'E0',NULL,NULL,NULL,NULL,1,131.330917,41.27236,0.093,NULL,64247367818,1003865122,15685392,15.7),(56585,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56585,38.31,0.17,459,17567,70,NULL,NULL,'2MASX J08451995+2740299',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000983,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,131.333083,27.67497,0.109,NULL,64322533225,1005039581,15703743,18.2),(56586,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56586,36.7,0.21,219,17568,70,NULL,NULL,'2MASX J08452057+4430321',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000107,NULL,'15.48',0.46,'E;BrClG','Compact group member',NULL,NULL,NULL,1,131.3357917,44.50894,0.105,NULL,64250548680,1003914823,15686169,15.48),(56587,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56587,37.34,0.33,293,17569,70,NULL,NULL,'2MASX J08452077+0200140',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000103,NULL,'16.3g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,131.336667,2.00397,0.153,NULL,62561895684,977529620,15273900,16.3),(56588,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56588,38.31,0.17,459,17570,70,NULL,NULL,'2MASX J08452091+2732159',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000185,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,131.337167,27.53778,0.097,NULL,64322491007,1005038921,15703733,17),(56589,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56589,37.08,0.46,261,17571,70,NULL,NULL,'2MASX J08452161+1125543',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',NULL,NULL,'17.18',0.4,NULL,NULL,NULL,NULL,NULL,1,131.340083,11.43181,0.145,NULL,63662593187,994728018,15542625,17.18),(56590,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56590,38.31,0.17,459,17572,70,NULL,NULL,'2MASX J08452169+2744463',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,131.34025,27.74614,0.109,NULL,64322530135,1005039533,15703742,18),(56591,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56591,38.31,0.17,459,17573,70,NULL,NULL,'2MASX J08452299+2737554',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000201,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,131.345791667,27.632,0.097,NULL,64322522093,1005039407,15703740,17.7),(56592,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56592,36.7,0.21,219,17574,70,NULL,NULL,'2MASX J08452308+4423311',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000177,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,131.346083,44.39197,0.105,NULL,64250560106,1003915001,15686171,16.9),(56593,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56593,37.41,0.46,304,17575,70,NULL,NULL,'2MASX J08452494+5103064',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000059,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,131.353833,51.05175,0.085,NULL,63494437396,992100584,15501571,17.7),(56594,'SNIa','2016-12-15 15:14:24','2016-12-16 11:19:30','1','PS1 SN PS10bzu','N',56594,40.92,0.17,1130,17576,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10bzu HOST',0.3506,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56595,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56595,38,0.46,398,17577,70,NULL,NULL,'2MASX J08452599+1332324',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,131.358291667,13.54228,0.085,NULL,63852462944,997694733,15588980,16.6),(56596,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56596,36.7,0.21,219,17578,70,NULL,NULL,'2MASX J08452601+4442001',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000168,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,131.358458333,44.69992,0.089,NULL,64283098889,1004423420,15694115,16.7),(56597,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56597,36.3,0.33,182,17579,70,NULL,NULL,'2MASX J08452634+2121414',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.45',0.25,NULL,NULL,NULL,NULL,NULL,1,131.3597083,21.36142,0.089,NULL,63797248759,996832011,15575500,17.45),(56598,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56598,37.88,0.46,377,17580,70,NULL,NULL,'2MASX J08452672+2004574',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00019,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,131.361416667,20.08264,0.069,NULL,63825278921,997269983,15582343,17),(56599,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56599,38.24,0.46,445,17581,70,NULL,NULL,'2MASX J08452678+6232066',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,131.3617917,62.53508,0.133,NULL,62053092989,969579577,15149680,18.7),(56600,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56600,37.82,0.46,367,17582,70,NULL,NULL,'SDSS J084526.87+301955.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000148,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,131.362,30.33211,0.165,NULL,64313836550,1004903696,15701620,18.7),(56601,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56601,36.23,0.53,176,17583,70,NULL,NULL,'CGCG 005-006',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000067,NULL,'15.6',0.8,NULL,NULL,NULL,NULL,NULL,1,131.369167,-2.47828,0.057,NULL,39208019838,612625309,9572270,15.6),(56602,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56602,36.89,0.46,239,17584,70,NULL,NULL,'VII Zw 250',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.9',0.31,NULL,NULL,NULL,NULL,NULL,1,131.371875,60.18436,0.161,NULL,62067212804,969800200,15153128,17.9),(56603,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56603,37.38,0.33,299,17585,70,NULL,NULL,'2MASX J08452993+5506225',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000085,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,131.3745417,55.10633,0.109,NULL,61542391344,961599864,15024997,17.2),(56604,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56604,37.86,0.46,373,17586,70,NULL,NULL,'2MASX J08453160+2759514',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000097,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,131.381667,27.99775,0.161,NULL,64322355389,1005036802,15703700,17.6),(56605,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56605,37.61,0.46,333,17587,70,NULL,NULL,'2MASX J08453161+4036437',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,131.381875,40.61208,0.081,NULL,64246765488,1003855710,15685245,18.2),(56606,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56606,38.08,0.33,413,17588,70,NULL,NULL,'2MASX J08453179+0228336',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000185,NULL,'16.4g',0.37,'AGN',NULL,NULL,NULL,NULL,1,131.382458333,2.47586,0.129,NULL,62561573080,977524579,15273821,16.4),(56607,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56607,38.03,0.46,404,17589,70,NULL,NULL,'2MASX J08453227+1458354',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,131.384583333,14.97658,0.057,NULL,63850721677,997667526,15588555,17.3),(56608,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56608,37.63,0.46,336,17590,70,NULL,NULL,'2MASX J08453243+2053064',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000178,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,131.385125,20.88525,0.085,NULL,63797163554,996830680,15575479,17),(56609,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56609,35.9,0.53,152,17591,70,NULL,NULL,'2MASX J08453265-1044134',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.06',0.7,NULL,NULL,NULL,NULL,NULL,1,131.385916667,-10.73708,0.141,NULL,42177175228,659018362,10297161,16.06),(56610,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56610,37.22,0.46,278,17592,70,NULL,NULL,'2MASX J08453509+1856273',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,131.396,18.941,0.081,NULL,63824797197,997262456,15582225,17.7),(56611,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56611,38.17,0.17,430,17593,70,NULL,NULL,'2MASX J08453537+2918474',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,131.397333,29.31319,0.145,NULL,64314241802,1004910028,15701719,18),(56612,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56612,37.59,0.46,329,17594,70,NULL,NULL,'2MASX J08453619+0303386',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000175,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,131.400833,3.06061,0.081,NULL,62558569344,977477646,15273088,16.5),(56613,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56613,37.19,0.46,275,17595,70,NULL,NULL,'2MASX J08453642+2328513',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00018,NULL,'16.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,131.4017917,23.48108,0.053,NULL,63802713451,996917397,15576834,16.2),(56614,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56614,38.55,0.46,513,17596,70,NULL,NULL,'SDSS J084536.80+412313.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000124,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,131.403333,41.38706,0.093,NULL,64247370902,1003865170,15685393,18.7),(56615,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56615,35.96,0.46,156,17597,70,NULL,NULL,'2MASX J08453741+4021027',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000173,NULL,'15.5g',0.5,'E0',NULL,NULL,NULL,NULL,1,131.4059583,40.35083,0.081,NULL,64246729523,1003855148,15685236,15.5),(56616,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56616,38.82,0.33,581,17598,70,NULL,NULL,'2MASX J08453748+2824384',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,131.40625,28.41072,0.161,NULL,64322737474,1005042773,15703793,18.3),(56617,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56617,37.46,0.46,311,17599,70,NULL,NULL,'2MASX J08453908+1111233',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,131.4127917,11.18994,0.165,NULL,63662604911,994728201,15542628,17.8),(56618,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56618,36.58,0.42,207,17600,NULL,NULL,'Malmquist cor.','UGC 04575',NULL,'2009ApJS..182..474S',2009,1,1.16,NULL,'G',0.00003,NULL,'15.4g',0.38,'Sb',NULL,NULL,NULL,NULL,1,131.415167,23.86881,0.081,NULL,63788324527,996692570,15573321,15.4),(56619,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56619,36.75,0.39,224,17600,NULL,NULL,NULL,'UGC 04575',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56620,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56620,37.05,0.2,257,17600,74.4,NULL,NULL,'UGC 04575',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56621,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56621,38.06,0.46,409,17601,70,NULL,NULL,'2MASX J08454133+0958063',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1E',NULL,NULL,NULL,NULL,NULL,NULL,1,131.42225,9.96842,0.197,NULL,63666135619,994783369,15543490,17.1),(56622,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56622,38.65,0.46,537,17602,70,NULL,NULL,'SDSS J084541.41+293733.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000139,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,131.422583333,29.62594,0.161,NULL,64314319095,1004911235,15701738,18.8),(56623,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56623,35.68,0.27,137,17603,70,NULL,NULL,'CGCG 208-044',NULL,'2015arXiv151105856S',2015,1,0.99,NULL,'G',0.000153,NULL,'14.8g',0.55,'E0',NULL,NULL,NULL,NULL,1,131.423375,41.28286,0.093,NULL,64247380550,1003865321,15685395,14.8),(56624,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56624,37.93,0.46,385,17604,70,NULL,NULL,'SDSS J084541.76+121007.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,131.424041667,12.16867,0.153,NULL,63662389897,994724842,15542575,18.4),(56625,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56625,38.03,0.46,403,17605,70,NULL,NULL,'2MASX J08454181+3124518',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000166,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,131.424291667,31.4145,0.093,NULL,64382941013,1005983453,15718491,17.1),(56626,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56626,37.31,0.46,290,17606,70,NULL,NULL,'2MASX J08454207+5103337',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000083,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,131.4255,51.0595,0.085,NULL,63494426512,992100414,15501568,17.4),(56627,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56627,38.08,0.33,413,17607,70,NULL,NULL,'SDSS J084545.46+023419.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000157,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,131.439417,2.57197,0.129,NULL,62561688419,977526381,15273849,18.7),(56628,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56628,37.63,0.46,335,17608,70,NULL,NULL,'2MASX J08454610+1928406',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000096,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,131.442,19.47781,0.053,NULL,63825618732,997275292,15582426,17.7),(56629,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56629,37.88,0.46,377,17609,70,NULL,NULL,'SDSS J084546.85+222054.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,131.44525,22.34839,0.081,NULL,63801502825,996898481,15576538,18.5),(56630,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56630,38.17,0.17,430,17610,70,NULL,NULL,'2MASX J08454707+2916174',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'17.3g',0.23,'S0',NULL,NULL,NULL,NULL,1,131.446166667,29.27167,0.145,NULL,64314238293,1004909973,15701718,17.3),(56631,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56631,38.2,0.46,436,17611,70,NULL,NULL,'2MASX J08454761+4003387',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,131.4485,40.06069,0.077,NULL,64367604595,1005743821,15714747,17.8),(56632,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56632,37.37,0.46,297,17612,70,NULL,NULL,'2MASX J08454946+5114198',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000072,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,131.456083,51.23883,0.093,NULL,63487096647,991985885,15499779,17.7),(56633,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56633,36.7,0.21,219,17613,70,NULL,NULL,'2MASX J08454965+4433035',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000197,NULL,'15.8g',0.37,'E0',NULL,NULL,NULL,NULL,1,131.456875,44.55092,0.089,NULL,64283109657,1004423588,15694118,15.8),(56634,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56634,35.76,0.33,142,17614,70,NULL,NULL,'CGCG 264-012 NED02',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000078,NULL,'16.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,131.463291667,54.00219,0.085,NULL,63488770982,992012046,15500188,16.5),(56635,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56635,37.9,0.19,380,17615,70,NULL,NULL,'2MASX J08455402+2749076',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000175,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,131.4752083,27.81886,0.141,NULL,64322478393,1005038724,15703730,18),(56636,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56636,38.74,0.46,559,17616,70,NULL,NULL,'SDSS J084554.99+244058.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,131.479125,24.68292,0.065,NULL,63789069219,996704206,15573503,18.7),(56637,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56637,37.71,0.46,348,17617,70,NULL,NULL,'2MASX J08455573+2902396',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,131.482167,29.04433,0.145,NULL,64313504686,1004898510,15701539,17.9),(56638,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56638,38.35,0.33,468,17618,70,NULL,NULL,'SDSS J084556.68+301541.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,131.486208333,30.26158,0.117,NULL,64313771679,1004902682,15701604,18.6),(56639,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56639,38.17,0.17,430,17619,70,NULL,NULL,'2MASX J08455860+2918486',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000186,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,131.494167,29.31358,0.145,NULL,64314230983,1004909859,15701716,16.7),(56640,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56640,38.14,0.46,424,17620,70,NULL,NULL,'2MASX J08460041+2848516',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,131.501833,28.81444,0.145,NULL,64321819735,1005028433,15703569,17.8),(56641,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56641,36.76,0.27,225,17621,70,NULL,NULL,'2MASX J08460064+3034028',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,131.502667,30.56756,0.113,NULL,64384167948,1006002624,15718791,17),(56642,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56642,38.12,0.46,420,17622,70,NULL,NULL,'SDSS J084601.33+175903.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000139,NULL,'18.3g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,131.505583,17.98436,0.057,NULL,63880186149,998127908,15595748,18.3),(56643,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56643,37.86,0.46,373,17623,70,NULL,NULL,'2MASX J08460178+0030274',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000082,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,131.507417,0.50775,0.097,NULL,62555862640,977435353,15272427,17.1),(56644,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56644,38.15,0.46,427,17624,70,NULL,NULL,'SDSS J084602.48+251229.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00015,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,131.510333,25.20817,0.077,NULL,64309231638,1004831744,15700496,18.6),(56645,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56645,37.38,0.33,299,17625,70,NULL,NULL,'2MASX J08460245+5504415',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000069,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,131.510375,55.07828,0.109,NULL,61542460907,961600951,15025014,17.4),(56646,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56646,38.82,0.33,581,17626,70,NULL,NULL,'SDSS J084604.14+282010.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000162,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,131.517291667,28.33633,0.161,NULL,64322742258,1005042847,15703794,18.6),(56647,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56647,35.76,0.33,142,17627,70,NULL,NULL,'2MASX J08460491+5359395',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000088,NULL,'16.0g',0.34,'E0',NULL,NULL,NULL,NULL,1,131.5205,53.99436,0.085,NULL,63488741531,992011586,15500181,16),(56648,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56648,37.59,0.46,329,17628,70,NULL,NULL,'SDSS J084605.32+260510.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000156,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,131.5222083,26.08619,0.105,NULL,64309972693,1004843323,15700676,18.6),(56649,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56649,38.17,0.17,430,17629,70,NULL,NULL,'2MASX J08460555+2921097',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,131.523083,29.35278,0.145,NULL,64314232126,1004909876,15701716,17.8),(56650,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56650,37.9,0.19,380,17630,70,NULL,NULL,'SDSS J084608.70+275620.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000159,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,131.53625,27.93911,0.141,NULL,64322371109,1005037048,15703703,18.7),(56651,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56651,37.8,0.33,363,17631,70,NULL,NULL,'2MASX J08460950+0504444',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000142,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,131.5395417,5.07914,0.157,NULL,63628007475,994187616,15534181,17.5),(56652,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56652,37.63,0.46,335,17632,70,NULL,NULL,'2MASX J08460977+1706348',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,131.540833,17.10975,0.057,NULL,63849106208,997642284,15588160,17.4),(56653,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56653,36.47,0.46,197,17633,70,NULL,NULL,'2MASX J08461224+0453184',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000064,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,131.551,4.88856,0.109,NULL,63627901136,994185955,15534155,16.5),(56654,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56654,35.35,0.55,117,17634,70,NULL,NULL,'2MASX J08461277-1737522',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,131.553167,-17.63125,0.365,NULL,42400983308,662515364,10351802,15),(56655,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56655,35.51,0.46,126,17635,70,NULL,NULL,'2MASX J08461298+4820537',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.000083,NULL,'15.1g',0.58,'E0',NULL,NULL,NULL,NULL,1,131.5540417,48.34836,0.093,NULL,64231224639,1003612884,15681451,15.1),(56656,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56656,38.14,0.46,424,17636,70,NULL,NULL,'2MASX J08461454+3250188',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,131.5605,32.83858,0.069,NULL,64416536193,1006508378,15726693,17.9),(56657,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56657,33.45,0.49,48.9,17637,75,NULL,'IR','KUG 0843+275',NULL,'2011yCatp016004901K',2011,1,0.9,'Multiple SDSS entries describe this object.','G',0.00005,NULL,'15.50',0.2,'S?',NULL,NULL,NULL,NULL,1,131.562917,27.34536,0.117,NULL,64322298261,1005035910,15703686,15.5),(56658,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56658,37.98,0.46,395,17638,70,NULL,NULL,'SDSS J084615.11+513110.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000072,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,131.563,51.51964,0.045,NULL,63487132234,991986441,15499788,18.6),(56659,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56659,37.56,0.46,326,17639,70,NULL,NULL,'2MASX J08461570+5659446',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,131.565708333,56.99586,0.177,NULL,62010696706,968917136,15139330,17.7),(56660,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56660,36.3,0.33,182,17640,70,NULL,NULL,'2MASX J08461735+2110225',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00018,NULL,'15.9g',0.35,NULL,NULL,NULL,NULL,NULL,1,131.5722083,21.17306,0.081,NULL,63797018962,996828421,15575444,15.9),(56661,'SNIa','2016-12-15 15:14:24','2016-12-16 11:19:30','1','PS1 SN PS10aj','N',56661,39.81,0.1,765,17641,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10aj HOST',0.1956,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56662,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56662,36.99,0.46,250,17642,70,NULL,NULL,'2MASX J08461955+0335545',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00018,NULL,'16.2g',0.37,'S0',NULL,NULL,NULL,NULL,1,131.581416667,3.59831,0.109,NULL,62552469203,977382331,15271598,16.2),(56663,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56663,37.81,0.46,365,17643,70,NULL,NULL,'2MASX J08462120+1136212',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000139,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,131.588333,11.60581,0.077,NULL,63663144041,994736625,15542759,18.1),(56664,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56664,36.89,0.46,239,17644,70,NULL,NULL,'2MASX J08462349+4112085',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000187,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,131.598083333,41.20228,0.101,NULL,64248224332,1003878505,15685601,16.3),(56665,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56665,37.4,0.46,301,17645,70,NULL,NULL,'2MASX J08462486+5631185',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00008,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,131.603417,56.52164,0.157,NULL,61540052716,961563323,15024426,17.4),(56666,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56666,37.83,0.46,368,17646,70,NULL,NULL,'2MASX J08462500+5129319',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000083,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,131.604,51.49236,0.045,NULL,63487104727,991986011,15499781,17.2),(56667,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56667,37.77,0.46,358,17647,70,NULL,NULL,'2MASX J08462521+2619245',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000138,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,131.605083333,26.32361,0.105,NULL,64309863189,1004841612,15700650,18),(56668,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56668,37.99,0.46,396,17648,70,NULL,NULL,'SDSS J084625.68+205203.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000141,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,131.607,20.86769,0.085,NULL,63797177335,996830895,15575482,18.2),(56669,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56669,37.84,0.46,370,17649,70,NULL,NULL,'2MASX J08462629+3402418',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000178,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,131.60975,34.04483,0.061,NULL,64419638072,1006556844,15727450,17.4),(56670,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56670,37.8,0.33,363,17650,70,NULL,NULL,'SDSS J084628.02+050907.8',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000126,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,131.616791667,5.15217,0.157,NULL,63628075152,994188674,15534198,18),(56671,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56671,38.35,0.33,468,17651,70,NULL,NULL,'2MASX J08462842+3007338',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000187,NULL,'16.7g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,131.6182917,30.12606,0.105,NULL,64313778867,1004902794,15701606,16.7),(56672,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56672,38.84,0.46,586,17652,70,NULL,NULL,'SDSS J084629.03+283923.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000174,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,131.620958333,28.65658,0.145,NULL,64321843894,1005028810,15703575,18.6),(56673,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56673,37.27,0.46,284,17653,70,NULL,NULL,'2MASX J08462919+2756405',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00017,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,131.6215417,27.9445,0.141,NULL,64322399750,1005037496,15703710,17.6),(56674,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56674,37.27,0.46,284,17654,70,NULL,NULL,'2MASX J08463054+4307491',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000137,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,131.627208333,43.13019,0.089,NULL,64245333780,1003833340,15684895,18.3),(56675,'SNIa','2016-12-15 15:14:24','2016-12-16 11:19:30','1','SN 2001jp','R',56675,41.27,NULL,1180,17655,65,NULL,'SALT','H-ZSNS J084631.40+440356.6',0.528,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,131.630833,44.06572,0.117,NULL,64250506277,1003914160,15686158,NULL),(56676,'SNIa','2016-12-15 15:14:24','2016-12-16 11:19:30','1','SN 2001jp',NULL,56676,41.75,0.25,1470,17655,74.2,NULL,'SALT 2','H-ZSNS J084631.40+440356.6',0.528,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56677,'SNIa','2016-12-15 15:14:24','2016-12-16 11:19:30','1','SN 2001jp',NULL,56677,42.35,0.24,1930,17655,70,NULL,'SALT','H-ZSNS J084631.40+440356.6',0.528,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56678,'SNIa','2016-12-15 15:14:24','2016-12-16 11:19:30','1','SN 2001jp',NULL,56678,42.4,0.15,1980,17655,72,NULL,'dm15','H-ZSNS J084631.40+440356.6',0.528,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56679,'SNIa','2016-12-15 15:14:24','2016-12-16 11:19:30','1','SN 2001jp',NULL,56679,42.42,0.15,1990,17655,72,NULL,'BATM','H-ZSNS J084631.40+440356.6',0.528,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56680,'SNIa','2016-12-15 15:14:24','2016-12-16 11:19:30','1','SN 2001jp',NULL,56680,42.53,0.21,2100,17655,72,NULL,'MLCS','H-ZSNS J084631.40+440356.6',0.528,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56681,'SNIa','2016-12-15 15:14:24','2016-12-16 11:19:30','1','SN 2001jp',NULL,56681,42.54,0.22,2110,17655,65,NULL,'SALT','H-ZSNS J084631.40+440356.6',0.528,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56682,'SNIa','2016-12-15 15:14:24','2016-12-16 11:19:30','1','SN 2001jp',NULL,56682,42.77,0.25,2340,17655,65,NULL,NULL,'H-ZSNS J084631.40+440356.6',0.528,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56683,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56683,37.09,0.21,262,17656,70,NULL,NULL,'MCG +05-21-006',NULL,'2015arXiv151105856S',2015,1,0.78,'One of two 6cm sources associated with [WB92] 0843+2940','G',0.000137,NULL,'15.7g',0.53,'S0;BrClG',NULL,NULL,NULL,NULL,1,131.63525,29.59872,0.125,NULL,64314318742,1004911230,15701737,15.7),(56684,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56684,37.99,0.46,397,17657,70,NULL,NULL,'2MASX J08463321+0944523',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000193,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,131.638291667,9.74778,0.193,NULL,63666374316,994787098,15543548,17.1),(56685,'IRAS','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56685,34.97,0.8,98.6,17658,75,NULL,'CF, r','UGC 04580',NULL,'1997ApJS..109..333W',1997,1,1.05,NULL,'G',0.000007,NULL,'14.5g',0.53,'Sbc',NULL,NULL,NULL,NULL,1,131.638708333,48.43011,0.093,NULL,64231326368,1003614474,15681476,14.5),(56686,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56686,34.78,0.38,90.3,17658,75,NULL,'CF, r, raw','UGC 04580',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56687,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56687,34.91,0.38,95.9,17658,75,NULL,'CF, r, inv','UGC 04580',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56688,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56688,35.08,0.38,104,17658,75,NULL,'CF, r, cor','UGC 04580',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56689,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56689,37.85,0.46,372,17659,70,NULL,NULL,'2MASX J08463341+2224165',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000155,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,131.639167,22.40444,0.081,NULL,63801599814,996899997,15576562,17.8),(56690,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56690,36.54,0.46,203,17660,70,NULL,NULL,'2MASX J08463429+3115108',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000188,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,131.642833,31.25289,0.105,NULL,64386462881,1006038482,15719351,16.4),(56691,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56691,36.76,0.27,225,17661,70,NULL,NULL,'2MASX J08463440+3027258',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000178,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,131.6434583,30.45731,0.117,NULL,64384382702,1006005979,15718843,16.4),(56692,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56692,37.34,0.46,294,17662,70,NULL,NULL,'2MASX J08463469+2740075',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000143,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,131.644625,27.66875,0.129,NULL,64322385315,1005037270,15703707,17.9),(56693,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56693,33.8,NULL,57.6,17663,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04588',NULL,'2010Ap&SS.325..163P',2010,1,1.81,NULL,'G',0.000005,NULL,'14.97',0.24,'Sbc',NULL,NULL,NULL,NULL,1,131.648125,19.01847,0.081,NULL,63825702269,997276597,15582446,14.97),(56694,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56694,33.81,NULL,57.9,17663,NULL,NULL,'Dipole','UGC 04588',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56695,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56695,33.81,NULL,57.9,17663,NULL,NULL,'Dipole + Quadrupole','UGC 04588',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56696,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56696,33.87,0.49,59.4,17663,75,NULL,'IR','UGC 04588',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56697,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56697,33.89,NULL,60,17663,NULL,NULL,NULL,'UGC 04588',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56698,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56698,33.95,0.11,61.8,17663,NULL,NULL,NULL,'UGC 04588',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56699,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56699,34.33,0.2,73.5,17663,74.4,NULL,NULL,'UGC 04588',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56700,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56700,37.84,0.46,370,17664,70,NULL,NULL,'2MASX J08463617+1919435',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000203,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,131.650625,19.32872,0.057,NULL,63825758604,997277478,15582460,17.3),(56701,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56701,37.83,0.46,367,17665,70,NULL,NULL,'2MASX J08463630+0643253',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000174,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,131.65125,6.72361,0.157,NULL,63674749302,994917957,15545593,16.8),(56702,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56702,37.27,0.33,285,17666,70,NULL,NULL,'2MASX J08463646+2821545',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000156,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,131.6520417,28.36533,0.161,NULL,64322620132,1005040939,15703764,17.3),(56703,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56703,39.18,0.46,686,17667,70,NULL,NULL,'SDSS J084636.66+323931.9',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000174,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,131.65275,32.65889,0.069,NULL,64383192896,1005987389,15718552,18.1),(56704,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56704,37,0.23,251,17668,70,NULL,NULL,'SDSS J084636.72+014839.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000095,NULL,'17.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,131.653,1.81094,0.141,NULL,62562080021,977532500,15273945,17.5),(56705,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56705,37.09,0.21,262,17669,70,NULL,NULL,'2MASX J08463782+2939025',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,131.657541667,29.65072,0.125,NULL,64314331738,1004911433,15701741,17.3),(56706,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56706,36.77,0.46,226,17670,70,NULL,NULL,'2MASX J08463907+4822300',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000092,NULL,'16.0g',0.39,'BrClG          AGN',NULL,NULL,NULL,NULL,1,131.66275,48.37494,0.093,NULL,64231211746,1003612683,15681448,16),(56707,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56707,37.09,0.21,262,17671,70,NULL,NULL,'2MASX J08463914+2948425',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000176,NULL,'16.5g',0.3,'E',NULL,NULL,NULL,NULL,1,131.663208333,29.81172,0.125,NULL,64314293560,1004910836,15701731,16.5),(56708,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56708,38.05,0.46,407,17672,70,NULL,NULL,'2MASX J08463960+1345027',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,131.665125,13.75086,0.085,NULL,63844135059,997564610,15586947,18),(56709,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56709,37.27,0.33,285,17673,70,NULL,NULL,'2MASX J08464031+2818295',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000178,NULL,'16.2g',0.35,'E0',NULL,NULL,NULL,NULL,1,131.668083,28.30822,0.161,NULL,64322631223,1005041112,15703767,16.2),(56710,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56710,37.72,0.46,349,17674,70,NULL,NULL,'2MASX J08464050+6241274',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,131.668416667,62.69083,0.161,NULL,62053128144,969580127,15149689,18.5),(56711,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56711,37.74,0.46,353,17675,70,NULL,NULL,'2MASX J08464063+6030094',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,131.6692917,60.50275,0.149,NULL,62065894784,969779606,15152806,17),(56712,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56712,37.14,0.46,267,17676,70,NULL,NULL,'2MASX J08464077+0345284',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000141,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,131.669833,3.75783,0.109,NULL,62552554155,977383658,15271619,17.7),(56713,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56713,35.9,0.53,151,17677,70,NULL,NULL,'2MASX J08464081-0426565',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.45',0.6,'poss. LINER',NULL,NULL,NULL,NULL,1,131.670083,-4.44919,0.045,NULL,39203640835,612556888,9571201,16.45),(56714,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56714,37.32,0.46,292,17678,70,NULL,NULL,'2MASX J08464146+0755073',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000178,NULL,'17.6g',NULL,NULL,NULL,NULL,NULL,NULL,1,131.672625,7.91875,0.161,NULL,63658581088,994665329,15541645,17.6),(56715,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56715,36.69,0.46,218,17679,70,NULL,NULL,'2MASX J08464194+0650513',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000163,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,131.6747917,6.84753,0.157,NULL,63674616178,994915877,15545560,16.9),(56716,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56716,38.33,0.46,462,17680,70,NULL,NULL,'2MASX J08464224+1559217',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000167,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,131.6760417,15.9895,0.081,NULL,63848784513,997637258,15588082,17.4),(56717,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56717,37.71,0.46,349,17681,70,NULL,NULL,'2MASX J08464264+3142589',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000184,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,131.677667,31.71639,0.085,NULL,64382895432,1005982741,15718480,16.7),(56718,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56718,37.53,0.46,320,17682,70,NULL,NULL,'2MASX J08464337+0934353',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,131.68075,9.57664,0.193,NULL,63666234098,994784907,15543514,16.8),(56719,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56719,37.09,0.21,262,17683,70,NULL,NULL,'SDSS J084643.67+294005.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,131.682,29.66808,0.125,NULL,64314331206,1004911425,15701741,18.3),(56720,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56720,38.3,0.23,456,17684,70,NULL,NULL,'2MASX J08464376+2956265',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000164,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,131.682375,29.94069,0.125,NULL,64313769543,1004902649,15701603,17.6),(56721,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56721,37.63,0.46,335,17685,70,NULL,NULL,'2MASX J08464501+0532354',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,131.687667,5.54333,0.165,NULL,63628601840,994196903,15534326,17.4),(56722,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56722,36.42,0.46,193,17686,70,NULL,NULL,'2MASX J08464539+3549039',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000103,NULL,'15.5g',0.5,'E0',NULL,NULL,NULL,NULL,1,131.6892083,35.81789,0.077,NULL,64362835028,1005669297,15713582,15.5),(56723,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56723,37.18,0.46,273,17687,70,NULL,NULL,'2MASX J08464597+1029586',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,131.6915,10.49975,0.157,NULL,63665665400,994776021,15543375,17.2),(56724,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56724,37,0.23,251,17688,70,NULL,NULL,'2MASX J08464603+0149514',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000101,NULL,'15.5g',0.57,'E0',NULL,NULL,NULL,NULL,1,131.691833,1.83081,0.141,NULL,62562084963,977532577,15273946,15.5),(56725,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56725,36.45,0.46,195,17689,70,NULL,NULL,'2MASX J08464628+3201539',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00018,NULL,'16.1g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,131.692791667,32.03153,0.089,NULL,64383279024,1005988734,15718573,16.1),(56726,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56726,37,0.23,251,17690,70,NULL,NULL,'2MASX J08464883+0148304',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00007,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,131.703375,1.80825,0.141,NULL,62562105589,977532899,15273951,17.3),(56727,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56727,34.57,0.46,81.9,17691,70,NULL,NULL,'IC 2393',NULL,'2015arXiv151105856S',2015,1,1.25,NULL,'G',0.00007,NULL,'13.8g',0.87,'E','Group member',NULL,NULL,NULL,1,131.704958333,28.17131,0.161,NULL,64322661057,1005041579,15703774,13.8),(56728,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56728,37.65,0.33,339,17692,70,NULL,NULL,'2MASX J08464966+2515275',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,131.707041667,25.25761,0.093,NULL,64309566469,1004836976,15700577,17.8),(56729,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56729,36.34,0.46,185,17693,70,NULL,NULL,'2MASX J08465305+5803598',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.61',0.26,NULL,NULL,NULL,NULL,NULL,1,131.720833,58.06672,0.201,NULL,62018420611,969037822,15141215,17.61),(56730,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56730,35.78,0.46,143,17694,70,NULL,NULL,'2MASX J08465431+0233361',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00009,NULL,'16.2g',0.33,'S0',NULL,NULL,NULL,NULL,1,131.7262083,2.56008,0.125,NULL,62561615009,977525234,15273831,16.2),(56731,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56731,37.31,0.46,290,17695,70,NULL,NULL,'SDSS J084656.22+131454.8',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00015,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,131.734291667,13.24858,0.121,NULL,63844333695,997567713,15586995,17.4),(56732,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56732,36.43,0.46,194,17696,70,NULL,NULL,'2MASX J08465685+0245311',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000136,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,131.737,2.75872,0.101,NULL,62560647110,977510111,15273595,17.2),(56733,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56733,38.09,0.46,415,17697,70,NULL,NULL,'SDSS J084657.15+610151.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,131.738125,61.03111,0.173,NULL,62066068013,969782312,15152848,18.3),(56734,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56734,37.09,0.21,262,17698,70,NULL,NULL,'2MASX J08465716+2928124',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000143,NULL,'16.7g',0.28,'E',NULL,NULL,NULL,NULL,1,131.73825,29.47008,0.113,NULL,64313457958,1004897780,15701527,16.7),(56735,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56735,34.23,0.49,70.2,17699,75,NULL,'IR','UGC 04591',NULL,'2011yCatp016004901K',2011,1,1.57,'Hernandez-Toledo et al. (2010AJ....139.2525H) give z = 0.1113.','G',0.00003,NULL,'15.58',0.2,'Sbc','Group member',NULL,NULL,NULL,1,131.742375,28.23817,0.161,NULL,64322658741,1005041542,15703774,15.58),(56736,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56736,34.77,NULL,90.1,17699,NULL,NULL,'Dipole','UGC 04591',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56737,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56737,34.78,NULL,90.5,17699,NULL,NULL,'Dipole + Quadrupole','UGC 04591',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56738,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56738,34.78,NULL,90.6,17699,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04591',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56739,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56739,38.35,0.46,468,17700,70,NULL,NULL,'2MASX J08465894+2026478',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000144,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,131.745583333,20.44647,0.073,NULL,63827090596,997298290,15582785,18),(56740,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56740,38.13,0.46,423,17701,70,NULL,NULL,'SDSS J084659.02+320532.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,131.745916667,32.09228,0.065,NULL,64383285966,1005988843,15718575,18.1),(56741,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56741,37.98,0.46,395,17702,70,NULL,NULL,'SDSS J084700.27-003209.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000074,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,131.751167,-0.53608,0.109,NULL,39198060115,612469689,9569838,18.5),(56742,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56742,37.41,0.46,304,17703,70,NULL,NULL,'2MASX J08470071+6120056',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.34',0.27,NULL,NULL,NULL,NULL,NULL,1,131.752958333,61.33481,0.133,NULL,62073712534,969901758,15154714,17.34),(56743,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56743,37.95,0.46,388,17704,70,NULL,NULL,'2MASX J08470150+3048129',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000177,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,131.756375,30.80378,0.113,NULL,64384172490,1006002695,15718792,17.5),(56744,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56744,36.58,0.46,207,17705,70,NULL,NULL,'2MASX J08470186+1001067',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000107,NULL,'16.53',0.53,NULL,NULL,NULL,NULL,NULL,1,131.757875,10.01853,0.193,NULL,63665767221,994777612,15543400,16.53),(56745,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56745,36.35,0.46,186,17706,70,NULL,NULL,'2MASX J08470220+5539199',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000092,NULL,'15.8g',0.45,'S0',NULL,NULL,NULL,NULL,1,131.7594583,55.65569,0.129,NULL,61542866543,961607289,15025113,15.8),(56746,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56746,38.15,0.19,427,17707,70,NULL,NULL,'SDSS J084702.48+045813.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000136,NULL,'18.8g',0.09,NULL,NULL,NULL,NULL,NULL,1,131.760375,4.97033,0.161,NULL,63627874526,994185539,15534149,18.8),(56747,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56747,37.01,0.46,252,17708,70,NULL,NULL,'2MASX J08470253+3125469',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000196,NULL,'15.9g',0.4,'E0',NULL,NULL,NULL,NULL,1,131.760541667,31.42978,0.105,NULL,64386430747,1006037980,15719343,15.9),(56748,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56748,37.75,0.46,355,17709,70,NULL,NULL,'2MASX J08470322+3058489',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000159,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,131.763375,30.98014,0.113,NULL,64386479644,1006038744,15719355,17.3),(56749,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56749,36.04,0.46,162,17710,70,NULL,NULL,'2MASX J08470416+3113139',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,131.767416667,31.22053,0.101,NULL,64386494011,1006038968,15719358,17),(56750,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56750,36.97,0.46,248,17711,70,NULL,NULL,'2MASX J08470472+0300251',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000165,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,131.769625,3.00683,0.101,NULL,62560618020,977509656,15273588,16.8),(56751,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56751,38.15,0.19,427,17712,70,NULL,NULL,'SDSS J084706.48+050007.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00014,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,131.777041667,5.00208,0.161,NULL,63628092109,994188939,15534202,18.3),(56752,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56752,38.12,0.46,422,17713,70,NULL,NULL,'2MASX J08470845+6351317',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,131.7850417,63.85889,0.133,NULL,62051017345,969547146,15149174,17.5),(56753,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56753,37.36,0.46,296,17714,70,NULL,NULL,'2MASX J08470853+2704424',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000138,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,131.785667,27.0785,0.157,NULL,64308405772,1004818840,15700294,17.4),(56754,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56754,37.05,0.46,257,17715,70,NULL,NULL,'2MASX J08470883+2607244',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000201,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,131.7867083,26.12361,0.105,NULL,64309956691,1004843073,15700673,16.9),(56755,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56755,38.32,0.46,462,17716,70,NULL,NULL,'2MASX J08471016+0901157',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,131.7922917,9.02106,0.197,NULL,63658974766,994671480,15541741,17.9),(56756,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56756,36.88,0.17,238,17717,70,NULL,NULL,'2MASX J08471037+5349499',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000064,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,131.793208333,53.83058,0.085,NULL,63488823278,992012863,15500200,17),(56757,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56757,38.13,0.46,422,17718,70,NULL,NULL,'2MASX J08471056+5929169',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,131.794083,59.48808,0.145,NULL,62064907113,969764173,15152565,18.1),(56758,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56758,37.93,0.46,385,17719,70,NULL,NULL,'2MASX J08471084+1326392',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,131.795125,13.44419,0.089,NULL,63844348366,997567943,15586999,17.6),(56759,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56759,38.3,0.23,456,17720,70,NULL,NULL,'2MASX J08471195+3002009',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,131.7997083,30.03372,0.105,NULL,64384218875,1006003419,15718803,17.4),(56760,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56760,37.65,0.33,339,17721,70,NULL,NULL,'2MASX J08471327+2520594',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000206,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,131.805417,25.34994,0.093,NULL,64309624400,1004837881,15700591,16.8),(56761,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56761,37.01,0.33,252,17722,70,NULL,NULL,'2MASX J08471352+4924529',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,131.8065417,49.41464,0.109,NULL,64230143763,1003595996,15681187,16.7),(56762,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56762,36.86,0.46,235,17723,70,NULL,NULL,'2MASX J08471408+0121451',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000109,NULL,'15.9g',0.45,'E0',NULL,NULL,NULL,NULL,1,131.8087083,1.36239,0.093,NULL,62559886968,977498233,15273409,15.9),(56763,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56763,37,0.23,251,17724,70,NULL,NULL,'2MASX J08471547+0153441',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000087,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,131.8145417,1.89556,0.141,NULL,62562059387,977532177,15273940,16.9),(56764,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56764,36.58,0.46,207,17725,70,NULL,NULL,'ARK 178',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000083,NULL,'15.7',0.2,'E0',NULL,NULL,NULL,NULL,1,131.8147917,35.47506,0.085,NULL,64419151481,1006549241,15727331,15.7),(56765,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56765,37.38,0.23,300,17726,70,NULL,NULL,'2MASX J08471562+1111156',NULL,'2015arXiv151105856S',2015,1,1.12,NULL,'G',NULL,NULL,'17.21',NULL,NULL,NULL,NULL,NULL,NULL,1,131.814917,11.18764,0.105,NULL,63662695855,994729622,15542650,17.21),(56766,'Faber-Jackson','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56766,33.38,0.59,47.4,17727,95,NULL,'Weighted Mean','NGC 2629',NULL,'1984ApJS...56...91D',1984,1,1.8,NULL,'G',0.00008,NULL,'13.33',1.5,'SA(r)0^0^:','in a pair',NULL,NULL,NULL,1,131.815917,72.98564,0.029,NULL,62176969940,971515155,15179924,13.33),(56767,'Faber-Jackson','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56767,33.38,0.59,47.4,17727,95,NULL,'de Vaucouleurs','NGC 2629',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56768,'Tertiary','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56768,32.7,0.29,34.7,17727,95,NULL,NULL,'NGC 2629',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56769,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56769,37.33,0.23,293,17728,70,NULL,NULL,'2MASXi J0847159+335355',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,131.816333,33.89867,0.065,NULL,64419652383,1006557068,15727454,17.5),(56770,'IRAS','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56770,34.01,0.8,63.3,17729,75,NULL,'MAT, I','UGCA 145',NULL,'1997ApJS..109..333W',1997,1,3.36,NULL,'G',0.000013,NULL,'14',0.45,'SAbc: sp       HII',NULL,NULL,NULL,NULL,1,131.82075,-20.03569,0.493,NULL,42357785496,661840398,10341256,14),(56771,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56771,33.64,0.46,53.5,17729,NULL,NULL,'J','UGCA 145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56772,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56772,33.69,0.47,54.6,17729,NULL,NULL,'H','UGCA 145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56773,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56773,33.78,0.45,56.9,17729,NULL,NULL,'K','UGCA 145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56774,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56774,33.95,0.49,61.6,17729,75,NULL,'IR','UGCA 145',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56775,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56775,34.14,0.43,67.2,17729,75,NULL,'MAT, I, raw','UGCA 145',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56776,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56776,34.15,0.4,67.7,17729,NULL,NULL,'mean','UGCA 145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56777,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56777,34.23,NULL,70.3,17729,NULL,NULL,'Dipole','UGCA 145',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56778,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56778,34.24,NULL,70.5,17729,NULL,NULL,'Dipole + Quadrupole','UGCA 145',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56779,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56779,34.25,NULL,70.9,17729,NULL,NULL,'Dipole + Quadrupole + Octopole','UGCA 145',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56780,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56780,34.38,0.43,75.3,17729,75,NULL,'MAT, I, cor','UGCA 145',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56781,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56781,34.39,0.32,75.4,17729,85,NULL,'I, raw','UGCA 145',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56782,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56782,34.4,0.31,75.7,17729,NULL,NULL,'Malmquist cor.','UGCA 145',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56783,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56783,34.42,NULL,76.4,17729,NULL,NULL,NULL,'UGCA 145',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56784,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56784,34.48,0.32,78.8,17729,85,NULL,'I, inv','UGCA 145',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56785,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56785,34.51,0.2,79.8,17729,74.4,NULL,NULL,'UGCA 145',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56786,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56786,34.52,0.43,80,17729,75,NULL,'MAT, I, inv','UGCA 145',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56787,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56787,34.6,0.43,83.3,17729,75,NULL,'3.6 micron, color corrected','UGCA 145',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56788,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56788,34.71,0.27,87.5,17729,NULL,NULL,NULL,'UGCA 145',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56789,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56789,34.87,0.43,94.2,17729,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 145',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56790,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56790,37.97,0.33,394,17730,70,NULL,NULL,'2MASX J08471814+3830040',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.1g',0.26,'BrClG',NULL,NULL,NULL,NULL,1,131.825667,38.50117,0.069,NULL,64369064846,1005766638,15715103,17.1),(56791,'SNIa','2016-12-15 15:14:24','2016-12-16 11:19:30','1','PS1 SN PS10bkf','N',56791,39.88,0.13,806,17731,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10bkf HOST',0.1726,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56792,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56792,36.76,0.27,225,17732,70,NULL,NULL,'2MASX J08471916+3040125',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,131.82975,30.67011,0.113,NULL,64384368455,1006005757,15718839,17.4),(56793,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56793,37.27,0.46,284,17733,70,NULL,NULL,'SDSS J084719.87+180151.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000122,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,131.8327917,18.03094,0.057,NULL,63880073498,998126148,15595721,17.9),(56794,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56794,37.66,0.46,341,17734,70,NULL,NULL,'2MASX J08471996+2921364',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000136,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,131.833083,29.36006,0.113,NULL,64313565709,1004899464,15701554,18),(56795,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56795,38.19,0.46,434,17735,70,NULL,NULL,'2MASX J08472067+2242115',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,131.836167,22.70319,0.101,NULL,63801586079,996899782,15576559,17.6),(56796,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56796,38.01,0.46,400,17736,70,NULL,NULL,'2MASX J08472152+0122480',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000082,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,131.83975,1.37989,0.093,NULL,62559892248,977498316,15273411,17.6),(56797,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56797,37.38,0.23,300,17737,70,NULL,NULL,'2MASX J08472195+1103336',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,131.841333,11.0595,0.121,NULL,63662483976,994726312,15542598,16.5),(56798,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56798,35.59,0.46,131,17738,70,NULL,NULL,'2MASX J08472263+1207179',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000175,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,131.8442917,12.12172,0.089,NULL,63663083556,994735680,15542745,16.2),(56799,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56799,35.76,0.46,142,17739,70,NULL,NULL,'2MASX J08472283+4642399',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000171,NULL,'15.6g',0.35,'S0/a',NULL,NULL,NULL,NULL,1,131.844958333,46.71108,0.081,NULL,64285509422,1004461084,15694704,15.6),(56800,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56800,37.97,0.33,394,17740,70,NULL,NULL,'2MASXi J0847233+382814',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00006,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,131.847375,38.47058,0.069,NULL,64369056387,1005766506,15715101,18),(56801,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56801,38.3,0.23,456,17741,70,NULL,NULL,'SDSS J084724.71+300120.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000129,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,131.853,30.02228,0.105,NULL,64384220235,1006003441,15718803,18.3),(56802,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56802,37.77,0.46,358,17742,70,NULL,NULL,'2MASX J08472547+3011035',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,131.8559583,30.18428,0.105,NULL,64384270058,1006004219,15718815,17.4),(56803,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56803,37.66,0.33,340,17743,70,NULL,NULL,'2MASX J08472544+2046205',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000139,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,131.856125,20.77225,0.089,NULL,63827296741,997301511,15582836,18.3),(56804,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56804,36.4,0.46,191,17744,70,NULL,NULL,'CGCG 090-009',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000097,NULL,'15.4g',0.51,NULL,NULL,NULL,NULL,NULL,1,131.862167,19.53664,0.057,NULL,63825571261,997274550,15582414,15.4),(56805,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56805,38.15,0.19,427,17745,70,NULL,NULL,'SDSS J084727.95+050310.3',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000138,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,131.8665,5.05286,0.161,NULL,63628096184,994189002,15534203,17.7),(56806,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56806,37.33,0.23,293,17746,70,NULL,NULL,'2MASX J08472829+3351565',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00019,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,131.8677917,33.86581,0.065,NULL,64420061416,1006563459,15727554,16.7),(56807,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56807,37.77,0.46,358,17747,70,NULL,NULL,'2MASX J08472930+1826475',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,131.8719583,18.44653,0.053,NULL,63879859847,998122810,15595668,17.4),(56808,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56808,37.86,0.46,374,17748,70,NULL,NULL,'2MASX J08473010+1024507',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.5E',NULL,NULL,NULL,NULL,NULL,NULL,1,131.8755,10.41417,0.205,NULL,63665638009,994775593,15543368,16.5),(56809,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56809,37.01,0.33,252,17749,70,NULL,NULL,'2MASX J08473105+4924339',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,131.879333333,49.40939,0.109,NULL,64230142731,1003595980,15681187,16.7),(56810,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56810,37.89,0.46,379,17750,70,NULL,NULL,'SDSS J084732.02+330410.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,131.883416667,33.06953,0.089,NULL,64416625004,1006509765,15726715,18.1),(56811,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56811,38.04,0.46,406,17751,70,NULL,NULL,'2MASX J08473206+4128210',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000169,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,131.883458333,41.47253,0.065,NULL,64248290774,1003879543,15685617,17.5),(56812,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56812,36.88,0.17,238,17752,70,NULL,NULL,'CGCG 264-014',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000115,NULL,'15.4g',0.56,'S0^-',NULL,NULL,NULL,NULL,1,131.883875,53.90525,0.065,NULL,63488833066,992013016,15500203,15.4),(56813,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56813,37.5,0.27,316,17753,70,NULL,NULL,'2MASX J08473217+3142445',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00021,NULL,'16.1g',0.43,'E0',NULL,NULL,NULL,NULL,1,131.8839583,31.71239,0.101,NULL,64386501876,1006039091,15719360,16.1),(56814,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56814,38.75,0.46,562,17754,70,NULL,NULL,'2MASX J08473343+3450145',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000169,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,131.889458333,34.83742,0.077,NULL,64418566616,1006540103,15727189,18.3),(56815,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56815,37.39,0.46,301,17755,70,NULL,NULL,'2MASX J08473419+6211176',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,131.892208333,62.18822,0.137,NULL,62060824386,969700381,15151568,17.8),(56816,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56816,37.96,0.33,390,17756,70,NULL,NULL,'SDSS J084734.77+164320.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000147,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,131.894917,16.72225,0.065,NULL,63848202883,997628170,15587940,18.5),(56817,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56817,37.73,0.46,352,17757,70,NULL,NULL,'2MASX J08473493+0045190',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000086,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,131.895667,0.75531,0.101,NULL,62559262914,977488483,15273257,17.3),(56818,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56818,38.09,0.46,415,17758,70,NULL,NULL,'2MASX J08473525+4342189',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,131.896958333,43.70531,0.125,NULL,64245210279,1003831410,15684865,17.7),(56819,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56819,36.15,0.46,170,17759,70,NULL,NULL,'2MASX J08473619+0631437',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,131.901,6.52872,0.169,NULL,63674731469,994917679,15545588,16.7),(56820,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56820,36.88,0.17,238,17760,70,NULL,NULL,'2MASX J08473678+5345449',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000099,NULL,'17.0g',0.24,'NLAGN',NULL,NULL,NULL,'Sy 2',1,131.903083,53.76256,0.065,NULL,63488947801,992014809,15500231,17),(56821,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56821,37.96,0.33,390,17761,70,NULL,NULL,'2MASX J08473698+1640569',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000184,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,131.904125,16.68258,0.065,NULL,63848205011,997628203,15587940,17.1),(56822,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56822,37.33,0.23,293,17762,70,NULL,NULL,'2MASX J08473712+3351285',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,131.904875,33.85797,0.065,NULL,64420107159,1006564174,15727565,17.3),(56823,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56823,37.44,0.33,307,17763,70,NULL,NULL,'2MASX J08474003+1859437',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000194,NULL,'16.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,131.916875,18.99564,0.049,NULL,63825167921,997268248,15582316,16.8),(56824,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56824,34.82,0.46,92,17764,NULL,NULL,'Malmquist cor.','UGC 04597',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.84',0.5,'S?',NULL,NULL,NULL,NULL,1,131.917417,25.89353,0.105,NULL,64309518571,1004836227,15700566,14.84),(56825,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56825,34.89,0.44,94.9,17764,NULL,NULL,NULL,'UGC 04597',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56826,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56826,34.93,0.2,96.8,17764,74.4,NULL,NULL,'UGC 04597',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56827,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56827,37.5,0.46,316,17765,70,NULL,NULL,'2MASX J08474084+3547355',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00011,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,131.920083,35.79311,0.081,NULL,64418322288,1006536285,15727129,17),(56828,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56828,37.33,0.23,293,17766,70,NULL,NULL,'KUG 0844+339',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,131.920875,33.77239,0.065,NULL,64420063396,1006563490,15727554,16.8),(56829,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56829,37.38,0.23,300,17767,70,NULL,NULL,'2MASX J08474144+1106057',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,131.922666667,11.10158,0.121,NULL,63662475680,994726182,15542596,17),(56830,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56830,37.06,0.46,258,17768,70,NULL,NULL,'2MASX J08474162+2313397',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,131.9232917,23.22764,0.089,NULL,63789828057,996716063,15573688,17.2),(56831,'Black Hole','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56831,37.96,0.71,390,17769,NULL,NULL,NULL,'PG 0844+349',NULL,'2014ApJ...793..108W',2014,1,NULL,NULL,'QSO',NULL,NULL,'13.5B',NULL,'Sp(d)          Sy1',NULL,NULL,NULL,'Sy 1.0',1,131.9269583,34.75122,0.077,NULL,64418596757,1006540574,15727196,13.5),(56832,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56832,37.96,0.46,390,17770,70,NULL,NULL,'2MASX J08474372+2616047',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,131.932375,26.26794,0.125,NULL,64309828468,1004841069,15700641,18.2),(56833,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56833,36.68,0.27,217,17771,70,NULL,NULL,'2MASX J08474491+1407149',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000107,NULL,'15.6g',0.49,NULL,NULL,NULL,NULL,NULL,1,131.9372917,14.12069,0.081,NULL,63842875484,997544929,15586639,15.6),(56834,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56834,35.95,0.46,155,17772,70,NULL,NULL,'CGCG 208-046',NULL,'2015arXiv151105856S',2015,1,0.87,NULL,'G',0.000195,NULL,'15.2g',0.5,'E0',NULL,NULL,NULL,NULL,1,131.9390417,39.53636,0.085,NULL,64369577600,1005774650,15715228,15.2),(56835,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56835,37.84,0.46,369,17773,70,NULL,NULL,'2MASX J08474560+1422239',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000164,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,131.9402083,14.37333,0.053,NULL,63850513315,997664270,15588504,17.4),(56836,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56836,37.31,0.15,289,17774,70,NULL,NULL,'2MASX J08474583+0859484',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,131.941083,8.99692,0.197,NULL,63658093672,994657713,15541526,17.2),(56837,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56837,36.8,0.46,229,17775,70,NULL,NULL,'2MASX J08474598+1519049',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,131.9417083,15.31811,0.089,NULL,63849984749,997656011,15588375,17),(56838,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56838,37.5,0.27,316,17776,70,NULL,NULL,'2MASX J08474638+3154115',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000211,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,131.943083,31.90322,0.061,NULL,64386051167,1006032049,15719250,18.1),(56839,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56839,37.86,0.19,373,17777,70,NULL,NULL,'SDSS J084746.66+245628.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000176,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,131.944458333,24.94117,0.085,NULL,63788756569,996699321,15573426,18.3),(56840,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56840,36.88,0.17,238,17778,70,NULL,NULL,'2MASX J08474681+5401365',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,'FoF','16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,131.944875,54.02667,0.041,NULL,63488806984,992012609,15500197,16.9),(56841,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56841,38.03,0.46,403,17779,70,NULL,NULL,'2MASX J08474679+2247317',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000185,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,131.9449583,22.79225,0.085,NULL,63801530525,996898914,15576545,17.2),(56842,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56842,37.75,0.46,355,17780,70,NULL,NULL,'2MASX J08474686+2740507',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000174,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,131.945375,27.68081,0.129,NULL,64308573532,1004821461,15700335,17),(56843,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56843,37.94,0.46,388,17781,70,NULL,NULL,'2MASX J08474836+3858584',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,131.951667,38.98283,0.121,NULL,64369927211,1005780112,15715314,17.7),(56844,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56844,37.86,0.19,373,17782,70,NULL,NULL,'2MASX J08474869+2453497',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000185,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,131.9529583,24.89708,0.085,NULL,63788760606,996699384,15573427,18.1),(56845,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56845,36.78,0.46,227,17783,70,NULL,NULL,'2MASX J08474890+0933105',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,131.9537083,9.55286,0.193,NULL,63665506024,994773531,15543336,17.4),(56846,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56846,37.97,0.46,392,17784,70,NULL,NULL,'2MASX J08474892+5224113',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000101,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,131.954,52.40331,0.085,NULL,63488020000,992000312,15500004,17.1),(56847,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56847,37.44,0.33,307,17785,70,NULL,NULL,'2MASX J08474920+1902517',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000187,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,131.955083,19.04767,0.049,NULL,63825161783,997268152,15582314,16.2),(56848,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56848,36.68,0.27,217,17786,70,NULL,NULL,'2MASX J08474950+1407299',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00018,NULL,'16.0g',0.45,NULL,NULL,NULL,NULL,NULL,1,131.9562083,14.12511,0.081,NULL,63842862152,997544721,15586636,16),(56849,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56849,36.95,0.46,246,17787,70,NULL,NULL,'2MASX J08474962+1837307',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000154,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,131.956958333,18.62525,0.053,NULL,63879889222,998123269,15595676,16.9),(56850,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56850,37.66,0.33,340,17788,70,NULL,NULL,'2MASX J08475065+2048297',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000159,NULL,'16.6g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,131.961,20.80842,0.089,NULL,63827236864,997300576,15582821,16.6),(56851,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56851,37.85,0.46,372,17789,70,NULL,NULL,'2MASX J08475081+0338174',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000175,NULL,'16.8g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,131.961625,3.63808,0.109,NULL,62552758095,977386845,15271669,16.8),(56852,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56852,38.25,0.46,446,17790,70,NULL,NULL,'2MASX J08475133+2856147',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000146,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,131.964,28.93731,0.105,NULL,64321768722,1005027636,15703556,18.7),(56853,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56853,38.15,0.19,427,17791,70,NULL,NULL,'2MASX J08475162+0458204',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000206,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,131.965167,4.97244,0.161,NULL,63627870674,994185479,15534148,17),(56854,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56854,37.23,0.46,279,17792,70,NULL,NULL,'2MASX J08475254+2442057',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000179,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,131.9690417,24.70169,0.093,NULL,63788717332,996698708,15573417,16.8),(56855,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56855,37.24,0.46,281,17793,70,NULL,NULL,'2MASX J08475286+2957067',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000177,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,131.97025,29.95192,0.125,NULL,64384482345,1006007536,15718867,17.4),(56856,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56856,35.62,0.8,133,17794,70,NULL,NULL,'2MASX J08475323-2009342',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.4,NULL,NULL,NULL,NULL,NULL,1,131.971791667,-20.15953,0.493,NULL,42357969545,661843274,10341301,14.4),(56857,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56857,36.27,0.46,179,17795,70,NULL,NULL,'2MASX J08475333+3152373',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000176,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,131.972125,31.87697,0.061,NULL,64386050635,1006032041,15719250,16.6),(56858,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56858,37.64,0.46,337,17796,70,NULL,NULL,'2MASX J08475439+0542044',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000182,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,131.9765417,5.70133,0.157,NULL,63628608052,994197000,15534328,17.2),(56859,'SNIa','2016-12-15 15:14:24','2016-12-16 11:19:30','1','SN 2002W',NULL,56859,42.14,1.33,1320,17797,65,NULL,'SALT','H-ZSNS J084754.42+441342.9',1.031,'2009ApJ...700.1097H',2009,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,131.97675,44.22858,0.097,NULL,64283014571,1004422102,15694095,NULL),(56860,'SNIa','2016-12-15 15:14:24','2016-12-16 11:19:30','1','SN 2002W',NULL,56860,42.18,1.29,1340,17797,70,NULL,'SALT','H-ZSNS J084754.42+441342.9',1.031,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56861,'SNIa','2016-12-15 15:14:24','2016-12-16 11:19:30','1','SN 2002W','R',56861,42.58,NULL,1610,17797,65,NULL,'SALT','H-ZSNS J084754.42+441342.9',1.031,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56862,'SNIa','2016-12-15 15:14:24','2016-12-16 11:19:30','1','SN 2002W',NULL,56862,43.66,0.48,2660,17797,72,NULL,'BATM','H-ZSNS J084754.42+441342.9',1.031,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56863,'SNIa','2016-12-15 15:14:24','2016-12-16 11:19:30','1','SN 2002W',NULL,56863,43.96,0.89,3050,17797,72,NULL,'MLCS','H-ZSNS J084754.42+441342.9',1.031,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56864,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56864,38.06,0.46,410,17798,70,NULL,NULL,'2MASX J08475496+2925326',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,131.979083333,29.42567,0.113,NULL,64313468790,1004897949,15701530,17.5),(56865,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56865,37.8,0.46,363,17799,70,NULL,NULL,'2MASX J08475519+3828464',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,131.979875,38.47956,0.097,NULL,64369012856,1005765825,15715091,17.5),(56866,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56866,38.15,0.19,427,17800,70,NULL,NULL,'2MASX J08475529+0459324',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00018,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,131.980458333,4.99219,0.161,NULL,63628084221,994188815,15534200,17),(56867,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56867,34.75,0.4,89,17801,NULL,NULL,'mean','UGC 04602',NULL,'2007A&A...465...71T',2007,1,1.28,NULL,'G',0.000033,NULL,'14.7g',0.46,'Sab',NULL,NULL,NULL,NULL,1,131.982541667,25.83167,0.105,NULL,64309552731,1004836761,15700574,14.7),(56868,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56868,35.11,0.47,105,17801,NULL,NULL,'H','UGC 04602',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56869,'Tully est','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56869,32.95,0.8,38.8,17802,75,NULL,'B','IC 2389',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.00003,NULL,'12.61',0.3,'S','in a pair',NULL,NULL,NULL,1,131.990708333,73.53919,0.037,NULL,62176432502,971506757,15179793,12.61),(56870,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56870,31.68,0.43,21.6,17802,75,NULL,'3.6 micron, color + selection bias corrected','IC 2389',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56871,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56871,31.84,0.43,23.4,17802,75,NULL,'3.6 micron, color corrected','IC 2389',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56872,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56872,32.04,0.2,25.6,17802,74.4,NULL,NULL,'IC 2389',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56873,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56873,32.23,0.53,27.9,17802,NULL,NULL,'Malmquist cor.','IC 2389',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56874,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56874,32.35,0.5,29.5,17802,NULL,NULL,NULL,'IC 2389',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56875,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56875,37.01,0.46,253,17803,70,NULL,NULL,'2MASX J08475825+3252273',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000136,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,131.992625,32.87442,0.069,NULL,64416433474,1006506773,15726668,17.7),(56876,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56876,36.1,0.46,166,17804,70,NULL,NULL,'2MASX J08475821+5136034',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000061,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,131.992791667,51.60103,0.053,NULL,64224382324,1003505973,15679780,16.6),(56877,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56877,37.5,0.27,316,17805,70,NULL,NULL,'IC 2402',NULL,'2015arXiv151105856S',2015,1,0.83,'TXS codes: lobes(W)','G',0.000127,NULL,'14.9g',0.71,'AGN:',NULL,NULL,'radio jet','Flat-Spectrum Radio Source',1,131.996,31.78564,0.061,NULL,64386046732,1006031980,15719249,14.9),(56878,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56878,38.08,0.33,413,17806,70,NULL,NULL,'2MASX J08475945+1802207',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000144,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,131.99775,18.03908,0.057,NULL,63880050321,998125786,15595715,18.1),(56879,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56879,38.1,0.46,416,17807,70,NULL,NULL,'2MASX J08480119+0445094',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,132.0050417,4.75264,0.161,NULL,63631326107,994239470,15534991,17.5),(56880,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56880,37.6,0.46,331,17808,70,NULL,NULL,'2MASX J08480168+5054064',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000074,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,132.007083,50.90178,0.057,NULL,64237914200,1003717409,15683084,17.6),(56881,'SNIa','2016-12-15 15:14:24','2016-12-16 11:19:30','1','PS1 SN PS10bzo','N',56881,41.68,0.15,1570,17809,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10bzo HOST',0.3806,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56882,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56882,38.08,0.33,413,17810,70,NULL,NULL,'2MASX J08480352+1802597',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000176,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,132.0147917,18.04989,0.057,NULL,63880052603,998125821,15595715,17.2),(56883,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56883,36.99,0.46,250,17811,70,NULL,NULL,'2MASX J08480414+0213094',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00015,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,132.017333333,2.21939,0.129,NULL,62561257543,977519649,15273744,17.1),(56884,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56884,37,0.46,251,17812,70,NULL,NULL,'2MASX J08480427+3235483',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00018,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,132.017958333,32.59667,0.069,NULL,64383149204,1005986706,15718542,16.5),(56885,'Tully est','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56885,32.61,0.8,33.2,17813,75,NULL,'B','NGC 2633',NULL,'1988NBGC.C....0000T',1988,1,2.5,'Described by VV as \'three or more galaxies with one and two bridges\'.','G',0.000023,NULL,'12.9',1.5,'SB(s)b         HII','in a pair',NULL,NULL,NULL,1,132.019083,74.09886,0.049,NULL,61288109275,957626707,14962917,12.9),(56886,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56886,31.82,0.43,23.1,17813,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2633',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56887,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56887,32.09,0.43,26.2,17813,75,NULL,'3.6 micron, color corrected','NGC 2633',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56888,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56888,32.12,0.45,26.5,17813,NULL,NULL,'K','NGC 2633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56889,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56889,32.18,0.47,27.2,17813,NULL,NULL,'H','NGC 2633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56890,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56890,32.19,0.45,27.4,17813,NULL,NULL,'Malmquist cor.','NGC 2633',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56891,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56891,32.3,0.46,28.8,17813,NULL,NULL,'J','NGC 2633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56892,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56892,32.32,0.2,29.1,17813,74.4,NULL,NULL,'NGC 2633',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56893,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56893,32.36,0.42,29.7,17813,NULL,NULL,NULL,'NGC 2633',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56894,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56894,32.58,0.4,32.9,17813,NULL,NULL,'mean','NGC 2633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56895,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56895,38.15,0.19,427,17814,70,NULL,NULL,'2MASX J08480520+0458084',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000123,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,132.02175,4.96906,0.161,NULL,63631474715,994241792,15535028,18.2),(56896,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56896,38.09,0.46,415,17815,70,NULL,NULL,'2MASX J08480526+4319448',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,132.02175,43.32919,0.101,NULL,64245462430,1003835350,15684927,17.3),(56897,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56897,37.7,0.46,347,17816,70,NULL,NULL,'2MASX J08480626+5524285',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,'FoF','17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,132.026125,55.40786,0.117,NULL,61542823015,961606609,15025103,17),(56898,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56898,35.85,0.46,148,17817,70,NULL,NULL,'2MASX J08480720+4634478',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000174,NULL,'15.9g',0.42,'AGN',NULL,NULL,NULL,NULL,1,132.029958333,46.57989,0.085,NULL,64285996896,1004468701,15694823,15.9),(56899,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56899,37.09,0.46,262,17818,70,NULL,NULL,'2MASX J08480783+0356344',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000137,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,132.03275,3.943,0.109,NULL,62552196234,977378066,15271532,17.7),(56900,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56900,37.36,0.46,297,17819,70,NULL,NULL,'2MASX J08480837+0121284',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000092,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,132.034958333,1.35794,0.097,NULL,62559471749,977491746,15273308,16.7),(56901,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56901,34.74,0.49,88.6,17820,75,NULL,'IR','IC 2407',NULL,'2011yCatp016004901K',2011,1,1.58,NULL,'G',0.000027,NULL,'15.0g',0.27,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,132.038125,17.61147,0.045,NULL,63883074112,998173033,15596453,15),(56902,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56902,35.04,0.2,102,17820,74.4,NULL,NULL,'IC 2407',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56903,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56903,35.2,0.45,110,17820,NULL,NULL,NULL,'IC 2407',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56904,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56904,35.24,0.45,112,17820,NULL,NULL,'Malmquist cor.','IC 2407',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56905,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56905,37.95,0.33,389,17821,70,NULL,NULL,'2MASX J08480993+1134255',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000196,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,132.0414583,11.57369,0.117,NULL,63662993063,994734266,15542722,16.8),(56906,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56906,35.76,0.46,142,17822,70,NULL,NULL,'IC 2401',NULL,'2015arXiv151105856S',2015,1,1.11,NULL,'G',0.00011,NULL,'14.5g',0.71,'S0:','Group member',NULL,NULL,NULL,1,132.042917,37.75536,0.053,NULL,64368909756,1005764214,15715065,14.5),(56907,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56907,34.95,0.46,97.9,17823,70,NULL,NULL,'IC 2404',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00012,NULL,'15.3g',0.44,'Sb',NULL,NULL,NULL,NULL,1,132.0435417,29.49136,0.113,NULL,64313473680,1004898026,15701531,15.3),(56908,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56908,37.95,0.33,389,17824,70,NULL,NULL,'2MASX J08481055+1136185',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000155,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,132.0440417,11.60531,0.117,NULL,63662992164,994734252,15542722,17.4),(56909,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56909,36.77,0.46,226,17825,70,NULL,NULL,'2MASX J08481093+2743337',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000144,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,132.045625,27.72594,0.129,NULL,64308567436,1004821366,15700333,17.4),(56910,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56910,37.87,0.46,375,17826,70,NULL,NULL,'2MASX J08481114+3308363',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000156,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,132.0465,33.14356,0.089,NULL,64416400265,1006506254,15726660,17.1),(56911,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56911,37.29,0.46,287,17827,70,NULL,NULL,'2MASX J08481304+3410403',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000192,NULL,'16.2g',0.39,'E0',NULL,NULL,NULL,NULL,1,132.0545417,34.17781,0.061,NULL,64419692860,1006557700,15727464,16.2),(56912,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56912,37.32,0.46,291,17828,70,NULL,NULL,'2MASX J08481405+0343294',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000184,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,132.058625,3.72494,0.109,NULL,62552692008,977385812,15271653,16.4),(56913,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56913,38.3,0.23,456,17829,70,NULL,NULL,'SDSS J084815.28+300046.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000139,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,132.063667,30.01289,0.125,NULL,64384477214,1006007456,15718866,18.7),(56914,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56914,33.84,0.2,58.6,17830,74.4,NULL,NULL,'CGCG 005-008',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.00002,NULL,'14.16',0.8,'SA(s)c:','Pair member (points to parent)',NULL,NULL,NULL,1,132.078166667,-3.01961,0.021,NULL,39205800981,612590640,9571728,14.16),(56915,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56915,33.98,0.46,62.4,17830,NULL,NULL,NULL,'CGCG 005-008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56916,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56916,34.12,0.43,66.7,17830,NULL,NULL,'Malmquist cor.','CGCG 005-008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56917,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56917,36.1,0.51,166,17831,70,NULL,NULL,'2MFGC 06913',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.36',0.2,NULL,NULL,NULL,NULL,NULL,1,132.08475,-11.8955,0.089,NULL,42167780616,658871572,10294868,16.36),(56918,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56918,36.98,0.46,249,17832,70,NULL,NULL,'2MASX J08482252+1222106',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000201,NULL,'16.1g',0.37,NULL,NULL,NULL,NULL,NULL,1,132.093916667,12.36964,0.065,NULL,63844021973,997562843,15586919,16.1),(56919,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56919,37.86,0.19,373,17833,70,NULL,NULL,'2MASX J08482273+2439127',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,132.0947917,24.65361,0.093,NULL,63788741287,996699082,15573423,17.3),(56920,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56920,36.68,0.27,217,17834,70,NULL,NULL,'2MASX J08482323+1416186',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,132.0969583,14.27186,0.053,NULL,63843037952,997547468,15586679,17.3),(56921,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56921,34.87,0.47,94.1,17835,NULL,NULL,'H','IC 2409',NULL,'2007A&A...465...71T',2007,1,1.04,NULL,'G',0.000033,NULL,'14.1g',0.83,'SAB(s)a',NULL,NULL,NULL,NULL,1,132.10275,18.33114,0.049,NULL,63879948699,998124198,15595690,14.1),(56922,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56922,34.91,0.4,95.8,17835,NULL,NULL,'mean','IC 2409',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56923,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56923,34.95,0.46,97.7,17835,NULL,NULL,'J','IC 2409',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56924,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56924,36.88,0.17,238,17836,70,NULL,NULL,'2MASX J08482492+5355074',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000105,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,132.103625,53.91875,0.041,NULL,63488848390,992013256,15500207,17.1),(56925,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56925,34.89,0.2,95.1,17837,74.4,NULL,NULL,'CGCG 120-038',NULL,'2013AJ....146...86T',2013,1,0.77,NULL,'G',0.000049,NULL,'15.5g',0.35,'Sbc(r)',NULL,NULL,NULL,NULL,1,132.104083,23.83722,0.085,NULL,63790381998,996724718,15573823,15.5),(56926,'SBF','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56926,32.62,0.68,33.4,17838,NULL,NULL,'I','NGC 2634',NULL,'2001ApJ...546..681T',2001,1,1.7,NULL,'G',0.000017,NULL,'12.91',1.6,'E1:','in a pair',NULL,NULL,NULL,1,132.1057917,73.96717,0.025,NULL,61288154363,957627411,14962928,12.91),(56927,'SBF','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56927,32.62,0.68,33.4,17838,NULL,NULL,NULL,'NGC 2634',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56928,'SBF','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56928,32.65,0.14,33.9,17838,74.4,NULL,NULL,'NGC 2634',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56929,'SBF','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56929,33.28,0.68,45.2,17838,NULL,NULL,'Malmquist cor.','NGC 2634',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56930,'D-Sigma','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56930,33.06,0.4,41,17838,75,NULL,'Edat, raw','NGC 2634',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56931,'D-Sigma','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56931,33.4,0.4,47.8,17838,75,NULL,'Edat, cor','NGC 2634',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56932,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56932,33.43,0.41,48.5,17838,NULL,NULL,NULL,'NGC 2634',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56933,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56933,33.59,0.41,52.2,17838,NULL,NULL,'Malmquist cor.','NGC 2634',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56934,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56934,37.27,0.46,284,17839,70,NULL,NULL,'2MASX J08482559+1805588',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,132.106625,18.09956,0.049,NULL,63879918696,998123729,15595683,17.2),(56935,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56935,37.86,0.19,373,17840,70,NULL,NULL,'SDSS J084826.73+244721.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,132.111416667,24.78925,0.093,NULL,63788728501,996698882,15573420,18.5),(56936,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56936,37.56,0.46,326,17841,70,NULL,NULL,'2MASX J08482779+2238008',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000194,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,132.11575,22.63367,0.101,NULL,63800682625,996885666,15576338,16.3),(56937,'GRB','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56937,42.81,1.65,1880,17842,69.7,NULL,'Fiducial','GRB 051016B',0.94,'2009MNRAS.400..775C',2009,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,132.115875,13.65556,0.081,NULL,63844887315,997576364,15587130,NULL),(56938,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56938,38.3,0.46,458,17843,70,NULL,NULL,'SDSS J084828.14+220333.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000146,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,132.11725,22.05931,0.101,NULL,63800819987,996887812,15576372,18.7),(56939,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56939,36.98,0.27,249,17844,70,NULL,NULL,'2MASX J08482823+3218564',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,132.117833333,32.31578,0.073,NULL,64383125183,1005986330,15718536,17),(56940,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56940,36.67,0.46,215,17845,70,NULL,NULL,'2MASX J08482853+1744286',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000164,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,132.11875,17.74117,0.045,NULL,63883111434,998173616,15596462,17.1),(56941,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56941,38.05,0.46,407,17846,70,NULL,NULL,'2MASX J08482874+1144309',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000189,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,132.1197083,11.74208,0.117,NULL,63662858254,994732160,15542690,16.7),(56942,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56942,37.19,0.46,274,17847,70,NULL,NULL,'2MASX J08482898+1651036',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000163,NULL,'18.60',0.22,NULL,NULL,NULL,NULL,NULL,1,132.120833,16.85108,0.069,NULL,63881075072,998141798,15595965,18.6),(56943,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56943,36.96,0.46,246,17848,70,NULL,NULL,'2MASX J08482997+1429356',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000177,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,132.125,14.49325,0.053,NULL,63843002098,997546907,15586670,16.7),(56944,'SNIa','2016-12-15 15:14:24','2016-12-16 11:19:30','1','SN 2002X',NULL,56944,42.76,0.64,1920,17849,72,NULL,'MLCS','H-ZSNS J084830.54+441535.3',0.859,'2004ApJ...602..571B',2004,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,132.12725,44.25981,0.097,NULL,64282984155,1004421627,15694087,NULL),(56945,'SNIa','2016-12-15 15:14:24','2016-12-16 11:19:30','1','SN 2002X','R',56945,43.24,NULL,2390,17849,65,NULL,'SALT','H-ZSNS J084830.54+441535.3',0.859,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56946,'SNIa','2016-12-15 15:14:24','2016-12-16 11:19:30','1','SN 2002X',NULL,56946,43.38,0.3,2550,17849,74.2,NULL,'SALT 2','H-ZSNS J084830.54+441535.3',0.859,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56947,'SNIa','2016-12-15 15:14:24','2016-12-16 11:19:30','1','SN 2002X',NULL,56947,43.63,0.43,2860,17849,72,NULL,'BATM','H-ZSNS J084830.54+441535.3',0.859,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56948,'SNIa','2016-12-15 15:14:24','2016-12-16 11:19:30','1','SN 2002X',NULL,56948,44.02,0.3,3430,17849,70,NULL,'SALT','H-ZSNS J084830.54+441535.3',0.859,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56949,'SNIa','2016-12-15 15:14:24','2016-12-16 11:19:30','1','SN 2002X',NULL,56949,44.23,0.28,3770,17849,65,NULL,'SALT','H-ZSNS J084830.54+441535.3',0.859,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56950,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56950,37.62,0.46,334,17850,70,NULL,NULL,'2MASX J08483104+0404081',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000185,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,132.129333333,4.06878,0.145,NULL,63629270333,994207348,15534489,17),(56951,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56951,38.31,0.13,460,17851,70,NULL,NULL,'2MASX J08483144+2921186',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,132.130875,29.35511,0.113,NULL,64313592075,1004899876,15701560,17.3),(56952,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56952,37.86,0.19,373,17852,70,NULL,NULL,'2MASX J08483183+2434132',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,132.1327083,24.57039,0.101,NULL,63788684583,996698196,15573409,17.5),(56953,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56953,38.67,0.46,541,17853,70,NULL,NULL,'SDSS J084833.07+311132.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000179,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,132.137833,31.19228,0.097,NULL,64386321047,1006036266,15719316,18.5),(56954,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56954,38.24,0.46,445,17854,70,NULL,NULL,'2MASX J08483338+4046068',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000177,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,132.139167,40.76853,0.073,NULL,64247808916,1003872014,15685500,18.2),(56955,'SNIa','2016-12-15 15:14:24','2016-12-16 11:19:30','1','PS1 SN PS10bki','N',56955,42.15,0.15,1880,17855,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10bki HOST',0.4306,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56956,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56956,37.34,0.46,293,17856,70,NULL,NULL,'2MASX J08483487+1940078',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,132.145333,19.66889,0.057,NULL,63828201204,997315643,15583056,17.2),(56957,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56957,37.38,0.23,300,17857,70,NULL,NULL,'2MASX J08483552+1115449',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,132.148,11.26258,0.105,NULL,63664450125,994757033,15543078,16.5),(56958,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56958,36.98,0.27,249,17858,70,NULL,NULL,'2MASX J08483612+3211194',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,132.1505,32.18858,0.065,NULL,64386207448,1006034491,15719288,17),(56959,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56959,36.98,0.27,249,17859,70,NULL,NULL,'2MASX J08483707+3212144',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000158,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,132.1545,32.20394,0.065,NULL,64386207043,1006034485,15719288,16.9),(56960,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56960,37.52,0.46,320,17860,70,NULL,NULL,'SDSS J084837.33+293937.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000171,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,132.155583,29.66053,0.125,NULL,64383804473,1005996944,15718702,18.1),(56961,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56961,36.88,0.17,238,17861,70,NULL,NULL,'2MASX J08483759+5347320',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000091,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,132.1564583,53.79233,0.065,NULL,63488922283,992014410,15500225,16.8),(56962,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56962,32.49,0.49,31.5,17862,75,NULL,'IR','NGC 2634A',NULL,'2011yCatp016004901K',2011,1,1.8,NULL,'G',0.00003,NULL,'14.36',0.4,'SB(s)bc? sp','in a pair',NULL,NULL,NULL,1,132.158917,73.93928,0.025,NULL,61288156920,957627451,14962928,14.36),(56963,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56963,37.92,0.46,384,17863,70,NULL,NULL,'2MASX J08483865+1819148',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,132.161,18.32083,0.049,NULL,63879957627,998124337,15595692,17.5),(56964,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56964,37.31,0.15,289,17864,70,NULL,NULL,'2MASX J08483896+0901309',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,132.1625,9.02536,0.193,NULL,63658251121,994660173,15541565,17.2),(56965,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56965,38.35,0.46,467,17865,70,NULL,NULL,'2MASX J08483907+0618319',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000175,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,132.162833333,6.30881,0.169,NULL,63674212464,994909569,15545462,17.8),(56966,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56966,37.17,0.46,271,17866,70,NULL,NULL,'2MASX J08483922+2248328',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000157,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,132.163291667,22.80922,0.101,NULL,63789204026,996706312,15573536,17),(56967,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56967,38.49,0.46,498,17867,70,NULL,NULL,'2MASX J08483956+3653378',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000148,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,132.165083,36.89389,0.061,NULL,64367929939,1005748905,15714826,18.4),(56968,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56968,38.53,0.46,507,17868,70,NULL,NULL,'2MASX J08483981+2731592',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,132.165875,27.53308,0.117,NULL,64308578287,1004821535,15700336,17.7),(56969,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56969,37.31,0.15,289,17869,70,NULL,NULL,'2MASX J08483998+0906499',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000161,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,132.166667,9.11397,0.193,NULL,63658108784,994657949,15541530,18.1),(56970,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56970,38.52,0.46,506,17870,70,NULL,NULL,'SDSS J084840.09+331310.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,132.167083,33.21964,0.097,NULL,64420007059,1006562610,15727540,18.2),(56971,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56971,38.48,0.46,497,17871,70,NULL,NULL,'2MASX J08484056+1123359',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,132.169,11.39333,0.105,NULL,63664430448,994756725,15543073,17.8),(56972,'BL Lac Luminosity','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56972,41.29,NULL,1810,17872,NULL,NULL,'Min. z = 0.57','1FGL J0848.6+0504',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,132.171,5.081,0.165,NULL,63631420106,994240939,15535014,NULL),(56973,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56973,37.41,0.46,303,17873,70,NULL,NULL,'2MASX J08484165+2343013',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,132.173625,23.71722,0.081,NULL,63790356487,996724320,15573817,17.9),(56974,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56974,36.88,0.17,238,17874,70,NULL,NULL,'2MASX J08484312+5347540',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000107,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,132.179875,53.79822,0.065,NULL,63488924955,992014452,15500225,16.3),(56975,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56975,38.55,0.46,514,17875,70,NULL,NULL,'SDSS J084843.42+524344.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000094,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,132.1809583,52.72908,0.085,NULL,63487451730,991991433,15499866,18.3),(56976,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56976,37.62,0.46,334,17876,70,NULL,NULL,'2MASX J08484391+0804199',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000153,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,132.182875,8.07219,0.161,NULL,63676242397,994941287,15545957,17.8),(56977,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56977,36.71,0.46,220,17877,70,NULL,NULL,'2MASX J08484420+0010071',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000091,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,132.18425,0.1685,0.117,NULL,62559100536,977485945,15273217,16.4),(56978,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56978,36.8,0.46,229,17878,70,NULL,NULL,'2MASX J08484448+0419551',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,132.185333333,4.33203,0.149,NULL,63629404621,994209447,15534522,16.6),(56979,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56979,38.33,0.46,463,17879,70,NULL,NULL,'2MASX J08484722+0453419',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,132.196917,4.89506,0.161,NULL,63631487069,994241985,15535031,18),(56980,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56980,37.5,0.46,316,17880,70,NULL,NULL,'2MASX J08484766+5035590',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,132.198333,50.59969,0.061,NULL,64237977598,1003718399,15683099,16.8),(56981,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56981,36.4,0.27,191,17881,70,NULL,NULL,'2MASX J08484842+3451424',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000173,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,132.201833333,34.86178,0.077,NULL,64419058663,1006547791,15727309,16.3),(56982,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56982,37.31,0.15,289,17882,70,NULL,NULL,'2MASX J08484890+0902175',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,132.2037917,9.03817,0.193,NULL,63658235451,994659928,15541561,17.5),(56983,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56983,37.32,0.46,291,17883,70,NULL,NULL,'2MASX J08484984+0435219',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00016,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,132.2077917,4.58936,0.149,NULL,63629198869,994206232,15534472,16.7),(56984,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56984,34.51,NULL,79.9,17884,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04611',NULL,'2010Ap&SS.325..163P',2010,1,2.13,NULL,'G',0.000018,NULL,'15.42',0.19,'Scd',NULL,NULL,NULL,NULL,1,132.212,29.87025,0.125,NULL,64383783591,1005996618,15718697,15.42),(56985,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56985,34.52,NULL,80.2,17884,NULL,NULL,'Dipole + Quadrupole','UGC 04611',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56986,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56986,34.52,NULL,80.3,17884,NULL,NULL,'Dipole','UGC 04611',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56987,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56987,34.57,NULL,82.1,17884,NULL,NULL,NULL,'UGC 04611',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56988,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56988,34.86,0.2,93.8,17884,74.4,NULL,NULL,'UGC 04611',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56989,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56989,35.1,0.38,105,17884,NULL,NULL,'Malmquist cor.','UGC 04611',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56990,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,56990,35.17,0.36,108,17884,NULL,NULL,NULL,'UGC 04611',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(56991,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56991,37.31,0.15,289,17885,70,NULL,NULL,'CGCG 061-015',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000107,NULL,'15.7',0.5,'BrClG',NULL,NULL,NULL,NULL,1,132.2137083,9.02269,0.193,NULL,63658252631,994660197,15541565,15.7),(56992,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56992,37.31,0.15,289,17886,70,NULL,NULL,'CGCG 061-015',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000107,NULL,'15.7',0.5,'BrClG',NULL,NULL,NULL,NULL,1,132.2137083,9.02269,0.193,NULL,63658252631,994660197,15541565,15.7),(56993,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56993,38.88,0.46,597,17887,70,NULL,NULL,'2MASX J08485254+6140430',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,132.21875,61.67858,0.125,NULL,62060076442,969688694,15151385,NULL),(56994,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56994,36.8,0.46,229,17888,70,NULL,NULL,'2MASX J08485324+5359226',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000071,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,132.221833,53.98967,0.041,NULL,63488847305,992013239,15500206,17.3),(56995,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56995,38.44,0.46,488,17889,70,NULL,NULL,'2MASX J08485537+2003364',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,132.2307917,20.06028,0.057,NULL,63828344321,997317880,15583091,18.1),(56996,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56996,36.7,0.46,219,17890,70,NULL,NULL,'2MASX J08485604+3614587',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000117,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,132.233666667,36.24956,0.085,NULL,64418278301,1006535598,15727118,17.8),(56997,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56997,37.86,0.19,373,17891,70,NULL,NULL,'2MASX J08485697+2431001',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000191,NULL,'16.8g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,132.23725,24.51683,0.101,NULL,63790720316,996730004,15573906,16.8),(56998,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56998,36.4,0.27,191,17892,70,NULL,NULL,'2MASX J08485808+3454153',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000186,NULL,'15.7g',0.49,'E0',NULL,NULL,NULL,NULL,1,132.242125,34.90419,0.077,NULL,64419060491,1006547820,15727309,15.7),(56999,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',56999,36.81,0.46,230,17893,70,NULL,NULL,'2MASX J08485819+2607441',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000187,NULL,'16.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,132.242458333,26.12886,0.097,NULL,64310617879,1004853404,15700834,16.6),(57000,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',57000,37.74,0.46,353,17894,70,NULL,NULL,'2MASX J08485924+0555550',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000181,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,132.246791667,5.93203,0.157,NULL,63628368774,994193262,15534269,17.3),(57001,'FP','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',57001,34.74,0.46,88.9,17895,70,NULL,NULL,'CGCG 208-047',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000157,NULL,'14.6g',0.57,NULL,NULL,NULL,NULL,NULL,1,132.2485,41.00317,0.049,NULL,64247767522,1003871367,15685490,14.6),(57002,'SNIa','2016-12-15 15:14:24','2016-12-16 11:19:30','1','PS1 SN PS10bzt','N',57002,41.76,0.21,1580,17896,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10bzt HOST',0.4206,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57003,'IRAS','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,57003,33.15,0.8,42.6,17897,75,NULL,'MAT, I','MCG -01-23-002',NULL,'1997ApJS..109..333W',1997,1,1.5,'MCG notes say that dec. for MCG -01-23 zone is off by 8\'.','G',0.000023,NULL,'13.5',1,'SB(s)bc',NULL,NULL,NULL,NULL,1,132.2515417,-7.82983,0.085,NULL,42204885713,659451339,10303927,13.5),(57004,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,57004,32.45,0.32,30.9,17897,85,NULL,'I, raw','MCG -01-23-002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57005,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,57005,32.46,0.32,31.1,17897,85,NULL,'I, inv','MCG -01-23-002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57006,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',57006,32.61,0.4,33.3,17897,75,NULL,NULL,'MCG -01-23-002',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57007,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,57007,32.74,0.43,35.3,17897,75,NULL,'MAT, I, raw','MCG -01-23-002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57008,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,57008,32.84,0.43,36.9,17897,75,NULL,'MAT, I, inv','MCG -01-23-002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57009,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,57009,32.86,0.43,37.3,17897,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-23-002',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57010,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,'R',57010,32.88,0.49,37.7,17897,75,NULL,'IR','MCG -01-23-002',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57011,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,57011,32.94,0.43,38.7,17897,75,NULL,'3.6 micron, color corrected','MCG -01-23-002',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57012,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,57012,32.96,0.43,39,17897,75,NULL,'MAT, I, cor','MCG -01-23-002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57013,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,57013,33.04,0.2,40.6,17897,74.4,NULL,NULL,'MCG -01-23-002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57014,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,57014,33.21,0.51,43.8,17897,NULL,NULL,NULL,'MCG -01-23-002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57015,'Tully-Fisher','2016-12-15 15:14:24','2016-12-16 11:19:30','1',NULL,NULL,57015,33.36,0.48,46.9,17897,NULL,NULL,'Malmquist cor.','MCG -01-23-002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57016,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:30','1',NULL,NULL,57016,33.44,0.4,48.8,17897,NULL,NULL,'mean','MCG -01-23-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57017,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:30','1',NULL,NULL,57017,33.6,0.47,52.5,17897,NULL,NULL,'H','MCG -01-23-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57018,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:30','1',NULL,NULL,57018,33.69,0.46,54.7,17897,NULL,NULL,'J','MCG -01-23-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57019,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:30','1',NULL,NULL,57019,33.71,0.45,55.3,17897,NULL,NULL,'K','MCG -01-23-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57020,'FP','2016-12-15 15:14:25','2016-12-16 11:19:30','1',NULL,'R',57020,35.77,0.46,143,17898,70,NULL,NULL,'UGC 04609',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000037,NULL,'15.2g',0.57,'Peculiar',NULL,NULL,NULL,NULL,1,132.255,41.19922,0.057,NULL,64248120481,1003876882,15685576,15.2),(57021,'FP','2016-12-15 15:14:25','2016-12-16 11:19:30','1',NULL,'R',57021,35.33,0.46,117,17899,70,NULL,NULL,'2MASX J08490354+4629139',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000154,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,132.264625,46.48711,0.089,NULL,64286028574,1004469196,15694831,16.3),(57022,'FP','2016-12-15 15:14:25','2016-12-16 11:19:30','1',NULL,'R',57022,38.2,0.46,437,17900,70,NULL,NULL,'SDSS J084905.77+570719.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000074,NULL,'18.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,132.2740417,57.12211,0.185,NULL,62022466834,969101044,15142203,18.8),(57023,'TRGB','2016-12-15 15:14:25','2016-12-16 11:19:30','1',NULL,NULL,57023,29.67,0.1,8.6,17901,74.4,NULL,NULL,'ESO 496- G 010',NULL,'2013AJ....146...86T',2013,1,1.2,'Possible cross-ID with HIPASS J0848-26 (2011AJ....142...83N).','G',0.00015,NULL,'15',0.8,'Sa:',NULL,NULL,NULL,NULL,1,132.275083,-26.32169,0.261,NULL,42718849692,667482026,10429406,15),(57024,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:30','1',NULL,NULL,57024,29.46,NULL,7.8,17901,NULL,NULL,NULL,'ESO 496- G 010',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57025,'FP','2016-12-15 15:14:25','2016-12-16 11:19:30','1',NULL,'R',57025,37.36,0.46,297,17902,70,NULL,NULL,'2MASX J08490648+5607485',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000071,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,132.2769583,56.13006,0.153,NULL,61540606744,961571980,15024562,17.4),(57026,'FP','2016-12-15 15:14:25','2016-12-16 11:19:30','1',NULL,'R',57026,36.54,0.46,203,17903,70,NULL,NULL,'SDSS J084907.92+013556.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000072,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,132.283041667,1.59911,0.097,NULL,62561228366,977519193,15273737,17.6),(57027,'FP','2016-12-15 15:14:25','2016-12-16 11:19:30','1',NULL,'R',57027,37.37,0.46,298,17904,70,NULL,NULL,'2MASX J08490841+2943476',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000145,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,132.2850417,29.73,0.125,NULL,64383789538,1005996711,15718698,18.2),(57028,'FP','2016-12-15 15:14:25','2016-12-16 11:19:30','1',NULL,'R',57028,37.31,0.15,289,17905,70,NULL,NULL,'SDSS J084908.49+090348.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000144,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,132.285417,9.0635,0.193,NULL,63658240588,994660009,15541562,18.4),(57029,'FP','2016-12-15 15:14:25','2016-12-16 11:19:30','1',NULL,'R',57029,38.07,0.46,411,17906,70,NULL,NULL,'2MASX J08490956+1512149',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,132.289917,15.20403,0.073,NULL,63850114280,997658035,15588406,17.5),(57030,'FP','2016-12-15 15:14:25','2016-12-16 11:19:30','1',NULL,'R',57030,37.31,0.15,289,17907,70,NULL,NULL,'2MASX J08491104+0902184',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00018,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,132.295916667,9.03842,0.193,NULL,63658240067,994660001,15541562,17.2),(57031,'Tully est','2016-12-15 15:14:25','2016-12-16 11:19:30','1',NULL,NULL,57031,31.83,0.8,23.3,17908,75,NULL,'B','NGC 2654',NULL,'1988NBGC.C....0000T',1988,1,4.3,NULL,'G',0.00001,NULL,'12.74',0.8,'SBab: sp;AGN?  RET','Isolated galaxy',NULL,NULL,NULL,1,132.299458333,60.22111,0.161,NULL,62066478061,969788719,15152948,12.74),(57032,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:30','1',NULL,'R',57032,31.71,0.4,22,17908,75,NULL,NULL,'NGC 2654',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57033,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57033,31.82,0.4,23.2,17908,NULL,NULL,'mean','NGC 2654',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57034,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57034,32.15,0.49,26.9,17908,75,NULL,'IR','NGC 2654',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57035,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57035,32.15,0.47,26.9,17908,NULL,NULL,'H','NGC 2654',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57036,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57036,32.15,0.46,26.9,17908,NULL,NULL,'J','NGC 2654',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57037,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57037,32.2,0.45,27.5,17908,NULL,NULL,'K','NGC 2654',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57038,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57038,32.34,0.4,29.4,17908,NULL,NULL,NULL,'NGC 2654',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57039,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57039,32.52,0.2,31.9,17908,74.4,NULL,NULL,'NGC 2654',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57040,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57040,32.56,0.43,32.6,17908,75,NULL,'3.6 micron, color corrected','NGC 2654',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57041,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57041,32.7,0.43,34.6,17908,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2654',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57042,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57042,37.28,0.27,286,17909,70,NULL,NULL,'2MASX J08491335+1500359',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000185,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,132.3055417,15.00989,0.081,NULL,63850079745,997657496,15588398,17.6),(57043,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57043,34.63,0.46,84.5,17910,70,NULL,NULL,'CGCG 120-039',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000088,NULL,'15.5g',0.42,NULL,NULL,NULL,NULL,NULL,1,132.308667,23.38028,0.081,NULL,63789772777,996715199,15573674,15.5),(57044,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57044,37.4,0.46,302,17911,70,NULL,NULL,'2MASX J08491453+1725428',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00018,NULL,'18.62',0.31,NULL,NULL,NULL,NULL,NULL,1,132.310667,17.4285,0.081,NULL,63883125543,998173836,15596466,18.62),(57045,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57045,37.61,0.46,333,17912,70,NULL,NULL,'2MASX J08491470+2125208',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000156,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,132.31125,21.42253,0.105,NULL,63826927164,997295736,15582745,17.3),(57046,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57046,38.31,0.13,460,17913,70,NULL,NULL,'2MASX J08491632+2932456',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000162,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,132.317958333,29.546,0.113,NULL,64383837496,1005997460,15718710,18.3),(57047,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2005ms',NULL,57047,34.68,0.17,84.2,17914,74.2,NULL,'SALT 2','UGC 04614',0.025204,'2010ApJ...716..712A',2010,1,0.7,NULL,'G',0.00003,NULL,'14.5g',0.67,'S?',NULL,NULL,NULL,NULL,1,132.318291667,36.11981,0.077,NULL,64418268991,1006535452,15727116,14.5),(57048,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2005ms',NULL,57048,35.23,0.09,111,17914,74.4,NULL,NULL,'UGC 04614',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57049,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2005ms',NULL,57049,35.3,0.02,112,17914,70,NULL,'SALT 2','UGC 04614',0.025204,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57050,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2005ms',NULL,57050,35.33,0.02,114,17914,72,NULL,'SALT','UGC 04614',0.025204,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57051,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2005ms',NULL,57051,35.42,0.16,119,17914,70,NULL,'SALT 2','UGC 04614',0.025204,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57052,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2005ms',NULL,57052,35.44,0.15,119,17914,73.8,NULL,'SALT 2 (SNANA)','UGC 04614',0.0266,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57053,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2005ms','R',57053,35.38,0.06,119,17914,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 04614',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57054,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2005ms','R',57054,35.43,0.07,122,17914,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 04614',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57055,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2005ms',NULL,57055,35.49,0.18,122,17914,65,NULL,'SALT','UGC 04614',0.025204,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57056,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2005ms',NULL,57056,35.51,0.19,124,17914,65,NULL,'SALT2','UGC 04614',0.025204,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57057,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2005ms',NULL,57057,35.62,0.16,130,17914,65,NULL,'MLCS17','UGC 04614',0.025204,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57058,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2005ms',NULL,57058,35.67,0.16,133,17914,65,NULL,'MLCS31','UGC 04614',0.025204,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57059,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57059,37.75,0.33,355,17915,70,NULL,NULL,'2MASX J08491639+5726223',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,132.318333333,57.43958,0.189,NULL,62022409952,969100155,15142189,17.6),(57060,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57060,33.57,0.57,51.7,17916,70,NULL,NULL,'ESO 563- G 024',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000063,NULL,'15',1,'S0',NULL,NULL,NULL,NULL,1,132.329,-19.00411,0.529,NULL,42354655679,661791494,10340492,15),(57061,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57061,38.31,0.13,460,17917,70,NULL,NULL,'SDSS J084919.69+293630.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000129,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,132.332083,29.60853,0.085,NULL,64383836847,1005997450,15718710,18.7),(57062,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57062,37.68,0.46,344,17918,70,NULL,NULL,'SDSS J084919.78+285952.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,132.332416667,28.99794,0.105,NULL,64313374288,1004896473,15701507,17.6),(57063,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57063,36.4,0.27,191,17919,70,NULL,NULL,'2MASX J08492068+3455493',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,132.33625,34.93033,0.077,NULL,64419069092,1006547954,15727311,17.4),(57064,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57064,37.62,0.46,334,17920,70,NULL,NULL,'SDSS J084921.10+221943.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000144,NULL,'18.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,132.337917,22.32889,0.101,NULL,63800624976,996884765,15576324,18.3),(57065,'D-Sigma','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57065,33.34,0.4,46.5,17921,75,NULL,'Edat, raw','NGC 2672',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000033,NULL,'12.7',2.8,'E1-2','Pair member (points to parent)',NULL,NULL,NULL,1,132.3412083,19.07497,0.049,NULL,63825009062,997265766,15582277,12.7),(57066,'D-Sigma','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57066,33.55,0.4,51.4,17921,75,NULL,'Edat, cor','NGC 2672',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57067,'Faber-Jackson','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57067,33.1,0.29,41.7,17921,95,NULL,'Weighted Mean','NGC 2672',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57068,'Faber-Jackson','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57068,33.24,0.39,44.5,17921,95,NULL,'de Vaucouleurs','NGC 2672',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57069,'Faber-Jackson','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57069,33.27,0.46,45.1,17921,95,NULL,'Michard 1979a','NGC 2672',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57070,'Faber-Jackson','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57070,33.45,0.63,49,17921,95,NULL,'Michard 1979b, c','NGC 2672',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57071,'Faber-Jackson','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57071,34.96,1.61,98.2,17921,55,NULL,'Visvanathan & Sandage 1979','NGC 2672',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57072,'Tertiary','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57072,32.91,0.5,38.2,17921,95,NULL,NULL,'NGC 2672',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57073,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57073,33.85,0.45,58.9,17921,NULL,NULL,'K','NGC 2672',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57074,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57074,34.04,0.4,64.2,17921,NULL,NULL,'mean','NGC 2672',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57075,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57075,36.09,0.46,165,17922,70,NULL,NULL,'2MASX J08492250+2414536',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000178,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,132.343791667,24.24833,0.089,NULL,63791031663,996734869,15573982,16.8),(57076,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57076,35.37,0.4,118,17923,NULL,NULL,'mean','NGC 2668',NULL,'2007A&A...465...71T',2007,1,1.26,NULL,'G',0.00003,NULL,'14.3g',0.73,'Sab',NULL,NULL,NULL,NULL,1,132.344,36.71033,0.069,NULL,64367894106,1005748345,15714817,14.3),(57077,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57077,35.56,0.47,130,17923,NULL,NULL,'H','NGC 2668',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57078,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57078,35.66,0.46,136,17923,NULL,NULL,'J','NGC 2668',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57079,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57079,34.83,NULL,92.3,17924,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04586',NULL,'2010Ap&SS.325..163P',2010,1,1.19,NULL,'G',NULL,NULL,'16.5',0.13,'Sc',NULL,NULL,NULL,NULL,1,132.3462083,75.29236,0.021,NULL,61407554442,959493038,14992078,16.5),(57080,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57080,34.84,NULL,92.8,17924,NULL,NULL,'Dipole + Quadrupole','UGC 04586',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57081,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57081,34.85,NULL,93.4,17924,NULL,NULL,'Dipole','UGC 04586',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57082,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57082,34.88,NULL,94.7,17924,NULL,NULL,NULL,'UGC 04586',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57083,'D-Sigma','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57083,33.34,0.4,46.5,17925,75,NULL,'Edat, raw','NGC 2673',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.00002,NULL,'14.3g',1.2,'E0 pec','Pair member (points to parent)',NULL,NULL,NULL,1,132.350583,19.07419,0.049,NULL,63825009628,997265775,15582277,14.3),(57084,'D-Sigma','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57084,33.55,0.4,51.4,17925,75,NULL,'Edat, cor','NGC 2673',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57085,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2001hx',NULL,57085,42.65,0.24,1880,17926,74.2,NULL,'SALT 2','H-ZSNS J084924.61+440222.4',0.799,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,132.3525417,44.03956,0.133,NULL,64287209112,1004487642,15695119,NULL),(57086,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2001hx',NULL,57086,43.17,0.27,2390,17926,70,NULL,'SALT','H-ZSNS J084924.61+440222.4',0.799,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57087,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2001hx',NULL,57087,43.21,0.25,2440,17926,65,NULL,'SALT','H-ZSNS J084924.61+440222.4',0.799,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57088,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2001hx',NULL,57088,43.24,0.33,2470,17926,72,NULL,'dm15','H-ZSNS J084924.61+440222.4',0.799,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57089,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2001hx','R',57089,43.42,NULL,2690,17926,65,NULL,'SALT','H-ZSNS J084924.61+440222.4',0.799,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57090,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2001hx',NULL,57090,43.65,0.36,2990,17926,72,NULL,'MLCS','H-ZSNS J084924.61+440222.4',0.799,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57091,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2001hx',NULL,57091,43.81,0.44,3210,17926,72,NULL,'BATM','H-ZSNS J084924.61+440222.4',0.799,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57092,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2001hx',NULL,57092,43.88,0.31,3320,17926,65,NULL,NULL,'H-ZSNS J084924.61+440222.4',0.799,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57093,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57093,36.89,0.46,239,17927,70,NULL,NULL,'2MASX J08492476+3322213',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000185,NULL,'15.7g',0.47,'E0',NULL,NULL,NULL,NULL,1,132.353417,33.37272,0.081,NULL,64420049362,1006563271,15727551,15.7),(57094,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57094,35.04,0.46,102,17928,70,NULL,NULL,'MCG -01-23-003',NULL,'2014MNRAS.445.2677S',2014,1,0.5,'MCG notes say that dec. for MCG -01-23 zone is off by 8\'.','G',0.000087,NULL,'15.5',0.5,NULL,NULL,NULL,NULL,NULL,1,132.3545417,-6.68053,0.061,NULL,42203803413,659434428,10303662,15.5),(57095,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57095,38.52,0.46,505,17929,70,NULL,NULL,'2MASX J08492524+0900401',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000145,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,132.3552917,9.01125,0.133,NULL,63658246794,994660106,15541564,18.5),(57096,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57096,35.45,0.5,123,17930,70,NULL,NULL,'2MASX J08492622-7255195',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'19.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,132.35925,-72.92208,0.485,NULL,40618085367,634657583,9916524,19.2),(57097,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57097,37.75,0.33,355,17931,70,NULL,NULL,'2MASX J08492708+5719044',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000076,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,132.362917,57.31789,0.189,NULL,62022395544,969099930,15142186,17.4),(57098,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57098,35.48,0.44,124,17932,NULL,NULL,'Malmquist cor.','UGC 04617',NULL,'2009ApJS..182..474S',2009,1,1.32,NULL,'G',0.000023,NULL,'15.3g',0.45,'SAd','Field galaxy',NULL,NULL,NULL,1,132.3632917,29.51997,0.085,NULL,64383841265,1005997519,15718711,15.3),(57099,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57099,35.7,0.4,138,17932,NULL,NULL,NULL,'UGC 04617',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57100,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57100,35.74,0.2,141,17932,74.4,NULL,NULL,'UGC 04617',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57101,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57101,37.53,0.46,321,17933,70,NULL,NULL,'2MASXi J0849273+163249',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000146,NULL,'17.4g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,132.364083,16.54717,0.113,NULL,63881204085,998143813,15595997,17.4),(57102,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57102,37.31,0.15,289,17934,70,NULL,NULL,'2MASX J08492963+0907191',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,132.3735,9.12206,0.193,NULL,63658023696,994656620,15541509,17.8),(57103,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57103,37.41,0.46,304,17935,70,NULL,NULL,'2MASX J08492997+2646346',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,132.374833333,26.7765,0.145,NULL,64310385505,1004849773,15700777,17.2),(57104,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57104,37.31,0.15,289,17936,70,NULL,NULL,'2MASX J08493050+0847470',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000192,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,132.377208333,8.79653,0.133,NULL,63658163494,994658804,15541543,16.4),(57105,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57105,38.17,0.33,431,17937,70,NULL,NULL,'2MASX J08493137+5138368',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000088,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,132.380667,51.64372,0.053,NULL,64224415476,1003506491,15679788,17.7),(57106,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57106,37.53,0.19,320,17938,70,NULL,NULL,'2MASX J08493164+3257173',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000185,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,132.38175,32.955,0.081,NULL,64419845150,1006560080,15727501,18.2),(57107,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57107,37.45,0.46,308,17939,70,NULL,NULL,'2MASX J08493180+4228008',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000166,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,132.3825,42.46686,0.109,NULL,64245892750,1003842074,15685032,16.9),(57108,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57108,35.39,0.46,120,17940,70,NULL,NULL,'CGCG 264-017',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.00008,NULL,'15.0g',0.55,'Sa',NULL,NULL,NULL,NULL,1,132.384458333,50.87417,0.057,NULL,64238122916,1003720670,15683135,15),(57109,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57109,37.23,0.46,280,17941,70,NULL,NULL,'2MASX J08493308+0143411',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000111,NULL,'16.4g',0.31,'AGN',NULL,NULL,NULL,NULL,1,132.387833,1.72803,0.097,NULL,62560718933,977511233,15273613,16.4),(57110,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57110,38.4,0.46,479,17942,70,NULL,NULL,'SDSS J084934.00+195148.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000152,NULL,'18.1g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,132.3917083,19.86344,0.041,NULL,63828704529,997323508,15583179,18.1),(57111,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57111,37.49,0.46,315,17943,70,NULL,NULL,'2MASX J08493596+3222433',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,132.4,32.37878,0.065,NULL,64386038973,1006031858,15719247,17.7),(57112,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57112,38.32,0.46,460,17944,70,NULL,NULL,'2MASX J08493651+4147313',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000158,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,132.402166667,41.79206,0.113,NULL,64247920296,1003873754,15685527,17.5),(57113,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57113,37.59,0.46,329,17945,70,NULL,NULL,'SDSS J084936.78+025147.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000176,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,132.40325,2.86325,0.113,NULL,62560227612,977503556,15273493,17.8),(57114,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57114,38.31,0.13,460,17946,70,NULL,NULL,'2MASX J08493788+2936121',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000198,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,132.408,29.60331,0.085,NULL,64383872133,1005998002,15718718,17.7),(57115,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57115,37.72,0.46,350,17947,70,NULL,NULL,'2MASX J08493841+3440383',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,132.410166667,34.67739,0.073,NULL,64418875731,1006544933,15727264,18.3),(57116,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57116,36.92,0.46,242,17948,70,NULL,NULL,'2MASX J08494055+2309228',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,132.419,23.15633,0.089,NULL,63789959474,996718116,15573720,17.4),(57117,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57117,36.76,0.46,225,17949,70,NULL,NULL,'2MASX J08494065+1104120',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.2g',0.32,NULL,NULL,NULL,NULL,NULL,1,132.419458333,11.07,0.121,NULL,63664498052,994757782,15543090,16.2),(57118,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57118,37.07,0.46,259,17950,70,NULL,NULL,'2MASX J08494070+3143223',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000172,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,132.419667,31.72283,0.101,NULL,64386712353,1006042380,15719412,16.7),(57119,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57119,37.41,0.46,304,17951,70,NULL,NULL,'2MASX J08494171+1359233',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000229,NULL,'16.0g',0.36,NULL,NULL,NULL,NULL,NULL,1,132.4239583,13.98978,0.097,NULL,63842917542,997545586,15586649,16),(57120,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57120,35.82,0.46,146,17952,70,NULL,NULL,'2MASX J08494174+3650023',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.0001,NULL,'16.1g',0.4,'E0',NULL,NULL,NULL,NULL,1,132.424,36.83403,0.069,NULL,64367914097,1005748657,15714822,16.1),(57121,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57121,38.08,0.46,412,17953,70,NULL,NULL,'2MASX J08494269+3330023',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000156,NULL,'17.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,132.427917,33.50072,0.081,NULL,64420001381,1006562521,15727539,17.1),(57122,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57122,36.25,0.27,178,17954,70,NULL,NULL,'MCG +10-13-018',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000101,NULL,'15.6g',0.48,'E0',NULL,NULL,NULL,NULL,1,132.4370417,57.15644,0.185,NULL,62022455551,969100867,15142201,15.6),(57123,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2001hy',NULL,57123,42.94,0.39,2140,17955,74.2,NULL,'SALT 2','H-ZSNS J084945.85+441531.8',0.812,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,132.4410417,44.25883,0.105,NULL,64287373565,1004490211,15695159,NULL),(57124,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2001hy',NULL,57124,43.52,0.41,2790,17955,72,NULL,'MLCS','H-ZSNS J084945.85+441531.8',0.812,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57125,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2001hy','R',57125,43.64,NULL,2960,17955,65,NULL,'SALT','H-ZSNS J084945.85+441531.8',0.812,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57126,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2001hy',NULL,57126,43.81,0.28,3190,17955,70,NULL,'SALT','H-ZSNS J084945.85+441531.8',0.812,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57127,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2001hy',NULL,57127,43.96,0.37,3420,17955,72,NULL,'BATM','H-ZSNS J084945.85+441531.8',0.812,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57128,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2001hy',NULL,57128,43.97,0.35,3430,17955,65,NULL,NULL,'H-ZSNS J084945.85+441531.8',0.812,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57129,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2001hy',NULL,57129,43.98,0.26,3450,17955,65,NULL,'SALT','H-ZSNS J084945.85+441531.8',0.812,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57130,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57130,37.34,0.46,293,17956,70,NULL,NULL,'2MASX J08494607+1510433',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,132.442083,15.17875,0.081,NULL,63850103795,997657871,15588404,16.9),(57131,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57131,38.31,0.13,460,17957,70,NULL,NULL,'2MASX J08494633+2930272',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,132.442875,29.50747,0.085,NULL,64383863244,1005997863,15718716,18.1),(57132,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57132,37.57,0.46,327,17958,70,NULL,NULL,'SDSS J084948.45+223105.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,132.451875,22.51811,0.097,NULL,63789234179,996706784,15573543,17.6),(57133,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57133,37.04,0.46,256,17959,70,NULL,NULL,'2MASX J08494850+4819227',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000158,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,132.4522917,48.32308,0.089,NULL,64229095459,1003579616,15680931,16.3),(57134,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57134,37.28,0.27,286,17960,70,NULL,NULL,'2MASX J08494854+1506372',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000117,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,132.452375,15.11019,0.081,NULL,63842648324,997541380,15586584,18.1),(57135,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57135,36.18,0.46,172,17961,70,NULL,NULL,'2MASX J08494910+5105377',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00007,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,132.454625,51.09389,0.077,NULL,64238010725,1003718917,15683108,16.4),(57136,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57136,38.68,0.46,544,17962,70,NULL,NULL,'2MASX J08494942+2737532',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00018,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,132.4557917,27.63156,0.109,NULL,64309129964,1004830155,15700471,17.5),(57137,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57137,37.28,0.27,286,17963,70,NULL,NULL,'SDSS J084949.46+150545.5',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.3g',0.35,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,132.456125,15.096,0.081,NULL,63842651747,997541433,15586584,16.3),(57138,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57138,38.78,0.46,570,17964,70,NULL,NULL,'SDSS J084950.32+384123.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000139,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,132.459708333,38.68986,0.097,NULL,64369368452,1005771382,15715177,18.6),(57139,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57139,38.28,0.46,453,17965,70,NULL,NULL,'2MASX J08495110+1921304',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,132.462875,19.35847,0.029,NULL,63828548106,997321064,15583141,18.5),(57140,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57140,38.04,0.46,405,17966,70,NULL,NULL,'2MASX J08495153+2031304',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00018,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,132.464666667,20.52508,0.057,NULL,63827208225,997300128,15582814,17.5),(57141,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57141,36.25,0.27,178,17967,70,NULL,NULL,'SDSS J084951.75+570837.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000076,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,132.465625,57.14375,0.185,NULL,62022329251,969098894,15142170,17.6),(57142,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57142,37.88,0.46,378,17968,70,NULL,NULL,'SDSS J084952.55+103243.8',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.8g',0.27,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,132.4689583,10.54553,0.113,NULL,63663942823,994749106,15542954,16.8),(57143,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57143,36.25,0.27,178,17969,70,NULL,NULL,'CGCG 288-007 NED01',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000077,NULL,'16.3g',0.39,'E0',NULL,NULL,NULL,NULL,1,132.47,57.11969,0.185,NULL,62022332211,969098940,15142170,16.3),(57144,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57144,37.21,0.46,277,17970,70,NULL,NULL,'2MASX J08495479+2329514',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00016,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,132.47825,23.49758,0.081,NULL,63789738055,996714657,15573666,17.2),(57145,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57145,37.69,0.46,346,17971,70,NULL,NULL,'SDSS J084954.99+040607.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000145,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,132.479125,4.10222,0.145,NULL,63629255830,994207122,15534486,18.4),(57146,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57146,34.12,NULL,66.7,17972,NULL,NULL,'Dipole + Quadrupole + Octopole','FGCE 0721',NULL,'2010Ap&SS.325..163P',2010,1,0.92,NULL,'G',0.000017,NULL,'17.3',0.1,'Sd',NULL,NULL,NULL,NULL,1,132.48,-20.65,0.589,NULL,42355826465,661809788,10340777,17.3),(57147,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57147,34.14,NULL,67.3,17972,NULL,NULL,'Dipole','FGCE 0721',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57148,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57148,34.15,NULL,67.6,17972,NULL,NULL,'Dipole + Quadrupole','FGCE 0721',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57149,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57149,34.18,NULL,68.5,17972,NULL,NULL,NULL,'FGCE 0721',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57150,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57150,37.77,0.46,358,17973,70,NULL,NULL,'2MASX J08495592+0417396',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000169,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,132.483125,4.29428,0.145,NULL,63629362272,994208785,15534512,17.3),(57151,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57151,36.9,0.46,240,17974,70,NULL,NULL,'2MASX J08495676+0234116',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000171,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,132.486667,2.56997,0.113,NULL,62560311376,977504865,15273513,16.8),(57152,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57152,38.26,0.46,448,17975,70,NULL,NULL,'SDSS J084957.12+054718.9',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000135,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,132.4880417,5.78858,0.181,NULL,63628332876,994192701,15534260,18),(57153,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57153,37.55,0.46,324,17976,70,NULL,NULL,'2MASX J08495735+2153144',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000157,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,132.488833,21.88744,0.093,NULL,63796423115,996819111,15575298,17.1),(57154,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57154,33.75,0.47,56.1,17977,NULL,NULL,'H','NGC 2650',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.00003,NULL,'14.08',1.2,'SB(rs)b:','in a pair',NULL,NULL,NULL,1,132.493125,70.29944,0.053,NULL,62224889634,972263900,15191623,14.08),(57155,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57155,33.76,0.45,56.6,17977,NULL,NULL,'K','NGC 2650',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57156,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57156,33.77,0.4,56.6,17977,NULL,NULL,'mean','NGC 2650',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57157,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57157,33.89,0.46,60.1,17977,NULL,NULL,'J','NGC 2650',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57158,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57158,36.36,0.46,187,17978,70,NULL,NULL,'CGCG 264-018',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000112,NULL,'15.3g',0.52,'NLAGN',NULL,NULL,NULL,NULL,1,132.498125,53.51769,0.081,NULL,63488522726,992008167,15500127,15.3),(57159,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57159,33.97,0.46,62.4,17979,70,NULL,NULL,'NGC 2677',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000169,NULL,'14.9g',0.48,NULL,NULL,NULL,NULL,NULL,1,132.505541667,19.00978,0.037,NULL,63825043720,997266308,15582286,14.9),(57160,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57160,36.44,0.33,194,17980,70,NULL,NULL,'2MASX J08500161+0013326',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000066,NULL,'16.5g',0.43,NULL,NULL,NULL,NULL,NULL,1,132.506708333,0.22578,0.117,NULL,62547811031,977309547,15270461,16.5),(57161,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57161,38.31,0.13,460,17981,70,NULL,NULL,'2MASX J08500357+2936242',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000137,NULL,'17.3g',0.3,'E',NULL,NULL,NULL,NULL,1,132.5147917,29.60675,0.085,NULL,64383873542,1005998024,15718719,17.3),(57162,'IRAS','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57162,33.38,0.8,47.5,17982,75,NULL,'MAT, I','ESO 060- G 015',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'14.68',0.4,'Sc:',NULL,NULL,NULL,NULL,1,132.51525,-70.12658,0.345,NULL,40751346551,636739789,9949059,14.68),(57163,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57163,31.89,0.32,23.9,17982,85,NULL,'I, inv','ESO 060- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57164,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57164,31.92,0.32,24.2,17982,85,NULL,'I, raw','ESO 060- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57165,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57165,32.15,0.78,26.9,17982,NULL,NULL,NULL,'ESO 060- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57166,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57166,32.19,0.2,27.4,17982,74.4,NULL,NULL,'ESO 060- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57167,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57167,32.28,0.43,28.6,17982,75,NULL,'MAT, I, inv','ESO 060- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57168,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57168,32.32,0.43,29.1,17982,75,NULL,'MAT, I, raw','ESO 060- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57169,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57169,32.36,0.39,29.6,17982,73,NULL,'opt','ESO 060- G 015',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57170,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57170,32.44,0.68,30.8,17982,NULL,NULL,'Malmquist cor.','ESO 060- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57171,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57171,32.66,0.43,34.1,17982,75,NULL,'MAT, I, cor','ESO 060- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57172,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57172,32.79,0.49,36.1,17982,75,NULL,'IR','ESO 060- G 015',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57173,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57173,36.63,0.46,212,17983,70,NULL,NULL,'2MASX J08500535+3013421',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000192,NULL,'16.0g',0.39,'S0',NULL,NULL,NULL,NULL,1,132.522417,30.22836,0.077,NULL,64384660670,1006010322,15718911,16),(57174,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57174,38.31,0.13,460,17984,70,NULL,NULL,'2MASX J08500609+2930192',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000146,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,132.5255,29.50547,0.085,NULL,64383862501,1005997851,15718716,17.9),(57175,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57175,37.53,0.19,320,17985,70,NULL,NULL,'2MASX J08500660+3236581',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000186,NULL,'16.2g',0.32,'E0',NULL,NULL,NULL,NULL,1,132.527583,32.61619,0.065,NULL,64384941035,1006014703,15718979,16.2),(57176,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57176,35.64,0.33,134,17986,70,NULL,NULL,'2MASX J08500759+5522116',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000068,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,132.531625,55.36983,0.101,NULL,61542643795,961603809,15025059,16.5),(57177,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57177,37.53,0.19,320,17987,70,NULL,NULL,'2MASX J08500815+3250181',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000201,NULL,'15.9g',0.47,'E0',NULL,NULL,NULL,NULL,1,132.533875,32.83836,0.081,NULL,64417703367,1006526615,15726978,15.9),(57178,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57178,37.23,0.46,280,17988,70,NULL,NULL,'2MASX J08500894+2242403',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,132.5372917,22.711,0.101,NULL,63789245719,996706964,15573546,18.3),(57179,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57179,38.25,0.46,447,17989,70,NULL,NULL,'2MASXi J0850102+294157',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,132.54275,29.69925,0.085,NULL,64383823780,1005997246,15718706,17.8),(57180,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57180,38.27,0.46,451,17990,70,NULL,NULL,'2MASX J08501051+2724019',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,132.543833333,27.40058,0.121,NULL,64308967910,1004827623,15700431,18.2),(57181,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57181,37.74,0.46,353,17991,70,NULL,NULL,'2MASX J08501060+2342513',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,132.5440417,23.71417,0.081,NULL,63790201131,996721892,15573779,17.3),(57182,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57182,38.17,0.33,431,17992,70,NULL,NULL,'2MASX J08501112+5134471',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000096,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,132.546291667,51.57986,0.081,NULL,64224404627,1003506322,15679786,17.4),(57183,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57183,34.75,0.33,89.2,17993,70,NULL,NULL,'CGCG 208-054',NULL,'2015arXiv151105856S',2015,1,0.87,NULL,'G',0.00016,NULL,'14.6g',0.64,'E0','Group member',NULL,NULL,NULL,1,132.547083,40.25572,0.073,NULL,64366088639,1005720134,15714377,14.6),(57184,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57184,38.62,0.46,530,17994,70,NULL,NULL,'SDSS J085011.35+044840.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000163,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,132.547333333,4.81117,0.145,NULL,63631356743,994239949,15534999,18.6),(57185,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57185,38.75,0.46,562,17995,70,NULL,NULL,'2MASX J08501145+3349501',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000177,NULL,'17.3g',0.21,'BrClG',NULL,NULL,NULL,NULL,1,132.54775,33.8305,0.065,NULL,64420163047,1006565047,15727578,17.3),(57186,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57186,32.54,0.43,32.3,17996,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04621',NULL,'2014MNRAS.444..527S',2014,1,1.09,NULL,'G',0.000033,NULL,'13.9g',0.62,'S?',NULL,NULL,NULL,NULL,1,132.5492083,35.07639,0.069,NULL,64419022567,1006547227,15727300,13.9),(57187,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57187,32.71,0.43,34.8,17996,75,NULL,'3.6 micron, color corrected','UGC 04621',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57188,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57188,32.86,0.4,37.4,17996,NULL,NULL,'mean','UGC 04621',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57189,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57189,32.88,0.2,37.7,17996,74.4,NULL,NULL,'UGC 04621',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57190,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57190,33.2,0.47,43.6,17996,NULL,NULL,'H','UGC 04621',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57191,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57191,33.23,0.45,44.3,17996,NULL,NULL,'K','UGC 04621',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57192,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57192,33.29,0.46,45.5,17996,NULL,NULL,'J','UGC 04621',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57193,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57193,38.31,0.13,460,17997,70,NULL,NULL,'2MASX J08501422+2940499',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00013,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,132.559125,29.68069,0.085,NULL,64383823350,1005997239,15718706,17.5),(57194,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57194,37.18,0.46,272,17998,70,NULL,NULL,'2MASX J08501523+3955107',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000162,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,132.563458333,39.91972,0.073,NULL,64366069721,1005719839,15714372,17),(57195,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57195,35.66,0.46,135,17999,70,NULL,NULL,'CGCG 208-055',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000182,NULL,'15.3g',0.45,'E0',NULL,NULL,NULL,NULL,1,132.567,39.98778,0.073,NULL,64366082314,1005720036,15714375,15.3),(57196,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57196,38.31,0.13,460,18000,70,NULL,NULL,'2MASX J08501669+2931419',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000151,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,132.569625,29.52839,0.085,NULL,64383854739,1005997730,15718714,18.5),(57197,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57197,35.21,NULL,110,18001,NULL,NULL,'Dipole + Quadrupole','UGC 04625',NULL,'2010Ap&SS.325..163P',2010,1,1.68,NULL,'G',0.000009,NULL,'15.43',0.1,'Sd(f)',NULL,NULL,NULL,NULL,1,132.573667,3.49739,0.125,NULL,63628791472,994199866,15534372,15.43),(57198,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57198,35.21,NULL,110,18001,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04625',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57199,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57199,35.22,NULL,110,18001,NULL,NULL,'Dipole','UGC 04625',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57200,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57200,35.21,0.49,110,18001,75,NULL,'IR','UGC 04625',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57201,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57201,35.23,NULL,111,18001,NULL,NULL,NULL,'UGC 04625',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57202,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57202,35.36,0.3,118,18001,NULL,NULL,NULL,'UGC 04625',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57203,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57203,35.38,0.3,119,18001,NULL,NULL,'Malmquist cor.','UGC 04625',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57204,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57204,35.39,0.2,120,18001,74.4,NULL,NULL,'UGC 04625',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57205,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57205,35.61,0.43,132,18001,75,NULL,'3.6 micron, color corrected','UGC 04625',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57206,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57206,35.68,0.43,137,18001,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04625',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57207,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57207,37.83,0.46,368,18002,70,NULL,NULL,'2MASX J08501879+6009130',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,132.578375,60.15361,0.145,NULL,62064528265,969758254,15152472,17.1),(57208,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57208,38.26,0.27,449,18003,70,NULL,NULL,'2MASX J08501955+3557477',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,132.581625,35.96333,0.073,NULL,64418433316,1006538020,15727156,17.5),(57209,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57209,36.74,0.46,223,18004,70,NULL,NULL,'2MASX J08501978+0033582',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000073,NULL,'17.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,132.582375,0.56617,0.113,NULL,62548432107,977319251,15270613,17.5),(57210,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57210,38.14,0.46,424,18005,70,NULL,NULL,'2MASX J08501985+1742396',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,132.582917,17.711,0.053,NULL,63883422938,998178483,15596538,17.8),(57211,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57211,28.86,0.76,5.93,18006,NULL,NULL,NULL,'ARP 007',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000027,NULL,'14.5',1,'SB(rs)bc:      HII?',NULL,NULL,NULL,NULL,1,132.584333333,-16.57947,0.213,NULL,42403254291,662550848,10352357,14.5),(57212,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57212,28.86,0.76,5.93,18006,NULL,NULL,'Malmquist cor.','ARP 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57213,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57213,34.52,0.4,80.2,18006,NULL,NULL,'mean','ARP 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57214,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57214,34.61,0.47,83.7,18006,NULL,NULL,'H','ARP 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57215,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57215,38.31,0.13,460,18007,70,NULL,NULL,'SDSS J085020.66+293036.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000147,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,132.586125,29.51003,0.085,NULL,64383857080,1005997766,15718715,18.6),(57216,'Ring Diameter','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57216,33.5,0.84,51,18008,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 2646',NULL,'1981ApJS...45..541P',1981,1,1.3,NULL,'G',0.00009,NULL,'13.09',1.3,'SB(r)0^0^:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,132.591875,73.46308,0.037,NULL,62176451427,971507053,15179797,13.09),(57217,'Faber-Jackson','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57217,32.49,0.32,31.5,18008,95,NULL,'Weighted Mean','NGC 2646',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57218,'Faber-Jackson','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57218,32.49,0.63,31.5,18008,95,NULL,'Michard 1979b, c','NGC 2646',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57219,'Faber-Jackson','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57219,32.63,0.46,33.6,18008,95,NULL,'Michard 1979a','NGC 2646',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57220,'Faber-Jackson','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57220,32.67,0.63,34.2,18008,95,NULL,'de Vaucouleurs','NGC 2646',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57221,'Faber-Jackson','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57221,34.53,0.81,80.5,18008,55,NULL,'Visvanathan & Sandage 1979','NGC 2646',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57222,'Tertiary','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57222,32.7,0.29,34.7,18008,95,NULL,NULL,'NGC 2646',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57223,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57223,33.53,0.4,50.9,18008,NULL,NULL,'mean','NGC 2646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57224,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57224,34.19,0.45,68.8,18008,NULL,NULL,'K','NGC 2646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57225,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57225,35.64,0.33,134,18009,70,NULL,NULL,'CGCG 264-019 NED01',NULL,'2015arXiv151105856S',2015,1,1.02,NULL,'G',0.000127,NULL,'14.4g',0.67,'E0',NULL,NULL,NULL,NULL,1,132.594958333,55.37875,0.101,NULL,61539166018,961549469,15024210,14.4),(57226,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57226,37.89,0.46,378,18010,70,NULL,NULL,'2MASX J08502455+3406131',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000146,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,132.60225,34.10364,0.061,NULL,64420253536,1006566461,15727600,18),(57227,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57227,37.77,0.46,357,18011,70,NULL,NULL,'2MASX J08502524+0100142',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00007,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,132.605083333,1.00392,0.101,NULL,62548335726,977317745,15270589,17.3),(57228,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57228,33.02,0.43,40.3,18012,75,NULL,'3.6 micron, color + selection bias corrected','ESO 563- G 026',NULL,'2014MNRAS.444..527S',2014,1,1.52,'Springob et al. (2005ApJS..160..149S) give v= 4714 km/sec.','G',0.000017,NULL,'16.2',0.12,'Sd',NULL,NULL,NULL,NULL,1,132.61,-19.53111,0.573,NULL,42357586084,661837282,10341207,16.2),(57229,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57229,33.15,NULL,42.7,18012,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 563- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57230,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57230,33.16,NULL,42.8,18012,NULL,NULL,'Dipole','ESO 563- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57231,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57231,33.16,NULL,42.8,18012,NULL,NULL,'Dipole + Quadrupole','ESO 563- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57232,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57232,35.78,0.46,143,18013,70,NULL,NULL,'2MASX J08502723+5543407',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.1g',0.38,NULL,NULL,NULL,NULL,NULL,1,132.613625,55.72808,0.113,NULL,61542518847,961601856,15025029,16.1),(57233,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57233,37.38,0.46,300,18014,70,NULL,NULL,'2MASX J08502751+3024251',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00019,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,132.614541667,30.40708,0.077,NULL,64384448492,1006007007,15718859,16.8),(57234,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57234,38.1,0.46,418,18015,70,NULL,NULL,'2MASX J08502754+2347495',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,132.614875,23.79711,0.081,NULL,63791050127,996735158,15573986,17.5),(57235,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57235,36.68,0.46,217,18016,70,NULL,NULL,'2MASX J08502764+2906040',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000178,NULL,'16.3g',0.37,'E',NULL,NULL,NULL,NULL,1,132.6152083,29.101,0.097,NULL,64387819284,1006059676,15719682,16.3),(57236,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57236,36.84,0.46,234,18017,70,NULL,NULL,'2MASX J08502767+3458311',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000178,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,132.6152083,34.97533,0.069,NULL,64418908069,1006545438,15727272,16.5),(57237,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57237,38.25,0.46,446,18018,70,NULL,NULL,'2MASX J08502772+3609377',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000175,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,132.615583333,36.16039,0.077,NULL,64420345117,1006567892,15727623,17.6),(57238,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57238,37.32,0.46,291,18019,70,NULL,NULL,'2MASX J08502780+4029047',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000172,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,132.615875,40.48453,0.077,NULL,64244731215,1003823925,15684748,17.1),(57239,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57239,38.1,0.46,417,18020,70,NULL,NULL,'SDSS J085027.84+322601.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,132.616,32.43383,0.065,NULL,64384950765,1006014855,15718982,18),(57240,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57240,38.41,0.46,481,18021,70,NULL,NULL,'2MASX J08502927+1608586',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000147,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,132.621916667,16.14958,0.061,NULL,63880519808,998133122,15595830,17.8),(57241,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57241,37.86,0.46,373,18022,70,NULL,NULL,'2MASX J08502990+0525522',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000158,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,132.624625,5.43122,0.165,NULL,63631092687,994235823,15534934,17.3),(57242,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57242,38.31,0.13,460,18023,70,NULL,NULL,'2MASX J08503018+2936580',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,132.6257917,29.61619,0.085,NULL,64383848785,1005997637,15718713,17.8),(57243,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57243,36.5,0.46,200,18024,70,NULL,NULL,'2MASX J08503216+3947387',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000186,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,132.633833333,39.794,0.081,NULL,64366152009,1005721125,15714392,16.3),(57244,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57244,37.71,0.46,348,18025,70,NULL,NULL,'2MASX J08503238+2907360',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000173,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,132.635083,29.12669,0.097,NULL,64387821225,1006059706,15719682,17),(57245,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57245,36.92,0.46,243,18026,70,NULL,NULL,'2MASX J08503260-0015101',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00008,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,132.636,-0.25283,0.073,NULL,39192802963,612387546,9568555,16.6),(57246,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57246,38.15,0.46,427,18027,70,NULL,NULL,'2MASX J08503350+1818495',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00018,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,132.639625,18.31372,0.049,NULL,63882899486,998170304,15596411,17.5),(57247,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57247,34.75,0.33,89.2,18028,70,NULL,NULL,'2MASX J08503392+4023527',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000106,NULL,'16.0g',0.32,'S0^-',NULL,NULL,NULL,NULL,1,132.6412083,40.398,0.077,NULL,64244708165,1003823565,15684743,16),(57248,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57248,38.26,0.27,449,18029,70,NULL,NULL,'SDSS J085034.25+360223.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000114,NULL,'18.7g',0.09,NULL,NULL,NULL,NULL,NULL,1,132.64275,36.03994,0.073,NULL,64420544552,1006571008,15727672,18.7),(57249,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57249,38.55,0.46,513,18030,70,NULL,NULL,'2MASX J08503449+2400209',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,132.643833333,24.00575,0.109,NULL,63791080399,996735631,15573994,18),(57250,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57250,37.35,0.46,296,18031,70,NULL,NULL,'2MASX J08503571+4011097',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000167,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,132.649041667,40.18594,0.073,NULL,64366097331,1005720270,15714379,17.1),(57251,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2008ia',NULL,57251,34.3,0.1,69.3,18032,72,NULL,NULL,'ESO 125- G 006',0.02233,'2013ApJ...773...53F',2013,1,1.2,NULL,'G',0.000097,NULL,'15.3b',1,'S0',NULL,NULL,NULL,NULL,1,132.649375,-61.27792,0.825,NULL,40598712089,634354876,9911794,15.3),(57252,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2008ia',NULL,57252,34.79,0.07,90.9,18032,72,NULL,'M(H) = -18.317 mag','ESO 125- G 006',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57253,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2008ia',NULL,57253,34.97,0.15,96.3,18032,73.8,NULL,'SALT 2 (SNANA)','ESO 125- G 006',0.0229,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57254,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57254,33.76,0.46,56.4,18032,70,NULL,NULL,'ESO 125- G 006',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57255,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57255,37.38,0.46,299,18033,70,NULL,NULL,'2MASX J08503738+1840355',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,132.6557917,18.67656,0.037,NULL,63882664814,998166637,15596353,17.7),(57256,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57256,36.42,NULL,193,18034,NULL,NULL,NULL,'FGC 0799',NULL,'2000BSAO...50....5K',2000,1,0.96,NULL,'G',0.00005,NULL,'16.5g',0.17,'Scd',NULL,NULL,NULL,NULL,1,132.6577083,35.15514,0.069,NULL,64419106581,1006548540,15727320,16.5),(57257,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57257,36.44,NULL,194,18034,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0799',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57258,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57258,36.47,NULL,197,18034,NULL,NULL,'Dipole + Quadrupole','FGC 0799',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57259,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57259,36.5,NULL,200,18034,NULL,NULL,'Dipole','FGC 0799',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57260,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57260,37.13,0.2,267,18034,74.4,NULL,NULL,'FGC 0799',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57261,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57261,36.42,0.46,192,18035,70,NULL,NULL,'2MASX J08503819+2435329',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000185,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,132.659,24.59264,0.153,NULL,63790854542,996732102,15573939,16.5),(57262,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57262,37.5,0.46,316,18036,70,NULL,NULL,'2MASX J08504116+1713565',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000154,NULL,'17.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,132.671417,17.23242,0.053,NULL,63882989148,998171705,15596432,17.9),(57263,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57263,38.46,0.46,491,18037,70,NULL,NULL,'2MASX J08504123+1342425',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,132.6717083,13.71181,0.085,NULL,63845556703,997586823,15587294,18.1),(57264,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57264,35.96,0.49,156,18038,70,NULL,NULL,'NGC 2696',NULL,'2014MNRAS.445.2677S',2014,1,1.2,'Identification as NGC 2696 is uncertain.','G',0.000113,NULL,'16',1.1,'E+',NULL,NULL,NULL,NULL,1,132.6752083,-5.00978,0.029,NULL,42152719802,658636246,10291191,16),(57265,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57265,38.26,0.27,449,18039,70,NULL,NULL,'2MASX J08504308+3559226',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000132,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,132.679583,35.98942,0.073,NULL,64420413923,1006568967,15727640,17.9),(57266,'SGRB','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'N',57266,42.84,0.06,3690,18040,70,NULL,'pseudo z = 2.67 +/- 0.37','GRB 140619B',NULL,'2015ApJ...808..190R',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57267,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57267,38.32,0.46,461,18041,70,NULL,NULL,'2MASX J08504393+2646361',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000134,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,132.683167,26.77653,0.109,NULL,64311122856,1004861294,15700957,18.3),(57268,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57268,35.88,0.46,150,18042,70,NULL,NULL,'2MASX J08504525+0118573',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000074,NULL,'16.0g',0.29,'Sa',NULL,NULL,NULL,NULL,1,132.688625,1.31597,0.101,NULL,62548634951,977322421,15270662,16),(57269,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57269,35.41,0.46,121,18043,70,NULL,NULL,'2MASX J08504525+1148390',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000177,NULL,'15.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,132.688667,11.81083,0.061,NULL,63665053280,994766457,15543225,15.8),(57270,'IRAS','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57270,32.9,0.8,38,18044,75,NULL,'MAT, I','ESO 563- G 028',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'14',0.6,'SBa: pec       HII',NULL,NULL,NULL,NULL,1,132.6895,-21.96336,0.609,NULL,42355133974,661798968,10340608,14),(57271,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57271,31.63,0.4,21.2,18044,NULL,NULL,NULL,'ESO 563- G 028',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57272,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57272,32.16,0.4,27,18044,73,NULL,'opt','ESO 563- G 028',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57273,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57273,32.69,0.4,34.5,18044,75,NULL,NULL,'ESO 563- G 028',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57274,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57274,32.93,0.43,38.5,18044,75,NULL,'3.6 micron, color + selection bias corrected','ESO 563- G 028',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57275,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57275,33.07,0.43,41.1,18044,75,NULL,'3.6 micron, color corrected','ESO 563- G 028',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57276,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57276,33.09,0.49,41.5,18044,75,NULL,'IR','ESO 563- G 028',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57277,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57277,33.13,0.43,42.4,18044,75,NULL,'MAT, I, raw','ESO 563- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57278,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57278,33.2,0.32,43.7,18044,85,NULL,'I, raw','ESO 563- G 028',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57279,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57279,33.22,0.2,44.1,18044,74.4,NULL,NULL,'ESO 563- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57280,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57280,33.26,0.32,44.8,18044,85,NULL,'I, inv','ESO 563- G 028',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57281,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57281,33.33,0.43,46.3,18044,75,NULL,'MAT, I, cor','ESO 563- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57282,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57282,33.38,0.43,47.4,18044,75,NULL,'MAT, I, inv','ESO 563- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57283,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57283,37.53,0.19,320,18045,70,NULL,NULL,'SDSS J085045.68+325211.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000138,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,132.690375,32.86981,0.081,NULL,64417755804,1006527434,15726991,18.2),(57284,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57284,38.2,0.27,437,18046,70,NULL,NULL,'2MASX J08504639+2959496',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000147,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,132.693416667,29.99717,0.081,NULL,64384577689,1006009026,15718891,17.2),(57285,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57285,35.08,0.49,104,18047,70,NULL,NULL,'2MASX J08504833-6545385',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000097,NULL,'15.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,132.701375,-65.76081,0.441,NULL,40787150954,637299233,9957800,15.7),(57286,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57286,38.2,0.27,437,18048,70,NULL,NULL,'2MASX J08504877+2958566',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000141,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,132.703125,29.9825,0.081,NULL,64384571307,1006008926,15718889,18.1),(57287,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57287,36.44,0.33,194,18049,70,NULL,NULL,'2MASX J08505068+0022234',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000103,NULL,'15.4g',0.57,'E0',NULL,NULL,NULL,NULL,1,132.71125,0.37328,0.117,NULL,62548522026,977320656,15270635,15.4),(57288,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57288,37.04,0.46,256,18050,70,NULL,NULL,'2MASX J08505276+3201076',NULL,'2015arXiv151105856S',2015,1,0.33,'SDSS has z = 0.077373 +- 0.000165.','G',0.0001,NULL,'17.0g',0.32,NULL,NULL,NULL,NULL,NULL,1,132.719833,32.01878,0.065,NULL,64386127099,1006033235,15719269,17),(57289,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57289,37.24,0.46,280,18051,70,NULL,NULL,'SDSS J085052.82+140359.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'18.0g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,132.720125,14.06647,0.093,NULL,63843349660,997552338,15586755,18),(57290,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57290,37.5,0.46,316,18052,70,NULL,NULL,'2MASX J08505392+4101589',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'16.9g',0.25,'AGN',NULL,NULL,NULL,NULL,1,132.7245,41.03306,0.089,NULL,64244816365,1003825255,15684769,16.9),(57291,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57291,37.49,0.46,315,18053,70,NULL,NULL,'2MASX J08505525+1312501',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000144,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,132.730167,13.214,0.061,NULL,63845582668,997587229,15587300,17.7),(57292,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57292,36.39,0.46,190,18054,70,NULL,NULL,'2MASX J08505537+4825106',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,132.730541667,48.41956,0.089,NULL,64229225675,1003581651,15680963,16.9),(57293,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57293,32.15,0.4,26.9,18055,75,NULL,NULL,'ESO 371- G 020',NULL,'2008Ap.....51..336K',2008,1,3.2,NULL,'G',0.000013,NULL,'13.46',1.1,'SA(s)c:',NULL,NULL,NULL,NULL,1,132.7334583,-34.53756,NULL,NULL,42936199640,670878119,10482470,13.46),(57294,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57294,32.15,0.4,26.9,18055,73,NULL,'IR','ESO 371- G 020',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57295,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57295,32.29,0.46,28.8,18055,NULL,NULL,'J','ESO 371- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57296,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57296,32.44,0.47,30.8,18055,NULL,NULL,'H','ESO 371- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57297,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57297,32.46,0.49,31.1,18055,75,NULL,'IR','ESO 371- G 020',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57298,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57298,32.56,0.45,32.5,18055,NULL,NULL,'K','ESO 371- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57299,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57299,32.72,0.4,35,18055,NULL,NULL,'mean','ESO 371- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57300,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57300,37.77,0.33,358,18056,70,NULL,NULL,'2MASX J08505682+4248170',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'16.1g',0.42,'BrClG',NULL,NULL,NULL,NULL,1,132.736667,42.80464,0.109,NULL,64245797959,1003840593,15685009,16.1),(57301,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57301,37.44,0.46,307,18057,70,NULL,NULL,'2MASX J08505710+0537204',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000206,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,132.737875,5.62225,0.177,NULL,63631234632,994238041,15534969,16.9),(57302,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57302,38.31,0.13,460,18058,70,NULL,NULL,'2MASX J08505743+2932441',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,132.7392917,29.5455,0.085,NULL,64383715473,1005995554,15718680,18.2),(57303,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57303,37.23,0.46,279,18059,70,NULL,NULL,'2MASX J08505842-0013434',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000077,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,132.743333,-0.22883,0.073,NULL,39193502511,612398476,9568726,17.2),(57304,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57304,37.29,0.46,287,18060,70,NULL,NULL,'2MASX J08505876+6354333',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,132.74525,63.90936,0.133,NULL,62051467239,969554175,15149283,16.5),(57305,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57305,38.3,0.46,458,18061,70,NULL,NULL,'2MASX J08510098+2320321',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,132.754167,23.34208,0.089,NULL,63789914231,996717409,15573709,18.3),(57306,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57306,38.09,0.33,416,18062,70,NULL,NULL,'2MASX J08510260+0039094',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000081,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,132.760916667,0.65269,0.109,NULL,62548587708,977321682,15270651,16.9),(57307,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57307,38.09,0.33,416,18063,70,NULL,NULL,'SDSS J085103.18+004008.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000083,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,132.76325,0.66897,0.109,NULL,62548587524,977321680,15270651,18.2),(57308,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57308,37.53,0.19,320,18064,70,NULL,NULL,'SDSS J085106.23+323942.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000181,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,132.776,32.66175,0.065,NULL,64384966199,1006015096,15718985,17.6),(57309,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57309,32.7,0.2,34.7,18065,74.4,NULL,NULL,'UGCA 147',NULL,'2013AJ....146...86T',2013,1,3.5,NULL,'G',0.000007,NULL,'14',1,'SA(rs)d:',NULL,NULL,NULL,NULL,1,132.779416667,-17.5635,0.345,NULL,42404326772,662567605,10352618,14),(57310,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57310,32.73,0.4,35.1,18065,NULL,NULL,'mean','UGCA 147',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57311,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57311,32.86,0.43,37.3,18065,75,NULL,'3.6 micron, color corrected','UGCA 147',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57312,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57312,33.03,0.43,40.3,18065,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 147',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57313,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57313,33.08,0.46,41.3,18065,NULL,NULL,'J','UGCA 147',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57314,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57314,33.14,0.47,42.4,18065,NULL,NULL,'H','UGCA 147',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57315,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57315,33.25,0.45,44.7,18065,NULL,NULL,'K','UGCA 147',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57316,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57316,37.77,0.33,358,18066,70,NULL,NULL,'2MASX J08510758+4240552',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000154,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,132.781625,42.68214,0.109,NULL,64245856979,1003841515,15685023,17.2),(57317,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57317,38.2,0.27,437,18067,70,NULL,NULL,'2MASX J08510814+2958041',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.1g',0.26,'BrClG',NULL,NULL,NULL,NULL,1,132.783916667,29.96772,0.081,NULL,64384589623,1006009212,15718893,17.1),(57318,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57318,35.61,0.59,132,18068,70,NULL,NULL,'2MASX J08510867-0610332',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,132.786167,-6.17594,0.029,NULL,42203614522,659431476,10303616,15.5),(57319,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57319,36.91,0.46,241,18069,70,NULL,NULL,'2MASX J08510869+1223410',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000195,NULL,'16.1g',0.39,NULL,NULL,NULL,NULL,NULL,1,132.7862917,12.39461,0.081,NULL,63844912582,997576759,15587136,16.1),(57320,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57320,37.43,0.46,306,18070,70,NULL,NULL,'2MASX J08510879+0148114',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000068,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,132.786667,1.80319,0.105,NULL,62547031709,977297370,15270271,17.8),(57321,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57321,37.59,0.46,329,18071,70,NULL,NULL,'2MASX J08510887+1815581',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000181,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,132.787041667,18.26606,0.021,NULL,63882913569,998170524,15596414,16.4),(57322,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57322,37.67,0.46,342,18072,70,NULL,NULL,'2MASX J08510952+4026529',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000157,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,132.789666667,40.448,0.077,NULL,64244917679,1003826838,15684794,17),(57323,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57323,35.68,0.46,136,18073,70,NULL,NULL,'CGCG 005-017',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000087,NULL,'15.1g',0.57,'E',NULL,NULL,NULL,NULL,1,132.7907917,0.25358,0.077,NULL,62548531805,977320809,15270637,15.1),(57324,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57324,37.28,0.23,286,18074,70,NULL,NULL,'2MASX J08511015+0929112',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,132.792208333,9.48656,0.157,NULL,63663308236,994739191,15542799,17.5),(57325,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57325,37.36,0.46,296,18075,70,NULL,NULL,'2MASX J08511098+0431074',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000175,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,132.79575,4.51889,0.145,NULL,63629428716,994209823,15534528,17.1),(57326,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57326,36.44,0.46,194,18076,70,NULL,NULL,'2MASX J08511118+2154411',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,132.7964583,21.91142,0.089,NULL,63835216603,997425259,15584769,16.6),(57327,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57327,38.73,0.46,558,18077,70,NULL,NULL,'SDSS J085111.69+153523.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,132.79875,15.58981,0.113,NULL,63884493578,998195212,15596800,18.4),(57328,'TRGB','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57328,29.64,0.1,8.47,18078,74.4,NULL,NULL,'SDSS J085112.11+275248.1',NULL,'2013AJ....146...86T',2013,1,0.43,NULL,'G',0.000008,NULL,'17.1g',0.32,NULL,NULL,NULL,NULL,NULL,1,132.800458333,27.88006,0.113,NULL,64309032375,1004828630,15700447,17.1),(57329,'TRGB','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57329,29.64,0.04,8.47,18078,NULL,NULL,NULL,'SDSS J085112.11+275248.1',NULL,'2015ApJ...805..144K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57330,'TRGB','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57330,29.78,0.06,9.02,18078,NULL,NULL,'I','SDSS J085112.11+275248.1',NULL,'2014ApJ...785....3M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57331,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57331,37.28,0.23,286,18079,70,NULL,NULL,'2MASX J08511251+0932212',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,132.8022083,9.53914,0.169,NULL,63663295710,994738995,15542796,16.2),(57332,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57332,37.28,0.23,286,18080,70,NULL,NULL,'2MASX J08511305+0929322',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,132.804417,9.49217,0.157,NULL,63663308764,994739199,15542799,17.1),(57333,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57333,37,0.46,251,18081,70,NULL,NULL,'2MASX J08511367+0702052',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000178,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,132.807,7.03481,0.145,NULL,63677906552,994967289,15546363,16.6),(57334,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57334,36.67,0.46,216,18082,70,NULL,NULL,'2MASX J08511567+1926233',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000168,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,132.815333,19.43972,0.029,NULL,63828599699,997321870,15583154,16.6),(57335,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57335,37.18,0.46,273,18083,70,NULL,NULL,'2MASX J08511623+0827232',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000206,NULL,'16.0g',0.37,'E0',NULL,NULL,NULL,NULL,1,132.817666667,8.45644,0.129,NULL,63676694533,994948352,15546068,16),(57336,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57336,38.31,0.13,460,18084,70,NULL,NULL,'2MASX J08511790+2932080',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00014,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,132.8247917,29.53564,0.085,NULL,64383714752,1005995543,15718680,18.1),(57337,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57337,37.95,0.46,389,18085,70,NULL,NULL,'SDSS J085118.26+521816.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000075,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,132.826125,52.30444,0.073,NULL,64224865304,1003513520,15679898,18.4),(57338,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57338,37.28,0.46,285,18086,70,NULL,NULL,'2MASX J08511872+0814472',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000193,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,132.828,8.24658,0.125,NULL,63676863563,994950993,15546109,16.9),(57339,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57339,37.94,0.46,388,18087,70,NULL,NULL,'2MASX J08512380+1524575',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000155,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,132.849167,15.41606,0.113,NULL,63842561560,997540024,15586562,18.8),(57340,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57340,37.28,0.23,286,18088,70,NULL,NULL,'2MASX J08512630+0936082',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000173,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,132.859667,9.60219,0.169,NULL,63663264398,994738506,15542789,16.9),(57341,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57341,37.93,0.46,386,18089,70,NULL,NULL,'2MASX J08512734+4744422',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000199,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,132.864083,47.74514,0.093,NULL,64229068115,1003579189,15680924,17.4),(57342,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57342,37.06,0.46,259,18090,70,NULL,NULL,'2MASX J08512748+2225583',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,132.864541667,22.43278,0.097,NULL,63789304298,996707879,15573560,17.3),(57343,'CMD','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57343,17.39,0.3,0.03,18091,NULL,NULL,'CMD','Ursa Major II Dwarf',NULL,'2006ApJ...650L..41Z',2006,1,NULL,NULL,'G',NULL,NULL,'14.3V',NULL,'dSph',NULL,NULL,NULL,NULL,1,132.875,63.13,0.161,1,62051078777,969548105,15149189,14.3),(57344,'CMD','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57344,17.5,0.3,0.032,18091,NULL,NULL,NULL,'Ursa Major II Dwarf',NULL,'2008AJ....135.1361D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57345,'CMD','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57345,17.9,NULL,0.038,18091,NULL,NULL,NULL,'Ursa Major II Dwarf',NULL,'2008A&A...477..139L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57346,'RR Lyrae','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57346,17.7,0.12,0.0347,18091,NULL,NULL,NULL,'Ursa Major II Dwarf',NULL,'2012ApJ...752...42D',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57347,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57347,37.24,0.46,281,18092,70,NULL,NULL,'2MASX J08513113+1651245',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,132.8797083,16.85675,0.049,NULL,63881134044,998142719,15595979,17),(57348,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57348,31.99,0.45,25,18093,NULL,NULL,'K','NGC 2679',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000017,NULL,'13.6g',1.8,'SB0:','Pair member (points to parent)',NULL,NULL,NULL,1,132.88725,30.86536,0.069,NULL,64385869789,1006029215,15719206,13.6),(57349,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57349,32.78,0.4,36,18093,NULL,NULL,'mean','NGC 2679',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57350,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57350,35.18,0.46,109,18094,70,NULL,NULL,'IC 2420',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000097,NULL,'14.7g',0.67,'E0',NULL,NULL,NULL,NULL,1,132.890667,3.10069,0.105,NULL,63632838061,994263094,15535360,14.7),(57351,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57351,37.21,0.46,276,18095,70,NULL,NULL,'2MASX J08513371+2457530',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000186,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,132.890667,24.96464,0.113,NULL,63787263773,996675996,15573062,17),(57352,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57352,33.63,NULL,53.3,18096,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 563- G 029',NULL,'2010Ap&SS.325..163P',2010,1,1.37,NULL,'G',0.000023,NULL,'16.7',0.11,'Sd',NULL,NULL,NULL,NULL,1,132.894167,-21.64722,0.569,NULL,42355150502,661799226,10340612,16.7),(57353,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57353,33.64,NULL,53.5,18096,NULL,NULL,'Dipole + Quadrupole','ESO 563- G 029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57354,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57354,33.65,NULL,53.6,18096,NULL,NULL,'Dipole','ESO 563- G 029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57355,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57355,33.69,NULL,54.8,18096,NULL,NULL,NULL,'ESO 563- G 029',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57356,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57356,38,0.33,397,18097,70,NULL,NULL,'2MASX J08513480+5200036',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000109,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,132.89525,52.00114,0.069,NULL,64225124245,1003517566,15679961,16.9),(57357,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57357,34.67,0.46,85.7,18098,70,NULL,NULL,'NGC 2676',NULL,'2015arXiv151105856S',2015,1,1.01,'RC3 has V = 6010 +- 60 km/s.','G',0.00018,NULL,'14.2g',0.92,'S0:','Isolated galaxy (6 Mpc isolation)',NULL,NULL,NULL,1,132.8985417,47.55767,0.093,NULL,64229053181,1003578955,15680921,14.2),(57358,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57358,33.88,0.5,59.6,18099,70,NULL,NULL,'MCG -01-23-005',NULL,'2014MNRAS.445.2677S',2014,1,1.6,'MCG notes say that dec. for MCG -01-23 zone is off by 8\'.','G',0.000083,NULL,'14',1.1,'SA(r)0/a?      HII',NULL,NULL,NULL,NULL,1,132.899125,-7.26103,0.101,NULL,42207227043,659487922,10304498,14),(57359,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57359,37.53,0.19,320,18100,70,NULL,NULL,'2MASX J08514021+3256294',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000204,NULL,'16.0g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,132.917458333,32.94147,0.081,NULL,64417932127,1006530189,15727034,16),(57360,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57360,38.63,0.27,533,18101,70,NULL,NULL,'SDSS J085140.55+021229.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000076,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,132.919,2.20817,0.101,NULL,62547472431,977304256,15270379,18.3),(57361,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57361,30.72,0.4,13.9,18102,73,NULL,'opt','UGC 04628',NULL,'2011A&A...532A.104N',2011,1,1.67,NULL,'G',0.00005,NULL,'15.1g',0.38,'Scd(f)',NULL,NULL,NULL,NULL,1,132.919458333,51.11869,0.077,NULL,64238001515,1003718773,15683105,15.1),(57362,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57362,31.21,0.2,17.5,18102,74.4,NULL,NULL,'UGC 04628',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57363,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57363,31.34,0.4,18.5,18102,NULL,NULL,NULL,'UGC 04628',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57364,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57364,31.58,0.54,20.7,18102,NULL,NULL,NULL,'UGC 04628',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57365,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57365,31.62,0.52,21.1,18102,NULL,NULL,'Malmquist cor.','UGC 04628',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57366,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57366,38.36,0.46,471,18103,70,NULL,NULL,'2MASX J08514083+3522284',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000136,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,132.920041667,35.37467,0.077,NULL,64418815228,1006543987,15727249,17.9),(57367,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57367,38,0.33,397,18104,70,NULL,NULL,'2MASX J08514130+5159236',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000083,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,132.921917,51.98986,0.069,NULL,64225123566,1003517555,15679961,17.8),(57368,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57368,37.97,0.46,393,18105,70,NULL,NULL,'SDSS J085142.16+050411.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000158,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,132.925708333,5.06992,0.161,NULL,63631732916,994245826,15535091,18.7),(57369,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57369,38.63,0.27,533,18106,70,NULL,NULL,'SDSS J085142.71+021435.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,132.928,2.24314,0.101,NULL,62547472907,977304264,15270379,18.2),(57370,'Sosies','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57370,33.65,0.14,53.7,18107,NULL,NULL,NULL,'UGC 04640',NULL,'2002A&A...393...57T',2002,1,3.2,'Confused HIPASS source','G',0.000019,NULL,'14.2',1.1,'SAB(rs)c:',NULL,NULL,NULL,NULL,1,132.932583,-2.13406,0.049,NULL,39194578922,612415295,9568988,14.2),(57371,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57371,33.27,0.2,45.1,18107,74.4,NULL,NULL,'UGC 04640',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57372,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57372,33.33,0.43,46.4,18107,75,NULL,'3.6 micron, color corrected','UGC 04640',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57373,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57373,33.47,0.46,49.5,18107,NULL,NULL,NULL,'UGC 04640',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57374,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57374,33.49,0.43,49.9,18107,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04640',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57375,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57375,33.55,0.44,51.2,18107,NULL,NULL,'Malmquist cor.','UGC 04640',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57376,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57376,37.59,0.46,330,18108,70,NULL,NULL,'SDSS J085144.74+352339.1',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000139,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,132.936417,35.39422,0.077,NULL,64418822436,1006544100,15727251,18.6),(57377,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57377,37.62,0.46,335,18109,70,NULL,NULL,'2MASX J08514479+0407574',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,132.936791667,4.13267,0.137,NULL,63629652951,994213327,15534583,17.7),(57378,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57378,33.63,0.52,53.3,18110,70,NULL,NULL,'MCG -02-23-006',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00011,NULL,'15.5',0.3,NULL,NULL,NULL,NULL,NULL,1,132.938791667,-14.90411,0.149,NULL,42389820985,662340952,10349077,15.5),(57379,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57379,37.76,0.46,357,18111,70,NULL,NULL,'2MASX J08514618+3231426',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000175,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,132.942375,32.52856,0.065,NULL,64385146131,1006017908,15719029,17.8),(57380,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57380,38.2,0.46,437,18112,70,NULL,NULL,'2MASX J08514695+0826428',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,132.945667,8.44533,0.129,NULL,63676708076,994948563,15546071,17.9),(57381,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57381,36.95,0.46,246,18113,70,NULL,NULL,'2MASX J08514698+0509504',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000145,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,132.9457083,5.164,0.161,NULL,63631778037,994246531,15535102,17.3),(57382,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57382,36.08,0.59,164,18114,70,NULL,NULL,'2MASX J08514795-0510265',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.7I',0.2,NULL,NULL,NULL,NULL,NULL,1,132.949875,-5.17397,0.041,NULL,42152726545,658636352,10291193,14.7),(57383,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57383,38.33,0.46,464,18115,70,NULL,NULL,'2MASX J08515029+1822090',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,132.959583,18.36919,0.021,NULL,63882874129,998169908,15596404,18),(57384,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57384,37.23,0.46,279,18116,70,NULL,NULL,'2MASX J08515069+2840242',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,132.961417,28.67333,0.093,NULL,64376516228,1005883066,15716922,17.7),(57385,'GRB','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57385,42.94,NULL,3870,18117,70,NULL,'Pseudo z = 3.43','GRB 010326',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE/Ulysses',NULL,NULL,NULL,NULL,1,132.9625,-38.3,NULL,NULL,42922100641,670657822,10479028,NULL),(57386,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57386,33.49,0.49,50,18118,75,NULL,'IR','ESO 496- G 012',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000031,NULL,'15.81',0.3,'S...',NULL,NULL,NULL,NULL,1,132.9677083,-24.31378,0.565,NULL,42232249622,659878900,10310607,15.81),(57387,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57387,37.32,0.46,291,18119,70,NULL,NULL,'SDSS J085153.71+043758.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000161,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,132.9737917,4.63289,0.145,NULL,63630883152,994232549,15534883,18.1),(57388,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57388,38.27,0.46,451,18120,70,NULL,NULL,'SDSS J085154.03+570415.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00009,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,132.975125,57.07089,0.193,NULL,62022302739,969098480,15142163,18.7),(57389,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57389,38.09,0.46,414,18121,70,NULL,NULL,'2MASX J08515403+2850552',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,132.9752083,28.84878,0.093,NULL,64376317192,1005879956,15716874,17.5),(57390,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57390,37.81,0.46,365,18122,70,NULL,NULL,'2MASX J08515407+4258150',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000138,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,132.975417,42.97075,0.093,NULL,64276018784,1004312793,15692387,17.5),(57391,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57391,37.65,0.46,340,18123,70,NULL,NULL,'2MASX J08515453+2919072',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000137,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,132.9772917,29.31875,0.085,NULL,64388035296,1006063051,15719735,18.2),(57392,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57392,35.17,0.47,108,18124,70,NULL,NULL,'2MASX J08515455-2642366',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,132.977416667,-26.71014,0.321,NULL,42718398405,667474975,10429296,14.4),(57393,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57393,38.73,0.46,556,18125,70,NULL,NULL,'SDSS J085155.57+300209.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000099,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,132.981583333,30.03583,0.073,NULL,64384539496,1006008429,15718881,18.5),(57394,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57394,35.32,0.58,116,18126,70,NULL,NULL,'ESO 563- G 030',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'16.20',0.9,'S...',NULL,NULL,NULL,NULL,1,132.981667,-18.54267,0.701,NULL,42401839432,662528741,10352011,16.2),(57395,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57395,37.21,0.33,276,18127,70,NULL,NULL,'2MASX J08515600+1635591',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'18.58',0.24,NULL,NULL,NULL,NULL,NULL,1,132.983333,16.59983,0.053,NULL,63881238508,998144351,15596005,18.58),(57396,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57396,37.2,0.46,276,18128,70,NULL,NULL,'2MASX J08515638+3219256',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000186,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,132.9849583,32.32375,0.065,NULL,64385161187,1006018143,15719033,16.5),(57397,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57397,34.91,0.46,96.1,18129,70,NULL,NULL,'UGC 04639',NULL,'2015arXiv151105856S',2015,1,1.5,NULL,'G',0.000107,NULL,'13.82',1.4,'S0?',NULL,NULL,NULL,NULL,1,132.986125,16.94481,0.049,NULL,63880653319,998135208,15595862,13.82),(57398,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57398,37.5,0.27,316,18130,70,NULL,NULL,'2MASX J08515840+5651334',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000068,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,132.9935,56.85942,0.189,NULL,62011597275,968931207,15139550,18.1),(57399,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57399,35.5,0.33,126,18131,70,NULL,NULL,'CGCG 311-020',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000067,NULL,'15.7',0.48,NULL,NULL,NULL,NULL,NULL,1,133.002166667,64.42664,0.169,NULL,62231876251,972373066,15193329,15.7),(57400,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57400,38.02,0.33,401,18132,70,NULL,NULL,'2MASX J08520215+5507364',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000096,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,133.009,55.12686,0.097,NULL,61539639244,961556863,15024325,17.2),(57401,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57401,37.21,0.33,276,18133,70,NULL,NULL,'2MASX J08520260+1643211',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,133.010791667,16.72244,0.053,NULL,63881236051,998144313,15596004,16.9),(57402,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57402,37.97,0.33,392,18134,70,NULL,NULL,'2MASX J08520321+5037576',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,133.0135,50.63283,0.101,NULL,64238861322,1003732208,15683315,17),(57403,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57403,37.39,0.46,300,18135,70,NULL,NULL,'2MASX J08520365+0812017',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000179,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,133.015167,8.20067,0.125,NULL,63676721140,994948767,15546074,16.6),(57404,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57404,38.63,0.27,533,18136,70,NULL,NULL,'SDSS J085204.95+015749.6',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000074,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,133.020625,1.96381,0.105,NULL,62547525007,977305078,15270391,17.8),(57405,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57405,35.13,0.46,106,18137,70,NULL,NULL,'NGC 2675',NULL,'2015arXiv151105856S',2015,1,1.22,NULL,'G',0.000103,NULL,'14.1g',0.8,'E',NULL,NULL,NULL,NULL,1,133.020625,53.61731,0.045,NULL,63485690787,991963918,15499436,14.1),(57406,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57406,35.7,0.4,138,18137,NULL,NULL,'mean','NGC 2675',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57407,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57407,35.75,0.45,141,18137,NULL,NULL,'K','NGC 2675',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57408,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57408,37.61,0.46,332,18138,70,NULL,NULL,'2MASX J08520504+1819219',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000184,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,133.021,18.32272,0.021,NULL,63882807958,998168874,15596388,17.1),(57409,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57409,37.36,0.46,296,18139,70,NULL,NULL,'2MASX J08520564+5055226',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00007,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,133.0235,50.92297,0.089,NULL,64238047472,1003719491,15683117,17.6),(57410,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57410,37.52,0.23,320,18140,70,NULL,NULL,'SDSS J085206.11+292335.3',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000147,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,133.0254583,29.39314,0.085,NULL,64388034384,1006063037,15719734,18.7),(57411,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57411,36.13,0.46,169,18141,70,NULL,NULL,'2MASX J08520645+5232536',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000073,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,133.0269583,52.54833,0.045,NULL,64224784950,1003512264,15679879,16.6),(57412,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57412,35.02,0.46,101,18142,70,NULL,NULL,'CGCG 264-022 NED01',NULL,'2015arXiv151105856S',2015,1,0.57,'MCG position is for MCG +09-15-036.','G',0.000077,NULL,'15.3g',0.45,'S0/a',NULL,NULL,NULL,NULL,1,133.0272917,52.93275,0.061,NULL,63488395338,992006177,15500096,15.3),(57413,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57413,37.61,0.46,332,18143,70,NULL,NULL,'2MASX J08520683+1355391',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,133.0285,13.92764,0.085,NULL,63845245768,997581965,15587218,17.9),(57414,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57414,37.8,0.46,363,18144,70,NULL,NULL,'SDSS J085209.78+172608.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000101,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,133.04075,17.43564,0.029,NULL,63882572064,998165188,15596331,18.5),(57415,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57415,37.99,0.46,396,18145,70,NULL,NULL,'SDSS J085211.89+354127.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000139,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,133.049583,35.69092,0.077,NULL,64420395065,1006568672,15727635,18.2),(57416,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57416,37.78,0.46,360,18146,70,NULL,NULL,'2MASX J08521209+2821072',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000158,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,133.0502917,28.352,0.093,NULL,64376396705,1005881198,15716893,17.4),(57417,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57417,37.52,0.23,320,18147,70,NULL,NULL,'2MASX J08521282+2924392',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.00015,NULL,'15.8g',0.48,'S0',NULL,NULL,NULL,NULL,1,133.0535417,29.41086,0.085,NULL,64388030797,1006062981,15719734,15.8),(57418,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57418,35.64,0.63,134,18148,70,NULL,NULL,'2MASX J08521365-2219432',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000097,NULL,'16.31',0.5,NULL,NULL,NULL,NULL,NULL,1,133.056791667,-22.32872,0.629,NULL,42348033167,661688018,10338875,16.31),(57419,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57419,38.34,0.46,466,18149,70,NULL,NULL,'2MASX J08521408+1627511',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000126,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,133.058791667,16.46411,0.045,NULL,63881271274,998144863,15596013,18.5),(57420,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57420,37.52,0.23,320,18150,70,NULL,NULL,'2MASX J08521434+2920182',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'16.5g',0.35,'E',NULL,NULL,NULL,NULL,1,133.0597083,29.3385,0.085,NULL,64388064421,1006063506,15719742,16.5),(57421,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57421,37.66,0.46,340,18151,70,NULL,NULL,'2MASX J08521513+1846599',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,133.063167,18.78344,0.037,NULL,63881649948,998150780,15596105,17.1),(57422,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57422,35.83,0.46,146,18152,70,NULL,NULL,'2MASX J08521588+4108248',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000174,NULL,'15.7g',0.43,'E0',NULL,NULL,NULL,NULL,1,133.066125,41.14025,0.085,NULL,64244951576,1003827368,15684802,15.7),(57423,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57423,37.52,0.23,320,18153,70,NULL,NULL,'2MASX J08521741+2920581',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,133.072417,29.34947,0.085,NULL,64388064851,1006063513,15719742,17.8),(57424,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57424,31.97,0.56,24.7,18154,70,NULL,NULL,'ESO 563- G 031',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000067,NULL,'14',1.3,'(R\')SB(s)0^0^:',NULL,NULL,NULL,NULL,1,133.076375,-17.74453,0.445,NULL,42404242779,662566293,10352598,14),(57425,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57425,36.93,0.46,243,18155,70,NULL,NULL,'2MASX J08521878+3203236',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000165,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,133.07825,32.05661,0.065,NULL,64385053102,1006016454,15719007,16.8),(57426,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57426,37.5,0.27,316,18156,70,NULL,NULL,'2MASX J08521899+5648403',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000086,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,133.078917,56.81119,0.189,NULL,62011590693,968931104,15139548,17.1),(57427,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57427,38.45,0.46,489,18157,70,NULL,NULL,'2MASX J08522041-0016400',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000084,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,133.08525,-0.27767,0.045,NULL,39193357363,612396208,9568690,17.8),(57428,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57428,37.78,0.46,359,18158,70,NULL,NULL,'SDSS J085221.25+011251.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000081,NULL,'18.5g',0.09,NULL,NULL,NULL,NULL,NULL,1,133.0885417,1.21422,0.117,NULL,62548773305,977324582,15270696,18.5),(57429,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57429,35.5,0.33,126,18159,70,NULL,NULL,'2MASX J08522145+6424282',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',NULL,NULL,'15.7g',0.54,NULL,NULL,NULL,NULL,NULL,1,133.089708333,64.40794,0.169,NULL,62231877696,972373089,15193329,15.7),(57430,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57430,37.74,0.33,352,18160,70,NULL,NULL,'SDSS J085223.19+292343.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000141,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,133.096625,29.39533,0.041,NULL,64388063658,1006063494,15719742,18.7),(57431,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57431,36.65,0.46,213,18161,70,NULL,NULL,'SDSS J085223.24+040450.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,133.096833333,4.08069,0.133,NULL,63629590306,994212348,15534567,17.4),(57432,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57432,37.77,0.46,359,18162,70,NULL,NULL,'2MASX J08522386+2854471',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000168,NULL,'16.9g',0.26,'Sb',NULL,NULL,NULL,NULL,1,133.099333,28.91311,0.093,NULL,64376488214,1005882628,15716916,16.9),(57433,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57433,38.49,0.46,498,18163,70,NULL,NULL,'2MASX J08522494+3433467',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000184,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,133.104083,34.56317,0.069,NULL,64419286167,1006551346,15727364,17.6),(57434,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57434,36.94,0.46,245,18164,70,NULL,NULL,'2MASX J08522634+5129592',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000065,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,133.109625,51.49992,0.093,NULL,64225192071,1003518626,15679978,17.6),(57435,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57435,38.25,0.46,446,18165,70,NULL,NULL,'2MASX J08522640+5453329',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00009,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,133.1100417,54.89256,0.097,NULL,61539442976,961553796,15024278,17.5),(57436,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57436,37.74,0.33,352,18166,70,NULL,NULL,'2MASX J08522697+2924292',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,133.1125,29.40808,0.041,NULL,64388063312,1006063489,15719742,17.8),(57437,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57437,37.52,0.46,319,18167,70,NULL,NULL,'SDSS J085227.05+285540.1',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000174,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,133.11275,28.92781,0.093,NULL,64376488862,1005882638,15716916,17.3),(57438,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57438,37.55,0.46,324,18168,70,NULL,NULL,'2MASX J08522961+5313542',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000079,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,133.123417,53.23183,0.045,NULL,63485565800,991961965,15499405,17.2),(57439,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57439,38.02,0.17,402,18169,70,NULL,NULL,'2MASX J08523029+1542176',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000128,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,133.1262917,15.70492,0.073,NULL,63884514919,998195545,15596805,18.3),(57440,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57440,37.5,0.27,316,18170,70,NULL,NULL,'MCG +10-13-027',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000088,NULL,'16.7g',0.3,'AGN',NULL,NULL,NULL,NULL,1,133.1265,56.81286,0.189,NULL,62011591241,968931113,15139548,16.7),(57441,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57441,38.59,0.46,521,18171,70,NULL,NULL,'2MASX J08523104+1526046',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000171,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,133.129375,15.43461,0.105,NULL,63873001874,998015654,15593994,18.1),(57442,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57442,37.36,0.46,297,18172,70,NULL,NULL,'2MASX J08523180+2547572',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,133.132625,25.79922,0.113,NULL,64307753901,1004808654,15700135,17.1),(57443,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57443,36.97,0.46,248,18173,70,NULL,NULL,'2MASX J08523329+3518187',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000162,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,133.138791667,35.30528,0.077,NULL,64418844788,1006544449,15727257,16.7),(57444,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57444,38.02,0.33,401,18174,70,NULL,NULL,'2MASX J08523366+5501020',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000102,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,133.140333,55.01736,0.109,NULL,61539858461,961560288,15024379,16.8),(57445,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57445,32.66,NULL,34,18175,NULL,NULL,NULL,'SDSS J085233.75+135028.3',NULL,'2015AstBu..70....1K',2015,1,0.5,NULL,'G',0.000012,NULL,'17.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,133.140667,13.84122,0.089,NULL,63845279991,997582499,15587226,17.2),(57446,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57446,37.95,0.27,389,18176,70,NULL,NULL,'2MASX J08523399+3346317',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000171,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,133.141625,33.77561,0.069,NULL,64417511261,1006523613,15726931,17.8),(57447,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57447,37.99,0.46,397,18177,70,NULL,NULL,'2MASX J08523491+1618266',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000182,NULL,'16.7g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,133.145417,16.30753,0.061,NULL,63880376962,998130890,15595795,16.7),(57448,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57448,38.31,0.46,458,18178,70,NULL,NULL,'2MASX J08523516+1655576',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,133.1464583,16.93275,0.049,NULL,63880769274,998137019,15595890,17.8),(57449,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57449,37.13,0.46,267,18179,70,NULL,NULL,'2MASX J08523562+3212487',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000173,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,133.1484583,32.2135,0.061,NULL,64385015723,1006015870,15718997,17.2),(57450,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57450,37.94,0.46,387,18180,70,NULL,NULL,'2MASX J08523722+3623033',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000155,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,133.155083,36.38414,0.073,NULL,64420468173,1006569815,15727653,17.1),(57451,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57451,36.82,0.46,231,18181,70,NULL,NULL,'2MASX J08523724+0827141',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000165,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,133.155125,8.45383,0.121,NULL,63676685623,994948212,15546065,16.7),(57452,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57452,36.51,0.46,200,18182,70,NULL,NULL,'2MASX J08523789+0007340',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00008,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,133.158,0.12611,0.069,NULL,62548043384,977313177,15270518,16.7),(57453,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57453,37.97,0.33,392,18183,70,NULL,NULL,'2MASX J08523822+5041392',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000093,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,133.159458333,50.69436,0.101,NULL,64238737667,1003730276,15683285,16.7),(57454,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57454,38,0.33,399,18184,70,NULL,NULL,'SDSS J085239.60+295609.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000151,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,133.1650417,29.93592,0.073,NULL,64388402819,1006068794,15719824,18.6),(57455,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57455,37.64,0.46,337,18185,70,NULL,NULL,'2MASX J08524001+5522080',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000074,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,133.166625,55.36892,0.101,NULL,61539186719,961549792,15024215,17.8),(57456,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57456,38.68,0.46,544,18186,70,NULL,NULL,'2MASX J08524037+1438246',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.5g',0.21,'BrClG',NULL,NULL,NULL,NULL,1,133.16825,14.64014,0.133,NULL,63843412614,997553322,15586770,17.5),(57457,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57457,35.34,0.4,117,18187,NULL,NULL,'mean','UGC 04643',NULL,'2007A&A...465...71T',2007,1,1.21,NULL,'G',0.000033,NULL,'14.1g',0.93,'SA(s)bc',NULL,NULL,NULL,NULL,1,133.168333,21.42239,0.073,NULL,63835283998,997426312,15584786,14.1),(57458,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57458,35.36,0.47,118,18187,NULL,NULL,'H','UGC 04643',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57459,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57459,35.4,0.45,120,18187,NULL,NULL,'K','UGC 04643',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57460,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57460,35.52,0.46,127,18187,NULL,NULL,'J','UGC 04643',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57461,'Brightest Stars','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57461,29.81,NULL,9.2,18188,NULL,NULL,NULL,'NGC 2683',NULL,'2000A&AS..142..425D',2000,1,9.3,NULL,'G',0.000005,NULL,'10.64',2.2,'SA(rs)b;LINER  Sy2','Field galaxy',NULL,NULL,NULL,1,133.172208333,33.42175,0.073,NULL,64417878218,1006529347,15727021,10.64),(57462,'SBF','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57462,29.44,0.36,7.73,18188,NULL,NULL,'I','NGC 2683',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57463,'SBF','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57463,29.67,0.09,8.59,18188,74.4,NULL,NULL,'NGC 2683',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57464,'TRGB','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57464,29.67,0.09,8.59,18188,74.4,NULL,NULL,'NGC 2683',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57465,'TRGB','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57465,29.86,0.06,9.36,18188,NULL,NULL,NULL,'NGC 2683',NULL,'2015ApJ...805..144K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57466,'IRAS','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57466,29.81,0.8,9.17,18188,75,NULL,'A82, H','NGC 2683',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57467,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57467,28.78,0.4,5.7,18188,75,NULL,'B','NGC 2683',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57468,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57468,29.67,0.09,8.59,18188,74.4,NULL,NULL,'NGC 2683',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57469,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57469,29.93,NULL,9.68,18188,NULL,NULL,'B','NGC 2683',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57470,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57470,29.98,0.4,9.9,18188,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 2683',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57471,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57471,30.08,0.35,10.4,18188,NULL,NULL,NULL,'NGC 2683',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57472,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57472,30.09,0.47,10.4,18188,75,NULL,'A82, H, raw','NGC 2683',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57473,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57473,30.26,0.47,11.3,18188,75,NULL,'A82, H, inv','NGC 2683',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57474,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57474,30.35,0.47,11.8,18188,75,NULL,'A82, H, cor','NGC 2683',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57475,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57475,30.36,0.43,11.8,18188,75,NULL,'3.6 micron, color corrected','NGC 2683',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57476,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57476,30.46,0.43,12.4,18188,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2683',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57477,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57477,30.56,0.31,12.9,18188,NULL,NULL,NULL,'NGC 2683',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57478,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57478,30.56,NULL,12.9,18188,NULL,NULL,'LEDA [April 2006]','NGC 2683',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57479,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57479,30.73,0.29,14,18188,NULL,NULL,'Malmquist cor.','NGC 2683',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57480,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57480,36.44,0.46,194,18189,70,NULL,NULL,'2MASX J08524151+2719381',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000173,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,133.173125,27.32736,0.077,NULL,64308859911,1004825936,15700405,16.5),(57481,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57481,38.02,0.17,402,18190,70,NULL,NULL,'2MASX J08524179+1541246',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000178,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,133.174291667,15.69011,0.073,NULL,63884516598,998195571,15596805,17.6),(57482,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57482,37,0.46,251,18191,70,NULL,NULL,'2MASX J08524226+1153061',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000178,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,133.176083,11.88497,0.077,NULL,63661521644,994711275,15542363,16.9),(57483,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57483,36.84,0.46,234,18192,70,NULL,NULL,'2MASX J08524251+5851500',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,133.177166667,58.864,0.149,NULL,62020099041,969064047,15141625,16.9),(57484,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57484,38.02,0.17,402,18193,70,NULL,NULL,'2MASX J08524255+1544066',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.8g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,133.17725,15.73514,0.073,NULL,63884514065,998195532,15596805,16.8),(57485,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57485,38.04,0.46,405,18194,70,NULL,NULL,'2MASX J08524288+1720556',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00017,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,133.178625,17.34881,0.017,NULL,63882547759,998164808,15596325,16.9),(57486,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57486,38.55,0.46,514,18195,70,NULL,NULL,'2MASX J08524375+1519516',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000183,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,133.182333,15.33097,0.105,NULL,63873196816,998018700,15594042,17.8),(57487,'L(H{beta})-{sigma}','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57487,45.13,NULL,1642,18196,74.3,NULL,NULL,'WISP 022_0216',1.543,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,133.192875,3.14608,0.101,NULL,63632863426,994263491,15535367,NULL),(57488,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57488,34.15,0.51,67.7,18197,70,NULL,NULL,'ESO 036- G 010',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000093,NULL,'14.61',0.7,'SA pec',NULL,NULL,NULL,NULL,1,133.194,-73.62219,0.589,NULL,40617856476,634654007,9916468,14.61),(57489,'TRGB','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57489,29.81,0.1,9.15,18198,74.4,NULL,NULL,'LEDA 166095',NULL,'2013AJ....146...86T',2013,1,2.4,NULL,'G',0.000001,NULL,'16.8',1.8,'dwarf Sph?',NULL,NULL,NULL,NULL,1,133.211667,33.79778,0.069,NULL,64417508087,1006523563,15726930,16.8),(57490,'TRGB','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57490,29.84,0.06,9.28,18198,NULL,NULL,NULL,'LEDA 166095',NULL,'2015ApJ...805..144K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57491,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57491,38.02,0.17,402,18199,70,NULL,NULL,'2MASX J08525159+1547221',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000155,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,133.2150417,15.78947,0.073,NULL,63884739363,998199052,15596860,17.3),(57492,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57492,37.74,0.46,352,18200,70,NULL,NULL,'2MASX J08525314+0101590',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000089,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,133.221541667,1.033,0.121,NULL,62549597118,977337454,15270897,17.8),(57493,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57493,38,0.33,399,18201,70,NULL,NULL,'SDSS J085253.70+295131.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000129,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,133.22375,29.85864,0.073,NULL,64388663871,1006072872,15719888,18.8),(57494,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57494,38.21,0.46,439,18202,70,NULL,NULL,'SDSS J085254.75+180136.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000143,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,133.228125,18.02694,0.041,NULL,63882792304,998168629,15596384,18.5),(57495,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57495,36.38,0.46,189,18203,70,NULL,NULL,'2MASX J08525476+0627081',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000192,NULL,'15.7g',0.47,'E0',NULL,NULL,NULL,NULL,1,133.22825,6.45231,0.157,NULL,63675531159,994930174,15545783,15.7),(57496,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57496,34.37,0.57,74.7,18204,70,NULL,NULL,'MRK 1219',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.5',0.6,NULL,NULL,NULL,NULL,NULL,1,133.2315,-4.77428,0.009,NULL,42151813341,658622083,10290970,16.5),(57497,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57497,37.95,0.33,389,18205,70,NULL,NULL,'2MASX J08525668+5914390',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.23',0.31,NULL,NULL,NULL,NULL,NULL,1,133.236375,59.24433,0.145,NULL,62019148060,969049188,15141393,17.23),(57498,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57498,37.92,0.46,383,18206,70,NULL,NULL,'2MASX J08525683+5052384',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000078,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,133.236583,50.87719,0.089,NULL,64238776724,1003730886,15683295,17.5),(57499,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57499,35.52,0.46,127,18207,70,NULL,NULL,'2MASX J08525685+2221250',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000168,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,133.2369583,22.35708,0.085,NULL,63821836146,997216189,15581502,16.4),(57500,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57500,36.47,0.62,197,18208,70,NULL,NULL,'2MASX J08525702-0503157',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.05',NULL,NULL,NULL,NULL,NULL,NULL,1,133.237875,-5.05447,0.041,NULL,42151886161,658623221,10290987,17.05),(57501,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57501,34.51,0.4,79.9,18209,NULL,NULL,'mean','ESO 496- G 013',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000013,NULL,'14.34',1.1,'SAB(rs)c',NULL,NULL,NULL,NULL,1,133.237875,-25.30244,0.553,NULL,42715270760,667426105,10428532,14.34),(57502,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57502,34.63,0.47,84.4,18209,NULL,NULL,'H','ESO 496- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57503,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57503,34.7,0.46,87,18209,NULL,NULL,'J','ESO 496- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57504,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57504,34.73,0.45,88.5,18209,NULL,NULL,'K','ESO 496- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57505,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57505,38.02,0.17,402,18210,70,NULL,NULL,'2MASX J08525789+1539051',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,133.241333333,15.65136,0.073,NULL,63884510402,998195475,15596804,17.1),(57506,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57506,37.5,0.46,317,18211,70,NULL,NULL,'2MASX J08525908+3118430',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000149,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,133.2462917,31.312,0.049,NULL,64385942581,1006030352,15719224,18.2),(57507,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57507,37.96,0.46,390,18212,70,NULL,NULL,'2MASX J08525941+3621004',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00017,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,133.2475,36.35022,0.073,NULL,64420497949,1006570280,15727660,17.8),(57508,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57508,36.04,0.46,161,18213,70,NULL,NULL,'2MASX J08530287+1935070',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000147,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,133.262125,19.58525,0.073,NULL,63826428330,997287942,15582624,16.9),(57509,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57509,37.15,0.46,269,18214,70,NULL,NULL,'2MASX J08530321+1918120',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000073,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,133.263416667,19.30344,0.077,NULL,63826479807,997288746,15582636,17.6),(57510,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57510,39.12,0.46,668,18215,70,NULL,NULL,'SDSS J085303.41+302121.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000169,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,133.26425,30.356,0.069,NULL,64384039066,1006000610,15718759,18.6),(57511,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57511,38.02,0.17,402,18216,70,NULL,NULL,'2MASX J08530351+1550071',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,133.2645417,15.83542,0.081,NULL,63884741353,998199083,15596860,17.5),(57512,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57512,37.67,0.46,342,18217,70,NULL,NULL,'SDSS J085303.53+094815.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000145,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,133.264708333,9.80433,0.153,NULL,63670772401,994855818,15544622,18),(57513,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57513,37.98,0.46,394,18218,70,NULL,NULL,'2MASX J08530420+4320401',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000149,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,133.267625,43.34458,0.077,NULL,64276601699,1004321901,15692529,16.8),(57514,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57514,37.83,0.33,367,18219,70,NULL,NULL,'SDSS J085304.32+041825.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000139,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,133.2680417,4.30703,0.145,NULL,63629111693,994204870,15534451,18.4),(57515,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57515,38.85,0.46,589,18220,70,NULL,NULL,'2MASX J08530555+2902351',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,133.273125,29.04303,0.069,NULL,64387923881,1006061310,15719707,18.2),(57516,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57516,36.55,0.46,204,18221,70,NULL,NULL,'2MASX J08530586+0901530',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000183,NULL,'16.1g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,133.274417,9.0315,0.133,NULL,63684461206,995069706,15547964,16.1),(57517,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57517,37.57,0.46,327,18222,70,NULL,NULL,'SDSS J085305.95+291235.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000149,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,133.2747917,29.20986,0.053,NULL,64388014094,1006062720,15719730,18.6),(57518,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57518,37.95,0.27,389,18223,70,NULL,NULL,'2MASX J08530600+3333231',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000176,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,133.274958333,33.55647,0.073,NULL,64417966093,1006530720,15727042,18.1),(57519,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57519,37.42,0.33,305,18224,70,NULL,NULL,'2MASX J08530659+2742451',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,133.277417,27.71269,0.089,NULL,64308745985,1004824156,15700377,17),(57520,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57520,37.1,0.46,263,18225,70,NULL,NULL,'2MASX J08530678+1356091',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000152,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,133.278416667,13.93586,0.105,NULL,63845269884,997582341,15587224,17),(57521,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57521,37.62,0.46,334,18226,70,NULL,NULL,'2MASX J08530888+1826169',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000185,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,133.286916667,18.43792,0.021,NULL,63881859233,998154050,15596157,17),(57522,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57522,36.3,0.5,182,18227,70,NULL,NULL,'CGCG 005-022',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000113,NULL,'15.5',0.5,NULL,NULL,NULL,NULL,NULL,1,133.287833,-1.64867,0.021,NULL,39194007301,612406364,9568849,15.5),(57523,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57523,37.95,0.33,389,18228,70,NULL,NULL,'2MASX J08530984+5914109',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,133.290875,59.23628,0.145,NULL,62019146499,969049164,15141393,17.8),(57524,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57524,36.26,0.74,179,18229,70,NULL,NULL,'2MASX J08531078-1731239',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,133.294875,-17.52325,0.425,NULL,42403621969,662556593,10352446,15.2),(57525,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57525,37,0.46,251,18230,70,NULL,NULL,'2MASX J08531081+2250229',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,133.295125,22.83975,0.117,NULL,63822168549,997221383,15581584,17.7),(57526,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57526,33,0.2,39.8,18231,74.4,NULL,NULL,'UGC 04623',NULL,'2013AJ....146...86T',2013,1,3.5,NULL,'G',0.000037,NULL,'13.35',0.9,'Scd:','Group member',NULL,NULL,NULL,1,133.296375,76.48606,0.033,NULL,61420960039,959702500,14995351,13.35),(57527,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57527,33.04,0.46,40.5,18231,NULL,NULL,'J','UGC 04623',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57528,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57528,33.11,0.43,42,18231,75,NULL,'3.6 micron, color corrected','UGC 04623',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57529,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57529,33.12,0.47,42.1,18231,NULL,NULL,'H','UGC 04623',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57530,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57530,33.16,0.4,42.8,18231,NULL,NULL,'mean','UGC 04623',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57531,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57531,33.21,0.58,43.9,18231,NULL,NULL,NULL,'UGC 04623',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57532,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57532,33.26,0.45,44.9,18231,NULL,NULL,'K','UGC 04623',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57533,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57533,33.27,0.56,45.1,18231,NULL,NULL,'Malmquist cor.','UGC 04623',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57534,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57534,33.37,0.43,47.1,18231,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04623',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57535,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57535,35.47,0.46,124,18232,70,NULL,NULL,'2MASX J08531142+3708062',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00007,NULL,'16.0g',0.34,'SF',NULL,NULL,NULL,NULL,1,133.297583,37.13514,0.081,NULL,64413858891,1006466545,15726039,16),(57536,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57536,38.16,0.46,428,18233,70,NULL,NULL,'2MASX J08531194+1805309',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,133.299625,18.09203,0.041,NULL,63881677974,998151218,15596112,17.5),(57537,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57537,37.59,0.46,330,18234,70,NULL,NULL,'2MASX J08531283+2408280',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00017,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,133.3035,24.14119,0.089,NULL,63790512328,996726755,15573855,17.3),(57538,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57538,38.02,0.27,402,18235,70,NULL,NULL,'2MASX J08531305+3123451',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000161,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,133.304375,31.39586,0.057,NULL,64385812378,1006028318,15719192,18.3),(57539,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57539,37.99,0.46,397,18236,70,NULL,NULL,'2MASX J08531367+4007052',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000192,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,133.306833333,40.11811,0.061,NULL,64366238887,1005722482,15714413,16.5),(57540,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57540,37.72,0.46,350,18237,70,NULL,NULL,'2MASX J08531376+2359560',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,133.3075,23.99894,0.097,NULL,63790620420,996728444,15573881,17),(57541,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57541,37.95,0.27,389,18238,70,NULL,NULL,'2MASX J08531449+3334221',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000145,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,133.3104583,33.57272,0.073,NULL,64418011081,1006531423,15727053,17.5),(57542,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57542,37.05,0.46,257,18239,70,NULL,NULL,'2MASX J08531524+0842390',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000164,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,133.313583,8.71097,0.121,NULL,63684336149,995067752,15547933,17.1),(57543,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57543,37.42,0.46,305,18240,70,NULL,NULL,'2MASX J08531556+5232414',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000079,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,133.3149583,52.54489,0.045,NULL,64224799363,1003512490,15679882,18),(57544,'Tully est','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57544,32.81,0.8,36.5,18241,75,NULL,NULL,'UGCA 146',NULL,'1988NBGC.C....0000T',1988,1,0.7,NULL,'G',0.000033,NULL,'15.2',0.6,'E;a',NULL,NULL,NULL,NULL,1,133.314875,73.18892,0.069,NULL,62176506574,971507915,15179811,15.2),(57545,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57545,37.83,0.46,367,18242,70,NULL,NULL,'2MASX J08531663+0237399',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000156,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,133.319208333,2.62783,0.105,NULL,63621409130,994084517,15532570,17.3),(57546,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57546,38.47,0.46,495,18243,70,NULL,NULL,'2MASX J08531717+4004382',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.00015,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,133.3214583,40.07744,0.061,NULL,64366239003,1005722484,15714413,18.5),(57547,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57547,38.35,0.46,467,18244,70,NULL,NULL,'SDSS J085317.35+143526.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000171,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,133.322333,14.59058,0.133,NULL,63843152847,997549263,15586707,18.5),(57548,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57548,38.52,0.46,505,18245,70,NULL,NULL,'2MASX J08531788+0020329',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000081,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,133.324667,0.3425,0.081,NULL,62547837387,977309959,15270468,18),(57549,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57549,37.38,0.46,299,18246,70,NULL,NULL,'2MASX J08531936+5140534',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000088,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,133.3307917,51.68161,0.081,NULL,64225241214,1003519393,15679990,17.9),(57550,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57550,37.22,0.46,278,18247,70,NULL,NULL,'2MASX J08532080+6407503',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,133.336625,64.13075,0.149,NULL,62231083562,972360680,15193135,16.5),(57551,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57551,37.01,0.46,252,18248,70,NULL,NULL,'2MASX J08532330+1308375',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000193,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,133.347041667,13.14386,0.081,NULL,63842287627,997535744,15586496,16.4),(57552,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57552,37.59,0.46,330,18249,70,NULL,NULL,'2MASX J08532470+1702235',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000168,NULL,'16.4g',0.32,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,133.3527917,17.03972,0.025,NULL,63880801494,998137523,15595898,16.4),(57553,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57553,37.6,0.46,332,18250,70,NULL,NULL,'2MASX J08532509+3347359',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000194,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,133.354667,33.79333,0.069,NULL,64417562113,1006524408,15726943,16.9),(57554,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57554,37.21,0.46,276,18251,70,NULL,NULL,'2MASX J08532541+1812133',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00015,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,133.355833,18.20367,0.041,NULL,63881680421,998151256,15596113,17.2),(57555,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57555,36.97,0.46,247,18252,70,NULL,NULL,'2MASX J08532552+1459015',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,133.356416667,14.98361,0.121,NULL,63873084400,998016943,15594014,16.9),(57556,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57556,38.4,0.46,478,18253,70,NULL,NULL,'SDSS J085325.56+003729.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000079,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,133.3565,0.625,0.121,NULL,62549044925,977328826,15270762,18.5),(57557,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57557,38.28,0.46,453,18254,70,NULL,NULL,'2MASX J08532596+0130479',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000085,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,133.358125,1.51333,0.117,NULL,62549205348,977331333,15270802,17.9),(57558,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57558,37.15,0.46,269,18255,70,NULL,NULL,'2MASX J08532631+3230579',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,133.359833,32.51608,0.061,NULL,64385107010,1006017297,15719020,17.3),(57559,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57559,37.18,0.33,272,18256,70,NULL,NULL,'2MASX J08532889+5529497',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000084,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,133.3705417,55.49711,0.125,NULL,61539346345,961552286,15024254,17.4),(57560,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57560,37.83,0.33,367,18257,70,NULL,NULL,'2MASX J08532921+0424359',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000158,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,133.371667,4.40994,0.145,NULL,63629144079,994205376,15534459,17.4),(57561,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57561,37.97,0.46,392,18258,70,NULL,NULL,'2MASX J08532923+0753210',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000178,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,133.3717917,7.88919,0.125,NULL,63676598306,994946848,15546044,18.1),(57562,'Tully est','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57562,32.64,0.8,33.7,18259,75,NULL,NULL,'NGC 2714',NULL,'1988NBGC.C....0000T',1988,1,1.6,'abs(b) < 10 degrees.','G',0.000127,NULL,'14.0B',1.6,'E0',NULL,NULL,NULL,NULL,1,133.37425,-59.21711,NULL,NULL,40539181883,633424716,9897261,14),(57563,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57563,37.6,0.46,331,18260,70,NULL,NULL,'2MASX J08533225+1413205',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000136,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,133.384333,14.22239,0.109,NULL,63843321262,997551894,15586748,17.6),(57564,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57564,37.49,0.46,315,18261,70,NULL,NULL,'2MASX J08533260+3137299',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000171,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,133.385875,31.62489,0.057,NULL,64385384417,1006021631,15719087,16.7),(57565,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57565,34.46,0.49,78,18262,75,NULL,'IR','UGC 04655',NULL,'2011yCatp016004901K',2011,1,1.31,NULL,'G',0.000008,NULL,'16.5g',0.16,'Sd','Field galaxy',NULL,NULL,NULL,1,133.386375,4.78242,0.161,NULL,63630955763,994233683,15534901,16.5),(57566,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57566,34.69,NULL,86.7,18262,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04655',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57567,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57567,34.71,NULL,87.4,18262,NULL,NULL,'Dipole + Quadrupole','UGC 04655',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57568,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57568,34.71,NULL,87.4,18262,NULL,NULL,'Dipole','UGC 04655',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57569,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57569,34.77,NULL,89.8,18262,NULL,NULL,NULL,'UGC 04655',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57570,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57570,34.82,0.43,91.9,18262,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04655',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57571,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57571,34.9,0.43,95.4,18262,75,NULL,'3.6 micron, color corrected','UGC 04655',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57572,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57572,34.92,0.2,96.4,18262,74.4,NULL,NULL,'UGC 04655',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57573,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57573,35.04,0.44,102,18262,NULL,NULL,NULL,'UGC 04655',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57574,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57574,35.2,0.41,109,18262,NULL,NULL,'Malmquist cor.','UGC 04655',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57575,'SBF','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57575,31.08,0.14,16.4,18263,74.4,NULL,NULL,'NGC 2681',NULL,'2013AJ....146...86T',2013,1,3.6,NULL,'G',0.000037,NULL,'11.09',3.3,'(R\')SAB(rs)0/a Sy3','Group member',NULL,NULL,'LINER b',1,133.386417,51.31367,0.093,NULL,64225156384,1003518068,15679969,11.09),(57576,'SBF','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57576,31.18,0.34,17.2,18263,NULL,NULL,'I','NGC 2681',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57577,'Tully est','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57577,30.62,0.8,13.3,18263,75,NULL,'B','NGC 2681',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57578,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57578,38.02,0.27,402,18264,70,NULL,NULL,'SDSS J085332.84+311859.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000138,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,133.386875,31.31639,0.057,NULL,64385941528,1006030336,15719224,18.5),(57579,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57579,38.02,0.27,402,18265,70,NULL,NULL,'2MASX J08533350+3117429',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000156,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,133.389458333,31.29517,0.057,NULL,64385728618,1006027009,15719172,16.9),(57580,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57580,37.61,0.46,333,18266,70,NULL,NULL,'2MASX J08533418+3413399',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000167,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,133.392375,34.22786,0.065,NULL,64419300968,1006551577,15727368,18.1),(57581,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57581,38.02,0.17,402,18267,70,NULL,NULL,'2MASX J08533659+1535045',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000179,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,133.402583,15.58453,0.085,NULL,63884592888,998196763,15596824,17.1),(57582,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57582,37.42,0.33,305,18268,70,NULL,NULL,'2MASX J08533696+2736501',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000186,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,133.404,27.61381,0.085,NULL,64308743891,1004824123,15700376,16.6),(57583,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57583,37.61,0.46,332,18269,70,NULL,NULL,'SDSS J085338.51+372109.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000114,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,133.4105,37.35267,0.081,NULL,64413872523,1006466758,15726043,18.4),(57584,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57584,37.4,0.46,301,18270,70,NULL,NULL,'2MASX J08533930+4124213',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,133.413667,41.40581,0.061,NULL,64244621651,1003822213,15684722,17.2),(57585,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57585,37.16,0.46,270,18271,70,NULL,NULL,'2MASX J08533973+3644113',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000143,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,133.415667,36.73658,0.073,NULL,64413098994,1006454671,15725854,17),(57586,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57586,37.85,0.46,372,18272,70,NULL,NULL,'2MASX J08534082+2945001',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,133.42,29.75008,0.073,NULL,64388726759,1006073855,15719903,17.8),(57587,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57587,37.87,0.46,375,18273,70,NULL,NULL,'2MASX J08534091+3316199',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000189,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,133.4204583,33.27233,0.077,NULL,64418187741,1006534183,15727096,17.1),(57588,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57588,38.18,0.46,432,18274,70,NULL,NULL,'2MASX J08534208+6033137',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,133.425375,60.55389,0.161,NULL,62074973498,969921460,15155022,NULL),(57589,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57589,33.02,0.45,40.2,18275,NULL,NULL,'K','IC 0520',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.00004,NULL,'12.55',1.5,'SAB(rs)ab?     LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,133.426083,73.49094,0.065,NULL,62176611576,971509555,15179836,12.55),(57590,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57590,33.04,0.47,40.6,18275,NULL,NULL,'H','IC 0520',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57591,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57591,33.09,0.46,41.5,18275,NULL,NULL,'J','IC 0520',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57592,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57592,33.49,0.4,49.9,18275,NULL,NULL,'mean','IC 0520',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57593,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57593,38.17,0.46,431,18276,70,NULL,NULL,'2MASX J08534245+0838558',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00017,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,133.4269583,8.64881,0.121,NULL,63684288060,995067000,15547921,17),(57594,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57594,37.55,0.46,324,18277,70,NULL,NULL,'2MASX J08534325+3126380',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,133.430291667,31.44411,0.057,NULL,64385350503,1006021101,15719079,17.9),(57595,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57595,37.14,0.33,268,18278,70,NULL,NULL,'2MASX J08534409+1508055',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000013,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,133.433833,15.13472,0.089,NULL,63873047142,998016361,15594005,16.8),(57596,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57596,38.87,0.46,594,18279,70,NULL,NULL,'SDSS J085344.78+405527.6',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,133.436625,40.92433,0.053,NULL,64245188151,1003831064,15684860,17.7),(57597,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57597,36.93,0.46,243,18280,70,NULL,NULL,'2MASX J08534565+3615325',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000123,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,133.440375,36.25908,0.073,NULL,64420483961,1006570061,15727657,16.5),(57598,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57598,35.91,0.6,152,18281,70,NULL,NULL,'2MASX J08534689-0533172',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,133.445375,-5.55486,0.025,NULL,42150273594,658598024,10290594,17.1),(57599,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57599,37.99,0.46,395,18282,70,NULL,NULL,'2MASX J08534790+4027356',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,133.4495,40.46,0.045,NULL,64244750800,1003824231,15684753,17.9),(57600,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57600,36.79,0.46,228,18283,70,NULL,NULL,'2MASX J08534847+3245410',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,133.451833333,32.76139,0.065,NULL,64417771496,1006527679,15726994,17.6),(57601,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57601,37.14,0.33,268,18284,70,NULL,NULL,'SDSS J085349.78+145226.0',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'15.9g',0.43,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,133.457417,14.87392,0.097,NULL,63873887286,998029488,15594210,15.9),(57602,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57602,37.88,0.17,376,18285,70,NULL,NULL,'2MASX J08535025+2904240',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000123,NULL,'16.7g',0.3,'E',NULL,NULL,NULL,NULL,1,133.459458333,29.07344,0.069,NULL,64387929427,1006061397,15719709,16.7),(57603,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57603,36.65,0.46,214,18286,70,NULL,NULL,'2MASX J08535041+2803390',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000107,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,133.460166667,28.06089,0.093,NULL,64377249909,1005894529,15717102,17),(57604,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57604,37.02,0.46,254,18287,70,NULL,NULL,'2MASX J08535115+5817368',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.15',0.24,NULL,NULL,NULL,NULL,NULL,1,133.462917,58.29367,0.137,NULL,62021490471,969085788,15141965,17.15),(57605,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57605,37.97,0.46,393,18288,70,NULL,NULL,'2MASX J08535139+1528283',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,133.464,15.47458,0.085,NULL,63873118779,998017480,15594023,17.4),(57606,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57606,36.36,NULL,187,18289,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0804',NULL,'2010Ap&SS.325..163P',2010,1,0.85,NULL,'G',NULL,NULL,'17.54',0.1,'Sb(f)',NULL,NULL,NULL,NULL,1,133.46625,49.34647,0.057,NULL,64236292533,1003692070,15682688,17.54),(57607,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57607,36.38,NULL,189,18289,NULL,NULL,NULL,'FGC 0804',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57608,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57608,36.39,NULL,190,18289,NULL,NULL,'Dipole + Quadrupole','FGC 0804',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57609,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57609,36.42,NULL,193,18289,NULL,NULL,'Dipole','FGC 0804',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57610,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57610,36.95,0.49,246,18289,75,NULL,'IR','FGC 0804',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57611,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57611,38.12,0.46,420,18290,70,NULL,NULL,'2MASX J08535213+1418293',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000185,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,133.467167,14.30806,0.129,NULL,63843318850,997551857,15586747,17.4),(57612,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57612,38,0.46,398,18291,70,NULL,NULL,'2MASX J08535295+5230113',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000095,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,133.4707083,52.50314,0.045,NULL,64224791456,1003512366,15679880,16.8),(57613,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57613,37.71,0.46,348,18292,70,NULL,NULL,'2MASX J08535379+4006296',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000191,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,133.474208333,40.10822,0.061,NULL,64366714202,1005729909,15714529,16.6),(57614,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57614,37.54,0.46,323,18293,70,NULL,NULL,'2MASX J08535412+3001429',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000167,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,133.475583,30.02872,0.073,NULL,64388461712,1006069714,15719839,16.9),(57615,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57615,37.08,0.46,261,18294,70,NULL,NULL,'2MASX J08535503+0344094',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000173,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,133.47925,3.73578,0.133,NULL,63633701262,994276582,15535571,16.6),(57616,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57616,35.15,0.46,107,18295,70,NULL,NULL,'CGCG 264-027',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000085,NULL,'14.9g',0.52,'E?',NULL,NULL,NULL,NULL,1,133.4797083,52.40044,0.073,NULL,64224982827,1003515356,15679927,14.9),(57617,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57617,36.86,0.46,236,18296,70,NULL,NULL,'2MASX J08535557+5421188',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000108,NULL,'16.0g',0.36,'E0',NULL,NULL,NULL,NULL,1,133.4815417,54.35511,0.105,NULL,63485948408,991967943,15499499,16),(57618,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57618,37.18,0.33,272,18297,70,NULL,NULL,'2MASX J08535761+5529438',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000083,NULL,'17.7g',0.22,'BLAGN',NULL,NULL,NULL,'Sy 1',1,133.490083,55.49553,0.125,NULL,61539315561,961551805,15024246,17.7),(57619,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57619,37.72,0.33,350,18298,70,NULL,NULL,'2MASX J08535772+6005217',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,133.4904583,60.08958,0.145,NULL,62064586972,969759171,15152487,18),(57620,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57620,38.28,0.46,453,18299,70,NULL,NULL,'SDSS J085358.08+543207.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000071,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,133.4920417,54.53533,0.113,NULL,63485911420,991967365,15499490,18.5),(57621,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57621,38.22,0.33,441,18300,70,NULL,NULL,'SDSS J085358.38+401445.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000144,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,133.49325,40.24594,0.053,NULL,64366184771,1005721637,15714400,18.6),(57622,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57622,38,0.46,399,18301,70,NULL,NULL,'2MASX J08535880+2214511',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,133.4952083,22.24758,0.085,NULL,63821666281,997213535,15581461,17.8),(57623,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57623,36.11,0.46,166,18302,70,NULL,NULL,'2MASX J08535931+4444538',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000157,NULL,'16.1g',0.4,'E0',NULL,NULL,NULL,NULL,1,133.497125,44.74831,0.093,NULL,64288164647,1004502572,15695352,16.1),(57624,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57624,38.02,0.46,401,18303,70,NULL,NULL,'2MASXi J0854001+263554',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000174,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,133.5007917,26.59825,0.109,NULL,64307430256,1004803597,15700056,18.2),(57625,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57625,34.12,0.1,66.8,18304,NULL,NULL,NULL,'UGC 04657',NULL,'2009ApJS..182..474S',2009,1,1.15,NULL,'G',0.000005,NULL,'15.5g',0.37,'Sb',NULL,NULL,NULL,NULL,1,133.502333,18.68231,0.041,NULL,63881792496,998153007,15596140,15.5),(57626,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57626,34.17,NULL,68.2,18304,NULL,NULL,'Dipole','UGC 04657',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57627,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57627,34.18,NULL,68.5,18304,NULL,NULL,'Dipole + Quadrupole','UGC 04657',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57628,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57628,34.18,NULL,68.7,18304,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04657',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57629,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57629,34.39,NULL,75.6,18304,NULL,NULL,NULL,'UGC 04657',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57630,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57630,34.41,0.2,76.2,18304,74.4,NULL,NULL,'UGC 04657',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57631,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57631,36.09,0.46,165,18305,70,NULL,NULL,'2MASX J08540104+1950341',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,133.504291667,19.84283,0.061,NULL,63826138756,997283418,15582553,17),(57632,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57632,36.99,0.46,251,18306,70,NULL,NULL,'2MASX J08540136+0033324',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000089,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,133.50575,0.55897,0.109,NULL,62549122713,977330042,15270781,16.6),(57633,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57633,36.92,0.46,242,18307,70,NULL,NULL,'2MASX J08540227+3508470',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000163,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,133.50925,35.14661,0.053,NULL,64420805109,1006575079,15727735,17),(57634,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57634,36.51,0.46,201,18308,70,NULL,NULL,'2MASX J08540244+1720333',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,133.510291667,17.34264,0.017,NULL,63882446650,998163228,15596300,16.3),(57635,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57635,36.27,0.46,179,18309,70,NULL,NULL,'2MASX J08540440+0051118',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000099,NULL,'15.4g',0.5,'E0',NULL,NULL,NULL,NULL,1,133.518333,0.85322,0.121,NULL,62549448729,977335136,15270861,15.4),(57636,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57636,37.88,0.17,376,18310,70,NULL,NULL,'2MASX J08540457+2903122',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000137,NULL,'15.8g',0.51,'BrClG;S0',NULL,NULL,NULL,NULL,1,133.518875,29.05356,0.069,NULL,64387885931,1006060717,15719698,15.8),(57637,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2002hd',NULL,57637,34.75,0.2,86.3,18311,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','MCG -01-23-008',0.035,'2011A&A...526A..81B',2011,1,1.1,'MCG notes say that dec. for MCG -01-23 zone is off by 8\'.','G',0.000107,NULL,'15',0.9,'SA0^0^:',NULL,NULL,NULL,NULL,1,133.5195,-7.18319,0.089,NULL,42206337717,659474026,10304281,15),(57638,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2002hd',NULL,57638,34.95,0.17,94.4,18311,74.2,NULL,'SALT 2','MCG -01-23-008',0.035,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57639,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2002hd',NULL,57639,35.53,0.09,128,18311,74.4,NULL,NULL,'MCG -01-23-008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57640,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2002hd',NULL,57640,35.75,0.04,136,18311,72,NULL,'SALT','MCG -01-23-008',0.035,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57641,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2002hd',NULL,57641,35.76,0.17,137,18311,65,NULL,'SALT','MCG -01-23-008',0.035,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57642,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2002hd',NULL,57642,35.8,0.17,139,18311,65,NULL,'MLCS17','MCG -01-23-008',0.035,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57643,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2002hd',NULL,57643,35.82,0.2,141,18311,65,NULL,'MLCS31','MCG -01-23-008',0.035,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57644,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2002hd',NULL,57644,35.84,0.19,142,18311,65,NULL,'SALT2','MCG -01-23-008',0.035,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57645,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2002hd',NULL,57645,36.53,0.06,196,18311,70,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','MCG -01-23-008',0.035,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57646,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57646,38.16,0.46,428,18312,70,NULL,NULL,'2MASX J08540627+2626482',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,133.5260417,26.44675,0.101,NULL,64307442129,1004803783,15700059,18.3),(57647,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57647,37.89,0.46,378,18313,70,NULL,NULL,'SDSS J085407.02+293500.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000145,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,133.52925,29.58333,0.041,NULL,64388802424,1006075037,15719922,18.5),(57648,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57648,37.72,0.33,350,18314,70,NULL,NULL,'SDSS J085407.09+600518.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,133.529583,60.08861,0.145,NULL,62064584880,969759138,15152486,18.6),(57649,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57649,38.3,0.46,457,18315,70,NULL,NULL,'2MASX J08540769+5018182',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000067,NULL,'18.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,133.5322083,50.30503,0.057,NULL,64238696722,1003729636,15683275,18.3),(57650,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57650,35.17,0.46,108,18316,70,NULL,NULL,'CGCG 090-033',NULL,'2015arXiv151105856S',2015,1,0.88,NULL,'G',0.000143,NULL,'14.7g',0.62,NULL,NULL,NULL,NULL,NULL,1,133.5362083,17.43,0.017,NULL,63882417532,998162773,15596293,14.7),(57651,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57651,38.66,0.46,540,18317,70,NULL,NULL,'2MASX J08540898+1539473',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,133.5375,15.66311,0.085,NULL,63884613862,998197091,15596829,NULL),(57652,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57652,37.26,0.33,283,18318,70,NULL,NULL,'2MASX J08540927+2845072',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000168,NULL,'16.5g',0.38,NULL,NULL,NULL,NULL,NULL,1,133.53875,28.75189,0.061,NULL,64376459973,1005882187,15716909,16.5),(57653,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57653,37.67,0.46,342,18319,70,NULL,NULL,'2MASX J08541003+5459217',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000077,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,133.54175,54.98933,0.109,NULL,61539711959,961557999,15024343,17.5),(57654,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57654,37.95,0.46,389,18320,70,NULL,NULL,'SDSS J085410.21+290204.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000161,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,133.542583,29.03453,0.069,NULL,64387885621,1006060712,15719698,18.4),(57655,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57655,37.76,0.46,356,18321,70,NULL,NULL,'2MASX J08541103+5158292',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000081,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,133.5457917,51.97472,0.061,NULL,64225045266,1003516332,15679942,17.4),(57656,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57656,37.96,0.46,391,18322,70,NULL,NULL,'2MASX J08541109+3857237',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,133.546083,38.95658,0.045,NULL,64366561575,1005727524,15714492,17.8),(57657,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57657,38.35,0.46,467,18323,70,NULL,NULL,'2MASX J08541150+2231590',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000172,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,133.547917,22.53314,0.109,NULL,63822461469,997225960,15581655,18),(57658,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57658,36.84,0.46,233,18324,70,NULL,NULL,'2MASX J08541205+2439312',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000187,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,133.55025,24.65878,0.093,NULL,63787807655,996684494,15573195,16.1),(57659,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57659,38.02,0.27,401,18325,70,NULL,NULL,'SDSS J085413.01+004015.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000062,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,133.55425,0.67089,0.109,NULL,62548963336,977327552,15270743,18.5),(57660,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57660,35.22,0.61,110,18326,70,NULL,NULL,'MCG -01-23-009',NULL,'2014MNRAS.445.2677S',2014,1,0.3,'MCG notes say that dec. for MCG -01-23 zone is off by 8\'.','G',0.00015,NULL,'17',0.25,NULL,NULL,NULL,NULL,NULL,1,133.555583,-7.17161,0.089,NULL,42205865540,659466649,10304166,17),(57661,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57661,36.65,0.46,214,18327,70,NULL,NULL,'2MASX J08541413+0214268',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000193,NULL,'16.1g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,133.5589583,2.24083,0.121,NULL,63621704433,994089131,15532642,16.1),(57662,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57662,38.15,0.33,426,18328,70,NULL,NULL,'2MASX J08541466+0824072',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,133.561083,8.40194,0.117,NULL,63684619030,995072172,15548002,17.2),(57663,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57663,38.15,0.33,426,18329,70,NULL,NULL,'SDSS J085414.71+082534.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00017,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,133.5612917,8.42619,0.117,NULL,63684620201,995072190,15548002,18.4),(57664,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57664,37.32,0.46,292,18330,70,NULL,NULL,'2MASX J08541506+4421592',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000162,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,133.562917,44.36653,0.093,NULL,64288087528,1004501367,15695333,16.6),(57665,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57665,37.88,0.17,376,18331,70,NULL,NULL,'SDSS J085415.92+290031.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,133.566375,29.00864,0.069,NULL,64387884420,1006060694,15719698,18.4),(57666,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57666,37.52,0.46,318,18332,70,NULL,NULL,'2MASX J08541621+5436338',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000078,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,133.56775,54.6095,0.113,NULL,63485058059,991954032,15499281,18),(57667,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57667,38.11,0.33,418,18333,70,NULL,NULL,'2MASX J08541672+0711413',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,133.569666667,7.19478,0.141,NULL,63675144245,994924128,15545689,18.1),(57668,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57668,38.6,0.46,525,18334,70,NULL,NULL,'2MASX J08541824+3157101',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000162,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,133.576166667,31.95278,0.061,NULL,64385474014,1006023031,15719109,18.4),(57669,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57669,37.55,0.46,324,18335,70,NULL,NULL,'SDSS J085418.96+151203.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,133.579,15.20106,0.089,NULL,63873122890,998017545,15594024,18.2),(57670,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57670,35.42,0.49,122,18336,75,NULL,'IR','MCG +09-15-043',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.00009,NULL,'16.2g',0.15,'Sd(f)',NULL,NULL,NULL,NULL,1,133.582667,54.45781,0.105,NULL,63485940246,991967816,15499497,16.2),(57671,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57671,35.6,NULL,132,18336,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG +09-15-043',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57672,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57672,35.62,NULL,133,18336,NULL,NULL,'Dipole + Quadrupole','MCG +09-15-043',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57673,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57673,35.64,NULL,134,18336,NULL,NULL,NULL,'MCG +09-15-043',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57674,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57674,35.64,NULL,134,18336,NULL,NULL,'Dipole','MCG +09-15-043',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57675,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57675,37.78,0.46,360,18337,70,NULL,NULL,'2MASX J08541988+0353098',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000174,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,133.582833,3.88608,0.125,NULL,63633430183,994272346,15535505,17.9),(57676,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57676,37.11,0.46,264,18338,70,NULL,NULL,'2MASX J08542017+1148123',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,133.584,11.8035,0.097,NULL,63661972487,994718320,15542473,17.3),(57677,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57677,38.11,0.33,418,18339,70,NULL,NULL,'SDSS J085420.60+071012.0',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000147,NULL,'19.0g',0.11,NULL,NULL,NULL,NULL,NULL,1,133.585875,7.17003,0.141,NULL,63675144828,994924137,15545689,19),(57678,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57678,37.55,0.33,324,18340,70,NULL,NULL,'2MASX J08542084+3332491',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000159,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,133.5867917,33.54714,0.053,NULL,64417998067,1006531219,15727050,18),(57679,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57679,37.21,0.2,277,18341,74.4,NULL,NULL,'CGCG 061-020',NULL,'2013AJ....146...86T',2013,1,0.66,NULL,'G',0.000178,NULL,'16.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,133.587458333,9.34092,0.157,NULL,63670712444,994854881,15544607,16.1),(57680,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57680,37.88,0.17,376,18342,70,NULL,NULL,'SDSS J085422.58+290109.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,133.594125,29.01931,0.069,NULL,64387888937,1006060764,15719699,18.6),(57681,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57681,37.41,0.46,303,18343,70,NULL,NULL,'2MASX J08542353+3551581',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,133.5982083,35.86617,0.061,NULL,64421358604,1006583728,15727870,17),(57682,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57682,37.2,0.46,275,18344,70,NULL,NULL,'2MASX J08542384+1447212',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000177,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,133.5992083,14.78939,0.105,NULL,63873933472,998030210,15594222,16.5),(57683,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57683,35.88,0.46,150,18345,70,NULL,NULL,'IC 2422',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00008,NULL,'15.5g',0.48,NULL,NULL,NULL,NULL,NULL,1,133.6012917,20.22481,0.065,NULL,63827908168,997311065,15582985,15.5),(57684,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57684,37.61,0.46,332,18346,70,NULL,NULL,'2MASX J08542447+3723465',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000124,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,133.602125,37.39625,0.081,NULL,64413994699,1006468667,15726072,18.1),(57685,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57685,38.22,0.33,441,18347,70,NULL,NULL,'SDSS J085424.87+401247.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000132,NULL,'18.8g',0.09,NULL,NULL,NULL,NULL,NULL,1,133.603667,40.21308,0.053,NULL,64366709385,1005729834,15714528,18.8),(57686,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57686,36.11,0.46,167,18348,70,NULL,NULL,'2MASX J08542564+0812413',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000182,NULL,'15.8g',0.36,NULL,NULL,NULL,NULL,NULL,1,133.6067917,8.21139,0.117,NULL,63684640285,995072504,15548007,15.8),(57687,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57687,37.63,0.46,335,18349,70,NULL,NULL,'SDSS J085426.26+545054.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000069,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,133.6094583,54.84842,0.097,NULL,61539013080,961547079,15024173,18.2),(57688,'SBF','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57688,32.54,0.14,32.2,18350,74.4,NULL,NULL,'NGC 2695',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.000017,NULL,'12.83',1.2,'SAB(s)0^0^?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,133.6127917,-3.06703,0.033,NULL,42159203210,658737550,10292774,12.83),(57689,'SBF','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57689,32.55,0.4,32.3,18350,NULL,NULL,'I','NGC 2695',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57690,'SBF','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57690,32.55,0.4,32.4,18350,NULL,NULL,NULL,'NGC 2695',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57691,'SBF','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57691,32.56,0.4,32.6,18350,NULL,NULL,'Malmquist cor.','NGC 2695',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57692,'D-Sigma','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57692,32.56,0.4,32.5,18350,75,NULL,'Edat, raw','NGC 2695',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57693,'D-Sigma','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57693,32.9,0.4,38,18350,75,NULL,'Edat, cor','NGC 2695',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57694,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57694,32.67,0.53,34.2,18350,70,NULL,NULL,'NGC 2695',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57695,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57695,32.86,0.41,37.2,18350,NULL,NULL,NULL,'NGC 2695',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57696,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57696,33.01,0.41,40,18350,NULL,NULL,'Malmquist cor.','NGC 2695',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57697,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57697,32.65,0.4,33.9,18350,NULL,NULL,'mean','NGC 2695',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57698,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57698,33.15,0.45,42.6,18350,NULL,NULL,'K','NGC 2695',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57699,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57699,36.59,0.46,208,18351,70,NULL,NULL,'2MASX J08542809+1254222',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000161,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,133.617167,12.90617,0.089,NULL,63842317096,997536204,15586503,16.5),(57700,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57700,37.5,0.46,316,18352,70,NULL,NULL,'2MASXi J0854294+260004',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000177,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,133.622791667,26.00139,0.089,NULL,64307906075,1004811032,15700172,17.8),(57701,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57701,37.39,0.46,301,18353,70,NULL,NULL,'2MASX J08543073+4433103',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000161,NULL,'16.2g',0.41,NULL,NULL,NULL,NULL,NULL,1,133.628,44.55292,0.093,NULL,64288149779,1004502340,15695349,16.2),(57702,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 1999X',NULL,57702,34.43,0.23,75,18354,74.2,NULL,'SALT 2','CGCG 180-022',0.02517,'2010ApJ...716..712A',2010,1,0.57,NULL,'G',0.000083,NULL,'15.5g',0.52,'Sa',NULL,NULL,NULL,NULL,1,133.632625,36.50961,0.073,NULL,64421167135,1006580736,15727824,15.5),(57703,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 1999X',NULL,57703,35.11,0.09,105,18354,74.4,NULL,NULL,'CGCG 180-022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57704,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 1999X',NULL,57704,35.15,0.17,107,18354,70.8,NULL,NULL,'CGCG 180-022',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57705,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 1999X',NULL,57705,35.22,0.18,108,18354,70,NULL,'SALT 2','CGCG 180-022',0.02517,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57706,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 1999X',NULL,57706,35.26,0.06,110,18354,72,NULL,NULL,'CGCG 180-022',0.02517,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57707,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 1999X',NULL,57707,35.3,0.09,112,18354,70,NULL,'SALT','CGCG 180-022',0.02517,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57708,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 1999X',NULL,57708,35.41,0.2,118,18354,65,NULL,NULL,'CGCG 180-022',0.02517,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57709,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 1999X',NULL,57709,35.37,0.14,119,18354,60,NULL,NULL,'CGCG 180-022',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57710,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 1999X',NULL,57710,35.55,0.13,122,18354,65,NULL,'MLCS2k2','CGCG 180-022',0.02517,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57711,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57711,36.61,0.46,210,18355,70,NULL,NULL,'2MASX J08543214+3509203',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00018,NULL,'16.1g',0.38,'E0',NULL,NULL,NULL,NULL,1,133.6339583,35.15561,0.053,NULL,64420823599,1006575368,15727740,16.1),(57712,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57712,37.55,0.33,324,18356,70,NULL,NULL,'2MASX J08543217+3337303',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000163,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,133.634125,33.62525,0.053,NULL,64417991967,1006531124,15727048,17),(57713,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57713,37.55,0.46,323,18357,70,NULL,NULL,'2MASX J08543229+1737202',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000161,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,133.6345,17.62242,0.029,NULL,63882084725,998157573,15596212,17.4),(57714,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57714,37.26,0.33,283,18358,70,NULL,NULL,'2MASXi J0854330+284527',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,133.637625,28.75792,0.061,NULL,64377131999,1005892687,15717073,17.6),(57715,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57715,37.56,0.46,325,18359,70,NULL,NULL,'2MASX J08543347+3430493',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000163,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,133.6395417,34.51383,0.053,NULL,64417433002,1006522390,15726912,18.2),(57716,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57716,37.79,0.46,361,18360,70,NULL,NULL,'2MASX J08543375+0758433',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,133.640583,7.97864,0.149,NULL,63676369415,994943272,15545988,17.7),(57717,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57717,35.59,0.46,131,18361,70,NULL,NULL,'2MASX J08543439+4247422',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000147,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,133.6432917,42.79519,0.081,NULL,64276124033,1004314438,15692413,16.8),(57718,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57718,34.83,0.49,92.6,18362,75,NULL,'IR','FGC 0811',NULL,'2011yCatp016004901K',2011,1,0.94,NULL,'G',NULL,NULL,'16.5',0.1,'Sd',NULL,NULL,NULL,NULL,1,133.643917,40.02714,0.061,NULL,64366763158,1005730674,15714541,16.5),(57719,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57719,35.01,NULL,100,18362,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0811',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57720,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57720,35.02,NULL,101,18362,NULL,NULL,'Dipole + Quadrupole','FGC 0811',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57721,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57721,35.04,NULL,102,18362,NULL,NULL,'Dipole','FGC 0811',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57722,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57722,35.06,NULL,103,18362,NULL,NULL,NULL,'FGC 0811',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57723,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57723,33.66,0.46,54,18363,70,NULL,NULL,'IC 0522',NULL,'2015arXiv151105856S',2015,1,1.06,NULL,'G',0.00008,NULL,'13.8g',0.92,'S0',NULL,NULL,NULL,NULL,1,133.6454583,57.16672,0.201,NULL,62022665290,969104145,15142252,13.8),(57724,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57724,37.85,0.46,372,18364,70,NULL,NULL,'2MASX J08543529+0539421',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000149,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,133.647167,5.66167,0.153,NULL,63630511131,994226736,15534792,17.3),(57725,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57725,37.88,0.17,376,18365,70,NULL,NULL,'2MASX J08543574+2901397',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00016,NULL,'16.6g',0.34,'Sb',NULL,NULL,NULL,NULL,1,133.649041667,29.02775,0.069,NULL,64387878111,1006060595,15719696,16.6),(57726,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57726,38.02,0.27,401,18366,70,NULL,NULL,'2MASX J08543662+0038331',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000107,NULL,'16.3g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,133.6525417,0.64258,0.109,NULL,62548989865,977327966,15270749,16.3),(57727,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57727,37.66,0.46,341,18367,70,NULL,NULL,'2MASX J08543721+2959103',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000147,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,133.6550417,29.98622,0.069,NULL,64388417320,1006069020,15719828,17.7),(57728,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57728,38.02,0.27,401,18368,70,NULL,NULL,'2MASX J08543822+0039231',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000079,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,133.659291667,0.65633,0.109,NULL,62548945005,977327265,15270738,18),(57729,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57729,37.83,0.46,369,18369,70,NULL,NULL,'2MASX J08543940+2912377',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,133.6642083,29.2105,0.053,NULL,64388780291,1006074692,15719917,18),(57730,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57730,37.14,0.46,268,18370,70,NULL,NULL,'2MASX J08543993+0136491',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000083,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,133.666375,1.61372,0.129,NULL,62547079316,977298114,15270283,16.5),(57731,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57731,32.65,0.2,33.9,18371,74.4,NULL,NULL,'UGC 04659',NULL,'2013AJ....146...86T',2013,1,1.71,NULL,'G',0.00002,NULL,'15.2g',0.5,'SAdm:','Isolated galaxy',NULL,NULL,NULL,1,133.668875,47.10489,0.097,NULL,64284984928,1004452889,15694576,15.2),(57732,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57732,32.79,0.43,36.1,18371,75,NULL,'3.6 micron, color corrected','UGC 04659',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57733,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57733,32.9,0.43,38.1,18371,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04659',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57734,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57734,37.88,0.17,376,18372,70,NULL,NULL,'2MASX J08544176+2900127',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000167,NULL,'17.1g',0.19,'Sa',NULL,NULL,NULL,NULL,1,133.674167,29.00375,0.069,NULL,64387878233,1006060597,15719696,17.1),(57735,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57735,37.79,0.17,361,18373,70,NULL,NULL,'2MASX J08544186+4024206',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000184,NULL,'16.8g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,133.674375,40.40578,0.053,NULL,64244287696,1003816995,15684640,16.8),(57736,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57736,36.96,0.46,246,18374,70,NULL,NULL,'2MASX J08544216+1955365',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000143,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,133.67575,19.92692,0.061,NULL,63826278789,997285606,15582587,17.6),(57737,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57737,37.67,0.46,342,18375,70,NULL,NULL,'2MASX J08544263+0411381',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000176,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,133.6775417,4.19383,0.141,NULL,63633589214,994274831,15535544,17.1),(57738,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57738,36.48,0.46,198,18376,70,NULL,NULL,'2MASXi J0854429+404206',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000165,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,133.6787917,40.70197,0.057,NULL,64245028323,1003828567,15684821,17),(57739,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57739,37.26,0.46,283,18377,70,NULL,NULL,'SDSS J085444.21+353356.3',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000155,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,133.68425,35.56564,0.061,NULL,64420659372,1006572802,15727700,16.7),(57740,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57740,37.52,0.46,320,18378,70,NULL,NULL,'SDSS J085444.76+000015.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000079,NULL,'18.4g',0.11,'NLAGN',NULL,NULL,NULL,NULL,1,133.6865,0.00436,0.089,NULL,62545991743,977281120,15270017,18.4),(57741,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57741,37.53,0.46,321,18379,70,NULL,NULL,'2MASX J08544502+1626102',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000155,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,133.6877083,16.43611,0.029,NULL,63885110277,998204848,15596950,17.3),(57742,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57742,38.33,0.46,463,18380,70,NULL,NULL,'2MASX J08544517+0846113',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000175,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,133.68825,8.76978,0.117,NULL,63685167206,995080737,15548136,17.3),(57743,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57743,36.54,0.46,203,18381,70,NULL,NULL,'2MASX J08544596+5304235',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000071,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,133.691625,53.07328,0.061,NULL,64223508442,1003492319,15679567,16.6),(57744,'SNIa','2016-12-15 15:14:25','2016-12-16 11:19:31','1','SN 2011hr',NULL,57744,33.34,0.2,46.5,18382,72,NULL,'M(H) = -18.317 mag','NGC 2691',NULL,'2014ApJ...784..105W',2013,1,1.12,NULL,'G',0.000023,NULL,'13.9g',0.82,'Sa?            HII',NULL,NULL,NULL,'Starburst',1,133.693083,39.53867,0.081,NULL,64366811489,1005731429,15714553,13.9),(57745,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57745,33.84,0.47,58.7,18382,NULL,NULL,'H','NGC 2691',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57746,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57746,33.86,0.45,59.2,18382,NULL,NULL,'K','NGC 2691',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57747,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57747,33.9,0.4,60.2,18382,NULL,NULL,'mean','NGC 2691',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57748,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57748,33.96,0.46,62.1,18382,NULL,NULL,'J','NGC 2691',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57749,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57749,37.25,0.46,282,18383,70,NULL,NULL,'2MASX J08544628+0745473',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,133.693,7.76325,0.181,NULL,63676360828,994943137,15545986,17.8),(57750,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57750,37.59,0.33,329,18384,70,NULL,NULL,'2MASX J08544798+1413505',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000188,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,133.699916667,14.23067,0.109,NULL,63873259966,998019686,15594057,16.1),(57751,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57751,36.45,0.46,195,18385,70,NULL,NULL,'2MASX J08544937+0432491',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,133.70575,4.54694,0.145,NULL,63628908170,994201690,15534401,17),(57752,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57752,38.29,0.46,455,18386,70,NULL,NULL,'2MASX J08544942+1758065',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,133.70575,17.96842,0.045,NULL,63882049994,998157031,15596203,18),(57753,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57753,37.66,0.27,341,18387,70,NULL,NULL,'2MASX J08545006+5117245',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000089,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,133.7085,51.29003,0.069,NULL,64224689986,1003510781,15679855,16.5),(57754,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57754,37.82,0.46,366,18388,70,NULL,NULL,'2MASX J08545039+2222463',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'17.78',0.27,NULL,NULL,NULL,NULL,NULL,1,133.709833,22.37969,0.085,NULL,63822544445,997227256,15581675,17.78),(57755,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57755,35.65,NULL,135,18389,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0809',NULL,'2010Ap&SS.325..163P',2010,1,0.66,NULL,'G',NULL,NULL,'17.0',0.08,'Scd',NULL,NULL,NULL,NULL,1,133.7157917,58.35575,0.137,NULL,62021479746,969085621,15141962,17),(57756,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57756,35.67,NULL,136,18389,NULL,NULL,'Dipole + Quadrupole','FGC 0809',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57757,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57757,35.69,NULL,137,18389,NULL,NULL,NULL,'FGC 0809',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57758,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57758,35.7,NULL,138,18389,NULL,NULL,'Dipole','FGC 0809',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57759,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57759,37.45,0.46,309,18390,70,NULL,NULL,'2MASX J08545192+3925096',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000177,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,133.716333333,39.41936,0.037,NULL,64366677007,1005729328,15714520,16.6),(57760,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57760,37.86,0.46,373,18391,70,NULL,NULL,'2MASX J08545237+2957083',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000142,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,133.7182917,29.95242,0.069,NULL,64388530809,1006070793,15719856,17.7),(57761,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57761,37.18,0.46,272,18392,70,NULL,NULL,'2MASX J08545305+5555351',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000065,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,133.72125,55.92631,0.133,NULL,62012057109,968938392,15139662,17.5),(57762,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57762,37.88,0.17,376,18393,70,NULL,NULL,'2MASX J08545441+2901237',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.1g',0.27,'Sc',NULL,NULL,NULL,NULL,1,133.7265417,29.02322,0.069,NULL,64388727550,1006073867,15719904,17.1),(57763,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57763,37.36,0.46,296,18394,70,NULL,NULL,'2MASX J08545435+0830313',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,133.726583,8.50858,0.117,NULL,63685159996,995080624,15548134,17.1),(57764,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57764,36.98,0.46,248,18395,70,NULL,NULL,'2MASX J08545439+5605021',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000071,NULL,'18.2g',0.14,'NLAGN',NULL,NULL,NULL,NULL,1,133.726875,56.08392,0.133,NULL,62012045183,968938205,15139659,18.2),(57765,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57765,37.59,0.33,329,18396,70,NULL,NULL,'2MASX J08545761+1404386',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,133.740083,14.07725,0.105,NULL,63843081384,997548146,15586689,17.6),(57766,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57766,37.57,0.46,326,18397,70,NULL,NULL,'2MASX J08545848+2629541',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000186,NULL,'17.1g',0.26,'AGN',NULL,NULL,NULL,NULL,1,133.743875,26.49825,0.101,NULL,64307592103,1004806126,15700095,17.1),(57767,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57767,37.49,0.46,315,18398,70,NULL,NULL,'2MASX J08550242+1421536',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000161,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,133.760125,14.36489,0.105,NULL,63873439983,998022499,15594101,17.1),(57768,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57768,37.8,0.33,362,18399,70,NULL,NULL,'2MASX J08550269+3634071',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,133.7612083,36.56878,0.077,NULL,64413369623,1006458900,15725920,17.3),(57769,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57769,37.91,0.46,382,18400,70,NULL,NULL,'2MASX J08550406+3434403',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000185,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,133.767,34.57775,0.053,NULL,64421891279,1006592051,15728000,16.6),(57770,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57770,37.26,0.46,284,18401,70,NULL,NULL,'SDSS J085504.36+002318.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000067,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,133.7682083,0.38856,0.101,NULL,62546139184,977283424,15270053,18.4),(57771,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57771,37.3,0.46,288,18402,70,NULL,NULL,'2MASX J08550474+1644096',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000194,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,133.769875,16.73603,0.009,NULL,63885257243,998207144,15596986,16.5),(57772,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57772,37.54,0.33,322,18403,70,NULL,NULL,'2MASX J08550631+2147173',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000139,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,133.776417,21.78797,0.105,NULL,63836122328,997439411,15584990,17.8),(57773,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57773,37.46,0.27,310,18404,70,NULL,NULL,'2MASXi J0855067+380423',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,133.7780417,38.07328,0.073,NULL,64413539365,1006461552,15725961,18),(57774,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57774,37.78,0.46,360,18405,70,NULL,NULL,'SDSS J085508.32+383313.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000125,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,133.784666667,38.55381,0.057,NULL,64412200033,1006440625,15725634,18),(57775,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57775,37.79,0.17,361,18406,70,NULL,NULL,'2MASX J08550909+4024282',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000142,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,133.7877917,40.40783,0.053,NULL,64244298704,1003817167,15684643,18),(57776,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57776,37.66,0.46,340,18407,70,NULL,NULL,'2MASX J08550946+4228238',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000142,NULL,'17.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,133.789583,42.47331,0.069,NULL,64275892438,1004310819,15692356,17.8),(57777,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57777,38.23,0.46,442,18408,70,NULL,NULL,'2MASX J08551001+3502376',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,133.7915417,35.04392,0.045,NULL,64420608271,1006572004,15727687,17.7),(57778,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57778,37.51,0.33,317,18409,70,NULL,NULL,'SDSS J085510.11+091534.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000158,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,133.792166667,9.25953,0.133,NULL,63670651773,994853933,15544592,18.3),(57779,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57779,37.99,0.46,396,18410,70,NULL,NULL,'2MASX J08551044+1750345',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,133.7934583,17.84292,0.061,NULL,63882076156,998157439,15596209,17.6),(57780,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57780,37.51,0.33,317,18411,70,NULL,NULL,'2MASX J08551100+0914341',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,133.7957083,9.24281,0.133,NULL,63670650956,994853921,15544592,17),(57781,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57781,37.66,0.27,341,18412,70,NULL,NULL,'2MASX J08551141+5118328',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000075,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,133.7972917,51.30933,0.069,NULL,64224676671,1003510572,15679852,17.5),(57782,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57782,37.5,0.46,316,18413,70,NULL,NULL,'2MASX J08551192+1650535',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000181,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,133.799625,16.84817,0.009,NULL,63885039366,998203740,15596933,16.9),(57783,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57783,35.62,0.46,133,18414,70,NULL,NULL,'MCG +10-13-034',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000083,NULL,'15.6g',0.44,NULL,NULL,NULL,NULL,NULL,1,133.800583333,61.42317,0.165,NULL,62074330198,969911409,15154865,15.6),(57784,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57784,38.32,0.46,461,18415,70,NULL,NULL,'2MASX J08551233+3424097',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000181,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,133.8015,34.40261,0.053,NULL,64417440593,1006522509,15726914,16.8),(57785,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57785,35.83,0.49,146,18416,70,NULL,NULL,'CGCG 005-028',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000147,NULL,'15.4',0.7,NULL,NULL,NULL,NULL,NULL,1,133.801667,-2.26806,0.033,NULL,42146024008,658531625,10289556,15.4),(57786,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57786,35.44,NULL,122,18417,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG +09-15-049',NULL,'2010Ap&SS.325..163P',2010,1,1.17,NULL,'G',0.000063,NULL,'16.9g',0.11,'Sd(f)',NULL,NULL,NULL,NULL,1,133.8049583,52.04014,0.061,NULL,64225024476,1003516007,15679937,16.9),(57787,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57787,35.46,NULL,123,18417,NULL,NULL,'Dipole + Quadrupole','MCG +09-15-049',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57788,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57788,35.48,NULL,125,18417,NULL,NULL,'Dipole','MCG +09-15-049',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57789,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57789,35.48,NULL,125,18417,NULL,NULL,NULL,'MCG +09-15-049',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57790,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57790,35.97,0.66,156,18418,70,NULL,NULL,'2MASX J08551408-0940544',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.7I',0.3,NULL,NULL,NULL,NULL,NULL,1,133.808791667,-9.68178,0.093,NULL,42197789234,659340456,10302194,14.7),(57791,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57791,36.68,0.46,217,18419,70,NULL,NULL,'2MASX J08551469+3240447',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000173,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,133.81125,32.67922,0.041,NULL,64384732190,1006011440,15718928,16.7),(57792,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57792,36.66,0.46,215,18420,70,NULL,NULL,'2MASX J08551514+4405518',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000155,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,133.81325,44.09764,0.089,NULL,64287603982,1004493812,15695215,16.8),(57793,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57793,37.97,0.33,392,18421,70,NULL,NULL,'2MASX J08551580+4749348',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,133.816,47.82628,0.057,NULL,64228602256,1003571910,15680811,18.1),(57794,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57794,37.46,0.46,311,18422,70,NULL,NULL,'2MASX J08551655+3605302',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000123,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,133.8189583,36.09169,0.061,NULL,64421214175,1006581471,15727835,17.7),(57795,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57795,37.58,0.46,327,18423,70,NULL,NULL,'2MASX J08551708+0723331',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000135,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,133.8212917,7.39261,0.193,NULL,63675068521,994922945,15545671,18.2),(57796,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57796,37.54,0.33,322,18424,70,NULL,NULL,'2MASX J08551959+2145529',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000168,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,133.8317917,21.76469,0.081,NULL,63836127223,997439487,15584991,17.2),(57797,'IRAS','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57797,34.23,0.8,70.3,18425,75,NULL,'MAT, I','ESO 496- G 019',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'15.34',0.8,'SB(s)cd',NULL,NULL,NULL,NULL,1,133.837917,-25.09225,0.549,NULL,42229120828,659830012,10309843,15.34),(57798,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57798,33.74,0.32,56.1,18425,85,NULL,'I, raw','ESO 496- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57799,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57799,33.76,0.32,56.4,18425,85,NULL,'I, inv','ESO 496- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57800,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57800,34.01,0.43,63.4,18425,75,NULL,'MAT, I, raw','ESO 496- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57801,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57801,34.1,0.43,66,18425,75,NULL,'MAT, I, inv','ESO 496- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57802,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57802,34.12,0.2,66.7,18425,74.4,NULL,NULL,'ESO 496- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57803,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57803,34.3,0.43,72.3,18425,75,NULL,'MAT, I, cor','ESO 496- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57804,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57804,38.1,0.27,418,18426,70,NULL,NULL,'SDSS J085521.19+491152.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000086,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,133.8382917,49.19783,0.057,NULL,64236341038,1003692828,15682700,18.5),(57805,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57805,37.8,0.33,362,18427,70,NULL,NULL,'SDSS J085521.49+362154.2',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000156,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,133.839541667,36.36506,0.057,NULL,64420910738,1006576730,15727761,17.2),(57806,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57806,37.66,0.27,341,18428,70,NULL,NULL,'2MASX J08552163+5106578',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000077,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,133.840167,51.11619,0.097,NULL,64238492345,1003726442,15683225,17.4),(57807,'TRGB','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57807,29.81,0.07,9.18,18429,NULL,NULL,NULL,'[KK98] 070',NULL,'2015ApJ...805..144K',2015,1,1.1,NULL,'G',NULL,NULL,'17.7',1,'dwarf Sph?',NULL,NULL,NULL,NULL,1,133.8430417,33.55911,0.053,NULL,64418117897,1006533092,15727079,17.7),(57808,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57808,36.62,0.46,211,18430,70,NULL,NULL,'2MASX J08552356+5457022',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000102,NULL,'16.0g',0.43,'E0',NULL,NULL,NULL,NULL,1,133.847917,54.95064,0.109,NULL,61538994235,961546784,15024168,16),(57809,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57809,37.82,0.46,366,18431,70,NULL,NULL,'2MASX J08552634+0422559',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000182,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,133.859625,4.38208,0.141,NULL,63633420174,994272190,15535502,17.2),(57810,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57810,37.44,0.46,308,18432,70,NULL,NULL,'2MASX J08552670+3541277',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000174,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,133.861167,35.69122,0.061,NULL,64421147523,1006580430,15727819,16.6),(57811,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57811,35.25,0.46,112,18433,70,NULL,NULL,'CGCG 208-069',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000147,NULL,'15.3',0.5,NULL,NULL,NULL,NULL,NULL,1,133.8660417,42.02417,0.081,NULL,64274093402,1004282709,15691917,15.3),(57812,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57812,37.2,0.46,275,18434,70,NULL,NULL,'2MASX J08552884+5551212',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000075,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,133.87025,55.85597,0.137,NULL,62009162179,968893159,15138955,17.3),(57813,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57813,37.39,0.46,300,18435,70,NULL,NULL,'2MASX J08553083+1731015',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,133.8785,17.51717,0.045,NULL,63881923289,998155051,15596172,17),(57814,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57814,38.05,0.46,408,18436,70,NULL,NULL,'2MASX J08553130+1513205',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,133.8805,15.22242,0.097,NULL,63873863297,998029114,15594204,18.1),(57815,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57815,35.44,0.46,122,18437,70,NULL,NULL,'CGCG 033-022',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000087,NULL,'14.8g',0.65,'E/S0',NULL,NULL,NULL,NULL,1,133.8817083,7.59847,0.205,NULL,63675041198,994922518,15545664,14.8),(57816,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57816,37.15,0.46,270,18438,70,NULL,NULL,'2MASX J08553234+1534305',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000183,NULL,'17.67',0.25,NULL,NULL,NULL,NULL,NULL,1,133.884875,15.57511,0.073,NULL,63873548340,998024192,15594128,17.67),(57817,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57817,38.54,0.46,510,18439,70,NULL,NULL,'2MASX J08553305+3732011',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000132,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,133.887583333,37.53372,0.081,NULL,64413669051,1006463578,15725993,18.3),(57818,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57818,37.97,0.33,392,18440,70,NULL,NULL,'2MASXi J0855339+475045',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,133.89125,47.84608,0.057,NULL,64228599484,1003571866,15680810,17.9),(57819,'Faber-Jackson','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57819,30,0.65,10,18441,95,NULL,'Weighted Mean','NGC 2685',NULL,'1984ApJS...56...91D',1984,1,4.5,NULL,'G',0.000013,NULL,'12.12',2.3,'(R)SB0+ pec;RETSy2',NULL,NULL,NULL,'Sy 2',1,133.894625,58.73439,0.149,NULL,62019668628,969057322,15141520,12.12),(57820,'Faber-Jackson','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57820,30.98,0.81,15.7,18441,55,NULL,'Visvanathan & Sandage 1979','NGC 2685',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57821,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57821,30.24,0.45,11.2,18441,NULL,NULL,'K','NGC 2685',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57822,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57822,30.26,0.4,11.3,18441,NULL,NULL,'mean','NGC 2685',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57823,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57823,30.91,0.48,15.2,18441,NULL,NULL,NULL,'NGC 2685',NULL,'2009A&A...494..489J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57824,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57824,31.05,0.4,16.2,18441,75,NULL,'B','NGC 2685',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57825,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57825,35.39,0.46,120,18442,70,NULL,NULL,'2MASX J08553500+6427569',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,133.895625,64.46581,0.181,NULL,62231008419,972359506,15193117,16.2),(57826,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57826,37.44,0.46,307,18443,70,NULL,NULL,'2MASX J08553501+4920027',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000067,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,133.895916667,49.33408,0.057,NULL,64236329962,1003692655,15682697,17.9),(57827,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57827,37.49,0.46,314,18444,70,NULL,NULL,'2MASX J08553511+3027367',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,133.89625,30.46025,0.065,NULL,64388382626,1006068478,15719819,16.9),(57828,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57828,37.79,0.17,361,18445,70,NULL,NULL,'2MASX J08553525+4027535',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000204,NULL,'16.1g',0.41,'E0',NULL,NULL,NULL,NULL,1,133.896791667,40.46483,0.045,NULL,64244347536,1003817930,15684655,16.1),(57829,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57829,36.05,0.46,162,18446,70,NULL,NULL,'VII Zw 255',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.5',0.22,NULL,NULL,NULL,NULL,NULL,1,133.8972917,59.52081,0.121,NULL,62064422887,969756607,15152446,17.5),(57830,'IRAS','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57830,33.19,0.8,43.4,18447,75,NULL,'MAT, I','ESO 090- G 009',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000026,NULL,'12.01',0.5,'SAB(s)c:',NULL,NULL,NULL,NULL,1,133.89975,-67.45294,0.549,NULL,40801654399,637525849,9961341,12.01),(57831,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57831,33.23,0.43,44.3,18447,75,NULL,'MAT, I, raw','ESO 090- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57832,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57832,33.37,0.32,47.2,18447,85,NULL,'I, raw','ESO 090- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57833,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57833,33.42,0.32,48.4,18447,85,NULL,'I, inv','ESO 090- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57834,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57834,33.45,0.43,48.9,18447,75,NULL,'MAT, I, cor','ESO 090- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57835,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57835,33.46,0.43,49.1,18447,75,NULL,'MAT, I, inv','ESO 090- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57836,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57836,33.62,0.52,53,18447,NULL,NULL,'Malmquist cor.','ESO 090- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57837,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57837,33.71,0.5,55.1,18447,NULL,NULL,NULL,'ESO 090- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57838,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57838,33.75,0.2,56.2,18447,74.4,NULL,NULL,'ESO 090- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57839,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57839,37.79,0.17,361,18448,70,NULL,NULL,'2MASX J08553604+4027275',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,133.900083333,40.45772,0.045,NULL,64244347579,1003817930,15684655,17),(57840,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57840,32.34,0.52,29.4,18449,70,NULL,NULL,'NGC 2698',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000017,NULL,'13.60',0.6,'SA0+?','Group member',NULL,NULL,NULL,1,133.902125,-3.18394,0.029,NULL,42159914883,658748670,10292947,13.6),(57841,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57841,38.15,0.46,427,18450,70,NULL,NULL,'2MASX J08553705-0028039',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000088,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,133.904416667,-0.46769,0.041,NULL,39191933387,612373959,9568343,17.4),(57842,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57842,37.46,0.27,310,18451,70,NULL,NULL,'2MASX J08553712+3809485',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000177,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,133.9047917,38.16344,0.061,NULL,64415624158,1006494127,15726470,16.5),(57843,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57843,37.77,0.33,358,18452,70,NULL,NULL,'2MASX J08553741+4735453',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000158,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,133.90575,47.59594,0.105,NULL,64228585284,1003571645,15680806,17),(57844,'Tully est','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57844,31.94,0.8,24.4,18453,75,NULL,'B','NGC 2655',NULL,'1988NBGC.C....0000T',1988,1,4.9,NULL,'G',0.000003,NULL,'10.96',4.1,'SAB(s)0/a      Sy2','Group member, radial-velocity confirmed',NULL,NULL,'LINER',1,133.907208333,78.22308,0.025,NULL,61467707989,960432937,15006764,10.96),(57845,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57845,36.58,0.46,207,18454,70,NULL,NULL,'2MASX J08553876+5153227',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000086,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,133.9114583,51.88961,0.073,NULL,64225029838,1003516091,15679938,16.4),(57846,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57846,37.5,0.46,316,18455,70,NULL,NULL,'SDSS J085539.66+113322.8',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.4g',0.28,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,133.915291667,11.55636,0.101,NULL,63661752574,994714883,15542420,16.4),(57847,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57847,37.9,0.23,380,18456,70,NULL,NULL,'2MASX J08553988+3707035',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000142,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,133.91625,37.11783,0.085,NULL,64413807688,1006465745,15726027,17.8),(57848,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57848,35.76,0.56,142,18457,70,NULL,NULL,'2MASX J08554139-1215531',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.0I',0.3,NULL,NULL,NULL,NULL,NULL,1,133.9224583,-12.26472,0.173,NULL,42166191886,658846748,10294480,14),(57849,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57849,37.67,0.46,342,18458,70,NULL,NULL,'2MASX J08554144+4311233',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000167,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,133.9224583,43.18997,0.081,NULL,64276459787,1004319684,15692495,17),(57850,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57850,37.79,0.17,361,18459,70,NULL,NULL,'2MASX J08554156+4026316',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000173,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,133.923125,40.44214,0.053,NULL,64244350681,1003817979,15684655,17.5),(57851,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57851,37.79,0.17,361,18460,70,NULL,NULL,'2MASX J08554183+4021195',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,133.924333,40.3555,0.053,NULL,64244343570,1003817868,15684654,17),(57852,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57852,35.69,0.46,138,18461,70,NULL,NULL,'CGCG 033-024',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000103,NULL,'15.1g',0.56,'E0',NULL,NULL,NULL,NULL,1,133.924916667,4.99481,0.145,NULL,63630450898,994225795,15534778,15.1),(57853,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57853,37.44,0.46,308,18462,70,NULL,NULL,'2MASX J08554221+3356119',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000174,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,133.925833,33.93678,0.057,NULL,64417586938,1006524795,15726949,17.1),(57854,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57854,37.77,0.33,358,18463,70,NULL,NULL,'2MASX J08554256+4735063',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,133.927375,47.58508,0.105,NULL,64228583217,1003571612,15680806,18),(57855,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57855,36.66,0.46,215,18464,70,NULL,NULL,'2MASX J08554279+4634443',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00016,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,133.9285417,46.57908,0.065,NULL,64284595646,1004446806,15694481,16.8),(57856,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57856,35.1,0.48,105,18465,70,NULL,NULL,'2MASX J08554389-2638408',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000103,NULL,'13.2I',0.8,NULL,NULL,NULL,NULL,NULL,1,133.932875,-26.64467,0.745,NULL,42715346956,667427296,10428551,13.2),(57857,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57857,37.93,0.46,386,18466,70,NULL,NULL,'SDSS J085544.02+412401.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000144,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,133.9334583,41.40044,0.061,NULL,64244610667,1003822041,15684719,18.5),(57858,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57858,37.9,0.23,380,18467,70,NULL,NULL,'SDSS J085544.39+365840.7',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00006,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,133.9350417,36.978,0.065,NULL,64413909844,1006467341,15726052,18.3),(57859,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57859,36.1,0.46,166,18468,70,NULL,NULL,'2MASX J08554480+3634495',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000139,NULL,'16.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,133.9365,36.58053,0.077,NULL,64413372681,1006458948,15725921,16.9),(57860,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57860,36.56,0.46,205,18469,70,NULL,NULL,'2MASX J08554509+4204023',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000077,NULL,'17.27',0.34,NULL,NULL,NULL,NULL,NULL,1,133.938,42.06728,0.073,NULL,64274075917,1004282436,15691913,17.27),(57861,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57861,37.66,0.46,340,18470,70,NULL,NULL,'SDSS J085545.18+111242.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,133.938291667,11.21181,0.113,NULL,63661908701,994717323,15542458,17.7),(57862,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57862,37.67,0.46,343,18471,70,NULL,NULL,'2MASX J08554546+1006501',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,133.9394583,10.114,0.129,NULL,63671318670,994864354,15544755,17.2),(57863,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57863,37.27,0.27,284,18472,70,NULL,NULL,'2MASX J08554612+6456229',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,133.942167,64.93958,0.117,NULL,62260978022,972827781,15200434,17),(57864,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57864,38.1,0.27,418,18473,70,NULL,NULL,'2MASX J08554677+4910254',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,133.9447917,49.17372,0.057,NULL,64236332002,1003692687,15682698,17.4),(57865,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57865,38.02,0.46,402,18474,70,NULL,NULL,'2MASX J08554675+3334089',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,133.944875,33.56928,0.053,NULL,64418145321,1006533520,15727086,17.4),(57866,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57866,38.14,0.46,425,18475,70,NULL,NULL,'SDSS J085547.51+485255.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,133.948,48.88211,0.049,NULL,64236401785,1003693777,15682715,18.3),(57867,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57867,35.56,0.58,129,18476,70,NULL,NULL,'2MASX J08554793-6147415',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,133.94975,-61.79489,0.745,NULL,40586952452,634171132,9908923,17.1),(57868,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57868,38.41,0.46,481,18477,70,NULL,NULL,'2MASX J08554836+5905442',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,133.9517917,59.09572,0.145,NULL,62019280446,969051256,15141425,17.2),(57869,'SBF','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57869,32.15,0.27,26.9,18478,NULL,NULL,'I','NGC 2699',NULL,'2001ApJ...546..681T',2001,1,1,NULL,'G',0.000017,NULL,'13.63',1,'E:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,133.953333,-3.12758,0.033,NULL,42159901176,658748455,10292944,13.63),(57870,'SBF','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57870,32.15,0.27,26.9,18478,NULL,NULL,NULL,'NGC 2699',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57871,'SBF','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57871,32.16,0.14,27,18478,74.4,NULL,NULL,'NGC 2699',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57872,'SBF','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57872,32.22,0.27,27.8,18478,NULL,NULL,'Malmquist cor.','NGC 2699',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57873,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57873,31.87,0.41,23.6,18478,NULL,NULL,NULL,'NGC 2699',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57874,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57874,32.06,0.41,25.9,18478,NULL,NULL,'Malmquist cor.','NGC 2699',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57875,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57875,37.98,0.46,394,18479,70,NULL,NULL,'2MASX J08554958+5531052',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000088,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,133.95675,55.51808,0.125,NULL,62009218981,968894046,15138969,17.6),(57876,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57876,38.7,0.46,549,18480,70,NULL,NULL,'SDSS J085549.65+294959.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000166,NULL,'18.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,133.956875,29.83308,0.069,NULL,64388622918,1006072233,15719878,18.3),(57877,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57877,37.46,0.27,310,18481,70,NULL,NULL,'2MASX J08555085+3807505',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000144,NULL,'16.1g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,133.961875,38.13056,0.073,NULL,64415625892,1006494154,15726471,16.1),(57878,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57878,38.02,0.46,402,18482,70,NULL,NULL,'2MASX J08555133+5413322',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00008,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,133.96375,54.22558,0.057,NULL,63485165068,991955704,15499307,17.6),(57879,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57879,37.9,0.46,380,18483,70,NULL,NULL,'2MASX J08555233+1512561',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,133.967958333,15.21553,0.097,NULL,63873854704,998028979,15594202,17.2),(57880,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57880,37.2,0.46,275,18484,70,NULL,NULL,'2MASX J08555246+5613052',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000072,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,133.9685,56.21825,0.129,NULL,62012151246,968939863,15139685,17),(57881,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57881,34.18,0.46,68.6,18485,70,NULL,NULL,'ARK 186',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000178,NULL,'14.9g',0.37,NULL,NULL,NULL,NULL,NULL,1,133.968666667,18.15647,0.045,NULL,63882241599,998160024,15596250,14.9),(57882,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57882,37.02,0.46,254,18486,70,NULL,NULL,'2MASX J08555343+4200273',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,133.9724583,42.00764,0.097,NULL,64274094116,1004282720,15691917,17.2),(57883,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57883,37.9,0.23,380,18487,70,NULL,NULL,'2MASX J08555408+3705575',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000172,NULL,'16.7g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,133.9752917,37.09942,0.085,NULL,64413797597,1006465587,15726024,16.7),(57884,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57884,37.79,0.46,361,18488,70,NULL,NULL,'2MASX J08555437+1750211',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,133.976625,17.83919,0.061,NULL,63882076593,998157446,15596210,17.9),(57885,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57885,36.26,0.46,179,18489,70,NULL,NULL,'MCG +10-13-041',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000098,NULL,'15.9g',0.38,'E0',NULL,NULL,NULL,NULL,1,133.9787083,57.34072,0.153,NULL,62022570649,969102666,15142229,15.9),(57886,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57886,37.5,0.46,316,18490,70,NULL,NULL,'SDSS J085555.33+082708.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00014,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,133.980583,8.4525,0.129,NULL,63684562211,995071284,15547988,18.4),(57887,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57887,33.94,0.46,61.4,18491,70,NULL,NULL,'UGC 04670',NULL,'2015arXiv151105856S',2015,1,1.6,NULL,'G',0.000067,NULL,'13.67',1.1,'S0:','in a pair',NULL,NULL,NULL,1,133.980833,13.22969,0.093,NULL,63841940548,997530321,15586411,13.67),(57888,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57888,38.1,0.27,418,18492,70,NULL,NULL,'2MASX J08555636+4911105',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,'PHOT','16.2',NULL,NULL,NULL,NULL,NULL,NULL,1,133.984875,49.18631,0.057,NULL,64236331295,1003692676,15682698,16.2),(57889,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57889,37.56,0.46,326,18493,70,NULL,NULL,'2MASX J08555682+0849341',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,133.986791667,8.82611,0.117,NULL,63685238669,995081854,15548153,17.3),(57890,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57890,37.27,0.27,284,18494,70,NULL,NULL,'2MASX J08555765+6501569',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,133.9899583,65.03236,0.125,NULL,62261029313,972828583,15200446,17.6),(57891,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57891,37.47,0.46,313,18495,70,NULL,NULL,'2MASX J08555826+5604062',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00008,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,133.992917,56.06839,0.133,NULL,62012246799,968941356,15139708,17.3),(57892,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57892,37.26,0.46,283,18496,70,NULL,NULL,'2MASX J08560061+0934531',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000143,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,134.002625,9.58142,0.129,NULL,63671524355,994867568,15544805,16.9),(57893,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57893,35.68,0.59,137,18497,70,NULL,NULL,'2MASX J08560214-2517466',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.3,NULL,NULL,NULL,NULL,NULL,1,134.0089583,-25.29633,0.669,NULL,42714873371,667419896,10428435,14),(57894,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57894,38.37,0.27,473,18498,70,NULL,NULL,'2MASX J08560215+1525091',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,134.009125,15.41925,0.069,NULL,63873553078,998024266,15594129,17.4),(57895,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57895,36.06,0.46,163,18499,70,NULL,NULL,'SDSS J085602.32+064512.3',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000158,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,134.0097083,6.75342,0.157,NULL,63675785494,994934148,15545846,16.6),(57896,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57896,37.7,0.46,348,18500,70,NULL,NULL,'2MASX J08560278+3609225',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000149,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,134.011583333,36.15633,0.037,NULL,64420922819,1006576919,15727764,18),(57897,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57897,36.48,0.78,197,18501,70,NULL,NULL,'2MASX J08560293-2815586',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,'E',NULL,NULL,NULL,NULL,1,134.012333,-28.26636,0.669,NULL,42901227211,670331675,10473932,15.6),(57898,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57898,37.9,0.23,380,18502,70,NULL,NULL,'2MASX J08560309+3659494',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000174,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,134.012875,36.99706,0.065,NULL,64413434691,1006459917,15725936,16.7),(57899,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57899,37.01,0.46,252,18503,70,NULL,NULL,'2MASX J08560407+3843554',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,134.0167917,38.73214,0.041,NULL,64412231087,1006441110,15725642,17.5),(57900,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57900,37.63,0.46,336,18504,70,NULL,NULL,'2MASX J08560432+3444069',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,134.018083,34.73519,0.053,NULL,64424044030,1006625687,15728526,17.8),(57901,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57901,37.6,0.33,331,18505,70,NULL,NULL,'SDSS J085604.50+215806.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'18.0g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,134.01875,21.96847,0.093,NULL,63835812314,997434567,15584915,18),(57902,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57902,37.83,0.21,368,18506,70,NULL,NULL,'2MASX J08560513+5333085',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000095,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,134.021375,53.55236,0.033,NULL,64223639052,1003494360,15679599,16.7),(57903,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57903,37.22,0.46,278,18507,70,NULL,NULL,'2MASX J08560554+4906365',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,134.023,49.11025,0.053,NULL,64236536635,1003695884,15682748,16.6),(57904,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57904,37.39,0.23,301,18508,70,NULL,NULL,'2MASX J08560588+1428200',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000167,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,134.0245,14.47214,0.105,NULL,63873457178,998022768,15594105,17.2),(57905,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57905,37.27,0.27,284,18509,70,NULL,NULL,'2MASX J08560689+6455488',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.7g',0.35,NULL,NULL,NULL,NULL,NULL,1,134.0284583,64.93036,0.117,NULL,62260979274,972827801,15200434,16.7),(57906,'Sosies','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57906,33.32,0.15,46.1,18510,NULL,NULL,NULL,'NGC 2708',NULL,'2002A&A...393...57T',2002,1,2.6,NULL,'G',0.00002,NULL,'12.55',1.3,'SAB(s)b pec?   HII','in a pair',NULL,NULL,NULL,1,134.033541667,-3.36011,0.029,NULL,42159944442,658749131,10292955,12.55),(57907,'Tully est','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57907,32.22,0.8,27.8,18510,75,NULL,NULL,'NGC 2708',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57908,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57908,32.75,0.4,35.5,18510,NULL,NULL,'mean','NGC 2708',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57909,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57909,32.92,0.59,38.3,18510,NULL,NULL,'Malmquist cor.','NGC 2708',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57910,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57910,33,0.56,39.9,18510,NULL,NULL,NULL,'NGC 2708',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57911,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57911,33.04,0.2,40.6,18510,74.4,NULL,NULL,'NGC 2708',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57912,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57912,33.04,0.46,40.6,18510,NULL,NULL,'J','NGC 2708',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57913,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57913,33.05,0.47,40.7,18510,NULL,NULL,'H','NGC 2708',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57914,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57914,33.09,0.45,41.6,18510,NULL,NULL,'K','NGC 2708',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57915,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57915,37.16,0.33,271,18511,70,NULL,NULL,'2MASX J08560861+1146442',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,134.035958333,11.77903,0.101,NULL,63662137550,994720899,15542514,17.8),(57916,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57916,37.89,0.23,379,18512,70,NULL,NULL,'SDSS J085609.10+304239.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000146,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,134.037917,30.71106,0.065,NULL,64390495580,1006101493,15720335,18.3),(57917,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57917,36.37,0.46,188,18513,70,NULL,NULL,'2MASX J08560910+3441289',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000176,NULL,'15.8g',0.43,'E0',NULL,NULL,NULL,NULL,1,134.038,34.69144,0.053,NULL,64424046086,1006625720,15728526,15.8),(57918,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57918,37.72,0.46,350,18514,70,NULL,NULL,'2MASX J08560949+4548431',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000146,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,134.039666667,45.81189,0.089,NULL,64286391514,1004474867,15694919,17.3),(57919,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57919,37.83,0.21,368,18515,70,NULL,NULL,'SDSS J085610.16+532131.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000065,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,134.042375,53.35875,0.037,NULL,64223666812,1003494793,15679606,18.2),(57920,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57920,37.42,0.46,304,18516,70,NULL,NULL,'2MASX J08561137+2723102',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,134.047458333,27.38611,0.097,NULL,64377631458,1005900491,15717195,17.2),(57921,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57921,37.75,0.46,355,18517,70,NULL,NULL,'2MASX J08561195+5355313',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000089,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,134.049667,53.92525,0.053,NULL,63485119237,991954988,15499296,16.7),(57922,'Sosies','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57922,33.61,0.23,52.7,18518,NULL,NULL,NULL,'NGC 2706',NULL,'2002A&A...393...57T',2002,1,1.8,NULL,'G',0.000017,NULL,'13.80',0.6,'Sbc? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,134.0512917,-2.56344,0.041,NULL,42146421966,658537843,10289653,13.8),(57923,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57923,31.96,0.43,24.7,18518,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2706',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57924,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57924,32.35,0.43,29.5,18518,75,NULL,'3.6 micron, color corrected','NGC 2706',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57925,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57925,32.37,0.4,29.8,18518,NULL,NULL,'mean','NGC 2706',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57926,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57926,32.49,0.45,31.5,18518,NULL,NULL,'K','NGC 2706',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57927,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57927,32.5,0.4,31.7,18518,75,NULL,NULL,'NGC 2706',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57928,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57928,32.56,0.47,32.4,18518,NULL,NULL,'H','NGC 2706',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57929,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57929,32.65,0.46,33.9,18518,NULL,NULL,'J','NGC 2706',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57930,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57930,32.75,0.2,35.5,18518,74.4,NULL,NULL,'NGC 2706',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57931,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57931,33.16,0.49,42.9,18518,75,NULL,'IR','NGC 2706',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57932,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57932,37.83,0.21,368,18519,70,NULL,NULL,'2MASX J08561239+5314535',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000075,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,134.0515,53.24831,0.029,NULL,64223704386,1003495381,15679615,18.1),(57933,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57933,37.91,0.11,382,18520,70,NULL,NULL,'2MASX J08561339+3742292',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,134.05575,37.70817,0.081,NULL,64413688075,1006463876,15725998,17.8),(57934,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57934,37.92,0.46,383,18521,70,NULL,NULL,'2MASX J08561355+4800475',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,134.0565,48.01322,0.081,NULL,64228514080,1003570532,15680789,17.5),(57935,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57935,37.54,0.46,322,18522,70,NULL,NULL,'2MASX J08561365+4008022',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000158,NULL,'17.5g',NULL,NULL,NULL,NULL,NULL,NULL,1,134.056833333,40.13394,0.061,NULL,64365907512,1005717304,15714332,17.5),(57936,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57936,37.8,0.33,363,18523,70,NULL,NULL,'2MASX J08561405+5351145',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000081,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,134.058375,53.85389,0.053,NULL,63485837409,991966209,15499472,17.6),(57937,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57937,37.16,0.33,271,18524,70,NULL,NULL,'2MASX J08561420+1147062',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000113,NULL,'16.94',0.54,NULL,NULL,NULL,NULL,NULL,1,134.059167,11.785,0.101,NULL,63662019148,994719049,15542485,16.94),(57938,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57938,38.13,0.46,423,18525,70,NULL,NULL,'2MASX J08561509+5945553',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,134.063041667,59.76528,0.121,NULL,62064285150,969754455,15152413,18.3),(57939,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57939,36.36,0.66,187,18526,70,NULL,NULL,'2MASX J08561533-1011349',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,134.063833,-10.19311,0.073,NULL,42197173087,659330829,10302044,14.6),(57940,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57940,37.88,0.46,377,18527,70,NULL,NULL,'2MASX J08561572+3458232',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,134.065625,34.97322,0.013,NULL,64424031446,1006625491,15728523,17.4),(57941,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57941,37.39,0.46,301,18528,70,NULL,NULL,'2MASX J08561597+3442532',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000179,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,134.066375,34.71481,0.049,NULL,64424012687,1006625198,15728518,17.5),(57942,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57942,37.07,0.46,259,18529,70,NULL,NULL,'2MASX J08561635+1342202',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,134.0682083,13.70561,0.101,NULL,63871413816,997990840,15593606,17.2),(57943,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57943,38.37,0.27,473,18530,70,NULL,NULL,'SDSS J085616.56+152508.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,134.069,15.41917,0.069,NULL,63873609173,998025143,15594142,18.6),(57944,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57944,36.73,0.46,222,18531,70,NULL,NULL,'2MASX J08561663+5856312',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,134.069208333,58.94214,0.145,NULL,62019267144,969051049,15141422,17.7),(57945,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57945,38.23,0.46,442,18532,70,NULL,NULL,'2MASX J08561686+3652342',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000115,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,134.07025,36.87619,0.065,NULL,64413440062,1006460000,15725937,18.5),(57946,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57946,38.37,0.27,473,18533,70,NULL,NULL,'2MASX J08561759+1526422',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000182,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,134.0734583,15.445,0.069,NULL,63873608072,998025126,15594142,17.2),(57947,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57947,36.99,0.23,249,18534,70,NULL,NULL,'2MASX J08561815+3242213',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000194,NULL,'16.2g',0.37,'E0',NULL,NULL,NULL,NULL,1,134.075625,32.706,0.041,NULL,64384766783,1006011980,15718937,16.2),(57948,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57948,37.83,0.21,368,18535,70,NULL,NULL,'2MASX J08561947+5327435',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000071,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,134.08125,53.46203,0.037,NULL,64223629296,1003494207,15679596,17.1),(57949,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57949,36.25,0.46,178,18536,70,NULL,NULL,'2MASX J08562000+2858522',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'16.8g',0.23,'Sa',NULL,NULL,NULL,NULL,1,134.08325,28.98111,0.073,NULL,64388227181,1006066049,15719782,16.8),(57950,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57950,37.18,0.46,272,18537,70,NULL,NULL,'2MASX J08562077+3658362',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000148,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,134.08675,36.97678,0.065,NULL,64413436727,1006459948,15725936,16.7),(57951,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57951,37.17,0.46,272,18538,70,NULL,NULL,'2MASX J08562164+5114235',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000074,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,134.0900417,51.23992,0.069,NULL,64224709388,1003511084,15679860,16.8),(57952,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57952,37.85,0.46,372,18539,70,NULL,NULL,'2MASX J08562181+1508242',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,134.090875,15.14003,0.077,NULL,63873978355,998030911,15594232,17.6),(57953,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57953,36.13,0.46,168,18540,70,NULL,NULL,'2MASX J08562314+4509171',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,134.0965,45.15464,0.077,NULL,64289871695,1004529245,15695769,16.6),(57954,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57954,38.12,0.21,420,18541,70,NULL,NULL,'2MASX J08562318+0549492',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000173,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,134.096708333,5.83039,0.145,NULL,63630653607,994228962,15534827,17.9),(57955,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57955,38.3,0.46,456,18542,70,NULL,NULL,'2MASX J08562340+1515182',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,134.097417,15.255,0.077,NULL,63873844378,998028818,15594200,17.9),(57956,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57956,37.39,0.23,301,18543,70,NULL,NULL,'SDSS J085623.98+143050.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000153,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,134.099958333,14.51408,0.105,NULL,63873328484,998020757,15594074,18.5),(57957,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57957,33.42,0.2,48.3,18544,74.4,NULL,NULL,'UGC 04677',NULL,'2013AJ....146...86T',2013,1,1.24,NULL,'G',0.000023,NULL,'15.1g',0.61,'Scd:',NULL,NULL,NULL,NULL,1,134.100375,13.18228,0.117,NULL,63841935345,997530239,15586409,15.1),(57958,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57958,37.8,0.33,363,18545,70,NULL,NULL,'2MASX J08562442+5348224',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000086,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,134.102,53.80633,0.053,NULL,64223576653,1003493385,15679584,17),(57959,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57959,35.67,0.5,136,18546,70,NULL,NULL,'2MASX J08562490-0540163',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00008,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,134.1037917,-5.67125,0.033,NULL,42150607003,658603234,10290675,15.8),(57960,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57960,37.55,0.46,323,18547,70,NULL,NULL,'SDSS J085625.17+144559.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,134.104917,14.76656,0.105,NULL,63873311011,998020484,15594070,18.3),(57961,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57961,37.83,0.21,368,18548,70,NULL,NULL,'2MASX J08562553+5330084',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000072,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,134.1065,53.50233,0.037,NULL,64223626528,1003494164,15679596,17.6),(57962,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57962,37.98,0.46,394,18549,70,NULL,NULL,'2MASX J08562760+2806482',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,134.114833,28.11344,0.093,NULL,64377116178,1005892440,15717069,17.6),(57963,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57963,37.39,0.23,301,18550,70,NULL,NULL,'2MASX J08562789+1431362',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000207,NULL,'15.7g',0.42,NULL,NULL,NULL,NULL,NULL,1,134.11625,14.52683,0.105,NULL,63873330400,998020787,15594074,15.7),(57964,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57964,37.79,0.17,361,18551,70,NULL,NULL,'SDSS J085629.91+402740.8',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000157,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,134.124667,40.46133,0.061,NULL,64244309412,1003817334,15684645,17.1),(57965,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57965,37.39,0.23,301,18552,70,NULL,NULL,'2MASX J08563043+1431392',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000175,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,134.126875,14.52753,0.105,NULL,63873329896,998020779,15594074,17.6),(57966,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57966,37.91,0.11,382,18553,70,NULL,NULL,'2MASX J08563050+3748362',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000145,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,134.127333,37.81006,0.081,NULL,64415702245,1006495347,15726489,17.7),(57967,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57967,35.02,NULL,101,18554,NULL,NULL,NULL,'CGCG 120-052',NULL,'2000BSAO...50....5K',2000,1,0.81,NULL,'G',0.000027,NULL,'15.7',0.1,'Scd',NULL,NULL,NULL,NULL,1,134.13,21.37806,0.057,NULL,63836061515,997438461,15584975,15.7),(57968,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57968,35.38,NULL,119,18554,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 120-052',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57969,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57969,35.39,NULL,120,18554,NULL,NULL,'Dipole + Quadrupole','CGCG 120-052',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57970,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,NULL,57970,35.41,NULL,121,18554,NULL,NULL,'Dipole','CGCG 120-052',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57971,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57971,37.23,0.46,279,18555,70,NULL,NULL,'2MASX J08563246+1735312',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000174,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,134.13525,17.59208,0.045,NULL,63881887901,998154498,15596164,16.8),(57972,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57972,37.32,0.46,291,18556,70,NULL,NULL,'2MASX J08563250+1121494',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,134.135291667,11.36389,0.113,NULL,63661779867,994715310,15542426,17),(57973,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57973,36.99,0.23,249,18557,70,NULL,NULL,'2MASX J08563266+3238214',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000181,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,134.136208333,32.63925,0.041,NULL,64384775036,1006012109,15718939,17.1),(57974,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57974,35.51,0.46,126,18558,70,NULL,NULL,'CGCG 209-008',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.00015,NULL,'14.2g',0.75,'S0^-',NULL,NULL,NULL,NULL,1,134.136333333,39.14106,0.049,NULL,64412324089,1006442563,15725665,14.2),(57975,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57975,37.68,0.46,344,18559,70,NULL,NULL,'2MASX J08563492+5903178',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,134.145583333,59.05506,0.145,NULL,62019231210,969050487,15141413,17.7),(57976,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57976,36.83,0.46,232,18560,70,NULL,NULL,'2MASX J08563540+1602502',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,134.1474583,16.04722,0.045,NULL,63885316048,998208063,15597000,16.4),(57977,'FP','2016-12-15 15:14:25','2016-12-16 11:19:31','1',NULL,'R',57977,37.78,0.46,359,18561,70,NULL,NULL,'2MASX J08563603+1734562',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000191,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,134.1500417,17.58219,0.045,NULL,63883739297,998183426,15596616,16.7),(57978,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',57978,34.5,0.33,79.4,18562,70,NULL,NULL,'CGCG 264-032',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000083,NULL,'15.0g',0.55,'S0^-',NULL,NULL,NULL,NULL,1,134.153916667,51.92039,0.061,NULL,64224573219,1003508956,15679827,15),(57979,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',57979,36.99,0.23,249,18563,70,NULL,NULL,'2MASX J08563702+3232304',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000188,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,134.154333,32.54175,0.045,NULL,64384778541,1006012164,15718940,16.4),(57980,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',57980,38.18,0.46,433,18564,70,NULL,NULL,'2MASX J08564031+5222085',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000088,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,134.168,52.36908,0.037,NULL,64226981825,1003546591,15680415,18),(57981,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,57981,35,0.48,100,18565,70,NULL,NULL,'ESO 060- G 018',NULL,'2014MNRAS.445.2677S',2014,1,2,NULL,'G',0.00015,NULL,'14.13',1.4,'SB(s)bc pec',NULL,NULL,NULL,NULL,1,134.168917,-67.87033,0.421,NULL,40798692549,637479571,9960618,14.13),(57982,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',57982,38.12,0.21,420,18566,70,NULL,NULL,'2MASX J08564070+0553474',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000183,NULL,'16.3g',0.39,'BrClG',NULL,NULL,NULL,NULL,1,134.169667,5.8965,0.145,NULL,63629783394,994215365,15534615,16.3),(57983,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',57983,38.12,0.21,420,18567,70,NULL,NULL,'SDSS J085641.49+055137.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,134.172917,5.8605,0.145,NULL,63629784431,994215381,15534615,18.3),(57984,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',57984,37.97,0.46,393,18568,70,NULL,NULL,'SDSS J085641.66+155928.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000142,NULL,'18.7g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,134.173625,15.99128,0.045,NULL,63884837118,998200579,15596884,18.7),(57985,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',57985,37.89,0.23,379,18569,70,NULL,NULL,'2MASX J08564193+3040504',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000139,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,134.174625,30.68069,0.065,NULL,64390475032,1006101172,15720330,17.6),(57986,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,57986,33.51,0.47,50.4,18570,NULL,NULL,'H','UGC 04671',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000087,NULL,'13.60',1.1,'S?','Pair member (points to parent)',NULL,NULL,NULL,1,134.178083,52.10536,0.061,NULL,64227182904,1003549732,15680464,13.6),(57987,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,57987,33.6,0.45,52.4,18570,NULL,NULL,'K','UGC 04671',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57988,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,57988,33.64,0.46,53.4,18570,NULL,NULL,'J','UGC 04671',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57989,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,57989,33.72,0.4,55.5,18570,NULL,NULL,'mean','UGC 04671',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(57990,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,57990,36.1,0.57,166,18571,70,NULL,NULL,'2MASX J08564302-2826285',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,'S',NULL,NULL,NULL,NULL,1,134.1792083,-28.44122,0.753,NULL,42900747564,670324180,10473815,15.4),(57991,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',57991,37.47,0.46,312,18572,70,NULL,NULL,'2MASX J08564342+3934521',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000135,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,134.180833,39.58114,0.073,NULL,64365929146,1005717642,15714338,18.2),(57992,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',57992,38.01,0.46,400,18573,70,NULL,NULL,'2MASX J08564572+0854085',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,134.190583,8.90247,0.117,NULL,63684824729,995075386,15548052,18),(57993,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',57993,37.53,0.46,320,18574,70,NULL,NULL,'2MASX J08564580+2310051',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,134.190833,23.16803,0.097,NULL,63824300026,997254687,15582104,17.3),(57994,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',57994,37.19,0.46,275,18575,70,NULL,NULL,'2MASX J08564591+1652232',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,134.191416667,16.87317,0.037,NULL,63887132526,998236445,15597444,16.3),(57995,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',57995,38.11,0.46,419,18576,70,NULL,NULL,'2MASX J08564628+0645205',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,134.192875,6.75572,0.157,NULL,63675758929,994933733,15545839,17.7),(57996,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',57996,37.44,0.46,308,18577,70,NULL,NULL,'2MASX J08564725+4316083',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000151,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,134.197167,43.26897,0.093,NULL,64276322278,1004317535,15692461,17.3),(57997,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',57997,36.15,0.46,170,18578,70,NULL,NULL,'2MASX J08564772+6441057',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,134.1985417,64.68497,0.113,NULL,62261113825,972829903,15200467,17.1),(57998,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',57998,37.6,0.33,331,18579,70,NULL,NULL,'2MASX J08564859+2157281',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,134.202333333,21.95789,0.093,NULL,63835837535,997434961,15584921,17.8),(57999,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',57999,38.16,0.33,428,18580,70,NULL,NULL,'2MASX J08564864+1504252',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000169,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,134.20275,15.07364,0.089,NULL,63873763515,998027554,15594180,18.2),(58000,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58000,37.91,0.11,382,18581,70,NULL,NULL,'2MASX J08564897+3803204',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,134.204083333,38.05558,0.073,NULL,64415838253,1006497472,15726523,18.1),(58001,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58001,38.04,0.33,406,18582,70,NULL,NULL,'2MASX J08564955+5910149',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,134.2065,59.17089,0.113,NULL,62019294734,969051480,15141429,17.3),(58002,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58002,37.42,0.46,305,18583,70,NULL,NULL,'2MASX J08564993+3642044',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000155,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,134.2079583,36.70119,0.077,NULL,64413460190,1006460315,15725942,16.5),(58003,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58003,38.03,0.27,403,18584,70,NULL,NULL,'SDSS J085650.06+385732.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,134.208625,38.959,0.033,NULL,64412342023,1006442844,15725669,18.7),(58004,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58004,38.6,0.46,525,18585,70,NULL,NULL,'SDSS J085651.02+534742.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000066,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,134.212583333,53.79506,0.053,NULL,64224103627,1003501619,15679712,18.5),(58005,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58005,37.16,0.46,270,18586,70,NULL,NULL,'2MASX J08565185+0729485',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000175,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,134.2160417,7.49686,0.193,NULL,63682694030,995042094,15547532,17.2),(58006,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58006,37.91,0.11,382,18587,70,NULL,NULL,'2MASX J08565340+3756434',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,134.2225417,37.94531,0.073,NULL,64415703311,1006495364,15726490,17.7),(58007,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58007,38.16,0.33,428,18588,70,NULL,NULL,'SDSS J085653.60+150931.2',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'16.3g',0.34,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,134.223375,15.15869,0.077,NULL,63873650157,998025783,15594152,16.3),(58008,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58008,37.42,0.46,305,18589,70,NULL,NULL,'2MASX J08565384+3208272',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000153,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,134.224375,32.14097,0.041,NULL,64384832949,1006013014,15718953,17.7),(58009,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58009,38.03,0.27,403,18590,70,NULL,NULL,'2MASX J08565586+3910574',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000141,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,134.232833,39.18264,0.053,NULL,64412326960,1006442608,15725665,17.8),(58010,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58010,38.04,0.33,406,18591,70,NULL,NULL,'2MASX J08565658+5912109',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,134.2355417,59.20306,0.113,NULL,62019322106,969051907,15141436,17),(58011,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58011,38.43,0.33,485,18592,70,NULL,NULL,'SDSS J085656.94+011330.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000083,NULL,'18.3g',0.16,'NLAGN',NULL,NULL,NULL,NULL,1,134.23725,1.22506,0.149,NULL,63619744906,994058514,15532164,18.3),(58012,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58012,37.89,0.23,379,18593,70,NULL,NULL,'SDSS J085657.20+304011.5',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,134.238333,30.66986,0.045,NULL,64390648347,1006103880,15720373,17.5),(58013,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58013,37.6,0.46,331,18594,70,NULL,NULL,'2MASX J08565738+1054165',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,134.2392083,10.90444,0.121,NULL,63669848313,994841379,15544396,17.1),(58014,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58014,35.71,0.48,139,18595,70,NULL,NULL,'2MASX J08565770-2756415',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00011,NULL,'15.1R',NULL,'E',NULL,NULL,NULL,NULL,1,134.2404583,-27.94483,0.669,NULL,42901059941,670329061,10473891,15.1),(58015,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58015,32.4,0.47,30.2,18596,NULL,NULL,'H','NGC 2692',NULL,'2007A&A...465...71T',2007,1,1.35,NULL,'G',0.000037,NULL,'13.7g',0.59,'SBab:','Pair member (points to parent)',NULL,NULL,NULL,1,134.2417083,52.06594,0.061,NULL,64227182239,1003549722,15680464,13.7),(58016,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58016,32.57,0.46,32.7,18596,NULL,NULL,'J','NGC 2692',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58017,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58017,32.63,0.45,33.5,18596,NULL,NULL,'K','NGC 2692',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58018,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58018,33.52,0.4,50.6,18596,NULL,NULL,'mean','NGC 2692',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58019,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58019,38.11,0.46,418,18597,70,NULL,NULL,'2MASX J08565879+4447504',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,134.2449583,44.79739,0.097,NULL,64287474381,1004491787,15695184,17.1),(58020,'D-Sigma','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58020,33.65,0.4,53.7,18598,75,NULL,'Edat, raw','NGC 2693',NULL,'1997ApJS..109..333W',1997,1,1.75,'CGCG misprints declination as +51d 03\'.','G',0.00005,NULL,'12.8g',1.17,'E3:','in a radial-velocity based grouping',NULL,NULL,NULL,1,134.246958333,51.34744,0.069,NULL,64224714555,1003511164,15679861,12.8),(58021,'D-Sigma','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58021,33.98,0.4,62.6,18598,75,NULL,'Edat, cor','NGC 2693',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58022,'Faber-Jackson','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58022,33.32,0.28,46.1,18598,95,NULL,'Weighted Mean','NGC 2693',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58023,'Faber-Jackson','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58023,33.41,0.46,48.1,18598,95,NULL,'Michard 1979a','NGC 2693',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58024,'Faber-Jackson','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58024,33.57,0.63,51.8,18598,95,NULL,'Michard 1979b, c','NGC 2693',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58025,'Faber-Jackson','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58025,33.81,0.45,57.8,18598,95,NULL,'de Vaucouleurs','NGC 2693',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58026,'Faber-Jackson','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58026,34.59,0.81,82.8,18598,55,NULL,'Visvanathan & Sandage 1979','NGC 2693',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58027,'Tertiary','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58027,33.53,0.5,50.8,18598,95,NULL,NULL,'NGC 2693',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58028,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58028,34.23,0.4,70.2,18598,NULL,NULL,'mean','NGC 2693',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58029,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58029,34.41,0.45,76.2,18598,NULL,NULL,'K','NGC 2693',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58030,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58030,34.5,0.33,79.4,18599,70,NULL,NULL,'NGC 2694',NULL,'2015arXiv151105856S',2015,1,0.65,'CGCG misprints Dec as +5102.','G',0.000084,NULL,'15.2g',0.4,'E1','in a pair',NULL,NULL,NULL,1,134.246917,51.33197,0.069,NULL,64224714159,1003511158,15679861,15.2),(58031,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58031,37.91,0.11,382,18600,70,NULL,NULL,'SDSS J085659.38+374538.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000123,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,134.2474583,37.76058,0.081,NULL,64415718615,1006495603,15726493,18.3),(58032,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58032,36.99,0.23,249,18601,70,NULL,NULL,'2MASX J08565998+3239082',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000156,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,134.24975,32.65228,0.041,NULL,64384764540,1006011945,15718936,16.8),(58033,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58033,34.72,0.46,87.8,18602,70,NULL,NULL,'2MASX J08570041+3920005',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000167,NULL,'15.7g',0.3,'S0/a',NULL,NULL,NULL,NULL,1,134.251833,39.33342,0.021,NULL,64366379606,1005724681,15714448,15.7),(58034,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58034,37.38,0.46,300,18603,70,NULL,NULL,'2MASX J08570053+2939432',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'16.9g',0.3,'E',NULL,NULL,NULL,NULL,1,134.2522083,29.66181,0.061,NULL,64388195314,1006065551,15719774,16.9),(58035,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58035,37.16,0.46,271,18604,70,NULL,NULL,'2MASX J08570094+1903309',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000197,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,134.2539583,19.05861,0.053,NULL,63825945048,997280391,15582506,16.3),(58036,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58036,33.98,0.4,62.6,18605,NULL,NULL,'mean','UGC 04685',NULL,'2007A&A...465...71T',2007,1,1.24,NULL,'G',0.00002,NULL,'14.3g',0.51,'S?','in a pair',NULL,NULL,NULL,1,134.2545417,13.19911,0.097,NULL,63841905680,997529776,15586402,14.3),(58037,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58037,34.02,0.47,63.7,18605,NULL,NULL,'H','UGC 04685',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58038,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58038,34.1,0.46,66.2,18605,NULL,NULL,'J','UGC 04685',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58039,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58039,34.11,0.45,66.3,18605,NULL,NULL,'K','UGC 04685',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58040,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58040,32.36,0.52,29.6,18606,70,NULL,NULL,'NGC 2717',NULL,'2014MNRAS.445.2677S',2014,1,2.1,NULL,'G',0.000067,NULL,'13.43',1.5,'SAB(s)0-','in an interacting pair',NULL,NULL,NULL,1,134.254667,-24.67375,0.777,NULL,42228343203,659817862,10309654,13.43),(58041,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58041,37.72,0.46,350,18607,70,NULL,NULL,'2MASX J08570145+0743170',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000189,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,134.255916667,7.72139,0.209,NULL,63685554001,995086781,15548230,17.2),(58042,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58042,37.27,0.46,284,18608,70,NULL,NULL,'2MASX J08570179+3058002',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,134.257541667,30.96683,0.041,NULL,64387053796,1006047715,15719495,18),(58043,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58043,35.63,0.63,134,18609,70,NULL,NULL,'2MASX J08570200-0548092',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'17.01',0.3,NULL,NULL,NULL,NULL,NULL,1,134.258375,-5.80286,0.033,NULL,42149807429,658590741,10290480,17.01),(58044,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58044,37.66,0.33,340,18610,70,NULL,NULL,'2MASX J08570227+1541352',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000191,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,134.259375,15.69311,0.073,NULL,63884908487,998201695,15596901,16.5),(58045,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58045,38.35,0.46,467,18611,70,NULL,NULL,'SDSS J085702.79+213437.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000139,NULL,'18.7g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,134.261667,21.57717,0.077,NULL,63835913386,997436146,15584939,18.7),(58046,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58046,38.28,0.46,454,18612,70,NULL,NULL,'SDSS J085703.57+133408.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000179,NULL,'18.6g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,134.264917,13.56914,0.101,NULL,63871617004,997994015,15593656,18.6),(58047,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58047,37.34,0.46,294,18613,70,NULL,NULL,'2MASX J08570507+0521291',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000198,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,134.271083333,5.35817,0.145,NULL,63630285301,994223207,15534737,16.5),(58048,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58048,36.27,0.54,179,18614,70,NULL,NULL,'2MASX J08570559-0208562',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,134.27325,-2.14894,0.033,NULL,42146131420,658533303,10289582,15.1),(58049,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58049,38.43,0.33,485,18615,70,NULL,NULL,'2MASX J08570601+0115031',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000087,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,134.274875,1.25092,0.149,NULL,63619966199,994061971,15532218,17.7),(58050,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58050,38.12,0.21,420,18616,70,NULL,NULL,'2MASX J08570604+0551540',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000158,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,134.275167,5.86511,0.145,NULL,63629895544,994217117,15534642,18.3),(58051,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58051,38.05,0.46,408,18617,70,NULL,NULL,'2MASX J08570638+6317226',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,134.276625,63.28964,0.169,NULL,62059864808,969685387,15151334,18.1),(58052,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58052,35.06,0.49,103,18618,75,NULL,'IR','MCG -01-23-011',NULL,'2011yCatp016004901K',2011,1,1.7,'MCG notes say that dec. for MCG -01-23 zone is off by 8\'.','G',0.000033,NULL,'15',0.3,'Sbc:',NULL,NULL,NULL,NULL,1,134.277167,-8.72392,0.073,NULL,42208683751,659510683,10304854,15),(58053,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58053,35.83,0.4,147,18618,NULL,NULL,'mean','MCG -01-23-011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58054,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58054,35.91,0.47,152,18618,NULL,NULL,'H','MCG -01-23-011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58055,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58055,36,0.45,159,18618,NULL,NULL,'K','MCG -01-23-011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58056,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58056,32.3,0.43,28.9,18619,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04601',NULL,'2014MNRAS.444..527S',2014,1,1.6,NULL,'G',0.000043,NULL,'14.9',0.7,NULL,NULL,NULL,NULL,NULL,1,134.280333,84.80853,0.205,NULL,61270152392,957346131,14958533,14.9),(58057,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58057,32.53,0.43,32.1,18619,75,NULL,'3.6 micron, color corrected','UGC 04601',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58058,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58058,32.76,0.2,35.7,18619,74.4,NULL,NULL,'UGC 04601',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58059,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58059,36.4,0.55,190,18620,70,NULL,NULL,'2MASX J08570743-0545082',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.46',NULL,NULL,NULL,NULL,NULL,NULL,1,134.280958333,-5.75256,0.033,NULL,42149808519,658590758,10290480,16.46),(58060,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58060,37.31,0.46,290,18621,70,NULL,NULL,'2MASX J08570789+2425589',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000181,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,134.282833,24.43306,0.069,NULL,63787566231,996680722,15573136,16.7),(58061,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58061,35.68,0.46,137,18622,70,NULL,NULL,'2MASX J08570794+3808105',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000173,NULL,'16.0g',0.29,'E0',NULL,NULL,NULL,NULL,1,134.2829583,38.13617,0.073,NULL,64415856124,1006497751,15726527,16),(58062,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58062,32.27,0.49,28.5,18623,75,NULL,'IR','UGC 04679',NULL,'2011yCatp016004901K',2011,1,1.24,NULL,'G',0.000089,NULL,'16.2g',0.25,'Sb(f)',NULL,NULL,NULL,NULL,1,134.284375,51.47156,0.073,NULL,64224734204,1003511471,15679866,16.2),(58063,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58063,32.66,NULL,34,18623,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04679',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58064,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58064,32.67,NULL,34.2,18623,NULL,NULL,'Dipole','UGC 04679',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58065,'Tully-Fisher','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,NULL,58065,32.67,NULL,34.2,18623,NULL,NULL,'Dipole + Quadrupole','UGC 04679',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58066,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58066,37.89,0.23,379,18624,70,NULL,NULL,'2MASX J08570891+3035142',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,134.287083,30.58728,0.045,NULL,64390680470,1006104382,15720380,17),(58067,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58067,38.12,0.21,420,18625,70,NULL,NULL,'2MASX J08570935+0548261',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,134.288917,5.80736,0.145,NULL,63629899065,994217172,15534643,17.7),(58068,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58068,37.47,0.16,312,18626,70,NULL,NULL,'SDSS J085709.62+012104.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000078,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,134.290125,1.35122,0.161,NULL,63619777364,994059021,15532172,18.1),(58069,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58069,37.47,0.16,312,18627,70,NULL,NULL,'2MASX J08571027+0124501',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00009,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,134.292917,1.41381,0.161,NULL,63619771181,994058924,15532170,16.7),(58070,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58070,37.69,0.46,346,18628,70,NULL,NULL,'2MASX J08571030+5527358',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000064,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,134.2929583,55.45997,0.045,NULL,62009237668,968894338,15138974,18.4),(58071,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58071,37.66,0.46,341,18629,70,NULL,NULL,'2MASX J08571295+4028334',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'17.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,134.3037917,40.47597,0.045,NULL,64244383220,1003818487,15684663,17.9),(58072,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58072,37.41,0.46,304,18630,70,NULL,NULL,'2MASX J08571393+4226593',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000183,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,134.3080417,42.44978,0.093,NULL,64277181355,1004330958,15692671,16.8),(58073,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58073,37.66,0.33,340,18631,70,NULL,NULL,'2MASX J08571398+1540443',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000173,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,134.308333,15.67894,0.069,NULL,63884917031,998201828,15596903,17),(58074,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58074,37.64,0.46,337,18632,70,NULL,NULL,'2MASX J08571460+5123109',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00009,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,134.31075,51.38642,0.069,NULL,64224739579,1003511555,15679868,17.3),(58075,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58075,36.7,0.46,219,18633,70,NULL,NULL,'2MASX J08571545+1443382',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.4g',0.24,'AGN',NULL,NULL,NULL,NULL,1,134.3144583,14.72753,0.101,NULL,63873301196,998020331,15594067,17.4),(58076,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58076,38.03,0.27,403,18634,70,NULL,NULL,'2MASX J08571560+3855184',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000184,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,134.315041667,38.92178,0.033,NULL,64412368962,1006443265,15725676,17.2),(58077,'FP','2016-12-15 15:14:25','2016-12-16 11:19:32','1',NULL,'R',58077,37.47,0.16,312,18635,70,NULL,NULL,'SDSS J085717.45+012259.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000075,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,134.32275,1.38311,0.161,NULL,63619769103,994058892,15532170,18),(58078,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58078,33.68,0.75,54.4,18636,70,NULL,NULL,'ESO 563- G 037',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000143,NULL,'15.19',0.8,'S0',NULL,NULL,NULL,NULL,1,134.325,-19.14439,0.541,NULL,42356388808,661818575,10340915,15.19),(58079,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58079,37.54,0.46,322,18637,70,NULL,NULL,'2MASX J08571937+3920374',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,134.330625,39.34372,0.021,NULL,64412844948,1006450702,15725792,17),(58080,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58080,38.3,0.46,457,18638,70,NULL,NULL,'2MASX J08571953+5030409',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.0001,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,134.331167,50.51147,0.045,NULL,64238543682,1003727245,15683238,17.1),(58081,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58081,33.32,0.46,46.1,18639,NULL,NULL,'J','NGC 2713',NULL,'2007A&A...465...71T',2007,1,2.55,NULL,'G',0.00002,NULL,'12.7g',0.99,'SB(rs)ab','in a pair',NULL,NULL,NULL,1,134.335458333,2.92131,0.137,NULL,63621934751,994092730,15532698,12.7),(58082,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58082,33.33,0.47,46.4,18639,NULL,NULL,'H','NGC 2713',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58083,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58083,33.39,0.45,47.6,18639,NULL,NULL,'K','NGC 2713',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58084,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58084,33.7,0.4,54.9,18639,NULL,NULL,'mean','NGC 2713',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58085,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58085,33.81,0.27,57.9,18639,NULL,NULL,'Malmquist cor.','NGC 2713',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58086,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58086,34.05,0.24,64.7,18639,NULL,NULL,NULL,'NGC 2713',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58087,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58087,34.09,0.2,65.8,18639,74.4,NULL,NULL,'NGC 2713',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58088,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58088,34.26,0.43,71,18639,75,NULL,'3.6 micron, color corrected','NGC 2713',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58089,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58089,34.54,0.43,80.8,18639,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2713',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58090,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58090,38.13,0.46,422,18640,70,NULL,NULL,'2MASX J08572062+5210189',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000099,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,134.335833,52.17189,0.045,NULL,64227191834,1003549872,15680466,17.6),(58091,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58091,37.79,0.46,362,18641,70,NULL,NULL,'2MASX J08572096+1642503',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'16.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,134.3372917,16.71417,0.045,NULL,63887225790,998237902,15597467,16.8),(58092,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58092,35.81,0.46,145,18642,70,NULL,NULL,'CGCG 120-054',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.00017,NULL,'14.9g',0.63,NULL,NULL,NULL,NULL,NULL,1,134.343417,22.44317,0.089,NULL,63821929784,997217652,15581525,14.9),(58093,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58093,35.28,0.47,114,18643,70,NULL,NULL,'2MASX J08572271-0947480',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'15.36',NULL,NULL,NULL,NULL,NULL,NULL,1,134.344666667,-9.79683,0.085,NULL,42197504606,659336009,10302125,15.36),(58094,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58094,37.66,0.21,341,18644,70,NULL,NULL,'2MASX J08572292+1550353',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000149,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,134.345708333,15.84308,0.073,NULL,63885011421,998203303,15596926,17.9),(58095,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58095,36.49,0.46,198,18645,70,NULL,NULL,'2MASX J08572355+2414149',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000159,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,134.348041667,24.23744,0.077,NULL,63820982563,997202852,15581294,17),(58096,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58096,37.72,0.46,350,18646,70,NULL,NULL,'SDSS J085723.77+323115.9',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.5g',0.3,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,134.349083333,32.52111,0.045,NULL,64384905415,1006014147,15718971,16.5),(58097,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58097,35.63,0.58,134,18647,70,NULL,NULL,'2MASX J08572497-1145410',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.14',NULL,NULL,NULL,NULL,NULL,NULL,1,134.354,-11.76153,0.125,NULL,42165461623,658835337,10294302,16.14),(58098,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58098,38.29,0.46,454,18648,70,NULL,NULL,'SDSS J085724.95+443238.5',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000142,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,134.354,44.54403,0.065,NULL,64287529364,1004492646,15695197,17.8),(58099,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58099,39.13,0.46,668,18649,70,NULL,NULL,'2MASX J08572551+4710473',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,134.356208333,47.17967,0.053,NULL,64284229153,1004441080,15694391,17.8),(58100,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58100,37.94,0.33,387,18650,70,NULL,NULL,'SDSS J085726.50+411722.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000146,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,134.360458333,41.28956,0.081,NULL,64274369492,1004287023,15691984,18.3),(58101,'IRAS','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58101,31.16,0.8,17.1,18651,75,NULL,'A82, H','ESO 060- G 019',NULL,'1997ApJS..109..333W',1997,1,3.2,'Extended HIPASS source','G',0.000013,NULL,'12.78',1.2,'SB(s)d',NULL,NULL,NULL,NULL,1,134.361333333,-69.06008,0.365,NULL,40745614619,636650228,9947659,12.78),(58102,'IRAS','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58102,31.17,0.8,17.1,18651,75,NULL,'MAT, I','ESO 060- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58103,'Tully est','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58103,31.17,0.8,17.1,18651,75,NULL,NULL,'ESO 060- G 019',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58104,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58104,31.06,0.32,16.3,18651,85,NULL,'I, inv','ESO 060- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58105,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58105,31.07,0.32,16.4,18651,85,NULL,'I, raw','ESO 060- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58106,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58106,31.15,0.47,17,18651,75,NULL,'A82, H, inv','ESO 060- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58107,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58107,31.21,0.47,17.4,18651,75,NULL,'A82, H, raw','ESO 060- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58108,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58108,31.35,0.43,18.6,18651,75,NULL,'MAT, I, raw','ESO 060- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58109,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58109,31.37,0.2,18.8,18651,74.4,NULL,NULL,'ESO 060- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58110,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58110,31.38,0.43,18.9,18651,75,NULL,'MAT, I, inv','ESO 060- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58111,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58111,31.5,0.47,19.9,18651,75,NULL,'A82, H, cor','ESO 060- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58112,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58112,31.59,0.43,20.8,18651,75,NULL,'MAT, I, cor','ESO 060- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58113,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58113,31.63,0.38,21.2,18651,NULL,NULL,NULL,'ESO 060- G 019',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58114,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58114,31.63,0.39,21.2,18651,73,NULL,'opt','ESO 060- G 019',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58115,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58115,32.19,0.4,27.4,18651,NULL,NULL,'mean','ESO 060- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58116,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58116,32.58,0.46,32.7,18651,NULL,NULL,'J','ESO 060- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58117,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58117,32.61,0.47,33.2,18651,NULL,NULL,'H','ESO 060- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58118,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58118,32.71,0.45,34.9,18651,NULL,NULL,'K','ESO 060- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58119,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58119,36.1,0.46,166,18652,70,NULL,NULL,'SDSS J085727.11+163849.6',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'15.9g',0.44,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,134.363,16.64711,0.045,NULL,63887235842,998238060,15597469,15.9),(58120,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58120,36.94,0.46,244,18653,70,NULL,NULL,'2MASX J08572816+4758520',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00017,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,134.36725,47.98117,0.077,NULL,64228670343,1003572974,15680827,16.7),(58121,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58121,37.91,0.11,382,18654,70,NULL,NULL,'2MASX J08572867+3757234',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,134.3695417,37.95656,0.077,NULL,64415801853,1006496903,15726514,17.5),(58122,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58122,37.6,0.46,331,18655,70,NULL,NULL,'2MASX J08572965+0254000',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,134.3735417,2.90017,0.137,NULL,63622061388,994094709,15532729,18),(58123,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58123,37.84,0.46,369,18656,70,NULL,NULL,'2MASX J08572977+3630014',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000187,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,134.3739583,36.50028,0.057,NULL,64420856587,1006575884,15727748,17.1),(58124,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58124,37.95,0.27,390,18657,70,NULL,NULL,'2MASX J08573208+1807478',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,134.383541667,18.13,0.057,NULL,63881491617,998148306,15596067,17.3),(58125,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58125,37.26,0.46,283,18658,70,NULL,NULL,'2MASX J08573269+3619034',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,134.386125,36.31764,0.037,NULL,64421079362,1006579365,15727802,17.3),(58126,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58126,38.54,0.46,511,18659,70,NULL,NULL,'2MASX J08573336+1502373',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000206,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,134.388917,15.04364,0.089,NULL,63873677710,998026214,15594159,17.1),(58127,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58127,37.95,0.27,390,18660,70,NULL,NULL,'SDSS J085733.47+180752.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000144,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,134.389458333,18.13128,0.057,NULL,63881492429,998148319,15596067,18.6),(58128,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58128,37.5,0.46,316,18661,70,NULL,NULL,'SDSS J085737.17+042934.9',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,134.404917,4.49303,0.129,NULL,63635683559,994307555,15536055,17.7),(58129,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58129,37.76,0.46,356,18662,70,NULL,NULL,'2MASX J08573716+4102385',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000213,NULL,'16.2g',0.41,NULL,NULL,NULL,NULL,NULL,1,134.405,41.04389,0.041,NULL,64244231691,1003816120,15684626,16.2),(58130,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58130,36.48,0.46,198,18663,70,NULL,NULL,'2MASX J08573773+3046526',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00017,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,134.407167,30.78139,0.045,NULL,64390646239,1006103847,15720372,16.3),(58131,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58131,37.66,0.21,341,18664,70,NULL,NULL,'2MASX J08573866+1554334',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,134.411125,15.90925,0.093,NULL,63885006516,998203226,15596925,16.6),(58132,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58132,36.02,0.33,160,18665,70,NULL,NULL,'2MASX J08574061+5503111',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00007,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,134.41925,55.05314,0.069,NULL,61538929692,961545776,15024152,16.2),(58133,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58133,37.47,0.16,312,18666,70,NULL,NULL,'2MASX J08574158+0058551',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000082,NULL,'17.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,134.4232917,0.98189,0.141,NULL,63619847507,994060117,15532189,17.9),(58134,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58134,37.66,0.46,341,18667,70,NULL,NULL,'2MASX J08574186+2143398',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000183,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,134.424583,21.72764,0.085,NULL,63835989275,997437332,15584958,17),(58135,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58135,37.48,0.33,313,18668,70,NULL,NULL,'2MASX J08574205+0953118',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000158,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,134.425375,9.88656,0.125,NULL,63670925665,994858213,15544659,17.5),(58136,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58136,37.91,0.11,382,18669,70,NULL,NULL,'2MASX J08574205+3813334',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000174,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,134.425375,38.22592,0.073,NULL,64415818214,1006497159,15726518,17.5),(58137,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58137,37.66,0.21,341,18670,70,NULL,NULL,'2MASX J08574365+1552524',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,134.431875,15.88133,0.093,NULL,63885013518,998203336,15596927,17.7),(58138,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58138,37.91,0.11,382,18671,70,NULL,NULL,'2MASX J08574395+3843434',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000073,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,134.43325,38.72878,0.045,NULL,64412395802,1006443684,15725682,17),(58139,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58139,37.47,0.16,312,18672,70,NULL,NULL,'2MASX J08574431+0110041',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000077,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,134.434458333,1.16778,0.133,NULL,63619961781,994061902,15532217,17.7),(58140,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58140,36.02,0.33,160,18673,70,NULL,NULL,'CGCG 264-037',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000083,NULL,'15.0g',0.59,'E0',NULL,NULL,NULL,NULL,1,134.436917,55.07328,0.069,NULL,61538928516,961545758,15024152,15),(58141,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58141,38.02,0.21,402,18674,70,NULL,NULL,'2MASX J08574500+3015586',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000156,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,134.437625,30.26614,0.053,NULL,64390558730,1006102480,15720351,18.5),(58142,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58142,37.91,0.11,382,18675,70,NULL,NULL,'2MASX J08574512+3825075',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000141,NULL,'17.7g',0.2,'AGN',NULL,NULL,NULL,NULL,1,134.43825,38.41881,0.073,NULL,64415746124,1006496033,15726500,17.7),(58143,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58143,37.94,0.33,387,18676,70,NULL,NULL,'2MASX J08574569+4126524',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,134.4404583,41.44794,0.061,NULL,64274161719,1004283776,15691934,17.3),(58144,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58144,37.48,0.33,313,18677,70,NULL,NULL,'2MASX J08574584+0957367',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,134.441,9.96019,0.125,NULL,63670914733,994858042,15544656,16.9),(58145,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58145,37.12,0.46,265,18678,70,NULL,NULL,'2MASX J08574711+1155187',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,134.4462083,11.92206,0.109,NULL,63661327355,994708239,15542316,16.5),(58146,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58146,38.19,0.46,435,18679,70,NULL,NULL,'2MASX J08574740+1545533',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,134.4475,15.76475,0.085,NULL,63884980381,998202818,15596919,17.8),(58147,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58147,38.02,0.21,402,18680,70,NULL,NULL,'2MASX J08574793+3015046',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,134.449625,30.25133,0.053,NULL,64390554843,1006102419,15720350,17.2),(58148,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58148,33.63,0.57,53.2,18681,70,NULL,NULL,'2MASX J08574836-1909193',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,134.4514583,-19.15531,0.525,NULL,42356434565,661819290,10340926,14.7),(58149,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58149,37.77,0.46,358,18682,70,NULL,NULL,'2MASX J08574882+3453016',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000157,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,134.4532917,34.88383,0.049,NULL,64424236006,1006628687,15728573,17.5),(58150,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58150,36.49,0.46,199,18683,70,NULL,NULL,'2MASX J08574997+0848477',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000167,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,134.4582917,8.81319,0.121,NULL,63684919974,995076874,15548076,16.8),(58151,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58151,37.68,0.33,344,18684,70,NULL,NULL,'2MASX J08575076+3005425',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,134.461708333,30.09528,0.053,NULL,64390503826,1006101622,15720337,17.6),(58152,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58152,37.66,0.21,341,18685,70,NULL,NULL,'SDSS J085751.27+155219.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,134.463667,15.87203,0.093,NULL,63885015459,998203366,15596927,18.2),(58153,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58153,37.47,0.16,312,18686,70,NULL,NULL,'2MASX J08575184+0126361',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000067,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,134.4660417,1.44322,0.161,NULL,63619942958,994061608,15532212,17.6),(58154,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58154,34.9,0.2,95.5,18687,74.4,NULL,NULL,'UGC 04694',NULL,'2013AJ....146...86T',2013,1,0.73,NULL,'G',0.000097,NULL,'15.9g',0.5,'SBcd:',NULL,NULL,NULL,NULL,1,134.4689583,12.49533,0.113,NULL,63841727017,997526984,15586359,15.9),(58155,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58155,35.33,0.46,116,18688,70,NULL,NULL,'CGCG 090-044 NED01',NULL,'2015arXiv151105856S',2015,1,0.87,NULL,'G',0.000183,NULL,'14.6g',0.7,NULL,NULL,NULL,NULL,NULL,1,134.469541667,20.12253,0.069,NULL,63833887829,997404497,15584445,14.6),(58156,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58156,37.17,0.33,272,18689,70,NULL,NULL,'2MASX J08575391+4027314',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,134.47475,40.45881,0.061,NULL,64244199350,1003815614,15684618,16.9),(58157,'Tully est','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58157,31.14,0.8,16.9,18690,75,NULL,NULL,'UGC 04683',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000017,NULL,'16.3g',0.8,'Im',NULL,NULL,NULL,NULL,1,134.4730417,59.08336,0.161,NULL,62019289989,969051406,15141428,16.3),(58158,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58158,37.42,0.46,305,18691,70,NULL,NULL,'2MASX J08575523+3421064',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,134.4800417,34.35183,0.045,NULL,64422089138,1006595142,15728049,17.7),(58159,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58159,37.62,0.46,335,18692,70,NULL,NULL,'2MASX J08575568+5658010',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000077,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,134.482167,56.96706,0.161,NULL,62011275078,968926173,15139471,17.5),(58160,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58160,36.72,0.46,221,18693,70,NULL,NULL,'2MASX J08575739+0010158',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000091,NULL,'15.9g',0.45,'E0',NULL,NULL,NULL,NULL,1,134.4890417,0.17119,0.129,NULL,62545642293,977275660,15269932,15.9),(58161,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58161,37.95,0.27,390,18694,70,NULL,NULL,'SDSS J085757.46+180543.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'18.2g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,134.489417,18.09539,0.061,NULL,63883511927,998179873,15596560,18.2),(58162,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58162,37.5,0.46,317,18695,70,NULL,NULL,'2MASX J08575773+3637473',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000154,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,134.490667,36.62975,0.077,NULL,64413286101,1006457595,15725899,16.6),(58163,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58163,37.47,0.16,312,18696,70,NULL,NULL,'2MASX J08575805+0111548',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000086,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,134.4917917,1.19853,0.133,NULL,63619978754,994062168,15532221,16.9),(58164,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58164,37.85,0.33,372,18697,70,NULL,NULL,'2MASX J08575832+0749597',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,134.492875,7.83322,0.209,NULL,63685761545,995090024,15548281,18.3),(58165,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58165,37.68,0.46,343,18698,70,NULL,NULL,'2MASX J08575847+5853150',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,134.4937083,58.88761,0.181,NULL,62021302639,969082853,15141919,17.3),(58166,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58166,37.91,0.11,382,18699,70,NULL,NULL,'SDSS J085759.82+381253.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,134.499291667,38.21497,0.073,NULL,64415777600,1006496525,15726508,18.5),(58167,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58167,38.17,0.27,431,18700,70,NULL,NULL,'2MASX J08580119+3443264',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,134.505083,34.72403,0.045,NULL,64424099499,1006626554,15728539,17.6),(58168,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58168,39.3,0.46,724,18701,70,NULL,NULL,'2MASX J08580130+1640063',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,134.505458333,16.66839,0.045,NULL,63887239104,998238111,15597470,18.2),(58169,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58169,37.66,0.21,341,18702,70,NULL,NULL,'SDSS J085803.57+155748.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,134.514917,15.96342,0.093,NULL,63884991934,998202998,15596921,18.2),(58170,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58170,37.68,0.46,344,18703,70,NULL,NULL,'SDSS J085804.09+213558.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000127,NULL,'18.2g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,134.517041667,21.59961,0.077,NULL,63835888275,997435754,15584933,18.2),(58171,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58171,38.02,0.21,402,18704,70,NULL,NULL,'2MASX J08580429+3020584',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00013,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,134.5177083,30.34964,0.053,NULL,64390527960,1006101999,15720343,17.9),(58172,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58172,37.43,0.46,306,18705,70,NULL,NULL,'SDSS J085804.79+180015.3',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000186,NULL,'16.4g',0.33,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,134.52,18.00425,0.061,NULL,63884364277,998193191,15596768,16.4),(58173,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58173,37.47,0.16,312,18706,70,NULL,NULL,'2MASX J08580492+0109138',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000102,NULL,'16.1g',0.41,'BrClG          AGN',NULL,NULL,NULL,NULL,1,134.520583333,1.15375,0.133,NULL,63619932472,994061444,15532210,16.1),(58174,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58174,38.02,0.21,402,18707,70,NULL,NULL,'SDSS J085805.00+301724.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,134.520833,30.29025,0.053,NULL,64390528761,1006102011,15720343,18.6),(58175,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58175,36.11,0.46,167,18708,70,NULL,NULL,'CGCG 120-055',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.00006,NULL,'15.1g',0.56,NULL,NULL,NULL,NULL,NULL,1,134.521833333,22.77611,0.065,NULL,63823821332,997247208,15581987,15.1),(58176,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58176,39.24,0.46,704,18709,70,NULL,NULL,'SDSS J085805.83+385419.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000159,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,134.5242917,38.90528,0.033,NULL,64412354982,1006443046,15725672,18.7),(58177,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58177,37.85,0.33,372,18710,70,NULL,NULL,'2MASX J08580674+0743397',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000175,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,134.528,7.72767,0.181,NULL,63685627814,995087934,15548248,17.7),(58178,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58178,38.66,0.46,539,18711,70,NULL,NULL,'2MASX J08580726+3723264',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000141,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,134.530333,37.39083,0.105,NULL,64415216045,1006487750,15726371,18),(58179,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58179,37.66,0.46,340,18712,70,NULL,NULL,'2MASX J08580746+5628459',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000084,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,134.531083,56.47958,0.149,NULL,62011859129,968935298,15139614,17.1),(58180,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58180,37.68,0.33,344,18713,70,NULL,NULL,'2MASX J08580815+3006454',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000159,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,134.534083333,30.11272,0.053,NULL,64390767458,1006105741,15720402,17.2),(58181,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58181,37.91,0.11,382,18714,70,NULL,NULL,'2MASX J08580837+3829234',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,134.535,38.49,0.065,NULL,64412292564,1006442071,15725657,17.5),(58182,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58182,38.93,0.46,611,18715,70,NULL,NULL,'2MASX J08580877+3600593',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,134.5364583,36.01653,0.057,NULL,64420988407,1006577943,15727780,18.1),(58183,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58183,37.17,0.33,272,18716,70,NULL,NULL,'2MASX J08580960+4023224',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000138,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,134.540083333,40.38944,0.061,NULL,64244192678,1003815510,15684617,17.1),(58184,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58184,37.91,0.11,382,18717,70,NULL,NULL,'2MASX J08580981+3838254',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000077,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,134.540833,38.64039,0.065,NULL,64412304061,1006442250,15725660,16.3),(58185,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58185,37.18,0.46,273,18718,70,NULL,NULL,'2MASX J08580988+3452154',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000183,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,134.5412917,34.87086,0.049,NULL,64424072065,1006626126,15728533,16.5),(58186,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58186,38.55,0.46,513,18719,70,NULL,NULL,'SDSS J085810.57+062629.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,134.5440417,6.44144,0.125,NULL,63675019436,994922178,15545659,18.1),(58187,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58187,35.73,0.46,140,18720,70,NULL,NULL,'2MASX J08581103+0650497',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'16.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,134.546083,6.84714,0.149,NULL,63682263654,995035369,15547427,16.5),(58188,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58188,38.08,0.46,413,18721,70,NULL,NULL,'2MASX J08581153+0727447',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'18.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,134.547917,7.46247,0.165,NULL,63682896540,995045258,15547582,18),(58189,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58189,37.26,0.46,283,18722,70,NULL,NULL,'2MASX J08581169+0810427',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,134.548875,8.17861,0.173,NULL,63685694587,995088977,15548265,18.2),(58190,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58190,37.8,0.27,364,18723,70,NULL,NULL,'SDSS J085811.72+553413.9',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000071,NULL,'18.1g',0.1,NULL,NULL,NULL,NULL,NULL,1,134.548875,55.57053,0.045,NULL,62009475878,968898060,15139032,18.1),(58191,'IRAS','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58191,34.17,0.8,68.3,18724,75,NULL,'MAT, I','MCG -01-23-013',NULL,'1997ApJS..109..333W',1997,1,2,'MCG notes say that dec. for MCG -01-23 zone is off by 8\'.','G',0.000013,NULL,'15.5',0.8,'SB(r)bc:',NULL,NULL,NULL,NULL,1,134.55,-6.19919,0.033,NULL,42205215343,659456489,10304007,15.5),(58192,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58192,33.45,0.32,49,18724,85,NULL,'I, raw','MCG -01-23-013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58193,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58193,33.48,0.32,49.7,18724,85,NULL,'I, inv','MCG -01-23-013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58194,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58194,33.59,0.43,52.2,18724,75,NULL,'MAT, I, raw','MCG -01-23-013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58195,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58195,33.75,0.43,56.2,18724,75,NULL,'MAT, I, inv','MCG -01-23-013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58196,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58196,33.91,0.2,60.5,18724,74.4,NULL,NULL,'MCG -01-23-013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58197,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58197,33.94,0.43,61.4,18724,75,NULL,'MAT, I, cor','MCG -01-23-013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58198,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58198,34.06,0.46,65,18724,NULL,NULL,NULL,'MCG -01-23-013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58199,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58199,34.13,0.45,67,18724,NULL,NULL,'Malmquist cor.','MCG -01-23-013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58200,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58200,34.43,0.4,76.9,18724,NULL,NULL,'mean','MCG -01-23-013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58201,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58201,34.62,0.47,83.8,18724,NULL,NULL,'H','MCG -01-23-013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58202,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58202,37.91,0.11,382,18725,70,NULL,NULL,'2MASX J08581236+3842444',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00011,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,134.551541667,38.71244,0.045,NULL,64412278198,1006441846,15725653,17.4),(58203,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58203,33.67,0.49,54.2,18726,70,NULL,NULL,'IC 0524',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000097,NULL,'15.01',0.8,'S0',NULL,NULL,NULL,NULL,1,134.5534583,-19.19192,0.577,NULL,42356405874,661818841,10340919,15.01),(58204,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58204,37.98,0.46,395,18727,70,NULL,NULL,'SDSS J085813.32+092339.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000152,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,134.5555417,9.39428,0.125,NULL,63671063098,994860360,15544693,18.5),(58205,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58205,37.54,0.46,322,18728,70,NULL,NULL,'SDSS J085814.18+384821.8',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,134.559083,38.80611,0.045,NULL,64412387488,1006443554,15725680,17.6),(58206,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58206,37.34,0.46,294,18729,70,NULL,NULL,'2MASX J08581500-0028039',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000081,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,134.562416667,-0.46783,0.081,NULL,39191759053,612371235,9568300,17.7),(58207,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58207,37.18,0.46,273,18730,70,NULL,NULL,'2MASX J08581632+1720454',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,134.568125,17.34606,0.057,NULL,63883816729,998184636,15596634,17),(58208,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58208,37.52,0.46,319,18731,70,NULL,NULL,'2MASX J08581651+0201188',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000078,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,134.568917,2.02192,0.121,NULL,63622780240,994105941,15532905,17.7),(58209,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58209,38.02,0.21,402,18732,70,NULL,NULL,'2MASX J08581750+3020543',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000158,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,134.573041667,30.34847,0.053,NULL,64390514031,1006101781,15720340,17.6),(58210,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58210,37.71,0.46,348,18733,70,NULL,NULL,'2MASX J08581762+5207481',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000074,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,134.573333,52.12992,0.017,NULL,64227241802,1003550653,15680478,17.7),(58211,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58211,37.37,0.46,298,18734,70,NULL,NULL,'2MASX J08581868+0006160',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000072,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,134.57775,0.10439,0.129,NULL,62545683518,977276304,15269942,17.6),(58212,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58212,37.81,0.46,365,18735,70,NULL,NULL,'2MASX J08581872+2622431',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000183,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,134.578,26.37869,0.101,NULL,64375083920,1005860686,15716573,16.6),(58213,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58213,37.35,0.46,295,18736,70,NULL,NULL,'2MASX J08581933+3656564',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000124,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,134.5805417,36.94903,0.073,NULL,64413470133,1006460470,15725944,17.2),(58214,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58214,36.58,0.46,207,18737,70,NULL,NULL,'CGCG 090-046',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000215,NULL,'15.0g',0.69,'AGN',NULL,NULL,NULL,NULL,1,134.586,17.53786,0.053,NULL,63883919224,998186237,15596659,15),(58215,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58215,37.03,0.46,255,18738,70,NULL,NULL,'2MASX J08582106+1028557',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,134.58775,10.48214,0.113,NULL,63673417164,994897143,15545267,17.6),(58216,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58216,37.58,0.46,328,18739,70,NULL,NULL,'2MASX J08582103+5307121',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000084,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,134.587833,53.11997,0.029,NULL,64223573561,1003493336,15679583,16.7),(58217,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58217,37.02,0.33,254,18740,70,NULL,NULL,'2MASX J08582139+0440168',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000173,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,134.589,4.67133,0.169,NULL,63632162657,994252541,15535195,17.9),(58218,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58218,37.75,0.19,354,18741,70,NULL,NULL,'2MASX J08582143+4503316',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000127,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,134.5890417,45.05867,0.077,NULL,64290150651,1004533603,15695837,18.2),(58219,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58219,38.31,0.46,459,18742,70,NULL,NULL,'2MASX J08582220+1502234',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000151,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,134.592583333,15.03969,0.089,NULL,63873642072,998025657,15594150,17.4),(58220,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58220,37.8,0.27,364,18743,70,NULL,NULL,'2MASX J08582225+5529336',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000075,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,134.5929583,55.49286,0.045,NULL,62009490990,968898296,15139035,17.9),(58221,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58221,38,0.46,398,18744,70,NULL,NULL,'2MASX J08582313+6404420',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,134.59625,64.07842,0.153,NULL,62230899525,972357805,15193090,NULL),(58222,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58222,37.55,0.46,324,18745,70,NULL,NULL,'2MASX J08582382+3504393',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,134.5992083,35.0775,0.013,NULL,64424185475,1006627898,15728560,17.5),(58223,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58223,39.04,0.46,642,18746,70,NULL,NULL,'SDSS J085825.07+274435.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,134.6044583,27.74308,0.081,NULL,64378267310,1005910426,15717350,18.2),(58224,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58224,35.98,0.46,157,18747,70,NULL,NULL,'2MASX J08582695+1125248',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,134.6122083,11.42353,0.109,NULL,63670459957,994850936,15544545,16.5),(58225,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58225,37.91,0.11,382,18748,70,NULL,NULL,'2MASX J08582719+3827564',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000179,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,134.6132083,38.46558,0.065,NULL,64412291539,1006442055,15725657,17.7),(58226,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58226,37.81,0.46,365,18749,70,NULL,NULL,'2MASX J08582765+1928511',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,134.61525,19.48075,0.085,NULL,63833303353,997395364,15584302,18),(58227,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58227,38.03,0.46,403,18750,70,NULL,NULL,'2MASX J08582765+6224217',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,134.615333,62.40617,0.169,NULL,62062972602,969733946,15152092,17.4),(58228,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58228,38.26,0.46,450,18751,70,NULL,NULL,'2MASX J08583013+1450454',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,134.625417,14.84589,0.101,NULL,63874085707,998032589,15594259,18.1),(58229,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58229,38.8,0.46,575,18752,70,NULL,NULL,'2MASX J08583016+1414354',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000164,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,134.62575,14.24319,0.081,NULL,63874475897,998038685,15594354,18.4),(58230,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58230,37.02,0.33,254,18753,70,NULL,NULL,'2MASX J08583109+0438314',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000155,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,134.6295417,4.64194,0.133,NULL,63632153096,994252392,15535193,16.9),(58231,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58231,36.19,0.46,173,18754,70,NULL,NULL,'MCG +08-17-001',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000158,NULL,'15.8g',0.42,'E0',NULL,NULL,NULL,NULL,1,134.6297083,45.27953,0.085,NULL,64290259045,1004535297,15695864,15.8),(58232,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58232,38.17,0.27,431,18755,70,NULL,NULL,'SDSS J085831.47+344201.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,134.631167,34.7005,0.045,NULL,64424106265,1006626660,15728541,18.1),(58233,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58233,37.91,0.11,382,18756,70,NULL,NULL,'2MASX J08583154+3830043',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,134.631291667,38.50122,0.065,NULL,64412310949,1006442358,15725661,17.7),(58234,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58234,37.8,0.27,364,18757,70,NULL,NULL,'2MASX J08583165+5536476',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000068,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,134.63175,55.61317,0.061,NULL,62009393956,968896780,15139012,17.7),(58235,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58235,35.03,0.59,101,18758,70,NULL,NULL,'ESO 564- G 002',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000103,NULL,'15.77',0.6,'S0-a',NULL,NULL,NULL,NULL,1,134.632416667,-22.48864,0.721,NULL,42348464768,661694762,10338980,15.77),(58236,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58236,37.26,0.46,283,18759,70,NULL,NULL,'2MASX J08583213+5112510',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000092,NULL,'16.2g',0.38,'NLAGN',NULL,NULL,NULL,'Sy 2',1,134.6337083,51.21431,0.037,NULL,64224504090,1003507876,15679810,16.2),(58237,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58237,37.53,0.46,320,18760,70,NULL,NULL,'2MASX J08583209+4421426',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000163,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,134.633833333,44.36194,0.065,NULL,64287424649,1004491010,15695172,16.8),(58238,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58238,35.44,0.4,123,18761,NULL,NULL,'mean','UGC 04698',NULL,'2007A&A...465...71T',2007,1,1.6,'The UZC position is for a superposed star 8\\\" west.','G',0.00002,NULL,'14.20',0.8,'SBab',NULL,NULL,NULL,NULL,1,134.636917,28.26725,0.085,NULL,64377444814,1005897575,15717149,14.2),(58239,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58239,35.52,0.47,127,18761,NULL,NULL,'H','UGC 04698',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58240,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58240,35.54,0.46,128,18761,NULL,NULL,'J','UGC 04698',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58241,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58241,35.55,0.45,129,18761,NULL,NULL,'K','UGC 04698',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58242,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58242,35.58,0.37,130,18761,NULL,NULL,'Malmquist cor.','UGC 04698',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58243,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58243,35.88,0.32,150,18761,NULL,NULL,NULL,'UGC 04698',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58244,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58244,35.92,0.2,153,18761,74.4,NULL,NULL,'UGC 04698',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58245,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58245,37.41,0.46,304,18762,70,NULL,NULL,'2MASX J08583306+0358504',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000185,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,134.637666667,3.98061,0.121,NULL,63635840563,994310008,15536093,17.5),(58246,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58246,37.78,0.46,360,18763,70,NULL,NULL,'2MASX J08583435+3108567',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000147,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,134.6432083,31.14919,0.041,NULL,64387117571,1006048712,15719511,17.7),(58247,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58247,37.4,0.46,302,18764,70,NULL,NULL,'2MASX J08583478+2612421',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000189,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,134.644708333,26.21175,0.101,NULL,64375034215,1005859909,15716561,16.3),(58248,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58248,37.79,0.19,361,18765,70,NULL,NULL,'2MASX J08583580+5417586',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000081,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,134.64925,54.29947,0.061,NULL,64223202866,1003487544,15679492,18.1),(58249,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58249,37.79,0.19,361,18766,70,NULL,NULL,'2MASX J08583580+5423106',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000077,NULL,'17.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,134.64925,54.38636,0.061,NULL,64223201320,1003487520,15679492,17),(58250,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58250,37.79,0.19,361,18767,70,NULL,NULL,'MCG +09-15-062',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000127,NULL,'15.4g',0.61,'BrClG',NULL,NULL,NULL,NULL,1,134.652166667,54.31736,0.061,NULL,64223203171,1003487549,15679492,15.4),(58251,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58251,37.16,0.46,270,18768,70,NULL,NULL,'SDSS J085837.07+370403.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000059,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,134.6545417,37.06761,0.105,NULL,64415223561,1006487868,15726372,17.8),(58252,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58252,37.76,0.33,356,18769,70,NULL,NULL,'SDSS J085837.63+373154.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,134.6567917,37.53192,0.097,NULL,64415982338,1006499724,15726558,18.5),(58253,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58253,37.35,0.46,294,18770,70,NULL,NULL,'2MASX J08583811+1602203',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,134.658833,16.03908,0.093,NULL,63884854962,998200858,15596888,17.4),(58254,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58254,37.81,0.46,364,18771,70,NULL,NULL,'2MASX J08583921+1238473',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000111,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,134.6635,12.64633,0.081,NULL,63841518649,997523728,15586308,18.4),(58255,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58255,38.52,0.46,505,18772,70,NULL,NULL,'2MASX J08583935+3903273',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,134.663791667,39.05775,0.033,NULL,64412876205,1006451190,15725799,17.6),(58256,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58256,37.91,0.11,382,18773,70,NULL,NULL,'2MASX J08583994+3833533',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000141,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,134.666416667,38.56478,0.065,NULL,64412319048,1006442485,15725663,18),(58257,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58257,37.86,0.46,374,18774,70,NULL,NULL,'2MASX J08584154+5012102',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000093,NULL,'16.5g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,134.673166667,50.20289,0.041,NULL,64239869506,1003747961,15683561,16.5),(58258,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58258,38.17,0.27,431,18775,70,NULL,NULL,'2MASX J08584294+3437367',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000185,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,134.6787917,34.62692,0.045,NULL,64422023230,1006594112,15728033,17.4),(58259,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58259,37.79,0.19,361,18776,70,NULL,NULL,'2MASX J08584324+5424206',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000102,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,134.680083,54.40567,0.061,NULL,64223208679,1003487635,15679494,16.3),(58260,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58260,38.28,0.46,452,18777,70,NULL,NULL,'2MASX J08584331+0302204',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,134.6805,3.03903,0.125,NULL,63621849731,994091402,15532678,17.7),(58261,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58261,37.71,0.46,348,18778,70,NULL,NULL,'2MASX J08584383+1749553',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000185,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,134.682625,17.83197,0.049,NULL,63884421083,998194079,15596782,17.2),(58262,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58262,35.62,NULL,133,18779,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0819',NULL,'2010Ap&SS.325..163P',2010,1,1.04,NULL,'G',0.000014,NULL,'17.0g',0.11,'Scd',NULL,NULL,NULL,NULL,1,134.684291667,31.11114,0.041,NULL,64387117285,1006048707,15719511,17),(58263,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58263,35.64,NULL,134,18779,NULL,NULL,'Dipole + Quadrupole','FGC 0819',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58264,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58264,35.66,NULL,135,18779,NULL,NULL,'Dipole','FGC 0819',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58265,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58265,35.74,NULL,141,18779,NULL,NULL,NULL,'FGC 0819',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58266,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58266,36.51,0.2,200,18779,74.4,NULL,NULL,'FGC 0819',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58267,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58267,36.42,0.46,192,18780,70,NULL,NULL,'2MASX J08584492+3909133',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000189,NULL,'16.0g',0.27,'E0',NULL,NULL,NULL,NULL,1,134.687166667,39.15364,0.053,NULL,64412896247,1006451503,15725804,16),(58268,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58268,37.91,0.11,382,18781,70,NULL,NULL,'2MASX J08584541+3831213',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000175,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,134.68925,38.52253,0.065,NULL,64412309461,1006442335,15725661,17.4),(58269,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58269,37.57,0.46,327,18782,70,NULL,NULL,'2MASX J08584567+3720323',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000148,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,134.690417,37.34239,0.105,NULL,64415267795,1006488559,15726383,17.2),(58270,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58270,37.91,0.11,382,18783,70,NULL,NULL,'2MASX J08584616+3839243',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.0001,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,134.692333,38.65672,0.065,NULL,64412313409,1006442397,15725662,17.6),(58271,'IRAS','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58271,33.06,0.8,40.9,18784,75,NULL,'MAT, I','NGC 2722',NULL,'1997ApJS..109..333W',1997,1,2,'MCG errata note that its declinations are +8 arcmin in error for this field.','G',0.00001,NULL,'13',1.3,'SA(rs)bc pec:  HII',NULL,NULL,NULL,NULL,1,134.692375,-3.71011,0.025,NULL,42160222803,658753481,10293023,13),(58272,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58272,32.16,0.69,27,18784,100,NULL,'mid-IR','NGC 2722',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58273,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58273,32.58,0.43,32.8,18784,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2722',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58274,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58274,32.64,0.32,33.7,18784,85,NULL,'I, raw','NGC 2722',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58275,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58275,32.66,0.32,34,18784,85,NULL,'I, inv','NGC 2722',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58276,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58276,32.72,0.43,35,18784,75,NULL,'3.6 micron, color corrected','NGC 2722',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58277,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58277,32.92,0.2,38.4,18784,74.4,NULL,NULL,'NGC 2722',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58278,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58278,32.95,0.43,39,18784,75,NULL,'MAT, I, raw','NGC 2722',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58279,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58279,33.09,0.43,41.5,18784,75,NULL,'MAT, I, inv','NGC 2722',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58280,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58280,33.18,0.51,43.2,18784,NULL,NULL,NULL,'NGC 2722',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58281,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58281,33.23,0.43,44.4,18784,75,NULL,'MAT, I, cor','NGC 2722',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58282,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58282,33.24,0.5,44.5,18784,NULL,NULL,'Malmquist cor.','NGC 2722',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58283,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58283,33.33,0.4,46.3,18784,NULL,NULL,'mean','NGC 2722',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58284,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58284,33.34,0.47,46.5,18784,NULL,NULL,'H','NGC 2722',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58285,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58285,33.38,0.46,47.4,18784,NULL,NULL,'J','NGC 2722',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58286,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58286,33.41,0.45,48,18784,NULL,NULL,'K','NGC 2722',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58287,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58287,38.03,0.46,404,18785,70,NULL,NULL,'2MASX J08584718+3256017',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,134.6967083,32.93389,0.053,NULL,64417232459,1006519257,15726863,17.2),(58288,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58288,36.75,0.46,224,18786,70,NULL,NULL,'2MASX J08584748+0150334',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000098,NULL,'16.5g',0.28,'NLAGN',NULL,NULL,NULL,NULL,1,134.697833333,1.84253,0.133,NULL,63622694561,994104602,15532884,16.5),(58289,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58289,38.13,0.46,423,18787,70,NULL,NULL,'2MASX J08584806+3446547',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000221,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,134.7002917,34.78186,0.049,NULL,64424112474,1006626757,15728543,17),(58290,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58290,37.79,0.19,361,18788,70,NULL,NULL,'2MASX J08584907+5423266',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000091,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,134.7044583,54.39064,0.061,NULL,64223213437,1003487709,15679495,16.9),(58291,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58291,37.5,0.33,316,18789,70,NULL,NULL,'2MASX J08584980+3507407',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,134.70775,35.12803,0.013,NULL,64424477681,1006632463,15728632,18),(58292,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58292,35.28,0.46,114,18790,70,NULL,NULL,'UGC 04702',NULL,'2015arXiv151105856S',2015,1,0.97,NULL,'G',0.00016,NULL,'14.4g',0.85,'S0?',NULL,NULL,NULL,NULL,1,134.7135417,38.8095,0.045,NULL,64412747331,1006449177,15725768,14.4),(58293,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58293,36.91,0.46,241,18791,70,NULL,NULL,'2MASX J08585173+4322088',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00018,NULL,'16.0g',0.43,'E0',NULL,NULL,NULL,NULL,1,134.715708333,43.36906,0.093,NULL,64276771840,1004324560,15692571,16),(58294,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58294,37.94,0.46,387,18792,70,NULL,NULL,'2MASX J08585210+3102567',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000183,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,134.717,31.04914,0.041,NULL,64387147222,1006049175,15719518,16.5),(58295,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58295,37.75,0.19,354,18793,70,NULL,NULL,'2MASX J08585303+4508158',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000137,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,134.72075,45.13772,0.077,NULL,64290137775,1004533402,15695834,17.9),(58296,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58296,36.77,0.46,226,18794,70,NULL,NULL,'2MASX J08585326+3238257',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,134.7220417,32.64061,0.025,NULL,64384723861,1006011310,15718926,17.5),(58297,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58297,36.88,0.46,238,18795,70,NULL,NULL,'2MASX J08585329+5420435',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00008,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,134.722333,54.34536,0.061,NULL,64223214648,1003487728,15679495,17.1),(58298,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58298,37.93,0.33,385,18796,70,NULL,NULL,'SDSS J085853.95+303720.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000152,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,134.724833,30.62239,0.045,NULL,64390600258,1006103129,15720361,18.6),(58299,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58299,37.86,0.15,373,18797,70,NULL,NULL,'2MASX J08585413+3928423',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,134.725583,39.47853,0.021,NULL,64412050471,1006438288,15725598,18.2),(58300,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58300,37.94,0.33,387,18798,70,NULL,NULL,'2MASX J08585512+1937094',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,134.729667,19.61908,0.061,NULL,63833280758,997395011,15584297,17.6),(58301,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58301,37.71,0.46,349,18799,70,NULL,NULL,'2MASX J08585642+3211017',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000147,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,134.7352083,32.18378,0.057,NULL,64386991690,1006046745,15719480,17.6),(58302,'IRAS','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58302,33.61,0.8,52.7,18800,75,NULL,'MAT, I','NGC 2721',NULL,'1997ApJS..109..333W',1997,1,2.3,'Declination in MCG is +8 arcmin in error.','G',0.00001,NULL,'12.5',1.6,'SB(rs)bc pec   HII',NULL,NULL,NULL,NULL,1,134.7355,-4.90194,0.061,NULL,42157640849,658713138,10292392,12.5),(58303,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58303,32.79,0.69,36.1,18800,100,NULL,'mid-IR','NGC 2721',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58304,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58304,33.61,0.43,52.7,18800,75,NULL,'MAT, I, raw','NGC 2721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58305,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58305,33.82,0.4,58,18800,NULL,NULL,'mean','NGC 2721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58306,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58306,33.85,0.45,58.9,18800,NULL,NULL,'K','NGC 2721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58307,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58307,33.86,0.47,59.1,18800,NULL,NULL,'H','NGC 2721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58308,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58308,33.87,0.43,59.3,18800,75,NULL,'MAT, I, inv','NGC 2721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58309,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58309,33.88,0.46,59.8,18800,NULL,NULL,'J','NGC 2721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58310,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58310,33.89,0.32,59.9,18800,85,NULL,'I, raw','NGC 2721',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58311,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58311,33.95,0.43,61.7,18800,75,NULL,'MAT, I, cor','NGC 2721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58312,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58312,33.95,0.32,61.8,18800,85,NULL,'I, inv','NGC 2721',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58313,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58313,34.08,0.2,65.5,18800,74.4,NULL,NULL,'NGC 2721',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58314,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58314,34.1,0.44,66.1,18800,NULL,NULL,'Malmquist cor.','NGC 2721',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58315,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58315,34.14,0.43,67.3,18800,NULL,NULL,NULL,'NGC 2721',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58316,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58316,37.34,0.46,294,18801,70,NULL,NULL,'2MASX J08585668+1929364',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,134.73625,19.49358,0.085,NULL,63833308270,997395441,15584303,17.5),(58317,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58317,37.85,0.46,372,18802,70,NULL,NULL,'2MASX J08585688+2345534',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,134.736917,23.76478,0.081,NULL,63820919133,997201861,15581279,17.1),(58318,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58318,37.91,0.11,382,18803,70,NULL,NULL,'2MASX J08585698+3819363',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,'PRED','16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,134.7374583,38.32694,0.073,NULL,64415732986,1006495827,15726497,16.9),(58319,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58319,36.69,0.33,218,18804,70,NULL,NULL,'2MASX J08585718+0126175',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000097,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,134.738125,1.43825,0.161,NULL,63619918393,994061224,15532206,16.7),(58320,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58320,36.79,0.46,228,18805,70,NULL,NULL,'2MASX J08585786+3102547',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000174,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,134.741,31.04858,0.041,NULL,64387148968,1006049202,15719518,16.5),(58321,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58321,38.01,0.15,400,18806,70,NULL,NULL,'2MASX J08585811+6236227',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00013,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,134.74225,62.60642,0.165,NULL,62062886325,969732598,15152071,18),(58322,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58322,37.79,0.19,361,18807,70,NULL,NULL,'2MASX J08585845+5421285',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000091,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,134.743625,54.35794,0.061,NULL,64223214785,1003487731,15679495,17),(58323,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58323,37.94,0.33,387,18808,70,NULL,NULL,'2MASX J08585887+1936354',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,134.7455,19.60978,0.061,NULL,63833281496,997395023,15584297,17.2),(58324,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58324,37.18,0.46,273,18809,70,NULL,NULL,'2MASX J08585896+0515345',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000154,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,134.745583333,5.25958,0.129,NULL,63632767316,994261989,15535343,16.9),(58325,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58325,29.71,0.4,8.7,18810,75,NULL,'B','UGC 04704',NULL,'1988NBGC.C....0000T',1988,1,4.14,'The position in 1984AnTok..192.595T is for a knot northwest of the center.','G',0.00002,NULL,'15.0',0.41,'Sdm',NULL,NULL,NULL,NULL,1,134.751167,39.20992,0.053,NULL,64412894815,1006451481,15725804,15),(58326,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58326,30.23,NULL,11.1,18810,NULL,NULL,NULL,'UGC 04704',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58327,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58327,30.32,NULL,11.6,18810,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04704',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58328,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58328,30.33,NULL,11.6,18810,NULL,NULL,'Dipole + Quadrupole','UGC 04704',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58329,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58329,30.34,NULL,11.7,18810,NULL,NULL,'Dipole','UGC 04704',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58330,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58330,30.91,NULL,15.2,18810,NULL,NULL,NULL,'UGC 04704',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58331,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58331,37.93,0.33,385,18811,70,NULL,NULL,'SDSS J085900.68+303534.7',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.00015,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,134.752875,30.59297,0.045,NULL,64390602596,1006103165,15720361,18.6),(58332,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58332,37.58,0.46,329,18812,70,NULL,NULL,'2MASX J08590159+1724126',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,134.7565417,17.40356,0.057,NULL,63883830860,998184857,15596638,16.4),(58333,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58333,37.68,0.46,343,18813,70,NULL,NULL,'2MASX J08590269+3445457',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000171,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,134.761333333,34.76272,0.045,NULL,64424055843,1006625872,15728529,17.5),(58334,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58334,37.5,0.33,316,18814,70,NULL,NULL,'2MASX J08590369+3503247',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,134.765375,35.05689,0.053,NULL,64424348869,1006630451,15728600,16.5),(58335,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58335,36.7,0.46,219,18815,70,NULL,NULL,'2MASX J08590446+1643306',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'16.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,134.7685,16.72528,0.049,NULL,63887607369,998243865,15597560,16.9),(58336,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58336,37.76,0.33,356,18816,70,NULL,NULL,'2MASX J08590516+3733123',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000149,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,134.7714583,37.55361,0.097,NULL,64415953298,1006499270,15726551,17.5),(58337,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58337,37.19,0.46,274,18817,70,NULL,NULL,'2MASX J08590555+0850116',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000174,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,134.77325,8.83675,0.121,NULL,63685493412,995085834,15548216,17.4),(58338,'IRAS','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58338,32.73,0.8,35.2,18818,75,NULL,'A82, H','NGC 2701',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000017,NULL,'12.73',1.6,'SAB(rs)c:','Field galaxy',NULL,NULL,NULL,1,134.773916667,53.77167,0.053,NULL,64224149417,1003502334,15679723,12.73),(58339,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58339,32.44,0.6,30.7,18818,NULL,NULL,'Malmquist cor.','NGC 2701',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58340,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58340,32.6,0.43,33.1,18818,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2701',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58341,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58341,32.62,0.38,33.4,18818,NULL,NULL,NULL,'NGC 2701',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58342,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58342,32.63,0.43,33.6,18818,75,NULL,'3.6 micron, color corrected','NGC 2701',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58343,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58343,32.7,0.2,34.7,18818,74.4,NULL,NULL,'NGC 2701',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58344,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58344,32.73,0.4,35.1,18818,75,NULL,'B','NGC 2701',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58345,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58345,32.83,0.5,36.9,18818,NULL,NULL,NULL,'NGC 2701',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58346,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58346,32.99,0.4,39.6,18818,NULL,NULL,'mean','NGC 2701',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58347,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58347,33.14,0.47,42.4,18818,75,NULL,'A82, H, raw','NGC 2701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58348,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58348,33.23,0.47,44.3,18818,75,NULL,'A82, H, inv','NGC 2701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58349,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58349,33.27,0.4,45.1,18818,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 2701',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58350,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58350,33.33,0.45,46.3,18818,NULL,NULL,'K','NGC 2701',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58351,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58351,33.34,0.46,46.5,18818,NULL,NULL,'J','NGC 2701',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58352,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58352,33.34,0.47,46.6,18818,NULL,NULL,'H','NGC 2701',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58353,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58353,33.44,0.47,48.7,18818,75,NULL,'A82, H, cor','NGC 2701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58354,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58354,36.69,0.33,218,18819,70,NULL,NULL,'2MASX J08590725+0126275',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000101,NULL,'16.0g',0.37,'E0',NULL,NULL,NULL,NULL,1,134.780083,1.441,0.161,NULL,63619918044,994061219,15532206,16),(58355,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58355,32.82,0.4,36.6,18820,75,NULL,NULL,'UGC 04696',NULL,'2008Ap.....51..336K',2008,1,1.3,NULL,'G',0.00002,NULL,'15.78',0.17,'Sd(f)',NULL,NULL,NULL,NULL,1,134.782541667,53.63239,0.033,NULL,64224141536,1003502211,15679722,15.78),(58356,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58356,33.48,0.49,49.6,18820,75,NULL,'IR','UGC 04696',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58357,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58357,33.67,NULL,54.1,18820,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04696',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58358,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58358,33.7,NULL,54.9,18820,NULL,NULL,'Dipole','UGC 04696',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58359,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58359,33.7,NULL,54.9,18820,NULL,NULL,'Dipole + Quadrupole','UGC 04696',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58360,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58360,36.94,0.46,244,18821,70,NULL,NULL,'2MASX J08590923-0010061',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000078,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,134.788417,-0.16842,0.125,NULL,39191640184,612369377,9568271,17.1),(58361,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58361,36.69,0.46,218,18822,70,NULL,NULL,'MCG +09-15-065',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000109,NULL,'15.4g',0.51,'E0',NULL,NULL,NULL,NULL,1,134.79975,54.04306,0.057,NULL,64223387719,1003490433,15679538,15.4),(58362,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58362,37.21,0.46,277,18823,70,NULL,NULL,'2MASX J08591260+1231226',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,134.802625,12.52303,0.081,NULL,63841562297,997524410,15586318,17.5),(58363,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58363,37.76,0.46,356,18824,70,NULL,NULL,'2MASX J08591286+2747337',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000146,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,134.8035417,27.79281,0.081,NULL,64378262485,1005910351,15717349,18.2),(58364,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58364,37.01,0.46,252,18825,70,NULL,NULL,'2MASX J08591347+6529316',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'17.32',0.34,NULL,NULL,NULL,NULL,NULL,1,134.805708333,65.49208,0.145,NULL,62264224490,972878507,15201226,17.32),(58365,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58365,33.44,NULL,48.7,18826,NULL,NULL,NULL,'FGC 0821',NULL,'2000BSAO...50....5K',2000,1,0.9,NULL,'G',0.000047,NULL,'16.9',0.1,'Sdm',NULL,NULL,NULL,NULL,1,134.81,-4.88028,0.061,NULL,42157761751,658715027,10292422,16.9),(58366,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58366,33.48,NULL,49.6,18826,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0821',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58367,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58367,33.5,NULL,50.2,18826,NULL,NULL,'Dipole + Quadrupole','FGC 0821',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58368,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58368,33.51,NULL,50.2,18826,NULL,NULL,'Dipole','FGC 0821',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58369,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58369,37.86,0.15,373,18827,70,NULL,NULL,'2MASX J08591487+3927131',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,134.811875,39.45369,0.021,NULL,64412024639,1006437884,15725591,17.7),(58370,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58370,36.53,0.46,202,18828,70,NULL,NULL,'2MASX J08591541+3628041',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000161,NULL,'16.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,134.814125,36.46797,0.097,NULL,64420855199,1006575862,15727747,16.4),(58371,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58371,36.05,0.46,162,18829,70,NULL,NULL,'2MASX J08591579+3941071',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000174,NULL,'15.7g',0.35,'E0',NULL,NULL,NULL,NULL,1,134.8159583,39.68533,0.073,NULL,64412164059,1006440063,15725625,15.7),(58372,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58372,37.46,0.46,311,18830,70,NULL,NULL,'2MASX J08591620+5625232',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000073,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,134.817333,56.42317,0.109,NULL,62012701729,968948464,15139819,17.6),(58373,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58373,36.53,0.46,203,18831,70,NULL,NULL,'2MASX J08591660+0740286',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000187,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,134.819166667,7.67456,0.181,NULL,63682779474,995043429,15547553,17.2),(58374,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58374,37.88,0.46,376,18832,70,NULL,NULL,'2MASX J08591784+2356087',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,134.8242917,23.93586,0.097,NULL,63821355646,997208681,15581385,17.2),(58375,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58375,37.92,0.46,383,18833,70,NULL,NULL,'2MASX J08591822+2148133',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000175,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,134.825916667,21.80364,0.081,NULL,63835771503,997433929,15584905,17.1),(58376,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58376,38.04,0.46,405,18834,70,NULL,NULL,'SDSS J085918.70+110821.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,134.827958333,11.13931,0.105,NULL,63670356543,994849320,15544520,17.8),(58377,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58377,37.77,0.21,358,18835,70,NULL,NULL,'SDSS J085920.16+241555.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,134.8340417,24.26531,0.089,NULL,63821488960,997210765,15581418,18),(58378,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58378,36.76,0.33,225,18836,70,NULL,NULL,'2MASX J08592030+1723160',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'16.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,134.834583,17.38792,0.057,NULL,63883830104,998184845,15596638,16.5),(58379,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58379,38.35,0.46,467,18837,70,NULL,NULL,'SDSS J085920.29+371623.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,134.834583,37.27328,0.105,NULL,64415245228,1006488206,15726378,18.8),(58380,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58380,38.34,0.46,465,18838,70,NULL,NULL,'2MASX J08592091+2612527',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,134.8372917,26.21475,0.093,NULL,64375060321,1005860317,15716567,17.8),(58381,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58381,38.56,0.46,514,18839,70,NULL,NULL,'2MASX J08592210+2221563',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000153,NULL,'18.7g',0.09,NULL,NULL,NULL,NULL,NULL,1,134.8419583,22.36572,0.081,NULL,63823724428,997245694,15581963,18.7),(58382,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58382,37.6,0.46,332,18840,70,NULL,NULL,'2MASX J08592247+1844303',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000171,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,134.843625,18.74167,0.085,NULL,63881359719,998146245,15596035,17.5),(58383,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58383,32.83,NULL,36.8,18841,NULL,NULL,NULL,'UGC 04712',NULL,'2015AstBu..70....1K',2015,1,1,NULL,'G',0.000133,NULL,'15.2',0.25,'S',NULL,NULL,NULL,NULL,1,134.848333,11.13528,0.105,NULL,63670367595,994849493,15544523,15.2),(58384,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58384,38.28,0.46,453,18842,70,NULL,NULL,'2MASX J08592387+6159346',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,134.849083333,61.99297,0.165,NULL,62062287328,969723239,15151925,17.9),(58385,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58385,37.61,0.46,333,18843,70,NULL,NULL,'SDSS J085925.10+643920.7',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.6g',0.09,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,134.854583,64.65575,0.113,NULL,62261121015,972830015,15200468,18.6),(58386,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58386,37.86,0.15,373,18844,70,NULL,NULL,'2MASX J08592532+3921092',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,134.855667,39.35267,0.053,NULL,64412878755,1006451230,15725800,17.7),(58387,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58387,37.43,0.46,306,18845,70,NULL,NULL,'2MASX J08592584+4604193',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000186,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,134.85775,46.07208,0.053,NULL,64286922696,1004483167,15695049,16.3),(58388,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58388,37.86,0.15,373,18846,70,NULL,NULL,'2MASX J08592670+3931162',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000083,NULL,'17.0g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,134.8612083,39.52103,0.021,NULL,64412014943,1006437733,15725589,17),(58389,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58389,38.19,0.46,434,18847,70,NULL,NULL,'2MASX J08592749+3942462',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,134.864583,39.71275,0.073,NULL,64412161970,1006440030,15725625,18.1),(58390,'Tully est','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58390,32.28,0.8,28.6,18848,75,NULL,'B','NGC 2712',NULL,'1988NBGC.C....0000T',1988,1,2.9,'The 2MASXi position is 5 arcsec southwest of the nucleus.','G',0.000017,NULL,'12.75',1.6,'SB(r)b:','Isolated galaxy',NULL,NULL,NULL,1,134.876958333,44.91389,0.037,NULL,64290112987,1004533015,15695828,12.75),(58391,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58391,31.34,0.69,18.6,18848,100,NULL,'mid-IR','NGC 2712',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58392,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58392,32.16,NULL,27,18848,NULL,NULL,'B','NGC 2712',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58393,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58393,32.43,0.43,30.6,18848,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2712',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58394,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58394,32.44,0.49,30.7,18848,NULL,NULL,'Malmquist cor.','NGC 2712',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58395,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58395,32.44,0.4,30.8,18848,NULL,NULL,'mean','NGC 2712',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58396,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58396,32.45,0.4,30.9,18848,NULL,NULL,NULL,'NGC 2712',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58397,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58397,32.48,0.43,31.3,18848,75,NULL,'3.6 micron, color corrected','NGC 2712',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58398,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58398,32.53,0.2,32.1,18848,74.4,NULL,NULL,'NGC 2712',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58399,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58399,32.59,0.46,33,18848,NULL,NULL,'J','NGC 2712',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58400,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58400,32.59,0.45,33,18848,NULL,NULL,'K','NGC 2712',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58401,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58401,32.6,0.47,33.2,18848,NULL,NULL,'H','NGC 2712',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58402,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58402,32.61,0.45,33.3,18848,NULL,NULL,NULL,'NGC 2712',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58403,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58403,36.48,0.33,198,18849,70,NULL,NULL,'SDSS J085931.38+173253.6',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'16.8g',0.27,'AGN',NULL,NULL,NULL,NULL,1,134.8807917,17.54822,0.053,NULL,63884279518,998191867,15596747,16.8),(58404,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58404,37.86,0.15,373,18850,70,NULL,NULL,'2MASX J08593232+3931522',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,134.884667,39.53111,0.021,NULL,64412132969,1006439577,15725618,17.7),(58405,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58405,38.35,0.46,467,18851,70,NULL,NULL,'SDSS J085933.22+020311.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00006,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,134.888458333,2.05328,0.133,NULL,63623359795,994114996,15533046,18.8),(58406,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58406,37.9,0.33,380,18852,70,NULL,NULL,'SDSS J085934.04+014113.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000091,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,134.891833333,1.68706,0.145,NULL,63623143888,994111623,15532994,18.1),(58407,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58407,37.86,0.46,373,18853,70,NULL,NULL,'2MASX J08593405+0548341',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00017,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,134.891875,5.80953,0.125,NULL,63631815201,994247112,15535111,17.2),(58408,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58408,37.75,0.19,354,18854,70,NULL,NULL,'2MASX J08593423+4523144',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,134.892333,45.38739,0.069,NULL,64290051197,1004532049,15695813,17.6),(58409,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58409,38.16,0.46,429,18855,70,NULL,NULL,'SDSS J085935.13+161433.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,134.896417,16.24258,0.085,NULL,63886763526,998230680,15597354,17.9),(58410,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58410,37.9,0.33,380,18856,70,NULL,NULL,'SDSS J085935.16+014237.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000089,NULL,'18.6g',0.09,NULL,NULL,NULL,NULL,NULL,1,134.896541667,1.71047,0.145,NULL,63623144392,994111631,15532994,18.6),(58411,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58411,37.77,0.21,358,18857,70,NULL,NULL,'2MASX J08593574+2412306',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000191,NULL,'16.7g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,134.898875,24.20844,0.089,NULL,63821570422,997212037,15581438,16.7),(58412,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58412,36.76,0.33,225,18858,70,NULL,NULL,'SDSS J085936.77+173110.7',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.2g',0.32,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,134.903208333,17.51967,0.053,NULL,63884275904,998191811,15596747,16.2),(58413,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58413,36.45,0.46,195,18859,70,NULL,NULL,'2MASX J08593693+2831446',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,134.904,28.529,0.061,NULL,64377346408,1005896037,15717125,17),(58414,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58414,37.03,0.33,254,18860,70,NULL,NULL,'SDSS J085937.55+142651.1',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000136,NULL,'16.9g',0.24,'AGN',NULL,NULL,NULL,NULL,1,134.9064583,14.44756,0.081,NULL,63875019611,998047181,15594487,16.9),(58415,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58415,34.87,0.46,94.4,18861,70,NULL,NULL,'2MASX J08593852+5652442',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00007,NULL,'15.6g',0.45,'E',NULL,NULL,NULL,NULL,1,134.910417,56.87889,0.117,NULL,62011797385,968934334,15139598,15.6),(58416,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58416,37.32,0.46,291,18862,70,NULL,NULL,'2MASX J08593900+1933515',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,134.912625,19.56436,0.081,NULL,63833279061,997394985,15584296,18.1),(58417,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58417,37.77,0.21,358,18863,70,NULL,NULL,'2MASX J08594020+2412456',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000175,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,134.9175,24.21275,0.089,NULL,63821573940,997212092,15581438,16.9),(58418,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58418,37.03,0.33,254,18864,70,NULL,NULL,'2MASX J08594108+1426410',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000139,NULL,'17.4g',0.21,'AGN',NULL,NULL,NULL,NULL,1,134.921125,14.44464,0.081,NULL,63875011711,998047057,15594485,17.4),(58419,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58419,37.97,0.46,392,18865,70,NULL,NULL,'2MASX J08594240+5347015',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000086,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,134.926417,53.78378,0.057,NULL,64224135480,1003502116,15679720,17.6),(58420,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58420,37.68,0.46,343,18866,70,NULL,NULL,'2MASX J08594308+2203385',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,134.929416667,22.06056,0.085,NULL,63821843793,997216309,15581504,17.5),(58421,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58421,37.26,0.46,283,18867,70,NULL,NULL,'2MASX J08594515+3240282',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000185,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,134.938291667,32.6745,0.025,NULL,64384665952,1006010405,15718912,16.8),(58422,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58422,37.86,0.15,373,18868,70,NULL,NULL,'2MASX J08594585+3917523',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000139,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,134.940958333,39.29792,0.053,NULL,64412879313,1006451239,15725800,18),(58423,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58423,37.83,0.46,367,18869,70,NULL,NULL,'SDSS J085947.62+090156.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,134.9484583,9.03242,0.141,NULL,63685323135,995083173,15548174,18.1),(58424,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58424,37.77,0.21,358,18870,70,NULL,NULL,'2MASX J08594816+2401119',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,134.9505417,24.02014,0.097,NULL,63821357876,997208716,15581386,17.7),(58425,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58425,31.99,0.69,25,18871,100,NULL,'mid-IR','NGC 2710',NULL,'2013ApJ...771...88L',2013,1,2,NULL,'G',0.000013,NULL,'13.66',1,'SB(rs)b','Field galaxy',NULL,NULL,NULL,1,134.9514583,55.70639,0.061,NULL,62009441799,968897528,15139023,13.66),(58426,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58426,33.09,0.43,41.4,18871,75,NULL,'3.6 micron, color corrected','NGC 2710',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58427,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58427,33.11,0.2,41.9,18871,74.4,NULL,NULL,'NGC 2710',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58428,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58428,33.11,0.43,41.9,18871,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2710',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58429,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58429,33.21,0.4,43.8,18871,NULL,NULL,'mean','NGC 2710',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58430,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58430,33.56,0.46,51.5,18871,NULL,NULL,'J','NGC 2710',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58431,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58431,33.58,0.45,52,18871,NULL,NULL,'K','NGC 2710',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58432,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58432,33.67,0.47,54.3,18871,NULL,NULL,'H','NGC 2710',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58433,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58433,37.07,0.46,260,18872,70,NULL,NULL,'2MASX J08594849+5803281',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000077,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,134.95225,58.05786,0.141,NULL,62025110661,969142354,15142849,16.7),(58434,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58434,37.99,0.46,397,18873,70,NULL,NULL,'2MASX J08594981+3635153',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000148,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,134.95775,36.58767,0.097,NULL,64413237504,1006456836,15725888,17.5),(58435,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58435,37.65,0.27,339,18874,70,NULL,NULL,'2MASX J08595042+5306265',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000081,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,134.959917,53.10728,0.045,NULL,64223985173,1003499768,15679683,17.2),(58436,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58436,37.26,0.46,283,18875,70,NULL,NULL,'2MASX J08595067+5550231',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000071,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,134.961125,55.83967,0.069,NULL,62009378458,968896538,15139008,17.2),(58437,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58437,37.88,0.46,376,18876,70,NULL,NULL,'2MASX J08595104+3310522',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,134.9625417,33.18128,0.045,NULL,64421405549,1006584461,15727882,17.6),(58438,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58438,36.76,0.46,225,18877,70,NULL,NULL,'2MASX J08595152+5144475',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000102,NULL,'16.1g',0.41,'E0',NULL,NULL,NULL,NULL,1,134.964583,51.74664,0.033,NULL,64226588300,1003540442,15680319,16.1),(58439,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58439,37.65,0.27,339,18878,70,NULL,NULL,'2MASX J08595256+5315475',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000085,NULL,'17.4g',0.18,'NLAGN',NULL,NULL,NULL,'Sy 2',1,134.969125,53.26325,0.061,NULL,64224033462,1003500522,15679695,17.4),(58440,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58440,38.03,0.46,404,18879,70,NULL,NULL,'2MASX J08595264+5628421',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000068,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,134.969417,56.47817,0.109,NULL,62011818109,968934657,15139604,17.7),(58441,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58441,35.51,0.46,126,18880,70,NULL,NULL,'2MASX J08595302+5107024',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000066,NULL,'16.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,134.9712083,51.11722,0.041,NULL,64238911922,1003732998,15683328,16.6),(58442,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58442,37.42,0.46,305,18881,70,NULL,NULL,'2MASX J08595342+2155015',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,134.9724583,21.91725,0.085,NULL,63836273469,997441772,15585027,17.9),(58443,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58443,35.66,0.46,135,18882,70,NULL,NULL,'2MASX J08595371+2415309',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000153,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,134.9737917,24.25861,0.089,NULL,63821518774,997211230,15581425,16.2),(58444,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58444,34.25,0.2,70.8,18883,74.4,NULL,NULL,'MCG -01-23-016',NULL,'2013AJ....146...86T',2013,1,1.5,'MCG notes say that dec. for MCG -01-23 zone is off by 8\'.','G',0.000034,NULL,'15',1.1,'SB(rs)bc:',NULL,NULL,NULL,NULL,1,134.974208333,-7.41692,0.049,NULL,42208131903,659502060,10304719,15),(58445,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58445,34.43,0.38,76.8,18883,NULL,NULL,NULL,'MCG -01-23-016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58446,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58446,34.47,0.37,78.5,18883,NULL,NULL,'Malmquist cor.','MCG -01-23-016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58447,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58447,37.03,0.46,254,18884,70,NULL,NULL,'2MASX J08595560+3029252',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,134.981625,30.49022,0.045,NULL,64390744724,1006105386,15720396,16.9),(58448,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58448,37.77,0.21,358,18885,70,NULL,NULL,'2MASX J08595590+2401249',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'17.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,134.9830417,24.02372,0.097,NULL,63821357234,997208706,15581386,17.9),(58449,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58449,38.14,0.46,424,18886,70,NULL,NULL,'2MASX J08595643+5711257',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00008,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,134.9849583,57.19053,0.113,NULL,62024373310,969130832,15142669,17.6),(58450,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58450,37.55,0.46,323,18887,70,NULL,NULL,'SDSS J085956.40+045458.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000134,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,134.9850417,4.91614,0.113,NULL,63632625222,994259769,15535308,18.4),(58451,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58451,37.75,0.19,354,18888,70,NULL,NULL,'2MASX J08595728+4519394',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000178,NULL,'15.8g',0.44,'E0',NULL,NULL,NULL,NULL,1,134.9887083,45.32756,0.069,NULL,64290079576,1004532493,15695820,15.8),(58452,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58452,38.07,0.46,412,18889,70,NULL,NULL,'2MASX J08595943+4534123',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000172,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,134.997417,45.56992,0.073,NULL,64290042645,1004531916,15695811,16.7),(58453,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58453,37.08,0.33,260,18890,70,NULL,NULL,'2MASX J09000055+1635377',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,135.00225,16.59375,0.061,NULL,63887578115,998243408,15597553,17.2),(58454,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58454,35.92,0.46,153,18891,70,NULL,NULL,'2MASX J09000055+3954574',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000168,NULL,'16.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,135.0022917,39.91589,0,NULL,64411979540,1006437180,15725580,16.5),(58455,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58455,38.08,0.21,412,18892,70,NULL,NULL,'2MASX J09000069+1445137',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,135.002958333,14.75381,0.113,NULL,63874990300,998046723,15594480,17.9),(58456,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58456,37.75,0.19,354,18893,70,NULL,NULL,'2MASX J09000121+4508083',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000133,NULL,'16.6g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,135.005083,45.13578,0.029,NULL,64290291512,1004535804,15695871,16.6),(58457,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58457,37.72,0.46,350,18894,70,NULL,NULL,'SDSS J090002.51+390223.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,135.0104583,39.03989,0.025,NULL,64412974207,1006452721,15725823,18.4),(58458,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58458,38.12,0.46,420,18895,70,NULL,NULL,'2MASX J09000443+3252221',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,135.018667,32.87283,0.029,NULL,64421378745,1006584042,15727875,17.3),(58459,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58459,37.86,0.15,373,18896,70,NULL,NULL,'2MASX J09000566+3919214',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,135.023708333,39.32272,0.021,NULL,64412910326,1006451723,15725808,18),(58460,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58460,37.86,0.15,373,18897,70,NULL,NULL,'2MASX J09000644+3918214',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000177,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,135.027,39.30586,0.021,NULL,64412912919,1006451764,15725808,18.5),(58461,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58461,38.21,0.46,440,18898,70,NULL,NULL,'2MASX J09000743+4200376',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000179,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,135.030833,42.01053,0.025,NULL,64274314651,1004286166,15691971,17.2),(58462,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58462,38.11,0.46,418,18899,70,NULL,NULL,'SDSS J090007.67+274419.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000152,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,135.0319583,27.73861,0.085,NULL,64378370321,1005912036,15717375,18.5),(58463,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58463,36.1,0.5,166,18900,70,NULL,NULL,'2MASX J09000936-0713590',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.17',0.4,NULL,NULL,NULL,NULL,NULL,1,135.039,-7.23325,0.045,NULL,42208314992,659504921,10304764,16.17),(58464,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58464,38.08,0.21,412,18901,70,NULL,NULL,'2MASX J09000992+1442047',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,135.0412917,14.70119,0.113,NULL,63874992535,998046758,15594480,18.3),(58465,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58465,37.29,0.33,288,18902,70,NULL,NULL,'2MASX J09001027+3023167',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000178,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,135.04275,30.38797,0.045,NULL,64390910531,1006107977,15720437,16.7),(58466,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58466,37.11,0.46,265,18903,70,NULL,NULL,'2MASX J09001054+4607366',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000155,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,135.043875,46.12686,0.053,NULL,64286935380,1004483365,15695052,16.9),(58467,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58467,38.4,0.46,479,18904,70,NULL,NULL,'SDSS J090010.64+512238.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000085,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,135.044375,51.37728,0.037,NULL,64226333829,1003536466,15680257,18.3),(58468,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58468,35.46,0.49,123,18905,70,NULL,NULL,'2MASX J09001068-1144120',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,135.0444583,-11.73661,0.145,NULL,42194905860,659295404,10301490,14.2),(58469,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58469,37.98,0.46,395,18906,70,NULL,NULL,'SDSS J090011.11+351319.0',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000179,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,135.046333333,35.22197,0.053,NULL,64424498254,1006632785,15728637,18.7),(58470,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58470,33.55,0.2,51.3,18907,74.4,NULL,NULL,'UGC 04697',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000037,NULL,'16.0',0.3,'SBcd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,135.05125,70.01972,0.085,NULL,62223288642,972238885,15191232,16),(58471,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58471,33.66,0.39,53.9,18907,NULL,NULL,'Malmquist cor.','UGC 04697',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58472,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58472,33.68,0.39,54.5,18907,NULL,NULL,NULL,'UGC 04697',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58473,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58473,38.08,0.21,412,18908,70,NULL,NULL,'2MASX J09001323+1443516',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00019,NULL,'16.7g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,135.055083,14.73089,0.113,NULL,63874879174,998044987,15594452,16.7),(58474,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58474,37.84,0.46,369,18909,70,NULL,NULL,'2MASX J09001365+5539408',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000094,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,135.056667,55.66136,0.061,NULL,62009427964,968897311,15139020,17.1),(58475,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58475,37.65,0.27,339,18910,70,NULL,NULL,'2MASX J09001478+5304059',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000084,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,135.061833,53.06828,0.045,NULL,64223984474,1003499757,15679683,16.7),(58476,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58476,38.2,0.46,436,18911,70,NULL,NULL,'2MASX J09001513+1359224',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000143,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,135.063167,13.9895,0.113,NULL,63874666291,998041660,15594400,18.1),(58477,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58477,33.37,0.49,47.2,18912,75,NULL,'IR','NGC 2719',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000013,NULL,'14',0.3,'Im pec?','Pair member (points to parent)',NULL,NULL,NULL,1,135.064417,35.72764,0.073,NULL,64423934016,1006623969,15728499,14),(58478,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58478,35.42,0.67,121,18913,70,NULL,NULL,'ESO 060- G 022',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'15.49',0.4,'Sb:',NULL,NULL,NULL,NULL,1,135.065583,-69.94394,0.337,NULL,40748455304,636694614,9948353,15.49),(58479,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58479,36.34,0.46,186,18914,70,NULL,NULL,'2MASX J09001750+5420238',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000098,NULL,'15.9g',0.38,'E0',NULL,NULL,NULL,NULL,1,135.072917,54.33992,0.057,NULL,64223227199,1003487924,15679498,15.9),(58480,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58480,37.05,0.33,257,18915,70,NULL,NULL,'CGCG 033-040',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000218,NULL,'15.4g',0.52,'E0',NULL,NULL,NULL,NULL,1,135.075667,7.75986,0.205,NULL,63685921624,995092525,15548320,15.4),(58481,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58481,36.99,0.46,250,18916,70,NULL,NULL,'2MASX J09001855+2109476',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000168,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,135.0772917,21.16308,0.065,NULL,63837128619,997455134,15585236,16.8),(58482,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58482,36.7,0.46,219,18917,70,NULL,NULL,'2MASX J09001876+1248094',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000096,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,135.07825,12.80253,0.061,NULL,63871101612,997985962,15593530,17.5),(58483,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58483,37.43,0.46,307,18918,70,NULL,NULL,'2MASX J09001886+2609399',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00014,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,135.0785,26.16111,0.093,NULL,64374263083,1005847860,15716372,17.4),(58484,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58484,35.9,0.2,151,18919,74.4,NULL,NULL,'UGC 04713',NULL,'2013AJ....146...86T',2013,1,1.39,NULL,'G',0.000023,NULL,'13.6g',1.04,'Sb             AGN','Brightest group member',NULL,NULL,NULL,1,135.084416667,52.49422,0.009,NULL,64227332847,1003552075,15680501,13.6),(58485,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58485,36.49,0.46,199,18920,70,NULL,NULL,'2MASX J09002182+0532222',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000152,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,135.091,5.53967,0.129,NULL,63631987509,994249804,15535153,16.9),(58486,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58486,37.86,0.46,373,18921,70,NULL,NULL,'2MASX J09002249+3955371',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000178,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,135.093625,39.92694,0,NULL,64411970390,1006437037,15725578,16.9),(58487,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58487,37.86,0.15,373,18922,70,NULL,NULL,'2MASX J09002252+3920511',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000171,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,135.09375,39.34739,0.021,NULL,64412798404,1006449975,15725780,17.9),(58488,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58488,31.98,NULL,24.9,18923,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04722',NULL,'2010Ap&SS.325..163P',2010,1,1.57,'Multiple SDSS entries describe this object.','G',0.000023,NULL,'15.16',0.22,'Sdm','Isolated galaxy',NULL,NULL,NULL,1,135.098083333,25.61128,0.093,NULL,64374206644,1005846978,15716359,15.16),(58489,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58489,32,NULL,25.2,18923,NULL,NULL,'Dipole + Quadrupole','UGC 04722',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58490,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58490,32.02,NULL,25.4,18923,NULL,NULL,'Dipole','UGC 04722',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58491,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58491,32.34,NULL,29.4,18923,NULL,NULL,NULL,'UGC 04722',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58492,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58492,37.75,0.19,354,18924,70,NULL,NULL,'SDSS J090023.63+450100.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000124,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,135.0985,45.01667,0.037,NULL,64290234241,1004534910,15695857,18.4),(58493,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58493,37,0.46,251,18925,70,NULL,NULL,'2MASX J09002373+3227567',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,135.0989583,32.46569,0.025,NULL,64386817350,1006044021,15719437,17.6),(58494,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58494,38.92,0.33,608,18926,70,NULL,NULL,'SDSS J090024.45+354652.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,135.101916667,35.78131,0.073,NULL,64423927108,1006623861,15728497,18.4),(58495,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58495,37.68,0.46,344,18927,70,NULL,NULL,'2MASX J09002474+1528203',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,135.103125,15.47217,0.093,NULL,63872179015,998002797,15593793,16.3),(58496,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58496,37.94,0.33,387,18928,70,NULL,NULL,'2MASX J09002592+1918082',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,135.1079583,19.30231,0.085,NULL,63833354688,997396167,15584315,17.7),(58497,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58497,38.01,0.15,400,18929,70,NULL,NULL,'2MASX J09002609+6237455',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,135.1085417,62.62944,0.181,NULL,62062904476,969732882,15152076,18.3),(58498,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58498,37.16,0.46,271,18930,70,NULL,NULL,'2MASX J09002614+1555013',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,135.108875,15.91711,0.101,NULL,63886619354,998228427,15597319,17.7),(58499,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58499,37.08,0.33,260,18931,70,NULL,NULL,'2MASX J09002631+1638413',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,135.109667,16.64483,0.061,NULL,63887598082,998243720,15597558,16.9),(58500,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58500,37.94,0.33,387,18932,70,NULL,NULL,'2MASX J09002719+1918052',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00019,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,135.11325,19.30153,0.085,NULL,63833354585,997396165,15584315,17.1),(58501,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58501,37.8,0.46,363,18933,70,NULL,NULL,'2MASX J09002795+3142577',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'17.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,135.116583,31.71608,0.013,NULL,64387644148,1006056939,15719639,17.2),(58502,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58502,38.01,0.46,400,18934,70,NULL,NULL,'2MASX J09002867+3711102',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000116,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,135.119583,37.18633,0.105,NULL,64415325500,1006489460,15726397,17.4),(58503,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58503,38.08,0.21,412,18935,70,NULL,NULL,'2MASX J09002988+1441213',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,135.124667,14.68939,0.109,NULL,63874890057,998045157,15594455,17.5),(58504,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58504,36.95,0.33,246,18936,70,NULL,NULL,'2MASX J09003066+0818070',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000174,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,135.1277083,8.302,0.201,NULL,63686136677,995095885,15548373,16.6),(58505,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58505,37.37,0.46,298,18937,70,NULL,NULL,'2MASX J09003067+5110039',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000088,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,135.128,51.16783,0.037,NULL,64225806046,1003528219,15680128,17),(58506,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58506,37.98,0.46,394,18938,70,NULL,NULL,'2MASX J09003145+5159209',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000082,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,135.1309583,51.98903,0.025,NULL,64226411888,1003537685,15680276,16.9),(58507,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58507,36.05,0.46,162,18939,70,NULL,NULL,'2MASX J09003181+0914340',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000175,NULL,'15.8g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,135.132458333,9.24286,0.133,NULL,63672157197,994877456,15544960,15.8),(58508,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58508,33.85,NULL,58.9,18940,NULL,NULL,'Dipole','ESO 496- G 025',NULL,'2010Ap&SS.325..163P',2010,1,1.85,NULL,'G',0.00008,NULL,'16.97',0.2,'Sc',NULL,NULL,NULL,NULL,1,135.132917,-25.235,0.829,NULL,42312139825,661127184,10330112,16.97),(58509,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58509,33.86,NULL,59.2,18940,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 496- G 025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58510,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58510,33.86,NULL,59.3,18940,NULL,NULL,'Dipole + Quadrupole','ESO 496- G 025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58511,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58511,37.35,0.27,295,18941,70,NULL,NULL,'LCSB S1223N',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'17.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,135.138458333,16.23558,0.097,NULL,63886676617,998229322,15597333,17.6),(58512,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58512,37.98,0.27,394,18942,70,NULL,NULL,'2MASX J09003376+0842350',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,135.140583,8.70961,0.157,NULL,63685488270,995085754,15548214,17.6),(58513,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58513,35.74,0.53,141,18943,70,NULL,NULL,'2MASX J09003464-7304252',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,135.144375,-73.07372,0.389,NULL,40736031132,636500486,9945320,16.3),(58514,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58514,34.45,0.46,77.7,18944,70,NULL,NULL,'ARK 190',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000145,NULL,'14.8g',0.47,'Compact',NULL,NULL,NULL,NULL,1,135.1502917,46.6865,0.049,NULL,64286263248,1004472863,15694888,14.8),(58515,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58515,37.4,0.46,302,18945,70,NULL,NULL,'2MASX J09003713+2847279',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000184,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,135.154875,28.79111,0.065,NULL,64375493396,1005867084,15716673,16.5),(58516,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58516,37.57,0.46,326,18946,70,NULL,NULL,'SDSS J090037.90+031353.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,135.1579583,3.23153,0.125,NULL,63634461574,994288462,15535757,18.5),(58517,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58517,34.19,0.46,68.8,18947,NULL,NULL,'J','UGC 04719',NULL,'2007A&A...465...71T',2007,1,3.31,NULL,'G',0.000037,NULL,'14.2g',0.39,'Sb(f)','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,135.159,50.67839,0.045,NULL,64239131299,1003736426,15683381,14.2),(58518,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58518,34.22,0.47,69.8,18947,NULL,NULL,'H','UGC 04719',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58519,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58519,34.22,0.49,69.9,18947,75,NULL,'IR','UGC 04719',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58520,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58520,34.28,0.45,71.9,18947,NULL,NULL,'K','UGC 04719',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58521,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58521,34.28,0.4,71.9,18947,NULL,NULL,'mean','UGC 04719',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58522,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58522,34.38,0.45,75.2,18947,NULL,NULL,'Malmquist cor.','UGC 04719',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58523,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58523,34.39,NULL,75.4,18947,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04719',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58524,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58524,34.39,NULL,75.5,18947,NULL,NULL,'Dipole','UGC 04719',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58525,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58525,34.39,NULL,75.6,18947,NULL,NULL,'Dipole + Quadrupole','UGC 04719',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58526,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58526,34.53,NULL,80.4,18947,NULL,NULL,NULL,'UGC 04719',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58527,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58527,34.67,0.4,85.8,18947,NULL,NULL,NULL,'UGC 04719',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58528,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58528,34.71,0.2,87.5,18947,74.4,NULL,NULL,'UGC 04719',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58529,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58529,37.1,0.46,263,18948,70,NULL,NULL,'2MASX J09003845+4404386',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00016,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,135.160125,44.0775,0.057,NULL,64288728838,1004511388,15695490,17),(58530,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58530,37.35,0.27,295,18949,70,NULL,NULL,'2MASXi J0900401+160425',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,135.1670417,16.07381,0.097,NULL,63886834000,998231781,15597371,17.8),(58531,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58531,37.93,0.46,385,18950,70,NULL,NULL,'SDSS J090040.39+632603.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,135.168375,63.43433,0.165,NULL,62059792876,969684263,15151316,18.5),(58532,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58532,39.01,0.46,634,18951,70,NULL,NULL,'SDSS J090040.50+025331.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000165,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,135.16875,2.89206,0.121,NULL,63620572142,994071439,15532366,18.4),(58533,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58533,37.38,0.46,299,18952,70,NULL,NULL,'SDSS J090040.53+040607.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000722,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,135.168875,4.10217,0.113,NULL,63635941361,994311583,15536118,17.6),(58534,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58534,38.92,0.33,608,18953,70,NULL,NULL,'SDSS J090040.92+354419.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000105,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,135.1705,35.73875,0.073,NULL,64423899129,1006623423,15728490,18.6),(58535,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58535,38.79,0.46,572,18954,70,NULL,NULL,'SDSS J090042.06+361201.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,135.17525,36.20053,0.085,NULL,64423763039,1006621297,15728457,18.5),(58536,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58536,37.77,0.46,358,18955,70,NULL,NULL,'2MASX J09004215+5258268',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000079,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,135.175375,52.97417,0.037,NULL,64223840146,1003497502,15679648,16.9),(58537,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58537,38.08,0.21,412,18956,70,NULL,NULL,'2MASX J09004256+1439533',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,135.1775,14.66489,0.109,NULL,63874880590,998045009,15594453,17.9),(58538,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58538,37.86,0.15,373,18957,70,NULL,NULL,'SDSS J090044.12+390848.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,135.183833,39.14689,0.025,NULL,64412798993,1006449984,15725781,18.2),(58539,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58539,37.1,0.46,263,18958,70,NULL,NULL,'2MASX J09004423+0637551',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,135.1842083,6.63183,0.141,NULL,63682353353,995036771,15547449,17.4),(58540,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58540,38.9,0.46,602,18959,70,NULL,NULL,'2MASX J09004533+0225022',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000177,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,135.1889583,2.41731,0.121,NULL,63622530881,994102045,15532844,17.7),(58541,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58541,38.01,0.46,399,18960,70,NULL,NULL,'2MASX J09004537+5246288',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000091,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,135.189083,52.77464,0.037,NULL,64226660906,1003541576,15680337,17.3),(58542,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58542,37.13,0.27,267,18961,70,NULL,NULL,'2MASX J09004691+3148231',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.7g',0.18,'AGN',NULL,NULL,NULL,NULL,1,135.195375,31.80631,0.013,NULL,64386931622,1006045806,15719465,17.7),(58543,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58543,37.95,0.46,390,18962,70,NULL,NULL,'SDSS J090046.90+262438.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,135.195417,26.41067,0.093,NULL,64375116175,1005861190,15716581,18),(58544,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58544,35.37,0.46,119,18963,70,NULL,NULL,'CGCG 033-042',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000159,NULL,'16.0g',0.32,'S0',NULL,NULL,NULL,NULL,1,135.197375,5.90214,0.137,NULL,63624474203,994132409,15533318,16),(58545,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58545,38.49,0.46,498,18964,70,NULL,NULL,'2MASX J09004744+5119128',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000092,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,135.197833333,51.32014,0.037,NULL,64225816214,1003528378,15680130,17.4),(58546,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58546,37.29,0.33,288,18965,70,NULL,NULL,'2MASX J09004917+3028481',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,135.204958333,30.47992,0.045,NULL,64390740844,1006105325,15720395,17.9),(58547,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58547,36.39,0.46,190,18966,70,NULL,NULL,'2MASX J09004960+6313436',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.43',0.22,'S:',NULL,NULL,NULL,NULL,1,135.207083,63.22869,0.169,NULL,62059943871,969686622,15151353,17.43),(58548,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58548,37.66,0.46,340,18967,70,NULL,NULL,'2MASX J09004977+0434593',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000199,NULL,'16.1g',0.39,NULL,NULL,NULL,NULL,NULL,1,135.207541667,4.58328,0.105,NULL,63635271384,994301115,15535954,16.1),(58549,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58549,37.05,0.33,257,18968,70,NULL,NULL,'2MASX J09005022+0751261',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00018,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,135.20925,7.85736,0.185,NULL,63685975965,995093374,15548333,17.5),(58550,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58550,38.01,0.15,400,18969,70,NULL,NULL,'CGPG 0856.6+6252.5',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'18.4',NULL,NULL,NULL,NULL,NULL,NULL,1,135.21,62.66736,0.177,NULL,62062892758,969732699,15152073,18.4),(58551,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58551,38.03,0.46,403,18970,70,NULL,NULL,'2MASX J09005055+2101372',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000181,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,135.2107083,21.02711,0.073,NULL,63837151783,997455496,15585242,17.1),(58552,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58552,36.84,0.46,234,18971,70,NULL,NULL,'2MASX J09005150+4625151',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000164,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,135.2144583,46.42086,0.045,NULL,64286990562,1004484227,15695066,16.3),(58553,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58553,35.76,0.46,142,18972,70,NULL,NULL,'CGCG 150-058',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00016,NULL,'15.8g',0.34,'E0',NULL,NULL,NULL,NULL,1,135.215417,31.1645,0.033,NULL,64387455453,1006053991,15719593,15.8),(58554,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58554,38.66,0.46,540,18973,70,NULL,NULL,'SDSS J090052.16+144305.0',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000169,NULL,'18.9g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,135.217333,14.71808,0.109,NULL,63874885960,998045093,15594454,18.9),(58555,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58555,37.37,0.46,298,18974,70,NULL,NULL,'2MASX J09005364+5304595',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000092,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,135.2232917,53.08317,0.045,NULL,64223849645,1003497650,15679650,16.3),(58556,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58556,32.71,NULL,34.9,18975,NULL,NULL,NULL,'UGC 04725',NULL,'2000BSAO...50....5K',2000,1,1.46,NULL,'G',0.000009,NULL,'16.3g',0.18,'Sd',NULL,NULL,NULL,NULL,1,135.2302083,31.99317,0.013,NULL,64386944794,1006046012,15719468,16.3),(58557,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58557,32.75,NULL,35.5,18975,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04725',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58558,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58558,32.76,NULL,35.7,18975,NULL,NULL,'Dipole + Quadrupole','UGC 04725',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58559,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58559,32.77,NULL,35.8,18975,NULL,NULL,'Dipole','UGC 04725',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58560,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58560,33.08,0.2,41.3,18975,74.4,NULL,NULL,'UGC 04725',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58561,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58561,33.12,0.43,42,18975,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04725',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58562,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58562,33.16,0.43,42.8,18975,75,NULL,'3.6 micron, color corrected','UGC 04725',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58563,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58563,33.23,0.63,44.3,18975,NULL,NULL,NULL,'UGC 04725',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58564,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58564,33.34,0.6,46.5,18975,NULL,NULL,'Malmquist cor.','UGC 04725',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58565,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58565,37.66,0.46,341,18976,70,NULL,NULL,'2MASX J09005607+1831151',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000184,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,135.233625,18.52094,0.065,NULL,63876122771,998064418,15594756,16.7),(58566,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58566,37.36,0.46,296,18977,70,NULL,NULL,'2MASX J09005636+2357470',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,135.2347917,23.96303,0.097,NULL,63821334598,997208353,15581380,17.3),(58567,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58567,36.91,0.46,241,18978,70,NULL,NULL,'2MASX J09005644+5322026',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000076,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,135.2349583,53.36725,0.061,NULL,64224000161,1003500002,15679687,17.1),(58568,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58568,37.8,0.33,363,18979,70,NULL,NULL,'2MASX J09005680+5457166',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000087,NULL,'16.4g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,135.236541667,54.9545,0.021,NULL,62008620565,968884696,15138823,16.4),(58569,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58569,37.4,0.46,302,18980,70,NULL,NULL,'2MASX J09005706+1822581',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,135.237917,18.38294,0.093,NULL,63883660642,998182197,15596596,18),(58570,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58570,38.01,0.15,400,18981,70,NULL,NULL,'CGPG 0856.8+6250.3',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.6',0.23,NULL,NULL,NULL,NULL,NULL,1,135.240917,62.62392,0.181,NULL,62062899841,969732810,15152075,17.6),(58571,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58571,37.63,0.46,335,18982,70,NULL,NULL,'2MASX J09005812+0455333',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000118,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,135.242083,4.92606,0.117,NULL,63632475695,994257432,15535272,17.8),(58572,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58572,37.27,0.46,285,18983,70,NULL,NULL,'2MASX J09005902+5455046',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000071,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,135.246,54.918,0.021,NULL,62008618718,968884667,15138822,17.6),(58573,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58573,38.3,0.46,456,18984,70,NULL,NULL,'2MASX J09010005+1559187',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,135.250167,15.9885,0.101,NULL,63886819465,998231554,15597368,17.7),(58574,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58574,36.55,0.46,204,18985,70,NULL,NULL,'2MASX J09010029+0732481',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000097,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,135.251125,7.54681,0.221,NULL,63682510359,995039224,15547487,17.3),(58575,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58575,38.61,0.33,528,18986,70,NULL,NULL,'2MASXi J0901002+385909',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00018,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,135.25125,38.98589,0.025,NULL,64412943431,1006452241,15725816,18.3),(58576,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58576,38.09,0.46,415,18987,70,NULL,NULL,'2MASX J09010146+3830242',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00017,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,135.2562917,38.50661,0.029,NULL,64412587947,1006446686,15725729,17.4),(58577,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58577,37.51,0.46,318,18988,70,NULL,NULL,'2MASX J09010166+5331196',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000073,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,135.256833333,53.52219,0.065,NULL,64224205490,1003503210,15679737,17.8),(58578,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58578,36.11,0.46,166,18989,70,NULL,NULL,'IC 2427',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000181,NULL,'15.2g',0.56,'S0^-',NULL,NULL,NULL,NULL,1,135.257083,37.87544,0.065,NULL,64416074729,1006501167,15726580,15.2),(58579,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58579,38.09,0.21,416,18990,70,NULL,NULL,'SDSS J090102.31+580717.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000073,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,135.259625,58.12147,0.109,NULL,62024652266,969135191,15142737,18.2),(58580,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58580,37.59,0.33,330,18991,70,NULL,NULL,'SDSS J090102.50+061904.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000142,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,135.2604583,6.31786,0.133,NULL,63680075986,995001187,15546893,18),(58581,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58581,38.15,0.46,427,18992,70,NULL,NULL,'SDSS J090102.99+143344.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000137,NULL,'18.3g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,135.2625,14.56233,0.109,NULL,63874902255,998045347,15594458,18.3),(58582,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58582,37.96,0.46,391,18993,70,NULL,NULL,'SDSS J090103.09+240812.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000117,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,135.262917,24.13678,0.097,NULL,63821417038,997209641,15581400,18.7),(58583,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58583,37.8,0.33,363,18994,70,NULL,NULL,'SDSS J090103.40+545050.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000069,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,135.264208333,54.84731,0.021,NULL,61874426124,966787908,15106061,18.4),(58584,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58584,37.59,0.33,330,18995,70,NULL,NULL,'SDSS J090104.76+061944.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00013,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,135.269875,6.32894,0.133,NULL,63680075779,995001184,15546893,18),(58585,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58585,38.1,0.46,416,18996,70,NULL,NULL,'2MASX J09010504+1551237',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,135.2709583,15.85672,0.101,NULL,63886114699,998220542,15597195,17.4),(58586,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58586,38.01,0.15,400,18997,70,NULL,NULL,'CGPG 0856.9+6251',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.4',0.12,NULL,NULL,NULL,NULL,NULL,1,135.2765417,62.64192,0.181,NULL,62062893570,969732712,15152073,18.4),(58587,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58587,37.13,0.27,267,18998,70,NULL,NULL,'2MASX J09010785+3145540',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000171,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,135.282625,31.76492,0.013,NULL,64387637952,1006056843,15719638,16.7),(58588,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58588,38.42,0.33,484,18999,70,NULL,NULL,'2MASX J09010808+5244266',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00009,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,135.2835,52.74075,0.033,NULL,64226714621,1003542415,15680350,17.2),(58589,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58589,37.83,0.46,368,19000,70,NULL,NULL,'2MASX J09010810+0536423',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000201,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,135.283667,5.61181,0.141,NULL,63631949461,994249210,15535143,17),(58590,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58590,37.35,0.27,295,19001,70,NULL,NULL,'2MASX J09010895+1611327',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,135.2872917,16.19244,0.097,NULL,63886710795,998229856,15597341,16.2),(58591,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58591,35.12,0.46,105,19002,70,NULL,NULL,'CGCG 033-043',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.00013,NULL,'15.1g',0.52,'E0',NULL,NULL,NULL,NULL,1,135.287583333,6.10847,0.137,NULL,63624499777,994132809,15533325,15.1),(58592,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58592,38.06,0.46,409,19003,70,NULL,NULL,'2MASX J09010904+3518130',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,135.2877083,35.30367,0.057,NULL,64424422105,1006631595,15728618,18),(58593,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58593,37.5,0.46,316,19004,70,NULL,NULL,'SDSS J090109.73+365304.2',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00018,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,135.290541667,36.8845,0.053,NULL,64414595204,1006478050,15726219,16.7),(58594,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58594,38.01,0.15,400,19005,70,NULL,NULL,'SDSS J090110.10+623719.6',NULL,'2015arXiv151105856S',2015,1,0.5,'One of two 6cm sources associated with [WB92] 0856+6256','G',0.00016,NULL,'16.4B',0.37,'BrClG',NULL,NULL,NULL,NULL,1,135.292083,62.62214,0.181,NULL,62062902667,969732854,15152075,16.4),(58595,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58595,37.45,0.46,310,19006,70,NULL,NULL,'2MASX J09011038+0725301',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000117,NULL,'17.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,135.293208333,7.42517,0.221,NULL,63682476361,995038693,15547479,17.3),(58596,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58596,35.8,0.46,145,19007,70,NULL,NULL,'CGCG 264-051',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000087,NULL,'15.1g',0.61,'S?','Pair member (points to parent)',NULL,NULL,NULL,1,135.2934583,53.22011,0.061,NULL,64223878404,1003498100,15679657,15.1),(58597,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58597,37.88,0.33,377,19008,70,NULL,NULL,'2MASX J09011049+1846491',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,135.293875,18.78028,0.085,NULL,63876158143,998064970,15594765,17.5),(58598,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58598,37.88,0.33,377,19009,70,NULL,NULL,'2MASX J09011063+1848381',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,135.2945,18.81061,0.085,NULL,63876157587,998064962,15594765,17.6),(58599,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58599,35.27,0.46,113,19010,70,NULL,NULL,'CGCG 120-057',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.00008,NULL,'15.2g',0.46,NULL,NULL,NULL,NULL,NULL,1,135.295667,20.61069,0.069,NULL,63836977322,997452770,15585199,15.2),(58600,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58600,38.01,0.15,400,19011,70,NULL,NULL,'CGPG 0857.1+6252.2',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00014,NULL,'18.7B',NULL,NULL,NULL,NULL,NULL,NULL,1,135.29625,62.65769,0.177,NULL,62062894150,969732721,15152073,18.7),(58601,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58601,35.36,0.49,118,19012,75,NULL,'IR','CGCG 061-039',NULL,'2011yCatp016004901K',2011,1,0.55,'The bright star just south-southwest affects the photometry.','G',0.000017,NULL,'15.7',0.14,NULL,NULL,NULL,NULL,NULL,1,135.300958333,13.0445,0.057,NULL,63870988693,997984198,15593503,15.7),(58602,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58602,35.24,0.2,112,19013,74.4,NULL,NULL,'CGCG 061-039',NULL,'2013AJ....146...86T',2013,1,0.55,'The bright star just south-southwest affects the photometry.','G',0.000017,NULL,'15.7',0.14,NULL,NULL,NULL,NULL,NULL,1,135.300958333,13.0445,0.057,NULL,63870988693,997984198,15593503,15.7),(58603,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58603,36.48,0.33,198,19014,70,NULL,NULL,'2MASX J09011251+1733357',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000189,NULL,'15.8g',0.48,NULL,NULL,NULL,NULL,NULL,1,135.302166667,17.56003,0.085,NULL,63884133075,998189579,15596712,15.8),(58604,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58604,36.88,0.33,238,19015,70,NULL,NULL,'2MASX J09011259+5459247',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000086,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,135.302375,54.99025,0.021,NULL,62008610022,968884531,15138820,17.8),(58605,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58605,38.6,0.46,526,19016,70,NULL,NULL,'SDSS J090112.61+150613.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.7g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,135.302583333,15.10375,0.113,NULL,63874156872,998033701,15594276,18.7),(58606,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58606,37.45,0.46,309,19017,70,NULL,NULL,'2MASX J09011266+2507270',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,135.302875,25.12411,0.097,NULL,63703154066,995361782,15552527,17.4),(58607,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58607,38.07,0.46,412,19018,70,NULL,NULL,'2MASX J09011308+2710560',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000175,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,135.304375,27.18233,0.093,NULL,64378040105,1005906876,15717294,17.6),(58608,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58608,35.87,0.48,149,19019,70,NULL,NULL,'2MASX J09011354-0604000',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00011,NULL,'15.86',0.7,NULL,NULL,NULL,NULL,NULL,1,135.3062917,-6.06681,0.105,NULL,42154911437,658670491,10291726,15.86),(58609,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58609,38.59,0.46,523,19020,70,NULL,NULL,'2MASX J09011378+3910413',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000161,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,135.3072917,39.17814,0.021,NULL,64412828951,1006450452,15725788,18.3),(58610,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58610,36.61,0.46,210,19021,70,NULL,NULL,'2MASX J09011402+3747323',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000172,NULL,'16.0g',0.44,NULL,NULL,NULL,NULL,NULL,1,135.3085417,37.79233,0.049,NULL,64416020967,1006500327,15726567,16),(58611,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58611,38.01,0.15,400,19022,70,NULL,NULL,'CGPG 0857.2+6248.3',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000073,NULL,'18.2',0.25,NULL,NULL,NULL,NULL,NULL,1,135.311875,62.60294,0.181,NULL,62062900498,969732820,15152075,18.2),(58612,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58612,37.29,0.33,287,19023,70,NULL,NULL,'SDSS J090114.87+300418.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,135.311958333,30.07194,0.057,NULL,64390889364,1006107646,15720431,18.1),(58613,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58613,36.95,0.46,245,19024,70,NULL,NULL,'2MASX J09011517+1258081',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000173,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,135.313333,12.96883,0.057,NULL,63870983149,997984111,15593501,16.8),(58614,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58614,35.08,NULL,104,19025,NULL,NULL,'Dipole','UGC 04733',NULL,'2010Ap&SS.325..163P',2010,1,1.1,NULL,'G',0.000033,NULL,'16.7g',0.14,'Sd','Isolated galaxy',NULL,NULL,NULL,1,135.315166667,4.11811,0.153,NULL,63635879013,994310609,15536103,16.7),(58615,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58615,35.08,NULL,104,19025,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04733',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58616,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58616,35.09,NULL,104,19025,NULL,NULL,'Dipole + Quadrupole','UGC 04733',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58617,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58617,35.09,NULL,104,19025,NULL,NULL,NULL,'UGC 04733',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58618,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58618,35.24,0.49,112,19025,75,NULL,'IR','UGC 04733',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58619,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58619,37.29,0.33,287,19026,70,NULL,NULL,'2MASX J09011567+3001292',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000169,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,135.315417,30.02475,0.057,NULL,64390880306,1006107504,15720429,16.5),(58620,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58620,38.84,0.46,587,19027,70,NULL,NULL,'2MASX J09011614+5538007',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000106,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,135.3175417,55.63356,0.061,NULL,62009412799,968897074,15139016,17.8),(58621,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58621,38.09,0.21,416,19028,70,NULL,NULL,'2MASX J09011683+5814367',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000088,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,135.320167,58.24361,0.109,NULL,62021834204,969091159,15142049,17.9),(58622,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58622,37.11,0.23,264,19029,70,NULL,NULL,'2MASXi J0901171+382451',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,135.321417,38.41425,0.045,NULL,64415408328,1006490755,15726418,17.2),(58623,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58623,35.98,0.46,157,19030,70,NULL,NULL,'KUG 0857+475',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000085,NULL,'16.7g',0.27,'Compact',NULL,NULL,NULL,NULL,1,135.321583,47.36033,0.057,NULL,64278816408,1004356506,15693070,16.7),(58624,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58624,38.09,0.21,416,19031,70,NULL,NULL,'2MASX J09011734+5816467',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000091,NULL,'16.6g',0.39,'BrClG',NULL,NULL,NULL,NULL,1,135.3225417,58.27978,0.109,NULL,62021839050,969091235,15142050,16.6),(58625,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58625,38.03,0.33,404,19032,70,NULL,NULL,'SDSS J090118.54+400649.5',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.2g',0.26,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,135.32725,40.11378,0.005,NULL,64395208068,1006175126,15721486,17.2),(58626,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58626,37.46,0.46,311,19033,70,NULL,NULL,'2MASX J09011886+5413417',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000068,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,135.32875,54.22806,0.057,NULL,64223398550,1003490602,15679540,17.4),(58627,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58627,37.68,0.46,343,19034,70,NULL,NULL,'2MASX J09011996+4725271',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,135.333208333,47.42431,0.057,NULL,64278819202,1004356550,15693071,16.4),(58628,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58628,38.03,0.33,404,19035,70,NULL,NULL,'SDSS J090120.74+400527.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000156,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,135.3364583,40.09089,0.005,NULL,64395207909,1006175123,15721486,18.4),(58629,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58629,37.08,0.46,261,19036,70,NULL,NULL,'2MASX J09012079+0907241',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,135.336625,9.12331,0.141,NULL,63683478620,995054353,15547724,17.4),(58630,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58630,37.13,0.27,267,19037,70,NULL,NULL,'2MASX J09012176+3144153',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,135.340583333,31.73758,0.013,NULL,64387670672,1006057354,15719646,17.3),(58631,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58631,38.26,0.46,448,19038,70,NULL,NULL,'2MASX J09012294+2026321',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,135.3454583,20.44225,0.053,NULL,63836938727,997452167,15585190,17.5),(58632,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58632,37.98,0.46,394,19039,70,NULL,NULL,'SDSS J090123.12+255345.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,135.346375,25.89606,0.097,NULL,64374281494,1005848148,15716377,18.1),(58633,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58633,38.07,0.46,410,19040,70,NULL,NULL,'SDSS J090123.69+371911.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,135.348791667,37.31989,0.061,NULL,64415203312,1006487551,15726367,18.3),(58634,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58634,38.42,0.33,484,19041,70,NULL,NULL,'2MASX J09012427+5245245',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000089,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,135.351333,52.75686,0.037,NULL,64226717554,1003542461,15680350,17.4),(58635,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58635,37.96,0.46,391,19042,70,NULL,NULL,'2MASX J09012589+3035263',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000136,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,135.357833,30.59053,0.045,NULL,64390256065,1006097751,15720277,17.9),(58636,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58636,38.09,0.21,416,19043,70,NULL,NULL,'2MASX J09012594+5814206',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000081,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,135.358125,58.23906,0.109,NULL,62021834510,969091164,15142049,17.4),(58637,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58637,37.57,0.27,326,19044,70,NULL,NULL,'SDSS J090126.06+045417.6',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000124,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,135.358583,4.90489,0.117,NULL,63632521399,994258146,15535283,17.5),(58638,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58638,37.66,0.27,340,19045,70,NULL,NULL,'2MASX J09012641+1949330',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000198,NULL,'16.5g',0.38,'BrClG',NULL,NULL,NULL,NULL,1,135.360125,19.82586,0.073,NULL,63834091021,997407672,15584494,16.5),(58639,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58639,37.01,0.46,252,19046,70,NULL,NULL,'2MASX J09012714+3427513',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000205,NULL,'16.1g',0.35,'E0',NULL,NULL,NULL,NULL,1,135.362917,34.46433,0.041,NULL,64421755921,1006589936,15727967,16.1),(58640,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58640,37.98,0.27,394,19047,70,NULL,NULL,'SDSS J090127.27+084615.9',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000182,NULL,'17.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,135.363625,8.77111,0.173,NULL,63683541167,995055330,15547739,17.3),(58641,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58641,37.98,0.27,394,19048,70,NULL,NULL,'SDSS J090127.28+085217.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000168,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,135.363666667,8.87158,0.157,NULL,63683659428,995057178,15547768,18.1),(58642,'IRAS','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58642,32.14,0.8,26.8,19049,75,NULL,'MAT, I','ESO 497- G 002',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000023,NULL,'14.64',1.2,'SB(rs)d',NULL,NULL,NULL,NULL,1,135.364667,-26.30053,0.609,NULL,42900254962,670316483,10473695,14.64),(58643,'Tully est','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58643,32.05,0.8,25.6,19049,75,NULL,NULL,'ESO 497- G 002',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58644,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58644,31.61,0.32,21,19049,85,NULL,'I, inv','ESO 497- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58645,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58645,31.64,0.32,21.3,19049,85,NULL,'I, raw','ESO 497- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58646,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58646,31.92,0.43,24.2,19049,75,NULL,'MAT, I, inv','ESO 497- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58647,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58647,31.98,0.43,24.9,19049,75,NULL,'MAT, I, raw','ESO 497- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58648,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58648,32.29,0.43,28.7,19049,75,NULL,'MAT, I, cor','ESO 497- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58649,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58649,33,0.2,39.8,19049,74.4,NULL,NULL,'ESO 497- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58650,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58650,33.27,1.12,45,19049,NULL,NULL,NULL,'ESO 497- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58651,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58651,33.29,1.1,45.6,19049,NULL,NULL,'Malmquist cor.','ESO 497- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58652,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58652,34.02,0.46,63.7,19050,70,NULL,NULL,'NGC 2729',NULL,'2015arXiv151105856S',2015,1,1.03,'HOLM 106B is a star.','G',0.000063,NULL,'14.3g',0.61,'S0?',NULL,NULL,NULL,NULL,1,135.36925,3.72061,0.101,NULL,63635008460,994297007,15535890,14.3),(58653,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58653,38.88,0.46,596,19051,70,NULL,NULL,'SDSS J090128.85+473922.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000138,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,135.3702083,47.65631,0.041,NULL,64233728827,1003652012,15682062,18.5),(58654,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58654,38.89,0.46,601,19052,70,NULL,NULL,'SDSS J090129.21+033229.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000132,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,135.37175,3.54158,0.137,NULL,63634569025,994290141,15535783,18.6),(58655,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58655,36.82,0.27,231,19053,70,NULL,NULL,'2MASX J09013103+0204140',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000094,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,135.379167,2.0705,0.133,NULL,63623238371,994113099,15533017,17.3),(58656,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58656,38.61,0.33,528,19054,70,NULL,NULL,'2MASX J09013128+3855543',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00019,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,135.38025,38.93186,0.033,NULL,64412533320,1006445833,15725716,16.6),(58657,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58657,37.11,0.23,264,19055,70,NULL,NULL,'2MASX J09013127+3828133',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000203,NULL,'16.0g',0.44,'E0',NULL,NULL,NULL,NULL,1,135.3802917,38.47025,0.045,NULL,64412639697,1006447495,15725742,16),(58658,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58658,36.82,0.27,231,19056,70,NULL,NULL,'2MASX J09013203+0203440',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000066,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,135.3835,2.06211,0.133,NULL,63622963506,994108804,15532950,17.1),(58659,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58659,29.99,NULL,9.97,19057,NULL,NULL,NULL,'MCG +09-15-079',NULL,'2000BSAO...50....5K',2000,1,1.56,'Matthews (2000A&AS..143..421M) detects another feature at v=2458 km/sec.','G',0.00005,NULL,'17.1g',0.2,'Sdm',NULL,NULL,NULL,NULL,1,135.384208333,50.61572,0.025,NULL,64239060948,1003735327,15683364,17.1),(58660,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58660,30.19,NULL,10.9,19057,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG +09-15-079',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58661,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58661,30.23,NULL,11.1,19057,NULL,NULL,'Dipole + Quadrupole','MCG +09-15-079',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58662,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58662,30.27,NULL,11.3,19057,NULL,NULL,'Dipole','MCG +09-15-079',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58663,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58663,37.33,0.46,292,19058,70,NULL,NULL,'2MASX J09013232+5619082',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000077,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,135.384583333,56.31883,0.109,NULL,62012631434,968947366,15139802,17.8),(58664,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58664,37.34,0.46,293,19059,70,NULL,NULL,'2MASX J09013280+2507202',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000142,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,135.38675,25.12233,0.097,NULL,63703132251,995361441,15552522,18),(58665,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58665,38.09,0.21,416,19060,70,NULL,NULL,'2MASX J09013326+5813093',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000101,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,135.3885417,58.21919,0.109,NULL,62021833027,969091141,15142049,16.8),(58666,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58666,37.11,0.23,264,19061,70,NULL,NULL,'2MASX J09013331+3826231',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.1g',0.39,NULL,NULL,NULL,NULL,NULL,1,135.388917,38.43992,0.045,NULL,64412607439,1006446991,15725734,16.1),(58667,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58667,37.84,0.46,369,19062,70,NULL,NULL,'2MASX J09013560+5931433',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,135.3982917,59.52883,0.157,NULL,62069447848,969835122,15153673,17.3),(58668,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58668,36.87,0.46,236,19063,70,NULL,NULL,'2MASX J09013597-0040328',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000067,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,135.4,-0.67578,0.105,NULL,42144510500,658507976,10289187,18.1),(58669,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58669,37.83,0.46,368,19064,70,NULL,NULL,'2MASX J09013662+4709237',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,135.402375,47.1565,0.041,NULL,64278774576,1004355852,15693060,17.5),(58670,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58670,38.02,0.46,402,19065,70,NULL,NULL,'SDSS J090137.94+103825.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,135.408125,10.64031,0.093,NULL,63673049764,994891402,15545178,18),(58671,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58671,35.78,0.46,143,19066,70,NULL,NULL,'2MASX J09013815+4905170',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000193,NULL,'15.6g',0.33,'S0',NULL,NULL,NULL,NULL,1,135.4089583,49.08806,0.033,NULL,64236122459,1003689413,15682647,15.6),(58672,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58672,38.21,0.46,439,19067,70,NULL,NULL,'2MASX J09013881+5857303',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,135.411625,58.95836,0.161,NULL,62021327879,969083248,15141925,NULL),(58673,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58673,38.04,0.46,406,19068,70,NULL,NULL,'SDSS J090139.39+110821.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,135.414167,11.13939,0.073,NULL,63670269757,994847964,15544499,17.9),(58674,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58674,37.66,0.27,340,19069,70,NULL,NULL,'2MASX J09014021+1955200',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000148,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,135.417417,19.92239,0.073,NULL,63833545456,997399147,15584361,16.9),(58675,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58675,38.93,0.46,612,19070,70,NULL,NULL,'SDSS J090140.17+372212.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000164,NULL,'18.7g',0.09,NULL,NULL,NULL,NULL,NULL,1,135.417417,37.37006,0.069,NULL,64415197410,1006487459,15726366,18.7),(58676,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58676,38.15,0.23,427,19071,70,NULL,NULL,'SDSS J090140.49+323101.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000161,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,135.41875,32.51719,0.049,NULL,64379470489,1005929226,15717644,18.5),(58677,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58677,37.93,0.27,386,19072,70,NULL,NULL,'SDSS J090140.54+514322.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000066,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,135.4189583,51.72303,0,NULL,64226440688,1003538135,15680283,18.3),(58678,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58678,37.57,0.27,326,19073,70,NULL,NULL,'2MASX J09014149+0457260',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00018,NULL,'16.3g',0.36,'E0',NULL,NULL,NULL,NULL,1,135.422833333,4.95728,0.117,NULL,63632520769,994258137,15535283,16.3),(58679,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58679,37.88,0.46,376,19074,70,NULL,NULL,'SDSS J090142.64+562629.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000072,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,135.4277083,56.44142,0.105,NULL,62012645814,968947590,15139806,18.3),(58680,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58680,37.78,0.33,360,19075,70,NULL,NULL,'2MASX J09014375+1512190',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000169,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,135.4322917,15.20536,0.105,NULL,63872416664,998006510,15593851,18.1),(58681,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58681,33.32,NULL,46.1,19076,NULL,NULL,NULL,'UGC 04727',NULL,'2000BSAO...50....5K',2000,1,1.41,'Multiple SDSS entries describe this object.','G',NULL,NULL,'16.0',0.16,'Sc',NULL,NULL,NULL,NULL,1,135.432833,60.15739,0.193,NULL,62072453261,969882082,15154407,16),(58682,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58682,33.45,NULL,48.9,19076,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04727',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58683,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58683,33.48,NULL,49.7,19076,NULL,NULL,'Dipole + Quadrupole','UGC 04727',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58684,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58684,33.49,NULL,49.9,19076,NULL,NULL,'Dipole','UGC 04727',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58685,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58685,37.66,0.27,340,19077,70,NULL,NULL,'2MASX J09014417+1951460',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00016,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,135.434167,19.86294,0.073,NULL,63833543673,997399119,15584361,16.8),(58686,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58686,35.4,0.26,120,19078,NULL,NULL,NULL,'CGCG 061-043',NULL,'2009ApJS..182..474S',2009,1,0.79,NULL,'G',0.000159,NULL,'15.6g',0.42,NULL,NULL,NULL,NULL,NULL,1,135.439417,12.99144,0.057,NULL,63870935336,997983364,15593490,15.6),(58687,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58687,35.45,0.26,123,19078,NULL,NULL,'Malmquist cor.','CGCG 061-043',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58688,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58688,35.65,0.2,135,19078,74.4,NULL,NULL,'CGCG 061-043',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58689,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58689,38.52,0.33,506,19079,70,NULL,NULL,'2MASX J09014550+1926030',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000164,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,135.439666667,19.43414,0.085,NULL,63831150629,997361728,15583777,17.4),(58690,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58690,38.02,0.46,401,19080,70,NULL,NULL,'SDSS J090145.59+590243.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,135.44,59.04539,0.161,NULL,62021386878,969084169,15141940,18.4),(58691,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58691,37.8,0.46,363,19081,70,NULL,NULL,'2MASX J09014610+5911324',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,135.4422083,59.19247,0.161,NULL,62013860475,968966569,15140102,17.7),(58692,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58692,38.19,0.46,434,19082,70,NULL,NULL,'2MASX J09014619+5746064',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000098,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,135.4425,57.76844,0.125,NULL,62025258198,969144659,15142885,18),(58693,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58693,37.82,0.46,367,19083,70,NULL,NULL,'2MASX J09014665+1950040',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000186,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,135.4445,19.83453,0.073,NULL,63833559088,997399360,15584365,17),(58694,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58694,38.42,0.46,483,19084,70,NULL,NULL,'2MASX J09014669+2246530',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,135.444625,22.7815,0.113,NULL,63823757192,997246206,15581971,18.6),(58695,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58695,38.65,0.46,536,19085,70,NULL,NULL,'SDSS J090147.45+480027.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,135.4477083,48.00767,0.049,NULL,64233881765,1003654402,15682100,18.4),(58696,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58696,37.78,0.33,360,19086,70,NULL,NULL,'2MASX J09014762+1512030',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000177,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,135.44825,15.20083,0.105,NULL,63872408185,998006377,15593849,17.3),(58697,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58697,38.15,0.23,427,19087,70,NULL,NULL,'2MASX J09014824+3241064',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000159,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,135.450958333,32.68517,0.033,NULL,64379460122,1005929064,15717641,18.7),(58698,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58698,38.38,0.46,474,19088,70,NULL,NULL,'2MASX J09014844+5615584',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000083,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,135.451833333,56.26614,0.109,NULL,62012636243,968947441,15139803,18.1),(58699,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58699,38.52,0.33,506,19089,70,NULL,NULL,'2MASX J09014903+1924330',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000143,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,135.45425,19.40931,0.085,NULL,63831204772,997362574,15583790,18),(58700,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58700,37.52,0.46,320,19090,70,NULL,NULL,'2MASX J09014920+3255352',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,135.454917,32.92644,0.041,NULL,64409879266,1006404363,15725068,17.3),(58701,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58701,36.56,0.46,205,19091,70,NULL,NULL,'2MASX J09014955-0023529',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000098,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,135.4565417,-0.39792,0.117,NULL,41070739613,641730306,10027036,16.3),(58702,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58702,37.86,0.14,374,19092,70,NULL,NULL,'2MASX J09014978+2053280',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,135.4575,20.89103,0.073,NULL,63836880363,997451255,15585175,16.9),(58703,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58703,38.14,0.33,424,19093,70,NULL,NULL,'2MASX J09015006+1858220',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,135.4584583,18.97281,0.085,NULL,63831039242,997359988,15583749,17.9),(58704,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58704,38.14,0.33,424,19094,70,NULL,NULL,'2MASX J09015077+1859500',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000172,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,135.4614583,18.99728,0.085,NULL,63831253417,997363334,15583802,16.7),(58705,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58705,36.53,0.46,203,19095,70,NULL,NULL,'2MASX J09015125+3237234',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000083,NULL,'15.3g',0.55,'E0',NULL,NULL,NULL,NULL,1,135.4635,32.62322,0.033,NULL,64379466232,1005929159,15717643,15.3),(58706,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58706,36.82,0.27,231,19096,70,NULL,NULL,'2MASX J09015211+0159360',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000086,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,135.4670417,1.99328,0.133,NULL,63622960235,994108753,15532949,16.8),(58707,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58707,36.88,0.33,238,19097,70,NULL,NULL,'2MASX J09015478+5503544',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000093,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,135.478375,55.06511,0.037,NULL,62008692253,968885816,15138840,16.8),(58708,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58708,37.87,0.33,374,19098,70,NULL,NULL,'SDSS J090154.82+260759.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000155,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,135.478458333,26.13328,0.093,NULL,64374258289,1005847785,15716371,18.6),(58709,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58709,37.57,0.27,326,19099,70,NULL,NULL,'SDSS J090154.90+045928.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000135,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,135.47875,4.99136,0.117,NULL,63632399643,994256244,15535253,18.1),(58710,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58710,36.63,0.46,212,19100,70,NULL,NULL,'2MASX J09015521+1508460',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000185,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,135.479958333,15.14619,0.105,NULL,63872282442,998004413,15593818,16.2),(58711,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58711,38.15,0.23,427,19101,70,NULL,NULL,'2MASX J09015537+3235554',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,135.480875,32.59886,0.033,NULL,64379464943,1005929139,15717642,17),(58712,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58712,37.36,0.46,297,19102,70,NULL,NULL,'2MASX J09015559+1918440',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,135.4817917,19.31222,0.085,NULL,63831175338,997362114,15583783,16.6),(58713,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58713,38.15,0.23,427,19103,70,NULL,NULL,'SDSS J090156.21+323617.3',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000183,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,135.4842083,32.60481,0.033,NULL,64379464730,1005929136,15717642,17.6),(58714,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58714,37.13,0.46,267,19104,70,NULL,NULL,'2MASX J09015896+5131420',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000101,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,135.495583333,51.52831,0.005,NULL,64225839615,1003528743,15680136,16.3),(58715,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58715,33.05,0.43,40.7,19105,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04701',NULL,'2014MNRAS.444..527S',2014,1,2,NULL,'G',0.000037,NULL,'15.1',1,'Sd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,135.504041667,78.2775,0.025,NULL,61467621805,960431590,15006743,15.1),(58716,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58716,36.27,0.58,179,19106,70,NULL,NULL,'2MFGC 07046',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,135.5047083,-10.58722,0.137,NULL,42198623939,659353499,10302398,15.5),(58717,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58717,37.86,0.14,374,19107,70,NULL,NULL,'2MASX J09020221+2030394',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'18.0g',0.17,'AGN',NULL,NULL,NULL,NULL,1,135.509,20.51089,0.053,NULL,63836931271,997452051,15585188,18),(58718,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58718,38.62,0.46,530,19108,70,NULL,NULL,'2MASX J09020318+1803304',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000184,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,135.5132917,18.05842,0.085,NULL,63883579124,998180923,15596576,18),(58719,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58719,38.38,0.46,475,19109,70,NULL,NULL,'2MASX J09020370+1401050',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,135.515625,14.01794,0.077,NULL,63874680349,998041880,15594404,18.5),(58720,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58720,35.49,0.46,125,19110,70,NULL,NULL,'2MASX J09020466+4633530',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000133,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,135.5194583,46.56481,0.045,NULL,64286961851,1004483778,15695059,16.5),(58721,'IRAS','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58721,31.53,0.8,20.2,19111,75,NULL,'MAT, I','ESO 090- G 015',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000017,NULL,'12.34',0.4,'SAB(r)b',NULL,NULL,NULL,NULL,1,135.523208333,-64.90431,0.633,NULL,40786428380,637287943,9957624,12.34),(58722,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58722,31.9,0.4,23.9,19111,NULL,NULL,'mean','ESO 090- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58723,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58723,32.15,0.43,26.9,19111,75,NULL,'3.6 micron, color + selection bias corrected','ESO 090- G 015',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58724,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58724,32.32,0.4,29.1,19111,NULL,NULL,NULL,'ESO 090- G 015',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58725,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58725,32.32,0.39,29.1,19111,73,NULL,'opt','ESO 090- G 015',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58726,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58726,32.37,0.43,29.7,19111,75,NULL,'3.6 micron, color corrected','ESO 090- G 015',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58727,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58727,32.39,0.45,30.1,19111,NULL,NULL,'K','ESO 090- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58728,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58728,32.41,0.46,30.3,19111,NULL,NULL,'J','ESO 090- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58729,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58729,32.41,0.47,30.3,19111,NULL,NULL,'H','ESO 090- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58730,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58730,32.43,0.32,30.6,19111,85,NULL,'I, raw','ESO 090- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58731,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58731,32.45,0.32,30.9,19111,85,NULL,'I, inv','ESO 090- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58732,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58732,32.52,0.2,31.9,19111,74.4,NULL,NULL,'ESO 090- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58733,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58733,32.65,0.43,33.9,19111,75,NULL,'MAT, I, raw','ESO 090- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58734,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58734,32.77,0.43,35.9,19111,75,NULL,'MAT, I, inv','ESO 090- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58735,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58735,32.93,0.43,38.5,19111,75,NULL,'MAT, I, cor','ESO 090- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58736,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58736,37.86,0.14,374,19112,70,NULL,NULL,'2MASX J09020648+2030374',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000192,NULL,'16.5g',0.34,'AGN',NULL,NULL,NULL,NULL,1,135.5269583,20.51047,0.053,NULL,63836997702,997453089,15585204,16.5),(58737,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58737,37.86,0.14,374,19113,70,NULL,NULL,'2MASX J09020698+2020334',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,135.529083,20.34272,0.053,NULL,63833605313,997400083,15584376,16.9),(58738,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58738,36.22,0.33,176,19114,70,NULL,NULL,'2MASX J09020847+4842370',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000092,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,135.534958333,48.71019,0.041,NULL,64236711285,1003698613,15682790,16.7),(58739,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58739,31.48,0.43,19.8,19115,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2731',NULL,'2014MNRAS.444..527S',2014,1,0.8,NULL,'G',0.000033,NULL,'14.50',0.5,'S?',NULL,NULL,NULL,NULL,1,135.5350417,8.30167,0.177,NULL,63685866340,995091661,15548307,14.5),(58740,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58740,31.8,0.43,22.9,19115,75,NULL,'3.6 micron, color corrected','NGC 2731',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58741,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58741,32.07,0.2,25.9,19115,74.4,NULL,NULL,'NGC 2731',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58742,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58742,33,0.47,39.8,19115,NULL,NULL,'H','NGC 2731',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58743,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58743,33.08,0.46,41.2,19115,NULL,NULL,'J','NGC 2731',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58744,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58744,33.09,0.4,41.5,19115,NULL,NULL,'mean','NGC 2731',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58745,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58745,33.09,0.45,41.5,19115,NULL,NULL,'K','NGC 2731',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58746,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58746,37.88,0.33,376,19116,70,NULL,NULL,'2MASX J09020882+2105414',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,135.5367917,21.09467,0.073,NULL,63836862755,997450980,15585171,18.2),(58747,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58747,37.86,0.14,374,19117,70,NULL,NULL,'2MASX J09020925+2032504',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000175,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,135.538458333,20.54747,0.053,NULL,63837009866,997453279,15585207,16.6),(58748,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58748,37.88,0.33,376,19118,70,NULL,NULL,'2MASX J09020960+2113374',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,135.5399583,21.22703,0.073,NULL,63837111192,997454862,15585232,17.3),(58749,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58749,37.73,0.46,351,19119,70,NULL,NULL,'SDSS J090209.65+344840.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000128,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,135.5402083,34.81128,0.061,NULL,64423612929,1006618952,15728421,18.3),(58750,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58750,37.19,0.46,274,19120,70,NULL,NULL,'SDSS J090209.87+283042.9',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.8g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,135.541166667,28.51192,0.049,NULL,64375596545,1005868696,15716698,16.8),(58751,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58751,37.11,0.23,264,19121,70,NULL,NULL,'2MASX J09021045+3821484',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,135.5435,38.36333,0.045,NULL,64415447699,1006491370,15726427,17.3),(58752,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58752,37.92,0.46,383,19122,70,NULL,NULL,'2MASX J09021059+2557088',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,135.544333333,25.95261,0.101,NULL,64189765341,1002965083,15671329,17.4),(58753,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58753,34.14,0.53,67.4,19123,70,NULL,NULL,'ESO 564- G 008',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000123,NULL,'15.78',0.2,'S0-a',NULL,NULL,NULL,NULL,1,135.5457083,-19.37258,0.565,NULL,42351066422,661735412,10339615,15.78),(58754,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58754,37.87,0.33,374,19124,70,NULL,NULL,'2MASX J09021142+2601598',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000147,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,135.54775,26.03344,0.093,NULL,64189773896,1002965217,15671331,17.5),(58755,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58755,37.19,0.46,274,19125,70,NULL,NULL,'2MASX J09021279+5344076',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000074,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,135.553167,53.73556,0.057,NULL,64224094451,1003501475,15679710,17.5),(58756,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58756,37.86,0.14,374,19126,70,NULL,NULL,'2MASX J09021296+2034455',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000142,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,135.554083333,20.57925,0.069,NULL,63837011493,997453304,15585207,18.3),(58757,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58757,37.45,0.46,309,19127,70,NULL,NULL,'2MASX J09021429+5848093',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000083,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,135.559667,58.80261,0.141,NULL,62021313170,969083018,15141922,17.6),(58758,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58758,37.56,0.46,325,19128,70,NULL,NULL,'2MASX J09021498+5150399',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000083,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,135.562333,51.84436,0,NULL,64226450918,1003538295,15680285,17.1),(58759,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58759,38.01,0.15,400,19129,70,NULL,NULL,'2MASX J09021527+6240161',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00016,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,135.5637083,62.67114,0.177,NULL,62062427506,969725429,15151959,16.7),(58760,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58760,37.93,0.46,386,19130,70,NULL,NULL,'SDSS J090215.74+262042.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000143,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,135.565583,26.34503,0.093,NULL,64374580538,1005852820,15716450,18.2),(58761,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58761,38.67,0.46,542,19131,70,NULL,NULL,'SDSS J090216.80+233744.8',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000178,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,135.57,23.62914,0.101,NULL,63824036085,997250563,15582040,17.6),(58762,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58762,37.93,0.27,386,19132,70,NULL,NULL,'2MASX J09022015+5143147',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000081,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,135.58375,51.72081,0,NULL,64225961191,1003530643,15680166,17.4),(58763,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58763,38.17,0.27,430,19133,70,NULL,NULL,'2MASX J09022107+1420415',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,135.587917,14.34483,0.133,NULL,63874765736,998043214,15594425,17.7),(58764,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58764,37.86,0.46,374,19134,70,NULL,NULL,'2MASX J09022108+5538233',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000069,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,135.588167,55.63981,0.041,NULL,62009051696,968891432,15138928,18),(58765,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58765,34.65,0.46,85,19135,70,NULL,NULL,'2MASX J09022116+0336563',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000141,NULL,'16.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,135.5882917,3.61572,0.137,NULL,63634593545,994290524,15535789,16.2),(58766,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58766,37.03,0.46,255,19136,70,NULL,NULL,'2MASX J09022261+3730254',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000121,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,135.5942083,37.50708,0.069,NULL,64415993787,1006499902,15726560,17.8),(58767,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58767,38.52,0.46,506,19137,70,NULL,NULL,'SDSS J090222.89+164418.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,135.595375,16.73856,0.077,NULL,63887035684,998234932,15597420,18.4),(58768,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58768,38.32,0.19,460,19138,70,NULL,NULL,'2MASX J09022341+5201017',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000084,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,135.597333,52.01711,0,NULL,64226400959,1003537514,15680273,18.4),(58769,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58769,36.61,0.46,210,19139,70,NULL,NULL,'2MASX J09022428+3257124',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,135.601125,32.95339,0.041,NULL,64410069792,1006407340,15725114,16.6),(58770,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58770,38.12,0.46,421,19140,70,NULL,NULL,'2MASX J09022512+5236017',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000095,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,135.6045,52.60044,0.033,NULL,64226800815,1003543762,15680371,17.5),(58771,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58771,37.31,0.46,290,19141,70,NULL,NULL,'2MASX J09022534+1553205',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'15.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,135.605667,15.88894,0.093,NULL,63886321846,998223778,15597246,15.9),(58772,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58772,37.86,0.14,374,19142,70,NULL,NULL,'2MASX J09022586+2045464',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000184,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,135.6077917,20.76292,0.069,NULL,63837034865,997453669,15585213,16.6),(58773,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58773,35.67,0.46,136,19143,70,NULL,NULL,'CGCG 090-058',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000193,NULL,'15.2g',0.56,'AGN','Group member',NULL,NULL,NULL,1,135.608833,14.45542,0.105,NULL,63874647242,998041363,15594396,15.2),(58774,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58774,36.21,0.27,175,19144,70,NULL,NULL,'CGCG 121-002',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000167,NULL,'15.0g',0.58,NULL,NULL,NULL,NULL,NULL,1,135.613666667,22.65392,0.105,NULL,63823293279,997238957,15581858,15),(58775,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58775,37.74,0.46,352,19145,70,NULL,NULL,'2MASX J09022816+3719424',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000151,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,135.6174583,37.3285,0.061,NULL,64414685323,1006479458,15726241,17.3),(58776,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58776,36.87,0.46,237,19146,70,NULL,NULL,'2MASX J09022890+0857093',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000176,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,135.620417,8.95264,0.165,NULL,63683630095,995056720,15547761,17),(58777,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58777,36.24,0.52,177,19147,70,NULL,NULL,'2MASX J09022910-1003380',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.24',NULL,NULL,NULL,NULL,NULL,NULL,1,135.621125,-10.06086,0.105,NULL,42196406086,659318845,10301856,16.24),(58778,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58778,36.2,0.46,174,19148,70,NULL,NULL,'2MASX J09023035+3759214',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.00017,NULL,'16.0g',0.38,'E0',NULL,NULL,NULL,NULL,1,135.626417,37.98931,0.065,NULL,64415538860,1006492794,15726449,16),(58779,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58779,38.32,0.19,460,19149,70,NULL,NULL,'2MASX J09023045+5202518',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000076,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,135.6267083,52.04781,0,NULL,64226400375,1003537505,15680273,17.8),(58780,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58780,37.64,0.46,337,19150,70,NULL,NULL,'2MASX J09023080+3929535',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000165,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,135.628333,39.49822,0.029,NULL,64395224093,1006175376,15721490,16.8),(58781,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58781,38.17,0.27,430,19151,70,NULL,NULL,'2MASX J09023139+1424145',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000182,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,135.630917,14.40394,0.105,NULL,63874641834,998041278,15594394,17.1),(58782,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58782,36.84,0.7,234,19152,70,NULL,NULL,'2MASX J09023413-0612251',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.5I',0.2,NULL,NULL,NULL,NULL,NULL,1,135.642208333,-6.20694,0.085,NULL,42200103506,659376617,10302759,14.5),(58783,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58783,36.21,0.27,175,19153,70,NULL,NULL,'2MASX J09023427+2237552',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000087,NULL,'15.5g',0.5,NULL,NULL,NULL,NULL,NULL,1,135.642875,22.63206,0.105,NULL,63823337194,997239643,15581869,15.5),(58784,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58784,37.75,0.33,355,19154,70,NULL,NULL,'2MASX J09023484+3513284',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,135.6452083,35.22447,0.049,NULL,64423589277,1006618582,15728415,18),(58785,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58785,37.75,0.46,355,19155,70,NULL,NULL,'2MASX J09023539+5653345',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000096,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,135.6474583,56.89292,0.113,NULL,62009921620,968905025,15139141,16.7),(58786,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58786,36.99,0.46,249,19156,70,NULL,NULL,'2MASX J09023678+0119123',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000074,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,135.65325,1.32022,0.129,NULL,63619711867,994057997,15532156,16.9),(58787,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58787,38.32,0.19,460,19157,70,NULL,NULL,'2MASX J09023684+5203488',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000105,NULL,'16.3g',0.36,'BrClG          AGN',NULL,NULL,NULL,NULL,1,135.6535,52.06356,0,NULL,64227255520,1003550867,15680482,16.3),(58788,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58788,37.92,0.46,383,19158,70,NULL,NULL,'2MASX J09023743+1319495',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000164,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,135.6559583,13.33036,0.093,NULL,63871259415,997988428,15593569,17.3),(58789,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58789,37.83,0.46,368,19159,70,NULL,NULL,'SDSS J090237.65+481259.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,135.656917,48.21658,0.057,NULL,64233857969,1003654030,15682094,18.5),(58790,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58790,38.17,0.27,430,19160,70,NULL,NULL,'2MASX J09023786+1422395',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000181,NULL,'16.9g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,135.657875,14.37769,0.133,NULL,63874639842,998041247,15594394,16.9),(58791,'Tully est','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58791,32.87,0.8,37.5,19161,75,NULL,'B','NGC 2735',NULL,'1988NBGC.C....0000T',1988,1,1.2,NULL,'G',0.000017,NULL,'14.13',0.4,'SAB(rs)b? pec','Pair member (points to parent)',NULL,NULL,NULL,1,135.661,25.93453,0.101,NULL,64189814294,1002965848,15671341,14.13),(58792,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58792,33.21,0.4,43.8,19161,NULL,NULL,'mean','NGC 2735',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58793,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58793,33.55,0.45,51.3,19161,NULL,NULL,'K','NGC 2735',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58794,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58794,33.56,0.47,51.6,19161,NULL,NULL,'H','NGC 2735',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58795,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58795,33.59,0.46,52.3,19161,NULL,NULL,'J','NGC 2735',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58796,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58796,37.41,0.46,303,19162,70,NULL,NULL,'2MASX J09023882+0949403',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000131,NULL,'18.0g',0.11,NULL,NULL,NULL,NULL,NULL,1,135.66175,9.82783,0.149,NULL,63672295601,994879618,15544994,18),(58797,'IRAS','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58797,33.62,0.8,53,19163,75,NULL,'MAT, I','NGC 2788A',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.000033,NULL,'13.95',0.4,'Sb: sp         AGN',NULL,NULL,NULL,NULL,1,135.664333333,-68.22683,0.397,NULL,40798969154,637483893,9960685,13.95),(58798,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58798,33.66,0.46,54,19163,NULL,NULL,'J','NGC 2788A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58799,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58799,33.74,0.47,55.9,19163,NULL,NULL,'H','NGC 2788A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58800,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58800,33.79,0.49,57.4,19163,75,NULL,'IR','NGC 2788A',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58801,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58801,33.81,0.43,57.7,19163,75,NULL,'MAT, I, raw','NGC 2788A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58802,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58802,33.81,0.4,57.8,19163,NULL,NULL,'mean','NGC 2788A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58803,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58803,33.83,0.45,58.4,19163,NULL,NULL,'K','NGC 2788A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58804,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58804,33.91,0.53,60.4,19163,NULL,NULL,'Malmquist cor.','NGC 2788A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58805,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58805,34.12,0.43,66.7,19163,75,NULL,'MAT, I, cor','NGC 2788A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58806,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58806,34.12,0.48,66.8,19163,NULL,NULL,NULL,'NGC 2788A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58807,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58807,34.16,0.32,67.9,19163,85,NULL,'I, raw','NGC 2788A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58808,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58808,34.16,0.43,67.9,19163,75,NULL,'MAT, I, inv','NGC 2788A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58809,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58809,34.17,0.2,68.2,19163,74.4,NULL,NULL,'NGC 2788A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58810,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58810,34.25,0.32,70.7,19163,85,NULL,'I, inv','NGC 2788A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58811,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58811,38.32,0.19,460,19164,70,NULL,NULL,'2MASX J09023946+5211148',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000095,NULL,'16.6g',0.29,'AGN',NULL,NULL,NULL,NULL,1,135.664666667,52.18747,0,NULL,64227253421,1003550834,15680481,16.6),(58812,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58812,37.96,0.46,390,19165,70,NULL,NULL,'2MASX J09023971+2643005',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,135.6655,26.71675,0.093,NULL,64374663581,1005854118,15716470,17.4),(58813,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58813,37.79,0.46,362,19166,70,NULL,NULL,'2MASX J09023983+5423005',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000075,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,135.666125,54.38347,0.037,NULL,63954992851,999296763,15614011,17.2),(58814,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58814,37.71,0.46,348,19167,70,NULL,NULL,'SDSS J090239.94+633711.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,135.666416667,63.61992,0.133,NULL,62059080913,969673139,15151142,18.4),(58815,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58815,37.13,0.46,267,19168,70,NULL,NULL,'SDSS J090240.77+034937.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00012,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,135.669917,3.82703,0.097,NULL,63634671679,994291744,15535808,18.2),(58816,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58816,37.93,0.27,386,19169,70,NULL,NULL,'2MASX J09024102+5140088',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000086,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,135.671125,51.66914,0,NULL,64225968029,1003530750,15680167,17.4),(58817,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58817,36.95,0.33,246,19170,70,NULL,NULL,'2MASX J09024130+0816423',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000199,NULL,'16.1g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,135.672208333,8.27844,0.177,NULL,63685861398,995091584,15548306,16.1),(58818,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58818,37.86,0.14,374,19171,70,NULL,NULL,'2MASX J09024157+2046382',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,135.67325,20.77728,0.069,NULL,63837017366,997453396,15585209,17.6),(58819,'Tully est','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58819,32.98,0.8,39.4,19172,75,NULL,NULL,'NGC 2735A',NULL,'1988NBGC.C....0000T',1988,1,0.11,NULL,'G',0.000053,NULL,'17.4g',0.1,'Im: pec','Pair member (points to parent)',NULL,NULL,NULL,1,135.6744583,25.93839,0.101,NULL,64189814272,1002965848,15671341,17.4),(58820,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58820,36.21,0.27,175,19173,70,NULL,NULL,'2MASX J09024186+2238342',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000169,NULL,'16.93',0.33,NULL,NULL,NULL,NULL,NULL,1,135.6745417,22.64294,0.105,NULL,63823291112,997238923,15581858,16.93),(58821,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58821,38.33,0.46,464,19174,70,NULL,NULL,'2MASX J09024232+5430475',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000089,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,135.6762083,54.51314,0.037,NULL,63954964598,999296321,15614005,18),(58822,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58822,37.36,0.46,296,19175,70,NULL,NULL,'2MASX J09024248+6501361',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,135.677,65.02675,0.153,NULL,62260607404,972821990,15200343,17.5),(58823,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58823,34.52,0.49,80,19176,75,NULL,'IR','UGC 04745',NULL,'2011yCatp016004901K',2011,1,1.18,NULL,'G',0.000033,NULL,'15.6g',0.29,'Scd:',NULL,NULL,NULL,NULL,1,135.6814583,25.09197,0.097,NULL,63703311935,995364248,15552566,15.6),(58824,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58824,34.97,0.45,98.8,19176,NULL,NULL,NULL,'UGC 04745',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58825,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58825,34.98,0.44,99.3,19176,NULL,NULL,'Malmquist cor.','UGC 04745',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58826,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58826,35.01,0.2,100,19176,74.4,NULL,NULL,'UGC 04745',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58827,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58827,36.86,0.46,235,19177,70,NULL,NULL,'2MASX J09024366+3405043',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000194,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,135.682041667,34.08456,0,NULL,64421809658,1006590775,15727980,16.3),(58828,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58828,37.75,0.33,355,19178,70,NULL,NULL,'2MASX J09024382+3513553',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000188,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,135.682583,35.23214,0.049,NULL,64423590444,1006618600,15728415,16.6),(58829,'IRAS','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58829,34.63,0.8,84.5,19179,75,NULL,'CF, r','UGC 04746',NULL,'1997ApJS..109..333W',1997,1,1.37,NULL,'G',0.000033,NULL,'14.8g',0.57,'Sbc',NULL,NULL,NULL,NULL,1,135.6827083,25.42117,0.109,NULL,64189865236,1002966644,15671353,14.8),(58830,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58830,34.49,0.2,79.1,19179,74.4,NULL,NULL,'UGC 04746',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58831,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58831,34.51,0.38,79.9,19179,75,NULL,'CF, r, raw','UGC 04746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58832,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58832,34.62,0.38,83.8,19179,75,NULL,'CF, r, inv','UGC 04746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58833,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58833,34.74,0.45,88.8,19179,NULL,NULL,NULL,'UGC 04746',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58834,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58834,34.78,0.38,90.2,19179,75,NULL,'CF, r, cor','UGC 04746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58835,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58835,34.79,0.44,90.9,19179,NULL,NULL,'Malmquist cor.','UGC 04746',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58836,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58836,37.22,0.46,278,19180,70,NULL,NULL,'2MASX J09024396+5723106',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000077,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,135.68325,57.38642,0.113,NULL,62023958106,969124345,15142567,17),(58837,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58837,38.32,0.19,460,19181,70,NULL,NULL,'SDSS J090244.82+520443.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000071,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,135.686791667,52.07872,0,NULL,64227260299,1003550942,15680483,18.7),(58838,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58838,38.38,0.33,475,19182,70,NULL,NULL,'SDSS J090245.68+183332.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000177,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,135.690333,18.55911,0.089,NULL,63876308705,998067323,15594801,18.7),(58839,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58839,33.19,0.4,43.4,19183,NULL,NULL,'mean','ESO 564- G 011',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000033,NULL,'14.5',0.7,'Sa?            HII','Pair member (points to parent)',NULL,NULL,NULL,1,135.692375,-20.72531,0.677,NULL,42361902472,661904726,10342261,14.5),(58840,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58840,33.22,0.47,44,19183,NULL,NULL,'H','ESO 564- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58841,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58841,33.29,0.46,45.5,19183,NULL,NULL,'J','ESO 564- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58842,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58842,33.31,0.45,46,19183,NULL,NULL,'K','ESO 564- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58843,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58843,36.73,0.46,222,19184,70,NULL,NULL,'2MASX J09024625+0913443',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000189,NULL,'16.2g',0.33,'S0',NULL,NULL,NULL,NULL,1,135.692667,9.22892,0.153,NULL,63683589328,995056083,15547751,16.2),(58844,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58844,38.38,0.33,475,19185,70,NULL,NULL,'2MASX J09024620+1833232',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000192,NULL,'16.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,135.692667,18.55658,0.089,NULL,63876308586,998067321,15594801,16.4),(58845,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58845,36.27,0.46,180,19186,70,NULL,NULL,'2MASX J09024819+4047132',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00017,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,135.700625,40.78703,0.033,NULL,64265277512,1004144961,15689765,16.4),(58846,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58846,38.32,0.19,460,19187,70,NULL,NULL,'2MASX J09024910+5204397',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,135.704583,52.07775,0,NULL,64227248710,1003550761,15680480,NULL),(58847,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58847,35.97,0.65,156,19188,70,NULL,NULL,'2MFGC 07054',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.2I',0.2,NULL,NULL,NULL,NULL,NULL,1,135.705458333,-6.10461,0.085,NULL,42154957418,658671209,10291737,14.2),(58848,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58848,37.64,0.46,338,19189,70,NULL,NULL,'SDSS J090250.33+421231.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000146,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,135.7097917,42.20875,0.029,NULL,64277400333,1004334380,15692724,18.4),(58849,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58849,36.22,0.33,176,19190,70,NULL,NULL,'2MASX J09025085+4842307',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000191,NULL,'15.8g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,135.712083,48.70856,0.041,NULL,64236215997,1003690874,15682669,15.8),(58850,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58850,37.33,0.46,292,19191,70,NULL,NULL,'2MASX J09025095+1332506',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000207,NULL,'16.1g',0.34,NULL,NULL,NULL,NULL,NULL,1,135.712166667,13.54731,0.093,NULL,63871272149,997988627,15593572,16.1),(58851,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58851,38.15,0.46,427,19192,70,NULL,NULL,'2MASX J09025311+5728046',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000075,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,135.7212083,57.468,0.113,NULL,62023983333,969124739,15142574,18.1),(58852,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58852,35.7,0.46,138,19193,70,NULL,NULL,'2MASX J09025334+3554403',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000167,NULL,'15.9g',0.42,'E',NULL,NULL,NULL,NULL,1,135.722375,35.91125,0.053,NULL,64422803431,1006606303,15728223,15.9),(58853,'TRGB','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58853,29.69,NULL,8.67,19194,NULL,NULL,NULL,'LSBC D564-08',NULL,'2006AJ....131.1361K',2006,1,0.7,'Multiple SDSS entries describe this source.','G',0.000004,NULL,'18.35',0.5,'dI',NULL,NULL,NULL,NULL,1,135.724167,20.07556,0.073,NULL,63833601350,997400021,15584375,18.35),(58854,'TRGB','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58854,29.72,0.07,8.79,19194,NULL,NULL,'I','LSBC D564-08',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58855,'TRGB','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58855,29.73,0.1,8.83,19194,74.4,NULL,NULL,'LSBC D564-08',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58856,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58856,38.32,0.33,461,19195,70,NULL,NULL,'SDSS J090253.87+183124.4',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000147,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,135.7245,18.52347,0.089,NULL,63876307482,998067304,15594801,18.7),(58857,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58857,36.47,0.88,197,19196,70,NULL,NULL,'2MASX J09025448-7039437',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,135.727083,-70.66208,0.349,NULL,40751779997,636746562,9949165,17.3),(58858,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58858,37.95,0.27,389,19197,70,NULL,NULL,'SDSS J090255.74+083242.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,135.73225,8.545,0.185,NULL,63683965108,995061954,15547843,18.7),(58859,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58859,37.37,0.33,298,19198,70,NULL,NULL,'2MASX J09025607+0427219',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000138,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,135.733625,4.45619,0.125,NULL,63635245422,994300709,15535948,17.2),(58860,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58860,37.95,0.27,389,19199,70,NULL,NULL,'2MASX J09025631+0844434',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000164,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,135.734667,8.74542,0.169,NULL,63683519684,995054995,15547734,17.1),(58861,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58861,34,NULL,63,19200,NULL,NULL,'Dipole','ESO 564- G 012',NULL,'2010Ap&SS.325..163P',2010,1,1.18,NULL,'G',0.000037,NULL,'16.72',0.15,'Scd',NULL,NULL,NULL,NULL,1,135.74,-18.02889,0.397,NULL,42407372706,662615198,10353362,16.72),(58862,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58862,34.01,NULL,63.4,19200,NULL,NULL,'Dipole + Quadrupole','ESO 564- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58863,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58863,34.01,NULL,63.5,19200,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 564- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58864,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58864,34.53,0.43,80.5,19200,75,NULL,'3.6 micron, color + selection bias corrected','ESO 564- G 012',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58865,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58865,37.56,0.46,325,19201,70,NULL,NULL,'2MASX J09025867+0321409',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,135.744375,3.36133,0.113,NULL,63634606129,994290720,15535792,17.2),(58866,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58866,37.42,0.33,305,19202,70,NULL,NULL,'2MASX J09025919+0619444',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000177,NULL,'16.3g',0.34,'E0',NULL,NULL,NULL,NULL,1,135.7467083,6.32908,0.157,NULL,63680106752,995001668,15546901,16.3),(58867,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58867,37.15,0.46,269,19203,70,NULL,NULL,'2MASX J09025973+3852352',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,135.749,38.87636,0.033,NULL,64412685302,1006448207,15725753,17.1),(58868,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58868,37.33,0.46,292,19204,70,NULL,NULL,'SDSS J090259.82+382438.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000138,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,135.74925,38.41058,0.045,NULL,64415351654,1006489869,15726404,18.4),(58869,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58869,37.05,0.46,257,19205,70,NULL,NULL,'2MASX J09030019+0200189',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000086,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,135.75075,2.00525,0.133,NULL,63620925499,994076960,15532452,17.2),(58870,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58870,38.27,0.46,450,19206,70,NULL,NULL,'SDSS J090300.56+052932.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000141,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,135.752333,5.49236,0.105,NULL,63625418672,994147166,15533549,18.2),(58871,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58871,36.87,0.46,237,19207,70,NULL,NULL,'NGC 2734',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000107,NULL,'15.2g',0.41,NULL,NULL,NULL,NULL,NULL,1,135.756708333,16.86361,0.077,NULL,63887066523,998235414,15597428,15.2),(58872,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58872,37.95,0.27,389,19208,70,NULL,NULL,'2MASX J09030178+0836454',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00017,NULL,'17.2g',0.22,'BrClG',NULL,NULL,NULL,NULL,1,135.757375,8.61272,0.189,NULL,63684009103,995062642,15547853,17.2),(58873,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58873,37.78,0.46,360,19209,70,NULL,NULL,'2MASX J09030202+1637546',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.1,NULL,NULL,NULL,NULL,NULL,1,135.758375,16.63206,0.101,NULL,63885909476,998217335,15597145,18.1),(58874,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58874,37.07,0.46,259,19210,70,NULL,NULL,'2MASX J09030236-0012014',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000093,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,135.7599583,-0.20039,0.117,NULL,41071531245,641742675,10027229,16.7),(58875,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58875,31.39,NULL,19,19211,NULL,NULL,NULL,'ESO 497- G 004',NULL,'2013AJ....145..101K',2013,1,1.1,NULL,'G',0.000013,NULL,'16.43',0.2,'S...',NULL,NULL,NULL,NULL,1,135.7632083,-23.80853,0.993,NULL,42346005067,661656329,10338380,16.43),(58876,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58876,36.78,0.46,227,19212,70,NULL,NULL,'2MASX J09030472+0108089',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000088,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,135.7697083,1.13569,0.129,NULL,63619613472,994056460,15532132,16.8),(58877,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58877,37.42,0.33,305,19213,70,NULL,NULL,'2MASX J09030730+0621454',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000158,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,135.7805,6.36261,0.157,NULL,63680108017,995001687,15546901,16.9),(58878,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58878,37.37,0.33,298,19214,70,NULL,NULL,'2MASX J09030737+0423149',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000138,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,135.78075,4.38742,0.113,NULL,63635237871,994300591,15535946,17.3),(58879,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58879,34.71,0.57,87.6,19215,70,NULL,NULL,'2MASX J09030771-1301516',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.43',NULL,NULL,NULL,NULL,NULL,NULL,1,135.781917,-13.03125,0.201,NULL,42367643813,661994434,10343663,15.43),(58880,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58880,37.57,0.46,327,19216,70,NULL,NULL,'2MASX J09030839+1443086',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,135.784875,14.71917,0.113,NULL,63872576913,998009014,15593890,17.6),(58881,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58881,38.56,0.46,515,19217,70,NULL,NULL,'2MASX J09030982+5712529',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000086,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,135.791,57.21481,0.113,NULL,62024043938,969125686,15142588,18.2),(58882,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58882,37.77,0.46,358,19218,70,NULL,NULL,'2MASX J09030983+2251191',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000158,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,135.791083333,22.85539,0.113,NULL,63822960970,997233765,15581777,17.8),(58883,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58883,37.95,0.46,390,19219,70,NULL,NULL,'2MASX J09031020+3645262',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000179,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,135.792375,36.75728,0.049,NULL,64414781914,1006480967,15726265,17.4),(58884,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58884,38.27,0.23,451,19220,70,NULL,NULL,'2MASX J09031116+5403515',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000101,NULL,'15.9g',0.46,'AGN',NULL,NULL,NULL,NULL,1,135.796416667,54.06433,0.045,NULL,63954866433,999294788,15613981,15.9),(58885,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58885,37.63,0.33,336,19221,70,NULL,NULL,'2MASX J09031134+1559455',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.4g',0.26,'AGN',NULL,NULL,NULL,NULL,1,135.7972083,15.99606,0.117,NULL,63886230209,998222347,15597224,16.4),(58886,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58886,35.4,0.23,120,19222,70,NULL,NULL,'CGCG 061-048',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.000163,NULL,'14.5g',0.75,NULL,'Group member',NULL,NULL,NULL,1,135.79725,13.63236,0.093,NULL,63871159190,997986862,15593544,14.5),(58887,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58887,37.36,0.46,297,19223,70,NULL,NULL,'2MASX J09031136+4736034',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,135.797375,47.60083,0.021,NULL,64233898860,1003654669,15682104,17.8),(58888,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58888,37.63,0.33,336,19224,70,NULL,NULL,'2MASX J09031185+1559161',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'18.0g',0.17,'AGN',NULL,NULL,NULL,NULL,1,135.7995,15.98769,0.117,NULL,63886230142,998222345,15597224,18),(58889,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58889,36.52,0.83,201,19225,70,NULL,NULL,'2MASX J09031268-0045107',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.000088,NULL,'15.9g',0.48,'(R)SBab',NULL,NULL,NULL,NULL,1,135.80275,-0.75294,0.085,NULL,41071572200,641743315,10027239,15.9),(58890,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58890,37.78,0.46,360,19226,70,NULL,NULL,'SDSS J090313.27+304126.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000129,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,135.805333,30.69069,0.041,NULL,64390192814,1006096762,15720261,18.1),(58891,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58891,38.33,0.46,464,19227,70,NULL,NULL,'2MASX J09031378+2337521',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000171,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,135.807333,23.63125,0.101,NULL,63823963700,997249432,15582022,17.6),(58892,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58892,33.54,0.49,51.1,19228,75,NULL,'IR','IC 2428',NULL,'2011yCatp016004901K',2011,1,1.92,NULL,'G',0.000023,NULL,'14.3g',0.41,'Scd:','Isolated galaxy',NULL,NULL,NULL,1,135.81125,30.59133,0.041,NULL,64390386497,1006099789,15720309,14.3),(58893,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58893,33.77,0.2,56.8,19228,74.4,NULL,NULL,'IC 2428',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58894,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58894,33.95,0.52,61.7,19228,NULL,NULL,NULL,'IC 2428',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58895,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58895,34.02,0.5,63.8,19228,NULL,NULL,'Malmquist cor.','IC 2428',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58896,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58896,34.21,0.4,69.5,19228,NULL,NULL,'mean','IC 2428',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58897,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58897,34.26,0.47,71.3,19228,NULL,NULL,'H','IC 2428',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58898,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58898,34.37,0.46,74.8,19228,NULL,NULL,'J','IC 2428',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58899,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58899,34.41,0.45,76,19228,NULL,NULL,'K','IC 2428',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58900,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58900,35.5,0.6,126,19229,70,NULL,NULL,'2MASX J09031484-2644398',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,135.8117917,-26.74447,0.617,NULL,42900109149,670314205,10473659,15.8),(58901,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58901,37.52,0.46,320,19230,70,NULL,NULL,'2MASX J09031530+1209191',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,135.8137083,12.15522,0.033,NULL,63640356077,994380563,15537196,17.6),(58902,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58902,38.27,0.23,451,19231,70,NULL,NULL,'2MASX J09031538+5401410',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000083,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,135.814167,54.02817,0.045,NULL,63954825139,999294142,15613970,17.9),(58903,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58903,36,0.46,159,19232,70,NULL,NULL,'2MASX J09031580+1808271',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000172,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,135.815917,18.14075,0.085,NULL,63877083730,998079433,15594991,16.5),(58904,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58904,37.84,0.46,370,19233,70,NULL,NULL,'2MASX J09031581+2815320',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000195,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,135.816083333,28.25908,0.057,NULL,64376067061,1005876047,15716813,16.9),(58905,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58905,37.69,0.46,344,19234,70,NULL,NULL,'2MASX J09031584+3759402',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,135.816125,37.99453,0.065,NULL,64415558689,1006493104,15726454,18.5),(58906,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58906,37.63,0.46,336,19235,70,NULL,NULL,'2MASX J09031641+5637310',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000086,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,135.8182083,56.62542,0.077,NULL,62010023489,968906617,15139165,16.8),(58907,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58907,38.26,0.33,448,19236,70,NULL,NULL,'2MASX J09031731+2849350',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00017,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,135.822333,28.82647,0.041,NULL,64375641802,1005869403,15716709,18.2),(58908,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58908,37.75,0.46,356,19237,70,NULL,NULL,'SDSS J090317.36+113406.5',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.7g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,135.822375,11.5685,0.053,NULL,63641096199,994392128,15537377,17.7),(58909,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58909,38.08,0.46,414,19238,70,NULL,NULL,'2MASX J09031775+1605271',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,135.823875,16.09089,0.125,NULL,63886357976,998224343,15597255,17.3),(58910,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58910,38.55,0.46,513,19239,70,NULL,NULL,'2MASX J09031826+3751061',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000178,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,135.826,37.85158,0.065,NULL,64415495146,1006492111,15726439,17.7),(58911,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58911,37.01,0.46,253,19240,70,NULL,NULL,'2MASX J09031872+0559250',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000135,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,135.828125,5.99031,0.165,NULL,63624640865,994135013,15533359,17.4),(58912,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58912,36.1,0.46,166,19241,70,NULL,NULL,'2MASX J09031909+5152034',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000078,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,135.829583,51.86761,0,NULL,64225940756,1003530324,15680161,16.6),(58913,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58913,38.26,0.33,448,19242,70,NULL,NULL,'SDSS J090319.83+285033.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00014,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,135.832625,28.84258,0.041,NULL,64375641945,1005869405,15716709,18.3),(58914,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58914,35.48,0.2,125,19243,74.4,NULL,NULL,'CGCG 061-053',NULL,'2013AJ....146...86T',2013,1,0.87,NULL,'G',0.000085,NULL,'16.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,135.836917,13.38317,0.085,NULL,63863108600,997861071,15591579,16.1),(58915,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58915,36.25,0.46,178,19244,70,NULL,NULL,'2MASX J09032125+4645171',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000168,NULL,'15.9g',0.32,'S0',NULL,NULL,NULL,NULL,1,135.83825,46.75472,0.037,NULL,64278824912,1004356639,15693072,15.9),(58916,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,NULL,58916,35.27,0.7,113,19245,70,NULL,NULL,'ESO 564- G 013',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'16.41',0.2,'S0:',NULL,NULL,NULL,NULL,1,135.838375,-20.23497,0.689,NULL,42358851705,661857057,10341516,16.41),(58917,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58917,37.74,0.46,354,19246,70,NULL,NULL,'2MASX J09032171+1154541',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,135.840458333,11.91494,0.041,NULL,63641125579,994392587,15537384,16.8),(58918,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58918,37.06,0.46,258,19247,70,NULL,NULL,'2MASX J09032201+5339254',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000103,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,135.841833333,53.65706,0.057,NULL,64223780057,1003496563,15679633,16.4),(58919,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58919,38.59,0.46,522,19248,70,NULL,NULL,'2MASX J09032256+0218541',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000106,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,135.843916667,2.31503,0.109,NULL,63621063652,994079119,15532486,17.6),(58920,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58920,36.09,0.46,165,19249,70,NULL,NULL,'2MASX J09032298+1502301',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000153,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,135.845708333,15.04175,0.113,NULL,63872745303,998011645,15593931,17.2),(58921,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58921,37.72,0.46,349,19250,70,NULL,NULL,'2MASX J09032302+0717003',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,135.845875,7.28333,0.141,NULL,63680775081,995012110,15547064,17.9),(58922,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58922,38.27,0.23,451,19251,70,NULL,NULL,'2MASX J09032423+5359000',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000079,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,135.850875,53.98325,0.045,NULL,63954826866,999294169,15613971,17.2),(58923,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58923,35.86,0.46,149,19252,70,NULL,NULL,'2MASX J09032704+1440081',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.0001,NULL,'15.5g',0.58,NULL,NULL,NULL,NULL,NULL,1,135.8627083,14.66894,0.109,NULL,63872621164,998009705,15593901,15.5),(58924,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58924,37.79,0.46,362,19253,70,NULL,NULL,'2MASX J09032710+0415081',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000145,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,135.862875,4.25236,0.113,NULL,63634165223,994283831,15535684,18.1),(58925,'FP','2016-12-15 15:14:26','2016-12-16 11:19:32','1',NULL,'R',58925,38.21,0.46,438,19254,70,NULL,NULL,'SDSS J090331.25+175946.7',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.6g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,135.88025,17.99633,0.081,NULL,63876535215,998070862,15594857,17.6),(58926,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58926,37.37,0.46,298,19255,70,NULL,NULL,'2MASX J09033399+0528561',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,135.891583333,5.48236,0.105,NULL,63625414782,994147105,15533548,17.6),(58927,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,58927,35.19,0.66,109,19256,70,NULL,NULL,'2MFGC 07064',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.03',0.3,NULL,NULL,NULL,NULL,NULL,1,135.895083,-19.96144,0.689,NULL,42351347417,661739803,10339684,16.03),(58928,'IRAS','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,58928,31.12,0.8,16.7,19257,75,NULL,'MAT, I','NGC 2788B',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.47',0.4,'Sb pec?',NULL,NULL,NULL,NULL,1,135.89875,-67.96981,0.405,NULL,40798424016,637475375,9960552,14.47),(58929,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,58929,29.35,0.32,7.37,19257,85,NULL,'I, inv','NGC 2788B',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58930,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,58930,29.43,0.32,7.68,19257,85,NULL,'I, raw','NGC 2788B',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58931,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,58931,29.96,0.43,9.84,19257,75,NULL,'MAT, I, inv','NGC 2788B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58932,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,58932,30.2,0.43,11,19257,75,NULL,'MAT, I, raw','NGC 2788B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58933,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,58933,30.5,0.43,12.6,19257,75,NULL,'MAT, I, cor','NGC 2788B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58934,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58934,30.86,0.49,14.9,19257,75,NULL,'IR','NGC 2788B',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58935,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,58935,30.94,0.7,15.4,19257,NULL,NULL,NULL,'NGC 2788B',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58936,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,58936,30.98,0.2,15.7,19257,74.4,NULL,NULL,'NGC 2788B',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58937,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,58937,31.29,0.39,18.1,19257,73,NULL,'opt','NGC 2788B',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58938,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,58938,31.38,0.57,18.9,19257,NULL,NULL,'Malmquist cor.','NGC 2788B',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58939,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58939,38.27,0.23,451,19258,70,NULL,NULL,'SDSS J090336.03+540156.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000077,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,135.900167,54.03225,0.045,NULL,63954826147,999294158,15613971,18.3),(58940,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58940,36.57,0.46,206,19259,70,NULL,NULL,'SDSS J090337.68+555108.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000085,NULL,'17.8g',0.13,'NLAGN',NULL,NULL,NULL,'Sy 2',1,135.907041667,55.85239,0.045,NULL,62009082546,968891914,15138936,17.8),(58941,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,58941,36.37,0.62,188,19260,70,NULL,NULL,'2MASX J09033806-0912105',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'16.48',0.4,NULL,NULL,NULL,NULL,NULL,1,135.908583333,-9.20289,0.105,NULL,42209979641,659530931,10305170,16.48),(58942,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58942,38.32,0.33,461,19261,70,NULL,NULL,'2MASX J09033841+1826158',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000164,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,135.909917,18.43789,0.089,NULL,63876972874,998077701,15594964,17.6),(58943,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58943,37.86,0.14,374,19262,70,NULL,NULL,'2MASX J09033959+2026188',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,135.9150417,20.43844,0.053,NULL,63836791238,997449863,15585154,17.7),(58944,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58944,35.4,0.23,120,19263,70,NULL,NULL,'CGCG 061-055',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.000167,NULL,'15.0g',0.71,NULL,'Group member',NULL,NULL,NULL,1,135.916125,13.67217,0.093,NULL,63871162471,997986913,15593545,15),(58945,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58945,37.24,0.46,281,19264,70,NULL,NULL,'2MASX J09034052+0306210',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,135.9187917,3.10583,0.121,NULL,63634486788,994288856,15535763,16.9),(58946,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58946,37.75,0.27,355,19265,70,NULL,NULL,'SDSS J090342.72+265020.0',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.8g',0.31,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,135.928,26.83892,0.081,NULL,64374485845,1005851341,15716427,16.8),(58947,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58947,37.68,0.46,344,19266,70,NULL,NULL,'2MASX J09034386+3003151',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000173,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,135.9329583,30.05414,0.041,NULL,64389247351,1006081989,15720031,16.8),(58948,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58948,35.4,0.23,120,19267,70,NULL,NULL,'2MASX J09034444+1310197',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'16.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,135.9352083,13.17203,0.077,NULL,63863089107,997860767,15591574,16.3),(58949,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58949,38.15,0.46,427,19268,70,NULL,NULL,'2MASX J09034512+3458261',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,135.9380417,34.97397,0.021,NULL,64423491825,1006617059,15728391,18.2),(58950,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,58950,34.54,0.49,81,19269,70,NULL,NULL,'2MFGC 07066',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00008,NULL,'15.1',0.3,NULL,NULL,NULL,NULL,NULL,1,135.9385,-4.37406,0.057,NULL,42158559837,658727497,10292617,15.1),(58951,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58951,36.4,0.46,191,19270,70,NULL,NULL,'2MASX J09034532+0446364',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000144,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,135.938917,4.77678,0.105,NULL,63632367773,994255746,15535246,17.3),(58952,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58952,38.36,0.46,471,19271,70,NULL,NULL,'SDSS J090346.77+383804.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,135.944917,38.63456,0.033,NULL,64412500666,1006445322,15725708,18),(58953,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58953,36.79,0.46,228,19272,70,NULL,NULL,'2MASX J09034768+4305462',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,135.949,43.09633,0.065,NULL,64275365280,1004302582,15692227,17.1),(58954,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,58954,31.69,0.47,21.7,19273,NULL,NULL,'H','IC 0512',NULL,'2007A&A...465...71T',2007,1,2.9,NULL,'G',0.000033,NULL,'12.90',2.3,'SAB(s)cd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,135.957625,85.50169,0.237,NULL,61267069302,957297957,14957780,12.9),(58955,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,58955,31.7,0.45,21.9,19273,NULL,NULL,'K','IC 0512',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58956,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,58956,31.72,0.46,22.1,19273,NULL,NULL,'J','IC 0512',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58957,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,58957,31.82,0.4,23.1,19273,NULL,NULL,'mean','IC 0512',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58958,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,58958,32.14,0.4,26.7,19273,75,NULL,'B','IC 0512',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58959,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58959,37.82,0.33,366,19274,70,NULL,NULL,'2MASX J09035160+5605439',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000091,NULL,'17.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,135.964875,56.09556,0.049,NULL,62012520543,968945633,15139775,17.6),(58960,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58960,37.86,0.14,374,19275,70,NULL,NULL,'2MASX J09035196+2021008',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000164,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,135.9665,20.35031,0.105,NULL,63833387902,997396685,15584323,17.4),(58961,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58961,37.97,0.33,393,19276,70,NULL,NULL,'SDSS J090353.09+072900.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,135.97125,7.48361,0.161,NULL,63680602358,995009411,15547022,17.9),(58962,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58962,37.38,0.27,300,19277,70,NULL,NULL,'2MASX J09035335+3518531',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,135.972208333,35.31464,0.049,NULL,64423095146,1006610861,15728294,17.8),(58963,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,58963,36.86,0.7,236,19278,70,NULL,NULL,'2MASX J09035337-0917142',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.81',0.2,NULL,NULL,NULL,NULL,NULL,1,135.9722917,-9.28747,0.105,NULL,42196155039,659314922,10301795,16.81),(58964,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58964,36.53,0.46,202,19279,70,NULL,NULL,'2MASX J09035585+1831478',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000099,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,135.982917,18.53006,0.085,NULL,63876982245,998077847,15594966,17.3),(58965,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58965,37.12,0.46,266,19280,70,NULL,NULL,'2MASX J09035602+1527097',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000159,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,135.9834583,15.45292,0.097,NULL,63872314561,998004915,15593826,17.1),(58966,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58966,37.78,0.46,360,19281,70,NULL,NULL,'2MASX J09035635+3908216',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,135.984667,39.13928,0.013,NULL,64395601449,1006181272,15721582,18.5),(58967,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58967,36.44,0.46,194,19282,70,NULL,NULL,'2MASX J09035704+0013284',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000077,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,135.9875,0.22469,0.141,NULL,60666850988,947919546,14811242,16.9),(58968,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58968,37.86,0.14,374,19283,70,NULL,NULL,'2MASX J09035865+2102507',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000198,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,135.994417,21.04733,0.101,NULL,63834865754,997419777,15584684,16.9),(58969,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58969,37.2,0.46,276,19284,70,NULL,NULL,'2MASX J09035918+2040547',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00016,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,135.9964583,20.68178,0.097,NULL,63834725857,997417591,15584649,17),(58970,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58970,37.75,0.27,355,19285,70,NULL,NULL,'2MASX J09035964+2648513',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,135.998375,26.81431,0.081,NULL,64374480256,1005851254,15716425,17.4),(58971,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58971,33.19,0.46,43.5,19286,70,NULL,NULL,'NGC 2737',NULL,'2015arXiv151105856S',2015,1,1.21,NULL,'G',0.00006,NULL,'14.0g',0.51,'Sab','Group member',NULL,NULL,NULL,1,135.998833,21.90656,0.097,NULL,63834564943,997415077,15584610,14),(58972,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,58972,33.16,0.47,42.9,19287,NULL,NULL,'H','NGC 2738',NULL,'2007A&A...465...71T',2007,1,1.75,'Multiple SDSS entries describe this object.','G',0.000013,NULL,'13.6g',0.67,'S?','in a pair',NULL,NULL,NULL,1,136.0015,21.96753,0.081,NULL,63834570102,997415157,15584611,13.6),(58973,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,58973,33.27,0.46,45.1,19287,NULL,NULL,'J','NGC 2738',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58974,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,58974,33.29,0.45,45.6,19287,NULL,NULL,'K','NGC 2738',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58975,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,58975,33.42,0.4,48.3,19287,NULL,NULL,'mean','NGC 2738',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(58976,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,58976,34.39,0.43,75.4,19288,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04754',NULL,'2014MNRAS.444..527S',2014,1,1.14,'UGC DEC. is -24\' in error. Multiple SDSS entries describe this object.','G',0.00015,NULL,'15.7',0.16,'Sbc            HII',NULL,NULL,NULL,NULL,1,136.004167,-0.08875,0.125,NULL,41071261271,641738457,10027163,15.7),(58977,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58977,36.56,0.46,206,19289,70,NULL,NULL,'2MASX J09040143+5238321',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000079,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,136.0060417,52.64233,0,NULL,64226839400,1003544365,15680380,17),(58978,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58978,37.62,0.46,334,19290,70,NULL,NULL,'2MASX J09040167+1437057',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,136.006917,14.61828,0.109,NULL,63872609845,998009528,15593898,18),(58979,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58979,37.88,0.46,377,19291,70,NULL,NULL,'2MASX J09040184+5052331',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000093,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,136.007625,50.87581,0.017,NULL,64237333801,1003708340,15682942,16.9),(58980,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58980,37.82,0.33,366,19292,70,NULL,NULL,'2MASX J09040255+5604145',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000065,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,136.01075,56.07089,0.049,NULL,62012507963,968945436,15139772,17.8),(58981,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58981,37.92,0.46,384,19293,70,NULL,NULL,'2MASX J09040296+5227361',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000107,NULL,'16.7g',0.28,'AGN',NULL,NULL,NULL,NULL,1,136.012375,52.46,0,NULL,64226746330,1003542911,15680357,16.7),(58982,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58982,38.71,0.46,552,19294,70,NULL,NULL,'2MASX J09040517+1545467',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000158,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,136.0215417,15.76314,0.105,NULL,63886402545,998225039,15597266,18.5),(58983,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58983,37.75,0.27,355,19295,70,NULL,NULL,'SDSS J090405.22+264926.1',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000167,NULL,'18.2g',NULL,NULL,NULL,NULL,NULL,NULL,1,136.02175,26.82392,0.081,NULL,64374480363,1005851255,15716425,18.2),(58984,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58984,37.09,0.27,262,19296,70,NULL,NULL,'2MASX J09040551+3057078',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000175,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,136.022875,30.95225,0.065,NULL,64387339418,1006052178,15719565,16.7),(58985,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58985,37.97,0.33,393,19297,70,NULL,NULL,'SDSS J090405.66+071810.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'18.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,136.023625,7.303,0.141,NULL,63680568590,995008884,15547013,18.1),(58986,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,58986,35.62,0.53,133,19298,70,NULL,NULL,'2MASX J09040572-1928564',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.73',NULL,NULL,NULL,NULL,NULL,NULL,1,136.02375,-19.48236,0.605,NULL,42351877617,661748087,10339813,15.73),(58987,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58987,37.09,0.27,262,19299,70,NULL,NULL,'2MASX J09040715+3052588',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000191,NULL,'16.1g',0.4,'E0',NULL,NULL,NULL,NULL,1,136.029875,30.88297,0.065,NULL,64387296932,1006051514,15719554,16.1),(58988,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58988,38.11,0.46,419,19300,70,NULL,NULL,'2MASX J09040853+1718297',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000163,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,136.035667,17.30819,0.077,NULL,63883974838,998187106,15596673,18.2),(58989,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58989,35.58,0.21,130,19301,70,NULL,NULL,'MRK 1223',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000169,NULL,'16.0g',0.36,NULL,NULL,NULL,NULL,NULL,1,136.038583,17.07625,0.081,NULL,63886862156,998232221,15597378,16),(58990,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58990,36.85,0.46,234,19302,70,NULL,NULL,'2MASX J09041126+2237516',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000146,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,136.046958333,22.63097,0.105,NULL,63823659225,997244675,15581948,17.4),(58991,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58991,37.1,0.46,263,19303,70,NULL,NULL,'2MASX J09041201+0226258',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00008,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,136.05,2.44036,0.109,NULL,63621283328,994082552,15532539,17.4),(58992,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58992,36.51,0.46,200,19304,70,NULL,NULL,'2MASX J09041219+0400227',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,136.050875,4.00631,0.097,NULL,63634353150,994286767,15535730,17),(58993,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58993,38.92,0.46,608,19305,70,NULL,NULL,'SDSS J090413.82+535615.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00007,NULL,'18.0g',0.19,'BLAGN',NULL,NULL,NULL,'Sy 1',1,136.057625,53.93772,0.009,NULL,63955679069,999307485,15614179,18),(58994,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58994,37.68,0.46,344,19306,70,NULL,NULL,'2MASX J09041394+2029496',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00018,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,136.0580417,20.49703,0.097,NULL,63836797541,997449961,15585155,16.9),(58995,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58995,37.38,0.27,300,19307,70,NULL,NULL,'2MASX J09041494+3519179',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,136.06225,35.32156,0.049,NULL,64423089825,1006610778,15728293,17.3),(58996,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58996,37.02,0.46,253,19308,70,NULL,NULL,'2MASX J09041504+1937566',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000167,NULL,'16.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,136.0627917,19.63239,0.085,NULL,63831624176,997369127,15583892,16.4),(58997,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58997,37.69,0.27,345,19309,70,NULL,NULL,'2MASX J09041533+1946296',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000159,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,136.0637917,19.77506,0.077,NULL,63831746194,997371034,15583922,18.1),(58998,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58998,37.97,0.21,392,19310,70,NULL,NULL,'2MASX J09041545+1917516',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000143,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,136.0642917,19.29781,0.073,NULL,63832004533,997375070,15583985,17.6),(58999,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',58999,37.09,0.27,262,19311,70,NULL,NULL,'2MASX J09041547+3052049',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,136.0644583,30.86803,0.065,NULL,64387294913,1006051483,15719554,17.3),(59000,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59000,35.89,0.46,150,19312,70,NULL,NULL,'2MASX J09041876+2226596',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000181,NULL,'15.7g',0.44,NULL,NULL,NULL,NULL,NULL,1,136.078083333,22.45008,0.101,NULL,63823649149,997244517,15581945,15.7),(59001,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59001,38.28,0.46,452,19313,70,NULL,NULL,'2MASX J09041938+1548284',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000184,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,136.08075,15.80794,0.105,NULL,63886447994,998225749,15597277,17.8),(59002,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59002,38.22,0.33,440,19314,70,NULL,NULL,'SDSS J090420.96+481058.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000125,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,136.087375,48.18303,0.061,NULL,64234548796,1003664824,15682262,18.7),(59003,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59003,36.45,0.46,195,19315,70,NULL,NULL,'2MASX J09042174+0322158',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,136.090666667,3.371,0.109,NULL,63634787442,994293553,15535836,17.3),(59004,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59004,36.18,0.59,172,19316,70,NULL,NULL,'2MASX J09042362-0835541',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.1I',0.2,NULL,NULL,NULL,NULL,NULL,1,136.098375,-8.59847,0.117,NULL,42210393886,659537404,10305271,15.1),(59005,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59005,37.96,0.46,391,19317,70,NULL,NULL,'2MASX J09042441+3721347',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000171,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,136.1017083,37.35964,0.049,NULL,64414865623,1006482275,15726285,17.9),(59006,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59006,36.96,0.46,246,19318,70,NULL,NULL,'2MASX J09042531+4927339',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000177,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,136.1052917,49.45931,0.029,NULL,64239481791,1003741902,15683467,16.7),(59007,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59007,37.97,0.21,392,19319,70,NULL,NULL,'2MASX J09042597+1913336',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000138,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,136.108375,19.22589,0.073,NULL,63832003139,997375049,15583985,18.4),(59008,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59008,38.22,0.33,440,19320,70,NULL,NULL,'2MASX J09042631+4811569',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,136.1095,48.19911,0.061,NULL,64234548900,1003664826,15682262,17.5),(59009,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59009,37.44,0.33,308,19321,70,NULL,NULL,'2MASX J09042672+1733574',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000176,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,136.111167,17.56606,0.081,NULL,63876415953,998068999,15594828,17.1),(59010,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59010,35.76,0.77,142,19322,70,NULL,NULL,'2MASX J09042684-7232222',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,136.111917,-72.53958,0.397,NULL,40735453379,636491459,9945179,15.7),(59011,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59011,37.54,0.46,323,19323,70,NULL,NULL,'SDSS J090427.20+463924.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000127,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,136.113416667,46.65692,0.037,NULL,64279679516,1004369992,15693281,18.4),(59012,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59012,37.02,0.46,253,19324,70,NULL,NULL,'2MASX J09043028+1711184',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000165,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,136.126083333,17.18831,0.081,NULL,63885803536,998215680,15597120,18.1),(59013,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59013,36.05,0.68,162,19325,70,NULL,NULL,'2MASX J09043213-1849458',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.08',NULL,NULL,NULL,NULL,NULL,NULL,1,136.1339583,-18.82953,0.421,NULL,42351067173,661735424,10339616,16.08),(59014,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59014,36.38,0.74,189,19326,70,NULL,NULL,'2MASX J09043312-2734155',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'13.53',0.29,NULL,NULL,NULL,NULL,NULL,1,136.138,-27.57108,0.461,NULL,42901723539,670339430,10474053,13.53),(59015,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59015,35.58,0.21,130,19327,70,NULL,NULL,'2MASX J09043321+1723544',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000173,NULL,'15.9g',0.43,NULL,NULL,NULL,NULL,NULL,1,136.1385,17.39847,0.077,NULL,63876371463,998068304,15594817,15.9),(59016,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59016,32.28,0.43,28.6,19328,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04753',NULL,'2014MNRAS.444..527S',2014,1,1.76,'Multiple SDSS entries describe this object.','G',0.00001,NULL,'15.59',0.2,'Sdm',NULL,NULL,NULL,NULL,1,136.1389583,45.29017,0.037,NULL,64289652845,1004525825,15695716,15.59),(59017,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59017,32.69,NULL,34.4,19328,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04753',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59018,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59018,32.7,NULL,34.7,19328,NULL,NULL,'Dipole + Quadrupole','UGC 04753',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59019,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59019,32.71,NULL,34.8,19328,NULL,NULL,'Dipole','UGC 04753',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59020,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59020,33.29,0.49,45.5,19328,75,NULL,'IR','UGC 04753',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59021,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59021,33.31,NULL,45.9,19328,NULL,NULL,NULL,'UGC 04753',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59022,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59022,34.16,0.48,67.9,19329,70,NULL,NULL,'2MASX J09043369-6439404',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000123,NULL,'15.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,136.1405,-64.66119,0.633,NULL,40786002286,637281285,9957520,15.7),(59023,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59023,37.97,0.21,392,19330,70,NULL,NULL,'2MASX J09043400+1917261',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,136.141791667,19.29067,0.073,NULL,63832059867,997375935,15583998,17.9),(59024,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59024,37.45,0.46,308,19331,70,NULL,NULL,'2MASX J09043460+0535297',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000142,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,136.1442083,5.59144,0.149,NULL,63625482145,994148158,15533564,17.4),(59025,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59025,37.38,0.27,300,19332,70,NULL,NULL,'2MASX J09043495+3516228',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000095,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,136.1457083,35.27306,0.049,NULL,64423161395,1006611896,15728310,17.6),(59026,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59026,36.95,0.46,246,19333,70,NULL,NULL,'2MASX J09043509+5207135',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000103,NULL,'16.2g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,136.146166667,52.12042,0,NULL,64225623414,1003525365,15680083,16.2),(59027,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59027,36.62,0.46,211,19334,70,NULL,NULL,'2MASX J09043671+3619303',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000156,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,136.153041667,36.32517,0.045,NULL,64422859224,1006607175,15728237,16.5),(59028,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59028,37.33,0.46,292,19335,70,NULL,NULL,'2MASX J09043690+5219275',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000091,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,136.153875,52.32431,0,NULL,64226746653,1003542916,15680358,17),(59029,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59029,37.97,0.21,392,19336,70,NULL,NULL,'2MASX J09043803+1907551',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000185,NULL,'17.0g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,136.158625,19.13192,0.073,NULL,63831984855,997374763,15583980,17),(59030,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59030,37.59,0.46,330,19337,70,NULL,NULL,'2MASX J09043813+3323534',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,136.158833,33.39825,0.025,NULL,64410821473,1006419085,15725298,17.2),(59031,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59031,33.69,0.4,54.6,19338,NULL,NULL,'mean','NGC 2744',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'GPair',0.000017,NULL,NULL,NULL,'SB(s)ab: pec','Isolated galaxy (6 Mpc isolation)',NULL,NULL,NULL,1,136.162083,18.46028,0.077,NULL,63877005780,998078215,15594972,NULL),(59032,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59032,34.23,0.47,70,19338,NULL,NULL,'H','NGC 2744',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59033,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59033,34.37,0.46,74.7,19339,70,NULL,NULL,'NGC 2745',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000175,NULL,'15.5g',0.4,NULL,'Group member',NULL,NULL,NULL,1,136.163875,18.25736,0.077,NULL,63877149995,998080468,15595007,15.5),(59034,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59034,37.58,0.33,329,19340,70,NULL,NULL,'2MASX J09043947+3705353',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000184,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,136.164666667,37.09308,0.041,NULL,64415053608,1006485212,15726331,16.6),(59035,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59035,38.76,0.46,565,19341,70,NULL,NULL,'SDSS J090440.30+142545.3',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000169,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,136.167958333,14.42928,0.105,NULL,63872674233,998010534,15593914,18.6),(59036,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59036,37.97,0.21,392,19342,70,NULL,NULL,'2MASX J09044036+1917471',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,136.168167,19.29653,0.073,NULL,63832057486,997375898,15583998,17.6),(59037,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59037,38.2,0.23,436,19343,70,NULL,NULL,'2MASX J09044054+1356574',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,'PHOT','16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,136.1690417,13.94928,0.089,NULL,63865881329,997904395,15592256,16.7),(59038,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59038,35.55,0.6,129,19344,70,NULL,NULL,'ESO 497- G 006',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000113,NULL,'15.92',0.5,'S0-a',NULL,NULL,NULL,NULL,1,136.1717083,-25.84358,0.717,NULL,42833280373,669270005,10457343,15.92),(59039,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59039,37.44,0.33,308,19345,70,NULL,NULL,'2MASX J09044333+1734334',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000196,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,136.180417,17.57603,0.081,NULL,63876387199,998068549,15594821,17.2),(59040,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59040,35.81,0.46,145,19346,70,NULL,NULL,'CGCG 209-021',NULL,'2015arXiv151105856S',2015,1,0.97,NULL,'G',0.000167,NULL,'14.7g',0.68,'E0',NULL,NULL,NULL,NULL,1,136.181,42.32031,0.029,NULL,64277243521,1004331930,15692686,14.7),(59041,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59041,37.69,0.27,345,19347,70,NULL,NULL,'2MASX J09044369+1956081',NULL,'2015arXiv151105856S',2015,1,0.6,'TXS codes: lobes(W)','G',0.000213,NULL,'15.8g',0.48,'BrClG',NULL,NULL,NULL,NULL,1,136.1822917,19.93553,0.109,NULL,63831788390,997371693,15583932,15.8),(59042,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59042,35.14,0.69,107,19348,100,NULL,'mid-IR','UGC 04758',NULL,'2013ApJ...771...88L',2013,1,1.2,NULL,'G',0.000008,NULL,'14.80',0.7,'SBb',NULL,NULL,NULL,NULL,1,136.19675,22.02842,0.101,NULL,63834226871,997409794,15584528,14.8),(59043,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59043,35.68,0.34,137,19348,NULL,NULL,'Malmquist cor.','UGC 04758',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59044,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59044,36.07,0.28,164,19348,NULL,NULL,NULL,'UGC 04758',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59045,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59045,36.09,0.4,165,19348,NULL,NULL,'mean','UGC 04758',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59046,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59046,36.27,0.2,179,19348,74.4,NULL,NULL,'UGC 04758',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59047,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59047,36.37,0.47,188,19348,NULL,NULL,'H','UGC 04758',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59048,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59048,36.89,0.46,239,19349,70,NULL,NULL,'2MASX J09044814+3304014',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000174,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,136.2004583,33.067,0.025,NULL,64410784938,1006418514,15725289,16.7),(59049,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59049,36.87,0.58,237,19350,70,NULL,NULL,'2MASX J09044837-0907064',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,136.201625,-9.11842,0.117,NULL,42209519265,659523738,10305058,14.7),(59050,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59050,38.2,0.23,436,19351,70,NULL,NULL,'2MASX J09044927+1355424',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000141,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,136.205458333,13.92864,0.089,NULL,63865883278,997904426,15592256,18.3),(59051,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59051,37.69,0.27,345,19352,70,NULL,NULL,'2MASX J09044958+1954001',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000196,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,136.206583333,19.90003,0.109,NULL,63831795584,997371806,15583934,16.4),(59052,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59052,38.2,0.23,436,19353,70,NULL,NULL,'2MASX J09044968+1356524',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,136.206917,13.94803,0.089,NULL,63865883079,997904423,15592256,17.7),(59053,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59053,35.4,0.23,120,19354,70,NULL,NULL,'CGCG 061-058',NULL,'2015arXiv151105856S',2015,1,1.03,NULL,'G',0.000093,NULL,'14.3g',0.72,'S?','Pair member (points to parent)',NULL,NULL,NULL,1,136.209,13.56189,0.089,NULL,63863039841,997859997,15591562,14.3),(59054,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59054,35.58,0.21,130,19355,70,NULL,NULL,'SDSS J090450.73+172700.9',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',NULL,NULL,'15.7g',0.37,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,136.211375,17.45028,0.077,NULL,63876427340,998069177,15594830,15.7),(59055,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59055,37.72,0.46,350,19356,70,NULL,NULL,'2MASX J09045094+2918426',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000141,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,136.21225,29.31194,0.065,NULL,64389774285,1006090223,15720159,18),(59056,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59056,37.26,0.46,284,19357,70,NULL,NULL,'2MASX J09045222+5157205',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000078,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,136.217875,51.95575,0,NULL,64226076871,1003532451,15680194,17.6),(59057,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59057,37.56,0.46,325,19358,70,NULL,NULL,'2MASX J09045351+6242237',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,136.223166667,62.70653,0.177,NULL,62062579201,969727800,15151996,16.8),(59058,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59058,35.58,0.21,130,19359,70,NULL,NULL,'2MASX J09045500+1725334',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00011,NULL,'15.8g',0.43,NULL,NULL,NULL,NULL,NULL,1,136.229333,17.42581,0.077,NULL,63876424460,998069132,15594830,15.8),(59059,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59059,35.3,0.46,115,19360,70,NULL,NULL,'2MASX J09045531+3357224',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000159,NULL,'15.6g',0.43,'LINER',NULL,NULL,NULL,NULL,1,136.230583,33.95614,0.033,NULL,64410607569,1006415743,15725245,15.6),(59060,'Tully est','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59060,31.9,0.8,24,19361,75,NULL,'B','NGC 2726',NULL,'1988NBGC.C....0000T',1988,1,1.6,'MCG misprints R.A. as 08h01.0m. MRK list I & UGC misidentify this as MRK0018','G',0.000037,NULL,'13.40',0.5,'Sa?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,136.236541667,59.93292,0.157,NULL,62070261772,969847840,15153872,13.4),(59061,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59061,33.73,0.43,55.7,19361,75,NULL,'3.6 micron, color corrected','NGC 2726',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59062,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59062,33.73,0.2,55.7,19361,74.4,NULL,NULL,'NGC 2726',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59063,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59063,33.83,0.43,58.3,19361,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2726',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59064,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59064,37.67,0.46,342,19362,70,NULL,NULL,'2MASX J09045575+5242105',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000072,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,136.232541667,52.70289,0,NULL,64226635025,1003541172,15680330,18),(59065,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59065,35.58,0.21,130,19363,70,NULL,NULL,'UGC 04761',NULL,'2015arXiv151105856S',2015,1,1.06,NULL,'G',0.000097,NULL,'14.3g',0.79,'E',NULL,NULL,NULL,NULL,1,136.233875,17.45514,0.077,NULL,63876425269,998069144,15594830,14.3),(59066,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59066,37.58,0.33,329,19364,70,NULL,NULL,'2MASX J09045619+3706054',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,136.234333,37.10142,0.041,NULL,64415052192,1006485190,15726331,18.2),(59067,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59067,38.33,0.46,464,19365,70,NULL,NULL,'2MASX J09045696+5442568',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000079,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,136.2375,54.71569,0.021,NULL,63954882785,999295043,15613985,17.8),(59068,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59068,38.2,0.23,436,19366,70,NULL,NULL,'2MASX J09045717+1356244',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000169,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,136.238291667,13.94028,0.089,NULL,63865882813,997904418,15592256,18.1),(59069,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59069,36.65,0.46,214,19367,70,NULL,NULL,'2MASX J09045722+1826360',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,136.2385,18.44339,0.077,NULL,63876998520,998078101,15594970,17.3),(59070,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59070,37.72,0.46,350,19368,70,NULL,NULL,'2MASX J09045772+1711064',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,136.240583,17.18506,0.081,NULL,63877680123,998088751,15595136,18.2),(59071,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59071,37.47,0.46,311,19369,70,NULL,NULL,'SDSS J090458.22+625030.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,136.242583,62.84194,0.165,NULL,62062349785,969724215,15151940,18.4),(59072,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59072,36.81,0.46,230,19370,70,NULL,NULL,'2MASX J09045952+5022484',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000091,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,136.2477917,50.38008,0.061,NULL,64237663008,1003713484,15683023,16.9),(59073,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59073,38.46,0.33,493,19371,70,NULL,NULL,'SDSS J090501.50+314415.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000169,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,136.2562917,31.7375,0.005,NULL,64379879734,1005935620,15717744,18.6),(59074,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59074,36.59,0.98,208,19372,70,NULL,NULL,'FAIRALL 1349',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'15.8B',0.5,NULL,NULL,NULL,NULL,NULL,1,136.266417,-72.03103,0.457,NULL,40738873588,636544899,9946014,15.8),(59075,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59075,38.33,0.46,463,19373,70,NULL,NULL,'SDSS J090506.95+515333.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000079,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,136.279,51.89264,0,NULL,64226128363,1003533255,15680207,18),(59076,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59076,37.91,0.23,382,19374,70,NULL,NULL,'2MASX J09050757+2314072',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000169,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,136.2814583,23.23519,0.113,NULL,63822931530,997233305,15581770,17.9),(59077,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59077,38.25,0.46,446,19375,70,NULL,NULL,'SDSS J090507.63+071937.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,136.281833,7.32706,0.141,NULL,63680581515,995009086,15547016,18.6),(59078,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59078,38.46,0.33,493,19376,70,NULL,NULL,'SDSS J090508.86+314329.6',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000138,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,136.286916667,31.72489,0.005,NULL,64379883276,1005935676,15717744,18.6),(59079,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59079,37.91,0.23,382,19377,70,NULL,NULL,'SDSS J090510.86+230955.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000166,NULL,'18.3g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,136.295291667,23.16547,0.113,NULL,63823114903,997236170,15581815,18.3),(59080,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59080,34.56,0.49,81.6,19378,70,NULL,NULL,'NGC 2754',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000077,NULL,'15.18',0.5,'S0^0^ pec',NULL,NULL,NULL,NULL,1,136.2967083,-19.08486,0.489,NULL,42351828416,661747319,10339801,15.18),(59081,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59081,38.12,0.46,421,19379,70,NULL,NULL,'2MASX J09051143+3832329',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,136.2977917,38.54261,0.033,NULL,64412457192,1006444643,15725697,18.3),(59082,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59082,37.82,0.46,366,19380,70,NULL,NULL,'2MASX J09051220+2524197',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000187,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,136.3007083,25.40567,0.113,NULL,64190033593,1002969274,15671394,17.3),(59083,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59083,35.64,0.59,134,19381,70,NULL,NULL,'2MASX J09051292-2008419',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.5,NULL,NULL,NULL,NULL,NULL,1,136.3039583,-20.14489,0.645,NULL,42351226032,661737906,10339654,14.3),(59084,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59084,37.91,0.23,382,19382,70,NULL,NULL,'2MASX J09051352+2311132',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000186,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,136.3065417,23.18692,0.113,NULL,63823116781,997236199,15581815,16.7),(59085,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59085,37.77,0.46,358,19383,70,NULL,NULL,'SDSS J090514.54+632510.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,136.310583,63.41947,0.177,NULL,62029957949,969218092,15144032,18.4),(59086,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59086,37.56,0.33,325,19384,70,NULL,NULL,'2MASX J09051480+5223047',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000098,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,136.311875,52.38458,0,NULL,64225641878,1003525654,15680088,16.8),(59087,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59087,36.62,0.46,211,19385,70,NULL,NULL,'2MASX J09051520+4858167',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000152,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,136.313041667,48.97144,0.049,NULL,64234211622,1003659556,15682180,17.5),(59088,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59088,37.24,0.46,280,19386,70,NULL,NULL,'2MASX J09051609+0755223',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000176,NULL,'16.6g',0.32,'AGN',NULL,NULL,NULL,NULL,1,136.317167,7.92286,0.165,NULL,63679274224,994988659,15546697,16.6),(59089,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59089,36.8,0.46,229,19387,70,NULL,NULL,'2MASX J09051625+1438235',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,136.3177083,14.63994,0.089,NULL,63872550983,998008609,15593884,NULL),(59090,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59090,37.69,0.33,344,19388,70,NULL,NULL,'2MASX J09051678+1730185',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000194,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,136.3199583,17.505,0.077,NULL,63876396165,998068690,15594823,16.8),(59091,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59091,37.39,0.46,300,19389,70,NULL,NULL,'SDSS J090519.88+064449.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,136.332833,6.74717,0.149,NULL,63680857495,995013398,15547084,17.8),(59092,'HII LF','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'N',59092,45.22,1.76,1920,19390,71,NULL,NULL,'B2 0902+343 C006',3.099,'2005MNRAS.356.1117S',2005,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59093,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59093,37.91,0.23,382,19391,70,NULL,NULL,'2MASX J09052077+2310222',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000176,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,136.336667,23.17275,0.149,NULL,63823117506,997236211,15581815,17.9),(59094,'D-Sigma','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59094,33.54,0.4,51.1,19392,75,NULL,'Edat, raw','NGC 2749',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00007,NULL,'12.71',1.4,'E3             LINER','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,136.338833,18.31311,0.077,NULL,63877129245,998080144,15595002,12.71),(59095,'D-Sigma','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59095,33.88,0.4,59.7,19392,75,NULL,'Edat, cor','NGC 2749',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59096,'Faber-Jackson','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59096,33.41,0.63,48.1,19392,95,NULL,'Michard 1979b, c','NGC 2749',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59097,'Faber-Jackson','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59097,33.51,0.46,50.4,19392,95,NULL,'Michard 1979a','NGC 2749',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59098,'Faber-Jackson','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59098,33.55,0.3,51.3,19392,95,NULL,'Weighted Mean','NGC 2749',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59099,'Faber-Jackson','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59099,33.98,0.4,62.5,19392,95,NULL,'de Vaucouleurs','NGC 2749',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59100,'Tertiary','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59100,32.91,0.5,38.2,19392,95,NULL,NULL,'NGC 2749',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59101,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59101,34.1,0.4,65.9,19392,NULL,NULL,'mean','NGC 2749',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59102,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59102,34.26,0.45,71.1,19392,NULL,NULL,'K','NGC 2749',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59103,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59103,36.91,0.46,241,19393,70,NULL,NULL,'2MASX J09052348+2402567',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,136.347875,24.04894,0.109,NULL,63703583582,995368493,15552632,17.1),(59104,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59104,37.29,0.46,288,19394,70,NULL,NULL,'SDSS J090523.97+562357.7',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000083,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,136.349917,56.39939,0.089,NULL,62010350843,968911731,15139245,16.3),(59105,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59105,37.07,0.46,259,19395,70,NULL,NULL,'2MASX J09052622+2313032',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000179,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,136.3592917,23.21747,0.149,NULL,63823103948,997235999,15581812,16.2),(59106,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59106,36.64,0.59,213,19396,70,NULL,NULL,'2MASX J09052703-0733088',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.86',NULL,NULL,NULL,NULL,NULL,NULL,1,136.362583,-7.55267,0.145,NULL,42202103700,659407870,10303247,16.86),(59107,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59107,37.56,0.33,325,19397,70,NULL,NULL,'SDSS J090527.19+522200.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000099,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,136.363333,52.36672,0,NULL,64225654243,1003525847,15680091,18.2),(59108,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59108,38.11,0.46,420,19398,70,NULL,NULL,'2MASX J09052779+2705087',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000189,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,136.3659583,27.08564,0.081,NULL,64193038493,1003016226,15672128,17.1),(59109,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59109,37.69,0.33,344,19399,70,NULL,NULL,'2MASX J09052782+1726385',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000191,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,136.3660417,17.44422,0.077,NULL,63878241535,998097523,15595273,16.7),(59110,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59110,37.99,0.46,396,19400,70,NULL,NULL,'2MASX J09052801+5035248',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000076,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,136.366875,50.59039,0.037,NULL,64237635740,1003713058,15683016,17.2),(59111,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59111,37.39,0.46,300,19401,70,NULL,NULL,'2MASX J09053075+1721085',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,136.378333,17.35239,0.077,NULL,63878257679,998097776,15595277,17.2),(59112,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59112,37.55,0.46,324,19402,70,NULL,NULL,'2MASX J09053119+0049352',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000085,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,136.379875,0.82639,0.109,NULL,60670350740,947974230,14812097,17),(59113,'IRAS','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59113,32.25,0.8,28.1,19403,75,NULL,'MAT, I','NGC 2758',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.00001,NULL,'13.96',0.5,'(R\')SBbc pec?  HII','Pair member (points to parent)',NULL,NULL,NULL,1,136.38,-19.04278,0.489,NULL,42351553291,661743020,10339734,13.96),(59114,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59114,31.74,0.32,22.3,19403,85,NULL,'I, inv','NGC 2758',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59115,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59115,31.76,0.32,22.5,19403,85,NULL,'I, raw','NGC 2758',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59116,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59116,32.05,0.43,25.8,19403,75,NULL,'MAT, I, inv','NGC 2758',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59117,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59117,32.07,0.43,26,19403,75,NULL,'MAT, I, raw','NGC 2758',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59118,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59118,32.36,0.43,29.6,19403,75,NULL,'MAT, I, cor','NGC 2758',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59119,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59119,32.51,0.2,31.8,19403,74.4,NULL,NULL,'NGC 2758',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59120,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59120,32.61,0.4,33.3,19403,NULL,NULL,NULL,'NGC 2758',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59121,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59121,32.78,0.56,36,19403,NULL,NULL,'Malmquist cor.','NGC 2758',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59122,'Tully-Fisher','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59122,32.93,0.52,38.6,19403,NULL,NULL,NULL,'NGC 2758',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59123,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59123,37.65,0.46,339,19404,70,NULL,NULL,'SDSS J090531.27+500732.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000154,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,136.380333333,50.12578,0.045,NULL,64237519902,1003711248,15682988,18.6),(59124,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59124,38.98,0.46,626,19405,70,NULL,NULL,'2MASX J09053303-0010136',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000097,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,136.387708333,-0.17053,0.109,NULL,41074037565,641781836,10027841,17.8),(59125,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,NULL,59125,34.33,0.47,73.6,19406,70,NULL,NULL,'IC 2437',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.000067,NULL,'13.92',1.1,'SAB(rs)0-:','Pair member (points to parent)',NULL,NULL,NULL,1,136.3879583,-19.20711,0.509,NULL,42351821585,661747212,10339800,13.92),(59126,'FP','2016-12-15 15:14:26','2016-12-16 11:19:33','1',NULL,'R',59126,37.46,0.46,311,19407,70,NULL,NULL,'2MASX J09053323+1555285',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000144,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,136.388666667,15.92456,0.089,NULL,63885709013,998214203,15597096,17.3),(59127,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59127,37.53,0.33,320,19408,70,NULL,NULL,'2MASX J09053427+3035517',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000183,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,136.393,30.59761,0.021,NULL,64389174271,1006080847,15720013,17.1),(59128,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59128,37.96,0.46,391,19409,70,NULL,NULL,'2MASX J09053447+1412325',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,136.39375,14.20908,0.093,NULL,63864880451,997888757,15592011,17.7),(59129,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59129,36.99,0.46,250,19410,70,NULL,NULL,'2MASX J09053720+2028175',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00017,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,136.405125,20.47147,0.105,NULL,63830236680,997347448,15583553,16.4),(59130,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59130,37.83,0.46,368,19411,70,NULL,NULL,'2MASX J09053738+5143588',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000078,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,136.405625,51.73306,0.017,NULL,64226098050,1003532782,15680199,17.2),(59131,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59131,37.69,0.46,346,19412,70,NULL,NULL,'2MASX J09053777+1321595',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,136.4075,13.36661,0.085,NULL,63863154852,997861794,15591590,17.6),(59132,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59132,37.33,0.46,293,19413,70,NULL,NULL,'2MASX J09053964+0929526',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000177,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,136.415125,9.49803,0.165,NULL,63671809647,994872025,15544875,17.3),(59133,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59133,36.95,0.46,246,19414,70,NULL,NULL,'2MASX J09054100+3324217',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000011,NULL,'16.2g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,136.420916667,33.40606,0.025,NULL,64410862219,1006419722,15725308,16.2),(59134,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59134,35.09,0.49,104,19415,75,NULL,'IR','NGC 2752',NULL,'2011yCatp016004901K',2011,1,1.9,'RC3 also gives an optical v = 4022 km/sec.','G',0.000033,NULL,'14.51',0.4,'SBb: sp','Group member of poor cluster',NULL,NULL,NULL,1,136.4292917,18.33972,0.077,NULL,63876911014,998076734,15594948,14.51),(59135,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59135,37.93,0.46,385,19416,70,NULL,NULL,'2MASX J09054350+0438239',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000171,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,136.4312083,4.64,0.101,NULL,63626570843,994165169,15533830,17.9),(59136,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59136,39.1,0.46,660,19417,70,NULL,NULL,'SDSS J090543.74+131728.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,136.4322917,13.29136,0.085,NULL,63863187988,997862312,15591598,18.2),(59137,'HII LF','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'N',59137,46.96,0.4,3980,19418,71,NULL,NULL,'B2 0902+343 C012',3.395,'2005MNRAS.356.1117S',2005,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59138,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59138,37.53,0.33,320,19419,70,NULL,NULL,'2MASX J09054403+3036547',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,136.4332083,30.61522,0.021,NULL,64389156864,1006080576,15720009,17.4),(59139,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59139,38.52,0.46,506,19420,70,NULL,NULL,'2MASX J09054476+3015598',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,136.436708333,30.26678,0.033,NULL,64389346874,1006083544,15720055,18.1),(59140,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59140,35.07,0.46,103,19421,70,NULL,NULL,'UGC 04767',NULL,'2015arXiv151105856S',2015,1,1.27,NULL,'G',0.000087,NULL,'13.9g',0.92,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,136.438583,36.35458,0.045,NULL,64423339814,1006614684,15728354,13.9),(59141,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59141,38.04,0.46,405,19422,70,NULL,NULL,'2MASX J09054538+2133516',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00018,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,136.439167,21.56442,0.105,NULL,63835033202,997422393,15584724,17.6),(59142,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59142,38.87,0.46,594,19423,70,NULL,NULL,'2MASX J09054582+3521078',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,136.441,35.35206,0.037,NULL,64423142034,1006611594,15728306,17.5),(59143,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59143,36.75,0.46,224,19424,70,NULL,NULL,'2MASX J09054591+4953457',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,136.4412083,49.89614,0.029,NULL,64237565935,1003711967,15682999,17.4),(59144,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59144,36.74,0.46,223,19425,70,NULL,NULL,'2MASX J09054733+3727164',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000161,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,136.447167,37.45467,0.045,NULL,64414958296,1006483723,15726308,16.6),(59145,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59145,29.74,0.43,8.9,19426,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2750',NULL,'2014MNRAS.444..527S',2014,1,1.9,NULL,'G',0.000013,NULL,'12.3',1.5,'Sc','Pair member (points to parent)',NULL,NULL,NULL,1,136.449625,25.43742,0.133,NULL,64190085208,1002970081,15671407,12.3),(59146,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59146,30.14,0.43,10.7,19426,75,NULL,'3.6 micron, color corrected','NGC 2750',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59147,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59147,32.92,0.4,38.4,19426,75,NULL,'B','NGC 2750',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59148,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59148,36.35,0.46,186,19427,70,NULL,NULL,'2MASX J09054830+3126298',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,136.4512083,31.44167,0,NULL,64379918903,1005936232,15717753,17),(59149,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59149,37.02,0.46,253,19428,70,NULL,NULL,'2MASX J09055151+0107500',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000123,NULL,'15.7g',0.45,'E',NULL,NULL,NULL,NULL,1,136.464625,1.13053,0.081,NULL,60669906676,947967291,14811988,15.7),(59150,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59150,39.24,0.46,703,19429,70,NULL,NULL,'SDSS J090551.95+153845.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,136.4665,15.64583,0.097,NULL,63885700031,998214062,15597094,18.6),(59151,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59151,38.17,0.46,430,19430,70,NULL,NULL,'2MASX J09055250+1702112',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000018,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,136.468917,17.03644,0.093,NULL,63877729535,998089523,15595148,18.2),(59152,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59152,37.11,0.46,264,19431,70,NULL,NULL,'2MASX J09055315+1915505',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,136.471375,19.26394,0.105,NULL,63831360037,997365000,15583828,17.8),(59153,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59153,34.55,0.49,81.2,19432,70,NULL,NULL,'2MASX J09055325-6417539',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00014,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,136.471875,-64.29833,0.701,NULL,40756262275,636816598,9950259,16.1),(59154,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59154,37.58,0.46,328,19433,70,NULL,NULL,'SDSS J090553.82+043211.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000131,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,136.474291667,4.53667,0.101,NULL,63626067307,994157301,15533707,18.4),(59155,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59155,37.19,0.46,274,19434,70,NULL,NULL,'2MASX J09055398+0040090',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000077,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,136.474916667,0.66917,0.109,NULL,60670257683,947972776,14812074,17.2),(59156,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59156,36.48,0.46,197,19435,70,NULL,NULL,'2MASX J09055432+4615331',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00015,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,136.4765417,46.25911,0.029,NULL,64279238008,1004363093,15693173,16.5),(59157,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59157,37.11,0.46,264,19436,70,NULL,NULL,'2MASX J09055455+0304420',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000207,NULL,'15.9g',0.4,'BrClG',NULL,NULL,NULL,NULL,1,136.4772917,3.07844,0.101,NULL,63634039911,994281873,15535654,15.9),(59158,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59158,37.64,0.46,338,19437,70,NULL,NULL,'2MASX J09055580+3347408',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000164,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,136.4824583,33.79481,0.029,NULL,64410528771,1006414512,15725226,18.3),(59159,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59159,37.47,0.46,312,19438,70,NULL,NULL,'2MASX J09055600+6003056',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,136.483375,60.05136,0.157,NULL,62070061472,969844710,15153823,17.6),(59160,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59160,37.27,0.46,284,19439,70,NULL,NULL,'2MASX J09055600+1448512',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,136.4834583,14.81414,0.125,NULL,63872773230,998012081,15593938,17.2),(59161,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59161,37.85,0.46,371,19440,70,NULL,NULL,'2MASX J09055773+1912085',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000214,NULL,'16.9g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,136.490541667,19.20239,0.105,NULL,63831477620,997366837,15583856,16.9),(59162,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59162,37.89,0.46,378,19441,70,NULL,NULL,'2MASX J09055970+1711562',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,136.498833,17.19906,0.081,NULL,63878227483,998097304,15595270,18.4),(59163,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59163,33.63,0.47,53.1,19442,NULL,NULL,'H','UGC 04773',NULL,'2007A&A...465...71T',2007,1,1.61,NULL,'G',0.000033,NULL,'14.5g',0.41,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,136.50125,18.76458,0.085,NULL,63876732683,998073948,15594905,14.5),(59164,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59164,33.69,0.4,54.6,19442,NULL,NULL,'mean','UGC 04773',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59165,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59165,33.71,0.46,55.3,19442,NULL,NULL,'J','UGC 04773',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59166,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59166,33.74,0.45,56,19442,NULL,NULL,'K','UGC 04773',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59167,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59167,34,0.49,63.2,19442,75,NULL,'IR','UGC 04773',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59168,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59168,37.95,0.27,389,19443,70,NULL,NULL,'2MASX J09060087+1522192',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000133,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,136.503875,15.37194,0.133,NULL,63872025161,998000393,15593756,18.3),(59169,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59169,38.11,0.46,419,19444,70,NULL,NULL,'SDSS J090601.07+190937.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000139,NULL,'18.5g',0.09,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,136.5044583,19.16036,0.105,NULL,63831476011,997366812,15583856,18.5),(59170,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59170,38.69,0.46,547,19445,70,NULL,NULL,'2MASX J09060242+1621302',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,136.510167,16.3585,0.097,NULL,63886465701,998226026,15597281,18),(59171,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59171,37.16,0.46,270,19446,70,NULL,NULL,'SDSS J090603.10+113506.9',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,136.512917,11.58528,0.057,NULL,63640974416,994390225,15537347,NULL),(59172,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59172,36.16,0.7,171,19447,70,NULL,NULL,'ESO 036- G 017',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.91',0.4,'S...',NULL,NULL,NULL,NULL,1,136.522083,-72.82972,0.353,NULL,40735516747,636492449,9945194,15.91),(59173,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59173,35.38,0.62,119,19448,70,NULL,NULL,'MCG -01-23-017',NULL,'2014MNRAS.445.2677S',2014,1,1.6,'MCG notes say that dec. for MCG -01-23 field is off by 8\'.','G',0.00015,NULL,'14.5',0.8,'SA(s)c?',NULL,NULL,NULL,NULL,1,136.52425,-4.35619,0.065,NULL,42154286593,658660728,10291573,14.5),(59174,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59174,34.91,0.42,95.7,19448,NULL,NULL,'Malmquist cor.','MCG -01-23-017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59175,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59175,35,0.2,100,19448,74.4,NULL,NULL,'MCG -01-23-017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59176,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59176,35.06,0.4,103,19448,NULL,NULL,'mean','MCG -01-23-017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59177,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59177,35.12,0.38,106,19448,NULL,NULL,NULL,'MCG -01-23-017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59178,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59178,35.23,0.47,111,19448,NULL,NULL,'H','MCG -01-23-017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59179,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59179,35.3,0.46,115,19448,NULL,NULL,'J','MCG -01-23-017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59180,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59180,35.33,0.45,116,19448,NULL,NULL,'K','MCG -01-23-017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59181,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59181,37.5,0.19,316,19449,70,NULL,NULL,'2MASX J09060787+2055568',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000181,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,136.532833,20.93242,0.093,NULL,63830385713,997349776,15583590,17.4),(59182,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59182,38.14,0.19,424,19450,70,NULL,NULL,'2MASX J09060802+5234482',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000071,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,136.533583,52.58003,0,NULL,64225572658,1003524572,15680071,17.7),(59183,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59183,38.57,0.46,518,19451,70,NULL,NULL,'SDSS J090609.39+005823.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00008,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,136.539167,0.97333,0.117,NULL,60670387195,947974799,14812106,18.2),(59184,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59184,37.48,0.46,314,19452,70,NULL,NULL,'2MASX J09060956+5504387',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000068,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,136.54025,55.0775,0,NULL,61875368132,966802627,15106291,17.8),(59185,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59185,37.44,0.46,307,19453,70,NULL,NULL,'2MASX J09061005+2515055',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,136.5420417,25.25156,0.133,NULL,64190047927,1002969498,15671398,16.9),(59186,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59186,35.83,0.46,146,19454,70,NULL,NULL,'2MASX J09061013+0823429',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000155,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,136.542333,8.39539,0.149,NULL,63683769796,995058903,15547795,16.6),(59187,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59187,37.01,0.46,253,19455,70,NULL,NULL,'2MASX J09061059+3301287',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000182,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,136.54425,33.02458,0.025,NULL,64410261838,1006410341,15725161,17),(59188,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59188,37.7,0.23,347,19456,70,NULL,NULL,'2MASX J09061149+1641374',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00019,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,136.548,16.69358,0.097,NULL,63877790010,998090468,15595163,17.9),(59189,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59189,37.39,0.23,301,19457,70,NULL,NULL,'SDSS J090612.08+223030.9',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000129,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,136.550375,22.50861,0.137,NULL,63822710924,997229858,15581716,18.6),(59190,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59190,38.08,0.46,413,19458,70,NULL,NULL,'SDSS J090612.52+113543.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,136.552166667,11.59539,0.057,NULL,63640963805,994390059,15537344,18.3),(59191,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59191,37.84,0.46,370,19459,70,NULL,NULL,'2MASX J09061328+3725414',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000172,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,136.55525,37.42817,0.049,NULL,64414971895,1006483935,15726311,16.7),(59192,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59192,37.1,0.46,263,19460,70,NULL,NULL,'2MASX J09061350+1835408',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000138,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,136.5564583,18.59453,0.077,NULL,63876833356,998075521,15594930,18.3),(59193,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59193,36.53,0.46,202,19461,70,NULL,NULL,'2MASX J09061429+5015292',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000157,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,136.5597917,50.25806,0.061,NULL,64237620123,1003712814,15683012,16.3),(59194,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59194,37.6,0.46,330,19462,70,NULL,NULL,'B3 0902+468',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.0005,NULL,'16.6g',0.32,'WLRG           LINER',NULL,NULL,NULL,NULL,1,136.56475,46.60528,0,NULL,64279216603,1004362759,15693168,16.6),(59195,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59195,36.55,0.46,205,19463,70,NULL,NULL,'2MASX J09061566+5511337',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000064,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,136.5652917,55.19247,0.009,NULL,61875395996,966803062,15106297,17.4),(59196,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59196,37.39,0.23,301,19464,70,NULL,NULL,'2MASX J09061686+2226498',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000181,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,136.5702917,22.44722,0.137,NULL,63822710763,997229855,15581716,16.6),(59197,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59197,36.45,0.33,195,19465,70,NULL,NULL,'2MASX J09061723+3349057',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000177,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,136.57175,33.81842,0.029,NULL,64410535004,1006414609,15725228,16.2),(59198,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59198,37.87,0.46,374,19466,70,NULL,NULL,'2MASX J09061781+3847284',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000141,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,136.5742917,38.79125,0,NULL,64395443911,1006178811,15721543,17.9),(59199,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59199,37.39,0.23,301,19467,70,NULL,NULL,'2MASX J09061801+2229438',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,136.574917,22.49558,0.137,NULL,63822722547,997230039,15581719,18),(59200,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59200,37.39,0.23,301,19468,70,NULL,NULL,'2MASX J09061931+2230228',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000142,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,136.580375,22.50653,0.137,NULL,63822722862,997230044,15581719,18.2),(59201,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59201,37.29,0.46,287,19469,70,NULL,NULL,'2MASX J09062050+0333099',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00004,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,136.5855,3.55275,0.101,NULL,63634012065,994281438,15535647,17.3),(59202,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59202,37.5,0.19,316,19470,70,NULL,NULL,'2MASX J09062065+2048108',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,136.586083,20.80319,0.093,NULL,63830455386,997350865,15583607,17.3),(59203,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59203,36.17,0.16,172,19471,70,NULL,NULL,'2MASX J09062087+4941392',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000189,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,136.587167,49.69431,0.029,NULL,64237381692,1003709088,15682954,16.8),(59204,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59204,37.57,0.46,327,19472,70,NULL,NULL,'2MASX J09062384+2719095',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,136.599375,27.31942,0.089,NULL,64192038544,1003000602,15671884,17.5),(59205,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59205,37.12,0.33,265,19473,70,NULL,NULL,'2MASX J09062399+2038418',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000183,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,136.600125,20.64508,0.093,NULL,63830446206,997350721,15583605,16.6),(59206,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59206,37.95,0.27,389,19474,70,NULL,NULL,'2MASX J09062402+2616355',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,136.600166667,26.27647,0.085,NULL,64190296901,1002973389,15671459,17.6),(59207,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59207,37.77,0.46,358,19475,70,NULL,NULL,'SDSS J090624.60+005756.0',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000105,NULL,'17.9g',0.19,'BLAGN',NULL,NULL,NULL,'Sy 1',1,136.6025417,0.96558,0.065,NULL,60670594621,947978040,14812156,17.9),(59208,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59208,37.88,0.46,376,19476,70,NULL,NULL,'2MASXi J0906258+153311',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000177,NULL,'18.0g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,136.607667,15.55322,0.093,NULL,63872011889,998000185,15593752,18),(59209,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59209,38.08,0.46,413,19477,70,NULL,NULL,'2MASX J09062717+5046061',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000077,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,136.61325,50.7685,0.037,NULL,64237754323,1003714911,15683045,17.6),(59210,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59210,37.1,0.46,263,19478,70,NULL,NULL,'2MASX J09062728+2259378',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,136.6137917,22.99383,0.145,NULL,63823025110,997234767,15581793,16.9),(59211,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59211,37.12,0.33,265,19479,70,NULL,NULL,'2MASX J09062741+2038308',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,136.614375,20.64203,0.093,NULL,63830474919,997351170,15583612,17.2),(59212,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59212,38,0.46,399,19480,70,NULL,NULL,'SDSS J090628.10+514817.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000075,NULL,'18.3g',0.17,'NLAGN',NULL,NULL,NULL,NULL,1,136.617125,51.80494,0.017,NULL,64226312786,1003536137,15680252,18.3),(59213,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59213,36.84,0.46,234,19481,70,NULL,NULL,'2MASX J09062920+1313134',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,136.621667,13.22036,0.085,NULL,63865948590,997905446,15592272,17.2),(59214,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59214,37.73,0.33,351,19482,70,NULL,NULL,'SDSS J090629.75+564341.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000072,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,136.624,56.72825,0.077,NULL,62010647617,968916369,15139318,18.7),(59215,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59215,38.14,0.19,424,19483,70,NULL,NULL,'2MASX J09063029+5235161',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000096,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,136.626083333,52.58786,0,NULL,64225571743,1003524558,15680071,17),(59216,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59216,37.83,0.27,369,19484,70,NULL,NULL,'2MASX J09063057+3902523',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000147,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,136.62725,39.04781,0.013,NULL,64395647275,1006181988,15721593,18.2),(59217,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59217,34.39,0.46,75.5,19485,70,NULL,NULL,'MCG -01-23-019',NULL,'2014MNRAS.445.2677S',2014,1,1.5,'MCG notes say that dec. for MCG -01-23 zone is off by 8\'.','G',0.000113,NULL,'15',0.9,'SA(r)0-? poss. LINER',NULL,NULL,NULL,NULL,1,136.6417083,-7.24097,0.129,NULL,42202222246,659409722,10303276,15),(59218,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59218,32.04,0.2,25.6,19486,74.4,NULL,NULL,'UGC 04781',NULL,'2013AJ....146...86T',2013,1,1.57,NULL,'G',0.000017,NULL,'15.2g',0.47,'Scd:','Isolated galaxy',NULL,NULL,NULL,1,136.642875,6.30381,0.133,NULL,63680508045,995007938,15546999,15.2),(59219,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59219,32.11,0.52,26.4,19486,NULL,NULL,NULL,'UGC 04781',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59220,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59220,32.35,0.47,29.5,19486,NULL,NULL,'Malmquist cor.','UGC 04781',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59221,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59221,37.95,0.27,389,19487,70,NULL,NULL,'2MASX J09063481+2617404',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,136.645041667,26.29444,0.085,NULL,64190290962,1002973296,15671457,17.5),(59222,'IRAS','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59222,33.92,0.8,60.8,19488,75,NULL,'MAT, I','ESO 036- G 019',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000023,NULL,'13.73',0.8,'(R\')SAB(rs)c',NULL,NULL,NULL,NULL,1,136.648833,-75.82569,0.517,NULL,39943710248,624120472,9751882,13.73),(59223,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59223,33.52,0.47,50.6,19488,NULL,NULL,'H','ESO 036- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59224,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59224,33.56,0.46,51.5,19488,NULL,NULL,'J','ESO 036- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59225,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59225,33.57,0.45,51.7,19488,NULL,NULL,'K','ESO 036- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59226,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59226,33.71,0.43,55.2,19488,75,NULL,'MAT, I, raw','ESO 036- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59227,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59227,33.76,0.32,56.6,19488,85,NULL,'I, raw','ESO 036- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59228,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59228,33.83,0.32,58.3,19488,85,NULL,'I, inv','ESO 036- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59229,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59229,33.88,0.4,59.8,19488,NULL,NULL,'mean','ESO 036- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59230,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59230,33.99,0.43,62.9,19488,75,NULL,'MAT, I, inv','ESO 036- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59231,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59231,34.05,0.43,64.5,19488,75,NULL,'MAT, I, cor','ESO 036- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59232,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59232,34.21,0.39,69.5,19488,NULL,NULL,'Malmquist cor.','ESO 036- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59233,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59233,34.34,0.37,73.8,19488,NULL,NULL,NULL,'ESO 036- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59234,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59234,34.38,0.2,75.2,19488,74.4,NULL,NULL,'ESO 036- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59235,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59235,33.87,NULL,59.5,19489,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -01-23-020',NULL,'2010Ap&SS.325..163P',2010,1,2.12,'MCG notes say that dec. for MCG -01-23 zone is off by 8\'.','G',0.00002,NULL,'16',0.17,'Sd',NULL,NULL,NULL,NULL,1,136.654667,-6.56872,0.093,NULL,42200646182,659385096,10302892,16),(59236,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59236,33.88,NULL,59.7,19489,NULL,NULL,'Dipole + Quadrupole','MCG -01-23-020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59237,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59237,33.88,NULL,59.8,19489,NULL,NULL,'Dipole','MCG -01-23-020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59238,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59238,34.02,0.49,63.6,19489,75,NULL,'IR','MCG -01-23-020',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59239,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59239,34.18,0.43,68.5,19489,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-23-020',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59240,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59240,38.26,0.46,449,19490,70,NULL,NULL,'2MASX J09063728+5713103',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000086,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,136.65525,57.2195,0.061,NULL,62024162846,969127544,15142617,18.3),(59241,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59241,37.5,0.19,316,19491,70,NULL,NULL,'2MASX J09063795+2048582',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000176,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,136.65825,20.81625,0.093,NULL,63830451750,997350808,15583606,17.4),(59242,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59242,38.14,0.19,424,19492,70,NULL,NULL,'2MASX J09063893+5236559',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000063,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,136.662083,52.61572,0,NULL,64225568883,1003524513,15680070,18.2),(59243,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59243,36.45,0.33,195,19493,70,NULL,NULL,'2MASX J09063909+3352078',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000087,NULL,'15.5g',0.48,'E0',NULL,NULL,NULL,NULL,1,136.6629583,33.86878,0.029,NULL,64410547801,1006414809,15725231,15.5),(59244,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59244,36.05,0.46,162,19494,70,NULL,NULL,'2MASX J09063956+4509141',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000064,NULL,'16.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,136.6649583,45.15378,0.029,NULL,64288711833,1004511122,15695486,16.4),(59245,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59245,37.83,0.27,369,19495,70,NULL,NULL,'SDSS J090639.70+390341.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000177,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,136.665417,39.06139,0.013,NULL,64395519619,1006179994,15721562,18),(59246,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59246,37.95,0.27,389,19496,70,NULL,NULL,'2MASX J09064024+2616537',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000147,NULL,'17.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,136.6677083,26.28164,0.085,NULL,64190298500,1002973414,15671459,17.4),(59247,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59247,32.43,0.43,30.7,19497,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04777',NULL,'2014MNRAS.444..527S',2014,1,1.77,NULL,'G',0.000017,NULL,'15.0g',0.42,'Im:','Isolated galaxy',NULL,NULL,NULL,1,136.6687083,34.61908,0.029,NULL,64410914818,1006420544,15725321,15),(59248,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59248,32.45,0.4,30.9,19497,75,NULL,'B','UGC 04777',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59249,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59249,32.47,0.43,31.1,19497,75,NULL,'3.6 micron, color corrected','UGC 04777',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59250,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59250,32.5,0.2,31.6,19497,74.4,NULL,NULL,'UGC 04777',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59251,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59251,32.64,0.4,33.7,19497,NULL,NULL,NULL,'UGC 04777',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59252,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59252,32.66,0.42,34,19497,NULL,NULL,'Malmquist cor.','UGC 04777',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59253,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59253,32.76,0.4,35.6,19497,NULL,NULL,NULL,'UGC 04777',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59254,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59254,34.45,0.39,77.5,19498,NULL,NULL,'Malmquist cor.','2MASX J09064137-1000302',NULL,'2009ApJS..182..474S',2009,1,1.02,NULL,'G',0.00002,NULL,'13.64',0.5,'Sc             HII',NULL,NULL,NULL,NULL,1,136.672375,-10.00839,0.161,NULL,42188472435,659194881,10299920,13.64),(59255,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59255,34.48,0.39,78.8,19498,NULL,NULL,NULL,'2MASX J09064137-1000302',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59256,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59256,34.52,0.2,80.2,19498,74.4,NULL,NULL,'2MASX J09064137-1000302',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59257,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59257,37.15,0.33,270,19499,70,NULL,NULL,'2MASX J09064182+3734343',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000176,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,136.674291667,37.57611,0.009,NULL,64414472362,1006476130,15726189,16.6),(59258,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59258,35.76,0.52,142,19500,70,NULL,NULL,'2MASX J09064433-1745230',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.05',0.3,NULL,NULL,NULL,NULL,NULL,1,136.684667,-17.75639,0.281,NULL,42407686690,662620104,10353439,16.05),(59259,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59259,36.34,0.33,185,19501,70,NULL,NULL,'2MASX J09064478+4415391',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000187,NULL,'15.4g',0.47,'E0',NULL,NULL,NULL,NULL,1,136.686417,44.26097,0.009,NULL,64289073782,1004516777,15695574,15.4),(59260,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59260,38.14,0.19,424,19502,70,NULL,NULL,'2MASX J09064640+5236580',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000081,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,136.69325,52.61611,0.009,NULL,64225600753,1003525011,15680078,18.3),(59261,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59261,38.14,0.19,424,19503,70,NULL,NULL,'2MASX J09064665+5225370',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00008,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,136.694458333,52.427,0,NULL,64225782138,1003527845,15680122,18.1),(59262,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59262,37.15,0.19,270,19504,70,NULL,NULL,'2MASX J09064700+5218070',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000086,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,136.695916667,52.30197,0.009,NULL,64225795922,1003528061,15680125,17.3),(59263,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59263,37.5,0.19,316,19505,70,NULL,NULL,'SDSS J090647.91+205114.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000163,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,136.699666667,20.85414,0.093,NULL,63830381001,997349703,15583589,18.3),(59264,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59264,37.29,0.46,288,19506,70,NULL,NULL,'2MASX J09064832+1410104',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,136.701291667,14.16961,0.105,NULL,63865084865,997891951,15592061,16.9),(59265,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59265,38.13,0.33,422,19507,70,NULL,NULL,'SDSS J090648.33+490447.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000136,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,136.701375,49.07981,0.041,NULL,64234255077,1003660235,15682191,18.3),(59266,'Ring Diameter','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59266,31.2,0.76,17,19508,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 2763',NULL,'1981ApJS...45..541P',1981,1,2.3,NULL,'G',0.000021,NULL,'12.64',2,'SB(r)cd pec    HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,136.704375,-15.49978,0.157,NULL,42398338637,662474041,10351156,12.64),(59267,'Ring Diameter','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59267,32.2,0.6,27,19508,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 2763',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59268,'IRAS','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59268,32.22,0.8,27.8,19508,75,NULL,'MAT, I','NGC 2763',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59269,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59269,31.95,0.4,24.5,19508,NULL,NULL,NULL,'NGC 2763',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59270,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59270,31.95,0.4,24.5,19508,73,NULL,'opt','NGC 2763',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59271,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59271,32.05,0.4,25.7,19508,75,NULL,'B','NGC 2763',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59272,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59272,32.13,0.39,26.7,19508,73,NULL,'opt','NGC 2763',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59273,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59273,32.21,0.61,27.7,19508,NULL,NULL,NULL,'NGC 2763',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59274,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59274,32.22,0.61,27.8,19508,NULL,NULL,'Malmquist cor.','NGC 2763',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59275,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59275,32.26,0.2,28.3,19508,74.4,NULL,NULL,'NGC 2763',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59276,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59276,32.33,0.32,29.3,19508,85,NULL,'I, raw','NGC 2763',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59277,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59277,32.36,0.32,29.7,19508,85,NULL,'I, inv','NGC 2763',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59278,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59278,32.39,0.43,30,19508,75,NULL,'MAT, I, raw','NGC 2763',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59279,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59279,32.56,0.43,32.5,19508,75,NULL,'MAT, I, inv','NGC 2763',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59280,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59280,32.59,0.4,32.9,19508,NULL,NULL,'mean','NGC 2763',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59281,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59281,32.6,0.43,33.1,19508,75,NULL,'MAT, I, cor','NGC 2763',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59282,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59282,32.62,0.47,33.3,19508,NULL,NULL,'H','NGC 2763',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59283,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59283,32.69,0.45,34.4,19508,NULL,NULL,'K','NGC 2763',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59284,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59284,32.69,0.46,34.5,19508,NULL,NULL,'J','NGC 2763',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59285,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59285,34.9,0.46,95.5,19509,70,NULL,NULL,'IC 2435',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000157,NULL,'14.7g',0.5,'E',NULL,NULL,NULL,NULL,1,136.7074583,26.27544,0.085,NULL,64190284804,1002973200,15671456,14.7),(59286,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59286,38.58,0.46,521,19510,70,NULL,NULL,'2MASX J09065044+2656447',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000146,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,136.7100417,26.94578,0.105,NULL,64193078888,1003016857,15672138,17.9),(59287,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59287,37.73,0.33,351,19511,70,NULL,NULL,'2MASX J09065131+5643014',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000087,NULL,'16.6g',0.37,NULL,NULL,NULL,NULL,NULL,1,136.713875,56.71717,0.077,NULL,62010650589,968916415,15139318,16.6),(59288,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59288,38.14,0.19,424,19512,70,NULL,NULL,'2MASX J09065156+5230450',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000079,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,136.71475,52.51239,0,NULL,64225563267,1003524426,15680069,17.7),(59289,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59289,36,0.33,159,19513,70,NULL,NULL,'CGCG 209-027',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.00016,NULL,'14.7g',0.56,'Sy1.9','Group member',NULL,NULL,'Flat-Spectrum Radio Source',1,136.72,41.40822,0,NULL,64265833823,1004153653,15689900,14.7),(59290,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59290,37.86,0.46,374,19514,70,NULL,NULL,'2MASX J09065289+1437264',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,136.720375,14.62408,0.089,NULL,63864977120,997890267,15592035,17.4),(59291,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59291,36.5,0.46,200,19515,70,NULL,NULL,'MCG +10-13-056',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000107,NULL,'16.0g',0.32,'S0^-',NULL,NULL,NULL,NULL,1,136.7287083,56.93617,0.069,NULL,62010563434,968915053,15139297,16),(59292,'IRAS','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59292,34.46,0.8,77.9,19516,75,NULL,'HMCL, I','CGCG 005-057',NULL,'1997ApJS..109..333W',1997,1,0.64,NULL,'G',0.000067,NULL,'15.5g',0.41,'Sc',NULL,NULL,NULL,NULL,1,136.7310417,-0.03131,0.097,NULL,41073020283,641765941,10027592,15.5),(59293,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59293,34.94,0.4,97.3,19516,75,NULL,'HMCL, I, raw','CGCG 005-057',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59294,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59294,35.06,0.4,103,19516,75,NULL,'HMCL, I, inv','CGCG 005-057',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59295,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59295,35.23,0.4,111,19516,75,NULL,'HMCL, I, cor','CGCG 005-057',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59296,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59296,37.25,0.46,282,19517,70,NULL,NULL,'2MASX J09065630+3956542',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,136.734458333,39.94819,0.025,NULL,64395769223,1006183894,15721623,17.1),(59297,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59297,38.04,0.46,406,19518,70,NULL,NULL,'SDSS J090657.49+172521.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,136.739583,17.42267,0.065,NULL,63878454035,998100844,15595325,18.4),(59298,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59298,37.48,0.17,314,19519,70,NULL,NULL,'2MASX J09065826+1552394',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,136.742875,15.87781,0.089,NULL,63885793312,998215520,15597117,16.9),(59299,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59299,37.5,0.19,316,19520,70,NULL,NULL,'2MASX J09065870+2047103',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.000083,NULL,'15.5g',0.51,NULL,NULL,NULL,NULL,NULL,1,136.744583,20.78631,0.093,NULL,63830483728,997351308,15583614,15.5),(59300,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59300,34.16,0.6,67.8,19521,70,NULL,NULL,'ESO 497- G 010',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000103,NULL,'15.82',0.3,'Sa',NULL,NULL,NULL,NULL,1,136.744875,-23.1825,1.041,NULL,42314678934,661166858,10330732,15.82),(59301,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59301,37.68,0.46,343,19522,70,NULL,NULL,'2MASX J09065897+3951284',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000182,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,136.7457917,39.85794,0,NULL,64396034944,1006188046,15721688,16.8),(59302,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59302,37.95,0.27,389,19523,70,NULL,NULL,'2MASX J09065925+1529434',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000142,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,136.746791667,15.49556,0.093,NULL,63871927476,997998866,15593732,17.6),(59303,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59303,37.67,0.46,341,19524,70,NULL,NULL,'2MASX J09065929+0522091',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000177,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,136.746958333,5.36931,0.117,NULL,63627134175,994173971,15533968,17.9),(59304,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59304,33.88,0.51,59.6,19525,70,NULL,NULL,'2MASX J09065937-1903314',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,136.747417,-19.05869,0.509,NULL,42351707439,661745428,10339772,13.8),(59305,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59305,36.3,0.46,182,19526,70,NULL,NULL,'2MASX J09065947+3657154',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,136.747625,36.95428,0,NULL,64414220722,1006472198,15726128,17.1),(59306,'IRAS','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59306,34.54,0.8,80.9,19527,75,NULL,'MAT, I','MCG -01-23-021',NULL,'1997ApJS..109..333W',1997,1,1.5,'MCG notes say that dec. for MCG -01-23 zone is off by 8\'.','G',0.00003,NULL,'14.5',1.5,'SABb',NULL,NULL,NULL,NULL,1,136.748833,-7.394,0.129,NULL,42202247579,659410118,10303283,14.5),(59307,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59307,33.91,0.32,60.4,19527,85,NULL,'I, raw','MCG -01-23-021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59308,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59308,33.95,0.43,61.7,19527,75,NULL,'MAT, I, raw','MCG -01-23-021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59309,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59309,33.95,0.32,61.8,19527,85,NULL,'I, inv','MCG -01-23-021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59310,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59310,34.18,0.43,68.5,19527,75,NULL,'MAT, I, inv','MCG -01-23-021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59311,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59311,34.28,0.38,71.9,19527,NULL,NULL,'Malmquist cor.','MCG -01-23-021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59312,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59312,34.31,0.43,72.7,19527,75,NULL,'MAT, I, cor','MCG -01-23-021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59313,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59313,34.32,0.2,73.1,19527,74.4,NULL,NULL,'MCG -01-23-021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59314,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59314,34.37,0.36,74.9,19527,NULL,NULL,NULL,'MCG -01-23-021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59315,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59315,34.57,0.47,82.2,19527,NULL,NULL,'H','MCG -01-23-021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59316,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59316,34.64,0.45,84.6,19527,NULL,NULL,'K','MCG -01-23-021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59317,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59317,34.66,0.46,85.5,19527,NULL,NULL,'J','MCG -01-23-021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59318,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59318,34.74,0.4,88.8,19527,NULL,NULL,'mean','MCG -01-23-021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59319,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59319,37.5,0.19,316,19528,70,NULL,NULL,'2MASX J09070027+2045423',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,136.7512917,20.76172,0.093,NULL,63830486470,997351351,15583614,17.4),(59320,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59320,38.26,0.46,449,19529,70,NULL,NULL,'SDSS J090700.43+030401.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,136.7517917,3.06703,0.077,NULL,63633916989,994279952,15535624,18.1),(59321,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59321,38.57,0.46,518,19530,70,NULL,NULL,'2MASX J09070065+6159388',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,136.752958333,61.99422,0.197,NULL,62062038853,969719357,15151864,17.9),(59322,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59322,37.74,0.33,353,19531,70,NULL,NULL,'2MASX J09070127+1649064',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000195,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,136.755375,16.81861,0.061,NULL,63877885706,998091964,15595186,17),(59323,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59323,36.76,0.64,225,19532,70,NULL,NULL,'2MASX J09070311-2026556',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.0I',0.2,NULL,NULL,NULL,NULL,NULL,1,136.763041667,-20.44883,0.661,NULL,42352656806,661760262,10340004,15),(59324,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59324,34.91,0.81,95.8,19533,NULL,NULL,'Malmquist cor.','AGC 490240',NULL,'2009ApJS..182..474S',2009,1,0.49,NULL,'G',0.00003,NULL,'16.07',NULL,'Sc','Group member',NULL,NULL,NULL,1,136.768083,-9.24764,0.113,NULL,42195765468,659308835,10301700,16.07),(59325,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59325,34.96,0.78,98.4,19533,NULL,NULL,NULL,'AGC 490240',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59326,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59326,37.95,0.27,389,19534,70,NULL,NULL,'2MASX J09070507+1527264',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,136.7710417,15.45747,0.093,NULL,63871932523,997998945,15593733,18.2),(59327,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59327,37.69,0.46,345,19535,70,NULL,NULL,'SDSS J090705.31+042510.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000124,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,136.772125,4.41958,0.089,NULL,63626170467,994158913,15533733,18),(59328,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59328,37.59,0.46,330,19536,70,NULL,NULL,'2MASX J09070533+4320330',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,136.772333,43.34258,0.021,NULL,64275555538,1004305555,15692274,17),(59329,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59329,37.83,0.27,369,19537,70,NULL,NULL,'2MASX J09070573+3903425',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000156,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,136.773833,39.06169,0.013,NULL,64395522707,1006180042,15721563,17),(59330,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59330,37.7,0.23,347,19538,70,NULL,NULL,'2MASX J09070643+1640464',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,136.7767083,16.67956,0.061,NULL,63877769238,998090144,15595158,17.4),(59331,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59331,37.19,0.46,274,19539,70,NULL,NULL,'2MASX J09070680+0608358',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,136.778333,6.14319,0.133,NULL,63680321757,995005027,15546953,17.3),(59332,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59332,39.41,0.46,760,19540,70,NULL,NULL,'SDSS J090707.00+024849.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000166,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,136.779208333,2.81381,0.105,NULL,63620472317,994069879,15532341,18.2),(59333,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59333,37.86,0.46,372,19541,70,NULL,NULL,'2MASX J09070730+4019565',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000171,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,136.780583,40.33228,0,NULL,64265577378,1004149646,15689838,16.9),(59334,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59334,37.52,0.46,320,19542,70,NULL,NULL,'2MASX J09070764+0404000',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,136.7817083,4.06681,0.093,NULL,63626109201,994157956,15533718,17.5),(59335,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59335,34.39,NULL,75.6,19543,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04786',NULL,'2010Ap&SS.325..163P',2010,1,1.1,NULL,'G',0.00003,NULL,'16.3g',0.17,'Sc',NULL,NULL,NULL,NULL,1,136.782583333,28.31608,0.069,NULL,64375414182,1005865846,15716653,16.3),(59336,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59336,34.41,NULL,76.1,19543,NULL,NULL,'Dipole','UGC 04786',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59337,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59337,34.42,NULL,76.5,19543,NULL,NULL,'Dipole + Quadrupole','UGC 04786',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59338,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59338,34.48,NULL,78.8,19543,NULL,NULL,NULL,'UGC 04786',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59339,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59339,34.5,0.49,79.5,19543,75,NULL,'IR','UGC 04786',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59340,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59340,37.2,0.46,275,19544,70,NULL,NULL,'2MASX J09070964+2015296',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000176,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,136.7902917,20.25814,0.093,NULL,63832288349,997379505,15584054,17.3),(59341,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59341,35.6,0.46,132,19545,70,NULL,NULL,'CGCG 238-011',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000177,NULL,'15.1g',0.63,'E0',NULL,NULL,NULL,NULL,1,136.793833333,46.21114,0,NULL,64279262310,1004363473,15693179,15.1),(59342,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59342,37.99,0.17,396,19546,70,NULL,NULL,'2MASX J09071137+5244529',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000099,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,136.797583,52.74817,0.009,NULL,64225555298,1003524301,15680067,18),(59343,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59343,38.02,0.46,402,19547,70,NULL,NULL,'2MASX J09071184+0454270',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,136.7992917,4.90747,0.105,NULL,63626753939,994168030,15533875,17.7),(59344,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59344,36.69,0.46,217,19548,70,NULL,NULL,'2MASX J09071231+1806536',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000163,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,136.8012917,18.11497,0.073,NULL,63878800468,998106257,15595410,16.6),(59345,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59345,37.74,0.33,353,19549,70,NULL,NULL,'2MASX J09071255+1651254',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000162,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,136.802166667,16.85714,0.061,NULL,63877886463,998091975,15595187,18.2),(59346,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59346,36.01,0.69,159,19550,70,NULL,NULL,'2MASX J09071285-6759005',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,136.8035,-67.98356,0.485,NULL,40798407885,637475123,9960548,16.7),(59347,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59347,35.38,0.53,119,19551,70,NULL,NULL,'2MASX J09071391-1559468',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000103,NULL,'16.25',0.4,NULL,NULL,NULL,NULL,NULL,1,136.808083,-15.99647,0.173,NULL,42409810776,662653293,10353957,16.25),(59348,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59348,37.49,0.33,315,19552,70,NULL,NULL,'2MASX J09071472+1637214',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000186,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,136.8112083,16.62256,0.069,NULL,63877767777,998090121,15595158,16.7),(59349,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59349,37.12,0.46,265,19553,70,NULL,NULL,'2MASX J09071467+0226340',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000097,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,136.81125,2.44269,0.105,NULL,60668632069,947947376,14811677,16.4),(59350,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59350,37.75,0.46,354,19554,70,NULL,NULL,'2MASX J09071508+0019570',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000073,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,136.812917,0.3325,0.105,NULL,60668209467,947940772,14811574,17.4),(59351,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59351,38,0.46,399,19555,70,NULL,NULL,'2MASX J09071544+1717144',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,136.814333,17.28731,0.065,NULL,63878313565,998098649,15595291,18),(59352,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59352,34.8,0.47,91.2,19556,NULL,NULL,'H','IC 2434',NULL,'2007A&A...465...71T',2007,1,1.5,'HOLM 109B,C are stars.','G',0.000063,NULL,'14.35',0.7,'SBc','in a radial-velocity based grouping',NULL,NULL,NULL,1,136.816916667,37.21528,0.02,NULL,64414978322,1006484036,15726313,14.35),(59353,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59353,34.88,0.45,94.8,19556,NULL,NULL,'K','IC 2434',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59354,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59354,34.92,0.46,96.3,19556,NULL,NULL,'J','IC 2434',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59355,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59355,35.15,0.4,107,19556,NULL,NULL,'mean','IC 2434',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59356,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59356,37.15,0.33,270,19557,70,NULL,NULL,'2MASXi J0907165+373908',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,136.818875,37.65253,0.009,NULL,64414478258,1006476222,15726190,18),(59357,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59357,37.05,0.46,257,19558,70,NULL,NULL,'2MASX J09071718+1727164',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000172,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,136.8215417,17.45469,0.065,NULL,63878409684,998100151,15595314,17.6),(59358,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59358,37.68,0.46,344,19559,70,NULL,NULL,'SDSS J090717.72+112217.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,136.823875,11.3715,0.081,NULL,63644164488,994440070,15538126,18.2),(59359,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59359,36.53,0.46,202,19560,70,NULL,NULL,'2MASX J09071777+1644184',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000205,NULL,'15.4g',0.51,NULL,NULL,NULL,NULL,NULL,1,136.823916667,16.73839,0.061,NULL,63877773665,998090213,15595159,15.4),(59360,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59360,37.49,0.33,315,19561,70,NULL,NULL,'2MASX J09071771+1640154',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000177,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,136.8239583,16.67106,0.069,NULL,63877769883,998090154,15595158,16.8),(59361,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59361,36.95,0.46,246,19562,70,NULL,NULL,'2MASX J09071829+3037316',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000178,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,136.82625,30.6255,0.021,NULL,64381214422,1005956475,15718069,16.3),(59362,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59362,37.99,0.17,396,19563,70,NULL,NULL,'2MASX J09071863+5247215',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000066,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,136.8277917,52.78922,0.009,NULL,64225558396,1003524349,15680067,17.9),(59363,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59363,37.4,0.46,302,19564,70,NULL,NULL,'2MASX J09071965+6245444',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,136.8315417,62.76222,0.177,NULL,62062341062,969724079,15151938,17.2),(59364,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59364,37.7,0.23,347,19565,70,NULL,NULL,'2MASX J09072049+1639064',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000214,NULL,'15.6g',0.55,'BrClG',NULL,NULL,NULL,NULL,1,136.835458333,16.65189,0.069,NULL,63877771250,998090175,15595158,15.6),(59365,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59365,38.6,0.46,524,19566,70,NULL,NULL,'2MASX J09072069+1653124',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,136.836167,16.88669,0.061,NULL,63877886473,998091976,15595187,18),(59366,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59366,38.03,0.46,403,19567,70,NULL,NULL,'2MASX J09072176+1600404',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,136.840791667,16.01144,0.089,NULL,63885653917,998213342,15597083,17.4),(59367,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59367,37.3,0.47,288,19568,NULL,NULL,'Malmquist cor.','AGC 490243',NULL,'2009ApJS..182..474S',2009,1,0.51,NULL,'G',0.00003,NULL,'15.82',NULL,'Sc',NULL,NULL,NULL,NULL,1,136.8410417,-9.24511,0.113,NULL,42195772972,659308952,10301702,15.82),(59368,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59368,37.38,0.45,299,19568,NULL,NULL,NULL,'AGC 490243',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59369,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59369,36.99,0.49,250,19569,75,NULL,'IR','2MFGC 07104',NULL,'2011yCatp016004901K',2011,1,NULL,NULL,'G',0.000267,NULL,'16.3R',NULL,'S','Group member',NULL,NULL,NULL,1,136.8414583,-9.27839,0.113,NULL,42195774559,659308977,10301702,16.3),(59370,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59370,37.42,0.2,305,19570,74.4,NULL,NULL,'2MFGC 07104',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000267,NULL,'16.3R',NULL,'S','Group member',NULL,NULL,NULL,1,136.8414583,-9.27839,0.113,NULL,42195774559,659308977,10301702,16.3),(59371,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59371,36.14,0.46,169,19571,70,NULL,NULL,'2MASX J09072220+4316313',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000174,NULL,'15.7g',0.43,'E0',NULL,NULL,NULL,NULL,1,136.8425,43.27542,0.021,NULL,64275436977,1004303702,15692245,15.7),(59372,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59372,37.04,0.46,256,19572,70,NULL,NULL,'2MASX J09072277+4406393',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000128,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,136.844875,44.11083,0.009,NULL,64288381597,1004505962,15695405,17.5),(59373,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59373,36.21,0.46,174,19573,70,NULL,NULL,'2MASX J09072363+0939198',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,136.8485417,9.65564,0.153,NULL,63671734264,994870847,15544856,16.5),(59374,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59374,38.33,0.46,463,19574,70,NULL,NULL,'2MASX J09072662+5612310',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000091,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,136.861,56.2085,0.045,NULL,62010410513,968912664,15139260,17.6),(59375,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59375,36.97,0.46,247,19575,70,NULL,NULL,'2MASX J09072898+6239324',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,136.8705417,62.659,0.173,NULL,62061309693,969707963,15151686,18.1),(59376,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59376,36.21,0.46,175,19576,70,NULL,NULL,'2MASX J09072944+5039156',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000082,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,136.8727083,50.65439,0.037,NULL,64237804189,1003715690,15683057,16.4),(59377,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59377,37.36,0.46,296,19577,70,NULL,NULL,'2MASX J09073039+5124516',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000077,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,136.876667,51.41442,0.021,NULL,64226193017,1003534265,15680222,18.2),(59378,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59378,37.92,0.46,384,19578,70,NULL,NULL,'SDSS J090731.56+595608.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,136.8815,59.93581,0.157,NULL,62070017299,969844020,15153812,18.4),(59379,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59379,37.38,0.46,299,19579,70,NULL,NULL,'2MASX J09073175+3653165',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000148,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,136.882333333,36.88797,0,NULL,64414236146,1006472439,15726131,17.2),(59380,'SNII optical','2016-12-15 15:14:27','2016-12-16 11:19:33','1','SN 2003Z',NULL,59380,32.22,0.12,27.8,19580,NULL,NULL,'I, photospheric magnitude method','NGC 2742',NULL,'2014AJ....148..107R',2014,1,3,NULL,'G',0.000023,NULL,'11.3B',1.5,'SA(s)c:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,136.889708333,60.47933,0.185,NULL,62071770232,969871409,15154240,11.3),(59381,'SNII optical','2016-12-15 15:14:27','2016-12-16 11:19:33','1','SN 2003Z',NULL,59381,32.25,0.18,28.2,19580,NULL,NULL,'V, photospheric magnitude method','NGC 2742',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59382,'IRAS','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59382,31.71,0.8,22,19580,75,NULL,'CF, r','NGC 2742',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59383,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59383,30.5,0.69,12.6,19580,100,NULL,'mid-IR','NGC 2742',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59384,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59384,31.56,0.4,20.5,19580,NULL,NULL,NULL,'NGC 2742',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59385,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59385,31.62,0.43,21.1,19580,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2742',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59386,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59386,31.63,0.43,21.2,19580,75,NULL,'3.6 micron, color corrected','NGC 2742',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59387,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59387,31.65,0.2,21.4,19580,74.4,NULL,NULL,'NGC 2742',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59388,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59388,31.73,0.4,22.2,19580,75,NULL,'B','NGC 2742',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59389,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59389,31.76,0.45,22.5,19580,NULL,NULL,'Malmquist cor.','NGC 2742',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59390,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59390,31.78,0.4,22.7,19580,NULL,NULL,'mean','NGC 2742',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59391,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59391,31.8,0.44,23,19580,NULL,NULL,NULL,'NGC 2742',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59392,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59392,31.87,0.38,23.7,19580,75,NULL,'CF, r, raw','NGC 2742',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59393,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59393,31.98,0.38,24.9,19580,75,NULL,'CF, r, inv','NGC 2742',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59394,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59394,32.02,0.38,25.4,19580,75,NULL,'CF, r, cor','NGC 2742',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59395,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59395,32.04,0.46,25.6,19580,NULL,NULL,'J','NGC 2742',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59396,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59396,32.11,0.45,26.4,19580,NULL,NULL,'K','NGC 2742',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59397,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59397,32.13,0.47,26.7,19580,NULL,NULL,'H','NGC 2742',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59398,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59398,29.47,0.4,7.8,19581,75,NULL,'B','UGC 04787',NULL,'1988NBGC.C....0000T',1988,1,1.92,'Multiple SDSS entries describe this object.','G',0.000014,NULL,'14.6g',0.51,'Sdm            HII',NULL,NULL,NULL,NULL,1,136.895375,33.27667,0.029,NULL,64410179444,1006409053,15725141,14.6),(59399,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59399,31.54,NULL,20.3,19581,NULL,NULL,NULL,'UGC 04787',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59400,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59400,35.26,0.55,113,19582,70,NULL,NULL,'2MASX J09073533-7340517',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,136.897333,-73.68108,0.393,NULL,39812481807,622070028,9719844,16),(59401,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59401,36.17,0.16,172,19583,70,NULL,NULL,'2MASX J09073591+4938216',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000183,NULL,'15.6g',0.26,'Sa',NULL,NULL,NULL,NULL,1,136.89975,49.63925,0.037,NULL,64237367083,1003708860,15682950,15.6),(59402,'SNIa','2016-12-15 15:14:27','2016-12-16 11:19:33','1','SN 2008hv',NULL,59402,33.57,0.16,50.4,19584,72,NULL,NULL,'NGC 2765',0.01359,'2013ApJ...773...53F',2013,1,1.94,NULL,'G',0.000067,NULL,'13.0g',0.98,'S0','Isolated galaxy',NULL,NULL,NULL,1,136.902667,3.39292,0.097,NULL,63633902971,994279733,15535620,13),(59403,'SNIa','2016-12-15 15:14:27','2016-12-16 11:19:33','1','SN 2008hv',NULL,59403,33.87,0.25,58.6,19584,73.8,NULL,'SALT 2 (SNANA)','NGC 2765',0.0139,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59404,'SNIa','2016-12-15 15:14:27','2016-12-16 11:19:33','1','SN 2008hv',NULL,59404,33.86,0.05,59.1,19584,72,NULL,'M(H) = -18.317 mag','NGC 2765',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59405,'SNIa','2016-12-15 15:14:27','2016-12-16 11:19:33','1','SN 2008hv',NULL,59405,33.99,0.32,61.9,19584,73.8,NULL,'SALT 2 (SNANA)','NGC 2765',0.0139,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59406,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59406,38.15,0.46,426,19585,70,NULL,NULL,'2MASX J09073655+5655120',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000095,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,136.9025,56.92017,0.069,NULL,62010567732,968915120,15139298,16.8),(59407,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59407,38.46,0.46,491,19586,70,NULL,NULL,'2MASX J09073678+1641134',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000177,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,136.903333,16.68722,0.069,NULL,63877772301,998090192,15595159,17.8),(59408,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59408,38.13,0.46,422,19587,70,NULL,NULL,'2MASX J09073685+5231596',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00008,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,136.903667,52.53314,0,NULL,64225586612,1003524790,15680074,17.8),(59409,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59409,37.15,0.19,270,19588,70,NULL,NULL,'MCG +09-15-092',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000102,NULL,'15.9g',0.41,'E0',NULL,NULL,NULL,NULL,1,136.90675,52.11514,0.009,NULL,64225708914,1003526701,15680104,15.9),(59410,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59410,34.88,0.61,94.5,19589,70,NULL,NULL,'2MASX J09073808-0722269',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00013,NULL,'13.0I',0.6,NULL,NULL,NULL,NULL,NULL,1,136.908666667,-7.37414,0.141,NULL,42202123468,659408179,10303252,13),(59411,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59411,37.7,0.23,347,19590,70,NULL,NULL,'2MASX J09073872+1635334',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,136.911375,16.59261,0.069,NULL,63878045208,998094456,15595225,16.6),(59412,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59412,37.55,0.46,323,19591,70,NULL,NULL,'2MASX J09073884+1903452',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000169,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,136.911708333,19.0625,0.105,NULL,63831301589,997364087,15583813,16.9),(59413,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59413,34.8,0.49,91.4,19592,75,NULL,'IR','FGC 0842',NULL,'2011yCatp016004901K',2011,1,1.13,NULL,'G',0.000018,NULL,'16.6g',0.15,'Sd',NULL,NULL,NULL,NULL,1,136.9124583,28.63592,0.037,NULL,64375486460,1005866975,15716671,16.6),(59414,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59414,35.11,NULL,105,19592,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0842',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59415,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59415,35.12,NULL,106,19592,NULL,NULL,'Dipole + Quadrupole','FGC 0842',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59416,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59416,35.14,NULL,107,19592,NULL,NULL,'Dipole','FGC 0842',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59417,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59417,35.15,NULL,107,19592,NULL,NULL,NULL,'FGC 0842',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59418,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59418,35.17,0.2,108,19592,74.4,NULL,NULL,'FGC 0842',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59419,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59419,36.92,0.46,242,19593,70,NULL,NULL,'2MASX J09073911+5602340',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000076,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,136.913208333,56.04292,0.045,NULL,62010224414,968909756,15139214,17),(59420,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59420,37.15,0.19,270,19594,70,NULL,NULL,'2MASX J09073952+5204036',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000088,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,136.914666667,52.06778,0.009,NULL,64225709894,1003526717,15680104,17.2),(59421,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59421,36.46,0.49,196,19595,75,NULL,'IR','2MFGC 07107',NULL,'2011yCatp016004901K',2011,1,0.64,NULL,'G',0.00003,NULL,'14.91',NULL,'S/S0','Group member',NULL,NULL,NULL,1,136.915375,-9.45081,0.141,NULL,42195791959,659309249,10301707,14.91),(59422,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59422,36.78,0.41,227,19595,NULL,NULL,NULL,'2MFGC 07107',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59423,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59423,36.78,0.41,227,19595,NULL,NULL,'Malmquist cor.','2MFGC 07107',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59424,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59424,36.82,0.2,231,19595,74.4,NULL,NULL,'2MFGC 07107',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59425,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59425,37.15,0.19,270,19596,70,NULL,NULL,'2MASX J09073976+5151096',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000083,NULL,'16.8g',0.33,NULL,NULL,NULL,NULL,NULL,1,136.915875,51.85267,0.017,NULL,64226291349,1003535802,15680246,16.8),(59426,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59426,36.65,0.46,214,19597,70,NULL,NULL,'2MASX J09074047+5237116',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00009,NULL,'15.9g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,136.9187917,52.62,0.009,NULL,64225597645,1003524963,15680077,15.9),(59427,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59427,37.66,0.46,341,19598,70,NULL,NULL,'2MASX J09074123+1907372',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,136.9217083,19.12694,0.105,NULL,63831520286,997367504,15583867,17.3),(59428,'IRAS','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59428,33.43,0.8,48.6,19599,75,NULL,'MAT, I','NGC 2772',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00003,NULL,'14.16',0.9,'Sb: pec sp     HII','Pair member (points to parent)',NULL,NULL,NULL,1,136.9244583,-23.62142,0.993,NULL,42314602621,661165665,10330713,14.16),(59429,'Sosies','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59429,34.51,0.25,79.8,19599,NULL,NULL,NULL,'NGC 2772',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59430,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59430,33.7,0.4,54.9,19599,NULL,NULL,'mean','NGC 2772',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59431,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59431,33.73,0.53,55.7,19599,NULL,NULL,'Malmquist cor.','NGC 2772',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59432,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59432,33.76,0.52,56.6,19599,NULL,NULL,NULL,'NGC 2772',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59433,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59433,33.77,0.43,56.7,19599,75,NULL,'MAT, I, raw','NGC 2772',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59434,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59434,33.81,0.2,57.8,19599,74.4,NULL,NULL,'NGC 2772',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59435,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59435,33.82,0.47,58.2,19599,NULL,NULL,'H','NGC 2772',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59436,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59436,33.82,0.45,58.2,19599,NULL,NULL,'K','NGC 2772',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59437,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59437,33.89,0.32,60.1,19599,85,NULL,'I, raw','NGC 2772',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59438,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59438,33.92,0.46,60.8,19599,NULL,NULL,'J','NGC 2772',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59439,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59439,33.97,0.32,62.2,19599,85,NULL,'I, inv','NGC 2772',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59440,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59440,34.03,0.43,63.9,19599,75,NULL,'MAT, I, cor','NGC 2772',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59441,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59441,34.07,0.43,65.3,19599,75,NULL,'MAT, I, inv','NGC 2772',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59442,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59442,34.32,0.49,73.2,19599,75,NULL,'IR','NGC 2772',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59443,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59443,36.17,0.16,172,19600,70,NULL,NULL,'2MASX J09074301+4933076',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000177,NULL,'16.0g',0.32,'S0^-',NULL,NULL,NULL,NULL,1,136.9292083,49.55219,0,NULL,64232935516,1003639617,15681869,16),(59444,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59444,37.22,0.46,278,19601,70,NULL,NULL,'SDSS J090743.24+102940.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000151,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,136.9302083,10.49447,0.097,NULL,63641912628,994404884,15537576,18.3),(59445,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59445,37.57,0.46,327,19602,70,NULL,NULL,'2MASX J09074347+2541048',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000164,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,136.931,25.68478,0.109,NULL,64190121135,1002970642,15671416,17),(59446,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59446,37.42,0.46,305,19603,70,NULL,NULL,'2MASX J09074343+5216286',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000086,NULL,'16.9g',0.28,'AGN',NULL,NULL,NULL,NULL,1,136.931166667,52.27458,0.009,NULL,64225796776,1003528074,15680126,16.9),(59447,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59447,37.99,0.17,396,19604,70,NULL,NULL,'SDSS J090744.26+524521.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000068,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,136.9345,52.75606,0.009,NULL,64225554010,1003524281,15680066,18.5),(59448,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59448,37.54,0.46,323,19605,70,NULL,NULL,'2MASX J09074457+0428128',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000126,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,136.93575,4.47014,0.089,NULL,63626212084,994159563,15533743,17.7),(59449,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59449,37.99,0.17,396,19606,70,NULL,NULL,'2MASX J09074619+5246416',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000126,NULL,'17.3g',0.23,'BLAGN',NULL,NULL,NULL,'Sy 1',1,136.9425,52.77825,0.009,NULL,64225551955,1003524249,15680066,17.3),(59450,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59450,36.17,0.16,172,19607,70,NULL,NULL,'2MASX J09074753+4928486',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00018,NULL,'16.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,136.948125,49.48008,0,NULL,64232893407,1003638959,15681858,16.2),(59451,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59451,36.17,0.16,172,19608,70,NULL,NULL,'2MASX J09074835+4934396',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000193,NULL,'16.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,136.9515,49.57764,0,NULL,64232919989,1003639374,15681865,16.4),(59452,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59452,38.2,0.46,436,19609,70,NULL,NULL,'SDSS J090749.42+011452.9',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000081,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,136.9559583,1.24806,0.081,NULL,60669764678,947965073,14811954,17.7),(59453,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59453,35.03,0.46,101,19610,70,NULL,NULL,'CGCG 180-038',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000097,NULL,'15.1g',0.52,'Sa',NULL,NULL,NULL,NULL,1,136.9602083,33.46814,0.025,NULL,64410170219,1006408909,15725139,15.1),(59454,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59454,36.34,0.33,185,19611,70,NULL,NULL,'2MASX J09075107+4401533',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',NULL,NULL,'15.5g',0.54,'E',NULL,NULL,NULL,NULL,1,136.962833333,44.03156,0,NULL,64288384116,1004506001,15695406,15.5),(59455,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59455,37.91,0.46,381,19612,70,NULL,NULL,'2MASX J09075215+5503180',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000089,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,136.96725,55.05494,0,NULL,61875374045,966802719,15106292,17.1),(59456,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59456,37.48,0.17,314,19613,70,NULL,NULL,'SDSS J090752.24+160011.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000175,NULL,'17.7g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,136.967667,16.00325,0.089,NULL,63877301085,998082829,15595044,17.7),(59457,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59457,38.4,0.46,478,19614,70,NULL,NULL,'SDSS J090753.52+434738.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,136.973,43.79411,0,NULL,64274692319,1004292067,15692063,18.2),(59458,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59458,36.17,0.16,172,19615,70,NULL,NULL,'2MASX J09075381+4936536',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000117,NULL,'16.1g',NULL,'S0/a',NULL,NULL,NULL,NULL,1,136.97425,49.61489,0,NULL,64232922603,1003639415,15681865,16.1),(59459,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59459,37.15,0.19,270,19616,70,NULL,NULL,'2MASX J09075504+5204576',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000082,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,136.979583,52.08264,0.009,NULL,64225721083,1003526891,15680107,17.7),(59460,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59460,36.17,0.16,172,19617,70,NULL,NULL,'2MASX J09075527+4941336',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,136.9805,49.69267,0,NULL,64237368522,1003708883,15682951,16.5),(59461,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59461,38.07,0.46,411,19618,70,NULL,NULL,'2MASX J09075534+4612099',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000146,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,136.980541667,46.20283,0,NULL,64279117846,1004361216,15693144,17.2),(59462,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59462,38.13,0.33,422,19619,70,NULL,NULL,'2MASX J09075584+4906276',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000183,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,136.982875,49.10772,0.009,NULL,64234745111,1003667892,15682310,17.7),(59463,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59463,36.06,0.46,163,19620,70,NULL,NULL,'2MASX J09075614+5532160',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000071,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,136.984083,55.53792,0.017,NULL,61875123694,966798807,15106231,16.5),(59464,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59464,37.71,0.46,349,19621,70,NULL,NULL,'2MASX J09075664+3642224',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000142,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,136.986125,36.70636,0.017,NULL,64414248048,1006472625,15726134,18.5),(59465,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59465,37.27,0.46,285,19622,70,NULL,NULL,'2MASX J09075720+3541134',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,136.988417,35.68717,0.045,NULL,64422557066,1006602454,15728163,17.6),(59466,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59466,38.71,0.46,552,19623,70,NULL,NULL,'SDSS J090759.69+190421.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000152,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,136.998708333,19.07256,0.105,NULL,63831310088,997364220,15583815,18.6),(59467,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59467,37.99,0.17,396,19624,70,NULL,NULL,'2MASX J09080030+5247256',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000078,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,137.001375,52.79042,0.009,NULL,63956327488,999317617,15614337,17.3),(59468,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59468,35.39,0.48,120,19625,70,NULL,NULL,'2MASX J09080035-2029082',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.37',0.9,NULL,NULL,NULL,NULL,NULL,1,137.0014583,-20.48578,0.661,NULL,42352701034,661760953,10340014,15.37),(59469,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59469,37.91,0.46,381,19626,70,NULL,NULL,'2MASX J09080154+2932418',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00012,NULL,'17.3g',0.2,'S0',NULL,NULL,NULL,NULL,1,137.006708333,29.54486,0.053,NULL,64388969338,1006077645,15719963,17.3),(59470,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59470,38.38,0.46,473,19627,70,NULL,NULL,'2MASX J09080370+1400137',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,137.0155,14.00397,0.109,NULL,63864908096,997889189,15592018,18.1),(59471,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59471,37.87,0.46,375,19628,70,NULL,NULL,'2MASX J09080390+0325039',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000174,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,137.016417,3.41764,0.097,NULL,63625541005,994149078,15533579,16.9),(59472,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59472,37.09,0.27,262,19629,70,NULL,NULL,'2MASX J09080455+3143365',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000187,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,137.018917,31.72694,0.017,NULL,64382373047,1005974578,15718352,16.5),(59473,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59473,38.23,0.46,443,19630,70,NULL,NULL,'2MASX J09080489+3037185',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,137.020417,30.62192,0.021,NULL,64381215584,1005956493,15718070,17.8),(59474,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59474,37.44,0.46,308,19631,70,NULL,NULL,'2MASX J09080540+2415048',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000196,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,137.022625,24.25142,0.085,NULL,63707084622,995423197,15553487,17.1),(59475,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59475,37.09,0.27,262,19632,70,NULL,NULL,'2MASX J09080556+3146335',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,137.023333,31.77603,0.017,NULL,64382372158,1005974564,15718352,17.4),(59476,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59476,34.61,0.49,83.5,19633,75,NULL,'IR','UGC 04792',NULL,'2011yCatp016004901K',2011,1,1.46,NULL,'G',0.000013,NULL,'16.10',0.19,'Sbc',NULL,NULL,NULL,NULL,1,137.024125,20.50353,0.093,NULL,63830351099,997349235,15583581,16.1),(59477,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59477,34.98,NULL,99.2,19633,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04792',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59478,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59478,35,NULL,99.8,19633,NULL,NULL,'Dipole','UGC 04792',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59479,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59479,35,NULL,100,19633,NULL,NULL,'Dipole + Quadrupole','UGC 04792',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59480,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59480,35.1,0.2,105,19633,74.4,NULL,NULL,'UGC 04792',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59481,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59481,35.14,NULL,107,19633,NULL,NULL,NULL,'UGC 04792',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59482,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59482,35.16,0.38,108,19633,NULL,NULL,NULL,'UGC 04792',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59483,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59483,35.25,0.37,112,19633,NULL,NULL,'Malmquist cor.','UGC 04792',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59484,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59484,37.72,0.46,351,19634,70,NULL,NULL,'2MASX J09080607+1656147',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,137.0252083,16.93753,0.061,NULL,63877847604,998091368,15595177,17.7),(59485,'Sosies','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59485,31.97,0.08,24.8,19635,NULL,NULL,NULL,'NGC 2715',NULL,'2002A&A...393...57T',2002,1,4.9,NULL,'G',0.000013,NULL,'11.79',1.7,'SAB(rs)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,137.025833,78.08517,0.017,NULL,61465582208,960399722,15006245,11.79),(59486,'Tully est','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59486,31.55,0.8,20.4,19635,75,NULL,'B','NGC 2715',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59487,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59487,31.08,0.43,16.4,19635,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2715',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59488,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59488,31.11,0.43,16.7,19635,75,NULL,'3.6 micron, color corrected','NGC 2715',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59489,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59489,31.14,0.4,16.9,19635,NULL,NULL,NULL,'NGC 2715',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59490,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59490,31.21,0.2,17.5,19635,74.4,NULL,NULL,'NGC 2715',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59491,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59491,31.46,0.42,19.6,19635,NULL,NULL,NULL,'NGC 2715',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59492,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59492,31.54,0.4,20.3,19635,NULL,NULL,'Malmquist cor.','NGC 2715',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59493,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59493,31.69,0.4,21.8,19635,NULL,NULL,'mean','NGC 2715',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59494,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59494,31.87,0.47,23.7,19635,NULL,NULL,'H','NGC 2715',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59495,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59495,31.91,0.46,24.1,19635,NULL,NULL,'J','NGC 2715',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59496,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59496,32.04,0.45,25.6,19635,NULL,NULL,'K','NGC 2715',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59497,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59497,38.07,0.46,412,19636,70,NULL,NULL,'SDSS J090806.51+021457.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000077,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,137.027125,2.24931,0.109,NULL,60669381643,947959088,14811860,18.4),(59498,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59498,37.88,0.46,377,19637,70,NULL,NULL,'2MASX J09080757+1438547',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,137.031667,14.64844,0.101,NULL,63865537571,997899024,15592172,18.2),(59499,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59499,37.09,0.27,262,19638,70,NULL,NULL,'2MASX J09080909+3144055',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000176,NULL,'16.1g',0.41,'E0',NULL,NULL,NULL,NULL,1,137.038,31.73469,0.017,NULL,64382373091,1005974579,15718352,16.1),(59500,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59500,36.69,0.46,217,19639,70,NULL,NULL,'SDSS J090809.81+441155.6',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,137.0409583,44.19881,0.009,NULL,64288370234,1004505784,15695402,17.7),(59501,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59501,37.35,0.46,296,19640,70,NULL,NULL,'2MASX J09081073+1716106',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,137.0447917,17.26983,0.093,NULL,63878277240,998098081,15595282,17.6),(59502,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59502,31.46,0.4,19.6,19641,75,NULL,'B','UGC 04797',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000017,NULL,'14.49',1.7,'Sm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,137.045,5.92778,0.109,NULL,63627092000,994173312,15533958,14.49),(59503,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59503,36.99,0.33,250,19642,70,NULL,NULL,'2MASX J09081098+0756155',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,137.0457083,7.93764,0.121,NULL,63679799083,994996860,15546825,17.1),(59504,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59504,38.17,0.46,430,19643,70,NULL,NULL,'2MASX J09081254+0130539',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.0001,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,137.0522917,1.51489,0.109,NULL,60669671581,947963618,14811931,17.3),(59505,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59505,37.01,0.46,252,19644,70,NULL,NULL,'2MASX J09081313+1029557',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,137.054875,10.49886,0.097,NULL,63642035460,994406804,15537606,17.5),(59506,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59506,37.41,0.46,304,19645,70,NULL,NULL,'2MASX J09081330+2110044',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000184,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,137.055583,21.16781,0.113,NULL,63830940951,997358452,15583725,16.5),(59507,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59507,37.28,0.33,286,19646,70,NULL,NULL,'2MASX J09081384+3946423',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000157,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,137.057791667,39.7785,0,NULL,64395849191,1006185143,15721642,17),(59508,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59508,38.41,0.46,481,19647,70,NULL,NULL,'SDSS J090815.12+060619.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000157,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,137.063041667,6.10547,0.113,NULL,63624971703,994140182,15533440,18.7),(59509,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59509,38.01,0.46,401,19648,70,NULL,NULL,'SDSS J090815.17+062055.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000127,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,137.0632083,6.34864,0.109,NULL,63681385288,995021645,15547213,18.2),(59510,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59510,37.31,0.46,290,19649,70,NULL,NULL,'2MASX J09081551+4306069',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,137.064833,43.10183,0.025,NULL,64275430854,1004303607,15692243,17.9),(59511,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59511,37.52,0.46,319,19650,70,NULL,NULL,'2MASX J09081589+4404579',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000131,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,137.066375,44.08286,0,NULL,64288349739,1004505464,15695397,17.8),(59512,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59512,37.94,0.46,386,19651,70,NULL,NULL,'SDSS J090815.96+364648.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000166,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,137.0665,36.78022,0.017,NULL,64414283659,1006473182,15726143,18.2),(59513,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59513,36.16,0.46,171,19652,70,NULL,NULL,'2MASX J09081668+4209509',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,137.069625,42.16414,0.017,NULL,64267516931,1004179952,15690311,NULL),(59514,'Tully est','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59514,32.86,0.8,37.4,19653,75,NULL,'B','NGC 2764',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.000017,NULL,'13.63',0.9,'S0:','in a pair',NULL,NULL,NULL,1,137.072791667,21.44333,0.129,NULL,63830076399,997344943,15583514,13.63),(59515,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59515,36.99,0.33,250,19654,70,NULL,NULL,'2MASX J09081768+0754007',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000178,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,137.0735417,7.90028,0.121,NULL,63679812471,994997069,15546829,16.5),(59516,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59516,38.07,0.46,411,19655,70,NULL,NULL,'SDSS J090819.62+003245.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000074,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,137.0817917,0.54597,0.125,NULL,60668277321,947941833,14811591,18.3),(59517,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59517,37.99,0.17,396,19656,70,NULL,NULL,'2MASX J09082084+5249170',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000093,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,137.087125,52.8215,0.013,NULL,63956332693,999317698,15614339,17.3),(59518,'IRAS','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59518,35.09,0.8,104,19657,75,NULL,'MAT, I','ESO 564- G 023',NULL,'1997ApJS..109..333W',1997,1,1.88,NULL,'G',0.000033,NULL,'16.63',0.21,'Sc',NULL,NULL,NULL,NULL,1,137.087875,-22.48519,0.741,NULL,42314336554,661161508,10330648,16.63),(59519,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59519,34.58,NULL,82.3,19657,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 564- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59520,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59520,34.59,NULL,82.7,19657,NULL,NULL,'Dipole','ESO 564- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59521,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59521,34.59,NULL,82.9,19657,NULL,NULL,'Dipole + Quadrupole','ESO 564- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59522,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59522,34.92,0.49,96.3,19657,75,NULL,'IR','ESO 564- G 023',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59523,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59523,35.04,0.32,102,19657,85,NULL,'I, raw','ESO 564- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59524,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59524,35.07,0.32,104,19657,85,NULL,'I, inv','ESO 564- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59525,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59525,35.13,0.43,106,19657,75,NULL,'MAT, I, raw','ESO 564- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59526,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59526,35.21,0.43,110,19657,75,NULL,'3.6 micron, color corrected','ESO 564- G 023',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59527,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59527,35.23,0.43,111,19657,75,NULL,'3.6 micron, color + selection bias corrected','ESO 564- G 023',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59528,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59528,35.3,0.43,115,19657,75,NULL,'MAT, I, inv','ESO 564- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59529,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59529,35.34,0.2,117,19657,74.4,NULL,NULL,'ESO 564- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59530,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59530,35.45,0.43,123,19657,75,NULL,'MAT, I, cor','ESO 564- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59531,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59531,35.63,0.49,134,19657,NULL,NULL,'Malmquist cor.','ESO 564- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59532,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59532,35.65,0.48,135,19657,NULL,NULL,NULL,'ESO 564- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59533,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59533,38.8,0.46,576,19658,70,NULL,NULL,'SDSS J090821.68+034414.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000175,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,137.090375,3.7375,0.069,NULL,63625671731,994151120,15533611,18.6),(59534,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59534,37.42,0.46,305,19659,70,NULL,NULL,'2MASX J09082248+1827114',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,137.093708333,18.45308,0.113,NULL,63878745125,998105392,15595396,17.2),(59535,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59535,36.17,0.16,172,19660,70,NULL,NULL,'2MASX J09082287+4925480',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000183,NULL,'15.7g',0.29,'S0',NULL,NULL,NULL,NULL,1,137.0952917,49.43008,0,NULL,64232942684,1003639729,15681870,15.7),(59536,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59536,36.16,0.27,171,19661,70,NULL,NULL,'2MASX J09082304+2816076',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000179,NULL,'15.7g',0.46,NULL,NULL,NULL,NULL,NULL,1,137.096,28.26886,0.033,NULL,64191831564,1002997368,15671833,15.7),(59537,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59537,38.59,0.46,522,19662,70,NULL,NULL,'SDSS J090823.40+341733.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000173,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,137.0975417,34.2925,0.025,NULL,64411080267,1006423129,15725361,18),(59538,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59538,37.48,0.17,314,19663,70,NULL,NULL,'2MASX J09082729+1610437',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,137.113875,16.17875,0.081,NULL,63877324800,998083200,15595050,17.2),(59539,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59539,36.54,0.46,204,19664,70,NULL,NULL,'2MASX J09082894+3843304',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000184,NULL,'16.2g',0.36,'E0',NULL,NULL,NULL,NULL,1,137.120791667,38.72519,0.017,NULL,64399080781,1006235637,15722431,16.2),(59540,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59540,37.99,0.17,396,19665,70,NULL,NULL,'2MASX J09082989+5246540',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000071,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,137.1247083,52.78161,0.009,NULL,63956380618,999318447,15614350,18.1),(59541,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59541,36.16,0.27,171,19666,70,NULL,NULL,'2MASX J09083000+2809426',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000177,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,137.125041667,28.16178,0.045,NULL,64191853510,1002997711,15671839,16.4),(59542,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59542,37.8,0.46,363,19667,70,NULL,NULL,'2MASX J09083034+1644347',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000183,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,137.1264583,16.74294,0.069,NULL,63878182566,998096602,15595259,16.9),(59543,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59543,37.64,0.46,337,19668,70,NULL,NULL,'SDSS J090831.45+145924.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,137.131083333,14.99003,0.089,NULL,63864820318,997887817,15591997,18.2),(59544,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59544,37.93,0.46,386,19669,70,NULL,NULL,'2MASX J09083198+2818356',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000168,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,137.133083,28.30981,0.033,NULL,64191829276,1002997332,15671833,17.2),(59545,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59545,37.28,0.33,286,19670,70,NULL,NULL,'2MASX J09083197+3945304',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,137.133291667,39.75847,0,NULL,64395857265,1006185269,15721644,18.1),(59546,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59546,36.16,0.27,171,19671,70,NULL,NULL,'2MASX J09083348+2807476',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000188,NULL,'15.7g',0.48,NULL,NULL,NULL,NULL,NULL,1,137.1395417,28.12989,0.045,NULL,64191851171,1002997674,15671838,15.7),(59547,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59547,37.48,0.17,314,19672,70,NULL,NULL,'2MASX J09083388+1602477',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000196,NULL,'15.9g',0.48,NULL,NULL,NULL,NULL,NULL,1,137.141125,16.04656,0.081,NULL,63877378737,998084042,15595063,15.9),(59548,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59548,36.78,0.46,227,19673,70,NULL,NULL,'SDSS J090835.32+101143.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,137.147208333,10.19542,0.141,NULL,63642216903,994409639,15537650,17.7),(59549,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59549,37.48,0.17,314,19674,70,NULL,NULL,'2MASX J09083540+1556327',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000197,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,137.1475417,15.94253,0.077,NULL,63877195253,998081175,15595018,16.4),(59550,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59550,37.48,0.17,314,19675,70,NULL,NULL,'2MASX J09083562+1601157',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000171,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,137.148375,16.02097,0.077,NULL,63877372429,998083944,15595061,17.7),(59551,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59551,29.13,NULL,6.7,19676,NULL,NULL,NULL,'SDSS J090836.54+051726.8',NULL,'2015AstBu..70....1K',2015,1,0.32,NULL,'G',0.000002,NULL,'18.6g',0.18,'Ir',NULL,NULL,NULL,NULL,1,137.15225,5.29078,0.097,NULL,63627560707,994180636,15534072,18.6),(59552,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59552,37.48,0.17,314,19677,70,NULL,NULL,'SDSS J090836.84+161339.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.1g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,137.1535417,16.22778,0.081,NULL,63877355777,998083684,15595057,18.1),(59553,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59553,38.26,0.46,449,19678,70,NULL,NULL,'2MASX J09083695+3607193',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000144,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,137.154125,36.12206,0.053,NULL,64422637989,1006603718,15728183,17.8),(59554,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59554,34.91,0.46,96.1,19679,70,NULL,NULL,'NGC 2759',NULL,'2015arXiv151105856S',2015,1,1.21,NULL,'G',0.000073,NULL,'13.8g',0.81,'S0-:','in a radial-velocity based grouping',NULL,NULL,NULL,1,137.155375,37.62161,0.009,NULL,64396794654,1006199916,15721873,13.8),(59555,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59555,35.07,0.4,103,19679,NULL,NULL,'mean','NGC 2759',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59556,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59556,35.41,0.45,121,19679,NULL,NULL,'K','NGC 2759',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59557,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59557,36.53,0.46,202,19680,70,NULL,NULL,'2MASX J09083759+1142567',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.71',0.33,NULL,NULL,NULL,NULL,NULL,1,137.15675,11.71567,0.081,NULL,63643790032,994434219,15538034,16.71),(59558,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59558,37.68,0.46,344,19681,70,NULL,NULL,'2MASX J09083904+2051392',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00019,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,137.162667,20.86081,0.113,NULL,63830981282,997359082,15583735,17.4),(59559,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59559,37.88,0.27,376,19682,70,NULL,NULL,'2MASX J09083919+1318147',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7E',NULL,NULL,NULL,NULL,NULL,NULL,1,137.163208333,13.30403,0.125,NULL,63866645750,997916339,15592442,17.7),(59560,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59560,37.42,0.46,304,19683,70,NULL,NULL,'2MASX J09083933+2935245',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000161,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,137.163791667,29.59008,0.037,NULL,64380630774,1005947355,15717927,17.2),(59561,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59561,36.78,0.66,227,19684,70,NULL,NULL,'FAIRALL 1350',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'15.9B',0.38,NULL,NULL,NULL,NULL,NULL,1,137.167375,-82.43917,0.361,NULL,39778965332,621546333,9711661,15.9),(59562,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59562,34.7,0.46,87,19685,70,NULL,NULL,'CGCG 006-005',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000071,NULL,'14.9g',0.58,'S0','Isolated galaxy',NULL,NULL,NULL,1,137.174333,0.48469,0.125,NULL,60668487929,947945123,14811642,14.9),(59563,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59563,34.12,0.43,66.7,19686,75,NULL,'3.6 micron, color + selection bias corrected','ESO 314- G 005',NULL,'2014MNRAS.444..527S',2014,1,1.9,'Marginal HIPASS detection.','G',0.000027,NULL,'15.91',0.6,'Sa-b',NULL,NULL,NULL,NULL,1,137.190875,-38.60789,NULL,NULL,42894585639,670227900,10472310,15.91),(59564,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59564,37.19,0.46,274,19687,70,NULL,NULL,'2MASX J09084616+0454489',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000154,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,137.19225,4.91361,0.105,NULL,63627513240,994179894,15534060,17.3),(59565,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59565,37.88,0.46,376,19688,70,NULL,NULL,'2MASX J09084632+6503526',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,137.1932083,65.06447,0.157,NULL,62252442142,972694408,15198350,18.1),(59566,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59566,37.17,0.46,271,19689,70,NULL,NULL,'2MASX J09084719+4342249',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,137.196791667,43.70683,0,NULL,64274798234,1004293722,15692089,17),(59567,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59567,34.16,0.4,67.8,19690,NULL,NULL,'mean','NGC 2766',NULL,'2007A&A...465...71T',2007,1,1.34,NULL,'G',0.000033,NULL,'14.2g',0.57,'Sab',NULL,NULL,NULL,NULL,1,137.198083,29.86478,0.045,NULL,64380654520,1005947726,15717933,14.2),(59568,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59568,34.47,0.45,78.4,19690,NULL,NULL,'K','NGC 2766',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59569,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59569,34.47,0.47,78.4,19690,NULL,NULL,'H','NGC 2766',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59570,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59570,34.53,0.46,80.6,19690,NULL,NULL,'J','NGC 2766',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59571,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59571,38.12,0.46,422,19691,70,NULL,NULL,'2MASX J09084894+0143349',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000068,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,137.203875,1.72633,0.093,NULL,60669282431,947957537,14811836,18),(59572,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59572,38.56,0.46,515,19692,70,NULL,NULL,'2MASX J09084991+0351079',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000172,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,137.207875,3.85219,0.069,NULL,63626445478,994163210,15533800,18.1),(59573,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59573,37.67,0.46,343,19693,70,NULL,NULL,'2MASX J09085104+0907270',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000164,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,137.212833333,9.12425,0.161,NULL,63678985567,994984149,15546627,17.6),(59574,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59574,37.39,0.46,300,19694,70,NULL,NULL,'2MASX J09085278+2404111',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000195,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,137.220083,24.06978,0.125,NULL,63707257870,995425904,15553529,16.6),(59575,'TRGB','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59575,29.9,NULL,9.46,19695,NULL,NULL,NULL,'LSBC D634-03',NULL,'2006AJ....131.1361K',2006,1,0.4,NULL,'G',0.000078,NULL,'17.5B',0.4,'dI',NULL,NULL,NULL,NULL,1,137.2229583,14.58181,0.101,NULL,63865565320,997899458,15592179,17.5),(59576,'TRGB','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59576,29.89,0.11,9.51,19695,NULL,NULL,'I','LSBC D634-03',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59577,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59577,36.53,0.46,203,19696,70,NULL,NULL,'2MASX J09085358+3215104',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000137,NULL,'15.3g',0.56,'E0',NULL,NULL,NULL,NULL,1,137.223166667,32.25303,0.021,NULL,64380158844,1005939981,15717812,15.3),(59578,'IRAS','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59578,34.2,0.8,69.2,19697,75,NULL,'HMCL, I','CGCG 006-006',NULL,'1997ApJS..109..333W',1997,1,0.69,NULL,'G',0.000027,NULL,'15.9g',0.36,'Sm','Isolated galaxy',NULL,NULL,NULL,1,137.226583,1.43256,0.109,NULL,60669580367,947962193,14811909,15.9),(59579,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59579,34.72,0.4,87.9,19697,75,NULL,'HMCL, I, raw','CGCG 006-006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59580,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59580,34.79,0.4,90.6,19697,75,NULL,'HMCL, I, inv','CGCG 006-006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59581,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59581,35.02,0.4,101,19697,75,NULL,'HMCL, I, cor','CGCG 006-006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59582,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59582,36.96,0.46,246,19698,70,NULL,NULL,'2MASX J09085481+5210501',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00008,NULL,'17.4g',0.2,'NLAGN',NULL,NULL,NULL,NULL,1,137.22825,52.18044,0.009,NULL,64225738746,1003527167,15680111,17.4),(59583,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59583,36.23,0.33,176,19699,70,NULL,NULL,'2MASX J09085587+4824071',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00017,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,137.23275,48.40203,0.009,NULL,64234469790,1003663590,15682243,16.4),(59584,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59584,35.74,0.79,141,19700,70,NULL,NULL,'2MASX J09085601-7417407',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,137.233375,-74.29467,0.505,NULL,39930372994,623912078,9748626,17),(59585,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59585,38.03,0.46,403,19701,70,NULL,NULL,'2MASX J09085682+2905311',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00011,NULL,'16.9g',0.29,'E',NULL,NULL,NULL,NULL,1,137.236667,29.092,0.041,NULL,64388920156,1006076877,15719951,16.9),(59586,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59586,37.23,0.46,280,19702,70,NULL,NULL,'2MASX J09085870+2018142',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000178,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,137.2445,20.304,0.097,NULL,63832922256,997389410,15584209,16.6),(59587,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59587,37.04,0.46,255,19703,70,NULL,NULL,'2MASX J09085901+0038029',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000067,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,137.245875,0.63397,0.125,NULL,60668475880,947944935,14811639,17.1),(59588,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59588,37.28,0.46,285,19704,70,NULL,NULL,'2MASXi J0908593+385028',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,137.247375,38.84117,0,NULL,64399022665,1006234729,15722417,17.8),(59589,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59589,37.88,0.27,376,19705,70,NULL,NULL,'2MASX J09085938+1322466',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000182,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,137.2475417,13.37972,0.125,NULL,63866657515,997916523,15592445,17.3),(59590,'Sosies','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59590,33.59,0.47,52.2,19706,NULL,NULL,NULL,'NGC 2756',NULL,'2002A&A...393...57T',2002,1,1.7,NULL,'G',0.000033,NULL,'13.20',1.1,'Sb','Group member',NULL,NULL,NULL,1,137.253875,53.84953,0.021,NULL,63955543416,999305365,15614146,13.2),(59591,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59591,33.68,0.45,54.4,19706,NULL,NULL,'K','NGC 2756',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59592,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59592,33.68,0.47,54.5,19706,NULL,NULL,'H','NGC 2756',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59593,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59593,33.69,0.4,54.6,19706,NULL,NULL,'mean','NGC 2756',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59594,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59594,33.72,0.46,55.4,19706,NULL,NULL,'J','NGC 2756',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59595,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59595,34.79,0.46,90.9,19707,70,NULL,NULL,'CGCG 238-014',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000148,NULL,'15.2g',0.35,'S0',NULL,NULL,NULL,NULL,1,137.25325,49.96303,0,NULL,64237444528,1003710070,15682969,15.2),(59596,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59596,37.73,0.46,352,19708,70,NULL,NULL,'2MASX J09090268+3959077',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000143,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,137.2612083,39.98558,0.025,NULL,64395892268,1006185816,15721653,17.6),(59597,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59597,37.09,0.61,262,19709,70,NULL,NULL,'2MASX J09090284-1015357',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15',NULL,'S0','Group member',NULL,NULL,NULL,1,137.262083,-10.26019,0.125,NULL,42189445938,659210092,10300157,15),(59598,'IRAS','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59598,31.47,0.8,19.7,19710,75,NULL,'MAT, I','NGC 2788',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'13.24',0.4,'Sab? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,137.262667,-67.93247,0.485,NULL,40796440497,637444382,9960068,13.24),(59599,'Tully est','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59599,31.33,0.8,18.4,19710,75,NULL,NULL,'NGC 2788',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59600,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59600,30.66,0.4,13.6,19710,75,NULL,NULL,'NGC 2788',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59601,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59601,30.67,0.39,13.6,19710,73,NULL,'IR','NGC 2788',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59602,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59602,30.85,0.32,14.8,19710,85,NULL,'I, inv','NGC 2788',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59603,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59603,30.88,0.32,15,19710,85,NULL,'I, raw','NGC 2788',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59604,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59604,30.91,0.43,15.2,19710,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2788',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59605,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59605,31.02,0.47,16,19710,NULL,NULL,'H','NGC 2788',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59606,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59606,31.04,0.45,16.1,19710,NULL,NULL,'K','NGC 2788',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59607,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59607,31.16,0.46,17.1,19710,NULL,NULL,'J','NGC 2788',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59608,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59608,31.18,0.43,17.3,19710,75,NULL,'MAT, I, inv','NGC 2788',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59609,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59609,31.21,0.43,17.5,19710,75,NULL,'MAT, I, raw','NGC 2788',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59610,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59610,31.34,0.49,18.6,19710,75,NULL,'IR','NGC 2788',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59611,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59611,31.45,0.43,19.5,19710,75,NULL,'3.6 micron, color corrected','NGC 2788',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59612,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59612,31.46,0.43,19.6,19710,75,NULL,'MAT, I, cor','NGC 2788',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59613,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59613,31.74,0.4,22.2,19710,NULL,NULL,'mean','NGC 2788',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59614,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59614,31.92,0.2,24.2,19710,74.4,NULL,NULL,'NGC 2788',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59615,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59615,37.28,0.46,285,19711,70,NULL,NULL,'2MASX J09090393+2106294',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000139,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,137.2664583,21.10814,0.113,NULL,63830964468,997358819,15583731,18.1),(59616,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59616,37.16,0.46,271,19712,70,NULL,NULL,'2MASX J09090393+0709040',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000196,NULL,'16.0g',0.41,'E0',NULL,NULL,NULL,NULL,1,137.266541667,7.15119,0.109,NULL,63682102819,995032856,15547388,16),(59617,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59617,36.23,0.33,176,19713,70,NULL,NULL,'KUG 0905+486',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000173,NULL,'16.1g',0.38,'Compact',NULL,NULL,NULL,NULL,1,137.2705,48.411,0.009,NULL,64234470238,1003663597,15682243,16.1),(59618,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59618,37.29,0.46,288,19714,70,NULL,NULL,'2MASX J09090515-0030516',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000079,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,137.271583333,-0.51444,0.085,NULL,41073759687,641777495,10027773,17.6),(59619,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59619,37.35,0.46,295,19715,70,NULL,NULL,'2MASX J09090566+0028133',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000082,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,137.2735417,0.47039,0.085,NULL,60668454950,947944608,14811634,17.1);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (59620,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59620,37.88,0.27,376,19716,70,NULL,NULL,'SDSS J090906.56+132234.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000144,NULL,'18.8g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,137.277375,13.37625,0.125,NULL,63866658729,997916542,15592445,18.8),(59621,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59621,37.51,0.46,318,19717,70,NULL,NULL,'2MASX J09090739+1300196',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,137.280667,13.00544,0.121,NULL,63866349558,997911711,15592370,17.1),(59622,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59622,38.03,0.46,403,19718,70,NULL,NULL,'2MASX J09090788+0548403',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,137.282833,5.81128,0.085,NULL,63627112812,994173637,15533963,17),(59623,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59623,38.07,0.46,411,19719,70,NULL,NULL,'2MASX J09090841+5632559',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000078,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,137.2847917,56.54883,0.041,NULL,62010555988,968914937,15139295,17.5),(59624,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59624,36.79,0.41,228,19720,70,NULL,NULL,'ABELL 0754',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I-II:  [BM]',NULL,NULL,NULL,NULL,1,137.285,-9.66611,0.165,NULL,42188626993,659197296,10299957,NULL),(59625,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59625,37.01,0.46,252,19721,70,NULL,NULL,'2MASX J09091119+0023543',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000092,NULL,'16.7g',0.27,'AGN',NULL,NULL,NULL,NULL,1,137.296625,0.39853,0.085,NULL,60668458239,947944659,14811635,16.7),(59626,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59626,38.61,0.46,527,19722,70,NULL,NULL,'2MASX J09091675+0736396',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000195,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,137.319708333,7.61122,0.121,NULL,63681675040,995026172,15547283,17.5),(59627,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59627,36.79,0.41,228,19723,70,NULL,'ABELL 0754, BGC','2MASX J09091923-0941591',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'G',0.000093,NULL,'14.3V',NULL,'cD; S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,137.330041667,-9.69983,0.165,NULL,42188635850,659197435,10299959,14.3),(59628,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59628,33.14,0.2,42.5,19724,74.4,NULL,NULL,'UGC 04800',NULL,'2013AJ....146...86T',2013,1,1.73,NULL,'G',0.00002,NULL,'14.6g',0.52,'SB(s)cd?',NULL,NULL,NULL,NULL,1,137.331,54.91197,0.017,NULL,61874837325,966794333,15106161,14.6),(59629,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59629,33.19,0.43,43.5,19724,75,NULL,'3.6 micron, color corrected','UGC 04800',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59630,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59630,33.24,0.43,44.5,19724,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04800',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59631,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59631,33.25,0.78,44.7,19724,NULL,NULL,NULL,'UGC 04800',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59632,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59632,33.29,0.77,45.5,19724,NULL,NULL,'Malmquist cor.','UGC 04800',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59633,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59633,38.5,0.46,501,19725,70,NULL,NULL,'SDSS J090919.62+123718.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.1g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,137.3317917,12.62189,0.061,NULL,63866170064,997908907,15592326,18.1),(59634,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59634,33.06,0.2,40.9,19726,74.4,NULL,NULL,'UGC 04809',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000024,NULL,'14.7g',0.51,'SBcd?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,137.334583,20.69733,0.101,NULL,63830816070,997356501,15583695,14.7),(59635,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59635,33.32,0.54,46.2,19726,NULL,NULL,NULL,'UGC 04809',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59636,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59636,33.6,0.47,52.5,19726,NULL,NULL,'Malmquist cor.','UGC 04809',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59637,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59637,33.12,0.4,42.2,19727,75,NULL,NULL,'2MFGC 07129',NULL,'2008Ap.....51..336K',2008,1,NULL,'This is the southeastern end of UGC 04800.','PofG',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,137.3367917,54.90983,0.017,NULL,61874891139,966795174,15106174,NULL),(59638,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59638,33.52,0.49,50.5,19727,75,NULL,'IR','2MFGC 07129',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59639,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59639,36.35,0.46,186,19728,70,NULL,NULL,'2MASX J09092195+1314268',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.13',0.32,NULL,NULL,NULL,NULL,NULL,1,137.341541667,13.24086,0.121,NULL,63866517016,997914328,15592411,17.13),(59640,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59640,36.94,0.2,244,19729,74.4,NULL,NULL,'CGCG 121-025',NULL,'2013AJ....146...86T',2013,1,0.56,NULL,'G',0.000073,NULL,'15.5g',0.42,'Sbc',NULL,NULL,NULL,NULL,1,137.342917,24.24539,0.125,NULL,63707245376,995425709,15553526,15.5),(59641,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59641,33.87,0.4,59.3,19730,NULL,NULL,'mean','IC 0528',NULL,'2007A&A...465...71T',2007,1,1.5,'UZC has V = 8636 +- 50 km/sec.','G',0.000097,NULL,'15.00',0.8,'SBab','Compact group member',NULL,NULL,NULL,1,137.3439583,15.79617,0.069,NULL,63877210437,998081413,15595022,15),(59642,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59642,34.71,0.47,87.5,19730,NULL,NULL,'H','IC 0528',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59643,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59643,38.27,0.46,451,19731,70,NULL,NULL,'2MASXi J0909240+460551',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000128,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,137.350166667,46.09764,0,NULL,64281112390,1004392381,15693630,17.7),(59644,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59644,34.85,0.56,93.4,19732,70,NULL,NULL,'2MASX J09092533-6407370',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000143,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,137.3557917,-64.12703,0.685,NULL,40756914731,636826792,9950418,16.1),(59645,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59645,37.88,0.46,377,19733,70,NULL,NULL,'SDSS J090926.41+282752.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000128,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,137.3600417,28.46467,0.033,NULL,64191965083,1002999454,15671866,18.7),(59646,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59646,36.28,0.46,181,19734,70,NULL,NULL,'2MASX J09092825+2239134',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000176,NULL,'16.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,137.36775,22.65383,0.141,NULL,63704345343,995380395,15552818,16.5),(59647,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59647,37.19,0.46,274,19735,70,NULL,NULL,'2MASX J09092977+3953320',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00015,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,137.373916667,39.89225,0.021,NULL,64395888035,1006185750,15721652,17.3),(59648,'Tully est','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59648,30.77,0.8,14.2,19736,75,NULL,NULL,'ESO 372- G 007',NULL,'1988NBGC.C....0000T',1988,1,0.9,NULL,'G',0.000007,NULL,NULL,0.5,'...',NULL,NULL,NULL,NULL,1,137.3747083,-33.34567,NULL,NULL,42945062897,671016607,10484634,NULL),(59649,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59649,38.14,0.46,424,19737,70,NULL,NULL,'2MASX J09093180+5237030',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000086,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,137.382416667,52.61739,0.009,NULL,63956559522,999321242,15614394,17.8),(59650,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59650,36.8,0.46,229,19738,70,NULL,NULL,'2MASX J09093247+5613028',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000074,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,137.38525,56.21733,0.037,NULL,61876892756,966826449,15106663,16.9),(59651,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59651,37.57,0.46,327,19739,70,NULL,NULL,'2MASX J09093269+1626018',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000174,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,137.386291667,16.43389,0.073,NULL,63878118512,998095601,15595243,17.8),(59652,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59652,35.84,0.46,147,19740,70,NULL,NULL,'CGCG 091-011',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000173,NULL,'15.4g',0.43,NULL,'Group member',NULL,NULL,NULL,1,137.386833,20.47908,0.101,NULL,63830625046,997353516,15583648,15.4),(59653,'SNIa','2016-12-15 15:14:27','2016-12-16 11:19:33','1','SN 2001G',NULL,59653,33.52,0.21,49.7,19741,74.2,NULL,'SALT 2','MCG +08-17-043',0.01677,'2010ApJ...716..712A',2010,1,0.75,NULL,'G',0.000055,NULL,'15.8g',0.28,'Sc',NULL,NULL,NULL,NULL,1,137.3872083,50.28186,0,NULL,64237680115,1003713751,15683027,15.8),(59654,'SNIa','2016-12-15 15:14:27','2016-12-16 11:19:33','1','SN 2001G',NULL,59654,34.13,0.09,67,19741,74.4,NULL,NULL,'MCG +08-17-043',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59655,'SNIa','2016-12-15 15:14:27','2016-12-16 11:19:33','1','SN 2001G',NULL,59655,34.22,0.2,68.7,19741,73.8,NULL,'SALT 2 (SNANA)','MCG +08-17-043',0.0175,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59656,'SNIa','2016-12-15 15:14:27','2016-12-16 11:19:33','1','SN 2001G',NULL,59656,34.29,0.22,70.8,19741,65,NULL,'SALT','MCG +08-17-043',0.01677,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59657,'SNIa','2016-12-15 15:14:27','2016-12-16 11:19:33','1','SN 2001G',NULL,59657,34.48,0.2,77.4,19741,65,NULL,'MLCS17','MCG +08-17-043',0.01677,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59658,'SNIa','2016-12-15 15:14:27','2016-12-16 11:19:33','1','SN 2001G',NULL,59658,34.52,0.2,79,19741,65,NULL,'MLCS31','MCG +08-17-043',0.01677,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59659,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59659,37.75,0.46,354,19742,70,NULL,NULL,'2MASX J09093313+3145072',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000136,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,137.387917,31.75214,0.017,NULL,64382408868,1005975138,15718361,18.1),(59660,'IRAS','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59660,32.48,0.8,31.4,19743,75,NULL,'A82, H','NGC 2770',NULL,'1997ApJS..109..333W',1997,1,4.08,'HOLM 111B is a star.','G',0.000006,NULL,'12.8g',0.84,'SA(s)c:','Group member',NULL,NULL,NULL,1,137.390458333,33.12353,0.017,NULL,64411174161,1006424596,15725384,12.8),(59661,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59661,31.92,0.4,24.2,19743,75,NULL,NULL,'NGC 2770',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59662,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59662,31.99,0.2,25,19743,74.4,NULL,NULL,'NGC 2770',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59663,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59663,32.08,0.38,26.1,19743,NULL,NULL,NULL,'NGC 2770',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59664,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59664,32.1,0.4,26.3,19743,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 2770',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59665,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59665,32.11,0.43,26.4,19743,75,NULL,'3.6 micron, color corrected','NGC 2770',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59666,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59666,32.15,0.46,26.9,19743,NULL,NULL,NULL,'NGC 2770',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59667,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59667,32.22,0.45,27.9,19743,NULL,NULL,'Malmquist cor.','NGC 2770',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59668,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59668,32.27,0.43,28.4,19743,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2770',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59669,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59669,32.33,0.46,29.2,19743,NULL,NULL,'J','NGC 2770',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59670,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59670,32.36,0.47,29.6,19743,NULL,NULL,'H','NGC 2770',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59671,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59671,32.36,0.4,29.6,19743,75,NULL,'B','NGC 2770',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59672,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59672,32.36,0.49,29.6,19743,75,NULL,'IR','NGC 2770',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59673,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59673,32.47,0.45,31.2,19743,NULL,NULL,'K','NGC 2770',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59674,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59674,32.54,0.47,32.2,19743,75,NULL,'A82, H, raw','NGC 2770',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59675,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59675,32.61,0.47,33.3,19743,75,NULL,'A82, H, inv','NGC 2770',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59676,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59676,32.76,0.4,35.7,19743,NULL,NULL,'mean','NGC 2770',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59677,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59677,32.78,0.47,36,19743,75,NULL,'A82, H, cor','NGC 2770',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59678,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59678,38.47,0.46,494,19744,70,NULL,NULL,'SDSS J090935.89+014008.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000077,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,137.399583,1.66897,0.109,NULL,60669094259,947954597,14811790,18.2),(59679,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59679,37.51,0.46,318,19745,70,NULL,NULL,'2MASX J09093633+6632241',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,137.401375,66.54017,0.161,NULL,62275790109,973059220,15204050,17.8),(59680,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59680,35.55,0.27,129,19746,70,NULL,NULL,'MRK 1226',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000233,NULL,'14.8g',0.66,'e;a',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,137.406,19.46897,0.097,NULL,63832414468,997381476,15584085,14.8),(59681,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59681,38.51,0.33,504,19747,70,NULL,NULL,'SDSS J090938.27+022439.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000156,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,137.409458333,2.41092,0.081,NULL,60680116296,948126817,14814481,18.8),(59682,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59682,38.51,0.33,504,19748,70,NULL,NULL,'SDSS J090939.31+022427.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000082,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,137.413833,2.40761,0.081,NULL,60680971429,948140178,14814690,18.5),(59683,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59683,37.59,0.33,329,19749,70,NULL,NULL,'2MASX J09094100+2059188',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000178,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,137.420875,20.98858,0.113,NULL,63831003825,997359434,15583741,16.8),(59684,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59684,37.05,0.46,257,19750,70,NULL,NULL,'2MASX J09094105+1044325',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000169,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,137.421,10.74239,0.109,NULL,63641562604,994399415,15537490,16.5),(59685,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59685,36.88,0.46,237,19751,70,NULL,NULL,'2MASX J09094239+2909537',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000107,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,137.4265417,29.16497,0.033,NULL,64380480850,1005945013,15717890,16.9),(59686,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59686,33.41,NULL,48.1,19752,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 564- G 026',NULL,'2010Ap&SS.325..163P',2010,1,1.66,'Stars superposed.','G',0.000017,NULL,'16.48',0.22,'Scd',NULL,NULL,NULL,NULL,1,137.43,-21.33806,0.589,NULL,42352073688,661751151,10339861,16.48),(59687,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59687,33.43,NULL,48.5,19752,NULL,NULL,'Dipole + Quadrupole','ESO 564- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59688,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59688,33.43,NULL,48.6,19752,NULL,NULL,'Dipole','ESO 564- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59689,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59689,38.92,0.46,608,19753,70,NULL,NULL,'SDSS J090943.42+630627.8',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,137.430916667,63.10775,0.173,NULL,62029847167,969216361,15144005,NULL),(59690,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59690,37.6,0.46,331,19754,70,NULL,NULL,'SDSS J090943.90+433836.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,137.4329583,43.64347,0.033,NULL,64274780565,1004293446,15692085,18),(59691,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59691,36.74,0.46,223,19755,70,NULL,NULL,'2MASX J09094500+0749285',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000163,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,137.4375417,7.82453,0.121,NULL,63679692246,994995191,15546799,16.5),(59692,'Tully est','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59692,29.21,0.8,7,19756,75,NULL,NULL,'UGCA 148',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000007,NULL,'15.6B',1,'IAB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,137.443917,-23.00917,0.785,NULL,42315227997,661175437,10330866,15.6),(59693,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59693,37.85,0.46,371,19757,70,NULL,NULL,'2MASX J09094651+1648228',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,137.44375,16.80647,0.093,NULL,63877974809,998093356,15595208,17.9),(59694,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59694,37.15,0.19,270,19758,70,NULL,NULL,'2MASX J09094646+5205319',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000092,NULL,'16.5g',0.28,'NLAGN',NULL,NULL,NULL,NULL,1,137.4437917,52.09214,0.009,NULL,64225689447,1003526397,15680099,16.5),(59695,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59695,38.03,0.46,404,19759,70,NULL,NULL,'2MASX J09094661+1617398',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000194,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,137.4442083,16.29425,0.081,NULL,63877247924,998081998,15595031,16.7),(59696,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59696,37.43,0.46,307,19760,70,NULL,NULL,'2MASX J09094703+3422586',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000173,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,137.446125,34.38289,0.017,NULL,64411063155,1006422861,15725357,17.2),(59697,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59697,37.15,0.46,269,19761,70,NULL,NULL,'2MASX J09094741+0621525',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,137.4475,6.36467,0.101,NULL,63678493503,994976460,15546507,17.7),(59698,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59698,37.53,0.46,320,19762,70,NULL,NULL,'2MASX J09094879+4622191',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,137.453375,46.372,0.041,NULL,64281042060,1004391282,15693613,17.4),(59699,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59699,37.79,0.46,361,19763,70,NULL,NULL,'2MASX J09094925+4423175',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000135,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,137.4552083,44.38811,0.029,NULL,64288303036,1004504734,15695386,18),(59700,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59700,38.41,0.46,480,19764,70,NULL,NULL,'2MASX J09094978+2922260',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,137.4574583,29.37386,0.041,NULL,64380513750,1005945527,15717898,17.9),(59701,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59701,37.59,0.33,329,19765,70,NULL,NULL,'LCSB L0366N',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000093,NULL,'15.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,137.460833,20.98867,0.113,NULL,63830987689,997359182,15583737,15.9),(59702,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59702,36.58,0.46,207,19766,70,NULL,NULL,'2MASX J09095244-0030163',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000095,NULL,'17.4g',0.16,'NLAGN',NULL,NULL,NULL,'Sy 2',1,137.468333,-0.50467,0.101,NULL,41072892303,641763942,10027561,17.4),(59703,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59703,36.49,0.46,198,19767,70,NULL,NULL,'2MASX J09095275+3803200',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000173,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,137.469833,38.05561,0.041,NULL,64396901224,1006201581,15721899,16.5),(59704,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59704,37.84,0.46,369,19768,70,NULL,NULL,'2MASX J09095590+4357215',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,137.4827917,43.95603,0.037,NULL,64288242015,1004503781,15695371,18.1),(59705,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59705,37.08,0.46,261,19769,70,NULL,NULL,'SDSS J090957.06+351657.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000171,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,137.487833333,35.28267,0.033,NULL,64409719415,1006401865,15725029,18.1),(59706,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59706,37.14,0.46,268,19770,70,NULL,NULL,'2MASX J09095724+6038094',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,137.488583,60.63589,0.181,NULL,62068677578,969823087,15153485,17),(59707,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59707,37.37,0.55,298,19771,70,NULL,NULL,'2MASX J09095896-0530470',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.13',NULL,NULL,NULL,NULL,NULL,NULL,1,137.49575,-5.51328,0.089,NULL,42156285179,658691955,10292061,17.13),(59708,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59708,38.09,0.46,414,19772,70,NULL,NULL,'2MASX J09095997+2904251',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00015,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,137.499833,29.07369,0.033,NULL,64380471815,1005944872,15717888,17.3),(59709,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59709,36.44,0.46,194,19773,70,NULL,NULL,'2MASX J09100099+1229098',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,137.50425,12.48603,0.085,NULL,63864109627,997876712,15591823,16.4),(59710,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59710,37.84,0.46,369,19774,70,NULL,NULL,'2MASX J09100257+3737252',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000147,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,137.5107083,37.62353,0.013,NULL,64397101436,1006204709,15721948,17.6),(59711,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59711,35.98,0.46,157,19775,70,NULL,NULL,'2MASX J09100294+0219438',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000086,NULL,'16.2g',0.37,'S0/a',NULL,NULL,NULL,NULL,1,137.512333,2.32894,0.077,NULL,60681020401,948140943,14814702,16.2),(59712,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59712,37.55,0.46,324,19776,70,NULL,NULL,'2MASX J09100310+4655216',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000146,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,137.513,46.92258,0.013,NULL,64279471798,1004366746,15693230,17.5),(59713,'Tully est','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59713,31.5,0.8,19.9,19777,75,NULL,NULL,'UGCA 149',NULL,'1988NBGC.C....0000T',1988,1,2.3,NULL,'G',0.000022,NULL,'15',1.3,'SB(s)m:',NULL,NULL,NULL,NULL,1,137.515583,-33.15406,1.085,NULL,42944978306,671015286,10484613,15),(59714,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59714,37.04,0.46,256,19778,70,NULL,NULL,'2MASX J09100414+4307196',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,137.517166667,43.12206,0.037,NULL,64267298866,1004176544,15690258,17.2),(59715,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59715,36.24,0.46,177,19779,70,NULL,NULL,'MCG +09-15-102',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000081,NULL,'15.6g',0.52,'E0',NULL,NULL,NULL,NULL,1,137.5194583,52.06711,0,NULL,64225676512,1003526195,15680096,15.6),(59716,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59716,35.17,0.49,108,19780,75,NULL,'IR','UGC 04814',NULL,'2011yCatp016004901K',2011,1,1.32,NULL,'G',0.00017,NULL,'15.8g',0.22,'Sbc',NULL,NULL,NULL,NULL,1,137.522375,44.61808,0.049,NULL,64279942016,1004374094,15693345,15.8),(59717,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59717,35.42,NULL,121,19780,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04814',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59718,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59718,35.43,NULL,122,19780,NULL,NULL,'Dipole + Quadrupole','UGC 04814',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59719,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59719,35.45,NULL,123,19780,NULL,NULL,'Dipole','UGC 04814',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59720,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59720,35.46,NULL,124,19780,NULL,NULL,NULL,'UGC 04814',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59721,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59721,37.61,0.46,333,19781,70,NULL,NULL,'2MASX J09100539+0647006',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000193,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,137.5225417,6.7835,0.093,NULL,63681451869,995022685,15547229,17),(59722,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59722,37.32,0.46,292,19782,70,NULL,NULL,'2MASX J09100765+3909233',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,137.531875,39.15647,0.037,NULL,64399133866,1006236466,15722444,17.3),(59723,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59723,37.38,0.46,299,19783,70,NULL,NULL,'2MASX J09100887+5746269',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000075,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,137.537041667,57.77433,0.073,NULL,62015509041,968992328,15140505,17.6),(59724,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59724,38.47,0.46,495,19784,70,NULL,NULL,'2MASX J09100992+3708383',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000128,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,137.5415,37.14389,0.025,NULL,64396422685,1006194104,15721782,18.7),(59725,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59725,35.08,0.46,104,19785,70,NULL,NULL,'UGC 04812 NED02',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000037,NULL,'15.9g',0.34,'S0/a',NULL,NULL,NULL,NULL,1,137.541917,50.04733,0,NULL,64233026131,1003641033,15681891,15.9),(59726,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59726,37.59,0.46,329,19786,70,NULL,NULL,'2MASX J09101026+4317236',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,137.542625,43.28981,0.037,NULL,64267328137,1004177002,15690265,17.4),(59727,'IRAS','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59727,31.56,0.8,20.5,19787,75,NULL,'MAT, I','ESO 018- G 015',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000022,NULL,'12.59',0.8,'SB(r)cd:',NULL,NULL,NULL,NULL,1,137.547833333,-79.23439,0.441,NULL,39996282051,624941907,9764717,12.59),(59728,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59728,32.25,0.32,28.2,19787,85,NULL,'I, raw','ESO 018- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59729,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59729,32.25,0.32,28.2,19787,85,NULL,'I, inv','ESO 018- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59730,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59730,32.51,0.39,31.7,19787,73,NULL,'opt','ESO 018- G 015',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59731,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59731,32.55,0.95,32.3,19787,NULL,NULL,NULL,'ESO 018- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59732,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59732,32.58,0.94,32.9,19787,NULL,NULL,'Malmquist cor.','ESO 018- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59733,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59733,32.59,0.2,33,19787,74.4,NULL,NULL,'ESO 018- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59734,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59734,32.62,0.43,33.5,19787,75,NULL,'MAT, I, raw','ESO 018- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59735,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59735,32.69,0.43,34.6,19787,75,NULL,'MAT, I, inv','ESO 018- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59736,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59736,32.91,0.43,38.3,19787,75,NULL,'MAT, I, cor','ESO 018- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59737,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59737,34.88,0.46,94.5,19788,70,NULL,NULL,'NGC 2767',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.0001,NULL,'14.3g',0.68,'S?','in a radial-velocity based grouping',NULL,NULL,NULL,1,137.5495,50.40131,0.005,NULL,64236958179,1003702471,15682851,14.3),(59738,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59738,38.19,0.46,434,19789,70,NULL,NULL,'SDSS J091011.97+221446.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000126,NULL,'18.8g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,137.549916667,22.24628,0.173,NULL,63717810150,995590783,15556105,18.8),(59739,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59739,37.05,0.33,257,19790,70,NULL,NULL,'2MASX J09101323+3843554',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'17.66',0.43,NULL,NULL,NULL,NULL,NULL,1,137.555291667,38.73208,0.037,NULL,64399186034,1006237281,15722457,17.66),(59740,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59740,38.06,0.46,409,19791,70,NULL,NULL,'2MASX J09101363+1359435',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,137.556833333,13.99542,0.125,NULL,63865253278,997894582,15592102,NULL),(59741,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59741,36.99,0.46,251,19792,70,NULL,NULL,'2MASX J09101650+3610474',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000143,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,137.568875,36.17981,0,NULL,64408808833,1006387638,15724806,17.7),(59742,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59742,36.81,0.46,231,19793,70,NULL,NULL,'2MASX J09101733+5304210',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000071,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,137.5719583,53.07258,0.009,NULL,63958662928,999354108,15614907,17.3),(59743,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59743,37.16,0.33,271,19794,70,NULL,NULL,'2MASX J09101845+0426258',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000178,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,137.57675,4.44042,0.097,NULL,63625863987,994154124,15533658,16.7),(59744,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59744,38.44,0.33,487,19795,70,NULL,NULL,'SDSS J091018.80+400128.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,137.578333,40.02447,0.025,NULL,64395714230,1006183034,15721609,18.3),(59745,'Ring Diameter','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59745,30.7,0.84,14,19796,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 2775',NULL,'1981ApJS...45..541P',1981,1,4.3,NULL,'G',0.000007,NULL,'11.03',3.3,'SA(r)ab        AGN?','Isolated galaxy',NULL,NULL,NULL,1,137.583833,7.03794,0.101,NULL,63681863661,995029119,15547329,11.03),(59746,'Tully est','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59746,31.15,0.8,17,19796,75,NULL,'B','NGC 2775',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59747,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59747,38.59,0.46,522,19797,70,NULL,NULL,'2MASXi J0910217+455131',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000147,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,137.590917,45.85897,0.041,NULL,64280963903,1004390060,15693594,17.6),(59748,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59748,38.71,0.46,553,19798,70,NULL,NULL,'SDSS J091022.02+111442.7',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,137.59175,11.24519,0.093,NULL,63643416197,994428378,15537943,NULL),(59749,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59749,37.81,0.46,365,19799,70,NULL,NULL,'SDSS J091022.60+022405.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000067,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,137.594167,2.40139,0.077,NULL,60680984495,948140382,14814693,18.6),(59750,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59750,37.47,0.46,312,19800,70,NULL,NULL,'2MASX J09102287+1910297',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000152,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,137.595417,19.175,0.097,NULL,63829475953,997335561,15583368,17.2),(59751,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59751,37.24,0.46,281,19801,70,NULL,NULL,'SDSS J091024.31+275644.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,137.601333,27.94561,0.041,NULL,64192610295,1003009535,15672023,18.2),(59752,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59752,36.85,0.46,235,19802,70,NULL,NULL,'2MASX J09102435+1725166',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,137.6015,17.42122,0.109,NULL,63878638692,998103729,15595370,17.4),(59753,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59753,37.29,0.46,287,19803,70,NULL,NULL,'2MASX J09102527+2615322',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000178,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,137.6052083,26.25903,0.061,NULL,64193681649,1003026275,15672285,16.8),(59754,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59754,38.17,0.46,431,19804,70,NULL,NULL,'2MASX J09102546+2459432',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,137.6059583,24.9955,0.133,NULL,63705477206,995398081,15553095,17.6),(59755,'IRAS','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59755,34.25,0.8,70.8,19805,75,NULL,'MAT, I','ESO 497- G 018',NULL,'1997ApJS..109..333W',1997,1,2.35,NULL,'G',0.000033,NULL,'15.25',0.33,'S0/a: sp',NULL,NULL,NULL,NULL,1,137.606416667,-23.49111,0.721,NULL,42314956452,661171194,10330799,15.25),(59756,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59756,34.28,0.43,71.7,19805,75,NULL,'MAT, I, raw','ESO 497- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59757,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59757,34.33,0.32,73.3,19805,85,NULL,'I, raw','ESO 497- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59758,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59758,34.33,0.49,73.6,19805,75,NULL,'IR','ESO 497- G 018',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59759,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59759,34.38,0.32,75.1,19805,85,NULL,'I, inv','ESO 497- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59760,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59760,34.52,0.43,80,19805,75,NULL,'MAT, I, inv','ESO 497- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59761,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59761,34.58,0.43,82.3,19805,75,NULL,'MAT, I, cor','ESO 497- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59762,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59762,34.61,NULL,83.5,19805,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 497- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59763,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59763,34.61,NULL,83.6,19805,NULL,NULL,'Dipole','ESO 497- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59764,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59764,34.62,NULL,84,19805,NULL,NULL,'Dipole + Quadrupole','ESO 497- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59765,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59765,34.64,0.52,84.5,19805,NULL,NULL,'Malmquist cor.','ESO 497- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59766,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59766,34.67,NULL,86,19805,NULL,NULL,NULL,'ESO 497- G 018',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59767,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59767,34.77,0.2,90,19805,74.4,NULL,NULL,'ESO 497- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59768,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59768,34.78,0.49,90.3,19805,NULL,NULL,NULL,'ESO 497- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59769,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59769,34.87,0.43,94.2,19805,75,NULL,'3.6 micron, color corrected','ESO 497- G 018',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59770,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59770,34.98,0.43,99,19805,75,NULL,'3.6 micron, color + selection bias corrected','ESO 497- G 018',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59771,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59771,37.59,0.46,330,19806,70,NULL,NULL,'2MASX J09102577+5226330',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000085,NULL,'16.7g',0.35,NULL,NULL,NULL,NULL,NULL,1,137.607375,52.44239,0,NULL,63956427329,999319177,15614362,16.7),(59772,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59772,37.62,0.46,334,19807,70,NULL,NULL,'2MASX J09102596+5159180',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000084,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,137.608375,51.98839,0,NULL,64226198215,1003534347,15680224,17.6),(59773,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59773,37.01,0.46,253,19808,70,NULL,NULL,'2MASX J09102726+3436517',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.0002,NULL,'17.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,137.6135,34.61436,0.017,NULL,64409109350,1006392333,15724880,17),(59774,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59774,32.58,0.47,32.8,19809,NULL,NULL,'H','NGC 2769',NULL,'2007A&A...465...71T',2007,1,2.15,NULL,'G',0.000043,NULL,'13.6g',0.55,'Sa','Pair member (points to parent)',NULL,NULL,NULL,1,137.634,50.43328,0.005,NULL,64236951538,1003702367,15682849,13.6),(59775,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59775,32.75,0.45,35.4,19809,NULL,NULL,'K','NGC 2769',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59776,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59776,32.79,0.46,36.2,19809,NULL,NULL,'J','NGC 2769',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59777,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59777,34.13,0.4,66.9,19809,NULL,NULL,'mean','NGC 2769',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59778,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59778,37.9,0.46,381,19810,70,NULL,NULL,'2MASX J09103293+4149393',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,137.637167,41.82769,0.021,NULL,64268704928,1004198514,15690601,17.8),(59779,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59779,36.37,0.46,188,19811,70,NULL,NULL,'2MASX J09103293+0135564',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000087,NULL,'16.0g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,137.63725,1.59889,0.073,NULL,60682147753,948158558,14814977,16),(59780,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59780,36.63,0.33,212,19812,70,NULL,NULL,'KUG 0907+479',NULL,'2015arXiv151105856S',2015,1,0.42,'The position in 2002PNAOJ...6..107M is for a star.','G',0.00006,NULL,'16.5g',0.27,'Spiral',NULL,NULL,NULL,NULL,1,137.644667,47.75825,0.017,NULL,64233979905,1003655936,15682124,16.5),(59781,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59781,37.05,0.33,257,19813,70,NULL,NULL,'2MASX J09103478+3843053',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000167,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,137.644833,38.71806,0.037,NULL,64399185665,1006237276,15722457,17.8),(59782,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59782,36.62,0.46,211,19814,70,NULL,NULL,'2MASX J09103525+1008275',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,137.646833,10.14083,0.189,NULL,63641626131,994400408,15537506,16.9),(59783,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59783,38.06,0.46,408,19815,70,NULL,NULL,'2MASX J09103532+3717233',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000137,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,137.647083,37.28978,0.009,NULL,64396401063,1006193766,15721777,18.5),(59784,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59784,37.32,0.46,292,19816,70,NULL,NULL,'SDSS J091036.42+043546.9',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,137.6517917,4.59639,0.101,NULL,63626953274,994171144,15533924,17.8),(59785,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59785,37.16,0.33,271,19817,70,NULL,NULL,'2MASX J09103985+0431274',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000176,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,137.6660417,4.52414,0.097,NULL,63625987660,994156057,15533688,17),(59786,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59786,35.06,0.46,103,19818,70,NULL,NULL,'NGC 2774',NULL,'2015arXiv151105856S',2015,1,0.94,NULL,'G',0.00014,NULL,'14.3g',0.9,NULL,NULL,NULL,NULL,NULL,1,137.666333333,18.69658,0.093,NULL,63875360931,998052514,15594570,14.3),(59787,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59787,38.34,0.46,467,19819,70,NULL,NULL,'2MASX J09104023+5233460',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000086,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,137.667667,52.56292,0,NULL,63956572117,999321439,15614397,17.5),(59788,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59788,37.9,0.46,380,19820,70,NULL,NULL,'2MASX J09104142+2304135',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000139,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,137.6727083,23.07053,0.157,NULL,63705081316,995391895,15552998,18.4),(59789,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59789,32.05,NULL,25.7,19821,NULL,NULL,NULL,'NGC 2777',NULL,'2015AstBu..70....1K',2015,1,0.84,NULL,'G',0.000023,NULL,'14.1g',0.67,'Sab?','in a pair',NULL,NULL,NULL,1,137.674291667,7.20669,0.109,NULL,63681774843,995027731,15547308,14.1),(59790,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59790,37.17,0.46,272,19822,70,NULL,NULL,'SDSS J091041.88+663853.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,137.6745417,66.64811,0.169,NULL,62275843074,973060048,15204063,18),(59791,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59791,38.62,0.46,530,19823,70,NULL,NULL,'SDSS J091042.20+452711.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000122,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,137.675875,45.45319,0.041,NULL,64280505055,1004382891,15693482,18.5),(59792,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59792,38.75,0.46,562,19824,70,NULL,NULL,'2MASX J09104360+2219315',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000131,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,137.6817917,22.32544,0.173,NULL,63717983265,995593488,15556148,18.4),(59793,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59793,37.17,0.46,271,19825,70,NULL,NULL,'SDSS J091045.14+501650.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000143,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,137.688083,50.28067,0.005,NULL,64232688757,1003635761,15681808,17.9),(59794,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59794,37.04,0.46,256,19826,70,NULL,NULL,'SDSS J091046.14+072401.8',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000173,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,137.6922917,7.40053,0.109,NULL,63681852339,995028942,15547327,17),(59795,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59795,35.55,0.27,129,19827,70,NULL,NULL,'CGCG 091-016 NED01',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000221,NULL,'15.5g',0.43,NULL,NULL,NULL,NULL,NULL,1,137.6937917,19.61,0.093,NULL,63832859779,997388434,15584194,15.5),(59796,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59796,36.63,0.33,212,19828,70,NULL,NULL,'2MASX J09104674+4756307',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000073,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,137.6947917,47.94214,0.013,NULL,64234161442,1003658772,15682168,16.8),(59797,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59797,36.29,0.46,181,19829,70,NULL,NULL,'2MASX J09104796+3526175',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,137.6997917,35.43828,0,NULL,64409766463,1006402600,15725040,17),(59798,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59798,38.1,0.27,417,19830,70,NULL,NULL,'2MASX J09104817+1602167',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,137.700833,16.03806,0.073,NULL,63859487421,997804490,15590695,17.2),(59799,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59799,37.97,0.46,393,19831,70,NULL,NULL,'2MASX J09104858+1710197',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,137.702625,17.17228,0.101,NULL,63877514465,998086163,15595096,17.7),(59800,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59800,35.55,0.27,129,19832,70,NULL,NULL,'SDSS J091048.62+193556.2',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'16.0g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,137.702625,19.59897,0.093,NULL,63832398018,997381219,15584081,16),(59801,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59801,38.44,0.33,487,19833,70,NULL,NULL,'SDSS J091048.63+395207.7',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,137.702667,39.86883,0.021,NULL,64398580745,1006227824,15722309,17.8),(59802,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59802,38.1,0.27,417,19834,70,NULL,NULL,'2MASX J09104886+1601487',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,137.703625,16.03008,0.073,NULL,63859487267,997804488,15590695,18),(59803,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59803,37.31,0.46,289,19835,70,NULL,NULL,'2MASX J09104898+2001015',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,137.7040417,20.01694,0.101,NULL,63832786100,997387282,15584176,17.8),(59804,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59804,32.02,0.4,25.3,19836,73,NULL,'IR','UGCA 150',NULL,'2011A&A...532A.104N',2011,1,6.5,NULL,'G',0.000013,NULL,'11.91',0.69,'SAB(rs)b: sp   HII',NULL,NULL,NULL,NULL,1,137.706083,-8.89069,0.137,NULL,42183418127,659115908,10298686,11.91),(59805,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59805,32.02,0.4,25.3,19836,75,NULL,NULL,'UGCA 150',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59806,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59806,32.08,0.46,26.1,19836,NULL,NULL,'J','UGCA 150',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59807,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59807,32.1,0.45,26.3,19836,NULL,NULL,'K','UGCA 150',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59808,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59808,32.11,0.49,26.5,19836,75,NULL,'IR','UGCA 150',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59809,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59809,32.37,0.2,29.8,19836,74.4,NULL,NULL,'UGCA 150',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59810,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59810,32.41,0.43,30.3,19836,75,NULL,'3.6 micron, color corrected','UGCA 150',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59811,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59811,32.5,0.4,31.6,19836,NULL,NULL,'mean','UGCA 150',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59812,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59812,32.53,0.43,32.1,19836,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 150',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59813,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59813,32.67,NULL,34.2,19836,NULL,NULL,'Dipole','UGCA 150',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59814,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59814,32.68,NULL,34.3,19836,NULL,NULL,'Dipole + Quadrupole','UGCA 150',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59815,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59815,32.68,NULL,34.3,19836,NULL,NULL,'Dipole + Quadrupole + Octopole','UGCA 150',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59816,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59816,32.74,NULL,35.4,19836,NULL,NULL,NULL,'UGCA 150',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59817,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59817,36.01,0.65,159,19837,70,NULL,NULL,'2MASX J09105025-0132578',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.59',0.5,NULL,NULL,NULL,NULL,NULL,1,137.709333,-1.54931,0.073,NULL,41086393726,641974901,10030857,16.59),(59818,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59818,37.3,0.46,288,19838,70,NULL,NULL,'2MASX J09105032+6554174',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,137.7097917,65.90481,0.145,NULL,62262191483,972846741,15200730,17.1),(59819,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59819,37.86,0.46,373,19839,70,NULL,NULL,'2MASX J09105148+0116004',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000083,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,137.714417,1.26689,0.093,NULL,60681857947,948154030,14814906,17.8),(59820,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59820,36.26,0.57,179,19840,70,NULL,NULL,'2MASX J09105415-1626109',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,137.725667,-16.43631,0.157,NULL,42406316640,662598697,10353104,15.6),(59821,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59821,38.15,0.46,426,19841,70,NULL,NULL,'2MASX J09105719+5307109',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000076,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,137.738125,53.11972,0.009,NULL,63958651737,999353933,15614905,18.1),(59822,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59822,35.86,0.46,148,19842,70,NULL,NULL,'2MASX J09105737+5033319',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000154,NULL,'15.9g',0.36,'S0/a',NULL,NULL,NULL,NULL,1,137.739333333,50.55886,0,NULL,64236972170,1003702690,15682854,15.9),(59823,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59823,37.17,0.46,271,19843,70,NULL,NULL,'2MASX J09105823+1550457',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000179,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,137.74275,15.84614,0.069,NULL,63859574990,997805859,15590716,16.3),(59824,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59824,37.82,0.33,367,19844,70,NULL,NULL,'SDSS J091100.17+182808.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000146,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,137.75075,18.46894,0.093,NULL,63875560043,998055625,15594619,18.5),(59825,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59825,34.47,0.47,78.2,19845,70,NULL,NULL,'2MASX J09110124-1306159',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00008,NULL,'15.54',NULL,NULL,NULL,NULL,NULL,NULL,1,137.755,-13.10461,0.173,NULL,42369090417,662017037,10344016,15.54),(59826,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59826,38.8,0.27,576,19846,70,NULL,NULL,'2MASX J09110121+1258097',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,137.755125,12.96933,0.093,NULL,63864189934,997877967,15591843,18.5),(59827,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59827,36.82,0.46,231,19847,70,NULL,NULL,'2MASX J09110135+5712472',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000896,NULL,'17.0g',0.26,'BLAGN',NULL,NULL,NULL,'Sy 1',1,137.755541667,57.21303,0.073,NULL,62023531867,969117685,15142463,17),(59828,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59828,35.12,0.49,106,19848,75,NULL,'IR','UGC 04827',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000033,NULL,'14.90',0.3,'Sb             AGN?','Isolated galaxy',NULL,NULL,NULL,1,137.757041667,13.41411,0.113,NULL,63865814923,997903358,15592239,14.9),(59829,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59829,37.76,0.46,356,19849,70,NULL,NULL,'SDSS J091102.14+040459.2',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00014,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,137.7589583,4.08311,0.089,NULL,63625946552,994155414,15533678,17.6),(59830,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59830,38.17,0.46,431,19850,70,NULL,NULL,'2MASX J09110302+5657222',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000085,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,137.762625,56.95622,0.065,NULL,62009871487,968904241,15139128,17.5),(59831,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59831,37.73,0.33,352,19851,70,NULL,NULL,'2MASX J09110340+6314467',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'17.41',0.33,NULL,NULL,NULL,NULL,NULL,1,137.764333,63.24625,0.173,NULL,62029935559,969217743,15144027,17.41),(59832,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59832,35.8,0.55,145,19852,70,NULL,NULL,'2MASX J09110477-1612549',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.46',NULL,NULL,NULL,NULL,NULL,NULL,1,137.769917,-16.21531,0.189,NULL,42373033003,662078640,10344978,16.46),(59833,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59833,37.77,0.46,358,19853,70,NULL,NULL,'2MASX J09110667+4543447',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'15.6',0.28,NULL,NULL,NULL,NULL,NULL,1,137.7777083,45.72917,0.041,NULL,64280928450,1004389507,15693586,15.6),(59834,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59834,36.99,0.46,250,19854,70,NULL,NULL,'2MASX J09110903+2234495',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000133,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,137.78775,22.58036,0.129,NULL,63717958039,995593094,15556142,17.2),(59835,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59835,38.28,0.46,453,19855,70,NULL,NULL,'2MASX J09110922+3818042',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,137.788333,38.30119,0.033,NULL,64396988327,1006202942,15721920,17.3),(59836,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59836,36.98,0.64,249,19856,70,NULL,NULL,'2MASX J09110962-1830322',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,137.790041667,-18.50889,0.237,NULL,42405196821,662581200,10352831,15.9),(59837,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59837,35.29,0.49,114,19857,75,NULL,'IR','UGC 04828',NULL,'2011yCatp016004901K',2011,1,1.68,NULL,'G',0.00002,NULL,'15.8g',0.23,'Sc',NULL,NULL,NULL,NULL,1,137.79075,19.66817,0.093,NULL,63832851793,997388309,15584192,15.8),(59838,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59838,35.41,NULL,121,19857,NULL,NULL,'Dipole + Quadrupole','UGC 04828',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59839,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59839,35.41,NULL,121,19857,NULL,NULL,'Dipole','UGC 04828',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59840,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59840,35.41,NULL,121,19857,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04828',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59841,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59841,35.45,0.31,123,19857,NULL,NULL,'Malmquist cor.','UGC 04828',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59842,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59842,35.53,NULL,127,19857,NULL,NULL,NULL,'UGC 04828',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59843,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59843,35.63,0.29,134,19857,NULL,NULL,NULL,'UGC 04828',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59844,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59844,35.71,0.2,139,19857,74.4,NULL,NULL,'UGC 04828',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59845,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59845,38,0.23,399,19858,70,NULL,NULL,'2MASX J09111030+5149205',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000097,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,137.793083,51.82236,0,NULL,64225357123,1003521205,15680018,17.6),(59846,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59846,36.62,0.46,211,19859,70,NULL,NULL,'2MASX J09111058+2742486',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000196,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,137.794167,27.71358,0.041,NULL,64192617207,1003009643,15672025,16.3),(59847,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59847,36.83,0.53,232,19860,70,NULL,NULL,'2MASX J09110953-1609296',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.33',NULL,'poss. LINER?',NULL,NULL,NULL,NULL,1,137.795916667,-16.15436,0.189,NULL,42373076060,662079313,10344989,16.33),(59848,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59848,38.1,0.27,417,19861,70,NULL,NULL,'2MASX J09111246+1601116',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,137.802,16.01981,0.081,NULL,63859510639,997804853,15590700,17.9),(59849,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59849,38.14,0.33,425,19862,70,NULL,NULL,'SDSS J091114.00+564355.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000063,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,137.808333,56.73208,0.061,NULL,62009860546,968904071,15139126,18.5),(59850,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59850,36.98,0.46,249,19863,70,NULL,NULL,'2MASX J09111410+2047555',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,137.8087083,20.79894,0.101,NULL,63830697630,997354650,15583666,18.1),(59851,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59851,39.12,0.46,667,19864,70,NULL,NULL,'2MASX J09111485+4803205',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000147,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,137.811875,48.05572,0.009,NULL,64235129342,1003673895,15682404,18),(59852,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59852,38.8,0.27,576,19865,70,NULL,NULL,'2MASX J09111541+1250326',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,137.814125,12.8425,0.081,NULL,63864240367,997878755,15591855,18.1),(59853,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59853,36.09,0.55,165,19866,70,NULL,NULL,'2MASX J09111651-0742181',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,137.818833333,-7.705,0.141,NULL,42201271046,659394860,10303044,15.2),(59854,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59854,34.96,0.65,98.2,19867,70,NULL,NULL,'2MASX J09111889-0946061',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14',0.2,'S0','Group member',NULL,NULL,NULL,1,137.82875,-9.76839,0.181,NULL,42190630612,659228603,10300446,14),(59855,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59855,34.5,NULL,79.6,19868,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 497- G 020',NULL,'2010Ap&SS.325..163P',2010,1,1.12,NULL,'G',0.00005,NULL,'17.23',0.13,'Sd',NULL,NULL,NULL,NULL,1,137.83,-24.04194,0.933,NULL,42315460587,661179071,10330922,17.23),(59856,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59856,34.52,NULL,80,19868,NULL,NULL,'Dipole + Quadrupole','ESO 497- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59857,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59857,34.54,NULL,80.8,19868,NULL,NULL,'Dipole','ESO 497- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59858,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59858,34.57,NULL,81.9,19868,NULL,NULL,NULL,'ESO 497- G 020',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59859,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59859,38.18,0.46,432,19869,70,NULL,NULL,'2MASX J09111955+6219248',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,137.831583,62.32369,0.141,NULL,62061417480,969709648,15151713,17.8),(59860,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59860,32.23,0.4,27.9,19870,75,NULL,'B','DDO 057',NULL,'1988NBGC.C....0000T',1988,1,2,'Confused HIPASS source','G',0.000013,NULL,'14.2',1.7,'IB(s)m:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,137.832917,-15.04944,0.141,NULL,42375248762,662113261,10345519,14.2),(59861,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59861,32.14,0.4,26.8,19871,75,NULL,NULL,'ESO 433- G 007',NULL,'2008Ap.....51..336K',2008,1,1.6,NULL,'G',0.000017,NULL,'16',0.8,'IB(s)m',NULL,NULL,NULL,NULL,1,137.833625,-30.87272,0.965,NULL,42911474204,670491784,10476434,16),(59862,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59862,32.14,0.4,26.8,19871,73,NULL,'IR','ESO 433- G 007',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59863,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59863,32.85,0.49,37.2,19871,75,NULL,'IR','ESO 433- G 007',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59864,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59864,37.82,0.33,367,19872,70,NULL,NULL,'2MASX J09112086+1824105',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,137.8367917,18.403,0.093,NULL,63875551274,998055488,15594617,17.1),(59865,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59865,38.92,0.46,609,19873,70,NULL,NULL,'SDSS J091121.96+025911.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,137.841541667,2.98661,0.101,NULL,60680897857,948139029,14814672,18.1),(59866,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59866,37.6,0.46,331,19874,70,NULL,NULL,'2MASX J09112215+4114333',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000178,NULL,'17.0g',0.31,NULL,NULL,NULL,NULL,NULL,1,137.842333,41.24247,0.029,NULL,64269078017,1004204344,15690692,17),(59867,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59867,38.8,0.27,576,19875,70,NULL,NULL,'2MASX J09112239+1248067',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,'PHOT','17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,137.843375,12.80183,0.081,NULL,63864220239,997878441,15591850,17.3),(59868,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59868,37.56,0.46,325,19876,70,NULL,NULL,'2MASX J09112277+5103565',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000143,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,137.845,51.06581,0,NULL,64236846692,1003700729,15682823,17.6),(59869,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59869,34.99,0.46,99.5,19877,70,NULL,NULL,'CGCG 288-025',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000083,NULL,'15.3',0.3,NULL,NULL,NULL,NULL,NULL,1,137.845333,62.01619,0.145,NULL,62061115311,969704926,15151639,15.3),(59870,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59870,36.81,0.58,231,19878,70,NULL,NULL,'2MASX J09112470-1934542',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.09',NULL,NULL,NULL,NULL,NULL,NULL,1,137.852833,-19.58189,0.433,NULL,42350216000,661722125,10339408,16.09),(59871,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59871,38,0.23,399,19879,70,NULL,NULL,'SDSS J091126.15+514841.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000064,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,137.859,51.81156,0,NULL,64225353830,1003521153,15680018,18),(59872,'Ring Diameter','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59872,32.1,0.76,26,19880,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 2781',NULL,'1981ApJS...45..541P',1981,1,3,'Confused HIPASS source','G',0.000023,NULL,'12.53',1.5,'SAB(r)0+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,137.864667,-14.81683,0.133,NULL,42375907286,662123551,10345680,12.53),(59873,'Ring Diameter','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59873,32.3,0.98,29,19880,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 2781',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59874,'Faber-Jackson','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59874,29.71,0.63,8.75,19880,95,NULL,'Michard 1979b, c','NGC 2781',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59875,'Faber-Jackson','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59875,30.28,0.44,11.4,19880,95,NULL,'Weighted Mean','NGC 2781',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59876,'Faber-Jackson','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59876,30.86,0.46,14.9,19880,95,NULL,'Michard 1979a','NGC 2781',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59877,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59877,32.2,0.4,27.5,19880,75,NULL,'B','NGC 2781',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59878,'G Lens','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59878,41.03,0.52,1610,19881,NULL,NULL,NULL,'RX J0911.4+0551:[KCH2000] L01',NULL,'2007ApJ...660....1O',2007,1,NULL,NULL,'G',NULL,NULL,'22.4',NULL,NULL,NULL,NULL,NULL,NULL,1,137.864833,5.84839,0.081,NULL,63623862997,994122859,15533169,22.4),(59879,'G Lens','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,NULL,59879,42.69,0.47,3450,19881,NULL,NULL,NULL,'RX J0911.4+0551:[KCH2000] L01',NULL,'2014MNRAS.437..600S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59880,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59880,36.44,0.46,194,19882,70,NULL,NULL,'2MASX J09112976+2918389',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000097,NULL,'16.1g',0.39,'E',NULL,NULL,NULL,NULL,1,137.8742083,29.31089,0.041,NULL,64199100587,1003110946,15673608,16.1),(59881,'FP','2016-12-15 15:14:27','2016-12-16 11:19:33','1',NULL,'R',59881,37.51,0.46,318,19883,70,NULL,NULL,'2MASX J09113119+0113551',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000066,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,137.8799583,1.23197,0.077,NULL,60681829289,948153582,14814899,17.9),(59882,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59882,37.65,0.46,339,19884,70,NULL,NULL,'2MASX J09113188+1405407',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,137.882833,14.09461,0.145,NULL,63865313536,997895524,15592117,17.2),(59883,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59883,36.63,0.46,212,19885,70,NULL,NULL,'2MASX J09113196+0214231',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000083,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,137.883291667,2.23981,0.081,NULL,60680378022,948130906,14814545,16.3),(59884,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59884,32.45,0.4,30.9,19886,NULL,NULL,NULL,'UGC 04824',NULL,'2009AJ....138..323T',2009,1,1.31,NULL,'G',0.000017,NULL,'14.7g',0.55,'SAd',NULL,NULL,NULL,NULL,1,137.890708333,51.25444,0.005,NULL,64225323816,1003520684,15680010,14.7),(59885,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59885,32.47,0.58,31.1,19886,NULL,NULL,'Malmquist cor.','UGC 04824',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59886,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59886,32.58,0.2,32.8,19886,74.4,NULL,NULL,'UGC 04824',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59887,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59887,32.72,0.52,35,19886,NULL,NULL,NULL,'UGC 04824',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59888,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59888,32.74,0.43,35.3,19886,75,NULL,'3.6 micron, color corrected','UGC 04824',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59889,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59889,32.92,0.43,38.4,19886,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04824',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59890,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59890,32.96,0.49,39.1,19886,75,NULL,'IR','UGC 04824',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59891,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59891,32.97,0.4,39.3,19886,75,NULL,NULL,'UGC 04824',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59892,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59892,36.61,0.46,210,19887,70,NULL,NULL,'SDSS J091134.75+125538.1',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',NULL,NULL,'15.7g',0.44,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,137.894833,12.92725,0.081,NULL,63864213511,997878336,15591849,15.7),(59893,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59893,38.03,0.46,403,19888,70,NULL,NULL,'2MASX J09113503+5301504',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000075,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,137.8957917,53.03056,0,NULL,63958546672,999352291,15614879,18.1),(59894,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59894,37.81,0.46,365,19889,70,NULL,NULL,'2MASX J09113722+5704519',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000079,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,137.90525,57.08119,0.073,NULL,62023316627,969114322,15142411,17.9),(59895,'GCLF','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59895,31.57,0.22,20.6,19890,NULL,NULL,NULL,'NGC 2768',NULL,'2001AJ....122.1251K',2001,1,8.1,NULL,'G',0.000017,NULL,'10.84',4.3,'S0_1/2_        LINER','Possible field galaxy',NULL,NULL,'Sy',1,137.90625,60.03722,0.161,NULL,62070532864,969852076,15153938,10.84),(59896,'SBF','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59896,31.73,0.14,22.2,19890,74.4,NULL,NULL,'NGC 2768',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59897,'SBF','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59897,31.75,0.24,22.4,19890,NULL,NULL,'I','NGC 2768',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59898,'SBF','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59898,31.75,0.24,22.4,19890,NULL,NULL,NULL,'NGC 2768',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59899,'SBF','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59899,31.81,0.24,23,19890,NULL,NULL,'Malmquist cor.','NGC 2768',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59900,'D-Sigma','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59900,31.12,0.4,16.7,19890,75,NULL,'Edat, raw','NGC 2768',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59901,'D-Sigma','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59901,31.45,0.4,19.5,19890,75,NULL,'Edat, cor','NGC 2768',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59902,'Faber-Jackson','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59902,30.28,0.53,11.4,19890,95,NULL,'de Vaucouleurs','NGC 2768',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59903,'Faber-Jackson','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59903,30.64,NULL,13.4,19890,NULL,NULL,'LEDA [April 2006]','NGC 2768',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59904,'Faber-Jackson','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59904,30.8,0.3,14.5,19890,95,NULL,'Weighted Mean','NGC 2768',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59905,'Faber-Jackson','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59905,31.4,0.63,19.1,19890,95,NULL,'Michard 1979b, c','NGC 2768',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59906,'Faber-Jackson','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59906,31.45,0.46,19.5,19890,95,NULL,'Michard 1979a','NGC 2768',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59907,'Faber-Jackson','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59907,31.87,0.81,23.7,19890,55,NULL,'Visvanathan & Sandage 1979','NGC 2768',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59908,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59908,30.92,0.41,15.3,19890,NULL,NULL,NULL,'NGC 2768',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59909,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59909,31.16,0.41,17,19890,NULL,NULL,'Malmquist cor.','NGC 2768',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59910,'Tertiary','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59910,31.55,0.25,20.4,19890,95,NULL,NULL,'NGC 2768',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59911,'Tully est','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59911,31.87,0.8,23.7,19890,75,NULL,'B','NGC 2768',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59912,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59912,38.61,0.46,528,19891,70,NULL,NULL,'SDSS J091137.66+372957.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000136,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,137.906958333,37.49922,0.009,NULL,64397163152,1006205674,15721963,18.7),(59913,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59913,34.49,0.55,78.9,19892,70,NULL,NULL,'2MASX J09113819-0638467',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.89',NULL,NULL,NULL,NULL,NULL,NULL,1,137.9092083,-6.64644,0.125,NULL,42199718321,659370598,10302665,15.89),(59914,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59914,37.68,0.46,343,19893,70,NULL,NULL,'2MASX J09113849+1544044',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,137.910166667,15.73469,0.081,NULL,63859561131,997805642,15590713,17.5),(59915,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59915,37.93,0.46,385,19894,70,NULL,NULL,'SDSS J091139.97+020621.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000065,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,137.9165417,2.10586,0.081,NULL,60682276937,948160577,14815009,18.2),(59916,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59916,37.4,0.46,303,19895,70,NULL,NULL,'2MASX J09114154+0341431',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000183,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,137.923,3.69533,0.073,NULL,60676745709,948074151,14813658,16.5),(59917,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59917,36.43,0.46,193,19896,70,NULL,NULL,'VIII Zw 041',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'17.33',0.42,NULL,NULL,NULL,NULL,NULL,1,137.923833,8.50631,0.149,NULL,63647389037,994490453,15538913,17.33),(59918,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59918,37.79,0.46,361,19897,70,NULL,NULL,'2MASX J09114234+2442599',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,137.92625,24.71664,0.113,NULL,63705565817,995399465,15553116,18),(59919,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59919,35.9,0.33,152,19898,70,NULL,NULL,'2MASX J09114243+2301004',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00014,NULL,'15.9g',0.34,NULL,NULL,NULL,NULL,NULL,1,137.926917,23.01667,0.169,NULL,63704590428,995384225,15552878,15.9),(59920,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59920,37.55,0.46,323,19899,70,NULL,NULL,'SDSS J091144.59+154550.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,137.935833,15.76414,0.081,NULL,63859560466,997805632,15590713,18.3),(59921,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59921,37.38,0.46,299,19900,70,NULL,NULL,'2MASX J09114593+4101568',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,137.9415,41.03253,0.033,NULL,64269002137,1004203158,15690674,17.2),(59922,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59922,37.89,0.46,379,19901,70,NULL,NULL,'SDSS J091147.39+325016.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,137.9475,32.83789,0.005,NULL,64408319677,1006379994,15724687,18.4),(59923,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59923,36.42,0.46,193,19902,70,NULL,NULL,'2MASX J09114782+2808409',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,137.949333,28.14456,0.033,NULL,64191863637,1002997869,15671841,17.1),(59924,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59924,38.34,0.46,465,19903,70,NULL,NULL,'SDSS J091148.12+534932.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00008,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,137.9505417,53.82575,0.021,NULL,63958246258,999347597,15614806,17.9),(59925,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59925,37.94,0.46,387,19904,70,NULL,NULL,'2MASX J09114932+1353404',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,137.955583,13.89456,0.169,NULL,63865646085,997900720,15592198,18),(59926,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59926,37.86,0.46,373,19905,70,NULL,NULL,'SDSS J091149.40+614610.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.3g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,137.955875,61.76969,0.133,NULL,62061174020,969705844,15151653,18.3),(59927,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59927,37.29,0.46,287,19906,70,NULL,NULL,'SDSS J091151.25+022709.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000089,NULL,'17.7g',0.19,'BLAGN',NULL,NULL,NULL,'Sy 1',1,137.963583,2.45278,0.089,NULL,60680889067,948138891,14814670,17.7),(59928,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59928,36.08,0.53,165,19907,70,NULL,NULL,'2MASX J09115226-0724007',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.7I',0.3,NULL,NULL,NULL,NULL,NULL,1,137.96775,-7.40017,0.153,NULL,42202332009,659411437,10303303,13.7),(59929,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59929,38.02,0.46,402,19908,70,NULL,NULL,'2MASXi J0911523+162008',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'17.5g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,137.968,16.33578,0.073,NULL,63860193133,997815517,15590867,17.5),(59930,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59930,35.09,0.49,104,19909,75,NULL,'IR','UGC 04839',NULL,'2011yCatp016004901K',2011,1,1.3,'RC3 misprints velocity as V_sun_ = 9272.','G',0.000067,NULL,'15.26',0.2,'Sbc',NULL,NULL,NULL,NULL,1,137.9702917,16.27847,0.073,NULL,63860191953,997815499,15590867,15.26),(59931,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59931,37.51,0.33,317,19910,70,NULL,NULL,'2MASX J09115304+4906269',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,137.971,49.10744,0.009,NULL,64234904484,1003670382,15682349,17.2),(59932,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59932,37.93,0.46,385,19911,70,NULL,NULL,'2MASX J09115410+1011004',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,137.975375,10.18344,0.177,NULL,63649209305,994518895,15539357,18.3),(59933,'IRAS','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59933,32.48,0.8,31.3,19912,75,NULL,'MAT, I','UGCA 151',NULL,'1997ApJS..109..333W',1997,1,4.76,NULL,'G',0.000002,NULL,'14.35',0.31,'Sd',NULL,NULL,NULL,NULL,1,137.97775,-20.11692,0.521,NULL,42353535169,661773987,10340218,14.35),(59934,'Tully est','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59934,32.32,0.8,29.1,19912,75,NULL,NULL,'UGCA 151',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59935,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59935,32.11,0.4,26.4,19912,73,NULL,'IR','UGCA 151',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59936,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59936,32.11,0.4,26.4,19912,75,NULL,NULL,'UGCA 151',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59937,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59937,32.51,0.41,31.7,19912,NULL,NULL,'Malmquist cor.','UGCA 151',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59938,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59938,32.54,NULL,32.3,19912,NULL,NULL,'Dipole','UGCA 151',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59939,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59939,32.55,NULL,32.4,19912,NULL,NULL,'Dipole + Quadrupole','UGCA 151',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59940,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59940,32.56,NULL,32.5,19912,NULL,NULL,'Dipole + Quadrupole + Octopole','UGCA 151',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59941,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59941,32.56,NULL,32.5,19912,NULL,NULL,NULL,'UGCA 151',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59942,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59942,32.61,0.2,33.3,19912,74.4,NULL,NULL,'UGCA 151',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59943,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59943,32.65,0.39,33.9,19912,NULL,NULL,NULL,'UGCA 151',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59944,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59944,32.72,0.43,35,19912,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 151',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59945,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59945,32.74,0.49,35.3,19912,75,NULL,'IR','UGCA 151',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59946,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59946,32.76,0.37,35.6,19912,NULL,NULL,NULL,'UGCA 151',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59947,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59947,32.78,0.4,35.9,19912,NULL,NULL,'mean','UGCA 151',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59948,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59948,32.78,0.43,36,19912,75,NULL,'3.6 micron, color corrected','UGCA 151',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59949,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59949,32.87,0.46,37.5,19912,NULL,NULL,'J','UGCA 151',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59950,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59950,32.9,0.43,38,19912,75,NULL,'MAT, I, raw','UGCA 151',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59951,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59951,32.9,0.32,38,19912,85,NULL,'I, raw','UGCA 151',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59952,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59952,32.93,0.32,38.6,19912,85,NULL,'I, inv','UGCA 151',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59953,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59953,32.94,0.47,38.7,19912,NULL,NULL,'H','UGCA 151',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59954,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59954,33.01,0.45,40.1,19912,NULL,NULL,'K','UGCA 151',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59955,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59955,33.08,0.43,41.3,19912,75,NULL,'MAT, I, inv','UGCA 151',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59956,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59956,33.1,0.43,41.7,19912,75,NULL,'MAT, I, cor','UGCA 151',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59957,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59957,37.73,0.33,352,19913,70,NULL,NULL,'SDSS J091156.01+631456.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.09,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,137.983375,63.24894,0.177,NULL,62029927273,969217613,15144025,18.4),(59958,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59958,36.83,0.46,233,19914,70,NULL,NULL,'2MASX J09115621+5430489',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000065,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,137.98425,54.51369,0.025,NULL,63955328690,999302010,15614093,17.4),(59959,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59959,38.16,0.27,428,19915,70,NULL,NULL,'2MASX J09115620+4736045',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000133,NULL,'16.2g',0.41,NULL,NULL,NULL,NULL,NULL,1,137.984375,47.60122,0.017,NULL,64233943509,1003655367,15682115,16.2),(59960,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59960,38.3,0.46,458,19916,70,NULL,NULL,'SDSS J091156.25+451839.4',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,137.984417,45.31094,0.025,NULL,64280615978,1004384624,15693509,18.1),(59961,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59961,37.96,0.46,391,19917,70,NULL,NULL,'2MASX J09115639+6252158',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,137.984833,62.87114,0.149,NULL,62033264335,969269755,15144839,17.5),(59962,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59962,37.51,0.33,317,19918,70,NULL,NULL,'2MASX J09115641+4904559',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000155,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,137.9849583,49.08211,0.009,NULL,64234887149,1003670111,15682345,17.6),(59963,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59963,37.81,0.46,364,19919,70,NULL,NULL,'2MASX J09115686+3013417',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'18.0g',0.11,NULL,NULL,NULL,NULL,NULL,1,137.986791667,30.22836,0.029,NULL,64380902132,1005951595,15717993,18),(59964,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59964,35.63,0.5,134,19920,70,NULL,NULL,'2MASX J09115750-1522028',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,137.989625,-15.36744,0.125,NULL,42375168715,662112011,10345500,14.7),(59965,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59965,37.99,0.46,397,19921,70,NULL,NULL,'2MASX J09115846+4126128',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000189,NULL,'16.6g',0.38,NULL,NULL,NULL,NULL,NULL,1,137.9934583,41.43694,0,NULL,64269311776,1004207996,15690749,16.6),(59966,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59966,37.83,0.46,369,19922,70,NULL,NULL,'SDSS J091158.57+452311.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000181,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,137.994083333,45.3865,0.025,NULL,64280619092,1004384673,15693510,17.7),(59967,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59967,38.56,0.46,516,19923,70,NULL,NULL,'2MASX J09115945+1332583',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,137.997583333,13.54944,0.129,NULL,63865832135,997903627,15592244,18.1),(59968,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59968,32.25,0.43,28.2,19924,75,NULL,'3.6 micron, color + selection bias corrected','ESO 497- G 022',NULL,'2014MNRAS.444..527S',2014,1,1.6,NULL,'G',0.000027,NULL,'14.21',0.7,'Sc             HII',NULL,NULL,NULL,NULL,1,138.002125,-26.82792,0.565,NULL,42835626162,669306658,10457916,14.21),(59969,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59969,32.47,0.43,31.2,19924,75,NULL,'3.6 micron, color corrected','ESO 497- G 022',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59970,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59970,32.63,0.2,33.6,19924,74.4,NULL,NULL,'ESO 497- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59971,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59971,32.96,0.4,39.1,19924,NULL,NULL,'mean','ESO 497- G 022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59972,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59972,32.97,0.47,39.3,19924,NULL,NULL,'H','ESO 497- G 022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59973,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59973,33.07,0.46,41.1,19924,NULL,NULL,'J','ESO 497- G 022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59974,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59974,33.13,0.45,42.2,19924,NULL,NULL,'K','ESO 497- G 022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59975,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59975,36.76,0.15,225,19925,70,NULL,NULL,'2MASX J09120220+4745486',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.0001,NULL,'15.8g',0.38,'E0',NULL,NULL,NULL,NULL,1,138.00925,47.76339,0.017,NULL,64233955489,1003655554,15682118,15.8),(59976,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59976,37.52,0.46,320,19926,70,NULL,NULL,'2MASX J09120229+0744114',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000181,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,138.009625,7.73639,0.097,NULL,63679553199,994993018,15546765,17.1),(59977,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59977,37.25,0.46,281,19927,70,NULL,NULL,'SDSS J091202.65+013856.9',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000092,NULL,'17.2g',0.25,'NLAGN',NULL,NULL,NULL,'Sy 2',1,138.0110417,1.64914,0.073,NULL,60682257479,948160273,14815004,17.2),(59978,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59978,37.99,0.46,396,19928,70,NULL,NULL,'SDSS J091203.10+483547.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,138.012917,48.59661,0.021,NULL,64235687353,1003682614,15682540,17.9),(59979,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59979,38.14,0.33,425,19929,70,NULL,NULL,'2MASX J09120421+5636108',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000067,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,138.017625,56.60311,0.041,NULL,61876575506,966821492,15106585,17.9),(59980,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59980,37.01,0.21,253,19930,70,NULL,NULL,'2MASX J09120429+0025181',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000083,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,138.017958333,0.42181,0.065,NULL,60681336317,948145879,14814779,16.7),(59981,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59981,38.46,0.46,493,19931,70,NULL,NULL,'2MASX J09120532+4718236',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000137,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,138.0224583,47.30669,0.021,NULL,64279289868,1004363904,15693186,17.3),(59982,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59982,37.01,0.21,253,19932,70,NULL,NULL,'2MASX J09120589+0026561',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000095,NULL,'17.2g',0.25,'NLAGN',NULL,NULL,NULL,NULL,1,138.024375,0.44889,0.065,NULL,60681337930,948145905,14814779,17.2),(59983,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59983,36.65,0.46,214,19933,70,NULL,NULL,'2MASX J09120591+5215099',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000097,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,138.024833,52.25272,0,NULL,63956693213,999323331,15614427,16.5),(59984,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59984,38.16,0.27,428,19934,70,NULL,NULL,'SDSS J091207.54+473924.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000117,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,138.0314583,47.65675,0.017,NULL,64233938065,1003655282,15682113,18.6),(59985,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59985,38.07,0.46,411,19935,70,NULL,NULL,'2MASX J09120791+1904163',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000141,NULL,'18.5g',0.09,NULL,NULL,NULL,NULL,NULL,1,138.032917,19.07106,0.089,NULL,63829649044,997338266,15583410,18.5),(59986,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59986,32.3,0.4,28.9,19936,75,NULL,'B','UGC 04837',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.000017,NULL,'14.91',1.3,'Sm?','Group member',NULL,NULL,NULL,1,138.04,35.53156,0,NULL,64409636883,1006400576,15725009,14.91),(59987,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59987,37.28,0.46,286,19937,70,NULL,NULL,'2MASX J09121149+1322146',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,138.0477917,13.37075,0.113,NULL,63863895007,997873359,15591771,17.7),(59988,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59988,38.51,0.46,504,19938,70,NULL,NULL,'SDSS J091211.75+153800.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,138.049,15.63347,0.081,NULL,63859448233,997803878,15590685,18.2),(59989,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59989,36,0.33,159,19939,70,NULL,NULL,'2MASX J09121196+4120318',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000177,NULL,'16.1g',0.41,'E0',NULL,NULL,NULL,NULL,1,138.05,41.34219,0,NULL,64269168360,1004205755,15690714,16.1),(59990,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59990,32.41,0.5,30.4,19940,70,NULL,NULL,'ESO 433- G 008',NULL,'2014MNRAS.445.2677S',2014,1,2,NULL,'G',0.000093,NULL,'14.5',0.3,'S0^0^: sp',NULL,NULL,NULL,NULL,1,138.05325,-30.91103,0.969,NULL,42911512321,670492380,10476443,14.5),(59991,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59991,31.69,0.47,21.7,19941,NULL,NULL,'H','NGC 2776',NULL,'2007A&A...465...71T',2007,1,2.32,NULL,'G',0.000017,NULL,'12.7g',1.45,'SAB(rs)c','Isolated galaxy',NULL,NULL,NULL,1,138.0604583,44.95483,0.037,NULL,64280802973,1004387546,15693555,12.7),(59992,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59992,31.69,0.46,21.8,19941,NULL,NULL,'J','NGC 2776',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59993,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59993,31.71,0.45,22,19941,NULL,NULL,'K','NGC 2776',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59994,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59994,32.63,0.4,33.6,19941,NULL,NULL,'mean','NGC 2776',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59995,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59995,32.94,0.4,38.7,19941,75,NULL,'B','NGC 2776',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59996,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',59996,37.01,0.21,253,19942,70,NULL,NULL,'2MASX J09121483+0018421',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000072,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,138.06175,0.31178,0.093,NULL,60672741208,948011581,14812680,16.6),(59997,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59997,35.1,NULL,105,19943,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG +09-15-106',NULL,'2010Ap&SS.325..163P',2010,1,1.21,NULL,'G',0.000101,NULL,'16.1g',0.19,'Scd(f)',NULL,NULL,NULL,NULL,1,138.0689583,51.61736,0,NULL,63955944122,999311626,15614244,16.1),(59998,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59998,35.11,NULL,105,19943,NULL,NULL,'Dipole + Quadrupole','MCG +09-15-106',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(59999,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,59999,35.13,NULL,106,19943,NULL,NULL,'Dipole','MCG +09-15-106',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60000,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60000,35.15,NULL,107,19943,NULL,NULL,NULL,'MCG +09-15-106',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60001,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60001,36.49,0.46,198,19944,70,NULL,NULL,'2MASX J09121665+6056380',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.12',0.33,NULL,NULL,NULL,NULL,NULL,1,138.069333333,60.94397,0.145,NULL,62068764860,969824450,15153507,17.12),(60002,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60002,36.76,0.15,225,19945,70,NULL,NULL,'2MASX J09121806+4741136',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000067,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,138.075333,47.68733,0.017,NULL,64233938416,1003655287,15682113,16.7),(60003,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60003,38,0.23,399,19946,70,NULL,NULL,'2MASX J09121887+5159018',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000101,NULL,'17.9g',0.19,'NLAGN',NULL,NULL,NULL,'Sy 2',1,138.0787083,51.98389,0,NULL,63955964803,999311950,15614249,17.9),(60004,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60004,36.85,0.46,234,19947,70,NULL,NULL,'2MASX J09121932+4651286',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'15.9g',0.35,NULL,NULL,NULL,NULL,NULL,1,138.080583,46.85783,0.013,NULL,64281629153,1004400455,15693757,15.9),(60005,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60005,36,0.46,158,19948,70,NULL,NULL,'2MASX J09121944+4622586',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000171,NULL,'15.5g',0.51,'E',NULL,NULL,NULL,NULL,1,138.0809583,46.38308,0.041,NULL,64281893144,1004404580,15693821,15.5),(60006,'SBF','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60006,29.91,0.14,9.59,19949,74.4,NULL,NULL,'NGC 2784',NULL,'2013AJ....146...86T',2013,1,5.5,NULL,'G',0.000117,NULL,'11.30',2.2,'SA(s)0^0^:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,138.08125,-24.17261,0.733,NULL,42313552604,661149259,10330457,11.3),(60007,'SBF','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60007,29.96,0.25,9.8,19949,NULL,NULL,'I','NGC 2784',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60008,'Faber-Jackson','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60008,30.36,0.63,11.8,19949,95,NULL,'Michard 1979b, c','NGC 2784',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60009,'Faber-Jackson','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60009,30.42,0.46,12.1,19949,95,NULL,'Michard 1979a','NGC 2784',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60010,'Faber-Jackson','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60010,30.48,0.42,12.5,19949,95,NULL,'Weighted Mean','NGC 2784',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60011,'Faber-Jackson','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60011,30.75,NULL,14.1,19949,NULL,NULL,'LEDA [April 2006]','NGC 2784',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60012,'Faber-Jackson','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60012,33.96,1.61,61.9,19949,55,NULL,'Visvanathan & Sandage 1979','NGC 2784',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60013,'Tully est','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60013,29.26,0.8,7.1,19949,75,NULL,'B','NGC 2784',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60014,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60014,36.01,0.49,159,19950,70,NULL,NULL,'2MASX J09121988-1629162',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.09',NULL,NULL,NULL,NULL,NULL,NULL,1,138.0827917,-16.488,0.161,NULL,42373411508,662084554,10345071,16.09),(60015,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60015,35.36,0.46,118,19951,70,NULL,NULL,'CGCG 062-004',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.000203,NULL,'15.5',0.7,NULL,NULL,NULL,NULL,NULL,1,138.084833,13.67381,0.133,NULL,63865666034,997901031,15592203,15.5),(60016,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60016,36.72,0.46,220,19952,70,NULL,NULL,'2MASX J09122217+3942195',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,138.092541667,39.7055,0,NULL,64398772424,1006230819,15722356,17.5),(60017,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60017,38.55,0.27,512,19953,70,NULL,NULL,'SDSS J091222.77+400703.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,138.094958333,40.11764,0,NULL,64397568919,1006212014,15722062,18.4),(60018,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60018,35.51,0.49,127,19954,75,NULL,'IR','UGC 04842',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'15.15',0.3,'Sab',NULL,NULL,NULL,NULL,1,138.0955417,12.49811,0.077,NULL,63864172515,997877695,15591838,15.15),(60019,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60019,38,0.23,399,19955,70,NULL,NULL,'2MASX J09122307+5155288',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000081,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,138.096375,51.92478,0,NULL,63955983148,999312236,15614253,17.5),(60020,'SBF','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60020,31.8,0.3,22.9,19956,NULL,NULL,'I','NGC 2778',NULL,'2001ApJ...546..681T',2001,1,1.4,NULL,'G',0.000014,NULL,'13.35',1,'E','Possible field galaxy',NULL,NULL,NULL,1,138.1015417,35.02753,0.021,NULL,64409505709,1006398526,15724976,13.35),(60021,'SBF','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60021,31.83,0.14,23.2,19956,74.4,NULL,NULL,'NGC 2778',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60022,'D-Sigma','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60022,32.99,0.4,39.6,19956,75,NULL,'Edat, raw','NGC 2778',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60023,'D-Sigma','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60023,33.33,0.4,46.2,19956,75,NULL,'Edat, cor','NGC 2778',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60024,'Tully est','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60024,32.46,0.8,31,19956,75,NULL,'B','NGC 2778',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60025,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60025,32.9,0.4,38.1,19956,NULL,NULL,'mean','NGC 2778',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60026,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60026,33.44,0.45,48.7,19956,NULL,NULL,'K','NGC 2778',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60027,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60027,38.55,0.46,512,19957,70,NULL,NULL,'SDSS J091224.42+394953.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,138.10175,39.83156,0,NULL,64398593828,1006228028,15722312,18.2),(60028,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60028,38.45,0.23,490,19958,70,NULL,NULL,'2MASX J09122510+5341390',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00009,NULL,'17.3g',0.24,'BrClG          AGN',NULL,NULL,NULL,NULL,1,138.1045417,53.69422,0.021,NULL,63958724915,999355076,15614923,17.3),(60029,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60029,37.63,0.33,335,19959,70,NULL,NULL,'2MASX J09122552+0649087',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,138.10625,6.81908,0.069,NULL,63678755155,994980549,15546571,17.6),(60030,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60030,32.71,0.2,34.8,19960,74.4,NULL,NULL,'UGC 04845',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.000021,NULL,'14.50',0.6,'SBd:','Isolated galaxy',NULL,NULL,NULL,1,138.1077917,9.9555,0.197,NULL,63649455164,994522736,15539417,14.5),(60031,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60031,32.78,0.43,36,19960,75,NULL,'3.6 micron, color corrected','UGC 04845',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60032,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60032,32.88,0.43,37.6,19960,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04845',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60033,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60033,32.99,0.38,39.6,19960,NULL,NULL,NULL,'UGC 04845',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60034,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60034,33.17,0.35,43,19960,NULL,NULL,'Malmquist cor.','UGC 04845',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60035,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60035,37.64,0.46,337,19961,70,NULL,NULL,'2MASX J09122597+3510457',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000221,NULL,'16.0g',0.43,'E0',NULL,NULL,NULL,NULL,1,138.10825,35.17936,0.009,NULL,64409400377,1006396880,15724951,16),(60036,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60036,36.76,0.15,225,19962,70,NULL,NULL,'2MASX J09122701+4748445',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000063,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,138.11275,47.8125,0.013,NULL,64235034934,1003672420,15682381,16.8),(60037,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60037,38.16,0.27,428,19963,70,NULL,NULL,'SDSS J091227.30+473529.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000129,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,138.11375,47.59169,0.017,NULL,64233932285,1003655191,15682112,18.1),(60038,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60038,36.76,0.15,225,19964,70,NULL,NULL,'2MASX J09122745+4737103',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000057,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,138.114458333,47.61944,0.017,NULL,64233945278,1003655394,15682115,17.6),(60039,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60039,37.63,0.33,335,19965,70,NULL,NULL,'SDSS J091228.81+065213.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,138.1200417,6.87042,0.069,NULL,63678757785,994980590,15546571,17.9),(60040,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60040,38.51,0.46,503,19966,70,NULL,NULL,'2MASX J09122889+4902490',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,138.1205417,49.04706,0.009,NULL,64235594075,1003681157,15682518,17.5),(60041,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60041,38.06,0.46,410,19967,70,NULL,NULL,'2MASX J09122950+1635075',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,138.122833,16.58544,0.073,NULL,63859959985,997811874,15590810,17.2),(60042,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60042,35.07,0.2,103,19968,74.4,NULL,NULL,'CGCG 062-007',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.00024,NULL,'15.3',0.6,NULL,NULL,NULL,NULL,NULL,1,138.123333,13.80194,0.133,NULL,63865673494,997901148,15592205,15.3),(60043,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60043,37.02,0.46,254,19969,70,NULL,NULL,'2MASX J09123123+0829417',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000172,NULL,'16.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,138.130041667,8.49489,0.121,NULL,63647413936,994490842,15538919,16.6),(60044,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60044,38.45,0.23,490,19970,70,NULL,NULL,'2MASX J09123134+5330540',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00009,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,138.1304583,53.51506,0,NULL,63958920967,999358140,15614970,17.3),(60045,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60045,36.85,0.46,235,19971,70,NULL,NULL,'SDSS J091231.67+102107.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000132,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,138.132,10.35211,0.177,NULL,63649330583,994520790,15539387,18.1),(60046,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60046,35.02,NULL,101,19972,NULL,NULL,NULL,'FGC 0854',NULL,'2000BSAO...50....5K',2000,1,0.7,NULL,'G',0.000027,NULL,'17.3g',0.15,'Sc',NULL,NULL,NULL,NULL,1,138.13575,17.97825,0.093,NULL,63875747859,998058560,15594665,17.3),(60047,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60047,35.05,NULL,102,19972,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0854',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60048,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60048,35.06,NULL,103,19972,NULL,NULL,'Dipole + Quadrupole','FGC 0854',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60049,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60049,35.1,NULL,105,19972,NULL,NULL,'Dipole','FGC 0854',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60050,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60050,36.76,0.15,225,19973,70,NULL,NULL,'2MASX J09123279+4737383',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000067,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,138.136625,47.62742,0.017,NULL,64233931802,1003655184,15682112,16.3),(60051,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60051,37.31,0.46,290,19974,70,NULL,NULL,'2MASX J09123437+6059300',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,138.143041667,60.99158,0.145,NULL,62068766610,969824478,15153507,17.4),(60052,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60052,37.9,0.27,381,19975,70,NULL,NULL,'SDSS J091235.18+160000.6',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.4g',0.33,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,138.146625,16.00019,0.081,NULL,63860313459,997817397,15590896,16.4),(60053,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60053,38.37,0.46,472,19976,70,NULL,NULL,'2MASX J09123536+3831356',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000179,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,138.147417,38.52667,0.005,NULL,64398491207,1006226425,15722287,17.1),(60054,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60054,37.57,0.46,327,19977,70,NULL,NULL,'SDSS J091235.45+470005.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000113,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,138.1477917,47.00142,0.025,NULL,64281626130,1004400408,15693756,18.5),(60055,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60055,38.55,0.27,512,19978,70,NULL,NULL,'2MASX J09123566+4003576',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000181,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,138.148708333,40.06586,0,NULL,64397567393,1006211990,15722062,18.5),(60056,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60056,35.47,0.46,124,19979,70,NULL,NULL,'CGCG 180-056 NED02',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00004,NULL,'15.1g',0.53,'E0',NULL,NULL,NULL,NULL,1,138.1515417,35.78833,0.021,NULL,64408937046,1006389641,15724838,15.1),(60057,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60057,37.49,0.46,315,19980,70,NULL,NULL,'2MASX J09123792+4432374',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,138.1577083,44.54386,0,NULL,64280059748,1004375933,15693373,17.6),(60058,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60058,38.23,0.46,443,19981,70,NULL,NULL,'2MASXi J0912381+550243',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000078,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,138.1592083,55.04572,0.041,NULL,61878268878,966847951,15106999,18),(60059,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60059,38.55,0.27,512,19982,70,NULL,NULL,'2MASX J09123932+4003366',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000171,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,138.164125,40.06025,0,NULL,64397567046,1006211985,15722062,17.7),(60060,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60060,38.07,0.46,410,19983,70,NULL,NULL,'2MASX J09123946+1515238',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,138.164583,15.25669,0.097,NULL,63867544595,997930384,15592662,17.7),(60061,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60061,37.08,0.46,261,19984,70,NULL,NULL,'SDSS J091239.51+065731.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000156,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,138.164625,6.95867,0.069,NULL,63678282303,994973160,15546455,18.3),(60062,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60062,37.48,0.33,314,19985,70,NULL,NULL,'2MASX J09124030+4600564',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000153,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,138.16775,46.01572,0.041,NULL,64281837386,1004403709,15693807,16.8),(60063,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60063,37.86,0.46,374,19986,70,NULL,NULL,'SDSS J091240.60+144719.8',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.1r',NULL,NULL,NULL,NULL,NULL,NULL,1,138.169167,14.78886,0.097,NULL,63867610385,997931412,15592678,17.1),(60064,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60064,37.9,0.27,381,19987,70,NULL,NULL,'2MASXi J0912406+160015',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000175,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,138.169375,16.00433,0.081,NULL,63860314030,997817406,15590896,17.8),(60065,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60065,35.57,0.79,130,19988,70,NULL,NULL,'2MASX J09124267-6700104',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,138.177833,-67.00292,0.517,NULL,40799948980,637499202,9960925,15.4),(60066,'Tully est','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60066,32.59,0.8,32.9,19989,75,NULL,'B','NGC 2780',NULL,'1988NBGC.C....0000T',1988,1,1.19,NULL,'G',0.00003,NULL,'14.0g',0.77,'Sab            HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,138.184875,34.92558,0.021,NULL,64409509018,1006398578,15724977,14),(60067,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60067,32.78,0.4,35.9,19989,NULL,NULL,'mean','NGC 2780',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60068,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60068,34.38,0.47,75.1,19989,NULL,NULL,'H','NGC 2780',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60069,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60069,34.47,0.46,78.3,19989,NULL,NULL,'J','NGC 2780',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60070,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60070,37.6,0.46,331,19990,70,NULL,NULL,'2MASX J09124462+5620159',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000086,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,138.1860417,56.33778,0.041,NULL,61877451637,966835181,15106799,17),(60071,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60071,37.86,0.46,373,19991,70,NULL,NULL,'2MASXi J0912448+144850',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,138.186917,14.814,0.097,NULL,63867616913,997931514,15592679,18),(60072,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60072,34.91,0.33,95.7,19992,70,NULL,NULL,'CGCG 151-021',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000067,NULL,'15.2g',0.42,'S0',NULL,NULL,NULL,NULL,1,138.188791667,29.42164,0.033,NULL,64199238141,1003113095,15673642,15.2),(60073,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60073,36.91,0.46,241,19993,70,NULL,NULL,'2MASX J09124622+0435198',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000167,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,138.19275,4.58881,0.093,NULL,63625756938,994152452,15533632,16.5),(60074,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60074,38.3,0.46,457,19994,70,NULL,NULL,'2MASX J09124685+5608519',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000133,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,138.195333,56.14775,0.041,NULL,61877473004,966835515,15106804,17.1),(60075,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60075,37.08,0.46,260,19995,70,NULL,NULL,'SDSS J091247.44+071831.5',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00018,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,138.1977083,7.30875,0.077,NULL,63678209456,994972022,15546437,16.8),(60076,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60076,36.01,0.46,159,19996,70,NULL,NULL,'2MASX J09124790+0953110',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000188,NULL,'16.3g',0.33,'S0',NULL,NULL,NULL,NULL,1,138.199666667,9.88642,0.189,NULL,63649457342,994522770,15539418,16.3),(60077,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60077,37.69,0.46,346,19997,70,NULL,NULL,'2MASX J09125136+0914510',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000179,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,138.2140417,9.24736,0.153,NULL,63648632256,994509879,15539216,16.7),(60078,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60078,36.76,0.15,225,19998,70,NULL,NULL,'2MASX J09125307+4742154',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000073,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,138.2210417,47.70439,0.017,NULL,64234992088,1003671751,15682371,16.5),(60079,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60079,37.48,0.33,314,19999,70,NULL,NULL,'2MASX J09125355+4600424',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000146,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,138.223083,46.01186,0.005,NULL,64281830789,1004403606,15693806,17.4),(60080,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60080,37.58,0.46,328,20000,70,NULL,NULL,'2MASX J09125376+0301129',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000137,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,138.224125,3.02033,0.097,NULL,60680798971,948137483,14814648,17.6),(60081,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60081,37.01,0.21,253,20001,70,NULL,NULL,'2MASX J09125422+0005259',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000092,NULL,'17.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,138.225917,0.09075,0.089,NULL,60672934966,948014608,14812728,17),(60082,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60082,34.66,0.54,85.7,20002,70,NULL,NULL,'2MASX J09125621-0454059',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000107,NULL,'12.7I',0.4,NULL,NULL,NULL,NULL,NULL,1,138.23425,-4.90169,0.069,NULL,42153069325,658641708,10291276,12.7),(60083,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60083,36.35,0.46,186,20003,70,NULL,NULL,'2MASX J09125625+2220393',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,138.234417,22.34436,0.173,NULL,63718721259,995605019,15556328,17.2),(60084,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60084,35.5,0.49,126,20004,75,NULL,'IR','UGC 04848',NULL,'2011yCatp016004901K',2011,1,1.02,NULL,'G',0.000035,NULL,'16.0g',0.24,'Sc',NULL,NULL,NULL,NULL,1,138.235083333,34.06253,0.017,NULL,64411577776,1006430902,15725482,16),(60085,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60085,37.78,0.46,360,20005,70,NULL,NULL,'2MASX J09125687+2959368',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,138.236917,29.9935,0.033,NULL,64380863490,1005950992,15717984,17.4),(60086,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60086,38.63,0.46,532,20006,70,NULL,NULL,'SDSS J091257.37+655914.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,138.239125,65.98744,0.149,NULL,62262177362,972846521,15200726,18.3),(60087,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60087,37.9,0.27,381,20007,70,NULL,NULL,'2MASX J09125797+1601108',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,138.2417083,16.01978,0.081,NULL,63860325814,997817590,15590899,17.2),(60088,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60088,37.35,0.46,295,20008,70,NULL,NULL,'2MASX J09125891+2930179',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000143,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,138.245375,29.50494,0.033,NULL,64199242644,1003113166,15673643,17.2),(60089,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60089,37.77,0.33,357,20009,70,NULL,NULL,'2MASX J09125977+0630161',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,138.249,6.50444,0.101,NULL,63678816476,994981507,15546586,17.6),(60090,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60090,38.74,0.46,560,20010,70,NULL,NULL,'SDSS J091300.71+025025.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000149,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,138.253,2.8405,0.077,NULL,60680786866,948137294,14814645,18.7),(60091,'G Lens','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60091,41.41,1.83,1910,20011,NULL,NULL,NULL,'SBS 0909+532:[LFK2000] G',NULL,'2013ApJ...770..154T',2013,1,NULL,NULL,'G',NULL,NULL,'19.0I',NULL,NULL,NULL,NULL,NULL,NULL,1,138.253375,52.99208,0,NULL,63958484086,999351313,15614864,19),(60092,'G Lens','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60092,41.43,0.88,1930,20011,NULL,NULL,NULL,'SBS 0909+532:[LFK2000] G',NULL,'2007ApJ...660....1O',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60093,'G Lens','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60093,41.48,1.83,1980,20011,NULL,NULL,NULL,'SBS 0909+532:[LFK2000] G',NULL,'2013ApJ...770..154T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60094,'G Lens','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60094,41.81,1.86,2300,20011,NULL,NULL,NULL,'SBS 0909+532:[LFK2000] G',NULL,'2013ApJ...770..154T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60095,'G Lens','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60095,41.82,1.86,2310,20011,NULL,NULL,NULL,'SBS 0909+532:[LFK2000] G',NULL,'2013ApJ...770..154T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60096,'G Lens','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60096,43.05,NULL,4070,20011,NULL,NULL,'R(H) = ct','SBS 0909+532:[LFK2000] G',NULL,'2014ApJ...788..190W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60097,'G Lens','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60097,43.06,NULL,4090,20011,NULL,NULL,'Standard','SBS 0909+532:[LFK2000] G',NULL,'2014ApJ...788..190W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60098,'G Lens','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60098,44.88,0.68,9460,20011,NULL,NULL,NULL,'SBS 0909+532:[LFK2000] G',NULL,'2014MNRAS.437..600S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60099,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60099,37.25,0.46,281,20012,70,NULL,NULL,'2MASX J09130120+2613049',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000142,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,138.255125,26.21806,0.069,NULL,64191065957,1002985405,15671646,17.5),(60100,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60100,37.61,0.46,333,20013,70,NULL,NULL,'2MASX J09130177+2716459',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000185,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,138.257417,27.27939,0.049,NULL,64192301831,1003004716,15671948,16.5),(60101,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60101,36.49,0.46,199,20014,70,NULL,NULL,'2MASX J09130201+2707009',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00019,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,138.258333,27.11706,0.053,NULL,64192287208,1003004487,15671945,16.4),(60102,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60102,33.39,0.2,47.6,20015,74.4,NULL,NULL,'UGC 04844',NULL,'2013AJ....146...86T',2013,1,1.26,NULL,'G',0.000017,NULL,'13.9g',0.9,'SABbc:','Group member',NULL,NULL,NULL,1,138.2592917,49.63947,0.013,NULL,64233444560,1003647571,15681993,13.9),(60103,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60103,33.62,0.48,53,20015,NULL,NULL,NULL,'UGC 04844',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60104,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60104,33.74,0.4,56,20015,NULL,NULL,'mean','UGC 04844',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60105,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60105,33.92,0.41,60.8,20015,NULL,NULL,'Malmquist cor.','UGC 04844',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60106,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60106,34.17,0.47,68.1,20015,NULL,NULL,'H','UGC 04844',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60107,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60107,38.53,0.46,509,20016,70,NULL,NULL,'SDSS J091302.32+400439.9',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,138.2597083,40.07775,0,NULL,64397561033,1006211891,15722060,18.3),(60108,'GRB','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60108,47.58,1.65,6420,20017,NULL,NULL,NULL,'GRB 090516',4.109,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,138.260916667,-11.85433,0.149,NULL,42188397565,659193711,10299901,NULL),(60109,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60109,37.77,0.46,358,20018,70,NULL,NULL,'2MASX J09130302+2900349',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,138.262625,29.00975,0.013,NULL,64199180164,1003112190,15673627,17.4),(60110,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60110,38.18,0.46,433,20019,70,NULL,NULL,'SDSS J091303.90+090327.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000132,NULL,'18.9g',0.1,NULL,NULL,NULL,NULL,NULL,1,138.266291667,9.05758,0.133,NULL,63647330894,994489545,15538899,18.9),(60111,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60111,38.14,0.46,424,20020,70,NULL,NULL,'2MASX J09130471+3653240',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,138.269541667,36.89008,0,NULL,64403767025,1006308859,15723575,17.9),(60112,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60112,36.35,0.46,186,20021,70,NULL,NULL,'2MASX J09130487+0841021',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,138.270375,8.68381,0.149,NULL,63647512239,994492378,15538943,16.8),(60113,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60113,37.78,0.21,360,20022,70,NULL,NULL,'2MASX J09130513+0401160',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000142,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,138.271333,4.02103,0.069,NULL,60676527292,948070738,14813605,17.9),(60114,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60114,37.26,0.33,283,20023,70,NULL,NULL,'SDSS J091305.47+033303.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000138,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,138.272833,3.55111,0.085,NULL,60676205225,948065706,14813526,18.2),(60115,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60115,37.12,0.46,266,20024,70,NULL,NULL,'2MASX J09130648+1833463',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,138.2769583,18.56303,0.089,NULL,63875998715,998062479,15594726,17.1),(60116,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60116,36.76,0.15,225,20025,70,NULL,NULL,'2MASX J09130775+4742307',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000103,NULL,'15.5g',0.52,'BrClG',NULL,NULL,NULL,NULL,1,138.2822083,47.70842,0.017,NULL,64234984856,1003671638,15682369,15.5),(60117,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60117,37.01,0.21,253,20026,70,NULL,NULL,'2MASX J09130855+0014170',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000092,NULL,'16.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,138.285583,0.23792,0.093,NULL,60672957959,948014968,14812733,16.2),(60118,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60118,37.38,0.46,299,20027,70,NULL,NULL,'2MASX J09131137+3340104',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,138.297333333,33.66958,0.025,NULL,64411534244,1006430222,15725472,17.2),(60119,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60119,37.44,0.46,307,20028,70,NULL,NULL,'2MASX J09131169+1611572',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000143,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,138.2987917,16.19917,0.073,NULL,63860350753,997817980,15590905,17.9),(60120,'Tully est','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60120,29.51,0.8,8,20029,75,NULL,NULL,'UGCA 153',NULL,'1988NBGC.C....0000T',1988,1,2,NULL,'G',0.000017,NULL,'15.4B',1.3,'IB(s)m',NULL,NULL,NULL,NULL,1,138.300375,-19.40861,0.297,NULL,42350694437,661729600,10339525,15.4),(60121,'Tully-Fisher','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,NULL,60121,31.7,NULL,21.9,20029,NULL,NULL,NULL,'UGCA 153',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60122,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60122,36.29,0.46,181,20030,70,NULL,NULL,'2MASX J09131235+5116537',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000057,NULL,'16.2g',0.38,'S0',NULL,NULL,NULL,NULL,1,138.3012917,51.2815,0.017,NULL,64225284764,1003520074,15680001,16.2),(60123,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60123,38.5,0.46,501,20031,70,NULL,NULL,'2MASX J09131251+1531502',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,138.3022917,15.53047,0.077,NULL,63866801977,997918780,15592480,18.3),(60124,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60124,37.78,0.21,360,20032,70,NULL,NULL,'2MASX J09131308+0407230',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,138.304666667,4.12289,0.141,NULL,60676523493,948070679,14813604,17.5),(60125,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60125,37.91,0.46,382,20033,70,NULL,NULL,'2MASX J09131326+0608258',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000148,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,138.305333,6.14039,0.081,NULL,63678054749,994969605,15546400,17.2),(60126,'FP','2016-12-15 15:14:27','2016-12-16 11:19:34','1',NULL,'R',60126,37.76,0.46,357,20034,70,NULL,NULL,'2MASX J09131333+3438174',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000138,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,138.305708333,34.63806,0.009,NULL,64409518846,1006398731,15724980,17.7),(60127,'IRAS','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60127,33.67,0.8,54.1,20035,75,NULL,'HMCL, I','UGC 04857',NULL,'1997ApJS..109..333W',1997,1,1.33,NULL,'G',0.000014,NULL,'14.9g',0.58,'SBcd:',NULL,NULL,NULL,NULL,1,138.30575,3.23042,0.097,NULL,60676333179,948067705,14813557,14.9),(60128,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60128,33.43,0.2,48.5,20035,74.4,NULL,NULL,'UGC 04857',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60129,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60129,33.59,0.4,52.3,20035,75,NULL,'HMCL, I, raw','UGC 04857',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60130,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60130,33.64,0.52,53.4,20035,NULL,NULL,NULL,'UGC 04857',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60131,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60131,33.65,0.4,53.7,20035,75,NULL,'HMCL, I, inv','UGC 04857',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60132,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60132,33.73,0.49,55.8,20035,NULL,NULL,'Malmquist cor.','UGC 04857',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60133,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60133,33.87,0.4,59.5,20035,75,NULL,'HMCL, I, cor','UGC 04857',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60134,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60134,36.76,0.46,225,20036,70,NULL,NULL,'2MASX J09131453+5003477',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00015,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,138.3105,50.06322,0.013,NULL,64233610215,1003650159,15682033,17),(60135,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60135,35.9,0.33,152,20037,70,NULL,NULL,'CGCG 121-036',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000133,NULL,'15.1g',0.58,NULL,NULL,NULL,NULL,NULL,1,138.317167,23.09,0.173,NULL,63718529747,995602027,15556281,15.1),(60136,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60136,38.55,0.46,512,20038,70,NULL,NULL,'2MASX J09131716+1732202',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,138.3215,17.53908,0.085,NULL,63875624141,998056627,15594634,18.1),(60137,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60137,38.58,0.33,521,20039,70,NULL,NULL,'2MASX J09132022+3709131',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,138.33425,37.15358,0.005,NULL,64403730196,1006308284,15723566,18.1),(60138,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60138,38.45,0.23,490,20040,70,NULL,NULL,'2MASX J09132023+5335028',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000082,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,138.334541667,53.58411,0.021,NULL,63958904848,999357888,15614967,18),(60139,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60139,35.65,0.53,135,20041,70,NULL,NULL,'2MASX J09132088-1638339',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000027,NULL,'16.20',NULL,NULL,NULL,NULL,NULL,NULL,1,138.3369583,-16.64289,0.157,NULL,42373477953,662085593,10345087,16.2),(60140,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60140,37.78,0.21,360,20042,70,NULL,NULL,'SDSS J091321.30+040535.3',NULL,'2015arXiv151105856S',2015,1,0.11,NULL,'G',0.000164,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,138.33875,4.09317,0.141,NULL,60676535435,948070866,14813607,18.8),(60141,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60141,37.89,0.46,378,20043,70,NULL,NULL,'2MASX J09132288+2218169',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000189,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,138.34525,22.30472,0.173,NULL,63718732527,995605195,15556331,17.3),(60142,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60142,37.78,0.21,360,20044,70,NULL,NULL,'2MASX J09132336+0406252',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00017,NULL,'17.3g',0.25,'AGN',NULL,NULL,NULL,NULL,1,138.3475,4.10714,0.141,NULL,60676535347,948070864,14813607,17.3),(60143,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60143,36.76,0.15,225,20045,70,NULL,NULL,'2MASX J09132338+4749009',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00008,NULL,'15.9g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,138.347583,47.81708,0.013,NULL,64235038614,1003672478,15682382,15.9),(60144,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60144,36.05,0.46,162,20046,70,NULL,NULL,'2MASX J09132369+4358339',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.00009,NULL,'15.7g',0.4,'SF',NULL,NULL,NULL,NULL,1,138.348667,43.97617,0,NULL,64262039618,1004094369,15688974,15.7),(60145,'Faber-Jackson','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60145,31.24,0.66,17.7,20047,95,NULL,'de Vaucouleurs','NGC 2732',NULL,'1984ApJS...56...91D',1984,1,2.1,NULL,'G',0.000023,NULL,'12.9',0.8,'S0',NULL,NULL,NULL,NULL,1,138.3530417,79.18733,0.021,NULL,61471301558,960489086,15007641,12.9),(60146,'Faber-Jackson','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60146,31.34,0.46,18.5,20047,95,NULL,'Weighted Mean','NGC 2732',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60147,'Faber-Jackson','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60147,32.75,0.81,35.5,20047,55,NULL,'Visvanathan & Sandage 1979','NGC 2732',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60148,'Tertiary','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60148,32.37,0.35,29.8,20047,95,NULL,NULL,'NGC 2732',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60149,'Tully est','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60149,32.51,0.8,31.8,20047,75,NULL,'B','NGC 2732',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60150,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60150,31.58,0.45,20.7,20047,NULL,NULL,'K','NGC 2732',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60151,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60151,32.38,0.4,30,20047,NULL,NULL,'mean','NGC 2732',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60152,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60152,34.46,0.46,78.1,20048,70,NULL,NULL,'UGC 04851',NULL,'2015arXiv151105856S',2015,1,1.29,NULL,'G',0.000103,NULL,'14.1g',0.77,'S0-:','in a radial-velocity based grouping',NULL,NULL,NULL,1,138.357875,52.98133,0,NULL,63958749094,999355454,15614928,14.1),(60153,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60153,36.57,0.46,206,20049,70,NULL,NULL,'2MASX J09132622+2200520',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00014,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,138.35925,22.01447,0.161,NULL,63717837772,995591215,15556112,17.2),(60154,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60154,36.64,0.46,213,20050,70,NULL,NULL,'2MASX J09132721+1043508',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.61',0.32,NULL,NULL,NULL,NULL,NULL,1,138.3635417,10.73072,0.141,NULL,63651974311,994562098,15540032,17.61),(60155,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60155,37.43,0.46,306,20051,70,NULL,NULL,'2MASX J09132780+3214044',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000132,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,138.3660417,32.23458,0.013,NULL,64378840144,1005919377,15717490,17.4),(60156,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60156,37.77,0.33,357,20052,70,NULL,NULL,'SDSS J091328.52+062958.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000171,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,138.368833,6.49947,0.101,NULL,63678798798,994981231,15546581,18.6),(60157,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60157,37.78,0.21,360,20053,70,NULL,NULL,'2MASX J09132885+0406132',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,138.370417,4.10358,0.069,NULL,60678576302,948102754,14814105,17.7),(60158,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60158,38.45,0.23,490,20054,70,NULL,NULL,'SDSS J091330.61+534014.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000075,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,138.3775417,53.67064,0.021,NULL,63958905938,999357905,15614967,18.6),(60159,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60159,37.7,0.46,348,20055,70,NULL,NULL,'2MASX J09133126+1832170',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,138.380166667,18.53803,0.089,NULL,63876031754,998062996,15594734,17.7),(60160,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60160,35.34,0.47,117,20056,NULL,NULL,'H','IC 2446',NULL,'2007A&A...465...71T',2007,1,1.4,'The identification as IC 2447 is very uncertain.','G',0.000033,NULL,'14.3g',0.6,'Sa',NULL,NULL,NULL,NULL,1,138.38075,28.95175,0.013,NULL,64199168169,1003112002,15673625,14.3),(60161,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60161,35.36,0.45,118,20056,NULL,NULL,'K','IC 2446',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60162,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60162,35.41,0.4,121,20056,NULL,NULL,'mean','IC 2446',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60163,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60163,35.46,0.46,124,20056,NULL,NULL,'J','IC 2446',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60164,'Sosies','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60164,31.59,0.14,20.8,20057,NULL,NULL,NULL,'ESO 091- G 003',NULL,'2002A&A...393...57T',2002,1,2.2,NULL,'G',0.00001,NULL,'13.01',1.5,'SA(r)ab',NULL,NULL,NULL,NULL,1,138.381667,-63.62642,0.709,NULL,40576075038,634001172,9906268,13.01),(60165,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60165,32.18,0.4,27.3,20057,NULL,NULL,'mean','ESO 091- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60166,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60166,32.22,0.46,27.8,20057,NULL,NULL,'J','ESO 091- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60167,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60167,32.23,0.47,28,20057,NULL,NULL,'H','ESO 091- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60168,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60168,32.24,0.45,28,20057,NULL,NULL,'K','ESO 091- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60169,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60169,32.87,0.43,37.5,20057,75,NULL,'3.6 micron, color + selection bias corrected','ESO 091- G 003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60170,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60170,37.96,0.46,391,20058,70,NULL,NULL,'2MASX J09133292+0407453',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000176,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,138.3872083,4.12931,0.141,NULL,60678585132,948102892,14814107,17.1),(60171,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60171,34.63,0.49,84.4,20059,75,NULL,'IR','NGC 2783B',NULL,'2011yCatp016004901K',2011,1,1.88,NULL,'G',0.000077,NULL,'15.0g',0.28,'Sbc            LINER','Pair member (points to parent)',NULL,NULL,NULL,1,138.388125,30.00014,0.033,NULL,64199709732,1003120464,15673757,15),(60172,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60172,35.1,NULL,105,20059,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 2783B',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60173,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60173,35.11,NULL,105,20059,NULL,NULL,'Dipole + Quadrupole','NGC 2783B',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60174,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60174,35.12,NULL,106,20059,NULL,NULL,'Dipole','NGC 2783B',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60175,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60175,37.48,0.46,314,20060,70,NULL,NULL,'2MASX J09133338+0320463',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000123,NULL,'16.6g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,138.389167,3.34628,0.097,NULL,60676351285,948067988,14813562,16.6),(60176,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60176,33.46,0.69,49.3,20061,100,NULL,'mid-IR','NGC 2786',NULL,'2013ApJ...771...88L',2013,1,0.9,NULL,'G',0.00015,NULL,'14.20',0.5,'Sa?',NULL,NULL,NULL,NULL,1,138.3982917,12.44081,0.077,NULL,63863662451,997869725,15591714,14.2),(60177,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60177,34.05,0.44,64.7,20061,NULL,NULL,'Malmquist cor.','NGC 2786',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60178,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60178,34.28,0.39,71.9,20061,NULL,NULL,NULL,'NGC 2786',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60179,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60179,34.4,0.4,75.7,20061,NULL,NULL,'mean','NGC 2786',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60180,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60180,34.58,0.2,82.4,20061,74.4,NULL,NULL,'NGC 2786',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60181,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60181,34.59,0.47,82.9,20061,NULL,NULL,'H','NGC 2786',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60182,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60182,34.61,0.45,83.5,20061,NULL,NULL,'K','NGC 2786',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60183,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60183,34.67,0.46,86.1,20061,NULL,NULL,'J','NGC 2786',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60184,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60184,38.76,0.46,566,20062,70,NULL,NULL,'2MASX J09133623+1246305',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,138.400958333,12.77508,0.077,NULL,63864515108,997883048,15591922,18.1),(60185,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60185,37.55,0.46,323,20063,70,NULL,NULL,'2MASX J09133665+1324061',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'16.1g',0.43,NULL,NULL,NULL,NULL,NULL,1,138.4025,13.40175,0.089,NULL,63864039240,997875613,15591806,16.1),(60186,'Faber-Jackson','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60186,33.72,0.56,55.5,20064,95,NULL,'Weighted Mean','NGC 2783',NULL,'1984ApJS...56...91D',1984,1,2.04,NULL,'G',0.00009,NULL,'13.4g',0.98,'S0^+^:         LINER','Pair member (points to parent)',NULL,NULL,NULL,1,138.414417,29.99297,0.033,NULL,64199716961,1003120577,15673759,13.4),(60187,'Faber-Jackson','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60187,33.72,0.56,55.5,20064,95,NULL,'de Vaucouleurs','NGC 2783',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60188,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60188,34.91,0.33,95.7,20064,70,NULL,NULL,'NGC 2783',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60189,'Tertiary','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60189,34.14,0.5,67.3,20064,95,NULL,NULL,'NGC 2783',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60190,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60190,34.93,0.45,96.7,20064,NULL,NULL,'K','NGC 2783',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60191,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60191,35.05,0.4,103,20064,NULL,NULL,'mean','NGC 2783',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60192,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60192,36.62,0.46,211,20065,70,NULL,NULL,'2MASX J09134006+4145597',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000186,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,138.41675,41.76647,0.013,NULL,64268478035,1004194969,15690546,16.6),(60193,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60193,35.53,0.46,127,20066,70,NULL,NULL,'CGCG 121-039',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.000107,NULL,'14.8g',0.61,'S0?','Group member of poor cluster',NULL,NULL,NULL,1,138.427583,20.56983,0.093,NULL,63709653701,995463339,15554114,14.8),(60194,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60194,37.26,0.33,283,20067,70,NULL,NULL,'2MASX J09134265+0331243',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000138,NULL,'17.7g',0.18,'AGN',NULL,NULL,NULL,NULL,1,138.427667,3.52353,0.097,NULL,60676226558,948066039,14813531,17.7),(60195,'IRAS','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60195,31.89,0.8,23.9,20068,75,NULL,'CF, r','NGC 2748',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000007,NULL,'12.4',1.1,'SAbc           HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,138.42925,76.47533,0.013,NULL,61419786005,959684156,14995064,12.4),(60196,'Tully est','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60196,31.88,0.8,23.8,20068,75,NULL,'B','NGC 2748',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60197,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60197,31.11,0.43,16.7,20068,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2748',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60198,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60198,31.3,0.43,18.2,20068,75,NULL,'3.6 micron, color corrected','NGC 2748',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60199,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60199,31.47,0.38,19.7,20068,75,NULL,'CF, r, raw','NGC 2748',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60200,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60200,31.48,0.2,19.8,20068,74.4,NULL,NULL,'NGC 2748',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60201,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60201,31.53,0.38,20.2,20068,75,NULL,'CF, r, inv','NGC 2748',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60202,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60202,31.61,0.46,20.9,20068,NULL,NULL,NULL,'NGC 2748',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60203,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60203,31.6,0.45,20.9,20068,NULL,NULL,'K','NGC 2748',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60204,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60204,31.61,0.47,21,20068,NULL,NULL,'H','NGC 2748',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60205,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60205,31.62,0.46,21,20068,NULL,NULL,'J','NGC 2748',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60206,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60206,31.65,0.45,21.4,20068,NULL,NULL,'Malmquist cor.','NGC 2748',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60207,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60207,31.7,0.38,21.8,20068,75,NULL,'CF, r, cor','NGC 2748',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60208,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60208,31.82,0.4,23.1,20068,NULL,NULL,'mean','NGC 2748',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60209,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60209,38.58,0.33,521,20069,70,NULL,NULL,'2MASX J09134428+3709367',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,138.434625,37.16031,0.005,NULL,64403730599,1006308290,15723567,18.2),(60210,'Tully est','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60210,31.57,0.8,20.6,20070,75,NULL,NULL,'NGC 2836',NULL,'1988NBGC.C....0000T',1988,1,2.6,NULL,'G',0.00002,NULL,'12.64',1.9,'SA(rs)bc:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,138.435833,-69.33475,0.353,NULL,40741173789,636580840,9946575,12.64),(60211,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60211,36.85,0.46,234,20071,70,NULL,NULL,'2MASX J09134763+3604057',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000154,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,138.4485417,36.06811,0,NULL,64401648098,1006275751,15723058,17.3),(60212,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60212,38.31,0.46,459,20072,70,NULL,NULL,'2MASX J09135099+1230195',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,138.4624583,12.50533,0.077,NULL,63863705689,997870401,15591725,17.7),(60213,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60213,37.68,0.46,343,20073,70,NULL,NULL,'2MASX J09135122+1618565',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000194,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,138.463333,16.31569,0.069,NULL,63860133023,997814578,15590852,16.5),(60214,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60214,35.38,0.46,119,20074,70,NULL,NULL,'2MASX J09135117+4625160',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000153,NULL,'15.8g',0.32,'S0^-',NULL,NULL,NULL,NULL,1,138.463333,46.42114,0.005,NULL,64281694162,1004401471,15693772,15.8),(60215,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60215,35.77,0.46,142,20075,70,NULL,NULL,'CGCG 264-082',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000181,NULL,'15.4g',0.45,'S0/a',NULL,NULL,NULL,NULL,1,138.4664583,50.84267,0,NULL,64232682493,1003635663,15681807,15.4),(60216,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60216,37.44,0.46,308,20076,70,NULL,NULL,'2MASX J09135237+5231323',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000076,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,138.468,52.52575,0,NULL,63956625804,999322278,15614410,16.8),(60217,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60217,37.78,0.46,360,20077,70,NULL,NULL,'2MASX J09135353+1649225',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000159,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,138.473,16.82286,0.077,NULL,63859894933,997810858,15590794,18.1),(60218,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60218,38.14,0.33,424,20078,70,NULL,NULL,'2MASX J09135481+3036141',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00017,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,138.4785417,30.60392,0.053,NULL,64380781632,1005949713,15717964,17.7),(60219,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60219,38.14,0.33,424,20079,70,NULL,NULL,'2MASX J09135798+3036431',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,138.491667,30.61214,0.053,NULL,64380795755,1005949933,15717967,17.2),(60220,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60220,36.21,0.33,175,20080,70,NULL,NULL,'2MASX J09135802+5239364',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000068,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,138.491833,52.66,0,NULL,63956639278,999322488,15614413,17.1),(60221,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60221,35.97,0.46,156,20081,70,NULL,NULL,'2MASX J09135861+1645525',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000111,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,138.494417,16.76472,0.073,NULL,63860071297,997813614,15590837,16.5),(60222,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60222,35.35,0.46,117,20082,70,NULL,NULL,'MRK 1227',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00009,NULL,'16.0g',0.32,NULL,NULL,NULL,NULL,NULL,1,138.495167,17.94481,0.073,NULL,63875664977,998057265,15594644,16),(60223,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60223,37.57,0.33,326,20083,70,NULL,NULL,'SDSS J091359.66+463710.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000106,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,138.498625,46.61947,0.013,NULL,64281547475,1004399179,15693737,18.1),(60224,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60224,37.53,0.46,321,20084,70,NULL,NULL,'2MASX J09140314+0604192',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000195,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,138.513166667,6.07197,0.093,NULL,63623519966,994117499,15533085,17.4),(60225,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60225,37.35,0.46,295,20085,70,NULL,NULL,'2MASX J09140324+0337519',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,138.513625,3.631,0.093,NULL,60678105495,948095398,14813990,17.6),(60226,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60226,36.64,0.33,213,20086,70,NULL,NULL,'CGCG 034-014',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000198,NULL,'15.5g',0.53,'S0^-',NULL,NULL,NULL,NULL,1,138.51475,7.03783,0.069,NULL,63678381087,994974704,15546479,15.5),(60227,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60227,38.42,0.46,483,20087,70,NULL,NULL,'SDSS J091404.08+352232.1',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00015,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,138.517,35.37558,0.021,NULL,64401842069,1006278782,15723105,18.2),(60228,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60228,39.02,0.46,638,20088,70,NULL,NULL,'SDSS J091404.27+592750.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000077,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,138.517875,59.46406,0.153,NULL,62069696960,969839015,15153734,18.4),(60229,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60229,37.16,0.46,270,20089,70,NULL,NULL,'2MASX J09140494+4028196',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,138.520667,40.47208,0,NULL,64266939387,1004170927,15690170,18),(60230,'Tully est','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60230,32.86,0.8,37.3,20090,75,NULL,'B','NGC 2782',NULL,'1988NBGC.C....0000T',1988,1,3.5,NULL,'G',0.000007,NULL,'12.30',2.6,'SAB(rs)a;Sy1   Sbrst','Group member, radial-velocity confirmed',NULL,NULL,'Starburst',1,138.5212917,40.11369,0,NULL,64397736256,1006214629,15722103,12.3),(60231,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60231,30.92,0.47,15.3,20090,NULL,NULL,'H','NGC 2782',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60232,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60232,30.98,0.45,15.7,20090,NULL,NULL,'K','NGC 2782',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60233,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60233,31.03,0.46,16.1,20090,NULL,NULL,'J','NGC 2782',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60234,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60234,32.56,0.4,32.5,20090,NULL,NULL,'mean','NGC 2782',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60235,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60235,38.39,0.46,477,20091,70,NULL,NULL,'SDSS J091406.44+024523.2',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,138.526833333,2.75644,0.077,NULL,60682717012,948167453,14815116,17.9),(60236,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60236,37.93,0.46,386,20092,70,NULL,NULL,'SDSS J091407.70+660525.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,138.532125,66.09033,0.149,NULL,62261473006,972835515,15200554,18.4),(60237,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60237,36.45,0.46,195,20093,70,NULL,NULL,'2MASX J09140788+5137504',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000088,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,138.532583333,51.63064,0,NULL,63956036485,999313070,15614266,16.5),(60238,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60238,35.4,NULL,120,20094,NULL,NULL,NULL,'FGC 0859',NULL,'2000BSAO...50....5K',2000,1,0.66,NULL,'G',0.000021,NULL,'16.72',0.08,'Sd',NULL,NULL,NULL,NULL,1,138.535083,29.74244,0.033,NULL,64199967778,1003124496,15673820,16.72),(60239,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60239,35.43,NULL,122,20094,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0859',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60240,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60240,35.46,NULL,123,20094,NULL,NULL,'Dipole + Quadrupole','FGC 0859',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60241,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60241,35.48,NULL,125,20094,NULL,NULL,'Dipole','FGC 0859',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60242,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60242,38.22,0.46,441,20095,70,NULL,NULL,'2MASX J09141100+4021128',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000193,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,138.545916667,40.35353,0.009,NULL,64266931301,1004170801,15690168,17.5),(60243,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60243,36.85,0.46,235,20096,70,NULL,NULL,'2MASXi J0914110+382549',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,138.546083,38.43053,0.005,NULL,64398330221,1006223909,15722248,17.9),(60244,'Ring Diameter','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60244,32.3,0.84,29,20097,NULL,NULL,'Published at H = 100 km/s/Mpc','UGC 04864',NULL,'1981ApJS...45..541P',1981,1,1.9,NULL,'G',0.00002,NULL,'13.7',1.9,'SA(r)ab','Group member of poor cluster',NULL,NULL,NULL,1,138.553167,16.74233,0.073,NULL,63860066182,997813534,15590836,13.7),(60245,'SNII optical','2016-12-15 15:14:28','2016-12-16 11:19:34','1','SN 2003T',NULL,60245,34.72,0.31,87.8,20097,NULL,NULL,'EPM E96','UGC 04864',NULL,'2009ApJ...696.1176J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60246,'SNII optical','2016-12-15 15:14:28','2016-12-16 11:19:34','1','SN 2003T',NULL,60246,35.13,0.54,106,20097,NULL,NULL,'SCM, I','UGC 04864',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60247,'SNII optical','2016-12-15 15:14:28','2016-12-16 11:19:34','1','SN 2003T',NULL,60247,35.15,0.54,107,20097,NULL,NULL,'SCM, V','UGC 04864',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60248,'SNII optical','2016-12-15 15:14:28','2016-12-16 11:19:34','1','SN 2003T',NULL,60248,35.17,0.28,108,20097,NULL,NULL,'SCM, BVI','UGC 04864',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60249,'SNII optical','2016-12-15 15:14:28','2016-12-16 11:19:34','1','SN 2003T',NULL,60249,35.21,0.42,110,20097,NULL,NULL,'SCM, B','UGC 04864',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60250,'SNII optical','2016-12-15 15:14:28','2016-12-16 11:19:34','1','SN 2003T',NULL,60250,35.58,0.1,131,20097,NULL,NULL,'I, photospheric magnitude method','UGC 04864',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60251,'SNII optical','2016-12-15 15:14:28','2016-12-16 11:19:34','1','SN 2003T',NULL,60251,35.65,0.15,135,20097,NULL,NULL,'V, photospheric magnitude method','UGC 04864',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60252,'SNII optical','2016-12-15 15:14:28','2016-12-16 11:19:34','1','SN 2003T',NULL,60252,35.84,0.48,147,20097,NULL,NULL,'EPM D05','UGC 04864',NULL,'2009ApJ...696.1176J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60253,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60253,37.64,0.46,338,20098,70,NULL,NULL,'2MASX J09141512+4610460',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,138.562958333,46.17953,0,NULL,64281674662,1004401166,15693768,17.1),(60254,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60254,37.32,0.46,291,20099,70,NULL,NULL,'2MASX J09141684+4338030',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000181,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,138.570333,43.63436,0,NULL,64269557876,1004211841,15690810,18.2),(60255,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60255,38.07,0.46,412,20100,70,NULL,NULL,'2MASX J09141784+0431264',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,138.574417,4.52394,0.117,NULL,60678686386,948104474,14814132,17.9),(60256,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60256,37.57,0.33,326,20101,70,NULL,NULL,'2MASX J09141974+4638340',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000154,NULL,'16.7g',0.35,NULL,NULL,NULL,NULL,NULL,1,138.582125,46.64286,0.013,NULL,64281564145,1004399439,15693741,16.7),(60257,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60257,37.65,0.46,339,20102,70,NULL,NULL,'2MASX J09141990+5031244',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000109,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,138.583125,50.52347,0.005,NULL,64232843354,1003638177,15681846,17.8),(60258,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60258,38.28,0.46,452,20103,70,NULL,NULL,'SDSS J091420.37+103233.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000179,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,138.584917,10.54261,0.181,NULL,63652000358,994562505,15540039,17.8),(60259,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60259,37.3,0.46,288,20104,70,NULL,NULL,'2MASX J09142086+0915233',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,138.586917,9.25658,0.133,NULL,63648981527,994515336,15539302,17.5),(60260,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60260,38.24,0.46,444,20105,70,NULL,NULL,'2MASX J09142097+4048329',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000146,NULL,'17.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,138.587375,40.80919,0,NULL,64266882290,1004170035,15690156,17.7),(60261,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60261,38.3,0.46,458,20106,70,NULL,NULL,'2MASX J09142204+0153335',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00008,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,138.5919583,1.8925,0.073,NULL,60682612425,948165819,14815090,18.3),(60262,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60262,38.3,0.46,457,20107,70,NULL,NULL,'2MASX J09142233+1220571',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,138.592917,12.34928,0.081,NULL,63863710138,997870470,15591726,18.1),(60263,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60263,37,0.46,251,20108,70,NULL,NULL,'2MASX J09142425+1224541',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,138.601166667,12.41489,0.081,NULL,63863711165,997870486,15591726,17.4),(60264,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60264,37.1,0.46,263,20109,70,NULL,NULL,'2MASX J09142471+3608189',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000171,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,138.603,36.13861,0,NULL,64401644484,1006275695,15723057,17.3),(60265,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60265,35.29,0.75,114,20110,70,NULL,NULL,'AM 0912-242',NULL,'2014MNRAS.445.2677S',2014,1,0.1,NULL,'G',0.00015,NULL,'14.3I',0.4,'COMPACT',NULL,NULL,NULL,NULL,1,138.6085417,-24.58567,0.577,NULL,42314194961,661159296,10330614,14.3),(60266,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60266,35.06,0.46,103,20111,70,NULL,NULL,'CGCG 151-029',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000169,NULL,'15.5g',0.42,'E/S0',NULL,NULL,NULL,NULL,1,138.61,30.63653,0.053,NULL,64380786233,1005949784,15717965,15.5),(60267,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60267,38.09,0.46,415,20112,70,NULL,NULL,'2MASX J09142756+1922158',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000182,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,138.6149583,19.37117,0.101,NULL,63829877662,997341838,15583466,17.1),(60268,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60268,38.24,0.46,445,20113,70,NULL,NULL,'SDSS J091427.91+665625.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,138.6162917,66.94042,0.153,NULL,62275859624,973060306,15204067,18.5),(60269,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60269,38.07,0.33,412,20114,70,NULL,NULL,'2MASX J09143155+5253113',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000072,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,138.631333,52.88658,0,NULL,63956133482,999314585,15614290,18.4),(60270,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60270,38.07,0.33,412,20115,70,NULL,NULL,'2MASX J09143275+5251293',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000082,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,138.636208333,52.85803,0,NULL,63956133193,999314581,15614290,17.9),(60271,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60271,37.15,0.46,270,20116,70,NULL,NULL,'2MASX J09143288+4005050',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.6g',0.2,'Poss. dwarf gal.',NULL,NULL,NULL,NULL,1,138.637,40.08472,0,NULL,64397731469,1006214554,15722102,17.6),(60272,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60272,35.15,0.49,107,20117,75,NULL,'IR','UGC 04865',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000037,NULL,'15.6',0.15,'S','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,138.639791667,35.71756,0,NULL,64402414793,1006287731,15723245,15.6),(60273,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60273,34.8,0.45,91.3,20118,NULL,NULL,'K','UGC 04869',NULL,'2007A&A...465...71T',2007,1,1.94,NULL,'G',0.00007,NULL,'14.1g',0.54,'S0?            AGN','in a radial-velocity based grouping',NULL,NULL,NULL,1,138.643041667,30.14086,0.029,NULL,64199823780,1003122246,15673785,14.1),(60274,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60274,35.12,0.4,106,20118,NULL,NULL,'mean','UGC 04869',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60275,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60275,37.31,0.23,289,20119,70,NULL,NULL,'2MASX J09143462+0733207',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,138.644167,7.55572,0.085,NULL,63644937181,994452143,15538314,17.7),(60276,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60276,36.76,0.15,225,20120,70,NULL,NULL,'2MASX J09143513+4729433',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000063,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,138.646375,47.49536,0.005,NULL,64278024226,1004344128,15692877,16.5),(60277,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60277,34.66,0.57,85.5,20121,70,NULL,NULL,'2MASX J09143528-0827085',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.55',NULL,NULL,NULL,NULL,NULL,NULL,1,138.647125,-8.4525,0.113,NULL,42183957400,659124334,10298817,15.55),(60278,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60278,32.74,0.4,35.2,20122,75,NULL,NULL,'ESO 564- G 032',NULL,'2008Ap.....51..336K',2008,1,2,NULL,'G',0.000013,NULL,'15.16',0.4,'SB(s)bc?',NULL,NULL,NULL,NULL,1,138.652083,-21.96867,0.481,NULL,42321976091,661280876,10332513,15.16),(60279,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60279,33.51,0.49,50.2,20122,75,NULL,'IR','ESO 564- G 032',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60280,'IRAS','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60280,34.27,0.8,71.5,20123,75,NULL,'MAT, I','ESO 564- G 031',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000023,NULL,'14.35',0.6,'SAB(s)c        HII',NULL,NULL,NULL,NULL,1,138.653041667,-19.55119,0.333,NULL,42350779559,661730930,10339545,14.35),(60281,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60281,33.94,0.43,61.4,20123,75,NULL,'MAT, I, raw','ESO 564- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60282,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60282,33.95,0.43,61.7,20123,75,NULL,'3.6 micron, color corrected','ESO 564- G 031',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60283,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60283,33.96,0.43,62,20123,75,NULL,'3.6 micron, color + selection bias corrected','ESO 564- G 031',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60284,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60284,33.98,0.32,62.6,20123,85,NULL,'I, raw','ESO 564- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60285,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60285,34.03,0.32,64,20123,85,NULL,'I, inv','ESO 564- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60286,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60286,34.08,0.2,65.5,20123,74.4,NULL,NULL,'ESO 564- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60287,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60287,34.15,0.43,67.7,20123,75,NULL,'MAT, I, inv','ESO 564- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60288,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60288,34.17,0.43,68.2,20123,75,NULL,'MAT, I, cor','ESO 564- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60289,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60289,34.25,0.31,70.7,20123,NULL,NULL,'Malmquist cor.','ESO 564- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60290,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60290,34.35,0.3,74.2,20123,NULL,NULL,NULL,'ESO 564- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60291,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60291,34.53,0.4,80.5,20123,NULL,NULL,'mean','ESO 564- G 031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60292,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60292,34.54,0.47,81.1,20123,NULL,NULL,'H','ESO 564- G 031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60293,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60293,34.62,0.46,84,20123,NULL,NULL,'J','ESO 564- G 031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60294,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60294,34.65,0.45,85.2,20123,NULL,NULL,'K','ESO 564- G 031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60295,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60295,37.31,0.23,289,20124,70,NULL,NULL,'2MASX J09143758+0730277',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000161,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,138.6564583,7.50756,0.085,NULL,63644942778,994452230,15538316,16.9),(60296,'Sosies','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60296,33.61,0.32,52.7,20125,NULL,NULL,NULL,'ESO 126- G 003',NULL,'2002A&A...393...57T',2002,1,1.8,'Confused HIPASS source','G',0.00002,NULL,'13.36',1.1,'SB(rs)bc',NULL,NULL,NULL,NULL,1,138.663375,-60.43414,NULL,NULL,40591502088,634242220,9910034,13.36),(60297,'Tully est','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60297,32.8,0.8,36.3,20125,75,NULL,NULL,'ESO 126- G 003',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60298,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60298,33.23,0.45,44.3,20125,NULL,NULL,'K','ESO 126- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60299,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60299,33.24,0.4,44.4,20125,NULL,NULL,'mean','ESO 126- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60300,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60300,33.24,0.47,44.4,20125,NULL,NULL,'H','ESO 126- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60301,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60301,33.26,0.46,44.9,20125,NULL,NULL,'J','ESO 126- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60302,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60302,37.12,0.46,266,20126,70,NULL,NULL,'2MASX J09143951+4927032',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000162,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,138.664417,49.45094,0.005,NULL,64233330548,1003645789,15681965,16.7),(60303,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60303,34.67,0.49,86,20127,75,NULL,'IR','CGCG 151-031',NULL,'2011yCatp016004901K',2011,1,1.02,NULL,'G',0.000035,NULL,'15.6g',0.24,NULL,'Group member',NULL,NULL,NULL,1,138.6682083,29.98764,0.025,NULL,64199678104,1003119970,15673749,15.6),(60304,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60304,34.91,0.12,96.1,20127,NULL,NULL,NULL,'CGCG 151-031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60305,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60305,34.94,0.2,97.3,20127,74.4,NULL,NULL,'CGCG 151-031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60306,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60306,35.12,0.64,105,20128,70,NULL,NULL,'2MASX J09144216-3323088',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,138.675667,-33.38586,1.113,NULL,42942114109,670970532,10483914,15.6),(60307,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60307,37.31,0.23,289,20129,70,NULL,NULL,'2MASX J09144316+0735447',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000192,NULL,'16.0g',0.41,'BrClG',NULL,NULL,NULL,NULL,1,138.6797083,7.59581,0.085,NULL,63644942031,994452219,15538315,16),(60308,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60308,33.26,0.2,44.9,20130,74.4,NULL,NULL,'UGC 04867',NULL,'2013AJ....146...86T',2013,1,1.7,'Multiple SDSS entries describe this object.','G',0.000017,NULL,'14.7',1.3,'SAB(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,138.6797917,40.87961,0,NULL,64266885760,1004170090,15690157,14.7),(60309,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60309,33.46,0.43,49.2,20130,75,NULL,'3.6 micron, color corrected','UGC 04867',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60310,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60310,33.71,0.43,55.3,20130,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04867',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60311,'Tully est','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60311,32.86,0.8,37.4,20131,75,NULL,NULL,'ESO 126- G 004',NULL,'1988NBGC.C....0000T',1988,1,1.4,'Confused HIPASS source','G',0.000024,NULL,'15.1B',1.4,'SB(s)d',NULL,NULL,NULL,NULL,1,138.681833,-60.74531,NULL,NULL,40591183627,634237244,9909956,15.1),(60312,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60312,35.69,0.33,138,20132,70,NULL,NULL,'CGCG 121-041',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000174,NULL,'15.6g',0.27,NULL,'Group member',NULL,NULL,NULL,1,138.686541667,22.57636,0.129,NULL,63718600156,995603127,15556298,15.6),(60313,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60313,35.19,0.46,109,20133,70,NULL,NULL,'CGCG 091-030',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000163,NULL,'15.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,138.689916667,18.92344,0.085,NULL,63829111451,997329866,15583279,15.6),(60314,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60314,35.07,0.46,103,20134,70,NULL,NULL,'CGCG 091-031',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000093,NULL,'15.1g',0.65,NULL,'Group member of poor cluster',NULL,NULL,NULL,1,138.691083,20.12783,0.089,NULL,63707833789,995434902,15553670,15.1),(60315,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60315,36.21,0.46,174,20135,70,NULL,NULL,'2MASX J09144661+3813203',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,138.694167,38.22228,0,NULL,64396482429,1006195037,15721797,17.3),(60316,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60316,37.68,0.46,344,20136,70,NULL,NULL,'2MASX J09144697+4155143',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000174,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,138.695625,41.92064,0,NULL,64268514995,1004195546,15690555,17.7),(60317,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60317,37.56,0.46,324,20137,70,NULL,NULL,'2MASX J09144720-0028464',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000095,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,138.696541667,-0.47947,0.101,NULL,41081088184,641892002,10029562,16.8),(60318,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60318,31.55,0.4,20.4,20138,75,NULL,'B','Holmberg III',NULL,'1988NBGC.C....0000T',1988,1,2.8,NULL,'G',0.000023,NULL,'13.02',2.3,'SAB(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,138.699417,74.23247,0.017,NULL,61371792120,958934251,14983347,13.02),(60319,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60319,32.67,0.4,34.2,20138,NULL,NULL,NULL,'Holmberg III',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60320,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60320,37.41,0.46,303,20139,70,NULL,NULL,'2MASX J09144874+0725097',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,138.7029583,7.41928,0.085,NULL,63645134288,994455223,15538362,17.5),(60321,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60321,37.31,0.23,289,20140,70,NULL,NULL,'2MASX J09144874+0733137',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000155,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,138.7029583,7.554,0.085,NULL,63644935941,994452124,15538314,17.5),(60322,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60322,36.77,0.46,226,20141,70,NULL,NULL,'2MASX J09145007+5102232',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,138.7085,51.03992,0.005,NULL,63961054745,999391480,15615491,17.2),(60323,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60323,38.42,0.46,483,20142,70,NULL,NULL,'2MASX J09145198+0807537',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000179,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,138.716625,8.13156,0.117,NULL,63647937296,994499020,15539047,17.5),(60324,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60324,34.78,0.54,90.4,20143,70,NULL,NULL,'2MASX J09145343-0516204',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.41',NULL,NULL,NULL,NULL,NULL,NULL,1,138.7224583,-5.27258,0.093,NULL,42153149539,658642961,10291296,16.41),(60325,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60325,37.1,0.46,263,20144,70,NULL,NULL,'2MASX J09145349+1703282',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000143,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,138.722875,17.05783,0.069,NULL,63862012098,997843939,15591311,16.9),(60326,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60326,38.03,0.46,404,20145,70,NULL,NULL,'2MASX J09145475+3855344',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,138.728208333,38.92617,0.009,NULL,64398408523,1006225133,15722267,18.1),(60327,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60327,38.01,0.46,400,20146,70,NULL,NULL,'2MASX J09145621+6539526',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,138.734167,65.66469,0.145,NULL,62254361276,972724394,15198818,17.8),(60328,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60328,35.69,0.33,138,20147,70,NULL,NULL,'CGCG 121-043',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000196,NULL,'15.3g',0.46,NULL,'Group member',NULL,NULL,NULL,1,138.7502083,22.58494,0.129,NULL,63718598664,995603104,15556298,15.3),(60329,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60329,36.21,0.33,175,20148,70,NULL,NULL,'2MASX J09150015+5235132',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000091,NULL,'16.0g',0.39,'NLAGN',NULL,NULL,NULL,NULL,1,138.750625,52.58703,0.017,NULL,63956156023,999314937,15614295,16),(60330,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60330,34.99,0.49,99.3,20149,75,NULL,'IR','UGC 04872',NULL,'2011yCatp016004901K',2011,1,2.03,NULL,'G',0.000027,NULL,'15.2g',0.27,'SBb',NULL,NULL,NULL,NULL,1,138.756417,40.0365,0,NULL,64397689805,1006213903,15722092,15.2),(60331,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60331,35.23,NULL,111,20149,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04872',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60332,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60332,35.24,NULL,112,20149,NULL,NULL,'Dipole + Quadrupole','UGC 04872',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60333,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60333,35.24,NULL,112,20149,NULL,NULL,'Dipole','UGC 04872',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60334,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60334,35.28,NULL,114,20149,NULL,NULL,NULL,'UGC 04872',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60335,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60335,37.61,0.46,332,20150,70,NULL,NULL,'2MASX J09150164+0505363',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000176,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,138.756875,5.09339,0.097,NULL,60675258819,948050919,14813295,17.5),(60336,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60336,36.76,0.15,225,20151,70,NULL,NULL,'SDSS J091503.78+475421.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000138,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,138.76575,47.90606,0,NULL,64232312676,1003629885,15681716,18.1),(60337,'IRAS','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60337,32.32,0.8,29.1,20152,75,NULL,'MAT, I','ESO 433- G 010',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000023,NULL,'15',1.4,'SAB(rs)bc',NULL,NULL,NULL,NULL,1,138.77,-28.26317,0.797,NULL,42847945391,669499146,10460924,15),(60338,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60338,32.23,0.32,27.9,20152,85,NULL,'I, raw','ESO 433- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60339,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60339,32.25,0.32,28.2,20152,85,NULL,'I, inv','ESO 433- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60340,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60340,32.31,0.43,29,20152,75,NULL,'MAT, I, raw','ESO 433- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60341,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60341,32.44,0.43,30.8,20152,75,NULL,'MAT, I, inv','ESO 433- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60342,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60342,32.57,0.43,32.6,20152,75,NULL,'MAT, I, cor','ESO 433- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60343,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60343,32.75,0.43,35.5,20152,75,NULL,'3.6 micron, color + selection bias corrected','ESO 433- G 010',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60344,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60344,32.76,0.4,35.7,20152,NULL,NULL,'mean','ESO 433- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60345,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60345,32.78,0.43,35.9,20152,75,NULL,'3.6 micron, color corrected','ESO 433- G 010',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60346,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60346,32.8,0.2,36.3,20152,74.4,NULL,NULL,'ESO 433- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60347,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60347,32.82,0.42,36.6,20152,NULL,NULL,'Malmquist cor.','ESO 433- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60348,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60348,32.94,0.47,38.7,20152,NULL,NULL,'H','ESO 433- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60349,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60349,32.95,0.46,39,20152,NULL,NULL,'J','ESO 433- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60350,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60350,33,0.45,39.8,20152,NULL,NULL,'K','ESO 433- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60351,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60351,33.01,0.38,40,20152,NULL,NULL,NULL,'ESO 433- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60352,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60352,37.68,0.46,343,20153,70,NULL,NULL,'2MASX J09150585+4020155',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000197,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,138.7744583,40.33758,0.009,NULL,64266810030,1004168906,15690139,17.4),(60353,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60353,36.16,0.46,171,20154,70,NULL,NULL,'2MASX J09150603+2220371',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000201,NULL,'15.4g',0.41,NULL,NULL,NULL,NULL,NULL,1,138.775041667,22.34361,0.149,NULL,63718195755,995596808,15556200,15.4),(60354,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60354,36.69,0.46,218,20155,70,NULL,NULL,'SDSS J091506.80+092714.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000133,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,138.778333,9.45406,0.161,NULL,63649082607,994516915,15539326,18),(60355,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60355,37.45,0.46,308,20156,70,NULL,NULL,'2MASX J09150796+0709593',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,138.7832083,7.16647,0.085,NULL,63645023023,994453484,15538335,17.7),(60356,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60356,35.98,0.46,157,20157,70,NULL,NULL,'2MASX J09150845+4930042',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000166,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,138.785208333,49.50128,0.013,NULL,64233338967,1003645921,15681967,16.8),(60357,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60357,36.97,0.46,247,20158,70,NULL,NULL,'2MASX J09150863+3728185',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000171,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,138.785875,37.47189,0,NULL,64404185421,1006315397,15723678,17.1),(60358,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60358,35.43,0.46,122,20159,70,NULL,NULL,'2MASX J09151036+2440579',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000178,NULL,'15.7g',0.45,NULL,NULL,NULL,NULL,NULL,1,138.793166667,24.68269,0.117,NULL,63706068390,995407318,15553239,15.7),(60359,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60359,38.18,0.46,433,20160,70,NULL,NULL,'2MASX J09151115+0526463',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.6g',0.2,'BrClG',NULL,NULL,NULL,NULL,1,138.796416667,5.44625,0.101,NULL,63623531019,994117672,15533088,17.6),(60360,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60360,36.75,0.46,224,20161,70,NULL,NULL,'2MASX J09151405+0342123',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000197,NULL,'15.7g',0.44,'E0',NULL,NULL,NULL,NULL,1,138.8087083,3.70342,0.105,NULL,60678035802,948094309,14813973,15.7),(60361,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60361,33.99,0.2,62.8,20162,74.4,NULL,NULL,'NGC 2785',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.00006,NULL,'14.73',0.5,'Im?            HII',NULL,NULL,NULL,NULL,1,138.814125,40.91753,0,NULL,64266986441,1004171663,15690182,14.73),(60362,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60362,38.29,0.33,456,20163,70,NULL,NULL,'2MASX J09151610+1354041',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,138.8170417,13.90119,0.153,NULL,63868276714,997941823,15592840,17.4),(60363,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60363,38.16,0.46,429,20164,70,NULL,NULL,'2MASX J09151669+1206131',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',NULL,NULL,'16.0E',NULL,NULL,NULL,NULL,NULL,NULL,1,138.8195,12.10372,0.073,NULL,63642524503,994414445,15537725,16),(60364,'Sosies','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60364,34.64,0.43,84.7,20165,NULL,NULL,NULL,'IC 0530',NULL,'2002A&A...393...57T',2002,1,1.8,NULL,'G',0.00002,NULL,'13.98',0.6,'Sab','Isolated galaxy (6 Mpc isolation)',NULL,NULL,NULL,1,138.820708333,11.88569,0.085,NULL,63642452266,994413316,15537708,13.98),(60365,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60365,34.27,0.47,71.5,20165,NULL,NULL,'H','IC 0530',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60366,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60366,34.3,0.46,72.6,20165,NULL,NULL,'J','IC 0530',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60367,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60367,34.31,0.45,72.8,20165,NULL,NULL,'K','IC 0530',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60368,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60368,34.42,0.4,76.6,20165,NULL,NULL,'mean','IC 0530',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60369,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60369,34.49,0.57,79.1,20165,NULL,NULL,'Malmquist cor.','IC 0530',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60370,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60370,34.51,0.49,79.9,20165,75,NULL,'IR','IC 0530',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60371,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60371,34.62,0.53,84.1,20165,NULL,NULL,NULL,'IC 0530',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60372,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60372,34.65,0.2,85.1,20165,74.4,NULL,NULL,'IC 0530',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60373,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60373,36.92,0.46,243,20166,70,NULL,NULL,'2MASX J09151710+2506069',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,138.821333,25.10186,0.101,NULL,63705307364,995395427,15553053,17.3),(60374,'SNIa','2016-12-15 15:14:28','2016-12-16 11:19:34','1','SN 2006lu',NULL,60374,36.01,0.22,159,20167,72,NULL,'M(H) = -18.317 mag','2MASX J09151727-2536001',NULL,'2014ApJ...784..105W',2013,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,138.8219583,-25.60008,0.601,NULL,42834411782,669287684,10457620,NULL),(60375,'SNIa','2016-12-15 15:14:28','2016-12-16 11:19:34','1','SN 2006lu',NULL,60375,36.67,0.07,194,20167,72,NULL,NULL,'2MASX J09151727-2536001',0.0544,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60376,'SNIa','2016-12-15 15:14:28','2016-12-16 11:19:34','1','SN 2006lu','R',60376,36.61,0.07,210,20167,NULL,NULL,'MLCS2k2, R(V) = 1.8','2MASX J09151727-2536001',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60377,'SNIa','2016-12-15 15:14:28','2016-12-16 11:19:34','1','SN 2006lu','R',60377,36.62,0.08,211,20167,NULL,NULL,'MLCS2k2, R(V) = 3.1','2MASX J09151727-2536001',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60378,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60378,36.03,0.46,160,20168,70,NULL,NULL,'2MASX J09151837+2818549',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000164,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,138.8265417,28.31517,0.017,NULL,64204287866,1003191997,15674874,16.1),(60379,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60379,38.25,0.46,446,20169,70,NULL,NULL,'SDSS J091518.56+483252.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000055,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,138.827375,48.54797,0.009,NULL,64235563944,1003680686,15682510,18.2),(60380,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60380,38.29,0.33,456,20170,70,NULL,NULL,'2MASX J09151946+1351141',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,138.83125,13.85394,0.141,NULL,63868454019,997944594,15592884,17.8),(60381,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60381,38.37,0.46,471,20171,70,NULL,NULL,'SDSS J091519.95+044131.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,138.833125,4.69211,0.101,NULL,60675191674,948049869,14813279,18.1),(60382,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60382,37.92,0.46,383,20172,70,NULL,NULL,'SDSS J091520.77+580730.5',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000072,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,138.836583333,58.12517,0.109,NULL,62015210397,968987662,15140432,17.8),(60383,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60383,35.63,0.46,134,20173,70,NULL,NULL,'2MASX J09152102+5459563',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000076,NULL,'16.0g',0.3,'S0^-',NULL,NULL,NULL,NULL,1,138.8377917,54.99892,0.017,NULL,61876096224,966814003,15106468,16),(60384,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60384,38.08,0.46,413,20174,70,NULL,NULL,'2MASX J09152162+4100205',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000176,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,138.839875,41.00586,0,NULL,64267020697,1004172198,15690190,17.2),(60385,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60385,38.1,0.46,417,20175,70,NULL,NULL,'2MASX J09152270+6342477',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,138.8445,63.71342,0.145,NULL,62030302769,969223480,15144116,17.6),(60386,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60386,35.47,0.46,124,20176,70,NULL,NULL,'2MASX J09152371+2724319',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000151,NULL,'16.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,138.848875,27.40875,0.041,NULL,64205404369,1003209443,15675147,16.5),(60387,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60387,36.32,0.64,184,20177,70,NULL,NULL,'2MASX J09152536-8013174',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'17.1b',NULL,'SBa(r)',NULL,NULL,NULL,NULL,1,138.8555,-80.22156,0.441,NULL,39981508597,624711071,9761110,17.1),(60388,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60388,31.68,NULL,21.7,20178,NULL,NULL,NULL,'AGC 198507',NULL,'2013AJ....145..101K',2013,1,NULL,NULL,'RadioS',0.000062,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,138.855833,25.41972,0.097,NULL,64190857486,1002982148,15671596,NULL),(60389,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60389,37.76,0.33,357,20179,70,NULL,NULL,'2MASX J09152597+3841326',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000167,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,138.858291667,38.69239,0,NULL,64398325115,1006223829,15722247,16.7),(60390,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60390,37.42,0.46,305,20180,70,NULL,NULL,'2MASX J09152603+1417351',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,138.858333,14.29317,0.141,NULL,63870558773,997977480,15593398,17.2),(60391,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60391,34.69,1.02,86.8,20181,NULL,NULL,NULL,'2MASX J09152833+1150053',NULL,'2009ApJS..182..474S',2009,1,0.37,NULL,'G',0.000023,NULL,'17.49',0.35,NULL,NULL,NULL,NULL,NULL,1,138.8680417,11.83475,0.085,NULL,63642454643,994413353,15537708,17.49),(60392,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60392,35.08,0.85,104,20181,NULL,NULL,'Malmquist cor.','2MASX J09152833+1150053',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60393,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60393,36.26,0.57,178,20182,70,NULL,NULL,'2MASX J09152869-0809014',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.46',NULL,NULL,NULL,NULL,NULL,NULL,1,138.8695417,-8.15067,0.117,NULL,42185902290,659154723,10299292,16.46),(60394,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60394,36.72,0.46,220,20183,70,NULL,NULL,'2MASX J09153012+2336052',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000198,NULL,'15.6g',0.47,NULL,NULL,NULL,NULL,NULL,1,138.8754583,23.60144,0.169,NULL,63717009312,995578270,15555910,15.6),(60395,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60395,37.42,0.46,305,20184,70,NULL,NULL,'2MASX J09153166+1415100',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,138.882,14.25272,0.141,NULL,63870594201,997978034,15593406,16.9),(60396,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60396,37.54,0.46,322,20185,70,NULL,NULL,'2MASX J09153373+0019027',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000094,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,138.890541667,0.31731,0.061,NULL,60673174135,948018345,14812786,16.6),(60397,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60397,38.14,0.46,425,20186,70,NULL,NULL,'2MASX J09153413+0637083',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000148,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,138.892458333,6.619,0.081,NULL,63678026900,994969170,15546393,17.7),(60398,'Tully est','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60398,32.69,0.8,34.6,20187,75,NULL,NULL,'NGC 2842',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.000133,NULL,'13.41',1.3,'(R_1)SAB(rs)0^+',NULL,NULL,NULL,NULL,1,138.9017917,-63.06964,NULL,NULL,40579269011,634051078,9907048,13.41),(60399,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60399,37.94,0.46,387,20188,70,NULL,NULL,'SDSS J091538.10+533935.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00007,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,138.9087917,53.65986,0.021,NULL,63958821894,999356592,15614946,18.6),(60400,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60400,37.55,0.46,323,20189,70,NULL,NULL,'2MASX J09153920+3953446',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000195,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,138.9135417,39.89569,0,NULL,64397687392,1006213865,15722091,16.5),(60401,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60401,37.95,0.46,389,20190,70,NULL,NULL,'2MASX J09154047+0937063',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,138.9187083,9.61825,0.161,NULL,63648933543,994514586,15539290,17.4),(60402,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60402,37.57,0.46,327,20191,70,NULL,NULL,'2MASX J09154225+0619183',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000165,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,138.9262083,6.32175,0.093,NULL,63678169331,994971395,15546428,17.1),(60403,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60403,32.96,0.49,39,20192,75,NULL,'IR','ESO 497- G 029',NULL,'2011yCatp016004901K',2011,1,1.66,'6dF DR1 has z = 0.008476.','G',0.000047,NULL,'16.09',0.2,'Sd',NULL,NULL,NULL,NULL,1,138.930417,-23.70128,0.597,NULL,42327385890,661365404,10333834,16.09),(60404,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60404,33.78,NULL,57,20192,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 497- G 029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60405,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60405,33.78,NULL,57,20192,NULL,NULL,'Dipole','ESO 497- G 029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60406,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60406,33.78,NULL,57.1,20192,NULL,NULL,'Dipole + Quadrupole','ESO 497- G 029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60407,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60407,38.11,0.46,418,20193,70,NULL,NULL,'2MASX J09154408+0226387',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000093,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,138.933833,2.44408,0.065,NULL,60679846199,948122596,14814415,17),(60408,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60408,35.54,0.33,128,20194,70,NULL,NULL,'CGCG 209-036',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000183,NULL,'14.9g',0.57,'E0',NULL,NULL,NULL,NULL,1,138.9355,44.23608,0.005,NULL,64262189187,1004096706,15689011,14.9),(60409,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60409,37.76,0.33,357,20195,70,NULL,NULL,'2MASX J09154510+3843326',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000195,NULL,'18.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,138.937917,38.72561,0,NULL,64397818001,1006215906,15722123,18.1),(60410,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60410,37.55,0.23,323,20196,70,NULL,NULL,'2MASX J09154541+0705263',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,138.93925,7.09064,0.085,NULL,63645016116,994453376,15538334,17.2),(60411,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60411,36.64,0.33,213,20197,70,NULL,NULL,'2MASX J09154668+0713183',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,138.944583,7.22181,0.085,NULL,63644991453,994452991,15538327,17),(60412,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60412,37.17,0.33,271,20198,70,NULL,NULL,'2MASX J09154855+3858256',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000172,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,138.9522083,38.97381,0,NULL,64397924429,1006217569,15722149,16.9),(60413,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60413,35.3,0.55,115,20199,70,NULL,NULL,'2MASX J09155036-3347059',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,138.959917,-33.78492,1.017,NULL,42942021392,670969084,10483891,15.2),(60414,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60414,37.17,0.33,271,20200,70,NULL,NULL,'2MASX J09155089+3905176',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00019,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,138.961917,39.08819,0,NULL,64397951628,1006217994,15722156,16.3),(60415,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60415,37.56,0.46,326,20201,70,NULL,NULL,'SDSS J091553.00+210133.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,138.970875,21.02589,0.117,NULL,63710829771,995481715,15554401,18.1),(60416,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60416,37.93,0.46,385,20202,70,NULL,NULL,'2MASX J09155406+5105566',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000153,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,138.975417,51.09908,0.017,NULL,63969453817,999522715,15617542,16.9),(60417,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60417,37.37,0.46,298,20203,70,NULL,NULL,'SDSS J091554.25+244924.8',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000183,NULL,'17.6g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,138.976083,24.82358,0.117,NULL,63705390929,995396733,15553073,17.6),(60418,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60418,35.79,0.2,144,20204,74.4,NULL,NULL,'UGC 04884',NULL,'2013AJ....146...86T',2013,1,1.02,NULL,'G',0.000158,NULL,'14.7g',0.64,'Sab',NULL,NULL,NULL,NULL,1,138.979167,10.13253,0.213,NULL,63652506980,994570421,15540162,14.7),(60419,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60419,37.7,0.46,347,20205,70,NULL,NULL,'2MASX J09155507+5210016',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00009,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,138.979625,52.16722,0.005,NULL,63956718483,999323726,15614433,16.9),(60420,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60420,39.03,0.46,639,20206,70,NULL,NULL,'SDSS J091555.72+273143.1',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,138.982208333,27.52864,0.041,NULL,64205504773,1003211012,15675172,17.9),(60421,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60421,35.64,0.7,134,20207,70,NULL,NULL,'MCG -02-24-005',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15',0.6,NULL,NULL,NULL,NULL,NULL,1,138.982625,-13.98133,0.121,NULL,42378609924,662165780,10346340,15),(60422,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60422,37.55,0.23,323,20208,70,NULL,NULL,'2MASX J09155630+0714303',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,138.9845417,7.24175,0.085,NULL,63644976441,994452756,15538324,17.1),(60423,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60423,36.43,0.46,193,20209,70,NULL,NULL,'2MASX J09155774+1316404',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,138.990541667,13.27781,0.089,NULL,63868576236,997946503,15592914,16.4),(60424,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60424,34.46,NULL,78,20210,NULL,NULL,NULL,'ESO 564- G 033',NULL,'2000BSAO...50....5K',2000,1,1.15,NULL,'G',0.000017,NULL,'16.16',0.15,'Sdm',NULL,NULL,NULL,NULL,1,138.995833,-18.92583,0.305,NULL,42350133031,661720828,10339387,16.16),(60425,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60425,34.51,NULL,79.9,20210,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 564- G 033',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60426,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60426,34.52,NULL,80,20210,NULL,NULL,'Dipole + Quadrupole','ESO 564- G 033',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60427,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60427,34.52,NULL,80.1,20210,NULL,NULL,'Dipole','ESO 564- G 033',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60428,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60428,34.82,0.43,92.1,20210,75,NULL,'3.6 micron, color + selection bias corrected','ESO 564- G 033',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60429,'TRGB','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60429,25.22,0.18,1.1,20211,NULL,NULL,NULL,'UGC 04879',NULL,'2008MNRAS.387L..45K',2008,1,1.7,'UZC has V = 62 +- 69, but their reference (ApJS, 52, 89, 1983) has 600 +- 100.','G',0.00005,NULL,'13.78',1.3,'IAm','in a radial-velocity based grouping',NULL,NULL,NULL,1,139.0092083,52.84008,0.009,1,63956157925,999314967,15614296,13.78),(60430,'TRGB','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60430,25.21,0.19,1.1,20211,NULL,NULL,'I','UGC 04879',NULL,'2010AstL...36..309T',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60431,'TRGB','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60431,25.61,0.13,1.3,20211,NULL,NULL,'I','UGC 04879',NULL,'2011A&A...527A..58B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60432,'TRGB','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60432,25.67,0.04,1.36,20211,NULL,NULL,'I','UGC 04879',NULL,'2011AJ....141..106J',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60433,'TRGB','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60433,25.68,0.1,1.37,20211,74.4,NULL,NULL,'UGC 04879',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60434,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60434,35.54,0.27,128,20212,70,NULL,NULL,'NGC 2795',NULL,'2015arXiv151105856S',2015,1,1.42,NULL,'G',0.000067,NULL,'13.8g',0.99,'E','Group member',NULL,NULL,NULL,1,139.016333,17.62836,0.065,NULL,63858714925,997792420,15590506,13.8),(60435,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60435,35.54,0.27,128,20213,70,NULL,NULL,'SDSS J091607.48+174403.7',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'15.5g',0.47,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,139.031208333,17.73439,0.049,NULL,63858728111,997792626,15590509,15.5),(60436,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60436,34.5,0.53,79.6,20214,70,NULL,NULL,'MCG -01-24-005',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000063,NULL,'16',0.4,NULL,NULL,NULL,NULL,NULL,1,139.031291667,-6.56308,0.093,NULL,42199042536,659360039,10302500,16),(60437,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60437,38.34,0.46,465,20215,70,NULL,NULL,'SDSS J091609.87+025337.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000153,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,139.041166667,2.89364,0.041,NULL,60679439699,948116245,14814316,18.6),(60438,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60438,38.16,0.46,428,20216,70,NULL,NULL,'2MASX J09161100+0338217',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,139.045833,3.63936,0.105,NULL,60677559920,948086873,14813857,17.9),(60439,'SNIa','2016-12-15 15:14:28','2016-12-16 11:19:34','1','SN 2005am',NULL,60439,31.66,0.29,21.3,20217,74.2,NULL,'SALT 2','NGC 2811',0.007899,'2010ApJ...716..712A',2010,1,2.5,NULL,'G',0.000097,NULL,'11.5B',0.9,'SB(rs)a','Group member',NULL,NULL,NULL,1,139.046291667,-16.31272,0.117,NULL,42374071562,662094868,10345232,11.5),(60440,'SNIa','2016-12-15 15:14:28','2016-12-16 11:19:34','1','SN 2005am',NULL,60440,32.24,0.1,28.1,20217,74.4,NULL,NULL,'NGC 2811',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60441,'SNIa','2016-12-15 15:14:28','2016-12-16 11:19:34','1','SN 2005am',NULL,60441,32.33,0.01,29.2,20217,72,NULL,'B','NGC 2811',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60442,'SNIa','2016-12-15 15:14:28','2016-12-16 11:19:34','1','SN 2005am',NULL,60442,32.36,0.23,29.3,20217,73.8,NULL,'SALT 2 (SNANA)','NGC 2811',0.01,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60443,'SNIa','2016-12-15 15:14:28','2016-12-16 11:19:34','1','SN 2005am',NULL,60443,32.46,0.06,31.1,20217,72,NULL,'M(H) = -18.317 mag','NGC 2811',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60444,'SNIa','2016-12-15 15:14:28','2016-12-16 11:19:34','1','SN 2005am',NULL,60444,32.54,0.1,32,20217,72,NULL,'MLCS2k2, R(V) = 3.1','NGC 2811',0.007899,'2010ApJ...721.1608B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60445,'SNIa','2016-12-15 15:14:28','2016-12-16 11:19:34','1','SN 2005am',NULL,60445,35.26,0.1,112,20217,72,NULL,'MLCS2k2, R(V) = 1.7','NGC 2811',0.007899,'2010ApJ...721.1608B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60446,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60446,32.17,0.51,27.2,20217,70,NULL,NULL,'NGC 2811',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60447,'Tully est','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60447,32.64,0.8,33.7,20217,75,NULL,'B','NGC 2811',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60448,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60448,36.6,0.46,209,20218,70,NULL,NULL,'2MASX J09161192+3411021',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000067,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,139.0497917,34.18406,0,NULL,64408037457,1006375585,15724618,17.1),(60449,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60449,35.97,0.55,156,20219,70,NULL,NULL,'2MASX J09161214-0041582',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'16.63',0.3,NULL,NULL,NULL,NULL,NULL,1,139.050667,-0.69947,0.089,NULL,41080721252,641886269,10029472,16.63),(60450,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60450,37.34,0.46,293,20220,70,NULL,NULL,'2MASX J09161433+2821083',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,139.059583,28.35233,0.013,NULL,64203962621,1003186915,15674795,17.9),(60451,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60451,38.74,0.46,559,20221,70,NULL,NULL,'SDSS J091614.62+492629.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00014,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,139.060916667,49.44156,0.013,NULL,64233298326,1003645286,15681957,18.2),(60452,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60452,37.76,0.46,357,20222,70,NULL,NULL,'SDSS J091614.69+323315.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000134,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,139.0612083,32.55436,0.013,NULL,64378450444,1005913288,15717395,18.5),(60453,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60453,36.74,0.46,222,20223,70,NULL,NULL,'2MASX J09161500+4941430',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000151,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,139.062583333,49.69536,0.013,NULL,64233350446,1003646100,15681970,16.8),(60454,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60454,37.29,0.46,287,20224,70,NULL,NULL,'2MASX J09161619+4323436',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000176,NULL,'16.2g',0.41,NULL,NULL,NULL,NULL,NULL,1,139.067625,43.39544,0,NULL,64269402459,1004209413,15690772,16.2),(60455,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60455,35.81,0.56,145,20225,70,NULL,NULL,'2MASX J09161635-1818276',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,139.068083,-18.30769,0.113,NULL,42404522853,662570669,10352666,15.4),(60456,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60456,32.67,0.49,34.3,20226,75,NULL,'IR','UGC 04847',NULL,'2011yCatp016004901K',2011,1,1.18,NULL,'G',0.0001,NULL,'16.0',0.15,'Sbc',NULL,NULL,NULL,NULL,1,139.0747083,79.27494,0.021,NULL,61469294478,960457726,15007151,16),(60457,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60457,37.58,0.46,329,20227,70,NULL,NULL,'SDSS J091618.48+500921.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000132,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,139.077,50.15592,0,NULL,64233487179,1003648237,15682003,17.9),(60458,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60458,37.49,0.46,314,20228,70,NULL,NULL,'2MASX J09161880+5342470',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000073,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,139.078166667,53.71314,0.017,NULL,63957962274,999343160,15614736,18),(60459,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60459,35.76,0.46,142,20229,70,NULL,NULL,'CGCG 209-038',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.00018,NULL,'15.1g',0.64,'E0',NULL,NULL,NULL,NULL,1,139.079167,41.54994,0,NULL,64266669637,1004166713,15690104,15.1),(60460,'IRAS','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60460,32.79,0.8,36.2,20230,75,NULL,'MAT, I','NGC 2815',NULL,'1997ApJS..109..333W',1997,1,3.5,NULL,'G',0.000027,NULL,'12.81',1.1,'(R\')SB(r)b     HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,139.0822917,-23.63325,0.597,NULL,42327492096,661367064,10333860,12.81),(60461,'Tully est','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60461,32.41,0.8,30.3,20230,75,NULL,'B','NGC 2815',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60462,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60462,32.58,NULL,32.8,20230,NULL,NULL,'B','NGC 2815',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60463,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60463,32.77,0.43,35.7,20230,75,NULL,'MAT, I, raw','NGC 2815',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60464,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60464,32.79,0.46,36.1,20230,NULL,NULL,'J','NGC 2815',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60465,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60465,32.82,0.47,36.6,20230,NULL,NULL,'H','NGC 2815',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60466,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60466,32.89,0.45,37.9,20230,NULL,NULL,'K','NGC 2815',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60467,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60467,32.9,0.4,38,20230,NULL,NULL,NULL,'NGC 2815',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60468,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60468,32.94,0.32,38.7,20230,85,NULL,'I, raw','NGC 2815',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60469,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60469,32.95,0.43,38.8,20230,75,NULL,'MAT, I, cor','NGC 2815',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60470,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60470,32.96,0.43,39,20230,NULL,NULL,'Malmquist cor.','NGC 2815',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60471,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60471,33.01,0.4,39.9,20230,NULL,NULL,'mean','NGC 2815',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60472,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60472,33.03,0.32,40.3,20230,85,NULL,'I, inv','NGC 2815',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60473,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60473,33.11,0.43,41.8,20230,75,NULL,'MAT, I, inv','NGC 2815',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60474,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60474,33.15,0.2,42.7,20230,74.4,NULL,NULL,'NGC 2815',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60475,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60475,33.2,0.38,43.7,20230,NULL,NULL,NULL,'NGC 2815',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60476,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60476,33.34,0.43,46.5,20230,75,NULL,'3.6 micron, color corrected','NGC 2815',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60477,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60477,33.58,0.43,51.9,20230,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2815',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60478,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60478,37.48,0.46,314,20231,70,NULL,NULL,'2MASX J09161994+6135518',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,139.083166667,61.59783,0.113,NULL,62072556933,969883702,15154432,16.7),(60479,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60479,36.42,0.46,192,20232,70,NULL,NULL,'CGCG 181-005',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.00011,NULL,'15.1g',0.55,'E/S0:',NULL,NULL,NULL,NULL,1,139.09,32.82969,0.009,NULL,64407874967,1006373046,15724578,15.1),(60480,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60480,35.79,0.54,144,20233,70,NULL,NULL,'2MASX J09162203-1106228',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.31',0.3,NULL,NULL,NULL,NULL,NULL,1,139.091708333,-11.10642,0.149,NULL,42192241172,659253768,10300840,16.31),(60481,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60481,35.18,0.46,109,20234,70,NULL,NULL,'CGCG 062-012',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000077,NULL,'15.2g',0.43,'S0',NULL,NULL,NULL,NULL,1,139.092167,10.23175,0.137,NULL,63652543982,994570999,15540171,15.2),(60482,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60482,34.09,0.48,65.7,20235,70,NULL,NULL,'2MASX J09162266-7108567',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,139.0942083,-71.14911,0.533,NULL,40749913310,636717395,9948709,14.8),(60483,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60483,37.06,0.46,258,20236,70,NULL,NULL,'2MASX J09162366+1632490',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00017,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,139.098583,16.54706,0.061,NULL,63862329571,997848899,15591389,16.8),(60484,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60484,36.51,0.46,200,20237,70,NULL,NULL,'CGCG 034-020',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000167,NULL,'15.4g',0.45,'E0',NULL,NULL,NULL,NULL,1,139.105166667,7.09542,0.085,NULL,63645264073,994457251,15538394,15.4),(60485,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60485,37.85,0.46,371,20238,70,NULL,NULL,'SDSS J091625.54+215458.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,139.106416667,21.91631,0.149,NULL,63709923284,995467551,15554180,18.4),(60486,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60486,37.8,0.46,363,20239,70,NULL,NULL,'2MASX J09162718+1517140',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,139.113375,15.28719,0.101,NULL,63867233991,997925531,15592586,17.3),(60487,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60487,37.55,0.23,323,20240,70,NULL,NULL,'SDSS J091627.29+070350.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000187,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,139.11375,7.06408,0.069,NULL,63645271965,994457374,15538396,18.3),(60488,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60488,35.42,0.46,121,20241,70,NULL,NULL,'CGCG 209-040',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.000157,NULL,'14.9g',0.66,'E0',NULL,NULL,NULL,NULL,1,139.116917,42.13853,0,NULL,64267758472,1004183726,15690370,14.9),(60489,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60489,36.43,0.46,193,20242,70,NULL,NULL,'2MASX J09162892+3359201',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00008,NULL,'15.5g',0.52,'E0',NULL,NULL,NULL,NULL,1,139.120625,33.98889,0,NULL,64408223455,1006378491,15724663,15.5),(60490,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60490,37.19,0.46,275,20243,70,NULL,NULL,'2MASX J09162933+2134288',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000135,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,139.1222083,21.5745,0.105,NULL,63710058971,995469671,15554213,17.9),(60491,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60491,37.49,0.46,315,20244,70,NULL,NULL,'SDSS J091629.97+364335.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000153,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,139.124875,36.72664,0,NULL,64404515440,1006320553,15723758,18.2),(60492,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60492,37.88,0.46,376,20245,70,NULL,NULL,'2MASX J09163072-0009376',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000067,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,139.127917,-0.16036,0.085,NULL,41080643570,641885055,10029453,17.9),(60493,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60493,37.55,0.46,324,20246,70,NULL,NULL,'2MASX J09163069+1638020',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.1g',0.1,NULL,NULL,NULL,NULL,NULL,1,139.127958333,16.63392,0.061,NULL,63862040417,997844381,15591318,18.1),(60494,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60494,36.49,0.46,198,20247,70,NULL,NULL,'2MASX J09163124+0906217',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000187,NULL,'15.6g',0.47,'S0',NULL,NULL,NULL,NULL,1,139.130166667,9.10611,0.105,NULL,63647052698,994485198,15538831,15.6),(60495,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60495,37.58,0.46,328,20248,70,NULL,NULL,'2MASX J09163270+1832258',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,139.136291667,18.54042,0.069,NULL,63875273704,998051151,15594549,18.1),(60496,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60496,37.96,0.46,390,20249,70,NULL,NULL,'2MASX J09163323+6630525',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,139.138291667,66.51453,0.153,NULL,62274978256,973046535,15203852,17.3),(60497,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60497,37.47,0.46,312,20250,70,NULL,NULL,'2MASX J09163344+0721207',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000177,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,139.1392917,7.35589,0.085,NULL,63645173833,994455841,15538372,17.3),(60498,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60498,37.18,0.46,273,20251,70,NULL,NULL,'2MASX J09163388+3700443',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,'FoF','17.30',0.26,NULL,NULL,NULL,NULL,NULL,1,139.141083,37.01233,0,NULL,64404580013,1006321562,15723774,17.3),(60499,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60499,36.9,0.46,240,20252,70,NULL,NULL,'2MASX J09163699+5455531',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.0001,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,139.154083333,54.93133,0.017,NULL,61876146631,966814791,15106481,16.6),(60500,'IRAS','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60500,34.47,0.8,78.4,20253,75,NULL,'CF, r','UGC 04900',NULL,'1997ApJS..109..333W',1997,1,1.17,'HOLM 118B is a double star.','G',0.000057,NULL,'14.8g',0.6,'Sbc',NULL,NULL,NULL,NULL,1,139.1657917,7.26639,0.085,NULL,63645387113,994459173,15538424,14.8),(60501,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60501,34.09,0.57,65.9,20253,NULL,NULL,NULL,'UGC 04900',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60502,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60502,34.13,0.56,66.9,20253,NULL,NULL,'Malmquist cor.','UGC 04900',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60503,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60503,34.15,0.2,67.6,20253,74.4,NULL,NULL,'UGC 04900',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60504,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60504,34.36,0.38,74.5,20253,75,NULL,'CF, r, raw','UGC 04900',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60505,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60505,34.42,0.38,76.7,20253,75,NULL,'CF, r, inv','UGC 04900',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60506,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60506,34.64,0.38,84.7,20253,75,NULL,'CF, r, cor','UGC 04900',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60507,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60507,35.45,0.46,123,20254,70,NULL,NULL,'2MASX J09164049+2345187',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000164,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,139.168625,23.75514,0.153,NULL,63717217090,995581517,15555961,16.5),(60508,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60508,35.84,0.46,147,20255,70,NULL,NULL,'CGCG 151-041',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00007,NULL,'15.3g',0.49,'E','Group member',NULL,NULL,NULL,1,139.1712917,29.3395,0.029,NULL,64199538004,1003117781,15673715,15.3),(60509,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60509,37.72,0.46,351,20256,70,NULL,NULL,'2MASX J09164176+6605595',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,139.174333,66.09975,0.153,NULL,62261513700,972836151,15200564,18),(60510,'IRAS','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60510,34.25,0.8,70.7,20257,75,NULL,'HMCL, I','CGCG 006-024',NULL,'1997ApJS..109..333W',1997,1,0.61,NULL,'G',0.000027,NULL,'15.4g',0.41,'NLAGN',NULL,NULL,NULL,NULL,1,139.17575,0.20556,0.041,NULL,60672991329,948015489,14812742,15.4),(60511,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60511,34.92,0.4,96.5,20257,75,NULL,'HMCL, I, raw','CGCG 006-024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60512,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60512,35.03,0.4,102,20257,75,NULL,'HMCL, I, inv','CGCG 006-024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60513,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60513,35.15,0.4,107,20257,75,NULL,'HMCL, I, cor','CGCG 006-024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60514,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60514,37.11,0.46,265,20258,70,NULL,NULL,'2MASX J09164222+5748281',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000098,NULL,'17.3g',0.22,'NLAGN',NULL,NULL,NULL,NULL,1,139.175875,57.80772,0.101,NULL,62015815995,968997124,15140580,17.3),(60515,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60515,35.61,0.45,133,20259,NULL,NULL,'K','NGC 2803',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000043,NULL,'14.3',1.2,'S?','Pair member (points to parent)',NULL,NULL,NULL,1,139.1827917,18.95458,0.085,NULL,63828967763,997327621,15583244,14.3),(60516,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60516,35.67,0.4,136,20259,NULL,NULL,'mean','NGC 2803',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60517,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60517,36.5,0.46,199,20260,70,NULL,NULL,'SDSS J091644.11+404838.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,139.183833,40.81075,0,NULL,64267200661,1004175010,15690234,17.8),(60518,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60518,35.41,0.16,121,20261,70,NULL,NULL,'CGCG 091-045',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000107,NULL,'15.2g',0.43,NULL,'Group member of poor cluster',NULL,NULL,NULL,1,139.186417,19.83811,0.081,NULL,63707901468,995435960,15553686,15.2),(60519,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60519,37.82,0.46,366,20262,70,NULL,NULL,'2MASX J09164511+1339521',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,139.188,13.66458,0.089,NULL,63868418332,997944036,15592875,18),(60520,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60520,37.62,0.46,335,20263,70,NULL,NULL,'2MASX J09164520+3913024',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000176,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,139.1885417,39.21736,0,NULL,64397971031,1006218297,15722160,17.2),(60521,'Tully est','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60521,32.66,0.8,34,20264,75,NULL,'B','UGCA 154',NULL,'1988NBGC.C....0000T',1988,1,0.54,NULL,'G',0.000007,NULL,'15.1g',0.34,'Pec',NULL,NULL,NULL,NULL,1,139.1897083,53.44297,0.033,NULL,63958022346,999344099,15614751,15.1),(60522,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60522,37.55,0.23,323,20265,70,NULL,NULL,'2MASX J09164567+0658417',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,139.1904583,6.97836,0.069,NULL,63645250403,994457037,15538391,16.4),(60523,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60523,37.35,0.33,295,20266,70,NULL,NULL,'2MASX J09164627+3303101',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000107,NULL,'16.4g',0.37,'AGN',NULL,NULL,NULL,NULL,1,139.192667,33.053,0,NULL,64407897721,1006373401,15724584,16.4),(60524,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60524,35.59,0.46,131,20267,70,NULL,NULL,'CGCG 209-043 NED01',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.00017,NULL,'14.8g',0.59,'E0',NULL,NULL,NULL,NULL,1,139.195041667,43.71258,0.005,NULL,64269513366,1004211146,15690799,14.8),(60525,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60525,39.18,0.46,687,20268,70,NULL,NULL,'SDSS J091647.05+611348.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,139.1960417,61.23025,0.125,NULL,62068620849,969822200,15153471,18.5),(60526,'Tully est','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60526,32.1,0.8,26.3,20269,75,NULL,'B','NGC 2793',NULL,'1988NBGC.C....0000T',1988,1,1.3,'Noted as possible pair in MCG.','G',0.000005,NULL,'13.58',1.1,'SB(s)m pec','in a radial-velocity based grouping',NULL,NULL,NULL,1,139.197125,34.42981,0,NULL,64399873955,1006248030,15722625,13.58),(60527,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60527,35.16,0.2,108,20270,74.4,NULL,NULL,'CGCG 062-014',NULL,'2013AJ....146...86T',2013,1,1.02,NULL,'G',0.000099,NULL,'15.7g',0.28,'Sc',NULL,NULL,NULL,NULL,1,139.198333,9.89133,0.121,NULL,63652409470,994568897,15540139,15.7),(60528,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60528,36.78,0.46,227,20271,70,NULL,NULL,'B2 0913+38',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'16.6g',0.3,NULL,NULL,NULL,'radio jet',NULL,1,139.1989583,38.30164,0,NULL,64406946257,1006358535,15724352,16.6),(60529,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60529,35.82,0.46,146,20272,70,NULL,NULL,'CGCG 238-026',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.000143,NULL,'14.4g',0.79,'E0',NULL,NULL,NULL,NULL,1,139.199167,49.78039,0,NULL,64233259539,1003644680,15681948,14.4),(60530,'IRAS','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60530,32.67,0.8,34.3,20273,75,NULL,'MAT, I','NGC 2821',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.00002,NULL,'13.84',0.4,'Sbc: sp        HII',NULL,NULL,NULL,NULL,1,139.199916667,-26.81628,0.625,NULL,42846378368,669474662,10460541,13.84),(60531,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60531,32.91,0.46,38.2,20273,NULL,NULL,'J','NGC 2821',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60532,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60532,32.92,0.47,38.3,20273,NULL,NULL,'H','NGC 2821',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60533,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60533,32.96,0.4,39,20273,NULL,NULL,'mean','NGC 2821',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60534,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60534,32.98,0.45,39.4,20273,NULL,NULL,'K','NGC 2821',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60535,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60535,33.05,0.4,40.7,20273,75,NULL,NULL,'NGC 2821',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60536,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60536,33.18,0.32,43.3,20273,85,NULL,'I, raw','NGC 2821',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60537,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60537,33.21,0.43,43.8,20273,75,NULL,'MAT, I, raw','NGC 2821',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60538,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60538,33.23,0.43,44.3,20273,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2821',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60539,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60539,33.24,0.32,44.4,20273,85,NULL,'I, inv','NGC 2821',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60540,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60540,33.3,0.49,45.7,20273,75,NULL,'IR','NGC 2821',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60541,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60541,33.34,0.43,46.5,20273,75,NULL,'3.6 micron, color corrected','NGC 2821',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60542,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60542,33.38,0.43,47.4,20273,75,NULL,'MAT, I, cor','NGC 2821',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60543,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60543,33.45,0.43,48.9,20273,75,NULL,'MAT, I, inv','NGC 2821',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60544,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60544,33.52,0.2,50.6,20273,74.4,NULL,NULL,'NGC 2821',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60545,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60545,33.76,0.51,56.5,20273,NULL,NULL,'Malmquist cor.','NGC 2821',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60546,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60546,33.78,0.5,57.1,20273,NULL,NULL,NULL,'NGC 2821',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60547,'IRAS','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60547,34.97,0.8,98.8,20274,75,NULL,'CF, r','UGC 04895',NULL,'1997ApJS..109..333W',1997,1,1.32,NULL,'G',0.00003,NULL,'14.5g',0.46,'Sb','Field galaxy',NULL,NULL,NULL,1,139.206083,27.48961,0.025,NULL,64205611088,1003212673,15675198,14.5),(60548,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60548,35.11,0.35,105,20274,NULL,NULL,'Malmquist cor.','UGC 04895',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60549,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60549,35.14,0.34,107,20274,NULL,NULL,NULL,'UGC 04895',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60550,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60550,35.16,0.38,108,20274,75,NULL,'CF, r, raw','UGC 04895',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60551,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60551,35.17,0.4,108,20274,NULL,NULL,'mean','UGC 04895',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60552,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60552,35.18,0.2,109,20274,74.4,NULL,NULL,'UGC 04895',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60553,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60553,35.3,0.47,115,20274,NULL,NULL,'H','UGC 04895',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60554,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60554,35.35,0.38,117,20274,75,NULL,'CF, r, cor','UGC 04895',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60555,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60555,35.35,0.38,117,20274,75,NULL,'CF, r, inv','UGC 04895',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60556,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60556,35.43,0.46,122,20274,NULL,NULL,'J','UGC 04895',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60557,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60557,35.43,0.45,122,20274,NULL,NULL,'K','UGC 04895',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60558,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60558,37.38,0.46,299,20275,70,NULL,NULL,'SDSS J091649.51+305717.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00006,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,139.2062917,30.95481,0.033,NULL,64198331053,1003098922,15673420,18.4),(60559,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60559,35.41,0.16,121,20276,70,NULL,NULL,'NGC 2804',NULL,'2015arXiv151105856S',2015,1,2.2,NULL,'G',0.000077,NULL,'13.8g',2,'S0','in a pair',NULL,NULL,NULL,1,139.208375,20.1985,0.077,NULL,63707988791,995437324,15553708,13.8),(60560,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60560,34.82,0.45,91.9,20276,NULL,NULL,'K','NGC 2804',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60561,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60561,35.45,0.4,123,20276,NULL,NULL,'mean','NGC 2804',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60562,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60562,37.57,0.46,327,20277,70,NULL,NULL,'2MASX J09165014+4444420',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000162,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,139.208875,44.745,0,NULL,64262840459,1004106882,15689170,16.8),(60563,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60563,35.58,0.46,130,20278,70,NULL,NULL,'CGCG 209-043 NED02',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'15.6g',0.39,NULL,NULL,NULL,NULL,NULL,1,139.2104583,43.71867,0.005,NULL,64269513308,1004211145,15690799,15.6),(60564,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60564,38.54,0.46,510,20279,70,NULL,NULL,'2MASX J09165099+3712064',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,139.2125,37.20175,0,NULL,64404565676,1006321338,15723770,18.3),(60565,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60565,35.54,0.27,128,20280,70,NULL,NULL,'CGCG 091-049',NULL,'2015arXiv151105856S',2015,1,0.93,NULL,'G',0.000013,NULL,'14.7g',0.64,NULL,NULL,NULL,NULL,NULL,1,139.222875,17.45758,0.061,NULL,63858637402,997791209,15590487,14.7),(60566,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60566,36.78,0.33,227,20281,70,NULL,NULL,'2MASX J09165362+3848194',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000172,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,139.2235,38.80542,0,NULL,64397792082,1006215501,15722117,16.3),(60567,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60567,38.28,0.46,453,20282,70,NULL,NULL,'SDSS J091656.34+001709.4',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000089,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,139.2347917,0.28597,0.041,NULL,60674053216,948032081,14813001,17.8),(60568,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60568,37.33,0.46,292,20283,70,NULL,NULL,'2MASX J09165675+0307342',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000171,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,139.2365,3.12603,0.041,NULL,60677503592,948085993,14813843,17.8),(60569,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60569,38.45,0.46,489,20284,70,NULL,NULL,'2MASX J09165688+0639576',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000166,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,139.237083,6.666,0.081,NULL,63644590695,994446729,15538230,18.4),(60570,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60570,36.84,0.46,233,20285,70,NULL,NULL,'2MASX J09165697+2518161',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000184,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,139.237416667,25.30442,0.081,NULL,64190720602,1002980009,15671562,16.8),(60571,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60571,37.92,0.27,383,20286,70,NULL,NULL,'2MASX J09165812+1508091',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,139.242125,15.13594,0.101,NULL,63870304999,997973515,15593336,17.5),(60572,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60572,37.75,0.68,355,20287,70,NULL,NULL,'2MASX J09170045-0809194',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,139.251875,-8.15547,0.109,NULL,42186282413,659160662,10299385,15.7),(60573,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60573,35.96,0.46,156,20288,70,NULL,NULL,'2MASX J09170165+4148114',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000185,NULL,'16.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,139.257,41.80333,0,NULL,64266494745,1004163980,15690062,16.2),(60574,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60574,36.78,0.33,227,20289,70,NULL,NULL,'2MASX J09170218+3849234',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000203,NULL,'16.2g',0.36,'E0',NULL,NULL,NULL,NULL,1,139.258875,38.82319,0,NULL,64398008616,1006218884,15722170,16.2),(60575,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60575,37.46,0.33,310,20290,70,NULL,NULL,'2MASX J09170641+6144030',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,139.27675,61.73411,0.141,NULL,62030626063,969228532,15144195,17.6),(60576,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60576,35.41,0.16,121,20291,70,NULL,NULL,'NGC 2809',NULL,'2015arXiv151105856S',2015,1,1.14,'Incorrectly called NGC 2806 in 1980ApJ...235...347S.','G',0.000087,NULL,'13.9g',1.04,'S0','in a pair',NULL,NULL,NULL,1,139.278833,20.06969,0.077,NULL,63707974344,995437099,15553704,13.9),(60577,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60577,37.13,0.46,267,20292,70,NULL,NULL,'2MASX J09170714+3107342',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000182,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,139.27975,31.12617,0.021,NULL,64198499010,1003101547,15673461,16.2),(60578,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60578,37.3,0.46,288,20293,70,NULL,NULL,'SDSS J091708.18+222638.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000159,NULL,'18.7g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,139.284125,22.44414,0.149,NULL,63719229893,995612967,15556452,18.7),(60579,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60579,38,0.19,398,20294,70,NULL,NULL,'SDSS J091709.61+401626.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,139.290083333,40.27394,0.005,NULL,64267026842,1004172294,15690192,18.4),(60580,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60580,36.55,0.46,204,20295,70,NULL,NULL,'MCG +05-22-034',NULL,'2015arXiv151105856S',2015,1,0.64,'HOLM 119B is a star.','G',0.000192,NULL,'15.8g',0.4,NULL,NULL,NULL,NULL,NULL,1,139.29025,27.34806,0.041,NULL,64205608666,1003212635,15675197,15.8),(60581,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60581,37.68,0.46,343,20296,70,NULL,NULL,'2MASX J09171024+4021015',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000187,NULL,'17.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,139.292791667,40.35047,0.005,NULL,64267041376,1004172521,15690195,17.4),(60582,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60582,35.7,0.23,138,20297,70,NULL,NULL,'2MASX J09171042+1711278',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000077,NULL,'16.0g',0.43,NULL,NULL,NULL,NULL,NULL,1,139.293375,17.19106,0.073,NULL,63858617675,997790901,15590482,16),(60583,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60583,37.08,0.46,260,20298,70,NULL,NULL,'2MASX J09171149+5406200',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000088,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,139.297917,54.10564,0.009,NULL,63957202481,999331288,15614551,16.5),(60584,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60584,37.1,0.46,263,20299,70,NULL,NULL,'2MASX J09171174+5041041',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,139.299125,50.68453,0,NULL,63961245952,999394468,15615538,17.5),(60585,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60585,35.86,0.54,149,20300,70,NULL,NULL,'2MASX J09171240-1430021',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.87',NULL,NULL,NULL,NULL,NULL,NULL,1,139.30175,-14.50078,0.141,NULL,42379203192,662175049,10346485,15.87),(60586,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60586,36.95,0.46,246,20301,70,NULL,NULL,'2MASX J09171312+0631506',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,139.304625,6.53089,0.041,NULL,63644586316,994446661,15538229,17.8),(60587,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60587,38.03,0.46,404,20302,70,NULL,NULL,'2MASX J09171400+2802536',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000166,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,139.3084583,28.04833,0.017,NULL,64205949299,1003217957,15675280,17.5),(60588,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60588,37.01,0.46,252,20303,70,NULL,NULL,'2MASX J09171408+3754385',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,139.308667,37.91072,0,NULL,64404109283,1006314207,15723659,17.7),(60589,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60589,35.54,0.33,128,20304,70,NULL,NULL,'CGCG 238-030',NULL,'2015arXiv151105856S',2015,1,0.91,NULL,'G',0.00016,NULL,'14.7g',0.61,'E0',NULL,NULL,NULL,NULL,1,139.308875,44.48922,0.005,NULL,64262856631,1004107134,15689173,14.7),(60590,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60590,37.1,0.46,263,20305,70,NULL,NULL,'2MASX J09171689+2239181',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,139.3205,22.655,0.145,NULL,63719275976,995613687,15556463,17.1),(60591,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60591,35.41,0.16,121,20306,70,NULL,NULL,'2MASX J09171742+2002431',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000077,NULL,'16.1g',0.33,NULL,NULL,NULL,NULL,NULL,1,139.3227083,20.04528,0.081,NULL,63707973252,995437082,15553704,16.1),(60592,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60592,36.26,0.46,178,20307,70,NULL,NULL,'2MASX J09171769+0641516',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000172,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,139.323625,6.69767,0.081,NULL,63644570758,994446418,15538225,16.2),(60593,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60593,35.71,0.46,139,20308,70,NULL,NULL,'2MASX J09171966+1137436',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',NULL,NULL,'16.55',0.46,NULL,NULL,NULL,NULL,NULL,1,139.331875,11.62869,0.045,NULL,63650859016,994544672,15539760,16.55),(60594,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60594,37.88,0.46,377,20309,70,NULL,NULL,'2MASX J09172015-0024411',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000088,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,139.3337917,-0.41142,0.089,NULL,41082929738,641920777,10030012,17.3),(60595,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60595,37.09,0.46,261,20310,70,NULL,NULL,'2MASX J09172039+3807216',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000183,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,139.334917,38.12272,0,NULL,64406949993,1006358593,15724353,17.6),(60596,'Tully est','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60596,32.16,0.8,27.1,20311,75,NULL,'B','NGC 2798',NULL,'1988NBGC.C....0000T',1988,1,2.6,NULL,'G',0.00004,NULL,'13.04',1,'SB(s)a pec     HII','Possible field galaxy',NULL,NULL,NULL,1,139.344958333,41.99972,0.005,NULL,64268272172,1004191752,15690496,13.04),(60597,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60597,31.47,NULL,19.7,20311,65.2,NULL,'CO','NGC 2798',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60598,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60598,31.76,0.45,22.5,20311,NULL,NULL,'K','NGC 2798',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60599,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60599,31.87,0.47,23.7,20311,NULL,NULL,'H','NGC 2798',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60600,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60600,31.97,0.46,24.8,20311,NULL,NULL,'J','NGC 2798',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60601,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60601,32.4,0.4,30.2,20311,NULL,NULL,'mean','NGC 2798',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60602,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60602,32.82,NULL,36.6,20311,54,NULL,'HI','NGC 2798',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60603,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60603,35.25,0.15,112,20312,70,NULL,NULL,'IC 2456',NULL,'2015arXiv151105856S',2015,1,0.5,'The identification as IC 2456 is not certain.','G',0.00008,NULL,'15.6g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,139.351,34.67439,0,NULL,64402814574,1006293977,15723343,15.6),(60604,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60604,37.37,0.46,298,20313,70,NULL,NULL,'2MASX J09172433+3742236',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000176,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,139.3514583,37.70658,0,NULL,64404285162,1006316955,15723702,17.6),(60605,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60605,38.12,0.46,420,20314,70,NULL,NULL,'SDSS J091724.51+061324.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,139.352125,6.22353,0.093,NULL,63644384285,994443504,15538179,18.2),(60606,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60606,37.07,0.46,260,20315,70,NULL,NULL,'2MASX J09172507+5316431',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000077,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,139.354417,53.27878,0.033,NULL,63958123960,999345686,15614776,17.1),(60607,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60607,37.92,0.27,383,20316,70,NULL,NULL,'2MASX J09172516+1512118',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000183,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,139.3549583,15.20328,0.101,NULL,63870106985,997970421,15593287,17.2),(60608,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60608,37.93,0.46,385,20317,70,NULL,NULL,'2MASX J09172522+2046001',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,139.355083333,20.76667,0.105,NULL,63711249096,995488267,15554504,17.4),(60609,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60609,37.84,0.46,371,20318,70,NULL,NULL,'2MASX J09172556+3700076',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000155,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,139.356583,37.00225,0,NULL,64404539343,1006320927,15723764,17.1),(60610,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60610,36.93,0.46,243,20319,70,NULL,NULL,'2MASX J09172578+0117179',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000089,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,139.357416667,1.28833,0.057,NULL,60673932958,948030202,14812971,16.5),(60611,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60611,38.27,0.46,451,20320,70,NULL,NULL,'SDSS J091725.95+035539.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,139.358166667,3.92764,0.097,NULL,60677289213,948082643,14813791,18.2),(60612,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60612,37.46,0.33,310,20321,70,NULL,NULL,'2MASX J09172739+6143549',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,139.3642083,61.73197,0.141,NULL,62030616907,969228389,15144193,18.4),(60613,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60613,36.79,0.46,228,20322,70,NULL,NULL,'2MASX J09172756+1352388',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,139.364833,13.87736,0.109,NULL,63868374086,997943345,15592864,17.1),(60614,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60614,36.97,0.46,248,20323,70,NULL,NULL,'2MASX J09172825+2454557',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000147,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,139.36775,24.91558,0.085,NULL,63705234910,995394295,15553035,17.4),(60615,'IRAS','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60615,34.19,0.8,68.9,20324,75,NULL,'HMCL, I','UGC 04915',NULL,'1997ApJS..109..333W',1997,1,1.34,NULL,'G',0.000013,NULL,'15.0g',0.31,'Scd(f)         HII',NULL,NULL,NULL,NULL,1,139.370833,-0.62058,0.105,NULL,41082892619,641920197,10030003,15),(60616,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60616,34.27,0.4,71.4,20324,75,NULL,'HMCL, I, raw','UGC 04915',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60617,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60617,34.39,0.4,75.5,20324,75,NULL,'HMCL, I, inv','UGC 04915',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60618,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60618,34.58,0.4,82.4,20324,75,NULL,'HMCL, I, cor','UGC 04915',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60619,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60619,34.97,0.49,98.5,20324,75,NULL,'IR','UGC 04915',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60620,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60620,36.85,0.46,234,20325,70,NULL,NULL,'2MASX J09172940+0318589',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000187,NULL,'15.7g',0.45,'E0',NULL,NULL,NULL,NULL,1,139.3725,3.31633,0.093,NULL,60677813864,948090841,14813919,15.7),(60621,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60621,38,0.19,398,20326,70,NULL,NULL,'2MASX J09172948+4018556',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,139.373167,40.31553,0.005,NULL,64266308431,1004161069,15690016,17.9),(60622,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60622,37.3,0.46,289,20327,70,NULL,NULL,'2MASX J09173009+1531318',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,139.375333,15.52564,0.081,NULL,63867193337,997924895,15592576,17.2),(60623,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60623,35.41,0.16,121,20328,70,NULL,NULL,'2MASX J09173062+2010591',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00007,NULL,'16.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,139.3775417,20.18328,0.077,NULL,63707995417,995437428,15553709,16.4),(60624,'Tully est','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60624,32.09,0.8,26.2,20329,75,NULL,NULL,'ESO 091- G 007',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.00003,NULL,'13.82',1,'SB(rs)c',NULL,NULL,NULL,NULL,1,139.378291667,-62.88286,NULL,NULL,40579776450,634059007,9907171,13.82),(60625,'Tully est','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60625,32.19,0.8,27.4,20330,75,NULL,'B','NGC 2799',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000013,NULL,'14.32',0.5,'SB(s)m?        HII','Pair member, near/close',NULL,NULL,NULL,1,139.379291667,41.99408,0.005,NULL,64266436979,1004163077,15690048,14.32),(60626,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60626,38,0.19,398,20331,70,NULL,NULL,'2MASX J09173114+4030356',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,139.379833,40.50994,0,NULL,64267087481,1004173241,15690206,17.5),(60627,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60627,38.28,0.46,453,20332,70,NULL,NULL,'SDSS J091731.40+002541.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000072,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,139.380833,0.42822,0.041,NULL,60674256099,948035251,14813050,18),(60628,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60628,37.35,0.33,295,20333,70,NULL,NULL,'2MASX J09173313+3308253',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000087,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,139.387875,33.14042,0,NULL,64407815417,1006372115,15724564,16.6),(60629,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60629,37.64,0.46,338,20334,70,NULL,NULL,'2MASX J09173357+1701138',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,139.3900417,17.02058,0.061,NULL,63862091456,997845179,15591330,17.3),(60630,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60630,35.58,0.33,131,20335,70,NULL,NULL,'CGCG 091-056',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.000097,NULL,'14.9g',0.5,NULL,NULL,NULL,NULL,NULL,1,139.39225,18.95225,0.101,NULL,63828976403,997327756,15583246,14.9),(60631,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60631,37.91,0.46,382,20336,70,NULL,NULL,'2MASX J09173479+1151186',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,139.394833,11.85517,0.049,NULL,63650910194,994545471,15539772,17),(60632,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60632,35.4,0.46,120,20337,70,NULL,NULL,'2MASX J09173494-0034571',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000079,NULL,'16.2g',0.33,'S0^-',NULL,NULL,NULL,NULL,1,139.3955417,-0.58267,0.089,NULL,41082885836,641920091,10030001,16.2),(60633,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60633,38,0.19,398,20338,70,NULL,NULL,'2MASX J09173491+4020116',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,'PRED','17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,139.395625,40.33669,0.005,NULL,64266319704,1004161245,15690019,17),(60634,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60634,37.86,0.46,373,20339,70,NULL,NULL,'2MASX J09173511+0019309',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000111,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,139.3964583,0.32514,0.041,NULL,60674047183,948031987,14812999,17.2),(60635,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60635,38.26,0.46,448,20340,70,NULL,NULL,'2MASX J09173568+0327489',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,139.3987917,3.46372,0.093,NULL,60677890892,948092045,14813938,18),(60636,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60636,38,0.19,398,20341,70,NULL,NULL,'SDSS J091736.37+402017.1',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000172,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,139.401583,40.33808,0.005,NULL,64266319738,1004161245,15690019,17.6),(60637,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60637,37.75,0.33,355,20342,70,NULL,NULL,'2MASX J09173672+3959456',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,139.402917,39.99611,0,NULL,64398172368,1006221443,15722210,18),(60638,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60638,35.7,0.23,138,20343,70,NULL,NULL,'2MASX J09173732+1558215',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,139.405375,15.9725,0.069,NULL,63861643584,997838181,15591221,16.2),(60639,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60639,36.67,0.79,216,20344,70,NULL,NULL,'2MASX J09173752-0834105',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,139.4062917,-8.56961,0.093,NULL,42185471517,659147992,10299187,14.6),(60640,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60640,37.2,0.46,275,20345,70,NULL,NULL,'2MASX J09173768+0813476',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000176,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,139.407,8.22989,0.101,NULL,63648552528,994508633,15539197,16.4),(60641,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60641,35.7,0.23,138,20346,70,NULL,NULL,'CGCG 091-059',NULL,'2015arXiv151105856S',2015,1,0.97,NULL,'G',0.000183,NULL,'14.5g',0.65,NULL,NULL,NULL,NULL,NULL,1,139.409708333,16.4405,0.065,NULL,63862307008,997848547,15591383,14.5),(60642,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60642,37.77,0.46,358,20347,70,NULL,NULL,'2MASX J09173856+1902031',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,139.410666667,19.03431,0.101,NULL,63707323861,995426935,15553545,17.7),(60643,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60643,34.45,0.49,77.6,20348,75,NULL,'IR','MCG -01-24-007',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.000023,NULL,'15',0.2,'S?',NULL,NULL,NULL,NULL,1,139.413667,-7.90769,0.109,NULL,42186103514,659157867,10299341,15),(60644,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60644,34.62,0.42,83.8,20348,NULL,NULL,'Malmquist cor.','MCG -01-24-007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60645,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60645,34.76,0.2,89.5,20348,74.4,NULL,NULL,'MCG -01-24-007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60646,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60646,34.86,0.37,93.7,20348,NULL,NULL,NULL,'MCG -01-24-007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60647,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60647,32.44,0.77,30.7,20349,NULL,NULL,'Malmquist cor.','UGC 04906',NULL,'2009ApJS..182..474S',2009,1,1.48,NULL,'G',0.000082,NULL,'13.3g',0.68,'Sa             NLAGN','Group member',NULL,NULL,'Sy 2',1,139.416333333,52.99292,0.009,NULL,63957936230,999342753,15614730,13.3),(60648,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60648,32.72,0.47,35,20349,NULL,NULL,'H','UGC 04906',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60649,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60649,32.75,0.45,35.5,20349,NULL,NULL,'K','UGC 04906',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60650,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60650,32.79,0.66,36.1,20349,NULL,NULL,NULL,'UGC 04906',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60651,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60651,32.79,0.4,36.1,20349,75,NULL,NULL,'UGC 04906',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60652,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60652,32.81,0.46,36.5,20349,NULL,NULL,'J','UGC 04906',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60653,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60653,32.82,0.2,36.6,20349,74.4,NULL,NULL,'UGC 04906',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60654,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60654,32.87,0.4,37.6,20349,NULL,NULL,'mean','UGC 04906',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60655,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60655,33.24,0.49,44.4,20349,75,NULL,'IR','UGC 04906',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60656,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60656,36.87,0.46,236,20350,70,NULL,NULL,'2MASX J09174105+0923486',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000158,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,139.421125,9.39678,0.105,NULL,63652238953,994566233,15540097,16.7),(60657,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60657,38.07,0.46,412,20351,70,NULL,NULL,'SDSS J091744.04+584942.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000073,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,139.4335417,58.82847,0.093,NULL,62016646272,969010098,15140782,18.3),(60658,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60658,38.59,0.46,522,20352,70,NULL,NULL,'2MASX J09174460+3132274',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000209,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,139.4359583,31.54086,0,NULL,64198417426,1003100272,15673441,17.5),(60659,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60659,35.41,0.16,121,20353,70,NULL,NULL,'NGC 2813',NULL,'2015arXiv151105856S',2015,1,0.96,NULL,'G',0.000093,NULL,'14.6g',0.67,'S0','Group member of poor cluster',NULL,NULL,NULL,1,139.439375,19.90661,0.081,NULL,63708315647,995442431,15553787,14.6),(60660,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60660,37.41,0.46,303,20354,70,NULL,NULL,'2MASX J09174632+1527515',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,139.443125,15.46439,0.081,NULL,63870076897,997969951,15593280,17.6),(60661,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60661,35.86,0.46,149,20355,70,NULL,NULL,'2MASX J09174660+1901141',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000163,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,139.4442917,19.02061,0.101,NULL,63707320683,995426885,15553545,16.3),(60662,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60662,38,0.19,398,20356,70,NULL,NULL,'SDSS J091746.90+403104.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,139.4454583,40.51803,0,NULL,64267054442,1004172725,15690198,18.3),(60663,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60663,37.66,0.46,340,20357,70,NULL,NULL,'2MASX J09174729+1023456',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,139.446875,10.39611,0.137,NULL,63652671254,994572988,15540202,17.7),(60664,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60664,36.93,0.46,243,20358,70,NULL,NULL,'2MASX J09174811+0722326',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000174,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,139.4505417,7.37586,0.085,NULL,63645193341,994456145,15538377,16.6),(60665,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60665,37.09,0.46,262,20359,70,NULL,NULL,'2MASX J09174852+4934349',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000167,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,139.452166667,49.57639,0.013,NULL,64233385562,1003646649,15681978,16.7),(60666,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60666,34.99,0.47,99.7,20360,70,NULL,NULL,'2MASX J09174864-6511054',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000127,NULL,'14.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,139.452791667,-65.18489,0.649,NULL,40757770326,636840161,9950627,14.5),(60667,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60667,36.18,0.33,172,20361,70,NULL,NULL,'2MASX J09175017+3355514',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000093,NULL,'16.2g',0.42,'S0','Group member',NULL,NULL,NULL,1,139.459125,33.93092,0,NULL,64399973542,1006249586,15722649,16.2),(60668,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60668,35.73,0.63,140,20362,70,NULL,NULL,'2MASX J09175040-3226067',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,139.459917,-32.43522,0.993,NULL,42907954654,670436791,10475574,14.5),(60669,'IRAS','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60669,34.32,0.8,73,20363,75,NULL,'HMCL, I','IC 0531',NULL,'1997ApJS..109..333W',1997,1,1.07,NULL,'G',0.000027,NULL,'14.6g',0.45,'(R\')SB(rs)ab?  HII',NULL,NULL,NULL,NULL,1,139.461708333,-0.27847,0.073,NULL,41079307303,641864176,10029127,14.6),(60670,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60670,33.95,0.47,61.8,20363,NULL,NULL,NULL,'IC 0531',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60671,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60671,34.01,0.4,63.5,20363,75,NULL,'HMCL, I, raw','IC 0531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60672,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60672,34.02,0.46,63.7,20363,NULL,NULL,'Malmquist cor.','IC 0531',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60673,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60673,34.15,0.2,67.6,20363,74.4,NULL,NULL,'IC 0531',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60674,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60674,34.17,0.4,68.2,20363,75,NULL,'HMCL, I, inv','IC 0531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60675,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60675,34.33,0.4,73.5,20363,75,NULL,'HMCL, I, cor','IC 0531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60676,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60676,34.59,0.4,82.7,20363,NULL,NULL,'mean','IC 0531',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60677,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60677,34.65,0.47,85.1,20363,NULL,NULL,'H','IC 0531',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60678,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60678,34.74,0.45,88.7,20363,NULL,NULL,'K','IC 0531',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60679,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60679,34.88,0.46,94.8,20363,NULL,NULL,'J','IC 0531',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60680,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60680,38.25,0.33,447,20364,70,NULL,NULL,'2MASX J09175087+1643485',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000176,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,139.462125,16.73025,0.049,NULL,63862448899,997850764,15591418,18),(60681,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60681,37.37,0.46,298,20365,70,NULL,NULL,'2MASX J09175123+1040366',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000139,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,139.463417,10.67697,0.093,NULL,63651775606,994558993,15539984,17.1),(60682,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60682,36.18,0.33,172,20366,70,NULL,NULL,'2MASX J09175162+3358274',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000073,NULL,'15.5g',0.54,'E0','Group member',NULL,NULL,NULL,1,139.465,33.97433,0,NULL,64399979152,1006249674,15722651,15.5),(60683,'Ring Diameter','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60683,31,0.84,16,20367,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 2835',NULL,'1981ApJS...45..541P',1981,1,6.6,'Extended HIPASS source','G',0.000007,NULL,'11.01',4.4,'SAB(rs)c       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,139.4704583,-22.35467,0.409,NULL,42328422498,661381601,10334087,11.01),(60684,'IRAS','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60684,30.36,0.8,11.8,20367,75,NULL,'MAT, I','NGC 2835',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60685,'IRAS','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60685,30.39,0.8,12,20367,75,NULL,'A82, H','NGC 2835',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60686,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60686,29.32,0.32,7.27,20367,85,NULL,'I, raw','NGC 2835',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60687,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60687,29.32,0.32,7.28,20367,85,NULL,'I, inv','NGC 2835',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60688,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60688,29.53,0.38,8.05,20367,NULL,NULL,NULL,'NGC 2835',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60689,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60689,29.54,0.39,8.1,20367,73,NULL,'opt','NGC 2835',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60690,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60690,29.56,0.43,8.16,20367,75,NULL,'MAT, I, raw','NGC 2835',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60691,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60691,29.62,0.43,8.39,20367,75,NULL,'MAT, I, inv','NGC 2835',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60692,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60692,29.67,NULL,8.6,20367,NULL,NULL,'I','NGC 2835',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60693,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60693,29.67,0.4,8.6,20367,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 2835',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60694,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60694,29.71,0.2,8.75,20367,74.4,NULL,NULL,'NGC 2835',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60695,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60695,29.82,0.43,9.2,20367,75,NULL,'MAT, I, cor','NGC 2835',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60696,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60696,29.95,0.54,9.76,20367,NULL,NULL,'Malmquist cor.','NGC 2835',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60697,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60697,29.95,NULL,9.77,20367,NULL,NULL,'B','NGC 2835',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60698,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60698,30.02,0.52,10.1,20367,NULL,NULL,NULL,'NGC 2835',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60699,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60699,30.04,NULL,10.2,20367,NULL,NULL,'B','NGC 2835',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60700,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60700,30.06,NULL,10.3,20367,NULL,NULL,NULL,'NGC 2835',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60701,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60701,30.16,0.4,10.8,20367,75,NULL,'B','NGC 2835',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60702,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60702,30.19,0.47,10.9,20367,75,NULL,'A82, H, raw','NGC 2835',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60703,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60703,30.19,0.47,10.9,20367,75,NULL,'A82, H, inv','NGC 2835',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60704,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60704,30.37,NULL,11.9,20367,NULL,NULL,'LEDA [Nov 2006]','NGC 2835',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60705,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60705,30.39,0.47,12,20367,NULL,NULL,'H','NGC 2835',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60706,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60706,30.4,0.46,12,20367,NULL,NULL,'J','NGC 2835',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60707,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60707,30.44,0.45,12.3,20367,NULL,NULL,'K','NGC 2835',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60708,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60708,30.51,0.47,12.7,20367,75,NULL,'A82, H, cor','NGC 2835',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60709,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60709,31.21,0.4,17.4,20367,NULL,NULL,'mean','NGC 2835',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60710,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60710,36.86,0.46,236,20368,70,NULL,NULL,'2MASX J09175425+1331454',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.79',0.27,NULL,NULL,NULL,NULL,NULL,1,139.476083,13.52931,0.085,NULL,63868543439,997945991,15592906,17.79),(60711,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60711,37.38,0.46,299,20369,70,NULL,NULL,'2MASX J09175455+4421255',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,139.4775,44.35708,0,NULL,64262970557,1004108914,15689201,17.6),(60712,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60712,35.58,0.33,131,20370,70,NULL,NULL,'2MASX J09175463+1901231',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,139.477667,19.02306,0.101,NULL,63707340070,995427188,15553549,17),(60713,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60713,36.74,0.15,223,20371,70,NULL,NULL,'2MASX J09175519+5439194',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000094,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,139.47975,54.65536,0.045,NULL,61876019222,966812800,15106450,16.6),(60714,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60714,35.15,0.33,107,20372,70,NULL,NULL,'CGCG 151-052',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.00007,NULL,'14.7g',0.48,NULL,NULL,NULL,NULL,NULL,1,139.481,27.7355,0.025,NULL,64206236570,1003222446,15675350,14.7),(60715,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60715,38.19,0.27,434,20373,70,NULL,NULL,'SDSS J091755.44+072059.9',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,139.4810417,7.34997,0.085,NULL,63645203786,994456309,15538379,17.4),(60716,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60716,35.76,0.46,142,20374,70,NULL,NULL,'2MASX J09175584+4733525',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000169,NULL,'15.7g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,139.482541667,47.56475,0.009,NULL,64232216320,1003628380,15681693,15.7),(60717,'SZ effect','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60717,39.96,0.35,980,20375,NULL,NULL,'Hydrost. Eq.','ABELL 0773',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III:[BM]',NULL,NULL,NULL,NULL,1,139.4974583,51.70642,0,NULL,63970308019,999536062,15617750,NULL),(60718,'SZ effect','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60718,40.81,NULL,1450,20375,NULL,NULL,NULL,'ABELL 0773',NULL,'2002ApJ...581...53R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60719,'SZ effect','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60719,40.83,NULL,1470,20375,NULL,NULL,NULL,'ABELL 0773',NULL,'2005ApJ...625..108D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60720,'SZ effect','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60720,40.89,0.49,1510,20375,NULL,NULL,'Isotherm.','ABELL 0773',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60721,'SZ effect','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60721,40.89,NULL,1510,20375,NULL,NULL,'3.1 (red) calibration','ABELL 0773',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60722,'SZ effect','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60722,40.91,NULL,1520,20375,NULL,NULL,'4.2 (black) calibration','ABELL 0773',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60723,'SZ effect','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60723,40.97,0.46,1560,20375,NULL,NULL,'Isotherm., r < 100 kpc','ABELL 0773',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60724,'SZ effect','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60724,41.24,NULL,1770,20375,NULL,NULL,'4.1 (blue) calibration','ABELL 0773',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60725,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60725,37.82,0.46,366,20376,70,NULL,NULL,'2MASX J09180066+5730264',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000074,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,139.5027917,57.5075,0.089,NULL,62014950637,968983603,15140368,17.5),(60726,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60726,35.25,0.69,112,20377,70,NULL,NULL,'ESO 433- G 011',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.00015,NULL,'13.7I',1.4,'Sa',NULL,NULL,NULL,NULL,1,139.507541667,-31.30958,0.933,NULL,42837069069,669329204,10458268,13.7),(60727,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60727,38.52,0.33,506,20378,70,NULL,NULL,'2MASX J09180191+5353069',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00009,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,139.507917,53.88528,0.009,NULL,63957696097,999339001,15614671,17.8),(60728,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60728,38.19,0.27,434,20379,70,NULL,NULL,'SDSS J091801.98+072939.2',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000175,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,139.5082917,7.49425,0.085,NULL,63644701065,994448454,15538257,18),(60729,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60729,35.13,0.49,106,20380,75,NULL,'IR','UGC 04911',NULL,'2011yCatp016004901K',2011,1,1.12,'Multiple SDSS entries describe this source.','G',0.000105,NULL,'16.5',0.1,'Sd(f)',NULL,NULL,NULL,NULL,1,139.512417,54.19131,0.029,NULL,63957844162,999341315,15614708,16.5),(60730,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60730,35.15,NULL,107,20380,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04911',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60731,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60731,35.16,NULL,108,20380,NULL,NULL,'Dipole + Quadrupole','UGC 04911',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60732,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60732,35.18,NULL,109,20380,NULL,NULL,'Dipole','UGC 04911',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60733,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60733,35.2,NULL,109,20380,NULL,NULL,NULL,'UGC 04911',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60734,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60734,36.67,0.46,216,20381,70,NULL,NULL,'2MASX J09180384+0657229',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000189,NULL,'15.9g',0.39,'E0',NULL,NULL,NULL,NULL,1,139.516083,6.95631,0.089,NULL,63645332158,994458314,15538411,15.9),(60735,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60735,36.64,0.17,213,20382,70,NULL,NULL,'2MASX J09180414+5516463',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000083,NULL,'17.1g',0.23,'NLAGN',NULL,NULL,NULL,NULL,1,139.517125,55.27947,0.033,NULL,61875754568,966808665,15106385,17.1),(60736,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60736,38.52,0.33,506,20383,70,NULL,NULL,'2MASX J09180461+5352443',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000079,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,139.519167,53.87917,0.009,NULL,63957694202,999338971,15614671,18.2),(60737,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60737,34.2,0.43,69.2,20384,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J09180580-1548419',NULL,'2014MNRAS.444..527S',2014,1,0.8,NULL,'G',0.00004,NULL,'13.9I',0.4,'HII',NULL,NULL,NULL,NULL,1,139.52425,-15.81169,0.133,NULL,42374068735,662094823,10345231,13.9),(60738,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60738,38.73,0.46,558,20385,70,NULL,NULL,'SDSS J091805.89+001135.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000093,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,139.524583,0.19322,0.073,NULL,60671172662,947987072,14812298,18.4),(60739,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60739,35.64,0.46,135,20386,70,NULL,NULL,'2MASX J09180638+4929189',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00016,NULL,'15.7g',0.37,'E0',NULL,NULL,NULL,NULL,1,139.526833333,49.48853,0.013,NULL,64233196850,1003643700,15681932,15.7),(60740,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60740,37.15,0.33,269,20387,70,NULL,NULL,'2MASX J09180716+5757274',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000068,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,139.530166667,57.95775,0.105,NULL,62015394770,968990543,15140477,17.7),(60741,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60741,36.8,0.2,229,20388,74.4,NULL,NULL,'CGCG 062-017',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000822,NULL,'15.6',0.2,NULL,NULL,NULL,NULL,NULL,1,139.53075,9.77628,0.129,NULL,63652339959,994567811,15540122,15.6),(60742,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60742,36.72,0.46,221,20389,70,NULL,NULL,'SDSS J091807.52+343946.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.001,NULL,'17.3g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,139.531375,34.66278,0,NULL,64402783107,1006293486,15723335,17.3),(60743,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60743,38.25,0.33,447,20390,70,NULL,NULL,'2MASX J09180761+1648066',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00013,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,139.531667,16.80189,0.049,NULL,63862260195,997847815,15591372,16.8),(60744,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60744,37.62,0.46,334,20391,70,NULL,NULL,'2MASX J09180828+1553066',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,139.534583333,15.88519,0.073,NULL,63861446163,997835096,15591173,NULL),(60745,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60745,35.7,0.23,138,20392,70,NULL,NULL,'NGC 2819',NULL,'2015arXiv151105856S',2015,1,1.4,NULL,'G',0.000107,NULL,'13.78',1.3,'E',NULL,NULL,NULL,NULL,1,139.5387083,16.19811,0.069,NULL,63861630214,997837972,15591218,13.78),(60746,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60746,37.63,0.46,337,20393,70,NULL,NULL,'2MASX J09181246+1749486',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000171,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,139.5519583,17.83011,0.049,NULL,63859277679,997801213,15590643,17.9),(60747,'IRAS','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60747,33.94,0.8,61.5,20394,75,NULL,'MAT, I','ESO 564- G 036',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000017,NULL,'14.14',1.3,'SB(rs)c',NULL,NULL,NULL,NULL,1,139.552166667,-18.4435,0.209,NULL,42370911398,662045490,10344460,14.14),(60748,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60748,33.5,0.32,50.2,20394,85,NULL,'I, raw','ESO 564- G 036',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60749,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60749,33.54,0.32,51.1,20394,85,NULL,'I, inv','ESO 564- G 036',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60750,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60750,33.66,0.43,53.9,20394,75,NULL,'MAT, I, raw','ESO 564- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60751,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60751,33.84,0.43,58.5,20394,75,NULL,'MAT, I, inv','ESO 564- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60752,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60752,33.92,0.56,60.9,20394,NULL,NULL,NULL,'ESO 564- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60753,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60753,33.95,0.43,61.7,20394,75,NULL,'MAT, I, cor','ESO 564- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60754,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60754,33.96,0.2,61.9,20394,74.4,NULL,NULL,'ESO 564- G 036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60755,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60755,33.99,0.54,62.7,20394,NULL,NULL,'Malmquist cor.','ESO 564- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60756,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60756,35.88,0.46,150,20395,70,NULL,NULL,'2MASX J09181473+2337180',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000157,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,139.561541667,23.62164,0.149,NULL,63717050006,995578906,15555920,16.6),(60757,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60757,37.24,0.46,281,20396,70,NULL,NULL,'2MASX J09181569+5730544',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000084,NULL,'16.8g',0.23,'NLAGN',NULL,NULL,NULL,NULL,1,139.56525,57.51519,0.089,NULL,62014950780,968983605,15140368,16.8),(60758,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60758,36.64,0.17,213,20397,70,NULL,NULL,'CGCG 264-093',NULL,'2015arXiv151105856S',2015,1,0.69,'UGC identification as UGC 04913 and MCG +09-15-116 is incorrect.','G',0.000105,NULL,'15.6g',0.37,'S0',NULL,NULL,NULL,NULL,1,139.571125,55.68253,0.037,NULL,61877571564,966837055,15106828,15.6),(60759,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60759,38.16,0.46,428,20398,70,NULL,NULL,'2MASX J09181836+1141239',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,139.576667,11.68992,0.045,NULL,63650844315,994544442,15539756,17.1),(60760,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60760,33.17,NULL,43,20399,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04925',NULL,'2010Ap&SS.325..163P',2010,1,1.54,NULL,'G',0.000004,NULL,'15.8g',0.23,'Sc',NULL,NULL,NULL,NULL,1,139.5827083,17.75331,0.049,NULL,63859316313,997801817,15590653,15.8),(60761,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60761,33.18,NULL,43.2,20399,NULL,NULL,'Dipole + Quadrupole','UGC 04925',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60762,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60762,33.18,NULL,43.3,20399,NULL,NULL,'Dipole','UGC 04925',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60763,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60763,33.26,NULL,44.8,20399,NULL,NULL,NULL,'UGC 04925',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60764,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60764,33.76,0.2,56.5,20399,74.4,NULL,NULL,'UGC 04925',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60765,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60765,33.9,0.38,60.1,20399,NULL,NULL,'Malmquist cor.','UGC 04925',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60766,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60766,33.9,0.38,60.3,20399,NULL,NULL,NULL,'UGC 04925',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60767,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60767,35.61,0.46,133,20400,70,NULL,NULL,'2MASX J09181993+1136529',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.26',0.28,NULL,NULL,NULL,NULL,NULL,1,139.583125,11.61458,0.049,NULL,63650836698,994544323,15539755,17.26),(60768,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60768,37.16,0.46,271,20401,70,NULL,NULL,'SDSS J091820.18+641125.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,139.584125,64.19039,0.161,NULL,62255582447,972743475,15199116,18.4),(60769,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60769,37.86,0.33,373,20402,70,NULL,NULL,'2MASX J09182028+3026277',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00007,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,139.584375,30.44103,0.025,NULL,64201890554,1003154539,15674289,17.6),(60770,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60770,37.85,0.46,372,20403,70,NULL,NULL,'2MASX J09182036+5548524',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000074,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,139.58475,55.81469,0.037,NULL,61877034384,966828662,15106697,18.1),(60771,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60771,37.64,0.46,337,20404,70,NULL,NULL,'2MASX J09182058+2741491',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000145,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,139.585833,27.69706,0.025,NULL,64206233507,1003222398,15675349,17.8),(60772,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60772,37.15,0.33,269,20405,70,NULL,NULL,'2MASX J09182124+5751484',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000081,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,139.588333,57.86353,0.105,NULL,62015348297,968989817,15140465,17.5),(60773,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60773,33.93,0.47,61,20406,NULL,NULL,'H','UGC 04896',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.00003,NULL,'14.71',0.4,'Sab',NULL,NULL,NULL,NULL,1,139.596875,69.81122,0.121,NULL,62221653629,972213337,15190833,14.71),(60774,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60774,33.97,0.45,62.3,20406,NULL,NULL,'K','UGC 04896',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60775,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60775,34.03,0.46,63.9,20406,NULL,NULL,'J','UGC 04896',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60776,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60776,34.07,0.4,65.1,20406,NULL,NULL,'mean','UGC 04896',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60777,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60777,37.45,0.46,310,20407,70,NULL,NULL,'2MASX J09182330+1733066',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00014,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,139.5972083,17.55186,0.061,NULL,63859085871,997798216,15590597,16.8),(60778,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60778,37.07,0.46,260,20408,70,NULL,NULL,'2MASX J09182351+0139493',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000076,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,139.598041667,1.66369,0.065,NULL,60672451923,948007061,14812610,17.1),(60779,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60779,36.9,0.33,239,20409,70,NULL,NULL,'2MASX J09182352+3032357',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00007,NULL,'15.7g',0.51,NULL,NULL,NULL,NULL,NULL,1,139.598125,30.54319,0.025,NULL,64201859226,1003154050,15674282,15.7),(60780,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60780,35.37,0.33,119,20410,70,NULL,NULL,'2MASX J09182367+3922522',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000169,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,139.598625,39.38131,0,NULL,64398153152,1006221143,15722205,16.2),(60781,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60781,37.37,0.46,298,20411,70,NULL,NULL,'VII Zw 273',NULL,'2015arXiv151105856S',2015,1,0.43,'CGPG +1m RA error.','G',0.000089,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,139.5989583,59.01567,0.093,NULL,62013291293,968957676,15139963,16.5),(60782,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60782,37.75,0.33,355,20412,70,NULL,NULL,'2MASX J09182390+4003392',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000188,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,139.5995,40.06089,0,NULL,64397377378,1006209021,15722015,16.4),(60783,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60783,35.25,0.15,112,20413,70,NULL,NULL,'CGCG 181-009',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000067,NULL,'15.1g',0.57,'S0:','Group member',NULL,NULL,NULL,1,139.601,33.86753,0,NULL,64399995770,1006249933,15722655,15.1),(60784,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,NULL,60784,36.03,0.48,161,20414,70,NULL,NULL,'2MASX J09182493-0930450',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000107,NULL,'15.78',NULL,NULL,NULL,NULL,NULL,NULL,1,139.6037917,-9.5125,0.109,NULL,42192882614,659263790,10300996,15.78),(60785,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60785,37.7,0.46,346,20415,70,NULL,NULL,'SDSS J091824.92+591718.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000066,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,139.603833,59.2885,0.109,NULL,62067861415,969810334,15153286,18.5),(60786,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60786,37.84,0.46,370,20416,70,NULL,NULL,'2MASX J09182707+1128060',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000155,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,139.612833,11.46842,0.049,NULL,63651539399,994555303,15539926,17.4),(60787,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60787,35.73,0.49,140,20417,75,NULL,'IR','CGCG 121-054',NULL,'2011yCatp016004901K',2011,1,0.93,NULL,'G',0.000112,NULL,'15.9g',0.21,'Sc','Group member of poor cluster',NULL,NULL,NULL,1,139.614167,20.40675,0.073,NULL,63711085085,995485704,15554464,15.9),(60788,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60788,36.38,0.46,189,20418,70,NULL,NULL,'MCG +11-12-002',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,139.616333,65.07889,0.197,NULL,62255937774,972749027,15199203,16.4),(60789,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60789,36.9,0.33,239,20419,70,NULL,NULL,'2MASX J09182800+3020337',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00006,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,139.616875,30.34272,0.033,NULL,64201887618,1003154494,15674288,17.7),(60790,'FP','2016-12-15 15:14:28','2016-12-16 11:19:34','1',NULL,'R',60790,38.28,0.46,452,20420,70,NULL,NULL,'SDSS J091828.63+620433.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,139.619333,62.07611,0.137,NULL,62030725787,969230090,15144220,18.4),(60791,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60791,36.82,0.46,231,20421,70,NULL,NULL,'2MASX J09182953+4114332',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000176,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,139.623041667,41.24258,0,NULL,64266623014,1004165984,15690093,16.8),(60792,'IRAS','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60792,32.61,0.8,33.3,20422,75,NULL,'A82, H','IC 0529',NULL,'1997ApJS..109..333W',1997,1,3.6,NULL,'G',0.000017,NULL,'12.62',1.7,'SA(s)c:','in a pair',NULL,NULL,NULL,1,139.636666667,73.75933,0.029,NULL,61371490854,958929544,14983274,12.62),(60793,'IRAS','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60793,32.65,0.8,34,20422,75,NULL,'CF, r','IC 0529',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60794,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60794,32.01,0.4,25.2,20422,NULL,NULL,'Virgo cluster at 15.6 Mpc','IC 0529',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60795,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60795,32.22,0.38,27.8,20422,75,NULL,'CF, r, raw','IC 0529',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60796,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60796,32.31,0.36,29,20422,NULL,NULL,NULL,'IC 0529',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60797,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60797,32.32,0.38,29.1,20422,75,NULL,'CF, r, inv','IC 0529',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60798,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60798,32.33,0.43,29.2,20422,75,NULL,'3.6 micron, color corrected','IC 0529',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60799,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60799,32.37,0.43,29.9,20422,75,NULL,'3.6 micron, color + selection bias corrected','IC 0529',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60800,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60800,32.39,0.2,30.1,20422,74.4,NULL,NULL,'IC 0529',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60801,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60801,32.46,0.38,31.1,20422,75,NULL,'CF, r, cor','IC 0529',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60802,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60802,32.49,0.47,31.5,20422,NULL,NULL,'Malmquist cor.','IC 0529',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60803,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60803,32.66,0.47,34,20422,75,NULL,'A82, H, raw','IC 0529',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60804,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60804,32.67,0.43,34.2,20422,NULL,NULL,NULL,'IC 0529',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60805,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60805,32.71,0.4,34.8,20422,NULL,NULL,'mean','IC 0529',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60806,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60806,32.71,0.4,34.8,20422,75,NULL,'B','IC 0529',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60807,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60807,32.74,0.47,35.3,20422,75,NULL,'A82, H, inv','IC 0529',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60808,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60808,32.95,0.46,38.9,20422,NULL,NULL,'J','IC 0529',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60809,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60809,32.98,0.45,39.5,20422,NULL,NULL,'K','IC 0529',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60810,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60810,32.98,0.47,39.5,20422,NULL,NULL,'H','IC 0529',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60811,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60811,33.03,0.47,40.3,20422,75,NULL,'A82, H, cor','IC 0529',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60812,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60812,37.81,0.33,364,20423,70,NULL,NULL,'2MASX J09183328+1539466',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,139.638625,15.66286,0.081,NULL,63860911177,997826737,15591042,17.4),(60813,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60813,36.55,0.47,204,20424,NULL,NULL,'Malmquist cor.','2MASX J09183347+3420417',NULL,'2009ApJS..182..474S',2009,1,0.44,NULL,'G',0.000023,NULL,'16.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,139.6395417,34.34492,0,NULL,64400094201,1006251471,15722679,16.2),(60814,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60814,36.67,0.44,216,20424,NULL,NULL,NULL,'2MASX J09183347+3420417',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60815,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60815,36.72,0.2,221,20424,74.4,NULL,NULL,'2MASX J09183347+3420417',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60816,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60816,38.51,0.46,503,20425,70,NULL,NULL,'SDSS J091834.54+373556.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,139.643917,37.599,0,NULL,64404197618,1006315587,15723681,18.2),(60817,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60817,37.25,0.46,282,20426,70,NULL,NULL,'2MASX J09183495+2235214',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,139.645667,22.58933,0.145,NULL,63719287457,995613866,15556466,17.1),(60818,'IRAS','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60818,35.26,0.8,113,20427,75,NULL,'HMCL, I','CGCG 151-053',NULL,'1997ApJS..109..333W',1997,1,0.67,NULL,'G',0.00007,NULL,'15.5g',0.37,'SBc',NULL,NULL,NULL,NULL,1,139.64625,32.27,0,NULL,64378598302,1005915598,15717431,15.5),(60819,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60819,34.82,0.4,92.2,20427,75,NULL,'HMCL, I, raw','CGCG 151-053',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60820,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60820,34.96,0.4,98,20427,75,NULL,'HMCL, I, inv','CGCG 151-053',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60821,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60821,35.02,0.4,101,20427,75,NULL,'HMCL, I, cor','CGCG 151-053',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60822,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60822,35.2,0.4,110,20428,NULL,NULL,'mean','NGC 2800',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000103,NULL,'13.81',0.9,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,139.64675,52.51447,0.009,NULL,63969970189,999530784,15617668,13.81),(60823,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60823,35.34,0.45,117,20428,NULL,NULL,'K','NGC 2800',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60824,'IRAS','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60824,34.69,0.8,86.9,20429,75,NULL,'HMCL, I','UGC 04926',NULL,'1997ApJS..109..333W',1997,1,1.58,NULL,'G',0.00001,NULL,'14.6g',0.35,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,139.648417,34.55322,0,NULL,64402980913,1006296576,15723384,14.6),(60825,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60825,34.79,0.49,90.7,20429,75,NULL,'IR','UGC 04926',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60826,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60826,34.82,0.4,92,20429,75,NULL,'HMCL, I, raw','UGC 04926',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60827,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60827,34.91,0.4,95.8,20429,NULL,NULL,'mean','UGC 04926',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60828,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60828,34.94,0.47,97.4,20429,NULL,NULL,'H','UGC 04926',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60829,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60829,35.03,0.45,101,20429,NULL,NULL,'K','UGC 04926',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60830,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60830,35.03,0.4,101,20429,75,NULL,'HMCL, I, cor','UGC 04926',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60831,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60831,35.05,0.4,102,20429,75,NULL,'HMCL, I, inv','UGC 04926',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60832,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60832,35.06,0.46,103,20429,NULL,NULL,'J','UGC 04926',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60833,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60833,35.25,0.11,112,20429,NULL,NULL,NULL,'UGC 04926',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60834,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60834,37.86,0.33,373,20430,70,NULL,NULL,'SDSS J091835.74+302844.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.0001,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,139.6489583,30.47897,0.025,NULL,64201860472,1003154069,15674282,18.6),(60835,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60835,32.45,0.4,30.8,20431,75,NULL,'B','UGC 04922',NULL,'1988NBGC.C....0000T',1988,1,2.41,NULL,'G',0.00002,NULL,'14.8g',0.71,'SAm',NULL,NULL,NULL,NULL,1,139.6522083,47.87242,0.005,NULL,64232469811,1003632340,15681755,14.8),(60836,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60836,32.66,0.2,34,20431,74.4,NULL,NULL,'UGC 04922',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60837,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60837,32.68,0.4,34.4,20431,NULL,NULL,NULL,'UGC 04922',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60838,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60838,32.78,0.43,36,20431,75,NULL,'3.6 micron, color corrected','UGC 04922',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60839,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60839,32.92,0.43,38.4,20431,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04922',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60840,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60840,37.47,0.46,312,20432,70,NULL,NULL,'2MASX J09183673+1454035',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,139.6529583,14.90086,0.093,NULL,63870258872,997972794,15593324,18),(60841,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60841,38.01,0.46,400,20433,70,NULL,NULL,'2MASX J09183688+5118284',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00012,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,139.653875,51.30797,0.005,NULL,63969520435,999523756,15617558,17.6),(60842,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60842,36.7,0.33,219,20434,70,NULL,NULL,'VIII Zw 043',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000184,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,139.654583,9.67442,0.109,NULL,63652334801,994567731,15540120,16.4),(60843,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60843,37.92,0.27,383,20435,70,NULL,NULL,'2MASXi J0918378+145138',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,139.65775,14.86067,0.093,NULL,63870256710,997972761,15593324,17.8),(60844,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60844,38.19,0.27,434,20436,70,NULL,NULL,'SDSS J091838.12+072249.8',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.00015,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,139.658875,7.38053,0.085,NULL,63644728294,994448879,15538263,18.6),(60845,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60845,37.41,0.46,304,20437,70,NULL,NULL,'2MASX J09183925+4244014',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,139.6637083,42.73369,0,NULL,64269697207,1004214018,15690844,17.5),(60846,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60846,36.74,0.15,223,20438,70,NULL,NULL,'2MASX J09184151+5447044',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000069,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,139.6730417,54.78461,0.053,NULL,61876068392,966813568,15106462,17.4),(60847,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60847,37.38,0.46,299,20439,70,NULL,NULL,'SDSS J091842.83+031557.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000199,NULL,'17.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,139.6785,3.26586,0.077,NULL,60677153893,948080529,14813758,17.6),(60848,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60848,37.62,0.46,334,20440,70,NULL,NULL,'2MASX J09184341+0656200',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000206,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,139.680916667,6.93886,0.089,NULL,63645296980,994457765,15538402,16.5),(60849,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60849,37.1,0.46,262,20441,70,NULL,NULL,'2MASX J09184394+0633220',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,139.683125,6.55606,0.085,NULL,60704312089,948504876,14820388,16.9),(60850,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60850,37.06,0.46,258,20442,70,NULL,NULL,'2MASX J09184563+5345014',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00008,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,139.6902083,53.75036,0.017,NULL,63957656589,999338384,15614662,16.9),(60851,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60851,35.15,0.33,107,20443,70,NULL,NULL,'2MASX J09184636+2759481',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000158,NULL,'15.9g',0.33,NULL,NULL,NULL,NULL,NULL,1,139.6932083,27.99675,0.017,NULL,64205976663,1003218385,15675287,15.9),(60852,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60852,36,0.46,158,20444,70,NULL,NULL,'2MASX J09184750+5510073',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000087,NULL,'15.9g',0.39,'E0',NULL,NULL,NULL,NULL,1,139.6977917,55.16869,0.033,NULL,61876253248,966816457,15106507,15.9),(60853,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60853,37.81,0.33,364,20445,70,NULL,NULL,'2MASX J09184921+1544035',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,139.7050417,15.73431,0.081,NULL,63860955420,997827428,15591053,16.8),(60854,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60854,36.64,0.17,213,20446,70,NULL,NULL,'2MASX J09184943+5549273',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000069,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,139.706125,55.82408,0.037,NULL,61877048316,966828879,15106701,17.3),(60855,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60855,37.74,0.46,352,20447,70,NULL,NULL,'2MASX J09184981+4042412',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,139.7075,40.71139,0,NULL,64266257046,1004160266,15690004,17.6),(60856,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60856,35.41,0.16,121,20448,70,NULL,NULL,'CGCG 091-067',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.00009,NULL,'15.4g',0.5,NULL,'Group member of poor cluster',NULL,NULL,NULL,1,139.712583333,20.16644,0.037,NULL,63708078134,995438720,15553730,15.4),(60857,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60857,36.99,0.33,250,20449,70,NULL,NULL,'2MASX J09185134+1533125',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,139.714083,15.55353,0.081,NULL,63860904622,997826634,15591041,17.2),(60858,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60858,37.44,0.46,308,20450,70,NULL,NULL,'2MASX J09185174+1857294',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000185,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,139.715583,18.95831,0.097,NULL,63736696859,995885888,15560717,16.7),(60859,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60859,37.75,0.16,356,20451,70,NULL,NULL,'2MASX J09185179+0114343',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000078,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,139.7157917,1.24278,0.061,NULL,60674360609,948036884,14813076,17.4),(60860,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60860,37.75,0.16,356,20452,70,NULL,NULL,'2MASX J09185179+0106203',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000088,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,139.715833,1.10561,0.061,NULL,60674445173,948038205,14813096,17.7),(60861,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60861,37.28,0.46,286,20453,70,NULL,NULL,'2MASX J09185294+0645410',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,139.72075,6.76125,0.085,NULL,63644445103,994444454,15538194,17.1),(60862,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60862,37.15,0.46,270,20454,70,NULL,NULL,'2MASX J09185426+4340263',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,139.725958333,43.67386,0.005,NULL,64269914443,1004217413,15690897,17.3),(60863,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60863,35.54,0.46,129,20455,70,NULL,NULL,'UGC 04927',NULL,'2015arXiv151105856S',2015,1,1.07,NULL,'G',0.00018,NULL,'14.2g',0.89,'S0-?',NULL,NULL,NULL,NULL,1,139.727125,50.02067,0,NULL,63961483190,999398174,15615596,14.2),(60864,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60864,37.13,0.46,267,20456,70,NULL,NULL,'2MASX J09185487+0502553',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,139.728583,5.04875,0.085,NULL,60721426570,948772290,14824567,17.2),(60865,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60865,37.34,0.33,294,20457,70,NULL,NULL,'SDSS J091855.32+280648.7',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000153,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,139.730541667,28.11353,0.029,NULL,64205970217,1003218284,15675285,18.6),(60866,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60866,34.27,0.2,71.5,20458,74.4,NULL,NULL,'CGCG 091-068',NULL,'2013AJ....146...86T',2013,1,0.84,NULL,'G',0.00009,NULL,'15.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,139.7314583,14.30489,0.121,NULL,63869976824,997968387,15593256,15.8),(60867,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60867,37.75,0.16,356,20459,70,NULL,NULL,'2MASX J09185632+0115183',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000077,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,139.734875,1.25497,0.061,NULL,60674374594,948037103,14813079,17.2),(60868,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60868,37,0.46,251,20460,70,NULL,NULL,'2MASX J09185753+0256233',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,139.739666667,2.93964,0.077,NULL,60679048018,948110125,14814220,17.1),(60869,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60869,37.75,0.16,356,20461,70,NULL,NULL,'2MASX J09185779+0108563',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000092,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,139.7407917,1.14892,0.061,NULL,60674475631,948038681,14813104,16.7),(60870,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60870,37.4,0.46,303,20462,70,NULL,NULL,'2MASX J09185781+1846574',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000162,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,139.740833,18.78247,0.097,NULL,63736650742,995885167,15560705,18),(60871,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60871,38.34,0.46,466,20463,70,NULL,NULL,'SDSS J091858.69+073918.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000174,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,139.744583,7.65508,0.081,NULL,63644735590,994448993,15538265,18.5),(60872,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60872,36.61,0.46,210,20464,70,NULL,NULL,'2MASX J09185907-0012596',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000107,NULL,'15.8g',0.4,'E0',NULL,NULL,NULL,NULL,1,139.7462083,-0.21644,0.073,NULL,41079451392,641866428,10029162,15.8),(60873,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60873,36.7,0.33,219,20465,70,NULL,NULL,'2MASX J09185936+0939520',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000186,NULL,'15.4g',0.49,'E0',NULL,NULL,NULL,NULL,1,139.74725,9.66439,0.109,NULL,63650297750,994535902,15539623,15.4),(60874,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60874,38.21,0.46,438,20466,70,NULL,NULL,'2MASX J09185934+3129476',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000176,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,139.7472917,31.49656,0.005,NULL,64198993714,1003109276,15673582,17.7),(60875,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60875,36.86,0.46,235,20467,70,NULL,NULL,'CGCG 151-055 NED01',NULL,'2015arXiv151105856S',2015,1,0.65,'May contribute to the radio flux of B2 0915+32B.','G',0.000113,NULL,'15.7g',0.47,'NE COMP',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,139.7475417,31.86131,0,NULL,64198137850,1003095903,15673373,15.7),(60876,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60876,37.34,0.33,294,20468,70,NULL,NULL,'2MASX J09185962+2807279',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00015,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,139.748375,28.12436,0.029,NULL,64205969848,1003218278,15675285,16.8),(60877,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60877,36.82,0.46,231,20469,70,NULL,NULL,'2MASX J09190103+1640024',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000137,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,139.754291667,16.66744,0.057,NULL,63862360052,997849375,15591396,17.9),(60878,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60878,37.26,0.46,284,20470,70,NULL,NULL,'2MASX J09190253+4010127',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000174,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,139.7607083,40.17017,0,NULL,64397359582,1006208743,15722011,16.7),(60879,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60879,37.67,0.46,342,20471,70,NULL,NULL,'2MASX J09190357+2222324',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000187,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,139.764833,22.37572,0.133,NULL,63719311551,995614242,15556472,16.8),(60880,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60880,37.75,0.16,356,20472,70,NULL,NULL,'2MASX J09190412+0110453',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000077,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,139.767333333,1.17936,0.061,NULL,60674488958,948038889,14813107,17.4),(60881,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60881,35.23,0.13,111,20473,NULL,NULL,NULL,'FGC 0872',NULL,'2009ApJS..182..474S',2009,1,0.88,NULL,'G',0.000018,NULL,'16.6g',0.14,'Sc',NULL,NULL,NULL,NULL,1,139.7722083,31.10375,0.033,NULL,64198376598,1003099634,15673431,16.6),(60882,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60882,35.55,NULL,129,20473,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0872',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60883,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60883,35.57,NULL,130,20473,NULL,NULL,NULL,'FGC 0872',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60884,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60884,35.57,NULL,130,20473,NULL,NULL,'Dipole + Quadrupole','FGC 0872',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60885,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60885,35.59,NULL,131,20473,NULL,NULL,'Dipole','FGC 0872',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60886,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60886,35.67,0.49,136,20473,75,NULL,'IR','FGC 0872',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60887,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60887,35.73,0.2,140,20473,74.4,NULL,NULL,'FGC 0872',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60888,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60888,34.75,0.57,89.2,20474,70,NULL,NULL,'MCG -01-24-008',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000083,NULL,'15',0.3,NULL,NULL,NULL,NULL,NULL,1,139.7744583,-6.70417,0.117,NULL,41095864412,642122881,10033170,15),(60889,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60889,38.53,0.46,509,20475,70,NULL,NULL,'2MASX J09190637+3706068',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,139.7764583,37.10181,0,NULL,64403927997,1006311374,15723615,18.2),(60890,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60890,35.22,0.46,110,20476,70,NULL,NULL,'CGCG 121-058',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000173,NULL,'15.1g',0.39,NULL,NULL,NULL,NULL,NULL,1,139.77975,21.51467,0.097,NULL,63710645303,995478832,15554356,15.1),(60891,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60891,35.56,0.49,129,20477,75,NULL,'IR','UGC 04938',NULL,'2011yCatp016004901K',2011,1,1.51,NULL,'G',0.00003,NULL,'14.9g',0.35,'Sb',NULL,NULL,NULL,NULL,1,139.794833,20.24297,0.077,NULL,63707670779,995432355,15553630,14.9),(60892,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60892,35.68,0.4,137,20477,NULL,NULL,'mean','UGC 04938',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60893,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60893,35.78,0.47,143,20477,NULL,NULL,'H','UGC 04938',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60894,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60894,35.89,0.45,151,20477,NULL,NULL,'K','UGC 04938',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60895,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60895,35.93,0.46,154,20477,NULL,NULL,'J','UGC 04938',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60896,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60896,37.65,0.46,339,20478,70,NULL,NULL,'2MASX J09191193+0608280',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000188,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,139.7997917,6.14119,0.093,NULL,60704274525,948504289,14820379,16.5),(60897,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60897,38.15,0.46,427,20479,70,NULL,NULL,'2MASX J09191246+3011149',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00006,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,139.801875,30.18758,0.025,NULL,64202184888,1003159138,15674361,17.6),(60898,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60898,37.48,0.46,313,20480,70,NULL,NULL,'2MASX J09191361+6544512',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,139.806625,65.74764,0.185,NULL,62254908278,972732941,15198952,17.9),(60899,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60899,36.99,0.33,250,20481,70,NULL,NULL,'2MASX J09191361+1534418',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00016,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,139.80675,15.57836,0.081,NULL,63860927774,997826996,15591046,16.8),(60900,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60900,37.75,0.16,356,20482,70,NULL,NULL,'2MASX J09191490+0104356',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000074,NULL,'17.2g',0.24,'NLAGN',NULL,NULL,NULL,NULL,1,139.8122083,1.07664,0.065,NULL,60674459207,948038425,14813100,17.2),(60901,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60901,36.6,0.46,208,20483,70,NULL,NULL,'2MASX J09191501+1239068',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,139.81275,12.65192,0.049,NULL,63856409732,997756402,15589943,16.8),(60902,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60902,36.64,0.17,213,20484,70,NULL,NULL,'2MASX J09191606+5534372',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000082,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,139.817167,55.57706,0.061,NULL,61875713605,966808025,15106375,17.3),(60903,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60903,37.75,0.16,356,20485,70,NULL,NULL,'2MASX J09191636+0102106',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00009,NULL,'16.5g',0.38,'BrClG',NULL,NULL,NULL,NULL,1,139.818166667,1.03631,0.065,NULL,60674472613,948038634,14813103,16.5),(60904,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60904,36.52,0.46,201,20486,70,NULL,NULL,'2MASX J09191689+0612410',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000192,NULL,'16.1g',0.37,'E/S0',NULL,NULL,NULL,NULL,1,139.820416667,6.21142,0.097,NULL,60704272694,948504260,14820379,16.1),(60905,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60905,37.18,0.57,273,20487,70,NULL,NULL,'2MASX J09191731-0924282',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,139.8222083,-9.40783,0.109,NULL,42193109997,659267343,10301052,15.5),(60906,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60906,37.81,0.46,365,20488,70,NULL,NULL,'2MASX J09191751+4409226',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,139.822791667,44.15636,0,NULL,64262924101,1004108189,15689190,18),(60907,'SBF','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60907,29.35,0.14,7.41,20489,74.4,NULL,NULL,'NGC 2787',NULL,'2013AJ....146...86T',2013,1,3.2,NULL,'G',0.000027,NULL,'11.82',2,'SB(r)0+        LINER',NULL,NULL,NULL,'LINER b',1,139.8275,69.20325,0.161,NULL,62221874772,972216793,15190887,11.82),(60908,'SBF','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60908,29.37,0.36,7.48,20489,NULL,NULL,'I','NGC 2787',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60909,'Faber-Jackson','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60909,30.96,0.6,15.6,20489,95,NULL,'de Vaucouleurs','NGC 2787',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60910,'Faber-Jackson','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60910,31.31,0.55,18.3,20489,95,NULL,'Weighted Mean','NGC 2787',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60911,'Faber-Jackson','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60911,34.66,1.61,85.5,20489,55,NULL,'Visvanathan & Sandage 1979','NGC 2787',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60912,'Tertiary','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60912,29.8,0.71,9.12,20489,95,NULL,NULL,'NGC 2787',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60913,'Tully est','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60913,30.58,0.8,13,20489,75,NULL,'B','NGC 2787',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60914,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60914,38.12,0.46,421,20490,70,NULL,NULL,'SDSS J091920.58+133124.2',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.7g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,139.83575,13.52342,0.073,NULL,63868175376,997940240,15592816,17.7),(60915,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60915,35.2,0.06,110,20491,NULL,NULL,NULL,'NGC 2825',NULL,'2009ApJS..182..474S',2009,1,1.01,NULL,'G',0.00004,NULL,'14.6g',0.48,'Sa: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,139.8435,33.74278,0,NULL,64400250739,1006253917,15722717,14.6),(60916,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60916,37.1,0.46,263,20492,70,NULL,NULL,'2MASXi J0919226+280652',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,139.8444583,28.1145,0.029,NULL,64206094163,1003220221,15675315,16.7),(60917,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60917,37.51,0.46,317,20493,70,NULL,NULL,'2MASX J09192288+0646239',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,139.84525,6.77333,0.085,NULL,60704308168,948504815,14820387,17.8),(60918,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60918,37.31,0.46,290,20494,70,NULL,NULL,'2MASX J09192352+1707358',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000107,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,139.847958333,17.12667,0.061,NULL,63861789016,997840453,15591257,16.7),(60919,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60919,37.86,0.46,373,20495,70,NULL,NULL,'2MASX J09192406+2844186',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,139.850333,28.73861,0.037,NULL,64205895975,1003217124,15675267,17.7),(60920,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60920,35.71,0.46,139,20496,70,NULL,NULL,'2MASX J09192443+0242246',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000164,NULL,'16.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,139.851833,2.70692,0.073,NULL,60671680424,947995006,14812421,16.3),(60921,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60921,37.75,0.46,355,20497,70,NULL,NULL,'2MASX J09192462+0628016',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000194,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,139.852625,6.46719,0.097,NULL,60704365214,948505706,14820401,16.5),(60922,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60922,35.46,0.23,123,20498,70,NULL,NULL,'CGCG 151-058',NULL,'2015arXiv151105856S',2015,1,0.86,NULL,'G',0.000063,NULL,'15.0g',0.54,NULL,NULL,NULL,NULL,NULL,1,139.854375,26.90892,0.049,NULL,64204642521,1003197539,15674961,15),(60923,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60923,37.75,0.16,356,20499,70,NULL,NULL,'2MASX J09192523+0103356',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000085,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,139.85525,1.05978,0.065,NULL,60674460518,948038445,14813100,16.9),(60924,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60924,37.17,0.46,271,20500,70,NULL,NULL,'2MASX J09192536+5020571',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000144,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,139.855333333,50.34942,0,NULL,63962046890,999406982,15615734,18.6),(60925,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60925,35.41,0.16,121,20501,70,NULL,NULL,'2MASX J09192630+1931425',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000087,NULL,'16.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,139.859667,19.52836,0.033,NULL,63707407208,995428237,15553566,16.4),(60926,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60926,38.23,0.46,443,20502,70,NULL,NULL,'2MASX J09192698+6412521',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,139.862458333,64.2145,0.145,NULL,62255561526,972743148,15199111,NULL),(60927,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60927,37.33,0.46,292,20503,70,NULL,NULL,'2MASX J09192747+4006598',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,139.864458333,40.11667,0,NULL,64397346972,1006208546,15722008,17.7),(60928,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60928,37.75,0.46,355,20504,70,NULL,NULL,'2MASX J09192748+5137331',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000131,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,139.864458333,51.62592,0,NULL,63970464811,999538512,15617789,17),(60929,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60929,37.36,0.46,296,20505,70,NULL,NULL,'2MASX J09192784+0537466',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000191,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,139.866,5.6295,0.077,NULL,60721928112,948780126,14824689,17),(60930,'Brightest Stars','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60930,29.5,0.2,7.9,20506,NULL,NULL,NULL,'LSBC D565-06',NULL,'1998A&AS..133..181M',1998,1,0.44,NULL,'G',0.000006,NULL,'17.3g',0.3,'dI',NULL,NULL,NULL,NULL,1,139.8765,21.60344,0.097,NULL,63708611213,995447050,15553860,17.3),(60931,'TRGB','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60931,29.79,NULL,9.08,20506,NULL,NULL,NULL,'LSBC D565-06',NULL,'2006AJ....131.1361K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60932,'TRGB','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60932,29.83,0.12,9.25,20506,NULL,NULL,'I','LSBC D565-06',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60933,'TRGB','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60933,29.84,0.1,9.29,20506,74.4,NULL,NULL,'LSBC D565-06',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60934,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60934,37.59,0.46,329,20507,70,NULL,NULL,'SDSS J091930.33+374356.0',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000142,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,139.876375,37.73222,0,NULL,64407062718,1006360354,15724380,17.9),(60935,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60935,37.82,0.46,366,20508,70,NULL,NULL,'2MASX J09193067+2752056',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000141,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,139.8777917,27.86803,0.021,NULL,64206375005,1003224609,15675384,17.8),(60936,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60936,36.7,0.46,219,20509,70,NULL,NULL,'2MASX J09193130+2051275',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000087,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,139.880333333,20.85772,0.101,NULL,63711328792,995489512,15554523,16.6),(60937,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60937,37.41,0.46,303,20510,70,NULL,NULL,'SDSS J091932.39-001759.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000078,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,139.8849583,-0.29992,0.085,NULL,41079961549,641874399,10029287,17.7),(60938,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60938,37.71,0.46,348,20511,70,NULL,NULL,'2MASX J09193327+0542106',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000166,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,139.888625,5.70289,0.077,NULL,60721931758,948780183,14824690,17.3),(60939,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60939,37.8,0.46,362,20512,70,NULL,NULL,'2MASX J09193348+5035440',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000154,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,139.889416667,50.59547,0,NULL,63962031660,999406744,15615730,16.8),(60940,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60940,31.57,NULL,20.6,20513,NULL,NULL,NULL,'UGC 04932',NULL,'2013AJ....145..101K',2013,1,1.5,NULL,'G',0.000037,NULL,'15.17',0.4,'Sdm:',NULL,NULL,NULL,NULL,1,139.892083,51.10917,0,NULL,63969494668,999523354,15617552,15.17),(60941,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60941,36.64,0.17,213,20514,70,NULL,NULL,'2MASX J09193446+5535010',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000103,NULL,'15.7g',0.47,'E0',NULL,NULL,NULL,NULL,1,139.893666667,55.58386,0.061,NULL,61875710668,966807979,15106374,15.7),(60942,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60942,37.89,0.46,379,20515,70,NULL,NULL,'2MASX J09193462+2128035',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,139.894375,21.46778,0.097,NULL,63710579416,995477803,15554340,18.1),(60943,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60943,35.25,0.15,112,20516,70,NULL,NULL,'NGC 2828',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000067,NULL,'15.5g',0.35,'S0:','Group member',NULL,NULL,NULL,1,139.895125,33.88808,0,NULL,64400235012,1006253672,15722713,15.5),(60944,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60944,35.25,0.15,112,20517,70,NULL,NULL,'CGCG 181-022',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000067,NULL,'14.9g',0.7,'S?',NULL,NULL,NULL,NULL,1,139.900167,33.42833,0,NULL,64399539879,1006242810,15722543,14.9),(60945,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60945,37.87,0.46,375,20518,70,NULL,NULL,'2MASX J09193741+1251202',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,139.905875,12.85556,0.061,NULL,63856372890,997755826,15589934,18.2),(60946,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60946,35.36,0.4,118,20519,NULL,NULL,'mean','UGC 04940',NULL,'2007A&A...465...71T',2007,1,1.15,NULL,'G',0.00003,NULL,'14.4g',0.67,'SABab',NULL,NULL,NULL,NULL,1,139.908083333,27.45781,0.049,NULL,64206297853,1003223403,15675365,14.4),(60947,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60947,35.51,0.47,126,20519,NULL,NULL,'H','UGC 04940',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60948,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60948,35.59,0.46,131,20519,NULL,NULL,'J','UGC 04940',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60949,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60949,35.59,0.45,131,20519,NULL,NULL,'K','UGC 04940',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60950,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60950,36.48,0.46,198,20520,70,NULL,NULL,'2MASXi J0919391+424539',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,139.913125,42.76075,0,NULL,64269702466,1004214101,15690845,17.2),(60951,'IRAS','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60951,34.6,0.8,83.3,20521,75,NULL,'HMCL, I','NGC 2830',NULL,'1997ApJS..109..333W',1997,1,1.36,NULL,'G',0.000008,NULL,'14.9g',0.3,'SB0/a: sp','in a triple',NULL,NULL,NULL,1,139.9225417,33.73814,0,NULL,64400260926,1006254076,15722719,14.9),(60952,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60952,34.75,0.49,89.3,20521,75,NULL,'IR','NGC 2830',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60953,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60953,34.82,0.4,91.9,20521,75,NULL,'HMCL, I, raw','NGC 2830',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60954,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60954,35,0.2,100,20521,74.4,NULL,NULL,'NGC 2830',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60955,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60955,35.02,0.4,101,20521,75,NULL,'HMCL, I, cor','NGC 2830',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60956,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60956,35.03,0.4,101,20521,75,NULL,'HMCL, I, inv','NGC 2830',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60957,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60957,35.21,0.1,110,20521,NULL,NULL,NULL,'NGC 2830',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60958,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60958,38.83,0.33,584,20522,70,NULL,NULL,'SDSS J091942.25+370835.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000135,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,139.926083,37.14308,0,NULL,64403874642,1006310541,15723602,18.2),(60959,'Faber-Jackson','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60959,34.1,0.44,66.1,20523,95,NULL,'Weighted Mean','NGC 2831',NULL,'1984ApJS...56...91D',1984,1,0.71,NULL,'G',0.000025,NULL,'14.7g',0.52,'E0','Pair member (points to parent)',NULL,NULL,NULL,1,139.9395417,33.745,0,NULL,64400261057,1006254079,15722719,14.7),(60960,'Faber-Jackson','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60960,34.55,0.63,81.3,20523,95,NULL,'Michard 1979b, c','NGC 2831',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60961,'Faber-Jackson','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60961,34.73,0.46,88.3,20523,95,NULL,'Michard 1979a','NGC 2831',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60962,'Tertiary','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60962,34.15,0.5,67.6,20523,95,NULL,NULL,'NGC 2831',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60963,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60963,37.47,0.46,312,20524,70,NULL,NULL,'2MASX J09194587+0536585',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000146,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,139.9410417,5.61631,0.077,NULL,60721986176,948781034,14824703,17.6),(60964,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60964,37.8,0.23,363,20525,70,NULL,NULL,'SDSS J091946.62+070202.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,139.9442917,7.034,0.089,NULL,63644769500,994449523,15538273,18.2),(60965,'BCG','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60965,34.77,0.35,88.2,20526,60,NULL,'ABELL 0779, BCG','NGC 2832',0.0201,'1980ApJ...241..486H',1980,1,1.71,NULL,'G',0.000019,NULL,'12.9g',1.18,'E+2:;cD        LINER','Triplet member, first-ranked galaxy',NULL,NULL,NULL,1,139.94525,33.74975,0,NULL,64400260190,1006254065,15722719,12.9),(60966,'D-Sigma','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60966,34.75,0.4,89.3,20526,75,NULL,'Edat, raw','NGC 2832',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60967,'D-Sigma','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60967,35,0.4,100,20526,75,NULL,'Edat, cor','NGC 2832',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60968,'Faber-Jackson','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60968,33.36,0.45,47,20526,95,NULL,'de Vaucouleurs','NGC 2832',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60969,'Faber-Jackson','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60969,33.51,0.32,50.4,20526,95,NULL,'Weighted Mean','NGC 2832',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60970,'Faber-Jackson','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60970,33.89,0.46,60,20526,95,NULL,'Michard 1979a','NGC 2832',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60971,'Faber-Jackson','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60971,34.63,0.63,84.3,20526,95,NULL,'Michard 1979b, c','NGC 2832',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60972,'Tertiary','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60972,34.15,0.5,67.6,20526,95,NULL,NULL,'NGC 2832',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60973,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60973,34.62,0.45,83.9,20526,NULL,NULL,'K','NGC 2832',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60974,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60974,34.95,0.1,97.6,20526,70,NULL,'ABELL 0779, BGC','NGC 2832',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60975,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60975,35.06,0.4,103,20526,NULL,NULL,'mean','NGC 2832',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60976,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60976,36.64,0.17,213,20527,70,NULL,NULL,'2MASX J09194805+5526283',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000108,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,139.950125,55.44108,0.061,NULL,61875923054,966811297,15106426,16.3),(60977,'Tully est','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60977,32.14,0.8,26.7,20528,75,NULL,NULL,'DDO 060',NULL,'1988NBGC.C....0000T',1988,1,1.7,'Confused HIPASS source','G',0.00001,NULL,'15',1.4,'IB(s)m pec','Dwarf, possible member',NULL,NULL,NULL,1,139.952667,-12.2505,0.149,NULL,42180247884,659066373,10297912,15),(60978,'IRAS','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60978,33.59,0.8,52.2,20529,75,NULL,'HMCL, I','CGCG 034-029',NULL,'1997ApJS..109..333W',1997,1,0.49,NULL,'G',0.00007,NULL,'15.6',0.18,NULL,NULL,NULL,NULL,NULL,1,139.954167,4.48469,0.085,NULL,60722731045,948792672,14824885,15.6),(60979,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60979,34.3,0.4,72.4,20529,75,NULL,'HMCL, I, inv','CGCG 034-029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60980,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60980,34.3,0.4,72.5,20529,75,NULL,'HMCL, I, raw','CGCG 034-029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60981,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60981,34.62,0.4,84,20529,75,NULL,'HMCL, I, cor','CGCG 034-029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60982,'BCG','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60982,34.77,0.35,88.2,20530,60,NULL,NULL,'ABELL 0779',0.0201,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',0.000844,NULL,NULL,NULL,'I-II:  [BM]',NULL,NULL,NULL,NULL,1,139.955,33.76028,0,NULL,64400259616,1006254056,15722719,NULL),(60983,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60983,34.95,0.1,97.6,20530,70,NULL,NULL,'ABELL 0779',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60984,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60984,38.14,0.46,424,20531,70,NULL,NULL,'2MASX J09194952+5340025',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000088,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,139.956375,53.66747,0.017,NULL,63957567952,999336999,15614640,17.3),(60985,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60985,37.43,0.46,306,20532,70,NULL,NULL,'2MASX J09194976+1603102',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,139.9575,16.05286,0.057,NULL,63861058496,997829039,15591078,17.8),(60986,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60986,37.82,0.46,367,20533,70,NULL,NULL,'2MASX J09194982+3051564',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00007,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,139.95775,30.86567,0,NULL,64198359230,1003099362,15673427,18),(60987,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60987,37.8,0.23,363,20534,70,NULL,NULL,'2MASX J09195120+0701527',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,139.963458333,7.03117,0.089,NULL,63644770229,994449534,15538273,17.9),(60988,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60988,36.89,0.46,238,20535,70,NULL,NULL,'2MASX J09195206+2123541',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00018,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,139.9667917,21.39844,0.097,NULL,63710588651,995477947,15554342,16.4),(60989,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60989,37.8,0.23,363,20536,70,NULL,NULL,'2MASX J09195207+0701357',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000194,NULL,'16.5g',0.36,'BrClG',NULL,NULL,NULL,NULL,1,139.967167,7.02658,0.089,NULL,63644769677,994449526,15538273,16.5),(60990,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60990,35.25,0.15,112,20537,70,NULL,NULL,'2MASX J09195225+3338584',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000019,NULL,'15.9g',0.39,'S0^-','Group member',NULL,NULL,NULL,1,139.967875,33.6495,0,NULL,64400254517,1006253976,15722718,15.9),(60991,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60991,37.95,0.23,389,20538,70,NULL,NULL,'2MASX J09195244+3944468',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00019,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,139.9687083,39.74639,0,NULL,64397467851,1006210435,15722038,17.1),(60992,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60992,38.83,0.33,584,20539,70,NULL,NULL,'2MASX J09195299+3705118',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,139.9707917,37.08669,0,NULL,64403903058,1006310985,15723609,18.6),(60993,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60993,38.49,0.46,498,20540,70,NULL,NULL,'SDSS J091953.08+445246.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000092,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,139.9712083,44.87956,0,NULL,64262699794,1004104684,15689135,18.5),(60994,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60994,34.7,0.33,87.1,20541,70,NULL,NULL,'MRK 1232',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000087,NULL,'14.9g',0.47,'S0^-','Group member of poor cluster',NULL,NULL,NULL,1,139.979958333,0.94514,0.061,NULL,60670998547,947984352,14812255,14.9),(60995,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60995,35.39,0.61,120,20542,70,NULL,NULL,'2MASX J09195522-3231407',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,139.9800417,-32.52803,0.993,NULL,42907743065,670433485,10475523,14.9),(60996,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',60996,37.48,0.46,313,20543,70,NULL,NULL,'2MASX J09195529+5705063',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000083,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,139.9800417,57.08522,0.045,NULL,61883926564,966936352,15108380,16.7),(60997,'IRAS','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60997,33.24,0.8,44.6,20544,75,NULL,'MAT, I','ESO 061- G 008',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'13.45',0.6,'SA(rs)c:',NULL,NULL,NULL,NULL,1,139.9809583,-68.90903,0.377,NULL,40740902164,636576596,9946509,13.45),(60998,'Tully est','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60998,32.3,0.8,28.9,20544,75,NULL,NULL,'ESO 061- G 008',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(60999,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,60999,32.84,0.32,36.9,20544,85,NULL,'I, raw','ESO 061- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61000,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61000,32.86,0.32,37.3,20544,85,NULL,'I, inv','ESO 061- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61001,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61001,32.99,0.43,39.7,20544,75,NULL,'MAT, I, raw','ESO 061- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61002,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61002,33.13,0.43,42.3,20544,75,NULL,'MAT, I, inv','ESO 061- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61003,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61003,33.22,0.43,44.1,20544,75,NULL,'MAT, I, cor','ESO 061- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61004,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61004,33.22,0.43,44.1,20544,75,NULL,'3.6 micron, color corrected','ESO 061- G 008',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61005,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61005,33.23,0.43,44.2,20544,75,NULL,'3.6 micron, color + selection bias corrected','ESO 061- G 008',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61006,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61006,33.29,0.2,45.5,20544,74.4,NULL,NULL,'ESO 061- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61007,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61007,33.48,0.56,49.6,20544,NULL,NULL,'Malmquist cor.','ESO 061- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61008,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61008,33.54,0.46,51,20544,NULL,NULL,'J','ESO 061- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61009,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61009,33.56,0.4,51.5,20544,NULL,NULL,'mean','ESO 061- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61010,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61010,33.57,0.53,51.6,20544,NULL,NULL,NULL,'ESO 061- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61011,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61011,33.57,0.47,51.7,20544,NULL,NULL,'H','ESO 061- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61012,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61012,33.68,0.45,54.6,20544,NULL,NULL,'K','ESO 061- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61013,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61013,36.57,0.46,206,20545,70,NULL,NULL,'2MASX J09195579+2324041',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000184,NULL,'16.0g',0.41,NULL,NULL,NULL,NULL,NULL,1,139.982541667,23.40114,0.161,NULL,63719460476,995616569,15556508,16),(61014,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61014,37.88,0.46,376,20546,70,NULL,NULL,'SDSS J091957.37+522141.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000074,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,139.9890417,52.3615,0.009,NULL,63970169169,999533893,15617717,18.1),(61015,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61015,37.74,0.46,354,20547,70,NULL,NULL,'2MASX J09195741+1218192',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,139.989167,12.30536,0.061,NULL,63856280466,997754382,15589912,18.1),(61016,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61016,35.46,0.23,123,20548,70,NULL,NULL,'CGCG 151-061',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.000067,NULL,'15.0g',0.45,'AGN',NULL,NULL,NULL,NULL,1,139.9915417,26.74858,0.049,NULL,64204664046,1003197875,15674966,15),(61017,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61017,32.89,0.4,37.9,20549,NULL,NULL,'mean','IC 2461',NULL,'2007A&A...465...71T',2007,1,2.9,NULL,'G',0.000007,NULL,'14.4g',0.39,'Sbc',NULL,NULL,NULL,NULL,1,139.9917917,37.19125,0,NULL,64407346730,1006364792,15724449,14.4),(61018,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61018,33,0.4,39.7,20549,75,NULL,NULL,'IC 2461',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61019,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61019,33.35,0.45,46.8,20549,NULL,NULL,'K','IC 2461',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61020,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61020,33.41,0.47,48.1,20549,NULL,NULL,'H','IC 2461',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61021,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61021,33.47,0.43,49.5,20549,75,NULL,'3.6 micron, color + selection bias corrected','IC 2461',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61022,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61022,33.49,0.46,49.9,20549,NULL,NULL,'J','IC 2461',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61023,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61023,33.6,NULL,52.4,20549,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 2461',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61024,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61024,33.6,NULL,52.4,20549,NULL,NULL,'Dipole','IC 2461',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61025,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61025,33.6,NULL,52.5,20549,NULL,NULL,'Dipole + Quadrupole','IC 2461',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61026,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61026,33.67,0.43,54.2,20549,75,NULL,'3.6 micron, color corrected','IC 2461',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61027,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61027,33.74,NULL,56.1,20549,NULL,NULL,NULL,'IC 2461',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61028,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61028,33.78,0.49,56.9,20549,75,NULL,'IR','IC 2461',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61029,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61029,33.97,0.2,62.2,20549,74.4,NULL,NULL,'IC 2461',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61030,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61030,34.2,0.47,69.2,20549,NULL,NULL,NULL,'IC 2461',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61031,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61031,34.42,0.42,76.5,20549,NULL,NULL,'Malmquist cor.','IC 2461',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61032,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61032,35.46,0.23,123,20550,70,NULL,NULL,'CGCG 151-060',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00014,NULL,'15.5g',0.39,NULL,NULL,NULL,NULL,NULL,1,139.994458333,26.55267,0.057,NULL,64205308808,1003207950,15675124,15.5),(61033,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61033,38.05,0.46,407,20551,70,NULL,NULL,'2MASX J09195871+0204385',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000081,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,139.9947917,2.07736,0.061,NULL,60672271233,948004238,14812566,17.9),(61034,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61034,36.36,0.46,187,20552,70,NULL,NULL,'2MASX J09195892+4504158',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000209,NULL,'15.6g',0.39,'S0',NULL,NULL,NULL,NULL,1,139.995667,45.07094,0,NULL,64262666877,1004104169,15689127,15.6),(61035,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61035,36.19,0.46,173,20553,70,NULL,NULL,'2MASX J09200015+5926093',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000077,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,140.000333,59.43606,0.081,NULL,62068088039,969813875,15153341,16.7),(61036,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61036,36.34,0.46,186,20554,70,NULL,NULL,'2MASX J09200035+3505284',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,140.0015,35.09122,NULL,NULL,64403426429,1006303537,15723492,17.2),(61037,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61037,36.26,0.46,179,20555,70,NULL,NULL,'2MASX J09200095+2644223',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000175,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,140.004083,26.73944,0.049,NULL,64204663311,1003197864,15674966,16.1),(61038,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61038,35.04,0.49,102,20556,75,NULL,'IR','UGC 04949',NULL,'2011yCatp016004901K',2011,1,0.93,NULL,'G',0.000014,NULL,'16.1g',0.21,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,140.00775,33.10203,0,NULL,64399378865,1006240294,15722504,16.1),(61039,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61039,35.08,0.11,104,20556,NULL,NULL,NULL,'UGC 04949',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61040,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61040,35.32,NULL,116,20556,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04949',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61041,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61041,35.34,NULL,117,20556,NULL,NULL,'Dipole + Quadrupole','UGC 04949',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61042,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61042,35.35,NULL,118,20556,NULL,NULL,'Dipole','UGC 04949',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61043,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61043,35.42,NULL,121,20556,NULL,NULL,NULL,'UGC 04949',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61044,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61044,35.44,0.2,122,20556,74.4,NULL,NULL,'UGC 04949',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61045,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61045,36.43,0.46,193,20557,70,NULL,NULL,'SDSS J092001.96+070609.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000166,NULL,'17.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,140.0082083,7.10258,0.117,NULL,63644819866,994450310,15538286,17.2),(61046,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61046,35.46,0.23,123,20558,70,NULL,NULL,'MCG +05-22-039',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.00017,NULL,'15.3g',0.51,NULL,NULL,NULL,NULL,NULL,1,140.008917,26.93053,0.049,NULL,64204691290,1003198301,15674973,15.3),(61047,'D-Sigma','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61047,34.21,0.4,69.6,20559,75,NULL,'Edat, raw','UGC 04956',NULL,'1997ApJS..109..333W',1997,1,1.45,NULL,'G',0.000087,NULL,'13.7g',0.91,'E:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,140.0090417,1.03831,0.065,NULL,60670983383,947984115,14812251,13.7),(61048,'D-Sigma','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61048,34.55,0.4,81.2,20559,75,NULL,'Edat, cor','UGC 04956',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61049,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61049,34.7,0.33,87.1,20559,70,NULL,NULL,'UGC 04956',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61050,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61050,34.32,0.45,73.3,20559,NULL,NULL,'K','UGC 04956',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61051,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61051,34.54,0.4,80.8,20559,NULL,NULL,'mean','UGC 04956',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61052,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61052,35.25,0.15,112,20560,70,NULL,NULL,'NGC 2834',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000067,NULL,'15.1g',0.52,'S0:','Group member',NULL,NULL,NULL,1,140.0105,33.71047,0,NULL,64400246826,1006253856,15722716,15.1),(61053,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61053,35.65,0.46,135,20561,70,NULL,NULL,'2MASX J09200366+5555523',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000078,NULL,'15.9g',0.4,'E0',NULL,NULL,NULL,NULL,1,140.015083333,55.93114,0.077,NULL,61888275042,967004297,15109442,15.9),(61054,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61054,38.24,0.46,445,20562,70,NULL,NULL,'2MASX J09200428+0635137',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,140.017917,6.58714,0.097,NULL,60705032091,948516126,14820564,17.3),(61055,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61055,38.08,0.46,414,20563,70,NULL,NULL,'2MASX J09200545+1405159',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,140.022833,14.08781,0.081,NULL,63870031242,997969238,15593269,17.5),(61056,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61056,36.64,0.17,213,20564,70,NULL,NULL,'2MASX J09200568+5533143',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000083,NULL,'16.0g',0.32,'E0',NULL,NULL,NULL,NULL,1,140.023666667,55.55394,0.061,NULL,61875735332,966808364,15106380,16),(61057,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61057,37.76,0.46,356,20565,70,NULL,NULL,'2MASX J09200778+2837584',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,140.032417,28.63281,0.025,NULL,64205919138,1003217486,15675273,18.1),(61058,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61058,37.95,0.33,389,20566,70,NULL,NULL,'SDSS J092008.42+091149.7',NULL,'2015arXiv151105856S',2015,1,0.11,NULL,'G',0.000157,NULL,'19.0g',0.1,NULL,NULL,NULL,NULL,NULL,1,140.035083,9.19717,0.113,NULL,63650235536,994534930,15539608,19),(61059,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61059,36.67,0.46,216,20567,70,NULL,NULL,'2MASX J09200862+4839585',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000148,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,140.036167,48.66642,0.005,NULL,64232093559,1003626461,15681663,16.8),(61060,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61060,35.81,0.52,146,20568,70,NULL,NULL,'2MASX J09200959-0530593',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.66',NULL,NULL,NULL,NULL,NULL,NULL,1,140.039833,-5.51664,0.105,NULL,41130184552,642659133,10041548,15.66),(61061,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61061,31.57,0.2,20.6,20569,74.4,NULL,NULL,'NGC 2848',NULL,'2013AJ....146...86T',2013,1,2.7,'HOLM 128B is a star.','G',0.000013,NULL,'12.35',1.7,'SAB(s)c:       HII','Group member',NULL,NULL,NULL,1,140.0409583,-16.52606,0.129,NULL,42374600617,662103134,10345361,12.35),(61062,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61062,32.21,0.46,27.6,20569,NULL,NULL,'J','NGC 2848',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61063,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61063,32.21,0.47,27.6,20569,NULL,NULL,'H','NGC 2848',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61064,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61064,32.21,0.4,27.7,20569,75,NULL,'B','NGC 2848',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61065,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61065,32.24,0.45,28,20569,NULL,NULL,'K','NGC 2848',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61066,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61066,32.7,0.4,34.6,20569,NULL,NULL,'mean','NGC 2848',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61067,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61067,37.77,0.46,358,20570,70,NULL,NULL,'2MASX J09201009+5031265',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000123,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,140.0419583,50.52397,0,NULL,63962077682,999407463,15615741,17.8),(61068,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61068,37.3,0.33,288,20571,70,NULL,NULL,'2MASX J09201141+3628569',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000152,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,140.047458333,36.48253,0,NULL,64403855669,1006310244,15723597,17.2),(61069,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61069,38.1,0.46,416,20572,70,NULL,NULL,'2MASX J09201140+5917273',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000083,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,140.0477083,59.291,0.109,NULL,62067936496,969811507,15153304,17.9),(61070,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61070,37.95,0.33,389,20573,70,NULL,NULL,'2MASX J09201317+0917367',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000158,NULL,'17.1g',0.31,NULL,NULL,NULL,NULL,NULL,1,140.054833,9.2935,0.109,NULL,63650245632,994535088,15539610,17.1),(61071,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61071,34.94,NULL,97.5,20574,NULL,NULL,'Dipole','UGC 04957',NULL,'2010Ap&SS.325..163P',2010,1,1.5,NULL,'G',0.000017,NULL,'16.1g',0.25,'Sd',NULL,NULL,NULL,NULL,1,140.0552083,8.793,0.121,NULL,63645776022,994465250,15538519,16.1),(61072,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61072,34.95,NULL,97.7,20574,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04957',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61073,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61073,34.95,NULL,97.7,20574,NULL,NULL,'Dipole + Quadrupole','UGC 04957',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61074,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61074,34.96,NULL,98.1,20574,NULL,NULL,NULL,'UGC 04957',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61075,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61075,36.78,0.46,227,20575,70,NULL,NULL,'2MASX J09201343+2859203',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00001,NULL,'16.3g',0.34,'Sa',NULL,NULL,NULL,NULL,1,140.0560417,28.98906,0.049,NULL,64200654421,1003135225,15673987,16.3),(61076,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61076,35.77,0.46,143,20576,70,NULL,NULL,'CGCG 209-054',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000181,NULL,'15.3g',0.39,'S0a',NULL,NULL,NULL,NULL,1,140.063875,39.9445,0,NULL,64397492556,1006210821,15722044,15.3),(61077,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61077,37.3,0.33,288,20577,70,NULL,NULL,'2MASX J09201580+3632079',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,140.065708333,36.53561,0,NULL,64403863964,1006310374,15723599,18.1),(61078,'SNIa','2016-12-15 15:14:28','2016-12-16 11:19:35','1','SN 1999ar',NULL,61078,38.5,0.08,436,20578,74.2,NULL,'SALT 2','MSACSS J092016.00+003339.6',0.15,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,140.066667,0.561,0.069,NULL,60671653073,947994579,14812415,NULL),(61079,'SNIa','2016-12-15 15:14:28','2016-12-16 11:19:35','1','SN 1999ar',NULL,61079,39.29,0.06,627,20578,70,NULL,'SALT','MSACSS J092016.00+003339.6',0.15,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61080,'SNIa','2016-12-15 15:14:28','2016-12-16 11:19:35','1','SN 1999ar',NULL,61080,39.45,0.07,674,20578,65,NULL,'SALT','MSACSS J092016.00+003339.6',0.15,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61081,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61081,37.5,0.46,316,20579,70,NULL,NULL,'2MASX J09201871+0211017',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000088,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,140.077917,2.18353,0.081,NULL,60672252123,948003939,14812561,16.6),(61082,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61082,38.46,0.46,493,20580,70,NULL,NULL,'2MASX J09201976+5504383',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000088,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,140.082125,55.07731,0.033,NULL,61876432200,966819253,15106550,17.6),(61083,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61083,37.95,0.23,389,20581,70,NULL,NULL,'2MASX J09201984+3945019',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00013,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,140.082583,39.75058,0,NULL,64397469609,1006210462,15722038,17.7),(61084,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61084,36.77,0.46,226,20582,70,NULL,NULL,'2MASX J09202006+2642003',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000168,NULL,'16.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,140.083458333,26.70011,0.073,NULL,64204667802,1003197934,15674967,16.6),(61085,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61085,32.14,0.47,26.8,20583,NULL,NULL,'H','NGC 2805',NULL,'2007A&A...465...71T',2007,1,6.3,NULL,'G',0.000002,NULL,'11.52',4.8,'SAB(rs)d','in a radial-velocity based grouping',NULL,NULL,NULL,1,140.0850417,64.10278,0.161,NULL,62253471626,972710494,15198601,11.52),(61086,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61086,32.18,0.46,27.3,20583,NULL,NULL,'J','NGC 2805',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61087,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61087,32.24,0.4,28,20583,75,NULL,'B','NGC 2805',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61088,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61088,32.25,0.4,28.2,20583,NULL,NULL,'mean','NGC 2805',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61089,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61089,32.3,0.45,28.8,20583,NULL,NULL,'K','NGC 2805',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61090,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61090,37.8,0.23,363,20584,70,NULL,NULL,'2MASX J09202094+0655027',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,140.087125,6.91744,0.105,NULL,60704809760,948512652,14820510,17.7),(61091,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61091,32.6,0.69,33.1,20585,100,NULL,'mid-IR','MCG -01-24-010',NULL,'2013ApJ...771...88L',2013,1,1.6,'HOLM 127B is a star.','G',0.000023,NULL,'13.5',0.8,'Sb?            HII',NULL,NULL,NULL,NULL,1,140.0914583,-7.88069,0.097,NULL,42185567995,659149499,10299210,13.5),(61092,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61092,33.69,0.4,54.8,20585,NULL,NULL,'mean','MCG -01-24-010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61093,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61093,33.73,0.47,55.6,20585,NULL,NULL,'H','MCG -01-24-010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61094,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61094,33.76,0.45,56.6,20585,NULL,NULL,'K','MCG -01-24-010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61095,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61095,33.78,0.46,56.9,20585,NULL,NULL,'J','MCG -01-24-010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61096,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61096,34.01,0.43,63.5,20585,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-24-010',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61097,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61097,37.72,0.46,349,20586,70,NULL,NULL,'2MASX J09202240+0647212',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000164,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,140.093417,6.78936,0.085,NULL,60705051661,948516432,14820569,17.6),(61098,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61098,36.74,0.15,223,20587,70,NULL,NULL,'CGCG 264-102',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000194,NULL,'15.3g',0.58,'E0',NULL,NULL,NULL,NULL,1,140.097667,54.94214,0.033,NULL,61876413853,966818966,15106546,15.3),(61099,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61099,37.5,0.74,317,20588,70,NULL,NULL,'2MASX J09202463-1214195',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,140.102667,-12.23881,0.149,NULL,42180132338,659064567,10297883,14.4),(61100,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61100,37.02,0.46,254,20589,70,NULL,NULL,'2MASX J09202497+0757212',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,140.104041667,7.95583,0.093,NULL,63648270552,994504227,15539128,17.3),(61101,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61101,37.99,0.46,397,20590,70,NULL,NULL,'2MASX J09202562+0528357',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,140.106875,5.47653,0.109,NULL,60721785677,948777901,14824654,17.8),(61102,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61102,38.27,0.46,451,20591,70,NULL,NULL,'2MASX J09202616+0640562',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,140.109083,6.68242,0.097,NULL,60705153051,948518016,14820594,18),(61103,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61103,36.74,0.15,223,20592,70,NULL,NULL,'2MASX J09202679+5456492',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000075,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,140.111833,54.94689,0.033,NULL,61876418300,966819035,15106547,17.3),(61104,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61104,35.8,0.17,144,20593,70,NULL,NULL,'2MASX J09202863+2201536',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00008,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,140.1194583,22.03175,0.113,NULL,63716427865,995569185,15555768,16.7),(61105,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61105,37.95,0.23,389,20594,70,NULL,NULL,'2MASX J09202902+3939239',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000224,NULL,'16.1g',0.4,'E0',NULL,NULL,NULL,NULL,1,140.120791667,39.65678,0,NULL,64397410209,1006209534,15722023,16.1),(61106,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61106,37.47,0.46,312,20595,70,NULL,NULL,'2MASX J09203085+2435561',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000194,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,140.128375,24.59892,0.069,NULL,63712648583,995510134,15554845,16.7),(61107,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61107,38.79,0.46,572,20596,70,NULL,NULL,'SDSS J092032.51+345504.7',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000138,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,140.1355,34.91797,0,NULL,64403324000,1006301937,15723467,18.2),(61108,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61108,34.09,0.55,65.7,20597,70,NULL,NULL,'2MASX J09203312-6437101',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000133,NULL,'15.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,140.138083,-64.61947,0.693,NULL,40760177843,636877778,9951215,15.4),(61109,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61109,37.08,0.46,261,20598,70,NULL,NULL,'2MASX J09203370+5204589',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,140.140333,52.08311,0,NULL,63970127813,999533247,15617706,17.7),(61110,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61110,35.58,0.46,130,20599,70,NULL,NULL,'CGCG 151-064',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00007,NULL,'15.5g',0.49,NULL,NULL,NULL,NULL,NULL,1,140.1454583,30.17675,0,NULL,64202172932,1003158952,15674358,15.5),(61111,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61111,37.53,0.46,321,20600,70,NULL,NULL,'2MASX J09203612+3702119',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,140.1505,37.03661,0,NULL,64407370059,1006365157,15724455,16.8),(61112,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61112,38.23,0.46,443,20601,70,NULL,NULL,'2MASX J09203640+1419472',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,140.151625,14.32983,0.081,NULL,63869924579,997967571,15593243,17.8),(61113,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61113,35.13,0.07,106,20602,NULL,NULL,NULL,'CGCG 181-030',NULL,'2009ApJS..182..474S',2009,1,0.95,NULL,'G',0.000025,NULL,'15.0g',0.35,'Sab            AGN:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,140.153875,33.07472,0,NULL,64399388300,1006240442,15722506,15),(61114,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61114,35.18,0.2,109,20602,74.4,NULL,NULL,'CGCG 181-030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61115,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61115,38.67,0.46,541,20603,70,NULL,NULL,'SDSS J092038.26+082921.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000145,NULL,'18.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,140.159417,8.48925,0.109,NULL,63646263669,994472869,15538638,18.8),(61116,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61116,38.42,0.33,483,20604,70,NULL,NULL,'SDSS J092039.18+113050.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.8g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,140.1635417,11.514,0.081,NULL,63637430751,994334855,15536482,18.8),(61117,'Tully est','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61117,32.09,0.8,26.2,20605,75,NULL,NULL,'DDO 061',NULL,'1988NBGC.C....0000T',1988,1,2.2,'Confused HIPASS source','G',0.000013,NULL,'14.8',1.6,'IAB(s)m','Dwarf, possible member',NULL,NULL,NULL,1,140.1640417,-12.60383,0.129,NULL,42363716671,661933072,10342704,14.8),(61118,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61118,37.57,0.46,327,20606,70,NULL,NULL,'2MASX J09204017+0505054',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000174,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,140.1672917,5.08486,0.101,NULL,60724804372,948825068,14825391,17.1),(61119,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61119,37.34,0.46,294,20607,70,NULL,NULL,'2MASX J09204107+6315386',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,140.1710417,63.26069,0.129,NULL,62033636263,969275566,15144930,17.1),(61120,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61120,34.89,0.2,95.1,20608,74.4,NULL,NULL,'SDSS J092041.84+334339.9',NULL,'2013AJ....146...86T',2013,1,0.53,NULL,'G',0.000017,NULL,'16.32',0.5,'Sc',NULL,NULL,NULL,NULL,1,140.174375,33.72778,0,NULL,64400336884,1006255263,15722738,16.32),(61121,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61121,35.09,0.08,104,20608,NULL,NULL,NULL,'SDSS J092041.84+334339.9',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61122,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61122,36.89,0.46,238,20609,70,NULL,NULL,'2MASX J09204245+0457384',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00017,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,140.177,4.96072,0.101,NULL,60724812227,948825191,14825393,16.7),(61123,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61123,37.83,0.46,368,20610,70,NULL,NULL,'2MASX J09204252+0522304',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.0002,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,140.177083,5.37511,0.101,NULL,60721728941,948777014,14824640,17),(61124,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61124,35.37,0.33,119,20611,70,NULL,NULL,'NGC 2838',NULL,'2015arXiv151105856S',2015,1,1.02,NULL,'G',0.000173,NULL,'14.0g',0.86,'E0',NULL,NULL,NULL,NULL,1,140.179333,39.31575,0,NULL,64405706510,1006339164,15724049,14),(61125,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61125,37.62,0.46,334,20612,70,NULL,NULL,'2MASX J09204376+3652028',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,140.1824583,36.86747,0,NULL,64407241433,1006363147,15724424,17.4),(61126,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61126,36.74,0.15,223,20613,70,NULL,NULL,'2MASX J09204506+5454047',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000093,NULL,'16.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,140.187667,54.90131,0.053,NULL,61876291351,966817052,15106516,16.2),(61127,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61127,37.72,0.27,350,20614,70,NULL,NULL,'2MASX J09204526+4040308',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000173,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,140.188458333,40.67533,0,NULL,64266286284,1004160723,15690011,17.9),(61128,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61128,38.42,0.33,483,20615,70,NULL,NULL,'2MASX J09204725+1132002',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,140.196958333,11.53339,0.081,NULL,63637950589,994342977,15536609,17.7),(61129,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61129,36.12,0.46,167,20616,70,NULL,NULL,'2MASX J09205022+0605074',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000178,NULL,'16.2g',0.33,'S0/a',NULL,NULL,NULL,NULL,1,140.20925,6.08536,0.105,NULL,60721537761,948774027,14824594,16.2),(61130,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61130,34.03,NULL,63.9,20617,NULL,NULL,NULL,'FGC 0878',NULL,'2000BSAO...50....5K',2000,1,0.85,NULL,'G',0.00004,NULL,'16.7',0.1,'Sm',NULL,NULL,NULL,NULL,1,140.21,-3.78306,0.069,NULL,41131609514,642681398,10041896,16.7),(61131,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61131,34.15,NULL,67.5,20617,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0878',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61132,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61132,34.16,NULL,67.9,20617,NULL,NULL,'Dipole + Quadrupole','FGC 0878',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61133,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61133,34.17,NULL,68.4,20617,NULL,NULL,'Dipole','FGC 0878',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61134,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61134,37.32,0.46,291,20618,70,NULL,NULL,'2MASX J09205098+6341396',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,140.212416667,63.69439,0.129,NULL,62032152741,969252386,15144568,17.7),(61135,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61135,37.46,0.46,310,20619,70,NULL,NULL,'2MASX J09205207+0645350',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000187,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,140.216916667,6.75978,0.121,NULL,60705193900,948518654,14820603,16.9),(61136,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61136,35.83,0.46,147,20620,70,NULL,NULL,'2MASX J09205243+4242313',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.0002,NULL,'15.7g',0.31,'E0',NULL,NULL,NULL,NULL,1,140.2184583,42.70881,0,NULL,64273131692,1004267682,15691682,15.7),(61137,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61137,37.05,0.46,257,20621,70,NULL,NULL,'2MASX J09205263-0046042',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000076,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,140.2192083,-0.76794,0.077,NULL,41079628989,641869202,10029206,17.1),(61138,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61138,34.92,0.2,96.4,20622,74.4,NULL,NULL,'NGC 2840',NULL,'2013AJ....146...86T',2013,1,0.82,NULL,'G',0.000007,NULL,'14.4g',0.6,'SB(rs)bc',NULL,NULL,NULL,NULL,1,140.219667,35.36828,0.013,NULL,64403453701,1006303964,15723499,14.4),(61139,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61139,35.14,0.06,107,20622,NULL,NULL,NULL,'NGC 2840',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61140,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61140,37.68,0.46,344,20623,70,NULL,NULL,'2MASX J09205542+0650120',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000172,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,140.2309583,6.83681,0.121,NULL,60705177961,948518405,14820600,17.1),(61141,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61141,37.95,0.23,389,20624,70,NULL,NULL,'2MASX J09205563+3934586',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00018,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,140.2317917,39.58311,0,NULL,64405748656,1006339822,15724059,17.2),(61142,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61142,35.5,0.2,126,20625,74.4,NULL,NULL,'CGCG 062-023',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00014,NULL,'14.9',0.3,NULL,NULL,NULL,NULL,NULL,1,140.233583333,10.69947,0.089,NULL,63651766841,994558856,15539982,14.9),(61143,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61143,35.14,0.49,107,20626,75,NULL,'IR','UGC 04964',NULL,'2011yCatp016004901K',2011,1,1.07,NULL,'G',0.000053,NULL,'15.6g',0.24,'Sdm:','Pair member (points to parent)',NULL,NULL,NULL,1,140.2357917,28.88175,0.037,NULL,64202511193,1003164237,15674441,15.6),(61144,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61144,37.35,0.46,295,20627,70,NULL,NULL,'2MASX J09205731+2106239',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000127,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,140.238917,21.10678,0.097,NULL,63708990665,995452979,15553952,17.6),(61145,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61145,37.88,0.46,377,20628,70,NULL,NULL,'2MASX J09205816+3009572',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00002,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,140.242333,30.16592,0,NULL,64202110996,1003157984,15674343,17.6),(61146,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61146,32.96,NULL,39.1,20629,NULL,NULL,NULL,'CGCG 062-024',NULL,'2015AstBu..70....1K',2015,1,0.8,NULL,'G',0.000133,NULL,'15.5g',0.44,NULL,NULL,NULL,NULL,NULL,1,140.248417,11.05922,0.109,NULL,63651203501,994550054,15539844,15.5),(61147,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61147,32.54,0.4,32.3,20630,75,NULL,NULL,'ESO 372- G 016',NULL,'2008Ap.....51..336K',2008,1,3.58,'Star superposed.','G',0.000053,NULL,'14.6',0.45,'SAb? sp        HII',NULL,NULL,NULL,NULL,1,140.252375,-33.19153,1.005,NULL,42887006856,670109482,10470460,14.6),(61148,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61148,32.58,0.43,32.8,20630,75,NULL,'3.6 micron, color + selection bias corrected','ESO 372- G 016',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61149,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61149,32.87,0.43,37.6,20630,75,NULL,'3.6 micron, color corrected','ESO 372- G 016',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61150,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61150,32.92,0.49,38.3,20630,75,NULL,'IR','ESO 372- G 016',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61151,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61151,33.13,0.2,42.3,20630,74.4,NULL,NULL,'ESO 372- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61152,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61152,33.41,NULL,48.1,20630,NULL,NULL,'Dipole','ESO 372- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61153,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61153,33.41,NULL,48.1,20630,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 372- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61154,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61154,33.42,NULL,48.2,20630,NULL,NULL,'Dipole + Quadrupole','ESO 372- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61155,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61155,37.77,0.46,358,20631,70,NULL,NULL,'2MASX J09210123+3216482',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000172,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,140.25525,32.28008,0,NULL,64198054975,1003094608,15673353,17.6),(61156,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61156,37.82,0.46,366,20632,70,NULL,NULL,'2MASX J09210232+3459442',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,140.259667,34.99556,0,NULL,64403496217,1006304628,15723509,18),(61157,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61157,34.99,0.49,99.6,20633,70,NULL,NULL,'2MASX J09210373-2014318',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000123,NULL,'13.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,140.265583,-20.24211,0.301,NULL,42321094097,661267095,10332298,13.1),(61158,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61158,37.72,0.27,350,20634,70,NULL,NULL,'2MASX J09210436+4050207',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000174,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,140.2682083,40.83903,0,NULL,64270528186,1004227002,15691046,16.4),(61159,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61159,37.75,0.46,355,20635,70,NULL,NULL,'SDSS J092106.41+581511.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00008,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,140.27675,58.25328,0.069,NULL,62016220001,969003437,15140678,18.6),(61160,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61160,38.08,0.46,412,20636,70,NULL,NULL,'2MASX J09210660+4614235',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,140.277625,46.23975,0,NULL,64278337824,1004349028,15692953,18),(61161,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61161,37.81,0.46,365,20637,70,NULL,NULL,'2MASX J09210761+1723541',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,140.2817083,17.39842,0.049,NULL,63858825498,997794148,15590533,18.1),(61162,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61162,36.6,0.46,208,20638,70,NULL,NULL,'2MASX J09210774+3148392',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000158,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,140.282417,31.81097,0,NULL,64198192141,1003096752,15673386,16.7),(61163,'IRAS','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61163,31.93,0.8,24.3,20639,75,NULL,'MAT, I','ESO 433- G 015',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000003,NULL,'15',1.2,'SB(s)c:',NULL,NULL,NULL,NULL,1,140.284958333,-31.89019,0.769,NULL,42836513621,669320525,10458133,15),(61164,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61164,31.78,0.32,22.7,20639,85,NULL,'I, raw','ESO 433- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61165,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61165,31.79,0.32,22.8,20639,85,NULL,'I, inv','ESO 433- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61166,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61166,32.08,0.43,26.1,20639,75,NULL,'MAT, I, raw','ESO 433- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61167,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61167,32.12,0.2,26.6,20639,74.4,NULL,NULL,'ESO 433- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61168,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61168,32.16,0.43,27,20639,75,NULL,'MAT, I, inv','ESO 433- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61169,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61169,32.23,0.55,27.9,20639,NULL,NULL,NULL,'ESO 433- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61170,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61170,32.27,0.4,28.5,20639,73,NULL,'opt','ESO 433- G 015',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61171,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61171,32.41,0.43,30.4,20639,75,NULL,'MAT, I, cor','ESO 433- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61172,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61172,32.47,0.49,31.3,20639,NULL,NULL,'Malmquist cor.','ESO 433- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61173,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61173,37.52,0.46,319,20640,70,NULL,NULL,'2MASX J09210865+0220016',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000083,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,140.286,2.33394,0.081,NULL,60728155302,948877426,14826209,16.8),(61174,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61174,37.96,0.33,391,20641,70,NULL,NULL,'2MASX J09210944+5028028',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,140.2895417,50.46731,0,NULL,63961856040,999404000,15615687,17.2),(61175,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61175,38.63,0.46,533,20642,70,NULL,NULL,'2MASX J09211147+3645416',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,140.29775,36.76169,0,NULL,64407253730,1006363339,15724427,18.4),(61176,'Tully est','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61176,32.17,0.8,27.1,20643,75,NULL,'B','NGC 2814',NULL,'1988NBGC.C....0000T',1988,1,1.2,NULL,'G',0.000013,NULL,'14.3',0.3,'Sb:','in a triple',NULL,NULL,NULL,1,140.297833333,64.25319,0.145,NULL,62253584363,972712255,15198628,14.3),(61177,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61177,35.55,0.46,129,20644,70,NULL,NULL,'CGCG 238-039',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.000163,NULL,'14.8g',0.52,'S0^-',NULL,NULL,NULL,NULL,1,140.303666667,44.95303,0,NULL,64264720653,1004136260,15689629,14.8),(61178,'IRAS','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61178,33.52,0.8,50.6,20645,75,NULL,'HMCL, I','IC 0534',NULL,'1997ApJS..109..333W',1997,1,0.83,NULL,'G',0.000006,NULL,'15.1g',0.36,'Sb',NULL,NULL,NULL,NULL,1,140.314375,3.15114,0.089,NULL,60729358386,948896224,14826503,15.1),(61179,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61179,33.55,0.4,51.4,20645,75,NULL,'HMCL, I, raw','IC 0534',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61180,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61180,33.61,0.4,52.7,20645,75,NULL,'HMCL, I, inv','IC 0534',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61181,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61181,33.85,0.4,59,20645,75,NULL,'HMCL, I, cor','IC 0534',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61182,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61182,36.05,0.46,162,20646,70,NULL,NULL,'CGCG 121-062',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.00019,NULL,'15.3g',0.54,NULL,NULL,NULL,NULL,NULL,1,140.319417,24.51808,0.089,NULL,63712596569,995509321,15554833,15.3),(61183,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61183,38.56,0.46,515,20647,70,NULL,NULL,'2MASX J09211867+5006209',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000152,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,140.327583,50.10572,0.005,NULL,63961391696,999396745,15615574,17.9),(61184,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61184,37.8,0.33,363,20648,70,NULL,NULL,'SDSS J092119.70+155253.8',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000182,NULL,'16.6g',0.35,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,140.332125,15.88164,0.069,NULL,63860982403,997827850,15591060,16.6),(61185,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61185,34.4,NULL,75.8,20649,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 372- G 018',NULL,'2010Ap&SS.325..163P',2010,1,1.57,NULL,'G',0.000033,NULL,'15.9',0.21,'Sc',NULL,NULL,NULL,NULL,1,140.335833,-34.42889,0.973,NULL,42887546516,670117914,10470592,15.9),(61186,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61186,34.4,NULL,76,20649,NULL,NULL,'Dipole + Quadrupole','ESO 372- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61187,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61187,34.42,NULL,76.4,20649,NULL,NULL,'Dipole','ESO 372- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61188,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61188,36.41,0.46,191,20650,70,NULL,NULL,'2MASX J09212159+1910275',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000187,NULL,'16.0g',0.39,NULL,NULL,NULL,NULL,NULL,1,140.340083,19.17428,0.049,NULL,63736811518,995887679,15560744,16),(61189,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61189,36.74,0.15,223,20651,70,NULL,NULL,'CGCG 264-104',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000113,NULL,'15.2g',0.52,'E0',NULL,NULL,NULL,NULL,1,140.342167,54.865,0.053,NULL,61875588555,966806071,15106344,15.2),(61190,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61190,35.38,0.46,119,20652,70,NULL,NULL,'CGCG 091-080',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000153,NULL,'15.2g',0.48,'E','Pair member (points to parent)',NULL,NULL,NULL,1,140.3462083,18.22389,0.045,NULL,63729220516,995769070,15558891,15.2),(61191,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61191,35.72,0.49,139,20653,75,NULL,'IR','UGC 04969',NULL,'2011yCatp016004901K',2011,1,1.43,NULL,'G',0.00003,NULL,'15.80',0.16,'Sb',NULL,NULL,NULL,NULL,1,140.350875,19.56656,0.081,NULL,63737241380,995894396,15560849,15.8),(61192,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61192,35.76,NULL,142,20653,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04969',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61193,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61193,35.78,NULL,143,20653,NULL,NULL,'Dipole + Quadrupole','UGC 04969',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61194,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61194,35.79,NULL,144,20653,NULL,NULL,'Dipole','UGC 04969',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61195,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61195,35.8,NULL,145,20653,NULL,NULL,NULL,'UGC 04969',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61196,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61196,37.8,0.33,363,20654,70,NULL,NULL,'2MASX J09212476+1553331',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000134,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,140.3532083,15.89239,0.069,NULL,63860982497,997827851,15591060,18),(61197,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61197,37.81,0.46,364,20655,70,NULL,NULL,'2MASX J09212496+5230569',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000077,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,140.35425,52.51594,0.009,NULL,63970507128,999539173,15617799,17.2),(61198,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61198,37.72,0.27,350,20656,70,NULL,NULL,'SDSS J092125.58+403528.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000141,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,140.356583,40.59136,0,NULL,64266191169,1004159237,15689988,18.5),(61199,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61199,37.15,0.46,269,20657,70,NULL,NULL,'2MASX J09212556+4956409',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,140.356667,49.94458,0.005,NULL,63961430596,999397353,15615583,17.2),(61200,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,'R',61200,31.86,NULL,23.6,20658,NULL,NULL,NULL,'AGC 193816',NULL,'2015AstBu..70....1K',2015,1,NULL,NULL,'RadioS',0.000093,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,140.36375,7.36639,0.117,NULL,60704749046,948511703,14820495,NULL),(61201,'FP','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61201,31.73,0.53,22.2,20659,70,NULL,NULL,'NGC 2855',NULL,'2014MNRAS.445.2677S',2014,1,2.5,NULL,'G',0.000057,NULL,'12.63',2.2,'(R)SA(rs)0/a  LINER?',NULL,NULL,NULL,NULL,1,140.364541667,-11.9095,0.149,NULL,42180977695,659077776,10298090,12.63),(61202,'Tully est','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61202,32.1,0.8,26.3,20659,75,NULL,'B','NGC 2855',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61203,'IRAS','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61203,30.25,0.8,11.2,20660,75,NULL,'MAT, I','UGCA 162',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000007,NULL,'14.8B',0.6,'IB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,140.3669583,-22.50189,0.257,NULL,42325548518,661336695,10333385,14.8),(61204,'Tully est','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61204,29.99,0.8,9.9,20660,75,NULL,NULL,'UGCA 162',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61205,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61205,30.43,0.39,12.2,20660,73,NULL,'opt','UGCA 162',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61206,'Tully-Fisher','2016-12-15 15:14:28','2016-12-16 11:19:35','1',NULL,NULL,61206,30.48,0.32,12.5,20660,85,NULL,'I, inv','UGCA 162',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61207,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61207,30.55,0.32,12.9,20660,85,NULL,'I, raw','UGCA 162',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61208,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61208,30.9,0.43,15.1,20660,75,NULL,'MAT, I, inv','UGCA 162',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61209,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61209,31.01,0.2,15.9,20660,74.4,NULL,NULL,'UGCA 162',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61210,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61210,31.08,0.43,16.5,20660,75,NULL,'MAT, I, raw','UGCA 162',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61211,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61211,31.18,0.4,17.2,20660,NULL,NULL,NULL,'UGCA 162',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61212,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61212,31.35,NULL,18.6,20660,NULL,NULL,NULL,'UGCA 162',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61213,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61213,31.42,0.43,19.3,20660,75,NULL,'MAT, I, cor','UGCA 162',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61214,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61214,37.91,0.46,381,20661,70,NULL,NULL,'2MASX J09212900+1423041',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,140.370791667,14.38442,0.081,NULL,63869504078,997961001,15593140,17.4),(61215,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61215,35.46,0.46,124,20662,70,NULL,NULL,'2MASX J09212943-0016082',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000077,NULL,'15.9g',0.35,'S0',NULL,NULL,NULL,NULL,1,140.3727083,-0.26889,0.093,NULL,41079272570,641863633,10029119,15.9),(61216,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61216,38.08,0.46,414,20663,70,NULL,NULL,'SDSS J092129.93+082115.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,140.37475,8.35425,0.101,NULL,63646108513,994470445,15538600,18.1),(61217,'Tully est','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61217,31.96,0.8,24.7,20664,75,NULL,'B','NGC 2820A',NULL,'1988NBGC.C....0000T',1988,1,0.5,NULL,'G',0.000027,NULL,'15.4',0.2,'I0 pec:','in an interacting pair',NULL,NULL,NULL,1,140.3752917,64.23869,0.145,NULL,62253582325,972712223,15198628,15.4),(61218,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61218,37.2,0.46,275,20665,70,NULL,NULL,'2MASX J09213090+6616088',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,140.378667,66.269,0.213,NULL,62256059473,972750929,15199233,17.4),(61219,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61219,36.74,0.15,223,20666,70,NULL,NULL,'2MASX J09213358+5500052',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000075,NULL,'16.2g',0.26,'S0',NULL,NULL,NULL,NULL,1,140.389875,55.00139,0.033,NULL,61876386150,966818533,15106539,16.2),(61220,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61220,37.86,0.23,373,20667,70,NULL,NULL,'2MASX J09213365+0235040',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000076,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,140.3902917,2.5845,0.085,NULL,60728182059,948877844,14826216,17.2),(61221,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61221,35.93,0.51,153,20668,70,NULL,NULL,'2MASX J09213393-3029400',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00011,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,140.3912917,-30.4945,0.721,NULL,42840271181,669379237,10459050,14.5),(61222,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61222,37.61,0.46,333,20669,70,NULL,NULL,'SDSS J092138.27+060401.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,140.409458333,6.067,0.097,NULL,60721696231,948776503,14824632,18.5),(61223,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61223,38.05,0.46,408,20670,70,NULL,NULL,'2MASX J09213853+1322190',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,140.41075,13.372,0.077,NULL,63856942659,997764729,15590073,17.4),(61224,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61224,38.28,0.46,454,20671,70,NULL,NULL,'2MASX J09213879+6104004',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000086,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,140.4114583,61.06697,0.117,NULL,62036786706,969324792,15145699,17.6),(61225,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61225,37.26,0.46,283,20672,70,NULL,NULL,'2MASX J09214007+2804592',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000154,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,140.4170417,28.08303,0.021,NULL,64202552669,1003164885,15674451,16.6),(61226,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61226,36.78,0.46,227,20673,70,NULL,NULL,'2MASX J09214100+5245039',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000104,NULL,'16.1g',0.39,'S0',NULL,NULL,NULL,NULL,1,140.42075,52.75106,0.009,NULL,63970514720,999539292,15617801,16.1),(61227,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61227,37.23,0.46,280,20674,70,NULL,NULL,'2MASX J09214323+4015174',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00018,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,140.430333,40.25489,0,NULL,64266185389,1004159146,15689986,16.8),(61228,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61228,37.72,0.46,350,20675,70,NULL,NULL,'2MASX J09214334+3709114',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,140.430583,37.15306,0,NULL,64407409968,1006365780,15724465,17.6),(61229,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61229,33.13,0.4,42.2,20676,75,NULL,NULL,'UGC 04970',NULL,'2008Ap.....51..336K',2008,1,1.57,NULL,'G',0.000037,NULL,'15.4g',0.26,'Sbc',NULL,NULL,NULL,NULL,1,140.439833333,39.52481,0,NULL,64405869262,1006341707,15724089,15.4),(61230,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61230,33.41,0.43,48.2,20676,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04970',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61231,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61231,33.53,0.43,50.9,20676,75,NULL,'3.6 micron, color corrected','UGC 04970',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61232,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61232,33.58,NULL,52,20676,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04970',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61233,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61233,33.59,NULL,52.2,20676,NULL,NULL,'Dipole + Quadrupole','UGC 04970',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61234,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61234,33.59,0.2,52.2,20676,74.4,NULL,NULL,'UGC 04970',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61235,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61235,33.6,NULL,52.5,20676,NULL,NULL,'Dipole','UGC 04970',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61236,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61236,33.68,0.49,54.5,20676,75,NULL,'IR','UGC 04970',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61237,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61237,33.69,0.52,54.6,20676,NULL,NULL,NULL,'UGC 04970',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61238,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61238,33.85,0.48,58.8,20676,NULL,NULL,'Malmquist cor.','UGC 04970',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61239,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61239,34,NULL,63.1,20676,NULL,NULL,NULL,'UGC 04970',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61240,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61240,32.08,0.4,26,20677,75,NULL,'B','NGC 2820',NULL,'1988NBGC.C....0000T',1988,1,4.31,NULL,'G',0.00002,NULL,'13.28',0.53,'SB(s)c pec sp','in an interacting pair',NULL,NULL,NULL,1,140.439916667,64.25794,0.145,NULL,62253595416,972712428,15198631,13.28),(61241,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61241,32.17,0.4,27.1,20677,NULL,NULL,'mean','NGC 2820',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61242,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61242,32.36,0.49,29.7,20677,75,NULL,'IR','NGC 2820',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61243,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61243,32.44,NULL,30.7,20677,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 2820',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61244,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61244,32.44,NULL,30.7,20677,NULL,NULL,'Dipole','NGC 2820',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61245,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61245,32.44,NULL,30.7,20677,NULL,NULL,'Dipole + Quadrupole','NGC 2820',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61246,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61246,32.51,NULL,31.7,20677,NULL,NULL,NULL,'NGC 2820',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61247,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61247,32.76,0.46,35.6,20677,NULL,NULL,'J','NGC 2820',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61248,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61248,32.85,0.47,37.1,20677,NULL,NULL,'H','NGC 2820',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61249,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61249,32.97,0.45,39.2,20677,NULL,NULL,'K','NGC 2820',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61250,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61250,36.4,0.52,190,20678,70,NULL,NULL,'2MASX J09214575-1407058',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.11',0.5,NULL,NULL,NULL,NULL,NULL,1,140.4405,-14.11833,0.153,NULL,42376421569,662131587,10345806,16.11),(61251,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61251,37.65,0.33,339,20679,70,NULL,NULL,'2MASX J09214762+1538490',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'16.0g',0.4,NULL,NULL,NULL,NULL,NULL,1,140.448583,15.64697,0.093,NULL,63860972679,997827698,15591057,16),(61252,'Tully est','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61252,31.91,0.8,24.1,20680,75,NULL,'B','NGC 2844',NULL,'1988NBGC.C....0000T',1988,1,1.5,'SDSS position is 4.6 arcsec southwest of the nucleus.','G',0.000033,NULL,'13.75',0.8,'SA(r)a:        HII','Group member',NULL,NULL,NULL,1,140.4500417,40.15125,0,NULL,64397253316,1006207083,15721985,13.75),(61253,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61253,32.54,0.4,32.2,20680,NULL,NULL,'mean','NGC 2844',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61254,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61254,33.22,0.45,44,20680,NULL,NULL,'K','NGC 2844',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61255,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61255,33.24,0.47,44.5,20680,NULL,NULL,'H','NGC 2844',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61256,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61256,33.25,0.46,44.6,20680,NULL,NULL,'J','NGC 2844',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61257,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61257,33.27,0.2,45.1,20680,74.4,NULL,NULL,'NGC 2844',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61258,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61258,33.28,0.43,45.2,20680,75,NULL,'3.6 micron, color corrected','NGC 2844',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61259,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61259,33.37,0.43,47.3,20680,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2844',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61260,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61260,37.96,0.33,391,20681,70,NULL,NULL,'SDSS J092148.39+502403.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000141,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,140.451667,50.40106,0.005,NULL,63961853784,999403965,15615686,18.5),(61261,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61261,36.21,0.67,174,20682,70,NULL,NULL,'2MASX J09214866-1719288',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,140.452833,-17.32469,0.157,NULL,42371177834,662049653,10344525,15.1),(61262,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61262,35.79,0.61,144,20683,70,NULL,NULL,'2MASX J09214880-1722438',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,140.453333,-17.37878,0.157,NULL,42371162067,662049407,10344521,14.5),(61263,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61263,36.78,0.46,227,20684,70,NULL,NULL,'2MASX J09215048+1507340',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.0g',0.37,NULL,NULL,NULL,NULL,NULL,1,140.4604583,15.126,0.077,NULL,63869704424,997964131,15593189,16),(61264,'D-Sigma','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61264,34.75,0.4,89.3,20685,75,NULL,'Edat, raw','UGC 04972',NULL,'1997ApJS..109..333W',1997,1,1.12,'TXS codes: lobes(W)','G',0.000033,NULL,'14.1g',0.88,'S0:',NULL,NULL,NULL,NULL,1,140.4645417,33.40186,0,NULL,64399460796,1006241574,15722524,14.1),(61265,'D-Sigma','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61265,35,0.4,100,20685,75,NULL,'Edat, cor','UGC 04972',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61266,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61266,35.25,0.15,112,20685,70,NULL,NULL,'UGC 04972',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61267,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61267,35.14,0.4,107,20685,NULL,NULL,'mean','UGC 04972',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61268,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61268,35.46,0.45,124,20685,NULL,NULL,'K','UGC 04972',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61269,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61269,37.86,0.23,373,20686,70,NULL,NULL,'2MASX J09215214+0244579',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000181,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,140.46725,2.74931,0.081,NULL,60727396199,948865565,14826024,17.9),(61270,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61270,36.76,0.46,225,20687,70,NULL,NULL,'2MASX J09215227+2530372',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000198,NULL,'16.1g',0.33,NULL,NULL,NULL,NULL,NULL,1,140.467667,25.51028,0.089,NULL,64196118635,1003064353,15672880,16.1),(61271,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61271,37.65,0.33,339,20688,70,NULL,NULL,'2MASX J09215482+1539079',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'16.9r',NULL,NULL,NULL,NULL,NULL,NULL,1,140.478417,15.65217,0.093,NULL,63860973443,997827710,15591057,16.9),(61272,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61272,37.86,0.23,373,20689,70,NULL,NULL,'2MASX J09215641+0241329',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000176,NULL,'16.7g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,140.4849583,2.69228,0.077,NULL,60728100518,948876570,14826196,16.7),(61273,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61273,35.25,0.15,112,20690,70,NULL,NULL,'CGCG 181-034',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000067,NULL,'15.3g',0.44,'S0^-',NULL,NULL,NULL,NULL,1,140.490958333,33.00639,0.017,NULL,64177079917,1002766873,15668232,15.3),(61274,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61274,36.51,0.46,201,20691,70,NULL,NULL,'2MASX J09215830+4803220',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000161,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,140.492958333,48.05628,0,NULL,64231661854,1003619716,15681558,16.5),(61275,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61275,36.74,0.15,223,20692,70,NULL,NULL,'2MASX J09215879+5456372',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000073,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,140.495083,54.94375,0.033,NULL,61875516723,966804948,15106327,17.4),(61276,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61276,37.59,0.46,330,20693,70,NULL,NULL,'SDSS J092201.16+170142.3',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000171,NULL,'18.0g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,140.504833,17.02842,0.065,NULL,63861697586,997839024,15591234,18),(61277,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61277,36.52,0.46,202,20694,70,NULL,NULL,'2MASX J09220248+0559519',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000191,NULL,'16.3g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,140.510417,5.99792,0.097,NULL,60721515447,948773678,14824588,16.3),(61278,'Cepheids','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61278,30.58,0.06,13.1,20695,NULL,NULL,'18, VI','NGC 2841',NULL,'2001ApJ...559..243M',2001,1,8.1,NULL,'G',0.00001,NULL,'9.53B',3.5,'SA(r)b:;LINER  Sy1','Isolated galaxy',NULL,NULL,'LINER',1,140.510958333,50.97653,0,NULL,63961676252,999401191,15615643,9.53),(61279,'Cepheids','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61279,30.74,0.23,14.1,20695,NULL,NULL,'18, VI','NGC 2841',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61280,'Cepheids','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61280,30.74,0.23,14.1,20695,NULL,NULL,'18, VI, Zcor','NGC 2841',NULL,'2001ApJ...559..243M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61281,'Cepheids','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61281,30.75,0.06,14.1,20695,NULL,18.54,'LMC ZP','NGC 2841',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61282,'Cepheids','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61282,30.75,NULL,14.1,20695,NULL,18.54,NULL,'NGC 2841',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61283,'Cepheids','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61283,30.82,0.07,14.6,20695,74.4,NULL,NULL,'NGC 2841',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61284,'SNIa','2016-12-15 15:14:29','2016-12-16 11:19:35','1','SN 1999by',NULL,61284,30.2,0.2,11,20695,65,NULL,'MLCS','NGC 2841',NULL,'2000A&A...361...63T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61285,'SNIa','2016-12-15 15:14:29','2016-12-16 11:19:35','1','SN 1999by',NULL,61285,30.39,0.12,12,20695,NULL,NULL,NULL,'NGC 2841',NULL,'2002ApJ...568..791H',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61286,'SNIa','2016-12-15 15:14:29','2016-12-16 11:19:35','1','SN 1999by',NULL,61286,30.82,0.07,14.6,20695,74.4,NULL,NULL,'NGC 2841',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61287,'SNIa','2016-12-15 15:14:29','2016-12-16 11:19:35','1','Sn 1999by',NULL,61287,31.16,0.07,17,20695,65,NULL,'MLCS2k2','NGC 2841',0.002128,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61288,'SNIa','2016-12-15 15:14:29','2016-12-16 11:19:35','1','SN 1999by',NULL,61288,31.16,0.15,17.1,20695,65,NULL,'MLCS','NGC 2841',NULL,'2001AJ....121.3127V',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61289,'Grav. Stability Gas. Disk','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61289,30.38,NULL,11.9,20695,NULL,NULL,NULL,'NGC 2841',NULL,'1996AstL...22...71Z',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61290,'HII region diameter','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61290,29.54,0.04,8.07,20695,NULL,NULL,'Photographic, 463 \'dark cloud\' diameters','NGC 2841',NULL,'1982AN....303..329O',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61291,'IRAS','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61291,30.5,0.8,12.6,20695,75,NULL,'A82, H','NGC 2841',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61292,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61292,30.39,0.4,12,20695,75,NULL,'B','NGC 2841',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61293,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61293,30.74,0.06,14.1,20695,75,NULL,NULL,'NGC 2841',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61294,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61294,30.82,0.07,14.6,20695,74.4,NULL,NULL,'NGC 2841',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61295,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61295,30.87,NULL,14.9,20695,NULL,NULL,'B','NGC 2841',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61296,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61296,30.94,0.2,15.4,20695,NULL,NULL,'B','NGC 2841',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61297,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61297,31.25,NULL,17.8,20695,NULL,NULL,'I','NGC 2841',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61298,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61298,31.3,0.3,18.2,20695,NULL,18.45,'SN 1957A host','NGC 2841',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61299,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61299,31.32,0.35,18.4,20695,NULL,NULL,NULL,'NGC 2841',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61300,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61300,31.48,0.36,19.7,20695,NULL,NULL,'Malmquist cor.','NGC 2841',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61301,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61301,31.49,0.36,19.9,20695,NULL,NULL,NULL,'NGC 2841',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61302,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61302,31.67,0.4,21.6,20695,75,NULL,'HOSTS SN 1999by','NGC 2841',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61303,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61303,31.67,0.4,21.6,20695,75,NULL,'HOSTS SN 1999by','NGC 2841',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61304,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61304,31.74,NULL,22.3,20695,NULL,NULL,'LEDA [April 2006]','NGC 2841',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61305,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61305,31.74,0.43,22.3,20695,75,NULL,'3.6 micron, color corrected','NGC 2841',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61306,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61306,31.76,0.47,22.5,20695,75,NULL,'A82, H, raw','NGC 2841',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61307,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61307,31.86,0.42,23.6,20695,NULL,18.48,'3.6 micron','NGC 2841',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61308,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61308,31.99,0.43,25,20695,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2841',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61309,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61309,32.04,0.47,25.6,20695,75,NULL,'A82, H, cor','NGC 2841',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61310,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61310,32.08,0.47,26.1,20695,75,NULL,'A82, H, inv','NGC 2841',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61311,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61311,35.09,0.08,104,20696,NULL,NULL,NULL,'KUG 0919+340',NULL,'2009ApJS..182..474S',2009,1,0.58,NULL,'G',0.000027,NULL,'16.5g',0.26,'Sc',NULL,NULL,NULL,NULL,1,140.512333,33.86439,0,NULL,64400284456,1006254444,15722725,16.5),(61312,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61312,37.62,0.46,335,20697,70,NULL,NULL,'2MASX J09220399+0159189',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000082,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,140.516541667,1.98864,0.085,NULL,60727737779,948870902,14826107,17),(61313,'D-Sigma','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61313,33.38,0.4,47.3,20698,75,NULL,'Edat, raw','NGC 2810',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000025,NULL,'13.24',1.7,'E',NULL,NULL,NULL,NULL,1,140.51875,71.84403,0.109,NULL,62094436625,970225572,15159774,13.24),(61314,'D-Sigma','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61314,33.71,0.4,55.2,20698,75,NULL,'Edat, cor','NGC 2810',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61315,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61315,33.59,0.4,52.2,20698,NULL,NULL,'mean','NGC 2810',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61316,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61316,33.9,0.45,60.3,20698,NULL,NULL,'K','NGC 2810',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61317,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61317,38.13,0.46,422,20699,70,NULL,NULL,'2MASX J09220559+3717313',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00017,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,140.523375,37.29206,0,NULL,64407290161,1006363908,15724436,17.7),(61318,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61318,38.07,0.33,412,20700,70,NULL,NULL,'2MASX J09220616+3119049',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000184,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,140.525667,31.318,0.017,NULL,64198637248,1003103707,15673495,16.6),(61319,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61319,37.13,0.46,267,20701,70,NULL,NULL,'2MASX J09220738+0023569',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000066,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,140.530625,0.39903,0.105,NULL,60670706628,947979791,14812184,17.5),(61320,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61320,37.2,0.46,275,20702,70,NULL,NULL,'2MASX J09220825+3754103',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,140.534416667,37.90281,0.009,NULL,64407653512,1006369586,15724524,17.4),(61321,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61321,37.11,0.46,264,20703,70,NULL,NULL,'2MASX J09220886+0900496',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000145,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,140.537041667,9.01394,0.121,NULL,63646346620,994474165,15538658,17.8),(61322,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61322,36.6,0.41,209,20704,NULL,NULL,'Malmquist cor.','2MASX J09220975-0032218',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000017,NULL,'16.5g',0.32,'Sbc',NULL,NULL,NULL,NULL,1,140.540583,-0.53956,0.089,NULL,41125257209,642582143,10040345,16.5),(61323,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61323,36.68,0.39,217,20704,NULL,NULL,NULL,'2MASX J09220975-0032218',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61324,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61324,36.72,0.2,221,20704,74.4,NULL,NULL,'2MASX J09220975-0032218',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61325,'D-Sigma','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61325,34.75,0.4,89.3,20705,75,NULL,'Edat, raw','UGC 04974',NULL,'1997ApJS..109..333W',1997,1,1.11,NULL,'G',0.000039,NULL,'14.0g',0.9,'S0:','in a radial-velocity based grouping',NULL,NULL,NULL,1,140.543083,33.84856,0,NULL,64400284728,1006254448,15722725,14),(61326,'D-Sigma','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61326,35,0.4,100,20705,75,NULL,'Edat, cor','UGC 04974',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61327,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61327,35.25,0.15,112,20705,70,NULL,NULL,'UGC 04974',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61328,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61328,35.11,0.4,105,20705,NULL,NULL,'mean','UGC 04974',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61329,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61329,35.44,0.45,123,20705,NULL,NULL,'K','UGC 04974',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61330,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61330,35.25,0.15,112,20706,70,NULL,NULL,'2MASX J09221101+3318019',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000067,NULL,'15.7g',0.48,'S0',NULL,NULL,NULL,NULL,1,140.545916667,33.30069,0,NULL,64399452306,1006241442,15722522,15.7),(61331,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61331,37.05,0.59,257,20707,70,NULL,NULL,'2MASX J09221124-1028524',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.41',NULL,NULL,NULL,NULL,NULL,NULL,1,140.54675,-10.48142,0.169,NULL,42193184744,659268511,10301070,16.41),(61332,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61332,38.19,0.46,434,20708,70,NULL,NULL,'2MASX J09221283+1253290',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,140.5534583,12.89153,0.065,NULL,63857215042,997768985,15590140,17.8),(61333,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61333,38.07,0.33,412,20709,70,NULL,NULL,'SDSS J092214.43+312400.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000131,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,140.560125,31.40011,0.017,NULL,64198632242,1003103628,15673494,18.7),(61334,'IRAS','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61334,34.58,0.8,82.2,20710,75,NULL,'HMCL, I','KUG 0919+341',NULL,'1997ApJS..109..333W',1997,1,0.72,NULL,'G',0.000012,NULL,'16.0g',0.24,'Sc',NULL,NULL,NULL,NULL,1,140.561,33.93769,0,NULL,64400279203,1006254362,15722724,16),(61335,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61335,34.8,0.4,91.3,20710,75,NULL,'HMCL, I, raw','KUG 0919+341',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61336,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61336,34.85,0.4,93.2,20710,75,NULL,'HMCL, I, inv','KUG 0919+341',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61337,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61337,34.97,0.1,98.8,20710,NULL,NULL,NULL,'KUG 0919+341',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61338,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61338,35.01,0.4,100,20710,75,NULL,'HMCL, I, cor','KUG 0919+341',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61339,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61339,35.06,0.2,103,20710,74.4,NULL,NULL,'KUG 0919+341',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61340,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61340,37.86,0.23,373,20711,70,NULL,NULL,'SDSS J092215.91+024005.8',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000074,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,140.566333,2.66828,0.077,NULL,60728222151,948878471,14826226,17.6),(61341,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61341,36.99,0.23,250,20712,70,NULL,NULL,'2MASX J09221735-0032488',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000115,NULL,'15.5g',0.43,'BrClG',NULL,NULL,NULL,NULL,1,140.5722083,-0.54694,0.089,NULL,41125254538,642582102,10040345,15.5),(61342,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61342,38.24,0.46,444,20713,70,NULL,NULL,'2MASX J09221780+2042225',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,140.574167,20.70633,0.089,NULL,63708903261,995451613,15553931,18.1),(61343,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61343,36.41,0.46,191,20714,70,NULL,NULL,'2MASX J09221825+4220260',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000168,NULL,'16.1g',0.33,'S0/a',NULL,NULL,NULL,NULL,1,140.576166667,42.34061,0.021,NULL,64273074312,1004266786,15691668,16.1),(61344,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61344,37.52,0.73,319,20715,NULL,NULL,'Malmquist cor.','2MASX J09222262-0029198',NULL,'2009ApJS..182..474S',2009,1,0.55,NULL,'G',0.000023,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,140.594375,-0.48881,0.089,NULL,41125263280,642582238,10040347,16.3),(61345,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61345,37.81,0.64,365,20715,NULL,NULL,NULL,'2MASX J09222262-0029198',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61346,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61346,37.85,0.2,372,20715,74.4,NULL,NULL,'2MASX J09222262-0029198',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61347,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61347,36.7,0.46,219,20716,70,NULL,NULL,'2MASX J09222318+1833037',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000174,NULL,'16.1g',0.38,NULL,NULL,NULL,NULL,NULL,1,140.596667,18.55114,0.025,NULL,63729114762,995767418,15558865,16.1),(61348,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61348,37.28,0.46,285,20717,70,NULL,NULL,'SDSS J092223.25+052845.8',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,140.596916667,5.47942,0.105,NULL,60724559732,948821245,14825331,17.6),(61349,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61349,38.64,0.46,536,20718,70,NULL,NULL,'SDSS J092223.47+464329.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000151,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,140.597875,46.72478,0,NULL,64277852351,1004341442,15692835,18.8),(61350,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61350,35.19,0.53,109,20719,70,NULL,NULL,'2MASX J09222381-1720324',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,140.599167,-17.34225,0.157,NULL,42300139988,660939687,10327182,14.6),(61351,'Sosies','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61351,32.94,0.12,38.7,20720,NULL,NULL,NULL,'ESO 126- G 010',NULL,'2002A&A...393...57T',2002,1,1.7,NULL,'G',0.000017,NULL,'13.84',0.7,'SB(r)b:',NULL,NULL,NULL,NULL,1,140.603875,-61.04953,NULL,NULL,40573458284,633960285,9905629,13.84),(61352,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61352,32.16,0.46,27,20720,NULL,NULL,'J','ESO 126- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61353,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61353,32.17,0.47,27.2,20720,NULL,NULL,'H','ESO 126- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61354,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61354,32.24,0.45,28.1,20720,NULL,NULL,'K','ESO 126- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61355,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61355,32.46,0.4,31.1,20720,NULL,NULL,'mean','ESO 126- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61356,'Brightest Stars','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61356,29.14,NULL,6.7,20721,NULL,NULL,'3B','UGC 04945',NULL,'1993A&A...275...39T',1993,1,1.3,NULL,'G',0.000003,NULL,'17.',1.1,'Im',NULL,NULL,NULL,NULL,1,140.605,75.76583,0,NULL,61419445664,959678838,14994981,17),(61357,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61357,37.98,0.46,395,20722,70,NULL,NULL,'2MASX J09222808+0140249',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000095,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,140.6169583,1.67358,0.081,NULL,60728562333,948883786,14826309,17.4),(61358,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61358,38.01,0.46,400,20723,70,NULL,NULL,'2MASX J09222858+0736089',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000138,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,140.619083,7.60239,0.101,NULL,60707623594,948556618,14821197,17.8),(61359,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61359,35.41,0.46,121,20724,70,NULL,NULL,'CGCG 238-042',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000167,NULL,'15.1g',0.65,'E','Pair member (points to parent)',NULL,NULL,NULL,1,140.622875,47.26244,0,NULL,64277953900,1004343029,15692859,15.1),(61360,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61360,37.74,0.27,353,20725,70,NULL,NULL,'2MASX J09222998+1320559',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.9g',0.11,NULL,NULL,NULL,NULL,NULL,1,140.625083,13.34906,0.073,NULL,63856961086,997765016,15590078,18.9),(61361,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61361,36.32,0.46,184,20726,70,NULL,NULL,'2MASX J09223077+2151588',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000127,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,140.628166667,21.86631,0.081,NULL,63708739030,995449047,15553891,16.5),(61362,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61362,36.43,0.46,193,20727,70,NULL,NULL,'2MASX J09223092-0051342',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000086,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,140.628875,-0.85953,0.085,NULL,41126122520,642595664,10040557,16.3),(61363,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61363,37.25,0.46,281,20728,70,NULL,NULL,'2MASX J09223168+1707489',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000147,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,140.6319583,17.13017,0.109,NULL,63861686518,997838851,15591232,17.1),(61364,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61364,37.74,0.27,353,20729,70,NULL,NULL,'2MASX J09223236+1320330',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,140.634875,13.34256,0.073,NULL,63856959746,997764996,15590078,NULL),(61365,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61365,37.51,0.46,317,20730,70,NULL,NULL,'SDSS J092233.43+052742.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000165,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,140.639333333,5.46189,0.105,NULL,60724557920,948821217,14825331,18.3),(61366,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61366,36.33,0.56,184,20731,70,NULL,NULL,'2MASX J09223416-1217180',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,140.642333,-12.28833,0.141,NULL,42364118073,661939344,10342802,14.4),(61367,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61367,35.47,0.49,124,20732,75,NULL,'IR','LSBC F565-01',NULL,'2011yCatp016004901K',2011,1,1.07,NULL,'G',0.000013,NULL,'16.0g',0.27,'Sc',NULL,NULL,NULL,NULL,1,140.647917,20.85178,0.089,NULL,63709111388,995454865,15553982,16),(61368,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61368,37.74,0.27,353,20733,70,NULL,NULL,'2MASX J09223606+1323180',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,140.650333333,13.38836,0.073,NULL,63856929527,997764523,15590070,17.8),(61369,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61369,36.99,0.23,250,20734,70,NULL,NULL,'2MASX J09223660-0024322',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.00011,NULL,'15.7g',0.45,'AGN',NULL,NULL,NULL,NULL,1,140.652375,-0.40903,0.089,NULL,41125393986,642584281,10040379,15.7),(61370,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61370,38.09,0.46,415,20735,70,NULL,NULL,'2MASX J09223847+5243367',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000088,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,140.660125,52.72683,0.009,NULL,63970690727,999542042,15617844,17.6),(61371,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61371,36.54,0.33,203,20736,70,NULL,NULL,'2MASX J09224143+6034451',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000098,NULL,'16.0g',0.35,'E0',NULL,NULL,NULL,NULL,1,140.672375,60.57917,0.097,NULL,62068910800,969826731,15153542,16),(61372,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61372,35.47,0.46,124,20737,70,NULL,NULL,'2MASX J09224472+0844519',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000177,NULL,'15.5g',0.47,'S0^-',NULL,NULL,NULL,NULL,1,140.6862917,8.74786,0.121,NULL,63646402872,994475044,15538672,15.5),(61373,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61373,36.99,0.23,250,20738,70,NULL,NULL,'2MASX J09224493-0020562',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000106,NULL,'15.9g',0.4,'E0',NULL,NULL,NULL,NULL,1,140.68725,-0.34883,0.089,NULL,41125171554,642580805,10040325,15.9),(61374,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61374,37.7,0.46,347,20739,70,NULL,NULL,'2MASX J09224718+2709477',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000179,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,140.696541667,27.16342,0.013,NULL,64205680913,1003213764,15675215,17),(61375,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61375,39,0.46,630,20740,70,NULL,NULL,'SDSS J092247.36+443242.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000172,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,140.697375,44.54525,0.033,NULL,64264270090,1004129220,15689519,18.6),(61376,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61376,37.54,0.46,323,20741,70,NULL,NULL,'2MASX J09224869+3152589',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,140.702917,31.88319,0,NULL,64206482191,1003226284,15675410,17.9),(61377,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61377,37.55,0.19,324,20742,70,NULL,NULL,'SDSS J092249.48+130909.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,140.706166667,13.15275,0.065,NULL,63856874784,997763668,15590057,18.5),(61378,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61378,36.79,0.46,228,20743,70,NULL,NULL,'2MASX J09225044+3845405',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000167,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,140.710125,38.76119,0,NULL,64406660981,1006354077,15724282,16.7),(61379,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61379,35.67,0.46,136,20744,70,NULL,NULL,'2MASX J09225289+5132438',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000164,NULL,'15.9g',0.42,'S0/a',NULL,NULL,NULL,NULL,1,140.7204583,51.54547,0,NULL,63969807523,999528242,15617628,15.9),(61380,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61380,35.66,0.47,135,20745,NULL,NULL,'H','UGC 04985',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000033,NULL,'14.54',0.6,'SAB(s)b',NULL,NULL,NULL,NULL,1,140.721083333,21.97519,0.121,NULL,63716524697,995570698,15555792,14.54),(61381,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61381,35.71,0.45,139,20745,NULL,NULL,'K','UGC 04985',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61382,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61382,35.72,0.46,139,20745,NULL,NULL,'J','UGC 04985',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61383,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61383,35.79,0.4,144,20745,NULL,NULL,'mean','UGC 04985',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61384,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61384,38.55,0.46,512,20746,70,NULL,NULL,'SDSS J092253.85+550532.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,140.724417,55.09239,0.037,NULL,61875502001,966804718,15106323,18.7),(61385,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61385,37.33,0.46,293,20747,70,NULL,NULL,'2MASX J09225654+1528489',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000154,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,140.7357083,15.48033,0.085,NULL,63868843816,997950684,15592979,17),(61386,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61386,30.09,NULL,10.4,20748,NULL,NULL,NULL,'AGC 198508',NULL,'2013AJ....145..101K',2013,1,NULL,NULL,'RadioS',0.000048,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,140.739583,24.9475,0.073,NULL,63713384072,995521626,15555025,NULL),(61387,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61387,35.45,0.52,123,20749,70,NULL,NULL,'2MASX J09225853-1725221',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000123,NULL,'15.97',NULL,NULL,NULL,NULL,NULL,NULL,1,140.7439583,-17.42253,0.173,NULL,42300118263,660939347,10327177,15.97),(61388,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61388,35.77,0.46,143,20750,70,NULL,NULL,'2MASX J09230094+2417386',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000093,NULL,'15.1g',0.52,NULL,NULL,NULL,NULL,NULL,1,140.7539583,24.29414,0.061,NULL,63712985497,995515398,15554928,15.1),(61389,'IRAS','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61389,32.26,0.8,28.3,20751,75,NULL,'MAT, I','IC 2469',NULL,'1997ApJS..109..333W',1997,1,4.7,'1992ApJS...81..413M gives V = 2607 +- 10 km/sec.','G',0.000023,NULL,'12',1,'SAB:(rs)ab',NULL,NULL,NULL,NULL,1,140.754417,-32.44975,0.769,NULL,42866025938,669781655,10465338,12),(61390,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61390,31.42,0.43,19.2,20751,75,NULL,'MAT, I, raw','IC 2469',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61391,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61391,31.63,0.32,21.2,20751,85,NULL,'I, raw','IC 2469',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61392,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61392,31.7,0.49,21.9,20751,75,NULL,'IR','IC 2469',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61393,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61393,31.71,0.32,22,20751,85,NULL,'I, inv','IC 2469',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61394,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61394,31.72,0.43,22.1,20751,75,NULL,'MAT, I, inv','IC 2469',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61395,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61395,31.74,0.2,22.3,20751,74.4,NULL,NULL,'IC 2469',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61396,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61396,31.79,0.43,22.8,20751,75,NULL,'MAT, I, cor','IC 2469',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61397,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61397,31.87,0.4,23.7,20751,75,NULL,NULL,'IC 2469',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61398,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61398,31.87,0.39,23.7,20751,73,NULL,'IR','IC 2469',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61399,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61399,31.89,0.43,23.9,20751,75,NULL,'3.6 micron, color corrected','IC 2469',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61400,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61400,32.12,0.43,26.6,20751,75,NULL,'3.6 micron, color + selection bias corrected','IC 2469',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61401,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61401,37.65,0.46,338,20752,70,NULL,NULL,'2MASX J09230165+5917461',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000082,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,140.757041667,59.29622,0.041,NULL,62067901486,969810960,15153296,17.5),(61402,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61402,37.7,0.27,347,20753,70,NULL,NULL,'2MASX J09230184+5253537',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000085,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,140.757833,52.89836,0.013,NULL,63968872287,999513629,15617400,17.3),(61403,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61403,33.11,0.43,41.8,20754,75,NULL,'3.6 micron, color + selection bias corrected','UGC 04982',NULL,'2014MNRAS.444..527S',2014,1,1.45,NULL,'G',0.000108,NULL,'14.1g',0.44,'Sdm:','Field galaxy',NULL,NULL,NULL,1,140.762875,44.55494,0.033,NULL,64264273830,1004129278,15689519,14.1),(61404,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61404,33.14,0.43,42.5,20754,75,NULL,'3.6 micron, color corrected','UGC 04982',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61405,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61405,33.21,0.2,43.9,20754,74.4,NULL,NULL,'UGC 04982',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61406,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61406,38.35,0.46,467,20755,70,NULL,NULL,'2MASX J09230340+0746372',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,140.764041667,7.77711,0.089,NULL,60706544929,948539764,14820933,17.4),(61407,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61407,36.26,NULL,179,20756,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0883',NULL,'2010Ap&SS.325..163P',2010,1,1.04,NULL,'G',0.000133,NULL,'16.4',0.11,'Sbc',NULL,NULL,NULL,NULL,1,140.780458333,22.69217,0.101,NULL,63716606459,995571975,15555812,16.4),(61408,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61408,36.28,NULL,180,20756,NULL,NULL,NULL,'FGC 0883',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61409,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61409,36.28,NULL,180,20756,NULL,NULL,'Dipole + Quadrupole','FGC 0883',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61410,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61410,36.31,NULL,183,20756,NULL,NULL,'Dipole','FGC 0883',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61411,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61411,36.46,0.46,196,20757,70,NULL,NULL,'SDSS J092308.06+050639.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,140.783583,5.11092,0.105,NULL,60724178289,948815285,14825238,17.6),(61412,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61412,37.68,0.46,344,20758,70,NULL,NULL,'2MASX J09230860+3715124',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00015,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,140.785833,37.2535,0,NULL,64407332387,1006364568,15724446,17.1),(61413,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61413,37.68,0.46,343,20759,70,NULL,NULL,'SDSS J092311.41+380144.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000174,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,140.797583,38.02894,0.009,NULL,64406776091,1006355876,15724310,18),(61414,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61414,33.42,NULL,48.4,20760,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 497- G 042',NULL,'2010Ap&SS.325..163P',2010,1,1.93,'Stars superposed.','G',NULL,NULL,'17',0.22,'Sc','Pair member (points to parent)',NULL,NULL,NULL,1,140.799875,-26.94072,0.433,NULL,42846401869,669475029,10460547,17),(61415,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61415,33.43,NULL,48.6,20760,NULL,NULL,'Dipole','ESO 497- G 042',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61416,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61416,33.44,NULL,48.8,20760,NULL,NULL,'Dipole + Quadrupole','ESO 497- G 042',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61417,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61417,36.55,0.46,205,20761,70,NULL,NULL,'2MASX J09231224+0320498',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,140.801,3.34719,0.097,NULL,60730296479,948910882,14826732,17.2),(61418,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61418,36.71,0.46,219,20762,70,NULL,NULL,'2MASX J09231326+5656221',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000103,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,140.8055,56.93947,0.085,NULL,61884261056,966941579,15108462,16.5),(61419,'IRAS','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61419,34.23,0.8,70.2,20763,75,NULL,'HMCL, I','UGC 04993',NULL,'1997ApJS..109..333W',1997,1,1.13,NULL,'G',0.000049,NULL,'15.6g',0.36,'S',NULL,NULL,NULL,NULL,1,140.805708333,2.60131,0.077,NULL,60727919708,948873745,14826152,15.6),(61420,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61420,34.17,0.4,68.1,20763,75,NULL,'HMCL, I, raw','UGC 04993',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61421,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61421,34.23,0.4,70.2,20763,75,NULL,'HMCL, I, inv','UGC 04993',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61422,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61422,34.51,0.4,79.8,20763,75,NULL,'HMCL, I, cor','UGC 04993',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61423,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61423,36.54,0.33,203,20764,70,NULL,NULL,'2MASX J09231385+6031422',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000076,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,140.807833333,60.52839,0.097,NULL,62068941632,969827213,15153550,17),(61424,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61424,34.28,0.49,71.6,20765,75,NULL,'IR','ESO 037- G 002',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.000033,NULL,'14.62',1,'Sc',NULL,NULL,NULL,NULL,1,140.810667,-75.01267,0.513,NULL,39814031517,622094242,9720222,14.62),(61425,'Tully est','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61425,32.33,0.8,29.3,20766,75,NULL,'B','NGC 2852',NULL,'1988NBGC.C....0000T',1988,1,0.9,NULL,'G',0.000017,NULL,'14.09',0.8,'SAB(r)a?','Pair member (points to parent)',NULL,NULL,NULL,1,140.8107917,40.16381,0,NULL,64392006540,1006125102,15720704,14.09),(61426,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61426,37.42,0.46,304,20767,70,NULL,NULL,'2MASX J09231509+3905189',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000155,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,140.812875,39.08861,0,NULL,64406509520,1006351711,15724245,16.9),(61427,'IRAS','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61427,33.52,0.8,50.7,20768,75,NULL,'CF, r','UGC 04996',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000013,NULL,'14.21',0.5,'SAB(s)bc:      HII',NULL,NULL,NULL,NULL,1,140.815333,-0.72803,0.085,NULL,41125348128,642583564,10040368,14.21),(61428,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61428,33.29,0.38,45.5,20768,75,NULL,'CF, r, inv','UGC 04996',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61429,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61429,33.3,0.38,45.6,20768,75,NULL,'CF, r, raw','UGC 04996',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61430,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61430,33.39,0.2,47.6,20768,74.4,NULL,NULL,'UGC 04996',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61431,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61431,33.53,0.48,50.7,20768,NULL,NULL,NULL,'UGC 04996',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61432,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61432,33.53,0.38,50.7,20768,75,NULL,'CF, r, cor','UGC 04996',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61433,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61433,33.61,0.46,52.7,20768,NULL,NULL,'Malmquist cor.','UGC 04996',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61434,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61434,37.98,0.46,394,20769,70,NULL,NULL,'2MASX J09231692+0726142',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,140.8205,7.43728,0.101,NULL,60707824470,948559757,14821246,17.5),(61435,'Tully est','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61435,32.25,0.8,28.2,20770,75,NULL,'B','NGC 2853',NULL,'1988NBGC.C....0000T',1988,1,1.22,NULL,'G',0.00014,NULL,'14.4g',0.73,'SB0:','Pair member (points to parent)',NULL,NULL,NULL,1,140.8222083,40.20006,0,NULL,64258835877,1004044310,15688192,14.4),(61436,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61436,36.81,0.46,231,20771,70,NULL,NULL,'SDSS J092317.92-003406.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000084,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,140.824667,-0.56844,0.089,NULL,41125405419,642584459,10040382,18),(61437,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61437,36.94,0.33,245,20772,70,NULL,NULL,'2MASX J09231971+2946087',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00012,NULL,'16.9g',0.26,'S0             AGN:',NULL,NULL,NULL,NULL,1,140.83225,29.76919,0.009,NULL,64200909500,1003139210,15674050,16.9),(61438,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61438,33.81,0.47,57.9,20773,70,NULL,NULL,'2MASX J09232130-7135368',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000107,NULL,'14.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,140.838666667,-71.59361,0.597,NULL,40703859001,635997796,9937465,14.9),(61439,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61439,35.8,0.17,144,20774,70,NULL,NULL,'CGCG 121-069',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000103,NULL,'15.4g',0.52,NULL,'Group member',NULL,NULL,NULL,1,140.843083,22.43639,0.101,NULL,63716661197,995572831,15555825,15.4),(61440,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61440,36.99,0.23,250,20775,70,NULL,NULL,'2MASX J09232351-0024122',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000089,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,140.847958333,-0.40347,0.089,NULL,41125365518,642583836,10040372,17.1),(61441,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61441,36.94,0.33,245,20776,70,NULL,NULL,'2MASX J09232393+2948137',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00006,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,140.8497917,29.80386,0.009,NULL,64200446094,1003131970,15673937,17.5),(61442,'D-Sigma','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61442,32.53,0.4,32,20777,75,NULL,'Edat, raw','NGC 2887',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000083,NULL,'12.77',1.5,'SA(s)0-?','Pair member (points to parent)',NULL,NULL,NULL,1,140.8502083,-63.81256,NULL,NULL,40577377873,634021529,9906586,12.77),(61443,'D-Sigma','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61443,32.86,0.4,37.4,20777,75,NULL,'Edat, cor','NGC 2887',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61444,'Tully est','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61444,32.75,0.8,35.5,20777,75,NULL,NULL,'NGC 2887',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61445,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61445,33.09,0.45,41.6,20777,NULL,NULL,'K','NGC 2887',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61446,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61446,33.19,0.4,43.4,20777,NULL,NULL,'mean','NGC 2887',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61447,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61447,37.5,0.46,316,20778,70,NULL,NULL,'SDSS J092324.56+501723.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00013,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,140.852375,50.28978,0.005,NULL,63961701862,999401591,15615649,18.2),(61448,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61448,37.88,0.46,377,20779,70,NULL,NULL,'2MASX J09232564+3131549',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,140.8570417,31.53206,0,NULL,64206805684,1003231338,15675489,18),(61449,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61449,36.74,0.15,223,20780,70,NULL,NULL,'SDSS J092325.80+544954.4',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000088,NULL,'17.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,140.857625,54.83169,0.045,NULL,61875663433,966807241,15106363,17.5),(61450,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61450,36.88,0.46,237,20781,70,NULL,NULL,'SDSS J092326.33+352704.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,140.8597083,35.45131,0,NULL,64402633904,1006291154,15723299,17.8),(61451,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61451,33.61,0.49,52.7,20782,75,NULL,'IR','ESO 091- G 011',NULL,'2011yCatp016004901K',2011,1,1.68,NULL,'G',0.000027,NULL,'15.8B',0.21,'Sd','Pair member (points to parent)',NULL,NULL,NULL,1,140.8615,-63.67917,NULL,NULL,40577479164,634023111,9906611,15.8),(61452,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61452,33.72,NULL,55.5,20782,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 091- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61453,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61453,33.73,NULL,55.8,20782,NULL,NULL,'Dipole + Quadrupole','ESO 091- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61454,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61454,33.73,NULL,55.8,20782,NULL,NULL,'Dipole','ESO 091- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61455,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61455,34.78,0.46,90.2,20783,70,NULL,NULL,'2MASX J09232697+1315526',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'16.77',NULL,NULL,NULL,NULL,NULL,NULL,1,140.862541667,13.26458,0.073,NULL,63856897604,997764025,15590062,16.77),(61456,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61456,36.44,0.46,194,20784,70,NULL,NULL,'2MASX J09232715+5120580',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000086,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,140.863,51.34931,0.005,NULL,63969932217,999530190,15617659,16.4),(61457,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61457,35.36,0.47,118,20785,70,NULL,NULL,'NGC 2868',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000113,NULL,'15.28',0.7,'S0-: pec',NULL,NULL,NULL,NULL,1,140.863416667,-10.4295,0.157,NULL,42179459521,659054055,10297719,15.28),(61458,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61458,37.55,0.19,324,20786,70,NULL,NULL,'2MASX J09232736+1303446',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,140.864083,13.06253,0.065,NULL,63856975186,997765237,15590081,16.6),(61459,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61459,36.74,0.15,223,20787,70,NULL,NULL,'CGCG 264-106',NULL,'2015arXiv151105856S',2015,1,0.93,NULL,'G',0.00012,NULL,'14.7g',0.68,'BrClG',NULL,NULL,NULL,NULL,1,140.864167,54.82936,0.045,NULL,61875663428,966807241,15106363,14.7),(61460,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61460,37.94,0.46,387,20788,70,NULL,NULL,'SDSS J092327.44+285637.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000169,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,140.864333,28.94383,0.013,NULL,64200714645,1003136166,15674002,18.4),(61461,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61461,33.71,0.49,55.1,20789,75,NULL,'IR','ESO 091- G 010',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',NULL,NULL,'15.78',0.3,'S...',NULL,NULL,NULL,NULL,1,140.8672083,-62.88225,NULL,NULL,40578884100,634045064,9906954,15.78),(61462,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61462,36.82,0.46,232,20790,70,NULL,NULL,'2MASX J09232871+4045319',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000182,NULL,'16.0g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,140.8695417,40.75889,0.005,NULL,64270604259,1004228191,15691065,16),(61463,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61463,38.17,0.46,431,20791,70,NULL,NULL,'2MASX J09232888+5408421',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000176,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,140.870167,54.14522,0.021,NULL,63957066761,999329168,15614518,17.2),(61464,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61464,35.8,0.17,144,20792,70,NULL,NULL,'2MASX J09232995+2219374',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000087,NULL,'16.5g',0.23,'E',NULL,NULL,NULL,NULL,1,140.8747917,22.32714,0.097,NULL,63716664347,995572880,15555826,16.5),(61465,'SBF','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61465,32.89,0.2,37.8,20793,NULL,NULL,'I','NGC 2865',NULL,'2001ApJ...546..681T',2001,1,2.5,NULL,'G',0.000011,NULL,'12.57',1.8,'E3-4','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,140.875875,-23.16144,0.273,NULL,42325277150,661332455,10333319,12.57),(61466,'SBF','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61466,32.89,0.2,37.8,20793,NULL,NULL,NULL,'NGC 2865',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61467,'SBF','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61467,32.89,0.2,37.9,20793,NULL,NULL,'Malmquist cor.','NGC 2865',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61468,'SBF','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61468,32.95,0.14,38.9,20793,74.4,NULL,NULL,'NGC 2865',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61469,'D-Sigma','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61469,31.35,0.4,18.6,20793,75,NULL,'Edat, raw','NGC 2865',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61470,'D-Sigma','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61470,31.68,0.4,21.7,20793,75,NULL,'Edat, cor','NGC 2865',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61471,'Faber-Jackson','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61471,29.59,0.63,8.28,20793,95,NULL,'Michard 1979b, c','NGC 2865',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61472,'Faber-Jackson','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61472,30.21,0.37,11,20793,95,NULL,'Weighted Mean','NGC 2865',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61473,'Faber-Jackson','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61473,30.91,0.81,15.2,20793,55,NULL,'Visvanathan & Sandage 1979','NGC 2865',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61474,'Faber-Jackson','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61474,31.04,0.46,16.1,20793,95,NULL,'Michard 1979a','NGC 2865',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61475,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61475,31.92,0.49,24.2,20793,70,NULL,NULL,'NGC 2865',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61476,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61476,32.25,0.41,28.2,20793,NULL,NULL,NULL,'NGC 2865',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61477,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61477,32.49,0.41,31.5,20793,NULL,NULL,'Malmquist cor.','NGC 2865',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61478,'Tully est','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61478,32.77,0.8,35.7,20793,75,NULL,'B','NGC 2865',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61479,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61479,32.46,0.45,31.1,20793,NULL,NULL,'K','NGC 2865',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61480,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61480,33.06,0.4,41,20793,NULL,NULL,'mean','NGC 2865',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61481,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61481,38.49,0.46,499,20794,70,NULL,NULL,'2MASX J09233138+4120350',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000129,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,140.880833,41.34303,0,NULL,64271413079,1004240829,15691262,18.2),(61482,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61482,37.56,0.46,325,20795,70,NULL,NULL,'2MASX J09233220+1409236',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000149,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,140.884166667,14.15647,0.077,NULL,63855437297,997741207,15589706,18.6),(61483,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61483,35.22,0.46,111,20796,70,NULL,NULL,'CGCG 181-038',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000019,NULL,'15.1g',0.52,'E0',NULL,NULL,NULL,NULL,1,140.8860417,33.75494,0,NULL,64399747922,1006246061,15722594,15.1),(61484,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61484,37.62,0.33,335,20797,70,NULL,NULL,'2MASX J09233328+3210469',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000207,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,140.88875,32.17986,0.009,NULL,64206611809,1003228309,15675442,16.5),(61485,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61485,36.38,0.46,188,20798,70,NULL,NULL,'2MASX J09233423+5557051',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000077,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,140.892875,55.95144,0.073,NULL,61890349261,967036707,15109948,16.9),(61486,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61486,37.86,0.46,374,20799,70,NULL,NULL,'2MASX J09233437+5329010',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000081,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,140.892958333,53.48372,0.029,NULL,63969300499,999520320,15617505,17.7),(61487,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61487,35.2,0.47,110,20800,NULL,NULL,'H','UGC 04994',NULL,'2007A&A...465...71T',2007,1,1.17,NULL,'G',0.000033,NULL,'14.4g',0.55,'Sab',NULL,NULL,NULL,NULL,1,140.8980417,24.76172,0.077,NULL,63713420588,995522196,15555034,14.4),(61488,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61488,35.29,0.45,114,20800,NULL,NULL,'K','UGC 04994',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61489,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61489,35.31,0.4,115,20800,NULL,NULL,'mean','UGC 04994',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61490,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61490,35.33,0.46,117,20800,NULL,NULL,'J','UGC 04994',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61491,'IRAS','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61491,32.58,0.8,32.8,20801,75,NULL,'MAT, I','ESO 498- G 003',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.14',0.4,'Sb? sp         HII','Pair member (points to parent)',NULL,NULL,NULL,1,140.902083,-26.88183,0.433,NULL,42841934671,669405229,10459456,14.14),(61492,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61492,32.26,0.4,28.3,20801,73,NULL,'IR','ESO 498- G 003',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61493,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61493,32.26,0.4,28.3,20801,75,NULL,NULL,'ESO 498- G 003',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61494,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61494,32.41,0.43,30.3,20801,75,NULL,'3.6 micron, color + selection bias corrected','ESO 498- G 003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61495,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61495,32.61,0.43,33.3,20801,75,NULL,'3.6 micron, color corrected','ESO 498- G 003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61496,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61496,32.68,0.45,34.3,20801,NULL,NULL,'K','ESO 498- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61497,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61497,32.69,0.47,34.5,20801,NULL,NULL,'H','ESO 498- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61498,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61498,32.71,0.46,34.8,20801,NULL,NULL,'J','ESO 498- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61499,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61499,32.81,0.32,36.4,20801,85,NULL,'I, raw','ESO 498- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61500,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61500,32.84,0.32,37,20801,85,NULL,'I, inv','ESO 498- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61501,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61501,32.85,0.49,37.2,20801,75,NULL,'IR','ESO 498- G 003',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61502,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61502,32.91,0.4,38.2,20801,NULL,NULL,'mean','ESO 498- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61503,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61503,32.91,0.43,38.3,20801,75,NULL,'MAT, I, raw','ESO 498- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61504,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61504,32.92,0.2,38.4,20801,74.4,NULL,NULL,'ESO 498- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61505,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61505,33.07,0.43,41.2,20801,75,NULL,'MAT, I, cor','ESO 498- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61506,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61506,33.09,0.43,41.4,20801,75,NULL,'MAT, I, inv','ESO 498- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61507,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61507,33.17,0.59,43.1,20801,NULL,NULL,'Malmquist cor.','ESO 498- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61508,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61508,33.32,0.55,46.1,20801,NULL,NULL,NULL,'ESO 498- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61509,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61509,38.55,0.46,513,20802,70,NULL,NULL,'2MASX J09233652+6104118',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000101,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,140.902083,61.06997,0.085,NULL,62036793091,969324892,15145701,17.3),(61510,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61510,37.7,0.27,347,20803,70,NULL,NULL,'SDSS J092336.55+530615.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00007,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,140.902333333,53.10442,0.013,NULL,63968849732,999513277,15617394,18.3),(61511,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61511,38.11,0.46,419,20804,70,NULL,NULL,'2MASX J09233765+3020228',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00006,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,140.9067917,30.33972,0.017,NULL,64201461209,1003147831,15674184,18.7),(61512,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61512,37.66,0.46,340,20805,70,NULL,NULL,'2MASX J09233769+0305573',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,140.907041667,3.09906,0.113,NULL,60729745980,948902280,14826598,17.6),(61513,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61513,38.64,0.46,534,20806,70,NULL,NULL,'2MASX J09233945+2614443',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,140.914583,26.24578,0.041,NULL,64196646179,1003072596,15673009,18),(61514,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61514,36.87,0.46,236,20807,70,NULL,NULL,'2MASX J09233958+3227468',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000157,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,140.914916667,32.46297,0,NULL,64206560186,1003227502,15675429,17.1),(61515,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61515,34.41,NULL,76,20808,NULL,NULL,'Dipole + Quadrupole + Octopole','FGCE 0745',NULL,'2010Ap&SS.325..163P',2010,1,1.1,NULL,'G',0.000047,':','16.8',0.13,'Sdm',NULL,NULL,NULL,NULL,1,140.92,-23.24611,0.273,NULL,42325272195,661332378,10333318,16.8),(61516,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61516,34.43,NULL,77,20808,NULL,NULL,'Dipole + Quadrupole','FGCE 0745',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61517,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61517,34.43,NULL,77,20808,NULL,NULL,'Dipole','FGCE 0745',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61518,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61518,34.49,NULL,79.2,20808,NULL,NULL,NULL,'FGCE 0745',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61519,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61519,38.43,0.46,484,20809,70,NULL,NULL,'SDSS J092341.25+263607.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000143,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,140.921875,26.60203,0.025,NULL,64196497261,1003070269,15672972,18.5),(61520,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61520,37.35,0.46,295,20810,70,NULL,NULL,'2MASX J09234193+0019293',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000078,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,140.924833,0.32467,0.105,NULL,60691793682,948309276,14817332,16.9),(61521,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61521,37.87,0.23,374,20811,70,NULL,NULL,'SDSS J092342.22+065106.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,140.925917,6.85192,0.105,NULL,60707996344,948562442,14821288,18),(61522,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61522,37.62,0.33,335,20812,70,NULL,NULL,'2MASX J09234286+3211062',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00017,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,140.9285,32.18517,0.009,NULL,64206616237,1003228378,15675443,16.8),(61523,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61523,37.7,0.27,347,20813,70,NULL,NULL,'2MASX J09234429+5310430',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000055,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,140.934875,53.17867,0.013,NULL,63968851261,999513300,15617395,17.5),(61524,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61524,38.49,0.46,500,20814,70,NULL,NULL,'2MASX J09234460+0405343',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000186,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,140.936,4.09292,0.121,NULL,60730113016,948908015,14826687,17.8),(61525,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61525,36.63,NULL,212,20815,NULL,NULL,NULL,'FGC 0886',NULL,'2000BSAO...50....5K',2000,1,0.81,NULL,'G',0.000084,NULL,'17.2g',0.12,'Scd',NULL,NULL,NULL,NULL,1,140.93825,38.75622,0,NULL,64406519824,1006351872,15724248,17.2),(61526,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61526,36.65,NULL,213,20815,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0886',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61527,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61527,36.69,NULL,218,20815,NULL,NULL,'Dipole + Quadrupole','FGC 0886',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61528,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61528,36.74,NULL,222,20815,NULL,NULL,'Dipole','FGC 0886',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61529,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61529,38.29,0.33,455,20816,70,NULL,NULL,'2MASX J09234525+2822243',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,140.938625,28.37356,0.009,NULL,64203220919,1003175326,15674614,17.6),(61530,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61530,35.05,0.08,103,20817,NULL,NULL,NULL,'CGCG 181-039',NULL,'2009ApJS..182..474S',2009,1,0.68,NULL,'G',0.000013,NULL,'15.6g',0.33,'Sb:',NULL,NULL,NULL,NULL,1,140.944125,35.48342,0,NULL,64402621769,1006290965,15723296,15.6),(61531,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61531,35.29,0.2,114,20817,74.4,NULL,NULL,'CGCG 181-039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61532,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61532,37.31,0.46,290,20818,70,NULL,NULL,'2MASX J09234687+2649153',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000138,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,140.94525,26.82092,0.033,NULL,64196460181,1003069690,15672963,17.2),(61533,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61533,37.47,0.46,312,20819,70,NULL,NULL,'2MASX J09234729+3148292',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000153,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,140.946833,31.80819,0,NULL,64207334363,1003239599,15675618,17),(61534,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61534,34.34,0.49,73.7,20820,75,NULL,'IR','UGC 04992',NULL,'2011yCatp016004901K',2011,1,1.31,NULL,'G',0.000053,NULL,'15.9g',0.25,'Sc',NULL,NULL,NULL,NULL,1,140.948917,42.18344,0.017,NULL,64273323707,1004270682,15691729,15.9),(61535,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61535,34.71,NULL,87.5,20820,NULL,NULL,NULL,'UGC 04992',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61536,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61536,34.73,NULL,88.4,20820,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 04992',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61537,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61537,34.76,NULL,89.6,20820,NULL,NULL,'Dipole + Quadrupole','UGC 04992',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61538,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61538,34.78,NULL,90.4,20820,NULL,NULL,'Dipole','UGC 04992',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61539,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61539,37.95,0.46,389,20821,70,NULL,NULL,'2MASX J09234795+1521459',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,140.949666667,15.36264,0.085,NULL,63868880516,997951258,15592988,17.7),(61540,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61540,37.49,0.46,315,20822,70,NULL,NULL,'2MASX J09234803+2933383',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00007,NULL,'17.1g',0.27,'E',NULL,NULL,NULL,NULL,1,140.95025,29.56061,0.013,NULL,64200921393,1003139396,15674053,17.1),(61541,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61541,37.96,0.46,391,20823,70,NULL,NULL,'2MASX J09234821+5004100',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000151,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,140.950791667,50.06956,0.005,NULL,63963014587,999422102,15615970,17),(61542,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61542,37.81,0.46,365,20824,70,NULL,NULL,'2MASX J09234826+0222363',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000088,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,140.951167,2.37672,0.073,NULL,60728358562,948880602,14826259,16.5),(61543,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61543,37.78,0.46,361,20825,70,NULL,NULL,'2MASX J09234882+2046504',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000153,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,140.9535417,20.78075,0.097,NULL,63708957150,995452455,15553944,17.3),(61544,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61544,38.39,0.46,477,20826,70,NULL,NULL,'SDSS J092351.32+033211.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000162,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,140.963833,3.53664,0.097,NULL,60730160224,948908753,14826699,18.7),(61545,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61545,37.73,0.46,352,20827,70,NULL,NULL,'SDSS J092352.34-000120.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000093,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,140.968083,-0.02247,0.089,NULL,41108407117,642318861,10036232,18.2),(61546,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61546,37.87,0.23,374,20828,70,NULL,NULL,'2MASX J09235239+0659255',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,140.968333,6.99042,0.105,NULL,60708337658,948567775,14821371,17.3),(61547,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61547,37.85,0.46,371,20829,70,NULL,NULL,'2MASX J09235288+1726479',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,140.970375,17.44661,0.109,NULL,63731960237,995811878,15559560,17.7),(61548,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61548,37.9,0.46,380,20830,70,NULL,NULL,'2MASX J09235627+3948026',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000129,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,140.9845417,39.80089,0,NULL,64392022765,1006125355,15720708,17.7),(61549,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61549,36.4,0.33,191,20831,70,NULL,NULL,'2MASX J09235662+1325509',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',NULL,NULL,'16.98',0.47,NULL,NULL,NULL,NULL,NULL,1,140.985833,13.43069,0.077,NULL,63857340711,997770948,15590171,16.98),(61550,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61550,38.29,0.33,455,20832,70,NULL,NULL,'SDSS J092357.51+282431.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,140.989625,28.40861,0.009,NULL,64203152680,1003174260,15674597,18.5),(61551,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61551,37.83,0.46,369,20833,70,NULL,NULL,'SDSS J092357.62+245623.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'18.3g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,140.990125,24.93975,0.073,NULL,63713173837,995518341,15554974,18.3),(61552,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61552,36.4,0.33,191,20834,70,NULL,NULL,'2MASX J09235793+1327119',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,140.991375,13.45314,0.077,NULL,63857337699,997770901,15590170,17.6),(61553,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61553,37.34,0.46,294,20835,70,NULL,NULL,'2MASX J09235895+0921525',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00013,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,140.995583333,9.36461,0.133,NULL,63649835248,994528675,15539510,17.7),(61554,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61554,35.7,0.46,138,20836,70,NULL,NULL,'2MASX J09240032+3852006',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000183,NULL,'15.7g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,141.001333,38.86692,0,NULL,64406534396,1006352099,15724251,15.7),(61555,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61555,37.7,0.46,347,20837,70,NULL,NULL,'SDSS J092400.31+550125.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000069,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,141.001333,55.02367,0.037,NULL,61889241325,967019395,15109678,18.5),(61556,'IRAS','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61556,33.85,0.8,58.8,20838,75,NULL,'CF, r','UGC 04981',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000287,NULL,'14.70',0.4,'Sb',NULL,NULL,NULL,NULL,1,141.00825,68.56242,0.197,NULL,62264731546,972886430,15201350,14.7),(61557,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61557,33.28,0.38,45.4,20838,75,NULL,'CF, r, raw','UGC 04981',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61558,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61558,33.29,0.38,45.5,20838,75,NULL,'CF, r, inv','UGC 04981',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61559,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61559,33.46,0.38,49.3,20838,75,NULL,'CF, r, cor','UGC 04981',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61560,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61560,35.8,0.17,144,20839,70,NULL,NULL,'CGCG 121-079 NED02',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00009,NULL,'15.5',NULL,NULL,NULL,NULL,NULL,NULL,1,141.008167,22.33372,0.097,NULL,63716655178,995572737,15555824,15.5),(61561,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61561,37.87,0.23,374,20840,70,NULL,NULL,'2MASX J09240260+0656295',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000187,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,141.010791667,6.94136,0.105,NULL,60708194711,948565542,14821336,17),(61562,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61562,32.53,0.47,32.1,20841,NULL,NULL,'H','NGC 2854',NULL,'2007A&A...465...71T',2007,1,1.54,'Called \'Arp 285a\' in UGC notes. Multiple SDSS entries describe this object.','G',0.000037,NULL,'13.82',0.7,'SB(s)b','Pair member, near/close',NULL,NULL,NULL,1,141.0129583,49.20414,0.017,NULL,63962454274,999413348,15615833,13.82),(61563,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61563,32.59,0.45,33,20841,NULL,NULL,'K','NGC 2854',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61564,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61564,32.61,0.46,33.3,20841,NULL,NULL,'J','NGC 2854',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61565,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61565,32.81,0.4,36.4,20841,NULL,NULL,'mean','NGC 2854',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61566,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61566,38.73,0.46,558,20842,70,NULL,NULL,'SDSS J092403.72+630246.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.1g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,141.0155,63.04633,0.097,NULL,62032331390,969255177,15144612,18.1),(61567,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61567,35.8,0.17,144,20843,70,NULL,NULL,'CGCG 121-079 NED01',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000093,NULL,'15.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,141.018875,22.32461,0.097,NULL,63716622383,995572224,15555816,15.6),(61568,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61568,37.71,0.46,348,20844,70,NULL,NULL,'2MASX J09240513+0358379',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000173,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,141.0212917,3.97711,0.121,NULL,60730024725,948906636,14826666,17.9),(61569,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61569,37.55,0.19,324,20845,70,NULL,NULL,'2MASX J09240724+1312507',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'15.4r',NULL,NULL,NULL,NULL,NULL,NULL,1,141.030166667,13.21411,0.049,NULL,63857309257,997770457,15590163,15.4),(61570,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61570,37.51,0.46,317,20846,70,NULL,NULL,'2MASX J09240854+0400459',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000198,NULL,'16.0g',0.42,'BrClG',NULL,NULL,NULL,NULL,1,141.035625,4.01283,0.093,NULL,60730032165,948906752,14826668,16),(61571,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61571,37.97,0.46,392,20847,70,NULL,NULL,'2MASX J09240918+5001397',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000118,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,141.0382083,50.02772,0.005,NULL,63963015574,999422118,15615970,17.8),(61572,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61572,36.58,0.46,207,20848,70,NULL,NULL,'2MASX J09241049+2456026',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000143,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,141.0437083,24.93414,0.077,NULL,63713175545,995518367,15554974,17.2),(61573,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61573,37.72,0.21,349,20849,70,NULL,NULL,'2MASX J09241129+0327039',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,141.047,3.45111,0.097,NULL,60729672864,948901138,14826580,17.9),(61574,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61574,37.87,0.23,374,20850,70,NULL,NULL,'SDSS J092411.33+065446.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,141.04725,6.91297,0.105,NULL,60708207207,948565737,14821339,18.2),(61575,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61575,37.55,0.19,324,20851,70,NULL,NULL,'2MASX J09241189+1313367',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,141.049458333,13.22683,0.049,NULL,63857309223,997770456,15590163,17.2),(61576,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61576,38.47,0.21,494,20852,70,NULL,NULL,'2MASX J09241323+0757565',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,141.055083,7.96578,0.081,NULL,60706606797,948540731,14820948,17.9),(61577,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61577,38.23,0.46,442,20853,70,NULL,NULL,'SDSS J092414.30+035604.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000138,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,141.059583,3.9345,0.085,NULL,60730033262,948906769,14826668,18.4),(61578,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61578,32.38,0.47,30,20854,NULL,NULL,'H','NGC 2856',NULL,'2007A&A...465...71T',2007,1,1.1,'Called \'Arp 285b\' in UGC notes.','G',0.000063,NULL,'14.10',0.5,'S?             HII','Pair member, near/close',NULL,NULL,NULL,1,141.066708333,49.24919,0.017,NULL,63962452276,999413316,15615833,14.1),(61579,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61579,32.39,0.45,30,20854,NULL,NULL,'K','NGC 2856',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61580,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61580,32.47,0.46,31.3,20854,NULL,NULL,'J','NGC 2856',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61581,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61581,32.79,0.4,36.1,20854,NULL,NULL,'mean','NGC 2856',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61582,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61582,38.05,0.46,408,20855,70,NULL,NULL,'SDSS J092417.74+004423.6',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000089,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,141.073916667,0.73992,0.101,NULL,60725213252,948831457,14825491,17.9),(61583,'Faber-Jackson','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61583,30.13,0.63,10.6,20856,95,NULL,'Michard 1979b, c','NGC 2859',NULL,'1984ApJS...56...91D',1984,1,4.3,NULL,'G',0.000017,NULL,'11.83',3.8,'(R)SB(r)0+     Sy','Possible field galaxy',NULL,NULL,NULL,1,141.077208333,34.5135,0,NULL,64403049617,1006297650,15723400,11.83),(61584,'Faber-Jackson','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61584,30.47,0.6,12.4,20856,95,NULL,'de Vaucouleurs','NGC 2859',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61585,'Faber-Jackson','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61585,30.77,0.31,14.3,20856,95,NULL,'Weighted Mean','NGC 2859',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61586,'Faber-Jackson','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61586,31.03,0.46,16.1,20856,95,NULL,'Michard 1979a','NGC 2859',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61587,'Faber-Jackson','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61587,33.08,0.81,41.3,20856,55,NULL,'Visvanathan & Sandage 1979','NGC 2859',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61588,'Tertiary','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61588,31.4,0.25,19.1,20856,95,NULL,NULL,'NGC 2859',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61589,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61589,32.03,0.4,25.4,20856,75,NULL,'B','NGC 2859',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61590,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61590,32.19,0.45,27.5,20856,NULL,NULL,'K','NGC 2859',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61591,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61591,32.32,0.4,29.1,20856,NULL,NULL,'mean','NGC 2859',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61592,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61592,37.55,0.19,324,20857,70,NULL,NULL,'2MASX J09241977+1313037',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,141.082583,13.21775,0.049,NULL,63857311707,997770495,15590163,17.1),(61593,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61593,38.17,0.33,431,20858,70,NULL,NULL,'SDSS J092419.91+210923.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000127,NULL,'18.8g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,141.083,21.1565,0.117,NULL,63709195368,995456177,15554002,18.8),(61594,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61594,37.42,0.46,305,20859,70,NULL,NULL,'2MASX J09242027+5057247',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000138,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,141.084625,50.95697,0,NULL,63961621433,999400334,15615630,17.4),(61595,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61595,36.34,0.6,185,20860,70,NULL,NULL,'2MASX J09242110-3202297',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,141.088,-32.04158,0.769,NULL,42866658479,669791538,10465492,14.4),(61596,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61596,38.12,0.46,421,20861,70,NULL,NULL,'2MASX J09242124+4109326',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000184,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,141.088375,41.15939,0,NULL,64271342538,1004239727,15691245,16.7),(61597,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61597,34.99,0.4,99.7,20862,NULL,NULL,'mean','UGC 05002',NULL,'2007A&A...465...71T',2007,1,0.96,'Noted in MCG as possibly interacting.','G',0.000033,NULL,'14.3g',0.61,'Sa','Isolated galaxy',NULL,NULL,NULL,1,141.095333,28.29303,0.025,NULL,64203254778,1003175855,15674622,14.3),(61598,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61598,35.13,0.47,106,20862,NULL,NULL,'H','UGC 05002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61599,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61599,37.85,0.46,371,20863,70,NULL,NULL,'2MASX J09242354+5046297',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000121,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,141.098041667,50.77481,0,NULL,63961626684,999400416,15615631,17.8),(61600,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61600,38.47,0.21,494,20864,70,NULL,NULL,'SDSS J092425.47+075658.6',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000155,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,141.106167,7.94961,0.081,NULL,60707079262,948548113,14821064,18.8),(61601,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61601,38.02,0.46,401,20865,70,NULL,NULL,'2MASX J09242675+0656300',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00018,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,141.1114583,6.94175,0.105,NULL,60708198359,948565599,14821337,17.3),(61602,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61602,37.13,0.33,266,20866,70,NULL,NULL,'2MASX J09242709+1242276',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,141.113,12.7075,0.065,NULL,63856553292,997758645,15589978,17.1),(61603,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61603,37.61,0.46,332,20867,70,NULL,NULL,'SDSS J092427.70+361737.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000146,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,141.115417,36.29378,0,NULL,64400870897,1006263607,15722868,18.4),(61604,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61604,35.8,0.17,144,20868,70,NULL,NULL,'CGCG 121-082',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00008,NULL,'15.3g',0.53,NULL,NULL,NULL,NULL,NULL,1,141.116875,22.42858,0.097,NULL,63715763383,995558802,15555606,15.3),(61605,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61605,35.74,0.46,140,20869,70,NULL,NULL,'2MASX J09242815+4300338',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000172,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,141.117125,43.00947,0.017,NULL,64272901927,1004264092,15691626,16.2),(61606,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61606,37.92,0.46,384,20870,70,NULL,NULL,'2MASX J09242939+1519206',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000165,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,141.122625,15.3225,0.085,NULL,63868999586,997953118,15593017,17.9),(61607,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61607,38.17,0.33,431,20871,70,NULL,NULL,'SDSS J092429.58+211335.0',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.6g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,141.1232917,21.22642,0.117,NULL,63709189501,995456085,15554001,17.6),(61608,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61608,38.47,0.21,494,20872,70,NULL,NULL,'2MASX J09243083+0756560',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00021,NULL,'16.8g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,141.1284583,7.94892,0.081,NULL,60707093271,948548332,14821067,16.8),(61609,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61609,38.47,0.21,494,20873,70,NULL,NULL,'2MASX J09243292+0759550',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000142,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,141.13725,7.99875,0.081,NULL,60707080867,948548138,14821064,17.9),(61610,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61610,37.92,0.46,384,20874,70,NULL,NULL,'2MASX J09243291+3104496',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00016,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,141.13725,31.08036,0.009,NULL,64206715198,1003229924,15675467,17.6),(61611,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61611,37.45,0.46,309,20875,70,NULL,NULL,'2MASX J09243464+3834517',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000186,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,141.144541667,38.58114,0,NULL,64406361720,1006349401,15724209,16.6),(61612,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61612,37.26,0.46,283,20876,70,NULL,NULL,'2MASX J09243581+2430126',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,141.1489583,24.5035,0.061,NULL,63713370393,995521412,15555022,17.2),(61613,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61613,35.8,0.17,144,20877,70,NULL,NULL,'2MASX J09243663+2229323',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000093,NULL,'16.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,141.152583,22.49228,0.101,NULL,63716626621,995572290,15555817,16.1),(61614,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61614,37.81,0.46,364,20878,70,NULL,NULL,'SDSS J092436.78+003142.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000082,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,141.1532917,0.52836,0.097,NULL,60691766394,948308849,14817325,18.4),(61615,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61615,34.16,0.4,68,20879,NULL,NULL,'mean','NGC 2857',NULL,'2007A&A...465...71T',2007,1,1.7,'UGC misprints R.A. as 09h21.1m. UGC galactic coordinates are correct.','G',0.000023,NULL,'13.9g',1.43,'SA(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,141.157167,49.35706,0.009,NULL,63962475064,999413672,15615838,13.9),(61616,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61616,34.23,0.47,70.1,20879,NULL,NULL,'H','NGC 2857',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61617,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61617,37.64,0.46,337,20880,70,NULL,NULL,'2MASX J09243994+3917156',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000126,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,141.166416667,39.28772,0.017,NULL,64405781581,1006340337,15724067,18.2),(61618,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61618,35.29,0.49,114,20881,75,NULL,'IR','IC 0536',NULL,'2011yCatp016004901K',2011,1,1.35,NULL,'G',0.000027,NULL,'14.7g',0.4,'Sa?',NULL,NULL,NULL,NULL,1,141.167083,25.11019,0.073,NULL,63713155366,995518052,15554969,14.7),(61619,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61619,35.45,0.4,123,20881,NULL,NULL,'mean','IC 0536',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61620,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61620,35.46,0.47,123,20881,NULL,NULL,'H','IC 0536',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61621,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61621,35.55,0.45,129,20881,NULL,NULL,'K','IC 0536',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61622,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61622,35.56,0.46,129,20881,NULL,NULL,'J','IC 0536',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61623,'Tully est','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61623,32.52,0.8,31.9,20882,75,NULL,'B','ESO 498- G 005',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000083,NULL,'13.96',1.1,'SAB(s)c        HII',NULL,NULL,NULL,NULL,1,141.169458333,-25.09269,0.393,NULL,42318849720,661232026,10331750,13.96),(61624,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61624,37.72,0.21,349,20883,70,NULL,NULL,'2MASX J09244260+0322097',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00018,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,141.1775417,3.36928,0.113,NULL,60729825185,948903518,14826617,16.9),(61625,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61625,37.62,0.46,334,20884,70,NULL,NULL,'SDSS J092443.08+072159.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,141.1795417,7.3665,0.101,NULL,60708264988,948566640,14821353,18.4),(61626,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61626,37.55,0.19,324,20885,70,NULL,NULL,'2MASX J09244426+1308005',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,141.184375,13.13347,0.025,NULL,63858162700,997783792,15590371,17.3),(61627,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61627,36.19,0.46,173,20886,70,NULL,NULL,'2MASX J09244574+5739029',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000092,NULL,'16.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,141.190417,57.65086,0.109,NULL,61886534188,966977096,15109017,16.7),(61628,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61628,36.23,0.46,176,20887,70,NULL,NULL,'CGCG 209-064',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000087,NULL,'15.2g',0.51,'E0',NULL,NULL,NULL,NULL,1,141.191375,39.40225,0.017,NULL,64392077764,1006126215,15720722,15.2),(61629,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61629,35.67,0.46,136,20888,70,NULL,NULL,'CGCG 181-041',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.00009,NULL,'14.7g',0.68,'E/S0:',NULL,NULL,NULL,NULL,1,141.192958333,33.7795,0,NULL,64177674034,1002776156,15668377,14.7),(61630,'IRAS','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61630,35.03,0.8,102,20888,75,NULL,'HMCL, I','CGCG 181-041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61631,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61631,35.21,0.4,110,20888,75,NULL,'HMCL, I, raw','CGCG 181-041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61632,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61632,35.29,0.4,114,20888,75,NULL,'HMCL, I, inv','CGCG 181-041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61633,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61633,35.36,0.4,118,20888,75,NULL,'HMCL, I, cor','CGCG 181-041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61634,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61634,37.72,0.21,349,20889,70,NULL,NULL,'2MASX J09244634+0322127',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000154,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,141.193083,3.37022,0.113,NULL,60729832026,948903625,14826619,17.2),(61635,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61635,38.84,0.46,586,20890,70,NULL,NULL,'SDSS J092446.92+021455.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000074,NULL,'18.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,141.1955417,2.24886,0.069,NULL,60729262458,948894725,14826480,18.6),(61636,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61636,37.56,0.33,325,20891,70,NULL,NULL,'2MASX J09244753+5035352',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000201,NULL,'16.7g',0.31,'AGN',NULL,NULL,NULL,NULL,1,141.1980417,50.59325,0,NULL,63962106953,999407921,15615748,16.7),(61637,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61637,37.28,0.46,286,20892,70,NULL,NULL,'2MASX J09244853+0624141',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000174,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,141.202083,6.40386,0.113,NULL,60705992971,948531140,14820799,16.9),(61638,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61638,37.44,0.46,308,20893,70,NULL,NULL,'2MASX J09245111+0735291',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000141,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,141.213,7.59147,0.093,NULL,60707387917,948552936,14821139,17.3),(61639,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61639,37.13,0.33,266,20894,70,NULL,NULL,'2MASX J09245132+1246295',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,141.213791667,12.77483,0.061,NULL,63856556334,997758692,15589979,16.7),(61640,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61640,35.18,0.46,109,20895,70,NULL,NULL,'IC 2467',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.00016,NULL,'14.4g',0.72,'S0             AGN',NULL,NULL,NULL,NULL,1,141.219667,38.35175,0.005,NULL,64406375077,1006349610,15724212,14.4),(61641,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61641,35.82,0.46,146,20896,70,NULL,NULL,'2MASX J09245280+1502005',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000173,NULL,'15.7g',0.43,NULL,NULL,NULL,NULL,NULL,1,141.220125,15.03347,0.061,NULL,63868917658,997951838,15592997,15.7),(61642,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61642,37.74,0.27,352,20897,70,NULL,NULL,'SDSS J092454.08+151518.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000172,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,141.225333333,15.25519,0.085,NULL,63869013380,997953334,15593020,18.3),(61643,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61643,37.24,0.46,281,20898,70,NULL,NULL,'SDSS J092454.14+402650.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000147,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,141.225625,40.44731,0.009,NULL,64259055011,1004047734,15688245,18.2),(61644,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61644,37.86,0.33,373,20899,70,NULL,NULL,'2MASX J09245421+0342277',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000149,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,141.225791667,3.70764,0.105,NULL,60729670791,948901106,14826579,17.6),(61645,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61645,37.72,0.21,349,20900,70,NULL,NULL,'2MASX J09245477+0321212',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000176,NULL,'16.8g',0.26,'BrClG',NULL,NULL,NULL,NULL,1,141.228333,3.35583,0.113,NULL,60729833156,948903643,14826619,16.8),(61646,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61646,33.82,0.46,58,20901,NULL,NULL,'J','NGC 2862',NULL,'2007A&A...465...71T',2007,1,3.57,NULL,'G',0.000017,NULL,'13.2g',0.54,'Sb','Isolated galaxy',NULL,NULL,NULL,1,141.229625,26.77467,0.033,NULL,64197031001,1003078609,15673103,13.2),(61647,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61647,33.91,0.47,60.7,20901,NULL,NULL,'H','NGC 2862',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61648,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61648,33.94,0.49,61.4,20901,75,NULL,'IR','NGC 2862',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61649,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61649,34.01,0.45,63.5,20901,NULL,NULL,'K','NGC 2862',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61650,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61650,34.03,0.4,64.1,20901,NULL,NULL,'mean','NGC 2862',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61651,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61651,34.12,0.45,66.8,20901,NULL,NULL,'Malmquist cor.','NGC 2862',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61652,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61652,34.17,0.2,68.2,20901,74.4,NULL,NULL,'NGC 2862',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61653,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61653,34.3,0.42,72.4,20901,NULL,NULL,NULL,'NGC 2862',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61654,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61654,37.34,0.46,293,20902,70,NULL,NULL,'2MASX J09245586+3833236',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000169,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,141.23275,38.55642,0.005,NULL,64406421035,1006350328,15724223,16.5),(61655,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61655,37.86,0.33,373,20903,70,NULL,NULL,'2MASX J09245622+0347392',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000145,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,141.234291667,3.79436,0.093,NULL,60729656253,948900878,14826576,17.7),(61656,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61656,36.76,0.46,225,20904,70,NULL,NULL,'2MASX J09245707+2217215',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000097,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,141.2377917,22.28947,0.097,NULL,63715880701,995560635,15555634,17),(61657,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61657,38.34,0.46,466,20905,70,NULL,NULL,'2MASX J09245723+6552304',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,141.23825,65.87497,0.157,NULL,62256179681,972752807,15199262,18.2),(61658,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61658,35.83,NULL,147,20906,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0887',NULL,'2010Ap&SS.325..163P',2010,1,0.63,NULL,'G',0.000022,NULL,'17.80',0.09,'Sc',NULL,NULL,NULL,NULL,1,141.24,24.27611,0.065,NULL,63712855512,995513367,15554896,17.8),(61659,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61659,35.85,NULL,148,20906,NULL,NULL,'Dipole + Quadrupole','FGC 0887',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61660,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61660,35.85,NULL,148,20906,NULL,NULL,'Dipole','FGC 0887',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61661,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61661,35.92,NULL,152,20906,NULL,NULL,NULL,'FGC 0887',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61662,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61662,37.74,0.27,352,20907,70,NULL,NULL,'2MASX J09245857+1514264',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000228,NULL,'16.0g',0.33,NULL,NULL,NULL,NULL,NULL,1,141.24425,15.24047,0.085,NULL,63868983008,997952859,15593013,16),(61663,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61663,36.42,0.46,192,20908,70,NULL,NULL,'2MASX J09245884+1731004',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.0002,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,141.2452083,17.51681,0.097,NULL,63732097968,995814030,15559594,16.3),(61664,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61664,37.74,0.27,352,20909,70,NULL,NULL,'2MASX J09250079+1517184',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00017,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,141.253333,15.28833,0.085,NULL,63869010943,997953295,15593020,17.6),(61665,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61665,35.76,0.46,142,20910,70,NULL,NULL,'2MASX J09250218+6352585',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.28',0.33,NULL,NULL,NULL,NULL,NULL,1,141.259167,63.88297,0.129,NULL,62032056573,969250883,15144545,16.28),(61666,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61666,36.66,0.46,215,20911,70,NULL,NULL,'2MASX J09250289+2628576',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000191,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,141.2620417,26.48253,0.033,NULL,64197070148,1003079221,15673112,16.6),(61667,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61667,36.49,0.33,199,20912,70,NULL,NULL,'2MASX J09250306+5547579',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000089,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,141.26275,55.79936,0.037,NULL,61890211884,967034560,15109915,16.6),(61668,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61668,35.86,0.67,149,20913,70,NULL,NULL,'ESO 372- G 022',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'14.1I',0.2,'N',NULL,NULL,NULL,NULL,1,141.263041667,-35.2125,0.945,NULL,42889240551,670144383,10471005,14.1),(61669,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61669,35.64,0.5,135,20914,70,NULL,NULL,'2MASX J09250476-3046407',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'13.6I',0.4,NULL,NULL,NULL,NULL,NULL,1,141.2697917,-30.778,0.737,NULL,42866311497,669786117,10465408,13.6),(61670,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61670,36.76,0.46,224,20915,70,NULL,NULL,'2MASX J09250495+0218452',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.0001,NULL,'16.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,141.270625,2.31256,0.069,NULL,60728444559,948881946,14826280,16.5),(61671,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61671,37.79,0.46,362,20916,70,NULL,NULL,'2MASX J09250534+4112049',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000127,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,141.272375,41.20156,0.013,NULL,64271292104,1004238939,15691233,17.5),(61672,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61672,36.24,0.46,177,20917,70,NULL,NULL,'2MASX J09250555+5546019',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000079,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,141.273166667,55.76714,0.037,NULL,61890207298,967034489,15109913,16.7),(61673,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61673,38.47,0.21,494,20918,70,NULL,NULL,'SDSS J092506.27+075245.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,141.276167,7.87925,0.089,NULL,60707106321,948548536,14821070,18.2),(61674,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61674,37.8,0.46,364,20919,70,NULL,NULL,'SDSS J092506.90+054950.8',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000168,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,141.27875,5.83078,0.117,NULL,60723983412,948812240,14825191,18.5),(61675,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61675,34.72,0.49,87.9,20920,75,NULL,'IR','ESO 372- G 023',NULL,'2011yCatp016004901K',2011,1,2.46,NULL,'G',0.000033,NULL,'15.7',0.22,'Sc',NULL,NULL,NULL,NULL,1,141.2795417,-37.16794,NULL,NULL,42898040749,670281886,10473154,15.7),(61676,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61676,34.97,NULL,98.7,20920,NULL,NULL,'Dipole','ESO 372- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61677,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61677,34.98,NULL,99.2,20920,NULL,NULL,'Dipole + Quadrupole','ESO 372- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61678,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61678,34.99,NULL,99.3,20920,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 372- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61679,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61679,35.12,0.47,106,20920,NULL,NULL,'H','ESO 372- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61680,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61680,35.25,0.45,112,20920,NULL,NULL,'K','ESO 372- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61681,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61681,35.34,0.4,117,20920,NULL,NULL,'mean','ESO 372- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61682,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61682,35.47,0.46,124,20920,NULL,NULL,'J','ESO 372- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61683,'SBF','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61683,30.11,0.18,10.5,20921,NULL,NULL,NULL,'UGC 04998',NULL,'2001A&A...380...90J',2001,1,1.6,NULL,'G',0.0001,NULL,'15.0',0.8,'Im:',NULL,NULL,NULL,NULL,1,141.2957917,68.38303,0.157,NULL,62264804370,972887568,15201368,15),(61684,'TRGB','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61684,29.58,NULL,8.24,20921,NULL,NULL,NULL,'UGC 04998',NULL,'2006PASP..118..580A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61685,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61685,35.73,0.46,140,20922,70,NULL,NULL,'2MASX J09251104+1857155',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000167,NULL,'16.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,141.2959583,18.95431,0.085,NULL,63737153013,995893015,15560828,16.5),(61686,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61686,36.36,0.46,187,20923,70,NULL,NULL,'2MASX J09251178+0902161',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,141.299,9.03781,0.109,NULL,63645482465,994460663,15538447,17.4),(61687,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61687,33.84,0.46,58.5,20924,70,NULL,NULL,'IC 2471',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000063,NULL,'14.5',0.6,'S0^0^ pec:',NULL,NULL,NULL,NULL,1,141.3007083,-6.82992,0.097,NULL,41098218878,642159669,10033744,14.5),(61688,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61688,38.06,0.46,408,20925,70,NULL,NULL,'SDSS J092512.55+292341.6',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000185,NULL,'18.5g',0.09,NULL,NULL,NULL,NULL,NULL,1,141.3022917,29.39489,0.017,NULL,64201113599,1003142399,15674099,18.5),(61689,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61689,36.98,0.46,249,20926,70,NULL,NULL,'2MASX J09251255+0521062',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.0002,NULL,'15.8g',0.49,'E',NULL,NULL,NULL,NULL,1,141.302333,5.35175,0.125,NULL,60723642511,948806914,14825108,15.8),(61690,'AGN time lag','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61690,35.61,0.14,133,20927,NULL,NULL,NULL,'MRK 0110',NULL,'2014ApJ...784L..11Y',2014,1,0.67,NULL,'G',0.00002,NULL,'15.6g',0.42,'Pair?          Sy1',NULL,NULL,NULL,'Sy 1',1,141.303625,52.28625,0.005,NULL,63971473008,999554265,15618035,15.6),(61691,'Black Hole','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61691,35.87,0.5,149,20927,NULL,NULL,NULL,'MRK 0110',NULL,'2014ApJ...793..108W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61692,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61692,38.28,0.46,453,20928,70,NULL,NULL,'2MASX J09251397+5318082',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000096,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,141.308125,53.30217,0.021,NULL,63969391236,999521738,15617527,16.9),(61693,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61693,34.93,NULL,97,20929,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 062-031',NULL,'2010Ap&SS.325..163P',2010,1,1.23,NULL,'G',0.000013,NULL,'15.7',0.11,'Sdm',NULL,NULL,NULL,NULL,1,141.308791667,12.15608,0.085,NULL,63637616281,994337754,15536527,15.7),(61694,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61694,34.95,NULL,97.8,20929,NULL,NULL,'Dipole + Quadrupole','CGCG 062-031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61695,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61695,34.96,NULL,98,20929,NULL,NULL,'Dipole','CGCG 062-031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61696,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61696,34.99,NULL,99.7,20929,NULL,NULL,NULL,'CGCG 062-031',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61697,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61697,35.32,0.2,116,20929,74.4,NULL,NULL,'CGCG 062-031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61698,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61698,37.01,0.46,253,20930,70,NULL,NULL,'2MASX J09251502+0537582',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000183,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,141.3125417,5.63281,0.117,NULL,60724070454,948813600,14825212,17),(61699,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61699,36.73,0.46,221,20931,70,NULL,NULL,'2MASX J09251622+4816442',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000162,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,141.3177083,48.27906,0.009,NULL,63959106753,999361043,15615016,16.7),(61700,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61700,36.49,0.33,199,20932,70,NULL,NULL,'2MASX J09251862+5535158',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000185,NULL,'15.5g',0.48,'E0',NULL,NULL,NULL,NULL,1,141.3277917,55.58761,0.033,NULL,61889771525,967027680,15109807,15.5),(61701,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61701,35.09,0.09,104,20933,NULL,NULL,NULL,'UGC 05011',NULL,'2009ApJS..182..474S',2009,1,0.62,NULL,'G',0.000023,NULL,'15.8g',0.5,'SBcd:',NULL,NULL,NULL,NULL,1,141.3287917,34.1125,0,NULL,64399653109,1006244579,15722571,15.8),(61702,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61702,34.42,0.5,76.7,20934,70,NULL,NULL,'MCG -01-24-017',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000103,NULL,'16.5',0.4,NULL,NULL,NULL,NULL,NULL,1,141.332375,-6.67456,0.097,NULL,41098273777,642160527,10033758,16.5),(61703,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61703,36.35,0.46,186,20935,70,NULL,NULL,'2MASX J09251993+2715031',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,141.333,27.25094,0.045,NULL,64195178446,1003049663,15672650,17.2),(61704,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61704,37.72,0.21,349,20936,70,NULL,NULL,'2MASX J09252035+0321592',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000155,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,141.334833,3.36658,0.113,NULL,60729609147,948900142,14826564,17.5),(61705,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61705,36.71,0.6,220,20937,70,NULL,NULL,'2MASX J09252061-1243474',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,141.3359583,-12.72983,0.157,NULL,42366242619,661972540,10343320,14.3),(61706,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61706,38.3,0.33,457,20938,70,NULL,NULL,'SDSS J092521.35+143600.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000172,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,141.3389583,14.60019,0.065,NULL,63856104500,997751632,15589869,18.5),(61707,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61707,37.56,0.33,325,20939,70,NULL,NULL,'2MASX J09252221+5038492',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,141.3427083,50.64706,0,NULL,63962114227,999408034,15615750,17.6),(61708,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61708,38.3,0.33,457,20940,70,NULL,NULL,'2MASX J09252232+1441299',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000138,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,141.343167,14.69169,0.065,NULL,63856058629,997750916,15589858,18.1),(61709,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61709,35.18,0.48,109,20941,70,NULL,NULL,'2MASX J09252416-0913426',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.7I',0.4,NULL,NULL,NULL,NULL,NULL,1,141.35075,-9.22844,0.145,NULL,42192607020,659259484,10300929,13.7),(61710,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61710,34.03,0.2,64,20942,74.4,NULL,NULL,'UGC 05017',NULL,'2013AJ....146...86T',2013,1,1.17,NULL,'G',0.000179,NULL,'16.1g',0.22,'Scd',NULL,NULL,NULL,NULL,1,141.3534583,11.07378,0.077,NULL,63640080059,994376250,15537128,16.1),(61711,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61711,34.12,0.57,66.7,20942,NULL,NULL,NULL,'UGC 05017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61712,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61712,34.19,0.55,68.9,20942,NULL,NULL,'Malmquist cor.','UGC 05017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61713,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61713,34.38,0.49,75.1,20942,75,NULL,'IR','UGC 05017',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61714,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61714,34.62,NULL,83.8,20942,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61715,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61715,34.62,NULL,83.9,20942,NULL,NULL,'Dipole + Quadrupole','UGC 05017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61716,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61716,34.62,NULL,84,20942,NULL,NULL,'Dipole','UGC 05017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61717,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61717,37.6,0.33,331,20943,70,NULL,NULL,'2MASX J09252479+1247369',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,141.353417,12.79347,0.061,NULL,63857654856,997775857,15590247,16.7),(61718,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61718,37.6,0.33,331,20944,70,NULL,NULL,'2MASX J09252650+1252069',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,141.360625,12.86861,0.061,NULL,63857644762,997775699,15590245,17.1),(61719,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61719,37.3,0.46,288,20945,70,NULL,NULL,'2MASX J09252772+2132112',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,141.365375,21.53667,0.101,NULL,63708557249,995446207,15553846,17.5),(61720,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61720,34.68,0.47,86.5,20946,70,NULL,NULL,'2MASX J09252820-0604426',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00011,NULL,'14.83',0.6,NULL,NULL,NULL,NULL,NULL,1,141.3675,-6.0785,0.045,NULL,41130997480,642671835,10041747,14.83),(61721,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61721,38.22,0.46,441,20947,70,NULL,NULL,'2MASX J09252909+2627351',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000174,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,141.371167,26.45978,0.033,NULL,64197080595,1003079384,15673115,17.7),(61722,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61722,36.6,0.46,209,20948,70,NULL,NULL,'2MASX J09252916+3314092',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000073,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,141.371625,33.236,0.009,NULL,64178037461,1002781835,15668466,16.2),(61723,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61723,38.4,0.46,478,20949,70,NULL,NULL,'2MASX J09252996+0814077',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000175,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,141.37475,8.23553,0.081,NULL,60707250988,948550796,14821106,17.9),(61724,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61724,37.83,0.46,367,20950,70,NULL,NULL,'2MASX J09253000+4056548',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000139,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,141.375125,40.94856,0.009,NULL,64270436560,1004225571,15691024,17.6),(61725,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61725,38.18,0.46,432,20951,70,NULL,NULL,'SDSS J092530.27+054800.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000153,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,141.376125,5.80011,0.117,NULL,60724005375,948812583,14825196,18.3),(61726,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61726,37.27,0.46,284,20952,70,NULL,NULL,'2MASX J09253063+0835267',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000176,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,141.377625,8.59075,0.125,NULL,60706466187,948538534,14820914,17.6),(61727,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61727,35.38,0.55,119,20953,70,NULL,NULL,'2MASX J09253116-6801361',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,141.3797917,-68.02664,0.677,NULL,40797737631,637464650,9960385,16.8),(61728,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61728,37.86,0.19,373,20954,70,NULL,NULL,'SDSS J092531.85+072633.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000132,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,141.38275,7.44272,0.093,NULL,60707557613,948555587,14821181,17.8),(61729,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61729,38.54,0.46,510,20955,70,NULL,NULL,'SDSS J092531.87+025935.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000159,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,141.3827917,2.99319,0.121,NULL,60728282982,948879421,14826240,18.6),(61730,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61730,37.98,0.46,394,20956,70,NULL,NULL,'2MASX J09253244+3151582',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,141.38525,31.86617,0,NULL,64207417492,1003240898,15675639,17.6),(61731,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61731,37.45,0.33,310,20957,70,NULL,NULL,'2MASX J09253344+1706149',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000214,NULL,'16.1g',0.34,NULL,NULL,NULL,NULL,NULL,1,141.38925,17.10419,0.081,NULL,63732029913,995812967,15559577,16.1),(61732,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61732,37.86,0.19,373,20958,70,NULL,NULL,'2MASX J09253414+0725547',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,'FoF','16.6g',0.36,'BrClG',NULL,NULL,NULL,NULL,1,141.392208333,7.43178,0.093,NULL,60707558294,948555598,14821181,16.6),(61733,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61733,35.61,0.46,132,20959,70,NULL,NULL,'2MASX J09253576+0729227',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00018,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,141.399041667,7.48958,0.093,NULL,60707414490,948553351,14821146,16.9),(61734,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61734,37.45,0.33,310,20960,70,NULL,NULL,'2MASX J09253658+1707439',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000171,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,141.402583,17.12886,0.081,NULL,63732031410,995812990,15559577,18),(61735,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61735,37.86,0.19,373,20961,70,NULL,NULL,'2MASX J09253932+0732527',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000168,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,141.413875,7.54803,0.093,NULL,60707419744,948553433,14821147,16.7),(61736,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61736,36.9,0.46,239,20962,70,NULL,NULL,'SDSS J092539.40+105710.5',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,141.4142083,10.95294,0.077,NULL,63640080953,994376264,15537129,17.4),(61737,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61737,35.73,0.49,140,20963,70,NULL,NULL,'2MASX J09254036-3114093',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00009,NULL,'13.3I',0.6,NULL,NULL,NULL,NULL,NULL,1,141.418167,-31.23586,0.805,NULL,42866531543,669789555,10465461,13.3),(61738,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61738,38.11,0.46,419,20964,70,NULL,NULL,'SDSS J092540.97+451349.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000166,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,141.4207083,45.23053,0.025,NULL,64264911347,1004139239,15689675,18.2),(61739,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61739,37.02,0.46,253,20965,70,NULL,NULL,'2MASX J09254168+5645484',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000605,NULL,'17.8g',0.16,'NLAGN',NULL,NULL,NULL,'Sy 2',1,141.42375,56.76339,0.085,NULL,61888549875,967008591,15109509,17.8),(61740,'D-Sigma','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61740,33.56,0.4,51.5,20966,75,NULL,'Edat, raw','NGC 2872',NULL,'1997ApJS..109..333W',1997,1,1.65,NULL,'G',0.000037,NULL,'12.8g',1.14,'E2','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,141.42725,11.43214,0.081,NULL,63640026597,994375415,15537115,12.8),(61741,'D-Sigma','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61741,33.89,0.4,60.1,20966,75,NULL,'Edat, cor','NGC 2872',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61742,'Tully est','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61742,33.09,0.8,41.4,20966,75,NULL,'B','NGC 2872',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61743,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61743,33.4,0.4,47.9,20966,NULL,NULL,'mean','NGC 2872',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61744,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61744,34.06,0.45,64.9,20966,NULL,NULL,'K','NGC 2872',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61745,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61745,33.78,NULL,57.1,20967,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05014',NULL,'2010Ap&SS.325..163P',2010,1,1.14,NULL,'G',0.000011,NULL,'16.5g',0.18,'Sdm',NULL,NULL,NULL,NULL,1,141.42775,34.85661,0,NULL,64400950769,1006264855,15722888,16.5),(61746,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61746,33.79,NULL,57.2,20967,NULL,NULL,'Dipole + Quadrupole','UGC 05014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61747,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61747,33.8,NULL,57.5,20967,NULL,NULL,'Dipole','UGC 05014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61748,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61748,33.84,NULL,58.5,20967,NULL,NULL,NULL,'UGC 05014',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61749,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61749,34.15,0.2,67.6,20967,74.4,NULL,NULL,'UGC 05014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61750,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61750,34.21,0.54,69.5,20967,NULL,NULL,NULL,'UGC 05014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61751,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61751,34.48,0.48,78.8,20967,NULL,NULL,'Malmquist cor.','UGC 05014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61752,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61752,36.99,0.46,250,20968,70,NULL,NULL,'2MASX J09254435+5317554',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000067,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,141.43475,53.29881,0.021,NULL,63969413497,999522085,15617532,17.7),(61753,'FP','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61753,37.45,0.46,309,20969,70,NULL,NULL,'2MASX J09254438+0633341',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000158,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,141.435,6.55956,0.113,NULL,60706014942,948531483,14820804,17.3),(61754,'Ring Diameter','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61754,32.6,0.84,33,20970,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 2874',NULL,'1981ApJS...45..541P',1981,1,2.4,NULL,'G',0.000008,NULL,'13.3B',0.7,'SB(r)bc','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,141.447208333,11.42458,0.081,NULL,63640027134,994375423,15537115,13.3),(61755,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61755,32.6,0.46,33.1,20970,NULL,NULL,'J','NGC 2874',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61756,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,'R',61756,32.6,0.49,33.1,20970,75,NULL,'IR','NGC 2874',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61757,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61757,32.63,0.47,33.6,20970,NULL,NULL,'H','NGC 2874',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61758,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:35','1',NULL,NULL,61758,32.67,0.45,34.2,20970,NULL,NULL,'K','NGC 2874',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61759,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61759,33.67,0.4,54.3,20970,NULL,NULL,'mean','NGC 2874',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61760,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61760,38.17,0.46,430,20971,70,NULL,NULL,'2MASX J09254739+4617476',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,141.447666667,46.2965,0.021,NULL,64261926573,1004092602,15688946,17.5),(61761,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61761,37.86,0.19,373,20972,70,NULL,NULL,'2MASX J09254822+0735091',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,141.450958333,7.58606,0.093,NULL,60707408558,948553258,14821144,18.1),(61762,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61762,37.86,0.19,373,20973,70,NULL,NULL,'2MASX J09255004+0734212',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,141.4584583,7.5725,0.093,NULL,60707408820,948553262,14821144,17.6),(61763,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61763,37.69,0.46,344,20974,70,NULL,NULL,'2MASX J09255046+5921105',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000091,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,141.460375,59.35294,0.041,NULL,62067485015,969804453,15153194,16.9),(61764,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61764,38.24,0.46,445,20975,70,NULL,NULL,'SDSS J092551.20+093546.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000176,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,141.463375,9.59633,0.109,NULL,63638297628,994348400,15536693,18.2),(61765,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61765,38.19,0.46,435,20976,70,NULL,NULL,'2MASX J09255225+2021053',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,141.467958333,20.35153,0.129,NULL,63739106654,995923541,15561305,17.9),(61766,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61766,37.32,0.46,292,20977,70,NULL,NULL,'2MASX J09255241+2955261',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000176,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,141.46825,29.92408,0.053,NULL,64200571566,1003133930,15673967,17.5),(61767,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61767,35.55,0.61,129,20978,70,NULL,NULL,'2MASX J09255254-3152243',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000097,NULL,'13.9I',0.5,NULL,NULL,NULL,NULL,NULL,1,141.4690417,-31.87347,0.653,NULL,42866811426,669793928,10465530,13.9),(61768,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61768,37.06,0.46,259,20979,70,NULL,NULL,'SDSS J092552.97+542651.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000056,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,141.47075,54.44758,0.029,NULL,63968393741,999506152,15617283,18.1),(61769,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61769,35.35,0.46,118,20980,70,NULL,NULL,'CGCG 238-053 NED02',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000152,NULL,'15.9g',0.47,'S0^-',NULL,NULL,NULL,NULL,1,141.4734583,49.33711,0.009,NULL,63962889563,999420149,15615939,15.9),(61770,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61770,37.69,0.46,345,20981,70,NULL,NULL,'2MASX J09255651+0701022',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,141.485666667,7.01722,0.101,NULL,60705592996,948524890,14820701,18.2),(61771,'Tully est','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61771,32.78,0.8,35.9,20982,75,NULL,'B','UGC 05023',NULL,'1988NBGC.C....0000T',1988,1,0.7,'Same object in UGC and UGCA.','G',0.000017,NULL,'14.65',0.6,'S?','Group member of poor cluster',NULL,NULL,NULL,1,141.505167,19.38353,0.065,NULL,63740506732,995945417,15561647,14.65),(61772,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61772,32.36,0.4,29.6,20983,NULL,NULL,NULL,'UGC 05020',NULL,'2009AJ....138..323T',2009,1,2.08,NULL,'G',0.000008,NULL,'14.9g',0.41,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,141.5062083,34.65344,0,NULL,64400925595,1006264462,15722882,14.9),(61773,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61773,32.53,0.2,32.1,20983,74.4,NULL,NULL,'UGC 05020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61774,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61774,32.6,0.45,33.2,20983,NULL,NULL,'Malmquist cor.','UGC 05020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61775,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61775,32.63,0.43,33.5,20983,75,NULL,'3.6 micron, color corrected','UGC 05020',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61776,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61776,32.68,0.44,34.4,20983,NULL,NULL,NULL,'UGC 05020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61777,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61777,32.7,0.43,34.6,20983,75,NULL,'3.6 micron, color + selection bias corrected','UGC 05020',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61778,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61778,38.57,0.46,517,20984,70,NULL,NULL,'2MASX J09260172+0912282',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,141.5072083,9.20797,0.121,NULL,63649615403,994525240,15539456,18),(61779,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61779,37.09,0.46,262,20985,70,NULL,NULL,'2MASX J09260284+1158522',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'17.53',0.4,NULL,NULL,NULL,NULL,NULL,1,141.512,11.98119,0.089,NULL,63639677161,994369955,15537030,17.53),(61780,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61780,35.09,0.46,104,20986,70,NULL,NULL,'MCG +07-20-010',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000177,NULL,'15.6g',0.47,'SB0a',NULL,NULL,NULL,NULL,1,141.518375,42.402,0.025,NULL,64272554386,1004258662,15691541,15.6),(61781,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61781,37.79,0.46,361,20987,70,NULL,NULL,'2MASX J09260557+0939452',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00016,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,141.523166667,9.6625,0.109,NULL,63638337476,994349023,15536703,17.1),(61782,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61782,38.29,0.46,455,20988,70,NULL,NULL,'2MASXi J0926056+194304',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000179,NULL,'17.6g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,141.523583,19.71806,0.077,NULL,63740621684,995947213,15561675,17.6),(61783,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61783,31.47,NULL,19.7,20989,NULL,NULL,NULL,'LV J0926+3343',NULL,'2013AJ....145..101K',2013,1,0.66,NULL,'G',0.000191,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,141.539375,33.71781,0,NULL,64177778766,1002777793,15668403,17.8),(61784,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61784,36.47,0.46,197,20990,70,NULL,NULL,'2MASX J09261054+3110151',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000176,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,141.543875,31.17083,0.009,NULL,64206687802,1003229496,15675460,17.2),(61785,'Brightest Stars','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61785,28.62,0.48,5.3,20991,NULL,NULL,NULL,'NGC 2915',NULL,'1994AJ....107.2021M',1994,1,1.9,'Extended HIPASS source','G',0.00001,NULL,'13.2B',1,'I0             HII','Field galaxy',NULL,NULL,NULL,1,141.5480417,-76.62633,0.517,NULL,39939717736,624058089,9750907,13.2),(61786,'TRGB','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61786,27.77,0.1,3.58,20991,NULL,NULL,NULL,'NGC 2915',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61787,'TRGB','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61787,27.89,0.26,3.78,20991,NULL,NULL,NULL,'NGC 2915',NULL,'2003A&A...398..479K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61788,'TRGB','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61788,28.04,0.03,4.06,20991,NULL,NULL,'I','NGC 2915',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61789,'TRGB','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61789,28.06,0.16,4.1,20991,NULL,NULL,NULL,'NGC 2915',NULL,'2003ApJ...599L..83M',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61790,'TRGB','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61790,28.16,0.1,4.29,20991,74.4,NULL,NULL,'NGC 2915',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61791,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61791,27.61,0.4,3.3,20991,75,NULL,'B','NGC 2915',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61792,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61792,36.77,0.46,226,20992,70,NULL,NULL,'2MASX J09261264+1500301',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,141.5527917,15.00839,0.069,NULL,63855377887,997740279,15589691,18),(61793,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61793,37.7,0.46,347,20993,70,NULL,NULL,'SDSS J092614.98+081402.0',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,141.562416667,8.23392,0.105,NULL,60707165116,948549454,14821085,17.6),(61794,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61794,37.27,0.46,284,20994,70,NULL,NULL,'SDSS J092615.32+021546.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00009,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,141.563833,2.26303,0.113,NULL,60728869750,948888589,14826384,18),(61795,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61795,37.92,0.46,384,20995,70,NULL,NULL,'2MASX J09261689+0914113',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,141.570375,9.23658,0.105,NULL,63638079104,994344986,15536640,17.5),(61796,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61796,37.3,0.46,289,20996,70,NULL,NULL,'2MASX J09261717+4108072',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000159,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,141.5715417,41.13536,0.013,NULL,64270763153,1004230674,15691104,16.9),(61797,'IRAS','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61797,33.85,0.8,58.9,20997,75,NULL,'HMCL, I','UGC 05027',NULL,'1997ApJS..109..333W',1997,1,1.26,NULL,'G',0.000067,NULL,'15.6g',0.23,'Scd(f)',NULL,NULL,NULL,NULL,1,141.571916667,3.13486,0.093,NULL,60730959992,948921249,14826894,15.6),(61798,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61798,34.03,0.4,64.1,20997,75,NULL,'HMCL, I, raw','UGC 05027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61799,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61799,34.08,0.4,65.5,20997,75,NULL,'HMCL, I, inv','UGC 05027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61800,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61800,34.14,0.2,67.3,20997,74.4,NULL,NULL,'UGC 05027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61801,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61801,34.39,0.4,75.5,20997,75,NULL,'HMCL, I, cor','UGC 05027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61802,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61802,34.47,0.49,78.5,20997,75,NULL,'IR','UGC 05027',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61803,'Tully est','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61803,32.34,0.8,29.4,20998,75,NULL,'B','NGC 2888',NULL,'1988NBGC.C....0000T',1988,1,1.4,NULL,'G',0.00006,NULL,'13.58',1,'E+:',NULL,NULL,NULL,NULL,1,141.5819583,-28.03508,0.453,NULL,42844895314,669451489,10460179,13.58),(61804,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61804,32.63,0.45,33.6,20998,NULL,NULL,'K','NGC 2888',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61805,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61805,32.82,0.4,36.7,20998,NULL,NULL,'mean','NGC 2888',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61806,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61806,36.61,0.46,210,20999,70,NULL,NULL,'2MASX J09262013+0027271',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000088,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,141.583875,0.45742,0.089,NULL,60692579519,948321554,14817524,16.6),(61807,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61807,34.39,0.69,75.5,21000,100,NULL,'mid-IR','CGCG 121-091',NULL,'2013ApJ...771...88L',2013,1,1.07,NULL,'G',0.00005,NULL,'14.6g',0.41,NULL,'Group member',NULL,NULL,NULL,1,141.59075,22.13028,0.077,NULL,63715701551,995557836,15555591,14.6),(61808,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61808,35.02,0.2,101,21000,74.4,NULL,NULL,'CGCG 121-091',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61809,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61809,37.74,0.33,354,21001,70,NULL,NULL,'2MASX J09262181+3025070',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000167,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,141.59075,30.41875,0.049,NULL,64208002057,1003250032,15675781,16.8),(61810,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61810,36.85,0.46,235,21002,70,NULL,NULL,'2MASX J09262326+0134539',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00008,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,141.596833333,1.58175,0.069,NULL,60728814024,948887719,14826370,16.9),(61811,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61811,37.47,0.46,312,21003,70,NULL,NULL,'SDSS J092623.65+055516.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000138,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,141.598583,5.92119,0.113,NULL,60723128560,948798883,14824982,18.2),(61812,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61812,37.38,0.46,300,21004,70,NULL,NULL,'2MASX J09262403+1257480',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'17.99',0.29,NULL,NULL,NULL,NULL,NULL,1,141.600041667,12.96336,0.061,NULL,63857703536,997776617,15590259,17.99),(61813,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61813,33.47,0.48,49.4,21005,70,NULL,NULL,'NGC 2884',NULL,'2014MNRAS.445.2677S',2014,1,2,NULL,'G',0.000031,NULL,'13.91',1.1,'S0/a?','in a pair',NULL,NULL,NULL,1,141.601875,-11.55558,0.157,NULL,42181528973,659086390,10298224,13.91),(61814,'TRGB','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61814,27.66,0.15,3.4,21006,NULL,NULL,NULL,'[HKK2009] dJ0926+7030',NULL,'2013AJ....146..126C',2013,1,NULL,NULL,'G',NULL,NULL,'19.0B',NULL,'dI',NULL,NULL,NULL,NULL,1,141.61625,70.50667,0.141,NULL,62220233114,972191142,15190486,19),(61815,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61815,38.37,0.46,472,21007,70,NULL,NULL,'SDSS J092628.41+392027.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000096,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,141.618375,39.341,0.017,NULL,64392975760,1006140246,15720941,18.4),(61816,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61816,37.81,0.33,365,21008,70,NULL,NULL,'SDSS J092628.94+061101.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000159,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,141.620625,6.18367,0.109,NULL,60705346999,948521046,14820641,18.4),(61817,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61817,37.86,0.19,373,21009,70,NULL,NULL,'SDSS J092629.22+072942.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000141,NULL,'18.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,141.62175,7.49508,0.093,NULL,60707359974,948552499,14821132,18.8),(61818,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61818,38.1,0.46,417,21010,70,NULL,NULL,'2MASX J09262931+0410399',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,141.622041667,4.17758,0.093,NULL,60733482417,948960662,14827510,17.2),(61819,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61819,38.02,0.21,402,21011,70,NULL,NULL,'2MASX J09262945+0326179',NULL,'2015arXiv151105856S',2015,1,0.46,'1999ApJ...523...87T has z = 0.0894.','G',0.000185,NULL,'16.6g',0.32,'AGN',NULL,NULL,NULL,NULL,1,141.622667,3.43831,0.093,NULL,60733015662,948953369,14827396,16.6),(61820,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61820,34.49,0.49,79,21012,70,NULL,NULL,'NGC 2890',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000097,NULL,'15.00',0.3,'S0-:',NULL,NULL,NULL,NULL,1,141.624333,-14.52869,0.217,NULL,42365562106,661961907,10343154,15),(61821,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61821,37.2,0.46,275,21013,70,NULL,NULL,'2MASX J09263013+0209239',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,141.6255417,2.15664,0.117,NULL,60726845101,948856954,14825889,17.8),(61822,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61822,35.71,0.46,139,21014,70,NULL,NULL,'2MASX J09263100+0821033',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000186,NULL,'15.6g',0.27,'S0/a',NULL,NULL,NULL,NULL,1,141.629291667,8.35106,0.105,NULL,60707124484,948548820,14821075,15.6),(61823,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61823,37.74,0.33,354,21015,70,NULL,NULL,'2MASX J09263161+3024410',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,141.6317917,30.41142,0.049,NULL,64208001354,1003250021,15675781,17.8),(61824,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61824,37.55,0.46,324,21016,70,NULL,NULL,'2MASX J09263218+5201386',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,141.634166667,52.02742,0,NULL,63971307040,999551672,15617994,17.6),(61825,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61825,36.39,0.46,190,21017,70,NULL,NULL,'SDSS J092632.59+561609.8',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000088,NULL,'16.1g',0.41,NULL,NULL,NULL,NULL,NULL,1,141.6357917,56.26939,0.053,NULL,61890993275,967046769,15110105,16.1),(61826,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61826,38.02,0.21,402,21018,70,NULL,NULL,'SDSS J092632.99+032915.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,141.6375,3.48753,0.097,NULL,60733228304,948956692,14827448,18.2),(61827,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61827,37.44,0.46,308,21019,70,NULL,NULL,'2MASX J09263313+1203303',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,141.6382083,12.05858,0.113,NULL,63639705174,994370393,15537037,16.7),(61828,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61828,37.29,0.46,288,21020,70,NULL,NULL,'2MASX J09263535+3057290',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00018,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,141.647125,30.95819,0.025,NULL,64210119633,1003283119,15676298,16.5),(61829,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61829,37.29,0.46,287,21021,70,NULL,NULL,'2MASX J09263560+0147119',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000077,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,141.648417,1.78675,0.081,NULL,60728829830,948887966,14826374,17.5),(61830,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61830,32.74,0.46,35.3,21022,NULL,NULL,NULL,'NGC 2882',NULL,'2009ApJS..182..474S',2009,1,1.5,'Multiple SDSS entries describe this object.','G',0.000007,NULL,'13.5B',0.8,'S?',NULL,NULL,NULL,NULL,1,141.650583,7.95447,0.109,NULL,60707018114,948547158,14821049,13.5),(61831,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61831,32.78,0.2,36,21022,74.4,NULL,NULL,'NGC 2882',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61832,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61832,32.85,0.4,37.1,21022,NULL,NULL,'mean','NGC 2882',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61833,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61833,32.92,0.47,38.3,21022,NULL,NULL,'H','NGC 2882',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61834,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61834,32.94,0.42,38.8,21022,NULL,NULL,'Malmquist cor.','NGC 2882',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61835,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61835,32.96,0.46,39,21022,NULL,NULL,'J','NGC 2882',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61836,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61836,32.96,0.45,39.1,21022,NULL,NULL,'K','NGC 2882',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61837,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61837,37.42,0.46,305,21023,70,NULL,NULL,'2MASX J09263618+5046445',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000168,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,141.650875,50.77897,0,NULL,63960257301,999379020,15615297,17),(61838,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61838,37.53,0.46,321,21024,70,NULL,NULL,'2MASX J09263655+4105312',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,141.65225,41.09208,0.013,NULL,64259439725,1004053745,15688339,17.5),(61839,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61839,38.02,0.21,402,21025,70,NULL,NULL,'2MASX J09263673+0327379',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000188,NULL,'16.6g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,141.653208333,3.46056,0.093,NULL,60733227649,948956682,14827448,16.6),(61840,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61840,37.65,0.46,339,21026,70,NULL,NULL,'2MASX J09263765+3238561',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000188,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,141.656833,32.64906,0.005,NULL,64177451547,1002772680,15668323,16.4),(61841,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61841,37.1,0.33,263,21027,70,NULL,NULL,'SDSS J092638.12+173738.1',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000157,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,141.658875,17.62728,0.097,NULL,63732428040,995819188,15559674,17),(61842,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61842,38.02,0.21,402,21028,70,NULL,NULL,'SDSS J092640.13+032704.8',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,141.6672083,3.45136,0.093,NULL,60733227968,948956687,14827448,17.5),(61843,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61843,38.09,0.46,415,21029,70,NULL,NULL,'2MASX J09264122+0722423',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,141.6717083,7.37847,0.093,NULL,60707346513,948552289,14821129,18.2),(61844,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61844,37.45,0.33,309,21030,70,NULL,NULL,'2MASX J09264177+1340502',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,141.674041667,13.68061,0.085,NULL,63858092159,997782689,15590354,16.6),(61845,'SNIa','2016-12-15 15:14:29','2016-12-16 11:19:36','1','SN 1999U',NULL,61845,42.48,0.16,2090,21031,65,NULL,NULL,'H-ZSNS J092642.96-053757.8',0.5,'2006ApJ...642....1C',2006,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,141.679,-5.63272,0.085,NULL,41130521847,642664403,10041631,NULL),(61846,'SNIa','2016-12-15 15:14:29','2016-12-16 11:19:36','1','SN 1999U',NULL,61846,42.75,0.19,2370,21031,65,NULL,NULL,'H-ZSNS J092642.96-053757.8',0.5,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61847,'SNIa','2016-12-15 15:14:29','2016-12-16 11:19:36','1','SN 1999U',NULL,61847,42.8,0.2,2420,21031,65,NULL,NULL,'H-ZSNS J092642.96-053757.8',0.5,'2006ApJ...642....1C',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61848,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61848,37.57,0.46,327,21032,70,NULL,NULL,'SDSS J092643.07+034057.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,141.6794583,3.68275,0.097,NULL,60733114635,948954916,14827420,17.6),(61849,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61849,35.7,0.7,138,21033,70,NULL,NULL,'2MASX J09264337-2358246',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,141.680667,-23.97356,0.201,NULL,42320431197,661256737,10332136,14.3),(61850,'IRAS','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61850,34.25,0.8,70.8,21034,75,NULL,'HMCL, I','UGC 05032',NULL,'1997ApJS..109..333W',1997,1,1.04,NULL,'G',0.000027,NULL,'15.9g',0.24,'Sb(f)','Isolated galaxy',NULL,NULL,NULL,1,141.686333,1.15428,0.085,NULL,60692145858,948314779,14817418,15.9),(61851,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61851,34.68,0.4,86.4,21034,75,NULL,'HMCL, I, raw','UGC 05032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61852,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61852,34.82,0.4,92.1,21034,75,NULL,'HMCL, I, inv','UGC 05032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61853,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61853,34.91,0.4,96.2,21034,75,NULL,'HMCL, I, cor','UGC 05032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61854,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61854,37.53,0.46,320,21035,70,NULL,NULL,'2MASXi J0926457+421819',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,141.690708333,42.30542,0.025,NULL,64272718734,1004261230,15691581,17.4),(61855,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61855,36.86,0.46,235,21036,70,NULL,NULL,'2MASX J09264699+3932534',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000184,NULL,'16.1g',0.39,'E0',NULL,NULL,NULL,NULL,1,141.695833,39.54811,0.013,NULL,64392957157,1006139955,15720936,16.1),(61856,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61856,37.45,0.46,309,21037,70,NULL,NULL,'2MASX J09264720+0022309',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000085,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,141.6967083,0.37542,0.089,NULL,60692046868,948313232,14817394,17.2),(61857,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61857,37.72,0.46,349,21038,70,NULL,NULL,'2MASX J09264745+3214551',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000156,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,141.697833333,32.24869,0.009,NULL,64207025963,1003234780,15675543,17.3),(61858,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61858,37.74,0.46,354,21039,70,NULL,NULL,'2MASX J09264796+6256066',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,141.7,62.93531,0.097,NULL,62032204964,969253202,15144581,16.8),(61859,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61859,38.17,0.46,430,21040,70,NULL,NULL,'2MASX J09264951+6651371',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,141.7064583,66.86025,0.217,NULL,62249582365,972649724,15197651,NULL),(61860,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61860,37.62,0.46,334,21041,70,NULL,NULL,'2MASX J09265032+4413358',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000142,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,141.709875,44.22672,0.033,NULL,64263707623,1004120431,15689381,17.5),(61861,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61861,38.23,0.46,443,21042,70,NULL,NULL,'SDSS J092651.14+081300.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000141,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,141.713125,8.21681,0.105,NULL,60706857532,948544648,14821010,18.7),(61862,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61862,38.08,0.33,412,21043,70,NULL,NULL,'2MASX J09265192+0840165',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,141.716333333,8.67114,0.105,NULL,60714751972,948667999,14822937,18.1),(61863,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61863,37.89,0.46,378,21044,70,NULL,NULL,'2MASX J09265227+4904294',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000155,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,141.717625,49.07494,0.013,NULL,63959279756,999363746,15615058,17.1),(61864,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61864,37.32,0.46,291,21045,70,NULL,NULL,'2MASX J09265414+0803545',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000181,NULL,'16.7g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,141.725708333,8.06511,0.109,NULL,60706895338,948545239,14821019,16.7),(61865,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61865,37.76,0.46,356,21046,70,NULL,NULL,'2MASX J09265418+1503442',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,141.725875,15.06222,0.069,NULL,63855350206,997739846,15589685,17.8),(61866,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61866,37.81,0.33,365,21047,70,NULL,NULL,'SDSS J092655.16+061515.6',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000177,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,141.729833,6.25436,0.109,NULL,60705393320,948521770,14820652,17.9),(61867,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61867,38.59,0.46,522,21048,70,NULL,NULL,'SDSS J092655.41+242705.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000127,NULL,'18.8g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,141.730916667,24.45164,0.061,NULL,63715265884,995551029,15555484,18.8),(61868,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61868,37.49,0.46,315,21049,70,NULL,NULL,'2MASX J09265584+1036315',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,141.732625,10.60872,0.077,NULL,63638410674,994350166,15536721,17.5),(61869,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61869,31.66,0.51,21.5,21050,70,NULL,NULL,'NGC 2891',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000053,NULL,'13.51',1.4,'SA0-:',NULL,NULL,NULL,NULL,1,141.7359583,-24.78303,0.257,NULL,42319788093,661246688,10331979,13.51),(61870,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61870,38.08,0.46,413,21051,70,NULL,NULL,'SDSS J092658.47+672426.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,141.743666667,67.40744,0.173,NULL,62267041336,972922520,15201914,18.6),(61871,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61871,37.45,0.33,309,21052,70,NULL,NULL,'2MASX J09265857+1334252',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,141.7439583,13.57372,0.089,NULL,63858119746,997783121,15590361,17.6),(61872,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61872,38.61,0.46,528,21053,70,NULL,NULL,'2MASX J09265855+3830385',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,141.7440417,38.51075,0.005,NULL,64392303128,1006129736,15720777,17.3),(61873,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61873,36.32,0.46,184,21054,70,NULL,NULL,'2MASX J09265962+2053001',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000177,NULL,'15.8g',0.41,NULL,NULL,NULL,NULL,NULL,1,141.748417,20.88353,0.121,NULL,63739728279,995933254,15561457,15.8),(61874,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61874,37.1,0.33,263,21055,70,NULL,NULL,'SDSS J092659.69+552431.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,141.748708333,55.40869,0.033,NULL,61890057072,967032141,15109877,17.9),(61875,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61875,38.15,0.46,427,21056,70,NULL,NULL,'2MASX J09270182+6157426',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,141.757541667,61.96194,0.073,NULL,62038778372,969355912,15146186,17.7),(61876,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61876,38.02,0.21,402,21057,70,NULL,NULL,'SDSS J092703.22+031937.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,141.7634583,3.32722,0.093,NULL,60731119615,948923743,14826933,18.1),(61877,'GRB','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61877,47.63,0.61,6370,21058,72,NULL,NULL,'GRB 050505',4.27,'2008JCAP...07..004M',2008,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,141.763916667,30.2735,0.061,NULL,64208216053,1003253375,15675833,NULL),(61878,'GRB','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61878,47.76,0.6,6760,21058,70,NULL,NULL,'GRB 050505',4.27,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61879,'GRB','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61879,48.04,0.69,7700,21058,NULL,NULL,NULL,'GRB 050505',4.27,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61880,'GRB','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61880,48.47,0.55,9380,21058,69.7,NULL,'Fiducial','GRB 050505',4.27,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61881,'GRB','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61881,48.49,0.59,9470,21058,69.7,NULL,'Calibrated','GRB 050505',4.27,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61882,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61882,37.41,0.46,303,21059,70,NULL,NULL,'2MASX J09270418+1732585',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000147,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,141.7675,17.54953,0.121,NULL,63732441033,995819391,15559677,17.6),(61883,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61883,38.52,0.46,506,21060,70,NULL,NULL,'2MASX J09270467+3559005',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,141.769375,35.98367,0,NULL,64401373869,1006271466,15722991,18),(61884,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61884,38.26,0.46,450,21061,70,NULL,NULL,'SDSS J092705.65+555332.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00016,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,141.7735417,55.89233,0.037,NULL,61891082558,967048164,15110127,18.6),(61885,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61885,37.62,0.33,335,21062,70,NULL,NULL,'2MASX J09270582+0856584',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,141.774167,8.94953,0.101,NULL,60714885954,948670093,14822970,17),(61886,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61886,36.91,0.46,241,21063,70,NULL,NULL,'2MASX J09270739+4833326',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000133,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,141.780667,48.559,0.009,NULL,63959890406,999373287,15615207,17),(61887,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61887,37.62,0.33,335,21064,70,NULL,NULL,'2MASX J09270744+0900504',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000189,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,141.781083,9.01408,0.101,NULL,60714689343,948667020,14822922,16.9),(61888,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61888,35.46,0.46,124,21065,70,NULL,NULL,'2MASX J09270767+6245236',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00007,NULL,'16.24',0.45,NULL,NULL,NULL,NULL,NULL,1,141.78225,62.7565,0.097,NULL,62040323735,969380058,15146563,16.24),(61889,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61889,37.36,0.46,297,21066,70,NULL,NULL,'SDSS J092707.80+083428.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000137,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,141.782541667,8.5745,0.105,NULL,60714719025,948667484,14822929,18.2),(61890,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61890,37.8,0.46,363,21067,70,NULL,NULL,'SDSS J092709.07+104458.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,141.787833,10.74953,0.077,NULL,63639527004,994367609,15536993,18),(61891,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61891,35.65,0.39,135,21068,NULL,NULL,'Malmquist cor.','ESO 434- G 003',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.66',0.6,'(R\'_1)SB(r)a   HII',NULL,NULL,NULL,NULL,1,141.798167,-27.93228,0.465,NULL,42842858898,669419670,10459682,15.66),(61892,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61892,35.68,0.39,137,21068,NULL,NULL,NULL,'ESO 434- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61893,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61893,35.72,0.2,139,21068,74.4,NULL,NULL,'ESO 434- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61894,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61894,37.1,0.33,263,21069,70,NULL,NULL,'2MASX J09271181+1737335',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000129,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,141.7992083,17.62614,0.121,NULL,63732446722,995819480,15559679,17.8),(61895,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61895,38.06,0.46,409,21070,70,NULL,NULL,'2MASX J09271208+0916216',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,141.80025,9.27267,0.105,NULL,60701067473,948454179,14819596,18.3),(61896,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61896,35.99,0.53,158,21071,70,NULL,NULL,'2MASX J09271268-2401469',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,141.80275,-24.02967,0.201,NULL,42320469558,661257336,10332145,14.9),(61897,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61897,37.58,0.46,328,21072,70,NULL,NULL,'2MASX J09271325+2237051',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,141.8054583,22.61811,0.053,NULL,63713741794,995527215,15555112,17.6),(61898,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61898,35.71,0.46,139,21073,70,NULL,NULL,'2MASX J09271389+4251139',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.00017,NULL,'15.8g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,141.8080417,42.85383,0.017,NULL,64272205480,1004253210,15691456,15.8),(61899,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61899,35.19,0.08,109,21074,NULL,NULL,NULL,'CGCG 181-045',NULL,'2009ApJS..182..474S',2009,1,1.02,NULL,'G',0.000018,NULL,'15.4g',0.26,'Sa','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,141.816833,34.42719,0,NULL,64180462731,1002819730,15669058,15.4),(61900,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61900,35.56,0.2,129,21074,74.4,NULL,NULL,'CGCG 181-045',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61901,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61901,36.13,0.46,168,21075,70,NULL,NULL,'2MASX J09271692+5349116',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000071,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,141.8205,53.81992,0.029,NULL,63968561674,999508776,15617324,16.3),(61902,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61902,38.02,0.46,402,21076,70,NULL,NULL,'2MASX J09271715+1826121',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000172,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,141.821583,18.43672,0.153,NULL,63731717628,995808087,15559501,17.8),(61903,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61903,38.08,0.33,412,21077,70,NULL,NULL,'2MASX J09271810+0837336',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,141.825333,8.62606,0.105,NULL,60714774206,948668346,14822942,17.7),(61904,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61904,34.16,0.51,67.9,21078,70,NULL,NULL,'2MASX J09271905-1700528',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'15.41',NULL,NULL,NULL,NULL,NULL,NULL,1,141.8295,-17.01481,0.225,NULL,42302311264,660973613,10327712,15.41),(61905,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61905,38.05,0.33,407,21079,70,NULL,NULL,'2MASX J09271917+3904445',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000137,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,141.8297917,39.07894,0.021,NULL,64392445794,1006131965,15720811,17.7),(61906,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61906,37.1,0.33,263,21080,70,NULL,NULL,'2MASX J09272073+5524575',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,141.8365,55.41606,0.033,NULL,61889881704,967029401,15109834,17.1),(61907,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61907,36.43,0.46,194,21081,70,NULL,NULL,'2MASX J09272170+5558415',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00007,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,141.840583333,55.97814,0.037,NULL,61891068010,967047937,15110124,16.3),(61908,'BCG','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61908,38.77,0.35,500,21082,60,NULL,NULL,'ABELL 0787',0.1355,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II:    [BM]',NULL,NULL,NULL,NULL,1,141.842917,74.44028,0.033,NULL,61375147564,958986680,14984166,NULL),(61909,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61909,35.84,0.46,147,21083,70,NULL,NULL,'2MASX J09272251+2650119',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000158,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,141.843791667,26.83678,0.057,NULL,64197161371,1003080646,15673135,16.3),(61910,'BCG','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61910,38.77,0.35,500,21084,60,NULL,'ABELL 0787, BCG','MCG +12-09-048a',0.1355,'1980ApJ...241..486H',1980,1,0.6,NULL,'G',NULL,NULL,'17',0.4,NULL,'Pair member (points to parent)',NULL,NULL,NULL,1,141.843916667,74.44294,0.033,NULL,61375144223,958986628,14984166,17),(61911,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61911,36.25,0.27,178,21085,70,NULL,NULL,'2MASX J09272318+2624079',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000176,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,141.846667,26.40228,0.065,NULL,64197953365,1003093021,15673328,17.4),(61912,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61912,37.87,0.46,375,21086,70,NULL,NULL,'2MASX J09272349+0514540',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,141.848,5.24842,0.121,NULL,60732385479,948943523,14827242,18),(61913,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61913,36.7,0.46,219,21087,70,NULL,NULL,'2MASX J09272410+5445025',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000181,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,141.85025,54.75081,0.033,NULL,61880711393,966886115,15107595,16.7),(61914,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61914,35.57,0.46,130,21088,70,NULL,NULL,'UGC 05037 NOTES02',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000108,NULL,'15.4g',0.52,NULL,'Group member',NULL,NULL,NULL,1,141.854333333,23.03042,0.061,NULL,63714602255,995540660,15555322,15.4),(61915,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61915,38.74,0.46,559,21089,70,NULL,NULL,'SDSS J092725.52+093501.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,141.856333,9.58378,0.105,NULL,63638176033,994346500,15536664,18.2),(61916,'Tully est','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61916,30.67,0.8,13.6,21090,75,NULL,NULL,'UGCA 165',NULL,'1988NBGC.C....0000T',1988,1,1.4,NULL,'G',0.000018,NULL,'15.02',1.2,'IB(s)m',NULL,NULL,NULL,NULL,1,141.857917,-32.00983,0.613,NULL,42866147016,669783547,10465367,15.02),(61917,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61917,33.67,NULL,54.3,21091,NULL,NULL,'Dipole','ESO 061- G 009',NULL,'2010Ap&SS.325..163P',2010,1,2.13,NULL,'G',0.000029,NULL,'15.77',0.11,'Scd',NULL,NULL,NULL,NULL,1,141.865,-70.3975,0.533,NULL,40742348319,636599192,9946862,15.77),(61918,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61918,33.68,NULL,54.4,21091,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 061- G 009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61919,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61919,33.68,NULL,54.4,21091,NULL,NULL,'Dipole + Quadrupole','ESO 061- G 009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61920,'IRAS','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61920,34.34,0.8,73.8,21092,75,NULL,'HMCL, I','IC 2481',NULL,'1997ApJS..109..333W',1997,1,0.98,NULL,'G',0.000027,NULL,'14.3g',0.58,'S?',NULL,NULL,NULL,NULL,1,141.8700417,3.92961,0.125,NULL,60733331393,948958303,14827473,14.3),(61921,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61921,34.22,0.4,69.8,21092,75,NULL,'HMCL, I, raw','IC 2481',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61922,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61922,34.36,0.4,74.5,21092,75,NULL,'HMCL, I, inv','IC 2481',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61923,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61923,34.56,0.4,81.8,21092,75,NULL,'HMCL, I, cor','IC 2481',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61924,'Tully est','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61924,32.19,0.8,27.4,21093,75,NULL,NULL,'ESO 126- G 013',NULL,'1988NBGC.C....0000T',1988,1,3.7,NULL,'G',0.000284,NULL,'14.41',1.9,'S: pec sp',NULL,NULL,NULL,NULL,1,141.886,-60.77081,NULL,NULL,40575275140,633988674,9906073,14.41),(61925,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61925,35.27,0.46,113,21094,70,NULL,NULL,'CGCG 265-018',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.000093,NULL,'14.7g',0.57,'E0',NULL,NULL,NULL,NULL,1,141.89625,52.21058,0.005,NULL,63971281246,999551269,15617988,14.7),(61926,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61926,37.61,0.46,332,21095,70,NULL,NULL,'2MASX J09273625+3700326',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000152,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,141.901125,37.00917,0,NULL,64405630563,1006337977,15724030,17),(61927,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61927,37.29,0.46,287,21096,70,NULL,NULL,'2MASX J09273704+2046151',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00014,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,141.904375,20.77086,0.089,NULL,63739773966,995933968,15561468,17.3),(61928,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61928,34.04,0.46,64.3,21097,70,NULL,NULL,'ESO 565- G 007',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000067,NULL,'15',1.1,'S0',NULL,NULL,NULL,NULL,1,141.905541667,-19.69553,0.105,NULL,42333102734,661454730,10335230,15),(61929,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61929,38.03,0.46,404,21098,70,NULL,NULL,'2MASX J09273810+0226050',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000092,NULL,'17.4g',0.19,'BrClG',NULL,NULL,NULL,NULL,1,141.90875,2.43461,0.117,NULL,60727209545,948862649,14825978,17.4),(61930,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61930,38.05,0.33,407,21099,70,NULL,NULL,'2MASX J09273865+3858486',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,141.911,38.98031,0.021,NULL,64392469582,1006132337,15720817,18.1),(61931,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61931,37.65,0.46,339,21100,70,NULL,NULL,'SDSS J092739.48+110923.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,141.9145417,11.15658,0.077,NULL,63639473055,994366766,15536980,18.1),(61932,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61932,38.39,0.46,476,21101,70,NULL,NULL,'SDSS J092739.61+073944.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,141.915083,7.66247,0.113,NULL,60715961996,948686906,14823232,18.3),(61933,'SNIa','2016-12-15 15:14:29','2016-12-16 11:19:36','1','SN 2007as',NULL,61933,34.05,0.13,62.3,21102,72,NULL,NULL,'ESO 018- G 018',0.01791,'2013ApJ...773...53F',2013,1,1,NULL,'G',0.00046,NULL,'14.8B',0.9,'SB(rs)c',NULL,NULL,NULL,NULL,1,141.9185,-80.17994,0.437,NULL,39982029742,624719214,9761237,14.8),(61934,'SNIa','2016-12-15 15:14:29','2016-12-16 11:19:36','1','SN 2007as',NULL,61934,34.44,0.05,77.1,21102,72,NULL,'M(H) = -18.317 mag','ESO 018- G 018',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61935,'SNIa','2016-12-15 15:14:29','2016-12-16 11:19:36','1','SN 2007as',NULL,61935,34.71,0.15,86.1,21102,73.8,NULL,'SALT 2 (SNANA)','ESO 018- G 018',0.0179,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61936,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61936,36.6,0.46,209,21103,70,NULL,NULL,'2MASX J09274160+4720575',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000197,NULL,'16.0g',0.37,'E0',NULL,NULL,NULL,NULL,1,141.92325,47.34925,0.013,NULL,63979952533,999686758,15620105,16),(61937,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61937,36.97,0.46,248,21104,70,NULL,NULL,'2MASX J09274164+0359390',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.0002,NULL,'15.5g',0.53,'E0',NULL,NULL,NULL,NULL,1,141.923625,3.99419,0.125,NULL,60732612684,948947073,14827298,15.5),(61938,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61938,37.05,0.46,257,21105,70,NULL,NULL,'2MASX J09274498+2510010',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,141.937625,25.16689,0.025,NULL,64197233411,1003081772,15673152,17),(61939,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61939,35.43,0.46,122,21106,70,NULL,NULL,'2MASX J09274573+4433225',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000146,NULL,'15.8g',0.3,'S0^-',NULL,NULL,NULL,NULL,1,141.94075,44.55625,0.041,NULL,64263686957,1004120108,15689376,15.8),(61940,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61940,35.57,0.46,130,21107,70,NULL,NULL,'CGCG 289-006',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000079,NULL,'15.1g',0.61,'E',NULL,NULL,NULL,NULL,1,141.949,59.13569,0.077,NULL,62012804225,968950066,15139844,15.1),(61941,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61941,37.34,0.46,293,21108,70,NULL,NULL,'2MASX J09274913+3633035',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000174,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,141.954833,36.55097,0,NULL,64405495809,1006335872,15723998,16.5),(61942,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61942,37.83,0.46,368,21109,70,NULL,NULL,'2MASX J09274938+2755350',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000177,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,141.9557917,27.92653,0.013,NULL,64194962163,1003046283,15672598,16.7),(61943,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61943,37.61,0.33,333,21110,70,NULL,NULL,'2MASX J09274992+2111500',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,141.9579583,21.19717,0.101,NULL,63738914479,995920538,15561258,17.8),(61944,'IRAS','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61944,35.28,0.8,114,21111,75,NULL,'HMCL, I','UGC 05041',NULL,'1997ApJS..109..333W',1997,1,1.25,NULL,'G',0.000011,NULL,'15.1g',0.39,'Sc',NULL,NULL,NULL,NULL,1,141.96675,32.65342,0,NULL,64177470147,1002772971,15668327,15.1),(61945,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61945,35.09,0.09,104,21111,NULL,NULL,NULL,'UGC 05041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61946,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61946,35.09,0.2,104,21111,74.4,NULL,NULL,'UGC 05041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61947,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61947,35.17,0.4,108,21111,75,NULL,'HMCL, I, raw','UGC 05041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61948,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61948,35.33,0.4,116,21111,75,NULL,'HMCL, I, cor','UGC 05041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61949,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61949,35.36,0.4,118,21111,75,NULL,'HMCL, I, inv','UGC 05041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61950,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61950,35.26,0.33,113,21112,70,NULL,NULL,'IC 2476',NULL,'2015arXiv151105856S',2015,1,1.5,NULL,'G',0.000093,NULL,'14.1g',1.4,'S0-:','Group member',NULL,NULL,NULL,1,141.970125,29.98575,0.053,NULL,64208359430,1003255616,15675869,14.1),(61951,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61951,35,0.45,99.8,21112,NULL,NULL,'K','IC 2476',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61952,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61952,35.41,0.4,121,21112,NULL,NULL,'mean','IC 2476',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61953,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61953,33.18,0.2,43.3,21113,74.4,NULL,NULL,'NGC 2870',NULL,'2013AJ....146...86T',2013,1,2.75,NULL,'G',0.000017,NULL,'13.7g',0.62,'Sbc            AGN?','Isolated galaxy',NULL,NULL,NULL,1,141.973917,57.3755,0.069,NULL,61886084078,966970063,15108907,13.7),(61954,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61954,33.28,0.51,45.3,21113,NULL,NULL,'Malmquist cor.','NGC 2870',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61955,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61955,33.3,0.5,45.8,21113,NULL,NULL,NULL,'NGC 2870',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61956,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61956,33.31,0.47,46,21113,NULL,NULL,'H','NGC 2870',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61957,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61957,33.38,0.46,47.4,21113,NULL,NULL,'J','NGC 2870',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61958,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61958,33.39,0.4,47.6,21113,NULL,NULL,'mean','NGC 2870',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61959,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61959,33.45,0.45,49,21113,NULL,NULL,'K','NGC 2870',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61960,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61960,37.5,0.46,316,21114,70,NULL,NULL,'2MASX J09275369+0647145',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,141.97375,6.78725,0.125,NULL,60705277154,948519955,14820624,17.4),(61961,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61961,38.54,0.46,509,21115,70,NULL,NULL,'2MASX J09275396+0815555',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000138,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,141.974833,8.26525,0.109,NULL,60715112752,948673636,14823025,18.3),(61962,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61962,37.74,0.46,354,21116,70,NULL,NULL,'SDSS J092754.26+563008.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000071,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,141.976125,56.50236,0.041,NULL,61890872684,967044885,15110076,18.3),(61963,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61963,34.88,0.46,94.7,21117,70,NULL,NULL,'MRK 0112',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000134,NULL,'15.7g',0.43,'Compact',NULL,NULL,NULL,NULL,1,141.9815,48.082,0.009,NULL,63959018831,999359669,15614994,15.7),(61964,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61964,38.27,0.46,451,21118,70,NULL,NULL,'2MASX J09275608+5916574',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000082,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,141.983666667,59.28256,0.085,NULL,62067531189,969805174,15153205,17.7),(61965,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61965,37.91,0.46,381,21119,70,NULL,NULL,'SDSS J092756.10-002531.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000078,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,141.98375,-0.42547,0.065,NULL,41111880250,642373128,10037080,17.9),(61966,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61966,37.56,0.46,325,21120,70,NULL,NULL,'2MASX J09275739+0327314',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,141.9892083,3.45878,0.093,NULL,60731067781,948922934,14826920,17.6),(61967,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61967,37.51,0.46,317,21121,70,NULL,NULL,'2MASX J09275815+1530193',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,141.9922917,15.50542,0.069,NULL,63733556129,995836814,15559950,18.1),(61968,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61968,36.65,0.52,214,21122,70,NULL,NULL,'2MASX J09280012-1421287',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.25',NULL,NULL,NULL,NULL,NULL,NULL,1,142.000541667,-14.35808,0.213,NULL,42365503611,661960993,10343140,16.25),(61969,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61969,35.26,0.33,113,21123,70,NULL,NULL,'IC 2478',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000077,NULL,'15.3g',0.43,NULL,'Group member',NULL,NULL,NULL,1,142.003875,30.03697,0.053,NULL,64208343577,1003255368,15675865,15.3),(61970,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61970,37.42,0.46,304,21124,70,NULL,NULL,'2MASX J09280181+0058204',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000108,NULL,'17.4g',0.21,'BLAGN',NULL,NULL,NULL,'Sy 1',1,142.007583,0.97233,0.093,NULL,60695109701,948361089,14818142,17.4),(61971,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61971,33.52,0.2,50.6,21125,74.4,NULL,NULL,'UGC 05029',NULL,'2013AJ....146...86T',2013,1,1.6,'MCG implies the R.A. is 08h23.9m; corrected in MCG errata.','G',0.000173,NULL,'14.13',1,'SAB(s)c        NELG','Pair member (points to parent)',NULL,NULL,NULL,1,142.010667,68.42033,0.169,NULL,62264793553,972887399,15201365,14.13),(61972,'BL Lac Luminosity','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61972,42.88,NULL,2300,21126,NULL,NULL,NULL,'87GB 092308.0+745942',0.638,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.003,':','19.74',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,142.012375,74.78864,0.025,NULL,61373979337,958968427,14983881,19.74),(61973,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61973,37.61,0.33,333,21127,70,NULL,NULL,'2MASX J09280308+2103031',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000172,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,142.012875,21.05081,0.093,NULL,63739619247,995931550,15561430,17),(61974,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61974,37.64,0.46,337,21128,70,NULL,NULL,'2MASX J09280491+2705543',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,142.020625,27.0985,0.053,NULL,64195205491,1003050085,15672657,17.6),(61975,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61975,36.25,0.27,178,21129,70,NULL,NULL,'CGCG 151-090',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000127,NULL,'15.3g',0.55,'AGN',NULL,NULL,NULL,NULL,1,142.026,26.38314,0.065,NULL,64198006642,1003093853,15673341,15.3),(61976,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61976,37.66,0.46,340,21130,70,NULL,NULL,'2MASX J09280663+4638464',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000141,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,142.02775,46.64625,0.029,NULL,63979987269,999687301,15620114,18),(61977,'SNIa','2016-12-15 15:14:29','2016-12-16 11:19:36','1','SN 1999S',NULL,61977,42.55,0.2,2220,21131,65,NULL,NULL,'H-ZSNS J092808.08-045837.6',0.46,'2006ApJ...642....1C',2006,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,142.033667,-4.97711,0.085,NULL,41135590951,642743608,10042868,NULL),(61978,'SNIa','2016-12-15 15:14:29','2016-12-16 11:19:36','1','SN 1999S',NULL,61978,42.77,0.21,2450,21131,65,NULL,NULL,'H-ZSNS J092808.08-045837.6',0.46,'2006ApJ...642....1C',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61979,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61979,37.31,0.46,290,21132,70,NULL,NULL,'2MASX J09280983+0526194',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000144,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,142.041083333,5.43869,0.117,NULL,60731623340,948931614,14827056,17.2),(61980,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61980,34.06,0.49,64.9,21133,75,NULL,'IR','UGC 05033',NULL,'2011yCatp016004901K',2011,1,1.74,NULL,'G',0.000037,NULL,'16.5',0.11,'Sd',NULL,NULL,NULL,NULL,1,142.047625,64.93406,0.145,NULL,62253183164,972705986,15198531,16.5),(61981,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61981,34.19,NULL,68.9,21133,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05033',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61982,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61982,34.2,NULL,69.3,21133,NULL,NULL,'Dipole + Quadrupole','UGC 05033',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61983,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61983,34.21,NULL,69.4,21133,NULL,NULL,'Dipole','UGC 05033',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61984,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61984,34.5,NULL,79.4,21133,NULL,NULL,NULL,'UGC 05033',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61985,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61985,34.64,0.5,84.6,21133,NULL,NULL,NULL,'UGC 05033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61986,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61986,34.65,0.2,85.1,21133,74.4,NULL,NULL,'UGC 05033',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61987,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61987,34.84,0.45,92.9,21133,NULL,NULL,'Malmquist cor.','UGC 05033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61988,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61988,34.07,0.46,65.1,21134,70,NULL,NULL,'CGCG 034-050',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000027,NULL,'14.2g',0.6,'Sb','Isolated galaxy',NULL,NULL,NULL,1,142.050833,3.40836,0.101,NULL,60731261386,948925959,14826968,14.2),(61989,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61989,32.75,0.47,35.5,21134,NULL,NULL,'H','CGCG 034-050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61990,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61990,32.95,0.46,38.9,21134,NULL,NULL,'J','CGCG 034-050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61991,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61991,33,0.45,39.9,21134,NULL,NULL,'K','CGCG 034-050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61992,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,61992,33.43,0.4,48.6,21134,NULL,NULL,'mean','CGCG 034-050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61993,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61993,32.07,NULL,26,21135,NULL,NULL,NULL,'AGC 198454',NULL,'2015AstBu..70....1K',2015,1,NULL,NULL,'RadioS',0.000075,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,142.05125,7.53972,0.109,NULL,60713138264,948642785,14822543,NULL),(61994,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61994,38.26,0.46,448,21136,70,NULL,NULL,'SDSS J092813.04+161450.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000164,NULL,'18.5g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,142.054375,16.24736,0.077,NULL,63729373961,995771468,15558929,18.5),(61995,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61995,36.25,0.27,178,21137,70,NULL,NULL,'CGCG 151-093',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000179,NULL,'15.5g',0.48,NULL,NULL,NULL,NULL,NULL,1,142.056875,26.40347,0.065,NULL,64198008523,1003093883,15673341,15.5),(61996,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61996,37.6,0.46,330,21138,70,NULL,NULL,'2MASX J09281454+5605589',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000075,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,142.0607083,56.09972,0.037,NULL,61891134062,967048969,15110140,17.2),(61997,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61997,38.47,0.46,495,21139,70,NULL,NULL,'2MASX J09281512+3812254',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,142.063167,38.20722,0.113,NULL,64394101899,1006157842,15721216,18.2),(61998,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61998,38.27,0.46,450,21140,70,NULL,NULL,'2MASX J09281609+0321064',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,142.067,3.35175,0.101,NULL,60731275484,948926179,14826971,17.8),(61999,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',61999,37.29,0.33,287,21141,70,NULL,NULL,'2MASX J09281654+1206222',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,142.069,12.10606,0.113,NULL,63636461898,994319717,15536245,17.5),(62000,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62000,35.51,0.46,126,21142,70,NULL,NULL,'2MASX J09281695+1724092',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000163,NULL,'17.07',0.35,NULL,NULL,NULL,NULL,NULL,1,142.070708333,17.40258,0.117,NULL,63731566869,995805732,15559464,17.07),(62001,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62001,37.96,0.46,391,21143,70,NULL,NULL,'2MASX J09281734+0139014',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000083,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,142.072333,1.65042,0.141,NULL,60694177671,948346526,14817914,18.2),(62002,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62002,34.44,0.59,77.1,21144,NULL,NULL,'Malmquist cor.','ESO 565- G 009',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.64',0.3,'S...',NULL,NULL,NULL,NULL,1,142.072375,-19.43461,0.113,NULL,42332491843,661445185,10335081,15.64),(62003,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62003,34.54,0.56,81,21144,NULL,NULL,NULL,'ESO 565- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62004,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62004,34.58,0.2,82.4,21144,74.4,NULL,NULL,'ESO 565- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62005,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62005,36.97,0.46,248,21145,70,NULL,NULL,'2MASX J09281825+1838121',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000178,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,142.0759583,18.63661,0.109,NULL,63730667668,995791682,15559245,16.4),(62006,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62006,37.44,0.46,307,21146,70,NULL,NULL,'2MASX J09281978+6049471',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000073,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,142.082333333,60.82981,0.069,NULL,62037309504,969332961,15145827,17.3),(62007,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62007,37.77,0.46,358,21147,70,NULL,NULL,'2MASX J09282255+3213007',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000158,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,142.093875,32.21692,0,NULL,64207189142,1003237330,15675583,16.9),(62008,'SNIa','2016-12-15 15:14:29','2016-12-16 11:19:36','1','SN 2003ae',NULL,62008,35,0.19,96.7,21148,74.2,NULL,'SALT 2','2MASX J09282257+2726402',0.0338,'2010ApJ...716..712A',2010,1,0.25,NULL,'G',0.000083,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,142.094125,27.44467,0.029,NULL,64195878873,1003060607,15672821,17.7),(62009,'SNIa','2016-12-15 15:14:29','2016-12-16 11:19:36','1','SN 2003ae',NULL,62009,35.58,0.1,131,21148,74.4,NULL,NULL,'2MASX J09282257+2726402',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62010,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62010,35.68,0.51,137,21149,70,NULL,NULL,'2MASX J09282333-3008059',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,142.0972917,-30.13492,0.629,NULL,42868820429,669825319,10466020,14.8),(62011,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62011,37.72,0.46,351,21150,70,NULL,NULL,'SDSS J092825.16+040306.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,142.104875,4.05175,0.125,NULL,60732629823,948947340,14827302,18.2),(62012,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62012,36.91,0.46,241,21151,70,NULL,NULL,'SDSS J092825.78+033414.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,142.107416667,3.57081,0.069,NULL,60731185859,948924779,14826949,17.7),(62013,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62013,36.67,0.46,216,21152,70,NULL,NULL,'2MASX J09282639+6654579',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,142.109875,66.91608,0.157,NULL,62249329320,972645770,15197590,17.2),(62014,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62014,38.08,0.46,413,21153,70,NULL,NULL,'2MASX J09282901+1243092',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,142.121,12.71922,0.089,NULL,63854791059,997731110,15589548,17.3),(62015,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62015,34.74,0.51,88.6,21154,70,NULL,NULL,'ESO 498- G 010',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000103,NULL,'15.19',0.4,'(R\'_2)SAB(s)b',NULL,NULL,NULL,NULL,1,142.121875,-24.36697,0.145,NULL,42319835291,661247426,10331991,15.19),(62016,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62016,37.81,0.46,365,21155,70,NULL,NULL,'2MASX J09283032+4458187',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,142.126375,44.97183,0.037,NULL,64264497690,1004132776,15689574,17.6),(62017,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62017,35.76,0.4,142,21156,NULL,NULL,'Malmquist cor.','ESO 565- G 010',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.11',0.4,'Sb:',NULL,NULL,NULL,NULL,1,142.12825,-20.91239,0.081,NULL,42330947151,661421049,10334703,16.11),(62018,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62018,35.78,0.4,143,21156,NULL,NULL,NULL,'ESO 565- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62019,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62019,35.82,0.2,146,21156,74.4,NULL,NULL,'ESO 565- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62020,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62020,37.74,0.46,353,21157,70,NULL,NULL,'2MASX J09283183+2931219',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.2g',0.2,'E',NULL,NULL,NULL,NULL,1,142.132583,29.52267,0.013,NULL,64207636976,1003244327,15675692,17.2),(62021,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62021,37.23,0.46,279,21158,70,NULL,NULL,'2MASX J09283407+6809549',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,142.142333,68.16528,0.177,NULL,62265242310,972894411,15201475,17.2),(62022,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62022,38.16,0.46,429,21159,70,NULL,NULL,'2MASX J09283436+2724009',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000182,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,142.143083,27.40025,0.029,NULL,64195698772,1003057793,15672778,16.8),(62023,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62023,37.96,0.46,392,21160,70,NULL,NULL,'SDSS J092834.65+571434.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000083,NULL,'18.3g',0.16,'NLAGN',NULL,NULL,NULL,'Sy 2',1,142.144375,57.24294,0.065,NULL,61886163976,966971312,15108926,18.3),(62024,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62024,37.03,0.46,254,21161,70,NULL,NULL,'2MASX J09283603+3215266',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000176,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,142.1502083,32.25758,0,NULL,64207178018,1003237156,15675580,16.8),(62025,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62025,38.14,0.46,424,21162,70,NULL,NULL,'2MASX J09283616+2247120',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000175,NULL,'18.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,142.150583,22.78672,0.053,NULL,63714556685,995539948,15555311,18.1),(62026,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62026,38.03,0.46,404,21163,70,NULL,NULL,'SDSS J092836.20+462843.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000155,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,142.150875,46.47861,0.025,NULL,63979979674,999687182,15620112,18.6),(62027,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62027,35.34,0.46,117,21164,70,NULL,NULL,'2MASX J09283688+1227315',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',NULL,NULL,'16.77',0.48,NULL,NULL,NULL,NULL,NULL,1,142.1537083,12.45889,0.081,NULL,63854868542,997732320,15589567,16.77),(62028,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62028,37.04,0.46,256,21165,70,NULL,NULL,'SDSS J092836.93+031302.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000188,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,142.153916667,3.21742,0.101,NULL,60731241384,948925646,14826963,18.1),(62029,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62029,37.53,0.46,320,21166,70,NULL,NULL,'2MASX J09283736+2148580',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000186,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,142.155625,21.81625,0.093,NULL,63750329021,996098890,15564045,16.7),(62030,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62030,37.55,0.46,323,21167,70,NULL,NULL,'2MASX J09283813+0019186',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000089,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,142.159,0.32181,0.053,NULL,60695271380,948363615,14818181,17.5),(62031,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62031,38.62,0.46,531,21168,70,NULL,NULL,'2MASX J09283872+2711299',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,142.1612917,27.19172,0.029,NULL,64195717274,1003058082,15672782,17.6),(62032,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62032,37.06,0.46,258,21169,70,NULL,NULL,'2MASX J09283925+1151206',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,142.1635,11.85589,0.069,NULL,63636328626,994317634,15536213,16.8),(62033,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62033,36.83,0.46,233,21170,70,NULL,NULL,'2MASX J09283944+5510349',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000194,NULL,'15.8g',0.49,'S0^-',NULL,NULL,NULL,NULL,1,142.16425,55.17639,0.033,NULL,61889975303,967030864,15109857,15.8),(62034,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62034,38.59,0.46,522,21171,70,NULL,NULL,'2MASX J09283973+3628453',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000204,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,142.1654583,36.47919,0,NULL,64404768001,1006324500,15723820,17.8),(62035,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62035,37.29,0.33,287,21172,70,NULL,NULL,'2MASX J09283989+1207595',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,142.16625,12.13306,0.081,NULL,63636469540,994319836,15536247,17),(62036,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62036,37.56,0.46,325,21173,70,NULL,NULL,'SDSS J092840.11+412401.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000132,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,142.167125,41.40042,0.053,NULL,64259599759,1004056246,15688378,18.5),(62037,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62037,37.47,0.46,312,21174,70,NULL,NULL,'2MASX J09284087+2946079',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000167,NULL,'17.1g',0.2,'E',NULL,NULL,NULL,NULL,1,142.17025,29.76881,0.017,NULL,64208334584,1003255227,15675862,17.1),(62038,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62038,35.63,0.49,134,21175,75,NULL,'IR','2MFGC 07352',NULL,'2011yCatp016004901K',2011,1,0.76,NULL,'G',0.000114,NULL,'16.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,142.171917,16.07367,0.077,NULL,63733633972,995838030,15559969,16.8),(62039,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62039,38.26,0.46,448,21176,70,NULL,NULL,'2MASX J09284192+5146082',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000197,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,142.1745417,51.76892,0,NULL,63970806017,999543844,15617872,17),(62040,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62040,37.51,0.46,317,21177,70,NULL,NULL,'2MASX J09284197+4638416',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000177,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,142.1747083,46.64486,0.029,NULL,63979984812,999687262,15620113,17.5),(62041,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62041,37.44,0.46,308,21178,70,NULL,NULL,'2MASX J09284253+0313126',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,142.1772917,3.22017,0.101,NULL,60731233709,948925526,14826961,17.7),(62042,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62042,38.12,0.46,421,21179,70,NULL,NULL,'2MASX J09284327+2530359',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,142.180291667,25.51003,0.021,NULL,64197248831,1003082012,15673156,18),(62043,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62043,37.05,0.46,257,21180,70,NULL,NULL,'SDSS J092843.64+495306.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000082,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,142.181917,49.88528,0.009,NULL,63962693566,999417086,15615891,17.4),(62044,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62044,37.73,0.46,352,21181,70,NULL,NULL,'2MASX J09284553+0622346',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000195,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,142.189625,6.37636,0.101,NULL,60712588973,948634202,14822409,16.7),(62045,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62045,37.33,0.33,293,21182,70,NULL,NULL,'2MASX J09284558+3925414',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000151,NULL,'16.2g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,142.189833333,39.42822,0.017,NULL,64393028298,1006141067,15720954,16.2),(62046,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62046,37.35,0.46,295,21183,70,NULL,NULL,'2MASX J09284567+2852359',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000173,NULL,'16.4g',0.3,'E',NULL,NULL,NULL,NULL,1,142.19025,28.87661,0.021,NULL,64200129563,1003127024,15673859,16.4),(62047,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62047,37.15,0.46,270,21184,70,NULL,NULL,'2MASX J09284747+5011573',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,142.197833333,50.19936,0.005,NULL,63960331011,999380172,15615315,17.2),(62048,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62048,37.88,0.46,376,21185,70,NULL,NULL,'2MASX J09284884+1347385',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,142.2035,13.79408,0.073,NULL,63857987529,997781055,15590328,18.1),(62049,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62049,37.77,0.33,359,21186,70,NULL,NULL,'2MASX J09284919+0211201',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000082,NULL,'17.3g',0.24,'BrClG',NULL,NULL,NULL,NULL,1,142.205,2.18889,0.129,NULL,60694075403,948344928,14817889,17.3),(62050,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62050,37.77,0.33,359,21187,70,NULL,NULL,'2MASX J09284939+0208571',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000072,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,142.205667,2.14914,0.129,NULL,60694075938,948344936,14817889,18.2),(62051,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62051,38.18,0.46,433,21188,70,NULL,NULL,'SDSS J092849.44+014721.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000083,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,142.2060417,1.78928,0.141,NULL,60694145945,948346030,14817906,18.2),(62052,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62052,30.76,NULL,14.2,21189,NULL,NULL,NULL,'UGC 05047',NULL,'2000BSAO...50....5K',2000,1,0.91,NULL,'G',0.000067,NULL,'15.8g',0.32,'Scd(f)',NULL,NULL,NULL,NULL,1,142.206875,51.5605,0,NULL,63968047534,999500742,15617199,15.8),(62053,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62053,30.76,NULL,14.2,21189,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05047',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62054,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62054,30.8,NULL,14.4,21189,NULL,NULL,'Dipole + Quadrupole','UGC 05047',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62055,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62055,30.84,NULL,14.7,21189,NULL,NULL,'Dipole','UGC 05047',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62056,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62056,31.47,NULL,19.7,21189,NULL,NULL,NULL,'UGC 05047',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62057,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62057,37.9,0.46,380,21190,70,NULL,NULL,'2MASX J09285266+0148411',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000079,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,142.219625,1.81144,0.149,NULL,60694145610,948346025,14817906,17.5),(62058,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62058,36.49,0.46,199,21191,70,NULL,NULL,'2MASX J09285398+4053204',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000159,NULL,'16.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,142.2247917,40.88889,0.009,NULL,64259852922,1004060201,15688440,16.3),(62059,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62059,38.08,0.46,414,21192,70,NULL,NULL,'2MASX J09285540+3202066',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000179,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,142.230916667,32.03514,0,NULL,64207080471,1003235632,15675556,17.3),(62060,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62060,36.89,0.46,239,21193,70,NULL,NULL,'2MASX J09285721+3159356',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,142.238291667,31.99328,0,NULL,64207079579,1003235618,15675556,17.5),(62061,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62061,37.41,0.46,304,21194,70,NULL,NULL,'2MASX J09285922+5258022',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,142.247,52.96742,0.005,NULL,63969162439,999518163,15617471,16.9),(62062,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62062,37.2,0.46,275,21195,70,NULL,NULL,'2MASX J09285988+2456231',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,142.249583,24.93964,0.037,NULL,63711804814,995496950,15554639,16.9),(62063,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62063,37.35,0.46,296,21196,70,NULL,NULL,'SDSS J092900.36+352458.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00015,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,142.2515417,35.41614,0,NULL,64401245474,1006269460,15722960,18.1),(62064,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62064,36.9,0.2,240,21197,74.4,NULL,NULL,'CGCG 062-039',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000157,NULL,'15.4',0.6,NULL,NULL,NULL,NULL,NULL,1,142.2527917,12.50369,0.081,NULL,63854859835,997732184,15589565,15.4),(62065,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62065,33.55,0.46,51.4,21198,NULL,NULL,'J','ESO 315- G 012',NULL,'2007A&A...465...71T',2007,1,2.44,NULL,'G',0.00002,NULL,'15.72',0.22,'Sbc',NULL,NULL,NULL,NULL,1,142.2567917,-37.84211,NULL,NULL,42883921172,670061268,10469707,15.72),(62066,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62066,33.57,0.47,51.9,21198,NULL,NULL,'H','ESO 315- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62067,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62067,33.75,0.45,56.1,21198,NULL,NULL,'K','ESO 315- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62068,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62068,33.95,0.4,61.7,21198,NULL,NULL,'mean','ESO 315- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62069,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62069,34.02,NULL,63.6,21198,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 315- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62070,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62070,34.02,NULL,63.7,21198,NULL,NULL,'Dipole','ESO 315- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62071,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62071,34.02,NULL,63.8,21198,NULL,NULL,'Dipole + Quadrupole','ESO 315- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62072,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62072,38.65,0.46,538,21199,70,NULL,NULL,'SDSS J092903.30+013943.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000081,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,142.2637917,1.662,0.141,NULL,60694067769,948344808,14817887,18.8),(62073,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62073,37.81,0.21,364,21200,70,NULL,NULL,'2MASX J09290373+1212279',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,142.2657083,12.20789,0.081,NULL,63636403704,994318807,15536231,17.4),(62074,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62074,36.9,0.46,240,21201,70,NULL,NULL,'2MASX J09290516+2657141',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000199,NULL,'15.9g',0.36,NULL,NULL,NULL,NULL,NULL,1,142.2715417,26.95392,0.013,NULL,64195541247,1003055331,15672739,15.9),(62075,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62075,37.36,0.46,297,21202,70,NULL,NULL,'2MASX J09290567+0214141',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000085,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,142.273708333,2.23719,0.129,NULL,60694072596,948344884,14817888,17.2),(62076,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62076,37.95,0.33,389,21203,70,NULL,NULL,'SDSS J092906.19+033508.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,142.275791667,3.58558,0.069,NULL,60731419656,948928432,14827006,17.9),(62077,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62077,37.65,0.46,339,21204,70,NULL,NULL,'2MASX J09290670+3912584',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,142.27775,39.21636,0,NULL,64392828926,1006137951,15720905,17.2),(62078,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62078,36.62,0.46,211,21205,70,NULL,NULL,'2MASX J09290703+5125409',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,142.27925,51.428,0,NULL,63968028987,999500452,15617194,17.2),(62079,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62079,36.37,0.33,188,21206,70,NULL,NULL,'2MASX J09290710+3411276',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.00018,NULL,'15.7g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,142.2797083,34.19111,0,NULL,64180677567,1002823086,15669110,15.7),(62080,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62080,37.83,0.46,367,21207,70,NULL,NULL,'2MASX J09290736+6246407',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,142.280333,62.77808,0.105,NULL,62040361220,969380644,15146572,17.2),(62081,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62081,36.59,0.46,208,21208,70,NULL,NULL,'2MASX J09290789+0406091',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000177,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,142.282917,4.10247,0.093,NULL,60730874599,948919915,14826873,16.3),(62082,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62082,34.95,0.47,97.9,21209,NULL,NULL,'H','IC 0539',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000123,NULL,'14.14',0.9,'Scd:           HII',NULL,NULL,NULL,NULL,1,142.284333333,-2.54914,0.085,NULL,41127372365,642615193,10040862,14.14),(62083,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62083,35.08,0.4,104,21209,NULL,NULL,'mean','IC 0539',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62084,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62084,35.11,0.45,105,21209,NULL,NULL,'K','IC 0539',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62085,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62085,35.11,0.46,105,21209,NULL,NULL,'J','IC 0539',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62086,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62086,38.41,0.46,481,21210,70,NULL,NULL,'2MASX J09290877+1431429',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,142.286625,14.52875,0.069,NULL,63855732223,997745815,15589778,17.9),(62087,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62087,37.67,0.46,342,21211,70,NULL,NULL,'2MASX J09290891+4155596',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000144,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,142.287333,41.93322,0.053,NULL,64272466316,1004257286,15691520,17.4),(62088,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62088,37.63,0.46,336,21212,70,NULL,NULL,'2MASX J09290953+5511028',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00017,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,142.289625,55.18411,0.033,NULL,61889976973,967030890,15109857,16.9),(62089,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62089,37.33,0.46,292,21213,70,NULL,NULL,'2MASX J09291042+1328289',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,142.2934583,13.47483,0.061,NULL,63857977322,997780895,15590326,16.5),(62090,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62090,37.65,0.46,340,21214,70,NULL,NULL,'2MASX J09291063+1151337',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,142.294375,11.85936,0.073,NULL,63636441313,994319395,15536240,18.1),(62091,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62091,38.11,0.46,420,21215,70,NULL,NULL,'2MASX J09291410+4913449',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000123,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,142.308833333,49.22911,0.013,NULL,63962657972,999416530,15615883,18.5),(62092,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62092,37.33,0.33,293,21216,70,NULL,NULL,'2MASX J09291430+3921384',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,142.309583,39.36078,0.017,NULL,64392841701,1006138151,15720908,17.2),(62093,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62093,37.32,0.46,291,21217,70,NULL,NULL,'2MASX J09291599+3440436',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,142.3165,34.67875,0,NULL,64179657332,1002807145,15668861,17.5),(62094,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62094,37.74,0.46,353,21218,70,NULL,NULL,'SDSS J092916.55+132810.4',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.5g',0.31,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,142.319,13.46956,0.061,NULL,63857976545,997780883,15590326,16.5),(62095,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62095,37.29,0.46,288,21219,70,NULL,NULL,'2MASX J09291668+3429236',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000203,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,142.319541667,34.48997,0,NULL,64179635817,1002806809,15668856,16.4),(62096,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62096,37.42,0.46,305,21220,70,NULL,NULL,'2MASX J09291764+2434251',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000187,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,142.323417,24.57364,0.085,NULL,63711853395,995497709,15554651,16.8),(62097,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62097,36.49,0.46,198,21221,70,NULL,NULL,'2MASX J09291811+4339585',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000087,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,142.3252917,43.66619,0.093,NULL,64271825387,1004247271,15691363,16.7),(62098,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62098,37.81,0.21,364,21222,70,NULL,NULL,'2MASX J09291860+1210549',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',NULL,NULL,'17.82',0.36,NULL,NULL,NULL,NULL,NULL,1,142.327625,12.182,0.081,NULL,63636400739,994318761,15536230,17.82),(62099,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62099,37.98,0.46,394,21223,70,NULL,NULL,'2MASX J09291868+3546116',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,142.32775,35.76986,0,NULL,64400567633,1006258869,15722794,17.8),(62100,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62100,37.95,0.33,389,21224,70,NULL,NULL,'SDSS J092919.55+033558.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000146,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,142.3315,3.59972,0.069,NULL,60731363719,948927558,14826993,18.7),(62101,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62101,37.87,0.46,376,21225,70,NULL,NULL,'2MASX J09291959+1308219',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,142.3315417,13.13953,0.097,NULL,63854424429,997725381,15589459,17),(62102,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62102,37.74,0.27,352,21226,70,NULL,NULL,'2MASX J09292028+1442179',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,142.334416667,14.70511,0.081,NULL,63722884240,995670066,15557344,16.9),(62103,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62103,37.81,0.21,364,21227,70,NULL,NULL,'2MASX J09292105+1206479',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,142.3377917,12.11322,0.077,NULL,63636425126,994319142,15536236,18.3),(62104,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62104,37.81,0.21,364,21228,70,NULL,NULL,'2MASX J09292160+1205057',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000208,NULL,'15.7g',0.45,'BrClG',NULL,NULL,NULL,NULL,1,142.34,12.08486,0.077,NULL,63636426064,994319157,15536236,15.7),(62105,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62105,36.94,0.46,245,21229,70,NULL,NULL,'2MASX J09292171+3218207',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000144,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,142.340417,32.30569,0,NULL,64206973127,1003233955,15675530,17.9),(62106,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62106,37.48,0.46,314,21230,70,NULL,NULL,'SDSS J092926.89+491220.7',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,142.3620417,49.20578,0.013,NULL,63962660514,999416570,15615883,17.7),(62107,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62107,37.23,0.46,279,21231,70,NULL,NULL,'2MASX J09292733+6818277',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,142.3642083,68.30767,0.169,NULL,62265276874,972894951,15201483,17.3),(62108,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62108,37.77,0.46,357,21232,70,NULL,NULL,'SDSS J092929.11+541728.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000139,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,142.3712917,54.29131,0.029,NULL,63964408071,999443876,15616310,18),(62109,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62109,38.12,0.46,421,21233,70,NULL,NULL,'2MASX J09292998+3804215',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000159,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,142.375041667,38.07269,0,NULL,64393621704,1006150339,15721099,17.2),(62110,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62110,31.6,0.69,20.9,21234,100,NULL,'mid-IR','NGC 2894',NULL,'2013ApJ...771...88L',2013,1,1.9,NULL,'G',0.00002,NULL,'13.27',1,'Sa',NULL,NULL,NULL,NULL,1,142.376,7.71883,0.109,NULL,60716069016,948688578,14823259,13.27),(62111,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62111,32.85,0.4,37.2,21234,NULL,NULL,'mean','NGC 2894',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62112,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62112,33.1,0.47,41.6,21234,NULL,NULL,'H','NGC 2894',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62113,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62113,33.1,0.45,41.6,21234,NULL,NULL,'K','NGC 2894',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62114,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62114,33.15,0.46,42.6,21234,NULL,NULL,'J','NGC 2894',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62115,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62115,33.21,0.37,43.8,21234,NULL,NULL,'Malmquist cor.','NGC 2894',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62116,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62116,33.36,0.35,47,21234,NULL,NULL,NULL,'NGC 2894',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62117,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62117,33.57,0.2,51.8,21234,74.4,NULL,NULL,'NGC 2894',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62118,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62118,33.81,0.43,57.7,21234,75,NULL,'3.6 micron, color corrected','NGC 2894',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62119,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62119,33.96,0.43,62,21234,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2894',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62120,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62120,37.81,0.21,364,21235,70,NULL,NULL,'SDSS J092930.54+120242.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,142.3772917,12.04503,0.077,NULL,63636416908,994319014,15536234,18),(62121,'SBF','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62121,31.69,0.14,21.8,21236,74.4,NULL,NULL,'NGC 2880',NULL,'2013AJ....146...86T',2013,1,2.16,NULL,'G',0.000017,NULL,'12.5g',1.13,'SB0-','Possible field galaxy',NULL,NULL,NULL,1,142.394,62.49056,0.085,NULL,62041607869,969400122,15146876,12.5),(62122,'SBF','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62122,31.7,0.21,21.9,21236,NULL,NULL,'I','NGC 2880',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62123,'Faber-Jackson','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62123,30.61,0.81,13.2,21236,95,NULL,'de Vaucouleurs','NGC 2880',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62124,'Faber-Jackson','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62124,30.98,0.51,15.7,21236,95,NULL,'Weighted Mean','NGC 2880',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62125,'Faber-Jackson','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62125,32.49,0.81,31.5,21236,55,NULL,'Visvanathan & Sandage 1979','NGC 2880',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62126,'Tertiary','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62126,31.55,0.25,20.4,21236,95,NULL,NULL,'NGC 2880',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62127,'Tully est','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62127,32.01,0.8,25.2,21236,75,NULL,'B','NGC 2880',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62128,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62128,31.84,0.45,23.4,21236,NULL,NULL,'K','NGC 2880',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62129,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62129,32.06,0.4,25.8,21236,NULL,NULL,'mean','NGC 2880',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62130,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62130,37.18,0.46,273,21237,70,NULL,NULL,'2MASX J09293525-0054043',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000097,NULL,'16.3g',0.3,'E0',NULL,NULL,NULL,NULL,1,142.396833,-0.90114,0.069,NULL,41112488716,642382636,10037228,16.3),(62131,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62131,38.06,0.46,409,21238,70,NULL,NULL,'2MASX J09293744+0545248',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,142.4059583,5.75694,0.105,NULL,60718030247,948719222,14823737,17.8),(62132,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62132,34.62,0.46,83.9,21239,70,NULL,NULL,'CGCG 312-012',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000117,NULL,'14.7r',0.56,NULL,NULL,NULL,NULL,NULL,1,142.40775,62.54403,0.085,NULL,62041578998,969399671,15146869,14.7),(62133,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62133,37.82,0.46,367,21240,70,NULL,NULL,'2MASX J09293822+3249117',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000183,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,142.409458333,32.81989,0,NULL,64177337192,1002770893,15668295,17.4),(62134,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62134,36.69,0.46,218,21241,70,NULL,NULL,'2MASX J09293836+1121219',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000146,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,142.409708333,11.35611,0.065,NULL,63636700638,994323447,15536303,17.3),(62135,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62135,37.81,0.46,365,21242,70,NULL,NULL,'2MASX J09293840+0202268',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000084,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,142.409875,2.04072,0.137,NULL,60694624557,948353508,14818023,17.8),(62136,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62136,36.59,0.46,208,21243,70,NULL,NULL,'2MASX J09293916+5031239',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000171,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,142.413291667,50.5235,0.005,NULL,63960464598,999382259,15615347,16.7),(62137,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62137,36.85,0.46,235,21244,70,NULL,NULL,'2MASX J09293970+0745519',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000179,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,142.415541667,7.76444,0.101,NULL,60716087920,948688873,14823263,16.6),(62138,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62138,37.23,0.46,279,21245,70,NULL,NULL,'2MASX J09293979+1514375',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,142.415917,15.24378,0.077,NULL,63722135634,995658369,15557162,17.1),(62139,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62139,37.74,0.27,352,21246,70,NULL,NULL,'2MASX J09293992+1443115',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,142.4164583,14.72003,0.081,NULL,63722893848,995670216,15557347,17.9),(62140,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62140,36.7,0.65,218,21247,70,NULL,NULL,'2MASX J09294157-1434396',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,142.42325,-14.57775,0.237,NULL,42297012394,660890818,10326419,15.6),(62141,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62141,37.87,0.46,375,21248,70,NULL,NULL,'2MASX J09294161+1250505',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,142.423375,12.84753,0.089,NULL,63854929042,997733266,15589582,17.6),(62142,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62142,37.15,0.46,270,21249,70,NULL,NULL,'2MASX J09294250+2332169',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,142.4270417,23.53817,0.061,NULL,63715100756,995548449,15555444,16.4),(62143,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62143,36.15,0.46,170,21250,70,NULL,NULL,'2MASX J09294302+2124269',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000167,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,142.4292083,21.40744,0.081,NULL,63750390435,996099850,15564060,16.6),(62144,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62144,37.07,0.46,259,21251,70,NULL,NULL,'2MASX J09294309+3511477',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000173,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,142.429625,35.19664,0,NULL,64179545284,1002805395,15668834,16.5),(62145,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62145,35.98,0.46,157,21252,70,NULL,NULL,'CGCG 122-005',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00015,NULL,'15.5',0.4,NULL,NULL,NULL,NULL,NULL,1,142.4327917,21.43397,0.081,NULL,63750361186,996099393,15564053,15.5),(62146,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62146,38.67,0.33,542,21253,70,NULL,NULL,'SDSS J092944.61+100554.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000147,NULL,'18.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,142.435917,10.09842,0.093,NULL,60701745275,948464769,14819762,18.8),(62147,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62147,35.36,0.33,118,21254,70,NULL,NULL,'NGC 2898',NULL,'2015arXiv151105856S',2015,1,1.01,'SDSS has z = 0.024941 +- 0.000100.','G',0.000027,NULL,'14.3g',0.62,'S0+ pec:',NULL,NULL,NULL,NULL,1,142.443083,2.06436,0.137,NULL,60694617438,948353397,14818021,14.3),(62148,'IRAS','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62148,33.54,0.8,51,21254,75,NULL,'HMCL, I','NGC 2898',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62149,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62149,33.76,0.4,56.5,21254,75,NULL,'HMCL, I, inv','NGC 2898',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62150,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62150,33.8,0.4,57.6,21254,75,NULL,'HMCL, I, raw','NGC 2898',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62151,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62151,34.18,0.4,68.4,21254,75,NULL,'HMCL, I, cor','NGC 2898',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62152,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62152,38.21,0.46,438,21255,70,NULL,NULL,'2MASX J09294822+1351434',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,142.451,13.862,0.073,NULL,63855694670,997745229,15589769,17.5),(62153,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62153,38.3,0.46,456,21256,70,NULL,NULL,'2MASX J09294871+0838379',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000143,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,142.452875,8.64383,0.085,NULL,60715358909,948677482,14823085,17.8),(62154,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62154,36.88,0.46,238,21257,70,NULL,NULL,'2MASX J09294900+4111200',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000145,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,142.4542917,41.18889,0,NULL,64259539924,1004055311,15688364,16.4),(62155,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62155,35.88,0.46,150,21258,70,NULL,NULL,'2MASX J09295033+0803169',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,142.459625,8.05486,0.097,NULL,60716125290,948689457,14823272,16.9),(62156,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62156,36.63,0.46,211,21259,70,NULL,NULL,'2MASX J09295102+1447134',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,142.4627083,14.78697,0.081,NULL,63722936193,995670878,15557357,16.9),(62157,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62157,38.37,0.46,472,21260,70,NULL,NULL,'2MASX J09295143+2418305',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000178,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,142.464125,24.30847,0.065,NULL,63711807780,995496996,15554640,17.5),(62158,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62158,32.97,NULL,39.2,21261,NULL,NULL,NULL,'AGC 192137',NULL,'2015AstBu..70....1K',2015,1,NULL,NULL,'RadioS',0.0002,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,142.464583,11.92556,0.073,NULL,63636408131,994318877,15536232,NULL),(62159,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62159,36.57,0.46,206,21262,70,NULL,NULL,'2MASX J09295200+2004199',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000176,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,142.466625,20.07222,0.125,NULL,63740030745,995937980,15561530,16.8),(62160,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62160,37.33,0.46,293,21263,70,NULL,NULL,'2MASX J09295243+1006519',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.0002,NULL,'16.0g',0.41,'E/S0',NULL,NULL,NULL,NULL,1,142.468375,10.11439,0.093,NULL,60701745670,948464776,14819762,16),(62161,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62161,38.67,0.33,542,21264,70,NULL,NULL,'2MASX J09295256+1004389',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000207,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,142.468917,10.07758,0.093,NULL,60701748417,948464819,14819762,17.6),(62162,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62162,35.36,0.33,118,21265,70,NULL,NULL,'2MASX J09295353+0216492',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000083,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,142.473125,2.28036,0.129,NULL,60694631265,948353613,14818025,16.7),(62163,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62163,37.57,0.46,327,21266,70,NULL,NULL,'2MASX J09295362+1620284',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,142.4734583,16.34136,0.093,NULL,63734100214,995845315,15560083,18),(62164,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62164,38.23,0.46,442,21267,70,NULL,NULL,'2MASX J09295406+1104179',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000184,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,142.4752917,11.07153,0.053,NULL,63636539707,994320932,15536264,17.8),(62165,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62165,35.86,0.71,149,21268,70,NULL,NULL,'2MASX J09295458-0637238',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.59',NULL,NULL,NULL,NULL,NULL,NULL,1,142.477375,-6.62333,0.089,NULL,41100147195,642189799,10034215,16.59),(62166,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62166,37.72,0.46,349,21269,70,NULL,NULL,'SDSS J092954.79+103608.8',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000148,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,142.478333,10.60244,0.089,NULL,63638352122,994349251,15536707,18),(62167,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62167,37.74,0.27,352,21270,70,NULL,NULL,'2MASX J09295481+1439544',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,142.478333,14.66517,0.081,NULL,63722885964,995670093,15557345,18),(62168,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62168,38.95,0.46,617,21271,70,NULL,NULL,'2MASX J09295894+1437284',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,142.495667,14.62444,0.081,NULL,63722410417,995662662,15557229,17.9),(62169,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62169,37.54,0.33,323,21272,70,NULL,NULL,'2MASX J09300194+1717096',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,142.5080417,17.28603,0.053,NULL,63731424690,995803510,15559429,16.5),(62170,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62170,37.33,0.46,293,21273,70,NULL,NULL,'2MASX J09300254+3130077',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000154,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,142.510375,31.50208,0,NULL,64210372671,1003287072,15676360,17.3),(62171,'Mass Model','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62171,20.88,0.4,0.15,21274,NULL,NULL,'Model 2','AGC198606',NULL,'2015A&A...573L...3A',2015,1,NULL,NULL,'RadioS',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,142.510417,16.63556,0.097,1,63729713430,995776772,15559012,NULL),(62172,'Mass Model','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62172,23.12,NULL,0.42,21274,NULL,NULL,'Model 1','AGC198606',NULL,'2015A&A...573L...3A',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62173,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62173,23.96,NULL,0.62,21274,NULL,NULL,NULL,'AGC198606',NULL,'2015A&A...573L...3A',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62174,'CMD','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62174,22.89,0.05,0.378,21275,NULL,NULL,NULL,'AGC 198606',NULL,'2015ApJ...811...35J',2015,1,NULL,NULL,'RadioS',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,142.510417,16.63556,0.097,1,63729713430,995776772,15559012,NULL),(62175,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62175,36.37,0.33,188,21276,70,NULL,NULL,'CGCG 181-048',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000083,NULL,'15.3g',0.56,'S0^-',NULL,NULL,NULL,NULL,1,142.514833,34.22369,0,NULL,64180636726,1002822448,15669100,15.3),(62176,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62176,37.54,0.33,323,21277,70,NULL,NULL,'2MASX J09300522+1714416',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000176,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,142.5217083,17.24489,0.053,NULL,63731422728,995803480,15559429,16.9),(62177,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62177,37.03,0.33,254,21278,70,NULL,NULL,'2MASX J09300521+0535552',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000162,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,142.521833333,5.59861,0.129,NULL,60717884966,948716952,14823702,16.5),(62178,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62178,36.66,0.46,215,21279,70,NULL,NULL,'2MASX J09300617+0652559',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000135,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,142.525791667,6.88214,0.125,NULL,60713508103,948648564,14822633,17.2),(62179,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62179,38.32,0.46,461,21280,70,NULL,NULL,'2MASX J09300784+0731411',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000148,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,142.532667,7.52808,0.101,NULL,60713352135,948646127,14822595,17.7),(62180,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62180,37.69,0.46,346,21281,70,NULL,NULL,'2MASX J09300845-0019380',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000089,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,142.535125,-0.32731,0.049,NULL,41110942011,642358468,10036851,17.6),(62181,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62181,37.03,0.33,254,21282,70,NULL,NULL,'2MASX J09300876+0531442',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000195,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,142.536625,5.52897,0.129,NULL,60718766434,948730725,14823917,16.4),(62182,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62182,38.69,0.46,546,21283,70,NULL,NULL,'2MASX J09300906+3834571',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00018,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,142.537875,38.58267,0,NULL,64394324529,1006161320,15721270,17.5),(62183,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62183,37.25,0.27,282,21284,70,NULL,NULL,'2MASX J09300913-0000010',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000088,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,142.538,-0.00039,0.053,NULL,41110888515,642357633,10036838,17),(62184,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62184,33.59,0.49,52.1,21285,75,NULL,'IR','IC 2487',NULL,'2011yCatp016004901K',2011,1,1.27,'CGCG misprints name as \'IC 2489\'; corrected in CGCG errata.','G',0.00002,NULL,'14.1g',0.49,'Sb: sp','Isolated galaxy',NULL,NULL,NULL,1,142.5382083,20.09086,0.125,NULL,63739813552,995934586,15561477,14.1),(62185,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62185,33.9,0.47,60.2,21285,NULL,NULL,'H','IC 2487',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62186,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62186,33.99,0.45,62.8,21285,NULL,NULL,'K','IC 2487',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62187,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62187,34,0.46,63.1,21285,NULL,NULL,'J','IC 2487',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62188,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62188,34.11,0.4,66.2,21285,NULL,NULL,'mean','IC 2487',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62189,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62189,32.25,0.49,28.2,21286,75,NULL,'IR','IC 0540',NULL,'2011yCatp016004901K',2011,1,1.56,NULL,'G',0.000083,NULL,'14.5g',0.38,'S',NULL,NULL,NULL,NULL,1,142.5430417,7.90275,0.097,NULL,60716522387,948695662,14823369,14.5),(62190,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62190,33.03,NULL,40.4,21286,NULL,NULL,NULL,'IC 0540',NULL,'2015AstBu..70....1K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62191,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62191,36.24,0.46,177,21287,70,NULL,NULL,'SDSS J093011.90+034253.6',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000157,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,142.549625,3.71489,0.093,NULL,60731305021,948926640,14826978,16.9),(62192,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62192,37.39,0.46,300,21288,70,NULL,NULL,'2MASX J09301250+0312452',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,142.552,3.21244,0.105,NULL,60730597323,948915583,14826805,17.6),(62193,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62193,37.56,0.46,325,21289,70,NULL,NULL,'2MASX J09301257+0517342',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,142.552375,5.29269,0.109,NULL,60718225057,948722266,14823785,18),(62194,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62194,37.25,0.27,282,21290,70,NULL,NULL,'2MASX J09301371-0004269',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000078,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,142.55725,-0.07425,0.049,NULL,41110923025,642358172,10036846,17.2),(62195,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62195,37.7,0.46,346,21291,70,NULL,NULL,'2MASX J09301572+0333072',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,142.565708333,3.55192,0.093,NULL,60730504329,948914130,14826783,17.6),(62196,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62196,37.79,0.46,361,21292,70,NULL,NULL,'2MASX J09301613+0127472',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000103,NULL,'16.8g',0.32,'NLAGN',NULL,NULL,NULL,'Sy 2',1,142.5672083,1.46328,0.145,NULL,60694845146,948356955,14818077,16.8),(62197,'Tully est','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62197,32.14,0.8,26.8,21293,75,NULL,'B','NGC 2893',NULL,'1988NBGC.C....0000T',1988,1,1.1,NULL,'G',0.000017,NULL,'13.60',1,'(R)SB0/a       Sbrst','Possible field galaxy',NULL,NULL,'Starburst',1,142.570667,29.53997,0.021,NULL,64207569448,1003243272,15675676,13.6),(62198,'SBF','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62198,31.86,0.24,23.6,21294,NULL,NULL,'I','NGC 2904',NULL,'2001ApJ...546..681T',2001,1,1.5,NULL,'G',0.000103,NULL,'13.43',1,'SAB(s)0-?',NULL,NULL,NULL,NULL,1,142.570833,-30.38503,0.665,NULL,42868731606,669823931,10465998,13.43),(62199,'SBF','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62199,31.89,0.14,23.9,21294,74.4,NULL,NULL,'NGC 2904',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62200,'D-Sigma','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62200,33.57,0.4,51.7,21294,75,NULL,'Edat, raw','NGC 2904',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62201,'D-Sigma','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62201,33.9,0.4,60.3,21294,75,NULL,'Edat, cor','NGC 2904',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62202,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62202,32.89,0.4,37.8,21294,NULL,NULL,'mean','NGC 2904',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62203,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62203,33.58,0.45,52,21294,NULL,NULL,'K','NGC 2904',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62204,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62204,37.9,0.21,380,21295,70,NULL,NULL,'2MASX J09301866+0349192',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00016,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,142.5777083,3.82189,0.077,NULL,60730782722,948918480,14826851,16.8),(62205,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62205,37.23,0.46,279,21296,70,NULL,NULL,'2MASX J09302143+2515089',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000235,NULL,'17.35',0.36,NULL,NULL,NULL,NULL,NULL,1,142.58925,25.25244,0.041,NULL,64194582319,1003040348,15672505,17.35),(62206,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62206,38.4,0.46,479,21297,70,NULL,NULL,'2MASX J09302161+1543527',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,142.590125,15.73142,0.081,NULL,63733593261,995837394,15559959,17.6),(62207,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62207,37.4,0.46,302,21298,70,NULL,NULL,'2MASX J09302185+0854141',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,142.5910417,8.90389,0.065,NULL,60715431310,948678614,14823103,16.8),(62208,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62208,37.24,0.46,280,21299,70,NULL,NULL,'2MASX J09302345+6206261',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,142.597625,62.10731,0.069,NULL,62041885478,969404460,15146944,NULL),(62209,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62209,38,0.46,398,21300,70,NULL,NULL,'SDSS J093025.49+355739.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000188,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,142.60625,35.96086,0,NULL,64400612828,1006259575,15722805,18.4),(62210,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62210,36.57,0.46,206,21301,70,NULL,NULL,'2MASX J09302758+3205229',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000173,NULL,'16.0g',0.46,NULL,NULL,NULL,NULL,NULL,1,142.615,32.08981,0,NULL,64209834954,1003278671,15676229,16),(62211,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62211,37.17,0.46,271,21302,70,NULL,NULL,'2MASX J09302853+0142212',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000084,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,142.618833,1.70594,0.133,NULL,60694387145,948349799,14817965,17.4),(62212,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62212,37.56,0.46,325,21303,70,NULL,NULL,'SDSS J093030.33+083757.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00014,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,142.626417,8.63264,0.073,NULL,60715801688,948684401,14823193,18.4),(62213,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62213,37.67,0.46,342,21304,70,NULL,NULL,'SDSS J093030.67+200202.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.2g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,142.6277917,20.03417,0.125,NULL,63739840329,995935005,15561484,18.2),(62214,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62214,35.49,0.46,125,21305,70,NULL,NULL,'2MASX J09303127+3917503',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00016,NULL,'15.4g',0.5,'S0',NULL,NULL,NULL,NULL,1,142.6302917,39.29722,0,NULL,64392670791,1006135481,15720866,15.4),(62215,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62215,37.25,0.27,282,21306,70,NULL,NULL,'2MASX J09303138-0002389',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000072,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,142.6307917,-0.04406,0.049,NULL,41110871100,642357360,10036833,17.6),(62216,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62216,37.83,0.46,368,21307,70,NULL,NULL,'2MASX J09303180+1310384',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,142.632416667,13.17742,0.065,NULL,63854434811,997725543,15589461,17.7),(62217,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62217,37.35,0.46,295,21308,70,NULL,NULL,'2MASX J09303215+4130363',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000135,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,142.6339583,41.51017,0.053,NULL,64259903325,1004060989,15688452,17.7),(62218,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62218,36.86,0.46,236,21309,70,NULL,NULL,'2MASX J09303362+5323183',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,142.64025,53.38858,0.013,NULL,63964640414,999447506,15616367,17),(62219,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62219,37.74,0.46,353,21310,70,NULL,NULL,'SDSS J093034.75+053936.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,142.644833,5.66019,0.129,NULL,60718777483,948730898,14823920,18),(62220,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62220,37.02,0.46,254,21311,70,NULL,NULL,'2MASX J09303608+1524124',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,142.65025,15.40344,0.077,NULL,63722109404,995657959,15557155,16.8),(62221,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62221,37.87,0.46,376,21312,70,NULL,NULL,'2MASX J09303704+0744105',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000189,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,142.654375,7.73636,0.101,NULL,60716496911,948695264,14823363,16.9),(62222,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62222,36.17,0.46,171,21313,70,NULL,NULL,'2MASX J09303708+0159442',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000097,NULL,'15.9g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,142.654583,1.99567,0.129,NULL,60694706606,948354790,14818043,15.9),(62223,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62223,38.07,0.46,412,21314,70,NULL,NULL,'SDSS J093037.16+522835.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000096,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,142.654833,52.47647,0.005,NULL,63971055728,999547745,15617933,18.6),(62224,'BL Lac Luminosity','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62224,39.77,NULL,758,21315,NULL,NULL,NULL,'SDSS J093037.57+495025.6',0.186742,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.000195,NULL,'18.3g',NULL,'BrClG          BLLAC',NULL,NULL,NULL,'BL Lac',1,142.656625,49.84044,0.005,NULL,63960696483,999385882,15615404,18.3),(62225,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62225,36.35,0.46,186,21316,70,NULL,NULL,'2MASX J09303843+3214570',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000174,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,142.66,32.24917,0,NULL,64209875319,1003279301,15676239,16.3),(62226,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62226,38.17,0.46,430,21317,70,NULL,NULL,'2MASX J09303920+2548579',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000185,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,142.6635417,25.816,0.037,NULL,64194487747,1003038871,15672482,16.7),(62227,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62227,37.13,0.46,267,21318,70,NULL,NULL,'2MASX J09303977+2939409',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000131,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,142.665833,29.66147,0.017,NULL,64207580730,1003243448,15675678,17.9),(62228,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62228,36.59,0.46,208,21319,70,NULL,NULL,'2MASX J09303991+2027333',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000181,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,142.666125,20.45914,0.105,NULL,63739294581,995926477,15561351,16.3),(62229,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62229,37.12,0.46,265,21320,70,NULL,NULL,'2MASX J09304040+0751586',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,142.668416667,7.86631,0.101,NULL,60716542512,948695976,14823374,17.8),(62230,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62230,37.75,0.46,354,21321,70,NULL,NULL,'2MASX J09304260+2938399',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000127,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,142.677583,29.64453,0.017,NULL,64207580794,1003243449,15675678,17.4),(62231,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62231,37.92,0.46,384,21322,70,NULL,NULL,'2MASX J09304299+0207501',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000075,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,142.67925,2.13047,0.137,NULL,60694549401,948352334,14818005,17.8),(62232,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62232,37.73,0.46,352,21323,70,NULL,NULL,'SDSS J093043.82+074740.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000147,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,142.682625,7.79456,0.101,NULL,60716490071,948695157,14823361,18.3),(62233,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62233,38.31,0.46,459,21324,70,NULL,NULL,'2MASX J09304564+1549164',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,142.690291667,15.82136,0.081,NULL,63734461590,995850962,15560171,18.2),(62234,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62234,37.82,0.46,366,21325,70,NULL,NULL,'2MASX J09304876+4000333',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,142.703417,40.00933,0,NULL,64392630204,1006134846,15720856,17.6),(62235,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62235,36.61,0.46,210,21326,70,NULL,NULL,'2MASX J09305052+0248581',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00017,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,142.710333333,2.81611,0.145,NULL,60693737071,948339641,14817806,16.4),(62236,'Faber-Jackson','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62236,32.29,1.31,28.7,21327,95,NULL,'Weighted Mean','NGC 2902',NULL,'1984ApJS...56...91D',1984,1,1.4,NULL,'G',0.00002,NULL,'12.21',1.2,'SA(s)0^0^:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,142.720375,-14.73578,0.253,NULL,42297296957,660895264,10326488,12.21),(62237,'Faber-Jackson','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62237,33.81,1.61,57.8,21327,55,NULL,'Visvanathan & Sandage 1979','NGC 2902',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62238,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62238,32.56,0.52,32.6,21327,70,NULL,NULL,'NGC 2902',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62239,'Tully est','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62239,32.26,0.8,28.3,21327,75,NULL,'B','NGC 2902',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62240,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62240,35.98,0.46,157,21328,70,NULL,NULL,'2MASX J09305660+3158430',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000175,NULL,'15.6g',0.5,NULL,NULL,NULL,NULL,NULL,1,142.73575,31.97858,0,NULL,64210031683,1003281745,15676277,15.6),(62241,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62241,37.9,0.21,380,21329,70,NULL,NULL,'2MASX J09305872+0348281',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000201,NULL,'16.2g',0.39,'BrClG          AGN',NULL,NULL,NULL,NULL,1,142.74475,3.80769,0.081,NULL,60718975186,948733987,14823968,16.2),(62242,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62242,35.56,0.46,129,21330,70,NULL,NULL,'2MASX J09310438+4545530',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000186,NULL,'15.6g',0.41,'S0',NULL,NULL,NULL,NULL,1,142.76825,45.76481,0.081,NULL,63980230098,999691095,15620173,15.6),(62243,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62243,37.53,0.46,320,21331,70,NULL,NULL,'2MASX J09310508+3625186',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,142.7710417,36.42172,0,NULL,64404651252,1006322675,15723791,17.8),(62244,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62244,37.86,0.46,373,21332,70,NULL,NULL,'2MASX J09310615+0027221',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000093,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,142.775791667,0.45628,0.081,NULL,60693655885,948338373,14817787,17.7),(62245,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62245,34.3,0.56,72.5,21333,70,NULL,NULL,'IC 0542',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000093,NULL,'15',0.4,'(R\')SB(rs)0/a: HII',NULL,NULL,NULL,NULL,1,142.775917,-13.18136,0.193,NULL,42363200801,661925012,10342578,15),(62246,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62246,36.81,0.46,230,21334,70,NULL,NULL,'2MASX J09310664+4949267',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000089,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,142.7774583,49.82411,0.005,NULL,63960688137,999385752,15615402,16.8),(62247,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62247,33.47,0.51,49.4,21335,70,NULL,NULL,'ESO 434- G 009',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000067,NULL,'14',1,'E-S0    poss. LINER?',NULL,NULL,NULL,NULL,1,142.778916667,-30.35828,0.549,NULL,42868588212,669821690,10465963,14),(62248,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62248,37.96,0.46,390,21336,70,NULL,NULL,'SDSS J093106.95+112510.9',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000163,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,142.779,11.41972,0.081,NULL,63636589097,994321704,15536276,18.8),(62249,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62249,37.14,0.46,268,21337,70,NULL,NULL,'2MASX J09310774+3808426',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00015,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,142.782125,38.14514,0.013,NULL,64393737242,1006152144,15721127,17.8),(62250,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62250,37.9,0.21,380,21338,70,NULL,NULL,'2MASX J09310900+0346521',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,142.787375,3.78117,0.081,NULL,60718985133,948734142,14823970,18.1),(62251,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62251,37.28,0.33,286,21339,70,NULL,NULL,'2MASX J09310903+0954499',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000177,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,142.7877083,9.91397,0.109,NULL,60701802991,948465671,14819776,17.4),(62252,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62252,35.75,0.46,141,21340,70,NULL,NULL,'CGCG 122-012',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000181,NULL,'15.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,142.787833,20.91683,0.097,NULL,63750711470,996104866,15564138,15.9),(62253,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62253,31.87,0.4,23.7,21341,75,NULL,NULL,'UGC 05050',NULL,'2008Ap.....51..336K',2008,1,1.1,NULL,'G',0.000087,NULL,'15.44',0.2,'S?',NULL,NULL,NULL,NULL,1,142.789167,76.46417,0,NULL,61411714272,959558035,14993094,15.44),(62254,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62254,32.92,0.49,38.4,21341,75,NULL,'IR','UGC 05050',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62255,'SNIa','2016-12-15 15:14:29','2016-12-16 11:19:36','1','SN 1998J',NULL,62255,43.61,0.61,2880,21342,65,NULL,NULL,'H-ZSNS J093110.48-044536.5',0.83,'2004ApJ...607..665R',2004,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,142.793666667,-4.76014,0.065,NULL,41124152086,642564876,10040076,NULL),(62256,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62256,37.9,0.21,380,21343,70,NULL,NULL,'SDSS J093110.53+034929.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000147,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,142.793875,3.82478,0.081,NULL,60719700244,948745316,14824145,18.2),(62257,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62257,32.8,0.4,36.3,21344,75,NULL,NULL,'ESO 434- G 010',NULL,'2008Ap.....51..336K',2008,1,1,'6dF DR1 has z = 0.006759.','G',0.000023,NULL,'15.87',0.2,'Sa-b',NULL,NULL,NULL,NULL,1,142.8000417,-30.21425,0.549,NULL,42868605743,669821964,10465968,15.87),(62258,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62258,33.59,0.49,52.3,21344,75,NULL,'IR','ESO 434- G 010',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62259,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62259,37.17,0.33,271,21345,70,NULL,NULL,'2MASX J09311278+2614334',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,142.803417,26.24275,0.045,NULL,64197649307,1003088270,15673254,17.3),(62260,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62260,37.7,0.46,347,21346,70,NULL,NULL,'2MASX J09311348+0727359',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,142.806375,7.45997,0.101,NULL,60712919254,948639363,14822490,17.9),(62261,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62261,32.9,0.47,38,21347,NULL,NULL,'H','UGC 05052',NULL,'2007A&A...465...71T',2007,1,1.5,'MCG implies the R.A. is 08h26.2m; corrected in MCG errata.','G',0.000027,NULL,'14.05',1,'SB(s)a',NULL,NULL,NULL,NULL,1,142.808125,73.81053,0.037,NULL,61374955895,958983685,14984120,14.05),(62262,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62262,33.1,0.46,41.6,21347,NULL,NULL,'J','UGC 05052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62263,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62263,33.13,0.45,42.2,21347,NULL,NULL,'K','UGC 05052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62264,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62264,33.23,0.4,44.3,21347,NULL,NULL,'mean','UGC 05052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62265,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62265,35.26,0.52,113,21348,70,NULL,NULL,'2MASX J09311466-0739284',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.06',0.4,NULL,NULL,NULL,NULL,NULL,1,142.811125,-7.65806,0.069,NULL,41103498610,642242165,10035033,16.06),(62266,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62266,36.86,0.46,235,21349,70,NULL,NULL,'2MASX J09311483+2107060',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000172,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,142.811916667,21.11836,0.097,NULL,63751221845,996112841,15564263,16.8),(62267,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62267,35.84,0.46,147,21350,70,NULL,NULL,'2MASX J09311553+0920329',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,142.814583,9.34244,0.077,NULL,60701329683,948458276,14819660,17),(62268,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62268,37.87,0.46,375,21351,70,NULL,NULL,'2MASX J09311770+0847049',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000184,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,142.823916667,8.78456,0.065,NULL,60715719093,948683110,14823173,17.3),(62269,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62269,37.36,0.23,296,21352,70,NULL,NULL,'2MASX J09311773+0523457',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000192,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,142.824,5.39614,0.109,NULL,60718627079,948728548,14823883,16.6),(62270,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62270,35.69,0.46,137,21353,70,NULL,NULL,'2MASX J09311877+4446469',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000168,NULL,'16.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,142.828417,44.77981,0.065,NULL,64263492246,1004117066,15689329,16.3),(62271,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62271,37.51,0.46,318,21354,70,NULL,NULL,'2MASX J09311899+4715459',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000192,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,142.829208333,47.26289,0.013,NULL,63980044420,999688194,15620128,17.2),(62272,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62272,38.27,0.46,450,21355,70,NULL,NULL,'2MASX J09311924+0357277',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,142.830125,3.95761,0.077,NULL,60719748799,948746074,14824157,18.3),(62273,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62273,39.17,0.46,684,21356,70,NULL,NULL,'SDSS J093119.66+563312.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000083,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,142.8319583,56.55344,0.049,NULL,61887470910,966991732,15109245,18.5),(62274,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62274,37.45,0.46,309,21357,70,NULL,NULL,'2MASX J09311993+2625203',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,142.833125,26.42233,0.045,NULL,64197641297,1003088145,15673252,17.5),(62275,'SNIa','2016-12-15 15:14:29','2016-12-16 11:19:36','1','SN 1998ac',NULL,62275,41.83,0.4,1590,21358,65,NULL,NULL,'H-ZSNS J093120.00-051624.3',0.46,'2004ApJ...607..665R',2004,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,142.833333,-5.27342,0.117,NULL,41123765130,642558830,10039981,NULL),(62276,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62276,35.97,0.46,156,21359,70,NULL,NULL,'2MASX J09312135+0937289',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000161,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,142.839,9.62481,0.085,NULL,60701392340,948459255,14819675,16.4),(62277,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62277,36.95,0.46,245,21360,70,NULL,NULL,'2MASX J09312252+0311387',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000156,NULL,'16.6g',0.38,NULL,NULL,NULL,NULL,NULL,1,142.843791667,3.194,0.117,NULL,60718857783,948732152,14823939,16.6),(62278,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62278,37.17,0.33,271,21361,70,NULL,NULL,'2MASX J09312303+2612523',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000191,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,142.845958333,26.21453,0.053,NULL,64194187749,1003034183,15672409,16.5),(62279,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62279,38.38,0.46,474,21362,70,NULL,NULL,'2MASX J09312382+1155289',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000142,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,142.84925,11.92467,0.073,NULL,63636945246,994327269,15536363,18.2),(62280,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62280,36.28,0.46,181,21363,70,NULL,NULL,'2MASX J09312467-0021097',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000184,NULL,'15.8g',0.42,'S0',NULL,NULL,NULL,NULL,1,142.852917,-0.35278,0.045,NULL,41111429810,642366090,10036970,15.8),(62281,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62281,37.36,0.23,296,21364,70,NULL,NULL,'2MASX J09312484+0524087',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000175,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,142.8534583,5.40244,0.109,NULL,60718618375,948728412,14823881,17.2),(62282,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62282,36.9,0.46,240,21365,70,NULL,NULL,'2MASX J09312928+1429470',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'18.17',0.37,NULL,NULL,NULL,NULL,NULL,1,142.872041667,14.49633,0.081,NULL,63722432022,995663000,15557234,18.17),(62283,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62283,36.92,0.46,242,21366,70,NULL,NULL,'2MASX J09313290+5602574',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,142.887083,56.04939,0.045,NULL,61890482927,967038795,15109981,17.4),(62284,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62284,38.13,0.46,423,21367,70,NULL,NULL,'2MASX J09313335+0847569',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,142.889,8.79919,0.073,NULL,60715745476,948683523,14823180,17.4),(62285,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62285,37.3,0.46,288,21368,70,NULL,NULL,'2MASX J09313538+3229346',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,142.8975417,32.49303,0,NULL,64208774600,1003262103,15675970,17.3),(62286,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62286,37.61,0.46,333,21369,70,NULL,NULL,'2MASX J09313555+6626525',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,142.897833333,66.44783,0.121,NULL,62249658070,972650907,15197670,18),(62287,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62287,38.48,0.46,496,21370,70,NULL,NULL,'SDSS J093135.64+480804.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000133,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,142.8985,48.13469,0.017,NULL,64014484201,1000226315,15628536,18.2),(62288,'Tully est','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62288,32.25,0.8,28.2,21371,75,NULL,'B','NGC 2907',NULL,'1988NBGC.C....0000T',1988,1,1.8,NULL,'G',0.00003,NULL,'12.7',1.1,'SA(s)a?  poss. LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,142.903,-16.73467,0.221,NULL,42310366367,661099474,10329679,12.7),(62289,'FP','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,'R',62289,36.56,0.46,205,21372,70,NULL,NULL,'2MASX J09313674+0159197',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000079,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,142.90325,1.98892,0.129,NULL,60694318301,948348723,14817948,17.1),(62290,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62290,31.73,0.43,22.2,21373,75,NULL,'3.6 micron, color + selection bias corrected','ESO 434- G 011',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.000017,NULL,'14',0.5,'Sc             HII',NULL,NULL,NULL,'H_alpha Emission-Line Galaxy',1,142.90375,-30.30736,0.549,NULL,42868611818,669822059,10465969,14),(62291,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62291,31.92,0.43,24.2,21373,75,NULL,'3.6 micron, color corrected','ESO 434- G 011',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62292,'Tully-Fisher','2016-12-15 15:14:29','2016-12-16 11:19:36','1',NULL,NULL,62292,32.05,0.2,25.7,21373,74.4,NULL,NULL,'ESO 434- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62293,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62293,33,0.4,39.9,21373,NULL,NULL,'mean','ESO 434- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62294,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62294,33.13,0.47,42.3,21373,NULL,NULL,'H','ESO 434- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62295,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62295,33.24,0.45,44.5,21373,NULL,NULL,'K','ESO 434- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62296,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62296,33.25,0.46,44.7,21373,NULL,NULL,'J','ESO 434- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62297,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62297,36.96,0.46,246,21374,70,NULL,NULL,'2MASX J09313870+2908574',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000176,NULL,'16.3g',0.34,'E',NULL,NULL,NULL,NULL,1,142.911375,29.14933,0.021,NULL,64221341672,1003458463,15679038,16.3),(62298,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62298,37.53,0.23,321,21375,70,NULL,NULL,'2MASX J09313921+0926095',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000095,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,142.913291667,9.43583,0.061,NULL,60701308123,948457939,14819655,17.5),(62299,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62299,33.56,NULL,51.4,21376,NULL,NULL,NULL,'MCG -03-25-003',NULL,'2000BSAO...50....5K',2000,1,1.84,'RC3 has V = 5979 +- 9 km/s.','G',0.000038,NULL,'15',0.21,'Sd',NULL,NULL,NULL,NULL,1,142.922333,-16.04253,0.261,NULL,42311045937,661110092,10329845,15),(62300,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62300,34.05,NULL,64.4,21376,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -03-25-003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62301,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62301,34.05,NULL,64.7,21376,NULL,NULL,'Dipole + Quadrupole','MCG -03-25-003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62302,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62302,34.06,NULL,64.8,21376,NULL,NULL,'Dipole','MCG -03-25-003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62303,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62303,34.1,0.43,66.2,21376,75,NULL,'3.6 micron, color + selection bias corrected','MCG -03-25-003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62304,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62304,37.28,0.33,286,21377,70,NULL,NULL,'2MASX J09314149+0959065',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,142.92275,9.98506,0.109,NULL,60703980721,948499698,14820307,17.6),(62305,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62305,34.02,0.46,63.7,21378,70,NULL,NULL,'UGC 05075',NULL,'2015arXiv151105856S',2015,1,0.88,NULL,'G',0.000153,NULL,'14.0g',0.85,'S0/a?',NULL,NULL,NULL,NULL,1,142.9235,4.50003,0.085,NULL,60719528291,948742629,14824103,14),(62306,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62306,37.77,0.46,359,21379,70,NULL,NULL,'2MASX J09314173+2325218',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,142.923708333,23.42278,0.049,NULL,63713838290,995528723,15555136,17.6),(62307,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62307,38.7,0.46,549,21380,70,NULL,NULL,'2MASX J09314220+5326300',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000174,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,142.926,53.44164,0.005,NULL,63964619908,999447186,15616362,18.3),(62308,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62308,37.24,0.46,280,21381,70,NULL,NULL,'2MASX J09314376+0813525',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000151,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,142.9325,8.23131,0.081,NULL,60716603523,948696930,14823389,17.1),(62309,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62309,36.53,0.46,202,21382,70,NULL,NULL,'2MASX J09314499+4144033',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000169,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,142.937375,41.73417,0.025,NULL,64260102189,1004064096,15688501,16.6),(62310,'IRAS','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62310,33.37,0.8,47.1,21383,75,NULL,'HMCL, I','UGC 05078',NULL,'1997ApJS..109..333W',1997,1,1.22,NULL,'G',0.000033,NULL,'16.7g',0.16,'Sd(f)',NULL,NULL,NULL,NULL,1,142.940667,3.72856,0.081,NULL,60719019256,948734675,14823979,16.7),(62311,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62311,33.56,NULL,51.5,21383,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05078',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62312,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62312,33.58,NULL,51.9,21383,NULL,NULL,'Dipole + Quadrupole','UGC 05078',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62313,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62313,33.58,NULL,51.9,21383,NULL,NULL,'Dipole','UGC 05078',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62314,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62314,33.64,NULL,53.5,21383,NULL,NULL,NULL,'UGC 05078',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62315,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62315,34.07,0.4,65.1,21383,75,NULL,'HMCL, I, inv','UGC 05078',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62316,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62316,34.08,0.4,65.5,21383,75,NULL,'HMCL, I, raw','UGC 05078',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62317,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62317,34.15,0.2,67.6,21383,74.4,NULL,NULL,'UGC 05078',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62318,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62318,34.45,0.4,77.6,21383,75,NULL,'HMCL, I, cor','UGC 05078',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62319,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62319,37.9,0.21,380,21384,70,NULL,NULL,'2MASX J09314785+0350513',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,142.949291667,3.84747,0.081,NULL,60719723912,948745686,14824151,17.5),(62320,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62320,37.57,0.46,327,21385,70,NULL,NULL,'2MASX J09314805+0400453',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000176,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,142.950125,4.01261,0.077,NULL,60719735534,948745867,14824154,17.3),(62321,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62321,37.34,0.46,294,21386,70,NULL,NULL,'2MASX J09314952+5458553',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000066,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,142.95625,54.98194,0.029,NULL,61881561184,966899393,15107803,17.7),(62322,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62322,37.94,0.33,386,21387,70,NULL,NULL,'SDSS J093150.13+362329.8',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000165,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,142.958917,36.39164,0,NULL,64404593856,1006321779,15723777,17.1),(62323,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62323,37.28,0.46,286,21388,70,NULL,NULL,'2MASX J09315042+0912355',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000164,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,142.9600417,9.20992,0.053,NULL,60701279896,948457498,14819648,17.3),(62324,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62324,37.42,0.46,305,21389,70,NULL,NULL,'2MASX J09315112+5024590',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000187,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,142.963125,50.41656,0.013,NULL,63960977656,999390275,15615473,16.4),(62325,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62325,37.56,0.46,325,21390,70,NULL,NULL,'2MASX J09315165+2043318',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000152,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,142.965167,20.72567,0.089,NULL,63750798376,996106224,15564159,17.2),(62326,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62326,34.12,NULL,66.8,21391,NULL,NULL,'Dipole + Quadrupole','FGC 0904',NULL,'2010Ap&SS.325..163P',2010,1,1.49,NULL,'G',0.000027,'?','15.60',0.12,'Sd',NULL,NULL,NULL,NULL,1,142.974291667,-16.67933,0.253,NULL,42310335824,661098997,10329671,15.6),(62327,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62327,34.13,NULL,66.9,21391,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0904',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62328,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62328,34.14,NULL,67.2,21391,NULL,NULL,NULL,'FGC 0904',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62329,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62329,34.14,NULL,67.2,21391,NULL,NULL,'Dipole','FGC 0904',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62330,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62330,37.53,0.23,321,21392,70,NULL,NULL,'2MASX J09315394+0931505',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000159,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,142.974666667,9.53069,0.061,NULL,60703148962,948486702,14820104,16.9),(62331,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62331,36.81,0.46,230,21393,70,NULL,NULL,'2MASX J09315471+4212284',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,142.977917,42.20781,0.005,NULL,64258273514,1004035523,15688055,17.2),(62332,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62332,35.98,0.46,157,21394,70,NULL,NULL,'CGCG 181-051',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.000107,NULL,'14.9g',0.65,'E0',NULL,NULL,NULL,NULL,1,142.979583,35.55433,0,NULL,64179394253,1002803035,15668797,14.9),(62333,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62333,38.29,0.46,455,21395,70,NULL,NULL,'SDSS J093158.29+343812.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,142.992875,34.63689,0,NULL,64179988810,1002812325,15668942,18.4),(62334,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62334,36.05,0.51,162,21396,70,NULL,NULL,'2MASX J09320045-1839140',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.96',0.4,NULL,NULL,NULL,NULL,NULL,1,143.001875,-18.65394,0.117,NULL,42331079992,661423124,10334736,15.96),(62335,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62335,35.13,NULL,106,21397,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0901',NULL,'2010Ap&SS.325..163P',2010,1,0.76,NULL,'G',0.000019,NULL,'16.96',0.09,'Sdm',NULL,NULL,NULL,NULL,1,143.002917,12.26167,0.049,NULL,63854240489,997722507,15589414,16.96),(62336,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62336,35.14,NULL,107,21397,NULL,NULL,'Dipole + Quadrupole','FGC 0901',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62337,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62337,35.16,NULL,108,21397,NULL,NULL,'Dipole','FGC 0901',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62338,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62338,35.27,0.5,113,21397,NULL,NULL,NULL,'FGC 0901',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62339,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62339,35.31,0.2,115,21397,74.4,NULL,NULL,'FGC 0901',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62340,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62340,35.37,0.48,118,21397,NULL,NULL,'Malmquist cor.','FGC 0901',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62341,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62341,35.59,NULL,131,21397,NULL,NULL,NULL,'FGC 0901',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62342,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62342,37.46,0.46,311,21398,70,NULL,NULL,'2MASX J09320226+2029368',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,143.009333,20.4935,0.101,NULL,63750599862,996103122,15564111,17.5),(62343,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62343,37.2,0.46,275,21399,70,NULL,NULL,'2MASX J09320388+0345593',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000099,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,143.016166667,3.76642,0.081,NULL,60719041899,948735029,14823984,17.4),(62344,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62344,36.38,0.46,189,21400,70,NULL,NULL,'2MASX J09320454+5133031',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000195,NULL,'15.5g',0.46,'E0',NULL,NULL,NULL,NULL,1,143.018875,51.55097,0.005,NULL,63968340875,999505326,15617270,15.5),(62345,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62345,35.62,0.5,133,21401,70,NULL,NULL,'2MASX J09320592-0528360',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.23',0.4,NULL,NULL,NULL,NULL,NULL,1,143.024583,-5.47669,0.101,NULL,41123849946,642560155,10040002,16.23),(62346,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62346,31.61,0.69,21,21402,100,NULL,'mid-IR','NGC 2906',NULL,'2013ApJ...771...88L',2013,1,1.4,NULL,'G',0.00002,NULL,'13.40',0.9,'Scd:',NULL,NULL,NULL,NULL,1,143.025917,8.44178,0.073,NULL,60715838585,948684977,14823202,13.4),(62347,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62347,32.81,0.4,36.5,21402,NULL,NULL,'mean','NGC 2906',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62348,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62348,32.95,0.45,38.9,21402,NULL,NULL,'K','NGC 2906',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62349,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62349,32.95,0.47,39,21402,NULL,NULL,'H','NGC 2906',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62350,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62350,32.97,0.46,39.2,21402,NULL,NULL,'J','NGC 2906',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62351,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62351,33.14,0.43,42.5,21402,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2906',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62352,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62352,33.16,0.43,42.8,21402,75,NULL,'3.6 micron, color corrected','NGC 2906',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62353,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62353,33.26,0.2,44.9,21402,74.4,NULL,NULL,'NGC 2906',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62354,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62354,37.22,0.46,278,21403,70,NULL,NULL,'2MASX J09320663+0904068',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,143.02775,9.06853,0.033,NULL,60713876354,948654318,14822723,17.4),(62355,'Brightest Stars','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62355,29.74,NULL,8.9,21404,NULL,NULL,NULL,'NGC 2903',NULL,'2000A&AS..142..425D',2000,1,12.6,NULL,'G',0.000001,NULL,'9.68',6,'SAB(rs)bc I-II HII','Isolated galaxy',NULL,NULL,NULL,1,143.042125,21.50083,0.065,NULL,63751177384,996112146,15564252,9.68),(62356,'Grav. Stability Gas. Disk','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62356,29.06,NULL,6.5,21404,NULL,NULL,NULL,'NGC 2903',NULL,'1996AstL...22...71Z',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62357,'HII region diameter','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62357,30.36,NULL,11.8,21404,NULL,NULL,NULL,'NGC 2903',NULL,'1988ApL&C..27...41S',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62358,'IRAS','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62358,30.05,0.8,10.2,21404,75,NULL,'A82, H','NGC 2903',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62359,'Sosies','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62359,30,0.13,10,21404,NULL,NULL,NULL,'NGC 2903',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62360,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62360,27.54,0.69,3.22,21404,100,NULL,'mid-IR','NGC 2903',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62361,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62361,28.98,0.4,6.3,21404,75,NULL,'B','NGC 2903',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62362,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62362,29.35,0.4,7.4,21404,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 2903',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62363,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62363,29.66,0.35,8.55,21404,NULL,NULL,NULL,'NGC 2903',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62364,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62364,29.67,0.39,8.6,21404,73,NULL,'opt','NGC 2903',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62365,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62365,29.7,NULL,8.71,21404,NULL,NULL,'B','NGC 2903',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62366,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62366,29.71,0.47,8.75,21404,75,NULL,'A82, H, raw','NGC 2903',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62367,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62367,29.72,NULL,8.79,21404,NULL,NULL,'I','NGC 2903',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62368,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62368,29.81,0.43,9.1,21404,75,NULL,'3.6 micron, color corrected','NGC 2903',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62369,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62369,29.83,0.43,9.2,21404,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2903',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62370,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62370,29.85,0.1,9.33,21404,NULL,NULL,'B','NGC 2903',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62371,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62371,29.87,0.47,9.43,21404,75,NULL,'A82, H, inv','NGC 2903',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62372,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62372,29.88,0.2,9.46,21404,74.4,NULL,NULL,'NGC 2903',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62373,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62373,30.02,0.47,10.1,21404,75,NULL,'A82, H, cor','NGC 2903',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62374,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62374,30.06,NULL,10.3,21404,NULL,NULL,'LEDA [April 2006]','NGC 2903',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62375,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62375,30.12,0.42,10.6,21404,NULL,NULL,NULL,'NGC 2903',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62376,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62376,30.34,0.38,11.7,21404,NULL,NULL,'Malmquist cor.','NGC 2903',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62377,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62377,38.24,0.46,444,21405,70,NULL,NULL,'2MASX J09321011+0357246',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,143.042083,3.95689,0.081,NULL,60719840817,948747512,14824179,17.5),(62378,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62378,37.15,0.33,269,21406,70,NULL,NULL,'2MASX J09321107+4849252',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,143.046125,48.82369,0.005,NULL,64014045316,1000219458,15628429,17.2),(62379,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62379,37.06,0.46,258,21407,70,NULL,NULL,'2MASX J09321124+1543496',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,143.046875,15.73056,0.089,NULL,63733925027,995842578,15560040,NULL),(62380,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62380,37.59,0.46,330,21408,70,NULL,NULL,'2MASX J09321170+3831031',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,143.048625,38.51742,0,NULL,64394185650,1006159150,15721236,16.6),(62381,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62381,38.8,0.46,576,21409,70,NULL,NULL,'SDSS J093211.86+050838.3',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000158,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,143.049458333,5.144,0.105,NULL,60720078573,948751227,14824237,18.6),(62382,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62382,37.15,0.33,269,21410,70,NULL,NULL,'2MASX J09321206+4854512',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,143.050083333,48.91431,0.009,NULL,64016883142,1000263799,15629121,17.7),(62383,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62383,36.32,0.46,183,21411,70,NULL,NULL,'2MASX J09321455+3126277',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000156,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,143.0607083,31.44111,0,NULL,64210480314,1003288754,15676386,17.1),(62384,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62384,36.47,0.46,196,21412,70,NULL,NULL,'MCG +07-20-017',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000183,NULL,'15.6g',0.45,'E0',NULL,NULL,NULL,NULL,1,143.061375,39.55944,0.013,NULL,64392675394,1006135553,15720868,15.6),(62385,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62385,37.94,0.33,386,21413,70,NULL,NULL,'2MASX J09321569+3618502',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,143.065333,36.31397,0,NULL,64404588129,1006321689,15723776,17.9),(62386,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62386,37.25,0.46,281,21414,70,NULL,NULL,'2MASX J09321898+4115102',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00012,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,143.078917,41.25303,0.021,NULL,64259975563,1004062118,15688470,17.4),(62387,'IRAS','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62387,33.64,0.8,53.5,21415,75,NULL,'HMCL, I','UGC 05083',NULL,'1997ApJS..109..333W',1997,1,2.4,NULL,'G',0.000027,NULL,'16.0',2.1,'Scd(f)',NULL,NULL,NULL,NULL,1,143.08075,0.31586,0.073,NULL,60692840405,948325631,14817587,16),(62388,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62388,29.93,0.36,9.68,21415,NULL,NULL,NULL,'UGC 05083',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62389,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62389,34.52,0.4,80.3,21415,75,NULL,'HMCL, I, raw','UGC 05083',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62390,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62390,34.67,0.4,86,21415,75,NULL,'HMCL, I, inv','UGC 05083',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62391,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62391,34.78,0.4,90.4,21415,75,NULL,'HMCL, I, cor','UGC 05083',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62392,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62392,37.53,0.23,321,21416,70,NULL,NULL,'SDSS J093220.20+093319.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000161,NULL,'18.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,143.084208333,9.55542,0.061,NULL,60703359123,948489986,14820156,18.6),(62393,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62393,37.52,0.46,320,21417,70,NULL,NULL,'2MASX J09322082+4613049',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000173,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,143.0867083,46.21806,0.081,NULL,63980292700,999692073,15620188,16.9),(62394,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62394,33.3,0.2,45.7,21418,74.4,NULL,NULL,'UGC 05082',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.00017,NULL,'14.8',0.3,'S',NULL,NULL,NULL,NULL,1,143.087875,10.80922,0.085,NULL,60700473750,948444902,14819451,14.8),(62395,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62395,33.61,0.49,52.8,21419,75,NULL,'IR','UGC 05082',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.00017,NULL,'14.8',0.3,'S',NULL,NULL,NULL,NULL,1,143.087875,10.80922,0.085,NULL,60700473750,948444902,14819451,14.8),(62396,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62396,38.15,0.46,427,21420,70,NULL,NULL,'2MASX J09322289+3102007',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000186,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,143.095333,31.0335,0,NULL,64209758631,1003277478,15676210,17.7),(62397,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62397,36.4,0.46,190,21421,70,NULL,NULL,'2MASX J09322299+2900250',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00018,NULL,'16.3g',0.37,'E',NULL,NULL,NULL,NULL,1,143.095666667,29.00689,0.017,NULL,64221171760,1003455808,15678997,16.3),(62398,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62398,38.69,0.46,548,21422,70,NULL,NULL,'2MASX J09322371+3833502',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000177,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,143.098791667,38.56389,0,NULL,64395055008,1006172734,15721448,17.6),(62399,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62399,35.45,0.46,123,21423,70,NULL,NULL,'CGCG 063-003',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000177,NULL,'15.2g',0.55,'E0',NULL,NULL,NULL,NULL,1,143.1052083,10.76339,0.085,NULL,60700341363,948442833,14819419,15.2),(62400,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62400,36,0.46,159,21424,70,NULL,NULL,'2MASX J09322526+1440275',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',NULL,NULL,'17.47',0.31,NULL,NULL,NULL,NULL,NULL,1,143.105333333,14.67431,0.085,NULL,63722760476,995668132,15557314,17.47),(62401,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62401,37.53,0.23,321,21425,70,NULL,NULL,'2MASX J09322601+0926548',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000195,NULL,'16.2g',0.34,'E0',NULL,NULL,NULL,NULL,1,143.10825,9.44864,0.053,NULL,60703141901,948486592,14820103,16.2),(62402,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62402,37.09,0.46,262,21426,70,NULL,NULL,'2MASX J09322864+2622400',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000182,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,143.119333,26.37775,0.021,NULL,64194328295,1003036379,15672443,16.5),(62403,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62403,37.48,0.46,313,21427,70,NULL,NULL,'2MASX J09322973+0921228',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,143.123916667,9.35639,0.053,NULL,60703170616,948487040,14820110,17.6),(62404,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62404,37.79,0.46,361,21428,70,NULL,NULL,'2MASX J09322989+5846337',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00009,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,143.1244583,58.77611,0.065,NULL,61882912441,966920506,15108132,17.5),(62405,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62405,35.16,0.46,107,21429,70,NULL,NULL,'CGCG 181-053',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000166,NULL,'15.3g',0.41,'S0',NULL,NULL,NULL,NULL,1,143.1257083,32.52778,0,NULL,64178644571,1002791321,15668614,15.3),(62406,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62406,36.79,0.46,228,21430,70,NULL,NULL,'2MASX J09323198+0949568',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000191,NULL,'16.4g',0.29,'AGN',NULL,NULL,NULL,NULL,1,143.133208333,9.83258,0.085,NULL,60703310932,948489233,14820144,16.4),(62407,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62407,37.56,0.46,325,21431,70,NULL,NULL,'SDSS J093232.09+023201.6',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000088,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,143.1337083,2.53378,0.177,NULL,60695867063,948372922,14818326,17.4),(62408,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62408,38.06,0.46,409,21432,70,NULL,NULL,'2MASX J09323265+5540227',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000077,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,143.136,55.67311,0.025,NULL,61890374597,967037103,15109954,17.7),(62409,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62409,35.54,0.46,128,21433,70,NULL,NULL,'2MASX J09323275+3833412',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000165,NULL,'16.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,143.136375,38.56144,0,NULL,64395053805,1006172715,15721448,16.4),(62410,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62410,33.61,NULL,52.8,21434,NULL,NULL,'Dipole','FGCE 0751',NULL,'2010Ap&SS.325..163P',2010,1,1.68,NULL,'G',NULL,NULL,'16.8',0.1,'Sc',NULL,NULL,NULL,NULL,1,143.148875,-59.89286,NULL,NULL,40572524373,633945693,9905401,16.8),(62411,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62411,33.63,NULL,53.3,21434,NULL,NULL,'Dipole + Quadrupole + Octopole','FGCE 0751',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62412,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62412,33.64,NULL,53.6,21434,NULL,NULL,'Dipole + Quadrupole','FGCE 0751',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62413,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62413,38.43,0.46,486,21435,70,NULL,NULL,'2MASX J09323707+1244476',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,143.1544583,12.74647,0.041,NULL,63854177084,997721516,15589398,18.2),(62414,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62414,38.22,0.46,442,21436,70,NULL,NULL,'2MASX J09323949+3549358',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,143.164583,35.82672,0,NULL,64179186321,1002799786,15668746,17.2),(62415,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62415,36.61,0.46,210,21437,70,NULL,NULL,'2MASX J09323988+3413278',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000107,NULL,'16.1g',0.34,'E0',NULL,NULL,NULL,NULL,1,143.166083,34.22425,0.005,NULL,64180318671,1002817479,15669023,16.1),(62416,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62416,37.72,0.46,350,21438,70,NULL,NULL,'SDSS J093241.15+475548.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000155,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,143.1715,47.93014,0.017,NULL,64014297986,1000223406,15628490,18.3),(62417,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62417,36.66,0.89,214,21439,70,NULL,NULL,'2MASX J09324241-0544240',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.60',NULL,NULL,NULL,NULL,NULL,NULL,1,143.17675,-5.74022,0.085,NULL,41123549377,642555459,10039929,16.6),(62418,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62418,29.6,NULL,8.32,21440,NULL,NULL,NULL,'ESO 373- G 007',NULL,'2013AJ....145..101K',2013,1,1.3,NULL,'G',0.000007,NULL,'16.4',0.7,'IB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,143.189333333,-33.24547,0.669,NULL,42860998410,669703100,10464110,16.4),(62419,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62419,37.38,0.46,300,21441,70,NULL,NULL,'2MASX J09324553+0259572',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,143.1897083,2.99919,0.097,NULL,60695922202,948373784,14818340,17.9),(62420,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62420,37.36,0.23,296,21442,70,NULL,NULL,'2MASX J09324817+0504402',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,143.200625,5.07806,0.081,NULL,60720773242,948762081,14824407,18.1),(62421,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62421,37.13,0.46,266,21443,70,NULL,NULL,'2MASX J09324836+4034329',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000146,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,143.201667,40.57575,0.009,NULL,64260295345,1004067114,15688548,16.6),(62422,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62422,36.59,0.46,208,21444,70,NULL,NULL,'MCG +10-14-021',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000093,NULL,'16.0g',0.39,'E0',NULL,NULL,NULL,NULL,1,143.202583,58.74939,0.065,NULL,61882911663,966920494,15108132,16),(62423,'Brightest Stars','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62423,29.36,0.2,7.45,21445,NULL,NULL,NULL,'UGC 05086',NULL,'1998A&AS..133..181M',1998,1,0.61,NULL,'G',0.000033,NULL,'16.4g',0.55,'Im:','Field galaxy',NULL,NULL,NULL,1,143.203417,21.46564,0.053,NULL,63751161623,996111900,15564248,16.4),(62424,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62424,39.39,0.46,754,21446,70,NULL,NULL,'SDSS J093250.52-000914.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000176,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,143.2105417,-0.15408,0.069,NULL,41110491921,642351436,10036741,18.2),(62425,'GRB','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62425,46.25,1.65,4240,21447,100,NULL,NULL,'GRB 020124',3.198,'2009EPJC...63..139W',2009,1,NULL,NULL,'VisS',NULL,NULL,'18.5R',NULL,'HETE',NULL,NULL,NULL,NULL,1,143.211708333,-11.51961,0.133,NULL,42177987918,659031061,10297360,18.5),(62426,'GRB','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62426,46.4,1.59,4540,21447,100,NULL,NULL,'GRB 020124',3.198,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62427,'GRB','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62427,46.73,0.37,5280,21447,69.7,NULL,'Calibrated','GRB 020124',3.198,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62428,'GRB','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62428,46.88,0.44,5660,21447,72,NULL,NULL,'GRB 020124',3.198,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62429,'GRB','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62429,46.88,0.45,5660,21447,69.7,NULL,'Fiducial','GRB 020124',3.198,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62430,'GRB','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62430,46.98,0.44,5930,21447,70,NULL,NULL,'GRB 020124',3.198,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62431,'GRB','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62431,47.19,0.5,6530,21447,NULL,NULL,NULL,'GRB 020124',3.198,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62432,'GRB','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62432,42.75,NULL,3550,21448,70,NULL,'Pseudo z = 2.28','GRB 020124',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'VisS',NULL,NULL,'18.5R',NULL,'HETE',NULL,NULL,NULL,NULL,1,143.211708333,-11.51961,0.133,NULL,42177987918,659031061,10297360,18.5),(62433,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62433,34.81,0.63,91.6,21449,NULL,NULL,NULL,'CGCG 063-006',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.00013,NULL,'15.2',0.7,NULL,NULL,NULL,NULL,NULL,1,143.21625,12.28689,0.033,NULL,63854299636,997723431,15589428,15.2),(62434,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62434,34.85,0.2,93.3,21449,74.4,NULL,NULL,'CGCG 063-006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62435,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62435,34.95,0.59,97.6,21449,NULL,NULL,'Malmquist cor.','CGCG 063-006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62436,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62436,37.36,0.23,296,21450,70,NULL,NULL,'2MASX J09325560+0509202',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000185,NULL,'16.1g',0.42,'E0',NULL,NULL,NULL,NULL,1,143.231875,5.15547,0.081,NULL,60720764416,948761944,14824405,16.1),(62437,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62437,37.38,0.46,299,21451,70,NULL,NULL,'2MASX J09325586+2049331',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,143.2327083,20.82581,0.077,NULL,63750653315,996103958,15564124,17.7),(62438,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62438,37.76,0.46,357,21452,70,NULL,NULL,'SDSS J093256.74+395433.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,143.2364583,39.90917,0.005,NULL,64392540223,1006133440,15720835,18.3),(62439,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62439,37.55,0.46,324,21453,70,NULL,NULL,'2MASX J09325801+2029541',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,143.2417917,20.49842,0.101,NULL,63752408064,996131376,15564552,17.5),(62440,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62440,38.28,0.33,452,21454,70,NULL,NULL,'2MASX J09330012+5515442',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.0001,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,143.25025,55.26219,0.017,NULL,61881435307,966897426,15107772,18.3),(62441,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62441,36.45,0.46,195,21455,70,NULL,NULL,'2MASX J09330042+0102302',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00009,NULL,'16.0g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,143.251833,1.04175,0.113,NULL,60697451103,948397673,14818713,16),(62442,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62442,37.71,0.46,348,21456,70,NULL,NULL,'2MASX J09330256+6203554',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00007,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,143.261,62.06539,0.065,NULL,62041915211,969404925,15146951,18),(62443,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62443,38.1,0.46,416,21457,70,NULL,NULL,'2MASX J09330268+1216463',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,143.2610417,12.27947,0.033,NULL,63854300873,997723451,15589428,17.7),(62444,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62444,36.28,0.46,181,21458,70,NULL,NULL,'2MASX J09330306+3302497',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,143.2627917,33.04708,0,NULL,64178781458,1002793460,15668647,16.6),(62445,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62445,35.24,0.4,112,21459,NULL,NULL,'mean','IC 2490',NULL,'2007A&A...465...71T',2007,1,1.09,NULL,'G',0.000033,NULL,'14.3g',0.75,'Sbc',NULL,NULL,NULL,NULL,1,143.2652083,29.92836,0,NULL,64221731073,1003464548,15679133,14.3),(62446,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62446,35.38,0.06,119,21459,NULL,NULL,NULL,'IC 2490',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62447,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62447,35.51,0.47,127,21459,NULL,NULL,'H','IC 2490',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62448,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62448,35.61,0.46,133,21459,NULL,NULL,'J','IC 2490',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62449,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62449,35.84,0.46,147,21460,70,NULL,NULL,'2MASX J09330395+2342491',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000156,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,143.266583,23.71353,0.061,NULL,63712031768,995500496,15554695,16.4),(62450,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62450,38.92,0.46,609,21461,70,NULL,NULL,'SDSS J093304.00+404603.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000145,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,143.266667,40.76769,0.021,NULL,64260340905,1004067826,15688559,18.7),(62451,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62451,37.46,0.46,310,21462,70,NULL,NULL,'2MASX J09330486+5733533',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000074,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,143.2702083,57.56478,0.053,NULL,61886362822,966974419,15108975,17.4),(62452,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62452,34.78,0.43,90.2,21463,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0908',NULL,'2014MNRAS.444..527S',2014,1,1.12,NULL,'G',0.00015,NULL,'16.2',0.16,'Sc',NULL,NULL,NULL,NULL,1,143.270583333,-16.06189,0.249,NULL,42310834460,661106788,10329793,16.2),(62453,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62453,36.48,0.46,198,21464,70,NULL,NULL,'2MASX J09330505+1622063',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000184,NULL,'16.1g',0.33,NULL,NULL,NULL,NULL,NULL,1,143.2712083,16.36831,0.069,NULL,63734157924,995846217,15560097,16.1),(62454,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62454,37.24,0.46,280,21465,70,NULL,NULL,'2MASX J09330552+3606329',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000186,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,143.273,36.10906,0,NULL,64187536692,1002930260,15670785,16.6),(62455,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62455,36.39,0.46,190,21466,70,NULL,NULL,'2MASX J09330658+3308176',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000173,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,143.2775,33.13822,0,NULL,64178776348,1002793380,15668646,16.3),(62456,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62456,37.75,0.46,354,21467,70,NULL,NULL,'SDSS J093306.73+052416.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000138,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,143.278083333,5.40458,0.089,NULL,60720539165,948758424,14824350,18.6),(62457,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62457,37.42,0.46,304,21468,70,NULL,NULL,'2MASX J09330737+3216186',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,143.280625,32.27183,0,NULL,64209012975,1003265827,15676028,16.9),(62458,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62458,35.15,0.46,107,21469,70,NULL,NULL,'2MASX J09330745+4110259',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000158,NULL,'15.7g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,143.281167,41.17381,0.021,NULL,64260838490,1004075601,15688681,15.7),(62459,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62459,36.99,0.46,250,21470,70,NULL,NULL,'MCG +08-18-004',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000203,NULL,'15.6g',0.53,'E0',NULL,NULL,NULL,NULL,1,143.288041667,49.05033,0.013,NULL,64016912519,1000264258,15629129,15.6),(62460,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62460,37.8,0.46,363,21471,70,NULL,NULL,'2MASX J09330950+1413343',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,143.289666667,14.22619,0.093,NULL,63723426641,995678541,15557477,17),(62461,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62461,37.02,0.46,253,21472,70,NULL,NULL,'2MASX J09330977+1352113',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,143.290667,13.86972,0.073,NULL,63723507169,995679799,15557496,17.8),(62462,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62462,37.1,0.46,263,21473,70,NULL,NULL,'2MASX J09330991+1341493',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,143.2912917,13.69719,0.069,NULL,63720619132,995634673,15556791,17.7),(62463,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62463,38.29,0.46,456,21474,70,NULL,NULL,'2MASX J09331402+5639583',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000088,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,143.3085,56.66633,0.057,NULL,61887413278,966990832,15109231,17.8),(62464,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62464,35.44,0.51,123,21475,70,NULL,NULL,'2MASX J09331450-2114550',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.78',0.3,NULL,NULL,NULL,NULL,NULL,1,143.310417,-21.24858,0.129,NULL,42344421940,661631592,10337993,15.78),(62465,'Tully est','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62465,32.3,0.8,28.9,21476,75,NULL,NULL,'UGCA 167',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.00001,NULL,'14',1.4,'SB(r)b:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,143.3137083,-16.76794,0.241,NULL,42311601475,661118773,10329980,14),(62466,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62466,32.36,0.43,29.7,21476,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 167',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62467,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62467,32.42,0.43,30.5,21476,75,NULL,'3.6 micron, color corrected','UGCA 167',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62468,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62468,32.54,0.2,32.2,21476,74.4,NULL,NULL,'UGCA 167',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62469,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62469,32.55,0.59,32.3,21476,NULL,NULL,'Malmquist cor.','UGCA 167',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62470,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62470,32.76,0.4,35.6,21476,NULL,NULL,'mean','UGCA 167',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62471,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62471,32.79,0.53,36.1,21476,NULL,NULL,NULL,'UGCA 167',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62472,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62472,33.02,0.47,40.2,21476,NULL,NULL,'H','UGCA 167',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62473,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62473,33.03,0.45,40.5,21476,NULL,NULL,'K','UGCA 167',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62474,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62474,33.08,0.46,41.3,21476,NULL,NULL,'J','UGCA 167',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62475,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62475,38.16,0.27,428,21477,70,NULL,NULL,'2MASX J09331743+2727259',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,143.322625,27.45722,0.013,NULL,64213207931,1003331373,15677052,17.5),(62476,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62476,35.51,0.33,127,21478,70,NULL,NULL,'2MASX J09331834+6730225',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.38',0.38,NULL,NULL,NULL,NULL,NULL,1,143.326,67.50625,0.157,NULL,62247933041,972623953,15197249,16.38),(62477,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62477,36.97,0.46,248,21479,70,NULL,NULL,'2MASX J09331990+1034189',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000164,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,143.332875,10.57186,0.065,NULL,60703914958,948498671,14820291,16.8),(62478,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62478,38.28,0.33,452,21480,70,NULL,NULL,'2MASX J09332024+5515413',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000074,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,143.3344583,55.26139,0.017,NULL,61881437299,966897457,15107772,17.2),(62479,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62479,37.85,0.46,372,21481,70,NULL,NULL,'2MASX J09332129+0413436',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000141,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,143.338833,4.22881,0.069,NULL,60719304058,948739125,14824048,17.6),(62480,'Tully est','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62480,30.22,0.8,11.1,21482,75,NULL,NULL,'UGCA 168',NULL,'1988NBGC.C....0000T',1988,1,5.8,NULL,'G',0.000007,NULL,'12.8',0.9,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,143.339625,-33.0335,0.669,NULL,42859866427,669685412,10463834,12.8),(62481,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62481,29.93,0.2,9.68,21482,74.4,NULL,NULL,'UGCA 168',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62482,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62482,30.04,0.39,10.2,21482,73,NULL,'IR','UGCA 168',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62483,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62483,30.05,0.4,10.2,21482,75,NULL,NULL,'UGCA 168',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62484,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62484,31.25,0.49,17.8,21482,75,NULL,'IR','UGCA 168',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62485,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62485,37.46,0.46,311,21483,70,NULL,NULL,'2MASX J09332233-0053584',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000157,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,143.3430417,-0.89961,0.045,NULL,41119266363,642488536,10038883,17.1),(62486,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62486,37.77,0.46,358,21484,70,NULL,NULL,'2MASX J09332277+4720224',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,143.344916667,47.33958,0.037,NULL,64013890219,1000217034,15628391,17.8),(62487,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62487,37.5,0.46,317,21485,70,NULL,NULL,'2MASX J09332349+3646179',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,143.347833,36.77167,0,NULL,64393297829,1006145278,15721019,17.6),(62488,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62488,37.29,0.46,287,21486,70,NULL,NULL,'2MASX J09332401+3950579',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,143.35025,39.84961,0.005,NULL,64392537643,1006133400,15720834,17.3),(62489,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62489,37.83,0.46,367,21487,70,NULL,NULL,'SDSS J093324.09+655112.5',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,143.350375,65.8535,0.121,NULL,62256754771,972761793,15199403,NULL),(62490,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62490,35.5,0.27,126,21488,70,NULL,NULL,'UGC 05088',NULL,'2015arXiv151105856S',2015,1,1.15,NULL,'G',0.000087,NULL,'14.6g',0.72,'LINER','Group member',NULL,NULL,NULL,1,143.357125,34.04808,0.005,NULL,64180400055,1002818750,15669042,14.6),(62491,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62491,38.22,0.46,441,21489,70,NULL,NULL,'SDSS J093326.11+565518.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000075,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,143.358833,56.92183,0.053,NULL,61885470297,966960473,15108757,18.4),(62492,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62492,34.75,0.59,89.3,21490,70,NULL,NULL,'2MASX J09332826-0435314',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.02',NULL,NULL,NULL,NULL,NULL,NULL,1,143.3677917,-4.59211,0.085,NULL,41124700621,642573447,10040210,16.02),(62493,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62493,38.16,0.27,428,21491,70,NULL,NULL,'2MASX J09332855+2720039',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00018,NULL,'17.3g',0.21,'BrClG',NULL,NULL,NULL,NULL,1,143.368916667,27.33436,0,NULL,64212979964,1003327811,15676997,17.3),(62494,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62494,37.45,0.46,309,21492,70,NULL,NULL,'2MASX J09332876+1234135',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,143.36975,12.57036,0.053,NULL,63854328069,997723876,15589435,16.9),(62495,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62495,35.5,0.27,126,21493,70,NULL,NULL,'2MASX J09332969+3358275',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000117,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,143.373875,33.97431,0,NULL,64180400863,1002818763,15669043,16.2),(62496,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62496,36.6,0.98,209,21494,70,NULL,NULL,'ESO 498- G 013B',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.5,'(R\'_2)SB(rl)b',NULL,NULL,NULL,NULL,1,143.382833,-25.79469,0.189,NULL,42841516931,669398702,10459354,14.4),(62497,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62497,36.79,0.56,228,21495,70,NULL,NULL,'2MASX J09333240-1943130',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,143.385,-19.72028,0.057,NULL,42342970001,661608906,10337639,15.7),(62498,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62498,37.07,0.33,260,21496,70,NULL,NULL,'VII Zw 282',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.6',0.23,NULL,NULL,NULL,NULL,NULL,1,143.385083,66.19206,0.105,NULL,62256691874,972760810,15199387,18.6),(62499,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62499,35.33,0.7,116,21497,70,NULL,NULL,'ESO 373- G 009',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.2R',0.6,'(R\')SA(s)a',NULL,NULL,NULL,NULL,1,143.3877917,-33.01842,0.669,NULL,42859873085,669685516,10463836,15.2),(62500,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62500,36.66,0.46,215,21498,70,NULL,NULL,'2MASX J09333351+0952323',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000173,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,143.38975,9.87572,0.069,NULL,60703186537,948487289,14820113,16.8),(62501,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62501,37.07,0.33,260,21499,70,NULL,NULL,'2MASX J09333383+6608363',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,143.39075,66.14331,0.105,NULL,62256686557,972760727,15199386,18),(62502,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62502,35.92,0.53,153,21500,70,NULL,NULL,'2MASX J09333381-2109000',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,143.390875,-21.14994,0.129,NULL,42344391367,661631115,10337986,14.3),(62503,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62503,37.11,0.46,265,21501,70,NULL,NULL,'2MASX J09333411+5755542',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000102,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,143.392083,57.93183,0.061,NULL,61883318744,966926855,15108232,16.2),(62504,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62504,37.74,0.33,353,21502,70,NULL,NULL,'2MASX J09333436+5510262',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000183,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,143.393,55.17389,0.017,NULL,61881444667,966897572,15107774,16.4),(62505,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62505,34.16,0.46,68.1,21503,70,NULL,NULL,'CGCG 181-056',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000093,NULL,'15.0g',0.6,'S0',NULL,NULL,NULL,NULL,1,143.393041667,33.64864,0,NULL,64180332910,1002817701,15669026,15),(62506,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62506,37.71,0.46,349,21504,70,NULL,NULL,'2MASX J09333495+5304310',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000204,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,143.3957083,53.07533,0.013,NULL,63964463293,999444738,15616324,16.3),(62507,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62507,33.56,0.51,51.6,21505,70,NULL,NULL,'MCG -04-23-006',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.000093,NULL,'15',0.3,NULL,NULL,NULL,NULL,NULL,1,143.396375,-25.13606,0.165,NULL,42840748690,669386698,10459167,15),(62508,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62508,38.61,0.46,527,21506,70,NULL,NULL,'2MASX J09333714+6036234',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000083,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,143.404958333,60.6065,0.085,NULL,62037933517,969342711,15145979,17.7),(62509,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62509,38.13,0.46,422,21507,70,NULL,NULL,'2MASX J09334022+4812460',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000147,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,143.417625,48.21286,0.041,NULL,64014138458,1000220913,15628451,17.9),(62510,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62510,36.72,0.46,221,21508,70,NULL,NULL,'2MASX J09334063+2220259',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000174,NULL,'17.38',0.26,NULL,NULL,NULL,NULL,NULL,1,143.419417,22.34056,0.037,NULL,63746436657,996038072,15563094,17.38),(62511,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62511,38.43,0.46,485,21509,70,NULL,NULL,'2MASX J09334093+4929010',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,143.4204583,49.48356,0,NULL,64016042228,1000250659,15628916,18.2),(62512,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62512,37.63,0.46,336,21510,70,NULL,NULL,'2MASX J09334261+4351205',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,143.4277083,43.85581,0.061,NULL,64263249616,1004113275,15689269,17.1),(62513,'IRAS','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62513,32.96,0.8,39.1,21511,75,NULL,'MAT, I','MCG -02-25-002',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.00001,NULL,'14',0.5,'SAbc?',NULL,NULL,NULL,NULL,1,143.4305,-11.32181,0.125,NULL,41088306057,642004782,10031324,14),(62514,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62514,32.76,0.4,35.6,21511,NULL,NULL,NULL,'MCG -02-25-002',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62515,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62515,32.89,0.43,37.8,21511,75,NULL,'3.6 micron, color corrected','MCG -02-25-002',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62516,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62516,32.89,0.43,37.8,21511,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-25-002',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62517,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62517,32.93,0.32,38.6,21511,85,NULL,'I, raw','MCG -02-25-002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62518,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62518,32.96,0.2,39.1,21511,74.4,NULL,NULL,'MCG -02-25-002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62519,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62519,32.97,0.32,39.2,21511,85,NULL,'I, inv','MCG -02-25-002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62520,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62520,32.99,0.43,39.7,21511,75,NULL,'MAT, I, raw','MCG -02-25-002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62521,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62521,33.13,0.46,42.3,21511,NULL,NULL,'J','MCG -02-25-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62522,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62522,33.16,0.47,42.8,21511,NULL,NULL,'H','MCG -02-25-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62523,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62523,33.17,0.43,43,21511,75,NULL,'MAT, I, inv','MCG -02-25-002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62524,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62524,33.18,0.59,43.2,21511,NULL,NULL,NULL,'MCG -02-25-002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62525,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62525,33.26,0.45,44.9,21511,NULL,NULL,'K','MCG -02-25-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62526,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62526,33.28,0.43,45.2,21511,75,NULL,'MAT, I, cor','MCG -02-25-002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62527,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62527,33.3,0.56,45.7,21511,NULL,NULL,'Malmquist cor.','MCG -02-25-002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62528,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62528,33.3,0.4,45.7,21511,NULL,NULL,'mean','MCG -02-25-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62529,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62529,38.16,0.27,428,21512,70,NULL,NULL,'2MASX J09334530+2717117',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,143.438583,27.28667,0,NULL,64212983006,1003327859,15676997,18.2),(62530,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62530,38.19,0.46,435,21513,70,NULL,NULL,'2MASX J09334608+1047183',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000181,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,143.442,10.78842,0.085,NULL,60700769229,948449519,14819523,17.8),(62531,'Faber-Jackson','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62531,35.66,1.31,136,21514,95,NULL,'Weighted Mean','NGC 2911',NULL,'1984ApJS...56...91D',1984,1,4.1,NULL,'G',0.000017,NULL,'12.50',3.2,'SA(s)0:pec;Sy  LINER','Pair member (points to parent)',NULL,NULL,'Flat-Spectrum Radio Source',1,143.442125,10.15244,0.077,NULL,60704059668,948500932,14820327,12.5),(62532,'Faber-Jackson','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62532,37.97,1.61,393,21514,55,NULL,'Visvanathan & Sandage 1979','NGC 2911',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62533,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62533,33.53,0.46,50.9,21514,70,NULL,NULL,'NGC 2911',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62534,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62534,33.38,0.4,47.4,21514,NULL,NULL,'mean','NGC 2911',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62535,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62535,33.77,0.45,56.6,21514,NULL,NULL,'K','NGC 2911',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62536,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62536,38.21,0.46,439,21515,70,NULL,NULL,'2MASX J09334649+3713170',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000187,NULL,'17.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,143.443666667,37.22139,0,NULL,64394008045,1006156375,15721193,17.7),(62537,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62537,35.99,0.52,157,21516,70,NULL,NULL,'2MASX J09334656-1613591',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'14.7R',0.3,NULL,NULL,NULL,NULL,NULL,1,143.444,-16.233,0.237,NULL,42312011354,661125177,10330080,14.7),(62538,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62538,37.45,0.46,308,21517,70,NULL,NULL,'2MASX J09334830+0620483',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,143.451291667,6.34672,0.117,NULL,60710739337,948605302,14821957,17.2),(62539,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62539,37.7,0.46,346,21518,70,NULL,NULL,'2MASX J09334970+0749553',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000177,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,143.457,7.83194,0.085,NULL,60709703880,948589123,14821705,16.7),(62540,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62540,37.74,0.33,353,21519,70,NULL,NULL,'2MASX J09334980+5510584',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000077,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,143.457333,55.18278,0.017,NULL,61881443283,966897551,15107774,17.9),(62541,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62541,38.37,0.46,472,21520,70,NULL,NULL,'2MASX J09335077+3112556',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00019,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,143.461583,31.21561,0,NULL,64209188274,1003268566,15676071,17.5),(62542,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62542,36.13,0.46,168,21521,70,NULL,NULL,'2MASX J09335100+1525475',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'17.03',0.47,NULL,NULL,NULL,NULL,NULL,1,143.462667,15.42992,0.093,NULL,63733794263,995840535,15560008,17.03),(62543,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62543,37.66,0.46,341,21522,70,NULL,NULL,'2MASX J09335131+3700120',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,143.4637083,37.00333,0,NULL,64393169486,1006143273,15720988,16.8),(62544,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62544,37.84,0.46,370,21523,70,NULL,NULL,'SDSS J093352.39+084610.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00017,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,143.4682917,8.76953,0.045,NULL,60714601765,948665652,14822900,17.6),(62545,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62545,35.68,0.46,137,21524,70,NULL,NULL,'CGCG 152-028',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000067,NULL,'15.0g',0.63,NULL,NULL,NULL,NULL,NULL,1,143.47125,30.40403,0,NULL,64207773160,1003246455,15675725,15),(62546,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62546,38.04,0.46,405,21525,70,NULL,NULL,'2MASX J09335604+1512165',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,143.4834583,15.20442,0.089,NULL,63722508332,995664192,15557253,17.1),(62547,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62547,37.8,0.46,363,21526,70,NULL,NULL,'2MASX J09335607+2913447',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000189,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,143.4835417,29.22897,0.021,NULL,64222076194,1003469940,15679217,17.9),(62548,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62548,37.63,0.46,336,21527,70,NULL,NULL,'2MASX J09335729+4052060',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000156,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,143.4887083,40.86844,0.021,NULL,64260310314,1004067348,15688552,17),(62549,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62549,38.6,0.46,525,21528,70,NULL,NULL,'SDSS J093357.94+002114.8',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000154,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,143.491416667,0.35414,0.077,NULL,60696866623,948388540,14818570,18.8),(62550,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62550,35.96,0.46,156,21529,70,NULL,NULL,'2MASX J09335825+0823113',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000168,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,143.4927083,8.38636,0.081,NULL,60714287313,948660739,14822824,16.5),(62551,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62551,37.6,0.33,330,21530,70,NULL,NULL,'2MASX J09335980+1715106',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,143.499125,17.25311,0.077,NULL,63732963145,995827549,15559805,17.3),(62552,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62552,33.62,0.63,53,21531,NULL,NULL,NULL,'UGC 05093',NULL,'2009ApJS..182..474S',2009,1,1.12,NULL,'G',0.000057,NULL,'14.7g',0.44,'S','Group member',NULL,NULL,NULL,1,143.500541667,10.02953,0.069,NULL,60704037542,948500586,14820321,14.7),(62553,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62553,33.66,0.2,54,21531,74.4,NULL,NULL,'UGC 05093',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62554,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62554,33.71,0.61,55.3,21531,NULL,NULL,'Malmquist cor.','UGC 05093',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62555,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62555,35.5,0.27,126,21532,70,NULL,NULL,'CGCG 181-059',NULL,'2015arXiv151105856S',2015,1,0.98,NULL,'G',0.000067,NULL,'14.5g',0.6,'E0','Group member',NULL,NULL,NULL,1,143.504,33.99072,0,NULL,64180448474,1002819507,15669054,14.5),(62556,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62556,36.89,0.46,239,21533,70,NULL,NULL,'2MASX J09340121+2513057',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,143.505167,25.21819,0.013,NULL,64194003429,1003031303,15672364,16.7),(62557,'AGB','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62557,30.75,NULL,14.1,21534,NULL,NULL,NULL,'UGCA 166',NULL,'2004ApJ...616..768I',2004,1,NULL,NULL,'GPair',0.000007,NULL,NULL,NULL,'cI;Blue Compact Gal',NULL,NULL,NULL,NULL,1,143.508458333,55.24114,0.017,NULL,61881414121,966897095,15107767,NULL),(62558,'AGB','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62558,30.87,0.23,14.9,21534,NULL,NULL,NULL,'UGCA 166',NULL,'2006KFNT...22..432Y',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62559,'Brightest Stars','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62559,30.36,0.14,11.8,21534,NULL,NULL,'blue stars','UGCA 166',NULL,'2006KFNT...22..432Y',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62560,'Brightest Stars','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62560,30.67,0.13,13.6,21534,NULL,NULL,'red super giants','UGCA 166',NULL,'2006KFNT...22..432Y',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62561,'Cepheids','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62561,30.4,0.29,12,21534,NULL,NULL,'2, Udalaski PL + Z','UGCA 166',NULL,'2007IAUS..241..341F',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62562,'Cepheids','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62562,30.71,0.29,13.9,21534,NULL,NULL,'2, Udalski PL','UGCA 166',NULL,'2007IAUS..241..341F',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62563,'Cepheids','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62563,31.01,0.29,15.9,21534,NULL,NULL,'2, PL + Z','UGCA 166',NULL,'2007IAUS..241..341F',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62564,'Cepheids','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62564,31.09,0.26,16.5,21534,NULL,NULL,'3, VI(W), overluminous model','UGCA 166',NULL,'2008MmSAI..79..461F',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62565,'Cepheids','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62565,31.2,0.2,17.4,21534,NULL,NULL,'over luminous','UGCA 166',NULL,'2010ApJ...711..808F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62566,'Cepheids','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62566,31.28,0.26,18,21534,NULL,NULL,'2, PL','UGCA 166',NULL,'2007IAUS..241..341F',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62567,'Cepheids','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62567,31.35,0.26,18.6,21534,NULL,NULL,'3, VI(W)','UGCA 166',NULL,'2008MmSAI..79..461F',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62568,'Cepheids','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62568,31.38,0.17,18.9,21534,NULL,NULL,'3, avg','UGCA 166',NULL,'2007ApJ...667L.151A',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62569,'Cepheids','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62569,31.4,0.2,19,21534,NULL,NULL,'canonical','UGCA 166',NULL,'2010ApJ...711..808F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62570,'Cepheids','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62570,31.4,0.2,19,21534,NULL,NULL,'VI, 1','UGCA 166',NULL,'2010ApJ...713..615M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62571,'Cepheids','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62571,31.4,0.4,19.1,21534,NULL,NULL,'1, VI','UGCA 166',NULL,'2012MSAIS..19..146M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62572,'Cepheids','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62572,31.4,0.1,19.1,21534,NULL,NULL,'1, VI, light curve model fitting','UGCA 166',NULL,'2012MSAIS..19..146M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62573,'CMD','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62573,30.88,NULL,15,21534,NULL,NULL,NULL,'UGCA 166',NULL,'2001ApJ...560..222I',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62574,'CMD','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62574,32.12,0.31,26.5,21534,NULL,NULL,NULL,'UGCA 166',NULL,'2010A&A...509A..10J',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62575,'CMD','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62575,32.16,0.38,27,21534,NULL,NULL,'with intrinsic extinction','UGCA 166',NULL,'2010A&A...509A..10J',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62576,'TRGB','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62576,30.72,0.17,13.9,21534,NULL,NULL,NULL,'UGCA 166',NULL,'2007AstL...33..137T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62577,'TRGB','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62577,31.2,NULL,17.4,21534,NULL,NULL,'M(I) = -4.0','UGCA 166',NULL,'2007IAUS..235...65T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62578,'TRGB','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62578,31.3,0.17,18.2,21534,NULL,NULL,NULL,'UGCA 166',NULL,'2007ApJ...667L.151A',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62579,'TRGB','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62579,31.3,0.17,18.2,21534,NULL,NULL,NULL,'UGCA 166',NULL,'2012MSAIS..19..146M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62580,'TRGB','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62580,31.3,0.16,18.2,21534,NULL,NULL,NULL,'UGCA 166',NULL,'2014A&A...566A..71L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62581,'Tully est','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62581,30.78,0.8,14.3,21534,75,NULL,NULL,'UGCA 166',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62582,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62582,36.3,0.46,182,21535,70,NULL,NULL,'CGCG 152-029',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000194,NULL,'15.1g',0.49,NULL,NULL,NULL,NULL,NULL,1,143.510375,27.37611,0,NULL,64213202838,1003331294,15677051,15.1),(62583,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62583,33.32,0.4,46.1,21536,NULL,NULL,'mean','NGC 2913',NULL,'2007A&A...465...71T',2007,1,1.16,NULL,'G',0.000017,NULL,'14.3g',0.64,'S?','in a radial-velocity based grouping',NULL,NULL,NULL,1,143.511333333,9.47919,0.077,NULL,60702801233,948481269,14820019,14.3),(62584,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62584,33.76,0.47,56.5,21536,NULL,NULL,'H','NGC 2913',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62585,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62585,37.46,0.46,310,21537,70,NULL,NULL,'2MASX J09340277+5301408',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,143.511417,53.02817,0.013,NULL,63966496387,999476506,15616820,18),(62586,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62586,32.67,0.47,34.3,21538,NULL,NULL,'H','NGC 2914',NULL,'2007A&A...465...71T',2007,1,0.89,NULL,'G',0.000003,NULL,'13.8g',0.62,'SB(s)ab','in a radial-velocity based grouping',NULL,NULL,NULL,1,143.511583333,10.10858,0.069,NULL,60703514676,948492416,14820194,13.8),(62587,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62587,32.75,0.45,35.5,21538,NULL,NULL,'K','NGC 2914',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62588,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62588,32.79,0.46,36.2,21538,NULL,NULL,'J','NGC 2914',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62589,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62589,33.34,0.4,46.6,21538,NULL,NULL,'mean','NGC 2914',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62590,'Tully est','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62590,32.77,0.8,35.8,21539,75,NULL,'B','MRK 0706',NULL,'1988NBGC.C....0000T',1988,1,0.08,NULL,'G',0.000013,NULL,'15.3B',0.07,'Compact;WR?    HII',NULL,NULL,NULL,NULL,1,143.512667,11.00603,0.033,NULL,60700776107,948449626,14819525,15.3),(62591,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62591,35.29,0.48,114,21540,70,NULL,NULL,'2MASX J09340331-0512232',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00009,NULL,'15.70',0.8,NULL,NULL,NULL,NULL,NULL,1,143.513833,-5.2065,0.085,NULL,41124939529,642577180,10040268,15.7),(62592,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62592,36.95,0.46,246,21541,70,NULL,NULL,'2MASX J09340335+5416425',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000122,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,143.513875,54.27847,0.013,NULL,63964838931,999450608,15616415,16.3),(62593,'TRGB','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62593,27.4,0.7,3.01,21542,NULL,NULL,NULL,'MESSIER 081:[CKT2009] d0934+70',NULL,'2013AJ....146..126C',2013,1,NULL,NULL,'G',NULL,NULL,'19.3B',NULL,'dSph',NULL,NULL,NULL,NULL,1,143.515417,70.21583,0.177,0,62099258760,970300918,15160951,19.3),(62594,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62594,39,0.46,631,21543,70,NULL,NULL,'SDSS J093404.07+563216.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000098,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,143.517,56.53786,0.049,NULL,61887905290,966998520,15109351,18.5),(62595,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62595,37.42,0.46,305,21544,70,NULL,NULL,'2MASX J09340474+0251528',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000139,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,143.519667,2.86478,0.117,NULL,60696635701,948384932,14818514,17.8),(62596,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62596,37.6,0.33,330,21545,70,NULL,NULL,'2MASX J09340603+1704347',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000172,NULL,'18.54',0.31,NULL,NULL,NULL,NULL,NULL,1,143.524958333,17.07625,0.081,NULL,63732823665,995825369,15559771,18.54),(62597,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62597,37.75,0.33,355,21546,70,NULL,NULL,'2MASX J09340627+1645157',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000154,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,143.52625,16.75444,0.109,NULL,63736320901,995880014,15560625,17.3),(62598,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62598,37.55,0.33,324,21547,70,NULL,NULL,'2MASX J09340655+2137371',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000184,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,143.527375,21.62703,0.065,NULL,63751034161,996109908,15564217,17.3),(62599,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62599,35.51,0.33,127,21548,70,NULL,NULL,'2MASX J09340695+6725515',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.00008,NULL,'15.80',0.53,NULL,NULL,NULL,NULL,NULL,1,143.529208333,67.43106,0.157,NULL,62251372694,972677698,15198089,15.8),(62600,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62600,38.06,0.46,409,21549,70,NULL,NULL,'2MASX J09340765+0318242',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,143.532,3.30683,0.097,NULL,60689389287,948271707,14816745,17.4),(62601,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62601,36.94,0.46,244,21550,70,NULL,NULL,'2MASX J09340771+3146256',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,143.532041667,31.77378,0,NULL,64209344695,1003271010,15676109,17),(62602,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62602,37.55,0.33,324,21551,70,NULL,NULL,'2MASX J09340897+2137259',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,143.537333,21.62381,0.065,NULL,63751041760,996110027,15564219,17.5),(62603,'IRAS','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62603,34.16,0.8,67.9,21552,75,NULL,'HMCL, I','UGC 05097',NULL,'1997ApJS..109..333W',1997,1,0.7,NULL,'G',0.000003,NULL,'14.0',0.4,'Sb','Pair member (points to parent)',NULL,NULL,NULL,1,143.544291667,0.24219,0.073,NULL,60696880909,948388764,14818574,14),(62604,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62604,34.17,0.4,68.1,21552,75,NULL,'HMCL, I, raw','UGC 05097',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62605,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62605,34.3,0.4,72.5,21552,75,NULL,'HMCL, I, inv','UGC 05097',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62606,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62606,34.51,0.4,79.8,21552,75,NULL,'HMCL, I, cor','UGC 05097',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62607,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62607,35.09,0.46,104,21553,70,NULL,NULL,'CGCG 239-010',NULL,'2015arXiv151105856S',2015,1,1.01,NULL,'G',0.0001,NULL,'14.2g',0.83,'E0',NULL,NULL,NULL,NULL,1,143.552333,46.70794,0.033,NULL,63980620049,999697188,15620268,14.2),(62608,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62608,36.21,0.46,175,21554,70,NULL,NULL,'UGC 05094',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.00016,NULL,'15.2g',0.51,'S0',NULL,NULL,NULL,NULL,1,143.559583,24.22644,0.041,NULL,63712332906,995505201,15554768,15.2),(62609,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62609,36.66,0.46,214,21555,70,NULL,NULL,'2MASX J09341580+4809074',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000172,NULL,'16.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,143.566,48.15211,0.041,NULL,64016941221,1000264706,15629136,16.7),(62610,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62610,38.14,0.46,424,21556,70,NULL,NULL,'2MASX J09341673+0740505',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000194,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,143.569625,7.68064,0.093,NULL,60709697059,948589016,14821703,16.8),(62611,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62611,37.06,0.46,259,21557,70,NULL,NULL,'MCG +10-14-023',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000105,NULL,'16.1g',0.38,'E0',NULL,NULL,NULL,NULL,1,143.578166667,59.18525,0.053,NULL,61912360461,967380632,15115322,16.1),(62612,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62612,37.83,0.46,368,21558,70,NULL,NULL,'2MASX J09341988-0039138',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000147,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,143.58275,-0.65386,0.061,NULL,41119070157,642485471,10038835,17.5),(62613,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62613,36.6,0.27,209,21559,70,NULL,NULL,'CGCG 181-060',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000133,NULL,'15.7g',0.4,'E0',NULL,NULL,NULL,NULL,1,143.589167,34.69456,0,NULL,64179927352,1002811364,15668927,15.7),(62614,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62614,33.82,0.47,58,21560,70,NULL,NULL,'2MASX J09342200-1358523',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'14.56',NULL,NULL,NULL,NULL,NULL,NULL,1,143.591667,-13.98144,0.269,NULL,42299226222,660925409,10326959,14.56),(62615,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62615,33.09,0.5,41.5,21561,70,NULL,NULL,'NGC 2917',NULL,'2014MNRAS.445.2677S',2014,1,1.3,'6dF DR2 has z = 0.017981.','G',0.00003,NULL,'14.55',0.4,'S0+',NULL,NULL,NULL,NULL,1,143.612083,-2.50417,0.089,NULL,41117589128,642462330,10038473,14.55),(62616,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62616,33.14,0.49,42.4,21561,75,NULL,'IR','NGC 2917',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62617,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62617,35.66,0.77,136,21562,70,NULL,NULL,'2MASX J09342699-2252564',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,143.612417,-22.88233,0.017,NULL,42336713274,661511144,10336111,14.8),(62618,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62618,38.24,0.46,445,21563,70,NULL,NULL,'2MASX J09342766+4818145',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,143.6152917,48.304,0.041,NULL,64016946467,1000264788,15629137,18.2),(62619,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62619,34.55,0.5,81.4,21564,70,NULL,NULL,'FAIRALL 1352',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000133,NULL,'15.7B',0.28,NULL,NULL,NULL,NULL,NULL,1,143.61625,-77.19419,0.533,NULL,39941736991,624089640,9751400,15.7),(62620,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62620,37.75,0.33,355,21565,70,NULL,NULL,'2MASX J09342792+1643527',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000203,NULL,'17.0g',0.25,'AGN',NULL,NULL,NULL,NULL,1,143.616375,16.73133,0.109,NULL,63736294578,995879602,15560618,17),(62621,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62621,37.49,0.46,315,21566,70,NULL,NULL,'2MASX J09343023+3207328',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000184,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,143.626,32.12572,0,NULL,64208930592,1003264540,15676008,17.1),(62622,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62622,33.23,0.45,44.2,21567,NULL,NULL,'K','NGC 2921',NULL,'2007A&A...465...71T',2007,1,2.8,NULL,'G',0.000017,NULL,'12.94',1,'SAB(r)b',NULL,NULL,NULL,NULL,1,143.631667,-20.92036,0.097,NULL,42345564692,661649448,10338272,12.94),(62623,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62623,33.24,0.47,44.5,21567,NULL,NULL,'H','NGC 2921',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62624,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62624,33.24,0.46,44.5,21567,NULL,NULL,'J','NGC 2921',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62625,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62625,33.36,0.4,47,21567,NULL,NULL,'mean','NGC 2921',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62626,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62626,33.48,0.43,49.7,21567,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2921',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62627,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62627,35.28,0.48,114,21568,70,NULL,NULL,'2MASX J09343206-2134144',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00008,NULL,'15.69',NULL,NULL,NULL,NULL,NULL,NULL,1,143.6337083,-21.57075,0.117,NULL,42344107321,661626676,10337916,15.69),(62628,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62628,37.38,0.46,299,21569,70,NULL,NULL,'2MASX J09343233+0123053',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000076,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,143.634583333,1.38478,0.161,NULL,60697541922,948399092,14818735,17.5),(62629,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62629,37.43,0.46,306,21570,70,NULL,NULL,'2MASX J09343254+2253459',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000191,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,143.63575,22.89592,0.077,NULL,63748819810,996075309,15563676,16.3),(62630,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62630,37.06,0.46,258,21571,70,NULL,NULL,'2MASX J09343390+4609180',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000161,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,143.6415,46.15517,0.013,NULL,63983853024,999747703,15621057,16.8),(62631,'IRAS','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62631,34.17,0.8,68.2,21572,75,NULL,'HMCL, I','UGC 05099',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000024,NULL,'14.37',0.7,'SB(s)ab pec:',NULL,NULL,NULL,NULL,1,143.642625,0.08981,0.077,NULL,60685346098,948208532,14815758,14.37),(62632,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62632,34.17,0.4,68.1,21572,75,NULL,'HMCL, I, raw','UGC 05099',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62633,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62633,34.27,0.4,71.5,21572,75,NULL,'HMCL, I, inv','UGC 05099',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62634,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62634,34.51,0.4,79.7,21572,75,NULL,'HMCL, I, cor','UGC 05099',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62635,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62635,37.84,0.46,369,21573,70,NULL,NULL,'SDSS J093436.03+033939.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000139,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,143.650167,3.66103,0.065,NULL,60689456320,948272755,14816761,18.3),(62636,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62636,37.68,0.46,343,21574,70,NULL,NULL,'2MASX J09343667+2641107',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,143.653041667,26.68639,0,NULL,64211175054,1003299610,15676556,18.2),(62637,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62637,36.78,0.46,227,21575,70,NULL,NULL,'2MASX J09343713+1706311',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'16.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,143.654583,17.10867,0.081,NULL,63732841175,995825643,15559775,16.7),(62638,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62638,36.91,0.46,241,21576,70,NULL,NULL,'2MASX J09343725+2632227',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,143.655333,26.53972,0,NULL,64211363406,1003302553,15676602,17),(62639,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62639,37.72,0.46,349,21577,70,NULL,NULL,'2MASX J09343795+3628127',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000175,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,143.657917,36.47025,0,NULL,64174117251,1002720582,15667509,18.2),(62640,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62640,34.49,0.49,79,21578,75,NULL,'IR','UGC 05100',NULL,'2011yCatp016004901K',2011,1,1.15,NULL,'G',0.000033,NULL,'14.6g',0.55,'SB(s)b',NULL,NULL,NULL,NULL,1,143.661,5.84144,0.109,NULL,60720454565,948757102,14824329,14.6),(62641,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62641,34.61,0.4,83.6,21578,NULL,NULL,'mean','UGC 05100',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62642,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62642,34.94,0.47,97.3,21578,NULL,NULL,'H','UGC 05100',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62643,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62643,38.37,0.46,472,21579,70,NULL,NULL,'2MASX J09343967+0632464',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000142,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,143.6652083,6.54617,0.117,NULL,60711982372,948624724,14822261,17.9),(62644,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62644,37.44,0.46,308,21580,70,NULL,NULL,'2MASX J09344026+3227589',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,143.667958333,32.46636,0,NULL,64208901055,1003264078,15676001,17.6),(62645,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62645,38,0.46,398,21581,70,NULL,NULL,'SDSS J093441.53+033719.2',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000177,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,143.6730417,3.62203,0.065,NULL,60689471546,948272992,14816765,17.8),(62646,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62646,38.53,0.46,508,21582,70,NULL,NULL,'2MASX J09344252+2741165',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,143.6772917,27.68794,0,NULL,64213083415,1003329428,15677022,18.2),(62647,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62647,37.52,0.46,319,21583,70,NULL,NULL,'2MASX J09344262+3944237',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,143.6777083,39.73986,0.017,NULL,64391241935,1006113155,15720518,17.6),(62648,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62648,37.74,0.33,352,21584,70,NULL,NULL,'2MASX J09344384+0315101',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000194,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,143.682583,3.25286,0.041,NULL,60688863436,948263491,14816617,17.2),(62649,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62649,37.88,0.46,376,21585,70,NULL,NULL,'2MASX J09344425+0004271',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000154,NULL,'17.0g',0.35,NULL,NULL,NULL,NULL,NULL,1,143.68425,0.07422,0.077,NULL,60685314188,948208034,14815750,17),(62650,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62650,30.57,NULL,13,21586,NULL,NULL,NULL,'CGCG 035-007',NULL,'2013AJ....145..101K',2013,1,0.8,NULL,'G',0.000127,NULL,'15.1g',0.55,'Sc',NULL,NULL,NULL,NULL,1,143.686333,6.4255,0.117,NULL,60711816773,948622137,14822220,15.1),(62651,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62651,37.92,0.46,383,21587,70,NULL,NULL,'2MASX J09344502+3218249',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,143.687583333,32.30694,0,NULL,64208952497,1003264882,15676013,17.4),(62652,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62652,36.6,0.27,209,21588,70,NULL,NULL,'2MASX J09344625+3442219',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000127,NULL,'16.1g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,143.692791667,34.70606,0,NULL,64179908694,1002811073,15668923,16.1),(62653,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62653,38.53,0.46,509,21589,70,NULL,NULL,'SDSS J093446.81+470517.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,143.695083,47.08828,0.009,NULL,63980460579,999694696,15620229,18.3),(62654,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62654,35.79,0.46,144,21590,70,NULL,NULL,'SDSS J093447.28+484451.3',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,143.697,48.74761,0.037,NULL,64017132960,1000267702,15629182,16.8),(62655,'IRAS','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62655,32.92,0.8,38.3,21591,75,NULL,'CF, r','NGC 2919',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000027,NULL,'13.65',0.6,'SAB(r)b:','Group member',NULL,NULL,NULL,1,143.698,10.28372,0.077,NULL,60703529329,948492645,14820197,13.65),(62656,'Sosies','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62656,33.49,0.5,49.9,21591,NULL,NULL,NULL,'NGC 2919',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62657,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62657,32.7,0.4,34.7,21591,NULL,NULL,NULL,'NGC 2919',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62658,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62658,32.89,0.38,37.8,21591,75,NULL,'CF, r, raw','NGC 2919',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62659,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62659,32.97,0.38,39.2,21591,75,NULL,'CF, r, inv','NGC 2919',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62660,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62660,33.03,0.4,40.3,21591,NULL,NULL,'mean','NGC 2919',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62661,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62661,33.05,0.43,40.7,21591,75,NULL,'3.6 micron, color corrected','NGC 2919',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62662,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62662,33.05,0.43,40.7,21591,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2919',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62663,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62663,33.09,0.38,41.5,21591,75,NULL,'CF, r, cor','NGC 2919',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62664,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62664,33.1,0.2,41.7,21591,74.4,NULL,NULL,'NGC 2919',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62665,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62665,33.14,0.46,42.4,21591,NULL,NULL,'J','NGC 2919',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62666,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62666,33.16,0.47,42.8,21591,NULL,NULL,'H','NGC 2919',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62667,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62667,33.19,0.45,43.4,21591,NULL,NULL,'K','NGC 2919',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62668,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62668,33.24,0.34,44.5,21591,NULL,NULL,NULL,'NGC 2919',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62669,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62669,33.32,0.33,46.2,21591,NULL,NULL,'Malmquist cor.','NGC 2919',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62670,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62670,36.95,0.46,245,21592,70,NULL,NULL,'2MASX J09344917+2209479',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00016,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,143.7050417,22.16322,0.013,NULL,63746578611,996040290,15563129,16.9),(62671,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62671,36.81,0.46,230,21593,70,NULL,NULL,'SDSS J093450.03+414240.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000177,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,143.7085,41.71128,0.025,NULL,64260736981,1004074015,15688656,17.7),(62672,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62672,34.14,0.51,67.2,21594,70,NULL,NULL,'IC 0546',NULL,'2014MNRAS.445.2677S',2014,1,1.1,'Star (mag. 15) superposed 13 arcsec north of nucleus.','G',0.000077,NULL,'14.41',0.7,'SB(rs)0+',NULL,NULL,NULL,NULL,1,143.709333,-16.38442,0.237,NULL,42312029889,661125467,10330085,14.41),(62673,'Cepheids','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62673,23.05,0.1,0.407,21595,NULL,NULL,'Anomalous Cepheids','Leo T Dwarf',NULL,'2012ApJ...756..108C',2012,1,NULL,NULL,'G',NULL,NULL,'16  V',NULL,'Dwarf',NULL,NULL,NULL,NULL,1,143.7225,17.05139,0.113,1,63732832247,995825503,15559773,16),(62674,'CMD','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62674,23,0.2,0.398,21595,NULL,NULL,NULL,'Leo T Dwarf',NULL,'2008ApJ...680.1112D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62675,'CMD','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62675,23.05,NULL,0.407,21595,NULL,NULL,NULL,'Leo T Dwarf',NULL,'2012ApJ...748...88W',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62676,'CMD','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62676,23.09,NULL,0.415,21595,NULL,NULL,NULL,'Leo T Dwarf',NULL,'2015ApJ...811...35J',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62677,'CMD','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62677,23.1,0.6,0.417,21595,NULL,NULL,NULL,'Leo T Dwarf',NULL,'2008AJ....135.1361D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62678,'CMD','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62678,23.12,NULL,0.42,21595,NULL,NULL,NULL,'Leo T Dwarf',NULL,'2007ApJ...656L..13I',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62679,'CMD','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62679,23.1,NULL,0.42,21595,NULL,NULL,NULL,'Leo T Dwarf',NULL,'2008AJ....135.1361D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62680,'CMD','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62680,23.15,NULL,0.427,21595,NULL,NULL,NULL,'Leo T Dwarf',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62681,'CMD','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62681,23.16,NULL,0.429,21595,NULL,NULL,NULL,'Leo T Dwarf',NULL,'2012ApJ...756..108C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62682,'Horizontal Branch','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62682,23.1,0.1,0.417,21595,NULL,NULL,NULL,'Leo T Dwarf',NULL,'2008ApJ...680.1112D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62683,'Red Clump','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62683,23.1,0.2,0.417,21595,NULL,NULL,NULL,'Leo T Dwarf',NULL,'2008ApJ...680.1112D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62684,'RR Lyrae','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62684,23.06,0.15,0.409,21595,NULL,NULL,'1','Leo T Dwarf',NULL,'2012ApJ...756..108C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62685,'Type II Cepheids','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62685,22.88,0.16,0.377,21595,NULL,NULL,'11','Leo T Dwarf',NULL,'2014MNRAS.437.2307R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62686,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62686,36.6,0.27,209,21596,70,NULL,NULL,'2MASX J09345385+3438515',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000181,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,143.724333,34.64761,0.005,NULL,64179908045,1002811063,15668922,16.6),(62687,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62687,35.66,0.85,135,21597,70,NULL,NULL,'2MASX J09345428-7727001',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,143.7265417,-77.45006,0.541,NULL,39941619255,624087800,9751371,17.7),(62688,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62688,37.81,0.46,364,21598,70,NULL,NULL,'2MASX J09345526+3540115',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,143.7302083,35.66983,0.009,NULL,64187649489,1002932023,15670812,17.2),(62689,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62689,36.97,0.46,248,21599,70,NULL,NULL,'2MASX J09345556+3250295',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00019,NULL,'16.0g',0.41,NULL,NULL,NULL,NULL,NULL,1,143.7315417,32.84158,0,NULL,64178702527,1002792226,15668628,16),(62690,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62690,37.74,0.33,352,21600,70,NULL,NULL,'2MASX J09345639+0315192',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000184,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,143.7349583,3.25528,0.041,NULL,60688865131,948263517,14816617,16.7),(62691,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62691,37.21,0.46,277,21601,70,NULL,NULL,'SDSS J093456.52+540011.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000153,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,143.7355417,54.00322,0.013,NULL,63964912716,999451761,15616433,18.2),(62692,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62692,38.1,0.46,417,21602,70,NULL,NULL,'2MASX J09345677+1250470',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,143.736541667,12.84639,0.053,NULL,63720070556,995626102,15556657,17.4),(62693,'Sosies','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62693,33.04,0.26,40.6,21603,NULL,NULL,NULL,'NGC 2916',NULL,'2002A&A...393...57T',2002,1,1.89,NULL,'G',0.000023,NULL,'13.2g',1.07,'SA(rs)b?','Isolated galaxy (6 Mpc isolation)',NULL,NULL,NULL,1,143.74,21.70528,0.069,NULL,63750828488,996106695,15564167,13.2),(62694,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62694,33.54,0.45,51,21603,NULL,NULL,'K','NGC 2916',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62695,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62695,33.54,0.47,51.1,21603,NULL,NULL,'H','NGC 2916',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62696,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62696,33.57,0.46,51.7,21603,NULL,NULL,'J','NGC 2916',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62697,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62697,33.79,0.4,57.2,21603,NULL,NULL,'mean','NGC 2916',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62698,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62698,38.93,0.46,610,21604,70,NULL,NULL,'SDSS J093457.75+031825.9',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,143.740625,3.30722,0.041,NULL,60688865910,948263529,14816617,18.2),(62699,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62699,33.5,0.56,50.1,21605,70,NULL,NULL,'FAIRALL 0284',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0b',NULL,'(R_1)SB(s)0^+',NULL,NULL,NULL,NULL,1,143.7544583,-78.21683,0.473,NULL,39988335416,624817740,9762777,15),(62700,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62700,36.45,0.27,195,21606,70,NULL,NULL,'2MASX J09350224+2716156',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000202,NULL,'15.8g',0.42,NULL,NULL,NULL,NULL,NULL,1,143.7592917,27.271,0,NULL,64214234420,1003347412,15677303,15.8),(62701,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62701,37.46,0.46,311,21607,70,NULL,NULL,'SDSS J093504.23+393212.5',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.2g',0.38,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,143.767667,39.53681,0,NULL,64394658713,1006166542,15721352,16.2),(62702,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62702,37.56,0.46,326,21608,70,NULL,NULL,'2MASX J09350480+4851116',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000174,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,143.770333,48.85325,0.037,NULL,64017030483,1000266101,15629157,17.2),(62703,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62703,37.63,0.46,336,21609,70,NULL,NULL,'2MASX J09350545+0703466',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,143.772666667,7.06308,0.093,NULL,60712460301,948632192,14822378,17.2),(62704,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62704,32.58,0.2,32.8,21610,74.4,NULL,NULL,'UGC 05107',NULL,'2013AJ....146...86T',2013,1,1.59,NULL,'G',0.000013,NULL,'15.4g',0.4,'SBd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,143.781167,5.12008,0.077,NULL,60720272108,948754251,14824285,15.4),(62705,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62705,32.68,0.4,34.4,21610,NULL,NULL,NULL,'UGC 05107',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62706,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62706,32.69,0.43,34.6,21610,75,NULL,'3.6 micron, color corrected','UGC 05107',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62707,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62707,32.79,0.43,36.2,21610,75,NULL,'3.6 micron, color + selection bias corrected','UGC 05107',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62708,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62708,32.82,0.52,36.6,21610,NULL,NULL,NULL,'UGC 05107',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62709,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62709,33.08,0.47,41.3,21610,NULL,NULL,'Malmquist cor.','UGC 05107',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62710,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62710,36.6,0.46,209,21611,70,NULL,NULL,'2MASX J09350859+0809306',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000163,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,143.7857917,8.15842,0.073,NULL,60709859810,948591559,14821743,16.8),(62711,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62711,36.06,NULL,163,21612,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0909',NULL,'2010Ap&SS.325..163P',2010,1,1.06,NULL,'G',0.000086,NULL,'16.8g',0.13,'Sd(f)',NULL,NULL,NULL,NULL,1,143.786958333,59.37831,0.053,NULL,61912302205,967379721,15115308,16.8),(62712,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62712,36.08,NULL,164,21612,NULL,NULL,'Dipole + Quadrupole','FGC 0909',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62713,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62713,36.09,NULL,165,21612,NULL,NULL,NULL,'FGC 0909',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62714,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62714,36.11,NULL,166,21612,NULL,NULL,'Dipole','FGC 0909',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62715,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62715,38.11,0.46,419,21613,70,NULL,NULL,'2MASX J09350888+1202450',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,143.787125,12.04569,0.057,NULL,60699978952,948437171,14819330,17.9),(62716,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62716,37,0.46,251,21614,70,NULL,NULL,'2MASX J09351030+5934154',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000073,NULL,'18.1g',0.12,'NLAGN',NULL,NULL,NULL,NULL,1,143.793,59.57108,0.061,NULL,61912253457,967378960,15115296,18.1),(62717,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62717,38.02,0.46,401,21615,70,NULL,NULL,'2MASX J09351047+0303120',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,143.793583,3.05328,0.053,NULL,60688851968,948263312,14816614,17.5),(62718,'Faber-Jackson','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62718,30.84,0.65,14.7,21616,95,NULL,'Weighted Mean','NGC 2924',NULL,'1984ApJS...56...91D',1984,1,1.4,NULL,'G',0.000143,NULL,'13.00',1.3,'E+:',NULL,NULL,NULL,NULL,1,143.7950417,-16.39839,0.237,NULL,42312098739,661126542,10330102,13),(62719,'Faber-Jackson','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62719,32.52,0.81,31.9,21616,55,NULL,'Visvanathan & Sandage 1979','NGC 2924',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62720,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62720,33.59,0.48,52.1,21616,70,NULL,NULL,'NGC 2924',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62721,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62721,37.06,0.46,258,21617,70,NULL,NULL,'2MASX J09351161+4800506',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000184,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,143.798375,48.01419,0.029,NULL,64017281969,1000270030,15629219,16.9),(62722,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62722,36.28,0.57,181,21618,70,NULL,NULL,'2MASX J09351218-2716561',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,143.800833,-27.28236,0.353,NULL,42878090143,669970158,10468283,14),(62723,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62723,36.22,0.46,175,21619,70,NULL,NULL,'2MASX J09351228+2630116',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000168,NULL,'16.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,143.801083,26.50322,0,NULL,64211384428,1003302881,15676607,16.4),(62724,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62724,38.14,0.46,425,21620,70,NULL,NULL,'SDSS J093512.44+420622.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000154,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,143.801875,42.10619,0,NULL,64258637744,1004041214,15688143,18.1),(62725,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62725,37.39,0.46,301,21621,70,NULL,NULL,'2MASX J09351280+2349425',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000173,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,143.803375,23.82867,0.037,NULL,63745473581,996023024,15562859,17.5),(62726,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62726,35.41,0.46,121,21622,70,NULL,NULL,'IC 2491',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.00008,NULL,'14.7g',0.8,'S0?',NULL,NULL,NULL,NULL,1,143.80925,34.73167,0,NULL,64179898995,1002810921,15668920,14.7),(62727,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62727,38.16,0.46,429,21623,70,NULL,NULL,'2MASX J09351428+5342396',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,143.809291667,53.71106,0.017,NULL,63964851019,999450797,15616418,18.3),(62728,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62728,35.57,0.46,130,21624,70,NULL,NULL,'2MASX J09351434+0024330',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000175,NULL,'15.5g',0.49,'E0',NULL,NULL,NULL,NULL,1,143.80975,0.40914,0.073,NULL,60685450182,948210159,14815783,15.5),(62729,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62729,37.38,0.33,299,21625,70,NULL,NULL,'2MASX J09351578+3950075',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000193,NULL,'16.2g',0.41,NULL,NULL,NULL,NULL,NULL,1,143.815541667,39.83533,0.017,NULL,64391279245,1006113738,15720527,16.2),(62730,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62730,37.4,0.46,302,21626,70,NULL,NULL,'2MASX J09351821+0503240',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,143.825833,5.05656,0.077,NULL,60720265222,948754144,14824283,17.4),(62731,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62731,37.53,0.46,320,21627,70,NULL,NULL,'2MASX J09351844+1156086',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,143.826916667,11.93567,0.057,NULL,60700007182,948437612,14819337,17.2),(62732,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62732,36.59,0.27,208,21628,70,NULL,NULL,'2MASX J09351942+5436313',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000082,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,143.830917,54.60858,0.009,NULL,61881183165,966893486,15107710,16.5),(62733,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62733,36.29,0.46,181,21629,70,NULL,NULL,'2MASX J09351950+2558293',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000169,NULL,'16.0g',0.37,NULL,NULL,NULL,NULL,NULL,1,143.831291667,25.97494,0.005,NULL,64211454223,1003303972,15676624,16),(62734,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,NULL,62734,37.26,0.7,283,21630,70,NULL,NULL,'2MASX J09351954-0820414',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,143.8315,-8.34483,0.101,NULL,41094286618,642098228,10032784,15.7),(62735,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62735,37.38,0.33,299,21631,70,NULL,NULL,'2MASX J09352116+3951026',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,'FoF','17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,143.838083,39.85083,0.017,NULL,64391281979,1006113780,15720527,17.1),(62736,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62736,36.73,0.46,221,21632,70,NULL,NULL,'2MASX J09352310+2125516',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,143.846167,21.43103,0.049,NULL,63750836193,996106815,15564168,16.9),(62737,'FP','2016-12-15 15:14:30','2016-12-16 11:19:36','1',NULL,'R',62737,37.78,0.46,360,21633,70,NULL,NULL,'2MASX J09352403+4423201',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000179,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,143.850083,44.38894,0.077,NULL,63981136101,999705251,15620394,17.5),(62738,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62738,36.73,0.46,222,21634,70,NULL,NULL,'2MASX J09352465+4103366',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000212,NULL,'15.7g',0.37,NULL,NULL,NULL,NULL,NULL,1,143.8527917,41.06014,0.021,NULL,64260711070,1004073610,15688650,15.7),(62739,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62739,37.66,0.46,341,21635,70,NULL,NULL,'2MASX J09352511-0000236',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,143.8544583,-0.00647,0.077,NULL,41105378232,642271534,10035492,17.4),(62740,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62740,37.74,0.46,354,21636,70,NULL,NULL,'SDSS J093525.51+101412.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,143.856291667,10.23694,0.013,NULL,60702558192,948477471,14819960,18.4),(62741,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62741,35.42,0.4,122,21637,NULL,NULL,'mean','UGC 05108',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000087,NULL,'14.4g',0.56,'SBab',NULL,NULL,NULL,NULL,1,143.859541667,29.81261,0.017,NULL,64221792094,1003465501,15679148,14.4),(62742,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62742,35.69,0.47,138,21637,NULL,NULL,'H','UGC 05108',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62743,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62743,35.71,0.45,138,21637,NULL,NULL,'K','UGC 05108',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62744,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62744,35.79,0.46,144,21637,NULL,NULL,'J','UGC 05108',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62745,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62745,37.42,0.46,305,21638,70,NULL,NULL,'2MASX J09352940+3839506',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000167,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,143.872625,38.66414,0,NULL,64394458684,1006163416,15721303,16.7),(62746,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62746,38.1,0.46,417,21639,70,NULL,NULL,'2MASX J09352983+0321290',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00018,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,143.874333,3.35806,0.041,NULL,60688907723,948264183,14816627,17.1),(62747,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62747,37.84,0.46,370,21640,70,NULL,NULL,'2MASX J09353273+0605227',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,143.886375,6.08978,0.109,NULL,60717040719,948703761,14823496,18),(62748,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62748,36.63,0.46,212,21641,70,NULL,NULL,'2MASX J09353325+5429570',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000189,NULL,'15.7g',0.46,'S0^-',NULL,NULL,NULL,NULL,1,143.8885,54.49906,0.009,NULL,61881154688,966893042,15107703,15.7),(62749,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62749,37.78,0.33,360,21642,70,NULL,NULL,'SDSS J093534.89+100409.5',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,143.895417,10.06933,0.053,NULL,60702535251,948477113,14819954,17.9),(62750,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62750,37.81,0.46,364,21643,70,NULL,NULL,'2MASX J09353513+5920500',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000078,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,143.896375,59.34711,0.053,NULL,61912293665,967379588,15115306,18.1),(62751,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62751,37.98,0.33,395,21644,70,NULL,NULL,'2MASX J09353530+1645375',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000173,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,143.897208333,16.76053,0.109,NULL,63736387090,995881048,15560641,17),(62752,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62752,37.38,0.46,300,21645,70,NULL,NULL,'2MASX J09353542+1538495',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,143.8975417,15.64703,0.093,NULL,63735659195,995869674,15560463,17.8),(62753,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62753,37.78,0.33,360,21646,70,NULL,NULL,'2MASX J09353831+0957237',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000183,NULL,'16.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,143.909667,9.95656,0.065,NULL,60702524075,948476938,14819952,16.6),(62754,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62754,36.77,0.46,226,21647,70,NULL,NULL,'2MASX J09353938+1015207',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000175,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,143.914125,10.25572,0.013,NULL,60702570152,948477658,14819963,17.2),(62755,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62755,38.59,0.46,523,21648,70,NULL,NULL,'SDSS J093540.24+145208.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,143.9177083,14.869,0.101,NULL,63723271555,995676118,15557439,18.6),(62756,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62756,34.14,0.46,67.2,21649,70,NULL,NULL,'NGC 2918',NULL,'2015arXiv151105856S',2015,1,1.47,NULL,'G',0.000067,NULL,'13.5g',0.96,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,143.9335,31.70547,0,NULL,64209525560,1003273836,15676153,13.5),(62757,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62757,36.18,0.46,172,21650,70,NULL,NULL,'2MASX J09354549+0945447',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000194,NULL,'15.9g',0.36,'S0',NULL,NULL,NULL,NULL,1,143.939666667,9.7625,0.077,NULL,60703003361,948484427,14820069,15.9),(62758,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62758,37.29,0.46,287,21651,70,NULL,NULL,'2MASX J09354583+2803422',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,143.940833,28.06183,0,NULL,64213409271,1003334519,15677101,16.8),(62759,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62759,37.98,0.33,395,21652,70,NULL,NULL,'SDSS J093545.81+164641.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,143.940917,16.77822,0.109,NULL,63736393861,995881154,15560643,18.3),(62760,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62760,38.58,0.46,519,21653,70,NULL,NULL,'2MASX J09354617+4731412',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000132,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,143.9425417,47.52808,0.021,NULL,64013759552,1000214993,15628359,18.2),(62761,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62761,36.65,0.46,214,21654,70,NULL,NULL,'2MASX J09354636+2933162',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000163,NULL,'16.2g',0.33,'E',NULL,NULL,NULL,NULL,1,143.9432917,29.55453,0.021,NULL,64221932393,1003467693,15679182,16.2),(62762,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62762,37.63,0.46,336,21655,70,NULL,NULL,'2MASX J09354721+0316540',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,143.946875,3.28175,0.041,NULL,60688954706,948264917,14816639,17.6),(62763,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62763,34.51,NULL,79.9,21656,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0912',NULL,'2010Ap&SS.325..163P',2010,1,0.64,NULL,'G',0.000016,NULL,'18.3g',0.08,'Sd',NULL,NULL,NULL,NULL,1,143.958875,22.92419,0.053,NULL,63749197678,996081213,15563768,18.3),(62764,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62764,34.52,NULL,80.2,21656,NULL,NULL,'Dipole + Quadrupole','FGC 0912',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62765,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62765,34.53,NULL,80.6,21656,NULL,NULL,'Dipole','FGC 0912',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62766,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62766,34.58,NULL,82.3,21656,NULL,NULL,NULL,'FGC 0912',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62767,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62767,35.75,0.2,141,21656,74.4,NULL,NULL,'FGC 0912',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62768,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62768,37.5,0.46,316,21657,70,NULL,NULL,'2MASX J09355034+2412130',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000178,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,143.9599583,24.20372,0.045,NULL,63745155476,996018054,15562782,17),(62769,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62769,36.87,0.46,236,21658,70,NULL,NULL,'2MASX J09355160+0123070',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000083,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,143.965125,1.38519,0.149,NULL,60697214562,948393977,14818655,17.3),(62770,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62770,36.59,0.27,208,21659,70,NULL,NULL,'2MASX J09355322+5428380',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000218,NULL,'15.6g',0.43,'AGN',NULL,NULL,NULL,NULL,1,143.971667,54.47711,0.009,NULL,61881153690,966893026,15107703,15.6),(62771,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62771,36.23,0.33,176,21660,70,NULL,NULL,'2MASX J09355331+1445585',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000297,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,143.972083,14.76619,0.085,NULL,63723213213,995675206,15557425,16.5),(62772,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62772,34.45,0.2,77.6,21661,74.4,NULL,NULL,'IC 0544',NULL,'2013AJ....146...86T',2013,1,0.81,NULL,'G',0.00005,NULL,'15.5g',0.28,'Sb','Pair member (points to parent)',NULL,NULL,NULL,1,143.972417,24.89486,0.029,NULL,63711539119,995492798,15554574,15.5),(62773,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62773,34.8,0.49,91.3,21661,75,NULL,'IR','IC 0544',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62774,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62774,36.45,0.27,195,21662,70,NULL,NULL,'2MASX J09355433+2708431',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000181,NULL,'15.8g',0.36,NULL,NULL,NULL,NULL,NULL,1,143.976417,27.14547,0,NULL,64214259158,1003347799,15677309,15.8),(62775,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62775,37.36,0.46,296,21663,70,NULL,NULL,'2MASX J09355691+2249113',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000187,NULL,'16.4g',0.41,NULL,NULL,NULL,NULL,NULL,1,143.9872083,22.81989,0.053,NULL,63749072405,996079256,15563738,16.4),(62776,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62776,36.38,0.52,189,21664,70,NULL,NULL,'2MASX J09355732-2002060',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,143.988833,-20.03508,0.069,NULL,42342881390,661607521,10337617,16.3),(62777,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62777,35.64,0.58,134,21665,70,NULL,NULL,'ESO 498- G 015',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000033,NULL,'15',0.6,'SA(s)c',NULL,NULL,NULL,NULL,1,143.9900417,-24.98025,0.101,NULL,42840625396,669384771,10459137,15),(62778,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62778,35.58,0.4,131,21665,NULL,NULL,'Malmquist cor.','ESO 498- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62779,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62779,35.6,0.39,132,21665,NULL,NULL,NULL,'ESO 498- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62780,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62780,35.64,0.2,134,21665,74.4,NULL,NULL,'ESO 498- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62781,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62781,37.45,0.46,309,21666,70,NULL,NULL,'2MASX J09355783+1255411',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,143.990917,12.92803,0.053,NULL,63719959054,995624360,15556630,17),(62782,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62782,36.59,0.27,208,21667,70,NULL,NULL,'SDSS J093558.88+543639.0',NULL,'2015arXiv151105856S',2015,1,1.04,NULL,'G',0.000222,NULL,'14.5g',0.73,NULL,NULL,NULL,NULL,NULL,1,143.995333,54.61083,0.009,NULL,61881187221,966893550,15107711,14.5),(62783,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62783,38.33,0.46,464,21668,70,NULL,NULL,'2MASX J09355915+0159550',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000089,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,143.996583,1.99872,0.133,NULL,60699956275,948436816,14819325,17.6),(62784,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62784,37.08,0.27,261,21669,70,NULL,NULL,'2MASX J09360010+1102029',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000194,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,144.0005,11.03433,0.065,NULL,60700721939,948448780,14819512,16.2),(62785,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62785,36.11,0.59,167,21670,70,NULL,NULL,'2MASX J09360011-3453433',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,144.000583,-34.89533,0.701,NULL,42863265889,669738529,10464664,17.2),(62786,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62786,35.84,0.46,147,21671,70,NULL,NULL,'2MASX J09360124+0723169',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000166,NULL,'16.0g',0.42,'E',NULL,NULL,NULL,NULL,1,144.005333,7.38803,0.097,NULL,60712409572,948631399,14822365,16),(62787,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62787,36.11,0.69,167,21672,70,NULL,NULL,'2MASX J09360177-0240590',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00015,NULL,'17.38',0.42,NULL,NULL,NULL,NULL,NULL,1,144.007333,-2.68303,0.077,NULL,41120468265,642507316,10039176,17.38),(62788,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62788,37.43,0.46,306,21673,70,NULL,NULL,'2MASX J09360176+3148300',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000154,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,144.007375,31.80836,0,NULL,64209494654,1003273353,15676146,17),(62789,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62789,36.55,0.46,204,21674,70,NULL,NULL,'2MASX J09360618+0127389',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000086,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,144.025625,1.46072,0.149,NULL,60697187956,948393561,14818649,17),(62790,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62790,37.12,0.79,266,21675,70,NULL,NULL,'2MASX J09360727-0523450',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,144.03025,-5.39594,0.097,NULL,41121788427,642527944,10039499,15.6),(62791,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62791,37.98,0.46,394,21676,70,NULL,NULL,'2MASX J09360925+3505310',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,144.0385417,35.09186,0,NULL,64187975482,1002937116,15670892,17.4),(62792,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62792,37.03,0.46,255,21677,70,NULL,NULL,'2MASX J09360937+3313080',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000223,NULL,'16.0g',0.39,NULL,NULL,NULL,NULL,NULL,1,144.039083333,33.219,0.021,NULL,64179106484,1002798538,15668727,16),(62793,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62793,37.08,0.27,261,21678,70,NULL,NULL,'2MASX J09361015+1054389',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00019,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,144.0422917,10.91092,0.077,NULL,60700520062,948445625,14819462,16.6),(62794,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62794,37.42,0.46,305,21679,70,NULL,NULL,'2MASX J09361113+1623481',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,144.046375,16.39664,0.109,NULL,63736603140,995884424,15560694,17.4),(62795,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62795,37.08,0.27,261,21680,70,NULL,NULL,'2MASX J09361117+1058249',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,144.046416667,10.9735,0.065,NULL,60700510432,948445475,14819460,17),(62796,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62796,36.84,0.46,233,21681,70,NULL,NULL,'2MASX J09361140+4915363',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000195,NULL,'16.1g',0.3,'S0',NULL,NULL,NULL,NULL,1,144.047625,49.26014,0.029,NULL,64015920383,1000248755,15628886,16.1),(62797,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62797,37.06,0.46,258,21682,70,NULL,NULL,'2MASX J09361327+3300200',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00014,NULL,'16.0g',0.38,NULL,NULL,NULL,NULL,NULL,1,144.055417,33.00564,0.021,NULL,64179131947,1002798936,15668733,16),(62798,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62798,36.92,0.46,242,21683,70,NULL,NULL,'2MASX J09361398+3449010',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000183,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,144.0584583,34.81708,0,NULL,64188008331,1002937630,15670900,16.6),(62799,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62799,36.79,0.46,228,21684,70,NULL,NULL,'SDSS J093614.54+022000.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000072,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,144.060625,2.33361,0.113,NULL,60699377941,948427780,14819184,18.1),(62800,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62800,37.72,0.46,351,21685,70,NULL,NULL,'2MASX J09361651+0338449',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000178,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,144.0689583,3.64572,0.069,NULL,60688771393,948262053,14816594,17.1),(62801,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62801,37.68,0.46,343,21686,70,NULL,NULL,'2MASX J09361720+4843402',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,144.0715,48.72786,0.037,NULL,64017044108,1000266314,15629161,17.7),(62802,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62802,35.06,0.46,103,21687,70,NULL,NULL,'IC 2493',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000103,NULL,'14.5g',0.65,'E0',NULL,NULL,NULL,NULL,1,144.073083333,37.364,0,NULL,64393470162,1006147971,15721062,14.5),(62803,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62803,37.51,0.62,318,21688,70,NULL,NULL,'2MASX J09362070-2453382',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.0I',0.2,NULL,NULL,NULL,NULL,NULL,1,144.086333333,-24.89389,0.101,NULL,42316345708,661192901,10331139,15),(62804,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62804,35.88,0.46,150,21689,70,NULL,NULL,'2MASX J09362099+0424339',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,144.087375,4.40933,0.085,NULL,60691106619,948298540,14817164,16.8),(62805,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62805,38.41,0.46,480,21690,70,NULL,NULL,'2MASX J09362150+2854176',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000128,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,144.089667,28.90478,0.017,NULL,64221571742,1003462058,15679094,18.5),(62806,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62806,37.45,0.46,309,21691,70,NULL,NULL,'2MASX J09362271+0302529',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000169,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,144.094833333,3.04806,0.053,NULL,60696302129,948379720,14818433,16.6),(62807,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62807,36.13,0.46,169,21692,70,NULL,NULL,'2MASX J09362430+3204460',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000169,NULL,'15.7g',0.46,'S0',NULL,NULL,NULL,NULL,1,144.101208333,32.07933,0.005,NULL,64209468108,1003272939,15676139,15.7),(62808,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62808,34.26,0.54,71,21693,70,NULL,NULL,'ESO 373- G 010',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000117,NULL,'13.70',0.6,'SAB0-:',NULL,NULL,NULL,NULL,1,144.115125,-37.341,0.877,NULL,42851557455,669555585,10461806,13.7),(62809,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62809,37.33,0.46,292,21694,70,NULL,NULL,'2MASX J09362939+2418357',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000173,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,144.1224583,24.31014,0.045,NULL,63745118734,996017480,15562773,17.3),(62810,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62810,35.1,0.46,105,21695,70,NULL,NULL,'CGCG 152-037',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000173,NULL,'15.2g',0.52,'AGN',NULL,NULL,NULL,NULL,1,144.125667,28.50336,0.005,NULL,64213461696,1003335339,15677114,15.2),(62811,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62811,35.4,0.64,120,21696,70,NULL,NULL,'2MASX J09363104-2015512',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,144.129417,-20.26431,0.093,NULL,42345510726,661648605,10338259,14.1),(62812,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62812,33.98,NULL,62.5,21697,NULL,NULL,NULL,'FGC 0913',NULL,'2000BSAO...50....5K',2000,1,1.1,NULL,'G',0.000317,NULL,'16.6',0.1,'Sd',NULL,NULL,NULL,NULL,1,144.13,15.54889,0.069,NULL,63735126306,995861348,15560333,16.6),(62813,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62813,34.08,NULL,65.5,21697,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0913',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62814,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62814,34.09,NULL,65.6,21697,NULL,NULL,'Dipole + Quadrupole','FGC 0913',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62815,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62815,34.1,NULL,65.9,21697,NULL,NULL,'Dipole','FGC 0913',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62816,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62816,34.71,0.2,87.5,21697,74.4,NULL,NULL,'FGC 0913',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62817,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62817,36.45,0.27,195,21698,70,NULL,NULL,'2MASX J09363131+2709327',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000173,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,144.1304583,27.15919,0,NULL,64214214470,1003347101,15677298,16.5),(62818,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62818,38.64,0.46,535,21699,70,NULL,NULL,'2MASX J09363146+3747402',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,144.131208333,37.79439,0,NULL,64393531642,1006148931,15721077,18.1),(62819,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62819,37.76,0.46,356,21700,70,NULL,NULL,'SDSS J093631.71+075319.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000145,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,144.132125,7.88864,0.097,NULL,60710250325,948597661,14821838,18.4),(62820,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62820,37.79,0.46,361,21701,70,NULL,NULL,'2MASX J09363217+1206263',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000174,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,144.13425,12.1075,0.057,NULL,60884731136,951323924,14864436,16.9),(62821,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62821,36.82,0.46,231,21702,70,NULL,NULL,'2MASX J09363385+3502569',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000168,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,144.1409583,35.04922,0.005,NULL,64187994955,1002937421,15670897,16.5),(62822,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62822,37.86,0.46,374,21703,70,NULL,NULL,'2MASX J09363458+1435345',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,144.144083333,14.59297,0.081,NULL,63723197421,995674959,15557421,NULL),(62823,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62823,36.96,0.46,246,21704,70,NULL,NULL,'2MASX J09363457+0344284',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000209,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,144.1442083,3.74122,0.053,NULL,60690677173,948291830,14817059,16.3),(62824,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62824,37.41,0.46,304,21705,70,NULL,NULL,'2MASX J09363543+0332554',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,144.147625,3.54864,0.065,NULL,60690687091,948291985,14817062,17),(62825,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62825,38.55,0.46,513,21706,70,NULL,NULL,'SDSS J093638.92+400450.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00015,NULL,'18.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,144.1622083,40.08075,0,NULL,64257504455,1004023507,15687867,18.9),(62826,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62826,36.08,0.46,164,21707,70,NULL,NULL,'CGCG 265-028',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000133,NULL,'15.1g',0.49,'E0',NULL,NULL,NULL,NULL,1,144.17325,53.10767,0.005,NULL,63967153586,999486774,15616980,15.1),(62827,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62827,37.75,0.46,356,21708,70,NULL,NULL,'2MASX J09364157+5556194',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000195,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,144.1734583,55.93881,0.025,NULL,61880037374,966875583,15107430,16.6),(62828,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62828,37.66,0.46,341,21709,70,NULL,NULL,'2MASX J09364170+2955227',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000143,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,144.1739583,29.923,0.017,NULL,64222256928,1003472764,15679261,17.4),(62829,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62829,36.95,0.46,246,21710,70,NULL,NULL,'2MASX J09364265+5502574',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000106,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,144.1774583,55.04939,0.009,NULL,61881792739,966903011,15107859,16.3),(62830,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 1996Z',NULL,62830,31.98,0.3,24.7,21711,74.2,NULL,'SALT 2','NGC 2935',0.00758,'2010ApJ...716..712A',2010,1,3.6,NULL,'G',0.00001,NULL,'12.35',2.8,'(R\'_2)SAB(s)b  Sbrst','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,144.186875,-21.12814,0.113,NULL,42345115116,661642423,10338162,12.35),(62831,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 1996Z',NULL,62831,32.42,0.24,30.2,21711,72,NULL,NULL,'NGC 2935',0.00758,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62832,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 1996Z',NULL,62832,32.47,0.08,31.2,21711,74.4,NULL,NULL,'NGC 2935',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62833,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 1996Z',NULL,62833,32.64,0.14,33.7,21711,60,NULL,NULL,'NGC 2935',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62834,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 1996Z',NULL,62834,32.76,0.24,35.1,21711,65,NULL,'MLCS2k2','NGC 2935',0.00758,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62835,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 1996Z',NULL,62835,32.75,0.3,35.2,21711,70,NULL,'SALT','NGC 2935',0.00758,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62836,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 1996Z',NULL,62836,32.82,0.17,36.6,21711,70.8,NULL,NULL,'NGC 2935',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62837,'IRAS','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62837,32.52,0.8,31.9,21711,75,NULL,'MAT, I','NGC 2935',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62838,'Sosies','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62838,32.01,0.22,25.2,21711,NULL,NULL,NULL,'NGC 2935',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62839,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62839,31.97,0.36,24.8,21711,NULL,NULL,NULL,'NGC 2935',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62840,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62840,31.97,0.4,24.8,21711,73,NULL,'opt','NGC 2935',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62841,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62841,32.02,0.43,25.4,21711,75,NULL,'MAT, I, raw','NGC 2935',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62842,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62842,32.14,0.45,26.8,21711,NULL,NULL,'K','NGC 2935',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62843,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62843,32.18,0.4,27.3,21711,75,NULL,'HOSTS SN 1996Z','NGC 2935',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62844,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62844,32.18,0.47,27.3,21711,NULL,NULL,'H','NGC 2935',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62845,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62845,32.2,0.47,27.5,21711,NULL,NULL,'Malmquist cor.','NGC 2935',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62846,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62846,32.23,0.32,27.9,21711,85,NULL,'I, raw','NGC 2935',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62847,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62847,32.24,0.46,28,21711,NULL,NULL,'J','NGC 2935',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62848,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62848,32.26,0.46,28.3,21711,NULL,NULL,NULL,'NGC 2935',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62849,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62849,32.28,0.43,28.5,21711,75,NULL,'MAT, I, inv','NGC 2935',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62850,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62850,32.3,0.32,28.8,21711,85,NULL,'I, inv','NGC 2935',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62851,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62851,32.36,0.43,29.7,21711,75,NULL,'MAT, I, cor','NGC 2935',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62852,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62852,32.43,0.4,30.6,21711,75,NULL,'B','NGC 2935',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62853,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62853,32.47,0.08,31.2,21711,74.4,NULL,NULL,'NGC 2935',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62854,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62854,32.82,0.4,36.6,21711,NULL,NULL,'mean','NGC 2935',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62855,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62855,37.49,0.46,315,21712,70,NULL,NULL,'2MASX J09364549+2314124',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000067,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,144.189333333,23.23686,0.045,NULL,63748979948,996077811,15563715,17.6),(62856,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62856,38.41,0.46,481,21713,70,NULL,NULL,'SDSS J093646.58+055704.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,144.194083333,5.95133,0.097,NULL,60717147115,948705423,14823522,18.1),(62857,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62857,37.95,0.46,389,21714,70,NULL,NULL,'2MASX J09364958+0902284',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000164,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,144.206625,9.04133,0.081,NULL,60713664107,948651001,14822671,17),(62858,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62858,38.29,0.33,455,21715,70,NULL,NULL,'2MASX J09364987+4806335',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,144.207875,48.10942,0.045,NULL,64017419946,1000272186,15629252,17.6),(62859,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62859,37.87,0.46,375,21716,70,NULL,NULL,'2MASX J09365074+4034112',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,144.2114583,40.56983,0,NULL,64257451791,1004022684,15687854,18.1),(62860,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62860,35.43,0.46,122,21717,70,NULL,NULL,'2MASX J09365094+1315555',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.1g',0.34,NULL,NULL,NULL,NULL,NULL,1,144.2122917,13.26544,0.065,NULL,63720307131,995629798,15556715,16.1),(62861,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62861,37.86,0.46,374,21718,70,NULL,NULL,'2MASX J09365661+2338384',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,144.235833,23.64403,0.049,NULL,63745881534,996029398,15562959,17.8),(62862,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62862,38.37,0.46,472,21719,70,NULL,NULL,'SDSS J093657.50+010211.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,144.239625,1.03661,0.077,NULL,60685925585,948217587,14815899,18.1),(62863,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62863,37.48,0.33,313,21720,70,NULL,NULL,'2MASX J09370013+2151054',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000188,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,144.250625,21.85147,0.053,NULL,63747663771,996057246,15563394,16.9),(62864,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62864,36.07,0.63,164,21721,70,NULL,NULL,'2MASX J09370060-0516074',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.90',0.3,'S0','Group member',NULL,NULL,NULL,1,144.252333,-5.26875,0.089,NULL,41121405824,642521966,10039405,16.9),(62865,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62865,35.89,0.69,151,21722,70,NULL,NULL,'2MASX J09370067-0512244',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.68',0.3,'S0','Group member',NULL,NULL,NULL,1,144.25275,-5.20692,0.097,NULL,41121414174,642522096,10039407,16.68),(62866,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62866,36.13,0.5,168,21723,70,NULL,NULL,'2MASX J09370150-2104061',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00009,NULL,'15.73',0.5,NULL,NULL,NULL,NULL,NULL,1,144.256167,-21.06858,0.113,NULL,42344996695,661640573,10338133,15.73),(62867,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62867,37.39,0.46,300,21724,70,NULL,NULL,'2MASX J09370161+3554206',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000157,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,144.2565417,35.90578,0.017,NULL,64188440982,1002944390,15671006,17.1),(62868,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62868,38.29,0.33,455,21725,70,NULL,NULL,'2MASX J09370182+4803374',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,144.257875,48.0605,0.045,NULL,64017301527,1000270336,15629224,18.1),(62869,'Cepheids','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62869,27.8,0.08,3.63,21726,NULL,NULL,'HST KP Calibrated','MESSIER 081 GROUP',NULL,'2000ApJ...529..745F',2000,1,NULL,NULL,'GGroup',NULL,NULL,NULL,NULL,'Im',NULL,NULL,NULL,NULL,1,144.2707083,68.31639,0.165,NULL,62264646136,972885095,15201329,NULL),(62870,'Cepheids','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62870,29.34,0.1,7.38,21726,NULL,NULL,'HST KP Calibrated','MESSIER 081 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62871,'Cepheids','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62871,29.34,0.1,7.38,21726,NULL,NULL,'HST KP Calibrated','MESSIER 081 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62872,'PNLF','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62872,27.87,0.12,3.75,21726,NULL,NULL,'HST KP Calibrated','MESSIER 081 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62873,'PNLF','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62873,29.42,0.13,7.66,21726,NULL,NULL,'HST KP Calibrated','MESSIER 081 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62874,'PNLF','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62874,29.47,0.09,7.83,21726,NULL,NULL,'HST KP Calibrated','MESSIER 081 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62875,'SBF','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62875,28.07,0.15,4.11,21726,NULL,NULL,'HST KP Calibrated, I','MESSIER 081 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62876,'SBF','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62876,30.67,0.13,13.6,21726,NULL,NULL,'HST KP Calibrated, I','MESSIER 081 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62877,'TRGB','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62877,27.88,0.08,3.77,21726,NULL,NULL,'HST KP Calibrated','MESSIER 081 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62878,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62878,37.91,0.46,382,21727,70,NULL,NULL,'SDSS J093705.10+074619.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,144.27125,7.77194,0.097,NULL,60710111876,948595498,14821804,17.9),(62879,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62879,35.04,NULL,102,21728,NULL,NULL,'Dipole','UGC 05121',NULL,'2010Ap&SS.325..163P',2010,1,1.59,NULL,'G',0.000009,NULL,'15.64',0.19,'Sc',NULL,NULL,NULL,NULL,1,144.271875,13.89425,0.045,NULL,63723691469,995682679,15557541,15.64),(62880,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62880,35.05,NULL,102,21728,NULL,NULL,'Dipole + Quadrupole','UGC 05121',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62881,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62881,35.05,NULL,102,21728,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05121',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62882,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62882,35.19,NULL,109,21728,NULL,NULL,NULL,'UGC 05121',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62883,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62883,35.5,0.36,126,21728,NULL,NULL,'Malmquist cor.','UGC 05121',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62884,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62884,35.51,0.49,127,21728,75,NULL,'IR','UGC 05121',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62885,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62885,35.65,0.2,135,21728,74.4,NULL,NULL,'UGC 05121',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62886,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62886,35.67,0.33,136,21728,NULL,NULL,NULL,'UGC 05121',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62887,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62887,37.15,0.46,269,21729,70,NULL,NULL,'2MASX J09370536+2347524',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,144.272375,23.79792,0.037,NULL,63746058593,996032165,15563002,17.3),(62888,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62888,35.64,0.46,134,21730,70,NULL,NULL,'CGCG 210-016',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000087,NULL,'15.1g',0.46,'S0^-',NULL,NULL,NULL,NULL,1,144.283875,41.62636,0.025,NULL,64260517068,1004070579,15688602,15.1),(62889,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62889,37.47,0.46,312,21731,70,NULL,NULL,'2MASX J09370909+3803473',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000176,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,144.288,38.06331,0,NULL,64394400725,1006162511,15721289,17.3),(62890,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62890,35.51,0.4,126,21732,NULL,NULL,'mean','UGC 05123',NULL,'2007A&A...465...71T',2007,1,0.95,NULL,'G',0.000033,NULL,'14.2g',0.75,'S?','Group member of poor cluster',NULL,NULL,NULL,1,144.2885417,19.83597,0.085,NULL,63751681256,996120019,15564375,14.2),(62891,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62891,35.57,0.47,130,21732,NULL,NULL,'H','UGC 05123',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62892,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62892,35.57,0.45,130,21732,NULL,NULL,'K','UGC 05123',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62893,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62893,35.71,0.46,139,21732,NULL,NULL,'J','UGC 05123',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62894,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62894,37.21,0.46,276,21733,70,NULL,NULL,'SDSS J093710.31+101127.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000127,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,144.293,10.19103,0.053,NULL,60886210586,951347040,14864797,17.7),(62895,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62895,35.81,0.49,145,21734,70,NULL,NULL,'2MASX J09371067-2034013',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.96',NULL,NULL,NULL,NULL,NULL,NULL,1,144.294417,-20.56717,0.125,NULL,42345664351,661651005,10338296,15.96),(62896,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62896,37.63,0.46,335,21735,70,NULL,NULL,'2MASX J09371116+2254121',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000186,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,144.296583,22.9035,0.053,NULL,63749191971,996081124,15563767,16.5),(62897,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62897,37.52,0.46,320,21736,70,NULL,NULL,'2MASX J09371179+2652381',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,144.298917,26.87719,0.005,NULL,64214084620,1003345072,15677266,17.2),(62898,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62898,33.56,0.46,51.5,21737,70,NULL,NULL,'UGC 05119',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.00002,NULL,'14.2g',0.74,'S0?','Isolated galaxy (6 Mpc isolation)',NULL,NULL,NULL,1,144.3027083,38.09236,0,NULL,64394416697,1006162760,15721293,14.2),(62899,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62899,37.46,0.46,311,21738,70,NULL,NULL,'2MASX J09371333+6825143',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,144.305708333,68.42064,0.177,NULL,62264694323,972885848,15201341,17.4),(62900,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62900,36.78,0.46,227,21739,70,NULL,NULL,'2MASX J09371374+1812251',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,144.307333,18.20697,0.053,NULL,63725127468,995705116,15557892,16.9),(62901,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62901,37.34,0.46,294,21740,70,NULL,NULL,'2MASX J09371453+1319560',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'17.5E',NULL,NULL,NULL,NULL,NULL,NULL,1,144.310667,13.33219,0.057,NULL,63720304291,995629754,15556714,17.5),(62902,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62902,35.29,0.4,114,21741,NULL,NULL,'mean','NGC 2927',NULL,'2007A&A...465...71T',2007,1,1.67,NULL,'G',0.000033,NULL,'13.9g',0.88,'SAB(rs)b','in a radial-velocity based grouping',NULL,NULL,NULL,1,144.313333,23.59061,0.049,NULL,63745876238,996029316,15562958,13.9),(62903,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62903,35.38,0.47,119,21741,NULL,NULL,'H','NGC 2927',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62904,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62904,35.41,0.45,121,21741,NULL,NULL,'K','NGC 2927',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62905,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62905,35.44,0.46,122,21741,NULL,NULL,'J','NGC 2927',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62906,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62906,37.16,0.46,270,21742,70,NULL,NULL,'2MASX J09371625+0305244',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000187,NULL,'16.0g',0.45,'E0',NULL,NULL,NULL,NULL,1,144.317875,3.09011,0.065,NULL,60690021090,948281579,14816899,16),(62907,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62907,37.67,0.46,342,21743,70,NULL,NULL,'2MASX J09371676+1017264',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000188,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,144.319875,10.29067,0.053,NULL,60886197768,951346840,14864794,17),(62908,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62908,35.8,0.54,145,21744,70,NULL,NULL,'ESO 565- G 026',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000143,NULL,'15.33',0.3,'S0',NULL,NULL,NULL,NULL,1,144.328125,-20.63631,0.125,NULL,42345461911,661647842,10338247,15.33),(62909,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62909,34.74,0.46,88.7,21745,70,NULL,NULL,'2MASX J09371892+3946353',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000155,NULL,'15.6g',0.41,'S0a',NULL,NULL,NULL,NULL,1,144.328875,39.77628,0.025,NULL,64391371232,1006115175,15720549,15.6),(62910,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62910,35.38,0.49,119,21746,75,NULL,'IR','CGCG 181-068',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000025,NULL,'15.7',0.2,NULL,NULL,NULL,NULL,NULL,1,144.330083333,33.82383,0.013,NULL,64178571071,1002790172,15668596,15.7),(62911,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62911,36.91,0.46,241,21747,70,NULL,NULL,'2MASX J09372039+5026010',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,144.335083,50.43358,0.041,NULL,64015627497,1000244179,15628815,17.8),(62912,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62912,38.92,0.46,608,21748,70,NULL,NULL,'2MASX J09372180+0231555',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000106,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,144.340791667,2.53217,0.061,NULL,60698237199,948409956,14818905,17.8),(62913,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62913,32.17,NULL,27.2,21749,NULL,NULL,NULL,'AGC 198430',NULL,'2015AstBu..70....1K',2015,1,NULL,NULL,'RadioS',0.000077,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,144.35,4.09833,0.065,NULL,60691428748,948303574,14817243,NULL),(62914,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62914,37.91,0.46,382,21750,70,NULL,NULL,'2MASX J09372561+2229541',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000138,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,144.356833,22.49828,0.045,NULL,63748271324,996066739,15563542,18.7),(62915,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62915,37.48,0.33,313,21751,70,NULL,NULL,'2MASX J09372593+2153051',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000167,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,144.358083,21.88489,0.053,NULL,63747708239,996057941,15563405,16.4),(62916,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62916,36.94,0.46,245,21752,70,NULL,NULL,'2MASX J09372750+1549549',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'17.52',0.39,NULL,NULL,NULL,NULL,NULL,1,144.364416667,15.83194,0.085,NULL,63735230850,995862982,15560359,17.52),(62917,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 2010jn',NULL,62917,35.08,0.04,101,21753,70,NULL,'SN 2010jn, SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','NGC 2929',0.025047,'2014MNRAS.438.1391P',2014,1,1.2,NULL,'G',0.00003,NULL,'14.70',0.3,'S?','in a radial-velocity based grouping',NULL,NULL,NULL,1,144.3742083,23.16167,0.045,NULL,63748563743,996071308,15563614,14.7),(62918,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 2010jn',NULL,62918,35.19,0.04,106,21753,70,NULL,'SiFTO+SALT2, SN PTF10ygu, SN 2010jn','NGC 2929',0.025047,'2012MNRAS.426.2359M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62919,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62919,35.01,0.47,100,21753,NULL,NULL,'H','NGC 2929',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62920,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62920,35.13,0.45,106,21753,NULL,NULL,'K','NGC 2929',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62921,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62921,35.18,0.46,109,21753,NULL,NULL,'J','NGC 2929',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62922,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62922,35.28,0.4,114,21753,NULL,NULL,'mean','NGC 2929',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62923,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62923,37.66,0.46,340,21754,70,NULL,NULL,'2MASX J09373159+3904332',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,144.3817917,39.07589,0,NULL,64391746700,1006121042,15720641,17.8),(62924,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62924,37.69,0.46,346,21755,70,NULL,NULL,'2MASX J09373213+1620330',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,144.3840417,16.34247,0.049,NULL,63736042436,995875663,15560557,16.5),(62925,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62925,36.23,0.33,176,21756,70,NULL,NULL,'2MASX J09373253+1438360',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'17.56',0.3,NULL,NULL,NULL,NULL,NULL,1,144.385417,14.64339,0.085,NULL,63721256012,995644625,15556947,17.56),(62926,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 2005M',NULL,62926,32.63,0.78,32.9,21757,74.2,NULL,'SALT 2','NGC 2930',0.022012,'2010ApJ...716..712A',2010,1,0.7,'RC3 has V_sun = 6599 +- 60 km/s.','G',0.000047,NULL,'15.10',0.4,'S?','Group member',NULL,NULL,'Emission-Line Galaxy',1,144.385833,23.2025,0.045,NULL,63748565398,996071334,15563614,15.1),(62927,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 2005M',NULL,62927,34.89,0.02,94.9,21757,72,NULL,'M(H) = -18.317 mag','NGC 2930',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62928,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 2005M',NULL,62928,34.97,0.31,96.1,21757,73.8,NULL,'SALT 2 (SNANA)','NGC 2930',0.0259,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62929,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 2005M',NULL,62929,35,0.01,100,21757,72,NULL,NULL,'NGC 2930',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62930,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 2005M',NULL,62930,35.05,0.15,100,21757,72,NULL,NULL,'NGC 2930',0.022012,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62931,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 2005M',NULL,62931,35.07,0.1,103,21757,74.4,NULL,NULL,'NGC 2930',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62932,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 2005M',NULL,62932,35.19,0.15,104,21757,72,NULL,NULL,'NGC 2930',0.0256,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62933,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 2005M',NULL,62933,35.13,0.03,104,21757,72,NULL,NULL,'NGC 2930',0.022012,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62934,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 2005M',NULL,62934,35.18,0.16,106,21757,70,NULL,'SALT 2','NGC 2930',0.022012,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62935,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 2005M',NULL,62935,35.23,0.2,109,21757,73.8,NULL,'SALT 2 (SNANA)','NGC 2930',0.0233,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62936,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62936,37.65,0.46,340,21758,70,NULL,NULL,'2MASX J09373260+0743271',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000137,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,144.385833,7.72433,0.097,NULL,60710155664,948596182,14821815,17.9),(62937,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62937,36.04,0.46,161,21759,70,NULL,NULL,'I Zw 019',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,144.3867917,48.64364,0.037,NULL,64017586341,1000274786,15629293,16.5),(62938,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62938,36.13,0.53,169,21760,70,NULL,NULL,'2MASX J09373404-2051344',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.96',0.4,NULL,NULL,NULL,NULL,NULL,1,144.391875,-20.85969,0.125,NULL,42345488243,661648253,10338253,15.96),(62939,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62939,37.66,0.46,341,21761,70,NULL,NULL,'2MASX J09373624+0755051',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,144.400958333,7.91803,0.061,NULL,60710137861,948595904,14821811,17.1),(62940,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62940,38.15,0.46,426,21762,70,NULL,NULL,'2MASX J09373632+2145251',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,144.401375,21.75692,0.049,NULL,63747658627,996057166,15563393,17.9),(62941,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62941,36.2,0.46,174,21763,70,NULL,NULL,'2MASX J09373716+1333060',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.80',0.26,NULL,NULL,NULL,NULL,NULL,1,144.404958333,13.55156,0.057,NULL,63720368235,995630753,15556730,17.8),(62942,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62942,35.87,0.53,149,21764,70,NULL,NULL,'2MASX J09373737-2032024',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,144.4057917,-20.534,0.125,NULL,42345333627,661645837,10338216,15.1),(62943,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62943,37.66,0.46,341,21765,70,NULL,NULL,'2MASX J09373857+0645531',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,144.41075,6.76481,0.129,NULL,60709186623,948581040,14821578,17.2),(62944,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62944,37.64,0.46,337,21766,70,NULL,NULL,'2MASX J09373903+4137252',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00018,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,144.41275,41.62369,0.025,NULL,64260651971,1004072687,15688635,17.2),(62945,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62945,35.55,0.81,129,21767,70,NULL,NULL,'2MASX J09374009-3653243',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,144.417,-36.89019,0.877,NULL,42852115073,669564298,10461942,14.9),(62946,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62946,37.63,0.46,336,21768,70,NULL,NULL,'2MASX J09374092+1146191',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,144.420417,11.77211,0.085,NULL,60885556718,951336823,14864637,17.1),(62947,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62947,34.27,0.4,71.3,21769,NULL,NULL,'mean','NGC 2945',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.00005,NULL,'13.22',1.2,'SA0-:          AGN',NULL,NULL,NULL,NULL,1,144.421375,-22.03506,0.125,NULL,42334439993,661475624,10335556,13.22),(62948,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62948,34.82,0.45,92,21769,NULL,NULL,'K','NGC 2945',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62949,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62949,38.12,0.46,420,21770,70,NULL,NULL,'2MASX J09374364+3128342',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,144.432083,31.47625,0,NULL,64209093197,1003267081,15676048,17.5),(62950,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62950,37.46,0.46,311,21771,70,NULL,NULL,'2MASX J09374400+2209533',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,144.4334583,22.16481,0.049,NULL,63748277236,996066831,15563544,18),(62951,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62951,37.09,0.46,262,21772,70,NULL,NULL,'2MASX J09374404+0055234',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000084,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,144.433583333,0.92322,0.133,NULL,60686016292,948219004,14815921,16.7),(62952,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62952,38.37,0.46,473,21773,70,NULL,NULL,'SDSS J093746.30+061926.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000123,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,144.442958333,6.32417,0.105,NULL,60709265781,948582277,14821598,18.4),(62953,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62953,34.37,0.49,74.7,21774,75,NULL,'IR','MCG -02-25-008',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.00015,NULL,'14.5',0.4,'Sbc:',NULL,NULL,NULL,NULL,1,144.44475,-10.97389,0.125,NULL,41309157231,645455581,10085243,14.5),(62954,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62954,34.48,0.4,78.6,21774,NULL,NULL,'mean','MCG -02-25-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62955,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62955,34.55,0.47,81.4,21774,NULL,NULL,'H','MCG -02-25-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62956,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62956,34.6,0.46,83,21774,NULL,NULL,'J','MCG -02-25-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62957,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62957,34.6,0.42,83.1,21774,NULL,NULL,'Malmquist cor.','MCG -02-25-008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62958,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62958,34.66,0.45,85.5,21774,NULL,NULL,'K','MCG -02-25-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62959,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62959,34.69,0.2,86.7,21774,74.4,NULL,NULL,'MCG -02-25-008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62960,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62960,34.92,0.36,96.3,21774,NULL,NULL,NULL,'MCG -02-25-008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62961,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62961,36.56,0.23,205,21775,70,NULL,NULL,'2MASX J09374720+5149499',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,144.446791667,51.83047,0.009,NULL,63966227459,999472304,15616754,16.8),(62962,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62962,37.31,0.46,290,21776,70,NULL,NULL,'2MASX J09374744+1010241',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,144.447833333,10.17347,0.053,NULL,60886181545,951346586,14864790,17),(62963,'IRAS','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62963,32.64,0.8,33.7,21777,75,NULL,'MAT, I','UGCA 170',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000022,NULL,'14.24',1.4,'SB(rs)d',NULL,NULL,NULL,NULL,1,144.45375,-22.40361,0.157,NULL,42336452414,661507068,10336047,14.24),(62964,'Tully est','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62964,32.54,0.8,32.2,21777,75,NULL,NULL,'UGCA 170',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62965,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62965,32.24,0.4,28.1,21777,NULL,NULL,NULL,'UGCA 170',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62966,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62966,32.24,0.32,28.1,21777,85,NULL,'I, inv','UGCA 170',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62967,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62967,32.25,0.32,28.2,21777,85,NULL,'I, raw','UGCA 170',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62968,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62968,32.55,0.43,32.3,21777,75,NULL,'MAT, I, raw','UGCA 170',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62969,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62969,32.55,0.43,32.4,21777,75,NULL,'MAT, I, inv','UGCA 170',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62970,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62970,32.81,0.43,36.5,21777,75,NULL,'MAT, I, cor','UGCA 170',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62971,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62971,36.26,0.33,178,21778,70,NULL,NULL,'2MASX J09375348+3857202',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.00018,NULL,'15.4g',0.46,'E0',NULL,NULL,NULL,NULL,1,144.4727917,38.9555,0,NULL,64391648172,1006119502,15720617,15.4),(62972,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62972,37.64,0.46,337,21779,70,NULL,NULL,'2MASX J09375407+2959413',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00017,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,144.475333333,29.99481,0.025,NULL,64222229598,1003472337,15679255,17.2),(62973,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62973,37.46,0.46,310,21780,70,NULL,NULL,'SDSS J093755.25+000117.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,144.4802083,0.02167,0.113,NULL,60685697946,948214030,14815844,18.1),(62974,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62974,36.08,0.27,164,21781,70,NULL,NULL,'2MASX J09375534+1705337',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000151,NULL,'16.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,144.480625,17.09278,0.029,NULL,63733197474,995831210,15559862,16.4),(62975,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62975,37.8,0.46,364,21782,70,NULL,NULL,'2MASX J09375593+3639402',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,144.48325,36.66106,0,NULL,64174941013,1002733453,15667710,18),(62976,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62976,36.78,0.46,227,21783,70,NULL,NULL,'2MASX J09375598+5454412',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,144.4832917,54.91158,0.009,NULL,61882159837,966908747,15107949,17.4),(62977,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62977,37.66,0.46,340,21784,70,NULL,NULL,'SDSS J093757.32+013606.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000085,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,144.488833,1.60189,0.113,NULL,60698934078,948420844,14819075,18),(62978,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 2001fe',NULL,62978,33.19,0.21,42.9,21785,74.2,NULL,'SALT 2','UGC 05129',0.013539,'2010ApJ...716..712A',2010,1,1.27,NULL,'G',0.00002,NULL,'14.0g',0.69,'Sa',NULL,NULL,NULL,NULL,1,144.491667,25.49478,0,NULL,64210843969,1003294437,15676475,14),(62979,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 2001fe',NULL,62979,33.78,0.02,56.3,21785,70,NULL,'SALT 2','UGC 05129',0.013539,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62980,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 2001fe',NULL,62980,33.77,0.09,56.8,21785,74.4,NULL,NULL,'UGC 05129',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62981,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 2001fe',NULL,62981,33.81,0.03,57,21785,72,NULL,'SALT2','UGC 05129',0.013539,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62982,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 2001fe',NULL,62982,33.93,0.19,60.1,21785,73.8,NULL,'SALT 2 (SNANA)','UGC 05129',0.0146,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62983,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 2001fe',NULL,62983,33.99,0.21,62,21785,70,NULL,'SALT 2','UGC 05129',0.013539,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62984,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 2001fe',NULL,62984,34.08,0.25,64.5,21785,65,NULL,'SALT2','UGC 05129',0.013539,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62985,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 2001fe',NULL,62985,34.1,0.23,65.2,21785,65,NULL,'MLCS17','UGC 05129',0.013539,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62986,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 2001fe',NULL,62986,34.12,0.23,65.9,21785,65,NULL,'MLCS31','UGC 05129',0.013539,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62987,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62987,33,0.69,39.9,21785,100,NULL,'mid-IR','UGC 05129',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62988,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62988,33.86,0.47,59.3,21785,NULL,NULL,'H','UGC 05129',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62989,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62989,33.98,0.4,62.5,21785,NULL,NULL,'mean','UGC 05129',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62990,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62990,34.05,0.46,64.7,21785,NULL,NULL,'J','UGC 05129',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62991,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62991,34.08,0.45,65.5,21785,NULL,NULL,'K','UGC 05129',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62992,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62992,35.07,0.46,103,21786,NULL,NULL,NULL,'ESO 565- G 031',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000013,NULL,'15',0.6,'(R\'_2)SB(s)b',NULL,NULL,NULL,NULL,1,144.505541667,-20.85986,0.125,NULL,42345447129,661647611,10338243,15),(62993,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62993,35.11,0.2,105,21786,74.4,NULL,NULL,'ESO 565- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62994,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62994,35.19,0.43,109,21786,NULL,NULL,'Malmquist cor.','ESO 565- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62995,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62995,38.3,0.46,458,21787,70,NULL,NULL,'2MASX J09380171+0602008',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,144.5072917,6.03369,0.097,NULL,60716865952,948701030,14823453,17.7),(62996,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,62996,35.44,0.69,122,21788,70,NULL,NULL,'2MASX J09380177-1651339',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.30',0.2,NULL,NULL,NULL,NULL,NULL,1,144.507541667,-16.85933,0.245,NULL,42311831345,661122364,10330036,16.3),(62997,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62997,35.94,0.46,154,21789,70,NULL,NULL,'CGCG 210-019',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000189,NULL,'15.3g',0.39,'E0',NULL,NULL,NULL,NULL,1,144.516,42.97431,0.005,NULL,63973725530,999589461,15618585,15.3),(62998,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62998,37.01,0.46,252,21790,70,NULL,NULL,'2MASX J09380471+5226366',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00019,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,144.5197083,52.44344,0.005,NULL,63966020899,999469076,15616704,16.4),(62999,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',62999,35.18,0.46,109,21791,70,NULL,NULL,'NGC 2940',NULL,'2015arXiv151105856S',2015,1,0.91,NULL,'G',0.000093,NULL,'14.5g',0.81,'S0?','in a pair',NULL,NULL,NULL,1,144.521625,9.61672,0.069,NULL,60885814210,951340847,14864700,14.5),(63000,'Tully est','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63000,33.09,0.8,41.6,21791,75,NULL,'B','NGC 2940',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63001,'SGRB','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63001,38.73,NULL,557,21792,71,NULL,NULL,'SDSS J093805.34+153719.0',NULL,'2010ApJ...709..664R',2010,1,0.04,NULL,'G',0.0001,NULL,'21.0r',0.01,'S',NULL,NULL,NULL,NULL,1,144.52225,15.62197,0.069,NULL,63735328826,995864512,15560383,21),(63002,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63002,36.76,0.46,225,21793,70,NULL,NULL,'2MASX J09380574+6358134',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'17.05',0.35,NULL,NULL,NULL,NULL,NULL,1,144.523583,63.97056,0.129,NULL,62257122074,972767532,15199492,17.05),(63003,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63003,37.3,0.46,288,21794,70,NULL,NULL,'SDSS J093805.92+253336.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000134,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,144.524708333,25.56014,0.009,NULL,64210835857,1003294310,15676473,18.2),(63004,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63004,35.64,0.46,134,21795,70,NULL,NULL,'2MASX J09380611+4017451',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000176,NULL,'15.6g',0.48,'E0',NULL,NULL,NULL,NULL,1,144.525291667,40.29603,0,NULL,64257461186,1004022831,15687856,15.6),(63005,'IRAS','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63005,32.75,0.8,35.5,21796,75,NULL,'MAT, I','ESO 373- G 012',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000013,NULL,'13.53',1.1,'SAB(s)dm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,144.531541667,-33.92761,0.737,NULL,42862068929,669719827,10464372,13.53),(63006,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63006,31.55,0.32,20.4,21796,85,NULL,'I, inv','ESO 373- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63007,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63007,31.58,0.32,20.7,21796,85,NULL,'I, raw','ESO 373- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63008,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63008,31.95,0.43,24.5,21796,75,NULL,'MAT, I, inv','ESO 373- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63009,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63009,32.03,0.43,25.4,21796,75,NULL,'MAT, I, raw','ESO 373- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63010,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63010,32.42,0.43,30.4,21796,75,NULL,'MAT, I, cor','ESO 373- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63011,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63011,32.5,0.4,31.6,21796,NULL,NULL,NULL,'ESO 373- G 012',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63012,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63012,32.86,0.54,37.3,21796,NULL,NULL,'Malmquist cor.','ESO 373- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63013,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63013,32.92,0.53,38.4,21796,NULL,NULL,NULL,'ESO 373- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63014,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63014,32.96,0.2,39.1,21796,74.4,NULL,NULL,'ESO 373- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63015,'IRAS','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63015,33.5,0.8,50,21797,75,NULL,'CF, r','NGC 2939',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.000017,NULL,'13.15',0.7,'Sb-c','Possible field galaxy',NULL,NULL,NULL,1,144.533625,9.52153,0.069,NULL,60885586004,951337281,14864645,13.15),(63016,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63016,32.88,0.47,37.7,21797,NULL,NULL,'H','NGC 2939',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63017,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63017,32.92,0.46,38.3,21797,NULL,NULL,'J','NGC 2939',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63018,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63018,32.93,0.45,38.5,21797,NULL,NULL,'K','NGC 2939',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63019,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63019,32.98,0.2,39.5,21797,74.4,NULL,NULL,'NGC 2939',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63020,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63020,33.2,0.36,43.6,21797,NULL,NULL,NULL,'NGC 2939',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63021,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63021,33.25,0.35,44.8,21797,NULL,NULL,'Malmquist cor.','NGC 2939',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63022,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63022,33.4,0.4,47.8,21797,NULL,NULL,'mean','NGC 2939',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63023,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63023,33.43,0.38,48.5,21797,75,NULL,'CF, r, raw','NGC 2939',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63024,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63024,33.57,0.38,51.9,21797,75,NULL,'CF, r, inv','NGC 2939',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63025,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63025,33.65,0.38,53.6,21797,75,NULL,'CF, r, cor','NGC 2939',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63026,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63026,37.24,0.46,281,21798,70,NULL,NULL,'2MASX J09380837+1107478',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,144.535,11.13003,0.061,NULL,60888347226,951380425,14865319,16.8),(63027,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63027,37.05,0.46,257,21799,70,NULL,NULL,'2MASX J09380859+0713298',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,144.535833,7.22506,0.105,NULL,60708861103,948575954,14821499,17.8),(63028,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63028,37.75,0.46,355,21800,70,NULL,NULL,'2MASX J09381041+2232289',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000154,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,144.543375,22.54153,0.045,NULL,63749105322,996079770,15563746,18.3),(63029,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63029,37.28,0.46,286,21801,70,NULL,NULL,'2MASX J09381043+6438334',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,144.543625,64.64275,0.121,NULL,62257932076,972780188,15199690,16.8),(63030,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63030,36.6,0.46,209,21802,70,NULL,NULL,'2MASX J09381080+2753343',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,144.545125,27.89294,0.013,NULL,64213952418,1003343006,15677234,17.1),(63031,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63031,34.39,0.46,75.7,21803,70,NULL,NULL,'CGCG 035-017',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000167,NULL,'15.5g',0.39,'E/S0     Cand. BLAGN',NULL,NULL,NULL,NULL,1,144.551125,7.72778,0.057,NULL,60709992571,948593633,14821775,15.5),(63032,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63032,37.76,0.46,357,21804,70,NULL,NULL,'2MASX J09381257+1155038',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000148,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,144.5522917,11.91775,0.085,NULL,60885416226,951334628,14864603,17.3),(63033,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63033,38.01,0.46,401,21805,70,NULL,NULL,'2MASX J09381315+2147569',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,144.554666667,21.79919,0.049,NULL,63747685700,996057589,15563399,17.3),(63034,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63034,30.82,0.43,14.6,21806,75,NULL,'3.6 micron, color + selection bias corrected','ESO 091- G 016',NULL,'2014MNRAS.444..527S',2014,1,1.5,NULL,'G',0.0001,NULL,'14.12',0.4,'Sb? sp',NULL,NULL,NULL,NULL,1,144.556791667,-63.48656,NULL,NULL,40569451928,633897686,9904651,14.12),(63035,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63035,31.14,0.43,16.9,21806,75,NULL,'3.6 micron, color corrected','ESO 091- G 016',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63036,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63036,31.34,0.2,18.5,21806,74.4,NULL,NULL,'ESO 091- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63037,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63037,31.43,0.4,19.4,21806,75,NULL,NULL,'ESO 091- G 016',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63038,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63038,31.44,0.4,19.4,21806,73,NULL,'IR','ESO 091- G 016',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63039,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63039,31.56,0.47,20.5,21806,NULL,NULL,'H','ESO 091- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63040,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63040,31.56,0.45,20.5,21806,NULL,NULL,'K','ESO 091- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63041,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63041,31.67,0.46,21.6,21806,NULL,NULL,'J','ESO 091- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63042,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63042,31.86,0.49,23.5,21806,75,NULL,'IR','ESO 091- G 016',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63043,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63043,32.14,0.4,26.7,21806,NULL,NULL,'mean','ESO 091- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63044,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63044,36.56,0.23,205,21807,70,NULL,NULL,'SDSS J093815.09+520155.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,144.562917,52.03203,0.013,NULL,63966267691,999472932,15616764,17.8),(63045,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63045,38.21,0.46,438,21808,70,NULL,NULL,'2MASX J09381755+3128051',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000158,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,144.573083333,31.46808,0.005,NULL,64220957278,1003452457,15678944,17.7),(63046,'Tully est','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63046,32.52,0.8,31.9,21809,75,NULL,NULL,'ESO 315- G 017',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000023,NULL,'14.28',1.5,'SA(r)cd',NULL,NULL,NULL,NULL,1,144.58125,-39.00861,NULL,NULL,42883390188,670052971,10469577,14.28),(63047,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63047,34.13,0.47,66.9,21810,NULL,NULL,'H','ESO 061- G 011',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000033,NULL,'14.82',0.3,'S              HII',NULL,NULL,NULL,NULL,1,144.5814583,-70.09128,0.569,NULL,40713601455,636150022,9939844,14.82),(63048,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63048,34.17,0.45,68.3,21810,NULL,NULL,'K','ESO 061- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63049,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63049,34.24,0.46,70.6,21810,NULL,NULL,'J','ESO 061- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63050,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63050,34.42,0.49,76.4,21810,75,NULL,'IR','ESO 061- G 011',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63051,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63051,34.49,0.4,79.1,21810,NULL,NULL,'mean','ESO 061- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63052,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63052,34.57,0.36,82,21810,NULL,NULL,'Malmquist cor.','ESO 061- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63053,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63053,34.91,0.31,96.1,21810,NULL,NULL,NULL,'ESO 061- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63054,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63054,34.96,0.2,98.2,21810,74.4,NULL,NULL,'ESO 061- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63055,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63055,35.32,0.46,116,21811,70,NULL,NULL,'2MASX J09382127+5506254',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000069,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,144.588666667,55.107,0.013,NULL,61882673822,966916778,15108074,16.5),(63056,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63056,37.11,0.46,264,21812,70,NULL,NULL,'SDSS J093822.51+114905.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000147,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,144.593833,11.81819,0.085,NULL,60885532918,951336451,14864632,18.4),(63057,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63057,35.67,0.46,136,21813,70,NULL,NULL,'2MASX J09382252+3301521',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000179,NULL,'15.7g',0.39,NULL,NULL,NULL,NULL,NULL,1,144.594,33.03128,0.009,NULL,64178222298,1002784723,15668511,15.7),(63058,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63058,33.84,0.46,58.5,21814,70,NULL,NULL,'UGC 05133',NULL,'2015arXiv151105856S',2015,1,1.26,NULL,'G',0.00016,NULL,'14.3g',0.42,'S0',NULL,NULL,NULL,NULL,1,144.597375,43.50917,0.021,NULL,63973658480,999588413,15618568,14.3),(63059,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63059,32.42,0.4,30.5,21815,NULL,NULL,NULL,'NGC 2938',NULL,'2009AJ....138..323T',2009,1,1.7,NULL,'G',0.000037,NULL,'14.20',1,'SB(rs)cd',NULL,NULL,NULL,NULL,1,144.599125,76.31956,0.013,NULL,61411328955,959552014,14993000,14.2),(63060,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63060,33.09,0.43,41.4,21815,75,NULL,'3.6 micron, color corrected','NGC 2938',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63061,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63061,33.09,0.43,41.4,21815,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2938',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63062,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63062,33.21,0.2,43.9,21815,74.4,NULL,NULL,'NGC 2938',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63063,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63063,33.61,0.38,52.7,21815,NULL,NULL,NULL,'NGC 2938',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63064,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63064,33.69,0.36,54.8,21815,NULL,NULL,'Malmquist cor.','NGC 2938',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63065,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63065,38.09,0.46,414,21816,70,NULL,NULL,'2MASX J09382545+3455161',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,144.606,34.92119,0,NULL,64187907476,1002936054,15670875,18.2),(63066,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63066,36.75,0.46,224,21817,70,NULL,NULL,'2MASX J09382574+3622061',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,144.607333333,36.36836,0,NULL,64174301291,1002723457,15667554,16.8),(63067,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63067,36.87,0.46,237,21818,70,NULL,NULL,'2MASX J09382651+2639532',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,144.610458333,26.66472,0.009,NULL,64210935012,1003295859,15676497,16.9),(63068,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63068,35.69,0.68,137,21819,70,NULL,NULL,'2MASX J09382823-0757293',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.93',NULL,NULL,NULL,NULL,NULL,NULL,1,144.617583333,-7.95828,0.117,NULL,41093990657,642093604,10032712,16.93),(63069,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63069,35.16,0.2,108,21820,74.4,NULL,NULL,'CGCG 063-025',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00013,NULL,'15.5',0.4,NULL,NULL,NULL,NULL,NULL,1,144.619125,13.54522,0.057,NULL,63720179563,995627805,15556684,15.5),(63070,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63070,37.19,0.46,275,21821,70,NULL,NULL,'2MASX J09382871+5501303',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000078,NULL,'16.9g',0.32,NULL,NULL,NULL,NULL,NULL,1,144.619583,55.02522,0.009,NULL,61882681414,966916897,15108076,16.9),(63071,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63071,36.95,0.33,245,21822,70,NULL,NULL,'2MASX J09382963+2510242',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,144.62325,25.17336,0,NULL,64164506017,1002570406,15665162,17.4),(63072,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63072,38.18,0.46,432,21823,70,NULL,NULL,'2MASX J09383228+0005013',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,144.634625,0.08369,0.113,NULL,60685594820,948212419,14815819,17.7),(63073,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63073,37.88,0.46,377,21824,70,NULL,NULL,'2MASX J09383281+0029333',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,144.636708333,0.49258,0.097,NULL,60685679385,948213740,14815839,17.7),(63074,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63074,36.08,0.27,164,21825,70,NULL,NULL,'NGC 2943',NULL,'2015arXiv151105856S',2015,1,2.2,NULL,'G',0.00009,NULL,'13.42',1.2,'E','Possible field galaxy',NULL,NULL,NULL,1,144.636958333,17.03131,0.029,NULL,63733015874,995828373,15559818,13.42),(63075,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63075,36.01,0.46,159,21826,70,NULL,NULL,'VIII Zw 050',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000137,NULL,'15.5g',0.5,'E0',NULL,NULL,NULL,NULL,1,144.6370417,10.34178,0.045,NULL,60886383109,951349736,14864839,15.5),(63076,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 2008bc',NULL,63076,34.05,0.15,62.6,21827,72,NULL,NULL,'KK 1524',0.01572,'2013ApJ...773...53F',2013,1,0.9,NULL,'G',0.00012,NULL,'15.4',0.67,'S',NULL,NULL,NULL,NULL,1,144.642125,-63.97294,NULL,NULL,40752923355,636764427,9949444,15.4),(63077,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 2008bc',NULL,63077,34.06,0.16,63.8,21827,73.8,NULL,'SALT 2 (SNANA)','KK 1524',0.016,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63078,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 2008bc',NULL,63078,34.06,0.02,64.9,21827,72,NULL,'M(H) = -18.317 mag','KK 1524',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63079,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63079,38.08,0.46,414,21828,70,NULL,NULL,'2MASX J09383520+0353303',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,144.6467083,3.89186,0.065,NULL,60691502902,948304732,14817261,17.7),(63080,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63080,36.95,0.33,245,21829,70,NULL,NULL,'2MASX J09383559+2507432',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,144.648333,25.12853,0,NULL,64164515601,1002570556,15665164,16.9),(63081,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63081,36.05,0.46,163,21830,70,NULL,NULL,'MCG +09-16-034',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000171,NULL,'15.8g',0.4,'S0',NULL,NULL,NULL,NULL,1,144.651167,52.29494,0,NULL,63966073166,999469893,15616717,15.8),(63082,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63082,37.72,0.46,351,21831,70,NULL,NULL,'2MASX J09383633+3740020',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,144.651417,37.66711,0,NULL,64174488171,1002726377,15667599,17.4),(63083,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63083,37.94,0.33,387,21832,70,NULL,NULL,'SDSS J093837.07+621102.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000076,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,144.6545,62.18411,0.073,NULL,62041280294,969395004,15146796,18.5),(63084,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63084,36.2,0.46,174,21833,70,NULL,NULL,'2MASX J09383793+6601490',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,144.658125,66.03019,0.093,NULL,62259469780,972804215,15200065,17.5),(63085,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63085,37.53,0.33,321,21834,70,NULL,NULL,'2MASX J09383901+0200223',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000081,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,144.6625,2.00622,0.097,NULL,60698653957,948416468,14819007,17.2),(63086,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63086,36.08,0.27,164,21835,70,NULL,NULL,'2MASX J09383930+1702047',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000182,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,144.663917,17.03461,0.029,NULL,63733018506,995828414,15559818,16.5),(63087,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63087,36.05,0.53,162,21836,70,NULL,NULL,'ESO 373- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000097,NULL,'14.1R',0.9,'S0',NULL,NULL,NULL,NULL,1,144.6687917,-35.56856,0.837,NULL,42863475721,669741808,10464715,14.1),(63088,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63088,35.53,0.57,127,21837,70,NULL,NULL,'ESO 565- G 032',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'15.45',0.5,'S0',NULL,NULL,NULL,NULL,1,144.669667,-19.89603,0.101,NULL,42343320477,661614382,10337724,15.45),(63089,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63089,36.56,0.23,205,21838,70,NULL,NULL,'CGCG 265-029',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000133,NULL,'15.3g',0.49,'E0',NULL,NULL,NULL,NULL,1,144.671417,51.82611,0.009,NULL,63966192033,999471750,15616746,15.3),(63090,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63090,36.98,0.46,249,21839,70,NULL,NULL,'2MASX J09384215+6340228',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,144.675917,63.673,0.053,NULL,62026456753,969163386,15143177,17.3),(63091,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63091,36.81,0.46,231,21840,70,NULL,NULL,'2MASX J09384242+2933593',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00014,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,144.6767917,29.56653,0.009,NULL,64222575410,1003477740,15679339,17.4),(63092,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63092,37.53,0.33,321,21841,70,NULL,NULL,'2MASX J09384248+0158563',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000082,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,144.6769583,1.98219,0.097,NULL,60698642237,948416284,14819004,17.7),(63093,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 1995M',NULL,63093,37.17,0.15,258,21842,65,NULL,NULL,'2MFGC 07478',0.052,'2004ApJ...607..665R',2004,1,NULL,NULL,'G',0.00015,NULL,'12.9K',NULL,NULL,NULL,NULL,NULL,NULL,1,144.677791667,-12.33553,0.141,NULL,41171883732,643310683,10051729,12.9),(63094,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 1995M',NULL,63094,37.12,0.15,265,21842,65,NULL,'Snapshot','2MFGC 07478',NULL,'1998ApJ...504..935R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63095,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63095,36.59,0.46,208,21843,70,NULL,NULL,'2MASX J09384334+4140159',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00019,NULL,'16.0g',0.41,'S0',NULL,NULL,NULL,NULL,1,144.680417,41.67122,0.021,NULL,64260439779,1004069371,15688583,16),(63096,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63096,37.47,0.46,312,21844,70,NULL,NULL,'2MASX J09384426+5141080',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000178,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,144.684583,51.68572,0.005,NULL,63966198566,999471852,15616747,16.9),(63097,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63097,37.44,0.21,308,21845,70,NULL,NULL,'2MASX J09384556+6037508',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000076,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,144.6897083,60.63069,0.049,NULL,62035523582,969305055,15145391,17.2),(63098,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63098,36.36,0.46,187,21846,70,NULL,NULL,'2MASX J09384745+3145411',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000161,NULL,'17.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,144.697583333,31.76131,0,NULL,64220140220,1003439690,15678745,17),(63099,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63099,36.81,0.79,230,21847,70,NULL,NULL,'2MASX J09384814-1920438',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,144.700667,-19.3455,0.117,NULL,42338749490,661542960,10336608,15.7),(63100,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63100,37.95,0.46,389,21848,70,NULL,NULL,'2MASX J09384918+1643487',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000138,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,144.7047917,16.73017,0.041,NULL,63735910054,995873594,15560524,18),(63101,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63101,38.51,0.46,504,21849,70,NULL,NULL,'2MASX J09384961+1041159',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,144.7067917,10.68764,0.045,NULL,60888264249,951379128,14865298,18.2),(63102,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63102,37.63,0.46,336,21850,70,NULL,NULL,'2MASX J09385050+0741169',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000158,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,144.710375,7.68792,0.069,NULL,60709930581,948592665,14821760,16.9),(63103,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63103,37.94,0.33,387,21851,70,NULL,NULL,'2MASX J09385086+6210037',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000086,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,144.711708333,62.16786,0.073,NULL,62041279378,969394990,15146796,16.8),(63104,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63104,38.4,0.46,478,21852,70,NULL,NULL,'2MASX J09385180+2834373',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000142,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,144.715667,28.57711,0.013,NULL,64213748852,1003339825,15677184,17.7),(63105,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63105,37.7,0.46,347,21853,70,NULL,NULL,'2MASX J09385260+0550213',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000145,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,144.7190417,5.83922,0.085,NULL,60716964647,948702572,14823477,18.2),(63106,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63106,36.27,0.57,180,21854,70,NULL,NULL,'2MASX J09385313-2527275',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.0I',0.2,NULL,NULL,NULL,NULL,NULL,1,144.721333,-25.45767,0.185,NULL,42819762715,669058792,10454043,14),(63107,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 2003D',NULL,63107,34.67,0.1,85.9,21855,74.4,NULL,NULL,'ARP 321 NED01',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.00009,NULL,'13.77',1,'E1','in an interacting quintet',NULL,NULL,NULL,1,144.723125,-4.84928,0.117,NULL,41113418513,642397164,10037455,13.77),(63108,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 2003D',NULL,63108,34.88,0.22,92.7,21855,65,NULL,'MLCS31','ARP 321 NED01',0.022109,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63109,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 2003D',NULL,63109,34.98,0.19,97.1,21855,65,NULL,'MLCS17','ARP 321 NED01',0.022109,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63110,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 2003D',NULL,63110,35.06,0.18,100,21855,70,NULL,'SALT 2','ARP 321 NED01',0.022109,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63111,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63111,34.49,0.45,79.1,21855,NULL,NULL,'K','ARP 321 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63112,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63112,34.92,0.4,96.4,21855,NULL,NULL,'mean','ARP 321 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63113,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63113,38.12,0.46,420,21856,70,NULL,NULL,'SDSS J093854.32+143348.4',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,144.726375,14.56347,0.089,NULL,63721726470,995651976,15557062,17.5),(63114,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63114,35.57,0.67,130,21857,70,NULL,NULL,'2MASX J09385470-0736460',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,144.727917,-7.61281,0.117,NULL,41092120815,642064387,10032256,14.6),(63115,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63115,36.68,0.46,217,21858,70,NULL,NULL,'SDSS J093855.67+041220.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,144.732,4.20564,0.069,NULL,60690989998,948296718,14817136,18),(63116,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63116,32.84,NULL,37,21859,NULL,NULL,NULL,'SDSS J093857.12+004133.5',NULL,'2015AstBu..70....1K',2015,1,0.02,NULL,'G',0.000295,NULL,'23.4g',0.02,NULL,NULL,NULL,NULL,NULL,1,144.7380417,0.69264,0.137,NULL,60686744147,948230377,14816099,23.4),(63117,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63117,38.11,0.33,418,21860,70,NULL,NULL,'2MASX J09385803+2154477',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,144.7419583,21.91328,0.049,NULL,63747905613,996061025,15563453,17.9),(63118,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63118,35.97,0.46,156,21861,70,NULL,NULL,'2MASX J09385850+0409401',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000172,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,144.74375,4.16128,0.069,NULL,60690960358,948296255,14817128,16.4),(63119,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63119,38.36,0.46,470,21862,70,NULL,NULL,'2MASX J09385914+0208081',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000086,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,144.746333,2.13544,0.097,NULL,60698603375,948415677,14818994,17.8),(63120,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63120,33.44,0.69,48.8,21863,100,NULL,'mid-IR','NGC 2948',NULL,'2013ApJ...771...88L',2013,1,1.72,NULL,'G',0.00003,NULL,'13.5g',0.81,'SBbc','Field galaxy',NULL,NULL,NULL,1,144.746625,6.95544,0.129,NULL,60708804023,948575062,14821485,13.5),(63121,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63121,34.11,0.46,66.3,21863,NULL,NULL,'J','NGC 2948',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63122,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63122,34.13,0.47,67,21863,NULL,NULL,'H','NGC 2948',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63123,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63123,34.16,0.45,67.8,21863,NULL,NULL,'K','NGC 2948',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63124,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63124,34.21,0.2,69.5,21863,74.4,NULL,NULL,'NGC 2948',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63125,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63125,34.41,0.4,76.1,21863,NULL,NULL,'mean','NGC 2948',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63126,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63126,37.29,0.46,287,21864,70,NULL,NULL,'2MASX J09385980+6612140',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,144.7489583,66.20392,0.093,NULL,62248977532,972640273,15197504,NULL),(63127,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63127,33.46,0.62,49.1,21865,70,NULL,NULL,'MRK 1234',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.0',0.5,'S0',NULL,NULL,NULL,NULL,1,144.7560417,-9.45728,0.133,NULL,41319380951,645615327,10087739,16),(63128,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63128,35.68,0.4,137,21866,NULL,NULL,'mean','NGC 2946',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000033,NULL,'14.90',0.4,'SB?','Group member',NULL,NULL,NULL,1,144.756583333,17.02533,0.057,NULL,63733038048,995828719,15559823,14.9),(63129,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63129,35.8,0.47,144,21866,NULL,NULL,'H','NGC 2946',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63130,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63130,38.06,0.46,409,21867,70,NULL,NULL,'SDSS J093902.10+061709.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,144.7587917,6.28592,0.097,NULL,60708574921,948571483,14821429,18.2),(63131,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63131,37.36,0.46,297,21868,70,NULL,NULL,'SDSS J093903.43+085303.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,144.764333,8.88431,0.081,NULL,60891064420,951422881,14865982,18),(63132,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63132,37.7,0.46,346,21869,70,NULL,NULL,'2MASX J09390405+3859294',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000149,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,144.7667917,38.99139,0,NULL,64391971431,1006124553,15720696,17.5),(63133,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63133,35.16,0.67,107,21870,70,NULL,NULL,'ESO 373- G 016',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'13.4I',0.4,'Sb',NULL,NULL,NULL,NULL,1,144.77075,-36.65567,0.833,NULL,42852123171,669564424,10461944,13.4),(63134,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63134,37.5,0.46,317,21871,70,NULL,NULL,'2MASX J09390499+3451282',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,144.770791667,34.85789,0.013,NULL,64189002145,1002953158,15671143,17.9),(63135,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63135,37.86,0.46,373,21872,70,NULL,NULL,'2MASX J09390574+2121157',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,144.774167,21.35444,0.061,NULL,63749696610,996089009,15563890,17.6);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (63136,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63136,38.07,0.46,412,21873,70,NULL,NULL,'SDSS J093907.36-003110.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000138,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,144.780667,-0.51967,0.117,NULL,41107962123,642311908,10036123,18.8),(63137,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63137,37.88,0.46,377,21874,70,NULL,NULL,'2MASX J09390780+2658365',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000154,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,144.782417,26.97675,0.005,NULL,64214465010,1003351015,15677359,16.9),(63138,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63138,38.09,0.46,415,21875,70,NULL,NULL,'2MASX J09390787+3935243',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.6g',0.23,'BrClG',NULL,NULL,NULL,NULL,1,144.78275,39.59028,0.021,NULL,64391931688,1006123932,15720686,17.6),(63139,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63139,33.18,0.69,43.2,21876,100,NULL,'mid-IR','NGC 2942',NULL,'2013ApJ...771...88L',2013,1,1.74,NULL,'G',0.000017,NULL,'13.9g',1.04,'SA(s)c:',NULL,NULL,NULL,NULL,1,144.783167,34.00633,0,NULL,64186218302,1002909660,15670463,13.9),(63140,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63140,33.79,0.6,57.3,21876,NULL,NULL,NULL,'NGC 2942',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63141,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63141,33.81,NULL,57.8,21876,NULL,NULL,'B','NGC 2942',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63142,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63142,33.83,0.2,58.3,21876,74.4,NULL,NULL,'NGC 2942',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63143,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63143,33.92,0.56,60.9,21876,NULL,NULL,'Malmquist cor.','NGC 2942',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63144,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63144,37.38,0.46,299,21877,70,NULL,NULL,'2MASX J09390874+3233212',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00017,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,144.786625,32.556,0.017,NULL,64178137967,1002783405,15668490,16.8),(63145,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63145,36.49,0.46,199,21878,70,NULL,NULL,'2MASX J09391074+2423155',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000176,NULL,'16.79',0.35,NULL,NULL,NULL,NULL,NULL,1,144.794833,24.38753,0.025,NULL,63690635597,995166181,15549471,16.79),(63146,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63146,37.5,0.46,316,21879,70,NULL,NULL,'SDSS J093911.76+114325.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000142,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,144.799,11.72364,0.081,NULL,60885234928,951331795,14864559,17.8),(63147,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63147,38.84,0.33,586,21880,70,NULL,NULL,'2MASX J09391214+0346161',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000185,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,144.800625,3.77119,0.065,NULL,60690271755,948285496,14816960,17.2),(63148,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63148,38.55,0.33,514,21881,70,NULL,NULL,'2MASX J09391545+2721055',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000167,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,144.8145,27.35161,0.017,NULL,64214633430,1003353647,15677400,17),(63149,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63149,38.11,0.33,418,21882,70,NULL,NULL,'2MASX J09391565+2153546',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,144.815417,21.89847,0.049,NULL,63747888057,996060750,15563449,17.7),(63150,'TRGB','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63150,27.87,0.32,3.7,21883,NULL,NULL,NULL,'MESSIER 081:[CKT2009] d0939+71',NULL,'2013AJ....146..126C',2013,1,NULL,NULL,'G',NULL,NULL,'20.0B',NULL,'dSph?',NULL,NULL,NULL,NULL,1,144.81625,71.31167,0.049,NULL,62108092268,970438941,15163108,20),(63151,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63151,38.84,0.33,586,21884,70,NULL,NULL,'2MASX J09391776+0345151',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000199,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,144.8240417,3.75406,0.065,NULL,60690269613,948285462,14816960,17.5),(63152,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63152,37.59,0.46,330,21885,70,NULL,NULL,'2MASX J09391929+6151196',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000089,NULL,'17.5g',0.21,'NLAGN',NULL,NULL,NULL,NULL,1,144.8305,61.85556,0.073,NULL,62039798417,969371850,15146435,17.5),(63153,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63153,37.96,0.46,391,21886,70,NULL,NULL,'SDSS J093921.79+051556.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000145,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,144.840833,5.26567,0.089,NULL,60688370588,948255790,14816496,18.5),(63154,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63154,37.67,0.46,342,21887,70,NULL,NULL,'2MASX J09392260+0306258',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000177,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,144.8442917,3.10714,0.073,NULL,60690084156,948282564,14816915,17.7),(63155,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63155,35.84,0.62,147,21888,70,NULL,NULL,'2MASX J09392349-3436468',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00009,NULL,'13.9I',0.4,NULL,NULL,NULL,NULL,NULL,1,144.847917,-34.61306,0.733,NULL,42865523070,669773797,10465215,13.9),(63156,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63156,37.5,0.33,317,21889,70,NULL,NULL,'2MASX J09392425+1859287',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.0002,NULL,'16.0g',0.44,NULL,NULL,NULL,NULL,NULL,1,144.8509583,18.99131,0.089,NULL,63743817105,995997142,15562455,16),(63157,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63157,37.3,0.46,288,21890,70,NULL,NULL,'SDSS J093924.66+112031.4',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,144.8527917,11.34208,0.069,NULL,60888513017,951383015,14865359,17.4),(63158,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63158,37.3,0.46,288,21891,70,NULL,NULL,'2MASX J09392544+2839404',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,144.8560417,28.66114,0.013,NULL,64211912760,1003311136,15676736,17.5),(63159,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63159,36.99,0.46,250,21892,70,NULL,NULL,'2MASX J09392577+2214037',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,144.8572917,22.23433,0.045,NULL,63747825525,996059773,15563433,17.2),(63160,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63160,36.56,0.23,205,21893,70,NULL,NULL,'2MASX J09392606+5201590',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000167,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,144.8587917,52.03317,0.013,NULL,63966167507,999471367,15616740,16.8),(63161,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63161,34.23,0.49,70.2,21894,75,NULL,'IR','UGC 05147',NULL,'2011yCatp016004901K',2011,1,1.19,NULL,'G',0.00019,NULL,'15.9g',0.21,'Scd',NULL,NULL,NULL,NULL,1,144.8627083,38.42994,0,NULL,64391502443,1006117225,15720581,15.9),(63162,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63162,34.44,NULL,77.2,21894,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05147',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63163,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63163,34.45,NULL,77.7,21894,NULL,NULL,'Dipole + Quadrupole','UGC 05147',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63164,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63164,34.46,NULL,78.1,21894,NULL,NULL,'Dipole','UGC 05147',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63165,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63165,34.51,NULL,79.8,21894,NULL,NULL,NULL,'UGC 05147',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63166,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63166,36.75,0.46,224,21895,70,NULL,NULL,'2MASX J09392800+2555334',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000192,NULL,'15.8g',0.45,NULL,NULL,NULL,NULL,NULL,1,144.866708333,25.92608,0,NULL,64211532397,1003305193,15676643,15.8),(63167,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63167,36.98,0.46,249,21896,70,NULL,NULL,'2MASX J09392815+0306428',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,144.8674583,3.11194,0.073,NULL,60690087880,948282623,14816915,17.1),(63168,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63168,35.92,0.62,152,21897,70,NULL,NULL,'2MASX J09392978-3451129',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000097,NULL,'13.5I',0.7,NULL,NULL,NULL,NULL,NULL,1,144.8740417,-34.85364,0.693,NULL,42865378756,669771543,10465180,13.5),(63169,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63169,37.44,0.33,308,21898,70,NULL,NULL,'SDSS J093930.43+523303.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,144.876833,52.55092,0.009,NULL,63966679852,999479372,15616865,18.1),(63170,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63170,34.77,0.49,89.8,21899,75,NULL,'IR','UGC 05148',NULL,'2011yCatp016004901K',2011,1,1.12,'2MASX and SDSS positions both northeast of the galaxy\'s center.','G',0.000011,NULL,'15.5g',0.32,'Sdm',NULL,NULL,NULL,NULL,1,144.889708333,11.51011,0.069,NULL,60888051656,951375807,14865246,15.5),(63171,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63171,34.87,NULL,94.1,21899,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05148',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63172,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63172,34.88,NULL,94.6,21899,NULL,NULL,'Dipole + Quadrupole','UGC 05148',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63173,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63173,34.89,NULL,95,21899,NULL,NULL,'Dipole','UGC 05148',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63174,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63174,34.92,NULL,96.5,21899,NULL,NULL,NULL,'UGC 05148',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63175,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63175,34.93,0.2,96.8,21899,74.4,NULL,NULL,'UGC 05148',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63176,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63176,35.09,0.43,104,21899,NULL,NULL,NULL,'UGC 05148',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63177,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63177,35.11,0.43,105,21899,NULL,NULL,'Malmquist cor.','UGC 05148',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63178,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63178,38.55,0.33,514,21900,70,NULL,NULL,'SDSS J093933.94+271515.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,144.891458333,27.25428,0.017,NULL,64214352275,1003349254,15677332,18.3),(63179,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63179,37.02,0.46,254,21901,70,NULL,NULL,'2MASX J09393440+2943219',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000166,NULL,'17.0g',0.23,'E',NULL,NULL,NULL,NULL,1,144.8934583,29.72278,0.005,NULL,64223148170,1003486690,15679479,17),(63180,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63180,34.92,0.47,96.4,21902,NULL,NULL,'H','UGC 05145',NULL,'2007A&A...465...71T',2007,1,2.11,NULL,'G',0.00008,NULL,'14.3g',0.49,'S',NULL,NULL,NULL,NULL,1,144.894708333,48.42192,0.037,NULL,64016788663,1000262322,15629098,14.3),(63181,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63181,34.94,0.45,97.1,21902,NULL,NULL,'K','UGC 05145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63182,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63182,35.09,0.4,104,21902,NULL,NULL,'mean','UGC 05145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63183,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63183,35.14,0.46,107,21902,NULL,NULL,'J','UGC 05145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63184,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63184,35.25,0.49,112,21902,75,NULL,'IR','UGC 05145',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63185,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63185,37.77,0.46,358,21903,70,NULL,NULL,'2MASX J09393465+0755083',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,144.894625,7.91897,0.057,NULL,60891099453,951423428,14865991,16.9),(63186,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63186,36.95,0.46,245,21904,70,NULL,NULL,'2MASX J09393496+3731188',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000189,NULL,'15.8g',0.38,NULL,NULL,NULL,NULL,NULL,1,144.895875,37.52189,0,NULL,64174637978,1002728718,15667636,15.8),(63187,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63187,36.55,0.46,204,21905,70,NULL,NULL,'2MASX J09393732+2544079',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000173,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,144.905417,25.73558,0.009,NULL,64164595592,1002571806,15665184,16.7),(63188,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63188,36.63,0.46,212,21906,70,NULL,NULL,'2MASX J09393793+4105588',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000184,NULL,'16.1g',0.37,'E0',NULL,NULL,NULL,NULL,1,144.9082083,41.09964,0.009,NULL,64257236423,1004019319,15687801,16.1),(63189,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63189,38.05,0.46,406,21907,70,NULL,NULL,'2MASX J09393856+1434574',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,144.9107917,14.58267,0.089,NULL,63721718922,995651858,15557060,17.3),(63190,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63190,36.26,0.33,178,21908,70,NULL,NULL,'2MASX J09393863+3853588',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.0002,NULL,'15.9g',0.44,'S0^-',NULL,NULL,NULL,NULL,1,144.910917,38.89961,0,NULL,64391564025,1006118187,15720596,15.9),(63191,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63191,37.27,0.46,284,21909,70,NULL,NULL,'2MASX J09393878+5838571',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000078,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,144.91175,58.64908,0.045,NULL,61929705051,967651641,15119556,16.9),(63192,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63192,36.4,0.46,190,21910,70,NULL,NULL,'2MASX J09394026+4504309',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000188,NULL,'15.8g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,144.917917,45.07536,0.025,NULL,63981469822,999710465,15620476,15.8),(63193,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63193,38.33,0.33,463,21911,70,NULL,NULL,'2MASX J09394031+2204407',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000177,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,144.918041667,22.07806,0.049,NULL,63747853901,996060217,15563440,16.9),(63194,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63194,37.44,0.21,308,21912,70,NULL,NULL,'2MASX J09394183+6041276',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000079,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,144.9244583,60.69111,0.049,NULL,62035508717,969304823,15145387,17.1),(63195,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63195,38.21,0.46,439,21913,70,NULL,NULL,'2MASX J09394304+3038458',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000141,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,144.929416667,30.64608,0.017,NULL,64220826493,1003450413,15678912,18),(63196,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63196,33.73,0.73,55.6,21914,NULL,NULL,NULL,'ESO 061- G 013',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'14.36',1,'S...',NULL,NULL,NULL,NULL,1,144.941167,-68.82083,0.561,NULL,40739500123,636554689,9946167,14.36),(63197,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63197,33.77,0.2,56.8,21914,74.4,NULL,NULL,'ESO 061- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63198,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63198,33.9,0.67,60.3,21914,NULL,NULL,'Malmquist cor.','ESO 061- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63199,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63199,34.46,0.2,78,21915,74.4,NULL,NULL,'UGC 05149',NULL,'2013AJ....146...86T',2013,1,1.62,NULL,'G',0.000007,NULL,'16.3g',0.16,'Sd',NULL,NULL,NULL,NULL,1,144.941667,20.99972,0.061,NULL,63750074836,996094919,15563983,16.3),(63200,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63200,34.48,0.65,78.9,21915,NULL,NULL,NULL,'UGC 05149',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63201,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63201,34.51,NULL,79.6,21915,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05149',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63202,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63202,34.52,NULL,80.1,21915,NULL,NULL,'Dipole + Quadrupole','UGC 05149',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63203,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63203,34.53,NULL,80.7,21915,NULL,NULL,'Dipole','UGC 05149',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63204,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63204,34.58,NULL,82.6,21915,NULL,NULL,NULL,'UGC 05149',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63205,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63205,34.59,0.62,82.9,21915,NULL,NULL,'Malmquist cor.','UGC 05149',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63206,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63206,36.84,0.33,233,21916,70,NULL,NULL,'2MASX J09394702+1646184',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,144.9459583,16.77181,0.053,NULL,63735867178,995872924,15560514,17.1),(63207,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63207,34.91,0.54,96.1,21917,70,NULL,NULL,'2MASX J09394807-0433042',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000083,NULL,'15.93',0.4,'SB0/a','Group member',NULL,NULL,NULL,1,144.950167,-4.55122,0.097,NULL,41116385615,642443525,10038180,15.93),(63208,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63208,38.74,0.46,560,21918,70,NULL,NULL,'SDSS J093948.23+255148.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'18.1g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,144.951,25.86353,0,NULL,64210993306,1003296770,15676512,18.1),(63209,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63209,37.5,0.33,317,21919,70,NULL,NULL,'2MASX J09394962+1902368',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000176,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,144.9567083,19.04344,0.089,NULL,63743811017,995997047,15562453,17.7),(63210,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63210,38.33,0.33,463,21920,70,NULL,NULL,'SDSS J093951.29+220428.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000148,NULL,'18.8g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,144.9637083,22.07467,0.049,NULL,63747851039,996060172,15563440,18.8),(63211,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63211,37.69,0.46,345,21921,70,NULL,NULL,'2MASX J09395555+0340321',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000175,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,144.9814583,3.67572,0.065,NULL,60690319065,948286235,14816972,17.2),(63212,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63212,37.78,0.46,359,21922,70,NULL,NULL,'2MASX J09395597+4719388',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000145,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,144.983333,47.32739,0,NULL,64015292847,1000238950,15628733,17.7),(63213,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63213,36.73,0.46,222,21923,70,NULL,NULL,'2MASX J09400002+0106221',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000091,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,145.000167,1.10622,0.133,NULL,60687322988,948239421,14816240,16.9),(63214,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63214,36.84,0.33,233,21924,70,NULL,NULL,'2MASX J09400150+1653017',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000165,NULL,'16.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,145.006167,16.88378,0.053,NULL,63735857441,995872772,15560512,16.7),(63215,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63215,37.86,0.46,373,21925,70,NULL,NULL,'2MASX J09400209+0607259',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000138,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,145.008583333,6.12381,0.085,NULL,60708356739,948568074,14821376,18.1),(63216,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63216,38.35,0.46,468,21926,70,NULL,NULL,'SDSS J094003.45+031344.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,145.014375,3.229,0.073,NULL,60690339602,948286556,14816977,18.6),(63217,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63217,36.83,0.46,232,21927,70,NULL,NULL,'2MASX J09400601+3127080',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,145.025,31.45233,0.005,NULL,64220988198,1003452940,15678952,17.1),(63218,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63218,38.4,0.46,478,21928,70,NULL,NULL,'2MASX J09400750+2725058',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,145.03125,27.41828,0.017,NULL,64214363410,1003349428,15677334,17.7),(63219,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63219,37.58,0.46,328,21929,70,NULL,NULL,'2MASX J09400808+0731519',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,145.033833333,7.53117,0.081,NULL,60889462931,951397858,14865591,17.2),(63220,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63220,37.44,0.33,308,21930,70,NULL,NULL,'2MASX J09401131+5229199',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000191,NULL,'15.8g',0.47,'AGN',NULL,NULL,NULL,NULL,1,145.047125,52.48881,0.009,NULL,63965600076,999462501,15616601,15.8),(63221,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63221,36.61,0.46,210,21931,70,NULL,NULL,'2MASX J09401144+0014161',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000188,NULL,'16.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,145.0475417,0.23775,0.177,NULL,60683754595,948183665,14815369,16.4),(63222,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63222,31.48,NULL,19.8,21932,NULL,NULL,NULL,'KUG 0937+298',NULL,'2013AJ....145..101K',2013,1,0.62,NULL,'G',0.000037,NULL,'16.5g',0.23,'Irr            Sbrst',NULL,NULL,NULL,NULL,1,145.0535,29.59175,0.017,NULL,64222959927,1003483748,15679433,16.5),(63223,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63223,38.75,0.46,562,21933,70,NULL,NULL,'SDSS J094015.58+371454.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,145.0649583,37.24844,0,NULL,64174560223,1002727503,15667617,18.3),(63224,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63224,36.48,0.46,197,21934,70,NULL,NULL,'2MASX J09401601+3127431',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00017,NULL,'16.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,145.066833,31.46192,0.005,NULL,64220987434,1003452928,15678952,16.3),(63225,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63225,38.54,0.46,511,21935,70,NULL,NULL,'2MASX J09401688+3612007',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,145.0702917,36.20006,0,NULL,64174378437,1002724663,15667572,18),(63226,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63226,37.06,0.46,258,21936,70,NULL,NULL,'VIII Zw 051',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.92',0.28,NULL,NULL,NULL,NULL,NULL,1,145.0705417,13.23986,0.081,NULL,60820920930,950326889,14848857,17.92),(63227,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63227,35.6,0.46,132,21937,70,NULL,NULL,'2MASX J09401772+1232596',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000164,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,145.073916667,12.54989,0.049,NULL,60817914275,950279910,14848123,16.3),(63228,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63228,38.07,0.46,410,21938,70,NULL,NULL,'2MASX J09401838+5724490',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000088,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,145.07625,57.41364,0.017,NULL,61930563848,967665060,15119766,17.5),(63229,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63229,36.8,0.46,229,21939,70,NULL,NULL,'2MASX J09401900+6640398',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,145.079583,66.67767,0.173,NULL,62251009664,972672026,15198000,17.1),(63230,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63230,36.28,NULL,181,21940,NULL,NULL,NULL,'FGC 0921',NULL,'2000BSAO...50....5K',2000,1,0.92,NULL,'G',0.000022,NULL,'16.8g',0.12,'Sc',NULL,NULL,NULL,NULL,1,145.081083333,33.81053,0,NULL,64186122245,1002908160,15670440,16.8),(63231,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63231,36.29,NULL,181,21940,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0921',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63232,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63232,36.32,NULL,184,21940,NULL,NULL,'Dipole + Quadrupole','FGC 0921',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63233,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63233,36.35,NULL,186,21940,NULL,NULL,'Dipole','FGC 0921',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63234,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63234,37,0.2,251,21940,74.4,NULL,NULL,'FGC 0921',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63235,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63235,32.42,NULL,30.5,21941,NULL,NULL,NULL,'SDSS J094021.13+044406.3',NULL,'2015AstBu..70....1K',2015,1,0.36,NULL,'G',0.000017,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,145.0880417,4.73508,0.093,NULL,60688129382,948252021,14816437,17.8),(63236,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63236,38.64,0.46,535,21942,70,NULL,NULL,'2MASX J09402228+2835427',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,145.0927917,28.59531,0.013,NULL,64211950774,1003311730,15676745,18.1),(63237,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63237,36.98,0.46,248,21943,70,NULL,NULL,'2MASX J09402252+1237355',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,145.093916667,12.62653,0.049,NULL,60817782420,950277850,14848091,16.9),(63238,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63238,36.02,0.46,160,21944,70,NULL,NULL,'2MASX J09402267+3609587',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00008,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,145.0942917,36.16642,0,NULL,64174375836,1002724622,15667572,16.2),(63239,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63239,33.34,0.46,46.5,21945,70,NULL,NULL,'NGC 2954',NULL,'2015arXiv151105856S',2015,1,1.7,NULL,'G',0.000097,NULL,'13.30',1.1,'E','Isolated galaxy',NULL,NULL,NULL,1,145.1002917,14.92264,0.081,NULL,63721879166,995654361,15557099,13.3),(63240,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63240,33.78,0.4,57,21945,NULL,NULL,'mean','NGC 2954',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63241,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63241,34.07,0.45,65.2,21945,NULL,NULL,'K','NGC 2954',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63242,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63242,37.86,0.46,373,21946,70,NULL,NULL,'2MASX J09402559+1015583',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000196,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,145.10675,10.26617,0.041,NULL,60886008417,951343881,14864748,17.1),(63243,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63243,38.39,0.46,477,21947,70,NULL,NULL,'2MASX J09402590+1504485',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,145.107875,15.08014,0.073,NULL,63721885950,995654467,15557101,17.5),(63244,'Tully est','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63244,29.18,0.8,6.9,21948,75,NULL,'B','UGC 05151',NULL,'1988NBGC.C....0000T',1988,1,0.94,NULL,'G',0.000037,NULL,'13.8g',0.73,'I?','Field galaxy',NULL,NULL,NULL,1,145.112583,48.33764,0.025,NULL,64016773289,1000262082,15629095,13.8),(63245,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63245,36.28,0.46,181,21949,70,NULL,NULL,'2MASX J09402803+1255375',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'17.18',0.37,NULL,NULL,NULL,NULL,NULL,1,145.11675,12.92719,0.049,NULL,60821209580,950331399,14848928,17.18),(63246,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63246,34.12,0.52,66.6,21950,70,NULL,NULL,'IC 0550',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.5',0.4,NULL,NULL,NULL,NULL,NULL,1,145.119083,-6.94606,0.105,NULL,41314867285,645544801,10086637,14.5),(63247,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63247,32.86,0.43,37.3,21951,75,NULL,'3.6 micron, color + selection bias corrected','ESO 373- G 019',NULL,'2014MNRAS.444..527S',2014,1,1.4,NULL,'G',0.00005,NULL,'12.2I',0.4,'Sa: pec sp     HII',NULL,NULL,NULL,NULL,1,145.11975,-32.84353,0.681,NULL,42861623367,669712865,10464263,12.2),(63248,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63248,33.11,0.4,41.8,21951,NULL,NULL,'mean','ESO 373- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63249,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63249,33.14,0.45,42.4,21951,NULL,NULL,'K','ESO 373- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63250,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63250,33.28,0.47,45.3,21951,NULL,NULL,'H','ESO 373- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63251,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63251,33.44,0.46,48.8,21951,NULL,NULL,'J','ESO 373- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63252,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63252,33.55,0.4,51.4,21951,75,NULL,NULL,'ESO 373- G 019',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63253,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63253,33.8,0.49,57.6,21951,75,NULL,'IR','ESO 373- G 019',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63254,'Brightest Stars','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63254,28.32,NULL,4.61,21952,NULL,NULL,'Blue','Holmberg I',NULL,'1997AstL...23..644G',1997,1,3.6,'MCG implies the R.A. is 08h36.0m; corrected in MCG errata.','G',0.000002,NULL,'13.0',3,'IAB(s)m','Probable group member',NULL,NULL,NULL,1,145.1462917,71.17956,0.053,NULL,62107593262,970431144,15162986,13),(63255,'Brightest Stars','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63255,28.66,NULL,5.4,21952,NULL,NULL,'LF','Holmberg I',NULL,'1997AstL...23..656G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63256,'Brightest Stars','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63256,28.85,NULL,5.89,21952,NULL,NULL,'Red + Blue','Holmberg I',NULL,'1997AstL...23..644G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63257,'Brightest Stars','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63257,28.85,0.4,5.89,21952,NULL,NULL,'3B + 3R mean','Holmberg I',NULL,'1997AstL...23..656G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63258,'Brightest Stars','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63258,29.02,NULL,6.37,21952,NULL,NULL,'Red','Holmberg I',NULL,'1997AstL...23..644G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63259,'Brightest Stars','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63259,29.02,NULL,6.37,21952,NULL,NULL,'3R','Holmberg I',NULL,'1992A&AT....1..269T',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63260,'Brightest Stars','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63260,29.29,NULL,7.21,21952,NULL,NULL,'3B','Holmberg I',NULL,'1992A&AT....1..269T',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63261,'CMD','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63261,27.91,NULL,3.82,21952,NULL,NULL,NULL,'Holmberg I',NULL,'2012ApJ...748...47M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63262,'TRGB','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63262,26.69,NULL,2.18,21952,NULL,NULL,NULL,'Holmberg I',NULL,'2000ASPC..209..345D',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63263,'TRGB','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63263,27.92,0.26,3.84,21952,NULL,NULL,'I','Holmberg I',NULL,'2002A&A...383..125K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63264,'TRGB','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63264,27.95,0.03,3.9,21952,NULL,NULL,'I','Holmberg I',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63265,'TRGB','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63265,28,0.08,3.97,21952,74.4,NULL,NULL,'Holmberg I',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63266,'TRGB','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63266,28,0.03,3.98,21952,NULL,NULL,'I','Holmberg I',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63267,'HII region diameter','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63267,26.58,0.13,2.07,21952,NULL,NULL,'Method 2','Holmberg I',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63268,'HII region diameter','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63268,26.61,0.15,2.1,21952,NULL,NULL,'Method 1','Holmberg I',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63269,'Magnitude','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63269,27.47,0.11,3.12,21952,NULL,NULL,NULL,'Holmberg I',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63270,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63270,28.22,0.4,4.4,21952,75,NULL,'B','Holmberg I',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63271,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63271,37.74,0.46,353,21953,70,NULL,NULL,'2MASX J09403260+2241084',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000137,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,145.1360417,22.68564,0.037,NULL,63747506562,996054790,15563356,17.5),(63272,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63272,38.01,0.46,399,21954,70,NULL,NULL,'2MASX J09403433+1131393',NULL,'2015arXiv151105856S',2015,1,0.33,'TXS codes: lobes(W)','G',NULL,NULL,'16.6r',0.23,NULL,NULL,NULL,NULL,NULL,1,145.143167,11.52772,0.069,NULL,60888102856,951376607,14865259,16.6),(63273,'Maser','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63273,34.54,0.26,81,21955,NULL,NULL,NULL,'NGC 2960',NULL,'2012IAUS..287..311I',2012,1,1.8,NULL,'G',0.000033,NULL,'13.29',1.2,'Sa?            Sy3','Isolated galaxy',NULL,NULL,'LINER',1,145.151583,3.577,0.061,NULL,60690469145,948288580,14817009,13.29),(63274,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63274,33.42,0.69,48.2,21955,100,NULL,'mid-IR','NGC 2960',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63275,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63275,34.41,0.4,76.4,21955,NULL,NULL,'mean','NGC 2960',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63276,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63276,34.79,0.45,90.6,21955,NULL,NULL,'K','NGC 2960',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63277,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63277,34.87,0.47,94.3,21955,NULL,NULL,'H','NGC 2960',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63278,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63278,34.9,0.46,95.5,21955,NULL,NULL,'J','NGC 2960',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63279,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63279,35.45,0.65,123,21956,70,NULL,NULL,'2MASX J09403708-3407478',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00009,NULL,'14.5I',0.2,NULL,NULL,NULL,NULL,NULL,1,145.154583,-34.12992,0.733,NULL,42861982481,669718476,10464351,14.5),(63280,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63280,36.95,0.46,246,21957,70,NULL,NULL,'2MASX J09403716+5125128',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000141,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,145.154833,51.42014,0.009,NULL,64010460375,1000163443,15627553,17.4),(63281,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63281,37.74,0.46,353,21958,70,NULL,NULL,'2MASX J09403914+2218594',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,145.163125,22.31658,0.045,NULL,63747957652,996061838,15563466,18),(63282,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63282,38.62,0.46,529,21959,70,NULL,NULL,'2MASX J09403916+2231024',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000171,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,145.163125,22.51728,0.037,NULL,63747487732,996054495,15563351,18.3),(63283,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63283,35.61,0.33,132,21960,70,NULL,NULL,'2MASX J09403983+1659286',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000183,NULL,'15.8g',0.43,NULL,NULL,NULL,NULL,NULL,1,145.1662083,16.99122,0.057,NULL,63727216628,995737759,15558402,15.8),(63284,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63284,35.02,0.4,101,21961,NULL,NULL,'mean','NGC 2958',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.00003,NULL,'13.97',0.8,'S(r)bc','in a radial-velocity based grouping',NULL,NULL,NULL,1,145.173417,11.88842,0.049,NULL,60887977951,951374655,14865228,13.97),(63285,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63285,35.11,0.45,105,21961,NULL,NULL,'K','NGC 2958',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63286,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63286,35.11,0.47,105,21961,NULL,NULL,'H','NGC 2958',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63287,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63287,35.18,0.46,109,21961,NULL,NULL,'J','NGC 2958',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63288,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63288,38.35,0.46,467,21962,70,NULL,NULL,'SDSS J094041.89+012410.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000083,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,145.174583,1.40281,0.169,NULL,60687194997,948237421,14816209,18.4),(63289,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63289,37.44,0.21,308,21963,70,NULL,NULL,'SDSS J094042.94+604543.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000077,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,145.178916667,60.76197,0.057,NULL,62035823063,969309735,15145464,18.7),(63290,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63290,37.43,0.46,306,21964,70,NULL,NULL,'2MASX J09404301+1536536',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,145.17925,15.61481,0.053,NULL,63735428586,995866071,15560407,17.4),(63291,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63291,31.78,NULL,22.7,21965,NULL,NULL,NULL,'IC 0549',NULL,'2015AstBu..70....1K',2015,1,0.5,NULL,'G',0.00012,NULL,'14.8',0.3,NULL,NULL,NULL,NULL,NULL,1,145.180125,3.95975,0.065,NULL,60689953421,948280522,14816883,14.8),(63292,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63292,38.04,0.46,405,21966,70,NULL,NULL,'SDSS J094043.98+071459.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000145,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,145.1832917,7.25,0.097,NULL,60889514214,951398659,14865604,18.6),(63293,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63293,38.1,0.46,418,21967,70,NULL,NULL,'SDSS J094044.04+033952.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,145.1835417,3.66467,0.061,NULL,60690420396,948287818,14816997,18.2),(63294,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63294,37.97,0.46,392,21968,70,NULL,NULL,'SDSS J094044.58+323024.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000154,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,145.18575,32.50694,0,NULL,64185437038,1002897453,15670272,18.4),(63295,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63295,34.55,0.54,81.1,21969,70,NULL,NULL,'IC 0553',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000107,NULL,'15',0.9,'(R\')SB(rs)a pec:',NULL,NULL,NULL,NULL,1,145.1880417,-5.43536,0.101,NULL,41293068423,645204194,10081315,15),(63296,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63296,37.23,0.46,279,21970,70,NULL,NULL,'2MASX J09404612+2941207',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000181,NULL,'16.5g',0.32,'Sb',NULL,NULL,NULL,NULL,1,145.192083,29.68906,0.017,NULL,64222975926,1003483998,15679437,16.5),(63297,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63297,36.98,0.74,249,21971,70,NULL,NULL,'2MASX J09404903-1628579',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,145.20425,-16.48286,0.221,NULL,42309534927,661086483,10329476,15.8),(63298,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63298,34.1,0.49,66.1,21972,75,NULL,'IR','UGC 05164',NULL,'2011yCatp016004901K',2011,1,1.31,NULL,'G',0.00004,NULL,'14.9',0.16,'SB(s)b: sp','Group member',NULL,NULL,NULL,1,145.207333,11.55286,0.053,NULL,60888098900,951376545,14865258,14.9),(63299,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63299,35.4,NULL,120,21972,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05164',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63300,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63300,35.42,NULL,121,21972,NULL,NULL,'Dipole + Quadrupole','UGC 05164',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63301,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63301,35.44,NULL,122,21972,NULL,NULL,'Dipole','UGC 05164',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63302,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63302,37.76,0.46,356,21973,70,NULL,NULL,'2MASX J09404979+3741440',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000138,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,145.207625,37.69578,0,NULL,64176770652,1002762041,15668156,18),(63303,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63303,37.22,0.27,278,21974,70,NULL,NULL,'2MASX J09405103+6647205',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,145.212917,66.78908,0.173,NULL,62251795834,972684309,15198192,NULL),(63304,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63304,36.67,0.46,216,21975,70,NULL,NULL,'2MASX J09405116+1423306',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,145.21325,14.39183,0.105,NULL,63721563640,995649431,15557022,17.1),(63305,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63305,34.61,0.2,83.6,21976,74.4,NULL,NULL,'KUG 0937+319',NULL,'2013AJ....146...86T',2013,1,1.35,NULL,'G',0.00001,NULL,'16.3g',0.19,'Sd',NULL,NULL,NULL,NULL,1,145.2224583,31.74492,0.013,NULL,64220294698,1003442104,15678782,16.3),(63306,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63306,35.04,NULL,102,21976,NULL,NULL,'Dipole + Quadrupole + Octopole','KUG 0937+319',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63307,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63307,35.06,NULL,103,21976,NULL,NULL,'Dipole + Quadrupole','KUG 0937+319',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63308,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63308,35.07,NULL,103,21976,NULL,NULL,'Dipole','KUG 0937+319',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63309,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63309,35.12,0.49,106,21976,75,NULL,'IR','KUG 0937+319',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63310,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63310,35.12,NULL,106,21976,NULL,NULL,NULL,'KUG 0937+319',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63311,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63311,36.19,0.58,173,21977,70,NULL,NULL,'2MASX J09405379-3601319',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,145.224208333,-36.02547,0.961,NULL,42862952180,669733627,10464587,14.3),(63312,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63312,38.25,0.46,447,21978,70,NULL,NULL,'2MASX J09405384+5942474',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000077,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,145.224333,59.71319,0.041,NULL,61912801061,967387516,15115429,17.4),(63313,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 1995D',NULL,63313,31.88,0.37,23.6,21979,74.2,NULL,'SALT 2','NGC 2962',0.00656,'2010ApJ...716..712A',2010,1,2.6,NULL,'G',0.000017,NULL,'12.96',1.9,'(R)SAB(rs)0+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,145.2247083,5.16581,0.089,NULL,60910080155,951720002,14870625,12.96),(63314,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 1995D',NULL,63314,32.2,0.3,27.5,21979,NULL,NULL,NULL,'NGC 2962',NULL,'1996PASJ...48...51S',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63315,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 1995D',NULL,63315,32.43,0.17,30.4,21979,72,NULL,NULL,'NGC 2962',0.00656,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63316,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 1995D',NULL,63316,32.46,0.1,31.1,21979,74.4,NULL,NULL,'NGC 2962',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63317,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 1995D',NULL,63317,32.47,0.07,31.2,21979,60,NULL,'M(B) = -19.48 mag','NGC 2962',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63318,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 1995D',NULL,63318,32.5,0.06,31.6,21979,60,NULL,'M(V) = -19.47 mag','NGC 2962',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63319,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 1995D',NULL,63319,32.55,0.12,32.4,21979,70.8,NULL,NULL,'NGC 2962',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63320,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 1995D',NULL,63320,32.58,0.06,32.8,21979,60,NULL,'M(I) = -19.19 mag','NGC 2962',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63321,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 1995D',NULL,63321,32.67,0.37,34,21979,70,NULL,'SALT','NGC 2962',0.00656,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63322,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 1995D',NULL,63322,32.76,0.06,35.6,21979,65,NULL,'Snapshot','NGC 2962',NULL,'1996ApJ...473...88R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63323,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 1995D',NULL,63323,32.79,0.16,35.9,21979,65,NULL,'Template','NGC 2962',0.00656,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63324,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 1995D',NULL,63324,32.81,0.07,36.1,21979,65,NULL,'MLCS2k2','NGC 2962',0.00656,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63325,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 1995D',NULL,63325,32.84,0.14,37,21979,60,NULL,NULL,'NGC 2962',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63326,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 1995D',NULL,63326,33.01,0.13,39.7,21979,65,NULL,'MLCS','NGC 2962',0.00656,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63327,'SNIa','2016-12-15 15:14:30','2016-12-16 11:19:37','1','SN 1995D',NULL,63327,33.07,0.05,40.8,21979,65,NULL,'MLCS','NGC 2962',0.00656,'1996ApJ...473..588R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63328,'SBF','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63328,32.66,0.15,34,21979,NULL,NULL,'I','NGC 2962',NULL,'2001ApJ...559..584A',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63329,'Faber-Jackson','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63329,31.79,0.65,22.8,21979,95,NULL,'Weighted Mean','NGC 2962',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63330,'Faber-Jackson','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63330,33.69,0.81,54.7,21979,55,NULL,'Visvanathan & Sandage 1979','NGC 2962',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63331,'Tully est','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63331,32.43,0.8,30.6,21979,75,NULL,'B','NGC 2962',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63332,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63332,32.52,0.45,31.9,21979,NULL,NULL,'K','NGC 2962',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63333,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63333,32.56,0.4,32.5,21979,NULL,NULL,'mean','NGC 2962',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63334,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63334,32.58,0.4,32.8,21979,75,NULL,'HOSTS SN 1995D','NGC 2962',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63335,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63335,38.29,0.46,456,21980,70,NULL,NULL,'2MASX J09405679+5244190',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000145,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,145.236625,52.73867,0.037,NULL,63966801663,999481275,15616894,17.7),(63336,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63336,35.86,0.46,149,21981,70,NULL,NULL,'SBS 0937+514',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000165,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,145.2419583,51.23597,0.005,NULL,64010503968,1000164124,15627564,16.4),(63337,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63337,33.66,0.2,54,21982,74.4,NULL,NULL,'UGC 05157',NULL,'2013AJ....146...86T',2013,1,1.97,'HOLM 138B is a star.','G',0.000023,NULL,'14.3g',0.43,'S','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,145.24225,47.62044,0.009,NULL,64015321250,1000239394,15628740,14.3),(63338,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63338,33.71,0.41,55.2,21982,NULL,NULL,NULL,'UGC 05157',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63339,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63339,33.9,0.38,60.4,21982,NULL,NULL,'Malmquist cor.','UGC 05157',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63340,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63340,33.93,0.49,61.1,21982,75,NULL,'IR','UGC 05157',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63341,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63341,34.2,0.4,69.3,21982,NULL,NULL,'mean','UGC 05157',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63342,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63342,34.33,0.47,73.4,21982,NULL,NULL,'H','UGC 05157',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63343,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63343,34.41,0.45,76.1,21982,NULL,NULL,'K','UGC 05157',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63344,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63344,37.37,0.46,297,21983,70,NULL,NULL,'SDSS J094058.30+422652.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,145.242958333,42.44778,0.049,NULL,63974095545,999595242,15618675,18.1),(63345,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63345,35.52,0.49,127,21984,75,NULL,'IR','CGCG 122-047',NULL,'2011yCatp016004901K',2011,1,0.95,NULL,'G',0.000102,NULL,'15.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,145.243666667,25.47014,0.013,NULL,64165332045,1002583313,15665364,15.4),(63346,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63346,37.26,0.46,284,21985,70,NULL,NULL,'2MASX J09405886+0016009',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000184,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,145.2452917,0.267,0.157,NULL,60683974615,948187103,14815423,17.5),(63347,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63347,37.41,0.46,303,21986,70,NULL,NULL,'2MASX J09410021+0838228',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,145.250917,8.63969,0.073,NULL,60891621090,951431579,14866118,18.1),(63348,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63348,37.77,0.46,357,21987,70,NULL,NULL,'2MASX J09410056+5842444',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000076,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,145.2525,58.71233,0.017,NULL,61929624841,967650388,15119537,18),(63349,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63349,37.86,0.46,373,21988,70,NULL,NULL,'2MASX J09410184+3117289',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00018,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,145.257541667,31.29125,0,NULL,64220940590,1003452196,15678940,17.5),(63350,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63350,34.89,0.2,95.1,21989,74.4,NULL,NULL,'CGCG 063-037',NULL,'2013AJ....146...86T',2013,1,0.6,'Two bright stars on southeast side.','G',NULL,NULL,'15.6',0.5,NULL,'Group member',NULL,NULL,NULL,1,145.278125,11.50683,0.033,NULL,60888110831,951376731,14865261,15.6),(63351,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63351,34.66,0.49,85.7,21990,75,NULL,'IR','CGCG 063-037',NULL,'2011yCatp016004901K',2011,1,0.6,'Two bright stars on southeast side.','G',NULL,NULL,'15.6',0.5,NULL,'Group member',NULL,NULL,NULL,1,145.278125,11.50683,0.033,NULL,60888110831,951376731,14865261,15.6),(63352,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63352,37.8,0.46,364,21991,70,NULL,NULL,'2MASX J09410744+2643126',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,145.280917,26.72017,0.033,NULL,64210890584,1003295165,15676486,17.5),(63353,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63353,37.73,0.33,351,21992,70,NULL,NULL,'2MASX J09410984+1050388',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,145.291166667,10.84408,0.065,NULL,60887883641,951373181,14865205,16.7),(63354,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63354,36.92,0.46,242,21993,70,NULL,NULL,'2MASX J09411097+0306559',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000179,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,145.295875,3.11544,0.081,NULL,60689698202,948276534,14816820,16.3),(63355,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63355,36.84,0.46,233,21994,70,NULL,NULL,'CGCG 122-051',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000201,NULL,'15.7g',0.43,NULL,'Group member',NULL,NULL,NULL,1,145.3017083,26.09014,0.005,NULL,64165097909,1002579654,15665307,15.7),(63356,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63356,38.2,0.46,436,21995,70,NULL,NULL,'SDSS J094112.68+024943.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000182,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,145.302833,2.82889,0.101,NULL,60698116839,948408075,14818876,17.9),(63357,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63357,39.18,0.46,684,21996,70,NULL,NULL,'SDSS J094112.98+212407.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000153,NULL,'18.3g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,145.304125,21.40208,0.041,NULL,63750207929,996096998,15564015,18.3),(63358,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63358,37.58,0.46,328,21997,70,NULL,NULL,'2MASX J09411425+0323269',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000174,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,145.309458333,3.39089,0.073,NULL,60689692210,948276440,14816819,17.3),(63359,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63359,38.66,0.46,540,21998,70,NULL,NULL,'SDSS J094114.70+093643.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000132,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,145.3112917,9.61206,0.053,NULL,60900238470,951566226,14868222,18.6),(63360,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63360,37.87,0.46,375,21999,70,NULL,NULL,'SDSS J094116.20+283225.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,145.3175,28.54056,0.017,NULL,64212126796,1003314481,15676788,18.3),(63361,'FP','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,'R',63361,34.57,0.46,81.9,22000,70,NULL,NULL,'IC 0552',NULL,'2015arXiv151105856S',2015,1,1.12,NULL,'G',0.000063,NULL,'14.1g',0.67,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,145.3190417,10.647,0.041,NULL,60885855377,951341490,14864710,14.1),(63362,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63362,34.71,0.4,87.3,22000,NULL,NULL,'mean','IC 0552',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63363,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63363,34.8,0.45,91.1,22000,NULL,NULL,'K','IC 0552',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63364,'IRAS','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63364,34.95,0.8,97.6,22001,75,NULL,'CF, r','NGC 2955',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'13.61',0.9,'(R\')SA(r)b','Isolated galaxy',NULL,NULL,NULL,1,145.31925,35.88228,0,NULL,64188106340,1002939161,15670924,13.61),(63365,'Tully est','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63365,32.21,0.8,27.7,22001,75,NULL,'B','NGC 2955',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63366,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63366,34.5,NULL,79.4,22001,NULL,NULL,'B','NGC 2955',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63367,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63367,34.76,0.38,89.6,22001,75,NULL,'CF, r, raw','NGC 2955',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63368,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63368,34.79,0.47,90.7,22001,NULL,NULL,'H','NGC 2955',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63369,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63369,34.84,0.45,92.7,22001,NULL,NULL,'K','NGC 2955',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63370,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63370,34.84,0.46,93,22001,NULL,NULL,'J','NGC 2955',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63371,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63371,34.94,0.38,97.4,22001,75,NULL,'CF, r, cor','NGC 2955',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63372,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63372,35,0.38,99.8,22001,75,NULL,'CF, r, inv','NGC 2955',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63373,'Tully-Fisher','2016-12-15 15:14:30','2016-12-16 11:19:37','1',NULL,NULL,63373,35.05,0.4,102,22001,NULL,NULL,'mean','NGC 2955',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63374,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63374,35.09,0.06,104,22001,NULL,NULL,NULL,'NGC 2955',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63375,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63375,35.2,0.2,110,22001,74.4,NULL,NULL,'NGC 2955',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63376,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63376,37.69,0.46,345,22002,70,NULL,NULL,'2MASX J09411674+0602099',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,145.319708333,6.03617,0.073,NULL,60909729180,951714518,14870539,17.4),(63377,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63377,37.55,0.46,324,22003,70,NULL,NULL,'2MASX J09411812+0821218',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000175,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,145.325583,8.35617,0.089,NULL,60892778134,951449658,14866400,17.1),(63378,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63378,38.28,0.46,453,22004,70,NULL,NULL,'SDSS J094118.80+274132.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000131,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,145.328375,27.69239,0,NULL,64212305939,1003317280,15676832,18.4),(63379,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63379,37.42,0.46,305,22005,70,NULL,NULL,'2MASX J09411887+2520048',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,145.328667,25.33481,0.013,NULL,64165426196,1002584784,15665387,17.5),(63380,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63380,38.11,0.27,419,22006,70,NULL,NULL,'SDSS J094122.63-000100.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000073,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,145.344333,-0.01694,0.145,NULL,41104597371,642259333,10035302,18.2),(63381,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63381,37.58,0.46,328,22007,70,NULL,NULL,'2MASX J09412292+5619224',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000072,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,145.3454583,56.32292,0.013,NULL,61879853249,966872707,15107386,17.6),(63382,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63382,38.11,0.27,419,22008,70,NULL,NULL,'2MASX J09412343+0003156',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00008,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,145.3475,0.05439,0.145,NULL,60683818666,948184666,14815385,18.2),(63383,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63383,38.23,0.46,443,22009,70,NULL,NULL,'SDSS J094123.99-011513.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000079,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,145.35,-1.25383,0.085,NULL,41107766485,642308851,10036075,18.3),(63384,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63384,38.11,0.46,418,22010,70,NULL,NULL,'2MASX J09412588+2345275',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000173,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,145.3580417,23.75783,0.049,NULL,63691017322,995172145,15549564,17),(63385,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63385,37.65,0.46,340,22011,70,NULL,NULL,'2MASX J09412638+4016588',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,145.359875,40.28306,0.021,NULL,64256934794,1004014606,15687728,16.9),(63386,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63386,36.61,0.46,210,22012,70,NULL,NULL,'2MASX J09412704+2454198',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00015,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,145.362583,24.90567,0.029,NULL,64164528768,1002570762,15665168,16.7),(63387,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63387,37.95,0.46,389,22013,70,NULL,NULL,'2MASX J09412708+3519036',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000153,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,145.362833,35.31781,0,NULL,64188696732,1002948386,15671068,17.1),(63388,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63388,35.61,0.33,132,22014,70,NULL,NULL,'CGCG 092-029',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'15.7',0.46,NULL,NULL,NULL,NULL,NULL,1,145.364833,16.71103,0.053,NULL,63726746112,995730408,15558287,15.7),(63389,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63389,36.55,0.46,204,22015,70,NULL,NULL,'2MASX J09412875+1548051',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'16.0g',0.39,NULL,NULL,NULL,NULL,NULL,1,145.3697917,15.80136,0.065,NULL,63735503264,995867238,15560425,16),(63390,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63390,36.89,0.46,239,22016,70,NULL,NULL,'2MASX J09412977-0114573',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000097,NULL,'15.9g',0.4,NULL,NULL,NULL,NULL,NULL,1,145.374125,-1.24928,0.085,NULL,41107764306,642308817,10036075,15.9),(63391,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63391,37.28,0.46,285,22017,70,NULL,NULL,'2MASX J09413078+2447348',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000143,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,145.378166667,24.79294,0.033,NULL,63691360215,995177503,15549648,17.5),(63392,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63392,37.73,0.33,351,22018,70,NULL,NULL,'2MASX J09413148+1046469',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'18.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,145.381333,10.77983,0.041,NULL,60887726097,951370720,14865167,18.1),(63393,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63393,34.4,NULL,75.8,22019,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05173',NULL,'2010Ap&SS.325..163P',2010,1,2.67,NULL,'G',0.00002,NULL,'14.72',0.34,'Sbc','Group member',NULL,NULL,NULL,1,145.384166667,11.41331,0.033,NULL,60888580825,951384075,14865376,14.72),(63394,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63394,34.4,NULL,76,22019,NULL,NULL,'Dipole','UGC 05173',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63395,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63395,34.4,NULL,76,22019,NULL,NULL,'Dipole + Quadrupole','UGC 05173',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63396,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63396,34.46,NULL,78,22019,NULL,NULL,NULL,'UGC 05173',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63397,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63397,34.49,0.49,78.9,22019,75,NULL,'IR','UGC 05173',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63398,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63398,34.73,0.45,88.3,22019,NULL,NULL,'K','UGC 05173',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63399,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63399,34.74,0.47,88.5,22019,NULL,NULL,'H','UGC 05173',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63400,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63400,34.87,0.4,94,22019,NULL,NULL,'mean','UGC 05173',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63401,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63401,34.94,0.46,97.2,22019,NULL,NULL,'J','UGC 05173',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63402,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63402,37.22,0.27,278,22020,70,NULL,NULL,'2MASX J09413277+6642376',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',NULL,NULL,'15.9g',0.37,NULL,NULL,NULL,NULL,NULL,1,145.3864583,66.71056,0.173,NULL,62250896264,972670254,15197972,15.9),(63403,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63403,37.78,0.27,360,22021,70,NULL,NULL,'2MASX J09413279+2507158',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000194,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,145.386583333,25.12094,0.013,NULL,64165435094,1002584923,15665389,16.2),(63404,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63404,38.19,0.46,435,22022,70,NULL,NULL,'SDSS J094135.54+082117.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000163,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,145.398083,8.35478,0.089,NULL,60892788462,951449819,14866403,18.7),(63405,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63405,35.49,0.46,125,22023,70,NULL,NULL,'2MASX J09413551+2355075',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00015,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,145.398125,23.91889,0.021,NULL,63690977597,995171524,15549555,16.8),(63406,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63406,37.37,0.46,298,22024,70,NULL,NULL,'2MASX J09413610+1851225',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000171,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,145.400417,18.85614,0.057,NULL,63743934612,995998978,15562484,16.6),(63407,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63407,37.86,0.46,374,22025,70,NULL,NULL,'2MASX J09413668+6201423',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000083,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,145.402833,62.02831,0.073,NULL,62039494663,969367104,15146361,16.9),(63408,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63408,38.48,0.46,497,22026,70,NULL,NULL,'2MASX J09413687+3947179',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000178,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,145.4037917,39.78842,0.021,NULL,64391067920,1006110436,15720475,17.9),(63409,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63409,37.78,0.27,360,22027,70,NULL,NULL,'2MASX J09413765+2509360',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,145.4067083,25.16014,0.013,NULL,64165436453,1002584944,15665389,18),(63410,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63410,38.23,0.46,442,22028,70,NULL,NULL,'SDSS J094139.62+031947.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000154,NULL,'18.9g',0.11,NULL,NULL,NULL,NULL,NULL,1,145.415125,3.32989,0.073,NULL,60689721372,948276896,14816826,18.9),(63411,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63411,36.96,0.46,246,22029,70,NULL,NULL,'2MASX J09414039+0410550',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,145.418416667,4.18189,0.081,NULL,60689891536,948279555,14816868,16.8),(63412,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63412,37.78,0.27,360,22030,70,NULL,NULL,'2MASX J09414111+2512410',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,145.4215,25.21139,0.013,NULL,64165444436,1002585069,15665391,17.6),(63413,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63413,38,0.46,399,22031,70,NULL,NULL,'SDSS J094141.91+463149.7',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000155,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,145.424625,46.53047,0.025,NULL,63983022354,999734724,15620855,17.8),(63414,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63414,37.36,0.46,296,22032,70,NULL,NULL,'2MASX J09414292+2608550',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000147,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,145.428916667,26.14853,0.005,NULL,64165223123,1002581611,15665337,17.2),(63415,'IRAS','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63415,32.68,0.8,34.3,22033,75,NULL,'MAT, I','ESO 434- G 023',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'14.50',1,'SABb:',NULL,NULL,NULL,NULL,1,145.429625,-28.19133,0.425,NULL,42877008458,669953257,10468019,14.5),(63416,'Sosies','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63416,33.41,0.18,48.1,22033,NULL,NULL,NULL,'ESO 434- G 023',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63417,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63417,31.71,0.69,22,22033,100,NULL,'mid-IR','ESO 434- G 023',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63418,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63418,32.92,0.43,38.4,22033,75,NULL,'3.6 micron, color + selection bias corrected','ESO 434- G 023',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63419,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63419,32.93,0.32,38.5,22033,85,NULL,'I, raw','ESO 434- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63420,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63420,32.96,0.32,39,22033,85,NULL,'I, inv','ESO 434- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63421,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63421,32.97,0.2,39.3,22033,74.4,NULL,NULL,'ESO 434- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63422,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63422,32.97,0.43,39.3,22033,75,NULL,'3.6 micron, color corrected','ESO 434- G 023',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63423,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63423,32.99,0.4,39.7,22033,NULL,NULL,'mean','ESO 434- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63424,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63424,33.04,0.52,40.5,22033,NULL,NULL,NULL,'ESO 434- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63425,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63425,33.04,0.52,40.5,22033,NULL,NULL,'Malmquist cor.','ESO 434- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63426,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63426,33.17,0.43,43,22033,75,NULL,'MAT, I, raw','ESO 434- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63427,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63427,33.32,0.43,46.2,22033,75,NULL,'MAT, I, inv','ESO 434- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63428,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63428,33.35,0.43,46.9,22033,75,NULL,'MAT, I, cor','ESO 434- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63429,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63429,33.36,0.47,47.1,22033,NULL,NULL,'H','ESO 434- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63430,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63430,33.44,0.46,48.7,22033,NULL,NULL,'J','ESO 434- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63431,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63431,33.52,0.45,50.5,22033,NULL,NULL,'K','ESO 434- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63432,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63432,38.36,0.46,470,22034,70,NULL,NULL,'2MASX J09414371+5123539',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,145.432,51.39853,0.009,NULL,64011178479,1000174663,15627729,18),(63433,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63433,38.03,0.46,403,22035,70,NULL,NULL,'2MASX J09414450+4913039',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000195,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,145.4352917,49.21789,0,NULL,64016108660,1000251697,15628932,17.3),(63434,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63434,36.9,0.46,240,22036,70,NULL,NULL,'2MASX J09414468+0152470',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000075,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,145.436167,1.87967,0.165,NULL,60685056589,948204009,14815687,17.1),(63435,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63435,36.87,0.46,237,22037,70,NULL,NULL,'2MASX J09414558+3445296',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000176,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,145.4399583,34.75844,0,NULL,64189586631,1002962291,15671285,16.8),(63436,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63436,37.62,0.46,334,22038,70,NULL,NULL,'2MASXi J0941456+152443',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,145.440333,15.41194,0.069,NULL,63734698505,995854664,15560229,17.5),(63437,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63437,37.38,0.46,299,22039,70,NULL,NULL,'2MASX J09414655+0140010',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000084,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,145.444083333,1.66703,0.165,NULL,60684959010,948202484,14815663,17.6),(63438,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63438,34.69,0.46,86.9,22040,70,NULL,NULL,'CGCG 063-044',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000083,NULL,'14.4g',0.69,'E0','Group member',NULL,NULL,NULL,1,145.44525,11.48217,0.033,NULL,60886942160,951358471,14864976,14.4),(63439,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63439,38.11,0.27,419,22041,70,NULL,NULL,'2MASX J09414690-0007213',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000086,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,145.4454583,-0.12267,0.145,NULL,41104627625,642259806,10035309,18.3),(63440,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63440,37.42,0.46,305,22042,70,NULL,NULL,'SDSS J094148.57+214255.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000167,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,145.452416667,21.71542,0.045,NULL,63747265805,996051028,15563297,18.1),(63441,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63441,38.11,0.33,419,22043,70,NULL,NULL,'SDSS J094149.11+323836.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,145.454625,32.64336,0.009,NULL,64183374147,1002865221,15669769,18.6),(63442,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63442,38.11,0.33,419,22044,70,NULL,NULL,'2MASX J09414989+0208583',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000078,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,145.458,2.14942,0.113,NULL,60685231805,948206746,14815730,17.2),(63443,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63443,35.63,0.46,134,22045,70,NULL,NULL,'CGCG 092-030',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.00018,NULL,'15.2',0.6,NULL,NULL,NULL,NULL,NULL,1,145.4587083,14.96672,0.105,NULL,63721121798,995642528,15556914,15.2),(63444,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63444,37.24,0.46,280,22046,70,NULL,NULL,'VIII Zw 054',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000189,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,145.46075,10.74831,0.041,NULL,60887673716,951369901,14865154,16.6),(63445,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63445,35.35,0.46,118,22047,70,NULL,NULL,'CGCG 152-051',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.00017,NULL,'15.0g',0.48,'S?',NULL,NULL,NULL,NULL,1,145.46325,27.64686,0.017,NULL,64212312694,1003317385,15676834,15),(63446,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63446,36.61,0.46,210,22048,70,NULL,NULL,'2MASX J09415125+5331329',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000179,NULL,'16.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,145.463417,53.52575,0.025,NULL,63963478448,999429350,15616083,16.7),(63447,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63447,32.94,0.4,38.7,22049,75,NULL,'B','UGC 05172',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.00002,NULL,'14.9B',1.5,'SA(s)m',NULL,NULL,NULL,NULL,1,145.467417,48.67092,0.017,NULL,64016670568,1000260477,15629069,14.9),(63448,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63448,36.73,0.46,222,22050,70,NULL,NULL,'2MASX J09415193+0923508',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000163,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,145.466333333,9.39747,0.057,NULL,60899662089,951557220,14868081,16.6),(63449,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63449,37.75,0.46,355,22051,70,NULL,NULL,'SDSS J094152.42+021206.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000076,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,145.4684583,2.20169,0.113,NULL,60685108249,948204816,14815700,18.2),(63450,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63450,37.94,0.46,388,22052,70,NULL,NULL,'2MASX J09415362+6000502',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000082,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,145.473166667,60.01392,0.049,NULL,61915594540,967431164,15116111,17.6),(63451,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63451,38.02,0.46,402,22053,70,NULL,NULL,'2MASX J09415379+1714278',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,145.474167,17.24108,0.045,NULL,63727421693,995740963,15558452,17.4),(63452,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63452,36.59,0.46,208,22054,70,NULL,NULL,'2MASX J09415388+5554594',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000089,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,145.4745417,55.91647,0.017,NULL,61880488427,966882631,15107541,16.5),(63453,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63453,35.72,0.61,139,22055,70,NULL,NULL,'2MASX J09415420-7147331',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,145.4760417,-71.79256,0.557,NULL,40715524680,636180073,9940313,17.3),(63454,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63454,36.19,0.46,173,22056,70,NULL,NULL,'CGCG 152-052',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000188,NULL,'15.6g',0.48,NULL,NULL,NULL,NULL,NULL,1,145.476583,31.49322,0.021,NULL,64220180404,1003440318,15678754,15.6),(63455,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63455,33.86,0.47,59.1,22057,NULL,NULL,'H','NGC 2969',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00003,NULL,'15.5',1.2,'SA(s)c pec:    HII',NULL,NULL,NULL,NULL,1,145.477083,-8.603,0.125,NULL,41317196585,645581196,10087206,15.5),(63456,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63456,34.03,0.46,63.8,22057,NULL,NULL,'J','NGC 2969',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63457,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63457,34.06,0.45,65,22057,NULL,NULL,'K','NGC 2969',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63458,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63458,34.31,0.4,72.8,22057,NULL,NULL,'mean','NGC 2969',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63459,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63459,36.34,0.46,185,22058,70,NULL,NULL,'2MASX J09415519+4124340',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000209,NULL,'15.5g',0.5,'E0',NULL,NULL,NULL,NULL,1,145.4797917,41.40936,0.045,NULL,63972076356,999563693,15618182,15.5),(63460,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63460,36.06,0.46,163,22059,70,NULL,NULL,'2MASX J09415631+5307219',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000161,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,145.484667,53.12267,0.033,NULL,63966666381,999479162,15616861,16.7),(63461,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63461,36.26,0.46,179,22060,70,NULL,NULL,'2MASX J09415967+2349056',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000164,NULL,'17.08',0.42,NULL,NULL,NULL,NULL,NULL,1,145.498583,23.81811,0.049,NULL,63691002220,995171909,15549561,17.08),(63462,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63462,38.11,0.33,419,22061,70,NULL,NULL,'2MASX J09420077+3239056',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00019,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,145.503291667,32.65164,0.009,NULL,64183375206,1002865237,15669769,17),(63463,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63463,37.87,0.46,375,22062,70,NULL,NULL,'2MASX J09420243+2335476',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000178,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,145.510291667,23.59669,0.049,NULL,63690800988,995168765,15549511,17.1),(63464,'Tully est','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63464,32.45,0.8,30.9,22063,75,NULL,'B','NGC 2967',NULL,'1988NBGC.C....0000T',1988,1,3,NULL,'G',0.000017,NULL,'12.30',2.8,'SA(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,145.5137083,0.33644,0.157,NULL,60684078290,948188723,14815448,12.3),(63465,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63465,37.21,0.46,277,22064,70,NULL,NULL,'SBS 0938+497',NULL,'2015arXiv151105856S',2015,1,0.37,'2001Afz....44..163B has z = 0.0450.','G',0.000184,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,145.5167083,49.55992,0.005,NULL,64018108290,1000282942,15629420,16.5),(63466,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63466,34.72,NULL,88.1,22065,NULL,NULL,'Dipole + Quadrupole + Octopole','KUG 0938+483',NULL,'2010Ap&SS.325..163P',2010,1,0.93,NULL,'G',0.000033,NULL,'16.5:',0.1,'Sd',NULL,NULL,NULL,NULL,1,145.519833333,48.091,0.033,NULL,64014868413,1000232318,15628629,16.5),(63467,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63467,34.75,NULL,88.9,22065,NULL,NULL,'Dipole + Quadrupole','KUG 0938+483',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63468,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63468,34.76,NULL,89.4,22065,NULL,NULL,'Dipole','KUG 0938+483',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63469,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63469,34.8,NULL,91.2,22065,NULL,NULL,NULL,'KUG 0938+483',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63470,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63470,38.1,0.46,416,22066,70,NULL,NULL,'2MASX J09420485+4801168',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000145,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,145.52025,48.02131,0.025,NULL,64014876552,1000232446,15628631,17.8),(63471,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63471,37.31,0.46,290,22067,70,NULL,NULL,'2MASX J09420581+0635199',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,145.52425,6.58886,0.073,NULL,60918265326,951847895,14872623,17.2),(63472,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63472,37.36,0.46,297,22068,70,NULL,NULL,'2MASX J09420706+1825466',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,145.529458333,18.42953,0.053,NULL,63725738206,995714659,15558041,17.8),(63473,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63473,35.23,0.46,111,22069,70,NULL,NULL,'2MASX J09420860+4101511',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000158,NULL,'16.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,145.535833,41.031,0.017,NULL,64257158299,1004018098,15687782,16.3),(63474,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63474,37.58,0.46,328,22070,70,NULL,NULL,'2MASX J09420884+3237096',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000128,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,145.5367917,32.61936,0.009,NULL,64183374868,1002865232,15669769,18.3),(63475,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63475,35.34,0.33,117,22071,70,NULL,NULL,'2MASX J09420897+2249275',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000163,NULL,'15.9g',0.33,NULL,NULL,NULL,NULL,NULL,1,145.537416667,22.82428,0.065,NULL,63747608519,996056383,15563380,15.9),(63476,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63476,31.8,0.47,22.9,22072,NULL,NULL,'H','NGC 2966',NULL,'2007A&A...465...71T',2007,1,2.2,NULL,'G',0.000023,NULL,'13.56',0.9,'SBc;HII        Sbrst','Group member, radial-velocity confirmed',NULL,NULL,'Starburst',1,145.547833333,4.67314,0.089,NULL,60913414414,951772100,14871439,13.56),(63477,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63477,31.87,0.45,23.7,22072,NULL,NULL,'K','NGC 2966',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63478,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63478,31.89,0.46,23.9,22072,NULL,NULL,'J','NGC 2966',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63479,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63479,32.59,0.4,32.9,22072,NULL,NULL,'mean','NGC 2966',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63480,'IRAS','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63480,33.97,0.8,62.3,22073,75,NULL,'MAT, I','MCG -01-25-022',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'14.9',0.4,'Sbc:           HII',NULL,NULL,NULL,NULL,1,145.550833,-4.71406,0.121,NULL,41296396006,645256187,10082127,14.9),(63481,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63481,33.35,0.49,46.8,22073,75,NULL,'IR','MCG -01-25-022',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63482,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63482,33.51,0.43,50.3,22073,75,NULL,'MAT, I, raw','MCG -01-25-022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63483,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63483,33.55,0.32,51.2,22073,85,NULL,'I, raw','MCG -01-25-022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63484,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63484,33.59,0.32,52.2,22073,85,NULL,'I, inv','MCG -01-25-022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63485,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63485,33.7,0.2,55,22073,74.4,NULL,NULL,'MCG -01-25-022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63486,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63486,33.71,0.47,55.1,22073,NULL,NULL,'H','MCG -01-25-022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63487,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63487,33.71,0.43,55.2,22073,75,NULL,'MAT, I, inv','MCG -01-25-022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63488,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63488,33.81,0.46,57.7,22073,NULL,NULL,'J','MCG -01-25-022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63489,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63489,33.82,0.45,58,22073,NULL,NULL,'K','MCG -01-25-022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63490,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63490,33.9,0.43,60.2,22073,NULL,NULL,NULL,'MCG -01-25-022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63491,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63491,33.94,0.43,61.3,22073,75,NULL,'MAT, I, cor','MCG -01-25-022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63492,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63492,34.03,0.41,64,22073,NULL,NULL,'Malmquist cor.','MCG -01-25-022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63493,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63493,34.11,0.4,66.5,22073,NULL,NULL,'mean','MCG -01-25-022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63494,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63494,38.35,0.46,467,22074,70,NULL,NULL,'2MASX J09421398+3410028',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000171,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,145.5582917,34.16756,0.009,NULL,64185763294,1002902551,15670352,17.8),(63495,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63495,36.22,0.46,175,22075,70,NULL,NULL,'2MASX J09421415+1606319',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,145.5590417,16.10889,0.073,NULL,63726751189,995730487,15558288,16.4),(63496,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63496,37.9,0.46,380,22076,70,NULL,NULL,'2MASX J09421457+3706450',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,145.560875,37.11247,0,NULL,64176910171,1002764221,15668190,17.6),(63497,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63497,36.64,0.46,213,22077,70,NULL,NULL,'2MASX J09421738+5001565',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,145.5725417,50.03233,0,NULL,64018623617,1000290994,15629546,16.7),(63498,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63498,38.12,0.46,421,22078,70,NULL,NULL,'SDSS J094218.37+393318.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,145.5765417,39.55514,0.029,NULL,64391216116,1006112751,15720511,18.4),(63499,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63499,37.25,0.46,282,22079,70,NULL,NULL,'2MASX J09421932+2233421',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,145.5804583,22.56169,0.053,NULL,63747586524,996056039,15563375,17.2),(63500,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63500,35.64,0.46,134,22080,70,NULL,NULL,'CGCG 035-036',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000173,NULL,'15.7g',0.53,'S0/a','Group member',NULL,NULL,NULL,1,145.5905,4.35447,0.081,NULL,60911505178,951742268,14870972,15.7),(63501,'IRAS','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63501,32.29,0.8,28.7,22081,75,NULL,'MAT, I','MCG -01-25-024',NULL,'1997ApJS..109..333W',1997,1,1.8,'Confused HIPASS source','G',0.00003,NULL,'14',0.6,'SBd?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,145.5962917,-6.25142,0.085,NULL,41322464537,645663508,10088492,14),(63502,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63502,31.9,0.32,24,22081,85,NULL,'I, inv','MCG -01-25-024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63503,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63503,31.92,0.32,24.2,22081,85,NULL,'I, raw','MCG -01-25-024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63504,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63504,32.27,0.43,28.4,22081,75,NULL,'MAT, I, inv','MCG -01-25-024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63505,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63505,32.29,0.43,28.7,22081,75,NULL,'MAT, I, raw','MCG -01-25-024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63506,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63506,32.37,0.76,29.8,22081,NULL,NULL,'Malmquist cor.','MCG -01-25-024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63507,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63507,32.5,0.43,31.6,22081,75,NULL,'MAT, I, cor','MCG -01-25-024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63508,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63508,32.63,0.43,33.5,22081,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-25-024',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63509,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63509,32.64,0.2,33.7,22081,74.4,NULL,NULL,'MCG -01-25-024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63510,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63510,32.67,0.43,34.1,22081,75,NULL,'3.6 micron, color corrected','MCG -01-25-024',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63511,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63511,32.74,0.64,35.4,22081,NULL,NULL,NULL,'MCG -01-25-024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63512,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63512,32.89,0.4,37.8,22081,75,NULL,NULL,'MCG -01-25-024',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63513,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63513,33.1,0.49,41.8,22081,75,NULL,'IR','MCG -01-25-024',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63514,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63514,36.09,0.46,165,22082,70,NULL,NULL,'CGCG 122-057',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000179,NULL,'15.3g',0.48,NULL,NULL,NULL,NULL,NULL,1,145.602,25.23953,0.013,NULL,64165412517,1002584570,15665383,15.3),(63515,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63515,37.42,0.46,305,22083,70,NULL,NULL,'2MASX J09422544+4226341',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,145.605917,42.44267,0.033,NULL,63974009518,999593898,15618654,17.2),(63516,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63516,37.47,0.27,312,22084,70,NULL,NULL,'2MASX J09422548+0948189',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000182,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,145.606333,9.80544,0.033,NULL,60899994800,951562418,14868162,17.8),(63517,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63517,36.87,0.46,237,22085,70,NULL,NULL,'2MASX J09422669+2649276',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000163,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,145.611416667,26.82436,0,NULL,64214271150,1003347986,15677312,16.4),(63518,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63518,35.83,0.33,147,22086,70,NULL,NULL,'CGCG 152-055',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.00017,NULL,'15.2g',0.45,'E',NULL,NULL,NULL,NULL,1,145.613833,28.95281,0.005,NULL,64219609294,1003431395,15678615,15.2),(63519,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63519,36.35,0.46,186,22087,70,NULL,NULL,'2MASX J09422835+6226583',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000068,NULL,'16.6g',0.29,'S0/E0:',NULL,NULL,NULL,NULL,1,145.618167,62.44944,0.125,NULL,62041097793,969392153,15146752,16.6),(63520,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63520,35.96,0.63,155,22088,70,NULL,NULL,'2MASX J09423018-1101340',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,145.6257917,-11.02611,0.125,NULL,41306840942,645419389,10084677,14.3),(63521,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63521,37.21,0.46,277,22089,70,NULL,NULL,'2MASX J09423098+0151082',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000075,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,145.6289583,1.85219,0.165,NULL,60684970692,948202667,14815666,17.4),(63522,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63522,36.64,0.46,213,22090,70,NULL,NULL,'2MASX J09423204+1713333',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000179,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,145.633458333,17.22606,0.045,NULL,63727460386,995741568,15558462,16.9),(63523,'SBF','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63523,31.66,0.24,21.5,22091,NULL,NULL,'I','NGC 2974',NULL,'2001ApJ...546..681T',2001,1,3.5,NULL,'G',0.000017,NULL,'12.30',2,'E4  Sy2        LINER','Group member, radial-velocity confirmed',NULL,NULL,'Sy 2',1,145.638666667,-3.69914,0.109,NULL,41295150771,645236730,10081823,12.3),(63524,'SBF','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63524,31.66,0.24,21.5,22091,NULL,NULL,NULL,'NGC 2974',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63525,'SBF','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63525,31.72,0.14,22.1,22091,74.4,NULL,NULL,'NGC 2974',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63526,'SBF','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63526,31.76,0.24,22.4,22091,NULL,NULL,'Malmquist cor.','NGC 2974',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63527,'D-Sigma','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63527,31.82,0.4,23.2,22091,75,NULL,'Edat, raw','NGC 2974',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63528,'D-Sigma','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63528,32.16,0.4,27,22091,75,NULL,'Edat, cor','NGC 2974',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63529,'Faber-Jackson','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63529,31.87,0.37,23.7,22091,95,NULL,'Weighted Mean','NGC 2974',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63530,'Faber-Jackson','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63530,31.87,0.63,23.7,22091,95,NULL,'Michard 1979b, c','NGC 2974',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63531,'Faber-Jackson','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63531,32.28,0.46,28.6,22091,95,NULL,'Michard 1979a','NGC 2974',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63532,'Faber-Jackson','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63532,33.45,0.81,49,22091,55,NULL,'Visvanathan & Sandage 1979','NGC 2974',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63533,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63533,32.26,0.41,28.3,22091,NULL,NULL,NULL,'NGC 2974',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63534,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63534,32.39,0.41,30.1,22091,NULL,NULL,'Malmquist cor.','NGC 2974',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63535,'Tully est','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63535,32.28,0.8,28.5,22091,75,NULL,'B','NGC 2974',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63536,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63536,30.36,0.45,11.8,22091,NULL,NULL,'K','NGC 2974',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63537,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63537,32.6,0.4,33,22091,NULL,NULL,'mean','NGC 2974',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63538,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63538,37.77,0.46,359,22092,70,NULL,NULL,'2MASX J09423442+0424552',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,145.6434583,4.41544,0.081,NULL,60911474077,951741782,14870965,17.7),(63539,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63539,37.62,0.46,334,22093,70,NULL,NULL,'2MASX J09423478+3716311',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,145.6449583,37.27539,0,NULL,64176892260,1002763941,15668186,17.6),(63540,'SBF','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63540,30.87,0.27,14.9,22094,NULL,NULL,'I','NGC 2950',NULL,'2001ApJ...546..681T',2001,1,2.54,NULL,'G',0.000017,NULL,'11.7g',1.39,'(R)SB(r)0^0^','Field galaxy',NULL,NULL,NULL,1,145.6464583,58.85128,0.029,NULL,61929446346,967647599,15119493,11.7),(63541,'SBF','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63541,30.92,0.14,15.3,22094,74.4,NULL,NULL,'NGC 2950',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63542,'Faber-Jackson','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63542,30.77,0.43,14.3,22094,95,NULL,'Weighted Mean','NGC 2950',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63543,'Faber-Jackson','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63543,31.32,0.57,18.4,22094,95,NULL,'de Vaucouleurs','NGC 2950',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63544,'Faber-Jackson','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63544,31.54,0.81,20.3,22094,55,NULL,'Visvanathan & Sandage 1979','NGC 2950',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63545,'Tertiary','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63545,31.55,0.25,20.4,22094,95,NULL,NULL,'NGC 2950',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63546,'Tully est','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63546,31.84,0.8,23.3,22094,75,NULL,'B','NGC 2950',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63547,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63547,31.52,0.45,20.1,22094,NULL,NULL,'K','NGC 2950',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63548,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63548,31.67,0.4,21.6,22094,NULL,NULL,'mean','NGC 2950',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63549,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63549,36.58,0.46,207,22095,70,NULL,NULL,'2MASX J09423658+0234162',NULL,'2015arXiv151105856S',2015,1,0.42,'The Lick and 2MASS images include a superposed star.','G',0.000099,NULL,'16.0g',0.37,'E0',NULL,NULL,NULL,NULL,1,145.65225,2.57117,0.113,NULL,60684400646,948193760,14815527,16),(63550,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63550,37.44,0.21,308,22096,70,NULL,NULL,'2MASX J09423722+6048563',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00008,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,145.655291667,60.81556,0.053,NULL,62035709224,969307956,15145436,17.4),(63551,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63551,38.11,0.33,419,22097,70,NULL,NULL,'2MASX J09423771+0205332',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000099,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,145.657041667,2.09253,0.113,NULL,60684853260,948200832,14815638,17),(63552,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63552,37.39,0.46,300,22098,70,NULL,NULL,'2MASX J09423787+3447477',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000182,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,145.6577083,34.7965,0,NULL,64189608909,1002962639,15671291,16.9),(63553,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63553,37.35,0.46,296,22099,70,NULL,NULL,'2MASX J09424019+4310011',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000182,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,145.667417,43.16706,0.013,NULL,63974233495,999597398,15618709,16.2),(63554,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63554,38.28,0.46,453,22100,70,NULL,NULL,'2MASX J09424192+0941319',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000126,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,145.67475,9.69228,0.033,NULL,60899586664,951556041,14868063,18.5),(63555,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63555,38.07,0.23,411,22101,70,NULL,NULL,'SDSS J094244.63+054841.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,145.686,5.81142,0.093,NULL,60910585101,951727892,14870748,18.3),(63556,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63556,35.28,0.46,114,22102,70,NULL,NULL,'CGCG 092-033',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000147,NULL,'15.5',0.43,NULL,NULL,NULL,NULL,NULL,1,145.689666667,14.66136,0.105,NULL,60819608010,950306375,14848537,15.5),(63557,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63557,37.08,0.46,260,22103,70,NULL,NULL,'2MASX J09424826-0041034',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,145.701083,-0.68425,0.137,NULL,41105197992,642268718,10035448,17.6),(63558,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63558,37.57,0.46,326,22104,70,NULL,NULL,'SDSS J094248.31+060201.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,145.701291667,6.03372,0.085,NULL,60909816827,951715887,14870560,18.3),(63559,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63559,37.47,0.27,312,22105,70,NULL,NULL,'2MASX J09424877+0947015',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000187,NULL,'15.8g',0.5,'E0',NULL,NULL,NULL,NULL,1,145.703208333,9.78386,0.033,NULL,60899540713,951555323,14868051,15.8),(63560,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63560,34.67,0.4,85.8,22106,NULL,NULL,'mean','MCG -01-25-026',NULL,'2007A&A...465...71T',2007,1,2.2,NULL,'G',0.000023,NULL,'15',0.4,'Sb: sp         HII',NULL,NULL,NULL,NULL,1,145.704667,-6.74178,0.077,NULL,41323255676,645675869,10088685,15),(63561,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63561,34.98,0.49,98.9,22106,75,NULL,'IR','MCG -01-25-026',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63562,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63562,35.12,0.47,106,22106,NULL,NULL,'H','MCG -01-25-026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63563,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63563,37.22,0.27,278,22107,70,NULL,NULL,'2MASX J09424944+6657419',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,145.706,66.96153,0.181,NULL,62251813528,972684586,15198196,17.9),(63564,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63564,36.31,0.63,182,22108,70,NULL,NULL,'2MASX J09425011-2628090',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,145.70875,-26.46925,0.197,NULL,42819972438,669062069,10454094,15.7),(63565,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63565,32.92,NULL,38.4,22109,NULL,NULL,NULL,'SDSS J094250.98+045322.0',NULL,'2015AstBu..70....1K',2015,1,NULL,NULL,'G',0.000145,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,145.712083,4.89,0.125,NULL,60913581754,951774714,14871479,NULL),(63566,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63566,31.76,NULL,22.5,22110,NULL,NULL,NULL,'SDSS J094251.25+093757.6',NULL,'2015AstBu..70....1K',2015,1,NULL,'17th mag star superposed.','G',0.000057,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,145.713333,9.63333,0.033,NULL,60899562562,951555665,14868057,NULL),(63567,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63567,35.79,0.57,144,22111,70,NULL,NULL,'2MASX J09425202-2856430',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,145.716667,-28.94525,0.473,NULL,42878810316,669981411,10468459,15.5),(63568,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63568,36.75,0.46,224,22112,70,NULL,NULL,'2MASX J09425222+4732511',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000161,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,145.7175,47.54767,0.017,NULL,64015510457,1000242350,15628786,16.6),(63569,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63569,37.69,0.46,345,22113,70,NULL,NULL,'2MASX J09425226+0739505',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,145.71775,7.66397,0.045,NULL,60892538326,951445911,14866342,17.3),(63570,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63570,37.43,0.46,306,22114,70,NULL,NULL,'2MASX J09425227+0605055',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,145.717958333,6.08472,0.085,NULL,60909817554,951715899,14870560,17.3),(63571,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63571,37.99,0.46,396,22115,70,NULL,NULL,'SDSS J094252.93+032923.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000161,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,145.720583333,3.48978,0.081,NULL,60910950192,951733596,14870837,18.6),(63572,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63572,35.74,0.49,140,22116,70,NULL,NULL,'2MASX J09425310-2849460',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000137,NULL,'14.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,145.721166667,-28.82939,0.473,NULL,42878819638,669981556,10468461,14.2),(63573,'SNII optical','2016-12-15 15:14:31','2016-12-16 11:19:37','1','SN 2010jl','R',63573,33.45,NULL,49,22117,NULL,NULL,'Dense Shell Method (Baade ruler)','UGC 05189 NED01',NULL,'2013JETPL..98..432B',2013,1,0.8,'Misidentified in UGC as \'MCG +02-25-023\'.','G',0.000123,NULL,'13.75',0.6,'IRR_SY',NULL,NULL,NULL,NULL,1,145.722625,9.49497,0.045,NULL,60899689733,951557652,14868088,13.75),(63574,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63574,35.12,0.48,106,22118,70,NULL,NULL,'2MFGC 07534',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000133,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,145.725375,-15.81783,0.225,NULL,42304901958,661014093,10328345,14.3),(63575,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63575,35.2,0.27,110,22119,70,NULL,NULL,'CGCG 181-084',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000077,NULL,'15.3g',0.49,NULL,'Group member',NULL,NULL,NULL,1,145.725417,36.21397,0,NULL,64176010695,1002750167,15667971,15.3),(63576,'Ring Diameter','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63576,31,0.98,16,22120,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 2964',NULL,'1981ApJS...45..541P',1981,1,2.9,'One of two 6cm sources associated with [WB92] 0940+3206','G',0.00004,NULL,'12.00',1.6,'SAB(r)bc       HII','Pair member (points to parent)',NULL,NULL,NULL,1,145.725958333,31.84739,0.021,NULL,64215957806,1003374340,15677724,12),(63577,'Ring Diameter','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63577,31.6,0.76,21,22120,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 2964',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63578,'IRAS','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63578,31.83,0.8,23.3,22120,75,NULL,'CF, r','NGC 2964',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63579,'Tully est','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63579,31.7,0.8,21.9,22120,75,NULL,'B','NGC 2964',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63580,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63580,30.48,0.69,12.5,22120,100,NULL,'mid-IR','NGC 2964',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63581,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63581,31.01,0.4,15.9,22120,73,NULL,'opt','NGC 2964',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63582,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63582,31.1,0.33,16.6,22120,NULL,NULL,'Malmquist cor.','NGC 2964',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63583,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63583,31.16,0.32,17.1,22120,NULL,NULL,NULL,'NGC 2964',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63584,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63584,31.21,0.2,17.5,22120,74.4,NULL,NULL,'NGC 2964',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63585,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63585,31.6,0.38,20.9,22120,75,NULL,'CF, r, raw','NGC 2964',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63586,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63586,31.66,0.45,21.5,22120,NULL,NULL,'K','NGC 2964',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63587,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63587,31.69,0.47,21.7,22120,NULL,NULL,'H','NGC 2964',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63588,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63588,31.7,0.38,21.8,22120,75,NULL,'CF, r, inv','NGC 2964',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63589,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63589,31.72,0.46,22.1,22120,NULL,NULL,'J','NGC 2964',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63590,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63590,31.81,0.38,23,22120,75,NULL,'CF, r, cor','NGC 2964',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63591,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63591,31.83,0.4,23.2,22120,NULL,NULL,'mean','NGC 2964',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63592,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63592,33.97,0.46,62.2,22121,70,NULL,NULL,'CGCG 063-049',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000057,NULL,'14.7g',0.39,'S0-a',NULL,NULL,NULL,NULL,1,145.727,12.3865,0.041,NULL,60819217960,950300280,14848441,14.7),(63593,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63593,38.36,0.46,469,22122,70,NULL,NULL,'2MASX J09425504+0258198',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000183,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,145.7292917,2.97219,0.093,NULL,60903404315,951615692,14868995,17.1),(63594,'IRAS','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63594,35.37,0.8,119,22123,75,NULL,'CF, r','UGC 05185',NULL,'1997ApJS..109..333W',1997,1,1.18,NULL,'G',0.000107,NULL,'14.0g',0.65,'Spiral',NULL,NULL,NULL,NULL,1,145.7297917,28.98078,0.005,NULL,64219874438,1003435538,15678680,14),(63595,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63595,34.99,0.38,99.5,22123,75,NULL,'CF, r, raw','UGC 05185',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63596,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63596,35.17,0.38,108,22123,75,NULL,'CF, r, cor','UGC 05185',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63597,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63597,35.21,0.38,110,22123,75,NULL,'CF, r, inv','UGC 05185',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63598,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63598,35.26,0.47,113,22123,NULL,NULL,'H','UGC 05185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63599,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63599,35.41,0.46,121,22123,NULL,NULL,'J','UGC 05185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63600,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63600,35.46,0.45,124,22123,NULL,NULL,'K','UGC 05185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63601,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63601,35.49,0.4,126,22123,NULL,NULL,'mean','UGC 05185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63602,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63602,37.17,0.33,271,22124,70,NULL,NULL,'SDSS J094255.82+424618.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,145.732667,42.77189,0.025,NULL,63974433725,999600526,15618758,18.1),(63603,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63603,37.63,0.46,335,22125,70,NULL,NULL,'2MASX J09425700+0423598',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00019,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,145.737583333,4.39994,0.085,NULL,60911476839,951741825,14870966,17.1),(63604,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63604,38.21,0.46,439,22126,70,NULL,NULL,'2MASX J09425764+3646030',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000184,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,145.740125,36.76767,0,NULL,64176254304,1002753973,15668030,17.5),(63605,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63605,36.73,0.46,222,22127,70,NULL,NULL,'2MASX J09425865+3549389',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,145.744541667,35.82753,0,NULL,64188634935,1002947420,15671053,17.4),(63606,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63606,29.6,NULL,8.32,22128,NULL,NULL,NULL,'UGC 05186',NULL,'2013AJ....145..101K',2013,1,1.09,NULL,'G',0.000005,NULL,'15.7g',0.34,'Im',NULL,NULL,NULL,NULL,1,145.744417,33.26558,0.009,NULL,64185506560,1002898540,15670289,15.7),(63607,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63607,37.23,0.46,280,22129,70,NULL,NULL,'2MASX J09425942+5445318',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000071,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,145.7474583,54.75903,0,NULL,61879231519,966862992,15107234,17.4),(63608,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63608,37.44,0.21,308,22130,70,NULL,NULL,'2MASX J09425997+6042122',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000092,NULL,'16.9g',0.25,'NLAGN',NULL,NULL,NULL,'Sy 2',1,145.7499583,60.70331,0.057,NULL,62035710278,969307973,15145437,16.9),(63609,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63609,37.17,0.33,271,22131,70,NULL,NULL,'2MASX J09430142+4248201',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000139,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,145.756083,42.80569,0.017,NULL,63974317438,999598709,15618729,17.6),(63610,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63610,37.41,0.46,303,22132,70,NULL,NULL,'2MASX J09430213+6008325',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000087,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,145.7587917,60.14242,0.045,NULL,61914512757,967414261,15115847,16.8),(63611,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63611,36.09,0.33,165,22133,70,NULL,NULL,'CGCG 063-050 NED01',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00018,NULL,'15.65',NULL,NULL,NULL,NULL,NULL,NULL,1,145.7589583,14.14942,0.085,NULL,60820510323,950320473,14848757,15.65),(63612,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63612,37.71,0.46,349,22134,70,NULL,NULL,'2MASX J09430322+5958095',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000063,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,145.763583,59.96928,0.049,NULL,61915746877,967433544,15116149,18.2),(63613,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63613,38.38,0.46,474,22135,70,NULL,NULL,'SDSS J094303.91+415610.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00016,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,145.766291667,41.93633,0.033,NULL,63975180360,999612193,15618940,18.5),(63614,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63614,36.27,0.46,180,22136,70,NULL,NULL,'2MASX J09430431+1517342',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'17.27',NULL,NULL,NULL,NULL,NULL,NULL,1,145.7680417,15.29281,0.065,NULL,63734585054,995852891,15560201,17.27),(63615,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63615,35.34,0.33,117,22137,70,NULL,NULL,'CGCG 122-060',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.00016,NULL,'15.2g',0.57,NULL,'Group member',NULL,NULL,NULL,1,145.772833,22.77614,0.049,NULL,63692193435,995190522,15549851,15.2),(63616,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63616,37.84,0.46,369,22138,70,NULL,NULL,'2MASX J09430696+6915295',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,145.778583,69.25819,0.189,NULL,62097575851,970274622,15160540,17.5),(63617,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63617,37.47,0.27,312,22139,70,NULL,NULL,'2MASX J09430730+0939285',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000183,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,145.780333,9.65781,0.033,NULL,60900665155,951572893,14868326,17.6),(63618,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63618,35.29,0.46,114,22140,70,NULL,NULL,'CGCG 035-039',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000106,NULL,'15.5g',0.45,'E0',NULL,NULL,NULL,NULL,1,145.782,3.43006,0.089,NULL,60910752355,951730505,14870789,15.5),(63619,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63619,34.29,0.49,72.2,22141,75,NULL,'IR','UGC 05192',NULL,'2011yCatp016004901K',2011,1,2.07,NULL,'G',0.000033,NULL,'14.2g',0.57,'SBb:',NULL,NULL,NULL,NULL,1,145.785625,21.18236,0.045,NULL,63749410309,996084536,15563820,14.2),(63620,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63620,34.41,0.4,76.3,22141,NULL,NULL,'mean','UGC 05192',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63621,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63621,34.5,0.47,79.4,22141,NULL,NULL,'H','UGC 05192',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63622,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63622,34.59,0.46,82.7,22141,NULL,NULL,'J','UGC 05192',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63623,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63623,34.65,0.45,85.1,22141,NULL,NULL,'K','UGC 05192',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63624,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63624,34.68,0.5,86.2,22141,NULL,NULL,NULL,'UGC 05192',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63625,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63625,34.72,0.2,87.9,22141,74.4,NULL,NULL,'UGC 05192',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63626,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63626,34.76,0.48,89.6,22141,NULL,NULL,'Malmquist cor.','UGC 05192',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63627,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63627,34.12,0.2,66.7,22142,74.4,NULL,NULL,'NGC 2979',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.00005,NULL,'13.92',0.9,'(R\')SA(r)a?    Sy2',NULL,NULL,NULL,NULL,1,145.7860417,-10.38325,0.125,NULL,41321460724,645647823,10088247,13.92),(63628,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63628,38.76,0.46,565,22143,70,NULL,NULL,'2MASX J09430899+0313168',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000175,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,145.787333,3.22142,0.093,NULL,60914933939,951795842,14871810,17.6),(63629,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63629,36.52,0.46,201,22144,70,NULL,NULL,'2MASX J09431043+0111078',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000097,NULL,'17.8g',0.19,'NLAGN',NULL,NULL,NULL,'Sy 2',1,145.793375,1.18567,0.265,NULL,60683475509,948179304,14815301,17.8),(63630,'IRAS','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63630,34.5,0.8,79.6,22145,75,NULL,'MAT, I','NGC 2980',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.00003,NULL,'13.6',0.9,'SAB(s)c?       HII','in a pair',NULL,NULL,NULL,1,145.799875,-9.61239,0.129,NULL,41321859054,645654047,10088344,13.6),(63631,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63631,34.18,NULL,68.6,22145,NULL,NULL,'B','NGC 2980',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63632,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63632,34.19,0.13,68.9,22145,NULL,NULL,'B, Hubble-type-TF','NGC 2980',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63633,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63633,34.21,0.43,69.5,22145,75,NULL,'MAT, I, raw','NGC 2980',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63634,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63634,34.22,0.47,69.8,22145,NULL,NULL,'H','NGC 2980',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63635,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63635,34.23,0.45,70.2,22145,NULL,NULL,'K','NGC 2980',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63636,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63636,34.27,0.46,71.5,22145,NULL,NULL,'J','NGC 2980',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63637,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63637,34.29,0.32,72.1,22145,85,NULL,'I, raw','NGC 2980',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63638,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63638,34.36,0.32,74.6,22145,85,NULL,'I, inv','NGC 2980',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63639,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63639,34.47,NULL,78.3,22145,NULL,NULL,'I','NGC 2980',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63640,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63640,34.5,0.43,79.4,22145,75,NULL,'MAT, I, cor','NGC 2980',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63641,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63641,34.52,0.43,80,22145,75,NULL,'MAT, I, inv','NGC 2980',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63642,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63642,34.59,0.4,82.7,22145,NULL,NULL,'mean','NGC 2980',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63643,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63643,34.68,0.43,86.3,22145,NULL,NULL,'Malmquist cor.','NGC 2980',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63644,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63644,34.87,0.2,94.2,22145,74.4,NULL,NULL,'NGC 2980',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63645,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63645,35.04,0.36,102,22145,NULL,NULL,NULL,'NGC 2980',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63646,'Tully est','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63646,32.06,0.8,25.9,22146,75,NULL,'B','NGC 2968',NULL,'1988NBGC.C....0000T',1988,1,1.89,NULL,'G',0.000097,NULL,'12.9g',1.3,'I0','Pair member (points to parent)',NULL,NULL,NULL,1,145.8000417,31.92869,0.021,NULL,64216048235,1003375753,15677746,12.9),(63647,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63647,29.2,0.47,6.93,22146,NULL,NULL,'H','NGC 2968',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63648,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63648,29.38,0.45,7.53,22146,NULL,NULL,'K','NGC 2968',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63649,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63649,29.43,0.46,7.69,22146,NULL,NULL,'J','NGC 2968',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63650,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63650,31.65,0.4,21.4,22146,NULL,NULL,'mean','NGC 2968',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63651,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63651,31.71,NULL,22,22146,NULL,NULL,NULL,'NGC 2968',NULL,'2011A&A...536A.103Z',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63652,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63652,36.91,0.27,241,22147,70,NULL,NULL,'2MASX J09431218+0618085',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000181,NULL,'16.1g',0.35,'E0',NULL,NULL,NULL,NULL,1,145.800875,6.30231,0.077,NULL,60919044035,951860063,14872813,16.1),(63653,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63653,37.05,0.46,257,22148,70,NULL,NULL,'SDSS J094312.68+281519.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,145.802833,28.25528,0.017,NULL,64212624411,1003322256,15676910,17.9),(63654,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63654,36.09,0.33,165,22149,70,NULL,NULL,'2MASX J09431317+1411562',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.52',0.32,NULL,NULL,NULL,NULL,NULL,1,145.804833,14.19886,0.097,NULL,60820552920,950321139,14848767,17.52),(63655,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63655,35.24,0.46,112,22150,70,NULL,NULL,'2MASX J09431321+4118581',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,145.805083,41.31628,0.045,NULL,63972310960,999567358,15618239,16.4),(63656,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63656,36.4,0.46,191,22151,70,NULL,NULL,'2MASX J09431448+2508461',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,145.810417,25.14622,0.029,NULL,64164898612,1002576540,15665258,17.4),(63657,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63657,38.07,0.46,411,22152,70,NULL,NULL,'2MASX J09431527+2047448',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000185,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,145.81375,20.79575,0.053,NULL,63742280307,995973129,15562080,17.3),(63658,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63658,36.31,0.46,183,22153,70,NULL,NULL,'2MASX J09431530+2405071',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000161,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,145.8137917,24.08525,0.037,NULL,63691306789,995176668,15549635,17.1),(63659,'SNIa','2016-12-15 15:14:31','2016-12-16 11:19:37','1','SN 2008Z','R',63659,34.99,0.11,99.5,22154,NULL,NULL,'MLCS2k2, R(V) = 3.1','SDSS J094315.35+361709.2',NULL,'2015Sci...347.1459K',2015,1,0.55,NULL,'G',0.000226,NULL,'17.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,145.814,36.28589,0,NULL,64176002824,1002750044,15667969,17.8),(63660,'SNIa','2016-12-15 15:14:31','2016-12-16 11:19:37','1','SN 2008Z','R',63660,35.07,0.09,103,22154,NULL,NULL,'MLCS2k2, R(V) = 1.8','SDSS J094315.35+361709.2',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63661,'SNIa','2016-12-15 15:14:31','2016-12-16 11:19:37','1','SN 2008Z',NULL,63661,35.24,0.17,109,22154,70,NULL,'SALT 2','SDSS J094315.35+361709.2',0.02099,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63662,'SNIa','2016-12-15 15:14:31','2016-12-16 11:19:37','1','SN 2008Z',NULL,63662,35.4,0.2,118,22154,73.8,NULL,'SALT 2 (SNANA)','SDSS J094315.35+361709.2',0.0221,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63663,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63663,37.27,0.46,285,22155,70,NULL,NULL,'2MASX J09431545+0256583',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000202,NULL,'16.3g',0.34,'E0',NULL,NULL,NULL,NULL,1,145.814333,2.94964,0.105,NULL,60903455155,951616486,14869007,16.3),(63664,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63664,38.07,0.23,411,22156,70,NULL,NULL,'SDSS J094315.77+055318.9',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000161,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,145.81575,5.88858,0.093,NULL,60910298004,951723406,14870678,18.7),(63665,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63665,34.97,0.46,98.6,22157,70,NULL,NULL,'CGCG 210-026',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000161,NULL,'14.9g',0.68,'E0',NULL,NULL,NULL,NULL,1,145.819625,38.87839,0,NULL,64172974122,1002702720,15667230,14.9),(63666,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63666,33.07,0.4,41.1,22158,NULL,NULL,'mean','NGC 2978',NULL,'2007A&A...465...71T',2007,1,1,'6dF DR2 has z = 0.018838.','G',0.000037,NULL,'13.5',0.9,'(R\')SAB(rs)bc? HII','in a pair',NULL,NULL,NULL,1,145.82,-9.74589,0.129,NULL,41321880981,645654390,10088349,13.5),(63667,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63667,34.99,0.47,99.7,22158,NULL,NULL,'H','NGC 2978',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63668,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63668,34.99,0.45,99.7,22158,NULL,NULL,'K','NGC 2978',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63669,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63669,35.03,0.46,101,22158,NULL,NULL,'J','NGC 2978',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63670,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63670,37.02,0.46,253,22159,70,NULL,NULL,'2MASX J09431721+1123198',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00018,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,145.8217917,11.38889,0.033,NULL,60887221587,951362837,14865044,16.9),(63671,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63671,33.37,0.2,47.2,22160,74.4,NULL,NULL,'MCG -02-25-013',NULL,'2013AJ....146...86T',2013,1,2.6,NULL,'G',0.000007,NULL,'14.39',1.3,'SAB(s)d',NULL,NULL,NULL,NULL,1,145.8245417,-9.94567,0.149,NULL,41322100673,645657823,10088403,14.39),(63672,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63672,33.39,0.4,47.6,22160,NULL,NULL,'mean','MCG -02-25-013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63673,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63673,33.46,0.43,49.3,22160,75,NULL,'3.6 micron, color corrected','MCG -02-25-013',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63674,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63674,33.61,0.43,52.8,22160,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-25-013',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63675,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63675,34.13,0.45,67,22160,NULL,NULL,'K','MCG -02-25-013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63676,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63676,34.14,0.47,67.2,22160,NULL,NULL,'H','MCG -02-25-013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63677,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63677,37.91,0.33,383,22161,70,NULL,NULL,'2MASX J09431867+2253273',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,145.82775,22.89086,0.065,NULL,63692314368,995192412,15549881,17.2),(63678,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63678,37.54,0.46,322,22162,70,NULL,NULL,'2MASX J09431907+3308304',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000192,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,145.829667,33.14197,0.013,NULL,64185509469,1002898585,15670290,16.8),(63679,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63679,35.2,0.27,110,22163,70,NULL,NULL,'NGC 2965',NULL,'2015arXiv151105856S',2015,1,1.35,NULL,'G',0.000043,NULL,'14.0g',0.92,'S0             Sy?','Group member',NULL,NULL,'Flat-Spectrum Radio Source',1,145.8297917,36.24781,0,NULL,64176003749,1002750058,15667969,14),(63680,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63680,37.91,0.33,383,22164,70,NULL,NULL,'2MASX J09431990+2255143',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,145.832833,22.92078,0.065,NULL,63692313848,995192403,15549881,17.9),(63681,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63681,38.07,0.23,411,22165,70,NULL,NULL,'2MASX J09432089+0548073',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,145.837125,5.80211,0.093,NULL,60910291807,951723309,14870676,17.4),(63682,'Tully est','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63682,32.23,0.8,27.9,22166,75,NULL,NULL,'UGCA 173',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000019,NULL,'15',0.2,'SB(s)dm? sp','Pair member (points to parent)',NULL,NULL,NULL,1,145.8447083,-5.28322,0.097,NULL,41293579751,645212183,10081440,15),(63683,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63683,37.89,0.46,379,22167,70,NULL,NULL,'2MASX J09432283+0802228',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000195,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,145.84525,8.03975,0.045,NULL,60892478376,951444974,14866327,16.4),(63684,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63684,37.07,0.27,259,22168,70,NULL,NULL,'CGCG 122-062',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000097,NULL,'15.2g',0.55,NULL,'Group member',NULL,NULL,NULL,1,145.8455417,22.82039,0.049,NULL,63692185976,995190405,15549850,15.2),(63685,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63685,36.57,0.23,206,22169,70,NULL,NULL,'2MASX J09432302+3856030',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000091,NULL,'16.2g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,145.845958333,38.93419,0,NULL,64172977870,1002702779,15667230,16.2),(63686,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63686,36.91,0.27,241,22170,70,NULL,NULL,'2MASX J09432335+0618038',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000196,NULL,'15.9g',0.43,'E0',NULL,NULL,NULL,NULL,1,145.8472917,6.30103,0.077,NULL,60919048640,951860135,14872814,15.9),(63687,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63687,36.57,0.23,206,22171,70,NULL,NULL,'2MASX J09432600+3917390',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000156,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,145.858458333,39.29419,0,NULL,64391103093,1006110985,15720484,17),(63688,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63688,37.47,0.46,312,22172,70,NULL,NULL,'2MASX J09432613+0305323',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,145.8589583,3.09236,0.093,NULL,60914950663,951796104,14871814,18.2),(63689,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63689,36.65,0.46,214,22173,70,NULL,NULL,'2MASX J09432680+0246043',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000068,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,145.861667,2.76778,0.105,NULL,60903631695,951619245,14869050,16.8),(63690,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63690,38.05,0.33,407,22174,70,NULL,NULL,'2MASX J09432681+0820198',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,145.86175,8.33875,0.053,NULL,60892714553,951448664,14866385,18),(63691,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63691,37.07,0.27,259,22175,70,NULL,NULL,'2MASX J09432685+2253133',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000153,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,145.861875,22.88711,0.065,NULL,63692314112,995192408,15549881,17.9),(63692,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63692,38.05,0.33,407,22176,70,NULL,NULL,'2MASX J09432843+0818008',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000191,NULL,'16.6g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,145.868417,8.30033,0.053,NULL,60892713997,951448656,14866385,16.6),(63693,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63693,36.38,0.46,189,22177,70,NULL,NULL,'2MASX J09432900+6532157',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,145.8710417,65.53783,0.141,NULL,62258492699,972788948,15199827,16.6),(63694,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63694,38.53,0.46,508,22178,70,NULL,NULL,'SDSS J094329.68+270828.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,145.8737083,27.14131,0,NULL,64212204520,1003315695,15676807,18),(63695,'Tully est','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63695,32.13,0.8,26.7,22179,75,NULL,'B','NGC 2970',NULL,'1988NBGC.C....0000T',1988,1,0.83,NULL,'G',0.000027,NULL,'14.4g',0.73,'E1:','in an interacting pair',NULL,NULL,NULL,1,145.8794583,31.97697,0.021,NULL,64216052618,1003375822,15677747,14.4),(63696,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63696,32.13,0.4,26.6,22179,NULL,NULL,'mean','NGC 2970',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63697,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63697,32.3,0.45,28.8,22179,NULL,NULL,'K','NGC 2970',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63698,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63698,37.66,0.46,340,22180,70,NULL,NULL,'2MASX J09433119+3537314',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,145.879917,35.62539,0,NULL,64188615107,1002947111,15671048,17.4),(63699,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63699,35.13,0.49,106,22181,75,NULL,'IR','UGC 05194',NULL,'2011yCatp016004901K',2011,1,1.32,NULL,'G',0.000013,NULL,'16.0',0.16,'Sbc',NULL,NULL,NULL,NULL,1,145.88075,34.04208,0,NULL,64185806094,1002903220,15670362,16),(63700,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63700,35.27,NULL,113,22181,NULL,NULL,'Dipole + Quadrupole','UGC 05194',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63701,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63701,35.27,NULL,113,22181,NULL,NULL,'Dipole','UGC 05194',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63702,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63702,35.27,NULL,114,22181,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05194',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63703,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63703,35.47,NULL,124,22181,NULL,NULL,NULL,'UGC 05194',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63704,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,NULL,63704,35.57,0.2,130,22181,74.4,NULL,NULL,'UGC 05194',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63705,'FP','2016-12-15 15:14:31','2016-12-16 11:19:37','1',NULL,'R',63705,36.57,0.23,206,22182,70,NULL,NULL,'2MASX J09433189+3923490',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000214,NULL,'16.1g',0.43,'E0',NULL,NULL,NULL,NULL,1,145.883,39.39711,0,NULL,64390991356,1006109239,15720456,16.1),(63706,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63706,37.25,0.46,282,22183,70,NULL,NULL,'2MASX J09433196+4141200',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,145.883125,41.68894,0.041,NULL,63975163478,999611929,15618936,17.7),(63707,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63707,36.57,0.23,206,22184,70,NULL,NULL,'2MASX J09433225+3922110',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000168,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,145.884166667,39.36972,0,NULL,64390988369,1006109193,15720456,18),(63708,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63708,37.83,0.27,368,22185,70,NULL,NULL,'2MASX J09433373+0554428',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,145.890625,5.912,0.093,NULL,60910330884,951723920,14870686,18.3),(63709,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63709,38.14,0.46,425,22186,70,NULL,NULL,'SDSS J094334.34+282359.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000133,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,145.893083,28.39978,0.017,NULL,64212579312,1003321551,15676899,18.5),(63710,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63710,36.91,0.27,241,22187,70,NULL,NULL,'2MASX J09433528+0608478',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000168,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,145.897083,6.14644,0.085,NULL,60918469915,951851092,14872673,16.9),(63711,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63711,35.79,0.65,144,22188,70,NULL,NULL,'2MASX J09433597-2033567',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,145.899875,-20.56578,0.129,NULL,42340019503,661562804,10336918,14.8),(63712,'Tully est','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63712,32.3,0.8,28.8,22189,75,NULL,NULL,'UGCA 175',NULL,'1988NBGC.C....0000T',1988,1,2.2,'Confused HIPASS source','G',0.000017,NULL,'13.5',2.2,'SB(s)dm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,145.9012083,-5.91219,0.113,NULL,41293366320,645208848,10081388,13.5),(63713,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63713,38.32,0.46,462,22190,70,NULL,NULL,'SDSS J094336.43+402812.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00016,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,145.901833333,40.47003,0,NULL,64256839920,1004013123,15687705,18.7),(63714,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63714,38.5,0.46,501,22191,70,NULL,NULL,'2MASX J09433911+3526203',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,145.913125,35.43903,0,NULL,64188734005,1002948968,15671077,18),(63715,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63715,37.83,0.27,368,22192,70,NULL,NULL,'2MASX J09433925+0554333',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,145.913625,5.90928,0.093,NULL,60910323790,951723809,14870684,17.5),(63716,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63716,36.24,0.46,177,22193,70,NULL,NULL,'2MASX J09433934+1235557',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'16.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,145.913833,12.59875,0.049,NULL,60819144809,950299137,14848424,16.6),(63717,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63717,36.89,0.46,239,22194,70,NULL,NULL,'2MASX J09433945+4903159',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00017,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,145.9142083,49.05444,0,NULL,64017982374,1000280974,15629390,17),(63718,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63718,37.48,0.46,313,22195,70,NULL,NULL,'2MASX J09433985+6750597',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,145.915833,67.85,0.165,NULL,62248549045,972633578,15197399,17.2),(63719,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63719,34.82,0.46,91.8,22196,70,NULL,NULL,'NGC 2984',NULL,'2015arXiv151105856S',2015,1,0.86,NULL,'G',0.000067,NULL,'14.3g',0.75,'S0?','in a radial-velocity based grouping',NULL,NULL,NULL,1,145.91825,11.06086,0.025,NULL,60898626015,951541031,14867828,14.3),(63720,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63720,37.07,0.27,259,22197,70,NULL,NULL,'CGCG 122-064 NED01',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000213,NULL,'15.7g',0.46,NULL,NULL,NULL,NULL,NULL,1,145.919,22.79578,0.049,NULL,63692194403,995190537,15549852,15.7),(63721,'Faber-Jackson','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63721,31.67,0.65,21.6,22198,95,NULL,'Weighted Mean','NGC 2983',NULL,'1984ApJS...56...91D',1984,1,2.5,NULL,'G',0.000073,NULL,'12.76',1.5,'(RL)SB(s)0^+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,145.92125,-20.47719,0.129,NULL,42340024204,661562878,10336919,12.76),(63722,'Faber-Jackson','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63722,33.05,0.81,40.7,22198,55,NULL,'Visvanathan & Sandage 1979','NGC 2983',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63723,'Tully est','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63723,32.19,0.8,27.4,22198,75,NULL,'B','NGC 2983',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63724,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63724,37.83,0.27,368,22199,70,NULL,NULL,'SDSS J094342.83+053922.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,145.9285,5.65628,0.101,NULL,60910386833,951724794,14870699,18),(63725,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63725,37.83,0.46,369,22200,70,NULL,NULL,'2MASX J09434327+3214123',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00017,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,145.930333,32.23692,0,NULL,64216005505,1003375086,15677735,17.8),(63726,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63726,38.07,0.23,411,22201,70,NULL,NULL,'2MASX J09434342+0544149',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000141,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,145.931125,5.73753,0.101,NULL,60910418102,951725282,14870707,17.9),(63727,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63727,36.86,0.46,236,22202,70,NULL,NULL,'2MASX J09434405+3245343',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000173,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,145.9334583,32.75967,0.009,NULL,64183541255,1002867832,15669809,18.1),(63728,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63728,33.19,0.47,43.5,22203,NULL,NULL,'H','NGC 2977',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000007,NULL,'13.3',0.8,'Sb:','Isolated galaxy',NULL,NULL,NULL,1,145.942875,74.86022,0.033,NULL,61385122602,959142540,14986602,13.3),(63729,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63729,33.19,0.4,43.5,22203,NULL,NULL,'mean','NGC 2977',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63730,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63730,33.23,0.46,44.2,22203,NULL,NULL,'J','NGC 2977',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63731,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63731,33.26,0.45,44.8,22203,NULL,NULL,'K','NGC 2977',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63732,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63732,36,0.46,159,22204,70,NULL,NULL,'2MASX J09434655+1127225',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000087,NULL,'15.6g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,145.9440417,11.45642,0.029,NULL,60887503442,951367241,14865113,15.6),(63733,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63733,34.93,0.27,96.9,22205,70,NULL,NULL,'ARK 211',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.00015,NULL,'14.9g',0.65,'E0',NULL,NULL,NULL,NULL,1,145.94825,42.47361,0.033,NULL,63975588652,999618572,15619040,14.9),(63734,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63734,38.11,0.27,420,22206,70,NULL,NULL,'SDSS J094347.76+020451.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000068,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,145.949041667,2.08106,0.149,NULL,60903806749,951621980,14869093,18.2),(63735,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63735,35.92,0.46,153,22207,70,NULL,NULL,'CGCG 152-061',NULL,'2015arXiv151105856S',2015,1,0.86,NULL,'G',0.000177,NULL,'15.3g',0.5,NULL,NULL,NULL,NULL,NULL,1,145.9547917,30.54608,0.037,NULL,64220572574,1003446446,15678850,15.3),(63736,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63736,36.5,0.46,200,22208,70,NULL,NULL,'2MASX J09434914+1534027',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',NULL,NULL,'16.73',0.35,NULL,NULL,NULL,NULL,NULL,1,145.954875,15.56742,0.069,NULL,63726206120,995721970,15558155,16.73),(63737,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63737,37.59,0.46,330,22209,70,NULL,NULL,'2MASX J09434951+1106095',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000194,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,145.956333333,11.10258,0.025,NULL,60898573005,951540203,14867815,16.7),(63738,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63738,38.01,0.46,399,22210,70,NULL,NULL,'2MASX J09435270+5732196',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,145.969541667,57.53894,0.009,NULL,61930788944,967668577,15119821,17.4),(63739,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63739,36.61,0.33,210,22211,70,NULL,NULL,'2MASX J09435269+0049509',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000075,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,145.969667,0.83092,0.245,NULL,60683638389,948181849,14815341,17.5),(63740,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63740,38.11,0.27,420,22212,70,NULL,NULL,'2MASX J09435284+0206499',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000114,NULL,'17.6g',0.19,'BrClG          NLAGN',NULL,NULL,NULL,NULL,1,145.970125,2.11381,0.149,NULL,60903837077,951622454,14869100,17.6),(63741,'IRAS','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63741,32.65,0.8,33.9,22213,75,NULL,'MAT, I','ESO 373- G 021',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000026,NULL,'14.38',0.4,'SB(s)dm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,145.972625,-34.55925,0.781,NULL,42865211104,669768923,10465139,14.38),(63742,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63742,32.91,0.4,38.2,22213,75,NULL,NULL,'ESO 373- G 021',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63743,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63743,32.93,0.32,38.5,22213,85,NULL,'I, inv','ESO 373- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63744,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63744,32.94,0.32,38.8,22213,85,NULL,'I, raw','ESO 373- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63745,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63745,33.13,0.14,42.4,22213,NULL,NULL,NULL,'ESO 373- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63746,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63746,33.22,0.43,44.1,22213,75,NULL,'MAT, I, raw','ESO 373- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63747,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63747,33.23,0.43,44.2,22213,75,NULL,'MAT, I, inv','ESO 373- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63748,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63748,33.3,0.49,45.6,22213,75,NULL,'IR','ESO 373- G 021',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63749,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63749,33.43,0.43,48.6,22213,75,NULL,'MAT, I, cor','ESO 373- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63750,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63750,33.45,0.2,49,22213,74.4,NULL,NULL,'ESO 373- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63751,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63751,33.49,0.4,49.9,22213,NULL,NULL,NULL,'ESO 373- G 021',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63752,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63752,37.12,0.46,265,22214,70,NULL,NULL,'2MASX J09435526+1046185',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,145.9802083,10.77192,0.025,NULL,60898641322,951541270,14867832,17.5),(63753,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63753,37.99,0.46,396,22215,70,NULL,NULL,'2MASX J09435835+1033514',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000194,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,145.9932083,10.56433,0.025,NULL,60900400219,951568753,14868261,16.5),(63754,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63754,36.8,0.46,229,22216,70,NULL,NULL,'2MASX J09435869+1213471',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,145.994458333,12.22967,0.045,NULL,60819046476,950297601,14848400,17.4),(63755,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63755,36.73,0.46,222,22217,70,NULL,NULL,'SDSS J094358.67+521155.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,145.994458333,52.19881,0.005,NULL,64010851915,1000169561,15627649,17.7),(63756,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63756,37,0.46,251,22218,70,NULL,NULL,'2MASX J09435896+2635044',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000185,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,145.9957083,26.58469,0,NULL,64167934182,1002623971,15665999,16.4),(63757,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63757,34.93,0.27,96.9,22219,70,NULL,NULL,'CGCG 210-030',NULL,'2015arXiv151105856S',2015,1,1.04,NULL,'G',0.00015,NULL,'14.2g',0.81,'E0',NULL,NULL,NULL,NULL,1,145.996833,42.43294,0.033,NULL,63975589358,999618583,15619040,14.2),(63758,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63758,38.15,0.46,427,22220,70,NULL,NULL,'2MASX J09440018+0241109',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000082,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,146.00075,2.68633,0.113,NULL,60903601236,951618769,14869043,18.3),(63759,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63759,37.84,0.46,370,22221,70,NULL,NULL,'2MASX J09440110+0152249',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000109,NULL,'16.6g',0.36,'AGN',NULL,NULL,NULL,NULL,1,146.004625,1.87361,0.173,NULL,60903698223,951620284,14869066,16.6),(63760,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63760,35.07,0.54,103,22222,70,NULL,NULL,'2MASX J09440124-1415110',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.96',NULL,NULL,NULL,NULL,NULL,NULL,1,146.005083,-14.25319,0.217,NULL,41173283677,643332557,10052071,15.96),(63761,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63761,37.29,0.46,288,22223,70,NULL,NULL,'2MASX J09440174+0848364',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000145,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,146.00725,8.81028,0.013,NULL,60890255249,951410238,14865784,18.2),(63762,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63762,34.68,0.49,86.1,22224,75,NULL,'IR','FGC 0929',NULL,'2011yCatp016004901K',2011,1,0.74,NULL,'G',NULL,NULL,'16.8',0.09,'Scd',NULL,NULL,NULL,NULL,1,146.0095417,68.37022,0.157,NULL,62247676245,972619941,15197186,16.8),(63763,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63763,34.97,NULL,98.4,22224,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0929',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63764,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63764,34.99,NULL,99.3,22224,NULL,NULL,'Dipole + Quadrupole','FGC 0929',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63765,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63765,35.01,NULL,100,22224,NULL,NULL,'Dipole','FGC 0929',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63766,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63766,35.03,NULL,101,22224,NULL,NULL,NULL,'FGC 0929',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63767,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63767,38.34,0.46,466,22225,70,NULL,NULL,'2MASX J09440266+2823304',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,146.011083333,28.39175,0.025,NULL,64212574673,1003321479,15676898,18.1),(63768,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63768,38.48,0.33,497,22226,70,NULL,NULL,'2MASX J09440391+2336382',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00017,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,146.016333,23.61069,0.041,NULL,63694379367,995224677,15550385,18.4),(63769,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63769,37.35,0.46,295,22227,70,NULL,NULL,'2MASX J09440431+6206484',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000076,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,146.017875,62.1135,0.045,NULL,62039476128,969366814,15146356,17.7),(63770,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63770,37.75,0.46,355,22228,70,NULL,NULL,'2MASX J09440464+0509069',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,146.01925,5.15189,0.089,NULL,60913673817,951776153,14871502,17.5),(63771,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63771,38.02,0.46,403,22229,70,NULL,NULL,'SDSS J094404.97+155646.7',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.6g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,146.020791667,15.94633,0.093,NULL,63726335431,995723991,15558187,17.6),(63772,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63772,33.15,NULL,42.6,22230,NULL,NULL,'Dipole + Quadrupole + Octopole','FGCE 0768',NULL,'2010Ap&SS.325..163P',2010,1,0.86,'Matthews (2000A&AS..143..421M) may have detected a feature v=3775 km/sec.','G',0.000107,'?','16.9',0.12,'Sd',NULL,NULL,NULL,NULL,1,146.020833,-25.20306,0,NULL,42820430519,669069226,10454206,16.9),(63773,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63773,33.19,NULL,43.4,22230,NULL,NULL,'Dipole + Quadrupole','FGCE 0768',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63774,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63774,33.21,NULL,43.9,22230,NULL,NULL,'Dipole','FGCE 0768',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63775,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63775,33.27,NULL,45.1,22230,NULL,NULL,NULL,'FGCE 0768',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63776,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63776,36.61,0.33,210,22231,70,NULL,NULL,'2MASX J09440502+0044009',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.00009,NULL,'15.4g',0.54,'E0',NULL,NULL,NULL,NULL,1,146.020917,0.73356,0.225,NULL,60684109235,948189206,14815456,15.4),(63777,'Tully est','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63777,31,0.8,15.8,22232,75,NULL,NULL,'UGCA 177',NULL,'1988NBGC.C....0000T',1988,1,1.1,NULL,'G',0.000007,NULL,'15.17',0.9,'IAB(s)m:','X-ray-faint group member',NULL,NULL,NULL,1,146.021625,-32.16514,0.553,NULL,42872196717,669878073,10466844,15.17),(63778,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63778,34.71,0.46,87.7,22233,70,NULL,NULL,'ARK 212',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.00016,NULL,'14.9g',0.54,NULL,NULL,NULL,NULL,NULL,1,146.021667,18.12117,0.049,NULL,63725672557,995713633,15558025,14.9),(63779,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63779,38.11,0.27,420,22234,70,NULL,NULL,'2MASX J09440611+0205459',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000088,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,146.0255417,2.09619,0.149,NULL,60903854096,951622720,14869105,18.5),(63780,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63780,34.93,0.27,96.9,22235,70,NULL,NULL,'MCG +07-20-043',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000171,NULL,'16.0g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,146.0315,42.4305,0.033,NULL,63975603237,999618800,15619043,16),(63781,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63781,37.79,0.46,362,22236,70,NULL,NULL,'SDSS J094407.71+055038.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000151,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,146.032167,5.84406,0.093,NULL,60910465770,951726027,14870719,18.7),(63782,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63782,37.74,0.46,353,22237,70,NULL,NULL,'2MASX J09441015+2317042',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000157,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,146.0424583,23.28436,0.077,NULL,63694290170,995223283,15550363,17),(63783,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63783,37.55,0.46,323,22238,70,NULL,NULL,'2MASX J09441044+4713428',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000145,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,146.043583,47.22844,0.021,NULL,64014691800,1000229559,15628586,17.3),(63784,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63784,36.92,0.46,242,22239,70,NULL,NULL,'2MASX J09441168+0336189',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000199,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,146.048667,3.60519,0.089,NULL,60910834682,951731791,14870809,16.3),(63785,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63785,36.18,0.54,172,22240,70,NULL,NULL,'2MASX J09441233-2245054',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,146.0512917,-22.75153,0.161,NULL,42289511502,660773617,10324587,15.3),(63786,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63786,33.38,0.5,47.4,22241,70,NULL,NULL,'ESO 434- G 028',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000067,NULL,'13.12',1.2,'SA0-:    poss. LINER','Pair member (points to parent)',NULL,NULL,NULL,1,146.0542917,-28.84889,0.513,NULL,42879341191,669989706,10468589,13.12),(63787,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63787,36.17,0.46,172,22242,70,NULL,NULL,'2MASX J09441379-0005490',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000076,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,146.0572917,-0.09703,0.141,NULL,41104241665,642253776,10035215,16.7),(63788,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63788,37.98,0.46,395,22243,70,NULL,NULL,'2MASX J09441442+4253498',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000149,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,146.060375,42.89714,0.017,NULL,63974300391,999598443,15618725,18.3),(63789,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63789,37.44,0.46,307,22244,70,NULL,NULL,'2MASX J09441458+4522138',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,146.060667,45.37069,0.025,NULL,63984611323,999759551,15621242,17.2),(63790,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63790,36.49,0.46,199,22245,70,NULL,NULL,'2MASX J09441487+6659534',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,146.0617917,66.99814,0.153,NULL,62251274006,972676156,15198064,16.6),(63791,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63791,36.97,0.46,248,22246,70,NULL,NULL,'2MASX J09441543+0215329',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000077,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,146.06425,2.25908,0.149,NULL,60903832405,951622381,14869099,17),(63792,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63792,37.91,0.46,381,22247,70,NULL,NULL,'SDSS J094415.63+495342.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,146.065166667,49.89525,0,NULL,64018497954,1000289030,15629516,17.9),(63793,'SNIa','2016-12-15 15:14:31','2016-12-16 11:19:38','1','SN 1999gh',NULL,63793,32.38,0.24,29.7,22248,72,NULL,NULL,'NGC 2986',0.00768,'2006ApJ...645..488W',2006,1,3.2,NULL,'G',0.000014,NULL,'11.72',2.8,'E2;HII         BLLAC','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,146.066833,-21.278,0.089,NULL,42341516820,661586200,10337284,11.72),(63794,'SNIa','2016-12-15 15:14:31','2016-12-16 11:19:38','1','SN 1999gh',NULL,63794,32.41,0.1,30.3,22248,74.4,NULL,NULL,'NGC 2986',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63795,'SNIa','2016-12-15 15:14:31','2016-12-16 11:19:38','1','SN 1999gh',NULL,63795,32.6,0.25,32.9,22248,70,NULL,'SALT','NGC 2986',0.00768,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63796,'SNIa','2016-12-15 15:14:31','2016-12-16 11:19:38','1','SN 1999gh',NULL,63796,32.76,0.08,35.1,22248,65,NULL,'MLCS2k2','NGC 2986',0.00768,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63797,'SNIa','2016-12-15 15:14:31','2016-12-16 11:19:38','1','SN 1999gh',NULL,63797,32.86,0.12,37.3,22248,70.8,NULL,NULL,'NGC 2986',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63798,'SNIa','2016-12-15 15:14:31','2016-12-16 11:19:38','1','SN 1999gh',NULL,63798,33.08,0.14,41.3,22248,60,NULL,NULL,'NGC 2986',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63799,'D-Sigma','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63799,32.66,0.4,34,22248,75,NULL,'Edat, raw','NGC 2986',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63800,'D-Sigma','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63800,32.99,0.4,39.7,22248,75,NULL,'Edat, cor','NGC 2986',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63801,'Faber-Jackson','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63801,31.62,0.63,21.1,22248,95,NULL,'Michard 1979b, c','NGC 2986',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63802,'Faber-Jackson','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63802,31.65,0.37,21.4,22248,95,NULL,'Weighted Mean','NGC 2986',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63803,'Faber-Jackson','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63803,31.87,0.46,23.7,22248,95,NULL,'Michard 1979a','NGC 2986',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63804,'Faber-Jackson','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63804,33.42,0.81,48.3,22248,55,NULL,'Visvanathan & Sandage 1979','NGC 2986',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63805,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63805,32.53,0.5,32,22248,70,NULL,NULL,'NGC 2986',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63806,'Tully est','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63806,32.54,0.8,32.3,22248,75,NULL,'B','NGC 2986',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63807,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63807,32.18,0.4,27.3,22248,75,NULL,'HOSTS SN 1999gh','NGC 2986',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63808,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63808,32.85,0.4,37.2,22248,NULL,NULL,'mean','NGC 2986',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63809,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63809,33,0.45,39.8,22248,NULL,NULL,'K','NGC 2986',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63810,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63810,37,0.46,251,22249,70,NULL,NULL,'2MASX J09441645+6039315',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00008,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,146.06825,60.65878,0.057,NULL,62035659578,969307180,15145424,17.1),(63811,'Tully est','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63811,32.79,0.8,36.2,22250,75,NULL,'B','UGCA 171',NULL,'1988NBGC.C....0000T',1988,1,NULL,NULL,'GPair',0.000127,NULL,NULL,NULL,'Pec',NULL,NULL,NULL,NULL,1,146.072625,76.35167,0.029,NULL,61411384455,959552882,14993013,NULL),(63812,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63812,38.48,0.33,497,22251,70,NULL,NULL,'2MASX J09441776+2337038',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,146.0740417,23.61772,0.041,NULL,63694387205,995224800,15550387,17.5),(63813,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63813,37.54,0.46,322,22252,70,NULL,NULL,'2MASX J09441987+4249327',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,146.082875,42.82578,0.017,NULL,63974306105,999598532,15618727,17.3),(63814,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63814,32.2,NULL,27.5,22253,NULL,NULL,NULL,'AGC 193802',NULL,'2015AstBu..70....1K',2015,1,NULL,NULL,'RadioS',0.000072,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,146.085417,10.06278,0.025,NULL,60901256768,951582137,14868470,NULL),(63815,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63815,36.89,0.46,238,22254,70,NULL,NULL,'2MASX J09442084+0435319',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000204,NULL,'15.8g',0.44,'S0^-',NULL,NULL,NULL,NULL,1,146.0867917,4.59211,0.085,NULL,60912960325,951765005,14871328,15.8),(63816,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63816,36.7,0.27,219,22255,70,NULL,NULL,'2MASX J09442155+5209052',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000191,NULL,'15.6g',0.49,'S0^-',NULL,NULL,NULL,NULL,1,146.0897917,52.15139,0,NULL,64010900955,1000170327,15627661,15.6),(63817,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63817,37.65,0.46,339,22256,70,NULL,NULL,'SDSS J094421.59+691739.8',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,146.09,69.29442,0.189,NULL,62097707667,970276682,15160573,16.9),(63818,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63818,36.84,0.46,233,22257,70,NULL,NULL,'2MASX J09442184+0604313',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000166,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,146.091083,6.0755,0.093,NULL,60910306058,951723532,14870680,16.6),(63819,'TRGB','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63819,27.89,0.37,3.8,22258,NULL,NULL,NULL,'MESSIER 081:[CKT2009] d0944+69',NULL,'2013AJ....146..126C',2013,1,NULL,NULL,'G',NULL,NULL,'21.0B',NULL,'dSph',NULL,NULL,NULL,NULL,1,146.09375,69.21111,0.189,NULL,62097663864,970275997,15160562,21),(63820,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63820,37.29,0.33,288,22259,70,NULL,NULL,'2MASX J09442395+2635059',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000163,NULL,'16.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,146.09975,26.58514,0,NULL,64167917115,1002623704,15665995,16.1),(63821,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63821,36.05,0.46,162,22260,70,NULL,NULL,'2MASX J09442486+1603594',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,146.103625,16.06642,0.093,NULL,63727144235,995736628,15558384,16.5),(63822,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63822,36.31,0.46,183,22261,70,NULL,NULL,'2MASX J09442536+0546069',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000167,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,146.1055417,5.76853,0.101,NULL,60910432516,951725508,14870711,16.3),(63823,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63823,37.74,0.46,353,22262,70,NULL,NULL,'2MASX J09442619+4832542',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,146.1092917,48.54836,0.021,NULL,64019256515,1000300883,15629701,17),(63824,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63824,35.59,0.27,131,22263,70,NULL,NULL,'2MASX J09442665+1457034',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',NULL,NULL,'16.70',0.61,NULL,NULL,NULL,NULL,NULL,1,146.1109583,14.95092,0.093,NULL,60819545316,950305395,14848521,16.7),(63825,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63825,38.18,0.46,432,22264,70,NULL,NULL,'2MASX J09442677+0638393',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,146.111416667,6.64428,0.049,NULL,60918896053,951857750,14872777,17.8),(63826,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63826,37.67,0.21,342,22265,70,NULL,NULL,'SDSS J094426.95+144052.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,146.112333333,14.68119,0.089,NULL,60819665480,950307273,14848551,18.3),(63827,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63827,38.11,0.46,419,22266,70,NULL,NULL,'SDSS J094427.32+282435.9',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000144,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,146.113875,28.41,0.025,NULL,64211773778,1003308965,15676702,18.2),(63828,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63828,34.56,0.46,81.5,22267,70,NULL,NULL,'CGCG 182-007',NULL,'2015arXiv151105856S',2015,1,0.96,NULL,'G',0.00009,NULL,'14.6g',0.51,'SABa',NULL,NULL,NULL,NULL,1,146.1295417,32.81264,0,NULL,64183504165,1002867252,15669800,14.6),(63829,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63829,36.19,0.46,173,22268,70,NULL,NULL,'2MASX J09443127+1454473',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'15.9g',0.35,NULL,NULL,NULL,NULL,NULL,1,146.130375,14.91303,0.093,NULL,60819553102,950305517,14848523,15.9),(63830,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63830,37.67,0.21,342,22269,70,NULL,NULL,'2MASX J09443209+1452043',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,146.1337917,14.86789,0.093,NULL,60819541801,950305340,14848520,17.3),(63831,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63831,37.68,0.46,344,22270,70,NULL,NULL,'2MASX J09443283+2347578',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000178,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,146.136833,23.79939,0.037,NULL,63694463626,995225994,15550406,16.5),(63832,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63832,36.85,0.46,234,22271,70,NULL,NULL,'2MASX J09443291+0754192',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000174,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,146.137083,7.90525,0.041,NULL,60890323151,951411299,14865801,16.5),(63833,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63833,34,NULL,63,22272,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 498- G 023',NULL,'2010Ap&SS.325..163P',2010,1,1.12,'Compact galaxy or bright knot superposed on western side.','G',0.000103,'?','16.58',0.11,'Sd',NULL,NULL,NULL,NULL,1,146.138,-23.95014,0.129,NULL,42290918006,660795593,10324931,16.58),(63834,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63834,34.01,NULL,63.4,22272,NULL,NULL,'Dipole + Quadrupole','ESO 498- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63835,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63835,34.03,NULL,64.1,22272,NULL,NULL,'Dipole','ESO 498- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63836,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63836,34.08,NULL,65.3,22272,NULL,NULL,NULL,'ESO 498- G 023',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63837,'TRGB','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63837,27.63,0.06,3.4,22273,NULL,NULL,NULL,'MESSIER 081:[CKT2009] d0944+71',NULL,'2013AJ....146..126C',2013,1,NULL,NULL,'G',NULL,NULL,'17.5B',NULL,'dI',NULL,NULL,NULL,NULL,1,146.143333,71.4825,0.045,NULL,62108599507,970446867,15163232,17.5),(63838,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63838,38.07,0.46,411,22274,70,NULL,NULL,'2MASX J09443458+0830592',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,146.1442083,8.51656,0.037,NULL,60890558026,951414969,14865858,17.2),(63839,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63839,35.25,0.53,112,22275,NULL,NULL,NULL,'UGC 05201',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000037,NULL,'15.5g',0.66,'SAB(s)c','Isolated galaxy',NULL,NULL,NULL,1,146.1457083,55.76281,0.017,NULL,61880260707,966879073,15107485,15.5),(63840,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63840,35.29,0.2,114,22275,74.4,NULL,NULL,'UGC 05201',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63841,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63841,35.3,0.52,115,22275,NULL,NULL,'Malmquist cor.','UGC 05201',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63842,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63842,36.7,0.27,219,22276,70,NULL,NULL,'2MASX J09443513+5204232',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000195,NULL,'16.0g',0.41,'E0',NULL,NULL,NULL,NULL,1,146.1462917,52.07311,0,NULL,64010884154,1000170064,15627657,16),(63843,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63843,36.78,0.46,227,22277,70,NULL,NULL,'2MASX J09443539+4224070',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000167,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,146.147583333,42.40206,0.005,NULL,63975598994,999618734,15619042,16.5),(63844,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63844,31.86,NULL,23.6,22278,NULL,NULL,NULL,'SDSS J094437.11+100046.3',NULL,'2015AstBu..70....1K',2015,1,0.59,NULL,'G',0.000103,NULL,'16.9g',0.42,NULL,NULL,NULL,NULL,NULL,1,146.154667,10.01289,0.025,NULL,60901245983,951581968,14868468,16.9),(63845,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63845,37.67,0.21,342,22279,70,NULL,NULL,'2MASX J09443844+1449183',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,146.160083333,14.82164,0.093,NULL,60819652721,950307073,14848548,17.6),(63846,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63846,37.46,0.33,311,22280,70,NULL,NULL,'2MASX J09443978-0003510',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000108,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,146.165583,-0.06417,0.141,NULL,41104194916,642253045,10035203,18.2),(63847,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63847,34.45,NULL,77.7,22281,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 566- G 006',NULL,'2010Ap&SS.325..163P',2010,1,1.18,NULL,'G',0.000043,NULL,'17.07',0.11,'Sd',NULL,NULL,NULL,NULL,1,146.167083,-21.2625,0.089,NULL,42339436213,661553690,10336776,17.07),(63848,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63848,34.47,NULL,78.4,22281,NULL,NULL,'Dipole + Quadrupole','ESO 566- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63849,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63849,34.48,NULL,78.9,22281,NULL,NULL,'Dipole','ESO 566- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63850,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63850,34.53,NULL,80.4,22281,NULL,NULL,NULL,'ESO 566- G 006',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63851,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63851,36.23,0.46,177,22282,70,NULL,NULL,'2MASX J09444112+2029108',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000179,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,146.171417,20.48622,0.041,NULL,63742900211,995982815,15562231,16.6),(63852,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63852,37.53,0.1,321,22283,70,NULL,NULL,'2MASX J09444119+4308501',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,146.1717083,43.14728,0.013,NULL,63974195610,999596806,15618700,17.3),(63853,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63853,36.85,0.11,234,22284,70,NULL,NULL,'2MASX J09444131+5420018',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000188,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,146.1724583,54.33397,0.005,NULL,61879427346,966866052,15107282,16.6),(63854,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63854,37.4,0.46,302,22285,70,NULL,NULL,'2MASX J09444238+2104448',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000178,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,146.1765417,21.07917,0.037,NULL,63741994831,995968669,15562010,16.8),(63855,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63855,36.95,0.46,246,22286,70,NULL,NULL,'2MASX J09444307+2212298',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,146.179583,22.20839,0.061,NULL,63691707525,995182930,15549733,17.6),(63856,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63856,29.87,NULL,9.42,22287,NULL,NULL,NULL,'IC 0559',NULL,'2013AJ....145..101K',2013,1,0.8,'Multiple SDSS entries describe this source.','G',0.000024,NULL,'15.0',0.6,'Sc',NULL,NULL,NULL,NULL,1,146.182875,9.615,0.033,NULL,60900609125,951572017,14868312,15),(63857,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63857,38.41,0.46,481,22288,70,NULL,NULL,'SDSS J094445.56+051644.7',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,146.189875,5.27911,0.089,NULL,60913663013,951775984,14871499,17.8),(63858,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63858,37.94,0.46,387,22289,70,NULL,NULL,'SDSS J094445.72+025508.7',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000143,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,146.190541667,2.91908,0.113,NULL,60903576998,951618390,14869037,18.5),(63859,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63859,34.45,0.55,77.6,22290,70,NULL,NULL,'2MASX J09444585-7157588',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,146.191125,-71.96639,0.557,NULL,40717515423,636211178,9940799,16.4),(63860,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63860,37.46,0.33,311,22291,70,NULL,NULL,'2MASX J09444638-0002195',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000093,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,146.1932917,-0.03886,0.141,NULL,41104180542,642252820,10035200,17.7),(63861,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63861,35.59,0.27,131,22292,70,NULL,NULL,'CGCG 092-038 NED01',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.20',0.45,'AGN',NULL,NULL,NULL,NULL,1,146.194541667,14.88939,0.093,NULL,60831059601,950485306,14851332,16.2),(63862,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63862,37.52,0.33,319,22293,70,NULL,NULL,'2MASX J09444683+6030015',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000075,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,146.1952917,60.50036,0.057,NULL,61914624119,967416001,15115875,16.5),(63863,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63863,36.85,0.11,234,22294,70,NULL,NULL,'2MASX J09444697+5438458',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000164,NULL,'16.2g',0.26,'AGN',NULL,NULL,NULL,NULL,1,146.195417,54.64606,0.005,NULL,61879374029,966865219,15107269,16.2),(63864,'TRGB','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63864,27.82,0.04,3.66,22295,NULL,NULL,'I','F8D1',NULL,'2009ApJS..183...67D',2009,1,2.2,NULL,'G',NULL,NULL,'13.85',2,'Dwarf elliptical','Brightest group member',NULL,NULL,NULL,1,146.19625,67.43861,0.129,NULL,62248365051,972630703,15197354,13.85),(63865,'TRGB','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63865,27.84,0.08,3.7,22295,NULL,NULL,NULL,'F8D1',NULL,'2007ASPC..374..247D',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63866,'TRGB','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63866,27.86,0.11,3.73,22295,NULL,NULL,'HST KP Calibrated','F8D1',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63867,'TRGB','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63867,27.88,NULL,3.77,22295,NULL,NULL,NULL,'F8D1',NULL,'2000A&A...363..117K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63868,'TRGB','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63868,27.89,0.06,3.78,22295,NULL,NULL,'I','F8D1',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63869,'TRGB','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63869,27.9,NULL,3.8,22295,NULL,NULL,NULL,'F8D1',NULL,'1998AJ....115..535C',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63870,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63870,31.08,0.4,16.4,22296,75,NULL,'B','UGCA 180',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.000027,NULL,'13.18',1.7,'SB(s)m pec:','X-ray-faint group member',NULL,NULL,'H_alpha Emission-Line Galaxy',1,146.198375,-31.82564,0.553,NULL,42873062840,669891606,10467056,13.18),(63871,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63871,35.59,0.27,131,22297,70,NULL,NULL,'CGCG 092-038 NED02',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'15.97',0.37,'AGN',NULL,NULL,NULL,NULL,1,146.201,14.87922,0.093,NULL,60831269401,950488584,14851384,15.97),(63872,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63872,37.76,0.46,356,22298,70,NULL,NULL,'2MASX J09444920+3811258',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,146.205,38.19061,0,NULL,64173662967,1002713483,15667398,16.8),(63873,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63873,36.36,0.46,187,22299,70,NULL,NULL,'2MASX J09444946+1410243',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'17.35',0.29,NULL,NULL,NULL,NULL,NULL,1,146.2060417,14.17333,0.097,NULL,60820145403,950314771,14848668,17.35),(63874,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63874,37.84,0.46,370,22300,70,NULL,NULL,'2MASXi J0944498+143855',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,146.207417,14.64883,0.089,NULL,60819693579,950307712,14848558,17.9),(63875,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63875,37.79,0.46,361,22301,70,NULL,NULL,'2MASX J09445013+2714319',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,146.209,27.24239,0.009,NULL,64166982276,1002609098,15665767,17.4),(63876,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63876,36.99,0.46,251,22302,70,NULL,NULL,'2MASX J09445021+2433579',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000194,NULL,'15.9g',0.5,NULL,NULL,NULL,NULL,NULL,1,146.20925,24.56617,0.053,NULL,63691074704,995173042,15549578,15.9),(63877,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63877,37.29,0.33,288,22303,70,NULL,NULL,'2MASX J09445042+2638009',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000168,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,146.2102083,26.63361,0,NULL,64168083712,1002626308,15666036,18.3),(63878,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63878,37.56,0.46,325,22304,70,NULL,NULL,'2MASX J09445091+0923506',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,146.212333,9.39739,0.041,NULL,60897844586,951528821,14867637,17.4),(63879,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63879,36.89,0.33,239,22305,70,NULL,NULL,'2MASX J09445106+1136126',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000197,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,146.2127083,11.6035,0.029,NULL,60886757987,951355593,14864931,16.5),(63880,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63880,37.93,0.46,385,22306,70,NULL,NULL,'2MASX J09445104+4203141',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000189,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,146.212875,42.05406,0.013,NULL,63975670372,999619849,15619060,17.3),(63881,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63881,37.76,0.23,356,22307,70,NULL,NULL,'SDSS J094451.64+341556.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000172,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,146.215167,34.26564,0,NULL,64189139561,1002955305,15671176,18.6),(63882,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63882,35.64,0.52,135,22308,70,NULL,NULL,'2MASX J09445194-3810237',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.3I',0.6,NULL,NULL,NULL,NULL,NULL,1,146.216375,-38.17331,0.849,NULL,42849833894,669528654,10461385,13.3),(63883,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63883,36.29,0.6,182,22309,70,NULL,NULL,'2MASX J09445197-1229266',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00011,NULL,'15.88',0.6,NULL,NULL,NULL,NULL,NULL,1,146.216583333,-12.49078,0.113,NULL,41173480450,643335632,10052119,15.88),(63884,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63884,37.97,0.46,392,22310,70,NULL,NULL,'2MASX J09445241+2143305',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,146.2182917,21.72519,0.025,NULL,63747134644,996048978,15563265,17.4),(63885,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63885,37.78,0.46,360,22311,70,NULL,NULL,'2MASX J09445280+0521231',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,146.22,5.35644,0.089,NULL,60913175321,951768364,14871380,16.9),(63886,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63886,36.81,0.46,230,22312,70,NULL,NULL,'2MASX J09445360+0142171',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000081,NULL,'17.3g',0.17,'NLAGN',NULL,NULL,NULL,'Sy 2',1,146.223333,1.70481,0.173,NULL,60904754749,951636792,14869324,17.3),(63887,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63887,38.09,0.46,416,22313,70,NULL,NULL,'2MASX J09445486+2402519',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,146.2285417,24.04775,0.037,NULL,63694037586,995219337,15550302,18),(63888,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63888,37.11,0.46,265,22314,70,NULL,NULL,'2MASX J09445534+2840269',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000148,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,146.230417,28.67419,0.021,NULL,64219180059,1003424688,15678510,17.3),(63889,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63889,36.98,0.46,249,22315,70,NULL,NULL,'2MASX J09445663+2617019',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000186,NULL,'15.9g',0.46,NULL,NULL,NULL,NULL,NULL,1,146.2360417,26.28394,0.005,NULL,64168077579,1002626212,15666034,15.9),(63890,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63890,37.42,0.46,305,22316,70,NULL,NULL,'2MASX J09445817+1023016',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000161,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,146.242333,10.38378,0.045,NULL,60901148633,951580447,14868444,18),(63891,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63891,37.67,0.46,342,22317,70,NULL,NULL,'2MASX J09445883+5055451',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,146.244917,50.92906,0,NULL,64010749031,1000167953,15627624,18),(63892,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63892,38.1,0.46,417,22318,70,NULL,NULL,'2MASX J09445894+3820548',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,146.2457917,38.34856,0,NULL,64173668446,1002713569,15667399,17.9),(63893,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63893,35.83,0.33,147,22319,70,NULL,NULL,'IC 0558',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.0001,NULL,'14.5g',0.83,'S?',NULL,NULL,NULL,NULL,1,146.2514583,29.45231,0.033,NULL,64219933926,1003436467,15678694,14.5),(63894,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63894,37.67,0.21,342,22320,70,NULL,NULL,'2MASX J09450056+1444305',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'17.56',0.45,NULL,NULL,NULL,NULL,NULL,1,146.2524583,14.74175,0.089,NULL,60831143347,950486614,14851353,17.56),(63895,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63895,37.67,0.21,342,22321,70,NULL,NULL,'2MASX J09450146+1444085',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,146.25625,14.73578,0.089,NULL,60831143831,950486622,14851353,17.7),(63896,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63896,37.58,0.46,328,22322,70,NULL,NULL,'SDSS J094502.61+500019.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,146.260916667,50.00528,0,NULL,64018479064,1000288735,15629511,18.1),(63897,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63897,36.94,0.46,244,22323,70,NULL,NULL,'2MASX J09450311+4838310',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,146.263166667,48.64189,0.033,NULL,64019279082,1000301235,15629706,17.4),(63898,'TRGB','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63898,30.04,0.1,10.2,22324,74.4,NULL,NULL,'UGC 05209',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000003,NULL,'19.',0.9,'Im','Group member',NULL,NULL,NULL,1,146.2675,32.23778,0,NULL,64215989890,1003374842,15677731,19),(63899,'TRGB','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63899,30.09,0.07,10.4,22324,NULL,NULL,NULL,'UGC 05209',NULL,'2015ApJ...805..144K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63900,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63900,36.4,0.46,191,22325,70,NULL,NULL,'2MASX J09450581+5131230',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000176,NULL,'16.0g',0.27,'S0',NULL,NULL,NULL,NULL,1,146.274167,51.523,0,NULL,64011018193,1000172159,15627689,16),(63901,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63901,37.21,0.46,277,22326,70,NULL,NULL,'2MASX J09450693+0811446',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000149,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,146.2787917,8.19583,0.041,NULL,60890538610,951414665,14865854,18.4),(63902,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63902,37.97,0.46,393,22327,70,NULL,NULL,'2MASX J09450716+0604336',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000191,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,146.279958333,6.07597,0.049,NULL,60910232554,951722383,14870662,16.9),(63903,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63903,38.64,0.46,534,22328,70,NULL,NULL,'SDSS J094507.31+044938.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,146.280458333,4.82722,0.097,NULL,60912999286,951765613,14871337,18.1),(63904,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63904,37.52,0.33,319,22329,70,NULL,NULL,'2MASX J09450906+6032461',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000082,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,146.287583333,60.54617,0.057,NULL,61914625270,967416019,15115875,17.2),(63905,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63905,35.49,NULL,126,22330,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0934',NULL,'2010Ap&SS.325..163P',2010,1,0.6,NULL,'G',0.00002,NULL,'17.3',0.08,'Sd',NULL,NULL,NULL,NULL,1,146.29,30.64111,0.009,NULL,64216113136,1003376767,15677761,17.3),(63906,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63906,35.51,NULL,126,22330,NULL,NULL,'Dipole + Quadrupole','FGC 0934',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63907,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63907,35.53,NULL,127,22330,NULL,NULL,'Dipole','FGC 0934',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63908,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63908,35.59,NULL,131,22330,NULL,NULL,NULL,'FGC 0934',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63909,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63909,36.45,0.2,195,22330,74.4,NULL,NULL,'FGC 0934',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63910,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63910,38.32,0.46,462,22331,70,NULL,NULL,'2MASX J09450983+2817279',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000174,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,146.2909583,28.29119,0.025,NULL,64211735236,1003308363,15676693,17.2),(63911,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63911,37.38,0.46,299,22332,70,NULL,NULL,'2MASX J09450999+2421199',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,146.2915417,24.35561,0.053,NULL,63694014733,995218980,15550296,17.6),(63912,'TRGB','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63912,27.66,0.16,3.4,22333,NULL,NULL,NULL,'[FM2000] 1',NULL,'2001A&A...375..359K',2001,1,0.9,NULL,'G',NULL,NULL,'17.50',0.8,'dSph',NULL,NULL,NULL,NULL,1,146.291667,68.765,0.201,NULL,62096694525,970260851,15160325,17.5),(63913,'TRGB','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63913,27.74,NULL,3.53,22333,NULL,NULL,NULL,'[FM2000] 1',NULL,'2010ApJ...724.1030G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63914,'TRGB','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63914,27.74,0.02,3.53,22333,NULL,NULL,'I','[FM2000] 1',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63915,'TRGB','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63915,27.75,0.08,3.55,22333,NULL,NULL,'I','[FM2000] 1',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63916,'TRGB','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63916,27.84,0.08,3.7,22333,NULL,NULL,NULL,'[FM2000] 1',NULL,'2007ASPC..374..247D',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63917,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63917,37.03,0.46,255,22334,70,NULL,NULL,'2MASX J09451028+6047521',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000093,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,146.292583,60.79781,0.053,NULL,62034998248,969296847,15145263,16.8),(63918,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63918,38.69,0.46,547,22335,70,NULL,NULL,'SDSS J094511.60+041437.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000179,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,146.298333,4.24381,0.057,NULL,60911195813,951737434,14870897,18.5),(63919,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63919,37.22,0.46,278,22336,70,NULL,NULL,'2MASX J09451382+1944115',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000173,NULL,'17.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,146.307667,19.73667,0.005,NULL,63744900430,996014069,15562719,17.7),(63920,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63920,34.56,0.2,81.7,22337,74.4,NULL,NULL,'UGC 05215',NULL,'2013AJ....146...86T',2013,1,1.64,NULL,'G',0.000003,NULL,'13.8g',0.79,'Sbc','Field galaxy',NULL,NULL,NULL,1,146.31,9.11033,0.057,NULL,60890183149,951409111,14865767,13.8),(63921,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63921,34.57,0.4,82.1,22337,NULL,NULL,'mean','UGC 05215',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63922,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63922,34.61,0.47,83.4,22337,NULL,NULL,'H','UGC 05215',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63923,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63923,34.64,0.46,84.6,22337,NULL,NULL,'J','UGC 05215',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63924,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63924,34.67,0.42,85.9,22337,NULL,NULL,'Malmquist cor.','UGC 05215',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63925,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63925,34.7,0.45,87.2,22337,NULL,NULL,'K','UGC 05215',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63926,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63926,34.71,0.42,87.4,22337,NULL,NULL,NULL,'UGC 05215',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63927,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63927,36.69,0.46,218,22338,70,NULL,NULL,'2MASX J09451480+3522093',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000172,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,146.311875,35.36931,0,NULL,64186870615,1002919853,15670622,16.6),(63928,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63928,36.8,0.46,230,22339,70,NULL,NULL,'2MASX J09452040+3054383',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000209,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,146.3352083,30.91069,0.017,NULL,64216127780,1003376996,15677765,16.5),(63929,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63929,35.84,0.51,147,22340,70,NULL,NULL,'2MASX J09452069-1444557',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'13.9I',0.5,NULL,NULL,NULL,NULL,NULL,1,146.336167,-14.74889,0.233,NULL,41186149685,643533588,10055212,13.9),(63930,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63930,37.76,0.23,356,22341,70,NULL,NULL,'2MASX J09452087+3416373',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,146.337083,34.27703,0,NULL,64189149319,1002955458,15671179,17.7),(63931,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63931,32.97,0.43,39.3,22342,75,NULL,'3.6 micron, color + selection bias corrected','FGC 0937',NULL,'2014MNRAS.444..527S',2014,1,1.79,NULL,'G',0.000023,NULL,'16.3',0.1,'Sd',NULL,NULL,NULL,NULL,1,146.342083,-13.74861,0.185,NULL,41172613832,643322091,10051907,16.3),(63932,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63932,33.18,NULL,43.2,22342,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0937',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63933,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63933,33.18,NULL,43.3,22342,NULL,NULL,'Dipole','FGC 0937',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63934,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63934,33.19,NULL,43.4,22342,NULL,NULL,'Dipole + Quadrupole','FGC 0937',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63935,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63935,33.22,NULL,44,22342,NULL,NULL,NULL,'FGC 0937',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63936,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63936,30.87,NULL,14.9,22343,NULL,NULL,NULL,'RKK 1610',NULL,'2013AJ....145..101K',2013,1,0.9,NULL,'G',NULL,NULL,'16.9',0.22,NULL,NULL,NULL,NULL,NULL,1,146.3534583,-48.14144,NULL,NULL,42075616770,657431512,10272367,16.9),(63937,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63937,37.16,0.46,270,22344,70,NULL,NULL,'2MASX J09452496+2807513',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000182,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,146.354208333,28.13083,0.009,NULL,64211851985,1003310187,15676721,17.1),(63938,'IRAS','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63938,33.83,0.8,58.3,22345,75,NULL,'MAT, I','NGC 2989',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000017,NULL,'13.58',0.9,'SAB(s)bc:;HII  Sbrst','Group member, radial-velocity confirmed',NULL,NULL,'H II',1,146.355083333,-18.37392,0.149,NULL,42304275677,661004307,10328192,13.58),(63939,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63939,33.07,0.69,41.1,22345,100,NULL,'mid-IR','NGC 2989',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63940,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63940,33.29,0.32,45.6,22345,85,NULL,'I, raw','NGC 2989',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63941,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63941,33.33,0.32,46.4,22345,85,NULL,'I, inv','NGC 2989',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63942,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63942,33.44,0.43,48.8,22345,75,NULL,'MAT, I, raw','NGC 2989',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63943,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63943,33.47,NULL,49.4,22345,NULL,NULL,'B','NGC 2989',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63944,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63944,33.64,0.43,53.4,22345,75,NULL,'MAT, I, inv','NGC 2989',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63945,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63945,33.65,NULL,53.7,22345,NULL,NULL,'I','NGC 2989',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63946,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63946,33.69,0.47,54.8,22345,NULL,NULL,'H','NGC 2989',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63947,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63947,33.75,0.43,56.4,22345,75,NULL,'MAT, I, cor','NGC 2989',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63948,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63948,33.76,0.46,56.5,22345,NULL,NULL,'J','NGC 2989',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63949,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63949,33.82,0.45,58,22345,NULL,NULL,'K','NGC 2989',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63950,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63950,33.88,0.2,59.7,22345,74.4,NULL,NULL,'NGC 2989',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63951,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63951,33.93,0.42,61,22345,NULL,NULL,'Malmquist cor.','NGC 2989',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63952,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63952,33.96,0.4,61.9,22345,NULL,NULL,'mean','NGC 2989',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63953,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63953,34.05,0.4,64.6,22345,NULL,NULL,NULL,'NGC 2989',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63954,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63954,37.98,0.46,394,22346,70,NULL,NULL,'SDSS J094525.80+155226.5',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,146.3575417,15.87406,0.125,NULL,63726286842,995723231,15558175,18),(63955,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63955,38,0.23,398,22347,70,NULL,NULL,'2MASX J09452693+4724417',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,146.3622917,47.41167,0.017,NULL,64014623649,1000228494,15628570,18.1),(63956,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63956,36.97,0.46,248,22348,70,NULL,NULL,'2MASX J09452730+4355167',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000174,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,146.363625,43.92128,0.013,NULL,63987415772,999803371,15621927,16.8),(63957,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63957,37.57,0.46,326,22349,70,NULL,NULL,'2MASX J09452824+0004030',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000071,NULL,'18.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,146.367833333,0.06744,0.141,NULL,60767092046,949485813,14835715,18.5),(63958,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63958,38,0.23,398,22350,70,NULL,NULL,'2MASX J09452949+4730447',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000134,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,146.372791667,47.5125,0.017,NULL,64014645833,1000228841,15628575,17.7),(63959,'IRAS','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63959,30.46,0.8,12.3,22351,75,NULL,'MAT, I','UGCA 182',NULL,'1997ApJS..109..333W',1997,1,2.7,NULL,'G',0.000003,NULL,'14.60',0.5,'IBm: sp','X-ray-faint group member',NULL,NULL,NULL,1,146.375083,-30.34278,0.473,NULL,42871304328,669864130,10466627,14.6),(63960,'Tully est','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63960,30.49,0.8,12.6,22351,75,NULL,'B','UGCA 182',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63961,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63961,30.27,0.32,11.3,22351,85,NULL,'I, inv','UGCA 182',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63962,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63962,30.32,0.32,11.6,22351,85,NULL,'I, raw','UGCA 182',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63963,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63963,30.67,0.43,13.6,22351,75,NULL,'MAT, I, inv','UGCA 182',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63964,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63964,30.74,0.2,14.1,22351,74.4,NULL,NULL,'UGCA 182',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63965,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63965,30.82,0.43,14.6,22351,75,NULL,'MAT, I, raw','UGCA 182',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63966,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63966,30.88,0.4,15,22351,NULL,NULL,NULL,'UGCA 182',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63967,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63967,30.88,0.4,15,22351,73,NULL,'opt','UGCA 182',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63968,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63968,31.08,0.43,16.5,22351,75,NULL,'MAT, I, cor','UGCA 182',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63969,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63969,37.45,0.46,309,22352,70,NULL,NULL,'2MASX J09453002+2240434',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,146.375,22.67881,0.033,NULL,63692593252,995196769,15549949,17.4),(63970,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63970,33.55,0.4,51.3,22353,NULL,NULL,NULL,'UGC 05218',NULL,'2009AJ....138..323T',2009,1,1.09,NULL,'G',0.000003,NULL,'14.2B',0.49,'SABd',NULL,NULL,NULL,NULL,1,146.376125,6.37683,0.045,NULL,60918364907,951849451,14872647,14.2),(63971,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63971,33.63,0.2,53.2,22353,74.4,NULL,NULL,'UGC 05218',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63972,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63972,33.79,0.61,57.3,22353,NULL,NULL,NULL,'UGC 05218',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63973,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63973,34.03,0.55,63.9,22353,NULL,NULL,'Malmquist cor.','UGC 05218',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63974,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63974,36.89,0.33,239,22354,70,NULL,NULL,'2MASX J09453030+1143092',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000185,NULL,'15.9g',0.4,'E0',NULL,NULL,NULL,NULL,1,146.376333,11.71919,0.029,NULL,60898261100,951535329,14867739,15.9),(63975,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63975,37.53,0.1,321,22355,70,NULL,NULL,'2MASX J09453227+4255067',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,146.3845,42.91847,0,NULL,63974688663,999604510,15618820,17.9),(63976,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63976,37.13,0.46,266,22356,70,NULL,NULL,'SDSS J094532.52+015517.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00008,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,146.385541667,1.92147,0.173,NULL,60904854151,951638346,14869349,17.9),(63977,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63977,38,0.23,398,22357,70,NULL,NULL,'2MASX J09453275+4729407',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000178,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,146.386666667,47.49456,0.017,NULL,64014632898,1000228639,15628572,17),(63978,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63978,37.57,0.46,326,22358,70,NULL,NULL,'2MASX J09453409+2638164',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,146.3922917,26.638,0.037,NULL,64168032253,1002625503,15666023,17),(63979,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63979,37.53,0.1,321,22359,70,NULL,NULL,'2MASX J09453472+4252457',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,146.394667,42.87933,0,NULL,63974901931,999607842,15618872,17.6),(63980,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63980,38.48,0.46,496,22360,70,NULL,NULL,'2MASX J09453530+6052011',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000087,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,146.397083,60.86703,0.053,NULL,62034957850,969296216,15145253,17.5),(63981,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63981,29.25,0.36,7.08,22361,NULL,NULL,NULL,'NGC 2997',NULL,'2009AJ....138..323T',2009,1,8.9,'Extended HIPASS source','G',0.000003,NULL,'10.06',6.8,'SA(s)c','X-ray-faint group member',NULL,NULL,'Flat-Spectrum Radio Source',1,146.411625,-31.19108,0.505,NULL,42872774951,669887108,10466986,10.06),(63982,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63982,30.01,NULL,10,22361,NULL,NULL,'B','NGC 2997',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63983,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63983,30.43,0.16,12.2,22361,NULL,NULL,NULL,'NGC 2997',NULL,'2009ApJ...699...76H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63984,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63984,30.59,0.39,13.1,22361,73,NULL,'opt','NGC 2997',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63985,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63985,30.71,0.4,13.8,22361,75,NULL,NULL,'NGC 2997',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63986,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63986,37.96,0.46,390,22362,70,NULL,NULL,'2MASX J09453903+2116284',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,146.412583333,21.27469,0.037,NULL,63741937441,995967772,15561996,17.8),(63987,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63987,36.29,0.46,181,22363,70,NULL,NULL,'2MASX J09453901+5548113',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000174,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,146.4127917,55.80322,0,NULL,61935642434,967744413,15121006,16.4),(63988,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63988,37.84,0.46,369,22364,70,NULL,NULL,'SDSS J094539.64+393222.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,146.4152083,39.53972,0.005,NULL,64172860321,1002700942,15667202,18.1),(63989,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63989,38,0.23,398,22365,70,NULL,NULL,'SDSS J094539.90+472748.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,146.416333333,47.46342,0.017,NULL,64014625579,1000228524,15628570,18.3),(63990,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',63990,37.76,0.23,356,22366,70,NULL,NULL,'2MASX J09454024+3409254',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000148,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,146.4175417,34.15719,0,NULL,64185753852,1002902403,15670350,17.2),(63991,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63991,33.63,0.47,53.2,22367,NULL,NULL,'H','NGC 2987',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00003,NULL,'13.85',0.7,'Sab','Group member',NULL,NULL,NULL,1,146.4227917,4.94183,0.097,NULL,60913028014,951766062,14871344,13.85),(63992,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63992,33.65,0.45,53.7,22367,NULL,NULL,'K','NGC 2987',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63993,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63993,33.69,0.4,54.8,22367,NULL,NULL,'mean','NGC 2987',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63994,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63994,33.75,0.46,56.2,22367,NULL,NULL,'J','NGC 2987',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63995,'Tully est','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63995,32.42,0.8,30.5,22368,75,NULL,'B','NGC 2992',NULL,'1988NBGC.C....0000T',1988,1,3.5,NULL,'G',0.000013,NULL,'13.14',1.1,'Sa pec         Sy1.9','Pair member (points to parent)',NULL,NULL,'unobscured Seyfert 2',1,146.4252083,-14.32639,0.249,NULL,41186609678,643540776,10055324,13.14),(63996,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63996,32.31,0.45,29,22368,NULL,NULL,'K','NGC 2992',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63997,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63997,32.36,0.47,29.6,22368,NULL,NULL,'H','NGC 2992',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63998,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63998,32.45,0.46,30.9,22368,NULL,NULL,'J','NGC 2992',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63999,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,63999,32.9,0.4,38,22368,NULL,NULL,'mean','NGC 2992',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64000,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64000,37.32,0.46,291,22369,70,NULL,NULL,'2MASX J09454248+1858354',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000155,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,146.427125,18.97642,0.041,NULL,63744360550,996005633,15562588,17),(64001,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64001,37.53,0.1,321,22370,70,NULL,NULL,'2MASX J09454255+4254146',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000172,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,146.4272917,42.90403,0,NULL,63974701075,999604704,15618823,16.8),(64002,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64002,35.67,0.46,136,22371,70,NULL,NULL,'CGCG 152-067',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000184,NULL,'15.6g',0.46,NULL,NULL,NULL,NULL,NULL,1,146.436375,30.24444,0,NULL,64217478895,1003398107,15678095,15.6),(64003,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64003,36.85,0.11,234,22372,70,NULL,NULL,'2MASX J09454617+5440043',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000196,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,146.4425,54.66803,0.005,NULL,61879582466,966868476,15107319,16.3),(64004,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64004,36.7,0.27,219,22373,70,NULL,NULL,'2MASX J09454661+5209075',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000175,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,146.4442083,52.15197,0.005,NULL,64012964916,1000202576,15628165,16.6),(64005,'Tully est','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64005,32.42,0.8,30.5,22374,75,NULL,'B','NGC 2993',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000022,NULL,'12.7B',0.9,'Sa pec         HII','Pair member (points to parent)',NULL,NULL,NULL,1,146.451375,-14.36831,0.249,NULL,41186620470,643540944,10055327,12.7),(64006,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64006,36.94,0.46,244,22375,70,NULL,NULL,'2MASX J09455104+4917026',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,146.462583333,49.28422,0.013,NULL,64021514703,1000336167,15630252,17.4),(64007,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64007,37.52,0.46,319,22376,70,NULL,NULL,'2MASX J09455139+3857023',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000163,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,146.4642083,38.95056,0,NULL,64173045954,1002703843,15667247,16.8),(64008,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64008,37.76,0.23,356,22377,70,NULL,NULL,'2MASX J09455184+3410094',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000204,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,146.465833,34.16933,0,NULL,64185700933,1002901577,15670337,17.2),(64009,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64009,36.85,0.11,234,22378,70,NULL,NULL,'MCG +09-16-041',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000193,NULL,'15.7g',0.5,'S0/a',NULL,NULL,NULL,NULL,1,146.467417,54.90883,0.005,NULL,61879036253,966859941,15107186,15.7),(64010,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64010,32.27,0.4,28.4,22379,75,NULL,'B','UGC 05224',NULL,'1988NBGC.C....0000T',1988,1,1.38,'The SDSS position applies to the eastern end of the bar.','G',0.000015,NULL,'15.1',0.87,'Sc(f)','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,146.467875,2.97781,0.113,NULL,60903993768,951624902,14869139,15.1),(64011,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64011,32.48,NULL,31.4,22379,NULL,NULL,NULL,'UGC 05224',NULL,'2015AstBu..70....1K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64012,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64012,36.74,0.46,223,22380,70,NULL,NULL,'2MASX J09455251-0005345',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000112,NULL,'16.0g',0.38,'Sa',NULL,NULL,NULL,NULL,1,146.468917,-0.09283,0.129,NULL,41221675639,644088681,10063885,16),(64013,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64013,37.53,0.1,321,22381,70,NULL,NULL,'2MASX J09455375+4253578',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000171,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,146.474167,42.89956,0,NULL,63974693214,999604581,15618821,18.2),(64014,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64014,38.38,0.46,473,22382,70,NULL,NULL,'2MASX J09455491+0131259',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000086,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,146.4787083,1.52381,0.197,NULL,60904804510,951637570,14869337,18.4),(64015,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64015,37.41,0.46,303,22383,70,NULL,NULL,'2MASX J09455531+2217311',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,146.480541667,22.29194,0.061,NULL,63691753653,995183650,15549744,18),(64016,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64016,37.53,0.1,321,22384,70,NULL,NULL,'SDSS J094555.96+430242.4',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000178,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,146.483167,43.04514,0,NULL,63974729266,999605144,15618830,16.8),(64017,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64017,37.89,0.46,378,22385,70,NULL,NULL,'2MASX J09455614+4448118',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,146.4837917,44.80336,0.005,NULL,63987955960,999811811,15622059,18.3),(64018,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64018,37.17,0.46,272,22386,70,NULL,NULL,'2MASX J09455692+0252379',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000099,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,146.4870417,2.87711,0.113,NULL,60904040344,951625630,14869150,16.5),(64019,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64019,38.07,0.46,411,22387,70,NULL,NULL,'2MASX J09455713+4619198',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'15.98',0.27,'galaxy candidate',NULL,NULL,NULL,NULL,1,146.488291667,46.32211,0.013,NULL,63984212760,999753324,15621145,15.98),(64020,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64020,37.36,0.46,296,22388,70,NULL,NULL,'2MASX J09455784+4102013',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000195,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,146.4910417,41.03367,0,NULL,63972531782,999570809,15618293,16.2),(64021,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64021,37.53,0.1,321,22389,70,NULL,NULL,'SDSS J094557.94+430345.8',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000171,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,146.4914583,43.06272,0,NULL,63974731482,999605179,15618830,16.7),(64022,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64022,37.53,0.1,321,22390,70,NULL,NULL,'2MASX J09455877+4318178',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000187,NULL,'15.8g',0.44,'E0',NULL,NULL,NULL,NULL,1,146.4949583,43.30494,0.005,NULL,63974148048,999596063,15618688,15.8),(64023,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64023,37.93,0.46,385,22391,70,NULL,NULL,'2MASX J09455884+6113266',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000065,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,146.495125,61.22428,0.061,NULL,62039212320,969362692,15146292,17.8),(64024,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64024,36.41,0.46,191,22392,70,NULL,NULL,'2MASX J09455890+3433124',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000168,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,146.495667,34.55333,0,NULL,64189124494,1002955070,15671172,16.4),(64025,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64025,37.98,0.46,395,22393,70,NULL,NULL,'2MASX J09455914+2352431',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000183,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,146.4965,23.87853,0.037,NULL,63694666409,995229162,15550455,17.2),(64026,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64026,36.03,0.46,161,22394,70,NULL,NULL,'2MASX J09460015+2140271',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000152,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,146.500625,21.67425,0.053,NULL,63698908367,995295443,15551491,17),(64027,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64027,34.09,0.46,65.8,22395,70,NULL,NULL,'UGC 05226',NULL,'2015arXiv151105856S',2015,1,1.08,NULL,'G',0.000067,NULL,'14.0g',0.84,'S0:',NULL,NULL,NULL,NULL,1,146.51475,4.40344,0.117,NULL,60911046424,951735100,14870860,14),(64028,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64028,32.06,0.4,25.8,22396,NULL,NULL,NULL,'UGC 05228',NULL,'2009AJ....138..323T',2009,1,2.5,NULL,'G',0.000007,NULL,'13.66',0.7,'SB(s)c:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,146.5152083,1.66833,0.197,NULL,60904830270,951637972,14869343,13.66),(64029,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64029,32.49,0.4,31.5,22396,NULL,NULL,'mean','UGC 05228',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64030,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64030,32.6,0.46,33.2,22396,NULL,NULL,'J','UGC 05228',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64031,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64031,32.65,0.47,33.8,22396,NULL,NULL,'H','UGC 05228',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64032,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64032,32.74,0.45,35.4,22396,NULL,NULL,'K','UGC 05228',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64033,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64033,33.99,0.43,62.9,22397,NULL,NULL,NULL,'IC 0562',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000017,NULL,'14.5',0.4,'Sbc? sp',NULL,NULL,NULL,NULL,1,146.51625,-3.97117,0.097,NULL,41303851436,645372678,10083948,14.5),(64034,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64034,34.03,0.2,64,22397,74.4,NULL,NULL,'IC 0562',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64035,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64035,34.24,0.38,70.5,22397,NULL,NULL,'Malmquist cor.','IC 0562',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64036,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64036,34.28,0.4,71.7,22397,NULL,NULL,'mean','IC 0562',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64037,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64037,35.16,0.47,107,22397,NULL,NULL,'H','IC 0562',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64038,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64038,35.21,0.45,110,22397,NULL,NULL,'K','IC 0562',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64039,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64039,35.21,0.49,110,22397,75,NULL,'IR','IC 0562',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64040,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64040,37.49,0.33,315,22398,70,NULL,NULL,'2MASX J09460462+4217278',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000137,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,146.519375,42.29114,0,NULL,63975668827,999619825,15619059,17.8),(64041,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64041,38.06,0.46,409,22399,70,NULL,NULL,'2MASX J09460567+0309419',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,146.523583,3.16156,0.121,NULL,60915329935,951802030,14871906,18.1),(64042,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64042,36.61,0.46,210,22400,70,NULL,NULL,'2MASX J09460603+0905404',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000188,NULL,'15.7g',0.39,'E0',NULL,NULL,NULL,NULL,1,146.525125,9.09469,0.053,NULL,60890166742,951408855,14865763,15.7),(64043,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64043,37.49,0.33,315,22401,70,NULL,NULL,'2MASX J09460634+4216329',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000189,NULL,'15.9g',0.46,'E0',NULL,NULL,NULL,NULL,1,146.5265,42.27569,0,NULL,63975669739,999619839,15619059,15.9),(64044,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64044,34.41,0.51,76.4,22402,NULL,NULL,'Malmquist cor.','AGC 490154',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000027,NULL,'15.0I',NULL,NULL,NULL,NULL,NULL,NULL,1,146.526667,-3.89222,0.097,NULL,41303848645,645372635,10083947,15),(64045,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64045,34.44,0.51,77.2,22402,NULL,NULL,NULL,'AGC 490154',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64046,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64046,34.48,0.2,78.7,22402,74.4,NULL,NULL,'AGC 490154',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64047,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64047,36.56,0.46,205,22403,70,NULL,NULL,'2MASX J09460713+5200446',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,146.52975,52.01228,0,NULL,64013186151,1000206033,15628219,16.8),(64048,'Tully est','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64048,32.8,0.8,36.4,22404,75,NULL,NULL,'ESO 091- G 018',NULL,'1988NBGC.C....0000T',1988,1,2.18,'Stars superposed.','G',0.000029,NULL,'15.75',0.22,'Sd',NULL,NULL,NULL,NULL,1,146.5342083,-63.27247,NULL,NULL,40570342933,633911608,9904868,15.75),(64049,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64049,33.46,NULL,49.1,22404,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 091- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64050,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64050,33.46,NULL,49.2,22404,NULL,NULL,'Dipole','ESO 091- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64051,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64051,33.47,NULL,49.3,22404,NULL,NULL,'Dipole + Quadrupole','ESO 091- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64052,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64052,36.56,0.46,205,22405,70,NULL,NULL,'2MASX J09461069+0231108',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000082,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,146.544708333,2.51958,0.125,NULL,60904102985,951626609,14869165,16.5),(64053,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64053,38.02,0.46,402,22406,70,NULL,NULL,'2MASXi J0946113+290011',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,146.547375,29.00344,0,NULL,64219194303,1003424910,15678514,18),(64054,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64054,36.82,0.46,231,22407,70,NULL,NULL,'2MASX J09461321+1303190',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,146.5550417,13.05536,0.053,NULL,60818864128,950294752,14848355,16.4),(64055,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64055,38.14,0.46,425,22408,70,NULL,NULL,'SDSS J094613.63+075115.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000175,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,146.556791667,7.85442,0.021,NULL,60920679874,951885623,14873212,18.3),(64056,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64056,38.13,0.46,422,22409,70,NULL,NULL,'2MASX J09461439+2807256',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000195,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,146.559916667,28.12375,0.013,NULL,64211872788,1003310512,15676726,16.7),(64057,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64057,36.25,0.46,178,22410,70,NULL,NULL,'2MASX J09461604+1601250',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'15.7g',0.39,NULL,NULL,NULL,NULL,NULL,1,146.566791667,16.02378,0.093,NULL,63727088902,995735764,15558371,15.7),(64058,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64058,37.32,0.33,291,22411,70,NULL,NULL,'2MASX J09461612+2256471',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000131,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,146.567333,22.9465,0.041,NULL,63692397923,995193717,15549901,17.6),(64059,'Tully est','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64059,33.2,0.8,43.7,22412,75,NULL,'B','NGC 2990',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000017,NULL,'13.1',0.7,'Sc:','Brightest group member',NULL,NULL,NULL,1,146.5715,5.70881,0.049,NULL,60912140350,951752192,14871128,13.1),(64060,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64060,32.35,0.69,29.5,22412,100,NULL,'mid-IR','NGC 2990',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64061,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64061,33.17,0.47,43,22412,NULL,NULL,'H','NGC 2990',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64062,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64062,33.17,0.4,43.1,22412,NULL,NULL,NULL,'NGC 2990',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64063,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64063,33.19,0.46,43.4,22412,NULL,NULL,'J','NGC 2990',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64064,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64064,33.22,0.45,44,22412,NULL,NULL,'K','NGC 2990',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64065,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64065,33.28,0.2,45.3,22412,74.4,NULL,NULL,'NGC 2990',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64066,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64066,33.3,0.4,45.7,22412,NULL,NULL,'mean','NGC 2990',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64067,'IRAS','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64067,32.6,0.8,33.1,22413,75,NULL,'MAT, I','NGC 3001',NULL,'1997ApJS..109..333W',1997,1,2.9,NULL,'G',0.000019,NULL,'12.72',1.9,'SAB(rs)c       HII',NULL,NULL,NULL,NULL,1,146.57775,-30.43747,0.473,NULL,42873166179,669893221,10467081,12.72),(64068,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64068,32.56,0.4,32.5,22413,75,NULL,'B','NGC 3001',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64069,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64069,32.79,0.43,36.1,22413,75,NULL,'MAT, I, raw','NGC 3001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64070,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64070,32.81,0.46,36.4,22413,NULL,NULL,'J','NGC 3001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64071,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64071,32.82,0.47,36.6,22413,NULL,NULL,'H','NGC 3001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64072,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64072,32.82,0.45,36.6,22413,NULL,NULL,'K','NGC 3001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64073,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64073,32.89,0.32,37.8,22413,85,NULL,'I, raw','NGC 3001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64074,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64074,32.9,0.4,38,22413,NULL,NULL,'mean','NGC 3001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64075,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64075,32.97,0.32,39.2,22413,85,NULL,'I, inv','NGC 3001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64076,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64076,33.01,0.43,39.9,22413,75,NULL,'MAT, I, cor','NGC 3001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64077,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64077,33.1,0.43,41.7,22413,75,NULL,'MAT, I, inv','NGC 3001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64078,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64078,33.51,0.2,50.4,22413,74.4,NULL,NULL,'NGC 3001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64079,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64079,33.73,0.4,55.7,22413,NULL,NULL,NULL,'NGC 3001',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64080,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64080,37.7,0.46,347,22414,70,NULL,NULL,'2MASX J09461953+4132585',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000164,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,146.5815,41.54972,0.013,NULL,63975327633,999614494,15618976,16.6),(64081,'Ring Diameter','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64081,33.8,0.84,57,22415,NULL,NULL,'Published at H = 100 km/s/Mpc','IC 0563',NULL,'1981ApJS...45..541P',1981,1,1.06,NULL,'G',0.000109,NULL,'14.7g',0.42,'SB(r)ab: pec','Pair member (points to parent)',NULL,NULL,NULL,1,146.5847917,3.04558,0.113,NULL,60915343826,951802247,14871910,14.7),(64082,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64082,34.25,0.49,70.8,22416,75,NULL,'IR','IC 0564',NULL,'2011yCatp016004901K',2011,1,1.92,NULL,'G',0.000027,NULL,'14.0g',0.47,'SA(s)cd? pec   VLIRG','Pair member (points to parent)',NULL,NULL,NULL,1,146.587833,3.07136,0.121,NULL,60915344060,951802250,14871910,14),(64083,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64083,34.29,0.47,72.1,22416,NULL,NULL,'H','IC 0564',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64084,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64084,34.35,0.45,74.2,22416,NULL,NULL,'K','IC 0564',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64085,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64085,34.37,0.46,74.9,22416,NULL,NULL,'J','IC 0564',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64086,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64086,34.7,0.4,87.2,22416,NULL,NULL,'mean','IC 0564',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64087,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64087,37.53,0.1,321,22417,70,NULL,NULL,'2MASX J09462237+4307288',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,146.593083,43.12481,0.005,NULL,63974683482,999604429,15618819,17.7),(64088,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64088,35.67,0.5,136,22418,70,NULL,NULL,'2MASX J09462237-1534144',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.80',NULL,NULL,NULL,NULL,NULL,NULL,1,146.5932083,-15.57078,0.201,NULL,41177785097,643402892,10053170,15.8),(64089,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64089,34.82,0.2,92,22419,74.4,NULL,NULL,'CGCG 063-061',NULL,'2013AJ....146...86T',2013,1,0.94,NULL,'G',0.000088,NULL,'15.3g',0.38,'Sc',NULL,NULL,NULL,NULL,1,146.5942917,9.16522,0.053,NULL,60897689760,951526402,14867600,15.3),(64090,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64090,37.53,0.1,321,22420,70,NULL,NULL,'2MASX J09462295+4250558',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000171,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,146.595625,42.84875,0,NULL,63974887498,999607617,15618869,17.3),(64091,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64091,38.01,0.46,401,22421,70,NULL,NULL,'2MASX J09462397+5547023',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000094,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,146.600041667,55.78408,0,NULL,61935632993,967744265,15121004,17.4),(64092,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64092,33.78,0.49,57.1,22422,75,NULL,'IR','UGC 05210',NULL,'2011yCatp016004901K',2011,1,2.13,'MCG implies the R.A. is 08h42.3m; corrected in MCG errata.','G',0.000037,NULL,'16.0',0.22,'Scd',NULL,NULL,NULL,NULL,1,146.602417,68.95711,0.189,NULL,62096785968,970262280,15160348,16),(64093,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64093,33.83,NULL,58.4,22422,NULL,NULL,NULL,'UGC 05210',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64094,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64094,33.87,NULL,59.3,22422,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05210',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64095,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64095,33.87,NULL,59.5,22422,NULL,NULL,'Dipole + Quadrupole','UGC 05210',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64096,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64096,33.88,NULL,59.6,22422,NULL,NULL,'Dipole','UGC 05210',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64097,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64097,34.09,0.2,65.8,22422,74.4,NULL,NULL,'UGC 05210',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64098,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64098,34.11,0.6,66.4,22422,NULL,NULL,'Malmquist cor.','UGC 05210',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64099,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64099,34.12,0.6,66.7,22422,NULL,NULL,NULL,'UGC 05210',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64100,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64100,35.14,0.64,107,22423,70,NULL,NULL,'2MASX J09462464-1256054',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00009,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,146.602667,-12.93486,0.133,NULL,41184988493,643515445,10054928,14),(64101,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64101,37.17,0.46,271,22424,70,NULL,NULL,'2MASX J09462505+5034565',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000143,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,146.604291667,50.58236,0,NULL,64010731951,1000167686,15627620,17.4),(64102,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64102,36.85,0.11,234,22425,70,NULL,NULL,'2MASX J09462535+5431043',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,146.60575,54.51789,0.005,NULL,61879566252,966868222,15107315,17.3),(64103,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64103,37.6,0.46,331,22426,70,NULL,NULL,'2MASX J09462793+0550238',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,146.6165,5.84006,0.049,NULL,60912074141,951751158,14871111,17.2),(64104,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64104,38.28,0.46,452,22427,70,NULL,NULL,'SDSS J094628.01+000816.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000077,NULL,'18.6g',0.14,'AGN',NULL,NULL,NULL,NULL,1,146.61675,0.13789,0.233,NULL,60767315210,949489300,14835770,18.6),(64105,'IRAS','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64105,30.54,0.8,12.8,22428,75,NULL,'MAT, I','ESO 037- G 005',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000007,NULL,'13.89',0.8,'SAB(s)b pec','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,146.6179583,-74.59564,0.801,NULL,39827576308,622305879,9723529,13.89),(64106,'Tully est','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64106,30.66,0.8,13.5,22428,75,NULL,NULL,'ESO 037- G 005',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64107,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64107,31.48,0.4,19.8,22428,NULL,NULL,NULL,'ESO 037- G 005',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64108,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64108,31.48,0.4,19.8,22428,73,NULL,'opt','ESO 037- G 005',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64109,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64109,31.53,0.2,20.2,22428,74.4,NULL,NULL,'ESO 037- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64110,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64110,31.56,0.32,20.5,22428,85,NULL,'I, inv','ESO 037- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64111,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64111,31.58,0.32,20.7,22428,85,NULL,'I, raw','ESO 037- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64112,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64112,32.02,0.43,25.3,22428,75,NULL,'MAT, I, inv','ESO 037- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64113,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64113,32.03,0.43,25.4,22428,75,NULL,'MAT, I, raw','ESO 037- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64114,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64114,32.26,0.43,28.3,22428,75,NULL,'MAT, I, cor','ESO 037- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64115,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64115,37.53,0.1,321,22429,70,NULL,NULL,'2MASX J09462861+4313201',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,146.6190417,43.22244,0.005,NULL,63974673517,999604273,15618816,18.1),(64116,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64116,34.33,0.46,73.4,22430,70,NULL,NULL,'UGC 05225',NULL,'2015arXiv151105856S',2015,1,1.05,NULL,'G',0.000163,NULL,'14.4g',1.02,'S?','in a pair',NULL,NULL,NULL,1,146.619125,45.75261,0.017,NULL,63985048947,999766389,15621349,14.4),(64117,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64117,34.44,0.47,77.2,22431,70,NULL,NULL,'NGC 2996',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00005,NULL,'13.54',1.3,'S0+ pec:',NULL,NULL,NULL,NULL,1,146.62575,-21.57161,0.101,NULL,42283831834,660684872,10323201,13.54),(64118,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64118,34.33,0.58,73.4,22432,NULL,NULL,NULL,'CGCG 092-049',NULL,'2009ApJS..182..474S',2009,1,0.84,NULL,'G',0.000017,NULL,'15.3',0.37,NULL,NULL,NULL,NULL,NULL,1,146.62925,15.88633,0.085,NULL,60826978271,950421535,14850336,15.3),(64119,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64119,34.35,0.57,74,22432,NULL,NULL,'Malmquist cor.','CGCG 092-049',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64120,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64120,34.37,0.2,74.8,22432,74.4,NULL,NULL,'CGCG 092-049',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64121,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64121,35.07,0.33,103,22433,70,NULL,NULL,'2MASX J09463098+2203095',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00016,NULL,'16.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,146.629208333,22.05267,0.057,NULL,63691785339,995184145,15549752,16.5),(64122,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64122,37.2,0.46,276,22434,70,NULL,NULL,'2MASX J09463182+3437424',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000199,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,146.632583,34.62853,0,NULL,64187221200,1002925331,15670708,16.6),(64123,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64123,37.2,0.19,276,22435,70,NULL,NULL,'2MASX J09463255+2722460',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,146.635666667,27.37931,0.021,NULL,64167535722,1002617745,15665902,17.2),(64124,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64124,37.77,0.33,358,22436,70,NULL,NULL,'2MASX J09463320+2608180',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000209,NULL,'16.1g',0.39,NULL,NULL,NULL,NULL,NULL,1,146.63825,26.13828,0.017,NULL,64168621780,1002634715,15666167,16.1),(64125,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64125,37.53,0.1,321,22437,70,NULL,NULL,'SDSS J094633.57+431237.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00014,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,146.639917,43.21042,0.005,NULL,63974672991,999604265,15618816,17.8),(64126,'IRAS','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64126,34,0.8,63.1,22438,75,NULL,'MAT, I','ESO 499- G 004',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.91',0.5,'SAB(s)b:',NULL,NULL,NULL,NULL,1,146.6434583,-23.91797,0.141,NULL,42291018971,660797171,10324955,14.91),(64127,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64127,33.7,0.55,55.1,22438,NULL,NULL,'Malmquist cor.','ESO 499- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64128,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64128,33.92,0.32,60.9,22438,85,NULL,'I, raw','ESO 499- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64129,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64129,33.95,0.2,61.7,22438,74.4,NULL,NULL,'ESO 499- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64130,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64130,33.95,0.32,61.7,22438,85,NULL,'I, inv','ESO 499- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64131,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64131,33.98,0.48,62.4,22438,NULL,NULL,NULL,'ESO 499- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64132,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64132,34.05,0.43,64.5,22438,75,NULL,'MAT, I, raw','ESO 499- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64133,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64133,34.19,0.43,69,22438,75,NULL,'MAT, I, inv','ESO 499- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64134,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64134,34.23,0.43,70,22438,75,NULL,'MAT, I, cor','ESO 499- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64135,'SNIa','2016-12-15 15:14:31','2016-12-16 11:19:38','1','SN 2003kc',NULL,64135,35.11,0.17,102,22439,74.2,NULL,'SALT 2','CGCG 152-068',0.0341,'2010ApJ...716..712A',2010,1,0.85,NULL,'G',0.000158,NULL,'14.6g',0.58,'Sc I?',NULL,NULL,NULL,NULL,1,146.6447917,30.65308,0.009,NULL,64217981060,1003405954,15678218,14.6),(64136,'SNIa','2016-12-15 15:14:31','2016-12-16 11:19:38','1','SN 2003kc','R',64136,35.64,0.2,134,22439,NULL,NULL,'MLCS2k2, R(V) = 3.1','CGCG 152-068',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64137,'SNIa','2016-12-15 15:14:31','2016-12-16 11:19:38','1','SN 2003kc',NULL,64137,35.69,0.1,137,22439,74.4,NULL,NULL,'CGCG 152-068',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64138,'SNIa','2016-12-15 15:14:31','2016-12-16 11:19:38','1','SN 2003kc','R',64138,35.69,0.13,137,22439,NULL,NULL,'MLCS2k2, R(V) = 1.8','CGCG 152-068',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64139,'SNIa','2016-12-15 15:14:31','2016-12-16 11:19:38','1','SN 2003kc',NULL,64139,35.8,0.16,140,22439,73.8,NULL,'SALT 2 (SNANA)','CGCG 152-068',0.0346,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64140,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64140,37.32,0.33,291,22440,70,NULL,NULL,'2MASX J09463528+2257435',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,146.647125,22.96203,0.053,NULL,63691908042,995186063,15549782,17.6),(64141,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64141,35.07,0.33,103,22441,70,NULL,NULL,'CGCG 122-076',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000167,NULL,'15.5',0.25,NULL,NULL,NULL,NULL,NULL,1,146.649083,21.74967,0.053,NULL,63698950971,995296108,15551501,15.5),(64142,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64142,36.07,0.52,163,22442,70,NULL,NULL,'2MASX J09463583-2335038',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00009,NULL,'13.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,146.649333,-23.58433,0.161,NULL,42291116040,660798688,10324979,13.7),(64143,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64143,37.53,0.1,321,22443,70,NULL,NULL,'2MASX J09463620+4238461',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000184,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,146.65075,42.64625,0.005,NULL,63974924843,999608200,15618878,16.6),(64144,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64144,38.18,0.46,433,22444,70,NULL,NULL,'2MASX J09463627+6221197',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000084,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,146.65125,62.35539,0.061,NULL,62028023714,969187870,15143560,17.6),(64145,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64145,37.34,0.46,294,22445,70,NULL,NULL,'2MASX J09463811+2207545',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,146.658875,22.13186,0.057,NULL,63691664634,995182259,15549722,17.4),(64146,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64146,36.95,0.46,245,22446,70,NULL,NULL,'2MASX J09463844+3957160',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,146.660375,39.95456,0.013,NULL,64089008303,1001390754,15646730,17.3),(64147,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64147,35.2,0.27,110,22447,70,NULL,NULL,'2MASX J09463853+3559430',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00009,NULL,'15.7g',0.47,'E0',NULL,NULL,NULL,NULL,1,146.660583,35.99519,0,NULL,64186901279,1002920332,15670630,15.7),(64148,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64148,37.99,0.61,396,22448,70,NULL,NULL,'2MASX J09463936-0609193',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,146.6640417,-6.15531,0.113,NULL,41324697324,645698395,10089037,15.6),(64149,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64149,37.27,0.46,285,22449,70,NULL,NULL,'SDSS J094641.52+104953.9',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000179,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,146.673,10.83167,0.037,NULL,60898897078,951545266,14867894,16.9),(64150,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64150,37.73,0.33,351,22450,70,NULL,NULL,'2MASX J09464159+0419047',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000196,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,146.673333,4.31811,0.109,NULL,60915509218,951804831,14871950,16.4),(64151,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64151,35.54,0.46,128,22451,70,NULL,NULL,'CGCG 035-055',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000167,NULL,'15.2g',0.47,'S0',NULL,NULL,NULL,NULL,1,146.6775,6.68319,0.037,NULL,60921949141,951905455,14873522,15.2),(64152,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64152,35.91,0.46,152,22452,70,NULL,NULL,'2MASX J09464266+5239532',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00017,NULL,'15.8g',0.33,'S0^-',NULL,NULL,NULL,NULL,1,146.677625,52.66475,0.013,NULL,64009756609,1000152447,15627381,15.8),(64153,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64153,37.77,0.33,358,22453,70,NULL,NULL,'2MASX J09464278+2610160',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000182,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,146.678458333,26.17122,0.029,NULL,64168617623,1002634650,15666166,17.2),(64154,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64154,37.15,0.46,269,22454,70,NULL,NULL,'2MASX J09464317+4020520',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000174,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,146.68,40.34797,0.017,NULL,63971635795,999556809,15618075,17.5),(64155,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64155,37.19,0.46,274,22455,70,NULL,NULL,'2MASX J09464359+2135264',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00018,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,146.681583333,21.59058,0.057,NULL,63698952363,995296130,15551502,16.6),(64156,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64156,37.38,0.46,300,22456,70,NULL,NULL,'2MASX J09464536+1211393',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,146.689083,12.19433,0.037,NULL,60886617819,951353403,14864896,17.5),(64157,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64157,36.85,0.11,234,22457,70,NULL,NULL,'CGCG 265-035',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.000147,NULL,'14.9g',0.67,'S0?;BrClG','in a pair',NULL,NULL,NULL,1,146.689375,54.42692,0.005,NULL,61879438807,966866231,15107284,14.9),(64158,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64158,37.53,0.1,321,22458,70,NULL,NULL,'2MASX J09464618+4305072',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000177,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,146.6922917,43.08528,0,NULL,63974679068,999604360,15618818,17.2),(64159,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64159,37.52,0.46,319,22459,70,NULL,NULL,'2MASX J09464620+3818431',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000183,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,146.692417,38.31211,0,NULL,64173583680,1002712245,15667378,17.1),(64160,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64160,37.39,0.46,301,22460,70,NULL,NULL,'2MASX J09464642+4541032',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000182,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,146.693375,45.68425,0.017,NULL,63985117913,999767467,15621366,16.9),(64161,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64161,37.73,0.33,351,22461,70,NULL,NULL,'SDSS J094647.46+041734.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000146,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,146.6977917,4.29283,0.109,NULL,60915513235,951804894,14871951,18.5),(64162,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64162,36.89,0.46,239,22462,70,NULL,NULL,'2MASX J09464756+0210067',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000091,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,146.698125,2.16839,0.129,NULL,60905421653,951647213,14869487,16.6),(64163,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64163,34.24,0.46,70.5,22463,70,NULL,NULL,'CGCG 063-066',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.00016,NULL,'14.5g',0.74,NULL,NULL,NULL,NULL,NULL,1,146.7039583,9.73614,0.037,NULL,60898104253,951532878,14867701,14.5),(64164,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64164,37.87,0.46,374,22464,70,NULL,NULL,'SDSS J094649.25+580116.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000075,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,146.70525,58.02117,0.013,NULL,61932141711,967689714,15120151,18.5),(64165,'SNIa','2016-12-15 15:14:31','2016-12-16 11:19:38','1','SN 2003W',NULL,64165,33.92,0.18,59.6,22465,74.2,NULL,'SALT 2','UGC 05234',0.020071,'2010ApJ...716..712A',2010,1,1.6,NULL,'G',0.000033,NULL,'14.20',1.1,'S(r)c',NULL,NULL,NULL,NULL,1,146.706333333,16.04286,0.093,NULL,63726552852,995727388,15558240,14.2),(64166,'SNIa','2016-12-15 15:14:31','2016-12-16 11:19:38','1','SN 2003W',NULL,64166,34.52,0.05,78.6,22465,72,NULL,'SALT','UGC 05234',0.020071,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64167,'SNIa','2016-12-15 15:14:31','2016-12-16 11:19:38','1','SN 2003W',NULL,64167,34.49,0.09,79.1,22465,74.4,NULL,NULL,'UGC 05234',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64168,'SNIa','2016-12-15 15:14:31','2016-12-16 11:19:38','1','SN 2003W','R',64168,34.51,0.05,79.8,22465,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 05234',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64169,'SNIa','2016-12-15 15:14:31','2016-12-16 11:19:38','1','SN 2003W','R',64169,34.57,0.04,82,22465,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 05234',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64170,'SNIa','2016-12-15 15:14:31','2016-12-16 11:19:38','1','SN 2003W',NULL,64170,34.76,0.19,87.7,22465,65,NULL,'SALT','UGC 05234',0.020071,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64171,'SNIa','2016-12-15 15:14:31','2016-12-16 11:19:38','1','SN 2003W',NULL,64171,34.8,0.21,89.2,22465,65,NULL,'SALT2','UGC 05234',0.020071,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64172,'SNIa','2016-12-15 15:14:31','2016-12-16 11:19:38','1','SN 2003W',NULL,64172,34.87,0.18,92.2,22465,65,NULL,'MLCS17','UGC 05234',0.020071,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64173,'SNIa','2016-12-15 15:14:31','2016-12-16 11:19:38','1','SN 2003W',NULL,64173,34.88,0.18,92.9,22465,65,NULL,'MLCS31','UGC 05234',0.020071,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64174,'SNIa','2016-12-15 15:14:31','2016-12-16 11:19:38','1','SN 2003W',NULL,64174,35.53,0.02,125,22465,70,NULL,'SALT 2','UGC 05234',0.020071,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64175,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64175,33.84,0.69,58.7,22465,100,NULL,'mid-IR','UGC 05234',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64176,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64176,34.63,0.46,84.3,22465,NULL,NULL,'J','UGC 05234',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64177,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64177,34.77,0.47,89.9,22465,NULL,NULL,'H','UGC 05234',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64178,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64178,34.79,0.4,90.8,22465,NULL,NULL,'mean','UGC 05234',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64179,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64179,34.8,0.45,91.2,22465,NULL,NULL,'K','UGC 05234',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64180,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64180,37.67,0.46,343,22466,70,NULL,NULL,'2MASX J09464994+4109151',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,146.7080417,41.15422,0,NULL,63971871714,999560495,15618132,18.2),(64181,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64181,37.26,0.46,283,22467,70,NULL,NULL,'2MASX J09465011+6048444',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000076,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,146.7087083,60.81219,0.053,NULL,61914317872,967411216,15115800,17),(64182,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64182,35.27,0.4,113,22468,NULL,NULL,'mean','NGC 2991',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000097,NULL,'13.53',1.1,'S0','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,146.708833,22.01394,0.049,NULL,63691653898,995182092,15549720,13.53),(64183,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64183,35.44,0.45,122,22468,NULL,NULL,'K','NGC 2991',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64184,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64184,33.87,NULL,59.3,22469,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0940',NULL,'2010Ap&SS.325..163P',2010,1,1.01,NULL,'G',0.00004,NULL,'16.7',0.09,'Sdm',NULL,NULL,NULL,NULL,1,146.709167,-6.605,0.117,NULL,41325915541,645717430,10089334,16.7),(64185,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64185,33.9,NULL,60.1,22469,NULL,NULL,'Dipole + Quadrupole','FGC 0940',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64186,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64186,33.9,NULL,60.3,22469,NULL,NULL,'Dipole','FGC 0940',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64187,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64187,33.97,NULL,62.2,22469,NULL,NULL,NULL,'FGC 0940',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64188,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64188,37.96,0.46,391,22470,70,NULL,NULL,'2MASX J09465332+3956251',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000172,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,146.7222917,39.94042,0.013,NULL,64089006627,1001390728,15646730,17.2),(64189,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64189,32.1,0.4,26.3,22471,75,NULL,'B','UGC 05238',NULL,'1988NBGC.C....0000T',1988,1,1.72,'2MASS position for superposed star.','G',0.000006,NULL,'15.2g',0.59,'SB(s)dm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,146.724417,0.50731,0.233,NULL,60767270627,949488603,14835759,15.2),(64190,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64190,32.34,0.2,29.4,22471,74.4,NULL,NULL,'UGC 05238',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64191,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64191,32.37,0.43,29.8,22471,75,NULL,'3.6 micron, color corrected','UGC 05238',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64192,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64192,32.4,0.43,30.2,22471,75,NULL,'3.6 micron, color + selection bias corrected','UGC 05238',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64193,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64193,32.73,0.61,35.1,22471,NULL,NULL,NULL,'UGC 05238',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64194,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64194,32.81,0.4,36.5,22471,NULL,NULL,NULL,'UGC 05238',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64195,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64195,33.01,0.54,39.9,22471,NULL,NULL,'Malmquist cor.','UGC 05238',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64196,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64196,35.12,NULL,105,22472,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05235',NULL,'2010Ap&SS.325..163P',2010,1,1.4,NULL,'G',0.000007,NULL,'16.3g',0.19,'Scd',NULL,NULL,NULL,NULL,1,146.72475,23.02322,0.053,NULL,63691944193,995186628,15549791,16.3),(64197,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64197,35.13,NULL,106,22472,NULL,NULL,'Dipole + Quadrupole','UGC 05235',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64198,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64198,35.13,NULL,106,22472,NULL,NULL,'Dipole','UGC 05235',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64199,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64199,35.19,NULL,109,22472,NULL,NULL,NULL,'UGC 05235',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64200,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64200,35.38,0.49,119,22472,75,NULL,'IR','UGC 05235',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64201,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64201,35.77,0.2,143,22472,74.4,NULL,NULL,'UGC 05235',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64202,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64202,36.59,0.46,208,22473,70,NULL,NULL,'2MASX J09465391+3417560',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,146.7247917,34.29886,0,NULL,64187021075,1002922204,15670659,17),(64203,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64203,37.56,0.46,325,22474,70,NULL,NULL,'SDSS J094654.96+000136.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000082,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,146.729,0.02694,0.249,NULL,60767181897,949487217,14835737,18.4),(64204,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64204,38.04,0.46,406,22475,70,NULL,NULL,'2MASX J09465517+5647152',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000098,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,146.729917,56.78747,0.009,NULL,61937485505,967773211,15121456,17.3),(64205,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64205,32.14,NULL,26.8,22476,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05203',NULL,'2010Ap&SS.325..163P',2010,1,2.49,NULL,'G',0.000037,NULL,'15.5',0.22,'Scd',NULL,NULL,NULL,NULL,1,146.732625,79.81075,0.033,NULL,61426638607,959791228,14996737,15.5),(64206,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64206,32.16,NULL,27,22476,NULL,NULL,'Dipole + Quadrupole','UGC 05203',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64207,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64207,32.16,NULL,27.1,22476,NULL,NULL,'Dipole','UGC 05203',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64208,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64208,32.21,0.2,27.7,22476,74.4,NULL,NULL,'UGC 05203',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64209,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64209,32.28,0.56,28.5,22476,NULL,NULL,'Malmquist cor.','UGC 05203',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64210,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64210,32.31,0.4,29,22476,NULL,NULL,NULL,'UGC 05203',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64211,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64211,32.37,0.53,29.8,22476,NULL,NULL,NULL,'UGC 05203',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64212,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64212,32.41,NULL,30.4,22476,NULL,NULL,NULL,'UGC 05203',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64213,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64213,32.43,0.43,30.7,22476,75,NULL,'3.6 micron, color corrected','UGC 05203',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64214,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64214,32.47,0.4,31.2,22476,75,NULL,NULL,'UGC 05203',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64215,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64215,32.53,0.43,32.1,22476,75,NULL,'3.6 micron, color + selection bias corrected','UGC 05203',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64216,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64216,32.62,0.49,33.4,22476,75,NULL,'IR','UGC 05203',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64217,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64217,37.3,0.46,288,22477,70,NULL,NULL,'2MASX J09465652+3938131',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00018,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,146.735625,39.63692,0.021,NULL,64055459131,1000866548,15638539,17.1),(64218,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64218,38,0.33,399,22478,70,NULL,NULL,'2MASX J09465667+3527300',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000184,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,146.736083,35.45825,0,NULL,64187497329,1002929645,15670775,16.7),(64219,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64219,36.19,0.46,173,22479,70,NULL,NULL,'2MASX J09465706+1415508',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,146.73775,14.26425,0.089,NULL,60831410339,950490786,14851418,16.5),(64220,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64220,36.93,0.46,243,22480,70,NULL,NULL,'2MASX J09465842+2557090',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000155,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,146.743375,25.95256,0.033,NULL,64168646716,1002635104,15666173,16.9),(64221,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64221,37.2,0.19,276,22481,70,NULL,NULL,'2MASX J09465895+2715041',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,146.7455,27.25131,0.009,NULL,64167569300,1002618270,15665910,17.3),(64222,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64222,37.65,0.46,340,22482,70,NULL,NULL,'SDSS J094659.14+413633.7',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'16.2g',0.32,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,146.7464583,41.60939,0.013,NULL,63975385928,999615405,15618990,16.2),(64223,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64223,37.53,0.1,321,22483,70,NULL,NULL,'2MASX J09470035+4332041',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000187,NULL,'16.8g',0.33,NULL,NULL,NULL,NULL,NULL,1,146.751625,43.53453,0,NULL,63987311197,999801737,15621902,16.8),(64224,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64224,37.56,0.46,325,22484,70,NULL,NULL,'2MASX J09470166+2624002',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00014,NULL,'16.9g',0.32,NULL,NULL,NULL,NULL,NULL,1,146.756917,26.40017,0.041,NULL,64168586192,1002634159,15666158,16.9),(64225,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64225,37.77,0.27,358,22485,70,NULL,NULL,'2MASX J09470264+2312121',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,146.761125,23.2035,0.081,NULL,63693841250,995216269,15550254,17.2),(64226,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64226,36.23,0.58,176,22486,70,NULL,NULL,'2MASX J09470267-0552581',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000093,NULL,'16.40',0.6,NULL,NULL,NULL,NULL,NULL,1,146.761167,-5.88281,0.113,NULL,41294743173,645230362,10081724,16.4),(64227,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64227,37.77,0.27,358,22487,70,NULL,NULL,'2MASX J09470300+2316141',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000181,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,146.762583,23.27064,0.081,NULL,63693844790,995216324,15550255,17),(64228,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64228,37.51,0.46,317,22488,70,NULL,NULL,'SDSS J094703.02+021431.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000062,NULL,'18.4g',0.15,'NLAGN',NULL,NULL,NULL,NULL,1,146.762625,2.24219,0.129,NULL,60905396765,951646824,14869481,18.4),(64229,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64229,37.47,0.46,312,22489,70,NULL,NULL,'2MASX J09470470+2925252',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000165,NULL,'17.0g',0.23,'E',NULL,NULL,NULL,NULL,1,146.76975,29.42378,0.005,NULL,64217025249,1003391019,15677984,17),(64230,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64230,36.85,0.11,234,22490,70,NULL,NULL,'MCG +09-16-045',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000201,NULL,'16.0g',0.36,'S0',NULL,NULL,NULL,NULL,1,146.7712083,54.42136,0.005,NULL,61878731430,966855178,15107112,16),(64231,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64231,37.53,0.1,321,22491,70,NULL,NULL,'2MASX J09470522+4315290',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,146.771667,43.258,0.005,NULL,63972849628,999575775,15618371,18.3),(64232,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64232,37.96,0.46,392,22492,70,NULL,NULL,'2MASX J09470537+0231527',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000083,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,146.772417,2.53128,0.125,NULL,60904554472,951633663,14869275,17.7),(64233,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64233,32.62,NULL,33.4,22493,NULL,NULL,NULL,'UGC 05242',NULL,'2015AstBu..70....1K',2015,1,0.77,'Confused HIPASS source','G',0.000018,NULL,'16.2g',0.4,'SB(s)m:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,146.772875,0.96425,0.181,NULL,60902237100,951597454,14868710,16.2),(64234,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64234,37.45,0.46,309,22494,70,NULL,NULL,'2MASX J09470646+6201116',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000076,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,146.777041667,62.01989,0.057,NULL,62028107245,969189175,15143580,16.9),(64235,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64235,36.62,0.46,210,22495,70,NULL,NULL,'2MASX J09470671+0102227',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000072,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,146.777917,1.03958,0.181,NULL,60901726429,951589475,14868585,17.3),(64236,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64236,37.09,0.46,262,22496,70,NULL,NULL,'2MASX J09470693+1141002',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000196,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,146.778916667,11.68356,0.025,NULL,60898308453,951536069,14867751,16.4),(64237,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64237,35.91,0.46,152,22497,70,NULL,NULL,'IC 2508',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000184,NULL,'15.6g',0.39,'Sa',NULL,NULL,NULL,NULL,1,146.7795,33.50806,0,NULL,64184083089,1002876298,15669942,15.6),(64238,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64238,37.54,0.46,322,22498,70,NULL,NULL,'2MASX J09470794+2544022',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000144,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,146.783083333,25.73392,0.041,NULL,64168496754,1002632761,15666136,17.5),(64239,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64239,37.53,0.1,321,22499,70,NULL,NULL,'2MASX J09470855+4330381',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000178,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,146.7857917,43.51056,0,NULL,63987257566,999800899,15621889,16.5),(64240,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64240,37.61,0.33,333,22500,70,NULL,NULL,'2MASX J09470878+4211261',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000203,NULL,'16.0g',0.37,'E0',NULL,NULL,NULL,NULL,1,146.78675,42.19044,0,NULL,63975573278,999618332,15619036,16),(64241,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64241,36.81,0.33,230,22501,70,NULL,NULL,'2MASX J09471099+0146027',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000082,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,146.79575,1.76722,0.141,NULL,60905285321,951645083,14869454,17.8),(64242,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64242,37.75,0.46,355,22502,70,NULL,NULL,'2MASX J09471306+2208411',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,146.804625,22.14469,0.057,NULL,63691657593,995182149,15549721,17.8),(64243,'IRAS','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64243,33.93,0.8,61,22503,75,NULL,'MAT, I','ESO 499- G 005',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000013,NULL,'13.76',0.7,'SA(rs)c        HII',NULL,NULL,NULL,NULL,1,146.805917,-24.83961,0.129,NULL,42822019530,669094055,10454594,13.76),(64244,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64244,32.78,0.32,36,22503,85,NULL,'I, raw','ESO 499- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64245,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64245,32.82,0.32,36.6,22503,85,NULL,'I, inv','ESO 499- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64246,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64246,32.89,0.43,37.9,22503,75,NULL,'MAT, I, raw','ESO 499- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64247,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64247,33.07,0.43,41.1,22503,75,NULL,'MAT, I, inv','ESO 499- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64248,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64248,33.16,0.43,42.9,22503,75,NULL,'MAT, I, cor','ESO 499- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64249,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64249,33.29,0.39,45.6,22503,NULL,NULL,'Malmquist cor.','ESO 499- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64250,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64250,33.34,0.2,46.6,22503,74.4,NULL,NULL,'ESO 499- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64251,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64251,33.41,0.43,48.1,22503,75,NULL,'3.6 micron, color corrected','ESO 499- G 005',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64252,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64252,33.51,0.35,50.4,22503,NULL,NULL,NULL,'ESO 499- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64253,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64253,33.59,0.43,52.2,22503,75,NULL,'3.6 micron, color + selection bias corrected','ESO 499- G 005',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64254,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64254,33.8,0.47,57.6,22503,NULL,NULL,'H','ESO 499- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64255,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64255,33.87,0.46,59.5,22503,NULL,NULL,'J','ESO 499- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64256,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64256,33.95,0.45,61.7,22503,NULL,NULL,'K','ESO 499- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64257,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64257,34.06,0.4,64.8,22503,NULL,NULL,'mean','ESO 499- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64258,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64258,37.53,0.1,321,22504,70,NULL,NULL,'SDSS J094713.64+432004.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,146.806833333,43.33461,0,NULL,63986743702,999792870,15621763,18.4),(64259,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64259,37.53,0.1,321,22505,70,NULL,NULL,'2MASX J09471408+4303171',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000184,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,146.8085,43.05486,0,NULL,63972860608,999575947,15618374,16.6),(64260,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64260,35.39,0.46,120,22506,70,NULL,NULL,'2MASX J09471441+1852381',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00017,NULL,'15.9g',0.35,'AGN',NULL,NULL,NULL,NULL,1,146.8102083,18.87725,0.037,NULL,63741558641,995961853,15561903,15.9),(64261,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64261,36.92,0.46,243,22507,70,NULL,NULL,'2MASX J09471487-0011242',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000081,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,146.812,-0.19006,0.193,NULL,41221793856,644090529,10063914,17.6),(64262,'Brightest Stars','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64262,28.01,NULL,4,22508,NULL,NULL,'Blue','NGC 2976',NULL,'1997AstL...23..644G',1997,1,5.9,NULL,'G',NULL,NULL,'10.82',2.7,'SAc pec        HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,146.814417,67.91639,0.105,NULL,62247811312,972622051,15197219,10.82),(64263,'Brightest Stars','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64263,28.18,NULL,4.33,22508,NULL,NULL,'3B','NGC 2976',NULL,'1991A&AS...91..503K',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64264,'Brightest Stars','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64264,28.36,NULL,4.7,22508,NULL,NULL,'3R','NGC 2976',NULL,'1991A&AS...91..503K',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64265,'Brightest Stars','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64265,28.68,NULL,5.45,22508,NULL,NULL,'Red + Blue','NGC 2976',NULL,'1997AstL...23..644G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64266,'Brightest Stars','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64266,28.87,NULL,5.94,22508,NULL,NULL,'Red','NGC 2976',NULL,'1997AstL...23..644G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64267,'CMD','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64267,27.73,NULL,3.52,22508,NULL,NULL,NULL,'NGC 2976',NULL,'2012ApJ...748...47M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64268,'CMD','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64268,27.75,NULL,3.55,22508,NULL,NULL,NULL,'NGC 2976',NULL,'2010ApJ...709..135W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64269,'TRGB','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64269,27.75,0.02,3.55,22508,NULL,NULL,'I','NGC 2976',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64270,'TRGB','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64270,27.76,0.23,3.56,22508,NULL,NULL,'I','NGC 2976',NULL,'2003A&A...398..479K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64271,'TRGB','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64271,27.76,0.02,3.57,22508,NULL,NULL,'I','NGC 2976',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64272,'TRGB','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64272,27.77,0.07,3.58,22508,NULL,NULL,'I','NGC 2976',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64273,'TRGB','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64273,27.8,0.08,3.63,22508,74.4,NULL,NULL,'NGC 2976',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64274,'Tully est','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64274,26.63,0.8,2.1,22508,75,NULL,'B','NGC 2976',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64275,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64275,27.76,0.36,3.56,22508,NULL,NULL,NULL,'NGC 2976',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64276,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64276,27.96,NULL,3.91,22508,NULL,NULL,'LEDA [April 2006]','NGC 2976',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64277,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64277,37.03,0.33,255,22509,70,NULL,NULL,'2MASX J09471573+0608493',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000176,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,146.8154583,6.14714,0.041,NULL,60919662027,951869719,14872964,16.7),(64278,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64278,37.94,0.46,388,22510,70,NULL,NULL,'SDSS J094715.89+005638.6',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000089,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,146.81625,0.94408,0.181,NULL,60901696105,951589001,14868578,17.6),(64279,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64279,36.28,0.46,180,22511,70,NULL,NULL,'2MASX J09471697+3302304',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000175,NULL,'15.9g',0.38,'S0',NULL,NULL,NULL,NULL,1,146.8205417,33.04181,0.009,NULL,64184175248,1002877738,15669964,15.9),(64280,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64280,38.24,0.46,444,22512,70,NULL,NULL,'2MASX J09471825+2751522',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,146.826083333,27.86453,0,NULL,64166669869,1002604216,15665690,17.5),(64281,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64281,37.77,0.27,358,22513,70,NULL,NULL,'2MASX J09471881+2309241',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,146.828291667,23.15681,0.081,NULL,63691919921,995186248,15549785,17.2),(64282,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64282,36.81,0.33,230,22514,70,NULL,NULL,'2MASX J09471880+0144347',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000105,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,146.828375,1.74292,0.141,NULL,60905251806,951644559,14869446,16.6),(64283,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64283,37.53,0.1,321,22515,70,NULL,NULL,'2MASX J09471987+4324012',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000195,NULL,'16.0g',0.41,'E0',NULL,NULL,NULL,NULL,1,146.832833,43.40042,0,NULL,63986741326,999792833,15621763,16),(64284,'IRAS','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64284,34.14,0.8,67.2,22516,75,NULL,'CF, r','UGC 05237',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000023,NULL,'14.74',0.7,'Scd:',NULL,NULL,NULL,NULL,1,146.833917,46.61008,0.005,NULL,63984166547,999752602,15621134,14.74),(64285,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64285,34.03,0.2,64,22516,74.4,NULL,NULL,'UGC 05237',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64286,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64286,34.38,0.38,75.2,22516,75,NULL,'CF, r, raw','UGC 05237',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64287,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64287,34.45,0.38,77.5,22516,75,NULL,'CF, r, inv','UGC 05237',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64288,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64288,34.7,0.38,86.9,22516,75,NULL,'CF, r, cor','UGC 05237',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64289,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64289,35.06,0.2,103,22517,74.4,NULL,NULL,'CGCG 092-051',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000173,NULL,'15.0',0.4,NULL,NULL,NULL,NULL,NULL,1,146.835375,14.72433,0.073,NULL,60831848642,950497635,14851525,15),(64290,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64290,34.9,NULL,95.7,22518,NULL,NULL,NULL,'UGC 05240',NULL,'2000BSAO...50....5K',2000,1,1.25,NULL,'G',0.000033,NULL,'15.8g',0.25,'Scd','Field galaxy',NULL,NULL,NULL,1,146.840125,25.74597,0.041,NULL,64168507986,1002632937,15666139,15.8),(64291,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64291,34.92,0.49,96.4,22518,75,NULL,'IR','UGC 05240',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64292,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64292,34.92,NULL,96.6,22518,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05240',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64293,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64293,34.93,NULL,97,22518,NULL,NULL,'Dipole + Quadrupole','UGC 05240',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64294,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64294,34.95,NULL,97.5,22518,NULL,NULL,'Dipole','UGC 05240',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64295,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64295,35.2,0.2,110,22518,74.4,NULL,NULL,'UGC 05240',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64296,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64296,35.21,0.36,110,22518,NULL,NULL,'Malmquist cor.','UGC 05240',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64297,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64297,35.28,0.35,114,22518,NULL,NULL,NULL,'UGC 05240',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64298,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64298,36.85,0.11,234,22519,70,NULL,NULL,'CGCG 265-040',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000133,NULL,'15.2g',0.64,'E0','Group member',NULL,NULL,NULL,1,146.8407083,54.47386,0,NULL,61878649391,966853896,15107092,15.2),(64299,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64299,36.84,0.46,233,22520,70,NULL,NULL,'2MASX J09472431+5314328',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000174,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,146.851333,53.24236,0,NULL,63963726095,999433220,15616144,16.6),(64300,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64300,38.11,0.46,419,22521,70,NULL,NULL,'SDSS J094725.52+270557.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000129,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,146.856375,27.09933,0.037,NULL,64167387598,1002615431,15665866,18.2),(64301,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64301,37.54,0.46,323,22522,70,NULL,NULL,'2MASX J09472586+3352465',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,146.8579583,33.87972,0,NULL,64183899074,1002873423,15669897,17),(64302,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64302,36.85,0.46,235,22523,70,NULL,NULL,'2MASX J09472745+1424158',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,146.8642917,14.40433,0.089,NULL,60831380183,950490315,14851411,17),(64303,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64303,37.61,0.33,333,22524,70,NULL,NULL,'SDSS J094730.16+420533.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000169,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,146.8757083,42.09267,0.013,NULL,63975561747,999618152,15619033,18),(64304,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64304,38.16,0.46,429,22525,70,NULL,NULL,'2MASX J09473119+3439265',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000178,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,146.879917,34.65744,0,NULL,64187248125,1002925751,15670714,17.7),(64305,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64305,37.76,0.46,356,22526,70,NULL,NULL,'2MASX J09473124+1356449',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,146.8802083,13.94597,0.065,NULL,60833389607,950521712,14851901,17.4),(64306,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64306,35.24,0.46,112,22527,70,NULL,NULL,'2MASX J09473158+4815108',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000167,NULL,'15.7g',0.49,'E0',NULL,NULL,NULL,NULL,1,146.8815,48.25325,0.025,NULL,64019514998,1000304921,15629764,15.7),(64307,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64307,37.97,0.46,393,22528,70,NULL,NULL,'SDSS J094731.90+064852.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000197,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,146.8829583,6.81467,0.037,NULL,60921864924,951904139,14873502,18.2),(64308,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64308,36.26,0.46,179,22529,70,NULL,NULL,'2MASX J09473281+1045083',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000181,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,146.886666667,10.75239,0.045,NULL,60898729539,951542649,14867853,17),(64309,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64309,37.18,0.46,273,22530,70,NULL,NULL,'2MASX J09473305+2327199',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,146.887583333,23.45547,0.061,NULL,63693855558,995216493,15550257,17.2),(64310,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64310,37.32,0.46,291,22531,70,NULL,NULL,'2MASX J09473414+2730001',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000158,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,146.892083,27.49994,0.017,NULL,64167513086,1002617391,15665896,17.1),(64311,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64311,37.03,0.33,255,22532,70,NULL,NULL,'2MASX J09473417+0604033',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000176,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,146.8925417,6.06775,0.045,NULL,60912192848,951753013,14871140,16.5),(64312,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64312,36.8,0.46,229,22533,70,NULL,NULL,'2MASX J09473425+0625163',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000154,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,146.8927083,6.42128,0.041,NULL,60919868083,951872938,14873014,16.8),(64313,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64313,31.21,NULL,17.4,22534,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05245',NULL,'2010Ap&SS.325..163P',2010,1,2.8,'The UZC position refers to the northwestern arm.','G',0.000023,NULL,'14.70',0.34,'SBdm? sp','Isolated galaxy',NULL,NULL,NULL,1,146.893666667,-2.03292,0.077,NULL,41292885501,645201335,10081270,14.7),(64314,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64314,31.22,NULL,17.5,22534,NULL,NULL,'Dipole + Quadrupole','UGC 05245',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64315,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64315,31.22,NULL,17.5,22534,NULL,NULL,'Dipole','UGC 05245',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64316,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64316,31.62,NULL,21.1,22534,NULL,NULL,NULL,'UGC 05245',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64317,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64317,31.64,0.4,21.3,22534,75,NULL,'B','UGC 05245',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64318,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64318,31.84,0.2,23.3,22534,74.4,NULL,NULL,'UGC 05245',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64319,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64319,32.02,0.43,25.4,22534,75,NULL,'3.6 micron, color corrected','UGC 05245',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64320,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64320,32.11,0.43,26.4,22534,75,NULL,'3.6 micron, color + selection bias corrected','UGC 05245',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64321,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64321,34.75,NULL,89.2,22535,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0943',NULL,'2010Ap&SS.325..163P',2010,1,1.01,NULL,'G',0.000018,NULL,'16.01',0.09,'Sd',NULL,NULL,NULL,NULL,1,146.8987917,23.90703,0.033,NULL,63694574865,995227732,15550433,16.01),(64322,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64322,34.77,NULL,89.8,22535,NULL,NULL,'Dipole + Quadrupole','FGC 0943',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64323,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64323,34.78,NULL,90.5,22535,NULL,NULL,'Dipole','FGC 0943',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64324,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64324,34.9,0.2,95.5,22535,74.4,NULL,NULL,'FGC 0943',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64325,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64325,34.95,NULL,97.7,22535,NULL,NULL,NULL,'FGC 0943',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64326,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64326,38,0.33,399,22536,70,NULL,NULL,'2MASX J09473907+3523485',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000181,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,146.9129583,35.39681,0,NULL,64187528967,1002930140,15670783,17),(64327,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64327,36.93,0.46,243,22537,70,NULL,NULL,'2MASX J09473936+1447349',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'17.18',0.24,NULL,NULL,NULL,NULL,NULL,1,146.914083,14.79297,0.073,NULL,60831842848,950497544,14851524,17.18),(64328,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64328,38.56,0.46,516,22538,70,NULL,NULL,'SDSS J094740.32+084557.1',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000173,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,146.918041667,8.76586,0.041,NULL,60889913832,951404903,14865701,18.6),(64329,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64329,36.91,0.46,241,22539,70,NULL,NULL,'2MASX J09474203+2723151',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000175,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,146.9252917,27.3875,0.009,NULL,64167555821,1002618059,15665907,16.3),(64330,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64330,34.79,0.49,90.8,22540,75,NULL,'IR','2MFGC 07589',NULL,'2011yCatp016004901K',2011,1,0.55,NULL,'G',0.000217,NULL,'16.1g',0.31,NULL,NULL,NULL,NULL,NULL,1,146.925625,9.16103,0.049,NULL,60897249560,951519524,14867492,16.1),(64331,'IRAS','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64331,32.88,0.8,37.6,22541,75,NULL,'MAT, I','IC 2510',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14',0.7,'(R)SAB(r)a     Sy2','Group member, radial-velocity confirmed',NULL,NULL,'H_alpha Emission-Line Galaxy',1,146.931166667,-32.83744,0.681,NULL,42854941943,669608467,10462632,14),(64332,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64332,32.32,0.32,29.1,22541,85,NULL,'I, raw','IC 2510',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64333,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64333,32.34,0.32,29.4,22541,85,NULL,'I, inv','IC 2510',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64334,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64334,32.38,0.43,30,22541,75,NULL,'3.6 micron, color + selection bias corrected','IC 2510',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64335,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64335,32.48,0.43,31.4,22541,75,NULL,'MAT, I, raw','IC 2510',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64336,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64336,32.52,0.43,31.9,22541,75,NULL,'3.6 micron, color corrected','IC 2510',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64337,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64337,32.61,0.43,33.3,22541,75,NULL,'MAT, I, inv','IC 2510',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64338,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64338,32.64,0.2,33.7,22541,74.4,NULL,NULL,'IC 2510',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64339,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64339,32.77,0.43,35.8,22541,75,NULL,'MAT, I, cor','IC 2510',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64340,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64340,32.82,0.47,36.7,22541,NULL,NULL,'H','IC 2510',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64341,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64341,32.83,0.45,36.8,22541,NULL,NULL,'K','IC 2510',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64342,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64342,32.88,0.46,37.7,22541,NULL,NULL,'J','IC 2510',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64343,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64343,33.06,0.4,40.9,22541,NULL,NULL,'mean','IC 2510',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64344,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64344,33.21,0.1,43.9,22541,NULL,NULL,NULL,'IC 2510',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64345,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64345,38.31,0.46,459,22542,70,NULL,NULL,'2MASX J09474458+4702549',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000181,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,146.9359583,47.04867,0.005,NULL,64018720015,1000292500,15629570,17.4),(64346,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64346,37.29,0.33,288,22543,70,NULL,NULL,'2MASX J09474469+0618574',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000149,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,146.936375,6.31597,0.041,NULL,60919896815,951873387,14873021,17.5),(64347,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64347,36.29,0.62,182,22544,70,NULL,NULL,'2MASX J09474524-3404138',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,146.9385417,-34.07047,0.741,NULL,42856355119,669630548,10462977,15.4),(64348,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64348,32.1,0.77,26.2,22545,NULL,NULL,'Malmquist cor.','UGC 05249',NULL,'2009ApJS..182..474S',2009,1,2.4,NULL,'G',0.000007,NULL,'14.3g',0.7,'SBd:;WR?       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,146.9389583,2.62694,0.121,NULL,60904681425,951635647,14869306,14.3),(64349,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64349,32.12,0.2,26.6,22545,74.4,NULL,NULL,'UGC 05249',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64350,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64350,32.21,0.4,27.7,22545,75,NULL,'B','UGC 05249',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64351,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64351,32.29,0.43,28.7,22545,75,NULL,'3.6 micron, color corrected','UGC 05249',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64352,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64352,32.32,0.7,29.1,22545,NULL,NULL,NULL,'UGC 05249',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64353,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64353,32.44,0.43,30.8,22545,75,NULL,'3.6 micron, color + selection bias corrected','UGC 05249',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64354,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64354,32.46,0.4,31,22545,75,NULL,NULL,'UGC 05249',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64355,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64355,33.12,0.49,42,22545,75,NULL,'IR','UGC 05249',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64356,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64356,37.75,0.46,355,22546,70,NULL,NULL,'2MASX J09474545+4134321',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,146.939333333,41.57569,0.017,NULL,63975357911,999614967,15618983,17),(64357,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64357,37.96,0.46,390,22547,70,NULL,NULL,'2MASX J09474699+2052149',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,146.9457917,20.87072,0.037,NULL,63696878659,995263729,15550995,17.9),(64358,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64358,35.31,0.49,116,22548,70,NULL,NULL,'2MASX J09474744-1324492',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.93',NULL,NULL,NULL,NULL,NULL,NULL,1,146.947917,-13.41386,0.153,NULL,41185753252,643527394,10055115,15.93),(64359,'Tully est','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64359,32.11,0.8,26.4,22549,75,NULL,'B','MRK 0407',NULL,'1988NBGC.C....0000T',1988,1,0.5,NULL,'G',0.000033,NULL,'15.0g',0.39,'Compact',NULL,NULL,NULL,NULL,1,146.9485417,39.08422,0.017,NULL,64055534766,1000867730,15638558,15),(64360,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64360,38.37,0.46,472,22550,70,NULL,NULL,'2MASX J09475015+2726570',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000141,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,146.9587917,27.44919,0.017,NULL,64167558158,1002618096,15665907,18.6),(64361,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64361,35.07,0.49,103,22551,75,NULL,'IR','IC 0565 NED02',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.000203,NULL,'15.5',0.19,'Sbc',NULL,NULL,NULL,NULL,1,146.9605417,15.85189,0.085,NULL,60827867260,950435425,14850553,15.5),(64362,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64362,35.32,NULL,116,22551,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 0565 NED02',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64363,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64363,35.33,NULL,116,22551,NULL,NULL,'Dipole + Quadrupole','IC 0565 NED02',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64364,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64364,35.34,NULL,117,22551,NULL,NULL,'Dipole','IC 0565 NED02',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64365,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64365,35.41,NULL,121,22551,NULL,NULL,NULL,'IC 0565 NED02',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64366,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64366,35.69,0.2,137,22551,74.4,NULL,NULL,'IC 0565 NED02',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64367,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64367,38.18,0.46,433,22552,70,NULL,NULL,'SDSS J094751.44+053804.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,146.964375,5.6345,0.041,NULL,60912793742,951762402,14871287,17.9),(64368,'Tully-Fisher','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64368,35.25,0.2,112,22553,74.4,NULL,NULL,'CGCG 063-071',NULL,'2013AJ....146...86T',2013,1,0.72,NULL,'G',0.000092,NULL,'15.2g',0.39,'Scd',NULL,NULL,NULL,NULL,1,146.9655,8.83081,0.041,NULL,60889988801,951406075,14865719,15.2),(64369,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64369,36.87,0.33,237,22554,70,NULL,NULL,'2MASX J09475228+4147041',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00017,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,146.967917,41.78456,0.013,NULL,63975398536,999615602,15618993,16.4),(64370,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64370,36.02,0.33,160,22555,70,NULL,NULL,'2MASX J09475271+2017056',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000183,NULL,'15.8g',0.36,NULL,NULL,NULL,NULL,NULL,1,146.969708333,20.285,0.053,NULL,63742646071,995978844,15562169,15.8),(64371,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64371,37.89,0.27,378,22556,70,NULL,NULL,'2MASX J09475394+0758284',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,146.974666667,7.97458,0.021,NULL,60920999293,951890613,14873290,17.1),(64372,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64372,37.7,0.46,346,22557,70,NULL,NULL,'2MASX J09475413+1942236',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000171,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,146.975625,19.70667,0.017,NULL,63744754280,996011785,15562684,16.7),(64373,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64373,37.29,0.33,288,22558,70,NULL,NULL,'SDSS J094756.43+061215.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,146.985166667,6.20442,0.041,NULL,60919753348,951871146,14872986,18.4),(64374,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64374,37.87,0.46,376,22559,70,NULL,NULL,'SDSS J094757.23+263916.5',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000149,NULL,'17.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,146.988458333,26.65461,0.009,NULL,64167229644,1002612963,15665827,17.7),(64375,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64375,36.32,0.46,184,22560,70,NULL,NULL,'2MASX J09475939+5030566',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000159,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,146.997333,50.51575,0,NULL,64010620985,1000165952,15627593,16.5),(64376,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64376,36.18,0.46,173,22561,70,NULL,NULL,'CGCG 265-041',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000189,NULL,'15.4g',0.55,'E0',NULL,NULL,NULL,NULL,1,146.999041667,53.81217,0,NULL,63963394413,999428037,15616063,15.4),(64377,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64377,36.94,0.46,244,22562,70,NULL,NULL,'2MASX J09475979+0220319',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000089,NULL,'17.5g',0.21,'AGN',NULL,NULL,NULL,NULL,1,146.999167,2.34228,0.141,NULL,60904619814,951634684,14869291,17.5),(64378,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64378,38.06,0.46,410,22563,70,NULL,NULL,'2MASX J09480076+5757309',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000182,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,147.003083,57.95856,0.013,NULL,61932151613,967689868,15120154,17.3),(64379,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64379,36.85,0.11,234,22564,70,NULL,NULL,'2MASX J09480200+5417089',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'15.6g',0.37,NULL,NULL,NULL,NULL,NULL,1,147.0082917,54.28589,0,NULL,61878821179,966856580,15107134,15.6),(64380,'GRB','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64380,47.34,1.09,9700,22565,72,NULL,NULL,'GRB 060108',2.03,'2008JCAP...07..004M',2008,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,147.00825,31.91894,0.025,NULL,64216625447,1003384772,15677887,NULL),(64381,'GRB','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64381,47.43,1.04,10100,22565,70,NULL,NULL,'GRB 060108',2.03,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64382,'GRB','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64382,47.57,1.2,10800,22565,NULL,NULL,NULL,'GRB 060108',2.03,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64383,'GRB','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64383,47.93,0.72,12700,22565,69.7,NULL,'Fiducial','GRB 060108',2.03,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64384,'GRB','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64384,48.85,1.07,19400,22565,69.7,NULL,'Calibrated','GRB 060108',2.03,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64385,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64385,37.61,0.46,333,22566,70,NULL,NULL,'2MASX J09480412+3543572',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000177,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,147.017083333,35.73264,0,NULL,64187454851,1002928982,15670765,17.8),(64386,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64386,37.34,0.33,293,22567,70,NULL,NULL,'2MASX J09480416+4003031',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,147.017125,40.05075,0.009,NULL,64089167581,1001393243,15646769,18),(64387,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64387,38.1,0.27,416,22568,70,NULL,NULL,'2MASX J09480428+2038577',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000183,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,147.0177917,20.64944,0.045,NULL,63697206182,995268846,15551075,17),(64388,'FP','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,'R',64388,38.1,0.46,418,22569,70,NULL,NULL,'2MASX J09480455+6021333',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00008,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,147.019125,60.35939,0.033,NULL,61915264968,967426015,15116031,17.7),(64389,'Tully est','2016-12-15 15:14:31','2016-12-16 11:19:38','1',NULL,NULL,64389,31.94,0.8,24.4,22570,75,NULL,'B','MRK 0408',NULL,'1988NBGC.C....0000T',1988,1,0.64,'Position in 1991PNAOJ...2....7T is incorrect.','G',0.000008,NULL,'14.7g',0.47,'Compact','Group member',NULL,NULL,NULL,1,147.019541667,32.8825,0.009,NULL,64183693231,1002870206,15669846,14.7),(64390,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64390,36.89,0.46,239,22571,70,NULL,NULL,'2MASX J09480518+0045163',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000113,NULL,'15.9g',0.41,'E0',NULL,NULL,NULL,NULL,1,147.021667,0.75444,0.161,NULL,60767965761,949499465,14835929,15.9),(64391,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64391,37.65,0.46,339,22572,70,NULL,NULL,'2MASX J09480561+5911019',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000076,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,147.0234583,59.18378,0.013,NULL,61915904512,967436008,15116187,18.1),(64392,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64392,35.31,0.58,115,22573,70,NULL,NULL,'2MASX J09480599-1415571',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.86',NULL,NULL,NULL,NULL,NULL,NULL,1,147.025083,-14.26606,0.225,NULL,41187139821,643549059,10055454,15.86),(64393,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64393,37.99,0.46,396,22574,70,NULL,NULL,'2MASX J09480729+2308417',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000192,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,147.0305,23.14506,0.053,NULL,63691915361,995186177,15549784,17.3),(64394,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64394,36.87,0.33,237,22575,70,NULL,NULL,'2MASX J09480775+4148391',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000148,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,147.0324583,41.81092,0.013,NULL,63975403576,999615680,15618995,16.8),(64395,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64395,37.89,0.27,378,22576,70,NULL,NULL,'2MASX J09480806+0803168',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,147.033541667,8.05453,0.021,NULL,60921204353,951893818,14873340,17.6),(64396,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64396,36.02,0.33,160,22577,70,NULL,NULL,'CGCG 122-090',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000032,NULL,'15.7g',0.4,'Sy',NULL,NULL,NULL,NULL,1,147.038125,20.30911,0.053,NULL,63742655425,995978991,15562171,15.7),(64397,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64397,35.35,0.46,117,22578,70,NULL,NULL,'2MASX J09481032+4837516',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00016,NULL,'16.0g',0.35,'E0',NULL,NULL,NULL,NULL,1,147.043,48.63097,0.017,NULL,64019368977,1000302640,15629728,16),(64398,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64398,37.81,0.46,364,22579,70,NULL,NULL,'2MASX J09481055+1520023',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,147.044,15.33419,0.077,NULL,60827303233,950426613,14850415,17.4),(64399,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64399,37.2,0.19,276,22580,70,NULL,NULL,'2MASX J09481063+2708085',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00016,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,147.0445417,27.13558,0.005,NULL,64167589497,1002618585,15665915,17),(64400,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64400,36.38,0.46,189,22581,70,NULL,NULL,'2MASX J09481126+2548145',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00017,NULL,'16.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,147.046958333,25.80408,0.041,NULL,64168514625,1002633041,15666141,16.7),(64401,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64401,36.85,0.11,234,22582,70,NULL,NULL,'2MASX J09481137+5431549',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000183,NULL,'16.1g',0.39,'E0',NULL,NULL,NULL,NULL,1,147.047375,54.53194,0,NULL,61878660380,966854068,15107094,16.1),(64402,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64402,37.68,0.46,343,22583,70,NULL,NULL,'2MASX J09481208+4350209',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000172,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,147.050541667,43.83917,0,NULL,63987366093,999802595,15621915,16.9),(64403,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64403,37.2,0.19,276,22584,70,NULL,NULL,'2MASX J09481415+2659325',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000204,NULL,'16.0g',0.39,NULL,NULL,NULL,NULL,NULL,1,147.0589583,26.99231,0.005,NULL,64167376580,1002615259,15665863,16),(64404,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64404,37.67,0.46,343,22585,70,NULL,NULL,'SDSS J094814.22+252625.8',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.6g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,147.05925,25.4405,0.053,NULL,64168235925,1002628686,15666073,17.6),(64405,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64405,36.99,0.46,250,22586,70,NULL,NULL,'2MASX J09481531+4231269',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,147.063833,42.52428,0.009,NULL,63974807812,999606372,15618849,17.1),(64406,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64406,37.4,0.46,302,22587,70,NULL,NULL,'2MASX J09481671+3525301',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,147.069583,35.42503,0,NULL,64187479002,1002929359,15670771,17.4),(64407,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64407,38.01,0.46,401,22588,70,NULL,NULL,'2MASX J09481730+3939381',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,147.071875,39.66069,0.021,NULL,64089077904,1001391842,15646747,18),(64408,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64408,36.57,0.46,206,22589,70,NULL,NULL,'2MASX J09481868+2609075',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,147.077917,26.15217,0.013,NULL,64167772371,1002621443,15665960,16.8),(64409,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64409,37.32,0.46,291,22590,70,NULL,NULL,'2MASX J09481908+3713500',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000176,NULL,'16.2g',0.42,NULL,NULL,NULL,NULL,NULL,1,147.0794583,37.23056,0,NULL,64175448060,1002741375,15667833,16.2),(64410,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64410,37.2,0.19,276,22591,70,NULL,NULL,'2MASX J09481931+2700035',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000164,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,147.080417,27.00106,0.005,NULL,64167376790,1002615262,15665863,16.5),(64411,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64411,35.46,0.46,123,22592,70,NULL,NULL,'2MASX J09482250+3022252',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000169,NULL,'15.9g',0.37,NULL,NULL,NULL,NULL,NULL,1,147.093875,30.37375,0.005,NULL,64217604100,1003400064,15678126,15.9),(64412,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64412,38.08,0.46,413,22593,70,NULL,NULL,'2MASX J09482351+2849205',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000204,NULL,'16.9g',0.25,'E',NULL,NULL,NULL,NULL,1,147.097875,28.82242,0,NULL,64216946862,1003389794,15677965,16.9),(64413,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64413,38.15,0.46,427,22594,70,NULL,NULL,'2MASX J09482443+2854255',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000143,NULL,'17.2g',0.28,'Sc',NULL,NULL,NULL,NULL,1,147.10175,28.90714,0,NULL,64216935055,1003389610,15677962,17.2),(64414,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64414,38.11,0.46,419,22595,70,NULL,NULL,'2MASX J09482458+1422012',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,147.1025,14.36714,0.089,NULL,60833993787,950531152,14852049,18.2),(64415,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64415,37.2,0.19,276,22596,70,NULL,NULL,'SDSS J094826.02+265230.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'17.9g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,147.108458333,26.87519,0.005,NULL,64167253657,1002613338,15665833,17.9),(64416,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64416,38.23,0.46,442,22597,70,NULL,NULL,'2MASX J09482609+4104535',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000178,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,147.1085,41.08167,0.009,NULL,63972010422,999562662,15618166,16.9),(64417,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64417,36.85,0.11,234,22598,70,NULL,NULL,'SDSS J094826.66+543915.2',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00017,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,147.111125,54.65425,0.005,NULL,61879498705,966867167,15107299,16.4),(64418,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64418,37.34,0.33,293,22599,70,NULL,NULL,'2MASX J09482735+4007086',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00016,NULL,'17.0g',0.31,NULL,NULL,NULL,NULL,NULL,1,147.113917,40.11889,0.009,NULL,64089142440,1001392850,15646763,17),(64419,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64419,36.85,0.11,234,22600,70,NULL,NULL,'2MASX J09482868+5442468',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,147.1197917,54.71294,0.005,NULL,61878962289,966858785,15107168,17.7),(64420,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64420,36,0.46,158,22601,70,NULL,NULL,'MCG +10-14-040',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000177,NULL,'15.4g',0.61,'S0',NULL,NULL,NULL,NULL,1,147.125875,57.19106,0.005,NULL,61937927887,967780123,15121564,15.4),(64421,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64421,38.55,0.46,512,22602,70,NULL,NULL,'2MASX J09483121+2108111',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,147.130166667,21.1365,0.037,NULL,63696996785,995265574,15551024,18.2),(64422,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64422,35.98,0.46,157,22603,70,NULL,NULL,'2MASX J09483231+3820276',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000182,NULL,'15.7g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,147.134625,38.34108,0,NULL,64055886580,1000873227,15638644,15.7),(64423,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64423,36.17,0.46,171,22604,70,NULL,NULL,'2MASX J09483281+3736486',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000171,NULL,'15.9g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,147.13675,37.61358,0,NULL,64176312331,1002754880,15668045,15.9),(64424,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64424,36.75,0.46,224,22605,70,NULL,NULL,'2MASX J09483448+2955313',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,147.143666667,29.92539,0.029,NULL,64217696254,1003401503,15678148,17),(64425,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64425,38.48,0.46,496,22606,70,NULL,NULL,'SDSS J094835.29+473655.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000141,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,147.147083,47.61547,0.017,NULL,64018917221,1000295581,15629618,18.4),(64426,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64426,38.1,0.27,416,22607,70,NULL,NULL,'2MASX J09483585+2039481',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000175,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,147.1494583,20.66328,0.045,NULL,63697201562,995268774,15551074,18.2),(64427,'IRAS','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64427,32.05,0.8,25.8,22608,75,NULL,'A82, H','NGC 3003',NULL,'1997ApJS..109..333W',1997,1,5.8,NULL,'G',0.000003,NULL,'12.33',1.3,'SBbc','in a triple',NULL,NULL,NULL,1,147.1502083,33.4215,0,NULL,64184459851,1002882185,15670034,12.33),(64428,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64428,30.87,0.4,14.9,22608,73,NULL,'IR','NGC 3003',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64429,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64429,30.87,0.4,14.9,22608,75,NULL,NULL,'NGC 3003',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64430,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64430,30.94,0.4,15.4,22608,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 3003',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64431,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64431,31.34,0.35,18.5,22608,NULL,NULL,NULL,'NGC 3003',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64432,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64432,31.45,0.49,19.5,22608,NULL,NULL,'Malmquist cor.','NGC 3003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64433,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64433,31.46,0.2,19.6,22608,74.4,NULL,NULL,'NGC 3003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64434,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64434,31.46,0.43,19.6,22608,75,NULL,'3.6 micron, color corrected','NGC 3003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64435,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64435,31.5,0.43,20,22608,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64436,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64436,31.61,0.49,21,22608,75,NULL,'IR','NGC 3003',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64437,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64437,31.62,0.47,21.1,22608,75,NULL,'A82, H, raw','NGC 3003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64438,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64438,31.63,0.47,21.2,22608,75,NULL,'A82, H, inv','NGC 3003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64439,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64439,31.67,0.44,21.6,22608,NULL,NULL,NULL,'NGC 3003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64440,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64440,31.71,0.4,22,22608,NULL,NULL,'mean','NGC 3003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64441,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64441,31.9,0.47,24,22608,75,NULL,'A82, H, cor','NGC 3003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64442,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64442,31.93,0.4,24.4,22608,75,NULL,'B','NGC 3003',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64443,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64443,32.06,0.46,25.8,22608,NULL,NULL,'J','NGC 3003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64444,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64444,32.17,0.47,27.1,22608,NULL,NULL,'H','NGC 3003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64445,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64445,32.27,0.45,28.4,22608,NULL,NULL,'K','NGC 3003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64446,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64446,37.9,0.23,381,22609,70,NULL,NULL,'2MASX J09483673+0609458',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,147.153208333,6.16264,0.045,NULL,60919725493,951870710,14872979,17.5),(64447,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64447,38.1,0.27,416,22610,70,NULL,NULL,'2MASX J09483756+2043341',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000183,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,147.1565,20.72619,0.041,NULL,63697199514,995268742,15551074,17.1),(64448,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64448,37.98,0.27,394,22611,70,NULL,NULL,'SDSS J094839.55+020152.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000076,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,147.164833333,2.03117,0.141,NULL,60905094897,951642107,14869407,18.4),(64449,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64449,37.81,0.46,365,22612,70,NULL,NULL,'SDSS J094839.94+091902.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,147.166416667,9.3175,0.013,NULL,60897152078,951518001,14867468,18.3),(64450,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64450,36.85,0.11,234,22613,70,NULL,NULL,'2MASX J09484034+5423324',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000195,NULL,'15.7g',0.49,'E0',NULL,NULL,NULL,NULL,1,147.1682917,54.39222,0,NULL,61878817630,966856525,15107133,15.7),(64451,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64451,37.85,0.27,372,22614,70,NULL,NULL,'2MASX J09484158+1452222',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'17.54',0.32,NULL,NULL,NULL,NULL,NULL,1,147.1732083,14.87278,0.069,NULL,60831788179,950496690,14851510,17.54),(64452,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64452,36.28,0.46,181,22615,70,NULL,NULL,'2MASX J09484246+3040443',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00017,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,147.176833333,30.67903,0,NULL,64218035758,1003406808,15678231,17),(64453,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64453,37.24,0.46,280,22616,70,NULL,NULL,'2MASX J09484300+4955300',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,147.1792083,49.92497,0.017,NULL,64021311669,1000332994,15630203,17),(64454,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64454,36.58,0.46,207,22617,70,NULL,NULL,'2MASX J09484325+0025467',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000083,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,147.180083,0.42964,0.169,NULL,60768091177,949501424,14835959,16.8),(64455,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64455,37.9,0.23,381,22618,70,NULL,NULL,'2MASX J09484331+0608028',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,147.180417,6.13417,0.045,NULL,60919712901,951870514,14872976,17.6),(64456,'IRAS','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64456,34.17,0.8,68.3,22619,75,NULL,'CF, r','NGC 2998',NULL,'1997ApJS..109..333W',1997,1,2.07,NULL,'G',0.000007,NULL,'13.4g',0.93,'SAB(rs)c','Possible field galaxy',NULL,NULL,NULL,1,147.1817917,44.08144,0,NULL,63987335101,999802110,15621907,13.4),(64457,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64457,33.26,NULL,44.9,22619,NULL,NULL,'B','NGC 2998',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64458,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64458,33.31,0.69,46,22619,100,NULL,'mid-IR','NGC 2998',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64459,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64459,33.67,0.38,54.2,22619,75,NULL,'CF, r, raw','NGC 2998',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64460,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64460,33.83,0.43,58.3,22619,75,NULL,'3.6 micron, color corrected','NGC 2998',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64461,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64461,33.84,0.38,58.6,22619,75,NULL,'CF, r, inv','NGC 2998',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64462,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64462,33.87,0.43,59.4,22619,75,NULL,'3.6 micron, color + selection bias corrected','NGC 2998',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64463,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64463,33.9,0.2,60.3,22619,74.4,NULL,NULL,'NGC 2998',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64464,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64464,33.95,0.38,61.5,22619,75,NULL,'CF, r, cor','NGC 2998',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64465,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64465,33.95,0.47,61.6,22619,NULL,NULL,'H','NGC 2998',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64466,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64466,33.97,0.46,62.3,22619,NULL,NULL,'J','NGC 2998',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64467,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64467,34.01,0.27,63.2,22619,NULL,NULL,NULL,'NGC 2998',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64468,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64468,34.01,0.45,63.3,22619,NULL,NULL,'K','NGC 2998',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64469,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64469,34.05,0.26,64.6,22619,NULL,NULL,'Malmquist cor.','NGC 2998',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64470,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64470,34.19,0.4,68.9,22619,NULL,NULL,'mean','NGC 2998',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64471,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64471,37.38,0.46,300,22620,70,NULL,NULL,'2MASX J09484645+0456217',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000175,NULL,'16.8g',0.28,'AGN',NULL,NULL,NULL,NULL,1,147.193416667,4.93931,0.053,NULL,60914362228,951786909,14871670,16.8),(64472,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64472,37.98,0.27,394,22621,70,NULL,NULL,'2MASX J09484757+0203107',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000075,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,147.198166667,2.05292,0.141,NULL,60905091695,951642057,14869407,18),(64473,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64473,33.27,0.2,45.1,22622,74.4,NULL,NULL,'UGC 05244',NULL,'2013AJ....146...86T',2013,1,1.6,'Multiple SDSS entries describe this object.','G',0.000037,NULL,'15.19',0.2,'Scd:',NULL,NULL,NULL,NULL,1,147.2019583,64.16883,0.153,NULL,62246234914,972597420,15196834,15.19),(64474,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64474,33.31,0.51,45.9,22622,NULL,NULL,'Malmquist cor.','UGC 05244',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64475,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64475,33.4,0.49,47.8,22622,75,NULL,'IR','UGC 05244',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64476,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64476,33.41,0.49,48,22622,NULL,NULL,NULL,'UGC 05244',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64477,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64477,37.9,0.23,381,22623,70,NULL,NULL,'2MASX J09484854+0608108',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000178,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,147.2022917,6.13639,0.045,NULL,60919711268,951870488,14872976,16.6),(64478,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64478,37.38,0.46,300,22624,70,NULL,NULL,'2MASX J09484885+1401282',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,147.203583,14.02447,0.065,NULL,60834098079,950532782,14852074,17.2),(64479,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64479,36.43,0.46,194,22625,70,NULL,NULL,'2MASX J09484940+3558336',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00017,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,147.205916667,35.97606,0,NULL,64186557445,1002914960,15670546,16.9),(64480,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64480,36.85,0.11,234,22626,70,NULL,NULL,'2MASX J09485009+5449584',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,147.208875,54.83297,0.025,NULL,61933691531,967713930,15120530,16.8),(64481,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64481,38.17,0.46,431,22627,70,NULL,NULL,'2MASX J09485137+1011238',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000159,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,147.2140417,10.18981,0.017,NULL,60895647843,951494497,14867101,17.5),(64482,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64482,37.44,0.46,307,22628,70,NULL,NULL,'2MASX J09485149+0707198',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,147.214625,7.12206,0.017,NULL,60921375546,951896492,14873382,17.3),(64483,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64483,38.58,0.46,520,22629,70,NULL,NULL,'SDSS J094852.14+105535.3',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,147.2172917,10.9265,0.013,NULL,60894244378,951472568,14866758,17.7),(64484,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64484,37.18,0.46,273,22630,70,NULL,NULL,'2MASX J09485272+2426329',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,147.2197917,24.44239,0.061,NULL,63693067348,995204177,15550065,16.9),(64485,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64485,37.52,0.46,320,22631,70,NULL,NULL,'2MASX J09485296-0017350',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.0001,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,147.2207083,-0.29314,0.181,NULL,41222227217,644097300,10064020,16.5),(64486,'IRAS','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64486,34.78,0.8,90.4,22632,75,NULL,'MAT, I','NGC 3029',NULL,'1997ApJS..109..333W',1997,1,1.4,'MCG RA is +1 minute in error.','G',0.000033,NULL,'14.5',1,'SAB(r)c',NULL,NULL,NULL,NULL,1,147.225083333,-8.05094,0.085,NULL,41324266192,645691659,10088932,14.5),(64487,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64487,34.03,0.32,64,22632,85,NULL,'I, raw','NGC 3029',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64488,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64488,34.06,0.32,65,22632,85,NULL,'I, inv','NGC 3029',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64489,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64489,34.07,0.43,65.3,22632,75,NULL,'MAT, I, raw','NGC 3029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64490,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64490,34.24,0.43,70.6,22632,75,NULL,'MAT, I, inv','NGC 3029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64491,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64491,34.28,0.29,71.8,22632,NULL,NULL,'B, Hubble-type-TF','NGC 3029',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64492,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64492,34.28,NULL,71.8,22632,NULL,NULL,'B','NGC 3029',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64493,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64493,34.32,NULL,73.1,22632,NULL,NULL,'I','NGC 3029',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64494,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64494,34.41,0.43,76.4,22632,75,NULL,'MAT, I, cor','NGC 3029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64495,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64495,34.48,0.2,78.7,22632,74.4,NULL,NULL,'NGC 3029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64496,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64496,34.49,0.32,79.2,22632,NULL,NULL,'Malmquist cor.','NGC 3029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64497,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64497,34.6,0.31,83.3,22632,NULL,NULL,NULL,'NGC 3029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64498,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64498,37.08,0.46,260,22633,70,NULL,NULL,'2MASX J09485422+4037046',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,147.225875,40.61803,0,NULL,64089560967,1001399390,15646865,17.6),(64499,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64499,37.89,0.27,378,22634,70,NULL,NULL,'2MASX J09485452+0801478',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000232,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,147.227125,8.02981,0.041,NULL,60920775259,951887113,14873236,16.8),(64500,'GRB','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64500,46.18,1.01,7440,22635,NULL,NULL,NULL,'GRB 061121',1.314,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,147.227375,-13.19519,0.109,NULL,41185810982,643528296,10055129,NULL),(64501,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64501,37.08,0.46,261,22636,70,NULL,NULL,'2MASX J09485464+2854429',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000178,NULL,'16.9g',0.28,'E',NULL,NULL,NULL,NULL,1,147.227583,28.91194,0.005,NULL,64216912147,1003389252,15677957,16.9),(64502,'TRGB','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'N',64502,25.56,0.16,1.1,22637,NULL,NULL,NULL,'Antlia B',NULL,'2015ApJ...812L..13S',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64503,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64503,34.71,NULL,87.3,22638,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0950',NULL,'2010Ap&SS.325..163P',2010,1,0.99,NULL,'G',0.000016,NULL,'16.6g',0.16,'Scd',NULL,NULL,NULL,NULL,1,147.237667,33.04333,0.009,NULL,64183678955,1002869983,15669843,16.6),(64504,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64504,34.73,NULL,88.3,22638,NULL,NULL,'Dipole + Quadrupole','FGC 0950',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64505,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64505,34.73,NULL,88.4,22638,NULL,NULL,'Dipole','FGC 0950',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64506,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64506,34.81,NULL,91.6,22638,NULL,NULL,NULL,'FGC 0950',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64507,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64507,34.98,0.2,99.1,22638,74.4,NULL,NULL,'FGC 0950',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64508,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64508,37.46,0.27,310,22639,70,NULL,NULL,'2MASX J09485700+2250319',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000176,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,147.2377083,22.84233,0.029,NULL,63692036195,995188065,15549813,16.5),(64509,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64509,37.82,0.46,366,22640,70,NULL,NULL,'2MASX J09485950-0002080',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000079,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,147.248,-0.03572,0.181,NULL,41222243624,644097556,10064024,18.1),(64510,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64510,37.85,0.27,372,22641,70,NULL,NULL,'SDSS J094859.88+145104.0',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,147.2495417,14.85114,0.069,NULL,60831780323,950496567,14851508,NULL),(64511,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64511,37.85,0.46,371,22642,70,NULL,NULL,'SDSS J094859.97+610749.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000075,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,147.249875,61.13044,0.061,NULL,62039001210,969359393,15146240,18.3),(64512,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64512,36.44,0.46,194,22643,70,NULL,NULL,'2MASX J09490006+0848138',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000154,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,147.2502917,8.80403,0.037,NULL,60920218026,951878406,14873100,17),(64513,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64513,37.98,0.27,394,22644,70,NULL,NULL,'2MASX J09490024+0159027',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000102,NULL,'17.1g',0.24,'AGN',NULL,NULL,NULL,NULL,1,147.250917,1.98425,0.141,NULL,60905075237,951641800,14869403,17.1),(64514,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64514,38.54,0.46,511,22645,70,NULL,NULL,'SDSS J094900.69+014739.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000082,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,147.252917,1.79422,0.149,NULL,60904994842,951640544,14869383,18.2),(64515,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64515,33.39,0.54,47.6,22646,70,NULL,NULL,'MCG -01-25-041',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.00015,NULL,'14.5',1,'SB(rs)0+ pec',NULL,NULL,NULL,NULL,1,147.258167,-7.13792,0.137,NULL,41325534030,645711469,10089241,14.5),(64516,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64516,35.65,0.46,135,22647,70,NULL,NULL,'CGCG 239-030',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000073,NULL,'15.7',0.25,NULL,NULL,NULL,NULL,NULL,1,147.258875,47.03514,0,NULL,64007233460,1000113022,15626765,15.7),(64517,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64517,35.88,0.46,150,22648,70,NULL,NULL,'2MASX J09490413+4526397',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',NULL,NULL,'16.61',0.42,NULL,NULL,NULL,NULL,NULL,1,147.267041667,45.44456,0,NULL,63984831724,999762995,15621296,16.61),(64518,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64518,37.86,0.46,374,22649,70,NULL,NULL,'2MASX J09490443+4211497',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,147.268375,42.19708,0.013,NULL,63973235610,999581806,15618465,17.3),(64519,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64519,33.05,0.2,40.7,22650,74.4,NULL,NULL,'CGCG 063-073',NULL,'2013AJ....146...86T',2013,1,1,'Multiple SDSS entries describe this object.','G',0.000242,NULL,'15.7',0.6,NULL,NULL,NULL,NULL,NULL,1,147.269541667,13.88075,0.061,NULL,60834059056,950532172,14852065,15.7),(64520,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64520,36.95,0.46,245,22651,70,NULL,NULL,'2MASX J09490600+5554015',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000176,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,147.2747917,55.90056,0,NULL,61936017015,967750265,15121097,16.8),(64521,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64521,37.9,0.46,381,22652,70,NULL,NULL,'SDSS J094906.45+105811.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,147.276875,10.96986,0.013,NULL,60896085068,951501329,14867208,17.8),(64522,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64522,38.23,0.46,443,22653,70,NULL,NULL,'2MASX J09490725+0229557',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000084,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,147.2802917,2.49878,0.145,NULL,60902724973,951605077,14868829,17.7),(64523,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64523,37.09,0.46,262,22654,70,NULL,NULL,'2MASX J09490737+4158488',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000177,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,147.2805,41.98031,0.013,NULL,63975305874,999614154,15618971,16.3),(64524,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64524,36.46,0.62,196,22655,70,NULL,NULL,'2MASX J09490792-1441430',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,147.2829583,-14.69533,0.225,NULL,41187433697,643553651,10055525,14.5),(64525,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64525,37.48,0.46,313,22656,70,NULL,NULL,'2MASX J09490877+4227588',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000184,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,147.2865,42.46642,0.009,NULL,63973368996,999583890,15618498,16.8),(64526,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64526,38.55,0.33,514,22657,70,NULL,NULL,'SDSS J094910.29+103546.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000147,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,147.292917,10.59633,0.021,NULL,60895575571,951493368,14867083,18.3),(64527,'IRAS','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64527,34.11,0.8,66.3,22658,75,NULL,'MAT, I','ESO 566- G 014',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.00003,NULL,'14.86',0.4,'Sb-c           HII',NULL,NULL,NULL,NULL,1,147.295125,-20.36472,0.121,NULL,42284594439,660696788,10323387,14.86),(64528,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64528,33.59,0.32,52.3,22658,85,NULL,'I, raw','ESO 566- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64529,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64529,33.6,0.43,52.6,22658,75,NULL,'3.6 micron, color + selection bias corrected','ESO 566- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64530,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64530,33.6,0.32,52.6,22658,85,NULL,'I, inv','ESO 566- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64531,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64531,33.78,0.43,57.1,22658,75,NULL,'3.6 micron, color corrected','ESO 566- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64532,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64532,33.79,0.43,57.3,22658,75,NULL,'MAT, I, raw','ESO 566- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64533,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64533,33.89,0.43,60,22658,75,NULL,'MAT, I, inv','ESO 566- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64534,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64534,34,0.43,63.1,22658,75,NULL,'MAT, I, cor','ESO 566- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64535,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64535,34.03,0.2,64,22658,74.4,NULL,NULL,'ESO 566- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64536,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64536,34.13,0.49,67.1,22658,75,NULL,'IR','ESO 566- G 014',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64537,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64537,34.15,0.52,67.6,22658,NULL,NULL,'Malmquist cor.','ESO 566- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64538,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64538,34.27,0.49,71.3,22658,NULL,NULL,NULL,'ESO 566- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64539,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64539,37.81,0.46,364,22659,70,NULL,NULL,'2MASX J09491163+2311539',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000189,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,147.2985,23.19842,0.065,NULL,63693707687,995214182,15550221,16.7),(64540,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64540,38.55,0.33,514,22660,70,NULL,NULL,'SDSS J094911.72+103619.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,147.298833,10.60539,0.021,NULL,60895575669,951493369,14867083,18),(64541,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64541,37.79,0.46,362,22661,70,NULL,NULL,'2MASX J09491282+1845379',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,147.3034583,18.7605,0.029,NULL,63741859465,995966554,15561977,18.1),(64542,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64542,37.45,0.46,308,22662,70,NULL,NULL,'2MASX J09491398+0009047',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000081,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,147.3082917,0.15117,0.145,NULL,60767563613,949493181,14835830,17.4),(64543,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64543,37.85,0.27,372,22663,70,NULL,NULL,'2MASX J09491446+1452064',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,147.310375,14.86844,0.069,NULL,60831596952,950493702,14851464,16.6),(64544,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64544,32.71,0.49,34.8,22664,75,NULL,'IR','NGC 3005',NULL,'2011yCatp016004901K',2011,1,1.12,NULL,'G',0.000011,NULL,'15.5g',0.26,'Sb',NULL,NULL,NULL,NULL,1,147.311958333,44.13131,0,NULL,63987319680,999801870,15621904,15.5),(64545,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64545,37.74,0.21,354,22665,70,NULL,NULL,'2MASX J09491755+4218098',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000204,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,147.323,42.30256,0.013,NULL,63973241937,999581905,15618467,16.4),(64546,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64546,36.39,0.46,190,22666,70,NULL,NULL,'2MASX J09491844+3914467',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000191,NULL,'16.0g',0.37,'E/S0',NULL,NULL,NULL,NULL,1,147.327,39.24636,0,NULL,64056293123,1000879580,15638743,16),(64547,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64547,37.9,0.23,381,22667,70,NULL,NULL,'SDSS J094919.94+060935.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000136,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,147.333083,6.15989,0.045,NULL,60919266980,951863546,14872867,18),(64548,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64548,37.46,0.27,310,22668,70,NULL,NULL,'2MASX J09492065+2249188',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000176,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,147.3360417,22.82186,0.073,NULL,63691864803,995185387,15549771,16.9),(64549,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64549,38.18,0.46,432,22669,70,NULL,NULL,'2MASX J09492107+3806557',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000138,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,147.337833,38.11558,0.021,NULL,64055728664,1000870760,15638605,18),(64550,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64550,37.29,0.46,286,22670,70,NULL,NULL,'2MASX J09492271+4003537',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000157,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,147.34475,40.06489,0.009,NULL,64089948423,1001405444,15646960,16.9),(64551,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64551,37.57,0.46,326,22671,70,NULL,NULL,'2MASX J09492318+6429491',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,147.347041667,64.49697,0.161,NULL,62246647871,972603872,15196935,17.4),(64552,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64552,37.23,0.46,279,22672,70,NULL,NULL,'SDSS J094923.65+174939.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,147.348625,17.82775,0.049,NULL,63725103442,995704741,15557886,18.1),(64553,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64553,37.73,0.46,352,22673,70,NULL,NULL,'2MASX J09492379+0855284',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,147.3492083,8.92461,0.029,NULL,60920205776,951878215,14873097,17.5),(64554,'IRAS','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64554,32.96,0.8,39.1,22674,75,NULL,'MAT, I','IC 2511',NULL,'1997ApJS..109..333W',1997,1,2.9,NULL,'G',0.000033,NULL,'13.00',0.6,'(R\')Sa         HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,147.3522917,-32.83919,0.693,NULL,42854933841,669608341,10462630,13),(64555,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64555,32.11,0.43,26.5,22674,75,NULL,'MAT, I, raw','IC 2511',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64556,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64556,32.21,0.32,27.7,22674,85,NULL,'I, raw','IC 2511',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64557,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64557,32.26,0.32,28.3,22674,85,NULL,'I, inv','IC 2511',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64558,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64558,32.29,0.4,28.7,22674,75,NULL,NULL,'IC 2511',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64559,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64559,32.32,0.43,29.1,22674,75,NULL,'MAT, I, inv','IC 2511',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64560,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64560,32.43,0.49,30.7,22674,75,NULL,'IR','IC 2511',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64561,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64561,32.51,0.43,31.8,22674,75,NULL,'MAT, I, cor','IC 2511',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64562,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64562,32.76,0.2,35.7,22674,74.4,NULL,NULL,'IC 2511',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64563,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64563,32.83,0.43,36.9,22674,75,NULL,'3.6 micron, color corrected','IC 2511',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64564,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64564,32.97,0.43,39.3,22674,75,NULL,'3.6 micron, color + selection bias corrected','IC 2511',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64565,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64565,39.19,0.46,688,22675,70,NULL,NULL,'2MASX J09492558+5757017',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000164,NULL,'18.7g',0.12,'AGN',NULL,NULL,NULL,NULL,1,147.3564583,57.95044,0.013,NULL,61931671023,967682359,15120036,18.7),(64566,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64566,34.26,0.49,71,22676,75,NULL,'IR','UGC 05258',NULL,'2011yCatp016004901K',2011,1,1.75,'Multiple SDSS entries describe this object.','G',0.000007,NULL,'15.55',0.15,'Sc',NULL,NULL,NULL,NULL,1,147.35775,14.65731,0.073,NULL,60833911207,950529862,14852029,15.55),(64567,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64567,34.55,NULL,81.4,22676,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05258',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64568,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64568,34.56,NULL,81.8,22676,NULL,NULL,'Dipole','UGC 05258',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64569,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64569,34.56,NULL,81.8,22676,NULL,NULL,'Dipole + Quadrupole','UGC 05258',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64570,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64570,34.57,0.2,82,22676,74.4,NULL,NULL,'UGC 05258',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64571,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64571,34.58,NULL,82.4,22676,NULL,NULL,NULL,'UGC 05258',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64572,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64572,34.68,0.49,86.4,22676,NULL,NULL,NULL,'UGC 05258',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64573,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64573,34.78,0.47,90.3,22676,NULL,NULL,'Malmquist cor.','UGC 05258',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64574,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64574,36.37,0.46,188,22677,70,NULL,NULL,'2MASX J09492596+2638177',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,147.358417,26.63814,0.025,NULL,64167235540,1002613055,15665828,16.6),(64575,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64575,34.91,0.46,95.8,22678,70,NULL,NULL,'CGCG 035-065',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000163,NULL,'15.4g',0.36,'S0',NULL,NULL,NULL,NULL,1,147.361083,4.00317,0.065,NULL,60918067414,951844803,14872575,15.4),(64576,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64576,34.49,0.46,78.9,22679,70,NULL,NULL,'2MASX J09492930+0815014',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000147,NULL,'15.1g',0.46,'S0',NULL,NULL,NULL,NULL,1,147.372083,8.25033,0.033,NULL,60921032447,951891131,14873298,15.1),(64577,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64577,37.42,0.46,305,22680,70,NULL,NULL,'2MASX J09493007+5510318',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,147.375375,55.17547,0,NULL,61933837225,967716206,15120565,16.7),(64578,'Tully est','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64578,31.99,0.8,25,22681,75,NULL,'B','UGCA 184',NULL,'1988NBGC.C....0000T',1988,1,0.48,NULL,'G',0.00004,NULL,'15.8g',0.3,'BlueCG         HII',NULL,NULL,NULL,NULL,1,147.37625,55.57972,0,NULL,61936649995,967760156,15121252,15.8),(64579,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64579,37.29,0.46,286,22682,70,NULL,NULL,'2MASX J09493096+3229185',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00014,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,147.3789583,32.48842,0,NULL,64183621600,1002869087,15669829,17.2),(64580,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64580,37.71,0.27,349,22683,70,NULL,NULL,'2MASX J09493096+2122532',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000181,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,147.379,21.38139,0.037,NULL,63696941006,995264703,15551010,18),(64581,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64581,37.74,0.21,354,22684,70,NULL,NULL,'2MASX J09493097+4207488',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000189,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,147.379,42.13028,0.013,NULL,63973289777,999582652,15618478,16.7),(64582,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64582,36.49,0.69,199,22685,70,NULL,NULL,'2MASX J09493126-1403471',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.29',NULL,NULL,NULL,NULL,NULL,NULL,1,147.3802083,-14.06328,0.165,NULL,41187904257,643561004,10055640,16.29),(64583,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64583,35.84,0.48,147,22686,70,NULL,NULL,'2MASX J09493236-1406471',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000107,NULL,'14.0R',NULL,'poss. LINER',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,147.384833,-14.11319,0.165,NULL,41188033998,643563031,10055672,14),(64584,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64584,37.74,0.21,354,22687,70,NULL,NULL,'2MASX J09493287+4217178',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000177,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,147.386917,42.28817,0.013,NULL,63973240646,999581885,15618466,17.5),(64585,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64585,37.15,0.46,269,22688,70,NULL,NULL,'2MASX J09493293+4242288',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000178,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,147.3872083,42.70811,0.009,NULL,63972932844,999577075,15618391,16.8),(64586,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64586,37.63,0.46,336,22689,70,NULL,NULL,'2MASX J09493309+6015150',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00008,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,147.3877917,60.25422,0.033,NULL,61915237791,967425590,15116024,17.1),(64587,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64587,37.74,0.21,354,22690,70,NULL,NULL,'2MASX J09493313+4207068',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,147.388041667,42.11861,0.013,NULL,63973289673,999582651,15618478,17.7),(64588,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64588,33.97,0.51,62.4,22691,70,NULL,NULL,'2MASX J09493331-6800554',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00009,NULL,'14.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,147.388666667,-68.01536,0.773,NULL,40689114329,635767411,9933865,14.5),(64589,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64589,36.65,0.33,214,22692,70,NULL,NULL,'2MASX J09493424+0614092',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000182,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,147.392791667,6.23572,0.045,NULL,60919308104,951864189,14872877,16.6),(64590,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64590,38.51,0.46,504,22693,70,NULL,NULL,'2MASX J09493677+2652245',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000195,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,147.4032917,26.87347,0.009,NULL,64167341217,1002614706,15665854,16.8),(64591,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64591,36.85,0.11,234,22694,70,NULL,NULL,'2MASX J09493713+5439038',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000178,NULL,'16.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,147.404958333,54.651,0.005,NULL,61933227241,967706675,15120416,16.2),(64592,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64592,38.04,0.33,405,22695,70,NULL,NULL,'SDSS J094937.94-005313.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000081,NULL,'18.7g',0.09,NULL,NULL,NULL,NULL,NULL,1,147.408083333,-0.88703,0.109,NULL,41222009389,644093896,10063967,18.7),(64593,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64593,37.46,0.27,310,22696,70,NULL,NULL,'2MASX J09493964+2234572',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000174,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,147.415375,22.58247,0.053,NULL,63699655115,995307111,15551673,16.7),(64594,'Tully est','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64594,31.91,0.8,24.1,22697,75,NULL,'B','NGC 3011',NULL,'1988NBGC.C....0000T',1988,1,0.96,NULL,'G',0.000007,NULL,'14.2g',0.73,'S0/a','Group member',NULL,NULL,'Starburst',1,147.421667,32.22111,0.013,NULL,64216372168,1003380815,15677825,14.2),(64595,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64595,37.75,0.46,354,22698,70,NULL,NULL,'2MASX J09494275-0050239',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000091,NULL,'17.4g',0.23,'FR II          AGN',NULL,NULL,NULL,NULL,1,147.42825,-0.84006,0.109,NULL,41221959897,644093123,10063955,17.4),(64596,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64596,37.59,0.46,330,22699,70,NULL,NULL,'2MASX J09494289+0106263',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000081,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,147.428667,1.10747,0.117,NULL,60767814315,949497098,14835892,17.5),(64597,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64597,36.41,0.46,191,22700,70,NULL,NULL,'2MASX J09494431+3644154',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00017,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,147.434667,36.73753,0,NULL,64175917695,1002748713,15667948,16.5),(64598,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64598,36.3,0.46,182,22701,70,NULL,NULL,'2MASX J09494517+3422016',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000165,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,147.438208333,34.36717,0,NULL,64182811018,1002856422,15669631,16.5),(64599,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64599,38.55,0.46,512,22702,70,NULL,NULL,'2MASX J09494541+0002480',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000106,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,147.439125,0.04683,0.121,NULL,60767378640,949490291,14835785,18.1),(64600,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64600,35.97,0.7,157,22703,70,NULL,NULL,'2MASX J09494709-0515219',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00008,NULL,'16.46',0.5,NULL,NULL,NULL,NULL,NULL,1,147.446166667,-5.25611,0.117,NULL,41302179644,645346556,10083539,16.46),(64601,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64601,36.94,0.46,245,22704,70,NULL,NULL,'2MASX J09494758+4332519',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000202,NULL,'15.8g',0.45,'E0',NULL,NULL,NULL,NULL,1,147.448333,43.54775,0.017,NULL,63986936332,999795880,15621810,15.8),(64602,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64602,36.11,0.46,167,22705,70,NULL,NULL,'2MASX J09494907+0756562',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,147.4544583,7.94894,0.029,NULL,60920937918,951889654,14873275,17),(64603,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64603,37.77,0.27,358,22706,70,NULL,NULL,'SDSS J094949.28+054229.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000137,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,147.455375,5.70819,0.041,NULL,60911980684,951749698,14871089,18.3),(64604,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64604,38.02,0.46,402,22707,70,NULL,NULL,'2MASX J09495028+2027072',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,147.459333,20.45214,0.037,NULL,63697318244,995270597,15551103,18.6),(64605,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64605,35.71,0.4,139,22708,NULL,NULL,'mean','NGC 3016',NULL,'2007A&A...465...71T',2007,1,1.32,NULL,'G',0.000017,NULL,'13.9g',0.78,'Sb','in a triple',NULL,NULL,NULL,1,147.461083,12.69522,0.017,NULL,60824582216,950384097,14849751,13.9),(64606,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64606,35.74,0.45,141,22708,NULL,NULL,'K','NGC 3016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64607,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64607,35.75,0.47,141,22708,NULL,NULL,'H','NGC 3016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64608,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64608,35.82,0.46,146,22708,NULL,NULL,'J','NGC 3016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64609,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64609,37.77,0.27,358,22709,70,NULL,NULL,'SDSS J094951.05+054445.6',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000083,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,147.46275,5.74603,0.041,NULL,60911980860,951749700,14871089,17.4),(64610,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64610,34.92,0.2,96.4,22710,74.4,NULL,NULL,'CGCG 063-079',NULL,'2013AJ....146...86T',2013,1,0.93,NULL,'G',0.000113,NULL,'15.4g',0.29,'Sc',NULL,NULL,NULL,NULL,1,147.464916667,10.43197,0.025,NULL,60895700642,951495322,14867114,15.4),(64611,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64611,36.14,0.51,169,22711,70,NULL,NULL,'2MASX J09495163-1357169',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.07',0.5,NULL,NULL,NULL,NULL,NULL,1,147.465291667,-13.95481,0.165,NULL,41187629519,643556711,10055573,16.07),(64612,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64612,35.4,0.46,120,22712,70,NULL,NULL,'NGC 3012',NULL,'2015arXiv151105856S',2015,1,1.08,NULL,'G',0.0001,NULL,'14.1g',1.02,'E:','Group member',NULL,NULL,NULL,1,147.467125,34.71411,0,NULL,64182746998,1002855421,15669615,14.1),(64613,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64613,32.2,0.4,27.6,22713,75,NULL,'B','NGC 3023',NULL,'1988NBGC.C....0000T',1988,1,1.62,NULL,'G',0.000023,NULL,'13.9g',0.92,'SAB(s)c pec:','Pair member (points to parent)',NULL,NULL,NULL,1,147.469125,0.61817,0.169,NULL,60767419708,949490932,14835795,13.9),(64614,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64614,32.47,0.47,31.2,22713,NULL,NULL,'H','NGC 3023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64615,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64615,32.48,0.4,31.3,22713,NULL,NULL,'mean','NGC 3023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64616,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64616,32.63,0.45,33.6,22713,NULL,NULL,'K','NGC 3023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64617,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64617,32.63,0.46,33.6,22713,NULL,NULL,'J','NGC 3023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64618,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64618,34.15,0.49,67.8,22714,75,NULL,'IR','UGC 05267',NULL,'2011yCatp016004901K',2011,1,1.77,NULL,'G',0.000073,NULL,'14.5g',0.4,'Sb','Group member',NULL,NULL,NULL,1,147.4702917,9.09575,0.029,NULL,60931713532,952058023,14875906,14.5),(64619,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64619,34.54,0.4,81.1,22714,NULL,NULL,NULL,'UGC 05267',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64620,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64620,34.56,0.4,81.8,22714,NULL,NULL,'Malmquist cor.','UGC 05267',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64621,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64621,34.58,0.2,82.4,22714,74.4,NULL,NULL,'UGC 05267',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64622,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64622,38.76,0.33,564,22715,70,NULL,NULL,'2MASX J09495293+2719595',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000024,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,147.470583333,27.33333,0.009,NULL,64167157591,1002611837,15665809,17.4),(64623,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64623,34.81,0.46,91.5,22716,70,NULL,NULL,'ARK 219',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000157,NULL,'15.0g',0.46,'S0',NULL,NULL,NULL,NULL,1,147.47125,38.90669,0.025,NULL,64056422444,1000881600,15638775,15),(64624,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64624,36.56,0.49,205,22717,75,NULL,'IR','2MFGC 07609',NULL,'2011yCatp016004901K',2011,1,0.69,NULL,'G',0.000027,NULL,'16.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,147.472417,12.90911,0.025,NULL,60824608470,950384507,14849757,16.2),(64625,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64625,36.65,0.44,214,22717,NULL,NULL,'Malmquist cor.','2MFGC 07609',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64626,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64626,36.88,0.4,238,22717,NULL,NULL,NULL,'2MFGC 07609',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64627,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64627,36.92,0.2,242,22717,74.4,NULL,NULL,'2MFGC 07609',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64628,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64628,37.62,0.46,335,22718,70,NULL,NULL,'2MASX J09495376+3733424',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000143,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,147.474,37.56189,0.013,NULL,64175247567,1002738243,15667785,17.1),(64629,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64629,36.86,0.46,236,22719,70,NULL,NULL,'2MASXi J0949538-004829',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000064,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,147.474375,-0.80831,0.109,NULL,41221960966,644093140,10063955,17.6),(64630,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64630,33.7,0.47,55,22720,NULL,NULL,'H','NGC 3028',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00003,NULL,'13.53',1,'Sb pec:',NULL,NULL,NULL,NULL,1,147.476,-19.18417,0.133,NULL,42337925331,661530083,10336407,13.53),(64631,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64631,33.72,0.46,55.6,22720,NULL,NULL,'J','NGC 3028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64632,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64632,33.84,0.45,58.7,22720,NULL,NULL,'K','NGC 3028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64633,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64633,33.9,0.4,60.3,22720,NULL,NULL,'mean','NGC 3028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64634,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64634,36.44,0.46,194,22721,70,NULL,NULL,'2MASX J09495457+3815334',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000179,NULL,'16.0g',0.32,NULL,NULL,NULL,NULL,NULL,1,147.477375,38.25931,0.025,NULL,64055914040,1000873656,15638650,16),(64635,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64635,37.74,0.21,354,22722,70,NULL,NULL,'2MASX J09495517+4202469',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,147.479917,42.04628,0.013,NULL,63973257846,999582153,15618471,17.8),(64636,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64636,37.71,0.27,349,22723,70,NULL,NULL,'2MASX J09495541+2131460',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000178,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,147.480916667,21.52947,0.057,NULL,63698960717,995296261,15551504,16.9),(64637,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64637,35.36,0.48,118,22724,70,NULL,NULL,'IC 0566',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.000096,NULL,'15.0g',0.57,'S0/a',NULL,NULL,NULL,NULL,1,147.4849583,-0.23136,0.121,NULL,41222188552,644096696,10064010,15),(64638,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64638,37.71,0.27,349,22725,70,NULL,NULL,'SDSS J094957.97+213019.6',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,147.4915417,21.50547,0.057,NULL,63698961225,995296269,15551504,17.5),(64639,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64639,38.04,0.33,405,22726,70,NULL,NULL,'2MASX J09495849-0052599',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000085,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,147.493666667,-0.88314,0.109,NULL,41221957270,644093082,10063954,17.5),(64640,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64640,37.31,0.46,290,22727,70,NULL,NULL,'2MASX J09495883+0032243',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000091,NULL,'16.5g',0.38,NULL,NULL,NULL,NULL,NULL,1,147.4952083,0.54006,0.169,NULL,60767460494,949491570,14835805,16.5),(64641,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64641,32.7,0.43,34.6,22728,75,NULL,'3.6 micron, color + selection bias corrected','IC 2513',NULL,'2014MNRAS.444..527S',2014,1,1.5,NULL,'G',0.000037,NULL,'13.2R',0.3,'Sa',NULL,NULL,NULL,NULL,1,147.503291667,-32.88283,0.693,NULL,42856984913,669640389,10463131,13.2),(64642,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64642,32.74,0.4,35.3,22728,75,NULL,NULL,'IC 2513',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64643,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64643,32.75,0.49,35.5,22728,75,NULL,'IR','IC 2513',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64644,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64644,36.96,0.46,247,22729,70,NULL,NULL,'SDSS J095000.98+103020.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,147.504083,10.50558,0.021,NULL,60895708860,951495450,14867116,17.8),(64645,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64645,37.82,0.46,366,22730,70,NULL,NULL,'2MASX J09500140+0338291',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00019,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,147.505791667,3.64128,0.077,NULL,60917145234,951830394,14872349,16.9),(64646,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64646,38.08,0.46,413,22731,70,NULL,NULL,'2MASX J09500162+0851502',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,147.506833333,8.86386,0.045,NULL,60931945601,952061650,14875963,17.7),(64647,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64647,38.13,0.33,423,22732,70,NULL,NULL,'2MASX J09500212+1112231',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000132,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,147.509,11.20656,0.041,NULL,60896242819,951503794,14867246,18.1),(64648,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64648,36.65,0.33,214,22733,70,NULL,NULL,'2MASX J09500308+0610312',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000172,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,147.5127917,6.17519,0.005,NULL,60919283000,951863796,14872871,16.6),(64649,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64649,36.85,0.46,235,22734,70,NULL,NULL,'2MASX J09500377+0641052',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000157,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,147.5157917,6.68489,0.029,NULL,60920090393,951876412,14873068,16.8),(64650,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64650,38.13,0.33,423,22735,70,NULL,NULL,'2MASX J09500407+1114073',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,147.516916667,11.23547,0.041,NULL,60896243194,951503799,14867246,18.1),(64651,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64651,38.31,0.46,459,22736,70,NULL,NULL,'2MASX J09500600+0032201',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000085,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,147.524958333,0.53881,0.169,NULL,60767457968,949491530,14835805,17.5),(64652,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64652,37.77,0.27,358,22737,70,NULL,NULL,'SDSS J095006.51+054325.4',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000117,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,147.527167,5.72372,0.041,NULL,60912004808,951750075,14871094,17.7),(64653,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64653,38.76,0.33,564,22738,70,NULL,NULL,'SDSS J095006.53+272140.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000143,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,147.52725,27.36119,0.041,NULL,64167165388,1002611959,15665811,18.6),(64654,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64654,31.65,0.43,21.3,22739,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3020',NULL,'2014MNRAS.444..527S',2014,1,3.2,NULL,'G',0.000013,NULL,'12.63',1.6,'SB(r)cd:','Pair member, wide',NULL,NULL,NULL,1,147.5275,12.81364,0.017,NULL,60824600847,950384388,14849756,12.63),(64655,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64655,31.66,0.43,21.5,22739,75,NULL,'3.6 micron, color corrected','NGC 3020',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64656,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64656,31.68,0.2,21.7,22739,74.4,NULL,NULL,'NGC 3020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64657,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64657,31.7,0.4,21.9,22739,NULL,NULL,NULL,'NGC 3020',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64658,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64658,31.8,0.4,22.9,22739,75,NULL,'B','NGC 3020',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64659,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64659,31.93,0.56,24.3,22739,NULL,NULL,NULL,'NGC 3020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64660,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64660,31.99,0.54,25,22739,NULL,NULL,'Malmquist cor.','NGC 3020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64661,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64661,32.34,0.4,29.4,22739,NULL,NULL,'mean','NGC 3020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64662,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64662,33.37,0.47,47.2,22739,NULL,NULL,'H','NGC 3020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64663,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64663,35.6,0.2,132,22740,74.4,NULL,NULL,'NGC 3019',NULL,'2013AJ....146...86T',2013,1,0.79,NULL,'G',0.000095,NULL,'15.3g',0.45,'Sc','in a quartet',NULL,NULL,NULL,1,147.5300417,12.74614,0.017,NULL,60824691618,950385806,14849778,15.3),(64664,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64664,37.61,0.46,332,22741,70,NULL,NULL,'2MASX J09500737+0554541',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00011,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,147.53075,5.91511,0.041,NULL,60912021675,951750338,14871099,17.7),(64665,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64665,30.85,0.4,14.8,22742,75,NULL,'B','NGC 3059',NULL,'1988NBGC.C....0000T',1988,1,3.6,'Extended HIPASS source','G',0.00001,NULL,'11.7',3.2,'SB(rs)c','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,147.534,-73.92219,0.765,NULL,39826374404,622287100,9723235,11.7),(64666,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,NULL,64666,34.65,0.52,85.2,22743,70,NULL,NULL,'2MASX J09500846-0506258',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000097,NULL,'15.80',0.4,NULL,NULL,NULL,NULL,NULL,1,147.535458333,-5.10714,0.125,NULL,41302208465,645347007,10083546,15.8),(64667,'FP','2016-12-15 15:14:32','2016-12-16 11:19:38','1',NULL,'R',64667,37.67,0.33,343,22744,70,NULL,NULL,'2MASX J09501014+2041150',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000179,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,147.5422917,20.68764,0.033,NULL,63697142314,995267848,15551060,16.9),(64668,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64668,37.67,0.33,343,22745,70,NULL,NULL,'2MASX J09501021+2040070',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000148,NULL,'17.6g',NULL,NULL,NULL,NULL,NULL,NULL,1,147.5425417,20.66872,0.033,NULL,63697145652,995267900,15551060,17.6),(64669,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64669,37.61,0.46,333,22746,70,NULL,NULL,'2MASX J09501029+2740592',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000195,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,147.542875,27.68314,0.033,NULL,64168732061,1002636438,15666194,17.1),(64670,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64670,37.13,0.46,267,22747,70,NULL,NULL,'2MASX J09501039+3739517',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000163,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,147.543375,37.66436,0.005,NULL,64056988812,1000890450,15638913,16.8),(64671,'TRGB','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64671,27.63,0.1,3.36,22748,NULL,NULL,'I','LEDA 166101',NULL,'2009AJ....138..332J',2009,1,2.4,NULL,'G',NULL,NULL,'16.2:',1.8,'dwarf Sph',NULL,NULL,NULL,NULL,1,147.543875,67.50675,0.137,NULL,62118118132,970595595,15165556,16.2),(64672,'TRGB','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64672,27.71,NULL,3.48,22748,NULL,NULL,NULL,'LEDA 166101',NULL,'2000A&A...363..117K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64673,'TRGB','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64673,27.75,NULL,3.55,22748,NULL,NULL,NULL,'LEDA 166101',NULL,'2010ApJ...724.1030G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64674,'TRGB','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64674,27.75,0.03,3.55,22748,NULL,NULL,'I','LEDA 166101',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64675,'TRGB','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64675,27.84,0.08,3.7,22748,NULL,NULL,NULL,'LEDA 166101',NULL,'2007ASPC..374..247D',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64676,'TRGB','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64676,27.85,0.08,3.72,22748,74.4,NULL,NULL,'LEDA 166101',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64677,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64677,37.44,0.46,307,22749,70,NULL,NULL,'2MASX J09501132+4130107',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000158,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,147.547167,41.50289,0.017,NULL,63975207465,999612616,15618947,17.6),(64678,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64678,34.9,0.61,95.7,22750,NULL,NULL,NULL,'ESO 566- G 017',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.15',0.2,'S...',NULL,NULL,NULL,NULL,1,147.555666667,-21.83303,0.109,NULL,42292072288,660813629,10325212,16.15),(64679,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64679,34.95,0.2,97.7,22750,74.4,NULL,NULL,'ESO 566- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64680,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64680,35.18,0.54,109,22750,NULL,NULL,'Malmquist cor.','ESO 566- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64681,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64681,37.45,0.46,309,22751,70,NULL,NULL,'SDSS J095013.79+073503.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,147.5574583,7.58422,0.021,NULL,60921231969,951894249,14873347,17.7),(64682,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64682,33.17,0.4,43,22752,75,NULL,NULL,'MCG -02-25-020',NULL,'2008Ap.....51..336K',2008,1,1.84,NULL,'G',0.00002,NULL,'14.5',0.22,'Scd',NULL,NULL,NULL,NULL,1,147.5582083,-12.05767,0.097,NULL,41312247496,645503867,10085997,14.5),(64683,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64683,33.71,0.49,55.3,22752,75,NULL,'IR','MCG -02-25-020',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64684,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64684,34.37,NULL,74.9,22752,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -02-25-020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64685,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64685,34.38,NULL,75.1,22752,NULL,NULL,'Dipole + Quadrupole','MCG -02-25-020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64686,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64686,34.38,NULL,75.3,22752,NULL,NULL,'Dipole','MCG -02-25-020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64687,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64687,36.56,0.46,205,22753,70,NULL,NULL,'2MASX J09501520+0425411',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000169,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,147.563375,4.42819,0.077,NULL,60917358023,951833719,14872401,16.3),(64688,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64688,36.8,0.46,229,22754,70,NULL,NULL,'2MASX J09501657+2003240',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000179,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,147.569,20.05675,0.041,NULL,63698117041,995283078,15551298,16.3),(64689,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64689,37.46,0.46,311,22755,70,NULL,NULL,'2MASX J09501776+5752556',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000176,NULL,'17.1g',0.23,'AGN',NULL,NULL,NULL,NULL,1,147.574375,57.88208,0.013,NULL,61931566111,967680720,15120011,17.1),(64690,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64690,35.89,0.59,151,22756,70,NULL,NULL,'2MASX J09501802-1448538',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.69',NULL,NULL,NULL,NULL,NULL,NULL,1,147.574875,-14.81511,0.189,NULL,41187511118,643554861,10055544,16.69),(64691,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64691,32.76,0.4,35.6,22757,NULL,NULL,'mean','ESO 499- G 009',NULL,'2007A&A...465...71T',2007,1,2.2,NULL,'G',0.000023,NULL,'13.53',1.1,'SAB(r)b',NULL,NULL,NULL,NULL,1,147.5754583,-23.02528,0.105,NULL,42291432349,660803630,10325056,13.53),(64692,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64692,32.77,0.43,35.8,22757,75,NULL,'3.6 micron, color + selection bias corrected','ESO 499- G 009',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64693,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64693,32.98,0.47,39.4,22757,NULL,NULL,'H','ESO 499- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64694,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64694,33,0.45,39.8,22757,NULL,NULL,'K','ESO 499- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64695,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64695,33.01,0.46,40,22757,NULL,NULL,'J','ESO 499- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64696,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64696,38.39,0.46,476,22758,70,NULL,NULL,'SDSS J095018.09+193946.4',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'18.1g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,147.575417,19.66292,0.053,NULL,63741137740,995955277,15561801,18.1),(64697,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64697,37.84,0.46,371,22759,70,NULL,NULL,'SDSS J095019.87+202550.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000156,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,147.582833,20.43075,0.037,NULL,63697296913,995270264,15551097,18.7),(64698,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64698,38.34,0.46,466,22760,70,NULL,NULL,'SDSS J095020.76+112546.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,147.5865417,11.42969,0.041,NULL,60894282077,951473157,14866768,17.9),(64699,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64699,37.86,0.46,373,22761,70,NULL,NULL,'2MASX J09502209+2314320',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,147.592,23.24228,0.065,NULL,63693141564,995205336,15550083,17.4),(64700,'Tully est','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64700,31.75,0.8,22.4,22762,75,NULL,'B','NGC 2985',NULL,'1988NBGC.C....0000T',1988,1,4.6,NULL,'G',0.000023,NULL,'11.18',3.6,'(R\')SA(rs)ab   LINER','in a pair',NULL,NULL,'Sy 1.9',1,147.592625,72.27864,0.065,NULL,62106935171,970420862,15162825,11.18),(64701,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64701,31.57,NULL,20.6,22762,NULL,NULL,'B','NGC 2985',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64702,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64702,36.5,0.46,200,22763,70,NULL,NULL,'CGCG 122-095',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000183,NULL,'15.3g',0.6,NULL,NULL,NULL,NULL,NULL,1,147.593083,25.796,0.033,NULL,64165904364,1002592255,15665503,15.3),(64703,'Brightest Stars','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64703,27.9,NULL,3.8,22764,NULL,NULL,NULL,'UGC 05272',NULL,'1998AJ....116.2886S',1998,1,2.1,'The Kiso position applies to a knot southwest of the nucleus.','G',0.000007,NULL,'14.46',0.8,'ImIII','Field galaxy',NULL,NULL,NULL,1,147.593333,31.48778,0.033,NULL,64218673291,1003416770,15678387,14.46),(64704,'Brightest Stars','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64704,29.26,0.2,7.11,22764,NULL,NULL,NULL,'UGC 05272',NULL,'1998A&AS..133..181M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64705,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64705,29.06,0.4,6.5,22764,75,NULL,'B','UGC 05272',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64706,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64706,37.46,0.46,310,22765,70,NULL,NULL,'2MASX J09502253+4613006',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,147.5939583,46.21675,0,NULL,63976897721,999639026,15619359,17.2),(64707,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64707,35.17,0.64,108,22766,70,NULL,NULL,'2MASX J09502479-2151462',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000103,NULL,'15.98',0.5,NULL,NULL,NULL,NULL,NULL,1,147.60325,-21.86303,0.109,NULL,42292063557,660813493,10325210,15.98),(64708,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64708,37.51,0.46,318,22767,70,NULL,NULL,'2MASX J09502502+1859014',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000139,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,147.604208333,18.98369,0.029,NULL,63741813785,995965840,15561966,18.1),(64709,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64709,37.56,0.46,326,22768,70,NULL,NULL,'SDSS J095025.79+264444.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.9g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,147.607458333,26.74578,0.009,NULL,64167128525,1002611383,15665802,17.9),(64710,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64710,32.46,NULL,31.1,22769,NULL,NULL,NULL,'NGC 3024',NULL,'2015AstBu..70....1K',2015,1,1.88,NULL,'G',0.000017,NULL,'13.8g',0.62,'Sc: sp','Pair member, wide',NULL,NULL,NULL,1,147.614125,12.7655,0.017,NULL,60824737904,950386529,14849789,13.8),(64711,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64711,32.84,0.49,37.1,22769,75,NULL,'IR','NGC 3024',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64712,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64712,33.3,0.84,45.7,22770,NULL,NULL,'Malmquist cor.','ESO 566- G 018',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.00003,NULL,'14.05',1,'SB(rs)c        HII',NULL,NULL,NULL,NULL,1,147.615375,-21.80256,0.109,NULL,42292062256,660813472,10325210,14.05),(64713,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64713,33.42,0.79,48.2,22770,NULL,NULL,NULL,'ESO 566- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64714,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64714,37.11,0.46,264,22771,70,NULL,NULL,'2MASX J09502906+0318101',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,147.62125,3.30267,0.073,NULL,60916706507,951823539,14872242,17.1),(64715,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64715,36.39,0.46,189,22772,70,NULL,NULL,'2MASX J09502925+5508267',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,147.622,55.14086,0,NULL,61933771046,967715172,15120549,17.4),(64716,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64716,37.09,0.33,262,22773,70,NULL,NULL,'2MASX J09503133+3447294',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00017,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,147.630625,34.79147,0,NULL,64182689989,1002854531,15669602,17.1),(64717,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64717,35.47,0.71,124,22774,70,NULL,NULL,'2MASX J09503182-2119013',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,147.6325417,-21.31692,0.105,NULL,42284749439,660699209,10323425,15.3),(64718,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64718,36.64,0.46,213,22775,70,NULL,NULL,'2MASX J09503305+1328082',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,147.637583333,13.46911,0.041,NULL,60832399025,950506234,14851659,17.5),(64719,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64719,34.95,0.46,97.6,22776,70,NULL,NULL,'NGC 3010',NULL,'2015arXiv151105856S',2015,1,0.82,'Component \'a)\' in UGC notes.','G',0.00149,NULL,'14.9g',0.45,'AGN','Group member',NULL,NULL,'AGN',1,147.638125,44.31439,0.013,NULL,63986587939,999790436,15621725,14.9),(64720,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64720,37.62,0.46,335,22777,70,NULL,NULL,'2MASX J09503903+4307426',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,147.662625,43.12839,0.005,NULL,63972973700,999577714,15618401,17),(64721,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64721,37.36,0.46,296,22778,70,NULL,NULL,'2MASX J09503973+2444342',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,147.665625,24.74289,0.049,NULL,64166104747,1002595386,15665552,17.3),(64722,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64722,36.85,0.11,234,22779,70,NULL,NULL,'2MASX J09504074+5411207',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000188,NULL,'15.7g',0.36,'E0',NULL,NULL,NULL,NULL,1,147.67,54.18917,0,NULL,61878571449,966852678,15107073,15.7),(64723,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64723,37.75,0.46,355,22780,70,NULL,NULL,'2MASX J09504133+6310329',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000073,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,147.671958333,63.17589,0.097,NULL,62027154080,969174282,15143348,17.7),(64724,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64724,37.1,0.46,263,22781,70,NULL,NULL,'2MASX J09504265+2759291',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00018,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,147.6777083,27.99131,0.033,NULL,64168862647,1002638478,15666226,18.1),(64725,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64725,37.41,0.46,303,22782,70,NULL,NULL,'2MASX J09504276+2557521',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000169,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,147.678083,25.96447,0.025,NULL,64165885062,1002591954,15665499,16.6),(64726,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64726,37.83,0.33,369,22783,70,NULL,NULL,'2MASX J09504421+0338449',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,147.68425,3.64572,0.065,NULL,60916641535,951822523,14872226,17.8),(64727,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64727,37.7,0.46,347,22784,70,NULL,NULL,'2MASX J09504474+3220354',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000159,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,147.686375,32.34308,0.009,NULL,64184661906,1002885342,15670083,17.2),(64728,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64728,37.89,0.46,379,22785,70,NULL,NULL,'2MASX J09504543+0919080',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,147.68925,9.31908,0.029,NULL,60927746826,951996044,14874938,17.7),(64729,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64729,37.51,0.46,317,22786,70,NULL,NULL,'SDSS J095046.54+171821.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000145,NULL,'18.5g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,147.6939583,17.30594,0.061,NULL,63724659575,995697805,15557778,18.5),(64730,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64730,36.98,0.46,249,22787,70,NULL,NULL,'2MASX J09504661+0448499',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000153,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,147.6942083,4.81375,0.061,NULL,60914691685,951792057,14871750,17.2),(64731,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64731,36.37,0.33,188,22788,70,NULL,NULL,'2MASX J09504755+5158062',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000142,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,147.698083,51.96839,0,NULL,64013262138,1000207220,15628237,16.2),(64732,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64732,37.96,0.46,391,22789,70,NULL,NULL,'2MASX J09504787+2320424',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000147,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,147.6994583,23.34508,0.069,NULL,63693186426,995206037,15550094,18.3),(64733,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64733,37.08,0.33,260,22790,70,NULL,NULL,'2MASX J09504943+0122279',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000067,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,147.7060417,1.37453,0.117,NULL,60770712902,949542389,14836599,17.7),(64734,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64734,37.09,0.33,262,22791,70,NULL,NULL,'2MASX J09504954+3449104',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000202,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,147.7064583,34.81972,0,NULL,64183263779,1002863496,15669742,16.7),(64735,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64735,37.1,0.46,263,22792,70,NULL,NULL,'2MASX J09505022+0108529',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000091,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,147.709167,1.14822,0.121,NULL,60770691019,949542047,14836594,16.6),(64736,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64736,38.11,0.46,419,22793,70,NULL,NULL,'2MASX J09505035+2845062',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000193,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,147.709875,28.75161,0.013,NULL,64161565425,1002524459,15664444,17.2),(64737,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64737,37.88,0.46,376,22794,70,NULL,NULL,'2MASX J09505327+3424504',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,147.722125,34.41403,0,NULL,64182647390,1002853865,15669591,17.8),(64738,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64738,38.09,0.46,414,22795,70,NULL,NULL,'SDSS J095053.96+632145.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00009,NULL,'18.3g',0.13,'BLAGN',NULL,NULL,NULL,'Sy 1',1,147.724875,63.36269,0.097,NULL,62026992501,969171757,15143308,18.3),(64739,'IRAS','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64739,32.07,0.8,26,22796,75,NULL,'A82, H','NGC 3026',NULL,'1997ApJS..109..333W',1997,1,2.78,NULL,'G',0.000013,NULL,'13.6g',0.63,'Im','Isolated galaxy',NULL,NULL,NULL,1,147.7307083,28.55111,0.021,NULL,64161549332,1002524208,15664440,13.6),(64740,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64740,30.99,0.4,15.8,22796,73,NULL,'IR','NGC 3026',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64741,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64741,31,0.4,15.8,22796,75,NULL,NULL,'NGC 3026',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64742,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64742,31.65,0.49,21.4,22796,75,NULL,'IR','NGC 3026',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64743,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64743,31.91,0.47,24.1,22796,75,NULL,'A82, H, inv','NGC 3026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64744,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64744,31.94,0.4,24.5,22796,75,NULL,'B','NGC 3026',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64745,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64745,32,0.47,25.1,22796,75,NULL,'A82, H, raw','NGC 3026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64746,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64746,32.18,0.47,27.3,22796,75,NULL,'A82, H, cor','NGC 3026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64747,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64747,37.75,0.33,355,22797,70,NULL,NULL,'2MASX J09505581+2256300',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,147.732625,22.94175,0.069,NULL,63702310379,995348599,15552321,17.6),(64748,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64748,34.13,0.69,67.1,22798,100,NULL,'mid-IR','VV 110',NULL,'2013ApJ...771...88L',2013,1,1.9,'Note +45 arcsec error in VCV2006 declination.','G',0.00003,NULL,'14.46',0.8,'(R)SB(r)a      Sy2',NULL,NULL,NULL,NULL,1,147.735333333,-4.99772,0.125,NULL,41302327214,645348862,10083575,14.46),(64749,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64749,34.89,0.45,94.9,22798,NULL,NULL,'K','VV 110',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64750,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64750,34.93,0.47,96.8,22798,NULL,NULL,'H','VV 110',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64751,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64751,34.93,0.4,96.9,22798,NULL,NULL,'mean','VV 110',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64752,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64752,34.97,0.46,98.6,22798,NULL,NULL,'J','VV 110',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64753,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64753,37.69,0.33,345,22799,70,NULL,NULL,'2MASX J09505653+1816470',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000182,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,147.735583,18.27981,0.057,NULL,63740994754,995953043,15561766,16.7),(64754,'Cepheids','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64754,32.12,0.08,26.5,22800,NULL,NULL,'V, I, NIR (W), 22, Syst. +/- 0.39 mag','NGC 3021',NULL,'2013MNRAS.434.2866F',2013,1,1.6,'UZC has V = 5307 +- 46 km/sec.','G',0.000013,NULL,'12.91',0.9,'SA(rs)bc:','in a triple',NULL,NULL,NULL,1,147.738125,33.55364,0,NULL,64185382165,1002896596,15670259,12.91),(64755,'Cepheids','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64755,32.2,0.1,27.6,22800,NULL,NULL,NULL,'NGC 3021',NULL,'2009ApJ...699..539R',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64756,'Cepheids','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64756,32.27,0.08,28.4,22800,NULL,NULL,'SNIa calibrated','NGC 3021',NULL,'2011ApJ...730..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64757,'Cepheids','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64757,32.28,0.06,28.6,22800,74.4,NULL,NULL,'NGC 3021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64758,'SNIa','2016-12-15 15:14:32','2016-12-16 11:19:39','1','SN 1995al',NULL,64758,31.58,0.46,20.6,22800,74.2,NULL,'SALT 2','NGC 3021',0.00514,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64759,'SNIa','2016-12-15 15:14:32','2016-12-16 11:19:39','1','SN 1995al',NULL,64759,32.03,0.17,25.5,22800,70.8,NULL,NULL,'NGC 3021',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64760,'SNIa','2016-12-15 15:14:32','2016-12-16 11:19:39','1','SN 1995al',NULL,64760,32.26,0.19,28.2,22800,72,NULL,NULL,'NGC 3021',0.00514,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64761,'SNIa','2016-12-15 15:14:32','2016-12-16 11:19:39','1','SN 1995al',NULL,64761,32.27,0.08,28.4,22800,NULL,NULL,'MLCS2k2, Cepheids calibrated','NGC 3021',NULL,'2011ApJ...730..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64762,'SNIa','2016-12-15 15:14:32','2016-12-16 11:19:39','1','SN 1995al',NULL,64762,32.28,0.06,28.6,22800,74.4,NULL,NULL,'NGC 3021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64763,'SNIa','2016-12-15 15:14:32','2016-12-16 11:19:39','1','SN 1995al',NULL,64763,32.33,0.02,29.2,22800,NULL,NULL,'m-M(V)13.27 - -19.06 mag','NGC 3021',NULL,'2009ApJS..183..109R',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64764,'SNIa','2016-12-15 15:14:32','2016-12-16 11:19:39','1','SN 1995al',NULL,64764,32.38,0.46,29.8,22800,70,NULL,'SALT','NGC 3021',0.00514,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64765,'SNIa','2016-12-15 15:14:32','2016-12-16 11:19:39','1','SN 1995al',NULL,64765,32.61,0.06,33.3,22800,60,NULL,'M(I) = -19.19 mag','NGC 3021',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64766,'SNIa','2016-12-15 15:14:32','2016-12-16 11:19:39','1','SN 1995al','R',64766,32.62,NULL,33.4,22800,62.3,NULL,NULL,'NGC 3021',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64767,'SNIa','2016-12-15 15:14:32','2016-12-16 11:19:39','1','SN 1995al',NULL,64767,32.64,0.06,33.7,22800,60,NULL,'M(V) = -19.47 mag','NGC 3021',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64768,'SNIa','2016-12-15 15:14:32','2016-12-16 11:19:39','1','SN 1995al',NULL,64768,32.71,0.08,34.5,22800,65,NULL,'MLCS2k2','NGC 3021',0.00514,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64769,'SNIa','2016-12-15 15:14:32','2016-12-16 11:19:39','1','SN 1995al',NULL,64769,32.71,0.14,34.8,22800,60,NULL,NULL,'NGC 3021',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64770,'SNIa','2016-12-15 15:14:32','2016-12-16 11:19:39','1','SN 1995al',NULL,64770,32.74,0.07,35.3,22800,60,NULL,'M(B) = -19.48 mag','NGC 3021',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64771,'Tully est','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64771,32,0.8,25.1,22800,75,NULL,'B','NGC 3021',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64772,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64772,30.89,0.69,15.1,22800,100,NULL,'mid-IR','NGC 3021',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64773,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64773,31.71,0.63,22,22800,NULL,NULL,'Malmquist cor.','NGC 3021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64774,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64774,31.74,0.4,22.3,22800,75,NULL,'HOSTS SN 1995al','NGC 3021',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64775,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64775,31.75,0.43,22.3,22800,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3021',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64776,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64776,31.91,0.43,24.1,22800,75,NULL,'3.6 micron, color corrected','NGC 3021',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64777,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64777,31.98,0.56,24.8,22800,NULL,NULL,NULL,'NGC 3021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64778,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64778,32.02,0.42,25.4,22800,NULL,18.48,'3.6 micron','NGC 3021',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64779,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64779,32.02,0.4,25.4,22800,NULL,NULL,'mean','NGC 3021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64780,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64780,32.07,0.45,25.9,22800,NULL,NULL,'K','NGC 3021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64781,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64781,32.1,0.47,26.3,22800,NULL,NULL,'H','NGC 3021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64782,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64782,32.13,0.46,26.7,22800,NULL,NULL,'J','NGC 3021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64783,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64783,32.15,0.4,26.9,22800,75,NULL,'HOSTS SN 1995al','NGC 3021',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64784,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64784,32.28,0.06,28.6,22800,74.4,NULL,NULL,'NGC 3021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64785,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64785,32.4,0.4,30.2,22800,NULL,NULL,NULL,'NGC 3021',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64786,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64786,37.48,0.46,314,22801,70,NULL,NULL,'2MASX J09505869+0756190',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,147.74475,7.93867,0.029,NULL,60932017559,952062774,14875980,16.2),(64787,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64787,36.37,0.33,188,22802,70,NULL,NULL,'2MASX J09505867+5155046',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000179,NULL,'16.0g',0.4,'E0',NULL,NULL,NULL,NULL,1,147.74475,51.918,0,NULL,64013245653,1000206963,15628233,16),(64788,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64788,37.88,0.46,377,22803,70,NULL,NULL,'SDSS J095059.68+000656.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000071,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,147.748708333,0.11583,0.121,NULL,60768659276,949510301,14836098,18.3),(64789,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64789,37.08,0.33,260,22804,70,NULL,NULL,'2MASX J09510054+0123130',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000088,NULL,'16.8g',0.26,'AGN',NULL,NULL,NULL,NULL,1,147.752375,1.387,0.089,NULL,60770707419,949542303,14836598,16.8),(64790,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64790,37.17,0.46,271,22805,70,NULL,NULL,'2MASX J09510106+4336330',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000153,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,147.754417,43.60933,0.009,NULL,63987092416,999798319,15621848,16.8),(64791,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64791,39.2,0.46,690,22806,70,NULL,NULL,'2MASX J09510135+1849320',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,147.755541667,18.82547,0.037,NULL,63741792779,995965512,15561961,17.8),(64792,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64792,37.88,0.33,377,22807,70,NULL,NULL,'SDSS J095101.88+454250.9',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,147.757875,45.71417,0,NULL,63977220590,999644071,15619438,17.2),(64793,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64793,37.88,0.33,377,22808,70,NULL,NULL,'2MASX J09510186+4542510',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,147.758583333,45.71767,0,NULL,63977220598,999644071,15619438,18.1),(64794,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64794,37.2,0.46,275,22809,70,NULL,NULL,'SDSS J095102.18+381644.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,147.759083,38.27894,0.025,NULL,64059230619,1000925478,15639460,17.9),(64795,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64795,36.33,0.64,185,22810,70,NULL,NULL,'2MASX J09510364-1626126',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.64',NULL,NULL,NULL,NULL,NULL,NULL,1,147.765167,-16.43689,0.189,NULL,41178986424,643421662,10053463,16.64),(64796,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64796,37.69,0.33,345,22811,70,NULL,NULL,'2MASX J09510404+1816190',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00018,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,147.76675,18.27186,0.057,NULL,63740987446,995952928,15561764,17.4),(64797,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64797,37.79,0.27,361,22812,70,NULL,NULL,'2MASX J09510416+0604580',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,'PHOT','17.3g',0.24,'BrClG',NULL,NULL,NULL,NULL,1,147.767375,6.08275,0.029,NULL,60911783944,951746624,14871041,17.3),(64798,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64798,35.44,0.47,122,22813,70,NULL,NULL,'2MASX J09510432-1605436',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000097,NULL,'15.86',NULL,NULL,NULL,NULL,NULL,NULL,1,147.768,-16.09544,0.149,NULL,41179617575,643431524,10053617,15.86),(64799,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64799,37.75,0.33,355,22814,70,NULL,NULL,'2MASX J09510557+2308040',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,147.773208333,23.13433,0.069,NULL,63701269892,995332342,15552067,17.2),(64800,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64800,37.79,0.27,361,22815,70,NULL,NULL,'2MASX J09510557+0604330',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,147.77325,6.07594,0.029,NULL,60911784186,951746627,14871041,17.6),(64801,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64801,38.6,0.46,524,22816,70,NULL,NULL,'SDSS J095105.60+290448.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000141,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,147.773333,29.08022,0.005,NULL,64161506596,1002523540,15664430,18.7),(64802,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64802,34.31,0.2,72.8,22817,74.4,NULL,NULL,'UGC 05286',NULL,'2013AJ....146...86T',2013,1,2,NULL,'G',0.000013,NULL,'13.60',1.4,'SAd','in a radial-velocity based grouping',NULL,NULL,NULL,1,147.775125,9.00861,0.045,NULL,60931857932,952060280,14875941,13.6),(64803,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64803,34.41,0.44,76.2,22817,NULL,NULL,NULL,'UGC 05286',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64804,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64804,34.44,0.43,77.2,22817,NULL,NULL,'Malmquist cor.','UGC 05286',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64805,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64805,38.19,0.46,435,22818,70,NULL,NULL,'2MASX J09510637+0740077',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00017,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,147.7765,7.66878,0.021,NULL,60933805374,952090708,14876417,17.8),(64806,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64806,37.23,0.46,280,22819,70,NULL,NULL,'2MASX J09510644+6351599',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00007,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,147.777083,63.86664,0.121,NULL,62245936994,972592765,15196761,17.5),(64807,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64807,36.32,0.46,183,22820,70,NULL,NULL,'2MASX J09510706+6000519',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000073,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,147.779375,60.01436,0.021,NULL,61914965983,967421343,15115958,16.5),(64808,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64808,37.02,0.46,253,22821,70,NULL,NULL,'2MASX J09510779+2517242',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00018,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,147.7825,25.29011,0.029,NULL,64166558147,1002602471,15665663,17),(64809,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64809,36.31,0.46,183,22822,70,NULL,NULL,'2MASX J09510792+6154379',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000086,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,147.783167,61.91067,0.069,NULL,62028500061,969195313,15143676,16.4),(64810,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64810,36.22,0.46,175,22823,70,NULL,NULL,'CGCG 152-076 NED01',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000113,NULL,'15.4g',0.54,'N COMPONENT',NULL,NULL,NULL,NULL,1,147.784,26.28661,0.029,NULL,64167645718,1002619464,15665929,15.4),(64811,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64811,38.95,0.46,618,22824,70,NULL,NULL,'2MASX J09510823+1348177',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,147.784166667,13.80483,0.049,NULL,60833460225,950522816,14851919,18),(64812,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64812,35.49,0.47,126,22825,NULL,NULL,'H','IC 0568',NULL,'2007A&A...465...71T',2007,1,1.12,NULL,'G',0.00003,NULL,'14.5g',0.74,'SB(rs)b',NULL,NULL,NULL,NULL,1,147.7847083,15.73044,0.077,NULL,60829195671,950456182,14850877,14.5),(64813,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64813,35.56,0.45,129,22825,NULL,NULL,'K','IC 0568',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64814,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64814,35.58,0.4,130,22825,NULL,NULL,'mean','IC 0568',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64815,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64815,35.65,0.46,135,22825,NULL,NULL,'J','IC 0568',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64816,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64816,37.92,0.46,383,22826,70,NULL,NULL,'2MASX J09510887+1525597',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,147.786916667,15.43319,0.053,NULL,60828458958,950444671,14850697,17),(64817,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64817,38.38,0.46,475,22827,70,NULL,NULL,'2MASXi J0951088+115759',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000178,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,147.787083,11.96653,0.025,NULL,60894739483,951480304,14866879,17.5),(64818,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64818,37.43,0.46,306,22828,70,NULL,NULL,'2MASX J09510913+4602221',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,147.788167,46.03936,0,NULL,63977739827,999652184,15619565,16.1),(64819,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64819,37.79,0.46,361,22829,70,NULL,NULL,'SDSS J095110.43+000723.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00007,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,147.7934583,0.12325,0.121,NULL,60768660868,949510326,14836098,18),(64820,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64820,31.73,0.2,22.2,22830,74.4,NULL,NULL,'UGC 05282',NULL,'2013AJ....146...86T',2013,1,1.2,'Multiple SDSS entries describe this source.','G',0.00002,NULL,'16.0',0.5,'Sm:','Group member',NULL,NULL,NULL,1,147.7934583,33.1315,0.005,NULL,64184811996,1002887687,15670120,16),(64821,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64821,37.39,0.46,301,22831,70,NULL,NULL,'SDSS J095111.31-004645.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00006,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,147.797167,-0.77936,0.133,NULL,41225599168,644149987,10064843,18.1),(64822,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64822,36.75,0.46,224,22832,70,NULL,NULL,'2MASX J09511140+0604550',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000173,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,147.797416667,6.08197,0.029,NULL,60911784467,951746632,14871041,16.6),(64823,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64823,37.17,0.46,272,22833,70,NULL,NULL,'2MASX J09511314+2649388',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00017,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,147.804708333,26.82739,0.021,NULL,64167111430,1002611116,15665798,17.7),(64824,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64824,37.83,0.33,369,22834,70,NULL,NULL,'SDSS J095113.83+033310.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,147.807625,3.55286,0.065,NULL,60916791563,951824868,14872263,18.4),(64825,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64825,37.17,0.46,271,22835,70,NULL,NULL,'2MASX J09511402+2553118',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00015,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,147.8085417,25.88661,0.033,NULL,64166023489,1002594117,15665533,17.4),(64826,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64826,37.59,0.46,330,22836,70,NULL,NULL,'2MASX J09511476+2418578',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,147.8115,24.31608,0.049,NULL,63693563323,995211926,15550186,17.6),(64827,'IRAS','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64827,32.86,0.8,37.3,22837,75,NULL,'MAT, I','NGC 3038',NULL,'1997ApJS..109..333W',1997,1,2.5,'Confused HIPASS source','G',0.000013,NULL,'12.42',1.3,'SA(rs)b        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,147.814375,-32.75256,0.521,NULL,42857122122,669642533,10463164,12.42),(64828,'Sosies','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64828,33.07,0.12,41.1,22837,NULL,NULL,NULL,'NGC 3038',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64829,'Tully est','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64829,32.75,0.8,35.5,22837,75,NULL,'B','NGC 3038',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64830,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64830,32.01,0.69,25.3,22837,100,NULL,'mid-IR','NGC 3038',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64831,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64831,32.44,0.46,30.8,22837,NULL,NULL,'J','NGC 3038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64832,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64832,32.44,0.47,30.8,22837,NULL,NULL,'H','NGC 3038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64833,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64833,32.48,0.45,31.4,22837,NULL,NULL,'K','NGC 3038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64834,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64834,32.59,0.43,33,22837,75,NULL,'MAT, I, raw','NGC 3038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64835,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64835,32.61,0.4,33.3,22837,NULL,NULL,NULL,'NGC 3038',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64836,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64836,32.62,0.32,33.4,22837,85,NULL,'I, raw','NGC 3038',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64837,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64837,32.69,0.32,34.5,22837,85,NULL,'I, inv','NGC 3038',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64838,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64838,32.86,0.43,37.4,22837,75,NULL,'MAT, I, cor','NGC 3038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64839,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64839,32.89,0.43,37.8,22837,75,NULL,'MAT, I, inv','NGC 3038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64840,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64840,33.01,0.43,39.9,22837,75,NULL,'3.6 micron, color corrected','NGC 3038',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64841,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64841,33.01,0.2,40,22837,74.4,NULL,NULL,'NGC 3038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64842,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64842,33.03,0.4,40.3,22837,NULL,NULL,'mean','NGC 3038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64843,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64843,33.08,0.43,41.3,22837,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3038',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64844,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64844,33.25,0.08,44.8,22837,NULL,NULL,NULL,'NGC 3038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64845,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64845,37.28,0.46,286,22838,70,NULL,NULL,'2MASX J09511596+0530400',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,147.8165417,5.51106,0.053,NULL,60914079329,951782489,14871601,17.5),(64846,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64846,35.54,0.59,128,22839,70,NULL,NULL,'2MASX J09511617-0638054',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.30',NULL,NULL,NULL,NULL,NULL,NULL,1,147.81725,-6.63494,0.193,NULL,41324535945,645695874,10088998,16.3),(64847,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64847,37.96,0.27,391,22840,70,NULL,NULL,'SDSS J095116.74+045842.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00014,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,147.81975,4.97858,0.061,NULL,60914762533,951793164,14871768,18.7),(64848,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64848,37.64,0.27,337,22841,70,NULL,NULL,'SDSS J095116.75+052938.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000168,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,147.8197917,5.49408,0.053,NULL,60914081388,951782521,14871601,18.3),(64849,'Brightest Stars','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64849,29.18,NULL,6.85,22842,NULL,NULL,NULL,'UGC 05288',NULL,'1999AstL...25..322S',1999,1,1.3,NULL,'G',0.000017,NULL,'14.09',0.8,'Sdm:','Field galaxy',NULL,NULL,NULL,1,147.820833,7.8275,0.021,NULL,60933837631,952091212,14876425,14.09),(64850,'TRGB','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64850,30.29,0.2,11.4,22842,NULL,NULL,NULL,'UGC 05288',NULL,'2015ApJ...805..144K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64851,'TRGB','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64851,30.31,0.1,11.5,22842,74.4,NULL,NULL,'UGC 05288',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64852,'Tully est','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64852,28.59,0.8,5.2,22842,75,NULL,NULL,'UGC 05288',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64853,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64853,37.64,0.27,337,22843,70,NULL,NULL,'2MASX J09511810+0529230',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00008,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,147.825417,5.48986,0.053,NULL,60914081442,951782522,14871601,17.2),(64854,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64854,35.22,0.46,110,22844,70,NULL,NULL,'CGCG 289-021',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000077,NULL,'15.0g',0.51,'S0^-',NULL,NULL,NULL,NULL,1,147.832833,57.94094,0.013,NULL,61931781129,967684080,15120063,15),(64855,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64855,38.08,0.46,414,22845,70,NULL,NULL,'2MASX J09511991+1512216',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,147.833083,15.20611,0.061,NULL,60830292360,950473318,14851145,17.6),(64856,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64856,33.11,0.43,42,22846,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-25-023',NULL,'2014MNRAS.444..527S',2014,1,1.4,NULL,'G',0.00001,NULL,'15',0.9,'SB(s)cd',NULL,NULL,NULL,NULL,1,147.842583333,-12.62367,0.141,NULL,41181415948,643459624,10054056,15),(64857,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64857,37.96,0.27,391,22847,70,NULL,NULL,'SDSS J095122.57+045432.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,147.8440417,4.90908,0.061,NULL,60914601981,951790655,14871728,18.3),(64858,'G Lens','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64858,39.32,1.65,730,22848,NULL,NULL,NULL,'FBQS J0951+2635G',NULL,'2013ApJ...770..154T',2013,1,NULL,'This galaxy lenses a z = 1.24 QSO.','G',0.002,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,147.844167,26.58722,0.029,NULL,64167094146,1002610846,15665794,NULL),(64859,'G Lens','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64859,39.66,1.66,856,22848,NULL,NULL,NULL,'FBQS J0951+2635G',NULL,'2013ApJ...770..154T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64860,'G Lens','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64860,39.67,1.66,858,22848,NULL,NULL,NULL,'FBQS J0951+2635G',NULL,'2013ApJ...770..154T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64861,'G Lens','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64861,39.81,NULL,917,22848,NULL,NULL,'Standard','FBQS J0951+2635G',NULL,'2014ApJ...788..190W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64862,'G Lens','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64862,39.9,NULL,956,22848,NULL,NULL,'R(H) = ct','FBQS J0951+2635G',NULL,'2014ApJ...788..190W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64863,'G Lens','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64863,40.03,0.42,1020,22848,NULL,NULL,NULL,'FBQS J0951+2635G',NULL,'2007ApJ...660....1O',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64864,'G Lens','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64864,40.37,1.65,1180,22848,NULL,NULL,NULL,'FBQS J0951+2635G',NULL,'2013ApJ...770..154T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64865,'G Lens','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64865,41.62,0.71,2110,22848,NULL,NULL,NULL,'FBQS J0951+2635G',NULL,'2014MNRAS.437..600S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64866,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64866,37.96,0.27,391,22849,70,NULL,NULL,'2MASX J09512271+0459490',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00019,NULL,'17.6g',0.21,'BrClG',NULL,NULL,NULL,NULL,1,147.84475,4.99708,0.061,NULL,60914763306,951793176,14871768,17.6),(64867,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64867,37.64,0.27,337,22850,70,NULL,NULL,'2MASX J09512507+0529070',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000083,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,147.854583,5.48542,0.053,NULL,60914078287,951782473,14871601,16.9),(64868,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64868,33.23,0.82,44.2,22851,NULL,NULL,NULL,'UGC 05283',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'15.1',0.9,'SAd',NULL,NULL,NULL,NULL,1,147.855083333,44.92372,0.005,NULL,63987523572,999805055,15621953,15.1),(64869,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64869,33.27,0.2,45.1,22851,74.4,NULL,NULL,'UGC 05283',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64870,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64870,33.46,0.74,49.3,22851,NULL,NULL,'Malmquist cor.','UGC 05283',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64871,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64871,37.79,0.27,361,22852,70,NULL,NULL,'SDSS J095125.27+061254.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,147.855333333,6.21514,0.005,NULL,60919179716,951862183,14872846,18.4),(64872,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64872,36.01,0.62,159,22853,70,NULL,NULL,'2MFGC 07630',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,147.861875,-3.32858,0.077,NULL,41303299105,645364048,10083813,15.5),(64873,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64873,33.68,NULL,54.5,22854,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05289 NED01',NULL,'2010Ap&SS.325..163P',2010,1,1.06,'Multiple SDSS entries describe this source.','G',0.000033,NULL,'16.5',0.11,'Sd',NULL,NULL,NULL,NULL,1,147.862583,-1.74869,0.105,NULL,41223449987,644116406,10064318,16.5),(64874,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64874,33.69,NULL,54.8,22854,NULL,NULL,'Dipole + Quadrupole','UGC 05289 NED01',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64875,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64875,33.7,NULL,55,22854,NULL,NULL,'Dipole','UGC 05289 NED01',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64876,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64876,33.73,NULL,55.7,22854,NULL,NULL,NULL,'UGC 05289 NED01',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64877,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64877,34.6,0.47,83.2,22855,NULL,NULL,'H','MCG -01-25-050',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00006,NULL,'14.15',0.8,'SB(r)ab',NULL,NULL,NULL,NULL,1,147.863875,-5.10361,0.117,NULL,41302258050,645347782,10083559,14.15),(64878,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64878,34.75,0.46,89,22855,NULL,NULL,'J','MCG -01-25-050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64879,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64879,34.76,0.45,89.5,22855,NULL,NULL,'K','MCG -01-25-050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64880,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64880,34.82,0.4,92,22855,NULL,NULL,'mean','MCG -01-25-050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64881,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64881,32.51,0.2,31.8,22856,74.4,NULL,NULL,'UGC 05287',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.00002,NULL,'14.44',0.9,'SB(s)cd','Group member',NULL,NULL,NULL,1,147.866375,32.94192,0,NULL,64184855074,1002888360,15670130,14.44),(64882,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64882,37.57,0.46,326,22857,70,NULL,NULL,'2MASX J09512797+3234297',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00013,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,147.8665,32.57494,0.005,NULL,64184677239,1002885581,15670087,17.5),(64883,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64883,35.92,0.46,153,22858,70,NULL,NULL,'IC 0569',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.00018,NULL,'15.1g',0.54,'E','Isolated galaxy',NULL,NULL,NULL,1,147.8672917,10.92006,0.033,NULL,60897027388,951516052,14867438,15.1),(64884,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64884,37.44,0.46,308,22859,70,NULL,NULL,'2MASX J09512956+2231201',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000188,NULL,'17.66',0.31,NULL,NULL,NULL,NULL,NULL,1,147.873083333,22.52233,0.057,NULL,63699582592,995305978,15551655,17.66),(64885,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64885,38.03,0.46,404,22860,70,NULL,NULL,'2MASX J09513090+1645463',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,147.87875,16.76294,0.081,NULL,60826134897,950408357,14850130,17),(64886,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64886,36.66,0.46,215,22861,70,NULL,NULL,'2MASX J09513118+0324076',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000172,NULL,'16.2g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,147.879917,3.40228,0.061,NULL,60916870697,951826104,14872282,16.2),(64887,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64887,37.49,0.46,315,22862,70,NULL,NULL,'2MASX J09513209+5407306',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000172,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,147.8837083,54.12508,0,NULL,61933108255,967704816,15120387,16.7),(64888,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64888,37.75,0.46,355,22863,70,NULL,NULL,'SDSS J095132.35+064241.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,147.8847917,6.71139,0.029,NULL,60932942164,952077221,14876206,18.1),(64889,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64889,34.8,0.49,91.4,22864,75,NULL,'IR','CGCG 122-098',NULL,'2011yCatp016004901K',2011,1,0.6,NULL,'G',0.00013,NULL,'15.5',0.2,NULL,NULL,NULL,NULL,NULL,1,147.8867917,23.81061,0.061,NULL,63693220765,995206574,15550102,15.5),(64890,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64890,36.8,0.46,230,22865,70,NULL,NULL,'VII Zw 296',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,147.889375,58.05525,0.013,NULL,61931732991,967683327,15120051,17),(64891,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64891,37.78,0.21,360,22866,70,NULL,NULL,'2MASX J09513417+0556586',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,147.8925417,5.94967,0.029,NULL,60913892830,951779575,14871555,17.4),(64892,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64892,37.09,0.21,261,22867,70,NULL,NULL,'2MASX J09513419+0108196',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000068,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,147.892583,1.13883,0.121,NULL,60771157206,949549331,14836708,17.5),(64893,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64893,37.96,0.46,391,22868,70,NULL,NULL,'2MASX J09513454+0750209',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000181,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,147.894,7.83914,0.033,NULL,60933845917,952091342,14876427,17.5),(64894,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64894,37.41,0.46,303,22869,70,NULL,NULL,'2MASX J09513483+0015206',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000085,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,147.89525,0.25564,0.081,NULL,60768697734,949510902,14836107,17.1),(64895,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64895,36.8,0.46,229,22870,70,NULL,NULL,'2MASX J09513489+3516457',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000177,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,147.895583333,35.27936,0,NULL,64182399628,1002849994,15669531,17),(64896,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64896,34.99,0.46,99.7,22871,70,NULL,NULL,'CGCG 007-047',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000086,NULL,'15.4g',0.57,'BrClG',NULL,NULL,NULL,NULL,1,147.895875,1.11206,0.121,NULL,60771234979,949550546,14836727,15.4),(64897,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64897,37.07,0.46,260,22872,70,NULL,NULL,'2MASX J09513587+1510363',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,147.8995,15.17675,0.061,NULL,60830289883,950473279,14851144,17),(64898,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64898,37.74,0.46,354,22873,70,NULL,NULL,'2MASX J09513620+2210551',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,147.900791667,22.18203,0.057,NULL,63699740758,995308449,15551694,17.8),(64899,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64899,38.61,0.46,527,22874,70,NULL,NULL,'2MASX J09513663+2020581',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00018,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,147.902583,20.34956,0.045,NULL,63698268500,995285445,15551335,17.7),(64900,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64900,37.96,0.46,391,22875,70,NULL,NULL,'SDSS J095138.58+010155.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000075,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,147.91075,1.03197,0.113,NULL,60771226670,949550416,14836725,18.3),(64901,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64901,32.08,NULL,26.1,22876,NULL,NULL,NULL,'LSBC L1-097',NULL,'2015AstBu..70....1K',2015,1,NULL,NULL,'G',0.000067,NULL,'17.4',NULL,'Im',NULL,NULL,NULL,NULL,1,147.91175,0.36981,0.081,NULL,60770763177,949543174,14836612,17.4),(64902,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64902,36.78,0.46,227,22877,70,NULL,NULL,'SDSS J095140.36+033113.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,147.9182083,3.52042,0.061,NULL,60917020882,951828451,14872319,17.7),(64903,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64903,37.99,0.46,396,22878,70,NULL,NULL,'2MASX J09514051+1710313',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,147.918875,17.17531,0.061,NULL,60826732592,950417696,14850276,18.1),(64904,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64904,37.78,0.21,360,22879,70,NULL,NULL,'2MASX J09514114+0559316',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000156,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,147.921625,5.99206,0.029,NULL,60913880068,951779376,14871552,17.5),(64905,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64905,36.2,0.46,174,22880,70,NULL,NULL,'2MASX J09514118+3547207',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'15.7g',0.46,NULL,NULL,NULL,NULL,NULL,1,147.921625,35.78903,0,NULL,64186545251,1002914769,15670543,15.7),(64906,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64906,35.67,0.46,136,22881,70,NULL,NULL,'CGCG 063-088',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000163,NULL,'14.8g',0.66,'E0',NULL,NULL,NULL,NULL,1,147.9237917,12.44511,0.061,NULL,60824222771,950378480,14849663,14.8),(64907,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64907,37.49,0.33,315,22882,70,NULL,NULL,'2MASX J09514190+2026181',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000187,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,147.9245,20.43833,0.045,NULL,63698297809,995285903,15551342,16.7),(64908,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64908,37.81,0.46,365,22883,70,NULL,NULL,'2MASX J09514205+1839451',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000133,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,147.925083333,18.66244,0.041,NULL,63740952632,995952384,15561756,17.9),(64909,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64909,36.96,0.46,247,22884,70,NULL,NULL,'2MASX J09514217+5507176',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,147.9255,55.12161,0,NULL,61933810436,967715788,15120559,17.2),(64910,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64910,37.09,0.46,262,22885,70,NULL,NULL,'2MASX J09514234+4155431',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,147.9264583,41.92861,0.013,NULL,63973334245,999583347,15618489,16.9),(64911,'Tully est','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64911,32.18,0.8,27.3,22886,75,NULL,NULL,'UGCA 186',NULL,'1988NBGC.C....0000T',1988,1,1.1,NULL,'G',0.000025,NULL,'16',0.8,'IB(s)m:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,147.933833,1.44853,0.089,NULL,60770675098,949541798,14836590,16),(64912,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64912,32.33,NULL,29.3,22886,NULL,NULL,NULL,'UGCA 186',NULL,'2015AstBu..70....1K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64913,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64913,37.34,0.46,294,22887,70,NULL,NULL,'2MASX J09514382+5510106',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,147.9327083,55.16969,0,NULL,61933809142,967715767,15120558,16.9),(64914,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64914,38.61,0.46,527,22888,70,NULL,NULL,'2MASX J09514483+2739315',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000137,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,147.936791667,27.65886,0.033,NULL,64169626135,1002650408,15666412,18.1),(64915,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64915,39.12,0.33,666,22889,70,NULL,NULL,'2MASX J09514486+1200323',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,147.937125,12.00903,0.025,NULL,60894521779,951476902,14866826,17.6),(64916,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64916,39.12,0.33,666,22890,70,NULL,NULL,'SDSS J095144.95+120119.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000175,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,147.9372917,12.022,0.025,NULL,60894529271,951477019,14866828,18.8),(64917,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64917,37.78,0.21,360,22891,70,NULL,NULL,'2MASX J09514604+0600216',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,147.941916667,6.00606,0.029,NULL,60913879859,951779372,14871552,16.6),(64918,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64918,38.63,0.46,531,22892,70,NULL,NULL,'SDSS J095146.46+011824.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000076,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,147.943583,1.30683,0.117,NULL,60770652312,949541442,14836585,18.3),(64919,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64919,36.97,0.46,247,22893,70,NULL,NULL,'2MASX J09514667+2542025',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00016,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,147.944375,25.70083,0.029,NULL,64165940128,1002592814,15665512,16.4),(64920,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64920,37.51,0.46,317,22894,70,NULL,NULL,'2MASX J09514735+0333546',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000173,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,147.9474583,3.56531,0.065,NULL,60917008917,951828264,14872316,16.7),(64921,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64921,38.12,0.33,420,22895,70,NULL,NULL,'2MASX J09514841+1224193',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,147.951833333,12.40528,0.061,NULL,60824208022,950378250,14849660,17.3),(64922,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64922,37.09,0.21,261,22896,70,NULL,NULL,'2MASX J09514920+0108016',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000086,NULL,'16.4g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,147.955125,1.13389,0.117,NULL,60771229987,949550468,14836726,16.4),(64923,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64923,37.09,0.21,261,22897,70,NULL,NULL,'2MASX J09514959+0108346',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000079,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,147.95675,1.14281,0.117,NULL,60771160789,949549387,14836709,18),(64924,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64924,38.12,0.33,420,22898,70,NULL,NULL,'2MASX J09514984+1225483',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000145,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,147.9577083,12.43011,0.061,NULL,60824211151,950378299,14849660,17.9),(64925,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64925,38.1,0.46,417,22899,70,NULL,NULL,'2MASX J09515052+0546556',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000177,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,147.960375,5.78214,0.041,NULL,60913924463,951780069,14871563,16.8),(64926,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64926,37.66,0.46,341,22900,70,NULL,NULL,'2MASX J09515193-0030008',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000084,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,147.966333333,-0.50014,0.097,NULL,41225190790,644143606,10064743,17.5),(64927,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64927,37.01,0.46,252,22901,70,NULL,NULL,'SDSS J095152.00+043050.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,147.966667,4.51389,0.065,NULL,60917315262,951833050,14872391,18),(64928,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64928,36.74,0.46,223,22902,70,NULL,NULL,'2MASX J09515215+2154521',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000068,NULL,'17.35',0.24,NULL,NULL,NULL,NULL,NULL,1,147.967417,21.91447,0.057,NULL,63699254398,995300849,15551575,17.35),(64929,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64929,35.99,0.46,158,22903,70,NULL,NULL,'UGC 05291',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.00008,NULL,'14.39',0.8,'S0-:',NULL,NULL,NULL,NULL,1,147.9725417,12.94472,0.037,NULL,60824487106,950382611,14849728,14.39),(64930,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64930,37.86,0.46,374,22904,70,NULL,NULL,'2MASX J09515459+3238105',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000201,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,147.9775417,32.63625,0.005,NULL,64184665885,1002885404,15670084,16.7),(64931,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64931,37.15,0.46,270,22905,70,NULL,NULL,'2MASX J09515527+2100290',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000168,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,147.980375,21.00808,0.049,NULL,63697497198,995273393,15551146,16.8),(64932,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64932,37.09,0.21,261,22906,70,NULL,NULL,'2MASX J09515653+0106396',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000091,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,147.985583,1.11097,0.117,NULL,60771263321,949550989,14836734,17.1),(64933,'IRAS','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64933,32.98,0.8,39.4,22907,75,NULL,'MAT, I','ESO 374- G 003',NULL,'1997ApJS..109..333W',1997,1,2.2,'Confused HIPASS source','G',0.00001,NULL,'14.10',0.8,'SAB(rs)cd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,147.9892917,-33.07353,0.585,NULL,42857052865,669641451,10463147,14.1),(64934,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64934,31.75,0.32,22.4,22907,85,NULL,'I, raw','ESO 374- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64935,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64935,31.75,0.32,22.4,22907,85,NULL,'I, inv','ESO 374- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64936,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64936,32.03,0.43,25.4,22907,75,NULL,'MAT, I, raw','ESO 374- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64937,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64937,32.11,0.43,26.4,22907,75,NULL,'MAT, I, inv','ESO 374- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64938,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64938,32.2,0.2,27.5,22907,74.4,NULL,NULL,'ESO 374- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64939,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64939,32.36,0.43,29.6,22907,75,NULL,'3.6 micron, color corrected','ESO 374- G 003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64940,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64940,32.45,0.43,30.8,22907,75,NULL,'MAT, I, cor','ESO 374- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64941,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64941,32.52,0.43,32,22907,75,NULL,'3.6 micron, color + selection bias corrected','ESO 374- G 003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64942,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64942,33.13,0.4,42.3,22907,NULL,NULL,'mean','ESO 374- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64943,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64943,33.33,0.11,46.4,22907,NULL,NULL,NULL,'ESO 374- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64944,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64944,33.41,0.47,48,22907,NULL,NULL,'H','ESO 374- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64945,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64945,33.5,0.46,50.2,22907,NULL,NULL,'J','ESO 374- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64946,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64946,37.52,0.46,319,22908,70,NULL,NULL,'2MASX J09515746+1324033',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,147.9895,13.401,0.041,NULL,60824768436,950387006,14849796,17.1),(64947,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64947,38.45,0.46,490,22909,70,NULL,NULL,'SDSS J095158.11+253803.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000137,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,147.992125,25.63428,0.029,NULL,64165938249,1002592785,15665512,18.5),(64948,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64948,35.1,0.46,105,22910,70,NULL,NULL,'2MASX J09515953+6940584',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000087,NULL,'15.90',0.47,NULL,NULL,NULL,NULL,NULL,1,147.998333,69.68297,0.217,NULL,62100569166,970321393,15161271,15.9),(64949,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64949,37.78,0.21,360,22911,70,NULL,NULL,'2MASX J09515993+0605399',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,147.9997917,6.09436,0.029,NULL,60924364432,951943194,14874112,17.8),(64950,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64950,38.33,0.46,463,22912,70,NULL,NULL,'SDSS J095200.17+111023.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000142,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,148.000708333,11.17319,0.033,NULL,60897057960,951516530,14867445,18.5),(64951,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64951,37.6,0.46,331,22913,70,NULL,NULL,'2MASX J09520057+6056079',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,148.00225,60.9355,0.057,NULL,61922660158,967541564,15117836,17),(64952,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64952,38.01,0.46,400,22914,70,NULL,NULL,'2MASX J09520250+0158259',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000076,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,148.010541667,1.97367,0.145,NULL,60769600736,949525011,14836328,18.7),(64953,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64953,34.68,0.49,86.5,22915,70,NULL,NULL,'2MASX J09520444-0459481',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000127,NULL,'15.71',NULL,NULL,NULL,NULL,NULL,NULL,1,148.0185,-4.99683,0.117,NULL,41301757401,645339959,10083436,15.71),(64954,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64954,36.41,0.46,192,22916,70,NULL,NULL,'2MASX J09520450+0612332',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000189,NULL,'15.9g',0.33,'E0',NULL,NULL,NULL,NULL,1,148.018833,6.20931,0.029,NULL,60932758374,952074349,14876161,15.9),(64955,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64955,35.56,0.48,129,22917,70,NULL,NULL,'2MASX J09520478-1608102',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00012,NULL,'13.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,148.019917,-16.13619,0.197,NULL,41179530441,643430163,10053596,13.2),(64956,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64956,38.01,0.46,400,22918,70,NULL,NULL,'SDSS J095205.87+435551.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,148.0244583,43.93103,0,NULL,63987206726,999800105,15621876,18.1),(64957,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64957,36.9,0.46,240,22919,70,NULL,NULL,'2MASX J09520660+3821074',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000186,NULL,'16.0g',0.44,NULL,NULL,NULL,NULL,NULL,1,148.0275,38.35219,0.025,NULL,64059274075,1000926157,15639471,16),(64958,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64958,36.39,0.46,190,22920,70,NULL,NULL,'2MASX J09520766+3449416',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000177,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,148.032041667,34.82819,0,NULL,64183248496,1002863257,15669738,16.9),(64959,'SBF','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64959,31.55,0.28,20.4,22921,NULL,NULL,'I','NGC 3032',NULL,'2003ApJ...583..712J',2003,1,2,NULL,'G',0.000017,NULL,'13.00',1.8,'SAB(r)0^0^     HII','in a radial-velocity based grouping',NULL,NULL,'H II',1,148.0339583,29.23622,0.021,NULL,64162174858,1002533982,15664593,13),(64960,'SBF','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64960,31.71,0.14,22,22921,74.4,NULL,NULL,'NGC 3032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64961,'SBF','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64961,31.71,0.28,22,22921,NULL,NULL,'I','NGC 3032',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64962,'Ring Diameter','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64962,33.2,0.84,43,22921,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3032',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64963,'Faber-Jackson','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64963,25.83,1.31,1.47,22921,95,NULL,'Weighted Mean','NGC 3032',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64964,'Faber-Jackson','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64964,25.83,1.61,1.47,22921,55,NULL,'Visvanathan & Sandage 1979','NGC 3032',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64965,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64965,31.81,0.45,23,22921,NULL,NULL,'K','NGC 3032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64966,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64966,31.94,0.4,24.4,22921,NULL,NULL,'mean','NGC 3032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64967,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64967,31.94,0.4,24.5,22921,75,NULL,'B','NGC 3032',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64968,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64968,37.78,0.46,360,22922,70,NULL,NULL,'2MASX J09520818+1824342',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,148.034166667,18.40953,0.057,NULL,63740879265,995951238,15561738,18.1),(64969,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64969,37.68,0.46,343,22923,70,NULL,NULL,'2MASX J09521082+2512395',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000172,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,148.04525,25.21089,0.049,NULL,64166463955,1002600999,15665640,16.8),(64970,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64970,37.09,0.21,261,22924,70,NULL,NULL,'2MASX J09521118+0110439',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000069,NULL,'16.8g',0.26,'NLAGN',NULL,NULL,NULL,NULL,1,148.046667,1.17889,0.117,NULL,60771184525,949549758,14836714,16.8),(64971,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64971,35.35,0.46,118,22925,70,NULL,NULL,'2MASX J09521195+0412529',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000162,NULL,'16.0g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,148.049875,4.21456,0.073,NULL,60916267770,951816683,14872135,16),(64972,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64972,38.08,0.46,413,22926,70,NULL,NULL,'2MASX J09521426+2411035',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000167,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,148.059417,24.18431,0.057,NULL,63692781702,995199714,15549995,17.3),(64973,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64973,34.86,0.71,93.7,22927,70,NULL,NULL,'2MASX J09521506-0944019',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.52',NULL,NULL,NULL,NULL,NULL,NULL,1,148.06275,-9.73403,0.121,NULL,41329542248,645774097,10090220,15.52),(64974,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64974,36.85,0.46,234,22928,70,NULL,NULL,'2MASX J09521740+2229262',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,148.0724583,22.4905,0.057,NULL,63702424912,995350389,15552349,18),(64975,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64975,34.89,0.46,94.9,22929,70,NULL,NULL,'UGC 05294',NULL,'2015arXiv151105856S',2015,1,0.86,NULL,'G',0.000087,NULL,'14.8g',0.53,'JET?',NULL,NULL,NULL,NULL,1,148.0737083,33.06372,0,NULL,64184740952,1002886577,15670102,14.8),(64976,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64976,37.78,0.21,360,22930,70,NULL,NULL,'2MASX J09521877+0559249',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000143,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,148.078291667,5.99017,0.041,NULL,60906592140,951665502,14869773,17.6),(64977,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64977,36.76,0.46,224,22931,70,NULL,NULL,'2MASX J09521904+1344345',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.73',0.46,NULL,NULL,NULL,NULL,NULL,1,148.0795,13.74292,0.041,NULL,60822971111,950358923,14849358,16.73),(64978,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64978,37.69,0.46,345,22932,70,NULL,NULL,'2MASX J09522012+2738259',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,148.0837083,27.64072,0.033,NULL,64169666144,1002651033,15666422,17.5),(64979,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64979,35.55,0.55,129,22933,70,NULL,NULL,'2MASX J09522058-1555209',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,148.0857917,-15.92258,0.149,NULL,41178761759,643418152,10053408,15.2),(64980,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64980,36.4,0.46,191,22934,70,NULL,NULL,'2MASX J09522091+0058130',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000109,NULL,'15.7g',0.46,NULL,NULL,NULL,NULL,NULL,1,148.0872917,0.97031,0.097,NULL,60771095878,949548373,14836693,15.7),(64981,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64981,36.64,0.46,213,22935,70,NULL,NULL,'2MASX J09522146+2547519',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,148.0892917,25.79786,0.029,NULL,64165957308,1002593082,15665516,17.3),(64982,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64982,37.34,0.46,294,22936,70,NULL,NULL,'2MASX J09522178+6155168',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000085,NULL,'16.9g',0.24,'NLAGN',NULL,NULL,NULL,NULL,1,148.090833,61.92136,0.069,NULL,62028466063,969194782,15143668,16.9),(64983,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64983,38,0.46,398,22937,70,NULL,NULL,'2MASX J09522326+0842262',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000176,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,148.0967917,8.70719,0.053,NULL,60932721151,952073767,14876152,17.7),(64984,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64984,37.12,0.33,265,22938,70,NULL,NULL,'SDSS J095223.62+361720.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000171,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,148.0984583,36.28889,0.013,NULL,64174968710,1002733886,15667716,18),(64985,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64985,37.16,0.46,270,22939,70,NULL,NULL,'2MASX J09522436+2043142',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000146,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,148.1015417,20.72056,0.045,NULL,63697913921,995279905,15551248,17.4),(64986,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64986,37.12,0.33,265,22940,70,NULL,NULL,'2MASX J09522508+3615583',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000219,NULL,'16.0g',0.41,'E0',NULL,NULL,NULL,NULL,1,148.104583,36.26608,0.013,NULL,64174967501,1002733867,15667716,16),(64987,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64987,35.82,0.61,146,22941,70,NULL,NULL,'ESO 566- G 021',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.56',0.5,'S0:',NULL,NULL,NULL,NULL,1,148.108875,-19.48933,0.121,NULL,42283252033,660675813,10323059,15.56),(64988,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64988,35.76,0.5,142,22942,70,NULL,NULL,'CGCG 007-050',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'15.6',0.21,NULL,NULL,NULL,NULL,NULL,1,148.115125,-2.41097,0.053,NULL,41222807079,644106360,10064161,15.6),(64989,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64989,37.49,0.33,314,22943,70,NULL,NULL,'2MASX J09522837+5850275',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000069,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,148.117875,58.84108,0.021,NULL,61914033850,967406778,15115730,17.2),(64990,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64990,34.03,0.47,63.9,22944,NULL,NULL,'H','NGC 3039',NULL,'2007A&A...465...71T',2007,1,1.29,NULL,'G',0.000023,NULL,'14.0g',0.68,'SAB(s)b pec:',NULL,NULL,NULL,NULL,1,148.123625,2.15444,0.085,NULL,60770154818,949533669,14836463,14),(64991,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64991,34.11,0.46,66.2,22944,NULL,NULL,'J','NGC 3039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64992,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64992,34.13,0.45,67,22944,NULL,NULL,'K','NGC 3039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64993,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64993,34.38,0.4,75.1,22944,NULL,NULL,'mean','NGC 3039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64994,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64994,35.95,0.46,155,22945,70,NULL,NULL,'2MASX J09523012+5158184',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00016,NULL,'16.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,148.125417,51.97172,0,NULL,64012767256,1000199488,15628117,16.1),(64995,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64995,37.49,0.33,314,22946,70,NULL,NULL,'2MASX J09523073+5856505',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000077,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,148.127833,58.94728,0.021,NULL,61914067730,967407308,15115739,17.5),(64996,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64996,37.86,0.33,373,22947,70,NULL,NULL,'2MASX J09523138+0012069',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000084,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,148.1309583,0.20183,0.081,NULL,60768900070,949514063,14836157,17.7),(64997,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64997,37.49,0.33,315,22948,70,NULL,NULL,'2MASX J09523193+2033169',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000208,NULL,'15.9g',0.42,NULL,NULL,NULL,NULL,NULL,1,148.133083,20.55489,0.049,NULL,63698779072,995293423,15551459,15.9),(64998,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',64998,37.86,0.33,373,22949,70,NULL,NULL,'2MASX J09523224+0014089',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000082,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,148.1345,0.23581,0.081,NULL,60768902685,949514104,14836157,17.1),(64999,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,64999,35.15,0.51,107,22950,70,NULL,NULL,'2MASX J09523299-2153171',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.86',NULL,NULL,NULL,NULL,NULL,NULL,1,148.1375,-21.88833,0.101,NULL,42291872496,660810507,10325164,15.86),(65000,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65000,37.55,0.33,323,22951,70,NULL,NULL,'2MASX J09523450+0146139',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000082,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,148.143875,1.77058,0.105,NULL,60770015810,949531497,14836429,17.3),(65001,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65001,33.91,NULL,60.6,22952,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 435- G 004',NULL,'2010Ap&SS.325..163P',2010,1,1.66,NULL,'G',0.00006,NULL,'16.60',0.13,'Sc',NULL,NULL,NULL,NULL,1,148.15,-29.06889,0.261,NULL,42826902034,669170344,10455786,16.6),(65002,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65002,33.93,NULL,61,22952,NULL,NULL,'Dipole + Quadrupole','ESO 435- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65003,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65003,33.94,NULL,61.3,22952,NULL,NULL,'Dipole','ESO 435- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65004,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65004,35.4,0.46,120,22953,70,NULL,NULL,'CGCG 063-092',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00017,NULL,'14.9',0.4,NULL,NULL,NULL,NULL,NULL,1,148.151167,9.88203,0.033,NULL,60928400453,952006257,14875097,14.9),(65005,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65005,37.87,0.46,374,22954,70,NULL,NULL,'SDSS J095236.92+250613.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000127,NULL,'18.2g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,148.153875,25.10375,0.049,NULL,64165711289,1002589238,15665456,18.2),(65006,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65006,33.98,0.47,62.5,22955,70,NULL,NULL,'MCG -01-25-054',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000107,NULL,'14',0.5,NULL,NULL,NULL,NULL,NULL,1,148.156166667,-7.62056,0.149,NULL,41338167786,645908871,10092326,14),(65007,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65007,38.1,0.46,416,22956,70,NULL,NULL,'2MASX J09523764+0018320',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000084,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,148.15675,0.30883,0.081,NULL,60768858703,949513417,14836147,17.2),(65008,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65008,38.21,0.46,439,22957,70,NULL,NULL,'2MASX J09523813+0529529',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000166,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,148.1589583,5.49794,0.049,NULL,60906607818,951665747,14869777,17.4),(65009,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65009,37.56,0.46,324,22958,70,NULL,NULL,'2MASX J09524018+0031490',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000101,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,148.167458333,0.53042,0.081,NULL,60768842514,949513164,14836143,16.5),(65010,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65010,37.55,0.33,323,22959,70,NULL,NULL,'2MASX J09524023+0142470',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000089,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,148.1677083,1.71322,0.089,NULL,60770019549,949531555,14836430,17.8),(65011,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65011,38.15,0.33,426,22960,70,NULL,NULL,'2MASX J09524110+0142230',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000093,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,148.171125,1.70644,0.089,NULL,60770019435,949531553,14836430,17.2),(65012,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65012,34.89,NULL,95.2,22961,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0958',NULL,'2010Ap&SS.325..163P',2010,1,1.03,NULL,'G',0.000104,NULL,'16.8g',0.13,'Sd',NULL,NULL,NULL,NULL,1,148.1760417,42.8785,0,NULL,63972665567,999572899,15618326,16.8),(65013,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65013,34.92,NULL,96.2,22961,NULL,NULL,'Dipole + Quadrupole','FGC 0958',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65014,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65014,34.93,NULL,96.8,22961,NULL,NULL,'Dipole','FGC 0958',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65015,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65015,34.97,NULL,98.5,22961,NULL,NULL,NULL,'FGC 0958',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65016,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65016,37.22,0.33,279,22962,70,NULL,NULL,'2MASX J09524478+4045455',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000155,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,148.186791667,40.76278,0,NULL,64092482116,1001445033,15647578,17.1),(65017,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65017,37.89,0.46,379,22963,70,NULL,NULL,'2MASX J09524495+2622450',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,148.1874583,26.37914,0.029,NULL,64170290055,1002660782,15666574,17.9),(65018,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65018,36.59,0.46,208,22964,70,NULL,NULL,'2MASX J09524769+3917426',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,148.198667,39.29531,0.013,NULL,64056175768,1000877746,15638714,17.4),(65019,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65019,37.76,0.46,356,22965,70,NULL,NULL,'2MASX J09524921+6343428',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000083,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,148.204833,63.72847,0.121,NULL,62247093844,972610841,15197044,17.6),(65020,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65020,38.02,0.46,402,22966,70,NULL,NULL,'2MASX J09525024+0737492',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,148.209167,7.63044,0.025,NULL,60933873800,952091778,14876434,17.3),(65021,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65021,37.09,0.46,262,22967,70,NULL,NULL,'2MASXi J0952503+434305',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,148.209708333,43.71817,0,NULL,63987165140,999799455,15621866,17.6),(65022,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65022,37.6,0.46,331,22968,70,NULL,NULL,'SDSS J095251.42-010006.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000075,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,148.21425,-1.00169,0.089,NULL,41224859454,644138428,10064662,18.4),(65023,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65023,36.68,0.46,217,22969,70,NULL,NULL,'2MASX J09525158+3502482',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000187,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,148.2149583,35.04664,0.005,NULL,64182486714,1002851354,15669552,16.3),(65024,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65024,36.93,0.46,244,22970,70,NULL,NULL,'2MASX J09525252+2122269',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000167,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,148.218875,21.37425,0.045,NULL,63697354576,995271165,15551111,16.8),(65025,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65025,37.6,0.33,330,22971,70,NULL,NULL,'SDSS J095252.62+130704.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00017,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,148.2192917,13.11803,0.037,NULL,60825719131,950401861,14850029,18.2),(65026,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65026,36.82,0.46,231,22972,70,NULL,NULL,'2MASX J09525353+5350533',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000183,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,148.2229583,53.84831,0,NULL,63992561501,999883773,15623183,16.7),(65027,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65027,34.14,0.47,67.3,22973,NULL,NULL,'H','UGC 05295',NULL,'2007A&A...465...71T',2007,1,1.36,NULL,'G',0.000007,NULL,'13.9g',1.03,'SAB(s)b','in a radial-velocity based grouping',NULL,NULL,NULL,1,148.2265,42.84803,0,NULL,63972660730,999572823,15618325,13.9),(65028,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65028,34.21,0.4,69.4,22973,NULL,NULL,'mean','UGC 05295',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65029,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65029,34.23,0.2,70.2,22973,74.4,NULL,NULL,'UGC 05295',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65030,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65030,34.24,0.56,70.4,22973,NULL,NULL,NULL,'UGC 05295',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65031,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65031,34.25,0.45,70.8,22973,NULL,NULL,'K','UGC 05295',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65032,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65032,34.25,0.46,70.8,22973,NULL,NULL,'J','UGC 05295',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65033,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65033,34.36,0.53,74.5,22973,NULL,NULL,'Malmquist cor.','UGC 05295',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65034,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65034,38.33,0.33,463,22974,70,NULL,NULL,'2MASX J09525442+1822069',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000152,NULL,'17.2g',0.22,'BrClG',NULL,NULL,NULL,NULL,1,148.226667,18.3685,0.077,NULL,63740897822,995951528,15561742,17.2),(65035,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65035,36.47,0.6,196,22975,70,NULL,NULL,'2MASX J09525466-1552063',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.1I',0.3,NULL,NULL,NULL,NULL,NULL,1,148.22775,-15.86847,0.193,NULL,41177331222,643395800,10053059,14.1),(65036,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65036,36.26,0.46,179,22976,70,NULL,NULL,'2MASX J09525648+4044186',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000168,NULL,'16.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,148.235417,40.73858,0,NULL,64092489675,1001445151,15647580,16.5),(65037,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65037,37.49,0.46,314,22977,70,NULL,NULL,'2MASX J09525705-0047310',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000102,NULL,'16.7g',0.3,'BrClG          AGN',NULL,NULL,NULL,NULL,1,148.237667,-0.79197,0.089,NULL,41224831966,644137999,10064656,16.7),(65038,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65038,37.82,0.46,366,22978,70,NULL,NULL,'2MASX J09525734+0538335',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,148.239,5.64269,0.045,NULL,60906624342,951666005,14869781,16.8),(65039,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65039,36,0.46,159,22979,70,NULL,NULL,'2MASX J09525869+0719512',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'16.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,148.244541667,7.33097,0.025,NULL,60933564443,952086944,14876358,16.9),(65040,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65040,38.26,0.46,449,22980,70,NULL,NULL,'2MASX J09525923+3512012',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,148.246541667,35.20033,0.009,NULL,64182544509,1002852257,15669566,17.9),(65041,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65041,38.33,0.33,463,22981,70,NULL,NULL,'2MASX J09530049+1825471',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,148.252083,18.42986,0.077,NULL,63740864774,995951012,15561734,18.4),(65042,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65042,38.3,0.46,457,22982,70,NULL,NULL,'2MASX J09530090+4743183',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,148.2537917,47.72181,0,NULL,64007795517,1000121804,15626903,18),(65043,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65043,37.43,0.46,306,22983,70,NULL,NULL,'2MASX J09530232+6343128',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000073,NULL,'17.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,148.26,63.72011,0.121,NULL,62247093458,972610835,15197044,17.2),(65044,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65044,37.95,0.46,389,22984,70,NULL,NULL,'2MASX J09530248+0638387',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000175,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,148.260375,6.644,0.037,NULL,60932860821,952075950,14876186,17.4),(65045,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65045,35.24,0.46,112,22985,70,NULL,NULL,'2MFGC 07651',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000097,NULL,'13.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,148.2629583,-16.03811,0.197,NULL,41177201659,643393775,10053027,13.7),(65046,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65046,38.15,0.33,426,22986,70,NULL,NULL,'SDSS J095304.59+014256.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000066,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,148.269167,1.71561,0.049,NULL,60769866744,949529167,14836393,18.5),(65047,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65047,37.22,0.33,279,22987,70,NULL,NULL,'2MASX J09530484+4047016',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000143,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,148.270083333,40.78386,0,NULL,64092488129,1001445127,15647580,17.7),(65048,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65048,36.55,0.46,204,22988,70,NULL,NULL,'2MASX J09530531+2237441',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000138,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,148.2720417,22.62897,0.073,NULL,63702391734,995349870,15552341,17.8),(65049,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65049,35.98,0.46,157,22989,70,NULL,NULL,'2MASX J09530664+0642277',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000167,NULL,'16.1g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,148.277583,6.70775,0.033,NULL,60932879668,952076244,14876191,16.1),(65050,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65050,37.6,0.33,330,22990,70,NULL,NULL,'2MASX J09530701+1307157',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000182,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,148.27925,13.12108,0.037,NULL,60825729147,950402017,14850031,17.1),(65051,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65051,30.63,0.69,13.4,22991,100,NULL,'mid-IR','NGC 3041',NULL,'2013ApJ...771...88L',2013,1,3.7,NULL,'G',0.000007,NULL,'12.3',2.4,'SAB(rs)c','Brightest group member',NULL,NULL,NULL,1,148.27975,16.67767,0.077,NULL,60829318038,950458094,14850907,12.3),(65052,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65052,31.79,0.4,22.8,22991,75,NULL,'B','NGC 3041',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65053,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65053,31.88,0.4,23.8,22991,NULL,NULL,NULL,'NGC 3041',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65054,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65054,31.96,0.43,24.7,22991,75,NULL,'3.6 micron, color corrected','NGC 3041',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65055,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65055,31.96,0.43,24.7,22991,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3041',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65056,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65056,32,0.2,25.1,22991,74.4,NULL,NULL,'NGC 3041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65057,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65057,32.11,0.35,26.5,22991,NULL,NULL,'Malmquist cor.','NGC 3041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65058,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65058,32.16,0.34,27.1,22991,NULL,NULL,NULL,'NGC 3041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65059,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65059,32.18,0.47,27.3,22991,NULL,NULL,'H','NGC 3041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65060,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65060,32.19,0.45,27.5,22991,NULL,NULL,'K','NGC 3041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65061,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65061,32.22,0.46,27.8,22991,NULL,NULL,'J','NGC 3041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65062,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65062,32.23,0.4,28,22991,NULL,NULL,'mean','NGC 3041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65063,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65063,37.19,0.46,274,22992,70,NULL,NULL,'2MASX J09530786+1455467',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.78',0.28,NULL,NULL,NULL,NULL,NULL,1,148.2827917,14.92961,0.057,NULL,60830972126,950483939,14851311,17.78),(65064,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65064,34.53,0.46,80.6,22993,70,NULL,NULL,'CGCG 152-078',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000171,NULL,'15.3g',0.4,'E','Isolated galaxy',NULL,NULL,NULL,1,148.2897917,27.62175,0.033,NULL,64169486061,1002648219,15666378,15.3),(65065,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65065,37.83,0.46,369,22994,70,NULL,NULL,'2MASX J09530984+0110375',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000078,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,148.290917,1.17697,0.097,NULL,60770425912,949537904,14836529,17.8),(65066,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65066,35.85,0.46,148,22995,70,NULL,NULL,'MCG +12-10-007',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000107,NULL,'15.4g',0.4,NULL,NULL,NULL,NULL,NULL,1,148.29275,69.00064,0.145,NULL,62126682095,970729407,15167646,15.4),(65067,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65067,37.46,0.46,310,22996,70,NULL,NULL,'2MASX J09531037+0838107',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,148.293166667,8.63633,0.065,NULL,60932423623,952069119,14876079,17.1),(65068,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65068,33.13,NULL,42.3,22997,NULL,NULL,NULL,'FGC 0964',NULL,'2000BSAO...50....5K',2000,1,1.47,NULL,'G',0.000037,NULL,'15.83',0.1,'Sd',NULL,NULL,NULL,NULL,1,148.3,-6.48167,0.177,NULL,41331821322,645809708,10090776,15.83),(65069,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65069,34.56,NULL,81.6,22998,NULL,NULL,NULL,'KUG 0950+453',NULL,'2000BSAO...50....5K',2000,1,1.04,NULL,'G',NULL,NULL,'16.8g',0.15,'Sd',NULL,NULL,NULL,NULL,1,148.3027083,45.14739,0,NULL,63977054443,999641475,15619398,16.8),(65070,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65070,35.06,0.61,103,22999,70,NULL,NULL,'2MASX J09531351-1548403',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.37',0.3,NULL,NULL,NULL,NULL,NULL,1,148.306333333,-15.8115,0.193,NULL,41177381232,643396581,10053071,16.37),(65071,'CMD','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65071,30.4,0.4,12,23000,NULL,NULL,NULL,'GHOSTS 1',NULL,'2014ApJ...780..179M',2014,1,NULL,NULL,'G',NULL,NULL,'20.5g',NULL,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,148.305375,69.50161,0.133,NULL,62096962546,970265039,15160391,20.5),(65072,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65072,35.65,0.49,135,23001,70,NULL,NULL,'MCG -03-25-027',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00011,NULL,'15.5',0.6,'cD',NULL,NULL,NULL,NULL,1,148.310125,-15.97789,0.193,NULL,41177198204,643393721,10053026,15.5),(65073,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65073,37.54,0.46,322,23002,70,NULL,NULL,'2MASX J09531510+0702037',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,148.312833,7.03439,0.029,NULL,60933718050,952089344,14876396,17.2),(65074,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65074,38.09,0.46,416,23003,70,NULL,NULL,'SDSS J095316.50+401326.8',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000143,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,148.318791667,40.22411,0.009,NULL,64089302203,1001395346,15646802,17.9),(65075,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65075,37.53,0.46,320,23004,70,NULL,NULL,'2MASX J09531694+2051321',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,148.320667,20.85903,0.041,NULL,63697957466,995280585,15551259,17.1),(65076,'IRAS','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65076,32.52,0.8,31.9,23005,75,NULL,'MAT, I','NGC 3045',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00002,NULL,'13.61',0.6,'SB(rs)ab:      HII','in a pair',NULL,NULL,NULL,1,148.323583,-18.64511,NULL,NULL,42283021377,660672209,10323003,13.61),(65077,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65077,32.36,0.43,29.7,23005,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3045',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65078,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65078,32.54,0.43,32.3,23005,75,NULL,'3.6 micron, color corrected','NGC 3045',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65079,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65079,32.74,0.32,35.3,23005,85,NULL,'I, raw','NGC 3045',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65080,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65080,32.76,0.32,35.6,23005,85,NULL,'I, inv','NGC 3045',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65081,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65081,32.79,0.2,36.1,23005,74.4,NULL,NULL,'NGC 3045',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65082,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65082,32.86,0.4,37.3,23005,NULL,NULL,'mean','NGC 3045',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65083,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65083,33.09,0.47,41.5,23005,NULL,NULL,'H','NGC 3045',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65084,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65084,33.1,0.43,41.6,23005,75,NULL,'MAT, I, raw','NGC 3045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65085,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65085,33.1,0.46,41.7,23005,NULL,NULL,'J','NGC 3045',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65086,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65086,33.13,0.5,42.2,23005,NULL,NULL,NULL,'NGC 3045',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65087,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65087,33.16,0.45,42.9,23005,NULL,NULL,'K','NGC 3045',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65088,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65088,33.22,0.48,44,23005,NULL,NULL,'Malmquist cor.','NGC 3045',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65089,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65089,33.22,0.43,44.1,23005,75,NULL,'MAT, I, inv','NGC 3045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65090,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65090,33.44,0.43,48.7,23005,75,NULL,'MAT, I, cor','NGC 3045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65091,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65091,37.21,0.46,276,23006,70,NULL,NULL,'2MASX J09531816+2629131',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000198,NULL,'16.99',0.39,NULL,NULL,NULL,NULL,NULL,1,148.3257083,26.48692,0.041,NULL,64170267055,1002660422,15666569,16.99),(65092,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65092,37.76,0.46,356,23007,70,NULL,NULL,'2MASX J09531834+2954282',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000181,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,148.3264583,29.90772,0.025,NULL,64217187361,1003393552,15678024,17.6),(65093,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65093,36.31,0.33,182,23008,70,NULL,NULL,'2MASX J09531865+3445532',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00008,NULL,'15.4g',0.56,NULL,NULL,NULL,NULL,NULL,1,148.327667,34.76475,0.005,NULL,64183161235,1002861894,15669717,15.4),(65094,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65094,36.74,0.46,223,23009,70,NULL,NULL,'2MASX J09531866+0748067',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,148.327875,7.80181,0.037,NULL,60933922843,952092544,14876446,17.1),(65095,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65095,37.36,0.46,297,23010,70,NULL,NULL,'SDSS J095318.86+005640.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000076,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,148.328625,0.94469,0.073,NULL,60770358784,949536856,14836513,18.2),(65096,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65096,33.64,0.49,53.5,23011,NULL,NULL,NULL,'UGC 05301',NULL,'2009ApJS..182..474S',2009,1,1.46,NULL,'G',0.000027,NULL,'16.0',0.16,'Sd',NULL,NULL,NULL,NULL,1,148.337125,42.84436,0,NULL,63972778111,999574657,15618354,16),(65097,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65097,33.68,0.2,54.5,23011,74.4,NULL,NULL,'UGC 05301',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65098,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65098,33.76,0.49,56.6,23011,75,NULL,'IR','UGC 05301',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65099,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65099,33.97,0.42,62.1,23011,NULL,NULL,'Malmquist cor.','UGC 05301',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65100,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65100,34.3,NULL,72.5,23011,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05301',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65101,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65101,34.31,NULL,72.9,23011,NULL,NULL,'Dipole + Quadrupole','UGC 05301',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65102,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65102,34.32,NULL,73.1,23011,NULL,NULL,'Dipole','UGC 05301',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65103,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65103,34.37,NULL,74.7,23011,NULL,NULL,NULL,'UGC 05301',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65104,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65104,37.3,0.33,289,23012,70,NULL,NULL,'2MASX J09532181+0623077',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000151,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,148.340833,6.38539,0.041,NULL,60924586119,951946658,14874166,17.7),(65105,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65105,38.1,0.33,417,23013,70,NULL,NULL,'2MASX J09532237+3402291',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,148.34325,34.04122,0,NULL,64183001198,1002859393,15669678,17.9),(65106,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65106,35.41,0.56,121,23014,70,NULL,NULL,'2MASX J09532250-1601447',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,148.343833,-16.02908,0.193,NULL,41177241411,643394397,10053037,16.1),(65107,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65107,38.24,0.33,445,23015,70,NULL,NULL,'2MASX J09532404+1833030',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000149,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,148.350166667,18.55089,0.077,NULL,63694749375,995230458,15550475,17.5),(65108,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65108,37.93,0.46,385,23016,70,NULL,NULL,'2MASX J09532408+2323510',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,148.350417,23.39761,0.053,NULL,63701466071,995335407,15552115,18.2),(65109,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65109,36.78,0.63,227,23017,70,NULL,NULL,'2MASX J09532425-0548302',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00015,NULL,'15.53',0.36,NULL,NULL,NULL,NULL,NULL,1,148.351083333,-5.80847,0.129,NULL,41299421014,645303453,10082866,15.53),(65110,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65110,37.83,0.33,369,23018,70,NULL,NULL,'SDSS J095325.77+615814.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000067,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,148.357375,61.97072,0.069,NULL,62027812029,969184562,15143508,18.3),(65111,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65111,37.83,0.33,369,23019,70,NULL,NULL,'SDSS J095326.52+620124.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00007,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,148.360541667,62.02342,0.069,NULL,62027821376,969184709,15143511,18.3),(65112,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65112,38.31,0.46,458,23020,70,NULL,NULL,'2MASX J09532756+1714382',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,148.3647917,17.24419,0.073,NULL,60826694477,950417101,14850267,17.9),(65113,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65113,36.05,0.63,162,23021,70,NULL,NULL,'2MASX J09532805-1603587',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.49',0.3,NULL,NULL,NULL,NULL,NULL,1,148.36675,-16.0665,0.197,NULL,41177248753,643394511,10053039,16.49),(65114,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65114,37.35,0.46,295,23022,70,NULL,NULL,'2MASX J09532951+6358187',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000082,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,148.373375,63.97189,0.133,NULL,62247058710,972610292,15197035,16.6),(65115,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65115,37.3,0.33,289,23023,70,NULL,NULL,'2MASX J09532997+0622096',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000178,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,148.374833333,6.36944,0.041,NULL,60924618162,951947158,14874174,16.6),(65116,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65116,37.37,0.46,298,23024,70,NULL,NULL,'2MASX J09533047+0026546',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000106,NULL,'16.2g',0.41,'AGN',NULL,NULL,NULL,NULL,1,148.3767917,0.44864,0.081,NULL,60769154468,949518038,14836219,16.2),(65117,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65117,34.89,0.55,95.1,23025,70,NULL,NULL,'2MASX J09533174-0613171',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.38',0.39,NULL,NULL,NULL,NULL,NULL,1,148.382333333,-6.22169,0.149,NULL,41331944480,645811632,10090806,16.38),(65118,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65118,37.66,0.46,341,23026,70,NULL,NULL,'2MASX J09533238-0056292',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000077,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,148.3849583,-0.94147,0.093,NULL,41224429798,644131715,10064558,17.9),(65119,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65119,33.75,0.4,56.2,23027,NULL,NULL,'mean','ESO 566- G 024',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000023,NULL,'13.58',1.3,'(R\'_1)SB(r)b   HII',NULL,NULL,NULL,NULL,1,148.3892083,-19.58317,0.117,NULL,42283602795,660681293,10323145,13.58),(65120,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65120,34.6,0.46,83.2,23027,NULL,NULL,'J','ESO 566- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65121,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65121,34.6,0.47,83.3,23027,NULL,NULL,'H','ESO 566- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65122,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65122,34.62,0.45,83.8,23027,NULL,NULL,'K','ESO 566- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65123,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65123,37.54,0.46,323,23028,70,NULL,NULL,'SDSS J095333.63+025817.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000059,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,148.390167,2.97161,0.045,NULL,60902348569,951599196,14868737,18.4),(65124,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65124,38.11,0.23,419,23029,70,NULL,NULL,'SDSS J095334.29+014209.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000084,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,148.392917,1.70258,0.049,NULL,60769870408,949529225,14836394,18.5),(65125,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65125,38.98,0.46,626,23030,70,NULL,NULL,'2MASX J09533457+3244081',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000206,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,148.394167,32.73553,0.021,NULL,64181958041,1002843094,15669423,18.2),(65126,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65126,36.92,0.46,242,23031,70,NULL,NULL,'SDSS J095334.84+091032.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000174,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,148.3952083,9.17569,0.049,NULL,60927922095,951998782,14874980,17.8),(65127,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65127,35.35,0.27,118,23032,70,NULL,NULL,'KUG 0950+526',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000113,NULL,'15.2g',0.57,'Spiral',NULL,NULL,NULL,NULL,1,148.397083,52.41436,0,NULL,64010056959,1000157139,15627455,15.2),(65128,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65128,35.29,0.45,114,23033,NULL,NULL,'K','NGC 3058',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'GPair',0.00003,NULL,NULL,NULL,'S0+ pec:',NULL,NULL,NULL,NULL,1,148.3989583,-12.48156,0.113,NULL,41183386188,643490409,10054537,NULL),(65129,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65129,35.31,0.4,115,23033,NULL,NULL,'mean','NGC 3058',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65130,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65130,35.38,0.47,119,23033,NULL,NULL,'H','NGC 3058',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65131,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65131,35.48,0.46,125,23033,NULL,NULL,'J','NGC 3058',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65132,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65132,35.85,0.2,148,23034,74.4,NULL,NULL,'CGCG 063-095',NULL,'2013AJ....146...86T',2013,1,0.64,NULL,'G',0.000103,NULL,'15.9g',0.3,'Sb',NULL,NULL,NULL,NULL,1,148.404625,12.12925,0.041,NULL,60893222979,951456609,14866509,15.9),(65133,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65133,38.24,0.33,445,23035,70,NULL,NULL,'SDSS J095337.59+182501.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00011,NULL,'18.7g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,148.406667,18.41706,0.077,NULL,63694755348,995230552,15550477,18.7),(65134,'SGRB','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65134,42.71,NULL,3480,23036,70,NULL,'Photometric Distance, Host A, M(R) = -20 mag and spectral slope Beta = 1.0 ','GRB 061102',NULL,'2012A&A...545A..77R',2012,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,148.407667,-17.02403,0.169,NULL,41175953961,643374280,10052723,NULL),(65135,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65135,38.13,0.33,422,23037,70,NULL,NULL,'2MASX J09533800+0035196',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000109,NULL,'17.2g',0.23,'BrClG',NULL,NULL,NULL,NULL,1,148.408333,0.58875,0.053,NULL,60768963916,949515061,14836172,17.2),(65136,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65136,37.71,0.46,349,23038,70,NULL,NULL,'2MASX J09533823+1639352',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,148.4092083,16.65975,0.077,NULL,60829222608,950456603,14850884,NULL),(65137,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65137,37.74,0.46,353,23039,70,NULL,NULL,'2MASX J09533838+2424050',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,148.409917,24.40144,0.065,NULL,63692821397,995200334,15550005,18),(65138,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65138,38.1,0.33,417,23040,70,NULL,NULL,'SDSS J095339.29+335724.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,148.41375,33.95692,0,NULL,64185013601,1002890837,15670169,18.3),(65139,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65139,38.38,0.46,474,23041,70,NULL,NULL,'SDSS J095339.55+033559.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,148.4147917,3.59986,0.065,NULL,60916048007,951813250,14872082,18.2),(65140,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65140,36.31,0.33,182,23042,70,NULL,NULL,'2MASX J09533957+3447541',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000089,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,148.4150417,34.79853,0.005,NULL,64183203210,1002862550,15669727,16.9),(65141,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65141,35.9,0.46,151,23043,70,NULL,NULL,'CGCG 035-079',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00008,NULL,'15.6g',0.46,'E0',NULL,NULL,NULL,NULL,1,148.417,3.48358,0.049,NULL,60916087612,951813868,14872091,15.6),(65142,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65142,38.11,0.23,419,23044,70,NULL,NULL,'2MASX J09534026+0144226',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000074,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,148.4177083,1.73967,0.049,NULL,60769899244,949529675,14836401,17.8),(65143,'Tully est','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65143,31.57,0.8,20.6,23045,75,NULL,'B','NGC 3044',NULL,'1988NBGC.C....0000T',1988,1,5.71,NULL,'G',0.000018,NULL,'12.46',0.63,'SB(s)c? sp     HII','Group member of poor cluster',NULL,NULL,NULL,1,148.420333,1.57964,0.045,NULL,60769847227,949528862,14836388,12.46),(65144,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65144,31.18,0.4,17.2,23045,75,NULL,NULL,'NGC 3044',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65145,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65145,31.18,0.39,17.2,23045,73,NULL,'IR','NGC 3044',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65146,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65146,31.49,0.44,19.8,23045,NULL,NULL,'Malmquist cor.','NGC 3044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65147,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65147,31.51,0.44,20,23045,NULL,NULL,NULL,'NGC 3044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65148,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65148,31.53,0.2,20.2,23045,74.4,NULL,NULL,'NGC 3044',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65149,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65149,31.62,0.43,21.1,23045,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3044',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65150,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65150,31.65,0.43,21.4,23045,75,NULL,'3.6 micron, color corrected','NGC 3044',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65151,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65151,31.68,0.4,21.7,23045,NULL,NULL,NULL,'NGC 3044',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65152,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65152,31.89,0.4,23.8,23045,NULL,NULL,'mean','NGC 3044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65153,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65153,31.89,NULL,23.8,23045,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 3044',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65154,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65154,31.89,NULL,23.9,23045,NULL,NULL,'Dipole','NGC 3044',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65155,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65155,31.9,NULL,24,23045,NULL,NULL,'Dipole + Quadrupole','NGC 3044',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65156,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65156,31.97,0.46,24.8,23045,NULL,NULL,'J','NGC 3044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65157,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65157,32.01,0.47,25.2,23045,NULL,NULL,'H','NGC 3044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65158,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65158,32.02,0.49,25.4,23045,75,NULL,'IR','NGC 3044',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65159,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65159,32.05,NULL,25.7,23045,NULL,NULL,NULL,'NGC 3044',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65160,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65160,32.11,0.45,26.4,23045,NULL,NULL,'K','NGC 3044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65161,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65161,35.35,0.27,118,23046,70,NULL,NULL,'SBS 0950+527',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000164,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,148.421875,52.50042,0,NULL,64010058045,1000157156,15627455,16.3),(65162,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65162,38.11,0.23,419,23047,70,NULL,NULL,'2MASX J09534139+0142026',NULL,'2015arXiv151105856S',2015,1,0.68,'2008A&A...477..735C identify the XBS XrayS with the Gclstr SDSS-C4-DR3 1212.','G',0.00011,NULL,'16.0g',0.41,'BrClG          AGN',NULL,NULL,NULL,NULL,1,148.422417,1.70064,0.049,NULL,60769918991,949529984,14836406,16),(65163,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65163,36.8,0.33,229,23048,70,NULL,NULL,'2MASX J09534155+4240494',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000169,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,148.423125,42.68044,0.005,NULL,63972777556,999574649,15618353,16.6),(65164,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65164,38.11,0.46,419,23049,70,NULL,NULL,'2MASX J09534166+1322402',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,148.4235417,13.37778,0.037,NULL,60825618954,950400296,14850004,17.5),(65165,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65165,38.13,0.33,422,23050,70,NULL,NULL,'SDSS J095343.12+003959.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000082,NULL,'18.4g',0.15,'NLAGN',NULL,NULL,NULL,NULL,1,148.4297083,0.6665,0.053,NULL,60768956467,949514944,14836171,18.4),(65166,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65166,36.74,0.33,222,23051,70,NULL,NULL,'SDSS J095344.51+262843.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,148.4355,26.47875,0.041,NULL,64170277806,1002660590,15666571,17.9),(65167,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65167,37.52,0.33,319,23052,70,NULL,NULL,'2MASX J09534572-0048123',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000075,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,148.440583,-0.80353,0.089,NULL,41224425984,644131656,10064557,17.5),(65168,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65168,37.92,0.46,384,23053,70,NULL,NULL,'SDSS J095346.33+381752.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000143,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,148.443083,38.29803,0.049,NULL,64059364258,1000927566,15639493,18.2),(65169,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65169,35.7,0.46,138,23054,70,NULL,NULL,'2MASX J09534694+1943349',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000167,NULL,'15.8g',0.4,NULL,NULL,NULL,NULL,NULL,1,148.445583333,19.72647,0.065,NULL,63695370182,995240159,15550627,15.8),(65170,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65170,37.16,0.46,270,23055,70,NULL,NULL,'2MASX J09534703+1106487',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00016,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,148.446166667,11.11344,0.037,NULL,60893581106,951462204,14866596,17),(65171,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65171,37.24,0.46,281,23056,70,NULL,NULL,'2MASX J09534734+0542216',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000136,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,148.447208333,5.70594,0.049,NULL,60907407042,951678235,14869972,18.2),(65172,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65172,36.8,0.33,229,23057,70,NULL,NULL,'2MASX J09534789+4244295',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'16.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,148.449417,42.74161,0,NULL,63972831305,999575489,15618367,16.8),(65173,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65173,36.38,0.46,189,23058,70,NULL,NULL,'SDSS J095347.92+101420.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,148.449666667,10.23908,0.033,NULL,60928258569,952004040,14875063,17.4),(65174,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65174,35.47,0.48,124,23059,70,NULL,NULL,'2MASX J09534799-1441216',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.95',NULL,NULL,NULL,NULL,NULL,NULL,1,148.450167,-14.68933,0.165,NULL,41183961446,643499397,10054678,15.95),(65175,'Brightest Stars','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65175,27.23,NULL,2.8,23060,NULL,NULL,'3B','BK 03N',NULL,'1993A&A...275...39T',1993,1,0.5,NULL,'G',NULL,NULL,'17.1',0.4,'Im',NULL,NULL,NULL,NULL,1,148.45225,68.96883,0.145,1,62126649254,970728894,15167638,17.1),(65176,'TRGB','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65176,27.93,0.03,3.86,23060,NULL,NULL,'I','BK 03N',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65177,'TRGB','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65177,28.02,0.14,4.02,23060,NULL,NULL,'I','BK 03N',NULL,'2002A&A...383..125K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65178,'TRGB','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65178,28.04,0.08,4.06,23060,74.4,NULL,NULL,'BK 03N',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65179,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65179,38.08,0.46,414,23061,70,NULL,NULL,'2MASX J09534854+6017292',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000141,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,148.45225,60.29142,0.025,NULL,61923059278,967547801,15117934,18.4),(65180,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65180,37.46,0.27,311,23062,70,NULL,NULL,'2MASX J09534869+5710252',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000193,NULL,'16.6g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,148.452833,57.17358,0.017,NULL,61940782641,967824728,15122261,16.6),(65181,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65181,34.69,0.49,86.7,23063,75,NULL,'IR','UGC 05314',NULL,'2011yCatp016004901K',2011,1,1.14,NULL,'G',0.000009,NULL,'16.1g',0.19,'Scd',NULL,NULL,NULL,NULL,1,148.4627083,8.87819,0.053,NULL,60932447302,952069489,14876085,16.1),(65182,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65182,34.94,NULL,97.2,23063,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05314',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65183,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65183,34.95,NULL,97.9,23063,NULL,NULL,'Dipole + Quadrupole','UGC 05314',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65184,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65184,34.96,NULL,98.3,23063,NULL,NULL,'Dipole','UGC 05314',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65185,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65185,35.05,NULL,103,23063,NULL,NULL,NULL,'UGC 05314',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65186,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65186,37.72,0.46,350,23064,70,NULL,NULL,'SDSS J095350.99+164202.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,148.4625,16.70067,0.077,NULL,60829222997,950456609,14850884,17.9),(65187,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65187,37.64,0.46,338,23065,70,NULL,NULL,'2MASX J09535160+0025436',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00009,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,148.465083,0.42881,0.069,NULL,60769164553,949518196,14836221,16.8),(65188,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65188,38.26,0.46,449,23066,70,NULL,NULL,'2MASX J09535178-0049303',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000101,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,148.465667,-0.82519,0.089,NULL,41224410970,644131421,10064553,17.5),(65189,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65189,39.2,0.46,690,23067,70,NULL,NULL,'SDSS J095351.78+332413.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000184,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,148.4657917,33.40369,0,NULL,64185096369,1002892130,15670189,18.5),(65190,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65190,37.72,0.46,351,23068,70,NULL,NULL,'2MASX J09535326+0542005',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,148.472,5.70028,0.069,NULL,60907406392,951678224,14869972,17.2),(65191,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65191,37.29,0.46,287,23069,70,NULL,NULL,'2MASX J09535364+0226015',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00008,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,148.4735,2.43381,0.041,NULL,60769354123,949521158,14836268,17.5),(65192,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65192,37.74,0.46,353,23070,70,NULL,NULL,'2MASX J09535373+0249496',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000074,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,148.473833,2.83047,0.045,NULL,60769233096,949519267,14836238,18.2),(65193,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65193,35.28,0.51,114,23071,70,NULL,NULL,'2MASX J09535374-1551106',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.8I',0.3,NULL,NULL,NULL,NULL,NULL,1,148.474,-15.853,0.193,NULL,41177560098,643399376,10053115,13.8),(65194,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65194,38.01,0.46,400,23072,70,NULL,NULL,'2MASX J09535411+2115509',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000178,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,148.4755,21.264,0.057,NULL,63697333563,995270836,15551106,17.6),(65195,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65195,35.4,0.64,120,23073,70,NULL,NULL,'2MASX J09535522-1754207',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.17',0.4,NULL,NULL,NULL,NULL,NULL,1,148.4800417,-17.90583,0.129,NULL,41175513053,643367391,10052615,16.17),(65196,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65196,33.92,0.4,60.8,23074,NULL,NULL,'mean','UGC 05313',NULL,'2007A&A...465...71T',2007,1,0.81,NULL,'G',0.00003,NULL,'14.1g',0.67,'S?',NULL,NULL,NULL,NULL,1,148.484833,23.38322,0.057,NULL,63701336512,995333383,15552084,14.1),(65197,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65197,33.95,0.47,61.7,23074,NULL,NULL,'H','UGC 05313',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65198,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65198,34.02,0.45,63.6,23074,NULL,NULL,'K','UGC 05313',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65199,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65199,34.11,0.46,66.2,23074,NULL,NULL,'J','UGC 05313',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65200,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65200,37.64,0.46,337,23075,70,NULL,NULL,'2MASX J09535706+3430019',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000172,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,148.4877917,34.50064,0.005,NULL,64182898341,1002857786,15669652,16.8),(65201,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65201,38.18,0.33,432,23076,70,NULL,NULL,'2MASX J09535735+2038579',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000194,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,148.4889583,20.64931,0.049,NULL,63697941795,995280340,15551255,16.5),(65202,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65202,37.57,0.46,326,23077,70,NULL,NULL,'2MASX J09535787+2052149',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000145,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,148.491,20.87072,0.045,NULL,63698083529,995282555,15551289,17.1),(65203,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65203,32.96,0.4,39.1,23078,NULL,NULL,'mean','NGC 3051',NULL,'2007A&A...465...71T',2007,1,2.1,'Identification as NGC 3046 is doubtful.','G',0.00005,NULL,'12.78',1.9,'(RL:)SB0^0p','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,148.494333,-27.28633,0.077,NULL,42828753894,669199279,10456238,12.78),(65204,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65204,33.58,0.45,52,23078,NULL,NULL,'K','NGC 3051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65205,'IRAS','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65205,34.04,0.8,64.4,23079,75,NULL,'MAT, I','ESO 435- G 005',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000023,NULL,'15.07',0.3,'SB(s)c',NULL,NULL,NULL,NULL,1,148.495167,-31.30219,0.285,NULL,42870824163,669856627,10466509,15.07),(65206,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65206,33.65,0.32,53.7,23079,85,NULL,'I, raw','ESO 435- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65207,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65207,33.68,0.32,54.4,23079,85,NULL,'I, inv','ESO 435- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65208,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65208,33.89,0.43,59.9,23079,75,NULL,'MAT, I, raw','ESO 435- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65209,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65209,34.02,0.43,63.5,23079,75,NULL,'MAT, I, cor','ESO 435- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65210,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65210,34.04,0.43,64.2,23079,75,NULL,'MAT, I, inv','ESO 435- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65211,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65211,34.05,0.46,64.5,23079,NULL,NULL,'Malmquist cor.','ESO 435- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65212,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65212,34.06,0.2,64.9,23079,74.4,NULL,NULL,'ESO 435- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65213,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65213,34.29,0.41,72.2,23079,NULL,NULL,NULL,'ESO 435- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65214,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65214,38.18,0.46,432,23080,70,NULL,NULL,'2MASX J09535920+2547543',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000179,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,148.496541667,25.79853,0.029,NULL,64170300563,1002660946,15666577,16.7),(65215,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65215,37.46,0.46,311,23081,70,NULL,NULL,'2MASX J09540160+3944196',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000203,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,148.506625,39.73867,0.025,NULL,64089257324,1001394645,15646791,16.5),(65216,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65216,38.16,0.46,429,23082,70,NULL,NULL,'2MASX J09540197+2849513',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000177,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,148.5082083,28.83111,0.021,NULL,64162257753,1002535277,15664613,17.3),(65217,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65217,37.52,0.33,319,23083,70,NULL,NULL,'2MASX J09540207-0053324',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000079,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,148.508666667,-0.89222,0.093,NULL,41224422936,644131608,10064556,16.7),(65218,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65218,37.58,0.46,328,23084,70,NULL,NULL,'2MASX J09540210+3457309',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,148.508708333,34.95844,0,NULL,64182472815,1002851137,15669549,17.5),(65219,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65219,36.43,0.46,193,23085,70,NULL,NULL,'2MASX J09540216+2557374',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00019,NULL,'15.9g',0.41,NULL,NULL,NULL,NULL,NULL,1,148.5089583,25.96042,0.057,NULL,64170348322,1002661692,15666588,15.9),(65220,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65220,36.37,0.33,188,23086,70,NULL,NULL,'CGCG 063-101',NULL,'2015arXiv151105856S',2015,1,0.93,NULL,'G',0.000013,NULL,'14.9g',0.61,'E0',NULL,NULL,NULL,NULL,1,148.5092917,10.60825,0.033,NULL,60928035320,952000551,14875008,14.9),(65221,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65221,36.74,0.33,222,23087,70,NULL,NULL,'2MASX J09540288+2624274',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000166,NULL,'16.92',0.38,NULL,NULL,NULL,NULL,NULL,1,148.512125,26.40772,0.041,NULL,64170264702,1002660385,15666568,16.92),(65222,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65222,37.46,0.27,311,23088,70,NULL,NULL,'2MASX J09540542+5711541',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'17.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,148.522833,57.19856,0.017,NULL,61940783597,967824743,15122261,17.4),(65223,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65223,37.14,0.46,268,23089,70,NULL,NULL,'2MASX J09540709+0401345',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,148.5295417,4.02619,0.073,NULL,60908232960,951691140,14870174,17.7),(65224,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65224,37.37,0.46,298,23090,70,NULL,NULL,'SDSS J095409.05+135049.2',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.0g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,148.53775,13.84703,0.041,NULL,60823039046,950359985,14849374,17),(65225,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65225,38.34,0.46,466,23091,70,NULL,NULL,'SDSS J095409.10+493735.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,148.537917,49.62639,0,NULL,64020566118,1000321345,15630021,18),(65226,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65226,37.17,0.46,272,23092,70,NULL,NULL,'SDSS J095409.26+250805.4',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.4g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,148.538625,25.13486,0.049,NULL,64165623185,1002587862,15665435,17.4),(65227,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65227,37.76,0.46,356,23093,70,NULL,NULL,'2MASX J09540980+3804336',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000141,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,148.54075,38.07592,0.025,NULL,64059576854,1000930888,15639545,17.6),(65228,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65228,37.52,0.23,319,23094,70,NULL,NULL,'2MASX J09541081+3226529',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00018,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,148.545,32.44797,0.025,NULL,64181972594,1002843321,15669426,17.1),(65229,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65229,38.18,0.33,432,23095,70,NULL,NULL,'SDSS J095411.34+203709.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000186,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,148.5472917,20.61925,0.049,NULL,63697928893,995280138,15551252,18.6),(65230,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65230,35.42,0.46,121,23096,70,NULL,NULL,'2MASX J09541349-1407087',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000093,NULL,'15.61',0.8,NULL,NULL,NULL,NULL,NULL,1,148.5562917,-14.11931,0.181,NULL,41182658856,643479044,10054360,15.61),(65231,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65231,37.68,0.33,344,23097,70,NULL,NULL,'2MASX J09541437+0415405',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,148.559875,4.26119,0.073,NULL,60908360934,951693139,14870205,17.7),(65232,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65232,37.93,0.33,385,23098,70,NULL,NULL,'2MASX J09541439+3308539',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,148.5600417,33.14831,0.005,NULL,64181570459,1002837038,15669328,17.6),(65233,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65233,36.37,0.33,188,23099,70,NULL,NULL,'2MASX J09541682+1034574',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000179,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,148.570125,10.58264,0.033,NULL,60930145543,952033524,14875523,16.4),(65234,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65234,37.06,0.46,258,23100,70,NULL,NULL,'2MASX J09541732+0709154',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000162,NULL,'16.2g',0.31,'S0^-',NULL,NULL,NULL,NULL,1,148.5722917,7.15419,0.025,NULL,60933188491,952081070,14876266,16.2),(65235,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65235,34.18,0.2,68.6,23101,74.4,NULL,NULL,'UGC 05320',NULL,'2013AJ....146...86T',2013,1,1.61,'HOLM 149B does not exist (it is probably a plate defect).','G',0.00003,NULL,'14.4g',0.67,'SB(r)cd',NULL,NULL,NULL,NULL,1,148.5740417,23.28747,0.057,NULL,63701346126,995333533,15552086,14.4),(65236,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65236,34.44,0.62,77.2,23101,NULL,NULL,NULL,'UGC 05320',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65237,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65237,34.51,0.6,79.8,23101,NULL,NULL,'Malmquist cor.','UGC 05320',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65238,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65238,38.56,0.46,516,23102,70,NULL,NULL,'2MASX J09541876+2040537',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000171,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,148.577958333,20.68161,0.049,NULL,63698045746,995281964,15551280,18.1),(65239,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65239,37.52,0.46,319,23103,70,NULL,NULL,'2MASX J09541909+3308249',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,148.5795,33.14033,0.005,NULL,64181570323,1002837036,15669328,17.8),(65240,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65240,36.65,0.46,213,23104,70,NULL,NULL,'2MASX J09541995+0741324',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.0001,NULL,'15.4g',0.56,'E0',NULL,NULL,NULL,NULL,1,148.5830417,7.69228,0.025,NULL,60934253602,952097712,14876526,15.4),(65241,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65241,38.11,0.23,419,23105,70,NULL,NULL,'2MASX J09541993+0148005',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000076,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,148.583083,1.80014,0.049,NULL,60769939465,949530304,14836411,18),(65242,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65242,36.5,0.46,200,23106,70,NULL,NULL,'2MASX J09541998+4557566',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,148.583208333,45.96564,0.009,NULL,63977617276,999650269,15619535,17.6),(65243,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65243,37.25,0.46,282,23107,70,NULL,NULL,'2MASX J09542041-0056314',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000072,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,148.585,-0.94208,0.093,NULL,41224442154,644131908,10064561,17.4),(65244,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65244,37.68,0.33,344,23108,70,NULL,NULL,'2MASX J09542052+0412565',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000179,NULL,'16.8g',0.34,NULL,NULL,NULL,NULL,NULL,1,148.585625,4.21572,0.073,NULL,60908320269,951692504,14870195,16.8),(65245,'IRAS','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65245,31.37,0.8,18.8,23109,75,NULL,'MAT, I','ESO 374- G 008',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'15.53',0.3,'Sb? pec sp','in a triple',NULL,NULL,NULL,1,148.595625,-33.11694,0.529,NULL,42853862421,669591600,10462368,15.53),(65246,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65246,31.24,0.32,17.7,23109,85,NULL,'I, inv','ESO 374- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65247,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65247,31.29,0.32,18.1,23109,85,NULL,'I, raw','ESO 374- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65248,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65248,31.59,0.43,20.8,23109,75,NULL,'MAT, I, inv','ESO 374- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65249,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65249,31.71,0.43,22,23109,75,NULL,'MAT, I, raw','ESO 374- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65250,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65250,32.1,0.2,26.3,23109,74.4,NULL,NULL,'ESO 374- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65251,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65251,32.17,0.43,27.1,23109,75,NULL,'MAT, I, cor','ESO 374- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65252,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65252,32.59,0.48,32.9,23109,NULL,NULL,NULL,'ESO 374- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65253,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65253,32.71,0.45,34.8,23109,NULL,NULL,'Malmquist cor.','ESO 374- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65254,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65254,37.88,0.46,376,23110,70,NULL,NULL,'2MASX J09542340+0334270',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000181,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,148.597583,3.57411,0.057,NULL,60907806787,951684481,14870070,17.6),(65255,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65255,37.3,0.46,289,23111,70,NULL,NULL,'2MASX J09542404+4224486',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000178,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,148.6002917,42.41361,0.013,NULL,63972729673,999573901,15618342,16.8),(65256,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65256,36.28,0.46,181,23112,70,NULL,NULL,'2MASX J09542415+0049250',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000093,NULL,'15.8g',0.42,'E0',NULL,NULL,NULL,NULL,1,148.6007917,0.82372,0.053,NULL,60768587726,949509183,14836080,15.8),(65257,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65257,37.27,0.46,285,23113,70,NULL,NULL,'2MASX J09542508+6411051',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000085,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,148.6047917,64.18483,0.145,NULL,62247657996,972619656,15197182,17),(65258,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65258,38.92,0.46,608,23114,70,NULL,NULL,'SDSS J095425.21+202019.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,148.605083333,20.33869,0.053,NULL,63698894295,995295223,15551487,18.4),(65259,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65259,37.55,0.46,323,23115,70,NULL,NULL,'2MASX J09542533+3320129',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,148.6055417,33.337,0,NULL,64185102330,1002892223,15670190,17.8),(65260,'Ring Diameter','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65260,33,0.84,40,23116,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3052',NULL,'1981ApJS...45..541P',1981,1,2,NULL,'G',0.000027,NULL,'12.78',1.3,'SAB(rs)c       HII','in a pair',NULL,NULL,NULL,1,148.616375,-18.63889,0.105,NULL,42283006734,660671980,10322999,12.78),(65261,'IRAS','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65261,33.62,0.8,53.1,23116,75,NULL,'MAT, I','NGC 3052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65262,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65262,32.81,0.69,36.4,23116,100,NULL,'mid-IR','NGC 3052',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65263,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65263,33.11,0.32,41.9,23116,85,NULL,'I, raw','NGC 3052',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65264,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65264,33.13,NULL,42.3,23116,NULL,NULL,'B','NGC 3052',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65265,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65265,33.17,0.32,43,23116,85,NULL,'I, inv','NGC 3052',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65266,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65266,33.19,0.45,43.4,23116,NULL,NULL,'K','NGC 3052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65267,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65267,33.19,0.47,43.4,23116,NULL,NULL,'H','NGC 3052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65268,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65268,33.22,0.46,44.1,23116,NULL,NULL,'J','NGC 3052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65269,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65269,33.27,0.2,45.1,23116,74.4,NULL,NULL,'NGC 3052',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65270,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65270,33.28,0.43,45.3,23116,75,NULL,'MAT, I, raw','NGC 3052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65271,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65271,33.39,NULL,47.6,23116,NULL,NULL,'I','NGC 3052',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65272,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65272,33.4,0.38,47.9,23116,NULL,NULL,'Malmquist cor.','NGC 3052',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65273,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65273,33.45,0.37,49,23116,NULL,NULL,NULL,'NGC 3052',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65274,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65274,33.53,0.43,50.8,23116,75,NULL,'MAT, I, inv','NGC 3052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65275,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65275,33.6,0.43,52.5,23116,75,NULL,'MAT, I, cor','NGC 3052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65276,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65276,33.8,0.4,57.7,23116,NULL,NULL,'mean','NGC 3052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65277,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65277,36.21,0.46,175,23117,70,NULL,NULL,'2MASX J09542825+0223390',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000088,NULL,'15.6g',0.46,'S0^-',NULL,NULL,NULL,NULL,1,148.6177083,2.39414,0.041,NULL,60769312620,949520509,14836257,15.6),(65278,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65278,37.46,0.46,311,23118,70,NULL,NULL,'2MASX J09542830+3433538',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,148.61775,34.56514,0.005,NULL,64182907328,1002857927,15669655,17.8),(65279,'Ring Diameter','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65279,31.6,0.98,21,23119,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3054',NULL,'1981ApJS...45..541P',1981,1,3.8,NULL,'G',0.000023,NULL,'11.6B',2.3,'SAB(r)bc       HII?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,148.619167,-25.70344,0.257,NULL,42831060805,669235325,10456801,11.6),(65280,'Ring Diameter','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65280,32.2,0.76,27,23119,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3054',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65281,'IRAS','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65281,32.57,0.8,32.7,23119,75,NULL,'MAT, I','NGC 3054',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65282,'Sosies','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65282,32.69,0.08,34.5,23119,NULL,NULL,NULL,'NGC 3054',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65283,'Tully est','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65283,32.35,0.8,29.6,23119,75,NULL,'B','NGC 3054',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65284,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65284,32.5,0.4,31.6,23119,NULL,NULL,NULL,'NGC 3054',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65285,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65285,32.52,0.46,31.9,23119,NULL,NULL,'J','NGC 3054',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65286,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65286,32.55,0.43,32.4,23119,75,NULL,'MAT, I, raw','NGC 3054',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65287,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65287,32.58,0.45,32.9,23119,NULL,NULL,'K','NGC 3054',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65288,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65288,32.62,0.47,33.5,23119,NULL,NULL,'H','NGC 3054',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65289,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65289,32.64,0.32,33.8,23119,85,NULL,'I, raw','NGC 3054',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65290,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65290,32.72,0.32,35,23119,85,NULL,'I, inv','NGC 3054',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65291,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65291,32.85,0.43,37.2,23119,75,NULL,'MAT, I, inv','NGC 3054',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65292,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65292,32.87,0.43,37.5,23119,75,NULL,'MAT, I, cor','NGC 3054',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65293,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65293,32.91,0.4,38.1,23119,NULL,NULL,'mean','NGC 3054',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65294,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65294,32.94,0.39,38.7,23119,NULL,NULL,'Malmquist cor.','NGC 3054',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65295,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65295,32.97,0.39,39.3,23119,NULL,NULL,NULL,'NGC 3054',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65296,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65296,33.01,0.2,40,23119,74.4,NULL,NULL,'NGC 3054',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65297,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65297,34.83,0.56,92.5,23120,70,NULL,NULL,'NGC 3047 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.35,'Called \'NGC 3047b\' in MCG.  Component \'a)\' in UGC notes.','G',0.00015,NULL,NULL,0.35,NULL,NULL,NULL,NULL,NULL,1,148.622875,-1.28803,0.085,NULL,41224790288,644137348,10064646,NULL),(65298,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65298,35.84,0.62,147,23121,70,NULL,NULL,'2MASX J09543047-1534205',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.64',NULL,NULL,NULL,NULL,NULL,NULL,1,148.627,-15.57236,0.193,NULL,41176727595,643386368,10052912,16.64),(65299,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65299,38.58,0.33,520,23122,70,NULL,NULL,'2MASX J09543267+2028087',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000178,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,148.636208333,20.46925,0.053,NULL,63698843204,995294425,15551475,17.1),(65300,'SBF','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65300,30.27,0.25,11.3,23123,NULL,NULL,'I','NGC 3056',NULL,'2003ApJ...583..712J',2003,1,1.8,NULL,'G',0.00001,NULL,'12.57',1.1,'SA(rl)0^0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,148.637,-28.29819,0.165,NULL,42828490270,669195160,10456174,12.57),(65301,'SBF','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65301,30.43,0.14,12.2,23123,74.4,NULL,NULL,'NGC 3056',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65302,'SBF','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65302,30.43,0.25,12.2,23123,NULL,NULL,'I','NGC 3056',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65303,'Faber-Jackson','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65303,29.45,0.65,7.76,23123,95,NULL,'Weighted Mean','NGC 3056',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65304,'Faber-Jackson','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65304,30.31,0.81,11.5,23123,55,NULL,'Visvanathan & Sandage 1979','NGC 3056',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65305,'Tully est','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65305,30.64,0.8,13.4,23123,75,NULL,'B','NGC 3056',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65306,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65306,37.41,0.46,303,23124,70,NULL,NULL,'2MASX J09543361+2638414',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,148.639917,26.64486,0.041,NULL,64172570996,1002696421,15667131,17),(65307,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65307,36.36,0.46,187,23125,70,NULL,NULL,'2MASX J09543436+0032200',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000084,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,148.6432917,0.53894,0.069,NULL,60769087289,949516988,14836202,16.5),(65308,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65308,36.24,0.46,177,23126,70,NULL,NULL,'2MASX J09543452+2523304',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,148.643875,25.39169,0.061,NULL,64169896542,1002654633,15666478,16.5),(65309,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65309,37.95,0.23,390,23127,70,NULL,NULL,'2MASX J09543458+2610254',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,148.6442083,26.17364,0.053,NULL,64170432084,1002663001,15666609,18.1),(65310,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65310,32.22,NULL,27.8,23128,NULL,NULL,NULL,'HIPASS J0954+01',NULL,'2015AstBu..70....1K',2015,1,NULL,NULL,'G',0.000028,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,148.645833,1.91361,0.049,NULL,60769806211,949528222,14836378,NULL),(65311,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65311,36.83,0.46,232,23129,70,NULL,NULL,'2MASX J09543549+1617266',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,148.647833333,16.29078,0.085,NULL,60828402350,950443786,14850684,17.1),(65312,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65312,32.95,NULL,38.9,23130,NULL,NULL,NULL,'SDSS J095435.70+042307.9',NULL,'2015AstBu..70....1K',2015,1,0.4,NULL,'G',0.000128,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,148.6487917,4.38553,0.085,NULL,60908262234,951691597,14870181,17.4),(65313,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65313,36.73,0.46,222,23131,70,NULL,NULL,'2MASX J09543646+4134368',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,148.6519583,41.57681,0,NULL,64091407780,1001428246,15647316,17.3),(65314,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65314,37.12,0.46,265,23132,70,NULL,NULL,'2MASX J09543654+5101312',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,148.6522917,51.02528,0,NULL,64012209591,1000190774,15627980,17.6),(65315,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65315,37.93,0.33,385,23133,70,NULL,NULL,'2MASX J09543740+3309164',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000179,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,148.65575,33.15447,0.005,NULL,64181583557,1002837243,15669331,17.4),(65316,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65316,37.46,0.27,311,23134,70,NULL,NULL,'2MASX J09543851+5711491',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,148.66025,57.19706,0.017,NULL,61940893787,967826465,15122288,17.8),(65317,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65317,37.55,0.46,324,23135,70,NULL,NULL,'2MASX J09543894+3411594',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000165,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,148.662125,34.19986,0,NULL,64183036034,1002859938,15669686,16.6),(65318,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65318,36.99,0.46,250,23136,70,NULL,NULL,'2MASX J09543895+2525314',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,148.6625,25.42531,0.061,NULL,64169898161,1002654658,15666479,17.1),(65319,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65319,37.52,0.23,319,23137,70,NULL,NULL,'2MASXi J0954391+322621',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,148.6629583,32.43925,0.025,NULL,64181861819,1002841590,15669399,17.5),(65320,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65320,34.67,0.4,86,23138,NULL,NULL,'mean','IC 2515',NULL,'2007A&A...465...71T',2007,1,1.37,NULL,'G',0.000053,NULL,'14.8g',0.35,'Sb',NULL,NULL,NULL,NULL,1,148.66425,37.40858,0.029,NULL,64056791205,1000887362,15638865,14.8),(65321,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65321,34.69,0.47,86.9,23138,NULL,NULL,'H','IC 2515',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65322,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65322,34.75,0.45,89,23138,NULL,NULL,'K','IC 2515',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65323,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65323,34.87,0.49,94.1,23138,75,NULL,'IR','IC 2515',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65324,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65324,34.87,0.46,94.3,23138,NULL,NULL,'J','IC 2515',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65325,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65325,34.8,0.49,91.4,23139,75,NULL,'IR','KUG 0951+299',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000012,NULL,'16.6g',0.17,'Sd',NULL,NULL,NULL,NULL,1,148.665667,29.71625,0.037,NULL,64162068960,1002532327,15664567,16.6),(65326,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65326,34.85,NULL,93.3,23139,NULL,NULL,NULL,'KUG 0951+299',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65327,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65327,34.85,0.2,93.3,23139,74.4,NULL,NULL,'KUG 0951+299',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65328,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65328,34.87,NULL,94,23139,NULL,NULL,'Dipole + Quadrupole + Octopole','KUG 0951+299',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65329,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65329,34.87,NULL,94.2,23139,NULL,NULL,'Dipole','KUG 0951+299',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65330,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65330,34.87,NULL,94.3,23139,NULL,NULL,'Dipole + Quadrupole','KUG 0951+299',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65331,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65331,37.1,0.46,263,23140,70,NULL,NULL,'2MASX J09544174+0543300',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000139,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,148.673917,5.725,0.069,NULL,60907435429,951678678,14869979,17.9),(65332,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65332,36.02,0.46,160,23141,70,NULL,NULL,'2MASX J09544317+3636248',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000177,NULL,'15.9g',0.37,'E0',NULL,NULL,NULL,NULL,1,148.679958333,36.60686,0.013,NULL,64056583290,1000884113,15638814,15.9),(65333,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65333,37.62,0.33,335,23142,70,NULL,NULL,'2MASX J09544390+4220466',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000201,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,148.683083333,42.34636,0.025,NULL,64091184488,1001424757,15647261,16.4),(65334,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65334,37.49,0.46,314,23143,70,NULL,NULL,'SDSS J095444.25+612327.1',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000138,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,148.684417,61.39086,0.073,NULL,61909162513,967330664,15114541,18),(65335,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65335,36.83,0.46,232,23144,70,NULL,NULL,'2MASX J09544512+2054538',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,148.6879583,20.91483,0.065,NULL,63698064547,995282258,15551285,17),(65336,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65336,38.08,0.46,413,23145,70,NULL,NULL,'2MASX J09544523+5630561',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000219,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,148.688625,56.51556,0.005,NULL,61940997091,967828079,15122313,16.9),(65337,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65337,36.58,0.95,207,23146,70,NULL,NULL,'2MASX J09544526-1301385',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,148.6887083,-13.02731,0.125,NULL,41183621300,643494082,10054595,16.8),(65338,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65338,38.6,0.46,525,23147,70,NULL,NULL,'SDSS J095445.64+090856.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,148.6902083,9.14892,0.037,NULL,60927780709,951996573,14874946,17.7),(65339,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65339,34.75,0.2,89.1,23148,74.4,NULL,NULL,'UGC 05324',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000123,NULL,'15.3',0.5,'S',NULL,NULL,NULL,NULL,1,148.692375,13.37475,0.037,NULL,60825634451,950400538,14850008,15.3),(65340,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65340,34.79,0.54,90.7,23148,NULL,NULL,NULL,'UGC 05324',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65341,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65341,34.85,0.52,93.5,23148,NULL,NULL,'Malmquist cor.','UGC 05324',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65342,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65342,38.01,0.27,400,23149,70,NULL,NULL,'2MASX J09544682+3345014',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000148,NULL,'17.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,148.695167,33.75031,0.009,NULL,64185155888,1002893060,15670204,17.4),(65343,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65343,37.37,0.46,298,23150,70,NULL,NULL,'SDSS J095447.42+012211.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000078,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,148.697583333,1.36981,0.053,NULL,60768394499,949506164,14836033,18.3),(65344,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65344,37.75,0.46,354,23151,70,NULL,NULL,'2MASX J09544797+0646539',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000139,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,148.7,6.78158,0,NULL,60925271544,951957367,14874333,17.7),(65345,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65345,34.38,0.46,75.3,23152,70,NULL,NULL,'IC 2516',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000107,NULL,'14.5g',0.64,NULL,NULL,NULL,NULL,NULL,1,148.7015,37.68694,0.033,NULL,64058703447,1000917241,15639331,14.5),(65346,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65346,30.92,0.4,15.3,23153,75,NULL,NULL,'NGC 3049',NULL,'2008Ap.....51..336K',2008,1,2.13,NULL,'G',0.000011,NULL,'13.6g',1.07,'SB(rs)ab;HII   Sbrst','Isolated galaxy',NULL,NULL,'Starburst',1,148.7065,9.27108,0.037,NULL,60927831006,951997359,14874958,13.6),(65347,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65347,30.92,0.4,15.3,23153,73,NULL,'IR','NGC 3049',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65348,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65348,31.18,0.43,17.2,23153,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3049',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65349,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65349,31.32,0.43,18.3,23153,75,NULL,'3.6 micron, color corrected','NGC 3049',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65350,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65350,31.43,0.2,19.3,23153,74.4,NULL,NULL,'NGC 3049',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65351,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65351,32.01,0.49,25.2,23153,75,NULL,'IR','NGC 3049',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65352,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65352,32.34,0.4,29.3,23153,NULL,NULL,'mean','NGC 3049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65353,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65353,32.4,NULL,30.2,23153,NULL,NULL,NULL,'NGC 3049',NULL,'2015AstBu..70....1K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65354,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65354,32.44,0.47,30.8,23153,NULL,NULL,'H','NGC 3049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65355,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65355,32.45,0.45,31,23153,NULL,NULL,'K','NGC 3049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65356,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65356,32.53,0.46,32,23153,NULL,NULL,'J','NGC 3049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65357,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65357,37.73,0.46,352,23154,70,NULL,NULL,'2MASX J09544972+4712506',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,148.707167,47.21406,0.009,NULL,64007998224,1000124972,15626952,16.8),(65358,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65358,30.94,NULL,15.4,23155,NULL,NULL,NULL,'LV J0954+3620',NULL,'2013AJ....145..101K',2013,1,0.32,NULL,'G',0.000184,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,148.711,36.33386,0.013,NULL,64056561256,1000883769,15638808,17.8),(65359,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65359,35.35,0.27,118,23156,70,NULL,NULL,'2MASX J09545075+5235243',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000175,NULL,'15.4g',0.46,'E0',NULL,NULL,NULL,NULL,1,148.7115,52.59011,0,NULL,64009898246,1000154660,15627416,15.4),(65360,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65360,37.94,0.46,388,23157,70,NULL,NULL,'2MASXi J0954522+214735',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000175,NULL,'17.3g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,148.7177083,21.79314,0.049,NULL,63702802830,995356294,15552442,17.3),(65361,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65361,37.83,0.23,368,23158,70,NULL,NULL,'2MASX J09545426+0342022',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,148.7260417,3.70056,0.057,NULL,60907783661,951684119,14870064,17.7),(65362,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65362,37.68,0.46,343,23159,70,NULL,NULL,'2MASX J09545544+1725186',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000211,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,148.730916667,17.42186,0.081,NULL,60859755695,950933682,14858338,16.8),(65363,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65363,37.22,0.46,278,23160,70,NULL,NULL,'2MASX J09545588-0045398',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000088,NULL,'16.9g',0.25,'NLAGN',NULL,NULL,NULL,NULL,1,148.732875,-0.76117,0.081,NULL,41224331703,644130182,10064534,16.9),(65364,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65364,37.62,0.33,335,23161,70,NULL,NULL,'2MASX J09545612+4222347',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,148.733833,42.37628,0.025,NULL,64091166711,1001424479,15647257,17.9),(65365,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65365,37.52,0.23,319,23162,70,NULL,NULL,'2MASX J09545666+3237114',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000162,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,148.73625,32.61992,0.021,NULL,64182043010,1002844422,15669444,17),(65366,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65366,37.7,0.46,347,23163,70,NULL,NULL,'2MASX J09545702+0533142',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000172,NULL,'16.8g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,148.737583333,5.554,0.077,NULL,60907349298,951677332,14869958,16.8),(65367,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65367,37.89,0.46,378,23164,70,NULL,NULL,'SDSS J095457.08+003759.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00007,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,148.737833333,0.63322,0.069,NULL,60769104573,949517258,14836207,17.8),(65368,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65368,36.07,0.53,164,23165,70,NULL,NULL,'ESO 374- G 009',NULL,'2014MNRAS.445.2677S',2014,1,1.5,'A-M -10\' Dec error.','G',0.00015,NULL,'15.55',1.1,'(R\'_2)SA(r)a',NULL,NULL,NULL,NULL,1,148.746083333,-34.06208,0.621,NULL,42855581657,669618463,10462788,15.55),(65369,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65369,37.61,0.46,333,23166,70,NULL,NULL,'2MASX J09545907+2857549',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,148.746125,28.96522,0.041,NULL,64162151423,1002533615,15664587,17.7),(65370,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65370,38.58,0.33,520,23167,70,NULL,NULL,'2MASX J09545907+2027577',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000174,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,148.7462083,20.46597,0.069,NULL,63698720116,995292501,15551445,18.3),(65371,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65371,35.95,0.59,155,23168,70,NULL,NULL,'ESO 566- G 028',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.82',0.4,'SAB(r?)0/a:',NULL,NULL,NULL,NULL,1,148.756583333,-18.73136,0.101,NULL,42282939021,660670922,10322983,15.82),(65372,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65372,37.06,0.46,258,23169,70,NULL,NULL,'2MASX J09550211+1621406',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.3g',0.22,'AGN',NULL,NULL,NULL,NULL,1,148.7587917,16.36144,0.085,NULL,60828202965,950440671,14850635,17.3),(65373,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65373,37.36,0.46,296,23170,70,NULL,NULL,'2MASX J09550254+2049099',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,148.7605,20.81931,0.065,NULL,63698068445,995282319,15551286,16.9),(65374,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65374,37.91,0.46,382,23171,70,NULL,NULL,'2MASX J09550308+2020389',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000187,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,148.762917,20.34425,0.061,NULL,63698739478,995292804,15551450,17.3),(65375,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65375,38.17,0.46,430,23172,70,NULL,NULL,'2MASX J09550390+1840149',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,148.766375,18.67075,0.081,NULL,63694800151,995231252,15550488,17.3),(65376,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65376,36.7,0.46,219,23173,70,NULL,NULL,'2MASX J09550414+4743217',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,148.76725,47.72272,0.005,NULL,64007895573,1000123368,15626927,17.2),(65377,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65377,37.49,0.46,315,23174,70,NULL,NULL,'2MASX J09550534+1449306',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,148.772083,14.82508,0.053,NULL,60830138373,950470912,14851108,18),(65378,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65378,37.08,0.46,261,23175,70,NULL,NULL,'2MASX J09550572+1129516',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,148.773916667,11.49761,0.041,NULL,60893792690,951465510,14866648,17.4),(65379,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65379,37.62,0.46,335,23176,70,NULL,NULL,'2MASX J09550652+3656564',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000162,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,148.777041667,36.94908,0.013,NULL,64057406389,1000896974,15639015,17.1),(65380,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65380,34.84,0.2,92.9,23177,74.4,NULL,NULL,'FGC 113A',NULL,'2013AJ....146...86T',2013,1,0.78,NULL,'G',0.000035,NULL,'16.85',0.12,NULL,NULL,NULL,NULL,NULL,1,148.777625,13.52419,0.037,NULL,60825389088,950396704,14849948,16.85),(65381,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65381,34.94,0.65,97.3,23177,NULL,NULL,NULL,'FGC 113A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65382,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65382,35.04,0.62,102,23177,NULL,NULL,'Malmquist cor.','FGC 113A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65383,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65383,35.19,0.74,109,23178,70,NULL,NULL,'FGC 0972',NULL,'2014MNRAS.445.2677S',2014,1,1.06,NULL,'G',0.0001,NULL,'16.4',0.11,'Sbc',NULL,NULL,NULL,NULL,1,148.7797083,-16.06869,0.177,NULL,41177182991,643393484,10053023,16.4),(65384,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65384,37,0.33,251,23179,70,NULL,NULL,'2MASX J09550714+0420192',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000177,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,148.7797083,4.33872,0.093,NULL,60908281512,951691898,14870185,17.2),(65385,'IRAS','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65385,33.04,0.8,40.6,23180,75,NULL,'MAT, I','IC 2522',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.000017,NULL,'12.64',2,'SA(s)cd        HII','in a triple',NULL,NULL,'H_alpha Emission-Line Galaxy',1,148.787333,-33.13714,0.529,NULL,42853914369,669592412,10462381,12.64),(65386,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65386,31.39,0.43,19,23180,75,NULL,'MAT, I, raw','IC 2522',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65387,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65387,31.51,0.43,20.1,23180,75,NULL,'MAT, I, inv','IC 2522',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65388,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65388,31.59,0.32,20.8,23180,85,NULL,'I, raw','IC 2522',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65389,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65389,31.62,0.32,21.1,23180,85,NULL,'I, inv','IC 2522',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65390,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65390,31.78,0.43,22.7,23180,75,NULL,'MAT, I, cor','IC 2522',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65391,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65391,32.38,0.4,29.9,23180,NULL,NULL,NULL,'IC 2522',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65392,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65392,32.62,0.2,33.4,23180,74.4,NULL,NULL,'IC 2522',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65393,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65393,32.91,0.46,38.3,23180,NULL,NULL,'J','IC 2522',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65394,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65394,32.92,0.47,38.4,23180,NULL,NULL,'H','IC 2522',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65395,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65395,32.92,0.45,38.4,23180,NULL,NULL,'K','IC 2522',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65396,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65396,32.98,0.4,39.4,23180,75,NULL,'B','IC 2522',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65397,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65397,33.19,0.4,43.5,23180,NULL,NULL,'mean','IC 2522',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65398,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65398,33.4,0.08,48,23180,NULL,NULL,NULL,'IC 2522',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65399,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65399,38.01,0.27,400,23181,70,NULL,NULL,'2MASX J09550891+3340472',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00018,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,148.787167,33.67975,0.013,NULL,64185129273,1002892644,15670197,18.1),(65400,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65400,38,0.46,398,23182,70,NULL,NULL,'2MASX J09550897+0219482',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000079,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,148.787416667,2.32997,0.033,NULL,60781641043,949713141,14839267,17.3),(65401,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65401,37.76,0.46,357,23183,70,NULL,NULL,'2MASX J09550944+2118319',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000153,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,148.7892083,21.30883,0.057,NULL,63696027427,995250428,15550787,17.3),(65402,'IRAS','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65402,32.68,0.8,34.4,23184,75,NULL,'MAT, I','IC 2523',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000026,NULL,'13.60',0.8,'S pec','in a triple',NULL,NULL,NULL,1,148.789666667,-33.21022,0.537,NULL,42853921054,669592516,10462383,13.6),(65403,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65403,31.02,0.43,16,23184,75,NULL,'3.6 micron, color + selection bias corrected','IC 2523',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65404,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65404,31.27,0.43,17.9,23184,75,NULL,'3.6 micron, color corrected','IC 2523',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65405,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65405,31.45,0.2,19.5,23184,74.4,NULL,NULL,'IC 2523',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65406,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65406,32.07,0.32,25.9,23184,85,NULL,'I, raw','IC 2523',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65407,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65407,32.07,0.32,26,23184,85,NULL,'I, inv','IC 2523',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65408,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65408,32.43,0.43,30.6,23184,75,NULL,'MAT, I, raw','IC 2523',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65409,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65409,32.44,0.47,30.7,23184,NULL,NULL,'H','IC 2523',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65410,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65410,32.49,0.46,31.5,23184,NULL,NULL,'J','IC 2523',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65411,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65411,32.52,0.45,31.9,23184,NULL,NULL,'K','IC 2523',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65412,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65412,32.54,0.43,32.2,23184,75,NULL,'MAT, I, inv','IC 2523',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65413,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65413,32.75,0.43,35.5,23184,75,NULL,'MAT, I, cor','IC 2523',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65414,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65414,32.91,0.4,38.3,23184,NULL,NULL,'mean','IC 2523',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65415,'Tully-Fisher','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65415,33.11,0.1,42,23184,NULL,NULL,NULL,'IC 2523',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65416,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65416,36.77,0.46,226,23185,70,NULL,NULL,'2MASX J09551004+0648306',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00016,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,148.791667,6.80844,0,NULL,60925262699,951957229,14874331,16.2),(65417,'SNIa','2016-12-15 15:14:32','2016-12-16 11:19:39','1','PS1 SN PS11p','N',65417,42.3,0.18,1940,23186,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11p HOST',0.4812,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65418,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65418,37.92,0.46,384,23187,70,NULL,NULL,'2MASX J09551142+3424332',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,148.797625,34.40928,0.005,NULL,64183050216,1002860159,15669689,17.2),(65419,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65419,37.4,0.46,303,23188,70,NULL,NULL,'2MASX J09551205+1103586',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000147,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,148.800125,11.06617,0.041,NULL,60893528299,951461379,14866584,17.4),(65420,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65420,37.64,0.46,337,23189,70,NULL,NULL,'2MASX J09551285+0017052',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00009,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,148.80375,0.28481,0.065,NULL,60768377363,949505896,14836029,16.6),(65421,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65421,37.08,0.46,261,23190,70,NULL,NULL,'2MASX J09551336+1600006',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,148.805666667,16.00011,0.081,NULL,60828297761,950442152,14850658,17.1),(65422,'TRGB','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,NULL,65422,27.69,0.35,3.4,23191,NULL,NULL,NULL,'MESSIER 081:[CKT2009] d0955+70',NULL,'2013AJ....146..126C',2013,1,NULL,NULL,'G',NULL,NULL,'20.5B',NULL,'dSph',NULL,NULL,NULL,NULL,1,148.806667,70.40806,0.241,NULL,62098078363,970282474,15160663,20.5),(65423,'FP','2016-12-15 15:14:32','2016-12-16 11:19:39','1',NULL,'R',65423,37.88,0.46,377,23192,70,NULL,NULL,'SDSS J095513.66+180219.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,148.8069583,18.03872,0.081,NULL,60859575071,950930860,14858294,18.5),(65424,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65424,36.33,0.46,185,23193,70,NULL,NULL,'2MASX J09551440+1226356',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000166,NULL,'16.0g',0.41,'E0',NULL,NULL,NULL,NULL,1,148.81,12.44317,0.053,NULL,60822223133,950347236,14849175,16),(65425,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65425,37.59,0.46,329,23194,70,NULL,NULL,'2MASX J09551559+2511249',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000143,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,148.815083333,25.19042,0.077,NULL,64169929738,1002655152,15666486,17.5),(65426,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65426,35.97,0.46,156,23195,70,NULL,NULL,'2MASX J09551569+3435123',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00018,NULL,'15.7g',0.35,NULL,NULL,NULL,NULL,NULL,1,148.8155,34.58675,0.005,NULL,64182941774,1002858465,15669663,15.7),(65427,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65427,37.28,0.46,286,23196,70,NULL,NULL,'2MASX J09551691+3446132',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000148,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,148.820583333,34.77044,0.009,NULL,64182892351,1002857692,15669651,17.1),(65428,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65428,38.08,0.46,413,23197,70,NULL,NULL,'2MASX J09551727+1823509',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000195,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,148.822041667,18.3975,0.053,NULL,60805071281,950079238,14844988,16.6),(65429,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65429,36.27,0.46,180,23198,70,NULL,NULL,'2MASX J09551788+6837072',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000077,NULL,'15.98',0.55,NULL,NULL,NULL,NULL,NULL,1,148.8242917,68.61883,0.173,NULL,62127039090,970734985,15167734,15.98),(65430,'Tully est','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65430,32.15,0.8,26.9,23199,75,NULL,'B','NGC 3055',NULL,'1988NBGC.C....0000T',1988,1,2.12,NULL,'G',0.000016,NULL,'12.8g',1.2,'SAB(s)c        WR','Field galaxy',NULL,NULL,NULL,1,148.82525,4.27003,0.093,NULL,60908399487,951693741,14870214,12.8),(65431,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65431,31.9,0.43,24,23199,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3055',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65432,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65432,32.02,0.43,25.4,23199,75,NULL,'3.6 micron, color corrected','NGC 3055',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65433,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65433,32.19,0.2,27.4,23199,74.4,NULL,NULL,'NGC 3055',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65434,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65434,32.23,0.75,28,23199,NULL,NULL,'Malmquist cor.','NGC 3055',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65435,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65435,32.44,0.68,30.8,23199,NULL,NULL,NULL,'NGC 3055',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65436,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65436,32.54,0.4,32.2,23199,NULL,NULL,'mean','NGC 3055',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65437,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65437,32.68,0.47,34.3,23199,NULL,NULL,'H','NGC 3055',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65438,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65438,32.68,0.46,34.3,23199,NULL,NULL,'J','NGC 3055',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65439,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65439,32.71,0.45,34.8,23199,NULL,NULL,'K','NGC 3055',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65440,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65440,36.94,0.33,244,23200,70,NULL,NULL,'SDSS J095518.16+002321.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000068,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,148.825667,0.38931,0.065,NULL,60768239664,949503744,14835996,17.7),(65441,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65441,36.64,0.46,212,23201,70,NULL,NULL,'2MASX J09551937+3601264',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000178,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,148.830833,36.02392,0.013,NULL,64070336639,1001099009,15642172,17.4),(65442,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65442,35.04,0.6,102,23202,70,NULL,NULL,'2MFGC 07679',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,148.831583,-14.63206,0.153,NULL,41181974620,643468353,10054193,14.9),(65443,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65443,37.83,0.23,368,23203,70,NULL,NULL,'SDSS J095519.63+034217.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,148.831833,3.70492,0.057,NULL,60907683182,951682549,14870039,18.4),(65444,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65444,38.13,0.46,422,23204,70,NULL,NULL,'2MASX J09551979+3318552',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000182,NULL,'17.1g',0.23,'BrClG',NULL,NULL,NULL,NULL,1,148.8322917,33.31531,0.013,NULL,64181613413,1002837709,15669339,17.1),(65445,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65445,38.01,0.27,400,23205,70,NULL,NULL,'2MASX J09552036+3339012',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000131,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,148.834875,33.65028,0.013,NULL,64184951934,1002889873,15670154,17.5),(65446,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65446,38.31,0.46,460,23206,70,NULL,NULL,'SDSS J095520.55+070617.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,148.835625,7.10483,0.041,NULL,60924994689,951953042,14874266,18.4),(65447,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65447,37,0.33,251,23207,70,NULL,NULL,'2MASX J09552266+0425220',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,148.844417,4.42269,0.085,NULL,60908253125,951691455,14870178,16.7),(65448,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65448,35.53,0.54,128,23208,70,NULL,NULL,'2MASX J09552362-1254365',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,148.8484583,-12.91017,0.141,NULL,41180464447,643444756,10053824,15.9),(65449,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65449,37.95,0.46,390,23209,70,NULL,NULL,'2MASX J09552595+3329452',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000171,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,148.858208333,33.49586,0.013,NULL,64185057498,1002891523,15670180,17.7),(65450,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65450,37.49,0.46,314,23210,70,NULL,NULL,'2MASX J09552649+4407587',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,148.860583333,44.13294,0.005,NULL,63978721371,999667521,15619805,16.8),(65451,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65451,35.63,0.49,134,23211,70,NULL,NULL,'MCG -02-26-001',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15',0.2,NULL,NULL,NULL,NULL,NULL,1,148.8627917,-13.79772,0.141,NULL,41182165469,643471335,10054239,15),(65452,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65452,36.91,0.46,241,23212,70,NULL,NULL,'2MASX J09552912+0704271',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000158,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,148.8714583,7.07414,0.041,NULL,60925120875,951955013,14874297,16.5),(65453,'Tully est','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65453,31.55,0.8,20.4,23213,75,NULL,'B','UGCA 188',NULL,'1988NBGC.C....0000T',1988,1,0.96,NULL,'G',0.00009,NULL,'15.2g',0.54,'Sab? pec',NULL,NULL,NULL,NULL,1,148.87375,8.39064,0.073,NULL,60934468734,952101073,14876579,15.2),(65454,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65454,32.07,NULL,25.9,23213,NULL,NULL,NULL,'UGCA 188',NULL,'2015AstBu..70....1K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65455,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65455,37.71,0.46,349,23214,70,NULL,NULL,'2MASX J09553016+4530307',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,148.875583,45.50861,0.005,NULL,63979006063,999671969,15619874,17.4),(65456,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65456,36.84,0.19,233,23215,70,NULL,NULL,'2MASX J09553023+3617104',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000183,NULL,'16.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,148.8757917,36.28608,0.013,NULL,64070245390,1001097584,15642149,16.1),(65457,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65457,37.52,0.23,319,23216,70,NULL,NULL,'2MASX J09553172+3235272',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,148.8822917,32.59106,0.029,NULL,64182261906,1002847842,15669497,17.6),(65458,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65458,37.83,0.23,368,23217,70,NULL,NULL,'2MASX J09553183+0342160',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000208,NULL,'16.4g',0.35,'BrClG          AGN',NULL,NULL,NULL,NULL,1,148.882625,3.70439,0.057,NULL,60907709629,951682962,14870046,16.4),(65459,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65459,37.95,0.23,390,23218,70,NULL,NULL,'2MASX J09553209+2615263',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000191,NULL,'16.1g',0.41,NULL,NULL,NULL,NULL,NULL,1,148.883833333,26.25744,0.053,NULL,64170417125,1002662767,15666605,16.1),(65460,'GRB','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65460,43.11,NULL,4190,23219,NULL,NULL,NULL,'GRB 090423',NULL,'2011MNRAS.410.1611C',2011,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,148.888583,18.14942,0.033,NULL,60859513382,950929896,14858279,NULL),(65461,'GRB','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65461,49.95,1.66,10600,23219,NULL,NULL,NULL,'GRB 090423',8.26,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65462,'GRB','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65462,50.3,1.66,12400,23219,NULL,NULL,NULL,'GRB 090423',8.26,'2010ScChG..53S..64L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65463,'Brightest Stars','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65463,27.5,NULL,3.16,23220,NULL,NULL,'3R','MESSIER 081',NULL,'1992A&AS...95..581G',1992,1,26.9,NULL,'G',0.000013,NULL,'7.89',14.1,'SA(s)ab;LINER  Sy1.8','Pair member (points to parent)',NULL,NULL,'Flat-Spectrum Radio Source',1,148.8882083,69.06531,0.145,NULL,62126806707,970731354,15167677,7.89),(65464,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65464,27.55,0.2,3.24,23220,NULL,NULL,'31, VI','MESSIER 081',NULL,'1997ApJ...491...13K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65465,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65465,27.57,0.4,3.27,23220,73,NULL,'Cepheids periods Gaussian ','MESSIER 081',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65466,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65466,27.59,0.2,3.3,23220,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian ','MESSIER 081',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65467,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65467,27.59,0.31,3.3,23220,NULL,NULL,'2, I','MESSIER 081',NULL,'1988ApJ...332L..63F',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65468,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65468,27.59,0.31,3.3,23220,NULL,NULL,'2, I','MESSIER 081',NULL,'1991PASP..103..933M',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65469,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65469,27.6,0.2,3.31,23220,NULL,NULL,NULL,'MESSIER 081',NULL,'1998A&A...339..671P',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65470,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65470,27.6,0.03,3.31,23220,NULL,18.41,'107, VI, Z = -0.56 mag dex-1','MESSIER 081',NULL,'2011ApJ...743..176G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65471,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65471,27.62,0.08,3.34,23220,73,NULL,'Cepheids magnitudes Gaussian ','MESSIER 081',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65472,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65472,27.66,0.09,3.4,23220,NULL,NULL,'LMC W01','MESSIER 081',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65473,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65473,27.66,0.08,3.4,23220,NULL,NULL,'MW HIPP','MESSIER 081',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65474,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65474,27.7,0.16,3.47,23220,NULL,NULL,'MW P02','MESSIER 081',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65475,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65475,27.72,0.11,3.5,23220,NULL,NULL,'31, VI +Z','MESSIER 081',NULL,'1997ApJ...491...13K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65476,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65476,27.75,0.1,3.55,23220,NULL,NULL,'92, VI','MESSIER 081',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65477,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65477,27.75,0.08,3.55,23220,NULL,NULL,'17, VI, KEY PROJECT','MESSIER 081',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65478,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65478,27.75,0.1,3.55,23220,NULL,NULL,'MW GFG','MESSIER 081',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65479,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65479,27.75,0.08,3.55,23220,NULL,NULL,'LMC VIHJK','MESSIER 081',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65480,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65480,27.78,0.05,3.6,23220,NULL,18.41,'13, VI, LMC ZP','MESSIER 081',NULL,'2009AJ....137.4707M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65481,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65481,27.79,0.28,3.61,23220,NULL,NULL,'2, BVRI','MESSIER 081',NULL,'1993AJ....106.2243M',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65482,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65482,27.79,0.06,3.61,23220,74.4,NULL,NULL,'MESSIER 081',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65483,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65483,27.79,0.09,3.62,23220,NULL,NULL,'cte LMC K03','MESSIER 081',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65484,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65484,27.8,0.08,3.63,23220,NULL,NULL,'30, VI','MESSIER 081',NULL,'1994ApJ...427..628F',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65485,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65485,27.8,0.08,3.63,23220,NULL,NULL,'17, VI, +Z, KEY PROJECT','MESSIER 081',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65486,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65486,27.8,0.09,3.63,23220,NULL,NULL,'cte U99','MESSIER 081',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65487,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65487,27.8,0.09,3.63,23220,NULL,18.54,'LMC ZP','MESSIER 081',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65488,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65488,27.8,0.14,3.63,23220,NULL,18.41,'107, VI, Z = -0.56 mag dex-1','MESSIER 081',NULL,'2011ApJ...743..176G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65489,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65489,27.8,0.08,3.63,23220,NULL,NULL,'HST KP Calibrated','MESSIER 081',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65490,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65490,27.82,0.09,3.66,23220,NULL,NULL,'cte LMC STS02','MESSIER 081',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65491,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65491,27.85,0.1,3.72,23220,NULL,NULL,'cte MW FSG03','MESSIER 081',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65492,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65492,27.87,0.1,3.74,23220,NULL,NULL,'cte MW GFG98','MESSIER 081',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65493,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65493,27.89,0.09,3.78,23220,NULL,NULL,'cte MF91','MESSIER 081',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65494,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65494,27.91,0.08,3.82,23220,NULL,NULL,'6, H','MESSIER 081',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65495,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65495,27.91,0.08,3.82,23220,NULL,NULL,'6, H','MESSIER 081',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65496,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65496,27.94,0.1,3.87,23220,NULL,NULL,'cte MW STS03','MESSIER 081',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65497,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65497,28.02,0.13,4.02,23220,NULL,NULL,'6, I','MESSIER 081',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65498,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65498,28.02,0.13,4.02,23220,NULL,NULL,'6, I','MESSIER 081',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65499,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65499,28.1,NULL,4.17,23220,NULL,18.47,'Photographic','MESSIER 081',NULL,'1987SAAOC..11..125W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65500,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65500,28.12,0.05,4.21,23220,NULL,NULL,'BVRI','MESSIER 081',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65501,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65501,28.15,0.17,4.27,23220,NULL,NULL,'6, V','MESSIER 081',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65502,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65502,28.15,0.17,4.27,23220,NULL,NULL,'6, V','MESSIER 081',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65503,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65503,28.2,0.05,4.37,23220,NULL,NULL,'BVRI+','MESSIER 081',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65504,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65504,28.39,NULL,4.76,23220,NULL,NULL,'22, VI','MESSIER 081',NULL,'2006A&A...452..423P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65505,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65505,28.4,NULL,4.79,23220,NULL,NULL,'BV','MESSIER 081',NULL,'1991MNRAS.250..438M',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65506,'CMD','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65506,27.78,NULL,3.6,23220,NULL,NULL,NULL,'MESSIER 081',NULL,'2012ApJ...748...47M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65507,'CMD','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65507,27.89,0.06,3.78,23220,NULL,NULL,NULL,'MESSIER 081',NULL,'2009AJ....137..419W',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65508,'FGLR','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65508,27.68,0.09,3.44,23220,NULL,NULL,NULL,'MESSIER 081',NULL,'2012ApJ...747...15K',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65509,'GCLF','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65509,27.5,0.3,3.2,23220,NULL,NULL,NULL,'MESSIER 081',NULL,'1995AJ....109.1055P',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65510,'GCLF','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65510,27.53,0.26,3.2,23220,NULL,NULL,'MTO(V) = 7.5 mag','MESSIER 081',NULL,'1995PhDT........11P',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65511,'GCLF','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65511,27.86,0.28,3.73,23220,NULL,NULL,NULL,'MESSIER 081',NULL,'2011AJ....142..183N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65512,'GCLF','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65512,28.5,0.5,5,23220,NULL,NULL,NULL,'MESSIER 081',NULL,'2000ApJS..128..431F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65513,'Miras','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65513,27.67,0.25,3.4,23220,NULL,NULL,'Mira, LPV, PL(a)','MESSIER 081',NULL,'1998ASPC..135..390H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65514,'Miras','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65514,27.69,0.27,3.5,23220,NULL,NULL,'Mira, LPV, PL(b)','MESSIER 081',NULL,'1998ASPC..135..390H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65515,'Novae','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65515,27.75,NULL,3.55,23220,NULL,NULL,NULL,'MESSIER 081',NULL,'1999PASP..111.1367S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65516,'PNLF','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65516,27.7,0.09,3.47,23220,NULL,NULL,NULL,'MESSIER 081',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65517,'PNLF','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65517,27.72,0.25,3.5,23220,NULL,NULL,'185 PNe','MESSIER 081',NULL,'1989ApJ...344..704J',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65518,'PNLF','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65518,27.74,0.07,3.53,23220,NULL,NULL,NULL,'MESSIER 081',NULL,'1988ASPC....4...42J',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65519,'PNLF','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65519,27.88,0.12,3.77,23220,NULL,NULL,'HST KP Calibrated','MESSIER 081',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65520,'PNLF','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65520,27.92,0.23,3.84,23220,NULL,NULL,NULL,'MESSIER 081',NULL,'2001A&A...379...90M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65521,'PNLF','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65521,28,0.06,3.98,23220,NULL,NULL,'I','MESSIER 081',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65522,'S Doradus Stars','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65522,28,NULL,3.98,23220,NULL,NULL,NULL,'MESSIER 081',NULL,'1989A&A...217...87W',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65523,'SNII radio','2016-12-15 15:14:33','2016-12-16 11:19:39','1','SN 1993J',NULL,65523,26.9,0.17,2.4,23220,NULL,NULL,NULL,'MESSIER 081',NULL,'1998ApJ...500...51W',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65524,'SBF','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65524,27.5,0.09,3.16,23220,NULL,NULL,'I','MESSIER 081',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65525,'SBF','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65525,27.72,0.17,3.5,23220,NULL,NULL,'I','MESSIER 081',NULL,'1991ApJ...373L...1T',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65526,'SBF','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65526,27.78,0.08,3.6,23220,NULL,NULL,'I','MESSIER 081',NULL,'1997ApJ...475..399T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65527,'SBF','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65527,27.79,0.06,3.61,23220,74.4,NULL,NULL,'MESSIER 081',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65528,'SBF','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65528,27.8,0.26,3.63,23220,NULL,NULL,'I','MESSIER 081',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65529,'SBF','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65529,27.96,0.26,3.91,23220,NULL,NULL,NULL,'MESSIER 081',NULL,'2001ApJ...550..503J',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65530,'SBF','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65530,27.96,0.26,3.91,23220,NULL,NULL,'I','MESSIER 081',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65531,'SBF','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65531,28.02,0.28,4.02,23220,NULL,NULL,'HST KP Calibrated, I','MESSIER 081',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65532,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65532,27.68,0.09,3.44,23220,NULL,NULL,'I','MESSIER 081',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65533,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65533,27.69,0.04,3.45,23220,NULL,NULL,'I','MESSIER 081',NULL,'2007ApJ...661..815R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65534,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65534,27.72,0.06,3.49,23220,NULL,NULL,'I','MESSIER 081',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65535,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65535,27.77,0.02,3.58,23220,NULL,NULL,'I','MESSIER 081',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65536,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65536,27.77,0.04,3.58,23220,NULL,NULL,'I','MESSIER 081',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65537,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65537,27.78,0.04,3.6,23220,NULL,NULL,'I','MESSIER 081',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65538,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65538,27.79,0.07,3.6,23220,NULL,NULL,'I','MESSIER 081',NULL,'2011ApJS..195...18R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65539,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65539,27.79,0.06,3.61,23220,74.4,NULL,NULL,'MESSIER 081',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65540,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65540,27.8,0.03,3.63,23220,NULL,NULL,'GC-1','MESSIER 081',NULL,'2012ApJ...751L..19J',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65541,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65541,27.81,0.03,3.65,23220,NULL,NULL,'Field 1','MESSIER 081',NULL,'2012ApJ...751L..19J',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65542,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65542,27.81,0.03,3.65,23220,NULL,NULL,'Field 2','MESSIER 081',NULL,'2012ApJ...751L..19J',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65543,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65543,27.86,0.06,3.73,23220,NULL,NULL,'I','MESSIER 081',NULL,'2010ApJ...718.1118D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65544,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65544,27.93,0.04,3.85,23220,NULL,NULL,'VI','MESSIER 081',NULL,'2005A&A...431..127T',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65545,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65545,28.03,0.12,4.04,23220,NULL,NULL,NULL,'MESSIER 081',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65546,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65546,28.04,0.08,4.05,23220,NULL,NULL,'GC-2','MESSIER 081',NULL,'2012ApJ...751L..19J',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65547,'SNII optical','2016-12-15 15:14:33','2016-12-16 11:19:39','1','SN 1993J','R',65547,27.07,0.32,2.6,23220,NULL,NULL,'EPM','MESSIER 081',NULL,'1993PhDT........95S',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65548,'SNII optical','2016-12-15 15:14:33','2016-12-16 11:19:39','1','SN 1993J','R',65548,27.07,0.31,2.6,23220,NULL,NULL,'EPM','MESSIER 081',NULL,'1993Natur.364..600S',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65549,'SNII optical','2016-12-15 15:14:33','2016-12-16 11:19:39','1','SN 1993J',NULL,65549,27.66,0.06,3.4,23220,NULL,NULL,'SCM','MESSIER 081',NULL,'1994ApJ...426..334B',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65550,'SNII optical','2016-12-15 15:14:33','2016-12-16 11:19:39','1','SN 1993J',NULL,65550,27.71,0.05,3.48,23220,NULL,NULL,'EPM','MESSIER 081',NULL,'1995ApJ...446..167C',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65551,'SNII optical','2016-12-15 15:14:33','2016-12-16 11:19:39','1','SN 1993J',NULL,65551,27.99,0.03,3.96,23220,NULL,NULL,'ESM','MESSIER 081',NULL,'2007ApJ...668..924B',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65552,'SNII optical','2016-12-15 15:14:33','2016-12-16 11:19:39','1','SN 1993J',NULL,65552,28,0.3,3.98,23220,NULL,NULL,'EPM','MESSIER 081',NULL,'1995ApJ...441..170B',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65553,'SNII optical','2016-12-15 15:14:33','2016-12-16 11:19:39','1','SN 1993J',NULL,65553,28.01,0.26,4,23220,NULL,NULL,'EPM','MESSIER 081',NULL,'1993ApJ...416L..21B',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65554,'IRAS','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65554,28.36,0.8,4.69,23220,75,NULL,'A82, H','MESSIER 081',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65555,'Sosies','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65555,27.7,0.09,3.47,23220,NULL,NULL,NULL,'MESSIER 081',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65556,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65556,25.67,0.4,1.4,23220,75,NULL,'B','MESSIER 081',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65557,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65557,27.71,NULL,3.48,23220,NULL,NULL,'B','MESSIER 081',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65558,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65558,27.85,0.38,3.72,23220,53.9,NULL,'MESSIER 081 Group','MESSIER 081',NULL,'1984A&A...132..253R',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65559,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65559,27.86,NULL,3.73,23220,NULL,NULL,'IR','MESSIER 081',NULL,'1980ApJ...237..655A',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65560,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65560,27.95,NULL,3.89,23220,NULL,NULL,'I','MESSIER 081',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65561,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65561,27.96,0.4,3.9,23220,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','MESSIER 081',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65562,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65562,27.98,0.18,3.94,23220,NULL,NULL,'I','MESSIER 081',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65563,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65563,28,0.3,3.98,23220,NULL,18.45,'SN 1993J host','MESSIER 081',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65564,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65564,28.07,0.47,4.11,23220,75,NULL,'A82, H, raw','MESSIER 081',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65565,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65565,28.12,0.32,4.21,23220,NULL,NULL,'B','MESSIER 081',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65566,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65566,28.15,0.35,4.27,23220,NULL,NULL,NULL,'MESSIER 081',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65567,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65567,28.29,0.47,4.56,23220,75,NULL,'A82, H, inv','MESSIER 081',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65568,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65568,28.43,0.47,4.85,23220,75,NULL,'A82, H, cor','MESSIER 081',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65569,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65569,28.57,NULL,5.18,23220,NULL,NULL,'LEDA [April 2006]','MESSIER 081',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65570,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65570,33.7,0.45,55,23221,NULL,NULL,'K','NGC 3053',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000017,NULL,'13.63',0.9,'S(r)...','Pair member, wide',NULL,NULL,NULL,1,148.8900417,16.43286,0.085,NULL,60860955328,950952427,14858631,13.63),(65571,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65571,33.72,0.47,55.4,23221,NULL,NULL,'H','NGC 3053',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65572,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65572,33.76,0.34,56.5,23221,NULL,NULL,NULL,'NGC 3053',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65573,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65573,33.77,0.34,56.7,23221,NULL,NULL,'Malmquist cor.','NGC 3053',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65574,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65574,33.78,0.46,57,23221,NULL,NULL,'J','NGC 3053',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65575,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65575,33.81,0.4,57.8,23221,NULL,NULL,'mean','NGC 3053',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65576,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65576,33.9,0.2,60.3,23221,74.4,NULL,NULL,'NGC 3053',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65577,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65577,37.35,0.46,295,23222,70,NULL,NULL,'2MASX J09553372+0200560',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000085,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,148.8905,2.01547,0.029,NULL,60781193621,949706150,14839158,17.5),(65578,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65578,37.44,0.46,307,23223,70,NULL,NULL,'2MASX J09553577+0409300',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,148.899041667,4.15833,0.061,NULL,60908589780,951696715,14870261,17.9),(65579,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65579,37.32,0.46,291,23224,70,NULL,NULL,'2MASX J09553664+4217243',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000177,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,148.9025417,42.29017,0.025,NULL,64091148703,1001424198,15647253,16.8),(65580,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65580,38.14,0.46,424,23225,70,NULL,NULL,'2MASX J09553685+2618344',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000188,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,148.903417,26.30969,0.053,NULL,64170422894,1002662857,15666607,17.2),(65581,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65581,36.25,0.53,178,23226,70,NULL,NULL,'2MASX J09553732-0805379',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.54',NULL,NULL,NULL,NULL,NULL,NULL,1,148.905541667,-8.09414,0.169,NULL,41338729667,645917651,10092463,16.54),(65582,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65582,37.95,0.23,390,23227,70,NULL,NULL,'2MASX J09553774+2614504',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000177,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,148.907083,26.24744,0.053,NULL,64170416482,1002662757,15666605,18.3),(65583,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65583,37.86,0.46,373,23228,70,NULL,NULL,'2MASX J09553777+0527470',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000176,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,148.9072917,5.46303,0.069,NULL,60907200431,951675006,14869921,16.7),(65584,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65584,31.91,NULL,24.1,23229,NULL,NULL,NULL,'SDSS J095537.75+042836.2',NULL,'2015AstBu..70....1K',2015,1,0.62,NULL,'G',0.00006,NULL,'16.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,148.907333,4.47675,0.085,NULL,60908243875,951691310,14870176,16.4),(65585,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65585,37.03,0.46,255,23230,70,NULL,NULL,'SDSS J095538.10+131218.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,148.90875,13.20522,0.041,NULL,60825462701,950397854,14849966,17.7),(65586,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65586,35.8,0.57,144,23231,70,NULL,NULL,'2MASX J09553810-1529595',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,148.9087917,-15.49986,0.173,NULL,41176759125,643386861,10052919,13.5),(65587,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65587,36.98,0.46,249,23232,70,NULL,NULL,'2MASX J09553809+1700399',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,148.908833,17.01103,0.069,NULL,60859635644,950931806,14858309,16.3),(65588,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65588,38.4,0.46,480,23233,70,NULL,NULL,'2MASX J09553819+2800344',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,148.909041667,28.00961,0.037,NULL,64169440354,1002647505,15666367,17.6),(65589,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65589,37.13,0.46,267,23234,70,NULL,NULL,'2MASX J09553938+6257015',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000086,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,148.913833,62.95039,0.077,NULL,62029195204,969206175,15143846,16.9),(65590,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65590,37.1,0.46,263,23235,70,NULL,NULL,'2MASX J09553933+1351039',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,148.9140417,13.85106,0.033,NULL,60823359383,950364990,14849452,16.6),(65591,'IRAS','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65591,31.32,0.8,18.4,23236,75,NULL,'A82, H','NGC 3027',NULL,'1997ApJS..109..333W',1997,1,4.3,NULL,'G',0.000013,NULL,'12.18',2,'SB(rs)d:','in a pair',NULL,NULL,NULL,1,148.919167,72.20356,0.041,NULL,62106810245,970418910,15162795,12.18),(65592,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65592,31.1,0.38,16.6,23236,NULL,NULL,NULL,'NGC 3027',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65593,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65593,31.1,0.2,16.6,23236,74.4,NULL,NULL,'NGC 3027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65594,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65594,31.18,0.43,17.2,23236,75,NULL,'3.6 micron, color corrected','NGC 3027',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65595,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65595,31.26,0.4,17.9,23236,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 3027',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65596,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65596,31.27,0.43,17.9,23236,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3027',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65597,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65597,31.34,0.45,18.6,23236,NULL,NULL,NULL,'NGC 3027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65598,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65598,31.43,0.44,19.3,23236,NULL,NULL,'Malmquist cor.','NGC 3027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65599,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65599,31.45,0.4,19.5,23236,75,NULL,'B','NGC 3027',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65600,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65600,31.61,0.47,21,23236,75,NULL,'A82, H, inv','NGC 3027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65601,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65601,31.67,0.47,21.5,23236,75,NULL,'A82, H, raw','NGC 3027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65602,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65602,31.99,0.47,25,23236,75,NULL,'A82, H, cor','NGC 3027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65603,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65603,38.01,0.46,399,23237,70,NULL,NULL,'2MASX J09554060+0718371',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,148.919167,7.31044,0.029,NULL,60924917489,951951835,14874247,17.6),(65604,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65604,34.49,0.49,79.1,23238,75,NULL,'IR','NGC 3064',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'14.5',0.3,'Sbc? sp',NULL,NULL,NULL,NULL,1,148.9227083,-6.36392,0.141,NULL,41332329191,645817643,10090900,14.5),(65605,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65605,38.36,0.46,470,23239,70,NULL,NULL,'2MASX J09554149+5216262',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,148.923,52.27383,0,NULL,64009805349,1000153208,15627393,18.2),(65606,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65606,37.26,0.46,283,23240,70,NULL,NULL,'2MASX J09554165+3252244',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000142,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,148.923375,32.87344,0.025,NULL,64182071061,1002844860,15669450,17.8),(65607,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65607,37.69,0.46,346,23241,70,NULL,NULL,'2MASX J09554164+6010525',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000145,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,148.923375,60.18125,0.025,NULL,61923128682,967548885,15117951,18.2),(65608,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65608,37.95,0.23,390,23242,70,NULL,NULL,'2MASX J09554280+2614504',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000179,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,148.9285,26.24747,0.053,NULL,64170417506,1002662773,15666605,17.2),(65609,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65609,36.91,0.46,241,23243,70,NULL,NULL,'2MASX J09554524+0703451',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000176,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,148.938375,7.0625,0.041,NULL,60925145713,951955401,14874303,16.7),(65610,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65610,35.32,0.46,116,23244,70,NULL,NULL,'2MASX J09554549+3611362',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000172,NULL,'15.5g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,148.9395,36.19356,0.013,NULL,64070312530,1001098633,15642166,15.5),(65611,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65611,38.3,0.46,458,23245,70,NULL,NULL,'SDSS J095547.56-011248.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000079,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,148.9482083,-1.2135,0.065,NULL,41235740854,644308450,10067319,18.2),(65612,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65612,31.1,NULL,16.6,23246,NULL,NULL,NULL,'UGC 05332',NULL,'2015AstBu..70....1K',2015,1,1.1,NULL,'G',0.000013,NULL,'17.',0.3,'Im:',NULL,NULL,NULL,NULL,1,148.9515417,16.414,0.085,NULL,60861167344,950955739,14858683,17),(65613,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65613,37.54,0.15,321,23247,70,NULL,NULL,'2MASX J09554887-0005491',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.0001,NULL,'15.7g',0.52,'E0',NULL,NULL,NULL,NULL,1,148.953625,-0.09714,0.057,NULL,41223778363,644121536,10064399,15.7),(65614,'FP','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65614,37.66,0.33,341,23248,70,NULL,NULL,'2MASX J09555107+0134417',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000095,NULL,'16.4g',0.39,'BrClG',NULL,NULL,NULL,NULL,1,148.9627917,1.57814,0.053,NULL,60782810996,949731421,14839553,16.4),(65615,'Brightest Stars','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65615,27.7,0.4,3.5,23249,NULL,NULL,NULL,'MESSIER 082',NULL,'2000CRABS..53b...5G',2000,1,11.2,NULL,'G',0.000013,NULL,'9.30',4.3,'I0;Sbrst       HII','Pair member (points to parent)',NULL,'FR I',NULL,1,148.969708333,69.67939,0.125,NULL,62100366228,970318222,15161222,9.3),(65616,'PNLF','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65616,27.7,0.2,3.47,23249,NULL,NULL,'1 brightest','MESSIER 082',NULL,'2009ApJ...697.1138J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65617,'PNLF','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65617,28.1,0.2,4.2,23249,NULL,NULL,'84','MESSIER 082',NULL,'2009ApJ...697.1138J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65618,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:39','1','SN 2014J',NULL,65618,27.57,0.13,3.27,23249,NULL,NULL,'K','MESSIER 082',NULL,'2014MNRAS.443.2887F',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65619,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:39','1','SN 2014J',NULL,65619,27.72,NULL,3.5,23249,NULL,NULL,'NIR, model at 48.53 days','MESSIER 082',NULL,'2015ApJ...804...66V',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65620,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:39','1','SN 2014J',NULL,65620,27.84,NULL,3.7,23249,NULL,NULL,'NIR, model at 33.15 days','MESSIER 082',NULL,'2015ApJ...804...66V',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65621,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:39','1','SN 2014J',NULL,65621,27.85,0.09,3.72,23249,72,NULL,NULL,'MESSIER 082',NULL,'2015ApJ...798...39M',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65622,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:39','1','SN 2014J',NULL,65622,28.01,NULL,4,23249,NULL,NULL,'NIR, model at 44.12 days','MESSIER 082',NULL,'2015ApJ...804...66V',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65623,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:39','1','SN 2014J',NULL,65623,28.12,NULL,4.2,23249,NULL,NULL,'NIR, model at 40.11 days','MESSIER 082',NULL,'2015ApJ...804...66V',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65624,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65624,27.53,0.05,3.21,23249,NULL,NULL,'I','MESSIER 082',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65625,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65625,27.73,0.02,3.52,23249,NULL,NULL,'I','MESSIER 082',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65626,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65626,27.74,0.04,3.53,23249,NULL,NULL,'I','MESSIER 082',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65627,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65627,27.74,0.08,3.53,23249,74.4,NULL,NULL,'MESSIER 082',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65628,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65628,27.95,0.14,3.89,23249,NULL,NULL,NULL,'MESSIER 082',NULL,'1999ApJ...526..599S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65629,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65629,27.96,NULL,3.9,23249,NULL,NULL,'I','MESSIER 082',NULL,'2006ARep...50..517T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65630,'CO ring diameter','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65630,27.53,NULL,3.2,23249,NULL,NULL,NULL,'MESSIER 082',NULL,'1991PASJ...43..671S',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65631,'Tully est','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,NULL,65631,28.57,0.8,5.2,23249,75,NULL,'B','MESSIER 082',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65632,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:39','1',NULL,'R',65632,26.9,0.49,2.4,23249,75,NULL,'IR','MESSIER 082',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65633,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65633,27.72,NULL,3.5,23249,75,NULL,'HI','MESSIER 082',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65634,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65634,27.96,NULL,3.9,23249,75,NULL,'CO','MESSIER 082',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65635,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65635,28.58,NULL,5.2,23249,54,NULL,'HI','MESSIER 082',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65636,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65636,28.7,NULL,5.5,23249,65.2,NULL,'CO','MESSIER 082',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65637,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65637,37.11,0.46,264,23250,70,NULL,NULL,'2MASX J09555243+2359524',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000201,NULL,'15.9g',0.46,NULL,NULL,NULL,NULL,NULL,1,148.9685417,23.99783,0.073,NULL,63701213429,995331459,15552054,15.9),(65638,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65638,38.24,0.46,444,23251,70,NULL,NULL,'2MASX J09555291+1429048',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,148.9705,14.48478,0.037,NULL,60822829463,950356710,14849323,17),(65639,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65639,36.23,0.71,177,23252,70,NULL,NULL,'2MASX J09555344-0324004',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'16.73',0.29,NULL,NULL,NULL,NULL,NULL,1,148.97275,-3.40022,0.057,NULL,41228145174,644189768,10065465,16.73),(65640,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65640,36.69,0.46,218,23253,70,NULL,NULL,'2MASX J09555474+2727243',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00017,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,148.97825,27.45675,0.053,NULL,64172138306,1002689661,15667025,16.4),(65641,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65641,37.2,0.46,276,23254,70,NULL,NULL,'2MASX J09555572+4306133',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000141,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,148.982167,43.10372,0,NULL,63986217814,999784653,15621635,17.8),(65642,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65642,36.86,0.46,235,23255,70,NULL,NULL,'2MASX J09555631+0237457',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000069,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,148.9845,2.62931,0.041,NULL,60781691709,949713932,14839280,17),(65643,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65643,37.5,0.23,316,23256,70,NULL,NULL,'2MASX J09555654+1314058',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,148.9855417,13.23489,0.041,NULL,60825433720,950397401,14849959,16.9),(65644,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65644,35.62,0.56,133,23257,70,NULL,NULL,'MCG -02-26-002',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000137,NULL,'15',0.4,NULL,NULL,NULL,NULL,NULL,1,148.986167,-13.754,0.141,NULL,41182136779,643470887,10054232,15),(65645,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65645,37.06,0.46,258,23258,70,NULL,NULL,'2MASX J09555716+3943542',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00018,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,148.988083,39.73181,0,NULL,64092666420,1001447912,15647623,16.4),(65646,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65646,38.68,0.46,544,23259,70,NULL,NULL,'SDSS J095558.11+042123.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,148.992167,4.35656,0.093,NULL,60908380344,951693442,14870210,18.2),(65647,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65647,34.88,0.46,94.5,23260,70,NULL,NULL,'IC 2518',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000169,NULL,'15.4g',0.45,'E0',NULL,NULL,NULL,NULL,1,148.993875,37.15553,0.021,NULL,64056925228,1000889456,15638897,15.4),(65648,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65648,36.96,0.46,246,23261,70,NULL,NULL,'2MASX J09555946+1147459',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000142,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,148.997875,11.79606,0.041,NULL,60893888651,951467010,14866672,17.6),(65649,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65649,36.32,0.83,184,23262,70,NULL,NULL,'2MASX J09560005-1545162',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,149.000167,-15.75442,0.177,NULL,41194462757,643663480,10057241,15.3),(65650,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65650,37.66,0.33,341,23263,70,NULL,NULL,'2MASX J09560014+0147357',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000076,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,149.000583,1.79333,0,NULL,60780995706,949703057,14839110,17.9),(65651,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65651,36.42,0.46,193,23264,70,NULL,NULL,'2MASX J09560067+0616049',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,149.00275,6.26797,0.037,NULL,60924878856,951951232,14874238,17.2),(65652,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65652,36.84,0.19,233,23265,70,NULL,NULL,'2MASX J09560135+3611232',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,149.005625,36.18969,0.013,NULL,64070292420,1001098319,15642161,17.1),(65653,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65653,36.94,0.33,244,23266,70,NULL,NULL,'2MASX J09560136+0021287',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000096,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,149.00575,0.35803,0.061,NULL,60781790091,949715470,14839304,16.5),(65654,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65654,37.54,0.15,321,23267,70,NULL,NULL,'2MASX J09560170-0014274',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00008,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,149.007,-0.24103,0.089,NULL,41223756157,644121189,10064393,17.2),(65655,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65655,37.34,0.46,294,23268,70,NULL,NULL,'LCSB S1357O',NULL,'2015arXiv151105856S',2015,1,0.47,'2011ApJ...735..125S gives z=0.0709287.','G',0.000027,NULL,'17.0B',0.34,'SBc/E',NULL,NULL,NULL,NULL,1,149.017833,16.51481,0.049,NULL,60861141390,950955334,14858677,17),(65656,'IRAS','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65656,32.35,0.8,29.5,23269,75,NULL,'MAT, I','ESO 499- G 022',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.00002,NULL,'15.55',0.4,'Sc:            HII',NULL,NULL,NULL,NULL,1,149.018333,-27.10686,0.185,NULL,42832015677,669250244,10457035,15.55),(65657,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65657,32.78,0.32,35.9,23269,85,NULL,'I, inv','ESO 499- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65658,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65658,32.78,0.32,36,23269,85,NULL,'I, raw','ESO 499- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65659,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65659,32.91,0.4,38.3,23269,75,NULL,NULL,'ESO 499- G 022',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65660,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65660,33.05,0.11,40.8,23269,NULL,NULL,NULL,'ESO 499- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65661,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65661,33.1,0.43,41.7,23269,75,NULL,'MAT, I, raw','ESO 499- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65662,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65662,33.15,0.43,42.7,23269,75,NULL,'MAT, I, inv','ESO 499- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65663,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65663,33.29,0.2,45.5,23269,74.4,NULL,NULL,'ESO 499- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65664,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65664,33.35,0.43,46.7,23269,75,NULL,'MAT, I, cor','ESO 499- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65665,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65665,33.62,0.49,53,23269,75,NULL,'IR','ESO 499- G 022',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65666,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65666,37.77,0.46,358,23270,70,NULL,NULL,'2MASX J09560476-0035474',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000098,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,149.01975,-0.59644,0.081,NULL,41235374043,644302719,10067229,17),(65667,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65667,37.88,0.46,377,23271,70,NULL,NULL,'2MASX J09560512+1122029',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000146,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,149.021167,11.36747,0.049,NULL,60893498340,951460911,14866576,17.6),(65668,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65668,33.31,0.68,45.8,23272,NULL,NULL,'Malmquist cor.','ESO 316- G 004',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000013,NULL,'14.70',0.9,'SAB(rs)bc',NULL,NULL,NULL,NULL,1,149.02325,-37.77075,0.721,NULL,41963167754,655674496,10244914,14.7),(65669,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65669,33.31,0.68,46,23272,NULL,NULL,NULL,'ESO 316- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65670,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65670,33.35,0.2,46.8,23272,74.4,NULL,NULL,'ESO 316- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65671,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65671,37.49,0.46,314,23273,70,NULL,NULL,'SDSS J095606.01+460908.8',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.4g',0.34,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,149.025041667,46.15247,0.009,NULL,63977446700,999647604,15619493,16.4),(65672,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65672,36.7,0.6,219,23274,NULL,NULL,'Malmquist cor.','SDSS J095606.95+161717.4',NULL,'2009ApJS..182..474S',2009,1,0.38,NULL,'G',0.00002,NULL,'18.3g',0.09,NULL,NULL,NULL,NULL,NULL,1,149.029,16.28819,0.085,NULL,60861039349,950953739,14858652,18.3),(65673,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65673,36.9,0.55,239,23274,NULL,NULL,NULL,'SDSS J095606.95+161717.4',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65674,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65674,38.43,0.46,485,23275,70,NULL,NULL,'2MASX J09560708+2006003',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000174,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,149.029583,20.10014,0.057,NULL,63698577976,995290280,15551410,18),(65675,'IRAS','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65675,33.26,0.8,44.9,23276,75,NULL,'MAT, I','ESO 566- G 030',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'14.63',1,'SA(s)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,149.0344583,-21.98856,0.085,NULL,42294767432,660855741,10325870,14.63),(65676,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65676,33.29,0.32,45.5,23276,85,NULL,'I, raw','ESO 566- G 030',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65677,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65677,33.29,0.32,45.6,23276,85,NULL,'I, inv','ESO 566- G 030',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65678,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65678,33.66,0.43,54,23276,75,NULL,'MAT, I, raw','ESO 566- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65679,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65679,33.74,0.43,56.1,23276,75,NULL,'MAT, I, inv','ESO 566- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65680,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65680,33.86,0.43,59.1,23276,75,NULL,'MAT, I, cor','ESO 566- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65681,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65681,34.27,0.2,71.5,23276,74.4,NULL,NULL,'ESO 566- G 030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65682,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65682,34.47,0.69,78.4,23276,NULL,NULL,'Malmquist cor.','ESO 566- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65683,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65683,34.65,0.64,85.1,23276,NULL,NULL,NULL,'ESO 566- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65684,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65684,37.83,0.23,368,23277,70,NULL,NULL,'SDSS J095610.62+033634.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000145,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,149.04425,3.60947,0.049,NULL,60776650728,949635167,14838049,18.4),(65685,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65685,37.01,0.33,253,23278,70,NULL,NULL,'2MASX J09561110-0004395',NULL,'2015arXiv151105856S',2015,1,0.47,'2dFGRS gives z = 0.065160 +/- 0.000213.','G',0.000095,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,149.0462083,-0.07764,0.057,NULL,41223719018,644120609,10064384,16.4),(65686,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65686,37.7,0.46,347,23279,70,NULL,NULL,'SDSS J095611.81+233338.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000121,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,149.0492083,23.56067,0.057,NULL,63701887911,995341998,15552218,18.4),(65687,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65687,32.95,0.4,38.9,23280,NULL,NULL,'mean','NGC 3061',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000027,NULL,'13.47',1.5,'(R\')SB(rs)c','Isolated galaxy',NULL,NULL,NULL,1,149.0500417,75.8665,0.061,NULL,61381152159,959080502,14985632,13.47),(65688,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65688,34.27,0.47,71.3,23280,NULL,NULL,'H','NGC 3061',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65689,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65689,36.74,0.46,223,23281,70,NULL,NULL,'2MASX J09561200+5254008',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000188,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,149.050167,52.90028,0,NULL,63992938025,999889656,15623275,16.3),(65690,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65690,35.4,0.55,120,23282,70,NULL,NULL,'MCG -02-26-003',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'16',0.8,'SB0- pec?',NULL,NULL,NULL,NULL,1,149.057667,-12.96703,0.149,NULL,41180371834,643443309,10053801,16),(65691,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65691,38.22,0.46,441,23283,70,NULL,NULL,'2MASX J09561416+1603096',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,'PHOT','17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,149.059083,16.05264,0.081,NULL,60861262422,950957225,14858706,17.1),(65692,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65692,37.01,0.33,253,23284,70,NULL,NULL,'2MASX J09561424-0001145',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000101,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,149.059417,-0.02067,0.057,NULL,41235251273,644300801,10067200,16.4),(65693,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65693,36.13,0.46,168,23285,70,NULL,NULL,'2MASX J09561440+1350026',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'16.68',0.46,NULL,NULL,NULL,NULL,NULL,1,149.0597917,13.83411,0.033,NULL,60823404011,950365687,14849463,16.68),(65694,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65694,36.84,0.19,233,23286,70,NULL,NULL,'2MASX J09561457+3625136',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.00009,NULL,'15.3g',0.54,'E0',NULL,NULL,NULL,NULL,1,149.06075,36.4205,0.013,NULL,64070276625,1001098072,15642157,15.3),(65695,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65695,33.3,0.47,45.7,23287,NULL,NULL,'H','NGC 3043',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.00002,NULL,'13.44',0.6,'Sb: sp','Isolated galaxy',NULL,NULL,NULL,1,149.061875,59.30711,0.021,NULL,61913623144,967400361,15115630,13.44),(65696,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65696,33.3,0.4,45.8,23287,NULL,NULL,'mean','NGC 3043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65697,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65697,33.33,0.46,46.3,23287,NULL,NULL,'J','NGC 3043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65698,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65698,33.36,0.45,46.9,23287,NULL,NULL,'K','NGC 3043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65699,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65699,37.74,0.46,353,23288,70,NULL,NULL,'2MASX J09561490+2538423',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,149.062041667,25.64503,0.061,NULL,64170703529,1002667242,15666675,17.5),(65700,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65700,37.5,0.23,316,23289,70,NULL,NULL,'2MASX J09561503+1313016',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,149.062625,13.21722,0.041,NULL,60821976550,950343383,14849115,17.8),(65701,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65701,37,0.46,251,23290,70,NULL,NULL,'2MASX J09561506+4454187',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000163,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,149.062917,44.90511,0,NULL,63978986366,999671661,15619869,16.7),(65702,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65702,36.51,0.46,200,23291,70,NULL,NULL,'2MASX J09561531+0948079',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000165,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,149.0637083,9.80222,0.085,NULL,60929694278,952026473,14875413,16.4),(65703,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65703,36.84,0.19,233,23292,70,NULL,NULL,'2MASX J09561540+3625556',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,149.064333,36.43206,0.013,NULL,64070232553,1001097383,15642146,17.3),(65704,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65704,38.34,0.46,465,23293,70,NULL,NULL,'2MASX J09561595+4651447',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,149.066667,46.86236,0,NULL,64007687034,1000120109,15626876,17.7),(65705,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65705,37.3,0.46,288,23294,70,NULL,NULL,'SDSS J095616.01+025511.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000068,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,149.06675,2.91989,0.033,NULL,60780901289,949701582,14839087,18),(65706,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65706,36.44,0.46,194,23295,70,NULL,NULL,'2MASX J09561607+5011589',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000186,NULL,'15.9g',0.46,'E0',NULL,NULL,NULL,NULL,1,149.066875,50.19975,0,NULL,64019835440,1000309928,15629842,15.9),(65707,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65707,35.72,0.4,140,23296,NULL,NULL,'mean','IC 0578',NULL,'2007A&A...465...71T',2007,1,1.13,NULL,'G',0.00008,NULL,'14.7g',0.46,'SBa:','Pair member (points to parent)',NULL,NULL,NULL,1,149.067291667,10.48608,0.053,NULL,60930314832,952036169,14875565,14.7),(65708,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65708,35.86,0.47,149,23296,NULL,NULL,'H','IC 0578',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65709,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65709,35.3,0.33,115,23297,70,NULL,NULL,'CGCG 182-042',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.00008,NULL,'15.3g',0.51,'E0',NULL,NULL,NULL,NULL,1,149.069333333,37.64708,0.021,NULL,64058710053,1000917344,15639333,15.3),(65710,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65710,35.3,0.33,115,23298,70,NULL,NULL,'CGCG 182-041',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000113,NULL,'15.1g',0.56,'S0^-',NULL,NULL,NULL,NULL,1,149.072125,37.59003,0.029,NULL,64058705219,1000917269,15639332,15.1),(65711,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65711,37.17,0.46,272,23299,70,NULL,NULL,'2MASX J09561893+3324465',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,149.0787917,33.41292,0.013,NULL,64181742186,1002839721,15669370,17.4),(65712,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65712,37.5,0.23,316,23300,70,NULL,NULL,'2MASX J09561908+1313075',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,149.079583,13.21883,0.041,NULL,60821977007,950343390,14849115,17),(65713,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65713,33.76,0.46,56.5,23301,NULL,NULL,'J','NGC 3060',NULL,'2007A&A...465...71T',2007,1,2.2,NULL,'G',0.000013,NULL,'13.82',0.6,'Sb','Pair member, wide',NULL,NULL,NULL,1,149.08,16.83122,0.033,NULL,60863045280,950985082,14859141,13.82),(65714,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65714,33.79,0.47,57.2,23301,NULL,NULL,'H','NGC 3060',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65715,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65715,33.79,0.4,57.3,23301,NULL,NULL,'mean','NGC 3060',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65716,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65716,33.84,0.45,58.7,23301,NULL,NULL,'K','NGC 3060',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65717,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65717,33.9,0.49,60.1,23301,75,NULL,'IR','NGC 3060',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65718,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','PS1 SN PS11bk','N',65718,39.41,0.14,655,23302,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11bk HOST',0.1612,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65719,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65719,37.34,0.46,294,23303,70,NULL,NULL,'SDSS J095619.92+410313.7',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,149.0830417,41.05381,0.009,NULL,64092191071,1001440485,15647507,17.1),(65720,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65720,35.35,0.51,117,23304,70,NULL,NULL,'2MASX J09562079-1434215',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.16',NULL,NULL,NULL,NULL,NULL,NULL,1,149.086625,-14.57283,0.153,NULL,41181904251,643467253,10054175,16.16),(65721,'IRAS','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65721,32.59,0.8,33,23305,75,NULL,'MAT, I','ESO 435- G 010',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'14.65',0.6,'(R\'_2)SAB(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,149.0887917,-31.30358,0.241,NULL,42870963357,669858802,10466543,14.65),(65722,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65722,32.39,0.32,30,23305,85,NULL,'I, inv','ESO 435- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65723,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65723,32.39,0.32,30.1,23305,85,NULL,'I, raw','ESO 435- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65724,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65724,32.65,0.2,33.9,23305,74.4,NULL,NULL,'ESO 435- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65725,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65725,32.7,0.43,34.6,23305,75,NULL,'MAT, I, raw','ESO 435- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65726,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65726,32.74,0.43,35.3,23305,75,NULL,'MAT, I, inv','ESO 435- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65727,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65727,32.97,0.43,39.2,23305,75,NULL,'MAT, I, cor','ESO 435- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65728,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65728,33.03,0.1,40.4,23305,NULL,NULL,NULL,'ESO 435- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65729,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65729,37.27,0.46,284,23306,70,NULL,NULL,'2MASX J09562180+0050404',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000093,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,149.091,0.84453,0.065,NULL,60782613562,949728336,14839505,16.7),(65730,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65730,37.5,0.23,316,23307,70,NULL,NULL,'2MASX J09562196+1317515',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,149.091667,13.29753,0.037,NULL,60822094223,950345222,14849144,17.8),(65731,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65731,35.95,0.46,155,23308,70,NULL,NULL,'2MASX J09562241+1256295',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000176,NULL,'15.8g',0.42,'2MASS Extended Ver.2',NULL,NULL,NULL,NULL,1,149.093417,12.94167,0.045,NULL,60822423163,950350361,14849224,15.8),(65732,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65732,37.41,0.46,303,23309,70,NULL,NULL,'SDSS J095622.60+055112.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,149.0942083,5.85342,0.049,NULL,60907102586,951673477,14869898,18.1),(65733,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65733,37.52,0.46,319,23310,70,NULL,NULL,'2MASX J09562373+0252374',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000076,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,149.0990417,2.87722,0.033,NULL,60780892452,949701444,14839085,17.3),(65734,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65734,36.52,0.46,202,23311,70,NULL,NULL,'2MASXi J0956242+172157',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.5g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,149.1009583,17.36583,0.109,NULL,60859705398,950932896,14858326,17.5),(65735,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65735,36.85,0.23,235,23312,70,NULL,NULL,'2MASX J09562425+0113544',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000065,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,149.101,1.23192,0.053,NULL,60782538939,949727170,14839487,17.3),(65736,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65736,38.14,0.46,425,23313,70,NULL,NULL,'2MASX J09562734+2735152',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,149.113917,27.5875,0.049,NULL,64172180939,1002690327,15667036,17.2),(65737,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65737,35.84,0.46,147,23314,70,NULL,NULL,'2MASX J09562897+1438194',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'15.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,149.120791667,14.63864,0.045,NULL,60822808973,950356390,14849318,15.9),(65738,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65738,37.91,0.46,383,23315,70,NULL,NULL,'2MASX J09562939+1552514',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,149.122583,15.88083,0.073,NULL,60860569411,950946397,14858537,18.4),(65739,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65739,36.26,0.64,179,23316,70,NULL,NULL,'2MASX J09562965-1622265',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.65',NULL,NULL,NULL,NULL,NULL,NULL,1,149.123417,-16.37417,0.165,NULL,41194831151,643669236,10057331,16.65),(65740,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65740,35.73,0.46,140,23317,70,NULL,NULL,'2MASX J09563013+4610158',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'17.26',0.15,NULL,NULL,NULL,NULL,NULL,1,149.1255417,46.17111,0.009,NULL,63977506968,999648546,15619508,17.26),(65741,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65741,36.65,0.27,214,23318,70,NULL,NULL,'CGCG 182-044',NULL,'2015arXiv151105856S',2015,1,0.88,NULL,'G',0.00009,NULL,'15.1g',0.61,'E0',NULL,NULL,NULL,NULL,1,149.127625,35.91492,0.013,NULL,64070205703,1001096964,15642140,15.1),(65742,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65742,37.46,0.61,311,23319,70,NULL,NULL,'2MASX J09563078-1559045',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,149.128291667,-15.98461,0.157,NULL,41195328084,643677001,10057453,15.4),(65743,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65743,38.03,0.46,404,23320,70,NULL,NULL,'2MASX J09563179+4544408',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,149.132583,45.74478,0.017,NULL,63979462523,999679101,15619985,16.8),(65744,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65744,36.84,0.19,233,23321,70,NULL,NULL,'2MASX J09563288+3623207',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00018,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,149.137,36.38919,0.013,NULL,64070258796,1001097793,15642153,17.1),(65745,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65745,35.02,0.46,101,23322,70,NULL,NULL,'CGCG 008-003',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000074,NULL,'15.2g',0.6,'S0',NULL,NULL,NULL,NULL,1,149.139458333,1.84922,0,NULL,60783021117,949734704,14839604,15.2),(65746,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65746,37.93,0.46,385,23323,70,NULL,NULL,'2MASX J09563465+2157020',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000155,NULL,'17.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,149.144417,21.95042,0.073,NULL,63700656270,995322754,15551918,17.3),(65747,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65747,38.22,0.46,441,23324,70,NULL,NULL,'SDSS J095634.68+280047.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'18.3g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,149.1445,28.01328,0.037,NULL,64169230316,1002644223,15666315,18.3),(65748,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65748,35.95,0.46,155,23325,70,NULL,NULL,'MRK 1241',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.00017,NULL,'14.8g',0.66,'S0?',NULL,NULL,NULL,NULL,1,149.144875,11.16317,0.053,NULL,60927403197,951990674,14874854,14.8),(65749,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65749,38.06,0.46,410,23326,70,NULL,NULL,'2MASX J09563483+1820130',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,149.145041667,18.33694,0.053,NULL,60804898520,950076539,14844945,17.4),(65750,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65750,37.77,0.46,358,23327,70,NULL,NULL,'SDSS J095635.19+025003.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000068,NULL,'17.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,149.146667,2.83428,0.033,NULL,60781617679,949712776,14839262,17.9),(65751,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65751,36.62,0.56,211,23328,70,NULL,NULL,'2MASX J09563564-1558255',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.33',NULL,NULL,NULL,NULL,NULL,NULL,1,149.148583,-15.97389,0.157,NULL,41195311424,643676741,10057449,16.33),(65752,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65752,34.81,NULL,91.5,23329,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05341',NULL,'2010Ap&SS.325..163P',2010,1,3.1,NULL,'G',0.000006,NULL,'15.03',0.21,'Scd','Group member',NULL,NULL,NULL,1,149.1497083,20.64564,0.069,NULL,63696079379,995251240,15550800,15.03),(65753,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65753,34.81,NULL,91.7,23329,NULL,NULL,'Dipole','UGC 05341',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65754,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65754,34.81,NULL,91.7,23329,NULL,NULL,'Dipole + Quadrupole','UGC 05341',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65755,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65755,34.88,NULL,94.7,23329,NULL,NULL,NULL,'UGC 05341',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65756,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65756,35.03,0.49,101,23329,75,NULL,'IR','UGC 05341',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65757,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65757,35.3,0.4,115,23329,NULL,NULL,'mean','UGC 05341',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65758,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65758,35.37,0.45,118,23329,NULL,NULL,'K','UGC 05341',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65759,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65759,35.42,0.47,121,23329,NULL,NULL,'H','UGC 05341',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65760,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65760,35.54,0.46,128,23329,NULL,NULL,'J','UGC 05341',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65761,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65761,35.68,0.2,137,23329,74.4,NULL,NULL,'UGC 05341',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65762,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65762,37.89,0.23,378,23330,70,NULL,NULL,'2MASX J09563641+4642058',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,149.151625,46.70153,0,NULL,64007485010,1000116953,15626827,17.3),(65763,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65763,37.47,0.46,312,23331,70,NULL,NULL,'2MASX J09563667+3331404',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,149.152667,33.528,0.013,NULL,64181526050,1002836344,15669317,17.8),(65764,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65764,36.35,0.46,186,23332,70,NULL,NULL,'2MASX J09563743+6802276',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,149.1559583,68.04089,0.169,NULL,62118263577,970597868,15165591,17.6),(65765,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65765,37.54,0.15,321,23333,70,NULL,NULL,'SDSS J095637.95-002903.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00007,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,149.158167,-0.48417,0.089,NULL,41235503121,644304736,10067261,18.1),(65766,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65766,37.54,0.15,321,23334,70,NULL,NULL,'2MASX J09563864-0021284',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000099,NULL,'16.1g',0.44,'BrClG',NULL,NULL,NULL,NULL,1,149.160917,-0.35803,0.089,NULL,41235300485,644301570,10067212,16.1),(65767,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65767,37.89,0.23,378,23335,70,NULL,NULL,'2MASX J09564030+4642008',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,149.168125,46.70011,0,NULL,64007485148,1000116955,15626827,17.1),(65768,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65768,37.63,0.33,336,23336,70,NULL,NULL,'2MASX J09564035+1238494',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,149.1682083,12.64725,0.053,NULL,60822601208,950353143,14849267,17.2),(65769,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65769,38.23,0.46,443,23337,70,NULL,NULL,'2MASX J09564082+1949000',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,149.170041667,19.81686,0.041,NULL,63698405444,995287585,15551368,17.8),(65770,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65770,37.54,0.15,321,23338,70,NULL,NULL,'SDSS J095641.11-002148.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000072,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,149.1712917,-0.36342,0.089,NULL,41235300588,644301571,10067212,18.5),(65771,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65771,34.63,0.54,84.3,23339,70,NULL,NULL,'2MASX J09564118-1341285',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.00',NULL,NULL,NULL,NULL,NULL,NULL,1,149.171541667,-13.69133,0.141,NULL,41183121588,643486274,10054473,16),(65772,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65772,37.61,0.46,332,23340,70,NULL,NULL,'SDSS J095642.11+353931.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000157,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,149.1755,35.65869,0.013,NULL,64061892255,1000967066,15640110,18.3),(65773,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65773,37.05,0.46,257,23341,70,NULL,NULL,'2MASX J09564394+4814543',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000172,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,149.1830417,48.24836,0,NULL,64008444958,1000131952,15627061,16.6),(65774,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65774,37.29,0.46,287,23342,70,NULL,NULL,'2MASX J09564438+0141285',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000082,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,149.1849583,1.69125,0,NULL,60783045526,949735086,14839610,16.5),(65775,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65775,37.54,0.15,321,23343,70,NULL,NULL,'2MASX J09564471-0018424',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000073,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,149.186333,-0.31181,0.089,NULL,41235294599,644301478,10067210,17.9),(65776,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65776,37.39,0.46,301,23344,70,NULL,NULL,'2MASX J09564495+0342285',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000172,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,149.187333,3.70797,0.049,NULL,60777381325,949646583,14838227,17.4),(65777,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65777,37.56,0.27,325,23345,70,NULL,NULL,'2MASX J09564524+0656149',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000173,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,149.188417,6.93744,0,NULL,60925025333,951953520,14874273,16.6),(65778,'Brightest Stars','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65778,28.5,NULL,5.01,23346,NULL,NULL,NULL,'UGC 05340',NULL,'1998AJ....116.2886S',1998,1,2.7,NULL,'G',0.000017,NULL,'14.7B',1,'Im/BCD','Field galaxy',NULL,NULL,NULL,1,149.190417,28.82639,0.029,NULL,64161680024,1002526250,15664472,14.7),(65779,'Brightest Stars','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65779,28.85,0.2,5.89,23346,NULL,NULL,NULL,'UGC 05340',NULL,'1998A&AS..133..181M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65780,'CMD','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65780,30.4,0.05,12,23346,NULL,NULL,NULL,'UGC 05340',NULL,'2014AstL...40....1T',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65781,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65781,30.41,0.13,12.1,23346,NULL,NULL,NULL,'UGC 05340',NULL,'2013AJ....146....3S',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65782,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65782,30.53,0.05,12.7,23346,NULL,NULL,NULL,'UGC 05340',NULL,'2014ApJ...787L...1C',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65783,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65783,28.86,0.4,5.9,23346,75,NULL,'B','UGC 05340',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65784,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65784,29.96,NULL,9.82,23346,NULL,NULL,NULL,'UGC 05340',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65785,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65785,36.96,0.46,247,23347,70,NULL,NULL,'SDSS J095645.89+115714.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,149.19125,11.95392,0.045,NULL,60893157004,951455578,14866493,18.1),(65786,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65786,36.85,0.23,235,23348,70,NULL,NULL,'2MASX J09564653+0104125',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000077,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,149.193917,1.07019,0.065,NULL,60782645092,949728829,14839512,16.5),(65787,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65787,37.46,0.46,310,23349,70,NULL,NULL,'2MASX J09564668+0012095',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000095,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,149.194458333,0.20272,0.057,NULL,60781814689,949715854,14839310,16.4),(65788,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65788,37.74,0.46,353,23350,70,NULL,NULL,'2MASX J09564665-0044164',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00007,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,149.194541667,-0.73797,0.081,NULL,41235346516,644302289,10067223,18),(65789,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65789,35.95,0.46,155,23351,70,NULL,NULL,'2MASX J09564731+2213119',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000185,NULL,'15.6g',0.46,NULL,NULL,NULL,NULL,NULL,1,149.197167,22.22008,0.085,NULL,63702894506,995357726,15552464,15.6),(65790,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65790,36.45,0.46,195,23352,70,NULL,NULL,'2MASX J09564735+2131319',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000165,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,149.197333,21.52544,0.057,NULL,63700708210,995323565,15551930,18),(65791,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65791,36.85,0.23,235,23353,70,NULL,NULL,'2MASX J09564744+0115239',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000115,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,149.1977917,1.25664,0.053,NULL,60782483898,949726310,14839473,17),(65792,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65792,33.85,0.49,59,23354,70,NULL,NULL,'MCG -01-26-002',NULL,'2014MNRAS.445.2677S',2014,1,1.9,NULL,'G',0.000043,NULL,'14.07',0.5,'(R\')SB(s)ab?',NULL,NULL,NULL,NULL,1,149.1995417,-7.17964,0.145,NULL,41333968357,645843255,10091300,14.07),(65793,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65793,34.5,0.47,79.6,23354,NULL,NULL,'H','MCG -01-26-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65794,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65794,34.53,0.45,80.6,23354,NULL,NULL,'K','MCG -01-26-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65795,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65795,34.54,0.46,81,23354,NULL,NULL,'J','MCG -01-26-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65796,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65796,34.71,0.4,87.7,23354,NULL,NULL,'mean','MCG -01-26-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65797,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65797,37.89,0.33,379,23355,70,NULL,NULL,'2MASX J09564866+2610031',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000179,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,149.202833,26.16769,0.101,NULL,64170549228,1002664831,15666637,17.6),(65798,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65798,37.32,0.46,291,23356,70,NULL,NULL,'2MASX J09565021+1503292',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.99',0.38,NULL,NULL,NULL,NULL,NULL,1,149.209125,15.05806,0.053,NULL,60853124707,950830073,14856719,16.99),(65799,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65799,37.03,0.46,254,23357,70,NULL,NULL,'2MASX J09565138+0012319',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000114,NULL,'15.8g',0.45,'S0^-',NULL,NULL,NULL,NULL,1,149.214167,0.20881,0.057,NULL,60781781078,949715329,14839302,15.8),(65800,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65800,37.44,0.46,308,23358,70,NULL,NULL,'2MASX J09565244+0506489',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,149.2185,5.11353,0.085,NULL,60909666319,951713536,14870524,17.7),(65801,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65801,38.01,0.21,400,23359,70,NULL,NULL,'2MASX J09565295+1913119',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,149.220625,19.22011,0.037,NULL,63695119726,995236245,15550566,17),(65802,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65802,37.17,0.46,271,23360,70,NULL,NULL,'2MASX J09565441+2415071',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,149.226625,24.25189,0.081,NULL,63687603391,995118802,15548731,17.3),(65803,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65803,38.18,0.33,433,23361,70,NULL,NULL,'SDSS J095654.56+141548.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,149.227375,14.26344,0.037,NULL,60823249431,950363272,14849426,18.4),(65804,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65804,37.73,0.46,351,23362,70,NULL,NULL,'2MASX J09565501+4945234',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000165,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,149.229125,49.75653,0,NULL,64019926913,1000311358,15629864,16.9),(65805,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65805,37.89,0.23,378,23363,70,NULL,NULL,'SDSS J095655.63+464122.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,149.231833,46.68947,0,NULL,64007484333,1000116942,15626827,17.9),(65806,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65806,37.25,0.46,282,23364,70,NULL,NULL,'2MASX J09565616+0220409',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00007,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,149.234125,2.34469,0.029,NULL,60781550727,949711730,14839245,17.8),(65807,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65807,37.86,0.46,374,23365,70,NULL,NULL,'2MASX J09565714+1617592',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,149.238291667,16.29983,0.065,NULL,60861415769,950959621,14858744,18),(65808,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65808,37.63,0.33,336,23366,70,NULL,NULL,'2MASX J09565727+1240452',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000185,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,149.238791667,12.67925,0.053,NULL,60822566750,950352605,14849259,17),(65809,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65809,37.38,0.46,300,23367,70,NULL,NULL,'2MASX J09565753+3408384',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00014,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,149.2397083,34.14419,0.005,NULL,64061975984,1000968374,15640130,18.4),(65810,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65810,38.52,0.46,505,23368,70,NULL,NULL,'2MASX J09565765+0033039',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000086,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,149.24025,0.55097,0.057,NULL,60782008231,949718878,14839357,17.9),(65811,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65811,37.56,0.27,325,23369,70,NULL,NULL,'2MASX J09565782+0657351',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000178,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,149.240958333,6.95989,0,NULL,60925487050,951960735,14874386,16.7),(65812,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65812,38.05,0.46,407,23370,70,NULL,NULL,'SDSS J095657.90+003424.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000066,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,149.24125,0.57339,0.057,NULL,60781963507,949718179,14839346,18.4),(65813,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65813,37.02,0.33,253,23371,70,NULL,NULL,'2MASX J09565808+4055022',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000194,NULL,'15.7g',0.43,'E0',NULL,NULL,NULL,NULL,1,149.242167,40.91736,0,NULL,64092239037,1001441234,15647519,15.7),(65814,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65814,35.94,0.64,154,23372,70,NULL,NULL,'2MASX J09565821-1510422',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.56',0.5,NULL,NULL,NULL,NULL,NULL,1,149.2427083,-15.1785,0.145,NULL,41189118028,643579969,10055937,16.56),(65815,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65815,35.06,0.46,103,23373,70,NULL,NULL,'ARK 222',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000087,NULL,'15.0g',0.46,'E0',NULL,NULL,NULL,NULL,1,149.244417,3.77794,0.049,NULL,60777375282,949646488,14838226,15),(65816,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65816,38.13,0.46,423,23374,70,NULL,NULL,'SDSS J095659.69-010419.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000073,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,149.248708333,-1.07217,0.065,NULL,41236253669,644316463,10067444,18.7),(65817,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65817,38.1,0.46,418,23375,70,NULL,NULL,'2MASX J09565986+1223462',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000161,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,149.249375,12.39608,0.057,NULL,60821775121,950340236,14849066,17.2),(65818,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65818,37.54,0.15,321,23376,70,NULL,NULL,'2MASX J09570076-0023255',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000072,NULL,'17.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,149.253333,-0.39031,0.089,NULL,41235470507,644304226,10067253,17.5),(65819,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65819,38.01,0.21,400,23377,70,NULL,NULL,'2MASX J09570118+1859319',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,149.254917,18.99214,0.073,NULL,60805473038,950085516,14845086,18.3),(65820,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65820,37.78,0.46,359,23378,70,NULL,NULL,'2MASX J09570145+3208034',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,149.2560417,32.13428,0.045,NULL,64181431623,1002834869,15669294,17.6),(65821,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65821,36.97,0.46,248,23379,70,NULL,NULL,'2MASX J09570228+5008264',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,149.25925,50.14053,0,NULL,64019862672,1000310354,15629849,17.3),(65822,'SBF','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65822,27.61,0.17,3.3,23380,NULL,NULL,'R','SDSS J095702.62+683534.0',NULL,'2005A&A...437..823R',2005,1,NULL,'This is a globular cluster candidate in the galaxy KDG 061.','*Cl',NULL,NULL,NULL,NULL,'Candidate Glob.Cl.',NULL,NULL,NULL,NULL,1,149.260916667,68.59281,0.173,NULL,62127034185,970734909,15167732,NULL),(65823,'SBF','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65823,27.88,0.27,3.77,23380,NULL,NULL,'T01','SDSS J095702.62+683534.0',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65824,'SBF','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65824,27.88,0.27,3.77,23380,NULL,NULL,'J03','SDSS J095702.62+683534.0',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65825,'SBF','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65825,27.97,0.27,3.93,23380,NULL,NULL,'BV A01','SDSS J095702.62+683534.0',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65826,'SBF','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65826,28.39,0.3,4.76,23380,NULL,NULL,'M06','SDSS J095702.62+683534.0',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65827,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65827,27.66,1.42,3.4,23380,NULL,NULL,'I','SDSS J095702.62+683534.0',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65828,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65828,27.72,0.09,3.49,23380,NULL,NULL,'I','SDSS J095702.62+683534.0',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65829,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65829,27.72,NULL,3.49,23380,NULL,NULL,NULL,'SDSS J095702.62+683534.0',NULL,'2010ApJ...724.1030G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65830,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65830,27.77,0.04,3.58,23380,NULL,NULL,'I','SDSS J095702.62+683534.0',NULL,'2010MNRAS.406.1152M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65831,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65831,27.78,NULL,3.6,23380,NULL,NULL,NULL,'SDSS J095702.62+683534.0',NULL,'2000A&A...363..117K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65832,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65832,27.84,0.08,3.7,23380,NULL,NULL,NULL,'SDSS J095702.62+683534.0',NULL,'2007ASPC..374..247D',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65833,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65833,37.3,0.46,288,23381,70,NULL,NULL,'2MASX J09570257+4957054',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000187,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,149.260916667,49.95164,0,NULL,64019847523,1000310117,15629845,16.5),(65834,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65834,27.79,0.08,3.61,23382,74.4,NULL,NULL,'KDG 061',NULL,'2013AJ....146...86T',2013,1,1.2,'v=-135 (1997MNRAS.287..333J) is for the HII region [JLT97] A0951+68B.','G',0.00001,NULL,'14.9B',1,'dE','Group member',NULL,NULL,NULL,1,149.264375,68.59175,0.173,NULL,62127034184,970734909,15167732,14.9),(65835,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65835,37.89,0.33,379,23383,70,NULL,NULL,'2MASX J09570383+2611226',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,149.2659583,26.18975,0.101,NULL,64170545392,1002664771,15666637,17.7),(65836,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65836,37.02,0.33,253,23384,70,NULL,NULL,'2MASX J09570399+4055113',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,149.266875,40.91981,0,NULL,64092239757,1001441246,15647519,17.8),(65837,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65837,36.65,0.46,214,23385,70,NULL,NULL,'2MASX J09570670+1558392',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'15.8g',0.44,NULL,NULL,NULL,NULL,NULL,1,149.278083333,15.97758,0.077,NULL,60861268468,950957319,14858708,15.8),(65838,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65838,37.2,0.46,276,23386,70,NULL,NULL,'2MASX J09570696+0539059',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,149.279125,5.65167,0.053,NULL,60909405150,951709455,14870460,17.9),(65839,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65839,37.67,0.46,342,23387,70,NULL,NULL,'2MASX J09570715+3937573',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000184,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,149.2797083,39.63242,0,NULL,64090764031,1001418187,15647159,17.5),(65840,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65840,37.11,0.46,264,23388,70,NULL,NULL,'2MASX J09570770+2200102',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,149.282125,22.003,0.073,NULL,63700614753,995322105,15551907,16.9),(65841,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65841,37.72,0.27,349,23389,70,NULL,NULL,'2MASX J09570773+4406583',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00018,NULL,'16.1g',0.4,'E0',NULL,NULL,NULL,NULL,1,149.282375,44.11622,0,NULL,63978854178,999669596,15619837,16.1),(65842,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65842,36.36,0.33,187,23390,70,NULL,NULL,'CGCG 239-044',NULL,'2015arXiv151105856S',2015,1,0.75,'SDSS has z = 0.051261 +- 0.000192.','G',0.00006,NULL,'15.1g',0.54,'E/S0',NULL,NULL,NULL,NULL,1,149.2844583,48.97469,0,NULL,64006572074,1000102688,15626604,15.1),(65843,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65843,36.4,0.46,191,23391,70,NULL,NULL,'2MASX J09570899+3718173',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,149.2874583,37.30492,0.025,NULL,64056742279,1000886598,15638853,16.3),(65844,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65844,38.18,0.33,433,23392,70,NULL,NULL,'2MASXi J0957095+141729',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,149.28975,14.29167,0.045,NULL,60853457298,950835270,14856801,17.5),(65845,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65845,36.65,0.27,214,23393,70,NULL,NULL,'2MASX J09571047+3622032',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,149.293917,36.36764,0.013,NULL,64070971443,1001108928,15642327,17.8),(65846,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65846,37.01,0.46,253,23394,70,NULL,NULL,'2MASX J09571075+5018463',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',NULL,NULL,'16.61',0.39,NULL,NULL,NULL,NULL,NULL,1,149.2947917,50.31281,0,NULL,64011529156,1000180143,15627814,16.61),(65847,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65847,35.66,0.54,135,23395,70,NULL,NULL,'2MASX J09571209-3414368',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,149.300417,-34.24358,0.633,NULL,41969841484,655778773,10246543,15.2),(65848,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65848,38.68,0.23,543,23396,70,NULL,NULL,'SDSS J095712.63+191545.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000205,NULL,'18.0g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,149.302666667,19.26253,0.037,NULL,63695112607,995236134,15550564,18),(65849,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65849,37.81,0.46,364,23397,70,NULL,NULL,'2MASX J09571302+1517242',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,149.3042083,15.29008,0.061,NULL,60864652699,951010198,14859534,17),(65850,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65850,36.63,0.86,212,23398,70,NULL,NULL,'2MASX J09571318-0310075',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'16.39',0.32,NULL,NULL,NULL,NULL,NULL,1,149.3049583,-3.16886,0.081,NULL,41228775699,644199620,10065619,16.39),(65851,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65851,37.89,0.23,378,23399,70,NULL,NULL,'2MASXi J0957133+464303',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,149.3055417,46.71758,0,NULL,64007502709,1000117229,15626831,17.8),(65852,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65852,38.01,0.21,400,23400,70,NULL,NULL,'SDSS J095714.44+190006.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000146,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,149.3102083,19.00192,0.025,NULL,60805442212,950085034,14845078,18.7),(65853,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65853,37.72,0.27,349,23401,70,NULL,NULL,'2MASX J09571497+4408363',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000177,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,149.312333,44.14358,0,NULL,63978863969,999669749,15619839,18.1),(65854,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65854,37.56,0.27,325,23402,70,NULL,NULL,'2MASX J09571554+0659541',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00018,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,149.314917,6.99844,0,NULL,60925482421,951960662,14874385,17.3),(65855,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65855,38.01,0.21,400,23403,70,NULL,NULL,'2MASX J09571638+1906512',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00018,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,149.318375,19.11425,0.037,NULL,60805465890,950085404,14845084,16.8),(65856,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65856,32.58,0.4,32.9,23404,75,NULL,NULL,'UGC 05347',NULL,'2008Ap.....51..336K',2008,1,1.82,NULL,'G',0.000005,NULL,'15.1g',0.26,'Sd(f)',NULL,NULL,NULL,NULL,1,149.318833333,4.52697,0.069,NULL,60907946173,951686658,14870104,15.1),(65857,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65857,32.97,0.2,39.3,23404,74.4,NULL,NULL,'UGC 05347',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65858,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65858,32.98,NULL,39.4,23404,NULL,NULL,NULL,'UGC 05347',NULL,'2015AstBu..70....1K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65859,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65859,33,0.43,39.8,23404,75,NULL,'3.6 micron, color + selection bias corrected','UGC 05347',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65860,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65860,33.03,0.43,40.4,23404,75,NULL,'3.6 micron, color corrected','UGC 05347',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65861,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65861,33.13,0.49,42.3,23404,75,NULL,'IR','UGC 05347',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65862,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65862,33.49,NULL,49.8,23404,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05347',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65863,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65863,33.52,NULL,50.6,23404,NULL,NULL,'Dipole + Quadrupole','UGC 05347',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65864,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65864,33.52,NULL,50.6,23404,NULL,NULL,'Dipole','UGC 05347',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65865,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65865,33.58,NULL,52,23404,NULL,NULL,NULL,'UGC 05347',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65866,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65866,38.31,0.46,459,23405,70,NULL,NULL,'SDSS J095717.84+451838.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00016,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,149.324417,45.31058,0.005,NULL,63979863798,999685371,15620083,18.7),(65867,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65867,36.9,0.46,239,23406,70,NULL,NULL,'2MASX J09571789+0058574',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00008,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,149.324625,0.98264,0.065,NULL,60782795811,949731184,14839549,16.6),(65868,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65868,37.15,0.46,269,23407,70,NULL,NULL,'2MASXi J0957181+135241',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,149.325417,13.87828,0.033,NULL,60823232743,950363011,14849422,17.8),(65869,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65869,36.52,0.64,201,23408,70,NULL,NULL,'CGCG 008-004',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'14.4',0.5,NULL,'Group member of poor cluster',NULL,NULL,NULL,1,149.3304583,-2.41619,0.077,NULL,41237095095,644329610,10067650,14.4),(65870,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65870,38.07,0.46,411,23409,70,NULL,NULL,'2MASX J09572148+0506214',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.4g',0.23,'BrClG',NULL,NULL,NULL,NULL,1,149.339416667,5.10603,0.085,NULL,60909459039,951710297,14870473,17.4),(65871,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65871,37.22,0.46,278,23410,70,NULL,NULL,'2MASX J09572153+3459500',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,149.339541667,34.99719,0.005,NULL,64062713846,1000979903,15640310,18),(65872,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65872,37.79,0.46,361,23411,70,NULL,NULL,'2MASX J09572147+3755101',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,149.339541667,37.9195,0.021,NULL,64058800146,1000918752,15639355,18.2),(65873,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65873,36.85,0.23,235,23412,70,NULL,NULL,'2MASX J09572169+0112344',NULL,'2015arXiv151105856S',2015,1,0.66,'The APM image includes a superposed star.','G',0.000113,NULL,'15.9g',0.36,NULL,NULL,NULL,NULL,NULL,1,149.34025,1.20933,0.017,NULL,60782571849,949727685,14839495,15.9),(65874,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65874,36.65,0.27,214,23413,70,NULL,NULL,'2MASX J09572177+3633566',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000206,NULL,'15.6g',0.49,'E0',NULL,NULL,NULL,NULL,1,149.340583333,36.56561,0.009,NULL,64070979968,1001109062,15642329,15.6),(65875,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65875,37.84,0.27,369,23414,70,NULL,NULL,'2MASX J09572181+2726397',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000147,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,149.341,27.44431,0.053,NULL,64172265374,1002691646,15667056,17.3),(65876,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65876,36.51,0.46,200,23415,70,NULL,NULL,'2MASX J09572300+0529574',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00016,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,149.345875,5.49928,0.045,NULL,60909310065,951707969,14870437,16.7),(65877,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65877,37.72,0.27,349,23416,70,NULL,NULL,'2MASX J09572324+4409172',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000199,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,149.346916667,44.15475,0,NULL,63978864223,999669753,15619839,16.5),(65878,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65878,38.01,0.21,400,23417,70,NULL,NULL,'2MASX J09572343+1906101',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,149.347667,19.10283,0.025,NULL,60805467477,950085429,14845084,17.7),(65879,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65879,33.07,0.5,41.1,23418,70,NULL,NULL,'NGC 3072',NULL,'2014MNRAS.445.2677S',2014,1,1.9,NULL,'G',0.00008,NULL,'13.71',0.6,'S0/a? sp       HII?',NULL,NULL,NULL,NULL,1,149.3495417,-19.35497,0.121,NULL,42283320213,660676878,10323076,13.71),(65880,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65880,37.49,0.33,314,23419,70,NULL,NULL,'2MASX J09572774+1644443',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,149.365666667,16.74567,0.049,NULL,60863143426,950986616,14859165,16.7),(65881,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65881,38.81,0.46,579,23420,70,NULL,NULL,'2MASX J09572786+2808147',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000183,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,149.366083,28.13739,0.037,NULL,64172071206,1002688612,15667009,17.2),(65882,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65882,37.6,0.46,331,23421,70,NULL,NULL,'2MASX J09572808+1657023',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,149.367,16.95061,0.033,NULL,60863109700,950986089,14859157,16.9),(65883,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65883,37.54,0.15,321,23422,70,NULL,NULL,'2MASX J09572849-0018177',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00007,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,149.368791667,-0.30508,0.089,NULL,41231288412,644238881,10066232,17.2),(65884,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65884,36.84,0.19,233,23423,70,NULL,NULL,'2MASX J09572873+3638376',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.00019,NULL,'15.6g',0.45,'E0',NULL,NULL,NULL,NULL,1,149.369625,36.64372,0.009,NULL,64070708480,1001104820,15642262,15.6),(65885,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65885,36.98,0.46,249,23424,70,NULL,NULL,'2MASX J09572961+0355055',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000166,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,149.373417,3.91822,0.049,NULL,60777155248,949643050,14838172,17.1),(65886,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65886,37.7,0.46,346,23425,70,NULL,NULL,'2MASX J09573041+2354170',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000181,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,149.376916667,23.90475,0.081,NULL,63687438762,995116230,15548691,16.8),(65887,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65887,37.49,0.33,314,23426,70,NULL,NULL,'2MASX J09573060+1644513',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,149.3775,16.74769,0.049,NULL,60863097118,950985892,14859154,17.1),(65888,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65888,35.55,0.46,129,23427,70,NULL,NULL,'CGCG 182-048',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000123,NULL,'15.2g',0.48,'E0',NULL,NULL,NULL,NULL,1,149.381167,36.09131,0.013,NULL,64071054641,1001110228,15642347,15.2),(65889,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65889,37.44,0.46,308,23428,70,NULL,NULL,'SDSS J095731.67+311300.9',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.7g',0.29,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,149.382,31.21694,0.057,NULL,64214928144,1003358252,15677472,16.7),(65890,'Brightest Stars','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65890,27.07,NULL,2.59,23429,NULL,NULL,'LF','Holmberg IX',NULL,'1997AstL...23..656G',1997,1,2.5,NULL,'G',0.00002,NULL,'14.3',2,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,149.383333,69.04583,0.145,1,62126776703,970730885,15167670,14.3),(65891,'Brightest Stars','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65891,27.11,0.4,2.64,23429,NULL,NULL,'3B + 3R mean','Holmberg IX',NULL,'1997AstL...23..656G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65892,'Brightest Stars','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65892,27.43,NULL,3.06,23429,NULL,NULL,'3R','Holmberg IX',NULL,'1991A&AS...89..529G',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65893,'Brightest Stars','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65893,27.66,0.27,3.4,23429,NULL,NULL,NULL,'Holmberg IX',NULL,'2004A&A...423...87G',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65894,'Brightest Stars','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65894,27.67,NULL,3.42,23429,NULL,NULL,'3B + 3R mean','Holmberg IX',NULL,'1991A&AS...89..529G',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65895,'Brightest Stars','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65895,28.16,NULL,4.29,23429,NULL,NULL,'3B','Holmberg IX',NULL,'1991A&AS...89..529G',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65896,'Brightest Stars','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65896,30,NULL,10,23429,NULL,NULL,NULL,'Holmberg IX',NULL,'1987A&A...188....5H',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65897,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65897,27.79,0.08,3.61,23429,NULL,NULL,'I','Holmberg IX',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65898,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65898,27.84,NULL,3.7,23429,NULL,NULL,NULL,'Holmberg IX',NULL,'2006Ap.....49....3K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65899,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65899,27.88,0.08,3.77,23429,74.4,NULL,NULL,'Holmberg IX',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65900,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65900,27.89,0.05,3.78,23430,NULL,NULL,'I','Arp\'s Loop',NULL,'2009ApJS..183...67D',2009,1,1.8,NULL,'G',NULL,NULL,'16.08',1.6,'Ir',NULL,NULL,NULL,NULL,1,149.385916667,69.28342,0.121,NULL,62126611746,970728308,15167629,16.08),(65901,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65901,27.94,0.12,3.87,23430,NULL,NULL,'I','Arp\'s Loop',NULL,'2002A&A...383..125K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65902,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65902,27.94,0.08,3.88,23430,74.4,NULL,NULL,'Arp\'s Loop',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65903,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65903,36.22,0.33,175,23431,70,NULL,NULL,'2MASX J09573274+0428075',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000164,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,149.386417,4.46867,0.065,NULL,60907879192,951685612,14870087,16.8),(65904,'Tully est','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65904,31.98,0.8,24.9,23432,75,NULL,'B','IC 2524',NULL,'1988NBGC.C....0000T',1988,1,0.74,NULL,'G',0.000011,NULL,'14.7g',0.49,'S?;WR?         HII','Group member',NULL,NULL,NULL,1,149.386917,33.61972,0.013,NULL,64181542690,1002836604,15669321,14.7),(65905,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65905,37.9,0.46,379,23433,70,NULL,NULL,'SDSS J095735.02+371613.8',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000173,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,149.3959583,37.2705,0.025,NULL,64056771702,1000887057,15638860,17.8),(65906,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65906,37.86,0.46,373,23434,70,NULL,NULL,'SDSS J095735.24+012436.9',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000081,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,149.396833,1.41028,0.017,NULL,60782421270,949725332,14839458,17.7),(65907,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65907,36.79,0.46,228,23435,70,NULL,NULL,'2MASX J09573559+0234565',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,149.398375,2.58253,0.017,NULL,60781408628,949709509,14839211,17),(65908,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65908,36.87,0.46,237,23436,70,NULL,NULL,'2MASX J09573666+0707515',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000177,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,149.40275,7.13097,0.005,NULL,60925506475,951961038,14874391,16.6),(65909,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65909,36.36,0.33,187,23437,70,NULL,NULL,'2MASX J09573770+4859592',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000181,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,149.407,48.99994,0,NULL,64006584823,1000102887,15626607,16.4),(65910,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65910,36.22,0.33,175,23438,70,NULL,NULL,'2MASX J09573842+0426535',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000179,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,149.410083333,4.44822,0.065,NULL,60907877091,951685579,14870087,16.4),(65911,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65911,38.1,0.46,417,23439,70,NULL,NULL,'2MASX J09573866+1112365',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000177,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,149.411167,11.21011,0.049,NULL,60927497612,951992150,14874877,17.1),(65912,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65912,34.04,0.48,64.1,23440,70,NULL,NULL,'2MASX J09574153-2156074',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000117,NULL,'12.7I',0.4,NULL,NULL,NULL,NULL,NULL,1,149.423,-21.93533,0.093,NULL,42294104225,660845378,10325709,12.7),(65913,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65913,37.54,0.15,321,23441,70,NULL,NULL,'2MASX J09574175-0021177',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000084,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,149.424041667,-0.35489,0.089,NULL,41231300745,644239074,10066235,17),(65914,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65914,38.04,0.46,405,23442,70,NULL,NULL,'2MASX J09574189+1940080',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,149.424583,19.66894,0.033,NULL,63694970394,995233912,15550529,17.2),(65915,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65915,34.59,NULL,82.7,23443,NULL,NULL,NULL,'MCG +06-22-041',NULL,'2000BSAO...50....5K',2000,1,0.95,'Velocity may refer to MCG +06-22-038. See Giovanelli (1997,AJ,114,122).','G',0.000065,NULL,'17.0g',0.09,'Sd',NULL,NULL,NULL,NULL,1,149.428667,36.06914,0.013,NULL,64071057128,1001110267,15642347,17),(65916,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65916,35.06,NULL,103,23443,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG +06-22-041',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65917,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65917,35.06,NULL,103,23443,NULL,NULL,'Dipole + Quadrupole','MCG +06-22-041',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65918,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65918,35.08,NULL,104,23443,NULL,NULL,'Dipole','MCG +06-22-041',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65919,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65919,36.9,0.46,240,23444,70,NULL,NULL,'2MASX J09574328+0145165',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000102,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,149.430375,1.75458,0.013,NULL,60782896438,949732756,14839574,16.6),(65920,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65920,36.57,0.68,206,23445,70,NULL,NULL,'2MASX J09574412-0614173',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.01',0.39,NULL,NULL,NULL,NULL,NULL,1,149.433833,-6.23825,0.125,NULL,41334347656,645849182,10091393,16.01),(65921,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65921,37.51,0.46,318,23446,70,NULL,NULL,'2MASX J09574472+1626003',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,149.436375,16.43356,0.061,NULL,60861250736,950957042,14858703,17.5),(65922,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65922,37.4,0.46,302,23447,70,NULL,NULL,'2MASX J09574510+0051415',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000081,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,149.4380417,0.8615,0.037,NULL,60782717172,949729955,14839530,16.6),(65923,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65923,37.62,0.33,335,23448,70,NULL,NULL,'2MASX J09574520-0105010',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000101,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,149.438333,-1.08356,0.069,NULL,41236277974,644316843,10067450,17.4),(65924,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65924,38.08,0.46,412,23449,70,NULL,NULL,'2MASX J09574564+3411011',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000175,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,149.44025,34.18369,0.005,NULL,64061992288,1000968629,15640134,17.5),(65925,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65925,37.84,0.27,369,23450,70,NULL,NULL,'2MASX J09574597+2727227',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000173,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,149.4415417,27.45631,0.053,NULL,64172242028,1002691281,15667051,17.6),(65926,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65926,37.54,0.15,321,23451,70,NULL,NULL,'2MASX J09574747-0018100',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000085,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,149.447917,-0.30289,0.089,NULL,41231298697,644239042,10066235,16.7),(65927,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65927,38.68,0.23,543,23452,70,NULL,NULL,'2MASX J09574753+1912020',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000144,NULL,'18.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,149.4480417,19.2005,0.037,NULL,60805584457,950087257,14845113,18.3),(65928,'IRAS','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65928,32.79,0.8,36.2,23453,75,NULL,'MAT, I','ESO 435- G 014',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.000005,NULL,'14.40',0.3,'Sc: sp',NULL,NULL,NULL,NULL,1,149.45175,-28.50656,0.169,NULL,42826997439,669171834,10455809,14.4),(65929,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65929,32.31,0.4,29,23453,75,NULL,NULL,'ESO 435- G 014',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65930,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65930,32.7,0.49,34.6,23453,75,NULL,'IR','ESO 435- G 014',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65931,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65931,32.87,0.43,37.6,23453,75,NULL,'3.6 micron, color + selection bias corrected','ESO 435- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65932,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65932,32.9,0.43,38,23453,75,NULL,'3.6 micron, color corrected','ESO 435- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65933,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65933,32.9,0.2,38,23453,74.4,NULL,NULL,'ESO 435- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65934,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65934,33.01,0.4,40,23453,NULL,NULL,'mean','ESO 435- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65935,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65935,33.18,0.14,43.3,23453,NULL,NULL,NULL,'ESO 435- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65936,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65936,33.3,0.47,45.8,23453,NULL,NULL,'H','ESO 435- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65937,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65937,33.34,0.46,46.5,23453,NULL,NULL,'J','ESO 435- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65938,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65938,33.44,0.32,48.7,23453,85,NULL,'I, raw','ESO 435- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65939,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65939,33.46,0.43,49.2,23453,75,NULL,'MAT, I, raw','ESO 435- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65940,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65940,33.47,0.32,49.5,23453,85,NULL,'I, inv','ESO 435- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65941,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65941,33.48,0.45,49.7,23453,NULL,NULL,'K','ESO 435- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65942,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65942,33.61,0.43,52.7,23453,75,NULL,'MAT, I, cor','ESO 435- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65943,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65943,33.64,0.43,53.4,23453,75,NULL,'MAT, I, inv','ESO 435- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65944,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65944,35.22,0.46,111,23454,70,NULL,NULL,'MCG -02-26-009',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000083,NULL,'15',0.5,NULL,NULL,NULL,NULL,NULL,1,149.4522917,-13.59303,0.177,NULL,41188338430,643567787,10055746,15),(65945,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65945,37.84,0.27,369,23455,70,NULL,NULL,'SDSS J095748.76+272753.1',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'17.9g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,149.453208333,27.46478,0.053,NULL,64172242091,1002691282,15667051,17.9),(65946,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65946,37.62,0.33,335,23456,70,NULL,NULL,'2MASX J09574880-0109080',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000063,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,149.453458333,-1.15214,0.069,NULL,41236061592,644313462,10067397,17.7),(65947,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65947,37.74,0.33,354,23457,70,NULL,NULL,'SDSS J095749.28+284454.8',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.6g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,149.455375,28.74858,0.045,NULL,64163456083,1002554001,15664906,17.6),(65948,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65948,32.4,0.4,30.2,23458,75,NULL,NULL,'ESO 435- G 015',NULL,'2008Ap.....51..336K',2008,1,1.5,NULL,'G',0.000033,NULL,'15.54',0.3,'Sb:',NULL,NULL,NULL,NULL,1,149.456667,-31.01092,0.241,NULL,42824698075,669135907,10455248,15.54),(65949,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65949,32.99,0.49,39.7,23458,75,NULL,'IR','ESO 435- G 015',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65950,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65950,36.13,0.46,169,23459,70,NULL,NULL,'2MASX J09575020+4532242',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.1g',0.34,NULL,NULL,NULL,NULL,NULL,1,149.459041667,45.54014,0.009,NULL,63979881500,999685648,15620088,16.1),(65951,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65951,37.35,0.46,296,23460,70,NULL,NULL,'SDSS J095750.33-004644.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000062,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,149.459708333,-0.77903,0.045,NULL,41236160590,644315009,10067422,18),(65952,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65952,37.74,0.33,354,23461,70,NULL,NULL,'2MASX J09574927+2844547',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,149.460375,28.74589,0.045,NULL,64163456974,1002554015,15664906,18),(65953,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65953,35.44,0.46,123,23462,70,NULL,NULL,'CGCG 036-011',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000176,NULL,'15.7g',0.38,'E','Isolated galaxy',NULL,NULL,NULL,1,149.46425,7.83647,0.029,NULL,60923793670,951934276,14873973,15.7),(65954,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65954,37.55,0.46,324,23463,70,NULL,NULL,'2MASX J09575241+0531580',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000147,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,149.468375,5.53286,0.045,NULL,60909317318,951708083,14870438,17.7),(65955,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65955,37.9,0.46,379,23464,70,NULL,NULL,'2MASX J09575281+0540480',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000175,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,149.470041667,5.67992,0.053,NULL,60909371403,951708928,14870452,18),(65956,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65956,37.7,0.33,347,23465,70,NULL,NULL,'2MASX J09575434+1936100',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,149.476667,19.60289,0.033,NULL,63694973817,995233965,15550530,17.9),(65957,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65957,37.74,0.66,353,23466,70,NULL,NULL,'2MASX J09575552-1706043',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.58',NULL,NULL,NULL,NULL,NULL,NULL,1,149.481375,-17.10125,0.141,NULL,41196405111,643693829,10057716,16.58),(65958,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65958,38.16,0.46,428,23467,70,NULL,NULL,'2MASX J09575663+6146155',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00008,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,149.4857917,61.77103,0.069,NULL,61909732476,967339569,15114680,17.5),(65959,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65959,37.51,0.46,318,23468,70,NULL,NULL,'SDSS J095757.27+275309.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000138,NULL,'17.9g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,149.488667,27.88606,0.049,NULL,64172108138,1002689189,15667018,17.9),(65960,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65960,36.26,0.65,179,23469,70,NULL,NULL,'2MASX J09580038-8307101',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,149.500833,-83.11953,0.369,NULL,39751368159,621115127,9704923,17),(65961,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65961,38.2,0.46,436,23470,70,NULL,NULL,'2MASX J09580075+3423229',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000201,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,149.503,34.38961,0.005,NULL,64062207458,1000971991,15640187,17.2),(65962,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65962,37.59,0.33,329,23471,70,NULL,NULL,'2MASX J09580141+0635272',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000172,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,149.5059583,6.59097,0.009,NULL,60925928777,951967637,14874494,16.8),(65963,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65963,36.8,0.46,229,23472,70,NULL,NULL,'2MASX J09580314+1325320',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,149.51325,13.42572,0.037,NULL,60851518370,950804974,14856327,17.1),(65964,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65964,37.7,0.33,347,23473,70,NULL,NULL,'2MASX J09580526+1935322',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,149.5219583,19.59211,0.033,NULL,63694974096,995233970,15550530,17.4),(65965,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65965,31.84,0.4,23.4,23474,75,NULL,'B','UGC 05349',NULL,'1988NBGC.C....0000T',1988,1,2.6,'HOLM 154B is a star.','G',0.000037,NULL,'14.20',0.8,'Sdm:',NULL,NULL,NULL,NULL,1,149.525833,37.29261,0.045,NULL,64056731958,1000886436,15638850,14.2),(65966,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65966,32.17,0.43,27.1,23474,75,NULL,'3.6 micron, color + selection bias corrected','UGC 05349',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65967,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65967,37.16,0.46,271,23475,70,NULL,NULL,'2MASX J09580631+0951563',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000171,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,149.5264583,9.86553,0.061,NULL,60929355572,952021180,14875330,16.6),(65968,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65968,36.77,0.46,226,23476,70,NULL,NULL,'2MASX J09580675+1535190',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,149.528166667,15.58861,0.053,NULL,60864746119,951011658,14859557,16.5),(65969,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65969,37.7,0.46,347,23477,70,NULL,NULL,'2MASX J09580677+1107343',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,149.5282083,11.12614,0.061,NULL,60927347616,951989806,14874840,17.3),(65970,'D-Sigma','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65970,33.28,0.4,45.3,23478,75,NULL,'Edat, raw','NGC 3070',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000057,NULL,'13.25',1.4,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,149.5289583,10.35978,0.053,NULL,60930123105,952033173,14875518,13.25),(65971,'D-Sigma','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65971,33.61,0.4,52.8,23478,75,NULL,'Edat, cor','NGC 3070',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65972,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65972,34.5,0.45,79.5,23478,NULL,NULL,'K','NGC 3070',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65973,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65973,34.51,0.4,79.7,23478,NULL,NULL,'mean','NGC 3070',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65974,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65974,36.96,0.46,247,23479,70,NULL,NULL,'2MASX J09580697+2739576',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000148,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,149.529125,27.666,0.049,NULL,64172289981,1002692030,15667062,17.2),(65975,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65975,37.81,0.46,364,23480,70,NULL,NULL,'SDSS J095808.06+465120.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,149.533583,46.85578,0,NULL,64008527245,1000133238,15627081,18.5),(65976,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65976,37.53,0.46,321,23481,70,NULL,NULL,'2MASX J09580821+0229350',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000072,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,149.53425,2.49308,0.017,NULL,60781388756,949709199,14839206,17.5),(65977,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65977,35.67,0.46,136,23482,70,NULL,NULL,'CGCG 093-010 NED03',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.32',0.24,NULL,NULL,NULL,NULL,NULL,1,149.534333333,15.9635,0.085,NULL,60861329093,950958267,14858722,16.32),(65978,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65978,35,0.46,100,23483,70,NULL,NULL,'SDSS J095808.70+140331.1',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'15.5g',0.42,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,149.5362917,14.05867,0.041,NULL,60853345582,950833524,14856773,15.5),(65979,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65979,37.53,0.46,321,23484,70,NULL,NULL,'2MASX J09580884+4628301',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,149.536625,46.47497,0,NULL,63977305364,999645396,15619459,16.5),(65980,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65980,37.75,0.33,355,23485,70,NULL,NULL,'2MASX J09580970+1453470',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,149.540417,14.89644,0.045,NULL,60853226606,950831665,14856744,18.1),(65981,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65981,37.04,0.46,256,23486,70,NULL,NULL,'2MASX J09580978+0739073',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,149.540667,7.65189,0.009,NULL,60923677437,951932459,14873944,17.4),(65982,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65982,36.93,0.46,244,23487,70,NULL,NULL,'2MASX J09581045+1441140',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'15.9g',0.39,NULL,NULL,NULL,NULL,NULL,1,149.543625,14.68717,0.045,NULL,60854019831,950844059,14856938,15.9),(65983,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65983,35.48,0.56,125,23488,70,NULL,NULL,'2MASX J09581186-1511553',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.40',NULL,NULL,NULL,NULL,NULL,NULL,1,149.549416667,-15.19875,0.209,NULL,41202902066,643795344,10059302,16.4),(65984,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65984,38.54,0.46,511,23489,70,NULL,NULL,'2MASX J09581252+3744131',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,149.552333,37.73708,0.041,NULL,64058582804,1000915356,15639302,18),(65985,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65985,37.59,0.46,330,23490,70,NULL,NULL,'SDSS J095813.32+003339.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000061,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,149.5555417,0.561,0.057,NULL,60773559224,949586862,14837294,18.4),(65986,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65986,36.18,0.46,172,23491,70,NULL,NULL,'2MASX J09581337+1352120',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,149.555791667,13.87011,0.033,NULL,60854424271,950850379,14857037,16.8),(65987,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65987,38.68,0.23,543,23492,70,NULL,NULL,'2MASX J09581368+1913542',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,149.556833333,19.23172,0.037,NULL,60805597397,950087459,14845116,18.2),(65988,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65988,32.07,0.43,26,23493,75,NULL,'3.6 micron, color + selection bias corrected','ESO 499- G 025',NULL,'2014MNRAS.444..527S',2014,1,1.8,'6dF DR1 has z = 0.047373.','G',0.000047,NULL,'15.71',0.3,'Sb:',NULL,NULL,NULL,NULL,1,149.559291667,-25.04208,0.137,NULL,42816590129,669009220,10453269,15.71),(65989,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65989,32.28,0.4,28.5,23493,75,NULL,NULL,'ESO 499- G 025',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65990,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65990,32.9,0.4,38,23493,NULL,NULL,'mean','ESO 499- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65991,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65991,32.91,0.49,38.2,23493,75,NULL,'IR','ESO 499- G 025',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65992,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65992,33.21,0.47,43.8,23493,NULL,NULL,'H','ESO 499- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65993,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65993,37.88,0.46,377,23494,70,NULL,NULL,'2MASX J09581423+1742430',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,149.559333,17.71189,0.073,NULL,60860032808,950938012,14858406,17.9),(65994,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65994,37.08,0.46,260,23495,70,NULL,NULL,'2MASX J09581458+6207184',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000085,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,149.560667,62.12183,0.021,NULL,62028832256,969200504,15143757,16.6),(65995,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65995,37.52,0.46,320,23496,70,NULL,NULL,'2MASX J09581489+1244420',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,149.562125,12.745,0.037,NULL,60821704725,950339136,14849049,17.6),(65996,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65996,34.79,0.48,90.6,23497,70,NULL,NULL,'2MASX J09581497-2137177',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.44',NULL,NULL,NULL,NULL,NULL,NULL,1,149.562333,-21.62178,0.085,NULL,42293691554,660838930,10325608,15.44),(65997,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65997,36.84,0.46,233,23498,70,NULL,NULL,'2MASX J09581694+2740356',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000151,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,149.570625,27.67669,0.049,NULL,64172287787,1002691996,15667062,16.7),(65998,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,65998,36.22,0.53,175,23499,70,NULL,NULL,'2MASX J09581705-1620277',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,149.571,-16.34111,0.145,NULL,41195160378,643674380,10057412,14.7),(65999,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',65999,38.24,0.46,445,23500,70,NULL,NULL,'2MASX J09581738+3014239',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00018,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,149.5725417,30.24008,0.061,NULL,64160650908,1002510170,15664221,17.2),(66000,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66000,36.1,0.64,166,23501,70,NULL,NULL,'2MASX J09581779-0139522',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'17.37',0.37,NULL,NULL,NULL,NULL,NULL,1,149.574125,-1.66467,0.081,NULL,41238211093,644347048,10067922,17.37),(66001,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66001,38.68,0.23,543,23502,70,NULL,NULL,'SDSS J095820.89+191545.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00017,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,149.587083,19.26267,0.037,NULL,60805567948,950086999,14845109,18.2),(66002,'Tully est','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66002,31.92,0.8,24.2,23503,75,NULL,'B','NGC 3067',NULL,'1988NBGC.C....0000T',1988,1,2.44,NULL,'G',0.000013,NULL,'12.6g',0.83,'SAB(s)ab?      HII','Possible field galaxy',NULL,NULL,NULL,1,149.587833,32.36989,0.061,NULL,64181498857,1002835919,15669311,12.6),(66003,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66003,31.15,0.4,17,23503,NULL,NULL,NULL,'NGC 3067',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66004,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66004,31.54,0.45,20.3,23503,NULL,NULL,'K','NGC 3067',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66005,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66005,31.55,0.47,20.4,23503,NULL,NULL,'H','NGC 3067',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66006,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66006,31.61,0.46,20.9,23503,NULL,NULL,'J','NGC 3067',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66007,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66007,31.99,0.4,25.1,23503,NULL,NULL,'mean','NGC 3067',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66008,'IRAS','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66008,32.57,0.8,32.6,23504,75,NULL,'MAT, I','UGCA 190',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.000032,NULL,'14.15',0.5,'SB(s)d         HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,149.5885417,-25.174,0.137,NULL,42816629767,669009840,10453278,14.15),(66009,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66009,31.76,0.32,22.5,23504,85,NULL,'I, inv','UGCA 190',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66010,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66010,31.78,0.32,22.7,23504,85,NULL,'I, raw','UGCA 190',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66011,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66011,32.1,0.43,26.3,23504,75,NULL,'MAT, I, raw','UGCA 190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66012,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66012,32.12,0.43,26.6,23504,75,NULL,'MAT, I, inv','UGCA 190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66013,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66013,32.15,0.2,26.9,23504,74.4,NULL,NULL,'UGCA 190',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66014,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66014,32.36,0.47,29.6,23504,NULL,NULL,NULL,'UGCA 190',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66015,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66015,32.49,0.43,31.4,23504,75,NULL,'MAT, I, cor','UGCA 190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66016,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66016,32.59,0.42,32.9,23504,NULL,NULL,'Malmquist cor.','UGCA 190',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66017,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66017,37.75,0.33,355,23505,70,NULL,NULL,'2MASX J09582226+1452168',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,149.5927083,14.8715,0.045,NULL,60853930668,950842666,14856916,17),(66018,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66018,37.49,0.46,315,23506,70,NULL,NULL,'2MASX J09582451+0706439',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000187,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,149.602083,7.11231,0,NULL,60926401032,951975016,14874609,16.7),(66019,'SBF','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66019,32.73,0.3,35.2,23507,NULL,NULL,'I','NGC 3078',NULL,'2001ApJ...546..681T',2001,1,2.5,NULL,'G',0.000067,NULL,'12.14',2.1,'E2-3','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,149.6025417,-26.92667,0.165,NULL,42831351354,669239864,10456872,12.14),(66020,'SBF','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66020,32.73,0.3,35.2,23507,NULL,NULL,NULL,'NGC 3078',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66021,'SBF','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66021,32.78,0.14,36,23507,74.4,NULL,NULL,'NGC 3078',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66022,'SBF','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66022,32.89,0.3,37.8,23507,NULL,NULL,'Malmquist cor.','NGC 3078',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66023,'D-Sigma','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66023,32.26,0.4,28.3,23507,75,NULL,'Edat, raw','NGC 3078',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66024,'D-Sigma','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66024,32.59,0.4,33,23507,75,NULL,'Edat, cor','NGC 3078',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66025,'Faber-Jackson','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66025,31.66,0.37,21.5,23507,95,NULL,'Weighted Mean','NGC 3078',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66026,'Faber-Jackson','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66026,31.79,0.63,22.8,23507,95,NULL,'Michard 1979b, c','NGC 3078',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66027,'Faber-Jackson','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66027,32.03,0.46,25.5,23507,95,NULL,'Michard 1979a','NGC 3078',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66028,'Faber-Jackson','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66028,33.08,0.81,41.3,23507,55,NULL,'Visvanathan & Sandage 1979','NGC 3078',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66029,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66029,32.66,0.41,34,23507,NULL,NULL,NULL,'NGC 3078',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66030,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66030,32.96,0.41,39.1,23507,NULL,NULL,'Malmquist cor.','NGC 3078',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66031,'Tully est','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66031,32.62,0.8,33.4,23507,75,NULL,'B','NGC 3078',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66032,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66032,32.75,0.45,35.4,23507,NULL,NULL,'K','NGC 3078',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66033,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66033,32.95,0.4,39,23507,NULL,NULL,'mean','NGC 3078',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66034,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66034,36.68,0.46,217,23508,70,NULL,NULL,'IC 2525',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000201,NULL,'15.4g',0.54,'E0',NULL,NULL,NULL,NULL,1,149.604,37.10186,0.041,NULL,64070643737,1001103808,15642247,15.4),(66035,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66035,36.33,0.27,184,23509,70,NULL,NULL,'2MASX J09582515+3647111',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,149.6047917,36.78639,0.017,NULL,64070866710,1001107292,15642301,16.3),(66036,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66036,37.59,0.33,329,23510,70,NULL,NULL,'SDSS J095825.17+063603.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000182,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,149.604917,6.601,0.009,NULL,60925926863,951967607,14874493,18.2),(66037,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66037,37.72,0.15,351,23511,70,NULL,NULL,'2MASX J09582658+1135569',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,149.610833,11.59906,0.049,NULL,60926640247,951978753,14874668,17.7),(66038,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66038,36.61,0.46,210,23512,70,NULL,NULL,'2MASX J09582720+0022567',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000089,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,149.6134583,0.38247,0.057,NULL,60773544969,949586640,14837291,16.5),(66039,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66039,37.13,0.46,267,23513,70,NULL,NULL,'2MASX J09582734+5740390',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,149.6142083,57.67739,0,NULL,61940408720,967818886,15122170,17.5),(66040,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66040,36.33,0.27,184,23514,70,NULL,NULL,'2MASX J09582798+3646281',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000167,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,149.616625,36.77453,0.017,NULL,64070866777,1001107293,15642301,16.3),(66041,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66041,35.9,0.46,151,23515,70,NULL,NULL,'2MASX J09582823+0854239',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000168,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,149.617625,8.90664,0.049,NULL,60930748332,952042942,14875670,16.5),(66042,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66042,31.63,NULL,21.2,23516,NULL,NULL,NULL,'LSBC L1-099',NULL,'2015AstBu..70....1K',2015,1,0.69,NULL,'G',0.000028,NULL,'17.98',0.29,'dI',NULL,NULL,NULL,NULL,1,149.6202083,1.69467,0.013,NULL,60783727044,949745735,14839777,17.98),(66043,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66043,37.46,0.46,311,23517,70,NULL,NULL,'2MASX J09582900+0034297',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000076,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,149.620833,0.57478,0.057,NULL,60773509398,949586084,14837282,17.3),(66044,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2bw',NULL,66044,43.3,0.09,2380,23518,70,NULL,'SALT2','SNLS 05D2bw HOST',0.92,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.01,NULL,'24.5i',NULL,NULL,NULL,NULL,NULL,NULL,1,149.627625,2.53639,0.017,NULL,60783443047,949741297,14839707,24.5),(66045,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2bw',NULL,66045,43.55,0.17,2670,23518,NULL,NULL,'SALT2','SNLS 05D2bw HOST',0.92,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66046,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2bw',NULL,66046,43.89,0.24,3130,23518,70,NULL,'SALT 2','SNLS 05D2bw HOST',0.92,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66047,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2bw',NULL,66047,43.91,0.15,3150,23518,NULL,NULL,'SIFTO','SNLS 05D2bw HOST',0.92,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66048,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','PS1 SN PS11bh','N',66048,41.46,0.11,1450,23519,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11bh HOST',0.3512,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66049,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66049,37.74,0.46,353,23520,70,NULL,NULL,'2MASX J09583123+1053549',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,149.630166667,10.89872,0.045,NULL,60927241600,951988150,14874814,18),(66050,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2my',NULL,66050,43.63,0.08,2690,23521,70,NULL,'SIFTO','SNLS 05D2my',0.981,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',NULL,'PHOT',NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,149.6310417,2.49122,0.005,NULL,60783440305,949741254,14839707,NULL),(66051,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2my',NULL,66051,44.08,0.23,3300,23521,70,NULL,'SALT 2','SNLS 05D2my',0.981,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66052,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2my',NULL,66052,44.12,0.15,3370,23521,NULL,NULL,'SIFTO','SNLS 05D2my',0.981,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66053,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2my',NULL,66053,45.82,0.17,7360,23521,NULL,NULL,'SALT2','SNLS 05D2my',0.981,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66054,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66054,37.27,0.46,285,23522,70,NULL,NULL,'2MASX J09583194+1936491',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,149.633083,19.61347,0.033,NULL,60805352668,950083635,14845056,16.8),(66055,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2dw',NULL,66055,41.59,0.03,1460,23523,70,NULL,'SIFTO','[NSB2006] J095832.05+020156.3',0.42,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,'22.6i',NULL,'Candidate      ELG',NULL,NULL,NULL,NULL,1,149.633458333,2.03256,0.005,NULL,60783842584,949747540,14839805,22.6),(66056,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2dw',NULL,66056,41.75,0.11,1570,23523,70,NULL,'SALT 2','[NSB2006] J095832.05+020156.3',0.42,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66057,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2dw',NULL,66057,41.82,0.15,1630,23523,NULL,NULL,'SIFTO','[NSB2006] J095832.05+020156.3',0.42,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66058,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2dw',NULL,66058,41.93,0.12,1720,23523,72,NULL,NULL,'[NSB2006] J095832.05+020156.3',0.42,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66059,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2dw',NULL,66059,43.16,0.17,3020,23523,NULL,NULL,'SALT2','[NSB2006] J095832.05+020156.3',0.42,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66060,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66060,37.41,0.46,303,23524,70,NULL,NULL,'SDSS J095832.53+163258.6',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,149.635583333,16.54961,0.069,NULL,60860787767,950949808,14858590,NULL),(66061,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66061,37.17,0.46,272,23525,70,NULL,NULL,'SDSS J095833.66+460425.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,149.6402917,46.07389,0,NULL,63979606204,999681346,15620021,17.8),(66062,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66062,36.63,0.46,212,23526,70,NULL,NULL,'2MASX J09583416+0323237',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,149.642333,3.38992,0.025,NULL,60776982476,949640351,14838130,16.6),(66063,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66063,37.75,0.46,355,23527,70,NULL,NULL,'2MASX J09583423+5604589',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000179,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,149.642791667,56.08286,0,NULL,61934629227,967728581,15120759,17.5),(66064,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66064,38.54,0.46,510,23528,70,NULL,NULL,'2MASX J09583522-0050133',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000084,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,149.646791667,-0.83694,0.045,NULL,41235842386,644310037,10067344,17.2),(66065,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66065,38.21,0.27,439,23529,70,NULL,NULL,'2MASX J09583531+0508026',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,149.647125,5.13414,0.049,NULL,60906204994,951659453,14869678,17.6),(66066,'Tully est','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66066,33.03,0.8,40.4,23530,75,NULL,'B','MRK 1242',NULL,'1988NBGC.C....0000T',1988,1,0.73,NULL,'G',0.000121,NULL,'14.7g',0.56,'e;a',NULL,NULL,NULL,NULL,1,149.650958333,13.25528,0.029,NULL,60851603859,950806310,14856348,14.7),(66067,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66067,37.37,0.46,297,23531,70,NULL,NULL,'2MASX J09583715-0055463',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000134,NULL,'15.8g',0.39,'E0',NULL,NULL,NULL,NULL,1,149.654667,-0.9295,0.053,NULL,41235846841,644310106,10067345,15.8),(66068,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66068,37.51,0.46,317,23532,70,NULL,NULL,'SDSS J095838.47+194256.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,149.6602917,19.71561,0.033,NULL,63696273601,995254275,15550848,18.2),(66069,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66069,37.73,0.46,351,23533,70,NULL,NULL,'SDSS J095838.94+031014.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,149.66225,3.17078,0.021,NULL,60777001532,949640648,14838135,18),(66070,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66070,37.85,0.33,372,23534,70,NULL,NULL,'2MASX J09584000+0044087',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000084,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,149.666667,0.73592,0.057,NULL,60774223177,949597237,14837456,17.1),(66071,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66071,35.63,0.46,134,23535,70,NULL,NULL,'NGC 3068 NED02',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.00009,NULL,'14.6g',0.61,'S0-: pec',NULL,NULL,NULL,NULL,1,149.6670417,28.87756,0.045,NULL,64163674211,1002557409,15664959,14.6),(66072,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66072,36.67,0.88,216,23536,70,NULL,NULL,'2MASX J09584029-3815070',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,149.667791667,-38.25203,0.657,NULL,41961225767,655644152,10244439,15.5),(66073,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66073,36.33,0.27,184,23537,70,NULL,NULL,'2MASX J09584134+3648117',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,149.672375,36.80331,0.017,NULL,64070873585,1001107399,15642303,NULL),(66074,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66074,35.61,0.61,132,23538,70,NULL,NULL,'2MASX J09584161-0419513',NULL,'2014MNRAS.445.2677S',2014,1,0.69,NULL,'G',0.00015,NULL,'15.9b',0.43,NULL,NULL,NULL,NULL,NULL,1,149.673417,-4.33089,0.025,NULL,41228234138,644191158,10065486,15.9),(66075,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66075,37.46,0.46,311,23539,70,NULL,NULL,'2MASX J09584209-0048223',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000076,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,149.6755,-0.80625,0.045,NULL,41235843330,644310052,10067344,17.1),(66076,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66076,37.85,0.33,372,23540,70,NULL,NULL,'2MASX J09584247+0052346',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000078,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,149.6769583,0.87639,0.025,NULL,60782165925,949721342,14839395,18.5),(66077,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 06D2bk',NULL,66077,42.41,0.15,2020,23541,NULL,NULL,'SIFTO','SNLS 06D2bk HOST',0.499,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,'22.9i',NULL,NULL,NULL,NULL,NULL,NULL,1,149.6785417,2.17208,0.005,NULL,60783835277,949747426,14839803,22.9),(66078,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 06D2bk',NULL,66078,42.42,0.14,2040,23541,70,NULL,'SALT 2','SNLS 06D2bk HOST',0.499,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66079,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 06D2bk',NULL,66079,42.44,NULL,2050,23541,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SNLS 06D2bk HOST',0.499,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66080,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 06D2bk',NULL,66080,42.52,0.04,2130,23541,70,NULL,'SIFTO','SNLS 06D2bk HOST',0.499,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66081,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 06D2bk',NULL,66081,43.44,0.17,3250,23541,NULL,NULL,'SALT2','SNLS 06D2bk HOST',0.499,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66082,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66082,37.71,0.33,349,23542,70,NULL,NULL,'2MASX J09584377+2610556',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000224,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,149.6825,26.182,0.101,NULL,64170202923,1002659420,15666553,16.3),(66083,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66083,38.32,0.27,460,23543,70,NULL,NULL,'SDSS J095843.92+012319.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000142,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,149.683,1.38875,0.017,NULL,60782134664,949720854,14839388,17.8),(66084,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2cc',NULL,66084,43.81,0.17,3150,23544,NULL,NULL,'SALT2','SNLS 04D2cc HOST',0.838,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,'22.4i',NULL,NULL,NULL,NULL,NULL,NULL,1,149.68625,2.27067,0.005,NULL,60783413507,949740836,14839700,22.4),(66085,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2cc',NULL,66085,43.95,0.15,3360,23544,NULL,NULL,'SIFTO','SNLS 04D2cc HOST',0.838,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66086,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66086,37.68,0.46,344,23545,70,NULL,NULL,'2MASX J09584503+4458332',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000174,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,149.6877917,44.97578,0,NULL,63979298605,999676540,15619945,17.2),(66087,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66087,37.38,0.46,299,23546,70,NULL,NULL,'SDSS J095846.77+020818.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00007,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,149.694917,2.13844,0.005,NULL,60783836951,949747452,14839803,18.2),(66088,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66088,33.13,0.43,42.2,23547,75,NULL,'3.6 micron, color + selection bias corrected','UGC 05358',NULL,'2014MNRAS.444..527S',2014,1,1.51,NULL,'G',0.000003,NULL,'15.3g',0.42,'SB(s)b',NULL,NULL,NULL,NULL,1,149.696417,11.38869,0.073,NULL,60927318672,951989354,14874833,15.3),(66089,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66089,38.4,0.33,479,23548,70,NULL,NULL,'SDSS J095847.60+062039.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,149.698375,6.34444,0.025,NULL,60922836016,951919312,14873739,17.8),(66090,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66090,37.64,0.46,337,23549,70,NULL,NULL,'2MASX J09584787+0112213',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000083,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,149.6994583,1.20594,0.017,NULL,60782228248,949722316,14839411,17.2),(66091,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66091,38.5,0.46,501,23550,70,NULL,NULL,'2MASXi J0958484+425804',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000193,NULL,'17.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,149.701583,42.96783,0,NULL,64098433735,1001538027,15649031,17.3),(66092,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2ja','R',66092,42.53,NULL,1840,23551,65,NULL,'MLCS17','[AGR2006] J095848.51+014618.6',0.741,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,'21.1i',NULL,NULL,NULL,NULL,NULL,NULL,1,149.7020417,1.77183,0.005,NULL,60783748679,949746073,14839782,21.1),(66093,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2ja',NULL,66093,42.87,0.06,2150,23551,70,NULL,'MLCS17','[AGR2006] J095848.51+014618.6',0.741,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66094,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2ja',NULL,66094,42.99,0.23,2280,23551,74.2,NULL,'SALT 2','[AGR2006] J095848.51+014618.6',0.741,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66095,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2ja',NULL,66095,43.43,0.12,2780,23551,70,NULL,NULL,'[AGR2006] J095848.51+014618.6',0.741,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66096,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2ja',NULL,66096,43.48,0.16,2850,23551,70,NULL,'SALT','[AGR2006] J095848.51+014618.6',0.741,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66097,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2ja',NULL,66097,43.56,0.24,2960,23551,65,NULL,'MLCS17','[AGR2006] J095848.51+014618.6',0.741,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66098,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2ja',NULL,66098,43.58,0.22,2990,23551,65,NULL,'MLCS2k2','[AGR2006] J095848.51+014618.6',0.741,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66099,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2ja',NULL,66099,43.58,0.23,2990,23551,65,NULL,'MLCS31','[AGR2006] J095848.51+014618.6',0.741,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66100,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2ja',NULL,66100,43.64,0.2,3060,23551,65,NULL,'MLCS2k2','[AGR2006] J095848.51+014618.6',0.741,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66101,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2ja',NULL,66101,43.68,0.13,3130,23551,65,NULL,'SALT','[AGR2006] J095848.51+014618.6',0.741,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66102,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2ja',NULL,66102,43.69,0.08,3150,23551,65,NULL,'SALT','[AGR2006] J095848.51+014618.6',0.741,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66103,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2ja',NULL,66103,43.7,0.15,3150,23551,NULL,NULL,'SIFTO','[AGR2006] J095848.51+014618.6',0.741,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66104,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2ja',NULL,66104,43.81,0.19,3330,23551,65,NULL,'SALT2','[AGR2006] J095848.51+014618.6',0.741,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66105,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2ja',NULL,66105,43.88,0.22,3430,23551,65,NULL,'SALT2','[AGR2006] J095848.51+014618.6',0.741,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66106,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2ja',NULL,66106,43.93,0.27,3500,23551,70,NULL,'SALT 2','[AGR2006] J095848.51+014618.6',0.741,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66107,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2ja',NULL,66107,44.7,0.17,4990,23551,NULL,NULL,'SALT2','[AGR2006] J095848.51+014618.6',0.741,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66108,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66108,36.69,0.46,218,23552,70,NULL,NULL,'2MASX J09584873+1657330',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.95',0.29,NULL,NULL,NULL,NULL,NULL,1,149.703041667,16.95911,0.081,NULL,60863374711,950990229,14859222,16.95),(66109,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66109,27.91,0.06,3.8,23553,NULL,NULL,NULL,'KUG 0954+670',NULL,'2013AJ....146..126C',2013,1,0.7,NULL,'G',NULL,NULL,'16:',0.3,'Spiral',NULL,NULL,NULL,NULL,1,149.704416667,66.84811,0.137,NULL,62119410629,970615791,15165871,16),(66110,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66110,27.91,0.1,3.82,23553,74.4,NULL,NULL,'KUG 0954+670',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66111,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66111,36.38,0.46,189,23554,70,NULL,NULL,'2MASX J09584913+6951566',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,149.7047083,69.86561,0.141,NULL,62098496280,970289004,15160765,NULL),(66112,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66112,37.99,0.33,396,23555,70,NULL,NULL,'2MASX J09584974+0108033',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000077,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,149.707208333,1.13439,0.021,NULL,60782219777,949722184,14839409,17.6),(66113,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2nn',NULL,66113,42.58,0.17,1760,23556,NULL,NULL,'SALT2','SNLS 05D2nn HOST',0.87,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,149.7072917,2.71028,0.017,NULL,60781266685,949707291,14839176,NULL),(66114,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2nn',NULL,66114,43.31,0.09,2460,23556,70,NULL,'SALT2','SNLS 05D2nn HOST',0.87,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66115,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2nn',NULL,66115,43.82,0.15,3110,23556,NULL,NULL,'SIFTO','SNLS 05D2nn HOST',0.87,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66116,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2nn',NULL,66116,43.9,NULL,3220,23556,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SNLS 05D2nn HOST',0.87,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66117,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2nn',NULL,66117,43.97,0.24,3330,23556,70,NULL,'SALT 2','SNLS 05D2nn HOST',0.87,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66118,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66118,38.16,0.46,428,23557,70,NULL,NULL,'2MASX J09584983+1511120',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,149.707833,15.18658,0.037,NULL,60853196920,950831201,14856737,17.5),(66119,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66119,37.54,0.46,322,23558,70,NULL,NULL,'2MASX J09584992+4032347',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,149.708,40.54306,0,NULL,64092273254,1001441769,15647527,17.6),(66120,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66120,37.11,0.46,264,23559,70,NULL,NULL,'2MASX J09585052+1235210',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000178,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,149.7105,12.58928,0.049,NULL,60851190667,950799854,14856247,16.9),(66121,'IRAS','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66121,35.39,0.8,120,23560,75,NULL,'CF, r','UGC 05359',NULL,'1997ApJS..109..333W',1997,1,1.43,NULL,'G',0.00003,NULL,'14.8g',0.46,'SABb',NULL,NULL,NULL,NULL,1,149.7152083,19.21497,0.025,NULL,60805510637,950086103,14845095,14.8),(66122,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66122,35.15,0.38,107,23560,75,NULL,'CF, r, raw','UGC 05359',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66123,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66123,35.28,0.38,114,23560,75,NULL,'CF, r, cor','UGC 05359',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66124,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66124,35.32,0.38,116,23560,75,NULL,'CF, r, inv','UGC 05359',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66125,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66125,35.41,0.35,121,23560,NULL,NULL,'Malmquist cor.','UGC 05359',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66126,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66126,35.55,0.2,129,23560,74.4,NULL,NULL,'UGC 05359',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66127,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66127,35.58,0.33,130,23560,NULL,NULL,NULL,'UGC 05359',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66128,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66128,38.07,0.46,411,23561,70,NULL,NULL,'2MASX J09585238+0251243',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000176,NULL,'17.3g',0.23,'HII',NULL,NULL,NULL,NULL,1,149.7182917,2.85675,0.021,NULL,60781282383,949707537,14839180,17.3),(66129,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66129,38,0.46,398,23562,70,NULL,NULL,'2MASX J09585287+5917021',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000173,NULL,'17.8g',0.18,'Candidate      BLAGN',NULL,NULL,NULL,NULL,1,149.72025,59.28383,0.009,NULL,61921398900,967521857,15117529,17.8),(66130,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66130,34.95,0.46,97.9,23563,70,NULL,NULL,'NGC 3071',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.0001,NULL,'15.0g',0.58,NULL,NULL,NULL,NULL,NULL,1,149.7207917,31.62031,0.061,NULL,64215009083,1003359516,15677492,15),(66131,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66131,32.94,0.48,38.7,23564,70,NULL,NULL,'NGC 3082',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.00006,NULL,'13.47',0.7,'SA(s)0-:',NULL,NULL,NULL,NULL,1,149.721125,-30.35769,0.121,NULL,42824507595,669132931,10455202,13.47),(66132,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66132,32.83,0.45,36.8,23564,NULL,NULL,'K','NGC 3082',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66133,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66133,33.07,0.4,41.2,23564,NULL,NULL,'mean','NGC 3082',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66134,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66134,38.2,0.33,436,23565,70,NULL,NULL,'SDSS J095853.29+283252.5',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.26,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,149.722083,28.54794,0.037,NULL,64163438992,1002553734,15664902,16.9),(66135,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66135,32.27,0.2,28.4,23566,74.4,NULL,NULL,'UGC 05354',NULL,'2013AJ....146...86T',2013,1,2.1,NULL,'G',0.000007,NULL,'14.3g',1.1,'Sm             HII','Group member',NULL,NULL,NULL,1,149.7224583,47.73683,0,NULL,64009215599,1000143993,15627249,14.3),(66136,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66136,32.49,0.43,31.5,23566,75,NULL,'3.6 micron, color corrected','UGC 05354',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66137,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66137,32.73,0.43,35.1,23566,75,NULL,'3.6 micron, color + selection bias corrected','UGC 05354',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66138,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66138,37.99,0.33,396,23567,70,NULL,NULL,'2MASX J09585340+0112473',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000083,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,149.722583333,1.21319,0.017,NULL,60782220398,949722193,14839409,17),(66139,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66139,36.26,0.46,178,23568,70,NULL,NULL,'2MASX J09585352+3105411',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00016,NULL,'16.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,149.723,31.09483,0.069,NULL,64160358604,1002505603,15664150,16.3),(66140,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66140,37.72,0.15,351,23569,70,NULL,NULL,'SDSS J095853.99+113326.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,149.7249583,11.55736,0.073,NULL,60926651167,951978924,14874670,18.6),(66141,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66141,38.2,0.33,436,23570,70,NULL,NULL,'2MASX J09585449+2831216',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000146,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,149.727166667,28.52275,0.037,NULL,64162927612,1002545743,15664777,18.1),(66142,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66142,37.01,0.46,253,23571,70,NULL,NULL,'2MASX J09585575+4934036',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,149.73225,49.56761,0,NULL,64006233079,1000097391,15626521,16.9),(66143,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66143,36.19,0.46,173,23572,70,NULL,NULL,'2MASX J09585607+0946489',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.00013,NULL,'15.5g',0.46,NULL,NULL,NULL,NULL,NULL,1,149.7337917,9.78011,0.065,NULL,60929570167,952024533,14875383,15.5),(66144,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66144,33.74,0.4,55.9,23573,NULL,NULL,'mean','NGC 3075',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.00003,NULL,'14.32',0.8,'Sc             HII','Group member',NULL,NULL,NULL,1,149.734167,14.42047,0.045,NULL,60853415630,950834619,14856790,14.32),(66145,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66145,34.02,0.47,63.8,23573,NULL,NULL,'H','NGC 3075',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66146,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66146,34.14,0.46,67.2,23573,NULL,NULL,'J','NGC 3075',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66147,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66147,37.72,0.15,351,23574,70,NULL,NULL,'2MASX J09585672+1140529',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,149.736167,11.68131,0.049,NULL,60926621363,951978458,14874663,17.8),(66148,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66148,36.09,0.63,165,23575,70,NULL,NULL,'ESO 566- G 036',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000083,NULL,'15.65',0.6,'Sa',NULL,NULL,NULL,NULL,1,149.7362917,-18.81847,0.113,NULL,41146787742,642918558,10045602,15.65),(66149,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66149,37.75,0.46,354,23576,70,NULL,NULL,'SDSS J095856.93+410441.1',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.9g',0.3,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,149.73725,41.07811,0,NULL,64091634529,1001431789,15647371,16.9),(66150,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66150,37.08,0.46,261,23577,70,NULL,NULL,'2MASX J09585912+5859571',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000178,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,149.746625,58.99922,0,NULL,61920703646,967510994,15117359,16.5),(66151,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2ac',NULL,66151,41.66,0.03,1450,23578,70,NULL,'SIFTO','SDSS J095859.30+022922.9',0.479,'2011ApJS..192....1C',2011,1,0.07,NULL,'G',0.001,NULL,'20.8g',0.07,NULL,NULL,NULL,NULL,NULL,1,149.747125,2.48969,0.005,NULL,60783583023,949743484,14839741,20.8),(66152,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2ac',NULL,66152,42.03,0.12,1720,23578,70,NULL,'SALT 2','SDSS J095859.30+022922.9',0.479,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66153,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2ac',NULL,66153,42.16,0.15,1830,23578,NULL,NULL,'SIFTO','SDSS J095859.30+022922.9',0.479,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66154,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2ac',NULL,66154,43.43,0.17,3290,23578,NULL,NULL,'SALT2','SDSS J095859.30+022922.9',0.479,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66155,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66155,37.72,0.15,351,23579,70,NULL,NULL,'SDSS J095859.41+114419.0',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000168,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,149.747583333,11.73864,0.049,NULL,60926610822,951978294,14874660,18.7),(66156,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66156,37.07,0.46,259,23580,70,NULL,NULL,'2MASX J09585963+4016147',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,149.748333,40.27069,0.005,NULL,64090396083,1001412438,15647069,17.6),(66157,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','PS1 SN PS10e','N',66157,40.56,0.1,1040,23581,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10e HOST',0.2459,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66158,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66158,36.82,0.46,232,23582,70,NULL,NULL,'2MASX J09590001+3605177',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,149.750083,36.08822,0.033,NULL,64071093214,1001110831,15642356,16.7),(66159,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66159,35.46,0.47,124,23583,70,NULL,NULL,'2MASX J09590011-3430497',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,149.7505,-34.51386,0.589,NULL,41969967500,655780742,10246574,14),(66160,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SN 2001gb',NULL,66160,34.59,0.2,80.7,23584,74.2,NULL,'SALT 2','IC 0582',0.025731,'2010ApJ...716..712A',2010,1,1.1,NULL,'G',0.00011,NULL,'14.7',1,'S',NULL,NULL,NULL,NULL,1,149.7509583,17.81714,0.081,NULL,60862990573,950984227,14859128,14.7),(66161,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SN 2001gb',NULL,66161,35.2,0.09,110,23584,74.4,NULL,NULL,'IC 0582',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66162,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SN 2001gb',NULL,66162,35.54,0.23,125,23584,65,NULL,'MLCS17','IC 0582',0.025731,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66163,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66163,38.31,0.46,460,23585,70,NULL,NULL,'2MASX J09590036+2900576',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,149.751625,29.01592,0.049,NULL,64163500560,1002554696,15664917,17.6),(66164,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2ob',NULL,66164,43.93,0.23,3170,23586,70,NULL,'SALT 2','SNLS 05D2ob HOST',0.924,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',NULL,NULL,'24.6i',NULL,NULL,NULL,NULL,NULL,NULL,1,149.752958333,1.84914,0.005,NULL,60783742420,949745975,14839780,24.6),(66165,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2ob',NULL,66165,43.99,0.08,3270,23586,70,NULL,'SIFTO','SNLS 05D2ob HOST',0.924,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66166,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2ob',NULL,66166,44.11,0.15,3460,23586,NULL,NULL,'SIFTO','SNLS 05D2ob HOST',0.924,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66167,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2ob',NULL,66167,45.24,0.17,5800,23586,NULL,NULL,'SALT2','SNLS 05D2ob HOST',0.924,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66168,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66168,37.04,0.46,255,23587,70,NULL,NULL,'2MASX J09590209+2844246',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000158,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,149.758708333,28.74022,0.041,NULL,64163645567,1002556961,15664952,16.9),(66169,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66169,38.4,0.33,479,23588,70,NULL,NULL,'SDSS J095903.29+062242.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,149.7637083,6.37836,0.025,NULL,60923019220,951922175,14873783,18.5),(66170,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66170,35.97,0.46,157,23589,70,NULL,NULL,'SDSS J095903.28+130221.0',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.1g',0.4,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,149.7637083,13.03917,0.021,NULL,60851877464,950810585,14856415,16.1),(66171,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66171,34.78,0.46,90.3,23590,70,NULL,NULL,'CGCG 093-015',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.00013,NULL,'15.2',0.49,NULL,NULL,NULL,NULL,NULL,1,149.76625,15.66469,0.053,NULL,60865476054,951023063,14859735,15.2),(66172,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66172,37.71,0.33,349,23591,70,NULL,NULL,'2MASX J09590502+2612436',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000164,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,149.7710417,26.21208,0.101,NULL,64170206474,1002659476,15666554,16.9),(66173,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66173,34.85,0.46,93.5,23592,70,NULL,NULL,'2MASX J09590541+1839161',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000164,NULL,'16.0g',0.4,NULL,NULL,NULL,NULL,NULL,1,149.772583,18.65436,0.037,NULL,60805195801,950081184,14845018,16),(66174,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66174,33.68,0.51,54.4,23593,70,NULL,NULL,'2MASX J09590546-1340088',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,149.7727917,-13.66911,0.193,NULL,41188426557,643569164,10055768,14.6),(66175,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66175,38.37,0.46,472,23594,70,NULL,NULL,'2MASX J09590575+1922236',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'18.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,149.7739583,19.37314,0.037,NULL,60808252946,950128952,14845764,18),(66176,'IRAS','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66176,32.87,0.8,37.5,23595,75,NULL,'MAT, I','ESO 435- G 019',NULL,'1997ApJS..109..333W',1997,1,4.03,NULL,'G',0.00001,NULL,'13.75',0.56,'SB(s)c? sp     HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,149.774708333,-30.25133,0.189,NULL,42824501258,669132832,10455200,13.75),(66177,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66177,31.52,0.4,20.2,23595,75,NULL,NULL,'ESO 435- G 019',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66178,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66178,31.53,0.39,20.2,23595,73,NULL,'IR','ESO 435- G 019',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66179,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66179,31.73,0.32,22.2,23595,85,NULL,'I, raw','ESO 435- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66180,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66180,31.75,0.32,22.4,23595,85,NULL,'I, inv','ESO 435- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66181,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66181,31.87,0.43,23.7,23595,75,NULL,'MAT, I, raw','ESO 435- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66182,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66182,31.96,0.43,24.7,23595,75,NULL,'MAT, I, inv','ESO 435- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66183,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66183,31.97,0.4,24.8,23595,NULL,NULL,NULL,'ESO 435- G 019',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66184,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66184,31.99,0.43,25,23595,75,NULL,'3.6 micron, color + selection bias corrected','ESO 435- G 019',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66185,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66185,32.1,0.49,26.3,23595,75,NULL,'IR','ESO 435- G 019',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66186,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66186,32.12,0.43,26.5,23595,75,NULL,'3.6 micron, color corrected','ESO 435- G 019',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66187,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66187,32.19,NULL,27.4,23595,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 435- G 019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66188,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66188,32.21,NULL,27.6,23595,NULL,NULL,'Dipole','ESO 435- G 019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66189,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66189,32.21,NULL,27.7,23595,NULL,NULL,'Dipole + Quadrupole','ESO 435- G 019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66190,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66190,32.23,0.2,27.9,23595,74.4,NULL,NULL,'ESO 435- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66191,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66191,32.31,0.43,29,23595,75,NULL,'MAT, I, cor','ESO 435- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66192,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66192,32.41,NULL,30.3,23595,NULL,NULL,NULL,'ESO 435- G 019',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66193,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66193,32.71,0.47,34.9,23595,NULL,NULL,'H','ESO 435- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66194,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66194,32.76,0.46,35.6,23595,NULL,NULL,'J','ESO 435- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66195,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66195,32.77,0.45,35.8,23595,NULL,NULL,'K','ESO 435- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66196,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66196,33.07,0.4,41.2,23595,NULL,NULL,'mean','ESO 435- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66197,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66197,33.26,0.16,45,23595,NULL,NULL,NULL,'ESO 435- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66198,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66198,36.7,0.33,218,23596,70,NULL,NULL,'2MASX J09590595+2512006',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,149.774875,25.20028,0.133,NULL,64159051060,1002485172,15663830,17),(66199,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66199,31.46,0.47,19.6,23597,NULL,NULL,'H','NGC 3084',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000027,NULL,'13.16',1.2,'(R\'_1)SB(rs)a  HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,149.77675,-27.12881,0.165,NULL,42831323610,669239431,10456866,13.16),(66200,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66200,31.65,0.46,21.4,23597,NULL,NULL,'J','NGC 3084',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66201,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66201,31.67,0.45,21.5,23597,NULL,NULL,'K','NGC 3084',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66202,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66202,32.96,0.4,39,23597,NULL,NULL,'mean','NGC 3084',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66203,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 06D2ga',NULL,66203,43.25,0.08,2430,23598,70,NULL,'SIFTO','zCOSMOS 813451',0.8424,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.0002,'?','22.4i',NULL,NULL,NULL,NULL,NULL,NULL,1,149.784125,1.93767,0.005,NULL,60783808007,949747000,14839796,22.4),(66204,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 06D2ga',NULL,66204,43.69,0.28,2970,23598,70,NULL,'SALT 2','zCOSMOS 813451',0.8424,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66205,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 06D2ga',NULL,66205,43.69,0.15,2970,23598,NULL,NULL,'SIFTO','zCOSMOS 813451',0.8424,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66206,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 06D2ga',NULL,66206,45.77,0.17,7750,23598,NULL,NULL,'SALT2','zCOSMOS 813451',0.8424,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66207,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66207,38.21,0.27,439,23599,70,NULL,NULL,'2MASX J09590820+0512353',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,149.784166667,5.20975,0.049,NULL,60906189298,951659207,14869675,17.3),(66208,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2fq',NULL,66208,42.99,0.05,2280,23600,70,NULL,'SIFTO','SDSS J095908.51+023609.0',0.7329,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.0002,NULL,'20.7i',NULL,'LRG',NULL,NULL,NULL,NULL,1,149.785541667,2.60247,0.005,NULL,60783570818,949743294,14839738,20.7),(66209,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2fq',NULL,66209,43.32,0.15,2670,23600,NULL,NULL,'SIFTO','SDSS J095908.51+023609.0',0.7329,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66210,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2fq',NULL,66210,43.5,0.2,2890,23600,70,NULL,'SALT 2','SDSS J095908.51+023609.0',0.7329,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66211,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2fq',NULL,66211,44.71,0.17,5040,23600,NULL,NULL,'SALT2','SDSS J095908.51+023609.0',0.7329,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66212,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2mp',NULL,66212,41.58,0.12,1530,23601,72,NULL,'z lit','SNLS 05D2mp HOST',0.3537,'2009ApJ...704.1036F',2009,1,NULL,NULL,'G',0.0004,NULL,'23.3i',NULL,NULL,NULL,NULL,NULL,NULL,1,149.785916667,2.20406,0.005,NULL,60783622840,949744106,14839751,23.3),(66213,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2mp',NULL,66213,41.6,0.12,1540,23601,70,NULL,'SALT 2','SNLS 05D2mp HOST',0.3537,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66214,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2mp',NULL,66214,41.6,0.15,1550,23601,NULL,NULL,'SIFTO','SNLS 05D2mp HOST',0.3537,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66215,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2mp',NULL,66215,41.62,0.04,1560,23601,70,NULL,'z lit','SNLS 05D2mp HOST',0.3537,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66216,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2mp',NULL,66216,43.36,0.17,3470,23601,NULL,NULL,'SALT2','SNLS 05D2mp HOST',0.3537,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66217,'SBF','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66217,32.72,0.21,35,23602,NULL,NULL,'I','NGC 3087',NULL,'2001ApJ...546..681T',2001,1,2.5,NULL,'G',0.00007,NULL,'11.58',2,'E+:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,149.786083,-34.22522,0.577,NULL,41972120845,655814388,10247099,11.58),(66218,'SBF','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66218,32.72,0.21,35,23602,NULL,NULL,NULL,'NGC 3087',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66219,'SBF','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66219,32.75,0.14,35.5,23602,74.4,NULL,NULL,'NGC 3087',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66220,'SBF','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66220,32.8,0.21,36.3,23602,NULL,NULL,'Malmquist cor.','NGC 3087',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66221,'D-Sigma','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66221,32.88,0.4,37.6,23602,75,NULL,'Edat, raw','NGC 3087',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66222,'D-Sigma','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66222,33.21,0.4,43.9,23602,75,NULL,'Edat, cor','NGC 3087',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66223,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66223,32.59,0.49,32.9,23602,70,NULL,NULL,'NGC 3087',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66224,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66224,32.98,0.41,39.4,23602,NULL,NULL,NULL,'NGC 3087',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66225,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66225,33.19,0.41,43.4,23602,NULL,NULL,'Malmquist cor.','NGC 3087',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66226,'Tully est','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66226,32.71,0.8,34.9,23602,75,NULL,'B','NGC 3087',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66227,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66227,32.84,0.4,37,23602,NULL,NULL,'mean','NGC 3087',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66228,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66228,33.02,0.45,40.3,23602,NULL,NULL,'K','NGC 3087',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66229,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66229,36.41,0.46,192,23603,70,NULL,NULL,'2MASX J09590899+1017029',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,149.787583333,10.28422,0.061,NULL,60928841977,952013155,14875205,16.5),(66230,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66230,35.79,0.46,144,23604,70,NULL,NULL,'KUG 0955+517',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000149,NULL,'15.8g',0.35,'Spiral',NULL,NULL,NULL,NULL,1,149.788458333,51.515,0,NULL,63994183851,999909122,15623580,15.8),(66231,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 06D2ca',NULL,66231,42.42,0.14,1990,23605,70,NULL,'SALT 2','SDSS J095909.53+021808.5',0.531,'2013MNRAS.433.2240G',2013,1,0.04,NULL,'G',0.001,NULL,'22.4g',0.02,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,149.7897083,2.30239,0.005,NULL,60783497154,949742143,14839720,22.4),(66232,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 06D2ca',NULL,66232,42.56,0.05,2130,23605,70,NULL,NULL,'SDSS J095909.53+021808.5',0.531,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66233,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66233,38.21,0.27,439,23606,70,NULL,NULL,'SDSS J095909.70+051255.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000152,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,149.790417,5.21553,0.049,NULL,60906189280,951659207,14869675,18.4),(66234,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66234,37.03,0.46,255,23607,70,NULL,NULL,'2MASX J09591016+1414281',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,149.792375,14.24114,0.041,NULL,60853425040,950834766,14856793,16.8),(66235,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66235,37.25,0.46,282,23608,70,NULL,NULL,'2MASX J09591182+0535123',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000186,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,149.7992083,5.58658,0.045,NULL,60906309075,951661079,14869704,16.3),(66236,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66236,36.79,0.46,228,23609,70,NULL,NULL,'2MASX J09591291+2746322',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000144,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,149.80375,27.77558,0.049,NULL,64171116887,1002673701,15666776,17.4),(66237,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66237,36.89,0.33,239,23610,70,NULL,NULL,'SBS 0955+538',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000183,NULL,'16.0g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,149.805708333,53.60403,0.005,NULL,63993138091,999892782,15623324,16),(66238,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66238,36.67,0.46,216,23611,70,NULL,NULL,'2MASX J09591552+3821217',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,149.814875,38.35617,0.057,NULL,64058312429,1000911131,15639236,17),(66239,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66239,36.41,0.46,192,23612,70,NULL,NULL,'2MASX J09591587+2410162',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000155,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,149.8160417,24.17106,0.105,NULL,63688242554,995128789,15548887,16.9),(66240,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66240,37.67,0.46,342,23613,70,NULL,NULL,'2MASX J09591584+3019353',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000154,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,149.816166667,30.32661,0.077,NULL,64161066211,1002516659,15664322,17.2),(66241,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66241,36.7,0.33,218,23614,70,NULL,NULL,'2MASX J09591647+2509482',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,149.8185,25.16356,0.121,NULL,64159052210,1002485190,15663831,17.1),(66242,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','PS1 SN PS10p','N',66242,41.18,0.12,1310,23615,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10p HOST',0.3109,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66243,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66243,37.25,0.46,282,23616,70,NULL,NULL,'2MASX J09591737+1024199',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000177,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,149.822417,10.40556,0.061,NULL,60928847300,952013239,14875206,17.9),(66244,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SN 2007al',NULL,66244,34.15,0.29,66.9,23617,65,NULL,'MLCS31','2MASX J09591870-1928233',0.012122,'2009ApJ...700.1097H',2009,1,NULL,NULL,'G',0.00015,NULL,'14.9',NULL,NULL,NULL,NULL,NULL,NULL,1,149.828,-19.47314,0.129,NULL,41149837228,642966206,10046346,14.9),(66245,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SN 2007al',NULL,66245,34.34,0.25,72.8,23617,65,NULL,'MLCS17','2MASX J09591870-1928233',0.012122,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66246,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66246,38.32,0.27,460,23618,70,NULL,NULL,'2MASX J09591902+0120008',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000178,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,149.829291667,1.3335,0.017,NULL,60782259114,949722798,14839418,17.4),(66247,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2gp',NULL,66247,42.27,0.17,1670,23619,NULL,NULL,'SALT2','[AGR2006] J095920.40+023031.8',0.707,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,'23.7i',NULL,NULL,NULL,NULL,NULL,NULL,1,149.835125,2.50867,0.005,NULL,60783584749,949743511,14839742,23.7),(66248,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2gp',NULL,66248,42.59,0.26,1930,23619,74.2,NULL,'SALT 2','[AGR2006] J095920.40+023031.8',0.707,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66249,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2gp','R',66249,42.66,NULL,2000,23619,65,NULL,'MLCS17','[AGR2006] J095920.40+023031.8',0.707,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66250,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2gp',NULL,66250,43.21,0.25,2570,23619,65,NULL,'MLCS2k2','[AGR2006] J095920.40+023031.8',0.707,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66251,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2gp',NULL,66251,43.24,0.13,2600,23619,70,NULL,NULL,'[AGR2006] J095920.40+023031.8',0.707,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66252,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2gp',NULL,66252,43.3,0.26,2680,23619,65,NULL,'SALT2','[AGR2006] J095920.40+023031.8',0.707,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66253,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2gp',NULL,66253,43.32,0.25,2700,23619,70,NULL,'SALT','[AGR2006] J095920.40+023031.8',0.707,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66254,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2gp',NULL,66254,43.35,0.06,2740,23619,70,NULL,'SALT2','[AGR2006] J095920.40+023031.8',0.707,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66255,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2gp',NULL,66255,43.4,0.32,2800,23619,65,NULL,'MLCS17','[AGR2006] J095920.40+023031.8',0.707,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66256,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2gp',NULL,66256,43.43,0.32,2840,23619,65,NULL,'MLCS31','[AGR2006] J095920.40+023031.8',0.707,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66257,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2gp',NULL,66257,43.44,0.31,2850,23619,65,NULL,'MLCS2k2','[AGR2006] J095920.40+023031.8',0.707,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66258,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2gp',NULL,66258,43.46,0.15,2880,23619,NULL,NULL,'SIFTO','[AGR2006] J095920.40+023031.8',0.707,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66259,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2gp',NULL,66259,43.5,0.22,2930,23619,65,NULL,'SALT','[AGR2006] J095920.40+023031.8',0.707,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66260,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2gp',NULL,66260,43.5,NULL,2930,23619,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','[AGR2006] J095920.40+023031.8',0.707,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66261,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2gp',NULL,66261,43.5,0.09,2940,23619,65,NULL,'SALT','[AGR2006] J095920.40+023031.8',0.707,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66262,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2gp',NULL,66262,43.52,0.25,2960,23619,65,NULL,'SALT2','[AGR2006] J095920.40+023031.8',0.707,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66263,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2gp',NULL,66263,43.56,0.3,3020,23619,70,NULL,'SALT 2','[AGR2006] J095920.40+023031.8',0.707,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66264,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66264,37.84,0.46,370,23620,70,NULL,NULL,'2MASX J09592236+2546212',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000181,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,149.843167,25.77256,0.101,NULL,64170125250,1002658207,15666534,17.3),(66265,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66265,37.07,0.46,259,23621,70,NULL,NULL,'2MASX J09592303+0354228',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,149.845833,3.90636,0.021,NULL,60779214485,949675226,14838675,17.7),(66266,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66266,36.92,0.46,242,23622,70,NULL,NULL,'2MASX J09592317+2654442',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00018,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,149.8464583,26.91231,0.061,NULL,64171920763,1002686261,15666972,16.6),(66267,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66267,37.92,0.46,385,23623,70,NULL,NULL,'2MASX J09592324+0409528',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000168,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,149.846916667,4.16467,0.037,NULL,60779365435,949677584,14838712,17),(66268,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66268,35.84,0.46,147,23624,70,NULL,NULL,'2MASX J09592412+1111159',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000178,NULL,'15.9g',0.44,'S0^-',NULL,NULL,NULL,NULL,1,149.850583,11.18775,0.045,NULL,60927087368,951985740,14874777,15.9),(66269,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66269,37.33,0.46,293,23625,70,NULL,NULL,'2MASX J09592440+1105459',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000182,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,149.8515417,11.09619,0.045,NULL,60927097372,951985896,14874779,16.6),(66270,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2cb',NULL,66270,42.08,0.12,1830,23626,70,NULL,'SALT 2','SDSS J095924.60+021941.0',0.427,'2013MNRAS.433.2240G',2013,1,0.04,NULL,'G',0.001,NULL,'23.2g',0.03,'Candidate      ELG',NULL,NULL,NULL,NULL,1,149.8525417,2.32806,0.005,NULL,60783508963,949742327,14839723,23.2),(66271,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2cb',NULL,66271,42.16,0.15,1900,23626,NULL,NULL,'SIFTO','SDSS J095924.60+021941.0',0.427,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66272,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2cb',NULL,66272,43.09,0.04,2900,23626,70,NULL,'SIFTO','SDSS J095924.60+021941.0',0.427,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66273,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2cb',NULL,66273,43.21,0.17,3070,23626,NULL,NULL,'SALT2','SDSS J095924.60+021941.0',0.427,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66274,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66274,38.32,0.27,460,23627,70,NULL,NULL,'2MASX J09592582+0111568',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000094,NULL,'17.5g',0.21,'AGN',NULL,NULL,NULL,NULL,1,149.8577083,1.19919,0.021,NULL,60782247929,949722623,14839415,17.5),(66275,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2ec',NULL,66275,42.69,0.06,2100,23628,70,NULL,'SIFTO','SDSS J095926.14+020048.3',0.642,'2011ApJS..192....1C',2011,1,0.06,NULL,'G',0.0002,NULL,'23.1g',0.03,NULL,NULL,NULL,NULL,NULL,1,149.858917,2.01342,0.005,NULL,60783638961,949744358,14839755,23.1),(66276,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2ec',NULL,66276,43.02,0.15,2440,23628,NULL,NULL,'SIFTO','SDSS J095926.14+020048.3',0.642,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66277,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2ec',NULL,66277,43.08,0.18,2520,23628,70,NULL,'SALT 2','SDSS J095926.14+020048.3',0.642,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66278,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2ec',NULL,66278,43.17,0.17,2630,23628,NULL,NULL,'SALT2','SDSS J095926.14+020048.3',0.642,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66279,'Brightest Stars','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66279,25.89,0.9,1.51,23629,NULL,NULL,'3, B, blue stars','Leo A',NULL,'1994MNRAS.271..530R',1994,1,5.1,NULL,'G',0.000013,NULL,'12.92',3.1,'IBm','Group member',NULL,NULL,NULL,1,149.86025,30.74639,0.069,1,64161309861,1002520466,15664382,12.92),(66280,'Brightest Stars','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66280,26,1,1.6,23629,NULL,NULL,NULL,'Leo A',NULL,'1986AJ.....91..496S',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66281,'Brightest Stars','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66281,26.63,0.88,2.12,23629,NULL,NULL,'3, B, blue stars','Leo A',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66282,'Brightest Stars','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66282,26.65,0.58,2.14,23629,NULL,NULL,'V, 3, red stars','Leo A',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66283,'Brightest Stars','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66283,26.8,NULL,2.3,23629,NULL,NULL,'Photographic','Leo A',NULL,'1984AJ.....89.1160D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66284,'Brightest Stars','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66284,26.91,0.55,2.41,23629,NULL,NULL,'3, B, red stars','Leo A',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66285,'Brightest Stars','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66285,27.28,0.35,2.86,23629,NULL,NULL,'3, B, red stars revised','Leo A',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66286,'Brightest Stars','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66286,27.37,0.36,2.98,23629,NULL,NULL,'V, 3, red stars revised','Leo A',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66287,'Brightest Stars','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66287,27.4,NULL,3.02,23629,NULL,NULL,'Photographic','Leo A',NULL,'1982ApJ...256..339S',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66288,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66288,24.47,0.05,0.78,23629,74.4,NULL,NULL,'Leo A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66289,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66289,24.47,0.1,0.783,23629,NULL,NULL,'3, R','Leo A',NULL,'2006MmSAI..77..299G',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66290,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66290,24.49,0.03,0.791,23629,NULL,NULL,NULL,'Leo A',NULL,'2003AJ....125.1261D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66291,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66291,24.61,0.04,0.836,23629,NULL,NULL,NULL,'Leo A',NULL,'2003AJ....125.1261D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66292,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66292,24.63,0.04,0.843,23629,NULL,18.52,NULL,'Leo A',NULL,'2011A&A...531A.134T',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66293,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66293,24.7,0.03,0.871,23629,NULL,18.515,NULL,'Leo A',NULL,'2013MNRAS.432.3047B',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66294,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66294,26.74,NULL,2.23,23629,NULL,NULL,'4','Leo A',NULL,'1994AJ....108..645H',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66295,'CMD','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66295,24.52,NULL,0.802,23629,NULL,NULL,NULL,'Leo A',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66296,'CMD','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66296,24.52,NULL,0.802,23629,NULL,NULL,NULL,'Leo A',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66297,'PNLF','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66297,27.5,0.44,3.2,23629,NULL,NULL,NULL,'Leo A',NULL,'1981AJ.....86..185J',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66298,'Red Clump','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66298,24.2,NULL,0.691,23629,NULL,NULL,'V, M RC(V) = +0.73 mag','Leo A',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66299,'Red Clump','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66299,24.43,0.15,0.769,23629,NULL,NULL,NULL,'Leo A',NULL,'2003AJ....125.1261D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66300,'Red Clump','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66300,24.5,NULL,0.795,23629,NULL,NULL,'I, M RC(I) = -0.50 mag','Leo A',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66301,'Red Clump','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66301,24.6,0.1,0.832,23629,NULL,NULL,NULL,'Leo A',NULL,'2002AJ....124..896S',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66302,'RR Lyrae','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66302,24.44,0.11,0.773,23629,NULL,18.515,'Excluding 3 outlier RR Lyrae','Leo A',NULL,'2013MNRAS.432.3047B',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66303,'RR Lyrae','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66303,24.48,0.12,0.787,23629,NULL,18.515,'All RR Lyrae','Leo A',NULL,'2013MNRAS.432.3047B',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66304,'RR Lyrae','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66304,24.51,0.12,0.798,23629,NULL,NULL,'8','Leo A',NULL,'2002AJ....123.3154D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66305,'RR Lyrae','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66305,24.52,0.09,0.802,23629,NULL,NULL,NULL,'Leo A',NULL,'2003AJ....125.1261D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66306,'RR Lyrae','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66306,24.54,NULL,0.809,23629,NULL,NULL,NULL,'Leo A',NULL,'2008ApJ...679...52T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66307,'RR Lyrae','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66307,24.6,NULL,0.832,23629,NULL,NULL,NULL,'Leo A',NULL,'2004A&A...424..927C',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66308,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66308,24.2,0.2,0.692,23629,NULL,NULL,NULL,'Leo A',NULL,'1998AJ....116.1244T',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66309,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66309,24.4,0.2,0.759,23629,NULL,NULL,'M(I)TRGB = -3.91 mag for [Fe/H] < -0.7','Leo A',NULL,'2002AJ....124..896S',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66310,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66310,24.47,0.05,0.78,23629,74.4,NULL,NULL,'Leo A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66311,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66311,24.49,0.14,0.791,23629,NULL,NULL,NULL,'Leo A',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66312,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66312,24.5,0.2,0.794,23629,NULL,NULL,NULL,'Leo A',NULL,'2002AJ....124..896S',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66313,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66313,24.52,0.21,0.802,23629,NULL,NULL,'HST KP Calibrated','Leo A',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66314,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66314,24.53,0.06,0.805,23629,NULL,NULL,NULL,'Leo A',NULL,'2003AJ....125.1261D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66315,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66315,24.57,0.13,0.82,23629,NULL,18.515,'Rizzi et al. 2007 TRGB','Leo A',NULL,'2013MNRAS.432.3047B',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66316,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66316,24.58,0.13,0.824,23629,NULL,18.515,'Cassini & Salaris 2013 TRGB','Leo A',NULL,'2013MNRAS.432.3047B',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66317,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66317,24.78,NULL,0.904,23629,NULL,NULL,'I, M TRGB(I) = -4.05 mag','Leo A',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66318,'Tully est','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66318,25,0.8,1,23629,75,NULL,'B','Leo A',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66319,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66319,36.93,0.46,244,23630,70,NULL,NULL,'2MASX J09592666+2611122',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000189,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,149.8612083,26.18683,0.085,NULL,64169988801,1002656075,15666501,16.3),(66320,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 06D2cc',NULL,66320,41.88,0.17,1550,23631,NULL,NULL,'SALT2','SDSS J095926.88+022702.9',0.532,'2010A&A...523A...7G',2010,1,0.03,NULL,'G',0.001,NULL,'22.9g',0.01,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,149.862,2.45083,0.005,NULL,60783530239,949742659,14839729,22.9),(66321,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 06D2cc',NULL,66321,42.26,0.17,1850,23631,70,NULL,'SALT 2','SDSS J095926.88+022702.9',0.532,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66322,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 06D2cc',NULL,66322,42.3,NULL,1890,23631,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SDSS J095926.88+022702.9',0.532,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66323,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 06D2cc',NULL,66323,42.31,0.15,1890,23631,NULL,NULL,'SIFTO','SDSS J095926.88+022702.9',0.532,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66324,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 06D2cc',NULL,66324,43.04,0.05,2640,23631,70,NULL,'SALT2','SDSS J095926.88+022702.9',0.532,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66325,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66325,36.89,0.33,239,23632,70,NULL,NULL,'2MASX J09592741+5338095',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000177,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,149.864375,53.63594,0.005,NULL,63993139021,999892797,15623324,16.6),(66326,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2fp','R',66326,41.03,NULL,1130,23633,65,NULL,'SALT','[AGR2006] J095928.16+021915.5',0.415,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,149.867333,2.321,0.005,NULL,60783498731,949742167,14839721,NULL),(66327,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2fp',NULL,66327,41.15,0.14,1200,23633,74.2,NULL,'SALT 2','[AGR2006] J095928.16+021915.5',0.415,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66328,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2fp',NULL,66328,41.68,0.03,1530,23633,70,NULL,'SALT','[AGR2006] J095928.16+021915.5',0.415,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66329,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2fp',NULL,66329,41.77,0.03,1600,23633,70,NULL,NULL,'[AGR2006] J095928.16+021915.5',0.415,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66330,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2fp',NULL,66330,41.77,0.13,1600,23633,70,NULL,'SALT','[AGR2006] J095928.16+021915.5',0.415,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66331,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2fp',NULL,66331,41.79,0.12,1610,23633,70,NULL,'SALT 2','[AGR2006] J095928.16+021915.5',0.415,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66332,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2fp',NULL,66332,41.85,NULL,1660,23633,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','[AGR2006] J095928.16+021915.5',0.415,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66333,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2fp',NULL,66333,41.88,0.15,1680,23633,NULL,NULL,'SIFTO','[AGR2006] J095928.16+021915.5',0.415,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66334,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2fp',NULL,66334,41.89,0.08,1690,23633,65,NULL,'SALT2','[AGR2006] J095928.16+021915.5',0.415,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66335,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2fp',NULL,66335,41.89,0.12,1690,23633,65,NULL,'MLCS2k2','[AGR2006] J095928.16+021915.5',0.415,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66336,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2fp',NULL,66336,41.92,0.1,1710,23633,65,NULL,'SALT','[AGR2006] J095928.16+021915.5',0.415,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66337,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2fp',NULL,66337,41.98,0.15,1760,23633,65,NULL,'MLCS17','[AGR2006] J095928.16+021915.5',0.415,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66338,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2fp',NULL,66338,42.04,0.03,1810,23633,65,NULL,'SALT','[AGR2006] J095928.16+021915.5',0.415,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66339,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2fp',NULL,66339,42.05,0.17,1810,23633,65,NULL,'SALT2','[AGR2006] J095928.16+021915.5',0.415,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66340,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2fp',NULL,66340,42.05,0.16,1820,23633,65,NULL,'MLCS31','[AGR2006] J095928.16+021915.5',0.415,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66341,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2fp',NULL,66341,42.06,0.14,1830,23633,65,NULL,'MLCS2k2','[AGR2006] J095928.16+021915.5',0.415,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66342,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2fp',NULL,66342,42.38,0.17,2110,23633,NULL,NULL,'SALT2','[AGR2006] J095928.16+021915.5',0.415,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66343,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66343,32.88,0.4,37.7,23634,NULL,NULL,'mean','ESO 499- G 032',NULL,'2007A&A...465...71T',2007,1,2,NULL,'G',0.000027,NULL,'13.39',1.4,'SB(r)ab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,149.8685417,-26.86389,0.165,NULL,42831335513,669239617,10456869,13.39),(66344,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66344,33.48,0.47,49.6,23634,NULL,NULL,'H','ESO 499- G 032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66345,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66345,33.5,0.46,50,23634,NULL,NULL,'J','ESO 499- G 032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66346,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66346,33.51,0.45,50.3,23634,NULL,NULL,'K','ESO 499- G 032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66347,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66347,36.38,0.33,188,23635,70,NULL,NULL,'2MASX J09592927+0832599',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,149.8719583,8.54992,0.057,NULL,60923433496,951928648,14873885,17),(66348,'Ring Diameter','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66348,31.8,0.76,23,23636,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3081',NULL,'1981ApJS...45..541P',1981,1,2.1,'The IC identification is not certain.','G',0.00001,NULL,'12.85',1.6,'(R_1)SAB(r)0/a Sy2',NULL,NULL,NULL,'Sy 1 h',1,149.873083333,-22.82628,0.129,NULL,42293792203,660840503,10325632,12.85),(66349,'Ring Diameter','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66349,31.9,0.98,24,23636,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3081',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66350,'Tully est','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66350,32.56,0.8,32.5,23636,75,NULL,'B','NGC 3081',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66351,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66351,35.06,0.51,103,23637,70,NULL,NULL,'MCG -02-26-010',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00011,NULL,'15',0.7,NULL,NULL,NULL,NULL,NULL,1,149.874833333,-12.33856,0.169,NULL,41158765787,643105715,10048526,15),(66352,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66352,36.22,0.46,175,23638,70,NULL,NULL,'2MASX J09593063+1610312',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'16.44',0.42,NULL,NULL,NULL,NULL,NULL,1,149.8777083,16.17547,0.081,NULL,60865224071,951019126,14859673,16.44),(66353,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66353,36.2,0.46,174,23639,70,NULL,NULL,'2MASX J09593156-0015237',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000072,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,149.8814583,-0.25653,0.041,NULL,41231965042,644249453,10066397,16.8),(66354,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66354,37.62,0.46,334,23640,70,NULL,NULL,'SDSS J095932.07+140258.0',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.7g',0.26,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,149.883667,14.04947,0.033,NULL,60854572015,950852687,14857073,16.7),(66355,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 06D2fb',NULL,66355,38.89,0.11,533,23641,70,NULL,'SALT 2','SDSS J095932.09+014939.1',0.1245,'2013MNRAS.433.2240G',2013,1,0.14,NULL,'G',0.0002,NULL,'20.13',0.13,NULL,NULL,NULL,NULL,NULL,1,149.8837083,1.82753,0.009,NULL,60783276393,949738693,14839667,20.13),(66356,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 06D2fb',NULL,66356,38.94,NULL,545,23641,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SDSS J095932.09+014939.1',0.1245,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66357,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 06D2fb',NULL,66357,39.02,0.02,566,23641,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SDSS J095932.09+014939.1',0.1245,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66358,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66358,37.72,0.15,351,23642,70,NULL,NULL,'SDSS J095932.20+112923.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000182,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,149.884208333,11.48981,0.073,NULL,60872854406,951138350,14861536,18),(66359,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66359,28.1,0.15,4.2,23643,NULL,NULL,NULL,'MESSIER 081:[CKT2009] d0959+68',NULL,'2013AJ....146..126C',2013,1,NULL,NULL,'G',NULL,NULL,'18.0B',NULL,'dI/tdl',NULL,NULL,NULL,NULL,1,149.887917,68.65694,0.169,NULL,62126362693,970724417,15167569,18),(66360,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66360,38.26,0.46,450,23644,70,NULL,NULL,'2MASX J09593420+2400452',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000182,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,149.8925417,24.01244,0.109,NULL,63688353973,995130530,15548914,17.8),(66361,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66361,37.82,0.46,366,23645,70,NULL,NULL,'2MASX J09593480+0039467',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000073,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,149.895041667,0.663,0.029,NULL,60774266435,949597913,14837467,17.8),(66362,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66362,37.38,0.46,299,23646,70,NULL,NULL,'2MASX J09593537+0320587',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,149.897417,3.34972,0.021,NULL,60776794421,949637412,14838084,17.7),(66363,'IRAS','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66363,32.8,0.8,36.3,23647,75,NULL,'MAT, I','NGC 3089',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'13.21',1,'SAB(rs)b       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,149.902833,-28.33136,0.185,NULL,42825192895,669143638,10455369,13.21),(66364,'Sosies','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66364,32.38,0.31,29.9,23647,NULL,NULL,NULL,'NGC 3089',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66365,'Tully est','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66365,32.73,0.8,35.1,23647,75,NULL,'B','NGC 3089',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66366,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66366,32.4,0.32,30.2,23647,85,NULL,'I, raw','NGC 3089',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66367,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66367,32.44,0.32,30.8,23647,85,NULL,'I, inv','NGC 3089',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66368,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66368,32.61,0.43,33.3,23647,75,NULL,'MAT, I, raw','NGC 3089',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66369,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66369,32.73,0.2,35.2,23647,74.4,NULL,NULL,'NGC 3089',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66370,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66370,32.77,0.45,35.7,23647,NULL,NULL,'K','NGC 3089',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66371,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66371,32.79,0.47,36.2,23647,NULL,NULL,'H','NGC 3089',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66372,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66372,32.8,0.43,36.4,23647,75,NULL,'MAT, I, inv','NGC 3089',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66373,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66373,32.82,0.46,36.6,23647,NULL,NULL,'J','NGC 3089',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66374,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66374,32.93,0.43,38.6,23647,75,NULL,'MAT, I, cor','NGC 3089',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66375,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66375,33.03,0.4,40.4,23647,NULL,NULL,'mean','NGC 3089',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66376,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66376,33.17,0.08,43.1,23647,NULL,NULL,NULL,'NGC 3089',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66377,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66377,38.28,0.46,454,23648,70,NULL,NULL,'2MASX J09593758+4511338',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000136,NULL,'17.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,149.9067917,45.19258,0.005,NULL,63979211452,999675178,15619924,17.5),(66378,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66378,38.56,0.46,516,23649,70,NULL,NULL,'2MASX J09593794+1919529',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000155,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,149.908083333,19.33131,0.037,NULL,60808467435,950132303,14845817,18.5),(66379,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66379,37.72,0.15,351,23650,70,NULL,NULL,'2MASX J09593792+1129499',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000146,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,149.908125,11.49717,0.073,NULL,60872864838,951138513,14861539,17.3),(66380,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66380,37.09,0.27,262,23651,70,NULL,NULL,'SDSS J095939.70+140133.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,149.9154583,14.02589,0.033,NULL,60854574099,950852720,14857073,18.4),(66381,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66381,33.67,0.48,54.2,23652,70,NULL,NULL,'ESO 566- G 040',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'14.5',0.4,'S0','Pair member (points to parent)',NULL,NULL,NULL,1,149.917125,-20.78753,NULL,NULL,42285874120,660716783,10323699,14.5),(66382,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66382,38.14,0.46,425,23653,70,NULL,NULL,'SDSS J095940.15+420955.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00016,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,149.917333,42.16542,0,NULL,64103551101,1001617985,15650281,18.6),(66383,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66383,37.33,0.27,293,23654,70,NULL,NULL,'2MASX J09594042+1859599',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000152,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,149.9185,18.99986,0.041,NULL,60808772804,950137075,14845891,17.2),(66384,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66384,37.09,0.27,262,23655,70,NULL,NULL,'2MASX J09594062+1345442',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,149.919167,13.76225,0.033,NULL,60854473915,950851154,14857049,17.3),(66385,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66385,37.14,0.46,268,23656,70,NULL,NULL,'2MASX J09594076+2459301',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000183,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,149.919833,24.99181,0.109,NULL,64159155618,1002486806,15663856,17),(66386,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66386,36.86,0.46,235,23657,70,NULL,NULL,'2MASX J09594104+5417094',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000147,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,149.9210417,54.28592,0,NULL,61900376838,967193388,15112396,16.5),(66387,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66387,37.09,0.27,262,23658,70,NULL,NULL,'CGCG 064-023',NULL,'2015arXiv151105856S',2015,1,0.88,NULL,'G',0.000137,NULL,'15.7',0.63,NULL,NULL,NULL,NULL,NULL,1,149.921791667,14.07022,0.033,NULL,60854544127,950852251,14857066,15.7),(66388,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66388,38.57,0.46,517,23659,70,NULL,NULL,'2MASX J09594181+5044459',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00014,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,149.92425,50.74603,0.005,NULL,63993701546,999901586,15623462,18),(66389,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66389,37.68,0.46,344,23660,70,NULL,NULL,'SDSS J095941.86+030815.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000146,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,149.9244583,3.13764,0.021,NULL,60776782840,949637231,14838081,18.5),(66390,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66390,35.68,0.46,137,23661,70,NULL,NULL,'2MASX J09594194+3939267',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000171,NULL,'15.6g',0.4,'E0',NULL,NULL,NULL,NULL,1,149.924666667,39.65736,0.009,NULL,64091036362,1001422443,15647225,15.6),(66391,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66391,37.13,0.46,267,23662,70,NULL,NULL,'2MASX J09594301+4540598',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,149.9292917,45.68328,0.005,NULL,63979575219,999680862,15620013,17),(66392,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66392,37.55,0.46,323,23663,70,NULL,NULL,'2MASX J09594340+1621582',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,149.93075,16.36617,0.081,NULL,60860876139,950951189,14858612,17),(66393,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66393,34.16,0.46,68,23664,70,NULL,NULL,'CGCG 064-021',NULL,'2015arXiv151105856S',2015,1,1.03,NULL,'G',0.000017,NULL,'14.5g',0.65,'S0',NULL,NULL,NULL,NULL,1,149.9312083,11.66075,0.069,NULL,60872058208,951125909,14861342,14.5),(66394,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66394,37.68,0.46,344,23665,70,NULL,NULL,'2MASX J09594385+0245221',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000081,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,149.932541667,2.75619,0.013,NULL,60783367340,949740114,14839689,18),(66395,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66395,35.17,0.46,108,23666,70,NULL,NULL,'IC 0585',NULL,'2015arXiv151105856S',2015,1,1.1,'UGC misprints R.A. as 09h57.1m. UGC galactic coordinates are correct.','G',0.000083,NULL,'14.5g',0.7,'S0-:','Group member',NULL,NULL,NULL,1,149.933833,12.98858,0.053,NULL,60851949113,950811704,14856432,14.5),(66396,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66396,37.72,0.15,351,23667,70,NULL,NULL,'SDSS J095945.35+112935.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.0002,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,149.939,11.49311,0.073,NULL,60872867411,951138553,14861539,18.4),(66397,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2mh',NULL,66397,42.51,0.04,1990,23668,70,NULL,'SIFTO','[NSB2006] J095945.87+020827.9',0.6,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',NULL,NULL,'23.1i',NULL,NULL,NULL,NULL,NULL,NULL,1,149.941167,2.14136,0.005,NULL,60783602018,949743781,14839746,23.1),(66398,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2mh',NULL,66398,42.66,0.15,2130,23668,NULL,NULL,'SIFTO','[NSB2006] J095945.87+020827.9',0.6,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66399,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2mh',NULL,66399,42.69,0.14,2160,23668,70,NULL,'SALT 2','[NSB2006] J095945.87+020827.9',0.6,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66400,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 04D2mh',NULL,66400,44.68,0.17,5400,23668,NULL,NULL,'SALT2','[NSB2006] J095945.87+020827.9',0.6,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66401,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66401,37.72,0.15,351,23669,70,NULL,NULL,'CGCG 064-024',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.000227,NULL,'15.7',0.5,'BrClG',NULL,NULL,NULL,NULL,1,149.9452083,11.48872,0.061,NULL,60872867644,951138556,14861539,15.7),(66402,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66402,37.6,0.46,331,23670,70,NULL,NULL,'2MASX J09594785+4039461',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000185,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,149.94925,40.66267,0.009,NULL,64090301652,1001410963,15647046,17),(66403,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66403,37.83,0.46,367,23671,70,NULL,NULL,'SDSS J095948.59+081710.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000146,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,149.9524583,8.28619,0.065,NULL,60924278080,951941845,14874091,18.3),(66404,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66404,36.38,0.33,188,23672,70,NULL,NULL,'2MASX J09594861+0831218',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000179,NULL,'15.8g',0.44,'S0^-',NULL,NULL,NULL,NULL,1,149.952625,8.52278,0.057,NULL,60923432782,951928637,14873884,15.8),(66405,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66405,38.5,0.46,502,23673,70,NULL,NULL,'2MASX J09594936+2834122',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00019,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,149.95575,28.57022,0.037,NULL,64163109784,1002548590,15664821,17.7),(66406,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66406,34.52,0.47,80.3,23674,70,NULL,NULL,'NGC 3083',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00009,NULL,'14.24',0.4,'Sa?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,149.956958333,-2.87747,0.077,NULL,41237618619,644337790,10067777,14.24),(66407,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66407,37.98,0.46,395,23675,70,NULL,NULL,'2MASX J09595155+0547501',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,149.964875,5.79733,0.037,NULL,60906434470,951663038,14869734,17.5),(66408,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66408,37.97,0.46,393,23676,70,NULL,NULL,'2MASX J09595504+5335250',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,149.97925,53.59025,0.005,NULL,63993254028,999894594,15623353,17.8),(66409,'IRAS','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66409,32.57,0.8,32.7,23677,75,NULL,'HMCL, I','IC 2531',NULL,'1997ApJS..109..333W',1997,1,7.5,'The 2MASX position is weighted toward the south by the J-band image.','G',0.000017,NULL,'12.9',0.9,'Sb             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,149.982375,-29.61697,0.233,NULL,42828009099,669187642,10456056,12.9),(66410,'IRAS','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66410,32.57,0.8,32.7,23677,75,NULL,'A82, H','IC 2531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66411,'IRAS','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66411,32.6,0.8,33.2,23677,75,NULL,'MAT, I','IC 2531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66412,'Tully est','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66412,32.59,0.8,32.9,23677,75,NULL,NULL,'IC 2531',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66413,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66413,32.14,NULL,26.8,23677,NULL,NULL,NULL,'IC 2531',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66414,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66414,32.18,0.4,27.2,23677,75,NULL,NULL,'IC 2531',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66415,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66415,32.18,0.46,27.3,23677,NULL,NULL,'J','IC 2531',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66416,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66416,32.24,NULL,28.1,23677,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 2531',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66417,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66417,32.25,0.47,28.2,23677,NULL,NULL,'H','IC 2531',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66418,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66418,32.25,NULL,28.2,23677,NULL,NULL,'Dipole + Quadrupole','IC 2531',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66419,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66419,32.26,NULL,28.3,23677,NULL,NULL,'Dipole','IC 2531',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66420,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66420,32.29,0.43,28.7,23677,75,NULL,'MAT, I, raw','IC 2531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66421,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66421,32.36,0.45,29.6,23677,NULL,NULL,'K','IC 2531',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66422,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66422,32.46,0.32,31,23677,85,NULL,'I, raw','IC 2531',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66423,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66423,32.51,0.32,31.8,23677,85,NULL,'I, inv','IC 2531',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66424,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66424,32.54,0.43,32.2,23677,75,NULL,'MAT, I, inv','IC 2531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66425,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66425,32.64,0.35,33.7,23677,NULL,NULL,NULL,'IC 2531',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66426,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66426,32.67,0.43,34.1,23677,75,NULL,'MAT, I, cor','IC 2531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66427,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66427,32.73,0.49,35.1,23677,75,NULL,'IR','IC 2531',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66428,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66428,32.8,0.2,36.3,23677,74.4,NULL,NULL,'IC 2531',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66429,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66429,32.84,0.4,37.1,23677,NULL,NULL,'mean','IC 2531',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66430,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66430,32.85,0.43,37.1,23677,75,NULL,'3.6 micron, color corrected','IC 2531',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66431,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66431,32.88,0.4,37.6,23677,75,NULL,'HMCL, I, raw','IC 2531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66432,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66432,32.9,0.43,38.1,23677,75,NULL,'3.6 micron, color + selection bias corrected','IC 2531',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66433,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66433,33.01,0.47,40,23677,75,NULL,'A82, H, raw','IC 2531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66434,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66434,33.02,0.19,40.3,23677,NULL,NULL,NULL,'IC 2531',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66435,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66435,33.11,0.4,41.9,23677,75,NULL,'HMCL, I, cor','IC 2531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66436,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66436,33.12,0.4,42,23677,75,NULL,'HMCL, I, inv','IC 2531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66437,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66437,33.24,0.47,44.5,23677,75,NULL,'A82, H, inv','IC 2531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66438,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66438,33.29,0.47,45.5,23677,75,NULL,'A82, H, cor','IC 2531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66439,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66439,37.96,0.46,391,23678,70,NULL,NULL,'2MASX J09595609+4123391',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,149.9837083,41.39403,0.005,NULL,64091606285,1001431348,15647364,17.3),(66440,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66440,36.87,0.46,237,23679,70,NULL,NULL,'2MASX J09595685+1957049',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,149.986833,19.95125,0.045,NULL,60807226553,950112914,14845514,17.4),(66441,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66441,37.13,0.33,266,23680,70,NULL,NULL,'SDSS J095956.97+301339.6',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.6g',0.28,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,149.987375,30.22769,0.077,NULL,64160937685,1002514651,15664291,16.6),(66442,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66442,34.73,0.46,88.5,23681,70,NULL,NULL,'CGCG 153-011',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000087,NULL,'15.5g',0.38,NULL,NULL,NULL,NULL,NULL,1,149.987917,29.28881,0.081,NULL,64164387878,1002568560,15665133,15.5),(66443,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66443,36.56,0.46,205,23682,70,NULL,NULL,'2MASX J09595846+1425131',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,149.9937083,14.42047,0.033,NULL,60855026675,950859791,14857184,17.7),(66444,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66444,36.42,0.55,192,23683,70,NULL,NULL,'2MASX J09595937-0115313',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'17.28',0.4,NULL,NULL,NULL,NULL,NULL,1,149.99725,-1.25872,0.077,NULL,41235801524,644309398,10067334,17.28),(66445,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66445,36.85,0.46,235,23684,70,NULL,NULL,'2MASX J09595977-0052093',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000089,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,149.999041667,-0.86917,0.065,NULL,41231530968,644242671,10066291,16.3),(66446,'Brightest Stars','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66446,26.64,NULL,2.13,23685,NULL,NULL,'Photographic','Sextans B',NULL,'1982ApJ...256..339S',1982,1,5.1,NULL,'G',0.000002,NULL,'11.85',3.5,'ImIV-V','Possible field galaxy',NULL,NULL,NULL,1,150.000417,5.33222,0.049,1,60906388196,951662315,14869723,11.85),(66447,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66447,25.5,0.1,1.26,23685,NULL,18.47,'9, B, Photographic','Sextans B',NULL,'1987SAAOC..11..125W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66448,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66448,25.62,0.04,1.33,23685,NULL,18.52,NULL,'Sextans B',NULL,'2011A&A...531A.134T',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66449,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66449,25.64,NULL,1.34,23685,NULL,NULL,'B','Sextans B',NULL,'1991PASP..103..933M',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66450,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66450,25.63,0.21,1.34,23685,NULL,NULL,'3, VRI','Sextans B',NULL,'1994A&A...287..371P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66451,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66451,25.63,0.21,1.34,23685,NULL,NULL,'LMC VIHJK','Sextans B',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66452,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66452,25.69,0.27,1.37,23685,NULL,NULL,'8, BVRI','Sextans B',NULL,'1997ApJ...480..589S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66453,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66453,25.69,0.25,1.37,23685,NULL,NULL,'HST KP Calibrated','Sextans B',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66454,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66454,25.7,0.06,1.38,23685,74.4,NULL,NULL,'Sextans B',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66455,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66455,25.8,0.26,1.45,23685,NULL,NULL,'LMC W01','Sextans B',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66456,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66456,25.9,0.12,1.51,23685,NULL,NULL,'BVRI+','Sextans B',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66457,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66457,25.94,0.12,1.54,23685,NULL,NULL,'BVRI','Sextans B',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66458,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66458,26.19,0.51,1.73,23685,NULL,NULL,'BV(W)','Sextans B',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66459,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66459,26.2,0.2,1.74,23685,NULL,NULL,'Photographic','Sextans B',NULL,'1985AJ.....90.1019S',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66460,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66460,26.25,NULL,1.78,23685,NULL,NULL,'Photographic, APPARENT BLUE m-M','Sextans B',NULL,'1988PASP..100..935S',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66461,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66461,26.72,0.3,2.21,23685,NULL,NULL,'MW HIPP','Sextans B',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66462,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66462,26.76,0.35,2.25,23685,NULL,NULL,'MW P02','Sextans B',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66463,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66463,26.77,0.18,2.26,23685,NULL,NULL,'9, VI','Sextans B',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66464,'Cepheids','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66464,26.77,0.18,2.26,23685,NULL,NULL,'MW GFG','Sextans B',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66465,'CMD','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66465,25.7,NULL,1.38,23685,NULL,NULL,NULL,'Sextans B',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66466,'PNLF','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66466,26.5,NULL,2,23685,NULL,NULL,NULL,'Sextans B',NULL,'2002A&A...386..869M',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66467,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66467,25.56,0.1,1.29,23685,NULL,NULL,NULL,'Sextans B',NULL,'1999IAUS..183...48S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66468,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66468,25.6,0.12,1.32,23685,NULL,NULL,'HST KP Calibrated','Sextans B',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66469,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66469,25.63,0.04,1.34,23685,NULL,NULL,NULL,'Sextans B',NULL,'2002AJ....124..213M',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66470,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66470,25.63,0.04,1.34,23685,NULL,NULL,NULL,'Sextans B',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66471,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66471,25.66,0.13,1.36,23685,NULL,NULL,NULL,'Sextans B',NULL,'2002A&A...389..812K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66472,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66472,25.7,0.12,1.38,23685,NULL,NULL,NULL,'Sextans B',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66473,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66473,25.7,0.06,1.38,23685,74.4,NULL,NULL,'Sextans B',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66474,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66474,25.72,0.05,1.39,23685,NULL,NULL,'I','Sextans B',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66475,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66475,25.72,NULL,1.39,23685,NULL,NULL,'DA90','Sextans B',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66476,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66476,25.76,0.1,1.42,23685,NULL,NULL,NULL,'Sextans B',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66477,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66477,25.77,0.03,1.43,23685,NULL,NULL,'I','Sextans B',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66478,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66478,25.79,0.04,1.44,23685,NULL,NULL,'I','Sextans B',NULL,'2007ApJ...661..815R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66479,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66479,25.79,0.02,1.44,23685,NULL,NULL,NULL,'Sextans B',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66480,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66480,25.8,0.12,1.44,23685,NULL,NULL,'I','Sextans B',NULL,'2014A&A...566A..44B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66481,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66481,25.81,NULL,1.45,23685,NULL,NULL,'Yale','Sextans B',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66482,'TRGB','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66482,25.85,NULL,1.48,23685,NULL,NULL,'K97','Sextans B',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66483,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66483,25.7,0.06,1.38,23685,74.4,NULL,NULL,'Sextans B',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66484,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66484,25.96,0.4,1.6,23685,75,NULL,'B','Sextans B',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66485,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66485,38.81,0.46,577,23686,70,NULL,NULL,'SDSS J100000.87+003156.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000077,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,150.003625,0.53231,0.021,NULL,60774371746,949599558,14837493,18.4),(66486,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2ci',NULL,66486,41.3,0.17,1120,23687,NULL,NULL,'SALT2','SDSS J100001.97+021256.3',0.6303,'2010A&A...523A...7G',2010,1,0.08,NULL,'G',0.0002,NULL,'22.3g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,150.0082083,2.21564,0.005,NULL,60783594005,949743656,14839744,22.3),(66487,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2ci',NULL,66487,42.35,0.22,1810,23687,70,NULL,'SALT 2','SDSS J100001.97+021256.3',0.6303,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66488,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2ci',NULL,66488,42.53,NULL,1970,23687,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SDSS J100001.97+021256.3',0.6303,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66489,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2ci',NULL,66489,42.64,0.15,2070,23687,NULL,NULL,'SIFTO','SDSS J100001.97+021256.3',0.6303,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66490,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2ci',NULL,66490,43.1,0.06,2560,23687,70,NULL,'SALT2','SDSS J100001.97+021256.3',0.6303,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66491,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66491,37.53,0.46,321,23688,70,NULL,NULL,'2MASX J10000203+2107029',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000169,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,150.008417,21.11736,0.057,NULL,63695876357,995248068,15550751,18.1),(66492,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66492,37.06,0.46,259,23689,70,NULL,NULL,'SDSS J100002.07+243713.1',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.3g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,150.008666667,24.62033,0.109,NULL,64159102757,1002485980,15663843,17.3),(66493,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66493,35.09,0.6,104,23690,70,NULL,NULL,'2MASX J10000231-0103443',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.000085,NULL,'16.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,150.009417,-1.06228,0.065,NULL,41231545112,644242892,10066295,16.1),(66494,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66494,35.51,0.46,127,23690,70,NULL,NULL,'2MASX J10000231-0103443',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66495,'Tully-Fisher','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66495,35.23,0.49,111,23691,75,NULL,'IR','2MFGC 07740',NULL,'2011yCatp016004901K',2011,1,1.35,NULL,'G',NULL,NULL,'17.0',0.13,NULL,NULL,NULL,NULL,NULL,1,150.012667,-64.44031,NULL,NULL,40755416700,636803385,9950052,17),(66496,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66496,37.44,0.46,307,23692,70,NULL,NULL,'2MASX J10000322+0201462',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000085,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,150.013375,2.02956,0.005,NULL,60783197966,949737468,14839647,17),(66497,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66497,34.93,0.56,96.9,23693,70,NULL,NULL,'2MASX J10000339-4000066',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,150.014125,-40.00192,0.709,NULL,42080159412,657502490,10273476,14.4),(66498,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,'R',66498,37.13,0.33,266,23694,70,NULL,NULL,'2MASX J10000414+3014166',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'18.1g',0.1,NULL,NULL,NULL,NULL,NULL,1,150.017333333,30.23789,0.077,NULL,64160934426,1002514600,15664290,18.1),(66499,'FP','2016-12-15 15:14:33','2016-12-16 11:19:40','1',NULL,NULL,66499,35.59,0.48,131,23695,70,NULL,NULL,'2MASX J10000448-1214020',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000107,NULL,'15.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,150.018625,-12.23389,0.169,NULL,41158740300,643105317,10048520,15.5),(66500,'SNIa','2016-12-15 15:14:33','2016-12-16 11:19:40','1','SNLS 05D2hc',NULL,66500,41.13,0.17,1240,23696,NULL,NULL,'SALT2','[NSB2006] J100004.57+015309.9',0.36,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,150.019041667,1.88608,0.009,NULL,60783302971,949739108,14839673,NULL),(66501,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:40','1','SNLS 05D2hc',NULL,66501,41.57,0.11,1520,23696,70,NULL,'SALT 2','[NSB2006] J100004.57+015309.9',0.36,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66502,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:40','1','SNLS 05D2hc',NULL,66502,41.63,0.15,1560,23696,NULL,NULL,'SIFTO','[NSB2006] J100004.57+015309.9',0.36,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66503,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:40','1','SNLS 05D2hc',NULL,66503,42.18,0.03,2010,23696,70,NULL,'SALT2','[NSB2006] J100004.57+015309.9',0.36,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66504,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,'R',66504,37.64,0.33,337,23697,70,NULL,NULL,'2MASX J10000517+2515242',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,150.0214583,25.25697,0.117,NULL,64159067876,1002485435,15663834,18.2),(66505,'Tully est','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66505,32.89,0.8,37.8,23698,75,NULL,NULL,'IC 2532',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.00003,NULL,'13.88',1.3,'SB(rs)0/a      HII','Group member, radial-velocity confirmed',NULL,NULL,'H_alpha Emission-Line Galaxy',1,150.0225,-34.22828,0.581,NULL,41972081835,655813778,10247090,13.88),(66506,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66506,32.07,0.47,25.9,23698,NULL,NULL,'H','IC 2532',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66507,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66507,32.16,0.46,27,23698,NULL,NULL,'J','IC 2532',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66508,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66508,32.17,0.45,27.2,23698,NULL,NULL,'K','IC 2532',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66509,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66509,33.02,0.4,40.2,23698,NULL,NULL,'mean','IC 2532',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66510,'IRAS','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66510,32.75,0.8,35.6,23699,75,NULL,'MAT, I','NGC 3095',NULL,'1997ApJS..109..333W',1997,1,3.5,NULL,'G',0.00002,NULL,'12.42',2,'SB(rs)c','in a pair',NULL,NULL,'H_alpha Emission-Line Galaxy',1,150.0242917,-31.55286,0.321,NULL,42823888550,669123258,10455050,12.42),(66511,'Tully est','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66511,32.77,0.8,35.8,23699,75,NULL,'B','NGC 3095',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66512,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66512,32.23,0.32,27.9,23699,85,NULL,'I, raw','NGC 3095',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66513,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66513,32.25,0.47,28.2,23699,NULL,NULL,'H','NGC 3095',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66514,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66514,32.28,0.32,28.6,23699,85,NULL,'I, inv','NGC 3095',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66515,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66515,32.31,0.43,28.9,23699,75,NULL,'MAT, I, raw','NGC 3095',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66516,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66516,32.34,0.45,29.4,23699,NULL,NULL,'K','NGC 3095',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66517,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66517,32.36,0.46,29.6,23699,NULL,NULL,'J','NGC 3095',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66518,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66518,32.46,0.4,31,23699,NULL,NULL,NULL,'NGC 3095',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66519,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66519,32.55,0.43,32.4,23699,75,NULL,'MAT, I, inv','NGC 3095',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66520,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66520,32.68,0.43,34.3,23699,75,NULL,'MAT, I, cor','NGC 3095',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66521,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66521,32.97,0.4,39.3,23699,NULL,NULL,'mean','NGC 3095',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66522,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66522,33.2,0.07,43.7,23699,NULL,NULL,NULL,'NGC 3095',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66523,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66523,34.77,NULL,90.1,23700,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0985',NULL,'2010Ap&SS.325..163P',2010,1,0.93,NULL,'G',0.00002,NULL,'16.6g',0.16,'Sd',NULL,NULL,NULL,NULL,1,150.027083,34.17197,0.005,NULL,64063225256,1000987894,15640435,16.6),(66524,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66524,34.8,NULL,91,23700,NULL,NULL,'Dipole + Quadrupole','FGC 0985',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66525,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66525,34.81,NULL,91.6,23700,NULL,NULL,'Dipole','FGC 0985',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66526,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66526,34.86,NULL,94,23700,NULL,NULL,NULL,'FGC 0985',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66527,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,'R',66527,38.18,0.46,432,23701,70,NULL,NULL,'2MASX J10000658+0125392',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000103,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,150.027333333,1.42758,0.013,NULL,60782078658,949719979,14839374,16.9),(66528,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,'R',66528,36.96,0.46,247,23702,70,NULL,NULL,'2MASX J10000767+2514162',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,150.031875,25.23789,0.117,NULL,64159064329,1002485380,15663834,17.1),(66529,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,'R',66529,38.09,0.46,415,23703,70,NULL,NULL,'SDSS J100008.22+073942.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000148,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,150.0342917,7.66181,0.013,NULL,60924030881,951937982,14874030,18.6),(66530,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66530,33.91,0.47,60.6,23704,70,NULL,NULL,'MCG -03-26-006',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000103,NULL,'14.24',0.4,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,150.042875,-19.62181,0.137,NULL,41150023345,642969114,10046392,14.24),(66531,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,'R',66531,37.33,0.27,293,23705,70,NULL,NULL,'2MASX J10001031+1901085',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000198,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,150.043,19.01894,0.045,NULL,60808815985,950137749,14845902,16.9),(66532,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66532,36.16,0.49,170,23706,70,NULL,NULL,'2MASX J10001049-3106558',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,150.0437917,-31.11544,0.237,NULL,42824043834,669125684,10455088,13.9),(66533,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66533,34.43,0.52,76.8,23707,70,NULL,NULL,'NGC 3086',NULL,'2014MNRAS.445.2677S',2014,1,1.1,'RC3 gives v = 9766 +/- 42 km/sec.','G',0.00009,NULL,'14.67',0.4,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,150.0457917,-2.97617,0.073,NULL,41234742581,644292852,10067075,14.67),(66534,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,'R',66534,36.91,0.46,241,23708,70,NULL,NULL,'2MASX J10001309+2724512',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,150.0545417,27.41428,0.049,NULL,64171553920,1002680530,15666883,16.7),(66535,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,'R',66535,37.18,0.46,273,23709,70,NULL,NULL,'2MASX J10001330+4511269',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,150.0555,45.19083,0.009,NULL,63979214782,999675230,15619925,18),(66536,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,'R',66536,36.59,0.46,208,23710,70,NULL,NULL,'2MASX J10001337+1612041',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,150.055833,16.20106,0.093,NULL,60865353708,951021151,14859705,17.4),(66537,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,'R',66537,36.7,0.46,219,23711,70,NULL,NULL,'2MASX J10001346+2450242',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,150.0562083,24.84003,0.117,NULL,64159139318,1002486551,15663852,17.6),(66538,'D-Sigma','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66538,33.25,0.4,44.6,23712,75,NULL,'Edat, raw','NGC 3091',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000033,NULL,'12.13',1.9,'E3:','in a pair',NULL,NULL,NULL,1,150.0595417,-19.63697,0.137,NULL,41149892914,642967076,10046360,12.13),(66539,'D-Sigma','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66539,33.58,0.4,52.1,23712,75,NULL,'Edat, cor','NGC 3091',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66540,'Faber-Jackson','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66540,32.14,0.65,26.8,23712,95,NULL,'Weighted Mean','NGC 3091',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66541,'Faber-Jackson','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66541,33.62,0.81,53,23712,55,NULL,'Visvanathan & Sandage 1979','NGC 3091',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66542,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66542,33.7,0.45,54.9,23712,NULL,NULL,'K','NGC 3091',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66543,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66543,33.84,0.4,58.5,23712,NULL,NULL,'mean','NGC 3091',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66544,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:40','1','SNLS 05D2eb',NULL,66544,41.94,0.05,1600,23713,70,NULL,'SIFTO','SNLS 05D2eb HOST',0.5344,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,150.060667,2.40744,0,NULL,60783466761,949741668,14839713,NULL),(66545,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:40','1','SNLS 05D2eb',NULL,66545,42.38,0.22,1950,23713,72,NULL,'z lit','SNLS 05D2eb HOST',0.5344,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66546,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:40','1','SNLS 05D2eb',NULL,66546,42.43,0.14,2000,23713,70,NULL,'SALT 2','SNLS 05D2eb HOST',0.5344,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66547,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:40','1','SNLS 05D2eb',NULL,66547,42.5,0.15,2060,23713,NULL,NULL,'SIFTO','SNLS 05D2eb HOST',0.5344,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66548,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:40','1','SNLS 05D2eb',NULL,66548,43.91,0.17,3950,23713,NULL,NULL,'SALT2','SNLS 05D2eb HOST',0.5344,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66549,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,'R',66549,37.17,0.46,272,23714,70,NULL,NULL,'2MASX J10001485+1721316',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,150.062,17.35883,0.053,NULL,60862563476,950977554,14859024,16.4),(66550,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,'R',66550,37.26,0.33,284,23715,70,NULL,NULL,'SDSS J100014.94+115223.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000144,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,150.0622917,11.87328,0.073,NULL,60872145538,951127274,14861363,18),(66551,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,'R',66551,38.24,0.46,444,23716,70,NULL,NULL,'SDSS J100015.75+025545.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000102,NULL,'18.1g',0.13,'BLAGN',NULL,NULL,NULL,'Sy 1',1,150.065667,2.92931,0.013,NULL,60779982885,949687232,14838863,18.1),(66552,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66552,27.96,0.19,3.91,23717,NULL,NULL,NULL,'kkh 057',NULL,'2001A&A...375..359K',2001,1,0.6,NULL,'G',NULL,NULL,'18.5',0.5,'Sph',NULL,NULL,NULL,NULL,1,150.064167,63.18372,0.041,NULL,62025821652,969153463,15143022,18.5),(66553,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,'R',66553,35.63,0.46,134,23718,70,NULL,NULL,'2MASX J10001661+3529491',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000163,NULL,'15.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,150.069083,35.49708,0.017,NULL,64062459679,1000975932,15640248,15.7),(66554,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,'R',66554,37.81,0.46,364,23719,70,NULL,NULL,'SDSS J100018.17+130834.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000158,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,150.07575,13.14281,0.053,NULL,60851901293,950810957,14856421,18.6),(66555,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,'R',66555,37.26,0.33,284,23720,70,NULL,NULL,'2MASX J10001849+1153097',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,150.077041667,11.88603,0.073,NULL,60872145835,951127278,14861363,17.3),(66556,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,'R',66556,36.86,0.46,235,23721,70,NULL,NULL,'2MASX J10001869+3300362',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000172,NULL,'16.1g',0.39,NULL,NULL,NULL,NULL,NULL,1,150.077958333,33.00992,0.041,NULL,64060519622,1000945619,15639775,16.1),(66557,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,'R',66557,37.92,0.46,383,23722,70,NULL,NULL,'2MASX J10001978+2202146',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,150.082458333,22.03744,0.065,NULL,63700886380,995326349,15551974,17.1),(66558,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,'R',66558,35.83,0.33,146,23723,70,NULL,NULL,'2MASX J10002071+1558427',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,150.0862083,15.97847,0.085,NULL,60865282596,951020040,14859688,16.6),(66559,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,'R',66559,37.33,0.27,293,23724,70,NULL,NULL,'2MASX J10002103+1900086',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,150.0877917,19.00247,0.045,NULL,60808784503,950137257,14845894,17.3),(66560,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,'R',66560,37.98,0.27,394,23725,70,NULL,NULL,'2MASX J10002112+0315115',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,150.0880417,3.25317,0.005,NULL,60778668349,949666692,14838542,17.3),(66561,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:40','1','PS1 SN PS10if','N',66561,39.4,0.22,659,23726,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10if HOST',0.1512,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66562,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:40','1','SNLS 04D2fs',NULL,66562,40.72,0.14,1030,23727,74.2,NULL,'SALT 2','[AGR2006] J100022.11+014555.7',0.357,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,'23.9i',NULL,NULL,NULL,NULL,NULL,NULL,1,150.0920417,1.76539,0.009,NULL,60783098340,949735911,14839623,23.9),(66563,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:40','1','SNLS 04D2fs','R',66563,41,NULL,1170,23727,65,NULL,'SALT','[AGR2006] J100022.11+014555.7',0.357,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66564,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:40','1','SNLS 04D2fs',NULL,66564,41.33,0.11,1360,23727,70,NULL,'SALT 2','[AGR2006] J100022.11+014555.7',0.357,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66565,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:40','1','SNLS 04D2fs',NULL,66565,41.36,0.13,1380,23727,70,NULL,'SALT','[AGR2006] J100022.11+014555.7',0.357,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66566,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:40','1','SNLS 04D2fs',NULL,66566,41.4,NULL,1410,23727,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','[AGR2006] J100022.11+014555.7',0.357,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66567,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:40','1','SNLS 04D2fs',NULL,66567,41.42,0.15,1420,23727,NULL,NULL,'SIFTO','[AGR2006] J100022.11+014555.7',0.357,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66568,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:40','1','SNLS 04D2fs',NULL,66568,41.44,0.02,1430,23727,70,NULL,NULL,'[AGR2006] J100022.11+014555.7',0.357,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66569,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:40','1','SNLS 04D2fs',NULL,66569,41.45,0.07,1440,23727,65,NULL,'SALT2','[AGR2006] J100022.11+014555.7',0.357,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66570,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:40','1','SNLS 04D2fs',NULL,66570,41.47,0.1,1450,23727,65,NULL,'SALT','[AGR2006] J100022.11+014555.7',0.357,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66571,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:40','1','SNLS 04D2fs',NULL,66571,41.5,0.12,1470,23727,65,NULL,'MLCS2k2','[AGR2006] J100022.11+014555.7',0.357,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66572,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:40','1','SNLS 04D2fs',NULL,66572,41.6,0.17,1540,23727,65,NULL,'SALT2','[AGR2006] J100022.11+014555.7',0.357,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66573,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:40','1','SNLS 04D2fs',NULL,66573,41.62,0.17,1560,23727,65,NULL,'MLCS17','[AGR2006] J100022.11+014555.7',0.357,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66574,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:40','1','SNLS 04D2fs',NULL,66574,41.62,0.22,1560,23727,65,NULL,'MLCS31','[AGR2006] J100022.11+014555.7',0.357,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66575,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:40','1','SNLS 04D2fs',NULL,66575,41.64,0.17,1570,23727,NULL,NULL,'SALT2','[AGR2006] J100022.11+014555.7',0.357,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66576,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:40','1','SNLS 04D2fs',NULL,66576,41.65,0.2,1570,23727,65,NULL,'MLCS2k2','[AGR2006] J100022.11+014555.7',0.357,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66577,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:40','1','SNLS 04D2fs',NULL,66577,41.71,0.02,1620,23727,65,NULL,'SALT','[AGR2006] J100022.11+014555.7',0.357,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66578,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:40','1','SNLS 04D2fs',NULL,66578,41.89,0.03,1760,23727,70,NULL,'SALT 2','[AGR2006] J100022.11+014555.7',0.357,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66579,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,'R',66579,37.98,0.27,394,23728,70,NULL,NULL,'2MASX J10002285+0315205',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000188,NULL,'17.0g',0.26,'AGN',NULL,NULL,NULL,NULL,1,150.09525,3.25569,0.005,NULL,60778635797,949666184,14838534,17),(66580,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,'R',66580,37.71,0.46,348,23729,70,NULL,NULL,'2MASX J10002344-0026423',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000094,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,150.09775,-0.44503,0.049,NULL,41231862187,644247846,10066372,17),(66581,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,'R',66581,35.83,0.33,146,23730,70,NULL,NULL,'2MASX J10002369+1558027',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'15.9g',0.39,NULL,NULL,NULL,NULL,NULL,1,150.09875,15.96736,0.085,NULL,60865285931,951020092,14859688,15.9),(66582,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66582,35.36,0.54,118,23731,70,NULL,NULL,'2MASX J10002375-3939459',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,150.098916667,-39.66267,0.597,NULL,42080343657,657505369,10273521,14.3),(66583,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,'R',66583,37.01,0.46,252,23732,70,NULL,NULL,'2MASX J10002384+0000516',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000098,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,150.0994583,0.01433,0.041,NULL,60773778423,949590287,14837348,16.4),(66584,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66584,36.43,0.51,193,23733,70,NULL,NULL,'2MASX J10002429-1450359',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'15.82',NULL,NULL,NULL,NULL,NULL,NULL,1,150.101166667,-14.84356,0.165,NULL,41189626723,643587917,10056061,15.82),(66585,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,'R',66585,38.75,0.46,562,23734,70,NULL,NULL,'SDSS J100026.34+004530.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000073,NULL,'18.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,150.1097917,0.75853,0.029,NULL,60774062481,949594726,14837417,18.4),(66586,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,'R',66586,37.79,0.46,362,23735,70,NULL,NULL,'SDSS J100026.36+584059.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000133,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,150.109833,58.68325,0,NULL,61920569885,967508904,15117326,18.6),(66587,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,'R',66587,37.71,0.46,348,23736,70,NULL,NULL,'2MASX J10002639+1622047',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,150.109917,16.36808,0.081,NULL,60865140006,951017812,14859653,17.8),(66588,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66588,35.63,0.54,134,23737,70,NULL,NULL,'2MASX J10002693-0256503',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.0001,NULL,'16.27',0.31,NULL,NULL,NULL,NULL,NULL,1,150.1122917,-2.94722,0.073,NULL,41234787478,644293554,10067086,16.27),(66589,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66589,33.06,0.43,41,23738,75,NULL,'3.6 micron, color + selection bias corrected','UGC 05376',NULL,'2014MNRAS.444..527S',2014,1,1.58,NULL,'G',0.000022,NULL,'14.1g',0.58,'Sdm:','Group member',NULL,NULL,NULL,1,150.1127917,3.37439,0.005,NULL,60778634309,949666161,14838533,14.1),(66590,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,'R',66590,33.28,NULL,45.3,23738,NULL,NULL,NULL,'UGC 05376',NULL,'2015AstBu..70....1K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66591,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:40','1','PS1 SN PS10k','N',66591,41.29,0.12,1350,23739,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10k HOST',0.3412,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66592,'FP','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,'R',66592,38.23,0.46,442,23740,70,NULL,NULL,'SDSS J100027.66+615018.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000089,NULL,'18.3g',0.16,'NLAGN',NULL,NULL,NULL,'Sy 2',1,150.11525,61.83853,0.037,NULL,61909540501,967336570,15114633,18.3),(66593,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:40','1','SNLS 05D2by',NULL,66593,43.57,0.07,2740,23741,70,NULL,'SIFTO','SNLS 05D2by HOST',0.891,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,'23.2i',NULL,NULL,NULL,NULL,NULL,NULL,1,150.116833333,2.5215,0,NULL,60780043237,949688175,14838877,23.2),(66594,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:40','1','SNLS 05D2by',NULL,66594,43.93,0.24,3230,23741,70,NULL,'SALT 2','SNLS 05D2by HOST',0.891,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66595,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:40','1','SNLS 05D2by',NULL,66595,43.97,0.15,3290,23741,NULL,NULL,'SIFTO','SNLS 05D2by HOST',0.891,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66596,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:40','1','SNLS 05D2by',NULL,66596,45.78,0.17,7560,23741,NULL,NULL,'SALT2','SNLS 05D2by HOST',0.891,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66597,'G Lens','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66597,46.92,0.17,12800,23741,NULL,NULL,'SNLS 05D2by HOST','SNLS 05D2by HOST',0.891,'2010A&A...514A..44K',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66598,'Faber-Jackson','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66598,46.84,0.17,12300,23741,NULL,NULL,'SNLS 05D2by HOST','SNLS 05D2by HOST',0.891,'2010A&A...514A..44K',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66599,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66599,35.21,0.59,110,23742,NULL,NULL,'Malmquist cor.','ESO 374- G 017',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'16.12',0.7,'Sb:',NULL,NULL,NULL,NULL,1,150.1197083,-35.54669,0.669,NULL,41969550213,655774222,10246472,16.12),(66600,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66600,35.29,0.57,114,23742,NULL,NULL,NULL,'ESO 374- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66601,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66601,35.33,0.2,116,23742,74.4,NULL,NULL,'ESO 374- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66602,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66602,35.49,0.39,125,23743,NULL,NULL,NULL,'2MASX J10002897-1448579',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000013,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,150.120666667,-14.81606,0.165,NULL,41189610228,643587659,10056057,15.3),(66603,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66603,35.6,0.37,132,23743,NULL,NULL,'Malmquist cor.','2MASX J10002897-1448579',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66604,'D-Sigma','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66604,34.45,0.4,77.6,23744,75,NULL,'Edat, raw','NGC 3090',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'13.88',1.4,'E+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,150.1259583,-2.969,0.073,NULL,41234788087,644293563,10067086,13.88),(66605,'D-Sigma','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66605,34.78,0.4,90.5,23744,75,NULL,'Edat, cor','NGC 3090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66606,'CMD','2016-12-15 15:14:34','2016-12-16 11:19:40','1',NULL,NULL,66606,19.6,0.22,0.0832,23745,NULL,NULL,NULL,'SDSS J100030.39+572955.2',NULL,'2008A&A...477..139L',2008,1,NULL,NULL,'*',NULL,NULL,'23.0g',NULL,'Point Src [SDSS]',NULL,NULL,NULL,NULL,1,150.126625,57.49869,0,1,61940110125,967814220,15122097,23),(66607,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66607,34.62,0.48,84,23746,70,NULL,NULL,'MCG -01-26-007',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.36',0.3,NULL,NULL,NULL,NULL,NULL,1,150.1275,-7.88575,0.157,NULL,41333114785,645829918,10091092,15.36),(66608,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66608,34.67,0.53,85.9,23747,70,NULL,NULL,'UGC 05380',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00003,NULL,'14.61',0.7,'SB(r)ab','Group member of poor cluster',NULL,NULL,NULL,1,150.127917,-2.16131,0.101,NULL,41234539863,644289685,10067026,14.61),(66609,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66609,34.64,0.47,84.6,23747,NULL,NULL,'H','UGC 05380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66610,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66610,34.78,0.46,90.4,23747,NULL,NULL,'J','UGC 05380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66611,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66611,34.83,0.45,92.4,23747,NULL,NULL,'K','UGC 05380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66612,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66612,34.84,0.4,92.7,23747,NULL,NULL,'mean','UGC 05380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66613,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66613,34.33,NULL,73.4,23748,NULL,NULL,NULL,'FGC 0986',NULL,'2000BSAO...50....5K',2000,1,1.01,NULL,'G',0.000016,NULL,'16.7',0.1,'Scd',NULL,NULL,NULL,NULL,1,150.13,35.15806,0.025,NULL,64062450748,1000975792,15640246,16.7),(66614,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66614,34.37,NULL,75,23748,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0986',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66615,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66615,34.38,NULL,75.2,23748,NULL,NULL,'Dipole + Quadrupole','FGC 0986',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66616,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66616,34.38,NULL,75.3,23748,NULL,NULL,'Dipole','FGC 0986',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66617,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66617,37.98,0.27,394,23749,70,NULL,NULL,'2MASX J10003121+0323224',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000154,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,150.13025,3.38953,0.005,NULL,60778634181,949666159,14838533,17.3),(66618,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66618,32.38,0.45,30,23750,NULL,NULL,'K','IC 2533',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000067,NULL,'12.95',1.3,'(PR?)S0^0',NULL,NULL,NULL,NULL,1,150.1319583,-31.245,0.237,NULL,42824052487,669125820,10455090,12.95),(66619,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66619,32.82,0.4,36.7,23750,NULL,NULL,'mean','IC 2533',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66620,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66620,36,0.33,158,23751,70,NULL,NULL,'2MASX J10003166+0032564',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000085,NULL,'15.5g',0.51,'S0^-',NULL,NULL,NULL,NULL,1,150.132083,0.54894,0.021,NULL,60774192953,949596764,14837449,15.5),(66621,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66621,37.52,0.46,319,23752,70,NULL,NULL,'SDSS J100031.98+063826.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000143,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,150.133291667,6.64058,0.033,NULL,60923104189,951923502,14873804,18.4),(66622,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 2007S',NULL,66622,33.36,0.21,46.3,23753,74.2,NULL,'SALT 2','UGC 05378',0.01388,'2010ApJ...716..712A',2010,1,1.18,NULL,'G',0.000033,NULL,'14.4g',0.59,'Sb             HII',NULL,NULL,NULL,NULL,1,150.133291667,4.40706,0.005,NULL,60779317700,949676839,14838700,14.4),(66623,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 2007S',NULL,66623,33.77,0.04,56,23753,72,NULL,'MLCS31','UGC 05378',0.01388,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66624,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 2007S',NULL,66624,33.81,0.02,57.7,23753,72,NULL,'M(H) = -18.317 mag','UGC 05378',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66625,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 2007S',NULL,66625,33.84,0.1,57.8,23753,72,NULL,'MLCS2k2, R(V) = 3.1','UGC 05378',0.01388,'2010ApJ...721.1608B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66626,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 2007S',NULL,66626,33.84,0.24,57.9,23753,65,NULL,'MLCS31','UGC 05378',0.01388,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66627,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 2007S',NULL,66627,33.9,0.09,60.3,23753,74.4,NULL,NULL,'UGC 05378',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66628,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 2007S',NULL,66628,33.96,0.2,61,23753,70,NULL,'SALT 2','UGC 05378',0.01388,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66629,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 2007S',NULL,66629,34,0.17,61.2,23753,72,NULL,NULL,'UGC 05378',0.01503,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66630,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 2007S',NULL,66630,34.17,0.26,67.2,23753,65,NULL,'SALT2','UGC 05378',0.01388,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66631,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 2007S',NULL,66631,34.22,0.07,68.9,23753,72,NULL,'MLCS2k2, R(V) = 1.7','UGC 05378',0.01388,'2010ApJ...721.1608B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66632,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 2007S',NULL,66632,34.22,0.23,68.9,23753,65,NULL,'MLCS17','UGC 05378',0.01388,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66633,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66633,37.72,0.15,351,23754,70,NULL,NULL,'2MASX J10003231+1127534',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000161,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,150.134667,11.465,0.057,NULL,60872881415,951138772,14861543,17.2),(66634,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66634,37.36,0.46,296,23755,70,NULL,NULL,'2MASX J10003253+5144367',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000188,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,150.1357917,51.74364,0,NULL,63994251015,999910172,15623596,16.8),(66635,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66635,36.72,0.54,221,23756,70,NULL,NULL,'2MASX J10003297-3808409',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.3,NULL,NULL,NULL,NULL,NULL,1,150.137333333,-38.14467,0.537,NULL,41961315417,655645553,10244461,13.9),(66636,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66636,37.62,0.46,333,23757,70,NULL,NULL,'2MASX J10003407+2716562',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,150.141916667,27.28217,0.057,NULL,64171421191,1002678456,15666850,17.8),(66637,'Ring Diameter','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66637,33.7,0.84,54,23758,NULL,NULL,'Published at H = 100 km/s/Mpc','MCG -02-26-012',NULL,'1981ApJS...45..541P',1981,1,1.7,NULL,'G',0.00002,NULL,'14',1,'SAB(rs)c',NULL,NULL,NULL,NULL,1,150.146,-14.94781,0.165,NULL,41189637132,643588080,10056063,14),(66638,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66638,35.21,1.15,110,23758,NULL,NULL,'Malmquist cor.','MCG -02-26-012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66639,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66639,35.86,0.85,149,23758,NULL,NULL,NULL,'MCG -02-26-012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66640,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66640,35.9,0.2,151,23758,74.4,NULL,NULL,'MCG -02-26-012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66641,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2mc',NULL,66641,39.33,0.17,545,23759,NULL,NULL,'SALT2','SDSS J100035.52+014703.1',0.3468,'2010A&A...523A...7G',2010,1,0.06,NULL,'G',0.0002,NULL,'21.8g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,150.148,1.78419,0.009,NULL,60783097030,949735891,14839623,21.8),(66642,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2mc',NULL,66642,41.07,0.12,1220,23759,70,NULL,'SALT 2','SDSS J100035.52+014703.1',0.3468,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66643,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2mc',NULL,66643,41.1,NULL,1230,23759,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SDSS J100035.52+014703.1',0.3468,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66644,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2mc',NULL,66644,41.11,0.15,1240,23759,NULL,NULL,'SIFTO','SDSS J100035.52+014703.1',0.3468,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66645,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2mc',NULL,66645,42.45,0.04,2300,23759,70,NULL,'SALT2','SDSS J100035.52+014703.1',0.3468,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66646,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66646,37.23,0.46,279,23760,70,NULL,NULL,'2MASX J10003563+4635148',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000193,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,150.148583,46.58739,0,NULL,64005625795,1000087903,15626373,16.6),(66647,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2mj',NULL,66647,42.64,0.15,2230,23761,NULL,NULL,'SIFTO','[NSB2006] J100036.53+023437.4',0.51,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'a',NULL,NULL,NULL,NULL,1,150.15225,2.57706,0,NULL,60780037712,949688089,14838876,NULL),(66648,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2mj',NULL,66648,42.65,0.14,2240,23761,70,NULL,'SALT 2','[NSB2006] J100036.53+023437.4',0.51,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66649,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2mj',NULL,66649,43.32,0.04,3050,23761,70,NULL,'SIFTO','[NSB2006] J100036.53+023437.4',0.51,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66650,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2mj',NULL,66650,44.55,0.17,5380,23761,NULL,NULL,'SALT2','[NSB2006] J100036.53+023437.4',0.51,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66651,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66651,29.26,NULL,7.11,23762,NULL,NULL,NULL,'LV J1000+3032',NULL,'2013AJ....145..101K',2013,1,0.27,NULL,'G',0.000125,NULL,'17.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,150.15225,30.53606,0.065,NULL,64161074520,1002516789,15664324,17.9),(66652,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66652,37.31,0.46,290,23763,70,NULL,NULL,'2MASX J10003691+2453212',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000144,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,150.153833333,24.88928,0.105,NULL,64159113073,1002486141,15663845,17.5),(66653,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2kr',NULL,66653,42.93,0.05,2210,23764,70,NULL,'SIFTO','SDSS J100037.43+014243.7',0.7441,'2011ApJS..192....1C',2011,1,0.06,NULL,'G',0.0005,NULL,'20.9g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,150.156,1.71214,0.009,NULL,60783092416,949735819,14839622,20.9),(66654,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2kr',NULL,66654,43.18,0.15,2480,23764,NULL,NULL,'SIFTO','SDSS J100037.43+014243.7',0.7441,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66655,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2kr',NULL,66655,43.2,0.19,2500,23764,70,NULL,'SALT 2','SDSS J100037.43+014243.7',0.7441,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66656,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2kr',NULL,66656,44.36,0.17,4270,23764,NULL,NULL,'SALT2','SDSS J100037.43+014243.7',0.7441,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66657,'G Lens','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66657,45.57,0.17,7460,23764,NULL,NULL,'SNLS 04D2kr HOST','SDSS J100037.43+014243.7',0.7441,'2010A&A...514A..44K',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66658,'Faber-Jackson','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66658,45.72,0.17,7970,23764,NULL,NULL,'SNLS 04D2kr HOST','SDSS J100037.43+014243.7',0.7441,'2010A&A...514A..44K',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66659,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66659,35.73,0.53,140,23765,70,NULL,NULL,'2MASX J10003872-0741540',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'15.27',0.45,NULL,NULL,NULL,NULL,NULL,1,150.1612917,-7.69836,0.165,NULL,41333139451,645830303,10091098,15.27),(66660,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66660,36.16,0.46,171,23766,70,NULL,NULL,'CGCG 266-005',NULL,'2015arXiv151105856S',2015,1,0.94,NULL,'G',0.000087,NULL,'14.9g',0.6,'S0',NULL,NULL,NULL,NULL,1,150.1619583,53.025,0.005,NULL,63993158000,999893093,15623329,14.9),(66661,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66661,35.48,0.49,125,23767,75,NULL,'IR','CGCG 064-029',NULL,'2011yCatp016004901K',2011,1,1.16,NULL,'G',0.000162,NULL,'16.0g',0.18,'Sc',NULL,NULL,NULL,NULL,1,150.165167,11.94675,0.073,NULL,60872110733,951126730,14861355,16),(66662,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66662,35.63,0.2,134,23768,74.4,NULL,NULL,'CGCG 064-029',NULL,'2013AJ....146...86T',2013,1,1.16,NULL,'G',0.000162,NULL,'16.0g',0.18,'Sc',NULL,NULL,NULL,NULL,1,150.165167,11.94675,0.073,NULL,60872110733,951126730,14861355,16),(66663,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66663,36.79,0.46,228,23769,70,NULL,NULL,'2MASX J10004010+4157364',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000172,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,150.167125,41.96019,0,NULL,64103546533,1001617914,15650279,16.5),(66664,'L(H{beta})-{sigma}','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66664,44.89,NULL,1636,23770,74.3,NULL,NULL,'NMBS COSMOS 11627',1.412,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,150.170041667,2.36075,0,NULL,60780459164,949694674,14838979,NULL),(66665,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66665,37.58,0.46,328,23771,70,NULL,NULL,'SDSS J100041.27+452539.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,150.172,45.42753,0.009,NULL,63979207218,999675112,15619923,18.1),(66666,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66666,36.66,0.46,215,23772,70,NULL,NULL,'2MASX J10004171+1437297',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,150.173708333,14.62486,0.033,NULL,60854212106,950847064,14856985,16.9),(66667,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66667,36.31,0.57,182,23773,70,NULL,NULL,'2MASX J10004400-3811549',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.5I',0.5,'S',NULL,NULL,NULL,NULL,1,150.1832917,-38.19864,0.533,NULL,41961268080,655644813,10244450,13.5);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (66668,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','PS1 SN PS10io','N',66668,40.33,0.13,954,23774,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10io HOST',0.2212,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66669,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2ck',NULL,66669,40.83,0.17,862,23775,NULL,NULL,'SALT2','COSMOS-P 098322',0.698,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',NULL,'PHOT','21.2i',NULL,'a',NULL,NULL,NULL,NULL,1,150.188375,2.57369,0,NULL,60780038924,949688108,14838876,21.2),(66670,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2ck',NULL,66670,43.09,0.26,2440,23775,72,NULL,'z lit','COSMOS-P 098322',0.698,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66671,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2ck',NULL,66671,43.33,0.25,2730,23775,70,NULL,'SALT 2','COSMOS-P 098322',0.698,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66672,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2ck',NULL,66672,43.34,0.15,2740,23775,NULL,NULL,'SIFTO','COSMOS-P 098322',0.698,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66673,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2ck',NULL,66673,44.01,0.05,3730,23775,70,NULL,'SALT2','COSMOS-P 098322',0.698,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66674,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66674,34.82,0.46,92.2,23776,70,NULL,NULL,'UGC 05383',NULL,'2015arXiv151105856S',2015,1,1.17,'RC3 has V = 6808 +- 81 km/s.','G',0.000188,NULL,'14.6g',0.62,'S0',NULL,NULL,NULL,NULL,1,150.188375,4.73433,0.009,NULL,60775977195,949624643,14837885,14.6),(66675,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66675,36.84,0.46,233,23777,70,NULL,NULL,'2MASX J10004734+1652124',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.1g',0.43,NULL,NULL,NULL,NULL,NULL,1,150.197333,16.87008,0.053,NULL,60862554583,950977415,14859022,16.1),(66676,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 06D2gb',NULL,66676,40.19,0.17,756,23778,NULL,NULL,'SALT2','SNLS 06D2gb',0.442,'2010A&A...523A...7G',2010,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia?',NULL,NULL,NULL,NULL,1,150.197583333,1.98542,0.009,NULL,60780345920,949692905,14838951,NULL),(66677,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 06D2gb',NULL,66677,41.83,0.15,1610,23778,70,NULL,'SALT 2','SNLS 06D2gb',0.442,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66678,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 06D2gb',NULL,66678,41.89,0.15,1660,23778,NULL,NULL,'SIFTO','SNLS 06D2gb',0.442,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66679,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 06D2gb',NULL,66679,42.55,0.05,2250,23778,70,NULL,'SALT2','SNLS 06D2gb',0.442,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66680,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66680,34.77,0.53,89.9,23779,70,NULL,NULL,'NGC 3092',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000023,NULL,'14.94',0.6,'SB(s)0+?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,150.197625,-3.01239,0.073,NULL,41234753475,644293023,10067078,14.94),(66681,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66681,35.64,NULL,134,23780,NULL,NULL,NULL,'FGC 0987',NULL,'2000BSAO...50....5K',2000,1,1.19,NULL,'G',0.000022,NULL,'16.65',0.1,'Scd',NULL,NULL,NULL,NULL,1,150.20275,35.47911,0,NULL,64062258321,1000972786,15640199,16.65),(66682,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66682,35.66,NULL,135,23780,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0987',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66683,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66683,35.67,NULL,136,23780,NULL,NULL,'Dipole + Quadrupole','FGC 0987',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66684,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66684,35.69,NULL,137,23780,NULL,NULL,'Dipole','FGC 0987',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66685,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66685,35.87,0.49,149,23780,75,NULL,'IR','FGC 0987',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66686,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66686,36.34,0.2,185,23780,74.4,NULL,NULL,'FGC 0987',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66687,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66687,37.64,0.33,337,23781,70,NULL,NULL,'2MASX J10004976+2518299',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00019,NULL,'16.60',0.31,NULL,NULL,NULL,NULL,NULL,1,150.20725,25.30844,0.117,NULL,64159189898,1002487342,15663864,16.6),(66688,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66688,36.85,0.46,234,23782,70,NULL,NULL,'2MASX J10005010+3855384',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000183,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,150.2087083,38.92736,0.025,NULL,64057634000,1000900531,15639070,16.5),(66689,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66689,36.4,0.46,191,23783,70,NULL,NULL,'2MASX J10005018+1344134',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000704,NULL,'16.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,150.2089583,13.73703,0.033,NULL,60854777151,950855892,14857123,16.4),(66690,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66690,35.33,0.2,116,23784,74.4,NULL,NULL,'UGC 05381',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.00005,NULL,'15.0g',0.46,'S',NULL,NULL,NULL,NULL,1,150.21525,22.31369,0.065,NULL,63700362841,995318169,15551846,15),(66691,'GCLF','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66691,32.37,0.67,29.8,23785,NULL,NULL,'TOM(g) = -7.2 mag','NGC 3073',NULL,'2012MNRAS.422.3591C',2012,1,1.3,NULL,'G',0.000017,NULL,'14.07',1.2,'SAB0-','in an interacting pair',NULL,NULL,NULL,1,150.217,55.61883,0,NULL,61935171472,967737054,15120891,14.07),(66692,'SBF','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66692,32.64,0.93,33.7,23785,NULL,NULL,'I','NGC 3073',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66693,'SBF','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66693,32.66,0.14,34,23785,74.4,NULL,NULL,'NGC 3073',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66694,'Tully est','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66694,31.43,0.8,19.3,23785,75,NULL,'B','NGC 3073',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66695,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66695,31.21,0.45,17.5,23785,NULL,NULL,'K','NGC 3073',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66696,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66696,31.74,0.4,22.3,23785,NULL,NULL,'mean','NGC 3073',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66697,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2an',NULL,66697,42.76,0.05,2200,23786,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','[AGR2006] J100052.33+020228.7',0.62,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,150.218041667,2.04131,0,NULL,60780336415,949692756,14838949,NULL),(66698,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2an',NULL,66698,42.85,NULL,2300,23786,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','[AGR2006] J100052.33+020228.7',0.62,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66699,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2an',NULL,66699,42.96,0.15,2410,23786,72,NULL,NULL,'[AGR2006] J100052.33+020228.7',0.62,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66700,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66700,35.22,0.52,111,23787,NULL,NULL,'Malmquist cor.','ESO 316- G 015',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'16.37',0.2,'S...',NULL,NULL,NULL,NULL,1,150.220875,-42.68461,NULL,NULL,42092015827,657687747,10276371,16.37),(66701,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66701,35.49,0.46,125,23787,NULL,NULL,NULL,'ESO 316- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66702,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66702,35.53,0.2,128,23787,74.4,NULL,NULL,'ESO 316- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66703,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66703,38.3,0.46,457,23788,70,NULL,NULL,'SDSS J100053.17+183347.5',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000179,NULL,'17.6g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,150.221583,18.56319,0.045,NULL,60808513048,950133016,14845828,17.6),(66704,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66704,38.41,0.46,481,23789,70,NULL,NULL,'SDSS J100053.44+032823.6',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000147,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,150.222666667,3.47325,0.009,NULL,60778841949,949669405,14838584,18.2),(66705,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66705,37.87,0.46,375,23790,70,NULL,NULL,'2MASX J10005463+3252517',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,150.2275417,32.88103,0.041,NULL,64060476876,1000944951,15639764,18),(66706,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66706,36.78,0.46,227,23791,70,NULL,NULL,'SDSS J100055.55+190421.9',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'15.8g',0.41,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,150.2315,19.07275,0.045,NULL,60809002644,950140666,14845947,15.8),(66707,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66707,38.26,0.33,448,23792,70,NULL,NULL,'2MASX J10005573+2854140',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.7g',0.23,'E',NULL,NULL,NULL,NULL,1,150.232041667,28.90392,0.081,NULL,64163075190,1002548049,15664813,17.7),(66708,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66708,37.78,0.46,360,23793,70,NULL,NULL,'2MASX J10005568+1451164',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,150.232167,14.8545,0.057,NULL,60853800091,950840626,14856884,17.1),(66709,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66709,37.27,0.46,284,23794,70,NULL,NULL,'2MASX J10005619+0555517',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000192,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,150.234125,5.93106,0.037,NULL,60905614199,951650221,14869534,17.2),(66710,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66710,38.48,0.46,496,23795,70,NULL,NULL,'2MASX J10005669-0006228',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000094,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,150.236208333,-0.1065,0.049,NULL,41231604968,644243827,10066309,17.6),(66711,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66711,36.28,0.46,180,23796,70,NULL,NULL,'CGCG 036-018',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000097,NULL,'15.2g',0.61,'E0',NULL,NULL,NULL,NULL,1,150.238167,7.62869,0.033,NULL,60923874588,951935540,14873992,15.2),(66712,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 06D2cd',NULL,66712,44.01,0.12,3290,23797,70,NULL,NULL,'SNLS 06D2cd HOST',0.93,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,150.2415,2.53403,0,NULL,60780014212,949687722,14838870,NULL),(66713,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2dy',NULL,66713,41.67,0.04,1430,23798,70,NULL,'SIFTO','[NSB2006] J100058.08+021059.5',0.51,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.01,NULL,'24.6i',NULL,NULL,NULL,NULL,NULL,NULL,1,150.241833,2.18342,0,NULL,60780370466,949693288,14838957,24.6),(66714,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2dy',NULL,66714,42.52,0.15,2110,23798,NULL,NULL,'SIFTO','[NSB2006] J100058.08+021059.5',0.51,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66715,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2dy',NULL,66715,42.6,0.13,2190,23798,70,NULL,'SALT 2','[NSB2006] J100058.08+021059.5',0.51,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66716,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2dy',NULL,66716,44.19,0.17,4570,23798,NULL,NULL,'SALT2','[NSB2006] J100058.08+021059.5',0.51,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66717,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2nt',NULL,66717,43.07,0.05,2340,23799,70,NULL,'SIFTO','SNLS 05D2nt HOST',0.757,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',NULL,NULL,'23.6i',NULL,NULL,NULL,NULL,NULL,NULL,1,150.2427083,2.37258,0,NULL,60780455954,949694624,14838978,23.6),(66718,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2nt',NULL,66718,43.51,0.19,2860,23799,70,NULL,'SALT 2','SNLS 05D2nt HOST',0.757,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66719,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2nt',NULL,66719,43.52,0.15,2870,23799,NULL,NULL,'SIFTO','SNLS 05D2nt HOST',0.757,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66720,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2nt',NULL,66720,45.49,0.17,7150,23799,NULL,NULL,'SALT2','SNLS 05D2nt HOST',0.757,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66721,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66721,38.06,0.27,409,23800,70,NULL,NULL,'SDSS J100059.23+010636.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000066,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,150.246833,1.11019,0.017,NULL,60774105760,949595402,14837428,18.1),(66722,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66722,37.71,0.46,348,23801,70,NULL,NULL,'2MASX J10005998+4211210',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000143,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,150.249875,42.18933,0,NULL,64103585564,1001618524,15650289,17.5),(66723,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66723,37.86,0.23,373,23802,70,NULL,NULL,'2MASX J10010143+0001171',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000087,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,150.256083,0.02153,0.065,NULL,60773670338,949588599,14837321,17.7),(66724,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66724,37.86,0.23,373,23803,70,NULL,NULL,'2MASX J10010152+0002177',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000083,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,150.2564583,0.03828,0.065,NULL,60773670749,949588605,14837321,17.2),(66725,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66725,36.09,0.55,166,23804,70,NULL,NULL,'MCG -02-26-014',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.27',0.5,NULL,NULL,NULL,NULL,NULL,1,150.2585,-15.36322,0.141,NULL,41203509293,643804832,10059450,15.27),(66726,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66726,37.79,0.46,362,23805,70,NULL,NULL,'2MASX J10010241+3541157',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000141,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,150.260083,35.68756,0.005,NULL,64070397299,1001099957,15642186,17.6),(66727,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66727,38.26,0.33,448,23806,70,NULL,NULL,'2MASX J10010281+2853130',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000144,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,150.261667,28.88692,0.081,NULL,64163075445,1002548053,15664813,17.5),(66728,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2ie',NULL,66728,41.33,0.03,1370,23807,70,NULL,'SALT2','[NSB2006] J100102.90+023928.9',0.35,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,150.262125,2.65803,0,NULL,60780128098,949689501,14838898,NULL),(66729,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2ie',NULL,66729,41.53,0.12,1500,23807,70,NULL,'SALT 2','[NSB2006] J100102.90+023928.9',0.35,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66730,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2ie',NULL,66730,41.53,0.17,1500,23807,NULL,NULL,'SALT2','[NSB2006] J100102.90+023928.9',0.35,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66731,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2ie',NULL,66731,41.62,0.15,1560,23807,NULL,NULL,'SIFTO','[NSB2006] J100102.90+023928.9',0.35,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66732,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66732,37.83,0.46,368,23808,70,NULL,NULL,'2MASX J10010442-0032328',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000084,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,150.2685,-0.54231,0.057,NULL,41231774531,644246477,10066351,17.6),(66733,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66733,37.68,0.33,343,23809,70,NULL,NULL,'2MASX J10010469+0516057',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000182,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,150.269667,5.26839,0.005,NULL,60775859037,949622797,14837856,16.6),(66734,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66734,36.62,0.46,211,23810,70,NULL,NULL,'2MASX J10010721+2306099',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,150.279958333,23.10267,0.089,NULL,63689500411,995148443,15549194,17),(66735,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66735,36.66,0.33,215,23811,70,NULL,NULL,'2MASX J10010759+1425004',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,150.28175,14.41681,0.033,NULL,60855060133,950860314,14857192,16.8),(66736,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2ay',NULL,66736,43.68,0.31,2960,23812,70,NULL,'SALT 2','zCOSMOS 823997',0.8387,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',0.0002,NULL,'21.9i',NULL,NULL,NULL,NULL,NULL,NULL,1,150.284416667,2.12967,0,NULL,60780357890,949693092,14838954,21.9),(66737,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2ay',NULL,66737,43.75,0.17,3060,23812,NULL,NULL,'SALT2','zCOSMOS 823997',0.8387,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66738,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2ay',NULL,66738,43.83,0.15,3170,23812,NULL,NULL,'SIFTO','zCOSMOS 823997',0.8387,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66739,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2ay',NULL,66739,43.95,0.08,3350,23812,70,NULL,'SALT2','zCOSMOS 823997',0.8387,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66740,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66740,36.16,0.46,171,23813,70,NULL,NULL,'2MASX J10010952-0004460',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000103,NULL,'15.4g',0.57,'BrClG','Brightest group member',NULL,NULL,NULL,1,150.28975,-0.0795,0.057,NULL,41231640414,644244381,10066318,15.4),(66741,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66741,34.62,0.49,84,23814,75,NULL,'IR','NGC 3088 NED02',NULL,'2011yCatp016004901K',2011,1,0.7,'Called \'NGC 3088b\' in MCG.  Component \'b)\' in UGC notes.','G',0.00032,NULL,'14.7',0.2,'S',NULL,NULL,NULL,NULL,1,150.290417,22.40231,0.065,NULL,63689045664,995141338,15549083,14.7),(66742,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66742,36.99,0.33,250,23815,70,NULL,NULL,'2MASX J10011011+0935461',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,150.292208333,9.59622,0.061,NULL,60873208960,951143890,14861623,17),(66743,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66743,37.97,0.46,393,23816,70,NULL,NULL,'2MASX J10011116+0428268',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000176,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,150.296375,4.47406,0.005,NULL,60779282431,949676287,14838691,17.8),(66744,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66744,37.86,0.23,373,23817,70,NULL,NULL,'2MASX J10011126-0008010',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000089,NULL,'16.5g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,150.297,-0.13347,0.049,NULL,41231633095,644244267,10066316,16.5),(66745,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2iu',NULL,66745,41.16,0.17,1010,23818,NULL,NULL,'SALT2','[AGR2006] J100113.22+022453.9',0.691,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,150.305083,2.41497,0,NULL,60780509958,949695468,14838991,NULL),(66746,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2iu',NULL,66746,42.37,0.26,1760,23818,74.2,NULL,'SALT 2','[AGR2006] J100113.22+022453.9',0.691,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66747,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2iu','R',66747,42.85,NULL,2200,23818,65,NULL,'MLCS17','[AGR2006] J100113.22+022453.9',0.691,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66748,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2iu',NULL,66748,43.02,0.3,2380,23818,70,NULL,'SALT 2','[AGR2006] J100113.22+022453.9',0.691,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66749,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2iu',NULL,66749,43.04,0.33,2400,23818,65,NULL,'MLCS2k2','[AGR2006] J100113.22+022453.9',0.691,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66750,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2iu',NULL,66750,43.06,0.27,2420,23818,65,NULL,'SALT2','[AGR2006] J100113.22+022453.9',0.691,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66751,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2iu',NULL,66751,43.14,0.17,2510,23818,70,NULL,'SALT','[AGR2006] J100113.22+022453.9',0.691,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66752,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2iu',NULL,66752,43.14,0.14,2520,23818,70,NULL,NULL,'[AGR2006] J100113.22+022453.9',0.691,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66753,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2iu',NULL,66753,43.16,0.15,2540,23818,NULL,NULL,'SIFTO','[AGR2006] J100113.22+022453.9',0.691,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66754,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2iu',NULL,66754,43.22,0.35,2600,23818,65,NULL,'MLCS17','[AGR2006] J100113.22+022453.9',0.691,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66755,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2iu',NULL,66755,43.29,0.25,2680,23818,65,NULL,'SALT2','[AGR2006] J100113.22+022453.9',0.691,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66756,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2iu',NULL,66756,43.3,0.14,2700,23818,65,NULL,'SALT','[AGR2006] J100113.22+022453.9',0.691,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66757,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2iu',NULL,66757,43.4,0.39,2830,23818,65,NULL,'MLCS31','[AGR2006] J100113.22+022453.9',0.691,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66758,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2iu',NULL,66758,43.41,0.1,2840,23818,65,NULL,'SALT','[AGR2006] J100113.22+022453.9',0.691,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66759,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2iu',NULL,66759,43.42,0.38,2860,23818,65,NULL,'MLCS2k2','[AGR2006] J100113.22+022453.9',0.691,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66760,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2iu',NULL,66760,43.79,0.06,3390,23818,70,NULL,'SALT2','[AGR2006] J100113.22+022453.9',0.691,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66761,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66761,36.87,0.46,237,23819,70,NULL,NULL,'2MASX J10011354+3833460',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000173,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,150.3064583,38.56272,0.017,NULL,64057686604,1000901353,15639083,16.2),(66762,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66762,37.28,0.46,286,23820,70,NULL,NULL,'2MASX J10011374+1150120',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000183,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,150.3072917,11.83661,0.069,NULL,60872835790,951138059,14861532,16.6),(66763,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66763,36.68,0.46,217,23821,70,NULL,NULL,'2MASX J10011405+3252274',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000083,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,150.308583,32.87411,0.009,NULL,64060588988,1000946702,15639792,16.8),(66764,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66764,36.5,0.46,200,23822,70,NULL,NULL,'SDSS J100114.85+203622.9',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.6g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,150.311875,20.60639,0.057,NULL,63695886266,995248222,15550753,16.6),(66765,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66765,36.99,0.33,250,23823,70,NULL,NULL,'2MASX J10011519+0941190',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000164,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,150.313125,9.68878,0.081,NULL,60873134525,951142726,14861605,16.6),(66766,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66766,37.34,0.46,294,23824,70,NULL,NULL,'2MASX J10011530+2851079',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000142,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,150.31375,28.85236,0.081,NULL,64163076362,1002548068,15664813,18),(66767,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66767,38.39,0.46,475,23825,70,NULL,NULL,'2MASX J10011553+3144594',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000168,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,150.314625,31.74983,0.061,NULL,64030303098,1000473485,15632398,17.4),(66768,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66768,37.29,0.57,287,23826,70,NULL,NULL,'ESO 567-IG 004 NED02',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'16.99',NULL,NULL,NULL,NULL,NULL,NULL,1,150.320375,-18.04367,0.117,NULL,41194074846,643657419,10057147,16.99),(66769,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66769,37.43,0.46,306,23827,70,NULL,NULL,'2MASX J10011765+0533588',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,150.323583,5.56625,0,NULL,60905683792,951651309,14869551,17.2),(66770,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66770,37.53,0.46,321,23828,70,NULL,NULL,'2MASX J10011785+1259407',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000178,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,150.324417,12.99472,0.049,NULL,60843166085,950674470,14854288,17.5),(66771,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66771,37.86,0.23,373,23829,70,NULL,NULL,'SDSS J100118.91-001004.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000065,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,150.328833,-0.16778,0.049,NULL,41231632271,644244254,10066316,18.5),(66772,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66772,35.37,0.52,118,23830,70,NULL,NULL,'ESO 316- G 016',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00012,NULL,'15.53',0.6,'Sa:',NULL,NULL,NULL,NULL,1,150.330125,-40.61542,0.749,NULL,42079907677,657498557,10273414,15.53),(66773,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66773,37.84,0.46,370,23831,70,NULL,NULL,'SDSS J100120.30+193024.6',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,150.334625,19.50683,0.037,NULL,60808894173,950138971,14845921,17.3),(66774,'G Lens','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66774,39.76,0.36,895,23832,NULL,NULL,NULL,'2MASX J10012087+5553496',NULL,'2007ApJ...660....1O',2007,1,NULL,'This galaxy lenses the \\\"TWIN QUASAR\\\" quasar into two images.','G',0.0001,NULL,'18.5',NULL,'cD',NULL,NULL,NULL,NULL,1,150.336917,55.89742,0,NULL,61935121497,967736273,15120879,18.5),(66775,'G Lens','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66775,40.49,NULL,1260,23832,NULL,NULL,'Standard','2MASX J10012087+5553496',NULL,'2014ApJ...788..190W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66776,'G Lens','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66776,40.56,NULL,1290,23832,NULL,NULL,'R(H) = ct','2MASX J10012087+5553496',NULL,'2014ApJ...788..190W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66777,'G Lens','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66777,41.09,0.6,1650,23832,NULL,NULL,NULL,'2MASX J10012087+5553496',NULL,'2014MNRAS.437..600S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66778,'G Lens','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66778,41.15,0.66,1700,23832,NULL,NULL,NULL,'2MASX J10012087+5553496',NULL,'1991ApJ...378L...5N',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66779,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66779,38.1,0.46,417,23833,70,NULL,NULL,'SDSS J100122.62+182912.0',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.1g',0.26,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,150.3442917,18.48669,0.045,NULL,60806626736,950103542,14845367,17.1),(66780,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66780,37.24,0.46,281,23834,70,NULL,NULL,'2MASX J10012327+2532114',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,150.346833333,25.53647,0.117,NULL,64158871489,1002482367,15663786,17.5),(66781,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66781,38.03,0.46,403,23835,70,NULL,NULL,'2MASX J10012327+1628097',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,150.3469583,16.46947,0.065,NULL,60867243816,951050684,14860166,16.9),(66782,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 06D2cb',NULL,66782,44.16,0.15,3400,23836,NULL,NULL,'SIFTO','SNLS 06D2cb HOST',1,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,150.347875,2.45622,0,NULL,60780496482,949695257,14838988,NULL),(66783,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 06D2cb',NULL,66783,44.97,0.17,4940,23836,NULL,NULL,'SALT2','SNLS 06D2cb HOST',1,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66784,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66784,37.78,0.46,361,23837,70,NULL,NULL,'SDSS J100123.53+391002.7',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.9g',0.26,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,150.348083333,39.16744,0,NULL,64090203715,1001409433,15647022,16.9),(66785,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2dt',NULL,66785,42.68,0.14,2180,23838,70,NULL,'SALT 2','COSMOS-P 117869',0.574,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',0.001,NULL,'22.0i',NULL,NULL,NULL,NULL,NULL,NULL,1,150.34975,1.85775,0,NULL,60780207788,949690746,14838917,22),(66786,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2dt',NULL,66786,42.75,0.15,2250,23838,NULL,NULL,'SIFTO','COSMOS-P 117869',0.574,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66787,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2dt',NULL,66787,42.75,NULL,2260,23838,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','COSMOS-P 117869',0.574,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66788,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2dt',NULL,66788,42.97,0.05,2500,23838,70,NULL,'SIFTO','COSMOS-P 117869',0.574,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66789,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2dt',NULL,66789,43.14,0.17,2700,23838,NULL,NULL,'SALT2','COSMOS-P 117869',0.574,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66790,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66790,37.59,0.33,329,23839,70,NULL,NULL,'2MASX J10012412+4120160',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,150.3505,41.33764,0,NULL,64102882487,1001607538,15650117,18),(66791,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66791,38.06,0.27,409,23840,70,NULL,NULL,'2MASX J10012450+0107238',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000075,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,150.352083,1.12322,0.017,NULL,60774516955,949601827,14837528,17.5),(66792,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66792,37.88,0.46,376,23841,70,NULL,NULL,'2MASX J10012456+3430234',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000181,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,150.352333,34.50647,0,NULL,64063713688,1000995526,15640555,17.1),(66793,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66793,36.39,0.46,189,23842,70,NULL,NULL,'2MASX J10012467+0653359',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,150.3527917,6.89339,0.033,NULL,60922727171,951917612,14873712,17.2),(66794,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66794,36.59,0.46,208,23843,70,NULL,NULL,'2MASX J10012478+1733047',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,150.35325,17.55144,0.053,NULL,60862299771,950973433,14858959,17.7),(66795,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66795,38.06,0.27,409,23844,70,NULL,NULL,'2MASX J10012490+0100288',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000087,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,150.353667,1.00806,0.025,NULL,60774520425,949601881,14837529,16.5),(66796,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66796,37.68,0.33,343,23845,70,NULL,NULL,'2MASX J10012515+0513198',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000178,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,150.35475,5.22211,0.005,NULL,60776395073,949631173,14837987,17.5),(66797,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66797,32.76,0.45,35.7,23846,NULL,NULL,'K','NGC 3094',NULL,'2007A&A...465...71T',2007,1,2,'The position in 1989H&RHI.C...0000H is incorrect.','G',0.000004,NULL,'13.23',1.4,'SB(s)a         Sy2','Field galaxy',NULL,NULL,NULL,1,150.358083,15.77008,0.073,NULL,60864927115,951014486,14859601,13.23),(66798,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66798,32.87,0.47,37.4,23846,NULL,NULL,'H','NGC 3094',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66799,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66799,32.93,0.4,38.5,23846,NULL,NULL,'mean','NGC 3094',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66800,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66800,33,0.46,39.8,23846,NULL,NULL,'J','NGC 3094',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66801,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66801,33.25,0.4,44.7,23846,NULL,NULL,NULL,'NGC 3094',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66802,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66802,35.61,0.46,133,23847,70,NULL,NULL,'2MASX J10012635+0707519',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,150.359833,7.13103,0.029,NULL,60922770212,951918284,14873723,17),(66803,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2he',NULL,66803,42.86,0.16,2320,23848,70,NULL,'SALT 2','SNLS 05D2he HOST',0.608,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',0.001,NULL,'21.4i',NULL,NULL,NULL,NULL,NULL,NULL,1,150.360458333,2.31769,0,NULL,60780478031,949694969,14838983,21.4),(66804,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2he',NULL,66804,42.99,NULL,2460,23848,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SNLS 05D2he HOST',0.608,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66805,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2he',NULL,66805,43.02,0.15,2500,23848,NULL,NULL,'SIFTO','SNLS 05D2he HOST',0.608,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66806,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2he',NULL,66806,43.33,0.04,2880,23848,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SNLS 05D2he HOST',0.608,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66807,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2he',NULL,66807,43.45,0.17,3050,23848,NULL,NULL,'SALT2','SNLS 05D2he HOST',0.608,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66808,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 06D2ck',NULL,66808,42.58,0.04,2110,23849,70,NULL,NULL,'SDSS J100127.97+015149.3',0.552,'2011ApJS..192....1C',2011,1,0.05,NULL,'G',0.001,NULL,'22.9g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,150.366708333,1.86369,0,NULL,60780208060,949690750,14838917,22.9),(66809,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 06D2ck',NULL,66809,42.65,0.14,2180,23849,70,NULL,'SALT 2','SDSS J100127.97+015149.3',0.552,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66810,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2ah',NULL,66810,39.66,0.1,722,23850,72,NULL,'z lit','SDSS J100128.71+015147.1',0.184,'2009ApJ...704.1036F',2009,1,0.09,NULL,'G',0.0002,NULL,'20.8g',0.07,'Candidate      ELG',NULL,NULL,NULL,NULL,1,150.369666667,1.86308,0,NULL,60780208009,949690750,14838917,20.8),(66811,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2ah',NULL,66811,39.84,0.11,785,23850,70,NULL,'SALT 2','SDSS J100128.71+015147.1',0.184,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66812,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2ah',NULL,66812,39.9,NULL,806,23850,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SDSS J100128.71+015147.1',0.184,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66813,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2ah',NULL,66813,39.92,0.15,813,23850,NULL,NULL,'SIFTO','SDSS J100128.71+015147.1',0.184,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66814,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2ah',NULL,66814,40,0.17,844,23850,NULL,NULL,'SALT2','SDSS J100128.71+015147.1',0.184,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66815,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2ah',NULL,66815,40.05,0.03,863,23850,70,NULL,'z lit','SDSS J100128.71+015147.1',0.184,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66816,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66816,38.18,0.46,433,23851,70,NULL,NULL,'2MASX J10013048+1514567',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,150.376875,15.24919,0.053,NULL,60864911798,951014246,14859597,17.4),(66817,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66817,36.36,0.46,187,23852,70,NULL,NULL,'2MASX J10013087+3201194',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000176,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,150.3787083,32.02219,0.017,NULL,64076395329,1001193677,15643651,16.3),(66818,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66818,36.81,0.46,231,23853,70,NULL,NULL,'2MASX J10013204+3915367',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'15.8g',0.37,'E',NULL,NULL,NULL,NULL,1,150.383375,39.26006,0.037,NULL,64090197938,1001409342,15647020,15.8),(66819,'IRAS','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66819,33.57,0.8,51.8,23854,75,NULL,'MAT, I','ESO 567- G 006',NULL,'1997ApJS..109..333W',1997,1,2.63,NULL,'G',0.000017,NULL,'15.86',0.28,'Sc',NULL,NULL,NULL,NULL,1,150.385166667,-20.38286,0.161,NULL,41148028216,642937940,10045905,15.86),(66820,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66820,33.39,NULL,47.6,23854,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 567- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66821,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66821,33.39,NULL,47.7,23854,NULL,NULL,'Dipole','ESO 567- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66822,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66822,33.41,NULL,48,23854,NULL,NULL,'Dipole + Quadrupole','ESO 567- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66823,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66823,33.57,NULL,51.8,23854,NULL,NULL,NULL,'ESO 567- G 006',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66824,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66824,33.97,0.58,62.2,23854,NULL,NULL,'Malmquist cor.','ESO 567- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66825,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66825,34.08,0.32,65.5,23854,85,NULL,'I, raw','ESO 567- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66826,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66826,34.08,0.32,65.5,23854,85,NULL,'I, inv','ESO 567- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66827,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66827,34.21,0.2,69.5,23854,74.4,NULL,NULL,'ESO 567- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66828,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66828,34.22,0.51,70,23854,NULL,NULL,NULL,'ESO 567- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66829,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66829,34.29,0.43,72.2,23854,75,NULL,'MAT, I, raw','ESO 567- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66830,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66830,34.35,0.43,74.2,23854,75,NULL,'MAT, I, inv','ESO 567- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66831,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66831,34.39,0.43,75.7,23854,75,NULL,'3.6 micron, color corrected','ESO 567- G 006',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66832,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66832,34.53,0.43,80.6,23854,75,NULL,'3.6 micron, color + selection bias corrected','ESO 567- G 006',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66833,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66833,34.55,0.43,81.2,23854,75,NULL,'MAT, I, cor','ESO 567- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66834,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66834,36.66,0.33,215,23855,70,NULL,NULL,'2MASX J10013246+1420527',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.58',0.4,NULL,NULL,NULL,NULL,NULL,1,150.385208333,14.34792,0.037,NULL,60854991043,950859235,14857175,16.58),(66835,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66835,37.88,0.46,376,23856,70,NULL,NULL,'SDSS J100134.47+111636.4',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,150.393666667,11.27681,0.049,NULL,60872316664,951129947,14861405,18),(66836,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66836,38.08,0.46,412,23857,70,NULL,NULL,'2MASX J10013461+2646004',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,150.39425,26.76697,0.089,NULL,64171320190,1002676877,15666826,18.1),(66837,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66837,34.96,0.46,98,23858,70,NULL,NULL,'UGC 05395',NULL,'2015arXiv151105856S',2015,1,1.11,NULL,'G',0.000163,NULL,'14.3g',0.72,'S0-:',NULL,NULL,NULL,NULL,1,150.39625,12.76497,0.041,NULL,60843488387,950679506,14854367,14.3),(66838,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66838,35.27,NULL,113,23859,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05392',NULL,'2010Ap&SS.325..163P',2010,1,1.23,NULL,'G',0.000014,NULL,'16.0',0.12,'Sd',NULL,NULL,NULL,NULL,1,150.399041667,21.6075,0.069,NULL,63700177905,995315279,15551801,16),(66839,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66839,35.28,NULL,114,23859,NULL,NULL,'Dipole + Quadrupole','UGC 05392',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66840,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66840,35.3,NULL,115,23859,NULL,NULL,'Dipole','UGC 05392',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66841,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66841,35.34,NULL,117,23859,NULL,NULL,NULL,'UGC 05392',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66842,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66842,37.26,0.33,283,23860,70,NULL,NULL,'2MASX J10013609+4603399',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'15.9g',0.36,NULL,NULL,NULL,NULL,NULL,1,150.40025,46.06119,0,NULL,63976190041,999627969,15619187,15.9),(66843,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66843,34.27,NULL,71.5,23861,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05389',NULL,'2010Ap&SS.325..163P',2010,1,2.28,NULL,'G',0.000023,NULL,'15.3g',0.25,'Scd',NULL,NULL,NULL,NULL,1,150.4057917,39.62731,0.009,NULL,64090965156,1001421330,15647208,15.3),(66844,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66844,34.28,NULL,71.7,23861,NULL,NULL,'Dipole + Quadrupole','UGC 05389',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66845,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66845,34.28,NULL,71.9,23861,NULL,NULL,'Dipole','UGC 05389',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66846,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66846,34.3,NULL,72.6,23861,NULL,NULL,NULL,'UGC 05389',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66847,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66847,34.38,0.49,75.3,23861,75,NULL,'IR','UGC 05389',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66848,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66848,34.82,0.41,92.1,23861,NULL,NULL,NULL,'UGC 05389',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66849,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66849,34.85,0.4,93.2,23861,NULL,NULL,'Malmquist cor.','UGC 05389',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66850,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66850,34.86,0.2,93.8,23861,74.4,NULL,NULL,'UGC 05389',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66851,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66851,37.26,0.33,283,23862,70,NULL,NULL,'2MASX J10013755+4556119',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,150.406625,45.93672,0,NULL,63976069960,999626093,15619157,16.9),(66852,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66852,33.72,0.48,55.6,23863,70,NULL,NULL,'MCG -01-26-010',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000143,NULL,'14.40',0.4,NULL,NULL,NULL,NULL,NULL,1,150.4100417,-6.55517,0.081,NULL,41331546276,645805410,10090709,14.4),(66853,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66853,38.7,0.46,550,23864,70,NULL,NULL,'2MASX J10013878+4045528',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,150.411625,40.76458,0.013,NULL,64104229787,1001628590,15650446,17.6),(66854,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2ei',NULL,66854,41.06,0.15,1190,23865,NULL,NULL,'SIFTO','[NSB2006] J100139.10+014912.0',0.366,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,'19.7i',NULL,NULL,NULL,NULL,NULL,NULL,1,150.4129583,1.82017,0,NULL,60780213587,949690837,14838919,19.7),(66855,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2ei',NULL,66855,41.9,0.17,1760,23865,NULL,NULL,'SALT2','[NSB2006] J100139.10+014912.0',0.366,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66856,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2gc',NULL,66856,41.47,0.16,1290,23866,74.2,NULL,'SALT 2','[AGR2006] J100139.28+015259.3',0.521,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.0005,NULL,'22.5i',NULL,NULL,NULL,NULL,NULL,NULL,1,150.413583,1.88311,0,NULL,60780214308,949690848,14838919,22.5),(66857,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2gc','R',66857,41.85,NULL,1540,23866,65,NULL,'MLCS17','[AGR2006] J100139.28+015259.3',0.521,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66858,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2gc',NULL,66858,42.12,0.28,1740,23866,65,NULL,'MLCS17','[AGR2006] J100139.28+015259.3',0.521,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66859,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2gc',NULL,66859,42.28,0.17,1880,23866,70,NULL,'SALT','[AGR2006] J100139.28+015259.3',0.521,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66860,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2gc',NULL,66860,42.41,0.14,1990,23866,65,NULL,'SALT','[AGR2006] J100139.28+015259.3',0.521,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66861,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2gc',NULL,66861,42.44,0.05,2020,23866,70,NULL,NULL,'[AGR2006] J100139.28+015259.3',0.521,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66862,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2gc',NULL,66862,42.44,0.31,2020,23866,65,NULL,'MLCS2k2','[AGR2006] J100139.28+015259.3',0.521,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66863,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2gc',NULL,66863,42.47,0.04,2050,23866,70,NULL,'SALT 2','[AGR2006] J100139.28+015259.3',0.521,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66864,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2gc',NULL,66864,42.52,0.15,2100,23866,70,NULL,'SALT 2','[AGR2006] J100139.28+015259.3',0.521,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66865,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2gc',NULL,66865,42.66,0.15,2240,23866,NULL,NULL,'SIFTO','[AGR2006] J100139.28+015259.3',0.521,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66866,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2gc',NULL,66866,42.71,0.04,2280,23866,65,NULL,'SALT','[AGR2006] J100139.28+015259.3',0.521,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66867,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2gc',NULL,66867,44.05,0.17,4240,23866,NULL,NULL,'SALT2','[AGR2006] J100139.28+015259.3',0.521,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66868,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2bt',NULL,66868,42.28,0.05,1700,23867,70,NULL,'SIFTO','COSMOS 2252447',0.679,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.01,NULL,'24.0i',NULL,'Candidate      ELG',NULL,NULL,NULL,NULL,1,150.4177083,2.56589,0,NULL,60780674014,949698031,14839031,24),(66869,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2bt',NULL,66869,43.12,0.15,2500,23867,NULL,NULL,'SIFTO','COSMOS 2252447',0.679,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66870,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2bt',NULL,66870,43.17,0.19,2560,23867,72,NULL,'z lit','COSMOS 2252447',0.679,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66871,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2bt',NULL,66871,43.2,0.17,2600,23867,70,NULL,'SALT 2','COSMOS 2252447',0.679,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66872,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2bt',NULL,66872,44.05,0.17,3840,23867,NULL,NULL,'SALT2','COSMOS 2252447',0.679,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66873,'G Lens','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66873,45.27,0.17,6740,23867,NULL,NULL,'SNLS 05D2bt HOST','COSMOS 2252447',0.679,'2010A&A...514A..44K',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66874,'Faber-Jackson','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66874,45.17,0.17,6440,23867,NULL,NULL,'SNLS 05D2bt HOST','COSMOS 2252447',0.679,'2010A&A...514A..44K',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66875,'IRAS','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66875,34.35,0.8,74.3,23868,75,NULL,'CF, r','UGC 05396',NULL,'1997ApJS..109..333W',1997,1,1.59,NULL,'G',0.00002,NULL,'14.5g',0.52,'Scd:',NULL,NULL,NULL,NULL,1,150.418666667,10.75644,0.057,NULL,60875839728,951184995,14862265,14.5),(66876,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66876,34.28,0.38,71.8,23868,75,NULL,'CF, r, raw','UGC 05396',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66877,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66877,34.36,0.47,74.6,23868,NULL,NULL,NULL,'UGC 05396',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66878,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66878,34.39,0.38,75.5,23868,75,NULL,'CF, r, inv','UGC 05396',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66879,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66879,34.4,0.2,75.9,23868,74.4,NULL,NULL,'UGC 05396',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66880,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66880,34.41,0.46,76.3,23868,NULL,NULL,'Malmquist cor.','UGC 05396',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66881,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66881,34.63,0.38,84.5,23868,75,NULL,'CF, r, cor','UGC 05396',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66882,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66882,32.06,0.4,25.8,23869,75,NULL,'B','UGC 05391',NULL,'1988NBGC.C....0000T',1988,1,2.2,'HOLM 158B is a star.','G',0.000037,NULL,'14.50',0.8,'Sm','in a pair',NULL,NULL,NULL,1,150.421,37.24744,0,NULL,64071289528,1001113898,15642404,14.5),(66883,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66883,31.92,0.4,24.2,23870,75,NULL,'B','UGC 05393',NULL,'1988NBGC.C....0000T',1988,1,1.4,NULL,'G',0.000037,NULL,'14.8g',0.77,'SB(r)dm:','Group member',NULL,NULL,NULL,1,150.42525,33.13642,0.013,NULL,64060614771,1000947105,15639798,14.8),(66884,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66884,32.15,0.43,26.9,23870,75,NULL,'3.6 micron, color + selection bias corrected','UGC 05393',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66885,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2ct',NULL,66885,43.28,0.24,2610,23871,70,NULL,'SALT 2','zCOSMOS 700447',0.7349,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',0.0002,NULL,'22.4i',NULL,NULL,NULL,NULL,NULL,NULL,1,150.425708333,2.12389,0,NULL,60780391633,949693619,14838962,22.4),(66886,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2ct',NULL,66886,43.35,0.15,2700,23871,NULL,NULL,'SIFTO','zCOSMOS 700447',0.7349,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66887,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2ct',NULL,66887,43.83,0.07,3360,23871,70,NULL,'SIFTO','zCOSMOS 700447',0.7349,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66888,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2ct',NULL,66888,43.94,0.17,3530,23871,NULL,NULL,'SALT2','zCOSMOS 700447',0.7349,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66889,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66889,36.87,0.33,236,23872,70,NULL,NULL,'2MASX J10014232+0955579',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000188,NULL,'16.2g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,150.426167,9.93283,0.073,NULL,60873866285,951154160,14861783,16.2),(66890,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66890,37.89,0.46,379,23873,70,NULL,NULL,'2MASX J10014239+0345507',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000148,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,150.426583,3.76419,0.009,NULL,60778682551,949666914,14838545,17.2),(66891,'BL Lac Luminosity','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66891,41.25,NULL,1320,23874,NULL,NULL,NULL,'MS 0958.9+2102',0.346,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.003,':','19.84',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,150.4267083,20.80508,0.057,NULL,63695902937,995248483,15550757,19.84),(66892,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66892,34.57,NULL,82.1,23875,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0984',NULL,'2010Ap&SS.325..163P',2010,1,0.65,NULL,'G',NULL,NULL,'17.1',0.08,'Sd',NULL,NULL,NULL,NULL,1,150.430833,76.95861,0.025,NULL,61408946987,959514796,14992418,17.1),(66893,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66893,34.6,NULL,83.1,23875,NULL,NULL,'Dipole + Quadrupole','FGC 0984',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66894,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66894,34.62,NULL,84,23875,NULL,NULL,'Dipole','FGC 0984',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66895,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66895,34.64,NULL,84.7,23875,NULL,NULL,NULL,'FGC 0984',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66896,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 06D2ce',NULL,66896,43.18,0.07,2370,23876,70,NULL,NULL,'SNLS 06D2ce HOST',0.82,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,150.43425,2.71331,0,NULL,60780596167,949696815,14839012,NULL),(66897,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66897,36.86,0.46,236,23877,70,NULL,NULL,'2MASX J10014476+1748398',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000189,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,150.436333,17.81094,0.081,NULL,60862382098,950974720,14858980,16.1),(66898,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66898,38.2,0.46,437,23878,70,NULL,NULL,'SDSS J100145.05+454715.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000167,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,150.4377083,45.78769,0,NULL,63976071455,999626116,15619158,18.1),(66899,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66899,37.22,0.46,278,23879,70,NULL,NULL,'2MASX J10014590+4017378',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000182,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,150.441416667,40.29397,0.009,NULL,64090439665,1001413119,15647079,16.6),(66900,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66900,36.58,0.46,207,23880,70,NULL,NULL,'2MASX J10014630+1703528',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,150.4427083,17.06475,0.053,NULL,60862211633,950972056,14858938,17),(66901,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66901,36.9,0.46,240,23881,70,NULL,NULL,'2MASX J10014652+6149551',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000179,NULL,'15.8g',0.48,'E0',NULL,NULL,NULL,NULL,1,150.443917,61.83194,0.029,NULL,61911619490,967369054,15115141,15.8),(66902,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66902,37.27,0.46,284,23882,70,NULL,NULL,'2MASX J10014675+1140513',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00017,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,150.4447917,11.68083,0.057,NULL,60872751750,951136746,14861511,17.3),(66903,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66903,32.58,NULL,32.8,23883,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05394',NULL,'2010Ap&SS.325..163P',2010,1,1.19,'HOLM 159B is a star.','G',0.000013,NULL,'15.9g',0.28,'Sdm',NULL,NULL,NULL,NULL,1,150.4495417,36.49869,0.005,NULL,64072118333,1001126848,15642607,15.9),(66904,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66904,32.6,NULL,33.2,23883,NULL,NULL,'Dipole + Quadrupole','UGC 05394',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66905,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66905,32.61,NULL,33.2,23883,NULL,NULL,'Dipole','UGC 05394',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66906,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66906,32.61,NULL,33.3,23883,NULL,NULL,NULL,'UGC 05394',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66907,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66907,32.99,0.2,39.6,23883,74.4,NULL,NULL,'UGC 05394',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66908,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66908,33.22,0.75,44.1,23883,NULL,NULL,NULL,'UGC 05394',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66909,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66909,33.39,0.69,47.7,23883,NULL,NULL,'Malmquist cor.','UGC 05394',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66910,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66910,36.78,0.46,227,23884,70,NULL,NULL,'2MASX J10014825+1125153',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000153,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,150.451083,11.42078,0.049,NULL,60872730459,951136413,14861506,16.8),(66911,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66911,37.92,0.46,383,23885,70,NULL,NULL,'2MASX J10014835+0133397',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000189,NULL,'17.0g',0.25,'HII',NULL,NULL,NULL,NULL,1,150.451417,1.56108,0.013,NULL,60772608645,949572010,14837062,17),(66912,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66912,37.66,0.46,340,23886,70,NULL,NULL,'2MASX J10014899+4002319',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,150.4542083,40.04217,0,NULL,64090418440,1001412788,15647074,17.2),(66913,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66913,38.38,0.46,474,23887,70,NULL,NULL,'SDSS J100149.22+133335.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,150.455125,13.55986,0.069,NULL,60851470247,950804222,14856315,18),(66914,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66914,38.02,0.46,401,23888,70,NULL,NULL,'SDSS J100149.48-001831.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000081,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,150.4562083,-0.30864,0.049,NULL,41233708411,644276693,10066823,18.2),(66915,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66915,37.41,0.46,304,23889,70,NULL,NULL,'2MASX J10014968+0532277',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000169,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,150.456875,5.54092,0,NULL,60905645783,951650715,14869542,17.1),(66916,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66916,37.81,0.46,365,23890,70,NULL,NULL,'2MASX J10015020+1019513',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000181,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,150.459291667,10.33092,0.065,NULL,60873672392,951151131,14861736,16.9),(66917,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2ab',NULL,66917,41.17,0.11,1300,23891,70,NULL,'SALT 2','[NSB2006] J100150.83+020623.0',0.32,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',NULL,NULL,'20.1i',NULL,NULL,NULL,NULL,NULL,NULL,1,150.46175,2.10608,0,NULL,60780388741,949693574,14838962,20.1),(66918,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2ab',NULL,66918,41.19,0.03,1310,23891,70,NULL,'SALT2','[NSB2006] J100150.83+020623.0',0.32,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66919,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2ab',NULL,66919,41.18,0.17,1310,23891,NULL,NULL,'SALT2','[NSB2006] J100150.83+020623.0',0.32,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66920,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2ab',NULL,66920,41.21,0.15,1320,23891,NULL,NULL,'SIFTO','[NSB2006] J100150.83+020623.0',0.32,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66921,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2ab',NULL,66921,41.24,NULL,1340,23891,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','[NSB2006] J100150.83+020623.0',0.32,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66922,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66922,37.59,0.33,329,23892,70,NULL,NULL,'2MASX J10015114+4117169',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,'PHOT','16.7g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,150.4630417,41.28817,0,NULL,64102888881,1001607638,15650119,16.7),(66923,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66923,34.54,0.66,80.8,23893,70,NULL,NULL,'FAIRALL 1355',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'15.6B',0.58,NULL,NULL,NULL,NULL,NULL,1,150.4657917,-71.48006,0.505,NULL,40714858652,636169666,9940151,15.6),(66924,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66924,37.6,0.33,331,23894,70,NULL,NULL,'2MASX J10015201+1906434',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000149,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,150.466583333,19.11206,0.045,NULL,60808882010,950138781,14845918,17),(66925,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66925,36.87,0.33,236,23895,70,NULL,NULL,'SDSS J100152.36+095248.0',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,150.4682083,9.88003,0.081,NULL,60873146445,951142913,14861608,17.1),(66926,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2al',NULL,66926,42.77,0.18,1950,23896,70,NULL,'SALT 2','COSMOS 1551160',0.836,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',0.001,NULL,'23.1i',NULL,NULL,NULL,NULL,NULL,NULL,1,150.4685,2.16425,0,NULL,60780272477,949691757,14838933,23.1),(66927,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2al',NULL,66927,43.5,0.08,2730,23896,70,NULL,NULL,'COSMOS 1551160',0.836,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66928,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2al',NULL,66928,43.54,0.28,2780,23896,70,NULL,'SALT 2','COSMOS 1551160',0.836,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66929,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66929,35.87,0.61,149,23897,70,NULL,NULL,'2MASX J10015292-0007309',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.000098,NULL,'16.0g',0.41,'D              AGN',NULL,NULL,NULL,NULL,1,150.470625,-0.12517,0.057,NULL,41233685080,644276329,10066817,16),(66930,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66930,36,0.33,158,23897,70,NULL,NULL,'2MASX J10015292-0007309',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66931,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','PS1 SN PS11at','N',66931,40.7,0.18,1040,23898,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11at HOST',0.3212,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66932,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2le',NULL,66932,43.06,0.05,2400,23899,70,NULL,'SIFTO','SNLS 05D2le HOST',0.7002,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,150.4785417,2.09297,0,NULL,60780269667,949691713,14838933,NULL),(66933,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2le',NULL,66933,43.25,0.18,2620,23899,70,NULL,'SALT 2','SNLS 05D2le HOST',0.7002,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66934,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2le',NULL,66934,43.26,0.15,2640,23899,NULL,NULL,'SIFTO','SNLS 05D2le HOST',0.7002,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66935,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2le',NULL,66935,43.28,NULL,2670,23899,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SNLS 05D2le HOST',0.7002,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66936,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2le',NULL,66936,44.07,0.17,3830,23899,NULL,NULL,'SALT2','SNLS 05D2le HOST',0.7002,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66937,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66937,32.67,NULL,34.1,23900,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 0988',NULL,'2010Ap&SS.325..163P',2010,1,0.94,NULL,'G',0.000053,NULL,'16.7g',0.17,'Sd(f)',NULL,NULL,NULL,NULL,1,150.4794583,63.89258,0.117,NULL,62243862497,972560351,15196255,16.7),(66938,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66938,32.7,NULL,34.6,23900,NULL,NULL,'Dipole + Quadrupole','FGC 0988',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66939,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66939,32.73,NULL,35.2,23900,NULL,NULL,'Dipole','FGC 0988',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66940,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66940,32.78,NULL,36,23900,NULL,NULL,NULL,'FGC 0988',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66941,'Faber-Jackson','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66941,31.55,0.65,20.4,23901,95,NULL,'de Vaucouleurs','NGC 3065',NULL,'1984ApJS...56...91D',1984,1,1.7,'The 2MASS position is 10 arcsec northwest of the nucleus.','G',0.000037,NULL,'13.5',1.7,'SA(r)0^0^','in an interacting pair',NULL,NULL,'LINER b',1,150.480083,72.17033,0.097,NULL,62102388776,970349824,15161716,13.5),(66942,'Faber-Jackson','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66942,31.64,0.32,21.3,23901,95,NULL,'Weighted Mean','NGC 3065',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66943,'Faber-Jackson','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66943,31.78,0.63,22.7,23901,95,NULL,'Michard 1979b, c','NGC 3065',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66944,'Faber-Jackson','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66944,32.25,0.46,28.2,23901,95,NULL,'Michard 1979a','NGC 3065',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66945,'Faber-Jackson','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66945,32.76,0.81,35.6,23901,55,NULL,'Visvanathan & Sandage 1979','NGC 3065',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66946,'Tertiary','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66946,32.37,0.35,29.8,23901,95,NULL,NULL,'NGC 3065',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66947,'Tully est','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66947,32.48,0.8,31.3,23901,75,NULL,'B','NGC 3065',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66948,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66948,32.5,0.4,31.6,23901,NULL,NULL,'mean','NGC 3065',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66949,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66949,32.97,0.45,39.2,23901,NULL,NULL,'K','NGC 3065',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66950,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66950,38.91,0.46,606,23902,70,NULL,NULL,'2MASX J10015545+1756244',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000186,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,150.4810417,17.94031,0.077,NULL,60861890009,950967031,14858859,18.1),(66951,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66951,36.7,0.46,219,23903,70,NULL,NULL,'2MASX J10015549+2644119',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000178,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,150.48125,26.73672,0.089,NULL,64171302481,1002676601,15666821,16.6),(66952,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2cf',NULL,66952,40.79,0.17,1050,23904,NULL,NULL,'SALT2','[AGR2006] J100156.11+015246.4',0.369,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,'21.1V',NULL,NULL,NULL,NULL,NULL,NULL,1,150.48325,1.87983,0,NULL,60780200130,949690627,14838916,21.1),(66953,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2cf','R',66953,40.88,NULL,1100,23904,65,NULL,'SALT','[AGR2006] J100156.11+015246.4',0.369,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66954,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2cf',NULL,66954,40.9,0.15,1110,23904,74.2,NULL,'SALT 2','[AGR2006] J100156.11+015246.4',0.369,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66955,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2cf',NULL,66955,41.41,0.15,1400,23904,NULL,NULL,'SIFTO','[AGR2006] J100156.11+015246.4',0.369,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66956,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2cf',NULL,66956,41.47,NULL,1440,23904,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','[AGR2006] J100156.11+015246.4',0.369,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66957,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2cf',NULL,66957,41.47,0.13,1440,23904,70,NULL,'SALT 2','[AGR2006] J100156.11+015246.4',0.369,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66958,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2cf',NULL,66958,41.49,0.02,1450,23904,70,NULL,NULL,'[AGR2006] J100156.11+015246.4',0.369,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66959,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2cf',NULL,66959,41.51,0.13,1460,23904,70,NULL,'SALT','[AGR2006] J100156.11+015246.4',0.369,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66960,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2cf',NULL,66960,41.67,0.1,1570,23904,65,NULL,'SALT','[AGR2006] J100156.11+015246.4',0.369,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66961,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2cf',NULL,66961,41.72,0.18,1610,23904,65,NULL,'SALT2','[AGR2006] J100156.11+015246.4',0.369,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66962,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2cf',NULL,66962,41.75,0.02,1640,23904,65,NULL,'SALT','[AGR2006] J100156.11+015246.4',0.369,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66963,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2cf',NULL,66963,41.78,0.17,1650,23904,65,NULL,'MLCS17','[AGR2006] J100156.11+015246.4',0.369,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66964,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2cf',NULL,66964,41.81,0.14,1680,23904,65,NULL,'MLCS2k2','[AGR2006] J100156.11+015246.4',0.369,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66965,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2cf',NULL,66965,41.81,0.16,1680,23904,65,NULL,'MLCS31','[AGR2006] J100156.11+015246.4',0.369,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66966,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2cf',NULL,66966,41.91,0.07,1760,23904,70,NULL,'SALT2','[AGR2006] J100156.11+015246.4',0.369,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66967,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66967,37.63,0.33,336,23905,70,NULL,NULL,'2MASX J10015608+1453068',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'16.1g',0.38,NULL,NULL,NULL,NULL,NULL,1,150.4837917,14.88522,0.065,NULL,60854160624,950846259,14856972,16.1),(66968,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66968,37.6,0.33,331,23906,70,NULL,NULL,'2MASX J10015638+1907274',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00017,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,150.484917,19.12425,0.045,NULL,60808849886,950138279,14845910,17.6),(66969,'IRAS','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66969,31.5,0.8,20,23907,75,NULL,'A82, H','NGC 3079',NULL,'1997ApJS..109..333W',1997,1,7.9,'Same redshift as [HB89] 0958+558 NED03 ABS02.','G',0.000003,NULL,'9.97B',1.4,'SB(s)c;LINER   Sy2','in an interacting pair',NULL,NULL,'Sy 2',1,150.490833,55.67978,0,NULL,61935133346,967736458,15120882,9.97),(66970,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66970,31.09,0.35,16.5,23907,NULL,NULL,NULL,'NGC 3079',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66971,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66971,31.19,0.4,17.3,23907,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 3079',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66972,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66972,31.26,NULL,17.9,23907,75,NULL,'HI','NGC 3079',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66973,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66973,31.28,0.47,18,23907,75,NULL,'A82, H, raw','NGC 3079',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66974,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66974,31.47,0.47,19.7,23907,75,NULL,'A82, H, inv','NGC 3079',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66975,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66975,31.47,0.43,19.7,23907,NULL,NULL,'Malmquist cor.','NGC 3079',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66976,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66976,31.53,0.42,20.2,23907,NULL,NULL,NULL,'NGC 3079',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66977,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66977,31.54,0.4,20.4,23907,75,NULL,'B','NGC 3079',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66978,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66978,31.55,0.47,20.4,23907,75,NULL,'A82, H, cor','NGC 3079',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66979,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66979,31.57,0.2,20.6,23907,74.4,NULL,NULL,'NGC 3079',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66980,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66980,31.6,NULL,20.9,23907,75,NULL,'CO','NGC 3079',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66981,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66981,31.77,0.49,22.6,23907,75,NULL,'IR','NGC 3079',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66982,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66982,38.39,0.46,477,23908,70,NULL,NULL,'2MASX J10015816+3446407',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000169,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,150.4925417,34.778,0.009,NULL,64062959579,1000983743,15640370,18.1),(66983,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66983,35.97,0.46,156,23909,70,NULL,NULL,'2MASX J10015887+4543338',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000175,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,150.495375,45.726,0,NULL,63976543751,999633496,15619273,17),(66984,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66984,37.02,0.46,254,23910,70,NULL,NULL,'2MASX J10015956+4546488',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,150.498125,45.78003,0,NULL,63976545347,999633521,15619273,17.6),(66985,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66985,36.71,0.46,220,23911,70,NULL,NULL,'2MASX J10020194+5725352',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000169,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,150.5082083,57.42653,0,NULL,61940154577,967814915,15122108,16.9),(66986,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66986,37.14,0.46,268,23912,70,NULL,NULL,'2MASX J10020244+4030549',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000205,NULL,'15.9g',0.38,'E0',NULL,NULL,NULL,NULL,1,150.5099583,40.51533,0.009,NULL,64104187644,1001627931,15650436,15.9),(66987,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66987,36.81,0.46,230,23913,70,NULL,NULL,'2MASX J10020320+5209533',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,150.513125,52.16481,0,NULL,63996547830,999946059,15624157,17.1),(66988,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66988,36.83,0.15,232,23914,70,NULL,NULL,'2MASX J10020337+3245587',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000077,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,150.5139583,32.76644,0,NULL,64059698952,1000932796,15639574,16.8),(66989,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66989,38.04,0.46,406,23915,70,NULL,NULL,'2MASX J10020400+0641183',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,150.51675,6.68856,0.033,NULL,60923245154,951925705,14873839,17.6),(66990,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66990,37.51,0.17,317,23916,70,NULL,NULL,'2MASX J10020444+1102393',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000183,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,150.518458333,11.04431,0.049,NULL,60875777821,951184028,14862250,17),(66991,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66991,37.66,0.46,340,23917,70,NULL,NULL,'2MASX J10020451+2509349',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000148,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,150.518875,25.15981,0.113,NULL,64159011598,1002484556,15663821,17.2),(66992,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66992,36.02,0.51,160,23918,70,NULL,NULL,'MCG -02-26-021',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.0001,NULL,'15.5',0.2,NULL,NULL,NULL,NULL,NULL,1,150.524125,-15.29842,0.141,NULL,41203281743,643801277,10059394,15.5),(66993,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','PS1 SN PS11t','N',66993,42.16,0.13,1860,23919,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11t HOST',0.4512,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66994,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,66994,36.07,0.58,163,23920,70,NULL,NULL,'2MASX J10020769-0604563',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.60',0.21,NULL,NULL,NULL,NULL,NULL,1,150.5319583,-6.08256,0.057,NULL,41330691770,645792058,10090500,16.6),(66995,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66995,37.63,0.33,336,23921,70,NULL,NULL,'2MASX J10020836+1452098',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,150.534875,14.86931,0.057,NULL,60854152011,950846125,14856970,17.7),(66996,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','PS1 SN PS10o','N',66996,40.22,0.1,905,23922,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10o HOST',0.2212,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66997,'GRB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66997,42.64,0.79,1730,23923,NULL,NULL,NULL,'GRB 071010B',0.947,'2010JCAP...08..020W',2010,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,150.53775,45.73125,0,NULL,63976544083,999633501,15619273,NULL),(66998,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',66998,37.75,0.33,356,23924,70,NULL,NULL,'2MASXi J1002094+460042',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.7g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,150.539041667,46.01183,0,NULL,63976179483,999627804,15619184,17.7),(66999,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','PS1 SN PS10m','N',66999,43.3,0.2,2820,23925,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10m HOST',0.6192,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67000,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67000,36.95,0.46,245,23926,70,NULL,NULL,'2MASX J10020957+1632048',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'16.86',0.38,NULL,NULL,NULL,NULL,NULL,1,150.54,16.53464,0.065,NULL,60867435803,951053684,14860213,16.86),(67001,'Tully est','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67001,32.55,0.8,32.4,23927,75,NULL,'B','NGC 3066',NULL,'1988NBGC.C....0000T',1988,1,1.1,NULL,'G',0.000027,NULL,'13.55',1,'(R\')SAB(s)bc pec','in an interacting pair',NULL,NULL,'Starburst',1,150.546125,72.12539,0.097,NULL,62102212144,970347064,15161672,13.55),(67002,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67002,34.98,0.46,99,23928,70,NULL,NULL,'UGC 05400',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000103,NULL,'14.15',0.8,'S0',NULL,NULL,NULL,NULL,1,150.5570417,13.69667,0.069,NULL,60854668875,950854201,14857096,14.15),(67003,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67003,37.51,0.17,317,23929,70,NULL,NULL,'2MASX J10021572+1047232',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,150.565583,10.78975,0.057,NULL,60875732288,951183317,14862239,17.3),(67004,'Tully est','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67004,31.75,0.8,22.4,23930,75,NULL,'B','NGC 3098',NULL,'1988NBGC.C....0000T',1988,1,2.36,NULL,'G',0.000017,NULL,'12.8g',0.55,'S0','Isolated galaxy',NULL,NULL,NULL,1,150.569541667,24.71108,0.101,NULL,64158690425,1002479537,15663742,12.8),(67005,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67005,30.73,0.45,14,23930,NULL,NULL,'K','NGC 3098',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67006,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67006,31.25,0.4,17.8,23930,75,NULL,NULL,'NGC 3098',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67007,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67007,31.78,0.49,22.7,23930,75,NULL,'IR','NGC 3098',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67008,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67008,31.94,0.4,24.4,23930,NULL,NULL,'mean','NGC 3098',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67009,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67009,38.29,0.46,455,23931,70,NULL,NULL,'SDSS J100216.94+050556.1',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,150.570625,5.09892,0.009,NULL,60776509455,949632960,14838015,17.7),(67010,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2bv',NULL,67010,41.64,0.04,1450,23932,70,NULL,NULL,'[NSB2006] J100217.08+021426.0',0.47,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,'23.3i',NULL,'Candidate      ELG',NULL,NULL,NULL,NULL,1,150.570916667,2.24056,0,NULL,60780277070,949691829,14838934,23.3),(67011,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2bv',NULL,67011,42.18,0.11,1860,23932,70,NULL,'SALT 2','[NSB2006] J100217.08+021426.0',0.47,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67012,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2bv',NULL,67012,42.19,0.13,1870,23932,72,NULL,NULL,'[NSB2006] J100217.08+021426.0',0.47,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67013,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2bv',NULL,67013,42.22,0.15,1890,23932,NULL,NULL,'SIFTO','[NSB2006] J100217.08+021426.0',0.47,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67014,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 05D2bv',NULL,67014,42.37,0.17,2030,23932,NULL,NULL,'SALT2','[NSB2006] J100217.08+021426.0',0.47,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67015,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67015,36.65,0.33,213,23933,70,NULL,NULL,'2MASX J10021736+1025292',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00016,NULL,'17.1g',0.24,'AGN',NULL,NULL,NULL,NULL,1,150.572375,10.42472,0.065,NULL,60873826736,951153542,14861774,17.1),(67016,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67016,37.51,0.17,317,23934,70,NULL,NULL,'SDSS J100218.54+105841.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,150.5772917,10.97808,0.049,NULL,60875802959,951184421,14862256,17.9),(67017,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67017,36.65,0.33,213,23935,70,NULL,NULL,'2MASX J10022000+1026272',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000165,NULL,'16.5g',0.3,'AGN',NULL,NULL,NULL,NULL,1,150.583291667,10.44086,0.069,NULL,60873827310,951153551,14861774,16.5),(67018,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67018,38.24,0.46,445,23936,70,NULL,NULL,'2MASX J10022061+1751329',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,150.5859583,17.85919,0.081,NULL,60862387974,950974812,14858981,17.7),(67019,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67019,37.4,0.46,303,23937,70,NULL,NULL,'2MASX J10022123+4605231',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000179,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,150.588416667,46.08972,0,NULL,63976158974,999627483,15619179,17),(67020,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67020,36.83,0.16,232,23938,70,NULL,NULL,'2MASX J10022251+0033307',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000072,NULL,'16.4g',0.31,'AGN+SF',NULL,NULL,NULL,NULL,1,150.5939583,0.55861,0.033,NULL,60774935846,949608372,14837630,16.4),(67021,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2gb',NULL,67021,40.09,0.17,728,23939,NULL,NULL,'SALT2','SDSS J100222.66+015339.2',0.43,'2010A&A...523A...7G',2010,1,0.03,NULL,'G',0.01,NULL,'23.8g',0.01,NULL,NULL,NULL,NULL,NULL,1,150.5944583,1.89425,0,NULL,60772735029,949573984,14837093,23.8),(67022,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2gb',NULL,67022,41.08,0.15,1150,23939,74.2,NULL,'SALT 2','SDSS J100222.66+015339.2',0.43,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67023,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2gb','R',67023,41.34,NULL,1300,23939,65,NULL,'MLCS17','SDSS J100222.66+015339.2',0.43,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67024,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2gb',NULL,67024,41.69,0.14,1520,23939,70,NULL,'SALT 2','SDSS J100222.66+015339.2',0.43,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67025,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2gb',NULL,67025,41.71,0.12,1540,23939,65,NULL,'MLCS2k2','SDSS J100222.66+015339.2',0.43,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67026,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2gb',NULL,67026,41.71,0.17,1540,23939,65,NULL,'MLCS17','SDSS J100222.66+015339.2',0.43,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67027,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2gb',NULL,67027,41.75,0.14,1570,23939,65,NULL,'SALT2','SDSS J100222.66+015339.2',0.43,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67028,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2gb',NULL,67028,41.78,0.04,1580,23939,70,NULL,NULL,'SDSS J100222.66+015339.2',0.43,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67029,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2gb',NULL,67029,41.78,0.15,1590,23939,NULL,NULL,'SIFTO','SDSS J100222.66+015339.2',0.43,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67030,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2gb',NULL,67030,41.79,0.17,1600,23939,65,NULL,'MLCS31','SDSS J100222.66+015339.2',0.43,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67031,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2gb',NULL,67031,41.81,0.15,1610,23939,65,NULL,'MLCS2k2','SDSS J100222.66+015339.2',0.43,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67032,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2gb',NULL,67032,41.84,0.14,1630,23939,70,NULL,'SALT','SDSS J100222.66+015339.2',0.43,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67033,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2gb',NULL,67033,41.99,0.2,1750,23939,65,NULL,'SALT2','SDSS J100222.66+015339.2',0.43,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67034,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2gb',NULL,67034,42.02,0.11,1770,23939,65,NULL,'SALT','SDSS J100222.66+015339.2',0.43,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67035,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2gb',NULL,67035,42.04,0.04,1790,23939,65,NULL,'SALT','SDSS J100222.66+015339.2',0.43,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67036,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SNLS 04D2gb',NULL,67036,42.49,0.04,2210,23939,70,NULL,'SALT2','SDSS J100222.66+015339.2',0.43,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67037,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67037,36.83,0.15,232,23940,70,NULL,NULL,'2MASX J10022340+3240594',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000073,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,150.5974583,32.68319,0,NULL,64059730802,1000933293,15639582,17),(67038,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67038,37.63,0.46,336,23941,70,NULL,NULL,'2MASX J10022463+1319209',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,150.60275,13.32233,0.061,NULL,60843115292,950673676,14854276,17.2),(67039,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67039,37.51,0.46,318,23942,70,NULL,NULL,'2MASX J10022469+1012392',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,150.602875,10.21078,0.065,NULL,60874018058,951156532,14861820,17.2),(67040,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67040,37.79,0.33,362,23943,70,NULL,NULL,'2MASX J10022613+5555122',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000145,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,150.608917,55.92019,0,NULL,61935112351,967736130,15120877,17),(67041,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67041,38.22,0.46,440,23944,70,NULL,NULL,'2MASX J10022764+0346547',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000174,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,150.615083,3.78189,0,NULL,60777890868,949654544,14838352,17.5),(67042,'D-Sigma','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67042,32.76,0.4,35.6,23945,75,NULL,'Edat, raw','NGC 3108',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000057,NULL,'12.78',1.8,'S0^0p','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,150.620958333,-31.67742,0.309,NULL,41947472533,655429258,10241082,12.78),(67043,'D-Sigma','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67043,33.09,0.4,41.5,23945,75,NULL,'Edat, cor','NGC 3108',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67044,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67044,32.73,0.45,35.2,23945,NULL,NULL,'K','NGC 3108',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67045,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67045,32.95,0.4,38.8,23945,NULL,NULL,'mean','NGC 3108',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67046,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67046,37.38,0.46,300,23946,70,NULL,NULL,'2MASXi J1002295+291146',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,150.623,29.19603,0.017,NULL,64162752110,1002543001,15664734,17.7),(67047,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67047,36.59,0.46,208,23947,70,NULL,NULL,'2MASXi J1002298+430003',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000142,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,150.624375,43.00097,0,NULL,64099377440,1001552772,15649262,17.1),(67048,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67048,37.53,0.46,320,23948,70,NULL,NULL,'2MASX J10023051+2739412',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000176,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,150.627041667,27.66153,0.065,NULL,64171741490,1002683460,15666929,17.1),(67049,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67049,37.39,0.46,301,23949,70,NULL,NULL,'2MASX J10023109+3144095',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,150.629625,31.736,0.041,NULL,64030464439,1000476006,15632437,17.4),(67050,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67050,33.01,NULL,40,23950,NULL,NULL,NULL,'UGC 05401',NULL,'2015AstBu..70....1K',2015,1,0.94,NULL,'G',0.000013,NULL,'16.1g',0.37,'Im:',NULL,NULL,NULL,NULL,1,150.630583,19.03292,0.057,NULL,60808116829,950126825,14845731,16.1),(67051,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67051,36.28,0.46,180,23951,70,NULL,NULL,'2MASX J10023175+1450429',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,150.6322917,14.84531,0.057,NULL,60854144572,950846008,14856968,16.3),(67052,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67052,37.79,0.33,362,23952,70,NULL,NULL,'2MASX J10023243+5554211',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000135,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,150.635291667,55.90586,0,NULL,61935096701,967735885,15120873,17.7),(67053,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67053,38.41,0.46,480,23953,70,NULL,NULL,'2MASX J10023317+4615041',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000185,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,150.638458333,46.25125,0,NULL,63976175295,999627738,15619183,17.4),(67054,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67054,37.49,0.46,315,23954,70,NULL,NULL,'2MASX J10023340+4946536',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,150.639041667,49.78158,0,NULL,63998809580,999981399,15624709,17.1),(67055,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67055,38.22,0.33,441,23955,70,NULL,NULL,'2MASX J10023372+0051337',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000082,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,150.640458333,0.85939,0.029,NULL,60775356974,949614952,14837733,18),(67056,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67056,29.31,0.49,7.27,23956,75,NULL,'IR','ESO 499- G 035',NULL,'2011yCatp016004901K',2011,1,1,'6dF DR1 has z = 0.014360.','G',0.000017,NULL,'16.05',0.1,'Sb:',NULL,NULL,NULL,NULL,1,150.641791667,-26.90169,0.173,NULL,42829571921,669212061,10456438,16.05),(67057,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67057,37.81,0.46,365,23957,70,NULL,NULL,'2MASX J10023400+3019135',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000145,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,150.64175,30.32036,0.025,NULL,64161031086,1002516110,15664314,17),(67058,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67058,36.46,0.27,196,23958,70,NULL,NULL,'2MASX J10023446+3705410',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000199,NULL,'16.1g',0.35,'E0',NULL,NULL,NULL,NULL,1,150.643666667,37.09456,0,NULL,64071332439,1001114569,15642415,16.1),(67059,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67059,37.43,0.46,306,23959,70,NULL,NULL,'2MASX J10023481+4158540',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,150.645,41.98178,0,NULL,64103445805,1001616340,15650255,18.2),(67060,'SNII optical','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 2003bn',NULL,67060,33.5,0.28,50.2,23960,NULL,NULL,'EPM E96','2MASX J10023529-2110531',NULL,'2009ApJ...696.1176J',2009,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,150.647,-21.18142,NULL,NULL,42284884987,660701327,10323458,15.8),(67061,'SNII optical','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 2003bn',NULL,67061,33.53,0.54,50.8,23960,NULL,NULL,'SCM, I','2MASX J10023529-2110531',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67062,'SNII optical','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 2003bn',NULL,67062,33.54,0.55,51.1,23960,NULL,NULL,'SCM, V','2MASX J10023529-2110531',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67063,'SNII optical','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 2003bn',NULL,67063,33.6,0.28,52.5,23960,NULL,NULL,'SCM, BVI','2MASX J10023529-2110531',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67064,'SNII optical','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 2003bn',NULL,67064,33.67,0.42,54.2,23960,NULL,NULL,'SCM, B','2MASX J10023529-2110531',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67065,'SNII optical','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 2003bn',NULL,67065,34.03,0.04,64,23960,NULL,NULL,'I, photospheric magnitude method','2MASX J10023529-2110531',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67066,'SNII optical','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 2003bn',NULL,67066,34.07,0.07,65.2,23960,NULL,NULL,'V, photospheric magnitude method','2MASX J10023529-2110531',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67067,'SNII optical','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 2003bn',NULL,67067,34.7,0.64,87.2,23960,NULL,NULL,'EPM D05','2MASX J10023529-2110531',NULL,'2009ApJ...696.1176J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67068,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67068,33.33,NULL,46.4,23961,NULL,NULL,NULL,'UGC 05403',NULL,'2015AstBu..70....1K',2015,1,1.26,NULL,'G',0.000023,NULL,'14.1g',0.61,'S0/a',NULL,NULL,NULL,NULL,1,150.648125,19.17692,0.057,NULL,60808166829,950127606,14845743,14.1),(67069,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67069,36.28,0.46,181,23962,70,NULL,NULL,'2MASX J10023594+1340229',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,150.649666667,13.67322,0.069,NULL,60851249567,950800774,14856262,16.6),(67070,'Tully est','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67070,28.97,0.8,6.2,23963,75,NULL,NULL,'UGCA 193',NULL,'1988NBGC.C....0000T',1988,1,4.31,NULL,'G',0.000003,NULL,'14.50',0.3,'Sdm','Field galaxy',NULL,NULL,NULL,1,150.65,-6.01361,0.057,NULL,41297171144,645268299,10082317,14.5),(67071,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67071,30.2,NULL,11,23963,NULL,NULL,'Dipole + Quadrupole + Octopole','UGCA 193',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67072,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67072,30.21,NULL,11,23963,NULL,NULL,'Dipole + Quadrupole','UGCA 193',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67073,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67073,30.22,NULL,11.1,23963,NULL,NULL,'Dipole','UGCA 193',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67074,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67074,30.35,NULL,11.8,23963,NULL,NULL,NULL,'UGCA 193',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67075,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67075,30.86,0.43,14.9,23963,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 193',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67076,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67076,38.22,0.33,441,23964,70,NULL,NULL,'2MASX J10023632+0050515',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000075,NULL,'17.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,150.651417,0.84767,0.029,NULL,60775365005,949615078,14837735,17.3),(67077,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67077,36.83,0.15,232,23965,70,NULL,NULL,'NGC 3099',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.000117,NULL,'14.9g',0.55,'cD;BrClG       AGN',NULL,NULL,NULL,NULL,1,150.6522917,32.70672,0,NULL,64059676156,1000932439,15639569,14.9),(67078,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67078,37.51,0.17,317,23966,70,NULL,NULL,'SDSS J100236.70+105115.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000164,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,150.652917,10.85439,0.057,NULL,60875695061,951182735,14862230,18.2),(67079,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67079,38,0.46,398,23967,70,NULL,NULL,'2MASX J10023778+0244315',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000147,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,150.6575,2.74222,0,NULL,60780614951,949697108,14839017,17.7),(67080,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67080,37.57,0.46,327,23968,70,NULL,NULL,'2MASX J10023785+2611042',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000164,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,150.6577917,26.18433,0.089,NULL,64159275190,1002488674,15663885,17),(67081,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67081,38.04,0.46,405,23969,70,NULL,NULL,'SDSS J100238.01+440659.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,150.658375,44.11656,0,NULL,64098975763,1001546496,15649164,18.3),(67082,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67082,38.02,0.46,401,23970,70,NULL,NULL,'2MASX J10023845+0339435',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,150.6602917,3.66206,0,NULL,60778410305,949662661,14838479,17.3),(67083,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67083,37.71,0.46,348,23971,70,NULL,NULL,'SDSS J100239.11+520101.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000159,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,150.663,52.01697,0.017,NULL,63996508940,999945452,15624147,18.3),(67084,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67084,36.91,0.46,241,23972,70,NULL,NULL,'2MASX J10024047+5016267',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000184,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,150.668583,50.27422,0,NULL,64000940036,1000014688,15625229,16.6),(67085,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67085,37.05,0.46,257,23973,70,NULL,NULL,'2MASX J10024051+5602147',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000149,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,150.669,56.03739,0,NULL,61934220774,967722199,15120659,17),(67086,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67086,37.42,0.33,305,23974,70,NULL,NULL,'2MASX J10024060+5002347',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000204,NULL,'16.1g',0.41,NULL,NULL,NULL,NULL,NULL,1,150.6692083,50.04306,0,NULL,63998824602,999981634,15624713,16.1),(67087,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67087,36.86,0.46,236,23975,70,NULL,NULL,'2MASX J10024072+3812259',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00017,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,150.669625,38.20725,0.009,NULL,64069113230,1001079894,15641873,16.5),(67088,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67088,36.83,0.15,232,23976,70,NULL,NULL,'2MASX J10024082+3239125',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000168,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,150.6702083,32.65347,0.025,NULL,64059681349,1000932521,15639570,18.1),(67089,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67089,37.75,0.33,356,23977,70,NULL,NULL,'2MASX J10024130+4601260',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,150.6720417,46.02386,0,NULL,63976146880,999627295,15619176,17.6),(67090,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67090,36.02,0.46,160,23978,70,NULL,NULL,'VII Zw 304 NOTES02',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000067,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,150.677333333,63.26214,0.037,NULL,62244339099,972567798,15196371,17.1),(67091,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67091,33.79,NULL,57.2,23979,NULL,NULL,'Dipole','ESO 316- G 018',NULL,'2010Ap&SS.325..163P',2010,1,3.07,'Stars superposed.','G',0.000027,NULL,'14.80',0.36,'Sbc',NULL,NULL,NULL,NULL,1,150.68,-42.08975,0.865,NULL,42092773036,657699578,10276555,14.8),(67092,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67092,33.79,NULL,57.2,23979,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 316- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67093,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67093,33.79,NULL,57.4,23979,NULL,NULL,'Dipole + Quadrupole','ESO 316- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67094,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67094,38.01,0.46,400,23980,70,NULL,NULL,'2MASX J10024506+0149225',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00017,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,150.6877917,1.82289,0.005,NULL,60772837766,949575590,14837118,17.6),(67095,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67095,38.13,0.46,423,23981,70,NULL,NULL,'2MASX J10024552+0125575',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,150.689625,1.43272,0,NULL,60774606685,949603229,14837550,18.1),(67096,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67096,37.76,0.46,357,23982,70,NULL,NULL,'2MASX J10024590+1750212',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000197,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,150.691083,17.83939,0.081,NULL,60862408033,950975125,14858986,17.1),(67097,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67097,35.88,0.67,150,23983,70,NULL,NULL,'2MASX J10024625-1531599',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,150.692791667,-15.53336,0.169,NULL,41203835020,643809922,10059530,15),(67098,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67098,37.5,0.46,317,23984,70,NULL,NULL,'2MASX J10024827+2847372',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,150.701,28.79386,0.021,NULL,64163391931,1002552998,15664890,17.4),(67099,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67099,37.51,0.17,317,23985,70,NULL,NULL,'2MASX J10024826+1048419',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,150.701125,10.81161,0.057,NULL,60875943233,951186613,14862290,17.3),(67100,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67100,36.83,0.15,232,23986,70,NULL,NULL,'2MASX J10024837+3253065',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00007,NULL,'16.1g',0.39,NULL,NULL,NULL,NULL,NULL,1,150.7015,32.88519,0.009,NULL,64060528543,1000945758,15639777,16.1),(67101,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67101,37.95,0.46,388,23987,70,NULL,NULL,'2MASX J10024915+0722059',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000134,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,150.7047917,7.36839,0.037,NULL,60876674966,951198046,14862469,17.2),(67102,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67102,35.2,0.61,110,23988,70,NULL,NULL,'MCG -03-26-013',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15',0.4,NULL,NULL,NULL,NULL,NULL,1,150.7065417,-15.8205,0.173,NULL,41203882078,643810657,10059541,15),(67103,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67103,37.38,0.46,299,23989,70,NULL,NULL,'2MASX J10024978+2022163',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000173,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,150.707417,20.37139,0.057,NULL,60807791915,950121748,14845652,17.1),(67104,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67104,36.52,0.46,201,23990,70,NULL,NULL,'2MASX J10025017+2208463',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,150.7092083,22.14631,0.069,NULL,63689325103,995145704,15549151,17),(67105,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67105,36.83,0.15,232,23991,70,NULL,NULL,'2MASX J10025058+3247435',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000063,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,150.71075,32.79533,0,NULL,64060536677,1000945885,15639779,17.4),(67106,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67106,36.81,0.33,231,23992,70,NULL,NULL,'SDSS J100250.62+513347.9',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000176,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,150.7109583,51.56333,0,NULL,63994371708,999912057,15623625,17.2),(67107,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67107,37.51,0.17,317,23993,70,NULL,NULL,'2MASX J10025206+1053519',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000192,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,150.7167917,10.89764,0.057,NULL,60875970157,951187033,14862297,17),(67108,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67108,36.46,0.27,196,23994,70,NULL,NULL,'SDSS J100253.22+370010.5',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',NULL,NULL,'15.5g',0.48,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,150.72175,37.00292,0,NULL,64071323857,1001114435,15642413,15.5),(67109,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67109,36.57,0.17,206,23995,70,NULL,NULL,'CGCG 266-011',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000097,NULL,'15.7',0.4,NULL,NULL,NULL,NULL,NULL,1,150.721958333,54.82867,0.005,NULL,61903163306,967236926,15113076,15.7),(67110,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67110,34.87,0.46,94,23996,70,NULL,NULL,'SDSS J100253.27+162656.8',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',NULL,NULL,'14.8g',0.6,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,150.722,16.44914,0.073,NULL,60867391307,951052989,14860202,14.8),(67111,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67111,36.57,0.46,206,23997,70,NULL,NULL,'2MASX J10025360+2534192',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000177,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,150.723375,25.57206,0.145,NULL,64159296805,1002489012,15663890,16.5),(67112,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67112,36.46,0.27,196,23998,70,NULL,NULL,'2MASX J10025441+3657473',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000177,NULL,'16.2g',0.32,NULL,NULL,NULL,NULL,NULL,1,150.72675,36.96328,0,NULL,64072016791,1001125262,15642582,16.2),(67113,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67113,37.44,0.46,308,23999,70,NULL,NULL,'2MASX J10025455+3058517',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,150.72725,30.98097,0.037,NULL,64031163561,1000486930,15632608,17.7),(67114,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67114,37.33,0.46,293,24000,70,NULL,NULL,'2MASX J10025484+2844192',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'18.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,150.728625,28.73861,0.021,NULL,64163403886,1002553185,15664893,18.1),(67115,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67115,36.83,0.15,232,24001,70,NULL,NULL,'2MASX J10025725+3238198',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00008,NULL,'15.7g',0.37,NULL,NULL,NULL,NULL,NULL,1,150.7385,32.63892,0.025,NULL,64059679815,1000932497,15639570,15.7),(67116,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67116,37.4,0.46,302,24002,70,NULL,NULL,'2MASX J10025938+3004528',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000143,NULL,'17.7g',0.15,'AGN',NULL,NULL,NULL,NULL,1,150.7474583,30.08128,0.033,NULL,64160846788,1002513231,15664269,17.7),(67117,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67117,36.26,0.59,179,24003,70,NULL,NULL,'2MASX J10030291-0904456',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,150.762167,-9.07942,0.233,NULL,41277300731,644957823,10077465,16.3),(67118,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67118,35.95,0.53,155,24004,70,NULL,NULL,'2MASX J10030310-1157570',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,150.762917,-11.96589,0.237,NULL,41280851351,645013302,10078332,16.1),(67119,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67119,37.06,0.46,258,24005,70,NULL,NULL,'2MASX J10030346+1640153',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',NULL,NULL,'16.63',0.43,NULL,NULL,NULL,NULL,NULL,1,150.7645417,16.671,0.065,NULL,60867372888,951052701,14860198,16.63),(67120,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67120,36.83,0.15,232,24006,70,NULL,NULL,'2MASX J10030358+3236528',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000073,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,150.7650417,32.61464,0.025,NULL,64076519627,1001195619,15643681,17.5),(67121,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67121,34.87,0.55,94.1,24007,70,NULL,NULL,'2MASX J10030397-1510000',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.2I',0.6,'HII',NULL,NULL,NULL,NULL,1,150.766541667,-15.16672,0.141,NULL,41190711511,643604867,10056326,13.2),(67122,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67122,34.76,0.47,89.5,24008,70,NULL,NULL,'MCG -06-22-012',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000093,NULL,'15',0.8,NULL,NULL,NULL,NULL,NULL,1,150.766541667,-37.4305,0.553,NULL,41975206778,655862605,10247853,15),(67123,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67123,34,0.69,63,24009,100,NULL,'mid-IR','IC 0587',NULL,'2013ApJ...771...88L',2013,1,1.3,NULL,'G',0.00009,NULL,'14.77',0.6,'SAB(r)bc pec?',NULL,NULL,NULL,NULL,1,150.7715417,-2.40003,0.089,NULL,41234274778,644285543,10066961,14.77),(67124,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67124,34.85,0.2,93.3,24009,74.4,NULL,NULL,'IC 0587',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67125,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67125,34.85,0.4,93.4,24009,NULL,NULL,'mean','IC 0587',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67126,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67126,35.25,0.47,112,24009,NULL,NULL,'H','IC 0587',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67127,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67127,37.22,0.46,277,24010,70,NULL,NULL,'2MASX J10030615+0948279',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000177,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,150.7757083,9.80764,0.069,NULL,60873061774,951141590,14861587,17.2),(67128,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67128,36.83,0.16,232,24011,70,NULL,NULL,'2MASX J10030616+0027147',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000119,NULL,'15.4g',0.56,'BrClG',NULL,NULL,NULL,NULL,1,150.775875,0.45411,0.041,NULL,60774780016,949605937,14837592,15.4),(67129,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67129,36.83,0.16,232,24012,70,NULL,NULL,'2MASX J10030669+0019137',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000095,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,150.777917,0.32039,0.041,NULL,60772009632,949562650,14836916,16.3),(67130,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67130,37.65,0.46,339,24013,70,NULL,NULL,'2MASX J10030674+1501403',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,150.7780417,15.02783,0.065,NULL,60852325936,950817592,14856524,16.6),(67131,'Brightest Stars','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67131,25.34,NULL,1.17,24014,NULL,NULL,'Photographic, M supergiants','NGC 3109',NULL,'1985ApJ...289..141E',1985,1,19.1,NULL,'G',0.000003,NULL,'10.39',3.7,'SB(s)m','Possible field galaxy',NULL,NULL,NULL,1,150.778667,-26.15958,0.145,0,42818624107,669041001,10453765,10.39),(67132,'Brightest Stars','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67132,26.9,NULL,2.4,24014,NULL,NULL,'Photographic','NGC 3109',NULL,'1984JRASC..78R.208D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67133,'Cepheids','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67133,25.05,NULL,1.02,24014,NULL,NULL,NULL,'NGC 3109',NULL,'1993AJ....105.1392D',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67134,'Cepheids','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67134,25.1,0.16,1.05,24014,NULL,NULL,'31, VI','NGC 3109',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67135,'Cepheids','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67135,25.1,0.16,1.05,24014,NULL,NULL,'MW GFG','NGC 3109',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67136,'Cepheids','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67136,25.2,0.04,1.1,24014,NULL,NULL,'BVRI','NGC 3109',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67137,'Cepheids','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67137,25.2,0.31,1.1,24014,NULL,NULL,'MW P02','NGC 3109',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67138,'Cepheids','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67138,25.26,0.22,1.13,24014,NULL,NULL,'HST KP Calibrated','NGC 3109',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67139,'Cepheids','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67139,25.26,0.22,1.13,24014,NULL,NULL,'4, BVRI','NGC 3109',NULL,'2000ApJS..128..431F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67140,'Cepheids','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67140,25.27,0.12,1.13,24014,NULL,NULL,'LMC W01','NGC 3109',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67141,'Cepheids','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67141,25.3,0.04,1.15,24014,NULL,NULL,'BVRI+','NGC 3109',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67142,'Cepheids','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67142,25.38,0.22,1.19,24014,NULL,NULL,'MW HIPP','NGC 3109',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67143,'Cepheids','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67143,25.45,0.09,1.23,24014,NULL,NULL,'69, JHKs, GAL PL','NGC 3109',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67144,'Cepheids','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67144,25.47,0.06,1.24,24014,NULL,NULL,'69, JHKs, LMC PL','NGC 3109',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67145,'Cepheids','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67145,25.49,0.06,1.25,24014,NULL,NULL,'69, JHKs, GAL+LMC PL','NGC 3109',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67146,'Cepheids','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67146,25.5,NULL,1.26,24014,NULL,NULL,NULL,'NGC 3109',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67147,'Cepheids','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67147,25.5,0.2,1.26,24014,NULL,NULL,'21, BV','NGC 3109',NULL,'1992AJ....103.1151C',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67148,'Cepheids','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67148,25.54,0.28,1.28,24014,NULL,NULL,'LMC VIHJK','NGC 3109',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67149,'Cepheids','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67149,25.54,0.03,1.28,24014,NULL,NULL,'76, VI','NGC 3109',NULL,'2006ApJ...648..366P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67150,'Cepheids','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67150,25.57,0.02,1.3,24014,NULL,NULL,'77, JK','NGC 3109',NULL,'2006ApJ...648..375S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67151,'Cepheids','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67151,25.67,0.16,1.36,24014,NULL,NULL,'24, BVRI','NGC 3109',NULL,'1997AJ....114..976M',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67152,'Cepheids','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67152,25.69,0.06,1.37,24014,74.4,NULL,NULL,'NGC 3109',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67153,'Cepheids','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67153,25.94,NULL,1.54,24014,NULL,NULL,'29, B','NGC 3109',NULL,'1991PASP..103..933M',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67154,'Cepheids','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67154,25.98,0.15,1.57,24014,NULL,NULL,'Photographic, 5','NGC 3109',NULL,'1985AJ.....90.1967D',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67155,'Cepheids','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67155,26,NULL,1.58,24014,NULL,NULL,'29, B','NGC 3109',NULL,'1988AJ.....96.1599S',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67156,'Cepheids','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67156,26.1,0.08,1.66,24014,NULL,18.47,'5, V, Photographic','NGC 3109',NULL,'1987SAAOC..11..125W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67157,'Cepheids','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67157,26.35,NULL,1.86,24014,NULL,NULL,'Photographic, APPARENT BLUE m-M','NGC 3109',NULL,'1988PASP..100..935S',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67158,'FGLR','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67158,25.55,0.09,1.27,24014,NULL,NULL,NULL,'NGC 3109',NULL,'2014ApJ...785..151H',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67159,'GCLF','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67159,26.64,NULL,2.13,24014,NULL,NULL,'Photographic','NGC 3109',NULL,'1988IAUS..126..543B',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67160,'PNLF','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67160,25.96,0.4,1.6,24014,NULL,NULL,'7','NGC 3109',NULL,'1992AJ....103...54R',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67161,'PNLF','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67161,26.26,0.41,1.79,24014,NULL,NULL,'HST KP Calibrated, max. D','NGC 3109',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67162,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67162,25.42,0.05,1.21,24014,NULL,NULL,'K','NGC 3109',NULL,'2011AJ....141..194G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67163,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67163,25.45,0.15,1.23,24014,NULL,NULL,NULL,'NGC 3109',NULL,'1993ApJ...408..409L',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67164,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67164,25.45,0.1,1.23,24014,NULL,NULL,'I','NGC 3109',NULL,'1993ApJ...417..553L',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67165,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67165,25.49,0.05,1.25,24014,NULL,NULL,'J','NGC 3109',NULL,'2011AJ....141..194G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67166,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67166,25.5,0.04,1.26,24014,NULL,NULL,'I','NGC 3109',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67167,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67167,25.52,0.06,1.27,24014,NULL,NULL,NULL,'NGC 3109',NULL,'2002AJ....124..213M',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67168,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67168,25.52,0.05,1.27,24014,NULL,NULL,NULL,'NGC 3109',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67169,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67169,25.55,0.03,1.29,24014,NULL,NULL,'I','NGC 3109',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67170,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67170,25.56,0.05,1.29,24014,NULL,NULL,'I','NGC 3109',NULL,'2007ApJ...661..815R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67171,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67171,25.6,0.09,1.32,24014,NULL,NULL,'HST KP Calibrated','NGC 3109',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67172,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67172,25.61,0.1,1.32,24014,NULL,NULL,'VI','NGC 3109',NULL,'2008AJ....136.2332H',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67173,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67173,25.61,NULL,1.32,24014,NULL,NULL,NULL,'NGC 3109',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67174,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67174,25.61,NULL,1.32,24014,NULL,NULL,'DA90','NGC 3109',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67175,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67175,25.62,0.13,1.33,24014,NULL,NULL,NULL,'NGC 3109',NULL,'2002A&A...389..812K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67176,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67176,25.62,0.1,1.33,24014,NULL,NULL,'I','NGC 3109',NULL,'1999AJ....117..881M',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67177,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67177,25.62,0.1,1.33,24014,NULL,NULL,'I','NGC 3109',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67178,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67178,25.62,0.14,1.33,24014,NULL,NULL,NULL,'NGC 3109',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67179,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67179,25.63,0.03,1.34,24014,NULL,NULL,NULL,'NGC 3109',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67180,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67180,25.65,NULL,1.35,24014,NULL,NULL,'theory','NGC 3109',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67181,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67181,25.69,0.06,1.37,24014,74.4,NULL,NULL,'NGC 3109',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67182,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67182,25.69,NULL,1.37,24014,NULL,NULL,'Yale','NGC 3109',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67183,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67183,25.74,NULL,1.41,24014,NULL,NULL,'K97','NGC 3109',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67184,'Orbital Mech.','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67184,26.22,0.06,1.75,24014,NULL,NULL,NULL,'NGC 3109',NULL,'2013A&A...559L..11B',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67185,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67185,25.68,NULL,1.37,24014,NULL,NULL,'LEDA [April 2006]','NGC 3109',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67186,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67186,25.69,0.06,1.37,24014,74.4,NULL,NULL,'NGC 3109',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67187,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67187,26.22,0.4,1.8,24014,75,NULL,'B','NGC 3109',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67188,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67188,36.83,0.16,232,24015,70,NULL,NULL,'SDSS J100307.04+003025.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000079,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,150.779375,0.50697,0.041,NULL,60774792803,949606137,14837595,17.7),(67189,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67189,35.42,0.47,121,24016,70,NULL,NULL,'MCG -02-26-025',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000097,NULL,'15',0.5,NULL,NULL,NULL,NULL,NULL,1,150.779583,-15.47619,0.169,NULL,41203841814,643810028,10059531,15),(67190,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67190,37.19,0.46,274,24017,70,NULL,NULL,'2MASX J10030770+0321017',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000176,NULL,'16.1g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,150.782125,3.35036,0,NULL,60778436100,949663064,14838485,16.1),(67191,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67191,38.26,0.46,448,24018,70,NULL,NULL,'2MASX J10030776+4710537',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,150.782167,47.1815,0,NULL,64005920761,1000092511,15626445,17.7),(67192,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67192,37.05,0.33,257,24019,70,NULL,NULL,'2MASX J10030783+0002427',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000104,NULL,'15.7g',0.4,'E0',NULL,NULL,NULL,NULL,1,150.7827083,0.04517,0.057,NULL,60771814554,949559602,14836868,15.7),(67193,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67193,37.91,0.46,382,24020,70,NULL,NULL,'SDSS J100308.35+001030.7',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000073,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,150.784833333,0.17522,0.057,NULL,60771815666,949559619,14836869,17.7),(67194,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67194,37.42,0.33,305,24021,70,NULL,NULL,'2MASX J10030861+5000576',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,150.785833,50.01589,0,NULL,63998826703,999981667,15624713,17.2),(67195,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67195,37.38,0.46,299,24022,70,NULL,NULL,'2MASX J10030931+4638427',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00014,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,150.789041667,46.64517,0,NULL,64005696546,1000089008,15626390,18.1),(67196,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','PS1 SN PS11s','N',67196,41.49,0.22,1420,24023,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11s HOST',0.4012,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67197,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67197,35.67,0.9,136,24024,70,NULL,NULL,'2MASX J10031053-1511190',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,150.793917,-15.18872,0.169,NULL,41201996574,643781196,10059081,15.1),(67198,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67198,35.56,0.33,130,24025,70,NULL,NULL,'CGCG 064-045',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000215,NULL,'15.3g',0.42,'S0','Group member',NULL,NULL,NULL,1,150.7985,12.12667,0.057,NULL,60872478235,951132472,14861444,15.3),(67199,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67199,36.61,0.46,209,24026,70,NULL,NULL,'2MASX J10031285+5233094',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000184,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,150.8032917,52.55261,0,NULL,63996652027,999947687,15624182,16.2),(67200,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67200,37.51,0.17,317,24027,70,NULL,NULL,'2MASX J10031321+1058099',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,150.8050417,10.96947,0.057,NULL,60875984676,951187260,14862300,17.1),(67201,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','PS1 SN PS10n','N',67201,42.33,0.13,2000,24028,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10n HOST',0.4612,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67202,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67202,37.97,0.46,392,24029,70,NULL,NULL,'2MASX J10031515+1916359',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00014,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,150.813,19.27681,0.057,NULL,60808119643,950126869,14845732,17.6),(67203,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67203,36.57,0.17,206,24030,70,NULL,NULL,'2MASX J10031602+5446227',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000173,NULL,'16.1g',0.41,NULL,NULL,NULL,NULL,NULL,1,150.8165,54.77311,0.005,NULL,61903169100,967237017,15113078,16.1),(67204,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67204,38.31,0.33,459,24031,70,NULL,NULL,'SDSS J100316.07+032838.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,150.817,3.47725,0,NULL,60778600431,949665631,14838525,17.7),(67205,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67205,36.41,0.46,191,24032,70,NULL,NULL,'2MASX J10031609+2347569',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000191,NULL,'15.7g',0.46,NULL,NULL,NULL,NULL,NULL,1,150.817083333,23.79931,0.097,NULL,63690092552,995157696,15549339,15.7),(67206,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','PS1 SN PS11aj','N',67206,38.82,0.22,524,24033,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11aj HOST',0.1068,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67207,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67207,36.62,0.46,211,24034,70,NULL,NULL,'2MASX J10031656+0029257',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000075,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,150.819166667,0.49056,0.041,NULL,60774792116,949606126,14837595,17.2),(67208,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67208,33.49,0.69,49.8,24035,100,NULL,'mid-IR','MCG -02-26-027',NULL,'2013ApJ...771...88L',2013,1,1.7,NULL,'G',0.000027,NULL,'14.16',0.7,'SB(r)cd        HII',NULL,NULL,NULL,NULL,1,150.820791667,-14.94511,0.173,NULL,41190936057,643608375,10056380,14.16),(67209,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67209,34.32,0.4,73.1,24035,NULL,NULL,'mean','MCG -02-26-027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67210,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67210,34.55,0.47,81.1,24035,NULL,NULL,'H','MCG -02-26-027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67211,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67211,34.55,0.46,81.3,24035,NULL,NULL,'J','MCG -02-26-027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67212,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67212,38.31,0.33,459,24036,70,NULL,NULL,'2MASX J10031745+0325177',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,150.822791667,3.42153,0,NULL,60778557132,949664955,14838514,17.8),(67213,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67213,37.44,0.46,308,24037,70,NULL,NULL,'SDSS J100317.90+350640.4',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000048,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,150.824625,35.11125,0,NULL,64060942207,1000952221,15639878,17.5),(67214,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67214,36.38,0.46,188,24038,70,NULL,NULL,'2MASX J10031808+2947162',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,150.8255417,29.78786,0.025,NULL,64163713241,1002558019,15664969,17.4),(67215,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67215,37.49,0.46,315,24039,70,NULL,NULL,'SDSS J100318.35+183420.3',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00018,NULL,'17.0g',0.23,'AGN',NULL,NULL,NULL,NULL,1,150.8265,18.57231,0.069,NULL,60806894376,950107724,14845433,17),(67216,'Tully est','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67216,32.14,0.8,26.8,24040,75,NULL,NULL,'ESO 092- G 006',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000021,NULL,'13.43',1,'SB(r)b',NULL,NULL,NULL,NULL,1,150.827667,-64.96744,NULL,NULL,40686400008,635725000,9933203,13.43),(67217,'Tully est','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67217,33.06,0.8,41,24041,75,NULL,NULL,'UGCA 195',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000021,NULL,'14.39',1.2,'SB(s)c',NULL,NULL,NULL,NULL,1,150.828833,-21.43075,NULL,NULL,42279691934,660620186,10322190,14.39),(67218,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67218,35.71,0.46,138,24042,70,NULL,NULL,'2MASX J10031905+0753499',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000162,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,150.82925,7.89739,0.017,NULL,60879572846,951243325,14863176,16.5),(67219,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67219,36.57,0.17,206,24043,70,NULL,NULL,'2MASX J10031898+5441076',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000136,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,150.829375,54.6855,0,NULL,61903147369,967236677,15113073,16.7),(67220,'CMD','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67220,27.95,NULL,3.89,24044,NULL,NULL,NULL,'NGC 3077',NULL,'2012ApJ...748...47M',2012,1,5.4,NULL,'G',0.000013,NULL,'10.61',4.5,'I0 pec         HII','Probable group member',NULL,NULL,NULL,1,150.8294583,68.73392,0.213,NULL,62129968090,970780751,15168449,10.61),(67221,'SBF','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67221,27.9,0.07,3.81,24044,74.4,NULL,NULL,'NGC 3077',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67222,'SBF','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67222,28.03,0.13,4.04,24044,NULL,NULL,'I','NGC 3077',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67223,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67223,27.82,0.1,3.66,24044,NULL,NULL,NULL,'NGC 3077',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67224,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67224,27.84,0.04,3.7,24044,NULL,NULL,'I','NGC 3077',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67225,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67225,27.9,0.07,3.81,24044,74.4,NULL,NULL,'NGC 3077',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67226,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67226,27.91,NULL,3.82,24044,NULL,NULL,NULL,'NGC 3077',NULL,'2003A&A...398..479K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67227,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67227,27.92,0.02,3.83,24044,NULL,NULL,'I','NGC 3077',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67228,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67228,27.93,0.14,3.85,24044,NULL,NULL,NULL,'NGC 3077',NULL,'2001ApJ...555..280S',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67229,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67229,26.59,0.4,2.1,24044,75,NULL,'B','NGC 3077',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67230,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67230,28.11,NULL,4.19,24044,NULL,NULL,'LEDA [April 2006]','NGC 3077',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67231,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67231,36.83,0.59,233,24045,70,NULL,NULL,'2MASX J10032009-0748194',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.2,NULL,NULL,NULL,NULL,NULL,1,150.833667,-7.80536,0.149,NULL,41279837673,644997463,10078085,14.4),(67232,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67232,37.62,0.46,334,24046,70,NULL,NULL,'2MASX J10032028+4343296',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000195,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,150.834416667,43.72503,0,NULL,64099102776,1001548480,15649195,17.1),(67233,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67233,37.26,0.46,284,24047,70,NULL,NULL,'2MASX J10032041+1303335',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000162,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,150.835125,13.05925,0.057,NULL,60843279637,950676244,14854316,16.3),(67234,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67234,38.12,0.23,421,24048,70,NULL,NULL,'2MASX J10032206+0250007',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00018,NULL,'17.1g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,150.8419583,2.83364,0,NULL,60779745669,949683526,14838805,17.1),(67235,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67235,38.22,0.33,440,24049,70,NULL,NULL,'2MASX J10032270+0050257',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000095,NULL,'17.3g',0.26,'AGN',NULL,NULL,NULL,NULL,1,150.844625,0.84047,0.033,NULL,60775247907,949613248,14837707,17.3),(67236,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67236,35.56,0.33,130,24050,70,NULL,NULL,'CGCG 064-046',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000153,NULL,'15.6g',0.45,'E0','Group member',NULL,NULL,NULL,1,150.854125,12.09822,0.057,NULL,60872490334,951132661,14861447,15.6),(67237,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67237,35.72,0.59,139,24051,70,NULL,NULL,'2MASX J10032502-1557594',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.2,NULL,NULL,NULL,NULL,NULL,1,150.85425,-15.96661,0.145,NULL,41204665981,643822905,10059732,14.6),(67238,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67238,36.12,0.58,168,24052,70,NULL,NULL,'2MASX J10032512-8212245',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,150.855083333,-82.20686,0.237,NULL,39753508053,621148563,9705446,16.8),(67239,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','PS1 SN PS10v',NULL,67239,38.51,0.11,457,24053,73.8,NULL,'SALT 2 (SNANA)','SDSS J100325.83+010143.3',0.0996,'2014ApJ...795...44R',2014,1,0.25,NULL,'G',0.000297,NULL,'19.40',0.11,NULL,NULL,NULL,NULL,NULL,1,150.857625,1.02869,0.029,NULL,60775443475,949616304,14837754,19.4),(67240,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67240,38.48,0.46,496,24054,70,NULL,NULL,'2MASX J10032598+3106008',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,150.858333,31.10028,0.045,NULL,64031217151,1000487767,15632621,17.5),(67241,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67241,37.42,0.46,304,24055,70,NULL,NULL,'2MASX J10032840+2732140',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,150.868333,27.53714,0.065,NULL,64171637921,1002681842,15666903,17.2),(67242,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67242,35.87,0.53,149,24056,70,NULL,NULL,'2MASX J10032864-1530044',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.12',0.4,NULL,NULL,NULL,NULL,NULL,1,150.869375,-15.50136,0.173,NULL,41201979026,643780922,10059076,16.12),(67243,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67243,35.25,NULL,112,24057,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05413',NULL,'2010Ap&SS.325..163P',2010,1,1.06,NULL,'G',0.000013,NULL,'16.5g',0.16,'Sd',NULL,NULL,NULL,NULL,1,150.873041667,13.10333,0.057,NULL,60843280433,950676256,14854316,16.5),(67244,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67244,35.26,NULL,113,24057,NULL,NULL,'Dipole + Quadrupole','UGC 05413',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67245,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67245,35.27,NULL,114,24057,NULL,NULL,'Dipole','UGC 05413',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67246,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67246,35.35,NULL,118,24057,NULL,NULL,NULL,'UGC 05413',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67247,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67247,35.37,0.49,118,24057,75,NULL,'IR','UGC 05413',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67248,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67248,35.26,0.46,113,24058,70,NULL,NULL,'CGCG 182-065',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00009,NULL,'15.5g',0.27,'S0',NULL,NULL,NULL,NULL,1,150.874917,37.45964,0,NULL,64069885840,1001091966,15642061,15.5),(67249,'IRAS','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67249,32.77,0.8,35.8,24059,75,NULL,'MAT, I','IC 2536',NULL,'1997ApJS..109..333W',1997,1,1.9,'RC3 gives v = 5384 +/- 19 km/sec.','G',0.000033,NULL,'14.53',0.4,'SBc pec sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,150.875916667,-33.94975,0.505,NULL,41971819831,655809684,10247026,14.53),(67250,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67250,32.21,0.43,27.7,24059,75,NULL,'3.6 micron, color + selection bias corrected','IC 2536',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67251,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67251,32.3,0.4,28.8,24059,75,NULL,NULL,'IC 2536',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67252,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67252,32.32,0.32,29.1,24059,85,NULL,'I, raw','IC 2536',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67253,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67253,32.33,0.32,29.3,24059,85,NULL,'I, inv','IC 2536',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67254,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67254,32.37,0.43,29.8,24059,75,NULL,'3.6 micron, color corrected','IC 2536',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67255,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67255,32.5,0.2,31.6,24059,74.4,NULL,NULL,'IC 2536',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67256,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67256,32.58,0.49,32.8,24059,75,NULL,'IR','IC 2536',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67257,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67257,32.6,0.43,33,24059,75,NULL,'MAT, I, raw','IC 2536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67258,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67258,32.69,0.43,34.6,24059,75,NULL,'MAT, I, inv','IC 2536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67259,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67259,32.9,0.43,37.9,24059,75,NULL,'MAT, I, cor','IC 2536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67260,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67260,33.2,0.12,43.7,24059,NULL,NULL,NULL,'IC 2536',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67261,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67261,37.95,0.46,389,24060,70,NULL,NULL,'2MASX J10033022+4302037',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,150.876,43.0345,0,NULL,64098830501,1001544226,15649128,17.5),(67262,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67262,36.71,0.46,220,24061,70,NULL,NULL,'2MASX J10033162+2552211',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00018,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,150.881917,25.87272,0.145,NULL,64159471149,1002491736,15663933,16.3),(67263,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67263,38.22,0.33,440,24062,70,NULL,NULL,'SDSS J100331.85+005050.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000074,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,150.88275,0.84733,0.033,NULL,60775258729,949613417,14837709,18.7),(67264,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67264,35.86,0.46,149,24063,70,NULL,NULL,'2MASX J10033205+6901422',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'15.91',0.38,NULL,NULL,NULL,NULL,NULL,1,150.883917,69.02836,0.133,NULL,62129637811,970775590,15168368,15.91),(67265,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67265,37.81,0.46,365,24064,70,NULL,NULL,'SDSS J100332.17+131740.4',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.27,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,150.884083,13.29456,0.057,NULL,60843312671,950676760,14854324,17.1),(67266,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67266,36.19,0.53,173,24065,70,NULL,NULL,'2MASX J10033238-1527594',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,150.8849583,-15.46656,0.173,NULL,41201976496,643780882,10059076,15.7),(67267,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67267,30.83,NULL,14.7,24066,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 3136A',NULL,'2010Ap&SS.325..163P',2010,1,2.24,NULL,'G',0.000027,NULL,'15.54',0.22,'IB(s)m? sp',NULL,NULL,NULL,NULL,1,150.88575,-67.44847,NULL,NULL,40692977640,635827775,9934808,15.54),(67268,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67268,30.85,NULL,14.8,24066,NULL,NULL,'Dipole + Quadrupole','NGC 3136A',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67269,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67269,30.88,NULL,15,24066,NULL,NULL,'Dipole','NGC 3136A',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67270,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67270,37.95,0.46,388,24067,70,NULL,NULL,'2MASX J10033303+3132170',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,150.887708333,31.53806,0.045,NULL,64030418636,1000475291,15632426,17.7),(67271,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67271,37.14,0.46,268,24068,70,NULL,NULL,'2MASX J10033314+4137405',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000184,NULL,'16.1g',0.44,'E0',NULL,NULL,NULL,NULL,1,150.888125,41.628,0,NULL,64104839420,1001638115,15650595,16.1),(67272,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67272,37.22,0.46,278,24069,70,NULL,NULL,'2MASX J10033333+4041255',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,150.888833,40.69047,0.005,NULL,64104391883,1001631123,15650486,18.2),(67273,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67273,37.26,0.46,283,24070,70,NULL,NULL,'2MASX J10033393+4935345',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,150.891416667,49.59292,0,NULL,63999038070,999984969,15624765,17.2),(67274,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67274,37.55,0.33,324,24071,70,NULL,NULL,'2MASX J10033413+4404547',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000198,NULL,'16.1g',0.44,NULL,NULL,NULL,NULL,NULL,1,150.892125,44.08183,0,NULL,64098962907,1001546295,15649160,16.1),(67275,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67275,37.13,0.46,267,24072,70,NULL,NULL,'2MASX J10033413+5222435',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00015,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,150.892333,52.37872,0,NULL,63996641278,999947519,15624179,17.3),(67276,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67276,35.74,0.56,140,24073,70,NULL,NULL,'2MASX J10033480-1558004',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'16.44',0.3,NULL,NULL,NULL,NULL,NULL,1,150.895041667,-15.96697,0.141,NULL,41204676077,643823063,10059735,16.44),(67277,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 1993ag',NULL,67277,35.95,0.17,145,24074,74.2,NULL,'SALT 2','2MASX J10033546-3527410',0.071,'2010ApJ...716..712A',2010,1,0.4,'6dF DR1 has z = 0.049227.','G',0.00015,NULL,'15.60',0.24,'E3/S01',NULL,NULL,NULL,NULL,1,150.89775,-35.46139,0.601,NULL,41972672880,655823013,10247234,15.6),(67278,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 1993ag',NULL,67278,36.44,0.22,181,24074,72,NULL,NULL,'2MASX J10033546-3527410',0.071,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67279,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 1993ag',NULL,67279,36.58,0.19,193,24074,70,NULL,'SALT 2','2MASX J10033546-3527410',0.071,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67280,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 1993ag',NULL,67280,36.65,0.11,200,24074,65,NULL,'SALT2','2MASX J10033546-3527410',0.071,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67281,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 1993ag',NULL,67281,36.62,0.19,201,24074,73.8,NULL,'SALT 2 (SNANA)','2MASX J10033546-3527410',0.0493,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67282,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 1993ag',NULL,67282,36.72,0.06,207,24074,72,NULL,NULL,'2MASX J10033546-3527410',0.071,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67283,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 1993ag',NULL,67283,36.58,0.08,207,24074,74.4,NULL,NULL,'2MASX J10033546-3527410',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67284,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 1993ag',NULL,67284,36.77,0.15,211,24074,70,NULL,'SALT','2MASX J10033546-3527410',0.071,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67285,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 1993ag',NULL,67285,36.8,0.17,214,24074,65,NULL,'MLCS','2MASX J10033546-3527410',0.071,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67286,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 1993ag',NULL,67286,36.68,0.12,217,24074,70.8,NULL,NULL,'2MASX J10033546-3527410',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67287,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 1993ag',NULL,67287,36.83,0.06,217,24074,70,NULL,NULL,'2MASX J10033546-3527410',0.071,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67288,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 1993ag',NULL,67288,36.84,0.18,218,24074,65,NULL,'SALT2','2MASX J10033546-3527410',0.071,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67289,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 1993ag',NULL,67289,37.04,0.13,223,24074,65,NULL,'MLCS2k2','2MASX J10033546-3527410',0.071,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67290,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 1993ag',NULL,67290,36.91,0.14,225,24074,65,NULL,'SALT','2MASX J10033546-3527410',0.071,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67291,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 1993ag',NULL,67291,36.88,0.06,238,24074,60,NULL,'M(V) = -19.47 mag','2MASX J10033546-3527410',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67292,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 1993ag',NULL,67292,36.89,0.06,239,24074,60,NULL,'M(I) = -19.19 mag','2MASX J10033546-3527410',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67293,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 1993ag',NULL,67293,37.04,0.11,239,24074,65,NULL,'MLCS2k2','2MASX J10033546-3527410',0.071,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67294,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 1993ag',NULL,67294,37.07,0.14,242,24074,65,NULL,'MLCS2k2','2MASX J10033546-3527410',0.071,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67295,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 1993ag',NULL,67295,37.08,0.19,243,24074,65,NULL,NULL,'2MASX J10033546-3527410',0.071,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67296,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 1993ag',NULL,67296,37.08,0.04,243,24074,65,NULL,'SALT','2MASX J10033546-3527410',0.071,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67297,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 1993ag',NULL,67297,37.09,0.17,244,24074,65,NULL,'MLCS31','2MASX J10033546-3527410',0.071,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67298,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 1993ag',NULL,67298,36.94,0.08,244,24074,60,NULL,'M(B) = -19.48 mag','2MASX J10033546-3527410',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67299,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 1993ag',NULL,67299,37.1,0.16,246,24074,65,NULL,'MLCS17','2MASX J10033546-3527410',0.071,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67300,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 1993ag',NULL,67300,37.11,0.19,247,24074,65,NULL,'Template','2MASX J10033546-3527410',0.071,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67301,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 1993ag',NULL,67301,37.1,0.14,263,24074,60,NULL,NULL,'2MASX J10033546-3527410',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67302,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 1993ag',NULL,67302,37.5,0.04,296,24074,70,NULL,'SALT 2','2MASX J10033546-3527410',0.071,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67303,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67303,36.49,0.46,198,24075,70,NULL,NULL,'2MASX J10033615+1214025',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,150.900708333,12.23414,0.069,NULL,60842884441,950670069,14854219,16.8),(67304,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67304,37.42,0.46,305,24076,70,NULL,NULL,'2MASX J10033626+3456020',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,150.90125,34.93381,0.005,NULL,64061014141,1000953345,15639896,17),(67305,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67305,36.57,0.17,206,24077,70,NULL,NULL,'2MASX J10033756+5414270',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000153,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,150.906625,54.24092,0,NULL,61903380123,967240314,15113129,16.4),(67306,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67306,37.73,0.46,351,24078,70,NULL,NULL,'2MASX J10033899+2901191',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000157,NULL,'16.6g',0.35,'E',NULL,NULL,NULL,NULL,1,150.91225,29.022,0.009,NULL,64163301036,1002551578,15664868,16.6),(67307,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67307,38.25,0.46,446,24079,70,NULL,NULL,'2MASX J10033912+5004135',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,150.913125,50.0705,0,NULL,64000902470,1000014101,15625220,17.6),(67308,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67308,37.65,0.33,339,24080,70,NULL,NULL,'2MASX J10033924+1503105',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,150.913458333,15.05292,0.057,NULL,60852502353,950820349,14856567,NULL),(67309,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67309,34.84,0.46,93,24081,70,NULL,NULL,'CGCG 153-012',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00015,NULL,'15.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,150.917625,31.16181,0.045,NULL,64031207478,1000487616,15632619,15.6),(67310,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67310,37.02,0.46,254,24082,70,NULL,NULL,'2MASXi J1003409+165853',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,150.920625,16.98158,0.061,NULL,60863891075,950998298,14859348,17.6),(67311,'IRAS','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67311,30.35,0.8,11.8,24083,75,NULL,'MAT, I','UGCA 196',NULL,'1997ApJS..109..333W',1997,1,3.2,'Confused HIPASS source','G',0.00001,NULL,'13.30',1.3,'(R\')SA(s)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,150.924333,-27.02781,0.157,NULL,42829484684,669210698,10456417,13.3),(67312,'Tully est','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67312,30.4,0.8,12,24083,75,NULL,NULL,'UGCA 196',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67313,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67313,30.5,0.39,12.6,24083,73,NULL,'opt','UGCA 196',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67314,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67314,31.06,0.32,16.3,24083,85,NULL,'I, inv','UGCA 196',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67315,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67315,31.09,0.32,16.5,24083,85,NULL,'I, raw','UGCA 196',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67316,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67316,31.14,0.4,16.9,24083,NULL,NULL,NULL,'UGCA 196',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67317,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67317,31.31,0.2,18.3,24083,74.4,NULL,NULL,'UGCA 196',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67318,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67318,31.43,0.43,19.3,24083,75,NULL,'MAT, I, inv','UGCA 196',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67319,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67319,31.45,0.43,19.5,24083,75,NULL,'MAT, I, raw','UGCA 196',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67320,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67320,31.59,0.6,20.8,24083,NULL,NULL,NULL,'UGCA 196',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67321,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67321,31.8,0.4,22.9,24083,73,NULL,'opt','UGCA 196',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67322,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67322,31.81,0.43,23,24083,75,NULL,'MAT, I, cor','UGCA 196',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67323,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67323,31.88,0.52,23.8,24083,NULL,NULL,'Malmquist cor.','UGCA 196',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67324,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67324,37.75,0.46,355,24084,70,NULL,NULL,'2MASX J10034181-0034011',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000082,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,150.924291667,-0.56689,0.089,NULL,41230389633,644224838,10066013,17.3),(67325,'Brightest Stars','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67325,27.76,NULL,3.56,24085,NULL,NULL,NULL,'The Garland',NULL,'1991SvAL...17..383S',1991,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'Im',NULL,NULL,NULL,NULL,1,150.925,68.69333,0.213,NULL,62129868875,970779201,15168425,NULL),(67326,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67326,27.91,0.24,3.82,24085,NULL,NULL,'I','The Garland',NULL,'2002A&A...383..125K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67327,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67327,37.28,0.46,286,24086,70,NULL,NULL,'2MASX J10034272+3352031',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000136,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,150.928167,33.86739,0.021,NULL,64063532415,1000992693,15640510,17.3),(67328,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67328,36.99,0.33,249,24087,70,NULL,NULL,'2MASX J10034326+6144222',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000199,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,150.930167,61.73936,0.029,NULL,61911855539,967372742,15115199,16.4),(67329,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67329,37.74,0.46,353,24088,70,NULL,NULL,'2MASX J10034513+1812014',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000141,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,150.9379583,18.20028,0.077,NULL,60806062158,950094721,14845230,18.1),(67330,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67330,37.65,0.33,339,24089,70,NULL,NULL,'2MASX J10034549+1457081',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000123,NULL,'17.01',0.25,NULL,NULL,NULL,NULL,NULL,1,150.939375,14.95214,0.057,NULL,60852530557,950820789,14856574,17.01),(67331,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67331,37.05,0.33,257,24090,70,NULL,NULL,'2MASX J10034550+0001478',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000097,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,150.9394583,0.02994,0.049,NULL,60771900154,949560939,14836889,17.1),(67332,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67332,37.07,0.46,260,24091,70,NULL,NULL,'2MASX J10034639+1117075',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000191,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,150.943375,11.28558,0.061,NULL,60876089177,951188893,14862326,16.5),(67333,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67333,35.99,0.46,158,24092,70,NULL,NULL,'CGCG 093-033',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.00022,NULL,'15.4',1,NULL,NULL,NULL,NULL,NULL,1,150.9439583,16.43789,0.073,NULL,60867542562,951055352,14860239,15.4),(67334,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67334,37.95,0.46,388,24093,70,NULL,NULL,'2MASX J10034673+3255131',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,150.944583,32.92044,0.009,NULL,64060003984,1000937562,15639649,18.3),(67335,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67335,36.83,0.15,232,24094,70,NULL,NULL,'SDSS J100346.80+322424.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,150.945041667,32.40669,0.025,NULL,64076554109,1001196157,15643689,18.3),(67336,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67336,35.86,0.46,148,24095,70,NULL,NULL,'2MASX J10034682+1323401',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000168,NULL,'15.7g',0.46,'E',NULL,NULL,NULL,NULL,1,150.945083,13.39447,0.061,NULL,60846012298,950718942,14854983,15.7),(67337,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67337,37.73,0.46,351,24096,70,NULL,NULL,'2MASX J10034724+0114324',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00009,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,150.947,1.24225,0.029,NULL,60775308279,949614191,14837721,17.3),(67338,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67338,37.7,0.46,347,24097,70,NULL,NULL,'2MASX J10034764+4305267',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,150.948583,43.09092,0,NULL,64098863775,1001544746,15649136,17.1),(67339,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67339,37.77,0.46,358,24098,70,NULL,NULL,'2MASX J10034824+0813345',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000183,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,150.951,8.22611,0.021,NULL,60878615529,951228367,14862943,17),(67340,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67340,36.99,0.33,249,24099,70,NULL,NULL,'2MASX J10035016+6145202',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000196,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,150.958625,61.75547,0.029,NULL,61911854314,967372723,15115198,16.5),(67341,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67341,30.92,NULL,15.3,24100,NULL,NULL,NULL,'ESO 499- G 038',NULL,'2013AJ....145..101K',2013,1,1.1,'Confused HIPASS source','G',0.000013,NULL,'15.68',0.6,'S...',NULL,NULL,NULL,NULL,1,150.9589583,-26.61275,0.173,NULL,42818337157,669036518,10453695,15.68),(67342,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67342,36.81,0.33,231,24101,70,NULL,NULL,'2MASX J10035154+4847064',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000192,NULL,'15.8g',0.45,'E0',NULL,NULL,NULL,NULL,1,150.964833333,48.78506,0,NULL,64006757801,1000105590,15626649,15.8),(67343,'IRAS','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67343,32.86,0.8,37.4,24102,75,NULL,'MAT, I','IC 2537',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.000021,NULL,'12.78',1.7,'SAB(rs)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,150.9662083,-27.57086,0.205,NULL,42829182036,669205969,10456343,12.78),(67344,'Sosies','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67344,32.79,0.14,36.1,24102,NULL,NULL,NULL,'IC 2537',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67345,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67345,32.75,0.32,35.5,24102,85,NULL,'I, raw','IC 2537',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67346,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67346,32.76,0.43,35.7,24102,75,NULL,'MAT, I, raw','IC 2537',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67347,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67347,32.81,0.32,36.4,24102,85,NULL,'I, inv','IC 2537',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67348,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67348,32.85,0.4,37.2,24102,75,NULL,'B','IC 2537',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67349,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67349,32.94,0.4,38.7,24102,NULL,NULL,NULL,'IC 2537',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67350,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67350,32.99,0.43,39.7,24102,75,NULL,'MAT, I, inv','IC 2537',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67351,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67351,33.06,0.09,41,24102,NULL,NULL,NULL,'IC 2537',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67352,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67352,33.09,0.43,41.5,24102,75,NULL,'MAT, I, cor','IC 2537',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67353,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67353,38.36,0.46,470,24103,70,NULL,NULL,'SDSS J100352.29+020602.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000141,NULL,'18.8g',0.09,NULL,NULL,NULL,NULL,NULL,1,150.967917,2.10081,0.005,NULL,60773289295,949582645,14837228,18.8),(67354,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67354,37.55,0.33,324,24104,70,NULL,NULL,'SDSS J100353.47+440712.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00014,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,150.972833333,44.12028,0,NULL,64101043618,1001578806,15649668,18.6),(67355,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67355,36.56,0.56,205,24105,70,NULL,NULL,'2MASX J10035397-1450439',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,150.974916667,-14.84547,0.173,NULL,41190885930,643607592,10056368,14.5),(67356,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67356,37.51,0.46,318,24106,70,NULL,NULL,'2MASX J10035451+3112230',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,150.9772083,31.20644,0.045,NULL,64031204828,1000487575,15632618,17.8),(67357,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67357,37.02,0.46,253,24107,70,NULL,NULL,'2MASX J10035453+4925084',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000174,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,150.977333333,49.41892,0,NULL,63998911543,999982992,15624734,16.6),(67358,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67358,36.83,0.16,232,24108,70,NULL,NULL,'2MASX J10035477+0034574',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000085,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,150.97825,0.58264,0.041,NULL,60771932070,949561438,14836897,17.1),(67359,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67359,38.3,0.46,456,24109,70,NULL,NULL,'SDSS J100355.36+414801.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,150.980667,41.80033,0.009,NULL,64103255734,1001613370,15650208,18),(67360,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67360,37.55,0.46,323,24110,70,NULL,NULL,'2MASX J10035584+0126244',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000164,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,150.982583,1.44019,0.013,NULL,60775021984,949609718,14837651,17.3),(67361,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67361,36.83,0.15,232,24111,70,NULL,NULL,'2MASX J10035588+3222340',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00007,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,150.982917,32.37611,0.037,NULL,64076553078,1001196141,15643689,16.2),(67362,'IRAS','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67362,35.43,0.8,122,24112,75,NULL,'MAT, I','IC 2538',NULL,'1997ApJS..109..333W',1997,1,1.5,'RC3 gives v = 8412 +/- 19 km/sec.','G',0.000033,NULL,'14.58',0.8,'SA:(r)c        HII',NULL,NULL,NULL,NULL,1,150.985375,-34.80753,0.493,NULL,41970984274,655796629,10246822,14.58),(67363,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67363,34.94,0.43,97.3,24112,75,NULL,'MAT, I, raw','IC 2538',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67364,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67364,35.14,0.32,107,24112,85,NULL,'I, raw','IC 2538',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67365,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67365,35.23,0.32,111,24112,85,NULL,'I, inv','IC 2538',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67366,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67366,35.26,0.43,113,24112,75,NULL,'MAT, I, inv','IC 2538',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67367,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67367,35.26,0.49,113,24112,NULL,NULL,'Malmquist cor.','IC 2538',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67368,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67368,35.32,0.43,116,24112,75,NULL,'MAT, I, cor','IC 2538',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67369,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67369,35.38,0.46,119,24112,NULL,NULL,NULL,'IC 2538',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67370,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67370,35.4,0.47,120,24112,NULL,NULL,'H','IC 2538',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67371,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67371,35.54,0.45,128,24112,NULL,NULL,'K','IC 2538',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67372,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67372,35.55,0.46,129,24112,NULL,NULL,'J','IC 2538',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67373,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67373,35.57,0.4,130,24112,NULL,NULL,'mean','IC 2538',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67374,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67374,35.59,0.2,131,24112,74.4,NULL,NULL,'IC 2538',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67375,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67375,34.53,0.46,80.7,24113,70,NULL,NULL,'CGCG 008-030',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000158,NULL,'15.3g',0.44,'E',NULL,NULL,NULL,NULL,1,150.987125,1.51236,0.013,NULL,60772975748,949577746,14837152,15.3),(67376,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67376,29.86,0.4,9.4,24114,75,NULL,'B','NGC 3104',NULL,'1988NBGC.C....0000T',1988,1,3.3,NULL,'G',0.000007,NULL,'13.6',2.2,'IAB(s)m        HII','Group member',NULL,NULL,NULL,1,150.9889583,40.75692,0.045,NULL,64104330933,1001630170,15650471,13.6),(67377,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67377,31.02,NULL,16,24114,NULL,NULL,NULL,'NGC 3104',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67378,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67378,34.83,0.4,92.4,24115,NULL,NULL,'mean','UGC 05420',NULL,'2007A&A...465...71T',2007,1,0.92,NULL,'G',0.000103,NULL,'14.28',0.7,NULL,NULL,NULL,NULL,NULL,1,150.995083,22.276,0.077,NULL,63689444061,995147563,15549180,14.28),(67379,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67379,35.88,0.45,150,24115,NULL,NULL,'K','UGC 05420',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67380,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','PS1 SN PS11bg','N',67380,41.27,0.11,1350,24116,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11bg HOST',0.3302,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67381,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67381,35.26,0.46,113,24117,70,NULL,NULL,'CGCG 093-035',NULL,'2015arXiv151105856S',2015,1,0.5,'Position in 1996A&AS..117..467G is for a star.','G',0.000173,NULL,'15.3',0.3,NULL,NULL,NULL,NULL,NULL,1,150.999,14.42403,0.065,NULL,60852823096,950825360,14856646,15.3),(67382,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67382,37.16,0.46,270,24118,70,NULL,NULL,'2MASX J10040148+1811334',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000186,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,151.00625,18.19264,0.077,NULL,60806031271,950094238,14845222,16.8),(67383,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67383,37.98,0.46,394,24119,70,NULL,NULL,'2MASX J10040195+4614067',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,151.008,46.23508,0,NULL,63976639601,999634993,15619296,17.9),(67384,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67384,38.37,0.46,473,24120,70,NULL,NULL,'2MASX J10040204+0123534',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,151.008541667,1.39822,0.013,NULL,60775065717,949610401,14837662,17.6),(67385,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67385,33.62,0.45,53.1,24121,NULL,NULL,'K','NGC 3110',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000029,NULL,'13.00',0.7,'SB(rs)b pec;HIILIRG',NULL,NULL,NULL,NULL,1,151.0087917,-6.47478,0.065,NULL,41276364320,644943192,10077237,13),(67386,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67386,33.66,0.47,54,24121,NULL,NULL,'H','NGC 3110',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67387,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67387,33.73,0.46,55.8,24121,NULL,NULL,'J','NGC 3110',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67388,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67388,34.31,0.4,72.7,24121,NULL,NULL,'mean','NGC 3110',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67389,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67389,37.74,0.46,353,24122,70,NULL,NULL,'2MASX J10040224+1119355',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000184,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,151.009333,11.32664,0.061,NULL,60876026506,951187914,14862311,17.2),(67390,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67390,36.98,0.46,249,24123,70,NULL,NULL,'2MASX J10040238+3019451',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,151.009875,30.32936,0.025,NULL,64030562398,1000477537,15632461,17.5),(67391,'CMD','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67391,25.42,0.06,1.21,24124,NULL,NULL,NULL,'AM 1001-270',NULL,'2010ApJ...721..297M',2010,1,2,NULL,'G',0.000001,NULL,'16.19',1.5,'dE3.5',NULL,NULL,NULL,NULL,1,151.017083333,-27.331,0.209,0,42830014406,669218975,10456546,16.19),(67392,'CMD','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67392,25.47,0.13,1.24,24124,NULL,NULL,'Antlia extinction','AM 1001-270',NULL,'1997AJ....114.2505S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67393,'CMD','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67393,25.62,0.12,1.33,24124,NULL,NULL,NULL,'AM 1001-270',NULL,'1997AJ....114.2505S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67394,'Red Clump','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67394,25.48,NULL,1.25,24124,NULL,NULL,'V, M RC(V) = +0.73 mag','AM 1001-270',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67395,'Red Clump','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67395,25.88,NULL,1.5,24124,NULL,NULL,'I, M RC(I) = -0.50 mag','AM 1001-270',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67396,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67396,25.3,0.2,1.15,24124,NULL,NULL,'Antlia extinction','AM 1001-270',NULL,'1997AJ....114..996W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67397,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67397,25.47,0.14,1.24,24124,NULL,NULL,NULL,'AM 1001-270',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67398,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67398,25.49,0.13,1.25,24124,NULL,NULL,NULL,'AM 1001-270',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67399,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67399,25.55,0.02,1.29,24124,NULL,NULL,'I','AM 1001-270',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67400,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67400,25.59,0.05,1.31,24124,NULL,NULL,'I','AM 1001-270',NULL,'2012MNRAS.419.1153P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67401,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67401,25.6,0.09,1.32,24124,NULL,NULL,NULL,'AM 1001-270',NULL,'1997AJ....114.1447A',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67402,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67402,25.64,0.08,1.34,24124,74.4,NULL,NULL,'AM 1001-270',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67403,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67403,25.65,0.09,1.35,24124,NULL,NULL,'I','AM 1001-270',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67404,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67404,25.77,NULL,1.43,24124,NULL,NULL,'I, M TRGB(I) = -4.05 mag','AM 1001-270',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67405,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67405,25.89,0.1,1.51,24124,NULL,NULL,NULL,'AM 1001-270',NULL,'1999A&A...352L..63P',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67406,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67406,25.98,0.1,1.57,24124,NULL,NULL,NULL,'AM 1001-270',NULL,'2001MmSAI..72..765C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67407,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67407,36.9,0.46,240,24125,70,NULL,NULL,'2MASX J10040511+2718576',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,151.0212917,27.31603,0.065,NULL,64171612315,1002681442,15666897,17.1),(67408,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67408,33.89,0.45,59.9,24126,NULL,NULL,'K','NGC 3106',NULL,'2007A&A...465...71T',2007,1,1.43,NULL,'G',0.000093,NULL,'13.5g',1.12,'S0','Field galaxy',NULL,NULL,NULL,1,151.021875,31.18547,0.045,NULL,64031206916,1000487608,15632618,13.5),(67409,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67409,34.75,0.4,89,24126,NULL,NULL,'mean','NGC 3106',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67410,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67410,36.81,0.33,231,24127,70,NULL,NULL,'2MASX J10040593+5136575',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000193,NULL,'15.5g',0.53,'E0',NULL,NULL,NULL,NULL,1,151.024625,51.61606,0.005,NULL,63993925113,999905079,15623516,15.5),(67411,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67411,36.81,0.46,230,24128,70,NULL,NULL,'2MASX J10040787+4011044',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000142,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,151.0327917,40.18464,0.017,NULL,64104545690,1001633526,15650523,17.5),(67412,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67412,37.23,0.71,279,24129,70,NULL,NULL,'2MASX J10040814-3931040',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,151.033916667,-39.51786,0.413,NULL,42091119662,657673744,10276152,14.4),(67413,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67413,30.11,NULL,10.5,24130,NULL,NULL,NULL,'MRK 0714',NULL,'2015AstBu..70....1K',2015,1,0.5,'Haynes et al. (2011AJ....142..170H) give v = 1263 km/s.','G',0.000203,NULL,'15.4g',0.36,'Compact',NULL,NULL,NULL,NULL,1,151.036333,6.51047,0.025,NULL,60876367904,951193248,14862394,15.4),(67414,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67414,37.88,0.46,376,24131,70,NULL,NULL,'SDSS J100408.88+104709.2',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000181,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,151.037041667,10.78589,0.069,NULL,60875231964,951175499,14862117,17.8),(67415,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67415,37.26,0.46,283,24132,70,NULL,NULL,'2MASX J10041088+0014438',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000076,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,151.0455,0.24536,0.041,NULL,60771891498,949560804,14836887,17.5),(67416,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67416,37.94,0.46,388,24133,70,NULL,NULL,'2MASX J10041586+4931575',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,151.0660417,49.53278,0,NULL,63998993630,999984275,15624754,17.5),(67417,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67417,37.9,0.46,381,24134,70,NULL,NULL,'2MASX J10041618+0710157',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000154,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,151.067458333,7.17111,0.041,NULL,60877147004,951205421,14862584,17.1),(67418,'IRAS','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67418,32.87,0.8,37.6,24135,75,NULL,'MAT, I','IC 2539',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000013,NULL,'14.01',0.5,'SA(s)bc:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,151.0675417,-31.36294,0.425,NULL,41948187480,655440429,10241256,14.01),(67419,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67419,32.42,0.43,30.4,24135,75,NULL,'3.6 micron, color + selection bias corrected','IC 2539',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67420,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67420,32.44,0.4,30.8,24135,NULL,NULL,NULL,'IC 2539',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67421,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67421,32.46,0.32,31,24135,85,NULL,'I, raw','IC 2539',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67422,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67422,32.48,0.32,31.3,24135,85,NULL,'I, inv','IC 2539',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67423,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67423,32.55,0.43,32.4,24135,75,NULL,'3.6 micron, color corrected','IC 2539',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67424,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67424,32.66,0.43,34,24135,75,NULL,'MAT, I, raw','IC 2539',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67425,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67425,32.69,0.2,34.5,24135,74.4,NULL,NULL,'IC 2539',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67426,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67426,32.8,0.43,36.2,24135,75,NULL,'MAT, I, inv','IC 2539',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67427,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67427,32.97,0.43,39.2,24135,75,NULL,'MAT, I, cor','IC 2539',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67428,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67428,33.25,0.1,44.8,24135,NULL,NULL,NULL,'IC 2539',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67429,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67429,37.24,0.64,280,24136,70,NULL,NULL,'2MASX J10041700-1505347',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,151.070875,-15.09297,0.161,NULL,41190790322,643606098,10056345,15.3),(67430,'Tully est','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67430,31.68,0.8,21.7,24137,75,NULL,NULL,'ESO 037- G 010',NULL,'1988NBGC.C....0000T',1988,1,2.5,NULL,'G',0.000017,NULL,'13.14',2.2,'SAB(rs)c',NULL,NULL,NULL,NULL,1,151.071667,-75.47878,0.833,NULL,39819891126,622185798,9721653,13.14),(67431,'IRAS','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67431,35.45,0.8,123,24138,75,NULL,'CF, r','UGC 05424',NULL,'1997ApJS..109..333W',1997,1,1.11,NULL,'G',0.00006,NULL,'15.3g',0.39,'Scd:',NULL,NULL,NULL,NULL,1,151.0772917,3.68764,0,NULL,60778484738,949663824,14838497,15.3),(67432,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67432,35.1,0.38,105,24138,75,NULL,'CF, r, raw','UGC 05424',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67433,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67433,35.18,0.38,109,24138,75,NULL,'CF, r, inv','UGC 05424',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67434,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67434,35.3,0.38,115,24138,75,NULL,'CF, r, cor','UGC 05424',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67435,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67435,37.11,0.46,264,24139,70,NULL,NULL,'2MASX J10041928+1730187',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',NULL,NULL,'16.63',0.49,NULL,NULL,NULL,NULL,NULL,1,151.080417,17.50519,0.081,NULL,60863670957,950994858,14859294,16.63),(67436,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67436,36.83,0.16,232,24140,70,NULL,NULL,'2MASX J10042002+0028358',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000087,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,151.083458333,0.47658,0.041,NULL,60771965142,949561955,14836905,16.6),(67437,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67437,38.21,0.27,439,24141,70,NULL,NULL,'2MASX J10042016+3453071',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,151.084167,34.88542,0.017,NULL,64061026123,1000953533,15639898,17.5),(67438,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67438,36.83,0.16,232,24142,70,NULL,NULL,'2MASX J10042182+0032028',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000091,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,151.090875,0.53417,0.041,NULL,60772082156,949563783,14836934,16.9),(67439,'Tully est','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67439,32.95,0.8,38.9,24143,75,NULL,'B','NGC 3107',NULL,'1988NBGC.C....0000T',1988,1,0.7,NULL,'G',0.000007,NULL,'14.2',0.6,'Sbc:','Isolated galaxy',NULL,NULL,NULL,1,151.093625,13.62133,0.077,NULL,60846021789,950719090,14854985,14.2),(67440,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67440,36.57,0.17,206,24144,70,NULL,NULL,'2MASX J10042352+5434475',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000154,NULL,'15.8g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,151.098,54.57994,0,NULL,61903620433,967244069,15113188,15.8),(67441,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67441,35.2,0.49,110,24145,70,NULL,NULL,'IC 0589',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.00015,NULL,'15.40',0.51,NULL,NULL,NULL,NULL,NULL,1,151.099583,-5.67892,0.077,NULL,41255428140,644616064,10072126,15.4),(67442,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67442,36.51,0.46,200,24146,70,NULL,NULL,'2MASX J10042398+1225547',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000133,NULL,'15.8g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,151.099875,12.43192,0.077,NULL,60842861720,950669714,14854214,15.8),(67443,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67443,38.12,0.46,421,24147,70,NULL,NULL,'2MASX J10042599+1643427',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,151.10825,16.72847,0.073,NULL,60864203503,951003179,14859424,17.8),(67444,'IRAS','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67444,30.64,0.8,13.4,24148,75,NULL,'MAT, I','NGC 3113',NULL,'1997ApJS..109..333W',1997,1,3.3,NULL,'G',0.00001,NULL,'13.33',1.2,'SB(rs)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,151.1087917,-28.44403,0.221,NULL,42824981476,669140335,10455317,13.33),(67445,'Tully est','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67445,30.77,0.8,14.3,24148,75,NULL,NULL,'NGC 3113',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67446,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67446,30.72,0.32,13.9,24148,85,NULL,'I, inv','NGC 3113',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67447,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67447,30.73,0.32,14,24148,85,NULL,'I, raw','NGC 3113',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67448,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67448,30.84,0.2,14.7,24148,74.4,NULL,NULL,'NGC 3113',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67449,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67449,31.06,0.43,16.3,24148,75,NULL,'MAT, I, raw','NGC 3113',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67450,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67450,31.07,0.43,16.3,24148,75,NULL,'MAT, I, inv','NGC 3113',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67451,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67451,31.18,0.4,17.2,24148,NULL,NULL,NULL,'NGC 3113',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67452,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67452,31.18,0.39,17.2,24148,73,NULL,'opt','NGC 3113',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67453,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67453,31.33,0.43,18.5,24148,75,NULL,'MAT, I, cor','NGC 3113',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67454,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67454,31.82,0.4,23.1,24148,NULL,NULL,'mean','NGC 3113',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67455,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67455,32.53,0.46,32.1,24148,NULL,NULL,'J','NGC 3113',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67456,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67456,34.43,NULL,77,24149,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 316- G 021',NULL,'2010Ap&SS.325..163P',2010,1,2.91,NULL,'G',0.000028,NULL,'14.99',0.36,'Sc',NULL,NULL,NULL,NULL,1,151.109333333,-41.41608,0.757,NULL,42093080090,657704376,10276630,14.99),(67457,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67457,34.44,NULL,77.1,24149,NULL,NULL,'Dipole + Quadrupole','ESO 316- G 021',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67458,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67458,34.44,NULL,77.2,24149,NULL,NULL,'Dipole','ESO 316- G 021',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67459,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67459,35.92,0.78,153,24150,70,NULL,NULL,'2MASX J10042628-3752580',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,151.1094583,-37.88278,0.493,NULL,41975486811,655866981,10247921,15.1),(67460,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67460,36.83,0.16,232,24151,70,NULL,NULL,'2MASX J10042709+0031267',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000104,NULL,'15.5g',0.55,'E0',NULL,NULL,NULL,NULL,1,151.112917,0.52397,0.041,NULL,60772084927,949563826,14836934,15.5),(67461,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 1999N',NULL,67461,42.81,0.41,2370,24152,65,NULL,NULL,'H-ZSNS J100427.93-073551.1',0.54,'2006ApJ...642....1C',2006,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,151.116375,-7.59753,0.097,NULL,41280004947,645000077,10078126,NULL),(67462,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','SN 1999N',NULL,67462,43.11,0.2,2720,24152,65,NULL,NULL,'H-ZSNS J100427.93-073551.1',0.54,'2006ApJ...642....1C',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67463,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67463,37.5,0.46,317,24153,70,NULL,NULL,'SDSS J100428.89+074103.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000162,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,151.120417,7.68439,0.013,NULL,60879666134,951244783,14863199,18.2),(67464,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67464,34.85,0.49,93.4,24154,75,NULL,'IR','UGC 05426',NULL,'2011yCatp016004901K',2011,1,1.4,'Position in 1993ApJ...409..110S is for a superposed star.','G',0.000014,NULL,'15.80',0.11,'Sc',NULL,NULL,NULL,NULL,1,151.122917,14.76917,0.057,NULL,60853020550,950828446,14856694,15.8),(67465,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67465,35.29,0.41,114,24154,NULL,NULL,'Malmquist cor.','UGC 05426',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67466,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67466,35.34,0.4,117,24154,NULL,NULL,NULL,'UGC 05426',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67467,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67467,35.38,0.2,119,24154,74.4,NULL,NULL,'UGC 05426',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67468,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67468,35.41,NULL,121,24154,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05426',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67469,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67469,35.42,NULL,122,24154,NULL,NULL,'Dipole + Quadrupole','UGC 05426',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67470,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67470,35.44,NULL,122,24154,NULL,NULL,'Dipole','UGC 05426',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67471,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67471,35.46,NULL,124,24154,NULL,NULL,NULL,'UGC 05426',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67472,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67472,36.31,0.46,183,24155,70,NULL,NULL,'2MASX J10043084+3606354',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000168,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,151.1285,36.10975,0.005,NULL,64071521363,1001117521,15642461,16.2),(67473,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67473,36.92,0.46,242,24156,70,NULL,NULL,'2MASX J10043138+1320127',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000153,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,151.1307917,13.33686,0.081,NULL,60846232249,950722378,14855037,17.5),(67474,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67474,33.64,0.46,53.5,24157,70,NULL,NULL,'NGC 3102',NULL,'2015arXiv151105856S',2015,1,0.93,NULL,'G',0.000103,NULL,'14.1g',0.91,'S0-:','Isolated galaxy',NULL,NULL,NULL,1,151.132333333,60.10797,0.005,NULL,61924539998,967570937,15118295,14.1),(67475,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67475,36.58,0.46,207,24158,70,NULL,NULL,'2MASX J10043178+0157377',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000175,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,151.132416667,1.96036,0.005,NULL,60773351220,949583612,14837243,16.5),(67476,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67476,37.94,0.46,388,24159,70,NULL,NULL,'2MASX J10043277+1556407',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,151.136583333,15.94458,0.061,NULL,60867612626,951056447,14860256,17.1),(67477,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67477,35.71,0.33,138,24160,70,NULL,NULL,'2MASX J10043346+0147157',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000163,NULL,'15.3g',0.49,'S0^-',NULL,NULL,NULL,NULL,1,151.139458333,1.78775,0.013,NULL,60773021930,949578467,14837163,15.3),(67478,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67478,35.75,0.65,141,24161,70,NULL,NULL,'2MASX J10043434-1421557',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,151.143167,-14.36558,0.201,NULL,41190591039,643602984,10056296,15.5),(67479,'G Lens','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67479,43.06,0.64,4090,24162,NULL,NULL,NULL,'SDSS J1004+4112',NULL,'2014MNRAS.437..600S',2014,1,NULL,'This QSO is lensed by a foreground z=0.68 galaxy.','QSO',0.000608,NULL,'19.1g',NULL,'Candidate      QSO',NULL,NULL,NULL,'QSO',1,151.145583333,41.21186,0,NULL,64104893761,1001638965,15650608,19.1),(67480,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67480,35.5,0.5,126,24163,70,NULL,NULL,'2MASX J10043682-1615357',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.6I',0.4,NULL,NULL,NULL,NULL,NULL,1,151.153375,-16.25994,0.101,NULL,41204403350,643818802,10059668,13.6),(67481,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67481,38.21,0.27,439,24164,70,NULL,NULL,'SDSS J100437.56+345218.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000132,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,151.1565,34.87189,0.017,NULL,64061031304,1000953614,15639900,18.3),(67482,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67482,38.21,0.27,439,24165,70,NULL,NULL,'SDSS J100438.17+344841.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000143,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,151.159083,34.81142,0.013,NULL,64061033677,1000953651,15639900,18.2),(67483,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67483,32.5,NULL,31.6,24166,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG +10-15-008',NULL,'2010Ap&SS.325..163P',2010,1,0.9,NULL,'G',0.000149,NULL,'16.8g',0.14,'Sd(f)',NULL,NULL,NULL,NULL,1,151.160625,60.46617,0,NULL,61923697301,967557770,15118090,16.8),(67484,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67484,32.54,NULL,32.2,24166,NULL,NULL,'Dipole + Quadrupole','MCG +10-15-008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67485,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67485,32.58,NULL,32.8,24166,NULL,NULL,'Dipole','MCG +10-15-008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67486,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67486,32.64,NULL,33.7,24166,NULL,NULL,NULL,'MCG +10-15-008',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67487,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67487,35.71,0.55,139,24167,70,NULL,NULL,'2MASX J10043850-0920233',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,151.160417,-9.33983,0.205,NULL,41285423746,645084746,10079449,15.8),(67488,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67488,35.71,0.33,138,24168,70,NULL,NULL,'CGCG 008-033',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000168,NULL,'15.4g',0.5,'S0^-',NULL,NULL,NULL,NULL,1,151.161417,1.88958,0.013,NULL,60773122304,949580036,14837188,15.4),(67489,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67489,38.12,0.23,421,24169,70,NULL,NULL,'SDSS J100439.57+025643.9',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.00016,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,151.164875,2.94553,0,NULL,60779719929,949683123,14838798,18.5),(67490,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67490,36.47,0.27,197,24170,70,NULL,NULL,'2MASX J10044064+5248070',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000169,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,151.169125,52.80186,0.005,NULL,63996092359,999938943,15624045,16.3),(67491,'Brightest Stars','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67491,29.26,0.2,7.11,24171,NULL,NULL,NULL,'UGC 05427',NULL,'1998A&AS..133..181M',1998,1,1.25,'Noted in MCG as possibly interacting.','G',0.000017,NULL,'14.9g',0.65,'Sdm:',NULL,NULL,NULL,NULL,1,151.170625,29.36431,0.033,NULL,64162781724,1002543464,15664741,14.9),(67492,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67492,29.43,0.1,7.69,24171,74.4,NULL,NULL,'UGC 05427',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67493,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67493,27.72,0.05,3.49,24172,NULL,NULL,'I','SDSS J100441.39+681522.8',NULL,'2009ApJS..183...67D',2009,1,0.8,NULL,'G',NULL,NULL,'16.72',0.6,'Dwarf elliptical',NULL,NULL,NULL,NULL,1,151.1725,68.25636,0.193,NULL,62129756682,970777448,15168397,16.72),(67494,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67494,27.8,0.08,3.63,24172,74.4,NULL,NULL,'SDSS J100441.39+681522.8',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67495,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67495,27.81,0.09,3.65,24172,NULL,NULL,'I','SDSS J100441.39+681522.8',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67496,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67496,27.84,0.08,3.7,24172,NULL,NULL,NULL,'SDSS J100441.39+681522.8',NULL,'2007ASPC..374..247D',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67497,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67497,27.88,0.13,3.77,24172,NULL,NULL,'HST KP Calibrated','SDSS J100441.39+681522.8',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67498,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67498,27.89,NULL,3.78,24172,NULL,NULL,NULL,'SDSS J100441.39+681522.8',NULL,'2000A&A...363..117K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67499,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67499,28,NULL,3.98,24172,NULL,NULL,NULL,'SDSS J100441.39+681522.8',NULL,'1998AJ....115..535C',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67500,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67500,30.91,NULL,15.2,24173,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05421',NULL,'2010Ap&SS.325..163P',2010,1,2.18,NULL,'G',0.00001,NULL,'16.5',0.3,'Sdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,151.174167,55.31194,0.005,NULL,61902561238,967227519,15112929,16.5),(67501,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67501,30.92,NULL,15.3,24173,NULL,NULL,'Dipole + Quadrupole','UGC 05421',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67502,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67502,30.94,NULL,15.4,24173,NULL,NULL,'Dipole','UGC 05421',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67503,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67503,31.89,0.2,23.9,24173,74.4,NULL,NULL,'UGC 05421',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67504,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67504,38.12,0.23,421,24174,70,NULL,NULL,'2MASX J10044196+0258287',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000209,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,151.17475,2.9745,0,NULL,60779720451,949683132,14838798,17.1),(67505,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67505,37.17,0.46,272,24175,70,NULL,NULL,'2MASX J10044297+3752596',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,151.1792083,37.88314,0,NULL,64069918668,1001092479,15642069,16.2),(67506,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67506,37.79,0.33,361,24176,70,NULL,NULL,'2MASX J10044597+1126085',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000193,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,151.1917083,11.43581,0.061,NULL,60875482583,951179415,14862178,17.3),(67507,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67507,36.57,0.17,206,24177,70,NULL,NULL,'2MASX J10044606+5433166',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,151.1917917,54.55456,0,NULL,61903633068,967244266,15113191,17.1),(67508,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67508,38.34,0.46,467,24178,70,NULL,NULL,'2MASX J10044627+3338019',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,151.1927083,33.63389,0.021,NULL,64063313845,1000989278,15640457,18.4),(67509,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67509,36.08,0.46,164,24179,70,NULL,NULL,'2MASX J10044632+1643236',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',NULL,NULL,'16.17',0.55,NULL,NULL,NULL,NULL,NULL,1,151.192917,16.72311,0.073,NULL,60864206501,951003226,14859425,16.17),(67510,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67510,37.99,0.46,397,24180,70,NULL,NULL,'2MASX J10044669+3745126',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000199,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,151.1947917,37.7535,0.013,NULL,64069935415,1001092740,15642074,17),(67511,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67511,36.47,0.27,197,24181,70,NULL,NULL,'2MASX J10044727+5244291',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000155,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,151.197,52.74139,0.005,NULL,63996044159,999938189,15624034,16.9),(67512,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67512,35.19,0.33,109,24182,70,NULL,NULL,'CGCG 240-003',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.00001,NULL,'14.9g',0.61,'E0             AGN','Group member',NULL,NULL,NULL,1,151.198667,46.71936,0,NULL,64005954679,1000093041,15626453,14.9),(67513,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67513,36.89,0.19,239,24183,70,NULL,NULL,'2MASX J10044776+5013190',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000189,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,151.198917,50.22192,0,NULL,64001134659,1000017729,15625277,16.2),(67514,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67514,36.98,0.46,249,24184,70,NULL,NULL,'2MASX J10044829+0046067',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00008,NULL,'17.3g',0.19,'NLAGN',NULL,NULL,NULL,NULL,1,151.201125,0.76839,0.029,NULL,60771603428,949556303,14836817,17.3),(67515,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67515,36.99,0.46,251,24185,70,NULL,NULL,'2MASX J10044830+0245487',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000139,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,151.20125,2.76356,0,NULL,60772346960,949567921,14836998,17.8),(67516,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67516,36.31,0.46,183,24186,70,NULL,NULL,'2MASX J10044831+6038332',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000148,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,151.2015,60.64267,0,NULL,61923671210,967557362,15118083,16.7),(67517,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67517,37.99,0.23,397,24187,70,NULL,NULL,'2MASX J10044862+2912420',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.3g',0.22,'E',NULL,NULL,NULL,NULL,1,151.20275,29.21178,0.017,NULL,64162823816,1002544122,15664751,17.3),(67518,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67518,36.42,0.33,192,24188,70,NULL,NULL,'2MASX J10044898+5308451',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,151.203833333,53.14597,0,NULL,63996117593,999939337,15624052,16.7),(67519,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67519,37.99,0.23,397,24189,70,NULL,NULL,'2MASX J10044916+2915150',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00016,NULL,'16.9g',0.3,'Sa',NULL,NULL,NULL,NULL,1,151.204958333,29.25408,0.017,NULL,64162821999,1002544093,15664751,16.9),(67520,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67520,37.09,0.46,262,24190,70,NULL,NULL,'2MASX J10045027+3328570',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000149,NULL,'17.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,151.209583,33.48258,0.025,NULL,64059894049,1000935844,15639622,17.3),(67521,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67521,38.12,0.23,421,24191,70,NULL,NULL,'2MASX J10045157+0254337',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.4g',0.25,'AGN',NULL,NULL,NULL,NULL,1,151.21475,2.90933,0,NULL,60779670460,949682350,14838786,17.4),(67522,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67522,36.57,0.17,206,24192,70,NULL,NULL,'CGCG 266-018',NULL,'2015arXiv151105856S',2015,1,1.11,NULL,'G',0.000103,NULL,'14.9g',0.64,'E0             AGN',NULL,NULL,NULL,NULL,1,151.215958333,54.56789,0,NULL,61903634394,967244287,15113191,14.9),(67523,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67523,35.19,0.33,109,24193,70,NULL,NULL,'CGCG 240-004',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000174,NULL,'15.6g',0.45,'S0^-           AGN','Group member',NULL,NULL,NULL,1,151.21675,46.69003,0,NULL,64005963012,1000093172,15626455,15.6),(67524,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67524,37.82,0.46,367,24194,70,NULL,NULL,'2MASX J10045314-0040372',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000075,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,151.2212917,-0.67708,0.101,NULL,41230854091,644232095,10066126,17),(67525,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67525,34.85,0.46,93.3,24195,70,NULL,NULL,'UGC 05432',NULL,'2015arXiv151105856S',2015,1,1.17,NULL,'G',0.00015,NULL,'14.1g',0.93,'E:',NULL,NULL,NULL,NULL,1,151.224625,5.06264,0,NULL,60784373627,949755837,14839934,14.1),(67526,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67526,37.32,0.46,291,24196,70,NULL,NULL,'2MASX J10045432+3457069',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000162,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,151.2265,34.95194,0.017,NULL,64061122861,1000955044,15639922,16.5),(67527,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67527,37.71,0.46,348,24197,70,NULL,NULL,'2MASX J10045486+5138461',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,151.228625,51.64608,0.005,NULL,63994043336,999906927,15623545,17.7),(67528,'SNIa','2016-12-15 15:14:34','2016-12-16 11:19:41','1','PS1 SN PS10l','N',67528,41.6,0.1,1530,24198,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10l HOST',0.3712,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67529,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67529,37.79,0.33,361,24199,70,NULL,NULL,'SDSS J100455.96+112106.7',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,151.233167,11.35189,0.061,NULL,60875999873,951187498,14862304,17.9),(67530,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67530,37.55,0.46,324,24200,70,NULL,NULL,'2MASX J10045614-0042342',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00009,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,151.2337917,-0.70953,0.101,NULL,41230822708,644231604,10066118,16.8),(67531,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67531,37.47,0.46,312,24201,70,NULL,NULL,'2MASXi J1004570-000124',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000091,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,151.237583333,-0.02353,0.049,NULL,41230076678,644219948,10065936,17.6),(67532,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67532,34.91,0.33,95.7,24202,70,NULL,NULL,'CGCG 064-051',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000174,NULL,'15.6g',0.36,'S0',NULL,NULL,NULL,NULL,1,151.238458333,10.30394,0.061,NULL,60880878612,951263728,14863495,15.6),(67533,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67533,37.72,0.46,351,24203,70,NULL,NULL,'2MASX J10045860+3708286',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,151.244417,37.14117,0.017,NULL,64069722965,1001089421,15642022,17.6),(67534,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67534,36.89,0.19,239,24204,70,NULL,NULL,'2MASX J10045923+5014480',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000176,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,151.247,50.24664,0,NULL,64001093264,1000017082,15625266,17.1),(67535,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67535,33.88,NULL,59.6,24205,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05431',NULL,'2010Ap&SS.325..163P',2010,1,1.52,NULL,'G',0.000013,NULL,'16.1g',0.18,'Scd',NULL,NULL,NULL,NULL,1,151.246958333,21.53825,0.069,NULL,60801827126,950028548,14844196,16.1),(67536,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67536,33.88,NULL,59.6,24205,NULL,NULL,NULL,'UGC 05431',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67537,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67537,33.88,NULL,59.7,24205,NULL,NULL,'Dipole + Quadrupole','UGC 05431',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67538,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,NULL,67538,33.88,NULL,59.7,24205,NULL,NULL,'Dipole','UGC 05431',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67539,'FP','2016-12-15 15:14:34','2016-12-16 11:19:41','1',NULL,'R',67539,35.47,0.46,124,24206,70,NULL,NULL,'SDSS J100505.46+203408.0',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000163,NULL,'16.5g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,151.27275,20.56892,0.057,NULL,60816292252,950254566,14847727,16.5),(67540,'FP','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,'R',67540,36.89,0.19,239,24207,70,NULL,NULL,'2MASX J10050545+5006530',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000179,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,151.272833,50.11483,0,NULL,64001001162,1000015643,15625244,16.7),(67541,'FP','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,'R',67541,37.81,0.46,365,24208,70,NULL,NULL,'2MASX J10050578+4105396',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.0002,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,151.27425,41.09425,0,NULL,64104784932,1001637264,15650582,16.5),(67542,'FP','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,'R',67542,37.5,0.46,317,24209,70,NULL,NULL,'2MASX J10050588+1406105',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000123,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,151.274667,14.10297,0.065,NULL,60845096789,950704637,14854759,16.6),(67543,'CMD','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67543,27.67,NULL,3.42,24210,NULL,NULL,NULL,'UGC 05428',NULL,'2012ApJ...748...47M',2012,1,0.9,NULL,'G',0.000001,NULL,'18.',0.9,'Im:','Dwarf, possible member',NULL,NULL,NULL,1,151.276667,66.55889,0.121,NULL,62119155629,970611806,15165809,18),(67544,'SBF','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67544,27.98,0.27,3.94,24210,NULL,NULL,'T01','UGC 05428',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67545,'SBF','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67545,27.98,0.27,3.94,24210,NULL,NULL,'J03','UGC 05428',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67546,'SBF','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67546,28.18,0.27,4.33,24210,NULL,NULL,'BV A01','UGC 05428',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67547,'SBF','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67547,28.31,0.2,4.59,24210,NULL,NULL,'M06','UGC 05428',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67548,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67548,27.66,0.08,3.4,24210,NULL,NULL,'I','UGC 05428',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67549,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67549,27.72,NULL,3.5,24210,NULL,NULL,NULL,'UGC 05428',NULL,'2000A&A...363..117K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67550,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67550,27.74,0.04,3.53,24210,NULL,NULL,'I','UGC 05428',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67551,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67551,27.74,NULL,3.53,24210,NULL,NULL,NULL,'UGC 05428',NULL,'2010ApJ...724.1030G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67552,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67552,27.79,0.08,3.61,24210,74.4,NULL,NULL,'UGC 05428',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67553,'TRGB','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,'R',67553,27.84,0.08,3.7,24210,NULL,NULL,NULL,'UGC 05428',NULL,'2007ASPC..374..247D',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67554,'FP','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,'R',67554,37.17,0.46,271,24211,70,NULL,NULL,'2MASX J10050748+0517000',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000175,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,151.281125,5.28322,0.005,NULL,60784281301,949754395,14839912,16.6),(67555,'FP','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,'R',67555,38.24,0.27,444,24212,70,NULL,NULL,'2MASX J10050818+0653455',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000148,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,151.284166667,6.89608,0.013,NULL,60877100351,951204692,14862573,17.4),(67556,'FP','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,'R',67556,36.89,0.19,239,24213,70,NULL,NULL,'SDSS J100508.26+501216.5',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000189,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,151.2844583,50.20461,0,NULL,64000971077,1000015173,15625237,17.5),(67557,'IRAS','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67557,34.11,0.8,66.5,24214,75,NULL,'MAT, I','ESO 062- G 003',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'13.32',1,'S...',NULL,NULL,NULL,NULL,1,151.284416667,-70.81911,0.493,NULL,40714320434,636161256,9940019,13.32),(67558,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67558,34.05,0.32,64.5,24214,85,NULL,'I, raw','ESO 062- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67559,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67559,34.08,0.32,65.5,24214,85,NULL,'I, inv','ESO 062- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67560,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67560,34.23,0.43,70.1,24214,75,NULL,'MAT, I, raw','ESO 062- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67561,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67561,34.4,0.43,75.8,24214,75,NULL,'MAT, I, inv','ESO 062- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67562,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67562,34.5,0.43,79.4,24214,75,NULL,'MAT, I, cor','ESO 062- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67563,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67563,34.51,0.45,79.8,24214,NULL,NULL,'Malmquist cor.','ESO 062- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67564,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67564,34.75,0.41,89.3,24214,NULL,NULL,NULL,'ESO 062- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67565,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67565,34.8,0.2,91.2,24214,74.4,NULL,NULL,'ESO 062- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67566,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,'R',67566,35.35,0.49,118,24215,75,NULL,'IR','UGC 05430',NULL,'2011yCatp016004901K',2011,1,0.87,NULL,'G',0.000111,NULL,'16.3g',0.21,'Scd',NULL,NULL,NULL,NULL,1,151.2844583,44.51394,0,NULL,64097633647,1001525525,15648836,16.3),(67567,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67567,35.5,NULL,126,24215,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05430',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67568,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67568,35.53,NULL,127,24215,NULL,NULL,'Dipole + Quadrupole','UGC 05430',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67569,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67569,35.53,NULL,127,24215,NULL,NULL,'Dipole','UGC 05430',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67570,'Tully-Fisher','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67570,35.54,NULL,129,24215,NULL,NULL,NULL,'UGC 05430',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67571,'FP','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,'R',67571,36.89,0.19,239,24216,70,NULL,NULL,'2MASX J10051182+5010590',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.00009,NULL,'15.1g',0.53,'E0',NULL,NULL,NULL,NULL,1,151.299416667,50.18314,0,NULL,64000971023,1000015172,15625237,15.1),(67572,'FP','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67572,34.53,0.52,80.6,24217,70,NULL,NULL,'MCG -01-26-017',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.000123,NULL,'15.36',0.18,NULL,NULL,NULL,NULL,NULL,1,151.300333,-6.63272,0.029,NULL,41276281020,644941890,10077217,15.36),(67573,'FP','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,'R',67573,37.53,0.46,320,24218,70,NULL,NULL,'SDSS J100512.44+371408.9',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000164,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,151.301875,37.23583,0.017,NULL,64069748958,1001089827,15642028,17.6),(67574,'FP','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,'R',67574,38.24,0.27,444,24219,70,NULL,NULL,'SDSS J100512.57+065245.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000144,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,151.302375,6.87933,0.013,NULL,60877100927,951204701,14862573,18.5),(67575,'FP','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,'R',67575,37.7,0.46,347,24220,70,NULL,NULL,'2MASX J10051267+2800594',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,151.302666667,28.01642,0.045,NULL,64170986425,1002671662,15666744,17.6),(67576,'FP','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,'R',67576,36.88,0.46,238,24221,70,NULL,NULL,'2MASX J10051275+2316216',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,151.303041667,23.27269,0.109,NULL,63690286482,995160726,15549386,17.4),(67577,'FP','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67577,36.02,0.6,160,24222,70,NULL,NULL,'2MASX J10051284-1306390',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,151.3035,-13.11083,0.197,NULL,41162661422,643166584,10049477,16.7),(67578,'FP','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,'R',67578,36.84,0.46,233,24223,70,NULL,NULL,'2MASX J10051304+0941291',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,151.304333,9.69128,0.049,NULL,60881161977,951268155,14863564,17.3),(67579,'FP','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,'R',67579,36.69,0.46,218,24224,70,NULL,NULL,'2MASX J10051318+4422336',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000147,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,151.3050417,44.37606,0,NULL,64101058975,1001579046,15649672,17.9),(67580,'GCLF','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67580,29.62,0.27,8.39,24225,NULL,NULL,'blue GCs, TOM(V) = -7.17 mag','NGC 3115',NULL,'2001AJ....121.2974L',2001,1,7.2,NULL,'G',0.000013,NULL,'9.87',2.5,'S0-            PAS','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,151.30825,-7.71858,0.097,NULL,41280083258,645001300,10078145,9.87),(67581,'GCLF','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67581,29.8,0.3,9.12,24225,NULL,NULL,NULL,'NGC 3115',NULL,'1998AJ....116.2841K',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67582,'GCLF','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67582,29.9,0.26,9.55,24225,NULL,NULL,'HST KP Calibrated, V','NGC 3115',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67583,'GCLF','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67583,29.95,0.3,9.77,24225,NULL,NULL,NULL,'NGC 3115',NULL,'2015A&A...576A..14C',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67584,'GCLF','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67584,30,0.07,10,24225,NULL,NULL,NULL,'NGC 3115',NULL,'2001AJ....122.1251K',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67585,'GCLF','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67585,30,0.3,10,24225,NULL,NULL,'TOM(V) = -7.3 mag','NGC 3115',NULL,'2009ApJ...690..512H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67586,'GCLF','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67586,30,0.4,10,24225,NULL,NULL,'Photographic','NGC 3115',NULL,'1986ApJ...304..599H',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67587,'GCLF','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67587,30.18,0.21,10.9,24225,NULL,NULL,'all GCs, TOM(V) = -7.63 mag','NGC 3115',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67588,'GCLF','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,'R',67588,30.2,0.3,11,24225,NULL,NULL,NULL,'NGC 3115',NULL,'1998PhDT.........4K',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67589,'GCLF','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67589,30.21,0.33,11,24225,NULL,NULL,'red GCs, TOM(V) = -7.55 mag','NGC 3115',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67590,'PNLF','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67590,30.02,0.15,10.1,24225,NULL,NULL,NULL,'NGC 3115',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67591,'PNLF','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67591,30.12,0.19,10.6,24225,NULL,NULL,'HST KP Calibrated','NGC 3115',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67592,'PNLF','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67592,30.17,0.13,10.8,24225,NULL,NULL,'I','NGC 3115',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67593,'SBF','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67593,29.65,0.25,8.51,24225,NULL,NULL,'I','NGC 3115',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67594,'SBF','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67594,29.93,0.09,9.68,24225,NULL,NULL,'I','NGC 3115',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67595,'SBF','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67595,29.93,0.09,9.68,24225,NULL,NULL,NULL,'NGC 3115',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67596,'SBF','2016-12-15 15:14:34','2016-12-16 11:19:42','1',NULL,NULL,67596,29.95,0.09,9.77,24225,NULL,NULL,'Malmquist cor.','NGC 3115',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67597,'SBF','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67597,29.99,0.13,9.95,24225,NULL,NULL,'HST KP Calibrated, I','NGC 3115',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67598,'SBF','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67598,30.06,0.1,10.3,24225,74.4,NULL,NULL,'NGC 3115',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67599,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67599,30.05,0.05,10.2,24225,NULL,NULL,'F110W band, syst. +/- 0.10 mag','NGC 3115',NULL,'2015ApJ...800...13P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67600,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67600,30.06,0.1,10.3,24225,74.4,NULL,NULL,'NGC 3115',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67601,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67601,30.18,0.3,10.9,24225,NULL,NULL,'HST KP Calibrated','NGC 3115',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67602,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67602,30.21,0.25,11,24225,NULL,NULL,'I','NGC 3115',NULL,'1997MNRAS.286..771E',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67603,'D-Sigma','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67603,30.24,0.4,11.1,24225,75,NULL,'Edat, raw','NGC 3115',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67604,'D-Sigma','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67604,30.57,0.4,13,24225,75,NULL,'Edat, cor','NGC 3115',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67605,'Faber-Jackson','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67605,28.67,0.63,5.42,24225,95,NULL,'Michard 1979b, c','NGC 3115',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67606,'Faber-Jackson','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67606,29.04,0.46,6.43,24225,95,NULL,'Michard 1979a','NGC 3115',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67607,'Faber-Jackson','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67607,29.59,0.25,8.28,24225,95,NULL,'Weighted Mean','NGC 3115',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67608,'Faber-Jackson','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67608,29.98,0.33,9.91,24225,95,NULL,'de Vaucouleurs','NGC 3115',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67609,'Faber-Jackson','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67609,30.44,0.81,12.2,24225,55,NULL,'Visvanathan & Sandage 1979','NGC 3115',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67610,'Faber-Jackson','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67610,30.68,NULL,13.7,24225,NULL,NULL,'LEDA [April 2006]','NGC 3115',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67611,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67611,30.04,0.41,10.2,24225,NULL,NULL,NULL,'NGC 3115',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67612,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67612,30.28,0.41,11.4,24225,NULL,NULL,'Malmquist cor.','NGC 3115',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67613,'Tertiary','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67613,28.5,0.71,5.01,24225,95,NULL,NULL,'NGC 3115',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67614,'Tully est','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67614,29.12,0.8,6.7,24225,75,NULL,'B','NGC 3115',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67615,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67615,29.95,0.45,9.76,24225,NULL,NULL,'K','NGC 3115',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67616,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67616,30.48,0.4,12.5,24225,NULL,NULL,'mean','NGC 3115',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67617,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67617,36.42,0.33,192,24226,70,NULL,NULL,'CGCG 266-020',NULL,'2015arXiv151105856S',2015,1,0.98,NULL,'G',0.000113,NULL,'14.9g',0.61,'BrClG',NULL,NULL,NULL,NULL,1,151.312167,53.149,0,NULL,63994954445,999921163,15623768,14.9),(67618,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67618,37.61,0.46,332,24227,70,NULL,NULL,'2MASX J10051530+3940260',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000183,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,151.3137917,39.67381,0.005,NULL,64103857993,1001622781,15650355,17.2),(67619,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67619,37.28,0.46,286,24228,70,NULL,NULL,'2MASX J10051562+0036370',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000121,NULL,'15.7g',0.45,'E0',NULL,NULL,NULL,NULL,1,151.315125,0.61033,0.037,NULL,60772277374,949566833,14836981,15.7),(67620,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67620,38.24,0.27,444,24229,70,NULL,NULL,'SDSS J100517.63+065741.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00013,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,151.3235,6.96167,0.013,NULL,60877104622,951204759,14862574,18.2),(67621,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67621,37.11,0.46,265,24230,70,NULL,NULL,'2MASX J10051793+4338456',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000147,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,151.324958333,43.64614,0,NULL,64101103643,1001579744,15649683,17),(67622,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67622,35.39,0.46,120,24231,70,NULL,NULL,'CGCG 036-032',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000097,NULL,'15.4g',0.36,'E0',NULL,NULL,NULL,NULL,1,151.327167,5.56967,0,NULL,60784843319,949763176,14840049,15.4),(67623,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67623,38.06,0.46,409,24232,70,NULL,NULL,'2MASX J10051881+0726461',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000187,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,151.328291667,7.44617,0.017,NULL,60876462459,951194725,14862417,17.6),(67624,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67624,34.89,NULL,95.1,24233,NULL,NULL,NULL,'FGC 0999',NULL,'2000BSAO...50....5K',2000,1,0.93,NULL,'G',0.00007,NULL,'16.7',0.11,'Sdm',NULL,NULL,NULL,NULL,1,151.337917,77.77917,0.013,NULL,61463402582,960365665,15005713,16.7),(67625,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67625,37.26,0.46,283,24234,70,NULL,NULL,'2MASX J10052110+0727261',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',NULL,NULL,'16.1g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,151.338,7.45719,0.017,NULL,60876462781,951194730,14862417,16.1),(67626,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67626,38.02,0.46,402,24235,70,NULL,NULL,'2MASX J10052185+4013190',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,151.341125,40.22181,0.009,NULL,64104680963,1001635640,15650556,17.7),(67627,'SNII optical','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1999ca',NULL,67627,32.88,0.07,37.7,24236,NULL,NULL,'I, photospheric magnitude method','NGC 3120',NULL,'2014AJ....148..107R',2014,1,1.8,NULL,'G',0.000007,NULL,'13.52',1.3,'Sc             HII','in a pair',NULL,NULL,NULL,1,151.346,-34.21994,0.485,NULL,41970695040,655792110,10246751,13.52),(67628,'SNII optical','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1999ca',NULL,67628,32.93,0.89,37.8,24236,NULL,NULL,'SEAM','NGC 3120',0.00931,'2009ApJ...694.1067P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67629,'SNII optical','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1999ca',NULL,67629,32.97,0.1,39.3,24236,NULL,NULL,'V, photospheric magnitude method','NGC 3120',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67630,'IRAS','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67630,32.83,0.8,36.8,24236,75,NULL,'MAT, I','NGC 3120',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67631,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67631,31.56,0.43,20.5,24236,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3120',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67632,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67632,31.74,0.43,22.3,24236,75,NULL,'3.6 micron, color corrected','NGC 3120',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67633,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67633,31.84,0.32,23.3,24236,85,NULL,'I, raw','NGC 3120',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67634,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67634,31.84,0.43,23.4,24236,75,NULL,'MAT, I, raw','NGC 3120',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67635,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67635,31.86,0.32,23.5,24236,85,NULL,'I, inv','NGC 3120',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67636,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67636,31.89,0.2,23.9,24236,74.4,NULL,NULL,'NGC 3120',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67637,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67637,31.93,0.43,24.4,24236,75,NULL,'MAT, I, inv','NGC 3120',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67638,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67638,32.31,0.43,29,24236,75,NULL,'MAT, I, cor','NGC 3120',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67639,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67639,32.54,0.47,32.2,24236,NULL,NULL,'H','NGC 3120',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67640,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67640,32.57,0.45,32.7,24236,NULL,NULL,'K','NGC 3120',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67641,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67641,32.59,0.46,33,24236,NULL,NULL,'J','NGC 3120',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67642,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67642,32.98,0.4,39.5,24236,NULL,NULL,'mean','NGC 3120',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67643,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67643,33.24,0.09,44.6,24236,NULL,NULL,NULL,'NGC 3120',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67644,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67644,35.92,0.46,153,24237,70,NULL,NULL,'2MASX J10052377+1348461',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00009,NULL,'15.9g',0.37,NULL,NULL,NULL,NULL,NULL,1,151.349,13.81289,0.073,NULL,60845167137,950705736,14854777,15.9),(67645,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67645,37.32,0.46,291,24238,70,NULL,NULL,'2MASX J10052389+0531180',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,151.3497083,5.52153,0.005,NULL,60784897522,949764023,14840062,17.5),(67646,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67646,35.17,0.67,108,24239,70,NULL,NULL,'2MASX J10052540-4214529',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,151.355875,-42.24797,0.781,NULL,42092231173,657691112,10276423,15.1),(67647,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67647,37.99,0.23,397,24240,70,NULL,NULL,'2MASX J10052669+2904125',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'16.3',0.29,'BrClG;E',NULL,NULL,NULL,NULL,1,151.3612083,29.07011,0.057,NULL,64162761476,1002543148,15664736,16.3),(67648,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67648,37.52,0.46,320,24241,70,NULL,NULL,'SDSS J100527.41+370309.3',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.5g',0.31,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,151.36425,37.05258,0.013,NULL,64071776963,1001121515,15642523,16.5),(67649,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67649,37.99,0.23,397,24242,70,NULL,NULL,'2MASX J10052753+2905055',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,151.36475,29.08483,0.057,NULL,64162761824,1002543153,15664736,18),(67650,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1996T','R',67650,39.55,NULL,656,24243,65,NULL,'SALT','[GC96a] J100527.66-072723.9',0.24,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,151.36525,-7.45664,0.097,NULL,41276812063,644950188,10077346,NULL),(67651,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1996T',NULL,67651,40.68,0.43,1100,24243,65,NULL,'Snapshot','[GC96a] J100527.66-072723.9',0.24,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67652,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1996T',NULL,67652,40.68,0.43,1100,24243,65,NULL,NULL,'[GC96a] J100527.66-072723.9',0.24,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67653,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1996T',NULL,67653,40.89,0.28,1220,24243,70,NULL,'SALT','[GC96a] J100527.66-072723.9',0.24,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67654,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1996T',NULL,67654,41.09,0.27,1330,24243,65,NULL,'SALT','[GC96a] J100527.66-072723.9',0.24,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67655,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67655,37.56,0.46,326,24244,70,NULL,NULL,'2MASX J10052835+3420445',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,151.368167,34.34561,0.009,NULL,64061365956,1000958843,15639981,17.7),(67656,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67656,37.32,0.46,291,24245,70,NULL,NULL,'2MASX J10052878+0221560',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000086,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,151.369875,2.36561,0.005,NULL,60772511881,949570498,14837039,17.9),(67657,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67657,36.01,0.46,159,24246,70,NULL,NULL,'2MASX J10052921+5557147',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000176,NULL,'15.6g',0.46,'E0',NULL,NULL,NULL,NULL,1,151.3715417,55.95403,0,NULL,61934158178,967721221,15120644,15.6),(67658,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67658,37.48,0.46,314,24247,70,NULL,NULL,'SDSS J100529.32-003553.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000046,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,151.3722083,-0.59822,0.101,NULL,41231029750,644234839,10066169,18.6),(67659,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67659,37.16,0.46,270,24248,70,NULL,NULL,'2MASX J10053055+4637111',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000147,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,151.37725,46.61986,0,NULL,64005244340,1000081942,15626280,17.9),(67660,'Brightest Stars','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67660,28.61,NULL,5.27,24249,NULL,NULL,NULL,'UGC 05423',NULL,'1999AstL...25..322S',1999,1,0.9,NULL,'G',0.000002,NULL,'15.19',0.6,'Im','Possible field galaxy',NULL,NULL,NULL,1,151.3775,70.36444,0.185,NULL,62097979644,970280931,15160639,15.19),(67661,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67661,29.7,0.03,8.71,24249,NULL,NULL,'I','UGC 05423',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67662,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67662,29.74,0.1,8.87,24249,74.4,NULL,NULL,'UGC 05423',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67663,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67663,29.76,0.4,9,24249,75,NULL,'B','UGC 05423',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67664,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67664,35.57,0.46,130,24250,70,NULL,NULL,'2MASX J10053101+4434011',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000185,NULL,'15.8g',0.31,'E0',NULL,NULL,NULL,NULL,1,151.379375,44.56717,0,NULL,64097858914,1001529045,15648891,15.8),(67665,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67665,37.27,0.46,284,24251,70,NULL,NULL,'2MASX J10053173+4943359',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000183,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,151.382416667,49.72658,0,NULL,63998974318,999983973,15624749,16.9),(67666,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67666,35.76,0.55,142,24252,70,NULL,NULL,'2MASX J10053215-6852557',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,151.383833333,-68.88219,0.701,NULL,40722476136,636288689,9942010,16.3),(67667,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67667,36.96,0.46,247,24253,70,NULL,NULL,'2MASX J10053357+0836241',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000167,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,151.389791667,8.60672,0.013,NULL,60879387299,951240426,14863131,17.1),(67668,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67668,38.06,0.46,410,24254,70,NULL,NULL,'2MASX J10053453+0005234',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000079,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,151.393875,0.08978,0.049,NULL,60771460488,949554070,14836782,17.7),(67669,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67669,36.2,0.46,174,24255,70,NULL,NULL,'2MASX J10053451+2421127',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000182,NULL,'15.9g',0.34,NULL,NULL,NULL,NULL,NULL,1,151.393917,24.35356,0.101,NULL,64156603047,1002446922,15663233,15.9),(67670,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67670,37.29,0.46,287,24256,70,NULL,NULL,'2MASX J10053459+4834520',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000166,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,151.394333,48.581,0,NULL,63999267818,999988559,15624821,17.1),(67671,'SBF','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67671,29.01,0.27,6.3,24257,NULL,NULL,'R','UGCA 200',NULL,'2005A&A...437..823R',2005,1,1.1,NULL,'G',0.0001,NULL,'16.1B',0.7,'Im:',NULL,NULL,NULL,NULL,1,151.39625,-7.75,0.105,NULL,41280086741,645001355,10078146,16.1),(67672,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67672,36.89,0.19,239,24258,70,NULL,NULL,'2MASX J10053516+5014450',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,151.396667,50.24578,0,NULL,64000982969,1000015358,15625239,17.4),(67673,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67673,37.87,0.46,375,24259,70,NULL,NULL,'2MASX J10053532+3136245',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,151.397083,31.60697,0.057,NULL,64030849325,1000482020,15632531,17.9),(67674,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67674,36.19,0.46,173,24260,70,NULL,NULL,'2MASX J10053599+3644240',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000183,NULL,'15.8g',0.37,'S0',NULL,NULL,NULL,NULL,1,151.4000417,36.74011,0.013,NULL,64071919816,1001123747,15642558,15.8),(67675,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67675,37.17,0.46,271,24261,70,NULL,NULL,'2MASX J10053652+4016130',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000145,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,151.4022917,40.27031,0.009,NULL,64104472593,1001632384,15650506,17.7),(67676,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67676,37.75,0.46,354,24262,70,NULL,NULL,'SDSS J100536.88+294236.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000141,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,151.4037083,29.71008,0.065,NULL,64031838233,1000497472,15632773,18.3),(67677,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67677,36.89,0.46,239,24263,70,NULL,NULL,'2MASX J10053810+3754220',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000174,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,151.408833,37.90614,0,NULL,64069900276,1001092191,15642065,16.9),(67678,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67678,37.15,0.46,269,24264,70,NULL,NULL,'2MASX J10053853+0938551',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000146,NULL,'17.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,151.410666667,9.64861,0.049,NULL,60881146450,951267913,14863561,17.7),(67679,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67679,38,0.33,399,24265,70,NULL,NULL,'SDSS J100538.88+432040.4',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,151.4120417,43.34458,0,NULL,64100636210,1001572440,15649569,17.9),(67680,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67680,38.07,0.33,411,24266,70,NULL,NULL,'SDSS J100539.20+005111.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00007,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,151.413375,0.85328,0.029,NULL,60771743186,949558487,14836851,18.3),(67681,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67681,31.16,0.43,17,24267,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3057',NULL,'2014MNRAS.444..527S',2014,1,2.2,NULL,'G',0.000013,NULL,'13.49',1.3,'SB(s)dm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,151.414,80.28569,0.025,NULL,61434593449,959915522,14998680,13.49),(67682,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67682,32.05,0.4,25.7,24267,75,NULL,'B','NGC 3057',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67683,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67683,34.45,0.49,77.7,24268,NULL,NULL,'Malmquist cor.','ESO 374- G 030',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000007,NULL,'15.12',0.5,'Sc',NULL,NULL,NULL,NULL,1,151.414833333,-37.08761,0.405,NULL,41974859488,655857179,10247768,15.12),(67684,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67684,34.71,0.44,87.5,24268,NULL,NULL,NULL,'ESO 374- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67685,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67685,34.75,0.2,89.1,24268,74.4,NULL,NULL,'ESO 374- G 030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67686,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67686,37.2,0.46,275,24269,70,NULL,NULL,'2MASX J10054015+5401577',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00014,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,151.417458333,54.03267,0,NULL,61903315775,967239308,15113114,17.7),(67687,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67687,37.57,0.33,326,24270,70,NULL,NULL,'2MASX J10054094+1819294',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,151.4204583,18.32486,0.077,NULL,60805931768,950092683,14845198,17.8),(67688,'GCLF','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67688,30.3,0.8,11,24271,NULL,NULL,NULL,'NGC 3115 DW01',NULL,'1996ApJ...463..543D',1996,1,1.7,'Huchtmaier et al. (2001A&A...377..801H) give v = 134 +/- 3 km/sec.','G',0.00014,NULL,'13.3B',1.4,'SA(s)0^0^ pec:',NULL,NULL,NULL,NULL,1,151.423333,-7.9815,0.165,NULL,41280324198,645005065,10078204,13.3),(67689,'GCLF','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67689,30.53,0.84,12.8,24271,NULL,NULL,'HST KP Calibrated, V','NGC 3115 DW01',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67690,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67690,29.84,0.45,9.3,24271,NULL,NULL,'K','NGC 3115 DW01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67691,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67691,30.61,0.4,13.3,24271,NULL,NULL,'mean','NGC 3115 DW01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67692,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67692,36.81,0.33,231,24272,70,NULL,NULL,'2MASX J10054346+4849590',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,151.43125,48.83297,0.009,NULL,63999253719,999988339,15624817,17.1),(67693,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67693,38.6,0.46,526,24273,70,NULL,NULL,'2MASX J10054398+5517546',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000179,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,151.433416667,55.29842,0.005,NULL,61902617499,967228398,15112943,17.4),(67694,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 2004ap',NULL,67694,34.47,0.3,76.4,24274,74.2,NULL,'SALT 2','CGCG 064-054',0.0251,'2010ApJ...716..712A',2010,1,0.84,NULL,'G',0.00015,NULL,'15.0g',0.49,'E2',NULL,NULL,NULL,NULL,1,151.4354583,10.27678,0.045,NULL,60880893881,951263966,14863499,15),(67695,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 2004ap',NULL,67695,35.05,0.1,102,24274,74.4,NULL,NULL,'CGCG 064-054',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67696,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67696,34.91,0.33,95.7,24274,70,NULL,NULL,'CGCG 064-054',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67697,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1999M',NULL,67697,41.02,0.81,1070,24275,65,NULL,NULL,'H-ZSNS J100546.60-072731.3',0.5,'2006ApJ...642....1C',2006,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,151.444167,-7.45869,0.097,NULL,41276866065,644951032,10077359,NULL),(67698,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67698,38.07,0.33,411,24276,70,NULL,NULL,'2MASX J10054776+0052471',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000077,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,151.449208333,0.87969,0.029,NULL,60771744126,949558501,14836851,17.4),(67699,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67699,33.57,0.69,51.6,24277,100,NULL,'mid-IR','IC 2541',NULL,'2013ApJ...771...88L',2013,1,1.3,NULL,'G',0.000103,NULL,'13.66',0.5,'SA:(r)b        HII',NULL,NULL,NULL,NULL,1,151.4500417,-17.43456,0.117,NULL,41200771198,643762049,10058782,13.66),(67700,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67700,34.26,0.47,71.3,24277,NULL,NULL,'H','IC 2541',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67701,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67701,34.3,0.46,72.3,24277,NULL,NULL,'J','IC 2541',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67702,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67702,34.33,0.45,73.3,24277,NULL,NULL,'K','IC 2541',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67703,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67703,34.34,0.38,73.9,24277,NULL,NULL,'Malmquist cor.','IC 2541',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67704,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67704,34.39,0.4,75.6,24277,NULL,NULL,'mean','IC 2541',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67705,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67705,34.59,0.34,82.6,24277,NULL,NULL,NULL,'IC 2541',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67706,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67706,34.63,0.2,84.3,24277,74.4,NULL,NULL,'IC 2541',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67707,'SBF','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67707,31.93,0.14,24.3,24278,74.4,NULL,NULL,'NGC 3136',NULL,'2013AJ....146...86T',2013,1,3.1,NULL,'G',0.0001,NULL,'11.7',2.1,'E:          LINER/Sy',NULL,NULL,NULL,NULL,1,151.450667,-67.37797,NULL,NULL,40692952341,635827380,9934802,11.7),(67708,'SBF','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67708,31.95,0.22,24.5,24278,NULL,NULL,'I','NGC 3136',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67709,'SBF','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67709,31.95,0.22,24.5,24278,NULL,NULL,NULL,'NGC 3136',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67710,'SBF','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67710,32.03,0.22,25.4,24278,NULL,NULL,'Malmquist cor.','NGC 3136',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67711,'D-Sigma','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67711,31.94,0.4,24.4,24278,75,NULL,'Edat, raw','NGC 3136',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67712,'D-Sigma','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67712,32.14,0.4,26.8,24278,75,NULL,'Edat, cor','NGC 3136',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67713,'Faber-Jackson','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67713,30.77,0.65,14.3,24278,95,NULL,'Weighted Mean','NGC 3136',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67714,'Faber-Jackson','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67714,31.93,0.81,24.3,24278,55,NULL,'Visvanathan & Sandage 1979','NGC 3136',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67715,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67715,31.63,0.41,21.2,24278,NULL,NULL,NULL,'NGC 3136',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67716,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67716,31.9,0.41,24,24278,NULL,NULL,'Malmquist cor.','NGC 3136',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67717,'Tully est','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67717,31.56,0.8,20.5,24278,75,NULL,'B','NGC 3136',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67718,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67718,37.01,0.46,253,24279,70,NULL,NULL,'SDSS J100548.65+323801.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000128,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,151.45275,32.63375,0.033,NULL,64077071049,1001204235,15643816,18.3),(67719,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67719,35.17,0.56,108,24280,NULL,NULL,NULL,'ESO 567- G 013',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.00002,NULL,'15.19',0.8,'SA(rs)c',NULL,NULL,NULL,NULL,1,151.453083,-18.24647,0.121,NULL,41148233633,642941150,10045955,15.19),(67720,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67720,35.21,0.2,110,24280,74.4,NULL,NULL,'ESO 567- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67721,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67721,35.32,0.52,116,24280,NULL,NULL,'Malmquist cor.','ESO 567- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67722,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67722,37.41,0.46,304,24281,70,NULL,NULL,'2MASX J10054994+4536202',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000152,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,151.458083333,45.60544,0,NULL,63975903878,999623498,15619117,17.1),(67723,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67723,34.87,0.4,94.1,24282,NULL,NULL,'mean','IC 0590',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'GPair',0.000177,NULL,NULL,NULL,'DBL SYS',NULL,NULL,NULL,NULL,1,151.459291667,0.63294,0.037,NULL,60772212298,949565817,14836965,NULL),(67724,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67724,34.93,0.45,96.7,24282,NULL,NULL,'K','IC 0590',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67725,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67725,36.74,0.46,223,24283,70,NULL,NULL,'2MASX J10055718+1206133',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000166,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,151.488375,12.10389,0.089,NULL,60874510070,951164219,14861940,16.6),(67726,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67726,37.75,0.46,354,24284,70,NULL,NULL,'2MASX J10055746+0544351',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,151.489417,5.74306,0.005,NULL,60784756537,949761820,14840028,18),(67727,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67727,37.95,0.46,389,24285,70,NULL,NULL,'SDSS J100557.91+093027.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00017,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,151.491333333,9.50775,0.033,NULL,60880700295,951260942,14863452,18.3),(67728,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67728,38.63,0.46,533,24286,70,NULL,NULL,'2MASX J10055978+4040355',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000198,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,151.49925,40.67647,0,NULL,64103973220,1001624581,15650384,17.7),(67729,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67729,37.6,0.46,331,24287,70,NULL,NULL,'2MASX J10060298+3558355',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000164,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,151.512583,35.97669,0.009,NULL,64068838010,1001075593,15641806,16.4),(67730,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67730,35.04,0.33,102,24288,70,NULL,NULL,'CGCG 036-037',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000157,NULL,'15.6g',0.28,'S0/a',NULL,NULL,NULL,NULL,1,151.513,3.10981,0,NULL,60798546175,949977283,14843395,15.6),(67731,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67731,37.88,0.33,377,24289,70,NULL,NULL,'2MASX J10060346+1117372',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000205,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,151.514458333,11.29367,0.089,NULL,60874729652,951167650,14861994,16.7),(67732,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67732,36.36,0.46,187,24290,70,NULL,NULL,'2MASX J10060420-0048505',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000077,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,151.517416667,-0.81425,0.117,NULL,41230630608,644228603,10066071,16.4),(67733,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67733,37.57,0.33,326,24291,70,NULL,NULL,'2MASX J10060434+1818217',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,151.5182083,18.30589,0.077,NULL,60813229576,950206712,14846979,17.7),(67734,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67734,37.98,0.46,394,24292,70,NULL,NULL,'SDSS J100606.23+092620.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,151.526,9.43917,0.033,NULL,60880821279,951262832,14863481,18.3),(67735,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67735,33.92,0.49,60.9,24293,75,NULL,'IR','ESO 213- G 006',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000267,NULL,'16.1',0.27,'S...',NULL,NULL,NULL,NULL,1,151.526791667,-50.61103,NULL,NULL,42040477511,656882461,10263788,16.1),(67736,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67736,37.88,0.33,377,24294,70,NULL,NULL,'2MASX J10060666+1118022',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,151.5277083,11.30069,0.089,NULL,60874731932,951167686,14861995,17.9),(67737,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67737,37.79,0.27,362,24295,70,NULL,NULL,'2MASX J10060674+1512103',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,151.5282083,15.20286,0.061,NULL,60865831292,951028613,14859822,18.1),(67738,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67738,38.42,0.33,482,24296,70,NULL,NULL,'SDSS J100607.18+175208.8',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.7g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,151.529958333,17.86917,0.081,NULL,60863592613,950993634,14859275,17.7),(67739,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67739,34.6,0.46,83.1,24297,70,NULL,NULL,'NGC 3111',NULL,'2015arXiv151105856S',2015,1,1.15,'Alonso et al. (2003AJ....125.2307A) give v = 4414 km/sec.','G',0.000167,NULL,'13.7g',1.02,'S0-:','Field galaxy',NULL,NULL,NULL,1,151.531,47.26264,0,NULL,64005528801,1000086387,15626349,13.7),(67740,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67740,38.46,0.46,491,24298,70,NULL,NULL,'2MASX J10060792+4230416',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,151.533,42.51164,0,NULL,64103127579,1001611368,15650177,18),(67741,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67741,38,0.33,399,24299,70,NULL,NULL,'2MASX J10060806+4326596',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000185,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,151.533417,43.45006,0,NULL,64100684169,1001573190,15649581,16.8),(67742,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67742,34.88,0.46,94.4,24300,70,NULL,NULL,'2MASX J10060995-3944369',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000097,NULL,'13.0R',NULL,'E/D',NULL,NULL,NULL,NULL,1,151.5415417,-39.74356,0.521,NULL,42091061211,657672831,10276137,13),(67743,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67743,35.04,0.33,102,24301,70,NULL,NULL,'NGC 3117',NULL,'2015arXiv151105856S',2015,1,0.98,NULL,'G',0.000143,NULL,'14.3g',0.85,'E?',NULL,NULL,NULL,NULL,1,151.54375,2.91286,0,NULL,60790208697,949847010,14841359,14.3),(67744,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67744,37.52,0.46,320,24302,70,NULL,NULL,'2MASX J10061105+2448434',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,151.5460417,24.81228,0.081,NULL,64159580235,1002493441,15663960,17.9),(67745,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67745,36.82,0.46,232,24303,70,NULL,NULL,'2MASX J10061169+5622344',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000125,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,151.548875,56.37622,0,NULL,61938463585,967788493,15121695,17.2),(67746,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67746,36.72,0.46,220,24304,70,NULL,NULL,'2MASX J10061220+1556161',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.0g',0.33,NULL,NULL,NULL,NULL,NULL,1,151.5507917,15.93781,0.081,NULL,60866101830,951032841,14859888,16),(67747,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67747,34.26,0.49,71.3,24305,75,NULL,'IR','MCG -03-26-021',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.00003,NULL,'14.5',0.2,'Sc             HII','in a triple',NULL,NULL,NULL,1,151.5625417,-16.02522,0.121,NULL,41202432926,643788014,10059187,14.5),(67748,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67748,34.33,NULL,73.6,24305,NULL,NULL,NULL,'MCG -03-26-021',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67749,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67749,34.4,0.36,75.7,24305,NULL,NULL,'Malmquist cor.','MCG -03-26-021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67750,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67750,34.57,0.33,82.2,24305,NULL,NULL,NULL,'MCG -03-26-021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67751,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67751,34.59,NULL,82.8,24305,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -03-26-021',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67752,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67752,34.61,0.2,83.6,24305,74.4,NULL,NULL,'MCG -03-26-021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67753,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67753,34.62,NULL,83.8,24305,NULL,NULL,'Dipole + Quadrupole','MCG -03-26-021',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67754,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67754,34.62,NULL,84.1,24305,NULL,NULL,'Dipole','MCG -03-26-021',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67755,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67755,38.01,0.33,400,24306,70,NULL,NULL,'2MASX J10061535+0713117',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00012,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,151.563917,7.21997,0.013,NULL,60876644812,951197575,14862462,17.3),(67756,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67756,38.42,0.33,482,24307,70,NULL,NULL,'2MASX J10061543+1756042',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,151.564333,17.93456,0.081,NULL,60856233804,950878653,14857478,17.7),(67757,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67757,37.76,0.46,356,24308,70,NULL,NULL,'SDSS J100615.48+063654.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000105,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,151.5645417,6.61514,0.017,NULL,60755396638,949303072,14832860,18.6),(67758,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67758,35.89,0.7,151,24309,70,NULL,NULL,'2MASX J10061580-3927499',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,151.56575,-39.46394,0.597,NULL,42091052452,657672694,10276135,15.3),(67759,'Tully est','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67759,31.87,0.8,23.6,24310,75,NULL,'B','UGCA 201',NULL,'1988NBGC.C....0000T',1988,1,0.81,NULL,'G',0.000023,NULL,'14.3g',0.77,'S?;WR?         Sbrst',NULL,NULL,NULL,NULL,1,151.5754583,28.94456,0.053,NULL,64031440060,1000491250,15632675,14.3),(67760,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67760,38.01,0.33,400,24311,70,NULL,NULL,'2MASX J10061905+0717247',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000191,NULL,'16.9g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,151.57925,7.29031,0.013,NULL,60876652130,951197689,14862463,16.9),(67761,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67761,36.47,0.27,197,24312,70,NULL,NULL,'MCG +09-17-024',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000216,NULL,'15.4g',0.59,'AGN',NULL,NULL,NULL,NULL,1,151.593625,52.81339,0.009,NULL,63994936731,999920886,15623763,15.4),(67762,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67762,36.89,0.46,239,24313,70,NULL,NULL,'2MASX J10062395+0310047',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,151.5997083,3.16811,0,NULL,60798597677,949978088,14843407,17.3),(67763,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67763,37.79,0.27,362,24314,70,NULL,NULL,'SDSS J100624.05+151056.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,151.6002083,15.18222,0.089,NULL,60865803840,951028185,14859815,18.2),(67764,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67764,37.19,0.46,274,24315,70,NULL,NULL,'2MASX J10062505+3054079',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000175,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,151.6044583,30.90233,0.061,NULL,64031038173,1000484971,15632577,16.6),(67765,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67765,34.39,0.57,75.4,24316,NULL,NULL,'Malmquist cor.','ESO 567- G 015',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.5',0.6,'S...',NULL,NULL,NULL,NULL,1,151.6044583,-18.27522,0.133,NULL,41142983474,642859116,10044673,14.5),(67766,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67766,34.58,0.52,82.5,24316,NULL,NULL,NULL,'ESO 567- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67767,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67767,34.62,0.2,84,24316,74.4,NULL,NULL,'ESO 567- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67768,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67768,37.73,0.46,352,24317,70,NULL,NULL,'2MASX J10062668-0033015',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000077,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,151.61125,-0.55036,0.065,NULL,41230192823,644221762,10065965,17.4),(67769,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67769,37.1,0.33,263,24318,70,NULL,NULL,'SDSS J100627.07+005753.2',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000085,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,151.6127917,0.96481,0.029,NULL,60771686365,949557599,14836837,17.3),(67770,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67770,37.91,0.46,382,24319,70,NULL,NULL,'SDSS J100627.26+574536.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000174,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,151.613625,57.76003,0,NULL,61926587087,967602923,15118795,18.2),(67771,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67771,37.79,0.27,362,24320,70,NULL,NULL,'2MASX J10062751+1506282',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,151.614708333,15.10781,0.089,NULL,60852111886,950814248,14856472,17.2),(67772,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67772,35.65,0.54,135,24321,70,NULL,NULL,'2MASX J10062903-0622216',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'15.42',0.47,NULL,NULL,NULL,NULL,NULL,1,151.6210417,-6.37267,0.085,NULL,41247659703,644494682,10070229,15.42),(67773,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67773,36.93,0.46,243,24322,70,NULL,NULL,'2MASX J10062905+2225056',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000148,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,151.621167,22.41817,0.089,NULL,63688919180,995139362,15549052,16.7),(67774,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67774,36.65,0.46,213,24323,70,NULL,NULL,'2MASX J10062940+3717320',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,151.6225,37.29233,0.017,NULL,64069815646,1001090869,15642044,17.1),(67775,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67775,32.76,0.5,35.6,24324,NULL,NULL,'Malmquist cor.','UGC 05446',NULL,'2009ApJS..182..474S',2009,1,1.13,NULL,'G',0.000011,NULL,'15.3g',0.31,'Scd:',NULL,NULL,NULL,NULL,1,151.6289583,32.94694,0.029,NULL,64077135091,1001205235,15643831,15.3),(67776,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67776,32.89,0.47,37.9,24324,NULL,NULL,NULL,'UGC 05446',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67777,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67777,32.94,0.2,38.7,24324,74.4,NULL,NULL,'UGC 05446',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67778,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67778,37.1,0.33,263,24325,70,NULL,NULL,'2MASX J10063155+0108296',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000188,NULL,'15.7g',0.48,'E0',NULL,NULL,NULL,NULL,1,151.6315,1.14169,0.041,NULL,60771568127,949555751,14836808,15.7),(67779,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67779,37.4,0.46,303,24326,70,NULL,NULL,'2MASX J10063248+0020116',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000117,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,151.635291667,0.3365,0.033,NULL,60771521237,949555019,14836797,17.2),(67780,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67780,37.61,0.83,333,24327,70,NULL,NULL,'2MASX J10063306-1125515',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.5,NULL,NULL,NULL,NULL,NULL,1,151.6377917,-11.43103,0.217,NULL,41282211317,645034551,10078664,14.3),(67781,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67781,37.82,0.46,366,24328,70,NULL,NULL,'2MASX J10063396+2406384',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,151.641541667,24.11069,0.105,NULL,63686792712,995106136,15548533,17.6),(67782,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67782,36.53,0.65,202,24329,70,NULL,NULL,'ESO 567- G 016',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.88',0.5,'(R)SAB(rl)a:',NULL,NULL,NULL,NULL,1,151.643917,-22.08322,NULL,NULL,42280231771,660628621,10322322,15.88),(67783,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67783,36.86,0.6,235,24330,70,NULL,NULL,'2MASX J10063467-1947157',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000103,NULL,'14.7I',0.3,NULL,NULL,NULL,NULL,NULL,1,151.644458333,-19.78764,0.197,NULL,41154213416,643034584,10047415,14.7),(67784,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67784,36.03,0.46,161,24331,70,NULL,NULL,'2MASX J10063561+3614450',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000169,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,151.648417,36.24597,0.005,NULL,64068381274,1001068457,15641694,16.8),(67785,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67785,36.96,0.46,247,24332,70,NULL,NULL,'2MASX J10063684+1509261',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00008,NULL,'16.98',0.38,NULL,NULL,NULL,NULL,NULL,1,151.6535417,15.15725,0.089,NULL,60865790465,951027976,14859812,16.98),(67786,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67786,37.77,0.46,358,24333,70,NULL,NULL,'2MASX J10063685+0723197',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000192,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,151.65375,7.38886,0.013,NULL,60876631409,951197365,14862458,16.5),(67787,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67787,37.21,0.73,277,24334,70,NULL,NULL,'2MASX J10063693-0453241',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'16.3b',0.27,NULL,NULL,NULL,NULL,NULL,1,151.6540417,-4.89017,0.065,NULL,41258792772,644668637,10072947,16.3),(67788,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67788,37.72,0.46,349,24335,70,NULL,NULL,'2MASX J10063754+3826310',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,151.656333333,38.44206,0,NULL,64065083017,1001016922,15640889,17.4),(67789,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67789,37.68,0.46,344,24336,70,NULL,NULL,'2MASX J10063761+0731577',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000144,NULL,'16.7g',0.35,NULL,NULL,NULL,NULL,NULL,1,151.656833,7.53264,0,NULL,60876620363,951197193,14862456,16.7),(67790,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67790,35.38,0.27,119,24337,70,NULL,NULL,'CGCG 064-061',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000077,NULL,'15.7',0.38,NULL,NULL,NULL,NULL,NULL,1,151.65775,13.73297,0.097,NULL,60845459284,950710301,14854848,15.7),(67791,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67791,37.32,0.46,291,24338,70,NULL,NULL,'2MASX J10063800+0931537',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000188,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,151.6582917,9.53153,0.033,NULL,60884143572,951314743,14864292,17),(67792,'Ring Diameter','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67792,32.8,0.84,37,24339,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3124',NULL,'1981ApJS...45..541P',1981,1,3,NULL,'G',0.000013,NULL,'12.86',2.5,'SB(r)c','in a pair',NULL,NULL,NULL,1,151.66625,-19.22158,0.165,NULL,41151252070,642988313,10046692,12.86),(67793,'Sosies','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67793,32.94,0.57,38.7,24339,NULL,NULL,NULL,'NGC 3124',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67794,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67794,33.17,0.47,43,24339,NULL,NULL,'H','NGC 3124',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67795,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67795,33.23,0.45,44.3,24339,NULL,NULL,'K','NGC 3124',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67796,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67796,33.25,0.46,44.6,24339,NULL,NULL,'J','NGC 3124',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67797,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67797,33.71,0.4,55.3,24339,NULL,NULL,'mean','NGC 3124',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67798,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67798,37.79,0.46,361,24340,70,NULL,NULL,'2MASX J10064021+0308246',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,151.667667,3.14008,0.013,NULL,60798557265,949977457,14843397,17.8),(67799,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67799,37.59,0.46,330,24341,70,NULL,NULL,'2MASX J10064059+2901452',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'16.29',0.29,'Sb',NULL,NULL,NULL,NULL,1,151.6692917,29.02919,0.057,NULL,64032153444,1000502397,15632849,16.29),(67800,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67800,32.3,0.54,28.8,24342,70,NULL,NULL,'ESO 316- G 026',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000103,NULL,'14.38',0.5,'Sa:',NULL,NULL,NULL,NULL,1,151.672917,-41.11819,0.729,NULL,42093884622,657716947,10276827,14.38),(67801,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67801,38.18,0.13,433,24343,70,NULL,NULL,'SDSS J100641.73+002043.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,151.673917,0.34536,0.033,NULL,60771508161,949554815,14836793,18.2),(67802,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67802,37.8,0.68,363,24344,70,NULL,NULL,'2MASX J10064315-0711554',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.39',0.33,NULL,NULL,NULL,NULL,NULL,1,151.679875,-7.19867,0.045,NULL,41276903037,644951609,10077368,16.39),(67803,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67803,37.28,0.46,285,24345,70,NULL,NULL,'2MASX J10064386+4413331',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,151.682625,44.22597,0,NULL,64101220319,1001581567,15649711,17),(67804,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67804,37.03,0.46,255,24346,70,NULL,NULL,'2MASX J10064458+4353191',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000192,NULL,'15.7g',0.47,'AGN',NULL,NULL,NULL,NULL,1,151.68575,43.88858,0,NULL,64101518976,1001586234,15649784,15.7),(67805,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67805,38.18,0.13,433,24347,70,NULL,NULL,'SDSS J100644.97+002334.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000068,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,151.687416667,0.39283,0.033,NULL,60771380966,949552827,14836762,18.6),(67806,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67806,27.8,0.14,3.6,24348,NULL,NULL,NULL,'MESSIER 081:[CKT2009] d1006+67',NULL,'2013AJ....146..126C',2013,1,NULL,NULL,'G',NULL,NULL,'21.0B',NULL,'dSph',NULL,NULL,NULL,NULL,1,151.6925,67.20111,0.121,NULL,62120914595,970639290,15166238,21),(67807,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67807,37.22,0.46,278,24349,70,NULL,NULL,'2MASX J10064658+2927112',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000171,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,151.694125,29.45328,0.061,NULL,64032017102,1000500267,15632816,17.7),(67808,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67808,35.41,0.46,121,24350,70,NULL,NULL,'IC 2540',NULL,'2015arXiv151105856S',2015,1,0.95,NULL,'G',0.000083,NULL,'14.7g',0.58,'E?',NULL,NULL,NULL,NULL,1,151.694625,31.47572,0.061,NULL,64030876133,1000482439,15632538,14.7),(67809,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67809,35.38,0.27,119,24351,70,NULL,NULL,'CGCG 093-045',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000073,NULL,'15.3',0.51,NULL,'Group member',NULL,NULL,NULL,1,151.699375,14.31417,0.089,NULL,60845633932,950713030,14854891,15.3),(67810,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN PTF11qmo',NULL,67810,36.82,0.19,231,24352,72,NULL,'M(H) = -18.317 mag','2MASX J10064866-0741124',NULL,'2014ApJ...784..105W',2013,1,0.59,NULL,'G',0.00015,NULL,'15.46',0.4,NULL,NULL,NULL,NULL,NULL,1,151.70275,-7.68703,0.105,NULL,41279798900,644996857,10078075,15.46),(67811,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67811,38.07,0.33,412,24353,70,NULL,NULL,'2MASX J10065057+2920012',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000117,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,151.710625,29.33361,0.053,NULL,64031901888,1000498467,15632788,17.5),(67812,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67812,37.82,0.46,367,24354,70,NULL,NULL,'VII Zw 310',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.7',0.31,NULL,NULL,NULL,NULL,NULL,1,151.715833,69.54575,0.093,NULL,62128951169,970764862,15168200,17.7),(67813,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67813,35.53,0.45,128,24355,NULL,NULL,'K','NGC 3119',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000017,NULL,'14.2',0.9,'E','Pair member (points to parent)',NULL,'FR I','Flat-Spectrum Radio Source',1,151.716125,14.37353,0.093,NULL,60845628133,950712939,14854889,14.2),(67814,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67814,35.67,0.4,136,24355,NULL,NULL,'mean','NGC 3119',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67815,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67815,36.5,0.63,200,24356,70,NULL,NULL,'2MASX J10065207-1418052',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.0I',0.3,NULL,NULL,NULL,NULL,NULL,1,151.717,-14.30133,0.237,NULL,41160629276,643134832,10048981,14),(67816,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67816,38.35,0.46,468,24357,70,NULL,NULL,'2MASX J10065292+3925140',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,151.720583333,39.4205,0,NULL,64095415486,1001490866,15648294,17.7),(67817,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67817,37.24,0.46,280,24358,70,NULL,NULL,'2MASX J10065332+1213567',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000186,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,151.722167,12.23244,0.097,NULL,60844268744,950691699,14854557,17.8),(67818,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67818,35.27,0.47,113,24359,70,NULL,NULL,'2MASX J10065350-1543022',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.74',NULL,NULL,NULL,NULL,NULL,NULL,1,151.72275,-15.71744,0.145,NULL,41202575655,643790244,10059222,15.74),(67819,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67819,37.56,0.46,326,24360,70,NULL,NULL,'2MASX J10065514+4759024',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000194,NULL,'16.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,151.7295417,47.98411,0,NULL,63997270308,999957348,15624333,16.4),(67820,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67820,37.42,0.46,305,24361,70,NULL,NULL,'SDSS J100655.86+612913.8',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000152,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,151.73275,61.48719,0.029,NULL,61912108063,967376688,15115260,17.7),(67821,'IRAS','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67821,33.55,0.8,51.2,24362,75,NULL,'HMCL, I','ESO 263- G 005',NULL,'1997ApJS..109..333W',1997,1,1.9,'Confused HIPASS source','G',0.000025,NULL,'13.81',0.6,'SAB(rs)bc:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,151.732917,-45.04656,NULL,NULL,42082344679,657536635,10274009,13.81),(67822,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67822,32.87,0.4,37.5,24362,75,NULL,'HMCL, I, raw','ESO 263- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67823,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67823,33.03,0.4,40.3,24362,75,NULL,'HMCL, I, inv','ESO 263- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67824,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67824,33.09,0.4,41.6,24362,75,NULL,'HMCL, I, cor','ESO 263- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67825,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67825,33.35,0.47,46.7,24362,NULL,NULL,'H','ESO 263- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67826,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67826,33.39,0.46,47.7,24362,NULL,NULL,'J','ESO 263- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67827,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67827,33.47,0.45,49.4,24362,NULL,NULL,'K','ESO 263- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67828,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67828,33.65,0.4,53.6,24362,NULL,NULL,'mean','ESO 263- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67829,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67829,36.33,0.46,185,24363,70,NULL,NULL,'2MASX J10065642+3716484',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000165,NULL,'15.9g',0.42,'E0',NULL,NULL,NULL,NULL,1,151.735083333,37.28006,0.017,NULL,64069587704,1001087307,15641989,15.9),(67830,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67830,38.07,0.33,412,24364,70,NULL,NULL,'2MASX J10065715+2926402',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000153,NULL,'16.15',0.27,'BrClG;E',NULL,NULL,NULL,NULL,1,151.738125,29.44467,0.061,NULL,64032018234,1000500284,15632816,16.15),(67831,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67831,37.76,0.46,356,24365,70,NULL,NULL,'2MASX J10065800+5224374',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,151.741625,52.41047,0.005,NULL,63995306384,999926662,15623854,17.5),(67832,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67832,37.9,0.46,381,24366,70,NULL,NULL,'2MASX J10065875+3936105',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000172,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,151.7449583,39.603,0,NULL,64103722086,1001620657,15650322,16.9),(67833,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67833,36.09,0.54,165,24367,70,NULL,NULL,'2MASX J10065924-0937264',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.36',0.4,NULL,NULL,NULL,NULL,NULL,1,151.746875,-9.62394,0.201,NULL,41288052554,645125821,10080090,16.36),(67834,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67834,35.06,0.69,103,24368,NULL,NULL,'Malmquist cor.','ESO 374- G 035',NULL,'2009ApJS..182..474S',2009,1,1.6,NULL,'G',0.000033,NULL,'16.49',0.3,'Sc',NULL,NULL,NULL,NULL,1,151.748,-34.35633,0.445,NULL,41971240275,655800629,10246884,16.49),(67835,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67835,35.18,0.65,108,24368,NULL,NULL,NULL,'ESO 374- G 035',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67836,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67836,35.22,0.2,111,24368,74.4,NULL,NULL,'ESO 374- G 035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67837,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67837,38.33,0.46,463,24369,70,NULL,NULL,'SDSS J100700.09+065409.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000133,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,151.750375,6.90261,0.017,NULL,60755106660,949298541,14832789,18.6),(67838,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67838,36.48,0.69,197,24370,70,NULL,NULL,'2MASX J10070053-1416102',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.9I',0.5,NULL,NULL,NULL,NULL,NULL,1,151.752125,-14.2695,0.213,NULL,41160746762,643136668,10049010,13.9),(67839,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67839,37.58,0.46,328,24371,70,NULL,NULL,'2MASX J10070159+4048255',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000159,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,151.756583333,40.80706,0,NULL,64105149188,1001642956,15650671,17.1),(67840,'SBF','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67840,27.74,0.18,3.5,24372,NULL,NULL,'R','UGC 05442',NULL,'2005A&A...437..823R',2005,1,1.8,NULL,'G',0.000043,NULL,'15.2B',0.9,'Im:','Brightest group member',NULL,NULL,NULL,1,151.757917,67.8275,0.113,NULL,62120023858,970625372,15166021,15.2),(67841,'SBF','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67841,27.9,0.27,3.8,24372,NULL,NULL,'T01','UGC 05442',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67842,'SBF','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67842,27.9,0.27,3.8,24372,NULL,NULL,'J03','UGC 05442',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67843,'SBF','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67843,28,0.27,3.98,24372,NULL,NULL,'BV A01','UGC 05442',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67844,'SBF','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67844,28.27,0.21,4.51,24372,NULL,NULL,'M06','UGC 05442',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67845,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67845,27.7,0.08,3.47,24372,NULL,NULL,'I','UGC 05442',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67846,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67846,27.84,NULL,3.7,24372,NULL,NULL,NULL,'UGC 05442',NULL,'2000A&A...363..117K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67847,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67847,27.84,0.08,3.7,24372,NULL,NULL,NULL,'UGC 05442',NULL,'2007ASPC..374..247D',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67848,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67848,27.84,0.04,3.7,24372,NULL,NULL,'I','UGC 05442',NULL,'2010MNRAS.406.1152M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67849,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67849,27.85,NULL,3.72,24372,NULL,NULL,NULL,'UGC 05442',NULL,'2010ApJ...724.1030G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67850,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67850,27.85,0.02,3.72,24372,NULL,NULL,'I','UGC 05442',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67851,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67851,27.86,0.08,3.74,24372,74.4,NULL,NULL,'UGC 05442',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67852,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67852,36.47,0.46,197,24373,70,NULL,NULL,'2MASX J10070295+2358277',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000191,NULL,'16.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,151.7624583,23.97433,0.117,NULL,63686781158,995105955,15548530,16),(67853,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67853,39.5,0.46,793,24374,70,NULL,NULL,'SDSS J100703.25+174736.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.7g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,151.763583,17.79344,0.077,NULL,60856410158,950881408,14857522,18.7),(67854,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67854,36.85,0.46,234,24375,70,NULL,NULL,'2MASX J10070371+5323595',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000155,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,151.7654583,53.39986,0,NULL,63995078066,999923094,15623798,17),(67855,'CMD','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67855,16.8,0.2,0.023,24376,NULL,NULL,NULL,'Segue 1',NULL,'2007ApJ...654..897B',2007,1,NULL,'Uncertain whether this is a dwarf galaxy or a globular cluster.','G',0.000003,NULL,'13.8V',NULL,'Globular cluster?',NULL,NULL,NULL,NULL,1,151.766667,16.08194,0.085,1,60866087824,951032622,14859884,13.8),(67856,'CMD','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67856,16.8,0.2,0.023,24376,NULL,NULL,NULL,'Segue 1',NULL,'2008AJ....135.1361D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67857,'CMD','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67857,16.81,NULL,0.023,24376,NULL,NULL,NULL,'Segue 1',NULL,'2015ApJ...811...35J',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67858,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67858,30.27,NULL,11.3,24377,NULL,NULL,NULL,'SDSS J100704.47+050024.6',NULL,'2015AstBu..70....1K',2015,1,0.47,NULL,'G',0.000006,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,151.768667,5.00683,0,NULL,60787804773,949809449,14840772,17),(67859,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67859,36.06,0.46,163,24378,70,NULL,NULL,'2MASX J10070489+0700587',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000183,NULL,'15.8g',0.37,'S0',NULL,NULL,NULL,NULL,1,151.770333,7.01625,0.017,NULL,60755252158,949300814,14832825,15.8),(67860,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67860,38.82,0.46,580,24379,70,NULL,NULL,'SDSS J100705.13+291001.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000181,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,151.771417,29.16717,0.057,NULL,64032195688,1000503057,15632860,18.2),(67861,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67861,38.64,0.46,534,24380,70,NULL,NULL,'2MASX J10070612+0735167',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,151.775375,7.58789,0,NULL,60879837895,951247467,14863241,17.9),(67862,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67862,38,0.46,398,24381,70,NULL,NULL,'2MASX J10070663+3935285',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.0002,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,151.7777083,39.59125,0,NULL,64103720262,1001620629,15650322,17.5),(67863,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67863,37.22,0.23,278,24382,70,NULL,NULL,'2MASX J10070719+2500012',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000199,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,151.779875,25.00019,0.081,NULL,64156733749,1002448964,15663265,16.2),(67864,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67864,37.22,0.46,278,24383,70,NULL,NULL,'2MASX J10070751+0746281',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000135,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,151.781167,7.77442,0,NULL,60880044835,951250700,14863292,17.1),(67865,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67865,37.46,0.46,311,24384,70,NULL,NULL,'2MASX J10070871+3743185',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000179,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,151.7864583,37.72183,0.013,NULL,64065245618,1001019462,15640929,16.8),(67866,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67866,32.13,0.68,26.6,24385,NULL,NULL,'Malmquist cor.','NGC 3118',NULL,'2009ApJS..182..474S',2009,1,1.42,NULL,'G',0.000004,NULL,'14.1g',0.49,'Sbc','Group member',NULL,NULL,NULL,1,151.798083,33.02739,0.037,NULL,64079806735,1001246980,15644484,14.1),(67867,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67867,32.24,0.4,28.1,24385,NULL,NULL,NULL,'NGC 3118',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67868,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67868,32.29,0.63,28.7,24385,NULL,NULL,NULL,'NGC 3118',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67869,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67869,32.33,0.2,29.2,24385,74.4,NULL,NULL,'NGC 3118',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67870,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67870,38.18,0.13,433,24386,70,NULL,NULL,'SDSS J100712.03+003518.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000075,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,151.800167,0.58861,0.041,NULL,60788237135,949816205,14840878,18.6),(67871,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67871,38.97,0.46,622,24387,70,NULL,NULL,'SDSS J100713.28+571327.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000176,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,151.805375,57.22436,0,NULL,61927871132,967622986,15119109,18.5),(67872,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67872,37.64,0.21,338,24388,70,NULL,NULL,'2MASX J10071519+4259200',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,'FoF','17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,151.813125,42.98906,0,NULL,64100745445,1001574147,15649596,17.1),(67873,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67873,37.57,0.46,327,24389,70,NULL,NULL,'2MASX J10071530+0031068',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000067,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,151.813875,0.51856,0.033,NULL,60788204875,949815701,14840870,17.9),(67874,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67874,37.22,0.23,278,24390,70,NULL,NULL,'2MASXi J1007161+245641',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.2g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,151.817167,24.94506,0.081,NULL,64156789274,1002449832,15663278,18.2),(67875,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67875,37.22,0.23,278,24391,70,NULL,NULL,'2MASX J10071699+2458467',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000154,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,151.820875,24.97964,0.081,NULL,64156789680,1002449838,15663278,16.7),(67876,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67876,37.22,0.23,278,24392,70,NULL,NULL,'SDSS J100717.21+245328.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'18.0g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,151.82175,24.89131,0.081,NULL,64156792176,1002449877,15663279,18),(67877,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67877,29.92,0.43,9.6,24393,75,NULL,'3.6 micron, color + selection bias corrected','UGC 05451',NULL,'2014MNRAS.444..527S',2014,1,1.8,NULL,'G',0.000017,NULL,'14.1g',0.71,'Im             HII','Group member',NULL,NULL,NULL,1,151.8289583,47.0065,0,NULL,64005145914,1000080404,15626256,14.1),(67878,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67878,30.09,0.43,10.4,24393,75,NULL,'3.6 micron, color corrected','UGC 05451',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67879,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67879,30.17,0.2,10.8,24393,74.4,NULL,NULL,'UGC 05451',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67880,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67880,38.18,0.13,433,24394,70,NULL,NULL,'2MASX J10071916+0036348',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000079,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,151.8297917,0.60969,0.041,NULL,60788239794,949816246,14840878,18.1),(67881,'Brightest Stars','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67881,27.19,0.2,2.74,24395,NULL,NULL,NULL,'UGC 05456',NULL,'1998A&AS..133..181M',1998,1,1.6,NULL,'G',0.00001,NULL,'13.72',0.8,'Dwarf','in a pair',NULL,NULL,NULL,1,151.831833,10.36181,0.041,1,60883935118,951311486,14864241,13.72),(67882,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67882,27.91,0.27,3.82,24395,NULL,NULL,NULL,'UGC 05456',NULL,'2002AJ....123.1307M',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67883,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67883,28.74,NULL,5.6,24395,NULL,NULL,NULL,'UGC 05456',NULL,'2002AJ....123.1307M',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67884,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67884,30.11,0.1,10.5,24395,74.4,NULL,NULL,'UGC 05456',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67885,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67885,30.16,0.21,10.8,24395,NULL,NULL,NULL,'UGC 05456',NULL,'2015ApJ...805..144K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67886,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67886,29.21,0.49,6.95,24395,75,NULL,'IR','UGC 05456',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67887,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67887,37.1,0.46,263,24396,70,NULL,NULL,'2MASX J10072202+2701037',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,151.84175,27.01772,0.097,NULL,64158004005,1002468812,15663575,17.6),(67888,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67888,31.32,NULL,18.4,24397,NULL,NULL,NULL,'KUG 1004+392',NULL,'2013AJ....145..101K',2013,1,0.96,NULL,'G',0.000017,NULL,'15.4g',0.47,'Ir',NULL,NULL,NULL,NULL,1,151.844666667,38.96964,0,NULL,64095498815,1001492168,15648315,15.4),(67889,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67889,36.7,0.33,219,24398,70,NULL,NULL,'2MASX J10072523+2301149',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000174,NULL,'17.4g',0.23,'AGN',NULL,NULL,NULL,NULL,1,151.855083333,23.02078,0.085,NULL,63689951546,995155492,15549304,17.4),(67890,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67890,37.43,0.46,306,24399,70,NULL,NULL,'2MASX J10072549+0330318',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000152,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,151.856167,3.50872,0,NULL,60798727529,949980117,14843439,16.9),(67891,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67891,36.56,0.62,205,24400,70,NULL,NULL,'2MASX J10072604-1651411',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000083,NULL,'15.0I',0.2,NULL,NULL,NULL,NULL,NULL,1,151.858583,-16.86139,0.121,NULL,41199129672,643736401,10058381,15),(67892,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67892,36.97,0.46,247,24401,70,NULL,NULL,'2MASX J10072648+1030141',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000158,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,151.860458333,10.50408,0.045,NULL,60883885151,951310705,14864229,17.4),(67893,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67893,37.3,0.33,289,24402,70,NULL,NULL,'2MASX J10072651+6133344',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,151.860625,61.5595,0.029,NULL,61911900807,967373450,15115210,17.7),(67894,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67894,37.64,0.21,338,24403,70,NULL,NULL,'2MASX J10072661+4256333',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000181,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,151.861083,42.94253,0,NULL,64100520618,1001570634,15649541,17.4),(67895,'Tully est','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67895,33.04,0.8,40.5,24404,75,NULL,'B','IC 0591',NULL,'1988NBGC.C....0000T',1988,1,0.97,NULL,'G',0.00001,NULL,'14.2g',0.62,'S?','Pair member, wide',NULL,NULL,NULL,1,151.865375,12.2745,0.097,NULL,60844484174,950695065,14854610,14.2),(67896,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67896,38.6,0.46,524,24405,70,NULL,NULL,'SDSS J100728.34+025321.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000073,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,151.868125,2.88922,0.025,NULL,60790341119,949849079,14841391,18.3),(67897,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67897,38.42,0.33,482,24406,70,NULL,NULL,'SDSS J100728.88-003244.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000078,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,151.870375,-0.54569,0.073,NULL,41263673421,644744897,10074139,18.7),(67898,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67898,35.87,0.46,150,24407,70,NULL,NULL,'CGCG 036-040',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000172,NULL,'15.5g',0.45,'S0^-',NULL,NULL,NULL,NULL,1,151.872125,3.67364,0.005,NULL,60798670889,949979232,14843425,15.5),(67899,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67899,38.42,0.33,482,24408,70,NULL,NULL,'2MASX J10072993-0034206',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000076,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,151.874625,-0.57247,0.073,NULL,41263678521,644744976,10074140,17),(67900,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67900,36.7,0.33,219,24409,70,NULL,NULL,'2MASX J10073234+2301319',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000194,NULL,'16.2g',0.24,'AGN',NULL,NULL,NULL,NULL,1,151.884833,23.02547,0.085,NULL,63689736679,995152135,15549252,16.2),(67901,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67901,36.77,0.46,226,24410,70,NULL,NULL,'2MASX J10073244+3135268',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,151.8850417,31.59075,0.057,NULL,64030786211,1000481034,15632516,16.6),(67902,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67902,36.99,0.33,250,24411,70,NULL,NULL,'2MASX J10073279-0033306',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000071,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,151.886666667,-0.5585,0.073,NULL,41263672246,644744878,10074138,17.4),(67903,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67903,38.32,0.46,462,24412,70,NULL,NULL,'SDSS J100734.19+065221.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000137,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,151.892458333,6.87253,0.017,NULL,60755197510,949299961,14832811,18),(67904,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67904,37.09,0.46,261,24413,70,NULL,NULL,'2MASX J10073455+1252092',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000178,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,151.894,12.86925,0.081,NULL,60844417746,950694027,14854594,16.7),(67905,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67905,33.97,0.46,62.1,24414,70,NULL,NULL,'CGCG 240-011',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.0001,NULL,'15.1g',0.43,'S0',NULL,NULL,NULL,NULL,1,151.894833,46.094,0,NULL,63975747659,999621057,15619079,15.1),(67906,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67906,37.21,0.46,277,24415,70,NULL,NULL,'2MASX J10073595+5812412',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000201,NULL,'15.8g',0.47,'AGN',NULL,NULL,NULL,NULL,1,151.89975,58.21144,0,NULL,61926349837,967599216,15118737,15.8),(67907,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67907,36.78,0.46,227,24416,70,NULL,NULL,'2MASX J10073665+2546537',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000182,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,151.902625,25.78178,0.085,NULL,64159953901,1002499279,15664051,16.3),(67908,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67908,36.02,0.46,160,24417,70,NULL,NULL,'2MASX J10073665+3525508',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000158,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,151.902625,35.43072,0.009,NULL,64068905320,1001076645,15641822,16.8),(67909,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67909,37.6,0.46,332,24418,70,NULL,NULL,'2MASX J10073736+5330526',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,151.905541667,53.51469,0,NULL,63995016297,999922129,15623783,17.7),(67910,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67910,38.3,0.71,458,24419,70,NULL,NULL,'2MASX J10073787-1352331',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,151.90775,-13.87583,0.225,NULL,41160105898,643126654,10048853,15.2),(67911,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67911,36.99,0.46,249,24420,70,NULL,NULL,'2MASX J10073787+1551461',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,151.907917,15.86281,0.081,NULL,60865708491,951026695,14859792,16.9),(67912,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67912,36.58,0.62,207,24421,70,NULL,NULL,'2MASX J10073806-1604531',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.55',0.4,NULL,NULL,NULL,NULL,NULL,1,151.908416667,-16.08156,0.177,NULL,41197899871,643717185,10058081,16.55),(67913,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67913,36.73,0.46,222,24422,70,NULL,NULL,'2MASX J10073899+3639112',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'16.52',0.4,NULL,NULL,NULL,NULL,NULL,1,151.9125,36.65319,0.045,NULL,64068283114,1001066923,15641670,16.52),(67914,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67914,38.06,0.46,409,24423,70,NULL,NULL,'2MASX J10073973+0928208',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,151.9155,9.47239,0.041,NULL,60884231323,951316114,14864314,17.8),(67915,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67915,37.38,0.46,299,24424,70,NULL,NULL,'2MASX J10073969+4936326',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,151.915625,49.60889,0,NULL,63999405548,999990711,15624854,17.4),(67916,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67916,38.18,0.13,433,24425,70,NULL,NULL,'2MASX J10074078+0030005',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000115,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,151.92,0.5,0.033,NULL,60788270783,949816730,14840886,17.7),(67917,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67917,37.98,0.46,394,24426,70,NULL,NULL,'2MASX J10074137+4230313',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,151.922375,42.50875,0,NULL,64099982200,1001562221,15649409,17.8),(67918,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67918,37.41,0.46,303,24427,70,NULL,NULL,'2MASX J10074245+1040298',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,151.927,10.67511,0.081,NULL,60882796016,951293687,14863963,16.7),(67919,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67919,35.87,0.46,149,24428,70,NULL,NULL,'2MASX J10074270+1110228',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00018,NULL,'16.1g',0.3,'S0^-',NULL,NULL,NULL,NULL,1,151.927833,11.17297,0.081,NULL,60882873738,951294902,14863982,16.1),(67920,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67920,35.95,0.46,155,24429,70,NULL,NULL,'2MASX J10074317+0919588',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000152,NULL,'16.1g',0.34,'S0',NULL,NULL,NULL,NULL,1,151.929875,9.333,0.041,NULL,60881934677,951280229,14863753,16.1),(67921,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67921,38.18,0.13,433,24430,70,NULL,NULL,'2MASX J10074444+0032575',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000077,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,151.935,0.54933,0.033,NULL,60788200284,949815629,14840869,18.4),(67922,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67922,38.14,0.46,425,24431,70,NULL,NULL,'SDSS J100744.41+170558.3',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000103,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,151.935083333,17.09956,0.073,NULL,60856716416,950886194,14857596,17.6),(67923,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67923,37.67,0.46,342,24432,70,NULL,NULL,'2MASX J10074488+3041408',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,151.937,30.69469,0.065,NULL,64034185668,1000534151,15633346,17.5),(67924,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67924,33.9,0.47,60.1,24433,NULL,NULL,'H','ESO 316- G 029',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000013,NULL,'14.61',0.5,'(R\')SB:(r)a',NULL,NULL,NULL,NULL,1,151.937375,-41.33158,0.741,NULL,42093831723,657716120,10276814,14.61),(67925,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67925,33.92,0.45,60.9,24433,NULL,NULL,'K','ESO 316- G 029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67926,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67926,34.03,0.46,64.1,24433,NULL,NULL,'J','ESO 316- G 029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67927,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67927,34.4,0.4,75.8,24433,NULL,NULL,'mean','ESO 316- G 029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67928,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67928,37.87,0.46,375,24434,70,NULL,NULL,'SDSS J100745.55+290047.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.2g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,151.9397917,29.01317,0.053,NULL,64032163070,1000502547,15632852,18.2),(67929,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67929,37.06,0.46,258,24435,70,NULL,NULL,'2MASX J10074612+0747298',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000178,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,151.9422083,7.7915,0,NULL,60879826108,951247282,14863238,17),(67930,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67930,37.16,0.46,270,24436,70,NULL,NULL,'SDSS J100746.86+184954.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000168,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,151.94525,18.83186,0.081,NULL,60813284433,950207569,14846993,18),(67931,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67931,38.52,0.46,506,24437,70,NULL,NULL,'2MASX J10074692+1820079',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,151.945625,18.33547,0.097,NULL,60811351238,950177363,14846521,17.9),(67932,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67932,37.92,0.33,383,24438,70,NULL,NULL,'2MASX J10074732+5526393',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000121,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,151.946875,55.44431,0,NULL,61901838277,967216223,15112753,18.1),(67933,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67933,36.99,0.33,250,24439,70,NULL,NULL,'SDSS J100748.45-002829.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000068,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,151.951917,-0.47483,0.065,NULL,41263798146,644746846,10074169,18),(67934,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67934,38.18,0.13,433,24440,70,NULL,NULL,'2MASX J10074898+0034275',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000098,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,151.954,0.57431,0.033,NULL,60788228125,949816064,14840876,17.5),(67935,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67935,37.1,0.46,264,24441,70,NULL,NULL,'2MASX J10074911+3944173',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000183,NULL,'15.8g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,151.9547917,39.73819,0,NULL,64104038832,1001625606,15650400,15.8),(67936,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67936,37.47,0.27,311,24442,70,NULL,NULL,'2MASX J10074976+4954437',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000178,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,151.957541667,49.91203,0,NULL,64001283563,1000020055,15625313,17.6),(67937,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67937,36.2,0.46,174,24443,70,NULL,NULL,'2MASX J10075077+5444173',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000154,NULL,'16.1g',0.32,'S0',NULL,NULL,NULL,NULL,1,151.961791667,54.73811,0,NULL,61902348734,967224198,15112878,16.1),(67938,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67938,35.94,0.46,154,24444,70,NULL,NULL,'2MASX J10075293-0009136',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000095,NULL,'15.8g',0.36,'S0/a',NULL,NULL,NULL,NULL,1,151.970417,-0.15375,0.029,NULL,41263575008,644743359,10074114,15.8),(67939,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67939,35.73,0.46,140,24445,70,NULL,NULL,'CGCG 064-070',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000153,NULL,'15.1g',0.58,'E0',NULL,NULL,NULL,NULL,1,151.97575,13.39083,0.085,NULL,60845938447,950717788,14854965,15.1),(67940,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67940,34.51,0.49,79.6,24446,75,NULL,'IR','UGC 05461',NULL,'2011yCatp016004901K',2011,1,1.55,NULL,'G',0.00003,NULL,'15.5g',0.24,'Sbc',NULL,NULL,NULL,NULL,1,151.975708333,29.46072,0.077,NULL,64032109495,1000501710,15632839,15.5),(67941,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67941,33.44,0.47,48.9,24447,NULL,NULL,'H','IC 2548',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000027,NULL,'13.87',1.7,'(R\'_1)SB(r)b',NULL,NULL,NULL,NULL,1,151.9789583,-35.22961,0.405,NULL,41972479633,655819994,10247187,13.87),(67942,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67942,33.53,0.45,50.8,24447,NULL,NULL,'K','IC 2548',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67943,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67943,33.57,0.46,51.7,24447,NULL,NULL,'J','IC 2548',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67944,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67944,33.86,0.4,59.1,24447,NULL,NULL,'mean','IC 2548',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67945,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67945,37.1,0.46,263,24448,70,NULL,NULL,'2MASX J10075601+2744229',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000175,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,151.983375,27.73975,0.085,NULL,64157159988,1002455624,15663369,17.5),(67946,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67946,35.66,0.46,136,24449,70,NULL,NULL,'CGCG 008-046',NULL,'2015arXiv151105856S',2015,1,0.61,'The APM image includes a neighboring star and a fainter galaxy.','G',0.00009,NULL,'15.3g',0.53,'S0','Group member',NULL,NULL,NULL,1,151.9850417,0.27217,0.029,NULL,60788110528,949814227,14840847,15.3),(67947,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67947,38.02,0.46,401,24450,70,NULL,NULL,'2MASX J10075648+4233363',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000181,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,151.9855417,42.56,0,NULL,64099981216,1001562206,15649409,17.8),(67948,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67948,33.45,NULL,49,24451,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 064-071',NULL,'2010Ap&SS.325..163P',2010,1,1.2,NULL,'G',0.000108,NULL,'16.2g',0.17,'Scd',NULL,NULL,NULL,NULL,1,151.988,13.22742,0.085,NULL,60845869379,950716709,14854948,16.2),(67949,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67949,33.47,NULL,49.5,24451,NULL,NULL,'Dipole + Quadrupole','CGCG 064-071',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67950,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67950,33.49,NULL,49.9,24451,NULL,NULL,'Dipole','CGCG 064-071',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67951,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67951,33.67,0.2,54.2,24451,74.4,NULL,NULL,'CGCG 064-071',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67952,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67952,33.82,0.43,58.1,24451,75,NULL,'3.6 micron, color corrected','CGCG 064-071',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67953,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67953,33.91,0.43,60.6,24451,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 064-071',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67954,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67954,38.18,0.13,433,24452,70,NULL,NULL,'2MASX J10075711+0036250',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.0001,NULL,'18.53',0.25,NULL,NULL,NULL,NULL,NULL,1,151.9880417,0.607,0.033,NULL,60788249112,949816392,14840881,18.53),(67955,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67955,37.92,0.33,383,24453,70,NULL,NULL,'2MASX J10075754+5530403',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00013,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,151.989583,55.51125,0,NULL,61901895670,967217119,15112767,18.1),(67956,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67956,36.1,0.46,166,24454,70,NULL,NULL,'2MASX J10075826+0116080',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000161,NULL,'16.2g',0.41,'E0',NULL,NULL,NULL,NULL,1,151.992667,1.269,0.041,NULL,60788776756,949824636,14841009,16.2),(67957,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67957,38.18,0.13,433,24455,70,NULL,NULL,'2MASX J10075844+0040560',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000094,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,151.993625,0.68231,0.021,NULL,60788227678,949816057,14840875,17.8),(67958,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67958,37.3,0.33,289,24456,70,NULL,NULL,'2MASX J10075955+6134134',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,151.9980417,61.57039,0.033,NULL,61911907995,967373562,15115211,17.5),(67959,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67959,37.47,0.27,311,24457,70,NULL,NULL,'2MASX J10080096+5002536',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000183,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,152.004041667,50.04828,0.005,NULL,64001334643,1000020853,15625325,16.6),(67960,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67960,37.47,0.27,311,24458,70,NULL,NULL,'2MASX J10080239+4954516',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000173,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,152.009875,49.91442,0,NULL,64001283690,1000020057,15625313,16.6),(67961,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67961,37.47,0.46,312,24459,70,NULL,NULL,'SDSS J100802.64+213602.8',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000151,NULL,'17.3g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,152.011,21.60078,0.069,NULL,60802501846,950039091,14844360,17.3),(67962,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67962,38.18,0.13,433,24460,70,NULL,NULL,'SDSS J100803.37+003340.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000073,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,152.014041667,0.56128,0.033,NULL,60788304304,949817254,14840894,18.1),(67963,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67963,37.2,0.46,275,24461,70,NULL,NULL,'2MASX J10080573+3631062',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00014,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,152.023916667,36.51839,0.017,NULL,64068304908,1001067264,15641676,16.8),(67964,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67964,27.79,NULL,3.61,24462,NULL,NULL,NULL,'IKN',NULL,'2010ApJ...724.1030G',2010,1,2.7,NULL,'G',NULL,NULL,'17.0B',2.3,'dSph','Brightest group member',NULL,NULL,NULL,1,152.024583,68.39917,0.093,NULL,62129811936,970778311,15168411,17),(67965,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67965,27.79,0.04,3.61,24462,NULL,NULL,'I','IKN',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67966,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67966,27.87,NULL,3.75,24462,NULL,NULL,NULL,'IKN',NULL,'2006AJ....131.1361K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67967,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67967,27.88,0.03,3.77,24462,NULL,NULL,'I','IKN',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67968,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67968,38.18,0.13,433,24463,70,NULL,NULL,'2MASX J10080758+0040200',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000078,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,152.031417,0.67211,0.021,NULL,60788213803,949815840,14840872,17.9),(67969,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67969,37.71,0.46,348,24464,70,NULL,NULL,'2MASX J10080753+4039002',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000171,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,152.0314583,40.65011,0,NULL,64105103714,1001642245,15650660,16.9),(67970,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67970,38.26,0.46,449,24465,70,NULL,NULL,'2MASX J10080856+0758214',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000173,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,152.035833,7.97278,0.017,NULL,60877929161,951217643,14862775,17),(67971,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67971,35.99,0.68,158,24466,70,NULL,NULL,'2MASX J10080877-1535436',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,152.036541667,-15.59547,0.145,NULL,41197603585,643712556,10058008,14.8),(67972,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67972,31.49,0.4,19.9,24467,75,NULL,'B','UGC 05460',NULL,'1988NBGC.C....0000T',1988,1,2.3,'The position in 2002PNAOJ...6..107M is for a superposed star or a knot.','G',0.000017,NULL,'13.5',2.2,'SB(rs)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,152.03875,51.84389,0,NULL,63995127166,999923861,15623810,13.5),(67973,'IRAS','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67973,31.5,0.8,20,24468,75,NULL,'A82, H','UGC 05459',NULL,'1997ApJS..109..333W',1997,1,5.04,NULL,'G',0.000007,NULL,'13.19',0.67,'SB(s)c? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,152.0419583,53.08347,0,NULL,63995527745,999930121,15623908,13.19),(67974,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67974,30.98,0.4,15.7,24468,75,NULL,NULL,'UGC 05459',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67975,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67975,31.13,0.4,16.8,24468,NULL,NULL,'Virgo cluster at 15.6 Mpc','UGC 05459',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67976,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67976,31.48,NULL,19.8,24468,NULL,NULL,NULL,'UGC 05459',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67977,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67977,31.53,NULL,20.2,24468,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05459',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67978,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67978,31.54,0.4,20.3,24468,75,NULL,'B','UGC 05459',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67979,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67979,31.55,NULL,20.4,24468,NULL,NULL,'Dipole + Quadrupole','UGC 05459',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67980,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67980,31.55,NULL,20.4,24468,NULL,NULL,'Dipole','UGC 05459',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67981,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67981,31.57,0.47,20.6,24468,75,NULL,'A82, H, inv','UGC 05459',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67982,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67982,31.58,0.47,20.7,24468,75,NULL,'A82, H, raw','UGC 05459',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67983,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67983,31.61,0.43,21,24468,75,NULL,'3.6 micron, color + selection bias corrected','UGC 05459',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67984,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67984,31.66,0.4,21.5,24468,NULL,NULL,'mean','UGC 05459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67985,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67985,31.77,0.49,22.6,24468,75,NULL,'IR','UGC 05459',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67986,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67986,31.82,0.47,23.1,24468,75,NULL,'A82, H, cor','UGC 05459',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67987,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67987,32.09,0.46,26.2,24468,NULL,NULL,'J','UGC 05459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67988,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67988,32.29,0.47,28.8,24468,NULL,NULL,'H','UGC 05459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67989,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67989,32.35,0.45,29.6,24468,NULL,NULL,'K','UGC 05459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67990,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67990,36.45,0.46,195,24469,70,NULL,NULL,'2MASX J10081033+5059356',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000181,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,152.0429583,50.99311,0,NULL,64001663531,1000025992,15625406,16.2),(67991,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67991,37.42,0.46,305,24470,70,NULL,NULL,'2MASX J10081093+4113068',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,152.045333333,41.21861,0,NULL,64105048412,1001641381,15650646,17),(67992,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67992,37.4,0.46,302,24471,70,NULL,NULL,'2MASX J10081224+2104279',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,152.050875,21.07444,0.057,NULL,60816067339,950251052,14847672,17.8),(67993,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67993,36.02,0.46,160,24472,70,NULL,NULL,'2MASX J10081330+0022590',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000084,NULL,'16.0g',0.33,'S0',NULL,NULL,NULL,NULL,1,152.055375,0.38311,0.029,NULL,60788287306,949816989,14840890,16),(67994,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67994,36.52,0.46,201,24473,70,NULL,NULL,'2MASX J10081639+3609298',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000207,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,152.06825,36.15822,0,NULL,64068433061,1001069266,15641707,17),(67995,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67995,38.18,0.13,433,24474,70,NULL,NULL,'2MASX J10081684+0039090',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000085,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,152.07025,0.65258,0.021,NULL,60788259901,949816560,14840883,17.9),(67996,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67996,37.58,0.46,327,24475,70,NULL,NULL,'2MASX J10081808+5144291',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,152.0752083,51.7415,0,NULL,63995121092,999923767,15623808,17.2),(67997,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67997,37.64,0.21,338,24476,70,NULL,NULL,'2MASX J10081808+4300219',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000191,NULL,'16.1g',0.4,'E0',NULL,NULL,NULL,NULL,1,152.075417,43.00617,0,NULL,64100730694,1001573917,15649592,16.1),(67998,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,67998,34.76,0.47,89.3,24477,70,NULL,NULL,'ESO 567- G 019',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000107,NULL,'15',0.5,'S0',NULL,NULL,NULL,NULL,1,152.077667,-20.16906,0.281,NULL,41154502055,643039094,10047485,15),(67999,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',67999,37.5,0.46,316,24478,70,NULL,NULL,'2MASX J10081870+4445509',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000175,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,152.0780417,44.76419,0,NULL,64098181232,1001534081,15648970,17.3),(68000,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68000,37.97,0.16,393,24479,70,NULL,NULL,'2MASX J10081996+0012440',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000094,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,152.083208333,0.21236,0.029,NULL,60741948736,949092949,14829577,17.6),(68001,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68001,37.83,0.46,369,24480,70,NULL,NULL,'SDSS J100820.07+015044.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000077,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,152.083667,1.84575,0.033,NULL,60791710359,949870474,14841726,18.1),(68002,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68002,37.48,0.33,313,24481,70,NULL,NULL,'SDSS J100820.44+455828.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,152.08525,45.97472,0,NULL,63975775987,999621499,15619085,18),(68003,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68003,38.58,0.46,519,24482,70,NULL,NULL,'2MASX J10082062+0838334',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000182,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,152.0860417,8.64244,0.037,NULL,60877523680,951211307,14862676,17.5),(68004,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68004,33.9,0.49,60.3,24483,75,NULL,'IR','NGC 3126',NULL,'2011yCatp016004901K',2011,1,1.13,NULL,'G',0.000023,NULL,'13.8g',0.51,'Sb             AGN?','Isolated galaxy',NULL,NULL,NULL,1,152.086083,31.86269,0.061,NULL,64076667826,1001197934,15643717,13.8),(68005,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68005,33.95,0.46,61.6,24483,NULL,NULL,'J','NGC 3126',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68006,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68006,33.98,0.47,62.5,24483,NULL,NULL,'H','NGC 3126',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68007,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68007,34.07,0.45,65.1,24483,NULL,NULL,'K','NGC 3126',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68008,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68008,34.37,0.4,75,24483,NULL,NULL,'mean','NGC 3126',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68009,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68009,38.07,0.46,411,24484,70,NULL,NULL,'SDSS J100820.79+180700.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000135,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,152.086625,18.11694,0.113,NULL,60856344283,950880379,14857505,18.5),(68010,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68010,37.97,0.16,393,24485,70,NULL,NULL,'2MASX J10082083+0009410',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000093,NULL,'17.1g',0.29,'AGN',NULL,NULL,NULL,NULL,1,152.08675,0.16142,0.029,NULL,60741966409,949093225,14829581,17.1),(68011,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68011,38.35,0.46,468,24486,70,NULL,NULL,'2MASX J10082145+4923551',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000178,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,152.089167,49.39875,0,NULL,63999509831,999992341,15624880,17),(68012,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68012,37.49,0.46,314,24487,70,NULL,NULL,'2MASX J10082266+0927034',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000144,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,152.094417,9.45103,0.041,NULL,60882110631,951282978,14863796,17.5),(68013,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68013,38.14,0.46,425,24488,70,NULL,NULL,'2MASX J10082382+2852108',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00017,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,152.0992083,28.86994,0.061,NULL,64031378338,1000490286,15632660,18.1),(68014,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68014,36.69,0.46,218,24489,70,NULL,NULL,'2MASX J10082457+3728579',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000172,NULL,'16.2g',0.33,'E0',NULL,NULL,NULL,NULL,1,152.10225,37.48264,0.033,NULL,64065328215,1001020753,15640949,16.2),(68015,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68015,37.97,0.16,393,24490,70,NULL,NULL,'2MASX J10082521+0010337',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.0001,NULL,'16.6g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,152.105041667,0.17594,0.029,NULL,60741974228,949093347,14829583,16.6),(68016,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68016,32.86,NULL,37.3,24491,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 435- G 044',NULL,'2010Ap&SS.325..163P',2010,1,1.37,'Matthews (2000A&AS..143..421M) detects another feature at v=1219 km/sec.','G',0.000013,NULL,'16.82',0.17,'Sd',NULL,NULL,NULL,NULL,1,152.1075,-30.99528,0.301,NULL,41951126540,655486352,10241974,16.82),(68017,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68017,32.88,NULL,37.7,24491,NULL,NULL,'Dipole + Quadrupole','ESO 435- G 044',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68018,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68018,32.9,NULL,38.1,24491,NULL,NULL,'Dipole','ESO 435- G 044',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68019,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68019,33.12,NULL,42.1,24491,NULL,NULL,NULL,'ESO 435- G 044',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68020,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68020,33.29,0.43,45.6,24491,75,NULL,'3.6 micron, color + selection bias corrected','ESO 435- G 044',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68021,'Carbon Stars','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68021,21.5,0.3,0.2,24492,NULL,NULL,NULL,'Leo I',NULL,'1994MNRAS.266....7D',1994,1,9.8,NULL,'G',0.000007,NULL,'11.18',7.4,'E;dSph','in a radial-velocity based grouping',NULL,NULL,NULL,1,152.117083,12.30639,0.089,0,60843817980,950684655,14854447,11.18),(68022,'CMD','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68022,21.8,0.06,0.229,24492,NULL,NULL,NULL,'Leo I',NULL,'2002MNRAS.332...91D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68023,'CMD','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68023,21.95,NULL,0.245,24492,NULL,NULL,NULL,'Leo I',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68024,'CMD','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68024,21.97,NULL,0.248,24492,NULL,NULL,'Age = 1.0 Gyr','Leo I',NULL,'1996A&A...309..413C',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68025,'CMD','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68025,22.08,NULL,0.261,24492,NULL,NULL,NULL,'Leo I',NULL,'1999AJ....118.2245G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68026,'CMD','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68026,22.11,NULL,0.264,24492,NULL,NULL,'Age = 1.5 Gyr','Leo I',NULL,'1996A&A...309..413C',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68027,'CMD','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68027,22.14,NULL,0.268,24492,NULL,NULL,'Age = 2.0 Gyr','Leo I',NULL,'1996A&A...309..413C',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68028,'Horizontal Branch','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68028,21.48,0.3,0.198,24492,NULL,NULL,NULL,'Leo I',NULL,'1995MNRAS.277.1354I',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68029,'Horizontal Branch','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68029,21.63,NULL,0.212,24492,NULL,NULL,NULL,'Leo I',NULL,'1985IAUS..113..541W',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68030,'Miras','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68030,21.8,0.11,0.229,24492,NULL,18.39,NULL,'Leo I',NULL,'2010MNRAS.406...86M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68031,'Red Clump','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68031,21.55,NULL,0.204,24492,NULL,NULL,'V, M RC(V) = +0.73 mag','Leo I',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68032,'Red Clump','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68032,21.7,0.2,0.22,24492,NULL,NULL,NULL,'Leo I',NULL,'1994MNRAS.266....7D',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68033,'Red Clump','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68033,21.84,0.14,0.233,24492,NULL,NULL,NULL,'Leo I',NULL,'2002MNRAS.332...91D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68034,'Red Clump','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68034,21.88,NULL,0.237,24492,NULL,NULL,'I, M RC(I) = -0.50 mag','Leo I',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68035,'RR Lyrae','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68035,21.79,0.14,0.228,24492,NULL,18.39,NULL,'Leo I',NULL,'2010MNRAS.406...86M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68036,'RR Lyrae','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68036,21.92,NULL,0.242,24492,NULL,NULL,'V85, Fe/H = -1.43','Leo I',NULL,'2014PASP..126..616S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68037,'RR Lyrae','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68037,21.96,NULL,0.247,24492,NULL,NULL,'V85, Fe/H = -2.15','Leo I',NULL,'2014PASP..126..616S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68038,'RR Lyrae','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68038,22.01,NULL,0.252,24492,NULL,NULL,NULL,'Leo I',NULL,'2008ApJ...679...52T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68039,'RR Lyrae','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68039,22.01,NULL,0.252,24492,NULL,18.54,NULL,'Leo I',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68040,'RR Lyrae','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68040,22.04,0.14,0.256,24492,NULL,18.53,NULL,'Leo I',NULL,'2001ApJ...562L..39H',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68041,'RR Lyrae','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68041,22.06,0.08,0.258,24492,NULL,NULL,'Fe/H = -1.43','Leo I',NULL,'2014PASP..126..616S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68042,'RR Lyrae','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68042,22.1,NULL,0.263,24492,NULL,NULL,'V80, V141, V214, Fe/H = -1.43','Leo I',NULL,'2014PASP..126..616S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68043,'RR Lyrae','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68043,22.14,NULL,0.268,24492,NULL,NULL,'V80, V141, V214, Fe/H = -2.15','Leo I',NULL,'2014PASP..126..616S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68044,'RR Lyrae','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68044,22.25,0.07,0.282,24492,NULL,NULL,'Fe/H = -2.15','Leo I',NULL,'2014PASP..126..616S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68045,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68045,21.8,0.2,0.229,24492,NULL,NULL,NULL,'Leo I',NULL,'1987AJ.....93.1381F',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68046,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68046,21.84,0.14,0.233,24492,NULL,NULL,NULL,'Leo I',NULL,'2002MNRAS.332...91D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68047,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68047,21.85,0.15,0.234,24492,NULL,NULL,'I','Leo I',NULL,'1991AJ....101.1299R',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68048,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68048,21.9,0.05,0.24,24492,NULL,NULL,NULL,'Leo I',NULL,'1999AJ....117.2199C',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68049,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68049,22,NULL,0.25,24492,NULL,NULL,NULL,'Leo I',NULL,'2000glg..book.....V',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68050,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68050,21.99,0.12,0.25,24492,NULL,NULL,'HST KP Calibrated','Leo I',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68051,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68051,22,0.15,0.251,24492,NULL,NULL,NULL,'Leo I',NULL,'1999AJ....117.2199C',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68052,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68052,22,0.15,0.251,24492,NULL,NULL,NULL,'Leo I',NULL,'1999AJ....117.2199C',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68053,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68053,22.02,0.13,0.254,24492,NULL,NULL,NULL,'Leo I',NULL,'2004MNRAS.354..708B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68054,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68054,22.03,0.14,0.255,24492,NULL,NULL,NULL,'Leo I',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68055,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68055,22.04,0.11,0.256,24492,NULL,NULL,'JHK','Leo I',NULL,'2010MNRAS.404.1475H',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68056,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68056,22.05,0.1,0.26,24492,NULL,NULL,NULL,'Leo I',NULL,'2002AJ....124..213M',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68057,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68057,22.06,0.06,0.26,24492,74.4,NULL,NULL,'Leo I',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68058,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68058,22.1,0.15,0.263,24492,NULL,NULL,NULL,'Leo I',NULL,'1999AJ....117.2199C',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68059,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68059,22.14,NULL,0.268,24492,NULL,NULL,'I, M TRGB(I) = -4.05 mag','Leo I',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68060,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68060,22.18,0.11,0.27,24492,NULL,NULL,'I','Leo I',NULL,'1993AJ....106.1420L',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68061,'Type II Cepheids','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68061,22,NULL,0.251,24492,NULL,NULL,NULL,'Leo I',NULL,'1988ASPC....4..180N',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68062,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68062,21.73,NULL,0.222,24492,NULL,NULL,'LEDA [April 2006]','Leo I',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68063,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68063,35.71,0.54,139,24493,70,NULL,NULL,'2MASX J10082758-1452322',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.61',NULL,NULL,NULL,NULL,NULL,NULL,1,152.115,-14.87558,0.225,NULL,41159779527,643121555,10048774,16.61),(68064,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68064,38.18,0.13,433,24494,70,NULL,NULL,'2MASX J10082793+0029317',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000075,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,152.116375,0.49214,0.013,NULL,60788284541,949816945,14840889,17.8),(68065,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68065,37.12,0.75,265,24495,70,NULL,NULL,'2MASX J10082816-1308022',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.74',NULL,NULL,NULL,NULL,NULL,NULL,1,152.117125,-13.13431,0.229,NULL,41161551119,643149236,10049206,16.74),(68066,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68066,36.78,0.46,227,24496,70,NULL,NULL,'2MASX J10082824+4238529',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000152,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,152.117625,42.64794,0,NULL,64100025772,1001562902,15649420,17.1),(68067,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68067,37.89,0.46,378,24497,70,NULL,NULL,'2MASX J10082905+0454297',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,152.120917,4.90836,0.017,NULL,60787196122,949799939,14840624,17.7),(68068,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68068,37.34,0.46,294,24498,70,NULL,NULL,'2MASX J10082984+1630482',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,152.124417,16.5135,0.077,NULL,60858007204,950906362,14857911,16.3),(68069,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68069,38.11,0.46,419,24499,70,NULL,NULL,'2MASX J10083000+6121168',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,152.1247917,61.35475,0.005,NULL,61912041706,967375651,15115244,18.1),(68070,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68070,37.57,0.46,326,24500,70,NULL,NULL,'2MASX J10083007+0604547',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000141,NULL,'17.0g',0.23,'BrClG',NULL,NULL,NULL,NULL,1,152.125417,6.08181,0.009,NULL,60754764513,949293195,14832706,17),(68071,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68071,37.48,0.33,313,24501,70,NULL,NULL,'2MASX J10083117+4603059',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000179,NULL,'16.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,152.130041667,46.05158,0,NULL,63975732014,999620812,15619075,16.4),(68072,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68072,34.93,0.45,96.6,24502,NULL,NULL,'Malmquist cor.','IC 0594',NULL,'2009ApJS..182..474S',2009,1,1.15,NULL,'G',0.000013,NULL,'14.6g',0.59,'SB(r)bc        NLAGN','Isolated galaxy',NULL,NULL,NULL,1,152.133333,-0.66686,0.081,NULL,41263740152,644745939,10074155,14.6),(68073,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68073,35.17,0.4,108,24502,NULL,NULL,NULL,'IC 0594',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68074,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68074,35.26,0.2,113,24502,74.4,NULL,NULL,'IC 0594',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68075,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68075,36.42,0.46,192,24503,70,NULL,NULL,'2MASX J10083284+0903303',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000166,NULL,'16.1g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,152.136958333,9.05833,0.033,NULL,60877590424,951212350,14862692,16.1),(68076,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68076,35.59,0.69,131,24504,70,NULL,NULL,'2MASX J10083343-1310222',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,152.1392917,-13.17289,0.229,NULL,41161550000,643149218,10049206,15.7),(68077,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68077,37.61,0.46,332,24505,70,NULL,NULL,'2MASX J10083412+3136548',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,152.1422917,31.61514,0.057,NULL,64076701388,1001198459,15643725,17.7),(68078,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68078,35.91,0.46,152,24506,70,NULL,NULL,'CGCG 064-074',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000157,NULL,'15.0g',0.57,'E0',NULL,NULL,NULL,NULL,1,152.144625,12.55547,0.097,NULL,60844609486,950697023,14854640,15),(68079,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68079,38.1,0.46,418,24507,70,NULL,NULL,'SDSS J100834.76+294247.4',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000148,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,152.144833,29.71319,0.077,NULL,64032080443,1000501256,15632832,18.7),(68080,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68080,36.12,0.46,167,24508,70,NULL,NULL,'2MASX J10083573+1337592',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000087,NULL,'16.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,152.148917,13.63319,0.097,NULL,60845744277,950714754,14854918,16.4),(68081,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68081,37.97,0.16,393,24509,70,NULL,NULL,'2MASX J10083574+0006577',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000073,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,152.1489583,0.11597,0.029,NULL,60741932911,949092701,14829573,17.8),(68082,'Sosies','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68082,34.48,0.05,78.7,24510,NULL,NULL,NULL,'NGC 3131',NULL,'2002A&A...393...57T',2002,1,2.6,NULL,'G',0.00003,NULL,'13.6g',0.64,'SBb:','Field galaxy',NULL,NULL,NULL,1,152.1517083,18.23122,0.113,NULL,60811194461,950174913,14846483,13.6),(68083,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68083,33.99,0.47,62.9,24510,NULL,NULL,'H','NGC 3131',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68084,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68084,34.02,0.46,63.6,24510,NULL,NULL,'J','NGC 3131',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68085,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68085,34.05,0.45,64.5,24510,NULL,NULL,'K','NGC 3131',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68086,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68086,34.31,0.48,72.7,24510,NULL,NULL,'Malmquist cor.','NGC 3131',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68087,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68087,34.32,0.4,73.2,24510,NULL,NULL,'mean','NGC 3131',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68088,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68088,34.43,0.45,77,24510,NULL,NULL,NULL,'NGC 3131',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68089,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68089,34.47,0.2,78.3,24510,74.4,NULL,NULL,'NGC 3131',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68090,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68090,37.97,0.16,393,24511,70,NULL,NULL,'2MASX J10083647+0013187',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000076,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,152.152125,0.222,0.029,NULL,60741954674,949093041,14829578,17.4),(68091,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68091,38.45,0.46,490,24512,70,NULL,NULL,'SDSS J100837.43+005924.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00008,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,152.156,0.99028,0.021,NULL,60789092916,949829576,14841087,18.4),(68092,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68092,36.72,0.27,221,24513,70,NULL,NULL,'CGCG 240-013',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000123,NULL,'15.2g',0.55,'E0',NULL,NULL,NULL,NULL,1,152.15875,50.10625,0.005,NULL,64001326593,1000020728,15625323,15.2),(68093,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68093,37.97,0.16,393,24514,70,NULL,NULL,'2MASX J10083834+0008147',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000074,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,152.159833,0.13742,0.029,NULL,60741932553,949092696,14829573,17.7),(68094,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68094,37.69,0.46,345,24515,70,NULL,NULL,'2MASX J10083848+0216597',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000179,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,152.160375,2.28333,0.033,NULL,60790935032,949858359,14841536,16.8),(68095,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68095,33.4,0.56,47.9,24516,70,NULL,NULL,'ESO 316- G 030',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.02',0.5,'(R)SA0^+',NULL,NULL,NULL,NULL,1,152.166916667,-40.09353,0.741,NULL,42091513990,657679906,10276248,15.02),(68096,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68096,38.4,0.46,479,24517,70,NULL,NULL,'2MASX J10084005+0816479',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00017,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,152.166916667,8.27978,0.017,NULL,60877868249,951216691,14862760,18),(68097,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68097,37.23,0.46,279,24518,70,NULL,NULL,'SDSS J100842.36+161425.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,152.1765417,16.24047,0.077,NULL,60857864191,950904127,14857876,18.3),(68098,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68098,38.12,0.46,420,24519,70,NULL,NULL,'2MASX J10084427+4422592',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,152.18425,44.38308,0,NULL,64098023092,1001531610,15648931,17.1),(68099,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68099,35.33,0.46,116,24520,70,NULL,NULL,'CGCG 008-050',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000088,NULL,'15.3g',0.47,'NLAGN',NULL,NULL,NULL,NULL,1,152.19925,-0.26981,0.033,NULL,41209276408,643894943,10060858,15.3),(68100,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68100,37.26,0.46,283,24521,70,NULL,NULL,'2MASX J10084806+0910199',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,152.200333333,9.17208,0.033,NULL,60882007786,951281371,14863771,17.6),(68101,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68101,38.11,0.33,418,24522,70,NULL,NULL,'2MASX J10084839+2922129',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,152.201667,29.37025,0.089,NULL,64032128869,1000502013,15632843,17.6),(68102,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68102,36.23,0.46,176,24523,70,NULL,NULL,'2MASX J10084863+2410499',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000181,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,152.20275,24.18069,0.117,NULL,63686707915,995104811,15548512,16.3),(68103,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68103,37.51,0.33,317,24524,70,NULL,NULL,'2MASX J10084884+0137247',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,152.203667,1.62342,0.021,NULL,60791583539,949868492,14841695,17.8),(68104,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68104,38.01,0.46,400,24525,70,NULL,NULL,'SDSS J100849.18-004728.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00007,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,152.204917,-0.79131,0.081,NULL,41264445201,644756956,10074327,18.5),(68105,'Tully est','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68105,31.78,0.8,22.7,24526,75,NULL,NULL,'UGC 05455',NULL,'1988NBGC.C....0000T',1988,1,1.8,'Huchtmeier and Skillman (1998, A&AS, 127, 269) give v = 428 +/- 8 km/sec.','G',0.000013,NULL,'17.',1.8,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,152.209583,70.63361,0.173,NULL,62105083019,970391922,15162373,17),(68106,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68106,35.97,0.65,157,24527,70,NULL,NULL,'2MASX J10085040-0427593',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'15.74',0.24,NULL,NULL,NULL,NULL,NULL,1,152.2100417,-4.46656,0.057,NULL,41257842049,644653782,10072715,15.74),(68107,'Sosies','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68107,32.04,0.34,25.6,24528,NULL,NULL,NULL,'IC 2554',NULL,'2002A&A...393...57T',2002,1,3.1,'SGC calls this object double (1 plate only); RC1,2,3 and ESO call it single.','G',0.000021,NULL,'12.51',1.3,'SB(s)bc pec:',NULL,NULL,NULL,NULL,1,152.210666667,-67.03086,NULL,NULL,40692237962,635816218,9934628,12.51),(68108,'Tully est','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68108,31.11,0.8,16.7,24528,75,NULL,NULL,'IC 2554',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68109,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68109,32.26,0.49,28.3,24528,75,NULL,'IR','IC 2554',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68110,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68110,37.19,0.69,274,24529,70,NULL,NULL,'LCRS B100625.3-122934',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.21',NULL,NULL,NULL,NULL,NULL,NULL,1,152.2164583,-12.73881,0.221,NULL,41161706618,643151665,10049244,15.21),(68111,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68111,37.64,0.21,338,24530,70,NULL,NULL,'2MASX J10085392+4247433',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00019,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,152.224833,42.79542,0,NULL,64100203348,1001565677,15649463,16.7),(68112,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68112,36.33,0.33,184,24531,70,NULL,NULL,'2MASX J10085431+3448308',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000172,NULL,'16.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,152.2262083,34.80867,0.009,NULL,64060861397,1000950959,15639858,16.5),(68113,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68113,36.87,0.46,237,24532,70,NULL,NULL,'2MASX J10085465+1133049',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000199,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,152.227583,11.55125,0.085,NULL,60882540878,951289701,14863901,16.9),(68114,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68114,36.23,0.46,176,24533,70,NULL,NULL,'2MASX J10085537+0144209',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000111,NULL,'15.7g',0.43,'E/S0           AGN',NULL,NULL,NULL,NULL,1,152.2307083,1.73917,0.033,NULL,60791550460,949867975,14841687,15.7),(68115,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68115,36.33,0.33,184,24534,70,NULL,NULL,'2MASX J10085685+3456457',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000163,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,152.2370417,34.94592,0.017,NULL,64060760368,1000949380,15639834,16.6),(68116,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68116,35.57,0.46,130,24535,70,NULL,NULL,'CGCG 064-078',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000107,NULL,'15.4g',0.44,'E0',NULL,NULL,NULL,NULL,1,152.2387083,11.64031,0.085,NULL,60882525098,951289454,14863897,15.4),(68117,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68117,36.69,0.46,217,24536,70,NULL,NULL,'2MASX J10085793+4925191',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000162,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,152.2412917,49.42197,0,NULL,63999514619,999992415,15624881,16.4),(68118,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68118,37.91,0.27,381,24537,70,NULL,NULL,'2MASX J10085804+1447587',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,152.2417917,14.79956,0.093,NULL,60847012839,950734575,14855227,17.5),(68119,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68119,35.55,0.7,129,24538,70,NULL,NULL,'2MFGC 07857',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.58',NULL,NULL,NULL,NULL,NULL,NULL,1,152.242583,-10.90647,0.169,NULL,41286421104,645100329,10079692,16.58),(68120,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68120,37.19,0.46,274,24539,70,NULL,NULL,'2MASX J10085837+2523140',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,152.2432917,25.38736,0.105,NULL,64156465291,1002444770,15663199,17.2),(68121,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68121,37.64,0.21,338,24540,70,NULL,NULL,'2MASX J10085873+4249563',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000177,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,152.2447917,42.83222,0,NULL,64100201733,1001565652,15649463,16.4),(68122,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68122,36.72,0.27,221,24541,70,NULL,NULL,'2MASX J10090056+5007163',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00019,NULL,'16.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,152.252333,50.12131,0.005,NULL,64001350558,1000021102,15625329,16.6),(68123,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1992J',NULL,68123,35.55,0.16,123,24542,74.2,NULL,'SALT 2','2MASX J10090117-2638367',0.045,'2010ApJ...716..712A',2010,1,1,NULL,'G',NULL,NULL,'14.52',0.7,'S',NULL,NULL,NULL,NULL,1,152.254958333,-26.64347,0.089,NULL,42817969732,669030777,10453605,14.52),(68124,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1992J',NULL,68124,36.22,0.16,168,24542,65,NULL,'MLCS31','2MASX J10090117-2638367',0.045,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68125,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1992J',NULL,68125,36.15,0.08,170,24542,74.4,NULL,NULL,'2MASX J10090117-2638367',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68126,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1992J',NULL,68126,36.35,0.21,178,24542,65,NULL,NULL,'2MASX J10090117-2638367',0.045,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68127,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1992J',NULL,68127,36.45,0.27,179,24542,65,NULL,'MLCS2k2','2MASX J10090117-2638367',0.045,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68128,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1992J',NULL,68128,36.4,0.08,182,24542,72,NULL,NULL,'2MASX J10090117-2638367',0.045,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68129,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1992J',NULL,68129,36.41,0.08,183,24542,70,NULL,'SALT','2MASX J10090117-2638367',0.045,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68130,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1992J',NULL,68130,36.43,0.19,185,24542,65,NULL,'SALT2','2MASX J10090117-2638367',0.045,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68131,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1992J',NULL,68131,36.44,0.17,194,24542,70.8,NULL,NULL,'2MASX J10090117-2638367',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68132,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1992J',NULL,68132,36.72,0.14,221,24542,60,NULL,NULL,'2MASX J10090117-2638367',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68133,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1992J',NULL,68133,36.75,0.14,224,24542,65,NULL,'Snapshot','2MASX J10090117-2638367',NULL,'1996ApJ...473...88R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68134,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1992J',NULL,68134,36.82,0.16,231,24542,60,NULL,'M(V) = -19.47 mag','2MASX J10090117-2638367',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68135,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1992J',NULL,68135,36.83,0.15,232,24542,60,NULL,'M(I) = -19.19 mag','2MASX J10090117-2638367',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68136,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1992J',NULL,68136,36.95,0.11,235,24542,65,NULL,'MLCS','2MASX J10090117-2638367',0.045,'1996ApJ...473..588R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68137,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1992J',NULL,68137,36.88,0.13,238,24542,65,NULL,'LCS','2MASX J10090117-2638367',NULL,'1995ApJ...445L..91R',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68138,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1992J',NULL,68138,36.93,0.21,243,24542,60,NULL,'M(B) = -19.48 mag','2MASX J10090117-2638367',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68139,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68139,37.97,0.16,393,24543,70,NULL,NULL,'2MASX J10090162+0003009',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000089,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,152.256708333,0.05031,0.029,NULL,60742143530,949095992,14829624,17),(68140,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68140,38.14,0.46,425,24544,70,NULL,NULL,'2MASX J10090170+0108289',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00008,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,152.257083,1.14128,0.021,NULL,60788875549,949826180,14841034,16.9),(68141,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68141,37.6,0.46,331,24545,70,NULL,NULL,'SDSS J100902.54+005221.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000069,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,152.260625,0.87278,0.021,NULL,60789015682,949828370,14841068,18.2),(68142,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68142,36.66,0.46,215,24546,70,NULL,NULL,'2MASX J10090275+1125239',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000161,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,152.261375,11.42319,0.089,NULL,60882513303,951289270,14863894,16.9),(68143,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68143,37.91,0.27,381,24547,70,NULL,NULL,'2MASX J10090306+1443507',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00012,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,152.2627083,14.73064,0.093,NULL,60846877777,950732465,14855194,16.3),(68144,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68144,38.11,0.33,418,24548,70,NULL,NULL,'2MASX J10090315+2919020',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00013,NULL,'17.2g',0.24,'E',NULL,NULL,NULL,NULL,1,152.263083,29.31719,0.089,NULL,64032116129,1000501814,15632840,17.2),(68145,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68145,32.51,0.5,31.7,24549,70,NULL,NULL,'MCG -02-26-031',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00011,NULL,'14.31',0.6,'S0^0^',NULL,NULL,NULL,NULL,1,152.2637083,-11.23325,0.157,NULL,41286455949,645100874,10079701,14.31),(68146,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68146,37.4,0.27,303,24550,70,NULL,NULL,'2MASX J10090396-0016494',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000099,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,152.266417,-0.28039,0.053,NULL,41209276417,643894944,10060858,16.6),(68147,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68147,36.53,0.46,203,24551,70,NULL,NULL,'2MASX J10090440+0812285',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,152.268333,8.20806,0.017,NULL,60877789344,951215458,14862741,16.9),(68148,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68148,36.79,0.11,228,24552,70,NULL,NULL,'SDSS J100905.04+543230.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,152.271,54.54181,0,NULL,61902926778,967233230,15113019,17.3),(68149,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68149,36.28,0.46,180,24553,70,NULL,NULL,'2MASX J10090517+3104252',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000168,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,152.2715,31.07367,0.069,NULL,64033673746,1000526152,15633221,16.8),(68150,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68150,37.85,0.21,371,24554,70,NULL,NULL,'SDSS J100905.94+110454.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,152.27475,11.08194,0.089,NULL,60883454199,951303971,14864124,18.5),(68151,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68151,36.8,0.46,229,24555,70,NULL,NULL,'2MASX J10090636+1902294',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000176,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,152.276667,19.04144,0.069,NULL,60811759877,950183748,14846621,16.3),(68152,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68152,38.29,0.46,455,24556,70,NULL,NULL,'SDSS J100906.42+614441.5',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000185,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,152.276791667,61.74486,0.033,NULL,61911411343,967365802,15115090,17.3),(68153,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68153,37.51,0.33,317,24557,70,NULL,NULL,'2MASX J10090657+0135269',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,152.277375,1.59072,0.021,NULL,60791535964,949867749,14841683,17.8),(68154,'IRAS','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68154,30.67,0.8,13.6,24558,75,NULL,'MAT, I','NGC 3137',NULL,'1997ApJS..109..333W',1997,1,6.3,'Extended HIPASS source','G',0.000007,NULL,'12.1',2.2,'SA(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,152.281167,-29.06431,0.213,NULL,41950226451,655472288,10241754,12.1),(68155,'Tully est','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68155,30.8,0.8,14.5,24558,75,NULL,NULL,'NGC 3137',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68156,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68156,30.58,0.36,13.1,24558,NULL,NULL,NULL,'NGC 3137',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68157,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68157,30.59,0.39,13.1,24558,73,NULL,'opt','NGC 3137',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68158,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68158,30.64,0.32,13.4,24558,85,NULL,'I, raw','NGC 3137',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68159,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68159,30.64,0.32,13.4,24558,85,NULL,'I, inv','NGC 3137',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68160,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68160,30.86,0.43,14.9,24558,75,NULL,'MAT, I, raw','NGC 3137',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68161,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68161,30.95,0.43,15.5,24558,75,NULL,'MAT, I, inv','NGC 3137',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68162,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68162,31,0.2,15.9,24558,74.4,NULL,NULL,'NGC 3137',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68163,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68163,31.02,0.48,16,24558,NULL,NULL,NULL,'NGC 3137',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68164,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68164,31.07,0.47,16.4,24558,NULL,NULL,'Malmquist cor.','NGC 3137',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68165,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68165,31.08,0.43,16.4,24558,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3137',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68166,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68166,31.09,0.43,16.5,24558,75,NULL,'3.6 micron, color corrected','NGC 3137',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68167,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68167,31.1,0.43,16.6,24558,75,NULL,'MAT, I, cor','NGC 3137',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68168,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68168,31.55,0.46,20.4,24558,NULL,NULL,'J','NGC 3137',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68169,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68169,31.65,0.47,21.4,24558,NULL,NULL,'H','NGC 3137',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68170,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68170,31.76,0.45,22.5,24558,NULL,NULL,'K','NGC 3137',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68171,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68171,31.85,0.4,23.4,24558,NULL,NULL,'mean','NGC 3137',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68172,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68172,36.32,0.46,183,24559,70,NULL,NULL,'KUG 1005+626',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000171,NULL,'16.0g',0.43,'E0',NULL,NULL,NULL,NULL,1,152.285167,62.39303,0.033,NULL,61908009404,967312646,15114260,16),(68173,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68173,36.79,0.11,228,24560,70,NULL,NULL,'MCG +09-17-029',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000191,NULL,'15.4g',0.5,'E0',NULL,NULL,NULL,NULL,1,152.2919583,54.22553,0,NULL,61902839868,967231872,15112998,15.4),(68174,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68174,36.79,0.11,228,24561,70,NULL,NULL,'2MASX J10091068+5410135',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,152.294375,54.17042,0,NULL,61900926362,967201974,15112530,17.2),(68175,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68175,37.04,0.46,256,24562,70,NULL,NULL,'2MASX J10091066+0304569',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00001,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,152.2945417,3.08261,0.025,NULL,60798985965,949984155,14843502,16.6),(68176,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68176,36.93,0.46,243,24563,70,NULL,NULL,'2MASX J10091114+1827433',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000187,NULL,'16.0g',0.41,NULL,NULL,NULL,NULL,NULL,1,152.2965,18.46197,0.081,NULL,60812077662,950188713,14846698,16),(68177,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68177,37.77,0.46,358,24564,70,NULL,NULL,'SDSS J100911.70+084145.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,152.29875,8.69594,0.021,NULL,60878185998,951221656,14862838,18.1),(68178,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68178,36.79,0.11,228,24565,70,NULL,NULL,'2MASX J10091193+5410465',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000183,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,152.299583,54.1795,0,NULL,61900926239,967201972,15112530,16.5),(68179,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68179,35.8,0.54,144,24566,70,NULL,NULL,'2MASX J10091199-4240549',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,152.2999583,-42.682,0.689,NULL,42083008996,657547015,10274172,16.6),(68180,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68180,35.38,0.27,119,24567,70,NULL,NULL,'UGC 05477',NULL,'2015arXiv151105856S',2015,1,1.6,NULL,'G',0.000077,NULL,'13.69',1.6,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,152.301833,15.00511,0.097,NULL,60846812529,950731445,14855178,13.69),(68181,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68181,37.64,0.46,337,24568,70,NULL,NULL,'2MASX J10091239+4816224',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000186,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,152.3019583,48.27286,0,NULL,64000304952,1000004764,15625074,16.7),(68182,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68182,36.79,0.11,228,24569,70,NULL,NULL,'2MASX J10091343+5426035',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000142,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,152.3060417,54.43442,0,NULL,61902907429,967232928,15113014,17.2),(68183,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68183,36.84,0.46,233,24570,70,NULL,NULL,'2MASX J10091374+3834586',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00012,NULL,'16.1g',0.37,'E0',NULL,NULL,NULL,NULL,1,152.3072917,38.58289,0.005,NULL,64065714213,1001026784,15641043,16.1),(68184,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68184,37.3,0.46,288,24571,70,NULL,NULL,'2MASX J10091446+4040366',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000177,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,152.310333333,40.67678,0.033,NULL,64104998932,1001640608,15650634,16.9),(68185,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68185,37.44,0.46,307,24572,70,NULL,NULL,'2MASX J10091450+1801423',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,152.310625,18.02844,0.061,NULL,60856803264,950887551,14857617,17.6),(68186,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68186,37.79,0.46,361,24573,70,NULL,NULL,'2MASX J10091517+3913306',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000127,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,152.3132083,39.22514,0.033,NULL,64096255097,1001503985,15648499,17.3),(68187,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68187,38.21,0.27,439,24574,70,NULL,NULL,'2MASX J10091566+2941240',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,152.3152917,29.69003,0.077,NULL,64031633277,1000494269,15632722,17.7),(68188,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68188,38.21,0.27,439,24575,70,NULL,NULL,'2MASX J10091660+2940319',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000143,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,152.31925,29.6755,0.077,NULL,64031633335,1000494270,15632722,17.4),(68189,'IRAS','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68189,35.14,0.8,107,24576,75,NULL,'MAT, I','NGC 3138',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'15',0.4,'Sbc',NULL,NULL,NULL,NULL,1,152.3194583,-11.95675,0.205,NULL,41281438321,645022473,10078476,15),(68190,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68190,34.85,0.43,93.5,24576,75,NULL,'MAT, I, raw','NGC 3138',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68191,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68191,34.87,0.32,94.4,24576,85,NULL,'I, raw','NGC 3138',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68192,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68192,34.92,0.32,96.3,24576,85,NULL,'I, inv','NGC 3138',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68193,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68193,35.05,0.43,102,24576,75,NULL,'MAT, I, inv','NGC 3138',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68194,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68194,35.2,0.43,110,24576,75,NULL,'MAT, I, cor','NGC 3138',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68195,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68195,35.69,0.47,137,24576,NULL,NULL,'Malmquist cor.','NGC 3138',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68196,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68196,35.77,0.45,143,24576,NULL,NULL,NULL,'NGC 3138',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68197,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68197,35.81,0.2,145,24576,74.4,NULL,NULL,'NGC 3138',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68198,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68198,35.22,0.46,111,24577,70,NULL,NULL,'2MASX J10091670+1720098',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000123,NULL,'16.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,152.31975,17.33606,0.077,NULL,60856535636,950883369,14857552,16.1),(68199,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68199,36.79,0.11,228,24578,70,NULL,NULL,'MCG +09-17-030',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000184,NULL,'15.8g',0.37,'E0',NULL,NULL,NULL,NULL,1,152.320041667,54.21097,0,NULL,61900968104,967202626,15112541,15.8),(68200,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68200,32.87,NULL,37.5,24579,NULL,NULL,NULL,'FGC 120A',NULL,'2015AstBu..70....1K',2015,1,1.06,NULL,'G',0.000138,NULL,'21.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,152.322375,5.40408,0.013,NULL,60787398628,949803103,14840673,21.3),(68201,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68201,36.12,0.46,168,24580,70,NULL,NULL,'2MASX J10091880+4327261',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000144,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,152.32825,43.45731,0,NULL,64101422308,1001584723,15649761,17.3),(68202,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68202,37.55,0.46,324,24581,70,NULL,NULL,'2MASX J10091907+1501408',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,152.3295,15.02797,0.097,NULL,60846810438,950731413,14855178,17.4),(68203,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 2007ux',NULL,68203,35.61,0.2,124,24582,72,NULL,NULL,'2MASX J10091969+1459268',0.03202,'2013ApJ...773...53F',2013,1,0.45,NULL,'G',0.00009,NULL,'15.8g',0.39,NULL,NULL,NULL,NULL,NULL,1,152.3320417,14.99094,0.097,NULL,60846985774,950734152,14855221,15.8),(68204,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 2007ux',NULL,68204,35.66,0.21,131,24582,73.8,NULL,'SALT 2 (SNANA)','2MASX J10091969+1459268',0.0322,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68205,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 2007ux',NULL,68205,35.99,0.17,153,24582,70,NULL,'SALT 2','2MASX J10091969+1459268',0.030915,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68206,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68206,35.1,0.51,105,24583,70,NULL,NULL,'NGC 3141',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'16.13',0.5,'SB(s?)c',NULL,NULL,NULL,NULL,1,152.332875,-16.65342,0.141,NULL,41199756207,643746190,10058534,16.13),(68207,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68207,36.92,0.46,242,24584,70,NULL,NULL,'2MASX J10092028+0923235',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000181,NULL,'16.1g',0.4,'E0',NULL,NULL,NULL,NULL,1,152.3344583,9.38981,0.033,NULL,60881979202,951280925,14863764,16.1),(68208,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68208,37.4,0.27,303,24585,70,NULL,NULL,'2MASX J10092030-0018544',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000075,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,152.334667,-0.31506,0.053,NULL,41209290366,643895161,10060861,16.7),(68209,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68209,37.4,0.27,303,24586,70,NULL,NULL,'SDSS J100921.96-001739.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,152.3415,-0.29425,0.053,NULL,41209288610,643895134,10060861,18.2),(68210,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68210,38.1,0.46,417,24587,70,NULL,NULL,'SDSS J100922.17+081533.7',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000176,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,152.342417,8.25939,0.017,NULL,60877793840,951215528,14862742,17.7),(68211,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68211,38,0.46,398,24588,70,NULL,NULL,'2MASX J10092381+1729068',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,152.34925,17.48514,0.077,NULL,60857006524,950890726,14857667,18.1),(68212,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68212,37.06,0.46,258,24589,70,NULL,NULL,'2MASX J10092454+0858525',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000138,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,152.352125,8.98136,0.037,NULL,60877579667,951212182,14862690,17.7),(68213,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68213,37.91,0.27,381,24590,70,NULL,NULL,'SDSS J100924.61+144452.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,152.352583,14.74789,0.093,NULL,60846854971,950732108,14855189,18.2),(68214,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68214,38.21,0.27,439,24591,70,NULL,NULL,'2MASX J10092626+2936548',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000113,NULL,'17.2g',0.24,'BrClG',NULL,NULL,NULL,NULL,1,152.359416667,29.61533,0.077,NULL,64031675842,1000494935,15632733,17.2),(68215,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68215,36.82,0.46,231,24592,70,NULL,NULL,'2MASX J10092630+1050455',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'16.1g',0.42,NULL,NULL,NULL,NULL,NULL,1,152.359541667,10.84611,0.081,NULL,60883115322,951298676,14864041,16.1),(68216,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68216,35.22,0.5,111,24593,70,NULL,NULL,'NGC 3140',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000047,NULL,'14.8',0.5,'Sc',NULL,NULL,NULL,NULL,1,152.365917,-16.62817,0.141,NULL,41197839298,643716239,10058066,14.8),(68217,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68217,37.7,0.46,346,24594,70,NULL,NULL,'2MASX J10092898+1730158',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,152.37075,17.50442,0.077,NULL,60856998011,950890593,14857665,18.4),(68218,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68218,37.09,0.46,261,24595,70,NULL,NULL,'2MASX J10092950+1112365',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,152.373,11.21014,0.089,NULL,60883413678,951303338,14864114,16.8),(68219,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68219,38.25,0.33,448,24596,70,NULL,NULL,'SDSS J100929.59+071328.4',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.00013,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,152.3732917,7.22456,0.005,NULL,60758111584,949345493,14833523,18.7),(68220,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68220,31.85,0.4,23.4,24597,75,NULL,'B','UGC 05478',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000017,NULL,'14.69',1.6,'Im',NULL,NULL,NULL,NULL,1,152.381667,30.15169,0.057,NULL,64034260510,1000535320,15633364,14.69),(68221,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68221,37.43,0.46,306,24598,70,NULL,NULL,'2MASX J10093333+3636323',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,152.388875,36.60889,0.045,NULL,64066444338,1001038192,15641221,17.3),(68222,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68222,36.82,0.33,231,24599,70,NULL,NULL,'2MASX J10093535+2259557',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000154,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,152.3972917,22.999,0.057,NULL,63686856240,995107128,15548548,17.1),(68223,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68223,36.72,0.27,221,24600,70,NULL,NULL,'2MASX J10093604+5010113',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000179,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,152.4002917,50.16994,0,NULL,64001354523,1000021164,15625330,17.8),(68224,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68224,35.12,0.46,106,24601,70,NULL,NULL,'IC 0595',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.00017,NULL,'15.0g',0.57,'S0',NULL,NULL,NULL,NULL,1,152.408833,11.00025,0.101,NULL,60883438020,951303719,14864120,15),(68225,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68225,36.79,0.11,228,24602,70,NULL,NULL,'2MASX J10093831+5415463',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,152.409667,54.26303,0,NULL,61900953704,967202401,15112537,17.5),(68226,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68226,36.79,0.11,228,24603,70,NULL,NULL,'2MASX J10093894+5443073',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000149,NULL,'16.0g',0.37,'E0',NULL,NULL,NULL,NULL,1,152.412333,54.71886,0,NULL,61902373959,967224593,15112884,16),(68227,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68227,35.78,0.46,143,24604,70,NULL,NULL,'2MASX J10093899+2718098',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000095,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,152.412625,27.30281,0.129,NULL,64024044045,1000375688,15630870,16.3),(68228,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68228,37.85,0.21,371,24605,70,NULL,NULL,'2MASX J10094175+1107260',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000195,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,152.423875,11.12381,0.101,NULL,60883443115,951303798,14864121,17.1),(68229,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68229,38.32,0.33,462,24606,70,NULL,NULL,'2MASX J10094208+0336389',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,152.4254583,3.61075,0,NULL,60799383727,949990370,14843599,18),(68230,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68230,38.19,0.46,435,24607,70,NULL,NULL,'2MASX J10094223-0032401',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000088,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,152.4260417,-0.54464,0.061,NULL,41209162050,643893157,10060830,17.6),(68231,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68231,38.86,0.46,593,24608,70,NULL,NULL,'2MASX J10094298+0022579',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000087,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,152.4290417,0.38275,0.005,NULL,60742087688,949095120,14829611,17.7),(68232,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68232,38.32,0.33,462,24609,70,NULL,NULL,'2MASX J10094349+0337229',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000414,NULL,'16.18',0.4,'cD',NULL,NULL,NULL,NULL,1,152.43125,3.62297,0,NULL,60799384561,949990383,14843599,16.18),(68233,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68233,37.97,0.16,393,24610,70,NULL,NULL,'2MASX J10094382-0003071',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000083,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,152.432625,-0.05214,0.033,NULL,41209228592,643894196,10060846,17.2),(68234,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68234,37.05,0.91,257,24611,70,NULL,NULL,'2MASX J10094395-3904497',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,152.433125,-39.08047,0.561,NULL,42087596753,657618699,10275292,15.5),(68235,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68235,36.62,0.46,211,24612,70,NULL,NULL,'MCG +09-17-032',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000195,NULL,'15.7g',0.49,'E0',NULL,NULL,NULL,NULL,1,152.4352917,52.96069,0,NULL,63995580787,999930949,15623921,15.7),(68236,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68236,36.02,0.52,160,24613,70,NULL,NULL,'2MASX J10094479-4346534',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000123,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,152.436583,-43.78147,0.609,NULL,42085320715,657583136,10274736,16.2),(68237,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68237,36.93,0.46,243,24614,70,NULL,NULL,'2MASX J10094619+4022263',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,152.4425,40.37406,0.045,NULL,64103962469,1001624413,15650381,17.4),(68238,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68238,38.03,0.46,403,24615,70,NULL,NULL,'2MASX J10094645+1027020',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000147,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,152.443625,10.45058,0.041,NULL,60883705822,951307903,14864185,17.8),(68239,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68239,34.64,0.62,84.8,24616,70,NULL,NULL,'2MASX J10094861-4033517',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,152.452667,-40.56433,0.737,NULL,42093518621,657711228,10276737,14.8),(68240,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68240,37.62,0.46,335,24617,70,NULL,NULL,'2MASX J10095000+4551032',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000157,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,152.4585417,45.85092,0,NULL,64097407018,1001521984,15648781,16.7),(68241,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68241,37.67,0.46,342,24618,70,NULL,NULL,'2MASX J10095095+3509225',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,152.462166667,35.15619,0.041,NULL,64068029351,1001062958,15641608,17.3),(68242,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68242,34.71,0.45,87.4,24619,NULL,NULL,'K','UGC 05481',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000033,NULL,'14.76',0.5,'Sa:',NULL,NULL,NULL,NULL,1,152.4642917,30.32078,0.049,NULL,64034351721,1000536745,15633386,14.76),(68243,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68243,34.74,0.47,88.5,24619,NULL,NULL,'H','UGC 05481',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68244,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68244,34.79,0.4,90.6,24619,NULL,NULL,'mean','UGC 05481',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68245,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68245,34.87,0.46,94.4,24619,NULL,NULL,'J','UGC 05481',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68246,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68246,34.96,0.49,98.3,24619,75,NULL,'IR','UGC 05481',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68247,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68247,38.25,0.33,448,24620,70,NULL,NULL,'2MASX J10095512+0709220',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,152.47975,7.15611,0.013,NULL,60758642085,949353782,14833652,17.6),(68248,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68248,37.45,0.33,308,24621,70,NULL,NULL,'2MASX J10095559+1624137',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',NULL,NULL,'16.1g',0.42,NULL,NULL,NULL,NULL,NULL,1,152.4815417,16.40378,0.053,NULL,60858105113,950907892,14857935,16.1),(68249,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68249,34.45,0.5,77.5,24622,NULL,NULL,'Malmquist cor.','ESO 374- G 039',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.39',0.2,'S...',NULL,NULL,NULL,NULL,1,152.485166667,-37.29908,0.389,NULL,41967386816,655740419,10245944,16.39),(68250,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68250,34.62,0.46,84.1,24622,NULL,NULL,NULL,'ESO 374- G 039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68251,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68251,34.66,0.2,85.5,24622,74.4,NULL,NULL,'ESO 374- G 039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68252,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68252,37.45,0.46,309,24623,70,NULL,NULL,'2MASX J10095652+1138140',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,152.485666667,11.63714,0.089,NULL,60882679427,951291866,14863935,17.1),(68253,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68253,37.85,0.21,371,24624,70,NULL,NULL,'2MASX J10095779+1116460',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000133,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,152.490833,11.27933,0.089,NULL,60883300505,951301570,14864087,17.8),(68254,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68254,36.59,0.46,208,24625,70,NULL,NULL,'2MASX J10095855+0941290',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,152.493917,9.69131,0.029,NULL,60882209962,951284530,14863820,16.9),(68255,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68255,34.44,0.49,77.1,24626,75,NULL,'IR','FGC 1021',NULL,'2011yCatp016004901K',2011,1,0.88,NULL,'G',NULL,NULL,'16.6',0.1,'Scd',NULL,NULL,NULL,NULL,1,152.494125,71.87225,0.093,NULL,62104259216,970379050,15162172,16.6),(68256,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68256,35.32,NULL,116,24626,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1021',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68257,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68257,35.33,NULL,116,24626,NULL,NULL,'Dipole + Quadrupole','FGC 1021',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68258,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68258,35.35,NULL,118,24626,NULL,NULL,'Dipole','FGC 1021',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68259,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68259,35.36,NULL,118,24626,NULL,NULL,NULL,'FGC 1021',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68260,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68260,38.4,0.33,480,24627,70,NULL,NULL,'2MASX J10095876+0415590',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,152.49475,4.26647,0.017,NULL,60799113445,949986147,14843533,17.8),(68261,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68261,35.55,0.56,129,24628,70,NULL,NULL,'2MASX J10095885-0717172',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.75',NULL,NULL,NULL,NULL,NULL,NULL,1,152.495041667,-7.28831,0.097,NULL,41250551796,644539871,10070935,16.75),(68262,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68262,38.55,0.46,512,24629,70,NULL,NULL,'2MASX J10095910+0752270',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000168,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,152.4962083,7.87433,0.013,NULL,60757054994,949328984,14833265,17.2),(68263,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68263,37.45,0.33,308,24630,70,NULL,NULL,'2MASX J10095913+1625237',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,152.496667,16.42319,0.053,NULL,60858095049,950907735,14857933,17.9),(68264,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68264,37.09,0.46,262,24631,70,NULL,NULL,'2MASX J10100007+6817179',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.31',0.36,NULL,NULL,NULL,NULL,NULL,1,152.5004583,68.28817,0.093,NULL,62127756482,970746195,15167909,16.31),(68265,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68265,37.4,0.46,302,24632,70,NULL,NULL,'2MASX J10100072+3153185',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,152.503083,31.8885,0.077,NULL,64080073483,1001251148,15644549,17.7),(68266,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68266,36.79,0.11,228,24633,70,NULL,NULL,'2MASX J10100205+5430532',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000138,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,152.508541667,54.51489,0,NULL,61902733866,967230216,15112972,17.2),(68267,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68267,37.62,0.46,334,24634,70,NULL,NULL,'2MASX J10100249+0923023',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000182,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,152.5104583,9.384,0.033,NULL,60882266191,951285409,14863834,17.2),(68268,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68268,37.95,0.46,389,24635,70,NULL,NULL,'2MASX J10100358+3608302',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,152.515,36.14186,0.029,NULL,64066497056,1001039016,15641234,17.5),(68269,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68269,38.4,0.33,480,24636,70,NULL,NULL,'SDSS J101004.11+041512.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,152.517166667,4.25339,0.017,NULL,60799096218,949985878,14843529,18),(68270,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68270,38.2,0.46,437,24637,70,NULL,NULL,'2MASX J10100504+0155190',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00007,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,152.520833,1.92189,0.033,NULL,60792219095,949878423,14841850,17.9),(68271,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68271,38.12,0.46,421,24638,70,NULL,NULL,'2MASX J10100504+0153040',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000213,NULL,'18.40',0.25,NULL,NULL,NULL,NULL,NULL,1,152.5209583,1.88436,0.021,NULL,60792002582,949875040,14841797,18.4),(68272,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68272,31.46,0.5,19.5,24639,70,NULL,NULL,'NGC 3139',NULL,'2014MNRAS.445.2677S',2014,1,1.4,'2MRSS (2012ApJS..199...26H) gives v= 9200 +/- 30 km/sec.','G',0.000033,NULL,'15',1.2,'S0^0^ pec:',NULL,NULL,NULL,NULL,1,152.521583333,-11.77825,0.205,NULL,41285632140,645088002,10079500,15),(68273,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68273,36.3,0.63,182,24640,70,NULL,NULL,'LCRS B100736.1-021906',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00013,NULL,'17.93',0.22,NULL,NULL,NULL,NULL,NULL,1,152.535625,-2.56475,0.065,NULL,41266935806,644795871,10074935,17.93),(68274,'Ring Diameter','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68274,32.8,0.84,36,24641,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3145',NULL,'1981ApJS...45..541P',1981,1,3.1,NULL,'G',0.00002,NULL,'12.56',1.6,'SB(rs)bc','in a pair',NULL,NULL,NULL,1,152.541125,-12.43378,0.205,NULL,41160836444,643138069,10049032,12.56),(68275,'IRAS','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68275,33.56,0.8,51.6,24641,75,NULL,'MAT, I','NGC 3145',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68276,'Sosies','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68276,33.55,0.11,51.3,24641,NULL,NULL,NULL,'NGC 3145',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68277,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68277,32.96,0.46,39.2,24641,NULL,NULL,'J','NGC 3145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68278,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68278,33.02,0.45,40.1,24641,NULL,NULL,'K','NGC 3145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68279,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68279,33.03,0.47,40.4,24641,NULL,NULL,'H','NGC 3145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68280,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68280,33.24,NULL,44.5,24641,NULL,NULL,'B','NGC 3145',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68281,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68281,33.27,0.43,45,24641,75,NULL,'MAT, I, raw','NGC 3145',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68282,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68282,33.38,0.32,47.5,24641,85,NULL,'I, raw','NGC 3145',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68283,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68283,33.46,0.32,49.3,24641,85,NULL,'I, inv','NGC 3145',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68284,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68284,33.49,0.4,49.9,24641,NULL,NULL,'mean','NGC 3145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68285,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68285,33.54,NULL,51.1,24641,NULL,NULL,'I','NGC 3145',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68286,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68286,33.59,0.43,52.2,24641,75,NULL,'MAT, I, inv','NGC 3145',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68287,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68287,33.62,0.43,52.9,24641,75,NULL,'MAT, I, cor','NGC 3145',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68288,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68288,33.88,0.33,59.7,24641,NULL,NULL,'Malmquist cor.','NGC 3145',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68289,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68289,33.94,0.32,61.5,24641,NULL,NULL,NULL,'NGC 3145',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68290,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68290,33.98,0.2,62.5,24641,74.4,NULL,NULL,'NGC 3145',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68291,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68291,37.81,0.46,365,24642,70,NULL,NULL,'2MASX J10100990+5033594',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,152.5414583,50.56664,0,NULL,64001214348,1000018974,15625296,17.8),(68292,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68292,36.79,0.11,228,24643,70,NULL,NULL,'CGCG 266-027',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000127,NULL,'15.3g',0.52,'E0',NULL,NULL,NULL,NULL,1,152.5425417,54.30864,0,NULL,61900948420,967202319,15112536,15.3),(68293,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68293,36.79,0.11,228,24644,70,NULL,NULL,'2MASX J10101037+5433141',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000177,NULL,'15.8g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,152.5430417,54.55389,0,NULL,61902705767,967229777,15112965,15.8),(68294,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68294,37.31,0.46,290,24645,70,NULL,NULL,'2MASX J10101047+0533070',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000127,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,152.543583,5.55189,0.013,NULL,60786305945,949786030,14840406,17.4),(68295,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68295,37.41,0.46,304,24646,70,NULL,NULL,'2MASX J10101113+0734273',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,152.5465,7.57433,0.017,NULL,60756955213,949327425,14833241,17.4),(68296,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68296,37.1,0.54,263,24647,70,NULL,NULL,'LCRS B100742.4-054242',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.000133,NULL,'16.4b',0.34,NULL,NULL,NULL,NULL,NULL,1,152.552583333,-5.95861,0.069,NULL,41256777777,644637152,10072455,16.4),(68297,'SBF','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68297,31.63,0.14,21.2,24648,74.4,NULL,NULL,'NGC 3136B',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000103,NULL,'12.7',0.9,'E+',NULL,NULL,NULL,NULL,1,152.553875,-67.00508,NULL,NULL,40690487151,635788861,9934200,12.7),(68298,'SBF','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68298,31.64,0.19,21.3,24648,NULL,NULL,'I','NGC 3136B',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68299,'SBF','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68299,31.64,0.19,21.3,24648,NULL,NULL,NULL,'NGC 3136B',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68300,'SBF','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68300,31.69,0.19,21.8,24648,NULL,NULL,'Malmquist cor.','NGC 3136B',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68301,'D-Sigma','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68301,31.94,0.4,24.4,24648,75,NULL,'Edat, raw','NGC 3136B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68302,'D-Sigma','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68302,32.14,0.4,26.8,24648,75,NULL,'Edat, cor','NGC 3136B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68303,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68303,32.46,0.41,31,24648,NULL,NULL,NULL,'NGC 3136B',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68304,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68304,32.77,0.41,35.8,24648,NULL,NULL,'Malmquist cor.','NGC 3136B',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68305,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68305,32.01,0.4,25.3,24648,NULL,NULL,'mean','NGC 3136B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68306,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68306,32.37,0.45,29.7,24648,NULL,NULL,'K','NGC 3136B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68307,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68307,37.66,0.46,341,24649,70,NULL,NULL,'2MASX J10101556+5429241',NULL,'2015arXiv151105856S',2015,1,0.23,'Part of the GGroup VV 533 NED02.','G',0.000147,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,152.5647917,54.48997,0,NULL,61902735032,967230234,15112972,17.5),(68308,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68308,38.07,0.23,411,24650,70,NULL,NULL,'2MASX J10101605+0235530',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000084,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,152.566916667,2.59808,0.045,NULL,60791437059,949866204,14841659,17.5),(68309,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68309,35.53,0.33,128,24651,70,NULL,NULL,'2MASX J10101660+0619083',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'16.86',NULL,NULL,NULL,NULL,NULL,NULL,1,152.569166667,6.31897,0.021,NULL,60756112603,949314259,14833035,16.86),(68310,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68310,38.19,0.46,434,24652,70,NULL,NULL,'SDSS J101019.75+111123.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000179,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,152.582333333,11.18986,0.101,NULL,60883325689,951301963,14864093,18.6),(68311,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68311,37.85,0.21,371,24653,70,NULL,NULL,'SDSS J101020.10+110650.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000187,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,152.58375,11.11406,0.101,NULL,60883037772,951297465,14864022,18.2),(68312,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1996E',NULL,68312,40.6,0.36,922,24654,74.2,NULL,'SALT 2','[GC96] J101020.28-123309.2',0.43,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,152.5845,-12.55256,0.205,NULL,41169420583,643272196,10051128,NULL),(68313,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1996E',NULL,68313,41.42,0.11,1340,24654,70,NULL,'SALT','[GC96] J101020.28-123309.2',0.43,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68314,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1996E',NULL,68314,41.7,0.4,1530,24654,65,NULL,NULL,'[GC96] J101020.28-123309.2',0.43,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68315,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1996E',NULL,68315,41.74,0.28,1560,24654,65,NULL,'MLCS','[GC96] J101020.28-123309.2',0.43,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68316,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1996E',NULL,68316,42.03,0.22,1780,24654,65,NULL,'Template','[GC96] J101020.28-123309.2',0.43,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68317,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68317,36.7,0.46,219,24655,70,NULL,NULL,'2MASX J10102081+2448281',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000187,NULL,'16.2g',0.41,NULL,NULL,NULL,NULL,NULL,1,152.5867917,24.80792,0.113,NULL,64157063956,1002454124,15663345,16.2),(68318,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68318,37.94,0.46,387,24656,70,NULL,NULL,'2MASX J10102515+1345059',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000191,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,152.6047083,13.75186,0.105,NULL,60850500674,950789073,14856079,16.7),(68319,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68319,38.07,0.23,411,24657,70,NULL,NULL,'2MASX J10102531+0237488',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000087,NULL,'17.0g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,152.6055,2.63022,0.045,NULL,60791432865,949866138,14841658,17),(68320,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68320,36.26,0.46,179,24658,70,NULL,NULL,'2MASX J10102621+5638562',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,152.609125,56.64894,0,NULL,61927837071,967622454,15119100,17.2),(68321,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68321,34.32,0.4,73.1,24659,NULL,NULL,'mean','IC 2550',NULL,'2007A&A...465...71T',2007,1,0.83,NULL,'G',0.00003,NULL,'14.2g',0.77,'SAB(rs)b:',NULL,NULL,NULL,NULL,1,152.616333,27.95611,0.089,NULL,64035591336,1000556114,15633689,14.2),(68322,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68322,34.77,0.47,89.8,24659,NULL,NULL,'H','IC 2550',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68323,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68323,37.81,0.33,365,24660,70,NULL,NULL,'2MASX J10102926+1518399',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,152.621833333,15.31122,0.097,NULL,60839543651,950617869,14853404,16.9),(68324,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68324,38.07,0.23,411,24661,70,NULL,NULL,'2MASX J10103105+0238588',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000071,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,152.6294583,2.64986,0.045,NULL,60791217464,949862772,14841605,17.5),(68325,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68325,36.85,0.46,235,24662,70,NULL,NULL,'SDSS J101031.84+105209.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000164,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,152.6327083,10.86919,0.089,NULL,60883204920,951300076,14864063,18.1),(68326,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68326,38.58,0.46,521,24663,70,NULL,NULL,'2MASX J10103317+4042179',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000173,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,152.638125,40.70497,0.033,NULL,64102083856,1001595060,15649922,17.3),(68327,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1996J',NULL,68327,40.25,0.32,863,24664,74.2,NULL,'SALT 2','MS 1008.1-1224:PPP 001719',0.3,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,':','19.75',NULL,NULL,NULL,NULL,NULL,NULL,1,152.638375,-12.61811,0.209,NULL,41169426528,643272289,10051129,19.75),(68328,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1996J','R',68328,40.64,NULL,1030,24664,65,NULL,'SALT','MS 1008.1-1224:PPP 001719',0.3,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68329,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1996J',NULL,68329,40.91,0.32,1170,24664,70,NULL,'SALT','MS 1008.1-1224:PPP 001719',0.3,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68330,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1996J',NULL,68330,40.99,0.25,1210,24664,65,NULL,'Template','MS 1008.1-1224:PPP 001719',0.3,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68331,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1996J',NULL,68331,41.01,0.25,1230,24664,65,NULL,NULL,'MS 1008.1-1224:PPP 001719',0.3,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68332,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1996J',NULL,68332,41.05,0.29,1250,24664,65,NULL,'SALT','MS 1008.1-1224:PPP 001719',0.3,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68333,'SNIa','2016-12-15 15:14:35','2016-12-16 11:19:42','1','SN 1996J',NULL,68333,41.38,0.24,1450,24664,65,NULL,'MLCS','MS 1008.1-1224:PPP 001719',0.3,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68334,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68334,35.53,0.33,128,24665,70,NULL,NULL,'CGCG 036-047',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000087,NULL,'15.3g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,152.6457083,6.16731,0.021,NULL,60756309666,949317338,14833083,15.3),(68335,'Tully est','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68335,32.64,0.8,33.8,24666,75,NULL,NULL,'UGCA 204',NULL,'1988NBGC.C....0000T',1988,1,2,NULL,'G',0.00002,NULL,'14.24',1.6,'SB(s)dm:',NULL,NULL,NULL,NULL,1,152.647333,-25.82744,0.105,NULL,42816039852,669000622,10453134,14.24),(68336,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68336,37.75,0.33,354,24667,70,NULL,NULL,'SDSS J101036.74+032211.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000121,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,152.653125,3.36978,0.013,NULL,60799028408,949984818,14843512,18.4),(68337,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68337,35.99,0.46,158,24668,70,NULL,NULL,'2MASX J10103710+5451552',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000164,NULL,'16.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,152.654917,54.86539,0,NULL,61902405551,967225086,15112891,16.1),(68338,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68338,38.01,0.46,400,24669,70,NULL,NULL,'2MASX J10103754+2844100',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000177,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,152.656417,28.73608,0.073,NULL,64036353248,1000568019,15633875,17.6),(68339,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68339,37.85,0.21,371,24670,70,NULL,NULL,'SDSS J101037.63+110820.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,152.656833,11.13897,0.101,NULL,60883070150,951297971,14864030,18),(68340,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68340,35.29,0.66,114,24671,70,NULL,NULL,'2MASX J10103871-4116166',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.2,NULL,NULL,NULL,NULL,NULL,1,152.661417,-41.27133,0.717,NULL,42090192070,657659251,10275925,14.1),(68341,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68341,38.07,0.23,411,24672,70,NULL,NULL,'2MASX J10103919+0239568',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000074,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,152.663417,2.66592,0.045,NULL,60791214977,949862734,14841605,18.1),(68342,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68342,35.65,0.46,135,24673,70,NULL,NULL,'2MASX J10103932+1136453',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000161,NULL,'16.3g',0.33,'S0',NULL,NULL,NULL,NULL,1,152.66375,11.61258,0.089,NULL,60882583085,951290360,14863911,16.3),(68343,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68343,37.65,0.46,338,24674,70,NULL,NULL,'2MASX J10103969+3941399',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000178,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,152.665541667,39.69439,0.013,NULL,64095954789,1001499293,15648426,17.4),(68344,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68344,33.87,0.4,59.4,24675,NULL,NULL,'mean','UGC 05489',NULL,'2007A&A...465...71T',2007,1,2.1,NULL,'G',0.000017,NULL,'13.6g',1.1,'Sa','Field galaxy',NULL,NULL,NULL,1,152.666375,20.07017,0.061,NULL,60814937496,950233398,14847396,13.6),(68345,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68345,33.91,0.47,60.5,24675,NULL,NULL,'H','UGC 05489',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68346,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68346,33.96,0.45,61.9,24675,NULL,NULL,'K','UGC 05489',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68347,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68347,33.97,0.46,62.2,24675,NULL,NULL,'J','UGC 05489',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68348,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68348,37.97,0.46,393,24676,70,NULL,NULL,'2MASX J10104021+0127038',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000081,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,152.6675,1.45106,0.005,NULL,60788543273,949820988,14840952,17.6),(68349,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68349,35.15,0.46,107,24677,70,NULL,NULL,'CGCG 036-049',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000103,NULL,'15.7g',0.42,'E0',NULL,NULL,NULL,NULL,1,152.668833333,7.57686,0.021,NULL,60756921184,949326893,14833232,15.7),(68350,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68350,37.38,0.46,299,24678,70,NULL,NULL,'2MASX J10104074+2432170',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000177,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,152.669583,24.53806,0.109,NULL,64156251550,1002441430,15663147,17),(68351,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68351,35.43,0.78,122,24679,70,NULL,NULL,'2MASX J10104105-2021043',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.26',NULL,NULL,NULL,NULL,NULL,NULL,1,152.671,-20.35139,0.241,NULL,41152756586,643011821,10047059,16.26),(68352,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68352,37.38,0.46,299,24680,70,NULL,NULL,'2MASX J10104183+0620343',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000166,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,152.674375,6.34294,0.021,NULL,60756289751,949317027,14833078,16.5),(68353,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68353,37.75,0.33,354,24681,70,NULL,NULL,'2MASX J10104212+0323368',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000185,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,152.675583,3.39369,0.013,NULL,60799028788,949984824,14843512,16.9),(68354,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68354,37.75,0.46,355,24682,70,NULL,NULL,'2MASX J10104373+1832144',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,152.68225,18.53728,0.081,NULL,60811467340,950179177,14846549,17.8),(68355,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68355,37.99,0.23,396,24683,70,NULL,NULL,'SDSS J101045.34+084212.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,152.688917,8.70358,0.021,NULL,60877378326,951209036,14862641,18.3),(68356,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68356,35.24,0.49,112,24684,75,NULL,'IR','FGC 1026',NULL,'2011yCatp016004901K',2011,1,0.95,NULL,'G',0.000015,NULL,'16.4g',0.17,'Scd',NULL,NULL,NULL,NULL,1,152.689375,33.28153,0.057,NULL,64079269531,1001238586,15644352,16.4),(68357,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68357,35.45,NULL,123,24684,NULL,NULL,NULL,'FGC 1026',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68358,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68358,35.49,NULL,125,24684,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68359,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68359,35.51,NULL,126,24684,NULL,NULL,'Dipole + Quadrupole','FGC 1026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68360,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68360,35.53,NULL,128,24684,NULL,NULL,'Dipole','FGC 1026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68361,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68361,36.15,0.64,170,24685,70,NULL,NULL,'2MASX J10104556-2043442',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,152.689875,-20.729,0.241,NULL,41153118787,643017481,10047148,15.4),(68362,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68362,32.48,0.49,31.3,24686,70,NULL,NULL,'IC 2552',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.00004,NULL,'13.40',1.5,'SAB(s)0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,152.69225,-34.84469,0.409,NULL,41970363634,655786931,10246670,13.4),(68363,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68363,33,0.45,39.8,24686,NULL,NULL,'K','IC 2552',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68364,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68364,33.2,0.4,43.6,24686,NULL,NULL,'mean','IC 2552',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68365,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68365,37.12,0.33,266,24687,70,NULL,NULL,'2MASX J10104621+3108352',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000153,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,152.692417,31.14319,0.097,NULL,64032627779,1000509809,15632965,17.1),(68366,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68366,38.23,0.46,442,24688,70,NULL,NULL,'2MASX J10104908+0743323',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000208,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,152.7045,7.72564,0.017,NULL,60757385339,949334145,14833346,17),(68367,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68367,36.79,0.11,228,24689,70,NULL,NULL,'CGCG 266-030',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.00011,NULL,'15.1g',0.6,'E0',NULL,NULL,NULL,NULL,1,152.707083,54.21481,0,NULL,61901085888,967204467,15112569,15.1),(68368,'IRAS','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68368,32.77,0.8,35.8,24690,75,NULL,'MAT, I','ESO 435- G 050',NULL,'1997ApJS..109..333W',1997,1,2.13,NULL,'G',0.000003,NULL,'15.94',0.19,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,152.710417,-30.42389,0.293,NULL,41951246545,655488227,10242003,15.94),(68369,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68369,32.55,0.32,32.3,24690,85,NULL,'I, inv','ESO 435- G 050',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68370,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68370,32.58,0.32,32.8,24690,85,NULL,'I, raw','ESO 435- G 050',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68371,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68371,32.87,NULL,37.5,24690,NULL,NULL,NULL,'ESO 435- G 050',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68372,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68372,33.02,NULL,40.1,24690,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 435- G 050',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68373,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68373,33.03,NULL,40.4,24690,NULL,NULL,'Dipole + Quadrupole','ESO 435- G 050',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68374,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68374,33.04,NULL,40.5,24690,NULL,NULL,'Dipole','ESO 435- G 050',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68375,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68375,33.08,0.43,41.3,24690,75,NULL,'MAT, I, inv','ESO 435- G 050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68376,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68376,33.13,0.43,42.2,24690,75,NULL,'MAT, I, raw','ESO 435- G 050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68377,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68377,33.2,0.13,43.7,24690,NULL,NULL,NULL,'ESO 435- G 050',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68378,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68378,33.32,0.2,46.1,24690,74.4,NULL,NULL,'ESO 435- G 050',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68379,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68379,33.33,0.43,46.3,24690,75,NULL,'3.6 micron, color + selection bias corrected','ESO 435- G 050',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68380,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68380,33.37,0.43,47.2,24690,75,NULL,'3.6 micron, color corrected','ESO 435- G 050',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68381,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68381,33.38,0.43,47.4,24690,75,NULL,'MAT, I, cor','ESO 435- G 050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68382,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68382,36.47,0.46,196,24691,70,NULL,NULL,'2MASX J10105101+6847191',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,152.712416667,68.78878,0.101,NULL,62129356620,970771197,15168299,16.5),(68383,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68383,34.76,0.69,89.4,24692,70,NULL,NULL,'ESO 500- G 007',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'16.05',0.2,'Sa:',NULL,NULL,NULL,NULL,1,152.7155,-23.15903,NULL,NULL,41138385753,642787277,10043551,16.05),(68384,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68384,37.2,0.46,276,24693,70,NULL,NULL,'2MASX J10105344+2952442',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,152.72275,29.87894,0.161,NULL,64033639232,1000525613,15633212,17.4),(68385,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68385,37.81,0.46,365,24694,70,NULL,NULL,'2MASX J10105417+2315171',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,152.725875,23.25494,0.077,NULL,60801039314,950016239,14844003,17.9),(68386,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68386,37.3,0.46,289,24695,70,NULL,NULL,'2MASX J10105436+0855003',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,152.726417,8.91664,0.021,NULL,60877413794,951209590,14862649,17.6),(68387,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68387,38.05,0.46,406,24696,70,NULL,NULL,'2MASX J10105449+3055312',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,152.7270417,30.92536,0.089,NULL,64032716758,1000511199,15632987,17.6),(68388,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68388,37.9,0.46,380,24697,70,NULL,NULL,'2MASX J10105462+3411152',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,152.7275,34.18758,0.045,NULL,64078562706,1001227542,15644180,18.1),(68389,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68389,37.42,0.46,304,24698,70,NULL,NULL,'2MASX J10105471+5036360',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00017,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,152.728208333,50.61,0,NULL,64004688560,1000073258,15626144,17),(68390,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68390,37.38,0.33,299,24699,70,NULL,NULL,'2MASX J10105488+3753510',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000169,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,152.72875,37.8975,0,NULL,64065639003,1001025609,15641025,17.2),(68391,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68391,37.73,0.46,352,24700,70,NULL,NULL,'2MASX J10105521+0346300',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,152.73,3.77511,0,NULL,60799977580,949999649,14843744,17.5),(68392,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68392,37.62,0.46,335,24701,70,NULL,NULL,'2MASX J10105535+0806473',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000144,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,152.7307083,8.11317,0.025,NULL,60757529813,949336403,14833381,17.4),(68393,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68393,37.85,0.46,371,24702,70,NULL,NULL,'SDSS J101055.83+393037.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000172,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,152.732667,39.51031,0.041,NULL,64096069387,1001501084,15648454,17.8),(68394,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68394,37.73,0.46,351,24703,70,NULL,NULL,'2MASX J10105582+6144587',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,152.7327083,61.74958,0.013,NULL,61908601458,967321897,15114404,17.4),(68395,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68395,37.71,0.46,349,24704,70,NULL,NULL,'2MASX J10105586+6127267',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,152.732833,61.45728,0.025,NULL,61911589861,967368591,15115134,18),(68396,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68396,37.57,0.46,326,24705,70,NULL,NULL,'2MASX J10105663+0125560',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000083,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,152.736125,1.43233,0.005,NULL,60788341115,949817829,14840903,16.8),(68397,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68397,36.79,0.11,228,24706,70,NULL,NULL,'2MASX J10105716+5438070',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000174,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,152.738208333,54.63525,0,NULL,61902213455,967222085,15112845,16.2),(68398,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68398,35.79,0.46,144,24707,70,NULL,NULL,'2MASX J10105797-0030105',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000099,NULL,'15.3g',0.5,'E0',NULL,NULL,NULL,NULL,1,152.741667,-0.50283,0.069,NULL,41210084477,643907569,10061055,15.3),(68399,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68399,35.98,0.52,157,24707,70,NULL,NULL,'2MASX J10105797-0030105',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68400,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68400,38.12,0.46,421,24708,70,NULL,NULL,'SDSS J101058.25+312613.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,152.74275,31.43714,0.089,NULL,64077983312,1001218489,15644038,18.4),(68401,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68401,37.12,0.33,266,24709,70,NULL,NULL,'2MASX J10105915+3102052',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,152.746583,31.03483,0.097,NULL,64032849914,1000513279,15633019,17.6),(68402,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68402,37.81,0.33,365,24710,70,NULL,NULL,'2MASX J10105965+1517187',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,152.748625,15.28856,0.097,NULL,60839551704,950617995,14853406,18),(68403,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68403,36.79,0.11,228,24711,70,NULL,NULL,'2MASX J10105980+5439030',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,152.74925,54.65078,0,NULL,61902217074,967222141,15112845,17),(68404,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68404,35.64,0.46,134,24712,70,NULL,NULL,'2MASX J10110069+0859209',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000159,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,152.752875,8.98911,0.021,NULL,60877277437,951207459,14862616,16.3),(68405,'Cepheids','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68405,25.27,0.1,1.13,24713,NULL,NULL,NULL,'Sextans A',NULL,'1989ApJ...346..629V',1989,1,5.9,'Position in 1975A&A....19....1G refers to a starcloud southeast of the center.','G',0.000007,NULL,'11.86',4.9,'IBm','Possible field galaxy',NULL,NULL,NULL,1,152.753333,-4.69278,0.065,0,41270441982,644850655,10075791,11.86),(68406,'Cepheids','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68406,25.5,0.1,1.26,24713,NULL,18.47,'9, B, Photographic','Sextans A',NULL,'1987SAAOC..11..125W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68407,'Cepheids','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68407,25.59,NULL,1.31,24713,NULL,NULL,'B','Sextans A',NULL,'1991PASP..103..933M',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68408,'Cepheids','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68408,25.58,0.03,1.31,24713,NULL,NULL,NULL,'Sextans A',NULL,'2003AJ....125.1261D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68409,'Cepheids','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68409,25.6,NULL,1.32,24713,NULL,NULL,NULL,'Sextans A',NULL,'1985PASAu...6..140V',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68410,'Cepheids','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68410,25.62,0.04,1.33,24713,NULL,18.52,NULL,'Sextans A',NULL,'2011A&A...531A.134T',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68411,'Cepheids','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68411,25.64,0.05,1.34,24713,NULL,NULL,NULL,'Sextans A',NULL,'2003AJ....125.1261D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68412,'Cepheids','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68412,25.67,0.2,1.36,24713,NULL,NULL,'Photographic, 5, B','Sextans A',NULL,'1982ApJ...258..439S',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68413,'Cepheids','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68413,25.68,0.24,1.37,24713,NULL,NULL,'VI(W)','Sextans A',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68414,'Cepheids','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68414,25.69,0.06,1.37,24713,74.4,NULL,NULL,'Sextans A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68415,'Cepheids','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68415,25.71,0.2,1.39,24713,NULL,NULL,'5, VRI','Sextans A',NULL,'1994A&A...287..371P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68416,'Cepheids','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68416,25.73,NULL,1.4,24713,NULL,NULL,'V','Sextans A',NULL,'2004A&A...424..927C',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68417,'Cepheids','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68417,25.74,0.17,1.41,24713,NULL,NULL,'LMC W01','Sextans A',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68418,'Cepheids','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68418,25.75,0.23,1.41,24713,NULL,NULL,'MW GFG','Sextans A',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68419,'Cepheids','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68419,25.75,0.23,1.41,24713,NULL,NULL,'14, VI','Sextans A',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68420,'Cepheids','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68420,25.76,0.44,1.42,24713,NULL,NULL,'MW P02','Sextans A',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68421,'Cepheids','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68421,25.78,0.26,1.43,24713,NULL,NULL,'MW HIPP','Sextans A',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68422,'Cepheids','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68422,25.78,0.15,1.43,24713,NULL,NULL,NULL,'Sextans A',NULL,'2003AJ....125.1261D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68423,'Cepheids','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68423,25.79,0.15,1.44,24713,NULL,NULL,'LMC VIHJK','Sextans A',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68424,'Cepheids','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68424,25.85,NULL,1.48,24713,NULL,NULL,NULL,'Sextans A',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68425,'Cepheids','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68425,25.85,0.15,1.48,24713,NULL,NULL,'HST KP Calibrated','Sextans A',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68426,'Cepheids','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68426,25.85,0.15,1.48,24713,NULL,NULL,'6, BVRI','Sextans A',NULL,'1996ApJ...461..713S',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68427,'Cepheids','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68427,26,0.05,1.58,24713,NULL,NULL,'BVRI+','Sextans A',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68428,'Cepheids','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68428,26.03,0.05,1.61,24713,NULL,NULL,'BVRI','Sextans A',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68429,'Cepheids','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68429,26.07,0.19,1.64,24713,NULL,NULL,'BV(W)','Sextans A',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68430,'Cepheids','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68430,26.2,0.2,1.74,24713,NULL,NULL,'Photographic','Sextans A',NULL,'1985AJ.....90.1019S',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68431,'Cepheids','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68431,26.25,NULL,1.78,24713,NULL,NULL,'Photographic, APPARENT BLUE m-M','Sextans A',NULL,'1988PASP..100..935S',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68432,'Cepheids','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68432,26.8,0.4,2.29,24713,NULL,NULL,NULL,'Sextans A',NULL,'1987MNRAS.224..935W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68433,'CMD','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68433,25.6,NULL,1.32,24713,NULL,NULL,NULL,'Sextans A',NULL,'1987A&AS...71..297A',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68434,'CMD','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68434,25.72,NULL,1.39,24713,NULL,NULL,NULL,'Sextans A',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68435,'CMD','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68435,25.72,NULL,1.39,24713,NULL,NULL,NULL,'Sextans A',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68436,'PNLF','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68436,26.5,0.4,2,24713,NULL,NULL,NULL,'Sextans A',NULL,'1981AJ.....86..185J',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68437,'Red Clump','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68437,24.99,NULL,0.996,24713,NULL,NULL,'V, M RC(V) = +0.73 mag','Sextans A',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68438,'Red Clump','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68438,25.44,NULL,1.22,24713,NULL,NULL,'I, M RC(I) = -0.50 mag','Sextans A',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68439,'Red Clump','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68439,25.51,0.15,1.26,24713,NULL,NULL,NULL,'Sextans A',NULL,'2003AJ....125.1261D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68440,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68440,25.63,0.12,1.34,24713,NULL,NULL,NULL,'Sextans A',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68441,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68441,25.67,0.13,1.36,24713,NULL,NULL,NULL,'Sextans A',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68442,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68442,25.69,0.06,1.37,24713,NULL,NULL,NULL,'Sextans A',NULL,'2003AJ....125.1261D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68443,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68443,25.69,0.06,1.37,24713,74.4,NULL,NULL,'Sextans A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68444,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68444,25.71,0.07,1.38,24713,NULL,NULL,'I','Sextans A',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68445,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68445,25.7,0.11,1.38,24713,NULL,NULL,'HST KP Calibrated','Sextans A',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68446,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68446,25.74,0.13,1.42,24713,NULL,NULL,NULL,'Sextans A',NULL,'1996ApJ...461..713S',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68447,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68447,25.77,0.12,1.42,24713,NULL,NULL,'I','Sextans A',NULL,'2014A&A...566A..44B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68448,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68448,25.77,0.1,1.43,24713,NULL,NULL,NULL,'Sextans A',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68449,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68449,25.78,0.06,1.43,24713,NULL,NULL,NULL,'Sextans A',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68450,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68450,25.78,0.08,1.43,24713,NULL,NULL,'I','Sextans A',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68451,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68451,25.79,0.06,1.44,24713,NULL,NULL,'I','Sextans A',NULL,'2007ApJ...661..815R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68452,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68452,25.8,NULL,1.45,24713,NULL,NULL,'theory','Sextans A',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68453,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68453,25.83,NULL,1.47,24713,NULL,NULL,'I, M TRGB(I) = -4.05 mag','Sextans A',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68454,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68454,25.88,NULL,1.5,24713,NULL,NULL,'DA90','Sextans A',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68455,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68455,25.91,NULL,1.52,24713,NULL,NULL,NULL,'Sextans A',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68456,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68456,25.92,NULL,1.53,24713,NULL,NULL,'Yale','Sextans A',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68457,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68457,25.97,NULL,1.56,24713,NULL,NULL,'K97','Sextans A',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68458,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68458,25.59,0.4,1.3,24713,75,NULL,'B','Sextans A',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68459,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68459,32.95,0.49,38.9,24714,75,NULL,'IR','ESO 092- G 015',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000233,NULL,'14.50',1,'Sb:',NULL,NULL,NULL,NULL,1,152.75325,-67.14444,NULL,NULL,40690340099,635786564,9934165,14.5),(68460,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68460,36.19,0.46,173,24715,70,NULL,NULL,'CGCG 036-050',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000181,NULL,'15.8g',0.33,'S0/a',NULL,NULL,NULL,NULL,1,152.755333,3.22492,0.005,NULL,60799881458,949998147,14843721,15.8),(68461,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68461,37.64,0.46,337,24716,70,NULL,NULL,'SDSS J101101.40+141632.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,152.755875,14.27572,0.101,NULL,60847158235,950736847,14855263,18.1),(68462,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68462,37.79,0.46,361,24717,70,NULL,NULL,'2MASX J10110177+3657330',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,152.757667,36.95928,0.037,NULL,64067181160,1001049705,15641401,17.7),(68463,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68463,36.67,0.46,215,24718,70,NULL,NULL,'2MASX J10110181+2428010',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000176,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,152.7577083,24.46708,0.105,NULL,64156275243,1002441800,15663153,16.8),(68464,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68464,37.77,0.46,358,24719,70,NULL,NULL,'2MASX J10110290-0053155',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000079,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,152.762083,-0.88767,0.077,NULL,41209474873,643898044,10060906,17.5),(68465,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68465,37.13,0.33,267,24720,70,NULL,NULL,'SDSS J101103.08-010910.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000066,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,152.762833,-1.15294,0.065,NULL,41264103553,644751618,10074244,18.1),(68466,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68466,37.52,0.46,319,24721,70,NULL,NULL,'2MASX J10110686+3119462',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,152.7785417,31.32953,0.093,NULL,64032652656,1000510197,15632971,17.7),(68467,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68467,35.44,0.46,123,24722,70,NULL,NULL,'2MASX J10110690+1723597',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,152.7789583,17.39989,0.077,NULL,60859023608,950922243,14858160,16.4),(68468,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68468,34.82,0.98,91.9,24723,NULL,NULL,NULL,'ESO 567- G 022',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.80',0.7,'Sb',NULL,NULL,NULL,NULL,1,152.783,-21.53247,0.217,NULL,41141027442,642828553,10044196,15.8),(68469,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68469,34.86,0.2,93.8,24723,74.4,NULL,NULL,'ESO 567- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68470,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68470,34.9,0.94,95.5,24723,NULL,NULL,'Malmquist cor.','ESO 567- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68471,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68471,37.45,0.46,309,24724,70,NULL,NULL,'2MASX J10110873+1432517',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,152.786333,14.54756,0.105,NULL,60847606081,950743845,14855372,16.7),(68472,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68472,37.18,0.46,273,24725,70,NULL,NULL,'SDSS J101108.99+120354.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000152,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,152.7875,12.06506,0.085,NULL,60868845482,951075710,14860557,18),(68473,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68473,37.78,0.46,359,24726,70,NULL,NULL,'2MASX J10110999+1211381',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000177,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,152.791625,12.19394,0.085,NULL,60836288111,950567001,14852609,17.6),(68474,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68474,37.5,0.46,317,24727,70,NULL,NULL,'SDSS J101110.02+062444.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000141,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,152.79175,6.41228,0.021,NULL,60756269536,949316711,14833073,18),(68475,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68475,36.92,0.46,242,24728,70,NULL,NULL,'2MASX J10111125+1914312',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000168,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,152.796917,19.24203,0.073,NULL,60811788524,950184195,14846628,16.6),(68476,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68476,37.99,0.23,396,24729,70,NULL,NULL,'2MASX J10111137+0841319',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,'FoF','16.9g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,152.797333333,8.69225,0.021,NULL,60877399063,951209360,14862646,16.9),(68477,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68477,37.13,0.33,267,24730,70,NULL,NULL,'2MASX J10111230-0111115',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000081,NULL,'16.6g',0.31,'S0','Group member',NULL,NULL,NULL,1,152.801417,-1.18664,0.065,NULL,41209333421,643895834,10060872,16.6),(68478,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68478,36.05,0.66,162,24731,70,NULL,NULL,'2MASX J10111441-2157476',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.62',NULL,NULL,NULL,NULL,NULL,NULL,1,152.81025,-21.96353,0.221,NULL,41141762357,642840036,10044375,16.62),(68479,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68479,37.99,0.23,396,24732,70,NULL,NULL,'2MASX J10111487+0841089',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000189,NULL,'17.0g',0.24,'BrClG',NULL,NULL,NULL,NULL,1,152.812041667,8.68583,0.021,NULL,60877391891,951209248,14862644,17),(68480,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68480,38.14,0.46,425,24733,70,NULL,NULL,'2MASX J10111657+5631281',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000181,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,152.819083,56.52439,0,NULL,61927739682,967620932,15119077,17.7),(68481,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68481,37.99,0.23,396,24734,70,NULL,NULL,'2MASX J10111663+0836139',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000156,NULL,'17.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,152.819208333,8.60383,0.025,NULL,60877326494,951208226,14862628,17.2),(68482,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68482,38.18,0.23,433,24735,70,NULL,NULL,'2MASX J10111698+0635279',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000133,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,152.820667,6.59119,0.009,NULL,60756252460,949316444,14833069,17.9),(68483,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68483,37.53,0.46,321,24736,70,NULL,NULL,'2MASX J10111759+3439332',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,152.823125,34.65911,0.033,NULL,64078505994,1001226656,15644166,18.1),(68484,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68484,37.38,0.33,299,24737,70,NULL,NULL,'2MASX J10112113+3752513',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000123,NULL,'15.8g',0.44,'E0',NULL,NULL,NULL,NULL,1,152.8382083,37.88092,0,NULL,64065514053,1001023657,15640994,15.8),(68485,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68485,37.3,0.46,288,24738,70,NULL,NULL,'2MASX J10112180+1748511',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',NULL,NULL,'17.05',0.43,NULL,NULL,NULL,NULL,NULL,1,152.8407083,17.81422,0.085,NULL,60858855985,950919624,14858119,17.05),(68486,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68486,37.48,0.46,313,24739,70,NULL,NULL,'2MASX J10112191+6842011',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,152.8414583,68.70036,0.077,NULL,62129363640,970771306,15168301,17.3),(68487,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68487,36.82,0.33,231,24740,70,NULL,NULL,'2MASX J10112508+2305441',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000191,NULL,'16.1g',0.34,NULL,NULL,NULL,NULL,NULL,1,152.8545417,23.09561,0.069,NULL,60801578195,950024659,14844135,16.1),(68488,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68488,38.2,0.46,436,24741,70,NULL,NULL,'SDSS J101125.75+195658.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000134,NULL,'18.5g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,152.857333333,19.94958,0.077,NULL,60814839092,950231860,14847372,18.5),(68489,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68489,35.93,0.46,153,24742,70,NULL,NULL,'2MASX J10112664+3442125',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,152.860875,34.70347,0.033,NULL,64078538009,1001227156,15644174,16.4),(68490,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68490,37.29,0.46,288,24743,70,NULL,NULL,'2MASX J10112700+3555543',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,152.862625,35.93175,0.029,NULL,64066773564,1001043336,15641302,17.5),(68491,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68491,36.79,0.11,228,24744,70,NULL,NULL,'2MASX J10112821+5426011',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000166,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,152.867583333,54.43372,0,NULL,61900853366,967200833,15112513,16.4),(68492,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68492,36.79,0.11,228,24745,70,NULL,NULL,'2MASX J10112838+5439101',NULL,'2015arXiv151105856S',2015,1,0.46,'Mittaz, et al.(1999MNRAS.308..233M) give z = 0.233.','G',0.00021,NULL,'15.7g',0.39,'Elliptical',NULL,NULL,NULL,NULL,1,152.86825,54.65283,0,NULL,61902172205,967221440,15112835,15.7),(68493,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68493,36.8,0.46,229,24746,70,NULL,NULL,'2MASX J10112876+1628081',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,152.869958333,16.46892,0.113,NULL,60857758632,950902478,14857851,16.7),(68494,'FP','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,'R',68494,37.99,0.46,395,24747,70,NULL,NULL,'2MASX J10112989+1420481',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,152.874417,14.34661,0.101,NULL,60847097329,950735895,14855248,17.5),(68495,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68495,33.74,0.46,56.1,24748,NULL,NULL,'J','UGC 05490',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000023,NULL,'14.40',1,'Scd:',NULL,NULL,NULL,NULL,1,152.8757917,30.79156,0.097,NULL,64032732808,1000511450,15632991,14.4),(68496,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:42','1',NULL,NULL,68496,34.1,0.47,66,24748,NULL,NULL,'H','UGC 05490',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68497,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68497,34.36,0.4,74.6,24748,NULL,NULL,'mean','UGC 05490',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68498,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68498,34.49,0.45,78.9,24748,NULL,NULL,'K','UGC 05490',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68499,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68499,37.99,0.46,397,24749,70,NULL,NULL,'2MASX J10113056+3412035',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000173,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,152.87725,34.20114,0.045,NULL,64078690472,1001229538,15644211,16.8),(68500,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68500,37.51,0.46,318,24750,70,NULL,NULL,'2MASX J10113076+4848228',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000188,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,152.878333,48.80647,0,NULL,63999918994,999998734,15624980,16.8),(68501,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68501,37.46,0.46,310,24751,70,NULL,NULL,'SDSS J101132.10+153842.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.8g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,152.8837917,15.64503,0.105,NULL,60840419658,950631557,14853618,17.8),(68502,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68502,38.18,0.23,433,24752,70,NULL,NULL,'2MASX J10113309+0631484',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000145,NULL,'16.5g',0.4,NULL,NULL,NULL,NULL,NULL,1,152.8877917,6.53025,0.021,NULL,60756237300,949316207,14833065,16.5),(68503,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68503,36.47,0.58,197,24753,70,NULL,NULL,'2MASX J10113470-4234420',NULL,'2014MNRAS.445.2677S',2014,1,0.11,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,152.894625,-42.57836,0.633,NULL,42083443463,657553804,10274278,16.6),(68504,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68504,38.32,0.46,462,24754,70,NULL,NULL,'SDSS J101135.04+301859.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000178,NULL,'17.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,152.8960417,30.31644,0.105,NULL,64033005037,1000515703,15633057,17.9),(68505,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68505,35.41,0.46,121,24755,70,NULL,NULL,'2MASX J10113508+0914224',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000162,NULL,'15.9g',0.29,'E0',NULL,NULL,NULL,NULL,1,152.89625,9.23944,0.033,NULL,60881590258,951274847,14863669,15.9),(68506,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68506,38.18,0.23,433,24756,70,NULL,NULL,'2MASX J10113536+0638284',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00016,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,152.8972917,6.64111,0.013,NULL,60756333512,949317711,14833089,17.3),(68507,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68507,37.85,0.46,372,24757,70,NULL,NULL,'2MASX J10113775+3638473',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,152.9075,36.64664,0.037,NULL,64066615134,1001040861,15641263,17.9),(68508,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68508,37.3,0.46,288,24758,70,NULL,NULL,'2MASX J10113794+6821240',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,152.907875,68.35678,0.093,NULL,62127746385,970746037,15167906,18),(68509,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68509,37.11,0.46,264,24759,70,NULL,NULL,'2MASX J10114099+1043584',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,152.921,10.73292,0.073,NULL,60869064253,951079128,14860611,17),(68510,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68510,37.01,0.46,253,24760,70,NULL,NULL,'2MASX J10114202+0614494',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000179,NULL,'15.9g',0.44,'E0',NULL,NULL,NULL,NULL,1,152.925167,6.24719,0.013,NULL,60756157096,949314954,14833046,15.9),(68511,'IRAS','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68511,32.86,0.8,37.3,24761,75,NULL,'MAT, I','NGC 3157',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.00001,NULL,'13.91',0.5,'SAB(s)c        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,152.9267917,-31.64286,0.377,NULL,42004368575,656318258,10254972,13.91),(68512,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68512,32.17,0.32,27.2,24761,85,NULL,'I, raw','NGC 3157',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68513,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68513,32.2,0.32,27.5,24761,85,NULL,'I, inv','NGC 3157',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68514,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68514,32.21,0.4,27.7,24761,75,NULL,NULL,'NGC 3157',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68515,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68515,32.33,0.43,29.3,24761,75,NULL,'MAT, I, raw','NGC 3157',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68516,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68516,32.39,0.43,30.1,24761,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3157',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68517,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68517,32.46,0.43,31,24761,75,NULL,'3.6 micron, color corrected','NGC 3157',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68518,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68518,32.47,0.49,31.2,24761,75,NULL,'IR','NGC 3157',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68519,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68519,32.47,0.43,31.2,24761,75,NULL,'MAT, I, inv','NGC 3157',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68520,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68520,32.53,0.2,32.1,24761,74.4,NULL,NULL,'NGC 3157',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68521,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68521,32.55,0.46,32.3,24761,NULL,NULL,'J','NGC 3157',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68522,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68522,32.56,0.47,32.5,24761,NULL,NULL,'H','NGC 3157',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68523,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68523,32.62,0.45,33.4,24761,NULL,NULL,'K','NGC 3157',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68524,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68524,32.72,0.43,35,24761,75,NULL,'MAT, I, cor','NGC 3157',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68525,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68525,33.07,0.4,41.1,24761,NULL,NULL,'mean','NGC 3157',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68526,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68526,33.26,0.13,45,24761,NULL,NULL,NULL,'NGC 3157',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68527,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68527,35.81,0.46,145,24762,70,NULL,NULL,'2MASX J10114266+0449031',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000178,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,152.927833,4.81736,0.013,NULL,60798006285,949968848,14843263,16.3),(68528,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68528,37.03,0.33,255,24763,70,NULL,NULL,'2MASX J10114364+1034204',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000188,NULL,'15.9g',0.43,'E0',NULL,NULL,NULL,NULL,1,152.931958333,10.57231,0.073,NULL,60870364800,951099450,14860928,15.9),(68529,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68529,37.8,0.33,363,24764,70,NULL,NULL,'2MASX J10114370+0204191',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000096,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,152.932,2.07206,0.033,NULL,60791836694,949872448,14841757,16.8),(68530,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68530,35.84,0.46,147,24765,70,NULL,NULL,'2MASX J10114642+4117036',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,152.943416667,41.28428,0,NULL,64102169116,1001596392,15649943,16.9),(68531,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68531,38.48,0.46,497,24766,70,NULL,NULL,'SDSS J101146.96+111531.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000172,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,152.9457083,11.25878,0.093,NULL,60869245133,951081955,14860655,18),(68532,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68532,36.76,0.46,225,24767,70,NULL,NULL,'2MASX J10114744+4548248',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000133,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,152.9477083,45.80686,0,NULL,64143709688,1002245463,15660085,17.1),(68533,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68533,37.95,0.46,388,24768,70,NULL,NULL,'SDSS J101147.96-010345.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000072,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,152.949875,-1.06269,0.065,NULL,41209539418,643899053,10060922,18.4),(68534,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68534,38.18,0.23,433,24769,70,NULL,NULL,'2MASX J10114946+0632414',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00014,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,152.956125,6.54489,0.017,NULL,60756361047,949318141,14833095,18),(68535,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68535,37.89,0.27,378,24770,70,NULL,NULL,'SDSS J101151.74+083837.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00016,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,152.965625,8.64364,0.025,NULL,60756833631,949325525,14833211,18.5),(68536,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68536,37.27,0.46,285,24771,70,NULL,NULL,'2MASX J10115292+4821532',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000134,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,152.9702083,48.36494,0,NULL,64000867860,1000013560,15625211,17.8),(68537,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68537,37.03,0.33,255,24772,70,NULL,NULL,'SDSS J101152.89+103457.0',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000154,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,152.970375,10.58253,0.077,NULL,60870364154,951099439,14860928,17.7),(68538,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68538,34.65,NULL,85.1,24773,NULL,NULL,'Dipole','UGC 05495',NULL,'2010Ap&SS.325..163P',2010,1,2.97,NULL,'G',0.000007,NULL,'14.30',0.32,'Sbc',NULL,NULL,NULL,NULL,1,152.972167,16.44017,0.113,NULL,60857565260,950899457,14857804,14.3),(68539,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68539,34.66,NULL,85.3,24773,NULL,NULL,'Dipole + Quadrupole','UGC 05495',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68540,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68540,34.66,NULL,85.6,24773,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05495',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68541,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68541,34.84,NULL,92.7,24773,NULL,NULL,NULL,'UGC 05495',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68542,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68542,35,0.47,100,24773,NULL,NULL,'H','UGC 05495',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68543,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68543,35.12,0.45,106,24773,NULL,NULL,'K','UGC 05495',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68544,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68544,35.16,0.46,107,24773,NULL,NULL,'J','UGC 05495',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68545,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68545,35.43,0.4,122,24773,NULL,NULL,'mean','UGC 05495',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68546,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68546,37.8,0.33,363,24774,70,NULL,NULL,'SDSS J101153.75+020406.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000073,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,152.9739583,2.0685,0.033,NULL,60789777137,949840267,14841254,17.8),(68547,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68547,38.26,0.46,448,24775,70,NULL,NULL,'2MASX J10115489+3449366',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000173,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,152.978833333,34.82689,0.037,NULL,64078493532,1001226461,15644163,17.9),(68548,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68548,36.54,0.46,203,24776,70,NULL,NULL,'2MASX J10115499+2351588',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000178,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,152.979125,23.86647,0.101,NULL,63686532346,995102067,15548469,16.7),(68549,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68549,38.24,0.46,446,24777,70,NULL,NULL,'2MASX J10115587+4054576',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000185,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,152.9830417,40.91597,0.009,NULL,64102304844,1001598513,15649976,17.8),(68550,'Tully est','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68550,32.65,0.8,34,24778,75,NULL,NULL,'UGCA 206',NULL,'1988NBGC.C....0000T',1988,1,0.3,NULL,'G',0.000033,NULL,'17.0',0.2,'Pec',NULL,NULL,NULL,NULL,1,152.9849583,58.73439,0,NULL,61919854720,967497730,15117152,17),(68551,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68551,38.04,0.46,406,24779,70,NULL,NULL,'SDSS J101156.77+060054.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000117,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,152.986541667,6.015,0.005,NULL,60786868861,949794825,14840544,18.3),(68552,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68552,39.04,0.46,644,24780,70,NULL,NULL,'2MASX J10115761+0617272',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000181,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,152.990125,6.29103,0.013,NULL,60756432422,949319256,14833113,18.3),(68553,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68553,38.29,0.46,454,24781,70,NULL,NULL,'2MASX J10115767+0752344',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,152.990291667,7.87625,0.025,NULL,60757282327,949332536,14833320,17.7),(68554,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68554,36.29,0.46,181,24782,70,NULL,NULL,'2MASX J10115865+1023502',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00014,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,152.994375,10.39739,0.077,NULL,60870388211,951099815,14860934,16.9),(68555,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68555,37.13,0.46,267,24783,70,NULL,NULL,'2MASX J10115871+3934186',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000103,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,152.9947917,39.572,0.017,NULL,64095927672,1001498869,15648419,16.2),(68556,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68556,35.92,0.46,152,24784,70,NULL,NULL,'2MASX J10120265+5533421',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000177,NULL,'15.8g',0.38,'S0',NULL,NULL,NULL,NULL,1,153.010875,55.56161,0,NULL,61903937086,967249016,15113265,15.8),(68557,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68557,38.31,0.46,459,24785,70,NULL,NULL,'2MASX J10120297+0114392',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000068,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,153.012333,1.24428,0,NULL,60742472842,949101138,14829705,17.7),(68558,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68558,37.89,0.27,378,24786,70,NULL,NULL,'2MASX J10120638+0841333',NULL,'2015arXiv151105856S',2015,1,0.49,'TXS codes: lobes(C)','G',0.000176,NULL,'16.7g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,153.026667,8.69253,0.033,NULL,60756614433,949322100,14833157,16.7),(68559,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68559,34.21,0.49,69.6,24787,75,NULL,'IR','ESO 037- G 011',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000033,NULL,'15.14',0.3,'Sb:',NULL,NULL,NULL,NULL,1,153.027333333,-72.84139,0.505,NULL,40708238343,636066224,9938534,15.14),(68560,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68560,34.38,0.4,75.2,24787,NULL,NULL,'mean','ESO 037- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68561,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68561,34.47,0.38,78.3,24787,NULL,NULL,'Malmquist cor.','ESO 037- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68562,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68562,34.55,0.36,81.3,24787,NULL,NULL,NULL,'ESO 037- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68563,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68563,34.56,0.47,81.8,24787,NULL,NULL,'H','ESO 037- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68564,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68564,34.59,0.2,82.8,24787,74.4,NULL,NULL,'ESO 037- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68565,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68565,36.42,0.5,192,24788,NULL,NULL,'Malmquist cor.','2MASX J10120843-0125082',NULL,'2009ApJS..182..474S',2009,1,0.74,NULL,'G',0.000027,NULL,'17.32',0.3,'Sb:','Group member',NULL,NULL,NULL,1,153.035083,-1.41875,0.073,NULL,41209300039,643895313,10060864,17.32),(68566,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68566,36.67,0.44,216,24788,NULL,NULL,NULL,'2MASX J10120843-0125082',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68567,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68567,36.71,0.2,220,24788,74.4,NULL,NULL,'2MASX J10120843-0125082',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68568,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68568,37.87,0.46,375,24789,70,NULL,NULL,'2MASX J10120877+2817102',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000175,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,153.036417,28.28611,0.101,NULL,64036529822,1000570778,15633918,17.6),(68569,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68569,36.7,0.46,219,24790,70,NULL,NULL,'2MASX J10120968+1538593',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,153.0404583,15.64978,0.105,NULL,60840463818,950632247,14853628,16.7),(68570,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68570,36.19,0.79,173,24791,70,NULL,NULL,'LCRS B100939.3-021811',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.8g',0.36,NULL,NULL,NULL,NULL,NULL,1,153.0492917,-2.55061,0.045,NULL,41266360367,644786880,10074795,15.8),(68571,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68571,38.69,0.46,546,24792,70,NULL,NULL,'SDSS J101212.09+041913.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,153.050375,4.32033,0.017,NULL,60799753985,949996156,14843689,18.5),(68572,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68572,31.83,NULL,23.2,24793,NULL,NULL,NULL,'MCG +10-15-030',NULL,'2000BSAO...50....5K',2000,1,0.92,NULL,'G',0.000113,NULL,'16.7g',0.16,'Sd(f)',NULL,NULL,NULL,NULL,1,153.050541667,62.09697,0,NULL,61908578114,967321533,15114398,16.7),(68573,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68573,33.06,NULL,40.9,24793,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG +10-15-030',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68574,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68574,33.09,NULL,41.5,24793,NULL,NULL,'Dipole + Quadrupole','MCG +10-15-030',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68575,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68575,33.1,NULL,41.7,24793,NULL,NULL,'Dipole','MCG +10-15-030',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68576,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68576,37.89,0.27,378,24794,70,NULL,NULL,'SDSS J101212.46+083904.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00014,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,153.0519583,8.65117,0.033,NULL,60756836799,949325574,14833212,18.3),(68577,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68577,36.12,0.52,167,24795,70,NULL,NULL,'2MASX J10121471-0712482',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'15.91',0.38,NULL,NULL,NULL,NULL,NULL,1,153.06125,-7.21347,0.113,NULL,41250175483,644533991,10070843,15.91),(68578,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68578,36.53,0.46,203,24796,70,NULL,NULL,'2MASX J10121530+2934012',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00013,NULL,'16.7g',0.27,'E',NULL,NULL,NULL,NULL,1,153.063875,29.56708,0.093,NULL,64033404056,1000521938,15633155,16.7),(68579,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68579,37.81,0.46,364,24797,70,NULL,NULL,'2MASX J10121584+5020293',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000177,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,153.066166667,50.34147,0,NULL,64004706481,1000073538,15626149,17.7),(68580,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68580,38.39,0.46,475,24798,70,NULL,NULL,'2MASX J10121660+0552185',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000195,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,153.069208333,5.87164,0.017,NULL,60786077423,949782459,14840350,17.8),(68581,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68581,36.36,0.46,187,24799,70,NULL,NULL,'2MASX J10121683+1243054',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000191,NULL,'16.0g',0.37,'E',NULL,NULL,NULL,NULL,1,153.07,12.71808,0.109,NULL,60847891066,950748297,14855442,16),(68582,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68582,34.08,0.49,65.4,24800,75,NULL,'IR','UGC 05499',NULL,'2011yCatp016004901K',2011,1,2.27,NULL,'G',0.000017,NULL,'14.1g',0.55,'SBb:',NULL,NULL,NULL,'Emission-Line Galaxy',1,153.0735,27.86208,0.133,NULL,64035894839,1000560856,15633763,14.1),(68583,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68583,34.31,0.4,72.8,24800,NULL,NULL,'mean','UGC 05499',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68584,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68584,34.39,0.2,75.5,24800,74.4,NULL,NULL,'UGC 05499',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68585,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68585,34.39,0.47,75.6,24800,NULL,NULL,'H','UGC 05499',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68586,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68586,34.48,0.46,78.9,24800,NULL,NULL,'J','UGC 05499',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68587,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68587,34.49,0.45,79.2,24800,NULL,NULL,'K','UGC 05499',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68588,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68588,37.04,0.46,255,24801,70,NULL,NULL,'2MASX J10121859+6138037',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,153.077583,61.63428,0.013,NULL,61911366296,967365098,15115079,17.7),(68589,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68589,37.35,0.46,295,24802,70,NULL,NULL,'2MASX J10121862+3755056',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00017,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,153.07775,37.91825,0.037,NULL,64067574045,1001055844,15641497,17.4),(68590,'Tully est','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68590,32.53,0.8,32.1,24803,75,NULL,NULL,'ESO 263- G 015',NULL,'1988NBGC.C....0000T',1988,1,3.92,NULL,'G',0.000004,NULL,'14.38',0.34,'Sc',NULL,NULL,NULL,NULL,1,153.0827917,-47.29475,NULL,NULL,42031741992,656745968,10261655,14.38),(68591,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68591,32.09,0.4,26.2,24803,75,NULL,NULL,'ESO 263- G 015',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68592,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68592,32.09,0.39,26.2,24803,73,NULL,'IR','ESO 263- G 015',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68593,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68593,32.45,0.36,30.9,24803,NULL,NULL,NULL,'ESO 263- G 015',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68594,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68594,32.72,0.49,34.9,24803,75,NULL,'IR','ESO 263- G 015',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68595,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68595,32.76,NULL,35.6,24803,NULL,NULL,'Dipole','ESO 263- G 015',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68596,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68596,32.76,NULL,35.6,24803,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 263- G 015',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68597,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68597,32.76,NULL,35.7,24803,NULL,NULL,'Dipole + Quadrupole','ESO 263- G 015',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68598,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68598,32.82,NULL,36.6,24803,NULL,NULL,NULL,'ESO 263- G 015',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68599,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68599,37.92,0.46,383,24804,70,NULL,NULL,'2MASX J10122041+1937008',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,153.085167,19.61689,0.041,NULL,60812198335,950190598,14846728,17.8),(68600,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68600,37.82,0.46,366,24805,70,NULL,NULL,'2MASX J10122155+3457346',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,153.089667,34.95961,0.037,NULL,64073250956,1001144546,15642883,17.6),(68601,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68601,35.53,0.34,128,24806,NULL,NULL,NULL,'ESO 500- G 010',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.45',0.3,'SB(rs:)b:',NULL,NULL,NULL,NULL,1,153.09025,-25.76864,0.097,NULL,41943543234,655367863,10240122,15.45),(68602,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68602,35.57,0.2,130,24806,74.4,NULL,NULL,'ESO 500- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68603,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68603,35.61,0.32,132,24806,NULL,NULL,'Malmquist cor.','ESO 500- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68604,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68604,37.66,0.46,340,24807,70,NULL,NULL,'2MASX J10122223+3358156',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000187,NULL,'16.6g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,153.092625,33.97092,0.021,NULL,64079392127,1001240501,15644382,16.6),(68605,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68605,37.39,0.33,301,24808,70,NULL,NULL,'2MASX J10122330+0625443',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000168,NULL,'16.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,153.0969583,6.42897,0.009,NULL,60756561977,949321280,14833145,16.6),(68606,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68606,36.8,0.46,229,24809,70,NULL,NULL,'2MASX J10122338+4319039',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000164,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,153.0975,43.31789,0.009,NULL,64099919005,1001561234,15649394,17),(68607,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68607,36.71,0.46,220,24810,70,NULL,NULL,'2MASX J10122441+5320282',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000189,NULL,'16.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,153.101625,53.34125,0,NULL,63994693471,999917085,15623704,16.3),(68608,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68608,37.39,0.33,301,24811,70,NULL,NULL,'SDSS J101224.55+062527.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00017,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,153.102333,6.42417,0.009,NULL,60756533249,949320832,14833138,18.4),(68609,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68609,36.82,0.46,231,24812,70,NULL,NULL,'2MASX J10122990+1035037',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,153.124667,10.58439,0.077,NULL,60870398509,951099976,14860937,17.6),(68610,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68610,38.23,0.33,442,24813,70,NULL,NULL,'SDSS J101229.93+184939.1',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000152,NULL,'17.3g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,153.1247083,18.82753,0.081,NULL,60812605711,950196964,14846827,17.3),(68611,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68611,36.83,0.46,232,24814,70,NULL,NULL,'2MASX J10123283+1228094',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000178,NULL,'16.5g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,153.136833,12.46928,0.077,NULL,60836486935,950570108,14852657,16.5),(68612,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68612,37.56,0.46,325,24815,70,NULL,NULL,'2MASX J10123307+0634528',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000133,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,153.13775,6.58136,0.017,NULL,60756587957,949321686,14833151,17.4),(68613,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68613,38.23,0.33,442,24816,70,NULL,NULL,'SDSS J101235.43+184939.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000164,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,153.147666667,18.82767,0.081,NULL,60812606082,950196970,14846827,18.2),(68614,'IRAS','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68614,32.53,0.8,32,24817,75,NULL,'MAT, I','IC 2556',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000017,NULL,'14.25',1,'(R\')SAB(rs)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,153.1567917,-34.72886,0.385,NULL,42007059530,656360305,10255629,14.25),(68615,'IRAS','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68615,32.55,0.8,32.3,24817,75,NULL,'HMCL, I','IC 2556',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68616,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68616,32.63,NULL,33.6,24817,NULL,NULL,'B','IC 2556',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68617,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68617,32.65,0.4,33.9,24817,75,NULL,'HMCL, I, raw','IC 2556',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68618,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68618,32.71,0.32,34.9,24817,85,NULL,'I, raw','IC 2556',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68619,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68619,32.71,0.4,34.9,24817,75,NULL,'HMCL, I, inv','IC 2556',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68620,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68620,32.73,0.32,35.1,24817,85,NULL,'I, inv','IC 2556',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68621,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68621,32.75,0.2,35.5,24817,74.4,NULL,NULL,'IC 2556',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68622,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68622,32.82,0.43,36.6,24817,75,NULL,'3.6 micron, color corrected','IC 2556',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68623,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68623,32.86,0.43,37.4,24817,75,NULL,'3.6 micron, color + selection bias corrected','IC 2556',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68624,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68624,32.88,NULL,37.7,24817,NULL,NULL,'I','IC 2556',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68625,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68625,32.91,0.4,38.3,24817,75,NULL,'HMCL, I, cor','IC 2556',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68626,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68626,32.92,0.38,38.4,24817,NULL,NULL,NULL,'IC 2556',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68627,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68627,33.01,0.43,39.9,24817,75,NULL,'MAT, I, raw','IC 2556',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68628,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68628,33.09,0.43,41.5,24817,75,NULL,'MAT, I, inv','IC 2556',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68629,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68629,33.26,0.43,44.9,24817,75,NULL,'MAT, I, cor','IC 2556',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68630,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68630,33.26,0.11,45,24817,NULL,NULL,NULL,'IC 2556',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68631,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68631,35.25,0.46,112,24818,70,NULL,NULL,'CGCG 123-023',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000193,NULL,'15.4g',0.44,NULL,NULL,NULL,NULL,NULL,1,153.1580417,22.29183,0.069,NULL,60804240858,950066263,14844785,15.4),(68632,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68632,37.94,0.46,387,24819,70,NULL,NULL,'SDSS J101237.94+033327.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000157,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,153.158125,3.5575,0.013,NULL,60799950004,949999218,14843737,18.6),(68633,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68633,36.94,0.46,245,24820,70,NULL,NULL,'2MASX J10123845+5408334',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,153.160166667,54.14256,0,NULL,61901071945,967204249,15112566,17),(68634,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68634,37.21,0.46,276,24821,70,NULL,NULL,'2MASX J10123899+1635064',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,153.162375,16.58514,0.093,NULL,60857522910,950898795,14857793,17.7),(68635,'SBF','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68635,31.74,0.14,22.3,24822,74.4,NULL,NULL,'NGC 3156',NULL,'2013AJ....146...86T',2013,1,1.91,NULL,'G',0.000017,NULL,'12.9g',0.94,'S0:','in a radial-velocity based grouping',NULL,NULL,NULL,1,153.171875,3.12936,0.041,NULL,60797205745,949956339,14843067,12.9),(68636,'SBF','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68636,31.75,0.14,22.4,24822,NULL,NULL,'I','NGC 3156',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68637,'SBF','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68637,31.75,0.14,22.4,24822,NULL,NULL,NULL,'NGC 3156',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68638,'SBF','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68638,31.77,0.14,22.6,24822,NULL,NULL,'Malmquist cor.','NGC 3156',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68639,'D-Sigma','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68639,31.39,0.4,19,24822,75,NULL,'Edat, raw','NGC 3156',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68640,'D-Sigma','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68640,31.73,0.4,22.2,24822,75,NULL,'Edat, cor','NGC 3156',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68641,'Faber-Jackson','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68641,31.05,1.2,16.2,24822,95,NULL,'Weighted Mean','NGC 3156',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68642,'Faber-Jackson','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68642,31.05,1.2,16.2,24822,95,NULL,'de Vaucouleurs','NGC 3156',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68643,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68643,31.96,0.41,24.7,24822,NULL,NULL,NULL,'NGC 3156',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68644,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68644,32.09,0.41,26.2,24822,NULL,NULL,'Malmquist cor.','NGC 3156',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68645,'Tertiary','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68645,30.39,0.41,12,24822,95,NULL,NULL,'NGC 3156',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68646,'Tully est','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68646,31.34,0.8,18.6,24822,75,NULL,'B','NGC 3156',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68647,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68647,31.55,0.45,20.4,24822,NULL,NULL,'K','NGC 3156',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68648,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68648,31.63,0.4,21.2,24822,NULL,NULL,'mean','NGC 3156',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68649,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68649,36.58,0.46,207,24823,70,NULL,NULL,'2MASX J10124126+0555455',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000172,NULL,'16.1g',0.38,'E0',NULL,NULL,NULL,NULL,1,153.172083,5.92936,0.017,NULL,60786066512,949782289,14840348,16.1),(68650,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68650,36.54,0.49,204,24824,NULL,NULL,'Malmquist cor.','2MASX J10124183-0039407',NULL,'2009ApJS..182..474S',2009,1,0.48,NULL,'G',0.000033,NULL,'18.17',0.15,'Sc',NULL,NULL,NULL,NULL,1,153.17425,-0.66128,0.037,NULL,41209693184,643901456,10060960,18.17),(68651,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68651,36.82,0.44,231,24824,NULL,NULL,NULL,'2MASX J10124183-0039407',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68652,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68652,36.86,0.2,236,24824,74.4,NULL,NULL,'2MASX J10124183-0039407',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68653,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68653,36.06,0.54,163,24825,70,NULL,NULL,'CGCG 008-068',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000133,NULL,'15.76',0.5,NULL,NULL,NULL,NULL,NULL,1,153.1772917,-3.49983,0.033,NULL,41268124252,644814441,10075225,15.76),(68654,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68654,36.81,0.46,230,24826,70,NULL,NULL,'2MASX J10124359+2532295',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000173,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,153.1815417,25.54142,0.125,NULL,64022588865,1000352951,15630514,17.4),(68655,'IRAS','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68655,32.7,0.8,34.6,24827,75,NULL,'MAT, I','ESO 436- G 001',NULL,'1997ApJS..109..333W',1997,1,3.58,'Star superposed near the center.','G',0.000017,NULL,'14.05',0.36,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,153.198083,-27.83944,0.161,NULL,41958372067,655599563,10243743,14.05),(68656,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68656,32.41,0.4,30.3,24827,75,NULL,NULL,'ESO 436- G 001',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68657,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68657,32.83,0.49,36.7,24827,75,NULL,'IR','ESO 436- G 001',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68658,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68658,32.83,0.43,36.9,24827,75,NULL,'3.6 micron, color + selection bias corrected','ESO 436- G 001',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68659,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68659,32.94,0.43,38.7,24827,75,NULL,'3.6 micron, color corrected','ESO 436- G 001',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68660,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68660,32.95,0.32,38.9,24827,85,NULL,'I, raw','ESO 436- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68661,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68661,32.96,0.4,39.1,24827,NULL,NULL,NULL,'ESO 436- G 001',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68662,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68662,32.99,0.32,39.6,24827,85,NULL,'I, inv','ESO 436- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68663,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68663,33.09,0.2,41.5,24827,74.4,NULL,NULL,'ESO 436- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68664,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68664,33.09,0.09,41.6,24827,NULL,NULL,NULL,'ESO 436- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68665,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68665,33.1,0.43,41.7,24827,75,NULL,'MAT, I, raw','ESO 436- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68666,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68666,33.3,0.43,45.6,24827,75,NULL,'MAT, I, inv','ESO 436- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68667,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68667,33.32,NULL,46.2,24827,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 436- G 001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68668,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68668,33.34,NULL,46.6,24827,NULL,NULL,'Dipole + Quadrupole','ESO 436- G 001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68669,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68669,33.34,NULL,46.7,24827,NULL,NULL,'Dipole','ESO 436- G 001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68670,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68670,33.38,0.43,47.5,24827,75,NULL,'MAT, I, cor','ESO 436- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68671,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68671,33.4,NULL,47.8,24827,NULL,NULL,NULL,'ESO 436- G 001',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68672,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68672,27.83,0.06,3.7,24828,NULL,NULL,NULL,'UGC 05497',NULL,'2013AJ....146..126C',2013,1,1.1,'MCG misprints R.A. as 10h09.9m; corrected in MCG errata.','G',NULL,NULL,'15.7',1.1,'BCD',NULL,NULL,NULL,NULL,1,153.200083333,64.10789,0.033,NULL,62112741284,970511582,15164243,15.7),(68673,'TRGB','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68673,27.86,0.1,3.73,24828,74.4,NULL,NULL,'UGC 05497',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68674,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68674,37.12,0.46,265,24829,70,NULL,NULL,'2MASX J10124856+1106598',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00018,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,153.2025,11.11667,0.085,NULL,60869158244,951080597,14860634,16.6),(68675,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68675,37.03,0.46,255,24830,70,NULL,NULL,'2MASX J10124884+3055338',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,153.203583,30.92592,0.085,NULL,64033278354,1000519974,15633124,17.3),(68676,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68676,32.38,NULL,30,24831,NULL,NULL,NULL,'UGC 05504',NULL,'2000BSAO...50....5K',2000,1,1.28,NULL,'G',0.000013,NULL,'16.1g',0.23,'Sdm',NULL,NULL,NULL,NULL,1,153.204958333,7.10381,0.017,NULL,60756048642,949313260,14833019,16.1),(68677,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68677,32.41,NULL,30.3,24831,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05504',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68678,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68678,32.42,NULL,30.4,24831,NULL,NULL,'Dipole','UGC 05504',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68679,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68679,32.42,NULL,30.4,24831,NULL,NULL,'Dipole + Quadrupole','UGC 05504',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68680,'FP','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,'R',68680,38.25,0.46,447,24832,70,NULL,NULL,'2MASX J10124992+0803108',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000132,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,153.2079583,8.05294,0.025,NULL,60757243492,949331929,14833311,18.1),(68681,'IRAS','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68681,33.16,0.8,42.8,24833,75,NULL,'A82, H','NGC 3153',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000017,NULL,'13.35',0.9,'Scd:','Possible field galaxy',NULL,NULL,NULL,1,153.210417,12.66667,0.077,NULL,60836470461,950569850,14852653,13.35),(68682,'IRAS','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68682,33.18,0.8,43.2,24833,75,NULL,'CF, r','NGC 3153',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68683,'Sosies','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68683,33.41,0.26,48.1,24833,NULL,NULL,NULL,'NGC 3153',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68684,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68684,31.88,0.4,23.8,24833,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 3153',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68685,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68685,32.17,0.69,27.2,24833,100,NULL,'mid-IR','NGC 3153',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68686,'Tully-Fisher','2016-12-15 15:14:35','2016-12-16 11:19:43','1',NULL,NULL,68686,32.41,0.47,30.4,24833,75,NULL,'A82, H, inv','NGC 3153',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68687,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68687,32.45,0.47,30.8,24833,75,NULL,'A82, H, raw','NGC 3153',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68688,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68688,32.57,0.36,32.7,24833,NULL,NULL,NULL,'NGC 3153',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68689,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68689,32.66,0.61,34,24833,NULL,NULL,'Malmquist cor.','NGC 3153',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68690,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68690,32.67,0.47,34.1,24833,75,NULL,'A82, H, cor','NGC 3153',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68691,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68691,32.74,0.58,35.4,24833,NULL,NULL,NULL,'NGC 3153',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68692,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68692,32.75,0.38,35.5,24833,75,NULL,'CF, r, raw','NGC 3153',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68693,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68693,32.78,0.2,36,24833,74.4,NULL,NULL,'NGC 3153',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68694,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68694,32.8,0.38,36.3,24833,75,NULL,'CF, r, inv','NGC 3153',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68695,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68695,32.91,0.38,38.1,24833,75,NULL,'CF, r, cor','NGC 3153',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68696,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68696,33.02,0.4,40.2,24833,75,NULL,'B','NGC 3153',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68697,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68697,33.37,0.4,47.3,24833,NULL,NULL,'mean','NGC 3153',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68698,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68698,33.6,0.47,52.4,24833,NULL,NULL,'H','NGC 3153',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68699,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68699,33.61,0.46,52.6,24833,NULL,NULL,'J','NGC 3153',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68700,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68700,33.7,0.45,55.1,24833,NULL,NULL,'K','NGC 3153',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68701,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68701,38.61,0.46,526,24834,70,NULL,NULL,'SDSS J101250.90+372952.2',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,153.212083,37.49786,0.041,NULL,64067842118,1001060033,15641563,17.5),(68702,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68702,36.34,0.46,186,24835,70,NULL,NULL,'SDSS J101251.84+503650.0',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,153.2160417,50.61389,0,NULL,64004836375,1000075568,15626180,17.2),(68703,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68703,36.95,0.46,246,24836,70,NULL,NULL,'2MASX J10125222+6026367',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000171,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,153.21775,60.44367,0,NULL,61921625455,967525397,15117584,16.3),(68704,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68704,37.67,0.27,342,24837,70,NULL,NULL,'2MASX J10125497+1534350',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,153.229125,15.57639,0.113,NULL,60839786153,950621658,14853463,NULL),(68705,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68705,37.19,0.46,274,24838,70,NULL,NULL,'2MASX J10125541+4704129',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,153.2310417,47.07025,0,NULL,63997096873,999954638,15624291,17.1),(68706,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68706,36.57,0.46,206,24839,70,NULL,NULL,'2MASX J10125606+0912048',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000179,NULL,'15.7g',0.4,'E0',NULL,NULL,NULL,NULL,1,153.233583333,9.20119,0.037,NULL,60869849732,951091402,14860803,15.7),(68707,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68707,38.2,0.46,437,24840,70,NULL,NULL,'SDSS J101256.11+165623.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,153.233833,16.93997,0.081,NULL,60858583332,950915364,14858052,18.3),(68708,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68708,37.67,0.27,342,24841,70,NULL,NULL,'SDSS J101256.30+153615.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,153.234625,15.60428,0.113,NULL,60839782188,950621596,14853462,17.9),(68709,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68709,37.16,0.46,270,24842,70,NULL,NULL,'2MASX J10125831+5104478',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,153.243,51.08008,0,NULL,64004979232,1000077800,15626215,17),(68710,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68710,37.67,0.27,342,24843,70,NULL,NULL,'2MASX J10125850+1538440',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,153.2437083,15.64556,0.113,NULL,60840251926,950628936,14853577,16.7),(68711,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68711,35.82,0.25,146,24844,74.4,NULL,NULL,'2MASX J10125924-0053335',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.0001,NULL,'16.82',0.3,'SB0','Group member',NULL,NULL,NULL,1,153.24675,-0.89247,0.037,NULL,41212847878,643950748,10061730,16.82),(68712,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68712,35.95,0.66,155,24844,70,NULL,NULL,'2MASX J10125924-0053335',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68713,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68713,35.05,0.49,102,24845,70,NULL,NULL,'2MASX J10130010-1722510',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000103,NULL,'13.6I',0.2,NULL,NULL,NULL,NULL,NULL,1,153.2504583,-17.38089,0.181,NULL,41197253865,643707091,10057923,13.6),(68714,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68714,36.35,0.78,186,24846,70,NULL,NULL,'2MASX J10130071-1813023',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.4I',0.3,'(R\'_1)SB(s)a',NULL,NULL,NULL,NULL,1,153.253,-18.21736,0.221,NULL,41142254013,642847718,10044495,14.4),(68715,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68715,36.51,0.57,201,24847,70,NULL,NULL,'CGCG 008-071',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'16.45',0.8,NULL,'Group member',NULL,NULL,NULL,1,153.253333,-2.66131,0.041,NULL,41266548166,644789815,10074840,16.45),(68716,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68716,38.26,0.46,448,24848,70,NULL,NULL,'2MASX J10130173+4626529',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,153.2572083,46.44819,0,NULL,64126891617,1001982681,15655979,17.6),(68717,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68717,38.18,0.27,433,24849,70,NULL,NULL,'2MASX J10130295+0636299',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000185,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,153.2622083,6.60819,0.017,NULL,60756500668,949320322,14833130,16.6),(68718,'Carbon Stars','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68718,19.93,0.57,0.097,24850,NULL,NULL,'Carbon star S25, RA 153.8581, DEC -02.0757','Sextans Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,1,30,NULL,'G',0.000002,NULL,'10.4V',12,'dSph',NULL,NULL,NULL,NULL,1,153.262333,-1.61461,0.073,1,41210674064,643916782,10061199,10.4),(68719,'CMD','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68719,19.67,NULL,0.086,24850,NULL,NULL,NULL,'Sextans Dwarf Spheroidal',NULL,'2009ApJ...703..692L',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68720,'Horizontal Branch','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68720,19.56,0.12,0.0817,24850,NULL,NULL,'Probability > 0.5','Sextans Dwarf Spheroidal',NULL,'2011ApJ...731..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68721,'Horizontal Branch','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68721,19.57,0.11,0.082,24850,NULL,NULL,'Red HB','Sextans Dwarf Spheroidal',NULL,'2011ApJ...731..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68722,'Horizontal Branch','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68722,19.59,0.23,0.083,24850,NULL,NULL,NULL,'Sextans Dwarf Spheroidal',NULL,'1995MNRAS.277.1354I',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68723,'Horizontal Branch','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68723,19.6,0.29,0.085,24850,NULL,NULL,'Photographic','Sextans Dwarf Spheroidal',NULL,'1990MNRAS.244P..16I',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68724,'Horizontal Branch','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68724,19.7,0.3,0.087,24850,NULL,NULL,NULL,'Sextans Dwarf Spheroidal',NULL,'1991AJ....101..892M',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68725,'Miras','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68725,19.38,0.34,0.0753,24850,NULL,NULL,'Ks, Mira #1','Sextans Dwarf Spheroidal',NULL,'2012ApJ...761L..10S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68726,'Miras','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68726,19.51,0.29,0.0798,24850,NULL,NULL,'Ks, Mira #2','Sextans Dwarf Spheroidal',NULL,'2012ApJ...761L..10S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68727,'Miras','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68727,19.69,0.51,0.0866,24850,NULL,NULL,'Ic, Mira #2','Sextans Dwarf Spheroidal',NULL,'2012ApJ...761L..10S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68728,'RR Lyrae','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68728,19.62,NULL,0.084,24850,NULL,NULL,'2, V','Sextans Dwarf Spheroidal',NULL,'2015AJ....150..160B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68729,'RR Lyrae','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68729,19.67,0.15,0.086,24850,NULL,NULL,'36RR+6AC','Sextans Dwarf Spheroidal',NULL,'1995AJ....110.2166M',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68730,'RR Lyrae','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68730,19.69,NULL,0.0867,24850,NULL,NULL,NULL,'Sextans Dwarf Spheroidal',NULL,'2008ApJ...679...52T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68731,'RR Lyrae','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68731,19.74,0.21,0.0887,24850,NULL,NULL,'V','Sextans Dwarf Spheroidal',NULL,'2013MNRAS.435.3206D',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68732,'TRGB','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68732,19.65,0.14,0.0851,24850,NULL,NULL,NULL,'Sextans Dwarf Spheroidal',NULL,'2011A&A...531A.152L',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68733,'TRGB','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68733,19.8,NULL,0.09,24850,NULL,NULL,NULL,'Sextans Dwarf Spheroidal',NULL,'2000glg..book.....V',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68734,'TRGB','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68734,19.9,0.06,0.096,24850,NULL,NULL,NULL,'Sextans Dwarf Spheroidal',NULL,'2003AJ....126.2840L',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68735,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68735,37.25,0.46,282,24851,70,NULL,NULL,'2MASX J10130383+5816435',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000183,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,153.265875,58.27861,0,NULL,61918703249,967479738,15116870,16.4),(68736,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68736,36.36,0.33,187,24852,70,NULL,NULL,'2MASX J10130384+0802549',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000151,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,153.266166667,8.04869,0.025,NULL,60757244298,949331942,14833311,16.7),(68737,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68737,37.87,0.46,376,24853,70,NULL,NULL,'SDSS J101307.92+101849.3',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,153.283041667,10.31372,0.085,NULL,60870565097,951102579,14860977,17.8),(68738,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68738,38.18,0.27,433,24854,70,NULL,NULL,'SDSS J101309.40+063932.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000126,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,153.2892083,6.65914,0.017,NULL,60756511000,949320484,14833132,18.6),(68739,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68739,34.75,0.73,88.9,24855,NULL,NULL,NULL,'2MASX J10130976+2016020',NULL,'2009ApJS..182..474S',2009,1,0.61,NULL,'G',0.000108,NULL,'16.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,153.290917,20.26722,0.077,NULL,60810475567,950163680,14846307,16.2),(68740,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68740,34.79,0.2,90.8,24855,74.4,NULL,NULL,'2MASX J10130976+2016020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68741,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68741,34.99,0.65,99.5,24855,NULL,NULL,'Malmquist cor.','2MASX J10130976+2016020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68742,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68742,38,0.33,398,24856,70,NULL,NULL,'2MASX J10131012+1910510',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000184,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,153.292333,19.18081,0.065,NULL,60813160851,950205638,14846963,17.4),(68743,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68743,37.41,0.46,303,24857,70,NULL,NULL,'2MASX J10131468+3709013',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000164,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,153.3112917,37.15031,0.009,NULL,64067933121,1001061455,15641585,16.8),(68744,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68744,37.72,0.46,350,24858,70,NULL,NULL,'2MASX J10131497+1558491',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,153.312333,15.98022,0.093,NULL,60840144966,950627265,14853551,17.5),(68745,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68745,38.6,0.46,524,24859,70,NULL,NULL,'2MASX J10131536-0041179',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000084,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,153.313917,-0.68839,0.037,NULL,41212571591,643946431,10061662,18.1),(68746,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68746,35.9,0.46,151,24860,70,NULL,NULL,'2MASX J10131559+1015379',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000154,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,153.3149583,10.26064,0.069,NULL,60870559515,951102492,14860976,16.5),(68747,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68747,37.55,0.46,324,24861,70,NULL,NULL,'2MASX J10131574+2554052',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000194,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,153.3155,25.90158,0.117,NULL,64022541375,1000352208,15630503,16.5),(68748,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68748,37.49,0.46,315,24862,70,NULL,NULL,'2MASX J10131654+1825580',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,153.319083,18.43272,0.081,NULL,60809579925,950149686,14846088,17.7),(68749,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68749,36.77,0.46,226,24863,70,NULL,NULL,'2MASX J10131684+0330015',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,153.320041667,3.50044,0.009,NULL,60797155350,949955552,14843055,17.3),(68750,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68750,35.18,0.6,108,24864,70,NULL,NULL,'MCG -01-26-033',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000127,NULL,'15.42',0.2,NULL,NULL,NULL,NULL,NULL,1,153.320583333,-6.02911,0.077,NULL,41256371109,644630798,10072356,15.42),(68751,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68751,37.71,0.46,349,24865,70,NULL,NULL,'SDSS J101317.34+124623.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000169,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,153.3222917,12.77333,0.109,NULL,60837139487,950580304,14852817,18.4),(68752,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68752,38.38,0.46,473,24866,70,NULL,NULL,'2MASX J10131777+3750333',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.9g',0.17,'AGN',NULL,NULL,NULL,NULL,1,153.324125,37.84247,0,NULL,64067703700,1001057870,15641529,17.9),(68753,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68753,37.76,0.46,356,24867,70,NULL,NULL,'2MASX J10131779+3507564',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00018,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,153.3242083,35.13225,0.021,NULL,64073280284,1001145004,15642890,16.7),(68754,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68754,35.7,0.56,138,24868,70,NULL,NULL,'LCRS B101045.6-021939',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'16.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,153.325333,-2.57539,0.041,NULL,41266681420,644791897,10074873,16.1),(68755,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68755,37.85,0.15,372,24869,70,NULL,NULL,'2MASX J10131830+0000290',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000075,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,153.326208333,0.00803,0.013,NULL,60743487030,949116984,14829952,18.4),(68756,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68756,37.4,0.46,303,24870,70,NULL,NULL,'2MASX J10131833+2915372',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000174,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,153.326583,29.26036,0.081,NULL,64038166625,1000596353,15634318,17.7),(68757,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68757,37,0.33,252,24871,70,NULL,NULL,'2MASX J10131920+2525522',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000153,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,153.33,25.43136,0.109,NULL,64022463117,1000350986,15630484,18.1),(68758,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68758,36.43,0.46,193,24872,70,NULL,NULL,'2MASX J10131932+5603474',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,153.330417,56.06325,0,NULL,61896572262,967133941,15111467,16.9),(68759,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68759,37,0.33,252,24873,70,NULL,NULL,'2MASX J10131965+2524042',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00013,NULL,'15.6g',0.46,NULL,NULL,NULL,NULL,NULL,1,153.3320417,25.40108,0.109,NULL,64022464773,1000351012,15630484,15.6),(68760,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68760,37.71,0.46,348,24874,70,NULL,NULL,'2MASX J10131976-0018229',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000065,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,153.33225,-0.30647,0.033,NULL,41212467026,643944797,10061637,17.6),(68761,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68761,37.79,0.46,361,24875,70,NULL,NULL,'2MASX J10132047+2036340',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,153.335375,20.60942,0.073,NULL,60814433713,950225526,14847273,17.9),(68762,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68762,37.19,0.46,274,24876,70,NULL,NULL,'2MASX J10132102+3604083',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000142,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,153.337458333,36.06911,0,NULL,64066905657,1001045400,15641334,17),(68763,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68763,37.16,0.58,271,24877,70,NULL,NULL,'2MASX J10132133-1652247',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,153.3389583,-16.8735,0.169,NULL,41196774467,643699601,10057806,15.4),(68764,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68764,36.36,0.51,187,24878,NULL,NULL,'Malmquist cor.','SDSS J101321.66-004653.4',NULL,'2009ApJS..182..474S',2009,1,0.35,NULL,'G',0.000027,NULL,'17.9g',0.1,'Scd',NULL,NULL,NULL,NULL,1,153.3402917,-0.78142,0.037,NULL,41213023146,643953486,10061773,17.9),(68765,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68765,36.44,0.49,194,24878,NULL,NULL,NULL,'SDSS J101321.66-004653.4',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68766,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68766,36.48,0.2,198,24878,74.4,NULL,NULL,'SDSS J101321.66-004653.4',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68767,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68767,35.82,0.49,146,24879,70,NULL,NULL,'MCG -01-26-035',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.00015,NULL,'15.5',0.2,NULL,NULL,NULL,NULL,NULL,1,153.340417,-8.12106,0.137,NULL,41248231447,644503616,10070369,15.5),(68768,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68768,38,0.33,398,24880,70,NULL,NULL,'2MASX J10132238+1902060',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000171,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,153.343375,19.03489,0.049,NULL,60813170488,950205788,14846965,17.9),(68769,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68769,37.05,0.46,257,24881,70,NULL,NULL,'2MASX J10132425+4745578',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000167,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,153.35125,47.76614,0,NULL,63997051829,999953934,15624280,16.7),(68770,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68770,36.8,0.46,229,24882,70,NULL,NULL,'SDSS J101324.41+050131.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00017,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,153.35175,5.02547,0.021,NULL,60798526539,949976977,14843390,17.7),(68771,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68771,36.58,0.25,207,24883,74.4,NULL,NULL,'2MASX J10132449-0050339',NULL,'2013AJ....146...86T',2013,1,0.39,NULL,'G',0.00008,NULL,'16.3g',0.38,'SB0','Group member',NULL,NULL,NULL,1,153.352,-0.84275,0.037,NULL,41213023701,643953495,10061773,16.3),(68772,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68772,36.66,0.14,215,24883,70,NULL,NULL,'2MASX J10132449-0050339',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68773,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68773,36.66,0.14,215,24884,70,NULL,NULL,'2MASX J10132569-0054349',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000084,NULL,'16.8g',0.21,'S0','Group member',NULL,NULL,NULL,1,153.357,-0.90983,0.037,NULL,41213027822,643953559,10061774,16.8),(68774,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68774,37.85,0.15,372,24885,70,NULL,NULL,'2MASX J10132570+0001530',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000074,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,153.3570417,0.03147,0.013,NULL,60743484927,949116951,14829952,18.3),(68775,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68775,37.1,0.46,263,24886,70,NULL,NULL,'SDSS J101325.92+064514.2',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000123,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,153.358,6.75394,0.017,NULL,60756517122,949320580,14833134,17.3),(68776,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68776,38.18,0.27,433,24887,70,NULL,NULL,'2MASX J10132761+0635531',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000145,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,153.3650417,6.59811,0.009,NULL,60756498068,949320282,14833129,17.7),(68777,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68777,37.57,0.46,326,24888,70,NULL,NULL,'SDSS J101329.44+434708.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000141,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,153.3727083,43.78572,0,NULL,64099770153,1001558908,15649357,18.4),(68778,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68778,37.14,0.46,268,24889,70,NULL,NULL,'2MASX J10132949+1626290',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,153.373,16.44136,0.093,NULL,60842110621,950657978,14854030,16.7),(68779,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68779,36.36,0.33,187,24890,70,NULL,NULL,'CGCG 036-062',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000219,NULL,'15.3g',0.53,'E0',NULL,NULL,NULL,NULL,1,153.373583,7.90433,0.025,NULL,60757132114,949330189,14833284,15.3),(68780,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68780,31.26,NULL,17.9,24891,NULL,NULL,NULL,'NGC 3165',NULL,'2015AstBu..70....1K',2015,1,1.51,NULL,'G',0.000017,NULL,'14.5g',0.61,'SA(s)dm:','in a radial-velocity based grouping',NULL,NULL,NULL,1,153.380417,3.37503,0.009,NULL,60797161121,949955642,14843056,14.5),(68781,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68781,37.28,0.46,286,24892,70,NULL,NULL,'2MASX J10133153+1044221',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000179,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,153.3815,10.73939,0.061,NULL,60871119407,951111240,14861113,17.5),(68782,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68782,31.73,0.4,22.2,24893,75,NULL,'B','NGC 3162',NULL,'1988NBGC.C....0000T',1988,1,3,NULL,'G',0.000007,NULL,'12.21',2.5,'SAB(rs)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,153.381625,22.73756,0.065,NULL,60801383908,950021623,14844087,12.21),(68783,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68783,31.94,0.4,24.4,24893,NULL,NULL,'mean','NGC 3162',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68784,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68784,32.28,0.47,28.6,24893,NULL,NULL,'H','NGC 3162',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68785,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68785,32.31,0.45,29,24893,NULL,NULL,'K','NGC 3162',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68786,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68786,32.32,0.46,29.1,24893,NULL,NULL,'J','NGC 3162',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68787,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68787,37.72,0.46,350,24894,70,NULL,NULL,'SDSS J101332.26+620708.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,153.384458333,62.11914,0,NULL,61908528675,967320760,15114386,18.4),(68788,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68788,35.3,0.49,115,24895,75,NULL,'IR','UGC 05509',NULL,'2011yCatp016004901K',2011,1,2.03,NULL,'G',0.000033,NULL,'14.9g',0.27,'Sc',NULL,NULL,NULL,NULL,1,153.385166667,20.17539,0.053,NULL,60810469585,950163587,14846306,14.9),(68789,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68789,35.44,NULL,122,24895,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05509',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68790,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68790,35.45,NULL,123,24895,NULL,NULL,'Dipole + Quadrupole','UGC 05509',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68791,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68791,35.46,NULL,124,24895,NULL,NULL,'Dipole','UGC 05509',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68792,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68792,35.51,0.4,126,24895,NULL,NULL,'mean','UGC 05509',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68793,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68793,35.52,NULL,127,24895,NULL,NULL,NULL,'UGC 05509',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68794,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68794,35.72,0.47,139,24895,NULL,NULL,'H','UGC 05509',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68795,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68795,35.84,0.45,147,24895,NULL,NULL,'K','UGC 05509',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68796,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68796,35.65,0.54,135,24896,70,NULL,NULL,'2MASX J10133428-3901075',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,153.392917,-39.01883,0.477,NULL,42089418627,657647166,10275736,14.6),(68797,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68797,36.62,0.5,211,24897,70,NULL,NULL,'2MASX J10133435-1649166',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000083,NULL,'16.64',0.5,NULL,NULL,NULL,NULL,NULL,1,153.393041667,-16.82158,0.169,NULL,41196771086,643699548,10057805,16.64),(68798,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68798,37.95,0.33,390,24898,70,NULL,NULL,'2MASX J10133529+1944472',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,153.39725,19.7465,0.057,NULL,60810455732,950163370,14846302,17.9),(68799,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68799,36.18,0.85,172,24899,70,NULL,NULL,'2MASX J10133567-0719453',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.40',0.45,NULL,NULL,NULL,NULL,NULL,1,153.3987917,-7.32933,0.109,NULL,41249467095,644522923,10070670,16.4),(68800,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68800,36.73,0.46,222,24900,70,NULL,NULL,'2MASX J10133602-0037249',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000071,NULL,'17.4g',0.18,'S0','Group member',NULL,NULL,NULL,1,153.4002083,-0.62367,0.037,NULL,41212534048,643945844,10061653,17.4),(68801,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68801,37.36,0.46,297,24901,70,NULL,NULL,'2MASX J10133685+4107256',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000162,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,153.403583,41.12375,0,NULL,64094616561,1001478383,15648099,18),(68802,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68802,36.02,0.46,160,24902,70,NULL,NULL,'2MASX J10133701+4029376',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000169,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,153.40425,40.49369,0.029,NULL,64094706491,1001479788,15648121,16.4),(68803,'BCG','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68803,36.51,0.35,192,24903,60,NULL,'ABELL 0957, BCG','UGC 05515',0.0437,'1980ApJ...241..486H',1980,1,1.5,NULL,'G',0.000097,NULL,'14.31',1.3,'E+ pec:;BrClG','Group member',NULL,NULL,NULL,1,153.409458333,-0.92542,0.037,NULL,41213021182,643953455,10061772,14.31),(68804,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68804,36.57,0.25,206,24903,74.4,NULL,NULL,'UGC 05515',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68805,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68805,36.24,0.16,177,24903,70,NULL,'ABELL 0957, BGC','UGC 05515',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68806,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68806,38.13,0.46,422,24904,70,NULL,NULL,'2MASX J10133891+0534475',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00017,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,153.412166667,5.57989,0.013,NULL,60797585650,949962275,14843160,17.6),(68807,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68807,36.7,0.46,219,24905,70,NULL,NULL,'2MASX J10133942+5058517',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,153.414375,50.981,0,NULL,64005038301,1000078723,15626230,17.7),(68808,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68808,37.95,0.33,390,24906,70,NULL,NULL,'SDSS J101339.45+194457.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,153.414417,19.74925,0.057,NULL,60810455522,950163367,14846302,18),(68809,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68809,35.21,0.17,110,24907,70,NULL,NULL,'2MASX J10133955+3844436',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00008,NULL,'15.8g',0.31,'S0',NULL,NULL,NULL,NULL,1,153.414666667,38.74539,0.037,NULL,64095546972,1001492921,15648326,15.8),(68810,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68810,35.68,0.25,137,24908,74.4,NULL,NULL,'2MASX J10134009-0051489',NULL,'2013AJ....146...86T',2013,1,0.38,NULL,'G',0.000057,NULL,'17.0g',0.15,'S0','Group member',NULL,NULL,NULL,1,153.417083,-0.86369,0.037,NULL,41213019294,643953426,10061772,17),(68811,'BCG','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68811,36.51,0.35,192,24909,60,NULL,NULL,'ABELL 0957',0.0437,'1980ApJ...241..486H',1980,1,NULL,'Katgert (1996,A&A,310,8) identifies multiple redshift systems in this cluster.','GClstr',NULL,NULL,NULL,NULL,'I-II:  [BM]',NULL,NULL,NULL,NULL,1,153.417917,-0.91444,0.037,NULL,41213021255,643953457,10061772,NULL),(68812,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68812,36.24,0.16,177,24909,70,NULL,NULL,'ABELL 0957',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68813,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68813,35.9,0.61,151,24910,70,NULL,NULL,'2MASX J10134035-3506314',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,153.418125,-35.10881,0.441,NULL,41995706493,656182913,10252858,15.1),(68814,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68814,37.56,0.46,325,24911,70,NULL,NULL,'2MASX J10134038+1900442',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00017,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,153.4184583,19.01242,0.049,NULL,60812993042,950203016,14846922,17.4),(68815,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68815,37.42,0.46,304,24912,70,NULL,NULL,'2MASX J10134070-0016019',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000075,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,153.419458333,-0.26714,0.033,NULL,41212482725,643945042,10061641,18.1),(68816,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68816,36.66,0.14,215,24913,70,NULL,NULL,'2MASX J10134149-0055199',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00007,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,153.4229583,-0.92231,0.037,NULL,41213021573,643953462,10061772,17.7),(68817,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68817,37.85,0.15,372,24914,70,NULL,NULL,'SDSS J101342.23-000725.6',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000075,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,153.426,-0.12378,0.013,NULL,41211401876,643928154,10061377,18.7),(68818,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68818,36.21,0.25,175,24915,74.4,NULL,NULL,'2MASX J10134223-0054259',NULL,'2013AJ....146...86T',2013,1,0.35,NULL,'G',0.00006,NULL,'17.1g',0.14,'S0','Group member',NULL,NULL,NULL,1,153.426083,-0.90719,0.037,NULL,41213022056,643953469,10061772,17.1),(68819,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68819,32.68,NULL,34.4,24916,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05514',NULL,'2010Ap&SS.325..163P',2010,1,1.65,NULL,'G',0.000007,NULL,'15.65',0.2,'Sc','Pair member (points to parent)',NULL,NULL,NULL,1,153.428208333,18.12533,0.077,NULL,60809642433,950150663,14846104,15.65),(68820,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68820,32.7,NULL,34.7,24916,NULL,NULL,'Dipole + Quadrupole','UGC 05514',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68821,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68821,32.71,NULL,34.8,24916,NULL,NULL,'Dipole','UGC 05514',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68822,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68822,33.13,NULL,42.3,24916,NULL,NULL,NULL,'UGC 05514',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68823,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68823,34.09,0.49,65.6,24916,75,NULL,'IR','UGC 05514',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68824,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68824,34.25,0.53,70.9,24917,70,NULL,NULL,'ESO 374-IG 045 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.00015,NULL,'15.5',0.25,'(R)SAB0:',NULL,NULL,NULL,NULL,1,153.42875,-34.86256,0.365,NULL,41995503226,656179737,10252808,15.5),(68825,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68825,33.07,0.4,41,24918,NULL,NULL,'mean','ESO 213- G 009',NULL,'2007A&A...465...71T',2007,1,0.78,NULL,'G',0.00002,NULL,'16.80',0.67,'SBb',NULL,NULL,NULL,NULL,1,153.44025,-52.28706,NULL,NULL,42041468746,656897949,10264030,16.8),(68826,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68826,33.6,0.47,52.5,24918,NULL,NULL,'H','ESO 213- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68827,'Tully est','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68827,31.71,0.8,22,24919,75,NULL,'B','NGC 3166',NULL,'1988NBGC.C....0000T',1988,1,4.8,'Multiple SDSS entries describe this object.','G',0.000017,NULL,'11.3B',2.3,'SAB(rs)0/a;HII LINER','Pair member (points to parent)',NULL,NULL,NULL,1,153.44075,3.42497,0.009,NULL,60797240234,949956878,14843076,11.3),(68828,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68828,37.85,0.15,372,24920,70,NULL,NULL,'2MASX J10134612-0008014',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000077,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,153.442125,-0.13358,0.013,NULL,41211455997,643928999,10061390,18.3),(68829,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68829,38.31,0.46,459,24921,70,NULL,NULL,'SDSS J101346.21+300604.8',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000188,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,153.442583,30.10136,0.109,NULL,64033099981,1000517187,15633081,18.8),(68830,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68830,37.76,0.7,357,24922,70,NULL,NULL,'2MASX J10134632-0212284',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,153.442958333,-2.20786,0.045,NULL,41266109981,644782968,10074733,14.2),(68831,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68831,35.04,0.25,102,24923,74.4,NULL,NULL,'2MASX J10134639-0057054',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000067,NULL,'17.36',0.3,'Sb(f)','Group member',NULL,NULL,NULL,1,153.443416667,-0.95147,0.037,NULL,41212989721,643952964,10061765,17.36),(68832,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68832,36.89,0.46,239,24924,70,NULL,NULL,'SDSS J101346.63+420252.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000134,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,153.444333,42.04786,0.013,NULL,64101657830,1001588403,15649818,17.9),(68833,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68833,36.8,0.46,229,24925,70,NULL,NULL,'2MASX J10134675+4201177',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000176,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,153.444917,42.02161,0.009,NULL,64101658416,1001588412,15649818,16.3),(68834,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68834,36.36,0.42,187,24926,NULL,NULL,'Malmquist cor.','CGCG 008-077',NULL,'2009ApJS..182..474S',2009,1,0.73,'The APMUKS data include an attached companion to the northwest.','G',0.000027,NULL,'15.7g',0.26,'Sb(f)          HII','Group member',NULL,NULL,'Sy 2',1,153.445083,-0.91422,0.037,NULL,41213018481,643953413,10061772,15.7),(68835,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68835,36.5,0.39,200,24926,NULL,NULL,NULL,'CGCG 008-077',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68836,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68836,36.55,0.2,204,24926,74.4,NULL,NULL,'CGCG 008-077',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68837,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68837,35.86,0.63,149,24927,70,NULL,NULL,'2MASX J10134913-2011470',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,153.45475,-20.19656,0.209,NULL,41144934302,642889598,10045149,15),(68838,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68838,36.22,0.46,175,24928,70,NULL,NULL,'2MASX J10134985+3938306',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00014,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,153.4577917,39.64189,0.053,NULL,64097261501,1001519710,15648745,17.1),(68839,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68839,35.21,0.17,110,24929,70,NULL,NULL,'2MASX J10135050+3822316',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000073,NULL,'15.2g',0.48,'S0',NULL,NULL,NULL,NULL,1,153.460333333,38.37536,0.021,NULL,64065385876,1001021654,15640963,15.2),(68840,'D-Sigma','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68840,34.17,0.4,68.2,24930,75,NULL,'Edat, raw','NGC 3158',NULL,'1997ApJS..109..333W',1997,1,1.64,NULL,'G',0.000073,NULL,'13.1g',1.1,'E3:','Possible field galaxy',NULL,NULL,NULL,1,153.4605,38.76489,0.037,NULL,64096606564,1001509477,15648585,13.1),(68841,'D-Sigma','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68841,34.51,0.4,79.6,24930,75,NULL,'Edat, cor','NGC 3158',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68842,'Faber-Jackson','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68842,33.83,0.24,58.3,24930,95,NULL,'Weighted Mean','NGC 3158',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68843,'Faber-Jackson','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68843,34.03,0.46,64,24930,95,NULL,'Michard 1979a','NGC 3158',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68844,'Faber-Jackson','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68844,34.05,0.32,64.6,24930,95,NULL,'de Vaucouleurs','NGC 3158',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68845,'Faber-Jackson','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68845,34.59,0.63,82.8,24930,95,NULL,'Michard 1979b, c','NGC 3158',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68846,'Faber-Jackson','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68846,35.36,0.81,118,24930,55,NULL,'Visvanathan & Sandage 1979','NGC 3158',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68847,'Tertiary','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68847,34.12,0.5,66.7,24930,95,NULL,NULL,'NGC 3158',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68848,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68848,34.9,0.45,95.4,24930,NULL,NULL,'K','NGC 3158',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68849,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68849,35.07,0.4,103,24930,NULL,NULL,'mean','NGC 3158',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68850,'Faber-Jackson','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68850,34.48,0.44,78.7,24931,95,NULL,'Weighted Mean','NGC 3159',NULL,'1984ApJS...56...91D',1984,1,0.92,NULL,'G',0.000073,NULL,'14.3g',0.7,'E2 pec:','in a pair',NULL,NULL,NULL,1,153.470125,38.65447,0,NULL,64095522977,1001492546,15648321,14.3),(68851,'Faber-Jackson','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68851,35.01,0.46,100,24931,95,NULL,'Michard 1979a','NGC 3159',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68852,'Faber-Jackson','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68852,35.2,0.63,110,24931,95,NULL,'Michard 1979b, c','NGC 3159',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68853,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68853,35.21,0.17,110,24931,70,NULL,NULL,'NGC 3159',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68854,'Tertiary','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68854,34.12,0.5,66.7,24931,95,NULL,NULL,'NGC 3159',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68855,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68855,36.66,0.14,215,24932,70,NULL,NULL,'2MASX J10135346-0052364',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000072,NULL,'17.0g',0.27,'E/S0','Group member',NULL,NULL,NULL,1,153.4727083,-0.87667,0.037,NULL,41213013579,643953337,10061770,17),(68856,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68856,37.85,0.15,372,24933,70,NULL,NULL,'2MASX J10135379-0009174',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.0001,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,153.474291667,-0.15483,0.017,NULL,41211456671,643929010,10061390,16.6),(68857,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68857,37.7,0.46,347,24934,70,NULL,NULL,'2MASX J10135489+1525598',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,153.478625,15.43333,0.121,NULL,60839710525,950620476,14853444,17.6),(68858,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68858,37.8,0.33,363,24935,70,NULL,NULL,'2MASX J10135500+0852540',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,153.4792083,8.88175,0.033,NULL,60765197396,949456209,14835253,17.5),(68859,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68859,37.24,0.46,280,24936,70,NULL,NULL,'2MASX J10135522+0930228',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000182,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,153.4802083,9.50622,0.057,NULL,60869937952,951092780,14860824,16.6),(68860,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68860,35.74,0.25,141,24937,74.4,NULL,NULL,'2MASX J10135566-0053104',NULL,'2013AJ....146...86T',2013,1,0.45,NULL,'G',0.000094,NULL,'16.3g',0.2,'S0','Group member',NULL,NULL,NULL,1,153.481958333,-0.88622,0.037,NULL,41213011502,643953304,10061770,16.3),(68861,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68861,36.22,0.58,175,24937,70,NULL,NULL,'2MASX J10135566-0053104',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68862,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68862,37.67,0.33,343,24938,70,NULL,NULL,'SDSS J101356.49+214426.4',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000169,NULL,'16.9g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,153.485417,21.74067,0.073,NULL,60803736754,950058386,14844662,16.9),(68863,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68863,36.33,0.46,185,24939,70,NULL,NULL,'2MASX J10135688+0520448',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000182,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,153.486875,5.34569,0.013,NULL,60797685532,949963836,14843184,16.6),(68864,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68864,37.88,0.46,377,24940,70,NULL,NULL,'2MASX J10135741+1053478',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,153.4892083,10.89658,0.069,NULL,60871084609,951110697,14861104,17.4),(68865,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68865,36.59,0.46,208,24941,70,NULL,NULL,'2MASX J10135848+1222398',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000193,NULL,'16.2g',0.33,'S0',NULL,NULL,NULL,NULL,1,153.493833333,12.37769,0.085,NULL,60837226569,950581665,14852838,16.2),(68866,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68866,37.8,0.33,363,24942,70,NULL,NULL,'2MASX J10135855+0854298',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000147,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,153.494083333,8.90833,0.033,NULL,60765205167,949456330,14835255,17.6),(68867,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68867,38.63,0.46,532,24943,70,NULL,NULL,'SDSS J101358.70+165315.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,153.494625,16.88758,0.081,NULL,60855707071,950870422,14857350,17.9),(68868,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68868,31.5,0.4,19.9,24944,75,NULL,'B','UGC 05522',NULL,'1988NBGC.C....0000T',1988,1,1.31,NULL,'G',0.000017,NULL,'14.5g',0.66,'Sd             HII',NULL,NULL,NULL,NULL,1,153.4954583,7.024,0,NULL,60755963082,949311923,14832998,14.5),(68869,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68869,32.5,NULL,31.6,24944,NULL,NULL,NULL,'UGC 05522',NULL,'2015AstBu..70....1K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68870,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68870,32.87,0.4,37.5,24944,NULL,NULL,NULL,'UGC 05522',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68871,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68871,33.11,0.2,41.9,24944,74.4,NULL,NULL,'UGC 05522',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68872,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68872,33.15,0.43,42.6,24944,75,NULL,'3.6 micron, color corrected','UGC 05522',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68873,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68873,33.22,0.43,44,24944,75,NULL,'3.6 micron, color + selection bias corrected','UGC 05522',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68874,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68874,33.33,0.45,46.3,24944,NULL,NULL,NULL,'UGC 05522',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68875,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68875,33.42,0.43,48.3,24944,NULL,NULL,'Malmquist cor.','UGC 05522',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68876,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68876,36.91,0.25,241,24945,74.4,NULL,NULL,'2MASX J10135893-0057054',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000076,NULL,'17.7g',0.12,'S0','Group member',NULL,NULL,NULL,1,153.495417,-0.95161,0.045,NULL,41213214972,643956483,10061820,17.7),(68877,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68877,37.85,0.15,372,24946,70,NULL,NULL,'2MASX J10135906-0004534',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000117,NULL,'16.2g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,153.496125,-0.08158,0.013,NULL,41211452066,643928938,10061389,16.2),(68878,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68878,35.21,0.17,110,24947,70,NULL,NULL,'NGC 3161',NULL,'2015arXiv151105856S',2015,1,2.1,NULL,'G',0.000015,NULL,'14.8g',1.6,'E2             AGN','in a pair',NULL,NULL,NULL,1,153.496667,38.65714,0,NULL,64096576428,1001509006,15648578,14.8),(68879,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68879,37.3,0.46,288,24948,70,NULL,NULL,'2MASX J10135983+3006106',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,153.499208333,30.10292,0.109,NULL,64032973554,1000515211,15633050,17.7),(68880,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68880,36.66,0.14,215,24949,70,NULL,NULL,'2MASX J10135993-0055304',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000069,NULL,'17.3g',0.2,'S0','Group member',NULL,NULL,NULL,1,153.499583,-0.92528,0.037,NULL,41213187056,643956047,10061813,17.3),(68881,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68881,37.65,0.46,339,24950,70,NULL,NULL,'2MASX J10140049+1525278',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,153.502,15.42431,0.121,NULL,60839709176,950620455,14853444,18),(68882,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68882,37.08,0.46,261,24951,70,NULL,NULL,'2MASX J10140052+0802338',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,153.5022917,8.04264,0.041,NULL,60765465806,949460403,14835318,17.6),(68883,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68883,37.67,0.33,343,24952,70,NULL,NULL,'2MASX J10140177+2141058',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000151,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,153.5072917,21.68492,0.073,NULL,60803666093,950057282,14844645,17.8),(68884,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68884,37.84,0.46,369,24953,70,NULL,NULL,'2MASX J10140341+3335516',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,153.514125,33.59778,0.025,NULL,64079108304,1001236067,15644313,17.5),(68885,'IRAS','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68885,33.5,0.8,50,24954,75,NULL,'MAT, I','ESO 567- G 026',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.00002,NULL,'14.23',0.4,'Sbc            HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,153.514625,-21.97675,0.221,NULL,41139519457,642804991,10043827,14.23),(68886,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68886,33.48,0.43,49.6,24954,75,NULL,'MAT, I, raw','ESO 567- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68887,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68887,33.57,0.32,51.7,24954,85,NULL,'I, raw','ESO 567- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68888,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68888,33.61,0.32,52.8,24954,85,NULL,'I, inv','ESO 567- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68889,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68889,33.65,0.43,53.7,24954,75,NULL,'MAT, I, cor','ESO 567- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68890,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68890,33.66,0.2,54,24954,74.4,NULL,NULL,'ESO 567- G 026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68891,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68891,33.68,0.47,54.6,24954,NULL,NULL,'H','ESO 567- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68892,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68892,33.7,0.43,54.9,24954,75,NULL,'MAT, I, inv','ESO 567- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68893,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68893,33.75,0.46,56.2,24954,NULL,NULL,'J','ESO 567- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68894,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68894,33.77,0.12,56.9,24954,NULL,NULL,NULL,'ESO 567- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68895,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68895,33.8,0.45,57.5,24954,NULL,NULL,'K','ESO 567- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68896,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68896,33.86,0.49,59,24954,75,NULL,'IR','ESO 567- G 026',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68897,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68897,33.87,0.4,59.3,24954,NULL,NULL,'mean','ESO 567- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68898,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68898,38.15,0.46,426,24955,70,NULL,NULL,'SDSS J101403.66+112729.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000145,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,153.51525,11.45819,0.101,NULL,60869457239,951085269,14860707,18.6),(68899,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68899,35.6,0.33,132,24956,70,NULL,NULL,'CGCG 093-076 NED02',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000117,NULL,'16.20',0.4,NULL,NULL,NULL,NULL,NULL,1,153.515583,14.52422,0.117,NULL,60850360286,950786879,14856044,16.2),(68900,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68900,38,0.33,397,24957,70,NULL,NULL,'2MASX J10140437+0614368',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000181,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,153.518333,6.24344,0,NULL,60755562915,949305670,14832901,16.3),(68901,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68901,37.97,0.46,392,24958,70,NULL,NULL,'2MASX J10140593+5821069',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000185,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,153.524875,58.35192,0,NULL,61919768211,967496378,15117130,17.7),(68902,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68902,38.21,0.46,439,24959,70,NULL,NULL,'SDSS J101406.19+424911.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000139,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,153.525833,42.81983,0.017,NULL,64100408768,1001568887,15649513,17.9),(68903,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68903,38,0.33,397,24960,70,NULL,NULL,'SDSS J101406.35+061438.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000158,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,153.5265,6.24408,0,NULL,60755562991,949305671,14832901,18.3),(68904,'Faber-Jackson','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68904,33.76,0.7,56.5,24961,95,NULL,'de Vaucouleurs','NGC 3163',NULL,'1984ApJS...56...91D',1984,1,1.5,NULL,'G',0.000077,NULL,'14.33',1.5,'SA0-:','Group member',NULL,NULL,NULL,1,153.529583,38.65256,0,NULL,64096576159,1001509002,15648578,14.33),(68905,'Faber-Jackson','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68905,34.01,0.37,63.4,24961,95,NULL,'Weighted Mean','NGC 3163',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68906,'Faber-Jackson','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68906,34.52,0.46,80.2,24961,95,NULL,'Michard 1979a','NGC 3163',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68907,'Faber-Jackson','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68907,34.92,0.63,96.4,24961,95,NULL,'Michard 1979b, c','NGC 3163',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68908,'Tertiary','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68908,34.12,0.5,66.7,24961,95,NULL,NULL,'NGC 3163',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68909,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68909,34.84,0.4,92.9,24961,NULL,NULL,'mean','NGC 3163',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68910,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68910,35.18,0.45,109,24961,NULL,NULL,'K','NGC 3163',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68911,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68911,37.51,0.46,317,24962,70,NULL,NULL,'2MASX J10140842+2958000',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000177,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,153.535083,29.96683,0.093,NULL,64032967478,1000515116,15633048,17.4),(68912,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68912,36.66,0.14,215,24963,70,NULL,NULL,'2MASX J10140946-0053544',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00009,NULL,'16.9g',0.3,'S0','Group member',NULL,NULL,NULL,1,153.539583,-0.89844,0.037,NULL,41213194806,643956168,10061815,16.9),(68913,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68913,36.82,0.25,231,24963,74.4,NULL,NULL,'2MASX J10140946-0053544',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68914,'Tully est','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68914,32.58,0.8,32.8,24964,75,NULL,NULL,'UGC 05518',NULL,'1988NBGC.C....0000T',1988,1,0.54,NULL,'G',0.000013,NULL,'16.6g',0.33,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,153.543166667,39.45139,0.017,NULL,64097250170,1001519533,15648742,16.6),(68915,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68915,35.6,0.33,132,24965,70,NULL,NULL,'CGCG 093-077',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',NULL,NULL,'15.6',0.68,NULL,'Group member',NULL,NULL,NULL,1,153.545916667,14.38069,0.117,NULL,60850316094,950786188,14856034,15.6),(68916,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68916,37.9,0.27,381,24966,70,NULL,NULL,'2MASX J10141328+0016473',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000071,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,153.555417,0.27978,0.005,NULL,60743529878,949117654,14829963,17.9),(68917,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68917,35.21,0.17,110,24967,70,NULL,NULL,'CGCG 211-028',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.00007,NULL,'14.8g',0.55,'S0',NULL,NULL,NULL,NULL,1,153.558125,39.05094,0,NULL,64096791994,1001512374,15648630,14.8),(68918,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68918,37.9,0.27,381,24968,70,NULL,NULL,'SDSS J101414.47+001756.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000077,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,153.560333333,0.29906,0.005,NULL,60743518903,949117482,14829960,18.3),(68919,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2003cg',NULL,68919,31.08,0.08,16.4,24969,72,NULL,NULL,'NGC 3169',0.00413,'2011ApJ...731..120M',2011,1,4.4,NULL,'G',0.000013,NULL,'10.8B',2.8,'SA(s)a pec;HII LINER','Pair member (points to parent)',NULL,NULL,'Sy',1,153.5627083,3.46608,0.041,NULL,60797465169,949960393,14843131,10.8),(68920,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2003cg',NULL,68920,31.25,0.44,17.7,24969,74.2,NULL,'SALT 2','NGC 3169',0.00413,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68921,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2003cg',NULL,68921,31.57,0.25,20.5,24969,72,NULL,NULL,'NGC 3169',0.00413,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68922,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2003cg',NULL,68922,31.83,0.1,23.2,24969,74.4,NULL,NULL,'NGC 3169',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68923,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2003cg',NULL,68923,31.97,0.06,24.7,24969,72,NULL,NULL,'NGC 3169',0.00413,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68924,'Tully est','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68924,31.47,0.8,19.7,24969,75,NULL,'B','NGC 3169',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68925,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68925,30.84,0.45,14.7,24969,NULL,NULL,'K','NGC 3169',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68926,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68926,30.93,0.46,15.3,24969,NULL,NULL,'J','NGC 3169',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68927,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68927,31.63,0.4,21.2,24969,NULL,NULL,'mean','NGC 3169',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68928,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68928,33.05,NULL,40.8,24969,54,NULL,'HI','NGC 3169',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68929,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68929,33.08,0.4,41.3,24969,75,NULL,'HOSTS SN 2003cg','NGC 3169',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68930,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68930,33.67,NULL,54.1,24969,65.2,NULL,'CO','NGC 3169',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68931,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68931,37.55,0.46,323,24970,70,NULL,NULL,'2MASX J10141539+4855156',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000176,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,153.564125,48.92089,0,NULL,63998123833,999970684,15624541,17.1),(68932,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68932,36.55,0.46,205,24971,70,NULL,NULL,'2MASX J10141607+4946586',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000164,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,153.566875,49.78303,0,NULL,64002508580,1000039196,15625612,16.6),(68933,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68933,37.9,0.27,381,24972,70,NULL,NULL,'2MASX J10141615+0018243',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000087,NULL,'16.8g',0.3,'AGN',NULL,NULL,NULL,NULL,1,153.567375,0.30686,0.005,NULL,60743518552,949117477,14829960,16.8),(68934,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68934,37.26,0.46,283,24973,70,NULL,NULL,'2MASX J10141629+1356495',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000185,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,153.567875,13.94728,0.125,NULL,60850164504,950783820,14855997,16.4),(68935,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68935,37.66,0.46,340,24974,70,NULL,NULL,'2MASX J10141710+2322158',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000175,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,153.571375,23.37122,0.061,NULL,60800762244,950011910,14843936,17.9),(68936,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68936,35.64,0.25,134,24975,74.4,NULL,NULL,'LCSB S1390P',NULL,'2013AJ....146...86T',2013,1,0.54,NULL,'G',0.000061,NULL,'16.9g',0.15,'Sc(f)','Group member',NULL,NULL,NULL,1,153.573333,-0.95367,0.045,NULL,41213228075,643956688,10061823,16.9),(68937,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68937,35.99,0.51,157,24976,70,NULL,NULL,'2MASX J10141842-1106420',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000133,NULL,'15.44',0.5,NULL,NULL,NULL,NULL,NULL,1,153.577125,-11.11175,0.185,NULL,41276054761,644938355,10077161,15.44),(68938,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68938,38.14,0.46,424,24977,70,NULL,NULL,'2MASX J10141978+2730461',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,153.5825417,27.51294,0.141,NULL,64024499514,1000382804,15630981,18),(68939,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68939,37.28,0.46,285,24978,70,NULL,NULL,'SDSS J101420.52+070552.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,153.585541667,7.09806,0,NULL,60763517620,949429962,14834843,17.8),(68940,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68940,32.07,0.4,26,24979,75,NULL,NULL,'UGC 05524',NULL,'2008Ap.....51..336K',2008,1,1.83,NULL,'G',0.000014,NULL,'15.29',0.22,'Sc',NULL,NULL,NULL,NULL,1,153.590375,22.12469,0.069,NULL,60803249279,950050769,14844543,15.29),(68941,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68941,32.29,0.49,28.7,24979,75,NULL,'IR','UGC 05524',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68942,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68942,32.65,NULL,33.8,24979,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05524',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68943,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68943,32.65,NULL,34,24979,NULL,NULL,'Dipole + Quadrupole','UGC 05524',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68944,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68944,32.67,NULL,34.3,24979,NULL,NULL,'Dipole','UGC 05524',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68945,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68945,32.78,NULL,35.9,24979,NULL,NULL,NULL,'UGC 05524',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68946,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68946,37.86,0.46,373,24980,70,NULL,NULL,'2MASX J10142197+5847462',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000159,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,153.591583,58.79636,0.005,NULL,61920428497,967506695,15117292,18),(68947,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68947,37.84,0.27,370,24981,70,NULL,NULL,'2MASX J10142215+3557120',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,153.592333,35.95336,0.005,NULL,64066343152,1001036611,15641197,17.6),(68948,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68948,38.2,0.46,436,24982,70,NULL,NULL,'2MASX J10142232+1617025',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,153.5929583,16.28403,0.089,NULL,60842256693,950660260,14854066,17.6),(68949,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68949,37.82,0.33,366,24983,70,NULL,NULL,'2MASX J10142304+3351264',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000151,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,153.596083,33.85744,0.017,NULL,64087271907,1001363623,15646306,16.5),(68950,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68950,37.85,0.15,372,24984,70,NULL,NULL,'2MASX J10142336+0000325',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000073,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,153.59725,0.00894,0.013,NULL,60743500322,949117192,14829956,17.8),(68951,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68951,37.78,0.46,360,24985,70,NULL,NULL,'2MASX J10142496+2104548',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000139,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,153.604125,21.08194,0.069,NULL,60814491844,950226435,14847288,18.3),(68952,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68952,36.59,0.33,208,24986,70,NULL,NULL,'CGCG 240-020',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000186,NULL,'15.5g',0.41,'E0',NULL,NULL,NULL,NULL,1,153.6052083,50.13211,0,NULL,64004656277,1000072754,15626136,15.5),(68953,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68953,38.14,0.46,424,24987,70,NULL,NULL,'2MASX J10142553+2149008',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000129,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,153.606583,21.81678,0.069,NULL,60803674071,950057407,14844646,17.3),(68954,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68954,35.78,0.25,143,24988,74.4,NULL,NULL,'2MASX J10142568-0052184',NULL,'2013AJ....146...86T',2013,1,0.74,NULL,'G',0.000103,NULL,'15.3g',0.56,'S0','Group member',NULL,NULL,NULL,1,153.607083,-0.87186,0.045,NULL,41213123460,643955054,10061797,15.3),(68955,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68955,36.66,0.14,215,24988,70,NULL,NULL,'2MASX J10142568-0052184',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68956,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68956,37.06,0.53,258,24988,70,NULL,NULL,'2MASX J10142568-0052184',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68957,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68957,34.62,0.57,84.1,24989,70,NULL,NULL,'2MASX J10142674-1726016',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.11',0.6,NULL,NULL,NULL,NULL,NULL,1,153.6115417,-17.43383,0.233,NULL,41197388918,643709201,10057956,16.11),(68958,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68958,37.18,0.46,273,24990,70,NULL,NULL,'2MASX J10142742+3010024',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,153.614375,30.16747,0.109,NULL,64032993920,1000515530,15633055,16.9),(68959,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68959,35.08,0.47,104,24991,NULL,NULL,'H','NGC 3197',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',NULL,NULL,'14.34',1,'Sbc',NULL,NULL,NULL,NULL,1,153.6152917,77.82025,0.013,NULL,61430649542,959853899,14997717,14.34),(68960,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68960,35.17,0.45,108,24991,NULL,NULL,'K','NGC 3197',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68961,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68961,35.19,0.46,109,24991,NULL,NULL,'J','NGC 3197',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68962,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68962,35.23,0.4,111,24991,NULL,NULL,'mean','NGC 3197',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68963,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68963,37.75,0.46,354,24992,70,NULL,NULL,'2MASX J10142788+1209325',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000189,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,153.616333,12.15889,0.065,NULL,60836703288,950573488,14852710,17),(68964,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68964,35.69,0.25,137,24993,74.4,NULL,NULL,'2MASX J10142801-0054114',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.0001,NULL,'15.8g',0.49,'SB0','Group member',NULL,NULL,NULL,1,153.616625,-0.90314,0.045,NULL,41213193775,643956152,10061814,15.8),(68965,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68965,37.55,0.33,324,24994,70,NULL,NULL,'2MASX J10142954+0904244',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000185,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,153.622958333,9.07339,0.057,NULL,60751447983,949241374,14831896,17),(68966,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68966,37.82,0.33,366,24995,70,NULL,NULL,'2MASX J10142963+3355574',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000168,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,153.623375,33.93258,0.017,NULL,64087790379,1001371724,15646433,18.4),(68967,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68967,36.66,0.14,215,24996,70,NULL,NULL,'2MASX J10142961-0048264',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000059,NULL,'17.3g',0.22,'S0',NULL,NULL,NULL,NULL,1,153.623417,-0.80719,0.037,NULL,41213132392,643955193,10061799,17.3),(68968,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68968,35.21,0.17,110,24997,70,NULL,NULL,'CGCG 211-030',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.00007,NULL,'14.9g',0.64,'S0/a',NULL,NULL,NULL,NULL,1,153.623833333,39.50161,0.017,NULL,64097247172,1001519487,15648741,14.9),(68969,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68969,36.59,0.33,208,24998,70,NULL,NULL,'2MASX J10142994+5004516',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,153.6245417,50.081,0,NULL,64002605594,1000040712,15625636,17.4),(68970,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68970,37.85,0.46,371,24999,70,NULL,NULL,'2MASX J10143055+0026013',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000071,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,153.627417,0.43383,0.005,NULL,60743633233,949119269,14829988,17.9),(68971,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68971,37.87,0.46,375,25000,70,NULL,NULL,'2MASX J10143091+0810014',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00019,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,153.628917,8.16719,0.041,NULL,60765453638,949460213,14835315,17.8),(68972,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68972,38.06,0.46,409,25001,70,NULL,NULL,'SDSS J101432.16+103432.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,153.6340417,10.57569,0.061,NULL,60870623238,951103488,14860992,18.5),(68973,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68973,36.66,0.14,215,25002,70,NULL,NULL,'2MASX J10143428-0050134',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000087,NULL,'16.5g',0.25,'S0','Group member',NULL,NULL,NULL,1,153.642833,-0.837,0.045,NULL,41213129570,643955149,10061799,16.5),(68974,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68974,37.85,0.15,372,25003,70,NULL,NULL,'2MASX J10143448-0021364',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000079,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,153.643666667,-0.36014,0.017,NULL,41211626620,643931665,10061432,17.6),(68975,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68975,36.66,0.14,215,25004,70,NULL,NULL,'2MASX J10143468-0049494',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000079,NULL,'17.3g',0.22,'S0','Group member',NULL,NULL,NULL,1,153.644541667,-0.83056,0.045,NULL,41213129690,643955151,10061799,17.3),(68976,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68976,37.15,0.46,269,25005,70,NULL,NULL,'2MASX J10143515+5605112',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,153.646583,56.08658,0,NULL,61897266986,967144796,15111637,17.3),(68977,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68977,37.36,0.27,296,25006,70,NULL,NULL,'2MASX J10143560+1031514',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000173,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,153.648417,10.53081,0.061,NULL,60870166025,951096344,14860880,16.4),(68978,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68978,35.95,0.6,155,25007,70,NULL,NULL,'2MASX J10143570-1108233',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.34',0.3,NULL,NULL,NULL,NULL,NULL,1,153.648708333,-11.13989,0.185,NULL,41276057938,644938405,10077162,16.34),(68979,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68979,35.2,0.62,109,25008,70,NULL,NULL,'MCG -01-26-037',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.70',0.25,NULL,NULL,NULL,NULL,NULL,1,153.648917,-6.63008,0.109,NULL,41251102037,644548469,10071069,15.7),(68980,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68980,36.97,0.61,247,25009,70,NULL,NULL,'2MASX J10143573-0202474',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'16.48',0.55,NULL,NULL,NULL,NULL,NULL,1,153.6489583,-2.04658,0.021,NULL,41210700679,643917198,10061206,16.48),(68981,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68981,37.55,0.33,324,25010,70,NULL,NULL,'2MASX J10143622+0904294',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000187,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,153.650958333,9.07481,0.057,NULL,60751452346,949241442,14831897,16.8),(68982,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68982,36.51,0.46,201,25011,70,NULL,NULL,'2MASX J10143647+5716272',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,153.651917,57.27406,0,NULL,61928203115,967628173,15119190,16.8),(68983,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68983,37.85,0.15,372,25012,70,NULL,NULL,'2MASX J10143708-0023154',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000085,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,153.654667,-0.38769,0.017,NULL,41211496669,643929635,10061400,17.6),(68984,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68984,37.01,0.46,253,25013,70,NULL,NULL,'2MASX J10143715+0020293',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000107,NULL,'16.0g',0.41,'E0',NULL,NULL,NULL,NULL,1,153.65475,0.34153,0.005,NULL,60743710400,949120475,14830007,16),(68985,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68985,37.36,0.27,296,25014,70,NULL,NULL,'2MASX J10143777+1031074',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,153.657417,10.51864,0.061,NULL,60870166096,951096345,14860880,17.1),(68986,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68986,38.31,0.46,458,25015,70,NULL,NULL,'2MASX J10143837+1832128',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00019,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,153.6597917,18.53711,0.093,NULL,60809708845,950151700,14846120,17.2),(68987,'IRAS','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68987,30.64,0.8,13.5,25016,75,NULL,'MAT, I','NGC 3175',NULL,'1997ApJS..109..333W',1997,1,5,NULL,'G',0.000017,NULL,'12.13',1.3,'SAB(s)b        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,153.6754583,-28.87206,0.241,NULL,41959214663,655612729,10243948,12.13),(68988,'Tully est','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68988,30.87,0.8,14.9,25016,75,NULL,'B','NGC 3175',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68989,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68989,30.47,0.32,12.4,25016,85,NULL,'I, raw','NGC 3175',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68990,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68990,30.48,0.32,12.5,25016,85,NULL,'I, inv','NGC 3175',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68991,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68991,30.6,0.39,13.2,25016,73,NULL,'IR','NGC 3175',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68992,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68992,30.61,0.4,13.2,25016,75,NULL,NULL,'NGC 3175',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68993,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68993,30.62,0.43,13.3,25016,75,NULL,'MAT, I, raw','NGC 3175',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68994,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',68994,30.73,0.49,14,25016,75,NULL,'IR','NGC 3175',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68995,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68995,30.73,0.43,14,25016,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3175',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68996,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68996,30.77,0.43,14.3,25016,75,NULL,'MAT, I, inv','NGC 3175',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68997,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68997,30.84,0.43,14.7,25016,75,NULL,'3.6 micron, color corrected','NGC 3175',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68998,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68998,30.86,0.43,14.8,25016,75,NULL,'MAT, I, cor','NGC 3175',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68999,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,68999,31.26,0.2,17.9,25016,74.4,NULL,NULL,'NGC 3175',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69000,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69000,32.03,0.44,25.4,25016,NULL,NULL,NULL,'NGC 3175',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69001,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69001,32.16,0.42,27,25016,NULL,NULL,'Malmquist cor.','NGC 3175',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69002,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69002,37.27,0.46,284,25017,70,NULL,NULL,'SDSS J101444.83+133503.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000128,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,153.686791667,13.58428,0.105,NULL,60848086938,950751358,14855489,18.1),(69003,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69003,35.21,0.17,110,25018,70,NULL,NULL,'CGCG 211-031',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.00008,NULL,'14.6g',0.67,'E0',NULL,NULL,NULL,NULL,1,153.688875,38.981,0,NULL,64096814396,1001512724,15648636,14.6),(69004,'IRAS','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69004,32.97,0.8,39.3,25019,75,NULL,'MAT, I','IC 2559',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000013,NULL,'14.35',0.7,'SB(s)b?        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,153.689125,-34.05881,0.377,NULL,42007920454,656373757,10255839,14.35),(69005,'IRAS','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69005,32.99,0.8,39.6,25019,75,NULL,'HMCL, I','IC 2559',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69006,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69006,31.82,0.3,23.1,25019,92,NULL,'I, Assuming Hydra cluster m-M = 33.2 mag','IC 2559',NULL,'1993AJ....105...97S',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69007,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69007,32,0.3,25.1,25019,92,NULL,'H, Assuming Hydra cluster m-M = 33.2 mag','IC 2559',NULL,'1993AJ....105...97S',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69008,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69008,32.58,0.43,32.8,25019,75,NULL,'3.6 micron, color + selection bias corrected','IC 2559',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69009,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69009,32.7,0.43,34.6,25019,75,NULL,'3.6 micron, color corrected','IC 2559',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69010,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69010,32.75,0.38,35.5,25019,NULL,NULL,NULL,'IC 2559',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69011,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69011,32.79,NULL,36.1,25019,NULL,NULL,'B','IC 2559',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69012,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69012,32.79,0.4,36.2,25019,75,NULL,'HMCL, I, raw','IC 2559',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69013,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69013,32.8,0.2,36.3,25019,74.4,NULL,NULL,'IC 2559',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69014,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69014,32.88,0.32,37.7,25019,85,NULL,'I, raw','IC 2559',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69015,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69015,32.88,0.4,37.7,25019,75,NULL,'HMCL, I, inv','IC 2559',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69016,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69016,32.9,0.32,38.1,25019,85,NULL,'I, inv','IC 2559',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69017,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69017,32.94,NULL,38.7,25019,NULL,NULL,'I','IC 2559',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69018,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69018,33.04,0.4,40.6,25019,75,NULL,'HMCL, I, cor','IC 2559',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69019,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69019,33.06,0.43,41,25019,75,NULL,'MAT, I, raw','IC 2559',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69020,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69020,33.17,0.4,43.1,25019,NULL,NULL,'mean','IC 2559',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69021,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69021,33.2,0.43,43.6,25019,75,NULL,'MAT, I, inv','IC 2559',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69022,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69022,33.21,0.14,43.9,25019,NULL,NULL,NULL,'IC 2559',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69023,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69023,33.32,0.43,46.1,25019,75,NULL,'MAT, I, cor','IC 2559',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69024,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69024,33.33,0.47,46.4,25019,NULL,NULL,'H','IC 2559',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69025,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69025,33.38,0.45,47.3,25019,NULL,NULL,'K','IC 2559',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69026,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69026,33.42,0.46,48.2,25019,NULL,NULL,'J','IC 2559',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69027,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69027,35.75,0.46,141,25020,70,NULL,NULL,'CGCG 008-081',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000107,NULL,'15.3g',0.44,'E/S0','Group member',NULL,NULL,NULL,1,153.6912083,-0.33936,0.017,NULL,41211633493,643931773,10061433,15.3),(69028,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69028,37.94,0.46,388,25021,70,NULL,NULL,'2MASX J10144836+6237504',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,153.701583,62.63067,0.021,NULL,61941739380,967839677,15122494,17.3),(69029,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69029,37.36,0.46,297,25022,70,NULL,NULL,'VII Zw 315',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,153.7024583,58.22153,0,NULL,61919784499,967496632,15117134,17.4),(69030,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69030,33.28,0.47,45.2,25023,NULL,NULL,'H','ESO 317- G 006',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000033,NULL,'14.39',0.5,'SB(rs)b pec?   HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,153.704375,-38.18881,0.361,NULL,41964589165,655696705,10245261,14.39),(69031,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69031,33.37,0.46,47.1,25023,NULL,NULL,'J','ESO 317- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69032,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69032,33.37,0.45,47.2,25023,NULL,NULL,'K','ESO 317- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69033,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69033,33.53,0.65,50.7,25023,NULL,NULL,'Malmquist cor.','ESO 317- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69034,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69034,33.55,0.65,51.2,25023,NULL,NULL,NULL,'ESO 317- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69035,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69035,33.59,0.2,52.2,25023,74.4,NULL,NULL,'ESO 317- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69036,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69036,33.81,0.4,57.7,25023,NULL,NULL,'mean','ESO 317- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69037,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69037,37.89,0.46,378,25024,70,NULL,NULL,'2MASX J10144953+1705459',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,153.7064583,17.09619,0.073,NULL,60838798937,950606233,14853222,17),(69038,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69038,34.36,0.81,74.6,25025,NULL,NULL,NULL,'CGCG 008-082',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000013,NULL,'15.24',0.4,'SBb','Group member',NULL,NULL,NULL,1,153.708833,-1.38628,0.053,NULL,41213050813,643953918,10061779,15.24),(69039,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69039,34.4,0.2,75.9,25025,74.4,NULL,NULL,'CGCG 008-082',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69040,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69040,34.64,0.72,84.6,25025,NULL,NULL,'Malmquist cor.','CGCG 008-082',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69041,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69041,36.6,0.46,209,25026,70,NULL,NULL,'2MASX J10145084-0107215',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.0001,NULL,'16.6g',0.22,'S0','Group member',NULL,NULL,NULL,1,153.711791667,-1.12267,0.049,NULL,41213178941,643955920,10061811,16.6),(69042,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69042,37.72,0.46,350,25027,70,NULL,NULL,'2MASX J10145260+0353285',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,153.719167,3.89128,0.017,NULL,60796904524,949951633,14842994,16.9),(69043,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69043,33.32,0.55,46.2,25028,70,NULL,NULL,'ESO 500- G 018',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000073,NULL,'14.19',0.7,'(RL)S0^+',NULL,NULL,NULL,NULL,1,153.7237917,-23.05069,0.225,NULL,41608250576,650128915,10158264,14.19),(69044,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69044,36.66,0.14,215,25029,70,NULL,NULL,'2MASX J10145418-0047405',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000078,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,153.725625,-0.79453,0.045,NULL,41213107751,643954808,10061793,17.1),(69045,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69045,37.36,0.27,296,25030,70,NULL,NULL,'2MASX J10145418+1026378',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,153.725791667,10.44386,0.061,NULL,60870224334,951097255,14860894,17.1),(69046,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69046,35.6,0.46,132,25031,70,NULL,NULL,'CGCG 290-017',NULL,'2015arXiv151105856S',2015,1,1.07,NULL,'G',0.00009,NULL,'14.6g',0.67,'E0',NULL,NULL,NULL,NULL,1,153.727625,56.29967,0,NULL,61897043122,967141298,15111582,14.6),(69047,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69047,38.19,0.46,435,25032,70,NULL,NULL,'2MASX J10145569+4612010',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,153.732167,46.20031,0,NULL,64127695477,1001995241,15656175,17.4),(69048,'TRGB','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69048,27.92,0.2,3.8,25033,NULL,NULL,NULL,'[HKK2009] dJ1014+6845',NULL,'2013AJ....146..126C',2013,1,NULL,NULL,'G',NULL,NULL,'21.0B',NULL,'dSph',NULL,NULL,NULL,NULL,1,153.7325,68.7575,0.113,NULL,62129212794,970768949,15168264,21),(69049,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69049,34.9,0.46,95.3,25034,70,NULL,NULL,'CGCG 313-008',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000177,NULL,'15.0g',0.48,'S0',NULL,NULL,NULL,NULL,1,153.7372917,64.36308,0.037,NULL,62113426701,970522292,15164410,15),(69050,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69050,35.38,0.46,119,25035,70,NULL,NULL,'2MASX J10145904+4555340',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000165,NULL,'15.6g',0.41,'E0',NULL,NULL,NULL,NULL,1,153.746166667,45.92597,0,NULL,64127633104,1001994267,15656160,15.6),(69051,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69051,37.06,0.46,258,25036,70,NULL,NULL,'2MASX J10145915+3050109',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000172,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,153.746625,30.83633,0.085,NULL,64032438400,1000506850,15632919,16.5),(69052,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69052,37.44,0.46,308,25037,70,NULL,NULL,'2MASX J10150002+0456515',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,153.750083,4.94775,0.025,NULL,60798119405,949970615,14843290,17.2),(69053,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69053,33.51,0.49,50.2,25038,NULL,NULL,'Malmquist cor.','UGC 05520',NULL,'2009ApJS..182..474S',2009,1,1.44,NULL,'G',0.00003,NULL,'14.3g',0.74,'Scd:','in a pair',NULL,NULL,NULL,1,153.75175,65.13989,0.105,NULL,62111932237,970498941,15164045,14.3),(69054,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69054,33.64,0.2,53.5,25038,74.4,NULL,NULL,'UGC 05520',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69055,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69055,33.72,0.44,55.4,25038,NULL,NULL,NULL,'UGC 05520',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69056,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69056,36.63,0.46,212,25039,70,NULL,NULL,'2MASX J10150085+1233499',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000198,NULL,'16.0g',0.44,'E0',NULL,NULL,NULL,NULL,1,153.75375,12.564,0.089,NULL,60836640741,950572511,14852695,16),(69057,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69057,38.03,0.33,403,25040,70,NULL,NULL,'2MASX J10150168+1401409',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,153.757083,14.02814,0.129,NULL,60849537538,950774024,14855844,16.9),(69058,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69058,37.79,0.46,362,25041,70,NULL,NULL,'2MASX J10150364+1333519',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,153.765167,13.56433,0.113,NULL,60848082042,950751281,14855488,17.3),(69059,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69059,34.57,0.49,81.9,25042,75,NULL,'IR','UGC 05529',NULL,'2011yCatp016004901K',2011,1,1.42,NULL,'G',0.000017,NULL,'15.2g',0.31,'Sdm:','Group member',NULL,NULL,NULL,1,153.766166667,21.17419,0.069,NULL,60802773162,950043330,14844427,15.2),(69060,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69060,38.09,0.46,415,25043,70,NULL,NULL,'2MASX J10150402+0923178',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000177,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,153.766667,9.38828,0.057,NULL,60751547420,949242928,14831920,17.8),(69061,'BL Lac Luminosity','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69061,39.91,NULL,800,25044,NULL,NULL,NULL,'[HB89] 1011+496',0.212,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.002,NULL,'16.15',NULL,'BLLAC',NULL,NULL,'radio jet','BL Lac',1,153.76725,49.43353,0,NULL,63998215633,999972119,15624564,16.15),(69062,'GeV TeV ratio','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69062,40.28,NULL,1140,25044,72,NULL,NULL,'[HB89] 1011+496',NULL,'2010MNRAS.405L..76P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69063,'GeV TeV ratio','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69063,41.3,0.38,1820,25044,72,NULL,NULL,'[HB89] 1011+496',NULL,'2011arXiv1111.0913P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69064,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69064,38.05,0.46,408,25045,70,NULL,NULL,'2MASX J10150510+0740298',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000179,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,153.771167,7.675,0.069,NULL,60766312956,949473639,14835525,18),(69065,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69065,37.84,0.27,370,25046,70,NULL,NULL,'2MASX J10150521+3600184',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,153.771583333,36.00522,0,NULL,64066353047,1001036766,15641199,18),(69066,'TRGB','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69066,27.94,0.14,3.9,25047,NULL,NULL,NULL,'MESSIER 081:[CKT2009] d1015+69',NULL,'2013AJ....146..126C',2013,1,NULL,NULL,'G',NULL,NULL,'20.5B',NULL,'dI',NULL,NULL,NULL,NULL,1,153.77875,69.0375,0.121,NULL,62128692626,970760822,15168137,20.5),(69067,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69067,37.02,0.46,253,25048,70,NULL,NULL,'2MASX J10150769+3509119',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,153.782041667,35.15342,0.025,NULL,64073435745,1001147433,15642928,17.7),(69068,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69068,36.83,0.33,232,25049,70,NULL,NULL,'2MASX J10150836+5123172',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000169,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,153.78475,51.38808,0,NULL,64004105843,1000064153,15626002,16.4),(69069,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69069,37.98,0.46,395,25050,70,NULL,NULL,'SDSS J101508.96+000706.1',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.2g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,153.787333,0.11839,0.017,NULL,60743592322,949118630,14829978,17.2),(69070,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69070,37.87,0.46,375,25051,70,NULL,NULL,'2MASX J10151121+2800421',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,153.796667,28.01161,0.129,NULL,64035766312,1000558848,15633732,17.6),(69071,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69071,37.99,0.46,397,25052,70,NULL,NULL,'2MASX J10151309+3105069',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00018,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,153.804625,31.08536,0.081,NULL,64032446059,1000506969,15632921,17.3),(69072,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69072,38.03,0.33,403,25053,70,NULL,NULL,'2MASX J10151561+1407481',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,153.814917,14.12994,0.125,NULL,60849550109,950774220,14855847,17.7),(69073,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69073,36.3,0.68,182,25054,70,NULL,NULL,'2MASX J10151661-1004272',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.21',NULL,NULL,NULL,NULL,NULL,NULL,1,153.819375,-10.07439,0.141,NULL,41273652353,644900818,10076575,16.21),(69074,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69074,37.48,0.46,313,25055,70,NULL,NULL,'2MASX J10151720+6009304',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,153.821875,60.15844,0,NULL,61921814873,967528357,15117630,17),(69075,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69075,37.65,0.46,339,25056,70,NULL,NULL,'2MASXi J1015175+151116',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,153.823083333,15.18794,0.093,NULL,60841027635,950641056,14853766,17.8),(69076,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69076,37.62,0.46,335,25057,70,NULL,NULL,'2MASX J10151757+0036218',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000077,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,153.823375,0.60603,0.009,NULL,60743627100,949119173,14829987,17.4),(69077,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69077,36.82,0.46,231,25058,70,NULL,NULL,'2MASX J10151806+2350457',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000154,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,153.8254583,23.846,0.077,NULL,60935050817,952110169,14876721,17.1),(69078,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69078,36.49,0.44,198,25059,NULL,NULL,'Malmquist cor.','AGC 500344',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000027,NULL,'15.27',0.5,'SD','Group member',NULL,NULL,NULL,1,153.828625,-1.43556,0.053,NULL,41212326883,643942607,10061603,15.27),(69079,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69079,36.69,0.4,218,25059,NULL,NULL,NULL,'AGC 500344',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69080,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69080,36.73,0.2,222,25059,74.4,NULL,NULL,'AGC 500344',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69081,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69081,37.39,0.46,301,25060,70,NULL,NULL,'2MASX J10151917-0047382',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000087,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,153.829833,-0.79392,0.045,NULL,41213104054,643954750,10061792,17),(69082,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69082,38.07,0.46,411,25061,70,NULL,NULL,'SDSS J101521.03+082729.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'18.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,153.837625,8.45831,0.029,NULL,60765815139,949465861,14835404,18.2),(69083,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69083,37.7,0.46,347,25062,70,NULL,NULL,'2MASX J10152178+2602311',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,153.840875,26.04189,0.117,NULL,64025846240,1000403847,15631310,18.3),(69084,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69084,36.87,0.46,237,25063,70,NULL,NULL,'2MASX J10152284+0032568',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000074,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,153.84525,0.54928,0.009,NULL,60743671547,949119867,14829997,16.7),(69085,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69085,36.89,0.46,238,25064,70,NULL,NULL,'2MASX J10152322+1920337',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,153.8469583,19.34275,0.065,NULL,60812938178,950202159,14846908,17.2),(69086,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69086,37.74,0.46,354,25065,70,NULL,NULL,'2MASX J10152508+1935427',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000183,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,153.854625,19.59508,0.057,NULL,60812788101,950199814,14846872,17.1),(69087,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69087,34.68,0.5,86.3,25066,70,NULL,NULL,'2MASX J10152692-1306180',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.23',NULL,NULL,NULL,NULL,NULL,NULL,1,153.862125,-13.10511,0.357,NULL,41155936157,643061502,10047835,16.23),(69088,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69088,37.83,0.46,368,25067,70,NULL,NULL,'2MASX J10152733+4148581',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,153.863666667,41.81611,0,NULL,64101593379,1001587396,15649803,17.7),(69089,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69089,37.52,0.46,320,25068,70,NULL,NULL,'2MASX J10152788+3126326',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000175,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,153.866125,31.44231,0.069,NULL,64077604285,1001212566,15643946,16.8),(69090,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69090,38.13,0.46,423,25069,70,NULL,NULL,'2MASX J10152886+2726021',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000159,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,153.8702083,27.43394,0.133,NULL,64024487829,1000382622,15630978,17.4),(69091,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69091,37.73,0.46,352,25070,70,NULL,NULL,'2MASX J10152899+4442333',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,153.871167,44.70928,0,NULL,64143875324,1002248051,15660125,17.7),(69092,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69092,38.54,0.46,510,25071,70,NULL,NULL,'2MASX J10152976+3346206',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,153.873833333,33.7725,0.033,NULL,64087296395,1001364006,15646312,17.8),(69093,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69093,35.48,0.49,125,25072,75,NULL,'IR','UGC 05533',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000009,NULL,'15.35',0.2,'Sb',NULL,NULL,NULL,NULL,1,153.877083,14.04111,0.129,NULL,60849618941,950775295,14855863,15.35),(69094,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69094,36.11,0.2,167,25072,74.4,NULL,NULL,'UGC 05533',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69095,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69095,37.84,0.27,370,25073,70,NULL,NULL,'2MASX J10153153+3601031',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,153.8814583,36.01756,0,NULL,64066322097,1001036282,15641191,17.7),(69096,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69096,34.64,0.43,84.6,25074,NULL,NULL,NULL,'NGC 3144',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',NULL,NULL,'14.29',0.7,'SB(s)ab pec:',NULL,NULL,NULL,NULL,1,153.884083,74.22028,0.037,NULL,61384408382,959131380,14986427,14.29),(69097,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69097,34.8,0.39,91.4,25074,NULL,NULL,'Malmquist cor.','NGC 3144',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69098,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69098,34.91,0.4,95.9,25074,NULL,NULL,'mean','NGC 3144',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69099,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69099,34.94,0.47,97.5,25074,NULL,NULL,'H','NGC 3144',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69100,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69100,35.03,0.45,101,25074,NULL,NULL,'K','NGC 3144',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69101,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69101,35.05,0.46,102,25074,NULL,NULL,'J','NGC 3144',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69102,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69102,35.11,0.2,105,25074,74.4,NULL,NULL,'NGC 3144',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69103,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69103,37.62,0.46,334,25075,70,NULL,NULL,'2MASX J10153301+4413283',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.0002,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,153.887666667,44.22456,0,NULL,64147379135,1002302798,15660981,16.5),(69104,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69104,36.51,0.46,201,25076,70,NULL,NULL,'2MASXi J1015350+163903',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.6g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,153.895916667,16.65089,0.089,NULL,60838761995,950605656,14853213,17.6),(69105,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69105,38.01,0.46,399,25077,70,NULL,NULL,'2MASX J10153547+1906199',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,153.8979583,19.10539,0.049,NULL,60809394953,950146796,14846043,18),(69106,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69106,36.81,0.43,230,25078,NULL,NULL,'Malmquist cor.','2MASX J10153570-0109462',NULL,'2009ApJS..182..474S',2009,1,0.46,NULL,'G',0.000027,NULL,'16.4g',0.24,'SBb','Group member',NULL,NULL,NULL,1,153.898833,-1.16275,0.049,NULL,41212393469,643943647,10061619,16.4),(69107,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69107,37.14,0.37,267,25078,NULL,NULL,NULL,'2MASX J10153570-0109462',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69108,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69108,37.18,0.2,273,25078,74.4,NULL,NULL,'2MASX J10153570-0109462',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69109,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69109,37.71,0.46,348,25079,70,NULL,NULL,'2MASX J10153597+0000477',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000169,NULL,'16.5g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,153.9,0.01322,0.017,NULL,60743562480,949118163,14829971,16.5),(69110,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69110,34.11,0.48,66.3,25080,70,NULL,NULL,'NGC 3171',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000117,NULL,'13.82',1.1,'S0- pec  poss. LINER',NULL,NULL,NULL,NULL,1,153.903417,-20.64739,0.229,NULL,41144265543,642879149,10044986,13.82),(69111,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69111,38.51,0.46,504,25081,70,NULL,NULL,'2MASX J10153813+1719523',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,153.908875,17.33119,0.073,NULL,60838772952,950605827,14853216,18),(69112,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69112,38.03,0.46,403,25082,70,NULL,NULL,'2MASX J10154071+2938168',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000103,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,153.9197917,29.63794,0.085,NULL,64034910106,1000545470,15633522,17.3),(69113,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69113,37.28,0.46,286,25083,70,NULL,NULL,'SDSS J101541.99+310033.4',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000149,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,153.925,31.00931,0.081,NULL,64032449657,1000507025,15632922,18.6),(69114,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69114,37.33,0.46,292,25084,70,NULL,NULL,'2MASX J10154203+1435063',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,153.925083333,14.58522,0.101,NULL,60849691677,950776432,14855881,17.2),(69115,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69115,33.42,NULL,48.4,25085,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05537',NULL,'2010Ap&SS.325..163P',2010,1,1.24,NULL,'G',0.000008,NULL,'15.3g',0.3,'Sd',NULL,NULL,NULL,NULL,1,153.9254583,7.32786,0.029,NULL,60763583075,949430985,14834859,15.3),(69116,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69116,33.43,NULL,48.5,25085,NULL,NULL,'Dipole','UGC 05537',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69117,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69117,33.43,NULL,48.6,25085,NULL,NULL,'Dipole + Quadrupole','UGC 05537',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69118,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69118,33.49,0.49,50,25085,75,NULL,'IR','UGC 05537',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69119,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69119,33.5,NULL,50.1,25085,NULL,NULL,NULL,'UGC 05537',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69120,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69120,34.11,0.2,66.4,25085,74.4,NULL,NULL,'UGC 05537',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69121,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69121,34.3,0.44,72.4,25085,NULL,NULL,NULL,'UGC 05537',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69122,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69122,34.43,0.41,77.1,25085,NULL,NULL,'Malmquist cor.','UGC 05537',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69123,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69123,37.38,0.46,299,25086,70,NULL,NULL,'2MASX J10154216+6121464',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,153.9254583,61.36272,0,NULL,61910324573,967348821,15114825,17.3),(69124,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69124,36.96,0.27,247,25087,70,NULL,NULL,'2MASX J10154218-0020564',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000066,NULL,'16.9g',0.27,'S0','Group member',NULL,NULL,NULL,1,153.925833,-0.34889,0.013,NULL,41211560332,643930630,10061416,16.9),(69125,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2002bf',NULL,69125,34.06,0.19,63.3,25088,74.2,NULL,'SALT 2','CGCG 266-031',0.024197,'2010ApJ...716..712A',2010,1,0.9,NULL,'G',0.000107,NULL,'14.3g',0.68,'SB(r)b:',NULL,NULL,NULL,NULL,1,153.9260417,55.66747,0,NULL,61896799662,967137494,15111523,14.3),(69126,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2002bf',NULL,69126,34.86,0.09,93.8,25088,74.4,NULL,NULL,'CGCG 266-031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69127,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2002bf',NULL,69127,35.01,0.18,98.1,25088,65,NULL,'SALT','CGCG 266-031',0.024197,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69128,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2002bf',NULL,69128,35.14,0.21,104,25088,65,NULL,'SALT2','CGCG 266-031',0.024197,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69129,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2002bf',NULL,69129,35.43,0.2,119,25088,65,NULL,'MLCS31','CGCG 266-031',0.024197,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69130,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2002bf',NULL,69130,35.48,0.13,119,25088,65,NULL,'MLCS2k2','CGCG 266-031',0.024197,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69131,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2002bf',NULL,69131,35.46,0.18,121,25088,65,NULL,'MLCS17','CGCG 266-031',0.024197,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69132,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2002bf',NULL,69132,36.19,0.05,169,25088,70,NULL,'SALT 2','CGCG 266-031',0.024197,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69133,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69133,37.88,0.33,376,25089,70,NULL,NULL,'2MASX J10154261+5509331',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000181,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,153.927625,55.15928,0,NULL,61904577752,967259027,15113422,16.5),(69134,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69134,38.15,0.33,428,25090,70,NULL,NULL,'SDSS J101543.07+350458.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,153.9295,35.08281,0,NULL,64073320493,1001145632,15642900,18.5),(69135,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69135,36.93,0.33,243,25091,70,NULL,NULL,'2MASX J10154480+4315322',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000158,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,153.936541667,43.259,0,NULL,64145190174,1002268596,15660446,16.6),(69136,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69136,36.1,0.46,166,25092,70,NULL,NULL,'2MASX J10154550+0016350',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000075,NULL,'17.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,153.9394583,0.27633,0.029,NULL,60743574564,949118352,14829974,17),(69137,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69137,38.33,0.46,463,25093,70,NULL,NULL,'2MASX J10155115+3045557',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,153.9630417,30.76567,0.093,NULL,64032598705,1000509354,15632958,18),(69138,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69138,38.03,0.46,403,25094,70,NULL,NULL,'2MASX J10155146+0859237',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000176,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,153.964583,8.99011,0.061,NULL,60765585288,949462270,14835347,17.2),(69139,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69139,38.72,0.46,555,25095,70,NULL,NULL,'SDSS J101551.73+011522.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00008,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,153.965541667,1.25628,0.037,NULL,60745308007,949145437,14830397,18.6),(69140,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69140,36.81,0.46,231,25096,70,NULL,NULL,'2MASX J10155212+3901151',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000083,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,153.96725,39.02075,0.009,NULL,64096676695,1001510573,15648602,16.8),(69141,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69141,37.4,0.46,302,25097,70,NULL,NULL,'2MASX J10155250+0005180',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000099,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,153.96875,0.08833,0.029,NULL,60743550007,949117968,14829968,16.5),(69142,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69142,36.96,0.27,247,25098,70,NULL,NULL,'2MASX J10155264-0024124',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.00013,NULL,'15.4g',0.55,'E/S0;BrClG','Group member',NULL,NULL,NULL,1,153.969458333,-0.40344,0.013,NULL,41212137269,643939644,10061556,15.4),(69143,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69143,35.1,0.46,105,25099,70,NULL,NULL,'NGC 3186',NULL,'2015arXiv151105856S',2015,1,0.86,'NGC identification is not certain.','G',0.000193,NULL,'15.24',0.63,NULL,NULL,NULL,NULL,NULL,1,153.9724583,6.96375,0.021,NULL,60763877499,949435585,14834931,15.24),(69144,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69144,38.15,0.33,428,25100,70,NULL,NULL,'2MASX J10155373+3500578',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,153.974,35.01606,0,NULL,64074194191,1001159284,15643113,17.8),(69145,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69145,37.76,0.46,357,25101,70,NULL,NULL,'2MASX J10155459+0637485',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000179,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,153.9774583,6.63019,0,NULL,60762997569,949421837,14834716,16.8),(69146,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69146,31.56,0.4,20.5,25102,75,NULL,'B','UGC 05539',NULL,'1988NBGC.C....0000T',1988,1,1.04,NULL,'G',0.000013,NULL,'15.9g',0.41,'IBm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,153.980291667,2.68728,0.089,NULL,60744026656,949125416,14830084,15.9),(69147,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69147,32.16,NULL,27,25102,NULL,NULL,NULL,'UGC 05539',NULL,'2015AstBu..70....1K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69148,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69148,37.16,0.46,270,25103,70,NULL,NULL,'2MASX J10155525-0020374',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000069,NULL,'17.1g',0.21,'E','Group member',NULL,NULL,NULL,1,153.980167,-0.34361,0.013,NULL,41212069362,643938583,10061540,17.1),(69149,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69149,37,0.54,252,25104,70,NULL,NULL,'2MASX J10155588-1725007',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000103,NULL,'16.88',0.3,NULL,NULL,NULL,NULL,NULL,1,153.982667,-17.41703,0.229,NULL,41163031632,643172369,10049568,16.88),(69150,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69150,36.93,0.33,243,25105,70,NULL,NULL,'2MASX J10155613+4310166',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000188,NULL,'16.1g',0.37,NULL,NULL,NULL,NULL,NULL,1,153.9837917,43.17142,0,NULL,64145403568,1002271930,15660498,16.1),(69151,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69151,37.84,0.46,370,25106,70,NULL,NULL,'2MASX J10155615+0234540',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00008,NULL,'17.3g',0.21,'BrClG',NULL,NULL,NULL,NULL,1,153.983917,2.58178,0.089,NULL,60744253282,949128957,14830139,17.3),(69152,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69152,38.2,0.46,437,25107,70,NULL,NULL,'SDSS J101557.08+335457.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,153.987833333,33.91592,0.033,NULL,64087869232,1001372956,15646452,18.4),(69153,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69153,38.13,0.46,422,25108,70,NULL,NULL,'SDSS J101558.42+151146.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,153.993416667,15.19622,0.093,NULL,60841244809,950644450,14853819,18.6),(69154,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69154,32.43,NULL,30.6,25109,NULL,NULL,NULL,'SDSS J101559.39+064821.3',NULL,'2015AstBu..70....1K',2015,1,0.03,'Haynes et al. (2011AJ....142..170H) give v = 1620 km/s.','G',0.000027,NULL,'21.8g',0.02,'Ir',NULL,NULL,NULL,NULL,1,153.9975,6.80594,0.021,NULL,60763834226,949434909,14834920,21.8),(69155,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69155,37.07,0.46,259,25110,70,NULL,NULL,'2MASX J10155947+0410530',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000184,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,153.9977917,4.18136,0.017,NULL,60796731851,949948935,14842952,16.7),(69156,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69156,36.58,0.46,207,25111,70,NULL,NULL,'2MASX J10155978+4900381',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000198,NULL,'15.8g',0.34,'E0',NULL,NULL,NULL,NULL,1,153.9989583,49.01069,0,NULL,63998083746,999970058,15624532,15.8),(69157,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69157,36,0.33,159,25112,70,NULL,NULL,'CGCG 036-076',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000157,NULL,'14.8g',0.74,'E0',NULL,NULL,NULL,NULL,1,154.000875,6.25144,0.005,NULL,60760826673,949387916,14834186,14.8),(69158,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69158,36.33,0.46,185,25113,70,NULL,NULL,'2MASX J10160087+0608320',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000156,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,154.0037083,6.14239,0.005,NULL,60760808169,949387627,14834181,16.6),(69159,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69159,38.1,0.46,417,25114,70,NULL,NULL,'2MASX J10160111+3106298',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,154.004667,31.10822,0.089,NULL,64077578816,1001212169,15643940,18.1),(69160,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69160,36.84,0.46,234,25115,70,NULL,NULL,'2MASX J10160159+1206485',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,154.006625,12.11333,0.097,NULL,60836557840,950571216,14852675,16.8),(69161,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69161,37.5,0.46,317,25116,70,NULL,NULL,'2MASX J10160281+2107482',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000183,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,154.011583333,21.13008,0.069,NULL,60935897868,952123404,14876928,17),(69162,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69162,36.71,0.33,220,25117,70,NULL,NULL,'MCG +10-15-046',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000184,NULL,'15.9g',0.39,'E0',NULL,NULL,NULL,NULL,1,154.014125,56.7925,0,NULL,61927088143,967610752,15118918,15.9),(69163,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69163,37.57,0.46,327,25118,70,NULL,NULL,'2MASX J10160548+4552566',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,154.0227083,45.8825,0,NULL,64127166837,1001986981,15656046,17.6),(69164,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69164,37.59,0.46,329,25119,70,NULL,NULL,'2MASX J10160616+1755032',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,154.025667,17.91758,0.097,NULL,60855391155,950865486,14857273,18.4),(69165,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69165,37.27,0.46,285,25120,70,NULL,NULL,'2MASX J10160816+0303094',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000078,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,154.034166667,3.05253,0.057,NULL,60796490728,949945167,14842893,17.1),(69166,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69166,33.39,0.47,47.7,25121,NULL,NULL,'H','NGC 3178',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000027,NULL,'13.49',0.7,'SA(rs)cd pec:  HII',NULL,NULL,NULL,NULL,1,154.0382083,-15.79128,0.165,NULL,41166187026,643221672,10050338,13.49),(69167,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69167,33.5,0.4,50.2,25121,NULL,NULL,'mean','NGC 3178',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69168,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69168,33.51,0.46,50.3,25121,NULL,NULL,'J','NGC 3178',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69169,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69169,33.58,0.45,52.1,25121,NULL,NULL,'K','NGC 3178',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69170,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69170,35.1,0.29,105,25122,NULL,NULL,NULL,'UGC 05534',NULL,'2009ApJS..182..474S',2009,1,1.33,NULL,'G',0.000033,NULL,'14.8g',0.49,'Sb',NULL,NULL,NULL,NULL,1,154.0427083,58.42703,0.013,NULL,61919833378,967497396,15117146,14.8),(69171,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69171,35.18,0.2,109,25122,74.4,NULL,NULL,'UGC 05534',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69172,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69172,35.28,0.27,114,25122,NULL,NULL,'Malmquist cor.','UGC 05534',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69173,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69173,38.07,0.46,411,25123,70,NULL,NULL,'2MASX J10161076+0655235',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,154.044917,6.92314,0.021,NULL,60763844181,949435065,14834922,17),(69174,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69174,37.69,0.46,344,25124,70,NULL,NULL,'SDSS J101611.57+344724.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000144,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,154.0482083,34.79028,0.005,NULL,64073303915,1001145373,15642896,18.3),(69175,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69175,35.47,0.33,124,25125,NULL,NULL,NULL,'ESO 436- G 007',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'15',0.6,'Sb             HII',NULL,NULL,NULL,NULL,1,154.0562083,-29.20369,0.221,NULL,41959150626,655611728,10243933,15),(69176,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69176,35.51,0.2,126,25125,74.4,NULL,NULL,'ESO 436- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69177,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69177,35.56,0.32,129,25125,NULL,NULL,'Malmquist cor.','ESO 436- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69178,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69178,37.38,0.46,299,25126,70,NULL,NULL,'2MASX J10161433+3554354',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,154.059958333,35.90992,0.013,NULL,64073873129,1001154267,15643035,16.9),(69179,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69179,38.16,0.46,428,25127,70,NULL,NULL,'SDSS J101614.74+024031.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000073,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,154.061417,2.67536,0.089,NULL,60744031950,949125499,14830085,18.3),(69180,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69180,38.08,0.46,413,25128,70,NULL,NULL,'SDSS J101615.25+170924.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,154.063583,17.15694,0.085,NULL,60839348608,950614822,14853356,18.4),(69181,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69181,36,0.33,159,25129,70,NULL,NULL,'CGCG 036-079',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000175,NULL,'15.7g',0.48,'E0',NULL,NULL,NULL,NULL,1,154.0675,6.24983,0.005,NULL,60761034416,949391162,14834236,15.7),(69182,'Maser','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69182,32.5,0.77,31,25130,NULL,NULL,NULL,'IC 2560',NULL,'2012PASJ...64..103Y',2012,1,3.2,NULL,'G',0.000007,NULL,'12.53',2,'(R\':)SB(r)bc;Sy2HII?','Group member, radial-velocity confirmed',NULL,NULL,'Sy 2',1,154.078,-33.56381,0.293,NULL,42007679920,656369998,10255781,12.53),(69183,'IRAS','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69183,32.91,0.8,38.2,25130,75,NULL,'HMCL, I','IC 2560',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69184,'IRAS','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69184,32.92,0.8,38.3,25130,75,NULL,'MAT, I','IC 2560',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69185,'Sosies','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69185,32.46,0.17,31,25130,NULL,NULL,NULL,'IC 2560',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69186,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69186,31.97,0.3,24.8,25130,92,NULL,'I, Assuming Hydra cluster m-M = 33.2 mag','IC 2560',NULL,'1993AJ....105...97S',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69187,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69187,32.1,0.3,26.3,25130,92,NULL,'H, Assuming Hydra cluster m-M = 33.2 mag','IC 2560',NULL,'1993AJ....105...97S',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69188,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69188,32.21,0.4,27.6,25130,75,NULL,'HMCL, I, raw','IC 2560',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69189,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69189,32.33,0.38,29.2,25130,NULL,NULL,NULL,'IC 2560',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69190,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69190,32.4,0.4,30.1,25130,75,NULL,'HMCL, I, inv','IC 2560',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69191,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69191,32.54,0.43,32.2,25130,75,NULL,'3.6 micron, color corrected','IC 2560',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69192,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69192,32.54,0.2,32.2,25130,74.4,NULL,NULL,'IC 2560',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69193,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69193,32.58,0.4,32.8,25130,75,NULL,'HMCL, I, cor','IC 2560',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69194,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69194,32.59,0.32,33,25130,85,NULL,'I, raw','IC 2560',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69195,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69195,32.6,NULL,33.1,25130,NULL,NULL,'I','IC 2560',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69196,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69196,32.61,0.43,33.2,25130,75,NULL,'3.6 micron, color + selection bias corrected','IC 2560',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69197,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69197,32.65,0.32,33.9,25130,85,NULL,'I, inv','IC 2560',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69198,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69198,32.71,0.43,34.8,25130,75,NULL,'MAT, I, raw','IC 2560',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69199,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69199,32.72,NULL,35,25130,NULL,NULL,'B','IC 2560',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69200,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69200,32.97,0.43,39.2,25130,75,NULL,'MAT, I, inv','IC 2560',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69201,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69201,33.02,0.43,40.2,25130,75,NULL,'MAT, I, cor','IC 2560',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69202,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69202,33.35,0.08,46.9,25130,NULL,NULL,NULL,'IC 2560',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69203,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69203,38.04,0.46,406,25131,70,NULL,NULL,'2MASX J10161886+0017304',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000086,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,154.078583,0.29175,0.029,NULL,60743862817,949122856,14830044,17.3),(69204,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69204,37.99,0.46,396,25132,70,NULL,NULL,'2MASX J10161943+2206532',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,154.080917,22.11489,0.069,NULL,60936513501,952133023,14877078,17.5),(69205,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69205,36.6,0.46,209,25133,70,NULL,NULL,'2MASX J10161988+0630165',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000174,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,154.082917,6.50458,0,NULL,60760946547,949389789,14834215,16.7),(69206,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69206,35.42,0.2,121,25134,74.4,NULL,NULL,'2MASX J10162092+2445232',NULL,'2013AJ....146...86T',2013,1,0.64,NULL,'G',0.000085,NULL,'15.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,154.0867083,24.75639,0.157,NULL,60465219967,944769061,14762016,15.8),(69207,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69207,37.03,0.46,254,25135,70,NULL,NULL,'2MASX J10162123+0558294',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000173,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,154.0884583,5.97497,0,NULL,60793453122,949897705,14842151,16.5),(69208,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69208,36.48,0.46,197,25136,70,NULL,NULL,'2MASX J10162145+3715293',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,154.089583,37.25806,0,NULL,64064461291,1001007207,15640737,16.9),(69209,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69209,38.12,0.23,421,25137,70,NULL,NULL,'2MASX J10162170+0851590',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.4g',0.24,'BrClG',NULL,NULL,NULL,NULL,1,154.090417,8.86619,0.065,NULL,60765589891,949462342,14835349,17.4),(69210,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69210,30.62,0.2,13.3,25138,74.4,NULL,NULL,'UGC 05540',NULL,'2013AJ....146...86T',2013,1,1.74,NULL,'G',0.000013,NULL,'14.5g',0.43,'Sc','Isolated galaxy',NULL,NULL,NULL,1,154.090625,37.78019,0,NULL,64064180097,1001002814,15640668,14.5),(69211,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69211,31.11,0.49,16.7,25138,75,NULL,'IR','UGC 05540',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69212,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69212,36.28,0.42,181,25139,NULL,NULL,'Malmquist cor.','2MASXi J1016228-010425',NULL,'2009ApJS..182..474S',2009,1,0.44,NULL,'G',0.00003,NULL,'17.5g',0.14,'Sc',NULL,NULL,NULL,NULL,1,154.0952083,-1.07336,0.053,NULL,41212282654,643941916,10061592,17.5),(69213,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69213,36.38,0.4,188,25139,NULL,NULL,NULL,'2MASXi J1016228-010425',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69214,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69214,36.42,0.2,192,25139,74.4,NULL,NULL,'2MASXi J1016228-010425',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69215,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69215,35.61,0.27,132,25140,70,NULL,NULL,'NGC 3168',NULL,'2015arXiv151105856S',2015,1,0.98,NULL,'G',0.00015,NULL,'14.2g',0.92,'E','in a pair',NULL,NULL,NULL,1,154.095875,60.23494,0,NULL,61921796469,967528069,15117626,14.2),(69216,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69216,36.19,0.49,173,25141,70,NULL,NULL,'2MASX J10162363-4336578',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000147,NULL,'15.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,154.0985,-43.61606,0.605,NULL,42138545847,658414778,10287730,15),(69217,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69217,35.79,0.46,144,25142,70,NULL,NULL,'CGCG 036-081',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000175,NULL,'15.4g',0.5,'E',NULL,NULL,NULL,NULL,1,154.100833,5.69539,0.025,NULL,60793487863,949898247,14842160,15.4),(69218,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69218,38.12,0.23,421,25143,70,NULL,NULL,'SDSS J101624.21+085531.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00014,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,154.100916667,8.92556,0.065,NULL,60765619942,949462811,14835356,18.7),(69219,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69219,37.88,0.33,376,25144,70,NULL,NULL,'2MASX J10162469+5507034',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000139,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,154.102875,55.11744,0,NULL,61904524100,967258189,15113409,17.9),(69220,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69220,37.64,0.86,337,25145,70,NULL,NULL,'2MASX J10162514-1058546',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.3I',0.4,NULL,NULL,NULL,NULL,NULL,1,154.104833,-10.98183,0.197,NULL,41275794151,644934283,10077098,14.3),(69221,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69221,37.33,0.46,292,25146,70,NULL,NULL,'2MASX J10162556+1255075',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,154.106583,12.91867,0.085,NULL,60838261326,950597833,14853091,17.6),(69222,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69222,38.22,0.33,440,25147,70,NULL,NULL,'2MASX J10162625+0134104',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000113,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,154.109375,1.56964,0.041,NULL,60744749020,949136703,14830260,17.8),(69223,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69223,36.96,0.27,247,25148,70,NULL,NULL,'2MASX J10162635-0014348',NULL,'2015arXiv151105856S',2015,1,0.25,'2dF final data release has z = 0.03450: +- 0.00041.','G',0.000088,NULL,'17.3g',0.23,'NLAGN',NULL,NULL,NULL,NULL,1,154.109917,-0.243,0.013,NULL,41212107095,643939173,10061549,17.3),(69224,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69224,38.22,0.33,440,25149,70,NULL,NULL,'2MASX J10162719+0132384',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00007,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,154.1132917,1.54408,0.041,NULL,60744745415,949136647,14830260,17.8),(69225,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69225,38.35,0.46,469,25150,70,NULL,NULL,'SDSS J101627.45+035238.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,154.114416667,3.87747,0.029,NULL,60794944222,949921003,14842515,18.5),(69226,'Tully est','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69226,32.17,0.8,27.1,25151,75,NULL,'B','UGCA 208',NULL,'1988NBGC.C....0000T',1988,1,0.52,NULL,'G',0.000009,NULL,'15.0g',0.44,'Pair      SB nuc.',NULL,NULL,NULL,'Starburst',1,154.117583333,45.32158,0,NULL,64144218149,1002253408,15660209,15),(69227,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69227,36.38,0.33,189,25152,70,NULL,NULL,'2MASX J10162833+0335024',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000102,NULL,'15.8g',0.41,'SF',NULL,NULL,NULL,NULL,1,154.118125,3.58408,0.037,NULL,60794495184,949913987,14842406,15.8),(69228,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69228,38.12,0.23,421,25153,70,NULL,NULL,'2MASX J10162844+0900060',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000145,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,154.11875,9.00169,0.061,NULL,60765607252,949462613,14835353,17.8),(69229,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69229,38.02,0.27,402,25154,70,NULL,NULL,'2MASX J10162918+1351585',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000185,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,154.121708333,13.86633,0.113,NULL,60835542934,950555358,14852427,16.9),(69230,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69230,39.43,0.46,768,25155,70,NULL,NULL,'SDSS J101629.28-004327.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000089,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,154.122,-0.72433,0.025,NULL,41211950997,643936734,10061511,18.5),(69231,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69231,38.91,0.46,606,25156,70,NULL,NULL,'SDSS J101631.24+075725.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000192,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,154.130166667,7.957,0.069,NULL,60767027862,949484810,14835700,18.1),(69232,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69232,38.44,0.33,488,25157,70,NULL,NULL,'SDSS J101631.97+081444.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000122,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,154.133208333,8.24561,0.045,NULL,60766956271,949483691,14835682,18.5),(69233,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69233,36.04,0.46,161,25158,70,NULL,NULL,'2MASX J10163259+0132024',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000097,NULL,'16.6g',0.29,'NLAGN',NULL,NULL,NULL,'Sy 2',1,154.13575,1.53397,0.041,NULL,60744568589,949133884,14830216,16.6),(69234,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69234,38.12,0.23,421,25159,70,NULL,NULL,'2MASX J10163323+0850320',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.001078,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,154.138833,8.84228,0.065,NULL,60765753667,949464901,14835389,17.4),(69235,'Tully est','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69235,31.62,0.8,21.1,25160,75,NULL,'B','NGC 3177',NULL,'1988NBGC.C....0000T',1988,1,1.34,NULL,'G',0.000017,NULL,'13.0g',1.07,'SA(rs)b        HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,154.14225,21.12306,0.069,NULL,60949535378,952336490,14880257,13),(69236,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69236,31.91,0.45,24.1,25160,NULL,NULL,'K','NGC 3177',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69237,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69237,32,0.47,25.1,25160,NULL,NULL,'H','NGC 3177',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69238,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69238,32.05,0.4,25.8,25160,NULL,NULL,'mean','NGC 3177',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69239,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69239,32.09,0.46,26.2,25160,NULL,NULL,'J','NGC 3177',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69240,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69240,36.68,0.55,217,25161,70,NULL,NULL,'2MASX J10163438-1715487',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000103,NULL,'14.7I',0.2,NULL,NULL,NULL,NULL,NULL,1,154.1432083,-17.26347,0.229,NULL,41163781063,643184079,10049751,14.7),(69241,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69241,35.84,0.46,148,25162,70,NULL,NULL,'CGCG 064-098',NULL,'2015arXiv151105856S',2015,1,0.94,NULL,'G',0.0001,NULL,'14.8g',0.55,'E','Pair member (points to parent)',NULL,NULL,NULL,1,154.1454583,12.65178,0.085,NULL,60837745069,950589766,14852965,14.8),(69242,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69242,37.5,0.46,317,25163,70,NULL,NULL,'SDSS J101638.70+091946.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000132,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,154.1612917,9.3295,0.065,NULL,60751788589,949246696,14831979,17.8),(69243,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69243,38.49,0.46,498,25164,70,NULL,NULL,'2MASX J10163942+3143251',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,154.1642917,31.72375,0.057,NULL,64077550665,1001211729,15643933,17.9),(69244,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69244,36.03,0.55,161,25165,70,NULL,NULL,'2MASX J10163974-1059586',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00013,NULL,'13.9I',0.3,'E',NULL,NULL,NULL,NULL,1,154.165667,-10.99958,0.197,NULL,41275774685,644933979,10077093,13.9),(69245,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69245,35.17,0.46,108,25166,70,NULL,NULL,'UGC 05547',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.000484,NULL,'14.57',0.7,'S0:',NULL,NULL,NULL,NULL,1,154.168041667,16.97156,0.093,NULL,60839411722,950615808,14853372,14.57),(69246,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69246,38.44,0.33,488,25167,70,NULL,NULL,'SDSS J101640.78+081550.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000142,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,154.1699583,8.26417,0.045,NULL,60766956819,949483700,14835682,18.3),(69247,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69247,36.9,0.46,240,25168,70,NULL,NULL,'2MASX J10164098+1617416',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,154.170916667,16.29481,0.097,NULL,60841870519,950654226,14853972,16.4),(69248,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69248,37.7,0.46,347,25169,70,NULL,NULL,'2MASX J10164145+2934031',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00014,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,154.1727083,29.56753,0.077,NULL,64035265824,1000551028,15633609,17.4),(69249,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69249,38.1,0.46,417,25170,70,NULL,NULL,'2MASX J10164458+3321101',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000159,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,154.185875,33.35294,0.013,NULL,64088327136,1001380111,15646564,18.3),(69250,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69250,36.83,0.33,232,25171,70,NULL,NULL,'2MASX J10164567+5128114',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,154.1905,51.46989,0,NULL,64003660162,1000057190,15625893,17),(69251,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69251,37.55,0.46,324,25172,70,NULL,NULL,'2MASX J10164594+4219339',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000185,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,154.191583333,42.32619,0,NULL,64144580123,1002259064,15660297,16.6),(69252,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69252,37.63,0.46,336,25173,70,NULL,NULL,'2MASX J10164643-0103396',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000083,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,154.193416667,-1.06089,0.049,NULL,41211884964,643935702,10061495,17.4),(69253,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69253,37.28,0.46,286,25174,70,NULL,NULL,'SDSS J101646.54+195602.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000139,NULL,'18.2g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,154.1939583,19.93392,0.061,NULL,60810609502,950165773,14846340,18.2),(69254,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69254,37.72,0.46,350,25175,70,NULL,NULL,'2MASX J10164693+4342109',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000172,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,154.195583333,43.70317,0,NULL,64145248199,1002269503,15660460,17.7),(69255,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69255,37.96,0.46,390,25176,70,NULL,NULL,'SDSS J101647.55+085353.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,154.198125,8.89833,0.065,NULL,60765738397,949464662,14835385,18),(69256,'GRB','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69256,47.53,0.66,7560,25177,69.7,NULL,'Fiducial','GRB 050319',3.24,'2009MNRAS.400..775C',2009,1,NULL,NULL,'G',NULL,NULL,'17.5V',NULL,'Swift',NULL,NULL,NULL,NULL,1,154.199583,43.54828,0,NULL,64145241993,1002269406,15660459,17.5),(69257,'GRB','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69257,47.73,0.93,8290,25177,69.7,NULL,'Calibrated','GRB 050319',3.24,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69258,'GRB','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69258,48.03,1.04,9520,25177,72,NULL,NULL,'GRB 050319',3.24,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69259,'GRB','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69259,48.46,1.24,11600,25177,NULL,NULL,NULL,'GRB 050319',3.24,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69260,'GRB','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69260,48.82,1.25,13700,25177,70,NULL,NULL,'GRB 050319',3.24,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69261,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69261,36.34,0.46,185,25178,70,NULL,NULL,'2MASX J10164810+1050470',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000176,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,154.200333333,10.84647,0.097,NULL,60871387020,951115422,14861178,16.7),(69262,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69262,35.49,0.46,125,25179,70,NULL,NULL,'2MASX J10164819+0818210',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000162,NULL,'16.0g',0.4,'S0',NULL,NULL,NULL,NULL,1,154.200708333,8.30597,0.045,NULL,60766097622,949470275,14835473,16),(69263,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69263,36.38,0.33,189,25180,70,NULL,NULL,'2MASX J10164850+0349291',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000189,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,154.202,3.82481,0.021,NULL,60795204111,949925064,14842579,16.4),(69264,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69264,38.11,0.46,419,25181,70,NULL,NULL,'2MASX J10164871-0051016',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000091,NULL,'16.6g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,154.203,-0.85039,0.025,NULL,41211869199,643935456,10061491,16.6),(69265,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69265,35.61,0.27,132,25182,70,NULL,NULL,'SBS 1013+605',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000165,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,154.2057917,60.25603,0,NULL,61921582262,967524722,15117573,16.8),(69266,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69266,36.98,0.55,249,25183,NULL,NULL,'Malmquist cor.','2MASX J10165276-0123056',NULL,'2009ApJS..182..474S',2009,1,0.49,NULL,'G',0.000033,NULL,'17.00',0.37,'S0/a','Group member',NULL,NULL,NULL,1,154.219917,-1.38483,0.057,NULL,41212247114,643941361,10061583,17),(69267,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69267,37.38,0.46,299,25183,NULL,NULL,NULL,'2MASX J10165276-0123056',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69268,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69268,37.42,0.2,305,25183,74.4,NULL,NULL,'2MASX J10165276-0123056',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69269,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2001ie',NULL,69269,34.89,0.17,92.2,25184,74.2,NULL,'SALT 2','UGC 05542',0.030738,'2010ApJ...716..712A',2010,1,0.85,NULL,'G',0.000157,NULL,'14.5g',0.71,'E:','in a pair',NULL,NULL,NULL,1,154.221083333,60.28489,0,NULL,61921590612,967524853,15117575,14.5),(69270,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2001ie','R',69270,35.44,0.15,122,25184,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 05542',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69271,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2001ie',NULL,69271,35.47,0.1,124,25184,74.4,NULL,NULL,'UGC 05542',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69272,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2001ie','R',69272,35.49,0.12,125,25184,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 05542',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69273,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2001ie',NULL,69273,35.73,0.16,136,25184,70,NULL,'SALT 2','UGC 05542',0.030738,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69274,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2001ie',NULL,69274,35.76,0.21,138,25184,65,NULL,'MLCS31','UGC 05542',0.030738,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69275,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2001ie',NULL,69275,35.78,0.18,139,25184,65,NULL,'MLCS17','UGC 05542',0.030738,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69276,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2001ie',NULL,69276,35.8,0.2,140,25184,65,NULL,'SALT2','UGC 05542',0.030738,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69277,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69277,35.61,0.27,132,25184,70,NULL,NULL,'UGC 05542',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69278,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 1997bq',NULL,69278,32.41,0.31,30.1,25185,74.2,NULL,'SALT 2','NGC 3147',0.00941,'2010ApJ...716..712A',2010,1,3.9,NULL,'G',0.000003,NULL,'11.43',3.5,'SA(rs)bc;HII   Sy2','Group member, radial-velocity confirmed',NULL,NULL,'unobscured Seyfert 2',1,154.2235417,73.40075,0.049,NULL,61378477925,959038717,14984979,11.43),(69279,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 1997bq',NULL,69279,32.94,0.02,38.4,25185,72,NULL,NULL,'NGC 3147',0.00941,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69280,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 1997bq',NULL,69280,32.97,0.09,39.3,25185,74.4,NULL,NULL,'NGC 3147',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69281,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 1997bq',NULL,69281,33.06,0.21,40.5,25185,72,NULL,NULL,'NGC 3147',0.00941,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69282,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 1997bq',NULL,69282,33.06,0.17,40.9,25185,70.8,NULL,NULL,'NGC 3147',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69283,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2008fv',NULL,69283,33.2,0.1,43.7,25185,NULL,NULL,NULL,'NGC 3147',NULL,'2012A&A...537A..57B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69284,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 1997bq',NULL,69284,33.27,0.35,44.7,25185,70,NULL,'SALT','NGC 3147',0.00941,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69285,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 1997bq',NULL,69285,33.46,0.11,48.2,25185,65,NULL,'MLCS2k2','NGC 3147',0.00941,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69286,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 1997bq',NULL,69286,33.42,0.14,48.3,25185,60,NULL,NULL,'NGC 3147',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69287,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 1972H',NULL,69287,33.55,0.4,51.3,25185,60,NULL,'M(V) = -19.47 mag','NGC 3147',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69288,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 1972H',NULL,69288,33.71,0.4,55.2,25185,60,NULL,'M(B) = -19.48 mag','NGC 3147',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69289,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 1972H','R',69289,34,NULL,63.1,25185,NULL,NULL,'Photographic','NGC 3147',NULL,'1988SSRv...48....1R',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69290,'Tully est','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69290,33.06,0.8,40.9,25185,75,NULL,'B','NGC 3147',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69291,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69291,33.16,NULL,42.9,25185,NULL,NULL,'LEDA [April 2006]','NGC 3147',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69292,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69292,36.71,0.33,220,25186,70,NULL,NULL,'2MASX J10165426+5646446',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000207,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,154.226083,56.77903,0,NULL,61928125620,967626962,15119171,16.3),(69293,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69293,35.48,0.49,125,25187,70,NULL,NULL,'MCG -01-26-038',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'15.10',0.3,NULL,NULL,NULL,NULL,NULL,1,154.2272083,-5.87058,0.085,NULL,41261592213,644712378,10073630,15.1),(69294,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69294,37.47,0.46,312,25188,70,NULL,NULL,'2MASX J10165467+4640549',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000144,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,154.2279583,46.68203,0,NULL,64127504389,1001992256,15656129,17.4),(69295,'Sosies','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69295,31.48,0.26,19.8,25189,NULL,NULL,NULL,'ESO 213- G 011',NULL,'2002A&A...393...57T',2002,1,3.5,NULL,'G',0.00001,NULL,'12.3',2.2,'SA(s)c',NULL,NULL,NULL,NULL,1,154.231333333,-48.88106,NULL,NULL,42034244170,656785065,10262266,12.3),(69296,'Tully est','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69296,32.73,0.8,35.1,25189,75,NULL,NULL,'ESO 213- G 011',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69297,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69297,32.22,0.2,27.8,25189,74.4,NULL,NULL,'ESO 213- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69298,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69298,32.27,0.43,28.4,25189,75,NULL,'3.6 micron, color corrected','ESO 213- G 011',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69299,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69299,32.27,0.43,28.5,25189,75,NULL,'3.6 micron, color + selection bias corrected','ESO 213- G 011',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69300,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69300,32.82,0.46,36.6,25189,NULL,NULL,'J','ESO 213- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69301,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69301,32.85,0.45,37.2,25189,NULL,NULL,'K','ESO 213- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69302,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69302,32.88,0.47,37.7,25189,NULL,NULL,'H','ESO 213- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69303,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69303,33.05,0.4,40.7,25189,NULL,NULL,'mean','ESO 213- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69304,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69304,36.72,0.46,221,25190,70,NULL,NULL,'2MASX J10165552+5403077',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000194,NULL,'15.9g',0.37,'E0',NULL,NULL,NULL,NULL,1,154.2312917,54.05208,0,NULL,61905799996,967278124,15113720,15.9),(69305,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69305,37.78,0.46,360,25191,70,NULL,NULL,'SDSS J101656.90+034353.3',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000179,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,154.237083,3.73147,0.021,NULL,60794524024,949914437,14842413,17.5),(69306,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69306,37.41,0.46,304,25192,70,NULL,NULL,'2MASX J10165704+0324511',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000183,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,154.2377917,3.41422,0.057,NULL,60794566781,949915105,14842423,16.8),(69307,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69307,34.14,0.46,67.2,25193,70,NULL,NULL,'CGCG 064-100',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000143,NULL,'15.3g',0.41,'S0',NULL,NULL,NULL,NULL,1,154.241833,8.65447,0.061,NULL,60765652354,949463318,14835364,15.3),(69308,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69308,38.12,0.23,421,25194,70,NULL,NULL,'2MASX J10165833+0844357',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000187,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,154.243041667,8.74317,0.061,NULL,60765732484,949464570,14835383,17.6),(69309,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69309,37.25,0.46,281,25195,70,NULL,NULL,'MCG +10-15-056',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000182,NULL,'15.9g',0.44,'E0',NULL,NULL,NULL,NULL,1,154.243333,61.54794,0,NULL,61945159140,967893111,15123329,15.9),(69310,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69310,38.12,0.33,420,25196,70,NULL,NULL,'SDSS J101701.88+035114.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000132,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,154.257875,3.85406,0.021,NULL,60795251695,949925807,14842590,18.8),(69311,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69311,36.33,0.46,184,25197,70,NULL,NULL,'2MASX J10170219+0003283',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000101,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,154.259125,0.05792,0.029,NULL,60743122627,949111291,14829863,16.5),(69312,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69312,36.81,0.33,230,25198,70,NULL,NULL,'2MASX J10170479+3254362',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,154.270125,32.91019,0.037,NULL,64088196576,1001378071,15646532,16.6),(69313,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69313,36.29,0.46,181,25199,70,NULL,NULL,'2MASX J10170544+0158031',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000071,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,154.272625,1.96761,0.101,NULL,60744640736,949135011,14830234,16.6),(69314,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69314,38.19,0.46,434,25200,70,NULL,NULL,'2MASX J10170687+4641434',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,154.2785417,46.69536,0,NULL,64127378221,1001990284,15656098,17.7),(69315,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69315,37.46,0.33,310,25201,70,NULL,NULL,'SDSS J101707.56+263501.4',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000168,NULL,'16.4g',0.37,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,154.281541667,26.58375,0.069,NULL,64025135889,1000392748,15631136,16.4),(69316,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69316,37.09,0.46,261,25202,70,NULL,NULL,'2MASX J10170789+6520140',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,154.2829583,65.33728,0.097,NULL,62124993461,970703022,15167234,17.3),(69317,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69317,38.37,0.33,473,25203,70,NULL,NULL,'2MASX J10170797+0817287',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000175,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,154.28325,8.29139,0.045,NULL,60766984389,949484131,14835689,16.7),(69318,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69318,36.27,0.46,179,25204,70,NULL,NULL,'2MASX J10170818+2913410',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000117,NULL,'16.4g',0.27,'E',NULL,NULL,NULL,NULL,1,154.2840417,29.22814,0.089,NULL,64038371546,1000599555,15634368,16.4),(69319,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69319,38.12,0.33,420,25205,70,NULL,NULL,'2MASX J10170836+0350065',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00019,NULL,'16.6g',0.36,'BrClG',NULL,NULL,NULL,NULL,1,154.28475,3.83522,0.021,NULL,60795252325,949925817,14842590,16.6),(69320,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69320,38.01,0.46,400,25206,70,NULL,NULL,'SDSS J101709.83+102409.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,154.291,10.40269,0.053,NULL,60751877487,949248085,14832001,18.3),(69321,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69321,38.02,0.27,402,25207,70,NULL,NULL,'SDSS J101710.25+134707.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,154.29275,13.78542,0.113,NULL,60835748264,950558566,14852477,18.2),(69322,'Tully est','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69322,31.54,0.8,20.3,25208,75,NULL,NULL,'IC 0600',NULL,'1988NBGC.C....0000T',1988,1,2.3,'Noted as possibly interacting in VV Atlas and in MCG.','G',0.000017,NULL,'13.68',1.2,'SB(s)dm','Group member of poor cluster',NULL,NULL,NULL,1,154.2954583,-3.49778,0.057,NULL,41260651734,644697683,10073401,13.68),(69323,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69323,31.91,0.43,24.1,25208,75,NULL,'3.6 micron, color + selection bias corrected','IC 0600',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69324,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69324,38.37,0.33,473,25209,70,NULL,NULL,'SDSS J101711.18+081752.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000167,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,154.296625,8.29794,0.045,NULL,60766992390,949484256,14835691,18.3),(69325,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69325,37.46,0.33,310,25210,70,NULL,NULL,'2MASX J10171123+2636140',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,154.297,26.60386,0.069,NULL,64025136340,1000392755,15631136,17.7),(69326,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69326,37.99,0.46,397,25211,70,NULL,NULL,'2MASX J10171132+0638017',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,154.2972083,6.63392,0,NULL,60760924501,949389445,14834210,17.2),(69327,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69327,37.1,0.46,263,25212,70,NULL,NULL,'2MASX J10171178+2409519',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000161,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,154.2992083,24.1645,0.073,NULL,60466007770,944781371,14762208,16.8),(69328,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69328,31.25,NULL,17.8,25213,NULL,NULL,NULL,'UGC 05551',NULL,'2015AstBu..70....1K',2015,1,0.9,NULL,'G',0.000013,NULL,'17.',0.7,'Im:','Group member',NULL,NULL,NULL,1,154.2992917,4.33078,0.017,NULL,60795118070,949923719,14842558,17),(69329,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69329,35.85,0.61,148,25214,70,NULL,NULL,'2MASX J10171182-0757412',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.48',0.4,NULL,NULL,NULL,NULL,NULL,1,154.299416667,-7.96144,0.121,NULL,41255158499,644611851,10072060,16.48),(69330,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69330,38.02,0.27,402,25215,70,NULL,NULL,'SDSS J101712.32+135109.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,154.301375,13.85278,0.105,NULL,60835754813,950558668,14852479,18.7),(69331,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69331,37.66,0.33,341,25216,70,NULL,NULL,'2MASX J10171353+0616027',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,154.306417,6.26742,0.005,NULL,60760879555,949388743,14834199,17.3),(69332,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69332,37.25,0.33,282,25217,70,NULL,NULL,'2MASX J10171425+4337064',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,154.3095,43.61847,0,NULL,64145233686,1002269276,15660457,17.2),(69333,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69333,37.16,0.46,271,25218,70,NULL,NULL,'2MASX J10171497+1503446',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',NULL,NULL,'17.12',0.42,NULL,NULL,NULL,NULL,NULL,1,154.312416667,15.06231,0.101,NULL,60849783370,950777865,14855904,17.12),(69334,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69334,36.68,0.63,217,25219,70,NULL,NULL,'2MASX J10171552-0753502',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.52',0.6,NULL,NULL,NULL,NULL,NULL,1,154.31475,-7.89758,0.121,NULL,41254956927,644608701,10072010,16.52),(69335,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69335,38.12,0.23,421,25220,70,NULL,NULL,'2MASX J10171769+0840576',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000179,NULL,'16.8g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,154.323875,8.68272,0.061,NULL,60765716484,949464320,14835380,16.8),(69336,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69336,36.09,0.6,165,25221,70,NULL,NULL,'2MASX J10171808-2814469',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,154.325375,-28.24642,0.209,NULL,41958937816,655608403,10243881,14.6),(69337,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69337,39.31,0.46,727,25222,70,NULL,NULL,'2MASX J10171818+3548332',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,154.32575,35.80922,0.013,NULL,64074017356,1001156521,15643070,17.6),(69338,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69338,37.95,0.46,389,25223,70,NULL,NULL,'SDSS J101718.22+162427.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,154.3259583,16.40764,0.097,NULL,60842022642,950656603,14854009,18.4),(69339,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69339,37.83,0.46,368,25224,70,NULL,NULL,'SDSS J101719.43+311014.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,154.331,31.17072,0.089,NULL,64077496219,1001210878,15643919,18.1),(69340,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69340,36.58,0.64,207,25225,70,NULL,NULL,'2MASX J10171994-0219458',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.000093,NULL,'16.44',0.49,NULL,NULL,NULL,NULL,NULL,1,154.333166667,-2.32947,0,NULL,41217560142,644024377,10062880,16.44),(69341,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69341,38.02,0.46,401,25226,70,NULL,NULL,'2MASX J10172026-0036028',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000077,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,154.334375,-0.60072,0.025,NULL,41212048809,643938262,10061535,17.6),(69342,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69342,37.69,0.46,345,25227,70,NULL,NULL,'2MASX J10172499+5054156',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000172,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,154.354,50.90425,0,NULL,64004259784,1000066559,15626039,16.5),(69343,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69343,38.12,0.23,421,25228,70,NULL,NULL,'2MASX J10172533+0841592',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000185,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,154.355583,8.69986,0.061,NULL,60766044945,949469452,14835460,17.8),(69344,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69344,38,0.46,399,25229,70,NULL,NULL,'SDSS J101725.40-004627.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000068,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,154.355833,-0.77425,0.025,NULL,41211752106,643933626,10061462,18.5),(69345,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69345,34.86,0.49,93.6,25230,75,NULL,'IR','UGC 05552',NULL,'2011yCatp016004901K',2011,1,1.5,'The 2MASS position applies to the southwestern arm.','G',0.000133,NULL,'14.89',0.3,'Sbc',NULL,NULL,NULL,NULL,1,154.358333,17.09708,0.085,NULL,60839273855,950613653,14853338,14.89),(69346,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69346,35.12,0.43,106,25230,NULL,NULL,'Malmquist cor.','UGC 05552',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69347,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69347,35.21,0.41,110,25230,NULL,NULL,NULL,'UGC 05552',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69348,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69348,35.23,0.2,111,25230,74.4,NULL,NULL,'UGC 05552',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69349,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69349,35.45,0.4,123,25230,NULL,NULL,'mean','UGC 05552',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69350,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69350,35.66,0.47,136,25230,NULL,NULL,'H','UGC 05552',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69351,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69351,37.22,0.46,278,25231,70,NULL,NULL,'2MASX J10172603+3921057',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00009,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,154.358667,39.35147,0,NULL,64096976588,1001515259,15648675,16.2),(69352,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69352,37.66,0.33,341,25232,70,NULL,NULL,'2MASX J10172713+0613502',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00016,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,154.3630417,6.23061,0,NULL,60760907873,949389185,14834206,17),(69353,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69353,38.34,0.46,466,25233,70,NULL,NULL,'SDSS J101727.59+043423.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000147,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,154.365,4.57331,0.009,NULL,60795489350,949929521,14842648,18.5),(69354,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69354,35.17,0.49,108,25234,75,NULL,'IR','KUG 1014+324',NULL,'2011yCatp016004901K',2011,1,0.78,NULL,'G',0.000017,NULL,'17.14',0.11,'Sdm',NULL,NULL,NULL,NULL,1,154.3695417,32.18325,0.069,NULL,64085386068,1001334157,15645846,17.14),(69355,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69355,35.63,NULL,133,25234,NULL,NULL,'Dipole + Quadrupole + Octopole','KUG 1014+324',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69356,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69356,35.65,NULL,135,25234,NULL,NULL,'Dipole + Quadrupole','KUG 1014+324',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69357,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69357,35.67,NULL,136,25234,NULL,NULL,'Dipole','KUG 1014+324',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69358,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69358,35.67,NULL,136,25234,NULL,NULL,NULL,'KUG 1014+324',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69359,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69359,36.78,0.46,227,25235,70,NULL,NULL,'2MASX J10172882+0600424',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000179,NULL,'15.9g',0.35,'E0',NULL,NULL,NULL,NULL,1,154.369916667,6.01197,0.005,NULL,60793422491,949897226,14842144,15.9),(69360,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69360,37.25,0.33,282,25236,70,NULL,NULL,'2MASX J10172935+4327085',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000203,NULL,'16.1g',0.41,NULL,NULL,NULL,NULL,NULL,1,154.3725,43.45231,0,NULL,64145358049,1002271219,15660487,16.1),(69361,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69361,38.01,0.46,400,25237,70,NULL,NULL,'2MASX J10173054+1927108',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000182,NULL,'17.0g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,154.377417,19.45286,0.065,NULL,60939627169,952181674,14877838,17),(69362,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69362,37.38,0.33,299,25238,70,NULL,NULL,'2MASX J10173192-0017358',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000079,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,154.382917,-0.29317,0.037,NULL,41211335723,643927120,10061361,17.7),(69363,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69363,38,0.46,398,25239,70,NULL,NULL,'2MASX J10173252-0016198',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000081,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,154.3854583,-0.27222,0.037,NULL,41211392216,643928003,10061375,17.2),(69364,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69364,36.81,0.33,230,25240,70,NULL,NULL,'2MASX J10173326+3258329',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,154.3885417,32.97575,0.025,NULL,64088423852,1001381622,15646587,16.7),(69365,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69365,37.2,0.46,275,25241,70,NULL,NULL,'2MASX J10173604+4100457',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,154.4002083,41.01258,0,NULL,64095117894,1001486217,15648222,17.3),(69366,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69366,36.9,0.46,240,25242,70,NULL,NULL,'2MASX J10173671+1902178',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000185,NULL,'16.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,154.402917,19.03831,0.073,NULL,60939686679,952182604,14877853,16.9),(69367,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69367,37.61,0.46,333,25243,70,NULL,NULL,'2MASX J10173685+0008265',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000074,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,154.4035417,0.14056,0.029,NULL,60743178765,949112168,14829877,17.7),(69368,'Ring Diameter','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69368,31.2,0.76,17,25244,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3185',NULL,'1981ApJS...45..541P',1981,1,2.16,NULL,'G',0.000005,NULL,'12.9g',1.1,'(R)SB(r)a      Sy2','in a radial-velocity based grouping',NULL,NULL,'Sy 2',1,154.4107083,21.68825,0.093,NULL,60936026972,952125421,14876959,12.9),(69369,'Ring Diameter','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69369,31.4,0.6,19,25244,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3185',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69370,'Tully est','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69370,31.64,0.8,21.3,25244,75,NULL,'B','NGC 3185',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69371,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69371,30.13,0.69,10.6,25244,100,NULL,'mid-IR','NGC 3185',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69372,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69372,31.54,0.57,20.3,25244,NULL,NULL,'Malmquist cor.','NGC 3185',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69373,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69373,31.77,0.4,22.6,25244,NULL,NULL,NULL,'NGC 3185',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69374,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69374,31.88,0.49,23.8,25244,NULL,NULL,NULL,'NGC 3185',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69375,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69375,31.99,0.43,25,25244,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3185',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69376,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69376,32,0.2,25.1,25244,74.4,NULL,NULL,'NGC 3185',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69377,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69377,32.05,0.4,25.8,25244,NULL,NULL,'mean','NGC 3185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69378,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69378,32.06,0.43,25.8,25244,75,NULL,'3.6 micron, color corrected','NGC 3185',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69379,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69379,32.21,0.45,27.7,25244,NULL,NULL,'K','NGC 3185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69380,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69380,32.24,0.47,28.1,25244,NULL,NULL,'H','NGC 3185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69381,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69381,32.25,0.46,28.2,25244,NULL,NULL,'J','NGC 3185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69382,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69382,34.47,NULL,78.3,25245,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05550',NULL,'2010Ap&SS.325..163P',2010,1,1.13,NULL,'G',0.00001,NULL,'16.6g',0.14,'Sdm',NULL,NULL,NULL,NULL,1,154.4122083,64.39169,0.029,NULL,62113307948,970520436,15164381,16.6),(69383,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69383,34.49,NULL,78.9,25245,NULL,NULL,'Dipole + Quadrupole','UGC 05550',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69384,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69384,34.5,NULL,79.5,25245,NULL,NULL,'Dipole','UGC 05550',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69385,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69385,34.55,NULL,81.2,25245,NULL,NULL,NULL,'UGC 05550',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69386,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69386,34.75,0.49,89,25245,75,NULL,'IR','UGC 05550',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69387,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69387,36.15,0.64,170,25246,70,NULL,NULL,'2MASX J10173939-0211274',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'17.26',0.34,NULL,NULL,NULL,NULL,NULL,1,154.414125,-2.19103,0.061,NULL,41218028398,644031693,10062995,17.26),(69388,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69388,33.15,0.4,42.6,25247,NULL,NULL,'mean','NGC 3155',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.00001,NULL,'13.85',1,'S?','X-ray-bright group member',NULL,NULL,NULL,1,154.4160417,74.34739,0.049,NULL,61384289807,959129528,14986398,13.85),(69389,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69389,33.41,0.43,48,25247,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3155',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69390,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69390,33.45,0.43,49.1,25247,75,NULL,'3.6 micron, color corrected','NGC 3155',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69391,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69391,33.54,0.2,51.1,25247,74.4,NULL,NULL,'NGC 3155',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69392,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69392,33.55,0.4,51.3,25247,NULL,NULL,'Malmquist cor.','NGC 3155',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69393,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69393,33.69,0.37,54.7,25247,NULL,NULL,NULL,'NGC 3155',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69394,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69394,33.78,0.47,57,25247,NULL,NULL,'H','NGC 3155',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69395,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69395,36,0.67,159,25248,70,NULL,NULL,'2MASX J10174011-1304482',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,154.417125,-13.08008,0.345,NULL,41158704374,643104755,10048511,14.3),(69396,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69396,37.09,0.46,262,25249,70,NULL,NULL,'2MASX J10174603+1043551',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000204,NULL,'16.3g',0.37,'E0',NULL,NULL,NULL,NULL,1,154.441667,10.73203,0.061,NULL,60868270074,951066719,14860417,16.3),(69397,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69397,38.26,0.46,450,25250,70,NULL,NULL,'2MASX J10174624+3336219',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,154.442791667,33.60628,0,NULL,64088310911,1001379857,15646560,17.8),(69398,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69398,37.64,0.46,338,25251,70,NULL,NULL,'2MASX J10174751+0019495',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000071,NULL,'17.1g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,154.4477917,0.33028,0.029,NULL,60743209680,949112651,14829885,17.1),(69399,'Tully est','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69399,32.08,0.8,26.1,25252,75,NULL,'B','NGC 3187',NULL,'1988NBGC.C....0000T',1988,1,3,NULL,'G',0.00001,NULL,'13.8g',1.3,'SB(s)c pec     HII','Pair member (points to parent)',NULL,NULL,NULL,1,154.449417,21.87333,0.081,NULL,60936852277,952138316,14877161,13.8),(69400,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69400,32.62,0.4,33.3,25252,NULL,NULL,'mean','NGC 3187',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69401,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69401,32.74,0.49,35.3,25252,75,NULL,'IR','NGC 3187',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69402,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69402,33.32,0.47,46.1,25252,NULL,NULL,'H','NGC 3187',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69403,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69403,37.27,0.46,285,25253,70,NULL,NULL,'2MASX J10174781+5141226',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000173,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,154.449375,51.68953,0,NULL,64003743337,1000058489,15625913,16.6),(69404,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69404,37.38,0.27,300,25254,70,NULL,NULL,'2MASX J10174805+3003479',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,154.450333333,30.06336,0.109,NULL,64035307929,1000551686,15633620,17.5),(69405,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69405,36.97,0.33,248,25255,70,NULL,NULL,'2MASX J10174864+1459479',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000103,NULL,'16.34',0.44,NULL,NULL,NULL,NULL,NULL,1,154.452667,14.99672,0.093,NULL,60848985495,950765398,14855709,16.34),(69406,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69406,36.51,0.59,201,25256,70,NULL,NULL,'GALEXASC J101749.08-072425.3',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.9R',0.4,'E/S0','Group member',NULL,NULL,NULL,1,154.45425,-7.40625,0.105,NULL,41251729668,644558276,10071223,14.9),(69407,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69407,35.69,0.49,138,25257,75,NULL,'IR','FGC 1048',NULL,'2011yCatp016004901K',2011,1,0.95,NULL,'G',0.000028,NULL,'16.6g',0.15,'Scd',NULL,NULL,NULL,NULL,1,154.457583,19.46339,0.065,NULL,60939631230,952181737,14877839,16.6),(69408,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69408,35.93,NULL,153,25257,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1048',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69409,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69409,35.96,NULL,155,25257,NULL,NULL,'Dipole + Quadrupole','FGC 1048',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69410,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69410,35.98,NULL,157,25257,NULL,NULL,'Dipole','FGC 1048',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69411,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69411,36,NULL,158,25257,NULL,NULL,NULL,'FGC 1048',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69412,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69412,36.91,0.46,241,25258,70,NULL,NULL,'2MASX J10175009+4212343',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000211,NULL,'15.6g',0.52,'S0^-',NULL,NULL,NULL,NULL,1,154.4585417,42.20958,0,NULL,64144596996,1002259328,15660302,15.6),(69413,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69413,38.33,0.27,464,25259,70,NULL,NULL,'SDSS J101750.22+032203.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,154.45925,3.36753,0.053,NULL,60794356396,949911818,14842372,18.7),(69414,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69414,37.42,0.46,305,25260,70,NULL,NULL,'2MASX J10175033+1558319',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.2g',0.32,NULL,NULL,NULL,NULL,NULL,1,154.459708333,15.97569,0.085,NULL,60840856961,950638390,14853724,16.2),(69415,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69415,37.38,0.27,300,25261,70,NULL,NULL,'2MASX J10175075+3003419',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,154.4615,30.06158,0.109,NULL,64035308031,1000551687,15633620,17.2),(69416,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69416,37.69,0.46,346,25262,70,NULL,NULL,'2MASX J10175119+3558230',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000145,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,154.4630417,35.97306,0.009,NULL,64073802899,1001153170,15643018,18.4),(69417,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69417,38.33,0.27,464,25263,70,NULL,NULL,'SDSS J101751.37+031730.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,154.464083,3.29175,0.069,NULL,60738812967,949043952,14828811,18),(69418,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69418,36.91,0.46,241,25264,70,NULL,NULL,'2MASX J10175168+3822580',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000107,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,154.465375,38.38283,0.005,NULL,64093813464,1001465835,15647903,16.4),(69419,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69419,36,0.66,159,25265,70,NULL,NULL,'2MASX J10175376-0036534',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.000075,NULL,'16.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,154.474167,-0.61483,0.025,NULL,41211274939,643926170,10061346,16.4),(69420,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69420,37.95,0.46,389,25266,70,NULL,NULL,'2MASX J10175447+5704131',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00014,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,154.4767917,57.07022,0,NULL,61925454558,967585227,15118519,17.6),(69421,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69421,37.32,0.46,291,25267,70,NULL,NULL,'SDSS J101755.20+134916.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,154.4800417,13.82128,0.105,NULL,60835593741,950556152,14852439,18.6),(69422,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69422,37.38,0.46,299,25268,70,NULL,NULL,'2MASX J10175629+1545518',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,154.484708333,15.76453,0.077,NULL,60841298849,950645294,14853832,18),(69423,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69423,37.05,0.46,258,25269,70,NULL,NULL,'2MASX J10175658+0517185',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00017,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,154.48575,5.28856,0.009,NULL,60794079548,949907492,14842304,16.6),(69424,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69424,35.17,0.4,108,25270,NULL,NULL,'mean','NGC 3179',NULL,'2007A&A...465...71T',2007,1,1.48,NULL,'G',0.000103,NULL,'13.8g',0.5,'S0',NULL,NULL,NULL,NULL,1,154.488375,41.11431,0,NULL,64094350173,1001474221,15648034,13.8),(69425,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69425,35.46,0.45,124,25270,NULL,NULL,'K','NGC 3179',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69426,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69426,37.94,0.27,387,25271,70,NULL,NULL,'SDSS J101758.03+083011.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000152,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,154.491833,8.50319,0.045,NULL,60766285277,949473207,14835518,18.3),(69427,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69427,35.57,0.46,130,25272,70,NULL,NULL,'CGCG 183-009',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000103,NULL,'15.0g',0.49,'E0',NULL,NULL,NULL,NULL,1,154.4922083,37.18167,0,NULL,64064526529,1001008227,15640753,15),(69428,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69428,35.94,0.53,154,25273,70,NULL,NULL,'2MASX J10175896-3448130',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,154.495625,-34.80358,0.357,NULL,41996111660,656189244,10252956,14.4),(69429,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69429,36.05,0.46,162,25274,70,NULL,NULL,'2MASX J10180158+0008295',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000085,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,154.5065417,0.14158,0.033,NULL,60743011912,949109561,14829836,16.5),(69430,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69430,38.12,0.23,421,25275,70,NULL,NULL,'2MASX J10180236+0843549',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000143,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,154.50975,8.732,0.041,NULL,60766080509,949470007,14835468,17.1),(69431,'GRB','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69431,44.02,0.84,3030,25276,69.7,NULL,'Calibrated','1SAX J1017.9+7127',1.1,'2010JCAP...08..020W',2010,1,NULL,NULL,'G',0.0002,NULL,'23.4',NULL,NULL,NULL,NULL,NULL,NULL,1,154.49125,71.45731,0.093,NULL,62103301826,970364091,15161938,23.4),(69432,'GRB','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69432,44.75,1.22,4240,25276,69.7,NULL,'Calibrated','1SAX J1017.9+7127',1.1,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69433,'GRB','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69433,44.93,1.29,4610,25276,69.7,NULL,'Fiducial','1SAX J1017.9+7127',1.1,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69434,'GRB','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69434,45.75,1.35,6730,25276,72,NULL,NULL,'1SAX J1017.9+7127',1.1,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69435,'GRB','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69435,45.85,1.33,7040,25276,70,NULL,NULL,'1SAX J1017.9+7127',1.1,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69436,'GRB','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69436,47.03,0.54,8850,25276,73,NULL,'H const./H=100','1SAX J1017.9+7127',1.1,'2006astro.ph..9262M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69437,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69437,38.33,0.27,464,25277,70,NULL,NULL,'2MASX J10180480+0321377',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00018,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,154.520125,3.36053,0.053,NULL,60738981537,949046586,14828852,17.7),(69438,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69438,37.94,0.27,387,25278,70,NULL,NULL,'SDSS J101805.32+082602.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000136,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,154.5222083,8.434,0.045,NULL,60766203687,949471932,14835498,18.1),(69439,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69439,37.85,0.46,371,25279,70,NULL,NULL,'2MASX J10180532+4051260',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,154.522417,40.85736,0,NULL,64095071907,1001485498,15648210,17.5),(69440,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2002bo',NULL,69440,31.29,0.44,18,25280,74.2,NULL,'SALT 2','NGC 3190',0.00424,'2010ApJ...716..712A',2010,1,4.4,'NGC 3189 is the southwestern side of NGC 3190.','G',0.000047,NULL,'11.3B',1.5,'SA(s)a pec sp  LINER','Pair member (points to parent)',NULL,NULL,NULL,1,154.5234583,21.83231,0.093,NULL,60935970230,952124534,14876945,11.3),(69441,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2002bo',NULL,69441,31.73,0.09,22.2,25280,74.4,NULL,NULL,'NGC 3190',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69442,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2002cv',NULL,69442,31.76,0.07,22.4,25280,72,NULL,NULL,'NGC 3190',0.00424,'2008MNRAS.384..107E',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69443,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2002bo',NULL,69443,31.84,0.23,23.2,25280,72,NULL,NULL,'NGC 3190',0.00424,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69444,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2002bo',NULL,69444,31.85,0.17,23.4,25280,70.8,NULL,NULL,'NGC 3190',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69445,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2002cv',NULL,69445,31.88,0.2,23.7,25280,72,NULL,NULL,'NGC 3190',0.00424,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69446,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2002bo',NULL,69446,31.93,0.2,24.2,25280,72,NULL,NULL,'NGC 3190',0.00424,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69447,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2002bo',NULL,69447,31.93,0.02,24.2,25280,72,NULL,NULL,'NGC 3190',0.00424,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69448,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2002bo',NULL,69448,31.95,0.11,24.3,25280,65,NULL,'MLCS2k2','NGC 3190',0.00424,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69449,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2002bo',NULL,69449,32.14,0.03,26.8,25280,72,NULL,'M(H) = -18.317 mag','NGC 3190',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69450,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2002bo','R',69450,32.15,NULL,26.9,25280,62.3,NULL,NULL,'NGC 3190',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69451,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2002bo',NULL,69451,32.19,0.05,27.3,25280,72,NULL,NULL,'NGC 3190',0.00424,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69452,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2002bo',NULL,69452,32.24,0.14,28.1,25280,60,NULL,NULL,'NGC 3190',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69453,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:43','1','SN 2002bo',NULL,69453,32.46,0.2,31,25280,NULL,NULL,NULL,'NGC 3190',NULL,'2003A&A...408..915S',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69454,'Tully est','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69454,31.76,0.8,22.4,25280,75,NULL,'B','NGC 3190',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69455,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69455,31.9,0.4,24,25280,75,NULL,'HOSTS SN 2002bo','NGC 3190',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69456,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69456,37.27,0.89,285,25281,70,NULL,NULL,'2MASX J10180585-2700093',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,154.5244583,-27.00258,0.217,NULL,41945863502,655404117,10240689,15.4),(69457,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,NULL,69457,36,0.5,159,25282,70,NULL,NULL,'2MASX J10180796-0409030',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'16.11',0.53,NULL,NULL,NULL,NULL,NULL,1,154.53325,-4.15083,0.065,NULL,41261244512,644706945,10073546,16.11),(69458,'FP','2016-12-15 15:14:36','2016-12-16 11:19:43','1',NULL,'R',69458,36.92,0.46,243,25283,70,NULL,NULL,'2MASX J10180850+3814270',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,154.53525,38.24083,0,NULL,64093761165,1001465018,15647890,17.4),(69459,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69459,37.15,0.33,269,25284,70,NULL,NULL,'2MASX J10180901+0546287',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000199,NULL,'16.4g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,154.5377083,5.77464,0.013,NULL,60793911420,949904865,14842263,16.4),(69460,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69460,37.94,0.27,387,25285,70,NULL,NULL,'2MASX J10180937+0833219',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000141,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,154.538917,8.55617,0.041,NULL,60766251389,949472677,14835510,18),(69461,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69461,35.63,0.49,134,25286,70,NULL,NULL,'2MASX J10181021-1307058',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.4I',0.6,NULL,NULL,NULL,NULL,NULL,1,154.5425,-13.11828,0.345,NULL,41158670437,643104225,10048503,13.4),(69462,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69462,37.52,0.46,320,25287,70,NULL,NULL,'2MASX J10181067+0858049',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,154.5445,8.96803,0.053,NULL,60765516829,949461200,14835331,17.3),(69463,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69463,37.38,0.27,300,25288,70,NULL,NULL,'2MASX J10181084+2954010',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,154.545125,29.90017,0.085,NULL,64035311961,1000551749,15633621,17.3),(69464,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69464,37.38,0.33,299,25289,70,NULL,NULL,'2MASX J10181177-0008580',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000094,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,154.549041667,-0.14947,0.037,NULL,41211198151,643924971,10061327,17.7),(69465,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69465,38.42,0.46,482,25290,70,NULL,NULL,'2MASX J10181192+1207439',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,154.549583,12.12883,0.113,NULL,60834822868,950544107,14852251,18),(69466,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69466,37.4,0.46,302,25291,70,NULL,NULL,'2MASX J10181286+0113108',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000074,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,154.553583333,1.21964,0.045,NULL,60747696005,949182750,14830980,17.5),(69467,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69467,35.06,0.46,103,25292,70,NULL,NULL,'2MASX J10181312+2502463',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000169,NULL,'15.4g',0.53,NULL,NULL,NULL,NULL,NULL,1,154.554583,25.04617,0.101,NULL,60465861893,944779092,14762173,15.4),(69468,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69468,37.98,0.46,395,25293,70,NULL,NULL,'2MASX J10181313+3655199',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00019,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,154.554583,36.92231,0,NULL,64064570903,1001008920,15640764,16.6),(69469,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69469,38.38,0.46,474,25294,70,NULL,NULL,'SDSS J101813.61+163029.7',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'17.1g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,154.556708333,16.50828,0.081,NULL,60841846629,950653853,14853966,17.1),(69470,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69470,37.55,0.46,324,25295,70,NULL,NULL,'2MASX J10181380+0800409',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000171,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,154.557583,8.01125,0.037,NULL,60766648049,949478875,14835607,16.8),(69471,'Cepheids','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69471,30.79,0.05,14.4,25296,NULL,NULL,'NGC 3184 group, HST KP Calibrated','NGC 3184',NULL,'2000ApJ...529..745F',2000,1,7.4,'IRAS source is extended over optical size of galaxy.','G',0.000003,NULL,'10.3B',6.9,'SAB(rs)cd      HII','Possible field galaxy',NULL,NULL,NULL,1,154.57025,41.42406,0,NULL,64149884118,1002341939,15661592,10.3),(69472,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:44','1','SN 1921C','R',69472,30.74,NULL,14.1,25296,NULL,NULL,'Photographic','NGC 3184',NULL,'1988SSRv...48....1R',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69473,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:44','1','SN 1937F','R',69473,33.44,NULL,48.8,25296,NULL,NULL,'Photographic','NGC 3184',NULL,'1988SSRv...48....1R',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69474,'SNII optical','2016-12-15 15:14:36','2016-12-16 11:19:44','1','SN 1999gi',NULL,69474,29.74,0.08,8.87,25296,NULL,NULL,'EPM, H01','NGC 3184',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69475,'SNII optical','2016-12-15 15:14:36','2016-12-16 11:19:44','1','SN 1999gi',NULL,69475,29.93,0.06,9.68,25296,NULL,NULL,'SCM','NGC 3184',NULL,'2015ApJ...799..215P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69476,'SNII optical','2016-12-15 15:14:36','2016-12-16 11:19:44','1','SN 1999gi',NULL,69476,30.23,0.36,11.1,25296,NULL,NULL,NULL,'NGC 3184',NULL,'2002AJ....124.2490L',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69477,'SNII optical','2016-12-15 15:14:36','2016-12-16 11:19:44','1','SN 1999gi',NULL,69477,30.33,0.05,11.6,25296,NULL,NULL,'EPM, D05','NGC 3184',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69478,'SNII optical','2016-12-15 15:14:36','2016-12-16 11:19:44','1','SN 1999gi',NULL,69478,30.34,0.14,11.7,25296,NULL,NULL,'EPM E96','NGC 3184',NULL,'2009ApJ...696.1176J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69479,'SNII optical','2016-12-15 15:14:36','2016-12-16 11:19:44','1','SN 1999gi',NULL,69479,30.48,0.4,12.5,25296,NULL,NULL,'SCM, B','NGC 3184',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69480,'SNII optical','2016-12-15 15:14:36','2016-12-16 11:19:44','1','SN 1999gi',NULL,69480,30.5,0.28,12.6,25296,NULL,NULL,'SCM, BVI','NGC 3184',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69481,'SNII optical','2016-12-15 15:14:36','2016-12-16 11:19:44','1','SN 1999gi',NULL,69481,30.51,0.54,12.6,25296,NULL,NULL,'SCM, V','NGC 3184',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69482,'SNII optical','2016-12-15 15:14:36','2016-12-16 11:19:44','1','SN 1999gi',NULL,69482,30.52,0.53,12.7,25296,NULL,NULL,'SCM, I','NGC 3184',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69483,'SNII optical','2016-12-15 15:14:36','2016-12-16 11:19:44','1','SN 1999gi',NULL,69483,30.57,0.13,13,25296,NULL,NULL,'SEAM','NGC 3184',0.001975,'2009ApJ...694.1067P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69484,'SNII optical','2016-12-15 15:14:36','2016-12-16 11:19:44','1','SN 1999gi',NULL,69484,30.7,0.22,13.8,25296,NULL,NULL,'V, photospheric magnitude method','NGC 3184',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69485,'SNII optical','2016-12-15 15:14:36','2016-12-16 11:19:44','1','SN 1999gi',NULL,69485,30.83,0.09,14.7,25296,NULL,NULL,'I, photospheric magnitude method','NGC 3184',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69486,'SNII optical','2016-12-15 15:14:36','2016-12-16 11:19:44','1','SN 1999gi',NULL,69486,31.2,0.26,17.4,25296,NULL,NULL,'EPM D05','NGC 3184',NULL,'2009ApJ...696.1176J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69487,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69487,29.3,0.5,7.24,25296,NULL,18.45,'SN 1921C host','NGC 3184',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69488,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69488,29.71,0.4,8.7,25296,75,NULL,'B','NGC 3184',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69489,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69489,30.3,NULL,11.5,25296,NULL,NULL,'LEDA [April 2006]','NGC 3184',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69490,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69490,35.96,0.62,155,25297,70,NULL,NULL,'2MASX J10181727-1814306',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,154.5719583,-18.24186,0.281,NULL,41615889829,650248278,10160129,15.3),(69491,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69491,35.88,0.33,150,25298,70,NULL,NULL,'2MASX J10181745+3505060',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000176,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,154.572791667,35.08514,0,NULL,64073581843,1001149716,15642964,16.2),(69492,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69492,35.77,0.49,143,25299,70,NULL,NULL,'2MASX J10181804-1046454',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000073,NULL,'15.61',0.6,'E/S0',NULL,NULL,NULL,NULL,1,154.575166667,-10.77936,0.157,NULL,41238949838,644358591,10068102,15.61),(69493,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69493,33.93,0.4,61.1,25300,NULL,NULL,'mean','IC 0602',NULL,'2007A&A...465...71T',2007,1,1.14,NULL,'G',0.00008,NULL,'13.7g',0.55,'S:             LLIRG','Possible field galaxy',NULL,NULL,NULL,1,154.5822083,7.04931,0.021,NULL,60761417641,949397150,14834330,13.7),(69494,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69494,34.01,0.46,63.4,25300,NULL,NULL,'J','IC 0602',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69495,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69495,34.02,0.47,63.6,25300,NULL,NULL,'H','IC 0602',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69496,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69496,34.08,0.45,65.5,25300,NULL,NULL,'K','IC 0602',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69497,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69497,36.97,0.46,248,25301,70,NULL,NULL,'2MASX J10181999+2015423',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000186,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,154.5835,20.26183,0.053,NULL,60941499342,952210927,14878295,16.1),(69498,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69498,36.69,0.46,218,25302,70,NULL,NULL,'2MASX J10182022+2110193',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,154.58425,21.17194,0.065,NULL,60949632194,952338003,14880281,17),(69499,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69499,36.4,0.58,190,25303,70,NULL,NULL,'2MASX J10182149-3415147',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,154.589541667,-34.25419,0.365,NULL,42007524086,656367563,10255743,15.6),(69500,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69500,36.97,0.33,248,25304,70,NULL,NULL,'2MASX J10182315+1451309',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,154.596583,14.85864,0.081,NULL,60849125851,950767591,14855743,17.1),(69501,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69501,37.15,0.33,269,25305,70,NULL,NULL,'2MASX J10182362+0544098',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000174,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,154.5984583,5.73611,0.013,NULL,60794024763,949906636,14842291,16.4),(69502,'SBF','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69502,32.63,0.14,33.6,25306,74.4,NULL,NULL,'NGC 3193',NULL,'2013AJ....146...86T',2013,1,3,NULL,'G',0.000017,NULL,'11.83',2.7,'E2             LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,154.60375,21.89397,0.081,NULL,60936828412,952137943,14877155,11.83),(69503,'SBF','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69503,32.65,0.18,33.8,25306,NULL,NULL,'Malmquist cor.','NGC 3193',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69504,'SBF','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69504,32.66,0.18,34,25306,NULL,NULL,'I','NGC 3193',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69505,'SBF','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69505,32.66,0.18,34,25306,NULL,NULL,NULL,'NGC 3193',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69506,'D-Sigma','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69506,32.31,0.4,28.9,25306,75,NULL,'Edat, raw','NGC 3193',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69507,'D-Sigma','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69507,32.48,0.4,31.3,25306,75,NULL,'Edat, cor','NGC 3193',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69508,'Faber-Jackson','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69508,30.83,0.39,14.7,25306,95,NULL,'de Vaucouleurs','NGC 3193',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69509,'Faber-Jackson','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69509,31.24,0.27,17.7,25306,95,NULL,'Weighted Mean','NGC 3193',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69510,'Faber-Jackson','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69510,31.68,0.63,21.7,25306,95,NULL,'Michard 1979b, c','NGC 3193',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69511,'Faber-Jackson','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69511,32.04,0.46,25.6,25306,95,NULL,'Michard 1979a','NGC 3193',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69512,'Faber-Jackson','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69512,32.93,0.81,38.5,25306,55,NULL,'Visvanathan & Sandage 1979','NGC 3193',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69513,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69513,32.03,0.41,25.5,25306,NULL,NULL,NULL,'NGC 3193',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69514,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69514,32.06,0.41,25.8,25306,NULL,NULL,'Malmquist cor.','NGC 3193',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69515,'Tertiary','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69515,31.8,0.25,22.9,25306,95,NULL,NULL,'NGC 3193',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69516,'Tully est','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69516,31.83,0.8,23.2,25306,75,NULL,'B','NGC 3193',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69517,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69517,32.08,0.4,26.1,25306,NULL,NULL,'mean','NGC 3193',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69518,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69518,32.42,0.45,30.5,25306,NULL,NULL,'K','NGC 3193',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69519,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69519,35.86,0.46,148,25307,70,NULL,NULL,'CGCG 123-040',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000103,NULL,'15.2g',0.54,NULL,NULL,NULL,NULL,NULL,1,154.61275,24.45333,0.045,NULL,60465545638,944774150,14762096,15.2),(69520,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69520,37.85,0.46,371,25308,70,NULL,NULL,'2MASX J10182858+1153041',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000191,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,154.619083,11.88436,0.101,NULL,60868171478,951065179,14860393,16.9),(69521,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69521,35.17,0.46,108,25309,70,NULL,NULL,'2MASX J10182922+1000491',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000151,NULL,'15.9g',0.32,'S0',NULL,NULL,NULL,NULL,1,154.621916667,10.01369,0.081,NULL,60754092862,949282700,14832542,15.9),(69522,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69522,37.17,0.55,272,25310,70,NULL,NULL,'2MASX J10182965-1845301',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.34',NULL,NULL,NULL,NULL,NULL,NULL,1,154.6235417,-18.75847,0.237,NULL,41615976532,650249633,10160150,16.34),(69523,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69523,36.57,0.46,206,25311,70,NULL,NULL,'2MASX J10183115+6537529',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,154.6297917,65.63139,0.097,NULL,62125189707,970706089,15167282,17.4),(69524,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69524,37.67,0.46,341,25312,70,NULL,NULL,'2MASX J10183219+1959598',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'17.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,154.634208333,19.99989,0.089,NULL,60941500831,952210950,14878296,17.9),(69525,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69525,36.5,0.56,200,25313,70,NULL,NULL,'2MASX J10183250-0059320',NULL,'2014MNRAS.445.2677S',2014,1,0.76,NULL,'G',0.000096,NULL,'16.0g',0.22,'Sa(f)',NULL,NULL,NULL,NULL,1,154.635541667,-0.99233,0.057,NULL,41219980940,644062202,10063471,16),(69526,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69526,37.65,0.46,339,25314,70,NULL,NULL,'2MASX J10183444+4849576',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,154.6434583,48.83272,0,NULL,63998724223,999980065,15624688,17.1),(69527,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69527,37.04,0.27,256,25315,70,NULL,NULL,'LSBC F638-V02',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',NULL,NULL,'16.82',0.3,'S/Malin-like',NULL,NULL,NULL,NULL,1,154.6475,14.85203,0.089,NULL,60849114199,950767409,14855740,16.82),(69528,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69528,38.22,0.46,440,25316,70,NULL,NULL,'2MASX J10183569+1932028',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000192,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,154.648583,19.53422,0.073,NULL,60939783846,952184122,14877876,16.7),(69529,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69529,38.06,0.33,409,25317,70,NULL,NULL,'2MASX J10183601+1350233',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,154.6500417,13.83986,0.105,NULL,60836084818,950563825,14852559,17.7),(69530,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69530,38.06,0.33,409,25318,70,NULL,NULL,'2MASX J10183621+1349413',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,154.651,13.82808,0.105,NULL,60836085737,950563839,14852559,NULL),(69531,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69531,33.14,0.49,42.4,25319,70,NULL,NULL,'NGC 3200',NULL,'2014MNRAS.445.2677S',2014,1,4.2,NULL,'G',0.000013,NULL,'12.83',1.3,'SA(rs)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,154.6522917,-17.98253,0.281,NULL,41645305858,650707904,10167311,12.83),(69532,'IRAS','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69532,33.45,0.8,48.9,25319,75,NULL,'MAT, I','NGC 3200',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69533,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69533,33.33,0.49,46.3,25319,75,NULL,'IR','NGC 3200',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69534,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69534,33.34,0.46,46.6,25319,NULL,NULL,'J','NGC 3200',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69535,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69535,33.44,0.47,48.8,25319,NULL,NULL,'H','NGC 3200',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69536,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69536,33.44,0.43,48.9,25319,75,NULL,'MAT, I, raw','NGC 3200',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69537,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69537,33.53,0.45,50.9,25319,NULL,NULL,'K','NGC 3200',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69538,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69538,33.57,0.37,51.7,25319,NULL,NULL,'Malmquist cor.','NGC 3200',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69539,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69539,33.58,0.2,52,25319,74.4,NULL,NULL,'NGC 3200',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69540,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69540,33.62,0.32,53,25319,85,NULL,'I, raw','NGC 3200',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69541,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69541,33.62,0.4,53,25319,NULL,NULL,'mean','NGC 3200',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69542,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69542,33.68,0.43,54.4,25319,75,NULL,'MAT, I, cor','NGC 3200',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69543,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69543,33.71,0.32,55.2,25319,85,NULL,'I, inv','NGC 3200',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69544,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69544,33.8,0.43,57.5,25319,75,NULL,'MAT, I, inv','NGC 3200',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69545,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69545,33.96,0.31,61.8,25319,NULL,NULL,NULL,'NGC 3200',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69546,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69546,37.69,0.46,345,25320,70,NULL,NULL,'2MASX J10183793+4512147',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000138,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,154.657875,45.20414,0,NULL,64147128951,1002298889,15660920,17.6),(69547,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69547,34.15,0.49,67.7,25321,75,NULL,'IR','CGCG 064-105',NULL,'2011yCatp016004901K',2011,1,1.06,NULL,'G',0.00013,NULL,'15.8g',0.27,'Scd','Group member',NULL,NULL,NULL,1,154.658625,13.22656,0.093,NULL,60838052721,950594573,14853040,15.8),(69548,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69548,36.18,0.52,172,25322,70,NULL,NULL,'2MASX J10183820-1819501',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.62',NULL,'(R\'_1)SB(rs)ab',NULL,NULL,NULL,NULL,1,154.659125,-18.33061,0.249,NULL,41615940197,650249065,10160141,16.62),(69549,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69549,38.06,0.46,410,25323,70,NULL,NULL,'SDSS J101839.66+015429.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00008,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,154.66525,1.90828,0.081,NULL,60746609728,949165777,14830715,18.2),(69550,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69550,36.55,0.46,204,25324,70,NULL,NULL,'CGCG 064-104 NED01',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000182,NULL,'15.6g',0.49,'E0',NULL,NULL,NULL,NULL,1,154.666167,10.77933,0.077,NULL,60750606307,949228223,14831690,15.6),(69551,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69551,38.16,0.46,429,25325,70,NULL,NULL,'2MASX J10184050+1940028',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,154.66875,19.66756,0.073,NULL,60942683045,952229422,14878584,17.5),(69552,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69552,35.76,0.33,142,25326,70,NULL,NULL,'MCG +10-15-059',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000203,NULL,'15.2g',0.48,'E0',NULL,NULL,NULL,NULL,1,154.6722917,57.28203,0,NULL,61925396205,967584315,15118504,15.2),(69553,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69553,36.54,0.5,203,25327,70,NULL,NULL,'2MASX J10184221-1813421',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.37',NULL,NULL,NULL,NULL,NULL,NULL,1,154.675708333,-18.2285,0.281,NULL,41662026493,650969163,10171393,16.37),(69554,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69554,37.83,0.33,369,25328,70,NULL,NULL,'2MASX J10184226+0648021',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000179,NULL,'16.6g',0.39,'BrClG',NULL,NULL,NULL,NULL,1,154.676167,6.80064,0,NULL,60761473523,949398023,14834344,16.6),(69555,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69555,38.23,0.33,442,25329,70,NULL,NULL,'2MASX J10184337+0417251',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000183,NULL,'17.0g',0.26,'BrClG',NULL,NULL,NULL,NULL,1,154.6807917,4.29028,0.013,NULL,60795166024,949924469,14842569,17),(69556,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69556,35.81,0.62,145,25330,70,NULL,NULL,'2MASX J10184354-2817177',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,154.681417,-28.28831,0.229,NULL,41959359457,655614991,10243984,15),(69557,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69557,37.04,0.27,256,25331,70,NULL,NULL,'2MASX J10184402+1448083',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,154.6834583,14.80239,0.089,NULL,60849085451,950766960,14855733,17.8),(69558,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69558,33.57,0.55,51.7,25332,70,NULL,NULL,'2MASX J10184420-3641149',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00009,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,154.684125,-36.6875,0.341,NULL,41993921723,656155026,10252422,14.5),(69559,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69559,37.37,0.27,298,25333,70,NULL,NULL,'2MASX J10184426+4253257',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000191,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,154.6845417,42.8905,0,NULL,64145498012,1002273406,15660521,16.5),(69560,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69560,37.75,0.46,355,25334,70,NULL,NULL,'2MASX J10184447+4213247',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000167,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,154.685166667,42.22342,0,NULL,64151921965,1002373780,15662090,17),(69561,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69561,38.21,0.46,439,25335,70,NULL,NULL,'SDSS J101844.93+354223.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,154.6872083,35.70656,0,NULL,64073917120,1001154955,15643046,18.5),(69562,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69562,36.73,0.46,222,25336,70,NULL,NULL,'2MASX J10184584+2408147',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000179,NULL,'17.72',0.19,NULL,NULL,NULL,NULL,NULL,1,154.691,24.13756,0.037,NULL,60465561818,944774403,14762100,17.72),(69563,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69563,37.62,0.46,334,25337,70,NULL,NULL,'2MASX J10184589+3554515',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000165,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,154.6912917,35.91447,0,NULL,64075956794,1001186824,15643544,17.2),(69564,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69564,37.86,0.46,373,25338,70,NULL,NULL,'2MASX J10184715+0819281',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,154.696417,8.32453,0.025,NULL,60766161537,949471274,14835488,17.5),(69565,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69565,38.23,0.33,442,25339,70,NULL,NULL,'2MASX J10184738+0418291',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,154.697333,4.30808,0.013,NULL,60794691994,949917062,14842454,18.2),(69566,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69566,37.93,0.33,386,25340,70,NULL,NULL,'SDSS J101847.46-010059.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000073,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,154.6977917,-1.01664,0.057,NULL,41219971146,644062049,10063469,18.7),(69567,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69567,36.7,0.46,219,25341,70,NULL,NULL,'2MASX J10184757+2941147',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000015,NULL,'16.3g',0.37,'E',NULL,NULL,NULL,NULL,1,154.69825,29.68728,0.081,NULL,64035325086,1000551954,15633624,16.3),(69568,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69568,38.33,0.46,464,25342,70,NULL,NULL,'2MASX J10184756+0540071',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000191,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,154.6982917,5.66864,0.005,NULL,60794037796,949906840,14842294,17.2),(69569,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69569,37.67,0.46,341,25343,70,NULL,NULL,'2MASX J10184797+5141036',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,154.699833,51.68444,0,NULL,64003736465,1000058382,15625912,17.6),(69570,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69570,37.28,0.46,285,25344,70,NULL,NULL,'2MASX J10185387+2314408',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,154.7244583,23.24458,0.041,NULL,60939000775,952171887,14877685,17.5),(69571,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69571,38.41,0.46,481,25345,70,NULL,NULL,'SDSS J101854.71+420027.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,154.7279583,42.0075,0,NULL,64151909047,1002373578,15662087,18.3),(69572,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69572,38.94,0.46,613,25346,70,NULL,NULL,'SDSS J101857.69+295742.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000126,NULL,'18.5g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,154.740417,29.96192,0.081,NULL,64035297004,1000551515,15633617,18.5),(69573,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69573,37.83,0.33,369,25347,70,NULL,NULL,'SDSS J101857.87+064259.3',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000101,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,154.741125,6.7165,0,NULL,60761600100,949400001,14834375,17.8),(69574,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69574,38.41,0.46,480,25348,70,NULL,NULL,'SDSS J101858.53+111038.5',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,154.743917,11.17736,0.085,NULL,60868394412,951068662,14860447,17.8),(69575,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69575,37.93,0.33,386,25349,70,NULL,NULL,'SDSS J101859.23-010808.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000073,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,154.746791667,-1.13575,0.065,NULL,41219987848,644062310,10063473,18.8),(69576,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69576,38.99,0.46,627,25350,70,NULL,NULL,'SDSS J101859.75+045859.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,154.7489583,4.98311,0,NULL,60796376171,949943377,14842865,18.3),(69577,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69577,37.44,0.46,308,25351,70,NULL,NULL,'2MASX J10185979+0928181',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000196,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,154.749208333,9.47169,0.065,NULL,60753691398,949276428,14832444,16.3),(69578,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69578,37.04,0.27,256,25352,70,NULL,NULL,'SDSS J101901.04+145148.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,154.754333333,14.86347,0.089,NULL,60848910238,950764222,14855690,18.2),(69579,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69579,31.97,NULL,24.8,25353,NULL,NULL,NULL,'LSBC F567-01',NULL,'2015AstBu..70....1K',2015,1,0.72,NULL,'G',0.000004,NULL,'15.1g',0.52,'E/p','Group member, radial-velocity confirmed',NULL,NULL,'Emission-Line Galaxy',1,154.75625,21.28369,0.065,NULL,60949652388,952338318,14880286,15.1),(69580,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69580,35.32,0.72,116,25354,70,NULL,NULL,'2MASX J10190298-1314050',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'15.4R',0.33,NULL,NULL,NULL,NULL,NULL,1,154.762333,-13.23481,0.325,NULL,41158125031,643095703,10048370,15.4),(69581,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69581,37.55,0.46,323,25355,70,NULL,NULL,'2MASX J10190297+0027473',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000086,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,154.7624583,0.46303,0.057,NULL,60747379645,949177806,14830903,17.1),(69582,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69582,35.15,0.62,107,25356,70,NULL,NULL,'2MASX J10190299-3508302',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,154.7625,-35.14167,0.357,NULL,41996189574,656190462,10252975,15.3),(69583,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69583,37.69,0.46,345,25357,70,NULL,NULL,'2MASX J10190499+0953261',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,154.77075,9.89047,0.073,NULL,60754326375,949286349,14832599,17),(69584,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69584,36.76,0.46,225,25358,70,NULL,NULL,'2MASX J10190611+4541091',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000136,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,154.775291667,45.68597,0,NULL,64126987594,1001984181,15656002,17.7),(69585,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69585,35.4,NULL,120,25359,NULL,NULL,NULL,'UGC 05567 NOTES01',NULL,'2000BSAO...50....5K',2000,1,0.69,NULL,'G',0.000029,NULL,'17.2g',0.16,'Sdm',NULL,NULL,NULL,NULL,1,154.776125,34.65506,0,NULL,64073540624,1001149072,15642954,17.2),(69586,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69586,37.87,0.46,374,25360,70,NULL,NULL,'2MASX J10190642+4022079',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000167,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,154.776667,40.36878,0,NULL,64094971813,1001483934,15648186,16.6),(69587,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69587,38.56,0.46,515,25361,70,NULL,NULL,'2MASX J10190682+2944525',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,154.778583,29.74781,0.073,NULL,64035054026,1000547719,15633558,17.9),(69588,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69588,35.19,0.64,109,25362,NULL,NULL,'Malmquist cor.','ESO 317- G 011',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.92',0.5,'Sb',NULL,NULL,NULL,NULL,1,154.77875,-40.67911,0.597,NULL,42088162043,657627531,10275430,15.92),(69589,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69589,35.51,0.55,126,25362,NULL,NULL,NULL,'ESO 317- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69590,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69590,35.55,0.2,129,25362,74.4,NULL,NULL,'ESO 317- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69591,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69591,37.96,0.33,390,25363,70,NULL,NULL,'2MASX J10190694+3556259',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000157,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,154.778875,35.94036,0,NULL,64076102420,1001189100,15643579,17.4),(69592,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69592,38.28,0.46,453,25364,70,NULL,NULL,'2MASX J10190700+4146189',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00017,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,154.7795,41.77186,0,NULL,64150001692,1002343776,15661621,17.8),(69593,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69593,37.58,0.46,328,25365,70,NULL,NULL,'2MASX J10190719+1201311',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,154.779958333,12.02522,0.121,NULL,60868135212,951064612,14860384,17.3),(69594,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69594,35.7,0.47,138,25366,NULL,NULL,'H','ESO 500- G 022',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000033,NULL,'15',0.5,'Sb:',NULL,NULL,NULL,NULL,1,154.781375,-26.98461,0.217,NULL,41945745450,655402272,10240660,15),(69595,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69595,35.73,0.31,140,25366,NULL,NULL,'Malmquist cor.','ESO 500- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69596,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69596,35.8,0.4,144,25366,NULL,NULL,'mean','ESO 500- G 022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69597,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69597,35.84,0.46,147,25366,NULL,NULL,'J','ESO 500- G 022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69598,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69598,35.84,0.45,148,25366,NULL,NULL,'K','ESO 500- G 022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69599,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69599,35.84,0.3,148,25366,NULL,NULL,NULL,'ESO 500- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69600,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69600,35.88,0.2,150,25366,74.4,NULL,NULL,'ESO 500- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69601,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69601,34.12,0.2,66.7,25367,74.4,NULL,NULL,'IC 2561',NULL,'2013AJ....146...86T',2013,1,1.05,NULL,'G',0.000013,NULL,'14.4g',0.53,'SBcd',NULL,NULL,NULL,NULL,1,154.785875,34.67503,0,NULL,64073541444,1001149085,15642954,14.4),(69602,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69602,37.96,0.33,390,25368,70,NULL,NULL,'2MASX J10190867+3555519',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000135,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,154.786,35.93106,0,NULL,64076102549,1001189102,15643579,18.1),(69603,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69603,35.88,0.33,150,25369,70,NULL,NULL,'CGCG 183-012',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.0001,NULL,'15.3g',0.46,NULL,NULL,NULL,NULL,NULL,1,154.786333,34.56925,0,NULL,64073532837,1001148950,15642952,15.3),(69604,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69604,38.1,0.33,418,25370,70,NULL,NULL,'2MASX J10190959+0602563',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000144,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,154.7899583,6.049,0.017,NULL,60761080730,949391886,14834248,17.6),(69605,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69605,35.76,0.33,142,25371,70,NULL,NULL,'2MASX J10190977+5706528',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000182,NULL,'15.9g',0.37,'E0',NULL,NULL,NULL,NULL,1,154.7909583,57.11453,0,NULL,61925482001,967585656,15118525,15.9),(69606,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69606,38.23,0.46,443,25372,70,NULL,NULL,'2MASX J10191008+4240391',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000175,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,154.791875,42.67758,0,NULL,64144659889,1002260310,15660317,17.4),(69607,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69607,38.1,0.33,418,25373,70,NULL,NULL,'SDSS J101910.18+060142.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000143,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,154.7924583,6.02842,0.017,NULL,60793832104,949903626,14842244,18.7),(69608,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69608,38.24,0.46,445,25374,70,NULL,NULL,'2MASX J10191044+3519099',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,154.7935417,35.31958,0,NULL,64073579250,1001149675,15642963,17.2),(69609,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69609,36.98,0.46,249,25375,70,NULL,NULL,'2MASX J10191055+2401275',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000143,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,154.7940417,24.02439,0.033,NULL,60935394550,952115539,14876805,17.2),(69610,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69610,37.52,0.46,320,25376,70,NULL,NULL,'2MASX J10191219+0804481',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000165,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,154.800958333,8.07997,0.037,NULL,60764614331,949447098,14835110,16.4),(69611,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69611,38.07,0.33,410,25377,70,NULL,NULL,'2MASX J10191314+1500443',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,154.80475,15.01225,0.081,NULL,60848892889,950763951,14855686,NULL),(69612,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69612,36.6,0.46,209,25378,70,NULL,NULL,'2MASX J10191319+4832413',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000185,NULL,'16.0g',0.43,'E0',NULL,NULL,NULL,NULL,1,154.8049583,48.54478,0,NULL,63998603792,999978184,15624659,16),(69613,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69613,38.77,0.46,566,25379,70,NULL,NULL,'2MASX J10191520+0253143',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000093,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,154.813417,2.88733,0.061,NULL,60746963369,949171302,14830801,17.7),(69614,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69614,36.11,0.79,167,25380,70,NULL,NULL,'2MASX J10191524-0323503',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,154.813583,-3.39739,0.025,NULL,41215410655,643990791,10062356,16.8),(69615,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69615,37.55,0.46,323,25381,70,NULL,NULL,'2MASX J10191571+0434083',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000184,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,154.8154583,4.56886,0.013,NULL,60795789029,949934203,14842721,17),(69616,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69616,36.6,0.33,209,25382,70,NULL,NULL,'2MASX J10191652+2802175',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000186,NULL,'15.7g',0.44,NULL,NULL,NULL,NULL,NULL,1,154.818875,28.03825,0.077,NULL,64037383636,1000584119,15634126,15.7),(69617,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69617,37.14,0.46,268,25383,70,NULL,NULL,'2MASX J10191650+0958571',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000174,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,154.818917,9.98253,0.073,NULL,60754317362,949286208,14832597,16.8),(69618,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69618,38.12,0.46,420,25384,70,NULL,NULL,'2MASX J10191730+0521083',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000143,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,154.822167,5.35217,0.025,NULL,60796010385,949937662,14842775,17.7),(69619,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69619,36.6,0.33,209,25385,70,NULL,NULL,'2MASX J10191750+2801525',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,154.822833,28.03117,0.077,NULL,64037383626,1000584119,15634126,16.9),(69620,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69620,35.06,0.5,103,25386,70,NULL,NULL,'ESO 062- G 007',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000087,NULL,'15.6b',0.4,'S0-a',NULL,NULL,NULL,NULL,1,154.8245,-71.94608,0.453,NULL,40709694158,636088971,9938890,15.6),(69621,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69621,37.94,0.46,388,25387,70,NULL,NULL,'2MASX J10191811-0051563',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000081,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,154.825417,-0.86572,0.073,NULL,41220490389,644070162,10063596,18),(69622,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69622,38.79,0.46,574,25388,70,NULL,NULL,'SDSS J101918.77+370510.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000153,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,154.8282083,37.08614,0,NULL,64064453849,1001007091,15640735,18.5),(69623,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69623,37.81,0.46,364,25389,70,NULL,NULL,'2MASX J10191992+1931346',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,154.8329583,19.52614,0.081,NULL,60939757247,952183706,14877870,18),(69624,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69624,37.85,0.46,371,25390,70,NULL,NULL,'2MASX J10192016+3532300',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000151,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,154.834,35.54156,0,NULL,64075926241,1001186347,15643536,17.5),(69625,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69625,37.88,0.46,376,25391,70,NULL,NULL,'2MASX J10192024+1039211',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000181,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,154.834416667,10.65581,0.069,NULL,60750669232,949229206,14831706,17.1),(69626,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69626,36.31,0.46,183,25392,70,NULL,NULL,'2MASX J10192065+1443083',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',NULL,NULL,'16.36',0.39,NULL,NULL,NULL,NULL,NULL,1,154.8360417,14.719,0.101,NULL,60835251273,950550801,14852356,16.36),(69627,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69627,38.51,0.46,504,25393,70,NULL,NULL,'SDSS J101922.40+320922.0',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,154.843333,32.15614,0.053,NULL,64085805914,1001340717,15645948,17.5),(69628,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69628,37.51,0.46,318,25394,70,NULL,NULL,'2MASX J10192250+0058583',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000076,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,154.8439583,0.98286,0.069,NULL,60748049651,949188275,14831066,17.4),(69629,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69629,37.07,0.46,259,25395,70,NULL,NULL,'2MASX J10192460+0630551',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000174,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,154.8524583,6.51544,0,NULL,60761139416,949392803,14834262,16.9),(69630,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69630,36.73,0.46,222,25396,70,NULL,NULL,'2MASX J10192482+2036266',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00017,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,154.8532083,20.60733,0.073,NULL,60941956738,952218074,14878407,16.3),(69631,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69631,37.26,0.46,283,25397,70,NULL,NULL,'2MASX J10192565+6512307',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,154.8572917,65.20867,0.097,NULL,62124523311,970695676,15167119,17),(69632,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69632,36.21,0.46,175,25398,70,NULL,NULL,'SDSS J101926.16+203346.7',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000184,NULL,'15.9g',0.38,NULL,NULL,NULL,NULL,NULL,1,154.859,20.563,0.073,NULL,60941954114,952218033,14878406,15.9),(69633,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:44','1','SN 1994G',NULL,69633,40.48,0.49,875,25399,74.2,NULL,'SALT 2','[PPG94] 101617.23+510723.4',0.425,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,'Pec/Irr',NULL,NULL,NULL,NULL,1,154.860541667,50.87203,0,NULL,64002258904,1000035295,15625551,NULL),(69634,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:44','1','SN 1994G','R',69634,40.78,NULL,1000,25399,65,NULL,'SALT','[PPG94] 101617.23+510723.4',0.425,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69635,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:44','1','SN 1994G',NULL,69635,41.3,0.37,1280,25399,70,NULL,'SALT','[PPG94] 101617.23+510723.4',0.425,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69636,'SNIa','2016-12-15 15:14:36','2016-12-16 11:19:44','1','SN 1994G',NULL,69636,41.45,0.34,1370,25399,65,NULL,'SALT','[PPG94] 101617.23+510723.4',0.425,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69637,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69637,37.82,0.46,366,25400,70,NULL,NULL,'2MASX J10192723+4500512',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000138,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,154.8635,45.01431,0,NULL,64147159489,1002299367,15660927,17.2),(69638,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69638,35.27,0.54,113,25401,70,NULL,NULL,'2MASX J10192809-1757186',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.39',NULL,NULL,NULL,NULL,NULL,NULL,1,154.866917,-17.95533,0.281,NULL,41645487871,650710747,10167355,16.39),(69639,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69639,37.81,0.19,364,25402,70,NULL,NULL,'2MASX J10192804+0013203',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000083,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,154.8669583,0.22233,0.061,NULL,60735656663,948994635,14828041,17.9),(69640,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69640,37.16,0.46,271,25403,70,NULL,NULL,'2MASX J10193002+2330545',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000141,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,154.875083,23.51503,0.041,NULL,60938465614,952163525,14877555,17.7),(69641,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69641,37.35,0.46,295,25404,70,NULL,NULL,'2MASX J10193029+0248083',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000091,NULL,'17.4g',0.16,'AGN',NULL,NULL,NULL,NULL,1,154.876083333,2.80233,0.069,NULL,60747013966,949172093,14830813,17.4),(69642,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69642,38.22,0.33,440,25405,70,NULL,NULL,'2MASX J10193038+3717068',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000203,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,154.8767083,37.28525,0,NULL,64064705171,1001011018,15640797,16.7),(69643,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69643,38,0.16,399,25406,70,NULL,NULL,'2MASX J10193054+4054308',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000123,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,154.87725,40.90881,0,NULL,64150185406,1002346646,15661666,17.5),(69644,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69644,34.26,0.38,71.1,25407,NULL,NULL,'Malmquist cor.','ESO 317- G 012',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.68',0.3,'S...',NULL,NULL,NULL,NULL,1,154.8784583,-39.47792,0.441,NULL,42086399367,657599990,10274999,15.68),(69645,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69645,34.32,0.37,73.1,25407,NULL,NULL,NULL,'ESO 317- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69646,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69646,34.36,0.2,74.5,25407,74.4,NULL,NULL,'ESO 317- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69647,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69647,37.92,0.46,383,25408,70,NULL,NULL,'SDSS J101931.77+360230.4',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000147,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,154.882416667,36.04178,0,NULL,64076105032,1001189141,15643580,18.1),(69648,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69648,37.73,0.46,352,25409,70,NULL,NULL,'2MASX J10193194+3027500',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00015,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,154.8830417,30.46383,0.073,NULL,64027330344,1000427036,15631672,17.4),(69649,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69649,36.84,0.46,233,25410,70,NULL,NULL,'2MASX J10193278+2821294',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000167,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,154.886666667,28.35811,0.069,NULL,64036918974,1000576858,15634013,16.8),(69650,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69650,38,0.16,399,25411,70,NULL,NULL,'2MASX J10193333+4101198',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.0001,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,154.888875,41.02214,0,NULL,64150715727,1002354933,15661795,17.1),(69651,'Faber-Jackson','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69651,31.54,0.65,20.3,25412,95,NULL,'Weighted Mean','NGC 3203',NULL,'1984ApJS...56...91D',1984,1,2.9,NULL,'G',0.000127,NULL,'13.1',0.6,'SA(r)0+? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,154.8909583,-26.69889,0.321,NULL,41946171289,655408926,10240764,13.1),(69652,'Faber-Jackson','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69652,32.89,0.81,37.8,25412,55,NULL,'Visvanathan & Sandage 1979','NGC 3203',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69653,'Tully est','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69653,32.57,0.8,32.6,25412,75,NULL,'B','NGC 3203',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69654,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69654,37.12,0.46,266,25413,70,NULL,NULL,'2MASX J10193395+6311156',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000165,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,154.89175,63.18775,0,NULL,61824939368,966014677,15093979,17.9),(69655,'IRAS','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69655,35.41,0.8,121,25414,75,NULL,'CF, r','UGC 05573',NULL,'1997ApJS..109..333W',1997,1,1.33,NULL,'G',0.00004,NULL,'14.5g',0.68,'Scd:',NULL,NULL,NULL,NULL,1,154.8960417,6.32636,0.013,NULL,60761281551,949395024,14834297,14.5),(69656,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69656,35.25,0.38,112,25414,75,NULL,'CF, r, raw','UGC 05573',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69657,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69657,35.44,0.38,122,25414,75,NULL,'CF, r, inv','UGC 05573',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69658,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69658,35.45,0.38,123,25414,75,NULL,'CF, r, cor','UGC 05573',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69659,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69659,37.79,0.46,362,25415,70,NULL,NULL,'2MASX J10193574+4240552',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000175,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,154.8989583,42.68203,0,NULL,64144616491,1002259632,15660306,17.5),(69660,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69660,37.9,0.46,380,25416,70,NULL,NULL,'2MASX J10193690+6246156',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00002,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,154.904,62.77089,0,NULL,61824965715,966015089,15093985,17),(69661,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69661,37.74,0.33,354,25417,70,NULL,NULL,'SDSS J101937.04+363605.1',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000165,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,154.904333,36.60142,0,NULL,64072667777,1001135434,15642741,18.6),(69662,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69662,37.81,0.19,364,25418,70,NULL,NULL,'2MASX J10193793+0019555',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000102,NULL,'16.4g',0.31,'BrClG          AGN',NULL,NULL,NULL,NULL,1,154.908083333,0.33214,0.061,NULL,60747172894,949174576,14830852,16.4),(69663,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69663,38.07,0.33,410,25419,70,NULL,NULL,'2MASX J10193883+1459208',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,154.911833,14.98919,0.081,NULL,60848878484,950763726,14855683,18.1),(69664,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69664,37.81,0.19,364,25420,70,NULL,NULL,'SDSS J101941.19+002700.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000065,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,154.921667,0.45019,0.061,NULL,60747398543,949178102,14830907,18.3),(69665,'Tully est','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69665,33.01,0.8,40,25421,75,NULL,'B','NGC 3208',NULL,'1988NBGC.C....0000T',1988,1,1.8,NULL,'G',0.000017,NULL,'13.42',1.6,'SAB(rs)bc      HII',NULL,NULL,NULL,NULL,1,154.9220417,-25.81475,0.257,NULL,41945439378,655397490,10240585,13.42),(69666,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69666,36.9,0.46,240,25422,70,NULL,NULL,'2MASX J10194155+3310179',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000105,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,154.9230417,33.17161,0.021,NULL,64088923473,1001389429,15646709,16.8),(69667,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69667,37.7,0.46,347,25423,70,NULL,NULL,'2MASX J10194163+4545262',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,154.923583,45.75742,0,NULL,64126982844,1001984106,15656001,17.3),(69668,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69668,35.46,0.46,124,25424,70,NULL,NULL,'2MASX J10194218+1315148',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000167,NULL,'15.6g',0.49,'E0',NULL,NULL,NULL,NULL,1,154.925791667,13.25408,0.093,NULL,60838084453,950595069,14853047,15.6),(69669,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69669,37.37,0.27,298,25425,70,NULL,NULL,'2MASX J10194246+4245302',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000183,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,154.9269583,42.75833,0,NULL,64144620230,1002259691,15660307,17.2),(69670,'Ring Diameter','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69670,33.2,0.84,43,25426,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3188',NULL,'1981ApJS...45..541P',1981,1,0.92,NULL,'G',0.000115,NULL,'14.6g',0.72,'(R)SB(r)ab','in a pair',NULL,NULL,'Starburst',1,154.928375,57.42347,0,NULL,61925743180,967589737,15118589,14.6),(69671,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69671,31.48,0.59,19.7,25427,NULL,NULL,'Malmquist cor.','UGC 05574',NULL,'2009ApJS..182..474S',2009,1,1.36,'Multiple SDSS entries describe this object.','G',0.000033,NULL,'15.3g',0.34,'Scd?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,154.9287083,22.45239,0.045,NULL,60936399527,952131242,14877050,15.3),(69672,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69672,31.65,0.43,21.4,25427,75,NULL,'3.6 micron, color + selection bias corrected','UGC 05574',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69673,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69673,31.68,0.2,21.7,25427,74.4,NULL,NULL,'UGC 05574',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69674,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69674,31.72,0.43,22,25427,75,NULL,'3.6 micron, color corrected','UGC 05574',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69675,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69675,31.73,0.4,22.2,25427,75,NULL,NULL,'UGC 05574',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69676,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69676,31.85,0.5,23.5,25427,NULL,NULL,NULL,'UGC 05574',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69677,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69677,32.41,0.49,30.3,25427,75,NULL,'IR','UGC 05574',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69678,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69678,38.02,0.33,402,25428,70,NULL,NULL,'2MASX J10194430-0038173',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000104,NULL,'16.0g',0.47,'BrClG          AGN',NULL,NULL,NULL,NULL,1,154.934458333,-0.63831,0.073,NULL,41219725388,644058209,10063409,16),(69679,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69679,35.52,0.65,127,25429,70,NULL,NULL,'2MASX J10194423-7334577',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,154.934583,-73.58278,0.505,NULL,39824077059,622251204,9722675,17.2),(69680,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69680,37.81,0.19,364,25430,70,NULL,NULL,'2MASX J10194506+0019295',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00009,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,154.937667,0.32494,0.061,NULL,60747172148,949174564,14830852,18),(69681,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69681,38,0.16,399,25431,70,NULL,NULL,'2MASX J10194571+4059389',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00009,NULL,'16.9g',0.32,NULL,NULL,NULL,NULL,NULL,1,154.940291667,40.99411,0,NULL,64150705928,1002354780,15661793,16.9),(69682,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69682,38.21,0.46,438,25432,70,NULL,NULL,'SDSS J101946.35+361826.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000131,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,154.943167,36.30739,0,NULL,64075890978,1001185796,15643528,18.3),(69683,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69683,36.32,0.9,184,25433,70,NULL,NULL,'2MASX J10194676-6930567',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,154.9449583,-69.51575,0.589,NULL,40733591812,636462372,9944724,17.1),(69684,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69684,38.16,0.46,428,25434,70,NULL,NULL,'2MASX J10194823+0820492',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,154.951,8.34703,0.025,NULL,60764778194,949449659,14835150,17.6),(69685,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69685,38.06,0.46,409,25435,70,NULL,NULL,'2MASX J10194833+3645339',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,154.9512083,36.7595,0,NULL,64072672295,1001135504,15642742,17.5),(69686,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69686,37.78,0.46,360,25436,70,NULL,NULL,'SDSS J101948.96+012620.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000071,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,154.9540417,1.43894,0.057,NULL,60747870127,949185470,14831022,18.2),(69687,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69687,33.88,0.51,59.6,25437,70,NULL,NULL,'ESO 567- G 049',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00007,NULL,'15',0.9,'S0','Pair member (points to parent)',NULL,NULL,NULL,1,154.955833,-19.95542,0.177,NULL,41619754492,650308663,10161072,15),(69688,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69688,38,0.16,399,25438,70,NULL,NULL,'SDSS J101949.70+410025.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000159,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,154.957125,41.00703,0,NULL,64150706047,1002354781,15661793,18.5),(69689,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69689,37.29,0.46,288,25439,70,NULL,NULL,'SDSS J101949.96+093421.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,154.958167,9.57272,0.065,NULL,60753555835,949274309,14832411,18.2),(69690,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69690,38.1,0.46,418,25440,70,NULL,NULL,'SDSS J101951.28+084836.1',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,154.9637083,8.81003,0.041,NULL,60764449044,949444516,14835070,17.8),(69691,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69691,36.58,0.46,207,25441,70,NULL,NULL,'2MASX J10195274+2211031',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000189,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,154.969708333,22.18411,0.041,NULL,60936309206,952129831,14877028,16.2),(69692,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69692,36.18,0.46,172,25442,70,NULL,NULL,'CGCG 313-013',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000103,NULL,'14.9g',0.67,'E0',NULL,NULL,NULL,NULL,1,154.970125,63.95153,0,NULL,62112976505,970515257,15164300,14.9),(69693,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69693,37.87,0.46,376,25443,70,NULL,NULL,'2MASX J10195282+0147325',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000083,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,154.9702083,1.79239,0.069,NULL,60749984003,949218500,14831539,18),(69694,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69694,37.12,0.46,266,25444,70,NULL,NULL,'2MASX J10195322+0423495',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000193,NULL,'16.1g',0.42,'S0',NULL,NULL,NULL,NULL,1,154.9717083,4.397,0.013,NULL,60794847198,949919487,14842491,16.1),(69695,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69695,37.3,0.46,289,25445,70,NULL,NULL,'2MASX J10195391+3735459',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000139,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,154.974625,37.59619,0,NULL,64064671205,1001010487,15640788,17.4),(69696,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69696,38.22,0.33,440,25446,70,NULL,NULL,'SDSS J101954.59+372045.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00014,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,154.9775,37.34597,0,NULL,64064710829,1001011106,15640798,18.6),(69697,'Cepheids','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69697,30.25,0.12,11.2,25447,NULL,NULL,'3, H','NGC 3198',NULL,'2001ApJ...549..721M',2001,1,8.5,NULL,'G',0.000001,NULL,'10.8B',3.3,'SB(rs)c        HII','Possible field galaxy',NULL,NULL,NULL,1,154.9789583,45.54961,0,NULL,64144017671,1002250276,15660160,10.8),(69698,'Cepheids','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69698,30.25,0.12,11.2,25447,NULL,NULL,'3, H','NGC 3198',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69699,'Cepheids','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69699,30.31,0.17,11.5,25447,73,NULL,'Cepheids periods Gaussian ','NGC 3198',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69700,'Cepheids','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69700,30.45,NULL,12.3,25447,NULL,NULL,'MOND theory fit ','NGC 3198',NULL,'2013A&A...554A.125G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69701,'Cepheids','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69701,30.55,0.11,12.9,25447,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian ','NGC 3198',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69702,'Cepheids','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69702,30.63,0.09,13.4,25447,74.4,NULL,NULL,'NGC 3198',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69703,'Cepheids','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69703,30.68,0.08,13.7,25447,NULL,NULL,'36, VI, KEY PROJECT','NGC 3198',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69704,'Cepheids','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69704,30.71,0.06,13.8,25447,NULL,NULL,'LMC W01','NGC 3198',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69705,'Cepheids','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69705,30.7,0.08,13.8,25447,NULL,NULL,'36, VI, +Z, KEY PROJECT','NGC 3198',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69706,'Cepheids','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69706,30.72,0.07,13.9,25447,NULL,NULL,'3, I','NGC 3198',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69707,'Cepheids','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69707,30.72,0.06,13.9,25447,NULL,NULL,'cte LMC K03','NGC 3198',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69708,'Cepheids','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69708,30.72,0.07,13.9,25447,NULL,NULL,'3, I','NGC 3198',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69709,'Cepheids','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69709,30.73,0.06,14,25447,NULL,NULL,'cte U99','NGC 3198',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69710,'Cepheids','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69710,30.75,0.06,14.1,25447,NULL,NULL,'cte LMC STS02','NGC 3198',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69711,'Cepheids','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69711,30.8,0.04,14.5,25447,73,NULL,'Cepheids magnitudes Gaussian ','NGC 3198',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69712,'Cepheids','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69712,30.8,0.06,14.5,25447,NULL,NULL,'HST KP Calibrated','NGC 3198',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69713,'Cepheids','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69713,30.8,NULL,14.5,25447,NULL,18.54,NULL,'NGC 3198',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69714,'Cepheids','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69714,30.81,0.06,14.5,25447,NULL,NULL,'cte MW FSG03','NGC 3198',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69715,'Cepheids','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69715,30.8,0.06,14.5,25447,NULL,NULL,'58, VI','NGC 3198',NULL,'1999ApJ...514..614K',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69716,'Cepheids','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69716,30.8,0.08,14.5,25447,NULL,18.54,'LMC ZP','NGC 3198',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69717,'Cepheids','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69717,30.83,0.09,14.7,25447,NULL,NULL,'3, V','NGC 3198',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69718,'Cepheids','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69718,30.83,0.09,14.7,25447,NULL,NULL,'3, V','NGC 3198',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69719,'Cepheids','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69719,30.84,0.06,14.7,25447,NULL,NULL,'cte MF91','NGC 3198',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69720,'Cepheids','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69720,30.84,0.06,14.7,25447,NULL,NULL,'cte MW GFG98','NGC 3198',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69721,'Cepheids','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69721,30.86,0.1,14.9,25447,NULL,NULL,'MW HIPP','NGC 3198',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69722,'Cepheids','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69722,30.92,0.06,15.3,25447,NULL,NULL,'cte MW STS03','NGC 3198',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69723,'Cepheids','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69723,31.11,0.23,16.7,25447,NULL,NULL,'MW P02','NGC 3198',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69724,'Cepheids','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69724,31.19,NULL,17.3,25447,NULL,NULL,'77, VI','NGC 3198',NULL,'2006A&A...452..423P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69725,'Cepheids','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69725,31.23,0.07,17.6,25447,NULL,NULL,'MW GFG','NGC 3198',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69726,'Cepheids','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69726,31.23,0.07,17.6,25447,NULL,NULL,'187, VI','NGC 3198',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69727,'Ring Diameter','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69727,30.2,0.76,11,25447,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3198',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69728,'Ring Diameter','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69728,30.6,0.6,13,25447,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3198',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69729,'IRAS','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69729,30.52,0.8,12.7,25447,75,NULL,'A82, H','NGC 3198',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69730,'Sosies','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69730,31.11,0.08,16.7,25447,NULL,NULL,NULL,'NGC 3198',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69731,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69731,30,0.4,10,25447,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 3198',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69732,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69732,30.17,0.4,10.8,25447,75,NULL,'B','NGC 3198',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69733,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69733,30.4,0.35,12,25447,NULL,NULL,NULL,'NGC 3198',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69734,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69734,30.48,0.43,12.5,25447,75,NULL,'3.6 micron, color corrected','NGC 3198',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69735,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69735,30.5,0.2,12.6,25447,NULL,NULL,'B','NGC 3198',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69736,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69736,30.51,NULL,12.6,25447,NULL,NULL,'LEDA [April 2006]','NGC 3198',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69737,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69737,30.54,0.43,12.9,25447,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3198',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69738,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69738,30.59,0.47,13.1,25447,75,NULL,'A82, H, raw','NGC 3198',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69739,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69739,30.58,NULL,13.1,25447,NULL,NULL,'B','NGC 3198',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69740,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69740,30.63,0.09,13.4,25447,74.4,NULL,NULL,'NGC 3198',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69741,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69741,30.65,0.47,13.5,25447,75,NULL,'A82, H, inv','NGC 3198',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69742,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69742,30.65,NULL,13.5,25447,NULL,NULL,'I','NGC 3198',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69743,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69743,30.7,0.41,13.8,25447,NULL,NULL,NULL,'NGC 3198',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69744,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69744,30.7,0.08,13.8,25447,75,NULL,NULL,'NGC 3198',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69745,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69745,30.73,0.03,14,25447,NULL,NULL,'I','NGC 3198',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69746,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69746,30.76,0.39,14.2,25447,73,NULL,'opt','NGC 3198',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69747,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69747,30.84,0.38,14.7,25447,NULL,NULL,'Malmquist cor.','NGC 3198',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69748,'Tully-Fisher','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69748,30.9,0.47,15.2,25447,75,NULL,'A82, H, cor','NGC 3198',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69749,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69749,37.4,0.46,302,25448,70,NULL,NULL,'SDSS J101955.91+342520.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000126,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,154.983,34.42239,0,NULL,64087397907,1001365592,15646337,18.1),(69750,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69750,37.81,0.19,364,25449,70,NULL,NULL,'2MASX J10195766+0031415',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000082,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,154.9902083,0.52811,0.061,NULL,60747263180,949175987,14830874,17.9),(69751,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69751,38.54,0.46,511,25450,70,NULL,NULL,'2MASX J10195772+2007451',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,154.990375,20.12911,0.077,NULL,60943131097,952236423,14878694,18.2),(69752,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69752,36.08,0.46,165,25451,70,NULL,NULL,'CGCG 266-038',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000182,NULL,'15.3g',0.58,'E0',NULL,NULL,NULL,NULL,1,154.991583333,53.95939,0,NULL,61905243737,967269433,15113584,15.3),(69753,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69753,37.37,0.27,298,25452,70,NULL,NULL,'2MASX J10195893+4239343',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000185,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,154.995625,42.65942,0,NULL,64152025200,1002375393,15662115,17.1),(69754,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,NULL,69754,35.2,0.56,110,25453,70,NULL,NULL,'LCRS B101731.4-112137',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.91',NULL,NULL,NULL,NULL,NULL,NULL,1,154.99725,-11.61194,0.229,NULL,41272045701,644875714,10076183,15.91),(69755,'FP','2016-12-15 15:14:36','2016-12-16 11:19:44','1',NULL,'R',69755,37.99,0.46,396,25454,70,NULL,NULL,'2MASX J10195991+0232242',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000081,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,154.9995,2.54003,0.081,NULL,60746799284,949168738,14830761,18.2),(69756,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69756,37.61,0.46,332,25455,70,NULL,NULL,'2MASX J10200007+0252375',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000172,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,155.000167,2.87697,0.069,NULL,60746754693,949168042,14830750,17.1),(69757,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69757,35.86,0.46,149,25456,70,NULL,NULL,'2MASX J10200164+0830533',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000169,NULL,'15.6g',0.3,'S0^-',NULL,NULL,NULL,NULL,1,155.00675,8.51489,0.025,NULL,60764760692,949449385,14835146,15.6),(69758,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69758,37.57,0.46,326,25457,70,NULL,NULL,'2MASX J10200197+0936133',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000145,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,155.008333,9.60358,0.065,NULL,60753549021,949274203,14832409,17.5),(69759,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69759,37.74,0.33,354,25458,70,NULL,NULL,'2MASX J10200228+3631289',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,155.0095417,36.52475,0,NULL,64072697670,1001135901,15642748,18),(69760,'D-Sigma','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69760,33.06,0.4,40.9,25459,75,NULL,'Edat, raw','ESO 567- G 051',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000047,NULL,'14.13',0.9,'E?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,155.010125,-21.51856,0.241,NULL,41622150928,650346108,10161657,14.13),(69761,'D-Sigma','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69761,33.39,0.4,47.7,25459,75,NULL,'Edat, cor','ESO 567- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69762,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69762,33.58,0.48,51.9,25459,70,NULL,NULL,'ESO 567- G 051',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69763,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69763,37.84,0.33,370,25460,70,NULL,NULL,'2MASX J10200351+0225102',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00008,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,155.0145417,2.41931,0.073,NULL,60746768749,949168261,14830754,17.3),(69764,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69764,38.02,0.33,402,25461,70,NULL,NULL,'SDSS J102003.55-004114.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000076,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,155.014833,-0.68733,0.073,NULL,41219699317,644057801,10063403,18.5),(69765,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69765,33.78,0.49,56.9,25462,75,NULL,'IR','ESO 317- G 013',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.30',0.2,'Sb:',NULL,NULL,NULL,NULL,1,155.016916667,-37.99903,0.233,NULL,41964202698,655690667,10245166,15.3),(69766,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69766,34.01,0.44,63.4,25462,NULL,NULL,NULL,'ESO 317- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69767,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69767,34.05,0.43,64.5,25462,NULL,NULL,'Malmquist cor.','ESO 317- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69768,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69768,34.05,0.2,64.6,25462,74.4,NULL,NULL,'ESO 317- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69769,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69769,36.27,0.33,180,25463,70,NULL,NULL,'CGCG 037-002',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000137,NULL,'15.3g',0.55,'S0^-',NULL,NULL,NULL,NULL,1,155.017625,7.77283,0.037,NULL,60764480232,949445003,14835078,15.3),(69770,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69770,37.71,0.46,348,25464,70,NULL,NULL,'SDSS J102004.26+553249.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00004,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,155.0177917,55.54711,0,NULL,61896719942,967136249,15111503,18.1),(69771,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69771,37.68,0.46,343,25465,70,NULL,NULL,'2MASX J10200548+0417282',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,155.022958333,4.29114,0.013,NULL,60794818927,949919045,14842485,17.7),(69772,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69772,33.88,0.48,59.6,25466,70,NULL,NULL,'ESO 567- G 052',NULL,'2014MNRAS.445.2677S',2014,1,2.9,NULL,'G',0.000077,NULL,'15.11',2.6,'SAB0 pec','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,155.033458333,-21.69531,0.225,NULL,41622139054,650345922,10161655,15.11),(69773,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69773,38,0.16,399,25467,70,NULL,NULL,'SDSS J102008.46+410033.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,155.035291667,41.00944,0,NULL,64150760657,1002355635,15661806,18.6),(69774,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69774,36.67,0.46,215,25468,70,NULL,NULL,'2MASX J10200912+4734072',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000171,NULL,'15.9g',0.38,'E0',NULL,NULL,NULL,NULL,1,155.038125,47.56875,0,NULL,64129183797,1002018496,15656539,15.9),(69775,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69775,36.14,0.53,169,25469,70,NULL,NULL,'MRK 1254',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000093,NULL,'16.0',0.4,NULL,NULL,NULL,NULL,NULL,1,155.043166667,-8.90822,0.129,NULL,41253708299,644589192,10071706,16),(69776,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69776,34.37,0.4,74.7,25470,NULL,NULL,'mean','NGC 3204',NULL,'2007A&A...465...71T',2007,1,1.09,NULL,'G',0.000033,NULL,'14.3g',0.77,'SAB(r)b',NULL,NULL,NULL,NULL,1,155.046167,27.81706,0.069,NULL,64037564482,1000586945,15634171,14.3),(69777,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69777,34.97,0.47,98.8,25470,NULL,NULL,'H','NGC 3204',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69778,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69778,35.02,0.46,101,25470,NULL,NULL,'J','NGC 3204',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69779,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69779,37.81,0.19,364,25471,70,NULL,NULL,'2MASX J10201133+0026002',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000074,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,155.0472917,0.43331,0.061,NULL,60735769281,948996395,14828068,18),(69780,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69780,37.23,0.46,279,25472,70,NULL,NULL,'2MASX J10201137+4725102',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,155.047375,47.41964,0,NULL,64130278066,1002035594,15656806,17.5),(69781,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69781,38,0.46,398,25473,70,NULL,NULL,'2MASX J10201247+1735018',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,155.0519583,17.58403,0.089,NULL,60961005498,952515710,14883057,17.7),(69782,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69782,37.88,0.46,376,25474,70,NULL,NULL,'2MASX J10201445+4850249',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000161,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,155.0602917,48.84031,0,NULL,63997911278,999967363,15624490,17.4),(69783,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69783,38.15,0.46,426,25475,70,NULL,NULL,'2MASX J10201519+0308042',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00009,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,155.0632083,3.13461,0.061,NULL,60739168640,949049510,14828898,16.8),(69784,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69784,37.51,0.46,318,25476,70,NULL,NULL,'2MASX J10201572+2923481',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,155.065625,29.39675,0.061,NULL,64035206375,1000550099,15633595,18),(69785,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69785,36.38,0.46,189,25477,70,NULL,NULL,'2MASX J10201647+2328319',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000174,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,155.0685,23.47547,0.041,NULL,60938452279,952163316,14877551,16.6),(69786,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69786,37.67,0.46,342,25478,70,NULL,NULL,'2MASX J10201905+1001045',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,155.07925,10.01794,0.081,NULL,60754384326,949287255,14832613,17.4),(69787,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69787,38.36,0.33,469,25479,70,NULL,NULL,'2MASX J10202055+3001323',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000214,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,155.0857083,30.02558,0.081,NULL,64028030877,1000437982,15631843,17.2),(69788,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69788,36.78,0.46,227,25480,70,NULL,NULL,'2MASX J10202073+0145572',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000079,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,155.086375,1.766,0.069,NULL,60749866883,949216670,14831510,17.3),(69789,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69789,37.31,0.33,290,25481,70,NULL,NULL,'2MASX J10202247+0527162',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,155.093791667,5.45439,0.025,NULL,60796095444,949938991,14842796,17.1),(69790,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69790,37.31,0.33,290,25482,70,NULL,NULL,'2MASX J10202287+0525422',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000166,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,155.095333,5.42844,0.025,NULL,60796106035,949939156,14842799,18.1),(69791,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69791,38.01,0.46,399,25483,70,NULL,NULL,'SDSS J102023.08+170556.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,155.0962083,17.09906,0.089,NULL,60960510682,952507979,14882937,18.5),(69792,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69792,36.58,0.81,207,25484,70,NULL,NULL,'2MASX J10202328-0459093',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.00015,NULL,'16.31',0.34,'SBb','Group member',NULL,NULL,NULL,1,155.097,-4.98589,0.097,NULL,41263214679,644737729,10074027,16.31),(69793,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69793,38.04,0.46,406,25485,70,NULL,NULL,'2MASX J10202361-0051423',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000091,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,155.098333,-0.86183,0.125,NULL,41220437074,644069329,10063583,17.1),(69794,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69794,35.51,0.48,126,25486,70,NULL,NULL,'ESO 317- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00011,NULL,'14.70',1,'S0',NULL,NULL,NULL,NULL,1,155.101916667,-40.40206,0.537,NULL,42133380081,658334063,10286469,14.7),(69795,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69795,37.31,0.19,290,25487,70,NULL,NULL,'2MASX J10202450+4834239',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00019,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,155.102333,48.57331,0,NULL,63997878243,999966847,15624481,16.5),(69796,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69796,37.32,0.46,291,25488,70,NULL,NULL,'SDSS J102024.75+123159.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,155.103166667,12.53331,0.109,NULL,60835182612,950549728,14852339,18.3),(69797,'BCG','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69797,37.04,0.35,243,25489,60,NULL,'ABELL 0978, BCG','MCG -01-27-002',0.0527,'1980ApJ...241..486H',1980,1,0.2,NULL,'G',0.00019,NULL,'15.63',0.2,'D','Group member',NULL,NULL,NULL,1,155.110667,-6.52661,0.137,NULL,41246373680,644474588,10069915,15.63),(69798,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69798,36.92,0.19,242,25490,70,NULL,NULL,'2MASX J10202754+3626577',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000168,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,155.114667,36.44942,0,NULL,64072687022,1001135734,15642745,16.7),(69799,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69799,37.02,0.46,253,25491,70,NULL,NULL,'2MASX J10202820+0746435',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000181,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,155.117541667,7.77878,0.037,NULL,60760044164,949375690,14833995,16.7),(69800,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69800,35.57,0.46,130,25492,70,NULL,NULL,'CGCG 266-039',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.0002,NULL,'14.8g',0.67,'E',NULL,NULL,NULL,NULL,1,155.118125,53.85636,0,NULL,61905217695,967269026,15113578,14.8),(69801,'BCG','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69801,37.04,0.35,243,25493,60,NULL,NULL,'ABELL 0978',0.0527,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II     [BM]',NULL,NULL,NULL,NULL,1,155.12,-6.51972,0.137,NULL,41246373070,644474579,10069915,NULL),(69802,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69802,38,0.16,399,25494,70,NULL,NULL,'2MASX J10203012+4103407',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000123,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,155.125667,41.06142,0,NULL,64150751565,1002355493,15661804,17.8),(69803,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69803,38.14,0.46,425,25495,70,NULL,NULL,'2MASX J10203040+4442508',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000131,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,155.126625,44.71403,0,NULL,64147068641,1002297947,15660905,17.3),(69804,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69804,36.88,0.46,237,25496,70,NULL,NULL,'2MASXi J1020310+162633',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.3g',NULL,NULL,NULL,NULL,NULL,NULL,1,155.1294583,16.44275,0.085,NULL,60961815841,952528372,14883255,17.3),(69805,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69805,37.69,0.46,345,25497,70,NULL,NULL,'2MASX J10203129+0426443',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000141,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,155.1305,4.44558,0.013,NULL,60794659993,949916562,14842446,18),(69806,'Ring Diameter','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69806,33.9,0.84,60,25498,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3202',NULL,'1981ApJS...45..541P',1981,1,1.24,NULL,'G',0.00013,NULL,'13.9g',0.84,'SB(r)a','in a radial-velocity based grouping',NULL,NULL,NULL,1,155.13225,43.02161,0,NULL,64144994474,1002265538,15660399,13.9),(69807,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69807,38.09,0.33,414,25499,70,NULL,NULL,'SDSS J102031.84+413745.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000162,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,155.132667,41.62931,0,NULL,64149964179,1002343190,15661612,18.6),(69808,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69808,36.33,0.46,185,25500,70,NULL,NULL,'VIII Zw 063',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000163,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,155.1337083,8.33097,0.025,NULL,60764816098,949450251,14835160,16.4),(69809,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69809,37.5,0.46,317,25501,70,NULL,NULL,'2MASX J10203288+0129363',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00009,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,155.136958333,1.4935,0.061,NULL,60747808925,949184514,14831008,17.1),(69810,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69810,36.26,0.64,179,25502,70,NULL,NULL,'2MASX J10203527-0437049',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'16.96',0.3,'S0','Group member',NULL,NULL,NULL,1,155.146917,-4.61808,0.089,NULL,41263067748,644735433,10073991,16.96),(69811,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69811,37.57,0.46,326,25503,70,NULL,NULL,'2MASX J10203567+4633459',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000135,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,155.14875,46.56278,0.009,NULL,64130665504,1002041648,15656900,17.5),(69812,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69812,38,0.16,399,25504,70,NULL,NULL,'2MASX J10203619+4054257',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000153,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,155.15075,40.90722,0,NULL,64150725698,1002355089,15661798,18.3),(69813,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69813,37.34,0.46,293,25505,70,NULL,NULL,'2MASX J10203644+1331339',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000187,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,155.151833333,13.52611,0.089,NULL,60837863004,950591609,14852993,16.9),(69814,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69814,37.27,0.46,285,25506,70,NULL,NULL,'2MASX J10203752+2618497',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,155.15625,26.31392,0.057,NULL,64023552213,1000368003,15630750,17.4),(69815,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69815,37.75,0.46,354,25507,70,NULL,NULL,'SDSS J102037.92+100603.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,155.1580417,10.10097,0.081,NULL,60754380920,949287201,14832612,17.7),(69816,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69816,36.75,0.33,224,25508,70,NULL,NULL,'CGCG 240-031',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000204,NULL,'15.6g',0.47,'S0',NULL,NULL,NULL,NULL,1,155.1629583,47.97967,0,NULL,64129238598,1002019353,15656552,15.6),(69817,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69817,36.48,0.46,198,25509,70,NULL,NULL,'2MASX J10203919+4459339',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000077,NULL,'16.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,155.163333,44.99267,0,NULL,64147114042,1002298656,15660916,16.8),(69818,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69818,36.27,0.33,180,25510,70,NULL,NULL,'CGCG 037-006',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.00014,NULL,'15.3g',0.52,'E0',NULL,NULL,NULL,NULL,1,155.1652083,7.85942,0.037,NULL,60760033632,949375525,14833992,15.3),(69819,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69819,38.15,0.46,427,25511,70,NULL,NULL,'2MASX J10204024+2516057',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,155.167833,25.26839,0.053,NULL,60468703935,944823498,14762867,17.3),(69820,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69820,37.31,0.19,290,25512,70,NULL,NULL,'2MASX J10204101+4831315',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000171,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,155.170916667,48.52542,0,NULL,64128888485,1002013882,15656466,16.9),(69821,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69821,38.18,0.46,433,25513,70,NULL,NULL,'SDSS J102041.09+193855.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000135,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,155.17125,19.64886,0.057,NULL,60942857481,952232148,14878627,18.1),(69822,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69822,35.29,0.2,114,25514,74.4,NULL,NULL,'CGCG 065-002',NULL,'2013AJ....146...86T',2013,1,0.74,NULL,'G',0.000185,NULL,'15.1g',0.4,'Sa',NULL,NULL,NULL,NULL,1,155.171917,13.96772,0.089,NULL,60835870091,950560470,14852507,15.1),(69823,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69823,37.84,0.33,370,25515,70,NULL,NULL,'2MASX J10204166+0225284',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00008,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,155.1735417,2.42442,0.065,NULL,60749587274,949212301,14831442,16.9),(69824,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69824,38.09,0.33,414,25516,70,NULL,NULL,'2MASX J10204230+4136276',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,155.176375,41.60775,0,NULL,64149977155,1002343393,15661615,16.8),(69825,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69825,33.69,0.47,54.6,25517,NULL,NULL,'H','UGC 05576',NULL,'2007A&A...465...71T',2007,1,1.06,NULL,'G',0.00003,NULL,'13.9g',0.67,'S?             NLAGN','in a pair',NULL,NULL,NULL,1,155.180625,65.17208,0.033,NULL,62124481910,970695029,15167109,13.9),(69826,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69826,33.69,0.4,54.6,25517,NULL,NULL,'mean','UGC 05576',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69827,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69827,33.77,0.46,56.8,25517,NULL,NULL,'J','UGC 05576',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69828,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69828,33.78,0.45,56.9,25517,NULL,NULL,'K','UGC 05576',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69829,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69829,35.97,0.57,156,25518,70,NULL,NULL,'2MASX J10204363-0433539',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.58',NULL,'E/S0','Group member',NULL,NULL,NULL,1,155.1817083,-4.56519,0.089,NULL,41263063612,644735368,10073990,16.58),(69830,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69830,36.8,0.17,230,25519,70,NULL,NULL,'CGCG 211-045',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000215,NULL,'15.2g',0.55,'E0',NULL,NULL,NULL,NULL,1,155.186875,38.52092,0,NULL,64093356918,1001458701,15647792,15.2),(69831,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69831,36.92,0.19,242,25520,70,NULL,NULL,'2MASX J10204586+3628274',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000162,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,155.191125,36.47439,0,NULL,64072564750,1001133824,15642716,17.1),(69832,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69832,36.98,0.46,249,25521,70,NULL,NULL,'2MASX J10204653+0612237',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000176,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,155.1940417,6.20675,0.017,NULL,60762101726,949407839,14834497,17.3),(69833,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69833,37.67,0.23,341,25522,70,NULL,NULL,'SDSS J102046.61+021334.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000059,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,155.19425,2.22636,0.073,NULL,60750091031,949220172,14831565,18),(69834,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69834,32.88,0.49,37.7,25523,75,NULL,'IR','UGC 05570',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',NULL,NULL,'16.5',0.13,'Sbc',NULL,NULL,NULL,NULL,1,155.195875,73.28425,0.085,NULL,61379376163,959052752,14985199,16.5),(69835,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69835,33.18,NULL,43.2,25523,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05570',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69836,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69836,33.2,NULL,43.6,25523,NULL,NULL,'Dipole + Quadrupole','UGC 05570',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69837,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69837,33.22,NULL,44,25523,NULL,NULL,'Dipole','UGC 05570',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69838,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69838,33.27,NULL,45.1,25523,NULL,NULL,NULL,'UGC 05570',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69839,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69839,37.51,0.33,317,25524,70,NULL,NULL,'SDSS J102047.14+091803.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,155.196417,9.30094,0.037,NULL,60753009515,949265773,14832277,17.9),(69840,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69840,35.49,0.46,125,25525,70,NULL,NULL,'2MASX J10204724+2606427',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'16.22',0.19,NULL,NULL,NULL,NULL,NULL,1,155.196833,26.11186,0.061,NULL,64023551329,1000367989,15630749,16.22),(69841,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69841,35.68,0.7,137,25526,70,NULL,NULL,'2MASX J10204724-0444149',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.60',0.4,'SBb','Group member',NULL,NULL,NULL,1,155.196875,-4.73756,0.089,NULL,41263079750,644735621,10073994,16.6),(69842,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69842,36.73,0.15,222,25527,70,NULL,NULL,'2MASX J10204772+2352101',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000194,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,155.19875,23.86953,0.029,NULL,60937238277,952144348,14877255,16.7),(69843,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69843,37.47,0.46,312,25528,70,NULL,NULL,'2MASX J10204815+4503049',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000127,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,155.20075,45.05144,0,NULL,64147115369,1002298677,15660916,18.2),(69844,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69844,38.36,0.33,469,25529,70,NULL,NULL,'2MASX J10204835+3002454',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,155.201375,30.04583,0.081,NULL,64028071115,1000438611,15631853,17.7),(69845,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69845,37.67,0.23,341,25530,70,NULL,NULL,'SDSS J102048.45+020507.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000078,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,155.201917,2.08544,0.069,NULL,60750086866,949220107,14831564,17.8),(69846,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69846,37.67,0.23,341,25531,70,NULL,NULL,'2MASX J10204854+0206424',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000109,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,155.202166667,2.11178,0.073,NULL,60750090097,949220157,14831564,16.2),(69847,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69847,36.88,0.46,237,25532,70,NULL,NULL,'2MASX J10204862+1352218',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000162,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,155.2025417,13.87292,0.085,NULL,60835776198,950559003,14852484,16.6),(69848,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69848,38.28,0.46,452,25533,70,NULL,NULL,'2MASX J10204874+0154144',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000093,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,155.2029583,1.904,0.069,NULL,60750273511,949223023,14831609,17.7),(69849,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69849,36.03,0.54,161,25534,70,NULL,NULL,'2MASX J10204918-0935103',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,155.204917,-9.58625,0.129,NULL,41239830857,644372357,10068318,16.3),(69850,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69850,38.11,0.46,419,25535,70,NULL,NULL,'2MASX J10205031+3927015',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000187,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,155.2095417,39.45053,0,NULL,64093635745,1001463058,15647860,17.2),(69851,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69851,38,0.16,399,25536,70,NULL,NULL,'2MASX J10205067+4057255',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000073,NULL,'17.0g',0.26,'BrClG',NULL,NULL,NULL,NULL,1,155.211083,40.95694,0,NULL,64150731544,1002355180,15661799,17),(69852,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69852,36.54,0.27,203,25537,70,NULL,NULL,'2MASX J10205141+2139511',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000199,NULL,'15.8g',0.41,NULL,NULL,NULL,NULL,NULL,1,155.21425,21.66411,0.029,NULL,60950358226,952349347,14880458,15.8),(69853,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69853,37.67,0.23,341,25538,70,NULL,NULL,'2MASX J10205320+0212344',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000083,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,155.2217083,2.20961,0.073,NULL,60750075610,949219931,14831561,17.6),(69854,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69854,37.33,0.46,293,25539,70,NULL,NULL,'2MASX J10205570+0114104',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00009,NULL,'16.4g',0.41,NULL,NULL,NULL,NULL,NULL,1,155.232208333,1.23606,0.069,NULL,60747511271,949179863,14830935,16.4),(69855,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69855,38.67,0.46,543,25540,70,NULL,NULL,'2MASX J10205604+0343204',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000188,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,155.2335417,3.72244,0.049,NULL,60739578368,949055912,14828998,17.3),(69856,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69856,35.7,NULL,138,25541,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1054',NULL,'2010Ap&SS.325..163P',2010,1,0.74,NULL,'G',0.000017,NULL,'17.3g',0.12,'Scd',NULL,NULL,NULL,NULL,1,155.234417,30.76225,0.073,NULL,64027249262,1000425769,15631652,17.3),(69857,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69857,35.71,NULL,139,25541,NULL,NULL,NULL,'FGC 1054',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69858,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69858,35.72,NULL,139,25541,NULL,NULL,'Dipole + Quadrupole','FGC 1054',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69859,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69859,35.72,NULL,139,25541,NULL,NULL,'Dipole','FGC 1054',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69860,'Tully est','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69860,31.92,0.8,24.2,25542,75,NULL,'B','UGC 05588',NULL,'1988NBGC.C....0000T',1988,1,0.5,NULL,'G',0.000033,NULL,'15.0',0.3,'S?','in a pair',NULL,NULL,NULL,1,155.2380417,25.36483,0.049,NULL,60468667226,944822925,14762858,15),(69861,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69861,38.16,0.46,429,25543,70,NULL,NULL,'2MASX J10205725+4310308',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000166,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,155.238417,43.17514,0,NULL,64144957065,1002264954,15660389,17.3),(69862,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69862,37.69,0.46,346,25544,70,NULL,NULL,'2MASXi J1020573+410823',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,155.2389583,41.13983,0,NULL,64150770088,1002355782,15661809,17.9),(69863,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69863,35.99,0.46,158,25545,70,NULL,NULL,'2MASX J10205785+4033525',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000186,NULL,'15.8g',0.29,'S0',NULL,NULL,NULL,NULL,1,155.2410417,40.56472,0,NULL,64150306454,1002348538,15661695,15.8),(69864,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69864,36.53,0.46,202,25546,70,NULL,NULL,'CGCG 037-008',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000183,NULL,'16.0g',0.35,'E0',NULL,NULL,NULL,NULL,1,155.2425,6.64181,0.025,NULL,60762299673,949410932,14834545,16),(69865,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69865,35.43,0.33,122,25547,70,NULL,NULL,'ARK 239',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000183,NULL,'14.7g',0.56,NULL,NULL,NULL,NULL,NULL,1,155.2440417,25.51942,0.061,NULL,60468644583,944822571,14762852,14.7),(69866,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69866,39.23,0.46,702,25548,70,NULL,NULL,'SDSS J102058.58-005358.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000091,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,155.244125,-0.89947,0.121,NULL,41220383039,644068484,10063570,18.7),(69867,'SNIa','2016-12-15 15:14:37','2016-12-16 11:19:44','1','PTF11apk','N',69867,36.49,0.05,191,25549,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF11apk',0.0405,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69868,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69868,36.54,0.27,203,25550,70,NULL,NULL,'MCG +04-25-005',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000182,NULL,'15.5g',0.4,NULL,NULL,NULL,NULL,NULL,1,155.25225,21.71661,0.029,NULL,60950378952,952349671,14880463,15.5),(69869,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69869,36.87,0.46,236,25551,70,NULL,NULL,'2MASX J10210075+1524467',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,155.253167,15.41308,0.085,NULL,60961086206,952516971,14883077,16.4),(69870,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69870,37.7,0.46,347,25552,70,NULL,NULL,'SDSS J102100.88+155336.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,155.2537083,15.89361,0.089,NULL,60961947054,952530422,14883287,18),(69871,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69871,37.74,0.46,353,25553,70,NULL,NULL,'2MASX J10210116+2011011',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,155.254667,20.18358,0.077,NULL,60943177354,952237146,14878705,17.8),(69872,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69872,38.39,0.33,476,25554,70,NULL,NULL,'2MASX J10210193+3318558',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000159,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,155.258125,33.31556,0.009,NULL,64088819329,1001387802,15646684,18.5),(69873,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69873,36.63,0.46,212,25555,70,NULL,NULL,'2MASX J10210241+2833014',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,155.2599583,28.55028,0.065,NULL,64036819154,1000575299,15633989,17.3),(69874,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69874,37.71,0.46,348,25556,70,NULL,NULL,'2MASX J10210248+1722367',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,155.260291667,17.37678,0.085,NULL,60960837888,952513092,14883017,16.9),(69875,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69875,36.72,0.46,221,25557,70,NULL,NULL,'2MASX J10210334+1119318',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000194,NULL,'15.7g',0.43,'S0',NULL,NULL,NULL,NULL,1,155.264083333,11.32547,0.101,NULL,60750383894,949224748,14831636,15.7),(69876,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69876,37.51,0.33,317,25558,70,NULL,NULL,'2MASX J10210348+0916408',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000177,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,155.2645,9.27794,0.037,NULL,60753013978,949265843,14832278,17.6),(69877,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69877,36.73,0.15,222,25559,70,NULL,NULL,'2MASX J10210411+2342559',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000188,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,155.267,23.71556,0.029,NULL,60937320217,952145628,14877275,16.7),(69878,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69878,36.26,0.46,179,25560,70,NULL,NULL,'2MASX J10210590+4422398',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000176,NULL,'15.8g',0.43,'E',NULL,NULL,NULL,NULL,1,155.274708333,44.37772,0,NULL,64147607553,1002306368,15661037,15.8),(69879,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69879,37.64,0.33,337,25561,70,NULL,NULL,'2MASX J10210623+3209158',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000139,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,155.276083333,32.15453,0.053,NULL,64085236105,1001331814,15645809,17.6),(69880,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69880,37.34,0.46,294,25562,70,NULL,NULL,'2MASX J10210666+0927538',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000148,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,155.277625,9.46481,0.049,NULL,60753199865,949268747,14832324,17.2),(69881,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69881,37.27,0.46,285,25563,70,NULL,NULL,'2MASX J10210803+4537488',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,155.283333,45.63031,0,NULL,64128299595,1002004681,15656323,17.6),(69882,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69882,37.31,0.19,290,25564,70,NULL,NULL,'SDSS J102108.44+482855.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00018,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,155.285208333,48.48206,0,NULL,64128930880,1002014545,15656477,17.6),(69883,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69883,34.87,0.46,94,25565,70,NULL,NULL,'CGCG 094-006',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000173,NULL,'14.8',0.6,NULL,NULL,NULL,NULL,NULL,1,155.286583,16.29953,0.085,NULL,60961764820,952527575,14883243,14.8),(69884,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69884,37.22,0.27,278,25566,70,NULL,NULL,'2MASX J10211032+4708008',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000167,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,155.2929583,47.13361,0,NULL,64130838301,1002044348,15656942,16.4),(69885,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69885,35.64,NULL,134,25567,NULL,NULL,'Dipole + Quadrupole + Octopole','KUG 1018+359',NULL,'2010Ap&SS.325..163P',2010,1,1.05,NULL,'G',0.00003,NULL,'16.1g',0.18,'Sc',NULL,NULL,NULL,NULL,1,155.294417,35.65794,0,NULL,64076356174,1001193065,15643641,16.1),(69886,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69886,35.66,NULL,135,25567,NULL,NULL,'Dipole + Quadrupole','KUG 1018+359',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69887,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69887,35.68,NULL,137,25567,NULL,NULL,'Dipole','KUG 1018+359',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69888,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69888,35.75,NULL,141,25567,NULL,NULL,NULL,'KUG 1018+359',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69889,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69889,36,0.49,158,25567,75,NULL,'IR','KUG 1018+359',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69890,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69890,36.28,0.2,180,25567,74.4,NULL,NULL,'KUG 1018+359',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69891,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69891,37.22,0.27,278,25568,70,NULL,NULL,'2MASX J10211072+4704538',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,155.294583,47.08158,0,NULL,64130835661,1002044307,15656942,16.9),(69892,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69892,38.38,0.46,475,25569,70,NULL,NULL,'2MASX J10211084+3920365',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,155.2950417,39.34344,0,NULL,64093570417,1001462037,15647844,18),(69893,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69893,37.03,0.46,255,25570,70,NULL,NULL,'2MASX J10211103+0001497',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000086,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,155.295916667,0.03058,0.077,NULL,60735694236,948995222,14828050,16.9),(69894,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69894,37.45,0.46,309,25571,70,NULL,NULL,'2MASX J10211181+4253528',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000186,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,155.299041667,42.89808,0,NULL,64152481263,1002382519,15662226,16.5),(69895,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69895,37.41,0.19,304,25572,70,NULL,NULL,'2MASX J10211183+1544001',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,155.299416667,15.73339,0.101,NULL,60961262129,952519720,14883120,16.7),(69896,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69896,35.43,0.33,122,25573,70,NULL,NULL,'2MASX J10211284+2518584',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000181,NULL,'15.4g',0.5,NULL,NULL,NULL,NULL,NULL,1,155.303666667,25.31611,0.053,NULL,60468674517,944823039,14762859,15.4),(69897,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69897,36.8,0.17,230,25574,70,NULL,NULL,'2MASX J10211491+3834355',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000077,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,155.312,38.57639,0,NULL,64093257720,1001457151,15647767,17.1),(69898,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69898,36.93,0.46,244,25575,70,NULL,NULL,'2MASX J10211537+1618501',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,155.314125,16.31386,0.085,NULL,60961766031,952527594,14883243,17.7),(69899,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69899,32.2,0.4,27.6,25576,NULL,NULL,'mean','NGC 3213',NULL,'2007A&A...465...71T',2007,1,1.15,NULL,'G',0.00003,NULL,'13.8g',0.88,'Sbc:           HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,155.3222917,19.65178,0.057,NULL,60942904836,952232888,14878638,13.8),(69900,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69900,32.6,0.47,33.1,25576,NULL,NULL,'H','NGC 3213',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69901,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69901,32.6,0.45,33.2,25576,NULL,NULL,'K','NGC 3213',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69902,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69902,32.67,0.46,34.2,25576,NULL,NULL,'J','NGC 3213',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69903,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69903,36.73,0.15,222,25577,70,NULL,NULL,'2MASX J10211765+2349200',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000196,NULL,'16.0g',0.38,NULL,NULL,NULL,NULL,NULL,1,155.323583,23.82222,0.029,NULL,60937450161,952147658,14877307,16),(69904,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69904,37.68,0.46,344,25578,70,NULL,NULL,'2MASX J10211842+4104584',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000172,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,155.32675,41.08294,0,NULL,64150824779,1002356637,15661822,16.9),(69905,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69905,38.11,0.46,419,25579,70,NULL,NULL,'2MASX J10211923-0043562',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000081,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,155.33025,-0.73225,0.125,NULL,41206810579,643856415,10060256,17.8),(69906,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69906,38.39,0.33,476,25580,70,NULL,NULL,'2MASX J10211931+3315018',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000189,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,155.3305,33.25061,0.009,NULL,64088807338,1001387614,15646681,18.5),(69907,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69907,37.31,0.46,290,25581,70,NULL,NULL,'2MASX J10211948+5649083',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000175,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,155.331291667,56.81897,0.009,NULL,61895861331,967122833,15111294,16.7),(69908,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69908,38.16,0.46,428,25582,70,NULL,NULL,'SDSS J102119.96+241359.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000138,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,155.333208333,24.23317,0.017,NULL,60466721118,944792517,14762383,18.3),(69909,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69909,37.5,0.46,316,25583,70,NULL,NULL,'2MASX J10212062+0850316',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,155.335875,8.84208,0.053,NULL,60764902193,949451596,14835181,17.6),(69910,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69910,37.56,0.46,325,25584,70,NULL,NULL,'2MASX J10212083+0229106',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000078,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,155.336875,2.48625,0.065,NULL,60749619478,949212804,14831450,17.1),(69911,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69911,37.75,0.46,354,25585,70,NULL,NULL,'2MASX J10212115+0019356',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000081,NULL,'17.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,155.338125,0.32644,0.101,NULL,60735703309,948995364,14828052,17.9),(69912,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69912,36.75,0.46,224,25586,70,NULL,NULL,'2MASX J10212211+2006250',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000172,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,155.34225,20.10683,0.073,NULL,60943210198,952237659,14878713,17.5),(69913,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69913,36.26,0.46,179,25587,70,NULL,NULL,'2MASX J10212255+1203400',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000161,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,155.3439583,12.06097,0.093,NULL,60867764626,951058822,14860294,16.7),(69914,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69914,37.31,0.19,290,25588,70,NULL,NULL,'2MASX J10212373+4827156',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000191,NULL,'16.2g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,155.349083333,48.45433,0,NULL,64128941616,1002014712,15656479,16.2),(69915,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69915,36.14,0.46,169,25589,70,NULL,NULL,'2MASX J10212390+1355250',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000177,NULL,'15.7g',0.46,'E0',NULL,NULL,NULL,NULL,1,155.349583,13.92364,0.085,NULL,60954027116,952406673,14881354,15.7),(69916,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69916,37.22,0.27,278,25590,70,NULL,NULL,'SDSS J102124.06+470645.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000143,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,155.35025,47.11258,0,NULL,64130837016,1002044328,15656942,18),(69917,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69917,36.88,0.46,237,25591,70,NULL,NULL,'2MASX J10212427+3106534',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000165,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,155.3510417,31.11478,0.065,NULL,64082884204,1001295065,15645235,16.7),(69918,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69918,37.64,0.33,337,25592,70,NULL,NULL,'SDSS J102124.39+321331.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,155.351667,32.22533,0.053,NULL,64085289899,1001332654,15645822,17.8),(69919,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69919,37.41,0.19,304,25593,70,NULL,NULL,'2MASX J10212483+1533030',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,155.3535417,15.55103,0.085,NULL,60961299286,952520301,14883129,18.1),(69920,'CMD','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69920,27.93,NULL,3.85,25594,NULL,NULL,NULL,'[HS98] 117',NULL,'2012ApJ...748...47M',2012,1,1.5,NULL,'G',NULL,NULL,'16.5:',0.9,'dIrr/dSph',NULL,NULL,NULL,NULL,1,155.355,71.11417,0.113,NULL,62103448574,970366383,15161974,16.5),(69921,'TRGB','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69921,27.91,0.04,3.82,25594,NULL,NULL,'I','[HS98] 117',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69922,'TRGB','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69922,27.94,0.05,3.87,25594,NULL,NULL,'I','[HS98] 117',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69923,'TRGB','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69923,27.99,NULL,3.96,25594,NULL,NULL,NULL,'[HS98] 117',NULL,'2006AJ....131.1361K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69924,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69924,36.92,0.19,242,25595,70,NULL,NULL,'2MASX J10212551+3622155',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000165,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,155.356208333,36.371,0,NULL,64072577341,1001134020,15642719,16.6),(69925,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69925,38.86,0.46,591,25596,70,NULL,NULL,'2MASX J10212692+4719178',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,155.3620417,47.32161,0,NULL,64130255187,1002035237,15656800,17.9),(69926,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69926,36.8,0.17,230,25597,70,NULL,NULL,'2MASX J10212694+3843065',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000181,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,155.3622083,38.71867,0,NULL,64093282523,1001457539,15647774,16.3),(69927,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69927,36.92,0.19,242,25598,70,NULL,NULL,'2MASX J10212766+3626376',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,155.3652083,36.44383,0,NULL,64072542299,1001133473,15642710,17.8),(69928,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69928,36.92,0.19,242,25599,70,NULL,NULL,'IC 2564',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000198,NULL,'15.3g',0.6,NULL,NULL,NULL,NULL,NULL,1,155.365417,36.45206,0,NULL,64072543057,1001133485,15642710,15.3),(69929,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69929,37.31,0.19,290,25600,70,NULL,NULL,'2MASX J10212865+4831297',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000183,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,155.3692083,48.525,0,NULL,64128940193,1002014690,15656479,16.8),(69930,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69930,36.97,0.46,247,25601,70,NULL,NULL,'2MASX J10213017+3529435',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000174,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,155.3757083,35.49531,0,NULL,64076328855,1001192638,15643634,16.3),(69931,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69931,35.31,0.46,115,25602,70,NULL,NULL,'CGCG 183-015',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000087,NULL,'14.9g',0.48,'S0',NULL,NULL,NULL,NULL,1,155.376916667,37.75669,0,NULL,64064049128,1001000767,15640636,14.9),(69932,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69932,37.33,0.46,292,25603,70,NULL,NULL,'SDSS J102133.50+553355.8',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,155.389666667,55.56553,0,NULL,61898545711,967164776,15111949,17.6),(69933,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69933,37.8,0.27,363,25604,70,NULL,NULL,'2MASX J10213372+1002366',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,155.390458333,10.04336,0.077,NULL,60753866495,949279163,14832486,17.2),(69934,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69934,36.38,0.46,189,25605,70,NULL,NULL,'2MASX J10213366+6151037',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,155.390583,61.851,0,NULL,61945417879,967897154,15123393,17.3),(69935,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69935,36.8,0.17,230,25606,70,NULL,NULL,'2MASX J10213403+3836225',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00006,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,155.391875,38.60625,0,NULL,64093283336,1001457552,15647774,17.3),(69936,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69936,37.94,0.46,387,25607,70,NULL,NULL,'2MASX J10213407+1216520',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,155.391916667,12.281,0.101,NULL,60834209109,950534517,14852101,17.2),(69937,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69937,34.98,0.46,99.1,25608,NULL,NULL,'Malmquist cor.','2MFGC 08020',NULL,'2009ApJS..182..474S',2009,1,0.88,NULL,'G',0.00002,NULL,'15.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,155.394541667,23.95897,0.029,NULL,60937425258,952147269,14877301,15.9),(69938,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69938,35.09,0.44,104,25608,NULL,NULL,NULL,'2MFGC 08020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69939,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69939,35.13,0.2,106,25608,74.4,NULL,NULL,'2MFGC 08020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69940,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69940,35.34,0.49,117,25608,75,NULL,'IR','2MFGC 08020',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69941,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69941,31.53,0.49,20.2,25609,70,NULL,NULL,'NGC 3223',NULL,'2014MNRAS.445.2677S',2014,1,4.1,NULL,'G',0.000022,NULL,'11.79',2.5,'SA(r)bc        HII','Possible group member',NULL,NULL,NULL,1,155.396166667,-34.26681,0.461,NULL,42008586406,656384162,10256002,11.79),(69942,'IRAS','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69942,32.89,0.8,37.9,25609,75,NULL,'MAT, I','NGC 3223',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69943,'IRAS','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69943,32.9,0.8,38,25609,75,NULL,'HMCL, I','NGC 3223',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69944,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69944,31.67,NULL,21.6,25609,NULL,NULL,'B','NGC 3223',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69945,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69945,31.83,0.3,23.2,25609,92,NULL,'H, Assuming Hydra cluster m-M = 33.2 mag','NGC 3223',NULL,'1993AJ....105...97S',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69946,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69946,31.98,NULL,24.9,25609,NULL,NULL,'B','NGC 3223',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69947,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69947,32,0.69,25.1,25609,100,NULL,'mid-IR','NGC 3223',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69948,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69948,32.2,0.47,27.6,25609,NULL,NULL,'H','NGC 3223',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69949,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69949,32.21,0.46,27.7,25609,NULL,NULL,'J','NGC 3223',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69950,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69950,32.24,0.45,28.1,25609,NULL,NULL,'K','NGC 3223',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69951,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69951,32.3,0.3,28.8,25609,92,NULL,'I, Assuming Hydra cluster m-M = 33.2 mag','NGC 3223',NULL,'1993AJ....105...97S',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69952,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69952,32.41,0.43,30.4,25609,75,NULL,'MAT, I, raw','NGC 3223',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69953,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69953,32.48,0.4,31.3,25609,75,NULL,'HMCL, I, raw','NGC 3223',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69954,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69954,32.52,NULL,31.9,25609,NULL,NULL,'I','NGC 3223',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69955,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69955,32.6,0.38,33.1,25609,NULL,NULL,NULL,'NGC 3223',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69956,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69956,32.62,0.32,33.4,25609,85,NULL,'I, raw','NGC 3223',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69957,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69957,32.71,0.32,34.8,25609,85,NULL,'I, inv','NGC 3223',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69958,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69958,32.73,0.43,35.2,25609,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3223',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69959,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69959,32.75,0.4,35.5,25609,75,NULL,'HMCL, I, inv','NGC 3223',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69960,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69960,32.77,0.43,35.8,25609,75,NULL,'MAT, I, inv','NGC 3223',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69961,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69961,32.78,0.43,36,25609,75,NULL,'MAT, I, cor','NGC 3223',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69962,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69962,32.79,0.4,36.2,25609,75,NULL,'HMCL, I, cor','NGC 3223',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69963,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69963,32.82,0.43,36.6,25609,75,NULL,'3.6 micron, color corrected','NGC 3223',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69964,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69964,32.91,0.4,38.1,25609,75,NULL,'B','NGC 3223',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69965,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69965,32.99,0.2,39.6,25609,74.4,NULL,NULL,'NGC 3223',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69966,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69966,33.1,0.4,41.7,25609,NULL,NULL,'mean','NGC 3223',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69967,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69967,33.25,0.08,44.8,25609,NULL,NULL,NULL,'NGC 3223',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69968,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69968,37.13,0.46,267,25610,70,NULL,NULL,'2MASX J10213598+5214027',NULL,'2015arXiv151105856S',2015,1,0.49,'2002AJ....124.1918M has z = 0.174354 +- 0.000227.','G',0.000179,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,155.3999583,52.23397,0,NULL,63990357808,999849340,15622645,16.4),(69969,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69969,36.73,0.15,222,25611,70,NULL,NULL,'2MASX J10213695+2359224',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000203,NULL,'15.5g',0.52,NULL,NULL,NULL,NULL,NULL,1,155.4039583,23.98972,0.029,NULL,60937428446,952147319,14877301,15.5),(69970,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69970,36,0.46,158,25612,70,NULL,NULL,'2MASX J10213718+1406140',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000171,NULL,'15.6g',0.42,'E0',NULL,NULL,NULL,NULL,1,155.4047917,14.10383,0.089,NULL,60954206368,952409474,14881398,15.6),(69971,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69971,37.31,0.19,290,25613,70,NULL,NULL,'2MASX J10213760+4826097',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000192,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,155.4067917,48.43594,0,NULL,64128939156,1002014674,15656479,16.4),(69972,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69972,35.82,0.6,146,25614,70,NULL,NULL,'2MASX J10213767-0418462',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000123,NULL,'15.30',0.7,'SBab','Group member',NULL,NULL,NULL,1,155.406917,-4.31292,0.089,NULL,41216676682,644010573,10062665,15.3),(69973,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69973,36.54,0.27,203,25615,70,NULL,NULL,'2MASX J10213766+2141137',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000187,NULL,'16.70',0.19,NULL,NULL,NULL,NULL,NULL,1,155.406917,21.68731,0.029,NULL,60949862254,952341597,14880337,16.7),(69974,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69974,37.6,0.46,332,25616,70,NULL,NULL,'2MASX J10213805+6334267',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000179,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,155.40875,63.57417,0.017,NULL,61824627060,966009797,15093903,17.4),(69975,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69975,32.45,0.2,30.9,25617,74.4,NULL,NULL,'UGC 05595',NULL,'2013AJ....146...86T',2013,1,0.89,NULL,'G',0.000004,NULL,'15.2g',0.67,'Sbc',NULL,NULL,NULL,NULL,1,155.409375,12.57611,0.109,NULL,60834307463,950536054,14852125,15.2),(69976,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69976,36.73,0.15,222,25618,70,NULL,NULL,'SDSS J102139.44+234750.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000179,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,155.414375,23.79742,0.029,NULL,60937457960,952147780,14877309,18),(69977,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69977,36.73,0.15,222,25619,70,NULL,NULL,'2MASX J10214003+2353597',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000156,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,155.4167917,23.89994,0.029,NULL,60937467192,952147924,14877311,17.9),(69978,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69978,37.83,0.23,368,25620,70,NULL,NULL,'SDSS J102140.23+080449.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000131,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,155.417667,8.08056,0.037,NULL,60760184259,949377879,14834029,18.4),(69979,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69979,32.83,0.45,36.7,25621,NULL,NULL,'K','NGC 3224',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.00006,NULL,'12.00',1.5,'E+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,155.421625,-34.69678,0.513,NULL,41996557443,656196210,10253065,12),(69980,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69980,33.19,0.4,43.5,25621,NULL,NULL,'mean','NGC 3224',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69981,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69981,36.73,0.15,222,25622,70,NULL,NULL,'NGC 3216',NULL,'2015arXiv151105856S',2015,1,1.18,NULL,'G',0.00009,NULL,'14.3g',0.81,'E:',NULL,NULL,NULL,NULL,1,155.421791667,23.92306,0.029,NULL,60937456494,952147757,14877308,14.3),(69982,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69982,37.41,0.19,304,25623,70,NULL,NULL,'2MASX J10214123+1532300',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,155.421833,15.54169,0.085,NULL,60961174784,952518356,14883099,16.5),(69983,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69983,37.8,0.27,363,25624,70,NULL,NULL,'2MASX J10214139+1006360',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000127,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,155.4227083,10.10997,0.077,NULL,60753868236,949279191,14832487,18.1),(69984,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69984,38.99,0.46,629,25625,70,NULL,NULL,'2MASX J10214152+2433544',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000184,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,155.4229583,24.565,0.037,NULL,60468856938,944825889,14762904,17.8),(69985,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69985,36.73,0.15,222,25626,70,NULL,NULL,'2MASX J10214229+2352457',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,155.426125,23.87936,0.029,NULL,60937469913,952147967,14877311,17),(69986,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69986,36.81,0.46,230,25627,70,NULL,NULL,'2MASX J10214259+3353475',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000187,NULL,'16.0g',0.39,NULL,NULL,NULL,NULL,NULL,1,155.4275417,33.89656,0.009,NULL,64088064975,1001376015,15646500,16),(69987,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69987,37.74,0.46,352,25628,70,NULL,NULL,'2MASX J10214446-0040202',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000098,NULL,'16.6g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,155.435333333,-0.67217,0.097,NULL,41206867294,643857301,10060270,16.6),(69988,'Brightest Stars','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69988,25.09,0.96,1.04,25629,NULL,NULL,NULL,'Leo P',NULL,'2013AJ....145..149R',2013,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,155.437917,18.08811,0.077,1,60993963061,953030672,14891104,NULL),(69989,'CMD','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69989,26.18,NULL,1.72,25629,NULL,NULL,NULL,'Leo P',NULL,'2015ApJ...811...35J',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69990,'RR Lyrae','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69990,26.05,0.19,1.62,25629,NULL,NULL,'RR Lyrae and Horizontal Branch','Leo P',NULL,'2015ApJ...812..158M',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69991,'TRGB','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69991,25.21,NULL,1.1,25629,NULL,NULL,'Star 7','Leo P',NULL,'2013AJ....145..149R',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69992,'TRGB','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69992,25.88,NULL,1.5,25629,NULL,NULL,'Star 11','Leo P',NULL,'2013AJ....145..149R',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69993,'TRGB','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69993,26.19,0.5,1.72,25629,NULL,NULL,NULL,'Leo P',NULL,'2013AJ....146..145M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69994,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69994,25.47,1.14,1.3,25629,NULL,NULL,NULL,'Leo P',NULL,'2013AJ....146...15G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69995,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,69995,34.88,0.69,94.7,25630,70,NULL,NULL,'ESO 567- G 056',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'15.49',0.8,'(R\'_2)SB(s)a',NULL,NULL,NULL,NULL,1,155.438291667,-18.41097,0.225,NULL,41662926117,650983220,10171612,15.49),(69996,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69996,37.4,0.33,303,25631,70,NULL,NULL,'2MASX J10214628+3617585',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000185,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,155.442917,36.29944,0,NULL,64072528407,1001133256,15642707,17.1),(69997,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69997,37.83,0.23,368,25632,70,NULL,NULL,'2MASX J10214655+0804490',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000163,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,155.443875,8.08039,0.037,NULL,60760186652,949377916,14834029,17.1),(69998,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69998,37.4,0.33,303,25633,70,NULL,NULL,'2MASX J10214659+3611595',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000171,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,155.4439583,36.19981,0,NULL,64072517670,1001133088,15642704,16.3),(69999,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',69999,36.41,0.27,192,25634,70,NULL,NULL,'2MASX J10214732+1536130',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,155.447125,15.60367,0.085,NULL,60961174501,952518351,14883099,17.1),(70000,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70000,31.23,0.43,17.7,25635,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3206',NULL,'2014MNRAS.444..527S',2014,1,2.2,NULL,'G',0.000003,NULL,'13.8g',1.03,'SB(s)cd','X-ray-faint group member',NULL,NULL,NULL,1,155.4482917,56.93042,0,NULL,61895789233,967121706,15111276,13.8),(70001,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70001,31.26,0.43,17.8,25635,75,NULL,'3.6 micron, color corrected','NGC 3206',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70002,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70002,31.29,0.2,18.1,25635,74.4,NULL,NULL,'NGC 3206',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70003,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70003,31.54,0.66,20.3,25635,NULL,NULL,NULL,'NGC 3206',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70004,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70004,31.55,0.66,20.5,25635,NULL,NULL,'Malmquist cor.','NGC 3206',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70005,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70005,31.61,0.4,21,25635,75,NULL,'B','NGC 3206',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70006,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70006,31.62,0.4,21.1,25635,NULL,NULL,NULL,'NGC 3206',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70007,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70007,32.82,0.2,36.6,25636,74.4,NULL,NULL,'NGC 3183',NULL,'2013AJ....146...86T',2013,1,2.3,'HOLM 177B is a star.','G',0.000023,NULL,'12.68',1.4,'SB(s)bc:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,155.454167,74.17686,0.113,NULL,61376703687,959010995,14984546,12.68),(70008,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70008,32.84,0.47,36.9,25636,NULL,NULL,'H','NGC 3183',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70009,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70009,32.84,0.45,37,25636,NULL,NULL,'K','NGC 3183',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70010,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70010,32.91,0.46,38.1,25636,NULL,NULL,'J','NGC 3183',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70011,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70011,33.21,0.4,43.9,25636,NULL,NULL,'mean','NGC 3183',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70012,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70012,36.35,0.46,186,25637,70,NULL,NULL,'2MASX J10214959+1704100',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,155.456667,17.06939,0.089,NULL,60963854140,952560220,14883753,17.4),(70013,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70013,37.08,0.46,260,25638,70,NULL,NULL,'2MASX J10214974+0251191',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000083,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,155.457417,2.85531,0.065,NULL,60746682815,949166918,14830733,16.5),(70014,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70014,35.67,0.46,136,25639,70,NULL,NULL,'CGCG 094-012',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000073,NULL,'15.6',0.53,NULL,NULL,NULL,NULL,NULL,1,155.459667,15.71475,0.097,NULL,60961191925,952518623,14883103,15.6),(70015,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70015,37.83,0.23,368,25640,70,NULL,NULL,'2MASX J10215039+0808340',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000188,NULL,'16.3g',0.4,NULL,NULL,NULL,NULL,NULL,1,155.459917,8.14275,0.037,NULL,60760141683,949377213,14834018,16.3),(70016,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70016,37.54,0.46,322,25641,70,NULL,NULL,'2MASX J10215065+4223188',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000189,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,155.461208333,42.38872,0,NULL,64152872484,1002388632,15662322,16.7),(70017,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70017,37.63,0.46,335,25642,70,NULL,NULL,'2MASX J10215087+4549498',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000138,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,155.462083,45.8305,0,NULL,64128334978,1002005234,15656331,17.1),(70018,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70018,38.51,0.46,504,25643,70,NULL,NULL,'2MASX J10215104+3228464',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000209,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,155.462667,32.47944,0,NULL,64085265797,1001332278,15645816,17.1),(70019,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70019,37.81,0.27,365,25644,70,NULL,NULL,'2MASX J10215129+4107495',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,155.463667,41.13056,0,NULL,64150816706,1002356511,15661820,17.8),(70020,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70020,36.8,0.17,230,25645,70,NULL,NULL,'2MASX J10215147+3844384',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00008,NULL,'16.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,155.4644583,38.74394,0,NULL,64093230548,1001456727,15647761,16.6),(70021,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70021,36.76,0.33,225,25646,70,NULL,NULL,'2MASX J10215203+3945324',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,155.466583333,39.75897,0,NULL,64148265001,1002316640,15661197,17.7),(70022,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70022,37.36,0.33,296,25647,70,NULL,NULL,'2MASX J10215257+4345318',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,155.468833333,43.75897,0,NULL,64146680878,1002291888,15660810,17.3),(70023,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70023,34.98,0.49,99.3,25648,75,NULL,'IR','UGC 05597',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000033,NULL,'15.55',0.2,'Sab',NULL,NULL,NULL,NULL,1,155.469083333,23.86083,0.029,NULL,60937463854,952147872,14877310,15.55),(70024,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70024,36.58,0.46,207,25649,70,NULL,NULL,'2MASX J10215284+2036037',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000169,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,155.470333,20.601,0.025,NULL,60942448189,952225752,14878527,16.5),(70025,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70025,37.8,0.27,363,25650,70,NULL,NULL,'SDSS J102152.88+100726.6',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000152,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,155.470375,10.12406,0.077,NULL,60752758278,949261848,14832216,17.5),(70026,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70026,37.01,0.85,252,25651,70,NULL,NULL,'2MASX J10215309-0721087',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'17.39',0.24,NULL,NULL,NULL,NULL,NULL,1,155.4712917,-7.35236,0.109,NULL,41246708000,644479812,10069997,17.39),(70027,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70027,37.4,0.27,302,25652,70,NULL,NULL,'2MASX J10215314+0212401',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000191,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,155.471417,2.21125,0.073,NULL,60750200330,949221880,14831591,16.4),(70028,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70028,36.73,0.15,222,25653,70,NULL,NULL,'2MASX J10215416+2342067',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000184,NULL,'17.55',0.19,NULL,NULL,NULL,NULL,NULL,1,155.475625,23.70194,0.029,NULL,60937305290,952145395,14877271,17.55),(70029,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70029,37.07,0.46,259,25654,70,NULL,NULL,'2MASX J10215415+4025034',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000175,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,155.475667,40.41769,0,NULL,64150275951,1002348061,15661688,18.2),(70030,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70030,37.81,0.27,365,25655,70,NULL,NULL,'2MASX J10215429+4106314',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,155.476083,41.10861,0,NULL,64150816474,1002356507,15661820,17.2),(70031,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70031,37.58,0.46,329,25656,70,NULL,NULL,'2MASX J10215489+5152366',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,155.478667,51.87678,0,NULL,63989730208,999839534,15622492,17.7),(70032,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70032,35.77,0.33,143,25657,70,NULL,NULL,'2MASX J10215524+2059377',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000168,NULL,'15.8g',0.44,NULL,NULL,NULL,NULL,NULL,1,155.480125,20.99389,0.025,NULL,60941676424,952213694,14878338,15.8),(70033,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70033,36.75,0.33,224,25658,70,NULL,NULL,'SDSS J102155.36+480303.0',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,155.480667,48.05089,0,NULL,64129852388,1002028943,15656702,17.2),(70034,'BCG','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70034,36.94,0.35,232,25659,60,NULL,NULL,'ABELL 0993',0.053,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,155.48075,-4.95267,0.097,NULL,41259879943,644685624,10073212,NULL),(70035,'BCG','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70035,36.94,0.35,232,25660,60,NULL,'ABELL 0993, BCG','MCG -01-27-005',0.053,'1980ApJ...241..486H',1980,1,0.25,'Beers, et al. (1995,AJ,109,874) give v = 12154 +/- 20 km/sec.','G',0.000033,NULL,'15.06',0.25,'S0/D','Group member',NULL,NULL,NULL,1,155.4827083,-4.89017,0.097,NULL,41259679766,644682496,10073164,15.06),(70036,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70036,38.16,0.46,428,25661,70,NULL,NULL,'2MASX J10215616+0322531',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,155.484083,3.38161,0.085,NULL,60739258221,949050909,14828920,17.9),(70037,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70037,36.73,0.15,222,25662,70,NULL,NULL,'2MASX J10215644+2354287',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00019,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,155.485333333,23.90794,0.029,NULL,60937464925,952147889,14877310,16.9),(70038,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70038,36.76,0.33,225,25663,70,NULL,NULL,'2MASX J10215721+3943434',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000186,NULL,'16.0g',0.38,'E0',NULL,NULL,NULL,NULL,1,155.488375,39.72872,0,NULL,64148259995,1002316562,15661196,16),(70039,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70039,36.92,0.19,242,25664,70,NULL,NULL,'SDSS J102157.87+361812.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000163,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,155.491167,36.30347,0,NULL,64072522607,1001133165,15642705,18),(70040,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70040,37.3,0.46,288,25665,70,NULL,NULL,'2MASX J10215822+5231406',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000181,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,155.492417,52.52806,0,NULL,63990247248,999847613,15622618,17.1),(70041,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70041,38.12,0.46,421,25666,70,NULL,NULL,'2MASX J10215834+2005407',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000181,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,155.493,20.09458,0.073,NULL,60943088573,952235758,14878683,18.1),(70042,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70042,37.67,0.46,342,25667,70,NULL,NULL,'2MASX J10215927+0738100',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,155.496958333,7.63628,0.017,NULL,60760069220,949376081,14834001,17.3),(70043,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70043,36.8,0.17,230,25668,70,NULL,NULL,'2MASX J10220045+3821424',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000087,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,155.5019583,38.36181,0,NULL,64093394165,1001459283,15647801,16.3),(70044,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70044,37.98,0.46,395,25669,70,NULL,NULL,'SDSS J102202.72+354328.9',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,155.511333333,35.72472,0,NULL,64076161262,1001190019,15643594,18),(70045,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70045,35.75,0.46,142,25670,70,NULL,NULL,'2MASX J10220417+2034565',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000174,NULL,'16.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,155.517291667,20.58225,0.025,NULL,60942442797,952225668,14878526,16),(70046,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70046,37.38,0.46,299,25671,70,NULL,NULL,'2MASX J10220454+0116574',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000078,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,155.518833,1.28253,0.069,NULL,60747633451,949181772,14830965,17.7),(70047,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70047,37.78,0.46,360,25672,70,NULL,NULL,'2MASX J10220466+4451438',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000159,NULL,'16.3g',0.4,NULL,NULL,NULL,NULL,NULL,1,155.5195,44.86225,0,NULL,64145979710,1002280932,15660639,16.3),(70048,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70048,36.97,0.46,248,25673,70,NULL,NULL,'2MASX J10220496+2516301',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.43',0.14,NULL,NULL,NULL,NULL,NULL,1,155.520583333,25.27503,0.029,NULL,60469200863,944831263,14762988,18.43),(70049,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70049,35.77,0.33,143,25674,70,NULL,NULL,'CGCG 124-015',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.000212,NULL,'14.7g',0.66,NULL,NULL,NULL,NULL,NULL,1,155.525125,21.06511,0.025,NULL,60941679712,952213745,14878339,14.7),(70050,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70050,37.79,0.33,362,25675,70,NULL,NULL,'2MASX J10220629+4841200',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,155.526167,48.68872,0,NULL,64129041904,1002016279,15656504,17),(70051,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70051,37.41,0.19,304,25676,70,NULL,NULL,'2MASX J10220652+1525505',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,155.5272083,15.43081,0.117,NULL,60965482089,952585657,14884150,16.5),(70052,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70052,36.36,0.5,187,25677,70,NULL,NULL,'2MASX J10220706-1135047',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000137,NULL,'15.47',NULL,NULL,NULL,NULL,NULL,NULL,1,155.529458333,-11.58458,0.201,NULL,41238632580,644353634,10068025,15.47),(70053,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70053,36.25,0.46,178,25678,70,NULL,NULL,'MCG +03-27-005',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000117,NULL,'16.83',0.27,'E3','Compact group member',NULL,NULL,NULL,1,155.529625,17.83811,0.089,NULL,60960745175,952511643,14882994,16.83),(70054,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70054,36.83,0.46,232,25679,70,NULL,NULL,'2MASX J10220749+4247198',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000164,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,155.531167,42.78875,0,NULL,64152498327,1002382786,15662231,16.6),(70055,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70055,37.83,0.23,368,25680,70,NULL,NULL,'2MASX J10220810+0809590',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,155.533667,8.16656,0.029,NULL,60760659698,949385307,14834145,17.8),(70056,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70056,37.79,0.33,362,25681,70,NULL,NULL,'SDSS J102208.23+484222.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000142,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,155.534375,48.70631,0,NULL,64129043682,1002016307,15656504,18.2),(70057,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70057,35.14,0.64,107,25682,70,NULL,NULL,'2MASX J10220873-0504257',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00015,NULL,'16.65',0.35,'SBa','Group member',NULL,NULL,NULL,1,155.536417,-5.07383,0.097,NULL,41259888895,644685763,10073215,16.65),(70058,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70058,37.05,0.89,257,25683,70,NULL,NULL,'LCRS B101938.5-052127',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.61',0.2,'Sb','Group member',NULL,NULL,NULL,1,155.539875,-5.61022,0.097,NULL,41260171524,644690180,10073284,16.61),(70059,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70059,36.64,0.46,213,25684,70,NULL,NULL,'2MASX J10220989+1410055',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000174,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,155.541375,14.16831,0.109,NULL,60954194216,952409284,14881395,16.9),(70060,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70060,38.07,0.46,412,25685,70,NULL,NULL,'SDSS J102210.01-000319.3',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000068,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,155.54175,-0.05539,0.085,NULL,41206491941,643851436,10060178,17.8),(70061,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70061,37.26,0.46,284,25686,70,NULL,NULL,'2MASX J10221013+0024214',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000094,NULL,'16.3g',0.36,'BrClG          AGN',NULL,NULL,NULL,NULL,1,155.5422917,0.40603,0.125,NULL,60736627378,949009802,14828278,16.3),(70062,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70062,37.41,0.19,304,25687,70,NULL,NULL,'2MASX J10221157+1525156',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,155.54825,15.42097,0.117,NULL,60965479094,952585610,14884150,16.8),(70063,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70063,36.64,0.46,213,25688,70,NULL,NULL,'2MASX J10221200+3706435',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000175,NULL,'15.9g',0.39,NULL,NULL,NULL,NULL,NULL,1,155.5502083,37.11197,0,NULL,64072282062,1001129407,15642646,15.9),(70064,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70064,37.2,0.46,275,25689,70,NULL,NULL,'2MASX J10221264+2024585',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,155.552583333,20.41642,0.025,NULL,60942375209,952224612,14878509,18),(70065,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70065,37.81,0.27,365,25690,70,NULL,NULL,'SDSS J102213.89+410329.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000152,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,155.557917,41.05822,0,NULL,64150590079,1002352969,15661765,18.5),(70066,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70066,34.2,0.49,69,25691,75,NULL,'IR','UGC 05598',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.00005,NULL,'14.8g',0.38,'S',NULL,NULL,NULL,NULL,1,155.558375,20.58942,0.025,NULL,60942410004,952225156,14878518,14.8),(70067,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70067,38.54,0.46,511,25692,70,NULL,NULL,'SDSS J102214.58+243824.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,155.56075,24.64019,0.037,NULL,60468859546,944825930,14762905,18.4),(70068,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70068,36.38,0.23,189,25693,70,NULL,NULL,'CGCG 094-015 NED02',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,155.565708333,14.91606,0.129,NULL,60953904608,952404759,14881324,16.3),(70069,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70069,37.36,0.46,297,25694,70,NULL,NULL,'SDSS J102216.21+253941.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000141,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,155.567583333,25.6615,0.033,NULL,60467517517,944804961,14762577,18.3),(70070,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70070,35.79,0.46,144,25695,70,NULL,NULL,'2MASX J10221759+3003016',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000156,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,155.5734583,30.05036,0.065,NULL,64028133580,1000439587,15631868,16.6),(70071,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70071,37.67,0.46,342,25696,70,NULL,NULL,'2MASX J10221833+2610011',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000161,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,155.576417,26.16706,0.045,NULL,60468163163,944815049,14762735,17.3),(70072,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70072,37.37,0.46,298,25697,70,NULL,NULL,'2MASX J10221896+1811525',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,155.578917,18.198,0.085,NULL,60994027159,953031674,14891119,17),(70073,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70073,37.36,0.46,296,25698,70,NULL,NULL,'2MASX J10221924+1335386',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,155.5802917,13.59394,0.089,NULL,60955061437,952422834,14881606,18.1),(70074,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70074,33.57,0.47,51.9,25699,NULL,NULL,'H','NGC 3221',NULL,'2007A&A...465...71T',2007,1,3.36,'The SDSS position is 4.1 arcsec southwest of the nucleus.','G',0.000017,NULL,'13.2g',0.71,'SB(s)cd:sp;HII;LIRG',NULL,NULL,NULL,NULL,1,155.58325,21.56958,0.029,NULL,60950989495,952359210,14880612,13.2),(70075,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70075,33.59,0.45,52.3,25699,NULL,NULL,'K','NGC 3221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70076,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70076,33.72,0.46,55.3,25699,NULL,NULL,'J','NGC 3221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70077,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70077,33.83,0.49,58.3,25699,75,NULL,'IR','NGC 3221',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70078,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70078,33.97,0.4,62.2,25699,NULL,NULL,'mean','NGC 3221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70079,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70079,37.71,0.46,348,25700,70,NULL,NULL,'2MASX J10222016+2647381',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000153,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,155.584,26.79392,0.041,NULL,64023152874,1000361763,15630652,18.4),(70080,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70080,36.98,0.46,249,25701,70,NULL,NULL,'2MASX J10222020+2740371',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000206,NULL,'15.9g',0.41,NULL,NULL,NULL,NULL,NULL,1,155.584333333,27.677,0.061,NULL,64036628627,1000572322,15633942,15.9),(70081,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70081,37.4,0.27,302,25702,70,NULL,NULL,'2MASX J10222155+0220154',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000092,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,155.5897917,2.33756,0.073,NULL,60749698379,949214037,14831469,16.5),(70082,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70082,37.36,0.33,296,25703,70,NULL,NULL,'2MASX J10222283+4343046',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.00019,NULL,'16.0g',0.39,NULL,NULL,NULL,NULL,NULL,1,155.5952083,43.71806,0,NULL,64146692675,1002292073,15660813,16),(70083,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70083,37.9,0.46,381,25704,70,NULL,NULL,'2MASX J10222292+0758467',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,155.5954583,7.97972,0.025,NULL,60760738393,949386537,14834164,17.7),(70084,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70084,36.7,0.46,219,25705,70,NULL,NULL,'2MASX J10222378+5432533',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000166,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,155.599,54.54811,0,NULL,61907002641,967296916,15114014,16.5),(70085,'IRAS','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70085,34.87,0.8,94.2,25706,75,NULL,'CF, r','UGC 05607',NULL,'1997ApJS..109..333W',1997,1,1.57,NULL,'G',0.000027,NULL,'14.2g',0.55,'Sb','Field galaxy',NULL,NULL,NULL,1,155.6017083,3.99736,0.029,NULL,60741513051,949086141,14829470,14.2),(70086,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70086,34.66,0.39,85.6,25706,NULL,NULL,NULL,'UGC 05607',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70087,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70087,34.68,0.39,86.3,25706,NULL,NULL,'Malmquist cor.','UGC 05607',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70088,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70088,34.72,0.2,87.9,25706,74.4,NULL,NULL,'UGC 05607',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70089,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70089,34.95,0.38,97.9,25706,75,NULL,'CF, r, raw','UGC 05607',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70090,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70090,35.14,0.38,107,25706,75,NULL,'CF, r, inv','UGC 05607',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70091,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70091,35.16,0.4,108,25706,NULL,NULL,'mean','UGC 05607',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70092,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70092,35.21,0.38,110,25706,75,NULL,'CF, r, cor','UGC 05607',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70093,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70093,35.38,0.46,119,25706,NULL,NULL,'J','UGC 05607',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70094,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70094,35.39,0.45,120,25706,NULL,NULL,'K','UGC 05607',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70095,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70095,35.42,0.47,121,25706,NULL,NULL,'H','UGC 05607',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70096,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70096,36.94,0.46,245,25707,70,NULL,NULL,'SDSS J102226.34+232108.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000169,NULL,'17.4g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,155.6097917,23.35239,0.029,NULL,60937634488,952150538,14877352,17.4),(70097,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70097,38.34,0.46,465,25708,70,NULL,NULL,'2MASX J10222655+5601333',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,155.610541667,56.02589,0,NULL,61899365317,967177583,15112149,17.9),(70098,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70098,36.41,0.27,192,25709,70,NULL,NULL,'CGCG 094-017',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00009,NULL,'15.7',0.42,'AGN',NULL,NULL,NULL,NULL,1,155.618916667,15.75389,0.097,NULL,60961142105,952517845,14883091,15.7),(70099,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70099,37.75,0.46,354,25710,70,NULL,NULL,'2MASX J10222891+1804505',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,155.6204583,18.08075,0.077,NULL,60960643160,952510049,14882969,18.2),(70100,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70100,36.41,0.27,192,25711,70,NULL,NULL,'2MASX J10223013+1553135',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,155.6255,15.88708,0.097,NULL,60961993190,952531143,14883299,16.7),(70101,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70101,34.38,0.54,75.2,25712,NULL,NULL,'Malmquist cor.','ESO 375- G 015',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.52',0.4,'Sb?',NULL,NULL,NULL,NULL,1,155.628625,-36.98039,0.237,NULL,41994255057,656160235,10252503,15.52),(70102,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70102,34.56,0.49,81.8,25712,NULL,NULL,NULL,'ESO 375- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70103,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70103,34.6,0.2,83.2,25712,74.4,NULL,NULL,'ESO 375- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70104,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70104,36.43,0.46,194,25713,70,NULL,NULL,'2MASX J10223191+5134560',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000159,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,155.6327917,51.58239,0,NULL,63991596301,999868692,15622948,16.4),(70105,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70105,37.57,0.27,326,25714,70,NULL,NULL,'SDSS J102234.02+101812.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000154,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,155.64175,10.30344,0.085,NULL,60752686888,949260732,14832198,17.9),(70106,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70106,36.38,0.23,189,25715,70,NULL,NULL,'2MASX J10223413+1459296',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,155.642166667,14.9915,0.129,NULL,60953914143,952404908,14881326,16.7),(70107,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70107,37.87,0.46,375,25716,70,NULL,NULL,'2MASX J10223427+6442007',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000173,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,155.643,64.70025,0.041,NULL,62110761250,970480644,15163760,16.9),(70108,'Faber-Jackson','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70108,32.96,0.67,39.1,25717,95,NULL,'Weighted Mean','NGC 3222',NULL,'1984ApJS...56...91D',1984,1,1.3,NULL,'G',0.00009,NULL,'13.7',1.1,'SB0:',NULL,NULL,NULL,NULL,1,155.6437917,19.88703,0.069,NULL,60942954500,952233664,14878651,13.7),(70109,'Faber-Jackson','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70109,32.96,0.67,39.1,25717,95,NULL,'de Vaucouleurs','NGC 3222',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70110,'Tertiary','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70110,33.69,0.5,54.7,25717,95,NULL,NULL,'NGC 3222',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70111,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70111,34.56,0.2,81.7,25718,74.4,NULL,NULL,'UGC 05599',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000189,NULL,'15.4g',0.49,'Sd',NULL,NULL,NULL,NULL,1,155.6472917,43.84731,0,NULL,64146658423,1002291537,15660805,15.4),(70112,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70112,34.66,0.41,85.7,25718,NULL,NULL,NULL,'UGC 05599',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70113,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70113,34.89,0.37,95.2,25718,NULL,NULL,'Malmquist cor.','UGC 05599',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70114,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70114,35.98,0.46,157,25719,70,NULL,NULL,'VIII Zw 070',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00018,NULL,'16.2g',0.25,'S0',NULL,NULL,NULL,NULL,1,155.649375,13.93747,0.105,NULL,60955246636,952425728,14881652,16.2),(70115,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70115,36.04,0.52,161,25720,70,NULL,NULL,'CGCG 009-012',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.000083,NULL,'15.88',0.55,NULL,NULL,NULL,NULL,NULL,1,155.650583,-3.62006,0.101,NULL,41216494806,644007731,10062620,15.88),(70116,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70116,36.38,0.23,189,25721,70,NULL,NULL,'2MASX J10223654+1506226',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'15.8g',0.41,NULL,NULL,NULL,NULL,NULL,1,155.65225,15.10625,0.129,NULL,60965376756,952584011,14884125,15.8),(70117,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70117,36.62,0.46,210,25722,70,NULL,NULL,'2MASX J10223694+3243177',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,155.653833333,32.72169,0,NULL,64088490088,1001382657,15646604,16.5),(70118,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70118,36.8,0.17,230,25723,70,NULL,NULL,'NGC 3219',NULL,'2015arXiv151105856S',2015,1,0.97,NULL,'G',0.000087,NULL,'14.9g',0.6,'E;BrClG        AGN',NULL,NULL,NULL,NULL,1,155.656,38.57917,0,NULL,64093264367,1001457255,15647769,14.9),(70119,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70119,36.04,0.46,161,25724,70,NULL,NULL,'CGCG 094-020',NULL,'2015arXiv151105856S',2015,1,1.18,NULL,'G',0.000227,NULL,'14.5g',0.61,NULL,NULL,NULL,NULL,NULL,1,155.6572917,19.39686,0.093,NULL,60939345520,952177273,14877769,14.5),(70120,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70120,36.92,0.33,242,25725,70,NULL,NULL,'2MASX J10223873+1205176',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000188,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,155.661333,12.08831,0.093,NULL,61169744470,955777257,14934019,16.6),(70121,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70121,37.41,0.19,304,25726,70,NULL,NULL,'2MASX J10223895+1527516',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,155.66225,15.46442,0.101,NULL,60965431068,952584860,14884138,16.3),(70122,'IRAS','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70122,34.27,0.8,71.3,25727,75,NULL,'CF, r','UGC 05604',NULL,'1997ApJS..109..333W',1997,1,2.05,NULL,'G',0.000023,NULL,'14.2g',0.89,'Sc',NULL,NULL,NULL,NULL,1,155.669708333,46.23869,0,NULL,64130460118,1002038439,15656850,14.2),(70123,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70123,33.8,0.38,57.6,25727,75,NULL,'CF, r, raw','UGC 05604',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70124,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70124,33.92,0.38,60.9,25727,75,NULL,'CF, r, inv','UGC 05604',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70125,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70125,34.02,0.38,63.7,25727,75,NULL,'CF, r, cor','UGC 05604',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70126,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70126,34.41,0.5,76.1,25727,NULL,NULL,NULL,'UGC 05604',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70127,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70127,34.45,0.2,77.6,25727,74.4,NULL,NULL,'UGC 05604',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70128,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70128,34.59,0.46,83,25727,NULL,NULL,'Malmquist cor.','UGC 05604',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70129,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70129,37.13,0.46,266,25728,70,NULL,NULL,'2MASX J10224093+2920465',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000171,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,155.670417,29.34633,0.041,NULL,64027591493,1000431117,15631736,17.2),(70130,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70130,37.48,0.46,313,25729,70,NULL,NULL,'2MASX J10224121+0912307',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000166,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,155.671791667,9.20842,0.061,NULL,60752617869,949259654,14832182,17),(70131,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70131,37.57,0.27,326,25730,70,NULL,NULL,'2MASX J10224120+1020147',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000159,NULL,'17.2g',0.22,'BrClG',NULL,NULL,NULL,NULL,1,155.671791667,10.33758,0.085,NULL,60752716206,949261190,14832206,17.2),(70132,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70132,37.19,0.46,274,25731,70,NULL,NULL,'2MASX J10224155+3827057',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000093,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,155.6730417,38.45158,0,NULL,64093261788,1001457215,15647768,17.2),(70133,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70133,36,0.33,159,25732,70,NULL,NULL,'2MASX J10224205+1444466',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,155.67525,14.74633,0.141,NULL,60954596692,952415573,14881493,16.4),(70134,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70134,36.88,0.46,238,25733,70,NULL,NULL,'2MASX J10224210+1743466',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,155.675583,17.72969,0.101,NULL,60960761478,952511898,14882998,16.3),(70135,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70135,36.32,0.46,184,25734,70,NULL,NULL,'2MASX J10224408+0400243',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,155.6835417,4.00681,0.033,NULL,60741753105,949089892,14829529,17),(70136,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70136,36,0.33,159,25735,70,NULL,NULL,'2MASX J10224426+1438416',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,155.684417,14.64483,0.133,NULL,60954762960,952418171,14881533,16.2),(70137,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70137,38.46,0.33,492,25736,70,NULL,NULL,'SDSS J102247.36+083332.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,155.697333,8.55906,0.033,NULL,60759849897,949372654,14833947,18),(70138,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70138,37.45,0.46,309,25737,70,NULL,NULL,'SDSS J102248.34+004618.5',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000075,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,155.701417,0.77181,0.101,NULL,60736309172,949004830,14828200,17.4),(70139,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70139,35.95,0.46,155,25738,70,NULL,NULL,'CGCG 094-021',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.00009,NULL,'15.3',0.52,NULL,NULL,NULL,NULL,NULL,1,155.7017083,14.93128,0.141,NULL,60953865985,952404156,14881314,15.3),(70140,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70140,37.61,0.46,333,25739,70,NULL,NULL,'2MASX J10224914+0057563',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000079,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,155.704667,0.96569,0.081,NULL,60736400228,949006253,14828222,17.3),(70141,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70141,38.06,0.46,409,25740,70,NULL,NULL,'2MASX J10224976+1130078',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000141,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,155.707375,11.50219,0.077,NULL,61035634418,953681787,14901277,17.7),(70142,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70142,37.45,0.46,309,25741,70,NULL,NULL,'2MASX J10225072+5207580',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,155.711208333,52.13294,0,NULL,63990198677,999846854,15622607,17.3),(70143,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70143,36.21,0.46,175,25742,70,NULL,NULL,'IC 2569',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000087,NULL,'15.3g',0.55,NULL,NULL,NULL,NULL,NULL,1,155.7232917,24.60642,0.021,NULL,60466854278,944794598,14762415,15.3),(70144,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70144,36.82,0.46,231,25743,70,NULL,NULL,'2MASX J10225695-0110391',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000075,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,155.7372917,-1.17769,0.101,NULL,41206202648,643846916,10060108,17),(70145,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70145,37.86,0.46,374,25744,70,NULL,NULL,'2MASX J10225703+4453265',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000124,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,155.737667,44.89064,0,NULL,64145948332,1002280442,15660631,18.2),(70146,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70146,38.33,0.46,464,25745,70,NULL,NULL,'2MASX J10225775+4335135',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00015,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,155.7405,43.58706,0,NULL,64146646977,1002291359,15660802,18),(70147,'GRB','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70147,42.63,NULL,3350,25746,70,NULL,'Pseudo z = 1.86','GRB 020317',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,155.75,12.71667,0.101,NULL,60951823375,952372240,14880816,NULL),(70148,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70148,38.35,0.21,467,25747,70,NULL,NULL,'2MASX J10230086+3715586',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000161,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,155.753625,37.26617,0,NULL,64072439478,1001131866,15642685,17.1),(70149,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70149,37.02,0.46,254,25748,70,NULL,NULL,'2MASX J10230201+1704215',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,155.758458333,17.07272,0.105,NULL,60964207367,952565740,14883839,17.4),(70150,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70150,37.73,0.46,352,25749,70,NULL,NULL,'SDSS J102302.84-005905.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000056,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,155.761875,-0.98486,0.097,NULL,41206386955,643849796,10060153,18.1),(70151,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70151,37.7,0.46,346,25750,70,NULL,NULL,'2MASX J10230296+0756198',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000174,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,155.7622917,7.93883,0.025,NULL,60760763974,949386937,14834170,17.1),(70152,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70152,36.06,0.5,163,25751,70,NULL,NULL,'CGCG 009-014',NULL,'2014MNRAS.445.2677S',2014,1,0.95,NULL,'G',0.000097,NULL,'15.46',0.61,NULL,NULL,NULL,NULL,NULL,1,155.766083,-3.62094,0.101,NULL,41216584945,644009139,10062642,15.46),(70153,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70153,38.46,0.33,492,25752,70,NULL,NULL,'SDSS J102304.53+084433.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,155.768917,8.74258,0.033,NULL,60763966089,949436970,14834952,18.5),(70154,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70154,37.14,0.46,268,25753,70,NULL,NULL,'2MASX J10230499+0448397',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000158,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,155.770833,4.811,0.025,NULL,60738233398,949034896,14828670,17.1),(70155,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70155,37.75,0.46,356,25754,70,NULL,NULL,'2MASX J10230526+4735282',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000133,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,155.772083,47.59131,0,NULL,64129507224,1002023550,15656617,17.4),(70156,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70156,37.83,0.23,369,25755,70,NULL,NULL,'2MASX J10230610-0012031',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000103,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,155.775333,-0.20086,0.129,NULL,41206667603,643854181,10060221,17.4),(70157,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70157,37.93,0.46,386,25756,70,NULL,NULL,'SDSS J102308.00+590614.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,155.783333,59.10403,0.013,NULL,61948075271,967938676,15124041,17.9),(70158,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70158,35,0.27,100,25757,70,NULL,NULL,'NGC 3214',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.00008,NULL,'14.7g',0.53,'SA0/a:','Group member',NULL,NULL,NULL,1,155.786625,57.03908,0,NULL,61896274441,967129288,15111395,14.7),(70159,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70159,36.07,0.46,164,25758,70,NULL,NULL,'2MASX J10230906+3254274',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000182,NULL,'15.7g',0.4,NULL,NULL,NULL,NULL,NULL,1,155.787625,32.90753,0,NULL,64088671080,1001385485,15646648,15.7),(70160,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70160,37.23,0.46,280,25759,70,NULL,NULL,'2MASX J10230901+3749144',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,155.787625,37.82064,0,NULL,64063813337,1000997083,15640579,17.4),(70161,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70161,37.4,0.27,302,25760,70,NULL,NULL,'SDSS J102309.04+023129.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,155.7877083,2.52497,0.073,NULL,60748594098,949196782,14831199,17.7),(70162,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70162,37.76,0.33,357,25761,70,NULL,NULL,'SDSS J102310.58+474916.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000159,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,155.794125,47.82122,0,NULL,64129829384,1002028584,15656696,18.7),(70163,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70163,37.57,0.27,326,25762,70,NULL,NULL,'2MASX J10231062+1022563',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000159,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,155.79425,10.38231,0.085,NULL,60752670090,949260470,14832194,17.3),(70164,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70164,36.98,0.46,249,25763,70,NULL,NULL,'2MASX J10231185+1242585',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00017,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,155.799416667,12.71614,0.101,NULL,60951824910,952372264,14880816,17.8),(70165,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70165,36.19,0.46,173,25764,70,NULL,NULL,'2MASX J10231195+1624465',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,155.7997917,16.41303,0.093,NULL,60961440384,952522506,14883164,16.7),(70166,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70166,36.71,0.46,220,25765,70,NULL,NULL,'2MASX J10231205+2618057',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'16.60',0.21,NULL,NULL,NULL,NULL,NULL,1,155.800125,26.30169,0.045,NULL,60467269467,944801085,14762516,16.6),(70167,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70167,37.21,0.46,277,25766,70,NULL,NULL,'2MASX J10231264+0859103',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000151,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,155.802541667,8.98611,0.053,NULL,60763957963,949436843,14834950,17.3),(70168,'IRAS','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70168,32.63,0.8,33.6,25767,75,NULL,'HMCL, I','ESO 263- G 031',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000026,NULL,'14.90',0.7,'SAB(rl)a:',NULL,NULL,NULL,NULL,1,155.8035417,-47.33847,NULL,NULL,42103854021,657872719,10279261,14.9),(70169,'Tully est','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70169,32.68,0.8,34.4,25767,75,NULL,NULL,'ESO 263- G 031',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70170,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70170,32.2,0.4,27.5,25767,NULL,NULL,NULL,'ESO 263- G 031',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70171,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70171,32.2,0.4,27.5,25767,73,NULL,'opt','ESO 263- G 031',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70172,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70172,32.33,0.4,29.2,25767,75,NULL,'HMCL, I, raw','ESO 263- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70173,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70173,32.35,0.4,29.5,25767,75,NULL,'HMCL, I, inv','ESO 263- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70174,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70174,32.64,0.4,33.8,25767,75,NULL,'HMCL, I, cor','ESO 263- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70175,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70175,33.69,0.47,54.6,25768,NULL,NULL,'H','ARK 242',NULL,'2007A&A...465...71T',2007,1,0.5,'2dF final data release has z = 0.01870 +- 0.00021.','G',0.000033,NULL,'14.95',0.25,NULL,NULL,NULL,NULL,NULL,1,155.8055,-3.23392,0.097,NULL,41214570261,643977660,10062150,14.95),(70176,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70176,33.91,0.46,60.6,25768,NULL,NULL,'J','ARK 242',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70177,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70177,33.95,0.45,61.6,25768,NULL,NULL,'K','ARK 242',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70178,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70178,34.13,0.4,66.9,25768,NULL,NULL,'mean','ARK 242',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70179,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70179,36.49,0.27,199,25769,70,NULL,NULL,'2MASX J10231399+4126454',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000175,NULL,'16.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,155.8084583,41.44603,0,NULL,64150423644,1002350369,15661724,16.3),(70180,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70180,37.92,0.46,383,25770,70,NULL,NULL,'2MASX J10231423+0738113',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000146,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,155.80925,7.63639,0.021,NULL,60760454769,949382105,14834095,17.5),(70181,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70181,38.06,0.33,408,25771,70,NULL,NULL,'2MASX J10231495+0812523',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00018,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,155.8122083,8.21442,0.029,NULL,60760722204,949386284,14834160,17.4),(70182,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70182,37.98,0.46,395,25772,70,NULL,NULL,'2MASX J10231496+2832327',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000208,NULL,'16.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,155.812375,28.54239,0.033,NULL,64028932865,1000452076,15632063,16.4),(70183,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70183,38.59,0.46,521,25773,70,NULL,NULL,'2MASX J10231573+4359583',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00018,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,155.81575,43.99967,0,NULL,64146148149,1002283564,15660680,17.3),(70184,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70184,36.88,0.46,238,25774,70,NULL,NULL,'2MASX J10231642+2110080',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000182,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,155.818417,21.16886,0.025,NULL,60947961562,952311899,14879873,16.2),(70185,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70185,37.86,0.46,373,25775,70,NULL,NULL,'2MASX J10231688+4057034',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000145,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,155.8202917,40.95081,0,NULL,64150573075,1002352704,15661761,18.4),(70186,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70186,37.31,0.46,290,25776,70,NULL,NULL,'2MASX J10231725+0158067',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00008,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,155.8219583,1.96858,0.061,NULL,60748876845,949201200,14831268,16.8),(70187,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70187,37.33,0.46,292,25777,70,NULL,NULL,'2MASX J10231730+5239221',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000182,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,155.8222083,52.65625,0,NULL,63989961738,999843152,15622549,17.2),(70188,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70188,36.93,0.46,243,25778,70,NULL,NULL,'2MASX J10231785+1826170',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'16.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,155.824375,18.43808,0.117,NULL,60994039600,953031868,14891122,16.9),(70189,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70189,37.81,0.21,365,25779,70,NULL,NULL,'2MASX J10231824+3554114',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000183,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,155.825833,35.90311,0,NULL,64075724629,1001183197,15643487,17.3),(70190,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70190,37.49,0.46,315,25780,70,NULL,NULL,'2MASX J10231951+0945004',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,155.8314583,9.75008,0.065,NULL,60753328775,949270762,14832355,17.1),(70191,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70191,36.95,0.27,246,25781,70,NULL,NULL,'VIII Zw 073a',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000183,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,155.83475,8.8635,0.049,NULL,60763986006,949437281,14834957,16.5),(70192,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70192,36.47,0.46,197,25782,70,NULL,NULL,'2MASX J10232151+5718223',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000185,NULL,'16.2g',0.37,'E0',NULL,NULL,NULL,NULL,1,155.839416667,57.30625,0,NULL,61924894642,967576478,15118382,16.2),(70193,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70193,35.47,NULL,124,25783,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05616',NULL,'2010Ap&SS.325..163P',2010,1,1.08,'HOLM 188B is a star.','G',0.000014,NULL,'16.0g',0.21,'Scd',NULL,NULL,NULL,NULL,1,155.8414583,9.9375,0.085,NULL,60752850816,949263294,14832238,16);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (70194,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70194,35.48,NULL,125,25783,NULL,NULL,'Dipole + Quadrupole','UGC 05616',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70195,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70195,35.5,NULL,126,25783,NULL,NULL,NULL,'UGC 05616',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70196,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70196,35.5,NULL,126,25783,NULL,NULL,'Dipole','UGC 05616',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70197,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70197,35.77,0.42,143,25783,NULL,NULL,'Malmquist cor.','UGC 05616',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70198,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70198,35.89,0.2,151,25783,74.4,NULL,NULL,'UGC 05616',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70199,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70199,35.98,0.39,157,25783,NULL,NULL,NULL,'UGC 05616',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70200,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70200,38.8,0.33,576,25784,70,NULL,NULL,'2MASX J10232247+0023417',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000081,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,155.843583333,0.395,0.117,NULL,60735968216,948999503,14828117,17.3),(70201,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70201,34.9,0.25,95.5,25785,74.4,NULL,NULL,'2MASX J10232244+1305365',NULL,'2013AJ....146...86T',2013,1,0.47,NULL,'G',0.000028,NULL,'15.9g',0.34,'E',NULL,NULL,NULL,NULL,1,155.843708333,13.0935,0.125,NULL,60952654562,952385227,14881019,15.9),(70202,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70202,35.75,0.27,142,25785,70,NULL,NULL,'2MASX J10232244+1305365',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70203,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70203,36.95,0.27,246,25786,70,NULL,NULL,'VIII Zw 073b',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000213,NULL,'16.0g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,155.84425,8.86697,0.049,NULL,60763986838,949437294,14834957,16),(70204,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70204,37.51,0.46,318,25787,70,NULL,NULL,'2MASX J10232346+4512203',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000145,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,155.847791667,45.20567,0,NULL,64146030799,1002281731,15660652,17.4),(70205,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70205,35.41,0.25,121,25788,74.4,NULL,NULL,'CGCG 065-015',NULL,'2013AJ....146...86T',2013,1,0.99,NULL,'G',0.000033,NULL,'14.4g',0.71,'BrClG','Brightest group member',NULL,NULL,NULL,1,155.849,12.83506,0.113,NULL,60952609665,952384526,14881008,14.4),(70206,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70206,35.75,0.27,142,25788,70,NULL,NULL,'CGCG 065-015',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70207,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70207,37.48,0.46,314,25789,70,NULL,NULL,'2MASX J10232404+4145124',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000195,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,155.850041667,41.75356,0,NULL,64152333505,1002380211,15662190,16.1),(70208,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70208,33.9,0.44,60.3,25790,NULL,NULL,NULL,'CGCG 009-016',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000023,NULL,'15.5',0.4,'SBab',NULL,NULL,NULL,NULL,1,155.851875,-3.38892,0.101,NULL,41216411953,644006436,10062600,15.5),(70209,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70209,34.24,0.38,70.5,25790,NULL,NULL,'Malmquist cor.','CGCG 009-016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70210,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70210,37.65,0.46,340,25791,70,NULL,NULL,'2MASX J10232482+4338203',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,155.853625,43.63911,0,NULL,64146651270,1002291426,15660803,17.4),(70211,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70211,36.07,0.33,164,25792,70,NULL,NULL,'2MASX J10232540+1036564',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,'PRED','15.8g',0.41,NULL,NULL,NULL,NULL,NULL,1,155.855875,10.61575,0.117,NULL,61035775661,953683994,14901312,15.8),(70212,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70212,36.92,0.33,242,25793,70,NULL,NULL,'2MASX J10232574+1201284',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,155.8572917,12.02467,0.085,NULL,61035559092,953680610,14901259,17.5),(70213,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70213,35.75,0.27,142,25794,70,NULL,NULL,'MCG +02-27-005 NED01',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'11.4K',NULL,NULL,NULL,NULL,NULL,NULL,1,155.8597083,12.81569,0.113,NULL,60952576420,952384006,14881000,11.4),(70214,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70214,35.58,0.25,131,25795,74.4,NULL,NULL,'MCG +02-27-005',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'GPair',0.000031,NULL,NULL,NULL,'E',NULL,NULL,NULL,NULL,1,155.860541667,12.81533,0.113,NULL,60952576421,952384006,14881000,NULL),(70215,'SBF','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70215,31.86,0.14,23.6,25796,74.4,NULL,NULL,'NGC 3226',NULL,'2013AJ....146...86T',2013,1,3.2,'z=0.003839 (1994A&A...286..389H)','G',0.000017,NULL,'12.3',2.8,'E2: pec;LINER  Sy3','Pair member (points to parent)',NULL,NULL,'LINER b',1,155.862541667,19.89853,0.021,NULL,60940662989,952197859,14878091,12.3),(70216,'SBF','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70216,31.86,0.24,23.6,25796,NULL,NULL,'I','NGC 3226',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70217,'SBF','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70217,31.86,0.24,23.6,25796,NULL,NULL,NULL,'NGC 3226',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70218,'SBF','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70218,31.89,0.24,23.8,25796,NULL,NULL,'Malmquist cor.','NGC 3226',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70219,'D-Sigma','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70219,32.31,0.4,28.9,25796,75,NULL,'Edat, raw','NGC 3226',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70220,'D-Sigma','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70220,32.48,0.4,31.3,25796,75,NULL,'Edat, cor','NGC 3226',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70221,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70221,33.04,0.41,40.6,25796,NULL,NULL,NULL,'NGC 3226',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70222,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70222,33.19,0.41,43.5,25796,NULL,NULL,'Malmquist cor.','NGC 3226',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70223,'Tully est','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70223,31.84,0.8,23.4,25796,75,NULL,'B','NGC 3226',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70224,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70224,36.07,0.33,164,25797,70,NULL,NULL,'2MASX J10232702+1036124',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000162,NULL,'15.6g',0.37,'S0',NULL,NULL,NULL,NULL,1,155.86275,10.6035,0.117,NULL,61039184350,953737255,14902144,15.6),(70225,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70225,37.46,0.46,311,25798,70,NULL,NULL,'SDSS J102327.12+013941.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000186,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,155.863,1.66144,0.073,NULL,60748737616,949199025,14831234,17.7),(70226,'SNIa','2016-12-15 15:14:37','2016-12-16 11:19:44','1','SN 1997aw',NULL,70226,42.57,0.4,2270,25799,65,NULL,NULL,'H-ZSNS J102328.21+040711.1',0.6,'2004ApJ...607..665R',2004,1,NULL,NULL,'G',NULL,'?',NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,155.867541667,4.11975,0.033,NULL,60741891961,949092061,14829563,NULL),(70227,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70227,37.56,0.46,325,25800,70,NULL,NULL,'SDSS J102328.84+115007.9',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000149,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,155.870167,11.83556,0.077,NULL,61035771779,953683934,14901311,17.6),(70228,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70228,38.35,0.21,467,25801,70,NULL,NULL,'SDSS J102329.13+371533.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,155.871375,37.25939,0,NULL,64072445021,1001131953,15642686,18.2),(70229,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70229,33.8,0.49,57.6,25802,75,NULL,'IR','IC 2573',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000033,NULL,'15.31',0.3,'SB(s)d: sp',NULL,NULL,NULL,NULL,1,155.87575,-35.45558,0.333,NULL,41997132136,656205189,10253206,15.31),(70230,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70230,34.04,0.12,64.4,25802,NULL,NULL,NULL,'IC 2573',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70231,'AGN time lag','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70231,30.81,0.09,14.5,25803,NULL,NULL,NULL,'NGC 3227',NULL,'2014ApJ...784L..11Y',2014,1,5.4,NULL,'G',0.00001,NULL,'11.1',3.6,'SAB(s) pec     Sy1.5','Pair member (points to parent)',NULL,NULL,'Sy 2',1,155.877417,19.86506,0.021,NULL,60940656564,952197758,14878089,11.1),(70232,'AGN time lag','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70232,32.46,0.61,31,25803,44,NULL,NULL,'NGC 3227',NULL,'2007MNRAS.380..669C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70233,'Sosies','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70233,31.62,0.29,21.1,25803,NULL,NULL,NULL,'NGC 3227',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70234,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70234,31.57,0.4,20.6,25803,75,NULL,'B','NGC 3227',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70235,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70235,31.73,NULL,22.2,25803,NULL,NULL,NULL,'NGC 3227',NULL,'2015AstBu..70....1K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70236,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70236,31.87,NULL,23.7,25803,NULL,NULL,'LEDA [April 2006]','NGC 3227',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70237,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70237,38.1,0.27,416,25804,70,NULL,NULL,'2MASX J10233213+0010256',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000103,NULL,'15.2r',0.47,'BrClG',NULL,NULL,NULL,NULL,1,155.88375,0.17372,0.113,NULL,60735922418,948998787,14828106,15.2),(70238,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70238,37.32,0.46,292,25805,70,NULL,NULL,'2MASX J10233276+3804174',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000166,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,155.8865,38.07158,0,NULL,64147695250,1002307738,15661058,16.8),(70239,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70239,38.06,0.33,408,25806,70,NULL,NULL,'SDSS J102333.78+081116.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000141,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,155.890791667,8.18803,0.025,NULL,60760610246,949384535,14834133,18.4),(70240,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70240,37.83,0.23,369,25807,70,NULL,NULL,'2MASX J10233557-0013179',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.0001,NULL,'16.2g',0.42,'BrClG',NULL,NULL,NULL,NULL,1,155.898125,-0.22156,0.129,NULL,41206633459,643853647,10060213,16.2),(70241,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70241,36.9,0.46,240,25808,70,NULL,NULL,'SDSS J102335.94+484930.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000163,NULL,'18.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,155.89975,48.82514,0,NULL,64128866465,1002013538,15656461,18.1),(70242,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70242,38.29,0.23,454,25809,70,NULL,NULL,'2MASX J10233610+3722504',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,155.900583,37.38058,0,NULL,64072406715,1001131354,15642677,18),(70243,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70243,38.13,0.27,422,25810,70,NULL,NULL,'2MASX J10233801+0838313',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,155.908333,8.64214,0.045,NULL,60759974483,949374601,14833978,17.6),(70244,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70244,35.43,0.46,122,25811,70,NULL,NULL,'CGCG 065-018',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000063,NULL,'15.0g',0.57,'E0',NULL,NULL,NULL,NULL,1,155.909083,13.95772,0.081,NULL,60955207306,952425114,14881642,15),(70245,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70245,38.29,0.23,454,25812,70,NULL,NULL,'2MASX J10233896+3723254',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,'PRED','17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,155.9124583,37.39044,0,NULL,64072408946,1001131389,15642677,17.4),(70246,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70246,38.1,0.27,416,25813,70,NULL,NULL,'2MASX J10233913+0010216',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000076,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,155.913125,0.17269,0.113,NULL,60735931047,948998922,14828108,17.3),(70247,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70247,38.35,0.21,467,25814,70,NULL,NULL,'2MASX J10233941+3710174',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,155.914167,37.17144,0,NULL,64072389231,1001131081,15642673,17.1),(70248,'SZ effect','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70248,39.4,0.5,760,25815,NULL,NULL,'Isotherm., r < 100 kpc','BLOX J1023.6+0411.1',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'Compact [Zw]',NULL,NULL,NULL,NULL,1,155.915125,4.18622,0.033,NULL,60741672179,949088627,14829509,NULL),(70249,'SZ effect','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70249,39.6,0.05,830,25815,NULL,NULL,'Hydrost. Eq.','BLOX J1023.6+0411.1',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70250,'SZ effect','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70250,39.77,NULL,900,25815,NULL,NULL,NULL,'BLOX J1023.6+0411.1',NULL,'2011A&A...532A..14C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70251,'SZ effect','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70251,39.96,0.53,980,25815,NULL,NULL,'Isotherm.','BLOX J1023.6+0411.1',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70252,'SZ effect','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70252,40.11,NULL,1050,25815,NULL,NULL,'3.1 (red) calibration','BLOX J1023.6+0411.1',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70253,'SZ effect','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70253,40.34,NULL,1170,25815,NULL,NULL,'4.2 (black) calibration','BLOX J1023.6+0411.1',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70254,'SZ effect','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70254,40.45,NULL,1230,25815,NULL,NULL,'4.1 (blue) calibration','BLOX J1023.6+0411.1',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70255,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70255,38.1,0.27,416,25816,70,NULL,NULL,'SDSS J102339.95+000757.3',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000074,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,155.9164583,0.13261,0.113,NULL,60735932197,948998940,14828108,18.1),(70256,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70256,37.37,0.46,298,25817,70,NULL,NULL,'2MASX J10234003+3821163',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000169,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,155.9167917,38.35472,0,NULL,64147727548,1002308242,15661066,16.7),(70257,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70257,37.83,0.23,369,25818,70,NULL,NULL,'2MASX J10234003-0013298',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000083,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,155.916916667,-0.22494,0.129,NULL,41206456611,643850884,10060170,17.9),(70258,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70258,36.95,0.27,246,25819,70,NULL,NULL,'2MASX J10234056+0858090',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,155.919083333,8.96911,0.053,NULL,60763943918,949436623,14834947,17.4),(70259,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70259,38.29,0.23,454,25820,70,NULL,NULL,'2MASX J10234064+3723283',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000174,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,155.919417,37.39125,0,NULL,64072408915,1001131389,15642677,17.3),(70260,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70260,37.48,0.46,313,25821,70,NULL,NULL,'SDSS J102340.81+405159.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000155,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,155.920041667,40.86656,0,NULL,64150451811,1002350809,15661731,18.3),(70261,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70261,36.53,0.46,202,25822,70,NULL,NULL,'2MASX J10234203+0221156',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000084,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,155.925125,2.35436,0.073,NULL,60749048418,949203881,14831310,16.2),(70262,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70262,35.55,0.25,129,25823,74.4,NULL,NULL,'CGCG 065-019',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000031,NULL,'15.4',0.5,'E','Group member',NULL,NULL,NULL,1,155.929583,12.71556,0.101,NULL,60951720080,952370626,14880791,15.4),(70263,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70263,37.22,0.46,278,25824,70,NULL,NULL,'2MASX J10234349+2610577',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000197,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,155.931417,26.18272,0.053,NULL,60468065000,944813515,14762711,16.4),(70264,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70264,35.97,0.46,156,25825,70,NULL,NULL,'2MASX J10234520+3554365',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000179,NULL,'16.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,155.93825,35.91008,0,NULL,64075712029,1001183000,15643484,16.3),(70265,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70265,38.43,0.33,485,25826,70,NULL,NULL,'2MASX J10234620+2205319',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,155.942417,22.09231,0.053,NULL,60951621588,952369087,14880766,17.7),(70266,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70266,37.99,0.46,396,25827,70,NULL,NULL,'2MASX J10234619+2917277',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,155.942583,29.29114,0.041,NULL,64029348759,1000458574,15632165,18.3),(70267,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70267,37.58,0.46,327,25828,70,NULL,NULL,'2MASX J10234625+5936125',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,155.942791667,59.60347,0,NULL,61948755348,967949302,15124207,18.1),(70268,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70268,36.38,0.23,189,25829,70,NULL,NULL,'SDSS J102346.96+144751.5',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'15.9g',0.39,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,155.9457083,14.79767,0.121,NULL,60954344481,952411632,14881431,15.9),(70269,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70269,38.29,0.23,454,25830,70,NULL,NULL,'2MASX J10234730+3725520',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,155.947125,37.43122,0,NULL,64072230501,1001128601,15642634,17.4),(70270,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70270,36.62,0.46,211,25831,70,NULL,NULL,'2MASX J10234817+3541385',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'16.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,155.950667,35.69397,0,NULL,64075808565,1001184508,15643507,16.7),(70271,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70271,37.81,0.21,365,25832,70,NULL,NULL,'2MASX J10234849+3556365',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000177,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,155.9520417,35.94347,0,NULL,64075705213,1001182893,15643482,17.2),(70272,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70272,33.32,0.2,46.1,25833,74.4,NULL,NULL,'UGC 05625',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000123,NULL,'15.2',0.4,'S','Group member',NULL,NULL,NULL,1,155.952166667,12.62983,0.093,NULL,60951741674,952370963,14880796,15.2),(70273,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70273,33.56,0.68,51.5,25833,NULL,NULL,NULL,'UGC 05625',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70274,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70274,33.74,0.63,55.9,25833,NULL,NULL,'Malmquist cor.','UGC 05625',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70275,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70275,38.43,0.33,485,25834,70,NULL,NULL,'2MASX J10234936+2205360',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000192,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,155.955583,22.0935,0.053,NULL,60951620775,952369074,14880766,17.7),(70276,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70276,38.13,0.27,422,25835,70,NULL,NULL,'SDSS J102349.42+083947.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,155.955916667,8.66311,0.045,NULL,60759953545,949374274,14833973,18.4),(70277,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70277,37.83,0.23,369,25836,70,NULL,NULL,'2MASXi J1023496-001514',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000049,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,155.956875,-0.25381,0.129,NULL,41206458290,643850910,10060170,18.3),(70278,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70278,36.48,0.46,198,25837,70,NULL,NULL,'2MASX J10234968+2059049',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000174,NULL,'15.9g',0.39,NULL,NULL,NULL,NULL,NULL,1,155.957041667,20.98481,0.025,NULL,60940573420,952196459,14878069,15.9),(70279,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70279,37.16,0.46,270,25838,70,NULL,NULL,'2MASX J10235136+2601557',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000227,NULL,'16.0g',0.32,NULL,NULL,NULL,NULL,NULL,1,155.964,26.03225,0.037,NULL,60468084317,944813817,14762715,16),(70280,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70280,36.24,0.46,177,25839,70,NULL,NULL,'2MASX J10235203+2543217',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000158,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,155.96675,25.72278,0.033,NULL,60467859695,944810307,14762661,16.7),(70281,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70281,37.99,0.46,396,25840,70,NULL,NULL,'2MASX J10235203+1724573',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,155.9667917,17.41589,0.093,NULL,60963599446,952556241,14883691,18),(70282,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70282,36.92,0.46,243,25841,70,NULL,NULL,'2MASX J10235224+2255410',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000137,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,155.96775,22.92819,0.033,NULL,60948951901,952327373,14880115,17.8),(70283,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70283,35.65,0.46,135,25842,70,NULL,NULL,'2MASX J10235242+4300057',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000166,NULL,'15.8g',0.4,'SABa',NULL,NULL,NULL,NULL,1,155.9684583,43.00164,0,NULL,64152632108,1002384876,15662263,15.8),(70284,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70284,37.44,0.46,308,25843,70,NULL,NULL,'2MASX J10235373+3653201',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,155.973833,36.88894,0,NULL,64073067396,1001141678,15642838,17),(70285,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70285,35.38,0.64,119,25844,70,NULL,NULL,'MCG -03-27-009',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15',0.2,'(R\')SB(r)a     HII?',NULL,NULL,NULL,NULL,1,155.973875,-17.29342,0.265,NULL,41649289512,650770148,10168283,15),(70286,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70286,38.11,0.23,418,25845,70,NULL,NULL,'SDSS J102353.85+013758.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000088,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,155.974417,1.63294,0.085,NULL,60734844783,948981949,14827842,18.6),(70287,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70287,37.89,0.46,379,25846,70,NULL,NULL,'SDSS J102354.90+035440.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000134,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,155.9787917,3.91119,0.041,NULL,60741821062,949090954,14829546,18.5),(70288,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70288,37.83,0.46,369,25847,70,NULL,NULL,'2MASX J10235590+0758530',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000184,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,155.9830417,7.98131,0.041,NULL,60760358725,949380605,14834071,16.6),(70289,'BL Lac Luminosity','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70289,41.19,0.33,1730,25848,70,NULL,NULL,'2MASS J10235619-4336015',NULL,'2014ApJ...784..151S',2014,1,NULL,NULL,'G',NULL,NULL,'17.50',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,155.984125,-43.60042,0.493,NULL,42137291095,658395173,10287424,17.5),(70290,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70290,34.66,0.4,85.5,25849,NULL,NULL,'mean','CGCG 009-018',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000027,NULL,'13.39',1.1,'SB(r)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,155.985375,-3.18211,0.101,NULL,41214760717,643980636,10062197,13.39),(70291,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70291,34.75,0.47,89,25849,NULL,NULL,'H','CGCG 009-018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70292,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70292,34.75,0.46,89.1,25849,NULL,NULL,'J','CGCG 009-018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70293,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70293,34.76,0.45,89.7,25849,NULL,NULL,'K','CGCG 009-018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70294,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70294,38.35,0.21,467,25850,70,NULL,NULL,'2MASX J10235789+3707171',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000184,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,155.991167,37.12139,0,NULL,64072369908,1001130779,15642668,17.9),(70295,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70295,35.91,0.51,152,25851,NULL,NULL,'Malmquist cor.','2MASX J10235794+1241103',NULL,'2009ApJS..182..474S',2009,1,0.61,NULL,'G',0.000143,NULL,'16.1g',0.45,'S',NULL,NULL,NULL,NULL,1,155.9912917,12.68628,0.101,NULL,60951756552,952371196,14880799,16.1),(70296,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70296,36.07,0.47,163,25851,NULL,NULL,NULL,'2MASX J10235794+1241103',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70297,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70297,36.13,0.2,168,25851,74.4,NULL,NULL,'2MASX J10235794+1241103',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70298,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70298,37.89,0.46,379,25852,70,NULL,NULL,'2MASX J10235867+3046395',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000196,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,155.994541667,30.77781,0.049,NULL,64083130914,1001298920,15645295,17),(70299,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70299,36.19,0.27,173,25853,70,NULL,NULL,'CGCG 211-053',NULL,'2015arXiv151105856S',2015,1,0.96,NULL,'G',0.000163,NULL,'14.9g',0.51,NULL,NULL,NULL,NULL,NULL,1,155.995,43.85578,0,NULL,64146176721,1002284011,15660687,14.9),(70300,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70300,38.11,0.23,418,25854,70,NULL,NULL,'2MASX J10235969+0121100',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000078,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,155.99875,1.35275,0.081,NULL,60736719459,949011241,14828300,17.6),(70301,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70301,37.43,0.46,307,25855,70,NULL,NULL,'2MASX J10240069+0105000',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000085,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,156.002917,1.08347,0.093,NULL,60736779812,949012184,14828315,16.8),(70302,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70302,38.11,0.23,418,25856,70,NULL,NULL,'2MASX J10240082+0130400',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',NULL,NULL,'17.17',0.24,'BrClG',NULL,NULL,NULL,NULL,1,156.003375,1.51117,0.085,NULL,60734837375,948981833,14827841,17.17),(70303,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70303,37.87,0.46,375,25857,70,NULL,NULL,'2MASX J10240080+2043429',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,156.0034583,20.72869,0.025,NULL,60940449826,952194528,14878039,17.6),(70304,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70304,37.76,0.33,357,25858,70,NULL,NULL,'2MASX J10240101+4757238',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000133,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,156.003875,47.95661,0,NULL,64129701710,1002026589,15656665,18.4),(70305,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70305,35.72,0.55,140,25859,70,NULL,NULL,'2MASX J10240200-1921214',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.3b',NULL,'Sp',NULL,NULL,NULL,NULL,1,156.008333,-19.356,0.249,NULL,41665740643,651027197,10172299,15.3),(70306,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70306,36.19,0.27,173,25860,70,NULL,NULL,'2MASX J10240303+4401257',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000178,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,156.0127083,44.02392,0,NULL,64146330065,1002286407,15660725,17.1),(70307,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70307,36.49,0.27,199,25861,70,NULL,NULL,'2MASX J10240324+4206297',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000188,NULL,'15.5g',0.47,'E0',NULL,NULL,NULL,NULL,1,156.013666667,42.10828,0,NULL,64152227378,1002378552,15662164,15.5),(70308,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70308,37,0.46,251,25862,70,NULL,NULL,'2MASX J10240366+6542196',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000076,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,156.015333,65.70561,0.037,NULL,62125381260,970709082,15167329,16.7),(70309,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70309,36.9,0.46,240,25863,70,NULL,NULL,'2MASX J10240387+1244287',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00011,NULL,'16.0g',0.37,'S',NULL,NULL,NULL,NULL,1,156.016083,12.74122,0.101,NULL,60951750989,952371109,14880798,16),(70310,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70310,37.09,0.46,262,25864,70,NULL,NULL,'2MASX J10240436+4432077',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,156.018375,44.53564,0,NULL,64146407311,1002287614,15660743,17.8),(70311,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70311,37.07,0.15,260,25865,70,NULL,NULL,'2MASXi J1024059+475826',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,156.024667,47.97419,0,NULL,64129718621,1002026853,15656669,17.7),(70312,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70312,31.41,0.4,19.1,25866,75,NULL,'B','UGC 05612',NULL,'1988NBGC.C....0000T',1988,1,3.4,NULL,'G',0.000037,NULL,'12.6',2.2,'SB(s)dm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,156.027083,70.88222,0.189,NULL,62136228187,970878565,15169977,12.6),(70313,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70313,37.17,0.46,272,25867,70,NULL,NULL,'2MASX J10240676+1016520',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000178,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,156.0282083,10.28106,0.085,NULL,61037325116,953708204,14901690,16.3),(70314,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70314,38.8,0.33,576,25868,70,NULL,NULL,'SDSS J102407.08+001844.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00008,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,156.0295417,0.31236,0.113,NULL,60735900005,948998437,14828100,18.2),(70315,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70315,37.81,0.46,364,25869,70,NULL,NULL,'2MASX J10240766+3530014',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000168,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,156.0317917,35.50056,0,NULL,64075777397,1001184021,15643500,17.9),(70316,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70316,33.68,0.49,54.4,25870,75,NULL,'IR','MCG -01-27-007',NULL,'2011yCatp016004901K',2011,1,1.57,'Star superposed.','G',0.000013,NULL,'15.24',0.2,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,156.031875,-5.63169,0.097,NULL,41259455245,644678988,10073109,15.24),(70317,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70317,34,0.2,63.1,25870,74.4,NULL,NULL,'MCG -01-27-007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70318,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70318,34.15,NULL,67.5,25870,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -01-27-007',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70319,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70319,34.15,NULL,67.7,25870,NULL,NULL,'Dipole + Quadrupole','MCG -01-27-007',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70320,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70320,34.17,NULL,68.1,25870,NULL,NULL,'Dipole','MCG -01-27-007',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70321,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70321,34.18,0.36,68.6,25870,NULL,NULL,NULL,'MCG -01-27-007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70322,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70322,34.34,0.34,73.6,25870,NULL,NULL,'Malmquist cor.','MCG -01-27-007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70323,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70323,36.38,0.46,189,25871,70,NULL,NULL,'2MASX J10240812+2037160',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.00019,NULL,'15.3g',0.62,NULL,NULL,NULL,NULL,NULL,1,156.033833333,20.62122,0.025,NULL,60940925358,952201958,14878155,15.3),(70324,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70324,38.62,0.46,530,25872,70,NULL,NULL,'SDSS J102409.26+372654.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,156.038625,37.44856,0,NULL,64072223252,1001128488,15642632,18.4),(70325,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70325,38.31,0.46,459,25873,70,NULL,NULL,'SDSS J102409.39+385205.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,156.039167,38.86825,0,NULL,64148568638,1002321384,15661271,18.3),(70326,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70326,37.27,0.46,285,25874,70,NULL,NULL,'2MASX J10240970+4550057',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000163,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,156.040583,45.83494,0,NULL,64128485049,1002007578,15656368,16.7),(70327,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70327,38.13,0.27,422,25875,70,NULL,NULL,'2MASX J10240978+0843403',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000181,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,156.04075,8.72781,0.045,NULL,60759785246,949371644,14833931,16.9),(70328,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70328,36.75,0.17,224,25876,70,NULL,NULL,'2MASX J10240984+1700138',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,156.0409583,17.00381,0.101,NULL,60963256979,952550890,14883607,17.4),(70329,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70329,37,0.46,251,25877,70,NULL,NULL,'2MASX J10240987+2849128',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000157,NULL,'16.9g',0.29,'E',NULL,NULL,NULL,NULL,1,156.0412917,28.82042,0.045,NULL,64029309824,1000457966,15632155,16.9),(70330,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70330,33.29,0.43,45.5,25878,75,NULL,'3.6 micron, color + selection bias corrected','ESO 436- G 014',NULL,'2014MNRAS.444..527S',2014,1,1.2,NULL,'G',0.000103,NULL,'15.53',0.6,'S...',NULL,NULL,NULL,NULL,1,156.048583,-28.92886,0.221,NULL,41954729121,655542642,10242853,15.53),(70331,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70331,37.28,0.53,285,25879,NULL,NULL,'Malmquist cor.','LCRS B102140.6-052204',NULL,'2009ApJS..182..474S',2009,1,0.58,NULL,'G',0.000013,NULL,'17.68',0.13,NULL,NULL,NULL,NULL,NULL,1,156.048583,-5.62178,0.097,NULL,41259483775,644679433,10073116,17.68),(70332,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70332,37.36,0.51,297,25879,NULL,NULL,NULL,'LCRS B102140.6-052204',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70333,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70333,37.4,0.2,302,25879,74.4,NULL,NULL,'LCRS B102140.6-052204',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70334,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70334,37.34,0.33,294,25880,70,NULL,NULL,'2MASX J10241237+0252470',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000186,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,156.0515,2.87969,0.081,NULL,60748646724,949197605,14831212,16.7),(70335,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70335,37.02,0.46,253,25881,70,NULL,NULL,'2MASX J10241302+2727228',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000186,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,156.0544583,27.45644,0.049,NULL,64028375149,1000443361,15631927,16.6),(70336,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70336,37.99,0.21,396,25882,70,NULL,NULL,'2MASX J10241360+3731210',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000166,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,156.05675,37.52253,0,NULL,64072227706,1001128557,15642633,18.1),(70337,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70337,37.45,0.46,309,25883,70,NULL,NULL,'SDSS J102414.06+024858.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000072,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,156.058625,2.81614,0.081,NULL,60748639147,949197486,14831210,17.9),(70338,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70338,37.34,0.33,294,25884,70,NULL,NULL,'2MASX J10241557+0252410',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000074,NULL,'17.5g',0.24,'NLAGN',NULL,NULL,NULL,'Sy 2',1,156.064833,2.87822,0.081,NULL,60748647135,949197611,14831212,17.5),(70339,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70339,37.86,0.46,373,25885,70,NULL,NULL,'2MASX J10241677+3423530',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,156.070041667,34.39792,0,NULL,64074927144,1001170736,15643292,18.2),(70340,'Ring Diameter','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70340,32.8,0.84,37,25886,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3241',NULL,'1981ApJS...45..541P',1981,1,2.2,NULL,'G',0.000013,NULL,'13.06',1.5,'SA(r)b         HII','Possible group member',NULL,NULL,NULL,1,156.070667,-32.48261,0.245,NULL,42008316351,656379942,10255936,13.06),(70341,'Sosies','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70341,33.1,0.19,41.7,25886,NULL,NULL,NULL,'NGC 3241',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70342,'Tully est','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70342,32.89,0.8,37.9,25886,75,NULL,'B','NGC 3241',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70343,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70343,32.13,0.69,26.6,25886,100,NULL,'mid-IR','NGC 3241',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70344,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70344,33.06,0.4,41,25886,NULL,NULL,'mean','NGC 3241',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70345,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70345,33.23,0.45,44.4,25886,NULL,NULL,'K','NGC 3241',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70346,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70346,33.24,0.47,44.4,25886,NULL,NULL,'H','NGC 3241',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70347,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70347,33.27,0.46,45,25886,NULL,NULL,'J','NGC 3241',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70348,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70348,37.76,0.46,356,25887,70,NULL,NULL,'2MASX J10241717+1918301',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,156.071667,19.30825,0.037,NULL,60997220010,953081562,14891899,17.3),(70349,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70349,36.75,0.17,224,25888,70,NULL,NULL,'2MASX J10241757+1700027',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.0g',0.34,NULL,NULL,NULL,NULL,NULL,1,156.073167,17.00078,0.101,NULL,60963256585,952550884,14883607,16),(70350,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70350,34,0.49,63.1,25889,75,NULL,'IR','FGC 1062',NULL,'2011yCatp016004901K',2011,1,1.01,NULL,'G',0.000023,NULL,'15.33',0.12,'Sc',NULL,NULL,NULL,NULL,1,156.073375,-5.67781,0.097,NULL,41259619238,644681550,10073149,15.33),(70351,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70351,34.49,0.48,79.2,25889,NULL,NULL,'Malmquist cor.','FGC 1062',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70352,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70352,34.53,0.47,80.4,25889,NULL,NULL,NULL,'FGC 1062',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70353,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70353,34.57,0.2,82,25889,74.4,NULL,NULL,'FGC 1062',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70354,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70354,34.89,NULL,95,25889,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1062',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70355,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70355,34.9,NULL,95.5,25889,NULL,NULL,'Dipole + Quadrupole','FGC 1062',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70356,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70356,34.92,NULL,96.3,25889,NULL,NULL,'Dipole','FGC 1062',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70357,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70357,37.78,0.46,359,25890,70,NULL,NULL,'2MASX J10241791+1046313',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000182,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,156.074667,10.7755,0.077,NULL,61039227428,953737928,14902155,16.7),(70358,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70358,38.35,0.21,467,25891,70,NULL,NULL,'2MASX J10241862+3705140',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000169,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,156.077625,37.08722,0,NULL,64072384466,1001131007,15642671,17.1),(70359,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70359,38.7,0.46,551,25892,70,NULL,NULL,'SDSS J102418.93+070638.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000162,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,156.078917,7.11081,0.021,NULL,60759195214,949362425,14833787,18.1),(70360,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70360,37.07,0.46,260,25893,70,NULL,NULL,'SDSS J102419.16+283601.4',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000161,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,156.079833,28.60039,0.025,NULL,64028855329,1000450864,15632044,16.9),(70361,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70361,37.19,0.46,274,25894,70,NULL,NULL,'2MASX J10241929+6000486',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,156.080417,60.01361,0,NULL,61947933459,967936460,15124007,17.1),(70362,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70362,36.76,0.98,225,25895,70,NULL,NULL,'2MASX J10242025-2643360',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.4b',NULL,'E',NULL,NULL,NULL,NULL,1,156.084375,-26.72667,0.221,NULL,41474354168,648036783,10125574,16.4),(70363,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70363,38.43,0.46,485,25896,70,NULL,NULL,'2MASX J10242034+1159363',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,156.084875,11.99361,0.061,NULL,61035670200,953682346,14901286,17.9),(70364,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70364,36.27,0.46,180,25897,70,NULL,NULL,'2MASX J10242102+1202483',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000169,NULL,'15.9g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,156.087583,12.04672,0.061,NULL,61169834884,955778670,14934041,15.9),(70365,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70365,36.49,0.27,199,25898,70,NULL,NULL,'CGCG 211-054 NED01',NULL,'2015arXiv151105856S',2015,1,0.97,NULL,'G',0.000205,NULL,'14.6g',0.73,'E0',NULL,NULL,NULL,NULL,1,156.094625,41.70694,0,NULL,64152290451,1002379538,15662180,14.6),(70366,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70366,36.75,0.46,224,25899,70,NULL,NULL,'2MASX J10242287+0643493',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.32',0.41,NULL,NULL,NULL,NULL,NULL,1,156.0952917,6.73022,0.021,NULL,60759623003,949369109,14833892,16.32),(70367,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70367,37.31,0.46,289,25900,70,NULL,NULL,'2MASX J10242372+4452211',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,156.098667,44.87264,0,NULL,64146601797,1002290653,15660791,17.4),(70368,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70368,37.81,0.21,365,25901,70,NULL,NULL,'2MASX J10242601+3601412',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000137,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,156.1085417,36.02811,0,NULL,64072860262,1001138441,15642788,17.9),(70369,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70369,37.46,0.46,310,25902,70,NULL,NULL,'2MASX J10242671+1437137',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,156.1112083,14.62036,0.117,NULL,60954430358,952412974,14881452,17.8),(70370,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70370,37.16,0.46,271,25903,70,NULL,NULL,'2MASX J10242674+1635377',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,156.1114583,16.59375,0.093,NULL,60963199135,952549986,14883593,17),(70371,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70371,37.99,0.21,396,25904,70,NULL,NULL,'2MASX J10242784+3731112',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000223,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,156.115875,37.51983,0,NULL,64042857655,1000669650,15635463,17),(70372,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70372,37.59,0.46,329,25905,70,NULL,NULL,'2MASX J10242812+4113062',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000174,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,156.117167,41.21847,0,NULL,64150530947,1002352046,15661750,17.5),(70373,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70373,37.99,0.21,396,25906,70,NULL,NULL,'2MASX J10242876+3735372',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000147,NULL,'17.6g',NULL,NULL,NULL,NULL,NULL,NULL,1,156.119875,37.59353,0,NULL,64042855837,1000669622,15635462,17.6),(70374,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70374,37.71,0.46,348,25907,70,NULL,NULL,'2MASX J10242884+6330335',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000201,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,156.120125,63.50931,0.005,NULL,61827469768,966054215,15094597,17),(70375,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70375,38.39,0.33,476,25908,70,NULL,NULL,'2MASX J10243008+4820544',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,156.125417,48.34842,0,NULL,64129002729,1002015667,15656494,18.2),(70376,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70376,36.85,0.46,235,25909,70,NULL,NULL,'2MASX J10243063+3944372',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00017,NULL,'16.1g',0.32,'E0',NULL,NULL,NULL,NULL,1,156.127667,39.74383,0,NULL,64151170681,1002362041,15661906,16.1),(70377,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70377,37.81,0.21,365,25910,70,NULL,NULL,'2MASX J10243139+3556070',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,156.130875,35.93522,0,NULL,64075828404,1001184818,15643512,17.5),(70378,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70378,37.79,0.46,361,25911,70,NULL,NULL,'SDSS J102431.62+411839.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000163,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,156.1317917,41.31089,0,NULL,64150555880,1002352435,15661756,18.6),(70379,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70379,37.59,0.46,330,25912,70,NULL,NULL,'2MASX J10243183+4514071',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000149,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,156.13275,45.23539,0,NULL,64145992676,1002281135,15660642,17),(70380,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70380,37.86,0.27,373,25913,70,NULL,NULL,'2MASX J10243210+0301107',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000174,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,156.1337083,3.01972,0.081,NULL,60740440107,949069376,14829209,17.3),(70381,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70381,36.01,0.61,159,25914,70,NULL,NULL,'ESO 375- G 020',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000063,NULL,'14.81',0.8,'S?             HII',NULL,NULL,NULL,NULL,1,156.135208333,-36.27228,0.261,NULL,41993887181,656154487,10252413,14.81),(70382,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70382,37.07,0.15,260,25915,70,NULL,NULL,'2MASX J10243254+4749361',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000184,NULL,'16.0g',0.4,'E0',NULL,NULL,NULL,NULL,1,156.13575,47.82681,0,NULL,64129428213,1002022315,15656598,16),(70383,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70383,37.86,0.27,373,25916,70,NULL,NULL,'2MASX J10243284+0301497',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000176,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,156.13675,3.03039,0.081,NULL,60740440174,949069377,14829209,17.2),(70384,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70384,37.99,0.21,396,25917,70,NULL,NULL,'SDSS J102433.48+373030.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,156.1395,37.50842,0,NULL,64042857888,1000669654,15635463,18.2),(70385,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70385,36.06,0.46,163,25918,70,NULL,NULL,'2MASX J10243365+2633138',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,156.140333,26.55378,0.041,NULL,60467332876,944802076,14762532,16.5),(70386,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70386,38.07,0.46,411,25919,70,NULL,NULL,'SDSS J102434.51+305346.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000168,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,156.1437917,30.89617,0.065,NULL,64083139621,1001299056,15645297,18.3),(70387,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70387,37.92,0.46,385,25920,70,NULL,NULL,'2MASX J10243519+2040221',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000134,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,156.146625,20.67264,0.053,NULL,60941105730,952204777,14878199,17.8),(70388,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70388,37.81,0.46,365,25921,70,NULL,NULL,'2MASX J10243524+1852091',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,156.146833,18.86903,0.009,NULL,60997507957,953086061,14891969,18.2),(70389,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70389,37.9,0.46,380,25922,70,NULL,NULL,'2MASX J10243618+1241459',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000157,NULL,'16.8g',0.26,'E',NULL,NULL,NULL,NULL,1,156.150875,12.696,0.093,NULL,61169875895,955779310,14934051,16.8),(70390,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70390,35.95,0.46,155,25923,70,NULL,NULL,'2MASX J10243648+2147091',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'16.75',0.22,NULL,NULL,NULL,NULL,NULL,1,156.151833333,21.78594,0.029,NULL,60950917356,952358083,14880595,16.75),(70391,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70391,33.76,NULL,56.4,25924,NULL,NULL,NULL,'FGC 1063',NULL,'2000BSAO...50....5K',2000,1,0.87,NULL,'G',0.000025,NULL,'16.9g',0.14,'Sdm',NULL,NULL,NULL,NULL,1,156.155291667,11.90806,0.045,NULL,61035697958,953682780,14901293,16.9),(70392,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70392,33.92,NULL,60.8,25924,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1063',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70393,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70393,33.93,NULL,61.2,25924,NULL,NULL,'Dipole','FGC 1063',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70394,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70394,33.94,NULL,61.3,25924,NULL,NULL,'Dipole + Quadrupole','FGC 1063',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70395,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70395,34.91,0.8,96.1,25925,NULL,NULL,NULL,'ESO 568- G 004',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.95',0.5,'Sb:',NULL,NULL,NULL,NULL,1,156.155875,-21.49353,0.285,NULL,41620575049,650321485,10161273,15.95),(70396,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70396,34.95,0.2,97.7,25925,74.4,NULL,NULL,'ESO 568- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70397,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70397,35.01,0.77,100,25925,NULL,NULL,'Malmquist cor.','ESO 568- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70398,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70398,37.29,0.46,287,25926,70,NULL,NULL,'SDSS J102438.46+601350.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,156.1602917,60.23069,0,NULL,61956412326,968068942,15126077,18.3),(70399,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70399,38.53,0.46,508,25927,70,NULL,NULL,'SDSS J102438.95+285705.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,156.162333,28.95161,0.065,NULL,64029313661,1000458025,15632156,18.4),(70400,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70400,38.39,0.33,476,25928,70,NULL,NULL,'2MASX J10243942+4826214',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000141,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,156.164083,48.43917,0,NULL,64128969888,1002015154,15656486,17.8),(70401,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70401,37.81,0.21,365,25929,70,NULL,NULL,'2MASX J10243953+3603402',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000185,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,156.1647083,36.06136,0,NULL,64072926009,1001139468,15642804,17),(70402,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70402,36.99,0.46,250,25930,70,NULL,NULL,'2MASX J10243956+2828307',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,156.1649583,28.47511,0.033,NULL,64028842638,1000450666,15632041,17),(70403,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70403,38.89,0.46,599,25931,70,NULL,NULL,'SDSS J102440.00+143025.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,156.1667083,14.50708,0.117,NULL,60954873920,952419905,14881561,18.5),(70404,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70404,31.84,0.4,23.4,25932,75,NULL,'B','UGC 05633',NULL,'1988NBGC.C....0000T',1988,1,3.1,NULL,'G',0.000017,NULL,'14.35',2.5,'SBdm','Group member',NULL,NULL,NULL,1,156.167125,14.75678,0.117,NULL,60954470809,952413606,14881462,14.35),(70405,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70405,32.79,NULL,36.2,25932,NULL,NULL,NULL,'UGC 05633',NULL,'2015AstBu..70....1K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70406,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70406,37.5,0.46,316,25933,70,NULL,NULL,'2MASX J10244063+1100335',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000171,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,156.16925,11.00922,0.065,NULL,61035885870,953685716,14901339,16.9),(70407,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70407,37.92,0.46,384,25934,70,NULL,NULL,'2MASX J10244083+4137052',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000184,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,156.17,41.61806,0,NULL,64152175426,1002377741,15662152,17.5),(70408,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70408,37.99,0.21,396,25935,70,NULL,NULL,'2MASX J10244171+3733402',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000171,NULL,'16.6g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,156.173917,37.56106,0,NULL,64042857435,1000669647,15635463,16.6),(70409,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70409,32.98,0.43,39.5,25936,75,NULL,'3.6 micron, color + selection bias corrected','ESO 317- G 023',NULL,'2014MNRAS.444..527S',2014,1,1.9,NULL,'G',0.000063,NULL,'13.93',0.8,'(R\'_1)SB(rs)a  HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,156.1770417,-39.30589,0.409,NULL,42132613949,658322092,10286282,13.93),(70410,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70410,33.14,0.43,42.6,25936,75,NULL,'3.6 micron, color corrected','ESO 317- G 023',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70411,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70411,33.35,0.2,46.8,25936,74.4,NULL,NULL,'ESO 317- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70412,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70412,36.58,0.46,207,25937,70,NULL,NULL,'SDSS J102444.98+145907.5',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.3g',0.33,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,156.187416667,14.98542,0.121,NULL,60954478502,952413726,14881464,16.3),(70413,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70413,36.43,0.46,193,25938,70,NULL,NULL,'CGCG 240-040',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000173,NULL,'15.6g',0.55,'E','Isolated galaxy',NULL,NULL,NULL,1,156.1935417,46.45608,0,NULL,64128145114,1002002267,15656285,15.6),(70414,'FP','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,'R',70414,37.86,0.27,373,25939,70,NULL,NULL,'SDSS J102446.87+030427.2',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,156.1952917,3.07422,0.037,NULL,60740413889,949068967,14829202,18.1),(70415,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70415,36.1,0.2,166,25940,74.4,NULL,NULL,'2MASX J10244760+1241269',NULL,'2013AJ....146...86T',2013,1,0.45,NULL,'G',0.000009,NULL,'16.5g',0.21,'S',NULL,NULL,NULL,NULL,1,156.1985,12.69092,0.093,NULL,61169874694,955779292,14934051,16.5),(70416,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70416,36.11,0.42,167,25940,NULL,NULL,'Malmquist cor.','2MASX J10244760+1241269',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70417,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:44','1',NULL,NULL,70417,36.14,0.41,169,25940,NULL,NULL,NULL,'2MASX J10244760+1241269',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70418,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70418,37.61,0.46,332,25941,70,NULL,NULL,'2MASX J10244974+4526122',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000142,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,156.207333,45.43667,0,NULL,64128368398,1002005756,15656339,18.2),(70419,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70419,37.07,0.15,260,25942,70,NULL,NULL,'2MASX J10245039+4740102',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000172,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,156.2097917,47.66942,0,NULL,64129541063,1002024079,15656626,16.8),(70420,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70420,37.11,0.46,264,25943,70,NULL,NULL,'2MASX J10245298+4001021',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,156.2209583,40.01722,0,NULL,64151656899,1002369639,15662025,17.4),(70421,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70421,35.13,0.49,106,25944,70,NULL,NULL,'MCG -03-27-010',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00005,NULL,'14.5',0.9,'SAB(rs)a pec:',NULL,NULL,NULL,NULL,1,156.2375,-17.43444,0.253,NULL,41648990088,650765470,10168210,14.5),(70422,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70422,37.07,0.15,260,25945,70,NULL,NULL,'2MASX J10245767+4745136',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000202,NULL,'15.9g',0.32,'AGN',NULL,NULL,NULL,NULL,1,156.2404583,47.75372,0,NULL,64129452385,1002022693,15656604,15.9),(70423,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70423,34.55,0.57,81.4,25946,70,NULL,NULL,'2MASX J10245910-1725359',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000143,NULL,'16.16',NULL,'Sp',NULL,NULL,NULL,NULL,1,156.246083333,-17.42667,0.253,NULL,41648993314,650765520,10168211,16.16),(70424,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70424,37.76,0.46,357,25947,70,NULL,NULL,'2MASX J10245923+0705255',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000183,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,156.246833,7.09042,0.025,NULL,60759179025,949362172,14833783,17.6),(70425,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70425,36.75,0.17,224,25948,70,NULL,NULL,'CGCG 094-039',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000223,NULL,'15.3',0.6,'AGN','Group member',NULL,NULL,NULL,1,156.253833,17.29211,0.105,NULL,60963225925,952550405,14883600,15.3),(70426,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70426,36.62,0.46,211,25949,70,NULL,NULL,'2MASX J10250102+4322147',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,156.254167,43.37078,0,NULL,64155343170,1002427237,15662925,17.4),(70427,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70427,37.07,0.15,260,25950,70,NULL,NULL,'VV 675',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000219,NULL,'15.5g',0.52,'BrClG',NULL,NULL,NULL,NULL,1,156.256625,47.84186,0,NULL,64129463844,1002022872,15656607,15.5),(70428,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70428,36.8,0.46,229,25951,70,NULL,NULL,'2MASX J10250162+1130065',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000179,NULL,'16.1g',0.4,'E0',NULL,NULL,NULL,NULL,1,156.256958333,11.50167,0.065,NULL,61036536661,953695885,14901498,16.1),(70429,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70429,37.08,0.46,260,25952,70,NULL,NULL,'2MASX J10250197+1136325',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000107,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,156.258417,11.60894,0.029,NULL,61036533076,953695829,14901497,17.6),(70430,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70430,37.34,0.33,293,25953,70,NULL,NULL,'SDSS J102503.47+083834.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,156.264458333,8.64281,0.041,NULL,61041913529,953779898,14902810,18.2),(70431,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70431,36.19,0.27,173,25954,70,NULL,NULL,'CGCG 211-055',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000093,NULL,'15.3g',0.52,'S0^-',NULL,NULL,NULL,NULL,1,156.266333,43.99206,0,NULL,64146343210,1002286612,15660728,15.3),(70432,'SNII optical','2016-12-15 15:14:37','2016-12-16 11:19:45','1','SN 2012A',NULL,70432,29.72,0.17,8.79,25955,NULL,NULL,NULL,'NGC 3239',NULL,'2013MNRAS.434.1636T',2013,1,5,NULL,'G',0.00001,NULL,'11.73',3.3,'IB(s)m pec','Group member',NULL,NULL,NULL,1,156.270375,17.16358,0.105,NULL,60963234456,952550538,14883602,11.73),(70433,'SNII optical','2016-12-15 15:14:37','2016-12-16 11:19:45','1','SN 2012A',NULL,70433,29.77,0.3,8.99,25955,NULL,NULL,'SCM Nugent 2006','NGC 3239',NULL,'2015MNRAS.448.2312B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70434,'SNII optical','2016-12-15 15:14:37','2016-12-16 11:19:45','1','SN 2012A',NULL,70434,30.02,0.04,10.1,25955,NULL,NULL,'SCM','NGC 3239',NULL,'2015ApJ...799..215P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70435,'SNII optical','2016-12-15 15:14:37','2016-12-16 11:19:45','1','SN 2012A',NULL,70435,30.04,0.2,10.2,25955,NULL,NULL,'SCM Poznanski 2009','NGC 3239',NULL,'2015MNRAS.448.2312B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70436,'SNII optical','2016-12-15 15:14:37','2016-12-16 11:19:45','1','SN 2012A',NULL,70436,30.05,0.3,10.2,25955,NULL,NULL,'SCM HP 2002','NGC 3239',NULL,'2015MNRAS.448.2312B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70437,'SNII optical','2016-12-15 15:14:37','2016-12-16 11:19:45','1','SN 2012A',NULL,70437,30.14,0.09,10.7,25955,NULL,NULL,'V, photospheric magnitude method','NGC 3239',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70438,'SNII optical','2016-12-15 15:14:37','2016-12-16 11:19:45','1','SN 2012A',NULL,70438,30.19,0.05,10.9,25955,NULL,NULL,'I, photospheric magnitude method','NGC 3239',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70439,'SNII optical','2016-12-15 15:14:37','2016-12-16 11:19:45','1','SN 2012A',NULL,70439,30.27,0.2,11.3,25955,NULL,NULL,'SCM D\'Andrea 2010','NGC 3239',NULL,'2015MNRAS.448.2312B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70440,'SNII optical','2016-12-15 15:14:37','2016-12-16 11:19:45','1','SN 2012A',NULL,70440,30.47,0.2,12.4,25955,NULL,NULL,'SCM Olivares 2010','NGC 3239',NULL,'2015MNRAS.448.2312B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70441,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70441,29.49,NULL,7.91,25955,NULL,NULL,NULL,'NGC 3239',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70442,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70442,29.53,0.4,8.1,25955,75,NULL,'B','NGC 3239',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70443,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70443,38.11,0.46,419,25956,70,NULL,NULL,'SDSS J102505.13+382728.4',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,156.271375,38.45792,0,NULL,64147795493,1002309304,15661082,17.4),(70444,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70444,37,0.46,251,25957,70,NULL,NULL,'2MASX J10250588+0429566',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000178,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,156.274417,4.49914,0.021,NULL,60741227273,949081676,14829401,16.7),(70445,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70445,36.14,0.46,169,25958,70,NULL,NULL,'2MASX J10250637+3949518',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000183,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,156.2764583,39.83097,0,NULL,64151165312,1002361958,15661905,16.3),(70446,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70446,35.78,0.25,143,25959,74.4,NULL,NULL,'2MASX J10250665+1224532',NULL,'2013AJ....146...86T',2013,1,0.46,NULL,'G',0.000022,NULL,'15.9g',0.37,'S0',NULL,NULL,NULL,NULL,1,156.27775,12.41472,0.085,NULL,61169926357,955780099,14934064,15.9),(70447,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70447,36.31,0.33,182,25959,70,NULL,NULL,'2MASX J10250665+1224532',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70448,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70448,37.98,0.46,395,25960,70,NULL,NULL,'2MASX J10250692+4036328',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000152,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,156.279,40.60897,0,NULL,64151786344,1002371661,15662057,17.7),(70449,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70449,37.06,0.46,258,25961,70,NULL,NULL,'2MASX J10250739+6329475',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,156.2810417,63.49667,0.005,NULL,61827665984,966057281,15094645,17),(70450,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70450,37.53,0.46,320,25962,70,NULL,NULL,'2MASX J10250838+1817225',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,156.284916667,18.28964,0.089,NULL,60997296888,953082763,14891918,16.6),(70451,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70451,37.34,0.33,293,25963,70,NULL,NULL,'VIII Zw 076',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000181,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,156.289625,8.64222,0.041,NULL,61041910651,953779853,14902810,16.8),(70452,'IRAS','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70452,32.63,0.8,33.6,25964,75,NULL,'A82, H','NGC 3225',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000023,NULL,'14.2g',1,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,156.29125,58.15,0,NULL,61916396114,967443689,15116307,14.2),(70453,'IRAS','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70453,32.64,0.8,33.7,25964,75,NULL,'CF, r','NGC 3225',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70454,'Sosies','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70454,33.68,0.29,54.5,25964,NULL,NULL,NULL,'NGC 3225',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70455,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70455,32.27,0.4,28.5,25964,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 3225',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70456,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70456,32.63,0.4,33.6,25964,75,NULL,'B','NGC 3225',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70457,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70457,32.83,0.36,36.8,25964,NULL,NULL,NULL,'NGC 3225',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70458,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70458,32.91,0.47,38.2,25964,75,NULL,'A82, H, raw','NGC 3225',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70459,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70459,32.92,0.47,38.3,25964,75,NULL,'A82, H, inv','NGC 3225',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70460,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70460,33.07,0.38,41.1,25964,75,NULL,'CF, r, raw','NGC 3225',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70461,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70461,33.09,0.47,41.5,25964,75,NULL,'A82, H, cor','NGC 3225',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70462,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70462,33.13,0.38,42.3,25964,75,NULL,'CF, r, inv','NGC 3225',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70463,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70463,33.17,0.38,43.1,25964,75,NULL,'CF, r, cor','NGC 3225',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70464,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70464,33.22,0.49,44.1,25964,NULL,NULL,'Malmquist cor.','NGC 3225',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70465,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70465,33.22,0.49,44.1,25964,NULL,NULL,NULL,'NGC 3225',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70466,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70466,33.23,0.43,44.4,25964,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3225',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70467,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70467,33.25,0.2,44.7,25964,74.4,NULL,NULL,'NGC 3225',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70468,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70468,33.27,0.43,45,25964,75,NULL,'3.6 micron, color corrected','NGC 3225',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70469,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70469,37.24,0.46,280,25965,70,NULL,NULL,'2MASX J10251026+4100498',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000155,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,156.292875,41.01381,0,NULL,64150931157,1002358299,15661848,17.2),(70470,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70470,37.07,0.15,260,25966,70,NULL,NULL,'2MASX J10251145+4744207',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000215,NULL,'15.8g',0.44,'AGN',NULL,NULL,NULL,NULL,1,156.2979583,47.73908,0,NULL,64129453806,1002022715,15656604,15.8),(70471,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70471,36.91,0.33,241,25967,70,NULL,NULL,'2MASX J10251359+4706547',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000144,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,156.306833333,47.11522,0,NULL,64129892101,1002029564,15656711,17.4),(70472,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70472,37.42,0.46,304,25968,70,NULL,NULL,'2MASX J10251368+4159287',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000175,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,156.3069583,41.99131,0,NULL,64152379164,1002380924,15662201,17),(70473,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70473,38.11,0.23,418,25969,70,NULL,NULL,'2MASX J10251467+0114556',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000084,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,156.3112083,1.24869,0.085,NULL,60736847746,949013246,14828331,17.1),(70474,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70474,39.13,0.46,671,25970,70,NULL,NULL,'SDSS J102514.79+011924.6',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000149,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,156.311667,1.3235,0.085,NULL,60736849044,949013266,14828332,17.8),(70475,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70475,38.12,0.33,420,25971,70,NULL,NULL,'2MASX J10251527+0138306',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000186,NULL,'17.4g',0.24,'AGN',NULL,NULL,NULL,NULL,1,156.3135,1.64189,0.081,NULL,60734940725,948983448,14827866,17.4),(70476,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70476,37.82,0.33,366,25972,70,NULL,NULL,'SDSS J102516.54+563220.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000141,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,156.3189583,56.53906,0,NULL,61896008178,967125127,15111330,18.1),(70477,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70477,38.12,0.33,420,25973,70,NULL,NULL,'2MASX J10251780+0132376',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00014,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,156.3242083,1.54372,0.081,NULL,60734937630,948983400,14827865,17.8),(70478,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70478,39.1,0.46,661,25974,70,NULL,NULL,'SDSS J102517.95+114921.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,156.324833333,11.82267,0.045,NULL,61036420965,953694077,14901469,18.4),(70479,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70479,38.02,0.46,402,25975,70,NULL,NULL,'2MASX J10251913+0045336',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000079,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,156.329583,0.75936,0.093,NULL,60737667076,949026048,14828532,17.8),(70480,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70480,37.44,0.46,307,25976,70,NULL,NULL,'2MASX J10252018+2628574',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000183,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,156.334208333,26.48261,0.045,NULL,60478845644,944981963,14765343,16.7),(70481,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70481,37.82,0.33,366,25977,70,NULL,NULL,'2MASX J10252160+5641360',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000178,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,156.340167,56.69333,0,NULL,61896155123,967127423,15111365,17.5),(70482,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70482,36.57,0.46,206,25978,70,NULL,NULL,'2MASX J10252170+3715168',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000186,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,156.340333,37.25481,0,NULL,64042937332,1000670895,15635482,16.5),(70483,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70483,36.99,0.33,250,25979,70,NULL,NULL,'2MASX J10252204+1908235',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000178,NULL,'15.9g',0.42,NULL,NULL,NULL,NULL,NULL,1,156.342,19.13975,0.017,NULL,60997536502,953086507,14891976,15.9),(70484,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70484,37.07,0.15,260,25980,70,NULL,NULL,'2MASX J10252217+4753147',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,156.3422917,47.88758,0,NULL,64129455291,1002022738,15656605,17.5),(70485,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70485,36.3,0.33,182,25981,70,NULL,NULL,'CGCG 183-022',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.000203,NULL,'14.9g',0.67,'E',NULL,NULL,NULL,NULL,1,156.347083,37.44692,0,NULL,64043068225,1000672941,15635514,14.9),(70486,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70486,36.93,0.46,243,25982,70,NULL,NULL,'2MASX J10252429+0545439',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000172,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,156.35125,5.76206,0.017,NULL,60737742806,949027231,14828550,16.7),(70487,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70487,36.44,0.33,194,25983,70,NULL,NULL,'2MASX J10252470+2725064',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000092,NULL,'16.6g',0.24,'SF',NULL,NULL,NULL,NULL,1,156.352917,27.41842,0.049,NULL,64028391940,1000443624,15631931,16.6),(70488,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70488,36.5,0.33,199,25984,70,NULL,NULL,'2MASX J10252498+3718008',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000182,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,156.354125,37.30019,0,NULL,64042938016,1000670906,15635482,16.9),(70489,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70489,36.07,0.33,164,25985,70,NULL,NULL,'CGCG 240-041',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000171,NULL,'15.6g',0.41,'E0',NULL,NULL,NULL,NULL,1,156.357667,47.47842,0,NULL,64129573409,1002024584,15656634,15.6),(70490,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70490,33.01,0.49,40.1,25986,75,NULL,'IR','MCG -02-27-001',NULL,'2011yCatp016004901K',2011,1,1.75,NULL,'G',0.000033,NULL,'14.5R',0.12,'Sd',NULL,NULL,NULL,NULL,1,156.360333,-15.34922,0.265,NULL,41656514282,650883035,10170047,14.5),(70491,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70491,33.87,NULL,59.5,25986,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -02-27-001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70492,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70492,33.89,NULL,59.9,25986,NULL,NULL,'Dipole + Quadrupole','MCG -02-27-001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70493,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70493,33.89,NULL,59.9,25986,NULL,NULL,'Dipole','MCG -02-27-001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70494,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70494,33.96,NULL,61.8,25986,NULL,NULL,NULL,'MCG -02-27-001',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70495,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70495,37.65,0.46,340,25987,70,NULL,NULL,'2MASX J10252759+4344497',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000174,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,156.3650417,43.74719,0,NULL,64154285820,1002410715,15662667,17.2),(70496,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70496,37.84,0.46,369,25988,70,NULL,NULL,'2MASX J10252762+6114264',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,156.365375,61.24061,0,NULL,61942897941,967857780,15122777,17.7),(70497,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70497,36.44,0.33,194,25989,70,NULL,NULL,'2MASX J10252793+2724364',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00017,NULL,'15.6g',0.48,NULL,NULL,NULL,NULL,NULL,1,156.366583,27.41017,0.049,NULL,64028378592,1000443415,15631928,15.6),(70498,'IRAS','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70498,32.73,0.8,35.2,25990,75,NULL,'MAT, I','NGC 3244',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000022,NULL,'12.89',1.5,'SA(rs)cd       HII',NULL,NULL,NULL,NULL,1,156.370167,-39.82756,0.549,NULL,42135731545,658370805,10287043,12.89),(70499,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70499,31.57,0.43,20.6,25990,75,NULL,'MAT, I, raw','NGC 3244',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70500,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70500,31.65,0.43,21.3,25990,75,NULL,'MAT, I, inv','NGC 3244',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70501,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70501,32.03,0.32,25.5,25990,85,NULL,'I, raw','NGC 3244',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70502,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70502,32.04,0.43,25.6,25990,75,NULL,'MAT, I, cor','NGC 3244',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70503,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70503,32.06,0.32,25.8,25990,85,NULL,'I, inv','NGC 3244',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70504,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70504,32.15,0.47,27,25990,NULL,NULL,'H','NGC 3244',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70505,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70505,32.22,0.46,27.8,25990,NULL,NULL,'J','NGC 3244',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70506,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70506,32.23,0.45,27.9,25990,NULL,NULL,'K','NGC 3244',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70507,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70507,32.93,0.4,38.5,25990,NULL,NULL,'mean','NGC 3244',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70508,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70508,33.26,0.08,45,25990,NULL,NULL,NULL,'NGC 3244',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70509,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70509,37.07,0.15,260,25991,70,NULL,NULL,'2MASX J10252928+4741157',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,156.3722083,47.68775,0,NULL,64129445050,1002022578,15656602,17.6),(70510,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70510,38.18,0.46,433,25992,70,NULL,NULL,'SDSS J102529.53+085303.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00017,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,156.373041667,8.88442,0.045,NULL,61042021686,953781588,14902837,18.7),(70511,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70511,37.57,0.46,327,25993,70,NULL,NULL,'2MASX J10253009+5004501',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000166,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,156.3752083,50.08064,0,NULL,63991361909,999865029,15622891,17.1),(70512,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70512,36.5,0.33,199,25994,70,NULL,NULL,'2MASX J10253052+3721067',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000157,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,156.377125,37.35186,0,NULL,64043065097,1000672892,15635513,16.6),(70513,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70513,37.89,0.46,378,25995,70,NULL,NULL,'2MASX J10253071+4128337',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,156.377875,41.47597,0,NULL,64150333925,1002348967,15661702,18.1),(70514,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70514,35.77,0.46,143,25996,70,NULL,NULL,'CGCG 037-032',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000123,NULL,'15.7g',0.38,'E','Isolated galaxy',NULL,NULL,NULL,1,156.380083333,7.46294,0.033,NULL,61040246537,953753852,14902403,15.7),(70515,'Black Hole','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70515,34.9,0.57,95.5,25997,NULL,NULL,NULL,'MRK 0142',NULL,'2014ApJ...793..108W',2014,1,0.41,NULL,'G',0.000153,NULL,'15.8g',0.34,'SB0/a          Sy1',NULL,NULL,NULL,'Sy 1',1,156.380333333,51.67636,0,NULL,63992352323,999880505,15623132,15.8),(70516,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70516,37.82,0.46,367,25998,70,NULL,NULL,'2MASX J10253131+5410260',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,156.38075,54.17381,0,NULL,61906414675,967287729,15113870,17.6),(70517,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70517,37.66,0.46,340,25999,70,NULL,NULL,'2MASX J10253266+1125341',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,156.38625,11.42622,0.033,NULL,61036359055,953693110,14901454,17.3),(70518,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70518,36.97,0.46,248,26000,70,NULL,NULL,'2MASX J10253285+1049191',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000152,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,156.386833,10.82203,0.077,NULL,61039391673,953740494,14902195,17.1),(70519,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70519,33.68,0.69,54.4,26001,100,NULL,'mid-IR','IC 0609',NULL,'2013ApJ...771...88L',2013,1,1.5,NULL,'G',0.00003,NULL,'14.07',0.7,'SAB(rs)bc pec',NULL,NULL,NULL,NULL,1,156.397625,-2.21522,0.077,NULL,41218870791,644044856,10063200,14.07),(70520,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70520,34.18,0.35,68.4,26001,NULL,NULL,NULL,'IC 0609',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70521,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70521,34.22,0.2,69.8,26001,74.4,NULL,NULL,'IC 0609',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70522,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70522,34.29,0.34,72.1,26001,NULL,NULL,'Malmquist cor.','IC 0609',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70523,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70523,34.51,0.47,80,26001,NULL,NULL,'H','IC 0609',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70524,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70524,34.61,0.46,83.4,26001,NULL,NULL,'J','IC 0609',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70525,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70525,34.61,0.4,83.7,26001,NULL,NULL,'mean','IC 0609',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70526,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70526,34.63,0.45,84.1,26001,NULL,NULL,'K','IC 0609',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70527,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70527,38.27,0.23,450,26002,70,NULL,NULL,'2MASX J10253635+0103239',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000087,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,156.4015,1.05667,0.085,NULL,60737705789,949026652,14828541,18.5),(70528,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70528,36.75,0.17,224,26003,70,NULL,NULL,'CGCG 094-046',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000237,NULL,'15.4',0.2,NULL,'Group member',NULL,NULL,NULL,1,156.403417,17.08069,0.109,NULL,60962798024,952543719,14883495,15.4),(70529,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70529,37.99,0.46,396,26004,70,NULL,NULL,'SDSS J102537.03+530028.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000204,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,156.404333,53.00803,0,NULL,61893769683,967090151,15110783,17.7),(70530,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70530,36.15,0.33,170,26005,70,NULL,NULL,'2MASX J10253715+3207417',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000171,NULL,'16.0g',0.34,NULL,NULL,NULL,NULL,NULL,1,156.4047083,32.12825,0.049,NULL,64083763626,1001308806,15645450,16),(70531,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70531,38.21,0.46,439,26006,70,NULL,NULL,'SDSS J102537.88+194649.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000122,NULL,'18.4g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,156.407875,19.78047,0.013,NULL,60996165224,953065081,14891641,18.4),(70532,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70532,37.63,0.46,336,26007,70,NULL,NULL,'2MASX J10253795+4749391',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,156.408083333,47.82758,0,NULL,64129457650,1002022775,15656605,17.7),(70533,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70533,38.34,0.46,465,26008,70,NULL,NULL,'2MASX J10254009+0901045',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,156.4169583,9.01806,0.069,NULL,61041837023,953778703,14902792,17.7),(70534,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70534,36.2,0.46,174,26009,70,NULL,NULL,'2MASX J10254019+0947205',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00016,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,156.4175,9.78919,0.101,NULL,61037511933,953711123,14901736,16.3),(70535,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70535,37.16,0.46,270,26010,70,NULL,NULL,'SDSS J102540.95+391046.3',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.0g',0.44,'AGN',NULL,NULL,NULL,NULL,1,156.420667,39.17956,0,NULL,64148506701,1002320417,15661256,16),(70536,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70536,32.56,0.4,32.5,26011,75,NULL,NULL,'UGC 05642',NULL,'2008Ap.....51..336K',2008,1,2.07,NULL,'G',0.000009,NULL,'14.7g',0.32,'Sbc','Isolated galaxy',NULL,NULL,NULL,1,156.424333,11.73911,0.029,NULL,61036121076,953689391,14901396,14.7),(70537,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70537,33.03,0.49,40.4,26011,75,NULL,'IR','UGC 05642',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70538,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70538,33.07,0.43,41,26011,75,NULL,'3.6 micron, color + selection bias corrected','UGC 05642',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70539,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70539,33.13,0.43,42.4,26011,75,NULL,'3.6 micron, color corrected','UGC 05642',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70540,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70540,33.18,0.2,43.3,26011,74.4,NULL,NULL,'UGC 05642',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70541,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70541,33.34,NULL,46.5,26011,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05642',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70542,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70542,33.34,NULL,46.6,26011,NULL,NULL,'Dipole + Quadrupole','UGC 05642',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70543,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70543,33.35,NULL,46.8,26011,NULL,NULL,'Dipole','UGC 05642',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70544,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70544,33.46,NULL,49.3,26011,NULL,NULL,NULL,'UGC 05642',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70545,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70545,37.65,0.33,339,26012,70,NULL,NULL,'2MASX J10254264+1553237',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,156.427791667,15.88986,0.101,NULL,60965925223,952592581,14884259,17.3),(70546,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70546,36.52,0.46,201,26013,70,NULL,NULL,'2MASX J10254308+3221247',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,156.429416667,32.35672,0.057,NULL,64081917606,1001279962,15644999,17.1),(70547,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70547,35.69,0.44,137,26014,NULL,NULL,'Malmquist cor.','2MASX J10254305+1057215',NULL,'2009ApJS..182..474S',2009,1,0.61,NULL,'G',0.000012,NULL,'15.9g',0.28,'S',NULL,NULL,NULL,NULL,1,156.4297083,10.95592,0.077,NULL,61039356426,953739944,14902186,15.9),(70548,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70548,35.77,0.43,142,26014,NULL,NULL,NULL,'2MASX J10254305+1057215',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70549,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70549,35.81,0.2,145,26014,74.4,NULL,NULL,'2MASX J10254305+1057215',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70550,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70550,38.27,0.23,450,26015,70,NULL,NULL,'2MASX J10254368+0109189',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000077,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,156.431875,1.15525,0.085,NULL,60737540516,949024070,14828501,18),(70551,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70551,36.91,0.33,241,26016,70,NULL,NULL,'2MASX J10254401+4719352',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000185,NULL,'15.5g',0.53,'ALG',NULL,NULL,NULL,NULL,1,156.4334583,47.32642,0,NULL,64129386486,1002021663,15656588,15.5),(70552,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70552,36.7,0.85,219,26017,70,NULL,NULL,'2MASX J10254477-0919461',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,156.436541667,-9.32947,0.125,NULL,41772365811,652693215,10198331,16.9),(70553,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70553,38.27,0.23,450,26018,70,NULL,NULL,'2MASX J10254482+0113029',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000086,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,156.436625,1.21756,0.085,NULL,60737571067,949024547,14828508,17.3),(70554,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70554,36.58,0.46,207,26019,70,NULL,NULL,'VII Zw 326',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00018,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,156.4402083,59.43264,0,NULL,61948595864,967946810,15124168,16.2),(70555,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70555,36.07,0.33,164,26020,70,NULL,NULL,'2MASX J10254582+4740472',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000181,NULL,'15.8g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,156.440917,47.67975,0,NULL,64129447894,1002022623,15656603,15.8),(70556,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70556,36.99,0.33,250,26021,70,NULL,NULL,'SDSS J102546.15+190532.4',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,156.442333,19.09236,0.017,NULL,60997749028,953089828,14892028,17.9),(70557,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70557,32.27,NULL,28.4,26022,NULL,NULL,NULL,'CGCG 037-033',NULL,'2015AstBu..70....1K',2015,1,1.04,'The SDSS position applies to a knot or superposed star.','G',0.000019,NULL,'16.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,156.443167,5.65347,0.017,NULL,60737757258,949027457,14828554,16.5),(70558,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70558,36.12,0.46,167,26023,70,NULL,NULL,'2MASX J10254693+2307282',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000175,NULL,'16.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,156.445667,23.12456,0.017,NULL,60949518454,952336225,14880253,16.5),(70559,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70559,36.47,0.46,197,26024,70,NULL,NULL,'2MASX J10254789+3749575',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.17',0.24,NULL,NULL,NULL,NULL,NULL,1,156.4495,37.83278,0,NULL,64114148776,1001783574,15652868,17.17),(70560,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70560,36.32,0.33,184,26025,70,NULL,NULL,'MCG +07-22-005',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00019,NULL,'15.7g',0.42,'E0',NULL,NULL,NULL,NULL,1,156.454583,40.07272,0.009,NULL,64151667324,1002369801,15662028,15.7),(70561,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70561,38.06,0.46,410,26026,70,NULL,NULL,'SDSS J102549.49+011954.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000147,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,156.45625,1.33192,0.085,NULL,60737527518,949023867,14828497,18.6),(70562,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70562,38.13,0.46,422,26027,70,NULL,NULL,'2MASX J10254949+2428074',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,156.456417,24.46872,0,NULL,60466385309,944787270,14762301,17.4),(70563,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70563,37.33,0.46,292,26028,70,NULL,NULL,'2MASXi J1025497+383656',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000142,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,156.4572917,38.61567,0,NULL,64147810759,1002309543,15661086,17.7),(70564,'IRAS','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70564,32.8,0.8,36.3,26029,75,NULL,'HMCL, I','NGC 3256A',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',NULL,NULL,'15.00',0.6,'SB(s)m pec:',NULL,NULL,NULL,NULL,1,156.462667,-43.74808,0.529,NULL,42141984083,658468501,10288570,15),(70565,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70565,32.83,0.4,36.8,26029,75,NULL,'HMCL, I, raw','NGC 3256A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70566,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70566,32.84,0.4,37,26029,75,NULL,'HMCL, I, inv','NGC 3256A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70567,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70567,33.04,0.4,40.5,26029,75,NULL,'HMCL, I, cor','NGC 3256A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70568,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70568,37.65,0.33,339,26030,70,NULL,NULL,'2MASX J10255184+1548186',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,156.465917,15.80506,0.105,NULL,60966047394,952594490,14884288,17.5),(70569,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70569,38.27,0.23,450,26031,70,NULL,NULL,'2MASX J10255197+0111264',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000297,NULL,'16.99',0.45,'BrClG',NULL,NULL,NULL,NULL,1,156.466583333,1.19061,0.085,NULL,60737572435,949024569,14828508,16.99),(70570,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70570,36.55,0.33,204,26032,70,NULL,NULL,'CGCG 183-023',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000194,NULL,'15.0g',0.61,NULL,NULL,NULL,NULL,NULL,1,156.466667,35.95783,0,NULL,64072720572,1001136258,15642754,15),(70571,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70571,38.31,0.33,459,26033,70,NULL,NULL,'SDSS J102552.30+115649.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000137,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,156.467958333,11.94714,0.045,NULL,61036114157,953689283,14901395,18.7),(70572,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70572,37.6,0.46,331,26034,70,NULL,NULL,'2MASX J10255262+3140220',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000165,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,156.469333,31.67289,0.061,NULL,64083849476,1001310148,15645471,18.2),(70573,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70573,35.45,0.35,123,26035,NULL,NULL,'Malmquist cor.','CGCG 065-031',NULL,'2009ApJS..182..474S',2009,1,1.13,NULL,'G',0.000018,NULL,'15.3g',0.28,'Sb',NULL,NULL,NULL,NULL,1,156.470916667,12.71089,0.081,NULL,61170626997,955791046,14934235,15.3),(70574,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70574,35.47,0.35,124,26035,NULL,NULL,NULL,'CGCG 065-031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70575,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70575,35.73,0.2,140,26035,74.4,NULL,NULL,'CGCG 065-031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70576,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70576,31.88,0.4,23.8,26036,75,NULL,NULL,'UGC 05646',NULL,'2008Ap.....51..336K',2008,1,1.7,'HOLM 192B is a star.','G',0.00003,NULL,'14.0g',0.55,'Sd','Group member',NULL,NULL,NULL,1,156.4712083,14.36317,0.109,NULL,60954950190,952421096,14881579,14),(70577,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70577,32.2,NULL,27.6,26036,NULL,NULL,NULL,'UGC 05646',NULL,'2015AstBu..70....1K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70578,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70578,32.52,0.49,31.9,26036,75,NULL,'IR','UGC 05646',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70579,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70579,38.13,0.46,424,26037,70,NULL,NULL,'2MASX J10255421+3912265',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000134,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,156.475791667,39.20722,0,NULL,64148508647,1002320447,15661256,17.6),(70580,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70580,36.55,0.33,204,26038,70,NULL,NULL,'2MASX J10255734+3550471',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,156.489083,35.84647,0,NULL,64075601032,1001181266,15643457,17.2),(70581,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70581,36.25,0.46,178,26039,70,NULL,NULL,'2MASX J10255740+1342336',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000162,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,156.4892083,13.70947,0.109,NULL,60955520616,952430009,14881718,16.6),(70582,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70582,36.32,0.33,184,26040,70,NULL,NULL,'SDSS J102557.44+400246.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000169,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,156.489375,40.04619,0.009,NULL,64151641825,1002369403,15662021,17.4),(70583,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70583,36.75,0.17,224,26041,70,NULL,NULL,'2MASX J10255841+1704026',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.33',0.32,NULL,NULL,NULL,NULL,NULL,1,156.4934583,17.06739,0.109,NULL,60962859801,952544684,14883510,17.33),(70584,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70584,36.67,0.46,216,26042,70,NULL,NULL,'2MASX J10255902+3907445',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000186,NULL,'16.1g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,156.496083333,39.12911,0,NULL,64148685392,1002323209,15661300,16.1),(70585,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70585,37.69,0.46,346,26043,70,NULL,NULL,'2MASX J10255989+3637185',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00014,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,156.4997083,36.62183,0,NULL,64043278828,1000676231,15635566,17.8),(70586,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70586,38.31,0.33,459,26044,70,NULL,NULL,'2MASX J10260012+1151385',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000184,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,156.500541667,11.86061,0.029,NULL,61036164204,953690065,14901407,16.7),(70587,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70587,36.41,0.46,191,26045,70,NULL,NULL,'2MASX J10260156+0527574',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000188,NULL,'15.9g',0.4,'S0',NULL,NULL,NULL,NULL,1,156.5065417,5.46586,0.037,NULL,60737869338,949029208,14828581,15.9),(70588,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70588,38.24,0.46,444,26046,70,NULL,NULL,'SDSS J102602.01+012720.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000145,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,156.508417,1.45564,0.085,NULL,60736801260,949012519,14828320,18.3),(70589,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70589,37.49,0.46,315,26047,70,NULL,NULL,'2MASX J10260237+0911395',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000194,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,156.50975,9.19425,0.073,NULL,61050433728,953913027,14904891,16.4),(70590,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70590,37.24,0.46,281,26048,70,NULL,NULL,'2MASX J10260279+1527325',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,156.511583333,15.45914,0.113,NULL,60965620651,952587822,14884184,17.8),(70591,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70591,36.97,0.46,247,26049,70,NULL,NULL,'2MASX J10260374+2104531',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00017,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,156.515625,21.08147,0.025,NULL,60940159547,952189992,14877968,17.1),(70592,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70592,37.85,0.46,372,26050,70,NULL,NULL,'SDSS J102604.98+044757.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,156.520791667,4.79925,0.025,NULL,60738500915,949039076,14828735,18.3),(70593,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70593,38.67,0.46,541,26051,70,NULL,NULL,'SDSS J102605.07+360351.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,156.521125,36.06433,0,NULL,64072774533,1001137102,15642767,17.7),(70594,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70594,37.88,0.21,376,26052,70,NULL,NULL,'2MASX J10260584+0034134',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000083,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,156.524333,0.57022,0.109,NULL,60737048616,949016384,14828381,17.1),(70595,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70595,37.07,0.46,260,26053,70,NULL,NULL,'2MASX J10260624+0146124',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000172,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,156.525833,1.77006,0.077,NULL,60735396759,948990574,14827977,17.2),(70596,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70596,34.39,0.56,75.6,26054,70,NULL,NULL,'ESO 568- G 008',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000037,NULL,'15.5',0.6,'S0','Pair member (points to parent)',NULL,NULL,NULL,1,156.534,-20.23528,0.329,NULL,41663676192,650994940,10171795,15.5),(70597,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70597,38.3,0.46,456,26055,70,NULL,NULL,'2MASX J10260939+4834547',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,156.5392917,48.582,0,NULL,64137405091,1002146954,15658546,17.7),(70598,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70598,34.89,0.62,94.9,26056,70,NULL,NULL,'2MASX J10260948-2034149',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000133,NULL,'15.66',NULL,'E',NULL,NULL,NULL,NULL,1,156.539375,-20.57081,0.329,NULL,41618935997,650295874,10160873,15.66),(70599,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70599,37.93,0.46,385,26057,70,NULL,NULL,'2MASX J10260952+3743106',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,156.53975,37.71972,0,NULL,64042975317,1000671489,15635492,17.8),(70600,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70600,36.15,0.33,170,26058,70,NULL,NULL,'CGCG 154-015',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000093,NULL,'14.8g',0.62,NULL,NULL,NULL,NULL,NULL,1,156.546375,32.099,0.049,NULL,64083948031,1001311687,15645495,14.8),(70601,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70601,37.29,0.46,287,26059,70,NULL,NULL,'2MASX J10261264+0157564',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,156.552625,1.96572,0.085,NULL,60735505581,948992274,14828004,17.7),(70602,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70602,38.05,0.46,407,26060,70,NULL,NULL,'2MASX J10261311+3644036',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000176,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,156.554833,36.73447,0,NULL,64043275398,1000676178,15635565,17.4),(70603,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70603,34.51,0.2,79.8,26061,74.4,NULL,NULL,'2MASX J10261377+1102324',NULL,'2013AJ....146...86T',2013,1,0.55,NULL,'G',0.000007,NULL,'15.7g',0.31,'S',NULL,NULL,NULL,NULL,1,156.557333,11.04225,0.029,NULL,61039469854,953741716,14902214,15.7),(70604,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70604,34.56,0.52,81.6,26061,NULL,NULL,NULL,'2MASX J10261377+1102324',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70605,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70605,34.65,0.5,85.1,26061,NULL,NULL,'Malmquist cor.','2MASX J10261377+1102324',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70606,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70606,36.26,0.59,178,26062,70,NULL,NULL,'2MASX J10261383-1457516',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,156.557667,-14.96436,0.353,NULL,41644205288,650690707,10167042,14.7),(70607,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70607,36.48,0.46,198,26063,70,NULL,NULL,'2MASX J10261387+1313517',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000142,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,156.557917,13.23097,0.077,NULL,60951921197,952373768,14880840,17.1),(70608,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70608,37.88,0.21,376,26064,70,NULL,NULL,'2MASX J10261537+0027414',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000068,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,156.564083333,0.46156,0.117,NULL,60734229333,948972333,14827692,18.3),(70609,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70609,38.15,0.46,427,26065,70,NULL,NULL,'2MASX J10261628+2056447',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,156.5680417,20.94592,0.041,NULL,60940216269,952190879,14877982,17.3),(70610,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70610,35,0.27,100,26066,70,NULL,NULL,'CGCG 290-039',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.000103,NULL,'14.9g',0.61,'S0^-',NULL,NULL,NULL,NULL,1,156.568417,57.29381,0,NULL,61895365309,967115082,15111173,14.9),(70611,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70611,37.86,0.46,373,26067,70,NULL,NULL,'2MASX J10261642+5051226',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,156.5684583,50.85619,0,NULL,63990728845,999855138,15622736,17.6),(70612,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70612,37.61,0.46,332,26068,70,NULL,NULL,'2MASX J10261690+3514541',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000159,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,156.570583333,35.24847,0,NULL,64074799022,1001168734,15643261,17.1),(70613,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70613,36.42,0.46,192,26069,70,NULL,NULL,'2MASX J10261805+1600297',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'16.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,156.5752083,16.00817,0.101,NULL,60967954678,952624291,14884754,16.9),(70614,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70614,38.05,0.46,408,26070,70,NULL,NULL,'2MASX J10261849+4049176',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,156.576958333,40.82153,0,NULL,64151082412,1002360662,15661885,17.5),(70615,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70615,36.31,0.33,182,26071,70,NULL,NULL,'2MASX J10261994+1235587',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000177,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,156.583166667,12.59964,0.085,NULL,61170763353,955793177,14934268,16.6),(70616,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70616,36.75,0.17,224,26072,70,NULL,NULL,'2MASX J10262031+1709567',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,156.584625,17.16567,0.109,NULL,60962838312,952544348,14883505,16.9),(70617,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70617,34.39,0.46,75.5,26073,70,NULL,NULL,'NGC 3243',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000093,NULL,'14.07',1.1,'S0^0^ pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,156.589458333,-2.62219,0.041,NULL,41218584283,644040379,10063130,14.07),(70618,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70618,37.88,0.21,376,26074,70,NULL,NULL,'2MASX J10262146+0029175',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000087,NULL,'16.7g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,156.589458333,0.48822,0.117,NULL,60734241946,948972530,14827695,16.7),(70619,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70619,33.25,0.08,44.8,26075,NULL,NULL,NULL,'NGC 3249',NULL,'2009ApJS..182..474S',2009,1,1.6,NULL,'G',0.000027,NULL,'13.83',1.3,'SAB(rs)cd:     HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,156.592541667,-34.96369,0.325,NULL,41995308367,656176693,10252760,13.83),(70620,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70620,37.09,0.46,262,26076,70,NULL,NULL,'2MASX J10262318+0125065',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,156.5965417,1.41847,0.085,NULL,60737272709,949019886,14828435,17.4),(70621,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70621,35.04,0.25,102,26077,74.4,NULL,NULL,'CGCG 065-032',NULL,'2013AJ....146...86T',2013,1,0.54,NULL,'G',0.000019,NULL,'15.4g',0.51,'E',NULL,NULL,NULL,NULL,1,156.597917,10.91842,0.077,NULL,61039677174,953744955,14902264,15.4),(70622,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70622,35.68,0.19,136,26077,70,NULL,NULL,'CGCG 065-032',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70623,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70623,37.88,0.21,376,26078,70,NULL,NULL,'SDSS J102623.53+003137.9',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000068,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,156.598083333,0.52722,0.117,NULL,60734239173,948972487,14827695,17.8),(70624,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70624,36.75,0.17,224,26079,70,NULL,NULL,'2MASX J10262365+1702436',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,156.598583,17.0455,0.101,NULL,60962882651,952545041,14883516,16.7),(70625,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70625,36.43,0.46,193,26080,70,NULL,NULL,'2MASX J10262440+4117417',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000165,NULL,'16.1g',0.33,'S0^-',NULL,NULL,NULL,NULL,1,156.601625,41.29478,0,NULL,64150835953,1002356811,15661825,16.1),(70626,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70626,36.7,0.46,219,26081,70,NULL,NULL,'2MASX J10262531+3844476',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,156.605333333,38.74644,0,NULL,64148619229,1002322175,15661283,17),(70627,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70627,37.78,0.46,360,26082,70,NULL,NULL,'2MASX J10262532+1328556',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,156.6055417,13.48206,0.109,NULL,60951916643,952373697,14880839,17.5),(70628,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70628,34.29,0.44,72.2,26083,NULL,NULL,NULL,'UGC 05651',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000007,NULL,'13.96',1.1,'SABcd:',NULL,NULL,NULL,NULL,1,156.606416667,17.51039,0.105,NULL,60962947410,952546053,14883532,13.96),(70629,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70629,34.33,0.2,73.5,26083,74.4,NULL,NULL,'UGC 05651',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70630,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70630,34.49,0.4,79.1,26083,NULL,NULL,'Malmquist cor.','UGC 05651',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70631,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70631,37.88,0.21,376,26084,70,NULL,NULL,'2MASX J10262626+0027385',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00009,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,156.609541667,0.46072,0.117,NULL,60734228403,948972318,14827692,17.2),(70632,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70632,36.3,0.33,182,26085,70,NULL,NULL,'2MASX J10262662+3727146',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000184,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,156.611125,37.45411,0,NULL,64043029464,1000672335,15635505,16.4),(70633,'CMD','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70633,27.84,NULL,3.7,26086,NULL,NULL,NULL,'DDO 078',NULL,'2012ApJ...748...47M',2012,1,2,'Huchtmeier & Skillman (1998A&AS..127..269H) give v = 2550 +/- 9.','G',0.000033,NULL,'15.8',2,'Im','Dwarf, possible member',NULL,NULL,NULL,1,156.616667,67.65972,0.057,NULL,62140743043,970949110,15171079,15.8),(70634,'TRGB','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70634,27.63,0.09,3.36,26086,NULL,NULL,'I','DDO 078',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70635,'TRGB','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70635,27.75,0.08,3.54,26086,74.4,NULL,NULL,'DDO 078',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70636,'TRGB','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70636,27.82,0.04,3.66,26086,NULL,NULL,'I','DDO 078',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70637,'TRGB','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70637,27.82,NULL,3.66,26086,NULL,NULL,NULL,'DDO 078',NULL,'2010ApJ...724.1030G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70638,'TRGB','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70638,27.85,NULL,3.72,26086,NULL,NULL,NULL,'DDO 078',NULL,'2000A&A...363..117K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70639,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70639,37.66,0.46,340,26087,70,NULL,NULL,'2MASX J10262818+2411193',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000162,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,156.617375,24.18872,0,NULL,60466146615,944783540,14762242,16.8),(70640,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70640,31.99,0.4,25,26088,NULL,NULL,'mean','IC 0610',NULL,'2007A&A...465...71T',2007,1,1.81,NULL,'G',0.000018,NULL,'14.72',0.25,'Sc             HII',NULL,NULL,NULL,NULL,1,156.6182083,20.22819,0.013,NULL,60996590955,953071733,14891745,14.72),(70641,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70641,32.33,0.43,29.2,26088,75,NULL,'3.6 micron, color + selection bias corrected','IC 0610',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70642,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70642,32.64,0.47,33.7,26088,NULL,NULL,'H','IC 0610',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70643,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70643,32.66,0.4,34.1,26088,75,NULL,NULL,'IC 0610',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70644,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70644,32.67,0.45,34.1,26088,NULL,NULL,'K','IC 0610',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70645,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70645,32.7,0.46,34.6,26088,NULL,NULL,'J','IC 0610',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70646,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70646,34,NULL,63.1,26088,NULL,NULL,NULL,'IC 0610',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70647,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70647,36.01,0.56,159,26089,70,NULL,NULL,'2MASX J10262861-0354567',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.000093,NULL,'16.68',0.38,NULL,NULL,NULL,NULL,NULL,1,156.619333,-3.91578,0.125,NULL,41215011364,643984552,10062258,16.68),(70648,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70648,34.66,0.49,85.5,26090,75,NULL,'IR','ESO 568- G 010',NULL,'2011yCatp016004901K',2011,1,1.16,NULL,'G',0.000013,NULL,'16.50',0.09,'Sd',NULL,NULL,NULL,NULL,1,156.62225,-21.31606,0.353,NULL,41621049398,650328896,10161389,16.5),(70649,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70649,35.06,NULL,103,26090,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 568- G 010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70650,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70650,35.08,NULL,104,26090,NULL,NULL,'Dipole + Quadrupole','ESO 568- G 010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70651,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70651,35.09,NULL,104,26090,NULL,NULL,'Dipole','ESO 568- G 010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70652,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70652,35.12,NULL,106,26090,NULL,NULL,NULL,'ESO 568- G 010',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70653,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70653,37.13,0.46,267,26091,70,NULL,NULL,'2MASX J10262926+5841576',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,156.622083,58.69942,0,NULL,61946419216,967912800,15123637,17.5),(70654,'IRAS','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70654,35.7,0.8,138,26092,75,NULL,'CF, r','UGC 05654',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'14.90',0.7,'Sbc',NULL,NULL,NULL,NULL,1,156.631875,15.34,0.125,NULL,60967393970,952615530,14884617,14.9),(70655,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70655,35.75,0.38,141,26092,75,NULL,'CF, r, raw','UGC 05654',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70656,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70656,35.87,0.38,150,26092,75,NULL,'CF, r, inv','UGC 05654',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70657,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70657,35.99,0.38,158,26092,75,NULL,'CF, r, cor','UGC 05654',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70658,'SBF','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70658,33.15,0.17,42.7,26093,NULL,NULL,'I','NGC 3250',NULL,'2001ApJ...546..681T',2001,1,2.8,NULL,'G',0.000107,NULL,'12.18',2,'E4','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,156.6345,-39.94394,0.529,NULL,42135754813,658371168,10287049,12.18),(70659,'SBF','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70659,33.15,0.17,42.7,26093,NULL,NULL,NULL,'NGC 3250',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70660,'SBF','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70660,33.16,0.17,42.9,26093,NULL,NULL,'Malmquist cor.','NGC 3250',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70661,'SBF','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70661,33.18,0.14,43.3,26093,74.4,NULL,NULL,'NGC 3250',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70662,'D-Sigma','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70662,33.15,0.4,42.6,26093,75,NULL,'Edat, raw','NGC 3250',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70663,'D-Sigma','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70663,33.24,0.4,44.4,26093,75,NULL,'Edat, cor','NGC 3250',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70664,'Faber-Jackson','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70664,31.6,0.63,20.9,26093,95,NULL,'Michard 1979b, c','NGC 3250',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70665,'Faber-Jackson','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70665,31.71,0.37,22,26093,95,NULL,'Weighted Mean','NGC 3250',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70666,'Faber-Jackson','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70666,31.95,0.46,24.5,26093,95,NULL,'Michard 1979a','NGC 3250',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70667,'Faber-Jackson','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70667,33.56,0.81,51.5,26093,55,NULL,'Visvanathan & Sandage 1979','NGC 3250',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70668,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70668,32.47,0.41,31.2,26093,NULL,NULL,NULL,'NGC 3250',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70669,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70669,32.81,0.41,36.4,26093,NULL,NULL,'Malmquist cor.','NGC 3250',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70670,'Tully est','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70670,32.87,0.8,37.4,26093,75,NULL,'B','NGC 3250',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70671,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70671,32.71,0.45,34.9,26093,NULL,NULL,'K','NGC 3250',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70672,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70672,32.94,0.4,38.6,26093,NULL,NULL,'mean','NGC 3250',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70673,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70673,37,0.46,251,26094,70,NULL,NULL,'2MASX J10263299+4658081',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000193,NULL,'15.8g',0.34,'E0',NULL,NULL,NULL,NULL,1,156.637625,46.96892,0,NULL,64129871467,1002029241,15656706,15.8),(70674,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70674,37.12,0.46,266,26095,70,NULL,NULL,'2MASX J10263339+2154576',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,156.6392917,21.91592,0.017,NULL,60947789516,952309211,14879831,17.7),(70675,'BL Lac Luminosity','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70675,41.42,NULL,1920,26096,70,NULL,'min.','PKS 1029-85',NULL,'2014ApJ...784..151S',2014,1,NULL,NULL,'RadioS',NULL,NULL,NULL,NULL,'AGN',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,156.6465,-85.72086,0.473,NULL,39734233518,620847398,9700740,NULL),(70676,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70676,37.07,0.33,259,26097,70,NULL,NULL,'2MASX J10263563+5313528',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000185,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,156.64825,53.23119,0,NULL,61893584534,967087258,15110738,16.3),(70677,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70677,35.62,0.36,133,26098,NULL,NULL,'Malmquist cor.','CGCG 065-035',NULL,'2009ApJS..182..474S',2009,1,0.82,NULL,'G',0.000014,NULL,'15.2g',0.52,'Sb',NULL,NULL,NULL,NULL,1,156.650417,12.04019,0.045,NULL,61170148459,955783569,14934118,15.2),(70678,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70678,35.71,0.2,139,26098,74.4,NULL,NULL,'CGCG 065-035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70679,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70679,35.83,0.33,147,26098,NULL,NULL,NULL,'CGCG 065-035',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70680,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70680,37.06,0.46,258,26099,70,NULL,NULL,'2MASX J10263618+5807583',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000182,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,156.650875,58.133,0,NULL,61945817641,967903400,15123490,16.5),(70681,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70681,35.84,0.46,147,26100,70,NULL,NULL,'2MASX J10263637+1933036',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000102,NULL,'15.9g',0.44,NULL,NULL,NULL,NULL,NULL,1,156.651625,19.55097,0.025,NULL,60997110051,953079844,14891872,15.9),(70682,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70682,38.27,0.46,450,26101,70,NULL,NULL,'2MASX J10263646+0044085',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000085,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,156.651875,0.73561,0.121,NULL,60736996324,949015567,14828368,17.5),(70683,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70683,35.53,0.25,128,26102,74.4,NULL,NULL,'CGCG 065-034',NULL,'2013AJ....146...86T',2013,1,0.69,NULL,'G',0.000022,NULL,'15.7g',0.35,'S0',NULL,NULL,NULL,NULL,1,156.652,10.93519,0.029,NULL,61039688683,953745135,14902267,15.7),(70684,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70684,37.45,0.33,309,26103,70,NULL,NULL,'SDSS J102639.27+012900.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000135,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,156.663667,1.48353,0.085,NULL,60737267033,949019797,14828434,18),(70685,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70685,36.93,0.46,243,26104,70,NULL,NULL,'2MASX J10263958+5413323',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,156.665083,54.22547,0,NULL,61906374407,967287100,15113860,17.5),(70686,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70686,37.45,0.33,309,26105,70,NULL,NULL,'2MASX J10263964+0131435',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,156.665333,1.52869,0.073,NULL,60735232846,948988013,14827937,17.4),(70687,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70687,36.64,0.46,213,26106,70,NULL,NULL,'2MASX J10264012+3744316',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,156.66725,37.74203,0,NULL,64114244453,1001785069,15652891,17),(70688,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70688,35.83,0.46,147,26107,70,NULL,NULL,'2MASX J10264018+0117485',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,156.667417,1.29683,0.085,NULL,60737286227,949020097,14828439,16.7),(70689,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70689,38.22,0.46,441,26108,70,NULL,NULL,'SDSS J102640.69+000847.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000081,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,156.669583,0.14656,0.121,NULL,60734174900,948971482,14827679,18.7),(70690,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70690,36.62,0.46,211,26109,70,NULL,NULL,'2MASX J10264084+0218245',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,156.6702917,2.30689,0.077,NULL,60734664067,948979126,14827798,17),(70691,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70691,36.45,0.46,195,26110,70,NULL,NULL,'2MASX J10264172+1158252',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000155,NULL,'17.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,156.673708333,11.97369,0.029,NULL,61036137173,953689643,14901400,17.3),(70692,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70692,32.52,0.4,31.9,26111,75,NULL,'B','NGC 3246',NULL,'1988NBGC.C....0000T',1988,1,2.14,NULL,'G',0.000019,NULL,'13.8g',0.89,'SABdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,156.674208333,3.86192,0.049,NULL,60740251942,949066436,14829163,13.8),(70693,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70693,32.75,0.4,35.5,26111,NULL,NULL,NULL,'NGC 3246',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70694,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70694,37.12,0.57,265,26112,70,NULL,NULL,'2MASX J10264222-0207108',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'17.09',0.33,NULL,NULL,NULL,NULL,NULL,1,156.676,-2.11972,0.057,NULL,41207815430,643872116,10060501,17.09),(70695,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70695,35.99,0.27,157,26113,70,NULL,NULL,'CGCG 124-021',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.00016,NULL,'15.0g',0.57,NULL,NULL,NULL,NULL,NULL,1,156.678583,21.724,0.017,NULL,60948444139,952319439,14879991,15),(70696,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70696,35,0.27,100,26114,70,NULL,NULL,'NGC 3238',NULL,'2015arXiv151105856S',2015,1,1.27,NULL,'G',0.000103,NULL,'13.8g',1,'SA(r)0^0^:',NULL,NULL,NULL,NULL,1,156.679125,57.22633,0,NULL,61895564859,967118200,15111221,13.8),(70697,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70697,34.64,0.45,84.9,26114,NULL,NULL,'K','NGC 3238',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70698,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70698,35.14,0.4,107,26114,NULL,NULL,'mean','NGC 3238',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70699,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70699,34.34,0.43,73.9,26115,75,NULL,'3.6 micron, color + selection bias corrected','ESO 568- G 012',NULL,'2014MNRAS.444..527S',2014,1,1.14,NULL,'G',0.000017,NULL,'16.13',0.11,'Sc             HII',NULL,NULL,NULL,NULL,1,156.683666667,-21.86333,0.313,NULL,41620884965,650326327,10161348,16.13),(70700,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70700,34.59,0.49,82.9,26115,75,NULL,'IR','ESO 568- G 012',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70701,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70701,34.62,0.43,84,26115,75,NULL,'3.6 micron, color corrected','ESO 568- G 012',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70702,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70702,34.92,0.2,96.4,26115,74.4,NULL,NULL,'ESO 568- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70703,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70703,35.11,0.57,105,26115,NULL,NULL,NULL,'ESO 568- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70704,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70704,35.14,NULL,107,26115,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 568- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70705,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70705,35.16,NULL,108,26115,NULL,NULL,'Dipole + Quadrupole','ESO 568- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70706,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70706,35.16,NULL,108,26115,NULL,NULL,'Dipole','ESO 568- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70707,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70707,35.3,0.52,115,26115,NULL,NULL,'Malmquist cor.','ESO 568- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70708,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70708,37.14,0.46,268,26116,70,NULL,NULL,'2MASX J10264583+4338231',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000157,NULL,'16.9g',0.33,NULL,NULL,NULL,NULL,NULL,1,156.690958333,43.63986,0,NULL,64154492131,1002413939,15662717,16.9),(70709,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70709,37.37,0.46,298,26117,70,NULL,NULL,'2MASX J10264619+2347419',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000181,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,156.692333,23.79489,0,NULL,60948524830,952320700,14880010,16.3),(70710,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70710,36.81,0.33,231,26118,70,NULL,NULL,'2MASX J10264698+0943528',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000194,NULL,'15.6g',0.48,'E0',NULL,NULL,NULL,NULL,1,156.695625,9.73128,0.077,NULL,61050323439,953911303,14904864,15.6),(70711,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70711,34.97,0.46,98.8,26119,70,NULL,NULL,'NGC 3236',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000087,NULL,'15.0g',0.53,'E0',NULL,NULL,NULL,NULL,1,156.702125,61.27292,0.009,NULL,61944842399,967888162,15123252,15),(70712,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70712,37.96,0.46,390,26120,70,NULL,NULL,'SDSS J102649.42+111058.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,156.705916667,11.18292,0.021,NULL,61039489041,953742016,14902219,18.2),(70713,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70713,34.77,0.45,90.1,26121,NULL,NULL,'Malmquist cor.','UGC 05656',NULL,'2009ApJS..182..474S',2009,1,1.02,NULL,'G',0.000033,NULL,'14.6g',0.57,'SAB(s)bc','Field galaxy',NULL,NULL,NULL,1,156.706833,34.92042,0,NULL,64075232797,1001175512,15643367,14.6),(70714,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70714,34.78,0.2,90.4,26121,74.4,NULL,NULL,'UGC 05656',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70715,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70715,34.88,0.43,94.8,26121,NULL,NULL,NULL,'UGC 05656',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70716,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70716,37.07,0.33,259,26122,70,NULL,NULL,'2MASX J10264999+5307198',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000208,NULL,'16.0g',0.36,'E0',NULL,NULL,NULL,NULL,1,156.7082083,53.12214,0,NULL,61893614369,967087724,15110745,16),(70717,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70717,37.29,0.46,288,26123,70,NULL,NULL,'SDSS J102650.13+442447.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000161,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,156.708875,44.41311,0,NULL,64146454604,1002288353,15660755,18.4),(70718,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70718,36.26,0.46,179,26124,70,NULL,NULL,'2MASX J10265031+3944460',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.19',0.24,NULL,NULL,NULL,NULL,NULL,1,156.70975,39.74628,0,NULL,64151551013,1002367984,15661999,16.19),(70719,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70719,37.79,0.46,361,26125,70,NULL,NULL,'2MASX J10265028+3416480',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,156.7097917,34.28017,0,NULL,64074466525,1001163539,15643180,18.1),(70720,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70720,36.81,0.33,231,26126,70,NULL,NULL,'2MASX J10265063+0945138',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,156.710917,9.75375,0.077,NULL,61050323069,953911297,14904864,17.5),(70721,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70721,38.18,0.46,432,26127,70,NULL,NULL,'SDSS J102650.75-005649.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000077,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,156.7115,-0.94722,0.077,NULL,41208375732,643880870,10060638,18.4),(70722,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70722,37.61,0.27,333,26128,70,NULL,NULL,'2MASX J10265115+0333449',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00017,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,156.713291667,3.56258,0.053,NULL,60740771480,949074554,14829289,16.7),(70723,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70723,36.08,0.46,164,26129,70,NULL,NULL,'2MASX J10265266+4019550',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000164,NULL,'15.9g',0.41,'S0/a',NULL,NULL,NULL,NULL,1,156.7192917,40.33197,0,NULL,64151735802,1002370871,15662044,15.9),(70724,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70724,37.91,0.33,382,26130,70,NULL,NULL,'2MASX J10265348+0203339',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000173,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,156.722666667,2.05942,0.085,NULL,60735615200,948993987,14828031,17.1),(70725,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70725,38.03,0.46,403,26131,70,NULL,NULL,'2MASX J10265351+4031550',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00018,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,156.722917,40.53186,0,NULL,64151001304,1002359395,15661865,17.2),(70726,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70726,38.07,0.46,412,26132,70,NULL,NULL,'2MASX J10265432+4835408',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,156.7264583,48.59461,0,NULL,64137411279,1002147051,15658547,17.4),(70727,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70727,37.61,0.27,333,26133,70,NULL,NULL,'SDSS J102654.73+033652.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,156.728083,3.61456,0.053,NULL,60740787872,949074810,14829293,18.5),(70728,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70728,35.82,0.27,146,26134,70,NULL,NULL,'CGCG 094-056',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.00017,NULL,'15.1',1,NULL,'Group member',NULL,NULL,NULL,1,156.728333,16.12339,0.089,NULL,60967976668,952624635,14884759,15.1),(70729,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70729,38.56,0.46,516,26135,70,NULL,NULL,'SDSS J102655.40+003325.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000065,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,156.730875,0.55722,0.117,NULL,60734333529,948973961,14827718,18.7),(70730,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70730,36.23,0.46,176,26136,70,NULL,NULL,'CGCG 037-039',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000068,NULL,'15.6g',0.38,'S0',NULL,NULL,NULL,NULL,1,156.734,8.15222,0.037,NULL,61042196236,953784316,14902879,15.6),(70731,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70731,32.6,0.69,33.1,26137,100,NULL,'mid-IR','ESO 500- G 041',NULL,'2013ApJ...771...88L',2013,1,1.1,NULL,'G',0.000037,NULL,'14.19',0.7,'(R)SA(r)ab     HII',NULL,NULL,NULL,NULL,1,156.7345417,-24.08922,0.293,NULL,41622178066,650346532,10161664,14.19),(70732,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70732,33.85,0.4,59,26137,NULL,NULL,'mean','ESO 500- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70733,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70733,34.57,0.45,81.9,26137,NULL,NULL,'K','ESO 500- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70734,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70734,34.6,0.47,83.1,26137,NULL,NULL,'H','ESO 500- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70735,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70735,34.61,0.46,83.5,26137,NULL,NULL,'J','ESO 500- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70736,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70736,33.94,0.49,61.3,26138,75,NULL,'IR','FGC 1071',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.00004,NULL,'16.3',0.12,'Sd',NULL,NULL,NULL,NULL,1,156.7350417,-16.07869,0.313,NULL,41657211243,650893925,10170217,16.3),(70737,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70737,34.88,NULL,94.8,26138,NULL,NULL,'Dipole + Quadrupole','FGC 1071',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70738,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70738,34.88,NULL,94.8,26138,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1071',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70739,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70739,34.89,NULL,95,26138,NULL,NULL,NULL,'FGC 1071',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70740,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70740,34.89,NULL,95.2,26138,NULL,NULL,'Dipole','FGC 1071',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70741,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70741,37.07,0.15,260,26139,70,NULL,NULL,'CGCG 240-044',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000174,NULL,'15.5g',0.5,'E0',NULL,NULL,NULL,NULL,1,156.7389583,47.52433,0,NULL,64137508343,1002148567,15658571,15.5),(70742,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70742,37.85,0.46,372,26140,70,NULL,NULL,'SDSS J102657.37+230924.5',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.7g',0.32,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,156.7390417,23.15683,0.009,NULL,60949130767,952330168,14880158,16.7),(70743,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70743,38.7,0.46,550,26141,70,NULL,NULL,'2MASX J10265901+0155289',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,156.7457917,1.92481,0.077,NULL,60735597610,948993712,14828026,18),(70744,'FP','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70744,38.5,0.46,501,26142,70,NULL,NULL,'2MASX J10270100+0104199',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000093,NULL,'18.3g',0.09,NULL,NULL,NULL,NULL,NULL,1,156.754291667,1.07211,0.061,NULL,60737373736,949021464,14828460,18.3),(70745,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70745,31.73,0.4,22.2,26143,75,NULL,NULL,'NGC 3245A',NULL,'2008Ap.....51..336K',2008,1,3.64,NULL,'G',0.000008,NULL,'14.70',0.34,'SB(s)b','in a pair',NULL,NULL,NULL,1,156.7547083,28.63933,0.045,NULL,64029618137,1000462783,15632230,14.7),(70746,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70746,31.79,NULL,22.8,26143,NULL,NULL,NULL,'NGC 3245A',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70747,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70747,31.8,NULL,22.9,26143,NULL,NULL,'Dipole','NGC 3245A',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70748,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70748,31.81,NULL,23,26143,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 3245A',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70749,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70749,31.81,NULL,23,26143,NULL,NULL,'Dipole + Quadrupole','NGC 3245A',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70750,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70750,31.82,0.4,23.1,26143,75,NULL,'B','NGC 3245A',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70751,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70751,32.05,0.82,25.7,26143,NULL,NULL,'Malmquist cor.','NGC 3245A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70752,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70752,32.08,0.43,26,26143,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3245A',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70753,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70753,32.14,0.43,26.8,26143,75,NULL,'3.6 micron, color corrected','NGC 3245A',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70754,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70754,32.18,0.2,27.3,26143,74.4,NULL,NULL,'NGC 3245A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70755,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70755,32.2,0.49,27.6,26143,75,NULL,'IR','NGC 3245A',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70756,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70756,32.5,0.66,31.6,26143,NULL,NULL,NULL,'NGC 3245A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70757,'Tully est','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70757,30.96,0.8,15.6,26144,75,NULL,NULL,'UGCA 211',NULL,'1988NBGC.C....0000T',1988,1,0.56,NULL,'G',0.000017,NULL,'16.2g',0.34,'Pec','X-ray-faint group member',NULL,NULL,NULL,1,156.75825,56.27056,0,NULL,61898982638,967171603,15112056,16.2),(70758,'IRAS','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70758,33.08,0.8,41.4,26145,75,NULL,'MAT, I','ESO 375- G 026',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.00002,NULL,'14.52',0.4,'Sbc: sp        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,156.760375,-36.22817,0.257,NULL,41985559484,656024366,10250380,14.52),(70759,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70759,32.89,0.43,37.8,26145,75,NULL,'3.6 micron, color + selection bias corrected','ESO 375- G 026',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70760,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70760,32.96,0.4,39.1,26145,NULL,NULL,NULL,'ESO 375- G 026',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70761,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70761,33.02,0.43,40.1,26145,75,NULL,'3.6 micron, color corrected','ESO 375- G 026',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70762,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70762,33.02,0.32,40.1,26145,85,NULL,'I, raw','ESO 375- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70763,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70763,33.05,0.32,40.7,26145,85,NULL,'I, inv','ESO 375- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70764,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70764,33.15,0.47,42.7,26145,NULL,NULL,'H','ESO 375- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70765,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70765,33.16,0.43,42.8,26145,75,NULL,'MAT, I, raw','ESO 375- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70766,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70766,33.18,0.2,43.3,26145,74.4,NULL,NULL,'ESO 375- G 026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70767,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,'R',70767,33.19,0.49,43.5,26145,75,NULL,'IR','ESO 375- G 026',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70768,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70768,33.2,NULL,43.7,26145,NULL,NULL,'I','ESO 375- G 026',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70769,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70769,33.22,0.45,44.1,26145,NULL,NULL,'K','ESO 375- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70770,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70770,33.24,0.4,44.5,26145,NULL,NULL,'mean','ESO 375- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70771,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70771,33.26,0.46,44.8,26145,NULL,NULL,'J','ESO 375- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70772,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70772,33.25,0.14,44.8,26145,NULL,NULL,NULL,'ESO 375- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70773,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70773,33.34,0.43,46.5,26145,75,NULL,'MAT, I, inv','ESO 375- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70774,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70774,33.42,0.43,48.3,26145,75,NULL,'MAT, I, cor','ESO 375- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70775,'Tully-Fisher','2016-12-15 15:14:37','2016-12-16 11:19:45','1',NULL,NULL,70775,33.53,NULL,50.8,26145,NULL,NULL,'B','ESO 375- G 026',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70776,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70776,37.14,0.46,267,26146,70,NULL,NULL,'2MASX J10270287+3225256',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000167,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,156.761833333,32.42369,0.041,NULL,64082002829,1001281294,15645020,17.1),(70777,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70777,36.07,0.46,164,26147,70,NULL,NULL,'2MASX J10270351+0732319',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,156.7645417,7.54219,0.045,NULL,61043214094,953800220,14903128,16.9),(70778,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70778,37.41,0.46,304,26148,70,NULL,NULL,'SDSS J102703.61+004159.4',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000087,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,156.7650417,0.69986,0.121,NULL,60734324268,948973816,14827715,17.2),(70779,'SNIa','2016-12-15 15:14:38','2016-12-16 11:19:45','1','SN 2004L',NULL,70779,35.13,0.17,103,26149,74.2,NULL,'SALT 2','CGCG 094-058',0.032309,'2010ApJ...716..712A',2010,1,0.75,NULL,'G',0.000087,NULL,'15.2',0.75,'S','Group member',NULL,NULL,NULL,1,156.7664583,16.01794,0.089,NULL,60968245069,952628829,14884825,15.2),(70780,'SNIa','2016-12-15 15:14:38','2016-12-16 11:19:45','1','SN 2004L',NULL,70780,35.73,0.16,135,26149,70,NULL,'SALT 2','CGCG 094-058',0.032309,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70781,'SNIa','2016-12-15 15:14:38','2016-12-16 11:19:45','1','SN 2004L',NULL,70781,35.69,0.09,137,26149,74.4,NULL,NULL,'CGCG 094-058',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70782,'SNIa','2016-12-15 15:14:38','2016-12-16 11:19:45','1','SN 2004L',NULL,70782,35.85,0.03,143,26149,72,NULL,'MLCS31','CGCG 094-058',0.032309,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70783,'SNIa','2016-12-15 15:14:38','2016-12-16 11:19:45','1','SN 2004L',NULL,70783,35.9,0.2,147,26149,65,NULL,'MLCS31','CGCG 094-058',0.032309,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70784,'SNIa','2016-12-15 15:14:38','2016-12-16 11:19:45','1','SN 2004L',NULL,70784,35.99,0.2,153,26149,65,NULL,'SALT2','CGCG 094-058',0.032309,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70785,'SNIa','2016-12-15 15:14:38','2016-12-16 11:19:45','1','SN 2004L',NULL,70785,36.06,0.17,158,26149,65,NULL,'MLCS17','CGCG 094-058',0.032309,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70786,'SNIa','2016-12-15 15:14:38','2016-12-16 11:19:45','1','SN 2004L',NULL,70786,36.07,0.17,159,26149,65,NULL,'SALT','CGCG 094-058',0.032309,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70787,'SNIa','2016-12-15 15:14:38','2016-12-16 11:19:45','1','SN 2004L',NULL,70787,37.3,0.05,280,26149,70,NULL,'SALT 2','CGCG 094-058',0.032309,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70788,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70788,37.69,0.46,344,26150,70,NULL,NULL,'2MASX J10270487+0121339',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,156.770333,1.35939,0.085,NULL,60737299116,949020298,14828442,17.6),(70789,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70789,35.82,0.27,146,26151,70,NULL,NULL,'CGCG 094-059',NULL,'2015arXiv151105856S',2015,1,1.48,NULL,'G',0.0001,NULL,'15.4',0.52,NULL,'Group member',NULL,NULL,NULL,1,156.771083333,16.07156,0.089,NULL,60968245967,952628843,14884825,15.4),(70790,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70790,35.68,0.19,136,26152,70,NULL,NULL,'IC 0612',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000033,NULL,'15.2g',0.43,'S              AGN','Group member',NULL,NULL,NULL,1,156.774417,11.05489,0.029,NULL,61039692535,953745195,14902268,15.2),(70791,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70791,35.69,0.25,137,26152,74.4,NULL,NULL,'IC 0612',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70792,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70792,35.67,0.25,136,26153,74.4,NULL,NULL,'IC 0613',NULL,'2013AJ....146...86T',2013,1,0.86,NULL,'G',0.000014,NULL,'14.5g',0.8,'BrClG','Group member',NULL,NULL,NULL,1,156.7824583,11.01072,0.029,NULL,61039705549,953745399,14902271,14.5),(70793,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70793,35.68,0.19,136,26153,70,NULL,NULL,'IC 0613',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70794,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70794,37.83,0.23,369,26154,70,NULL,NULL,'SDSS J102709.04+375420.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00015,NULL,'18.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,156.7877083,37.90575,0,NULL,64114246154,1001785096,15652892,18.6),(70795,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70795,38.11,0.46,420,26155,70,NULL,NULL,'2MASX J10270940+1425540',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,156.789167,14.43169,0.129,NULL,60953016085,952390876,14881107,18.1),(70796,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70796,34.97,0.46,98.5,26156,70,NULL,NULL,'2MASX J10271019+4252100',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000073,NULL,'15.2g',0.43,'S0',NULL,NULL,NULL,NULL,1,156.792417,42.86936,0,NULL,64155959338,1002436864,15663076,15.2),(70797,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70797,35.68,0.19,136,26157,70,NULL,NULL,'2MASX J10271056+1101163',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000014,NULL,'16.3g',0.27,'E',NULL,NULL,NULL,NULL,1,156.794125,11.02119,0.029,NULL,61039705880,953745404,14902271,16.3),(70798,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70798,35.85,0.46,148,26158,70,NULL,NULL,'CGCG 065-037',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000051,NULL,'15.1g',0.58,NULL,NULL,NULL,NULL,NULL,1,156.7960417,10.02461,0.077,NULL,61037017459,953703397,14901615,15.1),(70799,'SNIa','2016-12-15 15:14:38','2016-12-16 11:19:45','1','SN 2008at',NULL,70799,35.79,0.26,139,26159,73.8,NULL,'SALT 2 (SNANA)','UGC 05645',0.0354,'2014ApJ...795...44R',2014,1,1.2,NULL,'G',0.000163,NULL,'16.0',0.4,'SB(s)b',NULL,NULL,NULL,NULL,1,156.797375,71.41789,0.117,NULL,62101427762,970334808,15161481,16),(70800,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70800,37.65,0.15,339,26160,70,NULL,NULL,'2MASX J10271314+0352128',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,156.804875,3.87031,0.049,NULL,60740266009,949066656,14829166,17.3),(70801,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70801,36.67,0.46,215,26161,70,NULL,NULL,'2MASX J10271378+2124190',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000171,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,156.8074583,21.40522,0.017,NULL,60947608602,952306384,14879787,16.4),(70802,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70802,38.42,0.46,484,26162,70,NULL,NULL,'SDSS J102713.85+092300.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,156.8077083,9.38356,0.073,NULL,61051143142,953924111,14905064,18.4),(70803,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70803,35.46,0.46,124,26163,70,NULL,NULL,'CGCG 094-064',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000097,NULL,'15.3',0.7,NULL,NULL,NULL,NULL,NULL,1,156.809333,18.08292,0.041,NULL,60962511127,952539236,14883425,15.3),(70804,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70804,35.82,0.27,146,26164,70,NULL,NULL,'CGCG 094-062',NULL,'2015arXiv151105856S',2015,1,1.4,NULL,'G',0.000173,NULL,'15.1',1,'E','Group member',NULL,NULL,NULL,1,156.811417,16.04919,0.089,NULL,60968251811,952628934,14884827,15.1),(70805,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70805,38.25,0.46,447,26165,70,NULL,NULL,'2MASX J10271536+2114210',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000131,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,156.813833,21.23917,0.017,NULL,60947586125,952306033,14879781,18.4),(70806,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70806,36.64,0.46,212,26166,70,NULL,NULL,'2MASX J10271614+1803540',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00016,NULL,'16.0g',0.39,NULL,NULL,NULL,NULL,NULL,1,156.8172083,18.06511,0.049,NULL,60962511534,952539242,14883425,16),(70807,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70807,37.91,0.33,382,26167,70,NULL,NULL,'2MASX J10271613+0204379',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,156.817333,2.07714,0.085,NULL,60735561784,948993152,14828018,17.1),(70808,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70808,37.26,0.46,283,26168,70,NULL,NULL,'2MASX J10271629+4049000',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000168,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,156.81775,40.81661,0,NULL,64151053918,1002360217,15661878,17.8),(70809,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70809,36.03,0.46,161,26169,70,NULL,NULL,'CGCG 094-063',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',NULL,NULL,'15.6',0.4,NULL,NULL,NULL,NULL,NULL,1,156.823791667,16.46728,0.145,NULL,60968033205,952625518,14884773,15.6),(70810,'SBF','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70810,31.6,0.2,20.9,26170,NULL,NULL,'I','NGC 3245',NULL,'2001ApJ...546..681T',2001,1,2.85,NULL,'G',0.000017,NULL,'11.9g',1.13,'SA(r)0^0^:?;HIILINER','Possible field galaxy',NULL,NULL,NULL,1,156.826625,28.50744,0.049,NULL,64028523664,1000445682,15631963,11.9),(70811,'SBF','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70811,31.64,0.14,21.3,26170,74.4,NULL,NULL,'NGC 3245',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70812,'Faber-Jackson','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70812,29.93,0.81,9.68,26170,55,NULL,'Visvanathan & Sandage 1979','NGC 3245',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70813,'Faber-Jackson','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70813,30.54,0.63,12.8,26170,95,NULL,'Michard 1979b, c','NGC 3245',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70814,'Faber-Jackson','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70814,30.62,0.3,13.3,26170,95,NULL,'Weighted Mean','NGC 3245',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70815,'Faber-Jackson','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70815,30.92,0.46,15.3,26170,95,NULL,'Michard 1979a','NGC 3245',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70816,'Faber-Jackson','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70816,31.65,0.54,21.4,26170,95,NULL,'de Vaucouleurs','NGC 3245',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70817,'Tertiary','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70817,31.68,0.41,21.7,26170,95,NULL,NULL,'NGC 3245',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70818,'Tully est','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70818,31.73,0.8,22.2,26170,75,NULL,'B','NGC 3245',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70819,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70819,31.87,0.45,23.6,26170,NULL,NULL,'K','NGC 3245',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70820,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70820,32.19,0.4,27.4,26170,NULL,NULL,'mean','NGC 3245',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70821,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70821,37.41,0.46,303,26171,70,NULL,NULL,'2MASX J10271959+0236209',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,156.83175,2.60597,0.057,NULL,60734809573,948981399,14827834,16.8),(70822,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70822,37.51,0.46,318,26172,70,NULL,NULL,'2MASX J10272066+4120120',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000177,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,156.835917,41.33661,0,NULL,64149010619,1002328290,15661379,17.2),(70823,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70823,35.49,0.46,125,26173,70,NULL,NULL,'2MASX J10272070+1831520',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',NULL,NULL,'16.19',0.33,NULL,NULL,NULL,NULL,NULL,1,156.836167,18.531,0.029,NULL,60995320541,953051883,14891435,16.19),(70824,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70824,37.31,0.46,290,26174,70,NULL,NULL,'2MASX J10272096+1405580',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000178,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,156.8372917,14.09953,0.109,NULL,60953358293,952396223,14881190,16.6),(70825,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70825,37.06,0.46,258,26175,70,NULL,NULL,'2MASX J10272152+1020163',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000181,NULL,'16.1g',0.44,NULL,NULL,NULL,NULL,NULL,1,156.839833,10.33794,0.077,NULL,61037056049,953704000,14901625,16.1),(70826,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70826,35.85,0.36,148,26176,NULL,NULL,'Malmquist cor.','IC 0615',NULL,'2009ApJS..182..474S',2009,1,1.28,NULL,'G',0.000016,NULL,'15.0g',0.42,'S','Group member',NULL,NULL,NULL,1,156.841583,11.07997,0.029,NULL,61039699562,953745305,14902270,15),(70827,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70827,35.9,0.49,152,26176,75,NULL,'IR','IC 0615',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70828,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70828,35.91,0.4,152,26176,NULL,NULL,'mean','IC 0615',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70829,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70829,35.97,0.47,157,26176,NULL,NULL,'H','IC 0615',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70830,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70830,36.02,0.45,160,26176,NULL,NULL,'K','IC 0615',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70831,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70831,36.14,0.46,169,26176,NULL,NULL,'J','IC 0615',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70832,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70832,36.23,0.31,176,26176,NULL,NULL,NULL,'IC 0615',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70833,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70833,36.27,0.2,179,26176,74.4,NULL,NULL,'IC 0615',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70834,'IRAS','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70834,32.92,0.8,38.4,26177,75,NULL,'MAT, I','IC 2578',NULL,'1997ApJS..109..333W',1997,1,1.5,'6dF DR1 has z = 0.013056; 1997AJ....113...22G has V = 3899 km/s.','G',0.000033,NULL,'14.94',0.3,'Sc: sp         HII',NULL,NULL,NULL,NULL,1,156.8445417,-33.87733,0.289,NULL,42008274307,656379286,10255926,14.94),(70835,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70835,32.55,0.32,32.3,26177,85,NULL,'I, raw','IC 2578',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70836,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70836,32.55,0.32,32.3,26177,85,NULL,'I, inv','IC 2578',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70837,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70837,32.73,0.43,35.2,26177,75,NULL,'MAT, I, raw','IC 2578',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70838,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70838,32.8,0.43,36.4,26177,75,NULL,'MAT, I, inv','IC 2578',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70839,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70839,33.05,0.43,40.8,26177,75,NULL,'MAT, I, cor','IC 2578',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70840,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70840,33.38,0.47,47.4,26177,NULL,NULL,'H','IC 2578',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70841,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70841,33.48,0.45,49.6,26177,NULL,NULL,'K','IC 2578',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70842,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70842,33.68,0.46,54.4,26177,NULL,NULL,'J','IC 2578',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70843,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70843,33.68,0.4,54.5,26177,NULL,NULL,'mean','IC 2578',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70844,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70844,33.83,0.49,58.4,26177,75,NULL,'IR','IC 2578',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70845,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70845,33.91,0.14,60.7,26177,NULL,NULL,NULL,'IC 2578',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70846,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70846,33.93,0.2,61.1,26177,74.4,NULL,NULL,'IC 2578',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70847,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70847,37.44,0.46,307,26178,70,NULL,NULL,'2MASX J10272355+0903023',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,156.8482917,9.0505,0.069,NULL,61051109977,953923593,14905056,17.2),(70848,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70848,37.11,0.46,265,26179,70,NULL,NULL,'2MASX J10272363+3737220',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,156.8485417,37.62269,0,NULL,64042963304,1000671301,15635489,17.2),(70849,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70849,37.07,0.46,259,26180,70,NULL,NULL,'2MASX J10272554+3715170',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000207,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,156.856375,37.25461,0,NULL,64043711190,1000682987,15635671,16.3),(70850,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70850,37.69,0.46,345,26181,70,NULL,NULL,'2MASX J10272574+3131176',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000165,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,156.8572917,31.52156,0.041,NULL,64084762865,1001324419,15645694,16.8),(70851,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70851,37.24,0.46,281,26182,70,NULL,NULL,'SDSS J102726.45+411405.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,156.86025,41.23475,0,NULL,64149000786,1002328137,15661377,17.7),(70852,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70852,37.83,0.23,369,26183,70,NULL,NULL,'2MASX J10272654+3752370',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000169,NULL,'16.8g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,156.860583333,37.87706,0,NULL,64114259177,1001785299,15652895,16.8),(70853,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70853,36.1,0.46,166,26184,70,NULL,NULL,'2MASX J10272681+5350120',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000158,NULL,'16.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,156.8617083,53.8365,0,NULL,61894510503,967101726,15110964,16.8),(70854,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70854,37.83,0.46,367,26185,70,NULL,NULL,'2MASX J10272683+0331440',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,156.861833,3.52908,0.053,NULL,60739934941,949061483,14829085,17.7),(70855,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70855,36.54,0.46,203,26186,70,NULL,NULL,'CGCG 037-040',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000083,NULL,'15.4g',0.52,'S0',NULL,NULL,NULL,NULL,1,156.867541667,2.91267,0.061,NULL,60748212465,949190819,14831106,15.4),(70856,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70856,38.27,0.46,452,26187,70,NULL,NULL,'2MASX J10272863+4916580',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000187,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,156.869333,49.28292,0,NULL,64123776242,1001934003,15655218,17.2),(70857,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70857,38.07,0.46,411,26188,70,NULL,NULL,'2MASX J10272969+1050003',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,156.8737083,10.83344,0.029,NULL,61039528850,953742638,14902228,17.7),(70858,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70858,37.81,0.33,365,26189,70,NULL,NULL,'2MASX J10272973+3009476',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000138,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,156.874,30.16331,0.061,NULL,64026370911,1000412045,15631438,17.3),(70859,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70859,38.12,0.33,420,26190,70,NULL,NULL,'2MASX J10272979+4358219',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000159,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,156.8742917,43.97281,0,NULL,64154407252,1002412613,15662697,17.5),(70860,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70860,35.84,0.54,147,26191,70,NULL,NULL,'CGCG 009-051',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000127,NULL,'16.44',0.4,NULL,NULL,NULL,NULL,NULL,1,156.8795,-1.32486,0.141,NULL,41208469082,643882329,10060661,16.44),(70861,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70861,35.99,0.27,157,26192,70,NULL,NULL,'2MASX J10273135+2145550',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,156.8807083,21.76525,0.017,NULL,60948412222,952318940,14879983,17.2),(70862,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70862,37.61,0.27,333,26193,70,NULL,NULL,'2MASX J10273171+0339500',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000199,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,156.882125,3.66394,0.053,NULL,60739892682,949060823,14829075,17.1),(70863,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70863,38.28,0.23,452,26194,70,NULL,NULL,'2MASX J10273239+1035262',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,156.885125,10.59078,0.041,NULL,61038815369,953731490,14902054,18.4),(70864,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70864,37.34,0.46,294,26195,70,NULL,NULL,'2MASX J10273327+4421551',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000139,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,156.888666667,44.36539,0,NULL,64145720535,1002276883,15660576,17.5),(70865,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70865,38.28,0.23,452,26196,70,NULL,NULL,'2MASX J10273349+1034335',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000177,NULL,'16.7g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,156.8895,10.57603,0.041,NULL,61038815763,953731496,14902054,16.7),(70866,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70866,35.67,0.56,136,26197,70,NULL,NULL,'CGCG 009-050',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00011,NULL,'15.90',0.4,NULL,NULL,NULL,NULL,NULL,1,156.890667,-3.68603,0.073,NULL,41214412126,643975189,10062112,15.9),(70867,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70867,38.1,0.33,417,26198,70,NULL,NULL,'SDSS J102734.87+062633.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00011,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,156.8952917,6.44272,0.037,NULL,61039808139,953747002,14902296,17.8),(70868,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70868,38.5,0.46,502,26199,70,NULL,NULL,'2MASX J10273521+2258200',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,156.896875,22.97214,0,NULL,60949237642,952331838,14880184,18.1),(70869,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70869,36.75,0.55,224,26200,70,NULL,NULL,'2MASX J10273544-0303184',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.000077,NULL,'15.7g',0.44,NULL,NULL,NULL,NULL,NULL,1,156.8977083,-3.05522,0.049,NULL,41214287450,643973241,10062081,15.7),(70870,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70870,38.2,0.46,436,26201,70,NULL,NULL,'SDSS J102736.30+060929.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000129,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,156.90125,6.15828,0.033,NULL,61056504529,954007883,14906373,18.5),(70871,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70871,37.14,0.46,267,26202,70,NULL,NULL,'2MASX J10273710+5954200',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000157,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,156.90425,59.90544,0,NULL,61948377812,967943403,15124115,16.6),(70872,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70872,37.76,0.46,356,26203,70,NULL,NULL,'2MASX J10273739+5906340',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000192,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,156.90575,59.10942,0,NULL,61949244323,967956942,15124327,17.4),(70873,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70873,36.94,0.46,244,26204,70,NULL,NULL,'2MASX J10273773+2734399',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000202,NULL,'17.06',0.25,NULL,NULL,NULL,NULL,NULL,1,156.90725,27.57772,0.033,NULL,60475435867,944928685,14764510,17.06),(70874,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70874,38.11,0.21,419,26205,70,NULL,NULL,'2MASX J10273878+3748551',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,156.911833,37.81522,0,NULL,64114256535,1001785258,15652894,17.7),(70875,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70875,38.24,0.46,444,26206,70,NULL,NULL,'2MASX J10273896+4159280',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,156.9122917,41.99119,0,NULL,64155796841,1002434325,15663036,17.5),(70876,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70876,35.83,0.79,146,26207,70,NULL,NULL,'2MASX J10273899-1902566',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.43',0.3,'E',NULL,NULL,NULL,NULL,1,156.912583333,-19.049,0.201,NULL,41665287395,651020115,10172189,16.43),(70877,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70877,38.28,0.23,452,26208,70,NULL,NULL,'2MASX J10274169+1035246',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000141,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,156.9235417,10.59008,0.041,NULL,61038820703,953731573,14902055,18.2),(70878,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70878,37.53,0.33,320,26209,70,NULL,NULL,'2MASX J10274208+1118286',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000189,NULL,'16.3g',0.32,'S',NULL,NULL,NULL,NULL,1,156.925333333,11.30786,0.021,NULL,61039086870,953735732,14902120,16.3),(70879,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70879,37.83,0.23,369,26210,70,NULL,NULL,'2MASX J10274225+3754051',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000147,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,156.925958333,37.90153,0,NULL,64114223874,1001784748,15652886,17.5),(70880,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70880,33.12,0.43,42,26211,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3250C',NULL,'2014MNRAS.444..527S',2014,1,1.8,NULL,'G',0.000133,NULL,'14.24',0.5,'(R\':)SAB(s)a',NULL,NULL,NULL,NULL,1,156.9269583,-40.00258,0.469,NULL,42135364786,658365074,10286954,14.24),(70881,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70881,35.68,0.19,136,26212,70,NULL,NULL,'2MASX J10274264+1049276',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000025,NULL,'16.5g',0.35,'E',NULL,NULL,NULL,NULL,1,156.927583,10.82433,0.029,NULL,61038823746,953731621,14902056,16.5),(70882,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70882,35.75,0.25,141,26212,74.4,NULL,NULL,'2MASX J10274264+1049276',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70883,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70883,37.83,0.23,369,26213,70,NULL,NULL,'2MASX J10274309+3747241',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000135,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,156.929667,37.78986,0,NULL,64114256830,1001785262,15652894,17.7),(70884,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70884,37.81,0.33,365,26214,70,NULL,NULL,'2MASX J10274313+3004069',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.81',0.13,NULL,NULL,NULL,NULL,NULL,1,156.9297917,30.06881,0.057,NULL,64026338571,1000411540,15631430,18.81),(70885,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70885,36.42,0.46,192,26215,70,NULL,NULL,'2MASX J10274333+0354390',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,156.930458333,3.91094,0.053,NULL,61011995150,953312424,14895506,16.9),(70886,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70886,38.16,0.46,429,26216,70,NULL,NULL,'2MASX J10274340+0341060',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000171,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,156.931,3.68492,0.053,NULL,61011540118,953305314,14895395,17.3),(70887,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70887,37.47,0.46,312,26217,70,NULL,NULL,'2MASX J10274390+6611405',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000083,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,156.933,66.19467,0.069,NULL,62122424252,970662878,15166607,16.6),(70888,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70888,38.1,0.33,417,26218,70,NULL,NULL,'SDSS J102743.95+062722.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000103,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,156.933167,6.45617,0.037,NULL,61056633221,954009894,14906404,18.2),(70889,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70889,34.79,0.38,90.9,26219,NULL,NULL,'Malmquist cor.','UGC 05670',NULL,'2009ApJS..182..474S',2009,1,0.84,NULL,'G',0.000103,NULL,'16.1g',0.18,'Sbc',NULL,NULL,NULL,NULL,1,156.933583333,27.14353,0.029,NULL,60475450346,944928911,14764514,16.1),(70890,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70890,34.87,0.36,94.3,26219,NULL,NULL,NULL,'UGC 05670',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70891,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70891,34.92,0.2,96.4,26219,74.4,NULL,NULL,'UGC 05670',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70892,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70892,34.94,NULL,97.3,26219,NULL,NULL,'Dipole + Quadrupole','UGC 05670',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70893,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70893,34.94,NULL,97.3,26219,NULL,NULL,'Dipole','UGC 05670',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70894,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70894,34.94,NULL,97.3,26219,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05670',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70895,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70895,38.02,0.46,402,26220,70,NULL,NULL,'2MASX J10274765+0219387',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,156.9485,2.32756,0.053,NULL,60734740341,948980317,14827817,18),(70896,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70896,37.36,0.46,296,26221,70,NULL,NULL,'2MASX J10274910+1659542',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,156.954583,16.99833,0.065,NULL,60964651831,952572684,14883948,17),(70897,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70897,37.21,0.77,277,26222,70,NULL,NULL,'2MASX J10274944-1446589',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.56',0.3,NULL,NULL,NULL,NULL,NULL,1,156.955833,-14.78314,0.281,NULL,41643928179,650686377,10166974,16.56),(70898,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70898,38.35,0.46,468,26223,70,NULL,NULL,'SDSS J102749.49+031408.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000145,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,156.9562083,3.23556,0.057,NULL,60739841996,949060031,14829062,18.6),(70899,'BCG','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70899,38.11,0.35,393,26224,60,NULL,'ABELL 1020, BCG','MCG +02-27-017',0.065,'1980ApJ...241..486H',1980,1,0.52,NULL,'G',0.00017,NULL,'15.7g',0.48,'BrClG;E','Brightest group member',NULL,NULL,NULL,1,156.9562083,10.44169,0.053,NULL,61037053252,953703957,14901624,15.7),(70900,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70900,36.79,0.46,228,26224,70,NULL,NULL,'MCG +02-27-017',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70901,'BCG','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70901,38.11,0.35,393,26225,60,NULL,NULL,'ABELL 1020',0.065,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III:[BM]',NULL,NULL,NULL,NULL,1,156.961167,10.41111,0.053,NULL,61037067476,953704179,14901627,NULL),(70902,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70902,35.72,0.33,139,26226,NULL,NULL,'Malmquist cor.','ESO 375- G 031',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.35',0.4,'S...',NULL,NULL,NULL,NULL,1,156.963833,-33.12775,0.245,NULL,41999806395,656246974,10253858,15.35),(70903,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70903,35.9,0.3,152,26226,NULL,NULL,NULL,'ESO 375- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70904,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70904,35.94,0.2,154,26226,74.4,NULL,NULL,'ESO 375- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70905,'Tully est','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70905,32.86,0.8,37.4,26227,75,NULL,'B','NGC 3256',NULL,'1988NBGC.C....0000T',1988,1,3.8,'Confused HIPASS source','G',0.000019,NULL,'12.15',2.1,'Pec;merger;HII Sbrst','in an interacting pair',NULL,NULL,'H_alpha Emission-Line Galaxy',1,156.963625,-43.90375,0.545,NULL,42142111965,658470499,10288601,12.15),(70906,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70906,38.28,0.23,452,26228,70,NULL,NULL,'2MASX J10275295+1037576',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000194,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,156.970417,10.63264,0.041,NULL,61038812061,953731438,14902053,16.8),(70907,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70907,37.53,0.33,320,26229,70,NULL,NULL,'SDSS J102753.62+111840.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,156.973417,11.31119,0.029,NULL,61039098378,953735912,14902123,17.8),(70908,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70908,38.37,0.33,473,26230,70,NULL,NULL,'SDSS J102754.24+431703.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000139,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,156.976,43.28422,0,NULL,64155425048,1002428516,15662945,18.3),(70909,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70909,37.04,0.46,256,26231,70,NULL,NULL,'2MASX J10275481+1211112',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000178,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,156.978417,12.18633,0.049,NULL,61170043649,955781932,14934092,16.4),(70910,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70910,38.16,0.46,429,26232,70,NULL,NULL,'2MASX J10275534+6203450',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00014,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,156.9805,62.06258,0,NULL,61943939245,967874050,15123032,18),(70911,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70911,38.12,0.33,420,26233,70,NULL,NULL,'2MASXi J1027557+435752',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000169,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,156.9822917,43.96439,0,NULL,64154922931,1002420670,15662822,18.1),(70912,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70912,35.68,0.19,136,26234,70,NULL,NULL,'2MASX J10275602+1114446',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000103,NULL,'15.3g',0.4,'S0',NULL,NULL,NULL,NULL,1,156.983375,11.24575,0.029,NULL,61039601538,953743774,14902246,15.3),(70913,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70913,38.37,0.33,473,26235,70,NULL,NULL,'2MASX J10275728+4319052',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000214,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,156.9885,43.31831,0,NULL,64154316376,1002411193,15662674,16.3),(70914,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70914,38.04,0.46,405,26236,70,NULL,NULL,'2MASX J10275832+0246567',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.0g',0.23,'BrClG',NULL,NULL,NULL,NULL,1,156.992917,2.78244,0.069,NULL,60734627721,948978558,14827789,17),(70915,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70915,38.08,0.46,412,26237,70,NULL,NULL,'2MASX J10275883+2619270',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,156.995083,26.32411,0,NULL,60479515379,944992427,14765506,17.5),(70916,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70916,37.77,0.46,358,26238,70,NULL,NULL,'2MASX J10275906+2409520',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,156.996,24.16447,0.021,NULL,60471435464,944866179,14763534,17.7),(70917,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70917,37.55,0.46,324,26239,70,NULL,NULL,'2MASX J10275920+0841176',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000188,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,156.99675,8.68822,0.041,NULL,61042537730,953789652,14902963,16.9),(70918,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70918,37.64,0.46,338,26240,70,NULL,NULL,'2MASX J10275987+1719001',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,156.999333,17.31678,0.053,NULL,60962703152,952542236,14883472,16.6),(70919,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70919,36.6,0.46,209,26241,70,NULL,NULL,'2MASX J10280074+6108300',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000172,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,157.003125,61.14164,0.009,NULL,61942818758,967856543,15122758,16.7),(70920,'IRAS','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70920,34.36,0.8,74.6,26242,75,NULL,'MAT, I','ESO 317- G 032',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.52',0.5,'(R\')SAB:(r)b',NULL,NULL,NULL,NULL,1,157.0067917,-42.11072,0.481,NULL,42143784506,658496632,10289009,14.52),(70921,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70921,34.15,0.43,67.5,26242,75,NULL,'MAT, I, raw','ESO 317- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70922,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70922,34.19,0.32,69,26242,85,NULL,'I, raw','ESO 317- G 032',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70923,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70923,34.26,0.32,71.1,26242,85,NULL,'I, inv','ESO 317- G 032',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70924,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70924,34.32,0.47,73.1,26242,NULL,NULL,'H','ESO 317- G 032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70925,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70925,34.35,0.43,74,26242,75,NULL,'MAT, I, cor','ESO 317- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70926,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70926,34.36,0.46,74.6,26242,NULL,NULL,'J','ESO 317- G 032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70927,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70927,34.39,0.4,75.5,26242,NULL,NULL,'mean','ESO 317- G 032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70928,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70928,34.4,0.45,75.9,26242,NULL,NULL,'K','ESO 317- G 032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70929,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70929,34.41,0.33,76.1,26242,NULL,NULL,'Malmquist cor.','ESO 317- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70930,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70930,34.43,0.43,76.8,26242,75,NULL,'MAT, I, inv','ESO 317- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70931,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70931,34.65,0.29,85,26242,NULL,NULL,NULL,'ESO 317- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70932,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70932,34.69,0.2,86.7,26242,74.4,NULL,NULL,'ESO 317- G 032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70933,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70933,38.45,0.46,489,26243,70,NULL,NULL,'2MASX J10280251+0403317',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000181,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,157.010417,4.05892,0.061,NULL,61012036849,953313075,14895516,17.4),(70934,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70934,37.35,0.46,295,26244,70,NULL,NULL,'2MASX J10280281+4639032',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000181,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,157.011917,46.65086,0,NULL,64128058896,1002000920,15656264,16.8),(70935,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70935,37.36,0.46,297,26245,70,NULL,NULL,'SDSS J102804.47+400903.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,157.018625,40.15089,0,NULL,64151479619,1002366869,15661982,18),(70936,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70936,38.61,0.46,526,26246,70,NULL,NULL,'2MASX J10280451+2333417',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,157.018708333,23.56172,0,NULL,60944358998,952255609,14878993,17.7),(70937,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70937,36.48,0.46,198,26247,70,NULL,NULL,'2MASX J10280480+4655042',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000147,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,157.0202917,46.91792,0,NULL,64135632073,1002119251,15658113,17),(70938,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70938,36.94,0.7,244,26248,70,NULL,NULL,'LCRS B102533.4-032902',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'15.32',0.35,NULL,NULL,NULL,NULL,NULL,1,157.023208333,-3.73956,0.065,NULL,41748077192,652313706,10192401,15.32),(70939,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70939,35.99,0.27,157,26249,70,NULL,NULL,'2MASX J10280722+2149577',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.63',0.21,NULL,NULL,NULL,NULL,NULL,1,157.030125,21.83261,0.017,NULL,60948364352,952318193,14879971,17.63),(70940,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70940,37.19,0.46,274,26250,70,NULL,NULL,'2MASX J10280809+1630194',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,157.033875,16.50544,0.145,NULL,60968022159,952625346,14884771,17),(70941,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70941,37.79,0.46,361,26251,70,NULL,NULL,'2MASX J10280890+5834209',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000183,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,157.037083,58.57247,0,NULL,61946381862,967912216,15123628,17.5),(70942,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70942,37.65,0.15,339,26252,70,NULL,NULL,'SDSS J102809.52+034652.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000163,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,157.0397083,3.78131,0.053,NULL,61012253495,953316460,14895569,18.5),(70943,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70943,38.05,0.46,408,26253,70,NULL,NULL,'2MASX J10280964+4339391',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000163,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,157.0402083,43.66078,0,NULL,64154323841,1002411310,15662676,17.1),(70944,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70944,38.11,0.21,419,26254,70,NULL,NULL,'2MASX J10280986+3753277',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000123,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,157.0409583,37.89094,0,NULL,64115085764,1001798215,15653097,17.4),(70945,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70945,35.02,0.49,101,26255,75,NULL,'IR','FGC 1073',NULL,'2011yCatp016004901K',2011,1,0.95,NULL,'G',0.000034,NULL,'16.5g',0.17,'Sd',NULL,NULL,NULL,NULL,1,157.0417083,9.01233,0.069,NULL,61042401280,953787520,14902930,16.5),(70946,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70946,35.3,0.2,115,26255,74.4,NULL,NULL,'FGC 1073',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70947,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70947,35.76,NULL,142,26255,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1073',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70948,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70948,35.77,NULL,143,26255,NULL,NULL,'Dipole + Quadrupole','FGC 1073',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70949,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70949,35.81,NULL,145,26255,NULL,NULL,'Dipole','FGC 1073',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70950,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70950,35.96,NULL,155,26255,NULL,NULL,NULL,'FGC 1073',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70951,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70951,37.8,0.46,363,26256,70,NULL,NULL,'2MASX J10281041+1409284',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.3g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,157.0435,14.15786,0.117,NULL,60953402741,952396917,14881201,17.3),(70952,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70952,37.75,0.46,356,26257,70,NULL,NULL,'2MASX J10281056+2925279',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000142,NULL,'17.3g',0.27,'Sc',NULL,NULL,NULL,NULL,1,157.044125,29.42447,0.041,NULL,64029854005,1000466468,15632288,17.3),(70953,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70953,38.17,0.46,430,26258,70,NULL,NULL,'SDSS J102810.90+061028.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,157.045417,6.17458,0.013,NULL,61056720547,954011258,14906425,18.3),(70954,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70954,38.03,0.46,403,26259,70,NULL,NULL,'2MASX J10281151+3856247',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000204,NULL,'16.9g',0.23,'BrClG',NULL,NULL,NULL,NULL,1,157.047917,38.94036,0,NULL,64148097961,1002314030,15661156,16.9),(70955,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70955,37.14,0.46,267,26260,70,NULL,NULL,'2MASX J10281168+0524547',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000196,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,157.048667,5.41511,0.017,NULL,61011357340,953302458,14895350,16.5),(70956,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70956,38.01,0.46,400,26261,70,NULL,NULL,'2MASX J10281332+0851514',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,157.055417,8.86425,0.065,NULL,61042445865,953788216,14902940,17.6),(70957,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70957,36.55,0.27,204,26262,70,NULL,NULL,'2MASX J10281487+2253489',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000168,NULL,'16.64',0.18,NULL,NULL,NULL,NULL,NULL,1,157.062,22.89681,0,NULL,60944586560,952259165,14879049,16.64),(70958,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70958,37.72,0.46,350,26263,70,NULL,NULL,'2MASX J10281632-0028143',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000073,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,157.067958333,-0.47061,0.117,NULL,41205838884,643841232,10060019,18),(70959,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70959,35.82,0.2,146,26264,74.4,NULL,NULL,'SDSS J102817.04+105717.3',NULL,'2013AJ....146...86T',2013,1,0.52,NULL,'G',0.000055,NULL,'17.0g',0.17,'S',NULL,NULL,NULL,NULL,1,157.0710417,10.95447,0.029,NULL,61038755592,953730556,14902039,17),(70960,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70960,37.03,0.46,255,26265,70,NULL,NULL,'2MASX J10281769+6056560',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000169,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,157.0739583,60.949,0.005,NULL,61942840688,967856885,15122763,16.6),(70961,'Tully est','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70961,33.08,0.8,41.4,26266,75,NULL,'B','IC 2580',NULL,'1988NBGC.C....0000T',1988,1,1.9,'ESO-LV has two entries for this object.','G',0.000007,NULL,'13.2',1.7,'SAB(rs)c','Pair member (points to parent)',NULL,NULL,NULL,1,157.074917,-31.51803,0.213,NULL,42001746410,656277287,10254332,13.2),(70962,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70962,36.37,0.46,188,26267,70,NULL,NULL,'2MASX J10281800+2928458',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000181,NULL,'16.1g',0.38,'E',NULL,NULL,NULL,NULL,1,157.074833333,29.47933,0.041,NULL,64029853382,1000466459,15632288,16.1),(70963,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70963,36.48,0.46,198,26268,70,NULL,NULL,'2MASX J10281846+0400264',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'16.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,157.077,4.00725,0.061,NULL,61012012436,953312694,14895510,16.3),(70964,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70964,37.03,0.46,254,26269,70,NULL,NULL,'2MASX J10281877+4315588',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,157.078291667,43.26631,0,NULL,64155419802,1002428434,15662944,16.7),(70965,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70965,36.55,0.27,204,26270,70,NULL,NULL,'2MASX J10282008+2250539',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000231,NULL,'16.0g',0.43,NULL,NULL,NULL,NULL,NULL,1,157.083667,22.84828,0,NULL,60944603024,952259422,14879053,16),(70966,'Brightest Stars','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70966,28.98,NULL,6.25,26271,NULL,NULL,NULL,'UGC 05672',NULL,'1999AstL...25..322S',1999,1,2.06,NULL,'G',0.000033,NULL,'14.3g',0.56,'S?',NULL,NULL,NULL,NULL,1,157.0877917,22.56975,0,NULL,60945873594,952279274,14879363,14.3),(70967,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70967,30.28,NULL,11.4,26271,NULL,NULL,NULL,'UGC 05672',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70968,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70968,30.38,0.49,11.9,26271,75,NULL,'IR','UGC 05672',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70969,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70969,38.42,0.46,482,26272,70,NULL,NULL,'SDSS J102821.86+650353.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000076,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,157.091125,65.06494,0.009,NULL,62124805854,970700091,15167188,18.6),(70970,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70970,37.55,0.46,323,26273,70,NULL,NULL,'2MASX J10282200+4334318',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.80',0.2,NULL,NULL,NULL,NULL,NULL,1,157.091791667,43.57558,0,NULL,64154802665,1002418791,15662793,17.8),(70971,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70971,36.13,0.33,168,26274,70,NULL,NULL,'2MASX J10282318-0113283',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000086,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,157.0964583,-1.22444,0.141,NULL,41205412368,643834568,10059915,16.5),(70972,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70972,37.65,0.15,339,26275,70,NULL,NULL,'CGCG 037-042 NED01',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00006,NULL,'16.71',0.46,'BrClG',NULL,NULL,NULL,NULL,1,157.097833,3.75875,0.053,NULL,61011578880,953305920,14895405,16.71),(70973,'Brightest Stars','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70973,27.72,NULL,3.5,26276,NULL,NULL,'3V','IC 2574',NULL,'1991A&AS...89....1T',1991,1,13.2,NULL,'G',0.000007,NULL,'10.80',5.4,'SAB(s)m        HII','Probable group member',NULL,NULL,NULL,1,157.097833,68.41214,0.061,NULL,62141551997,970961749,15171277,10.8),(70974,'CMD','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70974,27.98,NULL,3.94,26276,NULL,NULL,NULL,'IC 2574',NULL,'2012ApJ...748...47M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70975,'TRGB','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70975,27.89,0.03,3.79,26276,NULL,NULL,'I','IC 2574',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70976,'TRGB','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70976,27.89,0.03,3.79,26276,NULL,NULL,'I','IC 2574',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70977,'TRGB','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70977,27.93,0.03,3.86,26276,NULL,NULL,'I','IC 2574',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70978,'TRGB','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70978,27.95,0.08,3.89,26276,74.4,NULL,NULL,'IC 2574',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70979,'TRGB','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70979,27.96,0.03,3.91,26276,NULL,NULL,'I','IC 2574',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70980,'TRGB','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70980,28.02,0.22,4.02,26276,NULL,NULL,'I','IC 2574',NULL,'2003A&A...398..479K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70981,'HII region diameter','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70981,26.81,0.15,2.3,26276,NULL,NULL,'Method 1','IC 2574',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70982,'HII region diameter','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70982,26.81,0.13,2.3,26276,NULL,NULL,'Method 2','IC 2574',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70983,'IRAS','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70983,28.65,0.8,5.37,26276,75,NULL,'A82, H','IC 2574',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70984,'Magnitude','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70984,26.76,0.11,2.25,26276,NULL,NULL,NULL,'IC 2574',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70985,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70985,27,NULL,2.51,26276,NULL,NULL,'LEDA [April 2006]','IC 2574',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70986,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70986,27.16,0.4,2.7,26276,75,NULL,'B','IC 2574',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70987,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70987,27.3,NULL,2.88,26276,NULL,NULL,'IR','IC 2574',NULL,'1980ApJ...237..655A',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70988,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70988,27.61,0.47,3.32,26276,75,NULL,'A82, H, inv','IC 2574',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70989,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70989,27.72,0.4,3.5,26276,NULL,NULL,'Virgo cluster at 15.6 Mpc','IC 2574',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70990,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70990,27.82,0.35,3.66,26276,NULL,NULL,NULL,'IC 2574',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70991,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70991,27.91,0.47,3.81,26276,75,NULL,'A82, H, raw','IC 2574',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70992,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70992,28.28,0.47,4.52,26276,75,NULL,'A82, H, cor','IC 2574',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70993,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70993,36.43,0.46,194,26277,70,NULL,NULL,'2MASX J10282372+4131037',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000164,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,157.098791667,41.51781,0,NULL,64153517732,1002398714,15662479,16.6),(70994,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70994,38.11,0.21,419,26278,70,NULL,NULL,'2MASX J10282380+3751547',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,157.0992917,37.86514,0,NULL,64115105642,1001798525,15653101,17.7),(70995,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,70995,34.09,0.77,65.6,26279,70,NULL,NULL,'ESO 375- G 034',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.0001,NULL,'15.10',0.4,'E','Group member',NULL,NULL,NULL,1,157.099875,-35.52967,0.257,NULL,41987559583,656055618,10250869,15.1),(70996,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70996,35.46,0.46,124,26280,70,NULL,NULL,'CGCG 290-042',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000159,NULL,'15.2g',0.41,'S0',NULL,NULL,NULL,NULL,1,157.100625,59.76414,0,NULL,61948391481,967943616,15124119,15.2),(70997,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70997,38.4,0.19,479,26281,70,NULL,NULL,'2MASX J10282427+0944024',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'17.3g',0.24,'BrClG',NULL,NULL,NULL,NULL,1,157.10125,9.73408,0.073,NULL,61051208635,953925134,14905080,17.3),(70998,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70998,38.4,0.19,479,26282,70,NULL,NULL,'SDSS J102825.18+093517.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000156,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,157.104917,9.58831,0.069,NULL,61051219442,953925303,14905082,18.3),(70999,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',70999,37.65,0.15,339,26283,70,NULL,NULL,'2MASX J10282615+0344484',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000211,NULL,'17.1g',0.25,'>3sigma from GB pos.',NULL,NULL,NULL,NULL,1,157.108833,3.74667,0.053,NULL,61011562590,953305665,14895401,17.1),(71000,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71000,38.4,0.19,479,26284,70,NULL,NULL,'2MASX J10282609+0937204',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000174,NULL,'16.9g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,157.108917,9.62219,0.069,NULL,61051217262,953925269,14905082,16.9),(71001,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71001,38.11,0.21,419,26285,70,NULL,NULL,'2MASX J10282667+3753006',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000171,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,157.111333333,37.88347,0,NULL,64115104874,1001798513,15653101,18.1),(71002,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71002,38.51,0.27,502,26286,70,NULL,NULL,'2MASX J10282767+1022374',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,157.1152917,10.37694,0.053,NULL,61036874291,953701160,14901580,17.4),(71003,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71003,37.37,0.46,297,26287,70,NULL,NULL,'2MASX J10282780+0454454',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000198,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,157.11575,4.91264,0.029,NULL,61010707064,953292297,14895192,16.4),(71004,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71004,36.55,0.27,204,26288,70,NULL,NULL,'2MASX J10282818+2248029',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000173,NULL,'16.1g',0.34,NULL,NULL,NULL,NULL,NULL,1,157.117625,22.80094,0,NULL,60944553296,952258645,14879041,16.1),(71005,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71005,38.04,0.46,406,26289,70,NULL,NULL,'2MASX J10282953+4528049',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000141,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,157.123083333,45.46789,0,NULL,64128024460,1002000382,15656255,18.6),(71006,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71006,37.03,0.46,254,26290,70,NULL,NULL,'2MASX J10282989+4352479',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000153,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,157.124333,43.87994,0,NULL,64154917795,1002420590,15662821,17),(71007,'Tully est','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71007,31.45,0.8,19.5,26291,75,NULL,NULL,'UGC 05675',NULL,'1988NBGC.C....0000T',1988,1,1.01,NULL,'G',0.000013,NULL,'16.3g',0.28,'Sm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,157.125,19.56239,0.029,NULL,60996734476,953073976,14891780,16.3),(71008,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71008,32.18,NULL,27.3,26291,NULL,NULL,NULL,'UGC 05675',NULL,'2015AstBu..70....1K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71009,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71009,36.2,0.46,173,26292,70,NULL,NULL,'2MASX J10283012+4904169',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000191,NULL,'16.0g',0.33,'S0',NULL,NULL,NULL,NULL,1,157.125625,49.07147,0,NULL,64123693336,1001932708,15655198,16),(71010,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71010,37.65,0.15,339,26293,70,NULL,NULL,'SDSS J102832.31+035556.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,157.134667,3.93228,0.061,NULL,61012302812,953317231,14895581,18.2),(71011,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71011,38.11,0.46,420,26294,70,NULL,NULL,'2MASX J10283357+0257524',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,157.139875,2.96453,0.073,NULL,61004066018,953188531,14893570,18.2),(71012,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71012,37.47,0.27,312,26295,70,NULL,NULL,'2MASX J10283377+4042497',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000205,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,157.140791667,40.71389,0,NULL,64149117287,1002329957,15661405,17.1),(71013,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71013,37.47,0.27,312,26296,70,NULL,NULL,'2MASX J10283694+4041357',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000178,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,157.1540417,40.69325,0,NULL,64149118926,1002329983,15661405,17.3),(71014,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71014,31.68,NULL,21.7,26297,NULL,NULL,NULL,'UGC 05677',NULL,'2000BSAO...50....5K',2000,1,1.66,'Multiple SDSS entries describe this object.','G',0.000017,NULL,'15.2',0.18,'Irr(f)',NULL,NULL,NULL,NULL,1,157.15875,3.56111,0.057,NULL,61011649231,953307019,14895422,15.2),(71015,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71015,31.7,NULL,21.9,26297,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05677',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71016,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71016,31.72,NULL,22.1,26297,NULL,NULL,'Dipole + Quadrupole','UGC 05677',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71017,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71017,31.73,NULL,22.2,26297,NULL,NULL,'Dipole','UGC 05677',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71018,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71018,37.67,0.46,343,26298,70,NULL,NULL,'2MASX J10283813+1409176',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,157.1587917,14.15478,0.117,NULL,60953407274,952396988,14881202,17.9),(71019,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71019,38.03,0.46,403,26299,70,NULL,NULL,'2MASX J10283831+5921519',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000188,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,157.159458333,59.36433,0,NULL,61948560579,967946259,15124160,16.4),(71020,'TRGB','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71020,27.92,0.06,3.8,26300,NULL,NULL,NULL,'[HKK2009] dJ1028+7014',NULL,'2013AJ....146..126C',2013,1,NULL,NULL,'G',NULL,NULL,'16.2B',NULL,'Sm;BCD',NULL,NULL,NULL,NULL,1,157.165417,70.23361,0.089,NULL,62135819429,970872178,15169877,16.2),(71021,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71021,36.13,0.33,168,26301,70,NULL,NULL,'2MASX J10283985-0108464',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000097,NULL,'16.0g',0.38,NULL,NULL,NULL,NULL,NULL,1,157.166,-1.14614,0.141,NULL,41205388207,643834190,10059909,16),(71022,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71022,37.69,0.46,345,26302,70,NULL,NULL,'2MASX J10284058+3830257',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000146,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,157.169,38.50728,0,NULL,64115030249,1001797347,15653083,17.8),(71023,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71023,38.51,0.27,502,26303,70,NULL,NULL,'2MASX J10284110+1021507',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000186,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,157.171333,10.36397,0.057,NULL,61036878872,953701232,14901581,17),(71024,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71024,37.35,0.46,294,26304,70,NULL,NULL,'2MASX J10284245+1801141',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,157.177125,18.02072,0.069,NULL,60962215770,952534621,14883353,17.2),(71025,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71025,37.22,0.46,279,26305,70,NULL,NULL,'2MASX J10284266+3717487',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000168,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,157.177791667,37.297,0,NULL,64043716968,1000683077,15635673,16.9),(71026,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71026,37.63,0.46,336,26306,70,NULL,NULL,'SDSS J102844.11+092625.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,157.183833,9.44056,0.065,NULL,61051014609,953922103,14905032,18.2),(71027,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71027,38.11,0.21,419,26307,70,NULL,NULL,'2MASX J10284509+3752377',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000077,NULL,'17.0g',0.26,'BrClG',NULL,NULL,NULL,NULL,1,157.1877917,37.87728,0,NULL,64115113668,1001798651,15653103,17),(71028,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71028,37.36,0.46,297,26308,70,NULL,NULL,'2MASX J10284636+0354088',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000177,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,157.193,3.90242,0.069,NULL,61012298867,953317169,14895580,16.6),(71029,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71029,34.87,0.53,94.2,26309,70,NULL,NULL,'2MASX J10284649-4219552',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,157.193666667,-42.33197,0.509,NULL,42144261620,658504087,10289126,16.6),(71030,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71030,36.61,0.46,209,26310,70,NULL,NULL,'2MASX J10284697+2114561',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000164,NULL,'16.1g',0.42,NULL,NULL,NULL,NULL,NULL,1,157.195667,21.249,0.017,NULL,60947437207,952303706,14879745,16.1),(71031,'SBF','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71031,32.68,0.26,34.4,26311,NULL,NULL,'I','NGC 3257',NULL,'2001ApJ...546..681T',2001,1,1,NULL,'G',0.000087,NULL,'14.11',0.9,'SAB(s)0-:','in a pair',NULL,NULL,NULL,1,157.196333,-35.65808,0.257,NULL,41987373240,656052706,10250823,14.11),(71032,'SBF','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71032,32.72,0.14,35,26311,74.4,NULL,NULL,'NGC 3257',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71033,'D-Sigma','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71033,33.15,0.4,42.6,26311,75,NULL,'Edat, raw','NGC 3257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71034,'D-Sigma','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71034,33.24,0.4,44.4,26311,75,NULL,'Edat, cor','NGC 3257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71035,'Tully est','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71035,32.87,0.8,37.5,26311,75,NULL,NULL,'NGC 3257',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71036,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71036,38.38,0.46,474,26312,70,NULL,NULL,'2MASX J10284715+0403008',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,157.1965,4.05017,0.061,NULL,61012280685,953316885,14895576,17.5),(71037,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71037,38.4,0.19,479,26313,70,NULL,NULL,'SDSS J102847.29+094326.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,157.197083,9.72408,0.069,NULL,61051008418,953922006,14905031,18.4),(71038,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71038,37.75,0.16,354,26314,70,NULL,NULL,'SDSS J102847.61+030804.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000174,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,157.198417,3.13458,0.073,NULL,61015643747,953369433,14896397,18.1),(71039,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71039,32.15,NULL,26.9,26315,NULL,NULL,NULL,'VIII Zw 081',NULL,'2015AstBu..70....1K',2015,1,0.41,NULL,'G',0.000274,NULL,'15.2',0.27,NULL,NULL,NULL,NULL,NULL,1,157.2002917,4.23475,0.061,NULL,61012122455,953314413,14895537,15.2),(71040,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71040,37.95,0.46,389,26316,70,NULL,NULL,'2MASX J10284826+4020497',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000144,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,157.201,40.34725,0,NULL,64149392918,1002334264,15661472,18.2),(71041,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71041,37.62,0.33,333,26317,70,NULL,NULL,'2MASX J10284897+1147107',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000179,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,157.204125,11.78622,0.073,NULL,61037899473,953717179,14901830,17.4),(71042,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71042,38.44,0.46,488,26318,70,NULL,NULL,'2MASX J10284942+2052291',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,157.206125,20.87483,0.021,NULL,60995729886,953058279,14891535,18.1),(71043,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71043,37.94,0.46,388,26319,70,NULL,NULL,'2MASX J10284961+2118221',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000182,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,157.206833,21.30622,0.017,NULL,60947489199,952304518,14879758,16.7),(71044,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71044,37.75,0.16,354,26320,70,NULL,NULL,'SDSS J102849.76+030617.2',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000176,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,157.207333,3.10478,0.073,NULL,61015650315,953369536,14896399,17.6),(71045,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71045,37.47,0.27,312,26321,70,NULL,NULL,'2MASX J10284995+4043287',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000158,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,157.2082083,40.72456,0,NULL,64149125444,1002330085,15661407,16.8),(71046,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71046,37.63,0.33,336,26322,70,NULL,NULL,'2MASX J10285016+3750127',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.0001,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,157.209083,37.83692,0,NULL,64115108524,1001798570,15653102,17.2),(71047,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71047,38.4,0.19,479,26323,70,NULL,NULL,'SDSS J102850.20+093450.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000142,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,157.2092083,9.58078,0.069,NULL,61051029027,953922328,14905036,18.1),(71048,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71048,36.63,0.46,212,26324,70,NULL,NULL,'2MASXi J1028512+230642',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000184,NULL,'16.9g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,157.213833,23.11183,0.029,NULL,60944808461,952262632,14879103,16.9),(71049,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71049,38.51,0.46,503,26325,70,NULL,NULL,'2MASX J10285134+1814201',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,157.213917,18.23892,0.053,NULL,60994812729,953043948,14891311,18),(71050,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71050,38.51,0.27,502,26326,70,NULL,NULL,'SDSS J102851.54+101942.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000183,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,157.2147917,10.32836,0.057,NULL,61036876024,953701187,14901581,18.2),(71051,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71051,37.59,0.46,329,26327,70,NULL,NULL,'2MASX J10285273+0027258',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000084,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,157.2195,0.45717,0.117,NULL,60733617105,948962767,14827543,17.2),(71052,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71052,38.33,0.46,464,26328,70,NULL,NULL,'SDSS J102852.91+380240.0',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.3g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,157.2205,38.04447,0,NULL,64115138612,1001799040,15653110,17.3),(71053,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71053,33.43,0.25,48.5,26329,74.4,NULL,NULL,'ESO 436- G 027',NULL,'2013AJ....146...86T',2013,1,2.3,NULL,'G',0.000067,NULL,'12.6',1.2,'(R\')SA(s)0^0^ pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,157.223083,-31.60894,0.213,NULL,42001714984,656276796,10254324,12.6),(71054,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71054,33.66,0.45,53.9,26329,NULL,NULL,'K','ESO 436- G 027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71055,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71055,33.97,0.4,62.2,26329,NULL,NULL,'mean','ESO 436- G 027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71056,'GCLF','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71056,32.42,0.19,30.5,26330,NULL,NULL,NULL,'NGC 3258',NULL,'2008MNRAS.386.1145B',2008,1,2.9,NULL,'G',0.000093,NULL,'12.49',2.5,'E1','in a pair',NULL,NULL,NULL,1,157.2232083,-35.60553,0.257,NULL,41987585863,656056029,10250875,12.49),(71057,'SBF','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71057,32.53,0.27,32.1,26330,NULL,NULL,'I','NGC 3258',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71058,'SBF','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71058,32.53,0.27,32.1,26330,NULL,NULL,NULL,'NGC 3258',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71059,'SBF','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71059,32.56,0.14,32.5,26330,74.4,NULL,NULL,'NGC 3258',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71060,'SBF','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71060,32.71,0.27,34.8,26330,NULL,NULL,'Malmquist cor.','NGC 3258',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71061,'SBF','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71061,33,0.15,39.8,26330,NULL,NULL,NULL,'NGC 3258',NULL,'2005ApJ...634..239C',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71062,'D-Sigma','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71062,33.15,0.4,42.6,26330,75,NULL,'Edat, raw','NGC 3258',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71063,'D-Sigma','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71063,33.24,0.4,44.4,26330,75,NULL,'Edat, cor','NGC 3258',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71064,'Dwarf Galaxy Diameter','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71064,32.84,0.72,37,26330,NULL,NULL,'Antlia cluster, bias corr.','NGC 3258',NULL,'2011MNRAS.414.3699M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71065,'Dwarf Galaxy Diameter','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71065,32.88,0.55,37.6,26330,NULL,NULL,'Antlia cluster','NGC 3258',NULL,'2011MNRAS.414.3699M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71066,'Faber-Jackson','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71066,31.58,0.63,20.7,26330,95,NULL,'Michard 1979b, c','NGC 3258',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71067,'Faber-Jackson','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71067,32.16,0.37,27,26330,95,NULL,'Weighted Mean','NGC 3258',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71068,'Faber-Jackson','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71068,32.3,0.46,28.8,26330,95,NULL,'Michard 1979a','NGC 3258',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71069,'Faber-Jackson','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71069,34.85,0.81,93.3,26330,55,NULL,'Visvanathan & Sandage 1979','NGC 3258',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71070,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71070,33.73,0.41,55.8,26330,NULL,NULL,NULL,'NGC 3258',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71071,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71071,33.88,0.41,59.6,26330,NULL,NULL,'Malmquist cor.','NGC 3258',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71072,'Tertiary','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71072,32.17,0.71,27.2,26330,95,NULL,NULL,'NGC 3258',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71073,'Tully est','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71073,32.87,0.8,37.5,26330,75,NULL,'B','NGC 3258',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71074,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71074,32.79,NULL,36.1,26330,77,NULL,'BRIK, Antlia cluster, 11 galaxies','NGC 3258',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71075,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71075,32.79,0.27,36.1,26330,77,NULL,'Antlia cluster, 11 galaxies','NGC 3258',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71076,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71076,32.82,0.1,36.6,26330,75,NULL,'Antlia cluster, avg. of 11 spiral galaxies','NGC 3258',NULL,'2013ApJ...765...94S',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71077,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71077,32.84,0.1,37,26330,75,NULL,'Antlia cluster, avg. of 11 spiral galaxies','NGC 3258',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71078,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71078,32.85,0.1,37.2,26330,75,NULL,'Antlia CLUSTER','NGC 3258',NULL,'2012ApJ...749...78T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71079,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71079,32.89,0.12,37.9,26330,74.4,NULL,'Antlia CLUSTER, 16 galaxies, WISE I-band','NGC 3258',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71080,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71080,32.94,0.11,38.8,26330,74.4,NULL,'Antlia CLUSTER, 16 galaxies, WISE W2 (4.6 micro-meter), color corrected','NGC 3258',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71081,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71081,32.96,0.11,39,26330,74.4,NULL,'Antlia CLUSTER, 16 galaxies, WISE W1 (3.4 micro-meter), color corrected','NGC 3258',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71082,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71082,32.97,0.07,39.3,26330,74.4,NULL,'Antlia CLUSTER, 16 galaxies, WISE W2 (4.6 micro-meter), curved','NGC 3258',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71083,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71083,33,0.07,39.8,26330,74.4,NULL,'Antlia CLUSTER, 16 galaxies, WISE W1 (3.4 micro-meter), curved','NGC 3258',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71084,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71084,33.03,0.4,40.4,26330,NULL,NULL,'mean','NGC 3258',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71085,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71085,33.08,0.15,41.3,26330,70,NULL,'Antlia Cluster','NGC 3258',NULL,'1992ApJ...396..453H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71086,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71086,33.27,NULL,45.1,26330,71,NULL,'ABELL S0636, Antlia Cluster, 100 galaxies','NGC 3258',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71087,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71087,33.3,0.3,45.6,26330,NULL,NULL,'ABELL S0636, Antlia Cluster, 16 galaxies','NGC 3258',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71088,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71088,33.65,0.45,53.8,26330,NULL,NULL,'K','NGC 3258',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71089,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71089,37.62,0.33,333,26331,70,NULL,NULL,'2MASX J10285367+1146477',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00015,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,157.2235,11.78,0.073,NULL,61037898933,953717170,14901830,17.2),(71090,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71090,37.63,0.33,336,26332,70,NULL,NULL,'2MASX J10285473+3756107',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,157.228041667,37.93644,0,NULL,64115100668,1001798447,15653100,17.1),(71091,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71091,35.58,0.2,131,26333,74.4,NULL,NULL,'CGCG 065-045',NULL,'2013AJ....146...86T',2013,1,0.47,NULL,'G',0.000013,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,157.229416667,12.58,0.073,NULL,61173552054,955836750,14934949,16.2),(71092,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71092,38.29,0.46,454,26334,70,NULL,NULL,'SDSS J102855.07+101016.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,157.2295,10.17114,0.061,NULL,61050740418,953917819,14904965,17.9),(71093,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71093,36.32,0.21,184,26335,70,NULL,NULL,'2MASX J10285560+2208081',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000175,NULL,'16.1g',0.38,NULL,NULL,NULL,NULL,NULL,1,157.231583333,22.13553,0.009,NULL,60945987912,952281061,14879391,16.1),(71094,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71094,30.34,NULL,11.7,26336,NULL,NULL,NULL,'SDSS J102855.73+095141.7',NULL,'2015AstBu..70....1K',2015,1,0.07,NULL,'G',0.000065,NULL,'19.7g',0.06,NULL,NULL,NULL,NULL,NULL,1,157.232208333,9.86161,0.073,NULL,61050890163,953920158,14905002,19.7),(71095,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71095,36.75,0.27,224,26337,70,NULL,NULL,'2MASX J10285696+0829007',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000087,NULL,'15.2g',0.59,NULL,NULL,NULL,NULL,NULL,1,157.237416667,8.48347,0.049,NULL,61042963143,953796299,14903067,15.2),(71096,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71096,37.53,0.27,321,26338,70,NULL,NULL,'2MASX J10285771+4021277',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000177,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,157.2405,40.35758,0,NULL,64149393335,1002334270,15661472,16.7),(71097,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71097,38.4,0.19,479,26339,70,NULL,NULL,'2MASX J10285843+0951007',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,157.243416667,9.85028,0.073,NULL,61050893853,953920216,14905003,17.3),(71098,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71098,37.65,0.15,339,26340,70,NULL,NULL,'2MASX J10285846+0341218',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000162,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,157.2435,3.68931,0.073,NULL,61011592788,953306137,14895408,17.2),(71099,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71099,37.2,0.46,276,26341,70,NULL,NULL,'2MASX J10285849+4342195',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000151,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,157.24375,43.70556,0,NULL,64154982670,1002421604,15662837,17.3),(71100,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71100,37.79,0.46,361,26342,70,NULL,NULL,'2MASX J10285853+3146065',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00018,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,157.2439583,31.76861,0.037,NULL,64084337811,1001317778,15645590,17.3),(71101,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71101,37.75,0.16,354,26343,70,NULL,NULL,'2MASX J10285900+0307278',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000229,NULL,'15.9g',0.41,'BrClG',NULL,NULL,NULL,NULL,1,157.2459583,3.12433,0.073,NULL,61015650959,953369546,14896399,15.9),(71102,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71102,37.75,0.16,354,26344,70,NULL,NULL,'SDSS J102859.75+030705.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000173,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,157.249,3.11814,0.073,NULL,61015650633,953369541,14896399,18.5),(71103,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71103,37.75,0.16,354,26345,70,NULL,NULL,'2MASX J10285974+0308278',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,157.249,3.141,0.073,NULL,61015653693,953369588,14896399,16.7),(71104,'Tully est','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71104,32.83,0.8,36.8,26346,75,NULL,NULL,'NGC 3250E',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.000013,NULL,'13.18',1.4,'SAB(s)cd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,157.252917,-40.08281,0.449,NULL,42135350946,658364858,10286950,13.18),(71105,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71105,33.25,0.08,44.8,26346,NULL,NULL,NULL,'NGC 3250E',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71106,'IRAS','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71106,32.67,0.8,34.3,26347,75,NULL,'HMCL, I','NGC 3256B',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000127,NULL,'13.75',0.5,'SA(s)b',NULL,NULL,NULL,NULL,1,157.2544583,-44.40289,0.633,NULL,42141404424,658459444,10288428,13.75),(71107,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71107,32.08,0.39,26.1,26347,73,NULL,'IR','NGC 3256B',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71108,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71108,32.09,0.4,26.2,26347,75,NULL,NULL,'NGC 3256B',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71109,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71109,32.35,0.49,29.6,26347,75,NULL,'IR','NGC 3256B',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71110,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71110,32.47,0.43,31.3,26347,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3256B',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71111,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71111,32.5,0.47,31.6,26347,NULL,NULL,'H','NGC 3256B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71112,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71112,32.5,0.46,31.7,26347,NULL,NULL,'J','NGC 3256B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71113,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71113,32.51,0.4,31.7,26347,75,NULL,'HMCL, I, raw','NGC 3256B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71114,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71114,32.55,0.45,32.4,26347,NULL,NULL,'K','NGC 3256B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71115,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71115,32.6,0.43,33.1,26347,75,NULL,'3.6 micron, color corrected','NGC 3256B',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71116,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71116,32.61,0.4,33.3,26347,NULL,NULL,NULL,'NGC 3256B',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71117,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71117,32.64,0.4,33.8,26347,75,NULL,'HMCL, I, inv','NGC 3256B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71118,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71118,32.78,0.4,35.9,26347,75,NULL,'HMCL, I, cor','NGC 3256B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71119,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71119,32.92,0.2,38.4,26347,74.4,NULL,NULL,'NGC 3256B',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71120,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71120,32.95,0.4,38.9,26347,NULL,NULL,'mean','NGC 3256B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71121,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71121,32.62,0.4,33.4,26348,75,NULL,'B','NGC 3261',NULL,'1988NBGC.C....0000T',1988,1,3.7,NULL,'G',0.000017,NULL,'12.00',2.8,'SB(rs)bc','Possible group member',NULL,NULL,'H_alpha Emission-Line Galaxy',1,157.256083,-44.65683,0.633,NULL,42141253865,658457091,10288392,12),(71122,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71122,37.77,0.33,357,26349,70,NULL,NULL,'2MASX J10290188+3131445',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000156,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,157.2579583,31.52897,0.041,NULL,64084526577,1001320727,15645636,17.3),(71123,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71123,36.75,0.27,224,26350,70,NULL,NULL,'2MASX J10290236+0828478',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000203,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,157.259875,8.48003,0.049,NULL,61042962906,953796295,14903067,16.5),(71124,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71124,37.77,0.33,357,26351,70,NULL,NULL,'2MASX J10290344+3129255',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,157.26425,31.49042,0.029,NULL,64084540496,1001320945,15645639,17.3),(71125,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71125,37.24,0.46,281,26352,70,NULL,NULL,'2MASX J10290367+0324368',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000196,NULL,'16.3g',0.37,'AGN',NULL,NULL,NULL,NULL,1,157.265417,3.41028,0.065,NULL,61011638245,953306847,14895419,16.3),(71126,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71126,38.62,0.46,530,26353,70,NULL,NULL,'SDSS J102903.84+392944.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000159,NULL,'18.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,157.2660417,39.49561,0,NULL,64151409019,1002365765,15661965,18.8),(71127,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71127,37.84,0.23,369,26354,70,NULL,NULL,'2MASX J10290478+3737056',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000174,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,157.270125,37.61833,0,NULL,64114539956,1001789686,15652963,17.5),(71128,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71128,36.99,0.46,250,26355,70,NULL,NULL,'2MASX J10290565+3558305',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000206,NULL,'15.9g',0.41,NULL,NULL,NULL,NULL,NULL,1,157.273625,35.97517,0,NULL,64046747357,1000730427,15636412,15.9),(71129,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71129,37.65,0.15,339,26356,70,NULL,NULL,'2MASX J10290607+0339098',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000196,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,157.2754583,3.65261,0.073,NULL,61011604907,953306326,14895411,17.1),(71130,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71130,38.27,0.46,450,26357,70,NULL,NULL,'2MASX J10290633+0825038',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,157.2765,8.41767,0.053,NULL,61042970394,953796412,14903068,18),(71131,'D-Sigma','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71131,33.15,0.4,42.6,26358,75,NULL,'Edat, raw','NGC 3260',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000107,NULL,'13.71',1,'E pec:','in a pair',NULL,NULL,NULL,1,157.276625,-35.59519,0.257,NULL,41987587300,656056051,10250875,13.71),(71132,'D-Sigma','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71132,33.24,0.4,44.4,26358,75,NULL,'Edat, cor','NGC 3260',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71133,'Tully est','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71133,32.87,0.8,37.5,26358,75,NULL,NULL,'NGC 3260',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71134,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71134,32.79,0.4,36.1,26358,NULL,NULL,'mean','NGC 3260',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71135,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71135,33.67,0.45,54.2,26358,NULL,NULL,'K','NGC 3260',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71136,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71136,31.66,NULL,21.5,26359,NULL,NULL,NULL,'AGC 749315',NULL,'2013AJ....145..101K',2013,1,NULL,NULL,'RadioS',0.000052,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,157.28375,26.90417,0.037,NULL,60479354059,944989907,14765467,NULL),(71137,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71137,37.92,0.46,383,26360,70,NULL,NULL,'2MASX J10290940+3907587',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,157.2892917,39.13308,0,NULL,64114681404,1001791896,15652998,17.9),(71138,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71138,37.75,0.16,354,26361,70,NULL,NULL,'2MASX J10290948+0310558',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,157.2897083,3.18214,0.073,NULL,61015639070,953369360,14896396,17.7),(71139,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71139,38.53,0.46,508,26362,70,NULL,NULL,'2MASX J10290973+0600248',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,157.290667,6.007,0.017,NULL,61056549419,954008584,14906384,17.5),(71140,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71140,37.02,0.46,254,26363,70,NULL,NULL,'2MASX J10291058+0822258',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,157.2939583,8.37389,0.053,NULL,61042941505,953795961,14903061,17.5),(71141,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71141,37.91,0.46,382,26364,70,NULL,NULL,'2MASX J10291278-0006387',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000088,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,157.30325,-0.11072,0.137,NULL,41204864188,643826002,10059781,17.1),(71142,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71142,37.55,0.46,324,26365,70,NULL,NULL,'2MASX J10291311+0126538',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000186,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,157.304583,1.44814,0.097,NULL,61002483165,953163799,14893184,16.7),(71143,'Tully est','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71143,32.96,0.8,39.1,26366,75,NULL,NULL,'NGC 3263',NULL,'1988NBGC.C....0000T',1988,1,5.1,'ESO declination is incorrect, but ESO-LV declination is correct.','G',0.000018,NULL,'12.5',1.4,'SB(rs)cd: sp','in an interacting pair',NULL,NULL,'H_alpha Emission-Line Galaxy',1,157.305666667,-44.12292,0.549,NULL,42142091883,658470185,10288596,12.5),(71144,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71144,38.03,0.46,403,26367,70,NULL,NULL,'SDSS J102913.55+051241.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00014,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,157.3064583,5.21144,0.029,NULL,61010680861,953291888,14895185,18.2),(71145,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71145,36.92,0.46,242,26368,70,NULL,NULL,'2MASX J10291489+0824178',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000179,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,157.312125,8.40486,0.053,NULL,61042938657,953795916,14903061,16.6),(71146,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71146,37.87,0.46,374,26369,70,NULL,NULL,'2MASX J10291515+4251405',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,157.313167,42.86122,0,NULL,64155982454,1002437225,15663081,18),(71147,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71147,33.22,0.49,44.1,26370,75,NULL,'IR','UGC 05687',NULL,'2011yCatp016004901K',2011,1,2.39,NULL,'G',0.000008,NULL,'15.0g',0.3,'Sc',NULL,NULL,NULL,NULL,1,157.3145417,6.12808,0.017,NULL,61057410644,954022041,14906594,15),(71148,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71148,33.41,0.2,48.1,26370,74.4,NULL,NULL,'UGC 05687',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71149,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71149,33.41,NULL,48.1,26370,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05687',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71150,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71150,33.42,NULL,48.2,26370,NULL,NULL,'Dipole + Quadrupole','UGC 05687',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71151,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71151,33.42,NULL,48.4,26370,NULL,NULL,'Dipole','UGC 05687',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71152,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71152,33.48,NULL,49.8,26370,NULL,NULL,NULL,'UGC 05687',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71153,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71153,33.6,0.59,52.5,26370,NULL,NULL,NULL,'UGC 05687',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71154,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71154,33.78,0.54,57,26370,NULL,NULL,'Malmquist cor.','UGC 05687',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71155,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71155,33.81,0.47,57.8,26371,NULL,NULL,'H','NGC 3251',NULL,'2007A&A...465...71T',2007,1,2.4,NULL,'G',0.00003,NULL,'13.6g',0.54,'SB?',NULL,NULL,NULL,NULL,1,157.320167,26.09925,0.033,NULL,60481718543,945026852,14766044,13.6),(71156,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71156,33.83,0.46,58.5,26371,NULL,NULL,'J','NGC 3251',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71157,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71157,33.84,0.49,58.5,26371,75,NULL,'IR','NGC 3251',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71158,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71158,33.91,0.45,60.7,26371,NULL,NULL,'K','NGC 3251',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71159,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71159,34.39,0.4,75.6,26371,NULL,NULL,'mean','NGC 3251',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71160,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71160,37.24,0.33,281,26372,70,NULL,NULL,'2MASX J10291685+4018277',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,157.320208333,40.30789,0,NULL,64149405416,1002334459,15661475,17.4),(71161,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71161,37.92,0.33,384,26373,70,NULL,NULL,'2MASX J10291763+2131355',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000162,NULL,'17.0g',0.31,NULL,NULL,NULL,NULL,NULL,1,157.323667,21.5265,0.013,NULL,60945562528,952274414,14879287,17),(71162,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71162,37.75,0.16,354,26374,70,NULL,NULL,'2MASX J10291820+0305168',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000196,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,157.325916667,3.08808,0.073,NULL,61015618407,953369037,14896391,16.6),(71163,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71163,37.79,0.46,362,26375,70,NULL,NULL,'SDSS J102918.25+005826.3',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000135,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,157.326083333,0.974,0.121,NULL,60733943478,948967866,14827622,17.8),(71164,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71164,36.32,0.21,184,26376,70,NULL,NULL,'2MASX J10291932+2216035',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000163,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,157.330667,22.26756,0,NULL,60946063777,952282246,14879410,17),(71165,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71165,39.08,0.46,655,26377,70,NULL,NULL,'SDSS J102919.88+273900.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.5g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,157.332875,27.65008,0.041,NULL,60475335951,944927124,14764486,18.5),(71166,'IRAS','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71166,31.96,0.8,24.7,26378,75,NULL,'A82, H','NGC 3254',NULL,'1997ApJS..109..333W',1997,1,5.1,NULL,'G',0.000003,NULL,'12.9g',0.9,'SA(s)bc        Sy2','Possible field galaxy',NULL,NULL,'Sy 2',1,157.333083,29.49183,0.041,NULL,64026891866,1000420185,15631565,12.9),(71167,'Sosies','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71167,32.89,0.14,37.8,26378,NULL,NULL,NULL,'NGC 3254',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71168,'Tully est','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71168,31.87,0.8,23.6,26378,75,NULL,'B','NGC 3254',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71169,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71169,32.08,0.51,26,26378,NULL,NULL,'Malmquist cor.','NGC 3254',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71170,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71170,32.09,0.38,26.2,26378,NULL,NULL,NULL,'NGC 3254',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71171,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71171,32.16,0.4,27.1,26378,NULL,NULL,'mean','NGC 3254',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71172,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71172,32.44,0.2,30.8,26378,74.4,NULL,NULL,'NGC 3254',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71173,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71173,32.47,0.43,31.2,26378,NULL,NULL,NULL,'NGC 3254',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71174,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71174,32.64,0.43,33.7,26378,75,NULL,'3.6 micron, color corrected','NGC 3254',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71175,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71175,32.74,0.47,35.3,26378,75,NULL,'A82, H, raw','NGC 3254',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71176,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71176,32.75,0.47,35.6,26378,75,NULL,'A82, H, cor','NGC 3254',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71177,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71177,32.81,0.46,36.5,26378,NULL,NULL,'J','NGC 3254',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71178,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71178,32.86,0.47,37.3,26378,NULL,NULL,'H','NGC 3254',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71179,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71179,32.87,0.43,37.6,26378,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3254',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71180,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71180,32.92,0.45,38.3,26378,NULL,NULL,'K','NGC 3254',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71181,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71181,32.92,0.47,38.4,26378,75,NULL,'A82, H, inv','NGC 3254',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71182,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71182,38.36,0.46,470,26379,70,NULL,NULL,'2MASX J10292019+2732307',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,157.3339583,27.54194,0.037,NULL,60475362491,944927538,14764492,17.8),(71183,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71183,35.47,0.46,124,26380,70,NULL,NULL,'2MASX J10292101+0746058',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000173,NULL,'16.1g',0.29,'S0',NULL,NULL,NULL,NULL,1,157.337458333,7.76817,0.041,NULL,61043546268,953805410,14903209,16.1),(71184,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71184,38.04,0.33,406,26381,70,NULL,NULL,'2MASX J10292115+1322350',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000167,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,157.3382917,13.37631,0.093,NULL,61173289078,955832641,14934885,18.1),(71185,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71185,36.9,0.46,239,26382,70,NULL,NULL,'2MASX J10292129+1730590',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,157.338625,17.51633,0.061,NULL,60964329515,952567648,14883869,16.6),(71186,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71186,38.21,0.46,438,26383,70,NULL,NULL,'2MASX J10292143+0159318',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000178,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,157.339375,1.99222,0.077,NULL,61004541097,953195954,14893686,17.6),(71187,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71187,38.02,0.46,402,26384,70,NULL,NULL,'2MASX J10292296+0420018',NULL,'2015arXiv151105856S',2015,1,0.21,'This galaxy lenses a z = 0.615 object.','G',0.000154,NULL,'17.8g',0.15,'S0',NULL,NULL,NULL,NULL,1,157.345583,4.33383,0.061,NULL,61012105999,953314156,14895533,17.8),(71188,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71188,37.23,0.46,279,26385,70,NULL,NULL,'2MASX J10292370+2757047',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,157.34875,27.95119,0.049,NULL,60475307239,944926675,14764479,17.6),(71189,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71189,38.39,0.46,475,26386,70,NULL,NULL,'2MASX J10292418-0026557',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000089,NULL,'17.4g',0.23,'NLAGN',NULL,NULL,NULL,'Sy 2',1,157.35075,-0.44883,0.113,NULL,41205003107,643828173,10059815,17.4),(71190,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71190,37.65,0.46,339,26387,70,NULL,NULL,'2MASX J10292443+1549420',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'16.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,157.352,15.82822,0.105,NULL,60966633909,952603654,14884432,16.4),(71191,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71191,37.46,0.46,311,26388,70,NULL,NULL,'2MASX J10292457+4121168',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,157.3525417,41.35456,0,NULL,64153469204,1002397956,15662468,17.3),(71192,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71192,37.84,0.23,369,26389,70,NULL,NULL,'2MASX J10292509+3737478',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.3g',0.19,'BrClG',NULL,NULL,NULL,NULL,1,157.354667,37.63,0,NULL,64114529439,1001789522,15652961,16.3),(71193,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71193,37.24,0.33,281,26390,70,NULL,NULL,'2MASX J10292516+4024228',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00017,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,157.3549583,40.40636,0,NULL,64149527278,1002336363,15661505,16.9),(71194,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71194,38.27,0.46,451,26391,70,NULL,NULL,'2MASX J10292613+1800285',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,157.3587917,18.00797,0.069,NULL,60962343873,952536623,14883384,17.7),(71195,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71195,37.1,0.46,263,26392,70,NULL,NULL,'2MASX J10292611+2721407',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000175,NULL,'17.56',0.2,NULL,NULL,NULL,NULL,NULL,1,157.3587917,27.36122,0.041,NULL,60474871778,944919871,14764372,17.56),(71196,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71196,37.09,0.46,262,26393,70,NULL,NULL,'2MASX J10292618+1427459',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000173,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,157.359,14.46275,0.121,NULL,60953579120,952399673,14881244,16.4),(71197,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71197,36.94,0.46,245,26394,70,NULL,NULL,'2MASX J10292623+2846546',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.85',0.22,'E',NULL,NULL,NULL,NULL,1,157.359125,28.78181,0.045,NULL,64026622171,1000415971,15631499,17.85),(71198,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71198,38.39,0.33,476,26395,70,NULL,NULL,'2MASX J10292637+3803117',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000138,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,157.359833,38.05322,0,NULL,64115144363,1001799130,15653111,17.6),(71199,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71199,37.75,0.16,354,26396,70,NULL,NULL,'2MASX J10292734+0302558',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000182,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,157.364,3.049,0.073,NULL,61015606586,953368852,14896388,17.2),(71200,'SNIa','2016-12-15 15:14:38','2016-12-16 11:19:45','1','SN 1991S',NULL,71200,36.17,0.15,162,26397,74.2,NULL,'SALT 2','UGC 05691',0.055,'2010ApJ...716..712A',2010,1,0.9,NULL,'G',0.000164,NULL,'15.3g',0.69,'Sb',NULL,NULL,NULL,NULL,1,157.364541667,22.00794,0.021,NULL,60946240938,952285014,14879453,15.3),(71201,'SNIa','2016-12-15 15:14:38','2016-12-16 11:19:45','1','SN 1991S',NULL,71201,36.84,0.09,233,26397,74.4,NULL,NULL,'UGC 05691',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71202,'SNIa','2016-12-15 15:14:38','2016-12-16 11:19:45','1','SN 1991S',NULL,71202,36.96,0.15,234,26397,70,NULL,'SALT 2','UGC 05691',0.055,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71203,'SNIa','2016-12-15 15:14:38','2016-12-16 11:19:45','1','SN 1991S',NULL,71203,36.99,0.02,237,26397,72,NULL,NULL,'UGC 05691',0.055,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71204,'SNIa','2016-12-15 15:14:38','2016-12-16 11:19:45','1','SN 1991S',NULL,71204,36.89,0.17,239,26397,70.8,NULL,NULL,'UGC 05691',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71205,'SNIa','2016-12-15 15:14:38','2016-12-16 11:19:45','1','SN 1991S',NULL,71205,37.08,0.05,247,26397,70,NULL,'SALT','UGC 05691',0.055,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71206,'SNIa','2016-12-15 15:14:38','2016-12-16 11:19:45','1','SN 1991S',NULL,71206,37.27,0.13,256,26397,65,NULL,'MLCS2k2','UGC 05691',0.055,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71207,'SNIa','2016-12-15 15:14:38','2016-12-16 11:19:45','1','SN 1991S',NULL,71207,37.07,0.21,259,26397,60,NULL,'M(B) = -19.48 mag','UGC 05691',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71208,'SNIa','2016-12-15 15:14:38','2016-12-16 11:19:45','1','SN 1991S',NULL,71208,37.07,0.16,259,26397,60,NULL,'M(V) = -19.47 mag','UGC 05691',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71209,'SNIa','2016-12-15 15:14:38','2016-12-16 11:19:45','1','SN 1991S',NULL,71209,37.12,0.15,265,26397,60,NULL,'M(I) = -19.19 mag','UGC 05691',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71210,'SNIa','2016-12-15 15:14:38','2016-12-16 11:19:45','1','SN 1991S',NULL,71210,37.31,0.18,275,26397,65,NULL,NULL,'UGC 05691',0.055,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71211,'SNIa','2016-12-15 15:14:38','2016-12-16 11:19:45','1','SN 1991S',NULL,71211,37.22,0.14,278,26397,60,NULL,NULL,'UGC 05691',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71212,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71212,37.63,0.33,336,26398,70,NULL,NULL,'2MASX J10292815+4241453',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,157.3675,42.69592,0,NULL,64156009040,1002437641,15663088,17.4),(71213,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71213,38.55,0.46,513,26399,70,NULL,NULL,'2MASX J10292933+3802557',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000185,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,157.372083,38.04881,0,NULL,64115144501,1001799132,15653111,17.4),(71214,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71214,36.32,0.21,184,26400,70,NULL,NULL,'2MASX J10292984+2214285',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000182,NULL,'15.7g',0.41,NULL,NULL,NULL,NULL,NULL,1,157.374417,22.24139,0.009,NULL,60945947480,952280429,14879381,15.7),(71215,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71215,35.38,0.48,119,26401,70,NULL,NULL,'CGCG 009-058',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00011,NULL,'14.45',0.3,'E?',NULL,NULL,NULL,NULL,1,157.3752083,-3.76022,0.045,NULL,41748876201,652326190,10192596,14.45),(71216,'Tully est','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71216,32.87,0.8,37.5,26402,75,NULL,NULL,'ESO 375- G 041',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000123,NULL,'14.57',0.3,'S0-','Group member',NULL,NULL,NULL,1,157.379167,-35.25986,0.257,NULL,41987540818,656055325,10250864,14.57),(71217,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71217,37.09,0.46,262,26403,70,NULL,NULL,'2MASX J10293131-0028217',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000072,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,157.380583,-0.47272,0.113,NULL,41205000706,643828136,10059814,17.8),(71218,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71218,37.72,0.46,349,26404,70,NULL,NULL,'SDSS J102931.44+041729.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,157.381,4.29156,0.061,NULL,61012086921,953313858,14895529,18),(71219,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71219,37.87,0.46,375,26405,70,NULL,NULL,'2MASX J10293241+2920447',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000145,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,157.385125,29.34586,0.041,NULL,64026894585,1000420227,15631566,17.3),(71220,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71220,38.39,0.33,476,26406,70,NULL,NULL,'SDSS J102933.22+380505.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000171,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,157.388458333,38.08478,0,NULL,64115146164,1001799158,15653111,18.1),(71221,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71221,37.31,0.46,289,26407,70,NULL,NULL,'SDSS J102934.31+470554.1',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000148,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,157.393,47.09839,0,NULL,64138533555,1002164586,15658821,17.7),(71222,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71222,38.38,0.46,474,26408,70,NULL,NULL,'2MASX J10293474+0037368',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000091,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,157.39475,0.62694,0.117,NULL,60733597276,948962457,14827538,18.1),(71223,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71223,38.04,0.33,406,26409,70,NULL,NULL,'2MASX J10293474+1316371',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,157.394875,13.27703,0.061,NULL,61173316856,955833075,14934891,18),(71224,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71224,38.56,0.46,514,26410,70,NULL,NULL,'2MASX J10293555+4407073',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000193,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,157.3982083,44.11864,0,NULL,64154928113,1002420751,15662824,17.9),(71225,'IRAS','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71225,33.64,0.8,53.6,26411,75,NULL,'MAT, I','ESO 501- G 001',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000017,NULL,'13.82',1.1,'SAB(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,157.404667,-24.11258,0.285,NULL,41613906424,650217287,10159645,13.82),(71226,'IRAS','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71226,33.67,0.8,54.2,26411,75,NULL,'HMCL, I','ESO 501- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71227,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71227,32.89,0.32,37.9,26411,85,NULL,'I, raw','ESO 501- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71228,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71228,32.89,0.32,37.9,26411,85,NULL,'I, inv','ESO 501- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71229,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71229,33.03,0.4,40.3,26411,75,NULL,'HMCL, I, raw','ESO 501- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71230,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71230,33.11,0.4,41.8,26411,75,NULL,'HMCL, I, inv','ESO 501- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71231,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71231,33.23,0.43,44.2,26411,75,NULL,'MAT, I, raw','ESO 501- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71232,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71232,33.29,0.43,45.6,26411,75,NULL,'MAT, I, inv','ESO 501- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71233,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71233,33.37,0.4,47.3,26411,75,NULL,'HMCL, I, cor','ESO 501- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71234,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71234,33.46,0.38,49.2,26411,NULL,NULL,NULL,'ESO 501- G 001',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71235,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71235,33.5,0.43,50.2,26411,75,NULL,'MAT, I, cor','ESO 501- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71236,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71236,33.63,0.2,53.2,26411,74.4,NULL,NULL,'ESO 501- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71237,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71237,33.72,0.43,55.5,26411,75,NULL,'3.6 micron, color corrected','ESO 501- G 001',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71238,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71238,33.83,0.13,58.5,26411,NULL,NULL,NULL,'ESO 501- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71239,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71239,33.85,0.43,58.8,26411,75,NULL,'3.6 micron, color + selection bias corrected','ESO 501- G 001',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71240,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71240,37.65,0.15,339,26412,70,NULL,NULL,'2MASX J10293734+0348578',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,157.4057083,3.81614,0.073,NULL,61012360323,953318130,14895595,17.4),(71241,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71241,36.89,0.46,238,26413,70,NULL,NULL,'B3 1026+386',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000198,NULL,'15.6g',0.49,'E0',NULL,NULL,NULL,NULL,1,157.40725,38.40614,0,NULL,64114936876,1001795888,15653060,15.6),(71242,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71242,37.65,0.15,339,26414,70,NULL,NULL,'2MASX J10293775+0347298',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,'PHOT','17.1g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,157.407417,3.79158,0.073,NULL,61012359942,953318124,14895595,17.1),(71243,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71243,37.92,0.33,384,26415,70,NULL,NULL,'SDSS J102937.94+212804.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000166,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,157.408125,21.46792,0.013,NULL,60945384416,952271631,14879244,18.2),(71244,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71244,36.76,0.46,225,26416,70,NULL,NULL,'2MASX J10293814+1959354',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00018,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,157.408875,19.99322,0.017,NULL,60996291900,953067060,14891672,16.6),(71245,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71245,38.08,0.46,414,26417,70,NULL,NULL,'2MASX J10293898+1758121',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,157.412375,17.97006,0.069,NULL,60962135982,952533374,14883333,18),(71246,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71246,36.47,0.65,196,26418,70,NULL,NULL,'2MASX J10294101-2111151',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.5b',0.3,'S0',NULL,NULL,NULL,NULL,1,157.4209583,-21.18761,0.253,NULL,41668325863,651067591,10172931,16.5),(71247,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71247,38.65,0.46,536,26419,70,NULL,NULL,'2MASX J10294115+3042060',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000174,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,157.4215,30.70172,0.049,NULL,64081273837,1001269903,15644842,17.8),(71248,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71248,37.01,0.46,252,26420,70,NULL,NULL,'SDSS J102941.62+512937.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,157.4235,51.49381,0,NULL,63991789140,999871705,15622995,17.8),(71249,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71249,37.63,0.33,336,26421,70,NULL,NULL,'2MASX J10294175+4244084',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000168,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,157.424083,42.73572,0,NULL,64155107432,1002423553,15662868,16.8),(71250,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71250,36.32,0.21,184,26422,70,NULL,NULL,'CGCG 124-031',NULL,'2015arXiv151105856S',2015,1,0.99,NULL,'G',0.000193,NULL,'14.6g',0.63,NULL,NULL,NULL,NULL,NULL,1,157.426,22.36064,0,NULL,60946060785,952282199,14879409,14.6),(71251,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71251,37.96,0.46,391,26423,70,NULL,NULL,'2MASX J10294301+1611231',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,157.42925,16.18969,0.053,NULL,60967789529,952621711,14884714,17.5),(71252,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71252,37.37,0.46,297,26424,70,NULL,NULL,'SDSS J102944.00+381510.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000101,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,157.433333,38.25278,0,NULL,64114938812,1001795918,15653061,18.2),(71253,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71253,37.16,0.46,270,26425,70,NULL,NULL,'2MASX J10294656+0332453',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000179,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,157.444,3.54594,0.077,NULL,61011498981,953304671,14895385,17.2),(71254,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71254,37.33,0.46,292,26426,70,NULL,NULL,'2MASX J10294823+2438367',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000163,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,157.450791667,24.64364,0,NULL,60471562791,944868168,14763565,16.7),(71255,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71255,35.49,0.46,125,26427,70,NULL,NULL,'2MASX J10294820+1918370',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000173,NULL,'15.7g',0.42,NULL,NULL,NULL,NULL,NULL,1,157.451,19.31033,0.033,NULL,60994929874,953045779,14891340,15.7),(71256,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71256,34.19,0.51,68.8,26428,70,NULL,NULL,'2MASX J10294837-3525077',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.0001,NULL,'15.1',0.4,'E','Group member',NULL,NULL,NULL,1,157.451625,-35.41881,0.257,NULL,41987432235,656053628,10250837,15.1),(71257,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71257,37.84,0.23,369,26429,70,NULL,NULL,'2MASX J10294916+3735088',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,157.4547083,37.58581,0,NULL,64114583268,1001790363,15652974,17.9),(71258,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71258,37.09,0.21,262,26430,70,NULL,NULL,'2MASX J10294962+0355083',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00019,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,157.45675,3.91889,0.069,NULL,61012353266,953318019,14895594,16.3),(71259,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71259,37.5,0.46,316,26431,70,NULL,NULL,'2MASX J10294995+1451521',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,157.4580417,14.86447,0.137,NULL,60953628775,952400449,14881257,17.8),(71260,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71260,37.91,0.46,382,26432,70,NULL,NULL,'2MASX J10295048+0436583',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'17.7g',0.22,'AGN',NULL,NULL,NULL,NULL,1,157.460333333,4.61608,0.049,NULL,61014141810,953345965,14896030,17.7),(71261,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71261,37.85,0.46,371,26433,70,NULL,NULL,'SDSS J102950.62+114954.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000135,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,157.460917,11.83186,0.073,NULL,61038090007,953720156,14901877,18.8),(71262,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71262,36.75,0.27,224,26434,70,NULL,NULL,'2MASX J10295114+0841325',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00019,NULL,'16.0g',0.41,'E0',NULL,NULL,NULL,NULL,1,157.46325,8.69228,0.049,NULL,61042874241,953794910,14903045,16),(71263,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71263,37.86,0.46,373,26435,70,NULL,NULL,'2MASX J10295152+1029205',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,157.464875,10.48892,0.057,NULL,61051243512,953925679,14905088,17.3),(71264,'IRAS','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71264,35.84,0.8,147,26436,75,NULL,'CF, r','UGC 05696',NULL,'1997ApJS..109..333W',1997,1,1.23,NULL,'G',0.000115,NULL,'14.4g',0.65,'Sb',NULL,NULL,NULL,NULL,1,157.465,19.83317,0.021,NULL,60996218617,953065915,14891654,14.4),(71265,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71265,35.35,0.38,117,26436,75,NULL,'CF, r, raw','UGC 05696',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71266,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71266,35.56,0.38,129,26436,75,NULL,'CF, r, inv','UGC 05696',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71267,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71267,35.56,0.38,130,26436,75,NULL,'CF, r, cor','UGC 05696',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71268,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71268,37.53,0.27,321,26437,70,NULL,NULL,'2MASX J10295297+4019598',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000204,NULL,'16.0g',0.44,'BrClG',NULL,NULL,NULL,NULL,1,157.47075,40.33328,0,NULL,64149426188,1002334784,15661481,16),(71269,'Tully est','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71269,32.87,0.8,37.5,26438,75,NULL,NULL,'2MASX J10295304-3522307',NULL,'1988NBGC.C....0000T',1988,1,2.5,NULL,'G',0.00022,NULL,'16.0',2,'d:SB01','Group member',NULL,NULL,NULL,1,157.4710417,-35.37522,0.257,NULL,41987431015,656053609,10250837,16),(71270,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71270,38.31,0.33,459,26439,70,NULL,NULL,'2MASX J10295352+3955538',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000185,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,157.473125,39.93167,0,NULL,64149473814,1002335528,15661492,16.6),(71271,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71271,37.66,0.46,340,26440,70,NULL,NULL,'2MASX J10295452+3801148',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000185,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,157.4769583,38.02078,0,NULL,64115130650,1001798916,15653108,16.8),(71272,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71272,38.05,0.46,407,26441,70,NULL,NULL,'SDSS J102955.24+002551.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000079,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,157.4802083,0.43111,0.125,NULL,61002108434,953157944,14893092,18.1),(71273,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71273,38.11,0.27,420,26442,70,NULL,NULL,'2MASX J10295605+3216260',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000178,NULL,'17.0g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,157.483625,32.27389,0.029,NULL,64082323807,1001286309,15645098,17),(71274,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71274,37.84,0.23,369,26443,70,NULL,NULL,'2MASX J10295648+3740598',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,157.485417,37.68331,0,NULL,64114576427,1001790256,15652972,17.7),(71275,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71275,37.13,0.46,267,26444,70,NULL,NULL,'2MASX J10295708+4003288',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000141,NULL,'17.8g',0.18,'LINER',NULL,NULL,NULL,'LINER',1,157.487625,40.05783,0,NULL,64149413669,1002334588,15661477,17.8),(71276,'Ring Diameter','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71276,31.2,0.84,17,26445,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3269',NULL,'1981ApJS...45..541P',1981,1,2.5,NULL,'G',0.00011,NULL,'13.23',1.1,'(R\'_2)SAB(s)a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,157.48775,-35.22439,0.257,NULL,41987424263,656053504,10250836,13.23),(71277,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71277,33.33,0.5,46.4,26445,70,NULL,NULL,'NGC 3269',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71278,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71278,38.31,0.33,459,26446,70,NULL,NULL,'SDSS J102957.87+395806.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,157.491125,39.96836,0,NULL,64149485435,1002335709,15661495,18.4),(71279,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71279,37.96,0.15,392,26447,70,NULL,NULL,'2MASX J10295794+4106118',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000087,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,157.491333333,41.10317,0,NULL,64149151046,1002330485,15661413,17.5),(71280,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71280,36.78,0.71,227,26448,70,NULL,NULL,'2MASX J10295821-1438060',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.56',NULL,NULL,NULL,NULL,NULL,NULL,1,157.4925,-14.63522,0.277,NULL,41644101367,650689083,10167016,16.56),(71281,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71281,36.89,0.46,239,26449,70,NULL,NULL,'2MASX J10295971+0528483',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000143,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,157.498875,5.48019,0.021,NULL,61011057375,953297771,14895277,16.8),(71282,'GCLF','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71282,32.81,0.2,36.5,26450,NULL,NULL,NULL,'NGC 3268',NULL,'2008MNRAS.386.1145B',2008,1,3.5,NULL,'G',0.00007,NULL,'12.5',2.5,'E2             LINER','Possible group member',NULL,NULL,NULL,1,157.50275,-35.32547,0.257,NULL,41987425591,656053524,10250836,12.5),(71283,'SBF','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71283,32.71,0.25,34.8,26450,NULL,NULL,'I','NGC 3268',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71284,'SBF','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71284,32.71,0.25,34.8,26450,NULL,NULL,NULL,'NGC 3268',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71285,'SBF','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71285,32.74,0.14,35.3,26450,74.4,NULL,NULL,'NGC 3268',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71286,'SBF','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71286,32.83,0.25,36.9,26450,NULL,NULL,'Malmquist cor.','NGC 3268',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71287,'SBF','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71287,33,0.15,39.8,26450,NULL,NULL,NULL,'NGC 3268',NULL,'2005ApJ...634..239C',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71288,'D-Sigma','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71288,33.15,0.4,42.6,26450,75,NULL,'Edat, raw','NGC 3268',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71289,'D-Sigma','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71289,33.24,0.4,44.4,26450,75,NULL,'Edat, cor','NGC 3268',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71290,'Faber-Jackson','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71290,32.32,0.37,29.1,26450,95,NULL,'Weighted Mean','NGC 3268',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71291,'Faber-Jackson','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71291,32.36,0.63,29.6,26450,95,NULL,'Michard 1979b, c','NGC 3268',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71292,'Faber-Jackson','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71292,32.75,0.46,35.5,26450,95,NULL,'Michard 1979a','NGC 3268',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71293,'Faber-Jackson','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71293,34.07,0.81,65.2,26450,55,NULL,'Visvanathan & Sandage 1979','NGC 3268',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71294,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71294,33.34,0.41,46.6,26450,NULL,NULL,NULL,'NGC 3268',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71295,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71295,33.56,0.41,51.5,26450,NULL,NULL,'Malmquist cor.','NGC 3268',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71296,'Tertiary','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71296,32.17,0.71,27.2,26450,95,NULL,NULL,'NGC 3268',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71297,'Tully est','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71297,32.87,0.8,37.5,26450,75,NULL,'B','NGC 3268',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71298,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71298,32.79,NULL,36.1,26450,77,NULL,'BRIK, Antlia cluster, 11 galaxies','NGC 3268',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71299,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71299,32.79,0.27,36.1,26450,77,NULL,'Antlia cluster, 11 galaxies','NGC 3268',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71300,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71300,32.82,0.1,36.6,26450,75,NULL,'Antlia cluster, avg. of 11 spiral galaxies','NGC 3268',NULL,'2013ApJ...765...94S',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71301,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71301,32.84,0.1,37,26450,75,NULL,'Antlia cluster, avg. of 11 spiral galaxies','NGC 3268',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71302,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71302,32.89,0.12,37.9,26450,74.4,NULL,'Antlia CLUSTER, 16 galaxies, WISE I-band','NGC 3268',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71303,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71303,32.94,0.11,38.8,26450,74.4,NULL,'Antlia CLUSTER, 16 galaxies, WISE W2 (4.6 micro-meter), color corrected','NGC 3268',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71304,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71304,32.96,0.11,39,26450,74.4,NULL,'Antlia CLUSTER, 16 galaxies, WISE W1 (3.4 micro-meter), color corrected','NGC 3268',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71305,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71305,32.97,0.07,39.3,26450,74.4,NULL,'Antlia CLUSTER, 16 galaxies, WISE W2 (4.6 micro-meter), curved','NGC 3268',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71306,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71306,33,0.07,39.8,26450,74.4,NULL,'Antlia CLUSTER, 16 galaxies, WISE W1 (3.4 micro-meter), curved','NGC 3268',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71307,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71307,33.03,0.4,40.4,26450,NULL,NULL,'mean','NGC 3268',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71308,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71308,33.08,0.15,41.3,26450,70,NULL,'Antlia Cluster','NGC 3268',NULL,'1992ApJ...396..453H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71309,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71309,33.1,0.45,41.7,26450,NULL,NULL,'K','NGC 3268',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71310,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71310,33.27,NULL,45.1,26450,71,NULL,'ABELL S0636, Antlia Cluster, 100 galaxies','NGC 3268',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71311,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71311,33.3,0.3,45.6,26450,NULL,NULL,'ABELL S0636, Antlia Cluster, 16 galaxies','NGC 3268',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71312,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71312,38.11,0.27,420,26451,70,NULL,NULL,'2MASX J10300079+3211330',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,157.503375,32.19247,0.029,NULL,64082332013,1001286437,15645100,17.4),(71313,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71313,34.74,0.25,88.7,26452,74.4,NULL,NULL,'2MASX J10300084+1108193',NULL,'2013AJ....146...86T',2013,1,0.39,NULL,'G',0.000022,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,157.503583,11.13856,0.077,NULL,61038308272,953723566,14901930,16.4),(71314,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71314,36.55,0.46,204,26453,70,NULL,NULL,'2MASX J10300090+0852033',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000125,NULL,'16.2g',0.37,'E0',NULL,NULL,NULL,NULL,1,157.503917,8.86739,0.045,NULL,61042339564,953786555,14902914,16.2),(71315,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71315,36.93,0.46,244,26454,70,NULL,NULL,'2MASX J10300102+2810594',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,157.5042083,28.18322,0.053,NULL,60475085628,944923212,14764425,17.5),(71316,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71316,37.96,0.15,392,26455,70,NULL,NULL,'SDSS J103001.49+410752.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000138,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,157.50625,41.13133,0,NULL,64149150916,1002330483,15661413,18.8),(71317,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71317,36.91,0.46,241,26456,70,NULL,NULL,'2MASX J10300223+4325114',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000209,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,157.5095,43.41972,0,NULL,64154672854,1002416763,15662761,16.3),(71318,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71318,36.02,0.6,160,26457,70,NULL,NULL,'2MASX J10300266-1459066',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.44',0.3,NULL,NULL,NULL,NULL,NULL,1,157.5110417,-14.98531,0.273,NULL,41643294251,650676472,10166819,16.44),(71319,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71319,37.68,0.46,343,26458,70,NULL,NULL,'2MASX J10300275+2102579',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,157.5114583,21.04944,0.021,NULL,60997808262,953090754,14892043,17.5),(71320,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71320,37.09,0.21,262,26459,70,NULL,NULL,'2MASX J10300325+0346313',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,157.513666667,3.77528,0.073,NULL,61012365750,953318214,14895597,17.6),(71321,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71321,38.64,0.46,535,26460,70,NULL,NULL,'2MASX J10300414+0604593',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000193,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,157.517333333,6.08317,0.021,NULL,61056935990,954014624,14906478,17.7),(71322,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71322,37.53,0.27,321,26461,70,NULL,NULL,'2MASX J10300433+4015398',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,157.518,40.26117,0,NULL,64149427900,1002334810,15661481,17.2),(71323,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71323,37.09,0.21,262,26462,70,NULL,NULL,'2MASX J10300446+0358183',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,157.5185417,3.97189,0.069,NULL,61012336049,953317750,14895589,17.1),(71324,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71324,37.39,0.11,300,26463,70,NULL,NULL,'2MASX J10300449+4003148',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000178,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,157.518583,40.05425,0,NULL,64149410505,1002334539,15661477,16.7),(71325,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71325,37.89,0.46,378,26464,70,NULL,NULL,'2MASX J10300499+0931584',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,157.520875,9.53275,0.057,NULL,61050573384,953915209,14904925,18.1),(71326,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71326,37.62,0.46,334,26465,70,NULL,NULL,'SDSS J103005.70+430723.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,157.52375,43.12306,0,NULL,64155145196,1002424143,15662877,18.1),(71327,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71327,37.96,0.15,392,26466,70,NULL,NULL,'2MASX J10300661+4108248',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.0001,NULL,'16.9g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,157.5275417,41.14011,0,NULL,64149149179,1002330455,15661413,16.9),(71328,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71328,38.11,0.27,420,26467,70,NULL,NULL,'SDSS J103006.79+321425.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000155,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,157.5282917,32.24042,0.029,NULL,64082330037,1001286406,15645100,18.5),(71329,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71329,38.28,0.46,452,26468,70,NULL,NULL,'2MASX J10300755+3758488',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,157.5314583,37.98039,0,NULL,64114475144,1001788674,15652948,17.6),(71330,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71330,35.77,0.46,142,26469,70,NULL,NULL,'2MASX J10300790+2702134',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000167,NULL,'16.0g',0.39,NULL,NULL,NULL,NULL,NULL,1,157.533,27.03711,0.041,NULL,60474831401,944919240,14764363,16),(71331,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71331,37.96,0.15,392,26470,70,NULL,NULL,'SDSS J103009.45+410838.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,157.539375,41.14411,0,NULL,64149149061,1002330454,15661413,18.6),(71332,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71332,34.72,NULL,87.8,26471,NULL,NULL,'Dipole','UGC 05698',NULL,'2010Ap&SS.325..163P',2010,1,1.37,NULL,'G',0.00003,NULL,'15.7g',0.28,'Sc',NULL,NULL,NULL,NULL,1,157.540041667,44.12242,0,NULL,64154144352,1002408505,15662632,15.7),(71333,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71333,34.72,NULL,88,26471,NULL,NULL,'Dipole + Quadrupole','UGC 05698',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71334,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71334,34.73,NULL,88.3,26471,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05698',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71335,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71335,35.44,0.49,122,26471,75,NULL,'IR','UGC 05698',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71336,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71336,35.72,0.2,139,26471,74.4,NULL,NULL,'UGC 05698',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71337,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71337,38.04,0.46,405,26472,70,NULL,NULL,'2MASX J10300985+5911503',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,157.5410417,59.19725,0,NULL,61949749587,967964837,15124450,18),(71338,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71338,38.13,0.46,423,26473,70,NULL,NULL,'2MASX J10301010+2448054',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000153,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,157.542125,24.80161,0,NULL,60472246114,944878845,14763731,17.2),(71339,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71339,38.01,0.46,401,26474,70,NULL,NULL,'2MASX J10301052+0253414',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000148,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,157.543833333,2.89492,0.077,NULL,61004248242,953191378,14893615,17.3),(71340,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71340,36.8,0.46,229,26475,70,NULL,NULL,'2MASX J10301214+3640018',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000166,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,157.5505,36.66714,0,NULL,64043485134,1000679455,15635616,16.2),(71341,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71341,38.26,0.33,449,26476,70,NULL,NULL,'2MASX J10301220+2546034',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,157.550833,25.76756,0.025,NULL,60481246634,945019478,14765929,17.8),(71342,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71342,38.94,0.46,614,26477,70,NULL,NULL,'SDSS J103014.63+470702.7',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000138,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,157.561,47.11742,0,NULL,64138752790,1002168012,15658875,18.2),(71343,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71343,36.45,NULL,195,26478,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05704',NULL,'2010Ap&SS.325..163P',2010,1,1.29,NULL,'G',0.000015,NULL,'16.0g',0.17,'Sc',NULL,NULL,NULL,NULL,1,157.575833,22.73033,0,NULL,60946494983,952288984,14879515,16),(71344,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71344,36.45,NULL,195,26478,NULL,NULL,'Dipole + Quadrupole','UGC 05704',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71345,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71345,36.47,NULL,197,26478,NULL,NULL,'Dipole','UGC 05704',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71346,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71346,36.54,NULL,203,26478,NULL,NULL,NULL,'UGC 05704',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71347,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71347,37.23,0.2,279,26478,74.4,NULL,NULL,'UGC 05704',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71348,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71348,36.26,0.46,178,26479,70,NULL,NULL,'2MASX J10301862+2734224',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000198,NULL,'15.8g',0.37,NULL,NULL,NULL,NULL,NULL,1,157.57775,27.57303,0.037,NULL,60474866027,944919781,14764371,15.8),(71349,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71349,36.32,0.21,184,26480,70,NULL,NULL,'2MASX J10301943+2223433',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000167,NULL,'18.19',0.15,NULL,NULL,NULL,NULL,NULL,1,157.580833,22.39536,0,NULL,60946037002,952281828,14879403,18.19),(71350,'IRAS','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71350,33.02,0.8,40.2,26481,75,NULL,'MAT, I','ESO 375- G 047',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000023,NULL,'14.52',0.4,'S pec sp       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,157.5814583,-34.40492,0.285,NULL,41987340887,656052201,10250815,14.52),(71351,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71351,32.99,0.32,39.7,26481,85,NULL,'I, raw','ESO 375- G 047',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71352,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71352,33.01,0.32,40,26481,85,NULL,'I, inv','ESO 375- G 047',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71353,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71353,33.15,0.1,42.7,26481,NULL,NULL,NULL,'ESO 375- G 047',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71354,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71354,33.23,0.43,44.3,26481,75,NULL,'MAT, I, raw','ESO 375- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71355,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71355,33.34,0.43,46.6,26481,75,NULL,'MAT, I, inv','ESO 375- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71356,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,NULL,71356,33.48,0.43,49.7,26481,75,NULL,'MAT, I, cor','ESO 375- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71357,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71357,36.08,0.46,164,26482,70,NULL,NULL,'2MASX J10302024+2113153',NULL,'2015arXiv151105856S',2015,1,0.91,NULL,'G',0.000087,NULL,'14.9g',0.6,'AGN',NULL,NULL,NULL,NULL,1,157.584333333,21.22111,0.017,NULL,60990444662,952975697,14890245,14.9),(71358,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71358,37.87,0.46,375,26483,70,NULL,NULL,'2MASX J10302125+5828073',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000172,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,157.588625,58.46853,0,NULL,61946516735,967914323,15123661,17.1),(71359,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71359,37.88,0.46,376,26484,70,NULL,NULL,'2MASX J10302240+6551547',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000075,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,157.5932083,65.86528,0.029,NULL,62116076281,970563691,15165057,17.3),(71360,'FP','2016-12-15 15:14:38','2016-12-16 11:19:45','1',NULL,'R',71360,37.89,0.46,379,26485,70,NULL,NULL,'2MASX J10302244+1012584',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,157.5935,10.21617,0.061,NULL,61051480582,953929384,14905146,17.6),(71361,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71361,38.54,0.46,510,26486,70,NULL,NULL,'SDSS J103022.73+380505.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000168,NULL,'18.6g',0.09,NULL,NULL,NULL,NULL,NULL,1,157.59475,38.08483,0,NULL,64114964557,1001796321,15653067,18.6),(71362,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71362,37.96,0.15,392,26487,70,NULL,NULL,'2MASX J10302323+4106016',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,157.597,41.10053,0,NULL,64149178947,1002330921,15661420,17.7),(71363,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71363,38.25,0.46,447,26488,70,NULL,NULL,'2MASX J10302215+6248077',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,157.59775,62.80686,0,NULL,61827836944,966059952,15094686,18.1),(71364,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71364,37.96,0.15,392,26489,70,NULL,NULL,'2MASX J10302402+4106566',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000203,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,157.6002083,41.11581,0,NULL,64149189736,1002331089,15661423,17.3),(71365,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71365,37.09,0.21,262,26490,70,NULL,NULL,'2MASX J10302443+0358325',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00019,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,157.6017917,3.97556,0.073,NULL,61012342272,953317848,14895591,16.7),(71366,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71366,37.09,0.21,262,26491,70,NULL,NULL,'2MASX J10302456+0359315',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000187,NULL,'16.1g',0.39,'E0',NULL,NULL,NULL,NULL,1,157.6024583,3.99203,0.069,NULL,61012342450,953317850,14895591,16.1),(71367,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71367,32.44,0.4,30.8,26492,75,NULL,'B','UGC 05688',NULL,'1988NBGC.C....0000T',1988,1,4,NULL,'G',0.000007,NULL,'13.8',1.9,'SBm:','Dwarf, possible member',NULL,NULL,NULL,1,157.603583,70.05022,0.089,NULL,62135969262,970874519,15169914,13.8),(71368,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71368,38.83,0.46,583,26493,70,NULL,NULL,'2MASX J10302528+2937354',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,157.6055417,29.62661,0.029,NULL,64027062923,1000422858,15631607,17.9),(71369,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71369,37.48,0.46,313,26494,70,NULL,NULL,'2MASX J10302563+4310468',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000176,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,157.606917,43.17978,0,NULL,64154660662,1002416572,15662758,16.8),(71370,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71370,37.51,0.46,318,26495,70,NULL,NULL,'2MASX J10302590+2634304',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,157.607917,26.57533,0.053,NULL,60481579820,945024684,14766010,17.4),(71371,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71371,35.96,0.46,156,26496,70,NULL,NULL,'2MASX J10302630+4946567',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000178,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,157.609541667,49.78233,0,NULL,64124289520,1001942023,15655344,16.5),(71372,'Faber-Jackson','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71372,31.88,0.44,23.8,26497,95,NULL,'Weighted Mean','NGC 3271',NULL,'1984ApJS...56...91D',1984,1,3.1,NULL,'G',0.000053,NULL,'12.86',1.8,'SAB(s)0^0;BrClG','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,157.610375,-35.3595,0.233,NULL,41987436130,656053689,10250838,12.86),(71373,'Faber-Jackson','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71373,32.07,0.63,25.9,26497,95,NULL,'Michard 1979b, c','NGC 3271',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71374,'Faber-Jackson','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71374,32.28,0.46,28.6,26497,95,NULL,'Michard 1979a','NGC 3271',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71375,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71375,32.65,0.45,33.8,26497,NULL,NULL,'K','NGC 3271',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71376,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71376,33.6,0.4,52.5,26497,NULL,NULL,'mean','NGC 3271',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71377,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71377,37.49,0.46,315,26498,70,NULL,NULL,'SDSS J103026.52+031946.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000161,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,157.6105,3.32953,0.073,NULL,61015792171,953371752,14896433,18.4),(71378,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71378,37.82,0.46,367,26499,70,NULL,NULL,'2MASX J10302652+3355057',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,157.610667,33.91828,0.037,NULL,64051230708,1000800479,15637507,17.8),(71379,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71379,38.26,0.33,449,26500,70,NULL,NULL,'2MASX J10302708+2544564',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000166,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,157.6127917,25.74914,0.025,NULL,60481251612,945019556,14765930,18.7),(71380,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71380,37.65,0.46,339,26501,70,NULL,NULL,'SDSS J103027.81+102558.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000144,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,157.615875,10.43281,0.061,NULL,61051279208,953926237,14905097,18.1),(71381,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71381,37.62,0.46,334,26502,70,NULL,NULL,'2MASX J10302867+1706403',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,157.619417,17.11128,0.057,NULL,60965098973,952579671,14884057,17.6),(71382,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71382,38,0.27,398,26503,70,NULL,NULL,'2MASX J10302884+3912276',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000175,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,157.620167,39.20767,0,NULL,64117545875,1001836654,15653697,17),(71383,'Ring Diameter','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71383,32.2,0.84,27,26504,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3273',NULL,'1981ApJS...45..541P',1981,1,1.7,NULL,'G',0.000067,NULL,'13.55',0.8,'SA(r)0^0^','in a pair',NULL,NULL,NULL,1,157.6215417,-35.61064,0.233,NULL,41987416888,656053388,10250834,13.55),(71384,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71384,33.21,0.49,43.9,26504,70,NULL,NULL,'NGC 3273',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71385,'Tully est','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71385,32.87,0.8,37.5,26504,75,NULL,NULL,'NGC 3273',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71386,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71386,38.09,0.46,415,26505,70,NULL,NULL,'2MASX J10303075+4314378',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000181,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,157.62825,43.24381,0,NULL,64154658835,1002416544,15662758,17),(71387,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71387,37.76,0.46,357,26506,70,NULL,NULL,'2MASX J10303334+1345288',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,157.638833,13.75797,0.125,NULL,61172179289,955815301,14934614,18),(71388,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71388,37.96,0.15,392,26507,70,NULL,NULL,'2MASX J10303464+4109486',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,157.64475,41.16333,0,NULL,64149186192,1002331034,15661422,17.8),(71389,'Brightest Stars','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71389,28.26,0.4,4.48,26508,NULL,NULL,'3B','UGC 05692',NULL,'1994A&AS..106..555K',1994,1,3.2,'RC3 gives v = 180 +/- 60 km/sec.','G',0.00001,NULL,'13.47',1.8,'Sm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,157.6459583,70.61867,0.069,NULL,62138165542,970908836,15170450,13.47),(71390,'CMD','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71390,28.04,NULL,4.06,26508,NULL,NULL,NULL,'UGC 05692',NULL,'2012ApJ...748...47M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71391,'TRGB','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71391,27.9,0.03,3.8,26508,NULL,NULL,'I','UGC 05692',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71392,'TRGB','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71392,27.9,0.03,3.8,26508,NULL,NULL,'I','UGC 05692',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71393,'TRGB','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71393,27.95,0.08,3.88,26508,74.4,NULL,NULL,'UGC 05692',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71394,'TRGB','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71394,28,0.02,3.98,26508,NULL,NULL,'I','UGC 05692',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71395,'TRGB','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71395,28.01,0.22,4,26508,NULL,NULL,'I','UGC 05692',NULL,'2002A&A...383..125K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71396,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71396,35.62,NULL,133,26509,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05699',NULL,'2010Ap&SS.325..163P',2010,1,0.9,NULL,'G',0.00012,NULL,'16.5g',0.17,'Sc',NULL,NULL,NULL,NULL,1,157.650958333,60.00794,0,NULL,61956678286,968073098,15126142,16.5),(71397,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71397,35.63,NULL,134,26509,NULL,NULL,'Dipole + Quadrupole','UGC 05699',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71398,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71398,35.65,NULL,135,26509,NULL,NULL,'Dipole','UGC 05699',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71399,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71399,35.66,NULL,135,26509,NULL,NULL,NULL,'UGC 05699',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71400,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71400,36.68,0.46,216,26510,70,NULL,NULL,'2MASX J10303648+1734428',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.96',0.22,NULL,NULL,NULL,NULL,NULL,1,157.652083,17.57864,0.061,NULL,60964432146,952569252,14883894,17.96),(71401,'IRAS','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71401,33.46,0.8,49.1,26511,75,NULL,'HMCL, I','ESO 501- G 002',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.00003,NULL,'15.36',0.2,'Sb:',NULL,NULL,NULL,'H_alpha Emission-Line Galaxy',1,157.660583,-27.59294,0.205,NULL,41480230961,648128608,10127009,15.36),(71402,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71402,33.79,0.4,57.3,26511,NULL,NULL,'mean','ESO 501- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71403,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71403,33.89,0.16,60.1,26511,NULL,NULL,NULL,'ESO 501- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71404,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71404,34.3,0.4,72.5,26511,75,NULL,'HMCL, I, raw','ESO 501- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71405,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71405,34.38,0.4,75.3,26511,75,NULL,'HMCL, I, cor','ESO 501- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71406,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71406,34.39,0.49,75.5,26511,75,NULL,'IR','ESO 501- G 002',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71407,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71407,34.47,0.4,78.3,26511,75,NULL,'HMCL, I, inv','ESO 501- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71408,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71408,34.56,0.47,81.7,26511,NULL,NULL,'H','ESO 501- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71409,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71409,37.57,0.46,326,26512,70,NULL,NULL,'2MASX J10303852+5455121',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,157.660417,54.92017,0,NULL,61906063121,967282236,15113784,17.5),(71410,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71410,35.01,0.33,101,26513,70,NULL,NULL,'CGCG 212-018',NULL,'2015arXiv151105856S',2015,1,0.99,NULL,'G',0.000143,NULL,'14.6g',0.63,'E0',NULL,NULL,NULL,NULL,1,157.6605,44.01272,0,NULL,64154856126,1002419626,15662806,14.6),(71411,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71411,37.72,0.46,349,26514,70,NULL,NULL,'2MASX J10303885+4233008',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000143,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,157.661791667,42.55031,0,NULL,64155207601,1002425118,15662892,17.4),(71412,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71412,37.09,0.46,262,26515,70,NULL,NULL,'SDSS J103042.49+041217.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000159,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,157.6770417,4.20486,0.073,NULL,61011740050,953308438,14895444,18.4),(71413,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71413,38,0.27,398,26516,70,NULL,NULL,'2MASX J10304406+3910286',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000172,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,157.683583333,39.17456,0,NULL,64117546512,1001836664,15653697,17.9),(71414,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71414,29.46,NULL,7.8,26517,NULL,NULL,NULL,'LV J1030+0607',NULL,'2013AJ....145..101K',2013,1,0.03,NULL,'G',0.000045,NULL,'22.0g',0.03,NULL,NULL,NULL,NULL,NULL,1,157.6845417,6.12708,0.041,NULL,61056897691,954014026,14906469,22),(71415,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71415,38,0.27,398,26518,70,NULL,NULL,'2MASX J10304476+3912436',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000204,NULL,'16.6g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,157.6865,39.21231,0,NULL,64117544408,1001836631,15653697,16.6),(71416,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71416,37.1,0.46,263,26519,70,NULL,NULL,'2MASX J10304490+0438319',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,157.687125,4.64206,0.049,NULL,61014351231,953349237,14896081,17.4),(71417,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71417,37.39,0.46,300,26520,70,NULL,NULL,'2MASX J10304518+0330579',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000203,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,157.688125,3.51603,0.073,NULL,61015773793,953371465,14896429,16.3),(71418,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71418,33,0.4,39.8,26521,75,NULL,NULL,'UGC 05689',NULL,'2008Ap.....51..336K',2008,1,1.62,'Misidentified as NGC 3252 in CGCG & UGC according to RC2. NED follows RC2.','G',0.000033,NULL,'15.43',0.22,'Sc',NULL,NULL,NULL,NULL,1,157.6912917,73.88539,0.125,NULL,61377196409,959018693,14984667,15.43),(71419,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71419,33.35,0.43,46.8,26521,75,NULL,'3.6 micron, color + selection bias corrected','UGC 05689',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71420,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71420,33.59,0.49,52.3,26521,75,NULL,'IR','UGC 05689',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71421,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71421,33.82,NULL,58.1,26521,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05689',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71422,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71422,33.83,NULL,58.3,26521,NULL,NULL,'Dipole + Quadrupole','UGC 05689',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71423,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71423,33.84,NULL,58.5,26521,NULL,NULL,'Dipole','UGC 05689',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71424,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71424,35.99,0.46,158,26522,70,NULL,NULL,'CGCG 183-027',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.000093,NULL,'15.0g',0.61,'E/S0',NULL,NULL,NULL,NULL,1,157.69375,36.95464,0,NULL,64043506261,1000679785,15635621,15),(71425,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71425,37.74,0.46,354,26523,70,NULL,NULL,'2MASX J10304723+1506118',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,157.696833,15.10319,0.137,NULL,60966465312,952601020,14884390,17.5),(71426,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71426,36.78,0.46,227,26524,70,NULL,NULL,'2MASX J10304729-0055262',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.0001,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,157.696958333,-0.92403,0.121,NULL,41742680586,652229384,10191084,16.4),(71427,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71427,37.04,0.46,256,26525,70,NULL,NULL,'2MASX J10304803-0022472',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000069,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,157.700167,-0.37983,0.137,NULL,41741932911,652217701,10190901,17.7),(71428,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71428,38.17,0.46,430,26526,70,NULL,NULL,'2MASX J10304811+3820385',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,157.7005,38.34397,0,NULL,64114924651,1001795697,15653057,17.9),(71429,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71429,38.13,0.46,423,26527,70,NULL,NULL,'2MASX J10304866+0321569',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000175,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,157.70275,3.36586,0.073,NULL,61015753224,953371144,14896424,17.9),(71430,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71430,37.68,0.46,343,26528,70,NULL,NULL,'2MASX J10304894+4545388',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000135,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,157.7040417,45.76069,0,NULL,64135275373,1002113677,15658026,17.7),(71431,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71431,37.39,0.11,300,26529,70,NULL,NULL,'2MASX J10304920+4009445',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,157.704917,40.16256,0,NULL,64149456769,1002335262,15661488,17.6),(71432,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71432,36.81,0.46,230,26530,70,NULL,NULL,'2MASX J10305058+5327097',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000152,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,157.7107083,53.45289,0,NULL,61895193754,967112402,15111131,16.8),(71433,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71433,38.45,0.46,490,26531,70,NULL,NULL,'SDSS J103051.11+264414.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,157.7129583,26.73722,0.045,NULL,60481404069,945021938,14765967,18.4),(71434,'Ring Diameter','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71434,32.6,0.84,33,26532,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3275',NULL,'1981ApJS...45..541P',1981,1,2.8,NULL,'G',0.00015,NULL,'11.8',2.1,'SB(r)a         HII','in a pair',NULL,NULL,NULL,1,157.715833,-36.73697,0.217,NULL,41988842458,656075663,10251182,11.8),(71435,'Tully est','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71435,33.14,0.8,42.4,26532,75,NULL,'B','NGC 3275',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71436,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71436,30.09,NULL,10.4,26533,NULL,NULL,NULL,'SDSS J103052.91+122647.9',NULL,'2013AJ....145..101K',2013,1,0.18,NULL,'G',0.000035,NULL,'18.6g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,157.7204583,12.44664,0.065,NULL,61171486296,955804473,14934444,18.6),(71437,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71437,37.96,0.15,392,26534,70,NULL,NULL,'2MASX J10305313+4122245',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,157.72125,41.37347,0,NULL,64153583538,1002399742,15662495,17.3),(71438,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71438,37.96,0.15,392,26535,70,NULL,NULL,'2MASX J10305361+4113165',NULL,'2015arXiv151105856S',2015,1,0.63,'May be a resolved component of 87GB[BWE91] 1027+4128.','G',0.000067,NULL,'16.1g',0.36,'BrClG          PEG',NULL,NULL,NULL,NULL,1,157.72325,41.22103,0,NULL,64153526347,1002398849,15662482,16.1),(71439,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71439,37.48,0.46,313,26536,70,NULL,NULL,'2MASX J10305387+4446343',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,157.72425,44.77631,NULL,NULL,64153985554,1002406024,15662594,17.6),(71440,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71440,37.38,0.23,299,26537,70,NULL,NULL,'SDSS J103053.93+110259.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000169,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,157.7247083,11.04983,0.089,NULL,61038240634,953722509,14901914,18.2),(71441,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71441,37.87,0.33,375,26538,70,NULL,NULL,'2MASX J10305804-0005332',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000074,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,157.74175,-0.09261,0.133,NULL,40869361740,638583777,9977871,18.1),(71442,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71442,37.38,0.23,299,26539,70,NULL,NULL,'2MASX J10305871+1106494',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,157.744708333,11.11378,0.089,NULL,61038220835,953722200,14901909,17),(71443,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71443,37.84,0.46,370,26540,70,NULL,NULL,'2MASX J10305950+1033214',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000142,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,157.7480417,10.55594,0.069,NULL,61049436780,953897449,14904647,17.8),(71444,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71444,38.05,0.21,407,26541,70,NULL,NULL,'SDSS J103100.26+073734.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000139,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,157.751125,7.62633,0.037,NULL,61043437830,953803716,14903183,18.2),(71445,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71445,38.49,0.46,500,26542,70,NULL,NULL,'SDSS J103101.11+025448.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,157.754667,2.91358,0.077,NULL,61004908385,953201693,14893776,18.2),(71446,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71446,37.8,0.33,362,26543,70,NULL,NULL,'SDSS J103101.25+310813.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000165,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,157.7552083,31.13703,0.029,NULL,64080964719,1001265073,15644766,18.6),(71447,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71447,38.37,0.46,473,26544,70,NULL,NULL,'SDSS J103101.30+010055.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000082,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,157.755458333,1.01536,0.137,NULL,61002979909,953171561,14893305,18.2),(71448,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71448,37.2,0.33,275,26545,70,NULL,NULL,'2MASX J10310165+4159403',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000158,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,157.757083,41.99472,0,NULL,64153722384,1002401912,15662529,16.6),(71449,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71449,33.9,0.4,60.2,26546,NULL,NULL,'mean','IC 2586',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00007,NULL,'13.54',1.1,'E4','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,157.76,-28.71664,0.149,NULL,41951727222,655495737,10242120,13.54),(71450,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71450,35.2,0.45,110,26546,NULL,NULL,'K','IC 2586',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71451,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71451,37.87,0.33,375,26547,70,NULL,NULL,'SDSS J103102.97-000520.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00007,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,157.762417,-0.08911,0.137,NULL,40869343239,638583488,9977867,18),(71452,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71452,37.26,0.46,283,26548,70,NULL,NULL,'2MASX J10310316+5657485',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000146,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,157.763333,56.96364,0,NULL,61967612219,968243940,15128811,17),(71453,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71453,37.38,0.23,299,26549,70,NULL,NULL,'2MASX J10310449+1105524',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000127,NULL,'16.90',0.54,'BrClG',NULL,NULL,NULL,NULL,1,157.768667,11.09781,0.089,NULL,61038251919,953722686,14901916,16.9),(71454,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71454,37.25,0.46,282,26550,70,NULL,NULL,'2MASX J10310556+2701185',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000182,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,157.773166667,27.02175,0.037,NULL,60474789704,944918589,14764352,17),(71455,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71455,37.39,0.11,300,26551,70,NULL,NULL,'SDSS J103106.04+401146.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000181,NULL,'18.1g',0.1,NULL,NULL,NULL,NULL,NULL,1,157.7752083,40.19625,0,NULL,64149458409,1002335287,15661488,18.1),(71456,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71456,37.88,0.46,377,26552,70,NULL,NULL,'2MASX J10310604+1635154',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,157.77525,16.58769,0.069,NULL,60964770659,952574541,14883977,17.5),(71457,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71457,37.15,0.46,269,26553,70,NULL,NULL,'2MASX J10310690+3012332',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'18.59',0.16,NULL,NULL,NULL,NULL,NULL,1,157.778916667,30.20925,0.045,NULL,64081167522,1001268242,15644816,18.59),(71458,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71458,37.95,0.46,389,26554,70,NULL,NULL,'2MASX J10310818+5353038',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00014,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,157.7842083,53.8845,0,NULL,61893039317,967078739,15110605,17.5),(71459,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71459,37.5,0.46,317,26555,70,NULL,NULL,'SDSS J103108.31+111724.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000138,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,157.784625,11.29011,0.077,NULL,61038509172,953726705,14901979,18.3),(71460,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71460,37.04,0.46,256,26556,70,NULL,NULL,'2MASX J10310885+4801548',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000165,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,157.7867917,48.03194,0,NULL,64137866073,1002154157,15658658,17.1),(71461,'GRB','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71461,38.89,NULL,601,26557,65,NULL,'L = 10e57 photons/s','GRB 790329',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,157.779625,45.63886,0,NULL,64135357821,1002114965,15658046,NULL),(71462,'GRB','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71462,39.72,NULL,877,26557,75,NULL,NULL,'GRB 790329',NULL,'1995ApJ...453..583W',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71463,'GRB','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71463,40,NULL,1000,26557,NULL,NULL,NULL,'GRB 790329',NULL,'1992grbo.book..107S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71464,'GRB','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71464,41.65,NULL,2130,26557,65,NULL,'L = 2 x 10e58 photons/s','GRB 790329',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71465,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71465,37.51,0.46,318,26558,70,NULL,NULL,'2MASX J10310949+6123036',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000143,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,157.7897917,61.38436,0,NULL,61944321531,967880023,15123125,17.7),(71466,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71466,37.08,0.46,261,26559,70,NULL,NULL,'SDSS J103109.69+363428.3',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000151,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,157.790417,36.57456,0.017,NULL,64046362419,1000724412,15636318,17),(71467,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71467,37.14,0.46,268,26560,70,NULL,NULL,'2MASX J10311038+6231426',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000142,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,157.793125,62.52847,0,NULL,61825835649,966028682,15094198,17.8),(71468,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71468,34.45,0.46,77.8,26561,70,NULL,NULL,'IC 2583',NULL,'2015arXiv151105856S',2015,1,0.86,NULL,'G',0.000162,NULL,'14.6g',0.6,NULL,NULL,NULL,NULL,NULL,1,157.7935,26.05506,0.029,NULL,60481168061,945018250,14765910,14.6),(71469,'Tully est','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71469,32.02,0.8,25.4,26562,75,NULL,NULL,'UGC 05706',NULL,'1988NBGC.C....0000T',1988,1,1.4,NULL,'G',0.000013,NULL,'18.',1.1,'Im',NULL,NULL,NULL,NULL,1,157.7955,34.50294,0.021,NULL,64043962858,1000686919,15635733,18),(71470,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71470,38.17,0.46,431,26563,70,NULL,NULL,'2MASX J10311118+4019579',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,157.796791667,40.33278,0,NULL,64149753709,1002339901,15661560,17.6),(71471,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71471,32.67,0.45,34.3,26564,NULL,NULL,'K','NGC 3283',NULL,'2007A&A...465...71T',2007,1,2.6,'NGC position is +1m35s, +10\' in error.  ESO 264- ? 001 is for nominal pos.','G',0.000073,NULL,'12.5',1.5,'SA(s)0^0^?',NULL,NULL,NULL,NULL,1,157.798333,-46.25128,0.801,NULL,42107627123,657931673,10280182,12.5),(71472,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71472,33.08,0.4,41.3,26564,NULL,NULL,'mean','NGC 3283',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71473,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71473,37.44,0.46,307,26565,70,NULL,NULL,'2MASX J10311316+1807378',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,157.804875,18.12714,0.053,NULL,60987277879,952926216,14889472,16.9),(71474,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71474,30.98,0.39,15.7,26566,73,NULL,'opt','UGC 05708',NULL,'2011A&A...532A.104N',2011,1,3.64,NULL,'G',0.000017,NULL,'13.80',0.47,'SBd:','Isolated galaxy',NULL,NULL,NULL,1,157.8054583,4.47253,0.045,NULL,61011759662,953308744,14895449,13.8),(71475,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71475,31.34,NULL,18.6,26566,NULL,NULL,'Dipole','UGC 05708',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71476,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71476,31.34,NULL,18.6,26566,NULL,NULL,'Dipole + Quadrupole','UGC 05708',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71477,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71477,31.34,NULL,18.6,26566,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05708',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71478,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71478,31.37,NULL,18.8,26566,NULL,NULL,NULL,'UGC 05708',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71479,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71479,31.44,0.4,19.4,26566,75,NULL,'B','UGC 05708',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71480,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71480,31.54,0.2,20.3,26566,74.4,NULL,NULL,'UGC 05708',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71481,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71481,31.64,NULL,21.3,26566,NULL,NULL,NULL,'UGC 05708',NULL,'2015AstBu..70....1K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71482,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71482,31.69,0.65,21.7,26566,NULL,NULL,'Malmquist cor.','UGC 05708',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71483,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71483,31.72,0.43,22.1,26566,75,NULL,'3.6 micron, color corrected','UGC 05708',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71484,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71484,31.84,0.4,23.3,26566,NULL,NULL,NULL,'UGC 05708',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71485,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71485,31.84,0.61,23.4,26566,NULL,NULL,NULL,'UGC 05708',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71486,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71486,31.9,0.43,24,26566,75,NULL,'3.6 micron, color + selection bias corrected','UGC 05708',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71487,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71487,38.08,0.46,413,26567,70,NULL,NULL,'2MASX J10311328+2827265',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000168,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,157.8055,28.45725,0.029,NULL,60473766247,944902597,14764103,18.1),(71488,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71488,37.58,0.46,329,26568,70,NULL,NULL,'2MASX J10311369+1618534',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,157.8070417,16.31489,0.053,NULL,60966595676,952603057,14884422,17.8),(71489,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71489,31.36,0.4,18.7,26569,NULL,NULL,NULL,'UGC 05707',NULL,'2009AJ....138..323T',2009,1,1.1,NULL,'G',0.000006,NULL,'14.8g',0.87,'SAB(s)cd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,157.809375,43.13744,0,NULL,64154648930,1002416389,15662756,14.8),(71490,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71490,33.09,0.4,41.6,26569,75,NULL,'B','UGC 05707',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71491,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71491,37.21,0.46,276,26570,70,NULL,NULL,'2MASX J10311465+0731195',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,157.810958333,7.52203,0.037,NULL,61043378921,953802795,14903168,17.2),(71492,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71492,37.97,0.27,392,26571,70,NULL,NULL,'2MASX J10311570+5815395',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000148,NULL,'16.8g',0.33,NULL,NULL,NULL,NULL,NULL,1,157.8154583,58.26089,0,NULL,61946675911,967916811,15123700,16.8),(71493,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71493,39.49,0.46,791,26572,70,NULL,NULL,'SDSS J103115.97+002807.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000092,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,157.8165417,0.46875,0.133,NULL,61002065042,953157266,14893082,18.1),(71494,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71494,38.05,0.21,407,26573,70,NULL,NULL,'SDSS J103116.33+073726.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000114,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,157.818083,7.624,0.037,NULL,61043383986,953802874,14903169,18.5),(71495,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71495,38.05,0.21,407,26574,70,NULL,NULL,'2MASX J10311640+0737575',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00018,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,157.81825,7.63275,0.037,NULL,61043380711,953802823,14903169,17),(71496,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71496,38.51,0.46,503,26575,70,NULL,NULL,'2MASX J10311663+1747564',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,157.819333333,17.79911,0.057,NULL,60956887261,952451363,14882052,18),(71497,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71497,37.03,0.33,254,26576,70,NULL,NULL,'2MASX J10311707+0748265',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,157.8212083,7.80733,0.065,NULL,61043394870,953803044,14903172,17.2),(71498,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71498,37.2,0.33,275,26577,70,NULL,NULL,'2MASX J10311735+4200514',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000184,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,157.82225,42.01428,0,NULL,64153776157,1002402752,15662543,17.3),(71499,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71499,36.5,0.46,199,26578,70,NULL,NULL,'MCG +10-15-092',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000205,NULL,'15.5g',0.45,'E0',NULL,NULL,NULL,NULL,1,157.8255417,57.40122,0,NULL,62000303212,968754737,15136792,15.5),(71500,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71500,37.49,0.46,314,26579,70,NULL,NULL,'2MASX J10311825+3513032',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000151,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,157.8259583,35.21761,0,NULL,64044713833,1000698653,15635916,17.4),(71501,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71501,35.43,0.38,122,26580,NULL,NULL,'Malmquist cor.','ESO 568- G 013',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.19',0.5,'(R\'_1)SB(s)a   HII',NULL,NULL,NULL,NULL,1,157.826333,-18.54297,0.225,NULL,41672752533,651136758,10174011,15.19),(71502,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71502,35.44,0.38,123,26580,NULL,NULL,NULL,'ESO 568- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71503,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71503,35.48,0.2,125,26580,74.4,NULL,NULL,'ESO 568- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71504,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71504,35.82,0.47,146,26580,NULL,NULL,'H','ESO 568- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71505,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71505,35.85,0.4,148,26580,NULL,NULL,'mean','ESO 568- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71506,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71506,35.92,0.45,153,26580,NULL,NULL,'K','ESO 568- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71507,'BL Lac Luminosity','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71507,41.34,NULL,1360,26581,NULL,NULL,NULL,'2MASX J10311847+5053358',0.360403,'2005ApJ...635..173S',2005,1,NULL,'Preliminary value of z=0.239 (1995MNRAS.277.1477P) incorrect.','QSO',0.000293,NULL,'17.0g',NULL,'BLLAC',NULL,NULL,NULL,'BL Lac',1,157.827167,50.89328,0,NULL,63988883433,999826303,15622285,17),(71508,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71508,37.8,0.33,362,26582,70,NULL,NULL,'2MASX J10311890+3105552',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00018,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,157.828875,31.09881,0.029,NULL,64080931829,1001264559,15644758,17.3),(71509,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71509,37.75,0.46,354,26583,70,NULL,NULL,'SDSS J103119.29+455654.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000122,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,157.830375,45.94844,0,NULL,64135973243,1002124581,15658196,18.8),(71510,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71510,37.1,0.46,262,26584,70,NULL,NULL,'2MASX J10312052+4550543',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000132,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,157.835541667,45.84847,0,NULL,64135269278,1002113582,15658024,17.5),(71511,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71511,38.19,0.46,434,26585,70,NULL,NULL,'2MASX J10312099+2951155',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,157.837375,29.85422,0.045,NULL,64027025017,1000422265,15631597,17.9),(71512,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71512,38.05,0.21,407,26586,70,NULL,NULL,'SDSS J103121.35+073338.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000132,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,157.8389583,7.56056,0.037,NULL,61043390605,953802978,14903171,18.5),(71513,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71513,37.38,0.69,299,26587,70,NULL,NULL,'LCRS B102850.0-031749',NULL,'2014MNRAS.445.2677S',2014,1,0.32,NULL,'G',0.00015,NULL,'17.35',0.26,NULL,NULL,NULL,NULL,NULL,1,157.8427083,-3.55472,0.057,NULL,41757362006,652458781,10194668,17.35),(71514,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71514,38.04,0.46,406,26588,70,NULL,NULL,'2MASX J10312229+4023479',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000171,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,157.8430417,40.39675,0,NULL,64149764553,1002340071,15661563,17.6),(71515,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71515,37.03,0.33,254,26589,70,NULL,NULL,'2MASX J10312239+0756145',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000165,NULL,'16.0g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,157.8432083,7.93736,0.049,NULL,61041429701,953772339,14902692,16),(71516,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71516,35.67,0.46,136,26590,70,NULL,NULL,'CGCG 094-080',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.00018,NULL,'15.5g',0.48,NULL,NULL,NULL,NULL,NULL,1,157.843417,20.08619,0,NULL,60998260977,953097827,14892153,15.5),(71517,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71517,37.39,0.11,300,26591,70,NULL,NULL,'SDSS J103122.78+401009.8',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000165,NULL,'17.4g',NULL,NULL,NULL,NULL,NULL,NULL,1,157.844958333,40.16942,0,NULL,64149341636,1002333463,15661460,17.4),(71518,'IRAS','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71518,34.52,0.8,80,26592,75,NULL,'MAT, I','ESO 317- G 041',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.38',0.4,'SB(r)bc: pec',NULL,NULL,NULL,NULL,1,157.846333,-42.06061,0.517,NULL,42143061618,658485337,10288833,14.38),(71519,'Sosies','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71519,34.86,0.08,93.8,26592,NULL,NULL,NULL,'ESO 317- G 041',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71520,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71520,34.11,0.43,66.4,26592,75,NULL,'MAT, I, raw','ESO 317- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71521,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71521,34.18,0.45,68.7,26592,NULL,NULL,'K','ESO 317- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71522,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71522,34.25,0.47,70.9,26592,NULL,NULL,'H','ESO 317- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71523,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71523,34.27,0.32,71.5,26592,85,NULL,'I, raw','ESO 317- G 041',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71524,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71524,34.32,0.43,73,26592,75,NULL,'MAT, I, cor','ESO 317- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71525,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71525,34.32,0.46,73.1,26592,NULL,NULL,'J','ESO 317- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71526,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71526,34.34,0.32,73.9,26592,85,NULL,'I, inv','ESO 317- G 041',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71527,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71527,34.39,0.49,75.7,26592,75,NULL,'IR','ESO 317- G 041',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71528,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71528,34.4,0.43,75.9,26592,75,NULL,'MAT, I, inv','ESO 317- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71529,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71529,34.5,0.4,79.6,26592,NULL,NULL,'mean','ESO 317- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71530,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71530,38.05,0.21,407,26593,70,NULL,NULL,'2MASX J10312340+0733335',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000176,NULL,'16.4g',0.39,'BrClG',NULL,NULL,NULL,NULL,1,157.8475417,7.55939,0.037,NULL,61043377242,953802769,14903168,16.4),(71531,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71531,32.58,0.43,32.9,26594,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3258C',NULL,'2014MNRAS.444..527S',2014,1,1.2,NULL,'G',0.000063,NULL,'14.57',0.9,'SB(r)ab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,157.850625,-35.22047,0.289,NULL,41987917920,656061217,10250956,14.57),(71532,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71532,37.38,0.23,299,26595,70,NULL,NULL,'SDSS J103126.38+110456.1',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000148,NULL,'17.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,157.8599583,11.08228,0.089,NULL,61038256068,953722751,14901917,17.6),(71533,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71533,37.86,0.46,374,26596,70,NULL,NULL,'2MASX J10312679+3841168',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000156,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,157.8617083,38.68814,0,NULL,64117642725,1001838167,15653721,17),(71534,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71534,36.55,0.46,204,26597,70,NULL,NULL,'CGCG 037-064',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000181,NULL,'15.6g',0.44,'E0',NULL,NULL,NULL,NULL,1,157.8677083,7.48183,0.049,NULL,61039968316,953749504,14902336,15.6),(71535,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71535,36.62,0.33,211,26598,70,NULL,NULL,'CGCG 094-081',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.000123,NULL,'15.0g',0.67,NULL,NULL,NULL,NULL,NULL,1,157.868667,19.70633,0.025,NULL,61001456166,953147752,14892933,15),(71536,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71536,36.39,0.46,190,26599,70,NULL,NULL,'2MASX J10312860+3218120',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000174,NULL,'16.1g',0.34,NULL,NULL,NULL,NULL,NULL,1,157.869083,32.30344,0.029,NULL,64082394923,1001287420,15645115,16.1),(71537,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71537,35.65,0.49,135,26600,75,NULL,'IR','CGCG 037-063',NULL,'2011yCatp016004901K',2011,1,0.98,NULL,'G',0.000014,NULL,'16.3g',0.19,'Sd(f)',NULL,NULL,NULL,NULL,1,157.86925,5.02394,0.053,NULL,61014479064,953351235,14896113,16.3),(71538,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71538,35.78,NULL,143,26600,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 037-063',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71539,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71539,35.8,NULL,145,26600,NULL,NULL,'Dipole + Quadrupole','CGCG 037-063',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71540,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71540,35.82,NULL,146,26600,NULL,NULL,'Dipole','CGCG 037-063',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71541,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71541,35.84,NULL,147,26600,NULL,NULL,NULL,'CGCG 037-063',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71542,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71542,37.33,0.46,292,26601,70,NULL,NULL,'2MASX J10312884+2732455',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,157.8702083,27.54603,0.053,NULL,60476804806,944950075,14764844,17.2),(71543,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71543,34.35,0.47,74,26602,NULL,NULL,'H','NGC 3270',NULL,'2007A&A...465...71T',2007,1,3.2,NULL,'G',0.000013,NULL,'13.9',0.8,'SAB(r)b:       AGN?','Isolated galaxy',NULL,NULL,NULL,1,157.874917,24.86944,0.005,NULL,60472099039,944876547,14763696,13.9),(71544,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71544,34.39,0.46,75.6,26602,NULL,NULL,'J','NGC 3270',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71545,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71545,34.4,0.45,75.9,26602,NULL,NULL,'K','NGC 3270',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71546,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71546,34.54,0.43,81,26602,75,NULL,'3.6 micron, color corrected','NGC 3270',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71547,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71547,34.58,0.2,82.4,26602,74.4,NULL,NULL,'NGC 3270',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71548,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71548,34.66,0.28,85.3,26602,NULL,NULL,'Malmquist cor.','NGC 3270',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71549,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71549,34.72,0.43,87.8,26602,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3270',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71550,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71550,34.74,0.27,88.6,26602,NULL,NULL,NULL,'NGC 3270',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71551,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71551,34.86,0.4,93.9,26602,NULL,NULL,'mean','NGC 3270',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71552,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71552,37.21,0.46,276,26603,70,NULL,NULL,'KUG 1028+365',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.27,'Compact',NULL,NULL,NULL,NULL,1,157.877667,36.27394,0.013,NULL,64046801127,1000731267,15636426,17),(71553,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71553,38.03,0.46,405,26604,70,NULL,NULL,'SDSS J103130.86+381438.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,157.878583,38.24397,0,NULL,64114461847,1001788466,15652944,18.5),(71554,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71554,37.52,0.46,319,26605,70,NULL,NULL,'2MASX J10313125+1802117',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,157.880166667,18.03664,0.053,NULL,60956879405,952451240,14882050,16.5),(71555,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71555,35.7,0.35,138,26606,NULL,NULL,'Malmquist cor.','CGCG 065-048',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000013,NULL,'14.9',0.4,NULL,NULL,NULL,NULL,NULL,1,157.880333333,12.49556,0.065,NULL,61171590224,955806097,14934470,14.9),(71556,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71556,35.98,0.31,157,26606,NULL,NULL,NULL,'CGCG 065-048',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71557,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71557,36.03,0.2,161,26606,74.4,NULL,NULL,'CGCG 065-048',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71558,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71558,37.97,0.27,392,26607,70,NULL,NULL,'2MASX J10313182+5812409',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00019,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,157.882583,58.21142,0,NULL,61946612539,967915820,15123684,17.5),(71559,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71559,39.09,0.46,658,26608,70,NULL,NULL,'SDSS J103134.42+084544.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000183,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,157.8934583,8.76233,0.049,NULL,61041266368,953769787,14902652,18.4),(71560,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71560,37.52,0.46,319,26609,70,NULL,NULL,'SDSS J103134.68+314922.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,157.894541667,31.823,0.053,NULL,64084305275,1001317269,15645582,17.8),(71561,'IRAS','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71561,35.4,0.8,120,26610,75,NULL,'CF, r','UGC 05715',NULL,'1997ApJS..109..333W',1997,1,1.08,NULL,'G',0.000043,NULL,'14.4g',0.66,'Sbc',NULL,NULL,NULL,NULL,1,157.8965,0.47536,0.133,NULL,61002070361,953157349,14893083,14.4),(71562,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71562,34.65,0.69,85.2,26610,100,NULL,'mid-IR','UGC 05715',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71563,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71563,35.31,0.38,115,26610,75,NULL,'CF, r, raw','UGC 05715',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71564,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71564,35.49,0.38,125,26610,75,NULL,'CF, r, cor','UGC 05715',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71565,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71565,35.52,0.38,127,26610,75,NULL,'CF, r, inv','UGC 05715',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71566,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71566,35.66,0.4,136,26610,NULL,NULL,'mean','UGC 05715',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71567,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71567,35.74,0.47,141,26610,NULL,NULL,'H','UGC 05715',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71568,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71568,35.92,0.46,153,26610,NULL,NULL,'J','UGC 05715',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71569,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71569,32.93,0.2,38.6,26611,74.4,NULL,NULL,'NGC 3278',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000123,NULL,'13.01',0.9,'SA(s)c?        HII',NULL,NULL,NULL,NULL,1,157.8974583,-39.95464,0.377,NULL,42134295256,658348363,10286693,13.01),(71570,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71570,33,0.47,39.8,26611,NULL,NULL,'H','NGC 3278',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71571,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71571,33,0.45,39.8,26611,NULL,NULL,'K','NGC 3278',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71572,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71572,33.03,0.46,40.5,26611,NULL,NULL,'J','NGC 3278',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71573,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71573,33.13,0.4,42.3,26611,NULL,NULL,'mean','NGC 3278',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71574,'GRB','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71574,39.71,NULL,874,26612,70,NULL,'Pseudo z = 0.23','GRB 010213',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,157.9,5.51083,0.025,NULL,61014000649,953343760,14895996,NULL),(71575,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71575,38.19,0.46,435,26613,70,NULL,NULL,'SDSS J103136.79+391259.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000158,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,157.9032917,39.21642,0,NULL,64117577483,1001837148,15653705,18.6),(71576,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71576,37.39,0.11,300,26614,70,NULL,NULL,'2MASX J10313706+4007396',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000117,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,157.904583,40.12764,0,NULL,64149356001,1002333687,15661463,17.1),(71577,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71577,37.39,0.11,300,26615,70,NULL,NULL,'2MASX J10313775+4010326',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,157.907208333,40.17581,0,NULL,64149354293,1002333660,15661463,17.4),(71578,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71578,36.88,0.46,237,26616,70,NULL,NULL,'2MASX J10313859+1334513',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000165,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,157.910875,13.58094,0.081,NULL,61172543104,955820986,14934702,16.8),(71579,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71579,37.71,0.33,348,26617,70,NULL,NULL,'2MASX J10313870+3601096',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,157.911417,36.01944,0.005,NULL,64046994018,1000734281,15636473,17.5),(71580,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71580,34.88,0.49,94.4,26618,75,NULL,'IR','UGC 05713',NULL,'2011yCatp016004901K',2011,1,1.93,NULL,'G',0.00005,NULL,'14.4g',0.46,'Sbc',NULL,NULL,NULL,NULL,1,157.9120417,25.98392,0.029,NULL,60481186740,945018542,14765914,14.4),(71581,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71581,34.99,0.43,99.4,26618,75,NULL,'3.6 micron, color corrected','UGC 05713',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71582,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71582,35,0.2,100,26618,74.4,NULL,NULL,'UGC 05713',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71583,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71583,35.13,0.43,106,26618,75,NULL,'3.6 micron, color + selection bias corrected','UGC 05713',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71584,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71584,37.96,0.46,392,26619,70,NULL,NULL,'2MASX J10313910+2509023',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,157.912875,25.15061,0,NULL,60472142436,944877225,14763706,18.3),(71585,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71585,38.04,0.46,406,26620,70,NULL,NULL,'2MASX J10313917+4349564',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,157.913167,43.83225,0,NULL,64154837287,1002419332,15662802,17.3),(71586,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71586,37.35,0.46,295,26621,70,NULL,NULL,'2MASX J10313926+0347232',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000207,NULL,'16.1g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,157.913667,3.78969,0.077,NULL,61016239982,953378749,14896542,16.1),(71587,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71587,36.59,0.46,208,26622,70,NULL,NULL,'SDSS J103139.89+140037.1',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'15.9g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,157.91625,14.01033,0.133,NULL,61172854844,955825856,14934779,15.9),(71588,'IRAS','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71588,32.62,0.8,33.4,26623,75,NULL,'HMCL, I','ESO 263- G 051',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000053,NULL,'14.18',0.6,'SB(rs)cd pec',NULL,NULL,NULL,NULL,1,157.9172917,-45.48314,0.717,NULL,42106838223,657919347,10279989,14.18),(71589,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71589,32.2,0.4,27.5,26623,NULL,NULL,NULL,'ESO 263- G 051',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71590,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71590,32.2,0.4,27.5,26623,73,NULL,'opt','ESO 263- G 051',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71591,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71591,32.31,0.4,29,26623,75,NULL,'HMCL, I, raw','ESO 263- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71592,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71592,32.39,0.4,30,26623,75,NULL,'HMCL, I, inv','ESO 263- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71593,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71593,32.63,0.4,33.6,26623,75,NULL,'HMCL, I, cor','ESO 263- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71594,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71594,32.68,0.47,34.4,26623,NULL,NULL,'H','ESO 263- G 051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71595,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71595,32.77,0.46,35.9,26623,NULL,NULL,'J','ESO 263- G 051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71596,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71596,32.83,0.45,36.7,26623,NULL,NULL,'K','ESO 263- G 051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71597,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71597,33.02,0.4,40.1,26623,NULL,NULL,'mean','ESO 263- G 051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71598,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71598,37.96,0.15,392,26624,70,NULL,NULL,'2MASX J10314055+4123507',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,157.918917,41.39756,0,NULL,64153788670,1002402947,15662546,18),(71599,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71599,32.68,NULL,34.3,26625,NULL,NULL,NULL,'2MASXi J1031407+135004',NULL,'2015AstBu..70....1K',2015,1,0.53,NULL,'G',0.00017,NULL,'16.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,157.920083,13.83492,0.129,NULL,61172643810,955822559,14934727,16.3),(71600,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71600,38.42,0.46,483,26626,70,NULL,NULL,'2MASX J10314088+0657383',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000147,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,157.92025,6.96069,0.053,NULL,61057166554,954018227,14906534,17.6),(71601,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71601,37.04,0.46,256,26627,70,NULL,NULL,'2MASX J10314152+4828327',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000189,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,157.922833333,48.47564,0,NULL,64137975979,1002155874,15658685,16.9),(71602,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71602,37.37,0.46,298,26628,70,NULL,NULL,'2MASX J10314193+0330122',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000196,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,157.9247083,3.50353,0.073,NULL,61016625451,953384772,14896637,16.8),(71603,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71603,37,0.46,252,26629,70,NULL,NULL,'2MASX J10314303+3852497',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000174,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,157.929333,38.88056,0,NULL,64117781210,1001840331,15653755,17),(71604,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71604,36.7,0.33,219,26630,70,NULL,NULL,'2MASX J10314349+0015212',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000096,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,157.931166667,0.25594,0.141,NULL,60264019069,941625297,14712895,16.5),(71605,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71605,37.39,0.11,300,26631,70,NULL,NULL,'2MASX J10314444+4020497',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,157.9352083,40.34708,0,NULL,64149628403,1002337943,15661530,17.3),(71606,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71606,37.31,0.46,290,26632,70,NULL,NULL,'2MASX J10314463+0924313',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000195,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,157.936,9.40875,0.025,NULL,61051733322,953933333,14905208,16.6),(71607,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71607,37.95,0.46,389,26633,70,NULL,NULL,'2MASX J10314660+0506352',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'18.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,157.94425,5.10972,0.053,NULL,61014460508,953350945,14896108,18.1),(71608,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71608,36.36,0.46,187,26634,70,NULL,NULL,'2MASX J10314679+0937433',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000157,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,157.9449583,9.62858,0.041,NULL,61051591625,953931119,14905173,16.7),(71609,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71609,36.17,0.64,171,26635,70,NULL,NULL,'CGCG 009-073 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.57,'The APM image includes a superposed star.','G',0.00015,NULL,'15.7g',0.39,NULL,NULL,NULL,NULL,NULL,1,157.948583,-2.69978,0.053,NULL,41743201332,652237520,10191211,15.7),(71610,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71610,37.39,0.11,300,26636,70,NULL,NULL,'2MASX J10314812+4013367',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,157.9505417,40.22694,0,NULL,64149624926,1002337889,15661529,17.5),(71611,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71611,34.23,0.23,70.2,26637,74.4,NULL,NULL,'ESO 501- G 003',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.00005,NULL,'13.74',1.3,'SAB0-',NULL,NULL,NULL,NULL,1,157.9514583,-26.56542,NULL,NULL,41486546376,648227287,10128551,13.74),(71612,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71612,34.1,0.4,66.2,26637,NULL,NULL,'mean','ESO 501- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71613,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71613,34.71,0.45,87.3,26637,NULL,NULL,'K','ESO 501- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71614,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71614,38.12,0.46,421,26638,70,NULL,NULL,'2MASX J10314844+1626192',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,157.9519583,16.43875,0.069,NULL,60966584070,952602876,14884419,17.9),(71615,'Sosies','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71615,33.54,0.47,51.5,26639,NULL,NULL,NULL,'IC 2588',NULL,'2002A&A...393...57T',2002,1,1.4,NULL,'G',0.000037,NULL,'13.63',1.2,'(R\'_2?)SB(r)a',NULL,NULL,NULL,NULL,1,157.958917,-30.38453,0.097,NULL,41998539680,656227182,10253549,13.63),(71616,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71616,33.64,0.45,53.4,26639,NULL,NULL,'K','IC 2588',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71617,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71617,33.66,0.47,54,26639,NULL,NULL,'H','IC 2588',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71618,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71618,33.67,0.4,54.2,26639,NULL,NULL,'mean','IC 2588',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71619,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71619,33.69,0.46,54.7,26639,NULL,NULL,'J','IC 2588',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71620,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71620,37.97,0.27,392,26640,70,NULL,NULL,'2MASX J10315056+5807550',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000176,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,157.960833,58.13194,0,NULL,61946618367,967915911,15123686,17.4),(71621,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71621,37.3,0.46,288,26641,70,NULL,NULL,'SDSS J103150.72+491055.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000125,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,157.961333,49.182,0,NULL,64124028983,1001937952,15655280,18.1),(71622,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71622,36.58,0.33,207,26642,70,NULL,NULL,'MCG +07-22-018',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000097,NULL,'15.4g',0.42,'S0/a',NULL,NULL,NULL,NULL,1,157.961417,42.86311,0,NULL,64155046879,1002422607,15662853,15.4),(71623,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71623,37.71,0.33,348,26643,70,NULL,NULL,'2MASX J10315081+3556367',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,157.9619583,35.94372,0,NULL,64046878060,1000732469,15636444,17.8),(71624,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71624,37.48,0.46,313,26644,70,NULL,NULL,'2MASX J10315193+3108301',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,157.9665417,31.14183,0.029,NULL,64081045197,1001266331,15644786,18),(71625,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71625,38.06,0.46,409,26645,70,NULL,NULL,'2MASX J10315306+1134123',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00021,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,157.971166667,11.56997,0.077,NULL,61038592524,953728008,14902000,16.8),(71626,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71626,37.1,0.46,263,26646,70,NULL,NULL,'2MASX J10315308+5440220',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,157.97125,54.67283,0,NULL,61905864109,967279126,15113736,17.1),(71627,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71627,31.45,0.43,19.5,26647,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3258D',NULL,'2014MNRAS.444..527S',2014,1,1.6,NULL,'G',0.000053,NULL,'13.96',0.9,'SB(s)b:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,157.982208333,-35.40981,0.289,NULL,41987747045,656058547,10250914,13.96),(71628,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71628,32.23,0.47,27.9,26647,NULL,NULL,'H','NGC 3258D',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71629,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71629,32.27,0.46,28.5,26647,NULL,NULL,'J','NGC 3258D',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71630,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71630,32.33,0.45,29.3,26647,NULL,NULL,'K','NGC 3258D',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71631,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71631,32.79,0.4,36.2,26647,NULL,NULL,'mean','NGC 3258D',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71632,'TRGB','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71632,30.11,0.1,10.5,26648,74.4,NULL,NULL,'SDSS J103155.79+280133.7',NULL,'2013AJ....146...86T',2013,1,0.37,NULL,'G',0.00006,NULL,'16.8g',0.31,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,157.9825,28.02603,0.037,NULL,60477505648,944961025,14765016,16.8),(71633,'TRGB','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71633,30.11,0.07,10.5,26648,NULL,NULL,NULL,'SDSS J103155.79+280133.7',NULL,'2015ApJ...805..144K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71634,'TRGB','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71634,30.23,0.04,11.1,26648,NULL,NULL,'I','SDSS J103155.79+280133.7',NULL,'2014ApJ...785....3M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71635,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71635,37.39,0.11,300,26649,70,NULL,NULL,'2MASX J10315598+4006437',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00011,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,157.9834583,40.112,0,NULL,64149350526,1002333601,15661462,16.4),(71636,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71636,38.31,0.46,459,26650,70,NULL,NULL,'2MASX J10315682+3133101',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000187,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,157.986875,31.55281,0.029,NULL,64080864554,1001263508,15644742,17.3),(71637,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71637,37.4,0.46,302,26651,70,NULL,NULL,'2MASX J10315697+0425442',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000187,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,157.9875417,4.42883,0.073,NULL,61011676790,953307449,14895428,16.7),(71638,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71638,37.39,0.11,300,26652,70,NULL,NULL,'2MASX J10315703+4018207',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00017,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,157.987625,40.30581,0,NULL,64149631947,1002337999,15661531,16.6),(71639,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71639,38.75,0.46,563,26653,70,NULL,NULL,'2MASX J10315778+6133429',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000176,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,157.9904583,61.56192,0,NULL,61944269785,967879215,15123112,17.9),(71640,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71640,37.33,0.46,293,26654,70,NULL,NULL,'2MASX J10315822+2052430',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,157.9925,20.87869,0,NULL,60998680212,953104378,14892255,17.9),(71641,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71641,36.42,0.46,192,26655,70,NULL,NULL,'2MASX J10315832+1630282',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.14',0.32,NULL,NULL,NULL,NULL,NULL,1,157.993125,16.50794,0.069,NULL,60966570316,952602661,14884416,17.14),(71642,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71642,36.27,0.46,180,26656,70,NULL,NULL,'2MASX J10315924+4719265',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000143,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,157.997083,47.32406,0,NULL,64139182153,1002174721,15658980,16.7),(71643,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71643,36.95,0.46,245,26657,70,NULL,NULL,'CGCG 037-070',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000198,NULL,'15.9g',0.34,'E0',NULL,NULL,NULL,NULL,1,158.0009583,7.67289,0.037,NULL,61041336893,953770888,14902670,15.9),(71644,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71644,36.97,0.46,247,26658,70,NULL,NULL,'2MASX J10320046-0021423',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000071,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,158.001875,-0.36175,0.141,NULL,40869404699,638584448,9977882,17),(71645,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71645,36.7,0.33,219,26659,70,NULL,NULL,'2MASX J10320062+0015372',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000081,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,158.002667,0.26039,0.141,NULL,60264018131,941625283,14712895,17.3),(71646,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71646,36.28,0.75,180,26660,70,NULL,NULL,'LCRS B102933.7-121617',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00012,NULL,'15.17',NULL,NULL,NULL,NULL,NULL,NULL,1,158.0077083,-12.52911,0.201,NULL,41828527766,653570746,10212042,15.17),(71647,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71647,37.83,0.33,369,26661,70,NULL,NULL,'2MASX J10320217+1346276',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000188,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,158.0090417,13.77436,0.129,NULL,61172524341,955820692,14934698,16.4),(71648,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71648,37.81,0.27,365,26662,70,NULL,NULL,'2MASX J10320286+1326326',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,158.0120417,13.44242,0.157,NULL,61172975658,955827744,14934808,16.5),(71649,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71649,37.43,0.46,306,26663,70,NULL,NULL,'SDSS J103203.17+042856.2',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,158.01325,4.48228,0.073,NULL,61013528113,953336376,14895880,17.7),(71650,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71650,38.52,0.46,507,26664,70,NULL,NULL,'2MASX J10320335+3947147',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,158.014,39.78736,0,NULL,64116640003,1001822500,15653476,17.7),(71651,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71651,35.01,0.33,101,26665,70,NULL,NULL,'2MASX J10320413+4351334',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000154,NULL,'15.6g',0.45,'S0^-',NULL,NULL,NULL,NULL,1,158.017041667,43.85928,0,NULL,64154581991,1002415343,15662739,15.6),(71652,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71652,37.68,0.46,343,26666,70,NULL,NULL,'2MASX J10320582+0037472',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00008,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,158.02425,0.62989,0.133,NULL,61002033685,953156776,14893074,17.8),(71653,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71653,37.39,0.11,300,26667,70,NULL,NULL,'2MASX J10320595+4017257',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000117,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,158.024625,40.29053,0,NULL,64149623979,1002337874,15661529,16.5),(71654,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71654,37.92,0.33,384,26668,70,NULL,NULL,'2MASX J10320622+1259476',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,158.025791667,12.99667,0.089,NULL,61173031224,955828612,14934822,17.3),(71655,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71655,38.03,0.46,403,26669,70,NULL,NULL,'2MASX J10320714+0118182',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000177,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,158.029833,1.30494,0.125,NULL,61002755476,953168054,14893250,17.4),(71656,'BCG','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71656,37.85,0.35,344,26670,60,NULL,NULL,'ABELL 1035',0.0799,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III:[BM]',NULL,NULL,NULL,NULL,1,158.030458333,40.20919,0,NULL,64149623651,1002337869,15661529,NULL),(71657,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71657,37.39,0.11,300,26671,70,NULL,NULL,'2MASX J10320742+4010303',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000133,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,158.030875,40.17511,0,NULL,64149349366,1002333583,15661462,16.8),(71658,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71658,38.48,0.46,497,26672,70,NULL,NULL,'SDSS J103211.89+174541.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,158.049583,17.76142,0.045,NULL,60957122213,952455034,14882109,18.2),(71659,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71659,35.14,0.46,106,26673,70,NULL,NULL,'MCG -01-27-013',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00013,NULL,'14.65',1,'(R)SA0-:',NULL,NULL,NULL,NULL,1,158.0512917,-9.23908,0.097,NULL,41771576099,652680876,10198138,14.65),(71660,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71660,37.39,0.11,300,26674,70,NULL,NULL,'2MASX J10321249+4008084',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000166,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,158.0522917,40.13567,0,NULL,64149381498,1002334085,15661470,16.8),(71661,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71661,35.01,0.68,100,26675,70,NULL,NULL,'UGC 05723',NULL,'2014MNRAS.445.2677S',2014,1,1,'RC3 has V = 1171 +- 9 km/s; 1996ApJS..105..209I have V = 11305 +- 275 km/s.','G',0.000143,NULL,'15.35',0.7,'(R\')SAB(r)a pec:',NULL,NULL,NULL,NULL,1,158.053208333,-1.49339,0.113,NULL,41745645775,652275715,10191808,15.35),(71662,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71662,38.14,0.46,425,26676,70,NULL,NULL,'SDSS J103213.37+094448.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,158.05575,9.74681,0.041,NULL,61052066166,953938533,14905289,18.2),(71663,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71663,37.9,0.27,380,26677,70,NULL,NULL,'2MASX J10321367+0042332',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000079,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,158.0569583,0.70931,0.133,NULL,61002037353,953156833,14893075,16.9),(71664,'BCG','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71664,37.85,0.35,344,26678,60,NULL,'ABELL 1035, BCG','2MASX J10321392+4016164',0.0799,'1980ApJ...241..486H',1980,1,0.6,NULL,'G',0.000117,NULL,'15.6g',0.55,'cD;BrClG','Brightest group member',NULL,NULL,NULL,1,158.058125,40.27125,0,NULL,64149641672,1002338151,15661533,15.6),(71665,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71665,37.39,0.11,300,26678,70,NULL,NULL,'2MASX J10321392+4016164',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71666,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71666,38.29,0.46,455,26679,70,NULL,NULL,'SDSS J103214.29+002909.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000079,NULL,'18.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,158.0595417,0.48608,0.133,NULL,60263956242,941624316,14712879,18.3),(71667,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71667,36.9,0.46,240,26680,70,NULL,NULL,'2MASX J10321435+1902190',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,158.0597917,19.03861,0.057,NULL,60999848404,953122631,14892541,16.7),(71668,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71668,37.46,0.33,310,26681,70,NULL,NULL,'2MASX J10321487+4613363',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,158.061958333,46.22689,0,NULL,64136137293,1002127145,15658236,17.5),(71669,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71669,37.39,0.11,300,26682,70,NULL,NULL,'2MASX J10321527+4010125',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000123,NULL,'16.0g',0.36,NULL,NULL,NULL,NULL,NULL,1,158.063667,40.17008,0,NULL,64149381359,1002334083,15661470,16),(71670,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71670,38.34,0.46,465,26683,70,NULL,NULL,'2MASX J10321536+3727305',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,158.0639583,37.45856,0,NULL,64114447422,1001788240,15652941,17.2),(71671,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71671,37.52,0.46,320,26684,70,NULL,NULL,'2MASX J10321541+1332426',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,158.064333,13.54517,0.157,NULL,61172499124,955820298,14934692,17.1),(71672,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71672,36.57,0.46,206,26685,70,NULL,NULL,'2MASX J10321553+3400407',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000173,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,158.064875,34.01136,0.029,NULL,64051476378,1000804318,15637567,16.3),(71673,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71673,36.58,0.33,207,26686,70,NULL,NULL,'MCG +07-22-020',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00009,NULL,'15.4g',0.53,'E0',NULL,NULL,NULL,NULL,1,158.068166667,43.00669,0,NULL,64155053690,1002422713,15662854,15.4),(71674,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71674,35.77,0.5,142,26687,70,NULL,NULL,'MCG -01-27-014',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.000123,NULL,'15.09',0.25,NULL,NULL,NULL,NULL,NULL,1,158.069208333,-5.03914,0.069,NULL,41749909560,652342336,10192849,15.09),(71675,'Brightest Stars','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71675,29.02,NULL,6.37,26688,NULL,NULL,'LF','NGC 3274',NULL,'1997AstL...23..514G',1997,1,2.1,NULL,'G',0.000017,NULL,'13.21',1,'SABd?','Possible field galaxy',NULL,NULL,'Emission-Line Galaxy',1,158.0719583,27.66878,0.053,NULL,60476817580,944950274,14764848,13.21),(71676,'Brightest Stars','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71676,29.08,0.2,6.55,26688,NULL,NULL,NULL,'NGC 3274',NULL,'1998A&AS..133..181M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71677,'Brightest Stars','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71677,29.51,0.4,7.98,26688,NULL,NULL,'3B + 3R mean','NGC 3274',NULL,'1997AstL...23..514G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71678,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71678,28.84,0.4,5.9,26688,75,NULL,'B','NGC 3274',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71679,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71679,31.11,0.4,16.6,26688,NULL,NULL,'mean','NGC 3274',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71680,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71680,31.91,0.46,24.1,26688,NULL,NULL,'J','NGC 3274',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71681,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71681,31.94,0.47,24.4,26688,NULL,NULL,'H','NGC 3274',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71682,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71682,37.73,0.46,351,26689,70,NULL,NULL,'2MASX J10321813+4129065',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000147,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,158.07575,41.48522,0,NULL,64153844281,1002403816,15662559,17.2),(71683,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71683,37.9,0.27,380,26690,70,NULL,NULL,'SDSS J103218.25+003648.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000077,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,158.076083333,0.61336,0.133,NULL,60263897285,941623395,14712865,18.5),(71684,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71684,38.55,0.46,512,26691,70,NULL,NULL,'2MASX J10321961+1716066',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,158.081875,17.26858,0.057,NULL,60957317614,952458087,14882157,18.6),(71685,'IRAS','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71685,31.19,0.8,17.3,26692,75,NULL,'A82, H','NGC 3264',NULL,'1997ApJS..109..333W',1997,1,2.9,NULL,'G',0.000003,NULL,'12.5',1.2,'SBdm:          HII','X-ray-faint group member',NULL,NULL,NULL,1,158.082083,56.08528,0,NULL,61968273578,968254274,15128973,12.5),(71686,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71686,30.57,0.43,13,26692,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3264',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71687,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71687,31.26,0.4,17.9,26692,75,NULL,'B','NGC 3264',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71688,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71688,31.6,0.47,20.9,26692,75,NULL,'A82, H, inv','NGC 3264',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71689,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71689,31.75,0.47,22.4,26692,75,NULL,'A82, H, raw','NGC 3264',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71690,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71690,32,0.47,25.1,26692,75,NULL,'A82, H, cor','NGC 3264',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71691,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71691,37.39,0.11,300,26693,70,NULL,NULL,'2MASX J10321990+4008265',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000179,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,158.082917,40.14058,0,NULL,64149381745,1002334089,15661470,16.8),(71692,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71692,32.06,0.43,25.8,26694,75,NULL,'3.6 micron, color + selection bias corrected','IC 2589',NULL,'2014MNRAS.444..527S',2014,1,0.9,NULL,'G',0.000053,NULL,'14.23',0.6,'Sb             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,158.08675,-24.03756,0.233,NULL,41614093471,650220210,10159690,14.23),(71693,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71693,37.73,0.46,352,26695,70,NULL,NULL,'SDSS J103221.59+383537.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000152,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,158.0899583,38.59383,0,NULL,64117631276,1001837988,15653718,18.3),(71694,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71694,37.92,0.33,384,26696,70,NULL,NULL,'2MASX J10322257+1259026',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000163,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,158.094,12.98417,0.089,NULL,61171151565,955799243,14934363,17),(71695,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71695,38.38,0.46,474,26697,70,NULL,NULL,'SDSS J103223.23+112420.4',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000142,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,158.096833333,11.40567,0.081,NULL,61037750634,953714853,14901794,18.1),(71696,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71696,37.39,0.11,300,26698,70,NULL,NULL,'2MASX J10322347+4010086',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00011,NULL,'16.2g',0.42,NULL,NULL,NULL,NULL,NULL,1,158.097667,40.16903,0,NULL,64149328045,1002333250,15661457,16.2),(71697,'IRAS','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71697,33.02,0.8,40.1,26699,75,NULL,'MAT, I','NGC 3258E',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'15.36',0.3,'Sb? sp','Group member',NULL,NULL,NULL,1,158.1037917,-34.99836,0.289,NULL,41987689871,656057654,10250900,15.36),(71698,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71698,30.87,0.32,14.9,26699,85,NULL,'I, inv','NGC 3258E',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71699,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71699,30.92,0.32,15.3,26699,85,NULL,'I, raw','NGC 3258E',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71700,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71700,31.36,0.43,18.7,26699,75,NULL,'MAT, I, inv','NGC 3258E',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71701,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71701,31.47,0.43,19.7,26699,75,NULL,'MAT, I, raw','NGC 3258E',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71702,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71702,31.89,0.43,23.8,26699,75,NULL,'MAT, I, cor','NGC 3258E',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71703,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71703,32,0.49,25.1,26699,75,NULL,'IR','NGC 3258E',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71704,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71704,38.32,0.46,462,26700,70,NULL,NULL,'SDSS J103225.91+205944.7',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000158,NULL,'17.6g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,158.1079583,20.99575,0.013,NULL,60998625124,953103517,14892242,17.6),(71705,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71705,37.83,0.33,369,26701,70,NULL,NULL,'SDSS J103227.52+134853.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000139,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,158.114667,13.81494,0.129,NULL,61172560456,955821257,14934707,18.6),(71706,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71706,36.93,0.46,243,26702,70,NULL,NULL,'2MASX J10322817+3620426',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000163,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,158.117541667,36.34531,0.017,NULL,64046909426,1000732959,15636452,16.9),(71707,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71707,36.5,0.46,200,26703,70,NULL,NULL,'2MASX J10322897+0734209',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000144,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,158.120625,7.57239,0.041,NULL,61058905825,954045403,14906959,16.9),(71708,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71708,37.81,0.27,365,26704,70,NULL,NULL,'2MASX J10322911+1325126',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000163,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,158.121375,13.42017,0.157,NULL,61172897989,955826531,14934789,18.2),(71709,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71709,37.87,0.46,376,26705,70,NULL,NULL,'2MASX J10323071+4432573',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'17.1g',0.32,NULL,NULL,NULL,NULL,NULL,1,158.127875,44.54906,0,NULL,64140587937,1002196686,15659323,17.1),(71710,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71710,37.42,0.46,305,26706,70,NULL,NULL,'2MASX J10323083+3003248',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00013,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,158.128375,30.05692,0.053,NULL,64080732786,1001261449,15644710,17.9),(71711,'Tully est','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71711,31.98,0.8,24.9,26707,75,NULL,'B','UGC 05720',NULL,'1988NBGC.C....0000T',1988,1,1.12,NULL,'G',0.000015,NULL,'13.5g',0.8,'Im pec;WR      HII','Group member',NULL,NULL,NULL,1,158.133333,54.40056,0,NULL,61892406088,967068845,15110450,13.5),(71712,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71712,37.85,0.46,372,26708,70,NULL,NULL,'2MASX J10323288+2543165',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,158.13725,25.72128,0,NULL,60478205271,944971957,14765186,17.9),(71713,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71713,37.9,0.27,380,26709,70,NULL,NULL,'2MASX J10323347+0031532',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00009,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,158.139375,0.53139,0.133,NULL,60263944650,941624135,14712877,17.4),(71714,'IRAS','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71714,32.23,0.8,28,26710,75,NULL,'CF, r','NGC 3259',NULL,'1997ApJS..109..333W',1997,1,1.35,NULL,'G',0.000057,NULL,'13.4g',0.89,'SAB(rs)bc:     BLAGN','in a radial-velocity based grouping',NULL,NULL,'Sy 1',1,158.1452083,65.04108,0.005,NULL,62124036190,970688065,15167001,13.4),(71715,'Tully est','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71715,32.29,0.8,28.7,26710,75,NULL,'B','NGC 3259',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71716,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71716,31.11,0.69,16.7,26710,100,NULL,'mid-IR','NGC 3259',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71717,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71717,32.29,0.4,28.7,26710,NULL,NULL,'mean','NGC 3259',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71718,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71718,32.48,0.43,31.3,26710,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3259',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71719,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71719,32.59,0.43,33,26710,75,NULL,'3.6 micron, color corrected','NGC 3259',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71720,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71720,32.6,0.47,33.1,26710,NULL,NULL,'H','NGC 3259',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71721,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71721,32.61,0.45,33.2,26710,NULL,NULL,'K','NGC 3259',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71722,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71722,32.61,0.46,33.3,26710,NULL,NULL,'J','NGC 3259',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71723,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71723,32.71,0.2,34.8,26710,74.4,NULL,NULL,'NGC 3259',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71724,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71724,32.78,0.48,35.9,26710,NULL,NULL,'Malmquist cor.','NGC 3259',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71725,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71725,32.87,0.46,37.4,26710,NULL,NULL,NULL,'NGC 3259',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71726,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71726,32.93,0.38,38.5,26710,75,NULL,'CF, r, raw','NGC 3259',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71727,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71727,33.01,0.38,40,26710,75,NULL,'CF, r, inv','NGC 3259',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71728,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71728,33.09,0.38,41.4,26710,75,NULL,'CF, r, cor','NGC 3259',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71729,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71729,37.26,0.46,284,26711,70,NULL,NULL,'2MASX J10323501+1552057',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,158.145833,15.86822,0.077,NULL,60958510747,952476730,14882448,17.7),(71730,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71730,37.75,0.46,355,26712,70,NULL,NULL,'SDSS J103235.30+590832.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,158.147125,59.14239,0,NULL,61948985446,967952897,15124264,18.1),(71731,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71731,37.34,0.33,294,26713,70,NULL,NULL,'2MASX J10323774+5314550',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000167,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,158.157208333,53.24864,0,NULL,61895014806,967109606,15111087,16.3),(71732,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71732,37.46,0.33,310,26714,70,NULL,NULL,'2MASX J10323789+4611133',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,158.158125,46.18714,0,NULL,64136112801,1002126762,15658230,17.3),(71733,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71733,37.97,0.27,393,26715,70,NULL,NULL,'2MASX J10323827+1010179',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000158,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,158.159667,10.17169,0.081,NULL,61052137804,953939653,14905307,17),(71734,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71734,35.48,0.2,125,26716,74.4,NULL,NULL,'CGCG 065-050',NULL,'2013AJ....146...86T',2013,1,1.01,NULL,'G',0.00002,NULL,'15.3g',0.42,NULL,NULL,NULL,NULL,NULL,1,158.1624583,12.17789,0.085,NULL,61170946346,955796036,14934313,15.3),(71735,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71735,35.48,0.37,125,26716,NULL,NULL,'Malmquist cor.','CGCG 065-050',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71736,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71736,35.51,0.37,126,26716,NULL,NULL,NULL,'CGCG 065-050',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71737,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71737,38.02,0.46,403,26717,70,NULL,NULL,'2MASX J10323911+4356033',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000156,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,158.163,43.93431,0,NULL,64140742093,1002199095,15659360,17.4),(71738,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71738,37.81,0.27,365,26718,70,NULL,NULL,'2MASX J10323997+1329297',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,158.166583333,13.49158,0.157,NULL,61172905369,955826646,14934791,17.1),(71739,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71739,37.8,0.46,363,26719,70,NULL,NULL,'2MASX J10324052+5845598',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000195,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,158.168625,58.76664,0,NULL,61949626580,967962915,15124420,17),(71740,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71740,37.84,0.23,370,26720,70,NULL,NULL,'2MASX J10324082+4855490',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,158.1699583,48.93017,0,NULL,64124079536,1001938742,15655292,17.7),(71741,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71741,38.02,0.46,402,26721,70,NULL,NULL,'2MASX J10324123+1728117',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,158.1717083,17.46994,0.049,NULL,60957837857,952466216,14882284,16.5),(71742,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71742,37.04,0.46,256,26722,70,NULL,NULL,'2MASX J10324144+6010098',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,158.1727083,60.16936,0,NULL,61956526365,968070724,15126105,17),(71743,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71743,38.19,0.46,435,26723,70,NULL,NULL,'SDSS J103241.65+242543.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000161,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,158.173583,24.42883,0,NULL,60471892091,944873313,14763645,18.4),(71744,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71744,37.32,0.46,292,26724,70,NULL,NULL,'2MASX J10324193+5414338',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'16.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,158.174666667,54.24283,0,NULL,61893070249,967079222,15110612,16.8),(71745,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71745,38.12,0.46,421,26725,70,NULL,NULL,'2MASX J10324248+3244412',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,158.1770417,32.74492,0.033,NULL,64049550056,1000774219,15637097,17.6),(71746,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71746,35.57,0.5,130,26726,70,NULL,NULL,'NGC 3280B',NULL,'2014MNRAS.445.2677S',2014,1,0.13,NULL,'G',0.00011,NULL,'14.80',0.13,'S0-',NULL,NULL,NULL,NULL,1,158.182541667,-12.63731,0.229,NULL,41828728058,653573875,10212091,14.8),(71747,'IRAS','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71747,33.49,0.8,49.8,26727,75,NULL,'MAT, I','ESO 436- G 034',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000023,NULL,'14.38',0.4,'Sb             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,158.1855,-28.61006,0.157,NULL,41478171160,648096424,10126506,14.38),(71748,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71748,33.74,0.45,56,26727,NULL,NULL,'K','ESO 436- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71749,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71749,33.76,0.47,56.4,26727,NULL,NULL,'H','ESO 436- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71750,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71750,33.78,0.4,56.9,26727,NULL,NULL,'mean','ESO 436- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71751,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71751,33.85,0.46,59,26727,NULL,NULL,'J','ESO 436- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71752,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71752,34.02,0.1,63.8,26727,NULL,NULL,NULL,'ESO 436- G 034',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71753,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71753,34.08,0.43,65.6,26727,75,NULL,'MAT, I, cor','ESO 436- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71754,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71754,34.1,0.43,66,26727,75,NULL,'MAT, I, raw','ESO 436- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71755,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71755,34.25,0.32,70.7,26727,85,NULL,'I, raw','ESO 436- G 034',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71756,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71756,34.31,0.49,72.9,26727,75,NULL,'IR','ESO 436- G 034',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71757,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71757,34.33,0.32,73.3,26727,85,NULL,'I, inv','ESO 436- G 034',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71758,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71758,34.38,0.43,75.2,26727,75,NULL,'3.6 micron, color + selection bias corrected','ESO 436- G 034',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71759,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71759,34.39,0.43,75.4,26727,75,NULL,'3.6 micron, color corrected','ESO 436- G 034',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71760,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71760,34.42,0.43,76.4,26727,75,NULL,'MAT, I, inv','ESO 436- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71761,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71761,34.52,0.2,80.2,26727,74.4,NULL,NULL,'ESO 436- G 034',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71762,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71762,37.97,0.27,393,26728,70,NULL,NULL,'2MASX J10324478+1010349',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,158.186708333,10.17633,0.081,NULL,61052140933,953939702,14905307,17.7),(71763,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71763,37.17,0.33,271,26729,70,NULL,NULL,'2MASX J10324510+0752569',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000176,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,158.187917,7.88239,0.041,NULL,61041512089,953773626,14902712,16.9),(71764,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71764,36.95,0.33,245,26730,70,NULL,NULL,'2MASX J10324511+5225309',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00018,NULL,'15.9g',0.39,'E0',NULL,NULL,NULL,NULL,1,158.188,52.42533,0,NULL,63988701498,999823460,15622241,15.9),(71765,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71765,34.96,0.63,98.1,26731,70,NULL,NULL,'NGC 3296',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00014,NULL,'14.93',0.9,'E0:',NULL,NULL,NULL,NULL,1,158.189167,-12.71742,0.193,NULL,41828499935,653570311,10212036,14.93),(71766,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71766,37.03,0.46,255,26732,70,NULL,NULL,'2MASX J10324536+3258273',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000149,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,158.1892083,32.97419,0.037,NULL,64050087059,1000782610,15637228,17.6),(71767,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71767,38.33,0.46,464,26733,70,NULL,NULL,'2MASX J10324622+1428287',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,158.192625,14.47461,0.077,NULL,61172009303,955812645,14934572,17.9),(71768,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71768,36.74,0.14,222,26734,70,NULL,NULL,'2MASX J10324668+5647278',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000186,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,158.194833,56.79119,0,NULL,61967662489,968244726,15128823,16.9),(71769,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71769,37.34,0.33,294,26735,70,NULL,NULL,'2MASX J10324756+5304229',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,158.1984583,53.07311,0,NULL,61891480973,967054390,15110224,17.3),(71770,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71770,37.95,0.46,390,26736,70,NULL,NULL,'2MASX J10324797+0144453',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,158.199916667,1.74581,0.089,NULL,61005916166,953217440,14894022,17.6),(71771,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71771,37.97,0.27,393,26737,70,NULL,NULL,'SDSS J103248.12+101430.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000142,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,158.2005417,10.24189,0.081,NULL,61052132995,953939578,14905305,18.3),(71772,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71772,36.74,0.14,222,26738,70,NULL,NULL,'2MASX J10324850+5646058',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000165,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,158.2024583,56.76819,0,NULL,61967661892,968244717,15128823,17.8),(71773,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71773,33.84,0.09,58.7,26739,NULL,NULL,NULL,'NGC 3285A',NULL,'2009ApJS..182..474S',2009,1,1.2,'ESO-LV gives V = 4300 +- 10 km/sec.','G',0.000033,NULL,'14.48',0.9,'SB(rs)cd:','in a pair',NULL,NULL,NULL,1,158.20325,-27.52244,0.193,NULL,41480801223,648137519,10127148,14.48),(71774,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71774,35.75,0.46,142,26740,70,NULL,NULL,'2MASX J10324953+3950473',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000167,NULL,'15.7g',0.47,'E0',NULL,NULL,NULL,NULL,1,158.2065,39.84656,0,NULL,64116680445,1001823131,15653486,15.7),(71775,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71775,37.84,0.23,370,26741,70,NULL,NULL,'2MASX J10325024+4904109',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000173,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,158.209375,49.06964,0,NULL,64124065471,1001938522,15655289,17.1),(71776,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71776,37.9,0.46,381,26742,70,NULL,NULL,'2MASXi J1032513+414751',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,158.213917,41.79764,0,NULL,64153970538,1002405789,15662590,18),(71777,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71777,37.26,0.46,283,26743,70,NULL,NULL,'SDSS J103252.44+013127.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,158.2185,1.52425,0.125,NULL,61005764369,953215068,14893985,17.8),(71778,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71778,38.75,0.46,563,26744,70,NULL,NULL,'2MASX J10325315+4424435',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000175,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,158.2214583,44.41197,0,NULL,64140431388,1002194240,15659285,17.9),(71779,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71779,34.56,0.46,81.5,26745,70,NULL,NULL,'MCG -01-27-015',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000067,NULL,'14.90',0.6,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,158.224167,-6.50742,0.093,NULL,41804075077,653188673,10206073,14.9),(71780,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71780,38.07,0.21,410,26746,70,NULL,NULL,'2MASX J10325391+1650157',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,158.224583,16.83758,0.049,NULL,60957157357,952455583,14882118,16.9),(71781,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71781,37.29,0.46,288,26747,70,NULL,NULL,'2MASX J10325451+0226483',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000179,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,158.227125,2.44672,0.065,NULL,61005214012,953206468,14893851,16.5),(71782,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71782,35.81,0.33,145,26748,70,NULL,NULL,'CGCG 065-051',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.00019,NULL,'15.1g',0.56,'E0','Group member',NULL,NULL,NULL,1,158.229,12.04033,0.073,NULL,61170936675,955795885,14934310,15.1),(71783,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71783,37.5,0.46,316,26749,70,NULL,NULL,'2MASX J10325511+0644204',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,158.2295417,6.73906,0.061,NULL,61060440863,954069388,14907334,17.2),(71784,'Tully est','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71784,31.99,0.8,25,26750,75,NULL,'B','NGC 3277',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000023,NULL,'12.50',1.7,'SA(r)ab        HII','Possible field galaxy',NULL,NULL,NULL,1,158.2310417,28.51172,0.029,NULL,60473863060,944904110,14764126,12.5),(71785,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71785,35.65,0.46,135,26751,70,NULL,NULL,'2MASX J10325572+0823204',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000177,NULL,'15.9g',0.3,'S0^-',NULL,NULL,NULL,NULL,1,158.2322917,8.38911,0.049,NULL,61041776541,953777758,14902777,15.9),(71786,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71786,37.39,0.11,300,26752,70,NULL,NULL,'SDSS J103256.31+401729.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,158.234667,40.29158,0,NULL,64149591815,1002337372,15661521,18),(71787,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71787,36.79,0.46,228,26753,70,NULL,NULL,'2MASX J10325655+1124454',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000161,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,158.235666667,11.41272,0.085,NULL,61037744140,953714752,14901793,16.5),(71788,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71788,38.07,0.21,410,26754,70,NULL,NULL,'2MASX J10325663+1649157',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,158.236,16.82086,0.069,NULL,60959005121,952484455,14882569,17.8),(71789,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71789,38.75,0.46,563,26755,70,NULL,NULL,'2MASX J10325776+3839513',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000183,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,158.240667,38.66436,0,NULL,64117624249,1001837878,15653716,17.6),(71790,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71790,38.02,0.46,402,26756,70,NULL,NULL,'2MASX J10325829+1816088',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,158.243083,18.26917,0.053,NULL,60987511870,952929872,14889529,18.1),(71791,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71791,36.74,0.14,222,26757,70,NULL,NULL,'CGCG 290-048',NULL,'2015arXiv151105856S',2015,1,0.95,NULL,'G',0.000147,NULL,'14.6g',0.73,'BrClG',NULL,NULL,'radio jet',NULL,1,158.245417,56.74814,0,NULL,61967468588,968241696,15128776,14.6),(71792,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71792,36.62,0.33,211,26758,70,NULL,NULL,'2MASX J10325910+1937548',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,158.2462083,19.63206,0.033,NULL,61001512955,953148639,14892947,17.8),(71793,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71793,37.17,0.33,271,26759,70,NULL,NULL,'2MASX J10325998+0754244',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000198,NULL,'16.0g',0.38,'E0',NULL,NULL,NULL,NULL,1,158.249916667,7.90672,0.041,NULL,61041379024,953771547,14902680,16),(71794,'IRAS','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71794,30.12,0.8,10.6,26760,75,NULL,'MAT, I','ESO 317- G 046',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.000013,NULL,'14.80',0.3,'SB(s)d: sp',NULL,NULL,NULL,NULL,1,158.2595417,-38.98103,0.249,NULL,42118792079,658106126,10282908,14.8),(71795,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71795,30.23,0.39,11.1,26760,73,NULL,'opt','ESO 317- G 046',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71796,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71796,30.47,0.32,12.4,26760,85,NULL,'I, inv','ESO 317- G 046',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71797,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71797,30.54,0.32,12.8,26760,85,NULL,'I, raw','ESO 317- G 046',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71798,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71798,30.9,0.4,15.1,26760,NULL,NULL,NULL,'ESO 317- G 046',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71799,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71799,30.95,0.43,15.5,26760,75,NULL,'MAT, I, inv','ESO 317- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71800,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71800,31.01,0.2,15.9,26760,74.4,NULL,NULL,'ESO 317- G 046',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71801,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71801,31.12,0.43,16.8,26760,75,NULL,'MAT, I, raw','ESO 317- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71802,'Tully-Fisher','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71802,31.45,0.43,19.5,26760,75,NULL,'MAT, I, cor','ESO 317- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71803,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71803,37.58,0.46,328,26761,70,NULL,NULL,'2MASX J10330253+1256324',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,158.260417,12.94239,0.085,NULL,61171291720,955801433,14934397,17.7),(71804,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71804,38.21,0.46,439,26762,70,NULL,NULL,'VIII Zw 086 NOTES02',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000161,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,158.264083333,13.36042,0.093,NULL,61172931325,955827051,14934797,17),(71805,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71805,38.29,0.46,454,26763,70,NULL,NULL,'SDSS J103303.46+025635.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000155,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,158.264417,2.94314,0.057,NULL,61004598039,953196844,14893700,18.4),(71806,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71806,36.95,0.33,245,26764,70,NULL,NULL,'2MASX J10330377+5218432',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00015,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,158.265625,52.31203,0,NULL,63988709037,999823578,15622243,16.9),(71807,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71807,37.84,0.23,370,26765,70,NULL,NULL,'SDSS J103306.38+491127.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,158.276625,49.19094,0,NULL,64123939531,1001936555,15655258,18.3),(71808,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71808,37.18,0.46,273,26766,70,NULL,NULL,'2MASX J10330687+3939302',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000147,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,158.2785,39.65853,0,NULL,64116691090,1001823298,15653489,16.9),(71809,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71809,36.8,0.91,229,26767,70,NULL,NULL,'2MASX J10330726-2147499',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.6b',0.2,'Sp',NULL,NULL,NULL,NULL,1,158.280333,-21.79725,0.181,NULL,41669262284,651082223,10173159,16.6),(71810,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71810,37.84,0.23,370,26768,70,NULL,NULL,'2MASX J10330767+4901502',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,158.28175,49.03075,0,NULL,64124075779,1001938684,15655291,18),(71811,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71811,37.82,0.46,367,26769,70,NULL,NULL,'2MASX J10330785+1712404',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,158.282583333,17.21119,0.057,NULL,60957336647,952458385,14882162,17.1),(71812,'FP','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,'R',71812,37.39,0.11,300,26770,70,NULL,NULL,'SDSS J103309.65+401121.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,158.2902083,40.18936,0,NULL,64149587225,1002337300,15661520,18.1),(71813,'IRAS','2016-12-15 15:14:38','2016-12-16 11:19:46','1',NULL,NULL,71813,33.63,0.8,53.1,26771,75,NULL,'MAT, I','ESO 501- G 011',NULL,'1997ApJS..109..333W',1997,1,1.79,NULL,'G',0.000023,NULL,'15.5',0.22,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,158.292208333,-24.54283,0.217,NULL,41483401884,648178154,10127783,15.5),(71814,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71814,33.53,0.32,50.7,26771,85,NULL,'I, raw','ESO 501- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71815,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71815,33.54,0.32,51.1,26771,85,NULL,'I, inv','ESO 501- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71816,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71816,33.57,0.43,51.7,26771,75,NULL,'MAT, I, raw','ESO 501- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71817,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71817,33.66,0.43,53.9,26771,75,NULL,'MAT, I, cor','ESO 501- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71818,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71818,33.67,0.43,54.3,26771,75,NULL,'MAT, I, inv','ESO 501- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71819,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71819,33.78,0.43,57.1,26771,75,NULL,'3.6 micron, color + selection bias corrected','ESO 501- G 011',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71820,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71820,33.84,0.13,58.7,26771,NULL,NULL,NULL,'ESO 501- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71821,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71821,33.88,0.43,59.7,26771,75,NULL,'3.6 micron, color corrected','ESO 501- G 011',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71822,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71822,33.97,0.2,62.2,26771,74.4,NULL,NULL,'ESO 501- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71823,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71823,34.32,NULL,73.1,26771,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 501- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71824,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71824,34.33,NULL,73.5,26771,NULL,NULL,'Dipole + Quadrupole','ESO 501- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71825,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71825,34.33,NULL,73.6,26771,NULL,NULL,'Dipole','ESO 501- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71826,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71826,34.39,NULL,75.6,26771,NULL,NULL,NULL,'ESO 501- G 011',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71827,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71827,35.51,0.2,126,26772,74.4,NULL,NULL,'CGCG 065-052',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000046,NULL,'15.7g',0.31,'Sbc','Group member',NULL,NULL,NULL,1,158.2930417,11.89056,0.073,NULL,61037840318,953716254,14901816,15.7),(71828,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71828,36,0.46,159,26773,70,NULL,NULL,'2MASX J10331032+3721272',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000184,NULL,'15.9g',0.37,NULL,NULL,NULL,NULL,NULL,1,158.293208333,37.35764,0,NULL,64117804749,1001840699,15653760,15.9),(71829,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71829,38.07,0.21,410,26774,70,NULL,NULL,'2MASX J10331047+1637324',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,158.293583,16.62561,0.069,NULL,60958992900,952484264,14882566,16.3),(71830,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71830,38.79,0.46,573,26775,70,NULL,NULL,'2MASX J10331140+3548327',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000138,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,158.297333333,35.80928,0,NULL,64046171162,1000721424,15636272,18.1),(71831,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71831,34.69,0.56,86.8,26776,70,NULL,NULL,'NGC 3297',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000133,NULL,'15.44',0.5,'SB?(s?)0o',NULL,NULL,NULL,NULL,1,158.299167,-12.67183,0.169,NULL,41828597419,653571834,10212059,15.44),(71832,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71832,38.07,0.21,410,26777,70,NULL,NULL,'2MASX J10331228+1642114',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,158.3012917,16.70325,0.069,NULL,60959017768,952484652,14882572,17.6),(71833,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71833,36.74,0.14,222,26778,70,NULL,NULL,'2MASX J10331248+5705339',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000173,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,158.302,57.09289,0,NULL,61967559899,968243123,15128798,17.4),(71834,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71834,37.47,0.46,312,26779,70,NULL,NULL,'2MASX J10331341+1047594',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000144,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,158.3059583,10.79992,0.077,NULL,61049982650,953905978,14904780,17.4),(71835,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71835,38.07,0.21,410,26780,70,NULL,NULL,'2MASX J10331395+1639424',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,158.308125,16.66169,0.069,NULL,60958995268,952484301,14882567,16.9),(71836,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71836,37.31,0.46,290,26781,70,NULL,NULL,'2MASX J10331521+3535058',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000179,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,158.313417,35.58486,0,NULL,64046128346,1000720755,15636261,16.4),(71837,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71837,37.03,0.46,255,26782,70,NULL,NULL,'2MASX J10331620+0400102',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000151,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,158.317625,4.00278,0.041,NULL,61016339648,953380307,14896567,16.9),(71838,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71838,37.87,0.33,375,26783,70,NULL,NULL,'SDSS J103316.54+265947.3',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000191,NULL,'16.2g',0.35,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,158.3189583,26.9965,0.017,NULL,60476196658,944940572,14764696,16.2),(71839,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71839,36.74,0.14,222,26784,70,NULL,NULL,'2MASX J10331694+5643160',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000164,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,158.3204583,56.721,0,NULL,61967482741,968241917,15128779,16.8),(71840,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71840,38.02,0.46,401,26785,70,NULL,NULL,'2MASX J10331863+1038044',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000179,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,158.3277917,10.63447,0.081,NULL,61049934421,953905225,14904769,17.2),(71841,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71841,36.42,0.46,193,26786,70,NULL,NULL,'2MASX J10331900+6458098',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000084,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,158.329167,64.96956,0.013,NULL,62115706541,970557914,15164967,16.6),(71842,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71842,37.78,0.46,360,26787,70,NULL,NULL,'2MASX J10331941+2525073',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,158.3307917,25.41861,0,NULL,60472478827,944882481,14763788,17.6),(71843,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71843,36.4,0.46,191,26788,70,NULL,NULL,'SDSS J103319.79+580432.8',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',NULL,NULL,'15.4g',0.37,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,158.3325,58.07578,0,NULL,61946129544,967908274,15123566,15.4),(71844,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71844,36.91,0.46,241,26789,70,NULL,NULL,'2MASX J10331987+1109514',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,158.3327083,11.16433,0.081,NULL,61050109289,953907957,14904811,16.9),(71845,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71845,37.24,0.46,281,26790,70,NULL,NULL,'2MASX J10332101+0620254',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000164,NULL,'17.1g',NULL,NULL,NULL,NULL,NULL,NULL,1,158.337666667,6.34028,0.077,NULL,61060392115,954068626,14907322,17.1),(71846,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71846,37.47,0.33,313,26791,70,NULL,NULL,'2MASX J10332111+4802011',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000141,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,158.3380417,48.03369,0,NULL,64138484307,1002163817,15658809,17.2),(71847,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71847,36.86,0.46,236,26792,70,NULL,NULL,'2MASX J10332114+4404124',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,158.338125,44.07011,0,NULL,64141273521,1002207398,15659490,17.1),(71848,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71848,38.24,0.46,445,26793,70,NULL,NULL,'2MASX J10332139+0103122',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000088,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,158.339083,1.05339,0.149,NULL,61002375156,953162111,14893157,17.9),(71849,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71849,38.24,0.46,445,26794,70,NULL,NULL,'2MASX J10332334+0009292',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000089,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,158.34725,0.15808,0.145,NULL,60264682306,941635661,14713057,17.8),(71850,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71850,37.87,0.33,375,26795,70,NULL,NULL,'2MASX J10332392+2655063',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000165,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,158.349667,26.91853,0.021,NULL,60478091717,944970183,14765159,18.3),(71851,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71851,37.8,0.46,364,26796,70,NULL,NULL,'2MASX J10332411+1235193',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000189,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,158.3502917,12.58872,0.081,NULL,61171759715,955808745,14934511,16.5),(71852,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71852,37.99,0.46,397,26797,70,NULL,NULL,'SDSS J103324.76+111652.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,158.3532083,11.28117,0.081,NULL,61049236168,953894315,14904598,18.5),(71853,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71853,36.74,0.14,222,26798,70,NULL,NULL,'2MASX J10332730+5632320',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000189,NULL,'16.1g',0.34,NULL,NULL,NULL,NULL,NULL,1,158.3635,56.54233,0,NULL,61967027215,968234800,15128668,16.1),(71854,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71854,37.95,0.46,390,26799,70,NULL,NULL,'2MASX J10332853+4828041',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000191,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,158.368916667,48.46786,0,NULL,64137786089,1002152907,15658639,17.2),(71855,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71855,37.16,0.46,270,26800,70,NULL,NULL,'2MASX J10332875+6116041',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,158.3697083,61.26789,0,NULL,61944202106,967878157,15123096,17.5),(71856,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71856,33.27,0.49,45,26801,70,NULL,NULL,'ESO 501- G 013',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000117,NULL,'13.91',0.6,'S0^0^:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,158.3752083,-26.89753,NULL,NULL,41486506012,648226656,10128541,13.91),(71857,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71857,34.01,0.23,63.4,26801,74.4,NULL,NULL,'ESO 501- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71858,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71858,33.94,0.4,61.4,26801,NULL,NULL,'mean','ESO 501- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71859,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71859,34.24,0.45,70.4,26801,NULL,NULL,'K','ESO 501- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71860,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71860,36.92,0.46,242,26802,70,NULL,NULL,'2MASX J10333076+0915578',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,158.3782083,9.26628,0.025,NULL,61048703077,953885985,14904468,17.5),(71861,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71861,37.73,0.46,351,26803,70,NULL,NULL,'2MASX J10333123+2835222',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000165,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,158.380083333,28.58939,0.041,NULL,60474316427,944911194,14764237,16.9),(71862,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71862,37.15,0.46,269,26804,70,NULL,NULL,'2MASX J10333125+4151178',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000178,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,158.380083333,41.85503,0,NULL,64153867914,1002404186,15662565,17.1),(71863,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71863,37.29,0.46,287,26805,70,NULL,NULL,'2MASX J10333235+3105088',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,158.384875,31.08569,0.029,NULL,64081028823,1001266075,15644782,18),(71864,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71864,36.24,0.46,177,26806,70,NULL,NULL,'2MASX J10333273+1829540',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,158.386375,18.49844,0.037,NULL,60987452664,952928947,14889514,16.7),(71865,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71865,36.81,0.46,230,26807,70,NULL,NULL,'2MASX J10333299+3642248',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000217,NULL,'15.6g',0.55,NULL,NULL,NULL,NULL,NULL,1,158.387333333,36.70678,0.013,NULL,64046385100,1000724767,15636324,15.6),(71866,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71866,38.38,0.46,475,26808,70,NULL,NULL,'2MASX J10333540+1505547',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,158.397583333,15.09844,0.093,NULL,61179174062,955924594,14936321,17.6),(71867,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71867,33.18,0.49,43.3,26809,70,NULL,NULL,'NGC 3285',NULL,'2014MNRAS.445.2677S',2014,1,2.6,NULL,'G',0.000033,NULL,'13.05',1.5,'SB(s)a pec','in a pair',NULL,NULL,NULL,1,158.399333,-27.45444,0.193,NULL,41478913424,648108022,10126687,13.05),(71868,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71868,33.69,0.4,54.7,26809,NULL,NULL,'mean','NGC 3285',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71869,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71869,33.7,0.47,55,26809,NULL,NULL,'H','NGC 3285',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71870,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71870,33.74,0.46,56,26809,NULL,NULL,'J','NGC 3285',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71871,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71871,33.74,0.45,56.1,26809,NULL,NULL,'K','NGC 3285',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71872,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71872,33.98,0.38,62.5,26809,NULL,NULL,NULL,'NGC 3285',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71873,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71873,34.18,0.2,68.6,26809,74.4,NULL,NULL,'NGC 3285',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71874,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71874,34.22,0.43,69.7,26809,75,NULL,'3.6 micron, color corrected','NGC 3285',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71875,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71875,34.41,0.43,76.3,26809,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3285',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71876,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71876,37.2,0.46,275,26810,70,NULL,NULL,'2MASX J10333582+0259453',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',NULL,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,158.399375,2.99589,0.057,NULL,61015905020,953373515,14896461,16.3),(71877,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71877,37.76,0.46,357,26811,70,NULL,NULL,'2MASX J10333642+3903518',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000183,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,158.401917,39.06458,0,NULL,64117731140,1001839549,15653742,16.4),(71878,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71878,37.13,0.46,267,26812,70,NULL,NULL,'2MASX J10333644+4147088',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000179,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,158.4020417,41.78581,0,NULL,64153898680,1002404666,15662572,16.7),(71879,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71879,37.65,0.46,340,26813,70,NULL,NULL,'2MASX J10333658+3830188',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00016,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,158.402375,38.50522,0,NULL,64118283757,1001848183,15653877,16.6),(71880,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71880,35.81,0.33,145,26814,70,NULL,NULL,'2MASX J10333692+1142078',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000164,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,158.403875,11.70222,0.117,NULL,61037650963,953713296,14901770,16.3),(71881,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71881,36.71,0.46,219,26815,70,NULL,NULL,'2MASX J10333744+2146270',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000179,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,158.405916667,21.77433,0,NULL,60991232028,952988000,14890437,17.4),(71882,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71882,37.72,0.46,350,26816,70,NULL,NULL,'2MASX J10333768+6035072',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000179,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,158.406875,60.58528,0.009,NULL,61957297876,968082779,15126293,16.8),(71883,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71883,35.69,0.46,138,26817,70,NULL,NULL,'SDSS J103338.03+201432.6',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.0g',0.34,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,158.4085,20.24242,0.013,NULL,61001759605,953152493,14893007,16),(71884,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71884,38.34,0.27,465,26818,70,NULL,NULL,'2MASX J10333817+4409419',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000152,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,158.4092083,44.16175,0,NULL,64141303423,1002207865,15659497,17.4),(71885,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71885,37.28,0.46,286,26819,70,NULL,NULL,'2MASX J10334275+6028522',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000133,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,158.4282917,60.48108,0,NULL,61957333954,968083343,15126302,17.7),(71886,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71886,37.38,0.46,300,26820,70,NULL,NULL,'2MASX J10334312+2635330',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,158.42975,26.59269,0.009,NULL,60478682733,944979417,14765303,17.8),(71887,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71887,38.31,0.46,459,26821,70,NULL,NULL,'2MASX J10334598+1907290',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,158.44175,19.12483,0.057,NULL,60999244388,953113193,14892393,18),(71888,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71888,37.05,0.46,257,26822,70,NULL,NULL,'2MASX J10334603+2633330',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000179,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,158.441875,26.55933,0.009,NULL,60478679616,944979369,14765302,17.7),(71889,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71889,35.66,0.46,136,26823,70,NULL,NULL,'CGCG 313-025',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000169,NULL,'15.1g',0.6,'E','Isolated galaxy',NULL,NULL,NULL,1,158.445333,62.23706,0,NULL,61825686739,966026355,15094161,15.1),(71890,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71890,37.39,0.46,301,26824,70,NULL,NULL,'2MASX J10334719+5444170',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,158.446667,54.73803,0,NULL,61892201056,967065641,15110400,17.6),(71891,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71891,36.02,0.46,160,26825,70,NULL,NULL,'2MASX J10334738+1243576',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000187,NULL,'15.6g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,158.4475417,12.73283,0.117,NULL,61171700591,955807821,14934497,15.6),(71892,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71892,37.78,0.46,360,26826,70,NULL,NULL,'2MASX J10334873+1812185',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,158.453083,18.20506,0.077,NULL,60987402821,952928169,14889502,17.6),(71893,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71893,36.16,0.46,171,26827,70,NULL,NULL,'2MASX J10334951+1852495',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.86',0.32,NULL,NULL,NULL,NULL,NULL,1,158.456125,18.88053,0.045,NULL,60999205629,953112587,14892384,16.86),(71894,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71894,37.65,0.46,339,26828,70,NULL,NULL,'SDSS J103349.84+204247.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000131,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,158.4577083,20.71328,0.005,NULL,60998450013,953100781,14892199,18.4),(71895,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71895,37.64,0.33,337,26829,70,NULL,NULL,'2MASX J10335008+2351475',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000159,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,158.4585,23.86311,0.005,NULL,60946946670,952296041,14879625,16.9),(71896,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71896,36.74,0.14,222,26830,70,NULL,NULL,'SBS 1030+573S',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00013,NULL,'15.2g',0.58,'BrClG',NULL,NULL,NULL,NULL,1,158.463417,57.05594,0,NULL,61967555221,968243050,15128797,15.2),(71897,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71897,37.69,0.46,345,26831,70,NULL,NULL,'2MASX J10335181+1544206',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,158.465875,15.739,0.077,NULL,60958115827,952470559,14882352,18),(71898,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71898,37.47,0.33,313,26832,70,NULL,NULL,'SDSS J103352.56+475740.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000062,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,158.4690417,47.96128,0,NULL,64138500653,1002164072,15658813,18.2),(71899,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71899,38.34,0.33,466,26833,70,NULL,NULL,'2MASX J10335300+0441023',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,158.47075,4.68414,0.061,NULL,61013027901,953328560,14895758,16.8),(71900,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71900,34.14,0.43,67.3,26834,75,NULL,'3.6 micron, color + selection bias corrected','ESO 436- G 038',NULL,'2014MNRAS.444..527S',2014,1,0.9,NULL,'G',0.000023,NULL,'15.64',0.6,'Sd',NULL,NULL,NULL,NULL,1,158.4739583,-27.82917,0.165,NULL,41481478432,648148100,10127314,15.64),(71901,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71901,37.57,0.46,327,26835,70,NULL,NULL,'2MASX J10335404+5739569',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000155,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,158.4750417,57.66564,0,NULL,62001076915,968766826,15136981,17),(71902,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71902,37.74,0.46,354,26836,70,NULL,NULL,'2MASX J10335433+0419373',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000143,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,158.47625,4.32708,0.081,NULL,61018272210,953410503,14897039,17.7),(71903,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71903,38.34,0.46,466,26837,70,NULL,NULL,'2MASX J10335469+0118373',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,158.477833,1.31031,0.105,NULL,61002240689,953160010,14893125,17.8),(71904,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71904,37.65,0.46,338,26838,70,NULL,NULL,'2MASX J10335543+0133213',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,158.4809583,1.55581,0.065,NULL,61005855269,953216488,14894007,17.3),(71905,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71905,37.38,0.46,300,26839,70,NULL,NULL,'2MASX J10335675+2844121',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,158.4864583,28.73661,0.041,NULL,60474282209,944910659,14764229,17.2),(71906,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71906,36.95,0.46,245,26840,70,NULL,NULL,'SDSS J103356.80+285850.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000139,NULL,'17.8g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,158.486708333,28.98067,0.041,NULL,60474435287,944913051,14764266,17.8),(71907,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71907,34.33,0.49,73.5,26841,70,NULL,NULL,'MCG -01-27-019',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.30',0.6,NULL,NULL,NULL,NULL,NULL,1,158.48775,-8.24269,0.113,NULL,41769895295,652654613,10197728,15.3),(71908,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71908,37.64,0.33,337,26842,70,NULL,NULL,'2MASX J10335715+2351375',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.48',0.15,NULL,NULL,NULL,NULL,NULL,1,158.488167,23.86036,0,NULL,60946954245,952296160,14879627,18.48),(71909,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71909,38.36,0.46,471,26843,70,NULL,NULL,'SDSS J103357.19+202025.7',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000243,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,158.488291667,20.34047,0.013,NULL,61001735152,953152111,14893001,17.1),(71910,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71910,36.95,0.46,245,26844,70,NULL,NULL,'2MASX J10335846+2352345',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000176,NULL,'16.8g',0.28,'AGN',NULL,NULL,NULL,NULL,1,158.4937083,23.87636,0,NULL,60943525011,952242578,14878790,16.8),(71911,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71911,37.77,0.46,358,26845,70,NULL,NULL,'2MASX J10335876+4724249',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000169,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,158.494708333,47.40681,0,NULL,64139285456,1002176335,15659005,16.5),(71912,'IRAS','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71912,33.37,0.8,47.3,26846,75,NULL,'MAT, I','ESO 436- G 039',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'14.87',0.3,'Sbc: sp        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,158.496541667,-30.16789,0.137,NULL,41997812092,656215813,10253372,14.87),(71913,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71913,33.65,0.4,53.8,26846,NULL,NULL,'mean','ESO 436- G 039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71914,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71914,33.66,0.47,54,26846,NULL,NULL,'H','ESO 436- G 039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71915,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71915,33.67,0.45,54.3,26846,NULL,NULL,'K','ESO 436- G 039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71916,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71916,33.81,0.46,57.8,26846,NULL,NULL,'J','ESO 436- G 039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71917,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71917,33.82,0.43,57.9,26846,75,NULL,'MAT, I, raw','ESO 436- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71918,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71918,33.82,0.32,58,26846,85,NULL,'I, raw','ESO 436- G 039',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71919,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71919,33.82,0.43,58.1,26846,75,NULL,'MAT, I, cor','ESO 436- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71920,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71920,33.86,0.32,59.2,26846,85,NULL,'I, inv','ESO 436- G 039',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71921,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71921,33.9,0.11,60.4,26846,NULL,NULL,NULL,'ESO 436- G 039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71922,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71922,34.02,0.43,63.6,26846,75,NULL,'3.6 micron, color + selection bias corrected','ESO 436- G 039',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71923,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71923,34.02,0.43,63.8,26846,75,NULL,'MAT, I, inv','ESO 436- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71924,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71924,34.17,0.43,68.2,26846,75,NULL,'3.6 micron, color corrected','ESO 436- G 039',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71925,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71925,34.29,0.49,72.2,26846,75,NULL,'IR','ESO 436- G 039',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71926,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71926,34.39,0.2,75.5,26846,74.4,NULL,NULL,'ESO 436- G 039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71927,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71927,36.51,0.46,200,26847,70,NULL,NULL,'2MASX J10335941+0402293',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000178,NULL,'16.2g',0.36,'S0/a',NULL,NULL,NULL,NULL,1,158.4975417,4.04158,0.073,NULL,61018322735,953411292,14897051,16.2),(71928,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71928,37.48,0.46,314,26848,70,NULL,NULL,'2MASX J10340165+1620565',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,158.506875,16.34922,0.073,NULL,60958618033,952478406,14882475,17.6),(71929,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71929,36.41,0.46,192,26849,70,NULL,NULL,'2MASX J10340271+3552464',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000149,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,158.5114583,35.87958,0.017,NULL,64046060426,1000719694,15636245,16.9),(71930,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71930,37.22,0.33,278,26850,70,NULL,NULL,'2MASX J10340311+0713132',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.0002,NULL,'16.1g',0.31,'S0',NULL,NULL,NULL,NULL,1,158.513083,7.22028,0.053,NULL,61060605483,954071960,14907374,16.1),(71931,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71931,37.94,0.46,387,26851,70,NULL,NULL,'2MASX J10340323+2442371',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,158.5134583,24.71022,0,NULL,60472872654,944888635,14763884,18),(71932,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71932,38.21,0.46,439,26852,70,NULL,NULL,'2MASX J10340401+2533451',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000134,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,158.516667,25.56247,0,NULL,60470608403,944853256,14763332,18.1),(71933,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71933,38.34,0.33,466,26853,70,NULL,NULL,'SDSS J103404.40+044430.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000166,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,158.518375,4.74192,0.061,NULL,61012996310,953328067,14895751,18.2),(71934,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71934,37.56,0.46,325,26854,70,NULL,NULL,'2MASX J10340497+0951012',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,158.520583333,9.85033,0.061,NULL,61048477162,953882455,14904413,17.7),(71935,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71935,36.1,0.46,166,26855,70,NULL,NULL,'2MASX J10340521+0320029',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000153,NULL,'17.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,158.52175,3.33406,0.049,NULL,61015949508,953374211,14896472,17),(71936,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71936,37.22,0.33,278,26856,70,NULL,NULL,'2MASX J10340634+0712302',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,158.5265,7.20833,0.053,NULL,61060605914,954071967,14907374,17.6),(71937,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71937,37.72,0.46,350,26857,70,NULL,NULL,'2MASX J10340789+4248332',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000189,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,158.533041667,42.80919,0,NULL,64141919291,1002217488,15659648,16.8),(71938,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71938,37.06,0.46,258,26858,70,NULL,NULL,'2MASX J10340817+5930123',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,158.533875,59.50353,0,NULL,61948878757,967951230,15124237,17.2),(71939,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71939,37.95,0.46,389,26859,70,NULL,NULL,'2MASX J10340817+2724050',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000174,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,158.534166667,27.40136,0.033,NULL,60476275694,944941807,14764715,17.1),(71940,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71940,38.02,0.46,402,26860,70,NULL,NULL,'2MASX J10340884+5232384',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000144,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,158.536875,52.54397,0,NULL,61892063792,967063496,15110367,17.7),(71941,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71941,37.57,0.46,326,26861,70,NULL,NULL,'SDSS J103408.96+020745.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000121,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,158.537333,2.12942,0.049,NULL,61005960390,953218131,14894033,18.3),(71942,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71942,37.64,0.46,337,26862,70,NULL,NULL,'2MASX J10340900+1709345',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,158.5375417,17.15956,0.057,NULL,60959101763,952485965,14882593,NULL),(71943,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71943,35.04,0.33,102,26863,70,NULL,NULL,'CGCG 290-053',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000167,NULL,'15.3g',0.5,'E0',NULL,NULL,NULL,NULL,1,158.541166667,61.60778,0,NULL,61944473623,967882400,15123162,15.3),(71944,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71944,36.74,0.14,222,26864,70,NULL,NULL,'2MASX J10341052+5641103',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000175,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,158.543625,56.68631,0,NULL,61967490293,968242035,15128781,17.1),(71945,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71945,37.79,0.46,362,26865,70,NULL,NULL,'SDSS J103410.75+055201.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000135,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,158.544833,5.86697,0.049,NULL,61012867270,953326051,14895719,18.4),(71946,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71946,37.87,0.46,375,26866,70,NULL,NULL,'2MASX J10341215+4808394',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000184,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,158.550375,48.14411,0,NULL,64138269597,1002160462,15658757,17.2),(71947,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71947,29.44,0.43,7.7,26867,75,NULL,'3.6 micron, color + selection bias corrected','IC 2596',NULL,'2014MNRAS.444..527S',2014,1,1.2,NULL,'G',0.00015,NULL,'15.6',0.8,'SB(r)0/a',NULL,NULL,NULL,NULL,1,158.551917,-73.24014,0.525,NULL,39824151948,622252374,9722693,15.6),(71948,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71948,36.94,0.23,244,26868,70,NULL,NULL,'SDSS J103413.40+145733.8',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',NULL,NULL,'15.2g',0.61,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,158.555875,14.95939,0.069,NULL,61183407105,955990736,14937355,15.2),(71949,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71949,36.94,0.23,244,26869,70,NULL,NULL,'2MASX J10341354+1500235',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,158.5565,15.0065,0.085,NULL,61183396891,955990576,14937352,17.1),(71950,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71950,36.95,0.46,246,26870,70,NULL,NULL,'2MASX J10341387+3005244',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000161,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,158.5577083,30.09025,0.037,NULL,64080618081,1001259657,15644682,17.3),(71951,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71951,38.34,0.27,465,26871,70,NULL,NULL,'SDSS J103414.00+441011.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000142,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,158.558416667,44.16975,0,NULL,64141305172,1002207893,15659498,18.6),(71952,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71952,35.04,0.33,102,26872,70,NULL,NULL,'CGCG 290-054',NULL,'2015arXiv151105856S',2015,1,0.82,'UZC has V = 6192 +- 150 km/s.','G',0.000194,NULL,'14.4g',0.73,'E',NULL,NULL,NULL,NULL,1,158.5600417,61.6405,0,NULL,61944483567,967882555,15123164,14.4),(71953,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71953,36.47,0.46,197,26873,70,NULL,NULL,'2MASX J10341451+0204479',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000178,NULL,'16.2g',0.36,'AGN',NULL,NULL,NULL,NULL,1,158.5605417,2.07983,0.049,NULL,61005967236,953218238,14894034,16.2),(71954,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71954,38.13,0.46,423,26874,70,NULL,NULL,'2MASX J10341498+4255492',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00017,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,158.5625417,42.93047,0,NULL,64142446333,1002225723,15659776,17.4),(71955,'L(H{beta})-{sigma}','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71955,46.21,NULL,1589,26875,74.3,NULL,NULL,'WISP 206_0261',2.315,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,158.573167,-28.51383,0.165,NULL,41477859939,648091561,10126430,NULL),(71956,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71956,37.84,0.33,370,26876,70,NULL,NULL,'2MASX J10341775+1513375',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,158.574167,15.22725,0.089,NULL,61179216660,955925260,14936332,17.8),(71957,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71957,38.09,0.46,416,26877,70,NULL,NULL,'2MASX J10341790+2251105',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000165,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,158.574625,22.85297,0.009,NULL,60946674111,952291782,14879559,18.2),(71958,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71958,38.34,0.27,465,26878,70,NULL,NULL,'2MASX J10341802+4409372',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000136,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,158.5752083,44.16044,0,NULL,64141305481,1002207898,15659498,18),(71959,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71959,32.38,0.43,29.9,26879,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3281D',NULL,'2014MNRAS.444..527S',2014,1,2,'RC3 gives V = 5366 +- 19 km/sec.','G',0.000033,NULL,'14.63',0.4,'SB(s)d: sp','Group member',NULL,NULL,NULL,1,158.57925,-34.40342,0.329,NULL,41990122135,656095658,10251494,14.63),(71960,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71960,32.45,0.43,30.9,26879,75,NULL,'3.6 micron, color corrected','NGC 3281D',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71961,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71961,32.51,0.2,31.8,26879,74.4,NULL,NULL,'NGC 3281D',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71962,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71962,32.6,0.49,33.1,26879,75,NULL,'IR','NGC 3281D',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71963,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71963,33.19,0.12,43.5,26879,NULL,NULL,NULL,'NGC 3281D',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71964,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71964,37.6,0.46,331,26880,70,NULL,NULL,'2MASX J10341920+2402200',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000184,NULL,'18.31',0.13,NULL,NULL,NULL,NULL,NULL,1,158.58,24.03906,0,NULL,60943560907,952243139,14878799,18.31),(71965,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71965,36.74,0.14,222,26881,70,NULL,NULL,'2MASX J10341974+5644234',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000184,NULL,'15.8g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,158.582083,56.73992,0,NULL,61967497001,968242140,15128783,15.8),(71966,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71966,32.49,0.49,31.5,26882,75,NULL,'IR','UGC 05739',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000007,NULL,'14.5',0.3,'Im?','in a radial-velocity based grouping',NULL,NULL,NULL,1,158.5825,13.75458,0.065,NULL,61183688462,955995132,14937423,14.5),(71967,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71967,36.94,0.23,244,26883,70,NULL,NULL,'2MASX J10342003+1504445',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,158.5835417,15.07906,0.085,NULL,61179185804,955924778,14936324,16.9),(71968,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71968,37.35,0.46,295,26884,70,NULL,NULL,'2MASX J10342012+1331405',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,158.583833,13.52789,0.093,NULL,61185460150,956022814,14937856,NULL),(71969,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71969,36.71,0.46,220,26885,70,NULL,NULL,'2MASX J10342016+1202565',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000156,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,158.5840417,12.04914,0.073,NULL,61170834642,955794291,14934285,16.9),(71970,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71970,33.23,0.43,44.2,26886,75,NULL,'3.6 micron, color + selection bias corrected','ESO 436- G 040',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.000027,NULL,'14.69',0.5,'(R\')SB(rs)ab:  HII',NULL,NULL,NULL,NULL,1,158.589083,-32.18481,0.249,NULL,41984557269,656008707,10250136,14.69),(71971,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71971,34.05,0.4,64.6,26886,NULL,NULL,'mean','ESO 436- G 040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71972,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71972,34.1,0.47,66.1,26886,NULL,NULL,'H','ESO 436- G 040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71973,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71973,37.28,0.46,286,26887,70,NULL,NULL,'2MASX J10342137+1739585',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,158.589167,17.66631,0.049,NULL,60957884976,952466952,14882296,17.4),(71974,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71974,31.53,0.4,20.3,26888,75,NULL,NULL,'NGC 3252',NULL,'2008Ap.....51..336K',2008,1,2,'NED follows RC2 for NGC identification. See also UGC 05689.','G',0.00002,NULL,'14.12',0.6,'SBd? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,158.596417,73.76497,0.125,NULL,61376952660,959014885,14984607,14.12),(71975,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71975,31.59,0.4,20.8,26888,75,NULL,'B','NGC 3252',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71976,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71976,31.83,0.4,23.3,26888,NULL,NULL,'mean','NGC 3252',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71977,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71977,32.02,0.49,25.4,26888,75,NULL,'IR','NGC 3252',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71978,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71978,32.21,0.46,27.7,26888,NULL,NULL,'J','NGC 3252',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71979,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71979,32.26,0.47,28.3,26888,NULL,NULL,'H','NGC 3252',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71980,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71980,32.37,0.45,29.8,26888,NULL,NULL,'K','NGC 3252',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71981,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71981,36.94,0.23,244,26889,70,NULL,NULL,'2MASX J10342327+1502215',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,158.596875,15.03944,0.085,NULL,61183394155,955990533,14937352,17.3),(71982,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71982,36.26,0.46,178,26890,70,NULL,NULL,'CGCG 290-055',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000083,NULL,'15.0g',0.65,'E0',NULL,NULL,NULL,NULL,1,158.59975,59.3875,0,NULL,61948856450,967950882,15124232,15),(71983,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71983,37.54,0.46,322,26891,70,NULL,NULL,'2MASX J10342444+1006400',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,158.601875,10.11119,0.077,NULL,61051981222,953937206,14905268,17.9),(71984,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71984,36.74,0.14,222,26892,70,NULL,NULL,'SDSS J103424.53+571611.6',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000198,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,158.602208333,57.26989,0,NULL,62001120796,968767512,15136992,17),(71985,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71985,36.56,0.46,205,26893,70,NULL,NULL,'2MASX J10342469+4502212',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000156,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,158.6030417,45.03925,0.005,NULL,64133120129,1002080002,15657500,16.5),(71986,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71986,37.84,0.33,370,26894,70,NULL,NULL,'2MASX J10342556+1513365',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,158.606416667,15.22672,0.089,NULL,61179187376,955924802,14936325,17.9),(71987,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71987,37.09,0.46,262,26895,70,NULL,NULL,'2MASX J10342751+4240292',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000149,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,158.614625,42.67489,0,NULL,64141976493,1002218382,15659662,17),(71988,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71988,37.39,0.46,301,26896,70,NULL,NULL,'2MASX J10342785+4528072',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000163,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,158.616083,45.46858,0,NULL,64133193049,1002081141,15657517,17),(71989,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71989,37.5,0.33,316,26897,70,NULL,NULL,'2MASX J10342835+4015442',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,158.618,40.26236,0,NULL,64116347901,1001817935,15653405,17),(71990,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71990,35.27,0.46,113,26898,70,NULL,NULL,'2MASX J10342869+1026580',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000099,NULL,'16.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,158.6195,10.44944,0.081,NULL,61051781811,953934090,14905220,16.3),(71991,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71991,37.4,0.46,301,26899,70,NULL,NULL,'2MASX J10342873+0447069',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000149,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,158.61975,4.78539,0.061,NULL,61012986961,953327921,14895748,16.8),(71992,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71992,32.61,0.2,33.3,26900,74.4,NULL,NULL,'UGC 05738',NULL,'2013AJ....146...86T',2013,1,0.87,NULL,'G',0.00003,NULL,'14.1g',0.66,'SABd','in a pair',NULL,NULL,NULL,1,158.62425,35.25678,0.017,NULL,64044196925,1000690576,15635790,14.1),(71993,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71993,35.42,0.46,121,26901,70,NULL,NULL,'CGCG 212-024',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000183,NULL,'15.4g',0.47,'E','Pair member (points to parent)',NULL,NULL,NULL,1,158.624375,39.61544,0,NULL,64117231051,1001831735,15653620,15.4),(71994,'TRGB','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71994,27.6,0.15,3.31,26902,NULL,NULL,'I','BK 06N',NULL,'2009AJ....138..332J',2009,1,1,NULL,'G',NULL,NULL,'16.7:',0.8,'dwarf Sph',NULL,NULL,NULL,NULL,1,158.620833,66.00833,0.021,NULL,62116853640,970575838,15165247,16.7),(71995,'TRGB','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71995,27.6,0.1,3.31,26902,74.4,NULL,NULL,'BK 06N',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71996,'TRGB','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,71996,27.93,NULL,3.85,26902,NULL,NULL,NULL,'BK 06N',NULL,'2000A&A...363..117K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71997,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71997,37.58,0.46,328,26903,70,NULL,NULL,'2MASX J10343067+1831050',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,158.6277917,18.518,0.057,NULL,60988275904,952941811,14889715,17.9),(71998,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71998,37.9,0.46,381,26904,70,NULL,NULL,'2MASX J10343251+2704130',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,158.635417,27.07031,0.029,NULL,60476168412,944940131,14764689,18.6),(71999,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',71999,37.89,0.46,379,26905,70,NULL,NULL,'2MASX J10343265+2339550',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000172,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,158.636,23.66536,0,NULL,60943628531,952244195,14878815,17.8),(72000,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72000,37.49,0.46,315,26906,70,NULL,NULL,'SDSS J103432.90+191313.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'18.2g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,158.637125,19.22056,0.057,NULL,60999295443,953113991,14892406,18.2),(72001,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72001,38.02,0.33,402,26907,70,NULL,NULL,'2MASX J10343327+1700192',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,158.638708333,17.00533,0.053,NULL,60959142187,952486596,14882603,16.9),(72002,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72002,37.34,0.46,293,26908,70,NULL,NULL,'SDSS J103435.30+093123.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,158.647083,9.52328,0.045,NULL,61049104400,953892256,14904566,18),(72003,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72003,33.78,0.51,57,26909,70,NULL,NULL,'2MASX J10343568-2834048',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000087,NULL,'14.58',0.26,'S0(5)','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,158.648625,-28.56811,0.165,NULL,41477851239,648091425,10126428,14.58),(72004,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72004,34.34,0.25,73.8,26909,74.4,NULL,NULL,'2MASX J10343568-2834048',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72005,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72005,37.42,0.46,305,26910,70,NULL,NULL,'2MASX J10343672+5759553',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,158.653,57.99875,0,NULL,62000836720,968763073,15136923,17.9),(72006,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72006,32.98,0.47,39.4,26911,NULL,NULL,'H','NGC 3285B',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000033,NULL,'13.86',1.1,'SB(rs)b        HII','in a pair',NULL,NULL,NULL,1,158.653667,-27.65294,0.177,NULL,41479315405,648114303,10126785,13.86),(72007,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72007,33.08,0.43,41.3,26911,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3285B',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72008,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72008,33.12,0.46,42,26911,NULL,NULL,'J','NGC 3285B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72009,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72009,33.26,0.45,44.8,26911,NULL,NULL,'K','NGC 3285B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72010,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72010,33.3,0.4,45.7,26911,NULL,NULL,'mean','NGC 3285B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72011,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72011,38.36,0.46,470,26912,70,NULL,NULL,'2MASX J10343741+1135230',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000167,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,158.655833,11.58964,0.125,NULL,61049184525,953893508,14904586,18.2),(72012,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72012,35.66,0.46,136,26913,70,NULL,NULL,'CGCG 037-081',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00006,NULL,'15.7g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,158.6642917,6.64158,0.077,NULL,61060235159,954066174,14907283,15.7),(72013,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72013,38.27,0.46,450,26914,70,NULL,NULL,'2MASX J10344004+4754486',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000149,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,158.6667917,47.91356,0,NULL,64138472711,1002163636,15658806,17.6),(72014,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72014,37.57,0.46,326,26915,70,NULL,NULL,'2MASX J10344079+1333403',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000146,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,158.67,13.56114,0.065,NULL,61185463973,956022874,14937857,17.9),(72015,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72015,35.38,0.27,119,26916,70,NULL,NULL,'CGCG 240-056',NULL,'2015arXiv151105856S',2015,1,0.88,NULL,'G',0.00009,NULL,'15.0g',0.47,'S0',NULL,NULL,NULL,NULL,1,158.671625,44.62536,0,NULL,64140538464,1002195913,15659311,15),(72016,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72016,38.02,0.33,402,26917,70,NULL,NULL,'2MASX J10344156+1700133',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,158.673417,17.00364,0.057,NULL,60959145153,952486643,14882603,17.5),(72017,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72017,37.16,0.46,271,26918,70,NULL,NULL,'2MASX J10344170+3801167',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,158.673833,38.02122,0,NULL,64117895218,1001842112,15653783,17.3),(72018,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72018,39.38,0.46,751,26919,70,NULL,NULL,'2MASX J10344207+4606261',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,158.6754583,46.10731,0,NULL,64135546182,1002117909,15658092,17.8),(72019,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72019,32.19,0.4,27.4,26920,NULL,NULL,'mean','NGC 3279',NULL,'2007A&A...465...71T',2007,1,2.03,'HOLM 201B,C are stars.','G',0.000009,NULL,'13.4g',0.47,'Scd            HII',NULL,NULL,NULL,NULL,1,158.678333,11.19733,0.113,NULL,61049999451,953906241,14904785,13.4),(72020,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72020,32.27,0.46,28.4,26920,NULL,NULL,'J','NGC 3279',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72021,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72021,32.3,0.47,28.9,26920,NULL,NULL,'H','NGC 3279',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72022,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72022,32.35,0.4,29.5,26920,NULL,NULL,NULL,'NGC 3279',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72023,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72023,32.41,0.45,30.4,26920,NULL,NULL,'K','NGC 3279',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72024,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72024,32.5,0.43,31.6,26920,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3279',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72025,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72025,32.54,0.46,32.2,26920,NULL,NULL,'Malmquist cor.','NGC 3279',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72026,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72026,32.58,0.4,32.8,26920,75,NULL,NULL,'NGC 3279',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72027,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72027,32.59,0.43,32.9,26920,75,NULL,'3.6 micron, color corrected','NGC 3279',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72028,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72028,32.62,0.2,33.4,26920,74.4,NULL,NULL,'NGC 3279',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72029,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72029,32.69,0.49,34.5,26920,75,NULL,'IR','NGC 3279',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72030,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72030,32.78,0.41,35.9,26920,NULL,NULL,NULL,'NGC 3279',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72031,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72031,33.38,NULL,47.5,26920,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 3279',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72032,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72032,33.4,NULL,47.8,26920,NULL,NULL,'Dipole + Quadrupole','NGC 3279',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72033,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72033,33.4,NULL,47.9,26920,NULL,NULL,NULL,'NGC 3279',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72034,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72034,33.41,NULL,48,26920,NULL,NULL,'Dipole','NGC 3279',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72035,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72035,37.54,0.46,321,26921,70,NULL,NULL,'2MASX J10344346+0336352',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00018,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,158.681166667,3.60981,0.045,NULL,61017872406,953404256,14896941,16.5),(72036,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72036,36.16,0.46,171,26922,70,NULL,NULL,'SDSS J103443.62+050213.1',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,158.6817917,5.037,0.065,NULL,61013053877,953328966,14895765,17.1),(72037,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72037,37.97,0.46,392,26923,70,NULL,NULL,'2MASX J10344542+6227323',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,158.6890417,62.45903,0,NULL,61826121052,966033141,15094267,17.2),(72038,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72038,37.58,0.46,328,26924,70,NULL,NULL,'2MASX J10344557+3448368',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.60',0.12,NULL,NULL,NULL,NULL,NULL,1,158.689875,34.81022,0.013,NULL,64051985010,1000812265,15637691,18.6),(72039,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72039,30.27,0.4,11.3,26925,75,NULL,'B','UGC 05740',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000013,NULL,'15.1',1.2,'SABm',NULL,NULL,NULL,NULL,1,158.690833,50.76833,0,NULL,64123040567,1001922508,15655039,15.1),(72040,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72040,32.05,0.43,25.7,26925,75,NULL,'3.6 micron, color + selection bias corrected','UGC 05740',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72041,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72041,37.52,0.33,319,26926,70,NULL,NULL,'2MASX J10344620+0344132',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000184,NULL,'16.1g',0.4,'E0',NULL,NULL,NULL,NULL,1,158.6925417,3.737,0.045,NULL,61018595709,953415557,14897118,16.1),(72042,'Tully est','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72042,31.57,0.8,20.6,26927,75,NULL,'B','NGC 3287',NULL,'1988NBGC.C....0000T',1988,1,2.1,'The 2MASS position is 9 arcsec northwest of the center of the bar.','G',0.00002,NULL,'12.89',1,'SB(s)d         HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,158.697083,21.64828,0.013,NULL,60990812633,952981447,14890335,12.89),(72043,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72043,30.67,0.43,13.6,26927,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3287',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72044,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72044,30.77,0.43,14.3,26927,75,NULL,'3.6 micron, color corrected','NGC 3287',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72045,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72045,30.85,0.2,14.8,26927,74.4,NULL,NULL,'NGC 3287',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72046,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72046,31.57,0.47,20.6,26927,NULL,NULL,'H','NGC 3287',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72047,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72047,31.64,0.46,21.2,26927,NULL,NULL,'J','NGC 3287',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72048,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72048,31.7,0.45,21.9,26927,NULL,NULL,'K','NGC 3287',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72049,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72049,32.09,0.4,26.2,26927,NULL,NULL,'mean','NGC 3287',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72050,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72050,33.09,0.23,41.5,26928,74.4,NULL,NULL,'ESO 436- G 044',NULL,'2013AJ....146...86T',2013,1,1.1,'ESO-LV has two entries for this object.','G',0.000057,NULL,'13.87',0.8,'S0(2)','Pair member (points to parent)',NULL,NULL,NULL,1,158.6977917,-28.49633,0.165,NULL,41477843642,648091306,10126426,13.87),(72051,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72051,33.48,0.4,49.8,26928,NULL,NULL,'mean','ESO 436- G 044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72052,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72052,33.85,0.45,58.9,26928,NULL,NULL,'K','ESO 436- G 044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72053,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72053,37.99,0.46,395,26929,70,NULL,NULL,'2MASX J10344762+0204392',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,158.6985,2.07769,0.045,NULL,61005706843,953214169,14893971,17.8),(72054,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72054,38.41,0.46,481,26930,70,NULL,NULL,'SDSS J103448.24+005649.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000081,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,158.701,0.94708,0.145,NULL,60264508749,941632949,14713014,18.3),(72055,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72055,36.74,0.14,222,26931,70,NULL,NULL,'2MASX J10344948+5700534',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000192,NULL,'16.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,158.706417,57.01489,0,NULL,61967264953,968238514,15128726,16.1),(72056,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72056,35.03,0.46,101,26932,70,NULL,NULL,'CGCG 009-083',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000037,NULL,'15.3g',0.47,'E/S0',NULL,NULL,NULL,NULL,1,158.71075,0.67639,0.157,NULL,60264554087,941633657,14713025,15.3),(72057,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72057,33.14,0.46,42.5,26933,NULL,NULL,'J','ESO 436- G 046',NULL,'2007A&A...465...71T',2007,1,2.2,NULL,'G',0.00003,NULL,'13.42',1.7,'SB(rs)b        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,158.710666667,-28.583,0.165,NULL,41477821229,648090956,10126421,13.42),(72058,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72058,33.15,0.47,42.7,26933,NULL,NULL,'H','ESO 436- G 046',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72059,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72059,33.27,0.45,45.1,26933,NULL,NULL,'K','ESO 436- G 046',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72060,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72060,33.68,0.4,54.5,26933,NULL,NULL,'mean','ESO 436- G 046',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72061,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72061,34.38,0.23,75.2,26934,74.4,NULL,NULL,'ESO 436- G 045',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000047,NULL,'15.05',0.6,'N','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,158.711833,-28.51269,0.165,NULL,41477844947,648091327,10126426,15.05),(72062,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:46','1','SN 1993B',NULL,72062,36.71,0.16,206,26935,74.2,NULL,'SALT 2','[MH93a] 103235.1-341103',0.069,'2010ApJ...716..712A',2010,1,0.34,NULL,'G',NULL,NULL,'16.80',0.24,'SBb',NULL,NULL,NULL,NULL,1,158.717,-34.44311,0.309,NULL,41989607150,656087611,10251368,16.8),(72063,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:46','1','SN 1993B',NULL,72063,37.24,0.28,262,26935,72,NULL,NULL,'[MH93a] 103235.1-341103',0.069,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72064,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:46','1','SN 1993B',NULL,72064,37.31,0.19,271,26935,70,NULL,'SALT 2','[MH93a] 103235.1-341103',0.069,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72065,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:46','1','SN 1993B',NULL,72065,37.35,0.2,275,26935,73.8,NULL,'SALT 2 (SNANA)','[MH93a] 103235.1-341103',0.0708,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72066,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:46','1','SN 1993B',NULL,72066,37.39,0.12,281,26935,65,NULL,'SALT2','[MH93a] 103235.1-341103',0.069,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72067,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:46','1','SN 1993B',NULL,72067,37.33,0.08,292,26935,74.4,NULL,NULL,'[MH93a] 103235.1-341103',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72068,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:46','1','SN 1993B',NULL,72068,37.5,0.05,295,26935,72,NULL,NULL,'[MH93a] 103235.1-341103',0.069,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72069,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:46','1','SN 1993B',NULL,72069,37.39,0.17,301,26935,70.8,NULL,NULL,'[MH93a] 103235.1-341103',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72070,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:46','1','SN 1993B',NULL,72070,37.56,0.17,305,26935,65,NULL,'SALT2','[MH93a] 103235.1-341103',0.069,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72071,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:46','1','SN 1993B',NULL,72071,37.57,0.15,306,26935,70,NULL,'SALT','[MH93a] 103235.1-341103',0.069,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72072,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:46','1','SN 1993B',NULL,72072,37.6,0.05,311,26935,70,NULL,NULL,'[MH93a] 103235.1-341103',0.069,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72073,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:46','1','SN 1993B',NULL,72073,37.78,0.15,315,26935,65,NULL,'MLCS2k2','[MH93a] 103235.1-341103',0.069,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72074,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:46','1','SN 1993B',NULL,72074,37.66,0.12,319,26935,65,NULL,'MLCS2k2','[MH93a] 103235.1-341103',0.069,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72075,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:46','1','SN 1993B',NULL,72075,37.73,0.12,329,26935,65,NULL,'SALT','[MH93a] 103235.1-341103',0.069,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72076,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:46','1','SN 1993B',NULL,72076,37.74,0.17,330,26935,65,NULL,'MLCS17','[MH93a] 103235.1-341103',0.069,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72077,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:46','1','SN 1993B',NULL,72077,37.6,0.09,331,26935,60,NULL,'M(V) = -19.47 mag','[MH93a] 103235.1-341103',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72078,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:46','1','SN 1993B',NULL,72078,37.61,0.1,333,26935,60,NULL,'M(I) = -19.19 mag','[MH93a] 103235.1-341103',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72079,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:46','1','SN 1993B',NULL,72079,37.78,0.15,337,26935,65,NULL,'MLCS2k2','[MH93a] 103235.1-341103',0.069,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72080,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:46','1','SN 1993B',NULL,72080,37.78,0.19,337,26935,65,NULL,NULL,'[MH93a] 103235.1-341103',0.069,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72081,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:46','1','SN 1993B',NULL,72081,37.8,0.17,339,26935,65,NULL,'MLCS31','[MH93a] 103235.1-341103',0.069,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72082,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:46','1','SN 1993B',NULL,72082,37.67,0.14,342,26935,60,NULL,NULL,'[MH93a] 103235.1-341103',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72083,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:46','1','SN 1993B',NULL,72083,37.7,0.11,347,26935,60,NULL,'M(B) = -19.48 mag','[MH93a] 103235.1-341103',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72084,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:46','1','SN 1993B',NULL,72084,37.85,0.02,347,26935,65,NULL,'SALT','[MH93a] 103235.1-341103',0.069,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72085,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:46','1','SN 1993B',NULL,72085,38.01,0.06,374,26935,70,NULL,'SALT 2','[MH93a] 103235.1-341103',0.069,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72086,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72086,38.2,0.46,436,26936,70,NULL,NULL,'2MASX J10345212+1446373',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,158.7172083,14.77706,0.089,NULL,61183539028,955992797,14937387,17.7),(72087,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72087,38.23,0.46,442,26937,70,NULL,NULL,'SDSS J103452.19+051030.6',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000179,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,158.7175,5.17519,0.057,NULL,61013062768,953329105,14895767,17.5),(72088,'CMD','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72088,19.93,0.1,0.0968,26938,NULL,NULL,NULL,'UMa Dwarf',NULL,'2008A&A...487..103O',2008,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'dSph','Group member',NULL,NULL,NULL,1,158.72,51.92,0.009,1,63988385323,999818520,15622164,NULL),(72089,'CMD','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72089,20,NULL,0.1,26938,NULL,NULL,NULL,'UMa Dwarf',NULL,'2008AJ....135.1361D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72090,'CMD','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72090,20,NULL,0.1,26938,NULL,NULL,NULL,'UMa Dwarf',NULL,'2005ApJ...626L..85W',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72091,'CMD','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72091,20,NULL,0.1,26938,NULL,NULL,NULL,'UMa Dwarf',NULL,'2008A&A...477..139L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72092,'CMD','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72092,20.11,0.04,0.105,26938,NULL,NULL,NULL,'UMa Dwarf',NULL,'2012ApJ...753L..21B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72093,'CMD','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72093,20.13,0.18,0.106,26938,NULL,NULL,NULL,'UMa Dwarf',NULL,'2007ApJ...670..313S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72094,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72094,37.04,0.46,256,26939,70,NULL,NULL,'2MASX J10345326+1039056',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000151,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,158.721958333,10.65169,0.081,NULL,61049914087,953904907,14904764,16.8),(72095,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72095,38,0.46,398,26940,70,NULL,NULL,'2MASX J10345338+1604153',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,158.72225,16.07111,0.069,NULL,60958928762,952483261,14882550,17),(72096,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72096,35.38,0.27,119,26941,70,NULL,NULL,'CGCG 240-058',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000093,NULL,'14.2g',0.3,'E0',NULL,NULL,NULL,NULL,1,158.722333,45.26931,0,NULL,64133172680,1002080823,15657512,14.2),(72097,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72097,37.03,0.46,255,26942,70,NULL,NULL,'2MASX J10345377+6041283',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000172,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,158.7239583,60.69114,0,NULL,61957411339,968084552,15126321,16.4),(72098,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72098,37.52,0.33,319,26943,70,NULL,NULL,'SDSS J103453.98+034351.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000172,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,158.7249583,3.73097,0.045,NULL,61018566095,953415095,14897110,18),(72099,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72099,37.95,0.46,389,26944,70,NULL,NULL,'2MASX J10345453+4508002',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00019,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,158.7272083,45.13344,0,NULL,64133088648,1002079510,15657492,17.1),(72100,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72100,37.64,0.46,337,26945,70,NULL,NULL,'2MASX J10345522+4202552',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,158.730125,42.04875,0,NULL,64153328686,1002395760,15662433,17.7),(72101,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72101,37.03,0.46,255,26946,70,NULL,NULL,'2MASX J10345542+3448140',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000179,NULL,'16.0g',0.43,NULL,NULL,NULL,NULL,NULL,1,158.730916667,34.80375,0.013,NULL,64051986426,1000812287,15637691,16),(72102,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72102,37.87,0.46,374,26947,70,NULL,NULL,'2MASX J10345585+4505022',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,158.7325,45.08392,0,NULL,64133103018,1002079734,15657495,17.8),(72103,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72103,36.22,0.46,175,26948,70,NULL,NULL,'2MASX J10345834+1352487',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000188,NULL,'16.1g',0.35,'E0',NULL,NULL,NULL,NULL,1,158.743041667,13.88025,0.065,NULL,61183640778,955994387,14937412,16.1),(72104,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72104,37.36,0.46,297,26949,70,NULL,NULL,'SDSS J103458.68+161602.6',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.8g',0.28,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,158.744541667,16.26742,0.069,NULL,60958746802,952480418,14882506,16.8),(72105,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72105,37.27,0.46,285,26950,70,NULL,NULL,'2MASX J10345889+0301072',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000155,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,158.74525,3.01864,0.017,NULL,61017175013,953393359,14896771,17.1),(72106,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72106,38.02,0.33,401,26951,70,NULL,NULL,'2MASX J10350064+0035393',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000084,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,158.752667,0.59417,0.157,NULL,60264093985,941626468,14712913,17.2),(72107,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72107,36.81,0.46,230,26952,70,NULL,NULL,'2MASX J10350102+3732418',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,158.754041667,37.54503,0,NULL,64115931921,1001811436,15653303,17.3),(72108,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72108,37.29,0.46,287,26953,70,NULL,NULL,'2MASX J10350201+2254116',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000147,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,158.7582917,22.90328,0.029,NULL,60943825744,952247277,14878863,17.6),(72109,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72109,37.44,0.46,308,26954,70,NULL,NULL,'SDSS J103502.01+171632.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,158.758417,17.27569,0.057,NULL,60959833234,952497394,14882771,18.4),(72110,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72110,37.38,0.33,300,26955,70,NULL,NULL,'2MASX J10350280+2256256',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,158.761833333,22.94053,0.029,NULL,60943805327,952246958,14878858,17.2),(72111,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72111,35.38,0.27,119,26956,70,NULL,NULL,'CGCG 240-059',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000087,NULL,'15.0g',0.64,'E0',NULL,NULL,NULL,NULL,1,158.770125,44.74575,0,NULL,64140483361,1002195052,15659297,15),(72112,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72112,36.77,0.46,225,26957,70,NULL,NULL,'2MASX J10350576+5430535',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000141,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,158.773875,54.51497,0,NULL,61960373476,968130835,15127044,16.7),(72113,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72113,37.61,0.46,333,26958,70,NULL,NULL,'2MASX J10350677+4059537',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00017,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,158.7780417,40.99814,0,NULL,64152976340,1002390255,15662347,17.1),(72114,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72114,37.32,0.46,291,26959,70,NULL,NULL,'2MASX J10350710+3420350',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00018,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,158.7795417,34.34303,0.017,NULL,64052235611,1000816181,15637752,16.5),(72115,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72115,37.81,0.46,364,26960,70,NULL,NULL,'SDSS J103507.32+304616.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000138,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,158.7805,30.77136,0.033,NULL,64047878937,1000748108,15636689,18.2),(72116,'IRAS','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72116,32.84,0.8,36.9,26961,75,NULL,'HMCL, I','NGC 3366',NULL,'1997ApJS..109..333W',1997,1,2.2,'Confused HIPASS source','G',0.000023,NULL,'12.03',1.1,'SB(rs)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,158.7845,-43.69181,0.561,NULL,42130387983,658287312,10285739,12.03),(72117,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72117,33.04,0.4,40.5,26961,75,NULL,'HMCL, I, raw','NGC 3366',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72118,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72118,33.11,0.4,41.9,26961,NULL,NULL,NULL,'NGC 3366',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72119,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72119,33.23,0.4,44.3,26961,75,NULL,'HMCL, I, cor','NGC 3366',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72120,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72120,33.3,0.4,45.6,26961,75,NULL,'HMCL, I, inv','NGC 3366',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72121,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72121,34.45,0.69,77.5,26962,100,NULL,'mid-IR','UGC 05746',NULL,'2013ApJ...771...88L',2013,1,1.4,NULL,'G',0.000027,NULL,'14.1g',0.9,'SBab',NULL,NULL,NULL,NULL,1,158.7857917,45.08464,0,NULL,64133101339,1002079708,15657495,14.1),(72122,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72122,34.75,0.37,89.2,26962,NULL,NULL,NULL,'UGC 05746',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72123,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72123,34.88,0.35,94.7,26962,NULL,NULL,'Malmquist cor.','UGC 05746',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72124,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72124,35.05,0.2,102,26962,74.4,NULL,NULL,'UGC 05746',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72125,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72125,35.09,0.47,104,26962,NULL,NULL,'H','UGC 05746',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72126,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72126,35.17,0.46,108,26962,NULL,NULL,'J','UGC 05746',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72127,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72127,35.19,0.45,109,26962,NULL,NULL,'K','UGC 05746',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72128,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72128,35.24,0.4,112,26962,NULL,NULL,'mean','UGC 05746',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72129,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72129,38.46,0.46,492,26963,70,NULL,NULL,'2MASX J10351094+4502171',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000168,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,158.7955,45.03806,0.005,NULL,64133098721,1002079667,15657494,18),(72130,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72130,35.2,0.46,110,26964,70,NULL,NULL,'CGCG 212-026',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.000173,NULL,'14.9g',0.65,'E',NULL,NULL,NULL,NULL,1,158.796291667,42.77042,0,NULL,64141974916,1002218358,15659661,14.9),(72131,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72131,37.74,0.46,354,26965,70,NULL,NULL,'SDSS J103512.91+435409.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000117,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,158.803875,43.90253,0,NULL,64141346761,1002208543,15659508,18.4),(72132,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72132,35.87,0.33,149,26966,70,NULL,NULL,'CGCG 212-027',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.00017,NULL,'15.1g',0.56,'S0^-',NULL,NULL,NULL,NULL,1,158.804666667,38.52508,0,NULL,64118262988,1001847859,15653872,15.1),(72133,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72133,37.01,0.46,253,26967,70,NULL,NULL,'2MASX J10351535+0455268',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000174,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,158.814,4.92411,0.065,NULL,61014959481,953358741,14896230,16.7),(72134,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72134,37.91,0.46,382,26968,70,NULL,NULL,'2MASX J10351626+4626431',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000145,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,158.81775,46.44531,0,NULL,64135606689,1002118854,15658107,17.2),(72135,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72135,35.87,0.33,149,26969,70,NULL,NULL,'2MASX J10351654+3848310',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00017,NULL,'16.1g',0.31,'S0^-',NULL,NULL,NULL,NULL,1,158.818791667,38.80856,0,NULL,64117346307,1001833536,15653649,16.1),(72136,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72136,33.5,0.69,50.1,26970,100,NULL,'mid-IR','MCG -01-27-021',NULL,'2013ApJ...771...88L',2013,1,1.2,NULL,'G',0.000017,NULL,'14.59',0.6,'SB(s)a pec?',NULL,NULL,NULL,NULL,1,158.8205,-7.24711,0.113,NULL,41803754384,653183662,10205994,14.59),(72137,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72137,34.42,0.4,76.4,26970,NULL,NULL,'mean','MCG -01-27-021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72138,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72138,34.54,0.47,81,26970,NULL,NULL,'H','MCG -01-27-021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72139,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72139,37.5,0.33,316,26971,70,NULL,NULL,'2MASX J10351872+4012500',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000186,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,158.827875,40.21383,0,NULL,64116343240,1001817863,15653404,17.2),(72140,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72140,34.53,0.35,80.6,26972,NULL,NULL,'Malmquist cor.','ESO 264- G 009',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.91',0.2,'Sb:',NULL,NULL,NULL,NULL,1,158.8280417,-44.174,0.561,NULL,42130730213,658292659,10285822,15.91),(72141,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72141,34.63,0.49,84.3,26972,75,NULL,'IR','ESO 264- G 009',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72142,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72142,34.7,0.33,87.1,26972,NULL,NULL,NULL,'ESO 264- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72143,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72143,34.74,0.2,88.7,26972,74.4,NULL,NULL,'ESO 264- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72144,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72144,37.4,0.46,302,26973,70,NULL,NULL,'2MASX J10351916+0352258',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000181,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,158.829875,3.87397,0.065,NULL,61018587193,953415424,14897116,16.8),(72145,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72145,38.13,0.46,422,26974,70,NULL,NULL,'SDSS J103520.02+082750.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000161,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,158.833458333,8.46417,0.033,NULL,61058694269,954042097,14906907,18.2),(72146,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72146,33.7,0.4,55,26975,75,NULL,'Edat, raw','ESO 501- G 021',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000047,NULL,'14.55',0.3,'S0pec',NULL,NULL,NULL,NULL,1,158.835417,-27.36208,0.177,NULL,41479508432,648117319,10126833,14.55),(72147,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72147,33.72,0.4,55.4,26975,75,NULL,'Edat, cor','ESO 501- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72148,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72148,37.78,0.46,360,26976,70,NULL,NULL,'2MASX J10352135+0248198',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000199,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,158.838917,2.80556,0.041,NULL,61003312951,953176764,14893386,16.9),(72149,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72149,37.34,0.46,294,26977,70,NULL,NULL,'2MASX J10352140+1045551',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000182,NULL,'16.0g',0.4,'E0',NULL,NULL,NULL,NULL,1,158.8392917,10.76539,0.081,NULL,61049899596,953904681,14904760,16),(72150,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72150,33.75,0.43,56.3,26978,75,NULL,'3.6 micron, color + selection bias corrected','ESO 501- G 022',NULL,'2014MNRAS.444..527S',2014,1,1,NULL,'G',0.00003,NULL,'15.77',0.2,'Sdni',NULL,NULL,NULL,NULL,1,158.83975,-27.6955,0.169,NULL,41479223507,648112867,10126763,15.77),(72151,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72151,35.13,0.64,106,26979,70,NULL,NULL,'FAIRALL 1361',NULL,'2014MNRAS.445.2677S',2014,1,0.92,NULL,'G',0.00015,NULL,'16.0B',0.22,NULL,NULL,NULL,NULL,NULL,1,158.84275,-81.745,0.401,NULL,39752381134,621130955,9705171,16),(72152,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72152,37.11,0.46,265,26980,70,NULL,NULL,'2MASX J10352311+2955277',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000173,NULL,'16.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,158.8464583,29.92439,0.033,NULL,64080577563,1001259024,15644672,16.4),(72153,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72153,29.23,0.4,7,26981,73,NULL,'opt','UGCA 212',NULL,'2011A&A...532A.104N',2011,1,3.5,NULL,'G',0.000002,NULL,'13.2',2.8,'SB(s)dm','Group member, radial-velocity confirmed',NULL,NULL,'H_alpha Emission-Line Galaxy',1,158.846667,-24.75414,0.169,NULL,41485531349,648211427,10128303,13.2),(72154,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72154,29.23,0.37,7.01,26981,NULL,NULL,NULL,'UGCA 212',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72155,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72155,29.23,NULL,7.01,26981,NULL,NULL,NULL,'UGCA 212',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72156,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72156,30.76,0.4,14.2,26981,75,NULL,'B','UGCA 212',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72157,'IRAS','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72157,33.23,0.8,44.2,26982,75,NULL,'HMCL, I','ESO 437- G 004',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000017,NULL,'13.93',1.1,'SB(r)b         HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,158.846875,-28.31406,0.165,NULL,41481189014,648143578,10127243,13.93),(72158,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72158,33.19,0.4,43.5,26982,75,NULL,'HMCL, I, raw','ESO 437- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72159,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72159,33.32,0.4,46.1,26982,75,NULL,'HMCL, I, inv','ESO 437- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72160,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72160,33.41,0.43,48,26982,75,NULL,'3.6 micron, color + selection bias corrected','ESO 437- G 004',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72161,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72161,33.43,0.38,48.5,26982,NULL,NULL,NULL,'ESO 437- G 004',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72162,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72162,33.46,0.4,49.1,26982,75,NULL,'HMCL, I, cor','ESO 437- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72163,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72163,33.46,0.43,49.2,26982,75,NULL,'3.6 micron, color corrected','ESO 437- G 004',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72164,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72164,33.56,0.2,51.5,26982,74.4,NULL,NULL,'ESO 437- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72165,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72165,33.58,0.4,51.9,26982,NULL,NULL,'mean','ESO 437- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72166,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72166,33.58,0.47,51.9,26982,NULL,NULL,'H','ESO 437- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72167,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72167,33.6,0.46,52.4,26982,NULL,NULL,'J','ESO 437- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72168,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72168,33.6,0.45,52.6,26982,NULL,NULL,'K','ESO 437- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72169,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72169,33.87,0.12,59.6,26982,NULL,NULL,NULL,'ESO 437- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72170,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72170,37.3,0.46,288,26983,70,NULL,NULL,'2MASX J10352365+3503329',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.22',0.17,NULL,NULL,NULL,NULL,NULL,1,158.8487083,35.05911,0.013,NULL,64051798706,1000809354,15637646,18.22),(72171,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72171,37.65,0.46,338,26984,70,NULL,NULL,'2MASX J10352419+3711160',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000191,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,158.8507083,37.18789,0,NULL,64115933962,1001811468,15653304,16.9),(72172,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72172,38.05,0.46,408,26985,70,NULL,NULL,'SDSS J103524.39+255646.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,158.851667,25.94628,0.017,NULL,60470758601,944855603,14763368,18.6),(72173,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72173,36.88,0.46,237,26986,70,NULL,NULL,'2MASX J10352471+0416518',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000152,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,158.852875,4.281,0.073,NULL,61018393787,953412402,14897068,17.1),(72174,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72174,33.6,0.25,52.5,26987,74.4,NULL,NULL,'ESO 501- G 025',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.000043,NULL,'14.12',0.9,'SAB0^0^','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,158.854333333,-26.65711,NULL,NULL,41486071292,648219863,10128435,14.12),(72175,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72175,33.77,0.45,56.7,26987,NULL,NULL,'K','ESO 501- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72176,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72176,33.94,0.4,61.4,26987,NULL,NULL,'mean','ESO 501- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72177,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72177,37.38,0.33,300,26988,70,NULL,NULL,'2MASX J10352579+2303543',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000183,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,158.857583,23.06519,0.025,NULL,60944011039,952250172,14878908,17),(72178,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72178,38.04,0.46,406,26989,70,NULL,NULL,'2MASX J10352594+1215377',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000154,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,158.858208333,12.26061,0.077,NULL,61184462065,956007219,14937612,17.4),(72179,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72179,36.61,0.46,210,26990,70,NULL,NULL,'MCG +11-13-035a',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000109,NULL,'15.4g',0.47,'E0',NULL,NULL,NULL,NULL,1,158.8652083,64.15606,0.009,NULL,61837770783,966215168,15097112,15.4),(72180,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72180,36.8,0.46,229,26991,70,NULL,NULL,'2MASX J10352855+3631180',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000176,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,158.869083,36.52164,0.005,NULL,64045278869,1000707482,15636054,16.6),(72181,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72181,37.41,0.46,303,26992,70,NULL,NULL,'2MASX J10352898-0023595',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000111,NULL,'16.8g',0.26,'BLAGN',NULL,NULL,NULL,'Sy 1',1,158.870958333,-0.39978,0.113,NULL,40869973466,638593335,9978020,16.8),(72182,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72182,38.02,0.46,402,26993,70,NULL,NULL,'2MASX J10352920+1815273',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,158.871708333,18.25756,0.053,NULL,60987721299,952933145,14889580,16.9),(72183,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72183,37.44,0.46,307,26994,70,NULL,NULL,'2MASX J10353035+2322213',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,158.876375,23.3725,0.029,NULL,60943939807,952249059,14878891,17.5),(72184,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72184,37.88,0.46,376,26995,70,NULL,NULL,'2MASX J10353041+2538057',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00019,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,158.876667,25.63503,0.013,NULL,60470670280,944854223,14763347,16.6),(72185,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72185,36.79,0.64,228,26996,70,NULL,NULL,'2MASX J10353319-1314407',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,158.888291667,-13.24461,0.181,NULL,41839701392,653745334,10214770,15.5),(72186,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72186,37.51,0.46,318,26997,70,NULL,NULL,'2MASX J10353351+4416266',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000177,NULL,'16.4g',0.4,NULL,NULL,NULL,NULL,NULL,1,158.889625,44.27403,0,NULL,64141238434,1002206850,15659482,16.4),(72187,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72187,37.38,0.46,299,26998,70,NULL,NULL,'2MASX J10353417+4121460',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000147,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,158.8925417,41.36281,0,NULL,64153172836,1002393325,15662395,17.7),(72188,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72188,36.07,0.88,164,26999,70,NULL,NULL,'2MASX J10353526-4244213',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,158.896875,-42.73931,0.521,NULL,42128929115,658264517,10285383,15.5),(72189,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72189,38.49,0.46,498,27000,70,NULL,NULL,'2MASXi J1035355+233849',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,158.897917,23.64714,0,NULL,60944070456,952251100,14878923,17.9),(72190,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72190,38.07,0.46,412,27001,70,NULL,NULL,'2MASX J10353633+4047220',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00019,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,158.901417,40.78939,0,NULL,64148795879,1002324935,15661327,16.7),(72191,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72191,36.86,0.46,236,27002,70,NULL,NULL,'2MASX J10353641+5143026',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000137,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,158.90175,51.71728,0,NULL,63988476024,999819937,15622186,17.2),(72192,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72192,36.66,0.46,214,27003,70,NULL,NULL,'2MASX J10353672+3928070',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000181,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,158.903083,39.46853,0,NULL,64117038401,1001828725,15653573,16.5),(72193,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72193,37.67,0.46,342,27004,70,NULL,NULL,'2MASX J10353723-0001591',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000086,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,158.905291667,-0.03319,0.145,NULL,40872706448,638636038,9978688,18),(72194,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72194,38.02,0.33,401,27005,70,NULL,NULL,'2MASX J10353840+0029138',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000094,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,158.909917,0.48731,0.169,NULL,60267587068,941681047,14713766,17.2),(72195,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72195,38.41,0.46,481,27006,70,NULL,NULL,'2MASX J10353983+1556575',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,158.915958333,15.94936,0.073,NULL,60958320267,952473754,14882402,17.6),(72196,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72196,38.71,0.46,553,27007,70,NULL,NULL,'SDSS J103539.96+152658.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,158.9165417,15.44947,0.089,NULL,61179333405,955927084,14936360,18.1),(72197,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72197,37.68,0.27,344,27008,70,NULL,NULL,'SDSS J103540.42+010844.2',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000076,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,158.9184583,1.14564,0.129,NULL,60267400126,941678126,14713720,18),(72198,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72198,37.18,0.33,273,27009,70,NULL,NULL,'2MASX J10354100+4555596',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000145,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,158.92075,45.93342,0,NULL,64133635678,1002088057,15657625,17),(72199,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72199,36.41,0.46,192,27010,70,NULL,NULL,'2MASX J10354159+4636446',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000054,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,158.9235,46.61233,0,NULL,64135381523,1002115336,15658052,17),(72200,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72200,37.5,0.33,316,27011,70,NULL,NULL,'2MASXi J1035417+160525',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,158.924125,16.09039,0.069,NULL,60958350347,952474224,14882409,17.9),(72201,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72201,37.18,0.33,273,27012,70,NULL,NULL,'MCG +08-19-042',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000192,NULL,'15.6g',0.47,'E0',NULL,NULL,NULL,NULL,1,158.933625,45.91494,0,NULL,64133633786,1002088027,15657625,15.6),(72202,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72202,37.87,0.46,375,27013,70,NULL,NULL,'2MASX J10354520+5722035',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000173,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,158.938583,57.36764,0,NULL,62001145416,968767897,15136998,17),(72203,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72203,36.68,0.33,216,27014,70,NULL,NULL,'VV 393 NED01',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000197,NULL,'15.6g',0.49,NULL,NULL,NULL,NULL,NULL,1,158.939,20.04611,0.033,NULL,61001025309,953141020,14892828,15.6),(72204,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72204,38.34,0.46,465,27015,70,NULL,NULL,'2MASX J10354574+4426055',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00018,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,158.9404583,44.43481,0,NULL,64141259293,1002207176,15659487,17.7),(72205,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72205,35.46,0.44,124,27016,NULL,NULL,NULL,'ESO 437- G 006',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'16.24',0.5,'Sb:',NULL,NULL,NULL,NULL,1,158.944125,-29.02542,0.133,NULL,41478405098,648100079,10126563,16.24),(72206,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72206,35.5,0.2,126,27016,74.4,NULL,NULL,'ESO 437- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72207,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72207,35.65,0.41,135,27016,NULL,NULL,'Malmquist cor.','ESO 437- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72208,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72208,36.68,0.33,216,27017,70,NULL,NULL,'2MASX J10354668+2001053',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000167,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,158.944375,20.01814,0.033,NULL,61001018835,953140919,14892826,16.4),(72209,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72209,38.11,0.46,420,27018,70,NULL,NULL,'2MASX J10354830+3422397',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,158.951417,34.37767,0.037,NULL,64051910828,1000811106,15637673,17.8),(72210,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72210,34.8,0.53,91,27019,70,NULL,NULL,'2MASX J10354844-4354253',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.7I',0.4,NULL,NULL,NULL,NULL,NULL,1,158.951875,-43.90708,0.561,NULL,42130494840,658288981,10285765,13.7),(72211,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72211,37.25,0.46,282,27020,70,NULL,NULL,'2MASX J10354843+2751217',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000175,NULL,'17.71',0.22,NULL,NULL,NULL,NULL,NULL,1,158.951875,27.85608,0.041,NULL,60476042498,944938164,14764658,17.71),(72212,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72212,37.23,0.46,280,27021,70,NULL,NULL,'2MASX J10354860+2427127',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000196,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,158.952583,24.45367,0,NULL,60470029623,944844212,14763190,16.3),(72213,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72213,37.5,0.33,316,27022,70,NULL,NULL,'2MASX J10354884+1559225',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,158.953458333,15.98961,0.073,NULL,60958321056,952473766,14882402,17.4),(72214,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72214,37.03,0.46,255,27023,70,NULL,NULL,'2MASX J10354903+1306035',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,158.9542917,13.10094,0.033,NULL,61185294364,956020224,14937816,16.9),(72215,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72215,37.75,0.46,355,27024,70,NULL,NULL,'2MASX J10354930+2522536',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000165,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,158.955417,25.38158,0.005,NULL,60473288995,944895140,14763986,18.2),(72216,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72216,36.05,0.46,162,27025,70,NULL,NULL,'CGCG 065-061',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000103,NULL,'15.3g',0.49,'E0',NULL,NULL,NULL,NULL,1,158.9579583,12.20356,0.089,NULL,61184437778,956006840,14937606,15.3),(72217,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72217,35.03,0.46,101,27026,70,NULL,NULL,'CGCG 124-042',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000169,NULL,'14.7g',0.73,NULL,NULL,NULL,NULL,NULL,1,158.9595,20.65094,0.033,NULL,61001321131,953145642,14892900,14.7),(72218,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72218,36.81,0.33,230,27027,70,NULL,NULL,'2MASX J10355178+0941209',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000176,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,158.965708333,9.68928,0.069,NULL,61049018817,953890919,14904545,16.9),(72219,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72219,37.31,0.46,290,27028,70,NULL,NULL,'2MASX J10355251+0650119',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,158.9687083,6.83672,0.069,NULL,61057916462,954029944,14906717,17.6),(72220,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72220,37.18,0.46,272,27029,70,NULL,NULL,'2MASX J10355283+2604023',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000111,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,158.970083,26.06736,0.013,NULL,60471275656,944863682,14763495,17.4),(72221,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72221,37.68,0.27,344,27030,70,NULL,NULL,'2MASX J10355359+0115128',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000089,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,158.9734583,1.25347,0.129,NULL,60267191846,941674872,14713669,17),(72222,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72222,38.27,0.46,451,27031,70,NULL,NULL,'2MASX J10355422+2135345',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000194,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,158.9760417,21.59297,0.009,NULL,60992743349,953011614,14890806,17.2),(72223,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72223,37.55,0.46,323,27032,70,NULL,NULL,'2MASX J10355767+4357364',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000185,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,158.9905,43.96019,0,NULL,64141181271,1002205957,15659468,16.5),(72224,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72224,33.38,0.45,47.4,27033,NULL,NULL,'K','ESO 501- G 027',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000033,NULL,'15.30',0.5,'E6/S0',NULL,NULL,NULL,NULL,1,158.990917,-27.31914,NULL,NULL,41479471965,648116749,10126824,15.3),(72225,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72225,33.53,0.4,50.9,27033,NULL,NULL,'mean','ESO 501- G 027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72226,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72226,33.7,0.4,55,27034,75,NULL,'Edat, raw','2MASX J10355816-2733449',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000047,NULL,'14.71',0.25,'S0(6)','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,158.9922917,-27.56247,0.169,NULL,41479417697,648115901,10126810,14.71),(72227,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72227,33.72,0.4,55.4,27034,75,NULL,'Edat, cor','2MASX J10355816-2733449',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72228,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72228,37.11,0.46,264,27035,70,NULL,NULL,'2MASX J10355903+5233539',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00012,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,158.9960417,52.56494,0.005,NULL,61892018190,967062784,15110356,17.4),(72229,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72229,37.68,0.27,344,27036,70,NULL,NULL,'2MASX J10355920+0111465',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000073,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,158.9967083,1.19611,0.129,NULL,60267409292,941678270,14713722,17.6),(72230,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72230,37.33,0.33,292,27037,70,NULL,NULL,'2MASX J10355930+4718224',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000146,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,158.997208333,47.30628,0,NULL,64138843664,1002169432,15658897,17.8),(72231,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72231,36.33,0.46,185,27038,70,NULL,NULL,'2MASX J10360101+1457229',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'17.00',0.49,NULL,NULL,NULL,NULL,NULL,1,159.004291667,14.9565,0.089,NULL,61184214385,956003349,14937552,17),(72232,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72232,37.61,0.46,333,27039,70,NULL,NULL,'2MASX J10360352+4115045',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,159.014833,41.25125,0,NULL,64152947201,1002389800,15662340,17.8),(72233,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72233,37.12,0.46,265,27040,70,NULL,NULL,'2MASX J10360414+1559140',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,159.017166667,15.98719,0.073,NULL,60958316194,952473690,14882401,17.7),(72234,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72234,33.86,0.4,59.2,27041,NULL,NULL,'mean','IC 2594',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.0001,NULL,'13.37',1.5,'SA0-','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.017375,-24.32308,0.253,NULL,41482183560,648159118,10127486,13.37),(72235,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72235,34.19,0.45,68.9,27041,NULL,NULL,'K','IC 2594',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72236,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72236,33.7,0.4,55,27042,75,NULL,'Edat, raw','2MASX J10360425-2730319',NULL,'1997ApJS..109..333W',1997,1,0.5,'FLASH project (2003MNRAS.339..652K) gives v = 21195 +/- 131 km/sec.','G',0.000047,NULL,'14.47',0.4,'E+ pec:','Group member',NULL,NULL,NULL,1,159.01775,-27.50886,0.169,NULL,41479422695,648115979,10126812,14.47),(72237,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72237,33.72,0.4,55.4,27042,75,NULL,'Edat, cor','2MASX J10360425-2730319',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72238,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72238,33.63,0.23,53.2,27042,74.4,NULL,NULL,'2MASX J10360425-2730319',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72239,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72239,37.68,0.46,343,27043,70,NULL,NULL,'2MASX J10360459+0251115',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000172,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,159.019,2.85322,0.049,NULL,61003430077,953178594,14893415,16.8),(72240,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72240,37.97,0.46,393,27044,70,NULL,NULL,'2MASX J10360484+4643176',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00014,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,159.020083333,46.72158,0,NULL,64138815409,1002168990,15658890,17.3),(72241,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72241,36.05,0.46,162,27045,70,NULL,NULL,'2MASX J10360559-0031081',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000091,NULL,'16.3g',0.36,'Sa',NULL,NULL,NULL,NULL,1,159.023417,-0.51886,0.125,NULL,40872813456,638637710,9978714,16.3),(72242,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72242,37.69,0.46,345,27046,70,NULL,NULL,'4C +00.37',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000115,NULL,'16.0g',0.42,'Scd            AGN',NULL,NULL,'radio jet','Flat-Spectrum Radio Source',1,159.0240417,0.10189,0.145,NULL,60265342289,941645973,14713218,16),(72243,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72243,37.93,0.46,385,27047,70,NULL,NULL,'2MASX J10360659+4428226',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000169,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,159.027583,44.47297,0,NULL,64141206268,1002206347,15659474,18.5),(72244,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72244,37.99,0.46,396,27048,70,NULL,NULL,'SDSS J103608.86+482615.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000136,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,159.036958333,48.43753,0,NULL,64136466855,1002132294,15658317,18.3),(72245,'Tully est','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72245,30.32,0.8,11.6,27049,75,NULL,NULL,'ESO 375- G 071',NULL,'1988NBGC.C....0000T',1988,1,3,NULL,'G',0.000007,NULL,'13.09',2.5,'IB(s)m',NULL,NULL,NULL,NULL,1,159.0392917,-37.23786,0.153,NULL,42117520969,658086265,10282597,13.09),(72246,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72246,37.48,0.33,314,27050,70,NULL,NULL,'2MASX J10360940+3516163',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,159.03925,35.27117,0.045,NULL,64053576494,1000837132,15638080,17.8),(72247,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72247,37.38,0.46,299,27051,70,NULL,NULL,'SDSS J103609.49+023121.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.3g',0.1,NULL,NULL,NULL,NULL,NULL,1,159.039583,2.52275,0.061,NULL,61003826018,953184781,14893512,18.3),(72248,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72248,38.07,0.46,412,27052,70,NULL,NULL,'2MASX J10360967+4038415',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000184,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,159.0402917,40.64503,0,NULL,64116285580,1001816962,15653390,17.8),(72249,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72249,36.95,0.19,245,27053,70,NULL,NULL,'2MASX J10361026+5021449',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000198,NULL,'16.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,159.043,50.36261,0,NULL,64122857062,1001919641,15654994,16.3),(72250,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72250,36.81,0.33,230,27054,70,NULL,NULL,'SDSS J103610.39+094224.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,159.043333,9.70672,0.069,NULL,61048490487,953882663,14904416,17.7),(72251,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72251,35.26,0.49,113,27055,70,NULL,NULL,'ESO 264- G 010',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.93',0.3,'S0',NULL,NULL,NULL,NULL,1,159.043417,-43.37931,0.505,NULL,42130847795,658294496,10285851,15.93),(72252,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72252,37.64,0.33,338,27056,70,NULL,NULL,'2MASX J10361082+1344380',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000138,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,159.04525,13.74381,0.065,NULL,61185709774,956026715,14937917,18.3),(72253,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72253,33.7,0.4,55,27057,75,NULL,'Edat, raw','2MASX J10361101-2727149',NULL,'1997ApJS..109..333W',1997,1,0.81,NULL,'G',0.00005,NULL,'14.90',0.26,'S0(6)',NULL,NULL,NULL,NULL,1,159.045833,-27.45417,0.169,NULL,41479404837,648115700,10126807,14.9),(72254,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72254,33.72,0.4,55.4,27057,75,NULL,'Edat, cor','2MASX J10361101-2727149',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72255,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72255,36.07,0.33,164,27058,70,NULL,NULL,'2MASX J10361165+4912559',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000184,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,159.048625,49.21556,0,NULL,64125870409,1001966725,15655730,16.6),(72256,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72256,33.7,0.4,55,27059,75,NULL,'Edat, raw','NGC 3305',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000057,NULL,'13.77',1.1,'E0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.0489583,-27.16219,NULL,NULL,41478606999,648103234,10126613,13.77),(72257,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72257,33.72,0.4,55.4,27059,75,NULL,'Edat, cor','NGC 3305',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72258,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72258,33.6,0.47,52.4,27059,70,NULL,NULL,'NGC 3305',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72259,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72259,33.95,0.23,61.7,27059,74.4,NULL,NULL,'NGC 3305',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72260,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72260,37.2,0.46,276,27060,70,NULL,NULL,'2MASX J10361190+5247599',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000158,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,159.049667,52.80003,0,NULL,61892094133,967063970,15110374,17.1),(72261,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72261,38.11,0.46,418,27061,70,NULL,NULL,'2MASX J10361206+0242555',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000192,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,159.050417,2.71528,0.049,NULL,61003444030,953178812,14893418,17.1),(72262,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72262,37.72,0.46,350,27062,70,NULL,NULL,'2MASX J10361209+3257513',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000139,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,159.050541667,32.96442,0.037,NULL,64049864755,1000779136,15637174,18),(72263,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72263,37.12,0.46,266,27063,70,NULL,NULL,'2MASX J10361213+0203255',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000172,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,159.050667,2.05708,0.053,NULL,61003742644,953183478,14893491,16.6),(72264,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72264,36.82,0.33,231,27064,70,NULL,NULL,'2MASX J10361255+2635004',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00018,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,159.0522917,26.58333,0.025,NULL,60477831985,944966124,14765095,16.1),(72265,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72265,36.95,0.19,245,27065,70,NULL,NULL,'2MASX J10361263+5009119',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000173,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,159.052625,50.15328,0,NULL,64126328900,1001973889,15655842,16.2),(72266,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72266,36.82,0.33,231,27066,70,NULL,NULL,'2MASX J10361263+2635594',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000176,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,159.0527083,26.59989,0.029,NULL,60477831295,944966113,14765095,16.4),(72267,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72267,33.92,0.25,60.8,27067,74.4,NULL,NULL,'2MASX J10361305-2741189',NULL,'2013AJ....146...86T',2013,1,0.97,NULL,'G',0.000047,NULL,'14.67',0.45,'S0(4)','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.054,-27.68908,0.169,NULL,41479140390,648111568,10126743,14.67),(72268,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72268,33.77,0.46,56.7,27068,70,NULL,NULL,'IC 0624',NULL,'2014MNRAS.445.2677S',2014,1,2.7,NULL,'G',0.00003,NULL,'14.27',0.8,'SABa:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.06325,-8.33394,0.069,NULL,41801690630,653151416,10205490,14.27),(72269,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72269,34.01,0.29,63.5,27068,NULL,NULL,NULL,'IC 0624',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72270,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72270,34.05,0.29,64.6,27068,NULL,NULL,'Malmquist cor.','IC 0624',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72271,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72271,34.06,0.2,64.9,27068,74.4,NULL,NULL,'IC 0624',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72272,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72272,34.35,0.49,74.1,27068,75,NULL,'IR','IC 0624',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72273,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72273,34.41,0.45,76.2,27068,NULL,NULL,'K','IC 0624',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72274,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72274,34.42,0.47,76.6,27068,NULL,NULL,'H','IC 0624',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72275,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72275,34.43,0.4,76.8,27068,NULL,NULL,'mean','IC 0624',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72276,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72276,34.46,0.46,77.9,27068,NULL,NULL,'J','IC 0624',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72277,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72277,38.11,0.46,419,27069,70,NULL,NULL,'2MASX J10361548+3942445',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,159.0644583,39.71253,0,NULL,64117100795,1001829699,15653589,18.1),(72278,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,'R',72278,38.08,0.46,413,27070,70,NULL,NULL,'SDSS J103615.93+022758.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00014,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,159.066375,2.46636,0.061,NULL,61004019720,953187808,14893559,18.2),(72279,'FP','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72279,36.14,0.59,169,27071,70,NULL,NULL,'IC 2593',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000127,NULL,'15.83',NULL,NULL,NULL,NULL,NULL,NULL,1,159.0664583,-12.72581,0.165,NULL,41840099888,653751560,10214868,15.83),(72280,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:46','1','SN 1992G',NULL,72280,32.22,0.11,27.8,27072,65,NULL,'Snapshot','NGC 3294',NULL,'1996ApJ...473...88R',1996,1,2.3,'The position in 1987A&AS...70..191S is 13 arcsec southeast of the nucleus.','G',0.00002,NULL,'12.2g',1.4,'SA(s)c','in a pair',NULL,NULL,NULL,1,159.0677083,37.32469,0,NULL,64115789918,1001809217,15653269,12.2),(72281,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:46','1','SN 1992G',NULL,72281,32.26,0.09,28.3,27072,74.4,NULL,NULL,'NGC 3294',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72282,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:46','1','SN 1992G',NULL,72282,32.4,0.41,29,27072,67,NULL,NULL,'NGC 3294',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72283,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:46','1','SN 1992G',NULL,72283,32.58,0.14,32.5,27072,65,NULL,'MLCS2k2','NGC 3294',0.00529,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72284,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:46','1','SN 1992G',NULL,72284,32.57,0.08,32.7,27072,65,NULL,'LCS','NGC 3294',NULL,'1995ApJ...445L..91R',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72285,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:46','1','SN 1992G',NULL,72285,32.67,0.09,34,27072,65,NULL,'MLCS','NGC 3294',0.00529,'1996ApJ...473..588R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72286,'IRAS','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72286,32.24,0.8,28.1,27072,75,NULL,'A82, H','NGC 3294',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72287,'IRAS','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72287,32.28,0.8,28.6,27072,75,NULL,'CF, r','NGC 3294',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72288,'Sosies','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72288,32.35,0.14,29.5,27072,NULL,NULL,NULL,'NGC 3294',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72289,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72289,32.11,0.38,26.5,27072,75,NULL,'CF, r, raw','NGC 3294',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72290,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72290,32.13,0.4,26.7,27072,75,NULL,'B','NGC 3294',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72291,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72291,32.17,0.4,27.2,27072,NULL,NULL,'mean','NGC 3294',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72292,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72292,32.2,0.38,27.6,27072,75,NULL,'CF, r, cor','NGC 3294',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72293,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72293,32.22,0.5,27.8,27072,NULL,NULL,'Malmquist cor.','NGC 3294',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72294,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72294,32.23,NULL,27.9,27072,NULL,NULL,'B','NGC 3294',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72295,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72295,32.23,0.47,27.9,27072,NULL,NULL,'H','NGC 3294',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72296,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72296,32.26,0.09,28.3,27072,74.4,NULL,NULL,'NGC 3294',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72297,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72297,32.27,0.38,28.4,27072,75,NULL,'CF, r, inv','NGC 3294',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72298,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72298,32.29,0.45,28.7,27072,NULL,NULL,'K','NGC 3294',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72299,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72299,32.3,0.46,28.8,27072,NULL,NULL,'J','NGC 3294',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72300,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72300,32.36,0.43,29.6,27072,75,NULL,'3.6 micron, color corrected','NGC 3294',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72301,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72301,32.38,0.4,29.9,27072,75,NULL,'HOSTS SN 1992G','NGC 3294',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72302,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72302,32.4,0.4,30.2,27072,75,NULL,'HOSTS SN 1992G','NGC 3294',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72303,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72303,32.4,0.43,30.3,27072,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3294',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72304,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72304,32.42,0.42,30.5,27072,NULL,18.48,'3.6 micron','NGC 3294',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72305,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72305,32.53,0.43,32,27072,NULL,NULL,NULL,'NGC 3294',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72306,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:46','1',NULL,NULL,72306,32.61,0.47,33.3,27072,75,NULL,'A82, H, raw','NGC 3294',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72307,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72307,32.67,0.47,34.2,27072,75,NULL,'A82, H, cor','NGC 3294',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72308,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72308,32.8,0.47,36.2,27072,75,NULL,'A82, H, inv','NGC 3294',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72309,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72309,36.07,0.33,164,27073,70,NULL,NULL,'CGCG 240-064',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000182,NULL,'15.4g',0.4,'S0','Isolated galaxy',NULL,NULL,NULL,1,159.072417,49.37192,0,NULL,64125751292,1001964863,15655700,15.4),(72310,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72310,38.14,0.46,425,27074,70,NULL,NULL,'2MASX J10361762+1146239',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,159.0734583,11.77322,0.065,NULL,61045167202,953830737,14903605,17.3),(72311,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72311,33.88,0.23,59.7,27075,74.4,NULL,NULL,'2MASX J10361893-2743169',NULL,'2013AJ....146...86T',2013,1,0.47,NULL,'G',0.00004,NULL,'15.03',0.41,'SB(r)0(1)','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.079125,-27.72139,0.169,NULL,41479140907,648111576,10126743,15.03),(72312,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72312,37.33,0.46,293,27076,70,NULL,NULL,'2MASX J10361911+5838454',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000183,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,159.0795417,58.64608,0,NULL,61949579043,967962172,15124408,16.8),(72313,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72313,38.12,0.46,422,27077,70,NULL,NULL,'2MASX J10361985+3850317',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,159.082833,38.84203,0,NULL,64117385463,1001834147,15653658,17.5),(72314,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72314,36.95,0.19,245,27078,70,NULL,NULL,'2MASX J10361998+5020568',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000224,NULL,'15.9g',0.4,'E0',NULL,NULL,NULL,NULL,1,159.083333,50.34917,0,NULL,64126327017,1001973859,15655841,15.9),(72315,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72315,38.14,0.46,425,27079,70,NULL,NULL,'2MASX J10362076+1014305',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,159.086416667,10.24189,0.069,NULL,61046549335,953852333,14903942,17.8),(72316,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72316,33.98,0.25,62.5,27080,74.4,NULL,NULL,'2MASX J10362089-2709599',NULL,'2013AJ....146...86T',2013,1,0.56,NULL,'G',0.00005,NULL,'15.71',0.26,'S0',NULL,NULL,NULL,NULL,1,159.0870417,-27.16667,NULL,NULL,41478771672,648105807,10126653,15.71),(72317,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72317,37.85,0.46,372,27081,70,NULL,NULL,'SDSS J103620.89+011004.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000062,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,159.087083,1.16783,0.129,NULL,60267419533,941678430,14713725,18.4),(72318,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72318,35.35,0.46,117,27082,70,NULL,NULL,'NGC 3284',NULL,'2015arXiv151105856S',2015,1,1.06,NULL,'G',0.000157,NULL,'14.2g',0.69,'E?','Pair member (points to parent)',NULL,NULL,NULL,1,159.0885,58.62017,0,NULL,61949363823,967958809,15124356,14.2),(72319,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72319,33.13,0.49,42.3,27083,75,NULL,'IR','UGC 05760',NULL,'2011yCatp016004901K',2011,1,1.4,'HOLM 203B is a star.','G',0.000003,NULL,'14.40',0.4,'Scd            HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,159.088833,13.71142,0.065,NULL,61185663361,956025990,14937906,14.4),(72320,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72320,33.22,0.47,44,27083,NULL,NULL,'H','UGC 05760',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72321,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72321,33.32,0.46,46,27083,NULL,NULL,'J','UGC 05760',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72322,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72322,33.35,0.45,46.8,27083,NULL,NULL,'K','UGC 05760',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72323,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72323,33.4,0.4,47.9,27083,NULL,NULL,'mean','UGC 05760',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72324,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72324,37.94,0.33,388,27084,70,NULL,NULL,'2MASX J10362146+4439356',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,159.089333,44.65981,0,NULL,64140937994,1002202156,15659408,17.5),(72325,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72325,36.59,0.46,208,27085,70,NULL,NULL,'2MASX J10362151+2152353',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000173,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,159.089583,21.87647,0.013,NULL,60993398649,953021853,14890966,16.5),(72326,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72326,38.16,0.46,428,27086,70,NULL,NULL,'SDSS J103622.33+054528.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000142,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,159.093083,5.75783,0.065,NULL,61012561264,953321269,14895644,18.1),(72327,'SBF','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72327,33.04,0.3,40.6,27087,NULL,NULL,'I','NGC 3308',NULL,'2005A&A...438..103M',2005,1,1.7,NULL,'G',0.000011,NULL,'12.94',1.3,'SAB(s)0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.093333,-27.43814,NULL,NULL,41479403128,648115673,10126807,12.94),(72328,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72328,33.7,0.4,55,27087,75,NULL,'Edat, raw','NGC 3308',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72329,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72329,33.72,0.4,55.4,27087,75,NULL,'Edat, cor','NGC 3308',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72330,'Faber-Jackson','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72330,33.29,0.44,45.5,27087,95,NULL,'Weighted Mean','NGC 3308',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72331,'Faber-Jackson','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72331,33.57,0.46,51.8,27087,95,NULL,'Michard 1979a','NGC 3308',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72332,'Faber-Jackson','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72332,34.07,0.63,65.2,27087,95,NULL,'Michard 1979b, c','NGC 3308',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72333,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72333,33.33,0.23,46.3,27087,74.4,NULL,NULL,'NGC 3308',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72334,'Tertiary','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72334,32.75,0.5,35.5,27087,95,NULL,NULL,'NGC 3308',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72335,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72335,33.34,0.45,46.5,27087,NULL,NULL,'K','NGC 3308',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72336,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72336,33.91,0.4,60.6,27087,NULL,NULL,'mean','NGC 3308',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72337,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72337,38.54,0.46,510,27088,70,NULL,NULL,'SDSS J103622.45+103645.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,159.093583333,10.61278,0.101,NULL,61045218910,953831545,14903617,18),(72338,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72338,33.7,0.4,55,27089,75,NULL,'Edat, raw','2MASX J10362306-2721152',NULL,'1997ApJS..109..333W',1997,1,0.95,NULL,'G',0.00005,NULL,'14.41',0.56,'S0(3)','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.095875,-27.35467,NULL,NULL,41478687861,648104497,10126632,14.41),(72339,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72339,33.72,0.4,55.4,27089,75,NULL,'Edat, cor','2MASX J10362306-2721152',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72340,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72340,33.92,0.23,60.8,27089,74.4,NULL,NULL,'2MASX J10362306-2721152',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72341,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72341,28.66,0.4,5.4,27090,75,NULL,'B','NGC 3299',NULL,'1988NBGC.C....0000T',1988,1,2.2,NULL,'G',0.00002,NULL,'13.30',1.7,'SAB(s)dm','Probable group member',NULL,NULL,NULL,1,159.099167,12.70739,0.029,NULL,61184494528,956007727,14937620,13.3),(72342,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72342,37.39,0.46,301,27091,70,NULL,NULL,'2MASX J10362421+1022535',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000175,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,159.101,10.38164,0.105,NULL,61046532964,953852077,14903938,16.4),(72343,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72343,33.26,0.25,44.9,27092,74.4,NULL,NULL,'ESO 501- G 035',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000047,NULL,'14.18',0.5,'SB(r)0^0^:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.1034583,-26.99956,NULL,NULL,41478751172,648105487,10126648,14.18),(72344,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72344,34.1,0.4,66,27092,NULL,NULL,'mean','ESO 501- G 035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72345,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72345,34.17,0.45,68.3,27092,NULL,NULL,'K','ESO 501- G 035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72346,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72346,34.01,0.23,63.4,27093,74.4,NULL,NULL,'2MASX J10362490-2734542',NULL,'2013AJ....146...86T',2013,1,0.67,NULL,'G',0.00004,NULL,'14.16',0.54,'E2/S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.1035,-27.58189,0.169,NULL,41479436775,648116199,10126815,14.16),(72347,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72347,35.37,0.4,119,27094,NULL,NULL,'mean','NGC 3288',NULL,'2007A&A...465...71T',2007,1,0.93,NULL,'G',0.000157,NULL,'14.5g',0.69,'SABbc:','Pair member (points to parent)',NULL,NULL,NULL,1,159.1069583,58.55619,0,NULL,61949378313,967959036,15124359,14.5),(72348,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72348,36.64,0.47,213,27094,NULL,NULL,'H','NGC 3288',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72349,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72349,38.55,0.46,512,27095,70,NULL,NULL,'SDSS J103625.69+140205.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000149,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,159.107083,14.03486,0.069,NULL,61185651298,956025801,14937903,18.8),(72350,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72350,38.41,0.46,482,27096,70,NULL,NULL,'2MASX J10362600+3413143',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,159.108333,34.22056,0.017,NULL,64052008153,1000812627,15637697,17.7),(72351,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72351,37.64,0.33,338,27097,70,NULL,NULL,'2MASX J10362631+1346524',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,159.109583,13.78119,0.065,NULL,61185668633,956026072,14937907,18.1),(72352,'SBF','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72352,33.07,0.07,41.2,27098,NULL,NULL,'I','NFP J103626.8-272326',NULL,'2005A&A...438..103M',2005,1,NULL,NULL,'G',0.00007,NULL,'16.20',NULL,'S0',NULL,NULL,NULL,NULL,1,159.112083,-27.39044,NULL,NULL,41478699599,648104681,10126635,16.2),(72353,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72353,37.94,0.33,388,27099,70,NULL,NULL,'2MASX J10362747+4445416',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,159.114416667,44.76142,0,NULL,64133401163,1002084393,15657568,17.7),(72354,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72354,37.27,0.46,285,27100,70,NULL,NULL,'2MASX J10362768+2746432',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000171,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,159.11525,27.77875,0.073,NULL,60476009297,944937645,14764650,18.1),(72355,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72355,33.7,0.4,55,27101,75,NULL,'Edat, raw','2MASX J10362764-2719092',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000027,NULL,'14.16',0.41,'S0(4)','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.1152083,-27.31967,NULL,NULL,41478718492,648104976,10126640,14.16),(72356,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72356,33.72,0.4,55.4,27101,75,NULL,'Edat, cor','2MASX J10362764-2719092',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72357,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72357,33.77,0.23,56.8,27101,74.4,NULL,NULL,'2MASX J10362764-2719092',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72358,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72358,37.8,0.33,363,27102,70,NULL,NULL,'2MASX J10362831+1537439',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,159.1179583,15.62889,0.073,NULL,61180068539,955938570,14936540,17.2),(72359,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72359,37.33,0.46,292,27103,70,NULL,NULL,'2MASX J10362874+0118501',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00017,NULL,'16.5g',0.38,NULL,NULL,NULL,NULL,NULL,1,159.11975,1.31392,0.129,NULL,60267396555,941678071,14713719,16.5),(72360,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72360,37.52,0.46,319,27104,70,NULL,NULL,'SDSS J103629.00+285129.7',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.5g',0.27,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,159.120875,28.85828,0.049,NULL,60520032107,945625501,14775398,16.5),(72361,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72361,33.7,0.4,55,27105,75,NULL,'Edat, raw','2MASX J10362905-2729022',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000043,NULL,'14.01',0.9,'SB(rs)0(0)',NULL,NULL,NULL,NULL,1,159.120833,-27.48394,NULL,NULL,41479400838,648115638,10126806,14.01),(72362,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72362,33.72,0.4,55.4,27105,75,NULL,'Edat, cor','2MASX J10362905-2729022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72363,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72363,34.14,0.23,67.3,27105,74.4,NULL,NULL,'2MASX J10362905-2729022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72364,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72364,36.78,0.46,227,27106,70,NULL,NULL,'2MASX J10362967+5443072',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,159.1235,54.71878,0,NULL,61971921927,968311280,15129863,17.3),(72365,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72365,38.48,0.46,497,27107,70,NULL,NULL,'2MASX J10362990+3423182',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,159.1247917,34.38836,0.037,NULL,64051926633,1000811353,15637677,18.5),(72366,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72366,37.12,0.33,265,27108,70,NULL,NULL,'2MASX J10363033+0609185',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000164,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,159.1265,6.15531,0.057,NULL,61057703416,954026615,14906665,16.5),(72367,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72367,37.21,0.46,277,27109,70,NULL,NULL,'2MASX J10363174+3452018',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000184,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,159.1322083,34.86733,0.041,NULL,64054642786,1000853793,15638340,16.6),(72368,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72368,36.13,0.46,168,27110,70,NULL,NULL,'2MASX J10363182+4516456',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000177,NULL,'15.5g',0.5,'E0',NULL,NULL,NULL,NULL,1,159.132667,45.27939,0,NULL,64134050249,1002094535,15657727,15.5),(72369,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72369,33.7,0.56,54.8,27111,70,NULL,NULL,'ESO 437- G 008',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000093,NULL,'14.65',0.3,'S0?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.135541667,-28.06367,0.165,NULL,41479069470,648110460,10126725,14.65),(72370,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72370,38.3,0.46,457,27112,70,NULL,NULL,'SDSS J103633.23+255640.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,159.138458333,25.94453,0.017,NULL,60471361999,944865031,14763516,18.2),(72371,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72371,37.69,0.46,344,27113,70,NULL,NULL,'2MASX J10363331+4237115',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000167,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,159.138833,42.61989,0,NULL,64142140539,1002220945,15659702,16.8),(72372,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72372,34.91,0.46,96.1,27114,70,NULL,NULL,'UGC 05759',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000103,NULL,'14.3g',0.74,'S0-:',NULL,NULL,NULL,NULL,1,159.140583,38.43844,0,NULL,64117449424,1001835147,15653674,14.3),(72373,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72373,35.4,0.4,120,27114,NULL,NULL,'mean','UGC 05759',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72374,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72374,35.63,0.45,134,27114,NULL,NULL,'K','UGC 05759',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72375,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72375,36.95,0.19,245,27115,70,NULL,NULL,'2MASX J10363438+5007493',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000179,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,159.143416667,50.13028,0,NULL,64126459461,1001975929,15655873,16.5),(72376,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72376,32.87,0.25,37.5,27116,74.4,NULL,NULL,'ESO 437- G 009',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000017,NULL,'14.80',0.4,'E4/S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.144625,-28.21456,0.165,NULL,41479057415,648110272,10126723,14.8),(72377,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72377,33.73,0.58,55.8,27116,70,NULL,NULL,'ESO 437- G 009',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72378,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72378,36.69,0.46,218,27117,70,NULL,NULL,'2MASX J10363500+6009523',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,159.14575,60.16472,0,NULL,61957557498,968086835,15126356,17.7),(72379,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72379,37.45,0.46,310,27118,70,NULL,NULL,'2MASX J10363509+2123004',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.80',0.2,NULL,NULL,NULL,NULL,NULL,1,159.146333,21.3835,0.013,NULL,60992546243,953008535,14890758,17.8),(72380,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72380,33.7,0.4,55,27119,75,NULL,'Edat, raw','2MASX J10363551-2728122',NULL,'1997ApJS..109..333W',1997,1,0.34,'Richter (1987,A&AS,67,237) gives v = 8529 +/- 102 km/sec.','G',0.00004,NULL,'15.46',0.22,'E',NULL,NULL,NULL,NULL,1,159.1480417,-27.47044,NULL,NULL,41479397856,648115591,10126806,15.46),(72381,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72381,33.72,0.4,55.4,27119,75,NULL,'Edat, cor','2MASX J10363551-2728122',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72382,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72382,34.28,0.25,71.8,27119,74.4,NULL,NULL,'2MASX J10363551-2728122',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72383,'GCLF','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72383,33.95,0.73,61.7,27120,NULL,NULL,NULL,'NGC 3309',NULL,'2005A&A...438..103M',2005,1,1.9,NULL,'G',0.000014,NULL,'12.60',1.6,'E3','in a pair',NULL,NULL,NULL,1,159.14875,-27.51844,0.169,NULL,41479433944,648116155,10126814,12.6),(72384,'SBF','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72384,33.09,0.14,41.4,27120,NULL,NULL,'I','NGC 3309',NULL,'2005A&A...438..103M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72385,'SBF','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72385,33.33,0.23,46.3,27120,NULL,NULL,'K','NGC 3309',NULL,'1999ApJ...510...71J',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72386,'SBF','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72386,33.66,0.68,54,27120,NULL,NULL,NULL,'NGC 3309',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72387,'SBF','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72387,33.84,0.68,58.6,27120,NULL,NULL,'Malmquist cor.','NGC 3309',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72388,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72388,33.7,0.4,55,27120,75,NULL,'Edat, raw','NGC 3309',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72389,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72389,33.72,0.4,55.4,27120,75,NULL,'Edat, cor','NGC 3309',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72390,'Faber-Jackson','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72390,32.88,0.37,37.7,27120,95,NULL,'Weighted Mean','NGC 3309',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72391,'Faber-Jackson','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72391,33.36,0.46,47,27120,95,NULL,'Michard 1979a','NGC 3309',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72392,'Faber-Jackson','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72392,33.57,0.63,51.8,27120,95,NULL,'Michard 1979b, c','NGC 3309',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72393,'Faber-Jackson','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72393,34.21,0.81,69.5,27120,55,NULL,'Visvanathan & Sandage 1979','NGC 3309',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72394,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72394,33.33,0.41,46.3,27120,NULL,NULL,NULL,'NGC 3309',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72395,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72395,33.55,0.23,51.3,27120,74.4,NULL,NULL,'NGC 3309',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72396,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72396,33.55,0.41,51.3,27120,NULL,NULL,'Malmquist cor.','NGC 3309',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72397,'Tertiary','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72397,32.75,0.5,35.5,27120,95,NULL,NULL,'NGC 3309',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72398,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72398,36.23,0.46,176,27121,70,NULL,NULL,'2MASX J10363674+1529365',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.3g',0.19,'AGN',NULL,NULL,NULL,NULL,1,159.153,15.49336,0.077,NULL,61180155002,955939921,14936561,17.3),(72399,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72399,38.04,0.33,406,27122,70,NULL,NULL,'2MASX J10363764+3044389',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000154,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,159.156875,30.74403,0.041,NULL,64048006394,1000750099,15636720,17.8),(72400,'Faber-Jackson','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72400,30.48,0.65,12.5,27123,95,NULL,'Weighted Mean','NGC 3300',NULL,'1984ApJS...56...91D',1984,1,1.71,NULL,'G',0.00006,NULL,'13.1g',0.86,'SAB(r)0^0^:?','Probable group member',NULL,NULL,NULL,1,159.160166667,14.17111,0.073,NULL,61185591898,956024873,14937888,13.1),(72401,'Faber-Jackson','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72401,31.58,0.81,20.7,27123,55,NULL,'Visvanathan & Sandage 1979','NGC 3300',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72402,'Tully est','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72402,33.16,0.8,42.9,27123,75,NULL,'B','NGC 3300',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72403,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72403,32.86,0.45,37.2,27123,NULL,NULL,'K','NGC 3300',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72404,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72404,33.41,0.4,48.1,27123,NULL,NULL,'mean','NGC 3300',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72405,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72405,34,0.17,63.2,27124,NULL,NULL,NULL,'ESO 375- G 072',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000023,NULL,'15.66',0.4,'SB(s)m: sp',NULL,NULL,NULL,NULL,1,159.163833,-34.75675,0.297,NULL,41989668865,656088576,10251384,15.66),(72406,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72406,37.48,0.33,314,27125,70,NULL,NULL,'2MASX J10363940+3513409',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000137,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,159.164167,35.22817,0.041,NULL,64053582764,1000837230,15638081,16.9),(72407,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72407,33.7,0.4,55,27126,75,NULL,'Edat, raw','2MASX J10364122-2733392',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000043,NULL,'13.61',0.6,'S0- sp','Group member',NULL,NULL,NULL,1,159.171667,-27.561,0.169,NULL,41479432614,648116134,10126814,13.61),(72408,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72408,33.72,0.4,55.4,27126,75,NULL,'Edat, cor','2MASX J10364122-2733392',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72409,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72409,33.55,0.23,51.3,27126,74.4,NULL,NULL,'2MASX J10364122-2733392',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72410,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72410,37.48,0.46,313,27127,70,NULL,NULL,'SDSS J103641.25+081726.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000131,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,159.171875,8.29067,0.053,NULL,61058775314,954043364,14906927,18.5),(72411,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72411,37.8,0.33,363,27128,70,NULL,NULL,'2MASX J10364200+1538165',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,159.174833,15.63789,0.073,NULL,61180060047,955938438,14936538,16.5),(72412,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72412,37.31,0.46,289,27129,70,NULL,NULL,'SDSS J103641.98+354732.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000179,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,159.174916667,35.79228,0.045,NULL,64045709527,1000714211,15636159,17.7),(72413,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72413,36.49,0.46,199,27130,70,NULL,NULL,'2MASX J10364224+0404331',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000158,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,159.176125,4.07569,0.065,NULL,61018508929,953414202,14897096,17.1),(72414,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72414,37.37,0.46,299,27131,70,NULL,NULL,'2MASX J10364229+2535203',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,159.176333,25.589,0.013,NULL,60470989078,944859204,14763425,17.7),(72415,'GCLF','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72415,33.55,0.63,51.3,27132,NULL,NULL,NULL,'NGC 3311',NULL,'2005A&A...438..103M',2005,1,3.5,NULL,'G',0.000027,NULL,'12.65',2.9,'cD;E+2','in a pair',NULL,NULL,NULL,1,159.178417,-27.52833,0.169,NULL,41479430857,648116107,10126814,12.65),(72416,'PNLF','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72416,33.49,NULL,50,27132,NULL,NULL,NULL,'NGC 3311',NULL,'2011A&A...528A..24V',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72417,'PNLF','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72417,33.5,NULL,51.5,27132,NULL,NULL,'Hydra Cluster','NGC 3311',NULL,'2013IAUS..289..287A',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72418,'SBF','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72418,32.81,0.13,36.5,27132,NULL,NULL,'I','NGC 3311',NULL,'2005A&A...438..103M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72419,'SBF','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72419,33.23,0.52,44.3,27132,NULL,NULL,NULL,'NGC 3311',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72420,'SBF','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72420,33.3,0.24,45.7,27132,NULL,NULL,'K','NGC 3311',NULL,'1999ApJ...510...71J',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72421,'SBF','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72421,33.55,0.52,51.2,27132,NULL,NULL,'Malmquist cor.','NGC 3311',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72422,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72422,33.66,0.19,54,27132,NULL,NULL,'ABELL 1060, Hydra CLUSTER, 20 galaxies','NGC 3311',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72423,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72423,33.7,0.4,55,27132,75,NULL,'Edat, raw','NGC 3311',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72424,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72424,33.72,0.4,55.4,27132,75,NULL,'Edat, cor','NGC 3311',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72425,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72425,33.78,0.07,57,27132,72,NULL,'Hydra Cluster. 39 galaxies','NGC 3311',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72426,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72426,33.91,0.13,60.6,27132,70,NULL,'Hydra Cluster','NGC 3311',NULL,'1988MNRAS.235.1177L',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72427,'Dwarf Galaxy Diameter','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72427,33.53,0.85,50.8,27132,NULL,NULL,'Hydra I cluster, bias corr.','NGC 3311',NULL,'2011MNRAS.414.3699M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72428,'Dwarf Galaxy Diameter','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72428,33.8,0.57,57.6,27132,NULL,NULL,'Hydra I cluster','NGC 3311',NULL,'2011MNRAS.414.3699M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72429,'Faber-Jackson','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72429,33.54,0.44,51.1,27132,95,NULL,'Weighted Mean','NGC 3311',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72430,'Faber-Jackson','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72430,33.7,0.46,55,27132,95,NULL,'Michard 1979a','NGC 3311',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72431,'Faber-Jackson','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72431,34.6,0.63,83.2,27132,95,NULL,'Michard 1979b, c','NGC 3311',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72432,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72432,32.93,0.41,38.5,27132,NULL,NULL,NULL,'NGC 3311',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72433,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72433,32.96,0.25,39.1,27132,74.4,NULL,NULL,'NGC 3311',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72434,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72434,33.22,0.48,44,27132,70,NULL,NULL,'NGC 3311',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72435,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72435,33.33,0.41,46.4,27132,NULL,NULL,'Malmquist cor.','NGC 3311',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72436,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72436,33.46,0.2,49.1,27132,NULL,NULL,'ABELL 1060, Hydra CLUSTER, 20 galaxies','NGC 3311',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72437,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72437,33.58,0.2,52,27132,NULL,NULL,'ABELL 1060, Hydra CLUSTER, 20 galaxies','NGC 3311',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72438,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72438,33.6,0.1,52.6,27132,75,NULL,'Hydra Cluster','NGC 3311',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72439,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72439,33.6,0.1,52.6,27132,75,NULL,'Hydra cluster, 18 galaxies','NGC 3311',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72440,'Magnitude','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72440,33.85,NULL,58.9,27132,NULL,NULL,'Hydra I cluster','NGC 3311',NULL,'1995A&A...302...21G',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72441,'Tertiary','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72441,32.75,0.5,35.5,27132,95,NULL,NULL,'NGC 3311',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72442,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72442,33.2,0.45,43.7,27132,NULL,NULL,'K','NGC 3311',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72443,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72443,33.68,0.16,54.5,27132,70,NULL,'Hydra Cluster','NGC 3311',NULL,'1992ApJ...396..453H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72444,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72444,33.74,0.16,56,27132,75,NULL,'Hydra cluster, avg. of 14 spiral galaxies','NGC 3311',NULL,'2013ApJ...765...94S',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72445,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72445,33.81,0.36,57.8,27132,77,NULL,'ABELL 1060, Hydra CLUSTER, 12 galaxies','NGC 3311',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72446,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72446,33.81,NULL,57.8,27132,77,NULL,'BRIK, Hydra I cluster, 12 galaxies','NGC 3311',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72447,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72447,33.83,NULL,58.3,27132,71,NULL,'ABELL 1060, Hydra CLUSTER, 50 galaxies','NGC 3311',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72448,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72448,33.84,0.14,58.6,27132,75,NULL,'Hydra CLUSTER','NGC 3311',NULL,'2012ApJ...749...78T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72449,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72449,33.84,0.14,58.6,27132,75,NULL,'Hydra cluster, avg. of 14 spiral galaxies','NGC 3311',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72450,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72450,33.85,0.14,58.9,27132,74.4,NULL,'Hydra CLUSTER, 19 galaxies, WISE I-band','NGC 3311',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72451,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72451,33.89,0.07,60,27132,74.4,NULL,'Hydra CLUSTER, 19 galaxies, WISE W1 (3.4 micro-meter), curved','NGC 3311',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72452,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72452,33.9,0.3,60.2,27132,NULL,NULL,'ABELL 1060, Hydra CLUSTER, 17 galaxies','NGC 3311',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72453,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72453,33.9,0.06,60.3,27132,74.4,NULL,'Hydra CLUSTER, 19 galaxies, WISE W2 (4.6 micro-meter), curved','NGC 3311',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72454,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72454,33.91,0.4,60.6,27132,NULL,NULL,'mean','NGC 3311',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72455,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72455,33.96,0.14,62.1,27132,74.4,NULL,'Hydra CLUSTER, 19 galaxies, WISE W2 (4.6 micro-meter), color corrected','NGC 3311',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72456,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72456,33.97,0.14,62.1,27132,74.4,NULL,'Hydra CLUSTER, 19 galaxies, WISE W1 (3.4 micro-meter), color corrected','NGC 3311',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72457,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72457,34.3,0.07,72.4,27132,50,NULL,'ABELL 1060, Hydra I CLUSTER, 42 galaxies','NGC 3311',NULL,'1983A&A...125..187R',1983,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72458,'SBF','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72458,33.71,0.51,55.2,27133,NULL,NULL,'I','NFP J103642.8-273509',NULL,'2005A&A...438..103M',2005,1,0.28,NULL,'G',0.000097,NULL,'16.05',0.2,'S0',NULL,NULL,NULL,NULL,1,159.17825,-27.586,0.169,NULL,41479377982,648115280,10126801,16.05),(72459,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72459,38.35,0.46,467,27134,70,NULL,NULL,'SDSS J103642.82+015350.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000177,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,159.178417,1.89739,0.057,NULL,61003642253,953181910,14893467,17.9),(72460,'SBF','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72460,33.16,0.44,42.8,27135,NULL,NULL,'I','ABELL 1060:[CZ2003]C0393[008]',NULL,'2005A&A...438..103M',2005,1,NULL,NULL,'G',0.000127,NULL,'17.6R',NULL,'dE,N',NULL,NULL,NULL,NULL,1,159.179583,-27.42503,NULL,NULL,41478690134,648104533,10126633,17.6),(72461,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72461,29.19,0.4,6.9,27136,75,NULL,'B','UGC 05764',NULL,'1988NBGC.C....0000T',1988,1,2,NULL,'G',0.000017,NULL,'15.21',1.1,'IB(s)m:',NULL,NULL,NULL,NULL,1,159.180583,31.54675,0.033,NULL,64047678594,1000744978,15636640,15.21),(72462,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72462,33.02,0.43,40.3,27137,75,NULL,'3.6 micron, color + selection bias corrected','ESO 501- G 037',NULL,'2014MNRAS.444..527S',2014,1,1.1,NULL,'G',0.00015,NULL,'16',0.8,'SBb:',NULL,NULL,NULL,NULL,1,159.186125,-25.26247,0.205,NULL,41485287386,648207615,10128243,16),(72463,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72463,33.7,0.4,55,27138,75,NULL,'Edat, raw','2MASX J10364490-2728102',NULL,'1997ApJS..109..333W',1997,1,0.45,NULL,'G',0.00004,NULL,'13.99',0.39,'E1',NULL,NULL,NULL,NULL,1,159.187333,-27.46953,NULL,NULL,41478689184,648104518,10126633,13.99),(72464,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72464,33.72,0.4,55.4,27138,75,NULL,'Edat, cor','2MASX J10364490-2728102',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72465,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72465,33.51,0.25,50.4,27138,74.4,NULL,NULL,'2MASX J10364490-2728102',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72466,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72466,37.58,0.46,327,27139,70,NULL,NULL,'2MASX J10364524+5445483',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000164,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,159.188625,54.76339,0,NULL,61972129355,968314521,15129914,16.6),(72467,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72467,36.94,0.55,245,27140,70,NULL,NULL,'2MASX J10364532-1116533',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.99',NULL,NULL,NULL,NULL,NULL,NULL,1,159.188833,-11.28167,0.137,NULL,41765679572,652588743,10196699,15.99),(72468,'SBF','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72468,32.83,0.49,36.7,27141,NULL,NULL,'I','NFP J103645.8-273032',NULL,'2005A&A...438..103M',2005,1,NULL,NULL,'G',0.00005,NULL,'17.01',NULL,'E',NULL,NULL,NULL,NULL,1,159.190417,-27.50892,NULL,NULL,41479430183,648116096,10126814,17.01),(72469,'SBF','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72469,32.94,0.47,38.8,27142,NULL,NULL,'I','ABELL 1060:[CZ2003]A0494[106]',NULL,'2005A&A...438..103M',2005,1,NULL,NULL,'G',0.00053,NULL,'17.5R',NULL,'dE,N',NULL,NULL,NULL,NULL,1,159.191667,-27.52364,NULL,NULL,41479376974,648115265,10126801,17.5),(72470,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72470,37.82,0.46,366,27143,70,NULL,NULL,'2MASX J10364622+0857555',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000178,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,159.1925,8.96539,0.073,NULL,61048095055,953876485,14904320,17.2),(72471,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72471,38.04,0.33,406,27144,70,NULL,NULL,'SDSS J103647.64+303819.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,159.1985417,30.63878,0.025,NULL,64047973549,1000749586,15636712,18.3),(72472,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72472,37.16,0.46,270,27145,70,NULL,NULL,'2MASX J10364788+1250305',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000156,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,159.199583,12.84167,0.033,NULL,61185370557,956021414,14937834,16.8),(72473,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72473,37.12,0.33,265,27146,70,NULL,NULL,'2MASX J10364788+0603131',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,159.199666667,6.05364,0.057,NULL,61057714992,954026796,14906668,17.9),(72474,'SBF','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72474,32.68,0.47,34.3,27147,NULL,NULL,'I','ABELL 1060:[R89] 279',NULL,'2005A&A...438..103M',2005,1,NULL,NULL,'G',0.000146,NULL,'16.56',NULL,'E',NULL,NULL,NULL,NULL,1,159.2037917,-27.50042,NULL,NULL,41478705169,648104768,10126637,16.56),(72475,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72475,37.4,0.27,302,27148,70,NULL,NULL,'2MASX J10364899+0413091',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000153,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,159.204167,4.21911,0.057,NULL,61018038970,953406858,14896982,17.3),(72476,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72476,34.52,0.25,80.2,27149,74.4,NULL,NULL,'2MASX J10364911-2723192',NULL,'2013AJ....146...86T',2013,1,0.2,NULL,'G',0.00005,NULL,'15.76',0.19,'E/S0',NULL,NULL,NULL,NULL,1,159.204333,-27.38889,NULL,NULL,41478695873,648104623,10126634,15.76),(72477,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72477,37.51,0.46,317,27150,70,NULL,NULL,'2MASX J10364910+3534429',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000133,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,159.2047083,35.57867,0.045,NULL,64045481732,1000710652,15636103,17.7),(72478,'IRAS','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72478,34.6,0.8,83,27151,75,NULL,'MAT, I','ESO 568- G 019',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.24',0.9,'(R\')SB(r)a     HII',NULL,NULL,NULL,NULL,1,159.205833,-18.10636,0.193,NULL,41659404690,650928198,10170753,14.24),(72479,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72479,33.78,0.32,56.9,27151,85,NULL,'I, raw','ESO 568- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72480,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72480,33.82,0.32,58.1,27151,85,NULL,'I, inv','ESO 568- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72481,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72481,33.87,0.43,59.3,27151,75,NULL,'MAT, I, raw','ESO 568- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72482,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72482,33.95,0.43,61.6,27151,75,NULL,'MAT, I, cor','ESO 568- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72483,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72483,34.03,0.45,63.9,27151,NULL,NULL,'Malmquist cor.','ESO 568- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72484,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72484,34.08,0.43,65.6,27151,75,NULL,'MAT, I, inv','ESO 568- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72485,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72485,34.29,0.4,72.1,27151,NULL,NULL,NULL,'ESO 568- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72486,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72486,34.54,0.2,80.9,27151,74.4,NULL,NULL,'ESO 568- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72487,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72487,34.79,0.47,90.7,27151,NULL,NULL,'H','ESO 568- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72488,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72488,34.85,0.4,93.3,27151,NULL,NULL,'mean','ESO 568- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72489,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72489,34.96,0.46,98,27151,NULL,NULL,'J','ESO 568- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72490,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72490,34.97,0.45,98.5,27151,NULL,NULL,'K','ESO 568- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72491,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72491,33.02,0.43,40.2,27152,75,NULL,'3.6 micron, color + selection bias corrected','ESO 437- G 012',NULL,'2014MNRAS.444..527S',2014,1,1.4,NULL,'G',0.00015,NULL,'16.22',1.1,'Sb:',NULL,NULL,NULL,NULL,1,159.207208333,-30.62781,0.145,NULL,41981659165,655963424,10249428,16.22),(72492,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72492,37.4,0.27,302,27153,70,NULL,NULL,'2MASX J10364999+0413161',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,'FoF','17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,159.2082083,4.22117,0.057,NULL,61018038941,953406858,14896982,17.4),(72493,'SBF','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72493,33.5,0.47,50.2,27154,NULL,NULL,'I','NFP J103650.2-273047',NULL,'2005A&A...438..103M',2005,1,NULL,NULL,'G',0.000107,NULL,'17.1R',NULL,'dE,N',NULL,NULL,NULL,NULL,1,159.209167,-27.51325,NULL,NULL,41478660203,648104065,10126626,17.1),(72494,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72494,33.68,0.23,54.5,27155,74.4,NULL,NULL,'ESO 437- G 011',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.00005,NULL,'14.31',0.6,'S0(4)','Line-of-sight pair member',NULL,NULL,NULL,1,159.2102917,-27.91992,0.165,NULL,41479157327,648111833,10126747,14.31),(72495,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72495,34.25,0.4,70.7,27155,NULL,NULL,'mean','ESO 437- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72496,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72496,34.5,0.45,79.5,27155,NULL,NULL,'K','ESO 437- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72497,'SBF','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72497,32.73,0.44,35.1,27156,NULL,NULL,'I','ABELL 1060:[CZ2003]D0393[002]',NULL,'2005A&A...438..103M',2005,1,NULL,NULL,'G',0.000447,NULL,'17.4R',NULL,'dE',NULL,NULL,NULL,NULL,1,159.211667,-27.38397,NULL,NULL,41478695335,648104614,10126634,17.4),(72498,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72498,37.45,0.33,309,27157,70,NULL,NULL,'2MASX J10365162+1116053',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,159.215125,11.26806,0.065,NULL,61045898004,953842156,14903783,17.8),(72499,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72499,37.76,0.46,357,27158,70,NULL,NULL,'2MASX J10365221+3445299',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000175,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,159.21775,34.75839,0.041,NULL,64054853969,1000857093,15638392,17.4),(72500,'SBF','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72500,32.93,0.3,38.5,27159,NULL,NULL,'I','NFP J103652.6-273216',NULL,'2005A&A...438..103M',2005,1,NULL,NULL,'G',0.00015,NULL,'16.25',NULL,'S0',NULL,NULL,NULL,NULL,1,159.2190417,-27.53786,NULL,NULL,41479377660,648115275,10126801,16.25),(72501,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72501,37.59,0.46,329,27160,70,NULL,NULL,'SDSS J103652.69+341021.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,159.219541667,34.17272,0.013,NULL,64052016268,1000812754,15637699,18.3),(72502,'IRAS','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72502,32.85,0.8,37.1,27161,75,NULL,'MAT, I','ESO 437- G 014',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.00001,NULL,'13.46',0.8,'SA(s)ab: sp    HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.220333,-32.34836,0.285,NULL,41984845724,656013214,10250206,13.46),(72503,'IRAS','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72503,32.87,0.8,37.5,27161,75,NULL,'HMCL, I','ESO 437- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72504,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72504,32.34,0.3,29.4,27161,92,NULL,'I, Assuming Hydra cluster m-M = 33.2 mag','ESO 437- G 014',NULL,'1993AJ....105...97S',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72505,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72505,32.34,0.3,29.4,27161,92,NULL,'H, Assuming Hydra cluster m-M = 33.2 mag','ESO 437- G 014',NULL,'1993AJ....105...97S',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72506,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72506,32.53,NULL,32.1,27161,NULL,NULL,'B','ESO 437- G 014',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72507,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72507,32.53,NULL,32.1,27161,NULL,NULL,'I','ESO 437- G 014',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72508,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72508,32.55,0.4,32.3,27161,75,NULL,'HMCL, I, raw','ESO 437- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72509,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72509,32.71,0.4,34.9,27161,75,NULL,'HMCL, I, inv','ESO 437- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72510,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72510,32.75,0.45,35.6,27161,NULL,NULL,'K','ESO 437- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72511,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72511,32.76,0.47,35.6,27161,NULL,NULL,'H','ESO 437- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72512,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72512,32.81,0.46,36.5,27161,NULL,NULL,'J','ESO 437- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72513,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72513,32.86,0.38,37.3,27161,NULL,NULL,NULL,'ESO 437- G 014',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72514,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72514,32.88,0.43,37.6,27161,75,NULL,'3.6 micron, color + selection bias corrected','ESO 437- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72515,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72515,32.88,0.4,37.7,27161,75,NULL,'HMCL, I, cor','ESO 437- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72516,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72516,32.9,0.43,38.1,27161,75,NULL,'MAT, I, raw','ESO 437- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72517,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72517,32.94,0.32,38.7,27161,85,NULL,'I, raw','ESO 437- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72518,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72518,32.96,0.43,39,27161,75,NULL,'3.6 micron, color corrected','ESO 437- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72519,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72519,32.99,0.32,39.6,27161,85,NULL,'I, inv','ESO 437- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72520,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72520,33.1,0.2,41.7,27161,74.4,NULL,NULL,'ESO 437- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72521,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72521,33.13,0.4,42.2,27161,NULL,NULL,'mean','ESO 437- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72522,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72522,33.13,0.43,42.4,27161,75,NULL,'MAT, I, inv','ESO 437- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72523,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72523,33.23,0.43,44.3,27161,75,NULL,'MAT, I, cor','ESO 437- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72524,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72524,33.33,0.08,46.4,27161,NULL,NULL,NULL,'ESO 437- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72525,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72525,37.23,0.46,280,27162,70,NULL,NULL,'2MASX J10365304+2215037',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,159.2209583,22.25103,0.025,NULL,60993324776,953020699,14890948,17.1),(72526,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72526,33.89,0.43,59.8,27163,75,NULL,'3.6 micron, color + selection bias corrected','ESO 501- G 041',NULL,'2014MNRAS.444..527S',2014,1,0.8,NULL,'G',0.000027,NULL,'15.30',0.5,'SB?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.2214583,-27.05292,NULL,NULL,41478552050,648102375,10126599,15.3),(72527,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72527,36.77,0.46,226,27164,70,NULL,NULL,'2MASX J10365356+2817023',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.38',0.17,NULL,NULL,NULL,NULL,NULL,1,159.223125,28.28383,0.049,NULL,60475843814,944935059,14764610,18.38),(72528,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72528,37.45,0.33,309,27165,70,NULL,NULL,'SDSS J103653.86+111059.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00014,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,159.2244583,11.18317,0.085,NULL,61045375477,953833991,14903656,18),(72529,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72529,33.41,0.23,48.1,27166,74.4,NULL,NULL,'ESO 437- G 013',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.00004,NULL,'14.59',0.4,'S0(5)pec','Line-of-sight pair member',NULL,NULL,NULL,1,159.2245417,-27.91739,0.165,NULL,41479157427,648111834,10126747,14.59),(72530,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72530,33.91,0.4,60.6,27166,NULL,NULL,'mean','ESO 437- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72531,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72531,34.03,0.45,64,27166,NULL,NULL,'K','ESO 437- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72532,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72532,35.38,0.49,119,27167,75,NULL,'IR','CGCG 065-067',NULL,'2011yCatp016004901K',2011,1,1.35,NULL,'G',0.000023,NULL,'16.2g',0.16,'Scd',NULL,NULL,NULL,NULL,1,159.226375,9.66856,0.069,NULL,61046138639,953845916,14903842,16.2),(72533,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72533,35.89,0.2,151,27167,74.4,NULL,NULL,'CGCG 065-067',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72534,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72534,35.91,NULL,152,27167,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 065-067',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72535,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72535,35.92,NULL,153,27167,NULL,NULL,'Dipole + Quadrupole','CGCG 065-067',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72536,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72536,35.95,NULL,155,27167,NULL,NULL,'Dipole','CGCG 065-067',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72537,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72537,36.67,0.69,216,27168,70,NULL,NULL,'2MFGC 08245',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,159.2275417,-17.61911,0.177,NULL,41653094378,650829599,10169212,15.6),(72538,'Ring Diameter','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72538,32.2,0.84,27,27169,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3301',NULL,'1981ApJS...45..541P',1981,1,3.5,NULL,'G',0.000017,NULL,'12.31',1,'(R\')SB(rs)0/a','in a radial-velocity based grouping',NULL,NULL,NULL,1,159.2335,21.88214,0.013,NULL,60993470655,953022978,14890984,12.31),(72539,'Tully est','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72539,31.84,0.8,23.3,27169,75,NULL,'B','NGC 3301',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72540,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72540,33.59,0.47,52.3,27170,NULL,NULL,'H','ESO 501- G 042',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.00009,NULL,'14.49',0.4,'S(B)b(r)','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.2360417,-26.19425,0.261,NULL,41484749953,648199218,10128112,14.49),(72541,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72541,33.79,0.46,57.2,27170,NULL,NULL,'J','ESO 501- G 042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72542,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72542,33.8,0.45,57.4,27170,NULL,NULL,'K','ESO 501- G 042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72543,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72543,33.84,0.4,58.7,27170,NULL,NULL,'mean','ESO 501- G 042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72544,'SBF','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72544,32.96,0.44,39,27171,NULL,NULL,'I','2MASX J10365705-2734041',NULL,'2005A&A...438..103M',2005,1,0.19,NULL,'G',0.00006,NULL,'15.98',0.16,'E2',NULL,NULL,NULL,NULL,1,159.237416667,-27.56819,0.169,NULL,41479379723,648115308,10126801,15.98),(72545,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72545,37.63,0.46,336,27172,70,NULL,NULL,'SDSS J103657.47+024909.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000166,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,159.2395,2.81928,0.049,NULL,61003410461,953178288,14893410,18.2),(72546,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72546,35.67,0.5,136,27173,70,NULL,NULL,'2MASX J10365776-1739446',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.1b',NULL,'Sp',NULL,NULL,NULL,NULL,1,159.240667,-17.66244,0.177,NULL,41653084910,650829451,10169210,16.1),(72547,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72547,38.41,0.46,480,27174,70,NULL,NULL,'SDSS J103657.91+395336.8',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,159.241333333,39.89358,0,NULL,64116396892,1001818701,15653417,18.1),(72548,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72548,38.42,0.46,483,27175,70,NULL,NULL,'2MASX J10365804+1445377',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,159.241875,14.76058,0.093,NULL,61184093318,956001458,14937522,17.2),(72549,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72549,38.52,0.46,507,27176,70,NULL,NULL,'SDSS J103658.52+004620.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000079,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,159.243875,0.77231,0.149,NULL,60267925308,941686332,14713848,17.9),(72550,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72550,37.62,0.46,334,27177,70,NULL,NULL,'2MASX J10365985+2556249',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000179,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,159.249291667,25.94025,0.017,NULL,60471358876,944864982,14763515,17.2),(72551,'SBF','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72551,32.85,0.44,37.2,27178,NULL,NULL,'I','ABELL 1060:[CZ2003]D0393[103]',NULL,'2005A&A...438..103M',2005,1,NULL,NULL,'G',0.000157,NULL,'17.9R',NULL,'dE',NULL,NULL,NULL,NULL,1,159.250833,-27.49817,NULL,NULL,41478706741,648104792,10126637,17.9),(72552,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72552,38.12,0.46,420,27179,70,NULL,NULL,'SDSS J103701.40+372018.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000183,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,159.255875,37.33839,0,NULL,64115795376,1001809302,15653270,18.1),(72553,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72553,37.87,0.46,376,27180,70,NULL,NULL,'2MASX J10370171+5456293',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000144,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,159.257333,54.94144,0,NULL,61972116656,968314322,15129911,18.1),(72554,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72554,38.72,0.46,555,27181,70,NULL,NULL,'SDSS J103701.82+423348.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,159.257625,42.56336,0,NULL,64142071306,1002219864,15659685,18.5),(72555,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72555,38.05,0.46,408,27182,70,NULL,NULL,'2MASX J10370221+1225337',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000171,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,159.259125,12.42586,0.077,NULL,61176178722,955877792,14935590,17.4),(72556,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72556,36.95,0.19,245,27183,70,NULL,NULL,'2MASX J10370223+5004584',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000187,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,159.25925,50.08281,0,NULL,64126462862,1001975982,15655874,16.4),(72557,'Tully est','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72557,33.43,0.8,48.6,27184,75,NULL,'B','NGC 3312',NULL,'1988NBGC.C....0000T',1988,1,3.3,NULL,'G',0.00003,NULL,'12.68',1.3,'Sab(r%)p       AGN','Group member, radial-velocity confirmed',NULL,NULL,'LINER',1,159.2605,-27.56506,NULL,NULL,41478661965,648104093,10126626,12.68),(72558,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72558,33.19,0.4,43.4,27184,NULL,NULL,'mean','NGC 3312',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72559,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72559,33.23,0.46,44.3,27184,NULL,NULL,'J','NGC 3312',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72560,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72560,33.32,0.47,46,27184,NULL,NULL,'H','NGC 3312',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72561,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72561,33.41,0.45,48,27184,NULL,NULL,'K','NGC 3312',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72562,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72562,37.58,0.33,329,27185,70,NULL,NULL,'2MASX J10370312+1610087',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,159.263083,16.16914,0.073,NULL,61179920487,955936257,14936504,17),(72563,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72563,37.71,0.33,349,27186,70,NULL,NULL,'2MASX J10370479+1537217',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,159.2699583,15.62286,0.077,NULL,61180192922,955940514,14936570,17.2),(72564,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72564,33.7,0.4,55,27187,75,NULL,'Edat, raw','FLASH J103705.42-272357.4',NULL,'1997ApJS..109..333W',1997,1,0.78,NULL,'G',0.00004,NULL,'13.46',0.39,'S0(4)','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.2705,-27.39992,NULL,NULL,41478703773,648104746,10126636,13.46),(72565,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72565,33.72,0.4,55.4,27187,75,NULL,'Edat, cor','FLASH J103705.42-272357.4',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72566,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72566,36.89,0.46,239,27188,70,NULL,NULL,'2MASX J10370549+1236017',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000179,NULL,'17.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,159.273,12.60058,0.025,NULL,61184486042,956007594,14937618,17.1),(72567,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72567,35.91,0.58,152,27189,70,NULL,NULL,'2MASX J10370596-0746198',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.56',NULL,NULL,NULL,NULL,NULL,NULL,1,159.274917,-7.77225,0.061,NULL,41801971285,653155801,10205559,16.56),(72568,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72568,37.47,0.46,312,27190,70,NULL,NULL,'2MASX J10370599+2919509',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000168,NULL,'18.69',0.14,NULL,NULL,NULL,NULL,NULL,1,159.2752083,29.33083,0.037,NULL,60519706212,945620409,14775318,18.69),(72569,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72569,37.68,0.46,343,27191,70,NULL,NULL,'2MASX J10370725+2537169',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000168,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,159.280125,25.62142,0.013,NULL,60471011465,944859554,14763430,17.2),(72570,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72570,37.73,0.27,351,27192,70,NULL,NULL,'2MASX J10370825+0213151',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000174,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,159.2842083,2.22097,0.053,NULL,61003896542,953185883,14893529,17.2),(72571,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72571,35.06,0.46,103,27193,70,NULL,NULL,'CGCG 212-029',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000171,NULL,'15.4g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,159.287167,39.94878,0,NULL,64116416473,1001819007,15653421,15.4),(72572,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72572,37.33,0.33,292,27194,70,NULL,NULL,'2MASX J10370908+4714512',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000176,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,159.288,47.24756,0,NULL,64136864173,1002138502,15658414,16.7),(72573,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72573,33.7,0.4,55,27195,75,NULL,'Edat, raw','2MASX J10370969-2739281',NULL,'1997ApJS..109..333W',1997,1,0.41,NULL,'G',0.000011,NULL,'15.32',0.25,'E3/S0',NULL,NULL,NULL,NULL,1,159.290083333,-27.65814,0.165,NULL,41479375628,648115244,10126800,15.32),(72574,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72574,33.72,0.4,55.4,27195,75,NULL,'Edat, cor','2MASX J10370969-2739281',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72575,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72575,33.83,0.25,58.3,27195,74.4,NULL,NULL,'2MASX J10370969-2739281',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72576,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72576,37.73,0.27,351,27196,70,NULL,NULL,'2MASX J10371005+0212311',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00008,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,159.2919583,2.20856,0.053,NULL,61003895089,953185860,14893529,17.5),(72577,'IRAS','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72577,33.25,0.8,44.6,27197,75,NULL,'CF, r','NGC 3306',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000003,NULL,'14.00',0.5,'SB(s)m?','Possible field galaxy',NULL,NULL,NULL,1,159.292583,12.65247,0.029,NULL,61184490957,956007671,14937619,14),(72578,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72578,32.21,0.69,27.7,27197,100,NULL,'mid-IR','NGC 3306',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72579,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72579,32.71,0.43,34.8,27197,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3306',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72580,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72580,32.99,0.43,39.7,27197,75,NULL,'3.6 micron, color corrected','NGC 3306',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72581,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72581,33.34,0.2,46.6,27197,74.4,NULL,NULL,'NGC 3306',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72582,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72582,33.34,0.37,46.6,27197,NULL,NULL,NULL,'NGC 3306',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72583,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72583,33.49,0.38,49.9,27197,75,NULL,'CF, r, raw','NGC 3306',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72584,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72584,33.56,0.38,51.5,27197,75,NULL,'CF, r, cor','NGC 3306',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72585,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72585,33.56,0.38,51.6,27197,75,NULL,'CF, r, inv','NGC 3306',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72586,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72586,33.6,0.65,52.5,27197,NULL,NULL,NULL,'NGC 3306',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72587,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72587,33.68,0.63,54.3,27197,NULL,NULL,'Malmquist cor.','NGC 3306',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72588,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72588,37.59,0.46,329,27198,70,NULL,NULL,'2MASX J10371031+4131295',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00018,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,159.292875,41.52497,0,NULL,64141648767,1002213261,15659582,17.4),(72589,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72589,35.07,0.51,103,27199,70,NULL,NULL,'2MASX J10371091-0936408',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000127,NULL,'15.38',NULL,NULL,NULL,NULL,NULL,NULL,1,159.2954583,-9.61136,0.085,NULL,41763858412,652560287,10196254,15.38),(72590,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72590,37.42,0.46,305,27200,70,NULL,NULL,'2MASX J10371108+4430422',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000177,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,159.2960417,44.51186,0,NULL,64140998946,1002203108,15659423,16.5),(72591,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72591,37.57,0.33,327,27201,70,NULL,NULL,'2MASX J10371144+2825259',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,159.297625,28.42383,0.049,NULL,60523285745,945676339,14776192,17.3),(72592,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72592,36.66,0.46,215,27202,70,NULL,NULL,'2MASX J10371220+2631369',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000181,NULL,'16.0g',0.38,NULL,NULL,NULL,NULL,NULL,1,159.300917,26.52686,0.037,NULL,60470589443,944852960,14763327,16),(72593,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72593,38.45,0.46,489,27203,70,NULL,NULL,'SDSS J103712.51+103358.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000176,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,159.302125,10.56614,0.105,NULL,61047068397,953860443,14904069,18),(72594,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72594,32.1,0.47,26.3,27204,NULL,NULL,'H','NGC 3314A',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000027,NULL,'14.40',0.7,'Sab: sp        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.3035417,-27.68394,0.165,NULL,41479112438,648111131,10126736,14.4),(72595,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72595,32.26,0.45,28.3,27204,NULL,NULL,'K','NGC 3314A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72596,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72596,32.27,0.46,28.5,27204,NULL,NULL,'J','NGC 3314A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72597,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72597,33.19,0.4,43.4,27204,NULL,NULL,'mean','NGC 3314A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72598,'Tully est','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72598,33.43,0.8,48.6,27205,75,NULL,NULL,'NGC 3314',NULL,'1988NBGC.C....0000T',1988,1,NULL,NULL,'GPair',NULL,NULL,NULL,NULL,'(Sab:) + (Sc:)','Brightest group member',NULL,NULL,NULL,1,159.305,-27.68444,0.165,NULL,41479112446,648111131,10126736,NULL),(72599,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72599,35.87,0.46,149,27206,70,NULL,NULL,'2MASX J10371343+1706227',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',NULL,NULL,'16.43',0.44,NULL,NULL,NULL,NULL,NULL,1,159.3060417,17.10644,0.053,NULL,60959318111,952489345,14882646,16.43),(72600,'SBF','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72600,33.15,0.44,42.7,27207,NULL,NULL,'I','ABELL 1060:[CZ2003]B0494[075]',NULL,'2005A&A...438..103M',2005,1,NULL,NULL,'G',0.000123,NULL,'18.2R',NULL,'dE',NULL,NULL,NULL,NULL,1,159.307083,-27.507,NULL,NULL,41478657048,648104016,10126625,18.2),(72601,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72601,37.36,0.46,296,27208,70,NULL,NULL,'2MASX J10371416+3740305',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000173,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,159.308833333,37.67519,0,NULL,64115995388,1001812427,15653319,16.3),(72602,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72602,37.73,0.27,351,27209,70,NULL,NULL,'2MASX J10371492+0217081',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000165,NULL,'17.0g',0.24,'BrClG',NULL,NULL,NULL,NULL,1,159.3122083,2.28558,0.053,NULL,61003922251,953186285,14893535,17),(72603,'SBF','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72603,32.7,0.49,34.7,27210,NULL,NULL,'I','NGC 3318',NULL,'2001ApJ...546..681T',2001,1,2.4,'Confused HIPASS source','G',0.000021,NULL,'12.19',1.3,'SAB(rs)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.314625,-41.62756,0.325,NULL,42128726807,658261356,10285333,12.19),(72604,'SBF','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72604,32.74,0.12,35.3,27210,74.4,NULL,NULL,'NGC 3318',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72605,'IRAS','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72605,32.73,0.8,35.2,27210,75,NULL,'MAT, I','NGC 3318',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72606,'IRAS','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72606,32.74,0.8,35.3,27210,75,NULL,'HMCL, I','NGC 3318',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72607,'Tully est','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72607,32.89,0.8,37.9,27210,75,NULL,'B','NGC 3318',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72608,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72608,32.59,0.43,33,27210,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3318',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72609,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72609,32.65,0.43,34,27210,75,NULL,'3.6 micron, color corrected','NGC 3318',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72610,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72610,32.73,0.32,35.1,27210,85,NULL,'I, raw','NGC 3318',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72611,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72611,32.74,0.12,35.3,27210,74.4,NULL,NULL,'NGC 3318',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72612,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72612,32.76,0.43,35.7,27210,75,NULL,'MAT, I, raw','NGC 3318',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72613,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72613,32.78,0.32,36,27210,85,NULL,'I, inv','NGC 3318',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72614,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72614,32.89,0.46,37.9,27210,NULL,NULL,'J','NGC 3318',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72615,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72615,32.9,0.45,38,27210,NULL,NULL,'K','NGC 3318',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72616,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72616,32.92,0.47,38.3,27210,NULL,NULL,'H','NGC 3318',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72617,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72617,32.98,0.4,39.5,27210,75,NULL,'HMCL, I, raw','NGC 3318',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72618,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72618,33,0.4,39.8,27210,NULL,NULL,'mean','NGC 3318',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72619,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72619,33.01,0.43,39.9,27210,75,NULL,'MAT, I, cor','NGC 3318',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72620,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72620,33.01,0.43,40,27210,75,NULL,'MAT, I, inv','NGC 3318',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72621,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72621,33.18,0.4,43.3,27210,75,NULL,'HMCL, I, cor','NGC 3318',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72622,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72622,33.2,0.4,43.6,27210,75,NULL,'HMCL, I, inv','NGC 3318',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72623,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72623,33.21,0.09,43.9,27210,NULL,NULL,NULL,'NGC 3318',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72624,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72624,36.43,0.54,193,27211,70,NULL,NULL,'2MASX J10371625-1127298',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.02',NULL,NULL,NULL,NULL,NULL,NULL,1,159.317666667,-11.45844,0.133,NULL,41765819627,652590931,10196733,16.02),(72625,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72625,33.7,0.4,55,27212,75,NULL,'Edat, raw','ESO 501- G 047',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000033,NULL,'14.8',0.4,'SB0^0^:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.320833,-27.46919,NULL,NULL,41478712018,648104875,10126638,14.8),(72626,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72626,33.72,0.4,55.4,27212,75,NULL,'Edat, cor','ESO 501- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72627,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72627,33.32,0.25,46.1,27212,74.4,NULL,NULL,'ESO 501- G 047',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72628,'SBF','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72628,33.12,0.42,42.1,27213,NULL,NULL,'I','ABELL 1060:[CZ2003]B0393[109]',NULL,'2005A&A...438..103M',2005,1,NULL,NULL,'G',0.000136,NULL,'17.1R',NULL,'dE,N',NULL,NULL,NULL,NULL,1,159.322083,-27.59269,NULL,NULL,41478654702,648103979,10126624,17.1),(72629,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72629,37.57,0.46,326,27214,70,NULL,NULL,'2MASX J10371791+3440473',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,159.324667,34.67989,0.041,NULL,64054732220,1000855190,15638362,17.4),(72630,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72630,37.71,0.33,349,27215,70,NULL,NULL,'2MASX J10371821+1531307',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,159.325916667,15.52525,0.077,NULL,61180173564,955940211,14936565,17.7),(72631,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72631,37.32,0.46,292,27216,70,NULL,NULL,'2MASX J10371859+6012312',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00014,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,159.3274583,60.20878,0,NULL,61958045168,968094455,15126475,17.5),(72632,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72632,37.3,0.46,289,27217,70,NULL,NULL,'2MASX J10371909+1107141',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000142,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,159.32975,11.12056,0.085,NULL,61045309324,953832958,14903639,17.3),(72633,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72633,33.7,0.4,55,27218,75,NULL,'Edat, raw','NGC 3315',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'14.42',1,'S0-?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.330125,-27.19231,NULL,NULL,41478563473,648102554,10126602,14.42),(72634,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72634,33.72,0.4,55.4,27218,75,NULL,'Edat, cor','NGC 3315',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72635,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72635,33.49,0.25,49.9,27218,74.4,NULL,NULL,'NGC 3315',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72636,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72636,37.38,0.46,300,27219,70,NULL,NULL,'2MASX J10371936+5501174',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000147,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,159.3302917,55.02147,0,NULL,61972048407,968313256,15129894,16.8),(72637,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72637,34.86,0.46,93.6,27220,70,NULL,NULL,'UGC 05771',NULL,'2015arXiv151105856S',2015,1,1.25,NULL,'G',0.000173,NULL,'14.1g',0.81,'S0/a',NULL,NULL,NULL,NULL,1,159.3305417,43.58758,0,NULL,64142577480,1002227773,15659808,14.1),(72638,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72638,37.86,0.46,373,27221,70,NULL,NULL,'2MASX J10371940+0124521',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000141,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,159.330833,1.41456,0.069,NULL,60267324018,941676937,14713702,17.3),(72639,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72639,38.51,0.46,504,27222,70,NULL,NULL,'2MASX J10371993+1302307',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000193,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,159.333166667,13.04181,0.033,NULL,61185347240,956021050,14937828,17.6),(72640,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72640,33.7,0.4,55,27223,75,NULL,'Edat, raw','ESO 501- G 049',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000047,NULL,'15.15',0.3,'SB(s)0(6)','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.3335417,-27.55992,NULL,NULL,41478667684,648104182,10126627,15.15),(72641,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72641,33.72,0.4,55.4,27223,75,NULL,'Edat, cor','ESO 501- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72642,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72642,33.58,0.23,52,27223,74.4,NULL,NULL,'ESO 501- G 049',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72643,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72643,33.91,0.4,60.6,27223,NULL,NULL,'mean','ESO 501- G 049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72644,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72644,34.12,0.45,66.7,27223,NULL,NULL,'K','ESO 501- G 049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72645,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72645,37.31,0.27,290,27224,70,NULL,NULL,'2MASX J10372028+0613311',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000149,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,159.3344583,6.22519,0.057,NULL,61057741151,954027205,14906675,17.1),(72646,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72646,37.63,0.46,335,27225,70,NULL,NULL,'2MASX J10372085+1958347',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,159.336833,19.97633,0.005,NULL,61000622533,953134727,14892730,18),(72647,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72647,37.4,0.27,302,27226,70,NULL,NULL,'2MASX J10372120+0407561',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,'FoF','16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,159.338416667,4.13225,0.057,NULL,61018157370,953408708,14897011,16.3),(72648,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72648,38.5,0.46,502,27227,70,NULL,NULL,'2MASX J10372149+4021295',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.0002,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,159.339416667,40.35828,0,NULL,64116264314,1001816629,15653384,17.3),(72649,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72649,35.55,0.2,129,27228,74.4,NULL,NULL,'CGCG 065-071',NULL,'2013AJ....146...86T',2013,1,0.94,NULL,'G',0.000014,NULL,'15.7g',0.26,'Sb',NULL,NULL,NULL,NULL,1,159.340833,9.77064,0.069,NULL,61046908394,953857943,14904030,15.7),(72650,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72650,35.17,NULL,108,27229,NULL,NULL,'Dipole','UGC 05775',NULL,'2010Ap&SS.325..163P',2010,1,1.59,NULL,'G',0.000834,NULL,'16.0',0.21,'Sc',NULL,NULL,NULL,NULL,1,159.342125,37.07758,0,NULL,64115770796,1001808918,15653264,16),(72651,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72651,35.18,NULL,109,27229,NULL,NULL,'Dipole + Quadrupole','UGC 05775',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72652,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72652,35.18,NULL,109,27229,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05775',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72653,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72653,35.26,0.49,112,27229,75,NULL,'IR','UGC 05775',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72654,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72654,35.55,0.44,129,27229,NULL,NULL,'Malmquist cor.','UGC 05775',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72655,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72655,35.59,0.2,131,27229,74.4,NULL,NULL,'UGC 05775',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72656,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72656,35.67,0.42,136,27229,NULL,NULL,NULL,'UGC 05775',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72657,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72657,37.74,0.46,353,27230,70,NULL,NULL,'2MASX J10372293+1921080',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000209,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,159.345666667,19.35228,0.025,NULL,60988563768,952946308,14889786,16.9),(72658,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72658,37.58,0.33,329,27231,70,NULL,NULL,'SDSS J103725.46+161343.4',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.7g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,159.356125,16.22875,0.057,NULL,61179722253,955933160,14936455,16.7),(72659,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72659,37.56,0.46,325,27232,70,NULL,NULL,'SDSS J103726.64+094125.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,159.3610417,9.69039,0.069,NULL,61046875880,953857435,14904022,18.1),(72660,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72660,37.89,0.46,378,27233,70,NULL,NULL,'2MASX J10372696+2057110',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,159.3622083,20.95331,0.013,NULL,61000274635,953129291,14892645,17.2),(72661,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72661,37.95,0.33,389,27234,70,NULL,NULL,'SDSS J103727.08+114133.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,159.362833,11.69269,0.129,NULL,61045829059,953841079,14903766,18.2),(72662,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72662,37.32,0.46,291,27235,70,NULL,NULL,'2MASX J10372820+3104563',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000159,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,159.367333,31.08228,0.025,NULL,64047843886,1000747560,15636680,17),(72663,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72663,37.95,0.33,389,27236,70,NULL,NULL,'2MASX J10372819+1141421',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,159.367417,11.69497,0.129,NULL,61045829116,953841079,14903766,17.5),(72664,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72664,37.67,0.33,342,27237,70,NULL,NULL,'2MASX J10372840+1601117',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,159.36825,16.02,0.069,NULL,61179944123,955936626,14936509,16.9),(72665,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72665,37.87,0.46,375,27238,70,NULL,NULL,'2MASX J10372848+1357257',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000171,NULL,'17.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,159.368791667,13.95717,0.065,NULL,61186457141,956038392,14938099,17.8),(72666,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72666,31.99,NULL,25,27239,NULL,NULL,NULL,'FGC 125A',NULL,'2015AstBu..70....1K',2015,1,0.95,NULL,'G',0.000098,NULL,NULL,0.24,NULL,NULL,NULL,NULL,NULL,1,159.369833333,12.39617,0.021,NULL,61176195209,955878050,14935594,NULL),(72667,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72667,32.48,0.4,31.4,27240,75,NULL,NULL,'UGC 05765',NULL,'2008Ap.....51..336K',2008,1,1.7,NULL,'G',0.00004,NULL,'15.09',0.2,'Sbc',NULL,NULL,NULL,NULL,1,159.3704583,68.8195,0.045,NULL,62139274460,970926163,15170721,15.09),(72668,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72668,32.96,0.43,39.1,27240,75,NULL,'3.6 micron, color + selection bias corrected','UGC 05765',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72669,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72669,33.12,0.49,42,27240,75,NULL,'IR','UGC 05765',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72670,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72670,36.23,0.33,176,27241,70,NULL,NULL,'2MASX J10372896+0113303',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000071,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,159.370708333,1.22503,0.077,NULL,60267848210,941685128,14713830,16.7),(72671,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72671,37.89,0.46,378,27242,70,NULL,NULL,'2MASX J10372903+0011393',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000083,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,159.370875,0.19428,0.141,NULL,60265585454,941649772,14713277,17.4),(72672,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72672,32.39,0.69,30.1,27243,100,NULL,'mid-IR','ESO 501- G 051',NULL,'2013ApJ...771...88L',2013,1,2.7,NULL,'G',0.00002,NULL,'13.01',1.5,'(R\')SA(r)a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.371167,-26.317,0.261,NULL,41483861072,648185329,10127895,13.01),(72673,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72673,33.64,0.4,53.4,27243,NULL,NULL,'mean','ESO 501- G 051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72674,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72674,33.94,0.47,61.3,27243,NULL,NULL,'H','ESO 501- G 051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72675,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72675,33.95,0.46,61.7,27243,NULL,NULL,'J','ESO 501- G 051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72676,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72676,33.97,0.45,62.2,27243,NULL,NULL,'K','ESO 501- G 051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72677,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72677,34.42,0.2,76.6,27243,74.4,NULL,NULL,'ESO 501- G 051',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72678,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72678,37.89,0.46,378,27244,70,NULL,NULL,'2MASX J10372994+4010113',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,159.374875,40.16994,0,NULL,64116391502,1001818617,15653415,17.7),(72679,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72679,37.22,0.46,278,27245,70,NULL,NULL,'SDSS J103730.42-001207.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000081,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,159.3767917,-0.20222,0.145,NULL,40871913218,638623644,9978494,18.8),(72680,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72680,36.79,0.46,228,27246,70,NULL,NULL,'2MASX J10373072+2712022',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000192,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,159.378,27.20061,0.029,NULL,60475603219,944931300,14764551,16.8),(72681,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72681,38.18,0.46,432,27247,70,NULL,NULL,'2MASX J10373083+3054183',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,159.3784583,30.90511,0.033,NULL,64047970509,1000749539,15636711,17.7),(72682,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72682,37.24,0.46,280,27248,70,NULL,NULL,'2MASX J10373162+4118034',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,159.3817083,41.30106,0,NULL,64141632331,1002213005,15659578,17.9),(72683,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:47','1','SN 2006ar',NULL,72683,34.46,0.18,76.3,27249,74.2,NULL,'SALT 2','CGCG 313-029',0.022538,'2010ApJ...716..712A',2010,1,0.7,NULL,'G',0.000096,NULL,'15.4g',0.32,'Sc',NULL,NULL,NULL,NULL,1,159.383291667,65.01828,0.017,NULL,62116509903,970570467,15165163,15.4),(72684,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:47','1','SN 2006ar',NULL,72684,35.05,0.09,102,27249,74.4,NULL,NULL,'CGCG 313-029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72685,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:47','1','SN 2006ar',NULL,72685,35.15,0.03,105,27249,72,NULL,'MLCS17','CGCG 313-029',0.022538,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72686,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:47','1','SN 2006ar',NULL,72686,35.15,0.22,105,27249,65,NULL,'MLCS17','CGCG 313-029',0.022538,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72687,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:47','1','SN 2006ar',NULL,72687,35.25,0.28,110,27249,65,NULL,'MLCS31','CGCG 313-029',0.022538,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72688,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:47','1','SN 2006ar',NULL,72688,35.31,0.19,113,27249,65,NULL,'SALT','CGCG 313-029',0.022538,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72689,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:47','1','SN 2006ar',NULL,72689,35.37,0.21,116,27249,65,NULL,'SALT2','CGCG 313-029',0.022538,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72690,'SNIa','2016-12-15 15:14:39','2016-12-16 11:19:47','1','SN 2006ar',NULL,72690,36.23,0.03,173,27249,70,NULL,'SALT 2','CGCG 313-029',0.022538,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72691,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72691,34.65,0.52,85.1,27250,70,NULL,NULL,'2MASX J10373269-4322085',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,159.386291667,-43.369,0.505,NULL,42130861820,658294715,10285854,16.5),(72692,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72692,34.94,0.49,97.3,27251,75,NULL,'IR','UGC 05779',NULL,'2011yCatp016004901K',2011,1,1.28,NULL,'G',0.00004,NULL,'15.7g',0.22,'Sc(f)','Pair member (points to parent)',NULL,NULL,NULL,1,159.388083,5.62861,0.069,NULL,61012478472,953319976,14895624,15.7),(72693,'IRAS','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72693,32.72,0.8,35,27252,75,NULL,'MAT, I','NGC 3318B',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'13.89',1.1,'SB(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.391,-41.46539,0.325,NULL,42128896864,658264013,10285375,13.89),(72694,'IRAS','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72694,32.72,0.8,35,27252,75,NULL,'HMCL, I','NGC 3318B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72695,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72695,31.86,0.32,23.5,27252,85,NULL,'I, inv','NGC 3318B',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72696,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72696,31.86,0.32,23.6,27252,85,NULL,'I, raw','NGC 3318B',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72697,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72697,32.01,0.43,25.2,27252,75,NULL,'MAT, I, inv','NGC 3318B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72698,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72698,32.02,0.43,25.3,27252,75,NULL,'MAT, I, raw','NGC 3318B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72699,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72699,32.46,0.43,31.1,27252,75,NULL,'MAT, I, cor','NGC 3318B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72700,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72700,32.47,0.4,31.1,27252,75,NULL,'HMCL, I, raw','NGC 3318B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72701,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72701,32.51,0.4,31.8,27252,75,NULL,'HMCL, I, inv','NGC 3318B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72702,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72702,32.74,0.4,35.3,27252,75,NULL,'HMCL, I, cor','NGC 3318B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72703,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72703,33.21,0.11,43.9,27252,NULL,NULL,NULL,'NGC 3318B',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72704,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72704,37.57,0.33,327,27253,70,NULL,NULL,'2MASX J10373396+2830112',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,159.391791667,28.50314,0.045,NULL,60523293158,945676455,14776194,17.9),(72705,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72705,37.53,0.46,321,27254,70,NULL,NULL,'2MASX J10373608+0239153',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,159.4004583,2.65425,0.057,NULL,61003963196,953186924,14893545,17),(72706,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72706,37.31,0.27,290,27255,70,NULL,NULL,'2MASX J10373610+0617451',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000133,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,159.4004583,6.29592,0.057,NULL,61057618667,954025291,14906645,17.6),(72707,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72707,35.77,0.61,142,27256,70,NULL,NULL,'2MFGC 08254',NULL,'2014MNRAS.445.2677S',2014,1,0.91,NULL,'G',0.00015,NULL,'16.14',0.23,NULL,NULL,NULL,NULL,NULL,1,159.4005417,-7.43747,0.069,NULL,41801746098,653152282,10205504,16.14),(72708,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72708,35.5,0.4,126,27257,NULL,NULL,'mean','IC 0628',NULL,'2007A&A...465...71T',2007,1,1.06,'RC3 has V = 7170 +- 12 km/s.  UZC agrees with SDSS.','G',0.000184,NULL,'14.6g',0.74,'SAB(s)ab','Pair member (points to parent)',NULL,NULL,NULL,1,159.400791667,5.60369,0.073,NULL,61012477589,953319962,14895624,14.6),(72709,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72709,35.71,0.47,139,27257,NULL,NULL,'H','IC 0628',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72710,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72710,35.08,0.49,104,27258,75,NULL,'IR','ESO 437- G 016',NULL,'2011yCatp016004901K',2011,1,1.32,NULL,'G',0.000033,NULL,'16.53',0.16,'Sc',NULL,NULL,NULL,NULL,1,159.4032917,-32.44389,0.261,NULL,41984101599,656001587,10250024,16.53),(72711,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72711,35.23,NULL,111,27258,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 437- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72712,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72712,35.24,NULL,112,27258,NULL,NULL,'Dipole + Quadrupole','ESO 437- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72713,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72713,35.25,NULL,112,27258,NULL,NULL,'Dipole','ESO 437- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72714,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72714,33.7,0.4,55,27259,75,NULL,'Edat, raw','NGC 3316',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000027,NULL,'13.64',1.1,'SB(rs)0^0^:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.4055,-27.59431,NULL,NULL,41534174461,648971475,10140179,13.64),(72715,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72715,33.72,0.4,55.4,27259,75,NULL,'Edat, cor','NGC 3316',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72716,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72716,33.41,0.49,48.1,27259,70,NULL,NULL,'NGC 3316',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72717,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72717,34.06,0.4,65,27259,NULL,NULL,'mean','NGC 3316',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72718,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72718,34.23,0.45,70.2,27259,NULL,NULL,'K','NGC 3316',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72719,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72719,37.67,0.33,342,27260,70,NULL,NULL,'2MASX J10373903+1557198',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,159.4127083,15.95569,0.069,NULL,61179893098,955935829,14936497,17.7),(72720,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72720,36.09,0.46,165,27261,70,NULL,NULL,'2MASX J10373968+2338441',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'16.70',0.17,NULL,NULL,NULL,NULL,NULL,1,159.4155,23.64569,0.013,NULL,60943406407,952240725,14878761,16.7),(72721,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72721,35.61,0.53,133,27262,70,NULL,NULL,'LCRS B103509.7-062901',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.38',0.4,NULL,NULL,NULL,NULL,NULL,1,159.4184583,-6.74694,0.109,NULL,41803180733,653174698,10205854,16.38),(72722,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72722,32.56,0.25,32.5,27263,74.4,NULL,NULL,'2MASX J10374052-2703284',NULL,'2013AJ....146...86T',2013,1,0.51,'Christlein & Zabludoff (2003ApJ...591..764C) give v=3124+/-80 km/sec.','G',0.00008,NULL,'16.37',0.23,'S0a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.418917,-27.05797,NULL,NULL,41478531204,648102050,10126594,16.37),(72723,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72723,38.03,0.46,404,27264,70,NULL,NULL,'2MASX J10374055+1253339',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,159.418917,12.89267,0.029,NULL,61184811609,956012681,14937698,17.8),(72724,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72724,36.23,0.33,176,27265,70,NULL,NULL,'2MASX J10374142+0119563',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000147,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,159.422625,1.33231,0.077,NULL,60267309038,941676703,14713698,17),(72725,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72725,34.13,0.25,67,27266,74.4,NULL,NULL,'2MASX J10374157-2702394',NULL,'2013AJ....146...86T',2013,1,0.29,NULL,'G',0.000057,NULL,'17.48',0.25,'E1','Compact group member',NULL,NULL,NULL,1,159.4227083,-27.04453,NULL,NULL,41478534109,648102095,10126595,17.48),(72726,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72726,34.59,0.49,82.7,27267,75,NULL,'IR','UGC 05778',NULL,'2011yCatp016004901K',2011,1,1.28,NULL,'G',0.000132,NULL,'16.2g',0.2,'Scd',NULL,NULL,NULL,NULL,1,159.424583,46.0425,0,NULL,64133571419,1002087053,15657610,16.2),(72727,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72727,35.31,NULL,115,27267,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05778',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72728,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72728,35.33,NULL,116,27267,NULL,NULL,'Dipole + Quadrupole','UGC 05778',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72729,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72729,35.34,NULL,117,27267,NULL,NULL,'Dipole','UGC 05778',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72730,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72730,35.35,NULL,117,27267,NULL,NULL,NULL,'UGC 05778',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72731,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72731,37.96,0.46,391,27268,70,NULL,NULL,'2MASX J10374213+3411593',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000084,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,159.425625,34.19986,0.017,NULL,64055020301,1000859692,15638432,18.2),(72732,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72732,38.2,0.46,437,27269,70,NULL,NULL,'2MASX J10374336-0039162',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000092,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,159.430583,-0.65469,0.117,NULL,40872849836,638638278,9978723,17.2),(72733,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72733,38.04,0.46,406,27270,70,NULL,NULL,'SDSS J103745.04+055331.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000125,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,159.4377083,5.892,0.057,NULL,61012471390,953319865,14895622,18.2),(72734,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72734,33.89,0.25,60,27271,74.4,NULL,NULL,'ESO 501- G 056',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.00008,NULL,'13.76',0.5,'S0(7)/a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.43875,-26.63072,0.265,NULL,41483787621,648184181,10127877,13.76),(72735,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72735,33.58,0.45,52.1,27271,NULL,NULL,'K','ESO 501- G 056',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72736,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72736,33.93,0.4,61,27271,NULL,NULL,'mean','ESO 501- G 056',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72737,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72737,36.45,0.46,195,27272,70,NULL,NULL,'2MASX J10374732+3948454',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000198,NULL,'15.6g',0.45,'E0',NULL,NULL,NULL,NULL,1,159.4472917,39.81275,0,NULL,64117081937,1001829405,15653584,15.6),(72738,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72738,33.14,0.23,42.5,27273,74.4,NULL,NULL,'IC 2597',NULL,'2013AJ....146...86T',2013,1,2.6,NULL,'G',0.00004,NULL,'12.84',1.8,'E+4','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.4477083,-27.08169,NULL,NULL,41478532493,648102070,10126594,12.84),(72739,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72739,33.29,0.4,45.5,27273,NULL,NULL,'mean','IC 2597',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72740,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72740,33.69,0.45,54.7,27273,NULL,NULL,'K','IC 2597',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72741,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72741,37.48,0.13,313,27274,70,NULL,NULL,'2MASX J10374857+0514413',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000186,NULL,'16.2g',0.41,NULL,NULL,NULL,NULL,NULL,1,159.452333333,5.24478,0.081,NULL,61014740002,953355312,14896176,16.2),(72742,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72742,38.03,0.46,404,27275,70,NULL,NULL,'2MASX J10374918+3121114',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000178,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,159.4550417,31.35322,0.025,NULL,64047362050,1000740032,15636563,16.6),(72743,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72743,37.62,0.46,333,27276,70,NULL,NULL,'2MASX J10375047+3158064',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,159.460166667,31.96836,0.033,NULL,64051195824,1000799934,15637498,17.1),(72744,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72744,37.9,0.46,380,27277,70,NULL,NULL,'SDSS J103750.54+245038.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000144,NULL,'18.6g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,159.460625,24.844,0.013,NULL,60470101025,944845328,14763208,18.6),(72745,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72745,36.42,0.46,192,27278,70,NULL,NULL,'2MASX J10375104+1651480',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,159.4627083,16.86333,0.053,NULL,60959459518,952491554,14882680,16.5),(72746,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72746,37.65,0.46,339,27279,70,NULL,NULL,'2MASX J10375129+3121274',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000189,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,159.4637083,31.35778,0.025,NULL,64047360056,1000740000,15636562,17.1),(72747,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72747,38.36,0.33,469,27280,70,NULL,NULL,'2MASX J10375164+0417443',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000174,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,159.46525,4.29564,0.057,NULL,61018192793,953409262,14897019,17),(72748,'IRAS','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72748,33.28,0.8,45.3,27281,75,NULL,'HMCL, I','ESO 437- G 018',NULL,'1997ApJS..109..333W',1997,1,2.17,NULL,'G',0.000027,NULL,'13.00',0.31,'Sb             HII',NULL,NULL,NULL,NULL,1,159.4667083,-30.66878,0.177,NULL,41981651120,655963298,10249426,13),(72749,'IRAS','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72749,33.3,0.8,45.7,27281,75,NULL,'MAT, I','ESO 437- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72750,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72750,33.6,0.32,52.4,27281,85,NULL,'I, raw','ESO 437- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72751,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72751,33.61,0.32,52.8,27281,85,NULL,'I, inv','ESO 437- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72752,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72752,33.71,NULL,55.1,27281,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 437- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72753,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72753,33.71,NULL,55.3,27281,NULL,NULL,'Dipole + Quadrupole','ESO 437- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72754,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72754,33.72,NULL,55.4,27281,NULL,NULL,'Dipole','ESO 437- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72755,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72755,33.73,0.43,55.7,27281,75,NULL,'MAT, I, raw','ESO 437- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72756,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72756,33.76,0.12,56.6,27281,NULL,NULL,NULL,'ESO 437- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72757,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72757,33.77,0.43,56.7,27281,75,NULL,'MAT, I, cor','ESO 437- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72758,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72758,33.78,NULL,57,27281,NULL,NULL,NULL,'ESO 437- G 018',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72759,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72759,33.85,0.43,58.8,27281,75,NULL,'MAT, I, inv','ESO 437- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72760,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72760,33.86,0.43,59.1,27281,75,NULL,'3.6 micron, color + selection bias corrected','ESO 437- G 018',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72761,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72761,33.97,0.43,62.1,27281,75,NULL,'3.6 micron, color corrected','ESO 437- G 018',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72762,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72762,33.99,0.4,62.9,27281,75,NULL,'HMCL, I, cor','ESO 437- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72763,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72763,34.03,0.4,64.1,27281,75,NULL,'HMCL, I, raw','ESO 437- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72764,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72764,34.1,0.2,66.1,27281,74.4,NULL,NULL,'ESO 437- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72765,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72765,34.16,0.4,68,27281,75,NULL,'HMCL, I, inv','ESO 437- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72766,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72766,34.18,0.4,68.5,27281,NULL,NULL,NULL,'ESO 437- G 018',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72767,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72767,37.39,0.46,300,27282,70,NULL,NULL,'SDSS J103752.49+141519.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000136,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,159.4687083,14.25531,0.069,NULL,61186073648,956032400,14938006,18.4),(72768,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72768,38.17,0.46,431,27283,70,NULL,NULL,'2MASX J10375254+2934232',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,159.468875,29.57317,0.053,NULL,60519792392,945621756,14775339,18.1),(72769,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72769,38.4,0.46,478,27284,70,NULL,NULL,'2MASX J10375333+5827064',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,159.472333,58.45167,0,NULL,61947303102,967926610,15123853,17.6),(72770,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72770,38.22,0.46,440,27285,70,NULL,NULL,'SDSS J103753.52+294709.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,159.4730417,29.78603,0.021,NULL,60519770089,945621407,14775334,18),(72771,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72771,37.86,0.46,374,27286,70,NULL,NULL,'2MASX J10375360+4030145',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,159.473125,40.504,0,NULL,64118347136,1001849174,15653893,17.9),(72772,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72772,37.81,0.33,365,27287,70,NULL,NULL,'2MASX J10375358+4006124',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000181,NULL,'17.4g',0.2,'AGN',NULL,NULL,NULL,NULL,1,159.4734583,40.10344,0,NULL,64118428390,1001850443,15653913,17.4),(72773,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72773,35.52,0.54,127,27288,70,NULL,NULL,'2MASX J10375434-0712195',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'15.73',0.45,NULL,NULL,NULL,NULL,NULL,1,159.476417,-7.20561,0.097,NULL,41803080643,653173135,10205830,15.73),(72774,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72774,37.98,0.33,394,27289,70,NULL,NULL,'2MASX J10375479+1854040',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,159.478208333,18.90114,0.029,NULL,60989303562,952957868,14889966,17.5),(72775,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72775,37.22,0.33,278,27290,70,NULL,NULL,'2MASX J10375583+4656292',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000145,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,159.4827083,46.9415,0.005,NULL,64136710366,1002136099,15658376,17.1),(72776,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72776,34.07,0.43,65.2,27291,75,NULL,'3.6 micron, color + selection bias corrected','ESO 437- G 019',NULL,'2014MNRAS.444..527S',2014,1,1.1,NULL,'G',0.000087,NULL,'14.19',0.6,'SB(r)0^+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.484167,-28.90739,0.141,NULL,41532777174,648949643,10139838,14.19),(72777,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72777,34.09,0.43,65.8,27291,75,NULL,'3.6 micron, color corrected','ESO 437- G 019',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72778,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72778,34.18,0.2,68.6,27291,74.4,NULL,NULL,'ESO 437- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72779,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72779,37.81,0.33,365,27292,70,NULL,NULL,'2MASX J10375715+4004244',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,159.48825,40.07361,0,NULL,64118427903,1001850435,15653913,17.6),(72780,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72780,34.95,0.46,97.8,27293,70,NULL,NULL,'2MASX J10375730+3447174',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000168,NULL,'15.4g',0.43,NULL,NULL,NULL,NULL,NULL,1,159.488791667,34.78819,0.041,NULL,64054883057,1000857547,15638399,15.4),(72781,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72781,37.92,0.46,384,27294,70,NULL,NULL,'SDSS J103757.35+171524.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,159.489,17.25672,0.061,NULL,60959295763,952488996,14882640,18.3),(72782,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72782,34.64,0.45,84.7,27295,NULL,NULL,'Malmquist cor.','ESO 264- G 017',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'16.10',0.3,'S...',NULL,NULL,NULL,NULL,1,159.492333,-43.92519,0.589,NULL,42130070541,658282352,10285661,16.1),(72783,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72783,34.94,0.49,97.2,27295,75,NULL,'IR','ESO 264- G 017',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72784,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72784,34.98,0.39,98.9,27295,NULL,NULL,NULL,'ESO 264- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72785,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72785,35.02,0.2,101,27295,74.4,NULL,NULL,'ESO 264- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72786,'IRAS','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72786,31.92,0.8,24.3,27296,75,NULL,'MAT, I','ESO 019- G 003',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000027,NULL,'12.25',0.9,'SB(s)dm',NULL,NULL,NULL,NULL,1,159.5037083,-81.09756,0.085,NULL,39972817443,624575272,9758988,12.25),(72787,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72787,31.94,0.43,24.5,27296,75,NULL,'3.6 micron, color + selection bias corrected','ESO 019- G 003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72788,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72788,32.09,0.43,26.1,27296,75,NULL,'3.6 micron, color corrected','ESO 019- G 003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72789,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72789,32.11,0.32,26.4,27296,85,NULL,'I, raw','ESO 019- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72790,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72790,32.12,0.32,26.5,27296,85,NULL,'I, inv','ESO 019- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72791,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72791,32.19,0.2,27.4,27296,74.4,NULL,NULL,'ESO 019- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72792,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72792,32.24,0.4,28.1,27296,NULL,NULL,NULL,'ESO 019- G 003',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72793,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72793,32.24,0.39,28.1,27296,73,NULL,'opt','ESO 019- G 003',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72794,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72794,32.45,0.43,30.9,27296,75,NULL,'MAT, I, raw','ESO 019- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72795,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72795,32.49,0.4,31.5,27296,NULL,NULL,'mean','ESO 019- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72796,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72796,32.52,0.43,31.9,27296,75,NULL,'MAT, I, inv','ESO 019- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72797,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72797,32.64,0.43,33.7,27296,75,NULL,'MAT, I, cor','ESO 019- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72798,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72798,32.74,0.47,35.3,27296,NULL,NULL,'H','ESO 019- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72799,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72799,32.78,0.46,36,27296,NULL,NULL,'J','ESO 019- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72800,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72800,32.83,0.45,36.8,27296,NULL,NULL,'K','ESO 019- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72801,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72801,33.7,0.4,55,27297,75,NULL,'Edat, raw','2MASX J10380121-2727046',NULL,'1997ApJS..109..333W',1997,1,0.64,NULL,'G',0.000053,NULL,'15.19',0.26,'SB(r)0(5)',NULL,NULL,NULL,NULL,1,159.5050417,-27.45119,NULL,NULL,41534209725,648972026,10140187,15.19),(72802,'D-Sigma','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72802,33.72,0.4,55.4,27297,75,NULL,'Edat, cor','2MASX J10380121-2727046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72803,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72803,33.76,0.25,56.5,27297,74.4,NULL,NULL,'2MASX J10380121-2727046',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72804,'Tully est','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72804,32.17,0.8,27.1,27298,75,NULL,'B','UGC 05776',NULL,'1988NBGC.C....0000T',1988,1,0.68,NULL,'G',0.00002,NULL,'14.4g',0.63,'S?             AGN','Group member, radial-velocity confirmed',NULL,NULL,'Starburst',1,159.506708333,64.26636,0,NULL,61837900105,966217189,15097143,14.4),(72805,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72805,38.36,0.33,469,27299,70,NULL,NULL,'2MASX J10380450+0419546',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000183,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,159.518833,4.33192,0.057,NULL,61018180281,953409066,14897016,17.5),(72806,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72806,37.93,0.46,385,27300,70,NULL,NULL,'2MASX J10380457+3321165',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,159.519,33.35461,0.025,NULL,64051489391,1000804521,15637570,18.1),(72807,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72807,38.26,0.46,448,27301,70,NULL,NULL,'2MASX J10380459+2921283',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,159.5192083,29.358,0.037,NULL,60520607875,945634498,14775539,17.9),(72808,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72808,37.3,0.46,288,27302,70,NULL,NULL,'2MASX J10380468+3011305',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,159.519625,30.19186,0.041,NULL,60503007759,945359496,14771242,16.9),(72809,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72809,35.24,0.49,112,27303,75,NULL,'IR','UGC 05783',NULL,'2011yCatp016004901K',2011,1,1.52,NULL,'G',0.000033,NULL,'14.9g',0.43,'SB(rs)c?',NULL,NULL,NULL,NULL,1,159.5215,1.74511,0.069,NULL,60266677858,941666841,14713544,14.9),(72810,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72810,35.31,0.4,116,27303,NULL,NULL,'Malmquist cor.','UGC 05783',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72811,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72811,35.34,0.4,117,27303,NULL,NULL,NULL,'UGC 05783',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72812,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72812,35.38,0.2,119,27303,74.4,NULL,NULL,'UGC 05783',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72813,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72813,36.09,0.2,165,27304,74.4,NULL,NULL,'KUG 1035+394',NULL,'2013AJ....146...86T',2013,1,0.92,NULL,'G',0.000043,NULL,'14.7g',0.47,'S?             HII',NULL,NULL,NULL,NULL,1,159.527333333,39.17717,0,NULL,64116992329,1001828005,15653562,14.7),(72814,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72814,36.95,0.19,245,27305,70,NULL,NULL,'2MASX J10380652+4958281',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000183,NULL,'16.0g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,159.527333333,49.97442,0,NULL,64126022046,1001969094,15655767,16),(72815,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72815,36.78,0.46,227,27306,70,NULL,NULL,'2MASX J10380706+0249596',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.80',0.26,NULL,NULL,NULL,NULL,NULL,1,159.52925,2.83331,0.053,NULL,61003126570,953173852,14893341,16.8),(72816,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72816,36.98,0.46,249,27307,70,NULL,NULL,'2MASX J10380706+3113215',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000145,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,159.529333,31.22275,0.009,NULL,64047401083,1000740641,15636572,17.3),(72817,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72817,34.83,0.49,92.4,27308,75,NULL,'IR','UGC 05784',NULL,'2011yCatp016004901K',2011,1,1.02,NULL,'G',0.000033,NULL,'14.9g',0.35,'S?',NULL,NULL,NULL,NULL,1,159.529583,4.89436,0.061,NULL,61015440060,953366250,14896347,14.9),(72818,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72818,37.53,0.23,321,27309,70,NULL,NULL,'2MASX J10380709+0811198',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000202,NULL,'16.1g',0.34,'E0',NULL,NULL,NULL,NULL,1,159.5297083,8.18883,0.073,NULL,61067890805,954185793,14909153,16.1),(72819,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72819,35.76,0.46,142,27310,70,NULL,NULL,'2MASX J10380742+1240299',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000165,NULL,'15.8g',0.35,'E0',NULL,NULL,NULL,NULL,1,159.530833,12.67503,0.025,NULL,61176882618,955888790,14935762,15.8),(72820,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72820,36.89,0.46,239,27311,70,NULL,NULL,'SDSS J103807.51+191456.5',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,159.531333,19.24906,0.025,NULL,60988536584,952945884,14889779,17.3),(72821,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72821,32.81,NULL,36.5,27312,NULL,NULL,NULL,'CGCG 065-074',NULL,'2015AstBu..70....1K',2015,1,0.81,NULL,'G',0.000026,NULL,'14.4g',0.63,NULL,NULL,NULL,NULL,NULL,1,159.533333,10.38086,0.057,NULL,61046679823,953854372,14903974,14.4),(72822,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72822,37.53,0.23,321,27313,70,NULL,NULL,'SDSS J103808.69+080632.4',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000159,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,159.53625,8.10903,0.073,NULL,61067418110,954178407,14909037,18.7),(72823,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72823,37.53,0.23,321,27314,70,NULL,NULL,'2MASX J10380891+0807088',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'15.8g',0.39,NULL,NULL,NULL,NULL,NULL,1,159.5372917,8.11917,0.073,NULL,61067418888,954178420,14909037,15.8),(72824,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72824,32.79,0.2,36.1,27315,74.4,NULL,NULL,'UGC 05757',NULL,'2013AJ....146...86T',2013,1,2.1,NULL,'G',0.000023,NULL,'14.60',0.8,'Sa?',NULL,NULL,NULL,NULL,1,159.538167,79.36639,0.025,NULL,61435682444,959932538,14998945,14.6),(72825,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72825,32.98,0.66,39.5,27315,NULL,NULL,'Malmquist cor.','UGC 05757',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72826,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72826,33.01,0.65,39.9,27315,NULL,NULL,NULL,'UGC 05757',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72827,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72827,37.28,0.7,286,27316,70,NULL,NULL,'LCRS B103540.2-111734',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.74',NULL,NULL,NULL,NULL,NULL,NULL,1,159.538375,-11.55286,0.133,NULL,41765783958,652590374,10196724,15.74),(72828,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72828,37.71,0.46,348,27317,70,NULL,NULL,'SDSS J103809.37+324932.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000155,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,159.539083333,32.82583,0.009,NULL,64050189003,1000784203,15637253,18.3),(72829,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72829,34.27,NULL,71.3,27318,NULL,NULL,'Dipole','ESO 214- G 016',NULL,'2010Ap&SS.325..163P',2010,1,2.8,NULL,'G',NULL,NULL,'14.5',0.22,'Sbc',NULL,NULL,NULL,NULL,1,159.5397083,-50.15964,NULL,NULL,42097841290,657778770,10277793,14.5),(72830,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72830,34.28,NULL,71.8,27318,NULL,NULL,'Dipole + Quadrupole','ESO 214- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72831,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72831,34.3,NULL,72.4,27318,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 214- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72832,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72832,34.35,0.49,74,27318,75,NULL,'IR','ESO 214- G 016',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72833,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72833,37.72,0.19,349,27319,70,NULL,NULL,'2MASX J10381004+1208239',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,159.54175,12.13994,0.029,NULL,61176992598,955890509,14935789,17.4),(72834,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72834,37.63,0.46,335,27320,70,NULL,NULL,'SDSS J103810.60+005914.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000062,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,159.544208333,0.98731,0.093,NULL,60267787369,941684177,14713815,18.2),(72835,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72835,33.6,0.23,52.5,27321,74.4,NULL,NULL,'ESO 437- G 021',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000037,NULL,'13.97',1.2,'SB0(1)','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.54475,-28.78333,0.141,NULL,41532737900,648949029,10139828,13.97),(72836,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72836,33.88,0.4,59.7,27321,NULL,NULL,'mean','ESO 437- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72837,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72837,34.2,0.45,69.2,27321,NULL,NULL,'K','ESO 437- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72838,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72838,37.53,0.23,321,27322,70,NULL,NULL,'2MASX J10381080+0807398',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,159.5450417,8.12764,0.073,NULL,61067399438,954178116,14909033,17.6),(72839,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72839,38.7,0.46,550,27323,70,NULL,NULL,'2MASX J10381085+3027425',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,159.545083,30.46194,0,NULL,64047090043,1000735781,15636496,17.7),(72840,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72840,35.62,0.51,133,27324,70,NULL,NULL,'2MASX J10381151-1712367',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,159.548083,-17.21028,0.153,NULL,41649777711,650777776,10168402,15.1),(72841,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72841,37.78,0.46,359,27325,70,NULL,NULL,'2MASX J10381209+0646418',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000195,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,159.5502917,6.77819,0.049,NULL,61057932219,954030190,14906721,17),(72842,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72842,37.31,0.27,290,27326,70,NULL,NULL,'2MASX J10381303+0623108',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,159.554375,6.38622,0.057,NULL,61057635756,954025558,14906649,17.8),(72843,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72843,37.22,0.33,278,27327,70,NULL,NULL,'2MASX J10381401+4701577',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000158,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,159.5585,47.03258,0,NULL,64136901415,1002139084,15658423,16.4),(72844,'Tully est','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72844,33.01,0.8,40,27328,75,NULL,NULL,'ESO 317- G 054',NULL,'1988NBGC.C....0000T',1988,1,2,NULL,'G',0.000017,NULL,'13.98',1.9,'SB(s)cd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.561083,-38.09236,0.233,NULL,42117800956,658090639,10282666,13.98),(72845,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72845,38.31,0.46,459,27329,70,NULL,NULL,'SDSS J103814.84+024546.3',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.00015,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,159.561875,2.76286,0.057,NULL,61003123931,953173811,14893340,18.8),(72846,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72846,37.16,0.33,271,27330,70,NULL,NULL,'2MASX J10381507+5303221',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000145,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,159.562875,53.05617,0.013,NULL,61959013389,968109584,15126712,17),(72847,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72847,36.27,0.46,179,27331,70,NULL,NULL,'2MASX J10381531+5013391',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000152,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,159.563667,50.22767,0,NULL,64126001505,1001968773,15655762,16.9),(72848,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72848,37.98,0.46,394,27332,70,NULL,NULL,'2MASX J10381660+1459220',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,159.569333333,14.98942,0.073,NULL,61183911255,955998613,14937478,16.7),(72849,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72849,37.93,0.46,386,27333,70,NULL,NULL,'2MASX J10381686+0612224',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000132,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,159.570125,6.20614,0.057,NULL,61057549495,954024210,14906628,17.7),(72850,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72850,36.5,0.46,199,27334,70,NULL,NULL,'2MASX J10381773+3420508',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,159.5740417,34.3475,0.037,NULL,64055203544,1000862555,15638477,17.1),(72851,'IRAS','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72851,34.01,0.8,63.5,27335,75,NULL,'MAT, I','ESO 437- G 022',NULL,'1997ApJS..109..333W',1997,1,1.6,'The position in 1989H&RHI.C...0000H is incorrect.','G',0.00002,NULL,'14.94',0.3,'SBbc: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.574375,-28.88578,0.141,NULL,41532678128,648948095,10139813,14.94),(72852,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72852,33.78,0.32,56.9,27335,85,NULL,'I, raw','ESO 437- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72853,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72853,33.79,0.32,57.4,27335,85,NULL,'I, inv','ESO 437- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72854,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72854,33.83,0.43,58.5,27335,75,NULL,'MAT, I, cor','ESO 437- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72855,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72855,33.83,0.11,58.5,27335,NULL,NULL,NULL,'ESO 437- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72856,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72856,33.86,0.43,59.1,27335,75,NULL,'MAT, I, raw','ESO 437- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72857,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72857,33.89,0.49,60,27335,75,NULL,'IR','ESO 437- G 022',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72858,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72858,33.98,0.43,62.5,27335,75,NULL,'MAT, I, inv','ESO 437- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72859,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72859,34.02,0.2,63.7,27335,74.4,NULL,NULL,'ESO 437- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72860,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72860,34.08,0.43,65.3,27335,75,NULL,'3.6 micron, color corrected','ESO 437- G 022',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72861,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72861,34.18,0.43,68.4,27335,75,NULL,'3.6 micron, color + selection bias corrected','ESO 437- G 022',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72862,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72862,35.53,0.46,128,27336,70,NULL,NULL,'CGCG 037-099',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000133,NULL,'15.5g',0.45,'E0',NULL,NULL,NULL,NULL,1,159.5754583,3.938,0.057,NULL,61017011602,953390806,14896731,15.5),(72863,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72863,37.7,0.46,346,27337,70,NULL,NULL,'2MASX J10381873-0101093',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000058,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,159.577958333,-1.01922,0.113,NULL,40872528743,638633261,9978644,18.2),(72864,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72864,36.69,0.46,218,27338,70,NULL,NULL,'CGCG 154-035 NED01',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000198,NULL,'15.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,159.57975,27.68478,0.045,NULL,60521517294,945648707,14775761,15.7),(72865,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72865,37.95,0.46,390,27339,70,NULL,NULL,'2MASX J10381961+1511570',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,159.581667,15.19922,0.073,NULL,61179646415,955931975,14936437,16.2),(72866,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72866,36.93,0.46,243,27340,70,NULL,NULL,'2MASX J10382158+0856294',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000198,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,159.5899583,8.94147,0.069,NULL,61053354813,953958668,14905604,16.3),(72867,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72867,38.1,0.16,416,27341,70,NULL,NULL,'2MASX J10382319+2857283',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000127,NULL,'17.0g',0.31,'E',NULL,NULL,NULL,NULL,1,159.5965417,28.95789,0.061,NULL,60519991655,945624869,14775388,17),(72868,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72868,36.45,0.59,195,27342,70,NULL,NULL,'2MASX J10382342-1645557',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,159.5975417,-16.76556,0.161,NULL,41649759112,650777486,10168398,15.5),(72869,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72869,34.49,0.43,79.1,27343,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J10382362-2531276',NULL,'2014MNRAS.444..527S',2014,1,0.9,NULL,'G',0.00015,NULL,'16.19',0.28,'S',NULL,NULL,NULL,NULL,1,159.5984583,-25.52439,0.269,NULL,41485128575,648205133,10128205,16.19),(72870,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72870,35.81,0.53,145,27344,70,NULL,NULL,'2MASX J10382421-4655121',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'12.5J',NULL,NULL,NULL,NULL,NULL,NULL,1,159.600875,-46.92,0.793,NULL,42108998377,657953099,10280517,12.5),(72871,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72871,37.14,0.46,268,27345,70,NULL,NULL,'2MASX J10382555+5634553',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000188,NULL,'16.2g',0.43,NULL,NULL,NULL,NULL,NULL,1,159.6064583,56.58203,0,NULL,61970161756,968283777,15129434,16.2),(72872,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72872,35.16,0.36,108,27346,NULL,NULL,'Malmquist cor.','UGC 05787',NULL,'2009ApJS..182..474S',2009,1,1.58,NULL,'G',0.00002,NULL,'14.5g',0.61,'SBbc:',NULL,NULL,NULL,NULL,1,159.6097083,-2.56942,0.113,NULL,41744018892,652250295,10191410,14.5),(72873,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72873,35.18,0.35,109,27346,NULL,NULL,NULL,'UGC 05787',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72874,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72874,35.22,0.2,111,27346,74.4,NULL,NULL,'UGC 05787',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72875,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72875,38.1,0.16,416,27347,70,NULL,NULL,'2MASX J10382769+2859562',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000141,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,159.6155,28.99897,0.029,NULL,60519961658,945624400,14775381,18.1),(72876,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72876,37.88,0.46,376,27348,70,NULL,NULL,'SDSS J103827.93+453545.1',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.00018,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,159.616417,45.59586,0,NULL,64133717168,1002089330,15657645,18.6),(72877,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72877,37.49,0.46,314,27349,70,NULL,NULL,'2MASX J10382809+4433366',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000197,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,159.617167,44.56017,0,NULL,64133415125,1002084611,15657572,16.2),(72878,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72878,37.29,0.46,287,27350,70,NULL,NULL,'2MASX J10382914+0635083',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000173,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,159.6215,6.58564,0.041,NULL,61065018337,954140911,14908451,16.4),(72879,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72879,37.82,0.46,367,27351,70,NULL,NULL,'2MASX J10382988+4201246',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,159.624583,42.0235,0,NULL,64142439615,1002225618,15659775,17.8),(72880,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72880,36.8,0.46,229,27352,70,NULL,NULL,'2MASX J10383007+0313533',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000183,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,159.625333,3.23147,0.045,NULL,61017508367,953398568,14896852,16.3),(72881,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72881,37.7,0.46,346,27353,70,NULL,NULL,'SDSS J103831.70+321142.6',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000146,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,159.632125,32.19519,0.013,NULL,64051042138,1000797533,15637461,18.6),(72882,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72882,31.14,0.43,16.9,27354,75,NULL,'3.6 micron, color + selection bias corrected','ESO 501- G 065',NULL,'2014MNRAS.444..527S',2014,1,1.5,NULL,'G',0.00002,NULL,'13.71',1,'SB(s)d: pec    HII','Group member, radial-velocity confirmed',NULL,NULL,'H_alpha Emission-Line Galaxy',1,159.638666667,-27.73747,NULL,NULL,41535068609,648985447,10140397,13.71),(72883,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72883,31.39,0.43,18.9,27354,75,NULL,'3.6 micron, color corrected','ESO 501- G 065',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72884,'Tully-Fisher','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,NULL,72884,31.56,0.2,20.5,27354,74.4,NULL,NULL,'ESO 501- G 065',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72885,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72885,37.98,0.33,394,27355,70,NULL,NULL,'2MASX J10383406+1854048',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,159.642,18.90147,0.029,NULL,60989260926,952957201,14889956,17.7),(72886,'FP','2016-12-15 15:14:39','2016-12-16 11:19:47','1',NULL,'R',72886,37.16,0.33,271,27356,70,NULL,NULL,'2MASX J10383538+5305301',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000154,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,159.6477083,53.09161,0.013,NULL,61959025325,968109770,15126715,16.9),(72887,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72887,38.26,0.33,449,27357,70,NULL,NULL,'SDSS J103835.57+383124.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000145,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,159.6482083,38.52358,0,NULL,64115466502,1001804164,15653190,18.4),(72888,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72888,37.62,0.46,334,27358,70,NULL,NULL,'2MASX J10383652+2357498',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.79',0.14,NULL,NULL,NULL,NULL,NULL,1,159.652333333,23.96383,0.005,NULL,60943477575,952241837,14878778,17.79),(72889,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72889,38.1,0.16,416,27359,70,NULL,NULL,'SDSS J103836.79+285949.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,159.653333,28.99719,0.029,NULL,60520003194,945625049,14775391,18.4),(72890,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72890,37.81,0.46,366,27360,70,NULL,NULL,'2MASX J10383683+3824542',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000185,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,159.653375,38.415,0,NULL,64115474325,1001804286,15653191,16.6),(72891,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72891,38.1,0.16,416,27361,70,NULL,NULL,'2MASX J10383725+2838329',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000186,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,159.655375,28.64228,0.037,NULL,60523501015,945679703,14776245,17),(72892,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72892,38.1,0.16,416,27362,70,NULL,NULL,'SDSS J103837.81+284007.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000169,NULL,'18.7g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,159.657583,28.66869,0.037,NULL,60523511133,945679861,14776247,18.7),(72893,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72893,38.1,0.16,416,27363,70,NULL,NULL,'2MASX J10383778+2836169',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000177,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,159.657625,28.60475,0.029,NULL,60523530498,945680164,14776252,17.7),(72894,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72894,37.18,0.46,273,27364,70,NULL,NULL,'2MASX J10383811+4040072',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000141,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,159.658666667,40.66869,0,NULL,64118373129,1001849580,15653899,17.4),(72895,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72895,38.57,0.46,517,27365,70,NULL,NULL,'2MASX J10383888+4104142',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00019,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,159.662125,41.07078,0,NULL,64111032228,1001734878,15652107,17.3),(72896,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72896,37.85,0.46,372,27366,70,NULL,NULL,'2MASX J10383930+0127293',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00008,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,159.663875,1.45817,0.077,NULL,60266518853,941664357,14713505,17.6),(72897,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72897,33.35,0.8,46.9,27367,75,NULL,'MAT, I','ESO 437- G 025',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'14.49',0.4,'S(B)b          HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.667667,-28.56883,0.141,NULL,41535655191,648994612,10140540,14.49),(72898,'Sosies','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72898,34.38,0.22,75.2,27367,NULL,NULL,NULL,'ESO 437- G 025',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72899,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72899,32.7,0.43,34.6,27367,75,NULL,'3.6 micron, color + selection bias corrected','ESO 437- G 025',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72900,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72900,32.83,0.43,36.9,27367,75,NULL,'3.6 micron, color corrected','ESO 437- G 025',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72901,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72901,32.96,0.2,39.1,27367,74.4,NULL,NULL,'ESO 437- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72902,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72902,33.47,0.32,49.5,27367,85,NULL,'I, raw','ESO 437- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72903,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72903,33.5,0.32,50.2,27367,85,NULL,'I, inv','ESO 437- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72904,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72904,33.63,0.43,53.3,27367,75,NULL,'MAT, I, raw','ESO 437- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72905,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72905,33.69,0.43,54.8,27367,75,NULL,'MAT, I, cor','ESO 437- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72906,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72906,33.79,0.43,57.4,27367,75,NULL,'MAT, I, inv','ESO 437- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72907,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72907,33.87,0.08,59.6,27367,NULL,NULL,NULL,'ESO 437- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72908,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72908,37.41,0.46,304,27368,70,NULL,NULL,'2MASX J10384060+1101383',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000159,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,159.6692083,11.02731,0.085,NULL,61047189246,953862331,14904098,17),(72909,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72909,38.2,0.46,437,27369,70,NULL,NULL,'2MASX J10384145+6013444',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000201,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,159.6724583,60.22906,0,NULL,61958057158,968094643,15126478,17.2),(72910,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72910,37.54,0.19,322,27370,70,NULL,NULL,'2MASX J10384335+0435503',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000179,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,159.680625,4.59739,0.061,NULL,61015311223,953364237,14896316,16.5),(72911,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72911,37.48,0.13,313,27371,70,NULL,NULL,'2MASX J10384375+0514023',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000144,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,159.682208333,5.23394,0.069,NULL,61014725780,953355090,14896173,17.2),(72912,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72912,37.97,0.27,392,27372,70,NULL,NULL,'2MASX J10384442+5722003',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,159.68525,57.36678,0,NULL,62000572796,968758949,15136858,17.9),(72913,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72913,37.72,0.19,349,27373,70,NULL,NULL,'2MASX J10384446+1204166',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000172,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,159.6852917,12.07117,0.045,NULL,61176422672,955881604,14935650,17.2),(72914,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72914,37.73,0.33,351,27374,70,NULL,NULL,'2MASX J10384489+0310073',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.0002,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,159.687,3.16867,0.053,NULL,61016814973,953387733,14896683,17),(72915,'Sosies','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72915,31.21,1.88,17.5,27375,NULL,NULL,NULL,'NGC 3310',NULL,'2002A&A...393...57T',2002,1,3.1,NULL,'G',0.000009,NULL,'11.15',2.4,'SAB(r)bc pec   HII','Possible field galaxy',NULL,NULL,'H II',1,159.691083,53.50339,0,NULL,61961711822,968151747,15127371,11.15),(72916,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72916,31.36,0.4,18.7,27375,75,NULL,'B','NGC 3310',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72917,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72917,31.8,NULL,22.9,27375,NULL,NULL,'LEDA [April 2006]','NGC 3310',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72918,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72918,38.1,0.16,416,27376,70,NULL,NULL,'2MASX J10384643+2830578',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000179,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,159.693375,28.51597,0.029,NULL,60523524460,945680069,14776251,17.6),(72919,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72919,38.1,0.16,416,27377,70,NULL,NULL,'2MASX J10384645+2839268',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'18.37',0.16,NULL,NULL,NULL,NULL,NULL,1,159.693625,28.6575,0.037,NULL,60523507942,945679811,14776247,18.37),(72920,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72920,37.25,0.46,282,27378,70,NULL,NULL,'2MASX J10384646+2244307',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,159.693666667,22.74186,0.021,NULL,60990040524,952969383,14890146,NULL),(72921,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72921,38.3,0.46,457,27379,70,NULL,NULL,'SDSS J103846.54+250545.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000169,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,159.6939583,25.09594,0.009,NULL,60469802203,944840659,14763135,18.4),(72922,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72922,37.73,0.33,351,27380,70,NULL,NULL,'SDSS J103846.67+030822.1',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,159.6945,3.13947,0.053,NULL,61016810809,953387668,14896682,17.8),(72923,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72923,34.99,0.48,99.4,27381,NULL,NULL,NULL,'UGC 05788',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.6g',0.6,'Sb',NULL,NULL,NULL,NULL,1,159.694875,5.69692,0.049,NULL,61014594548,953353039,14896141,14.6),(72924,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72924,35.03,0.2,101,27381,74.4,NULL,NULL,'UGC 05788',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72925,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72925,35.18,0.44,109,27381,NULL,NULL,'Malmquist cor.','UGC 05788',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72926,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72926,37.54,0.19,322,27382,70,NULL,NULL,'2MASX J10384730+0449203',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,159.697,4.82219,0.061,NULL,61015179639,953362181,14896284,17.4),(72927,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72927,35.04,NULL,102,27383,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1111',NULL,'2010Ap&SS.325..163P',2010,1,0.97,NULL,'G',0.000016,NULL,'16.1g',0.18,'Sc',NULL,NULL,NULL,NULL,1,159.698166667,29.11414,0.029,NULL,60520436137,945631814,14775497,16.1),(72928,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72928,35.08,NULL,104,27383,NULL,NULL,'Dipole + Quadrupole','FGC 1111',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72929,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72929,35.09,NULL,104,27383,NULL,NULL,NULL,'FGC 1111',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72930,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72930,35.1,NULL,105,27383,NULL,NULL,'Dipole','FGC 1111',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72931,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72931,35.11,0.49,105,27383,75,NULL,'IR','FGC 1111',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72932,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72932,35.17,0.2,108,27383,74.4,NULL,NULL,'FGC 1111',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72933,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72933,37.48,0.13,313,27384,70,NULL,NULL,'2MASX J10384770+0514023',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,159.698667,5.23381,0.069,NULL,61014681634,953354400,14896162,17.1),(72934,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72934,37.54,0.46,322,27385,70,NULL,NULL,'2MASX J10384835-0010292',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000069,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,159.7014583,-0.17475,0.129,NULL,40872323186,638630049,9978594,17.8),(72935,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72935,36.44,0.46,194,27386,70,NULL,NULL,'SDSS J103848.97+001842.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000062,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,159.704083333,0.31194,0.169,NULL,60265703750,941651621,14713306,17.7),(72936,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72936,37.36,0.46,296,27387,70,NULL,NULL,'2MASX J10385017+0257093',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000101,NULL,'16.7g',0.3,'AGN',NULL,NULL,NULL,NULL,1,159.709125,2.95264,0.053,NULL,61016800299,953387504,14896679,16.7),(72937,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72937,32.79,0.8,36.1,27388,75,NULL,'MAT, I','NGC 3321',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.00001,NULL,'13.89',1.2,'SAB(r)c:',NULL,NULL,NULL,NULL,1,159.710666667,-11.64886,0.133,NULL,41765247158,652581986,10196593,13.89),(72938,'Tully est','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72938,32.72,0.8,35,27388,75,NULL,NULL,'NGC 3321',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72939,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72939,31.77,0.69,22.6,27388,100,NULL,'mid-IR','NGC 3321',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72940,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72940,32.64,0.32,33.8,27388,85,NULL,'I, raw','NGC 3321',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72941,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72941,32.65,0.4,33.9,27388,NULL,NULL,NULL,'NGC 3321',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72942,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72942,32.66,0.32,34.1,27388,85,NULL,'I, inv','NGC 3321',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72943,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72943,32.85,0.43,37.1,27388,75,NULL,'MAT, I, raw','NGC 3321',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72944,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72944,32.95,0.2,38.9,27388,74.4,NULL,NULL,'NGC 3321',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72945,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72945,32.97,0.43,39.3,27388,75,NULL,'MAT, I, inv','NGC 3321',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72946,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72946,32.98,0.43,39.4,27388,75,NULL,'3.6 micron, color corrected','NGC 3321',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72947,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72947,33.06,0.43,40.9,27388,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3321',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72948,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72948,33.15,0.33,42.6,27388,NULL,NULL,NULL,'NGC 3321',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72949,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72949,33.22,0.43,44.1,27388,75,NULL,'MAT, I, cor','NGC 3321',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72950,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72950,33.37,0.4,47.3,27388,NULL,NULL,'mean','NGC 3321',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72951,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72951,33.4,0.3,48,27388,NULL,NULL,'Malmquist cor.','NGC 3321',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72952,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72952,33.72,0.47,55.6,27388,NULL,NULL,'H','NGC 3321',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72953,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72953,33.78,0.46,57,27388,NULL,NULL,'J','NGC 3321',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72954,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72954,33.83,0.45,58.3,27388,NULL,NULL,'K','NGC 3321',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72955,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72955,38.41,0.46,480,27389,70,NULL,NULL,'2MASX J10385167+5136449',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000125,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,159.715417,51.61239,0,NULL,64122757278,1001918082,15654970,18.3),(72956,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72956,36.92,0.46,243,27390,70,NULL,NULL,'2MASX J10385222+5359182',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000175,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,159.7175,53.98833,0,NULL,61961177537,968143399,15127240,16.6),(72957,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72957,35.5,0.46,126,27391,70,NULL,NULL,'2MASX J10385240+0848463',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000166,NULL,'15.8g',0.43,'S0/a',NULL,NULL,NULL,NULL,1,159.718375,8.81297,0.065,NULL,61067121696,954173776,14908965,15.8),(72958,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72958,37.75,0.33,355,27392,70,NULL,NULL,'2MASX J10385278+6252094',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000161,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,159.719833,62.86919,0,NULL,61825387767,966021683,15094088,17),(72959,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72959,37.54,0.19,322,27393,70,NULL,NULL,'2MASX J10385299+0445083',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,159.72075,4.75222,0.061,NULL,61015302040,953364094,14896313,17.5),(72960,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72960,37.72,0.19,349,27394,70,NULL,NULL,'2MASX J10385409+1200263',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000141,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,159.72525,12.00725,0.045,NULL,61176419571,955881555,14935649,17.7),(72961,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72961,38.09,0.46,416,27395,70,NULL,NULL,'2MASX J10385406+1420335',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000174,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,159.7252917,14.34258,0.065,NULL,61186157297,956033707,14938026,18),(72962,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72962,37,0.46,251,27396,70,NULL,NULL,'2MASX J10385459+2541388',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000197,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,159.7275417,25.69422,0.041,NULL,60470915039,944858047,14763406,16.5),(72963,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72963,37.73,0.46,351,27397,70,NULL,NULL,'SDSS J103855.56+394921.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000138,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,159.7315,39.82269,0,NULL,64119259054,1001863422,15654115,18.3),(72964,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72964,38.26,0.33,449,27398,70,NULL,NULL,'2MASX J10385581+3830264',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,159.732417,38.50739,0,NULL,64115502824,1001804731,15653198,17.7),(72965,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72965,38.01,0.46,400,27399,70,NULL,NULL,'2MASX J10385659+0240443',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000163,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,159.735833,2.679,0.049,NULL,61003255747,953175871,14893372,16.9),(72966,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72966,33.78,0.8,57,27400,75,NULL,'MAT, I','ESO 038- G 004',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000032,NULL,'13.72',0.6,'SB(s)d',NULL,NULL,NULL,NULL,1,159.738875,-76.58922,0.565,NULL,39846198866,622596857,9728075,13.72),(72967,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72967,33.67,0.32,54.3,27400,85,NULL,'I, raw','ESO 038- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72968,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72968,33.69,0.32,54.6,27400,85,NULL,'I, inv','ESO 038- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72969,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72969,33.97,0.43,62.2,27400,75,NULL,'MAT, I, raw','ESO 038- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72970,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72970,34.08,0.43,65.5,27400,75,NULL,'MAT, I, inv','ESO 038- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72971,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72971,34.33,0.43,73.5,27400,75,NULL,'MAT, I, cor','ESO 038- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(72972,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72972,36.78,0.33,227,27401,70,NULL,NULL,'2MASX J10385762+1226273',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,159.7399583,12.44081,0.025,NULL,61177068707,955891698,14935807,17.5),(72973,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72973,37.97,0.27,392,27402,70,NULL,NULL,'SDSS J103858.85+572238.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000134,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,159.74525,57.3775,0,NULL,62000574555,968758977,15136859,18.7),(72974,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72974,35.46,0.49,123,27403,70,NULL,NULL,'IC 0631',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.000073,NULL,'15.43',0.57,NULL,NULL,NULL,NULL,NULL,1,159.745417,-7.05239,0.097,NULL,41805091794,653204559,10206321,15.43),(72975,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72975,32.09,NULL,26.2,27404,NULL,NULL,NULL,'AGC 208397',NULL,'2013AJ....145..101K',2013,1,NULL,NULL,'RadioS',0.000055,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,159.74625,3.86583,0.057,NULL,61017158028,953393094,14896767,NULL),(72976,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72976,36.78,0.46,227,27405,70,NULL,NULL,'2MASX J10385914+0749203',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,159.746541667,7.82225,0.065,NULL,61067463882,954179123,14909048,17.4),(72977,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72977,36.6,0.46,209,27406,70,NULL,NULL,'2MASX J10385952+3711464',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,159.748083,37.19617,0.025,NULL,64115359021,1001802484,15653163,17.4),(72978,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72978,37.17,0.46,272,27407,70,NULL,NULL,'KUG 1036+395',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000176,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,159.748583,39.28269,0,NULL,64118734866,1001855232,15653988,16.6),(72979,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72979,38.22,0.33,441,27408,70,NULL,NULL,'2MASX J10385975+2648348',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000141,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,159.748875,26.80981,0.049,NULL,60525953358,945718021,14776844,17.7),(72980,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72980,37.54,0.19,322,27409,70,NULL,NULL,'2MASX J10390083+0439163',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000179,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,159.753333,4.6545,0.061,NULL,61015303874,953364123,14896314,18.2),(72981,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72981,38.22,0.33,441,27410,70,NULL,NULL,'2MASX J10390101+2645098',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,159.75425,26.75289,0.049,NULL,60526141889,945720967,14776890,17.6),(72982,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72982,37.85,0.46,371,27411,70,NULL,NULL,'2MASX J10390154+1601193',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,159.7565,16.02206,0.057,NULL,61181909358,955967333,14936989,NULL),(72983,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72983,36.45,0.53,195,27412,70,NULL,NULL,'2MASX J10390163-4142010',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,159.756833333,-41.70028,0.389,NULL,42129515070,658273672,10285526,15.4),(72984,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72984,37.48,0.13,313,27413,70,NULL,NULL,'2MASX J10390196+0511543',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000183,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,159.758083333,5.19847,0.069,NULL,61014672642,953354260,14896160,17.6),(72985,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72985,37.35,0.46,295,27414,70,NULL,NULL,'2MASX J10390305+0422263',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000157,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,159.762625,4.37403,0.053,NULL,61017956097,953405564,14896961,17.5),(72986,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72986,37.43,0.17,307,27415,70,NULL,NULL,'2MASX J10390322+5819566',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,159.763625,58.33228,0,NULL,62002615431,968790866,15137357,17.7),(72987,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72987,38.62,0.33,530,27416,70,NULL,NULL,'SDSS J103903.66-004914.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000072,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,159.76525,-0.82078,0.121,NULL,40872112288,638626754,9978543,18.7),(72988,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72988,37.72,0.19,349,27417,70,NULL,NULL,'2MASX J10390370+1158503',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000161,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,159.765333,11.98075,0.045,NULL,61176475441,955882428,14935662,16.9),(72989,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72989,37.48,0.13,313,27418,70,NULL,NULL,'2MASX J10390377+0528003',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,159.76575,5.46667,0.045,NULL,61007300335,953239067,14894360,17.1),(72990,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72990,37.48,0.13,313,27419,70,NULL,NULL,'2MASX J10390424+0513353',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.0g',0.24,'Cand.grav.lens',NULL,NULL,NULL,NULL,1,159.767583,5.22661,0.069,NULL,61014686716,953354479,14896163,17),(72991,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72991,37.7,0.23,346,27420,70,NULL,NULL,'SDSS J103904.31+021750.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000076,NULL,'17.9g',0.17,'NLAGN',NULL,NULL,NULL,NULL,1,159.768,2.29731,0.061,NULL,60265974883,941655857,14713372,17.9),(72992,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72992,37.54,0.19,322,27421,70,NULL,NULL,'UGC 05790',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000214,NULL,'15.5g',0.52,'S?',NULL,NULL,NULL,NULL,1,159.769541667,4.64747,0.061,NULL,61015088017,953360750,14896261,15.5),(72993,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72993,36.78,0.33,227,27422,70,NULL,NULL,'2MASX J10390506+1226273',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000184,NULL,'15.6g',0.46,'E0',NULL,NULL,NULL,NULL,1,159.7710417,12.44094,0.025,NULL,61177055828,955891497,14935804,15.6),(72994,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72994,37.67,0.46,343,27423,70,NULL,NULL,'2MASX J10390515+3956523',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000169,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,159.771583333,39.94789,0,NULL,64119251875,1001863310,15654114,16.5),(72995,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72995,37.48,0.13,313,27424,70,NULL,NULL,'2MASX J10390571+0519333',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000174,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,159.773666667,5.32608,0.033,NULL,61014728737,953355136,14896174,16.7),(72996,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72996,37.87,0.46,375,27425,70,NULL,NULL,'2MASX J10390598+3938003',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000177,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,159.774833,39.63339,0,NULL,64118772945,1001855827,15653997,17.4),(72997,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',72997,37.65,0.46,339,27426,70,NULL,NULL,'2MASX J10390611+4442243',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000183,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,159.775291667,44.70675,0,NULL,64133488605,1002085759,15657589,16.6),(72998,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72998,34.52,0.25,80.2,27427,74.4,NULL,NULL,'ESO 264- G 023',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000057,NULL,'15.01',0.6,'S0',NULL,NULL,NULL,NULL,1,159.785667,-46.50575,0.745,NULL,42100863090,657825985,10278531,15.01),(72999,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,72999,34.6,0.4,83.1,27427,NULL,NULL,'mean','ESO 264- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73000,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73000,34.78,0.45,90.4,27427,NULL,NULL,'K','ESO 264- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73001,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73001,38.62,0.33,530,27428,70,NULL,NULL,'2MASX J10390932-0047160',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000111,NULL,'16.5g',0.31,'BrClG          AGN',NULL,NULL,NULL,NULL,1,159.788917,-0.78775,0.121,NULL,40872107392,638626678,9978541,16.5),(73002,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73002,37.48,0.13,313,27429,70,NULL,NULL,'2MASX J10390946+0512583',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,159.789333,5.21633,0.061,NULL,61014673233,953354269,14896160,17.4),(73003,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73003,30.23,0.15,11.1,27430,73,NULL,'Cepheids periods Gaussian ','NGC 3319',NULL,'2009RoAJ...19...35A',2009,1,6.2,NULL,'G',0.000004,NULL,'11.48',3.4,'SB(rs)cd       HII:','Possible field galaxy',NULL,NULL,NULL,1,159.789417,41.68667,0,NULL,64142365666,1002224463,15659757,11.48),(73004,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73004,30.33,0.17,11.6,27430,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian ','NGC 3319',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73005,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73005,30.44,0.22,12.2,27430,73,NULL,'Cepheids magnitudes Gaussian ','NGC 3319',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73006,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73006,30.5,0.09,12.6,27430,NULL,NULL,'cte LMC K03','NGC 3319',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73007,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73007,30.51,0.09,12.7,27430,NULL,NULL,'cte U99','NGC 3319',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73008,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73008,30.53,0.09,12.8,27430,NULL,NULL,'cte LMC STS02','NGC 3319',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73009,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73009,30.56,0.09,12.9,27430,NULL,NULL,'cte MW FSG03','NGC 3319',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73010,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73010,30.57,0.1,13,27430,NULL,NULL,'cte MW GFG98','NGC 3319',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73011,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73011,30.57,0.09,13,27430,74.4,NULL,NULL,'NGC 3319',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73012,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73012,30.59,0.09,13.1,27430,NULL,NULL,'cte MF91','NGC 3319',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73013,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73013,30.62,0.09,13.3,27430,NULL,NULL,'33, VI, +Z, KEY PROJECT','NGC 3319',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73014,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73014,30.64,0.09,13.4,27430,NULL,NULL,'33, VI, KEY PROJECT','NGC 3319',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73015,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73015,30.64,0.1,13.4,27430,NULL,NULL,'cte MW STS03','NGC 3319',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73016,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73016,30.7,0.08,13.8,27430,NULL,NULL,'LMC W01','NGC 3319',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73017,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73017,30.7,0.08,13.8,27430,NULL,NULL,'MW HIPP','NGC 3319',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73018,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73018,30.74,NULL,14.1,27430,NULL,18.54,NULL,'NGC 3319',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73019,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73019,30.74,0.08,14.1,27430,NULL,18.54,'LMC ZP','NGC 3319',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73020,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73020,30.78,0.1,14.3,27430,NULL,NULL,'28, VI','NGC 3319',NULL,'1999ApJ...523..540S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73021,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73021,30.78,0.1,14.3,27430,NULL,NULL,'HST KP Calibrated','NGC 3319',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73022,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73022,30.83,0.18,14.7,27430,NULL,NULL,'MW P02','NGC 3319',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73023,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73023,30.91,0.06,15.2,27430,NULL,NULL,'MW GFG','NGC 3319',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73024,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73024,30.91,0.06,15.2,27430,NULL,NULL,'88, VI','NGC 3319',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73025,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73025,30.97,NULL,15.6,27430,NULL,NULL,'33, VI','NGC 3319',NULL,'2006A&A...452..423P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73026,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73026,30.71,0.8,13.9,27430,75,NULL,'A82, H','NGC 3319',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73027,'Sosies','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73027,30.78,0.21,14.3,27430,NULL,NULL,NULL,'NGC 3319',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73028,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73028,30.11,0.51,10.5,27430,NULL,NULL,'B','NGC 3319',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73029,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73029,30.3,0.4,11.5,27430,75,NULL,'B','NGC 3319',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73030,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73030,30.36,NULL,11.8,27430,NULL,NULL,'B','NGC 3319',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73031,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73031,30.52,0.1,12.7,27430,NULL,NULL,'I','NGC 3319',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73032,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73032,30.54,0.47,12.8,27430,NULL,NULL,NULL,'NGC 3319',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73033,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73033,30.56,NULL,12.9,27430,NULL,NULL,'I','NGC 3319',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73034,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73034,30.57,0.43,13,27430,75,NULL,'3.6 micron, color corrected','NGC 3319',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73035,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73035,30.57,0.09,13,27430,74.4,NULL,NULL,'NGC 3319',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73036,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73036,30.59,0.4,13.1,27430,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 3319',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73037,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73037,30.59,0.43,13.1,27430,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3319',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73038,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73038,30.62,0.09,13.3,27430,75,NULL,NULL,'NGC 3319',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73039,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73039,30.72,0.4,13.9,27430,73,NULL,'opt','NGC 3319',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73040,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73040,30.82,0.41,14.6,27430,NULL,NULL,'Malmquist cor.','NGC 3319',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73041,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73041,30.92,0.35,15.3,27430,NULL,NULL,NULL,'NGC 3319',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73042,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73042,31.27,0.47,17.9,27430,75,NULL,'A82, H, inv','NGC 3319',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73043,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73043,31.3,0.47,18.2,27430,75,NULL,'A82, H, raw','NGC 3319',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73044,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73044,31.57,0.47,20.6,27430,75,NULL,'A82, H, cor','NGC 3319',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73045,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73045,31.85,0.4,23.4,27430,NULL,NULL,'mean','NGC 3319',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73046,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73046,32.77,0.46,35.9,27430,NULL,NULL,'J','NGC 3319',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73047,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73047,32.83,0.45,36.7,27430,NULL,NULL,'K','NGC 3319',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73048,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73048,32.84,0.47,36.9,27430,NULL,NULL,'H','NGC 3319',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73049,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73049,38.11,0.46,418,27431,70,NULL,NULL,'2MASX J10391047+4705583',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000129,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,159.793375,47.09958,0.005,NULL,64136926889,1002139482,15658429,18.1),(73050,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73050,38.2,0.33,437,27432,70,NULL,NULL,'2MASX J10391048+0117313',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000079,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,159.793625,1.29203,0.093,NULL,60267140449,941674069,14713657,17.7),(73051,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73051,37.97,0.27,392,27433,70,NULL,NULL,'2MASX J10391055+5714456',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000148,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,159.793875,57.24603,0,NULL,62000706952,968761046,15136891,17.1),(73052,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73052,34.53,0.45,80.5,27434,NULL,NULL,'K','ESO 264- G 024',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000047,NULL,'14.24',0.5,'S0-: sp',NULL,NULL,NULL,NULL,1,159.796833,-46.14164,0.745,NULL,42101420149,657834689,10278667,14.24),(73053,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73053,34.68,0.4,86.3,27434,NULL,NULL,'mean','ESO 264- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73054,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73054,35.69,0.59,138,27435,70,NULL,NULL,'2MASX J10391152-1649102',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,159.7979583,-16.81961,0.149,NULL,41649740989,650777202,10168393,15.1),(73055,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73055,37.3,0.46,288,27436,70,NULL,NULL,'2MASX J10391228+3141473',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000129,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,159.801333,31.69658,0.017,NULL,64050893905,1000795217,15637425,17.7),(73056,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73056,35.47,0.46,124,27437,70,NULL,NULL,'VIII Zw 097',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000098,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,159.8049583,7.85778,0.065,NULL,61067332359,954177068,14909016,16.5),(73057,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73057,37.78,0.46,360,27438,70,NULL,NULL,'2MASX J10391352+2543528',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000158,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,159.80625,25.73144,0.041,NULL,60526219516,945722179,14776909,18.4),(73058,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73058,38.2,0.33,437,27439,70,NULL,NULL,'2MASX J10391388+0115293',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000076,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,159.807791667,1.25828,0.093,NULL,60267165698,941674464,14713663,17.6),(73059,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73059,37.75,0.33,355,27440,70,NULL,NULL,'2MASX J10391428+6252452',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,159.809583,62.87922,0.009,NULL,61839264143,966238502,15097476,17.5),(73060,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73060,37.54,0.19,322,27441,70,NULL,NULL,'SDSS J103914.57+043720.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000146,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,159.8107083,4.62247,0.061,NULL,61015093921,953360842,14896263,18.4),(73061,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73061,37.7,0.46,347,27442,70,NULL,NULL,'2MASX J10391476+1219003',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,159.811583,12.31686,0.029,NULL,61177023402,955890990,14935796,18.1),(73062,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73062,37.22,0.46,278,27443,70,NULL,NULL,'2MASX J10391483+4441323',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,'FoF','16.97',0.23,'BrClG',NULL,NULL,NULL,NULL,1,159.811583,44.69233,0,NULL,64133485113,1002085704,15657589,16.97),(73063,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73063,33.59,0.8,52.2,27444,75,NULL,'MAT, I','ESO 437- G 030',NULL,'1997ApJS..109..333W',1997,1,3.1,NULL,'G',0.000013,NULL,'13.67',0.6,'SB(rs?)b?      HII','in a triple',NULL,NULL,NULL,1,159.812,-30.29783,0.141,NULL,41499406299,648428223,10131690,13.67),(73064,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73064,33.61,0.8,52.7,27444,75,NULL,'HMCL, I','ESO 437- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73065,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73065,33,0.38,39.8,27444,NULL,NULL,NULL,'ESO 437- G 030',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73066,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73066,33.02,0.4,40.2,27444,75,NULL,'HMCL, I, raw','ESO 437- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73067,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73067,33.07,0.47,41.1,27444,NULL,NULL,'H','ESO 437- G 030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73068,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73068,33.08,0.46,41.4,27444,NULL,NULL,'J','ESO 437- G 030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73069,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73069,33.1,0.43,41.8,27444,75,NULL,'MAT, I, raw','ESO 437- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73070,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73070,33.13,0.45,42.3,27444,NULL,NULL,'K','ESO 437- G 030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73071,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73071,33.2,0.49,43.6,27444,75,NULL,'IR','ESO 437- G 030',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73072,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73072,33.21,0.4,43.8,27444,75,NULL,'HMCL, I, inv','ESO 437- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73073,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73073,33.22,0.32,44.1,27444,85,NULL,'I, raw','ESO 437- G 030',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73074,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73074,33.28,0.32,45.3,27444,85,NULL,'I, inv','ESO 437- G 030',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73075,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73075,33.33,0.4,46.3,27444,75,NULL,'HMCL, I, cor','ESO 437- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73076,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73076,33.36,0.43,46.9,27444,75,NULL,'MAT, I, inv','ESO 437- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73077,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73077,33.37,0.43,47.2,27444,75,NULL,'3.6 micron, color corrected','ESO 437- G 030',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73078,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73078,33.4,0.2,47.9,27444,74.4,NULL,NULL,'ESO 437- G 030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73079,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73079,33.41,0.43,48,27444,75,NULL,'MAT, I, cor','ESO 437- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73080,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73080,33.43,0.43,48.6,27444,75,NULL,'3.6 micron, color + selection bias corrected','ESO 437- G 030',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73081,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73081,33.81,0.4,57.8,27444,NULL,NULL,'mean','ESO 437- G 030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73082,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73082,33.83,0.12,58.5,27444,NULL,NULL,NULL,'ESO 437- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73083,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73083,36.93,0.46,243,27445,70,NULL,NULL,'2MASX J10391576+1532093',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,159.815583,15.536,0.073,NULL,61181420815,955959700,14936870,17.5),(73084,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73084,37.48,0.13,313,27446,70,NULL,NULL,'SDSS J103916.01+050424.7',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000175,NULL,'17.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,159.816708333,5.07356,0.061,NULL,61015133114,953361454,14896272,17),(73085,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73085,37.55,0.46,324,27447,70,NULL,NULL,'2MASX J10391635+0006043',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000082,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,159.818333333,0.10111,0.085,NULL,60265001460,941640647,14713135,17.1),(73086,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73086,38.51,0.46,502,27448,70,NULL,NULL,'SDSS J103916.42+005700.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000061,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,159.8184583,0.95003,0.109,NULL,60265175592,941643368,14713177,18.6),(73087,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73087,37.72,0.19,349,27449,70,NULL,NULL,'2MASX J10391647+1201073',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,159.8185417,12.01889,0.045,NULL,61176476883,955882451,14935663,17.9),(73088,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73088,37.37,0.46,298,27450,70,NULL,NULL,'2MASX J10391658+2814518',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000152,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,159.819125,28.24761,0.017,NULL,60521381255,945646582,14775727,17),(73089,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73089,37.7,0.23,346,27451,70,NULL,NULL,'SDSS J103916.88+021943.3',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000148,NULL,'18.3g',0.1,NULL,NULL,NULL,NULL,NULL,1,159.820375,2.32872,0.061,NULL,60265971873,941655810,14713372,18.3),(73090,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73090,37.64,0.46,337,27452,70,NULL,NULL,'2MASX J10391820+5740366',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000173,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,159.826,57.67703,0,NULL,62003677729,968807464,15137616,17.3),(73091,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73091,33.03,0.8,40.4,27453,75,NULL,'MAT, I','ESO 501- G 068',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'14.25',0.6,'S(B)bc(rs)     HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.826083333,-26.83997,0.285,NULL,41528875304,648888676,10138885,14.25),(73092,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73092,33.06,0.8,40.9,27453,75,NULL,'HMCL, I','ESO 501- G 068',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73093,'Sosies','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73093,34.02,0.14,63.7,27453,NULL,NULL,NULL,'ESO 501- G 068',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73094,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73094,33.28,0.38,45.3,27453,NULL,NULL,NULL,'ESO 501- G 068',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73095,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73095,33.31,0.32,45.9,27453,85,NULL,'I, raw','ESO 501- G 068',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73096,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73096,33.32,0.4,46.1,27453,75,NULL,'HMCL, I, raw','ESO 501- G 068',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73097,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73097,33.35,0.32,46.7,27453,85,NULL,'I, inv','ESO 501- G 068',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73098,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73098,33.37,0.43,47.3,27453,75,NULL,'MAT, I, raw','ESO 501- G 068',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73099,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73099,33.44,0.4,48.8,27453,NULL,NULL,'mean','ESO 501- G 068',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73100,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73100,33.46,0.4,49.1,27453,75,NULL,'HMCL, I, inv','ESO 501- G 068',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73101,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73101,33.53,0.4,50.8,27453,75,NULL,'HMCL, I, cor','ESO 501- G 068',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73102,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73102,33.54,0.43,51.2,27453,75,NULL,'MAT, I, inv','ESO 501- G 068',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73103,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73103,33.57,0.43,51.7,27453,75,NULL,'MAT, I, cor','ESO 501- G 068',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73104,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73104,33.63,0.2,53.2,27453,74.4,NULL,NULL,'ESO 501- G 068',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73105,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73105,33.64,0.43,53.5,27453,75,NULL,'3.6 micron, color corrected','ESO 501- G 068',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73106,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73106,33.72,0.43,55.4,27453,75,NULL,'3.6 micron, color + selection bias corrected','ESO 501- G 068',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73107,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73107,33.84,0.09,58.7,27453,NULL,NULL,NULL,'ESO 501- G 068',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73108,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73108,34.05,0.47,64.7,27453,NULL,NULL,'H','ESO 501- G 068',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73109,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73109,34.08,0.46,65.6,27453,NULL,NULL,'J','ESO 501- G 068',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73110,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73110,37.84,0.46,370,27454,70,NULL,NULL,'2MASX J10391835+2359498',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.53',0.12,NULL,NULL,NULL,NULL,NULL,1,159.8265,23.99714,0.013,NULL,60943288863,952238888,14878732,18.53),(73111,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73111,36.91,0.46,241,27455,70,NULL,NULL,'2MASX J10391849+0050233',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000099,NULL,'16.0g',0.41,'Sbc',NULL,NULL,NULL,NULL,1,159.827083,0.83986,0.109,NULL,60265198999,941643734,14713183,16),(73112,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73112,37.7,0.23,346,27456,70,NULL,NULL,'SDSS J103919.47+021918.3',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000105,NULL,'16.5g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,159.831125,2.32178,0.061,NULL,60265943121,941655361,14713365,16.5),(73113,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73113,37.43,0.17,307,27457,70,NULL,NULL,'2MASX J10391961+5818536',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,159.83175,58.31492,0,NULL,62002623482,968790991,15137359,17.1),(73114,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73114,37.48,0.13,313,27458,70,NULL,NULL,'2MASX J10392003+0508113',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000183,NULL,'16.1g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,159.833375,5.13647,0.061,NULL,61007594355,953243661,14894432,16.1),(73115,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73115,36.35,0.46,186,27459,70,NULL,NULL,'2MASX J10392000+1141283',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000199,NULL,'15.8g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,159.833417,11.69117,0.057,NULL,61045725706,953839464,14903741,15.8),(73116,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73116,36.63,0.46,212,27460,70,NULL,NULL,'2MASX J10392002+4155129',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000143,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,159.8335417,41.92042,0,NULL,64142340629,1002224072,15659751,17.4),(73117,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73117,33.89,0.46,60,27461,70,NULL,NULL,'NGC 3325',NULL,'2015arXiv151105856S',2015,1,1.19,NULL,'G',0.000055,NULL,'13.7g',0.93,'E:','Possible field galaxy',NULL,NULL,NULL,1,159.8352083,-0.20025,0.097,NULL,40871488949,638617014,9978390,13.7),(73118,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73118,36.8,0.46,229,27462,70,NULL,NULL,'2MASX J10392202+0154523',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000091,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,159.841791667,1.91461,0.041,NULL,60266880384,941670006,14713593,17),(73119,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73119,33.68,0.8,54.4,27463,75,NULL,'MAT, I','ESO 437- G 031',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.71',0.8,'SAB(rs)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.8420417,-29.58475,0.109,NULL,41532431846,648944247,10139753,14.71),(73120,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73120,33.59,0.32,52.2,27463,85,NULL,'I, raw','ESO 437- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73121,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73121,33.6,0.32,52.5,27463,85,NULL,'I, inv','ESO 437- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73122,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73122,33.67,0.43,54.3,27463,75,NULL,'MAT, I, raw','ESO 437- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73123,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73123,33.72,0.43,55.5,27463,75,NULL,'MAT, I, cor','ESO 437- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73124,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73124,33.75,0.43,56.2,27463,75,NULL,'MAT, I, inv','ESO 437- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73125,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73125,33.75,0.2,56.2,27463,74.4,NULL,NULL,'ESO 437- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73126,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73126,33.79,0.43,57.3,27463,75,NULL,'3.6 micron, color corrected','ESO 437- G 031',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73127,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73127,33.83,0.13,58.5,27463,NULL,NULL,NULL,'ESO 437- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73128,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73128,33.85,0.43,58.9,27463,75,NULL,'3.6 micron, color + selection bias corrected','ESO 437- G 031',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73129,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73129,37.98,0.46,394,27464,70,NULL,NULL,'2MASX J10392326+4008340',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,159.847,40.14292,0,NULL,64118422166,1001850346,15653911,17.6),(73130,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73130,37.73,0.23,352,27465,70,NULL,NULL,'2MASX J10392334+2503378',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00018,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,159.847417,25.06067,0.009,NULL,60469706061,944839157,14763111,17.3),(73131,'TRGB','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73131,30.09,0.1,10.4,27466,74.4,NULL,NULL,'UGC 05797',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000013,NULL,'14.28',0.9,'dIm',NULL,NULL,NULL,NULL,1,159.854917,1.71856,0.045,NULL,60266548095,941664813,14713512,14.28),(73132,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73132,33.77,0.8,56.7,27467,75,NULL,'MAT, I','ESO 501- G 069',NULL,'1997ApJS..109..333W',1997,1,1.6,'This is not IC 0625; that is ESO 501- G 080.','G',0.000017,NULL,'15',0.3,'Sb?            HII',NULL,NULL,NULL,NULL,1,159.85875,-23.75486,0.193,NULL,41666250811,651035168,10172424,15),(73133,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73133,31.7,0.32,21.9,27467,85,NULL,'I, raw','ESO 501- G 069',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73134,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73134,31.7,0.32,21.9,27467,85,NULL,'I, inv','ESO 501- G 069',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73135,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73135,31.9,0.2,24,27467,74.4,NULL,NULL,'ESO 501- G 069',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73136,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73136,31.95,0.43,24.6,27467,75,NULL,'MAT, I, raw','ESO 501- G 069',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73137,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73137,32,0.43,25.1,27467,75,NULL,'MAT, I, inv','ESO 501- G 069',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73138,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73138,32.31,0.43,29,27467,75,NULL,'MAT, I, cor','ESO 501- G 069',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73139,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73139,32.83,0.49,36.7,27467,75,NULL,'IR','ESO 501- G 069',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73140,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73140,33.74,0.12,56.1,27467,NULL,NULL,NULL,'ESO 501- G 069',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73141,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73141,37.73,0.23,352,27468,70,NULL,NULL,'2MASX J10392666+2505178',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,159.861,25.08833,0.009,NULL,60469705980,944839155,14763111,17.7),(73142,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73142,31.87,0.2,23.7,27469,74.4,NULL,NULL,'UGC 05791',NULL,'2013AJ....146...86T',2013,1,1.41,NULL,'G',0.000033,NULL,'14.8g',0.43,'Sc             HII','Pair member (points to parent)',NULL,NULL,NULL,1,159.8620417,47.94711,0,NULL,64137096169,1002142127,15658470,14.8),(73143,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73143,32.11,0.43,26.4,27469,75,NULL,'3.6 micron, color corrected','UGC 05791',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73144,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73144,32.31,0.43,28.9,27469,75,NULL,'3.6 micron, color + selection bias corrected','UGC 05791',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73145,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73145,37.1,0.46,263,27470,70,NULL,NULL,'2MASX J10392736+4103240',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000158,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,159.864125,41.05675,0,NULL,64111209383,1001737646,15652150,16.7),(73146,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73146,37.73,0.23,352,27471,70,NULL,NULL,'2MASX J10392775+2457088',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000152,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,159.8657083,24.95264,0.025,NULL,60469734314,944839598,14763118,16.7),(73147,'SNIa','2016-12-15 15:14:40','2016-12-16 11:19:47','1','SN 2006al',NULL,73147,36.84,0.17,219,27472,74.2,NULL,'SALT 2','SDSS J103928.53+051101.1',0.067849,'2010ApJ...716..712A',2010,1,0.18,NULL,'G',0.000157,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,159.868875,5.18367,0.061,NULL,61008121261,953251894,14894560,18),(73148,'SNIa','2016-12-15 15:14:40','2016-12-16 11:19:47','1','SN 2006al',NULL,73148,37.56,0.16,304,27472,70,NULL,'SALT 2','SDSS J103928.53+051101.1',0.067849,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73149,'SNIa','2016-12-15 15:14:40','2016-12-16 11:19:47','1','SN 2006al',NULL,73149,37.63,0.18,314,27472,65,NULL,'SALT2','SDSS J103928.53+051101.1',0.067849,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73150,'SNIa','2016-12-15 15:14:40','2016-12-16 11:19:47','1','SN 2006al',NULL,73150,37.69,0.15,323,27472,65,NULL,'SALT','SDSS J103928.53+051101.1',0.067849,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73151,'SNIa','2016-12-15 15:14:40','2016-12-16 11:19:47','1','SN 2006al',NULL,73151,37.76,0.06,334,27472,70,NULL,'SALT 2','SDSS J103928.53+051101.1',0.067849,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73152,'SNIa','2016-12-15 15:14:40','2016-12-16 11:19:47','1','SN 2006al',NULL,73152,37.8,0.14,340,27472,65,NULL,'MLCS17','SDSS J103928.53+051101.1',0.067849,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73153,'SNIa','2016-12-15 15:14:40','2016-12-16 11:19:47','1','SN 2006al',NULL,73153,37.83,0.13,345,27472,65,NULL,'MLCS31','SDSS J103928.53+051101.1',0.067849,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73154,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73154,35.73,0.46,140,27473,70,NULL,NULL,'2MASX J10392906+2445588',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000168,NULL,'15.6g',0.5,NULL,NULL,NULL,NULL,NULL,1,159.871083,24.76647,0.045,NULL,60470212568,944847071,14763235,15.6),(73155,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73155,38.04,0.46,406,27474,70,NULL,NULL,'2MASX J10392926+5329230',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000128,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,159.871708333,53.48958,0.009,NULL,61961887211,968154487,15127413,17.7),(73156,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73156,37.89,0.46,378,27475,70,NULL,NULL,'2MASX J10392934+0126036',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,159.8722917,1.43428,0.093,NULL,60267004151,941671939,14713624,17.4),(73157,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73157,35.87,0.46,149,27476,70,NULL,NULL,'2MASX J10392955+4445456',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000161,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,159.873167,44.76264,0,NULL,64133506037,1002086031,15657594,16.1),(73158,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73158,37.94,0.46,388,27477,70,NULL,NULL,'SDSS J103929.99+071645.2',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000147,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,159.875,7.27925,0.105,NULL,61065550269,954149222,14908581,17.4),(73159,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73159,38.46,0.27,492,27478,70,NULL,NULL,'2MASX J10393046+3947190',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000192,NULL,'16.2g',0.38,'BrClG',NULL,NULL,NULL,NULL,1,159.876833,39.78861,0,NULL,64119304083,1001864126,15654126,16.2),(73160,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73160,38.13,0.46,423,27479,70,NULL,NULL,'2MASX J10393049+1407537',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,159.877125,14.1315,0.065,NULL,61186254055,956035219,14938050,17.9),(73161,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73161,37.32,0.33,290,27480,70,NULL,NULL,'SDSS J103931.19+580101.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000137,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,159.8799583,58.01703,0,NULL,62003851064,968810172,15137658,18),(73162,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73162,37.48,0.13,313,27481,70,NULL,NULL,'SDSS J103932.05+051007.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00018,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,159.883541667,5.16875,0.061,NULL,61008120961,953251890,14894560,18),(73163,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73163,37.72,0.19,349,27482,70,NULL,NULL,'2MASX J10393220+1158403',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,159.88425,11.97769,0.061,NULL,61176446179,955881971,14935655,17.9),(73164,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73164,32.57,0.25,32.7,27483,74.4,NULL,NULL,'NGC 3335',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000083,NULL,'13.99',0.9,'SAB(rl)0^+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.891916667,-23.92269,0.189,NULL,41611715204,650183050,10159110,13.99),(73165,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73165,35.81,0.46,145,27484,70,NULL,NULL,'2MASX J10393471+6228334',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000165,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,159.89475,62.47606,0,NULL,61826010130,966031408,15094240,16.2),(73166,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73166,37.24,0.27,281,27485,70,NULL,NULL,'2MASX J10393518+3243225',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000171,NULL,'16.0g',0.43,NULL,NULL,NULL,NULL,NULL,1,159.89675,32.72306,0.009,NULL,64048563103,1000758798,15636856,16),(73167,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73167,37.63,0.46,336,27486,70,NULL,NULL,'2MASX J10393544+1410437',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,159.897833333,14.17881,0.065,NULL,61186247384,956035115,14938048,18.3),(73168,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73168,38.15,0.46,427,27487,70,NULL,NULL,'2MASX J10393634-0008497',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00008,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,159.9014583,-0.14719,0.097,NULL,40871513773,638617402,9978396,17.7),(73169,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73169,37.31,0.46,290,27488,70,NULL,NULL,'2MASX J10393646+0146006',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000193,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,159.901875,1.76686,0.045,NULL,60266581843,941665341,14713520,16.8),(73170,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73170,32.86,0.8,37.3,27489,75,NULL,'CF, r','NGC 3320',NULL,'1997ApJS..109..333W',1997,1,1.58,NULL,'G',0.00003,NULL,'13.1g',0.94,'SBc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,159.9022083,47.39792,0.005,NULL,64137038286,1002141223,15658456,13.1),(73171,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73171,32.86,0.8,37.3,27489,75,NULL,'A82, H','NGC 3320',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73172,'Tully est','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73172,32.78,0.8,35.9,27489,75,NULL,'B','NGC 3320',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73173,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73173,32.35,0.38,29.5,27489,75,NULL,'CF, r, raw','NGC 3320',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73174,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73174,32.4,0.38,30.2,27489,75,NULL,'CF, r, inv','NGC 3320',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73175,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73175,32.5,0.38,31.7,27489,75,NULL,'CF, r, cor','NGC 3320',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73176,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73176,32.63,0.36,33.6,27489,NULL,NULL,NULL,'NGC 3320',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73177,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73177,32.63,0.43,33.6,27489,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3320',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73178,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73178,32.64,0.47,33.8,27489,75,NULL,'A82, H, raw','NGC 3320',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73179,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73179,32.67,0.43,34.2,27489,75,NULL,'3.6 micron, color corrected','NGC 3320',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73180,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73180,32.7,0.47,34.6,27489,75,NULL,'A82, H, inv','NGC 3320',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73181,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73181,32.77,0.2,35.8,27489,74.4,NULL,NULL,'NGC 3320',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73182,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73182,32.87,0.47,37.5,27489,75,NULL,'A82, H, cor','NGC 3320',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73183,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73183,32.95,0.4,38.9,27489,NULL,NULL,'mean','NGC 3320',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73184,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73184,32.95,0.57,38.9,27489,NULL,NULL,NULL,'NGC 3320',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73185,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73185,32.95,0.57,39,27489,NULL,NULL,'Malmquist cor.','NGC 3320',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73186,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73186,33.09,0.46,41.4,27489,NULL,NULL,'J','NGC 3320',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73187,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73187,33.14,0.47,42.4,27489,NULL,NULL,'H','NGC 3320',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73188,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73188,33.17,0.45,43,27489,NULL,NULL,'K','NGC 3320',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73189,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73189,34.69,0.51,86.7,27490,70,NULL,NULL,'2MASX J10393701-1032185',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'15.28',NULL,NULL,NULL,NULL,NULL,NULL,1,159.904083333,-10.53872,0.109,NULL,41766426986,652600421,10196881,15.28),(73190,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73190,37.7,0.23,346,27491,70,NULL,NULL,'SDSS J103937.00+021613.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,159.9042083,2.2705,0.049,NULL,60266069116,941657329,14713395,18.4),(73191,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73191,38.06,0.33,409,27492,70,NULL,NULL,'SDSS J103938.46+003046.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000088,NULL,'17.8g',0.21,'NLAGN',NULL,NULL,NULL,'Sy 2',1,159.91025,0.51294,0.173,NULL,60265795980,941653062,14713329,17.8),(73192,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73192,37.99,0.46,396,27493,70,NULL,NULL,'2MASX J10393847+1853051',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,159.91025,18.88478,0.033,NULL,60989169279,952955769,14889933,17.8),(73193,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73193,37.62,0.33,334,27494,70,NULL,NULL,'2MASX J10393864+1555187',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,159.910917,15.92197,0.073,NULL,61182172674,955971448,14937053,NULL),(73194,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73194,36.41,0.46,192,27495,70,NULL,NULL,'2MASX J10393958+1101353',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000163,NULL,'16.1g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,159.914833333,11.02656,0.085,NULL,61047942843,953874106,14904282,16.1),(73195,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73195,37.93,0.46,386,27496,70,NULL,NULL,'2MASX J10394256+4049581',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,159.927583,40.83297,0,NULL,64111221791,1001737840,15652153,17.1),(73196,'Magnitude','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73196,36.72,0.13,221,27497,100,NULL,NULL,'MCG -01-27-030',NULL,'1998A&A...337...31R',1998,1,0.6,NULL,'G',0.000103,NULL,'14.2V',0.5,'E;S0p;BrClG','Group member',NULL,NULL,NULL,1,159.930875,-8.68681,0.065,NULL,41806656469,653229007,10206703,14.2),(73197,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73197,37.65,0.33,340,27498,70,NULL,NULL,'SDSS J103943.49+311520.6',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,159.93125,31.25575,0.013,NULL,64047316829,1000739325,15636551,17.3),(73198,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73198,37.32,0.33,290,27499,70,NULL,NULL,'2MASX J10394349+5800185',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,159.931333333,58.00522,0,NULL,62003849500,968810148,15137658,18.1),(73199,'Magnitude','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73199,36.72,0.13,221,27500,100,NULL,NULL,'ABELL 1069',NULL,'1998A&A...337...31R',1998,1,NULL,'Katgert (1996,A&A,310,8) identifies multiple redshift systems in this cluster.','GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,159.935,-8.68361,0.065,NULL,41806655824,653228997,10206703,NULL),(73200,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73200,37.42,0.33,305,27501,70,NULL,NULL,'2MASX J10394561+0527307',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000178,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,159.940125,5.4585,0.033,NULL,61007318468,953239351,14894364,17),(73201,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73201,32.4,0.2,30.2,27502,74.4,NULL,NULL,'UGC 05798',NULL,'2013AJ....146...86T',2013,1,1.12,'Asymmetric.','G',0.000033,NULL,'14.5g',0.39,'Sc             HII','Pair member (points to parent)',NULL,NULL,NULL,1,159.945083,47.93169,0,NULL,64137131901,1002142685,15658479,14.5),(73202,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73202,32.54,0.43,32.3,27502,75,NULL,'3.6 micron, color corrected','UGC 05798',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73203,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73203,32.67,0.43,34.2,27502,75,NULL,'3.6 micron, color + selection bias corrected','UGC 05798',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73204,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73204,32.75,0.49,35.5,27502,75,NULL,'IR','UGC 05798',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73205,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73205,38.06,0.33,409,27503,70,NULL,NULL,'2MASX J10394756+0029067',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000071,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,159.948125,0.48514,0.169,NULL,60265768608,941652634,14713322,18.1),(73206,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73206,37.31,0.33,290,27504,70,NULL,NULL,'2MASX J10394783+0434497',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00021,NULL,'16.1g',0.34,'E0',NULL,NULL,NULL,NULL,1,159.949375,4.58053,0.053,NULL,61007515905,953242436,14894413,16.1),(73207,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73207,37.73,0.23,352,27505,70,NULL,NULL,'2MASX J10394811+2458284',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000137,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,159.9504583,24.97458,0.025,NULL,60524404997,945693828,14776466,17),(73208,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73208,36.6,0.46,209,27506,70,NULL,NULL,'2MASX J10394864+4525326',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,159.9525417,45.42572,0,NULL,64134972351,1002108942,15657952,16.7),(73209,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73209,34.17,0.8,68.2,27507,75,NULL,'MAT, I','NGC 3333',NULL,'1997ApJS..109..333W',1997,1,2,'1996ApJS..107...97M has z = 0.016231 +- 0.000033.','G',0.000027,NULL,'13.93',0.4,'SABbc pec sp   HII',NULL,NULL,NULL,NULL,1,159.957625,-36.03617,0.233,NULL,41990362530,656099414,10251553,13.93),(73210,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73210,32.88,0.32,37.7,27507,85,NULL,'I, raw','NGC 3333',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73211,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73211,32.92,0.32,38.4,27507,85,NULL,'I, inv','NGC 3333',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73212,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73212,32.98,0.43,39.5,27507,75,NULL,'MAT, I, raw','NGC 3333',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73213,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73213,33.1,0.47,41.7,27507,NULL,NULL,'H','NGC 3333',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73214,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73214,33.17,0.43,43,27507,75,NULL,'MAT, I, inv','NGC 3333',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73215,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73215,33.18,0.45,43.2,27507,NULL,NULL,'K','NGC 3333',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73216,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73216,33.23,0.46,44.3,27507,NULL,NULL,'J','NGC 3333',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73217,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73217,33.25,0.43,44.7,27507,75,NULL,'MAT, I, cor','NGC 3333',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73218,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73218,33.76,0.49,56.4,27507,75,NULL,'IR','NGC 3333',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73219,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73219,33.79,0.4,57.3,27507,NULL,NULL,'mean','NGC 3333',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73220,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73220,34.03,0.2,64,27507,74.4,NULL,NULL,'NGC 3333',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73221,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73221,34.04,0.08,64.4,27507,NULL,NULL,NULL,'NGC 3333',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73222,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73222,37.74,0.46,354,27508,70,NULL,NULL,'2MASX J10395103+4055430',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,159.9625417,40.92844,0,NULL,64111238389,1001738099,15652157,17.1),(73223,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73223,37.62,0.33,334,27509,70,NULL,NULL,'2MASX J10395106+1601357',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,159.9627917,16.02672,0.057,NULL,61182155179,955971174,14937049,16.9),(73224,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73224,37.48,0.13,313,27510,70,NULL,NULL,'2MASX J10395236+0507581',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,159.968083,5.13278,0.041,NULL,61007602163,953243783,14894434,17.9),(73225,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73225,36.58,0.46,207,27511,70,NULL,NULL,'2MASX J10395323+4428366',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00017,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,159.971667,44.477,0,NULL,64133275859,1002082435,15657538,16.5),(73226,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73226,35.62,0.5,133,27512,70,NULL,NULL,'2MASX J10395415-4307466',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00011,NULL,'15.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,159.975667,-43.12956,0.521,NULL,42131756266,658308691,10286073,15.5),(73227,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73227,37.36,0.46,297,27513,70,NULL,NULL,'2MASX J10395423+0057442',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000089,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,159.976083,0.96228,0.109,NULL,60265322933,941645670,14713213,16.6),(73228,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73228,37.09,0.46,262,27514,70,NULL,NULL,'2MASX J10395488+1725006',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,159.9785417,17.41692,0.033,NULL,60956842143,952450658,14882041,16.2),(73229,'SNIa','2016-12-15 15:14:40','2016-12-16 11:19:47','1','SN 2001N',NULL,73229,34.16,0.18,66.5,27515,74.2,NULL,'SALT 2','NGC 3327',0.021025,'2010ApJ...716..712A',2010,1,1.21,'HOLM 207B is a star.','G',0.00015,NULL,'13.7g',0.91,'SA(r)b:',NULL,NULL,NULL,NULL,1,159.991416667,24.09125,0.013,NULL,60943251909,952238311,14878723,13.7),(73230,'SNIa','2016-12-15 15:14:40','2016-12-16 11:19:47','1','SN 2001N',NULL,73230,34.72,0.09,87.9,27515,74.4,NULL,NULL,'NGC 3327',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73231,'SNIa','2016-12-15 15:14:40','2016-12-16 11:19:47','1','SN 2001N',NULL,73231,35,0.22,98,27515,65,NULL,'MLCS31','NGC 3327',0.021025,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73232,'SNIa','2016-12-15 15:14:40','2016-12-16 11:19:47','1','SN 2001N',NULL,73232,35.02,0.21,98.7,27515,65,NULL,'SALT2','NGC 3327',0.021025,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73233,'SNIa','2016-12-15 15:14:40','2016-12-16 11:19:47','1','SN 2001N',NULL,73233,35.1,0.2,103,27515,65,NULL,'MLCS17','NGC 3327',0.021025,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73234,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73234,35.38,NULL,119,27516,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05802',NULL,'2010Ap&SS.325..163P',2010,1,1.23,NULL,'G',0.000014,NULL,'16.0',0.11,'Sc',NULL,NULL,NULL,NULL,1,159.9915417,15.59858,0.073,NULL,61181465457,955960397,14936881,16),(73235,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73235,35.38,0.49,119,27516,75,NULL,'IR','UGC 05802',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73236,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73236,35.39,NULL,120,27516,NULL,NULL,NULL,'UGC 05802',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73237,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73237,35.39,NULL,120,27516,NULL,NULL,'Dipole + Quadrupole','UGC 05802',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73238,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73238,35.4,NULL,120,27516,NULL,NULL,'Dipole','UGC 05802',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73239,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73239,35.74,0.2,141,27516,74.4,NULL,NULL,'UGC 05802',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73240,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73240,33.88,0.25,59.7,27517,74.4,NULL,NULL,'2MASX J10395899-4611263',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.00004,NULL,'14.71',NULL,'E',NULL,NULL,NULL,NULL,1,159.995875,-46.19047,0.745,NULL,42101398982,657834359,10278661,14.71),(73241,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73241,38.46,0.27,492,27518,70,NULL,NULL,'2MASX J10395927+3943416',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,159.997083,39.72808,0,NULL,64119268646,1001863572,15654118,18),(73242,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73242,33.62,0.8,53.1,27519,75,NULL,'HMCL, I','ESO 437- G 034',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00015,NULL,'16.02',0.6,'Sb',NULL,NULL,NULL,NULL,1,159.99975,-29.41308,0.113,NULL,41532350347,648942974,10139733,16.02),(73243,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73243,33.43,0.38,48.5,27519,NULL,NULL,NULL,'ESO 437- G 034',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73244,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73244,33.48,0.2,49.7,27519,74.4,NULL,NULL,'ESO 437- G 034',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73245,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73245,33.61,0.12,52.8,27519,NULL,NULL,NULL,'ESO 437- G 034',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73246,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73246,33.67,0.4,54.3,27519,75,NULL,'HMCL, I, inv','ESO 437- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73247,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73247,33.68,0.4,54.5,27519,75,NULL,'HMCL, I, raw','ESO 437- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73248,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73248,33.72,0.4,55.4,27519,75,NULL,'HMCL, I, cor','ESO 437- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73249,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73249,33.82,0.43,58,27519,75,NULL,'3.6 micron, color corrected','ESO 437- G 034',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73250,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73250,34.16,0.43,68,27519,75,NULL,'3.6 micron, color + selection bias corrected','ESO 437- G 034',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73251,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73251,37.78,0.46,359,27520,70,NULL,NULL,'SDSS J104000.02+581156.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00013,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,160.000125,58.19903,0,NULL,62002586795,968790418,15137350,18.3),(73252,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73252,33.39,0.25,47.6,27521,74.4,NULL,NULL,'2MASX J10400161-4609063',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.00005,NULL,'12.0J',NULL,'S0',NULL,NULL,NULL,NULL,1,160.007041667,-46.15186,0.753,NULL,42101613050,657837703,10278714,12),(73253,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73253,33.88,0.25,59.7,27522,74.4,NULL,NULL,'2MASX J10400182-4623053',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000047,NULL,'16.14',NULL,'E',NULL,NULL,NULL,NULL,1,160.007625,-46.38506,0.813,NULL,42100890236,657826409,10278537,16.14),(73254,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73254,37.31,0.33,290,27523,70,NULL,NULL,'SDSS J104002.04+043330.9',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000141,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,160.008541667,4.55861,0.053,NULL,61007468452,953241694,14894401,17.6),(73255,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73255,37.1,0.46,263,27524,70,NULL,NULL,'2MASX J10400250+3909586',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,160.010625,39.16633,0,NULL,64118637455,1001853710,15653964,17.7),(73256,'FP','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,'R',73256,38.27,0.46,450,27525,70,NULL,NULL,'SDSS J104003.41+411231.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,160.01425,41.20883,0,NULL,64111167264,1001736988,15652140,18.4),(73257,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73257,33.29,0.8,45.5,27526,75,NULL,'MAT, I','ESO 437- G 035',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00003,NULL,'14.19',0.5,'SB(s)bc:       HII','in a triple',NULL,NULL,NULL,1,160.0182917,-30.26719,0.169,NULL,41499477328,648429333,10131708,14.19),(73258,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73258,31.93,0.32,24.3,27526,85,NULL,'I, inv','ESO 437- G 035',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73259,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73259,31.94,0.32,24.4,27526,85,NULL,'I, raw','ESO 437- G 035',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73260,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73260,32.25,0.43,28.2,27526,75,NULL,'MAT, I, raw','ESO 437- G 035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73261,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:47','1',NULL,NULL,73261,32.27,0.43,28.4,27526,75,NULL,'MAT, I, inv','ESO 437- G 035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73262,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73262,32.59,0.43,32.9,27526,75,NULL,'3.6 micron, color + selection bias corrected','ESO 437- G 035',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73263,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73263,32.68,0.43,34.3,27526,75,NULL,'MAT, I, cor','ESO 437- G 035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73264,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73264,32.71,0.43,34.9,27526,75,NULL,'3.6 micron, color corrected','ESO 437- G 035',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73265,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73265,32.83,0.2,36.8,27526,74.4,NULL,NULL,'ESO 437- G 035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73266,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73266,33.58,0.4,51.9,27526,NULL,NULL,'mean','ESO 437- G 035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73267,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73267,33.75,0.47,56.1,27526,NULL,NULL,'H','ESO 437- G 035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73268,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73268,37.73,0.46,351,27527,70,NULL,NULL,'SDSS J104004.66+425206.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000143,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,160.0194583,42.86847,0,NULL,64143386385,1002240412,15660006,18.7),(73269,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73269,37.51,0.46,317,27528,70,NULL,NULL,'2MASX J10400481+2439361',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000174,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,160.020083333,24.65997,0.037,NULL,60523995192,945687424,14776366,17.1),(73270,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73270,38.15,0.46,426,27529,70,NULL,NULL,'2MASX J10400521-0036514',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000069,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,160.021625,-0.61436,0.121,NULL,40872310965,638629858,9978591,18.2),(73271,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73271,37.16,0.46,271,27530,70,NULL,NULL,'2MASX J10400583+2144361',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,160.024167,21.74331,0.005,NULL,60992485375,953007583,14890743,17.3),(73272,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73272,34.04,0.45,64.2,27531,NULL,NULL,'K','ESO 264- G 028',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000057,NULL,'14.82',0.7,'SB(r)0^+',NULL,NULL,NULL,NULL,1,160.025375,-46.11561,0.753,NULL,42101613076,657837704,10278714,14.82),(73273,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73273,34.78,0.4,90.2,27531,NULL,NULL,'mean','ESO 264- G 028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73274,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73274,36.95,0.46,245,27532,70,NULL,NULL,'2MASX J10400632+2451531',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000136,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,160.026333333,24.86467,0.045,NULL,60524662140,945697845,14776528,17.5),(73275,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73275,35.87,0.46,149,27533,70,NULL,NULL,'KUG 1037+393B',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000164,NULL,'16.9g',0.16,'Spiral',NULL,NULL,NULL,NULL,1,160.028333,39.09925,0,NULL,64118639241,1001853738,15653964,16.9),(73276,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73276,37.48,0.13,313,27534,70,NULL,NULL,'2MASX J10400755+0512162',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000185,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,160.031291667,5.20456,0.041,NULL,61008179113,953252798,14894574,17.1),(73277,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73277,38.1,0.46,418,27535,70,NULL,NULL,'2MASX J10400773+1643097',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'18.32',0.24,NULL,NULL,NULL,NULL,NULL,1,160.032125,16.71947,0.073,NULL,61178621330,955915958,14936186,18.32),(73278,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73278,37.42,0.33,305,27536,70,NULL,NULL,'SDSS J104008.16+052709.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000164,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,160.0340417,5.45275,0.033,NULL,61007297699,953239026,14894359,18.2),(73279,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73279,37.86,0.46,374,27537,70,NULL,NULL,'2MASX J10400870+3903477',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000128,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,160.036333,39.06328,0,NULL,64118650807,1001853918,15653967,18.3),(73280,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73280,38.26,0.27,449,27538,70,NULL,NULL,'2MASX J10400891+1058269',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000182,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,160.037167,10.97422,0.057,NULL,61048072451,953876132,14904314,16.7),(73281,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73281,31.6,NULL,20.9,27539,NULL,NULL,NULL,'AGC 208399',NULL,'2013AJ....145..101K',2013,1,NULL,NULL,'G',0.000038,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,160.044583,4.90889,0.061,NULL,61007684120,953245064,14894454,NULL),(73282,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73282,35.03,0.25,101,27540,74.4,NULL,NULL,'LEDA 101362',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.00008,NULL,NULL,NULL,'E',NULL,NULL,NULL,NULL,1,160.049875,-46.34286,0.813,NULL,42100884690,657826323,10278536,NULL),(73283,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73283,37.53,0.46,321,27541,70,NULL,NULL,'2MASX J10401258+2914322',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000193,NULL,'17.1g',0.21,'E',NULL,NULL,NULL,NULL,1,160.052541667,29.24228,0.029,NULL,60520275654,945629307,14775457,17.1),(73284,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73284,37.59,0.46,330,27542,70,NULL,NULL,'2MASX J10401342+4139447',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,160.0559583,41.66236,0,NULL,64141789250,1002215457,15659616,17.6),(73285,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73285,37.43,0.17,307,27543,70,NULL,NULL,'2MASX J10401404+5818575',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00017,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,160.058375,58.31603,0,NULL,62002610830,968790794,15137356,16.7),(73286,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73286,34.85,0.47,93.2,27544,70,NULL,NULL,'ESO 264-IG 030 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00006,NULL,'14.57',0.6,'S0',NULL,NULL,NULL,NULL,1,160.0602083,-46.32869,0.813,NULL,42101394343,657834286,10278660,14.57),(73287,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73287,34.46,0.45,78.1,27544,NULL,NULL,'K','ESO 264-IG 030 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73288,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73288,34.72,0.4,87.9,27544,NULL,NULL,'mean','ESO 264-IG 030 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73289,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73289,37.83,0.46,368,27545,70,NULL,NULL,'2MASX J10401584+0923037',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,160.0660417,9.38442,0.089,NULL,61054330800,953973918,14905842,17.9),(73290,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73290,38.46,0.27,492,27546,70,NULL,NULL,'2MASX J10401704+3938467',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000193,NULL,'17.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,160.071,39.64647,0,NULL,64118752991,1001855515,15653992,17.9),(73291,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73291,38.38,0.46,474,27547,70,NULL,NULL,'2MASX J10401703+2903162',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,160.0710417,29.05444,0.029,NULL,60523556031,945680562,14776258,17.5),(73292,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73292,37.24,0.27,281,27548,70,NULL,NULL,'2MASX J10401765+3252091',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000152,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,160.073417,32.86933,0.005,NULL,64048579582,1000759055,15636860,17.2),(73293,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73293,35.63,0.46,133,27549,70,NULL,NULL,'CGCG 037-108',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000137,NULL,'15.5g',0.47,'S0^-',NULL,NULL,NULL,NULL,1,160.073916667,5.35919,0.041,NULL,61008163555,953252555,14894571,15.5),(73294,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73294,37.57,0.46,327,27550,70,NULL,NULL,'2MASX J10401840+3854247',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000159,NULL,'16.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,160.076583,38.90694,0,NULL,64118592125,1001853001,15653953,16.6),(73295,'Tully est','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73295,30.58,0.8,13.1,27551,75,NULL,NULL,'ESO 214- G 017',NULL,'1988NBGC.C....0000T',1988,1,4.3,NULL,'G',0.000007,NULL,'12.2',3.5,'SB(rs)d',NULL,NULL,NULL,NULL,1,160.0780417,-48.56969,NULL,NULL,42096028663,657750447,10277350,12.2),(73296,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73296,38.26,0.27,449,27552,70,NULL,NULL,'SDSS J104019.28+110028.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000149,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,160.080333333,11.00794,0.057,NULL,61048070445,953876100,14904314,18.6),(73297,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73297,37.37,0.46,297,27553,70,NULL,NULL,'2MASX J10401985+0445271',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000177,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,160.082667,4.75769,0.061,NULL,61007483036,953241922,14894405,16.8),(73298,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73298,32.76,0.8,35.6,27554,75,NULL,'MAT, I','NGC 3347A',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000033,NULL,'13.45',0.7,'SB(s)cd: sp    HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,160.085875,-36.41111,0.193,NULL,41986263672,656035369,10250552,13.45),(73299,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73299,32.78,0.8,35.9,27554,75,NULL,'HMCL, I','NGC 3347A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73300,'Sosies','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73300,33.19,0.26,43.5,27554,NULL,NULL,NULL,'NGC 3347A',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73301,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73301,32.36,0.32,29.6,27554,85,NULL,'I, raw','NGC 3347A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73302,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73302,32.39,0.32,30,27554,85,NULL,'I, inv','NGC 3347A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73303,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73303,32.46,0.49,31.1,27554,75,NULL,'IR','NGC 3347A',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73304,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73304,32.48,0.43,31.3,27554,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3347A',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73305,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73305,32.49,0.43,31.4,27554,75,NULL,'3.6 micron, color corrected','NGC 3347A',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73306,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73306,32.51,0.43,31.8,27554,75,NULL,'MAT, I, raw','NGC 3347A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73307,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73307,32.53,0.2,32.1,27554,74.4,NULL,NULL,'NGC 3347A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73308,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73308,32.61,NULL,33.3,27554,NULL,NULL,'B','NGC 3347A',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73309,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73309,32.66,0.4,34,27554,75,NULL,'HMCL, I, raw','NGC 3347A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73310,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73310,32.67,0.38,34.2,27554,NULL,NULL,NULL,'NGC 3347A',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73311,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73311,32.68,0.43,34.4,27554,75,NULL,'MAT, I, inv','NGC 3347A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73312,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73312,32.77,NULL,35.8,27554,NULL,NULL,'I','NGC 3347A',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73313,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73313,32.8,0.4,36.3,27554,75,NULL,'HMCL, I, inv','NGC 3347A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73314,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73314,32.83,0.43,36.9,27554,75,NULL,'MAT, I, cor','NGC 3347A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73315,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73315,32.91,0.4,38.1,27554,75,NULL,'HMCL, I, cor','NGC 3347A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73316,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73316,33.25,0.12,44.8,27554,NULL,NULL,NULL,'NGC 3347A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73317,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73317,37.94,0.46,387,27555,70,NULL,NULL,'2MASX J10402174+2600542',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000178,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,160.090666667,26.01489,0.033,NULL,60526401278,945725019,14776953,17.4),(73318,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73318,37.56,0.33,325,27556,70,NULL,NULL,'2MASX J10402287+1103578',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,160.095167,11.06611,0.057,NULL,61047863371,953872865,14904263,17.3),(73319,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73319,38.36,0.33,471,27557,70,NULL,NULL,'2MASX J10402298+3736037',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000237,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,160.095833,37.60097,0,NULL,64116107131,1001814173,15653346,18),(73320,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73320,39.15,0.46,677,27558,70,NULL,NULL,'2MASX J10402319+2641513',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,160.0965,26.69756,0.053,NULL,60526082184,945720034,14776875,17.6),(73321,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73321,37.67,0.46,342,27559,70,NULL,NULL,'2MASX J10402319+0437018',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000178,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,160.096583,4.61719,0.053,NULL,61007487525,953241992,14894406,17.2),(73322,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73322,32.09,0.25,26.2,27560,74.4,NULL,NULL,'AM 1038-273 NED01',NULL,'2013AJ....146...86T',2013,1,0.67,NULL,'G',0.00004,NULL,'14.26',0.54,'S0(2)',NULL,NULL,NULL,NULL,1,160.106125,-27.88083,NULL,NULL,41534993209,648984268,10140379,14.26),(73323,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73323,38.14,0.27,425,27561,70,NULL,NULL,'2MASX J10402648+4014047',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000103,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,160.11025,40.23458,0,NULL,64119206942,1001862608,15654103,17.1),(73324,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73324,37.96,0.27,392,27562,70,NULL,NULL,'SDSS J104026.98+403922.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,160.112417,40.65619,0,NULL,64111104571,1001736008,15652125,17.9),(73325,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73325,36.16,0.46,170,27563,70,NULL,NULL,'2MASX J10402718+3940207',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000103,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,160.113333,39.67239,0,NULL,64119259791,1001863434,15654116,16.9),(73326,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73326,37.65,0.33,340,27564,70,NULL,NULL,'2MASX J10402805+3119108',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000187,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,160.116791667,31.31958,0.013,NULL,64050745832,1000792903,15637389,17.1),(73327,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73327,36.91,0.46,241,27565,70,NULL,NULL,'2MASX J10402807+1306505',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00018,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,160.117,13.11403,0.057,NULL,61176581328,955884083,14935688,16.5),(73328,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73328,38.26,0.46,449,27566,70,NULL,NULL,'2MASX J10402827+3230138',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000163,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,160.117875,32.50397,0.013,NULL,64048461573,1000757212,15636831,17.5),(73329,'SNIa','2016-12-15 15:14:40','2016-12-16 11:19:48','1','SN 2005ki',NULL,73329,31.73,0.2,21.7,27567,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','NGC 3332',0.019207,'2011A&A...526A..81B',2011,1,1.34,NULL,'G',0.000023,NULL,'13.4g',1.12,'(R)SA0-','Field galaxy',NULL,NULL,NULL,1,160.1182083,9.18256,0.077,NULL,61054317826,953973716,14905839,13.4),(73330,'SNIa','2016-12-15 15:14:40','2016-12-16 11:19:48','1','SN 2005ki',NULL,73330,33.99,0.19,61.6,27567,74.2,NULL,'SALT 2','NGC 3332',0.019207,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73331,'SNIa','2016-12-15 15:14:40','2016-12-16 11:19:48','1','SN 2005ki',NULL,73331,34.49,0.15,75.9,27567,72,NULL,NULL,'NGC 3332',0.02038,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73332,'SNIa','2016-12-15 15:14:40','2016-12-16 11:19:48','1','SN 2005ki',NULL,73332,34.52,0.03,78.7,27567,72,NULL,NULL,'NGC 3332',0.019207,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73333,'SNIa','2016-12-15 15:14:40','2016-12-16 11:19:48','1','SN 2005ki',NULL,73333,34.57,0.04,80.5,27567,72,NULL,NULL,'NGC 3332',0.019207,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73334,'SNIa','2016-12-15 15:14:40','2016-12-16 11:19:48','1','SN 2005ki',NULL,73334,34.56,0.09,81.7,27567,74.4,NULL,NULL,'NGC 3332',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73335,'SNIa','2016-12-15 15:14:40','2016-12-16 11:19:48','1','SN 2005ki',NULL,73335,34.62,0.16,82.2,27567,72,NULL,NULL,'NGC 3332',0.019207,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73336,'SNIa','2016-12-15 15:14:40','2016-12-16 11:19:48','1','SN 2005ki',NULL,73336,34.58,0.01,82.4,27567,72,NULL,NULL,'NGC 3332',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73337,'SNIa','2016-12-15 15:14:40','2016-12-16 11:19:48','1','SN 2005ki',NULL,73337,34.69,0.24,85.1,27567,73.8,NULL,'SALT 2 (SNANA)','NGC 3332',0.0204,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73338,'SNIa','2016-12-15 15:14:40','2016-12-16 11:19:48','1','SN 2005ki',NULL,73338,34.7,0.17,85.5,27567,70,NULL,'SALT 2','NGC 3332',0.019207,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73339,'SNIa','2016-12-15 15:14:40','2016-12-16 11:19:48','1','SN 2005ki',NULL,73339,34.68,0.05,86.1,27567,72,NULL,'M(H) = -18.317 mag','NGC 3332',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73340,'SNIa','2016-12-15 15:14:40','2016-12-16 11:19:48','1','SN 2005ki',NULL,73340,34.75,0.02,87.6,27567,70,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','NGC 3332',0.019207,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73341,'SNIa','2016-12-15 15:14:40','2016-12-16 11:19:48','1','SN 2005ki',NULL,73341,34.77,0.21,87.9,27567,73.8,NULL,'SALT 2 (SNANA)','NGC 3332',0.0204,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73342,'SNIa','2016-12-15 15:14:40','2016-12-16 11:19:48','1','SN 2005ki',NULL,73342,34.8,0.18,89.6,27567,65,NULL,'MLCS17','NGC 3332',0.019207,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73343,'SNIa','2016-12-15 15:14:40','2016-12-16 11:19:48','1','SN 2005ki',NULL,73343,34.81,0.18,89.7,27567,65,NULL,'MLCS31','NGC 3332',0.019207,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73344,'SNIa','2016-12-15 15:14:40','2016-12-16 11:19:48','1','SN 2005ki',NULL,73344,34.86,0.19,92.2,27567,65,NULL,'SALT','NGC 3332',0.019207,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73345,'SNIa','2016-12-15 15:14:40','2016-12-16 11:19:48','1','SN 2005ki',NULL,73345,34.91,0.21,94.3,27567,65,NULL,'SALT2','NGC 3332',0.019207,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73346,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73346,34.17,0.46,68.3,27567,70,NULL,NULL,'NGC 3332',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73347,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73347,35.74,0.33,140,27568,70,NULL,NULL,'CGCG 065-082',NULL,'2015arXiv151105856S',2015,1,0.87,NULL,'G',0.000183,NULL,'14.9g',0.62,'E0',NULL,NULL,NULL,NULL,1,160.11875,13.62278,0.057,NULL,61182848438,955982006,14937218,14.9),(73348,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73348,36.79,0.46,228,27569,70,NULL,NULL,'2MASX J10402874+1815417',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,160.119875,18.26153,0.017,NULL,60985795217,952903050,14889110,16.5),(73349,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73349,36.63,0.46,211,27570,70,NULL,NULL,'2MASX J10402995+3703106',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00017,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,160.1247083,37.053,0,NULL,64115429165,1001803580,15653180,16.3),(73350,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73350,36.88,0.46,238,27571,70,NULL,NULL,'2MASX J10403055+0022348',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000073,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,160.127375,0.37642,0.105,NULL,60264923380,941639427,14713116,17.3),(73351,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73351,38.03,0.46,404,27572,70,NULL,NULL,'2MASX J10403093+1355075',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,160.128833,13.91875,0.057,NULL,61183063150,955985361,14937271,17.2),(73352,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73352,37.86,0.23,373,27573,70,NULL,NULL,'2MASX J10403170+4016037',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.0001,NULL,'16.5g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,160.131917,40.26772,0,NULL,64119203651,1001862557,15654102,16.5),(73353,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73353,36.28,0.46,181,27574,70,NULL,NULL,'CGCG 037-110',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000168,NULL,'15.7g',0.45,'E0',NULL,NULL,NULL,NULL,1,160.132667,6.87033,0.069,NULL,61065880078,954154376,14908662,15.7),(73354,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73354,33.27,0.25,45.1,27575,74.4,NULL,NULL,'AM 1038-273 NED02',NULL,'2013AJ....146...86T',2013,1,0.78,NULL,'G',0.000083,NULL,'14.29',0.36,'S0(4)','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,160.135666667,-27.86122,NULL,NULL,41534985865,648984154,10140377,14.29),(73355,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73355,38.14,0.27,425,27576,70,NULL,NULL,'2MASX J10403311+4011557',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,160.1377917,40.19875,0,NULL,64119207273,1001862613,15654103,17.7),(73356,'D-Sigma','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73356,34.16,0.18,68,27577,NULL,NULL,'ABELL S0639, 12 galaxies','ESO 264- G 031',NULL,'2000ApJ...529..768K',2000,1,1.2,NULL,'G',0.00006,NULL,'13.9',0.8,'E/S0',NULL,NULL,NULL,NULL,1,160.137917,-46.19122,0.801,NULL,42101618160,657837783,10278715,13.9),(73357,'D-Sigma','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73357,34.17,0.18,68.2,27577,72,NULL,'ABELL S0639, 6 galaxies','ESO 264- G 031',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73358,'D-Sigma','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73358,34.32,0.4,73,27577,75,NULL,'Edat, raw','ESO 264- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73359,'D-Sigma','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73359,34.65,0.4,85.2,27577,75,NULL,'Edat, cor','ESO 264- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73360,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73360,33.88,0.18,59.6,27577,NULL,NULL,'ABELL S0639, 12 galaxies','ESO 264- G 031',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73361,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73361,34,0.2,63,27577,NULL,NULL,'ABELL S0639, 12 galaxies','ESO 264- G 031',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73362,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73362,34.35,0.25,74.1,27577,74.4,NULL,NULL,'ESO 264- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73363,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73363,34.53,0.47,80.5,27577,70,NULL,NULL,'ESO 264- G 031',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73364,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73364,34.81,0.4,91.7,27577,NULL,NULL,'mean','ESO 264- G 031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73365,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73365,34.86,0.45,93.8,27577,NULL,NULL,'K','ESO 264- G 031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73366,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73366,35.14,0.46,107,27578,70,NULL,NULL,'2MASX J10403461-0054341',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000077,NULL,'15.8g',0.33,'S0',NULL,NULL,NULL,NULL,1,160.144333,-0.90942,0.125,NULL,40872028433,638625444,9978522,15.8),(73367,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73367,38.26,0.27,449,27579,70,NULL,NULL,'SDSS J104035.51+110142.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000147,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,160.1479583,11.02847,0.057,NULL,61047884208,953873190,14904268,18.7),(73368,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73368,38.39,0.46,476,27580,70,NULL,NULL,'2MASX J10403658+2553468',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000177,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,160.152333333,25.89636,0.029,NULL,60526396224,945724941,14776952,17.9),(73369,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73369,37.79,0.19,362,27581,70,NULL,NULL,'2MASX J10403761+3352069',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000173,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,160.156625,33.86844,0.021,NULL,64055014018,1000859594,15638431,16.8),(73370,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73370,36.78,0.46,227,27582,70,NULL,NULL,'2MASX J10403793+1732545',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',NULL,NULL,'16.97',0.49,NULL,NULL,NULL,NULL,NULL,1,160.1582083,17.54858,0.029,NULL,60956703022,952448484,14882007,16.97),(73371,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73371,38.14,0.27,425,27583,70,NULL,NULL,'2MASX J10403800+4012027',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000194,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,160.15825,40.20069,0,NULL,64119209803,1001862653,15654103,16.8),(73372,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73372,36.07,0.52,164,27584,70,NULL,NULL,'2MASX J10403802-1415204',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,160.158416667,-14.25561,0.133,NULL,41838980462,653734069,10214594,14.5),(73373,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73373,37.5,0.46,316,27585,70,NULL,NULL,'2MASX J10403868+0246498',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000188,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,160.1610417,2.78044,0.049,NULL,60265866464,941654163,14713346,17),(73374,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73374,36.89,0.46,239,27586,70,NULL,NULL,'2MASX J10403905+5432490',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000136,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,160.162917,54.54694,0,NULL,61972822113,968325345,15130083,17.1),(73375,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73375,36.35,0.46,186,27587,70,NULL,NULL,'2MASX J10403915+0851408',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000169,NULL,'15.8g',0.42,'E0',NULL,NULL,NULL,NULL,1,160.163083,8.86142,0.065,NULL,61067570669,954180791,14909074,15.8),(73376,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73376,37.86,0.46,374,27588,70,NULL,NULL,'2MASX J10403933+2624489',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,160.1639583,26.41347,0.053,NULL,60526915811,945733059,14777079,17.8),(73377,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73377,37.96,0.27,392,27589,70,NULL,NULL,'2MASX J10404031+4038387',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000183,NULL,'16.3g',0.42,NULL,NULL,NULL,NULL,NULL,1,160.167875,40.64408,0,NULL,64111104284,1001736004,15652125,16.3),(73378,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73378,37.17,0.46,271,27590,70,NULL,NULL,'2MASX J10404065+0422488',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,160.169375,4.38031,0.057,NULL,61008810552,953262664,14894729,17.3),(73379,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73379,38.36,0.33,471,27591,70,NULL,NULL,'2MASXi J1040425+373344',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00014,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,160.1772917,37.56258,0,NULL,64115261339,1001800958,15653139,18.1),(73380,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73380,37.24,0.27,281,27592,70,NULL,NULL,'2MASX J10404328+3247459',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000205,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,160.1805,32.79628,0.009,NULL,64048594530,1000759289,15636863,16.7),(73381,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73381,36.09,0.46,165,27593,70,NULL,NULL,'2MASX J10404408+2136077',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.86',0.17,NULL,NULL,NULL,NULL,NULL,1,160.18375,21.60219,0.009,NULL,60992428768,953006699,14890729,17.86),(73382,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73382,33.11,0.8,42,27594,75,NULL,'HMCL, I','ESO 264- G 033',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',NULL,NULL,'15.63',1,'SB...',NULL,NULL,NULL,NULL,1,160.184667,-47.18581,0.829,NULL,42109118934,657954983,10280546,15.63),(73383,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73383,35.22,0.4,111,27594,75,NULL,'HMCL, I, raw','ESO 264- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73384,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73384,35.3,0.4,115,27594,75,NULL,'HMCL, I, cor','ESO 264- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73385,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73385,35.42,0.4,121,27594,75,NULL,'HMCL, I, inv','ESO 264- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73386,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73386,37.89,0.46,379,27595,70,NULL,NULL,'2MASX J10404465+3853587',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,160.186125,38.89964,0,NULL,64122051889,1001907060,15654797,17.2),(73387,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73387,37.33,0.46,293,27596,70,NULL,NULL,'SDSS J104045.14+013250.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000075,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,160.188125,1.54725,0.037,NULL,60266386807,941662293,14713473,18.2),(73388,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73388,37.96,0.27,392,27597,70,NULL,NULL,'2MASX J10404849+4041287',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,160.2020417,40.69125,0,NULL,64111105144,1001736017,15652125,17.4),(73389,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73389,37.21,0.46,276,27598,70,NULL,NULL,'2MASX J10404973+5238328',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000123,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,160.207125,52.64233,0,NULL,61959130257,968111410,15126740,16.9),(73390,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73390,37.56,0.33,325,27599,70,NULL,NULL,'SDSS J104049.81+105758.4',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,160.207541667,10.96625,0.053,NULL,61047887944,953873249,14904269,17.9),(73391,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73391,37.98,0.46,395,27600,70,NULL,NULL,'2MASX J10405018+0345008',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,160.209291667,3.75011,0.057,NULL,61009111421,953267365,14894802,18),(73392,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73392,33.73,0.55,55.8,27601,70,NULL,NULL,'ESO 437- G 038',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000067,NULL,'14.45',0.5,'S0(4)','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,160.209583,-27.966,NULL,NULL,41534704364,648979755,10140308,14.45),(73393,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73393,34.26,0.25,71.1,27601,74.4,NULL,NULL,'ESO 437- G 038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73394,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73394,34.16,0.4,67.8,27601,NULL,NULL,'mean','ESO 437- G 038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73395,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73395,34.57,0.45,82,27601,NULL,NULL,'K','ESO 437- G 038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73396,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73396,37.03,0.46,255,27602,70,NULL,NULL,'2MASXi J1040504+321830',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,160.209875,32.30842,0.013,NULL,64048868741,1000763574,15636930,17.4),(73397,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73397,31.83,0.43,23.3,27603,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3347C',NULL,'2014MNRAS.444..527S',2014,1,1.5,NULL,'G',0.00002,NULL,'14.79',1.2,'SB(s)d',NULL,NULL,NULL,NULL,1,160.223708333,-36.28792,0.193,NULL,41990442502,656100664,10251572,14.79),(73398,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73398,35.46,0.62,124,27604,70,NULL,NULL,'2MASX J10405519-7959110',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,160.2297083,-79.9865,0.321,NULL,39979213532,624675211,9760550,16.6),(73399,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73399,37.43,0.17,307,27605,70,NULL,NULL,'2MASX J10405566+5818161',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000178,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,160.232041667,58.30442,0,NULL,62002807075,968793860,15137404,17.7),(73400,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73400,36.6,0.46,209,27606,70,NULL,NULL,'2MASX J10405734+5404221',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000142,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,160.238833,54.07281,0,NULL,61961045170,968141330,15127208,16.5),(73401,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73401,37.78,0.46,360,27607,70,NULL,NULL,'2MASX J10405799+1551594',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,160.241583333,15.86664,0.061,NULL,61182223446,955972241,14937066,17.8),(73402,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73402,37.58,0.46,329,27608,70,NULL,NULL,'2MASX J10405833+4717210',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000144,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,160.242958333,47.28908,0.005,NULL,64137015199,1002140862,15658450,16.9),(73403,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73403,38.09,0.27,415,27609,70,NULL,NULL,'2MASX J10405836+2547489',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,160.243333,25.79706,0.025,NULL,60527434777,945741168,14777205,17.3),(73404,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73404,34.17,0.8,68.2,27610,75,NULL,'MAT, I','ESO 501- G 075',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000023,NULL,'13.48',1.2,'SA(s)c:        HII',NULL,NULL,NULL,NULL,1,160.246125,-27.08403,0.285,NULL,41536385545,649006024,10140719,13.48),(73405,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73405,33.13,0.32,42.2,27610,85,NULL,'I, raw','ESO 501- G 075',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73406,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73406,33.17,0.32,43.1,27610,85,NULL,'I, inv','ESO 501- G 075',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73407,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73407,33.22,0.17,44.1,27610,NULL,NULL,'B, Hubble-type-TF','ESO 501- G 075',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73408,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73408,33.22,0.17,44.1,27610,NULL,NULL,'B, Hubble-type-TF','ESO 501- G 075',NULL,'2005Ap&SS.299..387R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73409,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73409,33.22,NULL,44.1,27610,NULL,NULL,'B, Hubble-type-TF','ESO 501- G 075',NULL,'2005Ap&SS.299..405R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73410,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73410,33.24,0.43,44.4,27610,75,NULL,'MAT, I, raw','ESO 501- G 075',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73411,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73411,33.29,0.43,45.5,27610,75,NULL,'3.6 micron, color corrected','ESO 501- G 075',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73412,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73412,33.32,0.43,46.1,27610,75,NULL,'3.6 micron, color + selection bias corrected','ESO 501- G 075',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73413,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73413,33.33,0.2,46.3,27610,74.4,NULL,NULL,'ESO 501- G 075',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73414,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73414,33.45,0.43,49,27610,75,NULL,'MAT, I, inv','ESO 501- G 075',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73415,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73415,33.5,0.43,50.2,27610,75,NULL,'MAT, I, cor','ESO 501- G 075',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73416,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73416,33.57,0.47,51.7,27610,NULL,NULL,'H','ESO 501- G 075',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73417,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73417,33.65,0.46,53.7,27610,NULL,NULL,'J','ESO 501- G 075',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73418,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73418,33.68,0.69,54.4,27610,100,NULL,'mid-IR','ESO 501- G 075',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73419,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73419,33.7,0.45,54.9,27610,NULL,NULL,'K','ESO 501- G 075',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73420,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73420,33.83,0.07,58.5,27610,NULL,NULL,NULL,'ESO 501- G 075',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73421,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73421,34.25,0.4,70.7,27610,NULL,NULL,'mean','ESO 501- G 075',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73422,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73422,37.92,0.46,384,27611,70,NULL,NULL,'2MASX J10405926+0952181',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,160.246833,9.87167,0.149,NULL,61053968873,953968263,14905754,17.1),(73423,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73423,37.4,0.46,303,27612,70,NULL,NULL,'2MASX J10405936+0057318',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000066,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,160.24725,0.95897,0.133,NULL,60265228274,941644191,14713190,17.5),(73424,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73424,38.38,0.46,474,27613,70,NULL,NULL,'2MASX J10410000+3104378',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,160.250125,31.07714,0,NULL,60503366417,945365100,14771329,18),(73425,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73425,37.86,0.23,373,27614,70,NULL,NULL,'2MASX J10410035+4014167',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000176,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,160.251416667,40.23794,0,NULL,64119236472,1001863069,15654110,16.8),(73426,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73426,32.99,0.43,39.6,27615,75,NULL,'3.6 micron, color + selection bias corrected','ESO 437- G 039',NULL,'2014MNRAS.444..527S',2014,1,1.1,NULL,'G',0.000037,NULL,'17.10',0.6,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,160.25325,-28.74058,0.149,NULL,41536132014,649002062,10140657,17.1),(73427,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73427,34.63,0.49,84.3,27616,75,NULL,'IR','2MFGC 08314',NULL,'2011yCatp016004901K',2011,1,0.47,NULL,'G',0.000043,NULL,'17.59',0.12,'Sd(f)',NULL,NULL,NULL,NULL,1,160.255083,0.63264,0.117,NULL,60264876618,941638697,14713104,17.59),(73428,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73428,37.75,0.33,355,27617,70,NULL,NULL,'SDSS J104101.20+013337.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000076,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,160.255,1.56031,0.037,NULL,60277663640,941838494,14716226,18.2),(73429,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73429,37.08,0.53,260,27618,70,NULL,NULL,'2MASX J10410142-1127041',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.90',NULL,NULL,NULL,NULL,NULL,NULL,1,160.25575,-11.45111,0.113,NULL,41766335256,652598988,10196859,15.9),(73430,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73430,37.09,0.46,262,27619,70,NULL,NULL,'2MASX J10410199+3442479',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,160.2582083,34.71325,0.025,NULL,64054488415,1000851381,15638302,17.6),(73431,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73431,36.31,0.46,182,27620,70,NULL,NULL,'2MASX J10410204+3831467',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,160.25875,38.52961,0,NULL,64119941278,1001874082,15654282,16.8),(73432,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73432,38.23,0.33,443,27621,70,NULL,NULL,'2MASX J10410368+3917356',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,160.26525,39.29322,0,NULL,64118823209,1001856612,15654009,18),(73433,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73433,36.27,0.46,179,27622,70,NULL,NULL,'2MASX J10410382+5836391',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000173,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,160.2657083,58.61078,0,NULL,61947369789,967927652,15123869,16.6),(73434,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73434,37.79,0.19,362,27623,70,NULL,NULL,'2MASX J10410409+3355199',NULL,'2015arXiv151105856S',2015,1,0.33,'May be a resolved component of 87GB[BWE91] 1038+3410.','G',0.000165,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,160.266958333,33.92231,0.021,NULL,64054966532,1000858852,15638419,17.2),(73435,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73435,37.08,0.23,261,27624,70,NULL,NULL,'2MASX J10410455+2525559',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00017,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,160.268917,25.43222,0.017,NULL,60524553393,945696146,14776502,16.5),(73436,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73436,37.08,0.23,261,27625,70,NULL,NULL,'SDSS J104104.59+252458.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00017,NULL,'18.2g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,160.269167,25.41639,0.017,NULL,60524553931,945696155,14776502,18.2),(73437,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73437,38.51,0.46,503,27626,70,NULL,NULL,'SDSS J104105.85+372528.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,160.274375,37.42444,0,NULL,64115298904,1001801545,15653149,18.5),(73438,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73438,38.09,0.27,415,27627,70,NULL,NULL,'SDSS J104106.32+254859.4',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.5g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,160.276375,25.81653,0.025,NULL,60527440867,945741263,14777207,17.5),(73439,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73439,38.09,0.27,415,27628,70,NULL,NULL,'2MASX J10410629+2548599',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000142,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,160.27925,25.82097,0.025,NULL,60527440688,945741260,14777207,18.4),(73440,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73440,37.08,0.23,261,27629,70,NULL,NULL,'2MASX J10410743+2526019',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,160.280958333,25.434,0.017,NULL,60524484696,945695073,14776485,17.3),(73441,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73441,38.02,0.46,401,27630,70,NULL,NULL,'2MASX J10410784+4153199',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,160.282541667,41.88897,0,NULL,64141808743,1002215761,15659621,17.8),(73442,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73442,37.86,0.23,373,27631,70,NULL,NULL,'SDSS J104108.35+400703.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000132,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,160.2847917,40.11753,0,NULL,64119226999,1001862921,15654108,18.2),(73443,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73443,38,0.46,398,27632,70,NULL,NULL,'SDSS J104108.75+411727.6',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00013,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,160.2864583,41.291,0,NULL,64111896342,1001748380,15652318,17.9),(73444,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73444,36.28,0.8,181,27633,75,NULL,'CF, r','UGC 05813',NULL,'1997ApJS..109..333W',1997,1,0.98,NULL,'G',0.000033,NULL,'15.0g',0.58,'Scd:','Isolated galaxy',NULL,NULL,NULL,1,160.286541667,36.37281,0.013,NULL,64053344239,1000833503,15638023,15),(73445,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73445,35.86,0.38,149,27633,75,NULL,'CF, r, raw','UGC 05813',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73446,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73446,36.07,0.38,164,27633,75,NULL,'CF, r, inv','UGC 05813',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73447,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73447,36.12,0.38,167,27633,75,NULL,'CF, r, cor','UGC 05813',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73448,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73448,37.65,0.46,339,27634,70,NULL,NULL,'2MASX J10410930+4343539',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000136,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,160.289,43.73172,0,NULL,64143189563,1002237336,15659958,17.8),(73449,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73449,37.3,0.46,288,27635,70,NULL,NULL,'2MASX J10410949+4450069',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,160.289417,44.83531,0,NULL,64134359037,1002099359,15657802,17.2),(73450,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73450,37.83,0.46,369,27636,70,NULL,NULL,'SDSS J104109.71+044959.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000158,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,160.2905,4.83311,0.045,NULL,61007563793,953243184,14894424,18.3),(73451,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73451,37.07,0.46,259,27637,70,NULL,NULL,'2MASX J10411083+0436218',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,160.2952083,4.60606,0.057,NULL,61009515049,953273672,14894901,17.6),(73452,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73452,36.84,0.46,234,27638,70,NULL,NULL,'2MASX J10411096+0112198',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000082,NULL,'16.7g',0.26,'NLAGN',NULL,NULL,NULL,NULL,1,160.29575,1.20542,0.057,NULL,60278996496,941859320,14716551,16.7),(73453,'D-Sigma','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73453,33.15,0.4,42.6,27639,75,NULL,'Edat, raw','ESO 376- G 007',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000037,NULL,'13.96',0.9,'(R\')SAB0^0^ pec:',NULL,NULL,NULL,NULL,1,160.297667,-37.14367,0.129,NULL,42117318409,658083100,10282548,13.96),(73454,'D-Sigma','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73454,33.24,0.4,44.4,27639,75,NULL,'Edat, cor','ESO 376- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73455,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73455,33.86,0.4,59.2,27639,NULL,NULL,'mean','ESO 376- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73456,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73456,34.14,0.45,67.4,27639,NULL,NULL,'K','ESO 376- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73457,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73457,36.85,0.56,235,27640,70,NULL,NULL,'2MASX J10411163-0114334',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000089,NULL,'16.0g',0.38,NULL,NULL,NULL,NULL,NULL,1,160.298625,-1.24267,0.125,NULL,40883230468,638800476,9981257,16),(73458,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73458,37.65,0.33,338,27641,70,NULL,NULL,'2MASX J10411175+3411020',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00018,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,160.299041667,34.18397,0.021,NULL,64055271777,1000863621,15638494,17.2),(73459,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73459,37.65,0.33,338,27642,70,NULL,NULL,'2MASX J10411224+3409380',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,160.301167,34.16072,0.021,NULL,64055274878,1000863669,15638494,17.5),(73460,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73460,34.99,0.57,99.7,27643,70,NULL,NULL,'2MASX J10411310-8309033',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,160.3042083,-83.15094,0.485,NULL,39758768213,621230753,9706730,16.7),(73461,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73461,34.4,0.48,75.8,27644,70,NULL,NULL,'CGCG 009-099',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000093,NULL,'14.72',0.4,NULL,NULL,NULL,NULL,NULL,1,160.3045417,-2.80292,0.141,NULL,40884038686,638813104,9981454,14.72),(73462,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73462,38.23,0.33,443,27645,70,NULL,NULL,'2MASX J10411318+3917023',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000143,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,160.3049583,39.28403,0,NULL,64118695713,1001854620,15653978,17.7),(73463,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73463,37.51,0.46,317,27646,70,NULL,NULL,'2MASX J10411331+1617334',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,160.3054583,16.29264,0.061,NULL,61182110222,955970472,14937038,18.1),(73464,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73464,38.04,0.46,405,27647,70,NULL,NULL,'2MASX J10411336+0237208',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000079,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,160.305708333,2.62253,0.053,NULL,60277630436,941837975,14716218,17.7),(73465,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73465,38.11,0.46,418,27648,70,NULL,NULL,'2MASX J10411480+2347492',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,160.311875,23.79697,0.021,NULL,60972842417,952700662,14885947,17.4),(73466,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73466,37.58,0.46,328,27649,70,NULL,NULL,'2MASX J10411497+0325518',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,160.312416667,3.431,0.061,NULL,61008503336,953257864,14894654,17.8),(73467,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73467,36.83,0.33,233,27650,70,NULL,NULL,'WISEPC J104115.63+045313.8',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000126,NULL,'16.0g',0.43,'S0^-           AGN',NULL,NULL,NULL,NULL,1,160.315083333,4.88717,0.045,NULL,61007576847,953243388,14894427,16),(73468,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73468,34.96,0.2,98.2,27651,74.4,NULL,NULL,'UGC 05818',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000033,NULL,'14.60',0.8,'Scd:','Pair member (points to parent)',NULL,NULL,NULL,1,160.315375,6.36142,0.013,NULL,61062961405,954108771,14907949,14.6),(73469,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73469,35.11,0.45,105,27651,NULL,NULL,NULL,'UGC 05818',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73470,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73470,35.27,0.42,113,27651,NULL,NULL,'Malmquist cor.','UGC 05818',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73471,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73471,37.26,0.46,283,27652,70,NULL,NULL,'2MASX J10411590+3326210',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,160.316333,33.43919,0.017,NULL,64053046951,1000828858,15637950,17.2),(73472,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73472,39.13,0.46,669,27653,70,NULL,NULL,'SDSS J104116.27+295350.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000165,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,160.317833333,29.89739,0.013,NULL,60503316640,945364322,14771317,18.5),(73473,'TRGB','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73473,27.84,0.16,3.7,27654,NULL,NULL,NULL,'MESSIER 081:[CKT2009] d1041+70',NULL,'2013AJ....146..126C',2013,1,NULL,NULL,'G',NULL,NULL,'20.5B',NULL,'dI',NULL,NULL,NULL,NULL,1,160.32,70.15083,0.061,NULL,62137961335,970905645,15170400,20.5),(73474,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73474,37.79,0.19,362,27655,70,NULL,NULL,'2MASX J10411695+3353570',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000188,NULL,'16.1g',0.42,'BrClG',NULL,NULL,NULL,NULL,1,160.32075,33.89925,0.021,NULL,64054967351,1000858864,15638419,16.1),(73475,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73475,35.28,0.49,114,27656,70,NULL,NULL,'2MASX J10411707-1751450',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.96',NULL,NULL,NULL,NULL,NULL,NULL,1,160.320958333,-17.86256,0.125,NULL,41649613033,650775203,10168362,15.96),(73476,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73476,33.53,0.43,50.7,27657,75,NULL,'3.6 micron, color + selection bias corrected','ESO 501- G 078',NULL,'2014MNRAS.444..527S',2014,1,1,NULL,'G',0.000183,NULL,'16.00',0.2,'Sb:',NULL,NULL,NULL,NULL,1,160.32225,-26.16614,0.289,NULL,41529562317,648899411,10139053,16),(73477,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73477,37.79,0.19,362,27658,70,NULL,NULL,'2MASX J10411775+3355320',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000167,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,160.3239583,33.92569,0.021,NULL,64054953370,1000858646,15638416,16.8),(73478,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73478,37.72,0.46,349,27659,70,NULL,NULL,'2MASX J10411847+0607440',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000136,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,160.3267917,6.12892,0.017,NULL,61062863787,954107246,14907925,18),(73479,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73479,35.64,0.46,134,27660,70,NULL,NULL,'2MASX J10411852+1032363',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000164,NULL,'15.8g',0.31,'S0',NULL,NULL,NULL,NULL,1,160.327,10.54336,0.093,NULL,61047350027,953864844,14904138,15.8),(73480,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73480,32.73,0.8,35.1,27661,75,NULL,'HMCL, I','ESO 318- G 003',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',NULL,NULL,'16.33',0.3,'Sc:',NULL,NULL,NULL,NULL,1,160.3309583,-41.84675,0.393,NULL,42129265946,658269780,10285465,16.33),(73481,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73481,33.03,0.4,40.3,27661,75,NULL,'HMCL, I, inv','ESO 318- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73482,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73482,33.08,0.4,41.2,27661,75,NULL,'HMCL, I, raw','ESO 318- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73483,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73483,33.09,0.4,41.5,27661,NULL,NULL,NULL,'ESO 318- G 003',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73484,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73484,33.28,0.4,45.3,27661,75,NULL,'HMCL, I, cor','ESO 318- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73485,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73485,36.83,0.33,233,27662,70,NULL,NULL,'2MASX J10411952+0452150',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,160.331291667,4.87089,0.045,NULL,61007575380,953243365,14894427,17.2),(73486,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73486,35.74,0.56,141,27663,70,NULL,NULL,'2MASX J10412111-1714270',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.20',NULL,'(R\')SB(s)a',NULL,NULL,NULL,NULL,1,160.337875,-17.24092,0.121,NULL,41830648549,653603883,10212560,16.2),(73487,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73487,37.08,0.23,261,27664,70,NULL,NULL,'2MASX J10412241+2536505',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000169,NULL,'16.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,160.343333,25.614,0.021,NULL,60527326304,945739473,14777179,16.9),(73488,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73488,36.65,0.46,213,27665,70,NULL,NULL,'2MASX J10412307+2401255',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'16.42',0.2,NULL,NULL,NULL,NULL,NULL,1,160.346333,24.02372,0.005,NULL,60972640262,952697504,14885898,16.42),(73489,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73489,37.5,0.46,317,27666,70,NULL,NULL,'2MASX J10412415+4342575',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000156,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,160.3504583,43.71611,0,NULL,64143121130,1002236267,15659941,17.1),(73490,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73490,30.9,0.8,15.1,27667,75,NULL,'MAT, I','NGC 3355',NULL,'1997ApJS..109..333W',1997,1,2.1,'Identification as NGC 3355 is very uncertain; N3355 may be ESO 501- G 080.','G',0.000013,NULL,'14.02',1.5,'SAB(s)m:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,160.358291667,-23.38425,0.189,NULL,41633526918,650523858,10164435,14.02),(73491,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73491,30.65,0.43,13.5,27667,75,NULL,'MAT, I, inv','NGC 3355',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73492,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73492,30.82,0.43,14.6,27667,75,NULL,'MAT, I, raw','NGC 3355',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73493,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73493,30.91,0.32,15.2,27667,85,NULL,'I, inv','NGC 3355',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73494,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73494,30.95,0.32,15.5,27667,85,NULL,'I, raw','NGC 3355',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73495,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73495,30.97,0.39,15.6,27667,73,NULL,'opt','NGC 3355',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73496,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73496,31.05,0.43,16.2,27667,75,NULL,'MAT, I, cor','NGC 3355',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73497,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73497,31.13,0.4,16.8,27667,75,NULL,'B','NGC 3355',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73498,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73498,32.87,0.4,37.5,27667,NULL,NULL,NULL,'NGC 3355',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73499,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73499,37.55,0.46,324,27668,70,NULL,NULL,'SDSS J104125.96+302808.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,160.358208333,30.46911,0,NULL,60503628448,945369194,14771393,17.9),(73500,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73500,33.83,NULL,58.4,27669,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05809',NULL,'2010Ap&SS.325..163P',2010,1,1.01,NULL,'G',NULL,NULL,'17.',0.11,'Scd',NULL,NULL,NULL,NULL,1,160.363416667,69.70578,0.029,NULL,62137238809,970894356,15170224,17),(73501,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73501,33.85,NULL,58.9,27669,NULL,NULL,'Dipole + Quadrupole','UGC 05809',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73502,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73502,33.87,NULL,59.4,27669,NULL,NULL,'Dipole','UGC 05809',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73503,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73503,33.92,NULL,60.9,27669,NULL,NULL,NULL,'UGC 05809',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73504,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73504,37.86,0.23,373,27670,70,NULL,NULL,'2MASX J10412720+4019534',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000191,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,160.363375,40.33153,0,NULL,64119190387,1001862349,15654099,17.7),(73505,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73505,35.71,0.46,139,27671,70,NULL,NULL,'2MASX J10412793+3142110',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000167,NULL,'15.7g',0.48,NULL,NULL,NULL,NULL,NULL,1,160.3665,31.70308,0.013,NULL,64048814597,1000762728,15636917,15.7),(73506,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73506,34.73,0.49,88.1,27672,75,NULL,'IR','UGC 05815',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000208,NULL,'16.5g',0.18,'Sd',NULL,NULL,NULL,NULL,1,160.369833333,50.81214,0,NULL,64123121311,1001923770,15655058,16.5),(73507,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73507,34.89,NULL,95.2,27672,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05815',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73508,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73508,34.91,NULL,95.8,27672,NULL,NULL,'Dipole + Quadrupole','UGC 05815',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73509,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73509,34.92,NULL,96.3,27672,NULL,NULL,'Dipole','UGC 05815',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73510,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73510,34.95,NULL,97.8,27672,NULL,NULL,NULL,'UGC 05815',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73511,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73511,36.99,0.46,250,27673,70,NULL,NULL,'2MASX J10412947+0727233',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000132,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,160.372875,7.45658,0.069,NULL,61068689096,954198267,14909347,17.7),(73512,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73512,37.86,0.46,373,27674,70,NULL,NULL,'2MASX J10412972+2300113',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.02',0.16,NULL,NULL,NULL,NULL,NULL,1,160.373875,23.00322,0.005,NULL,60973074388,952704287,14886004,18.02),(73513,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73513,37.97,0.46,393,27675,70,NULL,NULL,'2MASX J10413014+1329364',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000178,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,160.3754583,13.49339,0.057,NULL,61175261877,955863466,14935366,16.7),(73514,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73514,37.51,0.46,317,27676,70,NULL,NULL,'2MASX J10413050+1635474',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000155,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,160.377,16.59644,0.057,NULL,61178460749,955913449,14936147,17.1),(73515,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73515,35.13,0.46,106,27677,70,NULL,NULL,'NGC 3334',NULL,'2015arXiv151105856S',2015,1,1.23,NULL,'G',0.000083,NULL,'13.7g',1.04,'S0?            HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,160.38,37.31286,0,NULL,64119534682,1001867729,15654183,13.7),(73516,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73516,35.23,0.4,111,27677,NULL,NULL,'mean','NGC 3334',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73517,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73517,35.52,0.45,127,27677,NULL,NULL,'K','NGC 3334',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73518,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73518,37.79,0.19,362,27678,70,NULL,NULL,'2MASXi J1041316+335227',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,160.382083,33.87442,0.029,NULL,64054954450,1000858663,15638416,18),(73519,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73519,36.14,0.46,169,27679,70,NULL,NULL,'2MASX J10413250+4929144',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,160.385375,49.48731,NULL,NULL,64125121343,1001955020,15655547,17.4),(73520,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73520,37.61,0.33,333,27680,70,NULL,NULL,'2MASX J10413364+1031293',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,160.390083333,10.52494,0.093,NULL,61047358752,953864980,14904140,17.6),(73521,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73521,36.12,0.46,168,27681,70,NULL,NULL,'CGCG 037-117',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000153,NULL,'15.2g',0.59,'E0','Group member',NULL,NULL,NULL,1,160.390708333,6.25769,0.017,NULL,61062939386,954108427,14907944,15.2),(73522,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73522,37.62,0.46,334,27682,70,NULL,NULL,'2MASX J10413496+4736545',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000111,NULL,'17.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,160.395916667,47.61508,0.005,NULL,64136316213,1002129940,15658280,17.5),(73523,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73523,36.92,0.19,242,27683,70,NULL,NULL,'2MASX J10413516+1647524',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000173,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,160.396583,16.79789,0.065,NULL,61178944284,955921004,14936265,17.5),(73524,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73524,37.47,0.46,312,27684,70,NULL,NULL,'2MASX J10413568+0814263',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.0002,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,160.39875,8.24069,0.073,NULL,61068146592,954189790,14909215,17.7),(73525,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73525,36.92,0.19,242,27685,70,NULL,NULL,'SDSS J104136.44+164707.3',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'15.6g',0.41,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,160.401875,16.78539,0.065,NULL,61178945412,955921022,14936265,15.6),(73526,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73526,36.64,0.46,213,27686,70,NULL,NULL,'2MASX J10413899+0630183',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000155,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,160.412625,6.505,0.065,NULL,61063634826,954119294,14908113,16.8),(73527,'SGRB','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'N',73527,38.73,NULL,557,27687,71,NULL,NULL,'GRB 061217 HOST',NULL,'2010ApJ...709..664R',2010,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73528,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73528,37.79,0.19,362,27688,70,NULL,NULL,'2MASX J10414077+3354557',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,160.420041667,33.91556,0.029,NULL,64054952101,1000858626,15638416,17.3),(73529,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73529,35.72,0.7,139,27689,70,NULL,NULL,'2MASX J10414089-1713262',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,160.420375,-17.22394,0.121,NULL,41830651808,653603934,10212561,15.2),(73530,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73530,35.01,0.46,100,27690,70,NULL,NULL,'2MASX J10414174+6600349',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000071,NULL,'16.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,160.424041667,66.00967,0.013,NULL,62117402248,970584410,15165381,16.2),(73531,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73531,38.08,0.46,414,27691,70,NULL,NULL,'2MASX J10414190+3848553',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,160.4247917,38.81528,0.005,NULL,64122233225,1001909894,15654842,17.4),(73532,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73532,38.92,0.46,607,27692,70,NULL,NULL,'SDSS J104143.86+285324.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000036,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,160.43275,28.89,0.009,NULL,60523717480,945683085,14776298,18.4),(73533,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73533,37.61,0.33,333,27693,70,NULL,NULL,'2MASX J10414423+1037227',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000162,NULL,'16.7g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,160.43425,10.623,0.029,NULL,61047330060,953864532,14904133,16.7),(73534,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73534,37.91,0.46,382,27694,70,NULL,NULL,'2MASX J10414451+2448467',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000186,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,160.4355,24.81306,0.025,NULL,60523889307,945685770,14776340,16.9),(73535,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73535,36.92,0.19,242,27695,70,NULL,NULL,'2MASX J10414498+1649004',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'17.1g',0.32,NULL,NULL,NULL,NULL,NULL,1,160.4375417,16.81683,0.029,NULL,61178950382,955921099,14936267,17.1),(73536,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73536,35.37,0.45,119,27696,NULL,NULL,'Malmquist cor.','IC 0635',NULL,'2009ApJS..182..474S',2009,1,1.6,NULL,'G',0.000033,NULL,'14.95',0.3,'S?',NULL,NULL,NULL,NULL,1,160.43875,15.64333,0.049,NULL,61181338773,955958418,14936850,14.95),(73537,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73537,35.5,0.42,126,27696,NULL,NULL,NULL,'IC 0635',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73538,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73538,35.54,0.2,128,27696,74.4,NULL,NULL,'IC 0635',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73539,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73539,35.74,0.33,140,27697,70,NULL,NULL,'2MASX J10414558+1353524',NULL,'2015arXiv151105856S',2015,1,0.54,'HOLM 208B is a star.','G',0.000165,NULL,'15.9g',0.38,NULL,NULL,NULL,NULL,NULL,1,160.439833333,13.89803,0.057,NULL,61182938013,955983406,14937240,15.9),(73540,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73540,37.75,0.33,355,27698,70,NULL,NULL,'2MASX J10414680+0123131',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000122,NULL,'15.6g',0.49,'Sdm;BrClG',NULL,NULL,NULL,NULL,1,160.445041667,1.38694,0.057,NULL,60279002572,941859415,14716553,15.6),(73541,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73541,36.92,0.19,242,27699,70,NULL,NULL,'2MASX J10414700+1649594',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000174,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,160.44575,16.83308,0.029,NULL,61178950407,955921100,14936267,16.7),(73542,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73542,35.56,0.46,129,27700,70,NULL,NULL,'NGC 3337',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.000173,NULL,'15.1g',0.45,'S0^-',NULL,NULL,NULL,NULL,1,160.4482917,4.98839,0.045,NULL,61007540001,953242812,14894418,15.1),(73543,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73543,35.02,0.46,101,27701,70,NULL,NULL,'2MASX J10414865+3023117',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000173,NULL,'15.8g',0.39,NULL,NULL,NULL,NULL,NULL,1,160.452667,30.38653,0.005,NULL,60503177915,945362154,14771283,15.8),(73544,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73544,38.57,0.46,516,27702,70,NULL,NULL,'SDSS J104150.21+025103.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000072,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,160.45925,2.85111,0.061,NULL,60277428213,941834815,14716168,18.8),(73545,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73545,38.57,0.46,518,27703,70,NULL,NULL,'SDSS J104150.99+163029.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000172,NULL,'18.5g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,160.4625,16.50819,0.061,NULL,61181595134,955962423,14936912,18.5),(73546,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73546,37.96,0.46,390,27704,70,NULL,NULL,'2MASX J10415127+2250592',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,160.463583,22.84992,0.017,NULL,60972924433,952701944,14885967,18.6),(73547,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73547,36.92,0.19,242,27705,70,NULL,NULL,'2MASX J10415146+1649074',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000178,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,160.464417,16.81889,0.029,NULL,61178949875,955921091,14936267,16.3),(73548,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73548,37.82,0.46,366,27706,70,NULL,NULL,'2MASX J10415154+3048408',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000133,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,160.464666667,30.81119,0.005,NULL,60506345121,945411642,14772056,18),(73549,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73549,37.19,0.23,274,27707,70,NULL,NULL,'SDSS J104152.10+023940.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000074,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,160.467125,2.66117,0.057,NULL,60277649287,941838270,14716222,18.2),(73550,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73550,36.84,0.46,233,27708,70,NULL,NULL,'2MASX J10415322+3754504',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000175,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,160.471791667,37.91414,0.005,NULL,64119988632,1001874822,15654294,16.7),(73551,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73551,37.43,0.17,307,27709,70,NULL,NULL,'2MASX J10415444+5814580',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000164,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,160.4769583,58.24953,0,NULL,62002794773,968793668,15137401,16.6),(73552,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73552,37.22,0.46,278,27710,70,NULL,NULL,'SDSS J104156.76+152312.8',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,160.486541667,15.38694,0.049,NULL,61180913564,955951774,14936746,17),(73553,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73553,37.95,0.46,389,27711,70,NULL,NULL,'2MASX J10415726+1559187',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,160.488625,15.98844,0.061,NULL,61182209773,955972027,14937062,17.3),(73554,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73554,36.92,0.19,242,27712,70,NULL,NULL,'2MASX J10415813+1648366',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000185,NULL,'15.9g',0.39,NULL,NULL,NULL,NULL,NULL,1,160.492125,16.81033,0.029,NULL,61178968248,955921378,14936271,15.9),(73555,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73555,36.08,0.46,164,27713,70,NULL,NULL,'2MASX J10415857+5859270',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000184,NULL,'15.8g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,160.494167,58.99083,0,NULL,61947593481,967931148,15123924,15.8),(73556,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73556,37.19,0.23,274,27714,70,NULL,NULL,'2MASX J10415953+0237491',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000109,NULL,'15.9g',0.46,'BrClG',NULL,NULL,NULL,NULL,1,160.498,2.63028,0.057,NULL,60277595222,941837425,14716209,15.9),(73557,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73557,37.33,0.46,293,27715,70,NULL,NULL,'2MASX J10415964+2444588',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,160.498667,24.74958,0.025,NULL,60523901927,945685967,14776343,17.5),(73558,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73558,33.28,0.23,45.3,27716,74.4,NULL,NULL,'ESO 437- G 045',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000047,NULL,'14.33',1.1,'SA0^0^ pec',NULL,NULL,NULL,NULL,1,160.499125,-28.77669,0.149,NULL,41536014637,649000228,10140628,14.33),(73559,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73559,33.88,0.4,59.7,27716,NULL,NULL,'mean','ESO 437- G 045',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73560,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73560,34.01,0.45,63.2,27716,NULL,NULL,'K','ESO 437- G 045',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73561,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73561,33.13,0.8,42.3,27717,75,NULL,'MAT, I','NGC 3347B',NULL,'1997ApJS..109..333W',1997,1,3.2,NULL,'G',0.000027,NULL,'13.69',0.8,'SA(s)dm: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,160.49925,-36.93533,0.081,NULL,42125550519,658211726,10284558,13.69),(73562,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73562,33.14,0.8,42.5,27717,75,NULL,'HMCL, I','NGC 3347B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73563,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73563,32.78,0.49,35.9,27717,75,NULL,'IR','NGC 3347B',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73564,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73564,32.78,0.2,36,27717,74.4,NULL,NULL,'NGC 3347B',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73565,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73565,32.81,0.4,36.5,27717,75,NULL,'HMCL, I, raw','NGC 3347B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73566,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73566,32.87,0.38,37.5,27717,NULL,NULL,NULL,'NGC 3347B',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73567,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73567,32.92,0.43,38.3,27717,75,NULL,'3.6 micron, color corrected','NGC 3347B',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73568,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73568,32.93,0.32,38.6,27717,85,NULL,'I, raw','NGC 3347B',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73569,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73569,32.95,0.4,38.8,27717,75,NULL,'HMCL, I, inv','NGC 3347B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73570,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73570,32.97,0.32,39.3,27717,85,NULL,'I, inv','NGC 3347B',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73571,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73571,32.98,0.43,39.4,27717,75,NULL,'MAT, I, raw','NGC 3347B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73572,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73572,33.04,0.4,40.6,27717,75,NULL,'HMCL, I, cor','NGC 3347B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73573,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73573,33.12,0.43,42,27717,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3347B',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73574,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73574,33.17,0.43,43.1,27717,75,NULL,'MAT, I, inv','NGC 3347B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73575,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73575,33.24,0.43,44.4,27717,75,NULL,'MAT, I, cor','NGC 3347B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73576,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73576,33.26,0.11,45,27717,NULL,NULL,NULL,'NGC 3347B',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73577,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73577,37.44,0.46,308,27718,70,NULL,NULL,'2MASX J10420129+1404327',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,160.505333,14.07558,0.069,NULL,61182965201,955983831,14937247,17.9),(73578,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73578,37.75,0.27,355,27719,70,NULL,NULL,'2MASX J10420316+5703100',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,160.5129583,57.05289,0,NULL,62003900374,968810943,15137670,17.8),(73579,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73579,37.99,0.46,396,27720,70,NULL,NULL,'2MASX J10420349+3335058',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,160.514708333,33.58486,0.017,NULL,64052960381,1000827505,15637929,17.5),(73580,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73580,37.98,0.46,394,27721,70,NULL,NULL,'SDSS J104203.64+101146.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00014,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,160.515167,10.19639,0.057,NULL,61053916336,953967442,14905741,18.4),(73581,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73581,38.18,0.46,432,27722,70,NULL,NULL,'SDSS J104203.65+371120.8',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,160.51525,37.18914,0,NULL,64119588306,1001868567,15654196,18),(73582,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73582,36.78,0.46,227,27723,70,NULL,NULL,'2MASX J10420470+4348103',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000154,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,160.5194583,43.803,0,NULL,64139661296,1002182207,15659096,16.9),(73583,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73583,35.61,0.46,132,27724,70,NULL,NULL,'CGCG 094-105',NULL,'2015arXiv151105856S',2015,1,0.8,'HOLM 209B is a star.','G',0.000163,NULL,'15.1',0.6,NULL,'Group member',NULL,NULL,NULL,1,160.5235,18.24939,0.033,NULL,60985352917,952896139,14889002,15.1),(73584,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73584,31.77,0.8,22.6,27725,75,NULL,'A82, H','NGC 3338',NULL,'1997ApJS..109..333W',1997,1,3.38,NULL,'G',0.000003,NULL,'12.8g',1.26,'SA(s)c','in a radial-velocity based grouping',NULL,NULL,NULL,1,160.531417,13.747,0.057,NULL,61175460621,955866572,14935415,12.8),(73585,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73585,31.24,0.4,17.7,27725,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 3338',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73586,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73586,31.79,0.4,22.8,27725,75,NULL,'B','NGC 3338',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73587,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73587,31.82,0.52,23.1,27725,NULL,NULL,'Malmquist cor.','NGC 3338',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73588,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73588,31.82,0.43,23.1,27725,75,NULL,'3.6 micron, color corrected','NGC 3338',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73589,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73589,31.86,0.43,23.5,27725,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3338',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73590,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73590,31.87,0.2,23.7,27725,74.4,NULL,NULL,'NGC 3338',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73591,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73591,31.97,0.45,24.8,27725,NULL,NULL,'K','NGC 3338',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73592,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73592,31.97,0.47,24.8,27725,NULL,NULL,'H','NGC 3338',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73593,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73593,31.98,0.46,24.9,27725,NULL,NULL,'J','NGC 3338',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73594,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73594,32.04,0.47,25.6,27725,75,NULL,'A82, H, raw','NGC 3338',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73595,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73595,32.07,0.4,25.9,27725,NULL,NULL,'mean','NGC 3338',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73596,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73596,32.1,0.46,26.4,27725,NULL,NULL,NULL,'NGC 3338',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73597,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73597,32.2,0.47,27.5,27725,75,NULL,'A82, H, inv','NGC 3338',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73598,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73598,32.22,0.47,27.8,27725,75,NULL,'A82, H, cor','NGC 3338',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73599,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73599,32.26,0.3,28.3,27725,55,NULL,'B','NGC 3338',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73600,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73600,37.47,0.46,312,27726,70,NULL,NULL,'2MASX J10420954+0443071',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000164,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,160.539833,4.71858,0.041,NULL,61009500289,953273442,14894897,17.3),(73601,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73601,37.23,0.46,280,27727,70,NULL,NULL,'2MASX J10420988+2142145',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.98',0.17,NULL,NULL,NULL,NULL,NULL,1,160.541083333,21.70414,0.005,NULL,60973836770,952716199,14886190,17.98),(73602,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73602,38.45,0.46,491,27728,70,NULL,NULL,'SDSS J104210.10+022749.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00008,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,160.542083,2.46378,0.037,NULL,60278376044,941849625,14716400,18.1),(73603,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73603,36.92,0.46,242,27729,70,NULL,NULL,'2MASX J10421007+2857207',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.2g',0.21,'E',NULL,NULL,NULL,NULL,1,160.542166667,28.95583,0.009,NULL,60523741177,945683455,14776303,17.2),(73604,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73604,35.81,0.2,145,27730,74.4,NULL,NULL,'CGCG 065-088',NULL,'2013AJ....146...86T',2013,1,0.65,NULL,'G',0.000529,NULL,'15.6',0.23,NULL,NULL,NULL,NULL,NULL,1,160.545,12.4975,0.049,NULL,61177533884,955898966,14935921,15.6),(73605,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73605,33.96,0.4,62,27731,NULL,NULL,'mean','UGC 05825',NULL,'2007A&A...465...71T',2007,1,1.1,'The 2MASS position is 8 arcsec northwest of the nucleus.','G',0.000033,NULL,'14.91',0.5,'Sa?',NULL,NULL,NULL,NULL,1,160.5460417,23.74675,0,NULL,60972797247,952699956,14885936,14.91),(73606,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73606,34.21,0.47,69.4,27731,NULL,NULL,'H','UGC 05825',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73607,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73607,34.3,0.46,72.5,27731,NULL,NULL,'J','UGC 05825',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73608,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73608,34.32,0.45,73.1,27731,NULL,NULL,'K','UGC 05825',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73609,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73609,38.23,0.33,442,27732,70,NULL,NULL,'2MASX J10421154+3250241',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000176,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,160.548167,32.84,0.017,NULL,64048518300,1000758098,15636845,16.8),(73610,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73610,37.87,0.46,374,27733,70,NULL,NULL,'2MASX J10421182+1607456',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,160.549333,16.12944,0.061,NULL,61181692343,955963942,14936936,16.9),(73611,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73611,37.19,0.23,274,27734,70,NULL,NULL,'2MASX J10421248+0243051',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000087,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,160.5519583,2.71811,0.057,NULL,60277572437,941837069,14716204,16.4),(73612,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73612,37.97,0.46,393,27735,70,NULL,NULL,'SDSS J104212.51+024023.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00007,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,160.552166667,2.67325,0.057,NULL,60277567258,941836988,14716202,18),(73613,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73613,37.72,0.33,350,27736,70,NULL,NULL,'2MASX J10421341+4136394',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000205,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,160.555917,41.61097,0,NULL,64111597070,1001743704,15652245,16.5),(73614,'Tully est','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73614,32.1,0.8,26.3,27737,75,NULL,'B','UGCA 216',NULL,'1988NBGC.C....0000T',1988,1,0.75,NULL,'G',0.000053,NULL,'15.4g',0.33,'S?',NULL,NULL,NULL,NULL,1,160.559291667,47.76675,0,NULL,64136358060,1002130594,15658290,15.4),(73615,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73615,37.68,0.46,343,27738,70,NULL,NULL,'2MASXi J1042142+313750',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,160.5595,31.63067,0.013,NULL,64048833897,1000763029,15636922,17.4),(73616,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73616,37.53,0.27,321,27739,70,NULL,NULL,'VIII Zw 103 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000149,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,160.562125,9.17083,0.061,NULL,61053851672,953966432,14905725,17.3),(73617,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73617,38.27,0.46,451,27740,70,NULL,NULL,'2MASX J10421584+0127371',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00009,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,160.566166667,1.46036,0.057,NULL,60279505550,941867274,14716676,17.7),(73618,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73618,37.75,0.27,355,27741,70,NULL,NULL,'2MASX J10421641+5703479',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000155,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,160.5685,57.06325,0,NULL,62003897773,968810902,15137670,17.5),(73619,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73619,38.23,0.33,442,27742,70,NULL,NULL,'2MASX J10421733+3252242',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,160.5724583,32.87333,0.017,NULL,64048477019,1000757453,15636835,17.9),(73620,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73620,33.66,0.69,54.1,27743,100,NULL,'mid-IR','NGC 3340',NULL,'2013ApJ...771...88L',2013,1,1.17,'NGC 3339 = Holmberg 210b is a star.','G',0.00002,NULL,'13.7g',0.8,'Sbc(r)','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,160.574958333,-0.37686,0.121,NULL,40883143796,638799121,9981236,13.7),(73621,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73621,37.2,0.46,275,27744,70,NULL,NULL,'2MASX J10421930+3935533',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000091,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,160.580375,39.59831,0,NULL,64119124381,1001861318,15654083,17.9),(73622,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73622,37.13,0.46,267,27745,70,NULL,NULL,'2MASX J10421931+0212491',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000079,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,160.5804583,2.21358,0.049,NULL,60278394651,941849916,14716404,17.7),(73623,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73623,36.02,0.46,160,27746,70,NULL,NULL,'2MASX J10421956+4941121',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'16.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,160.581208333,49.68672,0,NULL,64124941957,1001952218,15655503,16.8),(73624,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73624,36.76,0.46,225,27747,70,NULL,NULL,'2MASX J10422127+2549126',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000171,NULL,'17.83',0.17,NULL,NULL,NULL,NULL,NULL,1,160.588833,25.82017,0.025,NULL,60527300493,945739070,14777172,17.83),(73625,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73625,38.3,0.46,457,27748,70,NULL,NULL,'2MASX J10422209+4259324',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000158,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,160.5920417,42.99236,0,NULL,64142833905,1002231779,15659871,18.1),(73626,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73626,34.02,0.09,63.8,27749,NULL,NULL,NULL,'ESO 376- G 012',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000033,NULL,'14.70',0.5,'SB?',NULL,NULL,NULL,NULL,1,160.593625,-36.17722,0.193,NULL,41990457591,656100899,10251576,14.7),(73627,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73627,36.34,0.46,186,27750,70,NULL,NULL,'2MASX J10422274+0107351',NULL,'2015arXiv151105856S',2015,1,0.52,'Hopp et al. (1995A&AS...109..537H) give z = 0.02725 +/- 0.00045.','G',0.000084,NULL,'16.0g',0.42,'Scd',NULL,NULL,NULL,NULL,1,160.594666667,1.12636,0.081,NULL,60279162514,941861914,14716592,16),(73628,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73628,37.47,0.33,311,27751,70,NULL,NULL,'2MASX J10422294+1548059',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,160.5955,15.80169,0.045,NULL,61180545492,955946023,14936656,17.6),(73629,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73629,36.99,0.46,250,27752,70,NULL,NULL,'2MASX J10422382+2402056',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'16.92',0.15,NULL,NULL,NULL,NULL,NULL,1,160.5992083,24.03492,0.021,NULL,60972759400,952699365,14885927,16.92),(73630,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73630,37.19,0.23,274,27753,70,NULL,NULL,'2MASX J10422397+0236211',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00008,NULL,'17.3g',0.21,'NLAGN',NULL,NULL,NULL,NULL,1,160.599917,2.60592,0.061,NULL,60277556314,941836817,14716200,17.3),(73631,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73631,37.3,0.21,289,27754,70,NULL,NULL,'2MASX J10422478+1229129',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,160.6032083,12.48683,0.049,NULL,61177540029,955899062,14935922,17.3),(73632,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73632,33.69,0.5,54.7,27755,70,NULL,NULL,'ESO 264- G 034',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000093,NULL,'14.96',0.6,'SAB(s)0^0^:',NULL,NULL,NULL,NULL,1,160.6049583,-44.88586,0.609,NULL,42102124859,657845700,10278839,14.96),(73633,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73633,37.53,0.27,321,27756,70,NULL,NULL,'2MASX J10422549+0908179',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,160.606333,9.13819,0.065,NULL,61053840545,953966258,14905722,17.8),(73634,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73634,37.42,0.46,305,27757,70,NULL,NULL,'2MASX J10422612+5718347',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000184,NULL,'16.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,160.608917,57.30967,0,NULL,62004080020,968813750,15137714,16.4),(73635,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73635,36.26,0.53,178,27758,70,NULL,NULL,'2MASX J10422626-1748460',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,160.609416667,-17.81286,0.121,NULL,41649679907,650776248,10168378,14.6),(73636,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73636,37.49,0.46,315,27759,70,NULL,NULL,'2MASX J10422620+4746134',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000145,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,160.609416667,47.77031,0,NULL,64136402037,1002131281,15658301,17.1),(73637,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73637,31.22,NULL,17.5,27760,NULL,NULL,NULL,'SDSS J104226.50+135725.7',NULL,'2015AstBu..70....1K',2015,1,0.58,'Haynes et al. (2011AJ....142..170H) give v = 1277 km/s.','G',0.000245,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,160.610458333,13.95714,0.069,NULL,61175393587,955865524,14935398,17.1),(73638,'SNIa','2016-12-15 15:14:40','2016-12-16 11:19:48','1','SN 1997bj',NULL,73638,40.92,0.3,1130,27761,65,NULL,NULL,'H-ZSNS J104226.65+000135.4',0.35,'2004ApJ...607..665R',2004,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,160.6110417,0.0265,0.077,NULL,60270070470,941719851,14714372,NULL),(73639,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73639,36.43,0.27,193,27762,70,NULL,NULL,'2MASX J10422727+1859513',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,160.6134583,18.99761,0.037,NULL,60985643303,952900676,14889073,17.5),(73640,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73640,38.08,0.46,414,27763,70,NULL,NULL,'2MASX J10422745+4050564',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,160.6142917,40.84889,0,NULL,64111924311,1001748817,15652325,17.4),(73641,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73641,37.3,0.21,289,27764,70,NULL,NULL,'2MASX J10422772+1230089',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,160.615625,12.50267,0.049,NULL,61177540596,955899071,14935922,17.6),(73642,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73642,38.25,0.46,447,27765,70,NULL,NULL,'2MASX J10422791+1841332',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,160.6162917,18.69244,0.033,NULL,60986160940,952908764,14889199,NULL),(73643,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73643,35.81,0.46,145,27766,70,NULL,NULL,'2MASX J10422892+2632386',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00015,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,160.620375,26.54403,0.053,NULL,60526602550,945728164,14777002,16.6),(73644,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73644,37.92,0.46,383,27767,70,NULL,NULL,'2MASX J10422905+4338133',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000172,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,160.620875,43.63711,0,NULL,64139680227,1002182503,15659101,17.2),(73645,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73645,32.54,0.8,32.1,27768,75,NULL,'MAT, I','ESO 437- G 047',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'15.70',0.8,'Sc:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,160.62275,-30.88506,0.233,NULL,41502337354,648474021,10132406,15.7),(73646,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73646,32.57,0.32,32.6,27768,85,NULL,'I, inv','ESO 437- G 047',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73647,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73647,32.6,0.32,33.1,27768,85,NULL,'I, raw','ESO 437- G 047',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73648,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73648,32.82,0.2,36.6,27768,74.4,NULL,NULL,'ESO 437- G 047',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73649,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73649,33.03,0.43,40.3,27768,75,NULL,'MAT, I, inv','ESO 437- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73650,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73650,33.05,0.1,40.8,27768,NULL,NULL,NULL,'ESO 437- G 047',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73651,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73651,33.08,0.43,41.4,27768,75,NULL,'MAT, I, raw','ESO 437- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73652,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73652,33.39,0.43,47.6,27768,75,NULL,'MAT, I, cor','ESO 437- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73653,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73653,39.16,0.46,678,27769,70,NULL,NULL,'SDSS J104230.20+332038.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000143,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,160.625875,33.34392,0.017,NULL,64052873498,1000826148,15637908,18.5),(73654,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73654,37.5,0.46,316,27770,70,NULL,NULL,'SDSS J104230.54+392322.1',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,160.62725,39.3895,0,NULL,64118666450,1001854163,15653971,17.3),(73655,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73655,37.31,0.46,289,27771,70,NULL,NULL,'2MASX J10423060+1440530',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000176,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,160.6274583,14.68156,0.073,NULL,61183275146,955988674,14937323,16.7),(73656,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73656,37.13,0.33,267,27772,70,NULL,NULL,'SDSS J104230.71+402012.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,160.628,40.33686,0,NULL,64118976563,1001859008,15654047,17.6),(73657,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73657,37.23,0.46,279,27773,70,NULL,NULL,'2MASX J10423087+0113342',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000091,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,160.6285417,1.22633,0.069,NULL,60279140200,941861565,14716586,17),(73658,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73658,38.2,0.46,437,27774,70,NULL,NULL,'2MASX J10423270+3423202',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000175,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,160.636541667,34.38903,0.025,NULL,64054586112,1000852908,15638326,17.1),(73659,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73659,36.12,0.46,167,27775,70,NULL,NULL,'2MASX J10423303+0404362',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000174,NULL,'16.2g',0.26,'S0',NULL,NULL,NULL,NULL,1,160.637666667,4.07669,0.093,NULL,61009086338,953266974,14894796,16.2),(73660,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73660,38.43,0.46,486,27776,70,NULL,NULL,'2MASX J10423318+4152424',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,160.638041667,41.87853,0,NULL,64111741847,1001745966,15652280,18),(73661,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73661,37.13,0.33,267,27777,70,NULL,NULL,'2MASX J10423347+4023394',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000179,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,160.639708333,40.39422,0,NULL,64118925690,1001858213,15654034,16.5),(73662,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73662,37.72,0.46,350,27778,70,NULL,NULL,'2MASX J10423429+6041492',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000201,NULL,'16.0g',0.4,'AGN',NULL,NULL,NULL,NULL,1,160.642791667,60.69708,0,NULL,61955856112,968060251,15125941,16),(73663,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73663,37.3,0.21,289,27779,70,NULL,NULL,'2MASX J10423550+1227370',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',NULL,NULL,'17.52',0.45,NULL,NULL,NULL,NULL,NULL,1,160.648,12.46036,0.049,NULL,61177565188,955899456,14935929,17.52),(73664,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73664,36.91,0.46,241,27780,70,NULL,NULL,'2MASX J10423567+3743355',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000148,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,160.648583,37.72642,0,NULL,64120247478,1001878866,15654357,17.5),(73665,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73665,36.61,0.46,210,27781,70,NULL,NULL,'2MASX J10423752+2859406',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00017,NULL,'16.3g',0.37,'E',NULL,NULL,NULL,NULL,1,160.656333333,28.99464,0.021,NULL,60523688423,945682631,14776291,16.3),(73666,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73666,36.57,0.67,206,27782,70,NULL,NULL,'2MASX J10423775-4547564',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'13.9I',0.4,NULL,NULL,NULL,NULL,NULL,1,160.6572917,-45.799,0.801,NULL,42102336431,657849006,10278890,13.9),(73667,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73667,38.33,0.46,462,27783,70,NULL,NULL,'2MASX J10423786+3718194',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,160.6577917,37.30547,0,NULL,64119631871,1001869247,15654206,18.1),(73668,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73668,30.5,0.8,12.6,27784,75,NULL,'MAT, I','IC 0625',NULL,'1997ApJS..109..333W',1997,1,2.3,'This may also be NGC 3355.','G',0.000003,NULL,'13.70',0.5,'Sc? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,160.6585417,-23.93561,0.217,NULL,41632778445,650512163,10164252,13.7),(73669,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73669,29.89,0.32,9.45,27784,85,NULL,'I, inv','IC 0625',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73670,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73670,29.93,0.32,9.72,27784,85,NULL,'I, raw','IC 0625',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73671,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73671,30.42,0.43,12.1,27784,75,NULL,'MAT, I, inv','IC 0625',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73672,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73672,30.41,0.43,12.1,27784,75,NULL,'3.6 micron, color + selection bias corrected','IC 0625',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73673,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73673,30.52,0.43,12.7,27784,75,NULL,'3.6 micron, color corrected','IC 0625',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73674,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73674,30.56,0.43,12.9,27784,75,NULL,'MAT, I, raw','IC 0625',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73675,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73675,30.57,0.2,13,27784,74.4,NULL,NULL,'IC 0625',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73676,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73676,30.71,0.4,13.9,27784,75,NULL,NULL,'IC 0625',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73677,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73677,30.72,0.4,13.9,27784,73,NULL,'IR','IC 0625',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73678,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73678,30.8,0.43,14.5,27784,75,NULL,'MAT, I, cor','IC 0625',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73679,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73679,30.89,0.78,15.1,27784,NULL,NULL,NULL,'IC 0625',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73680,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73680,31.11,0.71,16.6,27784,NULL,NULL,'Malmquist cor.','IC 0625',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73681,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73681,31.4,0.49,19.1,27784,75,NULL,'IR','IC 0625',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73682,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73682,37.49,0.46,315,27785,70,NULL,NULL,'2MASX J10423837+3820314',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000176,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,160.659833,38.34217,0.005,NULL,64120082257,1001876285,15654316,17.1),(73683,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73683,36.65,0.46,214,27786,70,NULL,NULL,'2MASX J10423875+0621310',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00014,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,160.6614583,6.35853,0.029,NULL,61063823155,954122236,14908159,17.2),(73684,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73684,36.9,0.46,239,27787,70,NULL,NULL,'SDSS J104239.48+183646.4',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',NULL,NULL,'16.1g',0.39,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,160.6645417,18.61292,0.029,NULL,60986134835,952908356,14889193,16.1),(73685,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73685,37.3,0.21,289,27788,70,NULL,NULL,'2MASX J10423993+1244590',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000192,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,160.6665,12.74969,0.041,NULL,61178070487,955907351,14936052,17.3),(73686,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73686,37.72,0.33,350,27789,70,NULL,NULL,'2MASX J10424043+4134414',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000177,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,160.668583,41.57819,0,NULL,64111716103,1001745564,15652274,17.3),(73687,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73687,37.47,0.33,311,27790,70,NULL,NULL,'2MASX J10424081+1548000',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000177,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,160.670125,15.79992,0.045,NULL,61180558765,955946230,14936659,16.9),(73688,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73688,37.3,0.21,289,27791,70,NULL,NULL,'2MASX J10424097+1226240',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000184,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,160.670833,12.44011,0.041,NULL,61177438546,955897477,14935898,16.4),(73689,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73689,29.51,0.4,8,27792,75,NULL,'B','UGC 05829',NULL,'1988NBGC.C....0000T',1988,1,4.7,'Position in 1987A&AS...70..189S is for an HII region.','G',0.000003,NULL,'13.73',4.2,'Im','Isolated galaxy',NULL,NULL,NULL,1,160.674625,34.44889,0.033,NULL,64054580393,1000852818,15638325,13.73),(73690,'SNIa','2016-12-15 15:14:40','2016-12-16 11:19:48','1','PS1 SN PS10w','N',73690,35.74,0.13,136,27793,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10w HOST',0.0317,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73691,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73691,35.75,0.19,141,27794,70,NULL,NULL,'2MASX J10424274+1419430',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,160.678041667,14.32867,0.069,NULL,61183224822,955987887,14937310,16.6),(73692,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73692,37.85,0.46,372,27795,70,NULL,NULL,'2MASX J10424301+0053512',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000088,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,160.6792083,0.89761,0.069,NULL,60279433658,941866150,14716658,17.4),(73693,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73693,35.73,0.33,140,27796,NULL,NULL,NULL,'ESO 501- G 081',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'16.00',0.4,'S...',NULL,NULL,NULL,NULL,1,160.690583,-26.79439,0.301,NULL,41529339655,648895932,10138998,16),(73694,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73694,35.77,0.2,143,27796,74.4,NULL,NULL,'ESO 501- G 081',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73695,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73695,35.79,0.32,144,27796,NULL,NULL,'Malmquist cor.','ESO 501- G 081',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73696,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73696,37.59,0.33,329,27797,70,NULL,NULL,'2MASX J10424628+5417507',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000175,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,160.693083,54.2975,0,NULL,61960980777,968140324,15127192,16.5),(73697,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73697,32.96,0.8,39.1,27798,75,NULL,'MAT, I','NGC 3347',NULL,'1997ApJS..109..333W',1997,1,3.6,'A 12th mag star is superposed just northwest of the nucleus (B. Skiff).','G',0.000027,NULL,'12.17',2.1,'SB(rs)b','in a pair',NULL,NULL,NULL,1,160.6939583,-36.35267,0.177,NULL,41978732527,655917695,10248713,12.17),(73698,'Sosies','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73698,32.23,0.25,27.9,27798,NULL,NULL,NULL,'NGC 3347',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73699,'Tully est','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73699,32.93,0.8,38.5,27798,75,NULL,'B','NGC 3347',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73700,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73700,31.87,0.3,23.7,27798,92,NULL,'I, Assuming Hydra cluster m-M = 33.2 mag','NGC 3347',NULL,'1993AJ....105...97S',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73701,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73701,31.87,0.32,23.7,27798,85,NULL,'I, raw','NGC 3347',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73702,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73702,31.92,0.32,24.2,27798,85,NULL,'I, inv','NGC 3347',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73703,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73703,32,0.43,25.1,27798,75,NULL,'MAT, I, raw','NGC 3347',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73704,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73704,32.14,0.4,26.8,27798,NULL,NULL,NULL,'NGC 3347',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73705,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73705,32.24,0.43,28.1,27798,75,NULL,'MAT, I, inv','NGC 3347',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (73706,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73706,32.39,NULL,30.1,27798,NULL,NULL,'I','NGC 3347',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73707,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73707,32.4,0.3,30.2,27798,92,NULL,'H, Assuming Hydra cluster m-M = 33.2 mag','NGC 3347',NULL,'1993AJ....105...97S',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73708,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73708,32.43,0.43,30.7,27798,75,NULL,'MAT, I, cor','NGC 3347',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73709,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73709,32.57,NULL,32.7,27798,NULL,NULL,'B','NGC 3347',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73710,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73710,33.26,0.08,45,27798,NULL,NULL,NULL,'NGC 3347',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73711,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73711,37.99,0.46,397,27799,70,NULL,NULL,'2MASX J10424712+3652494',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000165,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,160.696333,36.88031,0,NULL,64119434621,1001866165,15654158,17.1),(73712,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73712,37.75,0.27,355,27800,70,NULL,NULL,'2MASX J10424787+5700167',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000162,NULL,'17.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,160.6995,57.00467,0,NULL,62001823076,968778485,15137163,17.3),(73713,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73713,37.53,0.27,321,27801,70,NULL,NULL,'2MASX J10424831+0907410',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000169,NULL,'16.6g',NULL,NULL,NULL,NULL,NULL,NULL,1,160.70125,9.12803,0.105,NULL,61053632453,953963007,14905671,16.6),(73714,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73714,31.35,NULL,18.6,27802,NULL,NULL,NULL,'UGC 05832',NULL,'2015AstBu..70....1K',2015,1,1.51,NULL,'G',0.000013,NULL,'14.0g',0.75,'SB?','in a radial-velocity based grouping',NULL,NULL,NULL,1,160.701875,13.45983,0.053,NULL,61175353983,955864905,14935389,14),(73715,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73715,33.44,0.49,48.8,27803,75,NULL,'IR','ESO 568- G 023',NULL,'2011yCatp016004901K',2011,1,1.14,NULL,'G',0.000053,NULL,'15.78',0.13,'Sd',NULL,NULL,NULL,NULL,1,160.702125,-20.69633,0.113,NULL,41629664424,650463506,10163492,15.78),(73716,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73716,33.59,NULL,52.4,27803,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 568- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73717,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73717,33.62,NULL,52.9,27803,NULL,NULL,'Dipole + Quadrupole','ESO 568- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73718,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73718,33.62,NULL,53.1,27803,NULL,NULL,'Dipole','ESO 568- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73719,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73719,33.69,NULL,54.7,27803,NULL,NULL,NULL,'ESO 568- G 023',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73720,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73720,35.16,0.46,107,27804,70,NULL,NULL,'2MASX J10424861+1100010',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000091,NULL,'15.8g',0.36,'S0a',NULL,NULL,NULL,NULL,1,160.702625,11.00025,0.049,NULL,61044600630,953821884,14903466,15.8),(73721,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73721,37.13,0.6,266,27805,70,NULL,NULL,'2MASX J10424888-1750001',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,160.70375,-17.83333,0.121,NULL,41649468354,650772943,10168327,16.6),(73722,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73722,37.19,0.46,274,27806,70,NULL,NULL,'2MASX J10424892+4152596',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00019,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,160.704083333,41.88314,0,NULL,64111532286,1001742691,15652229,16.2),(73723,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73723,37.44,0.46,308,27807,70,NULL,NULL,'2MASX J10424929+2214052',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,160.705291667,22.23472,0.029,NULL,60974376062,952724625,14886322,16.9),(73724,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73724,37.62,0.46,334,27808,70,NULL,NULL,'SDSS J104249.36+013026.6',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000068,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,160.7057083,1.50742,0.057,NULL,60279603054,941868797,14716699,18.8),(73725,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73725,37.52,0.46,319,27809,70,NULL,NULL,'SDSS J104249.71+253545.2',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000136,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,160.707167,25.59589,0.017,NULL,60527742802,945745981,14777280,17.9),(73726,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73726,34.93,0.46,97,27810,70,NULL,NULL,'2MASX J10425028+2546166',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.001001,NULL,'15.9g',0.37,NULL,NULL,NULL,NULL,NULL,1,160.7095,25.77119,0.021,NULL,60527795086,945746798,14777293,15.9),(73727,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73727,35.15,0.66,107,27811,70,NULL,NULL,'2MASX J10425171-4551025',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'13.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,160.7154583,-45.85064,0.801,NULL,42102356425,657849319,10278895,13.6),(73728,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73728,37.12,0.46,266,27812,70,NULL,NULL,'2MASX J10425187+3224214',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000156,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,160.71625,32.40603,0.021,NULL,64049059462,1000766554,15636977,16.8),(73729,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73729,37.12,0.46,266,27813,70,NULL,NULL,'2MASX J10425338+0635190',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000128,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,160.72225,6.58847,0.037,NULL,61063660314,954119692,14908120,17.7),(73730,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73730,36.35,0.46,186,27814,70,NULL,NULL,'2MASX J10425398+2415316',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00018,NULL,'16.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,160.7249583,24.25889,0.021,NULL,60490367454,945161991,14768156,16.5),(73731,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73731,36.67,0.46,215,27815,70,NULL,NULL,'MCG +05-25-035',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00016,NULL,'15.6g',0.45,NULL,NULL,NULL,NULL,NULL,1,160.725125,28.43308,0.013,NULL,60522813517,945668961,14776077,15.6),(73732,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73732,36.47,0.46,197,27816,70,NULL,NULL,'2MASX J10425465+0916430',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000158,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,160.727583,9.27864,0.101,NULL,61053698417,953964037,14905688,16.6),(73733,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73733,36.21,0.46,175,27817,70,NULL,NULL,'2MASX J10425478+4930440',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000181,NULL,'16.0g',0.43,'E0',NULL,NULL,NULL,NULL,1,160.728333,49.51233,0,NULL,64124920848,1001951888,15655498,16),(73734,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73734,37.44,0.46,307,27818,70,NULL,NULL,'2MASX J10425538+5524496',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000157,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,160.7307083,55.41375,0,NULL,61972473975,968319905,15129998,17.1),(73735,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73735,36.71,0.46,220,27819,70,NULL,NULL,'2MASX J10425619+1224351',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,160.734125,12.40972,0.045,NULL,61177446153,955897596,14935899,17.6),(73736,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73736,37.39,0.46,301,27820,70,NULL,NULL,'2MASX J10425623+3032304',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,160.734333,30.54178,0.005,NULL,60506827105,945419173,14772174,17.6),(73737,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73737,37.96,0.46,391,27821,70,NULL,NULL,'2MASX J10425677+3401504',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000181,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,160.736583,34.03081,0.021,NULL,64052648678,1000822635,15637853,17),(73738,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73738,34.25,0.2,70.8,27822,74.4,NULL,NULL,'FGC 126A',NULL,'2013AJ....146...86T',2013,1,0.87,NULL,'G',0.000007,NULL,'16.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,160.7395,13.54858,0.065,NULL,61175365509,955865086,14935391,16.5),(73739,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73739,37.11,0.46,265,27823,70,NULL,NULL,'2MASX J10425778+1855182',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,160.740625,18.92158,0.041,NULL,60985635457,952900554,14889071,17.4),(73740,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73740,36.55,0.46,204,27824,70,NULL,NULL,'2MASX J10425908+6508461',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000086,NULL,'17.2g',0.18,'NLAGN',NULL,NULL,NULL,NULL,1,160.746166667,65.14622,0.041,NULL,62116033238,970563019,15165047,17.2),(73741,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73741,38.32,0.46,460,27825,70,NULL,NULL,'2MASX J10430220+1304541',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000169,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,160.759125,13.08161,0.041,NULL,61177971228,955905800,14936028,17.9),(73742,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73742,36.72,0.46,220,27826,70,NULL,NULL,'2MASX J10430412+3026215',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000183,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,160.76725,30.43922,0,NULL,60506674944,945416796,14772137,17.2),(73743,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73743,37.84,0.33,370,27827,70,NULL,NULL,'2MASX J10430437+1652211',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,160.76825,16.87261,0.029,NULL,61178839104,955919361,14936240,17.8),(73744,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73744,37.35,0.46,295,27828,70,NULL,NULL,'2MASX J10430510+5803135',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000157,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,160.7712083,58.05383,0,NULL,62002638486,968791226,15137362,17.1),(73745,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73745,31.29,NULL,18.1,27829,NULL,NULL,NULL,'CGCG 065-090',NULL,'2015AstBu..70....1K',2015,1,0.52,NULL,'G',0.000117,NULL,'16.7g',0.35,NULL,NULL,NULL,NULL,NULL,1,160.7727083,13.51039,0.065,NULL,61175354587,955864915,14935389,16.7),(73746,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73746,38.56,0.33,516,27830,70,NULL,NULL,'2MASX J10430567+5131382',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000141,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,160.773625,51.52722,0,NULL,63904589000,998509203,15601706,18.2),(73747,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73747,37.52,0.46,320,27831,70,NULL,NULL,'2MASX J10430578+4605546',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000155,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,160.774208333,46.09844,0,NULL,64134188496,1002096695,15657760,17.3),(73748,'Tully est','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73748,31.82,0.8,23.2,27832,75,NULL,'B','UGC 05833',NULL,'1988NBGC.C....0000T',1988,1,1.5,'The 2MASS position is 12 arcsec southeast of the nucleus.','G',0.00002,NULL,'14.4',0.5,'S0',NULL,NULL,NULL,NULL,1,160.774917,20.42228,0.017,NULL,60979815656,952809619,14887650,14.4),(73749,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73749,38.19,0.33,434,27833,70,NULL,NULL,'2MASX J10430631+0826000',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00018,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,160.776375,8.43344,0.113,NULL,61068233326,954191145,14909236,17.1),(73750,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73750,38.57,0.46,518,27834,70,NULL,NULL,'2MASX J10430746+2547415',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00014,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,160.7810417,25.79497,0.041,NULL,60527789327,945746708,14777292,18.1),(73751,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73751,36.6,0.57,209,27835,70,NULL,NULL,'LCRS B104039.1-123132',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.0001,NULL,'16.13',NULL,NULL,NULL,NULL,NULL,NULL,1,160.782667,-12.78811,0.113,NULL,41837944522,653717883,10214341,16.13),(73752,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73752,38.12,0.46,420,27836,70,NULL,NULL,'2MASX J10430876+3128224',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000193,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,160.7867083,31.473,0.013,NULL,60505422651,945397228,14771831,17.1),(73753,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73753,36.71,0.46,220,27837,70,NULL,NULL,'2MASX J10430884+5649138',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000188,NULL,'16.1g',0.26,'Sa',NULL,NULL,NULL,NULL,1,160.78675,56.82056,0,NULL,62001805283,968778207,15137159,16.1),(73754,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73754,37.16,0.46,271,27838,70,NULL,NULL,'2MASX J10430913+4430255',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,160.788041667,44.50719,0,NULL,64131474411,1002054287,15657098,17.7),(73755,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73755,37.13,0.33,267,27839,70,NULL,NULL,'2MASX J10430922+5233242',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000175,NULL,'15.8g',0.38,'E0',NULL,NULL,NULL,NULL,1,160.788583,52.55667,0,NULL,61959237861,968113091,15126767,15.8),(73756,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73756,37.45,0.46,309,27840,70,NULL,NULL,'2MASX J10431047+0314063',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00007,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,160.793625,3.23517,0.069,NULL,60273395446,941771803,14715184,17.3),(73757,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73757,37.24,0.46,281,27841,70,NULL,NULL,'2MASX J10431052+1216010',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000178,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,160.7937083,12.267,0.041,NULL,61174601744,955853152,14935205,16.7),(73758,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73758,37.85,0.33,371,27842,70,NULL,NULL,'2MASX J10431064+2721085',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000134,NULL,'17.8g',0.19,'AGN',NULL,NULL,NULL,NULL,1,160.794375,27.35225,0.037,NULL,60528821790,945762840,14777544,17.8),(73759,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73759,37.9,0.46,379,27843,70,NULL,NULL,'2MASX J10431107+1228070',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000168,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,160.796125,12.46872,0.045,NULL,61177453039,955897703,14935901,17.1),(73760,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73760,34.12,0.8,66.7,27844,75,NULL,'HMCL, I','ESO 501- G 082',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000017,NULL,'14.18',0.7,'SB(rs)bc:',NULL,NULL,NULL,NULL,1,160.798167,-26.24997,0.281,NULL,41531121006,648923765,10139433,14.18),(73761,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73761,33.92,0.12,60.9,27844,NULL,NULL,NULL,'ESO 501- G 082',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73762,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73762,34.06,0.4,64.7,27844,75,NULL,'HMCL, I, cor','ESO 501- G 082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73763,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73763,34.12,0.4,66.7,27844,75,NULL,'HMCL, I, raw','ESO 501- G 082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73764,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73764,34.18,0.38,68.5,27844,NULL,NULL,NULL,'ESO 501- G 082',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73765,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73765,34.21,0.4,69.4,27844,NULL,NULL,'mean','ESO 501- G 082',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73766,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73766,34.27,0.47,71.6,27844,NULL,NULL,'H','ESO 501- G 082',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73767,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73767,34.31,0.4,72.8,27844,75,NULL,'HMCL, I, inv','ESO 501- G 082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73768,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73768,34.33,0.46,73.6,27844,NULL,NULL,'J','ESO 501- G 082',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73769,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73769,34.34,0.43,73.8,27844,75,NULL,'3.6 micron, color corrected','ESO 501- G 082',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73770,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73770,34.38,0.45,75.1,27844,NULL,NULL,'K','ESO 501- G 082',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73771,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73771,34.38,0.2,75.2,27844,74.4,NULL,NULL,'ESO 501- G 082',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73772,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73772,34.39,0.43,75.5,27844,75,NULL,'3.6 micron, color + selection bias corrected','ESO 501- G 082',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73773,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73773,37.88,0.33,377,27845,70,NULL,NULL,'2MASXi J1043129+160130',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.0g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,160.804125,16.02492,0.037,NULL,61180590133,955946720,14936667,18),(73774,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73774,37.36,0.56,296,27846,70,NULL,NULL,'LCRS B104047.4-120520',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.69',NULL,NULL,NULL,NULL,NULL,NULL,1,160.817917,-12.35136,0.081,NULL,41834364179,653661940,10213467,14.69),(73775,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73775,37.84,0.33,370,27847,70,NULL,NULL,'2MASX J10431649+1651560',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,160.818666667,16.86567,0.037,NULL,61178842189,955919409,14936240,17.7),(73776,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73776,37.74,0.46,354,27848,70,NULL,NULL,'2MASX J10431660+0034446',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000073,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,160.819125,0.579,0.057,NULL,60278514418,941851787,14716434,17.8),(73777,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73777,38.56,0.33,516,27849,70,NULL,NULL,'2MASX J10431713+5132432',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000145,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,160.821625,51.54536,0,NULL,63904593413,998509272,15601707,17.5),(73778,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73778,37.43,0.46,306,27850,70,NULL,NULL,'SDSS J104318.16+262126.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000154,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,160.8257083,26.35744,0.049,NULL,60527080738,945735636,14777119,18.4),(73779,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73779,36.11,0.27,167,27851,70,NULL,NULL,'2MASX J10431868+3132558',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00017,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,160.827958333,31.54889,0.013,NULL,60505343205,945395987,14771812,16.4),(73780,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73780,36.11,0.27,167,27852,70,NULL,NULL,'2MASX J10431946+3136388',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000187,NULL,'15.6g',0.39,NULL,NULL,NULL,NULL,NULL,1,160.830917,31.61094,0.013,NULL,60505356222,945396190,14771815,15.6),(73781,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73781,37,0.27,251,27853,70,NULL,NULL,'SDSS J104320.08+105946.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,160.833667,10.99639,0.049,NULL,61044635165,953822424,14903475,18.1),(73782,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73782,34.88,0.46,94.8,27854,70,NULL,NULL,'2MASX J10432061+4047104',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00016,NULL,'15.9g',0.25,'S0/a           AGN',NULL,NULL,NULL,NULL,1,160.8357083,40.78633,0,NULL,64111414474,1001740851,15652200,15.9),(73783,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73783,38.19,0.33,434,27855,70,NULL,NULL,'SDSS J104320.89+082522.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000144,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,160.8370417,8.42281,0.113,NULL,61068169054,954190141,14909220,18.5),(73784,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73784,37.42,0.46,304,27856,70,NULL,NULL,'2MASX J10432184+0218396',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000088,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,160.8410417,2.31083,0.065,NULL,60278239229,941847487,14716366,16.9),(73785,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73785,35.75,0.19,141,27857,70,NULL,NULL,'2MASX J10432191+1353510',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.00018,NULL,'15.6g',0.36,'S0/a',NULL,NULL,NULL,NULL,1,160.8412083,13.89742,0.065,NULL,61175908600,955873571,14935524,15.6),(73786,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73786,36.86,0.46,236,27858,70,NULL,NULL,'2MASX J10432269+4643222',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000163,NULL,'16.1g',0.4,'E0',NULL,NULL,NULL,NULL,1,160.8445,46.72292,0,NULL,64132970189,1002077659,15657463,16.1),(73787,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73787,37.88,0.46,377,27859,70,NULL,NULL,'SDSS J104325.33+114935.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000141,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,160.855583,11.82644,0.029,NULL,61044320808,953817512,14903398,18.4),(73788,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73788,36.43,0.27,193,27860,70,NULL,NULL,'CGCG 094-114',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',NULL,NULL,'15.6',0.8,NULL,NULL,NULL,NULL,NULL,1,160.856375,19.02319,0.041,NULL,60977418868,952772169,14887065,15.6),(73789,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73789,36.43,0.27,193,27861,70,NULL,NULL,'CGCG 094-115',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00023,NULL,'15.4',0.28,NULL,NULL,NULL,NULL,NULL,1,160.8565417,19.06047,0.041,NULL,60977420714,952772198,14887065,15.4),(73790,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73790,37.91,0.33,382,27862,70,NULL,NULL,'2MASX J10432566+0117216',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000076,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,160.85675,1.28939,0.081,NULL,60279231995,941862999,14716609,17.9),(73791,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73791,38.77,0.33,567,27863,70,NULL,NULL,'SDSS J104326.88+013319.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.0001,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,160.8620417,1.55553,0.057,NULL,60279614403,941868975,14716702,18.2),(73792,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73792,37.7,0.46,347,27864,70,NULL,NULL,'2MASX J10432711+2845331',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000143,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,160.862875,28.75936,0,NULL,60522858017,945669656,14776088,18.4),(73793,'TRGB','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73793,29.2,0.1,6.92,27865,74.4,NULL,NULL,'ESO 376- G 016',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.00001,NULL,'15.44',0.8,'...',NULL,NULL,NULL,NULL,1,160.86275,-37.04261,0.009,NULL,42125527481,658211366,10284552,15.44),(73794,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73794,29.26,NULL,7.11,27865,NULL,NULL,NULL,'ESO 376- G 016',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73795,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73795,37.78,0.27,359,27866,70,NULL,NULL,'2MASX J10432770+6144051',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000167,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,160.865167,61.73469,0,NULL,61950930537,967983289,15124738,16.7),(73796,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73796,37.96,0.46,390,27867,70,NULL,NULL,'2MASX J10432809+0745139',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000131,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,160.8670417,7.75378,0.073,NULL,61068650456,954197663,14909338,17.4),(73797,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73797,37.42,0.33,304,27868,70,NULL,NULL,'2MASX J10432873+4158202',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,160.8694583,41.97225,0,NULL,64111574195,1001743346,15652239,17.2),(73798,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73798,37.85,0.33,371,27869,70,NULL,NULL,'2MASX J10432873+2722381',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000168,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,160.869666667,27.37725,0.037,NULL,60528359165,945755611,14777431,17.3),(73799,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73799,33.64,0.8,53.5,27870,75,NULL,'CF, r','UGC 05820',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.00026,NULL,'15.05',0.5,'Sbc','Isolated galaxy',NULL,NULL,NULL,1,160.870625,80.89106,0.053,NULL,61436120093,959939376,14999052,15.05),(73800,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73800,34.27,0.38,71.3,27870,75,NULL,'CF, r, raw','UGC 05820',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73801,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73801,34.35,0.38,74.3,27870,75,NULL,'CF, r, inv','UGC 05820',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73802,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73802,34.51,0.38,79.7,27870,75,NULL,'CF, r, cor','UGC 05820',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73803,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73803,37.88,0.46,377,27871,70,NULL,NULL,'2MASX J10432931+3947384',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,160.872,39.79375,0,NULL,64119043539,1001860055,15654063,18.2),(73804,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73804,38.15,0.46,427,27872,70,NULL,NULL,'SDSS J104330.22+090042.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000146,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,160.875916667,9.01189,0.053,NULL,61055447595,953991368,14906115,18.1),(73805,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73805,37,0.27,251,27873,70,NULL,NULL,'2MASX J10433039+1058409',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000113,NULL,'16.79',0.32,NULL,NULL,NULL,NULL,NULL,1,160.8765417,10.97792,0.029,NULL,61044629799,953822340,14903474,16.79),(73806,'TRGB','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73806,29.96,0.1,9.82,27874,74.4,NULL,NULL,'NGC 3344',NULL,'2013AJ....146...86T',2013,1,7.1,NULL,'G',0.000003,NULL,'10.45',6.5,'(R)SAB(r)bc    HII','Isolated galaxy',NULL,NULL,NULL,1,160.8797917,24.92222,0.025,NULL,60524215064,945690860,14776419,10.45),(73807,'Ring Diameter','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73807,31.4,0.98,19,27874,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3344',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73808,'Ring Diameter','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73808,31.9,0.76,24,27874,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3344',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73809,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73809,28.92,0.4,6.1,27874,75,NULL,'B','NGC 3344',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73810,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73810,37.02,0.46,253,27875,70,NULL,NULL,'2MASX J10433125+1921234',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.02',0.15,NULL,NULL,NULL,NULL,NULL,1,160.8802083,19.35661,0.033,NULL,60977343437,952770991,14887046,18.02),(73811,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73811,37.07,0.46,259,27876,70,NULL,NULL,'2MASX J10433146+1607431',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000174,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,160.88125,16.12867,0.037,NULL,61181739038,955964672,14936948,17.1),(73812,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73812,38.28,0.46,454,27877,70,NULL,NULL,'SDSS J104331.53+101338.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000184,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,160.881375,10.22725,0.041,NULL,61056179248,954002800,14906293,17.8),(73813,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73813,36.26,0.46,179,27878,70,NULL,NULL,'ARK 252',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000197,NULL,'15.4g',0.44,'S0^-',NULL,NULL,NULL,NULL,1,160.884833,57.67214,0,NULL,62004338228,968817784,15137777,15.4),(73814,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73814,37.6,0.46,331,27879,70,NULL,NULL,'2MASX J10433285+3114578',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,160.886875,31.24953,0,NULL,60505295701,945395245,14771800,17.4),(73815,'Tully est','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73815,32.92,0.8,38.3,27880,75,NULL,'B','NGC 3358',NULL,'1988NBGC.C....0000T',1988,1,3.3,NULL,'G',0.00002,NULL,'12.29',1.9,'(R\'_2)SAB(l)ab','in a pair',NULL,NULL,NULL,1,160.887583333,-36.41069,0.169,NULL,41978713719,655917401,10248709,12.29),(73816,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73816,37.31,0.33,290,27881,70,NULL,NULL,'2MASX J10433320+0022196',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000079,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,160.888416667,0.37211,0.073,NULL,60270225376,941722271,14714410,16.6),(73817,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73817,36.65,0.33,214,27882,70,NULL,NULL,'2MASX J10433397+0608149',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000143,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,160.891583333,6.13731,0.025,NULL,61063246387,954113224,14908019,17.5),(73818,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73818,37.99,0.46,397,27883,70,NULL,NULL,'2MASX J10433474+3920504',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,160.894541667,39.34736,0,NULL,64122273418,1001910522,15654851,17.6),(73819,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73819,36.08,0.46,165,27884,70,NULL,NULL,'2MASX J10433469+4219352',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000182,NULL,'15.9g',0.34,'S0',NULL,NULL,NULL,NULL,1,160.894583,42.32656,0,NULL,64142708156,1002229814,15659840,15.9),(73820,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73820,35.64,0.46,134,27885,70,NULL,NULL,'2MASX J10433475-0056035',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000096,NULL,'15.2g',0.55,'S0',NULL,NULL,NULL,NULL,1,160.89475,-0.93425,0.097,NULL,40883827490,638809804,9981403,15.2),(73821,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73821,37.43,0.17,307,27886,70,NULL,NULL,'MCG +10-15-123',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000216,NULL,'15.9g',0.41,'BrClG',NULL,NULL,NULL,NULL,1,160.897083,58.10631,0,NULL,62002632690,968791135,15137361,15.9),(73822,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73822,38.49,0.46,499,27887,70,NULL,NULL,'SDSS J104335.35+004041.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000065,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,160.8972917,0.67811,0.057,NULL,60278506758,941851668,14716432,18),(73823,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73823,37.55,0.46,324,27888,70,NULL,NULL,'2MASX J10433585+1421121',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000186,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,160.8994583,14.35328,0.069,NULL,61182451505,955975804,14937121,16.1),(73824,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73824,36.65,0.33,214,27889,70,NULL,NULL,'2MASX J10433623+0604536',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000172,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,160.900833,6.08144,0.017,NULL,61063294418,954113975,14908030,16.6),(73825,'Tully est','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73825,32.4,0.8,30.2,27890,75,NULL,NULL,'UGCA 217',NULL,'1988NBGC.C....0000T',1988,1,2,'MCG decs for MCG -01-28 field are 10 arcmin too far north (MCG4 errata).','G',0.000017,NULL,'14.33',1.8,'SB(s)d pec:    HII',NULL,NULL,NULL,NULL,1,160.901167,-9.85628,0.057,NULL,41795623171,653056612,10204009,14.33),(73826,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73826,37.54,0.46,322,27891,70,NULL,NULL,'2MASX J10433680+3332558',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000164,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,160.90325,33.54892,0.017,NULL,64053300150,1000832814,15638012,16.5),(73827,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73827,37,0.27,251,27892,70,NULL,NULL,'2MASX J10433704+1052246',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,160.9044583,10.87358,0.029,NULL,61044533096,953820829,14903450,17.3),(73828,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73828,37.31,0.33,290,27893,70,NULL,NULL,'2MASX J10433714+0016046',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000088,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,160.90475,0.26803,0.077,NULL,60270257182,941722768,14714418,16.6),(73829,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73829,37.88,0.33,377,27894,70,NULL,NULL,'2MASX J10433743+1558361',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,160.9060417,15.97661,0.053,NULL,61180585487,955946648,14936666,18),(73830,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73830,37.59,0.33,329,27895,70,NULL,NULL,'2MASX J10433783+5413129',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000192,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,160.9077083,54.22042,0,NULL,61960911145,968139236,15127175,16.9),(73831,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73831,36.27,0.46,179,27896,70,NULL,NULL,'2MASX J10433854+2112184',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'15.82',0.24,NULL,NULL,NULL,NULL,NULL,1,160.910625,21.20525,0.005,NULL,60981010035,952828281,14887941,15.82),(73832,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73832,37.42,0.33,304,27897,70,NULL,NULL,'2MASX J10433870+4151594',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000188,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,160.911167,41.86661,0,NULL,64111553989,1001743031,15652234,17),(73833,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73833,33.36,0.8,47,27898,75,NULL,'MAT, I','ESO 437- G 054',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'14.95',0.27,'Sb             HII',NULL,NULL,NULL,NULL,1,160.9120417,-28.86658,0.145,NULL,41533412731,648959573,10139993,14.95),(73834,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73834,33.39,0.8,47.7,27898,75,NULL,'HMCL, I','ESO 437- G 054',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73835,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73835,33.71,0.38,55.2,27898,NULL,NULL,NULL,'ESO 437- G 054',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73836,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73836,33.8,0.4,57.5,27898,75,NULL,'HMCL, I, cor','ESO 437- G 054',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73837,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73837,33.82,0.4,58.1,27898,75,NULL,'HMCL, I, raw','ESO 437- G 054',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73838,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73838,33.84,0.15,58.7,27898,NULL,NULL,NULL,'ESO 437- G 054',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73839,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73839,33.9,0.4,60.3,27898,75,NULL,'HMCL, I, inv','ESO 437- G 054',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73840,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73840,33.97,0.49,62.1,27898,75,NULL,'IR','ESO 437- G 054',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73841,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73841,34,NULL,63.2,27898,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 437- G 054',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73842,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73842,34.01,NULL,63.5,27898,NULL,NULL,'Dipole + Quadrupole','ESO 437- G 054',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73843,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73843,34.02,NULL,63.6,27898,NULL,NULL,'Dipole','ESO 437- G 054',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73844,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73844,34.09,0.2,65.8,27898,74.4,NULL,NULL,'ESO 437- G 054',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73845,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73845,34.11,0.32,66.4,27898,85,NULL,'I, raw','ESO 437- G 054',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73846,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73846,34.13,0.32,67.1,27898,85,NULL,'I, inv','ESO 437- G 054',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73847,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73847,34.13,0.43,67.1,27898,75,NULL,'MAT, I, cor','ESO 437- G 054',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73848,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73848,34.14,0.43,67.1,27898,75,NULL,'MAT, I, raw','ESO 437- G 054',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73849,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73849,34.27,0.43,71.5,27898,75,NULL,'MAT, I, inv','ESO 437- G 054',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73850,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73850,34.36,NULL,74.4,27898,NULL,NULL,NULL,'ESO 437- G 054',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73851,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73851,31.75,0.4,22.4,27899,75,NULL,'B','NGC 3346',NULL,'1988NBGC.C....0000T',1988,1,2.7,NULL,'G',0.000003,NULL,'13.4g',1.52,'SB(rs)cd','Probable group member',NULL,NULL,NULL,1,160.912125,14.87186,0.061,NULL,61182423461,955975366,14937115,13.4),(73852,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73852,37.43,0.17,307,27900,70,NULL,NULL,'2MASX J10433973+5804089',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000168,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,160.91525,58.06911,0,NULL,62002642723,968791292,15137363,18),(73853,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73853,38.23,0.46,443,27901,70,NULL,NULL,'SDSS J104339.94+063549.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,160.9164583,6.59722,0.037,NULL,61063586088,954118532,14908102,18.3),(73854,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73854,36.11,0.27,167,27902,70,NULL,NULL,'2MASX J10433996+3125448',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000175,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,160.9165,31.42911,0.021,NULL,60505452864,945397701,14771839,16.6),(73855,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73855,34.02,0.49,63.6,27903,70,NULL,NULL,'2MASX J10434009-4413251',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000127,NULL,'15.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,160.9170417,-44.22358,0.701,NULL,42098704444,657792256,10278004,15.4),(73856,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73856,36.41,0.46,192,27904,70,NULL,NULL,'2MASX J10434024+1246571',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'17.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,160.9177083,12.78264,0.045,NULL,61177916189,955904940,14936014,17.2),(73857,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73857,37.78,0.27,359,27905,70,NULL,NULL,'2MASX J10434080+6146001',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000142,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,160.920083,61.76669,0,NULL,61830340461,966099069,15095297,17.7),(73858,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73858,37.91,0.33,382,27906,70,NULL,NULL,'2MASX J10434139+0118206',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000086,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,160.922375,1.30581,0.073,NULL,60279235940,941863061,14716610,17.2),(73859,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73859,37.82,0.46,367,27907,70,NULL,NULL,'2MASX J10434191+3948595',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000177,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,160.924666667,39.81667,0,NULL,64119002955,1001859421,15654053,17.2),(73860,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73860,37.64,0.46,338,27908,70,NULL,NULL,'2MASX J10434511+2942060',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000137,NULL,'16.8g',0.24,'S0',NULL,NULL,NULL,NULL,1,160.937833333,29.70181,0.013,NULL,60522017751,945656527,14775883,16.8),(73861,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73861,38.04,0.46,406,27909,70,NULL,NULL,'2MASX J10434503+4316311',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,160.937875,43.27525,0,NULL,64140140678,1002189698,15659214,17.4),(73862,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73862,35.48,0.2,125,27910,74.4,NULL,NULL,'CGCG 065-093',NULL,'2013AJ....146...86T',2013,1,0.71,NULL,'G',0.00016,NULL,'15.7g',0.41,'Sb',NULL,NULL,NULL,NULL,1,160.9417917,11.49403,0.049,NULL,61044909620,953826712,14903542,15.7),(73863,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73863,36.99,0.46,251,27911,70,NULL,NULL,'2MASX J10434664+5120292',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000152,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,160.9442917,51.34139,0,NULL,63905401741,998521902,15601904,17.1),(73864,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73864,33.6,0.8,52.4,27912,75,NULL,'MAT, I','ESO 501- G 086',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.00002,NULL,'13.84',0.9,'SAB(s)bc       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,160.9467083,-24.36797,0.169,NULL,41511904747,648623511,10134742,13.84),(73865,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73865,33.62,0.8,52.9,27912,75,NULL,'HMCL, I','ESO 501- G 086',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73866,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73866,33.26,0.32,44.9,27912,85,NULL,'I, raw','ESO 501- G 086',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73867,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73867,33.29,0.32,45.6,27912,85,NULL,'I, inv','ESO 501- G 086',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73868,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73868,33.39,0.43,47.7,27912,75,NULL,'MAT, I, raw','ESO 501- G 086',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73869,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73869,33.57,0.43,51.8,27912,75,NULL,'MAT, I, inv','ESO 501- G 086',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73870,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73870,33.59,0.43,52.2,27912,75,NULL,'MAT, I, cor','ESO 501- G 086',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73871,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73871,33.64,0.4,53.5,27912,75,NULL,'HMCL, I, raw','ESO 501- G 086',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73872,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73872,33.69,0.4,54.8,27912,75,NULL,'HMCL, I, cor','ESO 501- G 086',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73873,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73873,33.75,0.2,56.2,27912,74.4,NULL,NULL,'ESO 501- G 086',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73874,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73874,33.76,0.43,56.6,27912,75,NULL,'3.6 micron, color corrected','ESO 501- G 086',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73875,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73875,33.82,0.4,58,27912,75,NULL,'HMCL, I, inv','ESO 501- G 086',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73876,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73876,33.84,0.08,58.7,27912,NULL,NULL,NULL,'ESO 501- G 086',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73877,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73877,33.85,0.43,59,27912,75,NULL,'3.6 micron, color + selection bias corrected','ESO 501- G 086',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73878,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73878,33.88,0.4,59.8,27912,NULL,NULL,'mean','ESO 501- G 086',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73879,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73879,33.9,0.38,60.3,27912,NULL,NULL,NULL,'ESO 501- G 086',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73880,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73880,33.91,0.47,60.6,27912,NULL,NULL,'H','ESO 501- G 086',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73881,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73881,33.98,0.46,62.4,27912,NULL,NULL,'J','ESO 501- G 086',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73882,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73882,34.03,0.45,64,27912,NULL,NULL,'K','ESO 501- G 086',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73883,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73883,37.81,0.33,365,27913,70,NULL,NULL,'2MASX J10434832+0309504',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000083,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,160.951375,3.16411,0.077,NULL,60274157803,941783715,14715370,16.6),(73884,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73884,36.14,0.46,169,27914,70,NULL,NULL,'2MASX J10434858+1828144',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.65',0.21,NULL,NULL,NULL,NULL,NULL,1,160.9525417,18.47075,0.029,NULL,60976942411,952764725,14886948,17.65),(73885,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73885,35.83,0.63,147,27915,70,NULL,NULL,'UGC 05847',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000107,NULL,'14.90',0.6,'(R\')SB(s)b:',NULL,NULL,NULL,NULL,1,160.953125,-2.52789,0.145,NULL,40884439461,638819366,9981552,14.9),(73886,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73886,37.76,0.46,356,27916,70,NULL,NULL,'2MASX J10434928+0204504',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000104,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,160.955333,2.08056,0.069,NULL,60280356129,941880564,14716883,16.9),(73887,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73887,32.9,0.8,37.9,27917,75,NULL,'MAT, I','ESO 318- G 004',NULL,'1997ApJS..109..333W',1997,1,2.7,NULL,'G',0.000033,NULL,'13.54',0.5,'SA(s)c? sp     HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,160.960583,-38.26325,0.153,NULL,42126290165,658223283,10284738,13.54),(73888,'IRAS','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73888,32.91,0.8,38.2,27917,75,NULL,'HMCL, I','ESO 318- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73889,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73889,31.79,0.3,22.8,27917,92,NULL,'I, Assuming Hydra cluster m-M = 33.2 mag','ESO 318- G 004',NULL,'1993AJ....105...97S',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73890,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73890,32.28,0.3,28.6,27917,92,NULL,'H, Assuming Hydra cluster m-M = 33.2 mag','ESO 318- G 004',NULL,'1993AJ....105...97S',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73891,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73891,32.32,0.4,29.1,27917,75,NULL,NULL,'ESO 318- G 004',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73892,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73892,32.39,NULL,30.1,27917,NULL,NULL,'B','ESO 318- G 004',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73893,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73893,32.46,0.4,31,27917,75,NULL,'HMCL, I, raw','ESO 318- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73894,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73894,32.61,0.4,33.3,27917,75,NULL,'HMCL, I, inv','ESO 318- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73895,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73895,32.62,0.46,33.5,27917,NULL,NULL,'J','ESO 318- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73896,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73896,32.63,0.49,33.6,27917,75,NULL,'IR','ESO 318- G 004',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73897,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73897,32.63,0.38,33.6,27917,NULL,NULL,NULL,'ESO 318- G 004',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73898,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73898,32.64,0.47,33.8,27917,NULL,NULL,'H','ESO 318- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73899,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73899,32.68,NULL,34.4,27917,NULL,NULL,'I','ESO 318- G 004',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73900,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73900,32.74,0.4,35.3,27917,75,NULL,'HMCL, I, cor','ESO 318- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73901,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73901,32.74,0.45,35.4,27917,NULL,NULL,'K','ESO 318- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73902,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73902,32.75,0.32,35.5,27917,85,NULL,'I, raw','ESO 318- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73903,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73903,32.77,0.43,35.9,27917,75,NULL,'MAT, I, raw','ESO 318- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73904,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73904,32.8,0.43,36.3,27917,75,NULL,'3.6 micron, color corrected','ESO 318- G 004',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73905,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73905,32.8,0.2,36.3,27917,74.4,NULL,NULL,'ESO 318- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73906,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73906,32.81,0.32,36.4,27917,85,NULL,'I, inv','ESO 318- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73907,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73907,32.87,0.43,37.5,27917,75,NULL,'3.6 micron, color + selection bias corrected','ESO 318- G 004',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73908,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73908,33,0.43,39.9,27917,75,NULL,'MAT, I, inv','ESO 318- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73909,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73909,33.03,0.43,40.3,27917,75,NULL,'MAT, I, cor','ESO 318- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73910,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73910,33.14,0.4,42.4,27917,NULL,NULL,'mean','ESO 318- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73911,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73911,33.25,0.1,44.8,27917,NULL,NULL,NULL,'ESO 318- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73912,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73912,37.87,0.46,375,27918,70,NULL,NULL,'2MASX J10435103+1240581',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000157,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,160.9627083,12.68281,0.045,NULL,61177858603,955904040,14936000,17),(73913,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73913,36.35,0.46,186,27919,70,NULL,NULL,'2MASX J10435111+2534004',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000166,NULL,'15.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,160.9629583,25.56692,0.033,NULL,60527635523,945744305,14777254,15.9),(73914,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73914,36.9,0.46,240,27920,70,NULL,NULL,'SDSS J104351.66+011732.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00007,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,160.965291667,1.29231,0.073,NULL,60278772714,941855823,14716497,18.1),(73915,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73915,36.57,0.46,206,27921,70,NULL,NULL,'2MASX J10435293+1814154',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.64',0.2,NULL,NULL,NULL,NULL,NULL,1,160.970583333,18.23767,0.033,NULL,60976844852,952763200,14886925,17.64),(73916,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73916,38.1,0.46,417,27922,70,NULL,NULL,'2MASX J10435447+2444464',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000964,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,160.976833333,24.74611,0.061,NULL,60491159534,945174367,14768349,18.2),(73917,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73917,37.34,0.33,294,27923,70,NULL,NULL,'SDSS J104355.53+041559.0',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000187,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,160.981417,4.26639,0.073,NULL,61008625405,953259771,14894683,16.5),(73918,'Tully-Fisher','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73918,32.21,0.43,27.7,27924,75,NULL,'3.6 micron, color + selection bias corrected','UGC 05844',NULL,'2014MNRAS.444..527S',2014,1,1.66,NULL,'G',0.000025,NULL,'16.0',0.28,'Sd',NULL,NULL,NULL,NULL,1,160.9824583,28.14753,0.029,NULL,60528563177,945758799,14777481,16),(73919,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73919,37.59,0.46,330,27925,70,NULL,NULL,'SDSS J104355.85+045004.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000135,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,160.9827083,4.83461,0.025,NULL,61010302275,953285973,14895093,18.3),(73920,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73920,37.81,0.33,365,27926,70,NULL,NULL,'2MASX J10435606+0306495',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000091,NULL,'17.6g',0.2,'NLAGN',NULL,NULL,NULL,'Sy 2',1,160.9835417,3.11367,0.077,NULL,60274179837,941784059,14715375,17.6),(73921,'FP','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73921,38.77,0.33,567,27927,70,NULL,NULL,'SDSS J104356.26+013017.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000081,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,160.984458333,1.50492,0.073,NULL,60280407686,941881370,14716896,18.3),(73922,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73922,29.77,0.08,8.99,27928,NULL,NULL,'46, VI','MESSIER 095',NULL,'1997ApJ...491...13K',1997,1,3.07,NULL,'G',0.000013,NULL,'11.4g',2.86,'SB(r)b;HII     Sbrst','in a radial-velocity based grouping',NULL,NULL,NULL,1,160.990417,11.70381,0.045,NULL,61044822155,953825346,14903521,11.4),(73923,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73923,29.81,0.09,9.16,27928,NULL,NULL,'MW HIPP','MESSIER 095',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73924,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73924,29.85,0.09,9.33,27928,NULL,NULL,'48, VI, KEY PROJECT','MESSIER 095',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73925,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73925,29.85,0.16,9.33,27928,NULL,NULL,'MW P02','MESSIER 095',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73926,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73926,29.88,0.08,9.46,27928,NULL,NULL,'MW GFG','MESSIER 095',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73927,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73927,29.88,0.08,9.46,27928,NULL,NULL,'110, VI','MESSIER 095',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73928,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73928,29.9,0.09,9.56,27928,NULL,NULL,'cte LMC K03','MESSIER 095',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73929,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73929,29.91,0.06,9.59,27928,NULL,NULL,'LMC W01','MESSIER 095',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73930,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73930,29.91,0.09,9.61,27928,NULL,NULL,'cte U99','MESSIER 095',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73931,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73931,29.92,0.09,9.64,27928,NULL,NULL,'LMC VIHJK','MESSIER 095',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73932,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73932,29.93,0.09,9.67,27928,NULL,NULL,'cte LMC STS02','MESSIER 095',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73933,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73933,29.94,0.09,9.71,27928,NULL,NULL,'cte MW GFG98','MESSIER 095',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73934,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73934,29.95,0.09,9.75,27928,NULL,NULL,'cte MW FSG03','MESSIER 095',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73935,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73935,29.98,0.09,9.9,27928,NULL,NULL,'cte MF91','MESSIER 095',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73936,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73936,30.01,0.08,10,27928,NULL,NULL,'49, VI','MESSIER 095',NULL,'1997ApJ...477..535G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73937,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73937,30,0.09,10,27928,NULL,NULL,'48, VI, +Z, KEY PROJECT','MESSIER 095',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73938,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73938,30,0.09,10,27928,NULL,NULL,'cte MW STS03','MESSIER 095',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73939,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73939,30.01,0.08,10,27928,NULL,NULL,'HST KP Calibrated','MESSIER 095',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73940,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73940,30.09,0.14,10.4,27928,NULL,NULL,'46, VI +Z','MESSIER 095',NULL,'1997ApJ...491...13K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73941,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73941,30.1,0.06,10.5,27928,74.4,NULL,NULL,'MESSIER 095',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73942,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,NULL,73942,30.1,0.07,10.5,27928,NULL,18.54,'LMC ZP','MESSIER 095',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73943,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73943,30.12,0.08,10.6,27928,73,NULL,'Cepheids periods Gaussian ','MESSIER 095',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73944,'Cepheids','2016-12-15 15:14:40','2016-12-16 11:19:48','1',NULL,'R',73944,30.18,0.12,10.9,27928,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian ','MESSIER 095',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73945,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,73945,30.19,0.08,10.9,27928,NULL,NULL,'Z, Key Project','MESSIER 095',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73946,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',73946,30.25,0.21,11.2,27928,73,NULL,'Cepheids magnitudes Gaussian ','MESSIER 095',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73947,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,73947,30.51,NULL,12.6,27928,NULL,NULL,'30, VI','MESSIER 095',NULL,'2006A&A...452..423P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73948,'PNLF','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,73948,30.05,0.16,10.2,27928,NULL,NULL,NULL,'MESSIER 095',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73949,'TRGB','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,73949,29.92,0.05,9.64,27928,NULL,NULL,'I','MESSIER 095',NULL,'2007ApJ...661..815R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73950,'TRGB','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,73950,30.1,0.06,10.5,27928,74.4,NULL,NULL,'MESSIER 095',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73951,'TRGB','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,73951,30.39,0.13,12,27928,NULL,NULL,NULL,'MESSIER 095',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73952,'Ring Diameter','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,73952,30,0.76,10,27928,NULL,NULL,'Published at H = 100 km/s/Mpc','MESSIER 095',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73953,'Ring Diameter','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,73953,30.2,0.6,11,27928,NULL,NULL,'Published at H = 100 km/s/Mpc','MESSIER 095',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73954,'SNII optical','2016-12-15 15:14:41','2016-12-16 11:19:48','1','SN 2012aw',NULL,73954,29.46,0.15,7.8,27928,NULL,NULL,'EPM, H01, fixed explosion epoch','MESSIER 095',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73955,'SNII optical','2016-12-15 15:14:41','2016-12-16 11:19:48','1','SN 2012aw',NULL,73955,29.58,0.2,8.24,27928,NULL,NULL,'SCM Olivares 2010','MESSIER 095',NULL,'2015MNRAS.448.2312B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73956,'SNII optical','2016-12-15 15:14:41','2016-12-16 11:19:48','1','SN 2012aw',NULL,73956,29.63,0.16,8.43,27928,NULL,NULL,'SCM, Poznanski et al. 2009','MESSIER 095',NULL,'2015A&A...580L..15P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73957,'SNII optical','2016-12-15 15:14:41','2016-12-16 11:19:48','1','SN 2012aw',NULL,73957,29.69,0.22,8.67,27928,NULL,NULL,'EPM, H01','MESSIER 095',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73958,'SNII optical','2016-12-15 15:14:41','2016-12-16 11:19:48','1','SN 2012aw',NULL,73958,29.7,0.2,8.71,27928,NULL,NULL,'SCM Poznanski 2009','MESSIER 095',NULL,'2015MNRAS.448.2312B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73959,'SNII optical','2016-12-15 15:14:41','2016-12-16 11:19:48','1','SN 2012aw',NULL,73959,29.79,0.16,9.08,27928,NULL,NULL,'SCM, D\'Andrea et al. 2010','MESSIER 095',NULL,'2015A&A...580L..15P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73960,'SNII optical','2016-12-15 15:14:41','2016-12-16 11:19:48','1','SN 2012aw',NULL,73960,29.86,0.2,9.38,27928,NULL,NULL,'SCM D\'Andrea 2010','MESSIER 095',NULL,'2015MNRAS.448.2312B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73961,'SNII optical','2016-12-15 15:14:41','2016-12-16 11:19:48','1','SN 2012aw',NULL,73961,29.86,0.16,9.38,27928,NULL,NULL,'SCM, Hamuy 2003','MESSIER 095',NULL,'2015A&A...580L..15P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73962,'SNII optical','2016-12-15 15:14:41','2016-12-16 11:19:48','1','SN 2012aw',NULL,73962,29.96,0.3,9.82,27928,NULL,NULL,'SCM HP 2002','MESSIER 095',NULL,'2015MNRAS.448.2312B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73963,'SNII optical','2016-12-15 15:14:41','2016-12-16 11:19:48','1','SN 2012aw',NULL,73963,29.96,0.09,9.83,27928,NULL,NULL,'EPM, D05, fixed explosion epoch','MESSIER 095',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73964,'SNII optical','2016-12-15 15:14:41','2016-12-16 11:19:48','1','SN 2012aw',NULL,73964,30,0.17,10,27928,NULL,NULL,'SCM, zero point for 24 type II supernovae','MESSIER 095',NULL,'2015ApJ...799..215P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73965,'SNII optical','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,73965,30,NULL,10,27928,NULL,NULL,'light echo','MESSIER 095',NULL,'2015ApJ...806..195V',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73966,'SNII optical','2016-12-15 15:14:41','2016-12-16 11:19:48','1','SN 2012aw',NULL,73966,30.03,0.3,10.1,27928,NULL,NULL,'SCM Nugent 2006','MESSIER 095',NULL,'2015MNRAS.448.2312B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73967,'SNII optical','2016-12-15 15:14:41','2016-12-16 11:19:48','1','SN 2012aw',NULL,73967,30.07,0.16,10.3,27928,NULL,NULL,'SCM, Nugent et al. 2006','MESSIER 095',NULL,'2015A&A...580L..15P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73968,'SNII optical','2016-12-15 15:14:41','2016-12-16 11:19:48','1','SN 2012aw',NULL,73968,30.12,0.09,10.6,27928,NULL,NULL,'V, photospheric magnitude method','MESSIER 095',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73969,'SNII optical','2016-12-15 15:14:41','2016-12-16 11:19:48','1','SN 2012aw',NULL,73969,30.15,0.05,10.7,27928,NULL,NULL,'I, photospheric magnitude method','MESSIER 095',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73970,'SNII optical','2016-12-15 15:14:41','2016-12-16 11:19:48','1','SN 2012aw',NULL,73970,30.26,0.16,11.3,27928,NULL,NULL,'EPM, D05','MESSIER 095',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73971,'Sosies','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,73971,30.04,0.08,10.2,27928,NULL,NULL,NULL,'MESSIER 095',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73972,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,73972,29.54,0.4,8.1,27928,75,NULL,'B','MESSIER 095',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73973,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',73973,29.84,NULL,9.29,27928,NULL,NULL,'I','MESSIER 095',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73974,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,73974,29.96,0.4,9.8,27928,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 3 galaxy group','MESSIER 095',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73975,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,73975,29.96,0.3,9.82,27928,69,NULL,NULL,'MESSIER 095',NULL,'1997MNRAS.290L..77S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73976,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,73976,29.97,0.03,9.86,27928,NULL,NULL,'I','MESSIER 095',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73977,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',73977,30,0.09,10,27928,75,NULL,NULL,'MESSIER 095',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73978,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',73978,30.08,NULL,10.4,27928,NULL,NULL,'B','MESSIER 095',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73979,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,73979,30.1,0.06,10.5,27928,74.4,NULL,NULL,'MESSIER 095',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73980,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,73980,30.17,0.36,10.8,27928,NULL,NULL,NULL,'MESSIER 095',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73981,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,73981,30.18,0.18,10.9,27928,NULL,NULL,'B','MESSIER 095',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73982,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,73982,30.31,0.3,11.5,27928,55,NULL,'B','MESSIER 095',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73983,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,73983,30.41,0.51,12.1,27928,NULL,NULL,NULL,'MESSIER 095',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73984,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,73984,30.52,0.39,12.7,27928,73,NULL,'opt','MESSIER 095',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73985,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',73985,30.53,NULL,12.8,27928,NULL,NULL,'LEDA [April 2006]','MESSIER 095',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73986,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,73986,30.55,0.48,12.9,27928,NULL,NULL,'Malmquist cor.','MESSIER 095',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73987,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',73987,36.65,0.46,214,27929,70,NULL,NULL,'2MASX J10435789-0030269',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000091,NULL,'16.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,160.991333333,-0.50747,0.069,NULL,40879690336,638745161,9980393,16.8),(73988,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',73988,37.71,0.46,349,27930,70,NULL,NULL,'2MASX J10435901+2613574',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000143,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,160.995833,26.2325,0.045,NULL,60527116698,945736198,14777128,17.5),(73989,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,73989,35.87,0.5,149,27931,70,NULL,NULL,'2MASX J10440045-0851477',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000133,NULL,'15.20',NULL,NULL,NULL,NULL,NULL,NULL,1,161.001875,-8.86325,0.037,NULL,41793363980,653021312,10203458,15.2),(73990,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',73990,37.78,0.27,359,27932,70,NULL,NULL,'2MASX J10440233+6143439',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000145,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,161.009417,61.72889,0,NULL,61830389809,966099840,15095310,17.5),(73991,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',73991,35.25,0.46,112,27933,70,NULL,NULL,'UGC 05845',NULL,'2015arXiv151105856S',2015,1,1.05,NULL,'G',0.00019,NULL,'14.4g',0.72,'AGN',NULL,NULL,NULL,NULL,1,161.015375,43.90336,0,NULL,64139760355,1002183755,15659121,14.4),(73992,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',73992,38.03,0.46,404,27934,70,NULL,NULL,'2MASX J10440425+2457454',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,161.017583,24.96269,0.053,NULL,60490895723,945170245,14768285,17.4),(73993,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,73993,37.74,0.59,352,27935,70,NULL,NULL,'2MASX J10440471-0930294',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,161.019667,-9.50814,0.037,NULL,41795401641,653053150,10203955,17),(73994,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',73994,37.54,0.46,322,27936,70,NULL,NULL,'2MASXi J1044051+141924',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00016,NULL,'17.5g',NULL,NULL,NULL,NULL,NULL,NULL,1,161.021333,14.32353,0.049,NULL,61175102963,955860983,14935327,17.5),(73995,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,73995,36.33,0.5,184,27937,NULL,NULL,'Malmquist cor.','SDSS J104405.80+260341.9',NULL,'2009ApJS..182..474S',2009,1,0.41,NULL,'G',0.00002,NULL,'17.9g',0.1,NULL,NULL,NULL,NULL,NULL,1,161.024208333,26.06167,0.049,NULL,60527854508,945747726,14777308,17.9),(73996,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,73996,36.45,0.47,195,27937,NULL,NULL,NULL,'SDSS J104405.80+260341.9',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73997,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',73997,37.81,0.46,366,27938,70,NULL,NULL,'2MASX J10440716+5557450',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000189,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,161.029958333,55.96267,0,NULL,61969522920,968273795,15129278,17),(73998,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',73998,37.47,0.46,311,27939,70,NULL,NULL,'2MASX J10440747+4008125',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000162,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,161.03125,40.13678,0,NULL,64119090609,1001860790,15654074,16.6),(73999,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',73999,37.89,0.46,378,27940,70,NULL,NULL,'2MASX J10440783+3941234',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,161.0327917,39.68981,0,NULL,64121838887,1001903732,15654745,18.1),(74000,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74000,38.48,0.46,496,27941,70,NULL,NULL,'SDSS J104409.19+023906.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000085,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,161.0382917,2.65192,0.069,NULL,60278123899,941845685,14716338,18.2),(74001,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74001,37.29,0.46,287,27942,70,NULL,NULL,'2MASX J10440933+1700413',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.15',0.15,NULL,NULL,NULL,NULL,NULL,1,161.038833,17.01156,0.021,NULL,61178771959,955918311,14936223,18.15),(74002,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74002,37.72,0.46,350,27943,70,NULL,NULL,'2MASX J10441125+4314143',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,161.047167,43.23725,0,NULL,64140109490,1002189210,15659206,17.8),(74003,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74003,37.34,0.33,294,27944,70,NULL,NULL,'2MASX J10441221+0424125',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,161.0507917,4.40339,0.061,NULL,61009722470,953276913,14894951,17.2),(74004,'IRAS','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74004,34.63,0.8,84.5,27945,75,NULL,'CF, r','NGC 3356',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000013,NULL,'13.8',0.8,'Sbc','in a radial-velocity based grouping',NULL,NULL,NULL,1,161.050958333,6.75878,0.053,NULL,61063488844,954117013,14908078,13.8),(74005,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74005,33.87,0.38,59.5,27945,75,NULL,'CF, r, raw','NGC 3356',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74006,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74006,34,0.38,63.2,27945,75,NULL,'CF, r, inv','NGC 3356',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74007,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74007,34.13,0.38,66.9,27945,75,NULL,'CF, r, cor','NGC 3356',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74008,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74008,34.34,0.57,73.8,27945,NULL,NULL,'Malmquist cor.','NGC 3356',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74009,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74009,34.35,0.57,74,27945,NULL,NULL,NULL,'NGC 3356',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74010,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74010,34.39,0.2,75.5,27945,74.4,NULL,NULL,'NGC 3356',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74011,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74011,34.59,0.47,82.7,27945,NULL,NULL,'H','NGC 3356',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74012,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74012,34.73,0.46,88.4,27945,NULL,NULL,'J','NGC 3356',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74013,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74013,34.75,0.45,89.3,27945,NULL,NULL,'K','NGC 3356',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74014,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74014,34.88,0.4,94.7,27945,NULL,NULL,'mean','NGC 3356',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74015,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74015,38.4,0.46,478,27946,70,NULL,NULL,'2MASX J10441250+0655164',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,161.052083,6.92108,0.061,NULL,61063448070,954116376,14908068,18.1),(74016,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74016,37.43,0.46,306,27947,70,NULL,NULL,'2MASX J10441315+0342237',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000146,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,161.05475,3.70658,0.093,NULL,60273852153,941778939,14715295,17.5),(74017,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74017,37.92,0.33,384,27948,70,NULL,NULL,'2MASX J10441442+0939514',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,161.060125,9.66433,0.057,NULL,61056304820,954004762,14906324,17.3),(74018,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74018,35.75,0.19,141,27949,70,NULL,NULL,'2MASX J10441443+1406173',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000194,NULL,'15.7g',0.36,NULL,NULL,NULL,NULL,NULL,1,161.06025,14.10478,0.065,NULL,61175938664,955874041,14935531,15.7),(74019,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74019,34.37,0.33,74.9,27950,70,NULL,NULL,'NGC 3352',NULL,'2015arXiv151105856S',2015,1,1.6,'The 2MASS position is 7 arcsec east of the nucleus.','G',0.000103,NULL,'13.53',1.2,'S0',NULL,NULL,NULL,NULL,1,161.0622083,22.37119,0,NULL,60974492272,952726441,14886350,13.53),(74020,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74020,34.38,0.45,75.3,27950,NULL,NULL,'K','NGC 3352',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74021,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74021,34.76,0.4,89.4,27950,NULL,NULL,'mean','NGC 3352',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74022,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74022,36.83,0.46,232,27951,70,NULL,NULL,'2MASX J10441542+6024211',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000187,NULL,'15.9g',0.39,'S0/a',NULL,NULL,NULL,NULL,1,161.064,60.40583,0,NULL,61957750376,968089849,15126403,15.9),(74023,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74023,38.08,0.46,412,27952,70,NULL,NULL,'SDSS J104415.49+603640.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,161.064583,60.61128,0,NULL,61955696617,968057759,15125902,18.3),(74024,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74024,35.39,0.49,119,27953,70,NULL,NULL,'NGC 3360',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00004,NULL,'14.57',0.9,'SA(s)c:',NULL,NULL,NULL,NULL,1,161.067417,-11.24256,0.101,NULL,41763665307,652557270,10196207,14.57),(74025,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74025,37.04,0.54,256,27954,70,NULL,NULL,'2MASX J10441692-4036204',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,161.0705417,-40.60578,0.357,NULL,42122074988,658157421,10283709,15.3),(74026,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74026,37.12,0.46,265,27955,70,NULL,NULL,'2MASX J10441697+4339473',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000164,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,161.071,43.66311,0,NULL,64140116903,1002189326,15659208,16.4),(74027,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74027,37.14,0.46,268,27956,70,NULL,NULL,'2MASX J10441732+4240093',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,161.0722083,42.66922,0,NULL,64139873839,1002185528,15659148,17.3),(74028,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74028,38.17,0.46,430,27957,70,NULL,NULL,'SDSS J104418.01+055612.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000122,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,161.075041667,5.93692,0.053,NULL,61063100524,954110945,14907983,18.3),(74029,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74029,37.58,0.46,328,27958,70,NULL,NULL,'2MASX J10441818+0251027',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000081,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,161.07575,2.85067,0.097,NULL,60278022124,941844095,14716313,17.8),(74030,'Sosies','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74030,34.32,0.22,73.1,27959,NULL,NULL,NULL,'ESO 501- G 088',NULL,'2002A&A...393...57T',2002,1,1.5,NULL,'G',0.000021,NULL,'13.93',1.1,'(R\'_2)SAB(rs)abHII',NULL,NULL,NULL,NULL,1,161.078291667,-22.82617,0.193,NULL,41636246062,650566344,10165099,13.93),(74031,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74031,33.96,0.4,61.9,27959,NULL,NULL,'mean','ESO 501- G 088',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74032,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74032,34.47,0.47,78.5,27959,NULL,NULL,'H','ESO 501- G 088',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74033,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74033,34.56,0.45,81.6,27959,NULL,NULL,'K','ESO 501- G 088',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74034,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74034,34.57,0.46,82.1,27959,NULL,NULL,'J','ESO 501- G 088',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74035,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74035,35.12,0.46,106,27960,70,NULL,NULL,'CGCG 267-008',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.00009,NULL,'14.4g',0.64,'E','Isolated galaxy',NULL,NULL,NULL,1,161.079,52.77014,0,NULL,61958733671,968105213,15126643,14.4),(74036,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74036,35.75,0.19,141,27961,70,NULL,NULL,'NGC 3357',NULL,'2015arXiv151105856S',2015,1,1.49,'Correction of UGC R.A. error for UGC 05206 makes UGC 05206 = UGC 05854A.','G',0.000167,NULL,'13.8g',0.97,'E+:','Probable group member',NULL,NULL,NULL,1,161.086416667,14.08447,0.065,NULL,61175932131,955873939,14935530,13.8),(74037,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74037,31.06,0.4,16.3,27962,75,NULL,'B','UGC 05848',NULL,'1988NBGC.C....0000T',1988,1,1.45,NULL,'G',0.000017,NULL,'14.9g',0.82,'Sm:','X-ray-faint group member',NULL,NULL,NULL,1,161.0964583,56.42144,0,NULL,61969203835,968268809,15129200,14.9),(74038,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74038,36.72,0.46,221,27963,70,NULL,NULL,'2MASX J10442308+3222239',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000143,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,161.0962083,32.37328,0,NULL,64048274241,1000754285,15636785,17.7),(74039,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74039,38.04,0.46,406,27964,70,NULL,NULL,'SDSS J104423.74+031448.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000072,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,161.098916667,3.24681,0.077,NULL,60274206532,941784477,14715382,18.5),(74040,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74040,37.28,0.33,285,27965,70,NULL,NULL,'2MASX J10442400+0219347',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,161.099833333,2.32642,0.069,NULL,60280132286,941877066,14716829,17.1),(74041,'IRAS','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74041,32.92,0.8,38.3,27966,75,NULL,'HMCL, I','ESO 437- G 056',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.06',1.1,'SB(rs)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,161.1017917,-32.20978,0.289,NULL,41983009940,655984530,10249758,14.06),(74042,'IRAS','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74042,32.94,0.8,38.7,27966,75,NULL,'MAT, I','ESO 437- G 056',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74043,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74043,31.86,0.3,23.6,27966,92,NULL,'I, Assuming Hydra cluster m-M = 33.2 mag','ESO 437- G 056',NULL,'1993AJ....105...97S',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74044,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74044,32.26,0.3,28.3,27966,92,NULL,'H, Assuming Hydra cluster m-M = 33.2 mag','ESO 437- G 056',NULL,'1993AJ....105...97S',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74045,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74045,32.88,0.38,37.7,27966,NULL,NULL,NULL,'ESO 437- G 056',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74046,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74046,32.98,0.32,39.4,27966,85,NULL,'I, raw','ESO 437- G 056',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74047,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74047,33,0.4,39.9,27966,75,NULL,'HMCL, I, raw','ESO 437- G 056',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74048,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74048,33.01,0.32,40,27966,85,NULL,'I, inv','ESO 437- G 056',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74049,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74049,33.11,0.4,42,27966,75,NULL,'HMCL, I, inv','ESO 437- G 056',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74050,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74050,33.12,0.43,42.1,27966,75,NULL,'3.6 micron, color + selection bias corrected','ESO 437- G 056',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74051,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74051,33.13,0.43,42.2,27966,75,NULL,'3.6 micron, color corrected','ESO 437- G 056',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74052,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74052,33.16,0.2,42.9,27966,74.4,NULL,NULL,'ESO 437- G 056',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74053,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74053,33.19,NULL,43.5,27966,NULL,NULL,'I','ESO 437- G 056',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74054,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74054,33.2,0.4,43.6,27966,NULL,NULL,'mean','ESO 437- G 056',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74055,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74055,33.25,0.08,44.8,27966,NULL,NULL,NULL,'ESO 437- G 056',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74056,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74056,33.26,0.43,44.8,27966,75,NULL,'MAT, I, raw','ESO 437- G 056',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74057,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74057,33.28,0.4,45.3,27966,75,NULL,'HMCL, I, cor','ESO 437- G 056',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74058,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74058,33.43,0.43,48.5,27966,75,NULL,'MAT, I, inv','ESO 437- G 056',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74059,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74059,33.49,0.43,50,27966,75,NULL,'MAT, I, cor','ESO 437- G 056',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74060,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74060,33.65,0.47,53.7,27966,NULL,NULL,'H','ESO 437- G 056',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74061,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74061,33.69,0.46,54.6,27966,NULL,NULL,'J','ESO 437- G 056',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74062,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74062,33.69,NULL,54.7,27966,NULL,NULL,'B','ESO 437- G 056',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74063,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74063,33.71,0.45,55.3,27966,NULL,NULL,'K','ESO 437- G 056',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74064,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74064,37.29,0.46,287,27967,70,NULL,NULL,'2MASX J10442470+4931305',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000141,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,161.1032083,49.52539,0,NULL,63906227495,998534804,15602106,17.8),(74065,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74065,34.24,0.48,70.6,27968,70,NULL,NULL,'ESO 501- G 089',NULL,'2014MNRAS.445.2677S',2014,1,1,'A-M -1m25s RA error.','G',0.00013,NULL,'13.67',0.8,'E2',NULL,NULL,NULL,NULL,1,161.107917,-25.37708,0.273,NULL,41528548802,648883575,10138805,13.67),(74066,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74066,37.7,0.46,347,27969,70,NULL,NULL,'2MASX J10442609+3901065',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,161.108667,39.01861,0,NULL,64122497576,1001914024,15654906,17),(74067,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74067,35.75,0.49,141,27970,70,NULL,NULL,'2MASX J10442687-0854004',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000127,NULL,'14.95',NULL,NULL,NULL,NULL,NULL,NULL,1,161.112083,-8.90031,0.037,NULL,41793403244,653021925,10203467,14.95),(74068,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74068,37.95,0.46,388,27971,70,NULL,NULL,'SDSS J104428.64+575137.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000134,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,161.119375,57.86044,0,NULL,62004274862,968816794,15137762,18.3),(74069,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74069,37.45,0.46,309,27972,70,NULL,NULL,'SDSS J104429.00+090653.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000138,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,161.120875,9.11489,0.153,NULL,61054957336,953983708,14905995,18),(74070,'IRAS','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74070,32.28,0.8,28.6,27973,75,NULL,'MAT, I','NGC 3361',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000017,NULL,'13.43',1.2,'SAB(rs)c?      HII',NULL,NULL,NULL,NULL,1,161.1215417,-11.20792,0.101,NULL,41763661980,652557218,10196206,13.43),(74071,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74071,32.13,0.43,26.6,27973,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3361',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74072,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74072,32.14,0.43,26.8,27973,75,NULL,'3.6 micron, color corrected','NGC 3361',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74073,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74073,32.15,0.32,26.9,27973,85,NULL,'I, raw','NGC 3361',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74074,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74074,32.16,0.32,27.1,27973,85,NULL,'I, inv','NGC 3361',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74075,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74075,32.17,0.2,27.2,27973,74.4,NULL,NULL,'NGC 3361',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74076,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74076,32.2,0.64,27.5,27973,NULL,NULL,'Malmquist cor.','NGC 3361',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74077,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74077,32.34,0.6,29.4,27973,NULL,NULL,NULL,'NGC 3361',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74078,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74078,32.35,0.43,29.6,27973,75,NULL,'MAT, I, raw','NGC 3361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74079,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74079,32.47,0.43,31.1,27973,75,NULL,'MAT, I, inv','NGC 3361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74080,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74080,32.62,0.43,33.4,27973,75,NULL,'MAT, I, cor','NGC 3361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74081,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74081,32.63,0.4,33.6,27973,NULL,NULL,'mean','NGC 3361',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74082,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74082,32.66,0.46,34,27973,NULL,NULL,'J','NGC 3361',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74083,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74083,32.66,0.47,34.1,27973,NULL,NULL,'H','NGC 3361',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74084,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74084,32.74,0.45,35.3,27973,NULL,NULL,'K','NGC 3361',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74085,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74085,31.42,0.4,19.3,27974,75,NULL,'B','UGC 05846',NULL,'1988NBGC.C....0000T',1988,1,1.7,'Two entries in MCG for this object.','G',0.000003,NULL,'15.2',1,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,161.122917,60.36778,0,NULL,61957743770,968089746,15126402,15.2),(74086,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74086,34.37,0.33,74.9,27975,70,NULL,NULL,'CGCG 124-063',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000183,NULL,'14.9',0.25,NULL,NULL,NULL,NULL,NULL,1,161.124417,21.71533,0,NULL,60973722749,952714417,14886162,14.9),(74087,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74087,35.92,0.46,153,27976,70,NULL,NULL,'2MASX J10443006+4413202',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000162,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,161.125166667,44.22236,0,NULL,64131546378,1002055412,15657115,16.2),(74088,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74088,37.56,0.46,325,27977,70,NULL,NULL,'2MASX J10443038+1554521',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000187,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,161.126583,15.91431,0.069,NULL,61180657701,955947776,14936684,16.9),(74089,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74089,35.63,0.47,134,27978,70,NULL,NULL,'MCG -02-28-005',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000143,NULL,'15.32',0.3,NULL,NULL,NULL,NULL,NULL,1,161.127917,-14.31469,0.169,NULL,41836260688,653691573,10213930,15.32),(74090,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74090,37.38,0.46,299,27979,70,NULL,NULL,'2MASX J10443083+1658021',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.53',0.17,NULL,NULL,NULL,NULL,NULL,1,161.128333,16.96731,0.021,NULL,61178756031,955918062,14936219,18.53),(74091,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74091,37.37,0.46,298,27980,70,NULL,NULL,'2MASX J10443086+4155082',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,161.128375,41.91889,0,NULL,64113632702,1001775510,15652742,18.1),(74092,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74092,37.28,0.33,285,27981,70,NULL,NULL,'2MASX J10443101+0221587',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000114,NULL,'15.5g',0.53,'E0',NULL,NULL,NULL,NULL,1,161.12925,2.36636,0.069,NULL,60280119267,941876863,14716825,15.5),(74093,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74093,37.86,0.46,373,27982,70,NULL,NULL,'2MASX J10443329+1842279',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.69',0.14,NULL,NULL,NULL,NULL,NULL,1,161.138875,18.70767,0.041,NULL,60976968187,952765127,14886955,18.69),(74094,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74094,37.05,0.46,257,27983,70,NULL,NULL,'2MASX J10443343+1839489',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.04',0.19,NULL,NULL,NULL,NULL,NULL,1,161.139416667,18.66369,0.041,NULL,60976967455,952765116,14886954,18.04),(74095,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74095,36.53,0.33,202,27984,70,NULL,NULL,'2MASX J10443397+0844153',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000181,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,161.141667,8.7375,0.101,NULL,61066410760,954162668,14908791,16.3),(74096,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74096,36.54,0.33,203,27985,70,NULL,NULL,'2MASX J10443576+1117458',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.00011,NULL,'15.2g',0.58,'E0',NULL,NULL,NULL,NULL,1,161.149208333,11.29614,0.041,NULL,61044811636,953825181,14903518,15.2),(74097,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74097,34.59,0.49,82.9,27986,75,NULL,'IR','UGC 05855',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.00005,NULL,'14.4g',0.43,'S?',NULL,NULL,NULL,NULL,1,161.1539583,26.18169,0.045,NULL,60527865475,945747898,14777310,14.4),(74098,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74098,34.8,0.28,91.3,27986,NULL,NULL,'Malmquist cor.','UGC 05855',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74099,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74099,34.83,0.2,92.5,27986,74.4,NULL,NULL,'UGC 05855',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74100,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74100,34.85,0.28,93.1,27986,NULL,NULL,NULL,'UGC 05855',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74101,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74101,36.22,0.46,175,27987,70,NULL,NULL,'2MASX J10443793+2028419',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'16.43',0.2,NULL,NULL,NULL,NULL,NULL,1,161.158,20.47828,0.009,NULL,60979900547,952810946,14887671,16.43),(74102,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:48','1','PS1 SN PS10r',NULL,74102,38.62,0.11,473,27988,73.8,NULL,'SALT 2 (SNANA)','SDSS J104438.19+574839.8',0.1188,'2014ApJ...795...44R',2014,1,0.15,NULL,'G',0.000141,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,161.159125,57.81106,0,NULL,62004273392,968816771,15137762,18.4),(74103,'Tully est','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74103,32.41,0.8,30.3,27989,75,NULL,'B','NGC 3329',NULL,'1988NBGC.C....0000T',1988,1,1.8,NULL,'G',0.000083,NULL,'12.96',1,'(R)SA(r)b:','Brightest group member',NULL,NULL,NULL,1,161.1640417,76.80944,0.037,NULL,61362359521,958786867,14981044,12.96),(74104,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74104,33.17,0.43,43.1,27989,75,NULL,'3.6 micron, color corrected','NGC 3329',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74105,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74105,33.18,0.2,43.3,27989,74.4,NULL,NULL,'NGC 3329',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74106,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74106,33.27,0.43,45,27989,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3329',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74107,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74107,37.16,0.46,270,27990,70,NULL,NULL,'2MASX J10444022+0133538',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000088,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,161.167667,1.56486,0.073,NULL,60279946691,941874167,14716783,17.3),(74108,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74108,37.36,0.46,296,27991,70,NULL,NULL,'SDSS J104441.96+033956.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000135,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,161.174833,3.66564,0.081,NULL,60273805170,941778205,14715284,18),(74109,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74109,36.91,0.46,241,27992,70,NULL,NULL,'2MASX J10444339+4414245',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,161.180667,44.24031,0,NULL,64131536075,1002055251,15657113,17.3),(74110,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74110,37.13,0.33,267,27993,70,NULL,NULL,'2MASX J10444462+5239361',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00017,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,161.185666667,52.66011,0,NULL,61958701471,968104710,15126636,16.7),(74111,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74111,36.54,0.33,203,27994,70,NULL,NULL,'2MASX J10444515+1119358',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000182,NULL,'15.9g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,161.18825,11.32672,0.041,NULL,61044780844,953824700,14903510,15.9),(74112,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74112,37.76,0.46,356,27995,70,NULL,NULL,'2MASX J10444542+0220132',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000072,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,161.189417,2.33706,0.069,NULL,60280129137,941877017,14716828,17.8),(74113,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74113,37.92,0.33,384,27996,70,NULL,NULL,'2MASX J10444619+0936498',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000183,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,161.192375,9.61378,0.057,NULL,61056399387,954006240,14906347,17.6),(74114,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74114,36.58,0.46,207,27997,70,NULL,NULL,'2MASX J10444666+3843555',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000186,NULL,'16.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,161.194375,38.73203,0,NULL,64122385824,1001912278,15654879,16.1),(74115,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74115,32.12,1.63,26.6,27998,NULL,NULL,'Malmquist cor.','UGC 05858',NULL,'2009ApJS..182..474S',2009,1,0.79,NULL,'G',0.000017,NULL,'15.6g',0.63,'Sdm','Isolated galaxy',NULL,NULL,NULL,1,161.204333,15.95169,0.069,NULL,61180632097,955947376,14936677,15.6),(74116,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74116,32.79,1.2,36.2,27998,NULL,NULL,NULL,'UGC 05858',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74117,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74117,36.01,0.53,159,27999,70,NULL,NULL,'2MASX J10444974-1607282',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.02',NULL,NULL,NULL,NULL,NULL,NULL,1,161.207375,-16.12464,0.125,NULL,41831397508,653615586,10212743,16.02),(74118,'GRB','2016-12-15 15:14:41','2016-12-16 11:19:48','1','SN 2003dh','R',74118,39.47,0.15,671,28000,69.7,NULL,'Calibrated','HG 030329',0.168,'2010JCAP...08..020W',2010,1,NULL,NULL,'G',NULL,NULL,'13  R',NULL,NULL,NULL,NULL,NULL,NULL,1,161.208125,21.52147,0.009,NULL,60981160098,952830626,14887978,13),(74119,'GRB','2016-12-15 15:14:41','2016-12-16 11:19:48','1','SN 2003dh',NULL,74119,39.73,0.29,756,28000,69.7,NULL,'Calibrated','HG 030329',0.168,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74120,'GRB','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74120,39.48,0.04,787,28000,NULL,NULL,NULL,'HG 030329',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74121,'GRB','2016-12-15 15:14:41','2016-12-16 11:19:48','1','SN 2003dh',NULL,74121,39.88,0.38,810,28000,70,NULL,NULL,'HG 030329',0.168,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74122,'GRB','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74122,39.61,0.17,836,28000,NULL,NULL,NULL,'HG 030329',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74123,'GRB','2016-12-15 15:14:41','2016-12-16 11:19:48','1','SN 2003dh','R',74123,39.97,0.41,844,28000,72,NULL,NULL,'HG 030329',0.168,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74124,'GRB','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74124,39.79,NULL,907,28000,70,NULL,'Pseudo z = 0.24','GRB 030329',NULL,'2004AIPC..727...37A',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74125,'GRB','2016-12-15 15:14:41','2016-12-16 11:19:48','1','SN 2003dh',NULL,74125,40.56,0.42,1110,28000,69.7,NULL,'Fiducial','HG 030329',0.168,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74126,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74126,36.1,0.51,166,28001,70,NULL,NULL,'2MASX J10445096-4654009',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'12.2J',NULL,NULL,NULL,NULL,NULL,NULL,1,161.2122917,-46.90022,0.817,NULL,42101278968,657832483,10278632,12.2),(74127,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74127,37.45,0.27,309,28002,70,NULL,NULL,'2MASX J10445140+0028232',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000072,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,161.2140417,0.47289,0.057,NULL,60271099649,941735932,14714623,17.7),(74128,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74128,34.8,0.47,91.2,28003,NULL,NULL,'H','NGC 3362',NULL,'2007A&A...465...71T',2007,1,1.27,NULL,'G',0.000143,NULL,'13.7g',1.14,'SABc           Sy2','in a radial-velocity based grouping',NULL,NULL,'Sy 2',1,161.2155,6.59672,0.049,NULL,61064742614,954136603,14908384,13.7),(74129,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74129,34.96,0.45,98.1,28003,NULL,NULL,'K','NGC 3362',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74130,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74130,34.96,0.46,98.1,28003,NULL,NULL,'J','NGC 3362',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74131,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74131,35.37,0.4,119,28003,NULL,NULL,'mean','NGC 3362',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74132,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74132,38.15,0.27,426,28004,70,NULL,NULL,'2MASX J10445224+4457065',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,161.2177083,44.95189,0,NULL,64131577682,1002055901,15657123,17.5),(74133,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74133,37.22,0.46,278,28005,70,NULL,NULL,'2MASX J10445293+3359350',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,161.220375,33.99308,0,NULL,64052752118,1000824251,15637878,17.2),(74134,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74134,35.69,0.67,137,28006,70,NULL,NULL,'2MASX J10445515-4645089',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,161.229917,-46.75258,0.817,NULL,42101366831,657833856,10278654,16.6),(74135,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74135,38.1,0.46,416,28007,70,NULL,NULL,'2MASX J10445700+3939555',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000188,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,161.2375,39.66558,0,NULL,64121969539,1001905774,15654777,16.8),(74136,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74136,30.27,NULL,11.3,28008,NULL,NULL,NULL,'SDSS J104457.30+115459.0',NULL,'2015AstBu..70....1K',2015,1,0.3,NULL,'G',0.00004,NULL,'17.43',0.1,'dE/ImV','Group member',NULL,NULL,NULL,1,161.2392083,11.91683,0.045,NULL,61174070311,955844848,14935075,17.43),(74137,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74137,33.55,NULL,51.2,28009,NULL,NULL,NULL,'SDSS J1044+0353',NULL,'2014A&A...562A..49M',2014,1,0.18,NULL,'G',0.000003,NULL,'17.5g',0.12,'HII',NULL,NULL,NULL,NULL,1,161.240833,3.88697,0.081,NULL,60273963797,941780684,14715323,17.5),(74138,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74138,35.27,0.46,113,28010,70,NULL,NULL,'CGCG 184-010',NULL,'2015arXiv151105856S',2015,1,1.03,NULL,'G',0.000083,NULL,'15.0g',0.34,'AGN',NULL,NULL,NULL,NULL,1,161.245125,37.138,0,NULL,64108031047,1001687985,15651374,15),(74139,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74139,37.35,0.46,296,28011,70,NULL,NULL,'2MASX J10445907+3524228',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,161.24625,35.40642,0.033,NULL,64040118877,1000626857,15634794,17.9),(74140,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74140,38.15,0.27,426,28012,70,NULL,NULL,'2MASX J10445911+4455154',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,161.246375,44.92114,0,NULL,64131573734,1002055839,15657122,17),(74141,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74141,37.45,0.27,309,28013,70,NULL,NULL,'2MASX J10445913+0034392',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000083,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,161.2464583,0.57758,0.057,NULL,60271072573,941735508,14714617,17.1),(74142,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74142,34.96,0.51,98.2,28014,70,NULL,NULL,'2MASX J10445969-4626149',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000143,NULL,'11.9J',NULL,NULL,NULL,NULL,NULL,NULL,1,161.248708333,-46.43742,0.757,NULL,42101147336,657830427,10278600,11.9),(74143,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74143,36.63,0.33,212,28015,70,NULL,NULL,'2MASX J10445988+0823108',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000191,NULL,'16.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,161.249583,8.38633,0.085,NULL,61066742361,954167849,14908872,16.3),(74144,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74144,37.44,0.33,307,28016,70,NULL,NULL,'SDSS J104500.75+032625.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000139,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,161.253167,3.44053,0.077,NULL,60274036349,941781817,14715340,18.1),(74145,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74145,37.44,0.33,307,28017,70,NULL,NULL,'SDSS J104502.03+032744.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,161.2585,3.46236,0.077,NULL,60274036621,941781822,14715340,17.8),(74146,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74146,38.33,0.46,463,28018,70,NULL,NULL,'2MASX J10450254+0447452',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000178,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,161.260625,4.79608,0.033,NULL,61009676923,953276201,14894940,17.5),(74147,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74147,37.34,0.46,294,28019,70,NULL,NULL,'2MASX J10450284+3637375',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,161.261875,36.62719,0,NULL,64108075279,1001688676,15651385,17),(74148,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74148,35.75,0.19,141,28020,70,NULL,NULL,'2MASX J10450318+1404499',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000166,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,161.263375,14.08039,0.049,NULL,61175853794,955872715,14935511,16.7),(74149,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74149,36.81,0.46,231,28021,70,NULL,NULL,'2MASX J10450401+1337289',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000166,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,161.2667083,13.62478,0.053,NULL,61175669183,955869830,14935466,16.5),(74150,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74150,36.13,0.46,168,28022,70,NULL,NULL,'2MASX J10450464+0219082',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000073,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,161.269375,2.31883,0.069,NULL,60280218379,941878412,14716850,16.3),(74151,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74151,36.53,0.33,202,28023,70,NULL,NULL,'2MASX J10450476+0838077',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000182,NULL,'16.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,161.2699583,8.63547,0.093,NULL,61066358574,954161852,14908778,16.1),(74152,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74152,36.77,0.46,226,28024,70,NULL,NULL,'2MASX J10450624+4616304',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00017,NULL,'15.8g',0.49,'E0',NULL,NULL,NULL,NULL,1,161.27575,46.27514,0,NULL,64132655147,1002072736,15657386,15.8),(74153,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74153,37.51,0.46,318,28025,70,NULL,NULL,'2MASX J10450626+2833390',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,161.2762083,28.56078,0.018,NULL,60530405851,945787591,14777931,17.3),(74154,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74154,34.6,NULL,83.1,28026,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05861',NULL,'2010Ap&SS.325..163P',2010,1,1.45,NULL,'G',0.0001,NULL,'15.8g',0.22,'Sbc',NULL,NULL,NULL,NULL,1,161.276583,38.98386,0,NULL,64122516456,1001914319,15654911,15.8),(74155,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74155,34.61,NULL,83.4,28026,NULL,NULL,'Dipole','UGC 05861',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74156,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74156,34.61,NULL,83.5,28026,NULL,NULL,'Dipole + Quadrupole','UGC 05861',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74157,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74157,34.65,0.49,85.1,28026,75,NULL,'IR','UGC 05861',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74158,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74158,34.66,NULL,85.3,28026,NULL,NULL,NULL,'UGC 05861',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74159,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74159,37.68,0.46,344,28027,70,NULL,NULL,'2MASX J10450645+0940047',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000179,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,161.276917,9.66797,0.057,NULL,61056407940,954006374,14906349,17.7),(74160,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74160,36.12,0.46,167,28028,70,NULL,NULL,'2MASX J10450719+3919526',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000177,NULL,'15.8g',0.41,'E0',NULL,NULL,NULL,NULL,1,161.279875,39.33133,0,NULL,64121815599,1001903368,15654740,15.8),(74161,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74161,37.08,0.46,261,28029,70,NULL,NULL,'2MASX J10450817+4057545',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,161.2839583,40.96519,0,NULL,64111370063,1001740157,15652189,17.8),(74162,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74162,37.99,0.46,396,28030,70,NULL,NULL,'2MASX J10450914+2201495',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,161.2882083,22.0305,0,NULL,60974093278,952720207,14886253,18.3),(74163,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:48','1','PS1 SN PS10ir','N',74163,40.59,0.11,1050,28031,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10ir HOST',0.2505,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74164,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74164,34.77,0.4,89.8,28032,NULL,NULL,'mean','NGC 3363',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000033,NULL,'14.34',0.8,'S?',NULL,NULL,NULL,NULL,1,161.289417,22.0785,0,NULL,60974079613,952719993,14886249,14.34),(74165,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74165,34.93,0.45,96.8,28032,NULL,NULL,'K','NGC 3363',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74166,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74166,34.97,0.47,98.8,28032,NULL,NULL,'H','NGC 3363',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74167,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74167,35.04,0.46,102,28032,NULL,NULL,'J','NGC 3363',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74168,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74168,36.95,0.46,245,28033,70,NULL,NULL,'2MASX J10451045+3959545',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,161.293375,39.99861,0,NULL,64118889624,1001857650,15654025,17.4),(74169,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74169,35.71,0.46,139,28034,70,NULL,NULL,'CGCG 154-046',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000133,NULL,'15.4g',0.44,NULL,NULL,NULL,NULL,NULL,1,161.30025,27.99956,0.01,NULL,60531617288,945806520,14778226,15.4),(74170,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74170,36.72,0.8,221,28035,70,NULL,NULL,'2MASX J10451249-0757453',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.38',0.3,NULL,NULL,NULL,NULL,NULL,1,161.3020417,-7.96264,0.057,NULL,41807198496,653237476,10206835,16.38),(74171,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74171,37.32,0.46,291,28036,70,NULL,NULL,'2MASX J10451425+4022375',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000175,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,161.3095417,40.37717,0,NULL,64111303619,1001739119,15652173,16.8),(74172,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:48','1','PS1 SN PS10ik','N',74172,40.32,0.15,941,28037,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10ik HOST',0.2305,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74173,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74173,37.32,0.46,292,28038,70,NULL,NULL,'2MASX J10451621+2839290',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,161.3177083,28.65814,0.026,NULL,60530396434,945787444,14777928,17.1),(74174,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74174,37.45,0.27,309,28039,70,NULL,NULL,'2MASX J10451726+0038503',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000087,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,161.321916667,0.64719,0.057,NULL,60271070172,941735471,14714616,16.9),(74175,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74175,34.45,0.49,77.8,28040,75,NULL,'IR','FGC 1130',NULL,'2011yCatp016004901K',2011,1,1.61,NULL,'G',0.000027,NULL,'16.1',0.1,'Sd             HII',NULL,NULL,NULL,NULL,1,161.322791667,-8.85094,0.049,NULL,41793512638,653023634,10203494,16.1),(74176,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74176,34.59,NULL,82.9,28040,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1130',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74177,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74177,34.61,NULL,83.4,28040,NULL,NULL,'Dipole + Quadrupole','FGC 1130',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74178,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74178,34.61,NULL,83.6,28040,NULL,NULL,'Dipole','FGC 1130',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74179,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74179,34.66,NULL,85.5,28040,NULL,NULL,NULL,'FGC 1130',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74180,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74180,37.61,0.46,333,28041,70,NULL,NULL,'2MASX J10451987+2353195',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,161.3330417,23.88878,0.045,NULL,60973370951,952708921,14886076,17.3),(74181,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74181,37.84,0.46,370,28042,70,NULL,NULL,'SDSS J104519.99+264923.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000164,NULL,'18.3g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,161.333333,26.82319,0.045,NULL,60525123351,945705052,14776641,18.3),(74182,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74182,33.89,NULL,59.9,28043,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 569- G 003',NULL,'2010Ap&SS.325..163P',2010,1,1.59,NULL,'G',0.000017,NULL,'15.81',0.22,'Sdm',NULL,NULL,NULL,NULL,1,161.336,-22.66167,0.193,NULL,41635886075,650560719,10165011,15.81),(74183,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74183,33.9,NULL,60.2,28043,NULL,NULL,'Dipole + Quadrupole','ESO 569- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74184,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74184,33.91,NULL,60.5,28043,NULL,NULL,'Dipole','ESO 569- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74185,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74185,33.99,NULL,62.9,28043,NULL,NULL,NULL,'ESO 569- G 003',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74186,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74186,37.17,0.33,272,28044,70,NULL,NULL,'2MASX J10452105+2006015',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.15',0.16,NULL,NULL,NULL,NULL,NULL,1,161.337833,20.10031,0.009,NULL,60980388516,952818570,14887790,18.15),(74187,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74187,38.29,0.46,454,28045,70,NULL,NULL,'2MASX J10452159+5357113',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000176,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,161.340083,53.95322,0,NULL,61961456401,968147756,15127308,17.2),(74188,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74188,38.15,0.27,426,28046,70,NULL,NULL,'SDSS J104521.88+445957.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,161.3412083,44.99933,0,NULL,64131708278,1002057941,15657155,18),(74189,'Tully est','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74189,31.13,0.8,16.8,28047,75,NULL,'B','NGC 3353',NULL,'1988NBGC.C....0000T',1988,1,1.2,NULL,'G',0.000017,NULL,'13.2g',0.83,'BCD/Irr        HII','X-ray-faint group member',NULL,NULL,'H II',1,161.343375,55.96039,0,NULL,61969474682,968273041,15129266,13.2),(74190,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74190,31.29,0.4,18.1,28047,NULL,NULL,'mean','NGC 3353',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74191,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74191,31.42,0.47,19.3,28047,NULL,NULL,'H','NGC 3353',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74192,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74192,31.51,0.46,20.1,28047,NULL,NULL,'J','NGC 3353',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74193,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74193,31.55,0.45,20.4,28047,NULL,NULL,'K','NGC 3353',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74194,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74194,37.89,0.46,378,28048,70,NULL,NULL,'2MASX J10452286+2658170',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000174,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,161.345375,26.9715,0.035,NULL,60529588742,945774824,14777731,16.7),(74195,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74195,36.08,0.46,165,28049,70,NULL,NULL,'2MASX J10452431+5156162',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00014,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,161.3512917,51.93783,0,NULL,61774664845,965229138,15081705,16.5),(74196,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:48','1','PS1 SN PS11uo','N',74196,41.11,0.12,1270,28050,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11uo HOST',0.3105,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74197,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74197,35.71,0.69,138,28051,70,NULL,NULL,'2MASX J10452591-1619172',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.07',NULL,NULL,NULL,NULL,NULL,NULL,1,161.357917,-16.3215,0.121,NULL,41861569125,654087017,10220109,16.07),(74198,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74198,37.69,0.46,345,28052,70,NULL,NULL,'2MASX J10452694+4124468',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00018,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,161.362167,41.41322,0,NULL,64113685489,1001776335,15652755,16.8),(74199,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74199,37.17,0.33,272,28053,70,NULL,NULL,'2MASX J10452802+2024185',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,161.366833333,20.40517,0.017,NULL,60979736625,952808384,14887631,17.1),(74200,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74200,37.08,0.46,260,28054,70,NULL,NULL,'2MASX J10452839+4540421',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.0002,NULL,'15.9g',0.37,'E/S0',NULL,NULL,NULL,NULL,1,161.3682083,45.67836,0,NULL,64134836929,1002106827,15657919,15.9),(74201,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74201,36.92,0.46,242,28055,70,NULL,NULL,'2MASX J10452845+3049227',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000168,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,161.368417,30.82297,0,NULL,60506177825,945409028,14772016,16.4),(74202,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74202,36.68,0.33,217,28056,70,NULL,NULL,'2MASX J10453051-0015280',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00009,NULL,'16.3g',0.33,'E/S0',NULL,NULL,NULL,NULL,1,161.377041667,-0.25792,0.069,NULL,40879465808,638741653,9980338,16.3),(74203,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74203,37.25,0.46,282,28057,70,NULL,NULL,'2MASX J10453060+1419508',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000152,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,161.377417,14.33092,0.061,NULL,61175153004,955861765,14935340,17.1),(74204,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74204,34.88,0.4,94.7,28058,NULL,NULL,'mean','CGCG 125-004',NULL,'2007A&A...465...71T',2007,1,0.7,NULL,'G',0.00005,NULL,'15.2',0.25,'HII',NULL,NULL,NULL,NULL,1,161.384625,24.15003,0.033,NULL,60490730999,945167671,14768244,15.2),(74205,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74205,35.18,0.47,109,28058,NULL,NULL,'H','CGCG 125-004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74206,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74206,36.82,0.46,231,28059,70,NULL,NULL,'2MASX J10453274+0017313',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000069,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,161.3865,0.29194,0.057,NULL,60270525200,941726956,14714483,17.3),(74207,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74207,37.95,0.46,389,28060,70,NULL,NULL,'2MASX J10453696+5939554',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,161.403833333,59.66547,0,NULL,61954993796,968046778,15125730,17.5),(74208,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74208,37.61,0.46,332,28061,70,NULL,NULL,'2MASX J10454142-0031093',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000077,NULL,'17.1g',0.23,'Sb-Sc',NULL,NULL,NULL,NULL,1,161.422666667,-0.51925,0.089,NULL,40879550559,638742977,9980359,17.1),(74209,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74209,34.81,0.52,91.4,28062,NULL,NULL,NULL,'UGC 05869',NULL,'2009ApJS..182..474S',2009,1,1.18,NULL,'G',0.00002,NULL,'14.7g',0.71,'SAB(rs)b:',NULL,NULL,NULL,NULL,1,161.427833,11.34417,0.045,NULL,61044059604,953813431,14903334,14.7),(74210,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74210,34.85,0.2,93.3,28062,74.4,NULL,NULL,'UGC 05869',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74211,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74211,34.88,0.51,94.6,28062,NULL,NULL,'Malmquist cor.','UGC 05869',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74212,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74212,38.39,0.46,476,28063,70,NULL,NULL,'2MASX J10454280+4209371',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,161.4285,42.16025,0,NULL,64110224442,1001722256,15651910,18),(74213,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74213,38.13,0.46,422,28064,70,NULL,NULL,'2MASX J10454291+1417478',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,161.428833333,14.29672,0.061,NULL,61175168941,955862014,14935343,17.9),(74214,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74214,34.85,0.57,93.3,28065,70,NULL,NULL,'2MASX J10454300-1615392',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.72',NULL,NULL,NULL,NULL,NULL,NULL,1,161.428875,-16.26131,0.121,NULL,41861554526,654086789,10220106,15.72),(74215,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74215,36.59,0.33,208,28066,70,NULL,NULL,'2MASX J10454333+2152015',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'16.61',0.22,NULL,NULL,NULL,NULL,NULL,1,161.430583,21.86714,0,NULL,60981582901,952837232,14888081,16.61),(74216,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74216,36.69,0.46,217,28067,70,NULL,NULL,'2MASX J10454657+4629030',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00019,NULL,'16.0g',0.32,'S0^-',NULL,NULL,NULL,NULL,1,161.4439583,46.48431,0,NULL,64132564615,1002071322,15657364,16),(74217,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74217,37.19,0.46,274,28068,70,NULL,NULL,'2MASX J10454753+4610240',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000132,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,161.4482083,46.17344,0,NULL,64132702513,1002073476,15657398,17.8),(74218,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74218,37.06,0.46,259,28069,70,NULL,NULL,'2MASX J10454801+2226165',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.32',0.14,NULL,NULL,NULL,NULL,NULL,1,161.450083333,22.43797,0,NULL,60974014720,952718980,14886234,18.32),(74219,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74219,37.59,0.46,330,28070,70,NULL,NULL,'2MASX J10454812-0113213',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000086,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,161.4505417,-1.22261,0.133,NULL,40879035113,638734923,9980233,16.7),(74220,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74220,36.58,0.46,207,28071,70,NULL,NULL,'2MASX J10454974+1841196',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.99',0.18,NULL,NULL,NULL,NULL,NULL,1,161.457208333,18.68889,0.041,NULL,60976918844,952764356,14886943,17.99),(74221,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74221,37.67,0.46,342,28072,70,NULL,NULL,'2MASX J10455021+0027350',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000098,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,161.459167,0.45964,0.057,NULL,60270405555,941725086,14714454,16.6),(74222,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,NULL,74222,35.9,0.2,151,28073,74.4,NULL,NULL,'CGCG 066-009',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000012,NULL,'15.4g',0.38,'Sc',NULL,NULL,NULL,NULL,1,161.46425,9.72261,0.061,NULL,61056358688,954005604,14906337,15.4),(74223,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74223,38.06,0.15,409,28074,70,NULL,NULL,'2MASX J10455161+0125520',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000092,NULL,'16.8g',0.35,NULL,NULL,NULL,NULL,NULL,1,161.465125,1.43108,0.085,NULL,60278759455,941855616,14716494,16.8),(74224,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74224,37.14,0.46,267,28075,70,NULL,NULL,'2MASX J10455199+2904552',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.4g',0.21,'E',NULL,NULL,NULL,NULL,1,161.466625,29.08208,0.009,NULL,60522615418,945665865,14776029,17.4),(74225,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74225,35.15,0.46,107,28076,70,NULL,NULL,'CGCG 125-005',NULL,'2015arXiv151105856S',2015,1,1.13,NULL,'G',0.000157,NULL,'14.4g',0.7,NULL,NULL,NULL,NULL,NULL,1,161.467791667,25.95158,0.033,NULL,60525529667,945711401,14776740,14.4),(74226,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74226,37.01,0.46,252,28077,70,NULL,NULL,'2MASX J10455258+4533353',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000188,NULL,'16.0g',0.4,'E0',NULL,NULL,NULL,NULL,1,161.4692083,45.55992,0.005,NULL,64134802104,1002106282,15657910,16),(74227,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74227,37.09,0.46,262,28078,70,NULL,NULL,'2MASX J10455369+1448218',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,161.473875,14.80603,0.041,NULL,61174982634,955859103,14935298,17.3),(74228,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74228,36.97,0.46,248,28079,70,NULL,NULL,'2MASX J10455435+0036090',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000082,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,161.4764583,0.60239,0.057,NULL,60270899911,941732811,14714575,16.6),(74229,'FP','2016-12-15 15:14:41','2016-12-16 11:19:48','1',NULL,'R',74229,36.63,0.33,212,28080,70,NULL,NULL,'2MASX J10455451+0837037',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'16.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,161.47725,8.61778,0.085,NULL,61066898521,954170289,14908910,16.9),(74230,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74230,36.59,0.33,208,28081,70,NULL,NULL,'2MASX J10455518+2149165',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'16.86',0.19,NULL,NULL,NULL,NULL,NULL,1,161.48,21.82142,0,NULL,60981579785,952837184,14888081,16.86),(74231,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74231,36.08,0.72,164,28082,70,NULL,NULL,'2MASX J10455576-1943066',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.7b',NULL,'E',NULL,NULL,NULL,NULL,1,161.482375,-19.71853,0.093,NULL,41632324607,650505071,10164141,16.7),(74232,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74232,37.13,0.46,266,28083,70,NULL,NULL,'2MASX J10455721+1643265',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,161.4885,16.72403,0.025,NULL,61190216409,956097131,14939017,16.9),(74233,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74233,36.92,0.46,242,28084,70,NULL,NULL,'2MASX J10455768+1532155',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,161.4904583,15.53769,0.069,NULL,61187749027,956058578,14938415,17.5),(74234,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74234,36.85,0.46,234,28085,70,NULL,NULL,'2MASX J10460043+4835554',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000124,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,161.50175,48.59878,0,NULL,63905644712,998525698,15601964,17),(74235,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74235,38.06,0.15,409,28086,70,NULL,NULL,'2MASX J10460301+0125320',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000073,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,161.512625,1.42547,0.061,NULL,60278709721,941854839,14716481,17.4),(74236,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74236,38.5,0.46,502,28087,70,NULL,NULL,'2MASX J10460318+0602210',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000125,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,161.513333,6.03908,0.053,NULL,61061242040,954081906,14907529,17.6),(74237,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74237,35.73,0.27,140,28088,70,NULL,NULL,'CGCG 212-050',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00008,NULL,'15.0g',0.48,'E0',NULL,NULL,NULL,NULL,1,161.513333,39.14936,0,NULL,64122417396,1001912771,15654887,15),(74238,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74238,37.5,0.23,317,28089,70,NULL,NULL,'2MASX J10460356+1607365',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000173,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,161.514875,16.12675,0.045,NULL,61188330448,956067663,14938557,16.8),(74239,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74239,33.86,0.62,59.2,28090,70,NULL,NULL,'ESO 264- G 039',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00015,NULL,'14.30',1.3,'(R\')SB(rs)a',NULL,NULL,NULL,NULL,1,161.5207083,-45.32733,0.669,NULL,42101741980,657839718,10278745,14.3),(74240,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74240,37.89,0.46,378,28091,70,NULL,NULL,'2MASX J10460537+3724200',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000179,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,161.5225,37.40553,0,NULL,64108444888,1001694451,15651475,16.8),(74241,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74241,36.74,0.46,223,28092,70,NULL,NULL,'2MASX J10460633+1643345',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000169,NULL,'16.2g',0.43,NULL,NULL,NULL,NULL,NULL,1,161.5264583,16.72619,0.025,NULL,61190225702,956097276,14939019,16.2),(74242,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74242,36.34,0.33,186,28093,70,NULL,NULL,'MCG +08-20-019',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000157,NULL,'15.4g',0.39,'AGN+SF',NULL,NULL,NULL,NULL,1,161.53025,44.72469,0,NULL,64131719121,1002058111,15657157,15.4),(74243,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74243,38.06,0.15,409,28094,70,NULL,NULL,'SDSS J104607.38+013309.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000057,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,161.5307917,1.55258,0.077,NULL,60279815938,941872124,14716751,18.7),(74244,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74244,36.36,0.46,187,28095,70,NULL,NULL,'2MASX J10460754+6643322',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000074,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,161.53175,66.72575,0.025,NULL,62130799770,970793746,15168652,16.7),(74245,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74245,37.09,0.46,262,28096,70,NULL,NULL,'2MASX J10460798+1313115',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000193,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,161.533333,13.21992,0.041,NULL,61177602188,955900034,14935938,16.6),(74246,'IRAS','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74246,35.62,0.8,133,28097,75,NULL,'CF, r','UGC 05872',NULL,'1997ApJS..109..333W',1997,1,1.16,NULL,'G',0.000101,NULL,'15.1g',0.39,'Sbc',NULL,NULL,NULL,NULL,1,161.539625,49.54358,0,NULL,63906169754,998533902,15602092,15.1),(74247,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74247,35.03,0.38,101,28097,75,NULL,'CF, r, raw','UGC 05872',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74248,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74248,35.17,0.38,108,28097,75,NULL,'CF, r, inv','UGC 05872',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74249,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74249,35.27,0.38,113,28097,75,NULL,'CF, r, cor','UGC 05872',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74250,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74250,38.41,0.46,481,28098,70,NULL,NULL,'SDSS J104610.54+174918.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,161.5439583,17.82186,0.033,NULL,61186675755,956041808,14938153,18.1),(74251,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74251,35.41,0.46,121,28099,70,NULL,NULL,'2MASX J10461124+1516175',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000142,NULL,'16.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,161.546958333,15.27167,0.053,NULL,61187599747,956056246,14938378,16.4),(74252,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74252,38.07,0.19,411,28100,70,NULL,NULL,'2MASX J10461173+4503254',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000141,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,161.54875,45.05714,0,NULL,64131293955,1002051468,15657054,18.2),(74253,'IRAS','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74253,30.9,0.8,15.2,28101,75,NULL,'A82, H','NGC 3365',NULL,'1997ApJS..109..333W',1997,1,4.84,NULL,'G',0.000005,NULL,'13.4g',0.66,'Sd(f)','Field galaxy',NULL,NULL,NULL,1,161.5524583,1.81328,0.073,NULL,60279862370,941872849,14716763,13.4),(74254,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74254,30.15,0.4,10.7,28101,75,NULL,'B','NGC 3365',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74255,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74255,30.8,0.4,14.5,28101,75,NULL,NULL,'NGC 3365',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74256,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74256,30.81,0.4,14.5,28101,73,NULL,'IR','NGC 3365',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74257,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74257,31.07,0.4,16.4,28101,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 3365',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74258,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74258,31.23,0.2,17.6,28101,74.4,NULL,NULL,'NGC 3365',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74259,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74259,31.25,0.4,17.8,28101,73,NULL,'opt','NGC 3365',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74260,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74260,31.26,0.43,17.9,28101,75,NULL,'3.6 micron, color corrected','NGC 3365',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74261,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74261,31.3,NULL,18.2,28101,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 3365',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74262,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74262,31.3,NULL,18.2,28101,NULL,NULL,'Dipole','NGC 3365',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74263,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74263,31.31,NULL,18.2,28101,NULL,NULL,'Dipole + Quadrupole','NGC 3365',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74264,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74264,31.31,0.38,18.3,28101,NULL,NULL,NULL,'NGC 3365',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74265,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74265,31.31,0.43,18.3,28101,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3365',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74266,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74266,31.34,0.53,18.5,28101,NULL,NULL,'Malmquist cor.','NGC 3365',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74267,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74267,31.37,NULL,18.8,28101,NULL,NULL,NULL,'NGC 3365',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74268,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74268,31.48,0.49,19.8,28101,75,NULL,'IR','NGC 3365',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74269,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74269,31.52,0.47,20.2,28101,75,NULL,'A82, H, inv','NGC 3365',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74270,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74270,31.55,0.48,20.4,28101,NULL,NULL,NULL,'NGC 3365',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74271,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74271,31.58,0.47,20.7,28101,75,NULL,'A82, H, raw','NGC 3365',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74272,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74272,31.79,0.47,22.8,28101,75,NULL,'A82, H, cor','NGC 3365',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74273,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74273,35.87,0.68,150,28102,70,NULL,NULL,'2MASX J10461295-4429253',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.4,NULL,NULL,NULL,NULL,NULL,1,161.5540417,-44.49039,0.849,NULL,42099169857,657799529,10278117,14.3),(74274,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74274,35.16,0.46,107,28103,70,NULL,NULL,'2MASX J10461416+0233222',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000171,NULL,'16.1g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,161.5589583,2.55614,0.085,NULL,60280048803,941875762,14716808,16.1),(74275,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74275,37.46,0.33,310,28104,70,NULL,NULL,'2MASX J10461420+1240055',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00016,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,161.5592083,12.66822,0.041,NULL,61174365448,955849460,14935147,17.2),(74276,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74276,38.38,0.46,474,28105,70,NULL,NULL,'2MASX J10461450+0448412',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00017,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,161.560333333,4.81136,0.053,NULL,61006898771,953232793,14894262,17.3),(74277,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74277,38.4,0.46,479,28106,70,NULL,NULL,'SDSS J104614.64+554343.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000141,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,161.5610417,55.72883,0,NULL,61971251741,968300808,15129700,18.6),(74278,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74278,38.24,0.46,445,28107,70,NULL,NULL,'2MASX J10461527+3745450',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,161.563833,37.76258,0,NULL,64119791417,1001871740,15654245,17.9),(74279,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74279,37.62,0.46,335,28108,70,NULL,NULL,'2MASX J10461596+4300314',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000174,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,161.5665417,43.00864,0,NULL,64139947510,1002186679,15659166,16.8),(74280,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74280,36.34,0.33,186,28109,70,NULL,NULL,'2MASX J10461624+4445304',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00018,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,161.567666667,44.75853,0,NULL,64131744373,1002058505,15657164,16.2),(74281,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74281,38.9,0.46,602,28110,70,NULL,NULL,'SDSS J104616.62+170352.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,161.569333333,17.06447,0.021,NULL,61186883832,956045059,14938204,18.3),(74282,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74282,32.64,NULL,33.8,28111,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 006- G 008',NULL,'2010Ap&SS.325..163P',2010,1,1.57,NULL,'G',0.000031,NULL,'17.28',0.15,'Sc',NULL,NULL,NULL,NULL,1,161.575417,-83.84528,0.449,NULL,39756652672,621197698,9706214,17.28),(74283,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74283,32.65,NULL,33.9,28111,NULL,NULL,'Dipole + Quadrupole','ESO 006- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74284,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74284,32.66,NULL,34.1,28111,NULL,NULL,'Dipole','ESO 006- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74285,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74285,37.05,0.46,258,28112,70,NULL,NULL,'2MASX J10461824+2034478',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.08',0.15,NULL,NULL,NULL,NULL,NULL,1,161.576083333,20.57994,0.009,NULL,60979608395,952806381,14887599,18.08),(74286,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74286,37.41,0.46,303,28113,70,NULL,NULL,'SDSS J104618.55+282133.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000142,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,161.577333,28.35922,0,NULL,60530463370,945788490,14777945,18),(74287,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74287,37.46,0.33,310,28114,70,NULL,NULL,'2MASX J10461980+1237195',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000172,NULL,'16.6g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,161.582416667,12.62217,0.041,NULL,61174354455,955849288,14935145,16.6),(74288,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74288,37.75,0.46,355,28115,70,NULL,NULL,'SDSS J104621.09+025113.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000168,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,161.587917,2.85383,0.093,NULL,60276605384,941821959,14715968,18.7),(74289,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74289,35.41,0.47,121,28116,70,NULL,NULL,'CGCG 010-010 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.81,NULL,'G',0.0001,NULL,'15.46',0.63,NULL,NULL,NULL,NULL,NULL,1,161.5905,-2.28706,0.109,NULL,40885366518,638833851,9981778,15.46),(74290,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74290,36.53,0.46,202,28117,70,NULL,NULL,'CGCG 038-010',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000186,NULL,'15.5g',0.51,'E0',NULL,NULL,NULL,NULL,1,161.598625,7.58461,0.065,NULL,61062196103,954096814,14907762,15.5),(74291,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74291,37.5,0.23,317,28118,70,NULL,NULL,'2MASX J10462468+1605426',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,161.602833,16.09508,0.045,NULL,61188289595,956067024,14938547,17.3),(74292,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74292,36.68,0.33,217,28119,70,NULL,NULL,'2MASX J10462560-0023086',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000091,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,161.606625,-0.38556,0.089,NULL,40879413874,638740841,9980325,17),(74293,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74293,35.87,0.46,149,28120,70,NULL,NULL,'2MASX J10462582+0953134',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000159,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,161.607667,9.88703,0.057,NULL,61055879812,953998122,14906220,16.2),(74294,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74294,38.15,0.46,428,28121,70,NULL,NULL,'SDSS J104627.11+664312.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000073,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,161.6130417,66.71997,0.025,NULL,62130792734,970793636,15168650,18.3),(74295,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74295,37.5,0.23,317,28122,70,NULL,NULL,'2MASX J10462870+1609086',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000186,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,161.619375,16.15228,0.045,NULL,61188292584,956067071,14938547,16.7),(74296,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74296,37.5,0.23,317,28123,70,NULL,NULL,'2MASX J10463064+1607376',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000178,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,161.62775,16.12714,0.045,NULL,61188290034,956067031,14938547,17.3),(74297,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74297,37.96,0.46,390,28124,70,NULL,NULL,'2MASX J10463076+1931138',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,161.6280417,19.52053,0.029,NULL,60977122685,952767541,14886992,17.7),(74298,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74298,38.06,0.15,409,28125,70,NULL,NULL,'2MASX J10463109+0124361',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000088,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,161.629625,1.40992,0.073,NULL,60270576543,941727758,14714496,18),(74299,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74299,36.91,0.33,241,28126,70,NULL,NULL,'2MASX J10463163+1144284',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000186,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,161.631917,11.74111,0.053,NULL,61043922125,953811283,14903301,16.5),(74300,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74300,37.76,0.46,356,28127,70,NULL,NULL,'2MASX J10463309+3756442',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,161.637833,37.94569,0.005,NULL,64119884590,1001873196,15654268,17.1),(74301,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74301,34.73,0.46,88.3,28128,70,NULL,NULL,'CGCG 212-052',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000161,NULL,'15.2g',0.55,'E',NULL,NULL,NULL,NULL,1,161.638167,39.98289,0,NULL,64121745380,1001902271,15654722,15.2),(74302,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74302,38.55,0.46,513,28129,70,NULL,NULL,'SDSS J104634.17+274915.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000147,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,161.642375,27.82094,0,NULL,60532186074,945815407,14778365,18.5),(74303,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74303,37.13,0.46,267,28130,70,NULL,NULL,'2MASX J10463438+2701519',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000129,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,161.6432083,27.03114,0.022,NULL,60529597341,945774958,14777733,17.7),(74304,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74304,37.38,0.33,299,28131,70,NULL,NULL,'2MASX J10463462+0406451',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000179,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,161.644167,4.11256,0.073,NULL,60275842421,941810037,14715781,16.5),(74305,'Tully est','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74305,33.2,0.8,43.6,28132,75,NULL,'B','NGC 3367',NULL,'1988NBGC.C....0000T',1988,1,2.02,'The 2MASXi position is 6 arcsec northwest of the nucleus.','G',0.000024,NULL,'12.7g',1.58,'SB(rs)c;LINER  Sy','in a radial-velocity based grouping',NULL,NULL,'Sy',1,161.645625,13.75086,0.049,NULL,61175513269,955867394,14935428,12.7),(74306,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74306,37.25,0.46,282,28133,70,NULL,NULL,'2MASX J10463550+2344263',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,161.6479583,23.74058,0.057,NULL,60976055245,952750863,14886732,NULL),(74307,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74307,38.06,0.15,409,28134,70,NULL,NULL,'2MASX J10463622+0128221',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000096,NULL,'16.7g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,161.650833,1.47292,0.073,NULL,60276867688,941826057,14716032,16.7),(74308,'HII region diameter','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74308,30.57,0.14,13,28135,NULL,NULL,NULL,'NGC 3359',NULL,'2005JKAS...38....7I',2005,1,7.2,NULL,'G',0.000004,NULL,'11.03',4.4,'SB(rs)c        HII','Isolated galaxy',NULL,NULL,NULL,1,161.653583,63.22422,0,NULL,61840761114,966261892,15097842,11.03),(74309,'IRAS','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74309,31.31,0.8,18.3,28135,75,NULL,'A82, H','NGC 3359',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74310,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74310,30.4,0.4,12,28135,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 3359',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74311,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74311,30.83,0.47,14.6,28135,75,NULL,'A82, H, raw','NGC 3359',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74312,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74312,30.87,0.47,14.9,28135,75,NULL,'A82, H, inv','NGC 3359',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74313,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74313,31.17,0.47,17.2,28135,75,NULL,'A82, H, cor','NGC 3359',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74314,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74314,31.42,0.4,19.2,28135,75,NULL,'B','NGC 3359',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74315,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74315,31.49,0.4,19.8,28135,NULL,NULL,'mean','NGC 3359',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74316,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74316,31.53,0.43,20.2,28135,75,NULL,'3.6 micron, color corrected','NGC 3359',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74317,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74317,31.53,0.43,20.2,28135,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3359',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74318,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74318,31.59,0.2,20.8,28135,74.4,NULL,NULL,'NGC 3359',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74319,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74319,31.76,0.47,22.5,28135,NULL,NULL,'H','NGC 3359',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74320,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74320,31.77,0.35,22.6,28135,NULL,NULL,NULL,'NGC 3359',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74321,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74321,31.79,0.46,22.8,28135,NULL,NULL,'J','NGC 3359',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74322,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74322,31.81,0.45,23,28135,NULL,NULL,'K','NGC 3359',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74323,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74323,35.86,0.46,149,28136,70,NULL,NULL,'2MASX J10463681+2647229',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000085,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,161.653375,26.78969,0.065,NULL,60525339910,945708436,14776694,16.4),(74324,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74324,37.47,0.46,312,28137,70,NULL,NULL,'2MASX J10463780+1627066',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00013,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,161.6575,16.45186,0.033,NULL,61188228059,956066063,14938532,18.5),(74325,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74325,37.28,0.46,286,28138,70,NULL,NULL,'2MASX J10463839+5653374',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,161.659917,56.89372,0,NULL,62002135404,968783365,15137240,17.2),(74326,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74326,34.05,0.49,64.7,28139,75,NULL,'IR','ESO 376- G 020',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000023,NULL,'14.87',0.3,'Sb:            HII',NULL,NULL,NULL,NULL,1,161.660333333,-36.35319,0.165,NULL,42111991988,657999874,10281248,14.87),(74327,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74327,38.66,0.46,541,28140,70,NULL,NULL,'SDSS J104638.66+383512.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000198,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,161.661083,38.58681,0,NULL,64121727093,1001901985,15654718,18.8),(74328,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74328,36.91,0.33,241,28141,70,NULL,NULL,'2MASX J10463894+1145551',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000157,NULL,'16.33',0.6,'BrClG;M32-type or bE','Group member',NULL,NULL,NULL,1,161.662083,11.76525,0.053,NULL,61043927145,953811361,14903302,16.33),(74329,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74329,38.06,0.15,409,28142,70,NULL,NULL,'2MASX J10463902+0126292',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000107,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,161.662667,1.44156,0.073,NULL,60269265007,941707265,14714176,17.1),(74330,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74330,36.71,0.46,219,28143,70,NULL,NULL,'2MASX J10463968+2152023',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.08',0.18,NULL,NULL,NULL,NULL,NULL,1,161.66525,21.86736,0,NULL,60981593791,952837402,14888084,18.08),(74331,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74331,37.37,0.46,298,28144,70,NULL,NULL,'2MASX J10464041+2313173',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,161.66825,23.22147,0.041,NULL,60976722929,952761295,14886895,18.1),(74332,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74332,37.01,0.33,253,28145,70,NULL,NULL,'2MASX J10464113+1122101',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00017,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,161.671333,11.36936,0.045,NULL,61052523926,953945686,14905401,17.4),(74333,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74333,37.38,0.33,299,28146,70,NULL,NULL,'2MASX J10464193+0406292',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000184,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,161.674625,4.10803,0.073,NULL,60276057064,941813391,14715834,17.1),(74334,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74334,37.17,0.46,271,28147,70,NULL,NULL,'2MASX J10464329+0022322',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000085,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,161.680458333,0.37561,0.061,NULL,60270412572,941725196,14714456,16.6),(74335,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74335,38.12,0.46,420,28148,70,NULL,NULL,'SDSS J104643.39+251521.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,161.680833,25.25608,0.024,NULL,60493682840,945213794,14768965,18.3),(74336,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74336,37.32,0.46,290,28149,70,NULL,NULL,'2MASX J10464412+5748584',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,161.683625,57.81639,0,NULL,62003460877,968804076,15137563,17.3),(74337,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74337,38.38,0.46,474,28150,70,NULL,NULL,'2MASX J10464446+1231156',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000135,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,161.685166667,12.52114,0.045,NULL,61174857225,955857144,14935267,18.3),(74338,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74338,35.61,0.46,132,28151,70,NULL,NULL,'2MASX J10464467+4046093',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000172,NULL,'15.9g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,161.686083,40.76928,0,NULL,64113306445,1001770413,15652662,15.9),(74339,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74339,38.06,0.15,409,28152,70,NULL,NULL,'SDSS J104644.67+012652.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000078,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,161.686167,1.44803,0.073,NULL,60269265386,941707271,14714176,18.5),(74340,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74340,29.94,0.13,9.72,28153,NULL,NULL,'LMC W01','MESSIER 096',NULL,'2001ApJ...548..564W',2001,1,7.6,NULL,'G',0.000013,NULL,'10.11',5.2,'SAB(rs)ab;Sy   LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,161.690583,11.81994,0.053,NULL,61043928705,953811386,14903302,10.11),(74341,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74341,29.96,0.1,9.8,28153,NULL,NULL,'7, VI','MESSIER 096',NULL,'2001ApJ...547L.103G',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74342,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74342,29.97,0.06,9.86,28153,NULL,NULL,'9, VI, KEY PROJECT','MESSIER 096',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74343,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74343,30.05,0.06,10.2,28153,NULL,NULL,'MW HIPP','MESSIER 096',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74344,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74344,30.08,0.17,10.4,28153,NULL,NULL,'MW P02','MESSIER 096',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74345,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74345,30.1,0.1,10.5,28153,NULL,NULL,'7, VI +Z','MESSIER 096',NULL,'2001ApJ...547L.103G',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74346,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74346,30.11,0.06,10.5,28153,NULL,NULL,'9, VI, +Z, KEY PROJECT','MESSIER 096',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74347,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74347,30.11,0.08,10.5,28153,74.4,NULL,NULL,'MESSIER 096',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74348,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74348,30.13,0.07,10.6,28153,NULL,NULL,'16, VI(W)','MESSIER 096',NULL,'1999MNRAS.310..175T',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74349,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74349,30.14,0.1,10.7,28153,NULL,NULL,'7, VI','MESSIER 096',NULL,'1997ApJ...491...13K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74350,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74350,30.17,0.1,10.8,28153,NULL,NULL,'MW GFG','MESSIER 096',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74351,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74351,30.17,0.1,10.8,28153,NULL,NULL,'74, VI','MESSIER 096',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74352,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74352,30.2,0.1,11,28153,NULL,NULL,'HST KP Calibrated','MESSIER 096',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74353,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74353,30.2,0.1,11,28153,NULL,NULL,'7, VI','MESSIER 096',NULL,'1999ApJ...512...48G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74354,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74354,30.2,0.1,11,28153,NULL,NULL,'ALLFRAME','MESSIER 096',NULL,'2000ApJ...529..723G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74355,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74355,30.25,0.18,11.2,28153,NULL,NULL,'16, VI(W) + Z','MESSIER 096',NULL,'1999MNRAS.310..175T',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74356,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74356,30.32,0.16,11.6,28153,NULL,NULL,'7, VI(W)','MESSIER 096',NULL,'1995Natur.377...27T',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74357,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74357,30.34,NULL,11.7,28153,NULL,18.54,NULL,'MESSIER 096',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74358,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74358,30.34,0.11,11.7,28153,NULL,18.54,'LMC ZP','MESSIER 096',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74359,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74359,30.36,0.09,11.8,28153,NULL,NULL,'ALLFRAME, Key Project','MESSIER 096',NULL,'2000ApJ...529..723G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74360,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74360,30.37,0.1,11.9,28153,NULL,NULL,'Z, Key Project','MESSIER 096',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74361,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74361,30.42,0.15,12.1,28153,NULL,NULL,'7, VI +Z','MESSIER 096',NULL,'1997ApJ...491...13K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74362,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74362,30.77,NULL,14.3,28153,NULL,NULL,'18, VI','MESSIER 096',NULL,'2006A&A...452..423P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74363,'PNLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74363,29.79,0.1,9.08,28153,NULL,NULL,NULL,'MESSIER 096',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74364,'PNLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74364,29.91,0.12,9.59,28153,NULL,NULL,'HST KP Calibrated','MESSIER 096',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74365,'PNLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74365,29.91,0.15,9.6,28153,NULL,NULL,'74','MESSIER 096',NULL,'1997ApJ...479..231F',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74366,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1998bu',NULL,74366,29.76,0.46,8.93,28153,72,NULL,NULL,'MESSIER 096',0.002992,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74367,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1998bu',NULL,74367,29.85,0.09,9.3,28153,72,NULL,NULL,'MESSIER 096',0.002992,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74368,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1998bu',NULL,74368,29.95,0.02,9.74,28153,72,NULL,NULL,'MESSIER 096',0.002992,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74369,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1998bu',NULL,74369,29.98,0.03,9.9,28153,72,NULL,'M(H) = -18.317 mag','MESSIER 096',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74370,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1998bu',NULL,74370,30.28,0.12,11.3,28153,65,NULL,'MLCS2k2','MESSIER 096',0.002992,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74371,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1998bu','R',74371,30.5,NULL,12.6,28153,62.3,NULL,NULL,'MESSIER 096',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74372,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1998bu',NULL,74372,30.59,0.14,13.1,28153,60,NULL,NULL,'MESSIER 096',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74373,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1998bu',NULL,74373,31.2,0.17,17.4,28153,70.8,NULL,NULL,'MESSIER 096',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74374,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74374,29.92,0.22,9.64,28153,NULL,NULL,'I','MESSIER 096',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74375,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74375,30.08,0.22,10.4,28153,NULL,NULL,'I','MESSIER 096',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74376,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74376,30.08,0.22,10.4,28153,NULL,NULL,'I','MESSIER 096',NULL,'2001ApJ...559..584A',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74377,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74377,30.11,0.08,10.5,28153,74.4,NULL,NULL,'MESSIER 096',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74378,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74378,30.14,0.23,10.7,28153,NULL,NULL,'HST KP Calibrated, I','MESSIER 096',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74379,'TRGB','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74379,29.65,0.28,8.51,28153,NULL,NULL,'I','MESSIER 096',NULL,'2009ApJ...694.1331M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74380,'TRGB','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74380,30.1,0.03,10.5,28153,NULL,NULL,'HOST SN 1998bu','MESSIER 096',NULL,'2013AAS...22143202J',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74381,'TRGB','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74381,30.15,0.03,10.7,28153,NULL,NULL,'Syst. +/- 0.12','MESSIER 096',NULL,'2013ApJ...773...13L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74382,'Sosies','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74382,29.81,0.14,9.16,28153,NULL,NULL,NULL,'MESSIER 096',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74383,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74383,28.58,0.69,5.21,28153,100,NULL,'mid-IR','MESSIER 096',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74384,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74384,29.54,0.4,8.1,28153,75,NULL,'B','MESSIER 096',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74385,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74385,30.04,0.3,10.2,28153,69,NULL,NULL,'MESSIER 096',NULL,'1997MNRAS.290L..77S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74386,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74386,30.04,0.4,10.2,28153,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 3 galaxy group','MESSIER 096',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74387,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74387,30.1,0.43,10.5,28153,NULL,NULL,NULL,'MESSIER 096',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74388,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74388,30.11,0.06,10.5,28153,75,NULL,NULL,'MESSIER 096',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74389,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74389,30.11,0.08,10.5,28153,74.4,NULL,NULL,'MESSIER 096',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74390,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74390,30.21,0.41,11,28153,NULL,NULL,'Malmquist cor.','MESSIER 096',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74391,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74391,30.25,NULL,11.2,28153,NULL,NULL,'I','MESSIER 096',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74392,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74392,30.28,0.43,11.4,28153,75,NULL,'3.6 micron, color corrected','MESSIER 096',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74393,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74393,30.31,NULL,11.5,28153,NULL,NULL,'B','MESSIER 096',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74394,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74394,30.3,0.43,11.5,28153,75,NULL,'3.6 micron, color + selection bias corrected','MESSIER 096',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74395,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74395,30.32,0.21,11.6,28153,NULL,NULL,'B','MESSIER 096',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74396,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74396,30.33,0.22,11.6,28153,NULL,NULL,'I','MESSIER 096',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74397,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74397,30.38,0.4,11.9,28153,75,NULL,'HOSTS SN 1998bu','MESSIER 096',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74398,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74398,30.43,0.4,12.2,28153,75,NULL,'HOSTS SN 1998bu','MESSIER 096',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74399,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74399,30.43,0.42,12.2,28153,NULL,18.48,'3.6 micron','MESSIER 096',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74400,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74400,30.46,0.36,12.4,28153,NULL,NULL,NULL,'MESSIER 096',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74401,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74401,30.49,0.3,12.6,28153,55,NULL,'B','MESSIER 096',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74402,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74402,30.99,NULL,15.8,28153,NULL,NULL,'LEDA [April 2006]','MESSIER 096',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74403,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74403,38.06,0.15,409,28154,70,NULL,NULL,'2MASX J10464782+0129232',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,161.69925,1.48978,0.073,NULL,60269267248,941707300,14714176,18.1),(74404,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74404,38.07,0.19,411,28155,70,NULL,NULL,'SDSS J104648.73+450725.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000134,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,161.703083,45.12389,0,NULL,64131257876,1002050904,15657045,18.6),(74405,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74405,38.07,0.19,411,28156,70,NULL,NULL,'2MASX J10464973+4506586',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,'PHOT','18.21',0.18,'BrClG',NULL,NULL,NULL,NULL,1,161.707333,45.11631,0,NULL,64131258075,1002050907,15657045,18.21),(74406,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74406,38.07,0.19,411,28157,70,NULL,NULL,'SDSS J104649.86+450559.0',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.00015,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,161.70775,45.09972,0,NULL,64131258166,1002050908,15657045,18.7),(74407,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74407,38.06,0.15,409,28158,70,NULL,NULL,'2MASX J10465016+0127582',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000142,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,161.709041667,1.46625,0.073,NULL,60269268863,941707325,14714176,18),(74408,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74408,37.08,0.33,260,28159,70,NULL,NULL,'2MASX J10465021+4147183',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000182,NULL,'16.1g',0.41,'E0',NULL,NULL,NULL,NULL,1,161.709167,41.78839,0,NULL,64113782525,1001777851,15652778,16.1),(74409,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74409,34.86,0.52,93.6,28160,70,NULL,NULL,'2MASX J10465059-1558393',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.73',NULL,NULL,NULL,NULL,NULL,NULL,1,161.710833,-15.97778,0.149,NULL,41862191166,654096736,10220261,15.73),(74410,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74410,38.14,0.46,425,28161,70,NULL,NULL,'SDSS J104651.36+052023.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,161.714,5.33975,0.101,NULL,61006984268,953234129,14894283,18.1),(74411,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74411,36.91,0.46,242,28162,70,NULL,NULL,'2MASX J10465252+1927533',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.33',0.16,NULL,NULL,NULL,NULL,NULL,1,161.718833333,19.46478,0.025,NULL,60977129593,952767649,14886994,18.33),(74412,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74412,36.25,0.33,178,28163,70,NULL,NULL,'SBS 1043+581',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000168,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,161.721166667,57.86486,0,NULL,62002984797,968796637,15137447,16.3),(74413,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74413,37.06,0.46,259,28164,70,NULL,NULL,'2MASX J10465363+4529376',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,161.7232917,45.49381,0.005,NULL,64134614738,1002103355,15657864,17.4),(74414,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74414,37.62,0.46,334,28165,70,NULL,NULL,'2MASX J10465377+1900473',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,161.7239583,19.01319,0.057,NULL,60977241565,952769399,14887021,17.6),(74415,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74415,36.89,0.46,239,28166,70,NULL,NULL,'2MASX J10465505+4010352',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000172,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,161.7292917,40.17636,0,NULL,64112559933,1001758748,15652480,16.2),(74416,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74416,38.13,0.46,422,28167,70,NULL,NULL,'SDSS J104655.49+173645.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,161.7312083,17.61278,0.037,NULL,61187529041,956055141,14938361,18.2),(74417,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74417,38.07,0.19,411,28168,70,NULL,NULL,'2MASX J10465643+4504226',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,161.735083333,45.07292,0,NULL,64131258893,1002050920,15657045,17.8),(74418,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74418,37.77,0.46,358,28169,70,NULL,NULL,'2MASX J10465663+0135512',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,161.7359583,1.59767,0.073,NULL,60276873113,941826142,14716033,18),(74419,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74419,34.18,NULL,68.5,28170,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05879',NULL,'2010Ap&SS.325..163P',2010,1,1.81,NULL,'G',0.000017,NULL,'15.75',0.13,'Sd(f)',NULL,NULL,NULL,NULL,1,161.738458333,59.91461,0,NULL,61952612715,968009573,15125149,15.75),(74420,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74420,34.18,0.49,68.7,28170,75,NULL,'IR','UGC 05879',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74421,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74421,34.2,NULL,69.2,28170,NULL,NULL,'Dipole + Quadrupole','UGC 05879',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74422,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74422,34.21,NULL,69.5,28170,NULL,NULL,'Dipole','UGC 05879',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74423,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74423,34.31,NULL,72.7,28170,NULL,NULL,NULL,'UGC 05879',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74424,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74424,37.23,0.46,280,28171,70,NULL,NULL,'2MASX J10465722+2413130',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.51',0.13,NULL,NULL,NULL,NULL,NULL,1,161.738375,24.22022,0.033,NULL,60490522252,945164410,14768193,18.51),(74425,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74425,38.02,0.27,403,28172,70,NULL,NULL,'2MASX J10465767+4104032',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00013,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,161.7404583,41.06744,0,NULL,64113261525,1001769711,15652651,18.6),(74426,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74426,38.08,0.46,413,28173,70,NULL,NULL,'SDSS J104658.13+274651.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000148,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,161.74225,27.78086,0,NULL,60532048197,945813253,14778332,18.5),(74427,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74427,38.1,0.46,417,28174,70,NULL,NULL,'SDSS J104700.12+152341.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,161.750541667,15.39494,0.053,NULL,61187800361,956059380,14938427,17.8),(74428,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74428,38.06,0.15,409,28175,70,NULL,NULL,'SDSS J104700.26+012403.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000151,NULL,'18.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,161.751083333,1.40111,0.077,NULL,60271111409,941736115,14714626,18.8),(74429,'D-Sigma','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74429,32.85,0.4,37.1,28176,75,NULL,'Edat, raw','NGC 3375',NULL,'1997ApJS..109..333W',1997,1,1.5,'MCG decs for MCG -01-28 field are 10 arcmin too far north (MCG4 errata).','G',0.000043,NULL,'13.43',1.1,'(R)SA(rs)0^0^?',NULL,NULL,NULL,NULL,1,161.753291667,-9.94131,0.053,NULL,41795815773,653059621,10204056,13.43),(74430,'D-Sigma','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74430,33.18,0.4,43.3,28176,75,NULL,'Edat, cor','NGC 3375',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74431,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74431,33.33,0.4,46.4,28176,NULL,NULL,'mean','NGC 3375',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74432,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74432,33.66,0.45,54,28176,NULL,NULL,'K','NGC 3375',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74433,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74433,36.86,0.46,235,28177,70,NULL,NULL,'2MASX J10470158-0017545',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000078,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,161.756667,-0.29856,0.049,NULL,40881389404,638771709,9980807,16.9),(74434,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 2009na','R',74434,34.72,0.07,87.9,28178,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 05884',NULL,'2015Sci...347.1459K',2015,1,1.23,'Noted in MCG as possibly interacting.','G',0.00005,NULL,'14.1g',0.75,'SA(s)b:','in a radial-velocity based grouping',NULL,NULL,NULL,1,161.760791667,26.54289,0.041,NULL,60525855645,945716494,14776820,14.1),(74435,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 2009na','R',74435,34.74,0.08,88.7,28178,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 05884',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74436,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 2009na',NULL,74436,34.83,0.2,90.4,28178,73.8,NULL,'SALT 2 (SNANA)','UGC 05884',0.0224,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74437,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74437,35.75,0.19,141,28179,70,NULL,NULL,'SDSS J104702.82+141548.0',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',NULL,NULL,'15.3g',0.57,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,161.7617917,14.26336,0.061,NULL,61193726882,956151982,14939874,15.3),(74438,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74438,37.33,0.46,292,28180,70,NULL,NULL,'2MASX J10470281+4540235',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00016,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,161.7617917,45.67336,0,NULL,64134641707,1002103776,15657871,16.8),(74439,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74439,37.75,0.46,355,28181,70,NULL,NULL,'2MASX J10470367+1359103',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00019,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,161.765125,13.98628,0.045,NULL,61193243714,956144433,14939756,17.8),(74440,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74440,38.2,0.46,436,28182,70,NULL,NULL,'2MASX J10470389+1739513',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.61',0.21,NULL,NULL,NULL,NULL,NULL,1,161.766083,17.66417,0.037,NULL,61187405337,956053208,14938331,18.61),(74441,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74441,32.04,0.03,25.6,28183,NULL,NULL,'V, I, NIR (W), 69, Syst. +/- 0.32 mag','NGC 3370',NULL,'2013MNRAS.434.2866F',2013,1,3.2,NULL,'G',0.000013,NULL,'12.28',1.8,'SA(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,161.766875,17.27361,0.037,NULL,61187302128,956051595,14938306,12.28),(74442,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74442,32.09,0.06,26.2,28183,74.4,NULL,NULL,'NGC 3370',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74443,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74443,32.12,0.08,26.5,28183,NULL,NULL,NULL,'NGC 3370',NULL,'2009ApJ...699..539R',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74444,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74444,32.13,0.07,26.7,28183,NULL,NULL,'SNIa calibrated','NGC 3370',NULL,'2011ApJ...730..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74445,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74445,32.15,0.03,26.9,28183,NULL,NULL,'STR 04 LMC non-linear','NGC 3370',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74446,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74446,32.17,0.03,27.2,28183,NULL,NULL,'STR04 LMC linear','NGC 3370',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74447,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74447,32.18,0.03,27.3,28183,NULL,NULL,'KN04 LMC non-linear','NGC 3370',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74448,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74448,32.19,0.03,27.4,28183,NULL,NULL,'KN04 LMC linear','NGC 3370',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74449,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74449,32.19,0.03,27.5,28183,NULL,NULL,'TR02 LMC linear','NGC 3370',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74450,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74450,32.2,0.03,27.5,28183,NULL,NULL,'KN06 LMC linear','NGC 3370',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74451,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74451,32.21,0.03,27.7,28183,NULL,NULL,'KN06 LMC non-linear','NGC 3370',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74452,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74452,32.22,0.05,27.8,28183,NULL,NULL,'70, VI','NGC 3370',NULL,'2005ApJ...627..579R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74453,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74453,32.22,0.03,27.8,28183,NULL,NULL,'TR02 LMC non-linear','NGC 3370',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74454,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74454,32.23,0.04,28,28183,NULL,NULL,'NK04 GAL','NGC 3370',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74455,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74455,32.36,0.04,29.7,28183,NULL,NULL,'STR04 GAL','NGC 3370',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74456,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74456,32.37,NULL,29.8,28183,NULL,18.54,NULL,'NGC 3370',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74457,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74457,32.37,0.03,29.8,28183,NULL,18.54,'LMC ZP','NGC 3370',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74458,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1994ae',NULL,74458,31.39,0.53,18.9,28183,74.2,NULL,'SALT 2','NGC 3370',0.004266,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74459,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1994ae',NULL,74459,31.76,0.17,22.5,28183,70.8,NULL,NULL,'NGC 3370',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74460,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1994ae',NULL,74460,32.07,0.53,25.8,28183,70,NULL,'SALT','NGC 3370',0.004266,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74461,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1994ae',NULL,74461,32.09,0.06,26.2,28183,74.4,NULL,NULL,'NGC 3370',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74462,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1994ae',NULL,74462,32.13,0.07,26.7,28183,NULL,NULL,'MLCS2k2, Cepheids calibrated','NGC 3370',NULL,'2011ApJ...730..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74463,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1994ae',NULL,74463,32.36,0.06,29.6,28183,60,NULL,'M(V) = -19.47 mag','NGC 3370',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74464,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1994ae',NULL,74464,32.43,0.05,30.6,28183,60,NULL,'M(I) = -19.19 mag','NGC 3370',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74465,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1994ae',NULL,74465,32.45,0.07,30.9,28183,60,NULL,'M(B) = -19.48 mag','NGC 3370',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74466,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1994ae','R',74466,32.47,NULL,31.2,28183,62.3,NULL,NULL,'NGC 3370',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74467,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1994ae',NULL,74467,32.56,0.07,32.3,28183,65,NULL,'MLCS2k2','NGC 3370',0.004266,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74468,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1994ae',NULL,74468,32.61,0.14,33.3,28183,60,NULL,NULL,'NGC 3370',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74469,'Tully est','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74469,31.85,0.8,23.4,28183,75,NULL,'B','NGC 3370',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74470,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74470,30.14,0.69,10.7,28183,100,NULL,'mid-IR','NGC 3370',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74471,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74471,31.84,0.49,23.4,28183,NULL,NULL,'Malmquist cor.','NGC 3370',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74472,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74472,31.86,0.36,23.6,28183,NULL,NULL,NULL,'NGC 3370',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74473,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74473,31.97,0.43,24.8,28183,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3370',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74474,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74474,32.04,0.4,25.5,28183,NULL,NULL,'mean','NGC 3370',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74475,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74475,32.08,0.43,26,28183,75,NULL,'3.6 micron, color corrected','NGC 3370',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74476,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74476,32.09,0.06,26.2,28183,74.4,NULL,NULL,'NGC 3370',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74477,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74477,32.11,0.42,26.4,28183,NULL,18.48,'3.6 micron','NGC 3370',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74478,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74478,32.19,0.4,27.4,28183,75,NULL,'HOSTS SN 1994ae','NGC 3370',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74479,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74479,32.19,0.4,27.4,28183,75,NULL,'HOSTS SN 1994ae','NGC 3370',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74480,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74480,32.35,0.39,29.5,28183,NULL,NULL,NULL,'NGC 3370',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74481,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74481,32.46,0.47,31.1,28183,NULL,NULL,'H','NGC 3370',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74482,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74482,32.46,0.46,31.1,28183,NULL,NULL,'J','NGC 3370',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74483,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74483,32.47,0.45,31.2,28183,NULL,NULL,'K','NGC 3370',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74484,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74484,37.51,0.46,318,28184,70,NULL,NULL,'2MASXi J1047041-000530',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000094,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,161.767083333,-0.09197,0.049,NULL,40881370415,638771412,9980803,17.5),(74485,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74485,36.02,0.46,160,28185,70,NULL,NULL,'2MASX J10470620+3933131',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.0001,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,161.775917,39.55353,0,NULL,64121883501,1001904429,15654756,16.8),(74486,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74486,36.47,0.46,197,28186,70,NULL,NULL,'2MASX J10470655+2634467',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.34',0.21,NULL,NULL,NULL,NULL,NULL,1,161.777375,26.57961,0.041,NULL,60525790199,945715471,14776804,17.34),(74487,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74487,38.07,0.19,411,28187,70,NULL,NULL,'SDSS J104707.87+450622.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000145,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,161.782833,45.10622,0,NULL,64131258681,1002050916,15657045,18.6),(74488,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74488,36.25,0.33,178,28188,70,NULL,NULL,'CGCG 290-071',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000209,NULL,'15.4g',0.48,'E0',NULL,NULL,NULL,NULL,1,161.787416667,58.08931,0,NULL,62003021640,968797213,15137456,15.4),(74489,'D-Sigma','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74489,32.37,0.4,29.7,28189,75,NULL,'Edat, raw','NGC 3348',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.00009,NULL,'12.17',2,'E0','in a radial-velocity based grouping',NULL,NULL,NULL,1,161.791667,72.83967,0.173,NULL,61392738430,959261537,14988461,12.17),(74490,'D-Sigma','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74490,32.7,0.4,34.7,28189,75,NULL,'Edat, cor','NGC 3348',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74491,'Faber-Jackson','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74491,31.81,0.47,23,28189,95,NULL,'de Vaucouleurs','NGC 3348',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74492,'Faber-Jackson','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74492,31.84,0.31,23.3,28189,95,NULL,'Weighted Mean','NGC 3348',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74493,'Faber-Jackson','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74493,31.87,0.63,23.7,28189,95,NULL,'Michard 1979b, c','NGC 3348',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74494,'Faber-Jackson','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74494,32.3,0.46,28.8,28189,95,NULL,'Michard 1979a','NGC 3348',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74495,'Faber-Jackson','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74495,33.76,1.61,56.5,28189,55,NULL,'Visvanathan & Sandage 1979','NGC 3348',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74496,'Tertiary','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74496,32.11,0.35,26.4,28189,95,NULL,NULL,'NGC 3348',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74497,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74497,32.89,0.45,37.8,28189,NULL,NULL,'K','NGC 3348',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74498,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74498,33.01,0.4,40,28189,NULL,NULL,'mean','NGC 3348',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74499,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74499,35.98,0.33,157,28190,70,NULL,NULL,'2MASX J10471380+3032162',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000178,NULL,'15.5g',0.48,NULL,NULL,NULL,NULL,NULL,1,161.8075,30.53803,0.044,NULL,60504242429,945378787,14771543,15.5),(74500,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74500,37.71,0.46,348,28191,70,NULL,NULL,'SDSS J104714.19+105642.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000162,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,161.809167,10.94506,0.041,NULL,61053205910,953956342,14905567,18.2),(74501,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74501,35.73,0.27,140,28192,70,NULL,NULL,'2MASX J10471511+3858345',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000178,NULL,'16.1g',0.34,'E0',NULL,NULL,NULL,NULL,1,161.812917,38.97628,0,NULL,64121543884,1001899123,15654673,16.1),(74502,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74502,37.94,0.46,387,28193,70,NULL,NULL,'SDSS J104715.76+082454.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000143,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,161.815708333,8.41525,0.085,NULL,61066093207,954157706,14908714,18.5),(74503,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74503,37.79,0.46,361,28194,70,NULL,NULL,'SDSS J104715.97+073523.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,161.8165417,7.58989,0.069,NULL,61062552151,954102377,14907849,18.2),(74504,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74504,37.01,0.33,253,28195,70,NULL,NULL,'2MASX J10471661+1114053',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,161.8192917,11.23475,0.045,NULL,61052461769,953944715,14905386,17.7),(74505,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74505,38.02,0.27,403,28196,70,NULL,NULL,'2MASX J10471710+4106145',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,161.8212917,41.10422,0,NULL,64113953135,1001780517,15652820,18.1),(74506,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74506,37.21,0.46,277,28197,70,NULL,NULL,'2MASX J10471780+1730202',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'17.20',0.36,NULL,NULL,NULL,NULL,NULL,1,161.824167,17.50556,0.037,NULL,61187325041,956051953,14938311,17.2),(74507,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74507,36.45,0.7,195,28198,70,NULL,NULL,'2MASX J10471799-1003312',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.3,NULL,NULL,NULL,NULL,NULL,1,161.825,-10.05872,0.053,NULL,41795745897,653058529,10204039,14.1),(74508,'IRAS','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74508,33.54,0.8,51.1,28199,75,NULL,'MAT, I','NGC 3383',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00003,NULL,'13.51',1.1,'SB(r)b:        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,161.83,-24.43817,0.201,NULL,41514451982,648663312,10135364,13.51),(74509,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74509,33.5,0.43,50.1,28199,75,NULL,'MAT, I, raw','NGC 3383',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74510,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74510,33.64,0.43,53.4,28199,75,NULL,'MAT, I, cor','NGC 3383',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74511,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74511,33.72,0.32,55.4,28199,85,NULL,'I, raw','NGC 3383',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74512,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74512,33.72,0.43,55.5,28199,75,NULL,'MAT, I, inv','NGC 3383',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74513,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74513,33.77,0.32,56.8,28199,85,NULL,'I, inv','NGC 3383',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74514,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74514,34,0.05,63.2,28199,NULL,NULL,NULL,'NGC 3383',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74515,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74515,38.02,0.27,403,28200,70,NULL,NULL,'2MASX J10471984+4104535',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000183,NULL,'16.4g',0.41,NULL,NULL,NULL,NULL,NULL,1,161.832875,41.08144,0,NULL,64113246467,1001769476,15652648,16.4),(74516,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74516,37.47,0.23,312,28201,70,NULL,NULL,'2MASX J10472203+0511179',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.8g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,161.841875,5.18825,0.045,NULL,61007183359,953237239,14894331,16.8),(74517,'Brightest Stars','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74517,29.85,0.2,9.33,28202,NULL,NULL,NULL,'NGC 3377A',NULL,'1998A&AS..133..181M',1998,1,2.2,NULL,'G',0.000002,NULL,'14.22',2.1,'SAB(s)m','in a pair',NULL,NULL,NULL,1,161.842917,14.06944,0.037,NULL,61193237292,956144332,14939755,14.22),(74518,'TRGB','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74518,29.44,NULL,7.73,28202,NULL,NULL,NULL,'NGC 3377A',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74519,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74519,28.53,0.4,5.1,28202,75,NULL,'B','NGC 3377A',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74520,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74520,38.26,0.46,450,28203,70,NULL,NULL,'2MASX J10472693+1019493',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000172,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,161.8622083,10.33039,0.045,NULL,61052847166,953950736,14905480,17.9),(74521,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74521,36.26,0.46,179,28204,70,NULL,NULL,'2MASX J10472772+3212403',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,161.865625,32.21125,0.02,NULL,60505148985,945392952,14771764,16.8),(74522,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74522,38.75,0.46,561,28205,70,NULL,NULL,'2MASX J10472936+1411197',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000184,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,161.872333,14.18872,0.061,NULL,61193743572,956152243,14939878,18.2),(74523,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74523,37.93,0.46,385,28206,70,NULL,NULL,'SDSS J104730.28+034837.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000171,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,161.876166667,3.81028,0.089,NULL,60276187610,941815431,14715866,18.4),(74524,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74524,36.31,0.46,183,28207,70,NULL,NULL,'2MASX J10473039+0308419',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000198,NULL,'15.2g',0.64,'E0',NULL,NULL,NULL,NULL,1,161.876625,3.14494,0.093,NULL,60274816496,941794007,14715531,15.2),(74525,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74525,35.43,0.59,122,28208,70,NULL,NULL,'2MASX J10473277-4731243',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.0J',NULL,NULL,NULL,NULL,NULL,NULL,1,161.8865,-47.52342,0.769,NULL,41919139858,654986560,10234165,13),(74526,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74526,35.14,0.46,107,28209,70,NULL,NULL,'CGCG 267-013',NULL,'2015arXiv151105856S',2015,1,0.86,NULL,'G',0.000097,NULL,'15.0g',0.39,'S0/a',NULL,NULL,NULL,NULL,1,161.890708333,51.86075,0,NULL,61774138629,965220916,15081576,15),(74527,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74527,37.25,0.46,282,28210,70,NULL,NULL,'2MASX J10473499+5806069',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,161.8960417,58.10197,0,NULL,62003022694,968797229,15137456,17.2),(74528,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74528,36.87,0.33,237,28211,70,NULL,NULL,'2MASX J10473739+1958160',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,161.9057083,19.971,0.017,NULL,60980954516,952827414,14887928,17.2),(74529,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74529,37.12,0.33,266,28212,70,NULL,NULL,'2MASX J10473821+2320360',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,161.909417,23.34328,0.041,NULL,60975022187,952734721,14886480,17.3),(74530,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74530,37.11,0.46,265,28213,70,NULL,NULL,'2MASX J10473841+0044344',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000087,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,161.9100417,0.74292,0.065,NULL,60272045849,941750716,14714854,16.5),(74531,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74531,34.63,0.49,84.2,28214,75,NULL,'IR','UGC 05894',NULL,'2011yCatp016004901K',2011,1,1.95,NULL,'G',0.000033,NULL,'14.2g',0.65,'SAB(s)ab',NULL,NULL,NULL,NULL,1,161.9140417,26.29481,0.041,NULL,60525749275,945714832,14776794,14.2),(74532,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74532,36.45,0.46,195,28215,70,NULL,NULL,'2MASX J10473959+1144466',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000146,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,161.9147917,11.74625,0.065,NULL,61052291804,953942059,14905344,16.8),(74533,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74533,37.12,0.33,266,28216,70,NULL,NULL,'2MASX J10473990+2314310',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.09',0.16,NULL,NULL,NULL,NULL,NULL,1,161.916167,23.24189,0.037,NULL,60975350805,952739856,14886560,18.09),(74534,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74534,35.73,0.27,140,28217,70,NULL,NULL,'UGC 05893',NULL,'2015arXiv151105856S',2015,1,1.04,NULL,'G',0.000093,NULL,'14.3g',0.77,'E?             AGN',NULL,NULL,NULL,NULL,1,161.9187083,38.93158,0,NULL,64121547398,1001899178,15654674,14.3),(74535,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74535,37.39,0.21,301,28218,70,NULL,NULL,'2MASX J10474118+5743459',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00017,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,161.921917,57.72939,0,NULL,62003579736,968805933,15137592,18),(74536,'IRAS','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74536,33.14,0.8,42.4,28219,75,NULL,'CF, r','UGC 05897',NULL,'1997ApJS..109..333W',1997,1,2.98,NULL,'G',0.000003,NULL,'13.8g',0.69,'SAc','Pair member, wide',NULL,NULL,NULL,1,161.922833333,11.07708,0.041,NULL,61053147526,953955430,14905553,13.8),(74537,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74537,32.64,0.37,33.7,28219,NULL,NULL,NULL,'UGC 05897',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74538,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74538,32.74,0.2,35.3,28219,74.4,NULL,NULL,'UGC 05897',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74539,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74539,32.8,0.43,36.3,28219,75,NULL,'3.6 micron, color corrected','UGC 05897',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74540,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74540,32.81,0.45,36.4,28219,NULL,NULL,'Malmquist cor.','UGC 05897',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74541,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74541,32.85,0.38,37.1,28219,75,NULL,'CF, r, raw','UGC 05897',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74542,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74542,32.9,0.43,38.1,28219,75,NULL,'3.6 micron, color + selection bias corrected','UGC 05897',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74543,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74543,32.92,0.42,38.3,28219,NULL,NULL,NULL,'UGC 05897',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74544,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74544,32.93,0.38,38.5,28219,75,NULL,'CF, r, inv','UGC 05897',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74545,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74545,33.05,0.38,40.7,28219,75,NULL,'CF, r, cor','UGC 05897',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74546,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74546,33.32,0.4,46.1,28219,NULL,NULL,'mean','UGC 05897',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74547,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74547,33.46,0.47,49.3,28219,NULL,NULL,'H','UGC 05897',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74548,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74548,33.54,0.46,51.1,28219,NULL,NULL,'J','UGC 05897',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74549,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74549,33.59,0.45,52.1,28219,NULL,NULL,'K','UGC 05897',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74550,'TRGB','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74550,29.2,0.1,6.92,28220,74.4,NULL,NULL,'ESO 318- G 013',NULL,'2013AJ....146...86T',2013,1,2.2,'6dF has z = 0.045675 +- 0.000150, but has the position of a superposed star.','G',0.000018,NULL,'14.97',0.3,'SB(s)d: sp',NULL,NULL,NULL,NULL,1,161.923333,-38.85367,0.253,NULL,42126733293,658230207,10284846,14.97),(74551,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74551,29.06,NULL,6.49,28220,NULL,NULL,NULL,'ESO 318- G 013',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74552,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74552,37.09,0.46,262,28221,70,NULL,NULL,'2MASX J10474201+2056540',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,161.925083333,20.9485,0.013,NULL,60979475646,952804306,14887567,17.6),(74553,'GCLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74553,29.96,0.03,9.82,28222,NULL,NULL,NULL,'NGC 3377',NULL,'2001AJ....121.2950K',2001,1,5.2,NULL,'G',0.000008,NULL,'11.24',3,'E5-6','in a radial-velocity based grouping',NULL,NULL,NULL,1,161.926375,13.98592,0.061,NULL,61193270113,956144845,14939763,11.24),(74554,'GCLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74554,30.14,0.43,10.7,28222,NULL,NULL,NULL,'NGC 3377',NULL,'1990PASP..102..966H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74555,'GCLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74555,30.15,0.11,10.7,28222,NULL,NULL,'TOM(z) = -8.4 mag','NGC 3377',NULL,'2012MNRAS.422.3591C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74556,'GCLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74556,30.28,0.12,11.4,28222,NULL,NULL,'TOM(g) = -7.2 mag','NGC 3377',NULL,'2012MNRAS.422.3591C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74557,'PNLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74557,29.93,NULL,9.68,28222,NULL,NULL,NULL,'NGC 3377',NULL,'1988ASPC....4...42J',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74558,'PNLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74558,29.93,NULL,9.7,28222,NULL,NULL,NULL,'NGC 3377',NULL,'1988ASPC....4..203C',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74559,'PNLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74559,29.99,0.15,9.95,28222,NULL,NULL,NULL,'NGC 3377',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74560,'PNLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74560,30.07,0.15,10.3,28222,NULL,NULL,'22 PNe','NGC 3377',NULL,'1989ApJ...344..715C',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74561,'PNLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74561,30.1,0.19,10.5,28222,NULL,NULL,'HST KP Calibrated','NGC 3377',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74562,'PNLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74562,30.13,0.12,10.6,28222,NULL,NULL,'I','NGC 3377',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74563,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74563,29.84,0.09,9.3,28222,NULL,NULL,'I','NGC 3377',NULL,'1991ApJ...373L...1T',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74564,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74564,29.94,0.08,9.73,28222,NULL,NULL,'I','NGC 3377',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74565,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74565,30,0.2,10,28222,NULL,NULL,'I','NGC 3377',NULL,'1993A&A...275..433B',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74566,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74566,30.12,0.12,10.6,28222,NULL,NULL,'HST KP Calibrated, F814W','NGC 3377',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74567,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74567,30.13,0.08,10.6,28222,74.4,NULL,NULL,'NGC 3377',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74568,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74568,30.16,0.05,10.8,28222,NULL,NULL,'I','NGC 3377',NULL,'1997AJ....114..626A',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74569,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74569,30.25,0.09,11.2,28222,NULL,NULL,'I','NGC 3377',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74570,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74570,30.25,0.09,11.2,28222,NULL,NULL,NULL,'NGC 3377',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74571,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74571,30.27,0.09,11.3,28222,NULL,NULL,'Malmquist cor.','NGC 3377',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74572,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74572,30.31,0.12,11.5,28222,NULL,NULL,'HST KP Calibrated, I','NGC 3377',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74573,'TRGB','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74573,30.13,0.08,10.6,28222,74.4,NULL,NULL,'NGC 3377',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74574,'TRGB','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74574,30.18,0.16,10.9,28222,NULL,NULL,NULL,'NGC 3377',NULL,'2007AJ....134...43H',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74575,'TRGB','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74575,30.18,0.16,10.9,28222,NULL,NULL,'I','NGC 3377',NULL,'2007AJ....134...43H',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74576,'TRGB','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74576,30.59,0.07,13.1,28222,NULL,NULL,'I','NGC 3377',NULL,'2009ApJ...694.1331M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74577,'D-Sigma','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74577,29.99,0.4,9.96,28222,75,NULL,'Edat, raw','NGC 3377',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74578,'D-Sigma','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74578,30.19,0.4,10.9,28222,75,NULL,'Edat, cor','NGC 3377',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74579,'Faber-Jackson','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74579,30.04,0.63,10.2,28222,95,NULL,'Michard 1979b, c','NGC 3377',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74580,'Faber-Jackson','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74580,30.15,NULL,10.7,28222,NULL,NULL,'LEDA [April 2006]','NGC 3377',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74581,'Faber-Jackson','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74581,30.28,0.29,11.4,28222,95,NULL,'Weighted Mean','NGC 3377',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74582,'Faber-Jackson','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74582,30.4,0.81,12,28222,55,NULL,'Visvanathan & Sandage 1979','NGC 3377',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74583,'Faber-Jackson','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74583,30.5,0.47,12.6,28222,95,NULL,'de Vaucouleurs','NGC 3377',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74584,'Faber-Jackson','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74584,30.92,0.46,15.3,28222,95,NULL,'Michard 1979a','NGC 3377',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74585,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74585,30.31,0.41,11.5,28222,NULL,NULL,NULL,'NGC 3377',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74586,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74586,30.39,NULL,12,28222,NULL,NULL,NULL,'NGC 3377',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74587,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74587,30.6,0.41,13.2,28222,NULL,NULL,'Malmquist cor.','NGC 3377',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74588,'Tertiary','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74588,29.92,0.32,9.64,28222,95,NULL,NULL,'NGC 3377',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74589,'Tully est','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74589,29.54,0.8,8.1,28222,75,NULL,'B','NGC 3377',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74590,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74590,30.55,0.45,12.9,28222,NULL,NULL,'K','NGC 3377',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74591,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74591,30.57,0.4,13,28222,NULL,NULL,'mean','NGC 3377',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74592,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74592,37.91,0.33,383,28223,70,NULL,NULL,'B3 1044+440',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000186,NULL,'16.1g',0.44,'E0',NULL,NULL,NULL,NULL,1,161.928458333,43.78131,0,NULL,64139405716,1002178214,15659034,16.1),(74593,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74593,35.16,0.46,108,28224,70,NULL,NULL,'CGCG 290-072',NULL,'2015arXiv151105856S',2015,1,0.88,NULL,'G',0.00009,NULL,'14.4g',0.77,'E0',NULL,NULL,NULL,NULL,1,161.9305,59.41119,0,NULL,61952118555,968001852,15125028,14.4),(74594,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74594,36.73,0.15,222,28225,70,NULL,NULL,'2MASX J10474407+2228040',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.12',0.18,NULL,NULL,NULL,NULL,NULL,1,161.9337917,22.46783,0,NULL,60981525323,952836333,14888067,18.12),(74595,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74595,35.46,0.63,124,28226,70,NULL,NULL,'2MASX J10474467-0022386',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.86',0.7,'Scd',NULL,NULL,NULL,NULL,1,161.936083,-0.37731,0.057,NULL,40881577400,638774646,9980853,14.86),(74596,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74596,38.87,0.46,596,28227,70,NULL,NULL,'SDSS J104745.15+025729.9',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,161.938167,2.95833,0.093,NULL,60275002313,941796911,14715576,18),(74597,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74597,37.96,0.46,390,28228,70,NULL,NULL,'SDSS J104746.63+063608.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000128,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,161.944333,6.60244,0.041,NULL,61064482072,954132532,14908320,18),(74598,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74598,37.44,0.46,308,28229,70,NULL,NULL,'2MASX J10474692+3950167',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000143,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,161.945583333,39.83789,0,NULL,64120705938,1001886030,15654469,17.4),(74599,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74599,37.08,0.33,260,28230,70,NULL,NULL,'2MASX J10474717+4134017',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,161.946541667,41.56719,0,NULL,64113892043,1001779563,15652805,17.9),(74600,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74600,37.24,0.46,280,28231,70,NULL,NULL,'2MASX J10474738+3221321',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000177,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,161.9475417,32.35908,0.02,NULL,60513348852,945521075,14773766,16.9),(74601,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74601,36.08,0.46,164,28232,70,NULL,NULL,'SDSS J104747.46+372823.8',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00017,NULL,'16.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,161.94775,37.47331,0,NULL,64108617391,1001697146,15651517,16.7),(74602,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74602,37.91,0.33,383,28233,70,NULL,NULL,'2MASX J10474900+4351295',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000111,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,161.954,43.85817,0,NULL,64139407889,1002178248,15659035,18.4),(74603,'GCLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74603,29.15,0.25,6.8,28234,NULL,NULL,NULL,'MESSIER 105',NULL,'1985AJ.....90.2027P',1985,1,5.4,NULL,'G',0.000008,NULL,'10.24',4.8,'E1             LINER','in a triple',NULL,NULL,NULL,1,161.956625,12.58161,0.049,NULL,61190844023,956106937,14939170,10.24),(74604,'GCLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74604,29.62,0.56,8.39,28234,NULL,NULL,'HST KP Calibrated, B','MESSIER 105',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74605,'GCLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74605,29.74,0.3,8.87,28234,NULL,NULL,'blue GCs, TOM(V) = -7.17 mag','MESSIER 105',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74606,'GCLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74606,30.23,0.06,11.1,28234,NULL,NULL,NULL,'MESSIER 105',NULL,'2001AJ....121.2950K',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74607,'GCLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74607,30.41,0.22,12.1,28234,NULL,NULL,'all GCs, TOM(V) = -7.63 mag','MESSIER 105',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74608,'GCLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74608,30.57,0.32,13,28234,NULL,NULL,'red GCs, TOM(V) = -7.55 mag','MESSIER 105',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74609,'PNLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74609,29.8,NULL,9.1,28234,NULL,NULL,NULL,'MESSIER 105',NULL,'1988ASPC....4..203C',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74610,'PNLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74610,29.8,NULL,9.12,28234,NULL,NULL,NULL,'MESSIER 105',NULL,'1988ASPC....4...42J',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74611,'PNLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74611,29.9,0.11,9.55,28234,NULL,NULL,NULL,'MESSIER 105',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74612,'PNLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74612,29.96,0.15,9.8,28234,NULL,NULL,'45 PNe','MESSIER 105',NULL,'1989ApJ...344..715C',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74613,'PNLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74613,30.01,0.09,10,28234,NULL,NULL,'I','MESSIER 105',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74614,'PNLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74614,30.01,0.15,10,28234,NULL,NULL,'HST KP Calibrated','MESSIER 105',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74615,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74615,29.7,NULL,8.8,28234,NULL,NULL,'I','MESSIER 105',NULL,'1989ApJ...346L..57T',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74616,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74616,29.85,0.2,9.3,28234,NULL,NULL,'I','MESSIER 105',NULL,'1993A&A...275..433B',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74617,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74617,29.87,0.07,9.42,28234,NULL,NULL,'I','MESSIER 105',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74618,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74618,29.91,0.09,9.59,28234,NULL,NULL,'K','MESSIER 105',NULL,'1994ApJ...433..567P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74619,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74619,29.96,NULL,9.8,28234,NULL,NULL,'I','MESSIER 105',NULL,'1988AJ.....96..807T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74620,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74620,29.96,0.11,9.82,28234,NULL,NULL,'I','MESSIER 105',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74621,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74621,30.08,0.08,10.4,28234,NULL,NULL,'I','MESSIER 105',NULL,'1997AJ....114..626A',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74622,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74622,30.12,0.11,10.6,28234,NULL,NULL,NULL,'MESSIER 105',NULL,'2001ApJ...550..503J',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74623,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74623,30.12,0.11,10.6,28234,NULL,NULL,'I, MK = -5.40 mag','MESSIER 105',NULL,'2001A&A...366...54M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74624,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74624,30.12,0.04,10.6,28234,NULL,NULL,'I','MESSIER 105',NULL,'1990AJ....100.1416T',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74625,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74625,30.12,0.11,10.6,28234,NULL,NULL,'I','MESSIER 105',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74626,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74626,30.12,0.11,10.6,28234,NULL,NULL,NULL,'MESSIER 105',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74627,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74627,30.14,0.11,10.7,28234,NULL,NULL,'Malmquist cor.','MESSIER 105',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74628,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74628,30.14,0.15,10.7,28234,NULL,NULL,'I','MESSIER 105',NULL,'1999ApJ...515...79P',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74629,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74629,30.14,0.06,10.7,28234,NULL,NULL,'I','MESSIER 105',NULL,'1997ApJ...475..399T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74630,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74630,30.15,0.15,10.7,28234,NULL,NULL,NULL,'MESSIER 105',NULL,'2002BaltA..11..385F',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74631,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74631,30.18,0.14,10.9,28234,NULL,NULL,'HST KP Calibrated, I','MESSIER 105',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74632,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74632,30.25,0.07,11.2,28234,74.4,NULL,NULL,'MESSIER 105',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74633,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74633,30.28,0.11,11.4,28234,NULL,NULL,NULL,'MESSIER 105',NULL,'1996AJ....111..208S',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74634,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74634,30.31,0.12,11.5,28234,NULL,NULL,'HST KP Calibrated, F814W','MESSIER 105',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74635,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74635,30.48,0.14,12.5,28234,NULL,NULL,'HST KP Calibrated, Ks','MESSIER 105',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74636,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74636,30.5,0.11,12.6,28234,NULL,NULL,'I','MESSIER 105',NULL,'1998MNRAS.298..451M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74637,'TRGB','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74637,30.1,0.16,10.5,28234,NULL,NULL,'I','MESSIER 105',NULL,'2007ApJ...666..903H',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74638,'TRGB','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74638,30.14,0.14,10.7,28234,NULL,NULL,NULL,'MESSIER 105',NULL,'2004AJ....127.1441G',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74639,'TRGB','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74639,30.25,0.07,11.2,28234,74.4,NULL,NULL,'MESSIER 105',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74640,'TRGB','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74640,30.3,0.14,11.5,28234,NULL,NULL,NULL,'MESSIER 105',NULL,'1997ApJ...478...49S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74641,'TRGB','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74641,30.33,0.11,11.6,28234,NULL,NULL,'HST KP Calibrated','MESSIER 105',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74642,'TRGB','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74642,30.44,0.13,12.2,28234,NULL,NULL,'DA90','MESSIER 105',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74643,'TRGB','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74643,30.46,0.16,12.4,28234,NULL,NULL,'mean of 3','MESSIER 105',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74644,'TRGB','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74644,30.48,0.13,12.5,28234,NULL,NULL,'K97','MESSIER 105',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74645,'TRGB','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74645,30.53,0.09,12.8,28234,NULL,NULL,'Yale','MESSIER 105',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74646,'D-Sigma','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74646,29.99,0.4,9.96,28234,75,NULL,'Edat, raw','MESSIER 105',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74647,'D-Sigma','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74647,30.19,0.4,10.9,28234,75,NULL,'Edat, cor','MESSIER 105',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74648,'Faber-Jackson','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74648,29.69,0.3,8.67,28234,95,NULL,'de Vaucouleurs','MESSIER 105',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74649,'Faber-Jackson','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74649,29.99,0.23,9.95,28234,95,NULL,'Weighted Mean','MESSIER 105',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74650,'Faber-Jackson','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74650,30.29,0.63,11.4,28234,95,NULL,'Michard 1979b, c','MESSIER 105',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74651,'Faber-Jackson','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74651,30.35,NULL,11.7,28234,NULL,NULL,'LEDA [April 2006]','MESSIER 105',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74652,'Faber-Jackson','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74652,30.51,0.46,12.6,28234,95,NULL,'Michard 1979a','MESSIER 105',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74653,'Faber-Jackson','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74653,31.96,0.81,24.7,28234,55,NULL,'Visvanathan & Sandage 1979','MESSIER 105',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74654,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74654,30.24,0.41,11.2,28234,NULL,NULL,NULL,'MESSIER 105',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74655,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74655,30.32,NULL,11.6,28234,NULL,NULL,NULL,'MESSIER 105',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74656,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74656,30.54,0.41,12.8,28234,NULL,NULL,'Malmquist cor.','MESSIER 105',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74657,'Tertiary','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74657,29.92,0.32,9.64,28234,95,NULL,NULL,'MESSIER 105',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74658,'Tully est','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74658,29.54,0.8,8.1,28234,75,NULL,'B','MESSIER 105',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74659,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74659,35.52,0.66,127,28235,70,NULL,NULL,'2MASX J10474984-2952391',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.5b',NULL,'E',NULL,NULL,NULL,NULL,1,161.9577917,-29.87758,0.221,NULL,41500648974,648447640,10131994,16.5),(74660,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74660,36.87,0.33,237,28236,70,NULL,NULL,'2MASX J10475108+1953370',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.0001,NULL,'16.02',0.28,NULL,NULL,NULL,NULL,NULL,1,161.9627917,19.89353,0.029,NULL,60980659194,952822799,14887856,16.02),(74661,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74661,37.91,0.46,382,28237,70,NULL,NULL,'SDSS J104752.17+002841.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000058,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,161.967375,0.47817,0.053,NULL,60271614828,941743981,14714749,18.6),(74662,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74662,38.16,0.46,429,28238,70,NULL,NULL,'2MASX J10475274+1327046',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000175,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,161.9697917,13.45131,0.045,NULL,61194168153,956158877,14939982,17.4),(74663,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74663,35.98,0.33,157,28239,70,NULL,NULL,'MCG +05-26-010',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000193,NULL,'15.4g',0.51,NULL,NULL,NULL,NULL,NULL,1,161.970833,30.63767,0.018,NULL,60504402205,945381284,14771582,15.4),(74664,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74664,37.7,0.46,346,28240,70,NULL,NULL,'2MASX J10475719+5355333',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000141,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,161.988291667,53.92597,0,NULL,61959610936,968118920,15126858,17.5),(74665,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74665,37.67,0.46,342,28241,70,NULL,NULL,'2MASX J10475792+2354560',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,161.9912917,23.91558,0.025,NULL,60975009144,952734517,14886476,17.7),(74666,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74666,38.78,0.46,569,28242,70,NULL,NULL,'2MASX J10475876+6445069',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000082,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,161.994833,64.75192,0.005,NULL,61834159404,966158740,15096230,17.7),(74667,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74667,38.08,0.46,413,28243,70,NULL,NULL,'2MASX J10475933+1526086',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,161.997167,15.43583,0.033,NULL,61201344821,956271012,14941734,17.4),(74668,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74668,38.2,0.15,437,28244,70,NULL,NULL,'SDSS J104759.36+010016.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00006,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,161.997333,1.00469,0.077,NULL,60272052901,941750826,14714856,18),(74669,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74669,37.47,0.23,312,28245,70,NULL,NULL,'2MASX J10480039+0455444',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000178,NULL,'17.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,162.001667,4.92897,0.065,NULL,61006752167,953230502,14894226,17.3),(74670,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74670,36.73,0.15,222,28246,70,NULL,NULL,'2MASX J10480239+2222230',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.59',0.21,NULL,NULL,NULL,NULL,NULL,1,162.010083,22.37303,0.005,NULL,60981563617,952836931,14888077,17.59),(74671,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74671,36.22,0.46,176,28247,70,NULL,NULL,'2MASX J10480302+2119240',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.59',0.21,NULL,NULL,NULL,NULL,NULL,1,162.0125417,21.32339,0.013,NULL,60981486875,952835732,14888058,17.59),(74672,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74672,37.06,0.46,259,28248,70,NULL,NULL,'SDSS J104803.29+502652.1',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00016,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,162.01375,50.44783,0,NULL,63908412538,998568945,15602639,17.4),(74673,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74673,34.83,0.57,92.6,28249,70,NULL,NULL,'2MASX J10480421-1717374',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.96',NULL,NULL,NULL,NULL,NULL,NULL,1,162.017583,-17.29389,0.097,NULL,41862956987,654108702,10220448,15.96),(74674,'Tully est','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74674,32.9,0.8,38,28250,75,NULL,'B','NGC 3390',NULL,'1988NBGC.C....0000T',1988,1,3.5,NULL,'G',0.000053,NULL,'12.85',0.6,'Sb       poss. LINER','Pair member (points to parent)',NULL,NULL,NULL,1,162.018167,-31.53336,0.289,NULL,41499905866,648436029,10131812,12.85),(74675,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74675,32.43,0.47,30.7,28250,NULL,NULL,'H','NGC 3390',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74676,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74676,32.46,0.46,31,28250,NULL,NULL,'J','NGC 3390',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74677,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74677,32.48,0.45,31.3,28250,NULL,NULL,'K','NGC 3390',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74678,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74678,32.62,0.49,33.4,28250,75,NULL,'IR','NGC 3390',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74679,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74679,33.14,0.4,42.5,28250,NULL,NULL,'mean','NGC 3390',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74680,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74680,34.37,0.49,74.8,28251,70,NULL,NULL,'2MASX J10480441-1228294',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000137,NULL,'15.48',NULL,'S0-a',NULL,NULL,NULL,NULL,1,162.0185417,-12.47489,0.117,NULL,41867660101,654182189,10221596,15.48),(74681,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74681,38.1,0.46,417,28252,70,NULL,NULL,'SDSS J104804.47+524816.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000143,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,162.018667,52.80467,0,NULL,61961931007,968155171,15127424,18.6),(74682,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74682,35.29,0.55,114,28253,70,NULL,NULL,'CGCG 010-017',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000064,NULL,'14.49',0.5,'Sbc',NULL,NULL,NULL,NULL,1,162.019833333,-1.92744,0.077,NULL,40882306342,638786036,9981031,14.49),(74683,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74683,35.86,0.46,148,28254,70,NULL,NULL,'2MASX J10480576+0601142',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000158,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,162.024125,6.02067,0.061,NULL,61061567200,954086987,14907609,16.8),(74684,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74684,35.08,0.53,104,28255,70,NULL,NULL,'2MASX J10480678-1821410',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.03',NULL,NULL,NULL,NULL,NULL,NULL,1,162.028375,-18.36136,0.097,NULL,41851660246,653932191,10217690,16.03),(74685,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','PS1 SN PS10af','N',74685,40.47,0.11,999,28256,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10af HOST',0.2445,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74686,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74686,35.44,0.46,122,28257,70,NULL,NULL,'2MASX J10480789+0618192',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000167,NULL,'16.0g',0.42,'AGN+SF',NULL,NULL,NULL,NULL,1,162.0327917,6.30539,0.057,NULL,61061496337,954085880,14907591,16),(74687,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74687,37.31,0.46,290,28258,70,NULL,NULL,'2MASX J10480800+0022497',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000088,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,162.033458333,0.38053,0.053,NULL,60271592202,941743628,14714744,16.8),(74688,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74688,34.31,0.46,72.9,28259,70,NULL,NULL,'IC 0642',NULL,'2015arXiv151105856S',2015,1,1.4,NULL,'G',0.000077,NULL,'13.63',1.3,'E?','Field galaxy',NULL,NULL,NULL,1,162.033875,18.18869,0.037,NULL,61157593627,955587400,14931053,13.63),(74689,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74689,37.9,0.33,380,28260,70,NULL,NULL,'2MASX J10480815+3917366',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,162.034166667,39.2935,0,NULL,64120757463,1001886835,15654481,18),(74690,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74690,37.47,0.23,312,28261,70,NULL,NULL,'2MASX J10480888+0457557',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.0002,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,162.037041667,4.96544,0.065,NULL,61006754145,953230533,14894227,16.3),(74691,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74691,37.9,0.33,380,28262,70,NULL,NULL,'2MASX J10480961+3915186',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,162.0399583,39.25519,0,NULL,64120757084,1001886829,15654481,17.2),(74692,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74692,37.36,0.46,297,28263,70,NULL,NULL,'SDSS J104809.66+145758.5',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.5g',0.27,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,162.0402917,14.96628,0.045,NULL,61201290699,956270167,14941721,16.5),(74693,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74693,38.2,0.15,437,28264,70,NULL,NULL,'SDSS J104809.87+005716.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000065,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,162.041125,0.95469,0.077,NULL,60272090567,941751415,14714865,18.1),(74694,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74694,37.69,0.46,346,28265,70,NULL,NULL,'2MASX J10481090+3102531',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000165,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,162.045375,31.04803,0.017,NULL,60504152239,945377378,14771521,16.9),(74695,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74695,38.37,0.46,471,28266,70,NULL,NULL,'SDSS J104810.97+544908.1',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000111,NULL,'18.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,162.04575,54.81894,0,NULL,61975025235,968359769,15130621,18),(74696,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74696,34.69,0.46,86.8,28267,70,NULL,NULL,'NGC 3385',NULL,'2015arXiv151105856S',2015,1,1.43,NULL,'G',0.000167,NULL,'13.8g',0.72,'S0','Possible field galaxy',NULL,NULL,NULL,1,162.048458333,4.92775,0.081,NULL,61006751368,953230490,14894226,13.8),(74697,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74697,36.85,0.46,235,28268,70,NULL,NULL,'2MASX J10481172+2356433',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.47',0.25,'E',NULL,NULL,NULL,NULL,1,162.048875,23.94556,0.035,NULL,60975001399,952734396,14886474,16.47),(74698,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74698,35.31,0.46,116,28269,70,NULL,NULL,'NGC 3386',NULL,'2015arXiv151105856S',2015,1,0.84,'NGC 3387 is small group of stars at 10h48m17s +04d58.0m (2000).','G',0.00013,NULL,'14.6g',0.76,'E','Group member',NULL,NULL,NULL,1,162.049625,4.99858,0.065,NULL,61006756198,953230565,14894227,14.6),(74699,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74699,29.01,0.43,6.3,28270,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3380',NULL,'2014MNRAS.444..527S',2014,1,1.41,NULL,'G',0.00003,NULL,'13.3g',0.97,'(R\')SBa?','Possible field galaxy',NULL,NULL,NULL,1,162.05075,28.60178,0,NULL,60530916926,945795576,14778055,13.3),(74700,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74700,29.37,0.43,7.5,28270,75,NULL,'3.6 micron, color corrected','NGC 3380',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74701,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74701,30.95,0.69,15.5,28270,100,NULL,'mid-IR','NGC 3380',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74702,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74702,34.87,0.2,94.2,28271,74.4,NULL,NULL,'MRK 1439',NULL,'2013AJ....146...86T',2013,1,0.59,NULL,'G',0.000104,NULL,'15.4g',0.37,'SBab(r)',NULL,NULL,NULL,NULL,1,162.0585,13.21703,0.041,NULL,61191451005,956116421,14939319,15.4),(74703,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74703,36.86,0.27,236,28272,70,NULL,NULL,'2MASX J10481419+1221415',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.74',0.26,NULL,NULL,NULL,NULL,NULL,1,162.0592083,12.36156,0.029,NULL,61190955319,956108676,14939198,16.74),(74704,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74704,36.87,0.46,237,28273,70,NULL,NULL,'2MASX J10481672+3938335',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,162.069625,39.64256,0,NULL,64120937969,1001889655,15654525,16.5),(74705,'GCLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74705,30.15,0.12,10.7,28274,NULL,NULL,'blue GCs, TOM(V) = -7.17 mag','NGC 3384',NULL,'2001AJ....121.2974L',2001,1,5.5,'Identification as NGC 3371 is not certain.','G',0.000008,NULL,'10.85',2.5,'SB(s)0-:','in a triple',NULL,NULL,NULL,1,162.070375,12.62928,0.069,NULL,61191581036,956118453,14939350,10.85),(74706,'GCLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74706,30.93,0.12,15.3,28274,NULL,NULL,'all GCs, TOM(V) = -7.63 mag','NGC 3384',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74707,'GCLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74707,31.92,0.3,24.2,28274,NULL,NULL,'red GCs, TOM(V) = -7.55 mag','NGC 3384',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74708,'PNLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74708,29.87,NULL,9.4,28274,NULL,NULL,NULL,'NGC 3384',NULL,'1988ASPC....4..203C',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74709,'PNLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74709,29.87,NULL,9.42,28274,NULL,NULL,NULL,'NGC 3384',NULL,'1988ASPC....4...42J',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74710,'PNLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74710,29.98,0.11,9.91,28274,NULL,NULL,NULL,'NGC 3384',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74711,'PNLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74711,30.03,0.15,10.1,28274,NULL,NULL,'43 PNe','NGC 3384',NULL,'1989ApJ...344..715C',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74712,'PNLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74712,30.09,0.09,10.4,28274,NULL,NULL,'I','NGC 3384',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74713,'PNLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74713,30.09,0.15,10.4,28274,NULL,NULL,'HST KP Calibrated','NGC 3384',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74714,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74714,29.88,0.12,9.46,28274,NULL,NULL,'I','NGC 3384',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74715,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74715,30.01,0.08,10.1,28274,74.4,NULL,NULL,'NGC 3384',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74716,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74716,30.11,0.13,10.5,28274,NULL,NULL,'I','NGC 3384',NULL,'1997AJ....114..626A',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74717,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74717,30.16,0.14,10.8,28274,NULL,NULL,'I','NGC 3384',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74718,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74718,30.32,0.14,11.6,28274,NULL,NULL,'I','NGC 3384',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74719,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74719,30.32,0.14,11.6,28274,NULL,NULL,NULL,'NGC 3384',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74720,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74720,30.34,0.11,11.7,28274,NULL,NULL,'HST KP Calibrated, F814W','NGC 3384',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74721,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74721,30.36,0.14,11.8,28274,NULL,NULL,'Malmquist cor.','NGC 3384',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74722,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74722,30.38,0.16,11.9,28274,NULL,NULL,'HST KP Calibrated, I','NGC 3384',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74723,'TRGB','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74723,30.01,0.08,10.1,28274,74.4,NULL,NULL,'NGC 3384',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74724,'TRGB','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74724,30.42,0.09,12.1,28274,NULL,NULL,'I','NGC 3384',NULL,'2009ApJ...694.1331M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74725,'Faber-Jackson','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74725,29.46,0.63,7.8,28274,95,NULL,'Michard 1979b, c','NGC 3384',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74726,'Faber-Jackson','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74726,29.74,0.27,8.87,28274,95,NULL,'Weighted Mean','NGC 3384',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74727,'Faber-Jackson','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74727,29.76,0.41,8.95,28274,95,NULL,'de Vaucouleurs','NGC 3384',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74728,'Faber-Jackson','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74728,30.01,0.46,10,28274,95,NULL,'Michard 1979a','NGC 3384',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74729,'Faber-Jackson','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74729,30.04,NULL,10.2,28274,NULL,NULL,'LEDA [April 2006]','NGC 3384',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74730,'Faber-Jackson','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74730,31.18,0.81,17.2,28274,55,NULL,'Visvanathan & Sandage 1979','NGC 3384',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74731,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74731,29.87,NULL,9.42,28274,NULL,NULL,NULL,'NGC 3384',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74732,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74732,30,0.41,9.99,28274,NULL,NULL,NULL,'NGC 3384',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74733,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74733,30.31,0.41,11.5,28274,NULL,NULL,'Malmquist cor.','NGC 3384',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74734,'Tertiary','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74734,29.92,0.32,9.64,28274,95,NULL,NULL,'NGC 3384',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74735,'Tully est','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74735,29.54,0.8,8.1,28274,75,NULL,'B','NGC 3384',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74736,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74736,36.86,0.27,236,28275,70,NULL,NULL,'2MASX J10481768+1228045',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,162.0737083,12.46786,0.029,NULL,61190877179,956107455,14939178,17.4),(74737,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74737,36.75,0.33,224,28276,70,NULL,NULL,'2MASX J10481770+0737412',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000145,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,162.073791667,7.62819,0.089,NULL,61062542598,954102228,14907847,17.2),(74738,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74738,37.3,0.46,288,28277,70,NULL,NULL,'2MASX J10481855+2042470',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,162.077333,20.71303,0.009,NULL,60979990173,952812346,14887692,18.1),(74739,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74739,34.7,0.46,87.1,28278,70,NULL,NULL,'CGCG 241-013',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.000157,NULL,'14.6g',0.41,'S0?','in a pair',NULL,NULL,NULL,1,162.080375,50.02306,0,NULL,63908458919,998569670,15602651,14.6),(74740,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74740,37.24,0.46,281,28279,70,NULL,NULL,'2MASX J10481970+1025112',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,162.082,10.41983,0.041,NULL,61052819378,953950302,14905473,17.5),(74741,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74741,38.28,0.46,452,28280,70,NULL,NULL,'2MASX J10482056+6653045',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000084,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,162.0859583,66.88456,0.009,NULL,62130908104,970795439,15168678,17.5),(74742,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74742,38.01,0.46,399,28281,70,NULL,NULL,'2MASX J10482118+3114154',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000148,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,162.088416667,31.23767,0.021,NULL,60505471409,945397990,14771843,18.3),(74743,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74743,36.51,0.46,200,28282,70,NULL,NULL,'2MASX J10482132+0126007',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000144,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,162.088666667,1.43353,0.073,NULL,60271256600,941738384,14714662,17),(74744,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74744,35.25,0.54,112,28283,70,NULL,NULL,'2MASX J10482143-1447505',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.80',NULL,NULL,NULL,NULL,NULL,NULL,1,162.089375,-14.79767,0.165,NULL,41868716275,654198691,10221854,15.8),(74745,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','PS1 SN PS10ix','N',74745,41.7,0.15,1590,28284,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10ix HOST',0.3815,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74746,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74746,37.36,0.46,296,28285,70,NULL,NULL,'2MASX J10482360+6121541',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000173,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,162.098125,61.36511,0,NULL,61951775116,967996486,15124945,17),(74747,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74747,36.16,0.66,170,28286,70,NULL,NULL,'2MASX J10482373-4437577',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.5,NULL,NULL,NULL,NULL,NULL,1,162.099,-44.63267,0.717,NULL,42099143924,657799123,10278111,13.9),(74748,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74748,37.24,0.46,280,28287,70,NULL,NULL,'2MASX J10482427+0516107',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000196,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,162.101166667,5.26967,0.045,NULL,61007031494,953234867,14894294,16.3),(74749,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74749,36.86,0.27,236,28288,70,NULL,NULL,'2MASX J10482468+1228270',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000177,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,162.102875,12.47431,0.057,NULL,61190875104,956107423,14939178,16.5),(74750,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74750,38.03,0.46,404,28289,70,NULL,NULL,'SDSS J104825.42+015033.3',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,162.1059583,1.84261,0.081,NULL,60269427002,941709796,14714215,17.8),(74751,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74751,36.75,0.33,224,28290,70,NULL,NULL,'SDSS J104825.48+073552.5',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,162.106167,7.59794,0.089,NULL,61062415534,954100242,14907816,17.1),(74752,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74752,36.51,0.46,200,28291,70,NULL,NULL,'2MASX J10482634+2318400',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.62',0.19,NULL,NULL,NULL,NULL,NULL,1,162.109875,23.31108,0.021,NULL,60975386861,952740419,14886569,17.62),(74753,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1967C','R',74753,32.52,NULL,31.9,28292,NULL,NULL,'Photographic','NGC 3389',NULL,'1988SSRv...48....1R',1988,1,2.8,'Identification as NGC 3373 is not certain.','G',0.000019,NULL,'12.3B',1.3,'SA(s)c','in a triple',NULL,NULL,NULL,1,162.1162917,12.53319,0.057,NULL,61190880477,956107507,14939179,12.3),(74754,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1967C',NULL,74754,32.58,0.3,32.8,28292,60,NULL,'M(B) = -19.48 mag','NGC 3389',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74755,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1967C',NULL,74755,32.6,0.3,33.1,28292,60,NULL,'M(V) = -19.47 mag','NGC 3389',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74756,'SNII optical','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 2009md',NULL,74756,31.38,NULL,18.9,28292,73,NULL,'SCM','NGC 3389',NULL,'2011MNRAS.417.1417F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74757,'SNII optical','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 2009md',NULL,74757,31.44,0.09,19.4,28292,NULL,NULL,'EPM, H01','NGC 3389',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74758,'SNII optical','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 2009md',NULL,74758,31.63,0.55,21.2,28292,73,NULL,'SCM, NIR','NGC 3389',NULL,'2011MNRAS.417.1417F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74759,'SNII optical','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 2009md',NULL,74759,31.84,0.18,23.3,28292,NULL,NULL,'EPM, D05','NGC 3389',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74760,'SNII optical','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 2009md',NULL,74760,32.01,0.14,25.2,28292,NULL,NULL,'SCM','NGC 3389',NULL,'2015ApJ...799..215P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74761,'SNII optical','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 2009md',NULL,74761,32.15,0.24,26.9,28292,NULL,NULL,'V, photospheric magnitude method','NGC 3389',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74762,'SNII optical','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 2009md',NULL,74762,32.25,0.19,28.2,28292,NULL,NULL,'I, photospheric magnitude method','NGC 3389',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74763,'Sosies','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74763,31.43,0.14,19.3,28292,NULL,NULL,NULL,'NGC 3389',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74764,'Tully est','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74764,31.76,0.8,22.5,28292,75,NULL,'B','NGC 3389',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74765,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74765,31.3,0.3,18.2,28292,NULL,18.45,'SN 1967C host','NGC 3389',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74766,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74766,31.47,0.43,19.7,28292,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3389',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74767,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74767,31.52,0.43,20.1,28292,75,NULL,'3.6 micron, color corrected','NGC 3389',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74768,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74768,31.53,0.52,20.2,28292,NULL,NULL,'Malmquist cor.','NGC 3389',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74769,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74769,31.59,0.2,20.8,28292,74.4,NULL,NULL,'NGC 3389',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74770,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74770,31.65,0.36,21.4,28292,NULL,NULL,NULL,'NGC 3389',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74771,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74771,31.79,0.46,22.8,28292,NULL,NULL,NULL,'NGC 3389',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74772,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74772,31.95,0.3,24.6,28292,55,NULL,'B','NGC 3389',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74773,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74773,37.42,0.46,304,28293,70,NULL,NULL,'2MASX J10482866+0039388',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000067,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,162.119583,0.66078,0.053,NULL,60271456754,941741511,14714711,17.8),(74774,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74774,37,0.46,251,28294,70,NULL,NULL,'2MASX J10482996+1931230',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.33',0.15,NULL,NULL,NULL,NULL,NULL,1,162.124917,19.52294,0.069,NULL,60977079887,952766873,14886982,18.33),(74775,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74775,37.15,0.46,270,28295,70,NULL,NULL,'2MASX J10483094+3332105',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000168,NULL,'16.7g',0.3,'AGN',NULL,NULL,NULL,NULL,1,162.1287917,33.53617,0,NULL,64041728765,1000652011,15635187,16.7),(74776,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74776,37.88,0.33,376,28296,70,NULL,NULL,'SDSS J104830.93+315408.1',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,162.128917,31.90228,0.036,NULL,60514253454,945535210,14773987,17.6),(74777,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74777,37.49,0.46,315,28297,70,NULL,NULL,'2MASX J10483203+3458485',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,162.133375,34.98022,0,NULL,64042659708,1000666557,15635414,17.5),(74778,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74778,37.88,0.33,376,28298,70,NULL,NULL,'2MASX J10483232+3150095',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000195,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,162.1347083,31.83614,0.036,NULL,60513723730,945526933,14773858,16.7),(74779,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74779,37.55,0.46,324,28299,70,NULL,NULL,'2MASX J10483246+3851541',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000164,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,162.135125,38.86514,0,NULL,64121136527,1001892758,15654574,16.9),(74780,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74780,37.41,0.46,304,28300,70,NULL,NULL,'2MASX J10483295+5323459',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000135,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,162.137291667,53.396,0,NULL,61960100124,968126564,15126977,17.3),(74781,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74781,36.73,0.15,222,28301,70,NULL,NULL,'2MASX J10483371+2208009',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.1g',0.32,NULL,NULL,NULL,NULL,NULL,1,162.1405,22.13356,0.017,NULL,60984506008,952882906,14888795,16.1),(74782,'Cepheids','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74782,30.08,0.06,10.4,28302,NULL,NULL,'HST KP Calibrated','MESSIER 096 GROUP',NULL,'2000ApJ...529..745F',2000,1,NULL,NULL,'GGroup',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,162.144541667,12.67081,0.069,NULL,61191585127,956118517,14939351,NULL),(74783,'GCLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74783,29.62,0.56,8.39,28302,NULL,NULL,'HST KP Calibrated, B','MESSIER 096 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74784,'PNLF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74784,30.01,0.07,10,28302,NULL,NULL,'HST KP Calibrated','MESSIER 096 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74785,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74785,30.26,0.07,11.3,28302,NULL,NULL,'HST KP Calibrated, F814W','MESSIER 096 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74786,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74786,30.3,0.06,11.5,28302,NULL,NULL,'HST KP Calibrated, I','MESSIER 096 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74787,'SBF','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74787,30.48,0.14,12.5,28302,NULL,NULL,'HST KP Calibrated, Ks','MESSIER 096 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74788,'TRGB','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74788,30.33,0.11,11.6,28302,NULL,NULL,'HST KP Calibrated','MESSIER 096 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74789,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74789,36.73,0.15,222,28303,70,NULL,NULL,'2MASX J10483411+2232379',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.99',0.2,NULL,NULL,NULL,NULL,NULL,1,162.142125,22.54378,0,NULL,60984405611,952881337,14888770,16.99),(74790,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74790,36.94,0.46,244,28304,70,NULL,NULL,'2MASX J10483489+1747070',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.27',0.18,NULL,NULL,NULL,NULL,NULL,1,162.145333,17.78542,0.045,NULL,61187291372,956051427,14938303,18.27),(74791,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74791,37.71,0.46,348,28305,70,NULL,NULL,'2MASX J10483626+2733271',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00015,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,162.151125,27.55772,0,NULL,60529892957,945779577,14777805,18.4),(74792,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74792,34.44,0.49,77.4,28306,75,NULL,'IR','UGC 05904',NULL,'2011yCatp016004901K',2011,1,0.76,'Component \'b)\' in UGC notes.','G',0.000047,NULL,'13.9g',0.38,'Sb             NLAGN','Pair member (points to parent)',NULL,NULL,'Sy 2',1,162.1580417,66.362,0.013,NULL,62113870401,970529225,15164519,13.9),(74793,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74793,34.6,0.45,83.3,28306,NULL,NULL,'K','UGC 05904',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74794,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74794,34.62,0.47,83.9,28306,NULL,NULL,'H','UGC 05904',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74795,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74795,34.77,0.46,90,28306,NULL,NULL,'J','UGC 05904',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74796,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74796,34.84,0.4,92.9,28306,NULL,NULL,'mean','UGC 05904',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74797,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74797,38.36,0.33,470,28307,70,NULL,NULL,'SDSS J104838.66+501544.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000143,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,162.161083,50.26242,0,NULL,63908587787,998571684,15602682,18.6),(74798,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74798,38.34,0.46,465,28308,70,NULL,NULL,'2MASX J10483878+3701221',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,162.161541667,37.02272,0,NULL,64108685187,1001698206,15651534,17.5),(74799,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74799,36.59,0.71,208,28309,70,NULL,NULL,'2MASX J10484213-4715266',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.5J',NULL,NULL,NULL,NULL,NULL,NULL,1,162.175583,-47.25739,0.757,NULL,41919120791,654986262,10234160,13.5),(74800,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74800,37.79,0.46,362,28310,70,NULL,NULL,'2MASX J10484282+2407291',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.15',0.12,NULL,NULL,NULL,NULL,NULL,1,162.178375,24.12489,0.016,NULL,60491843341,945185052,14768516,18.15),(74801,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74801,36.93,0.21,243,28311,70,NULL,NULL,'2MASX J10484280+1717320',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,162.1785417,17.29214,0.033,NULL,61190038848,956094357,14938974,16.6),(74802,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74802,36.73,0.15,222,28312,70,NULL,NULL,'2MASX J10484294+2218536',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.43',0.13,NULL,NULL,NULL,NULL,NULL,1,162.179,22.315,0.005,NULL,60984416548,952881508,14888773,18.43),(74803,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74803,36.27,0.53,179,28313,70,NULL,NULL,'2MASX J10484331-4717196',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'12.3J',NULL,'E0: pec',NULL,NULL,NULL,NULL,1,162.18025,-47.28883,0.757,NULL,41919134942,654986483,10234163,12.3),(74804,'IRAS','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74804,34.44,0.8,77.4,28314,75,NULL,'MAT, I','ESO 264- G 043',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000033,NULL,'14.63',0.5,'Sb',NULL,NULL,NULL,NULL,1,162.1812917,-45.41994,0.581,NULL,42098782680,657793479,10278023,14.63),(74805,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74805,34.03,0.47,64.1,28314,NULL,NULL,'H','ESO 264- G 043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74806,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74806,34.07,0.43,65.3,28314,75,NULL,'MAT, I, raw','ESO 264- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74807,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74807,34.1,0.45,66.2,28314,NULL,NULL,'K','ESO 264- G 043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74808,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74808,34.12,0.46,66.7,28314,NULL,NULL,'J','ESO 264- G 043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74809,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74809,34.17,0.49,68.1,28314,75,NULL,'IR','ESO 264- G 043',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74810,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74810,34.17,0.32,68.2,28314,85,NULL,'I, raw','ESO 264- G 043',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74811,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74811,34.24,0.32,70.6,28314,85,NULL,'I, inv','ESO 264- G 043',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74812,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74812,34.33,0.29,73.5,28314,NULL,NULL,'Malmquist cor.','ESO 264- G 043',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74813,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74813,34.35,0.43,74.1,28314,75,NULL,'MAT, I, cor','ESO 264- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74814,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74814,34.39,0.43,75.4,28314,75,NULL,'MAT, I, inv','ESO 264- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74815,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74815,34.47,0.27,78.3,28314,NULL,NULL,NULL,'ESO 264- G 043',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74816,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74816,34.51,0.2,79.8,28314,74.4,NULL,NULL,'ESO 264- G 043',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74817,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74817,34.56,0.4,81.5,28314,NULL,NULL,'mean','ESO 264- G 043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74818,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74818,36.93,0.21,243,28315,70,NULL,NULL,'2MASX J10484399+1718040',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000184,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,162.183416667,17.30125,0.033,NULL,61190038869,956094357,14938974,16.6),(74819,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74819,38.1,0.33,417,28316,70,NULL,NULL,'2MASX J10484475+3834001',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,162.1865,38.56664,0,NULL,64120982437,1001890350,15654536,17.5),(74820,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74820,38.2,0.15,437,28317,70,NULL,NULL,'2MASX J10484483+0052435',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000074,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,162.186791667,0.87881,0.081,NULL,60271927418,941748865,14714826,17.9),(74821,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74821,30.3,NULL,11.5,28318,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1136',NULL,'2010Ap&SS.325..163P',2010,1,0.9,'Multiple SDSS entries describe this object.','G',NULL,NULL,'17.72',0.1,'Sd',NULL,NULL,NULL,NULL,1,162.195125,19.13461,0.081,NULL,61157912088,955592376,14931130,17.72),(74822,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74822,30.41,NULL,12.1,28318,NULL,NULL,'Dipole + Quadrupole','FGC 1136',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74823,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74823,30.48,NULL,12.5,28318,NULL,NULL,NULL,'FGC 1136',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74824,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74824,30.49,NULL,12.5,28318,NULL,NULL,'Dipole','FGC 1136',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74825,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74825,37.47,0.23,312,28319,70,NULL,NULL,'SDSS J104848.40+045631.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,162.201667,4.94214,0.081,NULL,60273072735,941766761,14715105,17.9),(74826,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74826,38.13,0.46,423,28320,70,NULL,NULL,'2MASX J10484877+4718240',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000127,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,162.203458333,47.30675,0,NULL,63910919143,998608111,15603251,17.5),(74827,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74827,36.17,0.46,171,28321,70,NULL,NULL,'2MASX J10484891+6636365',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000078,NULL,'15.4g',0.53,'E0',NULL,NULL,NULL,NULL,1,162.2037083,66.61011,0.013,NULL,62131002654,970796916,15168701,15.4),(74828,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74828,37.18,0.46,272,28322,70,NULL,NULL,'2MASX J10484957+3446334',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,162.2065417,34.77606,0,NULL,64042762643,1000668166,15635440,18),(74829,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74829,36.41,0.46,192,28323,70,NULL,NULL,'CGCG 095-027',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000067,NULL,'15.3g',0.54,NULL,NULL,NULL,NULL,NULL,1,162.207417,17.12511,0.033,NULL,61190485513,956101336,14939083,15.3),(74830,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74830,37.96,0.46,391,28324,70,NULL,NULL,'2MASX J10485003+3259384',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000178,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,162.208625,32.994,0,NULL,64040961634,1000640025,15635000,17.4),(74831,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74831,36.73,0.15,222,28325,70,NULL,NULL,'2MASX J10485038+2211587',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.01',0.17,NULL,NULL,NULL,NULL,NULL,1,162.2099583,22.19964,0.017,NULL,60984630700,952884854,14888825,18.01),(74832,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1996cf','R',74832,41.74,NULL,1420,28326,65,NULL,'SALT','H-ZSNS J104850.96+000330.4',0.57,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,'Scd',NULL,NULL,NULL,NULL,1,162.212333,0.05844,0.061,NULL,60268589665,941696713,14714011,NULL),(74833,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1996cf',NULL,74833,41.96,0.48,1570,28326,74.2,NULL,'SALT 2','H-ZSNS J104850.96+000330.4',0.57,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74834,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1996cf',NULL,74834,42.74,0.4,2250,28326,70,NULL,'SALT','H-ZSNS J104850.96+000330.4',0.57,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74835,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1996cf',NULL,74835,42.77,0.19,2280,28326,65,NULL,NULL,'H-ZSNS J104850.96+000330.4',0.57,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74836,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1996cf',NULL,74836,42.9,0.38,2420,28326,65,NULL,'SALT','H-ZSNS J104850.96+000330.4',0.57,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74837,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74837,36.73,0.15,222,28327,70,NULL,NULL,'2MASX J10485103+2210067',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,162.2127083,22.16858,0.017,NULL,60984500709,952882823,14888794,16.7),(74838,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74838,36.68,0.23,217,28328,70,NULL,NULL,'2MASX J10485106+2436222',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,162.212917,24.60633,0.006,NULL,60494038068,945219344,14769052,16.6),(74839,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74839,38.1,0.33,417,28329,70,NULL,NULL,'2MASX J10485122+3831540',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,162.2135417,38.53161,0,NULL,64120993739,1001890527,15654539,17.1),(74840,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74840,36.18,0.46,172,28330,70,NULL,NULL,'2MASX J10485142-0028444',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000076,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,162.214417,-0.47906,0.061,NULL,40878053114,638719579,9979993,16.5),(74841,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74841,36.46,0.46,196,28331,70,NULL,NULL,'2MASX J10485263+0051115',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000104,NULL,'15.7g',0.34,'Sab',NULL,NULL,NULL,NULL,1,162.2192083,0.85314,0.081,NULL,60271937178,941749018,14714828,15.7),(74842,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74842,38.08,0.46,414,28332,70,NULL,NULL,'2MASX J10485501+3940053',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,162.2294583,39.66803,0,NULL,64120887087,1001888860,15654513,17.4),(74843,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74843,37.65,0.46,340,28333,70,NULL,NULL,'2MASX J10485510+4043323',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000172,NULL,'17.1g',0.25,'AGN',NULL,NULL,NULL,NULL,1,162.229625,40.72572,0,NULL,64113185180,1001768518,15652633,17.1),(74844,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74844,38.29,0.46,455,28334,70,NULL,NULL,'2MASX J10485509+0035345',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000077,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,162.2297083,0.59292,0.053,NULL,60271439317,941741239,14714706,17.5),(74845,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74845,36.68,0.23,217,28335,70,NULL,NULL,'2MASX J10485524+2436182',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,162.230333,24.60492,0.006,NULL,60494025763,945219152,14769049,17.1),(74846,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74846,37.45,0.46,309,28336,70,NULL,NULL,'2MASX J10485646+2930032',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000138,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,162.235333333,29.50078,0.025,NULL,60530125182,945783205,14777862,17.9),(74847,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74847,32.67,NULL,34.2,28337,NULL,NULL,NULL,'MRK 1263',NULL,'2015AstBu..70....1K',2015,1,0.53,'The SDSS position applies to the southern knot.','G',0.000033,NULL,'16.3g',0.24,'BCD','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,162.2369583,12.19492,0.073,NULL,61190717716,956104964,14939140,16.3),(74848,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1997ai',NULL,74848,41.12,0.46,1160,28338,74.2,NULL,'SALT 2','SCP J104857.61+003150.0',0.45,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,162.2400417,0.53056,0.065,NULL,60268667756,941697933,14714030,NULL),(74849,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1997ai','R',74849,41.46,NULL,1350,28338,65,NULL,'SALT','SCP J104857.61+003150.0',0.45,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74850,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1997ai',NULL,74850,41.8,0.37,1580,28338,70,NULL,'SALT','SCP J104857.61+003150.0',0.45,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74851,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1997ai',NULL,74851,41.93,0.36,1680,28338,65,NULL,'SALT','SCP J104857.61+003150.0',0.45,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74852,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','SN 1997ai',NULL,74852,42.1,0.23,1810,28338,65,NULL,NULL,'SCP J104857.61+003150.0',0.45,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74853,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74853,36.57,0.46,206,28339,70,NULL,NULL,'2MASX J10485833+1113335',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,162.242958333,11.22614,0.069,NULL,61023900024,953498437,14898413,16.7),(74854,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74854,32.92,NULL,38.4,28340,NULL,NULL,NULL,'CGCG 066-024',NULL,'2015AstBu..70....1K',2015,1,0.66,NULL,'G',0.0002,NULL,'16.0g',0.49,NULL,NULL,NULL,NULL,NULL,1,162.249083,10.83542,0.041,NULL,61023412695,953490823,14898294,16),(74855,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74855,36.73,0.15,222,28341,70,NULL,NULL,'2MASX J10485995+2233317',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.47',0.22,NULL,NULL,NULL,NULL,NULL,1,162.249666667,22.55886,0,NULL,60983370021,952865156,14888518,17.47),(74856,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74856,36.93,0.21,243,28342,70,NULL,NULL,'2MASX J10490166+1706497',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000173,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,162.257083,17.11378,0.033,NULL,61190666296,956104160,14939127,17.2),(74857,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74857,38.36,0.33,470,28343,70,NULL,NULL,'SDSS J104901.82+501927.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000122,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,162.257583,50.32428,0,NULL,63908566694,998571354,15602677,18.5),(74858,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74858,36.93,0.21,243,28344,70,NULL,NULL,'2MASX J10490201+1718037',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000166,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,162.2585,17.30103,0.037,NULL,61190009543,956093899,14938967,16.5),(74859,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74859,36.98,0.46,248,28345,70,NULL,NULL,'2MASX J10490215+0252585',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000204,NULL,'15.8g',0.46,'E0',NULL,NULL,NULL,NULL,1,162.259125,2.88292,0.093,NULL,60274836290,941794317,14715536,15.8),(74860,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74860,37.59,0.46,330,28346,70,NULL,NULL,'2MASX J10490301+5619103',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00019,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,162.2625,56.31939,0,NULL,61968859148,968263424,15129116,17.7),(74861,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74861,38.2,0.15,437,28347,70,NULL,NULL,'2MASX J10490337+0058275',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000058,NULL,'18.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,162.264125,0.97456,0.081,NULL,60272125785,941751965,14714874,18),(74862,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74862,37.37,0.46,298,28348,70,NULL,NULL,'2MASX J10490373+0200245',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000139,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,162.2655417,2.00672,0.081,NULL,60269406846,941709481,14714210,18),(74863,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74863,37.94,0.19,387,28349,70,NULL,NULL,'SDSS J104903.83+092832.9',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,162.2659583,9.47581,0.033,NULL,61054454437,953975850,14905872,NULL),(74864,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74864,37.94,0.33,387,28350,70,NULL,NULL,'SDSS J104903.92+092621.7',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,162.266333,9.43939,0.033,NULL,61054465898,953976029,14905875,18.6),(74865,'Tully est','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74865,32.8,0.8,36.3,28351,75,NULL,'B','UGCA 219',NULL,'1988NBGC.C....0000T',1988,1,0.54,NULL,'G',0.000055,NULL,'15.5g',0.3,'Scp',NULL,NULL,NULL,NULL,1,162.2709583,52.3355,0,NULL,61774394748,965224917,15081639,15.5),(74866,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74866,36.49,0.46,199,28352,70,NULL,NULL,'2MASX J10490544+5656293',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000156,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,162.27275,56.94169,0,NULL,62002291097,968785798,15137278,16.8),(74867,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74867,37.51,0.23,318,28353,70,NULL,NULL,'2MASX J10490580+2334162',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.90',0.17,NULL,NULL,NULL,NULL,NULL,1,162.2742917,23.57119,0.014,NULL,60975523399,952742553,14886602,17.9),(74868,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74868,37.88,0.46,376,28354,70,NULL,NULL,'2MASX J10490617+3124488',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000135,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,162.27575,31.41367,0.025,NULL,60513634913,945525545,14773836,18),(74869,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74869,34.86,0.56,93.9,28355,70,NULL,NULL,'2MASX J10490665-1538092',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.72',NULL,NULL,NULL,NULL,NULL,NULL,1,162.277667,-15.63619,0.181,NULL,41873709805,654276715,10223073,15.72),(74870,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74870,37.94,0.33,387,28356,70,NULL,NULL,'2MASX J10490684+0926046',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000097,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,162.2784583,9.43467,0.033,NULL,61054461835,953975966,14905874,17.2),(74871,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74871,36.68,0.23,217,28357,70,NULL,NULL,'2MASX J10490699+2424546',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.24',0.13,NULL,NULL,NULL,NULL,NULL,1,162.279083,24.41528,0.014,NULL,60492048144,945188252,14768566,18.24),(74872,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74872,31.74,NULL,22.3,28358,NULL,NULL,NULL,'UGC 05923',NULL,'2013AJ....145..101K',2013,1,1.18,NULL,'G',0.000013,NULL,'14.4g',0.55,'S0/a?          HII',NULL,NULL,NULL,NULL,1,162.281541667,6.91728,0.041,NULL,61064560641,954133760,14908340,14.4),(74873,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74873,38.2,0.15,437,28359,70,NULL,NULL,'2MASX J10490776+0101500',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000099,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,162.2824583,1.0305,0.081,NULL,60272129291,941752020,14714875,17.5),(74874,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74874,35.41,0.49,121,28360,70,NULL,NULL,'2MASX J10490928-2931199',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.0001,NULL,'15.1b',NULL,'E',NULL,NULL,NULL,NULL,1,162.288667,-29.52217,0.217,NULL,41537297520,649020273,10140941,15.1),(74875,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74875,36.21,0.33,174,28361,70,NULL,NULL,'2MASX J10490947-0054309',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000065,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,162.2895,-0.90856,0.041,NULL,40881661985,638775968,9980874,16.8),(74876,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74876,37.51,0.23,318,28362,70,NULL,NULL,'2MASX J10491003+2329552',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.52',0.23,NULL,NULL,NULL,NULL,NULL,1,162.291917,23.49881,0.014,NULL,60975718450,952745600,14886650,17.52),(74877,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74877,37.94,0.19,387,28363,70,NULL,NULL,'2MASX J10491036+0926426',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,162.293208333,9.44522,0.033,NULL,61054461151,953975955,14905874,NULL),(74878,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74878,37.94,0.19,387,28364,70,NULL,NULL,'2MASX J10491056+0927176',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.28',0.15,NULL,NULL,NULL,NULL,NULL,1,162.294083,9.45489,0.033,NULL,61054460941,953975952,14905874,18.28),(74879,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74879,38.5,0.46,502,28365,70,NULL,NULL,'2MASX J10491172+5351098',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000147,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,162.2987083,53.85278,0,NULL,61959793855,968121778,15126902,17.1),(74880,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74880,35.36,0.4,118,28366,NULL,NULL,'mean','UGC 05924',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000033,NULL,'14.75',0.4,'Sa',NULL,NULL,NULL,NULL,1,162.300583333,22.01597,0,NULL,60984484764,952882574,14888790,14.75),(74881,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74881,35.44,0.45,123,28366,NULL,NULL,'K','UGC 05924',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74882,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74882,35.46,0.47,123,28366,NULL,NULL,'H','UGC 05924',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74883,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74883,35.5,0.46,126,28366,NULL,NULL,'J','UGC 05924',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74884,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74884,37.39,0.21,301,28367,70,NULL,NULL,'MCG +10-16-011',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000198,NULL,'15.4g',0.54,'BrClG',NULL,NULL,NULL,NULL,1,162.300417,57.83725,0,NULL,62002874014,968794906,15137420,15.4),(74885,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74885,32.36,0.4,29.7,28368,75,NULL,NULL,'UGC 05921',NULL,'2008Ap.....51..336K',2008,1,1.6,NULL,'G',0.000013,NULL,'14.98',0.4,'Sdm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,162.301167,27.92767,0,NULL,60529410517,945772039,14777688,14.98),(74886,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74886,32.81,0.49,36.5,28368,75,NULL,'IR','UGC 05921',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74887,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74887,37.69,0.46,345,28369,70,NULL,NULL,'2MASX J10491268+4217038',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000169,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,162.303,42.28439,0,NULL,64110773728,1001730839,15652044,16.9),(74888,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74888,37.38,0.46,299,28370,70,NULL,NULL,'2MASX J10491276+3839584',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000155,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,162.3032917,38.66622,0,NULL,64121170108,1001893282,15654582,17),(74889,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74889,33.13,0.47,42.3,28371,NULL,NULL,'H','ESO 437- G 065',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000017,NULL,'14.21',0.8,'SB(r)b','Pair member (points to parent)',NULL,NULL,NULL,1,162.307,-31.30486,0.249,NULL,41504220044,648503438,10132866,14.21),(74890,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74890,33.27,0.46,45.2,28371,NULL,NULL,'J','ESO 437- G 065',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74891,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74891,33.31,0.45,46,28371,NULL,NULL,'K','ESO 437- G 065',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74892,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74892,33.42,0.4,48.4,28371,NULL,NULL,'mean','ESO 437- G 065',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74893,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74893,37.17,0.46,272,28372,70,NULL,NULL,'2MASX J10491387+1307067',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,162.307791667,13.11856,0.049,NULL,61191512552,956117383,14939334,17.4),(74894,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74894,38.2,0.15,437,28373,70,NULL,NULL,'2MASX J10491409+0059450',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000102,NULL,'16.9g',0.27,'AGN',NULL,NULL,NULL,NULL,1,162.3087083,0.99592,0.081,NULL,60271904692,941748510,14714820,16.9),(74895,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','PS1 SN PS10j','N',74895,42.14,0.17,1870,28374,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10j HOST',0.4365,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74896,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74896,37.22,0.46,279,28375,70,NULL,NULL,'2MASX J10491507+5245508',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000145,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,162.312833,52.76411,0,NULL,61776071904,965251123,15082048,16.8),(74897,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74897,37.86,0.46,373,28376,70,NULL,NULL,'SDSS J104915.67-000308.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000071,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,162.315333,-0.05244,0.057,NULL,40878085925,638720092,9980001,17.9),(74898,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74898,30.76,NULL,14.2,28377,NULL,NULL,NULL,'CGCG 066-029',NULL,'2015AstBu..70....1K',2015,1,1.6,NULL,'G',0.000033,NULL,'15.4',0.4,'Sm','Group member',NULL,NULL,NULL,1,162.32175,12.42175,0.045,NULL,61190819673,956106557,14939164,15.4),(74899,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74899,36.68,0.23,217,28378,70,NULL,NULL,'2MASX J10491744+2438596',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000162,NULL,'16.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,162.32275,24.65,0.046,NULL,60493999420,945218740,14769042,16),(74900,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74900,36.93,0.21,243,28379,70,NULL,NULL,'2MASX J10491868+1711137',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000191,NULL,'15.8g',0.44,'AGN',NULL,NULL,NULL,NULL,1,162.327917,17.18717,0.029,NULL,61190652836,956103950,14939124,15.8),(74901,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74901,36.25,0.55,178,28380,70,NULL,NULL,'2MASX J10491903-8307096',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,162.329125,-83.11931,0.453,NULL,39758254622,621222728,9706605,17.1),(74902,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74902,36.69,0.46,218,28381,70,NULL,NULL,'2MASX J10492090+2724487',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000148,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,162.3372083,27.41364,0,NULL,60530091914,945782686,14777854,17.3),(74903,'CMD','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74903,17.9,0.4,0.038,28382,NULL,NULL,NULL,'WILLMAN 1',NULL,'2008AJ....135.1361D',2008,1,NULL,'May be a dwarf satellite or a globular cluster. See 2005AJ....129.2692W.','G',0.000003,NULL,NULL,NULL,'MW companion?',NULL,NULL,NULL,NULL,1,162.3375,51.05,0,1,63907843294,998560051,15602500,NULL),(74904,'CMD','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74904,17.9,0.4,0.038,28382,NULL,NULL,NULL,'WILLMAN 1',NULL,'2008AJ....135.1361D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74905,'CMD','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74905,17.9,NULL,0.038,28382,NULL,NULL,NULL,'WILLMAN 1',NULL,'2015ApJ...811...35J',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74906,'CMD','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74906,18.27,0.44,0.045,28382,NULL,NULL,'helio','WILLMAN 1',NULL,'2005AJ....129.2692W',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74907,'Horizontal Branch','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74907,18.41,NULL,0.048,28382,NULL,NULL,'Blue HB, helio','WILLMAN 1',NULL,'2005AJ....129.2692W',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74908,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74908,36.21,0.33,174,28383,70,NULL,NULL,'CGCG 010-025',NULL,'2015arXiv151105856S',2015,1,1.02,NULL,'G',0.000079,NULL,'14.5g',0.82,'SA0- pec:',NULL,NULL,NULL,NULL,1,162.338083,-0.66806,0.041,NULL,40881489435,638773272,9980832,14.5),(74909,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74909,37.44,0.46,308,28384,70,NULL,NULL,'2MASX J10492181+4711338',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00015,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,162.340833,47.19264,0,NULL,63911576533,998618383,15603412,16.6),(74910,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74910,39.12,0.46,666,28385,70,NULL,NULL,'SDSS J104922.22+023909.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,162.342625,2.65253,0.089,NULL,60276440620,941819384,14715927,18.2),(74911,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74911,36.85,0.46,234,28386,70,NULL,NULL,'SDSS J104922.52+065101.8',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,162.343875,6.8505,0.041,NULL,61061184625,954081009,14907515,17.4),(74912,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74912,38.2,0.15,437,28387,70,NULL,NULL,'SDSS J104922.75+005407.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000075,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,162.344833333,0.90217,0.081,NULL,60271911441,941748616,14714822,18.7),(74913,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74913,37.94,0.19,387,28388,70,NULL,NULL,'2MASX J10492279+0926576',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000083,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,162.344958333,9.44939,0.033,NULL,61024115748,953501808,14898465,16.4),(74914,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74914,35.95,0.23,155,28389,70,NULL,NULL,'2MASX J10492439+0013550',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000071,NULL,'15.7g',0.42,'E/S0',NULL,NULL,NULL,NULL,1,162.351625,0.232,0.061,NULL,60268576422,941696506,14714007,15.7),(74915,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74915,36.08,0.52,164,28390,70,NULL,NULL,'2MASX J10492487-0025479',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.000097,NULL,'15.6g',0.47,'Sbc',NULL,NULL,NULL,NULL,1,162.353583,-0.42989,0.041,NULL,40878046842,638719481,9979991,15.6),(74916,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74916,38.31,0.46,458,28391,70,NULL,NULL,'2MASX J10492510+3252441',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,162.354375,32.87914,0,NULL,60499916389,945311193,14770487,17.9),(74917,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74917,37.07,0.46,260,28392,70,NULL,NULL,'2MASX J10492512+0141390',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'17.8g',0.18,'Sa-Sb',NULL,NULL,NULL,NULL,1,162.354667,1.69414,0.101,NULL,60269829105,941716079,14714313,17.8),(74918,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74918,37.19,0.33,275,28393,70,NULL,NULL,'2MASX J10492540+3325471',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000178,NULL,'17.83',0.22,NULL,NULL,NULL,NULL,NULL,1,162.35575,33.42975,0,NULL,64041704073,1000651626,15635181,17.83),(74919,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74919,36.47,0.33,197,28394,70,NULL,NULL,'2MASX J10492648+5641353',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000195,NULL,'15.8g',0.27,'S0^-',NULL,NULL,NULL,NULL,1,162.360125,56.69308,0,NULL,62001415449,968772116,15137064,15.8),(74920,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74920,38.2,0.15,437,28395,70,NULL,NULL,'2MASX J10492656+0056099',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000081,NULL,'18.0g',0.18,'AGN',NULL,NULL,NULL,NULL,1,162.360667,0.936,0.081,NULL,60271914746,941748667,14714822,18),(74921,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74921,36.88,0.46,238,28396,70,NULL,NULL,'2MASX J10492662+2922557',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00016,NULL,'16.6g',0.34,'E',NULL,NULL,NULL,NULL,1,162.3610417,29.38217,0.025,NULL,60530140289,945783442,14777866,16.6),(74922,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74922,37.94,0.33,388,28397,70,NULL,NULL,'2MASX J10492762+1103207',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000178,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,162.365,11.05575,0.065,NULL,61023356061,953489938,14898280,18),(74923,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74923,34.89,0.27,95.2,28398,70,NULL,NULL,'NGC 3399',NULL,'2015arXiv151105856S',2015,1,1.7,NULL,'G',0.000047,NULL,'13.80',1.7,'S0?','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,162.365,16.21856,0.033,NULL,61188078470,956063726,14938495,13.8),(74924,'IRAS','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74924,35.22,0.8,111,28399,75,NULL,'CF, r','UGC 05929',NULL,'1997ApJS..109..333W',1997,1,1.03,NULL,'G',0.000111,NULL,'15.3g',0.47,'Sbc',NULL,NULL,NULL,NULL,1,162.36825,4.79939,0.093,NULL,60273190491,941768601,14715134,15.3),(74925,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74925,34.73,0.38,88.2,28399,75,NULL,'CF, r, raw','UGC 05929',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74926,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74926,34.8,0.38,91.2,28399,75,NULL,'CF, r, inv','UGC 05929',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74927,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74927,35.09,0.38,104,28399,75,NULL,'CF, r, cor','UGC 05929',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74928,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74928,38.2,0.15,437,28400,70,NULL,NULL,'SDSS J104928.70+010138.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000084,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,162.369625,1.02725,0.081,NULL,60271905078,941748516,14714820,18.3),(74929,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74929,37.94,0.33,388,28401,70,NULL,NULL,'2MASX J10492959+1100117',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'17.14',0.18,NULL,NULL,NULL,NULL,NULL,1,162.3732083,11.00333,0.065,NULL,61023357630,953489962,14898280,17.14),(74930,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74930,35.43,0.33,122,28402,70,NULL,NULL,'2MASX J10493017+5155167',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00016,NULL,'16.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,162.3757917,51.92139,0,NULL,61774092285,965220191,15081565,16.1),(74931,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74931,36.72,0.46,221,28403,70,NULL,NULL,'2MASXi J1049304+240343',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.19',0.16,NULL,NULL,NULL,NULL,NULL,1,162.377041667,24.06219,0.016,NULL,60975112694,952736135,14886502,18.19),(74932,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74932,37.87,0.46,374,28404,70,NULL,NULL,'SDSS J104931.03+101219.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,162.379291667,10.20533,0.033,NULL,61024544769,953508512,14898570,17.9),(74933,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74933,37.48,0.46,314,28405,70,NULL,NULL,'2MASX J10493148+0044349',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000072,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,162.381291667,0.74306,0.081,NULL,60271886728,941748230,14714816,17.4),(74934,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74934,37.63,0.46,336,28406,70,NULL,NULL,'2MASX J10493195+2045083',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.22',0.16,NULL,NULL,NULL,NULL,NULL,1,162.383208333,20.75222,0.013,NULL,60978341165,952786580,14887290,18.22),(74935,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74935,36.73,0.15,222,28407,70,NULL,NULL,'2MASX J10493232+2154223',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.73',0.21,NULL,NULL,NULL,NULL,NULL,1,162.384833,21.90619,0,NULL,60984981425,952890334,14888911,17.73),(74936,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74936,36.12,0.46,167,28408,70,NULL,NULL,'CGCG 241-018',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000097,NULL,'15.1g',0.55,'S0',NULL,NULL,NULL,NULL,1,162.385958333,47.93325,0,NULL,63919300990,998739077,15605298,15.1),(74937,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74937,38.31,0.46,460,28409,70,NULL,NULL,'2MASX J10493328-0036510',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000086,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,162.388625,-0.61414,0.041,NULL,40878020715,638719073,9979985,18.1),(74938,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74938,38.59,0.46,523,28410,70,NULL,NULL,'SDSS J104933.26+431230.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,162.388625,43.20844,0,NULL,64110180359,1001721568,15651899,18),(74939,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','PS1 SN PS11mq','N',74939,40.1,0.11,865,28411,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11mq HOST',0.2105,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74940,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74940,37.97,0.46,392,28412,70,NULL,NULL,'SDSS J104935.06+031504.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,162.396125,3.25122,0.081,NULL,60275269073,941801079,14715641,17.9),(74941,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74941,37.71,0.33,348,28413,70,NULL,NULL,'2MASX J10493556+0104065',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000082,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,162.398125,1.06861,0.081,NULL,60271788760,941746699,14714792,17),(74942,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74942,38.05,0.46,408,28414,70,NULL,NULL,'SDSS J104935.61+304604.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000142,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,162.398417,30.76803,0,NULL,60511855277,945497738,14773402,18.5),(74943,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74943,38.15,0.46,426,28415,70,NULL,NULL,'2MASX J10493621+2804476',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,162.400833,28.07989,0,NULL,60531194214,945799909,14778123,18),(74944,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74944,37.87,0.27,376,28416,70,NULL,NULL,'2MASX J10493644+1529351',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000192,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,162.401917,15.49317,0.041,NULL,61202079926,956282498,14941914,16.8),(74945,'Brightest Stars','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74945,29.36,NULL,7.44,28417,NULL,NULL,NULL,'UGC 05918',NULL,'1999AstL...25..322S',1999,1,2.4,NULL,'G',0.000003,NULL,'15.1',2.4,'Im:','Group member',NULL,NULL,NULL,1,162.402083,65.53056,0,NULL,62114222596,970534728,15164605,15.1),(74946,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74946,29.25,0.4,7.1,28417,75,NULL,'B','UGC 05918',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74947,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74947,34.89,0.27,95.2,28418,70,NULL,NULL,'2MASX J10493746+1617381',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000172,NULL,'15.7g',0.47,NULL,NULL,NULL,NULL,NULL,1,162.406083,16.29408,0.037,NULL,61188062850,956063482,14938491,15.7),(74948,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74948,36.27,0.46,180,28419,70,NULL,NULL,'2MASX J10493822+1049477',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000183,NULL,'15.8g',0.39,'S0',NULL,NULL,NULL,NULL,1,162.40925,10.83003,0.041,NULL,61023444899,953491326,14898301,15.8),(74949,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74949,37.94,0.19,387,28420,70,NULL,NULL,'2MASX J10493942+0927127',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,162.41425,9.4535,0.033,NULL,61024162891,953502545,14898477,NULL),(74950,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74950,37.19,0.33,275,28421,70,NULL,NULL,'2MASX J10494097+3324502',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,162.42075,33.41397,0,NULL,64041703257,1000651613,15635181,16.6),(74951,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74951,35.95,0.23,155,28422,70,NULL,NULL,'CGCG 010-027',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.000082,NULL,'14.7g',0.69,'E','in a pair',NULL,NULL,NULL,1,162.4215,0.36308,0.061,NULL,60268970110,941702657,14714104,14.7),(74952,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74952,37.4,0.46,302,28423,70,NULL,NULL,'2MASX J10494137+0039105',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000077,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,162.422417,0.65294,0.077,NULL,60268755536,941699305,14714051,17),(74953,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74953,36.47,0.33,197,28424,70,NULL,NULL,'CGCG 291-005',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.00009,NULL,'15.0g',0.53,'BrClG',NULL,NULL,NULL,NULL,1,162.423875,56.64131,0,NULL,62001423821,968772247,15137066,15),(74954,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74954,37.87,0.27,376,28425,70,NULL,NULL,'2MASX J10494190+1529561',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000186,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,162.4247083,15.49883,0.041,NULL,61202207305,956284489,14941945,18.3),(74955,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74955,37.51,0.23,318,28426,70,NULL,NULL,'2MASX J10494200+2327473',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.32',0.15,NULL,NULL,NULL,NULL,NULL,1,162.424916667,23.46308,0.014,NULL,60975718319,952745598,14886649,18.32),(74956,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74956,38.19,0.46,434,28427,70,NULL,NULL,'2MASX J10494271+3237372',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000196,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,162.427917,32.62714,0.006,NULL,60499802099,945309407,14770459,17.5),(74957,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74957,37.31,0.46,289,28428,70,NULL,NULL,'SDSS J104942.94+071321.7',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000164,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,162.4289583,7.22269,0.037,NULL,61064407446,954131366,14908302,17.7),(74958,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74958,37.12,0.46,265,28429,70,NULL,NULL,'SDSS J104943.63+353511.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,162.4317917,35.58667,0.057,NULL,64042536667,1000664635,15635384,18.1),(74959,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74959,37.57,0.46,327,28430,70,NULL,NULL,'2MASX J10494365+4211097',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000178,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,162.432,42.18603,0,NULL,64110751180,1001730487,15652038,16.6),(74960,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74960,37.03,0.46,254,28431,70,NULL,NULL,'2MASXi J1049436+262036',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000142,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,162.43225,26.34344,0,NULL,60492469124,945194830,14768669,18),(74961,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74961,37.63,0.46,336,28432,70,NULL,NULL,'2MASX J10494418+2632488',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,162.434167,26.54694,0,NULL,60525076776,945704324,14776630,17.2),(74962,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74962,37.7,0.46,347,28433,70,NULL,NULL,'2MASX J10494472+1834343',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,162.436417,18.57622,0.041,NULL,61157480378,955585630,14931025,17.9),(74963,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74963,37.71,0.33,348,28434,70,NULL,NULL,'2MASX J10494550+0107465',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000113,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,162.439625,1.12964,0.081,NULL,60271823543,941747242,14714800,16.7),(74964,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74964,38.11,0.33,418,28435,70,NULL,NULL,'2MASX J10494881+3654522',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000153,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,162.453417,36.9145,0,NULL,64108182187,1001690346,15651411,18.2),(74965,'Tully est','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74965,32.19,0.8,27.4,28436,75,NULL,'B','NGC 3395',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.00002,NULL,'12.4',1.2,'SAB(rs)cd pec: HII','Pair member (points to parent)',NULL,NULL,'Starburst',1,162.4587917,32.98286,0,NULL,60499871945,945310499,14770476,12.4),(74966,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74966,31.88,0.47,23.8,28436,NULL,NULL,'H','NGC 3395',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74967,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74967,31.91,0.46,24.1,28436,NULL,NULL,'J','NGC 3395',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74968,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74968,31.97,0.45,24.7,28436,NULL,NULL,'K','NGC 3395',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74969,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74969,32.3,0.4,28.8,28436,NULL,NULL,'mean','NGC 3395',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74970,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74970,37.85,0.46,371,28437,70,NULL,NULL,'2MASX J10495016+1247445',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,162.459041667,12.79567,0.069,NULL,61191642985,956119421,14939365,18.1),(74971,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74971,37.76,0.46,357,28438,70,NULL,NULL,'2MASX J10495051+1854413',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,162.4605417,18.9115,0.049,NULL,61157859961,955591561,14931118,17.5),(74972,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74972,35.16,0.54,108,28439,70,NULL,NULL,'2MASX J10495108-4219358',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,162.46275,-42.32664,0.521,NULL,42120030158,658125471,10283210,15.4),(74973,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74973,38.83,0.46,583,28440,70,NULL,NULL,'SDSS J104951.08+261122.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000163,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,162.462875,26.18972,0,NULL,60492439611,945194368,14768662,18.5),(74974,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74974,30.41,NULL,12.1,28441,NULL,NULL,NULL,'AGC 205313',NULL,'2015AstBu..70....1K',2015,1,NULL,NULL,'G',0.00005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,162.464583,12.61361,0.057,NULL,61191627313,956119176,14939362,NULL),(74975,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74975,37.98,0.46,395,28442,70,NULL,NULL,'2MASX J10495264+1916013',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,162.469541667,19.26692,0.081,NULL,61160580466,955634069,14931782,17.4),(74976,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74976,38.75,0.46,562,28443,70,NULL,NULL,'2MASX J10495412+0710237',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,162.475417,7.17328,0.037,NULL,61064359021,954130609,14908290,18),(74977,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74977,35.7,0.46,138,28444,70,NULL,NULL,'2MASX J10495497+1912592',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.39',0.23,NULL,NULL,NULL,NULL,NULL,1,162.4790417,19.21661,0.081,NULL,61160573643,955633963,14931780,16.39),(74978,'Tully est','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74978,32.24,0.8,28,28445,75,NULL,'B','NGC 3396',NULL,'1988NBGC.C....0000T',1988,1,2.5,NULL,'G',0.000033,NULL,'13.0g',0.84,'IBm pec','Pair member (points to parent)',NULL,NULL,NULL,1,162.4794583,32.99083,0,NULL,60499872332,945310505,14770476,13),(74979,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74979,31.69,0.4,21.8,28445,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 3396',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74980,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74980,38.24,0.23,445,28446,70,NULL,NULL,'2MASX J10495522+1549015',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00017,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,162.480083,15.81722,0.037,NULL,61201829808,956278590,14941852,17.7),(74981,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74981,37.51,0.23,318,28447,70,NULL,NULL,'SDSS J104956.71+232752.2',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.2,'AGN',NULL,NULL,NULL,NULL,1,162.486333,23.46453,0.014,NULL,60975588321,952743567,14886618,17.7),(74982,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74982,36.61,0.46,210,28448,70,NULL,NULL,'2MASX J10495689+1356355',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000189,NULL,'15.3g',0.46,'bE or M32-type','Group member',NULL,NULL,NULL,1,162.487083,13.94325,0.061,NULL,61194825300,956169145,14940142,15.3),(74983,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74983,37.28,0.46,286,28449,70,NULL,NULL,'SDSS J104957.16+340116.6',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.2g',0.32,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,162.488208333,34.02128,0,NULL,64041117006,1000642453,15635038,16.2),(74984,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74984,37.29,0.46,288,28450,70,NULL,NULL,'2MASX J10495752+4806300',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000146,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,162.4897917,48.10836,0,NULL,63919262498,998738476,15605288,17.5),(74985,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74985,35.43,0.33,122,28451,70,NULL,NULL,'CGCG 267-017',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00016,NULL,'15.7g',0.4,'S0',NULL,NULL,NULL,NULL,1,162.4900417,51.86961,0,NULL,61774074177,965219909,15081561,15.7),(74986,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74986,37.28,0.46,285,28452,70,NULL,NULL,'2MASX J10495766+1527535',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000181,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,162.4902083,15.46481,0.037,NULL,61202225183,956284768,14941949,17.1),(74987,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74987,37.94,0.19,387,28453,70,NULL,NULL,'2MASX J10495817+0931180',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00011,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,162.4922917,9.52175,0.033,NULL,61024146335,953502286,14898473,16.6),(74988,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74988,37.9,0.46,381,28454,70,NULL,NULL,'2MASX J10495817+0032425',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000083,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,162.492333,0.54514,0.077,NULL,60268791857,941699872,14714060,17.7),(74989,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74989,37.63,0.46,335,28455,70,NULL,NULL,'2MASX J10495833+4030322',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000137,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,162.4932083,40.50892,0,NULL,64112735152,1001761486,15652523,18.1),(74990,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74990,37.09,0.33,262,28456,70,NULL,NULL,'2MASX J10495838+2344322',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.05',0.17,NULL,NULL,NULL,NULL,NULL,1,162.493333,23.74233,0.013,NULL,60975664956,952744764,14886636,18.05),(74991,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74991,35.95,0.23,155,28457,70,NULL,NULL,'CGCG 010-030',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000091,NULL,'14.6g',0.69,'E','Group member',NULL,NULL,NULL,1,162.4952083,0.32231,0.061,NULL,60268848423,941700756,14714074,14.6),(74992,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74992,38.62,0.46,529,28458,70,NULL,NULL,'SDSS J105000.66-004950.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000063,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,162.50275,-0.83058,0.041,NULL,40878349090,638724204,9980065,18.3),(74993,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74993,36.96,0.46,247,28459,70,NULL,NULL,'2MASX J10500075+0457455',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000192,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,162.50325,4.96278,0.097,NULL,60273134258,941767722,14715120,16.2),(74994,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74994,37.91,0.46,382,28460,70,NULL,NULL,'SDSS J105000.79+005136.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000076,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,162.503291667,0.86022,0.081,NULL,60271762906,941746295,14714785,18.3),(74995,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74995,36.72,0.46,220,28461,70,NULL,NULL,'2MASX J10500122+2309302',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,162.505167,23.15853,0,NULL,60975340711,952739698,14886557,16.5),(74996,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,74996,35.36,0.6,118,28462,70,NULL,NULL,'2MASX J10500165-0152029',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.27',0.4,'S0',NULL,NULL,NULL,NULL,1,162.507041667,-1.86747,0.077,NULL,40880817280,638762770,9980668,15.27),(74997,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74997,37.99,0.46,397,28463,70,NULL,NULL,'2MASX J10500173+1609545',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,162.507333,16.16511,0.033,NULL,61187859630,956060306,14938442,17.7),(74998,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74998,31.41,NULL,19.1,28464,NULL,NULL,NULL,'SDSS J105001.78+134705.1',NULL,'2015AstBu..70....1K',2015,1,0.26,NULL,'G',0.000004,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,162.5074583,13.78478,0.069,NULL,61194848554,956169508,14940148,16.9),(74999,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',74999,38.04,0.33,406,28465,70,NULL,NULL,'SDSS J105002.42+381731.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000131,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,162.510083,38.29211,0,NULL,64107093466,1001673335,15651145,18.5),(75000,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',75000,38.78,0.46,570,28466,70,NULL,NULL,'2MASX J10500312+1149080',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000242,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,162.5129583,11.81903,0.065,NULL,61144667121,955385423,14927897,17.6),(75001,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',75001,35.76,0.46,142,28467,70,NULL,NULL,'2MASX J10500321+0109287',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000083,NULL,'16.0g',0.44,'Scd',NULL,NULL,NULL,NULL,1,162.513416667,1.15778,0.081,NULL,60271834104,941747407,14714803,16),(75002,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',75002,35.57,0.49,130,28468,75,NULL,'IR','CGCG 066-032',NULL,'2011yCatp016004901K',2011,1,0.78,NULL,'G',0.000018,NULL,'16.1g',0.24,'Sc',NULL,NULL,NULL,NULL,1,162.514708333,11.03925,0.053,NULL,61023275922,953488686,14898260,16.1),(75003,'Tully-Fisher','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,NULL,75003,36.09,0.2,165,28469,74.4,NULL,NULL,'CGCG 066-032',NULL,'2013AJ....146...86T',2013,1,0.78,NULL,'G',0.000018,NULL,'16.1g',0.24,'Sc',NULL,NULL,NULL,NULL,1,162.514708333,11.03925,0.053,NULL,61023275922,953488686,14898260,16.1),(75004,'FP','2016-12-15 15:14:41','2016-12-16 11:19:49','1',NULL,'R',75004,37.81,0.46,365,28470,70,NULL,NULL,'2MASX J10500585+0653550',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000148,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,162.5242917,6.89869,0.081,NULL,61061160196,954080628,14907509,17.3),(75005,'SNIa','2016-12-15 15:14:41','2016-12-16 11:19:49','1','PS1 SN PS10im','N',75005,42.28,0.27,1890,28471,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10im HOST',0.5105,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75006,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75006,35.95,0.23,155,28472,70,NULL,NULL,'2MASX J10500615+0019597',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00011,NULL,'16.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,162.5257083,0.33325,0.061,NULL,60268851177,941700799,14714074,16.6),(75007,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75007,35.1,0.45,105,28473,NULL,NULL,'K','UGC 05936',NULL,'2007A&A...465...71T',2007,1,1.25,NULL,'G',0.000093,NULL,'14.0g',1,'(R)SA0+:',NULL,NULL,NULL,NULL,1,162.530375,36.34183,0,NULL,64108126064,1001689469,15651397,14),(75008,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75008,35.23,0.4,111,28473,NULL,NULL,'mean','UGC 05936',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75009,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75009,37.68,0.46,344,28474,70,NULL,NULL,'2MASX J10500766+2652449',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,162.531875,26.87925,0,NULL,60525084925,945704451,14776632,17.7),(75010,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75010,37.34,0.46,294,28475,70,NULL,NULL,'2MASX J10500772+5621019',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000168,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,162.532125,56.35061,0,NULL,61968977067,968265266,15129144,17.1),(75011,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75011,36.21,0.46,175,28476,70,NULL,NULL,'2MASX J10500951+1643435',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.00011,NULL,'15.7g',0.51,NULL,NULL,NULL,NULL,NULL,1,162.5397083,16.72869,0.041,NULL,61189903441,956092241,14938941,15.7),(75012,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75012,36.49,0.46,199,28477,70,NULL,NULL,'2MASX J10500995+0008157',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000089,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,162.541375,0.13761,0.057,NULL,60268813612,941700212,14714065,17),(75013,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75013,38.24,0.23,445,28478,70,NULL,NULL,'2MASX J10501130+1553565',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,162.5472083,15.89897,0.037,NULL,61201945126,956280392,14941881,18.2),(75014,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:49','1','SN 2002ad','R',75014,41.52,NULL,1330,28479,65,NULL,'SALT','H-ZSNS J105012.19+573111.6',0.514,'2010arXiv1006.2112L',2010,1,0.05,NULL,'G',0.001,NULL,'23.8g',0.02,NULL,NULL,NULL,NULL,NULL,1,162.550333,57.51964,0,NULL,62001518231,968773722,15137089,23.8),(75015,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:49','1','SN 2002ad',NULL,75015,42.08,0.51,1720,28479,74.2,NULL,'SALT 2','H-ZSNS J105012.19+573111.6',0.514,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75016,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:49','1','SN 2002ad',NULL,75016,42.12,0.4,1750,28479,72,NULL,'dm15','H-ZSNS J105012.19+573111.6',0.514,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75017,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:49','1','SN 2002ad',NULL,75017,42.16,0.25,1790,28479,72,NULL,'MLCS','H-ZSNS J105012.19+573111.6',0.514,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75018,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:49','1','SN 2002ad',NULL,75018,42.29,0.35,1900,28479,72,NULL,'BATM','H-ZSNS J105012.19+573111.6',0.514,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75019,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:49','1','SN 2002ad',NULL,75019,42.39,0.27,1990,28479,65,NULL,NULL,'H-ZSNS J105012.19+573111.6',0.514,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75020,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:49','1','SN 2002ad',NULL,75020,42.43,0.43,2020,28479,70,NULL,'SALT','H-ZSNS J105012.19+573111.6',0.514,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75021,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:49','1','SN 2002ad',NULL,75021,42.62,0.65,2210,28479,65,NULL,'SALT','H-ZSNS J105012.19+573111.6',0.514,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75022,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75022,38,0.33,397,28480,70,NULL,NULL,'2MASX J10501220+3803461',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000169,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,162.550958333,38.06281,0,NULL,64107114071,1001673657,15651150,18),(75023,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75023,38.04,0.33,406,28481,70,NULL,NULL,'2MASX J10501314+3821151',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000164,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,162.554875,38.35425,0,NULL,64120965144,1001890080,15654532,18.2),(75024,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75024,37.84,0.19,370,28482,70,NULL,NULL,'2MASX J10501355+2059294',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.12',0.16,NULL,NULL,NULL,NULL,NULL,1,162.556625,20.99158,0.021,NULL,60978138571,952783415,14887240,18.12),(75025,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75025,38.33,0.46,463,28483,70,NULL,NULL,'2MASX J10501524+1842084',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,162.563625,18.70225,0.041,NULL,61160950945,955639858,14931872,18.2),(75026,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75026,37.95,0.46,390,28484,70,NULL,NULL,'SDSS J105015.94+331543.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000134,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,162.566417,33.262,0.016,NULL,64040796656,1000637447,15634960,18.5),(75027,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75027,35.33,0.46,116,28485,70,NULL,NULL,'CGCG 038-026',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00012,NULL,'15.8g',0.3,'S0^-',NULL,NULL,NULL,NULL,1,162.5705417,6.12258,0.069,NULL,61060927875,954076998,14907453,15.8),(75028,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75028,37.14,0.46,268,28486,70,NULL,NULL,'2MASX J10501724+2314454',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.67',0.2,NULL,NULL,NULL,NULL,NULL,1,162.571833333,23.24603,0,NULL,60975297256,952739019,14886547,17.67),(75029,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75029,35.23,0.46,111,28487,70,NULL,NULL,'IC 2606',NULL,'2015arXiv151105856S',2015,1,1.03,NULL,'G',0.000063,NULL,'14.3g',0.56,'S?',NULL,NULL,NULL,NULL,1,162.5735417,37.95622,0,NULL,64108928456,1001702007,15651593,14.3),(75030,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75030,37.87,0.27,376,28488,70,NULL,NULL,'2MASX J10501792+1526595',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000147,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,162.574583,15.44992,0.041,NULL,61202219974,956284687,14941948,17.7),(75031,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75031,37.09,0.33,262,28489,70,NULL,NULL,'2MASX J10501797+2334474',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00001,NULL,'17.62',0.23,NULL,NULL,NULL,NULL,NULL,1,162.574958333,23.58003,0,NULL,60975686867,952745107,14886642,17.62),(75032,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75032,33.57,0.48,51.7,28490,70,NULL,NULL,'NGC 3404',NULL,'2014MNRAS.445.2677S',2014,1,2.1,NULL,'G',0.00002,NULL,'14.13',0.5,'SBab? sp',NULL,NULL,NULL,NULL,1,162.574917,-12.10872,0.105,NULL,41813228525,653331695,10208307,14.13),(75033,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75033,33.99,0.47,62.9,28490,NULL,NULL,'H','NGC 3404',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75034,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75034,34.02,0.46,63.7,28490,NULL,NULL,'J','NGC 3404',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75035,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75035,34.06,0.45,64.8,28490,NULL,NULL,'K','NGC 3404',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75036,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75036,34.23,0.49,70.1,28490,75,NULL,'IR','NGC 3404',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75037,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75037,34.33,0.4,73.6,28490,NULL,NULL,'mean','NGC 3404',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75038,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75038,37.06,0.33,258,28491,70,NULL,NULL,'2MASX J10501842+0323087',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,162.5767917,3.38581,0.081,NULL,60275233169,941800518,14715633,17.2),(75039,'SBF','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75039,30.22,0.17,11.1,28492,NULL,NULL,'R','UGC 05944',NULL,'2005A&A...437..823R',2005,1,0.8,NULL,'G',0.00009,NULL,'15.7g',0.71,'Im','Group member',NULL,NULL,NULL,1,162.579,13.27186,0.057,NULL,61191045045,956110078,14939219,15.7),(75040,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75040,36.08,0.46,164,28493,70,NULL,NULL,'CGCG 184-024',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.000097,NULL,'14.8g',0.51,NULL,NULL,NULL,NULL,NULL,1,162.580083333,33.62803,0,NULL,64041172244,1000643316,15635051,14.8),(75041,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75041,38.11,0.33,418,28494,70,NULL,NULL,'2MASX J10501929+3650151',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000177,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,162.580417,36.83769,0,NULL,64109288727,1001707636,15651681,17.8),(75042,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75042,38.24,0.23,445,28495,70,NULL,NULL,'2MASX J10501962+1601295',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000191,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,162.58175,16.02494,0.037,NULL,61201943339,956280364,14941880,17.4),(75043,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75043,37.06,0.46,258,28496,70,NULL,NULL,'SDSS J105020.32+035427.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,162.5847083,3.90772,0.109,NULL,60274738716,941792792,14715512,17.7),(75044,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75044,34.31,0.49,72.8,28497,75,NULL,'IR','NGC 3409',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',NULL,NULL,'15',0.2,'SBc? sp',NULL,NULL,NULL,NULL,1,162.5847917,-17.04364,0.105,NULL,41863156048,654111813,10220497,15),(75045,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75045,34.56,0.49,81.5,28497,NULL,NULL,'Malmquist cor.','NGC 3409',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75046,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75046,34.76,0.44,89.4,28497,NULL,NULL,NULL,'NGC 3409',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75047,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75047,34.8,0.2,91.2,28497,74.4,NULL,NULL,'NGC 3409',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75048,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75048,37.22,0.46,278,28498,70,NULL,NULL,'2MASX J10502070-0008538',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000085,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,162.58625,-0.14839,0.069,NULL,40877756851,638714950,9979921,17),(75049,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75049,37.09,0.33,261,28499,70,NULL,NULL,'2MASX J10502089+0755191',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,162.5869583,7.92192,0.053,NULL,61029619671,953587807,14899809,16.3),(75050,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75050,38.07,0.46,411,28500,70,NULL,NULL,'SDSS J105021.42-002001.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00007,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,162.5892917,-0.33375,0.085,NULL,40878645961,638728843,9980138,18.6),(75051,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75051,36.82,0.46,232,28501,70,NULL,NULL,'2MASX J10502141+2718416',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000192,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,162.5892917,27.31167,0,NULL,60529145155,945767893,14777623,16.5),(75052,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75052,36.73,0.46,222,28502,70,NULL,NULL,'SDSS J105021.46+004233.8',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000065,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,162.589458333,0.70942,0.077,NULL,60268778183,941699659,14714057,17.4),(75053,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75053,38,0.33,397,28503,70,NULL,NULL,'SDSS J105021.71+380511.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,162.5905,38.08658,0,NULL,64107111509,1001673617,15651150,18),(75054,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75054,37.06,0.33,258,28504,70,NULL,NULL,'2MASX J10502289+0320567',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00016,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,162.5955,3.34908,0.081,NULL,60275235629,941800556,14715633,16.7),(75055,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75055,37.35,0.46,295,28505,70,NULL,NULL,'2MASX J10502395+0057007',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000053,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,162.599833333,0.95011,0.081,NULL,60271781380,941746584,14714790,17.8),(75056,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75056,36.63,0.86,212,28506,70,NULL,NULL,'2MASX J10502509-4534343',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,162.6045417,-45.57617,0.745,NULL,41918169040,654971391,10233927,16.9),(75057,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75057,31.79,NULL,22.8,28507,NULL,NULL,NULL,'UGC 05945',NULL,'2015AstBu..70....1K',2015,1,1.7,NULL,'G',0.000013,NULL,'14.40',0.9,'IBm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,162.606416667,17.56422,0.041,NULL,61190129586,956095774,14938996,14.4),(75058,'D-Sigma','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75058,34.42,0.4,76.6,28508,75,NULL,'Edat, raw','NGC 3402',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.00012,NULL,'13.11',2.1,'E+',NULL,NULL,NULL,NULL,1,162.610291667,-12.84461,0.121,NULL,41868158288,654189973,10221718,13.11),(75059,'D-Sigma','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75059,34.76,0.4,89.4,28508,75,NULL,'Edat, cor','NGC 3402',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75060,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75060,34.06,0.48,64.9,28508,70,NULL,NULL,'NGC 3402',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75061,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75061,34.3,0.4,72.5,28508,NULL,NULL,'mean','NGC 3402',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75062,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75062,34.82,0.45,92.1,28508,NULL,NULL,'K','NGC 3402',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75063,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75063,36.74,0.46,222,28509,70,NULL,NULL,'2MASX J10502870+2233564',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,162.6194583,22.56575,0,NULL,60983464069,952866626,14888541,17.2),(75064,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75064,37.49,0.46,315,28510,70,NULL,NULL,'2MASX J10502984+0337097',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00015,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,162.62425,3.61931,0.085,NULL,60274672485,941791757,14715496,17.1),(75065,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75065,36.51,0.46,201,28511,70,NULL,NULL,'2MASX J10503005+5505323',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000171,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,162.625041667,55.09222,0,NULL,61974331039,968348922,15130451,16.7),(75066,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75066,37.39,0.21,301,28512,70,NULL,NULL,'2MASX J10503000+5745243',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000189,NULL,'17.3g',0.21,'Extended',NULL,NULL,NULL,NULL,1,162.62525,57.75669,0,NULL,62002831347,968794239,15137409,17.3),(75067,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75067,30.09,NULL,10.4,28513,NULL,NULL,NULL,'UGC 05947',NULL,'2015AstBu..70....1K',2015,1,1.3,NULL,'G',0.000021,NULL,'14.92',0.5,'Im pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,162.62625,19.645,0.053,NULL,61159560681,955618135,14931533,14.92),(75068,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75068,31.79,0.4,22.8,28513,75,NULL,'B','UGC 05947',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75069,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75069,35.01,0.27,100,28514,70,NULL,NULL,'CGCG 066-035',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000167,NULL,'15.5',0.32,NULL,'Group member',NULL,NULL,NULL,1,162.62725,8.75964,0.037,NULL,61029260632,953582197,14899721,15.5),(75070,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75070,37.84,0.19,370,28515,70,NULL,NULL,'2MASX J10503231+2051194',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.02',0.18,NULL,NULL,NULL,NULL,NULL,1,162.634667,20.85539,0.013,NULL,60978253959,952785218,14887269,18.02),(75071,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75071,36.57,0.46,206,28516,70,NULL,NULL,'2MASX J10503254+3211439',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000176,NULL,'16.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,162.635541667,32.19564,0.017,NULL,60514213952,945534593,14773978,16.1),(75072,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75072,35.97,0.87,156,28517,70,NULL,NULL,'2MASX J10503318-4720424',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,162.638333333,-47.34517,0.769,NULL,41919850946,654997671,10234338,17.2),(75073,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75073,38.43,0.46,486,28518,70,NULL,NULL,'2MASX J10503340+4122032',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,162.63925,41.36758,0,NULL,64113545658,1001774150,15652721,18.1),(75074,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75074,37.84,0.19,370,28519,70,NULL,NULL,'2MASX J10503374+2048453',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.98',0.18,NULL,NULL,NULL,NULL,NULL,1,162.640541667,20.81244,0.013,NULL,60978275203,952785550,14887274,17.98),(75075,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75075,34.65,0.54,85.2,28520,70,NULL,NULL,'IC 0647',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.04',0.4,NULL,NULL,NULL,NULL,NULL,1,162.6437083,-12.85481,0.125,NULL,41868159506,654189992,10221718,16.04),(75076,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75076,34.21,0.49,69.4,28521,70,NULL,NULL,'LCRS B104806.1-123754',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00011,NULL,'15.64',0.4,NULL,NULL,NULL,NULL,NULL,1,162.647,-12.89739,0.125,NULL,41868165044,654190078,10221719,15.64),(75077,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75077,37.32,0.46,292,28522,70,NULL,NULL,'2MASX J10503525+4556380',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000179,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,162.647083,45.94386,0,NULL,63912062836,998625981,15603530,17),(75078,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75078,37.2,0.46,276,28523,70,NULL,NULL,'2MASX J10503651-0055230',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000084,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,162.6520417,-0.92306,0.061,NULL,40878371776,638724559,9980071,17.6),(75079,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75079,36.16,0.46,171,28524,70,NULL,NULL,'2MASX J10503657+3251240',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,162.652416667,32.85681,0,NULL,60499771706,945308932,14770452,16.9),(75080,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75080,37.58,0.46,328,28525,70,NULL,NULL,'2MASX J10503698+0427473',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,162.654125,4.46311,0.117,NULL,60272892962,941763952,14715061,NULL),(75081,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75081,37.84,0.19,370,28526,70,NULL,NULL,'2MASX J10503694+2047093',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.16',0.16,NULL,NULL,NULL,NULL,NULL,1,162.654125,20.78594,0.009,NULL,60978276051,952785563,14887274,18.16),(75082,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75082,32.1,NULL,26.3,28527,NULL,NULL,NULL,'UGC 05948',NULL,'2015AstBu..70....1K',2015,1,1.3,'Superposed star.','G',0.000013,NULL,'16.65',0.4,'Im?',NULL,NULL,NULL,NULL,1,162.657875,15.7635,0.037,NULL,61201922158,956280033,14941875,16.65),(75083,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75083,37.84,0.19,370,28528,70,NULL,NULL,'2MASX J10503899+2047010',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,162.6625,20.78369,0.009,NULL,60978275978,952785562,14887274,17.5),(75084,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75084,37.59,0.46,330,28529,70,NULL,NULL,'2MASX J10503950+5745273',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000169,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,162.6647917,57.75764,0,NULL,62002830623,968794228,15137409,16.8),(75085,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75085,32.71,0.69,34.9,28530,100,NULL,'mid-IR','NGC 3394',NULL,'2013ApJ...771...88L',2013,1,1.67,NULL,'G',0.000097,NULL,'13.7g',1.15,'SA(rs)c','Possible field galaxy',NULL,NULL,NULL,1,162.666,65.72722,0,NULL,62114348235,970536691,15164635,13.7),(75086,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75086,33.78,0.4,57.1,28530,NULL,NULL,'mean','NGC 3394',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75087,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75087,34.09,0.2,65.8,28530,74.4,NULL,NULL,'NGC 3394',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75088,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75088,34.65,0.47,85.3,28530,NULL,NULL,'H','NGC 3394',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75089,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75089,34.66,0.45,85.5,28530,NULL,NULL,'K','NGC 3394',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75090,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75090,34.67,0.46,85.9,28530,NULL,NULL,'J','NGC 3394',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75091,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75091,37.04,0.46,256,28531,70,NULL,NULL,'SDSS J105040.10+181647.1',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.6g',0.29,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,162.667125,18.27975,0.045,NULL,61160865536,955638524,14931851,16.6),(75092,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75092,37.09,0.33,261,28532,70,NULL,NULL,'SDSS J105045.19+080454.8',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000186,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,162.688333,8.08192,0.053,NULL,61030143733,953595995,14899937,16.5),(75093,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:49','1','SN 1995K','R',75093,41.15,NULL,1150,28533,65,NULL,'SALT','[SPH95a] J105047.00-091507.4',0.478,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'Sb/c',NULL,NULL,NULL,NULL,1,162.695833,-9.25206,0.037,NULL,41785975873,652905873,10201654,NULL),(75094,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:49','1','SN 1995K',NULL,75094,42.25,0.2,1290,28533,65,NULL,'H96','[SPH95a] J105047.00-091507.4',0.478,'1998ApJ...493L..53G',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75095,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:49','1','SN 1995K',NULL,75095,42.31,0.13,1330,28533,65,NULL,NULL,'[SPH95a] J105047.00-091507.4',0.478,'1998ApJ...507...46S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75096,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:49','1','SN 1995K',NULL,75096,42.4,0.25,1380,28533,65,NULL,NULL,'[SPH95a] J105047.00-091507.4',0.478,'1998ApJ...507...46S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75097,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:49','1','SN 1995K',NULL,75097,42.4,0.26,1380,28533,65,NULL,'RPK','[SPH95a] J105047.00-091507.4',0.478,'1998ApJ...493L..53G',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75098,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:49','1','SN 1995K',NULL,75098,41.65,0.36,1450,28533,74.2,NULL,'SALT 2','[SPH95a] J105047.00-091507.4',0.478,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75099,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:49','1','SN 1995K',NULL,75099,42.26,0.31,1920,28533,70,NULL,'SALT','[SPH95a] J105047.00-091507.4',0.478,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75100,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:49','1','SN 1995K',NULL,75100,42.45,0.17,2090,28533,65,NULL,'MLCS','[SPH95a] J105047.00-091507.4',0.478,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75101,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:49','1','SN 1995K',NULL,75101,42.47,0.29,2110,28533,65,NULL,'SALT','[SPH95a] J105047.00-091507.4',0.478,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75102,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:49','1','SN 1995K',NULL,75102,42.48,0.23,2120,28533,65,NULL,NULL,'[SPH95a] J105047.00-091507.4',0.478,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75103,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:49','1','SN 1995K',NULL,75103,42.49,0.17,2130,28533,65,NULL,'Template','[SPH95a] J105047.00-091507.4',0.478,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75104,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:49','1','SN 1995K',NULL,75104,42.45,0.17,3090,28533,65,NULL,'Snapshot','[SPH95a] J105047.00-091507.4',NULL,'1998ApJ...504..935R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75105,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75105,37.29,0.46,287,28534,70,NULL,NULL,'2MASX J10504755+0054224',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000183,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,162.6980417,0.90625,0.077,NULL,60268323571,941692555,14713946,16.7),(75106,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75106,37.11,0.46,265,28535,70,NULL,NULL,'2MASX J10504805+5418114',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00017,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,162.7000417,54.30328,0,NULL,61973650177,968338284,15130285,17.3),(75107,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75107,36.93,0.46,243,28536,70,NULL,NULL,'2MASX J10504825+2004510',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.31',0.17,NULL,NULL,NULL,NULL,NULL,1,162.701167,20.08089,0.021,NULL,60978569928,952790155,14887346,18.31),(75108,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75108,37.84,0.46,369,28537,70,NULL,NULL,'SDSS J105048.77+040647.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,162.703208333,4.11331,0.141,NULL,60275596623,941806197,14715721,17.8),(75109,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75109,38.24,0.23,445,28538,70,NULL,NULL,'2MASX J10504905+1556171',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000192,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,162.7044583,15.93803,0.037,NULL,61201970565,956280790,14941887,17.3),(75110,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75110,37.57,0.46,326,28539,70,NULL,NULL,'2MASX J10504953+0134144',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000183,NULL,'16.8g',0.27,'Sa-Sb',NULL,NULL,NULL,NULL,1,162.70625,1.57078,0.105,NULL,60269749983,941714843,14714294,16.8),(75111,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75111,37.42,0.46,305,28540,70,NULL,NULL,'2MASX J10504985+2216070',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,162.70775,22.26869,0,NULL,60985113632,952892400,14888943,17.6),(75112,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75112,37.86,0.46,373,28541,70,NULL,NULL,'2MASX J10505007+1748046',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.21',0.19,NULL,NULL,NULL,NULL,NULL,1,162.708625,17.80142,0.057,NULL,61188924083,956076938,14938702,18.21),(75113,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75113,38.13,0.46,423,28542,70,NULL,NULL,'2MASX J10505095+5054510',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00018,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,162.71225,50.91414,0,NULL,63907865620,998560400,15602506,17.6),(75114,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75114,36.54,0.79,204,28543,70,NULL,NULL,'LCRS B104823.5-122726',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.34',NULL,NULL,NULL,NULL,NULL,NULL,1,162.719541667,-12.72281,0.121,NULL,41868143718,654189745,10221714,16.34),(75115,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75115,37.11,0.46,264,28544,70,NULL,NULL,'2MASX J10505311+2455321',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000163,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,162.721417,24.9255,0,NULL,60491685232,945182581,14768477,16.9),(75116,'SBF','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75116,30.26,0.14,11.3,28545,74.4,NULL,NULL,'NGC 3412',NULL,'2013AJ....146...86T',2013,1,3.67,NULL,'G',0.000006,NULL,'11.7g',1.17,'SB(s)0^0^      PAS','in a radial-velocity based grouping',NULL,NULL,NULL,1,162.722,13.41214,0.057,NULL,61194562324,956165036,14940078,11.7),(75117,'SBF','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75117,30.27,0.14,11.3,28545,NULL,NULL,'I','NGC 3412',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75118,'SBF','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75118,30.27,0.14,11.3,28545,NULL,NULL,NULL,'NGC 3412',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75119,'SBF','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75119,30.31,0.14,11.5,28545,NULL,NULL,'Malmquist cor.','NGC 3412',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75120,'Faber-Jackson','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75120,29.06,0.58,6.49,28545,95,NULL,'de Vaucouleurs','NGC 3412',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75121,'Faber-Jackson','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75121,29.62,NULL,8.39,28545,NULL,NULL,'LEDA [April 2006]','NGC 3412',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75122,'Faber-Jackson','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75122,29.74,0.31,8.87,28545,95,NULL,'Weighted Mean','NGC 3412',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75123,'Faber-Jackson','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75123,29.91,0.63,9.59,28545,95,NULL,'Michard 1979b, c','NGC 3412',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75124,'Faber-Jackson','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75124,30.73,0.46,14,28545,95,NULL,'Michard 1979a','NGC 3412',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75125,'Faber-Jackson','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75125,30.8,0.81,14.5,28545,55,NULL,'Visvanathan & Sandage 1979','NGC 3412',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75126,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75126,29.69,0.41,8.67,28545,NULL,NULL,NULL,'NGC 3412',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75127,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75127,29.72,NULL,8.8,28545,NULL,NULL,NULL,'NGC 3412',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75128,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75128,30.01,0.41,10,28545,NULL,NULL,'Malmquist cor.','NGC 3412',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75129,'Tertiary','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75129,29.92,0.32,9.64,28545,95,NULL,NULL,'NGC 3412',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75130,'Tully est','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75130,29.54,0.8,8.1,28545,75,NULL,'B','NGC 3412',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75131,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75131,29.81,0.45,9.17,28545,NULL,NULL,'K','NGC 3412',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75132,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75132,29.96,0.4,9.81,28545,NULL,NULL,'mean','NGC 3412',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75133,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75133,35.31,0.46,115,28546,70,NULL,NULL,'2MASX J10505585+4701340',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000093,NULL,'15.5g',0.51,'S0^-',NULL,NULL,NULL,NULL,1,162.732625,47.02631,0,NULL,63911737752,998620902,15603451,15.5),(75134,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75134,37.83,0.46,367,28547,70,NULL,NULL,'2MASX J10505632+4516060',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000138,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,162.7345,45.26828,0,NULL,63909385232,998584144,15602877,17.6),(75135,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75135,38.3,0.46,456,28548,70,NULL,NULL,'2MASX J10505631+2302090',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,162.734583,23.03581,0,NULL,60983515789,952867434,14888553,17.5),(75136,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75136,35.01,0.27,100,28549,70,NULL,NULL,'CGCG 066-037',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000244,NULL,'15.5',0.31,NULL,'Group member',NULL,NULL,NULL,1,162.734708333,8.75869,0.013,NULL,61029256903,953582139,14899720,15.5),(75137,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75137,37.72,0.46,351,28550,70,NULL,NULL,'SDSS J105056.91+561946.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,162.737166667,56.32967,0,NULL,61968774507,968262101,15129095,18.2),(75138,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75138,37.87,0.46,375,28551,70,NULL,NULL,'2MASXi J1050568+634620',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,162.7372917,63.77233,0,NULL,61836887919,966201373,15096896,17.9),(75139,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75139,34.28,0.51,71.9,28552,70,NULL,NULL,'NGC 3421',NULL,'2014MNRAS.445.2677S',2014,1,2,NULL,'G',0.00004,NULL,'14.47',1.6,'(R\')SB(rs)a pec',NULL,NULL,NULL,NULL,1,162.740125,-12.44853,0.121,NULL,41813988455,653343569,10208493,14.47),(75140,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75140,34.26,0.4,71.1,28552,NULL,NULL,'mean','NGC 3421',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75141,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75141,34.9,0.47,95.7,28552,NULL,NULL,'H','NGC 3421',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75142,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75142,34.91,0.45,95.8,28552,NULL,NULL,'K','NGC 3421',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75143,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75143,34.98,0.46,98.9,28552,NULL,NULL,'J','NGC 3421',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75144,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75144,35.83,0.46,147,28553,70,NULL,NULL,'2MASX J10505823+1833540',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.94',0.21,NULL,NULL,NULL,NULL,NULL,1,162.742625,18.56497,0.045,NULL,61160997283,955640582,14931884,17.94),(75145,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75145,33.43,0.47,48.5,28554,NULL,NULL,'H','ESO 501- G 102',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000017,NULL,'13.32',1.1,'SB(s)c: pec    HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,162.743,-23.65894,0.237,NULL,41633793834,650528028,10164500,13.32),(75146,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75146,33.53,0.45,50.9,28554,NULL,NULL,'K','ESO 501- G 102',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75147,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75147,33.57,0.46,51.7,28554,NULL,NULL,'J','ESO 501- G 102',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75148,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75148,33.99,0.4,62.7,28554,NULL,NULL,'mean','ESO 501- G 102',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75149,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75149,34.85,0.46,93.2,28555,70,NULL,NULL,'CGCG 125-012',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000163,NULL,'14.9g',0.58,NULL,NULL,NULL,NULL,'Emission-Line Galaxy',1,162.7432917,25.228,0.015,NULL,60493645998,945213218,14768956,14.9),(75150,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75150,37.15,0.46,269,28556,70,NULL,NULL,'2MASX J10505892+2831541',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000181,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,162.745375,28.53175,0,NULL,60516784920,945574764,14774605,16.9),(75151,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75151,37.68,0.11,344,28557,70,NULL,NULL,'2MASX J10505919+5511074',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000175,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,162.746583,55.18536,0,NULL,61971509342,968304833,15129763,16.7),(75152,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75152,37.28,0.46,285,28558,70,NULL,NULL,'2MASX J10510020+1633107',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,162.750833,16.553,0.033,NULL,61189712615,956089259,14938894,17.7),(75153,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75153,34.64,0.49,84.8,28559,75,NULL,'IR','UGC 05951',NULL,'2011yCatp016004901K',2011,1,1.66,NULL,'G',0.000014,NULL,'15.7g',0.2,'Sd',NULL,NULL,NULL,NULL,1,162.75425,36.19258,0,NULL,64109158755,1001705605,15651650,15.7),(75154,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75154,34.67,NULL,85.9,28559,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05951',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75155,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75155,34.7,NULL,86.9,28559,NULL,NULL,'Dipole + Quadrupole','UGC 05951',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75156,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75156,34.71,NULL,87.4,28559,NULL,NULL,'Dipole','UGC 05951',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75157,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75157,34.81,NULL,91.5,28559,NULL,NULL,NULL,'UGC 05951',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75158,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75158,35,0.2,100,28559,74.4,NULL,NULL,'UGC 05951',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75159,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75159,36.98,0.46,249,28560,70,NULL,NULL,'2MASX J10510104+1920370',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.96',0.21,NULL,NULL,NULL,NULL,NULL,1,162.754417,19.34364,0.057,NULL,61160780566,955637196,14931831,17.96),(75160,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75160,36.81,0.46,230,28561,70,NULL,NULL,'2MASX J10510150+0817412',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.09',0.18,NULL,NULL,NULL,NULL,NULL,1,162.7564583,8.29486,0.053,NULL,61030176818,953596512,14899945,18.09),(75161,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75161,38.39,0.46,476,28562,70,NULL,NULL,'2MASX J10510158+3536479',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000189,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,162.756708333,35.61322,0.007,NULL,64042347436,1000661678,15635338,16.9),(75162,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75162,37.84,0.19,370,28563,70,NULL,NULL,'2MASX J10510180+2038260',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.14',0.15,NULL,NULL,NULL,NULL,NULL,1,162.757667,20.64036,0.013,NULL,60978841606,952794400,14887412,18.14),(75163,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75163,34.41,0.46,76.3,28564,70,NULL,NULL,'2MASX J10510201+1137342',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000087,NULL,'15.4g',0.33,'bS0 or S0(M32-type)','Group member',NULL,NULL,NULL,1,162.758375,11.62614,0.053,NULL,61023522944,953492546,14898321,15.4),(75164,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75164,35.49,0.46,125,28565,70,NULL,NULL,'CGCG 095-042',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.00013,NULL,'15.4',0.4,NULL,NULL,NULL,NULL,NULL,1,162.759167,18.23569,0.045,NULL,61160879450,955638741,14931855,15.4),(75165,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:49','1','SN 2010Y',NULL,75165,33.89,0.25,59.2,28566,73.8,NULL,'SALT 2 (SNANA)','NGC 3392',0.0114,'2014ApJ...795...44R',2014,1,0.9,NULL,'G',0.000103,NULL,'14.3g',0.7,'E?             BLAGN','in a pair',NULL,NULL,'Sy 1',1,162.7625,65.78156,0,NULL,62114344270,970536629,15164634,14.3),(75166,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75166,34.55,0.46,81.3,28566,70,NULL,NULL,'NGC 3392',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75167,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75167,37.34,0.46,294,28567,70,NULL,NULL,'2MASX J10510321+1516347',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000187,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,162.763375,15.27625,0.041,NULL,61201538044,956274031,14941781,16.9),(75168,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75168,37.92,0.46,384,28568,70,NULL,NULL,'2MASX J10510517+0130383',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'18.2g',0.12,'Sc-Sd',NULL,NULL,NULL,NULL,1,162.7715417,1.51047,0.105,NULL,60269561973,941711905,14714248,18.2),(75169,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75169,37.39,0.46,301,28569,70,NULL,NULL,'2MASX J10510668+4353565',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000192,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,162.7780417,43.89906,0,NULL,63908621989,998572218,15602690,16.9),(75170,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75170,37.1,0.46,263,28570,70,NULL,NULL,'2MASX J10510944+0843322',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.93',0.18,NULL,NULL,NULL,NULL,NULL,1,162.789333,8.72564,0.013,NULL,61029436728,953584948,14899764,17.93),(75171,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75171,37.73,0.46,352,28571,70,NULL,NULL,'2MASX J10510982+4243075',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000193,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,162.790708333,42.71864,0,NULL,64110813392,1001731459,15652054,16.8),(75172,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75172,34.05,0.4,64.6,28572,NULL,NULL,'mean','UGC 05957',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000043,NULL,'14.7',0.25,'S',NULL,NULL,NULL,NULL,1,162.7947917,20.17044,0.021,NULL,60978459258,952788425,14887319,14.7),(75173,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75173,34.07,0.47,65.3,28572,NULL,NULL,'H','UGC 05957',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75174,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75174,34.15,0.45,67.5,28572,NULL,NULL,'K','UGC 05957',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75175,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75175,34.21,0.46,69.3,28572,NULL,NULL,'J','UGC 05957',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75176,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75176,34.26,0.49,71,28572,75,NULL,'IR','UGC 05957',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75177,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75177,36.79,0.46,228,28573,70,NULL,NULL,'2MASX J10511143+3359349',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000201,NULL,'15.8g',0.36,'S0',NULL,NULL,NULL,NULL,1,162.797583,33.99325,0,NULL,64041237346,1000644333,15635067,15.8),(75178,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75178,37.04,0.46,256,28574,70,NULL,NULL,'2MASX J10511144+5442533',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,162.797667,54.71492,0,NULL,61974425751,968350402,15130475,16.8),(75179,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75179,30.02,0.4,10.1,28575,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 3 galaxy group','NGC 3423',NULL,'1992ApJS...80..479T',1992,1,3.8,NULL,'G',0.000007,NULL,'11.59',3.2,'SA(s)cd','Field galaxy',NULL,NULL,NULL,1,162.8097083,5.84003,0.081,NULL,61060692129,954073314,14907395,11.59),(75180,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75180,30.18,0.4,10.9,28575,75,NULL,'B','NGC 3423',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75181,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75181,30.35,0.36,11.7,28575,NULL,NULL,NULL,'NGC 3423',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75182,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75182,30.34,0.39,11.7,28575,73,NULL,'opt','NGC 3423',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75183,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75183,31.45,NULL,19.5,28575,NULL,NULL,NULL,'NGC 3423',NULL,'2015AstBu..70....1K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75184,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75184,37.96,0.46,390,28576,70,NULL,NULL,'SDSS J105114.66+053304.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000141,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,162.811083,5.55131,0.089,NULL,60272202374,941753162,14714893,18.5),(75185,'FP','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75185,36.08,0.46,164,28577,70,NULL,NULL,'CGCG 038-028',NULL,'2015arXiv151105856S',2015,1,0.93,NULL,'G',0.000077,NULL,'14.9g',0.63,'S0',NULL,NULL,NULL,NULL,1,162.813041667,2.43781,0.093,NULL,60269251443,941707053,14714172,14.9),(75186,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75186,31.73,0.43,22.2,28578,75,NULL,'3.6 micron, color + selection bias corrected','UGC 05958',NULL,'2014MNRAS.444..527S',2014,1,1.62,NULL,'G',0.00002,NULL,'15.0g',0.38,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,162.816166667,27.84878,0,NULL,60518144717,945596011,14774937,15),(75187,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75187,31.88,0.4,23.7,28578,75,NULL,NULL,'UGC 05958',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75188,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75188,31.94,0.43,24.5,28578,75,NULL,'3.6 micron, color corrected','UGC 05958',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75189,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75189,32.13,0.2,26.7,28578,74.4,NULL,NULL,'UGC 05958',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75190,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75190,32.28,1.38,28.6,28578,NULL,NULL,'Malmquist cor.','UGC 05958',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75191,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75191,32.4,1.3,30.2,28578,NULL,NULL,NULL,'UGC 05958',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75192,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,'R',75192,32.45,0.49,30.9,28578,75,NULL,'IR','UGC 05958',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75193,'SBF','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75193,32.01,0.33,25.2,28579,NULL,NULL,'I','NGC 3414',NULL,'2001ApJ...546..681T',2001,1,3.5,NULL,'G',0.000017,NULL,'11.96',2.6,'S0 pec         LINER','Pair member (points to parent)',NULL,NULL,NULL,1,162.8175417,27.97511,0,NULL,60518272372,945598005,14774968,11.96),(75194,'SBF','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75194,32.05,0.14,25.7,28579,74.4,NULL,NULL,'NGC 3414',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75195,'Faber-Jackson','2016-12-15 15:14:42','2016-12-16 11:19:49','1',NULL,NULL,75195,29.74,0.65,8.87,28579,95,NULL,'Weighted Mean','NGC 3414',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75196,'Faber-Jackson','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75196,30.66,0.81,13.6,28579,55,NULL,'Visvanathan & Sandage 1979','NGC 3414',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75197,'Tully est','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75197,31.98,0.8,24.9,28579,75,NULL,'B','NGC 3414',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75198,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75198,32.36,0.4,29.6,28579,NULL,NULL,'mean','NGC 3414',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75199,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75199,32.81,0.45,36.4,28579,NULL,NULL,'K','NGC 3414',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75200,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75200,37.92,0.33,384,28580,70,NULL,NULL,'2MASX J10511658+3528119',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00018,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,162.819166667,35.47011,0.007,NULL,64042531436,1000664553,15635383,17.5),(75201,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75201,33.85,0.47,58.8,28581,70,NULL,NULL,'NGC 3422',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00011,NULL,'14.63',0.3,'S0+? sp',NULL,NULL,NULL,NULL,1,162.82225,-12.40239,0.121,NULL,41813986720,653343542,10208492,14.63),(75202,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75202,33.19,0.4,43.4,28582,75,NULL,'B','NGC 3419',NULL,'1988NBGC.C....0000T',1988,1,1.2,NULL,'G',0.000023,NULL,'13.46',1,'(R)SAB(r)0+','in a radial-velocity based grouping',NULL,NULL,NULL,1,162.823916667,13.946,0.045,NULL,61194838310,956169348,14940146,13.46),(75203,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75203,37.31,0.46,289,28583,70,NULL,NULL,'2MASX J10511769+0548323',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,162.823875,5.80889,0.093,NULL,61060679319,954073114,14907392,16.3),(75204,'Tully est','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75204,32.33,0.8,29.2,28584,75,NULL,'B','UGC 05953',NULL,'1988NBGC.C....0000T',1988,1,0.6,'RC3 has V = 1800 +- 110 km/sec.','G',0.00014,NULL,'13.8',0.3,'E/S0','Isolated galaxy (6 Mpc isolation)',NULL,NULL,NULL,1,162.825125,44.57181,0,NULL,63908779746,998574683,15602729,13.8),(75205,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75205,34.89,0.27,95.2,28585,70,NULL,NULL,'2MASX J10511908+1557157',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000167,NULL,'15.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,162.8295,15.95442,0.037,NULL,61201938317,956280286,14941879,15.9),(75206,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75206,33.38,0.4,47.4,28586,NULL,NULL,NULL,'NGC 3419A',NULL,'2009AJ....138..323T',2009,1,2.47,NULL,'G',0.000006,NULL,'14.7g',0.3,'SB(s)b: sp','Probable group member',NULL,NULL,NULL,1,162.833083,14.02344,0.045,NULL,61194716234,956167441,14940116,14.7),(75207,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75207,33.43,0.2,48.5,28586,74.4,NULL,NULL,'NGC 3419A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75208,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75208,33.52,NULL,50.5,28586,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 3419A',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75209,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75209,33.52,NULL,50.7,28586,NULL,NULL,'Dipole + Quadrupole','NGC 3419A',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75210,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75210,33.53,NULL,50.8,28586,NULL,NULL,'Dipole','NGC 3419A',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75211,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75211,33.59,NULL,52.2,28586,NULL,NULL,NULL,'NGC 3419A',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75212,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75212,33.61,0.62,52.7,28586,NULL,NULL,NULL,'NGC 3419A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75213,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75213,33.65,0.49,53.7,28586,75,NULL,'IR','NGC 3419A',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75214,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75214,33.69,0.6,54.6,28586,NULL,NULL,'Malmquist cor.','NGC 3419A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75215,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75215,37.55,0.46,324,28587,70,NULL,NULL,'2MASX J10511993+4614035',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,162.833083,46.23431,0,NULL,63912177607,998627775,15603558,17.2),(75216,'SBF','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75216,30.99,0.14,15.8,28588,74.4,NULL,NULL,'NGC 3413',NULL,'2013AJ....146...86T',2013,1,1.71,NULL,'G',0.00002,NULL,'13.2g',0.86,'S0','in a triple',NULL,NULL,NULL,1,162.836416667,32.76639,0.007,NULL,60500670773,945322980,14770671,13.2),(75217,'SBF','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75217,31.05,0.24,16.2,28588,NULL,NULL,'I','NGC 3413',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75218,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75218,30.4,NULL,12,28588,NULL,NULL,NULL,'NGC 3413',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75219,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75219,37.15,0.46,269,28589,70,NULL,NULL,'2MASX J10512203+2336284',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,162.8419583,23.60792,0.01,NULL,60974876302,952732442,14886444,17.3),(75220,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75220,32.99,0.4,39.5,28590,75,NULL,NULL,'MCG -02-28-016',NULL,'2008Ap.....51..336K',2008,1,1.81,NULL,'G',0.000017,NULL,'14.93',0.11,'S0: sp',NULL,NULL,NULL,NULL,1,162.84625,-10.13344,0.049,NULL,41786551921,652914873,10201794,14.93),(75221,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75221,33.47,NULL,49.3,28590,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -02-28-016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75222,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75222,33.47,NULL,49.5,28590,NULL,NULL,'Dipole + Quadrupole','MCG -02-28-016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75223,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75223,33.49,NULL,49.9,28590,NULL,NULL,'Dipole','MCG -02-28-016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75224,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75224,33.54,0.49,50.9,28590,75,NULL,'IR','MCG -02-28-016',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75225,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75225,37.49,0.33,314,28591,70,NULL,NULL,'2MASX J10512312+4008299',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000192,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,162.846333,40.14172,0,NULL,64112941798,1001764715,15652573,16.9),(75226,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75226,37.64,0.46,338,28592,70,NULL,NULL,'2MASX J10512336+3645479',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,162.8472083,36.76325,0,NULL,64109324589,1001708196,15651690,17.5),(75227,'IRAS','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75227,32.27,0.8,28.5,28593,75,NULL,'MAT, I','UGCA 221',NULL,'1997ApJS..109..333W',1997,1,4.26,'ESO-LV has V = 3108 +- 5 km/sec; 1992ApJS...81..413M have V = 2053 km/sec.','G',0.000013,NULL,'13.80',0.48,'SB(s)cd:',NULL,NULL,NULL,NULL,1,162.850333,-19.89072,0.117,NULL,41852438701,653944354,10217880,13.8),(75228,'Tully est','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75228,32.32,0.8,29.2,28593,75,NULL,NULL,'UGCA 221',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75229,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75229,31.68,0.4,21.6,28593,75,NULL,NULL,'UGCA 221',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75230,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75230,31.71,NULL,22,28593,NULL,NULL,NULL,'UGCA 221',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75231,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75231,31.86,0.49,23.5,28593,75,NULL,'IR','UGCA 221',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75232,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75232,31.93,NULL,24.4,28593,NULL,NULL,'Dipole + Quadrupole + Octopole','UGCA 221',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75233,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75233,31.94,NULL,24.4,28593,NULL,NULL,'Dipole','UGCA 221',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75234,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75234,31.94,NULL,24.4,28593,NULL,NULL,'Dipole + Quadrupole','UGCA 221',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75235,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75235,31.97,0.4,24.8,28593,NULL,NULL,NULL,'UGCA 221',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75236,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75236,32.02,0.2,25.4,28593,74.4,NULL,NULL,'UGCA 221',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75237,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75237,32.07,0.32,26,28593,85,NULL,'I, raw','UGCA 221',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75238,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75238,32.08,0.32,26.1,28593,85,NULL,'I, inv','UGCA 221',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75239,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75239,32.09,0.74,26.2,28593,NULL,NULL,NULL,'UGCA 221',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75240,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75240,32.14,0.43,26.8,28593,75,NULL,'MAT, I, raw','UGCA 221',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75241,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75241,32.21,0.43,27.7,28593,75,NULL,'3.6 micron, color corrected','UGCA 221',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75242,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75242,32.24,0.43,28,28593,75,NULL,'MAT, I, inv','UGCA 221',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75243,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75243,32.29,0.67,28.7,28593,NULL,NULL,'Malmquist cor.','UGCA 221',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75244,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75244,32.31,0.43,29,28593,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 221',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75245,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75245,32.47,0.43,31.1,28593,75,NULL,'MAT, I, cor','UGCA 221',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75246,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75246,37.53,0.46,321,28594,70,NULL,NULL,'2MASX J10512445+2856189',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,162.851958333,28.93867,0,NULL,60516908676,945576698,14774635,17.7),(75247,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 2009al','R',75247,34.93,0.07,96.8,28595,NULL,NULL,'MLCS2k2, R(V) = 3.1','NGC 3425',NULL,'2015Sci...347.1459K',2015,1,1,NULL,'G',0.00008,NULL,'14.12',1,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,162.856375,8.56714,0.017,NULL,61029395817,953584309,14899754,14.12),(75248,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 2009al',NULL,75248,35.03,0.2,98.8,28595,73.8,NULL,'SALT 2 (SNANA)','NGC 3425',0.0237,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75249,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 2009al','R',75249,35.06,0.06,103,28595,NULL,NULL,'MLCS2k2, R(V) = 1.8','NGC 3425',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75250,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75250,37.41,0.46,303,28596,70,NULL,NULL,'2MASX J10512553+2610549',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000186,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,162.856625,26.18189,0,NULL,60492518271,945195597,14768681,16.5),(75251,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75251,37.39,0.21,301,28597,70,NULL,NULL,'2MASX J10512572+5735437',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000219,NULL,'16.8g',0.26,'Elliptical',NULL,NULL,NULL,NULL,1,162.8570417,57.59558,0,NULL,62005971260,968843300,15138176,16.8),(75252,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75252,35.01,0.27,100,28598,70,NULL,NULL,'NGC 3427',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.00017,NULL,'14.20',0.5,'S0/a','in a radial-velocity based grouping',NULL,NULL,NULL,1,162.8597083,8.29869,0.025,NULL,61030209536,953597024,14899953,14.2),(75253,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75253,37.49,0.33,314,28599,70,NULL,NULL,'2MASX J10512652+4009510',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000175,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,162.860417,40.16419,0,NULL,64112950190,1001764846,15652575,17.2),(75254,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75254,37.39,0.21,301,28600,70,NULL,NULL,'2MASX J10512705+5742367',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000201,NULL,'15.9g',0.41,'E0',NULL,NULL,NULL,NULL,1,162.862875,57.71011,0,NULL,62004674033,968823031,15137859,15.9),(75255,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75255,37.49,0.46,315,28601,70,NULL,NULL,'2MASX J10512871+1017354',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.14',0.18,NULL,NULL,NULL,NULL,NULL,1,162.86975,10.29311,0.021,NULL,61026677990,953541843,14899091,18.14),(75256,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75256,35.31,0.4,115,28602,NULL,NULL,'mean','NGC 3428',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000007,NULL,'13.95',0.7,'SAB(s)b','Group member',NULL,NULL,NULL,1,162.872958333,9.2795,0.037,NULL,61031476942,953616827,14900262,13.95),(75257,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75257,35.31,0.47,115,28602,NULL,NULL,'H','NGC 3428',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75258,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75258,35.34,0.36,117,28602,NULL,NULL,NULL,'NGC 3428',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75259,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75259,35.34,0.36,117,28602,NULL,NULL,'Malmquist cor.','NGC 3428',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75260,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75260,35.4,0.2,120,28602,74.4,NULL,NULL,'NGC 3428',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75261,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75261,35.44,0.46,122,28602,NULL,NULL,'J','NGC 3428',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75262,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75262,35.44,0.45,122,28602,NULL,NULL,'K','NGC 3428',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75263,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75263,38.15,0.33,426,28603,70,NULL,NULL,'2MASX J10512949+1041084',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000204,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,162.873041667,10.68575,0.013,NULL,61026766502,953543226,14899112,16.6),(75264,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75264,37.68,0.46,344,28604,70,NULL,NULL,'2MASX J10513166+4930086',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000179,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,162.8817083,49.5025,0,NULL,63907607962,998556374,15602443,16.6),(75265,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75265,37.68,0.11,344,28605,70,NULL,NULL,'2MASX J10513194+5524057',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00018,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,162.883125,55.40161,0,NULL,61971859501,968310304,15129848,17.7),(75266,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75266,31.82,NULL,23.1,28606,NULL,NULL,NULL,'HIPASS J1051+03',NULL,'2015AstBu..70....1K',2015,1,1.2,'Bright star 18\\\" to the south.','G',0.000003,NULL,'16.5',0.95,'Sm',NULL,NULL,NULL,NULL,1,162.883375,3.45406,0.093,NULL,60274324255,941786316,14715411,16.5),(75267,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75267,36.9,0.46,240,28607,70,NULL,NULL,'2MASX J10513221+6121075',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000173,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,162.884,61.35194,0,NULL,61951546294,967992910,15124889,16.8),(75268,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75268,36.51,0.46,200,28608,70,NULL,NULL,'2MASX J10513220+5646047',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,162.884458333,56.76789,0,NULL,62001377557,968771524,15137055,16.9),(75269,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75269,37.68,0.11,344,28609,70,NULL,NULL,'SDSS J105132.54+552229.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,162.885625,55.37494,0,NULL,61971646392,968306974,15129796,18.4),(75270,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75270,36.28,0.46,181,28610,70,NULL,NULL,'2MASX J10513300+3605010',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000172,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,162.88775,36.08364,0,NULL,64109164779,1001705699,15651651,16.5),(75271,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75271,34.29,0.49,72,28611,75,NULL,'IR','ESO 376- G 023',NULL,'2011yCatp016004901K',2011,1,1.95,NULL,'G',0.000033,NULL,'15.35',0.2,'Sb',NULL,NULL,NULL,NULL,1,162.890416667,-35.47525,0.189,NULL,41980232410,655941131,10249080,15.35),(75272,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75272,34.31,0.43,72.9,28611,75,NULL,'3.6 micron, color + selection bias corrected','ESO 376- G 023',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75273,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75273,34.34,0.54,74,28611,NULL,NULL,'Malmquist cor.','ESO 376- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75274,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75274,34.4,0.43,76,28611,75,NULL,'3.6 micron, color corrected','ESO 376- G 023',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75275,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75275,34.47,NULL,78.3,28611,NULL,NULL,NULL,'ESO 376- G 023',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75276,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75276,34.48,NULL,78.7,28611,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 376- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75277,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75277,34.49,NULL,78.9,28611,NULL,NULL,'Dipole + Quadrupole','ESO 376- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75278,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75278,34.5,NULL,79.4,28611,NULL,NULL,'Dipole','ESO 376- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75279,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75279,34.53,0.2,80.5,28611,74.4,NULL,NULL,'ESO 376- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75280,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75280,34.63,0.47,84.3,28611,NULL,NULL,NULL,'ESO 376- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75281,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75281,37.47,0.46,311,28612,70,NULL,NULL,'2MASX J10513390+1739072',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000173,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,162.891333,17.65192,0.057,NULL,61189118054,956079969,14938749,16.9),(75282,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75282,35.94,0.33,154,28613,70,NULL,NULL,'2MASX J10513410+3012218',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000166,NULL,'16.0g',0.41,NULL,NULL,NULL,NULL,NULL,1,162.8920417,30.20608,0.029,NULL,60511329335,945489520,14773273,16),(75283,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75283,37.68,0.11,344,28614,70,NULL,NULL,'SDSS J105134.80+552128.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000157,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,162.895,55.35789,0,NULL,61971647527,968306992,15129796,18.7),(75284,'IRAS','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75284,31.29,0.8,18.1,28615,75,NULL,'CF, r','UGC 05974',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.00002,NULL,'14.00',0.8,'Scd:',NULL,NULL,NULL,NULL,1,162.896667,4.58306,0.113,NULL,60272702516,941760976,14715015,14),(75285,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75285,30.89,0.39,15.1,28615,73,NULL,'opt','UGC 05974',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75286,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75286,31.87,0.2,23.7,28615,74.4,NULL,NULL,'UGC 05974',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75287,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75287,32,0.4,25.1,28615,NULL,NULL,NULL,'UGC 05974',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75288,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75288,32.09,0.7,26.2,28615,NULL,NULL,'Malmquist cor.','UGC 05974',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75289,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75289,32.25,0.65,28.2,28615,NULL,NULL,NULL,'UGC 05974',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75290,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75290,32.49,0.38,31.5,28615,75,NULL,'CF, r, inv','UGC 05974',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75291,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75291,32.54,0.38,32.3,28615,75,NULL,'CF, r, raw','UGC 05974',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75292,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75292,32.69,0.38,34.5,28615,75,NULL,'CF, r, cor','UGC 05974',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75293,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75293,36.46,0.46,196,28616,70,NULL,NULL,'2MASX J10513705+2226573',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.17',0.17,NULL,NULL,NULL,NULL,NULL,1,162.9045,22.44939,0,NULL,60984210140,952878283,14888723,18.17),(75294,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75294,38.19,0.46,435,28617,70,NULL,NULL,'2MASX J10513743+3032427',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,162.905875,30.54519,0.035,NULL,60512185805,945502903,14773482,17.6),(75295,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75295,37.85,0.64,371,28618,70,NULL,NULL,'2MASX J10513858-0926434',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.50',0.4,NULL,NULL,NULL,NULL,NULL,1,162.9109583,-9.44531,0.033,NULL,41785897892,652904654,10201635,16.5),(75296,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75296,37.36,0.46,297,28619,70,NULL,NULL,'2MASX J10513922-0034505',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000082,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,162.913458333,-0.58069,0.101,NULL,40878599487,638728116,9980126,17.1),(75297,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75297,38.3,0.46,456,28620,70,NULL,NULL,'2MASX J10514040+3811560',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000177,NULL,'16.7g',0.35,NULL,NULL,NULL,NULL,NULL,1,162.9185,38.19878,0,NULL,64107311748,1001676746,15651199,16.7),(75298,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75298,37.73,0.46,351,28621,70,NULL,NULL,'SDSS J105140.89+240312.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,162.920375,24.05347,0,NULL,60491457670,945179026,14768422,18.3),(75299,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75299,36.39,0.46,190,28622,70,NULL,NULL,'2MASX J10514133+3636530',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000198,NULL,'16.1g',0.31,NULL,NULL,NULL,NULL,NULL,1,162.922083,36.61483,0,NULL,64109408123,1001709501,15651710,16.1),(75300,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75300,37.82,0.46,367,28623,70,NULL,NULL,'2MASX J10514162+4425364',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,162.923375,44.42669,0,NULL,63908782372,998574724,15602730,17.6),(75301,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75301,33.84,0.46,58.6,28624,70,NULL,NULL,'NGC 3426',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.000143,NULL,'14.08',0.8,'S?','Field galaxy',NULL,NULL,NULL,1,162.9239583,18.48083,0.045,NULL,61161053749,955641464,14931897,14.08),(75302,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75302,37.81,0.46,364,28625,70,NULL,NULL,'2MASX J10514189+2121077',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.89',0.2,NULL,NULL,NULL,NULL,NULL,1,162.9245417,21.35228,0,NULL,60982758715,952855604,14888368,17.89),(75303,'Faber-Jackson','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75303,29.09,1.31,6.58,28626,95,NULL,'Weighted Mean','NGC 3415',NULL,'1984ApJS...56...91D',1984,1,1.86,NULL,'G',0.00003,NULL,'13.0g',0.88,'SA0+:','Possible field galaxy',NULL,NULL,NULL,1,162.9275,43.71261,0,NULL,63937973274,999030832,15609856,13),(75304,'Faber-Jackson','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75304,29.86,1.61,9.38,28626,55,NULL,'Visvanathan & Sandage 1979','NGC 3415',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75305,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75305,33.11,0.45,41.9,28626,NULL,NULL,'K','NGC 3415',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75306,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75306,33.34,0.4,46.5,28626,NULL,NULL,'mean','NGC 3415',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75307,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75307,38.23,0.46,444,28627,70,NULL,NULL,'2MASX J10514417+0206232',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000186,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,162.934083,2.10631,0.093,NULL,60269868326,941716692,14714323,18.1),(75308,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75308,35.22,0.4,111,28628,NULL,NULL,'mean','NGC 3406',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'GPair',NULL,NULL,NULL,NULL,'DBL SYS','Possible field galaxy',NULL,NULL,NULL,1,162.934167,51.02389,0,NULL,63906807518,998543867,15602247,NULL),(75309,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75309,35.7,0.45,138,28628,NULL,NULL,'K','NGC 3406',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75310,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75310,38.15,0.33,426,28629,70,NULL,NULL,'2MASX J10514435+1041204',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,162.934833,10.68886,0.013,NULL,61026877731,953544964,14899140,17.7),(75311,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75311,37.41,0.46,303,28630,70,NULL,NULL,'2MASX J10514508-0026165',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000085,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,162.937833333,-0.43797,0.101,NULL,40877868192,638716690,9979948,17.4),(75312,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75312,37.77,0.46,358,28631,70,NULL,NULL,'SDSS J105145.47+112700.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000146,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,162.9395,11.45008,0.041,NULL,61023657007,953494640,14898353,18.1),(75313,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75313,37.07,0.46,259,28632,70,NULL,NULL,'SDSS J105145.47+210132.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,162.9395,21.02561,0,NULL,60982626497,952853539,14888336,17.8),(75314,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75314,37.79,0.46,362,28633,70,NULL,NULL,'2MASX J10514571+0436302',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000168,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,162.9404583,4.60828,0.113,NULL,60318595845,942478060,14726219,16.7),(75315,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75315,36.23,0.46,176,28634,70,NULL,NULL,'2MASX J10514602+2503539',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000185,NULL,'15.8g',0.42,NULL,NULL,NULL,NULL,NULL,1,162.941667,25.06481,0.018,NULL,60491807881,945184498,14768507,15.8),(75316,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75316,32.18,0.4,27.2,28635,NULL,NULL,'mean','NGC 3424',NULL,'2007A&A...465...71T',2007,1,2.8,NULL,'G',0.000013,NULL,'13.18',0.8,'SB(s)b:?       HII','in a triple',NULL,NULL,NULL,1,162.943041667,32.90075,0.007,NULL,60500697259,945323394,14770678,13.18),(75317,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75317,32.35,0.47,29.6,28635,NULL,NULL,'H','NGC 3424',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75318,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75318,32.36,0.45,29.6,28635,NULL,NULL,'K','NGC 3424',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75319,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75319,32.42,0.46,30.5,28635,NULL,NULL,'J','NGC 3424',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75320,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75320,32.47,0.49,31.2,28635,75,NULL,'IR','NGC 3424',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75321,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75321,37.68,0.11,344,28636,70,NULL,NULL,'MCG +09-18-041',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.0001,NULL,'15.6g',0.58,'BrClG          AGN',NULL,NULL,NULL,NULL,1,162.9475,55.38567,0,NULL,61971859947,968310311,15129848,15.6),(75322,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75322,36.34,0.46,186,28637,70,NULL,NULL,'2MASX J10514795+1159024',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000177,NULL,'15.8g',0.4,'E0',NULL,NULL,NULL,NULL,1,162.9497083,11.98381,0.049,NULL,61144994285,955390535,14927977,15.8),(75323,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75323,37.61,0.46,333,28638,70,NULL,NULL,'2MASX J10514809+3334504',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,162.950167,33.58061,0,NULL,64041144067,1000642876,15635044,17.5),(75324,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75324,36.13,0.71,169,28639,70,NULL,NULL,'LCRS B104916.6-053513',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.80',NULL,NULL,NULL,NULL,NULL,NULL,1,162.951875,-5.85275,0.029,NULL,40894470980,638976109,9984001,16.8),(75325,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75325,38.11,0.46,420,28640,70,NULL,NULL,'2MASX J10514880+2325386',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,162.953458333,23.42744,0,NULL,60983203327,952862551,14888477,17.5),(75326,'SNII radio','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 1988Z',NULL,75326,34.25,0.3,70.7,28641,NULL,NULL,NULL,'CGCG 095-049',NULL,'1998ApJ...500...51W',1998,1,0.68,NULL,'G',0.000224,NULL,'15.9g',0.57,'SBc',NULL,NULL,NULL,NULL,1,162.955833,16.00042,0.037,NULL,61202337091,956286517,14941976,15.9),(75327,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75327,37.14,0.46,268,28642,70,NULL,NULL,'2MASX J10515098+0237302',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000167,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,162.962416667,2.62508,0.077,NULL,60269042933,941703795,14714121,16.8),(75328,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75328,37.96,0.46,391,28643,70,NULL,NULL,'2MASX J10515173+3902280',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,162.965625,39.04122,0,NULL,64121332543,1001895820,15654622,17.6),(75329,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75329,37.37,0.33,298,28644,70,NULL,NULL,'SDSS J105152.19+561608.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,162.9675,56.269,0,NULL,61968805224,968262581,15129102,18.2),(75330,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75330,37.68,0.11,344,28645,70,NULL,NULL,'2MASX J10515299+5530277',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000187,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,162.970625,55.50781,0,NULL,61971862357,968310349,15129849,17.4),(75331,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75331,38.05,0.33,407,28646,70,NULL,NULL,'2MASX J10515333+1559494',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00019,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,162.972125,15.99694,0.037,NULL,61202337720,956286526,14941976,16.6),(75332,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75332,38.96,0.46,620,28647,70,NULL,NULL,'2MASX J10515440+1354264',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000147,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,162.976625,13.90739,0.049,NULL,61194754537,956168039,14940125,18.4),(75333,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75333,37.61,0.46,333,28648,70,NULL,NULL,'2MASX J10515651+0629186',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,162.9855,6.48842,0.073,NULL,61027293565,953551461,14899241,18),(75334,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75334,38.43,0.46,484,28649,70,NULL,NULL,'SDSS J105156.86+053820.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000174,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,162.986917,5.63914,0.089,NULL,60318349973,942474218,14726159,18.4),(75335,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75335,36.3,0.46,182,28650,70,NULL,NULL,'2MASX J10515828+3218225',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000171,NULL,'15.9g',0.44,NULL,NULL,NULL,NULL,NULL,1,162.992791667,32.30628,0.028,NULL,60514053830,945532091,14773938,15.9),(75336,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75336,37.43,0.33,307,28651,70,NULL,NULL,'2MASX J10515885+4541553',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000197,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,162.9952083,45.69869,0,NULL,63912127578,998626993,15603546,16.7),(75337,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75337,37.16,0.46,270,28652,70,NULL,NULL,'2MASX J10515975+2011086',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.58',0.13,NULL,NULL,NULL,NULL,NULL,1,162.998917,20.18586,0.021,NULL,60978445453,952788210,14887315,18.58),(75338,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75338,37.92,0.33,384,28653,70,NULL,NULL,'2MASX J10520005+3525205',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,163.000167,35.42233,0,NULL,64038997812,1000609340,15634520,17.5),(75339,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75339,36.19,0.49,173,28654,75,NULL,'IR','FGC 1145',NULL,'2011yCatp016004901K',2011,1,0.92,NULL,'G',0.00018,NULL,'16.3g',0.18,'Sbc',NULL,NULL,NULL,NULL,1,163.001875,45.53181,0,NULL,63909293665,998582713,15602854,16.3),(75340,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75340,36.31,NULL,183,28654,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1145',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75341,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75341,36.32,NULL,184,28654,NULL,NULL,NULL,'FGC 1145',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75342,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75342,36.34,NULL,185,28654,NULL,NULL,'Dipole + Quadrupole','FGC 1145',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75343,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75343,36.37,NULL,188,28654,NULL,NULL,'Dipole','FGC 1145',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75344,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75344,38.29,0.46,456,28655,70,NULL,NULL,'2MASX J10520075+0712006',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,163.00325,7.20033,0.049,NULL,61027864010,953560375,14899380,18),(75345,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75345,38.05,0.33,407,28656,70,NULL,NULL,'2MASX J10520095+1555054',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00015,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,163.004,15.91822,0.037,NULL,61202339248,956286550,14941977,18.5),(75346,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75346,37.93,0.33,385,28657,70,NULL,NULL,'SDSS J105201.02+094448.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'19.06',0.11,NULL,NULL,NULL,NULL,NULL,1,163.004291667,9.74672,0.041,NULL,61024922789,953514418,14898662,19.06),(75347,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75347,37.35,0.46,295,28658,70,NULL,NULL,'2MASX J10520299+2301056',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,163.0125,23.01819,0,NULL,60984128849,952877013,14888703,17.2),(75348,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75348,37.93,0.33,385,28659,70,NULL,NULL,'SDSS J105203.38+094513.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,163.014125,9.75372,0.041,NULL,61024921219,953514394,14898662,18.2),(75349,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75349,32.98,0.4,39.5,28660,75,NULL,'B','NGC 3433',NULL,'1988NBGC.C....0000T',1988,1,3.5,NULL,'G',0.000003,NULL,'12.29',3.2,'SA(s)c','Possible group member',NULL,NULL,NULL,1,163.016125,10.14831,0.037,NULL,61024313203,953504893,14898513,12.29),(75350,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75350,38.28,0.33,454,28661,70,NULL,NULL,'2MASX J10520544+1331304',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,163.0227083,13.52519,0.033,NULL,61194619870,956165935,14940092,17.6),(75351,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75351,37.16,0.46,270,28662,70,NULL,NULL,'2MASX J10520566+2157306',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,163.0235417,21.95847,0,NULL,60984267916,952879186,14888737,16.3),(75352,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75352,38.02,0.46,403,28663,70,NULL,NULL,'2MASX J10520585+2145246',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,163.0245417,21.75678,0,NULL,60982834397,952856787,14888387,17.5),(75353,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75353,35.96,0.46,156,28664,70,NULL,NULL,'CGCG 038-038',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000123,NULL,'15.1g',0.6,'E0',NULL,NULL,NULL,NULL,1,163.025583,3.37228,0.133,NULL,60319497859,942492154,14726439,15.1),(75354,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75354,37.7,0.46,347,28665,70,NULL,NULL,'SDSS J105206.54+053652.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000165,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,163.02725,5.61453,0.089,NULL,60318335269,942473988,14726156,17.9),(75355,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75355,36.49,0.46,198,28666,70,NULL,NULL,'2MASX J10520665+0631286',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000183,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,163.027875,6.52469,0.073,NULL,61028005702,953562589,14899415,16.2),(75356,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75356,34.5,0.5,79.3,28667,NULL,NULL,NULL,'IC 0653',NULL,'2009ApJS..182..474S',2009,1,1.9,'HOLM 220B is a double star.','G',0.00003,NULL,'13.9g',0.72,'S0/a:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,163.02825,-0.56078,0.101,NULL,40877830287,638716098,9979939,13.9),(75357,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75357,34.54,0.2,80.9,28667,74.4,NULL,NULL,'IC 0653',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75358,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75358,34.59,0.48,82.6,28667,NULL,NULL,'Malmquist cor.','IC 0653',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75359,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75359,37.68,0.11,344,28668,70,NULL,NULL,'2MASX J10520687+5519245',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,163.028625,55.32339,0,NULL,61971530509,968305164,15129768,17.9),(75360,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75360,37.9,0.46,379,28669,70,NULL,NULL,'2MASX J10520813+0019162',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000084,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,163.03375,0.32111,0.081,NULL,60268186864,941690419,14713912,18),(75361,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75361,36.34,0.33,186,28670,70,NULL,NULL,'2MASX J10520814+4120545',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000088,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,163.033833333,41.34864,0,NULL,64113392498,1001771757,15652683,16.6),(75362,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75362,37.37,0.33,298,28671,70,NULL,NULL,'SDSS J105208.15+561352.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,163.034,56.23128,0,NULL,61968749814,968261715,15129089,18.1),(75363,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75363,37.65,0.27,340,28672,70,NULL,NULL,'2MASX J10520826+0503332',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000201,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,163.0344583,5.05925,0.105,NULL,60319208192,942487628,14726369,16.2),(75364,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75364,36.5,0.46,200,28673,70,NULL,NULL,'MCG +04-26-014',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000117,NULL,'15.2g',0.52,NULL,NULL,NULL,NULL,NULL,1,163.0375,20.96783,0,NULL,60977909268,952779832,14887184,15.2),(75365,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75365,38.28,0.33,454,28674,70,NULL,NULL,'2MASX J10520962+1329564',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,163.040166667,13.49889,0.033,NULL,61194588432,956165444,14940085,17.6),(75366,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75366,37.88,0.46,376,28675,70,NULL,NULL,'2MASX J10521000+0053332',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.0001,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,163.0415417,0.89261,0.105,NULL,60268405015,941693828,14713966,16.9),(75367,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75367,36.34,0.33,186,28676,70,NULL,NULL,'2MASX J10521134+4116525',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00017,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,163.047416667,41.28128,0,NULL,64112315188,1001754924,15652420,16.7),(75368,'IRAS','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75368,32.27,0.8,28.5,28677,75,NULL,'A82, H','NGC 3430',NULL,'1997ApJS..109..333W',1997,1,4,NULL,'G',0.000003,NULL,'12.2',2.2,'SAB(rs)c','in a triple',NULL,NULL,NULL,1,163.0475,32.95044,0.007,NULL,60500701518,945323461,14770679,12.2),(75369,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75369,30.94,0.69,15.4,28677,100,NULL,'mid-IR','NGC 3430',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75370,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75370,31.83,0.4,23.2,28677,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 3430',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75371,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75371,32.13,0.4,26.7,28677,75,NULL,'B','NGC 3430',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75372,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75372,32.15,0.47,27,28677,75,NULL,'A82, H, raw','NGC 3430',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75373,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75373,32.25,0.47,28.2,28677,75,NULL,'A82, H, cor','NGC 3430',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75374,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75374,32.27,0.4,28.5,28677,NULL,NULL,'mean','NGC 3430',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75375,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75375,32.27,0.51,28.5,28677,NULL,NULL,'Malmquist cor.','NGC 3430',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75376,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75376,32.28,0.47,28.5,28677,75,NULL,'A82, H, inv','NGC 3430',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75377,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75377,32.4,0.43,30.2,28677,75,NULL,'3.6 micron, color corrected','NGC 3430',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75378,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75378,32.41,0.43,30.4,28677,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3430',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75379,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75379,32.45,0.2,30.9,28677,74.4,NULL,NULL,'NGC 3430',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75380,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75380,32.54,0.47,32.3,28677,NULL,NULL,'H','NGC 3430',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75381,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75381,32.55,0.46,32.4,28677,NULL,NULL,'J','NGC 3430',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75382,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75382,32.59,0.45,32.9,28677,NULL,NULL,'K','NGC 3430',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75383,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75383,32.61,0.44,33.3,28677,NULL,NULL,NULL,'NGC 3430',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75384,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75384,36.96,0.46,247,28678,70,NULL,NULL,'2MASX J10521315+0809166',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,163.054833,8.15469,0.017,NULL,61030048565,953594508,14899914,16.7),(75385,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75385,37.65,0.27,340,28679,70,NULL,NULL,'2MASX J10521448+0510452',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000176,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,163.0605417,5.17917,0.077,NULL,60319260203,942488440,14726381,17.3),(75386,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75386,36.92,0.46,242,28680,70,NULL,NULL,'2MASX J10521487-0057198',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000095,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,163.062041667,-0.9555,0.065,NULL,40878316336,638723692,9980057,16.6),(75387,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75387,37.34,0.61,293,28680,70,NULL,NULL,'2MASX J10521487-0057198',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75388,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75388,37.43,0.33,307,28681,70,NULL,NULL,'2MASX J10521488+4540342',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,163.06225,45.67617,0,NULL,63912133831,998627091,15603548,17.6),(75389,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75389,37.51,0.46,317,28682,70,NULL,NULL,'2MASX J10521527+3743075',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000175,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,163.063667,37.71864,0,NULL,64109079255,1001704363,15651630,16.9),(75390,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75390,29,0.43,6.3,28683,75,NULL,'3.6 micron, color + selection bias corrected','ESO 437- G 067',NULL,'2014MNRAS.444..527S',2014,1,2,NULL,'G',0.00001,NULL,'13.49',1.8,'(R\'_1)SB(r)ab  HII','in a triple',NULL,NULL,NULL,1,163.0669583,-32.67106,0.253,NULL,41492805109,648325079,10130079,13.49),(75391,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75391,32.1,0.47,26.3,28683,NULL,NULL,'H','ESO 437- G 067',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75392,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75392,32.21,0.46,27.7,28683,NULL,NULL,'J','ESO 437- G 067',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75393,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75393,32.23,0.45,28,28683,NULL,NULL,'K','ESO 437- G 067',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75394,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75394,33.37,0.4,47.3,28683,NULL,NULL,'mean','ESO 437- G 067',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75395,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75395,34.61,0.46,83.5,28684,70,NULL,NULL,'NGC 3407',NULL,'2015arXiv151105856S',2015,1,1.14,NULL,'G',0.000193,NULL,'14.3g',0.62,'S0-:',NULL,NULL,NULL,NULL,1,163.074125,61.37964,0,NULL,61830754814,966105543,15095399,14.3),(75396,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75396,36.72,0.46,220,28685,70,NULL,NULL,'2MASX J10521861+1848508',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.29',0.17,NULL,NULL,NULL,NULL,NULL,1,163.0775,18.81428,0.041,NULL,61161188366,955643568,14931930,18.29),(75397,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75397,37.78,0.46,359,28686,70,NULL,NULL,'2MASX J10521885+1351578',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,163.0787083,13.86606,0.049,NULL,61194497981,956164030,14940062,17.6),(75398,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 2001ix','R',75398,42.16,NULL,1580,28687,65,NULL,'SALT','H-ZSNS J105218.92+570729.6',0.711,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,163.078833,57.12489,0,NULL,62006073064,968844891,15138201,NULL),(75399,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 2001ix',NULL,75399,42.86,0.37,2180,28687,74.2,NULL,'SALT 2','H-ZSNS J105218.92+570729.6',0.711,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75400,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 2001ix',NULL,75400,43.05,0.32,2380,28687,65,NULL,NULL,'H-ZSNS J105218.92+570729.6',0.711,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75401,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 2001ix',NULL,75401,43.09,0.2,2430,28687,72,NULL,'dm15','H-ZSNS J105218.92+570729.6',0.711,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75402,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 2001ix',NULL,75402,43.14,0.28,2480,28687,72,NULL,'BATM','H-ZSNS J105218.92+570729.6',0.711,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75403,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 2001ix',NULL,75403,43.22,0.25,2570,28687,72,NULL,'MLCS','H-ZSNS J105218.92+570729.6',0.711,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75404,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 2001ix',NULL,75404,43.25,0.25,2610,28687,70,NULL,'SALT','H-ZSNS J105218.92+570729.6',0.711,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75405,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 2001ix',NULL,75405,43.45,0.23,2860,28687,65,NULL,'SALT','H-ZSNS J105218.92+570729.6',0.711,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75406,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75406,37.59,0.46,330,28688,70,NULL,NULL,'SDSS J105219.06+441701.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000135,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,163.0794583,44.28367,0,NULL,63908863136,998575986,15602749,18.6),(75407,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75407,36.7,0.74,219,28689,70,NULL,NULL,'LCRS B104948.9-063602',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'15.59',0.27,NULL,NULL,NULL,NULL,NULL,1,163.0849583,-6.86639,0.049,NULL,41780461663,652819713,10200308,15.59),(75408,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75408,37.68,0.11,344,28690,70,NULL,NULL,'2MASX J10522139+5520378',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000199,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,163.089167,55.344,0,NULL,61971562650,968305666,15129776,16.9),(75409,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75409,37.48,0.46,313,28691,70,NULL,NULL,'2MASX J10522278+1821118',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,163.094875,18.35331,0.045,NULL,61158881421,955607522,14931367,18),(75410,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75410,37.37,0.46,298,28692,70,NULL,NULL,'2MASX J10522308+1754438',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,163.096167,17.91208,0.057,NULL,61189017505,956078398,14938724,17.5),(75411,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75411,37.92,0.46,383,28693,70,NULL,NULL,'2MASX J10522316+3659295',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,163.0964583,36.99175,0,NULL,64109901151,1001717205,15651831,17.5),(75412,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 2001iy','R',75412,41.43,NULL,1230,28694,65,NULL,'SALT','H-ZSNS J105224.28+571636.1',0.568,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,163.101166667,57.27669,0,NULL,62006211863,968847060,15138235,NULL),(75413,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 2001iy',NULL,75413,42,0.3,1600,28694,74.2,NULL,'SALT 2','H-ZSNS J105224.28+571636.1',0.568,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75414,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 2001iy',NULL,75414,42.21,0.23,1760,28694,72,NULL,'MLCS','H-ZSNS J105224.28+571636.1',0.568,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75415,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 2001iy',NULL,75415,42.23,0.21,1780,28694,72,NULL,'dm15','H-ZSNS J105224.28+571636.1',0.568,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75416,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 2001iy',NULL,75416,42.35,0.17,1880,28694,72,NULL,'BATM','H-ZSNS J105224.28+571636.1',0.568,'2004ApJ...602..571B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75417,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 2001iy',NULL,75417,42.56,0.29,2070,28694,70,NULL,'SALT','H-ZSNS J105224.28+571636.1',0.568,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75418,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 2001iy',NULL,75418,42.77,0.27,2290,28694,65,NULL,'SALT','H-ZSNS J105224.28+571636.1',0.568,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75419,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 2001iy',NULL,75419,42.88,0.31,2400,28694,65,NULL,NULL,'H-ZSNS J105224.28+571636.1',0.568,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75420,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75420,37.2,0.46,275,28695,70,NULL,NULL,'SDSS J105224.44+474349.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00014,NULL,'17.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,163.101875,47.73042,0,NULL,63919529918,998742654,15605353,17.8),(75421,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75421,36.81,0.46,230,28696,70,NULL,NULL,'2MASX J10522491+0933005',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.45',0.19,NULL,NULL,NULL,NULL,NULL,1,163.103875,9.55017,0.037,NULL,61024370979,953505796,14898528,17.45),(75422,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75422,37.68,0.11,344,28697,70,NULL,NULL,'2MASX J10522572+5521499',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00019,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,163.107375,55.36375,0,NULL,61971448437,968303881,15129748,17.8),(75423,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75423,37.86,0.46,373,28698,70,NULL,NULL,'SDSS J105225.98+182957.9',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,163.10825,18.49942,0.049,NULL,61160922705,955639417,14931865,NULL),(75424,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75424,37.13,0.46,267,28699,70,NULL,NULL,'CGCG 241-024',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000231,NULL,'15.4g',0.52,'E0',NULL,NULL,NULL,NULL,1,163.1087917,48.51944,0,NULL,63919819288,998747176,15605424,15.4),(75425,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75425,37.12,0.46,265,28700,70,NULL,NULL,'2MASX J10522765+2154508',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.04',0.17,NULL,NULL,NULL,NULL,NULL,1,163.1152083,21.91408,0,NULL,60982415622,952850244,14888285,18.04),(75426,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75426,38.41,0.46,482,28701,70,NULL,NULL,'2MASX J10522787+2116338',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,163.116083,21.27589,0,NULL,60982950583,952858602,14888415,17.9),(75427,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75427,38.19,0.27,434,28702,70,NULL,NULL,'2MASX J10522860+3945305',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000176,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,163.119167,39.75842,0,NULL,64112189636,1001752963,15652390,17.4),(75428,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75428,36.27,0.33,179,28703,70,NULL,NULL,'2MASX J10522969+1733498',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.36',0.21,NULL,NULL,NULL,NULL,NULL,1,163.12375,17.56375,0.049,NULL,61189538023,956086531,14938852,17.36),(75429,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75429,38.32,0.46,461,28704,70,NULL,NULL,'SDSS J105230.79+195757.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.88',0.13,NULL,NULL,NULL,NULL,NULL,1,163.128333,19.96586,0.025,NULL,61159676530,955619945,14931561,18.88),(75430,'IRAS','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75430,30.27,0.8,11.3,28705,75,NULL,'A82, H','NGC 3432',NULL,'1997ApJS..109..333W',1997,1,6.8,NULL,'G',0.000013,NULL,'10.5B',1.5,'SB(s)m;LINER   HII','Possible field galaxy',NULL,NULL,NULL,1,163.1297083,36.61878,0,NULL,64109355103,1001708673,15651698,10.5),(75431,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75431,29.45,0.4,7.8,28705,75,NULL,'B','NGC 3432',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75432,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75432,29.82,NULL,9.2,28705,NULL,NULL,NULL,'NGC 3432',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75433,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75433,30.52,0.4,12.7,28705,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 3432',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75434,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75434,30.79,0.47,14.4,28705,75,NULL,'A82, H, inv','NGC 3432',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75435,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75435,30.82,0.47,14.6,28705,75,NULL,'A82, H, raw','NGC 3432',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75436,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75436,31.12,0.47,16.8,28705,75,NULL,'A82, H, cor','NGC 3432',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75437,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75437,31.59,0.49,20.8,28705,75,NULL,'IR','NGC 3432',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75438,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75438,34.83,0.46,92.6,28706,70,NULL,NULL,'2MASX J10523127-0755368',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00014,NULL,'14.90',NULL,NULL,NULL,NULL,NULL,NULL,1,163.130375,-7.92708,0.025,NULL,41781178443,652830913,10200483,14.9),(75439,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75439,36.68,0.33,217,28707,70,NULL,NULL,'2MASX J10523145+0845005',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.01',0.27,NULL,NULL,NULL,NULL,NULL,1,163.131125,8.75019,0.017,NULL,61029355066,953583672,14899744,17.01),(75440,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75440,37.4,0.46,302,28708,70,NULL,NULL,'2MASX J10523177+1414248',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,163.1325417,14.24022,0.061,NULL,61194038624,956156853,14939950,17.9),(75441,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75441,31.03,NULL,16.1,28709,NULL,NULL,NULL,'UGC 05989',NULL,'2015AstBu..70....1K',2015,1,1.5,NULL,'G',0.000013,NULL,'14.33',0.5,'Im?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,163.1329583,19.79219,0.053,NULL,61159589632,955618588,14931540,14.33),(75442,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75442,34.52,NULL,80.3,28710,NULL,NULL,'Dipole','UGC 05994',NULL,'2010Ap&SS.325..163P',2010,1,1.85,NULL,'G',0.000007,NULL,'15.75',0.22,'Sbc',NULL,NULL,NULL,NULL,1,163.13925,10.01908,0.049,NULL,61024446003,953506968,14898546,15.75),(75443,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75443,34.53,NULL,80.5,28710,NULL,NULL,'Dipole + Quadrupole','UGC 05994',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75444,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75444,34.53,NULL,80.7,28710,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 05994',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75445,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75445,34.73,NULL,88.4,28710,NULL,NULL,NULL,'UGC 05994',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75446,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75446,35.22,0.2,111,28710,74.4,NULL,NULL,'UGC 05994',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75447,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75447,35.3,0.44,115,28710,NULL,NULL,NULL,'UGC 05994',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75448,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75448,35.36,0.43,118,28710,NULL,NULL,'Malmquist cor.','UGC 05994',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75449,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75449,37.96,0.46,391,28711,70,NULL,NULL,'2MASX J10523363+4524175',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000167,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,163.1399583,45.40481,0,NULL,63909270740,998582355,15602849,17),(75450,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75450,37.14,0.46,268,28712,70,NULL,NULL,'2MASX J10523421+0316462',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000177,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,163.142583,3.27936,0.133,NULL,60319551753,942492996,14726453,16.8),(75451,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75451,37.83,0.46,368,28713,70,NULL,NULL,'2MASX J10523528+1659528',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000196,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,163.147,16.99792,0.017,NULL,61189336519,956083383,14938802,16.7),(75452,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75452,37.98,0.46,395,28714,70,NULL,NULL,'SDSS J105235.48+571730.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000162,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,163.147917,57.29172,0,NULL,62006212328,968847067,15138235,18.6),(75453,'IRAS','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75453,31.87,0.8,23.7,28715,75,NULL,'CF, r','NGC 3437',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000013,NULL,'11.6B',0.8,'SAB(rs)c:      HII','Isolated galaxy',NULL,NULL,NULL,1,163.1489583,22.93414,0,NULL,60984102804,952876606,14888696,11.6),(75454,'Sosies','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75454,32.52,0.12,31.9,28715,NULL,NULL,NULL,'NGC 3437',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75455,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75455,31.54,0.43,20.3,28715,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3437',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75456,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75456,31.68,0.38,21.6,28715,75,NULL,'CF, r, raw','NGC 3437',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75457,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75457,31.73,0.38,22.2,28715,75,NULL,'CF, r, inv','NGC 3437',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75458,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75458,31.74,0.43,22.2,28715,75,NULL,'3.6 micron, color corrected','NGC 3437',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75459,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75459,31.81,0.38,23.1,28715,75,NULL,'CF, r, cor','NGC 3437',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75460,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75460,31.82,0.36,23.2,28715,NULL,NULL,'Malmquist cor.','NGC 3437',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75461,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75461,31.85,0.4,23.4,28715,75,NULL,'B','NGC 3437',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75462,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75462,31.91,0.47,24.1,28715,NULL,NULL,'H','NGC 3437',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75463,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75463,31.93,0.46,24.3,28715,NULL,NULL,'J','NGC 3437',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75464,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75464,31.93,0.45,24.3,28715,NULL,NULL,'K','NGC 3437',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75465,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75465,32,0.2,25.1,28715,74.4,NULL,NULL,'NGC 3437',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75466,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75466,32.07,0.4,26,28715,NULL,NULL,'mean','NGC 3437',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75467,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75467,32.08,0.37,26.1,28715,NULL,NULL,NULL,'NGC 3437',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75468,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75468,32.26,0.3,28.3,28715,NULL,NULL,NULL,'NGC 3437',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75469,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75469,38.08,0.46,413,28716,70,NULL,NULL,'2MASX J10523600+0929205',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,163.1499583,9.48894,0.037,NULL,61032171651,953627682,14900432,17.5),(75470,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75470,33.54,NULL,51.2,28717,NULL,NULL,NULL,'FGC 1146',NULL,'2000BSAO...50....5K',2000,1,0.64,NULL,'G',0.000119,NULL,'17.6g',0.12,'Sc',NULL,NULL,NULL,NULL,1,163.149833,39.80383,0,NULL,64112223796,1001753496,15652398,17.6),(75471,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75471,37.91,0.33,381,28718,70,NULL,NULL,'SDSS J105236.73+104755.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000152,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,163.153041667,10.79869,0.013,NULL,61027121051,953548766,14899199,18.5),(75472,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75472,37.32,0.46,291,28719,70,NULL,NULL,'2MASX J10523680+0910365',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.36',0.14,NULL,NULL,NULL,NULL,NULL,1,163.153333,9.17672,0.033,NULL,61032186220,953627909,14900436,18.36),(75473,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75473,38.04,0.46,406,28720,70,NULL,NULL,'2MASX J10523745+1725268',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,163.156125,17.42408,0.049,NULL,61189611305,956087676,14938869,NULL),(75474,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75474,33.96,0.53,62,28721,70,NULL,NULL,'ESO 264- G 047',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000093,NULL,'14.85',0.8,'(R_1R\'_2)SAB(rl)a',NULL,NULL,NULL,NULL,1,163.156875,-45.16272,0.577,NULL,41918698863,654979669,10234057,14.85),(75475,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75475,37.53,0.46,321,28722,70,NULL,NULL,'2MASX J10523816+2213498',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.99',0.17,NULL,NULL,NULL,NULL,NULL,1,163.159125,22.23056,0,NULL,60984386783,952881043,14888766,17.99),(75476,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75476,32.06,0.4,25.8,28723,75,NULL,NULL,'UGC 05990',NULL,'2008Ap.....51..336K',2008,1,1.49,NULL,'G',0.000033,NULL,'14.8g',0.35,'Sab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,163.15975,34.48314,0,NULL,64042142610,1000658478,15635288,14.8),(75477,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75477,32.83,0.49,36.8,28723,75,NULL,'IR','UGC 05990',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75478,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75478,37.65,0.27,340,28724,70,NULL,NULL,'SDSS J105238.33+050648.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,163.15975,5.11356,0.089,NULL,60319233002,942488015,14726375,18),(75479,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75479,37.07,0.46,259,28725,70,NULL,NULL,'2MASX J10523866+1949138',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.24',0.16,NULL,NULL,NULL,NULL,NULL,1,163.1610417,19.82044,0.053,NULL,61159588488,955618570,14931540,18.24),(75480,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75480,36.68,0.33,217,28726,70,NULL,NULL,'2MASX J10523894+0840325',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.92',0.21,NULL,NULL,NULL,NULL,NULL,1,163.162375,8.67556,0.025,NULL,61030075494,953594929,14899920,17.92),(75481,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75481,38.19,0.27,434,28727,70,NULL,NULL,'2MASX J10523940+3940118',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000129,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,163.164125,39.67006,0,NULL,64120526177,1001883221,15654425,18.4),(75482,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75482,38.19,0.27,434,28728,70,NULL,NULL,'2MASX J10523999+3945368',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000202,NULL,'16.7g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,163.1664583,39.76014,0,NULL,64112193284,1001753020,15652390,16.7),(75483,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75483,37.88,0.46,376,28729,70,NULL,NULL,'SDSS J105240.22+063250.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00014,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,163.167583,6.54747,0.129,NULL,61028107812,953564184,14899440,18.5),(75484,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75484,31.57,0.4,20.6,28730,75,NULL,'B','UGC 05979',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000007,NULL,'15.1',1,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,163.1715,67.98856,0.021,NULL,62131882157,970810658,15168916,15.1),(75485,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75485,37.88,0.33,377,28731,70,NULL,NULL,'LCSB S1471N',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000185,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,163.1790417,31.34486,0.045,NULL,60515214633,945550228,14774222,16.9),(75486,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75486,35.72,0.64,139,28732,70,NULL,NULL,'2MASX J10524467-0745508',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.00015,NULL,'15.28',0.34,NULL,NULL,NULL,NULL,NULL,1,163.1860417,-7.76414,0.025,NULL,41783262470,652863476,10200991,15.28),(75487,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75487,37.5,0.46,316,28733,70,NULL,NULL,'SDSS J105245.25+372647.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,163.188583,37.44644,0,NULL,64109798623,1001715603,15651806,18.4),(75488,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75488,38.84,0.46,587,28734,70,NULL,NULL,'SDSS J105246.34+575831.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00014,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,163.193125,57.97528,0,NULL,62004911989,968826749,15137917,18.3),(75489,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75489,37.51,0.46,318,28735,70,NULL,NULL,'2MASX J10524705+1236078',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,163.1959583,12.60214,0.009,NULL,61145257946,955394655,14928041,17.4),(75490,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75490,34.75,0.46,89.3,28736,70,NULL,NULL,'UGC 05991',NULL,'2015arXiv151105856S',2015,1,1.15,NULL,'G',0.0001,NULL,'14.4g',0.71,'S0-',NULL,NULL,NULL,NULL,1,163.1984583,49.61258,0,NULL,63907588727,998556073,15602438,14.4),(75491,'IRAS','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75491,32.82,0.8,36.6,28737,75,NULL,'MAT, I','ESO 264- G 048',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000013,NULL,'14.41',0.6,'SAB(s)bc',NULL,NULL,NULL,NULL,1,163.200167,-45.67744,0.653,NULL,41921731591,655027056,10234797,14.41),(75492,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75492,32.94,0.32,38.8,28737,85,NULL,'I, raw','ESO 264- G 048',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75493,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75493,32.97,0.32,39.2,28737,85,NULL,'I, inv','ESO 264- G 048',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75494,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75494,33.04,0.43,40.5,28737,75,NULL,'MAT, I, raw','ESO 264- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75495,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75495,33.16,0.43,42.9,28737,75,NULL,'MAT, I, inv','ESO 264- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75496,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75496,33.18,0.4,43.2,28737,NULL,NULL,'mean','ESO 264- G 048',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75497,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75497,33.26,0.43,44.8,28737,75,NULL,'MAT, I, cor','ESO 264- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75498,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75498,33.38,0.61,47.4,28737,NULL,NULL,'Malmquist cor.','ESO 264- G 048',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75499,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75499,33.39,0.6,47.7,28737,NULL,NULL,NULL,'ESO 264- G 048',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75500,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75500,33.43,0.2,48.5,28737,74.4,NULL,NULL,'ESO 264- G 048',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75501,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75501,33.73,0.47,55.8,28737,NULL,NULL,'H','ESO 264- G 048',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75502,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75502,37.91,0.33,381,28738,70,NULL,NULL,'2MASX J10524824+1041314',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00019,NULL,'16.2g',0.36,'BrClG',NULL,NULL,NULL,NULL,1,163.201,10.69211,0.009,NULL,61027073573,953548024,14899187,16.2),(75503,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75503,37.91,0.46,382,28739,70,NULL,NULL,'SDSS J105248.25+051206.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,163.2010417,5.20172,0.089,NULL,60319253335,942488333,14726380,18.4),(75504,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75504,39.56,0.46,818,28740,70,NULL,NULL,'SDSS J105248.39+473356.9',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00013,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,163.20175,47.56581,0,NULL,63919541066,998742829,15605356,17.8),(75505,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75505,31.59,NULL,20.8,28741,NULL,NULL,NULL,'CGCG 010-041',NULL,'2015AstBu..70....1K',2015,1,0.52,NULL,'G',0.000009,NULL,'15.5g',0.34,'BlueCG?;WR?    HII',NULL,NULL,NULL,NULL,1,163.202667,0.03447,0.093,NULL,60288926993,942014484,14718976,15.5),(75506,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75506,37.88,0.33,377,28742,70,NULL,NULL,'2MASX J10524918+3124398',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,163.205125,31.411,0.045,NULL,60515207634,945550119,14774220,17.4),(75507,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75507,38.03,0.46,404,28743,70,NULL,NULL,'SDSS J105251.69+102517.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.4g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,163.215417,10.42156,0.021,NULL,61026270121,953535470,14898991,18.4),(75508,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75508,38.31,0.46,458,28744,70,NULL,NULL,'SDSS J105251.90+103309.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,163.2162917,10.55261,0.021,NULL,61026945066,953546016,14899156,18.1),(75509,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75509,36.32,0.46,184,28745,70,NULL,NULL,'2MASX J10525283+0153132',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000185,NULL,'15.7g',0.5,'E0',NULL,NULL,NULL,NULL,1,163.220083,1.88686,0.093,NULL,60325087441,942579491,14727804,15.7),(75510,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75510,37.11,0.73,264,28746,70,NULL,NULL,'2MASX J10525284-4506085',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,163.22025,-45.10231,0.577,NULL,41918703688,654979745,10234058,17.1),(75511,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75511,37.68,0.46,344,28747,70,NULL,NULL,'2MASX J10525300+2600366',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000179,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,163.220667,26.01017,0.007,NULL,60494898622,945232790,14769262,17.3),(75512,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75512,38.34,0.46,466,28748,70,NULL,NULL,'SDSS J105253.10+380123.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000136,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,163.2212917,38.02306,0,NULL,64107145483,1001674148,15651158,18.7),(75513,'IRAS','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75513,33.2,0.8,43.7,28749,75,NULL,'MAT, I','NGC 3449',NULL,'1997ApJS..109..333W',1997,1,3.3,NULL,'G',0.00002,NULL,'12.19',1,'SA(s)ab:','in a triple',NULL,NULL,NULL,1,163.223583,-32.92761,0.253,NULL,41492842166,648325658,10130088,12.19),(75514,'IRAS','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75514,33.23,0.8,44.2,28749,75,NULL,'HMCL, I','NGC 3449',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75515,'Sosies','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75515,33.35,0.15,46.8,28749,NULL,NULL,NULL,'NGC 3449',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75516,'Tully est','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75516,33.18,0.8,43.2,28749,75,NULL,'B','NGC 3449',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75517,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75517,32.71,0.3,34.8,28749,92,NULL,'H, Assuming Hydra cluster m-M = 33.2 mag','NGC 3449',NULL,'1993AJ....105...97S',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75518,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75518,32.98,0.43,39.4,28749,75,NULL,'MAT, I, raw','NGC 3449',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75519,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75519,33.1,0.3,41.7,28749,92,NULL,'I, Assuming Hydra cluster m-M = 33.2 mag','NGC 3449',NULL,'1993AJ....105...97S',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75520,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75520,33.18,0.38,43.3,28749,NULL,NULL,NULL,'NGC 3449',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75521,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75521,33.2,0.32,43.6,28749,85,NULL,'I, raw','NGC 3449',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75522,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75522,33.26,0.43,44.9,28749,75,NULL,'MAT, I, cor','NGC 3449',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75523,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75523,33.28,0.32,45.3,28749,85,NULL,'I, inv','NGC 3449',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75524,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75524,33.3,0.43,45.6,28749,75,NULL,'MAT, I, inv','NGC 3449',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75525,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75525,33.35,0.4,46.8,28749,75,NULL,'HMCL, I, raw','NGC 3449',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75526,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75526,33.48,0.2,49.7,28749,74.4,NULL,NULL,'NGC 3449',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75527,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75527,33.53,0.4,50.9,28749,75,NULL,'HMCL, I, cor','NGC 3449',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75528,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75528,33.54,0.43,51,28749,75,NULL,'3.6 micron, color corrected','NGC 3449',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75529,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75529,33.62,0.4,52.9,28749,75,NULL,'HMCL, I, inv','NGC 3449',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75530,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75530,33.73,0.43,55.7,28749,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3449',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75531,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75531,33.77,0.08,56.9,28749,NULL,NULL,NULL,'NGC 3449',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75532,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75532,37.31,0.46,290,28750,70,NULL,NULL,'2MASX J10525433-0046213',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00007,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,163.2264583,-0.77261,0.089,NULL,40924754213,639449284,9991395,17.8),(75533,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75533,38.41,0.46,482,28751,70,NULL,NULL,'2MASX J10525481+2807126',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,163.228333,28.12022,0,NULL,60518223592,945597243,14774956,18.1),(75534,'Brightest Stars','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75534,28.03,NULL,4,28752,NULL,NULL,'3B','KDG 073',NULL,'1993A&A...275...39T',1993,1,0.6,NULL,'G',0.000002,NULL,'14.9',0.4,'Im','Brightest group member',NULL,NULL,NULL,1,163.2377917,69.54939,0.049,NULL,62081089039,970017016,15156515,14.9),(75535,'CMD','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75535,27.9,NULL,3.8,28752,NULL,NULL,NULL,'KDG 073',NULL,'2012ApJ...748...47M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75536,'TRGB','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75536,27.84,NULL,3.7,28752,NULL,NULL,NULL,'KDG 073',NULL,'2003A&A...398..479K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75537,'TRGB','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75537,27.91,0.13,3.82,28752,NULL,NULL,NULL,'KDG 073',NULL,'2002A&A...383..125K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75538,'TRGB','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75538,27.98,0.08,3.95,28752,74.4,NULL,NULL,'KDG 073',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75539,'TRGB','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75539,28.03,0.04,4.03,28752,NULL,NULL,'I','KDG 073',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75540,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75540,36.27,0.27,179,28753,70,NULL,NULL,'2MASX J10525783+0419542',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'16.64',0.32,NULL,NULL,NULL,NULL,NULL,1,163.240917,4.33158,0.117,NULL,60321972885,942530826,14727044,16.64),(75541,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75541,35.33,NULL,116,28754,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 3444',NULL,'2010Ap&SS.325..163P',2010,1,1.53,NULL,'G',0.000009,NULL,'15.46',0.17,'Sbc','Possible group member',NULL,NULL,NULL,1,163.247417,10.21058,0.037,NULL,61024353390,953505521,14898523,15.46),(75542,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75542,35.34,NULL,117,28754,NULL,NULL,'Dipole + Quadrupole','NGC 3444',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75543,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75543,35.35,NULL,117,28754,NULL,NULL,'Dipole','NGC 3444',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75544,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75544,35.38,NULL,119,28754,NULL,NULL,NULL,'NGC 3444',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75545,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75545,35.44,0.49,123,28754,75,NULL,'IR','NGC 3444',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75546,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75546,35.74,0.34,141,28754,NULL,NULL,'Malmquist cor.','NGC 3444',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75547,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75547,35.92,0.2,153,28754,74.4,NULL,NULL,'NGC 3444',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75548,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75548,35.99,0.3,158,28754,NULL,NULL,NULL,'NGC 3444',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75549,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75549,37.45,0.46,309,28755,70,NULL,NULL,'2MASX J10530007+0208162',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000213,NULL,'16.6g',0.33,'AGN',NULL,NULL,NULL,NULL,1,163.250167,2.13775,0.089,NULL,60325010202,942578284,14727785,16.6),(75550,'IRAS','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75550,31.49,0.8,19.9,28756,75,NULL,'A82, H','NGC 3443',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.000033,NULL,'13.7',1.4,'SAd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,163.2505,17.57364,0.049,NULL,61189544763,956086636,14938853,13.7),(75551,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75551,31.43,0.4,19.3,28756,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 3443',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75552,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75552,31.62,0.4,21.1,28756,75,NULL,'B','NGC 3443',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75553,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75553,31.8,0.47,22.9,28756,75,NULL,'A82, H, inv','NGC 3443',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75554,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75554,31.93,0.47,24.4,28756,75,NULL,'A82, H, raw','NGC 3443',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75555,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75555,32.02,0.2,25.4,28756,74.4,NULL,NULL,'NGC 3443',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75556,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75556,32.09,0.47,26.1,28756,75,NULL,'A82, H, cor','NGC 3443',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75557,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75557,32.1,0.43,26.3,28756,75,NULL,'3.6 micron, color corrected','NGC 3443',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75558,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75558,32.15,0.43,26.9,28756,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3443',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75559,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75559,36.49,0.7,198,28757,70,NULL,NULL,'2MASX J10530162-0733283',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.00015,NULL,'15.90',0.33,NULL,NULL,NULL,NULL,NULL,1,163.256833333,-7.55783,0.013,NULL,41783343852,652864747,10201011,15.9),(75560,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75560,37.05,0.46,256,28758,70,NULL,NULL,'2MASX J10530242+1816038',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.78',0.14,NULL,NULL,NULL,NULL,NULL,1,163.260125,18.26764,0.033,NULL,61158931736,955608308,14931379,18.78),(75561,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75561,37.51,0.46,318,28759,70,NULL,NULL,'2MASX J10530262+0943217',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.12',0.18,NULL,NULL,NULL,NULL,NULL,1,163.260875,9.72256,0.049,NULL,61024396184,953506190,14898534,18.12),(75562,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75562,38.73,0.46,557,28760,70,NULL,NULL,'SDSS J105304.10+052051.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000168,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,163.267125,5.34758,0.077,NULL,60319284285,942488816,14726387,18.3),(75563,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75563,36.27,0.27,179,28761,70,NULL,NULL,'2MASX J10530451+0429362',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000196,NULL,'15.7g',0.45,'E0',NULL,NULL,NULL,NULL,1,163.268667,4.49331,0.117,NULL,60322193623,942534275,14727098,15.7),(75564,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75564,36.04,0.33,161,28762,70,NULL,NULL,'2MASX J10530505+3250129',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000182,NULL,'15.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,163.27125,32.83703,0.006,NULL,60500162052,945315032,14770547,15.6),(75565,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75565,37.81,0.46,365,28763,70,NULL,NULL,'SDSS J105305.49+194306.6',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,163.272917,19.71853,0.021,NULL,61160085880,955626341,14931661,17.2),(75566,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75566,37.77,0.46,359,28764,70,NULL,NULL,'2MASXi J1053055+294744',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,163.2730417,29.79572,0.016,NULL,60509198518,945456226,14772753,17.8),(75567,'D-Sigma','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75567,32.64,0.4,33.7,28765,75,NULL,'Edat, raw','ESO 318- G 021',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000103,NULL,'13.62',1,'E?',NULL,NULL,NULL,NULL,1,163.274833,-40.32906,0.389,NULL,42121133120,658142705,10283479,13.62),(75568,'D-Sigma','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75568,32.97,0.4,39.3,28765,75,NULL,'Edat, cor','ESO 318- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75569,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75569,34.03,0.46,63.9,28765,70,NULL,NULL,'ESO 318- G 021',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75570,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75570,37.42,0.46,304,28766,70,NULL,NULL,'2MASX J10530614+3731347',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000159,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,163.275583,37.52614,0,NULL,64109745302,1001714770,15651793,17.2),(75571,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75571,37.36,0.27,297,28767,70,NULL,NULL,'2MASX J10530797+5619537',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000188,NULL,'16.3g',0.41,NULL,NULL,NULL,NULL,NULL,1,163.283083333,56.33169,0,NULL,62001257240,968769644,15137025,16.3),(75572,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','PS1 SN PS11zg','N',75572,41.47,0.27,1430,28768,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11zg HOST',0.3705,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75573,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75573,36.66,0.46,215,28769,70,NULL,NULL,'2MASX J10530808+3745146',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000169,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,163.283625,37.75414,0,NULL,64109020723,1001703448,15651616,16.2),(75574,'Tully est','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75574,32.3,0.8,28.8,28770,75,NULL,'B','NGC 3442',NULL,'1988NBGC.C....0000T',1988,1,0.73,NULL,'G',0.000017,NULL,'13.6g',0.65,'Sa?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,163.283791667,33.91036,0,NULL,64041007617,1000640744,15635011,13.6),(75575,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75575,32.42,0.4,30.4,28770,NULL,NULL,'mean','NGC 3442',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75576,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75576,32.69,0.47,34.5,28770,NULL,NULL,'H','NGC 3442',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75577,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75577,32.76,0.46,35.6,28770,NULL,NULL,'J','NGC 3442',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75578,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75578,36.95,0.46,245,28771,70,NULL,NULL,'2MASX J10530827+1520540',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000179,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,163.284583333,15.34833,0.037,NULL,61202758853,956293107,14942079,16.8),(75579,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75579,38.46,0.46,492,28772,70,NULL,NULL,'SDSS J105308.30+165127.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000168,NULL,'18.7g',0.09,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,163.284625,16.85761,0.021,NULL,61189228376,956081693,14938776,18.7),(75580,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75580,36.42,0.46,192,28773,70,NULL,NULL,'2MASX J10530920+2301189',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.48',0.22,NULL,NULL,NULL,NULL,NULL,1,163.2885,23.02189,0,NULL,60983974777,952874605,14888665,16.48),(75581,'Tully est','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75581,31.79,0.8,22.8,28774,75,NULL,'B','UGC 05998',NULL,'1988NBGC.C....0000T',1988,1,NULL,NULL,'GPair',0.000033,NULL,NULL,NULL,'Pec?',NULL,NULL,NULL,NULL,1,163.290833,50.28278,0,NULL,63907306395,998551662,15602369,NULL),(75582,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75582,33.54,0.2,51.1,28775,74.4,NULL,NULL,'MCG -01-28-004',NULL,'2013AJ....146...86T',2013,1,1.3,'MCG decs for MCG -01-28 field are 10 arcmin too far north (MCG4 errata).','G',0.000029,NULL,'14.55',0.9,'SA(rs)c:',NULL,NULL,NULL,NULL,1,163.3022083,-7.42867,0.033,NULL,41783301254,652864082,10201001,14.55),(75583,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75583,33.7,0.36,54.8,28775,NULL,NULL,NULL,'MCG -01-28-004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75584,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75584,33.99,0.32,62.7,28775,NULL,NULL,'Malmquist cor.','MCG -01-28-004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75585,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75585,37.5,0.46,316,28776,70,NULL,NULL,'2MASX J10531252+2608246',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000154,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,163.302125,26.14019,0,NULL,60494893226,945232706,14769261,18.2),(75586,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75586,34.29,0.46,72,28777,70,NULL,NULL,'ARK 265',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.00016,NULL,'14.5g',0.7,NULL,NULL,NULL,NULL,NULL,1,163.304666667,16.23503,0.037,NULL,61202387687,956287307,14941989,14.5),(75587,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75587,36.27,0.27,179,28778,70,NULL,NULL,'2MASX J10531528+0420032',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.0001,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,163.3137083,4.33422,0.121,NULL,60322057880,942532154,14727064,16.4),(75588,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75588,38.88,0.46,596,28779,70,NULL,NULL,'SDSS J105315.95+542007.2',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,163.3165,54.33536,0,NULL,61973772477,968340194,15130315,17.8),(75589,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75589,37.68,0.11,344,28780,70,NULL,NULL,'2MASX J10531604+5509258',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000179,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,163.3169583,55.15717,0,NULL,61971625551,968306649,15129791,17.3),(75590,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75590,38.03,0.33,404,28781,70,NULL,NULL,'2MASX J10531693+5337206',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000119,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,163.320833,53.62247,0,NULL,61959434569,968116165,15126815,18.1),(75591,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75591,38.03,0.33,404,28782,70,NULL,NULL,'2MASX J10531704+5337116',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000127,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,163.32125,53.61986,0,NULL,61959438010,968116218,15126815,18.2),(75592,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75592,36.04,0.33,161,28783,70,NULL,NULL,'2MASX J10531734+3150359',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00018,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,163.322125,31.84331,0.082,NULL,60514455176,945538362,14774036,16.8),(75593,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75593,37.92,0.46,383,28784,70,NULL,NULL,'SDSS J105318.43+043601.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,163.3267917,4.60033,0.117,NULL,60322182119,942534095,14727095,18.1),(75594,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75594,31.35,NULL,18.6,28785,NULL,NULL,NULL,'LSBC L1-137',NULL,'2015AstBu..70....1K',2015,1,0.71,NULL,'G',0.000006,NULL,'15.9g',0.37,'dIn',NULL,NULL,NULL,NULL,1,163.327667,2.62603,0.085,NULL,60324780684,942574698,14727729,15.9),(75595,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75595,37.68,0.11,344,28786,70,NULL,NULL,'2MASX J10531874+5448278',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000167,NULL,'17.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,163.32825,54.80781,0,NULL,61974291430,968348303,15130442,17.9),(75596,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75596,38.31,0.46,458,28787,70,NULL,NULL,'SDSS J105321.02+162848.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000135,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,163.337625,16.48028,0.021,NULL,61200631690,956259870,14941560,18.5),(75597,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75597,36.27,0.33,179,28788,70,NULL,NULL,'2MASX J10532135+1742485',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.68',0.19,NULL,NULL,NULL,NULL,NULL,1,163.3390417,17.71369,0.053,NULL,61189581890,956087217,14938862,16.68),(75598,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75598,36.02,0.46,160,28789,70,NULL,NULL,'CGCG 066-056',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.00018,NULL,'15.2g',0.55,'S0',NULL,NULL,NULL,NULL,1,163.343167,11.18067,0.025,NULL,61026539173,953539674,14899057,15.2),(75599,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75599,36.04,0.33,161,28790,70,NULL,NULL,'CGCG 155-033',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000063,NULL,'14.9g',0.62,NULL,NULL,NULL,NULL,NULL,1,163.34325,31.82228,0.082,NULL,60514451709,945538307,14774036,14.9),(75600,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75600,36.53,0.46,203,28791,70,NULL,NULL,'2MASX J10532245+0550412',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000166,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,163.343583333,5.84469,0.117,NULL,60301619641,942212806,14722075,16.6),(75601,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75601,36.83,0.46,232,28792,70,NULL,NULL,'2MASX J10532291+2027404',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.98',0.17,NULL,NULL,NULL,NULL,NULL,1,163.3455,20.46133,0,NULL,61159349605,955614837,14931481,17.98),(75602,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75602,36.47,0.57,197,28793,70,NULL,NULL,'2MASX J10532363-4146265',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,163.348583,-41.77403,0.545,NULL,42119472691,658116760,10283074,15.7),(75603,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75603,36.93,0.46,243,28794,70,NULL,NULL,'2MASX J10532372+3140183',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000162,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,163.348791667,31.67167,0.058,NULL,60515364839,945552575,14774258,16.6),(75604,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75604,37.85,0.46,372,28795,70,NULL,NULL,'2MASX J10532391+1604385',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,163.3497083,16.07747,0.037,NULL,61202401921,956287530,14941992,17.7),(75605,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75605,36.84,0.46,234,28796,70,NULL,NULL,'2MASX J10532406+2558010',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00019,NULL,'17.52',0.24,NULL,NULL,NULL,NULL,NULL,1,163.350417,25.96689,0,NULL,60494963617,945233806,14769278,17.52),(75606,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75606,37.77,0.46,359,28797,70,NULL,NULL,'2MASX J10532511+1705035',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,163.35475,17.08422,0.017,NULL,61189253895,956082092,14938782,17.7),(75607,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75607,37.36,0.27,297,28798,70,NULL,NULL,'MCG +09-18-046',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000188,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,163.3552917,56.29325,0,NULL,62005446902,968835107,15138048,16.3),(75608,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75608,37.73,0.33,351,28799,70,NULL,NULL,'2MASX J10532558+1927454',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.82',0.12,NULL,NULL,NULL,NULL,NULL,1,163.3565,19.46256,0.025,NULL,61160367268,955630738,14931730,18.82),(75609,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75609,37.18,0.46,272,28800,70,NULL,NULL,'2MASX J10532599+5613028',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,163.358375,56.21769,0,NULL,61968744498,968261632,15129088,17.8),(75610,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75610,31.51,0.4,20.1,28801,75,NULL,'B','NGC 3447',NULL,'1988NBGC.C....0000T',1988,1,NULL,NULL,'GPair',NULL,NULL,NULL,NULL,'Mult','Pair member, contact system',NULL,NULL,NULL,1,163.361667,16.77889,0.021,NULL,61200554457,956258663,14941541,NULL),(75611,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75611,37.32,0.46,291,28802,70,NULL,NULL,'2MASX J10532680+0607560',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000182,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,163.361667,6.13225,0.109,NULL,60301688981,942213890,14722092,16.7),(75612,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75612,37.66,0.46,340,28803,70,NULL,NULL,'2MASX J10532864+2511210',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000198,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,163.3694583,25.18931,0,NULL,60496041992,945250656,14769541,16.7),(75613,'Tully est','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75613,31.47,0.8,19.7,28804,75,NULL,NULL,'NGC 3447b',NULL,'1988NBGC.C....0000T',1988,1,1.5,'Multiple SDSS entries describe this source.','G',0.000013,NULL,'14.3',0.8,'IB(s)m pec','Pair member (points to parent)',NULL,NULL,NULL,1,163.37425,16.78531,0.021,NULL,61200555298,956258676,14941541,14.3),(75614,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75614,37.72,0.46,350,28805,70,NULL,NULL,'2MASX J10533001+1218435',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,163.374917,12.31217,0.017,NULL,61144945998,955389781,14927965,17.3),(75615,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75615,34.41,0.46,76.3,28806,70,NULL,NULL,'CGCG 095-059',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000157,NULL,'14.9',0.6,NULL,NULL,NULL,NULL,NULL,1,163.3764583,18.93058,0.041,NULL,61160480204,955632503,14931757,14.9),(75616,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75616,37.19,0.46,274,28807,70,NULL,NULL,'2MASX J10533244+2121534',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,163.385291667,21.36497,0,NULL,60982231138,952847361,14888240,17.6),(75617,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75617,37.24,0.46,280,28808,70,NULL,NULL,'2MASX J10533326+0510391',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000146,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,163.3885417,5.17756,0.089,NULL,60319113864,942486154,14726346,17.2),(75618,'IRAS','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75618,33.33,0.8,46.3,28809,75,NULL,'MAT, I','ESO 437- G 069',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'15',0.5,'S...',NULL,NULL,NULL,NULL,1,163.3889583,-29.39389,0.221,NULL,41526136490,648845882,10138216,15),(75619,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75619,31.34,0.32,18.5,28809,85,NULL,'I, inv','ESO 437- G 069',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75620,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75620,31.35,0.32,18.6,28809,85,NULL,'I, raw','ESO 437- G 069',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75621,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75621,31.74,0.43,22.3,28809,75,NULL,'MAT, I, inv','ESO 437- G 069',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75622,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75622,31.76,0.43,22.5,28809,75,NULL,'MAT, I, raw','ESO 437- G 069',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75623,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75623,32.11,0.43,26.4,28809,75,NULL,'MAT, I, cor','ESO 437- G 069',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75624,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75624,37.73,0.33,351,28810,70,NULL,NULL,'2MASX J10533421+1922084',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.40',0.14,NULL,NULL,NULL,NULL,NULL,1,163.392625,19.36917,0.017,NULL,61160419871,955631560,14931743,18.4),(75625,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75625,37.68,0.11,344,28811,70,NULL,NULL,'2MASX J10533658+5452047',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000196,NULL,'16.2g',0.4,'BrClG',NULL,NULL,NULL,NULL,1,163.402375,54.86794,0,NULL,61974271147,968347986,15130437,16.2),(75626,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75626,36.04,0.33,161,28812,70,NULL,NULL,'IC 2612',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.00008,NULL,'15.3g',0.47,NULL,NULL,NULL,NULL,NULL,1,163.404833,32.76764,0.006,NULL,60500191355,945315489,14770554,15.3),(75627,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75627,34.72,0.49,88,28813,75,NULL,'IR','UGC 06012',NULL,'2011yCatp016004901K',2011,1,1.81,NULL,'G',0.000011,NULL,'15.3g',0.25,'Sc',NULL,NULL,NULL,NULL,1,163.4105417,26.90986,0,NULL,60487339387,945114677,14767416,15.3),(75628,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75628,34.97,0.4,98.5,28813,NULL,NULL,'mean','UGC 06012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75629,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75629,35.08,0.43,104,28813,NULL,NULL,'Malmquist cor.','UGC 06012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75630,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75630,35.1,0.2,105,28813,74.4,NULL,NULL,'UGC 06012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75631,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75631,35.14,0.42,107,28813,NULL,NULL,NULL,'UGC 06012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75632,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75632,35.24,0.47,112,28813,NULL,NULL,'H','UGC 06012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75633,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75633,35.29,NULL,114,28813,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75634,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75634,35.31,NULL,115,28813,NULL,NULL,'Dipole + Quadrupole','UGC 06012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75635,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75635,35.31,NULL,116,28813,NULL,NULL,'Dipole','UGC 06012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75636,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75636,35.33,NULL,116,28813,NULL,NULL,NULL,'UGC 06012',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75637,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75637,37.68,0.11,344,28814,70,NULL,NULL,'SDSS J105338.51+544400.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,163.4104583,54.73358,0,NULL,61974297755,968348402,15130443,18.3),(75638,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75638,37.36,0.27,297,28815,70,NULL,NULL,'2MASX J10533960+5621007',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000187,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,163.4152083,56.35025,0,NULL,62005455173,968835237,15138050,16.6),(75639,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75639,36.07,0.46,164,28816,70,NULL,NULL,'2MASX J10534003+1620335',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000166,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,163.416833,16.34267,0.029,NULL,61202394504,956287414,14941990,16.3),(75640,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75640,35.94,0.33,154,28817,70,NULL,NULL,'2MASX J10534050+3012284',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000168,NULL,'16.1g',0.43,NULL,NULL,NULL,NULL,NULL,1,163.418875,30.208,0.061,NULL,60510118000,945470593,14772978,16.1),(75641,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75641,37.94,0.46,388,28818,70,NULL,NULL,'2MASX J10534082+1156240',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000164,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,163.420083,11.94,0,NULL,61144885085,955388829,14927950,17.5),(75642,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75642,38.08,0.46,413,28819,70,NULL,NULL,'SDSS J105341.36+544405.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,163.422333,54.73494,0,NULL,61974297775,968348402,15130443,18.3),(75643,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75643,36.57,0.46,206,28820,70,NULL,NULL,'2MASX J10534185+1513175',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000123,NULL,'16.52',0.32,NULL,NULL,NULL,NULL,NULL,1,163.424333,15.22158,0.013,NULL,61202514047,956289281,14942020,16.52),(75644,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75644,31.15,NULL,17,28821,NULL,NULL,NULL,'UGC 06014',NULL,'2015AstBu..70....1K',2015,1,1.4,NULL,'G',0.00002,NULL,'14.40',0.8,'SABdm:',NULL,NULL,NULL,NULL,1,163.427875,9.72792,0.049,NULL,61031951881,953624248,14900378,14.4),(75645,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75645,37.24,0.46,280,28822,70,NULL,NULL,'2MASX J10534636+1521434',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,163.44325,15.36208,0.025,NULL,61202605848,956290716,14942042,17.6),(75646,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75646,37.75,0.46,354,28823,70,NULL,NULL,'2MASX J10534647+1957012',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.69',0.15,NULL,NULL,NULL,NULL,NULL,1,163.4437083,19.95044,0.06,NULL,61160290906,955629545,14931711,18.69),(75647,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75647,36.82,0.46,232,28824,70,NULL,NULL,'2MASX J10534734+0405541',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00018,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,163.447417,4.09833,0.133,NULL,60320146136,942502283,14726598,16.7),(75648,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75648,37.41,0.46,304,28825,70,NULL,NULL,'2MASX J10534767+3552194',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.29',0.19,NULL,NULL,NULL,NULL,NULL,1,163.448667,35.872,0.016,NULL,64106367175,1001661987,15650968,18.29),(75649,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75649,37.78,0.46,360,28826,70,NULL,NULL,'2MASX J10534773+4613497',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,163.448875,46.23044,0,NULL,63912723593,998636306,15603692,17.8),(75650,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75650,32.93,0.2,38.6,28827,74.4,NULL,NULL,'NGC 3440',NULL,'2013AJ....146...86T',2013,1,2.1,NULL,'G',0.00001,NULL,'14.02',0.5,'SBb? sp','in a radial-velocity based grouping',NULL,NULL,NULL,1,163.45625,57.11875,0,NULL,62006057571,968844649,15138197,14.02),(75651,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75651,32.97,0.43,39.3,28827,75,NULL,'3.6 micron, color corrected','NGC 3440',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75652,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75652,33.05,0.43,40.8,28827,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3440',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75653,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75653,33.16,0.53,42.8,28827,NULL,NULL,NULL,'NGC 3440',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75654,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75654,33.16,0.53,42.8,28827,NULL,NULL,'Malmquist cor.','NGC 3440',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75655,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75655,37.68,0.23,344,28828,70,NULL,NULL,'2MASX J10535011+1649382',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000155,NULL,'18.6g',0.08,NULL,NULL,NULL,NULL,NULL,1,163.458875,16.82731,0.021,NULL,61200584437,956259131,14941548,18.6),(75656,'BCG','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75656,37.65,0.35,313,28829,60,NULL,'ABELL 1126, BCG','2MASX J10535025+1651022',0.0828,'1980ApJ...241..486H',1980,1,0.92,NULL,'G',0.000157,NULL,'14.9g',0.65,'S;cD','Brightest group member',NULL,NULL,NULL,1,163.459333,16.85053,0.021,NULL,61200583898,956259123,14941548,14.9),(75657,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75657,35.65,0.51,135,28830,70,NULL,NULL,'IC 0654',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000117,NULL,'15.14',0.6,'(R\')SB0+?',NULL,NULL,NULL,NULL,1,163.4599583,-11.72558,0.061,NULL,41783922599,652873790,10201152,15.14),(75658,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75658,34.52,0.71,80.1,28831,NULL,NULL,'Malmquist cor.','ESO 318- G 022',NULL,'2009ApJS..182..474S',2009,1,1.6,NULL,'G',0.000033,NULL,'15.11',0.8,'Sb             HII',NULL,NULL,NULL,NULL,1,163.4667917,-38.21347,0.273,NULL,42113937030,658030266,10281722,15.11),(75659,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75659,34.83,0.61,92.7,28831,NULL,NULL,NULL,'ESO 318- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75660,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75660,34.88,0.2,94.6,28831,74.4,NULL,NULL,'ESO 318- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75661,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75661,37.57,0.46,327,28832,70,NULL,NULL,'2MASX J10535259+1721182',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,163.4690417,17.35517,0.029,NULL,61189483428,956085678,14938838,17.4),(75662,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75662,37.08,0.46,261,28833,70,NULL,NULL,'2MASX J10535265+2115182',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.31',0.16,NULL,NULL,NULL,NULL,NULL,1,163.469625,21.25511,0,NULL,60982236742,952847449,14888241,18.31),(75663,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75663,37.59,0.17,329,28834,70,NULL,NULL,'2MASX J10535293+1234312',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000157,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,163.4707083,12.57547,0.041,NULL,61148498189,955445284,14928832,17),(75664,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75664,37.59,0.17,329,28835,70,NULL,NULL,'2MASX J10535374+1237212',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000163,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,163.473917,12.62269,0.021,NULL,61148052195,955438315,14928723,16.7),(75665,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75665,37.88,0.46,377,28836,70,NULL,NULL,'SDSS J105354.01+393609.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,163.475083333,39.60261,0,NULL,64120441482,1001881898,15654404,18.5),(75666,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75666,38.5,0.46,500,28837,70,NULL,NULL,'SDSS J105354.35+470155.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000133,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,163.4765,47.03211,0,NULL,63911452004,998616437,15603381,18.2),(75667,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75667,37.67,0.33,342,28838,70,NULL,NULL,'2MASX J10535484+1418362',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.53',0.14,NULL,NULL,NULL,NULL,NULL,1,163.4785,14.31006,0.033,NULL,61192583430,956134116,14939595,18.53),(75668,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75668,37.29,0.46,287,28839,70,NULL,NULL,'2MASX J10535481+4807216',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,163.4785417,48.12261,0,NULL,63919893814,998748340,15605442,17),(75669,'IRAS','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75669,31.68,0.8,21.7,28840,75,NULL,'CF, r','NGC 3403',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000037,NULL,'12.97',1.2,'SAbc:','Isolated galaxy',NULL,NULL,NULL,1,163.478583,73.69036,0.117,NULL,61394688249,959292003,14988937,12.97),(75670,'Sosies','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75670,31.45,0.4,19.5,28840,NULL,NULL,NULL,'NGC 3403',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75671,'Tully est','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75671,31.67,0.8,21.6,28840,75,NULL,'B','NGC 3403',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75672,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75672,31.65,0.4,21.4,28840,NULL,NULL,'mean','NGC 3403',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75673,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75673,32.1,0.43,26.3,28840,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3403',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75674,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75674,32.12,0.38,26.5,28840,75,NULL,'CF, r, raw','NGC 3403',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75675,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75675,32.12,0.43,26.5,28840,75,NULL,'3.6 micron, color corrected','NGC 3403',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75676,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75676,32.15,0.2,26.9,28840,74.4,NULL,NULL,'NGC 3403',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75677,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75677,32.18,0.38,27.2,28840,75,NULL,'CF, r, inv','NGC 3403',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75678,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75678,32.31,0.44,29,28840,NULL,NULL,'Malmquist cor.','NGC 3403',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75679,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75679,32.33,0.38,29.2,28840,75,NULL,'CF, r, cor','NGC 3403',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75680,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75680,32.38,0.43,29.9,28840,NULL,NULL,NULL,'NGC 3403',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75681,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75681,32.5,0.47,31.6,28840,NULL,NULL,'H','NGC 3403',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75682,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75682,32.52,0.46,32,28840,NULL,NULL,'J','NGC 3403',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75683,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75683,32.53,0.45,32,28840,NULL,NULL,'K','NGC 3403',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75684,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75684,35.52,0.46,127,28841,70,NULL,NULL,'2MASX J10535504+5120066',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000164,NULL,'16.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,163.4792083,51.33522,0,NULL,61775521880,965242529,15081914,16.3),(75685,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75685,36.34,0.46,186,28842,70,NULL,NULL,'2MASX J10535572+5015376',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,163.482333,50.26044,0,NULL,63907327351,998551989,15602374,17.5),(75686,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 1998as',NULL,75686,40.62,0.2,978,28843,74.2,NULL,'SALT 2','H-ZSNS J105356.22-033910.0',0.36,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,163.48425,-3.65278,0.041,NULL,40931026483,639547288,9992926,NULL),(75687,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 1998as','R',75687,41.32,NULL,1350,28843,65,NULL,'SALT','H-ZSNS J105356.22-033910.0',0.36,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75688,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 1998as',NULL,75688,41.52,0.13,1480,28843,70,NULL,'SALT','H-ZSNS J105356.22-033910.0',0.36,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75689,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 1998as',NULL,75689,41.65,0.11,1570,28843,65,NULL,'SALT','H-ZSNS J105356.22-033910.0',0.36,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75690,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75690,35.87,0.46,149,28844,70,NULL,NULL,'MCG +05-26-027',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000186,NULL,'15.3g',0.4,NULL,NULL,NULL,NULL,NULL,1,163.485083333,26.90897,0,NULL,60487207664,945112619,14767384,15.3),(75691,'BCG','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75691,37.65,0.35,313,28845,60,NULL,NULL,'ABELL 1126',0.0828,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I-II:  [BM]',NULL,NULL,NULL,NULL,1,163.49025,16.85025,0.021,NULL,61200581793,956259090,14941548,NULL),(75692,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75692,37.11,0.33,264,28846,70,NULL,NULL,'2MASX J10535776+4425497',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000166,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,163.490583,44.43058,0,NULL,63908682209,998573159,15602705,16.5),(75693,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75693,39.06,0.46,648,28847,70,NULL,NULL,'SDSS J105358.26+453752.9',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000181,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,163.492791667,45.63139,0,NULL,63912547566,998633555,15603649,17.9),(75694,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75694,38.16,0.46,429,28848,70,NULL,NULL,'SDSS J105358.46+123625.2',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000065,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,163.493625,12.60703,0.021,NULL,61148038320,955438098,14928720,17.4),(75695,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75695,36.89,0.46,239,28849,70,NULL,NULL,'2MASX J10535876+1632142',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000156,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,163.494875,16.53725,0.025,NULL,61200518995,956258109,14941532,17.3),(75696,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75696,38.17,0.33,430,28850,70,NULL,NULL,'2MASX J10540000+4426447',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000189,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,163.500083,44.44581,0,NULL,63909537517,998586523,15602914,18.1),(75697,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75697,37.11,0.33,264,28851,70,NULL,NULL,'2MASX J10540028+4428137',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00018,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,163.501333,44.47039,0,NULL,63909539396,998586553,15602914,16.8),(75698,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75698,35.9,0.46,151,28852,70,NULL,NULL,'2MASX J10540221+1940212',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.79',0.18,NULL,NULL,NULL,NULL,NULL,1,163.5092917,19.67272,0.03,NULL,61159937094,955624017,14931625,16.79),(75699,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 2006cf',NULL,75699,35.66,0.16,130,28853,74.2,NULL,'SALT 2','UGC 06015',0.041552,'2010ApJ...716..712A',2010,1,0.83,NULL,'G',0.000155,NULL,'14.7g',0.65,'Scd:',NULL,NULL,NULL,NULL,1,163.510041667,46.028,0,NULL,63912765505,998636961,15603702,14.7),(75700,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 2006cf',NULL,75700,36.19,0.09,173,28853,74.4,NULL,NULL,'UGC 06015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75701,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 2006cf',NULL,75701,36.4,0.16,183,28853,73.8,NULL,'SALT 2 (SNANA)','UGC 06015',0.0423,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75702,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 2006cf','R',75702,36.34,0.09,185,28853,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 06015',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75703,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 2006cf',NULL,75703,36.44,0.16,186,28853,65,NULL,'SALT','UGC 06015',0.041552,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75704,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 2006cf',NULL,75704,36.46,0.2,188,28853,65,NULL,'SALT2','UGC 06015',0.041552,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75705,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 2006cf','R',75705,36.38,0.09,189,28853,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 06015',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75706,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 2006cf',NULL,75706,36.48,0.15,190,28853,65,NULL,'MLCS17','UGC 06015',0.041552,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75707,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 2006cf',NULL,75707,36.56,0.15,197,28853,65,NULL,'MLCS31','UGC 06015',0.041552,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75708,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75708,36.93,0.66,243,28854,70,NULL,NULL,'2MASX J10540241-4624465',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,163.510167,-46.413,0.681,NULL,41921191084,655018610,10234665,14.6),(75709,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75709,37.68,0.23,344,28855,70,NULL,NULL,'2MASX J10540272+1651282',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000187,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,163.5115,16.85783,0.021,NULL,61200574476,956258976,14941546,16.5),(75710,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75710,37.67,0.33,342,28856,70,NULL,NULL,'SDSS J105402.83+142124.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,163.511833333,14.35683,0.033,NULL,61192570155,956133908,14939592,17.8),(75711,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75711,37.07,0.27,260,28857,70,NULL,NULL,'2MASX J10540324+5549486',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000185,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,163.51325,55.83028,0,NULL,61970992487,968296757,15129636,16.3),(75712,'IRAS','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75712,33.9,0.8,60.2,28858,75,NULL,'MAT, I','NGC 3456',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000022,NULL,'13.33',1.3,'SB(rs)c:',NULL,NULL,NULL,NULL,1,163.5137917,-16.02772,0.161,NULL,41875844458,654310069,10223594,13.33),(75713,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75713,32.78,0.32,35.9,28858,85,NULL,'I, raw','NGC 3456',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75714,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75714,32.81,0.32,36.5,28858,85,NULL,'I, inv','NGC 3456',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75715,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75715,32.94,0.43,38.8,28858,75,NULL,'MAT, I, raw','NGC 3456',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75716,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75716,33.12,0.43,42,28858,75,NULL,'MAT, I, inv','NGC 3456',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75717,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75717,33.24,0.49,44.5,28858,NULL,NULL,NULL,'NGC 3456',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75718,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75718,33.28,0.2,45.3,28858,74.4,NULL,NULL,'NGC 3456',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75719,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75719,33.39,0.46,47.7,28858,NULL,NULL,'Malmquist cor.','NGC 3456',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75720,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75720,33.4,0.43,48,28858,75,NULL,'MAT, I, cor','NGC 3456',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75721,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75721,33.47,0.47,49.5,28858,NULL,NULL,'H','NGC 3456',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75722,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75722,33.56,0.45,51.5,28858,NULL,NULL,'K','NGC 3456',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75723,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75723,33.59,0.46,52.3,28858,NULL,NULL,'J','NGC 3456',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75724,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75724,34.07,0.4,65,28858,NULL,NULL,'mean','NGC 3456',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75725,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75725,37.07,0.27,260,28859,70,NULL,NULL,'2MASX J10540340+5535186',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00017,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,163.513916667,55.58839,0,NULL,61970986796,968296668,15129635,17.4),(75726,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75726,38.35,0.46,468,28860,70,NULL,NULL,'SDSS J105403.93+104714.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000156,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,163.516417,10.78739,0.033,NULL,61026201012,953534390,14898974,18.5),(75727,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75727,37.68,0.11,344,28861,70,NULL,NULL,'2MASX J10540422+5449416',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000205,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,163.5177083,54.82814,0,NULL,61974314978,968348671,15130447,16.4),(75728,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75728,37.07,0.27,260,28862,70,NULL,NULL,'2MASX J10540455+5547536',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000181,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,163.519167,55.79831,0,NULL,61970991980,968296749,15129636,16.9),(75729,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75729,35.97,0.46,157,28863,70,NULL,NULL,'2MASX J10540555+0340432',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000181,NULL,'16.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,163.523083,3.67875,0.133,NULL,60320306451,942504788,14726637,16.4),(75730,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75730,37.68,0.11,344,28864,70,NULL,NULL,'2MASX J10540562+5444166',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000187,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,163.523417,54.73789,0,NULL,61974289660,968348275,15130441,16.2),(75731,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75731,36.69,0.46,218,28865,70,NULL,NULL,'2MASX J10540685+0504552',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000104,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,163.5287083,5.08192,0.105,NULL,60319085934,942485717,14726339,17.7),(75732,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75732,38.22,0.46,441,28866,70,NULL,NULL,'2MASX J10540842+1603292',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000161,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,163.535167,16.05808,0.037,NULL,61203139067,956299047,14942172,18.2),(75733,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75733,37.68,0.23,344,28867,70,NULL,NULL,'2MASX J10540899+1652332',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,163.537625,16.87583,0.021,NULL,61200570194,956258909,14941545,17.7),(75734,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75734,37.59,0.17,329,28868,70,NULL,NULL,'2MASX J10540918+1233242',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,163.538458333,12.55681,0.021,NULL,61148511188,955445487,14928835,16.8),(75735,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75735,37.38,0.46,300,28869,70,NULL,NULL,'2MASX J10541007+4955433',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,163.5420417,49.92864,0,NULL,63907294863,998551482,15602366,17.8),(75736,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75736,37.77,0.46,358,28870,70,NULL,NULL,'2MASX J10541066+3939390',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000168,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,163.5445,39.66094,0,NULL,64112081686,1001751276,15652363,18),(75737,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75737,34.55,NULL,81.2,28871,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06017',NULL,'2010Ap&SS.325..163P',2010,1,1.41,NULL,'G',0.000171,NULL,'15.9g',0.24,'Sc',NULL,NULL,NULL,NULL,1,163.545291667,44.62425,0,NULL,63909588952,998587327,15602926,15.9),(75738,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75738,34.56,NULL,81.6,28871,NULL,NULL,'Dipole','UGC 06017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75739,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75739,34.56,NULL,81.7,28871,NULL,NULL,'Dipole + Quadrupole','UGC 06017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75740,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75740,34.61,NULL,83.7,28871,NULL,NULL,NULL,'UGC 06017',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75741,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75741,34.64,0.49,84.9,28871,75,NULL,'IR','UGC 06017',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75742,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75742,36.93,0.46,244,28872,70,NULL,NULL,'2MASX J10541097+1538012',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000143,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,163.5457917,15.63369,0.037,NULL,61203062716,956297854,14942153,17.5),(75743,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75743,37.68,0.11,344,28873,70,NULL,NULL,'2MASX J10541303+5500366',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000161,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,163.55425,55.01022,0,NULL,61971416281,968303379,15129740,17.3),(75744,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75744,38.74,0.46,560,28874,70,NULL,NULL,'SDSS J105413.22+450724.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000133,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,163.555083,45.12358,0,NULL,63908965828,998577591,15602774,18.8),(75745,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75745,37.59,0.17,329,28875,70,NULL,NULL,'SDSS J105413.30+123807.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000167,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,163.5554583,12.63553,0.021,NULL,61148505420,955445397,14928834,18.5),(75746,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75746,37.7,0.46,347,28876,70,NULL,NULL,'2MASX J10541383+4529346',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,163.5575,45.49308,0,NULL,63912425323,998631645,15603619,17.6),(75747,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75747,34.44,0.45,77.2,28877,70,NULL,NULL,'NGC 3452',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00012,NULL,'14.80',0.3,'Sa: sp',NULL,NULL,NULL,NULL,1,163.558667,-11.40506,0.021,NULL,41787346303,652927285,10201988,14.8),(75748,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75748,36.14,0.46,169,28878,70,NULL,NULL,'2MASX J10541430+4606276',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000172,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,163.559458333,46.10772,0,NULL,63912743171,998636612,15603697,16.3),(75749,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75749,35.87,0.49,149,28879,75,NULL,'IR','UGC 06020',NULL,'2011yCatp016004901K',2011,1,1.33,NULL,'G',0.000033,NULL,'16.0',0.15,'Sbc',NULL,NULL,NULL,NULL,1,163.560333333,21.13258,0,NULL,60982253830,952847716,14888245,16),(75750,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75750,36.26,NULL,178,28879,NULL,NULL,'Dipole + Quadrupole','UGC 06020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75751,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75751,36.26,NULL,179,28879,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75752,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75752,36.27,NULL,180,28879,NULL,NULL,'Dipole','UGC 06020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75753,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75753,36.41,NULL,191,28879,NULL,NULL,NULL,'UGC 06020',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75754,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75754,37.79,0.46,361,28880,70,NULL,NULL,'2MASX J10541507+1433232',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000174,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,163.562875,14.5565,0.037,NULL,61192189103,956127954,14939499,16.6),(75755,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75755,37.68,0.23,344,28881,70,NULL,NULL,'2MASX J10541512+1651342',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000171,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,163.563,16.85947,0.021,NULL,61200577027,956259016,14941547,17.6),(75756,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75756,32.51,NULL,31.8,28882,NULL,NULL,NULL,'UGC 06022',NULL,'2015AstBu..70....1K',2015,1,1.2,NULL,'G',0.000013,NULL,'17.07',0.7,'Im:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,163.564167,17.81028,0.025,NULL,61188674713,956073042,14938641,17.07),(75757,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75757,37.51,0.46,317,28883,70,NULL,NULL,'SDSS J105416.68+190229.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,163.569541667,19.04144,0.013,NULL,61160446575,955631977,14931749,18.1),(75758,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75758,34.71,0.33,87.6,28884,70,NULL,NULL,'CGCG 241-032',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000145,NULL,'14.9g',0.31,'S0/a',NULL,NULL,NULL,NULL,1,163.5697917,49.03803,0,NULL,63920205142,998753205,15605518,14.9),(75759,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75759,38.21,0.46,438,28885,70,NULL,NULL,'2MASX J10541745+2835367',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000187,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,163.5727083,28.59364,0,NULL,60519516912,945617451,14775272,17.9),(75760,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75760,37.59,0.17,329,28886,70,NULL,NULL,'2MASX J10541813+1233002',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,163.575583,12.55006,0.021,NULL,61148503160,955445361,14928833,NULL),(75761,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75761,37.59,0.17,329,28887,70,NULL,NULL,'2MASX J10541840+1233222',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,163.5767083,12.55628,0.021,NULL,61148503243,955445363,14928833,18.3),(75762,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75762,37.99,0.33,396,28888,70,NULL,NULL,'2MASX J10541859+1645572',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000171,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,163.577583,16.76583,0.025,NULL,61200566542,956258852,14941544,17.5),(75763,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75763,37.68,0.11,344,28889,70,NULL,NULL,'SDSS J105420.27+550048.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000168,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,163.5845,55.01356,0,NULL,61971417020,968303390,15129740,18.5),(75764,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75764,37.36,0.33,297,28890,70,NULL,NULL,'2MASX J10542039+1207525',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,163.5850417,12.13119,0,NULL,61148275757,955441808,14928778,17.9),(75765,'IRAS','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75765,31.96,0.8,24.6,28891,75,NULL,'CF, r','NGC 3451',NULL,'1997ApJS..109..333W',1997,1,1.7,'Multiple SDSS entries describe this object.','G',0.000033,NULL,'13.61',0.8,'Sd             HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,163.5870417,27.23975,0,NULL,60487279316,945113739,14767402,13.61),(75766,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75766,32.2,0.4,27.5,28891,NULL,NULL,NULL,'NGC 3451',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75767,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75767,32.22,0.43,27.8,28891,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3451',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75768,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75768,32.23,0.43,27.9,28891,75,NULL,'3.6 micron, color corrected','NGC 3451',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75769,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75769,32.25,0.2,28.2,28891,74.4,NULL,NULL,'NGC 3451',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75770,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75770,32.26,0.4,28.3,28891,NULL,NULL,'mean','NGC 3451',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75771,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75771,32.73,0.46,35.1,28891,NULL,NULL,'J','NGC 3451',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75772,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75772,32.73,0.45,35.2,28891,NULL,NULL,'K','NGC 3451',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75773,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75773,32.74,0.47,35.3,28891,NULL,NULL,'H','NGC 3451',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75774,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75774,32.8,0.38,36.3,28891,75,NULL,'CF, r, raw','NGC 3451',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75775,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75775,32.84,0.38,37,28891,75,NULL,'CF, r, cor','NGC 3451',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75776,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75776,32.86,0.38,37.3,28891,75,NULL,'CF, r, inv','NGC 3451',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75777,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75777,36.47,0.73,197,28892,70,NULL,NULL,'2MASX J10542092-4717134',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,163.5872083,-47.28717,0.817,NULL,41919224003,654987875,10234185,16.8),(75778,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75778,37.67,0.46,343,28893,70,NULL,NULL,'2MASX J10542099+2549277',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'18.35',0.14,NULL,NULL,NULL,NULL,NULL,1,163.587541667,25.82444,0,NULL,60494807913,945231373,14769240,18.35),(75779,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75779,37.66,0.46,340,28894,70,NULL,NULL,'2MASX J10542128+1909311',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,163.58875,19.15878,0.017,NULL,61160515617,955633056,14931766,18.2),(75780,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75780,36.89,0.46,239,28895,70,NULL,NULL,'2MASX J10542243+1606235',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000166,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,163.5934583,16.10647,0.029,NULL,61203151494,956299242,14942175,16.5),(75781,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75781,37.94,0.33,388,28896,70,NULL,NULL,'2MASX J10542254+1939211',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,163.5940417,19.65603,0.03,NULL,61159940967,955624077,14931626,17.4),(75782,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75782,38.33,0.46,465,28897,70,NULL,NULL,'2MASX J10542256+1703015',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000175,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,163.594083,17.05047,0.021,NULL,61201061940,956266592,14941665,17.4),(75783,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75783,37.44,0.33,307,28898,70,NULL,NULL,'2MASX J10542354+0238189',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00016,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,163.598083333,2.63853,0.077,NULL,60325494193,942585846,14727903,18.1),(75784,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75784,37.34,0.46,294,28899,70,NULL,NULL,'2MASX J10542435+5429295',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,163.6012917,54.49158,0,NULL,61973461437,968335334,15130239,18.2),(75785,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75785,34.07,0.58,65.1,28900,70,NULL,NULL,'2MASX J10542466-4644275',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.0001,NULL,'15.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,163.6027083,-46.74092,0.749,NULL,41921235406,655019303,10234676,15.4),(75786,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75786,35.66,0.46,136,28901,70,NULL,NULL,'2MASX J10542549+4819013',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000145,NULL,'16.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,163.606,48.31697,0,NULL,63919764961,998746327,15605411,16.3),(75787,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75787,38.17,0.33,430,28902,70,NULL,NULL,'2MASX J10542544+4428268',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000176,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,163.6060417,44.47417,0,NULL,63909542974,998586608,15602915,17.6),(75788,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75788,37.94,0.33,388,28903,70,NULL,NULL,'2MASX J10542566+1937271',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,163.6067917,19.62419,0.03,NULL,61159919705,955623745,14931621,17.3),(75789,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75789,36.4,0.46,191,28904,70,NULL,NULL,'CGCG 038-046',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000185,NULL,'15.5g',0.57,'E0',NULL,NULL,NULL,NULL,1,163.608875,7.14272,0.057,NULL,61027506261,953554785,14899293,15.5),(75790,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75790,37.99,0.33,396,28905,70,NULL,NULL,'2MASX J10542697+1645425',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.50',0.15,NULL,NULL,NULL,NULL,NULL,1,163.612417,16.76194,0.025,NULL,61200564379,956258818,14941544,18.5),(75791,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75791,37.45,0.46,309,28906,70,NULL,NULL,'2MASX J10542703+4324138',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,163.612833,43.40378,0,NULL,63929741141,998902205,15607846,17.1),(75792,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75792,37.93,0.46,385,28907,70,NULL,NULL,'2MASXi J1054271+194006',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.87',0.12,NULL,NULL,NULL,NULL,NULL,1,163.61325,19.66847,0.03,NULL,61159941005,955624078,14931626,18.87),(75793,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75793,37.59,0.17,329,28908,70,NULL,NULL,'2MASX J10542746+1233475',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,163.614458333,12.56331,0.021,NULL,61148503554,955445368,14928833,17.2),(75794,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75794,37.43,0.46,306,28909,70,NULL,NULL,'SDSS J105427.55+640019.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,163.614875,64.00539,0.021,NULL,61835200892,966175013,15096484,17.8),(75795,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75795,39.23,0.46,701,28910,70,NULL,NULL,'SDSS J105428.46+592759.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000145,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,163.618625,59.46658,0,NULL,61952366377,968005724,15125089,18),(75796,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75796,34.52,0.35,80.2,28911,NULL,NULL,'Malmquist cor.','ESO 264- G 050',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.88',0.5,'SB(r)ab',NULL,NULL,NULL,NULL,1,163.619125,-46.2115,0.681,NULL,41922005027,655031328,10234864,14.88),(75797,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75797,34.66,0.4,85.4,28911,NULL,NULL,'mean','ESO 264- G 050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75798,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75798,34.85,0.3,93.4,28911,NULL,NULL,NULL,'ESO 264- G 050',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75799,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75799,34.89,0.2,95.1,28911,74.4,NULL,NULL,'ESO 264- G 050',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75800,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75800,34.98,0.47,99.1,28911,NULL,NULL,'H','ESO 264- G 050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75801,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75801,35.02,0.45,101,28911,NULL,NULL,'K','ESO 264- G 050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75802,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75802,35.05,0.46,102,28911,NULL,NULL,'J','ESO 264- G 050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75803,'Tully est','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75803,31.64,0.8,21.3,28912,75,NULL,'B','NGC 3454',NULL,'1988NBGC.C....0000T',1988,1,2.8,NULL,'G',0.000005,NULL,'14.18',0.36,'SB(s)c? sp     HII','Pair member (points to parent)',NULL,NULL,NULL,1,163.623041667,17.34403,0.009,NULL,61188790089,956074845,14938669,14.18),(75804,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75804,31.57,0.4,20.6,28912,75,NULL,NULL,'NGC 3454',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75805,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75805,31.98,0.49,24.9,28912,75,NULL,'IR','NGC 3454',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75806,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75806,32.18,NULL,27.3,28912,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 3454',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75807,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75807,32.2,NULL,27.6,28912,NULL,NULL,'Dipole + Quadrupole','NGC 3454',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75808,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75808,32.21,NULL,27.7,28912,NULL,NULL,'Dipole','NGC 3454',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75809,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75809,32.31,NULL,29,28912,NULL,NULL,NULL,'NGC 3454',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75810,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75810,35.63,0.2,134,28913,74.4,NULL,NULL,'CGCG 066-060',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000012,NULL,'15.8g',0.4,'Sc',NULL,NULL,NULL,NULL,1,163.629417,11.45269,0.009,NULL,61025306056,953520407,14898756,15.8),(75811,'Tully est','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75811,31.56,0.8,20.5,28914,75,NULL,'B','NGC 3455',NULL,'1988NBGC.C....0000T',1988,1,1.78,NULL,'G',0.000033,NULL,'13.3g',0.99,'(R\')SAB(rs)b','Pair member (points to parent)',NULL,NULL,NULL,1,163.6295417,17.28475,0.017,NULL,61188751156,956074236,14938659,13.3),(75812,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75812,29.51,0.69,7.97,28914,100,NULL,'mid-IR','NGC 3455',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75813,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75813,31.94,0.4,24.5,28914,NULL,NULL,'mean','NGC 3455',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75814,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75814,32.18,0.83,27.3,28914,NULL,NULL,'Malmquist cor.','NGC 3455',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75815,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75815,32.55,0.47,32.4,28914,NULL,NULL,'H','NGC 3455',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75816,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75816,32.58,0.69,32.7,28914,NULL,NULL,NULL,'NGC 3455',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75817,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75817,32.58,0.46,32.8,28914,NULL,NULL,'J','NGC 3455',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75818,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75818,32.59,0.45,32.9,28914,NULL,NULL,'K','NGC 3455',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75819,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75819,32.62,0.2,33.4,28914,74.4,NULL,NULL,'NGC 3455',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75820,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75820,36.95,0.46,245,28915,70,NULL,NULL,'2MASX J10543141+4924342',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'17.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,163.631,49.40953,0,NULL,63918318369,998723724,15605058,17.6),(75821,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75821,37.36,0.33,297,28916,70,NULL,NULL,'SDSS J105432.51+121013.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000155,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,163.6355,12.17042,0,NULL,61148454062,955444594,14928821,18.3),(75822,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75822,34.71,0.33,87.6,28917,70,NULL,NULL,'CGCG 241-033',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000156,NULL,'15.3g',0.52,'E0',NULL,NULL,NULL,NULL,1,163.637,49.22111,0,NULL,63918315999,998723687,15605057,15.3),(75823,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75823,37.89,0.33,378,28918,70,NULL,NULL,'2MASX J10543324+1950551',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.54',0.15,NULL,NULL,NULL,NULL,NULL,1,163.638583,19.84883,0.03,NULL,61159850465,955622663,14931604,18.54),(75824,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75824,37.64,0.46,338,28919,70,NULL,NULL,'2MASX J10543343+1924321',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,163.63925,19.40892,0.019,NULL,61160522396,955633162,14931768,17.3),(75825,'GRB','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75825,42.16,NULL,2700,28920,70,NULL,'Pseudo z = 1.1','GRB 030418',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'VisS',NULL,NULL,'18.8',NULL,'HETE',NULL,NULL,NULL,NULL,1,163.6402917,-7.02797,0.033,NULL,41780240619,652816259,10200254,18.8),(75826,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75826,37.21,0.46,277,28921,70,NULL,NULL,'2MASX J10543475+4358518',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,163.644917,43.98097,0,NULL,63938144635,999033509,15609898,17.2),(75827,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75827,37.5,0.46,316,28922,70,NULL,NULL,'SDSS J105435.05+490511.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000132,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,163.6460417,49.08642,0,NULL,63920205960,998753218,15605519,18),(75828,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75828,36.05,0.2,162,28923,74.4,NULL,NULL,'CGCG 066-061',NULL,'2013AJ....146...86T',2013,1,0.63,NULL,'G',0.000012,NULL,'15.7g',0.32,'Sb',NULL,NULL,NULL,NULL,1,163.646166667,11.01294,0.033,NULL,61025353901,953521154,14898768,15.7),(75829,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75829,31.07,0.88,16.4,28924,NULL,NULL,NULL,'NGC 3445',NULL,'2009ApJS..182..474S',2009,1,1.6,'Multiple SDSS entries describe this object.','G',0.000003,NULL,'12.9',1.5,'SAB(s)m','Pair member (points to parent)',NULL,NULL,NULL,1,163.647875,56.99069,0,NULL,62006345414,968849147,15138267,12.9),(75830,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75830,31.11,0.2,16.7,28924,74.4,NULL,NULL,'NGC 3445',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75831,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75831,31.36,0.77,18.7,28924,NULL,NULL,'Malmquist cor.','NGC 3445',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75832,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75832,32.55,0.4,32.4,28924,75,NULL,'B','NGC 3445',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75833,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75833,37.68,0.11,344,28925,70,NULL,NULL,'2MASX J10543648+5447244',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000174,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,163.652,54.79,0,NULL,61974260221,968347815,15130434,16.5),(75834,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75834,36.16,0.46,171,28926,70,NULL,NULL,'2MASX J10543688+4300588',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000185,NULL,'16.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,163.65375,43.01636,0,NULL,63930452795,998913324,15608020,16.1),(75835,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75835,35,0.33,100,28927,70,NULL,NULL,'CGCG 241-034',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.00016,NULL,'14.6g',0.73,'E0',NULL,NULL,NULL,NULL,1,163.6585,47.47028,0,NULL,63919399452,998740616,15605322,14.6),(75836,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75836,35.8,0.56,144,28928,70,NULL,NULL,'LCRS B105206.2-052612',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00015,NULL,'16.20',0.33,NULL,NULL,NULL,NULL,NULL,1,163.658583333,-5.70344,0.025,NULL,40928417105,639506517,9992289,16.2),(75837,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75837,37.03,0.46,255,28929,70,NULL,NULL,'2MASX J10543846+4749239',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000143,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,163.660417,47.82322,0,NULL,63919466825,998741669,15605338,17.6),(75838,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75838,37.45,0.33,309,28930,70,NULL,NULL,'SDSS J105438.52+120718.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000136,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,163.6605,12.12178,0,NULL,61148274943,955441795,14928778,18.4),(75839,'Tully est','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75839,31.94,0.8,24.5,28931,75,NULL,'B','NGC 3448',NULL,'1988NBGC.C....0000T',1988,1,5.6,NULL,'G',0.000017,NULL,'12.48',1.8,'I0','Possible field galaxy',NULL,NULL,NULL,1,163.663333,54.30486,0,NULL,61973367348,968333864,15130216,12.48),(75840,'IRAS','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75840,33.61,0.8,52.7,28932,75,NULL,'MAT, I','NGC 3464',NULL,'1997ApJS..109..333W',1997,1,2.6,'DSS1 has a plate flaw superposed at 105440.8, -210507 (2000).','G',0.00001,NULL,'12.4B',1.7,'SAB(rs)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,163.6667083,-21.06664,0.177,NULL,41639013618,650609587,10165774,12.4),(75841,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75841,33.27,0.43,45,28932,75,NULL,'MAT, I, raw','NGC 3464',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75842,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75842,33.36,NULL,47,28932,NULL,NULL,'B','NGC 3464',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75843,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75843,33.42,0.32,48.4,28932,85,NULL,'I, raw','NGC 3464',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75844,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75844,33.49,0.32,49.8,28932,85,NULL,'I, inv','NGC 3464',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75845,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75845,33.49,0.47,49.9,28932,NULL,NULL,'H','NGC 3464',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75846,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75846,33.52,0.43,50.5,28932,75,NULL,'MAT, I, inv','NGC 3464',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75847,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75847,33.52,NULL,50.6,28932,NULL,NULL,'B','NGC 3464',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75848,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75848,33.53,0.45,50.9,28932,NULL,NULL,'K','NGC 3464',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75849,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75849,33.55,0.46,51.2,28932,NULL,NULL,'J','NGC 3464',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75850,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75850,33.57,0.2,51.8,28932,74.4,NULL,NULL,'NGC 3464',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75851,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75851,33.57,0.43,51.8,28932,75,NULL,'MAT, I, cor','NGC 3464',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75852,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75852,33.67,NULL,54.2,28932,NULL,NULL,'I','NGC 3464',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75853,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75853,33.8,0.4,57.6,28932,NULL,NULL,'mean','NGC 3464',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75854,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75854,33.91,0.07,60.7,28932,NULL,NULL,NULL,'NGC 3464',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75855,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75855,37.89,0.33,378,28933,70,NULL,NULL,'SDSS J105440.52+195051.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,163.668875,19.84767,0.03,NULL,61159851875,955622685,14931604,18.2),(75856,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75856,37,0.46,251,28934,70,NULL,NULL,'2MASX J10544193+3338259',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000178,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,163.67475,33.64042,0,NULL,60502545645,945352275,14771129,16.7),(75857,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75857,38.45,0.46,489,28935,70,NULL,NULL,'2MASX J10544252+5652108',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,163.6770417,56.86958,0,NULL,62006318930,968848733,15138261,17.2),(75858,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75858,36.43,0.46,193,28936,70,NULL,NULL,'KUG 1051+362C',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'16.5:',0.2,'Compact',NULL,NULL,NULL,NULL,1,163.678417,36.005,0.113,NULL,64106355213,1001661800,15650965,16.5),(75859,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75859,37.55,0.46,324,28937,70,NULL,NULL,'2MASX J10544309-0052303',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000072,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,163.6795,-0.87508,0.085,NULL,40924726656,639448854,9991388,17.2),(75860,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75860,37.44,0.33,307,28938,70,NULL,NULL,'2MASX J10544369+0236429',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000189,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,163.682041667,2.61192,0.077,NULL,60325468793,942585449,14727897,16.6),(75861,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75861,36.67,0.46,216,28939,70,NULL,NULL,'2MASX J10544375+4431379',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000161,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,163.6822917,44.52731,0,NULL,63909012711,998578323,15602786,16.7),(75862,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','PS1 SN PS11w','N',75862,39.49,0.1,672,28940,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11w HOST',0.1745,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75863,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75863,33.21,0.4,43.9,28941,75,NULL,NULL,'NGC 3459',NULL,'2008Ap.....51..336K',2008,1,1.6,'RC3 has V = 2663 +- 9 km/s; 1992ZCAT..M...0000H has V = 4253 +- 28 km/s.','G',0.00015,NULL,'14.50',0.5,'(R\')SBab:',NULL,NULL,NULL,NULL,1,163.6845,-17.042,0.105,NULL,41874696251,654292128,10223314,14.5),(75864,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75864,33.57,0.49,51.7,28941,75,NULL,'IR','NGC 3459',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75865,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75865,33.68,0.47,54.3,28941,NULL,NULL,'H','NGC 3459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75866,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75866,33.72,0.45,55.5,28941,NULL,NULL,'K','NGC 3459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75867,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75867,33.8,0.46,57.7,28941,NULL,NULL,'J','NGC 3459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75868,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75868,34.08,0.4,65.3,28941,NULL,NULL,'mean','NGC 3459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75869,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75869,35.52,0.59,127,28942,70,NULL,NULL,'2MASX J10544472-4807078',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,163.686417,-48.11878,0.829,NULL,41923774978,655058984,10235296,16.7),(75870,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75870,36.97,0.46,248,28943,70,NULL,NULL,'2MASX J10544598+3819294',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000167,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,163.691667,38.32494,0,NULL,64107827798,1001684809,15651325,16.5),(75871,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75871,38.03,0.46,403,28944,70,NULL,NULL,'SDSS J105446.02+130638.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,163.6917917,13.11064,0.029,NULL,61148195145,955440549,14928758,18.2),(75872,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75872,37.83,0.46,368,28945,70,NULL,NULL,'2MASX J10544685+1048450',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,163.695083,10.81244,0.037,NULL,61025739689,953527182,14898862,17.9),(75873,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75873,37.11,0.46,264,28946,70,NULL,NULL,'2MASX J10544828+3628444',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000164,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,163.701083,36.47911,0,NULL,64106533422,1001664584,15651009,16.8),(75874,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75874,34.67,0.4,85.8,28947,NULL,NULL,'mean','NGC 3435',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.00003,NULL,'13.5B',1.2,'Sb','in a pair',NULL,NULL,NULL,1,163.701375,61.28986,0,NULL,61830637682,966103713,15095370,13.5),(75875,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75875,34.94,0.2,97.3,28947,74.4,NULL,NULL,'NGC 3435',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75876,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75876,35.01,0.47,101,28947,NULL,NULL,'H','NGC 3435',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75877,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75877,35.07,0.45,103,28947,NULL,NULL,'K','NGC 3435',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75878,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75878,35.07,0.46,103,28947,NULL,NULL,'J','NGC 3435',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75879,'SBF','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75879,31.56,0.14,20.5,28948,74.4,NULL,NULL,'NGC 3457',NULL,'2013AJ....146...86T',2013,1,0.9,'Identification as NGC 3457 is not certain.','G',0.000017,NULL,'13.6',0.9,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,163.702625,17.62125,0.013,NULL,61188812860,956075200,14938675,13.6),(75880,'SBF','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75880,31.58,0.15,20.7,28948,NULL,NULL,'I','NGC 3457',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75881,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75881,36.41,0.33,191,28949,70,NULL,NULL,'2MASX J10545018+1608071',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000171,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,163.709125,16.13531,0.029,NULL,61203124987,956298827,14942169,16.3),(75882,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75882,36.89,0.46,238,28950,70,NULL,NULL,'2MASX J10545034+2310186',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000163,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,163.7097917,23.17206,0,NULL,60969899442,952654678,14885229,16.7),(75883,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75883,37.04,0.46,256,28951,70,NULL,NULL,'2MASX J10545094+1857396',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.04',0.22,NULL,NULL,NULL,NULL,NULL,1,163.7122083,18.96114,0.028,NULL,61158564889,955602576,14931290,17.04),(75884,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75884,37.1,0.46,264,28952,70,NULL,NULL,'2MASX J10545103+2720410',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000166,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,163.712625,27.34486,0,NULL,60487275307,945113676,14767401,16.8),(75885,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75885,36.99,0.46,250,28953,70,NULL,NULL,'2MASX J10545117+0902123',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.11',0.17,NULL,NULL,NULL,NULL,NULL,1,163.713167,9.03675,0.037,NULL,61031831926,953622373,14900349,18.11),(75886,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75886,35.84,0.2,147,28954,74.4,NULL,NULL,'CGCG 095-066',NULL,'2013AJ....146...86T',2013,1,0.74,NULL,'G',0.00013,NULL,'15.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,163.7197917,14.42394,0.033,NULL,61192757587,956136837,14939638,15.6),(75887,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75887,38.2,0.46,437,28955,70,NULL,NULL,'2MASX J10545510+1251542',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000181,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,163.729583,12.86506,0.025,NULL,61148054167,955438346,14928724,17.7),(75888,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75888,36.46,0.61,196,28956,70,NULL,NULL,'2MASX J10545541-4236305',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,163.730916667,-42.60856,0.685,NULL,41897934230,654655222,10228987,17.5),(75889,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75889,36.17,0.57,172,28957,70,NULL,NULL,'2MASX J10545590-1016197',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.12',NULL,NULL,NULL,NULL,NULL,NULL,1,163.733167,-10.27228,0.049,NULL,41786805526,652918836,10201856,16.12),(75890,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75890,37.88,0.46,377,28958,70,NULL,NULL,'2MASX J10545601+4500078',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,163.7332083,45.00208,0,NULL,63909078791,998579356,15602802,18.1),(75891,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75891,37.62,0.46,334,28959,70,NULL,NULL,'2MASX J10545635+1427132',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000189,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,163.734833,14.45358,0.033,NULL,61192688407,956135756,14939621,16.7),(75892,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75892,36.3,0.46,182,28960,70,NULL,NULL,'2MASX J10545726+2024196',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',NULL,NULL,'15.88',0.21,NULL,NULL,NULL,NULL,NULL,1,163.7387083,20.40553,0,NULL,61159424833,955616013,14931500,15.88),(75893,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75893,36.57,0.46,206,28961,70,NULL,NULL,'2MASX J10545766+0027088',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000085,NULL,'16.2g',0.35,'S0',NULL,NULL,NULL,NULL,1,163.740291667,0.45242,0.113,NULL,60289094780,942017105,14719017,16.2),(75894,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75894,36.41,0.33,191,28962,70,NULL,NULL,'2MASX J10545865+1611312',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000188,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,163.744458333,16.19181,0.029,NULL,61202883575,956295055,14942110,16.6),(75895,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75895,37.93,0.27,386,28963,70,NULL,NULL,'2MASX J10545931+0123108',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,163.747167,1.38642,0.085,NULL,60323269973,942551093,14727360,16.9),(75896,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75896,37.51,0.46,318,28964,70,NULL,NULL,'2MASX J10550067+3857570',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,163.752833333,38.96583,0,NULL,64107038707,1001672479,15651132,17.8),(75897,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75897,37.45,0.33,309,28965,70,NULL,NULL,'2MASX J10550082+1202533',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.39',0.17,'BrClG',NULL,NULL,NULL,NULL,1,163.753416667,12.04806,0,NULL,61148266103,955441657,14928775,18.39),(75898,'Tully est','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75898,31.93,0.8,24.3,28966,75,NULL,'B','UGC 06029',NULL,'1988NBGC.C....0000T',1988,1,1,NULL,'G',0.000023,NULL,'14.03',0.9,'Pec','in a pair',NULL,NULL,NULL,1,163.7592917,49.72586,0,NULL,63907282497,998551289,15602363,14.03),(75899,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75899,36.22,0.46,175,28967,70,NULL,NULL,'2MASXi J1055023+245336',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000174,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,163.760041667,24.89333,0,NULL,60496486992,945257609,14769650,16.6),(75900,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75900,36.37,0.46,188,28968,70,NULL,NULL,'2MASX J10550240+4108270',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.79',0.22,NULL,NULL,NULL,NULL,NULL,1,163.760041667,41.14089,0,NULL,63931394690,998928042,15608250,16.79),(75901,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75901,35.92,0.46,153,28969,70,NULL,NULL,'MRK 1268',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000168,NULL,'15.9g',0.37,'Compact',NULL,NULL,NULL,NULL,1,163.7624583,39.13614,0,NULL,64106813230,1001668956,15651077,15.9),(75902,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75902,38.12,0.46,421,28970,70,NULL,NULL,'2MASX J10550355-0023239',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000085,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,163.7647917,-0.38986,0.089,NULL,40907130350,639173911,9987092,17.8),(75903,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75903,36.83,0.46,232,28971,70,NULL,NULL,'2MASX J10550432+1311502',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000157,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,163.767875,13.19719,0.033,NULL,61148134178,955439596,14928743,16.7),(75904,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75904,36.47,0.91,197,28972,70,NULL,NULL,'2MFGC 08514',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.56',0.16,NULL,NULL,NULL,NULL,NULL,1,163.7682917,-5.66281,0.025,NULL,40928433628,639506775,9992293,15.56),(75905,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75905,37.77,0.46,358,28973,70,NULL,NULL,'2MASX J10550694+3220007',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000179,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,163.779083,32.33353,0.015,NULL,60512593651,945509275,14773582,17.2),(75906,'Tully est','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75906,32.25,0.8,28.2,28974,75,NULL,NULL,'UGC 06027',NULL,'1988NBGC.C....0000T',1988,1,1.3,'Multiple SDSS entries describe this source.','G',0.00002,NULL,'17.',0.7,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,163.780917,63.99342,0.021,NULL,61835214507,966175226,15096487,17),(75907,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75907,37.68,0.11,344,28975,70,NULL,NULL,'2MASX J10550737+5446198',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000175,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,163.7805417,54.77225,0,NULL,61974258870,968347794,15130434,16.3),(75908,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75908,35.43,0.46,122,28976,70,NULL,NULL,'2MASX J10550792+5055300',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000157,NULL,'16.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,163.783167,50.92506,0,NULL,63906961029,998546266,15602285,16.3),(75909,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75909,36.83,0.46,232,28977,70,NULL,NULL,'2MASX J10550929+3226347',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,163.788875,32.443,0.015,NULL,60512547324,945508551,14773571,16.5),(75910,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75910,37.99,0.46,397,28978,70,NULL,NULL,'2MASX J10550939+1235262',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,163.7892083,12.59061,0.013,NULL,61148526767,955445730,14928839,17.8),(75911,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75911,35.56,0.46,129,28979,70,NULL,NULL,'2MASX J10551017+0741043',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000153,NULL,'15.9g',0.39,'S0/a',NULL,NULL,NULL,NULL,1,163.7922917,7.68456,0.045,NULL,61031168528,953612008,14900187,15.9),(75912,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75912,37.09,0.46,261,28980,70,NULL,NULL,'2MASX J10551030+1839226',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.25',0.18,NULL,NULL,NULL,NULL,NULL,1,163.793,18.65639,0.005,NULL,61159129729,955611402,14931428,18.25),(75913,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75913,37.56,0.46,325,28981,70,NULL,NULL,'2MASX J10551069+1913446',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.46',0.17,NULL,NULL,NULL,NULL,NULL,1,163.7945,19.22917,0,NULL,61160330657,955630166,14931721,18.46),(75914,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75914,36.93,0.46,243,28982,70,NULL,NULL,'2MASX J10551163+1527002',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000166,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,163.798375,15.44994,0.025,NULL,61199754940,956246170,14941346,16.8),(75915,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75915,36.41,0.46,191,28983,70,NULL,NULL,'2MASX J10551278+2203036',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.26',0.21,NULL,NULL,NULL,NULL,NULL,1,163.803375,22.05097,0,NULL,60971135404,952673990,14885531,17.26),(75916,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75916,37.19,0.64,274,28984,70,NULL,NULL,'LCRS B105241.4-063519',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'15.12',0.26,NULL,NULL,NULL,NULL,NULL,1,163.803875,-6.85569,0.013,NULL,41780217478,652815898,10200248,15.12),(75917,'IRAS','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75917,33.75,0.8,56.3,28985,75,NULL,'MAT, I','NGC 3463',NULL,'1997ApJS..109..333W',1997,1,1.5,'ESO dec. of -25d53.5m is incorrect. Corrected in ESO-LV.','G',0.000033,NULL,'13.75',0.7,'Sb             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,163.805666667,-26.14075,0.313,NULL,41520208261,648753254,10136769,13.75),(75918,'IRAS','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75918,33.78,0.8,56.9,28985,75,NULL,'HMCL, I','NGC 3463',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75919,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75919,33.78,0.4,57.1,28985,75,NULL,'HMCL, I, cor','NGC 3463',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75920,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75920,33.81,0.4,57.7,28985,75,NULL,'HMCL, I, raw','NGC 3463',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75921,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75921,33.85,0.47,58.9,28985,NULL,NULL,'H','NGC 3463',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75922,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75922,33.89,0.43,60,28985,75,NULL,'MAT, I, cor','NGC 3463',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75923,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75923,33.89,0.32,60.1,28985,85,NULL,'I, raw','NGC 3463',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75924,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75924,33.9,0.46,60.3,28985,NULL,NULL,'J','NGC 3463',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75925,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75925,33.92,0.43,60.7,28985,75,NULL,'MAT, I, raw','NGC 3463',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75926,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75926,33.94,0.45,61.4,28985,NULL,NULL,'K','NGC 3463',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75927,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75927,33.95,0.32,61.8,28985,85,NULL,'I, inv','NGC 3463',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75928,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75928,33.97,0.4,62.3,28985,NULL,NULL,'mean','NGC 3463',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75929,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75929,33.98,0.07,62.6,28985,NULL,NULL,NULL,'NGC 3463',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75930,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75930,34.01,0.4,63.3,28985,75,NULL,'HMCL, I, inv','NGC 3463',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75931,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75931,34.11,0.43,66.3,28985,75,NULL,'3.6 micron, color corrected','NGC 3463',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75932,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75932,34.14,0.2,67.3,28985,74.4,NULL,NULL,'NGC 3463',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75933,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75933,34.17,0.43,68.2,28985,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3463',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75934,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75934,34.18,0.43,68.6,28985,75,NULL,'MAT, I, inv','NGC 3463',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75935,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75935,37.93,0.27,386,28986,70,NULL,NULL,'SDSS J105515.72+012016.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000149,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,163.8155,1.338,0.081,NULL,60322813421,942543959,14727249,18.2),(75936,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75936,36.6,0.46,209,28987,70,NULL,NULL,'2MASX J10551693+2306460',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000166,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,163.8204583,23.11289,0,NULL,60969886190,952654471,14885226,17),(75937,'IRAS','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75937,33.9,0.8,60.3,28988,75,NULL,'MAT, I','ESO 007- G 002',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'12.66',0.5,'(R\'_2)SB(s)c',NULL,NULL,NULL,NULL,1,163.821333,-85.59247,0.413,NULL,39732961492,620827523,9700430,12.66),(75938,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75938,33.15,0.32,42.7,28988,85,NULL,'I, raw','ESO 007- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75939,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75939,33.17,0.32,43.1,28988,85,NULL,'I, inv','ESO 007- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75940,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75940,33.32,0.43,46.2,28988,75,NULL,'MAT, I, raw','ESO 007- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75941,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75941,33.46,0.43,49.3,28988,75,NULL,'MAT, I, inv','ESO 007- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75942,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75942,33.54,0.5,51.1,28988,NULL,NULL,NULL,'ESO 007- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75943,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75943,33.58,0.2,52,28988,74.4,NULL,NULL,'ESO 007- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75944,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75944,33.59,0.47,52.2,28988,NULL,NULL,'H','ESO 007- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75945,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75945,33.69,0.43,54.7,28988,75,NULL,'MAT, I, cor','ESO 007- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75946,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75946,33.76,0.45,56.5,28988,NULL,NULL,'K','ESO 007- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75947,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75947,33.76,0.46,56.6,28988,NULL,NULL,'J','ESO 007- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75948,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75948,33.86,0.43,59.2,28988,NULL,NULL,'Malmquist cor.','ESO 007- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75949,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75949,34.01,0.4,63.5,28988,NULL,NULL,'mean','ESO 007- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75950,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75950,37.61,0.33,333,28989,70,NULL,NULL,'VII Zw 351',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000096,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,163.822583,65.43825,0.017,NULL,61833359094,966146235,15096034,16.7),(75951,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75951,36.12,0.6,167,28990,70,NULL,NULL,'2MASX J10551775-7959072',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,163.824167,-79.98528,0.345,NULL,39965967496,624468242,9757316,16.6),(75952,'IRAS','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75952,32.2,0.8,27.5,28991,75,NULL,'MAT, I','ESO 437- G 071',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000007,NULL,'13.4R',1.6,'Sb',NULL,NULL,NULL,NULL,1,163.831083333,-30.46975,0.241,NULL,41495684154,648370064,10130782,13.4),(75953,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75953,32.39,0.32,30.1,28991,85,NULL,'I, inv','ESO 437- G 071',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75954,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75954,32.4,0.32,30.2,28991,85,NULL,'I, raw','ESO 437- G 071',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75955,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75955,33.01,0.43,40,28991,75,NULL,'MAT, I, raw','ESO 437- G 071',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75956,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75956,33.06,0.43,40.9,28991,75,NULL,'MAT, I, inv','ESO 437- G 071',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75957,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75957,33.06,0.76,40.9,28991,NULL,NULL,NULL,'ESO 437- G 071',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75958,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75958,33.1,0.2,41.7,28991,74.4,NULL,NULL,'ESO 437- G 071',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75959,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75959,33.28,0.68,45.3,28991,NULL,NULL,'Malmquist cor.','ESO 437- G 071',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75960,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75960,33.33,0.43,46.3,28991,75,NULL,'MAT, I, cor','ESO 437- G 071',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75961,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75961,36.64,0.46,213,28992,70,NULL,NULL,'SDSS J105520.04+055034.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00014,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,163.8335417,5.84281,0.189,NULL,60301930677,942217666,14722151,17.8),(75962,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75962,38.52,0.46,507,28993,70,NULL,NULL,'SDSS J105520.73+161416.8',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.6g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,163.836416667,16.23803,0.029,NULL,61202890558,956295164,14942111,17.6),(75963,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75963,35.27,0.46,113,28994,70,NULL,NULL,'CGCG 125-016',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00019,NULL,'15.5',0.5,NULL,NULL,NULL,NULL,NULL,1,163.837541667,20.76569,0,NULL,61159297910,955614029,14931469,15.5),(75964,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75964,37.61,0.33,333,28995,70,NULL,NULL,'2MASX J10552357+6525118',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000075,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,163.848417,65.41986,0.017,NULL,61833358718,966146229,15096034,17),(75965,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75965,36.82,0.72,231,28996,70,NULL,NULL,'2MASX J10552455-0808088',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,163.852333,-8.13583,0.045,NULL,41782694140,652854595,10200853,16),(75966,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75966,38.25,0.33,448,28997,70,NULL,NULL,'2MASX J10552571+3012428',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000161,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,163.857125,30.21203,0.013,NULL,60509966513,945468226,14772941,17.2),(75967,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75967,38.25,0.33,448,28998,70,NULL,NULL,'2MASX J10552695+3012118',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00017,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,163.8622083,30.20339,0,NULL,60509949975,945467968,14772937,17.3),(75968,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75968,36.94,0.46,245,28999,70,NULL,NULL,'2MASX J10552767+0750102',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000144,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,163.865167,7.83611,0.057,NULL,61031183089,953612235,14900191,16.7),(75969,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75969,36.83,0.46,232,29000,70,NULL,NULL,'2MASX J10552854+2330390',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000197,NULL,'16.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,163.868875,23.51089,0,NULL,60970418071,952662782,14885355,16.4),(75970,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,75970,31.54,0.4,20.3,29001,75,NULL,'B','UGC 06035',NULL,'1988NBGC.C....0000T',1988,1,1.4,'Multiple SDSS entries describe this source.','G',0.000013,NULL,'14.3',1.3,'IBm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,163.8705417,17.14217,0.033,NULL,61200229580,956253587,14941462,14.3),(75971,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75971,37.82,0.46,366,29002,70,NULL,NULL,'2MASX J10552923-0021446',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000082,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,163.8719583,-0.36239,0.089,NULL,40908032406,639188006,9987312,17.9),(75972,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75972,38.34,0.46,466,29003,70,NULL,NULL,'2MASX J10553125+1825310',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,163.880333333,18.42519,0,NULL,61159161174,955611893,14931435,17.7),(75973,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75973,37.93,0.27,386,29004,70,NULL,NULL,'2MASX J10553179+0121384',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,163.882416667,1.36083,0.081,NULL,60322863052,942544735,14727261,17.8),(75974,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75974,37.92,0.46,384,29005,70,NULL,NULL,'2MASX J10553225+5825570',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,163.884208333,58.4325,0,NULL,62005012182,968828315,15137942,17.5),(75975,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75975,36.09,0.46,165,29006,70,NULL,NULL,'CGCG 038-050',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000185,NULL,'15.6g',0.52,'E',NULL,NULL,NULL,NULL,1,163.885375,4.45344,0.105,NULL,60321614851,942525232,14726956,15.6),(75976,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75976,37.99,0.46,396,29007,70,NULL,NULL,'2MASX J10553327+1808580',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.75',0.14,NULL,NULL,NULL,NULL,NULL,1,163.88875,18.14961,0.037,NULL,61158399544,955599992,14931249,18.75),(75977,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75977,36.28,0.46,181,29008,70,NULL,NULL,'2MASX J10553427+0546554',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000146,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,163.89275,5.78194,0.065,NULL,60301918586,942217477,14722148,17),(75978,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75978,36.75,0.46,224,29009,70,NULL,NULL,'2MASX J10553582+4606479',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000172,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,163.899083,46.11344,0,NULL,63912629280,998634832,15603669,16.3),(75979,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75979,38.14,0.46,425,29010,70,NULL,NULL,'2MASX J10553582+4629039',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000176,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,163.89925,46.48428,0,NULL,63911956886,998624326,15603505,17.9),(75980,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75980,36.57,0.46,206,29011,70,NULL,NULL,'2MASX J10553617+2007160',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.48',0.22,NULL,NULL,NULL,NULL,NULL,1,163.900833,20.12103,0,NULL,61159835087,955622423,14931600,16.48),(75981,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75981,35,0.33,100,29012,70,NULL,NULL,'ARK 266',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000145,NULL,'15.4g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,163.9042083,47.57733,0,NULL,63919376532,998740258,15605316,15.4),(75982,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75982,37.73,0.46,352,29013,70,NULL,NULL,'2MASX J10553785+3942244',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000174,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,163.9077083,39.70681,0.005,NULL,64112038469,1001750601,15652353,16.9),(75983,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75983,36.49,0.46,198,29014,70,NULL,NULL,'2MASX J10553795+0547104',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000154,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,163.9082083,5.78636,0.065,NULL,60301918619,942217478,14722148,16.2),(75984,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75984,36.32,0.46,184,29015,70,NULL,NULL,'2MASX J10553806+6107107',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000149,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,163.90875,61.11964,0,NULL,61951457542,967991524,15124867,16.9),(75985,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75985,37.68,0.46,344,29016,70,NULL,NULL,'2MASX J10553896+1228423',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,163.912333,12.47844,0.009,NULL,61148329043,955442641,14928791,17.8),(75986,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75986,31.68,NULL,21.7,29017,NULL,NULL,NULL,'CGCG 038-051',NULL,'2015AstBu..70....1K',2015,1,0.57,NULL,'G',0.000006,NULL,'16.2g',0.26,'WR?            HII',NULL,NULL,NULL,NULL,1,163.913208333,2.39575,0.073,NULL,60325260734,942582198,14727846,16.2),(75987,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75987,37.92,0.46,384,29018,70,NULL,NULL,'2MASX J10553951+2741485',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,163.914666667,27.69697,0,NULL,60487753476,945121148,14767517,17.6),(75988,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75988,37.12,0.46,265,29019,70,NULL,NULL,'2MASX J10554001+5353082',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000131,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,163.91675,53.8855,0,NULL,61973145092,968330392,15130162,17.9),(75989,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75989,37.73,0.33,351,29020,70,NULL,NULL,'2MASX J10554079+3945184',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,163.919875,39.75519,0,NULL,63930683542,998916930,15608077,17.7),(75990,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75990,38.04,0.46,406,29021,70,NULL,NULL,'SDSS J105540.88+575111.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000141,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,163.920333,57.85322,0,NULL,62008202671,968878166,15138721,18.2),(75991,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75991,37.73,0.33,351,29022,70,NULL,NULL,'SDSS J105541.04+394613.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000132,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,163.9210417,39.77039,0,NULL,63930667912,998916686,15608073,18.2),(75992,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75992,37.4,0.46,302,29023,70,NULL,NULL,'2MASX J10554263-0018486',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000094,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,163.9277083,-0.31353,0.089,NULL,40907921030,639186266,9987285,17.3),(75993,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75993,37.77,0.46,358,29024,70,NULL,NULL,'2MASX J10554270+3848084',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,163.928208333,38.80247,0.01,NULL,64106943070,1001670985,15651109,17.5),(75994,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75994,37.57,0.46,327,29025,70,NULL,NULL,'2MASX J10554407+2558275',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,163.933625,25.97444,0,NULL,60498259313,945285301,14770082,17.5),(75995,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75995,36.62,0.46,211,29026,70,NULL,NULL,'2MASX J10554475+3619384',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000172,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,163.936541667,36.32733,0.024,NULL,64106550227,1001664847,15651013,16.7),(75996,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75996,37.4,0.46,301,29027,70,NULL,NULL,'2MASX J10554482+0955262',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.77',0.14,NULL,NULL,NULL,NULL,NULL,1,163.936875,9.92406,0.017,NULL,61034970877,953671419,14901115,18.77),(75997,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75997,35.53,0.33,128,29028,70,NULL,NULL,'CGCG 213-007',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00009,NULL,'15.4g',0.5,'LINER',NULL,NULL,NULL,NULL,1,163.9449583,44.04967,0,NULL,63938843887,999044435,15610069,15.4),(75998,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75998,36.27,0.49,180,29029,75,NULL,'IR','2MFGC 08520',NULL,'2011yCatp016004901K',2011,1,0.56,NULL,'G',0.000087,NULL,'17.04',0.18,NULL,NULL,NULL,NULL,NULL,1,163.948917,9.72447,0.041,NULL,61034856321,953669630,14901087,17.04),(75999,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',75999,38.17,0.33,430,29030,70,NULL,NULL,'2MASX J10554791+5720161',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000159,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,163.9497917,57.33775,0,NULL,62006157408,968846209,15138222,17.3),(76000,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76000,37.8,0.33,364,29031,70,NULL,NULL,'2MASX J10554924+0939376',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,163.955167,9.66036,0.037,NULL,61034850425,953669537,14901086,17.4),(76001,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76001,38.05,0.46,407,29032,70,NULL,NULL,'2MASX J10554968+4829492',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,163.957125,48.49703,0,NULL,63920237500,998753710,15605526,17.8),(76002,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76002,38.3,0.46,458,29033,70,NULL,NULL,'SDSS J105549.76+064729.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000111,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,163.957333,6.79161,0.061,NULL,60302273559,942223024,14722234,18.2),(76003,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76003,37.8,0.33,364,29034,70,NULL,NULL,'SDSS J105550.49+093940.8',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,163.960417,9.66136,0.037,NULL,61034851253,953669550,14901086,18.5),(76004,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76004,36.53,0.46,202,29035,70,NULL,NULL,'2MASX J10555074+3530581',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000165,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,163.9612917,35.516,0.115,NULL,64038713484,1000604898,15634451,16.2),(76005,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76005,36.28,0.46,180,29036,70,NULL,NULL,'2MASX J10555187-0005471',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000089,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,163.9662917,-0.09642,0.117,NULL,40907642135,639181908,9987217,17),(76006,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76006,35.5,0.46,126,29037,70,NULL,NULL,'2MASX J10555276+1857456',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.29',0.25,NULL,NULL,NULL,NULL,NULL,1,163.97,18.96269,0.028,NULL,61158683123,955604423,14931319,16.29),(76007,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 1997aj',NULL,76007,41.34,0.51,1170,29038,74.2,NULL,'SALT 2','SCP J105552.98-035902.3',0.581,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,'Spec',NULL,NULL,NULL,NULL,1,163.97075,-3.98397,0.057,NULL,40930873141,639544892,9992888,NULL),(76008,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 1997aj','R',76008,41.52,NULL,1280,29038,65,NULL,'SALT','SCP J105552.98-035902.3',0.581,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76009,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 1997aj',NULL,76009,41.98,0.42,1570,29038,70,NULL,'SALT','SCP J105552.98-035902.3',0.581,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76010,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 1997aj',NULL,76010,42.07,0.4,1640,29038,65,NULL,'SALT','SCP J105552.98-035902.3',0.581,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76011,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 1997aj',NULL,76011,42.63,0.19,2120,29038,65,NULL,NULL,'SCP J105552.98-035902.3',0.581,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76012,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76012,38.17,0.33,430,29039,70,NULL,NULL,'2MASX J10555459+5726351',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000189,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,163.977667,57.44308,0,NULL,62008195650,968878057,15138719,17),(76013,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76013,35.98,0.46,157,29040,70,NULL,NULL,'2MASX J10555585+2840455',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'16.94',0.22,NULL,NULL,NULL,NULL,NULL,1,163.9827083,28.67944,0,NULL,60519386296,945615410,14775240,16.94),(76014,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 1997P',NULL,76014,41.25,0.52,1210,29041,74.2,NULL,'SALT 2','H-ZSNS J105555.93-035648.2',0.47,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,163.9830417,-3.94672,0.057,NULL,40930738414,639542787,9992856,NULL),(76015,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 1997P','R',76015,41.69,NULL,1480,29041,65,NULL,'SALT','H-ZSNS J105555.93-035648.2',0.47,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76016,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 1997P',NULL,76016,42.1,0.47,1790,29041,70,NULL,'SALT','H-ZSNS J105555.93-035648.2',0.47,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76017,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 1997P',NULL,76017,42.24,0.44,1900,29041,65,NULL,'SALT','H-ZSNS J105555.93-035648.2',0.47,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76018,'SNIa','2016-12-15 15:14:42','2016-12-16 11:19:50','1','SN 1997P',NULL,76018,42.46,0.19,2110,29041,65,NULL,NULL,'H-ZSNS J105555.93-035648.2',0.47,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76019,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76019,38.6,0.46,525,29042,70,NULL,NULL,'2MASX J10555620+0335238',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,163.98425,3.59003,0.169,NULL,60327559591,942618118,14728408,17.4),(76020,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76020,36.07,0.46,164,29043,70,NULL,NULL,'2MASXi J1055577+421741',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,163.99025,42.29475,0,NULL,63929970150,998905783,15607902,16.9),(76021,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76021,36.55,0.46,204,29044,70,NULL,NULL,'2MASX J10560091+1239103',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000155,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,164.00375,12.65292,0.013,NULL,61148611025,955447047,14928860,17.3),(76022,'Tully est','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,76022,32.35,0.8,29.5,29045,75,NULL,'B','NGC 3458',NULL,'1988NBGC.C....0000T',1988,1,1.4,NULL,'G',0.000017,NULL,'13.20',0.9,'SAB:','in a radial-velocity based grouping',NULL,NULL,NULL,1,164.006167,57.11697,0,NULL,62006258777,968847793,15138246,13.2),(76023,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76023,36.67,0.33,216,29046,70,NULL,NULL,'2MASX J10560238+1152196',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000174,NULL,'15.8g',0.42,'E0',NULL,NULL,NULL,NULL,1,164.009916667,11.87219,0.009,NULL,61146373134,955412080,14928313,15.8),(76024,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76024,35.53,0.33,128,29047,70,NULL,NULL,'CGCG 241-041',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000163,NULL,'15.8g',0.32,'S0^-',NULL,NULL,NULL,NULL,1,164.010041667,44.39558,0,NULL,63938620286,999040941,15610014,15.8),(76025,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76025,38.16,0.46,428,29048,70,NULL,NULL,'SDSS J105602.80+561214.7',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,164.011667,56.20411,0,NULL,61993960196,968655628,15135244,17.9),(76026,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76026,37.6,0.46,331,29049,70,NULL,NULL,'SDSS J105604.14+165432.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,164.017291667,16.90894,0.033,NULL,61201032067,956266126,14941658,18),(76027,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76027,37.77,0.46,357,29050,70,NULL,NULL,'2MASX J10560425+3030441',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000143,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,164.0175,30.51219,0,NULL,60509786763,945465418,14772897,17.7),(76028,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76028,36.96,0.27,246,29051,70,NULL,NULL,'2MASX J10560497+0514248',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000183,NULL,'16.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,164.020625,5.24033,0.173,NULL,60321944969,942530390,14727037,16.8),(76029,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76029,36.4,0.46,191,29052,70,NULL,NULL,'2MASX J10560565+0501308',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000173,NULL,'16.2g',0.33,'S0',NULL,NULL,NULL,NULL,1,164.0235417,5.02525,0.173,NULL,60322378979,942537171,14727143,16.2),(76030,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76030,37.37,0.46,298,29053,70,NULL,NULL,'2MASX J10560685+1058226',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000155,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,164.0285,10.97306,0,NULL,61025828911,953528576,14898884,16.6),(76031,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76031,36.95,0.46,246,29054,70,NULL,NULL,'2MASX J10560698+3244095',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000174,NULL,'18.24',0.17,NULL,NULL,NULL,NULL,NULL,1,164.0292917,32.736,0,NULL,60501309186,945332956,14770827,18.24),(76032,'Tully est','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,76032,30.68,0.8,13.7,29055,75,NULL,'B','MRK 1271',NULL,'1988NBGC.C....0000T',1988,1,0.3,'VY Leo (V~6mag) is 2\' to the west.','G',0.00002,NULL,'14.8',0.2,'Compact',NULL,NULL,NULL,NULL,1,164.037917,6.17289,0.061,NULL,60301858199,942216534,14722133,14.8),(76033,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76033,31.84,NULL,23.3,29055,NULL,NULL,NULL,'MRK 1271',NULL,'2015AstBu..70....1K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76034,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76034,36.25,0.46,178,29056,70,NULL,NULL,'2MASXi J1056099+120413',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,164.0412917,12.07039,0.009,NULL,61146390829,955412356,14928318,17),(76035,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76035,38.21,0.46,438,29057,70,NULL,NULL,'2MASX J10561024+3020255',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,164.0427083,30.34036,0,NULL,60509455139,945460236,14772816,17.6),(76036,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76036,38.57,0.46,517,29058,70,NULL,NULL,'2MASX J10561086+2111325',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.43',0.13,NULL,NULL,NULL,NULL,NULL,1,164.045167,21.19233,0,NULL,60970525118,952664454,14885382,18.43),(76037,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76037,36.77,0.46,226,29059,70,NULL,NULL,'2MASX J10561129+0954386',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.22',0.17,NULL,NULL,NULL,NULL,NULL,1,164.046958333,9.91078,0.021,NULL,61034977038,953671516,14901117,18.22),(76038,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76038,38.1,0.46,417,29060,70,NULL,NULL,'2MASX J10561130+2950079',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,164.0470417,29.83561,0,NULL,60509451309,945460176,14772815,17.5),(76039,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76039,36.68,0.46,217,29061,70,NULL,NULL,'2MASX J10561126+0204048',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00017,NULL,'17.0g',0.23,'S0','Group member',NULL,NULL,NULL,1,164.047083,2.06797,0.053,NULL,60326611461,942603304,14728176,17),(76040,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76040,37.98,0.46,395,29062,70,NULL,NULL,'2MASX J10561139+0214178',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.0002,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,164.047458333,2.23833,0.053,NULL,60325722542,942589414,14727959,17.2),(76041,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76041,35.13,0.46,106,29063,70,NULL,NULL,'CGCG 241-043',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000157,NULL,'14.9g',0.56,'E0',NULL,NULL,NULL,NULL,1,164.0475,49.93842,0,NULL,63907164467,998549444,15602335,14.9),(76042,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76042,35.44,0.46,123,29064,70,NULL,NULL,'CGCG 241-044',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000077,NULL,'15.0g',0.46,'S0',NULL,NULL,NULL,NULL,1,164.0489583,46.88069,0,NULL,63911812450,998622069,15603469,15),(76043,'FP','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,'R',76043,36.96,0.27,246,29065,70,NULL,NULL,'SDSS J105612.22+051544.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000233,NULL,'17.0g',0.2,'AGN:',NULL,NULL,NULL,NULL,1,164.050917,5.26239,0.173,NULL,60321955480,942530554,14727039,17),(76044,'IRAS','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,76044,33.25,0.8,44.7,29066,75,NULL,'MAT, I','ESO 437- G 072',NULL,'1997ApJS..109..333W',1997,1,2.35,NULL,'G',0.000033,NULL,'15',0.31,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,164.057125,-31.93817,0.333,NULL,41505582915,648524733,10133198,15),(76045,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,76045,33.31,0.32,45.9,29066,85,NULL,'I, raw','ESO 437- G 072',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76046,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,76046,33.35,0.32,46.7,29066,85,NULL,'I, inv','ESO 437- G 072',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76047,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,76047,33.42,0.43,48.2,29066,75,NULL,'MAT, I, raw','ESO 437- G 072',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76048,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,76048,33.5,0.4,50.2,29066,NULL,NULL,'mean','ESO 437- G 072',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76049,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,76049,33.53,0.47,50.9,29066,NULL,NULL,'H','ESO 437- G 072',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76050,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,76050,33.58,0.43,52.1,29066,75,NULL,'MAT, I, cor','ESO 437- G 072',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76051,'Tully-Fisher','2016-12-15 15:14:42','2016-12-16 11:19:50','1',NULL,NULL,76051,33.59,0.43,52.2,29066,75,NULL,'MAT, I, inv','ESO 437- G 072',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76052,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,NULL,76052,33.6,0.46,52.4,29066,NULL,NULL,'J','ESO 437- G 072',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76053,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,NULL,76053,33.61,0.12,52.8,29066,NULL,NULL,NULL,'ESO 437- G 072',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76054,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76054,33.62,0.49,52.9,29066,75,NULL,'IR','ESO 437- G 072',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76055,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,NULL,76055,33.69,0.45,54.8,29066,NULL,NULL,'K','ESO 437- G 072',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76056,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,NULL,76056,33.78,0.43,57,29066,75,NULL,'3.6 micron, color corrected','ESO 437- G 072',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76057,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,NULL,76057,33.78,0.2,57,29066,74.4,NULL,NULL,'ESO 437- G 072',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76058,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,NULL,76058,33.83,0.43,58.2,29066,75,NULL,'3.6 micron, color + selection bias corrected','ESO 437- G 072',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76059,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,NULL,76059,33.85,NULL,58.9,29066,NULL,NULL,NULL,'ESO 437- G 072',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76060,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,NULL,76060,34.03,NULL,64.1,29066,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 437- G 072',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76061,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,NULL,76061,34.05,NULL,64.5,29066,NULL,NULL,'Dipole + Quadrupole','ESO 437- G 072',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76062,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,NULL,76062,34.07,NULL,65.1,29066,NULL,NULL,'Dipole','ESO 437- G 072',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76063,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76063,36.03,0.46,161,29067,70,NULL,NULL,'2MASX J10561383+2026125',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.00',0.22,NULL,NULL,NULL,NULL,NULL,1,164.057625,20.43694,0,NULL,61167759714,955746245,14933535,16),(76064,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:50','1','SN 1998aw',NULL,76064,41.29,0.11,1260,29068,74.2,NULL,'SALT 2','H-ZSNS J105615.02-041521.5',0.44,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,':',NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,164.062583333,-4.25597,0.013,NULL,40930685692,639541963,9992843,NULL),(76065,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:50','1','SN 1998aw','R',76065,41.85,NULL,1630,29068,65,NULL,'SALT','H-ZSNS J105615.02-041521.5',0.44,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76066,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:50','1','SN 1998aw',NULL,76066,42,0.13,1740,29068,70,NULL,'SALT','H-ZSNS J105615.02-041521.5',0.44,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76067,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:50','1','SN 1998aw',NULL,76067,42.08,0.1,1810,29068,65,NULL,'SALT','H-ZSNS J105615.02-041521.5',0.44,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76068,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76068,37.57,0.33,327,29069,70,NULL,NULL,'2MASX J10561541+4556141',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000187,NULL,'16.1g',0.41,'E0',NULL,NULL,NULL,NULL,1,164.064125,45.93731,0,NULL,63912645578,998635087,15603673,16.1),(76069,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76069,37.9,0.46,380,29070,70,NULL,NULL,'2MASX J10561557+5850417',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000138,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,164.064583,58.84503,0,NULL,61997995162,968718674,15136229,18),(76070,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76070,37.77,0.46,359,29071,70,NULL,NULL,'2MASX J10561645+1635282',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,164.0685,16.59114,0.013,NULL,61200866587,956263540,14941617,17.3),(76071,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76071,37.9,0.33,380,29072,70,NULL,NULL,'SDSS J105617.82+070328.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000131,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,164.0742917,7.05781,0.053,NULL,60302039323,942219364,14722177,18.6),(76072,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76072,38.08,0.46,414,29073,70,NULL,NULL,'SDSS J105621.39-005405.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000075,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,164.089125,-0.90167,0.089,NULL,40907462380,639179099,9987173,18.6),(76073,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76073,38.06,0.46,409,29074,70,NULL,NULL,'SDSS J105621.81+090857.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,164.090917,9.14931,0.073,NULL,61035206606,953675103,14901173,18.3),(76074,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76074,37.1,0.46,263,29075,70,NULL,NULL,'2MASX J10562203+4218074',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.60',0.17,NULL,NULL,NULL,NULL,NULL,1,164.092,42.30219,0,NULL,63929916183,998904940,15607889,17.6),(76075,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76075,36.72,0.46,221,29076,70,NULL,NULL,'2MASX J10562436+3220526',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000188,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,164.1015,32.348,0.007,NULL,60512759021,945511859,14773622,16.9),(76076,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76076,36.96,0.27,246,29077,70,NULL,NULL,'2MASX J10562461+0514391',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000158,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,164.1025,5.24408,0.173,NULL,60321948106,942530439,14727038,16.8),(76077,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76077,38.15,0.33,426,29078,70,NULL,NULL,'SDSS J105624.71+124918.1',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00016,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,164.103,12.82169,0.017,NULL,61148695348,955448364,14928880,17.3),(76078,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76078,37.89,0.46,378,29079,70,NULL,NULL,'2MASX J10562480+1644296',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000192,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,164.1032083,16.74147,0.029,NULL,61200746199,956261659,14941588,16.6),(76079,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76079,35.54,0.46,128,29080,70,NULL,NULL,'VII Zw 352',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000176,NULL,'15.3g',0.51,'E?',NULL,NULL,NULL,NULL,1,164.110167,60.69217,0,NULL,61953763038,968027547,15125430,15.3),(76080,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76080,37.47,0.46,311,29081,70,NULL,NULL,'2MASX J10562701+3005566',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000143,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,164.1125,30.09906,0,NULL,60509488166,945460752,14772824,17.9),(76081,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76081,38.15,0.33,426,29082,70,NULL,NULL,'2MASX J10562947+1253026',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,164.122875,12.88392,0.021,NULL,61148663077,955447860,14928872,17.2),(76082,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76082,37.44,0.46,307,29083,70,NULL,NULL,'2MASX J10562961+1202224',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000159,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,164.1235,12.03956,0.009,NULL,61146346236,955411659,14928307,16.9),(76083,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76083,36.72,0.46,221,29084,70,NULL,NULL,'2MASX J10563094+4222355',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000175,NULL,'15.9g',0.39,'E0',NULL,NULL,NULL,NULL,1,164.129125,42.37653,0,NULL,63930383886,998912248,15608003,15.9),(76084,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76084,37.63,0.46,335,29085,70,NULL,NULL,'2MASX J10563128+1023354',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.57',0.16,NULL,NULL,NULL,NULL,NULL,1,164.13025,10.39303,0.025,NULL,61033914619,953654915,14900858,18.57),(76085,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76085,36.92,0.46,242,29086,70,NULL,NULL,'2MASX J10563139+2932509',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000177,NULL,'16.1g',0.47,'E',NULL,NULL,NULL,NULL,1,164.1309583,29.54744,0,NULL,60519104415,945611006,14775171,16.1),(76086,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76086,37.66,0.46,340,29087,70,NULL,NULL,'2MASX J10563169+1950395',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.43',0.22,NULL,NULL,NULL,NULL,NULL,1,164.1320417,19.84431,0,NULL,61168122771,955751918,14933623,18.43),(76087,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76087,36.02,0.46,160,29088,70,NULL,NULL,'2MASX J10563375+6636550',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00007,NULL,'16.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,164.140667,66.61528,0,NULL,62131204873,970800076,15168751,16.2),(76088,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76088,37.91,0.46,382,29089,70,NULL,NULL,'2MASX J10563487+2853003',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,164.145125,28.88356,0,NULL,60519363556,945615055,14775235,17.9),(76089,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76089,37.47,0.46,312,29090,70,NULL,NULL,'2MASX J10564089+1229486',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000195,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,164.170417,12.49689,0.009,NULL,61148563730,955446308,14928848,16.4),(76090,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76090,37.29,0.33,287,29091,70,NULL,NULL,'2MASX J10564190+0556391',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,164.1745417,5.94414,0.073,NULL,60301799449,942215616,14722119,17.1),(76091,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76091,35.03,0.46,101,29092,70,NULL,NULL,'NGC 3467',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.00009,NULL,'14.43',0.8,'S0','Group member',NULL,NULL,NULL,1,164.183666667,9.75892,0.021,NULL,61035285573,953676337,14901192,14.43),(76092,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76092,37.9,0.33,380,29093,70,NULL,NULL,'2MASX J10564416+0709044',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,164.18425,7.15136,0.053,NULL,60302033584,942219274,14722176,17),(76093,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76093,37.64,0.46,337,29094,70,NULL,NULL,'SDSS J105645.14+090355.4',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,164.188083,9.06542,0.057,NULL,61035010985,953672046,14901125,NULL),(76094,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76094,35.5,0.23,126,29095,70,NULL,NULL,'2MASX J10564586+1714175',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000188,NULL,'15.5g',0.47,NULL,NULL,NULL,NULL,NULL,1,164.191167,17.23825,0.041,NULL,61200320428,956255006,14941484,15.5),(76095,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76095,37.39,0.46,301,29096,70,NULL,NULL,'SDSS J105646.36+003055.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000074,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,164.1932083,0.51558,0.085,NULL,60289757074,942027454,14719178,17.9),(76096,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76096,37.52,0.46,319,29097,70,NULL,NULL,'2MASX J10564684+5634578',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000089,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,164.1954583,56.58286,0,NULL,62005568798,968837012,15138078,17.3),(76097,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,NULL,76097,34.29,0.63,72.2,29098,70,NULL,NULL,'2MFGC 08534',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.7I',0.3,NULL,NULL,NULL,NULL,NULL,1,164.20125,-15.59272,0.153,NULL,41872457792,654257153,10222768,13.7),(76098,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76098,36.67,0.33,216,29099,70,NULL,NULL,'2MASX J10564857+1205358',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000188,NULL,'16.1g',0.31,NULL,NULL,NULL,NULL,NULL,1,164.202416667,12.09325,0.009,NULL,61146334815,955411481,14928304,16.1),(76099,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76099,37.8,0.46,364,29100,70,NULL,NULL,'SDSS J105648.90+052003.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,164.2037917,5.33422,0.173,NULL,60321909622,942529837,14727028,18.5),(76100,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76100,37.29,0.33,287,29101,70,NULL,NULL,'2MASX J10564993+0556125',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000153,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,164.208125,5.93681,0.073,NULL,60301797643,942215588,14722118,17.2),(76101,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76101,38,0.46,397,29102,70,NULL,NULL,'2MASX J10565019+5921378',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000191,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,164.209083,59.36064,0,NULL,61997686801,968713856,15136154,16.8),(76102,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:50','1','SN 1997Q',NULL,76102,39.87,0.73,654,29103,70,NULL,'SALT','H-ZSNS J105651.48-035836.9',0.44,'2008ApJ...686..749K',2008,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'S0',NULL,NULL,NULL,NULL,1,164.2145,-3.97692,0.017,NULL,40932496002,639570250,9993285,NULL),(76103,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:50','1','SN 1997Q',NULL,76103,41.05,0.62,1130,29103,74.2,NULL,'SALT 2','H-ZSNS J105651.48-035836.9',0.44,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76104,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:50','1','SN 1997Q',NULL,76104,41.99,0.18,1740,29103,65,NULL,NULL,'H-ZSNS J105651.48-035836.9',0.44,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76105,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76105,35.55,0.46,129,29104,70,NULL,NULL,'2MASX J10565211+3204041',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00017,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,164.217,32.06781,0.007,NULL,60513273687,945519901,14773748,16.5),(76106,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76106,38.53,0.46,508,29105,70,NULL,NULL,'2MASX J10565252+1416270',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,164.218917,14.27411,0.033,NULL,61191909025,956123578,14939430,18.1),(76107,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76107,36.02,0.46,160,29106,70,NULL,NULL,'2MASX J10565315+4456564',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000182,NULL,'15.8g',0.39,'E/S0',NULL,NULL,NULL,NULL,1,164.221333,44.94908,0,NULL,63908922546,998576914,15602764,15.8),(76108,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76108,37.94,0.46,387,29107,70,NULL,NULL,'2MASX J10565432-0025006',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000111,NULL,'17.4g',0.2,'NLAGN',NULL,NULL,NULL,NULL,1,164.226167,-0.41678,0.089,NULL,40907736671,639183385,9987240,17.4),(76109,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76109,36.88,0.46,237,29108,70,NULL,NULL,'SDSS J105654.49+191032.1',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.2g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,164.227125,19.17561,0,NULL,61166082826,955720044,14933125,17.2),(76110,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76110,36.95,0.46,245,29109,70,NULL,NULL,'2MASX J10565480+0412456',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000146,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,164.228458333,4.21275,0.157,NULL,60319605934,942493842,14726466,17.1),(76111,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76111,37.18,0.46,273,29110,70,NULL,NULL,'2MASX J10565534+0046006',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000076,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,164.23075,0.76669,0.085,NULL,60289616435,942025256,14719144,17.3),(76112,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76112,36.82,0.46,231,29111,70,NULL,NULL,'2MASX J10565569+2316374',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000176,NULL,'17.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,164.231958333,23.27711,0,NULL,60970249697,952660151,14885314,17),(76113,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76113,35.5,0.23,126,29112,70,NULL,NULL,'2MASX J10565590+1706490',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000078,NULL,'15.9g',0.39,NULL,NULL,NULL,NULL,NULL,1,164.233083333,17.11375,0.041,NULL,61200277798,956254340,14941474,15.9),(76114,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,NULL,76114,33.86,0.49,59.1,29113,70,NULL,NULL,'NGC 3469',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000023,NULL,'13.78',1.2,'(R\')SB(r)ab',NULL,NULL,NULL,NULL,1,164.240375,-14.30081,0.113,NULL,41869744846,654214763,10222105,13.78),(76115,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,NULL,76115,33.34,0.69,46.6,29113,100,NULL,'mid-IR','NGC 3469',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76116,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,NULL,76116,34.23,0.47,70,29113,NULL,NULL,'H','NGC 3469',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76117,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,NULL,76117,34.24,0.45,70.4,29113,NULL,NULL,'K','NGC 3469',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76118,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,NULL,76118,34.27,0.46,71.5,29113,NULL,NULL,'J','NGC 3469',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76119,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,NULL,76119,34.31,0.4,72.8,29113,NULL,NULL,'mean','NGC 3469',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76120,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76120,37.36,0.46,296,29114,70,NULL,NULL,'2MASX J10565844+2757553',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,164.2435,27.9655,0,NULL,60487659603,945119681,14767495,17.4),(76121,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:50','1','SN 1996cl','R',76121,43.03,NULL,2210,29115,65,NULL,'SALT','H-ZSNS J105659.13-033736.4',0.8274,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.0005,NULL,'21.57',NULL,'S0/a',NULL,NULL,NULL,NULL,1,164.2462083,-3.62683,0.057,NULL,40932548586,639571071,9993297,21.57),(76122,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:50','1','SN 1996cl',NULL,76122,43.96,0.46,3390,29115,65,NULL,NULL,'H-ZSNS J105659.13-033736.4',0.8274,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76123,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:50','1','SN 1996cl',NULL,76123,44.2,0.61,3790,29115,70,NULL,'SALT','H-ZSNS J105659.13-033736.4',0.8274,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76124,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:50','1','SN 1996cl',NULL,76124,44.36,0.82,4070,29115,65,NULL,'SALT','H-ZSNS J105659.13-033736.4',0.8274,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76125,'SZ effect','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,NULL,76125,40.34,NULL,1170,29116,NULL,NULL,'4.1 (blue) calibration','BLOX J1056.9-0337.3',NULL,'2010ApJ...721..653R',2010,1,NULL,NULL,'GClstr',0.004,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,164.247917,-3.62444,0.057,NULL,40932548601,639571071,9993297,NULL),(76126,'SZ effect','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,NULL,76126,40.62,0.42,1330,29116,NULL,NULL,'Hydrost. Eq.','BLOX J1056.9-0337.3',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76127,'SZ effect','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,NULL,76127,40.7,NULL,1380,29116,NULL,NULL,'3.1 (red) calibration','BLOX J1056.9-0337.3',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76128,'SZ effect','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,NULL,76128,40.99,0.53,1580,29116,NULL,NULL,'Isotherm., r < 100 kpc','BLOX J1056.9-0337.3',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76129,'SZ effect','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,NULL,76129,41.02,0.54,1600,29116,NULL,NULL,'Isotherm.','BLOX J1056.9-0337.3',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76130,'SZ effect','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,NULL,76130,41.05,NULL,1620,29116,NULL,NULL,'4.2 (black) calibration','BLOX J1056.9-0337.3',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76131,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76131,37.57,0.33,327,29117,70,NULL,NULL,'2MASX J10570022+4555508',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000184,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,164.2509583,45.93064,0,NULL,63912351616,998630494,15603601,16.4),(76132,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,NULL,76132,36.1,0.25,166,29118,74.4,NULL,NULL,'2MASX J10570173+0134046',NULL,'2013AJ....146...86T',2013,1,0.43,NULL,'G',0.000019,NULL,'15.9g',0.4,'S0','Group member',NULL,NULL,NULL,1,164.25725,1.56803,0.065,NULL,60326194844,942596794,14728074,15.9),(76133,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76133,36.24,0.13,177,29118,70,NULL,NULL,'2MASX J10570173+0134046',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76134,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76134,38.23,0.46,443,29119,70,NULL,NULL,'2MASX J10570199+1221120',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000186,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,164.2582917,12.35325,0.009,NULL,61146406322,955412598,14928321,16.8),(76135,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76135,36.73,0.27,221,29120,70,NULL,NULL,'2MASX J10570288+0514426',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,164.262125,5.24506,0.173,NULL,60321853416,942528959,14727014,17),(76136,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,NULL,76136,34.76,NULL,89.4,29121,NULL,NULL,'Dipole','FGCE 0850',NULL,'2010Ap&SS.325..163P',2010,1,1.79,NULL,'G',NULL,NULL,'16.7',0.1,'Sd;v.edge-on',NULL,NULL,NULL,NULL,1,164.264167,-70.17586,NULL,NULL,40679961630,635624400,9931631,16.7),(76137,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,NULL,76137,34.77,NULL,89.8,29121,NULL,NULL,'Dipole + Quadrupole + Octopole','FGCE 0850',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76138,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,NULL,76138,34.77,NULL,90,29121,NULL,NULL,'Dipole + Quadrupole','FGCE 0850',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76139,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,NULL,76139,36.17,0.68,171,29122,70,NULL,NULL,'LCRS B105432.4-061249',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'15.02',0.31,NULL,NULL,NULL,NULL,NULL,1,164.266916667,-6.48158,0,NULL,40898396925,639037451,9984960,15.02),(76140,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,NULL,76140,33.92,0.48,60.9,29123,70,NULL,NULL,'ESO 215- G 008',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000083,NULL,'14.45',1,'S0',NULL,NULL,NULL,NULL,1,164.273666667,-48.66139,0.837,NULL,41925298722,655082792,10235668,14.45),(76141,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76141,37.51,0.46,318,29124,70,NULL,NULL,'2MASX J10570592+0244276',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000081,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,164.274583,2.74106,0.089,NULL,60325113347,942579896,14727810,16.9),(76142,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76142,37.54,0.27,322,29125,70,NULL,NULL,'2MASX J10570637+5743365',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,164.276375,57.72692,0,NULL,62008355510,968880554,15138758,17.1),(76143,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76143,36.73,0.27,221,29126,70,NULL,NULL,'2MASX J10570710+0502506',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000207,NULL,'15.9g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,164.279667,5.04731,0.209,NULL,60321825641,942528525,14727008,15.9),(76144,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,NULL,76144,36.15,0.62,170,29127,70,NULL,NULL,'LCRS B105436.7-054625',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'14.91',0.36,NULL,NULL,NULL,NULL,NULL,1,164.285667,-6.04133,0.005,NULL,40897902359,639029724,9984839,14.91),(76145,'FP','2016-12-15 15:14:43','2016-12-16 11:19:50','1',NULL,'R',76145,36.59,0.46,208,29128,70,NULL,NULL,'2MASX J10571018+3718328',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000178,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,164.2922917,37.30931,0,NULL,64109423198,1001709737,15651714,16.2),(76146,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76146,37.99,0.46,396,29129,70,NULL,NULL,'SDSS J105712.41+435511.6',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000157,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,164.30175,43.91992,0,NULL,63939006112,999046970,15610108,18.6),(76147,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76147,36.8,0.46,229,29130,70,NULL,NULL,'2MASX J10571316+3029351',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,164.3049583,30.49297,0,NULL,60511147281,945486676,14773229,17.2),(76148,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76148,37.79,0.46,361,29131,70,NULL,NULL,'SDSS J105714.67+284056.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000129,NULL,'18.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,164.311167,28.68233,0,NULL,60518930958,945608296,14775129,18.4),(76149,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76149,37.54,0.27,322,29132,70,NULL,NULL,'VII Zw 354',NULL,'2015arXiv151105856S',2015,1,0.32,'Companion superposed 10 arcsec southeast.','G',0.000182,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,164.3127083,57.75747,0,NULL,62008387371,968881052,15138766,16.9),(76150,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76150,35.26,0.46,113,29133,70,NULL,NULL,'2MASX J10571605+1812053',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.55',0.3,NULL,NULL,NULL,NULL,NULL,1,164.317,18.20147,0,NULL,61165584146,955712252,14933003,16.55),(76151,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1998ax',NULL,76151,41.61,0.17,1400,29134,74.2,NULL,'SALT 2','H-ZSNS J105716.38-033359.2',0.5,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,164.31825,-3.56644,0.057,NULL,40933002916,639578170,9993408,NULL),(76152,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1998ax','R',76152,41.67,NULL,1440,29134,65,NULL,'SALT','H-ZSNS J105716.38-033359.2',0.5,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76153,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1998ax',NULL,76153,42.41,0.16,2020,29134,70,NULL,'SALT','H-ZSNS J105716.38-033359.2',0.5,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76154,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1998ax',NULL,76154,42.56,0.13,2160,29134,65,NULL,'SALT','H-ZSNS J105716.38-033359.2',0.5,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76155,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76155,36.96,0.46,247,29135,70,NULL,NULL,'2MASX J10571906+5537586',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000098,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,164.329125,55.63283,0,NULL,61964488193,968195128,15128048,17.6),(76156,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1997R',NULL,76156,42.26,0.67,1720,29136,74.2,NULL,'SALT 2','H-ZSNS J105719.23-035451.7',0.65,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'Sab',NULL,NULL,NULL,NULL,1,164.330125,-3.91436,0.017,NULL,40932573833,639571466,9993304,NULL),(76157,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1997R','R',76157,42.42,NULL,1850,29136,65,NULL,'SALT','H-ZSNS J105719.23-035451.7',0.65,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76158,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1997R',NULL,76158,43.08,0.55,2500,29136,70,NULL,'SALT','H-ZSNS J105719.23-035451.7',0.65,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76159,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1997R',NULL,76159,43.23,0.52,2680,29136,65,NULL,'SALT','H-ZSNS J105719.23-035451.7',0.65,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76160,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1997R',NULL,76160,43.27,0.2,2730,29136,65,NULL,NULL,'H-ZSNS J105719.23-035451.7',0.65,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76161,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76161,37.47,0.46,312,29137,70,NULL,NULL,'2MASX J10571946+0208519',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,164.331208333,2.14769,0.093,NULL,60326484171,942601315,14728145,17.2),(76162,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76162,37.57,0.46,327,29138,70,NULL,NULL,'SDSS J105720.60+610838.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000159,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,164.335875,61.14411,0,NULL,61831644559,966119446,15095616,18.6),(76163,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76163,38.04,0.33,405,29139,70,NULL,NULL,'SDSS J105720.98+064230.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000148,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,164.337458333,6.70836,0.037,NULL,60305047326,942266364,14722911,18.6),(76164,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76164,36.53,0.46,202,29140,70,NULL,NULL,'2MASX J10572145+2105443',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,164.339333,21.09556,0,NULL,61154243074,955535048,14930235,17.6),(76165,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1998ay','R',76165,42.17,NULL,1660,29141,65,NULL,'SALT','H-ZSNS J105721.51-031449.9',0.64,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,164.339625,-3.24719,0.069,NULL,40932886160,639576346,9993380,NULL),(76166,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1998ay',NULL,76166,42.45,0.19,1880,29141,74.2,NULL,'SALT 2','H-ZSNS J105721.51-031449.9',0.64,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76167,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1998ay',NULL,76167,43.19,0.19,2650,29141,70,NULL,'SALT','H-ZSNS J105721.51-031449.9',0.64,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76168,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1998ay',NULL,76168,43.3,0.36,2790,29141,65,NULL,NULL,'H-ZSNS J105721.51-031449.9',0.64,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76169,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1998ay',NULL,76169,43.37,0.16,2870,29141,65,NULL,'SALT','H-ZSNS J105721.51-031449.9',0.64,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76170,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76170,36.73,0.27,221,29142,70,NULL,NULL,'2MASX J10572294+0512079',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000173,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,164.3454583,5.20228,0.209,NULL,60320721710,942511276,14726738,16.4),(76171,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76171,37.52,0.46,320,29143,70,NULL,NULL,'2MASX J10572478+3304259',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000192,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,164.353333,33.07408,0,NULL,60501399717,945334370,14770849,17),(76172,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76172,35.95,0.27,155,29144,70,NULL,NULL,'CGCG 066-069',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000157,NULL,'15.5',0.31,NULL,NULL,NULL,NULL,NULL,1,164.3682083,9.53792,0.033,NULL,61035357568,953677462,14901210,15.5),(76173,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76173,36.49,0.63,199,29145,70,NULL,NULL,'2MASX J10572962-4719121',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,164.373417,-47.32008,0.737,NULL,41922357561,655036836,10234950,16.9),(76174,'TRGB','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76174,28.55,0.1,5.13,29146,NULL,NULL,NULL,'ESO 215- G 009',NULL,'2012A&A...540A..49M',2012,1,6.6,'Extended HIPASS source','G',0.000003,NULL,'16.03',5.5,'SAB(s)m:',NULL,NULL,NULL,NULL,1,164.374583,-48.17861,0.845,NULL,41926245281,655097582,10235899,16.03),(76175,'TRGB','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76175,28.6,0.03,5.25,29146,NULL,NULL,'I','ESO 215- G 009',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76176,'TRGB','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76176,28.6,NULL,5.25,29146,NULL,NULL,NULL,'ESO 215- G 009',NULL,'2007AJ....133..504K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76177,'TRGB','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76177,28.69,0.1,5.47,29146,74.4,NULL,NULL,'ESO 215- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76178,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76178,37.22,0.46,278,29147,70,NULL,NULL,'2MASX J10573076+1920533',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.32',0.18,NULL,NULL,NULL,NULL,NULL,1,164.37825,19.34822,0,NULL,61166106107,955720407,14933131,18.32),(76179,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76179,35.16,0.33,108,29148,70,NULL,NULL,'NGC 3468',NULL,'2015arXiv151105856S',2015,1,1.39,'RC3 gives v = 2468 +/- 9 km/sec.','G',0.000053,NULL,'13.9g',0.8,'S0',NULL,NULL,NULL,NULL,1,164.379875,40.94614,0,NULL,63931475820,998929309,15608270,13.9),(76180,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76180,38.04,0.33,405,29149,70,NULL,NULL,'2MASX J10573118+0639371',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000176,NULL,'15.9g',0.43,'E0',NULL,NULL,NULL,NULL,1,164.379917,6.66047,0.049,NULL,60305040255,942266253,14722910,15.9),(76181,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1997am','R',76181,40.94,NULL,1090,29150,65,NULL,'SALT','SCP J105731.52-031348.3',0.416,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,'Spec/Irr',NULL,NULL,NULL,NULL,1,164.381333,-3.23008,0.069,NULL,40932769803,639574528,9993352,NULL),(76182,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1997am',NULL,76182,41.72,0.57,1560,29150,74.2,NULL,'SALT 2','SCP J105731.52-031348.3',0.416,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76183,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1997am',NULL,76183,42.04,0.44,1810,29150,70,NULL,'SALT','SCP J105731.52-031348.3',0.416,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76184,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1997am',NULL,76184,42.1,0.19,1860,29150,65,NULL,NULL,'SCP J105731.52-031348.3',0.416,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76185,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1997am',NULL,76185,42.23,0.41,1970,29150,65,NULL,'SALT','SCP J105731.52-031348.3',0.416,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76186,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76186,37.8,0.14,362,29151,70,NULL,NULL,'2MASX J10573163+2150593',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,164.3817083,21.84992,0,NULL,60971468275,952679191,14885612,17.4),(76187,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76187,38.62,0.46,529,29152,70,NULL,NULL,'SDSS J105732.09+071647.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000138,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,164.3837083,7.27986,0.053,NULL,60303927448,942248866,14722638,18.5),(76188,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76188,37.2,0.33,276,29153,70,NULL,NULL,'2MASX J10573223+1211499',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000191,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,164.384417,12.19711,0.009,NULL,61146638241,955416222,14928378,16.5),(76189,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76189,36.06,0.25,163,29154,74.4,NULL,NULL,'2MASX J10573288+0137170',NULL,'2013AJ....146...86T',2013,1,0.31,NULL,'G',0.000022,NULL,'16.7g',0.27,'E','Group member',NULL,NULL,NULL,1,164.387125,1.62144,0.069,NULL,60326177009,942596515,14728070,16.7),(76190,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76190,36.45,0.46,195,29154,70,NULL,NULL,'2MASX J10573288+0137170',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76191,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76191,34.22,0.62,69.7,29155,70,NULL,NULL,'ESO 264- G 055',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000113,NULL,'15.51',0.4,'S0',NULL,NULL,NULL,NULL,1,164.3919583,-47.73078,0.845,NULL,41925963008,655093172,10235830,15.51),(76192,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76192,37.09,0.33,262,29156,70,NULL,NULL,'2MASX J10573469+4008263',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00019,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,164.394708333,40.14078,0,NULL,63930717927,998917467,15608085,16.4),(76193,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76193,36.14,0.33,169,29157,70,NULL,NULL,'2MASX J10573696+2353523',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000196,NULL,'15.6g',0.42,NULL,NULL,NULL,NULL,NULL,1,164.404167,23.89783,0,NULL,60970046493,952656976,14885265,15.6),(76194,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76194,35.7,0.46,138,29158,70,NULL,NULL,'2MASX J10573709+4538042',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000087,NULL,'15.4g',0.55,'S0^-',NULL,NULL,NULL,NULL,1,164.4047083,45.63442,0,NULL,63912381848,998630966,15603608,15.4),(76195,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76195,32.3,NULL,28.8,29159,NULL,NULL,NULL,'LSBC F640-V02',NULL,'2015AstBu..70....1K',2015,1,0.51,NULL,'G',0.00002,NULL,'17.5g',0.19,'Irr',NULL,NULL,NULL,NULL,1,164.4089583,13.97903,0.029,NULL,61147644899,955431951,14928624,17.5),(76196,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76196,37.19,0.46,275,29160,70,NULL,NULL,'2MASX J10573822+5514306',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000175,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,164.409375,55.242,0,NULL,61963974455,968187100,15127923,17.9),(76197,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76197,33.93,0.4,61.2,29161,NULL,NULL,'mean','ESO 502-IG 006',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00004,NULL,'14.5',0.8,'S...','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,164.4095,-25.50486,0.289,NULL,41522670328,648791723,10137370,14.5),(76198,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76198,34.36,0.47,74.5,29161,NULL,NULL,'H','ESO 502-IG 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76199,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76199,36.64,0.46,212,29162,70,NULL,NULL,'2MASX J10573847+3718313',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000221,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,164.410166667,37.30878,0,NULL,64109414524,1001709601,15651712,16.5),(76200,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76200,37.68,0.46,344,29163,70,NULL,NULL,'2MASX J10573919+3810063',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000171,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,164.413375,38.16833,0,NULL,63923742061,998808469,15606382,17.7),(76201,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76201,36.36,0.46,187,29164,70,NULL,NULL,'2MASX J10573929+2729374',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000183,NULL,'15.3g',0.59,NULL,NULL,NULL,NULL,NULL,1,164.413791667,27.49367,0,NULL,60487899885,945123435,14767553,15.3),(76202,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76202,37.2,0.33,276,29165,70,NULL,NULL,'2MASX J10573945+1211218',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00019,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,164.4142917,12.18944,0.009,NULL,61146638857,955416232,14928378,16.3),(76203,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76203,38.78,0.46,570,29166,70,NULL,NULL,'2MASX J10573946+0746101',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000147,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,164.4145,7.76956,0.053,NULL,61028905809,953576653,14899635,17.3),(76204,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76204,35.95,0.27,155,29167,70,NULL,NULL,'2MASX J10573951+0935141',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.12',0.19,NULL,NULL,NULL,NULL,NULL,1,164.4147917,9.58725,0.033,NULL,61035356932,953677452,14901210,17.12),(76205,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76205,37.74,0.27,353,29168,70,NULL,NULL,'SDSS J105740.00+104016.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000177,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,164.4167083,10.67136,0.017,NULL,61033846230,953653847,14900841,18.2),(76206,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76206,37.74,0.27,353,29169,70,NULL,NULL,'2MASX J10574015+1037511',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,164.417167,10.63094,0.017,NULL,61033856848,953654013,14900843,17.6),(76207,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76207,35.52,0.46,127,29170,70,NULL,NULL,'CGCG 038-063',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000149,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,164.421333,6.08286,0.073,NULL,60305228373,942269193,14722956,16.2),(76208,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76208,37.4,0.46,302,29171,70,NULL,NULL,'2MASX J10574152+4750202',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000152,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,164.423166667,47.83897,0,NULL,63920614972,998759608,15605618,16.8),(76209,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76209,37.8,0.14,362,29172,70,NULL,NULL,'2MASX J10574190+2153483',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,164.424625,21.89681,0,NULL,60971469028,952679203,14885612,17.7),(76210,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76210,37.74,0.27,353,29173,70,NULL,NULL,'2MASX J10574225+1036231',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000103,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,164.426167,10.60636,0.013,NULL,61033843434,953653803,14900840,16.2),(76211,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76211,35.97,0.33,156,29174,70,NULL,NULL,'CGCG 184-039',NULL,'2015arXiv151105856S',2015,1,0.98,NULL,'G',0.000087,NULL,'14.6g',0.71,NULL,NULL,NULL,NULL,NULL,1,164.426917,37.65453,0,NULL,64107340014,1001677187,15651206,14.6),(76212,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76212,38.25,0.46,448,29175,70,NULL,NULL,'2MASX J10574272+6037127',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000196,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,164.427875,60.62019,0,NULL,61953697513,968026523,15125414,17.2),(76213,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76213,37.92,0.46,383,29176,70,NULL,NULL,'2MASX J10574297+0952561',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'18.24',0.14,NULL,NULL,NULL,NULL,NULL,1,164.429,9.88214,0.021,NULL,61035433832,953678653,14901228,18.24),(76214,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76214,36.24,0.13,177,29177,70,NULL,NULL,'2MASX J10574342+0134020',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000019,NULL,'15.5g',0.45,'S0','Group member',NULL,NULL,NULL,1,164.430916667,1.56733,0.069,NULL,60326158034,942596219,14728065,15.5),(76215,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76215,36.65,0.25,214,29177,74.4,NULL,NULL,'2MASX J10574342+0134020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76216,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76216,34.42,0.48,76.7,29178,70,NULL,NULL,'2MASX J10574751-4750338',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000103,NULL,'14.4B',0.9,'E-S0',NULL,NULL,NULL,NULL,1,164.448083,-47.84278,0.845,NULL,41925914162,655092408,10235818,14.4),(76217,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76217,37.09,0.33,262,29179,70,NULL,NULL,'2MASX J10574925+4007222',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00021,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,164.4552083,40.12278,0,NULL,63930758576,998918102,15608095,16.2),(76218,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76218,37.71,0.46,348,29180,70,NULL,NULL,'2MASX J10574985+1250518',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000175,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,164.45775,12.84783,0.009,NULL,61147863253,955435363,14928677,17.1),(76219,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76219,33.31,0.48,45.9,29181,70,NULL,NULL,'ESO 569- G 027',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000103,NULL,'14.00',0.8,'(R\'_1)SB(r)0/a','in a pair',NULL,NULL,NULL,1,164.4615,-20.00164,0.125,NULL,41856716183,654011190,10218924,14),(76220,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76220,38.13,0.46,422,29182,70,NULL,NULL,'SDSS J105751.25+012807.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000144,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,164.4635417,1.46867,0.069,NULL,60326150632,942596103,14728064,18.3),(76221,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76221,36.76,0.16,225,29183,70,NULL,NULL,'2MASX J10575133+2939084',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000163,NULL,'15.9g',0.46,'E',NULL,NULL,NULL,NULL,1,164.4639583,29.65233,0,NULL,60507578638,945430916,14772358,15.9),(76222,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76222,38.2,0.46,437,29184,70,NULL,NULL,'2MASX J10575172+0704305',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,164.465333,7.07517,0.045,NULL,60305136207,942267753,14722933,18.1),(76223,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76223,36.35,0.46,186,29185,70,NULL,NULL,'2MASX J10575169+4149512',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000158,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,164.4655,41.83083,0,NULL,63933533230,998961456,15608772,17),(76224,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76224,37.54,0.27,322,29186,70,NULL,NULL,'2MASX J10575205+5753485',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000187,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,164.4670417,57.89678,0,NULL,62007873846,968873028,15138641,16.9),(76225,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76225,36.14,0.33,169,29187,70,NULL,NULL,'SDSS J105752.91+235120.8',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',NULL,NULL,'15.3g',0.45,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,164.4705,23.85578,0,NULL,60970105881,952657904,14885279,15.3),(76226,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76226,35.97,0.33,156,29188,70,NULL,NULL,'MCG +06-24-041',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000103,NULL,'15.4g',0.53,'AGN',NULL,NULL,NULL,NULL,1,164.474833,37.54192,0,NULL,63923562484,998805663,15606338,15.4),(76227,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76227,37.19,0.46,274,29189,70,NULL,NULL,'SDSS J105754.10+192301.9',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.2g',0.35,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,164.4754583,19.38389,0,NULL,61166272679,955723010,14933172,16.2),(76228,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76228,36.54,0.27,204,29190,70,NULL,NULL,'VII Zw 356',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000091,NULL,'16.5g',0.35,'NLAGN',NULL,NULL,NULL,'Sy 2',1,164.477791667,66.99719,0,NULL,62130520941,970789389,15168584,16.5),(76229,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76229,36.24,0.13,177,29191,70,NULL,NULL,'2MASX J10575534+0143358',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000213,NULL,'17.00',0.3,'S0','Group member',NULL,NULL,NULL,1,164.4807083,1.72667,0.069,NULL,60324100931,942564077,14727563,17),(76230,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76230,36.73,0.46,222,29192,70,NULL,NULL,'SDSS J105755.66+214805.0',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.1g',0.38,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,164.481958333,21.80142,0,NULL,60971430522,952678601,14885603,16.1),(76231,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76231,38.12,0.46,420,29193,70,NULL,NULL,'SDSS J105757.49+062128.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000118,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,164.4895417,6.35789,0.049,NULL,60305382351,942271599,14722993,18.4),(76232,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76232,36.07,0.44,164,29194,NULL,NULL,'Malmquist cor.','SDSS J105757.82+013921.3',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000023,NULL,'17.3g',0.14,'Sc',NULL,NULL,NULL,NULL,1,164.490917,1.65592,0.069,NULL,60324090342,942563911,14727561,17.3),(76233,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76233,36.1,0.44,166,29194,NULL,NULL,NULL,'SDSS J105757.82+013921.3',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76234,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76234,36.14,0.2,169,29194,74.4,NULL,NULL,'SDSS J105757.82+013921.3',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76235,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76235,35.16,0.33,108,29195,70,NULL,NULL,'CGCG 213-011',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.00006,NULL,'15.2g',0.44,'E0',NULL,NULL,NULL,NULL,1,164.497125,40.82794,0,NULL,63931460509,998929070,15608266,15.2),(76236,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76236,38.64,0.46,535,29196,70,NULL,NULL,'SDSS J105759.88+365801.1',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,164.4995417,36.967,0,NULL,64106053295,1001657082,15650891,17.6),(76237,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76237,35.19,0.59,109,29197,70,NULL,NULL,'ESO 569- G 029',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'15.05',1.2,'SA(rs)b:',NULL,NULL,NULL,NULL,1,164.500375,-18.42758,0.125,NULL,41855217842,653987778,10218559,15.05),(76238,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76238,37.57,0.46,327,29198,70,NULL,NULL,'SDSS J105800.10+071931.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000136,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,164.5004583,7.32544,0.049,NULL,60303888643,942248260,14722629,17.8),(76239,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76239,38.63,0.46,533,29199,70,NULL,NULL,'SDSS J105800.31+211137.3',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.8g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,164.501333,21.19372,0,NULL,61154089435,955532647,14930197,17.8),(76240,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76240,37.31,0.46,290,29200,70,NULL,NULL,'2MASX J10580070+2020248',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.81',0.18,NULL,NULL,NULL,NULL,NULL,1,164.503125,20.34011,0,NULL,61168636545,955759946,14933749,17.81),(76241,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76241,37.1,0.46,263,29201,70,NULL,NULL,'2MASX J10580131+3914186',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000185,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,164.505625,39.23847,0,NULL,63923506822,998804794,15606324,17.2),(76242,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76242,37.31,0.46,289,29202,70,NULL,NULL,'2MASX J10580145+3022564',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,164.505916667,30.38247,0,NULL,60511175286,945487113,14773236,17.6),(76243,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76243,30.34,NULL,11.7,29203,NULL,NULL,NULL,'CGCG 095-078',NULL,'2015AstBu..70....1K',2015,1,0.64,'Multiple SDSS entries describe this object.','G',NULL,NULL,'15.6',0.31,NULL,NULL,NULL,NULL,NULL,1,164.506708333,19.50561,0,NULL,61169186271,955768535,14933883,15.6),(76244,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76244,37.52,0.33,319,29204,70,NULL,NULL,'2MASX J10580160+1944138',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.70',0.19,'AGN',NULL,NULL,NULL,NULL,1,164.506708333,19.73722,0,NULL,61169172295,955768317,14933879,18.7),(76245,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76245,36.24,0.13,177,29205,70,NULL,NULL,'2MASX J10580162+0138058',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000171,NULL,'16.2g',0.4,'S0','Group member',NULL,NULL,NULL,1,164.506833333,1.63483,0.069,NULL,60324109966,942564218,14727565,16.2),(76246,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76246,35.94,0.46,154,29206,70,NULL,NULL,'2MASX J10580219+0809425',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000146,NULL,'15.8g',0.34,'S0/a',NULL,NULL,NULL,NULL,1,164.5090417,8.16175,0.029,NULL,61029207451,953581366,14899708,15.8),(76247,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76247,35.68,0.46,137,29207,70,NULL,NULL,'2MASX J10580242+3640047',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000155,NULL,'16.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,164.510125,36.66789,0.005,NULL,64106157830,1001658716,15650917,16),(76248,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76248,37.81,0.46,364,29208,70,NULL,NULL,'2MASX J10580242+2000248',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.08',0.18,NULL,NULL,NULL,NULL,NULL,1,164.510291667,20.00697,0,NULL,61168024403,955750381,14933599,18.08),(76249,'CMD','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76249,16.9,0.23,0.024,29209,NULL,NULL,NULL,'SDSS J105803.14+284233.8',NULL,'2008A&A...477..139L',2008,1,0.03,NULL,'G',NULL,NULL,'21.9g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,164.513125,28.70939,0,1,60516165176,945565080,14774454,21.9),(76250,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76250,36.03,0.49,161,29210,70,NULL,NULL,'IC 0659',NULL,'2014MNRAS.445.2677S',2014,1,1.4,'MCG decs for MCG -01-28 field are 10 arcmin too far north (MCG4 errata).','G',0.000143,NULL,'15.17',1,'E+',NULL,NULL,NULL,NULL,1,164.516083,-6.26053,0,NULL,40898128593,639033259,9984894,15.17),(76251,'BCG','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76251,36.95,0.35,237,29211,60,NULL,NULL,'ABELL 1139',0.0376,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,164.5177917,1.49878,0.069,NULL,60324054705,942563354,14727552,NULL),(76252,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76252,36.23,0.11,177,29211,70,NULL,NULL,'ABELL 1139',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76253,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76253,37.81,0.46,365,29212,70,NULL,NULL,'SDSS J105804.86+371910.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000161,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,164.5202917,37.31953,0,NULL,63921717554,998776836,15605888,18.6),(76254,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76254,34.83,0.49,92.4,29213,75,NULL,'IR','MCG -01-28-011',NULL,'2011yCatp016004901K',2011,1,1.55,'MCG decs for MCG -01-28 field are 10 arcmin too far north (MCG4 errata).','G',0.00003,NULL,'15',0.13,'Sc',NULL,NULL,NULL,NULL,1,164.523875,-4.75914,0.021,NULL,40929576215,639524628,9992572,15),(76255,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76255,35.04,NULL,102,29213,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -01-28-011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76256,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76256,35.05,NULL,102,29213,NULL,NULL,'Dipole + Quadrupole','MCG -01-28-011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76257,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76257,35.05,NULL,103,29213,NULL,NULL,'Dipole','MCG -01-28-011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76258,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76258,35.09,0.2,104,29213,74.4,NULL,NULL,'MCG -01-28-011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76259,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76259,35.16,0.33,108,29213,NULL,NULL,'Malmquist cor.','MCG -01-28-011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76260,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76260,35.21,0.32,110,29213,NULL,NULL,NULL,'MCG -01-28-011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76261,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76261,36.51,0.46,201,29214,70,NULL,NULL,'2MASX J10580673+4016137',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000168,NULL,'16.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,164.5279583,40.27042,0,NULL,63931584713,998931011,15608297,16.1),(76262,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76262,38.53,0.46,508,29215,70,NULL,NULL,'SDSS J105807.16+584435.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,164.529833,58.74333,0,NULL,61997515840,968711185,15136112,18.4),(76263,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76263,35.95,0.27,155,29216,70,NULL,NULL,'NGC 3476',NULL,'2015arXiv151105856S',2015,1,0.81,'Identification as NGC 3480 is not certain.','G',0.000157,NULL,'14.7g',0.72,'E',NULL,NULL,NULL,NULL,1,164.531667,9.27614,0.037,NULL,61033028988,953641077,14900641,14.7),(76264,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76264,37.97,0.46,393,29217,70,NULL,NULL,'SDSS J105807.64+004122.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000071,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,164.531875,0.68969,0.089,NULL,60292730837,942073919,14719904,18.4),(76265,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76265,35.5,0.23,126,29218,70,NULL,NULL,'NGC 3474',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.0001,NULL,'14.7g',0.58,'S?','in a pair',NULL,NULL,NULL,1,164.5365,17.09569,0,NULL,61196868048,956201063,14940641,14.7),(76266,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76266,37.86,0.46,374,29219,70,NULL,NULL,'2MASX J10580938+0045548',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00008,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,164.539125,0.76514,0.089,NULL,60292402741,942068792,14719824,17.3),(76267,'BCG','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76267,36.95,0.35,237,29220,60,NULL,'ABELL 1139, BCG','UGC 06057 NED02',0.0376,'1980ApJ...241..486H',1980,1,1.74,NULL,'G',0.000019,NULL,'15.61',1.26,'BrClG','Group member',NULL,NULL,NULL,1,164.5457917,1.60458,0.069,NULL,60324065300,942563520,14727555,15.61),(76268,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76268,36.08,0.25,164,29220,74.4,NULL,NULL,'UGC 06057 NED02',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76269,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76269,36.23,0.11,177,29220,70,NULL,'ABELL 1139, BGC','UGC 06057 NED02',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76270,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76270,37.3,0.46,289,29221,70,NULL,NULL,'2MASX J10581202+1153191',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000131,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,164.55025,11.88881,0.025,NULL,61145798925,955403108,14928173,18.4),(76271,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76271,33.99,NULL,62.8,29222,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06054',NULL,'2010Ap&SS.325..163P',2010,1,1.29,'Star superposed near nucleus.','G',0.000004,NULL,'16.10',0.11,'Sd',NULL,NULL,NULL,NULL,1,164.5527917,20.10614,0,NULL,61168021500,955750335,14933598,16.1),(76272,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76272,34.01,NULL,63.4,29222,NULL,NULL,'Dipole + Quadrupole','UGC 06054',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76273,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76273,34.01,NULL,63.5,29222,NULL,NULL,'Dipole','UGC 06054',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76274,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76274,36.83,0.25,232,29223,74.4,NULL,NULL,'UGC 06057 NED01',NULL,'2013AJ....146...86T',2013,1,0.37,NULL,'G',0.000069,NULL,'15.3g',0.3,'E','Group member',NULL,NULL,NULL,1,164.554333,1.60686,0.069,NULL,60324058134,942563408,14727553,15.3),(76275,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76275,37.28,0.46,285,29224,70,NULL,NULL,'2MASX J10581384+3950287',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000138,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,164.557583,39.84147,0,NULL,63934988236,998984191,15609127,17.3),(76276,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76276,37.63,0.23,336,29225,70,NULL,NULL,'2MASX J10581518+2934061',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000174,NULL,'18.27',0.14,NULL,NULL,NULL,NULL,NULL,1,164.563375,29.56844,0,NULL,60515895235,945560863,14774388,18.27),(76277,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76277,36.24,0.13,177,29226,70,NULL,NULL,'2MASX J10581523+0136578',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000019,NULL,'15.5g',0.46,'E','Group member',NULL,NULL,NULL,1,164.563458333,1.61581,0.069,NULL,60324112480,942564257,14727566,15.5),(76278,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76278,36.38,0.25,189,29226,74.4,NULL,NULL,'2MASX J10581523+0136578',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76279,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76279,35.5,0.23,126,29227,70,NULL,NULL,'2MASX J10581568+1738251',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.81',0.19,NULL,NULL,NULL,NULL,NULL,1,164.565541667,17.64042,0,NULL,61196193702,956190526,14940476,17.81),(76280,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76280,37.48,0.33,313,29228,70,NULL,NULL,'2MASX J10581597+2052267',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,164.5664583,20.87403,0,NULL,61167777132,955746517,14933539,17.9),(76281,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76281,36.28,0.46,181,29229,70,NULL,NULL,'2MASX J10581739+2651221',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000178,NULL,'15.9g',0.33,NULL,NULL,NULL,NULL,NULL,1,164.5725,26.85611,0,NULL,60487382574,945115352,14767427,15.9),(76282,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76282,35.89,0.43,151,29230,NULL,NULL,NULL,'2MASX J10581762+0108303',NULL,'2009ApJS..182..474S',2009,1,0.35,NULL,'G',0.000059,NULL,'16.8g',0.17,'Sc','Group member',NULL,NULL,NULL,1,164.5735,1.14189,0.065,NULL,60292576655,942071510,14719867,16.8),(76283,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76283,35.92,0.43,153,29230,NULL,NULL,'Malmquist cor.','2MASX J10581762+0108303',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76284,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76284,35.93,0.2,153,29230,74.4,NULL,NULL,'2MASX J10581762+0108303',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76285,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76285,37.51,0.46,318,29231,70,NULL,NULL,'2MASX J10581827+1009586',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,164.576166667,10.16633,0.005,NULL,61034532169,953664565,14901008,17.3),(76286,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76286,37.64,0.46,338,29232,70,NULL,NULL,'SDSS J105818.57+165936.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000132,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,164.577417,16.99347,0,NULL,61196401055,956193766,14940527,18.2),(76287,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76287,38.35,0.46,469,29233,70,NULL,NULL,'SDSS J105819.55+071925.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,164.5815,7.32389,0.049,NULL,60304106776,942251668,14722682,18),(76288,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76288,36.33,0.43,185,29234,NULL,NULL,'Malmquist cor.','2MASX J10581962+0133363',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000023,NULL,'17.0g',0.14,'S0/S','Group member',NULL,NULL,NULL,1,164.5817917,1.56008,0.069,NULL,60324059643,942563431,14727553,17),(76289,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76289,36.57,0.39,206,29234,NULL,NULL,NULL,'2MASX J10581962+0133363',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76290,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76290,36.61,0.2,210,29234,74.4,NULL,NULL,'2MASX J10581962+0133363',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76291,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76291,37.52,0.33,319,29235,70,NULL,NULL,'2MASX J10581982+1945038',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.74',0.27,NULL,NULL,NULL,NULL,NULL,1,164.5825417,19.75125,0,NULL,61169167722,955768245,14933878,17.74),(76292,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76292,36.69,0.46,218,29236,70,NULL,NULL,'2MASX J10582140+0339263',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000191,NULL,'15.6g',0.51,'E',NULL,NULL,NULL,NULL,1,164.589125,3.65719,0.125,NULL,60330665661,942666650,14729166,15.6),(76293,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76293,36.76,0.16,225,29237,70,NULL,NULL,'2MASX J10582161+2938391',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000182,NULL,'15.9g',0.4,'E',NULL,NULL,NULL,NULL,1,164.5900417,29.64442,0,NULL,60507570784,945430793,14772356,15.9),(76294,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76294,35.83,0.33,146,29238,70,NULL,NULL,'ARK 270',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000153,NULL,'15.3g',0.49,'E0',NULL,NULL,NULL,NULL,1,164.5964583,6.71489,0.049,NULL,60305661828,942275966,14723061,15.3),(76295,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76295,38.16,0.46,429,29239,70,NULL,NULL,'2MASX J10582332+3231384',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000176,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,164.597083,32.52717,0,NULL,60501593487,945337398,14770896,18.2),(76296,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76296,39.17,0.46,682,29240,70,NULL,NULL,'SDSS J105823.79+223634.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.3g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,164.599125,22.60956,0,NULL,60972473785,952694902,14885857,18.3),(76297,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76297,38.11,0.46,418,29241,70,NULL,NULL,'2MASX J10582458+3932037',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00017,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,164.6025417,39.53433,0,NULL,63935084727,998985698,15609151,17.8),(76298,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76298,33.92,0.69,60.9,29242,100,NULL,'mid-IR','NGC 3475',NULL,'2013ApJ...771...88L',2013,1,1.7,NULL,'G',0.000033,NULL,'14.00',1.1,'Sa             LINER',NULL,NULL,NULL,NULL,1,164.605083333,24.22633,0,NULL,60484403108,945068798,14766699,14),(76299,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76299,35.02,0.4,101,29242,NULL,NULL,'mean','NGC 3475',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76300,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76300,35.16,0.45,108,29242,NULL,NULL,'K','NGC 3475',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76301,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76301,35.21,0.47,110,29242,NULL,NULL,'H','NGC 3475',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76302,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76302,35.27,0.46,113,29242,NULL,NULL,'J','NGC 3475',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76303,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76303,35.91,0.2,152,29242,74.4,NULL,NULL,'NGC 3475',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76304,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76304,35.83,0.33,146,29243,70,NULL,NULL,'2MASX J10582544+0640027',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000173,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,164.6060417,6.66744,0.049,NULL,60305687551,942276367,14723068,16.3),(76305,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76305,37.93,0.46,385,29244,70,NULL,NULL,'2MASX J10582613+1259572',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,164.608833,12.99936,0.017,NULL,61147754791,955433668,14928651,18.2),(76306,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76306,36.3,0.46,182,29245,70,NULL,NULL,'MCG +10-16-035',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000197,NULL,'15.6g',0.35,'S0','Group member',NULL,NULL,NULL,1,164.609416667,56.98964,0,NULL,62005804681,968840698,15138135,15.6),(76307,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76307,37.8,0.14,362,29246,70,NULL,NULL,'2MASX J10582650+2158167',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,164.610458333,21.97139,0,NULL,60970932058,952670813,14885481,17.9),(76308,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76308,36.24,0.13,177,29247,70,NULL,NULL,'IC 0660',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000031,NULL,'15.1g',0.56,'S0/E','Group member',NULL,NULL,NULL,1,164.611083,1.38292,0.065,NULL,60292390641,942068603,14719821,15.1),(76309,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76309,36.39,0.25,190,29247,74.4,NULL,NULL,'IC 0660',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76310,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76310,36.7,0.46,219,29248,70,NULL,NULL,'2MASX J10582721+0413053',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000192,NULL,'15.9g',0.42,'E0',NULL,NULL,NULL,NULL,1,164.613375,4.21811,0.121,NULL,60330309829,942661091,14729079,15.9),(76311,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76311,37.07,0.27,260,29249,70,NULL,NULL,'2MASX J10582842+4357381',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000189,NULL,'16.0g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,164.6184583,43.96053,0,NULL,63938818140,999044033,15610063,16),(76312,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76312,37.63,0.23,336,29250,70,NULL,NULL,'SDSS J105828.74+292926.4',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000119,NULL,'17.7g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,164.61975,29.49067,0,NULL,60515905494,945561023,14774390,17.7),(76313,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76313,37.46,0.46,311,29251,70,NULL,NULL,'2MASX J10582921+1557362',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,164.621833333,15.96019,0.005,NULL,61197750244,956214847,14940856,17.9),(76314,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76314,38.34,0.46,466,29252,70,NULL,NULL,'2MASX J10582935+0132423',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00019,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,164.622375,1.54517,0.069,NULL,60291296015,942051500,14719554,17.3),(76315,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76315,38.29,0.46,455,29253,70,NULL,NULL,'2MASX J10582987+0655136',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000129,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,164.6245417,6.92036,0.037,NULL,60305081784,942266902,14722920,17.4),(76316,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76316,38.78,0.46,571,29254,70,NULL,NULL,'SDSS J105830.21+264032.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,164.625916667,26.67569,0,NULL,60497867109,945279173,14769987,18.4),(76317,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76317,37.54,0.46,323,29255,70,NULL,NULL,'SDSS J105830.73+114038.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,164.6280417,11.67742,0.009,NULL,61025125502,953517585,14898712,18.4),(76318,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76318,36.55,0.46,205,29256,70,NULL,NULL,'2MASX J10583107+0631057',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000175,NULL,'15.9g',0.43,'E0',NULL,NULL,NULL,NULL,1,164.629417,6.51819,0.049,NULL,60305541379,942274084,14723032,15.9),(76319,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76319,36.54,0.27,204,29257,70,NULL,NULL,'2MASX J10583247+6705464',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000067,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,164.6350417,67.09625,0,NULL,62084639341,970072489,15157382,16.2),(76320,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76320,37.07,0.27,260,29258,70,NULL,NULL,'2MASX J10583268+4359201',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,164.636083,43.98883,0,NULL,63938816070,999044001,15610062,17.4),(76321,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76321,37.99,0.46,397,29259,70,NULL,NULL,'SDSS J105833.51+055901.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000139,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,164.639666667,5.98383,0.065,NULL,60303302335,942239098,14722485,18.5),(76322,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76322,37.91,0.46,381,29260,70,NULL,NULL,'2MASX J10583475+1737352',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,164.644708333,17.62661,0,NULL,61196201206,956190643,14940478,17.9),(76323,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76323,36.18,0.46,172,29261,70,NULL,NULL,'2MASX J10583496+0017333',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000079,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,164.645625,0.29239,0.085,NULL,60292646580,942072602,14719884,16.6),(76324,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76324,37.85,0.46,372,29262,70,NULL,NULL,'SDSS J105836.07+091858.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,164.650333333,9.31614,0.037,NULL,61033034936,953641170,14900643,17.9),(76325,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76325,36.24,0.13,177,29263,70,NULL,NULL,'2MASX J10583682+0124373',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000158,NULL,'16.6g',0.22,'S0','Group member',NULL,NULL,NULL,1,164.6535,1.41025,0.065,NULL,60292370870,942068294,14719817,16.6),(76326,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76326,35.9,0.49,152,29264,75,NULL,'IR','2MFGC 08554',NULL,'2011yCatp016004901K',2011,1,0.6,NULL,'G',0.000027,NULL,'16.87',0.4,'Sc(f)','Group member',NULL,NULL,NULL,1,164.654,1.42144,0.065,NULL,60292370524,942068289,14719817,16.87),(76327,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76327,36.14,0.42,169,29264,NULL,NULL,'Malmquist cor.','2MFGC 08554',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76328,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76328,36.24,0.4,177,29264,NULL,NULL,NULL,'2MFGC 08554',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76329,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76329,36.28,0.2,180,29264,74.4,NULL,NULL,'2MFGC 08554',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76330,'GRB','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76330,41.68,NULL,2170,29265,70,NULL,'Photo z = 0.75','GRB 110709B',NULL,'2013A&A...552L...5P',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,164.6545417,-23.45489,0.245,NULL,41627839636,650434994,10163046,NULL),(76331,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76331,37.29,0.46,287,29266,70,NULL,NULL,'2MASX J10583767+3929033',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000153,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,164.656958333,39.48419,0,NULL,63935059473,998985304,15609145,17.8),(76332,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76332,36.01,0.25,159,29267,74.4,NULL,NULL,'2MASX J10583882+0122543',NULL,'2013AJ....146...86T',2013,1,0.46,NULL,'G',0.000033,NULL,'16.1g',0.42,'S0','Group member',NULL,NULL,NULL,1,164.661708333,1.38186,0.065,NULL,60292372143,942068314,14719817,16.1),(76333,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76333,36.24,0.13,177,29267,70,NULL,NULL,'2MASX J10583882+0122543',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76334,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76334,36.24,0.13,177,29268,70,NULL,NULL,'2MASX J10583882+0139433',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,164.661791667,1.66206,0.069,NULL,60324081409,942563772,14727558,17.5),(76335,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76335,35.39,0.21,120,29269,70,NULL,NULL,'2MASX J10583898+5011249',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00016,NULL,'15.9g',0.42,'E0',NULL,NULL,NULL,NULL,1,164.662667,50.19033,0,NULL,63906669106,998541704,15602214,15.9),(76336,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76336,37.8,0.14,362,29270,70,NULL,NULL,'2MASX J10583916+2202036',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,164.663333,22.03428,0,NULL,60970937752,952670902,14885482,17.4),(76337,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76337,38.14,0.46,424,29271,70,NULL,NULL,'2MASX J10584019+3852573',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,164.6672917,38.88269,0.006,NULL,63923467662,998804182,15606315,17.8),(76338,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76338,37.07,0.46,259,29272,70,NULL,NULL,'2MASX J10584159+4404381',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000183,NULL,'15.9g',0.43,'E0',NULL,NULL,NULL,NULL,1,164.6732917,44.07717,0,NULL,63938634206,999041159,15610018,15.9),(76339,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76339,37.58,0.76,329,29273,70,NULL,NULL,'2MASX J10584239-4652457',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,164.6765417,-46.8795,0.673,NULL,41920727037,655011359,10234552,17.3),(76340,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76340,37.48,0.33,313,29274,70,NULL,NULL,'2MASX J10584281+2048255',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,164.6785,20.80725,0,NULL,61168494535,955757727,14933714,17.5),(76341,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76341,37.85,0.33,372,29275,70,NULL,NULL,'2MASX J10584306+3952023',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000197,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,164.679625,39.86725,0,NULL,63935018878,998984669,15609135,16.8),(76342,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76342,37.68,0.46,344,29276,70,NULL,NULL,'2MASX J10584343+1236332',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,164.6809583,12.60922,0.013,NULL,61146084103,955407564,14928243,17.6),(76343,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76343,37.8,0.14,362,29277,70,NULL,NULL,'2MASX J10584383+2200405',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'18.00',0.25,NULL,NULL,NULL,NULL,NULL,1,164.682541667,22.01133,0,NULL,60970944143,952671002,14885484,18),(76344,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','PTF10bxs','N',76344,37.78,0.12,335,29278,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10bxs',0.0727,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76345,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76345,38.36,0.46,470,29279,70,NULL,NULL,'SDSS J105844.32-000336.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000071,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,164.684667,-0.06017,0.113,NULL,40909417327,639209645,9987650,18.6),(76346,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76346,37.63,0.23,336,29280,70,NULL,NULL,'2MASX J10584467+2930401',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000174,NULL,'16.6g',0.32,'E',NULL,NULL,NULL,NULL,1,164.686208333,29.51128,0,NULL,60515835704,945559932,14774373,16.6),(76347,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76347,35.01,0.4,100,29281,NULL,NULL,'mean','NGC 3470',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000027,NULL,'14.2g',0.97,'SA(r)ab:','Pair member (points to parent)',NULL,NULL,NULL,1,164.687083,59.51069,0,NULL,61997645245,968713206,15136143,14.2),(76348,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76348,35.05,0.47,102,29281,NULL,NULL,'H','NGC 3470',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76349,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76349,35.24,0.46,112,29281,NULL,NULL,'J','NGC 3470',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76350,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76350,35.25,0.45,112,29281,NULL,NULL,'K','NGC 3470',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76351,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76351,34.5,0.49,79.4,29282,75,NULL,'IR','UGC 06063',NULL,'2011yCatp016004901K',2011,1,1.73,NULL,'G',0.000033,NULL,'14.8g',0.31,'Sc','Isolated galaxy',NULL,NULL,NULL,1,164.690291667,25.14094,0,NULL,60484512991,945070515,14766726,14.8),(76352,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76352,34.89,0.4,95,29282,NULL,NULL,'mean','UGC 06063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76353,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76353,34.91,NULL,95.8,29282,NULL,NULL,NULL,'UGC 06063',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76354,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76354,34.93,NULL,97,29282,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06063',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76355,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76355,34.96,NULL,98.2,29282,NULL,NULL,'Dipole + Quadrupole','UGC 06063',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76356,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76356,34.98,NULL,99,29282,NULL,NULL,'Dipole','UGC 06063',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76357,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76357,34.99,0.47,99.4,29282,NULL,NULL,'H','UGC 06063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76358,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76358,35.1,0.45,105,29282,NULL,NULL,'K','UGC 06063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76359,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76359,35.14,0.46,106,29282,NULL,NULL,'J','UGC 06063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76360,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76360,38.15,0.46,427,29283,70,NULL,NULL,'B3 1055+396 NED02',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000164,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,164.692667,39.31167,0,NULL,63934939131,998983423,15609115,17.3),(76361,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 2004at','R',76361,34.85,0.05,93.3,29284,NULL,NULL,'MLCS2k2, R(V) = 1.8','ARK 271',NULL,'2015Sci...347.1459K',2015,1,0.3,NULL,'G',0.000067,NULL,'15.6',0.13,'BlueCG','Pair member (points to parent)',NULL,NULL,NULL,1,164.695375,59.48681,0,NULL,61997644666,968713197,15136143,15.6),(76362,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 2004at','R',76362,34.9,0.05,95.5,29284,NULL,NULL,'MLCS2k2, R(V) = 3.1','ARK 271',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76363,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 2004at',NULL,76363,35.07,0.16,101,29284,70,NULL,'SALT 2','ARK 271',0.023131,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76364,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76364,37.85,0.33,372,29285,70,NULL,NULL,'2MASXi J1058488+395244',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000178,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,164.703208333,39.87892,0,NULL,63935020768,998984699,15609135,17.8),(76365,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76365,38.92,0.46,609,29286,70,NULL,NULL,'SDSS J105849.07+071333.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000142,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,164.7045,7.22608,0.045,NULL,60303973970,942249593,14722649,18.6),(76366,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76366,36.72,0.55,221,29287,70,NULL,NULL,'2MASX J10584963-0702427',NULL,'2014MNRAS.445.2677S',2014,1,0.69,NULL,'G',0.00015,NULL,'15.95',0.31,NULL,NULL,NULL,NULL,NULL,1,164.70675,-7.04511,0.029,NULL,40898260907,639035326,9984926,15.95),(76367,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76367,37.05,0.46,257,29288,70,NULL,NULL,'2MASX J10585012+5552214',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000159,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,164.709167,55.87269,0,NULL,61963647041,968181985,15127843,17.5),(76368,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76368,35.67,0.25,136,29289,74.4,NULL,NULL,'IC 0661',NULL,'2013AJ....146...86T',2013,1,0.74,NULL,'G',0.000019,NULL,'15.1g',0.55,'S0','Group member',NULL,NULL,NULL,1,164.714583,1.65064,0.065,NULL,60291325150,942051955,14719561,15.1),(76369,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76369,36.24,0.13,177,29289,70,NULL,NULL,'IC 0661',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76370,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76370,36.77,0.46,226,29290,70,NULL,NULL,'2MASX J10585204+3017129',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000183,NULL,'16.1g',0.37,NULL,NULL,NULL,NULL,NULL,1,164.7169583,30.287,0,NULL,60510563752,945477558,14773086,16.1),(76371,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76371,30.36,NULL,11.8,29291,NULL,NULL,NULL,'LSBC F640-01',NULL,'2015AstBu..70....1K',2015,1,0.3,NULL,'G',0.00006,NULL,'17.15',0.3,'S/Malin-like',NULL,NULL,NULL,NULL,1,164.718333,14.12972,0.021,NULL,61146852118,955419564,14928430,17.15),(76372,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76372,37.62,0.46,334,29292,70,NULL,NULL,'2MASX J10585262+2815531',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000185,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,164.71925,28.26492,0,NULL,60486347117,945099173,14767174,16.5),(76373,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76373,37.8,0.14,362,29293,70,NULL,NULL,'2MASX J10585266+2200188',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.09',0.16,NULL,NULL,NULL,NULL,NULL,1,164.719583,22.00533,0,NULL,60970945327,952671020,14885484,18.09),(76374,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76374,37.07,0.27,260,29294,70,NULL,NULL,'2MASX J10585278+4359139',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000204,NULL,'16.1g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,164.719917,43.98714,0,NULL,63938772465,999043319,15610051,16.1),(76375,'Tully est','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76375,32.74,0.8,35.4,29295,75,NULL,NULL,'ESO 215- G 013',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.00002,NULL,'14.16',1.1,'SB(rs)p',NULL,NULL,NULL,NULL,1,164.720583333,-49.97344,NULL,NULL,41924351110,655067986,10235437,14.16),(76376,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76376,36.08,0.46,165,29296,70,NULL,NULL,'CGCG 267-031',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.00013,NULL,'15.0g',0.64,'E0','Group member',NULL,NULL,NULL,1,164.7224583,55.63444,0,NULL,61964405836,968193841,15128028,15),(76377,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76377,38.4,0.46,478,29297,70,NULL,NULL,'SDSS J105854.45+392251.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000136,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,164.726917,39.38106,0,NULL,63934934940,998983358,15609114,18.3),(76378,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76378,36.98,0.46,249,29298,70,NULL,NULL,'2MASX J10585541+0802323',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000149,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,164.7309583,8.04219,0.061,NULL,61029088929,953579514,14899679,17.4),(76379,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76379,34.26,0.4,71,29299,NULL,NULL,'mean','NGC 3479',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.00003,NULL,'13.5',1.2,'SAB(r)bc',NULL,NULL,NULL,NULL,1,164.731166667,-14.96139,0.157,NULL,41864454893,654132107,10220814,13.5),(76380,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76380,34.48,0.46,78.6,29299,NULL,NULL,'J','NGC 3479',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76381,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76381,34.48,0.47,78.7,29299,NULL,NULL,'H','NGC 3479',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76382,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76382,34.52,0.45,80.1,29299,NULL,NULL,'K','NGC 3479',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76383,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76383,37.95,0.46,390,29300,70,NULL,NULL,'2MASX J10585553+1549097',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,164.7315,15.81936,0.005,NULL,61197645297,956213207,14940831,17.6),(76384,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76384,37.8,0.14,362,29301,70,NULL,NULL,'2MASX J10585633+2159238',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,164.73475,21.99006,0,NULL,60970944533,952671008,14885484,17.7),(76385,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76385,35.88,0.49,150,29302,75,NULL,'IR','CGCG 066-077',NULL,'2011yCatp016004901K',2011,1,1.01,NULL,'G',0.000014,NULL,'16.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,164.735,13.16714,0.009,NULL,61147715316,955433051,14928641,16.1),(76386,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76386,35.68,0.2,137,29303,74.4,NULL,NULL,'CGCG 066-077',NULL,'2013AJ....146...86T',2013,1,1.01,NULL,'G',0.000014,NULL,'16.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,164.735,13.16714,0.009,NULL,61147715316,955433051,14928641,16.1),(76387,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76387,37.86,0.46,374,29304,70,NULL,NULL,'2MASX J10585653+1643527',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000155,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,164.735583,16.73119,0,NULL,61196446866,956194482,14940538,17.4),(76388,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76388,37.63,0.23,336,29305,70,NULL,NULL,'2MASX J10585724+2929041',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000123,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,164.738583,29.48456,0,NULL,60515864390,945560381,14774380,17.4),(76389,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76389,36.53,0.46,202,29306,70,NULL,NULL,'2MASX J10585745+1615588',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,164.73925,16.26628,0.009,NULL,61197557316,956211833,14940809,17.2),(76390,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76390,34.71,1.19,87.5,29307,NULL,NULL,'Malmquist cor.','ESO 376- G 030',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.24',0.9,'Sb',NULL,NULL,NULL,NULL,1,164.7487917,-35.82419,0.181,NULL,42111027414,657984803,10281012,15.24),(76391,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76391,34.81,1.14,91.4,29307,NULL,NULL,NULL,'ESO 376- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76392,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76392,34.85,0.2,93.3,29307,74.4,NULL,NULL,'ESO 376- G 030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76393,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76393,36.97,0.46,247,29308,70,NULL,NULL,'2MASX J10590015+2148378',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,164.750583,21.81044,0,NULL,61154601907,955540654,14930322,16.8),(76394,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76394,33.4,0.45,47.9,29309,NULL,NULL,'K','NGC 3483',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000053,NULL,'13.06',1.3,'(R)SA(rl)0/a',NULL,NULL,NULL,NULL,1,164.75075,-28.47697,0.237,NULL,41515775414,648683990,10135687,13.06),(76395,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76395,33.74,0.4,55.9,29309,NULL,NULL,'mean','NGC 3483',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76396,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76396,37.68,0.27,343,29310,70,NULL,NULL,'2MASX J10590025+2744461',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,164.751,27.74611,0,NULL,60489820526,945153445,14768022,18.5),(76397,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76397,36.12,0.4,167,29311,NULL,NULL,'Malmquist cor.','SDSS J105901.02+012444.6',NULL,'2009ApJS..182..474S',2009,1,0.62,NULL,'G',0.000023,NULL,'16.8g',0.23,'Sc','Group member',NULL,NULL,NULL,1,164.75425,1.41239,0.065,NULL,60292367686,942068245,14719816,16.8),(76398,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76398,36.18,0.39,172,29311,NULL,NULL,NULL,'SDSS J105901.02+012444.6',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76399,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76399,36.22,0.2,175,29311,74.4,NULL,NULL,'SDSS J105901.02+012444.6',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76400,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76400,38.06,0.46,409,29312,70,NULL,NULL,'2MASX J10590161+2557551',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,164.756833333,25.9655,0,NULL,60497673739,945276152,14769939,17.6),(76401,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76401,37.18,0.46,273,29313,70,NULL,NULL,'2MASX J10590417+5016435',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,164.767291667,50.27858,0,NULL,63906675759,998541808,15602215,17.6),(76402,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76402,37.77,0.46,358,29314,70,NULL,NULL,'SDSS J105904.63+110825.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,164.769333,11.14031,0.009,NULL,61033524602,953648821,14900762,17.9),(76403,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76403,36.76,0.16,225,29315,70,NULL,NULL,'2MASX J10590538+2948321',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000183,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,164.772417,29.809,0,NULL,60507787557,945434180,14772409,16.2),(76404,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76404,36.17,0.44,171,29316,NULL,NULL,'Malmquist cor.','2MASX J10590566+0136132',NULL,'2009ApJS..182..474S',2009,1,0.37,NULL,'G',0.000023,NULL,'17.4g',0.15,'Sbc',NULL,NULL,NULL,NULL,1,164.773583,1.60375,0.065,NULL,60291334627,942052103,14719564,17.4),(76405,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76405,36.32,0.41,184,29316,NULL,NULL,NULL,'2MASX J10590566+0136132',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76406,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76406,36.36,0.2,187,29316,74.4,NULL,NULL,'2MASX J10590566+0136132',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76407,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76407,35.56,0.44,129,29317,NULL,NULL,'Malmquist cor.','CGCG 010-052',NULL,'2009ApJS..182..474S',2009,1,0.81,NULL,'G',0.000023,NULL,'15.4g',0.42,'SAab','Group member',NULL,NULL,NULL,1,164.774417,1.18206,0.073,NULL,60292536311,942070879,14719857,15.4),(76408,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76408,35.61,0.43,132,29317,NULL,NULL,NULL,'CGCG 010-052',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76409,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76409,35.65,0.2,135,29317,74.4,NULL,NULL,'CGCG 010-052',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76410,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76410,37.68,0.27,343,29318,70,NULL,NULL,'2MASX J10590657+2742491',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000138,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,164.777583,27.71361,0,NULL,60490093169,945157705,14768089,18),(76411,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76411,37.78,0.46,359,29319,70,NULL,NULL,'2MASX J10590750+3100357',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000186,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,164.781333,31.01008,0.026,NULL,60510306849,945473544,14773024,18),(76412,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76412,38.23,0.33,443,29320,70,NULL,NULL,'2MASX J10590758+5747305',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,164.7815,57.79178,0,NULL,62007888190,968873252,15138644,17.8),(76413,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76413,37,0.46,252,29321,70,NULL,NULL,'2MASX J10590855+4001549',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000193,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,164.785875,40.03183,0,NULL,63934970920,998983920,15609123,16.2),(76414,'Tully est','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76414,32.59,0.8,33,29322,75,NULL,'B','NGC 3471',NULL,'1988NBGC.C....0000T',1988,1,1.68,NULL,'G',0.000007,NULL,'13.1g',0.95,'Sa             HII','Possible field galaxy',NULL,NULL,'Starburst',1,164.7875417,61.53069,0,NULL,61831842223,966122534,15095664,13.1),(76415,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76415,31.8,0.45,22.9,29322,NULL,NULL,'K','NGC 3471',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76416,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76416,31.82,0.47,23.2,29322,NULL,NULL,'H','NGC 3471',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76417,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76417,31.89,0.46,23.9,29322,NULL,NULL,'J','NGC 3471',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76418,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76418,31.92,0.4,24.2,29322,NULL,NULL,NULL,'NGC 3471',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76419,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76419,32.49,0.4,31.5,29322,NULL,NULL,'mean','NGC 3471',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76420,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76420,35.83,0.46,147,29323,NULL,NULL,NULL,'2MASX J10590914+0123002',NULL,'2009ApJS..182..474S',2009,1,0.64,NULL,'G',0.000023,NULL,'16.1g',0.4,'Sc','Group member',NULL,NULL,NULL,1,164.788125,1.38339,0.065,NULL,60292550386,942071099,14719860,16.1),(76421,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76421,35.87,0.2,149,29323,74.4,NULL,NULL,'2MASX J10590914+0123002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76422,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76422,35.89,0.45,150,29323,NULL,NULL,'Malmquist cor.','2MASX J10590914+0123002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76423,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76423,36.54,0.27,204,29324,70,NULL,NULL,'2MASX J10591027+6702163',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000103,NULL,'16.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,164.792375,67.03781,0,NULL,62084635618,970072431,15157381,16.3),(76424,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76424,37.8,0.14,362,29325,70,NULL,NULL,'2MASX J10591058+2210558',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.29',0.16,NULL,NULL,NULL,NULL,NULL,1,164.794208333,22.18206,0,NULL,60971022304,952672223,14885503,18.29),(76425,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76425,37.68,0.27,343,29326,70,NULL,NULL,'2MASX J10591087+2745411',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000148,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,164.795167,27.7615,0,NULL,60489819486,945153429,14768022,17.3),(76426,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76426,37.6,0.23,331,29327,70,NULL,NULL,'2MASX J10591187+1529168',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,164.799416667,15.488,0.005,NULL,61197177485,956205898,14940717,17.1),(76427,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76427,36.24,0.13,177,29328,70,NULL,NULL,'2MASX J10591193+0126212',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'16.8g',0.22,'S0','Group member',NULL,NULL,NULL,1,164.7997083,1.43939,0.065,NULL,60291301956,942051593,14719556,16.8),(76428,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76428,37.8,0.14,362,29329,70,NULL,NULL,'2MASX J10591194+2200198',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,164.7997083,22.0055,0,NULL,60970925841,952670716,14885479,17.8),(76429,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76429,37.8,0.14,362,29330,70,NULL,NULL,'2MASX J10591244+2158398',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,164.801875,21.97781,0,NULL,60970919379,952670615,14885478,16.5),(76430,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76430,38.15,0.46,426,29331,70,NULL,NULL,'SDSS J105913.57+530425.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000145,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,164.806625,53.07383,0,NULL,61787583888,965430998,15084859,18.5),(76431,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76431,37.6,0.23,331,29332,70,NULL,NULL,'2MASX J10591415+1530087',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000198,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,164.8090417,15.50228,0.005,NULL,61197177708,956205901,14940717,16.4),(76432,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76432,35.91,0.46,152,29333,70,NULL,NULL,'UGC 06068',NULL,'2015arXiv151105856S',2015,1,1.02,NULL,'G',0.000197,NULL,'14.8g',0.55,'SA0+ pec?',NULL,NULL,NULL,NULL,1,164.811,5.29203,0.073,NULL,60321420524,942522195,14726909,14.8),(76433,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76433,37.21,0.46,276,29334,70,NULL,NULL,'2MASX J10591569+0846143',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000181,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,164.8152917,8.77072,0.045,NULL,61033233072,953644266,14900691,16.9),(76434,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76434,36.91,0.46,241,29335,70,NULL,NULL,'2MASX J10591576+2956518',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00017,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,164.81575,29.94764,0,NULL,60507758325,945433723,14772401,16.2),(76435,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76435,38.48,0.27,497,29336,70,NULL,NULL,'2MASX J10591606+0749163',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000145,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,164.816875,7.82114,0.041,NULL,60304000446,942250006,14722656,17.2),(76436,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76436,37.8,0.14,362,29337,70,NULL,NULL,'2MASX J10591632+2159178',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,164.8180417,21.98831,0,NULL,60970923884,952670685,14885479,17.2),(76437,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76437,38.28,0.33,453,29338,70,NULL,NULL,'2MASX J10591674+1446287',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000179,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,164.819833333,14.77458,0.013,NULL,61141432530,955334883,14927107,17.6),(76438,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76438,36.55,0.46,204,29339,70,NULL,NULL,'2MASX J10591690+1859098',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.64',0.25,NULL,NULL,NULL,NULL,NULL,1,164.820416667,18.98603,0,NULL,61166541660,955727213,14933237,16.64),(76439,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76439,36.24,0.13,177,29340,70,NULL,NULL,'CGCG 010-055',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000086,NULL,'15.0g',0.66,'cE','Group member',NULL,NULL,NULL,1,164.824375,1.15347,0.073,NULL,60292531427,942070803,14719856,15),(76440,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76440,36.2,0.25,174,29341,74.4,NULL,NULL,'IC 0662',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000033,NULL,'15.2g',0.56,'E','Group member',NULL,NULL,NULL,1,164.835625,1.59883,0.081,NULL,60291523356,942055052,14719610,15.2),(76441,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76441,36.24,0.13,177,29341,70,NULL,NULL,'IC 0662',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76442,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76442,38.23,0.46,442,29342,70,NULL,NULL,'2MASX J10592093+2752023',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,164.8372917,27.86742,0,NULL,60489926869,945155107,14768048,17.5),(76443,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76443,38.48,0.27,497,29343,70,NULL,NULL,'SDSS J105921.33+075046.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000137,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,164.838917,7.84622,0.041,NULL,60304002927,942250045,14722656,18.7),(76444,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76444,34.05,0.58,64.6,29344,70,NULL,NULL,'2MASX J10592172-4328237',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000137,NULL,'12.6I',1,NULL,NULL,NULL,NULL,NULL,1,164.840417,-43.47325,0.773,NULL,41927011342,655109552,10236086,12.6),(76445,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76445,37.58,0.46,328,29345,70,NULL,NULL,'2MASX J10592174+0603313',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000111,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,164.840625,6.05864,0.033,NULL,60303294355,942238974,14722483,17.4),(76446,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76446,38.91,0.46,606,29346,70,NULL,NULL,'SDSS J105922.27+210442.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,164.842833333,21.07856,0,NULL,61154403286,955537551,14930274,18.6),(76447,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76447,36.91,0.46,241,29347,70,NULL,NULL,'2MASX J10592407+2105384',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,'PHOT','17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,164.850375,21.09392,0,NULL,61154402505,955537539,14930274,17.1),(76448,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76448,38.23,0.33,443,29348,70,NULL,NULL,'2MASX J10592438+5752434',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,164.851667,57.87878,0,NULL,62008010341,968875161,15138674,18),(76449,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76449,38.31,0.46,458,29349,70,NULL,NULL,'2MASX J10592511+3919280',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,164.854625,39.32447,0,NULL,63934954946,998983671,15609119,17.4),(76450,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76450,38.28,0.33,453,29350,70,NULL,NULL,'2MASX J10592523+1449060',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,'PRED','18.62',0.14,NULL,NULL,NULL,NULL,NULL,1,164.855,14.81842,0.013,NULL,61141433704,955334901,14927107,18.62),(76451,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76451,37.22,0.33,278,29351,70,NULL,NULL,'2MASX J10592559+1135543',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'17.18',0.4,NULL,NULL,NULL,NULL,NULL,1,164.856667,11.59856,0.009,NULL,61025084579,953516946,14898702,17.18),(76452,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76452,34.49,0.49,79,29352,75,NULL,'IR','NGC 3478',NULL,'2011yCatp016004901K',2011,1,2.6,'The 2MASX position refers to a knot in the western arm.','G',0.000033,NULL,'13.57',1.2,'SB(rs)bc','in a radial-velocity based grouping',NULL,NULL,NULL,1,164.864,46.12239,0,NULL,63910469424,998601084,15603141,13.57),(76453,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76453,34.81,0.2,91.6,29352,74.4,NULL,NULL,'NGC 3478',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76454,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76454,34.84,0.33,92.9,29352,NULL,NULL,NULL,'NGC 3478',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76455,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76455,34.93,0.32,96.7,29352,NULL,NULL,'Malmquist cor.','NGC 3478',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76456,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76456,37.62,0.27,334,29353,70,NULL,NULL,'2MASX J10592770+0950083',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.00011,NULL,'16.1g',0.35,'S0','Group member',NULL,NULL,NULL,1,164.8655,9.83569,0.037,NULL,61034687559,953666993,14901046,16.1),(76457,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76457,38.54,0.46,509,29354,70,NULL,NULL,'2MASX J10592866+2257254',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000142,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,164.869375,22.95711,0,NULL,60972381802,952693465,14885835,18.2),(76458,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76458,35.48,0.63,125,29355,70,NULL,NULL,'2MASX J10592920-4622197',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,164.871625,-46.37208,0.609,NULL,41920989961,655015468,10234616,16.4),(76459,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76459,35.92,0.65,153,29356,70,NULL,NULL,'2MASX J10592995-1451416',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.15',NULL,NULL,NULL,NULL,NULL,NULL,1,164.874625,-14.86183,0.157,NULL,41819313605,653426775,10209793,16.15),(76460,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76460,37.87,0.27,375,29357,70,NULL,NULL,'SDSS J105930.18+431357.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,164.8757917,43.23272,0,NULL,63938285539,999035711,15609932,18.6),(76461,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76461,37.43,0.46,306,29358,70,NULL,NULL,'SDSS J105930.39+102319.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,164.876625,10.38889,0.005,NULL,61034115059,953658047,14900906,18),(76462,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76462,37.55,0.23,324,29359,70,NULL,NULL,'2MASX J10593052+5349586',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00016,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,164.877333,53.83297,0,NULL,61964762386,968199412,15128115,16.2),(76463,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76463,34.77,0.46,90,29360,70,NULL,NULL,'CGCG 095-083',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'15.7',0.21,NULL,NULL,NULL,NULL,NULL,1,164.8777083,18.85208,0,NULL,61166482142,955726283,14933223,15.7),(76464,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76464,36.79,0.46,228,29361,70,NULL,NULL,'2MASX J10593096+1111173',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.0001,NULL,'16.4g',0.36,'E','Group member',NULL,NULL,NULL,1,164.879083,11.18817,0.009,NULL,61033666644,953651041,14900797,16.4),(76465,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76465,36.03,0.82,161,29362,70,NULL,NULL,'LCRS B105659.4-062443',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'15.27',0.18,NULL,NULL,NULL,NULL,NULL,1,164.879667,-6.68047,0.009,NULL,40898565621,639040087,9985001,15.27),(76466,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76466,35.11,0.4,105,29363,NULL,NULL,'mean','NGC 3465',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.00011,NULL,'14.44',1,'Sab','in a triple',NULL,NULL,NULL,1,164.8802917,75.19128,0.137,NULL,61401881110,959404392,14990693,14.44),(76467,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76467,35.13,0.47,106,29363,NULL,NULL,'H','NGC 3465',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76468,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76468,37.1,0.23,263,29364,70,NULL,NULL,'SDSS J105931.33+060914.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,164.8805417,6.15403,0.033,NULL,60303259315,942238426,14722475,18.4),(76469,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76469,36.76,0.16,225,29365,70,NULL,NULL,'2MASX J10593142+2952143',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000183,NULL,'15.9g',0.39,'BrClG',NULL,NULL,NULL,NULL,1,164.880917,29.87075,0,NULL,60507760210,945433753,14772402,15.9),(76470,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76470,37.6,0.23,331,29366,70,NULL,NULL,'2MASX J10593229+1528310',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000158,NULL,'16.8g',0.33,NULL,NULL,NULL,NULL,NULL,1,164.884541667,15.47539,0,NULL,61197172187,956205815,14940715,16.8),(76471,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76471,37.62,0.27,334,29367,70,NULL,NULL,'2MASX J10593264+1004293',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00013,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,164.885916667,10.07489,0.017,NULL,61034694072,953667094,14901048,16.5),(76472,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76472,35.39,0.21,120,29368,70,NULL,NULL,'CGCG 241-052',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.00011,NULL,'15.3g',0.48,'E0','Group member',NULL,NULL,NULL,1,164.889,49.98544,0,NULL,63918164941,998721327,15605020,15.3),(76473,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76473,38.04,0.46,406,29369,70,NULL,NULL,'SDSS J105935.40+384059.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000136,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,164.8975,38.68306,0.006,NULL,63924163141,998815049,15606485,18.4),(76474,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76474,37.78,0.46,360,29370,70,NULL,NULL,'SDSS J105935.52+091342.7',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000176,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,164.8980417,9.22856,0.041,NULL,61033369727,953646401,14900725,17.5),(76475,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76475,38.25,0.46,447,29371,70,NULL,NULL,'2MASX J10593573+3925500',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000149,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,164.8987917,39.43064,0,NULL,63934918777,998983105,15609111,17.4),(76476,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76476,35.68,0.54,137,29372,70,NULL,NULL,'LCRS B105706.1-063702',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.03',0.39,NULL,NULL,NULL,NULL,NULL,1,164.907333,-6.88583,0.009,NULL,40898480930,639038764,9984980,16.03),(76477,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76477,33.01,0.49,40,29373,75,NULL,'IR','MCG -02-28-031',NULL,'2011yCatp016004901K',2011,1,2.17,NULL,'G',0.000027,NULL,'14.5',0.22,'Scd',NULL,NULL,NULL,NULL,1,164.909041667,-15.52633,0.153,NULL,41864487972,654132624,10220822,14.5),(76478,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76478,33.61,NULL,52.6,29373,NULL,NULL,'Dipole','MCG -02-28-031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76479,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76479,33.61,NULL,52.7,29373,NULL,NULL,'Dipole + Quadrupole','MCG -02-28-031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76480,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76480,33.61,NULL,52.8,29373,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -02-28-031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76481,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76481,33.69,NULL,54.7,29373,NULL,NULL,NULL,'MCG -02-28-031',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76482,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76482,36.76,0.16,225,29374,70,NULL,NULL,'2MASX J10593856+2947193',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000167,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,164.9107917,29.78872,0,NULL,60507670717,945432354,14772380,16.9),(76483,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76483,37.55,0.23,324,29375,70,NULL,NULL,'2MASX J10593928+5354210',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,164.913917,53.90581,0,NULL,61964717319,968198708,15128104,18),(76484,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76484,37.83,0.46,367,29376,70,NULL,NULL,'2MASX J10594000+2230544',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.46',0.14,NULL,NULL,NULL,NULL,NULL,1,164.916833,22.51519,0,NULL,60972027847,952687935,14885748,18.46),(76485,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76485,37.6,0.23,331,29377,70,NULL,NULL,'2MASX J10594038+1541451',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000135,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,164.91825,15.69578,0,NULL,61197895424,956217116,14940892,18.1),(76486,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76486,36.04,0.4,162,29378,NULL,NULL,'Malmquist cor.','2MASX J10594067+0127116',NULL,'2009ApJS..182..474S',2009,1,0.48,NULL,'G',0.000023,NULL,'16.2g',0.29,'Sbc','Group member',NULL,NULL,NULL,1,164.919417,1.45342,0.081,NULL,60291397839,942053091,14719579,16.2),(76487,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76487,36.07,0.4,163,29378,NULL,NULL,NULL,'2MASX J10594067+0127116',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76488,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76488,36.11,0.2,167,29378,74.4,NULL,NULL,'2MASX J10594067+0127116',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76489,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76489,36.54,0.46,203,29379,70,NULL,NULL,'2MASX J10594099+2409233',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000163,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,164.920916667,24.1565,0,NULL,60484244384,945066318,14766661,16.5),(76490,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76490,37.1,0.23,263,29380,70,NULL,NULL,'2MASX J10594153+0612021',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000168,NULL,'15.7g',0.39,'E0',NULL,NULL,NULL,NULL,1,164.922917,6.20044,0.033,NULL,60303260060,942238438,14722475,15.7),(76491,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76491,37.22,0.33,278,29381,70,NULL,NULL,'2MASX J10594183+1133561',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000165,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,164.924375,11.56564,0.005,NULL,61025080425,953516881,14898701,16.9),(76492,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76492,35.89,0.2,151,29382,74.4,NULL,NULL,'2MASX J10594188+1049591',NULL,'2013AJ....146...86T',2013,1,0.93,NULL,'G',0.000024,NULL,'15.6g',0.36,'SBab','Group member',NULL,NULL,NULL,1,164.924583,10.83319,0.009,NULL,61034296184,953660877,14900951,15.6),(76493,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76493,37.14,0.46,268,29383,70,NULL,NULL,'2MASX J10594482+3801256',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,164.936541667,38.02372,0.015,NULL,63923669914,998807342,15606364,17),(76494,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76494,37.87,0.27,375,29384,70,NULL,NULL,'2MASX J10594483+4311381',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000183,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,164.936791667,43.19392,0,NULL,63938296991,999035890,15609935,16.8),(76495,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76495,36.76,0.16,225,29385,70,NULL,NULL,'2MASX J10594588+2952092',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000179,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,164.941333333,29.86917,0,NULL,60507650824,945432044,14772375,16.4),(76496,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76496,37.55,0.23,324,29386,70,NULL,NULL,'MCG +09-18-064',NULL,'2015arXiv151105856S',2015,1,0.93,NULL,'G',0.000097,NULL,'15.2g',0.53,'BrClG',NULL,NULL,NULL,NULL,1,164.9417083,53.80364,0,NULL,61964757746,968199339,15128114,15.2),(76497,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76497,36.83,0.46,232,29387,70,NULL,NULL,'2MASX J10594627+5648031',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000183,NULL,'16.3g',0.34,NULL,'Group member',NULL,NULL,NULL,1,164.94275,56.80081,0,NULL,62005928146,968842627,15138166,16.3),(76498,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76498,37.59,0.46,330,29388,70,NULL,NULL,'2MASX J10594643+5721211',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,164.9435,57.35608,0,NULL,62007707048,968870422,15138600,17.4),(76499,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76499,38.08,0.46,414,29389,70,NULL,NULL,'2MASX J10594673+3457145',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.67',0.16,NULL,NULL,NULL,NULL,NULL,1,164.944625,34.95397,0,NULL,60498687538,945291992,14770187,18.67),(76500,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76500,37.54,0.27,322,29390,70,NULL,NULL,'2MASX J10594701+0829291',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000171,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,164.9457917,8.49136,0.029,NULL,61028290448,953567038,14899484,17.5),(76501,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76501,37.1,0.23,263,29391,70,NULL,NULL,'2MASX J10594709+0557433',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00015,NULL,'16.1g',0.41,'E0',NULL,NULL,NULL,NULL,1,164.9460417,5.96197,0.037,NULL,60303175349,942237114,14722454,16.1),(76502,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76502,36.83,0.6,232,29392,70,NULL,NULL,'LCRS B105716.3-062355',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'15.32',0.25,NULL,NULL,NULL,NULL,NULL,1,164.9502917,-6.66725,0.009,NULL,40897732725,639027073,9984798,15.32),(76503,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76503,38.48,0.27,497,29393,70,NULL,NULL,'SDSS J105948.28+074429.9',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000139,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,164.9512083,7.74167,0.033,NULL,60304582635,942259103,14722798,18),(76504,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76504,37.84,0.46,369,29394,70,NULL,NULL,'SDSS J105948.36+003129.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000069,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,164.9515,0.525,0.085,NULL,60292699244,942073425,14719897,18.3),(76505,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76505,38.19,0.46,435,29395,70,NULL,NULL,'2MASX J10594838+4943329',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000175,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,164.95175,49.72594,0,NULL,63919000392,998734381,15605224,17.1),(76506,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76506,35.8,0.46,145,29396,70,NULL,NULL,'2MASX J10594977+4934039',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000159,NULL,'15.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,164.95725,49.56792,0,NULL,63919035527,998734930,15605233,15.9),(76507,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76507,37.73,0.33,351,29397,70,NULL,NULL,'2MASX J10595347+0854272',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,164.9727917,8.90758,0.045,NULL,61033244312,953644442,14900694,16.9),(76508,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76508,38.13,0.46,422,29398,70,NULL,NULL,'2MASX J10595437+1856374',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,164.976417,18.94381,0,NULL,61165962885,955718170,14933096,17.8),(76509,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76509,35.73,0.33,140,29399,70,NULL,NULL,'NGC 3490',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000143,NULL,'15.2g',0.57,'E',NULL,NULL,NULL,NULL,1,164.9767083,9.36189,0.041,NULL,61033188424,953643569,14900680,15.2),(76510,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76510,38.04,0.33,405,29400,70,NULL,NULL,'2MASX J10595495+3626417',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000173,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,164.978916667,36.44492,0.029,NULL,63922098605,998782790,15605981,16.4),(76511,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76511,37.87,0.33,376,29401,70,NULL,NULL,'2MASX J10595534+4406561',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000177,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,164.980833,44.11558,0,NULL,63941458614,999085290,15610707,16.9),(76512,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76512,36.94,0.46,244,29402,70,NULL,NULL,'2MASX J10595574+2729143',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,164.982333,27.48731,0.006,NULL,60489400554,945146883,14767920,17.2),(76513,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76513,38.3,0.46,457,29403,70,NULL,NULL,'SDSS J105957.22+073159.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000159,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,164.988417,7.53306,0.025,NULL,60304435119,942256798,14722762,18.2),(76514,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76514,37.58,0.46,329,29404,70,NULL,NULL,'2MASX J10595725+2821493',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000175,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,164.9885417,28.36378,0.017,NULL,60486557301,945102457,14767225,17.8),(76515,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76515,37.62,0.27,334,29405,70,NULL,NULL,'2MASX J10595737+0959342',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000107,NULL,'16.4g',0.3,'S0','Group member',NULL,NULL,NULL,1,164.989,9.99294,0.037,NULL,61034512523,953664258,14901004,16.4),(76516,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76516,37.96,0.27,391,29406,70,NULL,NULL,'2MASX J10595811+2007194',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.50',0.15,NULL,NULL,NULL,NULL,NULL,1,164.9922083,20.12206,0,NULL,61169651879,955775810,14933997,18.5),(76517,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76517,38.02,0.46,402,29407,70,NULL,NULL,'2MASX J10595846+3655117',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000205,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,164.9935,36.92006,0,NULL,63921972681,998780823,15605950,17.1),(76518,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76518,37.43,0.46,307,29408,70,NULL,NULL,'2MASX J10595854+0117053',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.3g',0.18,'S0','Group member',NULL,NULL,NULL,1,164.993833333,1.28492,0.073,NULL,60292518251,942070597,14719853,17.3),(76519,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76519,37.87,0.33,376,29409,70,NULL,NULL,'2MASX J10595905+4407411',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000185,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,164.996,44.12806,0,NULL,63941458289,999085285,15610707,17),(76520,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76520,37.54,0.27,322,29410,70,NULL,NULL,'2MASX J10595941+0824082',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,164.9975417,8.40214,0.045,NULL,61028423269,953569113,14899517,17),(76521,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76521,35.39,0.21,120,29411,70,NULL,NULL,'UGC 06071',NULL,'2015arXiv151105856S',2015,1,1.04,NULL,'G',0.000083,NULL,'14.5g',0.74,'E','Pair member (points to parent)',NULL,NULL,NULL,1,164.998125,50.05664,0,NULL,63918153826,998721153,15605018,14.5),(76522,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76522,35.07,0.45,103,29411,NULL,NULL,'K','UGC 06071',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76523,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76523,35.14,0.4,107,29411,NULL,NULL,'mean','UGC 06071',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76524,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76524,35.88,0.4,150,29412,NULL,NULL,NULL,'SDSS J110001.08+013732.3',NULL,'2009ApJS..182..474S',2009,1,0.44,NULL,'G',0.000023,NULL,'16.7g',0.22,'Scd','Group member',NULL,NULL,NULL,1,165.0045,1.62564,0.081,NULL,60291371153,942052674,14719573,16.7),(76525,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76525,35.92,0.2,153,29412,74.4,NULL,NULL,'SDSS J110001.08+013732.3',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76526,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76526,35.98,0.38,157,29412,NULL,NULL,'Malmquist cor.','SDSS J110001.08+013732.3',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76527,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76527,37.95,0.46,390,29413,70,NULL,NULL,'SDSS J110001.88+195657.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,165.007875,19.94936,0,NULL,61169619169,955775299,14933989,18.2),(76528,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76528,35.82,0.46,146,29414,70,NULL,NULL,'CGCG 010-058',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000184,NULL,'15.2g',0.6,'SA(r)0-','Group member',NULL,NULL,NULL,1,165.007917,1.77619,0.081,NULL,60291486347,942054474,14719601,15.2),(76529,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76529,38.29,0.46,455,29415,70,NULL,NULL,'2MASX J11000235+1206195',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000154,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,165.009916667,12.10547,0.009,NULL,61145725963,955401968,14928155,17.9),(76530,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76530,35.94,0.63,154,29416,70,NULL,NULL,'2MASX J11000268-4329168',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,165.011083333,-43.48794,0.685,NULL,41926935453,655108366,10236068,16.7),(76531,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76531,37.32,0.46,291,29417,70,NULL,NULL,'2MASX J11000272+4354181',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000158,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,165.011583333,43.90508,0,NULL,63941784844,999090388,15610787,16.5),(76532,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76532,35.39,0.21,120,29418,70,NULL,NULL,'2MASX J11000332+5001530',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00016,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,165.014041667,50.03139,0,NULL,63918252092,998722688,15605042,16.5),(76533,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76533,37.87,0.27,375,29419,70,NULL,NULL,'2MASX J11000366+4309370',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000196,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,165.0152083,43.16019,0,NULL,63938292505,999035820,15609934,16.2),(76534,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76534,37.96,0.27,391,29420,70,NULL,NULL,'2MASX J11000392+2008154',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.49',0.14,NULL,NULL,NULL,NULL,NULL,1,165.016333,20.13753,0,NULL,61169635492,955775554,14933993,18.49),(76535,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76535,36.76,0.16,225,29421,70,NULL,NULL,'2MASX J11000410+3003131',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000179,NULL,'16.0g',0.41,NULL,NULL,NULL,NULL,NULL,1,165.017,30.05364,0,NULL,60507835228,945434925,14772420,16),(76536,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76536,37.1,0.23,263,29422,70,NULL,NULL,'2MASX J11000413+0611172',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000152,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,165.017166667,6.18797,0.033,NULL,60303361995,942240031,14722500,16.7),(76537,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76537,38.04,0.33,405,29423,70,NULL,NULL,'2MASX J11000414+3627237',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000174,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,165.0175,36.45647,0.029,NULL,63922098724,998782792,15605981,17.9),(76538,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76538,35.05,0.2,102,29424,74.4,NULL,NULL,'UGC 06078',NULL,'2013AJ....146...86T',2013,1,1.19,NULL,'G',0.000009,NULL,'15.0g',0.47,'Sbc','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,165.018875,12.23469,0.013,NULL,61145732046,955402063,14928157,15),(76539,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76539,38.21,0.33,439,29425,70,NULL,NULL,'2MASX J11000594+0637402',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,165.024708333,6.62778,0.053,NULL,60304790914,942262358,14722849,17.5),(76540,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76540,37.61,0.46,333,29426,70,NULL,NULL,'2MASX J11000593+1546285',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000185,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,165.024833,15.77458,0,NULL,61198016094,956219001,14940921,16.2),(76541,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76541,34.62,0.46,83.9,29427,70,NULL,NULL,'CGCG 291-019',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.0001,NULL,'15.0g',0.6,'S0/a',NULL,NULL,NULL,NULL,1,165.030917,57.42858,0,NULL,62008492160,968882690,15138792,15),(76542,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76542,37.87,0.46,375,29428,70,NULL,NULL,'2MASX J11000882+4658540',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000183,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,165.036667,46.98175,0,NULL,63917643037,998713172,15604893,17.4),(76543,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76543,34.91,0.46,96,29429,70,NULL,NULL,'UGC 06076',NULL,'2015arXiv151105856S',2015,1,0.93,NULL,'G',0.000103,NULL,'14.3g',0.8,'E?','in a radial-velocity based grouping',NULL,NULL,NULL,1,165.040125,45.91703,0,NULL,63910547166,998602299,15603160,14.3),(76544,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76544,37.73,0.33,351,29430,70,NULL,NULL,'2MASX J11001041+1521345',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,165.0435417,15.35958,0,NULL,61197079146,956204361,14940693,17.5),(76545,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76545,37.73,0.33,351,29431,70,NULL,NULL,'SDSS J110010.75+085111.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000142,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,165.044833,8.85331,0.045,NULL,61032540317,953633442,14900522,18.1),(76546,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76546,38.68,0.46,545,29432,70,NULL,NULL,'2MASX J11001162+0555424',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000155,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,165.0482917,5.92839,0.045,NULL,60303419446,942240928,14722514,17.4),(76547,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76547,38.68,0.46,544,29433,70,NULL,NULL,'SDSS J110012.67+180409.4',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,165.0527917,18.06931,0,NULL,61163531865,955680185,14932502,NULL),(76548,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76548,38.18,0.46,433,29434,70,NULL,NULL,'2MASX J11001468+4912390',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000161,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,165.061083,49.21078,0,NULL,63918865560,998732274,15605191,16.9),(76549,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76549,35.19,0.63,109,29435,NULL,NULL,'Malmquist cor.','ESO 318- G 029',NULL,'2009ApJS..182..474S',2009,1,1.8,NULL,'G',0.000033,NULL,'16.00',1.2,'S...',NULL,NULL,NULL,NULL,1,165.0672083,-38.63106,0.393,NULL,41894697169,654604643,10228197,16),(76550,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76550,35.25,0.62,112,29435,NULL,NULL,NULL,'ESO 318- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76551,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76551,35.29,0.2,114,29435,74.4,NULL,NULL,'ESO 318- G 029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76552,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76552,38.36,0.46,470,29436,70,NULL,NULL,'SDSS J110016.34+145918.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000127,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,165.068125,14.98853,0.013,NULL,61141460623,955335322,14927114,18.3),(76553,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76553,37.73,0.33,351,29437,70,NULL,NULL,'SDSS J110017.02+152226.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00014,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,165.070958333,15.37411,0,NULL,61197082297,956204410,14940693,18.3),(76554,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76554,36.73,0.46,221,29438,70,NULL,NULL,'2MASX J11001777+4435179',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000182,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,165.0742083,44.58839,0,NULL,63941625223,999087894,15610748,16.5),(76555,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76555,37.2,0.46,275,29439,70,NULL,NULL,'SDSS J110018.05+395121.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,165.07525,39.85586,0,NULL,63935728210,998995753,15609308,17.4),(76556,'GCLF','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76556,30.25,0.09,11.2,29440,NULL,NULL,NULL,'NGC 3489',NULL,'2001AJ....122.1251K',2001,1,3.5,NULL,'G',0.000006,NULL,'11.12',2,'SAB(rs)0+   Sy;LINER','Possible field galaxy',NULL,NULL,NULL,1,165.077375,13.90122,0.021,NULL,61149197058,955456204,14929003,11.12),(76557,'SBF','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76557,30.37,0.14,11.9,29440,74.4,NULL,NULL,'NGC 3489',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76558,'SBF','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76558,30.41,0.15,12.1,29440,NULL,NULL,'I','NGC 3489',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76559,'SBF','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76559,30.41,0.15,12.1,29440,NULL,NULL,NULL,'NGC 3489',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76560,'SBF','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76560,30.45,0.15,12.3,29440,NULL,NULL,'Malmquist cor.','NGC 3489',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76561,'Faber-Jackson','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76561,28.5,0.63,5.01,29440,95,NULL,'Michard 1979b, c','NGC 3489',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76562,'Faber-Jackson','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76562,29.25,0.28,7.08,29440,95,NULL,'Weighted Mean','NGC 3489',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76563,'Faber-Jackson','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76563,29.31,0.81,7.28,29440,55,NULL,'Visvanathan & Sandage 1979','NGC 3489',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76564,'Faber-Jackson','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76564,29.38,NULL,7.52,29440,NULL,NULL,'LEDA [April 2006]','NGC 3489',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76565,'Faber-Jackson','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76565,29.58,0.44,8.24,29440,95,NULL,'de Vaucouleurs','NGC 3489',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76566,'Faber-Jackson','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76566,29.66,0.46,8.55,29440,95,NULL,'Michard 1979a','NGC 3489',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76567,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76567,28.91,0.41,6.05,29440,NULL,NULL,NULL,'NGC 3489',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76568,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76568,29.24,0.41,7.04,29440,NULL,NULL,'Malmquist cor.','NGC 3489',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76569,'Tertiary','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76569,29.41,0.27,7.62,29440,95,NULL,NULL,'NGC 3489',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76570,'Tully est','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76570,29.05,0.8,6.4,29440,75,NULL,'B','NGC 3489',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76571,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76571,29.28,0.45,7.19,29440,NULL,NULL,'K','NGC 3489',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76572,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76572,30.36,0.4,11.8,29440,NULL,NULL,'mean','NGC 3489',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76573,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76573,38.21,0.33,439,29441,70,NULL,NULL,'2MASX J11001865+0632547',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000142,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,165.077667,6.5485,0.049,NULL,60302897495,942232773,14722387,18.4),(76574,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76574,36.76,0.16,225,29442,70,NULL,NULL,'2MASX J11001981+3007592',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000155,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,165.0825417,30.13311,0,NULL,60507844837,945435075,14772423,16.9),(76575,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76575,38.16,0.46,428,29443,70,NULL,NULL,'2MASX J11002000-0059279',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00008,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,165.083291667,-0.99119,0.153,NULL,40911190408,639237350,9988083,17.6),(76576,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76576,37.43,0.27,306,29444,70,NULL,NULL,'2MASX J11002005+0548323',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00017,NULL,'16.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,165.0835417,5.80894,0.045,NULL,60302703696,942229745,14722339,16.6),(76577,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76577,36.5,0.46,200,29445,70,NULL,NULL,'2MASX J11002009+4227089',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000173,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,165.083583,42.45239,0,NULL,63933209945,998956405,15608693,16.3),(76578,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76578,36.52,0.46,202,29446,70,NULL,NULL,'2MASX J11002058+2411338',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000168,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,165.0857083,24.19281,0,NULL,60484249282,945066395,14766662,16.9),(76579,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76579,37.28,0.46,286,29447,70,NULL,NULL,'2MASX J11002093-0109559',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000073,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,165.087167,-1.16556,0.121,NULL,40911095840,639235872,9988060,17.4),(76580,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76580,35.84,0.21,147,29448,70,NULL,NULL,'CGCG 066-085',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00007,NULL,'15.3g',0.55,'S0','Group member',NULL,NULL,NULL,1,165.095666667,10.32347,0.017,NULL,61033979973,953655937,14900874,15.3),(76581,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76581,37.16,0.46,270,29449,70,NULL,NULL,'2MASX J11002336+1644285',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000207,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,165.097417,16.74136,0,NULL,61198225268,956222269,14940972,16.2),(76582,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76582,36.49,0.6,199,29450,70,NULL,NULL,'2MASX J11002345-4844041',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,165.0977083,-48.73439,0.717,NULL,41925634420,655088037,10235750,16.9),(76583,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76583,32.17,NULL,27.2,29451,NULL,NULL,NULL,'UGC 06083',NULL,'2015AstBu..70....1K',2015,1,1.33,NULL,'G',0.000007,NULL,'15.2g',0.26,'Sc',NULL,NULL,NULL,NULL,1,165.099167,16.69217,0,NULL,61198213928,956222092,14940970,15.2),(76584,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76584,32.47,0.2,31.2,29451,74.4,NULL,NULL,'UGC 06083',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76585,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76585,32.5,0.43,31.6,29451,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06083',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76586,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76586,32.52,0.71,31.9,29451,NULL,NULL,'Malmquist cor.','UGC 06083',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76587,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76587,32.53,0.43,32,29451,75,NULL,'3.6 micron, color corrected','UGC 06083',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76588,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76588,32.61,0.68,33.3,29451,NULL,NULL,NULL,'UGC 06083',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76589,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76589,32.67,NULL,34.3,29451,NULL,NULL,NULL,'UGC 06083',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76590,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76590,32.73,NULL,35.1,29451,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06083',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76591,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76591,32.76,NULL,35.6,29451,NULL,NULL,'Dipole + Quadrupole','UGC 06083',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76592,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76592,32.78,NULL,36,29451,NULL,NULL,'Dipole','UGC 06083',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76593,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76593,29.36,0.4,7.4,29452,75,NULL,'B','NGC 3486',NULL,'1988NBGC.C....0000T',1988,1,7.1,NULL,'G',0.000003,NULL,'11.05',5.2,'SAB(r)c;HII    Sy2','Isolated galaxy',NULL,NULL,'Sy 2',1,165.0994583,28.97514,0.015,NULL,60516285762,945566965,14774483,11.05),(76594,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76594,30.45,0.4,12.3,29452,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 3 galaxy group','NGC 3486',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76595,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76595,30.68,0.36,13.7,29452,NULL,NULL,NULL,'NGC 3486',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76596,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76596,30.68,0.39,13.7,29452,73,NULL,'opt','NGC 3486',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76597,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76597,30.96,0.3,15.5,29452,55,NULL,'B','NGC 3486',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76598,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76598,30.96,0.47,15.5,29452,NULL,NULL,'H','NGC 3486',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76599,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76599,30.97,0.45,15.7,29452,NULL,NULL,'K','NGC 3486',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76600,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76600,31.04,0.46,16.1,29452,NULL,NULL,'J','NGC 3486',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76601,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76601,31.11,0.4,16.7,29452,NULL,NULL,'mean','NGC 3486',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76602,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76602,38.3,0.46,458,29453,70,NULL,NULL,'SDSS J110025.84+125139.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000169,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,165.1077083,12.861,0.029,NULL,61150566936,955477608,14929337,18.3),(76603,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76603,36.7,0.46,219,29454,70,NULL,NULL,'2MASX J11002627+3153542',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000191,NULL,'16.1g',0.32,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,165.1095,31.89831,0.046,NULL,60508192984,945440515,14772508,16.1),(76604,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76604,36.84,0.46,233,29455,70,NULL,NULL,'2MASX J11002714+3518122',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000172,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,165.1132917,35.30325,0.023,NULL,60414769666,943980776,14749699,17.1),(76605,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76605,37.03,0.46,255,29456,70,NULL,NULL,'2MASX J11002801+3907332',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000174,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,165.116667,39.12581,0,NULL,63935742397,998995974,15609312,16.4),(76606,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76606,37.98,0.46,394,29457,70,NULL,NULL,'2MASX J11002814+3420251',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,165.117167,34.34031,0,NULL,60499267887,945301060,14770329,18.2),(76607,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76607,37.31,0.33,290,29458,70,NULL,NULL,'2MASX J11002952+1001067',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000103,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,165.123,10.01867,0.037,NULL,61034517994,953664343,14901005,16.9),(76608,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76608,37.55,0.23,324,29459,70,NULL,NULL,'2MASXi J1100308+535322',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000193,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,165.1285,53.88944,0,NULL,61965502020,968210969,15128296,17.6),(76609,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76609,37.33,0.27,293,29460,70,NULL,NULL,'2MASX J11003126+0724287',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,165.1304583,7.40811,0.041,NULL,60304301460,942254710,14722729,17.5),(76610,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76610,37.33,0.27,293,29461,70,NULL,NULL,'2MASX J11003166+0713007',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000145,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,165.132,7.217,0.053,NULL,60304289147,942254517,14722726,17.6),(76611,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76611,37.77,0.46,358,29462,70,NULL,NULL,'2MASX J11003341+3655203',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000147,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,165.1392917,36.92225,0.006,NULL,63921898443,998779663,15605932,17.6),(76612,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76612,35.39,0.49,119,29463,75,NULL,'IR','UGC 06086',NULL,'2011yCatp016004901K',2011,1,1.49,NULL,'G',0.000009,NULL,'15.8g',0.21,'Sc','Group member',NULL,NULL,NULL,1,165.143125,9.95697,0.021,NULL,61034500189,953664065,14901001,15.8),(76613,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76613,35.64,0.2,134,29463,74.4,NULL,NULL,'UGC 06086',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76614,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76614,37.78,0.46,360,29464,70,NULL,NULL,'2MASX J11003489+1658335',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000139,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,165.1454583,16.97608,0,NULL,61198173354,956221458,14940960,18.1),(76615,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76615,37.54,0.27,322,29465,70,NULL,NULL,'SDSS J110035.29+082625.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000166,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,165.147083,8.44036,0.045,NULL,61028418350,953569036,14899516,18),(76616,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76616,34.75,0.46,89.2,29466,70,NULL,NULL,'NGC 3491',NULL,'2015arXiv151105856S',2015,1,1.02,NULL,'G',0.0001,NULL,'13.9g',0.91,'S0-:','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,165.1475,12.16156,0.009,NULL,61149969316,955468270,14929191,13.9),(76617,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76617,34.95,0.4,97.6,29466,NULL,NULL,'mean','NGC 3491',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76618,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76618,35.13,0.45,106,29466,NULL,NULL,'K','NGC 3491',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76619,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76619,37.48,0.46,313,29467,70,NULL,NULL,'2MASX J11003547+2728449',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,165.1479583,27.47903,0.021,NULL,60489297631,945145275,14767894,18),(76620,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76620,36.05,0.63,162,29468,70,NULL,NULL,'2MASX J11003601-0000449',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.000069,NULL,'15.8g',0.27,'SABb(r)',NULL,NULL,NULL,NULL,1,165.150083333,-0.01244,0.089,NULL,40909551849,639211747,9987683,15.8),(76621,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76621,34.74,0.57,88.7,29469,70,NULL,NULL,'2MASX J11003642-0856378',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00005,NULL,'15.33',0.5,NULL,NULL,NULL,NULL,NULL,1,165.1517917,-8.94397,0.029,NULL,41790158612,652971228,10202675,15.33),(76622,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76622,37.33,0.27,293,29470,70,NULL,NULL,'2MASX J11003805+0712307',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000183,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,165.158666667,7.20853,0.053,NULL,60304287533,942254492,14722726,17.1),(76623,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76623,36.81,0.33,230,29471,70,NULL,NULL,'2MASX J11003808+0832137',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000158,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,165.15875,8.53719,0.045,NULL,61028414608,953568978,14899515,17.2),(76624,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76624,35.84,0.21,147,29472,70,NULL,NULL,'2MASX J11003821+1053367',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000093,NULL,'17.21',0.3,'S0p','Group member',NULL,NULL,NULL,1,165.159125,10.89347,0.013,NULL,61034268332,953660442,14900944,17.21),(76625,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76625,37.96,0.27,391,29473,70,NULL,NULL,'2MASX J11003886+2002592',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.45',0.16,NULL,NULL,NULL,NULL,NULL,1,165.161833,20.04981,0,NULL,61169665505,955776023,14934000,18.45),(76626,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76626,36.89,0.84,239,29474,70,NULL,NULL,'2MASX J11003935-1510271',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,165.1640417,-15.17411,0.169,NULL,41819407619,653428244,10209816,15.3),(76627,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76627,35.84,0.2,147,29475,74.4,NULL,NULL,'UGC 06091',NULL,'2013AJ....146...86T',2013,1,1.28,NULL,'G',0.00002,NULL,'15.1g',0.39,'SB(r)bc','Group member',NULL,NULL,NULL,1,165.165291667,9.87667,0.021,NULL,61032655019,953635234,14900550,15.1),(76628,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76628,32.53,NULL,32.1,29476,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06080',NULL,'2010Ap&SS.325..163P',2010,1,2.14,NULL,'G',0.000008,NULL,'15.3g',0.29,'Sd(f)',NULL,NULL,NULL,NULL,1,165.167167,61.32058,0,NULL,61831749546,966121086,15095641,15.3),(76629,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76629,32.55,NULL,32.3,29476,NULL,NULL,'Dipole + Quadrupole','UGC 06080',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76630,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76630,32.56,NULL,32.5,29476,NULL,NULL,'Dipole','UGC 06080',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76631,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76631,32.64,0.4,33.7,29476,NULL,NULL,NULL,'UGC 06080',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76632,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76632,32.64,0.2,33.7,29476,74.4,NULL,NULL,'UGC 06080',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76633,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76633,32.77,0.43,35.7,29476,75,NULL,'3.6 micron, color corrected','UGC 06080',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76634,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76634,32.83,0.43,36.8,29476,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06080',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76635,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76635,32.85,0.57,37.1,29476,NULL,NULL,NULL,'UGC 06080',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76636,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76636,32.9,0.56,38,29476,NULL,NULL,'Malmquist cor.','UGC 06080',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76637,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76637,37.51,0.46,317,29477,70,NULL,NULL,'SDSS J110041.10+002743.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000069,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,165.1712917,0.462,0.065,NULL,60290667873,942041685,14719401,18.2),(76638,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76638,37.5,0.46,316,29478,70,NULL,NULL,'SDSS J110042.26+402048.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000135,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,165.176083,40.34667,0,NULL,63935461653,998991588,15609243,18.4),(76639,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76639,36.81,0.33,230,29479,70,NULL,NULL,'2MASX J11004260+0831047',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000172,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,165.1775,8.51803,0.045,NULL,61028194716,953565542,14899461,16.6),(76640,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76640,37.31,0.33,290,29480,70,NULL,NULL,'2MASX J11004438+1004187',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.0001,NULL,'16.5g',0.34,'E','Group member',NULL,NULL,NULL,1,165.1849583,10.07181,0.037,NULL,61034476508,953663695,14900995,16.5),(76641,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76641,35.86,0.46,149,29481,70,NULL,NULL,'2MASX J11004446+0407039',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00016,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,165.18525,4.11767,0.117,NULL,60329906534,942654789,14728981,16.5),(76642,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76642,37.09,0.46,262,29482,70,NULL,NULL,'2MASX J11004507+2949479',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000175,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,165.187917,29.83008,0.032,NULL,60507943196,945436612,14772447,16.5),(76643,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76643,37.57,0.46,327,29483,70,NULL,NULL,'2MASX J11004547+5307186',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000179,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,165.189417,53.12194,0,NULL,61787569724,965430776,15084855,16.7),(76644,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76644,36.11,0.54,166,29484,70,NULL,NULL,'2MASX J11004667-0023491',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.000104,NULL,'16.0g',0.28,'S0',NULL,NULL,NULL,NULL,1,165.194583,-0.397,0.097,NULL,40909492155,639210814,9987668,16),(76645,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76645,35.73,0.33,140,29485,70,NULL,NULL,'2MASX J11004736+0941437',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,165.1975,9.69553,0.029,NULL,61032876120,953638689,14900604,16.8),(76646,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76646,35.39,0.21,120,29486,70,NULL,NULL,'2MASX J11004754+4954066',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000163,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,165.1982917,49.90189,0,NULL,63918258585,998722790,15605043,16.5),(76647,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76647,38.43,0.46,485,29487,70,NULL,NULL,'2MASX J11004907+0842067',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,165.2045,8.70183,0.045,NULL,61032580851,953634075,14900532,17.6),(76648,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76648,36.04,0.61,161,29488,70,NULL,NULL,'2MASX J11004956-1006514',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.79',0.3,NULL,NULL,NULL,NULL,NULL,1,165.2064583,-10.11431,0.017,NULL,41791010531,652984539,10202883,16.79),(76649,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76649,37.26,0.33,283,29489,70,NULL,NULL,'2MASX J11005416+3756462',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000166,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,165.225625,37.94628,0,NULL,63924738069,998824032,15606625,16.2),(76650,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76650,36.29,0.33,181,29490,70,NULL,NULL,'2MASX J11005595+1213501',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000186,NULL,'15.6g',0.52,'E0',NULL,NULL,NULL,NULL,1,165.233167,12.23064,0.025,NULL,61149958164,955468096,14929189,15.6),(76651,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76651,36.55,0.46,204,29491,70,NULL,NULL,'2MASX J11005830+4400067',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00016,NULL,'16.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,165.242958333,44.00178,0,NULL,63941962294,999093160,15610830,16.8),(76652,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76652,36.29,0.33,181,29492,70,NULL,NULL,'2MASX J11005971+1213501',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.22',0.27,NULL,NULL,NULL,NULL,NULL,1,165.248708333,12.23053,0.025,NULL,61150060604,955469696,14929214,17.22),(76653,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76653,33.5,0.48,50.2,29493,70,NULL,NULL,'MCG -02-28-037',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00011,NULL,'14.48',1.2,'(R\')SB(s)0+ pec?',NULL,NULL,NULL,NULL,1,165.2494583,-14.03889,0.137,NULL,41822424224,653475378,10210552,14.48),(76654,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76654,37.89,0.46,378,29494,70,NULL,NULL,'2MASX J11010099+2811124',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,165.254375,28.18681,0.03,NULL,60489859354,945154052,14768032,17.6),(76655,'IRAS','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76655,30.78,0.8,14.3,29495,75,NULL,'MAT, I','ESO 265- G 002',NULL,'1997ApJS..109..333W',1997,1,2.13,NULL,'G',0.000033,NULL,'16.11',0.25,'SBd? sp',NULL,NULL,NULL,NULL,1,165.256667,-43.67833,0.669,NULL,41929786101,655152907,10236764,16.11),(76656,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76656,30.7,0.32,13.8,29495,85,NULL,'I, inv','ESO 265- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76657,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76657,30.78,0.32,14.3,29495,85,NULL,'I, raw','ESO 265- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76658,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76658,31.13,0.94,16.8,29495,NULL,NULL,NULL,'ESO 265- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76659,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76659,31.17,0.2,17.1,29495,74.4,NULL,NULL,'ESO 265- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76660,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76660,31.18,0.43,17.2,29495,75,NULL,'MAT, I, inv','ESO 265- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76661,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76661,31.37,0.43,18.8,29495,75,NULL,'MAT, I, raw','ESO 265- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76662,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76662,31.47,0.39,19.7,29495,73,NULL,'opt','ESO 265- G 002',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76663,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76663,31.57,0.77,20.6,29495,NULL,NULL,'Malmquist cor.','ESO 265- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76664,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76664,31.57,NULL,20.6,29495,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 265- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76665,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76665,31.6,NULL,20.9,29495,NULL,NULL,'Dipole + Quadrupole','ESO 265- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76666,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76666,31.61,NULL,21,29495,NULL,NULL,'Dipole','ESO 265- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76667,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76667,31.7,NULL,21.9,29495,NULL,NULL,NULL,'ESO 265- G 002',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76668,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76668,31.75,0.43,22.4,29495,75,NULL,'MAT, I, cor','ESO 265- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76669,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76669,37.26,0.33,283,29496,70,NULL,NULL,'2MASX J11010235+3759452',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000187,NULL,'16.1g',0.44,NULL,NULL,NULL,NULL,NULL,1,165.25975,37.99597,0,NULL,63923620299,998806567,15606352,16.1),(76670,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76670,37.25,0.46,282,29497,70,NULL,NULL,'SDSS J110102.68+532527.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000164,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,165.2612083,53.42442,NULL,NULL,61783365334,965365083,15083829,18.3),(76671,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76671,37.47,0.46,312,29498,70,NULL,NULL,'2MASX J11010307+1853275',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.08',0.18,NULL,NULL,NULL,NULL,NULL,1,165.262875,18.89114,0,NULL,61165958349,955718099,14933095,18.08),(76672,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76672,37.17,0.46,272,29499,70,NULL,NULL,'SDSS J110103.43+503625.2',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000184,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,165.264333,50.60703,0,NULL,63906529146,998539517,15602179,17.6),(76673,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76673,32.34,NULL,29.4,29500,NULL,NULL,NULL,'UGC 06095',NULL,'2015AstBu..70....1K',2015,1,1.4,NULL,'G',0.000013,NULL,'17.48',0.5,'Im?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,165.269583,19.10139,0,NULL,61166046084,955719470,14933116,17.48),(76674,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76674,38.01,0.46,400,29501,70,NULL,NULL,'2MASX J11010667+2727405',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000161,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,165.277875,27.46133,0.04,NULL,60489275999,945144937,14767889,17.4),(76675,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76675,37.48,0.46,314,29502,70,NULL,NULL,'2MASX J11010853+0309049',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000181,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,165.285583,3.15142,0.101,NULL,60328603683,942634432,14728663,17.1),(76676,'IRAS','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76676,30.93,0.8,15.3,29503,75,NULL,'MAT, I','ESO 265- G 003',NULL,'1997ApJS..109..333W',1997,1,2.7,'RC3 gives V = 11240 +- 60 km/sec.','G',0.00001,NULL,'14.04',1.2,'SAB(s)c',NULL,NULL,NULL,NULL,1,165.2864583,-44.03956,0.757,NULL,41930259568,655160305,10236879,14.04),(76677,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76677,31.23,0.4,17.6,29503,NULL,NULL,NULL,'ESO 265- G 003',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76678,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76678,31.23,0.39,17.6,29503,73,NULL,'opt','ESO 265- G 003',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76679,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76679,31.34,0.32,18.5,29503,85,NULL,'I, raw','ESO 265- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76680,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76680,31.34,0.32,18.5,29503,85,NULL,'I, inv','ESO 265- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76681,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76681,31.52,0.2,20.1,29503,74.4,NULL,NULL,'ESO 265- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76682,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76682,31.59,0.43,20.8,29503,75,NULL,'MAT, I, raw','ESO 265- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76683,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76683,31.66,0.43,21.5,29503,75,NULL,'MAT, I, inv','ESO 265- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76684,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76684,32.02,0.43,25.4,29503,75,NULL,'MAT, I, cor','ESO 265- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76685,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76685,32.18,0.4,27.3,29503,NULL,NULL,'mean','ESO 265- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76686,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76686,32.29,0.47,28.7,29503,NULL,NULL,'H','ESO 265- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76687,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76687,32.4,0.46,30.2,29503,NULL,NULL,'J','ESO 265- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76688,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76688,32.47,0.45,31.1,29503,NULL,NULL,'K','ESO 265- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76689,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76689,37.07,0.46,259,29504,70,NULL,NULL,'2MASX J11011358+5251104',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000151,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,165.306875,52.85292,0,NULL,61788291565,965442055,15085032,17.2),(76690,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76690,36.46,0.46,196,29505,70,NULL,NULL,'2MASX J11011408+0915544',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000199,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,165.308667,9.26503,0.025,NULL,61033295483,953645241,14900706,16.3),(76691,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76691,37.79,0.46,362,29506,70,NULL,NULL,'2MASX J11011439+3341084',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,165.310167,33.68561,0.01,NULL,60634489423,947413897,14803342,17.1),(76692,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1999bi',NULL,76692,38.08,0.11,367,29507,74.2,NULL,'SALT 2','EROS J110115.76-114515.2',0.124,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,165.3154583,-11.75444,0.045,NULL,41809932338,653280192,10207503,NULL),(76693,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1999bi',NULL,76693,38.81,0.07,514,29507,70,NULL,'SALT','EROS J110115.76-114515.2',0.124,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76694,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1999bi',NULL,76694,38.9,0.08,537,29507,65,NULL,'SALT','EROS J110115.76-114515.2',0.124,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76695,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76695,37.76,0.46,356,29508,70,NULL,NULL,'SDSS J110115.87+081540.9',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000148,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,165.316166667,8.26136,0.049,NULL,60303844539,942247570,14722618,17.7),(76696,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76696,38,0.46,398,29509,70,NULL,NULL,'2MASX J11011601+0129319',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,165.3165417,1.49222,0.077,NULL,60291691104,942057673,14719651,18),(76697,'IRAS','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76697,31.3,0.8,18.2,29510,75,NULL,'A82, H','NGC 3495',NULL,'1997ApJS..109..333W',1997,1,4.9,NULL,'G',0.000018,NULL,'12.41',1.2,'Scd            AGN?','Isolated galaxy',NULL,NULL,NULL,1,165.317625,3.62794,0.801,NULL,60328079278,942626238,14728534,12.41),(76698,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76698,30.54,0.4,12.8,29510,75,NULL,'B','NGC 3495',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76699,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76699,31.11,0.4,16.7,29510,75,NULL,NULL,'NGC 3495',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76700,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76700,31.11,0.39,16.7,29510,73,NULL,'IR','NGC 3495',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76701,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76701,31.23,0.4,17.6,29510,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 3495',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76702,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76702,31.23,0.47,17.6,29510,75,NULL,'A82, H, raw','NGC 3495',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76703,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76703,31.28,0.35,18,29510,NULL,NULL,NULL,'NGC 3495',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76704,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76704,31.29,0.47,18.1,29510,75,NULL,'A82, H, inv','NGC 3495',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76705,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76705,31.32,0.2,18.4,29510,74.4,NULL,NULL,'NGC 3495',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76706,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76706,31.33,0.43,18.4,29510,75,NULL,'3.6 micron, color corrected','NGC 3495',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76707,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76707,31.33,0.39,18.5,29510,NULL,NULL,'Malmquist cor.','NGC 3495',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76708,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76708,31.34,0.43,18.5,29510,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3495',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76709,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76709,31.47,0.47,19.7,29510,75,NULL,'A82, H, cor','NGC 3495',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76710,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76710,31.49,0.36,19.8,29510,NULL,NULL,NULL,'NGC 3495',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76711,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76711,31.77,0.49,22.6,29510,75,NULL,'IR','NGC 3495',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76712,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76712,31.83,0.4,23.2,29510,NULL,NULL,'mean','NGC 3495',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76713,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76713,31.86,0.46,23.6,29510,NULL,NULL,'J','NGC 3495',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76714,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76714,32.01,0.47,25.2,29510,NULL,NULL,'H','NGC 3495',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76715,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76715,32.09,0.45,26.2,29510,NULL,NULL,'K','NGC 3495',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76716,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76716,32.19,0.3,27.4,29510,55,NULL,'B','NGC 3495',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76717,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76717,37.43,0.27,306,29511,70,NULL,NULL,'SDSS J110116.25+055149.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000155,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,165.3177083,5.86378,0.049,NULL,60302711706,942229870,14722341,18.6),(76718,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76718,38.2,0.46,436,29512,70,NULL,NULL,'SDSS J110116.56+231819.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000142,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,165.319,23.30553,0,NULL,60968736961,952636515,14884945,18.2),(76719,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76719,37.43,0.27,306,29513,70,NULL,NULL,'2MASX J11011785+0552069',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000189,NULL,'16.1g',0.37,'E0',NULL,NULL,NULL,NULL,1,165.324417,5.8685,0.049,NULL,60302711174,942229862,14722341,16.1),(76720,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76720,37.29,0.46,287,29514,70,NULL,NULL,'2MASX J11011838+1232199',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,165.3265417,12.53886,0,NULL,61150680198,955479378,14929365,18.1),(76721,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76721,37.99,0.46,397,29515,70,NULL,NULL,'SDSS J110118.95+553734.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,165.3289583,55.62636,0,NULL,61964142558,968189727,15127964,18),(76722,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76722,37.22,0.73,278,29516,70,NULL,NULL,'2MASX J11011899-4751552',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,165.329167,-47.86542,0.713,NULL,41922778205,655043409,10235053,14.4),(76723,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76723,36.85,0.46,234,29517,70,NULL,NULL,'2MASX J11011972+1849540',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,165.3320417,18.83161,0,NULL,61164076550,955688696,14932635,17.8),(76724,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76724,36.22,0.46,175,29518,70,NULL,NULL,'2MASX J11012037+3155164',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00016,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,165.334917,31.92111,0.067,NULL,60508332369,945442693,14772542,16.8),(76725,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76725,38.12,0.46,422,29519,70,NULL,NULL,'2MASX J11012109+1822110',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.52',0.15,NULL,NULL,NULL,NULL,NULL,1,165.33775,18.36964,0,NULL,61164485445,955695085,14932735,18.52),(76726,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76726,37.23,0.46,280,29520,70,NULL,NULL,'2MASX J11012200-0108249',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000104,NULL,'15.9g',0.43,'E0',NULL,NULL,NULL,NULL,1,165.341708333,-1.14025,0.161,NULL,40910400329,639225005,9987890,15.9),(76727,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76727,32.41,0.69,30.3,29521,100,NULL,'mid-IR','NGC 3488',NULL,'2013ApJ...771...88L',2013,1,1.72,NULL,'G',0.000033,NULL,'13.6g',0.98,'SB(s)c:','Group member',NULL,NULL,NULL,1,165.348375,57.67767,0,NULL,62007988671,968874822,15138669,13.6),(76728,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76728,32.89,0.43,37.9,29521,75,NULL,'3.6 micron, color corrected','NGC 3488',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76729,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76729,32.9,0.43,38,29521,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3488',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76730,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76730,33.05,0.2,40.7,29521,74.4,NULL,NULL,'NGC 3488',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76731,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76731,33.27,0.4,45.1,29521,NULL,NULL,'mean','NGC 3488',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76732,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76732,33.33,0.45,46.3,29521,NULL,NULL,'Malmquist cor.','NGC 3488',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76733,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76733,33.42,0.43,48.4,29521,NULL,NULL,NULL,'NGC 3488',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76734,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76734,33.47,0.47,49.4,29521,NULL,NULL,'H','NGC 3488',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76735,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76735,33.48,0.46,49.6,29521,NULL,NULL,'J','NGC 3488',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76736,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76736,33.56,0.45,51.6,29521,NULL,NULL,'K','NGC 3488',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76737,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76737,37.53,0.27,320,29522,70,NULL,NULL,'2MASX J11012393+1546480',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00018,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,165.349667,15.78003,0,NULL,61197940130,956217814,14940903,16.8),(76738,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76738,35.84,0.21,147,29523,70,NULL,NULL,'2MASX J11012482+1017384',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000073,NULL,'16.3g',0.24,'S0','Group member',NULL,NULL,NULL,1,165.353375,10.29392,0.021,NULL,61020056771,953438387,14897474,16.3),(76739,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76739,37.5,0.46,316,29524,70,NULL,NULL,'2MASX J11012496+1041044',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000107,NULL,'16.4g',0.34,'S0','Group member',NULL,NULL,NULL,1,165.354041667,10.68461,0.017,NULL,61020205193,953440706,14897511,16.4),(76740,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76740,35.79,0.46,144,29525,70,NULL,NULL,'2MASX J11012645+0947194',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000238,NULL,'15.5g',0.38,'E              Sy1.9',NULL,NULL,NULL,'Sy 1.9',1,165.360291667,9.78889,0.029,NULL,61032664845,953635388,14900552,15.5),(76741,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76741,37.55,0.46,324,29526,70,NULL,NULL,'2MASX J11012680+5052275',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000227,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,165.361625,50.87425,0,NULL,61774784355,965231005,15081734,16.4),(76742,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76742,36.31,0.46,183,29527,70,NULL,NULL,'2MASX J11012718-0043059',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000106,NULL,'15.6g',0.4,'S0',NULL,NULL,NULL,NULL,1,165.363416667,-0.71833,0.153,NULL,40909807691,639215745,9987746,15.6),(76743,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76743,36.64,0.55,212,29527,70,NULL,NULL,'2MASX J11012718-0043059',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76744,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76744,35.84,0.21,147,29528,70,NULL,NULL,'SDSS J110127.33+102148.8',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000093,NULL,'16.7g',0.24,'S0','Group member',NULL,NULL,NULL,1,165.363875,10.36358,0.017,NULL,61020101970,953439093,14897485,16.7),(76745,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76745,35.62,0.47,133,29529,NULL,NULL,'H','NGC 3493',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.00005,NULL,'15.19',0.3,'S?             RET','Group member',NULL,NULL,NULL,1,165.3659583,27.71958,0.037,NULL,60490147785,945158559,14768102,15.19),(76746,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76746,35.62,0.4,133,29529,NULL,NULL,'mean','NGC 3493',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76747,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76747,35.74,0.45,141,29529,NULL,NULL,'K','NGC 3493',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76748,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76748,35.77,0.46,143,29529,NULL,NULL,'J','NGC 3493',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76749,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76749,37.26,0.21,283,29530,70,NULL,NULL,'2MASX J11012823+1646060',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000189,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,165.3677917,16.76833,0,NULL,61198915683,956233057,14941141,16.4),(76750,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76750,37.26,0.21,283,29531,70,NULL,NULL,'2MASX J11012865+1647490',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,165.369375,16.79711,0,NULL,61198916276,956233066,14941141,17.1),(76751,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76751,38.29,0.46,456,29532,70,NULL,NULL,'2MASX J11012937+3801166',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000168,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,165.37225,38.02144,0,NULL,63925256774,998832137,15606752,18.3),(76752,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76752,37.47,0.46,312,29533,70,NULL,NULL,'2MASX J11012939+0350049',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000191,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,165.3725417,3.83469,0.801,NULL,60328099397,942626553,14728539,17.4),(76753,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76753,36.24,0.46,177,29534,70,NULL,NULL,'2MASX J11013020+3021554',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00017,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,165.375875,30.3655,0,NULL,60507375193,945427737,14772308,16.6),(76754,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76754,37.07,0.46,259,29535,70,NULL,NULL,'2MASX J11013186+5407020',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,165.38275,54.11736,0,NULL,61965555847,968211810,15128309,17.4),(76755,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76755,35.78,0.46,143,29536,70,NULL,NULL,'2MASX J11013268+3052544',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000157,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,165.386208333,30.88186,0.024,NULL,60510751373,945480490,14773132,16.4),(76756,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76756,37.94,0.33,388,29537,70,NULL,NULL,'2MASX J11013313+3949306',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000173,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,165.3879583,39.82517,0,NULL,63935854502,998997726,15609339,17.3),(76757,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76757,35.75,0.23,141,29538,70,NULL,NULL,'IC 2614',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000172,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,165.390833333,38.80367,0,NULL,63923932768,998811449,15606428,16.3),(76758,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76758,37.98,0.33,395,29539,70,NULL,NULL,'2MASX J11013383+0748344',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000146,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,165.391,7.80958,0.025,NULL,60304519289,942258113,14722783,17.2),(76759,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76759,37.66,0.46,340,29540,70,NULL,NULL,'2MASX J11013383+1153140',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000163,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,165.391083,11.88731,0.005,NULL,61138317836,955286216,14926347,17),(76760,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76760,35.61,0.4,133,29541,NULL,NULL,'mean','UGC 06100',NULL,'2007A&A...465...71T',2007,1,1.07,NULL,'G',0.000127,NULL,'14.2g',0.66,'Sa?            Sy2','Group member',NULL,NULL,'Sy 2',1,165.391667,45.65394,0,NULL,63910258151,998597783,15603090,14.2),(76761,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76761,35.72,0.47,139,29541,NULL,NULL,'H','UGC 06100',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76762,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76762,37.32,0.33,291,29542,70,NULL,NULL,'2MASX J11013599+2652520',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000142,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,165.399875,26.88125,0.012,NULL,60488807355,945137614,14767775,17.1),(76763,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1999aw',NULL,76763,35.57,0.02,125,29543,70,NULL,'SALT 2','SCP J110136.37-060631.6',0.04,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,165.4015417,-6.10878,0.037,NULL,40896772097,639012064,9984563,NULL),(76764,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1999aw',NULL,76764,35.6,0.1,127,29543,74.2,NULL,'SALT 2','SCP J110136.37-060631.6',0.04,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76765,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1999aw',NULL,76765,36.28,0.06,174,29543,70,NULL,NULL,'SCP J110136.37-060631.6',0.04,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76766,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1999aw',NULL,76766,36.29,0.22,174,29543,72,NULL,NULL,'SCP J110136.37-060631.6',0.04,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76767,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1999aw',NULL,76767,36.31,0.07,176,29543,70,NULL,'SALT','SCP J110136.37-060631.6',0.04,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76768,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1999aw',NULL,76768,36.38,0.09,182,29543,65,NULL,'SALT2','SCP J110136.37-060631.6',0.04,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76769,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1999aw',NULL,76769,36.4,0.18,183,29543,65,NULL,'SALT2','SCP J110136.37-060631.6',0.04,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76770,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1999aw',NULL,76770,36.43,0.16,186,29543,73.8,NULL,'SALT 2 (SNANA)','SCP J110136.37-060631.6',0.0391,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76771,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1999aw',NULL,76771,36.55,0.04,188,29543,65,NULL,'MLCS2k2','SCP J110136.37-060631.6',0.04,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76772,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1999aw',NULL,76772,36.47,0.1,189,29543,65,NULL,'SALT','SCP J110136.37-060631.6',0.04,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76773,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1999aw',NULL,76773,36.54,0.05,195,29543,65,NULL,'MLCS2k2','SCP J110136.37-060631.6',0.04,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76774,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1999aw',NULL,76774,36.54,0.12,196,29543,65,NULL,'MLCS31','SCP J110136.37-060631.6',0.04,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76775,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1999aw',NULL,76775,36.55,0.01,196,29543,65,NULL,'SALT','SCP J110136.37-060631.6',0.04,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76776,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1999aw',NULL,76776,36.59,0.03,200,29543,65,NULL,'MLCS2k2','SCP J110136.37-060631.6',0.04,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76777,'SNIa','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1999aw',NULL,76777,36.61,0.14,210,29543,60,NULL,NULL,'SCP J110136.37-060631.6',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76778,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76778,36.55,0.46,204,29544,70,NULL,NULL,'2MASX J11013665+1706560',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000139,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,165.402833,17.11567,0,NULL,61198636196,956228690,14941073,17),(76779,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76779,37.49,0.46,314,29545,70,NULL,NULL,'2MASX J11013889+0528139',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000175,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,165.4122083,5.4705,0.069,NULL,60320416941,942506514,14726664,17),(76780,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76780,37.13,0.19,267,29546,70,NULL,NULL,'2MASX J11013908+2921100',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,165.412833333,29.35267,0.017,NULL,60515677837,945557466,14774335,17.7),(76781,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76781,35.83,0.46,147,29547,70,NULL,NULL,'2MASX J11013985+6033533',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000171,NULL,'16.0g',0.29,'S0',NULL,NULL,NULL,NULL,1,165.415833,60.56478,0,NULL,61950806999,967981359,15124708,16),(76782,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76782,36.11,0.46,166,29548,70,NULL,NULL,'2MASX J11014354+5720059',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000172,NULL,'16.1g',0.35,'S0',NULL,NULL,NULL,NULL,1,165.431583333,57.33497,0,NULL,62007657035,968869641,15138588,16.1),(76783,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76783,37.53,0.27,320,29549,70,NULL,NULL,'SDSS J110143.79+154203.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'18.4g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,165.4324583,15.70094,0,NULL,61197439965,956209999,14940781,18.4),(76784,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76784,35.03,0.61,101,29550,70,NULL,NULL,'LCRS B105912.4-063528',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000097,NULL,'14.47',0.26,NULL,NULL,NULL,NULL,NULL,1,165.4339583,-6.86044,0.029,NULL,40897130273,639017660,9984650,14.47),(76785,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76785,36.99,0.46,250,29551,70,NULL,NULL,'2MASX J11014542+5551159',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000144,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,165.4392917,55.85453,0,NULL,61994367210,968661987,15135343,17.3),(76786,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76786,37.53,0.27,320,29552,70,NULL,NULL,'2MASX J11014546+1539430',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,165.439625,15.66208,0,NULL,61197397968,956209343,14940770,17.3),(76787,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76787,37.18,0.46,272,29553,70,NULL,NULL,'2MASX J11014557+2448530',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00018,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,165.44,24.81464,0,NULL,60486017808,945094028,14767094,16.4),(76788,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76788,37.98,0.33,395,29554,70,NULL,NULL,'SDSS J110145.89+073922.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000147,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,165.44125,7.65628,0.041,NULL,60304258883,942254045,14722719,18.6),(76789,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76789,37.11,0.46,264,29555,70,NULL,NULL,'2MASX J11014618+4209516',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000096,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,165.4425417,42.1645,0,NULL,63932060192,998938440,15608413,17.6),(76790,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76790,37.26,0.21,283,29556,70,NULL,NULL,'2MASX J11014683+1645330',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.97',0.2,NULL,NULL,NULL,NULL,NULL,1,165.4452917,16.75911,0,NULL,61199034574,956234915,14941170,17.97),(76791,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76791,37.26,0.21,283,29557,70,NULL,NULL,'2MASX J11014753+1644370',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000177,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,165.448166667,16.74353,0,NULL,61199036464,956234944,14941171,16.8),(76792,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76792,37.82,0.33,366,29558,70,NULL,NULL,'2MASX J11014831+0752397',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,165.451417,7.87786,0.025,NULL,60304464973,942257265,14722769,17.4),(76793,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76793,37.94,0.33,388,29559,70,NULL,NULL,'2MASX J11014858+3951317',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000183,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,165.4524583,39.85883,0,NULL,63935628740,998994199,15609284,16.7),(76794,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76794,36.85,0.73,234,29560,70,NULL,NULL,'2MASX J11014874-4713514',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.9I',0.3,NULL,NULL,NULL,NULL,NULL,1,165.453083,-47.23086,0.681,NULL,41923076206,655048065,10235126,14.9),(76795,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76795,37.64,0.46,337,29561,70,NULL,NULL,'2MASX J11015087+0740357',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000141,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,165.462083,7.67672,0.041,NULL,60304258569,942254040,14722719,17.6),(76796,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76796,37.81,0.46,365,29562,70,NULL,NULL,'2MASX J11015096+2901183',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000178,NULL,'17.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,165.46225,29.02189,0.027,NULL,60486187380,945096677,14767135,17.7),(76797,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76797,33.37,0.2,47.2,29563,74.4,NULL,NULL,'UGC 06104',NULL,'2013AJ....146...86T',2013,1,1.68,NULL,'G',0.000003,NULL,'14.6g',0.43,'Sbc            HII','in a pair',NULL,NULL,NULL,1,165.462333,16.60694,0,NULL,61199008434,956234506,14941164,14.6),(76798,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76798,33.47,0.43,49.4,29563,75,NULL,'3.6 micron, color corrected','UGC 06104',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76799,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76799,33.48,0.56,49.6,29563,NULL,NULL,NULL,'UGC 06104',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76800,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76800,33.48,0.56,49.7,29563,NULL,NULL,'Malmquist cor.','UGC 06104',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76801,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76801,33.58,0.43,52,29563,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06104',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76802,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76802,37.26,0.21,283,29564,70,NULL,NULL,'2MASX J11015192+1640381',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.0002,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,165.46625,16.67742,0,NULL,61199028623,956234822,14941169,16.9),(76803,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76803,34.79,0.2,90.8,29565,74.4,NULL,NULL,'CGCG 125-021',NULL,'2013AJ....146...86T',2013,1,0.73,NULL,'G',0.000103,NULL,'15.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,165.4677083,23.90258,0,NULL,60968701180,952635955,14884936,15.2),(76804,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76804,37.04,0.86,256,29566,70,NULL,NULL,'2MASX J11015250-4231334',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,165.46875,-42.52592,0.613,NULL,41898518228,654664347,10229130,15.9),(76805,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76805,37.63,0.46,336,29567,70,NULL,NULL,'2MASX J11015348+4147327',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000172,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,165.472833333,41.79239,0,NULL,63932335855,998942747,15608480,16.8),(76806,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76806,37.82,0.33,366,29568,70,NULL,NULL,'2MASX J11015383+0753577',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000147,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,165.47425,7.89928,0.057,NULL,60304463940,942257249,14722769,17),(76807,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76807,37.13,0.19,267,29569,70,NULL,NULL,'2MASX J11015428+2914593',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000164,NULL,'17.2g',0.25,'E',NULL,NULL,NULL,NULL,1,165.476291667,29.24986,0.017,NULL,60515633401,945556771,14774324,17.2),(76808,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76808,37.39,0.46,300,29570,70,NULL,NULL,'2MASX J11015480+1034277',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000153,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,165.478083,10.57433,0.017,NULL,61020293625,953442087,14897532,17.2),(76809,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76809,38.06,0.46,410,29571,70,NULL,NULL,'2MASX J11015520+2116503',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,165.48,21.28061,0,NULL,61156311190,955567362,14930740,NULL),(76810,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76810,34.57,0.49,82,29572,75,NULL,'IR','UGC 06101',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000141,NULL,'15.5g',0.3,'Sc',NULL,NULL,NULL,NULL,1,165.481417,47.09503,0,NULL,63917913214,998717393,15604959,15.5),(76811,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76811,34.66,NULL,85.7,29572,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06101',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76812,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76812,34.68,NULL,86.1,29572,NULL,NULL,'Dipole + Quadrupole','UGC 06101',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76813,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76813,34.68,NULL,86.1,29572,NULL,NULL,'Dipole','UGC 06101',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76814,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76814,34.72,NULL,88,29572,NULL,NULL,NULL,'UGC 06101',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76815,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76815,36.87,0.46,237,29573,70,NULL,NULL,'2MASX J11015560+5113519',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000178,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,165.4817083,51.23119,0,NULL,61788532175,965445815,15085090,16.5),(76816,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76816,37.82,0.46,366,29574,70,NULL,NULL,'2MASX J11015630+3942347',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000154,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,165.484625,39.70964,0,NULL,63935660877,998994701,15609292,18.1),(76817,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76817,36.22,0.76,175,29575,70,NULL,NULL,'2MASX J11015634-4729514',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.8I',0.3,NULL,NULL,NULL,NULL,NULL,1,165.484708333,-47.49758,0.713,NULL,41923096332,655048380,10235130,14.8),(76818,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76818,35.58,0.2,131,29576,74.4,NULL,NULL,'CGCG 066-101',NULL,'2013AJ....146...86T',2013,1,0.54,NULL,'G',0.000007,NULL,'15.5',0.31,'Sc','Group member',NULL,NULL,NULL,1,165.485083333,10.29075,0.021,NULL,61021888933,953467014,14897922,15.5),(76819,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76819,38.2,0.46,438,29577,70,NULL,NULL,'2MASX J11020222+1657431',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000194,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,165.5092917,16.96181,0,NULL,61198939917,956233436,14941147,17.6),(76820,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76820,36.99,0.46,250,29578,70,NULL,NULL,'2MASX J11020248+1922103',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.88',0.21,NULL,NULL,NULL,NULL,NULL,1,165.51025,19.36956,0,NULL,61169242548,955769414,14933897,17.88),(76821,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76821,38.07,0.46,412,29579,70,NULL,NULL,'2MASX J11020318+2837084',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000184,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,165.513333,28.619,0.015,NULL,60487091500,945110804,14767356,17.6),(76822,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76822,37.81,0.46,365,29580,70,NULL,NULL,'2MASX J11020336+1201111',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00018,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,165.513875,12.01983,0,NULL,61138488632,955288884,14926388,17.2),(76823,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76823,37.91,0.46,382,29581,70,NULL,NULL,'2MASX J11020332+3655297',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000199,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,165.513916667,36.92497,0,NULL,63921981036,998780953,15605952,16.5),(76824,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76824,34.69,0.56,86.8,29582,70,NULL,NULL,'2MASX J11020386-0932053',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000087,NULL,'15.98',0.4,NULL,NULL,NULL,NULL,NULL,1,165.5160417,-9.53511,0.021,NULL,41776722364,652761286,10199395,15.98),(76825,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76825,35.75,0.23,141,29583,70,NULL,NULL,'IC 2616',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000206,NULL,'15.1g',0.61,NULL,NULL,NULL,NULL,NULL,1,165.524,38.78725,0,NULL,63924050768,998813293,15606457,15.1),(76826,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76826,35.75,0.23,141,29584,70,NULL,NULL,'IC 2617',NULL,'2015arXiv151105856S',2015,1,1.04,NULL,'G',0.00011,NULL,'14.6g',0.53,NULL,NULL,NULL,NULL,NULL,1,165.5317917,38.66425,0,NULL,63924067145,998813549,15606461,14.6),(76827,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76827,37.41,0.46,304,29585,70,NULL,NULL,'2MASX J11020905+3200499',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000174,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,165.53775,32.01397,0.037,NULL,60508228971,945441077,14772516,16.8),(76828,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76828,38.02,0.65,402,29586,70,NULL,NULL,'2MASX J11020997-4655413',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,165.541417,-46.92811,0.681,NULL,41922139046,655033422,10234897,17),(76829,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76829,36.9,0.46,240,29587,70,NULL,NULL,'SDSS J110210.84+064517.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.0001,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,165.5452083,6.75483,0.045,NULL,60303045752,942235089,14722423,18.2),(76830,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76830,35.64,0.27,134,29588,70,NULL,NULL,'2MASX J11021113+1839223',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.43',0.27,NULL,NULL,NULL,NULL,NULL,1,165.546333333,18.65625,0,NULL,61164142179,955689721,14932651,17.43),(76831,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76831,34.62,0.47,83.9,29589,NULL,NULL,'H','UGC 06106',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000143,NULL,'14.41',0.6,'SBb?','in a radial-velocity based grouping',NULL,NULL,NULL,1,165.546625,45.889,0,NULL,63909799081,998590610,15602978,14.41),(76832,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76832,34.72,0.2,87.9,29589,74.4,NULL,NULL,'UGC 06106',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76833,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76833,34.73,0.45,88.1,29589,NULL,NULL,'K','UGC 06106',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76834,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76834,34.73,0.46,88.3,29589,NULL,NULL,'J','UGC 06106',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76835,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76835,34.84,0.4,92.8,29589,NULL,NULL,'mean','UGC 06106',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76836,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76836,37.59,0.33,330,29590,70,NULL,NULL,'2MASX J11021237+2215033',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.58',0.13,NULL,NULL,NULL,NULL,NULL,1,165.551667,22.25081,0,NULL,61156664265,955572879,14930826,18.58),(76837,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76837,37.59,0.33,330,29591,70,NULL,NULL,'2MASX J11021419+2224533',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,165.5592083,22.41483,0,NULL,61153239334,955519364,14929990,18.2),(76838,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76838,35.6,0.46,132,29592,70,NULL,NULL,'IC 2619',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000172,NULL,'15.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,165.563583,37.96608,0,NULL,63924409077,998818891,15606545,15.8),(76839,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76839,36.38,0.46,189,29593,70,NULL,NULL,'2MASX J11021553+1031016',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000143,NULL,'16.2g',0.32,'S0','Group member',NULL,NULL,NULL,1,165.564666667,10.51719,0.017,NULL,61020284064,953441938,14897530,16.2),(76840,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76840,37.38,0.46,299,29594,70,NULL,NULL,'SDSS J110215.68+290725.2',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000177,NULL,'16.2g',0.35,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,165.565333,29.12367,0.027,NULL,60486166455,945096350,14767130,16.2),(76841,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76841,36.01,0.46,159,29595,70,NULL,NULL,'2MASX J11021643+3443179',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000167,NULL,'16.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,165.5684583,34.72164,0,NULL,60633845805,947403840,14803185,16.2),(76842,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76842,35.67,0.46,136,29596,70,NULL,NULL,'CGCG 241-063',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000157,NULL,'15.0g',0.57,'E0',NULL,NULL,NULL,NULL,1,165.568708333,44.27169,0,NULL,63942056333,999094630,15610853,15),(76843,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76843,38.73,0.46,557,29597,70,NULL,NULL,'SDSS J110216.99+182202.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,165.570833,18.36744,0,NULL,61164263395,955691615,14932681,18.3),(76844,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76844,37.82,0.46,366,29598,70,NULL,NULL,'2MASX J11021704+0610266',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,165.571083333,6.174,0.065,NULL,60302666613,942229165,14722330,17.1),(76845,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76845,37.32,0.33,291,29599,70,NULL,NULL,'SDSS J110217.09+270309.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000166,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,165.5712083,27.05261,0.021,NULL,60489052492,945141445,14767835,18.3),(76846,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76846,38.11,0.46,419,29600,70,NULL,NULL,'SDSS J110217.76+074010.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000146,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,165.574,7.6695,0.061,NULL,60304235856,942253685,14722713,18.5),(76847,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76847,38.32,0.33,462,29601,70,NULL,NULL,'SDSS J110218.26+085127.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000135,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,165.576125,8.85753,0.045,NULL,61020887322,953451364,14897677,18.3),(76848,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76848,38.32,0.33,462,29602,70,NULL,NULL,'SDSS J110219.16+084918.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,165.579833,8.82186,0.045,NULL,61020888817,953451387,14897677,18.3),(76849,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76849,37.91,0.46,382,29603,70,NULL,NULL,'2MASX J11021959+0720106',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000134,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,165.58175,7.33647,0.061,NULL,60304188007,942252937,14722702,18.4),(76850,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76850,38.13,0.46,423,29604,70,NULL,NULL,'2MASX J11022025+3144485',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000192,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,165.5844583,31.74708,0.067,NULL,60508212975,945440827,14772512,16.9),(76851,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76851,36.61,0.46,209,29605,70,NULL,NULL,'2MASX J11022032+5150520',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000166,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,165.584875,51.84767,0,NULL,61788950138,965452345,15085192,16.3),(76852,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76852,35.84,0.21,147,29606,70,NULL,NULL,'CGCG 066-103',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000042,NULL,'15.0g',0.63,'E/S0','Group member',NULL,NULL,NULL,1,165.586375,10.24314,0.013,NULL,61021945413,953467897,14897935,15),(76853,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76853,36.04,0.46,162,29607,70,NULL,NULL,'CGCG 066-104',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.0002,NULL,'15.0',0.4,'(R)SAB0-',NULL,NULL,NULL,NULL,1,165.5887917,8.48775,0.049,NULL,60312002204,942375034,14724609,15),(76854,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76854,35.7,0.46,138,29608,70,NULL,NULL,'2MASX J11022145+2939333',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000163,NULL,'15.9g',0.36,'Sa',NULL,NULL,NULL,NULL,1,165.5895,29.65911,0,NULL,60507064444,945422881,14772232,15.9),(76855,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76855,37.86,0.46,373,29609,70,NULL,NULL,'2MASX J11022241+3509466',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,165.593125,35.16308,0,NULL,60633018448,947390913,14802983,17.9),(76856,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76856,35.51,0.46,126,29610,70,NULL,NULL,'2MASX J11022275+0803096',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000169,NULL,'15.9g',0.43,'E0',NULL,NULL,NULL,NULL,1,165.5947917,8.05264,0.057,NULL,60312071834,942376122,14724626,15.9),(76857,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76857,36.39,0.2,190,29611,74.4,NULL,NULL,'2MASX J11022380+1020376',NULL,'2013AJ....146...86T',2013,1,0.58,NULL,'G',0.000022,NULL,'16.2g',0.33,'Sc','Group member',NULL,NULL,NULL,1,165.59925,10.34361,0.021,NULL,61021918655,953467478,14897929,16.2),(76858,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76858,37.41,0.46,304,29612,70,NULL,NULL,'2MASX J11022384+3826042',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,165.5995,38.43458,0,NULL,63924036790,998813074,15606454,17.2),(76859,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76859,37.42,0.46,305,29613,70,NULL,NULL,'2MASX J11022391+0833216',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,165.5995417,8.55606,0.045,NULL,60312009805,942375153,14724611,17.6),(76860,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76860,35.75,0.23,141,29614,70,NULL,NULL,'IC 2620',NULL,'2015arXiv151105856S',2015,1,0.95,NULL,'G',0.000163,NULL,'14.5g',0.78,'COMPACT',NULL,NULL,NULL,NULL,1,165.5997917,38.50503,0,NULL,63924038250,998813097,15606454,14.5),(76861,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76861,34.97,0.71,98.7,29615,70,NULL,NULL,'LCRS B105952.8-062557',NULL,'2014MNRAS.445.2677S',2014,1,0.89,NULL,'G',0.00008,NULL,'15.02',0.54,NULL,NULL,NULL,NULL,NULL,1,165.6024583,-6.70206,0.029,NULL,40897198385,639018724,9984667,15.02),(76862,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76862,37.11,0.46,265,29616,70,NULL,NULL,'2MASXi J1102257+444258',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000145,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,165.6072917,44.71644,0,NULL,63941516738,999086199,15610721,17.7),(76863,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76863,36.79,0.46,228,29617,70,NULL,NULL,'2MASX J11022700+2718178',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000183,NULL,'16.1g',0.31,NULL,NULL,NULL,NULL,NULL,1,165.612458333,27.305,0.021,NULL,60488994268,945140535,14767820,16.1),(76864,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76864,38.6,0.46,525,29618,70,NULL,NULL,'SDSS J110228.09+111627.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,165.617083,11.27422,0.013,NULL,61020651877,953447685,14897620,18.3),(76865,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76865,35.63,0.2,134,29619,74.4,NULL,NULL,'SDSS J110228.54+095852.1',NULL,'2013AJ....146...86T',2013,1,0.42,NULL,'G',0.000019,NULL,'16.9g',0.24,'Sc','Group member',NULL,NULL,NULL,1,165.618916667,9.98117,0,NULL,61021576597,953462134,14897845,16.9),(76866,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76866,38.98,0.46,625,29620,70,NULL,NULL,'SDSS J110229.47+164204.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000186,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,165.622833,16.70114,0,NULL,61199055408,956235240,14941175,18.3),(76867,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76867,37.13,0.19,267,29621,70,NULL,NULL,'2MASX J11022961+2907509',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,165.623333,29.13094,0.008,NULL,60486294638,945098353,14767161,17.2),(76868,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76868,37.2,0.46,275,29622,70,NULL,NULL,'2MASX J11022970-0024005',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000093,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,165.62375,-0.40017,0.105,NULL,40909311726,639207995,9987624,16.5),(76869,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76869,37.23,0.46,280,29623,70,NULL,NULL,'2MASX J11022998+1057396',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,165.625,10.96097,0.017,NULL,61020785571,953449774,14897652,17.2),(76870,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76870,35.64,0.27,134,29624,70,NULL,NULL,'SDSS J110230.07+184706.5',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.2g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,165.625333,18.78517,0,NULL,61164114500,955689289,14932645,16.2),(76871,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76871,37.71,0.46,348,29625,70,NULL,NULL,'2MASX J11023130-0026255',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000109,NULL,'17.0g',0.24,'AGN',NULL,NULL,NULL,NULL,1,165.630417,-0.44033,0.105,NULL,40910015357,639218989,9987796,17),(76872,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76872,37.09,0.46,261,29626,70,NULL,NULL,'2MASX J11023365+5131248',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.0002,NULL,'16.0g',0.38,'E0',NULL,NULL,NULL,NULL,1,165.640167,51.52342,0,NULL,61788996832,965453075,15085204,16),(76873,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76873,35.64,0.27,134,29627,70,NULL,NULL,'2MASXi J1102337+184207',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.8g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,165.640625,18.70214,0,NULL,61164144090,955689751,14932652,16.8),(76874,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76874,35.94,0.46,155,29628,70,NULL,NULL,'2MASX J11023445+2229273',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.00',0.16,NULL,NULL,NULL,NULL,NULL,1,165.643666667,22.49103,0,NULL,61153243797,955519434,14929991,18),(76875,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76875,31.56,0.4,20.5,29629,75,NULL,'B','UGC 06112',NULL,'1988NBGC.C....0000T',1988,1,2.5,NULL,'G',0.00002,NULL,'13.90',0.8,'Sd?','in a radial-velocity based grouping',NULL,NULL,NULL,1,165.647083,16.73472,0,NULL,61199054959,956235233,14941175,13.9),(76876,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76876,32.05,NULL,25.7,29629,NULL,NULL,NULL,'UGC 06112',NULL,'2015AstBu..70....1K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76877,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76877,37.81,0.46,365,29630,70,NULL,NULL,'2MASX J11023582+0414210',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000157,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,165.649375,4.23928,0.165,NULL,60329834291,942653660,14728963,17.2),(76878,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76878,38.24,0.46,445,29631,70,NULL,NULL,'2MASX J11023665+2524179',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000205,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,165.652875,25.40483,0,NULL,60483252591,945050821,14766419,17),(76879,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76879,38.06,0.46,410,29632,70,NULL,NULL,'2MASX J11023710+0609076',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000179,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,165.654667,6.15211,0.065,NULL,60302659311,942229051,14722328,17.2),(76880,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76880,37.13,0.19,267,29633,70,NULL,NULL,'SDSS J110238.41+291525.3',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.0002,NULL,'16.2g',0.37,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,165.660083333,29.25706,0,NULL,60486075734,945094933,14767108,16.2),(76881,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76881,37.4,0.21,302,29634,70,NULL,NULL,'2MASX J11023914+0728076',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000167,NULL,'16.5g',0.39,NULL,NULL,NULL,NULL,NULL,1,165.663083,7.46881,0.061,NULL,60312304993,942379765,14724683,16.5),(76882,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76882,35.6,0.46,132,29635,70,NULL,NULL,'2MASX J11024137+2500279',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000158,NULL,'16.0g',0.32,NULL,NULL,NULL,NULL,NULL,1,165.6725,25.00772,0,NULL,60485904184,945092252,14767066,16),(76883,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76883,37.19,0.46,275,29636,70,NULL,NULL,'2MASX J11024290+0748096',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,165.678667,7.80275,0.057,NULL,60312447008,942381984,14724718,17.7),(76884,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76884,35.99,0.46,158,29637,70,NULL,NULL,'CGCG 038-096',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.00013,NULL,'15.5g',0.5,'E',NULL,NULL,NULL,NULL,1,165.682333,5.38119,0.069,NULL,60328984771,942640387,14728756,15.5),(76885,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76885,38.34,0.46,465,29638,70,NULL,NULL,'2MASX J11024377+1046036',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00018,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,165.6824583,10.76775,0.017,NULL,61020134655,953439603,14897493,17.4),(76886,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76886,37.78,0.27,360,29639,70,NULL,NULL,'2MASX J11024521+0039385',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000078,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,165.688167,0.66072,0.045,NULL,60290950865,942046107,14719470,17.4),(76887,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76887,37.07,0.46,260,29640,70,NULL,NULL,'2MASX J11024517+2602079',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00017,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,165.688167,26.03558,0,NULL,60483833342,945059895,14766560,16.4),(76888,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76888,38.18,0.33,433,29641,70,NULL,NULL,'2MASX J11024561+5002435',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000167,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,165.690125,50.04536,0,NULL,63913954378,998655537,15603992,18.3),(76889,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76889,38.18,0.33,433,29642,70,NULL,NULL,'SDSS J110245.69+495853.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,165.690417,49.98147,0,NULL,63913966551,998655727,15603995,18.1),(76890,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76890,37.6,0.46,331,29643,70,NULL,NULL,'2MASX J11024599+5257335',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000136,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,165.691583333,52.95928,0,NULL,61788197005,965440578,15085009,17.9),(76891,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76891,37.4,0.46,302,29644,70,NULL,NULL,'2MASX J11024682+3704213',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000151,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,165.695167,37.07261,0,NULL,63925131282,998830176,15606721,17),(76892,'IRAS','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76892,31.5,0.8,19.9,29645,75,NULL,'A82, H','NGC 3501',NULL,'1997ApJS..109..333W',1997,1,4.4,NULL,'G',0.000004,NULL,'13.5g',0.56,'Scd','Pair member (points to parent)',NULL,NULL,NULL,1,165.696958333,17.98933,0,NULL,61163945993,955686656,14932604,13.5),(76893,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76893,31.45,0.4,19.5,29645,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 3501',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76894,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76894,31.57,0.4,20.6,29645,75,NULL,NULL,'NGC 3501',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76895,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76895,31.67,0.43,21.5,29645,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3501',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76896,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76896,31.69,0.4,21.7,29645,75,NULL,'B','NGC 3501',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76897,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76897,31.7,0.42,21.9,29645,NULL,NULL,'Malmquist cor.','NGC 3501',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76898,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76898,31.79,0.38,22.8,29645,NULL,NULL,NULL,'NGC 3501',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76899,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76899,31.81,0.43,23,29645,75,NULL,'3.6 micron, color corrected','NGC 3501',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76900,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76900,31.9,0.2,24,29645,74.4,NULL,NULL,'NGC 3501',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76901,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76901,31.91,0.4,24.1,29645,NULL,NULL,'mean','NGC 3501',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76902,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76902,31.91,0.46,24.1,29645,NULL,NULL,'J','NGC 3501',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76903,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76903,31.92,0.47,24.2,29645,75,NULL,'A82, H, raw','NGC 3501',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76904,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76904,31.93,NULL,24.3,29645,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 3501',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76905,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76905,31.94,NULL,24.5,29645,NULL,NULL,'Dipole + Quadrupole','NGC 3501',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76906,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76906,31.95,NULL,24.5,29645,NULL,NULL,'Dipole','NGC 3501',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76907,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76907,31.96,0.47,24.6,29645,75,NULL,'A82, H, inv','NGC 3501',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76908,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76908,32.02,0.47,25.3,29645,NULL,NULL,'H','NGC 3501',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76909,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76909,32.02,0.45,25.4,29645,NULL,NULL,'K','NGC 3501',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76910,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76910,32.04,0.35,25.6,29645,NULL,NULL,NULL,'NGC 3501',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76911,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76911,32.04,NULL,25.6,29645,NULL,NULL,NULL,'NGC 3501',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76912,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76912,32.06,0.47,25.8,29645,75,NULL,'A82, H, cor','NGC 3501',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76913,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76913,32.12,0.49,26.5,29645,75,NULL,'IR','NGC 3501',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76914,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76914,37.09,0.46,262,29646,70,NULL,NULL,'2MASX J11024813+0000301',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000087,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,165.7005,0.00831,0.053,NULL,60290014141,942031470,14719241,16.9),(76915,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76915,37.85,0.46,372,29647,70,NULL,NULL,'2MASX J11024881+3819223',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,165.70325,38.32297,0,NULL,63924438535,998819352,15606552,17.4),(76916,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76916,35.73,0.49,140,29648,70,NULL,NULL,'2MASX J11024897-4653511',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000127,NULL,'15.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,165.7039583,-46.89753,0.681,NULL,41922196505,655034320,10234911,15.7),(76917,'IRAS','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76917,33.53,0.8,50.7,29649,75,NULL,'MAT, I','ESO 502- G 012',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000026,NULL,'14.19',0.8,'(R:)SA:(s)ab   HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,165.708833,-23.59161,0.229,NULL,41625171323,650393301,10162395,14.19),(76918,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76918,32.91,0.32,38.2,29649,85,NULL,'I, raw','ESO 502- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76919,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76919,32.93,0.32,38.5,29649,85,NULL,'I, inv','ESO 502- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76920,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76920,33.19,0.43,43.4,29649,75,NULL,'MAT, I, raw','ESO 502- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76921,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76921,33.22,0.2,44.1,29649,74.4,NULL,NULL,'ESO 502- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76922,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76922,33.32,0.43,46.1,29649,75,NULL,'MAT, I, inv','ESO 502- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76923,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76923,33.51,0.43,50.3,29649,75,NULL,'MAT, I, cor','ESO 502- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76924,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76924,33.74,0.4,55.9,29649,NULL,NULL,'mean','ESO 502- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76925,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76925,33.78,0.09,57.1,29649,NULL,NULL,NULL,'ESO 502- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76926,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76926,33.89,0.46,60,29649,NULL,NULL,'J','ESO 502- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76927,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76927,33.9,0.47,60.1,29649,NULL,NULL,'H','ESO 502- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76928,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76928,34,0.45,63.1,29649,NULL,NULL,'K','ESO 502- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76929,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76929,37.13,0.19,267,29650,70,NULL,NULL,'2MASX J11025151+2902009',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'16.8g',0.26,'E',NULL,NULL,NULL,NULL,1,165.714666667,29.03353,0.008,NULL,60486260619,945097822,14767153,16.8),(76930,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76930,37.43,0.46,306,29651,70,NULL,NULL,'2MASX J11025155+2602308',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000187,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,165.7147083,26.04189,0,NULL,60483832228,945059878,14766560,16.7),(76931,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76931,37.37,0.46,298,29652,70,NULL,NULL,'2MASX J11025222+0443245',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,165.717625,4.72353,0.121,NULL,60329395995,942646812,14728856,17.7),(76932,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76932,37.78,0.27,360,29653,70,NULL,NULL,'2MASX J11025234+0040375',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000066,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,165.718167,0.67708,0.045,NULL,60290949815,942046090,14719470,17.9),(76933,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76933,36.83,0.46,232,29654,70,NULL,NULL,'2MASX J11025295+3623083',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000161,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,165.720833,36.38569,0.018,NULL,63921622534,998775352,15605864,17.3),(76934,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76934,37.08,0.46,260,29655,70,NULL,NULL,'2MASX J11025303+1212237',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,165.7210417,12.20664,0,NULL,61138408577,955287634,14926369,17),(76935,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76935,38.72,0.46,554,29656,70,NULL,NULL,'2MASX J11025481+4827435',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,165.728375,48.46206,0,NULL,63920723112,998761298,15605645,18.2),(76936,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76936,37.4,0.21,302,29657,70,NULL,NULL,'2MASX J11025945+0738026',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000139,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,165.747875,7.63414,0.061,NULL,60312480356,942382505,14724726,17.4),(76937,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76937,37.25,0.33,282,29658,70,NULL,NULL,'2MASX J11025963+3157076',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000169,NULL,'17.4g',NULL,NULL,NULL,NULL,NULL,NULL,1,165.7484583,31.95233,0.039,NULL,60639278417,947488725,14804511,17.4),(76938,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76938,37.03,0.72,254,29659,70,NULL,NULL,'2MASX J11025994-0132498',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.4b',0.27,NULL,NULL,NULL,NULL,NULL,1,165.7497083,-1.54717,0.129,NULL,40908423014,639194109,9987407,16.4),(76939,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76939,36.98,0.46,249,29660,70,NULL,NULL,'2MASX J11030158+0600286',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,165.756625,6.00803,0.069,NULL,60309952752,942343011,14724109,17.8),(76940,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76940,32.88,NULL,37.6,29661,NULL,NULL,NULL,'AGC 202040',NULL,'2015AstBu..70....1K',2015,1,0.6,NULL,'G',0.00016,NULL,'18.1B',0.3,NULL,NULL,NULL,NULL,NULL,1,165.757083,8.04806,0.057,NULL,60312965408,942390084,14724845,18.1),(76941,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76941,36.19,0.59,173,29662,70,NULL,NULL,'2MASX J11030175-1735180',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,165.757375,-17.58839,0.177,NULL,41866809565,654168899,10221389,16.2),(76942,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76942,37.4,0.21,302,29663,70,NULL,NULL,'2MASX J11030187+0736226',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000183,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,165.757875,7.60639,0.061,NULL,60312475577,942382430,14724725,17),(76943,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76943,37.61,0.46,332,29664,70,NULL,NULL,'2MASX J11030188+0808466',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,165.757875,8.14614,0.057,NULL,60312086974,942376358,14724630,17.8),(76944,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76944,38.46,0.46,492,29665,70,NULL,NULL,'2MASX J11030207+0730536',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,165.75875,7.51506,0.061,NULL,60312306084,942379782,14724684,17.6),(76945,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76945,38.78,0.46,571,29666,70,NULL,NULL,'2MASX J11030340+2227454',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000183,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,165.7642917,22.4625,0,NULL,61153447509,955522617,14930040,17.4),(76946,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76946,38.02,0.46,402,29667,70,NULL,NULL,'2MASX J11030366+3853534',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000185,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,165.765125,38.89828,0,NULL,63935120672,998986260,15609160,17.4),(76947,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76947,35.04,0.46,102,29668,70,NULL,NULL,'CGCG 314-004',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.00015,NULL,'14.5g',0.71,'E/S0',NULL,NULL,NULL,NULL,1,165.767625,64.77422,0.033,NULL,61866279042,966660610,15104072,14.5),(76948,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76948,38.45,0.46,491,29669,70,NULL,NULL,'SDSS J110304.75+024905.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000149,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,165.769833333,2.81817,0.133,NULL,60323531047,942555172,14727424,18.2),(76949,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76949,37.04,0.46,256,29670,70,NULL,NULL,'2MASX J11030480+4405301',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,165.770125,44.09169,0,NULL,63942111734,999095495,15610867,17.1),(76950,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76950,38.61,0.46,528,29671,70,NULL,NULL,'SDSS J110305.79+025615.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000136,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,165.774125,2.93778,0.125,NULL,60327738113,942620908,14728451,18.4),(76951,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76951,35.46,0.46,123,29672,70,NULL,NULL,'CGCG 155-048',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00015,NULL,'15.2g',0.42,NULL,NULL,NULL,NULL,NULL,1,165.776833333,26.2325,0.008,NULL,60496735531,945261492,14769710,15.2),(76952,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76952,36.79,0.46,228,29673,70,NULL,NULL,'2MASX J11030689+3544156',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000187,NULL,'15.9g',0.46,NULL,NULL,NULL,NULL,NULL,1,165.778875,35.73764,0.041,NULL,60414942827,943983481,14749741,15.9),(76953,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76953,37.13,0.19,267,29674,70,NULL,NULL,'2MASX J11030716+2915047',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000127,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,165.7800417,29.25131,0,NULL,60486078905,945094982,14767109,17.2),(76954,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76954,36.86,0.46,236,29675,70,NULL,NULL,'2MASX J11030747+0517291',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000176,NULL,'16.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,165.781167,5.29128,0.069,NULL,60315243738,942425683,14725401,16.7),(76955,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76955,38.2,0.46,437,29676,70,NULL,NULL,'SDSS J110308.03-001728.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000078,NULL,'18.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,165.7835,-0.29117,0.105,NULL,40909370144,639208908,9987639,18.1),(76956,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76956,38.6,0.46,525,29677,70,NULL,NULL,'SDSS J110308.48+274755.4',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000165,NULL,'18.7g',0.09,NULL,NULL,NULL,NULL,NULL,1,165.785375,27.79872,0.023,NULL,60488515820,945133059,14767704,18.7),(76957,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76957,37.8,0.46,364,29678,70,NULL,NULL,'2MASX J11030911+3526246',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000185,NULL,'16.7g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,165.787917,35.44036,0.026,NULL,60414842161,943981908,14749717,16.7),(76958,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76958,37.37,0.46,298,29679,70,NULL,NULL,'2MASX J11030944+5225445',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000087,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,165.789625,52.42919,0,NULL,61787693227,965432706,15084886,16.7),(76959,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76959,37.25,0.33,282,29680,70,NULL,NULL,'2MASX J11031055+3152506',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,165.7939583,31.88089,0.042,NULL,60639273157,947488643,14804510,18.1),(76960,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76960,37.95,0.46,389,29681,70,NULL,NULL,'2MASX J11031064+2329574',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000144,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,165.7944583,23.49931,0,NULL,60969443885,952647560,14885118,17.3),(76961,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76961,37.78,0.27,360,29682,70,NULL,NULL,'2MASX J11031074+0040461',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000083,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,165.79475,0.6795,0.081,NULL,60290906568,942045415,14719459,17.1),(76962,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76962,38.09,0.46,415,29683,70,NULL,NULL,'2MASX J11031084-0057132',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000084,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,165.795291667,-0.95369,0.113,NULL,40909776855,639215263,9987738,17.5),(76963,'Tully est','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76963,32.12,0.8,26.5,29684,75,NULL,'B','NGC 3504',NULL,'1988NBGC.C....0000T',1988,1,2.7,NULL,'G',0.000007,NULL,'11.4B',2.1,'(R)SAB(s)ab    HII','in a radial-velocity based grouping',NULL,NULL,'Starburst',1,165.7967083,27.9725,0.02,NULL,60489507492,945148554,14767946,11.4),(76964,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76964,30.66,NULL,13.6,29684,NULL,NULL,'B','NGC 3504',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76965,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76965,37.8,0.46,363,29685,70,NULL,NULL,'2MASX J11031198+0145071',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00018,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,165.799833,1.75208,0.137,NULL,60291780489,942059070,14719672,16.9),(76966,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76966,37.27,0.46,285,29686,70,NULL,NULL,'2MASX J11031193+3732074',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.81',0.22,NULL,NULL,NULL,NULL,NULL,1,165.799875,37.53539,0,NULL,63925385995,998834156,15606783,17.81),(76967,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76967,37.4,0.21,302,29687,70,NULL,NULL,'2MASX J11031428+0733503',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000181,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,165.8097083,7.56411,0.061,NULL,60312494957,942382733,14724730,16.9),(76968,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76968,37.98,0.46,394,29688,70,NULL,NULL,'2MASX J11031440+0902283',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00016,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,165.810125,9.04125,0.045,NULL,61021077264,953454332,14897723,17.4),(76969,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76969,34.1,0.46,66,29689,70,NULL,NULL,'UGC 06119',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.000163,NULL,'14.3g',0.45,'S0^0^','in a pair',NULL,NULL,NULL,1,165.810375,3.34231,2.277,NULL,60316346273,942442910,14725670,14.3),(76970,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76970,38.33,0.46,464,29690,70,NULL,NULL,'2MASX J11031463+4006283',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000181,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,165.810875,40.10806,0,NULL,63935507511,998992304,15609254,17.6),(76971,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76971,36.48,0.46,198,29691,70,NULL,NULL,'MCG +09-18-079',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.00018,NULL,'15.6g',0.38,'E0',NULL,NULL,NULL,NULL,1,165.815708333,54.11128,0,NULL,61965018900,968203420,15128178,15.6),(76972,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76972,37.38,0.33,300,29692,70,NULL,NULL,'2MASX J11031576+1914123',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.71',0.21,NULL,NULL,NULL,NULL,NULL,1,165.815833,19.23678,0.007,NULL,61164499545,955695305,14932739,17.71),(76973,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76973,35.96,0.46,156,29693,70,NULL,NULL,'2MASX J11031632+1906513',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.31',0.19,NULL,NULL,NULL,NULL,NULL,1,165.817958333,19.11414,0,NULL,61164514097,955695532,14932742,16.31),(76974,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76974,37.68,0.46,344,29694,70,NULL,NULL,'2MASX J11031636+0742103',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000182,NULL,'16.4g',0.37,'AGN',NULL,NULL,NULL,NULL,1,165.818291667,7.70275,0.061,NULL,60312512834,942383013,14724734,16.4),(76975,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76975,36.7,0.46,219,29695,70,NULL,NULL,'2MASX J11031708+2806167',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000142,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,165.821375,28.10475,0.02,NULL,60489498609,945148415,14767943,17.2),(76976,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76976,38.04,0.46,406,29696,70,NULL,NULL,'SDSS J110317.27+525716.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000107,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,165.822,52.95464,0,NULL,61788207403,965440740,15085011,18.4),(76977,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76977,36.98,0.46,248,29697,70,NULL,NULL,'MCG +10-16-048',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000181,NULL,'16.0g',0.39,'E0',NULL,NULL,NULL,NULL,1,165.822125,57.16389,0,NULL,62007561722,968868151,15138564,16),(76978,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76978,37.38,0.33,300,29698,70,NULL,NULL,'2MASX J11031767+1916113',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,165.8237083,19.26981,0.007,NULL,61164502771,955695355,14932739,NULL),(76979,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76979,37.12,0.46,266,29699,70,NULL,NULL,'2MASX J11031787+3533536',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00018,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,165.824667,35.56503,0.026,NULL,60414955219,943983675,14749744,16.3),(76980,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76980,36.98,0.59,249,29700,70,NULL,NULL,'2MASX J11031846-1521464',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.46',NULL,NULL,NULL,NULL,NULL,NULL,1,165.826875,-15.36317,0.101,NULL,41820322022,653442531,10210039,16.46),(76981,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76981,37.29,0.46,287,29701,70,NULL,NULL,'2MASX J11031858+3347266',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,165.8275417,33.79069,0,NULL,60634593149,947415517,14803367,17.5),(76982,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76982,36.27,0.33,179,29702,70,NULL,NULL,'2MASX J11031925+1620014',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000169,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,165.8302083,16.33378,0,NULL,61198349529,956224211,14941003,16.6),(76983,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76983,37.4,0.21,302,29703,70,NULL,NULL,'2MASX J11032040+0730463',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000189,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,165.8350417,7.51278,0.061,NULL,60312279788,942379371,14724677,16.3),(76984,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76984,37.3,0.46,288,29704,70,NULL,NULL,'SDSS J110320.88+075534.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,165.8370417,7.92614,0.057,NULL,60312937818,942389653,14724838,17.6),(76985,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76985,36.61,0.33,210,29705,70,NULL,NULL,'CGCG 038-103',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000188,NULL,'15.6g',0.45,'SAB(r)0-:','Group member',NULL,NULL,NULL,1,165.838416667,6.84117,0.037,NULL,60310627158,942353549,14724274,15.6),(76986,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76986,36.38,0.46,189,29706,70,NULL,NULL,'MCG +09-18-081',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000198,NULL,'15.5g',0.5,'E0',NULL,NULL,NULL,NULL,1,165.840333,55.67086,0,NULL,61994386590,968662290,15135348,15.5),(76987,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',76987,38.09,0.46,415,29707,70,NULL,NULL,'SDSS J110322.59+290850.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000141,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,165.844167,29.14742,0,NULL,60486283609,945098181,14767159,18.6),(76988,'IRAS','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76988,30.65,0.8,13.5,29708,75,NULL,'MAT, I','NGC 3511',NULL,'1997ApJS..109..333W',1997,1,5.8,'Extended HIPASS source','G',0.00001,NULL,'11.53',2,'SAB(s)c;HII    Sy1','in a pair',NULL,NULL,NULL,1,165.8490417,-23.08678,0.205,NULL,41624676425,650385569,10162274,11.53),(76989,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76989,30.3,0.4,11.5,29708,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 3 galaxy group','NGC 3511',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76990,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76990,30.41,0.43,12.1,29708,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3511',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76991,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76991,30.44,0.36,12.2,29708,NULL,NULL,NULL,'NGC 3511',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76992,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76992,30.43,0.39,12.2,29708,73,NULL,'opt','NGC 3511',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76993,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76993,30.45,0.43,12.3,29708,75,NULL,'3.6 micron, color corrected','NGC 3511',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76994,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76994,30.45,0.2,12.3,29708,74.4,NULL,NULL,'NGC 3511',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76995,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76995,30.54,0.32,12.8,29708,85,NULL,'I, raw','NGC 3511',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76996,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76996,30.56,0.46,12.9,29708,NULL,NULL,NULL,'NGC 3511',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76997,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76997,30.55,0.32,12.9,29708,85,NULL,'I, inv','NGC 3511',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76998,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76998,30.7,0.43,13.8,29708,75,NULL,'MAT, I, raw','NGC 3511',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76999,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,76999,30.74,0.46,14,29708,NULL,NULL,'J','NGC 3511',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77000,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77000,30.81,0.41,14.5,29708,NULL,NULL,'Malmquist cor.','NGC 3511',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77001,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77001,30.81,0.47,14.5,29708,NULL,NULL,'H','NGC 3511',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77002,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77002,30.85,0.43,14.8,29708,75,NULL,'MAT, I, inv','NGC 3511',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77003,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77003,30.95,0.4,15.5,29708,75,NULL,'B','NGC 3511',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77004,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77004,30.95,0.43,15.5,29708,75,NULL,'MAT, I, cor','NGC 3511',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77005,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77005,30.95,0.45,15.5,29708,NULL,NULL,'K','NGC 3511',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77006,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77006,31.2,0.4,17.4,29708,NULL,NULL,'mean','NGC 3511',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77007,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77007,37.53,0.27,321,29709,70,NULL,NULL,'SDSS J110324.75-003513.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000069,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,165.853125,-0.58711,0.109,NULL,40909290875,639207669,9987619,18.2),(77008,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77008,38.79,0.46,573,29710,70,NULL,NULL,'SDSS J110325.36+304120.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,165.8557083,30.689,0.015,NULL,60637809056,947465766,14804152,18.7),(77009,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77009,30.36,0.4,11.8,29711,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 3 galaxy group','NGC 3507',NULL,'1992ApJS...80..479T',1992,1,3.4,NULL,'G',0.000013,NULL,'11.73',2.9,'SB(s)b         LINER','Pair member (points to parent)',NULL,NULL,NULL,1,165.855667,18.13544,0,NULL,61163717035,955683078,14932548,11.73),(77010,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77010,31.48,0.4,19.8,29711,75,NULL,'B','NGC 3507',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77011,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77011,32.87,NULL,37.5,29712,NULL,NULL,NULL,'LSBC F640-02',NULL,'2015AstBu..70....1K',2015,1,0.82,NULL,'G',0.000175,NULL,'16.6g',0.31,'S/smooth',NULL,NULL,NULL,NULL,1,165.8597917,16.01617,0,NULL,61197292984,956207702,14940745,16.6),(77012,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77012,38.21,0.46,439,29713,70,NULL,NULL,'2MASX J11032657+2307352',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000167,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,165.860667,23.12658,0,NULL,60969000607,952640634,14885009,18.1),(77013,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77013,38.37,0.46,472,29714,70,NULL,NULL,'SDSS J110326.65+391410.9',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,165.861083,39.23636,0,NULL,63935321579,998989399,15609209,18.1),(77014,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77014,37.49,0.33,315,29715,70,NULL,NULL,'2MASX J11032664+3152570',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000151,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,165.861125,31.88264,0.042,NULL,60640104801,947501637,14804713,17.7),(77015,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77015,36.61,0.33,210,29716,70,NULL,NULL,'CGCG 038-105',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000173,NULL,'15.6g',0.47,'S0-','Group member',NULL,NULL,NULL,1,165.861625,6.87233,0.037,NULL,60310628612,942353572,14724274,15.6),(77016,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77016,37.48,0.46,313,29717,70,NULL,NULL,'2MASX J11032737+5400160',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000119,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,165.864333,54.00453,0,NULL,61965015350,968203364,15128177,18.1),(77017,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77017,37.12,0.46,265,29718,70,NULL,NULL,'2MASX J11032791+4506520',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'17.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,165.866125,45.11433,0,NULL,63940900685,999076573,15610571,17.2),(77018,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77018,38,0.46,398,29719,70,NULL,NULL,'2MASX J11032802+3828580',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000178,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,165.866833333,38.48286,0,NULL,63923854151,998810221,15606409,17.4),(77019,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77019,36.27,0.33,179,29720,70,NULL,NULL,'CGCG 095-101',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.0001,NULL,'15.2g',0.56,NULL,NULL,NULL,NULL,NULL,1,165.874083333,16.37011,0,NULL,61198347859,956224185,14941002,15.2),(77020,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77020,37.15,0.46,269,29721,70,NULL,NULL,'2MASX J11033002+5342003',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,165.87525,53.70008,0,NULL,61783738320,965370911,15083920,17.7),(77021,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77021,37.55,0.46,324,29722,70,NULL,NULL,'2MASX J11033090+3939450',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000173,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,165.878667,39.66264,0,NULL,63935153539,998986774,15609168,17.1),(77022,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77022,37.14,0.46,268,29723,70,NULL,NULL,'2MASX J11033092+1606514',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000184,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,165.8789583,16.11439,0,NULL,61197320042,956208125,14940751,16.6),(77023,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77023,36.62,0.64,211,29724,70,NULL,NULL,'2MASX J11033178-4658140',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,165.882416667,-46.97053,0.669,NULL,41922274769,655035543,10234930,17.2),(77024,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77024,38.45,0.46,490,29725,70,NULL,NULL,'SDSS J110332.53+170450.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000166,NULL,'18.2g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,165.885583333,17.08072,0,NULL,61198751327,956230489,14941101,18.2),(77025,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77025,37.33,0.46,292,29726,70,NULL,NULL,'2MASX J11033249+3301571',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,165.885583333,33.03244,0.013,NULL,60634004477,947406319,14803223,18),(77026,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77026,37.23,0.46,280,29727,70,NULL,NULL,'2MASX J11033309+1750394',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,165.887917,17.84433,0,NULL,61163701649,955682838,14932544,17.1),(77027,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77027,34.88,0.47,94.8,29728,NULL,NULL,'H','MCG -03-28-033',NULL,'2007A&A...465...71T',2007,1,1.68,NULL,'G',0.00004,NULL,'14.73',0.22,'Sbc            HII',NULL,NULL,NULL,NULL,1,165.89925,-17.47906,0.177,NULL,41866785138,654168517,10221383,14.73),(77028,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77028,34.91,0.45,96,29728,NULL,NULL,'K','MCG -03-28-033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77029,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77029,35,0.46,99.9,29728,NULL,NULL,'J','MCG -03-28-033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77030,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77030,35.03,0.49,102,29728,75,NULL,'IR','MCG -03-28-033',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77031,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77031,35.18,0.4,109,29728,NULL,NULL,'mean','MCG -03-28-033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77032,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77032,35.24,0.29,112,29728,NULL,NULL,'Malmquist cor.','MCG -03-28-033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77033,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77033,35.48,0.2,125,29728,74.4,NULL,NULL,'MCG -03-28-033',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77034,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77034,35.56,NULL,129,29728,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -03-28-033',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77035,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77035,35.56,NULL,130,29728,NULL,NULL,'Dipole + Quadrupole','MCG -03-28-033',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77036,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77036,35.58,NULL,131,29728,NULL,NULL,'Dipole','MCG -03-28-033',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77037,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77037,35.59,0.24,131,29728,NULL,NULL,NULL,'MCG -03-28-033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77038,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77038,37.37,0.46,298,29729,70,NULL,NULL,'2MASX J11033601+1649054',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000173,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,165.900125,16.81828,0,NULL,61198373172,956224580,14941009,16.6),(77039,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77039,36.33,0.46,185,29730,70,NULL,NULL,'2MASX J11033713+2159082',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'17.15',0.26,NULL,NULL,NULL,NULL,NULL,1,165.9047917,21.98569,0,NULL,61157123874,955580060,14930938,17.15),(77040,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77040,37.13,0.46,267,29731,70,NULL,NULL,'2MASX J11033740+1640124',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000139,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,165.905833,16.67008,0,NULL,61198418292,956225285,14941020,17.8),(77041,'GeV TeV ratio','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77041,39.65,0.72,850,29732,72,NULL,NULL,'2MASX J11033765-2329307',NULL,'2011arXiv1111.0913P',2011,1,NULL,NULL,'QSO',0.001,NULL,'15.7R',NULL,'BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,165.9067083,-23.492,0.229,NULL,41625269507,650394836,10162419,15.7),(77042,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77042,36.77,0.46,226,29733,70,NULL,NULL,'SDSS J110337.80+053146.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000194,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,165.9075,5.52969,0.069,NULL,60315389145,942427955,14725436,17.8),(77043,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77043,37.53,0.27,321,29734,70,NULL,NULL,'2MASX J11033843-0038521',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000072,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,165.910125,-0.64783,0.109,NULL,40909276289,639207442,9987616,17),(77044,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77044,37.49,0.33,315,29735,70,NULL,NULL,'SDSS J110338.85+315443.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.9g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,165.911917,31.91197,0.039,NULL,60640107010,947501672,14804713,17.9),(77045,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77045,37.11,0.46,264,29736,70,NULL,NULL,'2MASX J11034186+5000203',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,165.924375,50.00556,0,NULL,63913967672,998655744,15603996,17),(77046,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77046,37.22,0.57,277,29737,70,NULL,NULL,'2MASX J11034291-4658270',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,165.928916667,-46.97425,0.669,NULL,41922277832,655035591,10234931,16.9),(77047,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77047,37.45,0.46,309,29738,70,NULL,NULL,'2MASX J11034294+3805049',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000177,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,165.929083333,38.08478,0,NULL,63924590590,998821727,15606589,16.4),(77048,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77048,36.77,0.46,226,29739,70,NULL,NULL,'2MASX J11034317+2914325',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000133,NULL,'16.3g',0.28,'E',NULL,NULL,NULL,NULL,1,165.9297917,29.24233,0,NULL,60486093437,945095209,14767112,16.3),(77049,'SNII radio','2016-12-15 15:14:43','2016-12-16 11:19:51','1','SN 1996cb',NULL,77049,27.9,0.37,3.8,29740,NULL,NULL,NULL,'NGC 3510',NULL,'1998ApJ...500...51W',1998,1,4.35,NULL,'G',0.000009,NULL,'13.4g',0.64,'SB(s)m         HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,165.9307083,28.88717,0,NULL,60486198618,945096853,14767138,13.4),(77050,'IRAS','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77050,30.5,0.8,12.6,29740,75,NULL,'A82, H','NGC 3510',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77051,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77051,29.49,0.4,7.9,29740,75,NULL,'B','NGC 3510',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77052,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77052,30.55,0.4,12.9,29740,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 3510',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77053,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77053,30.75,0.39,14.1,29740,73,NULL,'IR','NGC 3510',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77054,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77054,30.75,0.4,14.1,29740,75,NULL,NULL,'NGC 3510',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77055,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77055,30.93,0.47,15.3,29740,75,NULL,'A82, H, inv','NGC 3510',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77056,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77056,31.07,0.47,16.4,29740,75,NULL,'A82, H, raw','NGC 3510',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77057,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77057,31.07,0.38,16.4,29740,NULL,NULL,NULL,'NGC 3510',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77058,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77058,31.11,0.2,16.7,29740,74.4,NULL,NULL,'NGC 3510',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77059,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77059,31.16,0.43,17,29740,75,NULL,'3.6 micron, color corrected','NGC 3510',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77060,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77060,31.17,0.43,17.1,29740,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3510',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77061,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77061,31.32,0.46,18.4,29740,NULL,NULL,NULL,'NGC 3510',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77062,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77062,31.32,0.46,18.4,29740,NULL,NULL,'Malmquist cor.','NGC 3510',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77063,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77063,31.36,0.47,18.7,29740,75,NULL,'A82, H, cor','NGC 3510',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77064,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77064,31.66,0.49,21.5,29740,75,NULL,'IR','NGC 3510',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77065,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77065,38.26,0.46,450,29741,70,NULL,NULL,'2MASX J11034429+0805292',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,165.9345,8.09142,0.057,NULL,60312981539,942390336,14724849,18),(77066,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77066,37.43,0.46,307,29742,70,NULL,NULL,'2MASX J11034454+5734303',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00018,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,165.935333333,57.57519,0,NULL,62007293609,968863962,15138499,17.8),(77067,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77067,38.28,0.46,452,29743,70,NULL,NULL,'2MASX J11034456+0837422',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,165.935583,8.62842,0.049,NULL,60298462131,942163470,14721304,17.9),(77068,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77068,37.42,0.46,305,29744,70,NULL,NULL,'SDSS J110345.36+455448.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000156,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,165.9390417,45.91333,0,NULL,63940172849,999065200,15610393,18.3),(77069,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77069,37.46,0.46,311,29745,70,NULL,NULL,'2MASX J11034541+1648124',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000147,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,165.939083,16.80358,0,NULL,61198428359,956225443,14941022,17.5),(77070,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77070,29.45,0.36,7.76,29746,NULL,NULL,NULL,'NGC 3513',NULL,'2009AJ....138..323T',2009,1,2.8,NULL,'G',0.000023,NULL,'11.93',2.2,'SB(s)c         HII','in a pair',NULL,NULL,NULL,1,165.942,-23.2455,0.225,NULL,41625202923,650393795,10162403,11.93),(77071,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77071,29.46,0.41,7.8,29746,73,NULL,'opt','NGC 3513',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77072,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77072,30.84,0.4,14.7,29746,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 3 galaxy group','NGC 3513',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77073,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77073,31.16,0.4,17,29746,75,NULL,'B','NGC 3513',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77074,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77074,37.86,0.46,373,29747,70,NULL,NULL,'2MASX J11034624+4055339',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,165.9427083,40.92603,0,NULL,63934091571,998970180,15608909,17.4),(77075,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77075,37.9,0.27,380,29748,70,NULL,NULL,'SDSS J110346.44+072705.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,165.9435417,7.45161,0.057,NULL,60313351244,942396113,14724939,17.8),(77076,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77076,38.08,0.46,412,29749,70,NULL,NULL,'2MASXi J1103468+152455',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.9g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,165.945041667,15.41544,0,NULL,61142231590,955347368,14927302,17.9),(77077,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77077,37.9,0.27,380,29750,70,NULL,NULL,'SDSS J110348.08+072841.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000143,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,165.950375,7.47822,0.057,NULL,60313340254,942395941,14724936,18.6),(77078,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77078,38.16,0.33,429,29751,70,NULL,NULL,'SDSS J110349.65+045533.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00014,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,165.956875,4.92592,0.145,NULL,60315576109,942430876,14725482,18.1),(77079,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77079,37.53,0.27,321,29752,70,NULL,NULL,'2MASX J11035010-0036061',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000088,NULL,'16.4g',0.36,'BrClG          AGN',NULL,NULL,NULL,NULL,1,165.9587083,-0.60167,0.109,NULL,40917608778,639337637,9989650,16.4),(77080,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77080,38.2,0.46,437,29753,70,NULL,NULL,'VIII Zw 120 NED02',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000182,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,165.95925,11.06197,0.017,NULL,61020594846,953446794,14897606,17.4),(77081,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77081,37.15,0.46,269,29754,70,NULL,NULL,'2MASX J11035047+0710042',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000115,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,165.9602917,7.16786,0.021,NULL,60310634596,942353665,14724276,18.2),(77082,'D-Sigma','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77082,33.54,0.4,51,29755,75,NULL,'Edat, raw','IC 2623',NULL,'1997ApJS..109..333W',1997,1,0.8,NULL,'G',0.000123,NULL,'14.93',0.5,'E?',NULL,NULL,NULL,NULL,1,165.962333,-20.09306,0.145,NULL,41857877853,654029341,10219208,14.93),(77083,'D-Sigma','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77083,33.87,0.4,59.5,29755,75,NULL,'Edat, cor','IC 2623',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77084,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77084,33.8,0.48,57.5,29755,70,NULL,NULL,'IC 2623',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77085,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77085,36.83,0.33,232,29756,70,NULL,NULL,'2MASX J11035094+1816191',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.23',0.18,NULL,NULL,NULL,NULL,NULL,1,165.9622083,18.27192,0,NULL,61164910676,955701729,14932839,18.23),(77086,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77086,36.83,0.33,232,29757,70,NULL,NULL,'2MASX J11035136+1815361',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.36',0.27,NULL,NULL,NULL,NULL,NULL,1,165.964083,18.26017,0,NULL,61164910628,955701728,14932839,17.36),(77087,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77087,37.8,0.46,363,29758,70,NULL,NULL,'2MASX J11035173+1939231',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.1g',0.1,NULL,NULL,NULL,NULL,NULL,1,165.965708333,19.65644,0.019,NULL,61167139195,955736549,14933383,18.1),(77088,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77088,37.9,0.27,380,29759,70,NULL,NULL,'2MASX J11035202+0729092',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000137,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,165.967,7.48575,0.057,NULL,60313519728,942398745,14724980,17.1),(77089,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77089,37.16,0.46,270,29760,70,NULL,NULL,'2MASX J11035208+5426183',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,165.96725,54.43858,0,NULL,61966055583,968219618,15128431,16.9),(77090,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77090,37.86,0.46,373,29761,70,NULL,NULL,'2MASX J11035314+0928492',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000156,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,165.971375,9.48042,0.025,NULL,61021794017,953465531,14897898,17.4),(77091,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77091,37.75,0.46,355,29762,70,NULL,NULL,'2MASX J11035312+5509274',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00019,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,165.9714583,55.15756,0,NULL,61966357858,968224341,15128505,16.5),(77092,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77092,36.92,0.46,242,29763,70,NULL,NULL,'2MASX J11035415+1425253',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000201,NULL,'15.9g',0.39,NULL,NULL,NULL,NULL,NULL,1,165.975583,14.42358,0,NULL,61149324400,955458193,14929034,15.9),(77093,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77093,37.44,0.46,307,29764,70,NULL,NULL,'2MASX J11035607+0221111',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,165.9835417,2.35317,0.161,NULL,60293246400,942081975,14720030,17.6),(77094,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77094,37.31,0.46,290,29765,70,NULL,NULL,'2MASX J11035654+0758532',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000143,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,165.985583,7.98142,0.061,NULL,60312995298,942390551,14724852,17.8),(77095,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77095,38.2,0.33,437,29766,70,NULL,NULL,'2MASX J11040134+4834192',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000139,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,166.005458333,48.57206,0,NULL,63918571822,998727684,15605120,17.7),(77096,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,NULL,77096,31.99,0.4,25,29767,75,NULL,'B','NGC 3512',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.000017,NULL,'12.98',1.5,'SAB(rs)c       LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,166.01225,28.03681,0.01,NULL,60489478088,945148095,14767938,12.98),(77097,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77097,37.24,0.46,280,29768,70,NULL,NULL,'2MASX J11040333+3414198',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,166.013875,34.23892,0,NULL,60636705617,947448525,14803883,17),(77098,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77098,37.29,0.46,287,29769,70,NULL,NULL,'2MASX J11040380+5119402',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000147,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,166.01575,51.32783,0,NULL,61789436815,965459950,15085311,16.8),(77099,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77099,35.9,0.46,151,29770,70,NULL,NULL,'2MASX J11040684+0501388',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000154,NULL,'16.1g',0.45,'S0^-',NULL,NULL,NULL,NULL,1,166.0285417,5.0275,0.117,NULL,60315569667,942430776,14725480,16.1),(77100,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77100,38.16,0.33,429,29771,70,NULL,NULL,'2MASX J11040724+0450488',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,166.0302083,4.84694,0.145,NULL,60315653689,942432088,14725501,17.3),(77101,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77101,37.65,0.33,339,29772,70,NULL,NULL,'2MASX J11040791+0747401',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000173,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,166.033,7.79447,0.061,NULL,60312373426,942380834,14724700,16.9),(77102,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77102,37.69,0.46,346,29773,70,NULL,NULL,'2MASX J11041032+0503358',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,166.0429583,5.05997,0.117,NULL,60316078076,942438719,14725604,18.1),(77103,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77103,35.54,0.46,128,29774,70,NULL,NULL,'CGCG 038-107',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000103,NULL,'15.4g',0.48,'Sa',NULL,NULL,NULL,NULL,1,166.0465417,7.06903,0.021,NULL,60310604173,942353190,14724268,15.4),(77104,'FP','2016-12-15 15:14:43','2016-12-16 11:19:51','1',NULL,'R',77104,37.65,0.33,339,29775,70,NULL,NULL,'2MASX J11041121+0744501',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,166.04675,7.74717,0.061,NULL,60312386429,942381037,14724703,17.8),(77105,'FP','2016-12-15 15:14:43','2016-12-16 11:19:52','1',NULL,'R',77105,37.19,0.33,274,29776,70,NULL,NULL,'2MASX J11041297+1846033',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,166.0542083,18.76758,0,NULL,61165441759,955710027,14932969,17.5),(77106,'FP','2016-12-15 15:14:43','2016-12-16 11:19:52','1',NULL,'R',77106,37.07,0.46,259,29777,70,NULL,NULL,'2MASX J11041442+2245283',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000166,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,166.059958333,22.75781,0,NULL,61153411526,955522055,14930032,16.5),(77107,'FP','2016-12-15 15:14:43','2016-12-16 11:19:52','1',NULL,'R',77107,38.43,0.46,486,29778,70,NULL,NULL,'2MASX J11041470+0733481',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,166.061375,7.56339,0.057,NULL,60313466970,942397921,14724967,17.5),(77108,'FP','2016-12-15 15:14:43','2016-12-16 11:19:52','1',NULL,NULL,77108,36.1,0.95,166,29779,70,NULL,NULL,'2MASX J11041478-2052161',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,166.061583,-20.87111,0.153,NULL,41843849038,653810141,10215783,15.2),(77109,'FP','2016-12-15 15:14:43','2016-12-16 11:19:52','1',NULL,'R',77109,37.43,0.46,306,29780,70,NULL,NULL,'2MASX J11041616+0224598',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000171,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,166.067291667,2.41653,0.161,NULL,60293211612,942081431,14720022,16.6),(77110,'FP','2016-12-15 15:14:43','2016-12-16 11:19:52','1',NULL,'R',77110,37.26,0.46,283,29781,70,NULL,NULL,'2MASX J11041765+1032051',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000166,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,166.07375,10.53481,0.025,NULL,61022750996,953480484,14898132,16.7),(77111,'FP','2016-12-15 15:14:43','2016-12-16 11:19:52','1',NULL,'R',77111,38.12,0.15,421,29782,70,NULL,NULL,'SDSS J110417.92+021439.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000138,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,166.0747083,2.24422,0.153,NULL,60294100511,942095320,14720239,18.3),(77112,'FP','2016-12-15 15:14:43','2016-12-16 11:19:52','1',NULL,'R',77112,36.4,0.46,190,29783,70,NULL,NULL,'2MASX J11041860+1638430',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.87',0.26,NULL,NULL,NULL,NULL,NULL,1,166.077417,16.64533,0,NULL,61198402002,956225031,14941016,16.87),(77113,'FP','2016-12-15 15:14:43','2016-12-16 11:19:52','1',NULL,'R',77113,37.68,0.46,343,29784,70,NULL,NULL,'2MASX J11041928+1248550',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000164,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,166.0802083,12.81528,0,NULL,61150297831,955473403,14929271,17.1),(77114,'FP','2016-12-15 15:14:43','2016-12-16 11:19:52','1',NULL,'R',77114,38.25,0.33,446,29785,70,NULL,NULL,'2MASX J11041934+1941283',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.48',0.17,NULL,NULL,NULL,NULL,NULL,1,166.0805417,19.69119,0,NULL,61167124498,955736320,14933380,18.48),(77115,'FP','2016-12-15 15:14:43','2016-12-16 11:19:52','1',NULL,'R',77115,38.2,0.33,437,29786,70,NULL,NULL,'SDSS J110421.15+483748.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000138,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,166.0882083,48.63025,0,NULL,63914130162,998658283,15604035,18.5),(77116,'FP','2016-12-15 15:14:43','2016-12-16 11:19:52','1',NULL,'R',77116,37.16,0.46,270,29787,70,NULL,NULL,'2MASX J11042202+5046183',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00017,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,166.091917,50.77189,0,NULL,61780148522,965314820,15083044,17.8),(77117,'FP','2016-12-15 15:14:43','2016-12-16 11:19:52','1',NULL,'R',77117,36.75,0.46,224,29788,70,NULL,NULL,'2MASX J11042289+3306499',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,166.0955,33.11394,0.006,NULL,60634833787,947419277,14803426,17.2),(77118,'FP','2016-12-15 15:14:43','2016-12-16 11:19:52','1',NULL,'R',77118,38.11,0.46,418,29789,70,NULL,NULL,'2MASX J11042362+3833260',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,166.09825,38.55725,0,NULL,63924353333,998818020,15606531,17.9),(77119,'Tully-Fisher','2016-12-15 15:14:43','2016-12-16 11:19:52','1',NULL,NULL,77119,34.94,0.47,97.1,29790,NULL,NULL,'H','NGC 3509',NULL,'2007A&A...465...71T',2007,1,2.1,NULL,'G',0.000023,NULL,'13.53',1,'SA(s)bc pec','in a radial-velocity based grouping',NULL,NULL,NULL,1,166.098125,4.82861,0.177,NULL,60315509551,942429836,14725466,13.53),(77120,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77120,35.05,0.45,103,29790,NULL,NULL,'K','NGC 3509',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77121,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77121,35.1,0.46,105,29790,NULL,NULL,'J','NGC 3509',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77122,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77122,35.24,0.4,112,29790,NULL,NULL,'mean','NGC 3509',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77123,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77123,35.92,0.46,153,29791,70,NULL,NULL,'2MASX J11042394+0127328',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000164,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,166.099625,1.459,0.137,NULL,60296818434,942137788,14720902,16.7),(77124,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77124,38.12,0.15,421,29792,70,NULL,NULL,'2MASX J11042437+0230158',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000139,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,166.101375,2.50428,0.161,NULL,60293202965,942081296,14720020,17.7),(77125,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77125,37.85,0.46,372,29793,70,NULL,NULL,'2MASX J11042484+0612251',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000193,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,166.103417,6.20706,0.077,NULL,60310010103,942343907,14724123,17.5),(77126,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77126,38.12,0.15,421,29794,70,NULL,NULL,'2MASX J11042510+0217128',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000172,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,166.1047083,2.28692,0.153,NULL,60294101517,942095336,14720239,18.2),(77127,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77127,37.27,0.46,285,29795,70,NULL,NULL,'2MASX J11042601+3754240',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,166.10825,37.90658,0,NULL,63924513668,998820526,15606570,17.2),(77128,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77128,37.7,0.46,346,29796,70,NULL,NULL,'2MASX J11042609+0757491',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000184,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,166.108833,7.96372,0.061,NULL,60312819571,942387805,14724809,16.9),(77129,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77129,30.06,NULL,10.3,29797,NULL,NULL,NULL,'CGCG 066-109',NULL,'2015AstBu..70....1K',2015,1,0.92,'2005SDSS4.C...0000: gives v = 982 km/s.','G',0.000073,NULL,'16.2g',0.33,'Ir',NULL,NULL,NULL,NULL,1,166.110333,11.75636,0.013,NULL,61138722538,955292539,14926445,16.2),(77130,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77130,36.39,0.46,189,29798,70,NULL,NULL,'2MASX J11042692+4609530',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000111,NULL,'15.8g',0.4,'S0',NULL,NULL,NULL,NULL,1,166.112,46.16478,0,NULL,63909692714,998588948,15602952,15.8),(77131,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77131,37.36,0.46,297,29799,70,NULL,NULL,'2MASX J11042720+0111598',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000091,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,166.113375,1.20003,0.137,NULL,60294954212,942108659,14720447,17),(77132,'BL Lac Luminosity','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77132,35.69,NULL,133,29800,NULL,NULL,NULL,'MRK 0421',0.030021,'2005ApJ...635..173S',2005,1,0.8,NULL,'G',0.00008,NULL,'12.8V',0.6,'S?; blazar     BLLAC','Field galaxy',NULL,'radio jet','Flat-Spectrum Radio Source',1,166.1137917,38.20883,0,NULL,63924558466,998821226,15606581,12.8),(77133,'GeV TeV ratio','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77133,32.86,NULL,37.3,29800,72,NULL,NULL,'MRK 0421',NULL,'2010MNRAS.405L..76P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77134,'GeV TeV ratio','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77134,37.24,0.53,281,29800,72,NULL,NULL,'MRK 0421',NULL,'2011arXiv1111.0913P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77135,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77135,34.9,0.46,95.6,29801,70,NULL,NULL,'UGC 06131',NULL,'2015arXiv151105856S',2015,1,1.12,NULL,'G',0.000167,NULL,'14.4g',0.65,'S0',NULL,NULL,NULL,NULL,1,166.1169583,44.03094,0,NULL,63941293744,999082714,15610667,14.4),(77136,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77136,34.77,0.47,90,29802,70,NULL,NULL,'MCG -01-28-023',NULL,'2014MNRAS.445.2677S',2014,1,1.5,'MCG decs for MCG -01-28 field are 10 arcmin too far north (MCG4 errata).','G',0.00014,NULL,'14.86',0.4,'SB(r)0^0^? sp',NULL,NULL,NULL,NULL,1,166.12,-9.79136,0.053,NULL,41777135181,652767737,10199495,14.86),(77137,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77137,37.72,0.46,350,29803,70,NULL,NULL,'2MASX J11042922+0359408',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000183,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,166.121667,3.99481,0.173,NULL,60316879107,942451236,14725800,17.2),(77138,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77138,37.67,0.46,342,29804,70,NULL,NULL,'2MASX J11043076+5701004',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00018,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,166.12825,57.01675,0,NULL,62007082364,968860661,15138447,16.9),(77139,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77139,38.12,0.15,421,29805,70,NULL,NULL,'2MASX J11043223+0213138',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,166.13425,2.22061,0.153,NULL,60294069570,942094837,14720231,17.6),(77140,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77140,37.87,0.46,375,29806,70,NULL,NULL,'2MASX J11043235+4309070',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,166.134875,43.15194,0,NULL,63939709498,999057960,15610280,17.5),(77141,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77141,37.04,0.84,256,29807,70,NULL,NULL,'2MASX J11043269-4655327',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,166.13625,-46.92572,0.645,NULL,41922292619,655035822,10234934,17.1),(77142,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77142,37.75,0.46,354,29808,70,NULL,NULL,'2MASX J11043311+5544563',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,166.138041667,55.74897,0,NULL,61994411861,968662685,15135354,17.5),(77143,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77143,34.95,0.45,97.8,29809,NULL,NULL,'K','UGC 06137',NULL,'2007A&A...465...71T',2007,1,1.07,NULL,'G',0.000087,NULL,'13.9g',0.77,'S0?',NULL,NULL,NULL,NULL,1,166.143625,16.06181,0,NULL,61141950958,955342983,14927234,13.9),(77144,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77144,34.96,0.4,98,29809,NULL,NULL,'mean','UGC 06137',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77145,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77145,37.85,0.46,372,29810,70,NULL,NULL,'2MASX J11043524+1144312',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,166.146875,11.74192,0.013,NULL,61138730264,955292660,14926447,17.7),(77146,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77146,35.92,0.46,153,29811,70,NULL,NULL,'2MASX J11043558+3639153',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.44',0.32,NULL,NULL,NULL,NULL,NULL,1,166.148375,36.65431,0.025,NULL,63921472524,998773008,15605828,16.44),(77147,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77147,37.36,0.46,296,29812,70,NULL,NULL,'2MASX J11043786+3011367',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,166.1577917,30.19364,0,NULL,60637230728,947456730,14804011,17.2),(77148,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77148,35.82,0.51,146,29813,70,NULL,NULL,'2MASX J11043809-0702472',NULL,'2014MNRAS.445.2677S',2014,1,0.69,NULL,'G',0.000097,NULL,'15.27',0.44,NULL,NULL,NULL,NULL,NULL,1,166.1587083,-7.04644,0.037,NULL,40899043842,639047560,9985118,15.27),(77149,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77149,38.25,0.33,446,29814,70,NULL,NULL,'2MASX J11043841+1942157',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.86',0.11,NULL,NULL,NULL,NULL,NULL,1,166.160083333,19.70442,0,NULL,61162802804,955668793,14932324,18.86),(77150,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77150,37.04,0.46,256,29815,70,NULL,NULL,'2MASX J11043955+3513477',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000184,NULL,'15.9g',0.42,NULL,NULL,NULL,NULL,NULL,1,166.1647083,35.23,0.04,NULL,60415153139,943986767,14749793,15.9),(77151,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77151,37.19,0.33,274,29816,70,NULL,NULL,'2MASX J11044081+1848017',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,166.170125,18.80036,0,NULL,61165451234,955710175,14932971,16.4),(77152,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77152,37.4,0.33,303,29817,70,NULL,NULL,'2MASX J11044112+3504317',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000181,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,166.171541667,35.07547,0,NULL,60633500837,947398450,14803100,16.2),(77153,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77153,34.13,0.53,66.9,29818,70,NULL,NULL,'ARK 275',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.000083,NULL,'14.99',0.3,'E',NULL,NULL,NULL,NULL,1,166.172208333,-1.54183,0.149,NULL,40918887216,639357612,9989962,14.99),(77154,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77154,37.4,0.33,303,29819,70,NULL,NULL,'SDSS J110441.64+350332.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000143,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,166.1735417,35.05897,0,NULL,60633501017,947398453,14803100,18.5),(77155,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77155,37.83,0.46,369,29820,70,NULL,NULL,'SDSS J110441.72+052650.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000189,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,166.173875,5.44728,0.105,NULL,60316024794,942437887,14725591,18.2),(77156,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77156,38.12,0.15,421,29821,70,NULL,NULL,'SDSS J110442.88+022128.9',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000148,NULL,'18.9g',0.1,NULL,NULL,NULL,NULL,NULL,1,166.178667,2.35806,0.153,NULL,60294078846,942094981,14720234,18.9),(77157,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77157,38.12,0.15,421,29822,70,NULL,NULL,'2MASX J11044430+0211197',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000187,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,166.184667,2.18883,0.149,NULL,60294057727,942094651,14720228,17.2),(77158,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77158,38.12,0.15,421,29823,70,NULL,NULL,'SDSS J110445.15+022815.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000139,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,166.188125,2.47092,0.153,NULL,60294103304,942095364,14720240,18.5),(77159,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77159,37.13,0.46,267,29824,70,NULL,NULL,'2MASX J11044542+0340547',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00018,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,166.189333333,3.68189,0.165,NULL,60317186610,942456040,14725875,16.6),(77160,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77160,33.16,0.43,42.9,29825,75,NULL,'3.6 micron, color + selection bias corrected','ESO 377- G 004',NULL,'2014MNRAS.444..527S',2014,1,1.23,NULL,'G',0.00015,NULL,'16.63',0.13,'Scd',NULL,NULL,NULL,NULL,1,166.192333,-37.65169,0.373,NULL,41896782638,654637228,10228706,16.63),(77161,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77161,38.02,0.46,401,29826,70,NULL,NULL,'2MASX J11044624+1236449',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000152,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,166.1925,12.61239,0.005,NULL,61139033359,955297396,14926521,17.3),(77162,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77162,38.84,0.46,587,29827,70,NULL,NULL,'SDSS J110449.11+121853.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00018,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,166.204667,12.31486,0,NULL,61139291476,955301429,14926584,18.2),(77163,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77163,36.59,0.23,208,29828,70,NULL,NULL,'2MASX J11045048+3134237',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,166.21025,31.57331,0.032,NULL,60639541190,947492831,14804575,16.7),(77164,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77164,37.84,0.46,371,29829,70,NULL,NULL,'SDSS J110450.48+001004.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000072,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,166.210375,0.16783,0.061,NULL,60282685384,941916959,14717452,18.2),(77165,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77165,38.11,0.46,420,29830,70,NULL,NULL,'SDSS J110450.66+535715.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000139,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,166.211125,53.95428,0,NULL,61965040886,968203763,15128183,18.4),(77166,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77166,38.12,0.15,421,29831,70,NULL,NULL,'2MASX J11045077+0219207',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000179,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,166.211667,2.32228,0.153,NULL,60294128499,942095757,14720246,17.1),(77167,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77167,37.66,0.46,340,29832,70,NULL,NULL,'2MASX J11045089+3812173',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00018,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,166.21225,38.20478,0,NULL,63924373895,998818342,15606536,16.9),(77168,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77168,36.9,0.46,239,29833,70,NULL,NULL,'2MASX J11045166+3928083',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000189,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,166.215,39.46908,0,NULL,63937105139,999017267,15609644,16.4),(77169,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77169,38.12,0.15,421,29834,70,NULL,NULL,'SDSS J110451.93+022018.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00017,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,166.216375,2.33833,0.153,NULL,60294161319,942096270,14720254,18.4),(77170,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77170,38.12,0.46,420,29835,70,NULL,NULL,'2MASX J11045216+2136297',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,166.217333,21.60822,0,NULL,61157016300,955578379,14930912,17.9),(77171,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77171,38.06,0.33,409,29836,70,NULL,NULL,'2MASX J11045336+0740212',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,'FoF','16.0g',0.38,NULL,NULL,NULL,NULL,NULL,1,166.222208333,7.67253,0.057,NULL,60313491973,942398312,14724973,16),(77172,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77172,37.11,0.46,265,29837,70,NULL,NULL,'2MASX J11045338+5242235',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000167,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,166.22225,52.70664,0,NULL,61788075247,965438675,15084979,16.3),(77173,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77173,37.58,0.46,328,29838,70,NULL,NULL,'2MASX J11045471+0526537',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,166.2279583,5.44814,0.105,NULL,60316014205,942437721,14725589,17.9),(77174,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77174,37.32,0.46,291,29839,70,NULL,NULL,'2MASX J11045486+4658309',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000193,NULL,'16.0g',0.44,'E0',NULL,NULL,NULL,NULL,1,166.2285417,46.97511,0,NULL,63917234257,998706785,15604793,16),(77175,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77175,37.58,0.46,328,29840,70,NULL,NULL,'2MASX J11045779+4127443',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000176,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,166.240917,41.46211,0,NULL,63932331718,998942683,15608479,16.7),(77176,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77176,38.12,0.15,421,29841,70,NULL,NULL,'2MASX J11045845+0219087',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,166.2435,2.31894,0.149,NULL,60294130032,942095781,14720246,17.5),(77177,'Tully est','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77177,29.21,0.8,6.9,29842,75,NULL,NULL,'UGCA 225',NULL,'1988NBGC.C....0000T',1988,1,0.56,'Several SDSS entries describe this object.','G',0.000017,NULL,'15.5g',0.32,'BCD;Sbrst      HII','Group member',NULL,NULL,NULL,1,166.242917,29.13961,0,NULL,60607780479,946996569,14796821,15.5),(77178,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77178,30.21,0.2,11,29842,74.4,NULL,NULL,'UGCA 225',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77179,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77179,36.29,0.33,181,29843,70,NULL,NULL,'2MASX J11045937+3006257',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000169,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,166.247417,30.10722,0,NULL,60637260453,947457194,14804018,16.4),(77180,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77180,38.45,0.46,490,29844,70,NULL,NULL,'2MASX J11045966+0915192',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000148,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,166.2485417,9.25533,0.021,NULL,60299216096,942175251,14721488,17.6),(77181,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77181,36.33,0.46,185,29845,70,NULL,NULL,'2MASX J11045978+0230207',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,166.249125,2.50581,0.153,NULL,60294105991,942095406,14720240,16.9),(77182,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77182,36.69,0.46,218,29846,70,NULL,NULL,'2MASX J11050032+0425297',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000181,NULL,'17.2g',0.23,'AGN',NULL,NULL,NULL,NULL,1,166.251333,4.42494,0.177,NULL,60317347760,942458558,14725914,17.2),(77183,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77183,38.05,0.46,407,29847,70,NULL,NULL,'2MASX J11050073+2252225',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000188,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,166.252958333,22.87286,0,NULL,61153963858,955530685,14930166,17.8),(77184,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77184,38.53,0.46,509,29848,70,NULL,NULL,'2MASX J11050087+1308129',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,166.253667,13.13694,0,NULL,61151943096,955499110,14929673,18.3),(77185,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77185,37.57,0.46,327,29849,70,NULL,NULL,'2MASX J11050154+5532104',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000178,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,166.256625,55.53631,0,NULL,61994183196,968659112,15135298,17.1),(77186,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77186,38.89,0.46,601,29850,70,NULL,NULL,'2MASX J11050188+0710393',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000182,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,166.2577917,7.17753,0.069,NULL,60310553782,942352402,14724256,18.4),(77187,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77187,36.29,0.33,181,29851,70,NULL,NULL,'CGCG 155-057',NULL,'2015arXiv151105856S',2015,1,1.09,NULL,'G',0.00018,NULL,'15.0g',0.56,NULL,'Group member',NULL,NULL,NULL,1,166.258833,29.95167,0,NULL,60637297851,947457778,14804027,15),(77188,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77188,37.25,0.46,282,29852,70,NULL,NULL,'2MASX J11050228-0054397',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000076,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,166.2595417,-0.91119,0.121,NULL,40918540543,639352195,9989878,18.2),(77189,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77189,37.97,0.46,392,29853,70,NULL,NULL,'2MASX J11050262+3947083',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,166.260791667,39.78567,0,NULL,63937835367,999028677,15609823,17.5),(77190,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77190,38.2,0.46,437,29854,70,NULL,NULL,'2MASX J11050317+3515540',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,166.263083,35.26514,0.04,NULL,60415175082,943987110,14749798,18.2),(77191,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77191,37.27,0.46,284,29855,70,NULL,NULL,'2MASX J11050333+1716029',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000172,NULL,'16.9g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,166.263875,17.26739,0,NULL,61195249093,956175767,14940246,16.9),(77192,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77192,37.47,0.33,311,29856,70,NULL,NULL,'2MASX J11050515+3101170',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000186,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,166.271625,31.02131,0.011,NULL,60640561758,947508777,14804824,16.8),(77193,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77193,37.11,0.46,264,29857,70,NULL,NULL,'2MASX J11050546+0619463',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000182,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,166.272666667,6.32947,0.085,NULL,60307938335,942311536,14723617,16.9),(77194,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77194,37.78,0.46,359,29858,70,NULL,NULL,'2MASX J11050546+4242219',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,166.272917,42.70622,0,NULL,63939615365,999056490,15610257,17.7),(77195,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77195,33.4,NULL,47.9,29859,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 007- G 003',NULL,'2010Ap&SS.325..163P',2010,1,1.1,NULL,'G',0.00004,NULL,'17.1',0.09,'Sc',NULL,NULL,NULL,NULL,1,166.273333,-83.25028,0.501,NULL,39756492350,621195192,9706174,17.1),(77196,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77196,33.41,NULL,48.1,29859,NULL,NULL,'Dipole + Quadrupole','ESO 007- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77197,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77197,33.43,NULL,48.5,29859,NULL,NULL,'Dipole','ESO 007- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77198,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77198,38.3,0.46,457,29860,70,NULL,NULL,'SDSS J110506.79+233114.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000145,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,166.278333,23.52081,0,NULL,60968625686,952634776,14884918,18.5),(77199,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77199,37.57,0.46,327,29861,70,NULL,NULL,'2MASX J11050714+0237430',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000176,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,166.279833,2.62864,0.161,NULL,60293290856,942082669,14720041,17.2),(77200,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77200,38.06,0.33,409,29862,70,NULL,NULL,'SDSS J110507.71+074830.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,166.282125,7.80836,0.057,NULL,60313449537,942397649,14724963,18.1),(77201,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77201,34.04,0.46,64.3,29863,70,NULL,NULL,'2MASX J11050813+1016533',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000083,NULL,'15.2g',0.55,'E0',NULL,NULL,NULL,NULL,1,166.2839583,10.28144,0.029,NULL,61022855340,953482114,14898158,15.2),(77202,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77202,38.13,0.46,423,29864,70,NULL,NULL,'2MASX J11050914+4147185',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,166.288125,41.78844,0,NULL,63932583564,998946618,15608540,17.6),(77203,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77203,35.16,0.51,108,29865,70,NULL,NULL,'CGCG 010-071',NULL,'2014MNRAS.445.2677S',2014,1,1.15,NULL,'G',0.000097,NULL,'14.9g',0.38,'SABab',NULL,NULL,NULL,NULL,1,166.288375,-0.79697,0.117,NULL,40918517231,639351831,9989872,14.9),(77204,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77204,36.75,0.46,224,29866,70,NULL,NULL,'2MASX J11050962+0955243',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000159,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,166.2902917,9.92344,0.037,NULL,61021211334,953456427,14897756,16.2),(77205,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77205,38.61,0.46,526,29867,70,NULL,NULL,'SDSS J110510.00+405616.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,166.2917083,40.93789,0,NULL,63934286734,998973230,15608956,18.4),(77206,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77206,38.36,0.46,469,29868,70,NULL,NULL,'2MASX J11051007+2026065',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,166.2919583,20.43508,0,NULL,61167581200,955743456,14933491,18),(77207,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77207,37.57,0.46,327,29869,70,NULL,NULL,'2MASXi J1105104+331019',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.7g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,166.293583,33.172,0,NULL,60634302509,947410976,14803296,17.7),(77208,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77208,35.55,0.46,129,29870,70,NULL,NULL,'2MASX J11051144+4606109',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000177,NULL,'15.5g',0.34,'S0',NULL,NULL,NULL,NULL,1,166.297833333,46.10294,0,NULL,63940096123,999064001,15610375,15.5),(77209,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77209,37.77,0.46,359,29871,70,NULL,NULL,'SDSS J110512.18+404344.3',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,166.30075,40.729,0,NULL,63934281013,998973140,15608955,17.9),(77210,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77210,37.33,0.46,292,29872,70,NULL,NULL,'2MASX J11051311+1929075',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,166.304666667,19.48553,0,NULL,61162901636,955670338,14932349,17.4),(77211,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77211,30.91,0.39,15.2,29873,73,NULL,'IR','ESO 502- G 016',NULL,'2011A&A...532A.104N',2011,1,1.6,NULL,'G',0.00004,NULL,'14.68',0.5,'SB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,166.30725,-26.62417,0.249,NULL,41508942928,648577233,10134019,14.68),(77212,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77212,30.91,0.4,15.2,29873,75,NULL,NULL,'ESO 502- G 016',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77213,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77213,31.47,0.49,19.7,29873,75,NULL,'IR','ESO 502- G 016',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77214,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77214,37.28,0.27,286,29874,70,NULL,NULL,'2MASX J11051695+3001511',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000171,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,166.320583333,30.031,0,NULL,60637288719,947457636,14804025,17.8),(77215,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77215,36.75,0.71,224,29875,70,NULL,NULL,'2MASX J11051855-8312265',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,166.327041667,-83.20731,0.485,NULL,39756494064,621195219,9706175,17.1),(77216,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77216,35.45,0.46,123,29876,70,NULL,NULL,'2MASX J11051935+2206015',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.51',0.21,NULL,NULL,NULL,NULL,NULL,1,166.330625,22.10058,0,NULL,61156566611,955571353,14930802,16.51),(77217,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77217,37.28,0.27,286,29877,70,NULL,NULL,'CGCG 155-059',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.0002,NULL,'15.3g',0.58,'E;BrClG',NULL,NULL,'radio jet',NULL,1,166.3450417,30.16153,0,NULL,60637141524,947455336,14803989,15.3),(77218,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77218,38.17,0.46,431,29878,70,NULL,NULL,'2MASX J11052522+0203100',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,166.355166667,2.05272,0.145,NULL,60293510065,942086094,14720095,18),(77219,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77219,35.57,0.46,130,29879,70,NULL,NULL,'2MASX J11052705+4509276',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000094,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,166.362917,45.15789,0,NULL,63940968187,999077627,15610587,16.5),(77220,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77220,37.67,0.46,341,29880,70,NULL,NULL,'2MASX J11052759+5724026',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,166.365083,57.40072,0,NULL,62007299000,968864046,15138500,17.6),(77221,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77221,37.47,0.33,312,29881,70,NULL,NULL,'2MASX J11052773+3354271',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,166.3657083,33.90742,0,NULL,60636147606,947439806,14803746,17.3),(77222,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77222,37.92,0.46,385,29882,70,NULL,NULL,'SDSS J110528.95+005349.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000083,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,166.370666667,0.89708,0.037,NULL,60295211417,942112678,14720510,18.4),(77223,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77223,37.04,0.46,255,29883,70,NULL,NULL,'2MASX J11053057+1836582',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.24',0.17,NULL,NULL,NULL,NULL,NULL,1,166.3775,18.61636,0,NULL,61165315367,955708052,14932938,18.24),(77224,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77224,37.05,0.33,257,29884,70,NULL,NULL,'2MASX J11053090+5018114',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000172,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,166.378667,50.30308,0,NULL,63914010939,998656420,15604006,16.8),(77225,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77225,37.28,0.27,286,29885,70,NULL,NULL,'2MASX J11053089+3005171',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000171,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,166.378875,30.08808,0,NULL,60637171435,947455803,14803996,16.8),(77226,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77226,37.77,0.33,359,29886,70,NULL,NULL,'2MASX J11053319+0713318',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,166.388333333,7.22558,0.069,NULL,60313701789,942401590,14725024,17.1),(77227,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77227,37.77,0.33,359,29887,70,NULL,NULL,'SDSS J110533.48+071515.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000135,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,166.3895417,7.25439,0.069,NULL,60313831396,942403615,14725056,18.5);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (77228,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77228,38.48,0.27,496,29888,70,NULL,NULL,'SDSS J110533.63+020406.8',NULL,'2015arXiv151105856S',2015,1,0.16,'2dF final data release has z = 0.24260: +- 0.00041.','G',0.000169,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,166.390125,2.06858,0.145,NULL,60293460010,942085312,14720083,18.7),(77229,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77229,37.71,0.27,348,29889,70,NULL,NULL,'2MASX J11053398+4256057',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,166.39175,42.93492,0,NULL,63939916067,999061188,15610331,17.4),(77230,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77230,37.54,0.46,322,29890,70,NULL,NULL,'2MASX J11053406+4002116',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,166.391916667,40.03664,0,NULL,63937807079,999028235,15609816,17.5),(77231,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77231,37.61,0.33,332,29891,70,NULL,NULL,'SDSS J110534.06+380034.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00017,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,166.3919583,38.00944,0,NULL,63922608690,998790760,15606105,17.8),(77232,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77232,37.71,0.27,348,29892,70,NULL,NULL,'SDSS J110534.36+425117.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,166.393167,42.85472,0,NULL,63939926944,999061358,15610333,18.5),(77233,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77233,30.15,NULL,10.7,29893,NULL,NULL,NULL,'UGC 06145',NULL,'2015AstBu..70....1K',2015,1,1.4,'UGC incorrectly has +04d26m.','G',0.000007,NULL,'16.45',1.2,'Im',NULL,NULL,NULL,NULL,1,166.394125,-1.86322,0.153,NULL,40918959941,639358749,9989980,16.45),(77234,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77234,37.71,0.27,348,29894,70,NULL,NULL,'2MASX J11053580+4256427',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000198,NULL,'15.8g',0.42,'E0',NULL,NULL,NULL,NULL,1,166.399041667,42.94533,0,NULL,63939914276,999061160,15610330,15.8),(77235,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77235,36.61,0.46,210,29895,70,NULL,NULL,'2MASX J11053598+0052404',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000103,NULL,'15.9g',0.39,'E0',NULL,NULL,NULL,NULL,1,166.400083333,0.87786,0.037,NULL,60295156710,942111823,14720497,15.9),(77236,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77236,37.56,0.46,325,29896,70,NULL,NULL,'2MASX J11053725+2920336',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000139,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,166.405125,29.34264,0,NULL,60607894409,946998350,14796849,17.9),(77237,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77237,35.23,0.46,111,29897,70,NULL,NULL,'2MASX J11053798-0013027',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000091,NULL,'15.7g',0.47,'S0/a',NULL,NULL,NULL,NULL,1,166.4082083,-0.21742,0.077,NULL,40904156469,639127444,9986366,15.7),(77238,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77238,37.61,0.46,332,29898,70,NULL,NULL,'2MASX J11053869+3834365',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000153,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,166.41125,38.57692,0,NULL,63922512532,998789258,15606082,17.1),(77239,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77239,38.19,0.46,435,29899,70,NULL,NULL,'SDSS J110541.08+042620.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000137,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,166.421166667,4.439,0.185,NULL,60317310685,942457979,14725905,18.6),(77240,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77240,36.67,0.46,216,29900,70,NULL,NULL,'2MASX J11054111+0542234',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000185,NULL,'15.9g',0.41,'E0',NULL,NULL,NULL,NULL,1,166.421166667,5.70653,0.105,NULL,60315733837,942433341,14725520,15.9),(77241,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77241,33.77,NULL,56.8,29901,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 438- G 002',NULL,'2010Ap&SS.325..163P',2010,1,1.31,NULL,'G',0.000017,NULL,'17.07',0.09,'Sd',NULL,NULL,NULL,NULL,1,166.425083333,-31.46017,0.317,NULL,41569350576,649521102,10148767,17.07),(77242,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77242,33.78,NULL,57,29901,NULL,NULL,'Dipole + Quadrupole','ESO 438- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77243,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77243,33.79,NULL,57.4,29901,NULL,NULL,'Dipole','ESO 438- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77244,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77244,33.81,NULL,57.9,29901,NULL,NULL,NULL,'ESO 438- G 002',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77245,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77245,37.47,0.33,311,29902,70,NULL,NULL,'2MASX J11054228+3100020',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000172,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,166.426333,31.00061,0,NULL,60640579907,947509061,14804829,16.5),(77246,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77246,35.55,0.54,129,29903,70,NULL,NULL,'MCG -02-28-046',NULL,'2014MNRAS.445.2677S',2014,1,0.15,NULL,'G',0.000107,NULL,'16',0.15,NULL,NULL,NULL,NULL,NULL,1,166.4275,-9.91683,0.093,NULL,41777065032,652766641,10199478,16),(77247,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77247,37.52,0.46,319,29904,70,NULL,NULL,'2MASX J11054273+3856341',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,166.428,38.94267,0,NULL,63936950183,999014846,15609606,17.1),(77248,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77248,37.05,0.33,257,29905,70,NULL,NULL,'2MASX J11054295+5014187',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000165,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,166.429167,50.23864,0,NULL,63914044147,998656939,15604014,17.7),(77249,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77249,37.47,0.33,312,29906,70,NULL,NULL,'2MASX J11054307+3347110',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000212,NULL,'15.8g',0.43,NULL,NULL,NULL,NULL,NULL,1,166.429375,33.78639,0,NULL,60634271777,947410496,14803289,15.8),(77250,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77250,37.08,0.46,260,29907,70,NULL,NULL,'2MASX J11054377+3553030',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000171,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,166.432667,35.88403,0.051,NULL,60415566931,943993233,14749894,16.5),(77251,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77251,35.72,0.46,139,29908,70,NULL,NULL,'CGCG 095-109',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00018,NULL,'15.5',0.27,NULL,NULL,NULL,NULL,NULL,1,166.4347917,19.81078,0,NULL,61162838275,955669348,14932333,15.5),(77252,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77252,37.39,0.46,301,29909,70,NULL,NULL,'2MASX J11054522+2214192',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.15',0.16,NULL,NULL,NULL,NULL,NULL,1,166.4385,22.23889,0,NULL,61156468538,955569820,14930778,18.15),(77253,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77253,35.04,0.46,102,29910,70,NULL,NULL,'2MASX J11054608+3737051',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000168,NULL,'16.1g',0.32,NULL,NULL,NULL,NULL,NULL,1,166.442167,37.61819,0,NULL,63922897089,998795267,15606176,16.1),(77254,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77254,36.84,0.46,234,29911,70,NULL,NULL,'2MASX J11054658+2642346',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000196,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,166.44425,26.7095,0,NULL,60601403698,946896932,14795264,16.6),(77255,'IRAS','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77255,30.28,0.8,11.4,29912,75,NULL,'A82, H','NGC 3521',NULL,'1997ApJS..109..333W',1997,1,11,'Extended HIPASS source','G',0.00001,NULL,'9.83',5.1,'SAB(rs)bc;HII  LINER','Isolated galaxy',NULL,NULL,NULL,1,166.452416667,-0.03586,0.057,NULL,40904060386,639125943,9986342,9.83),(77256,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77256,28,0.69,3.98,29912,100,NULL,'mid-IR','NGC 3521',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77257,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77257,29.28,0.4,7.2,29912,75,NULL,'B','NGC 3521',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77258,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77258,30.12,0.47,10.6,29912,75,NULL,'A82, H, raw','NGC 3521',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77259,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77259,30.15,NULL,10.7,29912,NULL,NULL,NULL,'NGC 3521',NULL,'2015AstBu..70....1K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77260,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77260,30.15,NULL,10.7,29912,NULL,NULL,NULL,'NGC 3521',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77261,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77261,30.25,0.35,11.2,29912,NULL,NULL,NULL,'NGC 3521',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77262,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77262,30.25,0.39,11.2,29912,73,NULL,'opt','NGC 3521',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77263,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77263,30.3,0.4,11.5,29912,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 3521',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77264,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77264,30.34,0.47,11.7,29912,75,NULL,'A82, H, inv','NGC 3521',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77265,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77265,30.47,0.47,12.4,29912,75,NULL,'A82, H, cor','NGC 3521',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77266,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77266,30.66,0.43,13.5,29912,75,NULL,'3.6 micron, color corrected','NGC 3521',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77267,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77267,30.7,0.43,13.8,29912,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3521',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77268,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77268,30.76,0.2,14.2,29912,74.4,NULL,NULL,'NGC 3521',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77269,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77269,30.98,0.39,15.7,29912,73,NULL,'opt','NGC 3521',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77270,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77270,31.07,0.36,16.3,29912,NULL,NULL,'Malmquist cor.','NGC 3521',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77271,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77271,31.08,0.36,16.4,29912,NULL,NULL,NULL,'NGC 3521',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77272,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77272,35.54,0.46,128,29913,70,NULL,NULL,'2MASX J11054901+3529331',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000177,NULL,'16.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,166.4544583,35.49253,0,NULL,60415229924,943987967,14749811,16.3),(77273,'IRAS','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77273,33.47,0.8,49.3,29914,75,NULL,'MAT, I','ESO 570- G 002',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00002,NULL,'14.27',0.7,'SB(r)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,166.457417,-20.791,0.137,NULL,41857203131,654018798,10219043,14.27),(77274,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77274,33.23,0.32,44.3,29914,85,NULL,'I, raw','ESO 570- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77275,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77275,33.25,0.32,44.7,29914,85,NULL,'I, inv','ESO 570- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77276,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77276,33.47,0.43,49.5,29914,75,NULL,'MAT, I, raw','ESO 570- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77277,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77277,33.59,0.43,52.4,29914,75,NULL,'MAT, I, inv','ESO 570- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77278,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77278,33.6,0.4,52.4,29914,NULL,NULL,'mean','ESO 570- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77279,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77279,33.68,0.43,54.6,29914,75,NULL,'MAT, I, cor','ESO 570- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77280,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77280,33.73,0.09,55.8,29914,NULL,NULL,NULL,'ESO 570- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77281,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77281,33.8,0.2,57.5,29914,74.4,NULL,NULL,'ESO 570- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77282,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77282,34.01,0.47,63.4,29914,NULL,NULL,'H','ESO 570- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77283,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77283,37.68,0.23,344,29915,70,NULL,NULL,'2MASX J11054998+5718376',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000195,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,166.458083333,57.31061,0,NULL,62007217235,968862769,15138480,16.6),(77284,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77284,36.59,0.23,208,29916,70,NULL,NULL,'MCG +05-26-052',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000191,NULL,'15.2g',0.62,NULL,NULL,NULL,NULL,NULL,1,166.4665417,31.38578,0.015,NULL,60640637890,947509967,14804843,15.2),(77285,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77285,35.07,0.2,103,29917,74.4,NULL,NULL,'MCG -01-28-024',NULL,'2013AJ....146...86T',2013,1,1.5,'MCG decs for MCG -01-28 field are 10 arcmin too far north (MCG4 errata).','G',0.00015,NULL,'15',1,'SAB(rs)bc:',NULL,NULL,NULL,NULL,1,166.466667,-9.70272,0.057,NULL,41777076470,652766819,10199481,15),(77286,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77286,37.43,0.46,306,29918,70,NULL,NULL,'SDSS J110552.76+072404.2',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000153,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,166.469875,7.40117,0.069,NULL,60313889971,942404530,14725070,18.6),(77287,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77287,38.94,0.46,614,29919,70,NULL,NULL,'2MASX J11055458+3843022',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000183,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,166.477375,38.71722,0,NULL,63936459196,999007174,15609487,18),(77288,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77288,31.93,0.4,24.3,29920,75,NULL,'B','UGC 06151',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000018,NULL,'14.8B',1.3,'Sm:','Group member',NULL,NULL,NULL,1,166.4845417,19.82628,0,NULL,61162820215,955669065,14932329,14.8),(77289,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77289,37.94,0.46,387,29921,70,NULL,NULL,'SDSS J110556.49+502952.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000164,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,166.485417,50.49792,0,NULL,61780087099,965313860,15083029,18.2),(77290,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77290,36.85,0.46,234,29922,70,NULL,NULL,'2MASX J11055697+4945037',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000141,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,166.48725,49.75097,0,NULL,63914846286,998669473,15604210,17),(77291,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77291,38.43,0.33,486,29923,70,NULL,NULL,'2MASX J11055700+2002380',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,166.487333,20.04394,0,NULL,61163307643,955676681,14932448,18.2),(77292,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77292,37.61,0.33,332,29924,70,NULL,NULL,'2MASX J11055895+3759152',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,166.495583333,37.98761,0,NULL,63922619596,998790931,15606108,16.8),(77293,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77293,35.32,0.46,116,29925,70,NULL,NULL,'CGCG 291-028',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000173,NULL,'15.4g',0.4,'Sy',NULL,NULL,NULL,NULL,1,166.495916667,58.94606,0,NULL,62000154099,968752407,15136756,15.4),(77294,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77294,37.24,0.46,280,29926,70,NULL,NULL,'2MASX J11060101+2149540',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.21',0.17,NULL,NULL,NULL,NULL,NULL,1,166.504333333,21.83167,0,NULL,61155416565,955553383,14930521,18.21),(77295,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77295,36.68,0.46,217,29927,70,NULL,NULL,'2MASX J11060155+2737385',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000153,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,166.5064583,27.6275,0.011,NULL,60609356243,947021191,14797206,17),(77296,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77296,37.01,0.33,252,29928,70,NULL,NULL,'2MASX J11060239+4310246',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000243,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,166.509875,43.17347,0,NULL,63940054814,999063356,15610364,16.4),(77297,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77297,38.2,0.46,437,29929,70,NULL,NULL,'2MASXi J1106034+281654',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,166.51425,28.28181,0,NULL,60611415671,947053369,14797708,18),(77298,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77298,37.04,0.46,256,29930,70,NULL,NULL,'2MASX J11060363+1617079',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,166.5152917,16.28561,0,NULL,61140662514,955322851,14926919,17),(77299,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77299,34.51,0.46,79.8,29931,70,NULL,NULL,'2MASX J11060426-1225503',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000123,NULL,'14.93',NULL,NULL,NULL,NULL,NULL,NULL,1,166.517833,-12.43067,0.093,NULL,41810211679,653284557,10207571,14.93),(77300,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77300,37.94,0.46,387,29932,70,NULL,NULL,'2MASX J11060451-0059161',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000085,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,166.518875,-0.98772,0.125,NULL,40918419509,639350304,9989848,17.4),(77301,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77301,35.52,0.33,127,29933,70,NULL,NULL,'CGCG 038-122',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00011,NULL,'15.5g',0.48,'E',NULL,NULL,NULL,NULL,1,166.520041667,3.31947,0.141,NULL,60286661741,941979089,14718423,15.5),(77302,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77302,37.1,0.46,263,29934,70,NULL,NULL,'2MASX J11060499+0531427',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000171,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,166.520791667,5.52836,0.117,NULL,60315754426,942433662,14725525,16.6),(77303,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77303,36.08,0.33,164,29935,70,NULL,NULL,'CGCG 184-057',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.00009,NULL,'15.1g',0.56,NULL,NULL,NULL,NULL,NULL,1,166.527417,34.69586,0,NULL,60636500989,947445327,14803833,15.1),(77304,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77304,34.92,0.36,96.5,29936,NULL,NULL,NULL,'UGC 06152',NULL,'2009ApJS..182..474S',2009,1,1.26,NULL,'G',0.000013,NULL,'14.8g',0.45,'SBb',NULL,NULL,NULL,NULL,1,166.5287083,29.93281,0,NULL,60653984909,947718514,14808101,14.8),(77305,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77305,34.93,0.36,96.7,29936,NULL,NULL,'Malmquist cor.','UGC 06152',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77306,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77306,35.02,0.2,101,29936,74.4,NULL,NULL,'UGC 06152',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77307,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77307,36.59,0.23,208,29937,70,NULL,NULL,'2MASX J11060711+3120281',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000174,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,166.529667,31.34131,0.015,NULL,60640627887,947509810,14804840,16.8),(77308,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77308,38.43,0.33,486,29938,70,NULL,NULL,'2MASX J11060906+2001130',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.55',0.16,NULL,NULL,NULL,NULL,NULL,1,166.537625,20.02028,0,NULL,61163309632,955676713,14932448,18.55),(77309,'GRB','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77309,47,1.07,5750,29939,72,NULL,NULL,'GRB 030323',3.372,'2008JCAP...07..004M',2008,1,NULL,NULL,'G',NULL,NULL,'18.7R',NULL,'HETE',NULL,NULL,NULL,NULL,1,166.539083333,-21.77036,0.201,NULL,41844139066,653814672,10215854,18.7),(77310,'GRB','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77310,47.13,1.07,6100,29939,70,NULL,NULL,'GRB 030323',3.372,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77311,'GRB','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77311,47.2,1.19,6290,29939,NULL,NULL,NULL,'GRB 030323',3.372,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77312,'GRB','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77312,47.65,0.96,7750,29939,69.7,NULL,'Calibrated','GRB 030323',3.372,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77313,'GRB','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77313,47.79,0.97,8270,29939,69.7,NULL,'Fiducial','GRB 030323',3.372,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77314,'GRB','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77314,47.84,1.72,8460,29939,100,NULL,NULL,'GRB 030323',3.372,'2009EPJC...63..139W',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77315,'GRB','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77315,47.96,1.67,8940,29939,72,NULL,NULL,'GRB 030323',3.372,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77316,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77316,37.87,0.46,375,29940,70,NULL,NULL,'SDSS J110609.58-011029.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000072,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,166.539917,-1.17494,0.117,NULL,40918346447,639349163,9989830,18.4),(77317,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77317,36.08,0.33,164,29941,70,NULL,NULL,'2MASX J11061011+3438321',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,166.542125,34.64228,0,NULL,60636471619,947444869,14803826,17),(77318,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77318,35.52,0.33,127,29942,70,NULL,NULL,'CGCG 038-124',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.0002,NULL,'15.2g',0.54,'SB0^0^ pec',NULL,NULL,NULL,NULL,1,166.5425417,3.32072,0.141,NULL,60286661931,941979092,14718423,15.2),(77319,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77319,36.67,0.33,216,29943,70,NULL,NULL,'2MASX J11061041+4238136',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000194,NULL,'15.9g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,166.54325,42.63711,0,NULL,63939161793,999049403,15610146,15.9),(77320,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77320,36.83,0.69,233,29944,70,NULL,NULL,'2MASX J11061060-4603402',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,166.54425,-46.06117,0.625,NULL,41927338361,655114661,10236166,17),(77321,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77321,37.98,0.46,394,29945,70,NULL,NULL,'2MASX J11061077+0221577',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,166.5447917,2.36611,0.145,NULL,60293812752,942090824,14720169,17.9),(77322,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77322,34.69,0.46,86.6,29946,70,NULL,NULL,'CGCG 038-125',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.00016,NULL,'14.4g',0.7,'SA0-',NULL,NULL,NULL,NULL,1,166.5454583,4.33608,0.177,NULL,60317631894,942462998,14725984,14.4),(77323,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77323,35.97,0.49,156,29947,70,NULL,NULL,'2MASX J11061093-1208193',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.56',NULL,NULL,NULL,NULL,NULL,NULL,1,166.5455,-12.13875,0.093,NULL,41810585786,653290402,10207662,16.56),(77324,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77324,36.67,0.33,216,29948,70,NULL,NULL,'2MASX J11061168+4236336',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000157,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,166.548583,42.60925,0,NULL,63939161335,999049395,15610146,16.5),(77325,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77325,36.68,0.46,216,29949,70,NULL,NULL,'2MASX J11061177+0044197',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000064,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,166.549083,0.73881,0.105,NULL,60295088971,942110765,14720480,16.9),(77326,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77326,37.19,0.46,275,29950,70,NULL,NULL,'2MASX J11061203+0543097',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,166.550083333,5.71919,0.117,NULL,60315783605,942434118,14725533,16.5),(77327,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77327,39.17,0.46,682,29951,70,NULL,NULL,'SDSS J110612.15+061333.5',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000164,NULL,'18.8g',0.1,'AGN',NULL,NULL,NULL,NULL,1,166.550625,6.226,0.097,NULL,60308793745,942324902,14723826,18.8),(77328,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77328,38.8,0.46,576,29952,70,NULL,NULL,'2MASX J11061434+3633172',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000174,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,166.559875,36.55483,0.033,NULL,63921458251,998772785,15605824,18),(77329,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77329,36.88,0.33,238,29953,70,NULL,NULL,'2MASX J11061675+2431461',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000207,NULL,'15.7g',0.45,NULL,NULL,NULL,NULL,NULL,1,166.569833333,24.5295,0,NULL,60482797513,945043711,14766307,15.7),(77330,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77330,39.2,0.46,692,29954,70,NULL,NULL,'SDSS J110616.89+011102.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000083,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,166.570416667,1.18411,0.117,NULL,60294994569,942109290,14720457,18.3),(77331,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77331,37.72,0.33,349,29955,70,NULL,NULL,'2MASX J11061703+0858333',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000195,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,166.570916667,8.97592,0.021,NULL,60299362873,942177544,14721524,16.4),(77332,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77332,36.54,0.62,203,29956,70,NULL,NULL,'2MASX J11061737-4704223',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,166.572375,-47.07286,0.645,NULL,41914838895,654919357,10233114,17.4),(77333,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77333,36.4,0.46,190,29957,70,NULL,NULL,'2MASX J11061786+0657513',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000159,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,166.5742917,6.96433,0.085,NULL,60310419759,942350308,14724223,16.8),(77334,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77334,34.83,0.5,92.6,29958,70,NULL,NULL,'2MASX J11061890-1003056',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.60',0.4,NULL,NULL,NULL,NULL,NULL,1,166.5787917,-10.0515,0.081,NULL,41776875197,652763674,10199432,15.6),(77335,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77335,36,0.86,158,29959,70,NULL,NULL,'2MASX J11061998-4822366',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.38',NULL,'Sb',NULL,NULL,NULL,NULL,1,166.583333,-48.37686,0.589,NULL,41916862327,654950973,10233608,16.38),(77336,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77336,36.94,0.46,245,29960,70,NULL,NULL,'2MASX J11062058+2402291',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00018,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,166.585875,24.04139,0,NULL,60481913841,945029903,14766092,16.3),(77337,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77337,35.71,0.51,138,29961,70,NULL,NULL,'CGCG 010-075',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00013,NULL,'15.46',0.53,NULL,NULL,NULL,NULL,NULL,1,166.58725,-2.31506,0.181,NULL,40915770987,639308921,9989201,15.46),(77338,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77338,35.55,0.46,129,29962,70,NULL,NULL,'SBS 1103+506',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000086,NULL,'16.1g',0.32,'Sy',NULL,NULL,NULL,NULL,1,166.5890417,50.388,0,NULL,61780127794,965314496,15083039,16.1),(77339,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77339,38.28,0.46,452,29963,70,NULL,NULL,'2MASX J11062197+2915031',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000175,NULL,'18.79',0.12,NULL,NULL,NULL,NULL,NULL,1,166.591541667,29.25086,0,NULL,60608577134,947009017,14797015,18.79),(77340,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77340,37.51,0.46,318,29964,70,NULL,NULL,'2MASX J11062224+0022377',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000092,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,166.5927917,0.37725,0.097,NULL,60282801494,941918773,14717480,16.4),(77341,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77341,37.1,0.63,263,29965,70,NULL,NULL,'2MASX J11062265-4830486',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,166.594417,-48.51344,0.789,NULL,41916870377,654951099,10233610,17.5),(77342,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77342,38.06,0.46,409,29966,70,NULL,NULL,'2MASX J11062268+3202429',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,166.594625,32.04533,0.03,NULL,60639886107,947498220,14804659,18),(77343,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77343,37.6,0.46,332,29967,70,NULL,NULL,'2MASX J11062285+2320280',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000172,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,166.595333,23.34103,0,NULL,61153209064,955518891,14929982,16.8),(77344,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77344,36.45,0.46,195,29968,70,NULL,NULL,'MCG +10-16-060',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000197,NULL,'15.3g',0.53,'E0',NULL,NULL,NULL,NULL,1,166.5964583,58.15389,0,NULL,61998833879,968731779,15136434,15.3),(77345,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77345,37.72,0.33,349,29969,70,NULL,NULL,'2MASX J11062325+0903073',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000172,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,166.596916667,9.05203,0.021,NULL,60299363358,942177552,14721524,16.4),(77346,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77346,38.48,0.27,496,29970,70,NULL,NULL,'2MASX J11062358+0203127',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.64',0.22,'BrClG',NULL,NULL,NULL,NULL,1,166.598333,2.05361,0.141,NULL,60297059390,942141552,14720961,17.64),(77347,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77347,34.44,NULL,77.3,29971,NULL,NULL,NULL,'FGC 1195',NULL,'2000BSAO...50....5K',2000,1,1.44,NULL,'G',0.000033,NULL,'15.8',0.18,'Sdm',NULL,NULL,NULL,NULL,1,166.598583,-5.34828,0.101,NULL,40922098968,639407796,9990746,15.8),(77348,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77348,34.5,NULL,79.4,29971,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1195',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77349,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77349,34.5,NULL,79.4,29971,NULL,NULL,'Dipole + Quadrupole','FGC 1195',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77350,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77350,34.5,NULL,79.6,29971,NULL,NULL,'Dipole','FGC 1195',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77351,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77351,37.48,0.46,313,29972,70,NULL,NULL,'2MASXi J1106248+330800',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000172,NULL,'18.1g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,166.6035417,33.1335,0.016,NULL,60648155534,947627430,14806678,18.1),(77352,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77352,33.17,0.4,43,29973,75,NULL,'B','UGC 06157',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000003,NULL,'13.9',1.8,'SA(s)dm',NULL,NULL,NULL,NULL,1,166.605041667,17.508,0,NULL,61195874275,956185535,14940398,13.9),(77353,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77353,32.51,NULL,31.8,29974,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 377- G 007',NULL,'2010Ap&SS.325..163P',2010,1,1.77,'Matthews (2000A&AS..143..421M) says v=2749 km/sec may refer to ESO 377-006.','G',0.00005,NULL,'15.93',0.22,'Sd',NULL,NULL,NULL,NULL,1,166.609583,-36.69694,0.337,NULL,41896118430,654626850,10228544,15.93),(77354,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77354,32.53,NULL,32.1,29974,NULL,NULL,'Dipole + Quadrupole','ESO 377- G 007',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77355,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77355,32.55,NULL,32.3,29974,NULL,NULL,'Dipole','ESO 377- G 007',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77356,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77356,32.61,NULL,33.3,29974,NULL,NULL,NULL,'ESO 377- G 007',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77357,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77357,36.56,0.46,206,29975,70,NULL,NULL,'2MASX J11062652+0251557',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000193,NULL,'16.0g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,166.6105,2.86539,0.437,NULL,60293723151,942089424,14720147,16),(77358,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77358,36.08,0.2,164,29976,74.4,NULL,NULL,'CGCG 066-111',NULL,'2013AJ....146...86T',2013,1,0.62,NULL,'G',0.000016,NULL,'15.9g',0.34,'Sb','Pair member (points to parent)',NULL,NULL,NULL,1,166.6129583,11.41372,0,NULL,61022410057,953475157,14898049,15.9),(77359,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77359,32.41,NULL,30.4,29977,NULL,NULL,NULL,'SDSS J110627.28+182324.0',NULL,'2015AstBu..70....1K',2015,1,0.63,NULL,'G',NULL,NULL,'17.45',0.14,NULL,NULL,NULL,NULL,NULL,1,166.6140417,18.39,0,NULL,61162011799,955656434,14932131,17.45),(77360,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77360,38.2,0.14,437,29978,70,NULL,NULL,'2MASX J11062784+1553092',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.0001,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,166.616167,15.88603,0,NULL,61144206442,955378225,14927784,16.8),(77361,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77361,37.92,0.46,384,29979,70,NULL,NULL,'2MASX J11062810+1522062',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000166,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,166.61725,15.36828,0,NULL,61143715637,955370556,14927664,16.5),(77362,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77362,35,NULL,99.8,29980,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1194',NULL,'2010Ap&SS.325..163P',2010,1,1.2,NULL,'G',0.000057,NULL,'16.3g',0.16,'Sd(f)',NULL,NULL,NULL,NULL,1,166.61925,67.49014,0.013,NULL,62088205964,970128218,15158253,16.3),(77363,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77363,35.01,NULL,101,29980,NULL,NULL,'Dipole + Quadrupole','FGC 1194',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77364,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77364,35.03,NULL,101,29980,NULL,NULL,'Dipole','FGC 1194',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77365,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77365,35.06,NULL,103,29980,NULL,NULL,NULL,'FGC 1194',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77366,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77366,38.29,0.33,454,29981,70,NULL,NULL,'2MASX J11062924+4947522',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,166.6219583,49.79781,0,NULL,63914873013,998669890,15604217,18.2),(77367,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77367,37.56,0.46,325,29982,70,NULL,NULL,'2MASX J11062924+4102098',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000175,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,166.622,41.03619,0,NULL,63934215430,998972116,15608939,16.9),(77368,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77368,36.3,0.33,182,29983,70,NULL,NULL,'2MASX J11063022+1308462',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000172,NULL,'16.1g',0.31,NULL,NULL,NULL,NULL,NULL,1,166.626125,13.14606,0,NULL,61137500764,955273449,14926147,16.1),(77369,'IRAS','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77369,32.84,0.8,36.9,29984,75,NULL,'MAT, I','ESO 377- G 010',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.000033,NULL,'13.62',0.7,'SB(rs)b:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,166.6322917,-37.65311,0.373,NULL,41895605125,654618830,10228419,13.62),(77370,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77370,32.58,0.46,32.8,29984,NULL,NULL,'J','ESO 377- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77371,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77371,32.6,0.32,33.1,29984,85,NULL,'I, raw','ESO 377- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77372,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77372,32.64,0.47,33.7,29984,NULL,NULL,'H','ESO 377- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77373,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77373,32.65,0.32,33.9,29984,85,NULL,'I, inv','ESO 377- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77374,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77374,32.67,0.45,34.2,29984,NULL,NULL,'K','ESO 377- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77375,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77375,32.68,0.49,34.3,29984,75,NULL,'IR','ESO 377- G 010',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77376,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77376,32.68,0.43,34.3,29984,75,NULL,'MAT, I, raw','ESO 377- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77377,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77377,32.86,0.2,37.3,29984,74.4,NULL,NULL,'ESO 377- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77378,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77378,32.9,0.43,38,29984,75,NULL,'MAT, I, cor','ESO 377- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77379,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77379,32.91,0.43,38.2,29984,75,NULL,'MAT, I, inv','ESO 377- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77380,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77380,32.92,0.43,38.3,29984,75,NULL,'3.6 micron, color corrected','ESO 377- G 010',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77381,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77381,32.99,0.4,39.6,29984,75,NULL,NULL,'ESO 377- G 010',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77382,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77382,33.04,0.43,40.5,29984,75,NULL,'3.6 micron, color + selection bias corrected','ESO 377- G 010',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77383,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77383,33.22,0.4,44,29984,NULL,NULL,'mean','ESO 377- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77384,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77384,33.49,0.08,50,29984,NULL,NULL,NULL,'ESO 377- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77385,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77385,36.77,0.46,226,29985,70,NULL,NULL,'2MASX J11063184+3830108',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000169,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,166.632583,38.50303,0,NULL,63922538292,998789660,15606088,16.6),(77386,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77386,38.02,0.46,401,29986,70,NULL,NULL,'2MASX J11063199+0606441',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,166.633208333,6.11233,0.105,NULL,60308808879,942325138,14723830,17.6),(77387,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77387,36.8,0.46,230,29987,70,NULL,NULL,'2MASX J11063258+1618162',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000183,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,166.635916667,16.30458,0,NULL,61140867268,955326051,14926969,16.7),(77388,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77388,36.58,0.46,207,29988,70,NULL,NULL,'2MASX J11063276+6154153',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000175,NULL,'16.1g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,166.636208333,61.90422,0,NULL,61829852560,966091446,15095178,16.1),(77389,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77389,38.37,0.33,472,29989,70,NULL,NULL,'SDSS J110632.72+065250.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000131,NULL,'18.6g',0.09,NULL,NULL,NULL,NULL,NULL,1,166.636333333,6.88069,0.089,NULL,60310388509,942349820,14724215,18.6),(77390,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77390,37.68,0.23,344,29990,70,NULL,NULL,'2MASX J11063275+5713291',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000158,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,166.636541667,57.22472,0,NULL,62007106699,968861042,15138453,17.4),(77391,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77391,37.68,0.23,344,29991,70,NULL,NULL,'2MASX J11063299+5720201',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000174,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,166.6375,57.33894,0,NULL,62007379608,968865306,15138520,16.3),(77392,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77392,36.49,0.46,199,29992,70,NULL,NULL,'2MASX J11063341+1058351',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000154,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,166.6392917,10.97625,0.041,NULL,61022588027,953477937,14898092,16.8),(77393,'G Lens','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77393,40.79,0.35,1440,29993,NULL,NULL,NULL,'HE 1104-1805A ABS08',NULL,'2007ApJ...660....1O',2007,1,NULL,NULL,'AbLS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,166.639375,-18.35672,0.133,NULL,41846905959,653857905,10216529,NULL),(77394,'G Lens','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77394,41.68,NULL,2170,29993,NULL,NULL,'R(H) = ct','HE 1104-1805A ABS08',NULL,'2014ApJ...788..190W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77395,'G Lens','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77395,41.71,NULL,2200,29993,NULL,NULL,'Standard','HE 1104-1805A ABS08',NULL,'2014ApJ...788..190W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77396,'G Lens','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77396,42.47,0.85,3120,29993,NULL,NULL,NULL,'HE 1104-1805A ABS08',NULL,'2014MNRAS.437..600S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77397,'G Lens','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77397,43.42,NULL,4830,29993,70,NULL,NULL,'HE 1104-1805A ABS08',NULL,'2012MNRAS.426..868S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77398,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77398,36.3,0.33,182,29994,70,NULL,NULL,'SDSS J110633.66+130921.7',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'15.9g',0.39,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,166.6402917,13.15606,0,NULL,61137500943,955273452,14926147,15.9),(77399,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77399,38.48,0.27,496,29995,70,NULL,NULL,'SDSS J110634.19+020422.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,166.6425,2.07289,0.141,NULL,60297064673,942141635,14720963,18.6),(77400,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77400,36.78,0.46,227,29996,70,NULL,NULL,'2MASX J11063422+4916522',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000134,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,166.6425417,49.28108,0,NULL,63914208959,998659514,15604054,17.7),(77401,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77401,38.46,0.46,491,29997,70,NULL,NULL,'2MASX J11063487+0623271',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000169,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,166.6454583,6.39083,0.097,NULL,60308687048,942323235,14723800,17.6),(77402,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77402,36.89,0.46,239,29998,70,NULL,NULL,'2MASX J11063522+2057542',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.46',0.18,NULL,NULL,NULL,NULL,NULL,1,166.64675,20.96511,0,NULL,61155244650,955550697,14930479,17.46),(77403,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77403,34.85,0.52,93.4,29999,70,NULL,NULL,'2MASX J11063556-3119504',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.4b',NULL,'*+E',NULL,NULL,NULL,NULL,1,166.648125,-31.33078,0.317,NULL,41569718260,649526847,10148856,15.4),(77404,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77404,37.68,0.23,344,30000,70,NULL,NULL,'2MASX J11063620+5716541',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,166.650625,57.28181,0,NULL,62007113059,968861141,15138455,17.6),(77405,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77405,36.7,0.46,219,30001,70,NULL,NULL,'2MASX J11063635+4635216',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,166.6515417,46.58942,0,NULL,63914906718,998670417,15604225,17),(77406,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77406,36.01,0.33,159,30002,70,NULL,NULL,'IC 0667',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000153,NULL,'15.85',0.46,NULL,NULL,NULL,NULL,NULL,1,166.6522917,15.08872,0,NULL,61143745915,955371029,14927672,15.85),(77407,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77407,36.01,0.33,159,30003,70,NULL,NULL,'CGCG 095-111 NED02',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'16.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,166.6547917,15.09833,0,NULL,61143746449,955371038,14927672,16.6),(77408,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77408,37.65,0.46,338,30004,70,NULL,NULL,'SDSS J110638.16+163450.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000145,NULL,'18.7g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,166.659041667,16.58061,0,NULL,61140783828,955324747,14926949,18.7),(77409,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77409,37.12,0.46,265,30005,70,NULL,NULL,'2MASX J11064006+4749166',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000128,NULL,'17.2g',0.21,'AGN',NULL,NULL,NULL,NULL,1,166.6672083,47.82133,0,NULL,63915509580,998679837,15604372,17.2),(77410,'SBF','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77410,32.01,0.14,25.2,30006,74.4,NULL,NULL,'NGC 3522',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000017,NULL,'14.13',0.7,'E','Group member',NULL,NULL,NULL,1,166.668583,20.08556,0,NULL,61162515739,955664308,14932254,14.13),(77411,'SBF','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77411,32.03,0.28,25.5,30006,NULL,NULL,'I','NGC 3522',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77412,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77412,36.76,0.46,225,30007,70,NULL,NULL,'2MASX J11064151+0640011',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,166.673083,6.66697,0.085,NULL,60308434874,942319294,14723738,17.3),(77413,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77413,38.29,0.33,454,30008,70,NULL,NULL,'2MASX J11064194+4947232',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.5g',0.24,'AGN',NULL,NULL,NULL,NULL,1,166.6747917,49.78981,0,NULL,63914749443,998667960,15604186,17.5),(77414,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77414,36.77,0.46,226,30009,70,NULL,NULL,'2MASX J11064316+3931348',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000175,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,166.679917,39.52639,0,NULL,63937878645,999029353,15609833,16.5),(77415,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77415,38.16,0.46,429,30010,70,NULL,NULL,'2MASX J11064449+2441301',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000138,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,166.6852917,24.69186,0,NULL,60599904070,946873501,14794898,17.9),(77416,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77416,36.74,0.46,222,30011,70,NULL,NULL,'SDSS J110644.51+122420.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.0g',0.11,NULL,NULL,NULL,NULL,NULL,1,166.6855,12.40575,0,NULL,61140241306,955316270,14926816,18),(77417,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77417,35.87,0.5,149,30012,70,NULL,NULL,'2MASX J11064547-0404202',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,166.6895,-4.07222,0.097,NULL,40921461055,639397828,9990591,14.8),(77418,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77418,37.93,0.46,385,30013,70,NULL,NULL,'2MASX J11064615+5228372',NULL,'2015arXiv151105856S',2015,1,0.31,'This galaxy lenses a z = 0.407 object.','G',0.000179,NULL,'17.0g',0.23,'E',NULL,NULL,NULL,NULL,1,166.692333,52.47714,0,NULL,61788013233,965437706,15084964,17),(77419,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77419,36.26,0.46,179,30014,70,NULL,NULL,'2MASX J11064635+0015244',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000092,NULL,'16.4g',0.3,'S0',NULL,NULL,NULL,NULL,1,166.693,0.25669,0.089,NULL,60283590606,941931103,14717673,16.4),(77420,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77420,36.59,0.23,208,30015,70,NULL,NULL,'2MASX J11064634+3117080',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000178,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,166.6932083,31.2855,0,NULL,60641027299,947516051,14804938,17.2),(77421,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77421,35.95,0.1,155,30016,70,NULL,NULL,'UGC 06160 NOTES01',NULL,'2015arXiv151105856S',2015,1,1.05,NULL,'G',0.000045,NULL,'14.4g',0.54,'S0:','Group member',NULL,NULL,NULL,1,166.6935417,28.71953,0,NULL,60608082407,947001287,14796895,14.4),(77422,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77422,35.42,0.47,121,30016,NULL,NULL,'H','UGC 06160 NOTES01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77423,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77423,35.58,0.46,131,30016,NULL,NULL,'J','UGC 06160 NOTES01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77424,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77424,35.59,0.45,131,30016,NULL,NULL,'K','UGC 06160 NOTES01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77425,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77425,35.66,0.4,136,30016,NULL,NULL,'mean','UGC 06160 NOTES01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77426,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77426,38.37,0.33,472,30017,70,NULL,NULL,'2MASX J11064661+0646321',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,166.69425,6.77561,0.089,NULL,60308426083,942319157,14723736,18.3),(77427,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77427,37.57,0.46,326,30018,70,NULL,NULL,'2MASX J11064670+4045348',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000176,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,166.69475,40.75964,0,NULL,63934131251,998970800,15608918,17.4),(77428,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77428,37.74,0.46,353,30019,70,NULL,NULL,'2MASX J11064740+2255282',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000173,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,166.6975417,22.92458,0,NULL,61153857729,955529027,14930141,16.9),(77429,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77429,35.14,0.46,107,30020,70,NULL,NULL,'2MASX J11064745-0055272',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000067,NULL,'15.7g',0.48,'E',NULL,NULL,NULL,NULL,1,166.6977917,-0.92417,0.121,NULL,40918184856,639346638,9989791,15.7),(77430,'AGN time lag','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77430,34,0.77,63,30021,44,NULL,NULL,'NGC 3516',NULL,'2007MNRAS.380..669C',2007,1,1.7,NULL,'G',0.000023,NULL,'12.5',1.3,'(R)SB(s)0^0^:  Sy1.5','in a radial-velocity based grouping',NULL,NULL,'Sy 1.5',1,166.697875,72.56858,0.093,NULL,61393701107,959276579,14988696,12.5),(77431,'AGN time lag','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77431,34.1,0.37,66.1,30021,NULL,NULL,NULL,'NGC 3516',NULL,'2014ApJ...784L..11Y',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77432,'Tully est','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77432,32.95,0.8,38.9,30021,75,NULL,'B','NGC 3516',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77433,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77433,34.89,0.33,94.9,30022,70,NULL,NULL,'CGCG 241-079',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.00015,NULL,'14.3g',0.77,'S0^-',NULL,NULL,NULL,NULL,1,166.7047917,45.96461,0,NULL,63951620646,999244072,15613188,14.3),(77434,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77434,30.34,0.2,11.7,30023,74.4,NULL,NULL,'UGC 06161',NULL,'2013AJ....146...86T',2013,1,2.6,NULL,'G',0.000019,NULL,'14.0',1.2,'SBdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,166.704958333,43.72325,0,NULL,63939516017,999054937,15610233,14),(77435,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77435,30.44,0.4,12.3,30023,75,NULL,'B','UGC 06161',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77436,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77436,37.17,0.46,272,30024,70,NULL,NULL,'2MASX J11064984+3940198',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,166.707541667,39.67208,0,NULL,63937880892,999029388,15609834,16.8),(77437,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77437,36.18,0.46,172,30025,70,NULL,NULL,'2MASX J11065067+1427234',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00015,NULL,'15.7g',0.39,'S0',NULL,NULL,NULL,NULL,1,166.711167,14.4565,0,NULL,61151339022,955489672,14929526,15.7),(77438,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77438,36.49,0.46,198,30026,70,NULL,NULL,'ARK 277',NULL,'2015arXiv151105856S',2015,1,0.93,NULL,'G',0.00016,NULL,'15.1g',0.52,'AGN',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,166.713125,14.20344,0,NULL,61151201616,955487525,14929492,15.1),(77439,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77439,36.99,0.46,250,30027,70,NULL,NULL,'2MASX J11065135+4416251',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000187,NULL,'15.9g',0.43,'E0',NULL,NULL,NULL,NULL,1,166.7140417,44.27358,0,NULL,63941176432,999080881,15610638,15.9),(77440,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77440,35.83,0.46,147,30028,70,NULL,NULL,'2MASX J11065269+1344164',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000171,NULL,'15.8g',0.42,NULL,NULL,NULL,NULL,NULL,1,166.719583,13.73783,0,NULL,61151582584,955493477,14929585,15.8),(77441,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77441,35.01,0.55,101,30029,70,NULL,NULL,'2MASX J11065292-1013090',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.88',NULL,NULL,NULL,NULL,NULL,NULL,1,166.7205417,-10.21917,0.081,NULL,41778990409,652796725,10199948,15.88),(77442,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77442,36.88,0.33,238,30030,70,NULL,NULL,'2MASX J11065345+2439181',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,166.722833333,24.65508,0,NULL,60599896721,946873386,14794896,17.2),(77443,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77443,32.44,0.2,30.8,30031,74.4,NULL,NULL,'UGC 06162',NULL,'2013AJ....146...86T',2013,1,2.5,NULL,'G',0.000037,NULL,'13.80',1.2,'Sd             HII','Isolated galaxy',NULL,NULL,NULL,1,166.7279583,51.20336,0,NULL,61788827365,965450427,15085162,13.8),(77444,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77444,32.49,0.43,31.4,30031,75,NULL,'3.6 micron, color corrected','UGC 06162',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77445,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77445,32.57,0.68,32.7,30031,NULL,NULL,'Malmquist cor.','UGC 06162',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77446,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77446,32.6,0.43,33.2,30031,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06162',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77447,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77447,32.7,0.4,34.7,30031,75,NULL,'B','UGC 06162',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77448,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77448,32.7,0.64,34.7,30031,NULL,NULL,NULL,'UGC 06162',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77449,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77449,31.38,0.43,18.9,30032,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3526',NULL,'2014MNRAS.444..527S',2014,1,1.9,'UZC has V = 4256 +- 31 km/sec.','G',0.00002,NULL,'13.86',0.4,'SAc pec sp','Isolated galaxy',NULL,NULL,NULL,1,166.7359583,7.17392,0.085,NULL,60310178105,942346532,14724164,13.86),(77450,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77450,31.41,0.43,19.1,30032,75,NULL,'3.6 micron, color corrected','NGC 3526',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77451,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77451,31.42,0.2,19.2,30032,74.4,NULL,NULL,'NGC 3526',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77452,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77452,31.44,0.4,19.4,30032,75,NULL,NULL,'NGC 3526',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77453,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77453,31.47,0.46,19.6,30032,NULL,NULL,'Malmquist cor.','NGC 3526',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77454,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77454,31.48,0.4,19.8,30032,NULL,NULL,NULL,'NGC 3526',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77455,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77455,31.59,NULL,20.8,30032,NULL,NULL,NULL,'NGC 3526',NULL,'2015AstBu..70....1K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77456,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77456,31.64,0.42,21.3,30032,NULL,NULL,NULL,'NGC 3526',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77457,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77457,31.88,0.49,23.7,30032,75,NULL,'IR','NGC 3526',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77458,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77458,32.53,0.4,32.1,30032,NULL,NULL,'mean','NGC 3526',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77459,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77459,33.43,0.46,48.6,30032,NULL,NULL,'J','NGC 3526',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77460,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77460,33.51,0.47,50.4,30032,NULL,NULL,'H','NGC 3526',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77461,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77461,33.61,0.45,52.6,30032,NULL,NULL,'K','NGC 3526',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77462,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77462,38.35,0.46,468,30033,70,NULL,NULL,'2MASX J11065713+3414570',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000147,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,166.738167,34.24922,0,NULL,60636961069,947452516,14803945,17.4),(77463,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77463,37.51,0.27,318,30034,70,NULL,NULL,'MCG +06-25-005',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.00009,NULL,'15.4g',0.61,NULL,NULL,NULL,NULL,NULL,1,166.741625,35.55183,0,NULL,60415128653,943986385,14749787,15.4),(77464,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77464,37.9,0.46,380,30035,70,NULL,NULL,'2MASX J11065871+1143131',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,166.744708333,11.72031,0.005,NULL,61139593777,955306152,14926658,17.4),(77465,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77465,37.51,0.27,318,30036,70,NULL,NULL,'2MASX J11065974+3532000',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,166.749083,35.53353,0,NULL,60415117379,943986209,14749784,17.5),(77466,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77466,38.15,0.46,426,30037,70,NULL,NULL,'2MASX J11070016+3835195',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000188,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,166.750583,38.58875,0,NULL,63936629429,999009834,15609528,17.4),(77467,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77467,37.61,0.46,333,30038,70,NULL,NULL,'2MASX J11070043+1937598',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.16',0.17,NULL,NULL,NULL,NULL,NULL,1,166.7517917,19.63333,0,NULL,61163197086,955674954,14932421,18.16),(77468,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77468,37.01,0.33,252,30039,70,NULL,NULL,'2MASX J11070054+4305231',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000184,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,166.75225,43.08989,0,NULL,63940006523,999062601,15610353,16.4),(77469,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77469,35.44,0.46,122,30040,70,NULL,NULL,'LCRS B110429.7-061053',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.000147,NULL,'15.38',0.56,NULL,NULL,NULL,NULL,NULL,1,166.757083,-6.45192,0.057,NULL,40892141101,638939704,9983432,15.38),(77470,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77470,36.26,0.46,179,30041,70,NULL,NULL,'CGCG 038-128',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000168,NULL,'15.9g',0.39,'E0',NULL,NULL,NULL,NULL,1,166.758875,2.62653,0.113,NULL,60293906187,942092284,14720191,15.9),(77471,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77471,32.7,NULL,34.6,30042,NULL,NULL,NULL,'UGC 06169',NULL,'2015AstBu..70....1K',2015,1,1.17,NULL,'G',0.000027,NULL,'14.4g',0.49,'Sb:',NULL,NULL,NULL,NULL,1,166.7639583,12.06006,0.005,NULL,61139805330,955309458,14926710,14.4),(77472,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77472,35.8,0.46,145,30043,70,NULL,NULL,'2MASX J11070460+4014565',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000184,NULL,'16.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,166.769333,40.24897,0,NULL,63937720641,999026885,15609795,16.1),(77473,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77473,36.68,0.46,217,30044,70,NULL,NULL,'2MASX J11070469+0433309',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000177,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,166.769625,4.55872,0.177,NULL,60317677354,942463708,14725995,17.2),(77474,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77474,36.19,0.87,173,30045,70,NULL,NULL,'2MASX J11070721-1001188',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.71',NULL,NULL,NULL,NULL,NULL,NULL,1,166.78,-10.02189,0.081,NULL,41776850407,652763287,10199426,16.71),(77475,'IRAS','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77475,33.08,0.8,41.4,30046,75,NULL,'MAT, I','NGC 3533',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.000033,NULL,'13.76',0.6,'(R\')SAB(r)ab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,166.7814583,-37.17264,0.365,NULL,41895320510,654614382,10228349,13.76),(77476,'IRAS','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77476,33.1,0.8,41.6,30046,75,NULL,'HMCL, I','NGC 3533',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77477,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77477,32.69,0.43,34.5,30046,75,NULL,'MAT, I, raw','NGC 3533',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77478,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77478,32.78,0.32,35.9,30046,85,NULL,'I, raw','NGC 3533',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77479,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77479,32.83,0.32,36.8,30046,85,NULL,'I, inv','NGC 3533',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77480,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77480,32.91,0.43,38.3,30046,75,NULL,'MAT, I, cor','NGC 3533',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77481,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77481,32.91,0.4,38.3,30046,75,NULL,'HMCL, I, raw','NGC 3533',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77482,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77482,32.92,0.43,38.4,30046,75,NULL,'MAT, I, inv','NGC 3533',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77483,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77483,32.99,0.2,39.6,30046,74.4,NULL,NULL,'NGC 3533',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77484,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77484,33.02,0.43,40.2,30046,75,NULL,'3.6 micron, color corrected','NGC 3533',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77485,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77485,33.07,0.4,41.2,30046,75,NULL,'HMCL, I, cor','NGC 3533',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77486,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77486,33.09,0.4,41.6,30046,75,NULL,'HMCL, I, inv','NGC 3533',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77487,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77487,33.12,0.43,42,30046,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3533',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77488,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77488,33.39,0.09,47.7,30046,NULL,NULL,NULL,'NGC 3533',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77489,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77489,36.65,0.46,214,30047,70,NULL,NULL,'MCG +09-18-087',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000196,NULL,'15.7g',0.43,'S0',NULL,NULL,NULL,NULL,1,166.7829583,55.19306,0,NULL,61962766767,968168230,15127628,15.7),(77490,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77490,38,0.33,397,30048,70,NULL,NULL,'2MASX J11070934+1959388',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.33',0.17,NULL,NULL,NULL,NULL,NULL,1,166.789125,19.99397,0,NULL,61163341155,955677205,14932456,18.33),(77491,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77491,37.71,0.46,348,30049,70,NULL,NULL,'SDSS J110709.76+081741.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,166.790708333,8.29481,0.037,NULL,60313067332,942391677,14724869,18.3),(77492,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77492,31.81,0.4,23,30050,75,NULL,'B','UGC 06171',NULL,'1988NBGC.C....0000T',1988,1,2.5,NULL,'G',0.00002,NULL,'14.40',0.6,'IBm:','X-ray-bright group member',NULL,NULL,NULL,1,166.791667,18.56944,0,NULL,61161684730,955651323,14932051,14.4),(77493,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77493,32.35,NULL,29.5,30050,NULL,NULL,NULL,'UGC 06171',NULL,'2015AstBu..70....1K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77494,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77494,38.2,0.14,437,30051,70,NULL,NULL,'2MASX J11071008+1546364',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000103,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,166.792,15.77694,0,NULL,61144547517,955383554,14927868,17.2),(77495,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77495,37.08,0.12,260,30052,70,NULL,NULL,'2MASX J11071127+4347471',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000166,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,166.797125,43.79647,0,NULL,63939521854,999055028,15610234,16.9),(77496,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77496,38.3,0.46,457,30053,70,NULL,NULL,'2MASX J11071143+3621415',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,166.79775,36.36158,0.033,NULL,60418192122,944034251,14750535,18.2),(77497,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77497,38.2,0.14,437,30054,70,NULL,NULL,'2MASX J11071148+1550494',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,166.797917,15.84711,0,NULL,61144354071,955380532,14927820,17.8),(77498,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77498,38.02,0.33,402,30055,70,NULL,NULL,'2MASX J11071261+2310208',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000184,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,166.8025,23.17239,0,NULL,61153096487,955517132,14929955,17.3),(77499,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77499,37.7,0.33,347,30056,70,NULL,NULL,'2MASX J11071266+4325011',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000173,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,166.802625,43.41708,0,NULL,63939448033,999053875,15610216,17.4),(77500,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77500,36.89,0.46,239,30057,70,NULL,NULL,'2MASX J11071338+3846205',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000166,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,166.805917,38.77256,0,NULL,63936657933,999010280,15609535,16.5),(77501,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77501,35.45,0.46,123,30058,70,NULL,NULL,'2MASX J11071453+1430285',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000169,NULL,'15.9g',0.41,NULL,NULL,NULL,NULL,NULL,1,166.8105417,14.50806,0,NULL,61151270417,955488600,14929509,15.9),(77502,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77502,37.55,0.46,323,30059,70,NULL,NULL,'2MASX J11071458+0829514',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,166.81075,8.49772,0.025,NULL,60312529285,942383270,14724738,17.3),(77503,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77503,37.74,0.15,354,30060,70,NULL,NULL,'SDSS J110715.25+311506.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,166.8135417,31.25169,0,NULL,60641005884,947515716,14804933,17.9),(77504,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77504,36.27,0.46,179,30061,70,NULL,NULL,'2MASX J11071579+0441259',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,166.8157917,4.69056,0.153,NULL,60318057393,942469646,14726088,16.9),(77505,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77505,37.29,0.46,287,30062,70,NULL,NULL,'SDSS J110716.40+005147.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000089,NULL,'18.1g',0.14,'NLAGN',NULL,NULL,NULL,NULL,1,166.818375,0.86317,0.105,NULL,60283280478,941926257,14717597,18.1),(77506,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77506,37.59,0.46,329,30063,70,NULL,NULL,'2MASX J11071640+0745484',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000171,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,166.8185417,7.76356,0.077,NULL,60313949505,942405461,14725085,17.5),(77507,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77507,34.57,0.46,82.2,30064,70,NULL,NULL,'IC 0669',NULL,'2015arXiv151105856S',2015,1,1.08,NULL,'G',0.000167,NULL,'14.2g',0.65,'S0-','Group member',NULL,NULL,NULL,1,166.8190417,6.30247,0.105,NULL,60308650172,942322658,14723791,14.2),(77508,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77508,38.12,0.46,421,30065,70,NULL,NULL,'2MASX J11071661+2903129',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,166.8192917,29.05364,0,NULL,60608510755,947007980,14796999,18),(77509,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77509,33.68,0.4,54.5,30066,NULL,NULL,'mean','NGC 3497',NULL,'2007A&A...465...71T',2007,1,2.6,NULL,'G',0.000083,NULL,'13.03',1.4,'SA(s)0^0^:    LINER?',NULL,NULL,NULL,NULL,1,166.8252917,-19.47156,0.129,NULL,41849023249,653890988,10217046,13.03),(77510,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77510,33.74,0.45,56,30066,NULL,NULL,'K','NGC 3497',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77511,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77511,35.16,0.81,108,30067,NULL,NULL,'Malmquist cor.','NGC 3527',NULL,'2009ApJS..182..474S',2009,1,1.04,NULL,'G',0.00003,NULL,'14.5g',0.84,'(R)SB(r)ab:','Group member',NULL,NULL,NULL,1,166.8257917,28.52778,0.009,NULL,60611546244,947055410,14797740,14.5),(77512,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77512,35.54,0.68,129,30067,NULL,NULL,NULL,'NGC 3527',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77513,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77513,35.59,0.2,131,30067,74.4,NULL,NULL,'NGC 3527',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77514,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77514,37.43,0.33,306,30068,70,NULL,NULL,'VIII Zw 125 NOTES03',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000184,NULL,'16.2g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,166.826916667,8.05511,0.073,NULL,60313215119,942393986,14724906,16.2),(77515,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77515,37.11,0.33,264,30069,70,NULL,NULL,'SDSS J110718.64+313048.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.6g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,166.8277083,31.51358,0.035,NULL,60641158671,947518104,14804970,17.6),(77516,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77516,38.32,0.46,461,30070,70,NULL,NULL,'2MASX J11071912+3429006',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,166.829583,34.4835,0,NULL,60636406243,947443847,14803810,18.4),(77517,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77517,38,0.33,397,30071,70,NULL,NULL,'SDSS J110719.34+200216.9',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,166.830583,20.03803,0,NULL,61162474989,955663671,14932244,NULL),(77518,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77518,38.62,0.46,531,30072,70,NULL,NULL,'SDSS J110719.44+505342.4',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000204,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,166.8310417,50.89511,0,NULL,61780597395,965321834,15083153,17.3),(77519,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77519,34.89,0.33,94.9,30073,70,NULL,NULL,'CGCG 241-082',NULL,'2015arXiv151105856S',2015,1,1.02,NULL,'G',0.000171,NULL,'14.5g',0.68,'E0',NULL,NULL,NULL,NULL,1,166.8319583,46.38331,0,NULL,63947467161,999179174,15612174,14.5),(77520,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77520,37.19,0.27,274,30074,70,NULL,NULL,'2MASX J11071967+0258199',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000177,NULL,'16.3g',0.34,'AGN',NULL,NULL,NULL,NULL,1,166.832166667,2.97236,0.133,NULL,60286196959,941971827,14718309,16.3),(77521,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77521,35.74,0.46,141,30075,70,NULL,NULL,'2MASX J11071994+0253159',NULL,'2015arXiv151105856S',2015,1,0.53,'SDSS DR2 has z = 0.039552 +- 0.000169.','G',0.000147,NULL,'16.2g',0.38,'Sa',NULL,NULL,NULL,NULL,1,166.833166667,2.88767,0.113,NULL,60286193029,941971766,14718308,16.2),(77522,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77522,38.2,0.14,437,30076,70,NULL,NULL,'2MASX J11072018+1554115',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000171,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,166.834167,15.90339,0,NULL,61144366303,955380723,14927823,18.4),(77523,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77523,38.05,0.46,407,30077,70,NULL,NULL,'2MASX J11072033+3726155',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.62',0.14,NULL,NULL,NULL,NULL,NULL,1,166.834833,37.43761,0,NULL,63922944610,998796009,15606187,18.62),(77524,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77524,38.5,0.46,501,30078,70,NULL,NULL,'SDSS J110722.90+412752.4',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000149,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,166.845417,41.46458,0,NULL,63933847398,998966365,15608849,18.7),(77525,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77525,37.04,0.46,256,30079,70,NULL,NULL,'2MASX J11072433+0703564',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,166.8514583,7.06564,0.089,NULL,60310214530,942347102,14724173,18),(77526,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77526,37.99,0.46,396,30080,70,NULL,NULL,'SDSS J110725.55+023030.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00013,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,166.8564583,2.50839,0.449,NULL,60293792209,942090503,14720164,18.7),(77527,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77527,36.87,0.46,237,30081,70,NULL,NULL,'2MASX J11072547+5209131',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,166.8564583,52.15367,0,NULL,61790045056,965469454,15085460,16.9),(77528,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77528,36.52,0.46,201,30082,70,NULL,NULL,'2MASX J11072568+0349439',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000168,NULL,'16.7g',NULL,NULL,NULL,NULL,NULL,NULL,1,166.857125,3.82881,0.161,NULL,60286541198,941977206,14718393,16.7),(77529,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77529,38.2,0.14,437,30083,70,NULL,NULL,'2MASX J11072634+1552455',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000214,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,166.859833,15.87944,0,NULL,61144351839,955380497,14927820,17.2),(77530,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77530,37.14,0.46,268,30084,70,NULL,NULL,'2MASX J11072767+5359163',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000191,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,166.8655,53.98797,NULL,NULL,61783672470,965369882,15083904,16.6),(77531,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77531,38.3,0.46,457,30085,70,NULL,NULL,'2MASX J11072812+1111284',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,166.867125,11.19128,0.017,NULL,61019240469,953425632,14897275,18.1),(77532,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77532,35.57,0.46,130,30086,70,NULL,NULL,'IC 0670',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000193,NULL,'14.3g',0.8,'E+',NULL,NULL,NULL,NULL,1,166.8700417,6.71425,0.085,NULL,60308583608,942321618,14723775,14.3),(77533,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77533,37.19,0.27,274,30087,70,NULL,NULL,'2MASX J11072969+0254382',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000189,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,166.8737083,2.91064,0.121,NULL,60286189837,941971716,14718308,16.4),(77534,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77534,36.46,0.54,196,30088,70,NULL,NULL,'2MASX J11072987-4715574',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.3I',0.4,NULL,NULL,NULL,NULL,NULL,1,166.874417,-47.26589,0.613,NULL,41914811201,654918925,10233108,14.3),(77535,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77535,38.31,0.46,459,30089,70,NULL,NULL,'2MASX J11072993+0558252',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000183,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,166.8747917,5.97364,0.125,NULL,60308322824,942317544,14723711,17),(77536,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77536,35.94,0.76,154,30090,70,NULL,NULL,'2MASX J11073019-4601024',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,166.875875,-46.01739,0.637,NULL,41940984753,655327886,10239498,17),(77537,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77537,37.82,0.46,366,30091,70,NULL,NULL,'2MASX J11073120+4852191',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00014,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,166.879833,48.87197,0,NULL,63916144088,998689751,15604527,17.3),(77538,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77538,37.19,0.27,274,30092,70,NULL,NULL,'2MASX J11073149+0300262',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000178,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,166.881167,3.00717,0.133,NULL,60286266903,941972920,14718326,16.8),(77539,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77539,37.6,0.33,332,30093,70,NULL,NULL,'2MASX J11073156+0253312',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000193,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,166.881667,2.89208,0.113,NULL,60286255992,941972749,14718324,16.8),(77540,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77540,37.59,0.46,329,30094,70,NULL,NULL,'2MASX J11073251+1659235',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000176,NULL,'17.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,166.8854583,16.98994,0,NULL,61195026707,956172292,14940192,17.2),(77541,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77541,36.55,0.2,204,30095,74.4,NULL,NULL,'CGCG 066-116',NULL,'2013AJ....146...86T',2013,1,0.68,NULL,'G',0.000087,NULL,'15.8g',0.38,NULL,NULL,NULL,NULL,NULL,1,166.887125,13.42078,0,NULL,61137700457,955276569,14926196,15.8),(77542,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77542,37.45,0.46,309,30096,70,NULL,NULL,'2MASX J11073321+3329107',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000184,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,166.888416667,33.48636,0,NULL,60648092566,947626446,14806663,17),(77543,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77543,38.16,0.46,428,30097,70,NULL,NULL,'2MASX J11073324+6322192',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,166.8885,63.37194,0,NULL,61867281274,966676269,15104316,18),(77544,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77544,36.77,0.46,226,30098,70,NULL,NULL,'2MASX J11073327+1547495',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00007,NULL,'17.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,166.888625,15.79706,0,NULL,61144343575,955380368,14927818,17.2),(77545,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77545,37.12,0.46,266,30099,70,NULL,NULL,'2MASX J11073351+4058267',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000191,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,166.889666667,40.97394,0,NULL,63934791341,998981114,15609079,16.4),(77546,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77546,36.97,0.46,247,30100,70,NULL,NULL,'2MASX J11073429+4236260',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000172,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,166.892833,42.60725,0,NULL,63939272853,999051138,15610174,16.6),(77547,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77547,38.14,0.33,424,30101,70,NULL,NULL,'2MASX J11073558+3824087',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000186,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,166.8982917,38.40247,0,NULL,63922660688,998791573,15606118,16.8),(77548,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77548,38.11,0.46,419,30102,70,NULL,NULL,'2MASX J11073585+1858583',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,166.899417,18.98292,0,NULL,61165270092,955707345,14932927,17.7),(77549,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77549,37.74,0.46,354,30103,70,NULL,NULL,'2MASX J11073628+0736005',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00015,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,166.90125,7.60019,0.089,NULL,60313683654,942401307,14725020,17.2),(77550,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77550,35.09,0.63,104,30104,NULL,NULL,'Malmquist cor.','ESO 319- G 004',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.87',0.3,'S...',NULL,NULL,NULL,NULL,1,166.9014583,-39.97294,0.521,NULL,41909242664,654831916,10231748,14.87),(77551,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77551,35.11,0.62,105,30104,NULL,NULL,NULL,'ESO 319- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77552,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77552,35.15,0.2,107,30104,74.4,NULL,NULL,'ESO 319- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77553,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77553,37.51,0.27,318,30105,70,NULL,NULL,'SDSS J110736.50+353812.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,166.902125,35.63678,0,NULL,60418588595,944040446,14750631,17.8),(77554,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77554,38.39,0.46,476,30106,70,NULL,NULL,'SDSS J110736.58+094436.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00015,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,166.902416667,9.74356,0.029,NULL,60298921366,942170646,14721416,18.7),(77555,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77555,37.33,0.21,292,30107,70,NULL,NULL,'2MASX J11073674-0003147',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000078,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,166.903125,-0.05408,0.117,NULL,40904536605,639133384,9986459,17.9),(77556,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77556,37.33,0.21,292,30108,70,NULL,NULL,'2MASX J11073734-0001377',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000104,NULL,'16.0g',0.41,'E0',NULL,NULL,NULL,NULL,1,166.90575,-0.02725,0.117,NULL,40904538508,639133414,9986459,16),(77557,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77557,35.2,0.58,109,30109,70,NULL,NULL,'2MASX J11073744-1007100',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.88',0.3,NULL,NULL,NULL,NULL,NULL,1,166.9060417,-10.11967,0.081,NULL,41778939980,652795937,10199936,15.88),(77558,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77558,37.49,0.27,315,30110,70,NULL,NULL,'2MASX J11073757+3816447',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,166.9065417,38.27917,0.055,NULL,63922686083,998791970,15606124,17.7),(77559,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77559,38.2,0.14,437,30111,70,NULL,NULL,'2MASX J11073771+1551305',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000107,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,166.907208333,15.85853,0,NULL,61144346957,955380421,14927819,17.7),(77560,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77560,36.34,0.46,185,30112,70,NULL,NULL,'2MASX J11074016+3345537',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000181,NULL,'17.33',0.27,NULL,NULL,NULL,NULL,NULL,1,166.917125,33.76492,0.012,NULL,60636013447,947437710,14803714,17.33),(77561,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77561,36.2,0.46,174,30113,70,NULL,NULL,'2MASX J11074152+1549275',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000067,NULL,'15.9g',0.41,NULL,NULL,NULL,NULL,NULL,1,166.9229583,15.82442,0,NULL,61144348123,955380439,14927819,15.9),(77562,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77562,36.3,0.21,182,30114,70,NULL,NULL,'CGCG 066-117',NULL,'2015arXiv151105856S',2015,1,1.01,NULL,'G',0.00017,NULL,'14.5g',0.67,'E0','Group member',NULL,NULL,NULL,1,166.92375,13.02567,0,NULL,61139536298,955305254,14926644,14.5),(77563,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77563,38.2,0.14,437,30115,70,NULL,NULL,'2MASX J11074180+1552215',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000171,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,166.924167,15.87261,0,NULL,61144349971,955380468,14927819,17.6),(77564,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77564,36.74,0.33,222,30116,70,NULL,NULL,'2MASX J11074191+6631266',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000095,NULL,'15.9g',0.43,'E0',NULL,NULL,NULL,NULL,1,166.924666667,66.52392,0,NULL,62084548612,970071072,15157360,15.9),(77565,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77565,37.15,0.46,269,30117,70,NULL,NULL,'2MASX J11074193+0600042',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000171,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,166.924833,6.00119,0.125,NULL,60308301911,942317217,14723706,17),(77566,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77566,38.46,0.33,492,30118,70,NULL,NULL,'2MASX J11074203+2442388',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000212,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,166.9252083,24.71078,0,NULL,60600213502,946878335,14794973,17.5),(77567,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77567,37.74,0.15,354,30119,70,NULL,NULL,'2MASX J11074229+3106277',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000183,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,166.926291667,31.10767,0,NULL,60640892063,947513938,14804905,17.3),(77568,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77568,35.96,0.46,156,30120,70,NULL,NULL,'2MASX J11074245+2656108',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000205,NULL,'15.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,166.9269583,26.93642,0.012,NULL,60613195432,947081178,14798143,15.7),(77569,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77569,37.74,0.15,354,30121,70,NULL,NULL,'2MASX J11074253+3118107',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000181,NULL,'16.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,166.927333333,31.30294,0,NULL,60641227970,947519187,14804987,16.4),(77570,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77570,36.3,0.21,182,30122,70,NULL,NULL,'2MASX J11074315+1259073',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,166.929917,12.98542,0,NULL,61139543252,955305363,14926646,16.7),(77571,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77571,37.57,0.17,327,30123,70,NULL,NULL,'2MASXi J1107432+400409',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,166.930417,40.06947,0,NULL,63937275526,999019930,15609686,17.6),(77572,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77572,35.92,0.46,152,30124,70,NULL,NULL,'2MASXi J1107434+195121',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.09',0.17,NULL,NULL,NULL,NULL,NULL,1,166.931166667,19.85617,0,NULL,61163291242,955676425,14932444,18.09),(77573,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77573,37.33,0.21,292,30125,70,NULL,NULL,'2MASX J11074408+0001282',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000068,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,166.933833,0.02453,0.117,NULL,60283046492,941922601,14717540,17.1),(77574,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77574,38.02,0.33,402,30126,70,NULL,NULL,'2MASX J11074417+2308044',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,166.9339583,23.13461,0,NULL,61085909269,954467332,14913552,18.1),(77575,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77575,37.54,0.33,322,30127,70,NULL,NULL,'2MASX J11074422+1022575',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,166.934417,10.38258,0.049,NULL,61019305430,953426647,14897291,16.9),(77576,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77576,37.43,0.33,306,30128,70,NULL,NULL,'2MASX J11074476+0817035',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000196,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,166.936583,8.28436,0.037,NULL,60313089434,942392022,14724875,17.2),(77577,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77577,37.47,0.33,313,30129,70,NULL,NULL,'SDSS J110744.88+453021.5',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,166.9370417,45.50597,0,NULL,63951673019,999244890,15613201,17.8),(77578,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77578,38.68,0.46,545,30130,70,NULL,NULL,'2MASX J11074602+0631105',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,166.9417917,6.51958,0.085,NULL,60308510353,942320474,14723757,18),(77579,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77579,37.08,0.12,260,30131,70,NULL,NULL,'2MASX J11074626+4355490',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000168,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,166.942791667,43.93039,0,NULL,63939344967,999052265,15610191,17.6),(77580,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77580,37.87,0.46,375,30132,70,NULL,NULL,'2MASX J11074650+2818528',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000168,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,166.94375,28.31469,0,NULL,60611457355,947054021,14797719,17.4),(77581,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77581,35.51,0.46,126,30133,70,NULL,NULL,'2MASX J11074772+0747225',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000167,NULL,'16.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,166.9487917,7.78958,0.089,NULL,60313647893,942400748,14725011,16.3),(77582,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77582,38.2,0.14,437,30134,70,NULL,NULL,'SDSS J110748.62+154955.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,166.952583,15.83217,0,NULL,61144337555,955380274,14927816,18.5),(77583,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77583,38.72,0.46,554,30135,70,NULL,NULL,'SDSS J110749.19+081005.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,166.955,8.16833,0.053,NULL,60313191739,942393620,14724900,18.2),(77584,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77584,37.08,0.12,260,30136,70,NULL,NULL,'2MASX J11074931+4355000',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000205,NULL,'15.8g',0.44,'BrClG',NULL,NULL,NULL,NULL,1,166.9555,43.91661,0,NULL,63939331178,999052049,15610188,15.8),(77585,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77585,36.74,0.33,222,30137,70,NULL,NULL,'2MASX J11074940+6627066',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000079,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,166.95575,66.452,0.013,NULL,62084548488,970071070,15157360,16.8),(77586,'Tully est','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77586,30.64,0.8,13.4,30138,75,NULL,NULL,'ESO 265- G 007',NULL,'1988NBGC.C....0000T',1988,1,3.6,'RC3 gives V = 1640 +- 60 km/sec.','G',0.000013,NULL,'12.38',1.2,'SB(s)cd',NULL,NULL,NULL,NULL,1,166.9565417,-46.52431,0.637,NULL,41932583133,655196611,10237447,12.38),(77587,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77587,29.77,0.43,9,30138,75,NULL,'3.6 micron, color + selection bias corrected','ESO 265- G 007',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77588,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77588,29.83,0.43,9.2,30138,75,NULL,'3.6 micron, color corrected','ESO 265- G 007',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77589,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77589,36.68,0.46,217,30139,70,NULL,NULL,'2MASX J11074965+3451097',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000151,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,166.9567917,34.85283,0,NULL,60635234920,947425545,14803524,16.7),(77590,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77590,38.49,0.33,498,30140,70,NULL,NULL,'2MASX J11074971+2419078',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000196,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,166.95725,24.31878,0,NULL,60599559331,946868114,14794814,17.5),(77591,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77591,36.87,0.46,236,30141,70,NULL,NULL,'2MASX J11075013+0730045',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000176,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,166.958917,7.50131,0.085,NULL,60313799931,942403123,14725048,16.5),(77592,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77592,35.03,0.62,101,30142,70,NULL,NULL,'ESO 215- G 025',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'15.90',0.2,'N',NULL,NULL,NULL,NULL,1,166.96125,-48.23478,0.581,NULL,41916981500,654952835,10233638,15.9),(77593,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77593,37.89,0.46,379,30143,70,NULL,NULL,'2MASX J11075171+4454520',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00018,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,166.965583,44.91447,0,NULL,63952026668,999250416,15613287,17),(77594,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77594,37.42,0.46,305,30144,70,NULL,NULL,'2MASX J11075189+1528083',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000131,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,166.96625,15.46886,0,NULL,61144448811,955382012,14927843,17.9),(77595,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77595,38.46,0.33,492,30145,70,NULL,NULL,'2MASX J11075195+2438128',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000161,NULL,'17.5g',0.19,'BrClG',NULL,NULL,NULL,NULL,1,166.9664583,24.63706,0,NULL,60600215331,946878364,14794974,17.5),(77596,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77596,38.08,0.46,412,30146,70,NULL,NULL,'SDSS J110752.29+190811.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.5g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,166.967917,19.13664,0,NULL,61165253788,955707090,14932923,18.5),(77597,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77597,37.6,0.33,332,30147,70,NULL,NULL,'SDSS J110752.96+024334.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000172,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,166.9707083,2.72633,0.449,NULL,60293708313,942089192,14720143,18.2),(77598,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77598,37.7,0.33,347,30148,70,NULL,NULL,'2MASX J11075307+4313510',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000175,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,166.971,43.23094,0,NULL,63939997043,999062453,15610350,16.8),(77599,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77599,37.98,0.21,394,30149,70,NULL,NULL,'SDSS J110753.31+085632.1',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,'PRED','16.2g',0.36,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,166.972167,8.94228,0.037,NULL,60300493205,942195206,14721800,16.2),(77600,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77600,36.3,0.21,182,30150,70,NULL,NULL,'2MASX J11075444+1314073',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000181,NULL,'16.1g',0.31,NULL,NULL,NULL,NULL,NULL,1,166.97675,13.23522,0,NULL,61137727817,955276997,14926203,16.1),(77601,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77601,38.49,0.33,498,30151,70,NULL,NULL,'2MASX J11075482+2427109',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00018,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,166.978333,24.45308,0,NULL,60599479429,946866866,14794794,16.4),(77602,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77602,38.19,0.46,434,30152,70,NULL,NULL,'2MASX J11075510+5348509',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000173,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,166.979875,53.81425,0,NULL,61783708350,965370442,15083913,16.5),(77603,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77603,37.54,0.33,322,30153,70,NULL,NULL,'2MASX J11075541+1022104',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000137,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,166.9810417,10.36961,0.049,NULL,61019302447,953426600,14897290,17.5),(77604,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77604,37.08,0.12,260,30154,70,NULL,NULL,'2MASX J11075589+4355080',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000073,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,166.983,43.91883,0,NULL,63939336202,999052128,15610189,16.2),(77605,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77605,36.54,0.46,203,30155,70,NULL,NULL,'2MASX J11075630+5719427',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000185,NULL,'16.6g',0.23,'AGN',NULL,NULL,NULL,NULL,1,166.984333,57.32858,0,NULL,62007410175,968865783,15138527,16.6),(77606,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77606,33.57,0.49,51.7,30156,75,NULL,'IR','UGC 06185',NULL,'2011yCatp016004901K',2011,1,1.65,'Position in 1993ApJS...88..383L is incorrect.','G',0.000003,NULL,'14.6g',0.68,'SAB(rs)dm',NULL,NULL,NULL,NULL,1,166.986583,8.00078,0.053,NULL,60313180852,942393450,14724897,14.6),(77607,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77607,37.11,0.33,264,30157,70,NULL,NULL,'2MASX J11075730+3128549',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000192,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,166.988625,31.48194,0.035,NULL,60641190351,947518599,14804978,16.9),(77608,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77608,38.2,0.14,437,30158,70,NULL,NULL,'2MASX J11075804+1556143',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000164,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,166.9919583,15.9375,0,NULL,61143871199,955372987,14927702,17),(77609,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77609,37.17,0.67,272,30159,70,NULL,NULL,'2MASX J11075830-2234522',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000103,NULL,'16.6b',0.3,'Sp',NULL,NULL,NULL,NULL,1,166.992958333,-22.58111,0.173,NULL,41708711758,651698621,10182790,16.6),(77610,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77610,37.74,0.15,354,30160,70,NULL,NULL,'2MASX J11075877+3103269',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000189,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,166.9949583,31.05744,0,NULL,60640905490,947514148,14804908,17.3),(77611,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77611,37.47,0.33,313,30161,70,NULL,NULL,'2MASX J11075973+4532599',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000208,NULL,'16.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,166.998917,45.54989,0,NULL,63951728306,999245754,15613214,16.2),(77612,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77612,38.46,0.46,491,30162,70,NULL,NULL,'SDSS J110759.89+352920.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000135,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,166.9995417,35.48914,0,NULL,60418469834,944038591,14750602,18.1),(77613,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77613,36.16,0.33,171,30163,70,NULL,NULL,'MCG +09-18-089',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000196,NULL,'15.4g',0.53,'E0',NULL,NULL,NULL,NULL,1,166.999625,55.88078,0,NULL,61995420153,968678439,15135600,15.4),(77614,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77614,38.14,0.33,424,30164,70,NULL,NULL,'2MASX J11080017+3822238',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000186,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,167.000875,38.37322,0,NULL,63922692348,998792067,15606126,16.7),(77615,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77615,37.51,0.46,317,30165,70,NULL,NULL,'2MASX J11080036+0758174',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000162,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,167.001708333,7.97158,0.053,NULL,60313175279,942393363,14724896,16.8),(77616,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77616,37.74,0.15,354,30166,70,NULL,NULL,'2MASX J11080079+3103409',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000214,NULL,'16.0g',0.43,'BrClG',NULL,NULL,NULL,NULL,1,167.003125,31.06128,0,NULL,60640906554,947514164,14804908,16),(77617,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77617,35.52,0.46,127,30167,70,NULL,NULL,'CGCG 066-119',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000157,NULL,'14.8g',0.67,NULL,NULL,NULL,NULL,NULL,1,167.0047917,14.10356,0,NULL,61151849739,955497652,14929650,14.8),(77618,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77618,36.7,0.46,219,30168,70,NULL,NULL,'2MASX J11080137+4641129',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000163,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,167.0057083,46.68683,0,NULL,63947440465,999178757,15612168,16.3),(77619,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77619,37.62,0.15,334,30169,70,NULL,NULL,'2MASX J11080149+4132058',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000159,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,167.006167,41.53508,0,NULL,63933894478,998967101,15608860,17.2),(77620,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77620,37.56,0.33,325,30170,70,NULL,NULL,'2MASX J11080155+2119045',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.18',0.16,NULL,NULL,NULL,NULL,NULL,1,167.0062917,21.31808,0,NULL,61155177121,955549642,14930463,18.18),(77621,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77621,37.56,0.33,325,30171,70,NULL,NULL,'2MASX J11080169+2117015',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.02',0.16,NULL,NULL,NULL,NULL,NULL,1,167.0072083,21.28378,0,NULL,61155179303,955549676,14930463,18.02),(77622,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77622,37.94,0.46,388,30172,70,NULL,NULL,'2MASX J11080209+1132084',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,167.008917,11.53556,0.009,NULL,61019043987,953422562,14897227,18),(77623,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77623,37.86,0.46,374,30173,70,NULL,NULL,'2MASX J11080332+2354329',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,167.013875,23.90903,0,NULL,60565809504,946340773,14786574,17.6),(77624,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77624,37.22,0.46,278,30174,70,NULL,NULL,'2MASX J11080350+5711527',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,167.014833,57.19797,0,NULL,62007089821,968860778,15138449,17.7),(77625,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77625,38.2,0.14,437,30175,70,NULL,NULL,'2MASX J11080366+1554133',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000202,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,167.015375,15.90361,0,NULL,61143873116,955373017,14927703,16.6),(77626,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77626,37.98,0.21,394,30176,70,NULL,NULL,'SDSS J110804.07+085552.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,167.016958333,8.93117,0.037,NULL,60300495418,942195240,14721800,18.5),(77627,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77627,38.2,0.14,437,30177,70,NULL,NULL,'2MASX J11080622+1554183',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.59',0.14,NULL,NULL,NULL,NULL,NULL,1,167.0260417,15.90522,0,NULL,61143873214,955373018,14927703,18.59),(77628,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77628,37.57,0.17,327,30178,70,NULL,NULL,'2MASX J11080724+4021354',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000187,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,167.0302083,40.35992,0,NULL,63934437756,998975589,15608993,17.4),(77629,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77629,37.08,0.12,260,30179,70,NULL,NULL,'2MASX J11080744+4357271',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00007,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,167.031167,43.95753,0,NULL,63939337508,999052148,15610189,16.4),(77630,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77630,36.67,0.46,216,30180,70,NULL,NULL,'2MASX J11080762+2601019',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000178,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,167.031917,26.01714,0,NULL,60602235915,946909936,14795467,16.2),(77631,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77631,38.26,0.46,448,30181,70,NULL,NULL,'2MASX J11080817+1904105',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,167.0339583,19.06975,0,NULL,61165060912,955704076,14932876,18.2),(77632,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77632,37.78,0.46,360,30182,70,NULL,NULL,'2MASX J11080832+5251319',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000144,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,167.0347083,52.859,0,NULL,61783461785,965366590,15083852,17.3),(77633,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77633,37.49,0.27,315,30183,70,NULL,NULL,'SDSS J110808.87+381615.8',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,167.037,38.27108,0.055,NULL,63922639916,998791248,15606113,17.7),(77634,'GRB','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77634,38.21,NULL,438,30184,65,NULL,'L = 10e57 photons/s','3B 911118',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Gamma ray burster',NULL,NULL,NULL,NULL,1,167.029167,-20.85,0.141,NULL,41843484995,653804453,10215694,NULL),(77635,'GRB','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77635,41.04,NULL,1610,30184,65,NULL,'L = 2 x 10e58 photons/s','3B 911118',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77636,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77636,36.69,0.2,218,30185,74.4,NULL,NULL,'CGCG 067-007',NULL,'2013AJ....146...86T',2013,1,0.86,NULL,'G',0.000161,NULL,'15.3g',0.3,'Sb','Group member',NULL,NULL,NULL,1,167.0389583,13.04381,0,NULL,61139479600,955304368,14926630,15.3),(77637,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77637,38.03,0.46,404,30186,70,NULL,NULL,'2MASX J11080940+2601169',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000205,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,167.03925,26.02156,0,NULL,60602236126,946909939,14795467,16.9),(77638,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77638,37.28,0.46,286,30187,70,NULL,NULL,'2MASX J11080958+3346179',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000156,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,167.039917,33.77178,0.012,NULL,60636007404,947437615,14803712,17.4),(77639,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77639,35.95,0.1,155,30188,70,NULL,NULL,'CGCG 155-069',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000053,NULL,'15.5g',0.45,'S0','Group member',NULL,NULL,NULL,1,167.042583,28.53078,0.009,NULL,60611654914,947057108,14797767,15.5),(77640,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77640,37.33,0.21,292,30189,70,NULL,NULL,'2MASX J11081083-0004599',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000105,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,167.0452083,-0.08319,0.125,NULL,40904657495,639135273,9986488,17),(77641,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77641,37.08,0.12,260,30190,70,NULL,NULL,'2MASX J11081125+4354551',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000188,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,167.0467083,43.91544,0,NULL,63939319119,999051861,15610185,16.6),(77642,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77642,37.64,0.46,337,30191,70,NULL,NULL,'SDSS J110811.54+020044.0',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,167.048125,2.01225,0.145,NULL,60297239603,942144368,14721005,17.5),(77643,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77643,36.46,0.46,196,30192,70,NULL,NULL,'2MASX J11081188+4207111',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000083,NULL,'15.5g',0.3,'Sa',NULL,NULL,NULL,NULL,1,167.049667,42.11967,0,NULL,63931700948,998932827,15608325,15.5),(77644,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77644,37.98,0.33,395,30193,70,NULL,NULL,'SDSS J110812.19+015703.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000147,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,167.0507917,1.95094,0.145,NULL,60297220869,942144076,14721001,18.1),(77645,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77645,38.1,0.46,418,30194,70,NULL,NULL,'SDSS J110813.91+000350.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000053,NULL,'18.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,167.058,0.064,0.117,NULL,60282932154,941920814,14717512,18.8),(77646,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77646,37.49,0.27,315,30195,70,NULL,NULL,'2MASX J11081391+3816235',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000174,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,167.058083,38.27317,0.055,NULL,63922647224,998791362,15606115,17.1),(77647,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77647,37.26,0.46,284,30196,70,NULL,NULL,'2MASX J11081416+4337291',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000215,NULL,'15.9g',0.49,'S0^-',NULL,NULL,NULL,NULL,1,167.0592083,43.62483,0,NULL,63939442893,999053795,15610215,15.9),(77648,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77648,37.41,0.46,303,30197,70,NULL,NULL,'2MASX J11081422+4114265',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,167.059375,41.24067,0,NULL,63934728893,998980138,15609064,17.7),(77649,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77649,36.97,0.46,248,30198,70,NULL,NULL,'2MASX J11081478+2839481',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,167.061417,28.66328,0.009,NULL,60611685051,947057578,14797774,17),(77650,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77650,37.98,0.21,394,30199,70,NULL,NULL,'2MASX J11081487+0855205',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,'PRED','18.97',0.1,NULL,NULL,NULL,NULL,NULL,1,167.062125,8.92239,0.037,NULL,60300503605,942195368,14721802,18.97),(77651,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77651,37.57,0.17,327,30200,70,NULL,NULL,'2MASX J11081584+4040505',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000196,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,167.065875,40.68058,0,NULL,63934589645,998977963,15609030,16.3),(77652,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77652,37.33,0.21,292,30201,70,NULL,NULL,'SDSS J110816.02-001557.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000079,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,167.066791667,-0.26589,0.097,NULL,40904676361,639135568,9986493,17.8),(77653,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77653,37.98,0.21,394,30202,70,NULL,NULL,'2MASX J11081642+0855315',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000173,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,167.068375,8.92536,0.037,NULL,60300504083,942195376,14721802,16.2),(77654,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77654,37.57,0.33,327,30203,70,NULL,NULL,'2MASX J11081641+4149435',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,167.0685417,41.82878,0,NULL,63931712441,998933006,15608328,17.6),(77655,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77655,37.08,0.12,260,30204,70,NULL,NULL,'2MASX J11081699+4354572',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00007,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,167.070833,43.91597,0,NULL,63939321798,999051903,15610185,16.2),(77656,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77656,37.04,0.46,256,30205,70,NULL,NULL,'2MASX J11081725+2449261',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00018,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,167.071833333,24.82403,0,NULL,60600191153,946877986,14794968,16.8),(77657,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77657,36.3,0.21,182,30206,70,NULL,NULL,'CGCG 067-010',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.00014,NULL,'15.1g',0.66,NULL,'Group member',NULL,NULL,NULL,1,167.076417,13.22433,0,NULL,61137596166,955274940,14926170,15.1),(77658,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77658,37.08,0.12,260,30207,70,NULL,NULL,'2MASX J11081846+4404382',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,167.077,44.07733,0,NULL,63939290862,999051419,15610178,17.4),(77659,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77659,38.01,0.46,400,30208,70,NULL,NULL,'2MASX J11081897+2246375',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000164,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,167.079208333,22.77711,0,NULL,61086334573,954473977,14913655,17.3),(77660,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77660,36.08,0.46,165,30209,70,NULL,NULL,'2MASX J11081926+3700405',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000161,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,167.080166667,37.01133,0,NULL,63922867054,998794797,15606168,16.3),(77661,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77661,37.63,0.33,335,30210,70,NULL,NULL,'2MASX J11081929+0532427',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000168,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,167.080333333,5.54517,0.109,NULL,60317815573,942465868,14726029,16.7),(77662,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77662,37.98,0.21,394,30211,70,NULL,NULL,'SDSS J110819.62+085339.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000134,NULL,'18.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,167.0817917,8.89419,0.037,NULL,60300510374,942195474,14721804,18.4),(77663,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77663,36.37,0.2,188,30212,74.4,NULL,NULL,'CGCG 067-008',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000021,NULL,'16.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,167.0820417,9.95061,0.025,NULL,60301047877,942203873,14721935,16.2),(77664,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77664,36.25,0.49,178,30213,75,NULL,'IR','CGCG 067-008',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.000021,NULL,'16.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,167.0820417,9.95061,0.025,NULL,60301047877,942203873,14721935,16.2),(77665,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77665,36.11,0.46,167,30214,70,NULL,NULL,'2MASX J11081973+1203291',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000174,NULL,'15.8g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,167.082166667,12.05819,0.009,NULL,61139695213,955307737,14926683,15.8),(77666,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77666,33.11,0.47,41.9,30215,NULL,NULL,'H','ESO 377- G 012',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000027,NULL,'13.92',1,'SB(r)ab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,167.082333333,-37.62392,0.481,NULL,41895815595,654622118,10228470,13.92),(77667,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77667,33.14,0.46,42.5,30215,NULL,NULL,'J','ESO 377- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77668,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77668,33.2,0.45,43.7,30215,NULL,NULL,'K','ESO 377- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77669,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77669,33.55,0.4,51.2,30215,NULL,NULL,'mean','ESO 377- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77670,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77670,37.57,0.33,327,30216,70,NULL,NULL,'2MASX J11081998+4152155',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,167.083083,41.87092,0,NULL,63931715441,998933053,15608328,17.5),(77671,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77671,37.51,0.46,318,30217,70,NULL,NULL,'2MASX J11081995+1035275',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000183,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,167.083208333,10.59097,0.077,NULL,61019516181,953429940,14897342,16.9),(77672,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77672,36.49,0.58,199,30218,70,NULL,NULL,'2MASX J11082017-0719452',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.58',0.28,NULL,NULL,NULL,NULL,NULL,1,167.084083,-7.32925,0.049,NULL,40901023048,639078485,9985601,16.58),(77673,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77673,37.57,0.17,327,30219,70,NULL,NULL,'2MASX J11082079+4025316',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000226,NULL,'15.8g',0.47,'BrClG',NULL,NULL,NULL,NULL,1,167.0867917,40.4255,0,NULL,63934490851,998976419,15609006,15.8),(77674,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77674,37.98,0.33,395,30220,70,NULL,NULL,'2MASX J11082160+0156327',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000185,NULL,'16.9g',0.27,'AGN',NULL,NULL,NULL,NULL,1,167.0899583,1.94231,0.105,NULL,60296356455,942130569,14720790,16.9),(77675,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77675,37.94,0.33,388,30221,70,NULL,NULL,'2MASX J11082173+0049217',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000094,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,167.090458333,0.82267,0.105,NULL,60283331956,941927061,14717610,16.6),(77676,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77676,34.19,0.53,68.8,30222,70,NULL,NULL,'ESO 215- G 027',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000117,NULL,'15.04',0.2,'Sb',NULL,NULL,NULL,NULL,1,167.0925,-47.93103,0.581,NULL,41915568535,654930758,10233293,15.04),(77677,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77677,36.3,0.21,182,30223,70,NULL,NULL,'2MASX J11082252+1311241',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000177,NULL,'15.9g',0.33,NULL,NULL,NULL,NULL,NULL,1,167.093708333,13.19014,0,NULL,61137595230,955274925,14926170,15.9),(77678,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77678,37.84,0.46,369,30224,70,NULL,NULL,'2MASX J11082252+3659146',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,167.093708333,36.9875,0,NULL,63922867288,998794801,15606168,17.9),(77679,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77679,38.83,0.46,583,30225,70,NULL,NULL,'2MASX J11082273+0211327',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,167.09475,2.19242,0.145,NULL,60296712895,942136138,14720877,18),(77680,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77680,37.76,0.46,357,30226,70,NULL,NULL,'2MASX J11082284+4202102',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00017,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,167.095125,42.03614,0,NULL,63931729765,998933277,15608332,16.8),(77681,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77681,37.08,0.12,260,30227,70,NULL,NULL,'2MASX J11082310+4409011',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000077,NULL,'15.4g',0.52,'E0',NULL,NULL,NULL,NULL,1,167.09625,44.15028,0,NULL,63953176461,999268382,15613568,15.4),(77682,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77682,37.63,0.33,335,30228,70,NULL,NULL,'2MASX J11082358+0537077',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,167.098333,5.61883,0.105,NULL,60317771537,942465180,14726018,17),(77683,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77683,38.74,0.46,559,30229,70,NULL,NULL,'SDSS J110824.43+383006.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,167.101833,38.50186,0,NULL,63936525236,999008206,15609503,18.4),(77684,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77684,36.58,0.46,207,30230,70,NULL,NULL,'2MASX J11082492+4300461',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.0002,NULL,'15.6g',0.42,'E0',NULL,NULL,NULL,NULL,1,167.103833,43.01297,0,NULL,63939088680,999048260,15610129,15.6),(77685,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77685,37.08,0.12,260,30231,70,NULL,NULL,'2MASXi J1108260+434536',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000169,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,167.1085417,43.76028,0,NULL,63939314324,999051786,15610184,17.8),(77686,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77686,38.12,0.46,421,30232,70,NULL,NULL,'SDSS J110826.07+102955.8',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000145,NULL,'18.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,167.108667,10.49883,0.049,NULL,61019506160,953429783,14897340,18.9),(77687,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77687,35.31,0.54,115,30233,70,NULL,NULL,'2MASX J11082608-0715172',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.23',0.28,NULL,NULL,NULL,NULL,NULL,1,167.108875,-7.25489,0.093,NULL,40901020608,639078447,9985600,16.23),(77688,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77688,37.3,0.46,288,30234,70,NULL,NULL,'2MASX J11082978+3727316',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000146,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,167.124167,37.45867,0,NULL,63923142639,998799103,15606235,17.2),(77689,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77689,35.53,NULL,128,30235,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1198',NULL,'2010Ap&SS.325..163P',2010,1,0.74,NULL,'G',0.000019,NULL,'16.9g',0.17,'Sc',NULL,NULL,NULL,NULL,1,167.1247917,10.82006,0.025,NULL,61019551731,953430495,14897351,16.9),(77690,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77690,35.55,NULL,129,30235,NULL,NULL,'Dipole + Quadrupole','FGC 1198',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77691,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77691,35.58,NULL,131,30235,NULL,NULL,'Dipole','FGC 1198',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77692,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77692,35.59,0.49,131,30235,75,NULL,'IR','FGC 1198',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77693,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77693,35.63,NULL,133,30235,NULL,NULL,NULL,'FGC 1198',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77694,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77694,35.89,0.2,151,30235,74.4,NULL,NULL,'FGC 1198',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77695,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77695,37.57,0.17,327,30236,70,NULL,NULL,'SDSS J110830.81+403707.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,167.128417,40.61864,0,NULL,63934470653,998976103,15609001,18.1),(77696,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77696,36.73,0.46,222,30237,70,NULL,NULL,'2MASX J11083111+3211507',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000178,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,167.12975,32.19742,0.022,NULL,60639683119,947495048,14804610,16.8),(77697,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77697,35.11,0.46,105,30238,70,NULL,NULL,'CGCG 039-009',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00015,NULL,'15.4g',0.49,'S0^-',NULL,NULL,NULL,NULL,1,167.13175,5.82547,0.105,NULL,60309113596,942329899,14723904,15.4),(77698,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77698,37.75,0.46,354,30239,70,NULL,NULL,'2MASXi J1108320+472641',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000141,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,167.133416667,47.44497,0.013,NULL,63915942742,998686605,15604478,17.4),(77699,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77699,37.94,0.33,388,30240,70,NULL,NULL,'SDSS J110832.14+004330.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000072,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,167.1339583,0.72508,0.105,NULL,60283326698,941926979,14717609,18),(77700,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77700,34.62,0.54,83.9,30241,70,NULL,NULL,'NGC 3541',NULL,'2014MNRAS.445.2677S',2014,1,1.5,'6dF final data release has z = 0.026512 +- 0.000150.','G',0.00003,NULL,'15.10',1.3,'(R\')SAB(r)d?',NULL,NULL,NULL,NULL,1,167.134208333,-10.49183,0.109,NULL,41775778036,652746531,10199164,15.1),(77701,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77701,37.28,0.46,285,30242,70,NULL,NULL,'2MASX J11083267+3948396',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000181,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,167.1360417,39.81094,0,NULL,63937386784,999021668,15609713,16.8),(77702,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77702,36.04,0.46,161,30243,70,NULL,NULL,'2MASX J11083304+5126218',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000177,NULL,'15.7g',0.45,'S0^-',NULL,NULL,NULL,NULL,1,167.137583333,51.43942,0,NULL,61789733534,965464586,15085384,15.7),(77703,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77703,35.75,0.46,142,30244,70,NULL,NULL,'2MASX J11083505+5155289',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000179,NULL,'15.6g',0.44,'S0',NULL,NULL,NULL,NULL,1,167.145833,51.92472,0,NULL,61790288190,965473252,15085519,15.6),(77704,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77704,38.26,0.46,449,30245,70,NULL,NULL,'SDSS J110835.23+504741.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000176,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,167.146833,50.79494,0,NULL,61780609623,965322025,15083156,18),(77705,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77705,37.62,0.15,334,30246,70,NULL,NULL,'2MASX J11083528+4142536',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000083,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,167.147167,41.71483,0,NULL,63934019025,998969047,15608891,16.6),(77706,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77706,37.74,0.15,354,30247,70,NULL,NULL,'2MASX J11083557+3103468',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000178,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,167.1482083,31.06322,0,NULL,60640949151,947514830,14804919,17.3),(77707,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77707,35.87,0.46,149,30248,70,NULL,NULL,'2MASX J11083651+2459241',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00017,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,167.1522083,24.99011,0,NULL,60600006808,946875106,14794923,16.3),(77708,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77708,38.51,0.46,503,30249,70,NULL,NULL,'2MASX J11083658+2338244',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,167.1524583,23.64011,0,NULL,61086099394,954470303,14913598,17.6),(77709,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77709,38.17,0.46,431,30250,70,NULL,NULL,'2MASX J11083666+5853276',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000182,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,167.153083,58.89119,0,NULL,61999673608,968744900,15136639,17.3),(77710,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77710,37.89,0.46,378,30251,70,NULL,NULL,'2MASX J11083670+4212251',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000186,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,167.153125,42.20683,0,NULL,63931706734,998932917,15608326,16.8),(77711,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77711,37.08,0.12,260,30252,70,NULL,NULL,'2MASX J11083786+4431401',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000191,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,167.157625,44.52797,0,NULL,63951925577,999248837,15613263,16.6),(77712,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77712,36.96,0.46,247,30253,70,NULL,NULL,'2MASX J11083859+6308129',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000163,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,167.160583,63.13686,0,NULL,61871266423,966738537,15105289,16.9),(77713,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77713,35.77,0.46,143,30254,70,NULL,NULL,'2MASX J11083916+2102174',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,167.163125,21.03831,0,NULL,61086931020,954483297,14913801,16.9),(77714,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77714,37.1,0.33,264,30255,70,NULL,NULL,'2MASX J11083986+5012409',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00018,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,167.166167,50.21131,0,NULL,61780455728,965319620,15083119,16.6),(77715,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77715,38.19,0.46,435,30256,70,NULL,NULL,'2MASX J11084044+2442110',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,167.168583,24.70306,0,NULL,60600298269,946879660,14794994,18.3),(77716,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77716,36.05,0.46,162,30257,70,NULL,NULL,'2MASX J11084085+2501430',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00016,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,167.17025,25.02867,0,NULL,60599999039,946874984,14794921,16.6),(77717,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77717,35.99,0.46,158,30258,70,NULL,NULL,'2MASX J11084101+0325115',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000186,NULL,'15.9g',0.3,'S0^-',NULL,NULL,NULL,NULL,1,167.170875,3.41986,0.133,NULL,60286119404,941970615,14718290,15.9),(77718,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77718,35.44,0.46,122,30259,70,NULL,NULL,'MCG +06-25-009',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000194,NULL,'15.0g',0.63,NULL,NULL,NULL,NULL,NULL,1,167.171583,36.16108,0,NULL,60418720064,944042501,14750664,15),(77719,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77719,37.57,0.17,327,30260,70,NULL,NULL,'2MASX J11084130+4031545',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,167.172083,40.53175,0,NULL,63934469266,998976082,15609001,17.4),(77720,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77720,37.1,0.33,264,30261,70,NULL,NULL,'2MASX J11084141+5018009',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000183,NULL,'16.1g',0.37,NULL,NULL,NULL,NULL,NULL,1,167.172666667,50.30022,0,NULL,61780434547,965319289,15083113,16.1),(77721,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77721,35.95,0.1,155,30262,70,NULL,NULL,'2MASX J11084203+2857020',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000087,NULL,'16.1g',0.43,'E','Group member',NULL,NULL,NULL,1,167.1752083,28.95053,0,NULL,60611220241,947050316,14797661,16.1),(77722,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77722,37.08,0.12,260,30263,70,NULL,NULL,'SDSS J110844.00+440428.4',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',NULL,NULL,'16.1g',0.34,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,167.183375,44.07456,0,NULL,63953180577,999268446,15613569,16.1),(77723,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77723,37.62,0.15,334,30264,70,NULL,NULL,'2MASX J11084491+4136151',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000083,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,167.187166667,41.60428,0,NULL,63934010532,998968914,15608889,17.2),(77724,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77724,38.03,0.46,404,30265,70,NULL,NULL,'SDSS J110845.52+521414.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,167.1897083,52.23733,0,NULL,61790187266,965471676,15085494,18),(77725,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77725,37.34,0.46,294,30266,70,NULL,NULL,'2MASX J11084577+2929411',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,167.190583,29.49464,0,NULL,60654241849,947722528,14808164,17.9),(77726,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77726,36.89,0.46,239,30267,70,NULL,NULL,'SDSS J110846.35+343722.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000156,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,167.193167,34.62306,0,NULL,60635287644,947426369,14803537,18.3),(77727,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77727,37.47,0.33,311,30268,70,NULL,NULL,'2MASX J11084746+2907561',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000188,NULL,'16.9g',0.3,'E',NULL,NULL,NULL,NULL,1,167.197833333,29.13239,0,NULL,60608371108,947005798,14796965,16.9),(77728,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77728,35.92,0.46,153,30269,70,NULL,NULL,'2MASX J11084855+0700214',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000166,NULL,'16.0g',0.3,'S0^-',NULL,NULL,NULL,NULL,1,167.20225,7.006,0.093,NULL,60308898555,942326539,14723852,16),(77729,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77729,38.24,0.46,445,30270,70,NULL,NULL,'2MASX J11084861+5308179',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000139,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,167.2024583,53.13831,0,NULL,61783511262,965367363,15083865,18.4),(77730,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77730,37.74,0.15,354,30271,70,NULL,NULL,'2MASX J11084864+3100378',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,167.202625,31.0105,0,NULL,60640765178,947511955,14804874,18.3),(77731,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77731,36.85,0.46,234,30272,70,NULL,NULL,'2MASX J11084926+5517376',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,167.205125,55.29394,0,NULL,61992568910,968633889,15134904,17.3),(77732,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77732,37.9,0.46,380,30273,70,NULL,NULL,'2MASX J11084994+1709549',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000147,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,167.2079583,17.16531,0,NULL,61140477570,955319962,14926874,18.4),(77733,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77733,36.39,0.46,189,30274,70,NULL,NULL,'2MASX J11085000+1546579',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00017,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,167.2085,15.78275,0,NULL,61144031457,955375491,14927742,16.2),(77734,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77734,37.99,0.46,396,30275,70,NULL,NULL,'2MASX J11085055+1508189',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,167.2107917,15.13872,0,NULL,61143276011,955363687,14927557,17.7),(77735,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77735,34.75,0.46,89.3,30276,70,NULL,NULL,'2MASX J11085126+1641229',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00009,NULL,'16.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,167.213583,16.68969,0,NULL,61141409703,955334526,14927101,16.1),(77736,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77736,38.19,0.46,434,30277,70,NULL,NULL,'SDSS J110851.29+485222.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000139,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,167.2137083,48.87292,0,NULL,63916829099,998700454,15604694,18.5),(77737,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77737,37.15,0.46,269,30278,70,NULL,NULL,'2MASX J11085218+0129565',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,167.217333,1.49914,0.109,NULL,60296281731,942129402,14720771,17.5),(77738,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77738,37.47,0.33,311,30279,70,NULL,NULL,'2MASX J11085233+2909262',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00018,NULL,'18.12',0.17,'E',NULL,NULL,NULL,NULL,1,167.217917,29.15736,0,NULL,60608440222,947006878,14796982,18.12),(77739,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77739,37.12,0.21,266,30280,70,NULL,NULL,'2MASX J11085282+1420099',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,167.22,14.33608,0,NULL,61150950675,955483604,14929431,17.2),(77740,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77740,36.53,0.46,202,30281,70,NULL,NULL,'2MASX J11085340+2124494',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.30',0.14,NULL,NULL,NULL,NULL,NULL,1,167.2225,21.41378,0,NULL,61087084967,954485702,14913839,18.3),(77741,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77741,37.61,0.46,333,30282,70,NULL,NULL,'2MASX J11085407+2457242',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000149,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,167.2254583,24.95661,0,NULL,60600122741,946876917,14794951,17.3),(77742,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77742,37.6,0.46,330,30283,70,NULL,NULL,'2MASX J11085419+0704424',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,167.225791667,7.07847,0.093,NULL,60308898853,942326544,14723852,17.4),(77743,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77743,38.19,0.46,434,30284,70,NULL,NULL,'2MASX J11085438+5758537',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,167.226667,57.98167,0,NULL,61999016035,968734625,15136478,18),(77744,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77744,37.74,0.15,354,30285,70,NULL,NULL,'2MASX J11085442+3115018',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00018,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,167.226833333,31.25061,0,NULL,60640928713,947514511,14804914,17.7),(77745,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77745,38.34,0.46,466,30286,70,NULL,NULL,'2MASX J11085528+2620032',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,167.230333,26.33425,0.007,NULL,60602288757,946910761,14795480,18.4),(77746,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77746,35.07,0.4,103,30287,NULL,NULL,'mean','NGC 3534',NULL,'2007A&A...465...71T',2007,1,1.22,NULL,'G',0.00003,NULL,'14.8g',0.54,'Sb','in a triple',NULL,NULL,NULL,1,167.231917,26.6105,0,NULL,60602257209,946910268,14795472,14.8),(77747,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77747,35.19,0.45,109,30287,NULL,NULL,'K','NGC 3534',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77748,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77748,35.22,0.47,111,30287,NULL,NULL,'H','NGC 3534',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77749,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77749,35.31,0.49,115,30287,75,NULL,'IR','NGC 3534',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77750,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77750,35.39,0.46,120,30287,NULL,NULL,'J','NGC 3534',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77751,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77751,38.41,0.33,480,30288,70,NULL,NULL,'2MASX J11085602+4018102',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000179,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,167.2332917,40.30275,0,NULL,63934457236,998975894,15608998,17),(77752,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77752,37.57,0.17,327,30289,70,NULL,NULL,'2MASX J11085713+4034452',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,167.238167,40.57922,0,NULL,63934480106,998976251,15609003,16.7),(77753,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77753,38.94,0.46,613,30290,70,NULL,NULL,'2MASX J11085768+4722100',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000187,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,167.2402083,47.3695,0.009,NULL,63915871678,998685494,15604460,17.5),(77754,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77754,37.74,0.15,354,30291,70,NULL,NULL,'2MASX J11085804+3055418',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000152,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,167.241916667,30.92831,0,NULL,60640762679,947511916,14804873,17.3),(77755,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77755,37.62,0.15,334,30292,70,NULL,NULL,'2MASX J11085819+4138312',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000067,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,167.24275,41.64208,0,NULL,63934016388,998969006,15608890,17.1),(77756,'IRAS','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77756,31.33,0.8,18.5,30293,75,NULL,'MAT, I','UGCA 226',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.000013,NULL,'14.82',0.5,'SB(s)m: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,167.244333,-28.37128,0.221,NULL,41548688274,649198254,10143722,14.82),(77757,'Tully est','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77757,31.65,0.8,21.4,30293,75,NULL,NULL,'UGCA 226',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77758,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77758,31.53,0.32,20.2,30293,85,NULL,'I, inv','UGCA 226',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77759,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77759,31.58,0.32,20.7,30293,85,NULL,'I, raw','UGCA 226',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77760,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77760,31.89,0.43,23.8,30293,75,NULL,'MAT, I, inv','UGCA 226',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77761,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77761,31.99,0.2,25,30293,74.4,NULL,NULL,'UGCA 226',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77762,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77762,32,0.43,25.1,30293,75,NULL,'MAT, I, raw','UGCA 226',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77763,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77763,32.09,0.4,26.2,30293,NULL,NULL,NULL,'UGCA 226',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77764,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77764,32.3,0.43,28.9,30293,75,NULL,'MAT, I, cor','UGCA 226',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77765,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77765,35.98,0.51,157,30294,70,NULL,NULL,'2MASX J11085890-0434477',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.78',NULL,NULL,NULL,NULL,NULL,NULL,1,167.2455,-4.58019,0.097,NULL,40919920673,639373760,9990215,15.78),(77766,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77766,37.85,0.46,372,30295,70,NULL,NULL,'2MASX J11090037-0006567',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00009,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,167.251416667,-0.11569,0.097,NULL,40904480134,639132502,9986445,17.6),(77767,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77767,36.55,0.72,204,30296,70,NULL,NULL,'2MASX J11090175-0049007',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.000098,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,167.25725,-0.81672,0.121,NULL,40904239811,639128747,9986386,16.5),(77768,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77768,36.71,0.46,220,30296,70,NULL,NULL,'2MASX J11090175-0049007',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77769,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77769,38.41,0.33,480,30297,70,NULL,NULL,'SDSS J110902.15+401459.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,167.2589583,40.24992,0,NULL,63937283114,999020048,15609688,18.2),(77770,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77770,38.69,0.46,548,30298,70,NULL,NULL,'SDSS J110902.73+311007.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000161,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,167.261417,31.16886,0,NULL,60640983077,947515360,14804927,18.4),(77771,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77771,37.62,0.15,334,30299,70,NULL,NULL,'2MASX J11090479+4131052',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,167.270041667,41.51822,0,NULL,63934034832,998969294,15608895,17.4),(77772,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77772,37.6,0.33,330,30300,70,NULL,NULL,'2MASX J11090683+4257310',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000188,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,167.2785,42.95864,0,NULL,63939093213,999048331,15610130,16.5),(77773,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77773,35.32,0.46,116,30301,70,NULL,NULL,'UGC 06197 NED01',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00013,NULL,'16.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,167.279667,8.18153,0.053,NULL,60311292099,942363939,14724436,16.3),(77774,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77774,35.7,0.46,138,30302,70,NULL,NULL,'CGCG 155-076',NULL,'2015arXiv151105856S',2015,1,0.81,'1981Afz....17....5K has V_sun = 6356 +- 50 km sec^-1.','G',0.000203,NULL,'14.9g',0.53,'S0','in a triple',NULL,NULL,NULL,1,167.283625,26.62761,0,NULL,60601994930,946906170,14795408,14.9),(77775,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77775,35.73,0.29,140,30303,NULL,NULL,'Malmquist cor.','NGC 3539',NULL,'2009ApJS..182..474S',2009,1,1.34,NULL,'G',0.000018,NULL,'15.0g',0.3,'S0/a','Group member',NULL,NULL,NULL,1,167.286833,28.67253,0,NULL,60611844297,947060067,14797813,15),(77776,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77776,35.81,0.49,145,30303,75,NULL,'IR','NGC 3539',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77777,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77777,35.97,0.26,157,30303,NULL,NULL,NULL,'NGC 3539',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77778,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77778,36.18,0.2,172,30303,74.4,NULL,NULL,'NGC 3539',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77779,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77779,35.81,0.46,145,30304,70,NULL,NULL,'2MASX J11090911+0528156',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000172,NULL,'16.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,167.287875,5.47103,0.117,NULL,60314595355,942415552,14725243,16.5),(77780,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77780,37.95,0.46,389,30305,70,NULL,NULL,'SDSS J110909.38+541138.2',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,167.289083333,54.19394,NULL,NULL,61963006489,968171976,15127687,17.6),(77781,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77781,36.01,0.51,159,30306,70,NULL,NULL,'2MASX J11091023-4848158',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,167.2927083,-48.80436,0.773,NULL,41917786679,654965416,10233834,16.5),(77782,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77782,37.66,0.46,340,30307,70,NULL,NULL,'2MASX J11091284+1453463',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000181,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,167.3035417,14.89617,0,NULL,61143345155,955364768,14927574,16.6),(77783,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77783,37.99,0.46,397,30308,70,NULL,NULL,'SDSS J110913.69+020618.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000183,NULL,'18.5g',0.09,NULL,NULL,NULL,NULL,NULL,1,167.307083,2.10517,0.105,NULL,60295887881,942123248,14720675,18.5),(77784,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77784,38.12,0.46,420,30309,70,NULL,NULL,'2MASX J11091375+0728055',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,167.307333,7.46817,0.089,NULL,60311489403,942367021,14724484,18.1),(77785,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77785,36.37,0.46,188,30310,70,NULL,NULL,'2MASX J11091482-0055407',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000093,NULL,'16.1g',0.33,NULL,NULL,NULL,NULL,NULL,1,167.3117083,-0.92794,0.121,NULL,40906154419,639158662,9986854,16.1),(77786,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77786,36.85,0.46,235,30311,70,NULL,NULL,'2MASX J11091497+0717205',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00015,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,167.31225,7.28892,0.093,NULL,60307065676,942297901,14723404,17.3),(77787,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77787,37.61,0.46,333,30312,70,NULL,NULL,'2MASX J11091575+3750002',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000168,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,167.315667,37.83336,0,NULL,63923195105,998799923,15606248,16.6),(77788,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77788,37.63,0.46,336,30313,70,NULL,NULL,'2MASX J11091575+6215418',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,167.315708333,62.26169,0,NULL,61860094006,966563968,15102562,17.7),(77789,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77789,37.67,0.46,342,30314,70,NULL,NULL,'2MASX J11091606+4304279',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,167.316916667,43.07436,0,NULL,63952782566,999262227,15613472,17.5),(77790,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77790,38.13,0.46,423,30315,70,NULL,NULL,'2MASX J11091680+5344028',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000225,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,167.320083,53.73414,0,NULL,61786005571,965406337,15084474,16.5),(77791,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77791,34.61,0.43,83.4,30316,NULL,NULL,NULL,'2MASX J11091692+2132245',NULL,'2009ApJS..182..474S',2009,1,0.37,NULL,'G',0.000027,NULL,'14.48',0.23,'SBab',NULL,NULL,NULL,NULL,1,167.320625,21.54025,0,NULL,61087768744,954496386,14914006,14.48),(77792,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77792,34.79,0.4,90.7,30316,NULL,NULL,'Malmquist cor.','2MASX J11091692+2132245',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77793,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77793,37.64,0.33,338,30317,70,NULL,NULL,'2MASX J11091751+3042371',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000172,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,167.323167,30.71025,0,NULL,60654379095,947724673,14808198,16.2),(77794,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77794,35.83,0.46,146,30318,70,NULL,NULL,'2MASX J11091760+2221595',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000031,NULL,'16.83',0.23,NULL,NULL,NULL,NULL,NULL,1,167.3232917,22.36647,0,NULL,61089545859,954524154,14914439,16.83),(77795,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77795,37.15,0.46,269,30319,70,NULL,NULL,'2MASX J11091817+2642041',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000175,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,167.325875,26.70128,0,NULL,60613331301,947083301,14798176,16.8),(77796,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77796,36.69,0.46,218,30320,70,NULL,NULL,'2MASX J11091827+4449069',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000176,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,167.325916667,44.81867,0,NULL,63952124316,999251942,15613311,16.3),(77797,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77797,37.08,0.12,260,30321,70,NULL,NULL,'2MASX J11091857+4416059',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000191,NULL,'16.1g',0.39,NULL,NULL,NULL,NULL,NULL,1,167.3274583,44.26844,0,NULL,63953758291,999277473,15613710,16.1),(77798,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77798,36.98,0.46,249,30322,70,NULL,NULL,'2MASX J11092027+4025229',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,167.3344583,40.42306,0,NULL,63934452471,998975819,15608997,17.4),(77799,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77799,31.31,0.43,18.3,30323,75,NULL,'3.6 micron, color + selection bias corrected','ESO 502- G 020',NULL,'2014MNRAS.444..527S',2014,1,1.4,NULL,'G',0.000013,NULL,'14.46',1.2,'SAB(s)c:',NULL,NULL,NULL,NULL,1,167.3419583,-22.8755,0.217,NULL,41708863495,651700992,10182828,14.46),(77800,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77800,37.52,0.23,319,30324,70,NULL,NULL,'2MASX J11092263+1927215',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.01',0.15,NULL,NULL,NULL,NULL,NULL,1,167.3444583,19.45608,0,NULL,61162941975,955670968,14932358,18.01),(77801,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77801,38.22,0.33,441,30325,70,NULL,NULL,'2MASX J11092359+2356245',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000176,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,167.3482083,23.94011,0,NULL,60565858079,946341532,14786586,16.9),(77802,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77802,37.62,0.15,334,30326,70,NULL,NULL,'SDSS J110924.44+413137.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000171,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,167.351875,41.52717,0,NULL,63934031720,998969245,15608894,18.2),(77803,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77803,37.64,0.33,338,30327,70,NULL,NULL,'SDSS J110924.97+304237.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000157,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,167.354083,30.71047,0,NULL,60654412795,947725199,14808206,18.6),(77804,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77804,33.93,0.69,61.2,30328,NULL,NULL,NULL,'AGC 211453',NULL,'2009ApJS..182..474S',2009,1,0.73,NULL,'G',0.000023,NULL,'15.9g',0.29,'Scd:',NULL,NULL,NULL,NULL,1,167.354167,22.48356,0,NULL,61089563061,954524422,14914444,15.9),(77805,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77805,33.97,0.2,62.2,30328,74.4,NULL,NULL,'AGC 211453',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77806,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77806,34.26,0.59,71.2,30328,NULL,NULL,'Malmquist cor.','AGC 211453',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77807,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77807,34.2,0.4,69.1,30329,NULL,NULL,'mean','IC 0673',NULL,'2007A&A...465...71T',2007,1,1.37,NULL,'G',0.000022,NULL,'14.5g',0.59,'(R\')SAB(rs)c   HII',NULL,NULL,NULL,NULL,1,167.3554583,-0.09772,0.097,NULL,40906537212,639164643,9986947,14.5),(77808,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77808,34.58,0.47,82.4,30329,NULL,NULL,'H','IC 0673',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77809,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77809,39,0.46,631,30330,70,NULL,NULL,'SDSS J110926.52+013740.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00016,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,167.360541667,1.62789,0.109,NULL,60295795803,942121809,14720653,18.6),(77810,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77810,38.21,0.46,438,30331,70,NULL,NULL,'SDSS J110927.62+380947.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000129,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,167.365125,38.16325,0,NULL,63922322177,998786284,15606035,18.6),(77811,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77811,37.12,0.21,266,30332,70,NULL,NULL,'2MASX J11092855+1427273',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000155,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,167.369083,14.45753,0,NULL,61150962334,955483786,14929434,17),(77812,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77812,37.06,0.46,259,30333,70,NULL,NULL,'2MASX J11092932+1041155',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.0002,NULL,'16.1g',0.39,NULL,NULL,NULL,NULL,NULL,1,167.372083,10.68772,0.029,NULL,61019384867,953427888,14897310,16.1),(77813,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77813,38.57,0.46,517,30334,70,NULL,NULL,'2MASX J11092944+5631507',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000187,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,167.3725,56.53064,0,NULL,61993205615,968643837,15135059,17.9),(77814,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77814,37.21,0.23,276,30335,70,NULL,NULL,'2MASX J11093041-0036394',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000074,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,167.37675,-0.61083,0.093,NULL,40906599410,639165615,9986962,17.3),(77815,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77815,36.3,0.46,182,30336,70,NULL,NULL,'2MASX J11093095+2720573',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000192,NULL,'15.7g',0.4,NULL,NULL,NULL,NULL,NULL,1,167.379167,27.34914,0,NULL,60613824736,947091011,14798297,15.7),(77816,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77816,37.44,0.46,308,30337,70,NULL,NULL,'SDSS J110931.48+335601.7',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,167.381208333,33.93381,0,NULL,60646792960,947606140,14806345,17.1),(77817,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77817,37.12,0.21,266,30338,70,NULL,NULL,'2MASX J11093172+1424293',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000191,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,167.3822917,14.40831,0,NULL,61151105165,955486018,14929469,16.1),(77818,'Tully est','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77818,32.91,0.8,38.2,30339,75,NULL,'B','NGC 3557B',NULL,'1988NBGC.C....0000T',1988,1,2,NULL,'G',0.00015,NULL,'13.6',0.6,'E5:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,167.383875,-37.34964,0.409,NULL,41895739346,654620927,10228451,13.6),(77819,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77819,36.73,0.46,222,30340,70,NULL,NULL,'2MASX J11093218+3609270',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000103,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,167.3839583,36.15753,0,NULL,60418908719,944045448,14750710,17.2),(77820,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77820,37.21,0.23,276,30341,70,NULL,NULL,'2MASX J11093247-0041034',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000087,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,167.38525,-0.68436,0.097,NULL,40906603491,639165679,9986963,16.5),(77821,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77821,37.53,0.46,321,30342,70,NULL,NULL,'2MASX J11093271+0757305',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000176,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,167.386208333,7.95836,0.061,NULL,60311963972,942374437,14724600,16.8),(77822,'SNIa','2016-12-15 15:14:44','2016-12-16 11:19:52','1','SN 2006ak',NULL,77822,35.32,0.17,112,30343,74.2,NULL,'SALT 2','2MASX J11093314+2837393',0.0381,'2010ApJ...716..712A',2010,1,0.81,NULL,'G',0.0001,NULL,'15.7g',0.23,'S','Group member',NULL,NULL,NULL,1,167.388083,28.62775,0,NULL,60611850000,947060156,14797814,15.7),(77823,'SNIa','2016-12-15 15:14:44','2016-12-16 11:19:52','1','SN 2006ak',NULL,77823,35.95,0.02,149,30343,72,NULL,'MLCS17','2MASX J11093314+2837393',0.0381,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77824,'SNIa','2016-12-15 15:14:44','2016-12-16 11:19:52','1','SN 2006ak',NULL,77824,35.96,0.09,156,30343,74.4,NULL,NULL,'2MASX J11093314+2837393',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77825,'SNIa','2016-12-15 15:14:44','2016-12-16 11:19:52','1','SN 2006ak',NULL,77825,36.13,0.16,162,30343,70,NULL,'SALT 2','2MASX J11093314+2837393',0.0381,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77826,'SNIa','2016-12-15 15:14:44','2016-12-16 11:19:52','1','SN 2006ak',NULL,77826,36.28,0.19,174,30343,65,NULL,'MLCS17','2MASX J11093314+2837393',0.0381,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77827,'SNIa','2016-12-15 15:14:44','2016-12-16 11:19:52','1','SN 2006ak',NULL,77827,36.33,0.22,178,30343,65,NULL,'SALT2','2MASX J11093314+2837393',0.0381,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77828,'SNIa','2016-12-15 15:14:44','2016-12-16 11:19:52','1','SN 2006ak',NULL,77828,36.38,0.18,181,30343,65,NULL,'MLCS31','2MASX J11093314+2837393',0.0381,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77829,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77829,37.21,0.23,276,30344,70,NULL,NULL,'2MASX J11093341-0036054',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000112,NULL,'16.3g',0.35,'AGN',NULL,NULL,NULL,NULL,1,167.389083333,-0.60142,0.093,NULL,40906643324,639166301,9986973,16.3),(77830,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77830,35.92,0.25,153,30345,74.4,NULL,NULL,'CGCG 125-032',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'GPair',NULL,NULL,NULL,NULL,NULL,'Group member',NULL,NULL,NULL,1,167.390667,21.74536,0,NULL,61087790027,954496719,14914011,NULL),(77831,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77831,38.28,0.46,452,30346,70,NULL,NULL,'2MASX J11093429+0547102',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000178,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,167.39275,5.78608,0.153,NULL,60306257664,942285276,14723207,18.1),(77832,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77832,37.7,0.46,346,30347,70,NULL,NULL,'2MASXi J1109342+142116',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,167.392958333,14.3545,0,NULL,61151106854,955486044,14929469,18),(77833,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77833,33.51,0.54,50.3,30348,70,NULL,NULL,'ESO 265- G 009',NULL,'2014MNRAS.445.2677S',2014,1,1.1,'RC3 has V = 6370 +- 60 km/s.','G',0.00015,NULL,'14.56',1,'SA(r)0/a:',NULL,NULL,NULL,NULL,1,167.39325,-46.74919,0.633,NULL,41932684526,655198195,10237471,14.56),(77834,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77834,36.69,0.46,218,30349,70,NULL,NULL,'2MASX J11093485+0111312',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000076,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,167.3954583,1.19192,0.101,NULL,60283706196,941932909,14717701,16.7),(77835,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77835,36.87,0.66,236,30350,70,NULL,NULL,'2MASX J11093601-7454321',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,'S0 pec',NULL,NULL,NULL,NULL,1,167.399916667,-74.90889,0.561,NULL,39861576366,622837130,9731830,17),(77836,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77836,37.6,0.33,330,30351,70,NULL,NULL,'2MASX J11093636+4252312',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,167.4015,42.8755,0,NULL,63952809387,999262646,15613478,17.6),(77837,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77837,36.76,0.46,225,30352,70,NULL,NULL,'SDSS J110936.52+434148.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,167.4022083,43.69672,0,NULL,63953411915,999272061,15613625,17.9),(77838,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77838,37.12,0.21,266,30353,70,NULL,NULL,'2MASX J11093716+1428163',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000175,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,167.40475,14.47128,0,NULL,61150963344,955483802,14929434,16.5),(77839,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77839,37.62,0.15,334,30354,70,NULL,NULL,'SDSS J110938.25+412730.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00008,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,167.409417,41.45858,0,NULL,63933998015,998968718,15608886,17.9),(77840,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77840,38.34,0.46,466,30355,70,NULL,NULL,'2MASX J11093841+2520183',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000177,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,167.41,25.33853,0,NULL,60602784445,946918506,14795601,17.9),(77841,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77841,37.06,0.46,258,30356,70,NULL,NULL,'2MASX J11093910+0953395',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000155,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,167.412833333,9.89436,0.029,NULL,60301171440,942205803,14721965,17.1),(77842,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77842,36.11,0.19,167,30357,70,NULL,NULL,'2MASX J11093924+2143036',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.06',0.15,NULL,NULL,NULL,NULL,NULL,1,167.413375,21.71767,0,NULL,61087787455,954496678,14914010,18.06),(77843,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77843,38.24,0.46,444,30358,70,NULL,NULL,'2MASX J11093939+0527132',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000188,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,167.414167,5.45367,0.117,NULL,60314566007,942415093,14725235,17.6),(77844,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77844,36.11,0.19,167,30359,70,NULL,NULL,'2MASX J11093974+2140146',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.25',0.14,NULL,NULL,NULL,NULL,NULL,1,167.415541667,21.67081,0,NULL,61087797127,954496830,14914012,18.25),(77845,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77845,34.88,0.46,94.7,30360,70,NULL,NULL,'CGCG 039-021',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000103,NULL,'15.7g',0.3,'E0',NULL,NULL,NULL,NULL,1,167.4164583,5.35019,0.137,NULL,60314439628,942413119,14725204,15.7),(77846,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77846,37.44,0.33,307,30361,70,NULL,NULL,'2MASX J11094104+1504370',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000146,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,167.4209583,15.07703,0,NULL,61143462451,955366600,14927603,18.4),(77847,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77847,37.64,0.27,338,30362,70,NULL,NULL,'2MASX J11094108+3854420',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000175,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,167.4212917,38.91181,0,NULL,63936909025,999014203,15609596,17),(77848,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77848,36.11,0.19,167,30363,70,NULL,NULL,'2MASX J11094118+2144256',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000031,NULL,'14.33',NULL,NULL,NULL,NULL,NULL,NULL,1,167.421583,21.74042,0,NULL,61087787702,954496682,14914010,14.33),(77849,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77849,36.14,0.23,169,30364,70,NULL,NULL,'2MASX J11094134+0452052',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000169,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,167.4222917,4.86814,0.161,NULL,60314825672,942419151,14725299,17.1),(77850,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77850,35.95,0.1,155,30365,70,NULL,NULL,'2MASX J11094162+2854543',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000067,NULL,'15.5g',0.4,'S0','Group member',NULL,NULL,NULL,1,167.423625,28.915,0,NULL,60611308658,947051697,14797682,15.5),(77851,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77851,37.62,0.15,334,30366,70,NULL,NULL,'2MASX J11094214+4144500',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,167.425667,41.74714,0,NULL,63933819827,998965934,15608842,18),(77852,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77852,37.14,0.46,268,30367,70,NULL,NULL,'2MASX J11094236+2911573',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000151,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,167.4265417,29.19925,0,NULL,60608251030,947003922,14796936,17.3),(77853,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77853,35.71,0.15,139,30368,70,NULL,NULL,'ABELL 1177',NULL,'1999AJ....118.1489D',1999,1,NULL,'X-ray flux may be blend of NGC 3551 and cluster.','GClstr',NULL,NULL,NULL,NULL,'I      [BM]',NULL,NULL,NULL,NULL,1,167.429583,21.76194,0,NULL,61087786246,954496660,14914010,NULL),(77854,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77854,35.56,0.52,130,30369,NULL,NULL,'Malmquist cor.','2MASX J11094325+2158456',NULL,'2009ApJS..182..474S',2009,1,0.85,NULL,'G',0.00003,NULL,'14.16',0.17,'Sbc',NULL,NULL,NULL,NULL,1,167.43025,21.97939,0,NULL,61087614074,954493969,14913968,14.16),(77855,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77855,35.84,0.46,147,30369,NULL,NULL,NULL,'2MASX J11094325+2158456',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77856,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77856,35.88,0.2,150,30369,74.4,NULL,NULL,'2MASX J11094325+2158456',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77857,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77857,34.54,0.33,81,30370,70,NULL,NULL,'UGC 06201',NULL,'2015arXiv151105856S',2015,1,0.93,NULL,'G',0.00016,NULL,'14.2g',0.69,'S0-','in a radial-velocity based grouping',NULL,NULL,NULL,1,167.432125,46.81428,0,NULL,63947600070,999181251,15612207,14.2),(77858,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77858,35.6,0.25,132,30371,74.4,NULL,NULL,'NGC 3551',NULL,'2013AJ....146...86T',2013,1,1.8,NULL,'G',0.000031,NULL,'13.8B',1.7,'BrClG','Group member',NULL,NULL,NULL,1,167.435166667,21.75892,0,NULL,61087788066,954496688,14914010,13.8),(77859,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77859,36.11,0.19,167,30371,70,NULL,NULL,'NGC 3551',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77860,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77860,35.71,0.15,139,30371,70,NULL,'ABELL 1177, BGC','NGC 3551',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77861,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77861,37.61,0.46,333,30372,70,NULL,NULL,'SDSS J110944.73+010335.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00007,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,167.436375,1.05975,0.101,NULL,60283789686,941934213,14717722,18.3),(77862,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77862,38.33,0.33,464,30373,70,NULL,NULL,'2MASX J11094506+1652580',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,167.4377083,16.88283,0,NULL,61141246534,955331977,14927062,18.2),(77863,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77863,37.53,0.46,320,30374,70,NULL,NULL,'2MASX J11094531+4624352',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,167.43875,46.40975,0,NULL,63947615877,999181498,15612210,17.4),(77864,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77864,37.08,0.46,260,30375,70,NULL,NULL,'2MASX J11094623+6743274',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000071,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,167.442458333,67.72431,0,NULL,62087256263,970113379,15158021,17.4),(77865,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77865,37.9,0.46,379,30376,70,NULL,NULL,'2MASX J11094657+6005273',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000167,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,167.444083333,60.09103,0,NULL,61996058949,968688421,15135756,17.1),(77866,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77866,33.92,0.47,60.8,30377,70,NULL,NULL,'NGC 3546',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00008,NULL,'14.41',0.7,'SA0- pec:',NULL,NULL,NULL,NULL,1,167.4449583,-13.38086,0.105,NULL,41811759007,653308734,10207948,14.41),(77867,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77867,36.89,0.46,238,30378,70,NULL,NULL,'2MASX J11094718+0210112',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,167.4465,2.16978,0.105,NULL,60296061013,942125953,14720718,17.4),(77868,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77868,36.16,0.33,171,30379,70,NULL,NULL,'2MASX J11094766+5607381',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000181,NULL,'15.8g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,167.448708333,56.12736,0,NULL,61995989036,968687328,15135739,15.8),(77869,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77869,37.08,0.12,260,30380,70,NULL,NULL,'2MASX J11094818+4401282',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,167.450958333,44.02458,0,NULL,63953223328,999269114,15613579,17.9),(77870,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77870,35.68,0.2,137,30381,74.4,NULL,NULL,'CGCG 067-015',NULL,'2013AJ....146...86T',2013,1,0.69,NULL,'G',0.0001,NULL,'15.5g',0.38,'(R)SBab',NULL,NULL,NULL,NULL,1,167.4515417,8.99406,0.041,NULL,60300090052,942188907,14721701,15.5),(77871,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77871,35.95,0.1,155,30382,70,NULL,NULL,'2MASX J11095000+2843469',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00012,NULL,'18.44',0.14,NULL,NULL,NULL,NULL,NULL,1,167.458416667,28.72983,0,NULL,60611775031,947058984,14797796,18.44),(77872,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77872,35.33,0.25,116,30383,74.4,NULL,NULL,'NGC 3555',NULL,'2013AJ....146...86T',2013,1,0.37,NULL,'G',0.000047,NULL,'15.7',0.26,NULL,'Group member',NULL,NULL,NULL,1,167.459708333,21.81019,0,NULL,61087779038,954496547,14914008,15.7),(77873,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77873,37.52,0.23,319,30384,70,NULL,NULL,'SDSS J110950.67+193012.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,167.461125,19.50339,0,NULL,61092447260,954569488,14915148,18.4),(77874,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77874,37.74,0.33,353,30385,70,NULL,NULL,'SDSS J110950.88+051517.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'18.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,167.4620417,5.25497,0.153,NULL,60314920750,942420636,14725322,18),(77875,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77875,38.33,0.33,464,30386,70,NULL,NULL,'SDSS J110951.10+165311.9',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000133,NULL,'18.8g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,167.4629583,16.88667,0,NULL,61141278909,955332482,14927070,18.8),(77876,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77876,37.44,0.33,307,30387,70,NULL,NULL,'2MASX J11095126+1504000',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000185,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,167.463667,15.06683,0,NULL,61143464104,955366626,14927603,16.2),(77877,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77877,34.13,0.49,66.9,30388,75,NULL,'IR','UGC 06199',NULL,'2011yCatp016004901K',2011,1,1.81,'This is part of the galaxy UGC 06199.','G',0.000007,NULL,'14.2g',0.41,'Sb(f)',NULL,NULL,NULL,NULL,1,167.465583,62.29183,0,NULL,61860669301,966572957,15102702,14.2),(77878,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77878,34.32,0.47,73.2,30388,NULL,NULL,'H','UGC 06199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77879,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77879,34.39,0.4,75.6,30388,NULL,NULL,'mean','UGC 06199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77880,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77880,34.4,0.45,76,30388,NULL,NULL,'K','UGC 06199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77881,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77881,34.42,0.46,76.6,30388,NULL,NULL,'J','UGC 06199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77882,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77882,35.63,0.46,134,30389,70,NULL,NULL,'CGCG 067-018',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.00017,NULL,'14.9g',0.63,'SA(r)0-',NULL,NULL,NULL,NULL,1,167.468041667,9.51944,0.033,NULL,60301501432,942210959,14722046,14.9),(77883,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77883,30.24,0.47,11.2,30390,NULL,NULL,'H','IC 2627',NULL,'2007A&A...465...71T',2007,1,2.7,NULL,'G',0.000007,NULL,'12.62',2.3,'SAB(rs?)bc     HII',NULL,NULL,NULL,NULL,1,167.4724583,-23.72594,0.281,NULL,41708230098,651691095,10182673,12.62),(77884,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77884,30.42,0.46,12.1,30390,NULL,NULL,'J','IC 2627',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77885,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77885,30.49,0.45,12.5,30390,NULL,NULL,'K','IC 2627',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77886,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77886,32.17,0.4,27.1,30390,NULL,NULL,'mean','IC 2627',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77887,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77887,32.35,0.4,29.5,30390,75,NULL,'B','IC 2627',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77888,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77888,36.87,0.46,236,30391,70,NULL,NULL,'2MASX J11095345+3434354',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000177,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,167.472625,34.57656,0.034,NULL,60635983407,947437240,14803706,16.3),(77889,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77889,34.25,0.55,70.9,30392,NULL,NULL,NULL,'2MASX J11095362+2226586',NULL,'2009ApJS..182..474S',2009,1,0.43,NULL,'G',0.000023,NULL,'15.07',0.15,'Sc',NULL,NULL,NULL,NULL,1,167.4735417,22.44967,0,NULL,61089756072,954527438,14914491,15.07),(77890,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77890,34.3,0.2,72.4,30392,74.4,NULL,NULL,'2MASX J11095362+2226586',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77891,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77891,34.52,0.48,80.2,30392,NULL,NULL,'Malmquist cor.','2MASX J11095362+2226586',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77892,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77892,37.62,0.15,334,30393,70,NULL,NULL,'2MASX J11095560+4117355',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,167.4815,41.29317,0,NULL,63933970790,998968293,15608879,17.5),(77893,'Tully est','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77893,32.11,0.8,26.5,30394,75,NULL,'B','NGC 3547',NULL,'1988NBGC.C....0000T',1988,1,1.61,NULL,'G',0.000007,NULL,'13.3g',0.78,'Sb:','Possible group member',NULL,NULL,NULL,1,167.483083333,10.72083,0.029,NULL,61019339115,953427173,14897299,13.3),(77894,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77894,31.29,0.4,18.1,30394,NULL,NULL,NULL,'NGC 3547',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77895,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77895,31.38,0.43,18.9,30394,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3547',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77896,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77896,31.51,0.43,20,30394,75,NULL,'3.6 micron, color corrected','NGC 3547',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77897,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77897,31.62,0.2,21.1,30394,74.4,NULL,NULL,'NGC 3547',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77898,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77898,32.27,0.46,28.5,30394,NULL,NULL,'J','NGC 3547',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77899,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77899,32.31,0.47,29,30394,NULL,NULL,'H','NGC 3547',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77900,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77900,32.35,0.4,29.5,30394,NULL,NULL,'mean','NGC 3547',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77901,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77901,32.44,0.45,30.8,30394,NULL,NULL,'K','NGC 3547',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77902,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77902,37.12,0.21,266,30395,70,NULL,NULL,'SDSS J110956.16+142718.6',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'15.8g',0.44,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,167.484041667,14.45519,0,NULL,61151100557,955485946,14929467,15.8),(77903,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77903,37.52,0.23,319,30396,70,NULL,NULL,'2MASX J11095640+1925536',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.36',0.17,NULL,NULL,NULL,NULL,NULL,1,167.485125,19.43164,0,NULL,61092459396,954569678,14915151,17.36),(77904,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77904,37.15,0.46,269,30397,70,NULL,NULL,'2MASX J11095647+4612132',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000174,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,167.48525,46.20358,0,NULL,63947528822,999180137,15612189,16.3),(77905,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77905,34.84,0.49,92.7,30398,75,NULL,'IR','UGC 06208',NULL,'2011yCatp016004901K',2011,1,1.33,NULL,'G',0.000033,NULL,'15.1g',0.28,'Sb','Group member',NULL,NULL,NULL,1,167.4855417,7.23347,0.093,NULL,60307114622,942298665,14723416,15.1),(77906,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77906,34.95,0.4,97.9,30398,NULL,NULL,'mean','UGC 06208',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77907,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77907,34.96,0.44,98,30398,NULL,NULL,'Malmquist cor.','UGC 06208',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77908,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77908,35,0.43,100,30398,NULL,NULL,NULL,'UGC 06208',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77909,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77909,35.04,0.2,102,30398,74.4,NULL,NULL,'UGC 06208',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77910,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77910,35.18,0.47,109,30398,NULL,NULL,'H','UGC 06208',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77911,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77911,38.16,0.23,428,30399,70,NULL,NULL,'2MASX J11095647+0130059',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,167.485417,1.50175,0.105,NULL,60281908302,941904817,14717262,17.8),(77912,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77912,37.21,0.23,276,30400,70,NULL,NULL,'2MASX J11095682-0034272',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00008,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,167.486708333,-0.57425,0.097,NULL,40906640670,639166260,9986972,16.9),(77913,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77913,37.15,0.46,269,30401,70,NULL,NULL,'2MASX J11095768+5703571',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000151,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,167.490375,57.06592,0,NULL,61993793269,968653019,15135203,16.9),(77914,'SBF','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77914,33.3,0.22,45.7,30402,NULL,NULL,'I','NGC 3557',NULL,'2001ApJ...546..681T',2001,1,4.1,NULL,'G',0.00006,NULL,'11.41',3,'E3             LINER','in a pair',NULL,'radio jet','Flat-Spectrum Radio Source',1,167.490167,-37.53917,0.549,NULL,41894899003,654607796,10228246,11.41),(77915,'SBF','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77915,33.33,0.14,46.3,30402,74.4,NULL,NULL,'NGC 3557',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77916,'D-Sigma','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77916,32.09,0.4,26.2,30402,75,NULL,'Edat, raw','NGC 3557',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77917,'D-Sigma','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77917,32.43,0.4,30.6,30402,75,NULL,'Edat, cor','NGC 3557',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77918,'Faber-Jackson','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77918,30.75,0.75,14.1,30402,95,NULL,'de Vaucouleurs','NGC 3557',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77919,'Faber-Jackson','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77919,31.2,0.33,17.4,30402,95,NULL,'Weighted Mean','NGC 3557',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77920,'Faber-Jackson','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77920,31.52,0.63,20.1,30402,95,NULL,'Michard 1979b, c','NGC 3557',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77921,'Faber-Jackson','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77921,31.6,0.46,20.9,30402,95,NULL,'Michard 1979a','NGC 3557',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77922,'Faber-Jackson','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77922,31.92,NULL,24.2,30402,NULL,NULL,'LEDA [April 2006]','NGC 3557',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77923,'Faber-Jackson','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77923,32.56,0.81,32.5,30402,55,NULL,'Visvanathan & Sandage 1979','NGC 3557',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77924,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77924,32.14,0.48,26.8,30402,70,NULL,NULL,'NGC 3557',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77925,'Tertiary','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77925,31.88,0.58,23.8,30402,95,NULL,NULL,'NGC 3557',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77926,'Tully est','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77926,33.09,0.8,41.5,30402,75,NULL,'B','NGC 3557',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77927,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77927,32.32,0.45,29.2,30402,NULL,NULL,'K','NGC 3557',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77928,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77928,32.94,NULL,38.7,30402,71,NULL,'NGC 3557, 60 galaxies','NGC 3557',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77929,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77929,33.02,0.3,40.2,30402,NULL,NULL,'NGC 3557, 9 galaxies','NGC 3557',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77930,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77930,33.09,0.19,41.5,30402,70,NULL,'NGC 3557 Group','NGC 3557',NULL,'1992ApJ...396..453H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77931,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77931,33.21,0.4,43.9,30402,NULL,NULL,'mean','NGC 3557',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77932,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77932,32.18,0.2,27.3,30403,74.4,NULL,NULL,'UGC 06205',NULL,'2013AJ....146...86T',2013,1,1.8,NULL,'G',0.000017,NULL,'14.9',1.4,'Sm:',NULL,NULL,NULL,NULL,1,167.493167,46.09489,0,NULL,63947481284,999179395,15612178,14.9),(77933,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77933,38.22,0.33,441,30404,70,NULL,NULL,'2MASX J11095919+2400360',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,167.49675,24.01014,0,NULL,60565836894,946341201,14786581,17.7),(77934,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77934,38.16,0.23,428,30405,70,NULL,NULL,'2MASX J11095961+0124319',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000158,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,167.4985,1.40881,0.105,NULL,60283723679,941933182,14717705,18.1),(77935,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77935,37.19,0.46,274,30406,70,NULL,NULL,'SDSS J111000.44+014107.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,167.501875,1.68533,0.093,NULL,60295767364,942121365,14720646,18.1),(77936,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77936,37.51,0.46,317,30407,70,NULL,NULL,'2MASX J11100138+1857203',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,167.505833,18.95583,0,NULL,61090593120,954540517,14914695,16.8),(77937,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77937,37.53,0.46,321,30408,70,NULL,NULL,'2MASX J11100156+3447114',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000177,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,167.506625,34.78642,0.034,NULL,60635957689,947436838,14803700,17.5),(77938,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77938,35.5,0.33,126,30409,70,NULL,NULL,'CGCG 314-011',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.000073,NULL,'14.5g',0.76,'S0',NULL,NULL,NULL,NULL,1,167.5095,63.64194,0,NULL,61868073683,966688651,15104510,14.5),(77939,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77939,36.53,0.46,202,30410,70,NULL,NULL,'2MASX J11100236+3236294',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000143,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,167.5097083,32.60828,0.01,NULL,60648900904,947639076,14806860,17.2),(77940,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77940,37.76,0.33,356,30411,70,NULL,NULL,'2MASX J11100243+0525029',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00014,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,167.510083,5.41753,0.137,NULL,60314517805,942414340,14725224,17.8),(77941,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77941,38.16,0.23,428,30412,70,NULL,NULL,'2MASX J11100287+0140169',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000167,NULL,'17.0g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,167.512083,1.67133,0.093,NULL,60281887133,941904486,14717257,17),(77942,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77942,38.16,0.23,428,30413,70,NULL,NULL,'SDSS J111002.91+013905.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,167.512125,1.65158,0.177,NULL,60281888172,941904502,14717257,18.1),(77943,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77943,35.78,0.54,143,30414,NULL,NULL,'Malmquist cor.','SDSS J111003.04+214102.9',NULL,'2009ApJS..182..474S',2009,1,0.45,NULL,'G',0.000023,NULL,'17.9g',0.09,'Sc',NULL,NULL,NULL,NULL,1,167.5127083,21.68417,0,NULL,61087886659,954498229,14914034,17.9),(77944,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77944,35.8,0.53,145,30414,NULL,NULL,NULL,'SDSS J111003.04+214102.9',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77945,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77945,35.84,0.2,147,30414,74.4,NULL,NULL,'SDSS J111003.04+214102.9',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77946,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77946,38.22,0.46,440,30415,70,NULL,NULL,'SDSS J111003.80+065101.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000143,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,167.515875,6.85044,0.085,NULL,60309732003,942339562,14724055,18.4),(77947,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77947,38.46,0.46,492,30416,70,NULL,NULL,'2MASX J11100402+5811340',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,167.516583,58.19297,0,NULL,61999148083,968736688,15136510,17.8),(77948,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77948,37.64,0.27,338,30417,70,NULL,NULL,'SDSS J111004.37+385443.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000152,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,167.51825,38.91208,0.048,NULL,63936918783,999014355,15609599,18.4),(77949,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77949,37.64,0.27,338,30418,70,NULL,NULL,'2MASX J11100455+3857016',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000185,NULL,'16.1g',0.38,NULL,NULL,NULL,NULL,NULL,1,167.519083,38.95061,0,NULL,63936877679,999013713,15609589,16.1),(77950,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77950,36.83,0.46,232,30419,70,NULL,NULL,'2MASX J11100711+3042554',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000195,NULL,'15.9g',0.42,NULL,NULL,NULL,NULL,NULL,1,167.529583,30.71542,0,NULL,60654363209,947724425,14808194,15.9),(77951,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77951,36.49,0.46,199,30420,70,NULL,NULL,'2MASX J11100788+4557138',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000155,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,167.532667,45.95383,0,NULL,63951745113,999246017,15613219,16.9),(77952,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77952,36.01,0.55,159,30421,70,NULL,NULL,'2MASX J11100895-4607325',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,167.537416667,-46.12578,0.621,NULL,41932692996,655198328,10237473,16.5),(77953,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77953,37.5,0.46,316,30422,70,NULL,NULL,'2MASX J11100976-0003002',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000079,NULL,'18.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,167.540833,-0.05033,0.109,NULL,40903171844,639112060,9986125,18.3),(77954,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77954,35.64,0.54,134,30423,NULL,NULL,'Malmquist cor.','2MASX J11100985+2213354',NULL,'2009ApJS..182..474S',2009,1,0.39,NULL,'G',0.000023,NULL,'14.37',0.29,'Sa',NULL,NULL,NULL,NULL,1,167.541208333,22.22653,0,NULL,61087574847,954493356,14913958,14.37),(77955,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77955,35.81,0.49,146,30423,NULL,NULL,NULL,'2MASX J11100985+2213354',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77956,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77956,35.86,0.2,149,30423,74.4,NULL,NULL,'2MASX J11100985+2213354',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77957,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77957,38.14,0.33,425,30424,70,NULL,NULL,'SDSS J111011.42+170458.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000125,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,167.547625,17.08281,0,NULL,61140559085,955321235,14926894,18.5),(77958,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77958,37.75,0.46,355,30425,70,NULL,NULL,'2MASX J11101231+1436547',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,167.55125,14.61503,0,NULL,61142679647,955354369,14927412,17.8),(77959,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77959,38.05,0.17,408,30426,70,NULL,NULL,'CGPG 1107.5+0132',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,167.553,1.28228,0.101,NULL,60283901333,941935958,14717749,17.1),(77960,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77960,38.3,0.46,456,30427,70,NULL,NULL,'2MASX J11101276+1252117',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,167.553125,12.86986,0,NULL,61139951641,955311744,14926746,18.2),(77961,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77961,37.65,0.46,339,30428,70,NULL,NULL,'2MASX J11101278+1416587',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,167.553167,14.28297,0,NULL,61151082639,955485666,14929463,17.3),(77962,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77962,36.14,0.23,169,30429,70,NULL,NULL,'2MASX J11101288+0447039',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000185,NULL,'15.9g',0.34,'S0',NULL,NULL,NULL,NULL,1,167.553583333,4.78436,0.165,NULL,60314730228,942417659,14725275,15.9),(77963,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77963,35.18,0.48,108,30430,70,NULL,NULL,'LCRS B110741.3-061840',NULL,'2014MNRAS.445.2677S',2014,1,0.89,NULL,'G',0.00015,NULL,'15.09',0.65,NULL,NULL,NULL,NULL,NULL,1,167.556166667,-6.5825,0.049,NULL,40894224690,638972260,9983941,15.09),(77964,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77964,37.52,0.23,319,30431,70,NULL,NULL,'2MASX J11101364+1913334',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,167.557,19.22589,0.033,NULL,61093450374,954585162,14915393,17.2),(77965,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77965,35.95,0.1,155,30432,70,NULL,NULL,'2MASX J11101374+2820091',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00005,NULL,'16.3g',0.32,'Spherical',NULL,NULL,NULL,NULL,1,167.55725,28.336,0,NULL,60611048382,947047630,14797619,16.3),(77966,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77966,37.08,0.46,261,30433,70,NULL,NULL,'2MASX J11101420+4411488',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000157,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,167.5592083,44.19697,0,NULL,63953729975,999277030,15613703,17.2),(77967,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77967,36.44,0.63,194,30434,70,NULL,NULL,'2MASX J11101432-4616385',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,167.559583,-46.27742,0.621,NULL,41932748921,655199201,10237487,17),(77968,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77968,37.76,0.33,356,30435,70,NULL,NULL,'2MASX J11101482+0525319',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,167.561833,5.4255,0.137,NULL,60315027970,942422312,14725348,17.7),(77969,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77969,35.95,0.1,155,30436,70,NULL,NULL,'2MASX J11101699+2847251',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00009,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,167.570875,28.79039,0,NULL,60611272610,947051134,14797673,17.1),(77970,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77970,36.25,0.46,178,30437,70,NULL,NULL,'2MASX J11101724+0957106',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000152,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,167.571708333,9.95289,0.029,NULL,60301247564,942206993,14721984,17.1),(77971,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77971,37.12,0.23,266,30438,70,NULL,NULL,'2MASX J11101765+1015206',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,167.573583,10.25553,0.025,NULL,60297670957,942151108,14721111,17.9),(77972,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77972,36.14,0.23,169,30439,70,NULL,NULL,'2MASX J11101769+0445479',NULL,'2015arXiv151105856S',2015,1,0.43,'Two MAPS entries for the same object.','G',NULL,'FoF','16.1g',0.39,NULL,NULL,NULL,NULL,NULL,1,167.573667,4.76328,0.165,NULL,60314729442,942417647,14725275,16.1),(77973,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77973,37.86,0.46,374,30440,70,NULL,NULL,'2MASX J11101932+1743177',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,167.5805,17.72164,0,NULL,61090041128,954531892,14914560,18.3),(77974,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77974,35.04,0.65,102,30441,NULL,NULL,NULL,'SDSS J111020.28+211924.7',NULL,'2009ApJS..182..474S',2009,1,0.27,NULL,'G',0.000023,NULL,'18.56',0.1,'Sc',NULL,NULL,NULL,NULL,1,167.5845,21.32356,0,NULL,61087010309,954484536,14913820,18.56),(77975,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77975,35.08,0.2,104,30441,74.4,NULL,NULL,'SDSS J111020.28+211924.7',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77976,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77976,35.3,0.58,115,30441,NULL,NULL,'Malmquist cor.','SDSS J111020.28+211924.7',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77977,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77977,37.98,0.46,395,30442,70,NULL,NULL,'2MASX J11102062+0017089',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000089,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,167.585875,0.28572,0.113,NULL,60283975600,941937118,14717767,17.9),(77978,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77978,37.34,0.46,294,30443,70,NULL,NULL,'2MASX J11102073+3428168',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,167.5865417,34.47136,0,NULL,60635843593,947435056,14803672,16.9),(77979,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77979,38.05,0.46,408,30444,70,NULL,NULL,'2MASX J11102079+1609527',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000148,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,167.586625,16.16469,0,NULL,61140947417,955327303,14926989,17.3),(77980,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77980,35.63,0.53,134,30445,NULL,NULL,NULL,'LCSB S1516P',NULL,'2009ApJS..182..474S',2009,1,0.33,NULL,'G',0.000023,NULL,'15.79',0.12,'Sc',NULL,NULL,NULL,NULL,1,167.587375,22.51814,0,NULL,61089718787,954526856,14914482,15.79),(77981,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77981,35.67,0.2,136,30445,74.4,NULL,NULL,'LCSB S1516P',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77982,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77982,35.7,0.51,138,30445,NULL,NULL,'Malmquist cor.','LCSB S1516P',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77983,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77983,35.95,0.1,155,30446,70,NULL,NULL,'2MASX J11102124+2837351',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.00009,NULL,'15.9g',0.31,'E','Group member',NULL,NULL,NULL,1,167.5884583,28.62639,0,NULL,60611810616,947059540,14797805,15.9),(77984,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77984,37.74,0.33,353,30447,70,NULL,NULL,'SDSS J111021.91+051748.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,167.591333,5.29681,0.153,NULL,60315133017,942423953,14725374,18),(77985,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77985,37.53,0.46,321,30448,70,NULL,NULL,'2MASX J11102379+4527388',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000184,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,167.5992083,45.46075,0,NULL,63952640438,999260006,15613437,17),(77986,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77986,35.54,0.47,128,30449,NULL,NULL,'H','CGCG 039-034',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'GPair',0.000033,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,167.600833,4.825,0.165,NULL,60314720173,942417502,14725273,NULL),(77987,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77987,35.64,0.4,135,30449,NULL,NULL,'mean','CGCG 039-034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77988,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77988,35.65,0.45,135,30449,NULL,NULL,'K','CGCG 039-034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77989,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77989,35.7,0.46,138,30449,NULL,NULL,'J','CGCG 039-034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77990,'SNII optical','2016-12-15 15:14:44','2016-12-16 11:19:52','1','SN 2003ci',NULL,77990,35.28,0.53,114,30450,NULL,NULL,'SCM, I','UGC 06212',NULL,'2010ApJ...715..833O',2010,1,1.1,NULL,'G',0.000099,NULL,'14.4g',0.62,'Sb','Group member',NULL,NULL,NULL,1,167.6022917,4.83006,0.165,NULL,60314719395,942417490,14725273,14.4),(77991,'SNII optical','2016-12-15 15:14:44','2016-12-16 11:19:52','1','SN 2003ci',NULL,77991,35.3,0.38,115,30450,NULL,NULL,'SCM, BVI','UGC 06212',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77992,'SNII optical','2016-12-15 15:14:44','2016-12-16 11:19:52','1','SN 2003ci',NULL,77992,35.31,0.54,115,30450,NULL,NULL,'SCM, V','UGC 06212',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77993,'SNII optical','2016-12-15 15:14:44','2016-12-16 11:19:52','1','SN 2003ci',NULL,77993,35.51,0.09,126,30450,NULL,NULL,'I, photospheric magnitude method','UGC 06212',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77994,'SNII optical','2016-12-15 15:14:44','2016-12-16 11:19:52','1','SN 2003ci',NULL,77994,35.81,0.16,145,30450,NULL,NULL,'V, photospheric magnitude method','UGC 06212',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77995,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77995,35.07,0.46,103,30450,NULL,NULL,'Malmquist cor.','UGC 06212',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77996,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77996,35.14,0.45,107,30450,NULL,NULL,NULL,'UGC 06212',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77997,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,77997,35.18,0.2,109,30450,74.4,NULL,NULL,'UGC 06212',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77998,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77998,37.67,0.33,342,30451,70,NULL,NULL,'2MASX J11102470+4349428',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000204,NULL,'16.2g',0.36,'E0',NULL,NULL,NULL,NULL,1,167.60275,43.82869,0,NULL,63953398270,999271847,15613622,16.2),(77999,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',77999,36.3,0.46,182,30452,70,NULL,NULL,'2MASX J11102490+5023001',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,167.603875,50.38342,0,NULL,61780357551,965318086,15083095,16.7),(78000,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78000,37.27,0.46,285,30453,70,NULL,NULL,'2MASX J11102494+3427268',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000192,NULL,'16.6g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,167.604083,34.4575,0,NULL,60635855719,947435245,14803675,16.6),(78001,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78001,31.36,NULL,18.7,30454,NULL,NULL,NULL,'CGCG 067-022',NULL,'2015AstBu..70....1K',2015,1,0.68,NULL,'G',0.0001,NULL,'16.1g',0.45,'SAm','Group member',NULL,NULL,NULL,1,167.605125,10.12533,0.029,NULL,60297656764,942150886,14721107,16.1),(78002,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78002,36.14,0.23,169,30455,70,NULL,NULL,'CGCG 039-033',NULL,'2015arXiv151105856S',2015,1,0.88,NULL,'G',0.00016,NULL,'15.3g',0.5,'E+:',NULL,NULL,NULL,NULL,1,167.6054583,4.5995,0.153,NULL,60285217371,941956521,14718070,15.3),(78003,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,78003,35.3,0.25,115,30456,74.4,NULL,NULL,'2MASX J11102589+2206373',NULL,'2013AJ....146...86T',2013,1,0.32,NULL,'G',0.000025,NULL,'17.00',0.27,NULL,NULL,NULL,NULL,NULL,1,167.607875,22.11036,0,NULL,61087604493,954493820,14913965,17),(78004,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,78004,36.69,0.56,218,30457,70,NULL,NULL,'2MASX J11102597-0717591',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'15.80',0.47,NULL,NULL,NULL,NULL,NULL,1,167.608208333,-7.29964,0.085,NULL,40893073942,638954280,9983660,15.8),(78005,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78005,37.69,0.08,345,30458,70,NULL,NULL,'2MASX J11102620+4101437',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,167.6092917,41.02881,0,NULL,63934630630,998978603,15609040,17.8),(78006,'BL Lac Luminosity','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,78006,41.96,NULL,2470,30459,70,NULL,'min.','CRATES J1110-1835 NED01',NULL,'2014ApJ...784..151S',2014,1,NULL,'May be the head of a radio jet.','RadioS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,167.6157083,-18.598,0.137,NULL,41716949370,651827333,10184802,NULL),(78007,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78007,35.5,0.33,126,30460,70,NULL,NULL,'CGCG 314-012',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000187,NULL,'15.3g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,167.617666667,63.5505,0,NULL,61867993480,966687398,15104490,15.3),(78008,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78008,38.08,0.46,413,30461,70,NULL,NULL,'2MASX J11102850+1213477',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000172,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,167.618875,12.23003,0,NULL,61137017088,955265892,14926029,17.6),(78009,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78009,37.05,0.46,257,30462,70,NULL,NULL,'2MASX J11102863+2732097',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000191,NULL,'15.9g',0.44,NULL,NULL,NULL,NULL,NULL,1,167.6192083,27.53611,0,NULL,60613710149,947089221,14798269,15.9),(78010,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78010,37.19,0.46,274,30463,70,NULL,NULL,'2MASX J11102910+2532267',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000158,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,167.6212917,25.54069,0,NULL,60603286216,946926347,14795724,17.1),(78011,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78011,37.11,0.27,264,30464,70,NULL,NULL,'2MASX J11102931-0043002',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00011,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,167.622125,-0.71683,0.085,NULL,40906884608,639170072,9987032,16.4),(78012,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78012,36.29,0.46,181,30465,70,NULL,NULL,'2MASX J11102973+2705287',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000201,NULL,'15.5g',0.46,NULL,NULL,NULL,NULL,NULL,1,167.623875,27.09131,0,NULL,60613941369,947092833,14798325,15.5),(78013,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78013,38.05,0.17,408,30466,70,NULL,NULL,'2MASX J11103013+0107096',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000082,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,167.625625,1.11939,0.101,NULL,60283882630,941935666,14717744,17.8),(78014,'SNIa','2016-12-15 15:14:44','2016-12-16 11:19:52','1','SN 2001ah',NULL,78014,36.3,0.2,172,30467,74.2,NULL,'SALT 2','UGC 06211',0.057756,'2010ApJ...716..712A',2010,1,0.78,'UGC misprints DEC. as +55d29\'.','G',0.000165,NULL,'15.2g',0.7,'SABbc',NULL,NULL,NULL,NULL,1,167.6264583,55.16983,0,NULL,61992460175,968632190,15134877,15.2),(78015,'SNIa','2016-12-15 15:14:44','2016-12-16 11:19:52','1','SN 2001ah',NULL,78015,36.84,0.09,233,30467,74.4,NULL,NULL,'UGC 06211',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78016,'SNIa','2016-12-15 15:14:44','2016-12-16 11:19:52','1','SN 2001ah',NULL,78016,36.97,0.03,234,30467,72,NULL,'SALT','UGC 06211',0.057756,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78017,'SNIa','2016-12-15 15:14:44','2016-12-16 11:19:52','1','SN 2001ah',NULL,78017,37,0.21,238,30467,73.8,NULL,'SALT 2 (SNANA)','UGC 06211',0.0586,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78018,'SNIa','2016-12-15 15:14:44','2016-12-16 11:19:52','1','SN 2001ah',NULL,78018,37.09,0.15,248,30467,65,NULL,'SALT','UGC 06211',0.057756,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78019,'SNIa','2016-12-15 15:14:44','2016-12-16 11:19:52','1','SN 2001ah',NULL,78019,37.12,0.16,251,30467,70,NULL,'SALT 2','UGC 06211',0.057756,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78020,'SNIa','2016-12-15 15:14:44','2016-12-16 11:19:52','1','SN 2001ah',NULL,78020,37.12,0.18,251,30467,65,NULL,'SALT2','UGC 06211',0.057756,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78021,'SNIa','2016-12-15 15:14:44','2016-12-16 11:19:52','1','SN 2001ah',NULL,78021,37.19,0.17,259,30467,65,NULL,'MLCS17','UGC 06211',0.057756,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78022,'SNIa','2016-12-15 15:14:44','2016-12-16 11:19:52','1','SN 2001ah',NULL,78022,37.26,0.16,268,30467,65,NULL,'MLCS31','UGC 06211',0.057756,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78023,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78023,37.94,0.46,387,30468,70,NULL,NULL,'2MASX J11103056+5820061',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,167.627208333,58.335,0,NULL,61999104638,968736009,15136500,17.8),(78024,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78024,37.69,0.08,345,30469,70,NULL,NULL,'2MASX J11103250+4057460',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000173,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,167.635291667,40.96289,0,NULL,63934380203,998974690,15608979,16.6),(78025,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78025,38.14,0.33,425,30470,70,NULL,NULL,'SDSS J111032.49+170333.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000143,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,167.635375,17.05931,0,NULL,61140505438,955320397,14926881,18.2),(78026,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78026,37.67,0.33,342,30471,70,NULL,NULL,'2MASX J11103337+4345408',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,167.638833,43.76147,0,NULL,63953429233,999272331,15613630,17.7),(78027,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78027,39.06,0.46,648,30472,70,NULL,NULL,'2MASX J11103438+3753400',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000148,NULL,'17.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,167.6434583,37.89447,0,NULL,63922491999,998788937,15606077,17.3),(78028,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78028,34.47,0.49,78.3,30473,75,NULL,'IR','CGCG 067-023',NULL,'2011yCatp016004901K',2011,1,0.91,NULL,'G',0.00004,NULL,'15.7g',0.26,'S',NULL,NULL,NULL,NULL,1,167.644167,12.45269,0,NULL,61136558455,955258725,14925917,15.7),(78029,'Tully est','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,78029,32.73,0.8,35.2,30474,75,NULL,NULL,'ESO 215- G 031',NULL,'1988NBGC.C....0000T',1988,1,2.3,NULL,'G',0.000019,NULL,'13.64',1.7,'(R\'_1)SB(r)b',NULL,NULL,NULL,NULL,1,167.6449583,-49.10261,0.761,NULL,41917264926,654957264,10233707,13.64),(78030,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78030,34.69,0.46,86.9,30475,70,NULL,NULL,'CGCG 039-037',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.0001,NULL,'15.3g',0.44,'E',NULL,NULL,NULL,NULL,1,167.647666667,3.26728,0.097,NULL,60287503413,941992240,14718628,15.3),(78031,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78031,36.54,0.33,203,30476,70,NULL,NULL,'SDSS J111036.03+074707.9',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000187,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,167.650167,7.78556,0.065,NULL,60307159132,942299361,14723427,16.9),(78032,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78032,37.86,0.46,374,30477,70,NULL,NULL,'SDSS J111036.05+095431.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,167.65025,9.90875,0.025,NULL,60300795189,942199924,14721873,18.4),(78033,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,78033,32.69,0.48,34.5,30478,70,NULL,NULL,'NGC 3564',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.000063,NULL,'13.14',0.8,'S0: sp','in a pair',NULL,NULL,NULL,1,167.651583,-37.54758,0.501,NULL,41894922143,654608158,10228252,13.14),(78034,'Tully est','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,78034,32.88,0.8,37.6,30478,75,NULL,'B','NGC 3564',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78035,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78035,35.91,0.33,152,30479,70,NULL,NULL,'2MASX J11103717+1003019',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000155,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,167.6547917,10.05056,0.029,NULL,60297969840,942155778,14721184,16.4),(78036,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78036,35.81,0.46,145,30480,70,NULL,NULL,'2MASX J11103719+0911349',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000157,NULL,'16.0g',0.41,'S0/a',NULL,NULL,NULL,NULL,1,167.654875,9.19314,0.045,NULL,60300076805,942188700,14721698,16),(78037,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78037,37.58,0.46,328,30481,70,NULL,NULL,'2MASX J11103724+4401285',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,167.6550417,44.02481,0,NULL,63953322923,999270670,15613604,17.6),(78038,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78038,35.95,0.1,155,30482,70,NULL,NULL,'CGCG 155-081',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00008,NULL,'15.3g',0.41,'S0','Group member',NULL,NULL,NULL,1,167.656166667,28.73269,0,NULL,60611763576,947058805,14797793,15.3),(78039,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78039,35.92,0.46,153,30483,70,NULL,NULL,'2MASX J11103826+0556036',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000164,NULL,'16.1g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,167.659375,5.93439,0.153,NULL,60306314231,942286159,14723221,16.1),(78040,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78040,38.73,0.46,556,30484,70,NULL,NULL,'2MASX J11103839+3110597',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000145,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,167.6597917,31.18306,0,NULL,60638676514,947479320,14804364,18.4),(78041,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78041,35.95,0.1,155,30485,70,NULL,NULL,'UGC 06218 NOTES01',NULL,'2015arXiv151105856S',2015,1,1.2,NULL,'G',0.000047,NULL,'14.37',1.2,'S0','Group member',NULL,NULL,NULL,1,167.660166667,28.31683,0,NULL,60611090614,947048290,14797629,14.37),(78042,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,78042,35.96,0.4,155,30485,NULL,NULL,'mean','UGC 06218 NOTES01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78043,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,78043,36.31,0.45,183,30485,NULL,NULL,'K','UGC 06218 NOTES01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78044,'BCG','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,78044,36.11,0.35,161,30486,60,NULL,'ABELL 1185, BCG','NGC 3550 NED01',0.0349,'1980ApJ...241..486H',1980,1,0.8,NULL,'G',0.00003,NULL,'14.2',0.8,'E','Pair member (points to parent)',NULL,NULL,NULL,1,167.660833,28.76778,0,NULL,60611240742,947050636,14797666,14.2),(78045,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,78045,35.44,0.45,123,30486,NULL,NULL,'K','NGC 3550 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78046,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,78046,35.85,0.4,148,30486,NULL,NULL,'mean','NGC 3550 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78047,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78047,38.19,0.46,435,30487,70,NULL,NULL,'2MASX J11103886+0249066',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,167.661917,2.81856,0.097,NULL,60295642675,942119416,14720615,17.9),(78048,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78048,35.26,0.46,113,30488,70,NULL,NULL,'CGCG 155-083',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000103,NULL,'14.6g',0.74,NULL,NULL,NULL,NULL,NULL,1,167.663083,31.65581,0,NULL,60638947757,947483558,14804430,14.6),(78049,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78049,37.61,0.33,333,30489,70,NULL,NULL,'SDSS J111039.39+402424.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,167.664167,40.40672,0,NULL,63934537997,998977156,15609018,18.4),(78050,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78050,37.2,0.46,275,30490,70,NULL,NULL,'2MASX J11103982+5509281',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000191,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,167.666,55.15786,0,NULL,61992459841,968632185,15134877,16.6),(78051,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78051,36.91,0.46,240,30491,70,NULL,NULL,'2MASX J11104016+1543136',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000182,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,167.667333,15.72033,0,NULL,61142948648,955358572,14927477,16.1),(78052,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,78052,37.32,0.63,292,30492,70,NULL,NULL,'2MASX J11104036-0719222',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'17.24',0.17,NULL,NULL,NULL,NULL,NULL,1,167.668125,-7.32281,0.073,NULL,40893078244,638954347,9983661,17.24),(78053,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78053,37.62,0.15,334,30493,70,NULL,NULL,'2MASX J11104144+4123550',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,167.672333,41.39869,0,NULL,63926541613,998852212,15607065,17.5),(78054,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78054,37.67,0.46,342,30494,70,NULL,NULL,'2MASX J11104198+1421028',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,167.675,14.35083,0,NULL,61150893336,955482708,14929417,17.5),(78055,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78055,38.05,0.17,408,30495,70,NULL,NULL,'2MASX J11104240+0110476',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000178,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,167.676667,1.18003,0.101,NULL,60283860981,941935327,14717739,17.5),(78056,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78056,35.91,0.33,152,30496,70,NULL,NULL,'CGCG 067-024',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000097,NULL,'15.5g',0.43,'SA0^0^','Group member',NULL,NULL,NULL,1,167.677917,10.09403,0.029,NULL,60298104545,942157883,14721216,15.5),(78057,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78057,38.17,0.46,430,30497,70,NULL,NULL,'2MASX J11104283+2004587',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,167.678333,20.08292,0,NULL,61093075853,954579310,14915301,17.2),(78058,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78058,35.95,0.1,155,30498,70,NULL,NULL,'SDSS J111042.84+284135.3',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',NULL,NULL,'14.6g',0.72,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,167.6785,28.69317,0,NULL,60611768990,947058890,14797795,14.6),(78059,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,78059,35.46,0.47,124,30499,70,NULL,NULL,'AM 1108-362 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000103,NULL,'15.5',0.4,NULL,NULL,NULL,NULL,NULL,1,167.68125,-36.66258,0.321,NULL,41374462659,646475979,10101187,15.5),(78060,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78060,38,0.46,398,30500,70,NULL,NULL,'SDSS J111043.69+580545.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000132,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,167.682167,58.09583,0,NULL,61999102201,968735971,15136499,18.5),(78061,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,78061,33.73,0.63,55.8,30501,NULL,NULL,'Malmquist cor.','ESO 438- G 008',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.33',0.5,'S?             HII',NULL,NULL,NULL,NULL,1,167.6852083,-30.34639,0.329,NULL,41602913890,650045529,10156961,14.33),(78062,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,78062,34.14,0.52,67.2,30501,NULL,NULL,NULL,'ESO 438- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78063,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,78063,34.18,0.2,68.6,30501,74.4,NULL,NULL,'ESO 438- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78064,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78064,37.17,0.46,272,30502,70,NULL,NULL,'2MASX J11104489+0452336',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00018,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,167.6870417,4.87611,0.165,NULL,60314690247,942417035,14725266,16.9),(78065,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78065,34.68,0.49,86.4,30503,75,NULL,'IR','UGC 06216',NULL,'2011yCatp016004901K',2011,1,1.44,NULL,'G',0.00001,NULL,'14.8g',0.32,'SBa? sp','Group member',NULL,NULL,NULL,1,167.686875,4.84644,0.165,NULL,60285128750,941955136,14718049,14.8),(78066,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,78066,34.83,0.4,92.5,30503,NULL,NULL,'mean','UGC 06216',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78067,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,78067,34.9,0.2,95.5,30503,74.4,NULL,NULL,'UGC 06216',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78068,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,78068,35.23,0.47,111,30503,NULL,NULL,'H','UGC 06216',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78069,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,78069,35.27,0.45,113,30503,NULL,NULL,'K','UGC 06216',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78070,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,NULL,78070,35.35,0.46,117,30503,NULL,NULL,'J','UGC 06216',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78071,'FP','2016-12-15 15:14:44','2016-12-16 11:19:52','1',NULL,'R',78071,39.06,0.46,649,30504,70,NULL,NULL,'2MASX J11104493+3043352',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,167.687166667,30.72631,0,NULL,60657301408,947770334,14808911,18.1),(78072,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78072,32.75,0.64,35.5,30505,NULL,NULL,'Malmquist cor.','NGC 3559',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000007,NULL,'13.9g',0.84,'S pec','Pair member, wide',NULL,NULL,NULL,1,167.688375,12.01614,0,NULL,61137222323,955269098,14926079,13.9),(78073,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78073,32.8,0.2,36.3,30505,74.4,NULL,NULL,'NGC 3559',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78074,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78074,32.81,0.62,36.5,30505,NULL,NULL,NULL,'NGC 3559',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78075,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78075,33.62,0.4,53,30505,NULL,NULL,'mean','NGC 3559',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78076,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78076,33.86,0.47,59.1,30505,NULL,NULL,'H','NGC 3559',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78077,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78077,36.99,0.46,250,30506,70,NULL,NULL,'2MASX J11104606+3001462',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000134,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,167.691667,30.02942,0,NULL,60657635671,947775557,14808993,17.5),(78078,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78078,33.75,0.2,56.2,30507,74.4,NULL,NULL,'MCG -02-29-008',NULL,'2013AJ....146...86T',2013,1,1.2,'6dF DR1 has z = 0.013083.','G',0.00015,NULL,'15.19',0.8,'SB(rs)c:',NULL,NULL,NULL,NULL,1,167.6922083,-15.73956,0.205,NULL,41818806497,653418851,10209669,15.19),(78079,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78079,33.95,0.32,61.8,30507,NULL,NULL,NULL,'MCG -02-29-008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78080,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78080,34.1,0.3,65.9,30507,NULL,NULL,'Malmquist cor.','MCG -02-29-008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78081,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78081,35.95,0.1,155,30508,70,NULL,NULL,'CGCG 155-084',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.000073,NULL,'15.1g',0.53,'S0p','Group member',NULL,NULL,NULL,1,167.694417,28.2785,0,NULL,60611078636,947048103,14797626,15.1),(78082,'BCG','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78082,36.11,0.35,161,30509,60,NULL,NULL,'ABELL 1185',0.0349,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II     [BM]',NULL,NULL,NULL,NULL,1,167.695,28.70611,0,NULL,60611771795,947058934,14797795,NULL),(78083,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78083,38.32,0.46,462,30510,70,NULL,NULL,'2MASX J11104695+1534338',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,167.6955,15.576,0,NULL,61142884191,955357565,14927461,17.9),(78084,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78084,35.95,0.1,155,30511,70,NULL,NULL,'SDSS J111047.82+283936.9',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',NULL,NULL,'14.8g',0.6,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,167.699291667,28.66028,0,NULL,60611765714,947058839,14797794,14.8),(78085,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78085,37.86,0.27,373,30512,70,NULL,NULL,'SDSS J111047.84+380814.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000133,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,167.699333,38.13728,0,NULL,63936022569,999000352,15609380,18.1),(78086,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78086,37.24,0.46,280,30513,70,NULL,NULL,'2MASX J11104799+0811050',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000165,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,167.699875,8.18464,0.065,NULL,60311816567,942372133,14724564,16.3),(78087,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78087,37.42,0.46,304,30514,70,NULL,NULL,'SDSS J111047.98+021611.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00013,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,167.6999583,2.26986,0.081,NULL,60296239707,942128745,14720761,18),(78088,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78088,34.75,0.45,89,30515,NULL,NULL,'K','ESO 438- G 009',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000043,NULL,'14.22',0.7,'(R\'_1)SB(rl)ab Sy1.5',NULL,NULL,NULL,'Sy 1',1,167.7,-28.50106,0.317,NULL,41547922200,649186284,10143535,14.22),(78089,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78089,34.83,0.47,92.5,30515,NULL,NULL,'H','ESO 438- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78090,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78090,35,0.4,99.9,30515,NULL,NULL,'mean','ESO 438- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78091,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78091,35.48,0.25,125,30516,74.4,NULL,NULL,'2MASX J11104821+2203337',NULL,'2013AJ....146...86T',2013,1,0.24,NULL,'G',0.000039,NULL,'17.66',0.19,NULL,NULL,NULL,NULL,NULL,1,167.701,22.05944,0,NULL,61087738677,954495916,14913998,17.66),(78092,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78092,36.11,0.19,167,30516,70,NULL,NULL,'2MASX J11104821+2203337',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78093,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78093,38.85,0.46,588,30517,70,NULL,NULL,'2MASX J11104827+1526548',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00013,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,167.701167,15.44847,0,NULL,61142921952,955358155,14927471,18.2),(78094,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78094,38.05,0.46,407,30518,70,NULL,NULL,'2MASX J11104833+0136476',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000144,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,167.7015417,1.61314,0.177,NULL,60282094726,941907730,14717308,17.7),(78095,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78095,37.06,0.46,258,30519,70,NULL,NULL,'2MASX J11104854+0224166',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.93',0.21,NULL,NULL,NULL,NULL,NULL,1,167.7022083,2.40464,0.097,NULL,60296263676,942129119,14720767,17.93),(78096,'IRAS','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78096,32.37,0.8,29.8,30520,75,NULL,'A82, H','NGC 3568',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000007,NULL,'13.00',0.8,'SB(s)c:        HII','in a pair',NULL,NULL,NULL,1,167.702375,-37.44786,0.501,NULL,41894908213,654607940,10228249,13),(78097,'IRAS','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78097,32.37,0.8,29.8,30520,75,NULL,'HMCL, I','NGC 3568',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78098,'IRAS','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78098,32.4,0.8,30.1,30520,75,NULL,'MAT, I','NGC 3568',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78099,'Sosies','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78099,32.63,0.1,33.6,30520,NULL,NULL,NULL,'NGC 3568',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78100,'Tully est','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78100,32.58,0.8,32.7,30520,75,NULL,NULL,'NGC 3568',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78101,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78101,31.23,0.43,17.6,30520,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3568',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78102,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78102,31.44,0.43,19.4,30520,75,NULL,'3.6 micron, color corrected','NGC 3568',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78103,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78103,31.49,0.4,19.9,30520,75,NULL,'HMCL, I, raw','NGC 3568',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78104,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78104,31.53,0.47,20.3,30520,75,NULL,'A82, H, raw','NGC 3568',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78105,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78105,31.56,0.47,20.5,30520,75,NULL,'A82, H, inv','NGC 3568',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78106,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78106,31.58,0.4,20.7,30520,75,NULL,'HMCL, I, inv','NGC 3568',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78107,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78107,31.69,0.2,21.8,30520,74.4,NULL,NULL,'NGC 3568',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78108,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78108,31.7,0.49,21.9,30520,75,NULL,'IR','NGC 3568',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78109,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78109,31.81,0.4,23,30520,75,NULL,'HMCL, I, cor','NGC 3568',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78110,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78110,31.87,0.38,23.7,30520,NULL,NULL,NULL,'NGC 3568',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78111,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78111,31.87,0.39,23.7,30520,73,NULL,'opt','NGC 3568',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78112,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78112,31.94,0.32,24.4,30520,85,NULL,'I, raw','NGC 3568',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78113,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78113,31.96,0.32,24.7,30520,85,NULL,'I, inv','NGC 3568',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78114,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78114,31.99,0.47,24.9,30520,75,NULL,'A82, H, cor','NGC 3568',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78115,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78115,32.16,0.43,27,30520,75,NULL,'MAT, I, raw','NGC 3568',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78116,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78116,32.33,0.43,29.2,30520,75,NULL,'MAT, I, inv','NGC 3568',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78117,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78117,32.5,0.43,31.7,30520,75,NULL,'MAT, I, cor','NGC 3568',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78118,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78118,32.98,0.12,39.5,30520,NULL,NULL,NULL,'NGC 3568',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78119,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78119,37.71,0.46,348,30521,70,NULL,NULL,'2MASX J11104891-0045193',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000074,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,167.703667,-0.75533,0.085,NULL,40906801444,639168772,9987012,17.8),(78120,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78120,35.42,0.33,121,30522,70,NULL,NULL,'SDSS J111049.15+231511.2',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00016,NULL,'16.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,167.704833,23.25314,0,NULL,61086535871,954477122,14913705,16.4),(78121,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78121,36.51,0.46,200,30523,70,NULL,NULL,'2MASX J11104921+2939298',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000153,NULL,'16.8g',0.28,'S0',NULL,NULL,NULL,NULL,1,167.7050417,29.65822,0,NULL,60654117284,947720582,14808134,16.8),(78122,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78122,37.12,0.23,266,30524,70,NULL,NULL,'2MASX J11104956+1009090',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.83',0.17,NULL,NULL,NULL,NULL,NULL,1,167.706583333,10.15253,0.029,NULL,60298115450,942158053,14721219,17.83),(78123,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78123,37.59,0.11,329,30525,70,NULL,NULL,'2MASX J11105012+3939011',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00011,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,167.709,39.65031,0,NULL,63936158938,999002483,15609413,17.4),(78124,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78124,37.51,0.46,318,30526,70,NULL,NULL,'2MASX J11105021+0751010',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000188,NULL,'16.1g',0.44,'E0',NULL,NULL,NULL,NULL,1,167.709417,7.85028,0.065,NULL,60307145527,942299148,14723424,16.1),(78125,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78125,38.16,0.46,428,30527,70,NULL,NULL,'SDSS J111050.64+063810.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000139,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,167.711,6.63633,0.101,NULL,60309661775,942338465,14724038,18.7),(78126,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78126,35.43,0.55,122,30528,70,NULL,NULL,'2MASX J11105122-1253193',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.20',NULL,NULL,NULL,NULL,NULL,NULL,1,167.7135417,-12.88869,0.121,NULL,41812451231,653319550,10208117,16.2),(78127,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78127,37.12,0.23,266,30529,70,NULL,NULL,'CGCG 067-026',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.00016,NULL,'15.5g',0.51,'SA0-:','Group member',NULL,NULL,NULL,1,167.71425,10.08814,0.029,NULL,60297972372,942155818,14721184,15.5),(78128,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78128,31.73,0.39,22.2,30530,73,NULL,'opt','ESO 438- G 010',NULL,'2011A&A...532A.104N',2011,1,1.4,NULL,'G',0.000033,NULL,'14.90',0.7,'SAB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,167.7162917,-27.89756,0.265,NULL,41547263336,649175989,10143374,14.9),(78129,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78129,32.02,0.75,25.3,30530,NULL,NULL,NULL,'ESO 438- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78130,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78130,32.06,0.2,25.8,30530,74.4,NULL,NULL,'ESO 438- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78131,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78131,32.32,0.65,29.1,30530,NULL,NULL,'Malmquist cor.','ESO 438- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78132,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78132,35.95,0.1,155,30531,70,NULL,NULL,'MCG +05-27-004 NED02',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000107,NULL,'15.7g',0.38,'S0','Group member',NULL,NULL,NULL,1,167.7165417,28.70256,0,NULL,60611771501,947058929,14797795,15.7),(78133,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78133,38.32,0.46,462,30532,70,NULL,NULL,'2MASX J11105221+0140056',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000153,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,167.7175417,1.66811,0.177,NULL,60282096144,941907752,14717308,17.5),(78134,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78134,37.48,0.46,313,30533,70,NULL,NULL,'2MASX J11105240+3144363',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000191,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,167.718375,31.74356,0,NULL,60638944072,947483501,14804429,16.7),(78135,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78135,37.27,0.46,285,30534,70,NULL,NULL,'2MASX J11105259+5133435',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,167.7192083,51.56214,0,NULL,61787029995,965422343,15084724,17.3),(78136,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78136,37.61,0.33,333,30535,70,NULL,NULL,'SDSS J111053.28+402809.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00013,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,167.722,40.46939,0,NULL,63934531743,998977058,15609016,18.3),(78137,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78137,32.48,NULL,31.4,30536,NULL,NULL,NULL,'TOLOLO 1108+098',NULL,'2015AstBu..70....1K',2015,1,0.56,NULL,'G',0.000008,NULL,'15.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,167.727166667,9.62183,0.037,NULL,60300902067,942201594,14721899,15.2),(78138,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78138,37.3,0.46,288,30537,70,NULL,NULL,'2MASX J11105485+1502478',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,167.728458333,15.04667,0,NULL,61142584562,955352883,14927388,17.4),(78139,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78139,31.05,NULL,16.2,30538,NULL,NULL,NULL,'CGCG 011-018',NULL,'2015AstBu..70....1K',2015,1,0.9,NULL,'G',0.000024,NULL,'15.3',0.3,'dIn',NULL,NULL,NULL,NULL,1,167.7289583,1.09308,0.101,NULL,60284553179,941946143,14717908,15.3),(78140,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78140,37.22,0.27,278,30539,70,NULL,NULL,'2MASX J11105507+1340528',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000185,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,167.7295417,13.68122,0,NULL,61138127857,955283247,14926300,17.4),(78141,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78141,37.6,0.46,332,30540,70,NULL,NULL,'2MASX J11105581+1545298',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.99',0.18,NULL,NULL,NULL,NULL,NULL,1,167.732375,15.75836,0,NULL,61142764100,955355689,14927432,17.99),(78142,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78142,35.95,0.1,155,30541,70,NULL,NULL,'NGC 3558',NULL,'2015arXiv151105856S',2015,1,0.97,NULL,'G',0.000077,NULL,'14.3g',0.86,'S0p','Group member',NULL,NULL,NULL,1,167.7327917,28.54381,0,NULL,60610966457,947046350,14797599,14.3),(78143,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78143,35.97,0.46,157,30542,70,NULL,NULL,'2MASX J11105588+0402307',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000164,NULL,'16.1g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,167.733,4.04186,0.129,NULL,60288726945,942011358,14718927,16.1),(78144,'IRAS','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78144,32.75,0.8,35.5,30543,75,NULL,'MAT, I','ESO 377- G 021',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000017,NULL,'13.79',0.8,'SAB(r)b:       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,167.735375,-35.98347,0.301,NULL,41375830831,646497356,10101521,13.79),(78145,'IRAS','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78145,32.77,0.8,35.7,30543,75,NULL,'HMCL, I','ESO 377- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78146,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78146,32.39,0.32,30.1,30543,85,NULL,'I, raw','ESO 377- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78147,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78147,32.41,0.32,30.3,30543,85,NULL,'I, inv','ESO 377- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78148,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78148,32.58,0.38,32.8,30543,NULL,NULL,NULL,'ESO 377- G 021',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78149,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78149,32.62,0.43,33.5,30543,75,NULL,'MAT, I, raw','ESO 377- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78150,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78150,32.73,0.43,35.2,30543,75,NULL,'MAT, I, inv','ESO 377- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78151,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78151,32.86,0.43,37.3,30543,75,NULL,'MAT, I, cor','ESO 377- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78152,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78152,32.88,0.2,37.7,30543,74.4,NULL,NULL,'ESO 377- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78153,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78153,32.88,0.43,37.7,30543,75,NULL,'3.6 micron, color corrected','ESO 377- G 021',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78154,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78154,32.89,0.43,37.9,30543,75,NULL,'3.6 micron, color + selection bias corrected','ESO 377- G 021',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78155,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78155,33.15,0.4,42.7,30543,75,NULL,'HMCL, I, raw','ESO 377- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78156,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78156,33.28,0.4,45.4,30543,75,NULL,'HMCL, I, inv','ESO 377- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78157,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78157,33.31,0.4,46,30543,75,NULL,'HMCL, I, cor','ESO 377- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78158,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78158,33.32,0.1,46.2,30543,NULL,NULL,NULL,'ESO 377- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78159,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78159,37.12,0.23,266,30544,70,NULL,NULL,'2MASX J11105675+1003379',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,167.736333,10.06047,0.033,NULL,60297984850,942156013,14721187,17.6),(78160,'IRAS','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78160,33.25,0.8,44.8,30545,75,NULL,'A82, H','NGC 3549',NULL,'1997ApJS..109..333W',1997,1,3.32,NULL,'G',0.00002,NULL,'12.8g',0.91,'SA(s)c:','Possible field galaxy',NULL,NULL,NULL,1,167.7369583,53.38778,0,NULL,61786142604,965408478,15084507,12.8),(78161,'IRAS','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78161,33.27,0.8,45,30545,75,NULL,'CF, r','NGC 3549',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78162,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78162,32.51,0.38,31.8,30545,75,NULL,'CF, r, raw','NGC 3549',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78163,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78163,32.63,0.38,33.6,30545,75,NULL,'CF, r, inv','NGC 3549',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78164,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78164,32.74,0.38,35.3,30545,75,NULL,'CF, r, cor','NGC 3549',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78165,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78165,32.88,0.46,37.7,30545,NULL,NULL,'J','NGC 3549',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78166,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78166,32.9,0.36,38,30545,NULL,NULL,NULL,'NGC 3549',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78167,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78167,32.91,0.47,38.2,30545,NULL,NULL,'H','NGC 3549',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78168,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78168,32.98,0.45,39.5,30545,NULL,NULL,'K','NGC 3549',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78169,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78169,33.11,0.47,41.8,30545,75,NULL,'A82, H, raw','NGC 3549',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78170,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78170,33.11,0.2,41.9,30545,74.4,NULL,NULL,'NGC 3549',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78171,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78171,33.11,0.43,42,30545,75,NULL,'3.6 micron, color corrected','NGC 3549',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78172,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78172,33.15,0.39,42.6,30545,NULL,NULL,'Malmquist cor.','NGC 3549',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78173,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78173,33.17,0.4,43,30545,75,NULL,'B','NGC 3549',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78174,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78174,33.2,0.4,43.7,30545,NULL,NULL,'mean','NGC 3549',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78175,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78175,33.24,0.47,44.4,30545,75,NULL,'A82, H, cor','NGC 3549',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78176,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78176,33.25,0.43,44.7,30545,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3549',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78177,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78177,33.26,0.47,44.9,30545,75,NULL,'A82, H, inv','NGC 3549',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78178,'Tully-Fisher','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78178,33.31,0.36,45.9,30545,NULL,NULL,NULL,'NGC 3549',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78179,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78179,37.61,0.46,332,30546,70,NULL,NULL,'2MASX J11105722+0859559',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.69',0.19,NULL,NULL,NULL,NULL,NULL,1,167.738458333,8.99878,0.041,NULL,60300430755,942194230,14721784,17.69),(78180,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78180,38.34,0.46,467,30547,70,NULL,NULL,'SDSS J111057.90+001216.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000084,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,167.741333333,0.20458,0.109,NULL,60281310998,941895484,14717116,18.5),(78181,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,NULL,78181,36.01,0.57,159,30548,70,NULL,NULL,'LCRS B110826.0-055447',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'16.66',0.3,NULL,NULL,NULL,NULL,NULL,1,167.7425,-6.18481,0.081,NULL,40890626513,638916039,9983063,16.66),(78182,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78182,36.9,0.33,240,30549,70,NULL,NULL,'2MASX J11105831+3917171',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00017,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,167.743041667,39.28806,0.036,NULL,63936339891,999005310,15609457,16.4),(78183,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78183,37.97,0.33,392,30550,70,NULL,NULL,'2MASX J11105861+0049377',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000085,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,167.74425,0.82722,0.113,NULL,60284697531,941948398,14717943,18.3),(78184,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78184,35.95,0.1,155,30551,70,NULL,NULL,'2MASX J11105865+2840384',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000073,NULL,'16.0g',0.33,'S0','Group member',NULL,NULL,NULL,1,167.74425,28.67733,0,NULL,60611758270,947058722,14797792,16),(78185,'FP','2016-12-15 15:14:44','2016-12-16 11:19:53','1',NULL,'R',78185,37.46,0.33,311,30552,70,NULL,NULL,'2MASX J11105885+0235557',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000154,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,167.7452083,2.59886,0.097,NULL,60296161856,942127529,14720742,17.4),(78186,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78186,37.22,0.27,278,30553,70,NULL,NULL,'2MASX J11105918+1341288',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,167.746791667,13.69133,0,NULL,61138138179,955283409,14926303,17.7),(78187,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78187,35.95,0.1,155,30554,70,NULL,NULL,'2MASX J11105941+2844424',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00009,NULL,'16.1g',0.27,'S0','Group member',NULL,NULL,NULL,1,167.747583333,28.74514,0,NULL,60611757241,947058706,14797792,16.1),(78188,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78188,37.22,0.27,278,30555,70,NULL,NULL,'2MASX J11105994+1340028',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000195,NULL,'15.5g',0.54,'BrClG',NULL,NULL,NULL,NULL,1,167.749833,13.66733,0,NULL,61138138369,955283412,14926303,15.5),(78189,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78189,38.05,0.17,408,30556,70,NULL,NULL,'2MASX J11110008+0107367',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000087,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,167.750167,1.12689,0.101,NULL,60284566743,941946355,14717911,17.4),(78190,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78190,37.13,0.46,266,30557,70,NULL,NULL,'2MASX J11110133+1030549',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.0002,NULL,'15.6g',0.51,'BrClG',NULL,NULL,NULL,NULL,1,167.755417,10.51522,0.021,NULL,60298325622,942161337,14721270,15.6),(78191,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78191,37.26,0.46,283,30558,70,NULL,NULL,'SDSS J111101.36+080617.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,167.7557083,8.10481,0.069,NULL,60311114022,942361156,14724393,18.1),(78192,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78192,35.89,0.46,151,30559,70,NULL,NULL,'CGCG 126-001',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.00009,NULL,'15.3g',0.45,NULL,NULL,NULL,NULL,NULL,1,167.7592083,25.90686,0,NULL,60603401108,946928142,14795752,15.3),(78193,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78193,36.87,0.46,237,30560,70,NULL,NULL,'2MASX J11110261+4459117',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000138,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,167.761083333,44.98661,0,NULL,63951934161,999248971,15613265,17.4),(78194,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78194,38.38,0.46,475,30561,70,NULL,NULL,'SDSS J111103.09+413628.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,167.762917,41.60794,0,NULL,63926680817,998854387,15607099,18.3),(78195,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78195,35.47,0.46,124,30562,70,NULL,NULL,'CGCG 096-008',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.001,NULL,'15.7',0.31,NULL,NULL,NULL,NULL,NULL,1,167.767083333,19.38625,0,NULL,61093662733,954588480,14915445,15.7),(78196,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78196,36.72,0.14,221,30563,70,NULL,NULL,'MCG +10-16-073',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.000193,NULL,'15.2g',0.57,'E0',NULL,NULL,NULL,NULL,1,167.7712917,57.14231,0,NULL,61992992210,968640503,15135007,15.2),(78197,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78197,36.78,0.46,227,30564,70,NULL,NULL,'CGCG 039-046',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000204,NULL,'16.0g',0.35,'E?             AGN',NULL,NULL,NULL,NULL,1,167.773375,3.74933,0.125,NULL,60288846169,942013221,14718956,16),(78198,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78198,37.6,0.33,331,30565,70,NULL,NULL,'2MASX J11110606+3925002',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,167.77525,39.41672,0.034,NULL,63936391040,999006110,15609470,17.2),(78199,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78199,38.05,0.17,408,30566,70,NULL,NULL,'SDSS J111106.18+010048.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000079,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,167.77575,1.01342,0.101,NULL,60284720752,941948761,14717949,18),(78200,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78200,36.22,0.62,176,30567,70,NULL,NULL,'2MASX J11110625-0718093',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.07',0.33,NULL,NULL,NULL,NULL,NULL,1,167.7762083,-7.30264,0.073,NULL,40893160075,638955626,9983681,16.07),(78201,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78201,34.4,0.69,76,30568,100,NULL,'mid-IR','IC 0674',NULL,'2013ApJ...771...88L',2013,1,1.34,NULL,'G',0.000037,NULL,'14.2g',0.58,'Sab',NULL,NULL,NULL,NULL,1,167.7765,43.633,0,NULL,63953351971,999271124,15613611,14.2),(78202,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78202,35.15,0.47,107,30568,NULL,NULL,'H','IC 0674',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78203,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78203,35.23,0.4,111,30568,NULL,NULL,'mean','IC 0674',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78204,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78204,35.28,0.45,114,30568,NULL,NULL,'K','IC 0674',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78205,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78205,35.29,0.46,114,30568,NULL,NULL,'J','IC 0674',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78206,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78206,36.54,0.33,203,30569,70,NULL,NULL,'2MASX J11110671+0734599',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000189,NULL,'15.9g',0.43,'E0',NULL,NULL,NULL,NULL,1,167.778083333,7.58328,0.065,NULL,60307689205,942307643,14723556,15.9),(78207,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78207,35.06,0.46,103,30570,70,NULL,NULL,'2MASX J11110693+0228477',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.001014,NULL,'15.9g',0.37,'Sy',NULL,NULL,NULL,NULL,1,167.778916667,2.48,0.097,NULL,60296204792,942128199,14720753,15.9),(78208,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78208,35.51,0.5,127,30571,70,NULL,NULL,'2MASX J11110740-4427252',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,167.780833,-44.45694,0.581,NULL,41942241911,655347529,10239805,16.5),(78209,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78209,35.26,0.46,113,30572,70,NULL,NULL,'CGCG 039-047',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000174,NULL,'16.0g',0.3,'S0/a',NULL,NULL,NULL,NULL,1,167.781583,4.33786,0.133,NULL,60285068601,941954196,14718034,16),(78210,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78210,37.59,0.11,329,30573,70,NULL,NULL,'SDSS J111107.71+393743.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,167.782167,39.62875,0,NULL,63936184978,999002890,15609420,18.3),(78211,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78211,36.9,0.33,240,30574,70,NULL,NULL,'SDSS J111107.88+391728.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,167.782875,39.29122,0.036,NULL,63936336544,999005258,15609457,17.8),(78212,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78212,37.85,0.46,371,30575,70,NULL,NULL,'SDSS J111108.23+505249.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00013,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,167.784333333,50.88053,0,NULL,61780739016,965324047,15083188,18.5),(78213,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78213,38.17,0.27,431,30576,70,NULL,NULL,'2MASX J11110850+0541467',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,167.785375,5.69619,0.173,NULL,60315009506,942422023,14725344,17.9),(78214,'BCG','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78214,37.82,0.35,340,30577,60,NULL,'ABELL 1187, BCG','2MASX J11110955+3935522',0.0791,'1980ApJ...241..486H',1980,1,0.6,NULL,'G',0.000103,NULL,'15.6g',0.51,NULL,'Brightest group member',NULL,NULL,NULL,1,167.789917,39.59778,0,NULL,63936185263,999002894,15609420,15.6),(78215,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78215,37.59,0.11,329,30577,70,NULL,NULL,'2MASX J11110955+3935522',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78216,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78216,38.39,0.46,476,30578,70,NULL,NULL,'2MASX J11110962+1219238',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,167.7899583,12.32311,0.006,NULL,61136520869,955258138,14925908,18.2),(78217,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78217,37.86,0.27,373,30579,70,NULL,NULL,'2MASX J11110998+3800002',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000179,NULL,'17.0g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,167.7917083,38.00025,0,NULL,63922474912,998788670,15606072,17),(78218,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78218,37.11,0.27,264,30580,70,NULL,NULL,'2MASX J11111005-0046077',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000075,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,167.791875,-0.76886,0.085,NULL,40906817237,639169019,9987015,17.9),(78219,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78219,36.85,0.46,234,30581,70,NULL,NULL,'2MASX J11111073+0827379',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000162,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,167.794833,8.46047,0.065,NULL,60311074320,942360536,14724383,16.5),(78220,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78220,38.05,0.17,408,30582,70,NULL,NULL,'2MASX J11111094+0106168',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000086,NULL,'17.2g',0.22,'BrClG',NULL,NULL,NULL,NULL,1,167.79575,1.10478,0.101,NULL,60284559303,941946239,14717909,17.2),(78221,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78221,37.09,0.46,262,30583,70,NULL,NULL,'2MASX J11111131+4834275',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,167.797125,48.57444,0,NULL,63916782614,998699728,15604683,16.6),(78222,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78222,37.97,0.33,392,30584,70,NULL,NULL,'2MASX J11111201+0044108',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000079,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,167.8,0.73647,0.113,NULL,60284509580,941945462,14717897,17.9),(78223,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78223,34.65,0.63,85,30585,NULL,NULL,NULL,'2MASX J11111213+2145488',NULL,'2009ApJS..182..474S',2009,1,0.65,NULL,'G',0.000027,NULL,'16.97',0.18,'Sa',NULL,NULL,NULL,NULL,1,167.800541667,21.76372,0,NULL,61087841086,954497516,14914023,16.97),(78224,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78224,34.69,0.2,86.7,30585,74.4,NULL,NULL,'2MASX J11111213+2145488',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78225,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78225,34.88,0.57,94.5,30585,NULL,NULL,'Malmquist cor.','2MASX J11111213+2145488',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78226,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78226,37.59,0.11,329,30586,70,NULL,NULL,'2MASX J11111240+3935502',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000197,NULL,'16.2g',0.41,NULL,NULL,NULL,NULL,NULL,1,167.801625,39.59719,0,NULL,63936184712,999002886,15609420,16.2),(78227,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78227,37.69,0.08,345,30587,70,NULL,NULL,'SDSS J111112.70+405224.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,167.802917,40.87347,0,NULL,63926837183,998856830,15607137,18.2),(78228,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78228,35.78,0.46,143,30588,70,NULL,NULL,'2MASX J11111335+2630383',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000161,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,167.805791667,26.51056,0,NULL,60601976992,946905890,14795404,16.5),(78229,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78229,38.17,0.27,431,30589,70,NULL,NULL,'2MASX J11111513+0542227',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000162,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,167.813083333,5.70639,0.173,NULL,60315009651,942422025,14725344,16.8),(78230,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78230,36.57,0.46,206,30590,70,NULL,NULL,'2MASX J11111560+0519598',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000188,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,167.815041667,5.33347,0.165,NULL,60314960526,942421258,14725332,16.8),(78231,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78231,35.07,0.46,103,30591,70,NULL,NULL,'MCG -01-29-004',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.05',0.35,NULL,NULL,NULL,NULL,NULL,1,167.816791667,-4.84131,0.085,NULL,40911835452,639247428,9988241,14.05),(78232,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78232,38.12,0.46,421,30592,70,NULL,NULL,'2MASX J11111655+0050058',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000088,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,167.819083,0.83486,0.113,NULL,60284513717,941945526,14717898,17.1),(78233,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78233,38.38,0.46,475,30593,70,NULL,NULL,'2MASX J11111657+1602178',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00018,NULL,'18.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,167.819083,16.03842,0,NULL,61112597891,954884342,14920067,18),(78234,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78234,37.65,0.46,339,30594,70,NULL,NULL,'2MASX J11111671+1635378',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000178,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,167.819625,16.59394,0,NULL,61111493733,954867089,14919798,16.4),(78235,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78235,37.18,0.33,273,30595,70,NULL,NULL,'2MASX J11111679+5506497',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,167.820167,55.11367,NULL,NULL,61992419126,968631548,15134867,17.3),(78236,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78236,37.11,0.27,264,30596,70,NULL,NULL,'2MASX J11111692-0049277',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000119,NULL,'15.5g',0.57,'BrClG',NULL,NULL,NULL,NULL,1,167.8204583,-0.82417,0.085,NULL,40906807102,639168860,9987013,15.5),(78237,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78237,37.45,0.33,309,30597,70,NULL,NULL,'2MASX J11111756+3130359',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,167.8232917,31.51017,0,NULL,60638824423,947481631,14804400,17),(78238,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78238,35.46,0.21,123,30598,70,NULL,NULL,'CGCG 039-050',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.000169,NULL,'15.4g',0.45,'E+','Group member',NULL,NULL,NULL,1,167.823916667,3.19797,0.101,NULL,60287564650,941993197,14718643,15.4),(78239,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78239,37.58,0.46,328,30599,70,NULL,NULL,'2MASX J11111821+0703519',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000138,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,167.8257917,7.06442,0.093,NULL,60309444466,942335069,14723985,18.3),(78240,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78240,37.79,0.46,362,30600,70,NULL,NULL,'SDSS J111118.20+265820.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000169,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,167.825833,26.97242,0,NULL,60613403037,947084422,14798194,18.2),(78241,'IRAS','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78241,32.37,0.8,29.7,30601,75,NULL,'A82, H','NGC 3573',NULL,'1997ApJS..109..333W',1997,1,3.6,NULL,'G',0.000026,NULL,'13.3',1,'SA0/a pec sp  LINER?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,167.827375,-36.87553,0.377,NULL,41374666843,646479169,10101237,13.3),(78242,'IRAS','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78242,32.37,0.8,29.8,30601,75,NULL,'HMCL, I','NGC 3573',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78243,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78243,32.94,0.47,38.8,30601,75,NULL,'A82, H, raw','NGC 3573',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78244,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78244,33.16,0.47,42.9,30601,75,NULL,'A82, H, inv','NGC 3573',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78245,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78245,33.17,0.47,43.1,30601,75,NULL,'A82, H, cor','NGC 3573',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78246,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78246,33.25,0.13,44.8,30601,NULL,NULL,NULL,'NGC 3573',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78247,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78247,33.33,0.4,46.2,30601,75,NULL,'HMCL, I, raw','NGC 3573',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78248,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78248,33.5,0.4,50.2,30601,75,NULL,'HMCL, I, cor','NGC 3573',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78249,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78249,33.58,0.4,51.9,30601,75,NULL,'HMCL, I, inv','NGC 3573',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78250,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78250,37.35,0.46,295,30602,70,NULL,NULL,'2MASX J11111877+2730543',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000117,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,167.828333,27.51519,0,NULL,60613612498,947087695,14798245,17.4),(78251,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78251,37.21,0.46,276,30603,70,NULL,NULL,'SDSS J111119.43+383349.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000162,NULL,'18.1g',0.1,NULL,NULL,NULL,NULL,NULL,1,167.831,38.56378,0,NULL,63936071905,999001123,15609392,18.1),(78252,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78252,37.73,0.21,352,30604,70,NULL,NULL,'2MASX J11111952+3030059',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00018,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,167.831416667,30.50169,0,NULL,60657324999,947770703,14808917,17.1),(78253,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78253,37.45,0.33,309,30605,70,NULL,NULL,'2MASX J11112022+3131349',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,167.834375,31.52639,0,NULL,60638823976,947481624,14804400,17.3),(78254,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78254,37.71,0.33,348,30606,70,NULL,NULL,'2MASX J11112120+2414323',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,167.8384583,24.24231,0,NULL,60566794547,946356164,14786815,17.6),(78255,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78255,35.59,0.71,131,30607,70,NULL,NULL,'2MASX J11112128-4509159',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,167.8387917,-45.15436,0.513,NULL,41941783882,655340373,10239693,17.2),(78256,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78256,37.69,0.08,345,30608,70,NULL,NULL,'2MASXi J1111214+405503',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,167.839416667,40.91767,0,NULL,63926844779,998856949,15607139,17.8),(78257,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78257,38.94,0.46,614,30609,70,NULL,NULL,'2MASX J11112159+5701388',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000175,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,167.840083,57.0275,0,NULL,61992953163,968639893,15134998,18.4),(78258,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78258,35.76,0.33,142,30610,70,NULL,NULL,'KUG 1108+265',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000175,NULL,'15.8g',0.42,'Compact',NULL,NULL,NULL,NULL,1,167.843791667,26.25819,0,NULL,60602681383,946916896,14795576,15.8),(78259,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78259,37.22,0.46,278,30611,70,NULL,NULL,'2MASX J11112283+0730245',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,167.84525,7.50686,0.073,NULL,60307580704,942305948,14723530,17.1),(78260,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78260,38.05,0.17,408,30612,70,NULL,NULL,'2MASX J11112381+0109084',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,167.8492917,1.15228,0.101,NULL,60284586659,941946666,14717916,17.4),(78261,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78261,37.59,0.11,329,30613,70,NULL,NULL,'2MASX J11112382+3933433',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000097,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,167.849417,39.56211,0.034,NULL,63936179965,999002811,15609418,17.1),(78262,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78262,36.91,0.46,241,30614,70,NULL,NULL,'2MASX J11112388+4108273',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,167.849667,41.14089,0,NULL,63927362618,998865040,15607266,17.4),(78263,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78263,35.95,0.1,155,30615,70,NULL,NULL,'CGCG 155-091',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000093,NULL,'15.3g',0.43,'S0','Group member',NULL,NULL,NULL,1,167.85075,28.73058,0,NULL,60610445514,947038211,14797472,15.3),(78264,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78264,37.07,0.46,260,30616,70,NULL,NULL,'2MASX J11112453+4404190',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000182,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,167.85225,44.07192,0,NULL,63953810402,999278287,15613723,16.4),(78265,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78265,37.25,0.46,282,30617,70,NULL,NULL,'SDSS J111124.81+655124.3',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000091,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,167.853375,65.85675,0.005,NULL,61812477797,965819965,15090936,16.8),(78266,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78266,37.51,0.46,318,30618,70,NULL,NULL,'2MASX J11112618+3859373',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000184,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,167.8592917,38.99372,0.048,NULL,63936848648,999013260,15609582,17),(78267,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78267,36.79,0.46,228,30619,70,NULL,NULL,'2MASXi J1111264+405620',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00011,NULL,'17.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,167.86025,40.93897,0,NULL,63926845183,998856955,15607139,17.3),(78268,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78268,35.72,0.46,140,30620,70,NULL,NULL,'CGCG 126-002',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.00015,NULL,'14.7g',0.59,NULL,NULL,NULL,NULL,NULL,1,167.861875,22.97078,0,NULL,61089786659,954527916,14914498,14.7),(78269,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78269,34.54,0.33,81,30621,70,NULL,NULL,'UGC 06227',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000163,NULL,'14.2g',0.7,'S0-:','in a radial-velocity based grouping',NULL,NULL,NULL,1,167.8640417,47.03553,0,NULL,63948057667,999188401,15612318,14.2),(78270,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78270,37.69,0.08,345,30622,70,NULL,NULL,'2MASX J11112760+4056483',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,167.8652083,40.94678,0,NULL,63926844947,998856952,15607139,17.1),(78271,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78271,35.65,0.37,135,30623,NULL,NULL,'Malmquist cor.','ESO 438- G 011',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.00003,NULL,'15.18',0.6,'S?',NULL,NULL,NULL,NULL,1,167.867167,-31.10653,0.313,NULL,41600712313,650011129,10156423,15.18),(78272,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78272,35.71,0.36,139,30623,NULL,NULL,NULL,'ESO 438- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78273,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78273,35.75,0.2,141,30623,74.4,NULL,NULL,'ESO 438- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78274,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78274,38.12,0.46,420,30624,70,NULL,NULL,'2MASX J11112821+0232264',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000177,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,167.8674583,2.54072,0.081,NULL,60296181330,942127833,14720747,17.5),(78275,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78275,38.08,0.46,413,30625,70,NULL,NULL,'2MASX J11112828+1342488',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,167.86775,13.71364,0,NULL,61138088871,955282638,14926291,17.8),(78276,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78276,32.71,NULL,34.8,30626,NULL,NULL,NULL,'UGC 06233',NULL,'2015AstBu..70....1K',2015,1,1.14,NULL,'G',0.00006,NULL,'14.6g',0.41,'SA(r)0/a:',NULL,NULL,NULL,NULL,1,167.8677917,6.9075,0.101,NULL,60309578800,942337168,14724018,14.6),(78277,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78277,35.46,0.21,123,30627,70,NULL,NULL,'CGCG 039-052',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000127,NULL,'15.7g',0.34,'S0^0^','Group member',NULL,NULL,NULL,1,167.869625,3.27153,0.101,NULL,60287532043,941992688,14718635,15.7),(78278,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78278,38.42,0.46,482,30628,70,NULL,NULL,'2MASX J11112879+1938437',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,167.8697917,19.64561,0,NULL,61093609073,954587641,14915431,17.4),(78279,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78279,36.72,0.14,221,30629,70,NULL,NULL,'2MASX J11112955+5700018',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000179,NULL,'16.1g',0.29,'S0^-',NULL,NULL,NULL,NULL,1,167.873,57.00058,0,NULL,61992953064,968639891,15134998,16.1),(78280,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78280,37.86,0.27,373,30630,70,NULL,NULL,'2MASX J11112969+3755023',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000138,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,167.8737083,37.91742,0,NULL,63922265087,998785391,15606021,17.5),(78281,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78281,38.17,0.27,431,30631,70,NULL,NULL,'SDSS J111130.13+054043.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,167.875583,5.67869,0.173,NULL,60314173382,942408959,14725139,18.2),(78282,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78282,33.24,0.47,44.5,30632,70,NULL,NULL,'NGC 3544',NULL,'2014MNRAS.445.2677S',2014,1,3,NULL,'G',0.000023,NULL,'12.99',1,'(R)SAB:(rs)a',NULL,NULL,NULL,NULL,1,167.876958333,-18.2895,0.137,NULL,41716751231,651824237,10184753,12.99),(78283,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78283,31.97,0.46,24.8,30632,NULL,NULL,'J','NGC 3544',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78284,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78284,32,0.47,25.1,30632,NULL,NULL,'H','NGC 3544',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78285,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78285,32.04,0.45,25.5,30632,NULL,NULL,'K','NGC 3544',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78286,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78286,33.6,0.4,52.4,30632,NULL,NULL,'mean','NGC 3544',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78287,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78287,38.04,0.46,406,30633,70,NULL,NULL,'2MASX J11113085+2721531',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000142,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,167.8787083,27.36494,0,NULL,60613602718,947087542,14798242,18.4),(78288,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78288,37.12,0.46,266,30634,70,NULL,NULL,'2MASX J11113088+4538350',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000173,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,167.87875,45.64314,0,NULL,63952219717,999253433,15613334,16.5),(78289,'Sosies','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78289,30.9,0.47,15.1,30635,NULL,NULL,NULL,'MESSIER 108',NULL,'2002A&A...393...57T',2002,1,8.7,NULL,'G',0.00003,NULL,'10.69',2.2,'SB(s)cd        HII','Isolated galaxy',NULL,NULL,NULL,1,167.879041667,55.67411,0,NULL,61992602602,968634415,15134912,10.69),(78290,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78290,29.6,0.4,8.3,30635,73,NULL,'IR','MESSIER 108',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78291,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78291,29.6,0.4,8.33,30635,75,NULL,NULL,'MESSIER 108',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78292,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78292,29.69,NULL,8.67,30635,NULL,NULL,'LEDA [April 2006]','MESSIER 108',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78293,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78293,29.72,0.43,8.8,30635,75,NULL,'3.6 micron, color + selection bias corrected','MESSIER 108',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78294,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78294,29.84,0.43,9.3,30635,75,NULL,'3.6 micron, color corrected','MESSIER 108',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78295,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78295,29.98,NULL,9.91,30635,NULL,NULL,NULL,'MESSIER 108',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78296,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78296,30,0.2,10,30635,74.4,NULL,NULL,'MESSIER 108',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78297,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78297,30.14,0.35,10.7,30635,NULL,NULL,NULL,'MESSIER 108',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78298,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78298,30.47,0.1,12.4,30635,NULL,NULL,NULL,'MESSIER 108',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78299,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78299,30.74,0.4,14.1,30635,75,NULL,'B','MESSIER 108',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78300,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78300,31.29,0.49,18.1,30635,75,NULL,'IR','MESSIER 108',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78301,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78301,31.43,0.4,19.3,30635,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 2 galaxy group','MESSIER 108',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78302,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78302,34.78,0.68,90.2,30636,NULL,NULL,NULL,'ESO 377- G 023',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.25',0.3,'S...',NULL,NULL,NULL,NULL,1,167.884083,-33.79192,0.341,NULL,41572561307,649571270,10149551,16.25),(78303,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78303,34.82,0.2,92,30636,74.4,NULL,NULL,'ESO 377- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78304,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78304,34.91,0.65,95.8,30636,NULL,NULL,'Malmquist cor.','ESO 377- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78305,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78305,36.19,0.46,173,30637,70,NULL,NULL,'CGCG 039-059',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000107,NULL,'15.2g',0.53,'E',NULL,NULL,NULL,NULL,1,167.8857083,6.44061,0.121,NULL,60306498642,942289041,14723266,15.2),(78306,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78306,37.06,0.46,258,30638,70,NULL,NULL,'2MASX J11113275+3003259',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000156,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,167.886291667,30.05714,0.009,NULL,60657674484,947776163,14809002,17.2),(78307,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78307,38.03,0.46,404,30639,70,NULL,NULL,'2MASX J11113329+0610355',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,167.888833,6.17656,0.129,NULL,60306732051,942292688,14723323,17.5),(78308,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78308,37.6,0.33,331,30640,70,NULL,NULL,'2MASX J11113358+3921303',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000202,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,167.89,39.3585,0.034,NULL,63936358120,999005595,15609462,16.7),(78309,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78309,36.65,0.46,214,30641,70,NULL,NULL,'2MASX J11113382+3251529',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000173,NULL,'16.3g',0.33,'AGN',NULL,NULL,NULL,NULL,1,167.89075,32.86489,0.045,NULL,60648969522,947640148,14806877,16.3),(78310,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78310,36.47,0.46,197,30642,70,NULL,NULL,'2MASX J11113415+0501324',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000185,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,167.892417,5.02567,0.165,NULL,60284800550,941950008,14717968,16.7),(78311,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78311,38.03,0.46,404,30643,70,NULL,NULL,'2MASX J11113458+3849033',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,167.894125,38.81775,0,NULL,63936844416,999013194,15609581,17.6),(78312,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78312,37.31,0.46,289,30644,70,NULL,NULL,'2MASX J11113470+3338149',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,167.89475,33.63747,0,NULL,60648734523,947636476,14806819,17.1),(78313,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78313,38.09,0.46,415,30645,70,NULL,NULL,'2MASX J11113495+0535064',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000164,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,167.895667,5.58522,0.189,NULL,60314215796,942409621,14725150,17.5),(78314,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78314,37.69,0.08,345,30646,70,NULL,NULL,'SDSS J111135.06+404553.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000171,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,167.896125,40.76492,0,NULL,63926888287,998857629,15607150,18.4),(78315,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78315,35.76,0.33,142,30647,70,NULL,NULL,'CGCG 156-016 NED01',NULL,'2015arXiv151105856S',2015,1,0.87,NULL,'G',0.000211,NULL,'15.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,167.8962917,26.30739,0,NULL,60602481980,946913780,14795527,15.2),(78316,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78316,37.69,0.08,345,30648,70,NULL,NULL,'2MASX J11113521+4108163',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000155,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,167.896625,41.13789,0,NULL,63927362901,998865045,15607266,17.2),(78317,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78317,36.11,0.19,167,30649,70,NULL,NULL,'MRK 1285',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',NULL,NULL,'17.0',0.3,'Compact',NULL,NULL,NULL,NULL,1,167.897375,22.18394,0,NULL,61087235423,954488053,14913875,17),(78318,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78318,36.44,0.62,194,30650,70,NULL,NULL,'2MASX J11113555-0700436',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,167.8982083,-7.01208,0.105,NULL,40893861442,638966585,9983852,16.8),(78319,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78319,36.07,0.53,164,30651,70,NULL,NULL,'2MASX J11113615-0737376',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.52',NULL,NULL,NULL,NULL,NULL,NULL,1,167.900708333,-7.62711,0.065,NULL,40893388721,638959198,9983737,16.52),(78320,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78320,37.32,0.33,291,30652,70,NULL,NULL,'2MASX J11113641+4230130',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000175,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,167.901625,42.50375,0,NULL,63952883609,999263806,15613496,16.8),(78321,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78321,37.73,0.46,352,30653,70,NULL,NULL,'2MASX J11113646+3010069',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,167.9017083,30.16847,0,NULL,60657787868,947777935,14809030,17.4),(78322,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78322,37.73,0.21,352,30654,70,NULL,NULL,'2MASX J11113724+3030449',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000182,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,167.905125,30.51236,0,NULL,60657443973,947772562,14808946,17.3),(78323,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78323,36.07,0.46,164,30655,70,NULL,NULL,'2MASX J11113814+2640591',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000167,NULL,'16.0g',0.37,NULL,NULL,NULL,NULL,NULL,1,167.909041667,26.68306,0,NULL,60613254027,947082094,14798157,16),(78324,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78324,36.76,0.46,225,30656,70,NULL,NULL,'2MASX J11113838+3706043',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.70',0.24,NULL,NULL,NULL,NULL,NULL,1,167.909833,37.10119,0,NULL,60417850139,944028908,14750451,16.7),(78325,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78325,37.66,0.46,341,30657,70,NULL,NULL,'2MASX J11113871+5336157',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000158,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,167.911333,53.60439,0,NULL,61785963433,965405678,15084463,17.2),(78326,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78326,37.67,0.46,342,30658,70,NULL,NULL,'2MASX J11113953+1933032',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.12',0.15,NULL,NULL,NULL,NULL,NULL,1,167.914666667,19.55092,0,NULL,61093667835,954588559,14915446,18.12),(78327,'BCG','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78327,37.82,0.35,340,30659,60,NULL,NULL,'ABELL 1187',0.0791,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,167.915417,39.57819,0.034,NULL,63936181792,999002840,15609419,NULL),(78328,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78328,37.69,0.08,345,30660,70,NULL,NULL,'MCG +07-23-030',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000103,NULL,'15.8g',0.47,'E0',NULL,NULL,'NAT',NULL,1,167.915583,40.84006,0,NULL,63926891423,998857678,15607151,15.8),(78329,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78329,37.69,0.08,345,30661,70,NULL,NULL,'2MASX J11113997+4100463',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,167.916583333,41.01297,0,NULL,63927360304,998865004,15607265,18),(78330,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78330,36.97,0.46,247,30662,70,NULL,NULL,'2MASX J11114002+0206304',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.50',0.33,NULL,NULL,NULL,NULL,NULL,1,167.916875,2.10836,0.097,NULL,60295810364,942122036,14720656,16.5),(78331,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78331,37.18,0.33,273,30663,70,NULL,NULL,'2MASX J11114013+5511417',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,167.917667,55.19483,NULL,NULL,61992701962,968635968,15134937,17.7),(78332,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78332,37.1,0.46,263,30664,70,NULL,NULL,'2MASX J11114041+3959593',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,167.918416667,39.99978,0,NULL,63937183856,999018497,15609664,17.3),(78333,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78333,37.69,0.08,345,30665,70,NULL,NULL,'2MASX J11114046+4047073',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.0002,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,167.918666667,40.78525,0,NULL,63926892159,998857689,15607151,16.4),(78334,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78334,34.36,0.49,74.6,30666,75,NULL,'IR','FGC 1204',NULL,'2011yCatp016004901K',2011,1,1.05,NULL,'G',0.000053,NULL,'16.4g',0.18,'Sd',NULL,NULL,NULL,NULL,1,167.919,45.35031,0,NULL,63952291658,999254557,15613352,16.4),(78335,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78335,34.76,NULL,89.5,30666,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1204',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78336,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78336,34.77,NULL,90.1,30666,NULL,NULL,'Dipole + Quadrupole','FGC 1204',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78337,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78337,34.79,NULL,90.7,30666,NULL,NULL,'Dipole','FGC 1204',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78338,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78338,34.82,NULL,92.1,30666,NULL,NULL,NULL,'FGC 1204',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78339,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78339,35.83,0.46,146,30667,70,NULL,NULL,'CGCG 039-061',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.000163,NULL,'14.9g',0.58,'E0',NULL,NULL,NULL,NULL,1,167.919458333,4.66886,0.141,NULL,60285732573,941964571,14718196,14.9),(78340,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78340,37.43,0.46,306,30668,70,NULL,NULL,'2MASX J11114164+2016112',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.00',0.14,NULL,NULL,NULL,NULL,NULL,1,167.923667,20.26981,0,NULL,61093166882,954580732,14915323,18),(78341,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78341,37.69,0.08,345,30669,70,NULL,NULL,'2MASX J11114317+4043352',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,167.929833,40.72639,0,NULL,63926850799,998857043,15607141,17.5),(78342,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78342,36.14,0.46,169,30670,70,NULL,NULL,'2MASX J11114322+3356569',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,167.929958333,33.94919,0,NULL,60646849160,947607018,14806359,16.5),(78343,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78343,37.05,0.46,257,30671,70,NULL,NULL,'2MASX J11114323+3231099',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000172,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,167.9302083,32.51931,0.022,NULL,60646224538,947597258,14806207,16.6),(78344,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78344,37.54,0.33,322,30672,70,NULL,NULL,'2MASX J11114359+0930226',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000189,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,167.9315,9.50622,0.041,NULL,60299784246,942184128,14721627,17.2),(78345,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78345,36.72,0.14,221,30673,70,NULL,NULL,'2MASX J11114474+5702027',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000201,NULL,'16.1g',0.29,'S0',NULL,NULL,NULL,NULL,1,167.936667,57.03417,0,NULL,61992959964,968639999,15134999,16.1),(78346,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78346,37.69,0.08,345,30674,70,NULL,NULL,'2MASX J11114586+4034432',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000154,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,167.940958333,40.57869,0,NULL,63926913887,998858029,15607156,17.1),(78347,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78347,38.13,0.46,423,30675,70,NULL,NULL,'2MASX J11114640+5857237',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000156,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,167.9435,58.95647,0,NULL,61996543156,968695986,15135874,17),(78348,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78348,35.95,0.1,155,30676,70,NULL,NULL,'CGCG 156-017',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000073,NULL,'15.1g',0.55,NULL,'Group member',NULL,NULL,NULL,1,167.94675,28.26731,0,NULL,60610355025,947036797,14797449,15.1),(78349,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78349,37.54,0.33,322,30677,70,NULL,NULL,'2MASX J11114731+0933506',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000181,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,167.947167,9.56403,0.041,NULL,60299786562,942184165,14721627,16.9),(78350,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78350,37,0.56,251,30678,70,NULL,NULL,'2MASX J11114892-0731346',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00012,NULL,'15.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,167.953916667,-7.52631,0.065,NULL,40893194707,638956167,9983690,15.4),(78351,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78351,37.59,0.11,329,30679,70,NULL,NULL,'SDSS J111150.18+394712.0',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,167.959083,39.78667,0.073,NULL,63936147135,999002298,15609410,17.7),(78352,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78352,37.69,0.08,345,30680,70,NULL,NULL,'2MASX J11115037+4046132',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000103,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,167.959833,40.77044,0,NULL,63926891933,998857686,15607151,17.1),(78353,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78353,37.69,0.08,345,30681,70,NULL,NULL,'2MASX J11115132+4054363',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000188,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,167.964,40.91014,0,NULL,63926885934,998857592,15607149,17.5),(78354,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78354,36.64,0.33,213,30682,70,NULL,NULL,'2MASX J11115155+2711561',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000093,NULL,'15.3g',0.54,'E',NULL,NULL,NULL,NULL,1,167.964833333,27.19889,0,NULL,60613279166,947082486,14798163,15.3),(78355,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78355,36.5,0.54,200,30683,70,NULL,NULL,'2MASX J11115174-4548260',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.4I',0.7,NULL,NULL,NULL,NULL,NULL,1,167.965583,-45.80725,0.705,NULL,41941341230,655333456,10239585,13.4),(78356,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78356,35.95,0.1,155,30684,70,NULL,NULL,'2MASX J11115186+2756161',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000103,NULL,'16.3g',0.32,NULL,'Group member',NULL,NULL,NULL,1,167.966,27.93786,0,NULL,60615571554,947118305,14798723,16.3),(78357,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78357,37.45,0.46,309,30685,70,NULL,NULL,'2MASX J11115238+0653585',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,167.9682917,6.89944,0.097,NULL,60309629763,942337965,14724030,16.8),(78358,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78358,37.46,0.33,311,30686,70,NULL,NULL,'2MASX J11115383+0228587',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000211,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,167.974417,2.48283,0.081,NULL,60295384892,942115388,14720552,16.5),(78359,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78359,38.31,0.46,459,30687,70,NULL,NULL,'2MASX J11115443+0038447',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000089,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,167.97675,0.64572,0.125,NULL,60281193805,941893653,14717088,17.2),(78360,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78360,37.59,0.11,329,30688,70,NULL,NULL,'2MASX J11115499+3957513',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000183,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,167.979083333,39.96425,0.034,NULL,63928009502,998875148,15607424,16.7),(78361,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78361,37.65,0.46,339,30689,70,NULL,NULL,'2MASX J11115512+4417290',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000203,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,167.97975,44.29139,0,NULL,63953904687,999279760,15613746,16.6),(78362,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78362,37.8,0.46,363,30690,70,NULL,NULL,'SDSS J111155.14+551606.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000147,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,167.97975,55.26853,NULL,NULL,61992713626,968636150,15134939,18.6),(78363,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78363,37.59,0.11,329,30691,70,NULL,NULL,'2MASX J11115562+3948123',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000133,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,167.9817917,39.80331,0.073,NULL,63936144902,999002264,15609410,17.2),(78364,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78364,37.48,0.46,313,30692,70,NULL,NULL,'2MASX J11115664+5554496',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00018,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,167.9860417,55.91392,0,NULL,61995666136,968682283,15135660,17),(78365,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78365,37.69,0.08,345,30693,70,NULL,NULL,'2MASX J11115669+4016203',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,167.986208333,40.27222,0,NULL,63926754467,998855538,15607117,17.6),(78366,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78366,36.72,0.14,221,30694,70,NULL,NULL,'2MASX J11115703+5704446',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00018,NULL,'15.9g',0.49,'AGN',NULL,NULL,NULL,NULL,1,167.9877917,57.079,0,NULL,61992951605,968639868,15134997,15.9),(78367,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78367,37.21,0.46,276,30695,70,NULL,NULL,'SDSS J111158.29+460525.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,167.992917,46.09039,0,NULL,63947812614,999184572,15612258,17.9),(78368,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78368,37.73,0.21,352,30696,70,NULL,NULL,'SDSS J111158.81+302807.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,167.995083,30.46886,0,NULL,60657320498,947770632,14808916,18),(78369,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78369,37.59,0.11,329,30697,70,NULL,NULL,'2MASX J11115891+3952553',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,167.9955417,39.88211,0.073,NULL,63928023169,998875362,15607427,17.9),(78370,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78370,35.46,0.21,123,30698,70,NULL,NULL,'UGC 06239',NULL,'2015arXiv151105856S',2015,1,1.01,NULL,'G',0.00017,NULL,'14.2g',0.81,'E','Group member',NULL,NULL,NULL,1,167.996417,3.13578,0.105,NULL,60287718502,941995601,14718681,14.2),(78371,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78371,37.56,0.46,325,30699,70,NULL,NULL,'2MASX J11115953+2957222',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.40',0.16,NULL,NULL,NULL,NULL,NULL,1,167.99825,29.95622,0,NULL,60657758428,947777475,14809023,18.4),(78372,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78372,37.62,0.46,334,30700,70,NULL,NULL,'2MASX J11115991+4025393',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000181,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,167.9997083,40.42775,0,NULL,63926740468,998855319,15607114,17),(78373,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78373,36.62,0.46,211,30701,70,NULL,NULL,'2MASX J11115997+0503497',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000154,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,167.9999583,5.06394,0.165,NULL,60284802369,941950037,14717969,16.6),(78374,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78374,38.23,0.23,443,30702,70,NULL,NULL,'2MASX J11120035+3039542',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000143,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,168.001416667,30.66497,0,NULL,60657438832,947772481,14808945,18.4),(78375,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78375,37.69,0.08,345,30703,70,NULL,NULL,'SDSS J111200.80+403634.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000165,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,168.003333,40.60969,0,NULL,63926920539,998858133,15607158,18),(78376,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78376,38.21,0.46,439,30704,70,NULL,NULL,'2MASX J11120131+5304246',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000154,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,168.005583,53.07356,0,NULL,61786195103,965409298,15084520,17.5),(78377,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78377,35.87,0.46,149,30705,70,NULL,NULL,'SDSS J111201.37+352837.3',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000168,NULL,'16.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,168.00575,35.47703,0,NULL,60416824104,944012876,14750201,16.5),(78378,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78378,38.14,0.46,424,30706,70,NULL,NULL,'2MASX J11120171+4912116',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,168.007125,49.20319,0,NULL,63916699263,998698425,15604662,17.6),(78379,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78379,36.71,0.46,220,30707,70,NULL,NULL,'2MASX J11120176+2750537',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000132,NULL,'16.0g',0.38,NULL,'Group member',NULL,NULL,NULL,1,168.0074583,27.84828,0,NULL,60615614934,947118983,14798734,16),(78380,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78380,35.46,0.21,123,30708,70,NULL,NULL,'CGCG 039-063',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000107,NULL,'15.7g',0.38,'E0','Group member',NULL,NULL,NULL,1,168.007833,3.04442,0.105,NULL,60287690809,941995168,14718674,15.7),(78381,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78381,37.69,0.08,345,30709,70,NULL,NULL,'SDSS J111202.36+403052.2',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.6g',0.31,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,168.009833,40.51453,0,NULL,63926925820,998858215,15607159,16.6),(78382,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78382,38.04,0.46,405,30710,70,NULL,NULL,'2MASX J11120272+0532347',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,168.0112917,5.54292,0.189,NULL,60314342305,942411598,14725181,17.9),(78383,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78383,35.95,0.1,155,30711,70,NULL,NULL,'NGC 3570',NULL,'2015arXiv151105856S',2015,1,1.03,NULL,'G',0.000033,NULL,'14.3g',0.84,'S0',NULL,NULL,NULL,NULL,1,168.0139583,27.58978,0,NULL,60615669918,947119842,14798747,14.3),(78384,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78384,36.16,0.4,171,30711,NULL,NULL,'mean','NGC 3570',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78385,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78385,36.27,0.45,180,30711,NULL,NULL,'K','NGC 3570',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78386,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78386,38.69,0.46,547,30712,70,NULL,NULL,'2MASX J11120435+2842327',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000175,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,168.0182917,28.70931,0,NULL,60610454335,947038348,14797474,17.5),(78387,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78387,36.95,0.46,246,30713,70,NULL,NULL,'2MASX J11120447+3939433',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00009,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,168.018583,39.66192,0.073,NULL,63928034824,998875544,15607430,16.7),(78388,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78388,37.8,0.33,363,30714,70,NULL,NULL,'2MASX J11120462+1031334',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,168.0192917,10.52608,0.017,NULL,60298208515,942159508,14721242,17),(78389,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78389,37.73,0.21,352,30715,70,NULL,NULL,'2MASX J11120471+3028212',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000196,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,168.019667,30.4725,0,NULL,60657795990,947778062,14809032,16.7),(78390,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78390,36.16,0.2,171,30716,74.4,NULL,NULL,'CGCG 067-031',NULL,'2013AJ....146...86T',2013,1,0.62,NULL,'G',0.00012,NULL,'16.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,168.024667,13.30661,0,NULL,61137779437,955277803,14926215,16),(78391,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78391,37.69,0.08,345,30717,70,NULL,NULL,'2MASX J11120596+4032543',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000169,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,168.024875,40.54847,0,NULL,63926926656,998858229,15607159,16.9),(78392,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78392,37.69,0.08,345,30718,70,NULL,NULL,'2MASX J11120658+4113103',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000207,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,168.027625,41.21944,0,NULL,63927393963,998865530,15607273,16.6),(78393,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78393,38.23,0.23,443,30719,70,NULL,NULL,'2MASX J11120670+3040412',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000179,NULL,'16.6g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,168.0280417,30.67828,0,NULL,60657410259,947772035,14808938,16.6),(78394,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78394,35.46,0.21,123,30720,70,NULL,NULL,'CGCG 039-065',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000097,NULL,'15.7g',0.3,'S0','Group member',NULL,NULL,NULL,1,168.02825,3.14336,0.105,NULL,60287730891,941995795,14718684,15.7),(78395,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78395,36.72,0.14,221,30721,70,NULL,NULL,'2MASX J11120735+5703210',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000159,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,168.030583,57.05594,0,NULL,61992950185,968639846,15134997,16.6),(78396,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78396,38.07,0.46,411,30722,70,NULL,NULL,'2MASX J11120737+5257161',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,168.03075,52.95458,0,NULL,61785361364,965396271,15084316,17.5),(78397,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78397,37.69,0.08,345,30723,70,NULL,NULL,'2MASX J11120806+4036013',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000177,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,168.033458333,40.6005,0,NULL,63926922346,998858161,15607158,17.4),(78398,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78398,35.34,0.4,117,30724,NULL,NULL,'mean','NGC 3569',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000073,NULL,'14.29',1,'SA0^0          PEG','Group member',NULL,NULL,NULL,1,168.0337083,35.45214,0,NULL,60416675866,944010560,14750165,14.29),(78399,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78399,36.13,0.45,168,30724,NULL,NULL,'K','NGC 3569',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78400,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78400,37.62,0.46,335,30725,70,NULL,NULL,'2MASX J11120829+0800124',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000173,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,168.0347083,8.00336,0.073,NULL,60306839195,942294362,14723349,17.1),(78401,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78401,36.72,0.14,221,30726,70,NULL,NULL,'2MASX J11120856+5706140',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'16.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,168.035583,57.10392,0,NULL,61993066733,968641667,15135026,16.9),(78402,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78402,38.87,0.46,593,30727,70,NULL,NULL,'SDSS J111208.77+585725.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,168.036583,58.95717,0,NULL,61996548064,968696063,15135875,18.4),(78403,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78403,37.59,0.11,329,30728,70,NULL,NULL,'2MASX J11120949+3942343',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000178,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,168.039375,39.70953,0.073,NULL,63928033907,998875529,15607430,17.3),(78404,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78404,38.42,0.46,482,30729,70,NULL,NULL,'SDSS J111209.84+020800.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,168.0410417,2.13336,0.097,NULL,60282516724,941914323,14717411,18.3),(78405,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78405,37.12,0.46,266,30730,70,NULL,NULL,'2MASX J11121033+1139344',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000211,NULL,'16.0g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,168.0429583,11.65964,0,NULL,61136393169,955256143,14925877,16),(78406,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78406,38.23,0.23,443,30731,70,NULL,NULL,'2MASX J11121081+3034552',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000188,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,168.045167,30.58194,0,NULL,60657404078,947771938,14808936,17.5),(78407,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78407,37.8,0.33,363,30732,70,NULL,NULL,'2MASX J11121114+1030164',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000189,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,168.046416667,10.50456,0.017,NULL,60298214144,942159596,14721243,16.3),(78408,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78408,38.23,0.23,443,30733,70,NULL,NULL,'2MASX J11121135+3043522',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,168.047375,30.73119,0,NULL,60657393326,947771770,14808933,NULL),(78409,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78409,37.83,0.46,368,30734,70,NULL,NULL,'2MASX J11121152+1729441',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000147,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,168.048083,17.49564,0,NULL,61111162418,954861912,14919717,18.1),(78410,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78410,36.52,0.58,201,30735,70,NULL,NULL,'LCRS B110939.5-062734',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.19',0.39,NULL,NULL,NULL,NULL,NULL,1,168.048667,-6.73128,0.093,NULL,40893776939,638965264,9983832,16.19),(78411,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78411,35.95,0.1,155,30736,70,NULL,NULL,'NGC 3574',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000207,NULL,'15.2g',0.56,'S?             AGN',NULL,NULL,NULL,NULL,1,168.050541667,27.62483,0,NULL,60615657989,947119656,14798744,15.2),(78412,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78412,35.83,0.46,147,30737,70,NULL,NULL,'2MASX J11121238+0950004',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000175,NULL,'15.8g',0.33,'S0^-',NULL,NULL,NULL,NULL,1,168.051625,9.83331,0.013,NULL,60300765952,942199468,14721866,15.8),(78413,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78413,37.69,0.08,345,30738,70,NULL,NULL,'2MASX J11121253+4028303',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000153,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,168.052166667,40.47492,0,NULL,63926918562,998858102,15607157,18.2),(78414,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78414,37.03,0.46,255,30739,70,NULL,NULL,'2MASX J11121272+1241212',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000191,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,168.053,12.68942,0,NULL,61136481008,955257515,14925898,16.2),(78415,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78415,37.04,0.46,256,30740,70,NULL,NULL,'2MASX J11121297+4349245',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000167,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,168.0542083,43.82358,0,NULL,63953321809,999270653,15613603,16.9),(78416,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78416,37.47,0.46,312,30741,70,NULL,NULL,'2MASX J11121320+4511395',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000166,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,168.055167,45.19442,0,NULL,63952313546,999254899,15613357,17.1),(78417,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78417,37.71,0.46,348,30742,70,NULL,NULL,'2MASX J11121390+3647113',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,168.058083,36.78642,0,NULL,60417574468,944024601,14750384,17.5),(78418,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78418,35.67,0.68,136,30743,70,NULL,NULL,'2MASX J11121428-1531114',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.40',NULL,NULL,NULL,NULL,NULL,NULL,1,168.05975,-15.52014,0.189,NULL,41698615935,651540873,10180326,16.4),(78419,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78419,37.51,0.46,317,30744,70,NULL,NULL,'SDSS J111215.05+392907.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000148,NULL,'18.6g',0.08,NULL,NULL,NULL,NULL,NULL,1,168.06275,39.48544,0.034,NULL,63928025172,998875393,15607428,18.6),(78420,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78420,36.84,0.46,233,30745,70,NULL,NULL,'2MASX J11121510+4641565',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000171,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,168.063,46.69906,0,NULL,63948438999,999194359,15612411,17.7),(78421,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78421,34.22,NULL,69.7,30746,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1205',NULL,'2010Ap&SS.325..163P',2010,1,1.2,NULL,'G',0.00001,NULL,'16.8g',0.14,'Sc',NULL,NULL,NULL,NULL,1,168.064333,8.62881,0.081,NULL,60299625331,942181645,14721588,16.8),(78422,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78422,34.22,NULL,69.8,30746,NULL,NULL,'Dipole + Quadrupole','FGC 1205',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78423,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78423,34.22,NULL,69.9,30746,NULL,NULL,'Dipole','FGC 1205',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78424,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78424,34.37,NULL,74.9,30746,NULL,NULL,NULL,'FGC 1205',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78425,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78425,34.87,0.2,94.2,30746,74.4,NULL,NULL,'FGC 1205',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78426,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78426,37.85,0.46,372,30747,70,NULL,NULL,'SDSS J111215.77+304621.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00102,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,168.06575,30.77275,0,NULL,60657401112,947771892,14808935,18.5),(78427,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78427,36.64,0.33,213,30748,70,NULL,NULL,'2MASX J11121612+2712147',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000175,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,168.0672083,27.20411,0.013,NULL,60615171058,947112047,14798625,16.4),(78428,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78428,36.72,0.14,221,30749,70,NULL,NULL,'CGCG 291-039',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000147,NULL,'14.8g',0.65,'BrClG',NULL,NULL,NULL,NULL,1,168.069583,57.076,0,NULL,61993070235,968641722,15135026,14.8),(78429,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78429,37.9,0.46,381,30750,70,NULL,NULL,'SDSS J111217.19+372648.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000146,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,168.071667,37.44675,0,NULL,60417112298,944017379,14750271,18.5),(78430,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78430,37.51,0.46,317,30751,70,NULL,NULL,'2MASX J11121720+1417122',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000156,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,168.07175,14.28667,0,NULL,61104748617,954761697,14918151,17.4),(78431,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78431,37.44,0.46,308,30752,70,NULL,NULL,'2MASX J11121737+0104597',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000094,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,168.0722917,1.08331,0.089,NULL,60284405605,941943837,14717872,16.6),(78432,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78432,37.69,0.08,345,30753,70,NULL,NULL,'2MASX J11121742+4052423',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.0001,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,168.07275,40.87856,0,NULL,63926869240,998857331,15607145,17.5),(78433,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78433,38.23,0.33,442,30754,70,NULL,NULL,'2MASX J11121825+6126350',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,168.0757917,61.44317,0,NULL,61858267210,966535425,15102116,17),(78434,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78434,37.53,0.46,321,30755,70,NULL,NULL,'2MASX J11121832+1635582',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000197,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,168.0764583,16.59944,0,NULL,61111508358,954867318,14919801,16.1),(78435,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78435,37.69,0.08,345,30756,70,NULL,NULL,'2MASX J11121842+4031441',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000178,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,168.076667,40.52903,0,NULL,63926917056,998858079,15607157,17.7),(78436,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78436,37.07,0.46,259,30757,70,NULL,NULL,'2MASX J11121838+1714552',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,168.0767083,17.24867,0,NULL,61111879176,954873112,14919892,17),(78437,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78437,36.32,0.46,184,30758,70,NULL,NULL,'2MASX J11121910+5808010',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000183,NULL,'16.0g',0.31,NULL,NULL,NULL,NULL,NULL,1,168.079875,58.13358,0,NULL,61999032794,968734887,15136482,16),(78438,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78438,36.95,0.46,245,30759,70,NULL,NULL,'2MASX J11121939+4803282',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000149,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,168.080667,48.05794,0.013,NULL,63916433323,998694270,15604597,17.4),(78439,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78439,37.15,0.46,269,30760,70,NULL,NULL,'2MASX J11122042+0754136',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000156,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,168.08525,7.90386,0.073,NULL,60306948231,942296066,14723376,16.6),(78440,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78440,37.39,0.46,301,30761,70,NULL,NULL,'2MASX J11122157+5429360',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000188,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,168.0900417,54.49331,0,NULL,61963329679,968177026,15127766,16.5),(78441,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78441,37.73,0.21,352,30762,70,NULL,NULL,'2MASX J11122328+3034486',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000194,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,168.096875,30.58025,0.007,NULL,60657403387,947771927,14808936,16.5),(78442,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78442,38.35,0.46,469,30763,70,NULL,NULL,'2MASX J11122484+0843256',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,168.103583,8.72372,0.081,NULL,60299640414,942181881,14721591,18.4),(78443,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78443,38.23,0.33,442,30764,70,NULL,NULL,'2MASX J11122495+6126250',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,168.1037083,61.44042,0,NULL,61858268109,966535439,15102116,17.3),(78444,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78444,38.42,0.46,484,30765,70,NULL,NULL,'2MASX J11122555+2503227',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,168.106333,25.05653,0,NULL,60599621268,946869082,14794829,18.2),(78445,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78445,37.56,0.46,324,30766,70,NULL,NULL,'2MASX J11122707+3854232',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,168.112833,38.90653,0,NULL,63936791138,999012361,15609568,17.2),(78446,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78446,36.33,0.46,185,30767,70,NULL,NULL,'2MASX J11122733+0346168',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.90',0.23,NULL,NULL,NULL,NULL,NULL,1,168.11375,3.77119,0.109,NULL,60287193578,941987399,14718553,17.9),(78447,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78447,38.02,0.46,401,30768,70,NULL,NULL,'SDSS J111228.14+585033.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,168.1172917,58.84261,0,NULL,61998368256,968724504,15136320,18.2),(78448,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78448,36.4,0.46,190,30769,70,NULL,NULL,'2MASX J11122818+0205428',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000171,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,168.117417,2.09519,0.097,NULL,60282560291,941915004,14717421,16.6),(78449,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78449,35.87,0.86,149,30770,70,NULL,NULL,'2MASX J11122860-4503253',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,168.1192917,-45.05708,0.513,NULL,41941280059,655332500,10239570,17.2),(78450,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78450,37.2,0.46,276,30771,70,NULL,NULL,'2MASX J11122903+0803396',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000151,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,168.120917,8.06097,0.073,NULL,60306959630,942296244,14723378,16.9),(78451,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78451,36.13,0.46,169,30772,70,NULL,NULL,'CGCG 096-009',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.001,NULL,'15.6',0.6,NULL,NULL,NULL,NULL,NULL,1,168.122125,19.81903,0,NULL,61094108084,954595438,14915553,15.6),(78452,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78452,36.14,0.33,169,30773,70,NULL,NULL,'2MASX J11122947+2539096',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000171,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,168.122791667,25.65275,0,NULL,60603104692,946923510,14795679,16.3),(78453,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78453,38.36,0.46,470,30774,70,NULL,NULL,'2MASX J11122992+3116217',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000161,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,168.1247083,31.27264,0.034,NULL,60656349774,947755465,14808679,18),(78454,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78454,37.04,0.46,256,30775,70,NULL,NULL,'2MASX J11123068-0102572',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000102,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,168.127875,-1.04928,0.089,NULL,40906350379,639161724,9986901,16.5),(78455,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78455,38.29,0.46,456,30776,70,NULL,NULL,'SDSS J111233.94+003628.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000073,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,168.141458333,0.60797,0.121,NULL,60281388402,941896693,14717135,18.7),(78456,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78456,37.89,0.46,378,30777,70,NULL,NULL,'2MASX J11123396+0016258',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000079,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,168.1415,0.27383,0.113,NULL,60281439347,941897489,14717148,16.5),(78457,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78457,37.59,0.11,329,30778,70,NULL,NULL,'2MASX J11123511+4009472',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,168.146166667,40.163,0.034,NULL,63926702189,998854721,15607105,18.1),(78458,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78458,35.93,NULL,153,30779,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1207',NULL,'2010Ap&SS.325..163P',2010,1,0.84,NULL,'G',0.000019,NULL,'17.11',0.11,'Sbc',NULL,NULL,NULL,NULL,1,168.14625,31.9675,0.012,NULL,60639062354,947485349,14804458,17.11),(78459,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78459,35.95,NULL,155,30779,NULL,NULL,'Dipole + Quadrupole','FGC 1207',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78460,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78460,35.98,NULL,157,30779,NULL,NULL,'Dipole','FGC 1207',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78461,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78461,35.99,NULL,157,30779,NULL,NULL,NULL,'FGC 1207',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78462,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78462,37.69,0.08,345,30780,70,NULL,NULL,'SDSS J111237.31+404411.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000161,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,168.1555,40.73653,0,NULL,63926901723,998857839,15607153,18.3),(78463,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78463,37.32,0.33,291,30781,70,NULL,NULL,'2MASX J11123752+4235476',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000187,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,168.1562083,42.59658,0,NULL,63952753505,999261773,15613465,16.2),(78464,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78464,37.75,0.46,354,30782,70,NULL,NULL,'2MASX J11123805+4055552',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00017,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,168.1584583,40.93214,0,NULL,63927384003,998865375,15607271,18.3),(78465,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78465,37.8,0.46,362,30783,70,NULL,NULL,'SDSS J111238.83+013156.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000146,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,168.161833,1.53236,0.137,NULL,60282251283,941910176,14717346,18.1),(78466,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78466,30.2,NULL,10.9,30784,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 502- G 024',NULL,'2010Ap&SS.325..163P',2010,1,1.23,NULL,'G',0.000027,NULL,'17.03',0.17,'Sdm',NULL,NULL,NULL,NULL,1,168.164,-23.46217,0.237,NULL,41711863627,651747869,10183560,17.03),(78467,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78467,30.28,NULL,11.4,30784,NULL,NULL,'Dipole + Quadrupole','ESO 502- G 024',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78468,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78468,30.38,NULL,11.9,30784,NULL,NULL,'Dipole','ESO 502- G 024',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78469,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78469,30.44,NULL,12.2,30784,NULL,NULL,NULL,'ESO 502- G 024',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78470,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78470,31.51,NULL,20,30785,NULL,NULL,NULL,'IC 0676',NULL,'2015AstBu..70....1K',2015,1,1.72,NULL,'G',0.000017,NULL,'13.3g',1.03,'(R)SB(r)0+     Sbrst','in a pair',NULL,NULL,'Starburst',1,168.165917,9.05583,0.061,NULL,60299503089,942179735,14721558,13.3),(78471,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78471,37.64,0.08,338,30786,70,NULL,NULL,'2MASX J11124080+0227458',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,168.170041667,2.46278,0.089,NULL,60295377408,942115272,14720551,17.3),(78472,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78472,38.78,0.46,571,30787,70,NULL,NULL,'SDSS J111241.28+302815.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,168.1720417,30.47086,0.007,NULL,60657985314,947781020,14809078,17.9),(78473,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78473,37.63,0.46,335,30788,70,NULL,NULL,'2MASX J11124177+3627482',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.0002,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,168.174041667,36.46347,0,NULL,60417919740,944029995,14750468,16.3),(78474,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78474,37.64,0.27,337,30789,70,NULL,NULL,'2MASX J11124278+3533417',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,168.178208333,35.56161,0,NULL,60416792268,944012379,14750193,17.5),(78475,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78475,37.64,0.08,338,30790,70,NULL,NULL,'2MASX J11124293+0223358',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000174,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,168.178833333,2.39314,0.097,NULL,60295374506,942115226,14720550,16.7),(78476,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78476,37.64,0.08,338,30791,70,NULL,NULL,'2MASX J11124300+0242007',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000192,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,168.17925,2.70028,0.113,NULL,60295452331,942116442,14720569,17.1),(78477,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78477,36.72,0.14,221,30792,70,NULL,NULL,'VII Zw 378',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000172,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,168.182875,57.27447,0,NULL,61992893087,968638954,15134983,16.2),(78478,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78478,37.64,0.27,337,30793,70,NULL,NULL,'2MASX J11124393+3533567',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000178,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,168.18325,35.56581,0,NULL,60416792284,944012379,14750193,17.5),(78479,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78479,37.42,0.46,305,30794,70,NULL,NULL,'2MASX J11124416+5123232',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000138,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,168.184083,51.38989,0,NULL,61786834268,965419285,15084676,17.7),(78480,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78480,38.07,0.46,412,30795,70,NULL,NULL,'2MASX J11124452+4316076',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,168.185417,43.26886,0,NULL,63953663315,999275989,15613687,18.2),(78481,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78481,37.41,0.21,303,30796,70,NULL,NULL,'SDSS J111244.70+132458.2',NULL,'2015arXiv151105856S',2015,1,0.04,NULL,'G',NULL,NULL,'22.7g',0.02,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,168.1862917,13.41617,0,NULL,61105207379,954768865,14918263,22.7),(78482,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78482,37.66,0.46,340,30797,70,NULL,NULL,'2MASX J11124508+5101041',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000191,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,168.188083,51.01792,0,NULL,61781098035,965329656,15083275,16.8),(78483,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78483,38.41,0.46,480,30798,70,NULL,NULL,'2MASX J11124614+0241157',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,168.1922917,2.68772,0.113,NULL,60295451794,942116434,14720569,17.8),(78484,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78484,37.41,0.21,303,30799,70,NULL,NULL,'2MASX J11124655+1326343',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000083,NULL,'17.77',0.17,NULL,NULL,NULL,NULL,NULL,1,168.193875,13.44283,0,NULL,61105208385,954768881,14918263,17.77),(78485,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78485,38.03,0.46,403,30800,70,NULL,NULL,'2MASX J11124657+0919396',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000147,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,168.1939583,9.32764,0.041,NULL,60299842384,942185037,14721641,18.1),(78486,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78486,37.59,0.11,329,30801,70,NULL,NULL,'2MASX J11124657+3935322',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000133,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,168.1942083,39.59233,0.073,NULL,63928031599,998875493,15607429,16.5),(78487,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78487,37.41,0.21,303,30802,70,NULL,NULL,'CGCG 067-034',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000063,NULL,'15.6g',0.46,'BrClG',NULL,NULL,NULL,NULL,1,168.1947917,13.40036,0,NULL,61105199191,954768737,14918261,15.6),(78488,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78488,37.19,0.46,275,30803,70,NULL,NULL,'2MASX J11124755-0004282',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000065,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,168.19825,-0.07456,0.105,NULL,40902930523,639108289,9986067,17.2),(78489,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78489,37.64,0.08,338,30804,70,NULL,NULL,'SDSS J111247.59+022706.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,168.198333,2.45175,0.089,NULL,60295380116,942115314,14720551,18.1),(78490,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78490,37.75,0.46,354,30805,70,NULL,NULL,'2MASX J11124789+5443541',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000181,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,168.199666667,54.73161,0,NULL,61962549728,968164839,15127575,17.7),(78491,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78491,36.14,0.33,169,30806,70,NULL,NULL,'CGCG 126-007',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00006,NULL,'15.4g',0.52,NULL,NULL,NULL,NULL,NULL,1,168.20225,25.59739,0,NULL,60603088292,946923254,14795675,15.4),(78492,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78492,36.95,0.46,246,30807,70,NULL,NULL,'2MASX J11124906+3257187',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'18.12',0.18,NULL,NULL,NULL,NULL,NULL,1,168.2044583,32.95528,0.043,NULL,60646231475,947597366,14806208,18.12),(78493,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78493,34.88,0.63,94.5,30808,NULL,NULL,'Malmquist cor.','ESO 570- G 013',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.41',0.6,'Sb',NULL,NULL,NULL,NULL,1,168.2067083,-21.19408,0.121,NULL,41722838383,651919349,10186239,15.41),(78494,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78494,34.95,0.61,97.6,30808,NULL,NULL,NULL,'ESO 570- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78495,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78495,34.99,0.2,99.5,30808,74.4,NULL,NULL,'ESO 570- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78496,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78496,37.64,0.27,337,30809,70,NULL,NULL,'2MASX J11124974+3533157',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000177,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,168.207208333,35.55433,0,NULL,60416793683,944012401,14750193,16.6),(78497,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78497,34.28,NULL,71.9,30810,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06246',NULL,'2010Ap&SS.325..163P',2010,1,1.88,NULL,'G',0.000011,NULL,'15.3g',0.26,'Scd','Group non-member, foreground',NULL,NULL,NULL,1,168.210333333,23.25661,0,NULL,61089503970,954523499,14914429,15.3),(78498,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78498,34.29,NULL,72.1,30810,NULL,NULL,'Dipole + Quadrupole','UGC 06246',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78499,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78499,34.3,NULL,72.5,30810,NULL,NULL,'Dipole','UGC 06246',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78500,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78500,34.34,NULL,73.9,30810,NULL,NULL,NULL,'UGC 06246',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78501,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78501,34.35,0.49,74.3,30810,75,NULL,'IR','UGC 06246',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78502,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78502,34.48,0.2,78.7,30810,74.4,NULL,NULL,'UGC 06246',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78503,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78503,34.51,0.4,79.6,30810,NULL,NULL,NULL,'UGC 06246',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78504,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78504,34.71,0.36,87.4,30810,NULL,NULL,'Malmquist cor.','UGC 06246',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78505,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78505,35.31,0.49,116,30811,70,NULL,NULL,'2MASX J11125061-0751246',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000137,NULL,'16.20',0.6,NULL,NULL,NULL,NULL,NULL,1,168.21075,-7.85697,0.069,NULL,40893325107,638958204,9983721,16.2),(78506,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78506,37.41,0.21,303,30812,70,NULL,NULL,'2MASX J11125101+1322243',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000151,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,168.2125417,13.3735,0,NULL,61105024618,954766009,14918218,17.5),(78507,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78507,32.04,NULL,25.6,30813,NULL,NULL,NULL,'SDSS J111252.70+075518.8',NULL,'2015AstBu..70....1K',2015,1,0.33,NULL,'G',0.000126,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,168.219583,7.92192,0.081,NULL,60306922524,942295664,14723369,17.3),(78508,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78508,37.69,0.08,345,30814,70,NULL,NULL,'2MASX J11125303+4022372',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,168.220833,40.37692,0.047,NULL,63926720580,998855009,15607109,17.4),(78509,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78509,36.54,0.46,203,30815,70,NULL,NULL,'2MASX J11125309+2729379',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000171,NULL,'16.0g',0.4,NULL,NULL,NULL,NULL,NULL,1,168.221166667,27.494,0,NULL,60615680908,947120014,14798750,16),(78510,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78510,38.09,0.46,415,30816,70,NULL,NULL,'2MASX J11125311+2004443',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.97',0.18,NULL,NULL,NULL,NULL,NULL,1,168.221333,20.07903,0,NULL,61092797871,954574966,14915233,17.97),(78511,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78511,37.03,0.46,254,30817,70,NULL,NULL,'2MASX J11125320+1258153',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000166,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,168.221541667,12.97083,0,NULL,61103158882,954736857,14917763,16.5),(78512,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78512,37.79,0.46,361,30818,70,NULL,NULL,'2MASX J11125319+2925389',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'18.26',0.19,'Sc',NULL,NULL,NULL,NULL,1,168.221791667,29.42753,0.026,NULL,60655502265,947742222,14808472,18.26),(78513,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78513,37.53,0.46,321,30819,70,NULL,NULL,'2MASX J11125389+2848429',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000133,NULL,'18.02',0.2,'E',NULL,NULL,NULL,NULL,1,168.224583,28.81189,0.02,NULL,60610600169,947040627,14797509,18.02),(78514,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78514,35.37,0.46,118,30820,70,NULL,NULL,'2MASX J11125448+0930505',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000174,NULL,'16.2g',0.23,'Candidate      BLAGN',NULL,NULL,NULL,NULL,1,168.2270417,9.51403,0.017,NULL,60299826027,942184781,14721637,16.2),(78515,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78515,37.54,0.46,322,30821,70,NULL,NULL,'2MASX J11125531+0834305',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000149,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,168.2305,8.57503,0.077,NULL,60311003978,942359437,14724366,17.1),(78516,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78516,38.08,0.46,413,30822,70,NULL,NULL,'2MASX J11125550-0044561',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000079,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,168.2312917,-0.74903,0.081,NULL,40903545328,639117895,9986217,17.8),(78517,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78517,34.46,0.46,77.8,30823,70,NULL,NULL,'CGCG 156-025',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000143,NULL,'15.6g',0.3,'S0','Group member',NULL,NULL,NULL,1,168.231625,28.39,0,NULL,60610557923,947039967,14797499,15.6),(78518,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78518,38.15,0.33,426,30824,70,NULL,NULL,'2MASX J11125579+0052245',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000084,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,168.232333,0.87344,0.121,NULL,60280921472,941889398,14717021,17.3),(78519,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78519,37.69,0.08,345,30825,70,NULL,NULL,'2MASX J11125716+4018250',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00011,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,168.238208333,40.30694,0.047,NULL,63926729813,998855153,15607111,16.6),(78520,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78520,38.15,0.33,426,30826,70,NULL,NULL,'SDSS J111257.62+004301.7',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000087,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,168.240125,0.71717,0.121,NULL,60280890883,941888920,14717014,18.1),(78521,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78521,36.35,0.46,186,30827,70,NULL,NULL,'2MASX J11125828+2154343',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000482,NULL,'16.59',0.27,'E              Sy1',NULL,NULL,NULL,NULL,1,168.242917,21.90947,0,NULL,61087368641,954490135,14913908,16.59),(78522,'D-Sigma','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78522,34.2,0.4,69.2,30828,75,NULL,'Edat, raw','NGC 3562',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000103,NULL,'13.17',1.3,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,168.2445,72.87931,0.093,NULL,61393278906,959269982,14988593,13.17),(78523,'D-Sigma','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78523,34.53,0.4,80.7,30828,75,NULL,'Edat, cor','NGC 3562',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78524,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78524,34.99,0.4,99.4,30828,NULL,NULL,'mean','NGC 3562',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78525,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78525,35.1,0.45,105,30828,NULL,NULL,'K','NGC 3562',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78526,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78526,36.71,0.46,220,30829,70,NULL,NULL,'2MASX J11125868+6234271',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000127,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,168.24475,62.57431,0,NULL,61860559256,966571238,15102675,17.7),(78527,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78527,37.85,0.46,372,30830,70,NULL,NULL,'2MASX J11125948+4426295',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000181,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,168.24775,44.44158,0,NULL,63954695412,999292115,15613939,17.1),(78528,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78528,31.78,NULL,22.7,30831,NULL,NULL,NULL,'CGCG 039-068',NULL,'2015AstBu..70....1K',2015,1,1.25,NULL,'G',0.000197,NULL,'15.0g',0.35,NULL,'Group member',NULL,NULL,NULL,1,168.250875,7.86186,0.081,NULL,60307660893,942307201,14723550,15),(78529,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78529,37.28,0.46,285,30832,70,NULL,NULL,'2MASX J11130036+5445022',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,168.251708333,54.75047,0,NULL,61962540858,968164700,15127573,17.4),(78530,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78530,37.59,0.11,329,30833,70,NULL,NULL,'2MASX J11130049+3922410',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,168.252,39.37794,0,NULL,63928118847,998876856,15607450,17.3),(78531,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78531,37.72,0.46,349,30834,70,NULL,NULL,'2MASX J11130071+1432513',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,168.252875,14.5475,0,NULL,61116270834,954941731,14920964,17.4),(78532,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78532,37.41,0.21,303,30835,70,NULL,NULL,'2MASX J11130287+1326183',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000083,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,168.262125,13.43833,0,NULL,61105198654,954768728,14918261,16.7),(78533,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78533,37.64,0.08,338,30836,70,NULL,NULL,'2MASX J11130290+0239565',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000179,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,168.26225,2.66578,0.101,NULL,60295463776,942116621,14720572,18),(78534,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78534,38.63,0.46,531,30837,70,NULL,NULL,'2MASX J11130367+4106580',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,168.265167,41.11625,0,NULL,63927476306,998866817,15607294,17.9),(78535,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78535,37.43,0.46,306,30838,70,NULL,NULL,'SDSS J111303.76+081212.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,168.265667,8.20356,0.073,NULL,60306972414,942296443,14723381,18.1),(78536,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78536,37.58,0.46,329,30839,70,NULL,NULL,'SDSS J111304.39+000724.3',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.7g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,168.268333,0.12342,0.101,NULL,60280733128,941886455,14716975,16.7),(78537,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78537,35.93,0.46,154,30840,70,NULL,NULL,'CGCG 011-027',NULL,'2015arXiv151105856S',2015,1,0.86,NULL,'G',0.00011,NULL,'14.8g',0.62,'E+',NULL,NULL,NULL,NULL,1,168.271625,0.00303,0.105,NULL,60280694282,941885848,14716966,14.8),(78538,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78538,37.84,0.46,370,30841,70,NULL,NULL,'VII Zw 380',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000178,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,168.276333333,58.33878,0,NULL,61998558879,968727482,15136366,17.3),(78539,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78539,35.75,0.46,142,30842,70,NULL,NULL,'2MASX J11130651+6138180',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000159,NULL,'15.8g',0.39,'LINER',NULL,NULL,NULL,NULL,1,168.277375,61.63833,0,NULL,61861262895,966582232,15102847,15.8),(78540,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78540,37.64,0.08,338,30843,70,NULL,NULL,'SDSS J111306.91+023324.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,168.278833,2.55689,0.101,NULL,60295431951,942116124,14720564,18.2),(78541,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78541,35.63,0.46,134,30844,70,NULL,NULL,'CGCG 039-072',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.0001,NULL,'15.8g',0.45,'E','Group member',NULL,NULL,NULL,1,168.2805417,7.688,0.081,NULL,60307399594,942303118,14723486,15.8),(78542,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78542,37.97,0.46,393,30845,70,NULL,NULL,'2MASX J11130780+3934440',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,168.2825,39.57875,0,NULL,63928254867,998878982,15607484,17.3),(78543,'Tully est','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78543,31.06,0.8,16.3,30846,75,NULL,NULL,'ESO 063- G 011',NULL,'1988NBGC.C....0000T',1988,1,4.37,NULL,'G',0.00001,NULL,'13.5',0.56,'SB(s)dm: sp',NULL,NULL,NULL,NULL,1,168.2840417,-69.26658,NULL,NULL,40684254310,635691473,9932679,13.5),(78544,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78544,31.22,NULL,17.5,30846,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 063- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78545,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78545,31.22,NULL,17.5,30846,NULL,NULL,'Dipole','ESO 063- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78546,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78546,31.23,NULL,17.6,30846,NULL,NULL,'Dipole + Quadrupole','ESO 063- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78547,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78547,37.74,0.46,353,30847,70,NULL,NULL,'SDSS J111308.38+404539.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,168.284958333,40.76106,0,NULL,63926896991,998857765,15607152,18.1),(78548,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78548,36.31,0.46,183,30848,70,NULL,NULL,'2MASX J11130941+1258143',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000105,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,168.289125,12.97075,0,NULL,61103153765,954736777,14917762,16.7),(78549,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78549,36.89,0.46,239,30849,70,NULL,NULL,'2MASX J11130939+3434574',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000177,NULL,'16.1g',0.42,NULL,NULL,NULL,NULL,NULL,1,168.289125,34.58253,0,NULL,60646600899,947603139,14806299,16.1),(78550,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78550,37.32,0.46,291,30850,70,NULL,NULL,'2MASX J11130965+0646305',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000169,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,168.290333,6.77522,0.101,NULL,60306211796,942284559,14723196,17.9),(78551,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78551,35.15,0.46,107,30851,70,NULL,NULL,'UGC 06250',NULL,'2015arXiv151105856S',2015,1,1.05,NULL,'G',0.000067,NULL,'14.3g',0.8,'E?','Group member',NULL,NULL,NULL,1,168.293375,27.81822,0,NULL,60615812100,947122064,14798782,14.3),(78552,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78552,37.96,0.27,392,30852,70,NULL,NULL,'2MASX J11131085+3906220',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.32',0.13,NULL,NULL,NULL,NULL,NULL,1,168.29525,39.10619,0,NULL,63928082158,998876283,15607441,18.32),(78553,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78553,38.58,0.46,519,30853,70,NULL,NULL,'2MASX J11131093+3114384',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,168.295583,31.24403,0.034,NULL,60656369264,947755769,14808683,17.5),(78554,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78554,37.34,0.46,294,30854,70,NULL,NULL,'2MASX J11131212+6448200',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,168.300541667,64.80558,0.013,NULL,61869491683,966710807,15104856,17.8),(78555,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78555,37.64,0.08,338,30855,70,NULL,NULL,'2MASX J11131271+0229055',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000169,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,168.3029583,2.48481,0.093,NULL,60281815426,941903366,14717240,17.8),(78556,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78556,36.85,0.46,234,30856,70,NULL,NULL,'2MASXi J1113132+390133',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'17.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,168.3050417,39.02581,0,NULL,63928346477,998880413,15607506,17.4),(78557,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78557,37.77,0.19,357,30857,70,NULL,NULL,'2MASX J11131322+3600401',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00015,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,168.30525,36.01114,0,NULL,60416326948,944005108,14750079,17.2),(78558,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78558,37.77,0.19,357,30858,70,NULL,NULL,'2MASX J11131347+3559401',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,168.3062917,35.9945,0,NULL,60416324340,944005067,14750079,17.6),(78559,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78559,37.93,0.21,386,30859,70,NULL,NULL,'2MASX J11131376+4122080',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000178,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,168.3075,41.36903,0,NULL,63927305655,998864150,15607252,18),(78560,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78560,37.64,0.46,338,30860,70,NULL,NULL,'2MASX J11131471+3004414',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000174,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,168.311417,30.07814,0,NULL,60657626425,947775412,14808990,17.3),(78561,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78561,37.77,0.19,357,30861,70,NULL,NULL,'2MASX J11131495+3609220',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000175,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,168.312667,36.15617,0,NULL,60416088934,944001389,14750021,17.1),(78562,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78562,37.96,0.27,392,30862,70,NULL,NULL,'2MASX J11131550+3924000',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000209,NULL,'16.0g',0.42,NULL,NULL,NULL,NULL,NULL,1,168.3147083,39.39997,0,NULL,63928242567,998878790,15607481,16),(78563,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78563,37.41,0.33,303,30863,70,NULL,NULL,'2MASX J11131569+0901245',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,168.3152083,9.0235,0.061,NULL,60299522478,942180038,14721563,17.2),(78564,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78564,37.06,0.46,259,30864,70,NULL,NULL,'CGCG 039-074',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000133,NULL,'15.7g',0.47,'E0','Group member',NULL,NULL,NULL,1,168.315583,7.83336,0.081,NULL,60307619120,942306548,14723539,15.7),(78565,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78565,37.73,0.46,351,30865,70,NULL,NULL,'SDSS J111315.81+244456.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,168.315875,24.74903,0,NULL,60566424753,946350386,14786724,18.2),(78566,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78566,34.59,0.46,82.9,30866,70,NULL,NULL,'NGC 3580',NULL,'2015arXiv151105856S',2015,1,1.03,NULL,'G',0.000173,NULL,'14.6g',0.4,'SA0^0^',NULL,NULL,NULL,NULL,1,168.316375,3.65733,0.109,NULL,60287289288,941988895,14718576,14.6),(78567,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78567,37.83,0.46,369,30867,70,NULL,NULL,'2MASX J11131630+2726262',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000123,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,168.317958333,27.44067,0,NULL,60615949242,947124206,14798815,18.1),(78568,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78568,37.62,0.46,334,30868,70,NULL,NULL,'2MASX J11131651+2027005',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,168.318708333,20.45011,0,NULL,61092920067,954576876,14915263,17),(78569,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78569,37.96,0.27,392,30869,70,NULL,NULL,'2MASX J11131662+3920130',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,168.31925,39.33708,0,NULL,63928123560,998876930,15607452,17.9),(78570,'GCLF','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78570,31.9,0.4,24,30870,NULL,NULL,'TOM(V) = -7.3 mag','NGC 3585',NULL,'2009ApJ...690..512H',2009,1,4.7,NULL,'G',0.00004,NULL,'10.88',2.6,'E7/S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,168.3212083,-26.75483,0.277,NULL,41554284553,649285696,10145089,10.88),(78571,'SBF','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78571,31.51,0.18,20,30870,NULL,NULL,'I','NGC 3585',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78572,'SBF','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78572,31.51,0.18,20,30870,NULL,NULL,NULL,'NGC 3585',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78573,'SBF','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78573,31.55,0.18,20.4,30870,NULL,NULL,'Malmquist cor.','NGC 3585',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78574,'SBF','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78574,31.55,0.14,20.4,30870,74.4,NULL,NULL,'NGC 3585',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78575,'D-Sigma','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78575,30.55,0.4,12.9,30870,75,NULL,'Edat, raw','NGC 3585',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78576,'D-Sigma','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78576,30.88,0.4,15,30870,75,NULL,'Edat, cor','NGC 3585',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78577,'Faber-Jackson','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78577,29.6,0.63,8.32,30870,95,NULL,'Michard 1979b, c','NGC 3585',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78578,'Faber-Jackson','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78578,30.12,0.37,10.6,30870,95,NULL,'Weighted Mean','NGC 3585',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78579,'Faber-Jackson','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78579,30.4,0.46,12,30870,95,NULL,'Michard 1979a','NGC 3585',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78580,'Faber-Jackson','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78580,30.79,NULL,14.4,30870,NULL,NULL,'LEDA [April 2006]','NGC 3585',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78581,'Faber-Jackson','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78581,31.52,0.81,20.1,30870,55,NULL,'Visvanathan & Sandage 1979','NGC 3585',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78582,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78582,30.58,0.56,13.1,30870,70,NULL,NULL,'NGC 3585',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78583,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78583,30.83,0.41,14.7,30870,NULL,NULL,NULL,'NGC 3585',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78584,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78584,31.06,0.41,16.3,30870,NULL,NULL,'Malmquist cor.','NGC 3585',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78585,'Tully est','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78585,31.67,0.8,21.6,30870,75,NULL,'B','NGC 3585',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78586,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78586,30.92,0.45,15.2,30870,NULL,NULL,'K','NGC 3585',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78587,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78587,31.53,0.4,20.2,30870,NULL,NULL,'mean','NGC 3585',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78588,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78588,38.05,0.15,407,30871,70,NULL,NULL,'SDSS J111317.15+374202.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000138,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,168.3215,37.70081,0,NULL,60416862474,944013476,14750210,18.3),(78589,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78589,37.93,0.21,386,30872,70,NULL,NULL,'SDSS J111317.58+412551.1',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.28,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,168.32325,41.43086,0,NULL,63927318527,998864351,15607255,16.9),(78590,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78590,36.61,0.46,210,30873,70,NULL,NULL,'2MASX J11131781+3907470',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,168.3242083,39.12969,0,NULL,63928132241,998877066,15607454,16.6),(78591,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78591,37.93,0.21,386,30874,70,NULL,NULL,'2MASX J11131793+4124290',NULL,'2015arXiv151105856S',2015,1,0.54,'May be identifiable with B3 1110+416.','G',0.000175,NULL,'16.5g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,168.324625,41.40814,0,NULL,63927317857,998864341,15607255,16.5),(78592,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78592,37.48,0.46,314,30875,70,NULL,NULL,'2MASX J11131837+3822240',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000167,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,168.3267083,38.37322,0,NULL,63927519491,998867492,15607304,17.1),(78593,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78593,36.1,0.46,166,30876,70,NULL,NULL,'MCG +10-16-086',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000188,NULL,'15.5g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,168.328833,59.93942,0,NULL,61979479059,968429360,15131708,15.5),(78594,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78594,36.07,0.46,164,30877,70,NULL,NULL,'2MASX J11131941+2948392',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.0001,NULL,'15.5g',0.54,NULL,NULL,NULL,NULL,NULL,1,168.331,29.81108,0,NULL,60655558211,947743097,14808485,15.5),(78595,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78595,38.56,0.33,515,30878,70,NULL,NULL,'SDSS J111319.44+513635.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000169,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,168.3310417,51.60992,0,NULL,61786913084,965420516,15084695,18),(78596,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78596,37.41,0.33,303,30879,70,NULL,NULL,'2MASX J11131984+0901210',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000142,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,168.332667,9.02256,0.081,NULL,60299525898,942180092,14721563,17.5),(78597,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78597,37.62,0.46,334,30880,70,NULL,NULL,'2MASX J11132000+5020016',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000172,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,168.333375,50.33378,0,NULL,61781488425,965335756,15083371,17.1),(78598,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78598,37.21,0.46,276,30881,70,NULL,NULL,'SDSS J111320.25+330156.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'17.8g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,168.334416667,33.0325,0.044,NULL,60645782383,947590349,14806099,17.8),(78599,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78599,37.94,0.46,387,30882,70,NULL,NULL,'2MASX J11132033+5442372',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000155,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,168.335,54.71033,0,NULL,61962658261,968166535,15127602,17.7),(78600,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78600,37.43,0.46,307,30883,70,NULL,NULL,'2MASX J11132111+4252447',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000173,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,168.338,42.87925,0,NULL,63953583347,999274739,15613667,17.9),(78601,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78601,37.64,0.08,338,30884,70,NULL,NULL,'2MASX J11132119+0237030',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000182,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,168.338333,2.61736,0.101,NULL,60295263553,942113493,14720523,17.2),(78602,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78602,36.61,0.6,210,30885,70,NULL,NULL,'2MASX J11132161-4858242',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.5,NULL,NULL,NULL,NULL,NULL,1,168.340167,-48.97347,0.701,NULL,41914343399,654911615,10232993,14),(78603,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78603,36.14,0.46,169,30886,70,NULL,NULL,'2MASX J11132202+6126488',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,168.341791667,61.44681,0,NULL,61861117937,966579967,15102811,16.4),(78604,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78604,37.85,0.33,371,30887,70,NULL,NULL,'2MASX J11132205+1421479',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,168.341875,14.36319,0.01,NULL,61104939809,954764684,14918198,17.5),(78605,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78605,37.64,0.08,338,30888,70,NULL,NULL,'2MASX J11132346+0229580',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,168.347833,2.49944,0.093,NULL,60281817581,941903399,14717240,17.5),(78606,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78606,37.71,0.33,348,30889,70,NULL,NULL,'SDSS J111323.50+241703.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,168.347958333,24.28428,0,NULL,60566132261,946345816,14786653,18),(78607,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78607,35.56,0.64,129,30890,70,NULL,NULL,'2MASX J11132354-0947414',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.21',0.2,NULL,NULL,NULL,NULL,NULL,1,168.348083333,-9.79508,0.097,NULL,40887676528,638869945,9982342,16.21),(78608,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78608,37.69,0.08,345,30891,70,NULL,NULL,'2MASX J11132458+4008470',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'18.1g',0.17,'AGN',NULL,NULL,NULL,NULL,1,168.352625,40.14628,0.034,NULL,63928578363,998884036,15607563,18.1),(78609,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78609,38.05,0.15,407,30892,70,NULL,NULL,'2MASX J11132470+3725090',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000174,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,168.352958333,37.41917,0,NULL,60417014899,944015857,14750247,17.3),(78610,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78610,37.17,0.46,272,30893,70,NULL,NULL,'2MASX J11132603+2443362',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000157,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,168.3585,24.72686,0,NULL,60566434820,946350544,14786727,16.8),(78611,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78611,37.64,0.08,338,30894,70,NULL,NULL,'2MASX J11132606+0240370',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000169,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,168.358583,2.67694,0.101,NULL,60295261091,942113454,14720522,17.2),(78612,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78612,31.28,0.4,18.1,30895,75,NULL,'B','UGC 06251',NULL,'1988NBGC.C....0000T',1988,1,0.72,NULL,'G',0.00002,NULL,'15.9g',0.56,'SABm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,168.358917,53.59508,0,NULL,61786030334,965406723,15084480,15.9),(78613,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78613,38.21,0.46,439,30896,70,NULL,NULL,'SDSS J111326.97+245108.0',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,168.362417,24.85225,0,NULL,60569174779,946393355,14787396,17.6),(78614,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78614,38.05,0.15,407,30897,70,NULL,NULL,'2MASX J11132718+3740310',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000178,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,168.363375,37.67525,0,NULL,60416888897,944013889,14750217,17.7),(78615,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78615,35.05,NULL,102,30898,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 039-078',NULL,'2010Ap&SS.325..163P',2010,1,0.71,NULL,'G',0.000014,NULL,'16.4g',0.18,'Scd',NULL,NULL,NULL,NULL,1,168.365666667,7.43147,0.089,NULL,60307514378,942304912,14723514,16.4),(78616,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78616,35.08,NULL,104,30898,NULL,NULL,'Dipole + Quadrupole','CGCG 039-078',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78617,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78617,35.12,NULL,106,30898,NULL,NULL,NULL,'CGCG 039-078',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78618,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78618,35.12,NULL,106,30898,NULL,NULL,'Dipole','CGCG 039-078',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78619,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78619,36.72,0.14,221,30899,70,NULL,NULL,'2MASX J11132787+5659331',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000177,NULL,'16.0g',0.39,'E0',NULL,NULL,NULL,NULL,1,168.366083,56.99261,0,NULL,61993034162,968641158,15135018,16),(78620,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78620,36.51,0.56,201,30900,70,NULL,NULL,'2MASX J11132794-0003245',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.000087,NULL,'16.1g',0.41,'S0/a',NULL,NULL,NULL,NULL,1,168.3664583,-0.05694,0.109,NULL,40902953581,639108649,9986072,16.1),(78621,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78621,37.69,0.08,345,30901,70,NULL,NULL,'2MASX J11132827+4015020',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000194,NULL,'18.0g',0.11,NULL,NULL,NULL,NULL,NULL,1,168.367833333,40.25058,0.047,NULL,63928569641,998883900,15607560,18),(78622,'Carbon Stars','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78622,21.51,NULL,0.2,30902,NULL,NULL,'SDSS J111320.64+22 1116.3','Leo B',NULL,'2013ApJ...765...12G',2013,1,12,'This galaxy was added to CGCG in vol III, \'Errors and Omissions\'.','G',0.000002,NULL,'12.6',11,'E0 pec','in a radial-velocity based grouping',NULL,NULL,NULL,1,168.37,22.15167,0,1,61087213376,954487709,14913870,12.6),(78623,'Carbon Stars','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78623,21.68,0.57,0.217,30902,NULL,NULL,'Carbon star S26, RA 168.3034, DEC 22.1872','Leo B',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78624,'Carbon Stars','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78624,21.85,0.57,0.234,30902,NULL,NULL,'Carbon star S27, RA 168.3359, DEC 22.1878','Leo B',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78625,'Carbon Stars','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78625,21.86,NULL,0.235,30902,NULL,NULL,'SDSS J111312.83+221114.1','Leo B',NULL,'2013ApJ...765...12G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78626,'CMD','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78626,21.55,0.08,0.204,30902,NULL,NULL,NULL,'Leo B',NULL,'2002MNRAS.332...91D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78627,'CMD','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78627,21.56,NULL,0.205,30902,NULL,NULL,NULL,'Leo B',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78628,'CMD','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78628,21.85,0.2,0.23,30902,NULL,NULL,NULL,'Leo B',NULL,'1983AJ.....88..329D',1983,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78629,'Horizontal Branch','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78629,21.48,0.16,0.198,30902,NULL,NULL,NULL,'Leo B',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78630,'Horizontal Branch','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78630,21.55,0.18,0.204,30902,NULL,NULL,NULL,'Leo B',NULL,'1996AJ....111..777M',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78631,'Horizontal Branch','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78631,21.58,0.13,0.207,30902,NULL,NULL,NULL,'Leo B',NULL,'1995MNRAS.277.1354I',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78632,'Horizontal Branch','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78632,21.67,0.1,0.216,30902,NULL,NULL,NULL,'Leo B',NULL,'2002MNRAS.332...91D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78633,'Horizontal Branch','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78633,21.82,NULL,0.231,30902,NULL,NULL,NULL,'Leo B',NULL,'1985IAUS..113..541W',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78634,'RR Lyrae','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78634,21.58,NULL,0.207,30902,NULL,NULL,NULL,'Leo B',NULL,'2008ApJ...679...52T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78635,'RR Lyrae','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78635,21.66,NULL,0.215,30902,NULL,NULL,NULL,'Leo B',NULL,'1993MNRAS.261..657D',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78636,'TRGB','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78636,21.6,NULL,0.21,30902,NULL,NULL,NULL,'Leo B',NULL,'2000glg..book.....V',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78637,'TRGB','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78637,21.66,0.21,0.215,30902,NULL,NULL,'I','Leo B',NULL,'1995AJ....110.1155L',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78638,'TRGB','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78638,21.68,0.11,0.217,30902,NULL,NULL,'JHK','Leo B',NULL,'2008MNRAS.388.1185G',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78639,'TRGB','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78639,21.7,NULL,0.219,30902,NULL,NULL,NULL,'Leo B',NULL,'2009AJ....137...62S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78640,'TRGB','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78640,21.73,0.21,0.222,30902,NULL,NULL,'HST KP Calibrated','Leo B',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78641,'TRGB','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78641,21.84,0.13,0.233,30902,NULL,NULL,'I','Leo B',NULL,'2005MNRAS.360..185B',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78642,'TRGB','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78642,21.9,0.08,0.24,30902,74.4,NULL,NULL,'Leo B',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78643,'Proper Motion','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78643,21.66,NULL,0.215,30902,NULL,NULL,NULL,'Leo B',NULL,'2011ApJ...741..100L',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78644,'Proper Motion','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78644,21.86,NULL,0.236,30902,NULL,NULL,NULL,'Leo B',NULL,'2011ApJ...741..100L',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78645,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78645,37.85,0.33,371,30903,70,NULL,NULL,'2MASX J11132921+1420319',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000196,NULL,'16.2g',0.41,'BrClG',NULL,NULL,NULL,NULL,1,168.371625,14.34214,0.01,NULL,61104898281,954764035,14918188,16.2),(78646,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78646,36.89,0.33,239,30904,70,NULL,NULL,'2MASX J11132922+4327447',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000176,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,168.37175,43.46258,0,NULL,63953010281,999265785,15613527,16.6),(78647,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78647,37.02,0.46,253,30905,70,NULL,NULL,'2MASX J11132993+0144450',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,168.374875,1.74575,0.105,NULL,60282321923,941911280,14717363,17.2),(78648,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78648,38.56,0.33,515,30906,70,NULL,NULL,'2MASX J11133087+5132036',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,168.3785417,51.53411,0,NULL,61786935265,965420863,15084700,18),(78649,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78649,37.77,0.19,357,30907,70,NULL,NULL,'2MASX J11133220+3559046',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000208,NULL,'16.5g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,168.3840417,35.98453,0,NULL,60416323351,944005052,14750078,16.5),(78650,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78650,37.09,0.46,261,30908,70,NULL,NULL,'2MASX J11133235+3018276',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,168.384833,30.30769,0,NULL,60657850195,947778909,14809045,17.5),(78651,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78651,37.9,0.46,380,30909,70,NULL,NULL,'2MASX J11133312+0737170',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000137,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,168.3877917,7.62125,0.085,NULL,60307380150,942302814,14723481,17.5),(78652,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78652,37.84,0.46,369,30910,70,NULL,NULL,'2MASX J11133393+0020150',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000085,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,168.391333,0.33747,0.101,NULL,60280734651,941886478,14716976,16.9),(78653,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78653,37.46,0.46,310,30911,70,NULL,NULL,'SDSS J111334.03+020618.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,168.391833333,2.105,0.105,NULL,60282467986,941913562,14717399,18.4),(78654,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78654,37.08,0.46,261,30912,70,NULL,NULL,'IC 2636',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000191,NULL,'16.2g',0.32,'E0',NULL,NULL,NULL,NULL,1,168.391833333,11.45617,0,NULL,60330877981,942669968,14729218,16.2),(78655,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78655,37.39,0.46,300,30913,70,NULL,NULL,'2MASX J11133465+3542156',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000134,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,168.3942083,35.70431,0,NULL,60416779765,944012183,14750190,17.1),(78656,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78656,37.59,0.11,329,30914,70,NULL,NULL,'2MASX J11133489+3922513',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,168.3952083,39.38108,0,NULL,63928217036,998878391,15607474,17.5),(78657,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78657,38.05,0.15,407,30915,70,NULL,NULL,'2MASX J11133491+3742533',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000147,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,168.3955,37.71486,0,NULL,60428390561,944193602,14753025,17.7),(78658,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78658,38.05,0.15,407,30916,70,NULL,NULL,'2MASX J11133492+3740013',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000161,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,168.395583333,37.66689,0,NULL,60428411314,944193926,14753030,16.9),(78659,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78659,38.08,0.33,412,30917,70,NULL,NULL,'SDSS J111335.61+014028.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000149,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,168.398417,1.67453,0.105,NULL,60282366344,941911974,14717374,18.5),(78660,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78660,37.77,0.19,357,30918,70,NULL,NULL,'2MASX J11133588+3607433',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000174,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,168.399291667,36.12875,0,NULL,60416282637,944004416,14750069,16.8),(78661,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78661,37.33,0.46,293,30919,70,NULL,NULL,'2MASX J11133588+1032049',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000185,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,168.3995417,10.53461,0.025,NULL,60331291076,942676423,14729319,16.6),(78662,'IRAS','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78662,34.22,0.8,69.7,30920,75,NULL,'MAT, I','ESO 265- G 016',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'15.49',0.3,'SAc: sp',NULL,NULL,NULL,NULL,1,168.403875,-44.01764,0.525,NULL,41942852350,655357067,10239954,15.49),(78663,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78663,33.89,0.43,60.1,30920,75,NULL,'MAT, I, raw','ESO 265- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78664,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78664,33.94,0.32,61.4,30920,85,NULL,'I, raw','ESO 265- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78665,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78665,33.98,0.32,62.5,30920,85,NULL,'I, inv','ESO 265- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78666,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78666,34.07,0.43,65.2,30920,75,NULL,'MAT, I, inv','ESO 265- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78667,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78667,34.15,0.38,67.7,30920,NULL,NULL,NULL,'ESO 265- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78668,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78668,34.19,0.2,68.9,30920,74.4,NULL,NULL,'ESO 265- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78669,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78669,34.22,0.43,69.9,30920,75,NULL,'MAT, I, cor','ESO 265- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78670,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78670,34.25,0.37,70.7,30920,NULL,NULL,'Malmquist cor.','ESO 265- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78671,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78671,36.11,0.46,166,30921,70,NULL,NULL,'2MASX J11133699+3941133',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00018,NULL,'15.8g',0.4,'E/S0',NULL,NULL,NULL,NULL,1,168.404083333,39.68703,0,NULL,63928236205,998878690,15607479,15.8),(78672,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78672,38.05,0.15,407,30922,70,NULL,NULL,'SDSS J111340.67+372736.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,168.419458333,37.46003,0,NULL,60417001879,944015654,14750244,18.5),(78673,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78673,37.84,0.46,370,30923,70,NULL,NULL,'2MASX J11134079+2230071',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,168.4197917,22.50217,0,NULL,61089228975,954519202,14914362,17.2),(78674,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78674,37.76,0.46,357,30924,70,NULL,NULL,'2MASX J11134082+3932243',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000175,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,168.420083,39.54014,0,NULL,63928264591,998879134,15607486,16.9),(78675,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78675,35.7,0.46,138,30925,70,NULL,NULL,'MRK 1295',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00018,NULL,'16.0g',0.28,'Compact','Group member',NULL,NULL,NULL,1,168.422208333,7.76275,0.081,NULL,60307350966,942302358,14723474,16),(78676,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78676,37.64,0.08,338,30926,70,NULL,NULL,'2MASX J11134168+0234500',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,168.42375,2.58058,0.093,NULL,60281618116,941900283,14717191,16.9),(78677,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78677,38.05,0.15,407,30927,70,NULL,NULL,'2MASX J11134203+3720013',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,168.4252917,37.33361,0.03,NULL,60417040534,944016258,14750254,17.7),(78678,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78678,38.05,0.15,407,30928,70,NULL,NULL,'2MASX J11134227+3721353',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,168.426291667,37.35983,0,NULL,60417008555,944015758,14750246,17.3),(78679,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78679,37.17,0.46,272,30929,70,NULL,NULL,'2MASX J11134279+1033059',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,168.4282917,10.55175,0.025,NULL,60331283531,942676305,14729317,17.4),(78680,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78680,36.72,0.14,221,30930,70,NULL,NULL,'2MASX J11134296+5704405',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,168.429125,57.07781,0,NULL,61993085817,968641965,15135030,17.5),(78681,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78681,36.09,0.46,166,30931,70,NULL,NULL,'2MASX J11134441+5709096',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000194,NULL,'15.7g',0.32,'S0',NULL,NULL,NULL,NULL,1,168.4352083,57.15264,0,NULL,61993082209,968641909,15135029,15.7),(78682,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78682,38,0.46,398,30932,70,NULL,NULL,'2MASX J11134530+0401350',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,168.438833,4.02636,0.097,NULL,60287142731,941986605,14718540,17.7),(78683,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78683,38.08,0.33,412,30933,70,NULL,NULL,'2MASX J11134643+0135119',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000148,NULL,'17.8g',0.2,'BrClG',NULL,NULL,NULL,NULL,1,168.443375,1.58664,0.109,NULL,60282330246,941911410,14717365,17.8),(78684,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78684,37.69,0.08,345,30934,70,NULL,NULL,'2MASX J11134754+4017533',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000194,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,168.448166667,40.29819,0.047,NULL,63928680750,998885636,15607588,16.9),(78685,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78685,36.47,0.46,197,30935,70,NULL,NULL,'2MASX J11134782+2817504',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'18.36',0.15,NULL,NULL,NULL,NULL,NULL,1,168.449291667,28.29736,0,NULL,60612373504,947068336,14797942,18.36),(78686,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78686,37.69,0.08,345,30936,70,NULL,NULL,'2MASX J11134824+4017083',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000093,NULL,'16.34',0.3,'cD;BrClG',NULL,NULL,NULL,NULL,1,168.450875,40.28575,0.047,NULL,63928746534,998886664,15607604,16.34),(78687,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78687,38.19,0.46,434,30937,70,NULL,NULL,'2MASX J11134816+4937483',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,168.450917,49.63011,0,NULL,63913105225,998642269,15603785,18.1),(78688,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78688,37.95,0.46,388,30938,70,NULL,NULL,'SDSS J111348.37+105259.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,168.451583,10.88333,0.017,NULL,60330941742,942670964,14729233,18),(78689,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78689,37.77,0.19,357,30939,70,NULL,NULL,'2MASX J11134843+3600263',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000193,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,168.451667,36.00742,0,NULL,60416290772,944004543,14750070,17.9),(78690,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78690,38.13,0.46,422,30940,70,NULL,NULL,'SDSS J111349.67+004053.1',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000076,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,168.456958333,0.68144,0.113,NULL,60281485039,941898203,14717159,17.9),(78691,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78691,32.08,0.4,26.1,30941,75,NULL,'B','UGC 06258',NULL,'1988NBGC.C....0000T',1988,1,2,NULL,'G',0.00002,NULL,'14.90',0.5,'Im','Isolated galaxy',NULL,NULL,NULL,1,168.457625,21.52103,0,NULL,61101227680,954706682,14917291,14.9),(78692,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78692,38,0.46,398,30942,70,NULL,NULL,'SDSS J111350.02+502738.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000132,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,168.4584583,50.46061,0,NULL,61781989145,965343580,15083493,18.2),(78693,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78693,37.64,0.08,338,30943,70,NULL,NULL,'2MASX J11135022+0218309',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,168.459333,2.30853,0.113,NULL,60281787210,941902925,14717233,NULL),(78694,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78694,31.45,NULL,19.5,30944,NULL,NULL,NULL,'SDSS J111350.75+095739.4',NULL,'2015AstBu..70....1K',2015,1,0.18,NULL,'G',0.000057,NULL,'18.3g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,168.4615,9.96094,0.029,NULL,60332452045,942694563,14729602,18.3),(78695,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78695,38.05,0.15,407,30945,70,NULL,NULL,'2MASX J11135074+3716393',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000151,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,168.461667,37.27772,0,NULL,60428461944,944194717,14753042,17.5),(78696,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78696,37.64,0.08,338,30946,70,NULL,NULL,'2MASX J11135095+0228539',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'17.41',0.21,NULL,NULL,NULL,NULL,NULL,1,168.4624583,2.48144,0.093,NULL,60281832363,941903630,14717244,17.41),(78697,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78697,37.64,0.08,338,30947,70,NULL,NULL,'SDSS J111351.00+022907.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,168.4625417,2.48536,0.093,NULL,60281832358,941903630,14717244,18.2),(78698,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78698,37.59,0.11,329,30948,70,NULL,NULL,'2MASX J11135146+3924483',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.18',0.14,NULL,NULL,NULL,NULL,NULL,1,168.464625,39.41344,0,NULL,63928218472,998878413,15607475,18.18),(78699,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78699,37.14,0.46,268,30949,70,NULL,NULL,'2MASX J11135150+4122453',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,168.4647083,41.37928,0,NULL,63927340022,998864687,15607260,17.3),(78700,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78700,37.06,0.46,259,30950,70,NULL,NULL,'2MASX J11135160+1459337',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,168.465,14.99264,0,NULL,61116412122,954943939,14920999,17.2),(78701,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78701,36.69,0.46,218,30951,70,NULL,NULL,'CGCG 185-019',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.00012,NULL,'15.3g',0.49,NULL,NULL,NULL,NULL,NULL,1,168.46525,34.28461,0,NULL,60647365186,947615081,14806485,15.3),(78702,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78702,37.59,0.11,329,30952,70,NULL,NULL,'2MASX J11135180+3924143',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000187,NULL,'15.7g',0.47,'BrClG',NULL,NULL,NULL,NULL,1,168.4657917,39.40411,0,NULL,63928218416,998878412,15607475,15.7),(78703,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78703,37.93,0.21,386,30953,70,NULL,NULL,'2MASX J11135185+4127423',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,168.466125,41.46178,0,NULL,63927348410,998864818,15607262,18),(78704,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78704,36.9,0.46,240,30954,70,NULL,NULL,'2MASX J11135221+5528326',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00015,NULL,'16.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,168.467458333,55.47583,0,NULL,61992816396,968637756,15134964,16.4),(78705,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78705,35,0.45,99.8,30955,NULL,NULL,'K','UGC 06260',NULL,'2007A&A...465...71T',2007,1,1.54,NULL,'G',0.000033,NULL,'14.8g',0.5,'Sc(f)',NULL,NULL,NULL,NULL,1,168.469125,4.29081,0.113,NULL,60288146353,942002286,14718785,14.8),(78706,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78706,35.01,0.47,100,30955,NULL,NULL,'H','UGC 06260',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78707,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78707,35.13,0.4,106,30955,NULL,NULL,'mean','UGC 06260',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78708,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78708,35.26,0.49,113,30955,75,NULL,'IR','UGC 06260',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78709,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78709,35.26,0.46,113,30955,NULL,NULL,'J','UGC 06260',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78710,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78710,35.31,0.48,115,30955,NULL,NULL,'Malmquist cor.','UGC 06260',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78711,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78711,35.5,0.44,126,30955,NULL,NULL,NULL,'UGC 06260',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78712,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78712,35.54,0.2,128,30955,74.4,NULL,NULL,'UGC 06260',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78713,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78713,37.63,0.46,335,30956,70,NULL,NULL,'2MASX J11135255+2355121',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000166,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,168.469167,23.92006,0,NULL,60569428963,946397327,14787458,17.2),(78714,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78714,37.93,0.21,386,30957,70,NULL,NULL,'2MASX J11135363+4129243',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,168.473625,41.49025,0,NULL,63927348653,998864822,15607262,17.8),(78715,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78715,37.69,0.08,345,30958,70,NULL,NULL,'2MASX J11135442+3955093',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000184,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,168.476833333,39.91919,0,NULL,63928775685,998887120,15607611,17.3),(78716,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78716,36.75,0.46,224,30959,70,NULL,NULL,'2MASX J11135463+4024433',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000097,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,168.477625,40.41219,0.047,NULL,63926810810,998856418,15607131,16.4),(78717,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78717,37.64,0.08,338,30960,70,NULL,NULL,'2MASX J11135475+0233589',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000175,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,168.47825,2.56622,0.093,NULL,60281637343,941900583,14717196,17),(78718,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78718,31.54,NULL,20.3,30961,NULL,NULL,NULL,'2MASX J11135527+0406189',NULL,'2015AstBu..70....1K',2015,1,0.31,NULL,'G',0.000105,NULL,'16.97',0.31,NULL,NULL,NULL,NULL,NULL,1,168.480167,4.10533,0.097,NULL,60287150246,941986722,14718542,16.97),(78719,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78719,36.96,0.46,247,30962,70,NULL,NULL,'2MASX J11135525+2736564',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,168.4802083,27.61564,0,NULL,60616052124,947125814,14798840,17.1),(78720,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78720,37.64,0.08,338,30963,70,NULL,NULL,'SDSS J111355.31+022656.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000164,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,168.480458333,2.44894,0.113,NULL,60281804389,941903193,14717237,18.5),(78721,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78721,37.64,0.08,338,30964,70,NULL,NULL,'SDSS J111355.64+022835.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000178,NULL,'18.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,168.481833,2.4765,0.113,NULL,60281803231,941903175,14717237,18.1),(78722,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78722,38.19,0.33,435,30965,70,NULL,NULL,'2MASX J11135580-0020211',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000072,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,168.4824583,-0.33917,0.109,NULL,40903056234,639110253,9986097,18.3),(78723,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78723,34.04,0.49,64.3,30966,75,NULL,'IR','UGC 06256',NULL,'2011yCatp016004901K',2011,1,1.66,NULL,'G',0.000149,NULL,'15.6g',0.26,'Sd(f)',NULL,NULL,NULL,NULL,1,168.484458333,65.17753,0.021,NULL,61811754399,965808662,15090760,15.6),(78724,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78724,34.48,NULL,78.8,30966,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06256',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78725,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78725,34.49,NULL,79.2,30966,NULL,NULL,'Dipole + Quadrupole','UGC 06256',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78726,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78726,34.5,NULL,79.4,30966,NULL,NULL,'Dipole','UGC 06256',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78727,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78727,34.54,NULL,81,30966,NULL,NULL,NULL,'UGC 06256',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78728,'IRAS','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78728,33.42,0.8,48.4,30967,75,NULL,'CF, r','IC 0677',NULL,'1997ApJS..109..333W',1997,1,1.55,NULL,'G',0.000017,NULL,'13.8g',0.67,'Sbc','Pair member, wide',NULL,NULL,NULL,1,168.485417,12.30108,0,NULL,61103499281,954742176,14917846,13.8),(78729,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78729,33.39,0.2,47.6,30967,74.4,NULL,NULL,'IC 0677',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78730,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78730,33.72,0.38,55.5,30967,75,NULL,'CF, r, raw','IC 0677',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78731,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78731,33.82,0.38,58.1,30967,75,NULL,'CF, r, inv','IC 0677',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78732,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78732,33.88,0.38,59.6,30967,75,NULL,'CF, r, cor','IC 0677',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78733,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78733,37.64,0.08,338,30968,70,NULL,NULL,'2MASX J11135756+0228279',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.18',0.2,NULL,NULL,NULL,NULL,NULL,1,168.489666667,2.47425,0.113,NULL,60281806544,941903227,14717237,18.18),(78734,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78734,37.61,0.46,333,30969,70,NULL,NULL,'2MASX J11135763+0152349',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,168.4902083,1.87622,0.105,NULL,60282204392,941909443,14717335,17.2),(78735,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78735,37.64,0.08,338,30970,70,NULL,NULL,'2MASX J11135802+0229569',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,168.4917917,2.499,0.113,NULL,60281803615,941903181,14717237,17.8),(78736,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78736,35.47,0.63,124,30971,70,NULL,NULL,'2MASX J11135896-4707095',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,168.495625,-47.11936,0.569,NULL,41933060909,655204076,10237563,16.4),(78737,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78737,37.59,0.11,329,30972,70,NULL,NULL,'2MASX J11135914+3926183',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000175,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,168.496541667,39.43844,0,NULL,63928210804,998878293,15607473,18),(78738,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78738,37.69,0.08,345,30973,70,NULL,NULL,'SDSS J111359.20+401919.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,168.4967083,40.32208,0.047,NULL,63928683669,998885682,15607588,18.1),(78739,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78739,38.14,0.46,424,30974,70,NULL,NULL,'2MASX J11135976+4208231',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,168.499208333,42.13983,0,NULL,63944346645,999130416,15611412,17.6),(78740,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78740,35.93,0.49,153,30975,75,NULL,'IR','FGC 1213',NULL,'2011yCatp016004901K',2011,1,0.69,NULL,'G',0.000048,NULL,'16.9g',0.15,'Sc',NULL,NULL,NULL,NULL,1,168.5115417,28.62628,0,NULL,60610439564,947038118,14797470,16.9),(78741,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78741,35.95,NULL,155,30975,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1213',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78742,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78742,35.98,NULL,157,30975,NULL,NULL,'Dipole + Quadrupole','FGC 1213',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78743,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78743,35.98,NULL,157,30975,NULL,NULL,NULL,'FGC 1213',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78744,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78744,36,NULL,159,30975,NULL,NULL,'Dipole','FGC 1213',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78745,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78745,38.15,0.46,426,30976,70,NULL,NULL,'2MASX J11140309+0623466',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,168.512875,6.39644,0.141,NULL,60335195817,942737434,14730272,17.9),(78746,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78746,37.07,0.46,260,30977,70,NULL,NULL,'2MASX J11140336+0313269',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000185,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,168.5139583,3.22422,0.109,NULL,60287064448,941985382,14718521,17),(78747,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78747,38.14,0.46,425,30978,70,NULL,NULL,'2MASX J11140359+1959350',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,168.514958333,19.99303,0,NULL,61093383003,954584109,14915376,18.1),(78748,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78748,37.86,0.46,373,30979,70,NULL,NULL,'2MASX J11140425+5141483',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000157,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,168.517583,51.69683,0,NULL,61787189433,965424834,15084763,17),(78749,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78749,37.51,0.46,317,30980,70,NULL,NULL,'2MASX J11140572+1414057',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.0001,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,168.5237917,14.23492,0.01,NULL,61105597496,954774960,14918358,17.6),(78750,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78750,37.64,0.08,338,30981,70,NULL,NULL,'2MASX J11140603+0223349',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000184,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,168.5252083,2.39297,0.113,NULL,60281808518,941903258,14717238,16.6),(78751,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78751,36.57,0.46,206,30982,70,NULL,NULL,'IC 0678',NULL,'2015arXiv151105856S',2015,1,0.84,'2011ApJ...735..125S gives z = 0.048008.','G',0.000167,NULL,'15.0g',0.58,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,168.526583,6.57719,0.129,NULL,60335662576,942744727,14730386,15),(78752,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78752,37.85,0.46,372,30983,70,NULL,NULL,'2MASX J11140650+0516039',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000179,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,168.527167,5.26778,0.189,NULL,60284892347,941951442,14717991,17.2),(78753,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78753,37.35,0.21,295,30984,70,NULL,NULL,'SDSS J111406.80+412845.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,168.528375,41.47936,0,NULL,63927347349,998864802,15607262,18),(78754,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78754,38.21,0.46,439,30985,70,NULL,NULL,'2MASX J11140687+5403456',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,168.5285,54.06272,0,NULL,61783068476,965360444,15083756,17.6),(78755,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78755,36.72,0.14,221,30986,70,NULL,NULL,'2MASX J11140734+5655056',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000183,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,168.53075,56.91839,0,NULL,61993056952,968641514,15135023,17.2),(78756,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78756,36.6,0.46,209,30987,70,NULL,NULL,'SDSS J111407.48+284028.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000171,NULL,'17.3g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,168.531208333,28.67469,0,NULL,60610384873,947037263,14797457,17.3),(78757,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78757,37.69,0.08,345,30988,70,NULL,NULL,'2MASX J11140754+4026414',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000166,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,168.5317083,40.44478,0.08,NULL,63926802812,998856293,15607129,18.2),(78758,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78758,35.7,0.83,138,30989,70,NULL,NULL,'2MASX J11140781-4454105',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,168.5324583,-44.90303,0.453,NULL,41942429383,655350459,10239850,16.6),(78759,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78759,38.1,0.46,416,30990,70,NULL,NULL,'SDSS J111408.13+195117.0',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,168.533916667,19.85475,0,NULL,61094053510,954594586,14915540,NULL),(78760,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78760,36.77,0.46,226,30991,70,NULL,NULL,'SDSS J111408.47+080714.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'18.0g',0.11,NULL,NULL,NULL,NULL,NULL,1,168.535333,8.12075,0.073,NULL,60337289577,942770149,14730783,18),(78761,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78761,35.73,0.46,140,30992,70,NULL,NULL,'II Zw 048',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000168,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,168.53825,30.34181,0,NULL,60657147859,947767935,14808873,16.4),(78762,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78762,38.08,0.46,414,30993,70,NULL,NULL,'SDSS J111409.81+002139.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000072,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,168.540917,0.36086,0.113,NULL,60280623234,941884738,14716949,18.2),(78763,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78763,37.69,0.08,345,30994,70,NULL,NULL,'2MASX J11140984+4022115',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000177,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,168.541208333,40.36986,0.047,NULL,63928694624,998885853,15607591,17.2),(78764,'Sosies','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78764,32.5,0.29,31.6,30995,NULL,NULL,NULL,'NGC 3583',NULL,'2002A&A...393...57T',2002,1,3.04,NULL,'G',0.00002,NULL,'12.5g',1.16,'SB(s)b','in a radial-velocity based grouping',NULL,NULL,NULL,1,168.545375,48.31853,0,NULL,63913477225,998648081,15603876,12.5),(78765,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78765,32.23,0.45,27.9,30995,NULL,NULL,'K','NGC 3583',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78766,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78766,32.28,0.47,28.6,30995,NULL,NULL,'H','NGC 3583',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78767,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78767,32.31,0.46,29,30995,NULL,NULL,'J','NGC 3583',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78768,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78768,32.64,0.4,33.7,30995,NULL,NULL,'mean','NGC 3583',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78769,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78769,32.65,0.4,34,30995,75,NULL,'B','NGC 3583',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78770,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78770,37.61,0.46,332,30996,70,NULL,NULL,'2MASX J11141098+0326449',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000188,NULL,'16.9g',0.24,'AGN',NULL,NULL,NULL,NULL,1,168.5457083,3.44567,0.109,NULL,60286907020,941982922,14718483,16.9),(78771,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78771,36.54,0.11,203,30997,70,NULL,NULL,'2MASX J11141109+2915151',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.90',0.18,'E',NULL,NULL,NULL,NULL,1,168.546,29.25442,0.015,NULL,60610720489,947042507,14797539,17.9),(78772,'Ring Diameter','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78772,34.6,0.84,83,30998,NULL,NULL,'Published at H = 100 km/s/Mpc','CGCG 291-042',NULL,'1981ApJS...45..541P',1981,1,0.74,NULL,'G',0.000067,NULL,'15.1g',0.58,'SB(r)bc:',NULL,NULL,NULL,NULL,1,168.5465,56.78508,0,NULL,61993721811,968651903,15135185,15.1),(78773,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78773,36.52,0.21,201,30999,70,NULL,NULL,'2MASX J11141133+6113127',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000164,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,168.54725,61.22019,0,NULL,61858307595,966536056,15102125,16.6),(78774,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78774,37.69,0.08,345,31000,70,NULL,NULL,'2MASX J11141195+4019595',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.0001,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,168.5499583,40.33306,0.047,NULL,63928696739,998885886,15607591,17.2),(78775,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78775,36.13,0.46,168,31001,70,NULL,NULL,'2MASX J11141214+2742441',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000182,NULL,'16.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,168.550541667,27.71219,0,NULL,60615849795,947122653,14798791,16.3),(78776,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78776,36.49,0.33,199,31002,70,NULL,NULL,'2MASX J11141250+3338587',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000174,NULL,'15.6g',0.47,NULL,NULL,NULL,NULL,NULL,1,168.5520417,33.64961,0.051,NULL,60649128653,947642635,14806916,15.6),(78777,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78777,37.74,0.46,353,31003,70,NULL,NULL,'2MASX J11141291+1552217',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,168.553708333,15.87283,0,NULL,61112853475,954888335,14920130,17.3),(78778,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78778,37.51,0.46,317,31004,70,NULL,NULL,'2MASX J11141286+2717541',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00014,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,168.553708333,27.29847,0,NULL,60615986314,947124786,14798824,18.2),(78779,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78779,39.23,0.46,701,31005,70,NULL,NULL,'SDSS J111413.05+314037.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000166,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,168.554417,31.67703,0,NULL,60656046480,947750726,14808605,18.7),(78780,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78780,36.82,0.46,231,31006,70,NULL,NULL,'SDSS J111413.97+310744.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,168.5582083,31.12892,0,NULL,60656757009,947761828,14808778,17.8),(78781,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78781,38.19,0.33,435,31007,70,NULL,NULL,'2MASX J11141487-0032091',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000082,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,168.561916667,-0.53586,0.117,NULL,40903036945,639109952,9986093,17.5),(78782,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78782,37.36,0.46,296,31008,70,NULL,NULL,'2MASX J11141497+4059485',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,168.5622917,40.99694,0,NULL,63927243186,998863174,15607237,17.6),(78783,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78783,38.08,0.46,414,31009,70,NULL,NULL,'SDSS J111417.05+084234.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,168.5710417,8.70958,0.069,NULL,60345559817,942899372,14732802,18.2),(78784,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78784,36.71,0.46,220,31010,70,NULL,NULL,'2MASX J11141723+0243234',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000156,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,168.5717917,2.72317,0.093,NULL,60281598748,941899980,14717187,16.5),(78785,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78785,37.57,0.46,326,31011,70,NULL,NULL,'2MASX J11142032+4401162',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000175,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,168.584667,44.02106,0,NULL,63954131994,999283312,15613801,16.9),(78786,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78786,35.9,0.65,151,31012,70,NULL,NULL,'2MASX J11142036-4625485',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,168.584917,-46.43011,0.585,NULL,41933266654,655207291,10237613,14.1),(78787,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78787,37.21,0.46,277,31013,70,NULL,NULL,'2MASX J11142087+0019254',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000079,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,168.5870417,0.32364,0.113,NULL,60280774507,941887101,14716985,17.4),(78788,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78788,37.51,0.46,317,31014,70,NULL,NULL,'2MASX J11142197+5903075',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000163,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,168.591541667,59.052,0,NULL,61979516073,968429938,15131717,17.2),(78789,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78789,36.86,0.46,236,31015,70,NULL,NULL,'2MASX J11142208+3007227',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00018,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,168.592083,30.12306,0,NULL,60655206733,947737605,14808400,17.2),(78790,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78790,37.69,0.08,345,31016,70,NULL,NULL,'2MASX J11142217+4031565',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00019,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,168.5922917,40.53258,0.08,NULL,63926817251,998856519,15607133,16.2),(78791,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78791,35.61,0.46,132,31017,70,NULL,NULL,'2MASX J11142264+0234314',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000173,NULL,'16.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,168.594333,2.57547,0.113,NULL,60281634128,941900533,14717195,16.5),(78792,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78792,37.38,0.46,299,31018,70,NULL,NULL,'2MASXi J1114238+343114',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000167,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,168.5995,34.52056,0,NULL,60646691700,947604557,14806321,17.9),(78793,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78793,38.46,0.46,492,31019,70,NULL,NULL,'SDSS J111424.09+073734.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,168.600417,7.62617,0.089,NULL,60337646691,942775729,14730870,18.3),(78794,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78794,35.42,0.33,121,31020,70,NULL,NULL,'KUG 1111+236B',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'16.6g',0.26,'Compact',NULL,NULL,NULL,NULL,1,168.6064583,23.38033,0,NULL,61088433226,954506769,14914168,16.6),(78795,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78795,36.58,0.51,207,31021,70,NULL,NULL,'2MASX J11142559-0715429',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.00011,NULL,'15.97',0.34,NULL,NULL,NULL,NULL,NULL,1,168.6067083,-7.26194,0.073,NULL,41015581758,640868464,10013569,15.97),(78796,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78796,36.45,0.46,195,31022,70,NULL,NULL,'2MASX J11142618+5039017',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,168.609167,50.65036,0,NULL,61781919367,965342490,15083476,17.3),(78797,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78797,31.43,0.43,19.3,31023,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3592',NULL,'2014MNRAS.444..527S',2014,1,1.46,'The 2MASS position is 9 arcsec southeast of the optical peak.','G',0.000033,NULL,'14.3g',0.5,'Sc? sp','X-ray-bright group member',NULL,NULL,NULL,1,168.6140417,17.26,0,NULL,61111735907,954870873,14919857,14.3),(78798,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78798,31.59,0.4,20.8,31023,NULL,NULL,NULL,'NGC 3592',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78799,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78799,31.6,0.43,20.9,31023,75,NULL,'3.6 micron, color corrected','NGC 3592',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78800,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78800,31.64,0.4,21.3,31023,75,NULL,NULL,'NGC 3592',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78801,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78801,31.73,0.2,22.2,31023,74.4,NULL,NULL,'NGC 3592',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78802,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78802,31.81,0.5,23,31023,NULL,NULL,'Malmquist cor.','NGC 3592',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78803,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78803,31.94,0.48,24.4,31023,NULL,NULL,NULL,'NGC 3592',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78804,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78804,32.05,0.4,25.7,31023,NULL,NULL,'mean','NGC 3592',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78805,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78805,32.16,0.49,27.1,31023,75,NULL,'IR','NGC 3592',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78806,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78806,32.37,0.47,29.8,31023,NULL,NULL,'H','NGC 3592',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78807,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78807,32.44,0.46,30.8,31023,NULL,NULL,'J','NGC 3592',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78808,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78808,32.48,0.45,31.4,31023,NULL,NULL,'K','NGC 3592',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78809,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78809,37.49,0.46,314,31024,70,NULL,NULL,'2MASX J11142800+4812367',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000159,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,168.616875,48.21031,0,NULL,63913556907,998649326,15603895,16.6),(78810,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78810,36.89,0.33,239,31025,70,NULL,NULL,'2MASX J11142881+4331371',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,168.619916667,43.52708,0,NULL,63953022702,999265979,15613530,17),(78811,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78811,36.25,0.54,178,31026,NULL,NULL,'Malmquist cor.','2MASX J11142927+2915151',NULL,'2009ApJS..182..474S',2009,1,0.63,NULL,'G',0.000027,NULL,'17.0g',0.15,'Sbc','Group member',NULL,NULL,NULL,1,168.621916667,29.25428,0.008,NULL,60610719553,947042493,14797538,17),(78812,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78812,36.55,0.47,204,31026,NULL,NULL,NULL,'2MASX J11142927+2915151',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78813,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78813,36.59,0.2,208,31026,74.4,NULL,NULL,'2MASX J11142927+2915151',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78814,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78814,37.37,0.46,298,31027,70,NULL,NULL,'2MASX J11142936+4039426',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000175,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,168.622167,40.66186,0.08,NULL,63926770872,998855794,15607121,18),(78815,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78815,37.35,0.21,295,31028,70,NULL,NULL,'2MASX J11142972+4122346',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000159,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,168.6240417,41.37617,0,NULL,63927326410,998864475,15607257,16.9),(78816,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78816,36.85,0.46,235,31029,70,NULL,NULL,'IC 2644',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000167,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,168.6242083,10.76847,0,NULL,60331805505,942684461,14729444,16.5),(78817,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78817,37.64,0.08,338,31030,70,NULL,NULL,'2MASX J11142998+0223084',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000178,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,168.625041667,2.38575,0.133,NULL,60281747040,941902297,14717223,17.4),(78818,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78818,37.3,0.46,288,31031,70,NULL,NULL,'2MASX J11143056+4822468',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000138,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,168.627417,48.37967,0,NULL,63913483639,998648181,15603877,17.5),(78819,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78819,37.35,0.21,295,31032,70,NULL,NULL,'2MASX J11143124+4131375',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000183,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,168.630125,41.52708,0,NULL,63927297511,998864023,15607250,17),(78820,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78820,37.27,0.46,285,31033,70,NULL,NULL,'2MASX J11143141-0034275',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000091,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,168.6307917,-0.57436,0.129,NULL,40902994973,639109296,9986082,17.4),(78821,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78821,32.37,0.2,29.8,31034,74.4,NULL,NULL,'UGC 06266',NULL,'2013AJ....146...86T',2013,1,0.72,NULL,'G',0.000017,NULL,'16.2g',0.46,'Sm',NULL,NULL,NULL,NULL,1,168.638917,43.236,0,NULL,63953167353,999268239,15613566,16.2),(78822,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78822,37.58,0.1,328,31035,70,NULL,NULL,'2MASX J11143406+5436164',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,168.642,54.60461,0,NULL,61962701259,968167207,15127612,17.6),(78823,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78823,37.78,0.46,360,31036,70,NULL,NULL,'SDSS J111434.17+394923.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,168.642375,39.82308,0,NULL,63928645386,998885084,15607579,18.2),(78824,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78824,38.04,0.17,405,31037,70,NULL,NULL,'2MASX J11143585+2445321',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,168.649375,24.75889,0,NULL,60569254700,946394604,14787415,17.4),(78825,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78825,36.82,0.6,231,31038,70,NULL,NULL,'2MASX J11143675-0721009',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.33',0.34,NULL,NULL,NULL,NULL,NULL,1,168.653,-7.3505,0.081,NULL,41015599132,640868736,10013574,16.33),(78826,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78826,28.71,0.4,5.5,31039,75,NULL,'B','NGC 3593',NULL,'1988NBGC.C....0000T',1988,1,1.46,NULL,'G',0.000013,NULL,'12.6g',1.06,'SA(s)0/a;HII   Sy2','in a radial-velocity based grouping',NULL,NULL,NULL,1,168.654167,12.81767,0,NULL,61103340327,954739692,14917807,12.6),(78827,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78827,29.76,0.2,8.95,31039,74.4,NULL,NULL,'NGC 3593',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78828,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78828,30.17,NULL,10.8,31039,NULL,NULL,NULL,'NGC 3593',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78829,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78829,37.58,0.1,328,31040,70,NULL,NULL,'2MASX J11143711+5429034',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000161,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,168.6544583,54.48419,0,NULL,61962601657,968165650,15127588,17.2),(78830,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78830,32.5,0.43,31.6,31041,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06271',NULL,'2014MNRAS.444..527S',2014,1,1.21,NULL,'G',0.000037,NULL,'14.5g',0.45,'Sa',NULL,NULL,NULL,NULL,1,168.6550417,30.31414,0,NULL,60657168734,947768261,14808879,14.5),(78831,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78831,36.43,0.81,193,31042,70,NULL,NULL,'2MASX J11143732-7442337',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,168.655583,-74.70936,0.557,NULL,39861023168,622828487,9731695,17.1),(78832,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78832,36.42,0.45,193,31043,NULL,NULL,'Malmquist cor.','2MASX J11143885+2905260',NULL,'2009ApJS..182..474S',2009,1,0.64,NULL,'G',0.000023,NULL,'16.7g',0.16,'Sb','Group member',NULL,NULL,NULL,1,168.6619583,29.09069,0.009,NULL,60610742126,947042845,14797544,16.7),(78833,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78833,36.7,0.4,219,31043,NULL,NULL,NULL,'2MASX J11143885+2905260',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78834,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78834,36.74,0.2,223,31043,74.4,NULL,NULL,'2MASX J11143885+2905260',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78835,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78835,38.18,0.46,433,31044,70,NULL,NULL,'2MASX J11143915+2207271',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,168.662875,22.12439,0,NULL,61101573365,954712083,14917376,18.1),(78836,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78836,37.66,0.46,341,31045,70,NULL,NULL,'2MASX J11143958+3913305',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,168.66475,39.22522,0,NULL,63928502528,998882852,15607544,17.4),(78837,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78837,38.62,0.46,529,31046,70,NULL,NULL,'2MASX J11143962+2404560',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,168.665083,24.08236,0,NULL,60569440961,946397515,14787461,18),(78838,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78838,36.82,0.46,231,31047,70,NULL,NULL,'2MASX J11143973+2443560',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',NULL,NULL,'15.6g',0.4,NULL,NULL,NULL,NULL,NULL,1,168.665583,24.73217,0,NULL,60569253317,946394583,14787415,15.6),(78839,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78839,35.97,0.59,157,31048,70,NULL,NULL,'2MASX J11144152-0756569',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.45',0.3,NULL,NULL,NULL,NULL,NULL,1,168.6732083,-7.94919,0.061,NULL,41013861159,640841580,10013149,16.45),(78840,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78840,38.08,0.46,413,31049,70,NULL,NULL,'SDSS J111441.68+243450.5',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.6g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,168.673708333,24.58072,0,NULL,60569746086,946402282,14787535,16.6),(78841,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78841,38,0.33,398,31050,70,NULL,NULL,'2MASX J11144189+5311448',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,168.6747083,53.19583,0,NULL,61785708669,965401697,15084401,17.3),(78842,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78842,36.13,0.46,168,31051,70,NULL,NULL,'2MASX J11144333+4230351',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000156,NULL,'16.4g',0.42,NULL,NULL,NULL,NULL,NULL,1,168.680583,42.50961,0,NULL,63945178350,999143411,15611615,16.4),(78843,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78843,36.24,0.27,177,31052,70,NULL,NULL,'CGCG 039-088 NED01',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.00012,NULL,'15.0g',0.56,'BrClG',NULL,NULL,NULL,NULL,1,168.680625,4.02453,0.121,NULL,60357838853,943091232,14735800,15),(78844,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78844,37.98,0.46,394,31053,70,NULL,NULL,'2MASX J11144427+0020374',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000083,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,168.6845,0.34369,0.129,NULL,60280770302,941887035,14716984,17.9),(78845,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78845,37.69,0.08,345,31054,70,NULL,NULL,'2MASX J11144479+4012410',NULL,'2015arXiv151105856S',2015,1,0.27,'1999A&AS..137..299P has V = 4590 km/s.','G',0.000172,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,168.68675,40.21147,0,NULL,63928705258,998886019,15607594,17.6),(78846,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78846,38.07,0.46,411,31055,70,NULL,NULL,'2MASX J11144490+0124535',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,168.687125,1.41481,0.113,NULL,60280799430,941887491,14716992,18),(78847,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78847,36.7,0.14,219,31056,70,NULL,NULL,'2MASX J11144500+2542070',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000176,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,168.687416667,25.70211,0,NULL,60600963778,946890059,14795157,17.1),(78848,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78848,30.21,NULL,11,31057,NULL,NULL,NULL,'SDSS J111445.01+123851.7',NULL,'2013AJ....145..101K',2013,1,0.42,NULL,'G',0.00007,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,168.687583333,12.64769,0,NULL,61103439658,954741244,14917831,17.4),(78849,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78849,36.55,0.2,204,31058,74.4,NULL,NULL,'IC 2648',NULL,'2013AJ....146...86T',2013,1,0.46,NULL,'G',0.000084,NULL,'16.0g',0.37,'Sb',NULL,NULL,NULL,NULL,1,168.690125,10.22483,0.029,NULL,60334580390,942727818,14730122,16),(78850,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78850,36.5,0.46,200,31059,70,NULL,NULL,'IC 2649',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000163,NULL,'15.0',0.6,NULL,NULL,NULL,NULL,NULL,1,168.6935417,11.12769,0,NULL,60331032667,942672385,14729256,15),(78851,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78851,36.7,0.14,219,31060,70,NULL,NULL,'2MASX J11144708+2550330',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000175,NULL,'16.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,168.696,25.84247,0,NULL,60600959586,946889993,14795156,16.4),(78852,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78852,37.52,0.46,319,31061,70,NULL,NULL,'2MASX J11144988+2811220',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000158,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,168.708083333,28.1895,0,NULL,60612246848,947066357,14797911,17.1),(78853,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78853,37.64,0.08,338,31062,70,NULL,NULL,'2MASX J11145034+0227375',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000191,NULL,'16.2g',0.42,'AGN',NULL,NULL,NULL,NULL,1,168.709833,2.46056,0.133,NULL,60349856979,942966515,14733851,16.2),(78854,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78854,37.11,0.27,264,31063,70,NULL,NULL,'IC 2652',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000199,NULL,'15.7g',0.51,'AGN',NULL,NULL,NULL,NULL,1,168.718,12.44806,0,NULL,61103668834,954744825,14917887,15.7),(78855,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78855,36.24,0.27,177,31064,70,NULL,NULL,'2MASX J11145351+0405375',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000165,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,168.722833333,4.09383,0.121,NULL,60357631757,943087996,14735749,16.5),(78856,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78856,37.58,0.1,328,31065,70,NULL,NULL,'2MASX J11145420+5445165',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,168.72575,54.7545,0,NULL,61962469688,968163588,15127556,17.8),(78857,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78857,37.11,0.27,264,31066,70,NULL,NULL,'2MASX J11145500+1227426',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.2g',0.27,'AGN',NULL,NULL,NULL,NULL,1,168.7292083,12.46169,0,NULL,61103666972,954744796,14917887,17.2),(78858,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78858,37.68,0.46,344,31067,70,NULL,NULL,'2MASX J11145544+4208382',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000181,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,168.7307917,42.14411,0,NULL,63945221787,999144090,15611626,16.9),(78859,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78859,37.36,0.46,296,31068,70,NULL,NULL,'SDSS J111456.13+635251.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000132,NULL,'18.6g',0.09,NULL,NULL,NULL,NULL,NULL,1,168.733917,63.881,0,NULL,61869278636,966707478,15104804,18.6),(78860,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78860,36.93,0.46,244,31069,70,NULL,NULL,'2MASX J11145642+1508376',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,168.7352083,15.14381,0,NULL,61117164474,954955694,14921182,17.4),(78861,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78861,35.61,0.46,132,31070,70,NULL,NULL,'CGCG 156-034',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000093,NULL,'14.9g',0.55,NULL,NULL,NULL,NULL,NULL,1,168.7372083,31.50831,0.006,NULL,60656881180,947763768,14808808,14.9),(78862,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78862,36.52,0.21,201,31071,70,NULL,NULL,'2MASX J11145792+6110304',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000183,NULL,'16.4g',0.27,'AGN',NULL,NULL,NULL,NULL,1,168.740958333,61.17528,0,NULL,61858388633,966537322,15102145,16.4),(78863,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78863,37.64,0.08,338,31072,70,NULL,NULL,'2MASX J11145841+0245065',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.71',0.16,'BrClG',NULL,NULL,NULL,NULL,1,168.7434583,2.75192,0.113,NULL,60349804960,942965702,14733839,18.71),(78864,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78864,38,0.46,398,31073,70,NULL,NULL,'2MASX J11145847+5337298',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000171,NULL,'17.0g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,168.74375,53.62492,0,NULL,61782810615,965356415,15083693,17),(78865,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78865,34.81,0.46,91.5,31074,70,NULL,NULL,'CGCG 039-089 NED01',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.00011,NULL,'14.7g',0.64,'S0',NULL,NULL,NULL,NULL,1,168.7485,3.60211,0.109,NULL,60357942666,943092854,14735825,14.7),(78866,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78866,37.26,0.46,283,31075,70,NULL,NULL,'2MASX J11150113+2728289',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00018,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,168.754875,27.47461,0,NULL,60615973999,947124593,14798821,16.2),(78867,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78867,35.75,0.73,141,31076,NULL,NULL,'Malmquist cor.','2MASX J11150175+2909199',NULL,'2009ApJS..182..474S',2009,1,0.47,NULL,'G',0.000027,NULL,'16.1g',0.43,'SBa','Group member',NULL,NULL,NULL,1,168.7572083,29.15558,0.008,NULL,60609887599,947029493,14797335,16.1),(78868,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78868,36.11,0.62,166,31076,NULL,NULL,NULL,'2MASX J11150175+2909199',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78869,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78869,36.15,0.2,170,31076,74.4,NULL,NULL,'2MASX J11150175+2909199',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78870,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78870,37.56,0.46,325,31077,70,NULL,NULL,'2MASX J11150196+4725432',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000168,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,168.758125,47.42861,0,NULL,63950092006,999220187,15612815,17.9),(78871,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78871,37.11,0.27,264,31078,70,NULL,NULL,'IC 2654',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,168.761917,12.49947,0,NULL,61103654989,954744609,14917884,16.7),(78872,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78872,36.7,0.14,219,31079,70,NULL,NULL,'2MASX J11150296+2605219',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,168.762375,26.08953,0,NULL,60601398951,946896858,14795263,16.6),(78873,'IRAS','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78873,33.33,0.8,46.3,31080,75,NULL,'MAT, I','ESO 438- G 015',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.00003,NULL,'13.80',0.9,'SB(rs)bc       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,168.764,-28.39242,0.325,NULL,41553578081,649274657,10144916,13.8),(78874,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78874,32.76,NULL,35.7,31080,NULL,NULL,'B','ESO 438- G 015',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78875,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78875,32.88,0.32,37.7,31080,85,NULL,'I, raw','ESO 438- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78876,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78876,32.92,0.32,38.3,31080,85,NULL,'I, inv','ESO 438- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78877,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78877,33,0.43,39.8,31080,75,NULL,'3.6 micron, color corrected','ESO 438- G 015',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78878,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78878,33.01,0.2,40,31080,74.4,NULL,NULL,'ESO 438- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78879,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78879,33.03,0.43,40.3,31080,75,NULL,'3.6 micron, color + selection bias corrected','ESO 438- G 015',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78880,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78880,33.08,0.43,41.3,31080,75,NULL,'MAT, I, raw','ESO 438- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78881,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78881,33.15,NULL,42.7,31080,NULL,NULL,'I','ESO 438- G 015',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78882,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78882,33.27,0.43,45,31080,75,NULL,'MAT, I, inv','ESO 438- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78883,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78883,33.32,0.47,46.2,31080,NULL,NULL,'H','ESO 438- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78884,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78884,33.35,0.43,46.7,31080,75,NULL,'MAT, I, cor','ESO 438- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78885,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78885,33.38,0.46,47.5,31080,NULL,NULL,'J','ESO 438- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78886,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78886,33.49,0.45,49.8,31080,NULL,NULL,'K','ESO 438- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78887,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78887,33.57,0.4,51.8,31080,NULL,NULL,'mean','ESO 438- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78888,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78888,33.63,0.08,53.3,31080,NULL,NULL,NULL,'ESO 438- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78889,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78889,38.1,0.46,418,31081,70,NULL,NULL,'2MASX J11150428+3903071',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,168.767958333,39.05208,0.006,NULL,63928531185,998883299,15607551,17.9),(78890,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78890,38.21,0.23,439,31082,70,NULL,NULL,'IC 2655',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000184,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,168.7715,12.16439,0,NULL,61102711372,954729865,14917654,17.3),(78891,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78891,36.52,0.21,201,31083,70,NULL,NULL,'MCG +10-16-094',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000179,NULL,'16.0g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,168.771875,61.08169,0,NULL,61858446844,966538231,15102159,16),(78892,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78892,37.92,0.46,384,31084,70,NULL,NULL,'2MASX J11150544-0031217',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000073,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,168.772583,-0.52283,0.129,NULL,41037176429,641205881,10018841,17.7),(78893,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78893,38.37,0.46,472,31085,70,NULL,NULL,'2MASX J11150580+0423445',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.001204,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,168.7740417,4.39575,0.097,NULL,60359766234,943121347,14736271,18.2),(78894,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78894,29.49,0.4,7.9,31086,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 3 galaxy group','NGC 3596',NULL,'1992ApJS...80..479T',1992,1,4,NULL,'G',0.000003,NULL,'11.95',3.8,'SAB(rs)c       HII','Probable group member',NULL,NULL,NULL,1,168.775875,14.78703,0,NULL,61117215566,954956493,14921195,11.95),(78895,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78895,31.81,0.4,23,31086,75,NULL,'B','NGC 3596',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78896,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78896,36.91,0.46,242,31087,70,NULL,NULL,'2MASX J11150659+5539374',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000191,NULL,'16.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,168.777667,55.66058,NULL,NULL,61992330341,968630161,15134846,16.7),(78897,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78897,37.9,0.46,381,31088,70,NULL,NULL,'SDSS J111507.29+425410.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,168.780417,42.90306,0,NULL,63944890228,999138909,15611545,17.9),(78898,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78898,36.61,0.46,210,31089,70,NULL,NULL,'2MASX J11150785+0842463',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,168.7827083,8.71286,0.057,NULL,60345788246,942902941,14732858,17.5),(78899,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78899,37.95,0.33,389,31090,70,NULL,NULL,'SDSS J111508.33+525130.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000139,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,168.78475,52.85847,0,NULL,61784529495,965383273,15084113,18.6),(78900,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78900,37.05,0.46,257,31091,70,NULL,NULL,'2MASX J11150870+0152385',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00018,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,168.786417,1.87728,0.109,NULL,60350231693,942972370,14733943,16.9),(78901,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78901,38.43,0.46,486,31092,70,NULL,NULL,'2MASX J11150966+2857039',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000169,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,168.790083333,28.95111,0.009,NULL,60609967027,947030734,14797355,18),(78902,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78902,35.28,0.46,114,31093,70,NULL,NULL,'UGC 06276',NULL,'2015arXiv151105856S',2015,1,0.88,NULL,'G',0.000087,NULL,'14.3g',0.7,'S0',NULL,NULL,NULL,NULL,1,168.79175,31.03369,0,NULL,60656631571,947759868,14808747,14.3),(78903,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78903,35.55,0.4,129,31093,NULL,NULL,'mean','UGC 06276',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78904,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78904,35.93,0.45,153,31093,NULL,NULL,'K','UGC 06276',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78905,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78905,36.52,0.21,201,31094,70,NULL,NULL,'MCG +10-16-097',NULL,'2015arXiv151105856S',2015,1,0.84,'MCG declination +19 arcmin in error.','G',0.000185,NULL,'15.3g',0.52,'BrClG',NULL,NULL,NULL,NULL,1,168.792125,61.11019,0,NULL,61858443422,966538178,15102159,15.3),(78906,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78906,38.62,0.33,529,31095,70,NULL,NULL,'2MASX J11151038-0102017',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00008,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,168.793166667,-1.03386,0.137,NULL,41037494760,641210855,10018919,17.8),(78907,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78907,37.72,0.46,350,31096,70,NULL,NULL,'2MASX J11151135+3500190',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000194,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,168.797375,35.00539,0,NULL,60646492464,947601444,14806272,16.6),(78908,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78908,38.21,0.23,439,31097,70,NULL,NULL,'SDSS J111511.46+121107.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,168.7977917,12.18542,0,NULL,61102743565,954730368,14917662,17.9),(78909,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78909,37.86,0.46,373,31098,70,NULL,NULL,'2MASX J11151209+1236549',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000144,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,168.8002083,12.61522,0,NULL,61103451448,954741428,14917834,17.6),(78910,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78910,37.58,0.1,328,31099,70,NULL,NULL,'2MASX J11151209+5426334',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000192,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,168.800417,54.44244,0,NULL,61962665997,968166656,15127604,17),(78911,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78911,36.17,0.46,171,31100,70,NULL,NULL,'2MASX J11151214+2829528',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000161,NULL,'16.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,168.800541667,28.49811,0,NULL,60612862230,947075972,14798062,16.9),(78912,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78912,36.49,0.33,199,31101,70,NULL,NULL,'2MASX J11151218+3326300',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000161,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,168.800667,33.44164,0.053,NULL,60645761348,947590021,14806094,17.1),(78913,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78913,37.64,0.08,338,31102,70,NULL,NULL,'2MASX J11151316+0224125',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,168.804875,2.40361,0.133,NULL,60349872095,942966751,14733855,17.6),(78914,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78914,37.24,0.49,280,31103,NULL,NULL,'Malmquist cor.','2MASX J11151319+2916158',NULL,'2009ApJS..182..474S',2009,1,0.53,NULL,'G',0.000027,NULL,'15.8g',0.3,'Sbc','Group member',NULL,NULL,NULL,1,168.804833,29.27128,0.008,NULL,60609920503,947030007,14797343,15.8),(78915,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78915,37.49,0.44,315,31103,NULL,NULL,NULL,'2MASX J11151319+2916158',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78916,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78916,37.53,0.2,321,31103,74.4,NULL,NULL,'2MASX J11151319+2916158',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78917,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78917,31.81,0.2,23,31104,74.4,NULL,NULL,'NGC 3589',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000033,NULL,'14.35',0.8,'Sd:','in a radial-velocity based grouping',NULL,NULL,NULL,1,168.8055417,60.69992,0,NULL,61858570163,966540158,15102189,14.35),(78918,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78918,31.93,0.43,24.3,31104,75,NULL,'3.6 micron, color corrected','NGC 3589',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78919,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78919,32.03,0.43,25.4,31104,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3589',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78920,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78920,38.05,0.33,408,31105,70,NULL,NULL,'SDSS J111514.05+482858.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000162,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,168.808583,48.48281,0,NULL,63913505938,998648530,15603883,18.2),(78921,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78921,38.21,0.23,439,31106,70,NULL,NULL,'2MASX J11151491+1214239',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,168.812125,12.24,0,NULL,61103594867,954743669,14917869,17.5),(78922,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78922,38.67,0.46,542,31107,70,NULL,NULL,'SDSS J111514.95+035316.1',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000179,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,168.812333,3.88783,0.121,NULL,60357694960,943088983,14735765,18.8),(78923,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78923,37.32,0.46,291,31108,70,NULL,NULL,'2MASX J11151554+0547223',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,168.81475,5.78956,0.173,NULL,60389621439,943587834,14743559,17.6),(78924,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78924,37.34,0.46,294,31109,70,NULL,NULL,'SDSS J111515.72+261210.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.6g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,168.815541667,26.20278,0,NULL,60601291693,946895182,14795237,17.6),(78925,'GRB','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78925,45.24,1.55,3570,31110,100,NULL,NULL,'GRB 011211',2.14,'2009EPJC...63..139W',2009,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'SAX/WFC',NULL,NULL,NULL,NULL,1,168.816667,-21.92889,0.145,NULL,41724107203,651939175,10186549,NULL),(78926,'GRB','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78926,45.33,1.48,3710,31110,100,NULL,NULL,'GRB 011211',2.14,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78927,'GRB','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78927,45.53,0.43,4070,31110,69.7,NULL,'Calibrated','GRB 011211',2.14,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78928,'GRB','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78928,45.55,0.57,4100,31110,72,NULL,NULL,'GRB 011211',2.14,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78929,'GRB','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78929,45.64,0.53,4280,31110,70,NULL,NULL,'GRB 011211',2.14,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78930,'GRB','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78930,45.77,0.62,4540,31110,69.7,NULL,'Fiducial','GRB 011211',2.14,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78931,'GRB','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78931,45.85,0.63,4710,31110,NULL,NULL,NULL,'GRB 011211',2.14,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78932,'GRB','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78932,47.54,0.45,7490,31110,73,NULL,'H const./H=100','GRB 011211',2.14,'2006astro.ph..9262M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78933,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78933,36.52,0.21,201,31111,70,NULL,NULL,'MCG +10-16-097 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.001191,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,168.818791667,61.11086,0,NULL,61858436344,966538067,15102157,16.6),(78934,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78934,37.9,0.46,379,31112,70,NULL,NULL,'2MASX J11151652+3227021',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000147,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,168.818875,32.45067,0.048,NULL,60645703261,947589113,14806079,17.5),(78935,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78935,37.93,0.21,385,31113,70,NULL,NULL,'2MASX J11151698+0307343',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000175,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,168.820833,3.12631,0.101,NULL,60357109931,943079842,14735622,16.9),(78936,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78936,38.62,0.33,529,31114,70,NULL,NULL,'SDSS J111517.02-010149.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000072,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,168.820958333,-1.03047,0.137,NULL,41037487247,641210738,10018917,18.3),(78937,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78937,36.7,0.14,219,31115,70,NULL,NULL,'2MASX J11151741+2550268',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,168.82275,25.84086,0,NULL,60601244981,946894452,14795225,17.4),(78938,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78938,36.71,0.46,219,31116,70,NULL,NULL,'2MASX J11151780+6558371',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000087,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,168.8242083,65.97706,0,NULL,61812132101,965814564,15090852,16.3),(78939,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78939,37.93,0.21,385,31117,70,NULL,NULL,'2MASX J11151944+0331073',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,168.8309583,3.51864,0.109,NULL,60357259973,943082187,14735659,17.4),(78940,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78940,37.74,0.46,354,31118,70,NULL,NULL,'SDSS J111520.14+005803.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000067,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,168.8339583,0.9675,0.133,NULL,60348300396,942942193,14733471,18.5),(78941,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78941,37.58,0.1,328,31119,70,NULL,NULL,'2MASX J11152081+5427257',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000188,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,168.8367917,54.45711,0,NULL,61962486677,968163854,15127560,17.7),(78942,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78942,37.82,0.46,366,31120,70,NULL,NULL,'2MASX J11152151+2843478',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'16.9g',0.28,'E',NULL,NULL,NULL,NULL,1,168.839625,28.73017,0,NULL,60611966382,947061974,14797843,16.9),(78943,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78943,35.87,0.33,149,31121,70,NULL,NULL,'CGCG 267-055',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.00009,NULL,'15.2g',0.63,'E0',NULL,NULL,NULL,NULL,1,168.841541667,55.97392,0,NULL,61995493326,968679583,15135618,15.2),(78944,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78944,37.67,0.46,343,31122,70,NULL,NULL,'2MASX J11152249+5452467',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00018,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,168.843667,54.87956,0,NULL,61992038965,968625608,15134775,16.9),(78945,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78945,36.7,0.14,219,31123,70,NULL,NULL,'2MASX J11152298+2556228',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000073,NULL,'15.3g',0.56,NULL,NULL,NULL,NULL,NULL,1,168.845791667,25.93972,0,NULL,60601248733,946894511,14795226,15.3),(78946,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78946,37.84,0.33,370,31124,70,NULL,NULL,'2MASX J11152318+4136410',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000208,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,168.846417,41.61153,0,NULL,63927037489,998859960,15607186,16.7),(78947,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78947,37.58,0.1,328,31125,70,NULL,NULL,'2MASX J11152391+5426377',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000192,NULL,'15.3g',0.6,'BrClG',NULL,NULL,NULL,NULL,1,168.8494583,54.44411,0,NULL,61782115194,965345549,15083524,15.3),(78948,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78948,37.64,0.08,338,31126,70,NULL,NULL,'2MASX J11152413+0259233',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000176,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,168.8504583,2.98989,0.101,NULL,60361332014,943145812,14736653,16.8),(78949,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78949,38.59,0.46,522,31127,70,NULL,NULL,'SDSS J111524.14+213544.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,168.850583,21.59581,0,NULL,61101645414,954713209,14917393,18.2),(78950,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78950,37.51,0.46,317,31128,70,NULL,NULL,'2MASX J11152449+4032280',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000183,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,168.852041667,40.54125,0,NULL,63928667032,998885422,15607584,17.6),(78951,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78951,36.7,0.14,219,31129,70,NULL,NULL,'SDSS J111524.61+254154.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.7g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,168.852583,25.69833,0,NULL,60600999059,946890610,14795165,17.7),(78952,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78952,36.79,0.46,228,31130,70,NULL,NULL,'2MASX J11152501+3700390',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00018,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,168.854167,37.01092,0,NULL,60428852227,944200816,14753137,16.7),(78953,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78953,36.13,0.78,169,31131,70,NULL,NULL,'ESO 007- G 005',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'16.5b',0.5,'SBa:',NULL,NULL,NULL,NULL,1,168.856167,-83.57439,0.313,NULL,39757206253,621206347,9706349,16.5),(78954,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78954,36.7,0.14,219,31132,70,NULL,NULL,'2MASX J11152625+2557417',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000178,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,168.8595,25.96164,0,NULL,60601255438,946894616,14795228,16.5),(78955,'SBF','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78955,31.49,0.14,19.9,31133,74.4,NULL,NULL,'NGC 3599',NULL,'2013AJ....146...86T',2013,1,2.7,NULL,'G',0.000017,NULL,'12.82',2.1,'SA0:           LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,168.862333333,18.11039,0,NULL,61120224613,955003509,14921929,12.82),(78956,'SBF','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78956,31.54,0.18,20.3,31133,NULL,NULL,'I','NGC 3599',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78957,'SBF','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78957,31.54,0.18,20.3,31133,NULL,NULL,NULL,'NGC 3599',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78958,'SBF','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78958,31.56,0.18,20.5,31133,NULL,NULL,'Malmquist cor.','NGC 3599',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78959,'Faber-Jackson','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78959,31.57,0.63,20.6,31133,95,NULL,'Michard 1979b, c','NGC 3599',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78960,'Faber-Jackson','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78960,31.75,0.44,22.4,31133,95,NULL,'Weighted Mean','NGC 3599',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78961,'Faber-Jackson','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78961,32.35,0.46,29.5,31133,95,NULL,'Michard 1979a','NGC 3599',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78962,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78962,31.34,0.41,18.5,31133,NULL,NULL,NULL,'NGC 3599',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78963,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78963,31.47,0.41,19.7,31133,NULL,NULL,'Malmquist cor.','NGC 3599',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78964,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78964,31.4,0.4,19.1,31133,NULL,NULL,'mean','NGC 3599',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78965,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78965,31.41,0.45,19.2,31133,NULL,NULL,'K','NGC 3599',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78966,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78966,36.24,0.27,177,31134,70,NULL,NULL,'2MASX J11152717+0408203',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000169,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,168.8632083,4.13908,0.121,NULL,60357832841,943091138,14735799,17.2),(78967,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78967,38.26,0.46,449,31135,70,NULL,NULL,'SDSS J111527.36+052152.2',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,168.8640417,5.36453,0.185,NULL,60356116979,943064327,14735380,18),(78968,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78968,35.47,0.49,124,31136,75,NULL,'IR','IC 2661',NULL,'2011yCatp016004901K',2011,1,0.69,NULL,'G',0.00028,NULL,'15.4',0.17,NULL,NULL,NULL,NULL,NULL,1,168.8715417,13.60867,0,NULL,61106691311,954792051,14918625,15.4),(78969,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78969,36.54,0.11,203,31137,70,NULL,NULL,'2MASX J11153018+2921367',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000123,NULL,'16.4g',0.25,'S0','Group member',NULL,NULL,NULL,1,168.87575,29.36017,0.008,NULL,60609893202,947029581,14797337,16.4),(78970,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78970,38.05,0.15,407,31138,70,NULL,NULL,'2MASX J11153060+3710430',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,168.8774583,37.17872,0,NULL,60429333808,944208340,14753255,16.9),(78971,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78971,38.25,0.33,447,31139,70,NULL,NULL,'SDSS J111531.36+502853.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,168.8807083,50.48167,0,NULL,61782077579,965344962,15083515,18.4),(78972,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78972,36.7,0.14,219,31140,70,NULL,NULL,'2MASX J11153137+2558087',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000165,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,168.8809583,25.96914,0,NULL,60601257567,946894649,14795228,16.4),(78973,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78973,37.8,0.46,363,31141,70,NULL,NULL,'2MASX J11153202+3236091',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000183,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,168.8835,32.60244,0.058,NULL,60645528018,947586375,14806037,17.3),(78974,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78974,34.33,0.47,73.5,31142,NULL,NULL,'H','IC 2668',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000023,NULL,'14.59',0.7,'SB(rs)a pec',NULL,NULL,NULL,NULL,1,168.8845,-14.17108,0.189,NULL,41692904119,651451626,10178931,14.59),(78975,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78975,34.35,0.4,74.2,31142,NULL,NULL,'mean','IC 2668',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78976,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78976,34.41,0.45,76.2,31142,NULL,NULL,'K','IC 2668',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78977,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78977,34.5,0.46,79.6,31142,NULL,NULL,'J','IC 2668',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78978,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78978,36.76,0.46,224,31143,70,NULL,NULL,'2MASX J11153244+0053054',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000086,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,168.885083,0.88483,0.133,NULL,60348239906,942941248,14733457,16.4),(78979,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78979,37.84,0.33,370,31144,70,NULL,NULL,'2MASX J11153424+4141240',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,168.892625,41.69008,0,NULL,63944660839,999135325,15611489,17.3),(78980,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78980,37.14,0.46,268,31145,70,NULL,NULL,'2MASX J11153447+3850170',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,168.893625,38.83825,0,NULL,63928443686,998881932,15607530,17.4),(78981,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78981,35.38,0.46,119,31146,70,NULL,NULL,'CGCG 185-025',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000103,NULL,'15.0g',0.61,NULL,NULL,NULL,NULL,NULL,1,168.896583,36.50914,0,NULL,60430542664,944227229,14753550,15),(78982,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78982,37.54,0.33,322,31147,70,NULL,NULL,'SDSS J111536.56+054449.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000132,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,168.902375,5.74714,0.189,NULL,60389818493,943590913,14743608,18.1),(78983,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78983,36.54,0.11,203,31148,70,NULL,NULL,'2MASX J11153680+2901476',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000143,NULL,'16.5g',0.28,'S0','Group member',NULL,NULL,NULL,1,168.903125,29.03,0,NULL,60610044056,947031938,14797374,16.5),(78984,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78984,37.58,0.1,328,31149,70,NULL,NULL,'2MASX J11153755+5424068',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,168.90675,54.40197,0,NULL,61782329836,965348903,15083576,17.5),(78985,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78985,37.91,0.46,381,31150,70,NULL,NULL,'2MASX J11153790+4944278',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,168.908,49.74111,0,NULL,61778680768,965291887,15082685,17.9),(78986,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78986,37.35,0.21,295,31151,70,NULL,NULL,'2MASX J11153867+4118050',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000174,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,168.911167,41.30142,0,NULL,63927049501,998860148,15607189,16.5),(78987,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78987,37.64,0.08,338,31152,70,NULL,NULL,'2MASX J11154149+0222064',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000187,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,168.922917,2.36844,0.117,NULL,60350700602,942979696,14734057,16.6),(78988,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,78988,35.96,0.7,156,31153,70,NULL,NULL,'LCRS B111309.6-055625',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'15.44',0.3,NULL,NULL,NULL,NULL,NULL,1,168.924916667,-6.21297,0.049,NULL,41012067776,640813559,10012711,15.44),(78989,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78989,37.64,0.08,338,31154,70,NULL,NULL,'2MASX J11154222+0253324',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000147,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,168.9260417,2.89236,0.101,NULL,60361308123,943145439,14736647,17.4),(78990,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78990,38.05,0.33,408,31155,70,NULL,NULL,'SDSS J111542.43+483533.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,168.926833333,48.59264,0,NULL,63913607985,998650124,15603908,18.3),(78991,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78991,37.85,0.27,371,31156,70,NULL,NULL,'SDSS J111542.45+404242.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,168.926917,40.71192,0,NULL,63927092387,998860818,15607200,18.6),(78992,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78992,36.28,0.46,180,31157,70,NULL,NULL,'2MASX J11154288+0449094',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,168.9287917,4.81917,0.153,NULL,60356403314,943068801,14735450,17.3),(78993,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78993,37.54,0.33,322,31158,70,NULL,NULL,'2MASX J11154309+0543470',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,168.9294583,5.72964,0.189,NULL,60389687604,943588868,14743576,17.7),(78994,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78994,37.58,0.1,328,31159,70,NULL,NULL,'2MASX J11154329+5431198',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000177,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,168.930625,54.52233,0,NULL,61962501407,968164084,15127563,17.3),(78995,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78995,37.46,0.46,310,31160,70,NULL,NULL,'SDSS J111543.85+121450.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,168.93275,12.24733,0,NULL,61103554447,954743038,14917859,17.9),(78996,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78996,36.72,0.21,221,31161,70,NULL,NULL,'IC 2667',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000172,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,168.9335,12.11683,0,NULL,61102688708,954729511,14917648,16.6),(78997,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78997,38.69,0.46,547,31162,70,NULL,NULL,'2MASX J11154432+1038428',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'17.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,168.934708333,10.64522,0.027,NULL,60331206433,942675100,14729298,17.9),(78998,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78998,37.06,0.46,259,31163,70,NULL,NULL,'2MASX J11154503+4804532',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000182,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,168.937667,48.08156,0,NULL,63913560232,998649378,15603896,16.7),(78999,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',78999,38.15,0.46,426,31164,70,NULL,NULL,'2MASX J11154536+2432387',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,168.939,24.54408,0,NULL,60569917907,946404967,14787577,18.4),(79000,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',79000,37.63,0.46,336,31165,70,NULL,NULL,'2MASXi J1115454+453732',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000174,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,168.939625,45.62558,0,NULL,63947673171,999182393,15612224,17.5),(79001,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',79001,37.85,0.27,371,31166,70,NULL,NULL,'2MASX J11154583+4042030',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000179,NULL,'17.2g',0.23,'AGN',NULL,NULL,NULL,NULL,1,168.941125,40.70094,0,NULL,63929124972,998892577,15607696,17.2),(79002,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',79002,36.7,0.14,219,31167,70,NULL,NULL,'SDSS J111545.88+254948.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000175,NULL,'17.2g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,168.9412083,25.83019,0,NULL,60601214504,946893976,14795218,17.2),(79003,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',79003,37.45,0.46,309,31168,70,NULL,NULL,'II Zw 050 NOTES02',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000193,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,168.944125,28.53964,0,NULL,60612855800,947075871,14798060,16.7),(79004,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',79004,38.04,0.17,405,31169,70,NULL,NULL,'2MASX J11154697+2440037',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,168.94575,24.66772,0,NULL,60569940295,946405317,14787583,18),(79005,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',79005,38,0.33,398,31170,70,NULL,NULL,'2MASX J11154728+5310473',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000144,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,168.946833,53.17981,0,NULL,61785760803,965402512,15084414,17.7),(79006,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',79006,35.87,0.33,149,31171,70,NULL,NULL,'SDSS J111547.26+560704.0',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,168.946958333,56.11786,0,NULL,61993400584,968646884,15135107,17.1),(79007,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',79007,37.58,0.1,328,31172,70,NULL,NULL,'2MASX J11154743+5432528',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000199,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,168.9477083,54.54792,0,NULL,61962490986,968163921,15127561,16.5),(79008,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',79008,38.5,0.46,502,31173,70,NULL,NULL,'SDSS J111547.63+561441.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000141,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,168.9485,56.24478,0,NULL,61993412367,968647068,15135110,18.3),(79009,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',79009,38.4,0.46,479,31174,70,NULL,NULL,'SDSS J111548.49+290739.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000141,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,168.9520417,29.12764,0,NULL,60610051419,947032053,14797375,18.2),(79010,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',79010,36.7,0.46,219,31175,70,NULL,NULL,'2MASX J11154919+1338119',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000172,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,168.9550417,13.63656,0.02,NULL,61106739018,954792797,14918637,16.8),(79011,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',79011,37.71,0.46,349,31176,70,NULL,NULL,'2MASX J11154953+1113205',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000181,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,168.956375,11.22219,0,NULL,60331776895,942684013,14729437,17.7),(79012,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',79012,37.91,0.46,381,31177,70,NULL,NULL,'2MASX J11155034+4323177',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000171,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,168.959667,43.38819,0,NULL,63952964225,999265066,15613516,18),(79013,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',79013,37.85,0.46,372,31178,70,NULL,NULL,'SDSS J111551.84+111534.5',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,168.966,11.25961,0,NULL,60331775305,942683989,14729437,17.6),(79014,'IRAS','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,79014,30.68,0.8,13.7,31179,75,NULL,'A82, H','NGC 3600',NULL,'1997ApJS..109..333W',1997,1,1.28,'The Bologna position is 6 arcsec northwest of the nucleus.','G',0.000033,NULL,'13.4g',0.83,'Sa?','Possible field galaxy',NULL,NULL,NULL,1,168.9667083,41.59103,0,NULL,63944680338,999135630,15611494,13.4),(79015,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,79015,30.11,0.4,10.5,31179,75,NULL,'B','NGC 3600',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79016,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,79016,30.17,0.4,10.8,31179,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 3600',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79017,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,79017,30.64,0.47,13.4,31179,75,NULL,'A82, H, inv','NGC 3600',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79018,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,79018,30.74,0.47,14.1,31179,75,NULL,'A82, H, raw','NGC 3600',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79019,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,79019,31.05,0.47,16.2,31179,75,NULL,'A82, H, cor','NGC 3600',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79020,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,79020,31.45,0.4,19.5,31179,NULL,NULL,'mean','NGC 3600',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79021,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,79021,31.87,0.47,23.6,31179,NULL,NULL,'H','NGC 3600',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79022,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,79022,31.91,0.45,24.1,31179,NULL,NULL,'K','NGC 3600',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79023,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,79023,31.91,0.46,24.1,31179,NULL,NULL,'J','NGC 3600',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79024,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',79024,36.73,0.46,222,31180,70,NULL,NULL,'2MASX J11155236+1458459',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000107,NULL,'17.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,168.968125,14.97947,0,NULL,61117298569,954957790,14921215,17.2),(79025,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',79025,37.3,0.46,289,31181,70,NULL,NULL,'2MASX J11155382+3027517',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000175,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,168.974291667,30.46428,0,NULL,60657009144,947765767,14808840,17.1),(79026,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',79026,36.54,0.11,203,31182,70,NULL,NULL,'2MASX J11155551+2918198',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000168,NULL,'17.1g',0.27,'E','Group member',NULL,NULL,NULL,1,168.981166667,29.30567,0.008,NULL,60609890921,947029545,14797336,17.1),(79027,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',79027,37.12,0.46,265,31183,70,NULL,NULL,'2MASX J11155550+0707395',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,168.9812917,7.12761,0.121,NULL,60335776222,942746503,14730414,17.4),(79028,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',79028,37.58,0.1,328,31184,70,NULL,NULL,'SDSS J111555.78+543553.4',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,168.9824583,54.59822,0,NULL,61962518431,968164350,15127567,17.2),(79029,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',79029,38.85,0.46,589,31185,70,NULL,NULL,'SDSS J111556.30+422246.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,168.984625,42.37944,0,NULL,63945288743,999145136,15611642,18.2),(79030,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',79030,38.52,0.46,505,31186,70,NULL,NULL,'2MASX J11155700+4305024',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,168.9875,43.08417,0,NULL,63944806130,999137595,15611524,18.1),(79031,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',79031,37.34,0.46,294,31187,70,NULL,NULL,'2MASX J11155712+0622385',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000171,NULL,'16.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,168.9880417,6.37744,0.165,NULL,60335187742,942737308,14730270,16.4),(79032,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',79032,37.48,0.46,313,31188,70,NULL,NULL,'2MASX J11155865+3350157',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000126,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,168.99425,33.83789,0.027,NULL,60642595288,947540551,14805321,18.5),(79033,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',79033,37.48,0.33,313,31189,70,NULL,NULL,'SDSS J111558.65+350609.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000171,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,168.994417,35.10261,0,NULL,60421051822,944078934,14751233,17.7),(79034,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',79034,37.93,0.21,385,31190,70,NULL,NULL,'2MASX J11155912+0327480',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,168.9965,3.46328,0.109,NULL,60357172622,943080822,14735637,17.4),(79035,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',79035,37.93,0.21,385,31191,70,NULL,NULL,'2MASX J11160012+0328140',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000186,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,169.0005,3.47069,0.109,NULL,60357171855,943080810,14735637,17),(79036,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',79036,36.84,0.33,233,31192,70,NULL,NULL,'2MASX J11160021+0009010',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000105,NULL,'16.2g',0.33,'E0',NULL,NULL,NULL,NULL,1,169.0009583,0.15019,0.129,NULL,60163160916,940049389,14688271,16.2),(79037,'FP','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,'R',79037,37.46,0.33,311,31193,70,NULL,NULL,'2MASX J11160075+1133415',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000176,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,169.003,11.56161,0,NULL,60213500769,940835949,14700561,18),(79038,'IRAS','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,79038,33.01,0.8,39.9,31194,75,NULL,'MAT, I','ESO 377- G 031',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000033,NULL,'14.05',0.9,'SAB(s)bc:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,169.004,-33.96803,0.321,NULL,41563997875,649437466,10147460,14.05),(79039,'IRAS','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,79039,33.02,0.8,40.3,31194,75,NULL,'HMCL, I','ESO 377- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79040,'Tully est','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,79040,33.01,0.8,40.1,31194,75,NULL,'B','ESO 377- G 031',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79041,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,79041,33.03,0.32,40.4,31194,85,NULL,'I, raw','ESO 377- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79042,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,79042,33.07,0.32,41.1,31194,85,NULL,'I, inv','ESO 377- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79043,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,79043,33.11,0.2,41.9,31194,74.4,NULL,NULL,'ESO 377- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79044,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,79044,33.16,0.43,42.9,31194,75,NULL,'MAT, I, raw','ESO 377- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79045,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:53','1',NULL,NULL,79045,33.16,0.43,42.9,31194,75,NULL,'3.6 micron, color corrected','ESO 377- G 031',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79046,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79046,33.25,0.4,44.7,31194,75,NULL,'HMCL, I, raw','ESO 377- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79047,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79047,33.26,0.43,44.8,31194,75,NULL,'3.6 micron, color + selection bias corrected','ESO 377- G 031',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79048,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79048,33.33,0.43,46.4,31194,75,NULL,'MAT, I, inv','ESO 377- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79049,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79049,33.34,0.43,46.5,31194,75,NULL,'MAT, I, cor','ESO 377- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79050,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79050,33.37,0.38,47.2,31194,NULL,NULL,NULL,'ESO 377- G 031',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79051,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79051,33.39,0.4,47.6,31194,75,NULL,'HMCL, I, inv','ESO 377- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79052,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79052,33.39,0.4,47.6,31194,NULL,NULL,'mean','ESO 377- G 031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79053,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79053,33.39,0.09,47.7,31194,NULL,NULL,NULL,'ESO 377- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79054,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79054,33.39,0.4,47.7,31194,75,NULL,'HMCL, I, cor','ESO 377- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79055,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79055,33.68,0.47,54.4,31194,NULL,NULL,'H','ESO 377- G 031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79056,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79056,33.75,0.46,56.1,31194,NULL,NULL,'J','ESO 377- G 031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79057,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79057,33.81,0.45,57.8,31194,NULL,NULL,'K','ESO 377- G 031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79058,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79058,36.41,0.46,191,31195,70,NULL,NULL,'2MASX J11160093+4407494',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000161,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,169.0037917,44.13028,0,NULL,63954079191,999282487,15613788,16.6),(79059,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79059,35.16,0.46,107,31196,70,NULL,NULL,'MCG +09-19-020',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000177,NULL,'15.5g',0.36,'S0',NULL,NULL,NULL,NULL,1,169.010791667,53.82364,0,NULL,61782996909,965359326,15083739,15.5),(79060,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79060,38.32,0.46,461,31197,70,NULL,NULL,'2MASX J11160266+4103536',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.0002,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,169.011167,41.065,0,NULL,63927132184,998861440,15607210,17.2),(79061,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79061,38.25,0.33,447,31198,70,NULL,NULL,'2MASX J11160266+5032203',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000185,NULL,'17.2g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,169.0112083,50.53894,0,NULL,61781948216,965342940,15083483,17.2),(79062,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79062,37.99,0.46,397,31199,70,NULL,NULL,'2MASX J11160339+0433280',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,169.014208333,4.55783,0.145,NULL,60359922728,943123792,14736309,17.5),(79063,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79063,38.04,0.17,405,31200,70,NULL,NULL,'B2 1113+24',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',NULL,NULL,'15.0',0.4,'E              AGN:',NULL,NULL,NULL,NULL,1,169.015833,24.68392,0,NULL,60569890939,946404545,14787571,15),(79064,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79064,36.94,0.46,245,31201,70,NULL,NULL,'2MASX J11160400+4133146',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,169.0167083,41.55392,0,NULL,63927065020,998860390,15607193,17.1),(79065,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79065,37.49,0.46,315,31202,70,NULL,NULL,'SDSS J111604.08+053416.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00015,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,169.017,5.57125,0.185,NULL,60356221522,943065961,14735405,18.6),(79066,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79066,31.06,0.47,16.3,31203,NULL,NULL,'H','NGC 3620',NULL,'2007A&A...465...71T',2007,1,2.8,NULL,'G',0.0001,NULL,'15.92',1.1,'(R\'_1)SB(s)ab',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,169.0195,-76.21631,0.369,NULL,39842637971,622541218,9727206,15.92),(79067,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79067,31.07,0.45,16.3,31203,NULL,NULL,'K','NGC 3620',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79068,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79068,31.09,0.46,16.5,31203,NULL,NULL,'J','NGC 3620',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79069,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79069,31.79,0.4,22.8,31203,NULL,NULL,'mean','NGC 3620',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79070,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79070,37.37,0.46,298,31204,70,NULL,NULL,'SDSS J111605.35+033727.3',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,169.022333,3.62428,0.113,NULL,60358035736,943094308,14735848,17.9),(79071,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79071,37.58,0.1,328,31205,70,NULL,NULL,'2MASX J11160565+5427136',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,169.0235,54.45369,0,NULL,61782128237,965345753,15083527,17.8),(79072,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79072,37.93,0.21,385,31206,70,NULL,NULL,'2MASX J11160687+0323330',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,169.028833,3.39253,0.109,NULL,60357192168,943081127,14735642,17.3),(79073,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79073,38.18,0.33,432,31207,70,NULL,NULL,'SDSS J111606.91+324317.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.3g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,169.028833,32.72144,0.058,NULL,60645564104,947586939,14806045,18.3),(79074,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79074,37.46,0.33,311,31208,70,NULL,NULL,'2MASX J11160701+1139005',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000185,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,169.029208333,11.65011,0,NULL,60214382621,940849728,14700777,16.2),(79075,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79075,37.81,0.46,364,31209,70,NULL,NULL,'2MASX J11160805+0610525',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,169.033458333,6.18117,0.177,NULL,60389746826,943589794,14743590,17.3),(79076,'IRAS','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79076,34.53,0.8,80.6,31210,75,NULL,'CF, r','IC 2674',NULL,'1997ApJS..109..333W',1997,1,0.84,NULL,'G',0.00003,NULL,'15.7g',0.56,'Scd:','Isolated galaxy',NULL,NULL,NULL,1,169.034375,11.04864,0.01,NULL,60331673955,942682405,14729412,15.7),(79077,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79077,34.68,0.38,86.5,31210,75,NULL,'CF, r, raw','IC 2674',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79078,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79078,34.7,0.38,87.1,31210,75,NULL,'CF, r, inv','IC 2674',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79079,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79079,34.87,0.2,94.2,31210,74.4,NULL,NULL,'IC 2674',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79080,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79080,34.98,0.38,98.9,31210,75,NULL,'CF, r, cor','IC 2674',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79081,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79081,37.48,0.33,313,31211,70,NULL,NULL,'2MASX J11160861+3508007',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000187,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,169.0357917,35.13364,0.013,NULL,60421107945,944079811,14751247,16.7),(79082,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79082,36.84,0.33,233,31212,70,NULL,NULL,'2MASX J11160885+0006487',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000069,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,169.037,0.11353,0.129,NULL,60163148166,940049190,14688268,16.8),(79083,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79083,38.18,0.33,432,31213,70,NULL,NULL,'2MASX J11160891+3245397',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000185,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,169.037167,32.76117,0.058,NULL,60645517953,947586218,14806034,17.2),(79084,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79084,38.21,0.23,439,31214,70,NULL,NULL,'SDSS J111609.18+120836.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,169.0382917,12.14353,0,NULL,60214283386,940848177,14700752,18.2),(79085,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79085,37.43,0.46,306,31215,70,NULL,NULL,'2MASX J11160996+3339407',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000169,NULL,'18.26',0.16,NULL,NULL,NULL,NULL,NULL,1,169.0415417,33.66122,0.041,NULL,60644396311,947568692,14805760,18.26),(79086,'SNIa','2016-12-15 15:14:45','2016-12-16 11:19:54','1','SN 1996R',NULL,79086,38.78,0.39,493,31216,74.2,NULL,'SALT 2','SDSS J111610.21-001131.9',0.15617,'2010ApJ...716..712A',2010,1,0.14,NULL,'G',0.000086,NULL,'19.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,169.0425417,-0.19219,0.145,NULL,40818989043,637796703,9965573,19.1),(79087,'SNIa','2016-12-15 15:14:45','2016-12-16 11:19:54','1','SN 1996R',NULL,79087,39.08,0.4,566,31216,65,NULL,NULL,'SDSS J111610.21-001131.9',0.15617,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79088,'SNIa','2016-12-15 15:14:45','2016-12-16 11:19:54','1','SN 1996R',NULL,79088,39.08,0.4,566,31216,65,NULL,'Snapshot','SDSS J111610.21-001131.9',0.15617,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79089,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79089,37.65,0.46,339,31217,70,NULL,NULL,'SDSS J111610.41+012913.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000159,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,169.043375,1.48719,0.125,NULL,60351072097,942985501,14734148,18),(79090,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79090,33.4,NULL,47.8,31218,NULL,NULL,'Dipole','ESO 019- G?006',NULL,'2010Ap&SS.325..163P',2010,1,3.92,'Stars superposed.','G',0.000023,NULL,'16.39',0.39,'Sc',NULL,NULL,NULL,NULL,1,169.046625,-79.39747,0.505,NULL,39967347040,624489797,9757653,16.39),(79091,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79091,33.4,NULL,47.9,31218,NULL,NULL,'Dipole + Quadrupole','ESO 019- G?006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79092,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79092,33.41,NULL,48.1,31218,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 019- G?006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79093,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79093,37.25,0.46,281,31219,70,NULL,NULL,'2MASX J11161220+4731195',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,169.0507917,47.52214,0,NULL,63950062728,999219730,15612808,17.6),(79094,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79094,37.58,0.1,328,31220,70,NULL,NULL,'2MASX J11161222+5431020',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000185,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,169.050958333,54.51736,0,NULL,61962490195,968163909,15127561,16.4),(79095,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79095,37.58,0.1,328,31221,70,NULL,NULL,'2MASX J11161223+5427580',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000158,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,169.0512083,54.46606,0,NULL,61782125711,965345714,15083526,18.1),(79096,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79096,37.95,0.33,389,31222,70,NULL,NULL,'2MASX J11161223+5252223',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000145,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,169.0512917,52.87303,0,NULL,61784574516,965383976,15084124,17.8),(79097,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79097,35.85,0.46,148,31223,70,NULL,NULL,'CGCG 156-041',NULL,'2015arXiv151105856S',2015,1,0.7,'1980ApJ...241..486H has z = 0.0484.','G',0.000044,NULL,'14.8g',0.62,'Sa','Group member',NULL,NULL,NULL,1,169.0564583,29.38525,0,NULL,60655029945,947734842,14808356,14.8),(79098,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79098,37.8,0.46,364,31224,70,NULL,NULL,'2MASX J11161475+0816538',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000181,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,169.061541667,8.28158,0.069,NULL,60338058753,942782168,14730971,17.5),(79099,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79099,36.46,0.58,195,31225,70,NULL,NULL,'2MASX J11161487-0442089',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.59',0.41,NULL,NULL,NULL,NULL,NULL,1,169.062,-4.70256,0.093,NULL,41044786742,641324792,10020699,16.59),(79100,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79100,36,0.27,158,31226,70,NULL,NULL,'2MASX J11161519+3255277',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00018,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,169.063125,32.92431,0.063,NULL,60645834833,947591169,14806112,16.3),(79101,'D-Sigma','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79101,33.51,0.4,50.3,31227,75,NULL,'Edat, raw','NGC 3606',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00007,NULL,'13.40',1.3,'E0:',NULL,NULL,NULL,NULL,1,169.065125,-33.82744,0.321,NULL,41564039927,649438123,10147470,13.4),(79102,'D-Sigma','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79102,33.84,0.4,58.7,31227,75,NULL,'Edat, cor','NGC 3606',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79103,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79103,33.36,0.4,46.9,31227,NULL,NULL,'mean','NGC 3606',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79104,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79104,34.17,0.45,68.3,31227,NULL,NULL,'K','NGC 3606',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79105,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79105,37.35,0.21,295,31228,70,NULL,NULL,'2MASX J11161566+4106566',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000196,NULL,'15.8g',0.48,'E0',NULL,NULL,NULL,NULL,1,169.0652917,41.11572,0,NULL,63927217906,998862779,15607230,15.8),(79106,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79106,37.64,0.08,338,31229,70,NULL,NULL,'SDSS J111616.00+025018.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000153,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,169.066708333,2.83844,0.109,NULL,60349893185,942967081,14733860,18.3),(79107,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79107,38.04,0.17,405,31230,70,NULL,NULL,'2MASX J11161617+2438175',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,169.067291667,24.63817,0,NULL,60569770484,946402663,14787541,17.4),(79108,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79108,37.82,0.46,366,31231,70,NULL,NULL,'2MASX J11161714+5241313',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000165,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,169.0714583,52.69208,0,NULL,61785028087,965391063,15084235,17.3),(79109,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79109,37.37,0.46,298,31232,70,NULL,NULL,'2MASX J11161717+0542009',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,169.0715417,5.70033,0.185,NULL,60356170116,943065158,14735393,18.1),(79110,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79110,36.54,0.11,203,31233,70,NULL,NULL,'CGCG 156-040',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000097,NULL,'15.00',0.7,'S0','Group member',NULL,NULL,NULL,1,169.072583,29.22642,0,NULL,60610029322,947031708,14797370,15),(79111,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79111,37.53,0.27,320,31234,70,NULL,NULL,'2MASX J11161673+2835475',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,169.077333,28.59953,0,NULL,60612839970,947075624,14798056,18.1),(79112,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79112,37.95,0.46,389,31235,70,NULL,NULL,'2MASX J11161866+4357455',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000171,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,169.07775,43.96275,0,NULL,63954195723,999284308,15613817,17),(79113,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79113,37.77,0.46,359,31236,70,NULL,NULL,'2MASX J11161904+1820194',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.30',0.15,NULL,NULL,NULL,NULL,NULL,1,169.079291667,18.33869,0,NULL,61120054207,955000846,14921888,18.3),(79114,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79114,37.46,0.46,310,31237,70,NULL,NULL,'2MASX J11161931+1117238',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000176,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,169.080375,11.28992,0,NULL,60331516217,942679940,14729374,17.2),(79115,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79115,37.64,0.46,338,31238,70,NULL,NULL,'2MASX J11162107+3230540',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000164,NULL,'18.24',0.16,NULL,NULL,NULL,NULL,NULL,1,169.0879583,32.51522,0.068,NULL,60645458281,947585285,14806020,18.24),(79116,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79116,37.64,0.08,338,31239,70,NULL,NULL,'2MASX J11162139+0235209',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,'FoF','18.67',0.15,NULL,NULL,NULL,NULL,NULL,1,169.089,2.589,0.105,NULL,60349908201,942967315,14733864,18.67),(79117,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79117,36.28,0.46,180,31240,70,NULL,NULL,'2MASX J11162217+0318299',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000169,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,169.092417,3.30828,0.101,NULL,60361438337,943147474,14736679,16.4),(79118,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79118,38.42,0.46,484,31241,70,NULL,NULL,'2MASX J11162239+3130320',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000136,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,169.093125,31.50883,0.011,NULL,60656070315,947751098,14808610,18.2),(79119,'BCG','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79119,36.92,0.35,231,31242,60,NULL,'ABELL 1213, BCG','CGCG 156-042',0.0484,'1980ApJ...241..486H',1980,1,0.77,NULL,'G',0.000107,NULL,'14.8g',0.63,'SB0','Group member',NULL,NULL,NULL,1,169.094666667,29.25231,0,NULL,60609812576,947028321,14797317,14.8),(79120,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79120,36.61,0.13,210,31242,70,NULL,'ABELL 1213, BGC','CGCG 156-042',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79121,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79121,36.72,0.21,221,31243,70,NULL,NULL,'IC 2679',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000196,NULL,'15.7g',0.46,NULL,NULL,NULL,NULL,NULL,1,169.096667,12.01539,0,NULL,60214342797,940849106,14700767,15.7),(79122,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79122,37.58,0.1,328,31244,70,NULL,NULL,'2MASX J11162359+5436440',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00017,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,169.09825,54.61222,0,NULL,61962458290,968163410,15127553,17.4),(79123,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79123,37.28,0.46,286,31245,70,NULL,NULL,'2MASX J11162372+0757489',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000178,NULL,'16.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,169.098791667,7.9635,0.061,NULL,60337959509,942780617,14730947,16.4),(79124,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79124,37.53,0.27,320,31246,70,NULL,NULL,'SDSS J111623.81+283734.5',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000208,NULL,'16.0g',0.43,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,169.09925,28.62625,0,NULL,60612841079,947075641,14798056,16),(79125,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79125,37.84,0.46,370,31247,70,NULL,NULL,'SDSS J111624.03+043010.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000153,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,169.100166667,4.50297,0.145,NULL,60359958170,943124346,14736317,18.8),(79126,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79126,37.53,0.27,320,31248,70,NULL,NULL,'2MASX J11162379+2837346',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000156,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,169.100583,28.63325,0,NULL,60612839133,947075611,14798056,18.2),(79127,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79127,37.7,0.46,346,31249,70,NULL,NULL,'2MASX J11162541+0545379',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000178,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,169.105875,5.76064,0.185,NULL,60389663254,943588488,14743570,17.4),(79128,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79128,33,NULL,39.8,31250,NULL,NULL,NULL,'CGCG 039-094',NULL,'2015AstBu..70....1K',2015,1,0.99,NULL,'G',0.000063,NULL,'15.7g',0.31,'Scd(f)',NULL,NULL,NULL,NULL,1,169.1095,4.3365,0.133,NULL,60359810658,943122041,14736281,15.7),(79129,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79129,37.43,0.27,306,31251,70,NULL,NULL,'2MASX J11162639-0057209',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000074,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,169.109875,-0.95586,0.133,NULL,41038081964,641220030,10019062,17.2),(79130,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79130,36.14,0.57,169,31252,70,NULL,NULL,'2MASX J11162731-0528499',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.63',NULL,NULL,NULL,NULL,NULL,NULL,1,169.113833,-5.48056,0.049,NULL,41042245968,641285093,10020079,16.63),(79131,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79131,34.4,0.45,75.7,31253,NULL,NULL,NULL,'UGC 06292',NULL,'2009ApJS..182..474S',2009,1,1.7,NULL,'G',0.000027,NULL,'14.4',1,'SB(s)b','Group member',NULL,NULL,NULL,1,169.1169583,29.32669,0,NULL,60609810186,947028284,14797316,14.4),(79132,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79132,34.73,0.38,88.5,31253,NULL,NULL,'Malmquist cor.','UGC 06292',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79133,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79133,36.54,0.11,203,31254,70,NULL,NULL,'2MASX J11162847+2917096',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000204,NULL,'15.7g',0.43,'E','Group member',NULL,NULL,NULL,1,169.118583333,29.28594,0,NULL,60609807747,947028246,14797316,15.7),(79134,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79134,37.74,0.46,354,31255,70,NULL,NULL,'2MASX J11162866+0003320',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000088,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,169.119375,0.05892,0.145,NULL,60163329471,940052022,14688312,17.1),(79135,'BCG','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79135,36.92,0.35,231,31256,60,NULL,NULL,'ABELL 1213',0.0484,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,169.121125,29.26031,0,NULL,60609813059,947028329,14797317,NULL),(79136,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79136,36.61,0.13,210,31256,70,NULL,NULL,'ABELL 1213',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79137,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79137,36.81,0.46,230,31257,70,NULL,NULL,'2MASX J11162908+4642185',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000179,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,169.121167,46.70519,0,NULL,63950412349,999225192,15612893,16.2),(79138,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79138,36.16,0.58,171,31258,70,NULL,NULL,'2MASX J11162934-0911116',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.11',0.4,NULL,NULL,NULL,NULL,NULL,1,169.12225,-9.18681,0.045,NULL,41018074679,640907416,10014178,16.11),(79139,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79139,37.43,0.27,306,31259,70,NULL,NULL,'2MASX J11162966-0054399',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000088,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,169.1234583,-0.91114,0.133,NULL,41038114117,641220533,10019070,16.7),(79140,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79140,36.54,0.11,203,31260,70,NULL,NULL,'2MASX J11163076+2913436',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000143,NULL,'16.1g',0.37,'E','Group member',NULL,NULL,NULL,1,169.128291667,29.22886,0,NULL,60609814494,947028351,14797317,16.1),(79141,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79141,37.58,0.1,328,31261,70,NULL,NULL,'2MASX J11163102+5419160',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000174,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,169.129333333,54.32122,0,NULL,61782344588,965349134,15083580,17),(79142,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79142,36.72,0.21,221,31262,70,NULL,NULL,'2MASX J11163195+1150449',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000179,NULL,'16.1g',0.28,'S0',NULL,NULL,NULL,NULL,1,169.133083,11.84578,0,NULL,60214418021,940850281,14700785,16.1),(79143,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79143,36.54,0.11,203,31263,70,NULL,NULL,'2MASX J11163229+2916336',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000143,NULL,'15.9g',0.43,'S0','Group member',NULL,NULL,NULL,1,169.1347083,29.27597,0,NULL,60609821484,947028460,14797319,15.9),(79144,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79144,37.43,0.46,307,31264,70,NULL,NULL,'2MASX J11163267+6145534',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000192,NULL,'16.1g',0.41,'AGN',NULL,NULL,NULL,NULL,1,169.136291667,61.76472,0,NULL,61861714904,966589295,15102957,16.1),(79145,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79145,37.73,0.46,352,31265,70,NULL,NULL,'2MASX J11163283+3327300',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000167,NULL,'18.26',0.16,NULL,NULL,NULL,NULL,NULL,1,169.136875,33.45853,0.059,NULL,60643931223,947561425,14805647,18.26),(79146,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79146,36.21,0.45,174,31266,NULL,NULL,'Malmquist cor.','2MASX J11163321+2918436',NULL,'2009ApJS..182..474S',2009,1,0.58,'FIRST source may be a sidelobe of another radio source.','G',0.00003,NULL,'16.1g',0.24,'Sb','Group member',NULL,NULL,NULL,1,169.1385,29.31222,0,NULL,60609809438,947028272,14797316,16.1),(79147,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79147,36.44,0.41,194,31266,NULL,NULL,NULL,'2MASX J11163321+2918436',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79148,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79148,36.48,0.2,198,31266,74.4,NULL,NULL,'2MASX J11163321+2918436',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79149,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79149,37.1,0.46,263,31267,70,NULL,NULL,'2MASX J11163351+1116179',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00017,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,169.139791667,11.27169,0,NULL,60331480995,942679390,14729365,16.7),(79150,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79150,37.43,0.27,306,31268,70,NULL,NULL,'2MASX J11163399-0101409',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000111,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,169.141791667,-1.02806,0.133,NULL,41038084873,641220076,10019063,16.4),(79151,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79151,36.7,0.14,219,31269,70,NULL,NULL,'2MASX J11163438+2604306',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000179,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,169.1432083,26.07519,0,NULL,60600529039,946883266,14795051,16.7),(79152,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79152,36.72,0.21,221,31270,70,NULL,NULL,'2MASX J11163441+1205079',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000184,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,169.1432917,12.08553,0,NULL,60214336057,940849000,14700765,17.3),(79153,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79153,37.42,0.46,305,31271,70,NULL,NULL,'2MASX J11163478+2749266',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000184,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,169.145083,27.82422,0,NULL,60615530620,947117665,14798713,16.8),(79154,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79154,37.59,0.46,329,31272,70,NULL,NULL,'2MASX J11163607+1402164',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000186,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,169.150417,14.03803,0,NULL,61105865049,954779141,14918424,16.9),(79155,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79155,37.64,0.08,338,31273,70,NULL,NULL,'2MASX J11163635+0219260',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,'PHOT','18.48',0.16,NULL,NULL,NULL,NULL,NULL,1,169.151417,2.32394,0.101,NULL,60350777652,942980900,14734076,18.48),(79156,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79156,36.22,0.61,175,31274,70,NULL,NULL,'2MASX J11163654-0748586',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.47',NULL,NULL,NULL,NULL,NULL,NULL,1,169.1520417,-7.81608,0.077,NULL,41015641733,640869402,10013584,16.47),(79157,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79157,34.18,0.49,68.6,31275,70,NULL,NULL,'IC 0679',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.0001,NULL,'15.37',NULL,NULL,NULL,NULL,NULL,NULL,1,169.1525417,-13.97208,0.165,NULL,41694690161,651479533,10179367,15.37),(79158,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79158,36.72,0.21,221,31276,70,NULL,NULL,'2MASX J11163762+1202099',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,169.156875,12.03608,0,NULL,60214332556,940848946,14700764,17.8),(79159,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79159,38.04,0.17,405,31277,70,NULL,NULL,'SDSS J111637.80+243621.0',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,169.1575,24.60583,0,NULL,60569775169,946402737,14787542,18.6),(79160,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79160,37.27,0.33,284,31278,70,NULL,NULL,'2MASX J11163798+3217140',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000173,NULL,'15.7g',0.52,NULL,NULL,NULL,NULL,NULL,1,169.158333,32.28731,0.054,NULL,60643357709,947552464,14805507,15.7),(79161,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79161,38.04,0.17,405,31279,70,NULL,NULL,'2MASX J11163810+2437266',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.18',0.17,NULL,NULL,NULL,NULL,NULL,1,169.1587083,24.62392,0,NULL,60569775156,946402736,14787542,18.18),(79162,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79162,36.82,0.46,231,31280,70,NULL,NULL,'2MASX J11163829+1551454',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.62',0.19,NULL,NULL,NULL,NULL,NULL,1,169.159417,15.86281,0,NULL,61112375026,954880859,14920013,17.62),(79163,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79163,36.49,0.59,199,31281,70,NULL,NULL,'LCRS B111406.3-052146',NULL,'2014MNRAS.445.2677S',2014,1,0.84,NULL,'G',0.00015,NULL,'14.85',0.32,NULL,NULL,NULL,NULL,NULL,1,169.162083,-5.63572,0.069,NULL,41041336323,641270880,10019857,14.85),(79164,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79164,37.16,0.33,270,31282,70,NULL,NULL,'2MASX J11163942+2723076',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,169.1645,27.38542,0,NULL,60614368658,947099510,14798429,17.3),(79165,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79165,37.27,0.33,284,31283,70,NULL,NULL,'2MASX J11164144+3213250',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,169.172833333,32.22361,0.054,NULL,60643345260,947552269,14805504,18.1),(79166,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79166,36.54,0.46,203,31284,70,NULL,NULL,'2MASX J11164161+1654427',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000187,NULL,'16.0g',0.38,NULL,NULL,NULL,NULL,NULL,1,169.1732917,16.91178,0,NULL,61114608256,954915754,14920558,16),(79167,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79167,36.7,0.14,219,31285,70,NULL,NULL,'2MASX J11164171+2552126',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000173,NULL,'15.9g',0.4,NULL,NULL,NULL,NULL,NULL,1,169.173833,25.87028,0,NULL,60567915438,946373678,14787088,15.9),(79168,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79168,34.98,0.46,99.1,31286,70,NULL,NULL,'2MASX J11164209+3325460',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000152,NULL,'16.62',0.22,NULL,NULL,NULL,NULL,NULL,1,169.175417,33.4295,0.059,NULL,60643892793,947560824,14805637,16.62),(79169,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79169,37.16,0.46,271,31287,70,NULL,NULL,'2MASX J11164217+0813448',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000185,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,169.175791667,8.22911,0.069,NULL,60337849185,942778893,14730920,16.7),(79170,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79170,36.19,0.46,173,31288,70,NULL,NULL,'2MASX J11164303+5532599',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000165,NULL,'16.1g',0.38,'E0',NULL,NULL,NULL,NULL,1,169.179167,55.54992,NULL,NULL,61984053273,968500832,15132825,16.1),(79171,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79171,35.82,0.49,146,31289,NULL,NULL,'Malmquist cor.','ZwCl 1115.2+3013 03',NULL,'2009ApJS..182..474S',2009,1,0.52,NULL,'G',0.00003,NULL,'16.6g',0.19,'Blue post-erupt. Irr','Group member',NULL,NULL,NULL,1,169.1794583,29.32894,0,NULL,60609819755,947028433,14797319,16.6),(79172,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79172,35.88,0.48,150,31289,NULL,NULL,NULL,'ZwCl 1115.2+3013 03',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79173,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79173,35.92,0.2,153,31289,74.4,NULL,NULL,'ZwCl 1115.2+3013 03',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79174,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79174,35.38,0.49,119,31290,75,NULL,'IR','UGC 06294',NULL,'2011yCatp016004901K',2011,1,1.54,NULL,'G',0.000012,NULL,'15.4g',0.24,'Sbc',NULL,NULL,NULL,NULL,1,169.180458333,26.37267,0,NULL,60600470071,946882344,14795036,15.4),(79175,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79175,35.63,0.34,134,31290,NULL,NULL,'Malmquist cor.','UGC 06294',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79176,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79176,35.86,0.2,149,31290,74.4,NULL,NULL,'UGC 06294',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79177,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79177,35.89,0.31,150,31290,NULL,NULL,NULL,'UGC 06294',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79178,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79178,38.54,0.46,512,31291,70,NULL,NULL,'2MASX J11164354+5302167',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,169.181417,53.03803,0,NULL,61784473833,965382403,15084100,17.7),(79179,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79179,35.44,0.46,122,31292,70,NULL,NULL,'MCG +09-19-023',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000177,NULL,'15.1g',0.5,'E0',NULL,NULL,NULL,NULL,1,169.184375,54.70236,0,NULL,61991823814,968622247,15134722,15.1),(79180,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79180,36.71,0.33,220,31293,70,NULL,NULL,'2MASX J11164471+4711570',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000182,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,169.18625,47.19903,0,NULL,63950283386,999223177,15612862,16.3),(79181,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79181,37.11,0.46,264,31294,70,NULL,NULL,'2MASX J11164493+4056210',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000176,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,169.187416667,40.93919,0,NULL,63927110687,998861104,15607204,16.6),(79182,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79182,38.37,0.46,472,31295,70,NULL,NULL,'2MASX J11164604+4237210',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000185,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,169.192125,42.62236,0.008,NULL,63944959253,999139988,15611562,17.3),(79183,'SBF','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79183,31.51,0.14,20,31296,74.4,NULL,NULL,'NGC 3605',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000017,NULL,'13.13',1,'E4-5','in a radial-velocity based grouping',NULL,NULL,NULL,1,169.194125,18.01717,0,NULL,61123216775,955050262,14922660,13.13),(79184,'SBF','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79184,31.58,0.29,20.7,31296,NULL,NULL,'I','NGC 3605',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79185,'SBF','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79185,31.58,0.29,20.7,31296,NULL,NULL,NULL,'NGC 3605',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79186,'SBF','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79186,31.62,0.29,21.1,31296,NULL,NULL,'Malmquist cor.','NGC 3605',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79187,'D-Sigma','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79187,31.91,0.4,24.1,31296,75,NULL,'Edat, raw','NGC 3605',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79188,'D-Sigma','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79188,32.02,0.4,25.4,31296,75,NULL,'Edat, cor','NGC 3605',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79189,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79189,32.02,0.41,25.4,31296,NULL,NULL,'Malmquist cor.','NGC 3605',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79190,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79190,32.06,0.41,25.8,31296,NULL,NULL,NULL,'NGC 3605',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79191,'Tully est','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79191,31.13,0.8,16.8,31296,75,NULL,'B','NGC 3605',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79192,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79192,31.26,0.4,17.9,31296,NULL,NULL,'mean','NGC 3605',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79193,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79193,31.81,0.45,23.1,31296,NULL,NULL,'K','NGC 3605',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79194,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79194,37.94,0.46,387,31297,70,NULL,NULL,'2MASX J11164871+1823397',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,169.203,18.39431,0,NULL,61123344236,955052253,14922691,17.7),(79195,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79195,38.04,0.17,405,31298,70,NULL,NULL,'2MASX J11164904+2433129',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.31',0.15,NULL,NULL,NULL,NULL,NULL,1,169.20425,24.55372,0,NULL,60569752443,946402381,14787537,18.31),(79196,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79196,37.64,0.46,338,31299,70,NULL,NULL,'2MASX J11164909+5408279',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000166,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,169.2047083,54.14103,0,NULL,61782270133,965347970,15083562,16.6),(79197,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79197,37.1,0.46,263,31300,70,NULL,NULL,'2MASX J11164946+2634129',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000169,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,169.205916667,26.57039,0,NULL,60614121080,947095641,14798369,16.7),(79198,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79198,37.79,0.46,361,31301,70,NULL,NULL,'2MASXi J1116505+443241',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,169.210833,44.54503,0,NULL,63950884172,999232565,15613008,17.9),(79199,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79199,31.55,0.4,20.4,31302,75,NULL,NULL,'UGC 06296',NULL,'2008Ap.....51..336K',2008,1,1.2,'The UZC position is for a knot south of the center of the galaxy.','G',0.00002,NULL,'14.51',0.4,'Sc             HII','X-ray-bright group member',NULL,NULL,NULL,1,169.21275,17.79856,0,NULL,61123106387,955048537,14922633,14.51),(79200,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79200,31.71,0.4,22,31302,NULL,NULL,'mean','UGC 06296',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79201,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79201,31.92,0.49,24.2,31302,75,NULL,'IR','UGC 06296',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79202,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79202,31.95,0.47,24.6,31302,NULL,NULL,'H','UGC 06296',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79203,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79203,32.01,0.46,25.3,31302,NULL,NULL,'J','UGC 06296',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79204,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79204,32.05,0.45,25.7,31302,NULL,NULL,'K','UGC 06296',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79205,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79205,37.85,0.27,371,31303,70,NULL,NULL,'2MASX J11165112+4038491',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000177,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,169.213,40.64714,0,NULL,63929186195,998893534,15607711,17.3),(79206,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79206,36.49,0.46,199,31304,70,NULL,NULL,'SDSS J111652.39+410310.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000147,NULL,'17.9g',0.11,NULL,NULL,NULL,NULL,NULL,1,169.218333,41.05289,0,NULL,63927187981,998862312,15607223,17.9),(79207,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79207,35.61,0.46,132,31305,70,NULL,NULL,'2MASX J11165338+2758219',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000133,NULL,'16.6g',0.29,'Sy2',NULL,NULL,NULL,'Sy 2',1,169.222583333,27.973,0,NULL,60612560255,947071253,14797988,16.6),(79208,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79208,36,0.27,158,31306,70,NULL,NULL,'2MASX J11165389+3233509',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000158,NULL,'16.1g',0.37,NULL,NULL,NULL,NULL,NULL,1,169.224625,32.56436,0.068,NULL,60643559349,947555614,14805556,16.1),(79209,'GCLF','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79209,31.3,0.4,18.2,31307,NULL,NULL,'TOM(V) = -7.3 mag','NGC 3607',NULL,'2009ApJ...690..512H',2009,1,4.9,NULL,'G',0.000017,NULL,'10.82',2.5,'SA(s)0^0^:     AGN2','X-ray-bright group member',NULL,NULL,'Sy 2',1,169.227667,18.05175,0,NULL,61123222219,955050347,14922661,10.82),(79210,'GCLF','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79210,31.49,0.22,19.9,31307,NULL,NULL,NULL,'NGC 3607',NULL,'2001AJ....122.1251K',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79211,'SBF','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79211,31.76,0.14,22.5,31307,74.4,NULL,NULL,'NGC 3607',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79212,'SBF','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79212,31.79,0.17,22.8,31307,NULL,NULL,'I','NGC 3607',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79213,'SBF','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79213,31.79,0.17,22.8,31307,NULL,NULL,'Malmquist cor.','NGC 3607',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79214,'SBF','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79214,31.79,0.17,22.8,31307,NULL,NULL,NULL,'NGC 3607',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79215,'D-Sigma','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79215,31.91,0.4,24.1,31307,75,NULL,'Edat, raw','NGC 3607',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79216,'D-Sigma','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79216,32.02,0.4,25.4,31307,75,NULL,'Edat, cor','NGC 3607',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79217,'Faber-Jackson','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79217,30.34,0.63,11.7,31307,95,NULL,'Michard 1979b, c','NGC 3607',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79218,'Faber-Jackson','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79218,30.68,0.46,13.7,31307,95,NULL,'Michard 1979a','NGC 3607',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79219,'Faber-Jackson','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79219,30.71,0.29,13.9,31307,95,NULL,'Weighted Mean','NGC 3607',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79220,'Faber-Jackson','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79220,30.98,0.48,15.7,31307,95,NULL,'de Vaucouleurs','NGC 3607',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79221,'Faber-Jackson','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79221,32.09,0.81,26.2,31307,55,NULL,'Visvanathan & Sandage 1979','NGC 3607',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79222,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79222,31.38,0.41,18.9,31307,NULL,NULL,NULL,'NGC 3607',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79223,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79223,31.5,0.41,20,31307,NULL,NULL,'Malmquist cor.','NGC 3607',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79224,'Tertiary','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79224,31.28,0.24,18,31307,95,NULL,NULL,'NGC 3607',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79225,'Tully est','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79225,31.49,0.8,19.9,31307,75,NULL,'B','NGC 3607',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79226,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79226,31.41,0.4,19.1,31307,NULL,NULL,'mean','NGC 3607',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79227,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79227,31.76,0.45,22.5,31307,NULL,NULL,'K','NGC 3607',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79228,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79228,36.85,0.46,235,31308,70,NULL,NULL,'2MASX J11165486+2536209',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,169.228667,25.60575,0,NULL,60568786832,946387294,14787301,16.8),(79229,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79229,36.37,0.46,188,31309,70,NULL,NULL,'CGCG 039-098 NED01',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.71',0.27,NULL,NULL,NULL,NULL,NULL,1,169.2325,5.00525,0.173,NULL,60356365833,943068216,14735440,16.71),(79230,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79230,37.87,0.46,376,31310,70,NULL,NULL,'2MASX J11165582+0247234',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000149,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,169.232667,2.78975,0.105,NULL,60349890231,942967034,14733859,17.5),(79231,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79231,37.11,0.46,264,31311,70,NULL,NULL,'2MASX J11165735+2820239',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000183,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,169.239,28.33989,0,NULL,60612775867,947074622,14798040,16.7),(79232,'SBF','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79232,31.77,0.14,22.6,31312,74.4,NULL,NULL,'NGC 3608',NULL,'2013AJ....146...86T',2013,1,3.2,NULL,'G',0.000017,NULL,'11.70',2.6,'E2            LINER:','X-ray-bright group member',NULL,NULL,NULL,1,169.245625,18.14869,0,NULL,61123261905,955050967,14922671,11.7),(79233,'SBF','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79233,31.8,0.14,22.9,31312,NULL,NULL,'I','NGC 3608',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79234,'SBF','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79234,31.8,0.14,22.9,31312,NULL,NULL,'Malmquist cor.','NGC 3608',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79235,'SBF','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79235,31.8,0.14,22.9,31312,NULL,NULL,NULL,'NGC 3608',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79236,'D-Sigma','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79236,31.91,0.4,24.1,31312,75,NULL,'Edat, raw','NGC 3608',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79237,'D-Sigma','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79237,32.02,0.4,25.4,31312,75,NULL,'Edat, cor','NGC 3608',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79238,'Faber-Jackson','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79238,31.51,0.63,20,31312,95,NULL,'Michard 1979b, c','NGC 3608',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79239,'Faber-Jackson','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79239,31.61,NULL,21,31312,NULL,NULL,'LEDA [April 2006]','NGC 3608',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79240,'Faber-Jackson','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79240,31.63,0.28,21.2,31312,95,NULL,'Weighted Mean','NGC 3608',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79241,'Faber-Jackson','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79241,31.82,0.43,23.1,31312,95,NULL,'de Vaucouleurs','NGC 3608',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79242,'Faber-Jackson','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79242,32.02,0.46,25.4,31312,95,NULL,'Michard 1979a','NGC 3608',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79243,'Faber-Jackson','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79243,32.71,0.81,34.8,31312,55,NULL,'Visvanathan & Sandage 1979','NGC 3608',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79244,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79244,31.89,0.41,23.9,31312,NULL,NULL,'Malmquist cor.','NGC 3608',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79245,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79245,31.9,0.41,24,31312,NULL,NULL,NULL,'NGC 3608',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79246,'Tertiary','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79246,31.28,0.24,18,31312,95,NULL,NULL,'NGC 3608',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79247,'Tully est','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79247,31.84,0.8,23.4,31312,75,NULL,'B','NGC 3608',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79248,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79248,31.82,0.4,23.1,31312,NULL,NULL,'mean','NGC 3608',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79249,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79249,32.39,0.45,30.1,31312,NULL,NULL,'K','NGC 3608',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79250,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79250,36.71,0.33,220,31313,70,NULL,NULL,'2MASX J11165903+4713160',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000167,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,169.246125,47.22119,0,NULL,63950209236,999222019,15612844,16.7),(79251,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79251,37.27,0.46,285,31314,70,NULL,NULL,'2MASX J11165972+5731016',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000188,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,169.24875,57.51717,0,NULL,61987652881,968557076,15133704,16.4),(79252,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79252,36,0.27,158,31315,70,NULL,NULL,'CGCG 185-028',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.00011,NULL,'14.8g',0.67,NULL,NULL,NULL,NULL,NULL,1,169.2505,32.59739,0.068,NULL,60643572933,947555827,14805559,14.8),(79253,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79253,36.86,0.27,236,31316,70,NULL,NULL,'2MASX J11170049+4654210',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000179,NULL,'16.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,169.252,46.90581,0,NULL,63950389592,999224837,15612888,16.6),(79254,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79254,36.54,0.11,203,31317,70,NULL,NULL,'2MASXi J1117012+291301',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000097,NULL,'16.1',0.18,'E','Group member',NULL,NULL,NULL,1,169.255125,29.21711,0,NULL,60609854923,947028983,14797327,16.1),(79255,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79255,37.33,0.46,292,31318,70,NULL,NULL,'SDSS J111701.77+391945.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.5g',0.09,NULL,NULL,NULL,NULL,NULL,1,169.257375,39.32939,0,NULL,63927877585,998873087,15607391,18.5),(79256,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79256,38.01,0.46,401,31319,70,NULL,NULL,'SDSS J111701.81+254723.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00015,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,169.257541667,25.78986,0,NULL,60568773108,946387079,14787298,18.5),(79257,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79257,36.54,0.11,203,31320,70,NULL,NULL,'2MASX J11170186+2905569',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00017,NULL,'15.9g',0.43,'E',NULL,NULL,NULL,NULL,1,169.2577917,29.09911,0,NULL,60611913290,947061145,14797830,15.9),(79258,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79258,33.24,NULL,44.4,31321,NULL,NULL,NULL,'SDSS J111702.67+100836.1',NULL,'2015AstBu..70....1K',2015,1,0.28,NULL,'G',0.0002,NULL,'18.34',0.11,NULL,NULL,NULL,NULL,NULL,1,169.261333333,10.14344,0.028,NULL,60334156162,942721190,14730018,18.34),(79259,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79259,37.63,0.46,336,31322,70,NULL,NULL,'SDSS J111703.39+131441.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000163,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,169.264125,13.24486,0.016,NULL,61106488856,954788888,14918576,18.4),(79260,'FP','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,'R',79260,37.32,0.46,291,31323,70,NULL,NULL,'2MASX J11170349+1420077',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000183,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,169.264625,14.33547,0,NULL,61105305350,954770396,14918287,16.7),(79261,'IRAS','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79261,33.77,0.8,56.8,31324,75,NULL,'MAT, I','ESO 215- G 039',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'13.57',1,'SA(s)c',NULL,NULL,NULL,NULL,1,169.267625,-49.2015,0.545,NULL,41914542111,654914720,10233042,13.57),(79262,'Tully-Fisher','2016-12-15 15:14:45','2016-12-16 11:19:54','1',NULL,NULL,79262,32.91,0.32,38.2,31324,85,NULL,'I, raw','ESO 215- G 039',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79263,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79263,32.93,0.32,38.6,31324,85,NULL,'I, inv','ESO 215- G 039',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79264,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79264,33.1,0.43,41.7,31324,75,NULL,'MAT, I, raw','ESO 215- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79265,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79265,33.23,0.43,44.2,31324,75,NULL,'MAT, I, inv','ESO 215- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79266,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79266,33.34,0.43,46.6,31324,75,NULL,'MAT, I, cor','ESO 215- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79267,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79267,33.35,0.63,46.8,31324,NULL,NULL,NULL,'ESO 215- G 039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79268,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79268,33.39,0.2,47.6,31324,74.4,NULL,NULL,'ESO 215- G 039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79269,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79269,33.53,0.58,50.7,31324,NULL,NULL,'Malmquist cor.','ESO 215- G 039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79270,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79270,34.15,0.47,67.6,31324,NULL,NULL,'H','ESO 215- G 039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79271,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79271,34.16,0.4,68,31324,NULL,NULL,'mean','ESO 215- G 039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79272,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79272,34.27,0.46,71.5,31324,NULL,NULL,'J','ESO 215- G 039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79273,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79273,34.34,0.45,73.8,31324,NULL,NULL,'K','ESO 215- G 039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79274,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79274,37.16,0.33,270,31325,70,NULL,NULL,'2MASX J11170420+2721019',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000197,NULL,'15.8g',0.47,NULL,NULL,NULL,NULL,NULL,1,169.2675,27.35053,0,NULL,60614364629,947099447,14798428,15.8),(79275,'IRAS','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79275,32.59,0.8,33,31326,75,NULL,'HMCL, I','ESO 377- G 034',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000007,NULL,'14.31',0.6,'SB(s)bc:',NULL,NULL,NULL,NULL,1,169.269083,-34.95531,0.281,NULL,41563686783,649432605,10147384,14.31),(79276,'IRAS','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79276,32.59,0.8,33,31326,75,NULL,'A82, H','ESO 377- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79277,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79277,31.81,0.4,23,31326,75,NULL,'HMCL, I, raw','ESO 377- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79278,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79278,31.83,0.4,23.3,31326,75,NULL,'HMCL, I, inv','ESO 377- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79279,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79279,31.88,0.38,23.8,31326,NULL,NULL,NULL,'ESO 377- G 034',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79280,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79280,31.9,0.2,24,31326,74.4,NULL,NULL,'ESO 377- G 034',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79281,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79281,32.1,0.47,26.3,31326,75,NULL,'A82, H, inv','ESO 377- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79282,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79282,32.13,0.4,26.6,31326,75,NULL,'HMCL, I, cor','ESO 377- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79283,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79283,32.17,0.47,27.2,31326,75,NULL,'A82, H, raw','ESO 377- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79284,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79284,32.54,0.47,32.2,31326,75,NULL,'A82, H, cor','ESO 377- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79285,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79285,33.05,0.4,40.7,31326,NULL,NULL,'mean','ESO 377- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79286,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79286,33.14,0.15,42.6,31326,NULL,NULL,NULL,'ESO 377- G 034',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79287,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79287,33.35,0.47,46.7,31326,NULL,NULL,'H','ESO 377- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79288,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79288,36.13,0.46,169,31327,70,NULL,NULL,'2MASX J11170491+4248160',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000097,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,169.2704583,42.80453,0,NULL,63945010247,999140785,15611574,16.9),(79289,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79289,37.39,0.33,300,31328,70,NULL,NULL,'2MASX J11170581+0959201',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000182,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,169.274375,9.98903,0.009,NULL,60332285450,942691960,14729561,16.9),(79290,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79290,37.79,0.46,361,31329,70,NULL,NULL,'2MASX J11170713+5223570',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000126,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,169.2795417,52.39911,0,NULL,61785179779,965393434,15084272,17.9),(79291,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79291,38.42,0.46,483,31330,70,NULL,NULL,'2MASX J11170931+5348211',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,169.288583,53.80592,0,NULL,61782712327,965354880,15083670,17.9),(79292,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79292,36.99,0.46,250,31331,70,NULL,NULL,'2MASX J11170981+5859206',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000154,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,169.290625,58.98917,0,NULL,61983089808,968485778,15132590,16.9),(79293,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79293,37.44,0.46,308,31332,70,NULL,NULL,'2MASX J11171134+5347501',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000175,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,169.297,53.79725,0,NULL,61782712528,965354883,15083670,17.2),(79294,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79294,37.81,0.46,365,31333,70,NULL,NULL,'2MASX J11171168+4253510',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,169.298875,42.89747,0,NULL,63945013718,999140839,15611575,18),(79295,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79295,36.62,0.46,210,31334,70,NULL,NULL,'2MASX J11171289+4053165',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,169.303833,40.88794,0,NULL,63929158970,998893108,15607704,17.4),(79296,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79296,37.19,0.46,274,31335,70,NULL,NULL,'2MASX J11171304+0851370',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000178,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,169.3042917,8.86019,0.077,NULL,60346528822,942914512,14733039,17.8),(79297,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79297,38.68,0.46,545,31336,70,NULL,NULL,'SDSS J111713.99+384053.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000162,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,169.3082917,38.68164,0,NULL,63927890942,998873295,15607395,18.3),(79298,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79298,36.89,0.46,239,31337,70,NULL,NULL,'SDSS J111714.30+324859.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.5g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,169.309625,32.81664,0.072,NULL,60643530980,947555171,14805549,17.5),(79299,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79299,36.94,0.46,244,31338,70,NULL,NULL,'2MASX J11171440+2931139',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000117,NULL,'16.7g',0.33,'S0','Group member',NULL,NULL,NULL,1,169.309833333,29.52067,0,NULL,60654900134,947732814,14808325,16.7),(79300,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79300,36.88,0.46,238,31339,70,NULL,NULL,'2MASX J11171564+3546110',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000171,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,169.31525,35.76964,0,NULL,60430401459,944225022,14753515,16.8),(79301,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79301,32.81,0.69,36.5,31340,100,NULL,'mid-IR','MCG -02-29-016',NULL,'2013ApJ...771...88L',2013,1,0.7,NULL,'G',0.000017,NULL,'14.85',0.35,'Sc',NULL,NULL,NULL,NULL,1,169.3214583,-14.52392,0.141,NULL,41706644619,651666322,10182286,14.85),(79302,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79302,33.9,0.4,60.4,31340,NULL,NULL,'mean','MCG -02-29-016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79303,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79303,34.2,0.47,69.3,31340,NULL,NULL,'H','MCG -02-29-016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79304,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79304,34.25,0.45,70.9,31340,NULL,NULL,'K','MCG -02-29-016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79305,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79305,34.31,0.46,72.8,31340,NULL,NULL,'J','MCG -02-29-016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79306,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79306,34.05,0.48,64.7,31341,70,NULL,NULL,'ESO 215- G 040',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000123,NULL,'14.49',0.7,'SA(rl)0^0',NULL,NULL,NULL,NULL,1,169.32325,-48.44211,0.505,NULL,41914602358,654915661,10233057,14.49),(79307,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79307,37.39,0.33,300,31342,70,NULL,NULL,'2MASX J11171759+0957320',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000197,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,169.323375,9.95881,0.009,NULL,60332293831,942692091,14729563,16.7),(79308,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79308,38.1,0.46,417,31343,70,NULL,NULL,'2MASX J11171778+5139122',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,169.323916667,51.65344,0,NULL,61786455098,965413360,15084583,17.7),(79309,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79309,37.66,0.46,340,31344,70,NULL,NULL,'2MASX J11171817+3001290',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,169.3257083,30.02472,0,NULL,60655810697,947747042,14808547,17.7),(79310,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79310,38.58,0.46,520,31345,70,NULL,NULL,'2MASX J11171839+4357500',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000143,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,169.3267083,43.96378,0,NULL,63951291258,999238925,15613108,18),(79311,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79311,39.01,0.46,633,31346,70,NULL,NULL,'SDSS J111718.84+040956.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000166,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,169.3285417,4.16567,0.117,NULL,60357418442,943084663,14735697,18.3),(79312,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79312,38.27,0.46,452,31347,70,NULL,NULL,'2MASX J11171948+0328205',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,169.331333,3.47239,0.093,NULL,60361417970,943147155,14736674,18.1),(79313,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79313,37.94,0.46,388,31348,70,NULL,NULL,'2MASXi J1117196+143257',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,169.3317917,14.54922,0,NULL,61116578039,954946531,14921039,17.6),(79314,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79314,37.12,0.46,265,31349,70,NULL,NULL,'2MASXi J1117212+270415',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000167,NULL,'18.56',0.15,NULL,NULL,NULL,NULL,NULL,1,169.338375,27.07092,0,NULL,60614995785,947109309,14798582,18.56),(79315,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79315,37.44,0.33,308,31350,70,NULL,NULL,'2MASX J11172115+5041562',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,169.338375,50.69897,0,NULL,61781648046,965338250,15083410,17.6),(79316,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79316,35.19,0.46,109,31351,70,NULL,NULL,'CGCG 126-018',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00009,NULL,'15.6',0.6,NULL,NULL,NULL,NULL,NULL,1,169.339541667,25.43789,0,NULL,60568653881,946385216,14787269,15.6),(79317,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79317,38.07,0.33,412,31352,70,NULL,NULL,'2MASX J11172164+3547309',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000169,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,169.34025,35.79186,0,NULL,60430397801,944224965,14753515,17.2),(79318,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79318,36.88,0.46,238,31353,70,NULL,NULL,'2MASX J11172189+2503586',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.39',0.22,NULL,NULL,NULL,NULL,NULL,1,169.341083,25.06625,0,NULL,60569014663,946390854,14787357,17.39),(79319,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79319,36.68,0.46,217,31354,70,NULL,NULL,'2MASX J11172203+3538359',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000168,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,169.341917,35.64328,0,NULL,60429559766,944211871,14753310,16.6),(79320,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79320,35.71,0.33,138,31355,NULL,NULL,'Malmquist cor.','UGC 06301',NULL,'2009ApJS..182..474S',2009,1,1.6,NULL,'G',NULL,NULL,'15.20',0.4,'Scd:',NULL,NULL,NULL,NULL,1,169.343125,22.33769,0,NULL,61099861016,954685328,14916958,15.2),(79321,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79321,36.07,0.28,164,31355,NULL,NULL,NULL,'UGC 06301',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79322,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79322,36.11,0.2,167,31355,74.4,NULL,NULL,'UGC 06301',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79323,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79323,37.81,0.46,364,31356,70,NULL,NULL,'2MASX J11172286-0004340',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000084,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,169.34525,-0.07622,0.153,NULL,40819157079,637799329,9965614,17.4),(79324,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79324,36.72,0.46,221,31357,70,NULL,NULL,'2MASX J11172306+6317417',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000181,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,169.346333,63.29503,0,NULL,61872000055,966750000,15105468,16.3),(79325,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79325,39.1,0.33,661,31358,70,NULL,NULL,'SDSS J111723.19+571043.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000147,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,169.346667,57.17878,0,NULL,61985738343,968527161,15133236,18.3),(79326,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79326,36.46,0.46,196,31359,70,NULL,NULL,'2MASX J11172490+4433481',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000175,NULL,'16.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,169.353917,44.56331,0,NULL,63951349694,999239838,15613122,16.4),(79327,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79327,37.19,0.46,274,31360,70,NULL,NULL,'2MASX J11172588+0332115',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000189,NULL,'16.2g',0.34,'E0',NULL,NULL,NULL,NULL,1,169.357833,3.53661,0.093,NULL,60362133348,943158333,14736848,16.2),(79328,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79328,38.03,0.46,404,31361,70,NULL,NULL,'SDSS J111726.01+351930.6',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.9g',0.27,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,169.358417,35.32519,0,NULL,60421270545,944082352,14751286,16.9),(79329,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79329,36.67,0.46,216,31362,70,NULL,NULL,'2MASX J11172637+1851177',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.66',0.18,NULL,NULL,NULL,NULL,NULL,1,169.3600417,18.85503,0,NULL,61123063415,955047865,14922622,17.66),(79330,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79330,36.46,0.46,196,31363,70,NULL,NULL,'2MASX J11172713+3954326',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000179,NULL,'16.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,169.363125,39.909,0,NULL,63929468800,998897950,15607780,16.4),(79331,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79331,38.63,0.46,533,31364,70,NULL,NULL,'2MASXi J1117272-000646',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000079,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,169.363583333,-0.11289,0.153,NULL,40819159618,637799369,9965615,18.2),(79332,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79332,39.1,0.33,661,31365,70,NULL,NULL,'2MASX J11172817+5709266',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000168,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,169.367666667,57.15733,0,NULL,61985737962,968527155,15133236,17.3),(79333,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79333,38.5,0.33,502,31366,70,NULL,NULL,'2MASX J11172865+3651056',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,169.3692917,36.8515,0,NULL,60430669848,944229216,14753581,17.9),(79334,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79334,38.52,0.23,506,31367,70,NULL,NULL,'2MASX J11172876+3558286',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,169.369958333,35.97483,0,NULL,60430446592,944225728,14753527,17.8),(79335,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79335,36.54,0.11,203,31368,70,NULL,NULL,'2MASX J11172899+2846436',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000143,NULL,'15.8g',0.42,'E',NULL,NULL,NULL,NULL,1,169.370917,28.77886,0,NULL,60612059276,947063426,14797866,15.8),(79336,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79336,38.72,0.46,556,31369,70,NULL,NULL,'SDSS J111729.45+395733.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,169.37275,39.95939,0,NULL,63929545846,998899153,15607799,18.2),(79337,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79337,35.39,0.46,120,31370,70,NULL,NULL,'CGCG 126-019',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000063,NULL,'15.2g',0.45,NULL,NULL,NULL,NULL,NULL,1,169.374167,25.75244,0,NULL,60568812010,946387687,14787307,15.2),(79338,'Sosies','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79338,32.97,0.82,39.3,31371,NULL,NULL,NULL,'NGC 3604',NULL,'2002A&A...393...57T',2002,1,2.1,NULL,'G',0.000013,NULL,'12.77',1.7,'SA(s)a pec     HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,169.3757083,4.55558,0.133,NULL,60360070164,943126096,14736345,12.77),(79339,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79339,32.18,0.4,27.3,31371,75,NULL,'B','NGC 3604',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79340,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79340,38.07,0.46,412,31372,70,NULL,NULL,'2MASX J11173042+4134166',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000178,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,169.376625,41.57119,0.013,NULL,63944566539,999133852,15611466,17),(79341,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79341,35.42,0.46,121,31373,70,NULL,NULL,'CGCG 268-014',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.00009,NULL,'15.2g',0.58,'E0',NULL,NULL,NULL,NULL,1,169.3805417,53.52244,0,NULL,61782862770,965357230,15083706,15.2),(79342,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79342,37.64,0.46,337,31374,70,NULL,NULL,'SDSS J111732.81+234031.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.3g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,169.386708333,23.67536,0,NULL,61088019683,954500307,14914067,18.3),(79343,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79343,36.54,0.11,203,31375,70,NULL,NULL,'2MASX J11173309+2922007',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00019,NULL,'16.2g',0.36,'E','Group member',NULL,NULL,NULL,1,169.387917,29.36681,0,NULL,60654890069,947732657,14808322,16.2),(79344,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79344,37.52,0.33,320,31376,70,NULL,NULL,'IC 2692',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000184,NULL,'16.1g',0.39,'E0',NULL,NULL,NULL,NULL,1,169.388416667,10.76806,0.013,NULL,60334361937,942724405,14730068,16.1),(79345,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79345,34.58,0.46,82.4,31377,70,NULL,NULL,'CGCG 268-015',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.00011,NULL,'14.8g',0.59,'S0(r)',NULL,NULL,NULL,NULL,1,169.388708333,51.27158,0,NULL,61779915906,965311186,15082987,14.8),(79346,'IRAS','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79346,34.95,0.8,97.7,31378,75,NULL,'MAT, I','ESO 438- G 018',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.00003,NULL,'15.09',0.7,'SB?            HII',NULL,NULL,NULL,NULL,1,169.388791667,-27.89575,0.361,NULL,41556679668,649323119,10145673,15.09),(79347,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79347,34.29,0.32,72.2,31378,85,NULL,'I, raw','ESO 438- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79348,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79348,34.33,0.32,73.6,31378,85,NULL,'I, inv','ESO 438- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79349,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79349,34.36,0.43,74.5,31378,75,NULL,'MAT, I, raw','ESO 438- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79350,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79350,34.56,0.43,81.5,31378,75,NULL,'MAT, I, inv','ESO 438- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79351,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79351,34.78,0.43,90.4,31378,75,NULL,'MAT, I, cor','ESO 438- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79352,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79352,34.87,0.2,94.2,31378,74.4,NULL,NULL,'ESO 438- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79353,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79353,35.13,0.41,106,31378,NULL,NULL,NULL,'ESO 438- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79354,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79354,35.2,0.4,110,31378,NULL,NULL,'Malmquist cor.','ESO 438- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79355,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79355,38.68,0.46,545,31379,70,NULL,NULL,'2MASX J11173396+0448335',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000174,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,169.3915,4.80928,0.161,NULL,60359989033,943124828,14736325,18.4),(79356,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79356,35.57,0.61,130,31380,70,NULL,NULL,'2MASX J11173507-2232092',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,169.3962083,-22.53597,0.169,NULL,41723445641,651928838,10186388,15.1),(79357,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79357,38.5,0.33,502,31381,70,NULL,NULL,'2MASX J11173600+3657465',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,169.4000417,36.96286,0,NULL,60430625321,944228520,14753570,17.7),(79358,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79358,37.98,0.46,394,31382,70,NULL,NULL,'2MASX J11173631+2426357',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.49',0.14,NULL,NULL,NULL,NULL,NULL,1,169.40125,24.44342,0,NULL,60567131565,946361430,14786897,18.49),(79359,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79359,36.54,0.11,203,31383,70,NULL,NULL,'2MASX J11173667+2855317',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00013,NULL,'16.6g',0.34,'E','Group member',NULL,NULL,NULL,1,169.402791667,28.92553,0,NULL,60612105532,947064148,14797877,16.6),(79360,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79360,37.64,0.08,338,31384,70,NULL,NULL,'2MASX J11173691+0233215',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000159,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,169.4039583,2.55606,0.109,NULL,60350353389,942974271,14733972,17.1),(79361,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79361,36.86,0.27,236,31385,70,NULL,NULL,'SDSS J111738.16+470526.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000164,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,169.409083,47.09081,0,NULL,63950199342,999221864,15612841,18),(79362,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79362,38.03,0.46,403,31386,70,NULL,NULL,'2MASX J11173824+4538581',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,169.409333,45.64947,0,NULL,63949030577,999203602,15612556,17.5),(79363,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79363,36.2,0.46,173,31387,70,NULL,NULL,'2MASX J11173838+0503205',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00018,NULL,'16.2g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,169.409917,5.05575,0.173,NULL,60359523642,943117556,14736211,16.2),(79364,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79364,37.04,0.46,255,31388,70,NULL,NULL,'2MASX J11173835+4046525',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,169.4099583,40.78133,0,NULL,63929292250,998895191,15607737,17.6),(79365,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79365,37.48,0.46,314,31389,70,NULL,NULL,'2MASX J11173870+1400013',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.93',0.15,NULL,NULL,NULL,NULL,NULL,1,169.41125,14.00047,0,NULL,61105984980,954781015,14918453,17.93),(79366,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79366,36.24,0.46,177,31390,70,NULL,NULL,'2MASX J11173964+0318511',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000171,NULL,'16.0g',0.4,'E',NULL,NULL,NULL,NULL,1,169.415083,3.31425,0.089,NULL,60362161009,943158765,14736855,16),(79367,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79367,37.52,0.33,320,31391,70,NULL,NULL,'2MASX J11173968+1039560',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000212,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,169.415375,10.66569,0.013,NULL,60335016134,942734627,14730228,16.5),(79368,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79368,32.97,0.49,39.3,31392,75,NULL,'IR','UGC 06307',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.000013,NULL,'14.78',0.4,'Sdm:',NULL,NULL,NULL,NULL,1,169.41775,38.05258,0,NULL,60425164856,944143200,14752237,14.78),(79369,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79369,38.12,0.46,421,31393,70,NULL,NULL,'2MASX J11174110+5536015',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000152,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,169.421333,55.60053,NULL,NULL,61984185369,968502896,15132857,17.3),(79370,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79370,35.35,0.49,118,31394,75,NULL,'IR','ESO 377- G 036',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'16.61',0.2,'S...',NULL,NULL,NULL,NULL,1,169.4217083,-35.98536,0.325,NULL,41387274943,646676170,10104315,16.61),(79371,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79371,35.56,0.39,130,31394,NULL,NULL,'Malmquist cor.','ESO 377- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79372,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79372,35.61,0.38,132,31394,NULL,NULL,NULL,'ESO 377- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79373,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79373,35.65,0.2,135,31394,74.4,NULL,NULL,'ESO 377- G 036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79374,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79374,36.86,0.27,236,31395,70,NULL,NULL,'CGCG 242-018',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000178,NULL,'15.4g',0.49,'E0',NULL,NULL,NULL,NULL,1,169.423083,47.08342,0,NULL,63950199483,999221866,15612841,15.4),(79375,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79375,37.79,0.46,362,31396,70,NULL,NULL,'2MASX J11174229+0427581',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000165,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,169.426083,4.46617,0.125,NULL,60360037938,943125592,14736337,16.6),(79376,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79376,35.66,0.49,136,31397,70,NULL,NULL,'2MASX J11174305-2749185',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.0b',NULL,'S0',NULL,NULL,NULL,NULL,1,169.4294583,-27.82186,0.361,NULL,41556695580,649323368,10145677,16),(79377,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79377,33.68,0.49,54.5,31398,70,NULL,NULL,'2MASX J11174323-0354409',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00013,NULL,'14.9',NULL,NULL,NULL,NULL,NULL,NULL,1,169.430167,-3.91133,0.105,NULL,41043974919,641312108,10020501,14.9),(79378,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79378,38.22,0.33,440,31399,70,NULL,NULL,'SDSS J111743.25+405439.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000181,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,169.43025,40.91106,0,NULL,63929074736,998891792,15607684,18.2),(79379,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79379,36.86,0.46,235,31400,70,NULL,NULL,'2MASX J11174379+4846072',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,169.432667,48.76878,0,NULL,63913673986,998651156,15603924,17.5),(79380,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79380,37.74,0.46,353,31401,70,NULL,NULL,'2MASX J11174405+3941077',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,169.433416667,39.68561,0,NULL,63928970075,998890157,15607658,17.4),(79381,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79381,36.54,0.11,203,31402,70,NULL,NULL,'2MASX J11174428+2936256',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000107,NULL,'16.5g',0.25,'E','Group member',NULL,NULL,NULL,1,169.434333,29.60711,0,NULL,60654896503,947732757,14808324,16.5),(79382,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79382,38.37,0.46,473,31403,70,NULL,NULL,'2MASX J11174432+4008275',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000179,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,169.434583,40.14097,0,NULL,63929536751,998899011,15607797,17.7),(79383,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79383,38.28,0.46,452,31404,70,NULL,NULL,'2MASX J11174454+0017291',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00008,NULL,'17.9g',0.18,'AGN',NULL,NULL,NULL,NULL,1,169.435666667,0.29136,0.129,NULL,60163180914,940049701,14688276,17.9),(79384,'BCG','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79384,37.6,0.35,315,31405,60,NULL,NULL,'ABELL 1216',0.0524,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,169.436667,-4.47339,0.121,NULL,41045384719,641334136,10020845,NULL),(79385,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79385,37.32,0.46,291,31406,70,NULL,NULL,'2MASX J11174520+2931292',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000142,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,169.43825,29.52461,0,NULL,60654906023,947732906,14808326,17.8),(79386,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79386,37.78,0.46,360,31407,70,NULL,NULL,'2MASX J11174582+3334544',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,169.4407917,33.58192,0.059,NULL,60644081899,947563779,14805684,17.9),(79387,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79387,37.33,0.33,293,31408,70,NULL,NULL,'2MASX J11174592+4733280',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000198,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,169.441375,47.55769,0,NULL,63946729976,999167655,15611994,16.3),(79388,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79388,37.12,0.46,265,31409,70,NULL,NULL,'2MASX J11174603+4553570',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,169.442,45.89908,0,NULL,63949734524,999214601,15612728,17.4),(79389,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79389,36.87,0.46,237,31410,70,NULL,NULL,'2MASX J11174623+4453350',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000189,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,169.4425417,44.89294,0,NULL,63950901984,999232843,15613013,16.9),(79390,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79390,38.37,0.46,471,31411,70,NULL,NULL,'2MASX J11174644+5240462',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000204,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,169.443416667,52.67956,0,NULL,61784636609,965384947,15084139,17.2),(79391,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79391,32.67,0.43,34.2,31412,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06309',NULL,'2014MNRAS.444..527S',2014,1,1.31,NULL,'G',0.00002,NULL,'13.8g',0.93,'SB?','Field galaxy',NULL,NULL,NULL,1,169.443666667,51.47658,0,NULL,61779070646,965297978,15082780,13.8),(79392,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79392,32.83,0.43,36.8,31412,75,NULL,'3.6 micron, color corrected','UGC 06309',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79393,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79393,33.01,0.2,40,31412,74.4,NULL,NULL,'UGC 06309',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79394,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79394,33.25,0.4,44.6,31412,NULL,NULL,'mean','UGC 06309',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79395,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79395,33.41,0.47,48.2,31412,NULL,NULL,'H','UGC 06309',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79396,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79396,33.51,0.46,50.4,31412,NULL,NULL,'J','UGC 06309',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79397,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79397,33.55,0.45,51.2,31412,NULL,NULL,'K','UGC 06309',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79398,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79398,38.29,0.46,455,31413,70,NULL,NULL,'2MASX J11174749-0012520',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000082,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,169.44775,-0.21456,0.161,NULL,40819135034,637798984,9965609,18.3),(79399,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79399,37.59,0.46,329,31414,70,NULL,NULL,'2MASX J11174846+1200364',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,169.452,12.01011,0,NULL,60214265772,940847902,14700748,17),(79400,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79400,37.58,0.1,328,31415,70,NULL,NULL,'2MASX J11174927+5431535',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000186,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,169.455,54.5315,0,NULL,61790490123,965476408,15085568,16.6),(79401,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79401,38.5,0.46,502,31416,70,NULL,NULL,'2MASX J11174944+0716285',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,169.4560417,7.27469,0.113,NULL,60338927028,942795734,14731183,17.7),(79402,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79402,38.52,0.23,506,31417,70,NULL,NULL,'2MASX J11175048+3608097',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000179,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,169.46025,36.13606,0.017,NULL,60430264380,944222880,14753482,18),(79403,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79403,32.43,0.4,30.7,31418,NULL,NULL,'mean','NGC 3617',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000027,NULL,'13.69',1.3,'E+','in a triple',NULL,NULL,NULL,1,169.461917,-26.13442,0.245,NULL,41542582425,649102850,10142232,13.69),(79404,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79404,32.67,0.45,34.2,31418,NULL,NULL,'K','NGC 3617',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79405,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79405,37.77,0.21,357,31419,70,NULL,NULL,'SDSS J111750.94+372139.1',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.6g',0.32,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,169.46225,37.36089,0,NULL,60429089033,944204516,14753195,16.6),(79406,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79406,35.95,0.77,155,31420,70,NULL,NULL,'2MASX J11175119-4932172',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,169.463333,-49.53817,0.529,NULL,40022972278,625358941,9771233,14.6),(79407,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79407,37.54,0.46,323,31421,70,NULL,NULL,'2MASX J11175178+5657165',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000143,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,169.465667,56.95458,0,NULL,61985724601,968526946,15133233,17.5),(79408,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79408,38.52,0.23,506,31422,70,NULL,NULL,'2MASX J11175189+3607238',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000186,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,169.466167,36.12333,0.017,NULL,60430266441,944222913,14753483,16.3),(79409,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79409,38.52,0.23,506,31423,70,NULL,NULL,'2MASX J11175224+3600198',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,169.467625,36.00547,0,NULL,60430449904,944225779,14753527,18.3),(79410,'IRAS','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79410,33.05,0.8,40.8,31424,75,NULL,'MAT, I','ESO 319- G 011',NULL,'1997ApJS..109..333W',1997,1,2.7,NULL,'G',0.000019,NULL,'15.5',1.7,'SB(r)cd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,169.4724583,-40.59364,0.481,NULL,41904714711,654761167,10230643,15.5),(79411,'IRAS','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79411,33.08,0.8,41.2,31424,75,NULL,'HMCL, I','ESO 319- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79412,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79412,32.46,0.4,31.1,31424,75,NULL,'HMCL, I, raw','ESO 319- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79413,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79413,32.64,0.4,33.7,31424,75,NULL,'HMCL, I, inv','ESO 319- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79414,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79414,32.69,0.4,34.5,31424,75,NULL,'HMCL, I, cor','ESO 319- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79415,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79415,33.1,0.38,41.7,31424,NULL,NULL,NULL,'ESO 319- G 011',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79416,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79416,33.13,0.32,42.3,31424,85,NULL,'I, raw','ESO 319- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79417,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79417,33.17,0.32,43.1,31424,85,NULL,'I, inv','ESO 319- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79418,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79418,33.22,0.43,44,31424,75,NULL,'MAT, I, raw','ESO 319- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79419,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79419,33.3,0.2,45.7,31424,74.4,NULL,NULL,'ESO 319- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79420,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79420,33.39,0.46,47.7,31424,NULL,NULL,NULL,'ESO 319- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79421,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79421,33.41,0.43,48,31424,75,NULL,'MAT, I, inv','ESO 319- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79422,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79422,33.41,0.4,48.1,31424,NULL,NULL,'mean','ESO 319- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79423,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79423,33.44,0.43,48.8,31424,75,NULL,'MAT, I, cor','ESO 319- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79424,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79424,33.47,0.43,49.4,31424,75,NULL,'3.6 micron, color corrected','ESO 319- G 011',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79425,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79425,33.7,0.43,54.9,31424,75,NULL,'3.6 micron, color + selection bias corrected','ESO 319- G 011',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79426,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79426,33.9,0.47,60.4,31424,NULL,NULL,'H','ESO 319- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79427,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79427,33.92,0.46,60.7,31424,NULL,NULL,'J','ESO 319- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79428,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79428,34.03,0.45,63.8,31424,NULL,NULL,'K','ESO 319- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79429,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79429,37.35,0.46,296,31425,70,NULL,NULL,'2MASX J11175388+4318403',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000174,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,169.4744583,43.31106,0,NULL,63945325092,999145704,15611651,16.6),(79430,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79430,36.54,0.11,203,31426,70,NULL,NULL,'2MASX J11175463+2927042',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000127,NULL,'17.2g',0.23,'E','Group member',NULL,NULL,NULL,1,169.4775,29.45122,0,NULL,60654886538,947732602,14808321,17.2),(79431,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79431,37.33,0.33,293,31427,70,NULL,NULL,'2MASX J11175473+4731483',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,169.478,47.53028,0,NULL,63946736754,999167761,15611996,17.6),(79432,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79432,37.14,0.46,268,31428,70,NULL,NULL,'2MASX J11175499+2643072',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000187,NULL,'16.1g',0.38,NULL,NULL,NULL,NULL,NULL,1,169.479083333,26.71872,0,NULL,60614240722,947097511,14798398,16.1),(79433,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79433,35.3,0.4,115,31429,NULL,NULL,'mean','UGC 06311',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000023,NULL,'14.34',1.2,'SAB(s)c pec',NULL,NULL,NULL,NULL,1,169.479083333,-2.092,0.089,NULL,41041080847,641266888,10019795,14.34),(79434,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79434,35.45,0.47,123,31429,NULL,NULL,'H','UGC 06311',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79435,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79435,37.69,0.46,345,31430,70,NULL,NULL,'SDSS J111755.23+113924.1',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000173,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,169.480167,11.65672,0,NULL,60213949594,940842962,14700671,17.7),(79436,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79436,37.77,0.21,357,31431,70,NULL,NULL,'2MASX J11175559+3726238',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,169.481417,37.44008,0,NULL,60429077429,944204334,14753192,17.3),(79437,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79437,38.23,0.46,443,31432,70,NULL,NULL,'2MASX J11175643+6532177',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000083,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,169.485,65.53822,0,NULL,61815296388,965864006,15091625,17.8),(79438,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79438,36.67,0.46,215,31433,70,NULL,NULL,'2MASX J11175656+4436323',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000195,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,169.4855,44.60892,0,NULL,63951393469,999240522,15613133,16.4),(79439,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79439,37.96,0.46,392,31434,70,NULL,NULL,'2MASX J11175686+3453054',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,'PRED','17.90',0.18,NULL,NULL,NULL,NULL,NULL,1,169.486917,34.88492,0.019,NULL,60642481613,947538775,14805293,17.9),(79440,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79440,37.34,0.46,294,31435,70,NULL,NULL,'MCG +05-27-045',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000133,NULL,'15.7g',0.43,NULL,NULL,NULL,NULL,NULL,1,169.489583,27.9605,0,NULL,60612467043,947069797,14797965,15.7),(79441,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79441,37.22,0.46,278,31436,70,NULL,NULL,'2MASX J11180003+4154148',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,169.5000417,41.90411,0.061,NULL,63944631643,999134869,15611482,17.8),(79442,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79442,36.59,0.46,208,31437,70,NULL,NULL,'2MASX J11180099+3159465',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000152,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,169.5039583,31.99636,0.032,NULL,60664534856,947883357,14810677,16.8),(79443,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79443,38.22,0.33,440,31438,70,NULL,NULL,'2MASX J11180111+4059068',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000195,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,169.504625,40.98533,0,NULL,63929086371,998891974,15607687,17),(79444,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79444,37.65,0.46,339,31439,70,NULL,NULL,'2MASX J11180149+0923305',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,169.506125,9.39189,0.069,NULL,60346272467,942910507,14732976,17.8),(79445,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79445,37.72,0.46,350,31440,70,NULL,NULL,'SDSS J111801.76+231722.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,169.507333,23.28947,0,NULL,61088113075,954501766,14914090,17.9),(79446,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79446,36.78,0.46,227,31441,70,NULL,NULL,'2MASX J11180258+4513343',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000174,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,169.510625,45.22622,0,NULL,63951043250,999235050,15613047,16.8),(79447,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79447,37.44,0.33,308,31442,70,NULL,NULL,'2MASX J11180295+5042544',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000132,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,169.5124583,50.71525,0,NULL,61779635091,965306798,15082918,17.7),(79448,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79448,36.75,0.46,224,31443,70,NULL,NULL,'2MASX J11180402+6227146',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000168,NULL,'16.1g',0.36,'S0',NULL,NULL,NULL,NULL,1,169.516916667,62.45392,0,NULL,61871716565,966745571,15105399,16.1),(79449,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79449,37.62,0.46,334,31444,70,NULL,NULL,'SDSS J111806.39+501430.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,169.526667,50.24175,0,NULL,61781732301,965339567,15083430,18),(79450,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79450,34.36,0.46,74.4,31445,70,NULL,NULL,'NGC 3615',NULL,'2015arXiv151105856S',2015,1,1.4,NULL,'G',0.000063,NULL,'13.82',0.9,'E','Possible field galaxy',NULL,NULL,NULL,1,169.5277083,23.39733,0,NULL,61088147689,954502307,14914098,13.82),(79451,'BCG','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79451,37.6,0.35,315,31446,60,NULL,'ABELL 1216, BCG','2MASX J11180808-0425480',0.0524,'1980ApJ...241..486H',1980,1,NULL,NULL,'G',0.000063,NULL,'16.40',NULL,NULL,'Brightest group member',NULL,NULL,NULL,1,169.533583,-4.43008,0.121,NULL,41044538907,641320920,10020639,16.4),(79452,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79452,37.73,0.46,352,31447,70,NULL,NULL,'II Zw 051 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000184,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,169.53425,30.42272,0,NULL,60662987093,947859173,14810299,17),(79453,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79453,36.54,0.11,203,31448,70,NULL,NULL,'2MASX J11180938+2853573',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000147,NULL,'16.1g',0.4,'E','Group member',NULL,NULL,NULL,1,169.53925,28.89908,0,NULL,60612038603,947063103,14797860,16.1),(79454,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79454,37.58,0.1,328,31449,70,NULL,NULL,'2MASX J11180961+5434285',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000194,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,169.5399583,54.57464,0,NULL,61761129891,965017654,15078400,16.6),(79455,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79455,36.93,0.46,243,31450,70,NULL,NULL,'2MASX J11181003+5412405',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000179,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,169.5420417,54.21142,0,NULL,61790585031,965477891,15085592,16.6),(79456,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79456,36.74,0.46,223,31451,70,NULL,NULL,'2MASX J11181018+2540593',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000173,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,169.5425,25.68306,0,NULL,60568722297,946386285,14787285,17.2),(79457,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79457,35.73,0.46,140,31452,70,NULL,NULL,'2MASX J11181037+3421455',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,169.543291667,34.36261,0.043,NULL,60643128160,947548877,14805451,16.5),(79458,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79458,37.77,0.21,357,31453,70,NULL,NULL,'2MASX J11181163+3726437',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000192,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,169.548458333,37.44547,0,NULL,60429114245,944204910,14753201,16.9),(79459,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79459,37.13,0.46,266,31454,70,NULL,NULL,'2MASXi J1118127+671949',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000078,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,169.5527083,67.33028,0.005,NULL,62085569376,970087021,15157609,17.3),(79460,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79460,33.43,0.48,48.5,31455,70,NULL,NULL,'ESO 216- G 003',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.00015,NULL,'14.01',1.5,'(R)SB(r)0^+',NULL,NULL,NULL,NULL,1,169.5622083,-48.74575,0.465,NULL,41913776123,654902751,10232855,14.01),(79461,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79461,38.22,0.46,441,31456,70,NULL,NULL,'2MASX J11181517+1903349',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,169.563458333,19.05958,0,NULL,61121862941,955029108,14922329,17.7),(79462,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79462,37.07,0.46,260,31457,70,NULL,NULL,'2MASX J11181535+3830457',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00016,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,169.564041667,38.51272,0,NULL,60424810444,944137663,14752150,17.2),(79463,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79463,37.29,0.33,287,31458,70,NULL,NULL,'SDSS J111815.95+080113.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00014,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,169.5665,8.02036,0.085,NULL,60338416662,942787760,14731058,18.5),(79464,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79464,37.12,0.46,266,31459,70,NULL,NULL,'2MASX J11181643+5239465',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000176,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,169.568291667,52.663,0,NULL,61784626214,965384784,15084137,16.8),(79465,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79465,29.08,0.06,6.55,31460,NULL,NULL,'59, VI, KEY PROJECT','NGC 3621',NULL,'2001ApJ...553...47F',2001,1,12.3,NULL,'G',0.000007,NULL,'10.18',7.1,'SA(s)d         HII','Field galaxy',NULL,NULL,NULL,1,169.568791667,-32.81406,0.393,NULL,41562573674,649415213,10147112,10.18),(79466,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79466,29.09,0.15,6.58,31460,NULL,NULL,'5, H','NGC 3621',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79467,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79467,29.09,0.15,6.58,31460,NULL,NULL,'5, H','NGC 3621',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79468,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79468,29.1,0.05,6.62,31460,NULL,NULL,'LMC W01','NGC 3621',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79469,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79469,29.11,0.06,6.64,31460,NULL,NULL,'59, VI, +Z, KEY PROJECT','NGC 3621',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79470,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79470,29.13,0.11,6.7,31460,NULL,NULL,'HST KP Calibrated','NGC 3621',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79471,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79471,29.13,0.11,6.7,31460,NULL,NULL,'36, VI','NGC 3621',NULL,'1997ApJ...490..517R',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79472,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79472,29.13,0.06,6.7,31460,NULL,NULL,'MW HIPP','NGC 3621',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79473,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79473,29.14,0.15,6.73,31460,NULL,NULL,'MW P02','NGC 3621',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79474,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79474,29.14,0.06,6.73,31460,74.4,NULL,NULL,'NGC 3621',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79475,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79475,29.15,0.07,6.76,31460,NULL,NULL,'MW GFG','NGC 3621',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79476,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79476,29.15,0.06,6.76,31460,NULL,NULL,'LMC VIHJK','NGC 3621',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79477,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79477,29.15,0.07,6.76,31460,NULL,NULL,'152, VI','NGC 3621',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79478,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79478,29.16,0.06,6.78,31460,NULL,NULL,'cte LMC K03','NGC 3621',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79479,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79479,29.16,0.06,6.81,31460,NULL,NULL,'cte U99','NGC 3621',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79480,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79480,29.18,0.06,6.87,31460,NULL,NULL,'cte LMC STS02','NGC 3621',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79481,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79481,29.21,0.1,6.95,31460,73,NULL,'Cepheids periods Gaussian, Data 1','NGC 3621',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79482,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79482,29.23,0.06,7,31460,NULL,NULL,'cte MW FSG03','NGC 3621',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79483,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79483,29.25,0.06,7.08,31460,NULL,NULL,'cte MW GFG98','NGC 3621',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79484,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79484,29.26,0.06,7.11,31460,NULL,NULL,'cte MF91','NGC 3621',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79485,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79485,29.29,0.06,7.21,31460,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian, Data 1','NGC 3621',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79486,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79486,29.3,0.06,7.24,31460,NULL,18.54,'LMC ZP','NGC 3621',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79487,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79487,29.32,0.06,7.32,31460,NULL,NULL,'cte MW STS03','NGC 3621',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79488,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79488,29.37,0.02,7.48,31460,73,NULL,'Cepheids magnitudes Gaussian, Data 1','NGC 3621',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79489,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79489,29.38,0.1,7.52,31460,NULL,NULL,'5, I','NGC 3621',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79490,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79490,29.38,0.01,7.52,31460,NULL,NULL,'5, I','NGC 3621',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79491,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79491,29.42,0.02,7.66,31460,73,NULL,'Cepheids magnitudes Gaussian, Data 2','NGC 3621',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79492,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79492,29.42,0.02,7.66,31460,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian, Data 2','NGC 3621',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79493,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79493,29.43,0.52,7.69,31460,73,NULL,'Cepheids periods Gaussian, Data 2','NGC 3621',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79494,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79494,29.75,0.16,8.91,31460,NULL,NULL,'5, V','NGC 3621',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79495,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79495,29.75,0.16,8.91,31460,NULL,NULL,'5, V','NGC 3621',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79496,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79496,30.4,NULL,12,31460,NULL,NULL,'49, VI','NGC 3621',NULL,'2006A&A...452..423P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79497,'FGLR','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79497,29.07,0.09,6.52,31460,NULL,NULL,NULL,'NGC 3621',NULL,'2014ApJ...788...56K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79498,'FGLR','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79498,29.08,NULL,6.55,31460,NULL,NULL,NULL,'NGC 3621',NULL,'2008ApJ...681..269K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79499,'TRGB','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79499,29.14,0.06,6.73,31460,74.4,NULL,NULL,'NGC 3621',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79500,'TRGB','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79500,29.26,0.12,7.11,31460,NULL,NULL,'I','NGC 3621',NULL,'2007ApJ...661..815R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79501,'TRGB','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79501,29.36,0.11,7.45,31460,NULL,NULL,NULL,'NGC 3621',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79502,'IRAS','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79502,29.31,0.8,7.28,31460,75,NULL,'A82, H','NGC 3621',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79503,'Sosies','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79503,29.14,0.11,6.73,31460,NULL,NULL,NULL,'NGC 3621',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79504,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79504,28.66,0.4,5.4,31460,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 3621',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79505,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79505,28.7,NULL,5.5,31460,NULL,NULL,'LEDA [April 2006]','NGC 3621',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79506,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79506,28.71,0.47,5.53,31460,75,NULL,'A82, H, raw','NGC 3621',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79507,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79507,28.75,0.36,5.62,31460,NULL,NULL,'B','NGC 3621',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79508,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79508,28.78,0.47,5.69,31460,75,NULL,'A82, H, inv','NGC 3621',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79509,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79509,28.92,0.43,6.1,31460,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3621',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79510,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79510,28.93,0.35,6.11,31460,NULL,NULL,NULL,'NGC 3621',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79511,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79511,29,0.43,6.3,31460,75,NULL,'3.6 micron, color corrected','NGC 3621',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79512,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79512,29.06,0.05,6.49,31460,NULL,NULL,'I','NGC 3621',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79513,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79513,29.08,0.47,6.53,31460,75,NULL,'A82, H, cor','NGC 3621',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79514,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79514,29.11,0.06,6.64,31460,75,NULL,NULL,'NGC 3621',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79515,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79515,29.14,0.06,6.73,31460,74.4,NULL,NULL,'NGC 3621',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79516,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79516,29.27,0.4,7.1,31460,75,NULL,'B','NGC 3621',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79517,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79517,29.26,0.3,7.11,31460,69,NULL,NULL,'NGC 3621',NULL,'1997MNRAS.290L..77S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79518,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79518,38.6,0.46,524,31461,70,NULL,NULL,'2MASX J11181669+0101402',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000099,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,169.569541667,1.02783,0.101,NULL,60348080684,942938760,14733418,17.5),(79519,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:54','1','SN 1966K',NULL,79519,36.35,0.4,186,31462,60,NULL,'M(B) = -19.48 mag','UGC 06322',NULL,'2000ApJ...540..634P',2000,1,1.4,NULL,'G',0.000103,NULL,'14.89',1.4,'SA0+:','in a pair',NULL,NULL,NULL,1,169.569541667,28.26044,0,NULL,60612511942,947070499,14797976,14.89),(79520,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:54','1','SN 1966K',NULL,79520,36.37,0.4,188,31462,60,NULL,'M(V) = -19.47 mag','UGC 06322',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79521,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79521,35.84,0.4,147,31462,NULL,NULL,'mean','UGC 06322',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79522,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79522,35.89,0.45,151,31462,NULL,NULL,'K','UGC 06322',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79523,'G Lens','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79523,40.39,0.55,1200,31463,NULL,NULL,NULL,'PG 1115+080:MWKZ GROUP 1',NULL,'2007ApJ...660....1O',2007,1,NULL,NULL,'GGroup',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,169.570833,7.76306,0.089,NULL,60339085181,942798205,14731221,NULL),(79524,'G Lens','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79524,41.58,0.54,2070,31463,NULL,NULL,NULL,'PG 1115+080:MWKZ GROUP 1',NULL,'2014MNRAS.437..600S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79525,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79525,37.32,0.33,291,31464,70,NULL,NULL,'SDSS J111817.08+183509.3',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.5g',0.32,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,169.5712083,18.58592,0,NULL,61123553367,955055521,14922742,16.5),(79526,'Tully est','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79526,31.77,0.8,22.6,31465,75,NULL,'B','UGC 06320',NULL,'1988NBGC.C....0000T',1988,1,1.04,NULL,'G',0.000017,NULL,'13.9g',0.89,'S?','X-ray-bright group member',NULL,NULL,NULL,1,169.571875,18.84711,0,NULL,61122977306,955046520,14922601,13.9),(79527,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79527,37.79,0.46,361,31466,70,NULL,NULL,'2MASX J11181750+4111247',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,169.572917,41.19031,0,NULL,63926971572,998858930,15607170,17.3),(79528,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79528,36.5,0.46,200,31467,70,NULL,NULL,'2MASX J11181794+4554113',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,169.5747917,45.90314,0,NULL,63949131199,999205174,15612580,17.2),(79529,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79529,35.59,0.46,131,31468,70,NULL,NULL,'2MASX J11181941+0232402',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,169.5809583,2.54458,0.109,NULL,60350525066,942976954,14734014,16.5),(79530,'Ring Diameter','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79530,33.1,0.84,41,31469,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3614',NULL,'1981ApJS...45..541P',1981,1,2.31,NULL,'G',0.000023,NULL,'13.5g',1.28,'SAB(r)c','Possible field galaxy',NULL,NULL,NULL,1,169.588833,45.74822,0,NULL,63949209476,999206398,15612599,13.5),(79531,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79531,32.25,NULL,28.2,31469,NULL,NULL,'B','NGC 3614',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79532,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79532,32.43,0.4,30.6,31469,NULL,NULL,NULL,'NGC 3614',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79533,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79533,32.56,0.68,32.5,31469,NULL,NULL,'Malmquist cor.','NGC 3614',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79534,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79534,32.74,0.2,35.3,31469,74.4,NULL,NULL,'NGC 3614',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79535,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79535,32.81,0.4,36.5,31469,75,NULL,'B','NGC 3614',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79536,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79536,32.83,0.43,36.8,31469,75,NULL,'3.6 micron, color corrected','NGC 3614',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79537,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79537,32.88,0.58,37.6,31469,NULL,NULL,NULL,'NGC 3614',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79538,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79538,33,0.43,39.8,31469,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3614',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79539,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79539,33.02,0.4,40.3,31469,NULL,NULL,'mean','NGC 3614',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79540,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79540,33.49,0.45,49.8,31469,NULL,NULL,'K','NGC 3614',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79541,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79541,33.51,0.46,50.3,31469,NULL,NULL,'J','NGC 3614',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79542,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79542,33.51,0.47,50.3,31469,NULL,NULL,'H','NGC 3614',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79543,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79543,31.99,NULL,25,31470,NULL,NULL,NULL,'LSBC D570-04',NULL,'2015AstBu..70....1K',2015,1,1,NULL,'G',NULL,NULL,NULL,NULL,'dI',NULL,NULL,NULL,NULL,1,169.589167,17.6975,0,NULL,61121216949,955019014,14922172,NULL),(79544,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79544,37.69,0.46,345,31471,70,NULL,NULL,'2MASX J11182269+1458410',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,169.594666667,14.97808,0.014,NULL,61118504540,954976633,14921509,17.6),(79545,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79545,37.4,0.46,301,31472,70,NULL,NULL,'2MASX J11182310+2107170',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'16.8',0.18,NULL,NULL,NULL,NULL,NULL,1,169.596167,21.12147,0,NULL,61099241071,954675641,14916806,16.8),(79546,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79546,37.32,0.33,291,31473,70,NULL,NULL,'2MASX J11182309+1828150',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.59',0.17,NULL,NULL,NULL,NULL,NULL,1,169.5962083,18.47092,0,NULL,61123582857,955055982,14922749,17.59),(79547,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79547,37.99,0.33,397,31474,70,NULL,NULL,'SDSS J111824.15+045649.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00013,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,169.600625,4.947,0.149,NULL,60360183409,943127865,14736372,18.7),(79548,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79548,37.49,0.46,314,31475,70,NULL,NULL,'SDSS J111824.47+380852.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,169.601958333,38.14781,0,NULL,60425203448,944143803,14752246,18.2),(79549,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79549,37.6,0.46,331,31476,70,NULL,NULL,'2MASX J11182514+5035294',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,169.60475,50.59161,0,NULL,61781675108,965338673,15083416,16.9),(79550,'SBF','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79550,31.65,0.22,21.4,31477,NULL,NULL,'I','NGC 3610',NULL,'2001ApJ...546..681T',2001,1,1.83,NULL,'G',0.000017,NULL,'11.7g',1.62,'SB(r)0^0^ pec','in a radial-velocity based grouping',NULL,NULL,NULL,1,169.6052917,58.78628,0,NULL,61983100689,968485948,15132592,11.7),(79551,'SBF','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79551,31.65,0.22,21.4,31477,NULL,NULL,NULL,'NGC 3610',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79552,'SBF','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79552,31.7,0.22,21.9,31477,NULL,NULL,'Malmquist cor.','NGC 3610',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79553,'SBF','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79553,32.47,0.13,31.2,31477,NULL,NULL,'T01','NGC 3610',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79554,'SBF','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79554,32.71,0.09,34.8,31477,NULL,NULL,'J03','NGC 3610',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79555,'SBF','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79555,32.71,0.14,34.8,31477,74.4,NULL,NULL,'NGC 3610',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79556,'SBF','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79556,32.72,0.15,35,31477,NULL,NULL,'BV A01','NGC 3610',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79557,'SBF','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79557,32.97,0.22,39.3,31477,NULL,NULL,'M06','NGC 3610',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79558,'Faber-Jackson','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79558,29.72,0.65,8.79,31477,95,NULL,'Weighted Mean','NGC 3610',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79559,'Faber-Jackson','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79559,30.64,0.81,13.4,31477,55,NULL,'Visvanathan & Sandage 1979','NGC 3610',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79560,'Faber-Jackson','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79560,31.14,NULL,16.9,31477,NULL,NULL,'LEDA [April 2006]','NGC 3610',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79561,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79561,31.07,0.41,16.4,31477,NULL,NULL,NULL,'NGC 3610',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79562,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79562,31.3,0.41,18.2,31477,NULL,NULL,'Malmquist cor.','NGC 3610',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79563,'Tully est','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79563,32.33,0.8,29.2,31477,75,NULL,'B','NGC 3610',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79564,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79564,31.88,0.45,23.8,31477,NULL,NULL,'K','NGC 3610',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79565,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79565,32.39,0.4,30.1,31477,NULL,NULL,'mean','NGC 3610',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79566,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79566,37.77,0.21,357,31478,70,NULL,NULL,'2MASX J11182626+3722578',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,169.609375,37.38272,0,NULL,60429094699,944204604,14753196,17.9),(79567,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79567,37.96,0.46,391,31479,70,NULL,NULL,'2MASX J11182638+5228474',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000166,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,169.609833,52.47992,0,NULL,61785167032,965393234,15084269,17.3),(79568,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79568,34.05,0.59,64.6,31480,70,NULL,NULL,'2MASX J11182730-4821156',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,169.613666667,-48.35439,0.505,NULL,41913745560,654902274,10232848,16.5),(79569,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79569,37.68,0.33,343,31481,70,NULL,NULL,'SDSS J111827.89+183755.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,169.61625,18.63208,0,NULL,61123551838,955055497,14922742,18.2),(79570,'IRAS','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79570,35.13,0.8,106,31482,75,NULL,'CF, r','UGC 06325',NULL,'1997ApJS..109..333W',1997,1,1.5,'HOLM 245B is a star.','G',0.00005,NULL,'14.90',0.5,'Scd?',NULL,NULL,NULL,NULL,1,169.6177917,25.32369,0,NULL,60568573385,946383959,14787249,14.9),(79571,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79571,34.64,0.49,84.6,31482,75,NULL,'IR','UGC 06325',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79572,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79572,34.76,0.38,89.4,31482,75,NULL,'CF, r, raw','UGC 06325',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79573,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79573,34.87,0.34,94.3,31482,NULL,NULL,'Malmquist cor.','UGC 06325',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79574,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79574,34.88,0.38,94.5,31482,75,NULL,'CF, r, inv','UGC 06325',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79575,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79575,34.89,0.34,95,31482,NULL,NULL,NULL,'UGC 06325',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79576,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79576,34.95,0.2,97.7,31482,74.4,NULL,NULL,'UGC 06325',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79577,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79577,34.98,0.38,98.9,31482,75,NULL,'CF, r, cor','UGC 06325',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79578,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79578,36.56,0.27,205,31483,70,NULL,NULL,'2MASX J11182876+4225332',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000157,NULL,'16.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,169.619958333,42.42586,0.055,NULL,63945378984,999146546,15611664,16.9),(79579,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79579,36.98,0.33,249,31484,70,NULL,NULL,'2MASX J11182924+2114000',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.08',0.15,NULL,NULL,NULL,NULL,NULL,1,169.621833333,21.23331,0,NULL,61099218610,954675290,14916801,18.08),(79580,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79580,37.02,0.27,253,31485,70,NULL,NULL,'2MASX J11182963+0105552',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000082,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,169.623417,1.09864,0.101,NULL,60348162834,942940044,14733438,17.1),(79581,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79581,37.46,0.46,310,31486,70,NULL,NULL,'2MASX J11182970+0649101',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000172,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,169.6237083,6.81961,0.165,NULL,60390133493,943595835,14743684,17.5),(79582,'GRB','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79582,46.25,0.57,5080,31487,69.7,NULL,'Calibrated','GRB 030115',2.5,'2009MNRAS.400..775C',2009,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,169.625,15.03333,0.014,NULL,61118533481,954977085,14921516,NULL),(79583,'GRB','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79583,46.29,0.63,5180,31487,72,NULL,NULL,'GRB 030115',2.5,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79584,'GRB','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79584,46.41,0.71,5460,31487,NULL,NULL,NULL,'GRB 030115',2.5,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79585,'GRB','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79585,46.44,0.63,5550,31487,70,NULL,NULL,'GRB 030115',2.5,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79586,'GRB','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79586,46.6,0.59,5970,31487,69.7,NULL,'Fiducial','GRB 030115',2.5,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79587,'GRB','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79587,42.42,NULL,3050,31488,70,NULL,'Pseudo z = 1.44','GRB 030115',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,169.625,15.03333,0.014,NULL,61118533481,954977085,14921516,NULL),(79588,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79588,36.54,0.46,203,31489,70,NULL,NULL,'MCG +11-14-016',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000172,NULL,'16.0g',0.43,'E0',NULL,NULL,NULL,NULL,1,169.629333333,63.08483,0,NULL,61871946827,966749169,15105455,16),(79589,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79589,37.05,0.46,256,31490,70,NULL,NULL,'2MASX J11183133+2734103',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,169.630625,27.56953,0.038,NULL,60614288848,947098263,14798410,17.4),(79590,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79590,37.75,0.46,354,31491,70,NULL,NULL,'2MASX J11183221+1458130',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,169.634375,14.97031,0.014,NULL,61118570883,954977670,14921526,17.3),(79591,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79591,37.68,0.33,343,31492,70,NULL,NULL,'2MASX J11183244+1840520',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.90',0.17,NULL,NULL,NULL,NULL,NULL,1,169.635375,18.68114,0,NULL,61123482512,955054414,14922725,17.9),(79592,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79592,37.43,0.46,307,31493,70,NULL,NULL,'2MASX J11183433+5648583',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000193,NULL,'15.8g',0.44,'E0',NULL,NULL,NULL,NULL,1,169.643083,56.81614,0,NULL,61986507155,968539174,15133424,15.8),(79593,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79593,35.1,0.46,105,31494,70,NULL,NULL,'IC 2708',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000147,NULL,'14.7g',0.67,NULL,NULL,NULL,NULL,NULL,1,169.6442083,12.71111,0.025,NULL,60213963200,940843175,14700674,14.7),(79594,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79594,36.56,0.27,205,31495,70,NULL,NULL,'2MASX J11183472+4225173',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000179,NULL,'15.8g',0.48,'E0',NULL,NULL,NULL,NULL,1,169.644625,42.42139,0.055,NULL,63945377583,999146524,15611664,15.8),(79595,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79595,36.56,0.46,205,31496,70,NULL,NULL,'2MASX J11183481+1940490',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.52',0.2,NULL,NULL,NULL,NULL,NULL,1,169.645167,19.68022,0,NULL,61121903918,955029748,14922339,16.52),(79596,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79596,37.02,0.27,253,31497,70,NULL,NULL,'2MASX J11183576+0103412',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000105,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,169.649,1.06139,0.101,NULL,60348060219,942938440,14733413,17.2),(79597,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79597,37.02,0.27,253,31498,70,NULL,NULL,'2MASX J11183596+0101512',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000091,NULL,'16.0g',0.44,'BrClG',NULL,NULL,NULL,NULL,1,169.6500417,1.031,0.101,NULL,60348062805,942938481,14733413,16),(79598,'SBF','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79598,32.32,0.4,29.1,31499,NULL,NULL,'I','NGC 3613',NULL,'2001ApJ...546..681T',2001,1,3.9,NULL,'G',0.000017,NULL,'11.82',1.9,'E6','in a radial-velocity based grouping',NULL,NULL,NULL,1,169.6504583,58,0,NULL,61981217493,968456523,15132133,11.82),(79599,'SBF','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79599,32.32,0.4,29.1,31499,NULL,NULL,NULL,'NGC 3613',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79600,'SBF','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79600,32.39,0.14,30.1,31499,74.4,NULL,NULL,'NGC 3613',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79601,'SBF','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79601,32.57,0.4,32.7,31499,NULL,NULL,'Malmquist cor.','NGC 3613',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79602,'D-Sigma','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79602,31.84,0.4,23.3,31499,75,NULL,'Edat, raw','NGC 3613',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79603,'D-Sigma','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79603,32.17,0.4,27.2,31499,75,NULL,'Edat, cor','NGC 3613',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79604,'Faber-Jackson','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79604,31.25,0.65,17.8,31499,95,NULL,'Weighted Mean','NGC 3613',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79605,'Faber-Jackson','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79605,32.53,0.81,32.1,31499,55,NULL,'Visvanathan & Sandage 1979','NGC 3613',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79606,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79606,32.3,0.41,28.8,31499,NULL,NULL,NULL,'NGC 3613',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79607,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79607,32.56,0.41,32.5,31499,NULL,NULL,'Malmquist cor.','NGC 3613',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79608,'Tully est','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79608,32.59,0.8,32.9,31499,75,NULL,'B','NGC 3613',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79609,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79609,31.96,0.45,24.7,31499,NULL,NULL,'K','NGC 3613',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79610,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79610,32.73,0.4,35.2,31499,NULL,NULL,'mean','NGC 3613',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79611,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79611,38.65,0.46,537,31500,70,NULL,NULL,'SDSS J111836.19-000530.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00007,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,169.650833,-0.09169,0.221,NULL,40819618638,637806541,9965727,18.7),(79612,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79612,37.77,0.21,357,31501,70,NULL,NULL,'2MASX J11183675+3723218',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,169.653208333,37.38942,0,NULL,60429065753,944204152,14753189,18),(79613,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79613,36.31,0.46,182,31502,70,NULL,NULL,'2MASX J11183845+5737287',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000176,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,169.6602083,57.62461,0,NULL,61987774682,968558979,15133734,16.4),(79614,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79614,37.62,0.46,334,31503,70,NULL,NULL,'2MASX J11183858+1156440',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000189,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,169.660833,11.94547,0,NULL,60213811890,940840810,14700637,17),(79615,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79615,38.11,0.11,418,31504,70,NULL,NULL,'2MASX J11183865+5333330',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000181,NULL,'17.1g',0.26,'BrClG',NULL,NULL,NULL,NULL,1,169.6612917,53.55922,0,NULL,61782720999,965355015,15083672,17.1),(79616,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79616,37.44,0.46,307,31505,70,NULL,NULL,'2MASX J11183905+2828353',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000145,NULL,'18.77',0.15,NULL,NULL,NULL,NULL,NULL,1,169.6627917,28.47664,0,NULL,60604948447,946952319,14796129,18.77),(79617,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79617,35.62,0.46,133,31506,70,NULL,NULL,'CGCG 156-059',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.0001,NULL,'15.1g',0.48,NULL,NULL,NULL,NULL,NULL,1,169.667917,28.53228,0,NULL,60604955329,946952427,14796131,15.1),(79618,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79618,37.99,0.33,397,31507,70,NULL,NULL,'SDSS J111840.74+045948.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000169,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,169.66975,4.99681,0.149,NULL,60360114940,943126795,14736356,18.2),(79619,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79619,35.67,0.48,136,31508,NULL,NULL,'Malmquist cor.','ESO 503- G 013',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.85',0.6,'S...',NULL,NULL,NULL,NULL,1,169.672583333,-24.68933,0.177,NULL,41425782120,647277845,10113716,15.85),(79620,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79620,35.9,0.43,152,31508,NULL,NULL,NULL,'ESO 503- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79621,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79621,35.94,0.2,154,31508,74.4,NULL,NULL,'ESO 503- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79622,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79622,38.22,0.33,440,31509,70,NULL,NULL,'2MASX J11184138+4501303',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,169.672625,45.02522,0,NULL,63950987597,999234181,15613034,17.9),(79623,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79623,38.38,0.23,475,31510,70,NULL,NULL,'SDSS J111841.76+541955.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000138,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,169.674041667,54.33217,0,NULL,61790508277,965476691,15085573,18.5),(79624,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79624,34.81,0.55,91.8,31511,70,NULL,NULL,'ESO 265- G 022',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'14.91',1,'(R_1R\'_2)SB(s)a',NULL,NULL,NULL,NULL,1,169.678667,-46.67772,0.581,NULL,41934624061,655228500,10237945,14.91),(79625,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79625,36.56,0.27,205,31512,70,NULL,NULL,'2MASX J11184401+4226333',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000187,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,169.683416667,42.44269,0.055,NULL,63945390164,999146721,15611667,16.7),(79626,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79626,37.2,0.46,275,31513,70,NULL,NULL,'2MASX J11184593+1532113',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000154,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,169.691416667,15.53658,0,NULL,61118970493,954983913,14921623,16.8),(79627,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79627,37.49,0.46,315,31514,70,NULL,NULL,'2MASX J11184594+5641257',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,169.691625,56.69042,0,NULL,61986564525,968540070,15133438,17.8),(79628,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79628,38.1,0.46,416,31515,70,NULL,NULL,'2MASX J11184726+5342200',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,169.69675,53.70553,0,NULL,61790937723,965483401,15085678,17.9),(79629,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79629,38.35,0.46,467,31516,70,NULL,NULL,'SDSS J111847.78+371312.5',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000176,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,169.699125,37.22017,0,NULL,60431130478,944236413,14753693,17.3),(79630,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79630,36.65,0.46,214,31517,70,NULL,NULL,'2MASX J11184848+2807383',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.001009,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,169.701875,28.12731,0,NULL,60604850050,946950782,14796105,16.5),(79631,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79631,36.8,0.46,230,31518,70,NULL,NULL,'2MASX J11184893+2526443',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.89',0.18,NULL,NULL,NULL,NULL,NULL,1,169.7040417,25.44558,0,NULL,60568460396,946382193,14787221,17.89),(79632,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79632,37.83,0.33,368,31519,70,NULL,NULL,'SDSS J111849.02+524939.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,169.70425,52.82758,0,NULL,61784672813,965385512,15084148,17.7),(79633,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79633,36.47,NULL,197,31520,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1226',NULL,'2010Ap&SS.325..163P',2010,1,0.82,NULL,'G',0.000222,NULL,'17.4g',0.12,'Sc',NULL,NULL,NULL,NULL,1,169.705333,57.24981,0,NULL,61987729046,968558266,15133722,17.4),(79634,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79634,36.49,NULL,199,31520,NULL,NULL,NULL,'FGC 1226',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79635,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79635,36.5,NULL,200,31520,NULL,NULL,'Dipole + Quadrupole','FGC 1226',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79636,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79636,36.54,NULL,203,31520,NULL,NULL,'Dipole','FGC 1226',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79637,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79637,36.81,0.46,231,31521,70,NULL,NULL,'2MASX J11184958+4134487',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,169.70675,41.58042,0,NULL,63944548792,999133574,15611462,17.2),(79638,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79638,37.6,0.33,330,31522,70,NULL,NULL,'2MASX J11184993+5144291',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000183,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,169.708,51.74156,0,NULL,61786348842,965411700,15084557,16.8),(79639,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79639,38.18,0.46,432,31523,70,NULL,NULL,'2MASX J11185107+5113291',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,169.7129583,51.22475,0,NULL,61779834788,965309918,15082967,18),(79640,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79640,35.51,0.43,126,31524,NULL,NULL,'Malmquist cor.','ESO 438- G 020',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.00003,NULL,'14.75',0.7,'S?;LINER       HII','Pair member (points to parent)',NULL,NULL,NULL,1,169.72275,-29.42433,0.357,NULL,41595969043,649937016,10155265,14.75),(79641,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79641,35.64,0.4,134,31524,NULL,NULL,NULL,'ESO 438- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79642,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79642,35.68,0.2,137,31524,74.4,NULL,NULL,'ESO 438- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79643,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79643,35.79,0.4,144,31524,NULL,NULL,'mean','ESO 438- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79644,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79644,35.85,0.47,148,31524,NULL,NULL,'H','ESO 438- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79645,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79645,35.94,0.45,154,31524,NULL,NULL,'K','ESO 438- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79646,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79646,35.99,0.46,157,31524,NULL,NULL,'J','ESO 438- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79647,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79647,37.52,0.46,320,31525,70,NULL,NULL,'2MASX J11185399+2105382',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00009,NULL,'17.6',0.13,NULL,NULL,NULL,NULL,NULL,1,169.724833,21.09386,0,NULL,61099452158,954678939,14916858,17.6),(79648,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79648,37.25,0.46,282,31526,70,NULL,NULL,'2MASX J11185401+1843232',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.36',0.17,NULL,NULL,NULL,NULL,NULL,1,169.725083333,18.72311,0,NULL,61123504248,955054753,14922730,17.36),(79649,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79649,37.3,0.46,289,31527,70,NULL,NULL,'2MASX J11185549+1906502',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.30',0.15,NULL,NULL,NULL,NULL,NULL,1,169.731083,19.114,0,NULL,61121838452,955028725,14922323,18.3),(79650,'IRAS','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79650,30.61,0.8,13.3,31528,75,NULL,'A82, H','MESSIER 065',NULL,'1997ApJS..109..333W',1997,1,9.8,NULL,'G',0.00001,NULL,'10.25',2.9,'SAB(rs)a       LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,169.733,13.09236,0.023,NULL,61104250862,954753919,14918029,10.25),(79651,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79651,29.31,0.4,7.3,31528,75,NULL,'B','MESSIER 065',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79652,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79652,30.39,0.35,12,31528,NULL,NULL,NULL,'MESSIER 065',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79653,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79653,30.42,0.39,12.1,31528,NULL,NULL,NULL,'MESSIER 065',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79654,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79654,30.43,0.2,12.2,31528,74.4,NULL,NULL,'MESSIER 065',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79655,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79655,30.45,0.4,12.3,31528,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','MESSIER 065',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79656,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79656,30.47,0.38,12.4,31528,NULL,NULL,'Malmquist cor.','MESSIER 065',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79657,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79657,30.54,0.4,12.8,31528,73,NULL,'opt','MESSIER 065',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79658,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79658,30.59,0.47,13.1,31528,75,NULL,'A82, H, raw','MESSIER 065',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79659,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79659,30.62,0.43,13.3,31528,75,NULL,'3.6 micron, color corrected','MESSIER 065',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79660,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79660,30.65,0.3,13.5,31528,55,NULL,'B','MESSIER 065',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79661,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79661,30.81,0.47,14.5,31528,75,NULL,'A82, H, inv','MESSIER 065',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79662,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79662,30.82,0.43,14.6,31528,75,NULL,'3.6 micron, color + selection bias corrected','MESSIER 065',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79663,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79663,30.93,0.47,15.4,31528,75,NULL,'A82, H, cor','MESSIER 065',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79664,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79664,37.2,0.27,275,31529,70,NULL,NULL,'2MASX J11185658+1346263',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000173,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,169.735625,13.77408,0.007,NULL,61104465456,954757272,14918082,16.9),(79665,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79665,37.89,0.46,378,31530,70,NULL,NULL,'SDSS J111857.17+504155.7',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000139,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,169.73825,50.69883,0,NULL,61779699665,965307807,15082934,18),(79666,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79666,37.56,0.46,325,31531,70,NULL,NULL,'2MASX J11185876+2434010',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,169.74475,24.56708,0,NULL,60567319535,946364367,14786943,18.1),(79667,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79667,37.83,0.33,368,31532,70,NULL,NULL,'2MASX J11185948+5252321',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,169.747666667,52.87556,0,NULL,61784492859,965382700,15084104,17.4),(79668,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79668,38.07,0.33,412,31533,70,NULL,NULL,'2MASX J11185956+3544347',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000184,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,169.748375,35.74306,0.023,NULL,60421638746,944088105,14751376,16.6),(79669,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79669,37.52,0.33,319,31534,70,NULL,NULL,'2MASX J11190006+2106402',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000117,NULL,'16.7',0.19,NULL,NULL,NULL,NULL,NULL,1,169.7502083,21.11103,0,NULL,61099450730,954678917,14916858,16.7),(79670,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79670,37.95,0.46,388,31535,70,NULL,NULL,'2MASX J11190013+1547243',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,169.7505,15.79019,0.007,NULL,61119098526,954985914,14921654,17.1),(79671,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79671,37.71,0.46,349,31536,70,NULL,NULL,'2MASX J11190031+3834554',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000168,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,169.75125,38.58225,0,NULL,60424926792,944139481,14752179,17.4),(79672,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79672,38.42,0.33,483,31537,70,NULL,NULL,'SDSS J111901.55+525309.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,169.7565,52.88592,0,NULL,61784493074,965382704,15084104,18.5),(79673,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79673,37.2,0.27,275,31538,70,NULL,NULL,'2MASX J11190173+1352513',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,169.7572917,13.88092,0.007,NULL,61104055950,954750874,14917982,17.4),(79674,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79674,36.62,0.46,211,31539,70,NULL,NULL,'2MASX J11190308+0513364',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000181,NULL,'16.4g',0.27,'E0',NULL,NULL,NULL,NULL,1,169.763416667,5.22744,0.129,NULL,60359704073,943120376,14736255,16.4),(79675,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79675,38.43,0.27,485,31540,70,NULL,NULL,'2MASX J11190538+5516597',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,169.7725,55.28339,0,NULL,61984326857,968505107,15132892,18.4),(79676,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79676,37.1,0.46,263,31541,70,NULL,NULL,'2MASX J11190615+0439244',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000188,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,169.7755417,4.65678,0.145,NULL,60359269330,943113583,14736149,16.6),(79677,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79677,34.67,0.49,85.8,31542,75,NULL,'IR','UGC 06331',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000017,NULL,'15.06',0.3,'Sd(f)',NULL,NULL,NULL,NULL,1,169.781125,3.23106,0.117,NULL,60361623333,943150364,14736724,15.06),(79678,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79678,38.1,0.33,418,31543,70,NULL,NULL,'2MASX J11190788+3727494',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,169.782875,37.46386,0,NULL,60429137677,944205276,14753207,18.1),(79679,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79679,38.38,0.23,475,31544,70,NULL,NULL,'2MASX J11190817+5448117',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,169.78425,54.80322,0,NULL,61983662565,968494727,15132730,17.9),(79680,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79680,38.22,0.33,440,31545,70,NULL,NULL,'2MASX J11190844+4500282',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000175,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,169.785291667,45.008,0,NULL,63950984217,999234128,15613033,17.4),(79681,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79681,38.14,0.46,425,31546,70,NULL,NULL,'2MASX J11191004+1236555',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,169.7917917,12.61533,0.061,NULL,60216866858,940888544,14701383,17.4),(79682,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79682,36.01,0.33,159,31547,70,NULL,NULL,'IC 2713',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00018,NULL,'15.9g',0.46,NULL,NULL,NULL,NULL,NULL,1,169.792583,12.16481,0.015,NULL,60217232263,940894254,14701472,15.9),(79683,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79683,37.52,0.33,319,31548,70,NULL,NULL,'2MASX J11191027+2104312',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00011,NULL,'17.2',0.23,NULL,NULL,NULL,NULL,NULL,1,169.792833,21.07528,0,NULL,61099459752,954679058,14916860,17.2),(79684,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79684,37.45,0.46,309,31549,70,NULL,NULL,'2MASX J11191115+0815401',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000214,NULL,'16.1g',0.41,NULL,NULL,NULL,NULL,NULL,1,169.796416667,8.26108,0.085,NULL,60338255701,942785245,14731019,16.1),(79685,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79685,38.09,0.46,415,31550,70,NULL,NULL,'2MASX J11191233+3658034',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,169.801417,36.96761,0,NULL,60431505532,944242273,14753785,17.4),(79686,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79686,37.6,0.33,330,31551,70,NULL,NULL,'2MASX J11191263+5141230',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000168,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,169.802583333,51.68983,0,NULL,61779009626,965297025,15082766,17),(79687,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79687,30.34,NULL,11.7,31552,NULL,NULL,NULL,'AGC 215286',NULL,'2015AstBu..70....1K',2015,1,NULL,NULL,'G',0.000047,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,169.802917,14.32778,0.024,NULL,61103978121,954749658,14917963,NULL),(79688,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79688,38.43,0.27,485,31553,70,NULL,NULL,'2MASX J11191369+5516177',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,169.8072917,55.27153,0,NULL,61984327341,968505114,15132892,18.1),(79689,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79689,34.21,NULL,69.5,31554,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1227',NULL,'2010Ap&SS.325..163P',2010,1,1.19,NULL,'G',0.000077,NULL,'16.6',0.08,'Sd',NULL,NULL,NULL,NULL,1,169.808416667,61.52408,0,NULL,61861645500,966588210,15102940,16.6),(79690,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79690,34.23,NULL,70.2,31554,NULL,NULL,'Dipole + Quadrupole','FGC 1227',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79691,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79691,34.24,NULL,70.4,31554,NULL,NULL,'Dipole','FGC 1227',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79692,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79692,34.29,NULL,72.2,31554,NULL,NULL,NULL,'FGC 1227',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79693,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79693,37.65,0.46,339,31555,70,NULL,NULL,'2MASX J11191408+3704024',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,169.808667,37.06733,0,NULL,60431382580,944240352,14753755,17.6),(79694,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79694,35.72,0.46,139,31556,70,NULL,NULL,'2MASX J11191407+2947560',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'16.1g',0.3,NULL,'Group member',NULL,NULL,NULL,1,169.808791667,29.79872,0.03,NULL,60662470136,947851095,14810173,16.1),(79695,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79695,38.38,0.46,473,31557,70,NULL,NULL,'SDSS J111914.12+374459.7',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000197,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,169.808875,37.74994,0,NULL,60429140047,944205313,14753208,16.9),(79696,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79696,30.34,NULL,11.7,31558,NULL,NULL,NULL,'IC 2715',NULL,'2015AstBu..70....1K',2015,1,0.59,NULL,'G',0.000085,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,169.809958333,11.95217,0,NULL,60217258766,940894668,14701479,17.1),(79697,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:54','1','SN 2007bc',NULL,79697,34.11,0.18,65,31559,74.2,NULL,'SALT 2','UGC 06332',0.02077,'2010ApJ...716..712A',2010,1,1.2,NULL,'G',0.000113,NULL,'14.13',1.1,'(R)SBa',NULL,NULL,NULL,NULL,1,169.81925,20.81356,0,NULL,61099306247,954676660,14916822,14.13),(79698,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:54','1','SN 2007bc',NULL,79698,34.6,0.11,79.8,31559,72,NULL,NULL,'UGC 06332',0.02077,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79699,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:54','1','SN 2007bc',NULL,79699,34.74,0.21,86.7,31559,73.8,NULL,'SALT 2 (SNANA)','UGC 06332',0.0217,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79700,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:54','1','SN 2007bc',NULL,79700,34.71,0.09,87.5,31559,74.4,NULL,NULL,'UGC 06332',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79701,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:54','1','SN 2007bc',NULL,79701,34.78,0.23,88.5,31559,73.8,NULL,'SALT 2 (SNANA)','UGC 06332',0.0217,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79702,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:54','1','SN 2007bc',NULL,79702,34.8,0.17,89.3,31559,70,NULL,'SALT 2','UGC 06332',0.02077,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79703,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:54','1','SN 2007bc',NULL,79703,34.82,0.02,90.2,31559,72,NULL,'MLCS31','UGC 06332',0.02077,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79704,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:54','1','SN 2007bc',NULL,79704,34.83,0.06,92.5,31559,72,NULL,'M(H) = -18.317 mag','UGC 06332',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79705,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:54','1','SN 2007bc',NULL,79705,34.92,0.21,94.2,31559,65,NULL,'MLCS31','UGC 06332',0.02077,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79706,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:54','1','SN 2007bc',NULL,79706,34.93,0.19,94.9,31559,65,NULL,'MLCS17','UGC 06332',0.02077,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79707,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:54','1','SN 2007bc',NULL,79707,35,0.19,98.1,31559,65,NULL,'SALT','UGC 06332',0.02077,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79708,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:54','1','SN 2007bc',NULL,79708,35.04,0.21,99.9,31559,65,NULL,'SALT2','UGC 06332',0.02077,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79709,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:54','1','SN 2007bc',NULL,79709,35.36,0.03,116,31559,70,NULL,'SALT 2','UGC 06332',0.02077,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79710,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79710,36.23,0.46,176,31560,70,NULL,NULL,'2MASX J11191685-0023148',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000084,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,169.82025,-0.38736,0.157,NULL,40819770129,637808908,9965764,16.6),(79711,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79711,35.84,0.21,147,31561,70,NULL,NULL,'CGCG 185-035',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.00007,NULL,'15.0g',0.45,NULL,NULL,NULL,NULL,NULL,1,169.8204583,34.12844,0.057,NULL,60644535983,947570874,14805794,15),(79712,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79712,38,0.33,398,31562,70,NULL,NULL,'2MASX J11191816+5320549',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,169.8255417,53.34875,0,NULL,61790805329,965481333,15085645,17.6),(79713,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79713,38.11,0.11,418,31563,70,NULL,NULL,'2MASX J11191961+5341170',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000189,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,169.831583,53.68822,0,NULL,61790944808,965483512,15085679,17),(79714,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79714,36.04,0.2,161,31564,74.4,NULL,NULL,'IC 2718',NULL,'2013AJ....146...86T',2013,1,0.65,NULL,'G',0.000095,NULL,'16.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,169.837083,12.02228,0,NULL,60217292653,940895197,14701487,16.1),(79715,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79715,37.68,0.33,343,31565,70,NULL,NULL,'2MASX J11192102+1933518',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.20',0.14,NULL,NULL,NULL,NULL,NULL,1,169.837541667,19.56444,0,NULL,61122441976,955038155,14922471,18.2),(79716,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79716,38.11,0.11,418,31566,70,NULL,NULL,'2MASX J11192115+5332270',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,169.838333,53.54092,0,NULL,61790963894,965483810,15085684,17.8),(79717,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79717,36.15,0.46,170,31567,70,NULL,NULL,'2MASX J11192130+0412342',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000164,NULL,'16.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,169.83875,4.20944,0.125,NULL,60357405633,943084463,14735694,16.8),(79718,'Faber-Jackson','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79718,31.84,0.65,23.3,31568,95,NULL,'Weighted Mean','NGC 3619',NULL,'1984ApJS...56...91D',1984,1,1.89,NULL,'G',0.000017,NULL,'12.5g',1.57,'(R)SA(s)0+:','in a radial-velocity based grouping',NULL,NULL,NULL,1,169.839833,57.75783,0,NULL,61981198551,968456227,15132128,12.5),(79719,'Faber-Jackson','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79719,33.25,0.81,44.7,31568,55,NULL,'Visvanathan & Sandage 1979','NGC 3619',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79720,'Tully est','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79720,32.23,0.8,27.9,31568,75,NULL,'B','NGC 3619',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79721,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79721,36.73,0.46,222,31569,70,NULL,NULL,'2MASX J11192184-0056598',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000064,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,169.840917,-0.95008,0.145,NULL,40819452228,637803941,9965686,16.8),(79722,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79722,38.21,0.46,440,31570,70,NULL,NULL,'2MASX J11192261+3741454',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,169.844125,37.69597,0,NULL,60428928185,944202002,14753156,17.8),(79723,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79723,36.35,0.46,186,31571,70,NULL,NULL,'2MASX J11192321+3711494',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000189,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,169.846833333,37.19714,0,NULL,60431095302,944235864,14753685,16.5),(79724,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79724,36.14,0.46,169,31572,70,NULL,NULL,'2MASX J11192351+3833284',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000166,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,169.848041667,38.55783,0,NULL,60424919061,944139360,14752177,16.7),(79725,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79725,38.1,0.33,418,31573,70,NULL,NULL,'2MASX J11192358+3726574',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00018,NULL,'17.4g',0.24,'BrClG',NULL,NULL,NULL,NULL,1,169.8482083,37.44936,0,NULL,60429127343,944205114,14753204,17.4),(79726,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79726,38.38,0.23,475,31574,70,NULL,NULL,'2MASX J11192403+5439246',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,169.849917,54.65692,0,NULL,61761165782,965018215,15078409,17.8),(79727,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79727,37.09,0.46,262,31575,70,NULL,NULL,'2MASX J11192419+3304203',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000157,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,169.8510417,33.07222,0.08,NULL,60644285455,947566960,14805733,16.7),(79728,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79728,37.2,0.27,275,31576,70,NULL,NULL,'2MASX J11192427+1352135',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000178,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,169.851083333,13.87031,0.007,NULL,61104496003,954757750,14918089,16.4),(79729,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79729,36.98,0.33,249,31577,70,NULL,NULL,'2MASX J11192428+2110298',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000133,NULL,'16.6',0.19,NULL,NULL,NULL,NULL,NULL,1,169.851083333,21.175,0,NULL,61099433798,954678653,14916853,16.6),(79730,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79730,36.9,0.46,240,31578,70,NULL,NULL,'2MASX J11192430+5547191',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,169.851083333,55.78861,NULL,NULL,61986931275,968545801,15133528,17.1),(79731,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79731,36.54,0.46,204,31579,70,NULL,NULL,'2MASX J11192426+0526572',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,169.851125,5.44903,0.129,NULL,60359492866,943117076,14736204,17.4),(79732,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79732,38.55,0.46,512,31580,70,NULL,NULL,'2MASX J11192438+6316099',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000172,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,169.85125,63.26967,0,NULL,61871784277,966746629,15105416,17),(79733,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79733,38.11,0.11,418,31581,70,NULL,NULL,'2MASX J11192502+5340580',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000171,NULL,'17.0g',0.31,NULL,NULL,NULL,NULL,NULL,1,169.854417,53.68286,0,NULL,61790945126,965483517,15085679,17),(79734,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79734,35.39,0.46,119,31582,70,NULL,NULL,'2MASX J11192579+3505263',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00017,NULL,'15.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,169.857375,35.09064,0.039,NULL,60421970781,944093293,14751457,15.6),(79735,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79735,38.43,0.27,485,31583,70,NULL,NULL,'2MASX J11192588+5515341',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000206,NULL,'17.2g',0.24,'BrClG',NULL,NULL,NULL,NULL,1,169.8577917,55.25953,0,NULL,61984326122,968505095,15132892,17.2),(79736,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79736,36.5,0.46,200,31584,70,NULL,NULL,'2MASX J11192682+0058052',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000107,NULL,'16.0g',0.32,'S0^-',NULL,NULL,NULL,NULL,1,169.861667,0.96808,0.117,NULL,60163855485,940060241,14688441,16),(79737,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79737,38,0.33,398,31585,70,NULL,NULL,'2MASX J11192749+5321340',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000171,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,169.864583,53.35942,0,NULL,61790804975,965481327,15085645,17.4),(79738,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79738,37.02,1.05,253,31586,70,NULL,NULL,'2MASX J11192785-0959367',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,169.8660417,-9.99353,0.081,NULL,41019245873,640925716,10014464,15.4),(79739,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79739,37.07,0.33,259,31587,70,NULL,NULL,'2MASX J11192792+0421052',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00012,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,169.8662083,4.35136,0.125,NULL,60359235906,943113061,14736141,17.5),(79740,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79740,37.58,0.1,328,31588,70,NULL,NULL,'2MASX J11192802+5421462',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000205,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,169.866917,54.36283,0,NULL,61790531974,965477062,15085579,16.3),(79741,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79741,31.57,NULL,20.6,31589,NULL,NULL,NULL,'SDSS J111928.09+093544.2',NULL,'2015AstBu..70....1K',2015,1,0.38,NULL,'G',0.000066,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,169.867083,9.59564,0.057,NULL,60346710822,942917356,14733083,17),(79742,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79742,37.29,0.33,287,31590,70,NULL,NULL,'2MASX J11192819+0751261',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000176,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,169.8674583,7.85736,0.077,NULL,60339061580,942797837,14731216,16.8),(79743,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79743,37.55,0.46,323,31591,70,NULL,NULL,'2MASX J11192910+2211038',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.20',0.16,NULL,NULL,NULL,NULL,NULL,1,169.871167,22.18456,0,NULL,61100214350,954690849,14917044,18.2),(79744,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79744,36.71,0.46,220,31592,70,NULL,NULL,'CGCG 011-054',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000213,NULL,'15.7g',0.38,'E',NULL,NULL,NULL,NULL,1,169.872667,1.61961,0.101,NULL,60351575122,942993361,14734271,15.7),(79745,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79745,35.46,0.46,123,31593,70,NULL,NULL,'ARK 287',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000217,NULL,'15.3',0.17,NULL,NULL,NULL,NULL,NULL,1,169.875,24.98933,0,NULL,60568910991,946389234,14787331,15.3),(79746,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:54','1','SN 2008Y',NULL,79746,37.33,0.2,273,31594,73.8,NULL,'SALT 2 (SNANA)','MCG +09-19-039',0.0703,'2014ApJ...795...44R',2014,1,0.66,NULL,'G',0.000158,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,169.8784583,54.46086,0,NULL,61761154368,965018037,15078406,16.3),(79747,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79747,38.31,0.33,460,31595,70,NULL,NULL,'2MASX J11193156+5504142',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,169.8814583,55.07072,0,NULL,61983592252,968493628,15132712,17.7),(79748,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79748,37.14,0.27,269,31596,70,NULL,NULL,'2MASX J11193303+2909593',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'16.9g',0.24,'E',NULL,NULL,NULL,NULL,1,169.8875417,29.16631,0.017,NULL,60604774892,946949607,14796087,16.9),(79749,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79749,37.34,0.33,294,31597,70,NULL,NULL,'2MASXi J1119339-003816',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00007,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,169.891375,-0.63772,0.161,NULL,40819790934,637809233,9965769,18.1),(79750,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79750,37.14,0.27,269,31598,70,NULL,NULL,'CGCG 156-062',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000193,NULL,'15.1g',0.62,'S0',NULL,NULL,NULL,NULL,1,169.8939583,29.18317,0.017,NULL,60604775415,946949615,14796087,15.1),(79751,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79751,37.49,0.46,314,31599,70,NULL,NULL,'2MASX J11193463+1750464',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.08',0.17,NULL,NULL,NULL,NULL,NULL,1,169.894167,17.84628,0,NULL,61121167731,955018245,14922160,18.08),(79752,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79752,38.42,0.33,483,31600,70,NULL,NULL,'2MASX J11193550+5245171',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,169.898166667,52.75475,0,NULL,61792159705,965502495,15085976,17.8),(79753,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79753,36.01,0.33,159,31601,70,NULL,NULL,'IC 2720',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000087,NULL,'15.2g',0.59,NULL,NULL,NULL,NULL,NULL,1,169.8985417,12.07658,0.031,NULL,60217292904,940895201,14701487,15.2),(79754,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79754,38.11,0.11,418,31602,70,NULL,NULL,'2MASX J11193573+5331471',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000177,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,169.898875,53.52975,0,NULL,61790975684,965483995,15085687,17.5),(79755,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79755,37.14,0.27,269,31603,70,NULL,NULL,'2MASX J11193586+2909023',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000188,NULL,'16.2g',0.36,'E',NULL,NULL,NULL,NULL,1,169.899291667,29.1505,0.017,NULL,60604772999,946949578,14796087,16.2),(79756,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79756,37.78,0.46,360,31604,70,NULL,NULL,'2MASX J11193589+1949278',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.37',0.14,NULL,NULL,NULL,NULL,NULL,1,169.899625,19.82431,0,NULL,61121568389,955024506,14922257,18.37),(79757,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79757,35.6,0.46,132,31605,70,NULL,NULL,'2MASX J11193796+3326582',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000176,NULL,'15.4g',0.46,NULL,NULL,NULL,NULL,NULL,1,169.90825,33.44936,0.071,NULL,60644140157,947564689,14805698,15.4),(79758,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79758,36.14,0.46,169,31606,70,NULL,NULL,'2MASX J11193829+6606412',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000079,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,169.909583,66.11161,0,NULL,61813917684,965842463,15091288,16.5),(79759,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79759,36.82,0.46,232,31607,70,NULL,NULL,'2MASX J11193834+1925188',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.09',0.16,NULL,NULL,NULL,NULL,NULL,1,169.909833,19.42181,0,NULL,61122500978,955039077,14922485,18.09),(79760,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79760,37.93,0.33,385,31608,70,NULL,NULL,'2MASX J11193995+1505003',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000217,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,169.916375,15.08347,0.015,NULL,61118444196,954975690,14921495,17.7),(79761,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79761,36.72,0.46,221,31609,70,NULL,NULL,'2MASX J11194054+4719334',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,169.918875,47.32592,0,NULL,63947016440,999172131,15612064,16.8),(79762,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79762,37.68,0.33,343,31610,70,NULL,NULL,'2MASX J11194118+1932108',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.91',0.16,NULL,NULL,NULL,NULL,NULL,1,169.921667,19.53639,0,NULL,61122506738,955039167,14922486,17.91),(79763,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79763,37.52,0.33,319,31611,70,NULL,NULL,'2MASX J11194283+2956188',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,169.928625,29.93856,0.03,NULL,60662302123,947848470,14810132,18.3),(79764,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79764,37.1,0.46,264,31612,70,NULL,NULL,'2MASX J11194289+3708427',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000135,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,169.9287083,37.14522,0,NULL,60431206642,944237603,14753712,17.9),(79765,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79765,37.93,0.33,385,31613,70,NULL,NULL,'2MASX J11194333+1506153',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,169.930583,15.10436,0.015,NULL,61118443805,954975684,14921495,17.3),(79766,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79766,37.48,0.46,314,31614,70,NULL,NULL,'SDSS J111943.56+212651.2',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.7g',0.3,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,169.9315417,21.44758,0,NULL,61098777586,954668399,14916693,16.7),(79767,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79767,37.58,0.1,328,31615,70,NULL,NULL,'2MASX J11194438+5423022',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000197,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,169.935125,54.38389,0,NULL,61790533966,965477093,15085579,16.8),(79768,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79768,38.09,0.46,415,31616,70,NULL,NULL,'2MASX J11194461+5049361',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'17.3g',0.22,'AGN',NULL,NULL,NULL,NULL,1,169.9362917,50.82664,0,NULL,61779682123,965307533,15082930,17.3),(79769,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79769,33.04,NULL,40.5,31617,NULL,NULL,NULL,'SDSS J111945.26+153008.0',NULL,'2015AstBu..70....1K',2015,1,NULL,'14th mag star 14\\\" to the southeast.','G',0.000172,NULL,'16.3g',NULL,NULL,NULL,NULL,NULL,NULL,1,169.937917,15.50222,0,NULL,61119376683,954990260,14921722,16.3),(79770,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79770,37.58,0.1,328,31618,70,NULL,NULL,'2MASX J11194610+5428022',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000183,NULL,'16.3g',0.38,'AGN',NULL,NULL,NULL,NULL,1,169.9420417,54.46731,0,NULL,61761153787,965018027,15078406,16.3),(79771,'L(H{beta})-{sigma}','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79771,46.06,NULL,1604,31619,74.3,NULL,NULL,'WISP 204_0133',2.191,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,169.9432083,4.17522,0.109,NULL,60361816130,943153377,14736771,NULL),(79772,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79772,35.36,0.46,118,31620,70,NULL,NULL,'2MASX J11194715+4420034',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000156,NULL,'16.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,169.946583,44.33417,0,NULL,63951447429,999241366,15613146,16.2),(79773,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79773,37.78,0.27,359,31621,70,NULL,NULL,'2MASX J11194910+0216353',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,169.9545,2.2765,0.101,NULL,60350975835,942983997,14734124,17.4),(79774,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79774,37.87,0.46,375,31622,70,NULL,NULL,'2MASX J11194986+1041132',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000184,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,169.957917,10.68689,0.021,NULL,60333677981,942713718,14729901,16.7),(79775,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79775,37.78,0.27,359,31623,70,NULL,NULL,'2MASX J11195164+0217113',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,169.965167,2.28658,0.101,NULL,60350975883,942983998,14734124,17.6),(79776,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79776,38.11,0.11,418,31624,70,NULL,NULL,'2MASX J11195315+5339060',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000172,NULL,'16.8g',0.34,NULL,NULL,NULL,NULL,NULL,1,169.971791667,53.65183,0,NULL,61790930522,965483289,15085676,16.8),(79777,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79777,36.47,0.61,197,31625,70,NULL,NULL,'2MASX J11195348-2146072',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.02',NULL,NULL,NULL,NULL,NULL,NULL,1,169.97275,-21.76883,0.185,NULL,41721300537,651895320,10185864,16.02),(79778,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79778,36.63,0.46,212,31626,70,NULL,NULL,'2MASX J11195359+3200537',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000187,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,169.973333,32.01506,0.05,NULL,60665174898,947893357,14810833,16.2),(79779,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79779,37.34,0.33,294,31627,70,NULL,NULL,'2MASX J11195424-0033203',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000073,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,169.976083,-0.55578,0.145,NULL,40819757453,637808710,9965761,17.2),(79780,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79780,37.73,0.46,351,31628,70,NULL,NULL,'2MASX J11195446+0832412',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,169.9770417,8.54475,0.081,NULL,60336384649,942756010,14730562,17.2),(79781,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79781,37.68,0.46,344,31629,70,NULL,NULL,'2MASX J11195471+0110573',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000079,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,169.9779583,1.18261,0.105,NULL,60163680226,940057503,14688398,18),(79782,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79782,37.59,0.46,330,31630,70,NULL,NULL,'2MASX J11195553+4351522',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,169.9812083,43.86436,0,NULL,63951190313,999237348,15613083,17.4),(79783,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79783,34.33,0.69,73.3,31631,100,NULL,'mid-IR','UGC 06340',NULL,'2013ApJ...771...88L',2013,1,1.6,'Fairall, et al. (1992,AJ,103,11) give v=5937 +/- 100 km/sec.','G',0.000033,NULL,'14.30',0.8,'SAB(rs)bc:',NULL,NULL,NULL,NULL,1,169.9812083,-0.87961,0.125,NULL,40819343472,637802241,9965660,14.3),(79784,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79784,34.79,0.31,90.9,31631,NULL,NULL,NULL,'UGC 06340',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79785,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79785,34.83,0.3,92.5,31631,NULL,NULL,'Malmquist cor.','UGC 06340',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79786,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79786,34.98,0.2,99.1,31631,74.4,NULL,NULL,'UGC 06340',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79787,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79787,35.07,0.47,103,31631,NULL,NULL,'H','UGC 06340',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79788,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79788,35.15,0.46,107,31631,NULL,NULL,'J','UGC 06340',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79789,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79789,35.21,0.45,110,31631,NULL,NULL,'K','UGC 06340',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79790,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79790,35.28,0.4,114,31631,NULL,NULL,'mean','UGC 06340',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79791,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79791,37.78,0.27,359,31632,70,NULL,NULL,'2MASX J11195557+0217193',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000177,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,169.981583333,2.28881,0.101,NULL,60350974545,942983977,14734124,17.2),(79792,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79792,36.86,0.46,235,31633,70,NULL,NULL,'SDSS J111955.75+281016.8',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000154,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,169.982333,28.17136,0,NULL,60604840656,946950635,14796103,17.1),(79793,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79793,37.6,0.46,331,31634,70,NULL,NULL,'IC 2725',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000188,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,169.989333333,13.42928,0.017,NULL,61104398953,954756233,14918066,16.7),(79794,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79794,38.11,0.11,418,31635,70,NULL,NULL,'SDSS J111958.61+534446.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,169.99425,53.74636,0,NULL,61790917490,965483085,15085673,18),(79795,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79795,35.53,0.61,128,31636,70,NULL,NULL,'2MASX J11195880-1544136',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.18',NULL,NULL,NULL,NULL,NULL,NULL,1,169.995041667,-15.73719,0.149,NULL,41707905870,651686029,10182594,16.18),(79796,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79796,38.38,0.23,475,31637,70,NULL,NULL,'2MASX J11195971+5439532',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,169.998667,54.66494,0,NULL,61761162377,965018162,15078408,18),(79797,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79797,36.34,0.61,185,31638,70,NULL,NULL,'2MFGC 08850',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,170.001,-20.49708,0.109,NULL,41718861267,651857207,10185268,15.2),(79798,'IRAS','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79798,35.11,0.8,105,31639,75,NULL,'CF, r','UGC 06338',NULL,'1997ApJS..109..333W',1997,1,1.14,'The 2MASXi position refers to a knot 8 arcsec southeast of the nucleus.','G',0.000011,NULL,'14.7g',0.54,'Scd:',NULL,NULL,NULL,NULL,1,170.002667,36.10086,0.024,NULL,60429915392,944217428,14753397,14.7),(79799,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79799,35.17,0.2,108,31639,74.4,NULL,NULL,'UGC 06338',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79800,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79800,35.21,0.38,110,31639,75,NULL,'CF, r, raw','UGC 06338',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79801,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79801,35.29,0.34,114,31639,NULL,NULL,NULL,'UGC 06338',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79802,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79802,35.36,0.33,118,31639,NULL,NULL,'Malmquist cor.','UGC 06338',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79803,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79803,35.37,0.38,119,31639,75,NULL,'CF, r, inv','UGC 06338',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79804,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79804,35.48,0.38,125,31639,75,NULL,'CF, r, cor','UGC 06338',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79805,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79805,31.85,NULL,23.4,31640,NULL,NULL,NULL,'UGC 06341',NULL,'2015AstBu..70....1K',2015,1,1,NULL,'G',0.000013,NULL,'16.0',0.2,'Sdm:','X-ray-bright group member',NULL,NULL,NULL,1,170.0027917,18.2605,0,NULL,61120788641,955012322,14922067,16),(79806,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79806,38.23,0.46,442,31641,70,NULL,NULL,'2MASX J11200143+3908216',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000179,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,170.005791667,39.13931,0,NULL,63927748054,998871063,15607360,17.8),(79807,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79807,37.88,0.46,376,31642,70,NULL,NULL,'SDSS J112001.99+020907.3',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000157,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,170.0082917,2.15203,0.101,NULL,60350932953,942983327,14734114,18.6),(79808,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79808,37.08,0.46,261,31643,70,NULL,NULL,'2MASX J11200307+2859371',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000093,NULL,'16.3g',0.32,'Sa',NULL,NULL,NULL,NULL,1,170.012917,28.99364,0.013,NULL,60604713083,946948641,14796072,16.3),(79809,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79809,37.58,0.1,328,31644,70,NULL,NULL,'2MASX J11200311+5432122',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000182,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,170.013125,54.53681,0,NULL,61761179445,965018428,15078412,16.6),(79810,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79810,35.88,0.67,150,31645,70,NULL,NULL,'2MASX J11200355-4825380',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,170.01475,-48.42725,0.449,NULL,41930650640,655166416,10236975,16.7),(79811,'SBF','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79811,31.51,0.24,20,31646,NULL,NULL,'I','NGC 3626',NULL,'2001ApJ...546..681T',2001,1,2.49,NULL,'G',0.000013,NULL,'11.9g',1.51,'(R)SA(rs)0+','X-ray-bright group member',NULL,NULL,NULL,1,170.015875,18.35683,0,NULL,61120784230,955012253,14922066,11.9),(79812,'SBF','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79812,31.8,0.12,22.9,31646,74.4,NULL,NULL,'NGC 3626',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79813,'Faber-Jackson','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79813,29.83,0.63,9.25,31646,95,NULL,'Michard 1979b, c','NGC 3626',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79814,'Faber-Jackson','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79814,29.98,0.37,9.91,31646,95,NULL,'Weighted Mean','NGC 3626',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79815,'Faber-Jackson','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79815,30.18,0.81,10.9,31646,55,NULL,'Visvanathan & Sandage 1979','NGC 3626',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79816,'Faber-Jackson','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79816,30.77,0.46,14.3,31646,95,NULL,'Michard 1979a','NGC 3626',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79817,'Tertiary','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79817,31.28,0.24,18,31646,95,NULL,NULL,'NGC 3626',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79818,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79818,30.6,0.69,13.2,31646,100,NULL,'mid-IR','NGC 3626',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79819,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79819,31.8,0.12,22.9,31646,74.4,NULL,NULL,'NGC 3626',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79820,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79820,32.1,0.4,26.3,31646,75,NULL,'B','NGC 3626',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79821,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79821,37.7,0.46,346,31647,70,NULL,NULL,'2MASX J11200451+3012147',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,170.018791667,30.20428,0.013,NULL,60663263536,947863492,14810367,17.3),(79822,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79822,38.11,0.11,418,31648,70,NULL,NULL,'2MASX J11200451+5341218',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,170.018833,53.68925,0,NULL,61790918028,965483094,15085673,17.9),(79823,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79823,38.31,0.33,460,31649,70,NULL,NULL,'SDSS J112005.31+545602.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000235,NULL,'18.1g',0.14,'Candidate      BLAGN',NULL,NULL,NULL,NULL,1,170.022166667,54.93406,0,NULL,61983512853,968492388,15132693,18.1),(79824,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79824,38.03,0.46,403,31650,70,NULL,NULL,'SDSS J112005.41+352416.0',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,170.022583,35.40447,0.039,NULL,60422091921,944095186,14751487,17.3),(79825,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79825,37.41,0.46,303,31651,70,NULL,NULL,'2MASX J11200545+0016337',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000107,NULL,'16.3g',0.35,'AGN',NULL,NULL,NULL,NULL,1,170.022625,0.27611,0.125,NULL,60163604002,940056312,14688379,16.3),(79826,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79826,37.36,0.46,296,31652,70,NULL,NULL,'2MASX J11200557+4218393',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,170.0232917,42.31089,0.03,NULL,63946250200,999160159,15611877,17.9),(79827,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79827,37.63,0.46,336,31653,70,NULL,NULL,'SDSS J112005.73-004251.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000105,NULL,'18.4g',0.15,'NLAGN',NULL,NULL,NULL,NULL,1,170.023875,-0.71439,0.145,NULL,40819300636,637801572,9965649,18.4),(79828,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79828,36,0.57,159,31654,70,NULL,NULL,'2MASX J11200585-0423128',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'15.84',0.47,NULL,NULL,NULL,NULL,NULL,1,170.024417,-4.38689,0.129,NULL,41044419730,641319058,10020610,15.84),(79829,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79829,36.01,0.63,159,31655,70,NULL,NULL,'2MASX J11200700-0807525',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00008,NULL,'16.71',NULL,NULL,NULL,NULL,NULL,NULL,1,170.0292917,-8.13144,0.065,NULL,41014721297,640855020,10013359,16.71),(79830,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79830,35.58,0.46,131,31656,70,NULL,NULL,'UGC 06342',NULL,'2015arXiv151105856S',2015,1,1.01,NULL,'G',0.000107,NULL,'14.7g',0.66,'S0-:',NULL,NULL,NULL,NULL,1,170.0332083,30.50019,0,NULL,60663029881,947859841,14810310,14.7),(79831,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79831,37.45,0.33,309,31657,70,NULL,NULL,'2MASX J11200935+0631302',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000168,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,170.039,6.52506,0.181,NULL,60393534526,943648976,14744515,16.8),(79832,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79832,37.73,0.46,351,31658,70,NULL,NULL,'2MASX J11201001+1745463',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.24',0.14,NULL,NULL,NULL,NULL,NULL,1,170.041583333,17.76303,0,NULL,61121343600,955020993,14922203,18.24),(79833,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79833,37.85,0.46,372,31659,70,NULL,NULL,'2MASX J11201015+1738083',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.04',0.15,NULL,NULL,NULL,NULL,NULL,1,170.042166667,17.63567,0,NULL,61121308856,955020450,14922194,18.04),(79834,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79834,36.34,0.46,185,31660,70,NULL,NULL,'2MASX J11201148+1556443',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.94',0.16,NULL,NULL,NULL,NULL,NULL,1,170.0477917,15.94564,0,NULL,61115545409,954930397,14920787,17.94),(79835,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79835,32.01,0.43,25.2,31661,75,NULL,'3.6 micron, color + selection bias corrected','ESO 570- G 019',NULL,'2014MNRAS.444..527S',2014,1,1.9,NULL,'G',0.000007,NULL,'14.40',1.1,'(R\')SAc: pec',NULL,NULL,NULL,NULL,1,170.050458333,-21.47064,0.113,NULL,41721474049,651898032,10185906,14.4),(79836,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79836,30.61,0.69,13.2,31662,100,NULL,'mid-IR','NGC 3622',NULL,'2013ApJ...771...88L',2013,1,1.31,NULL,'G',0.000007,NULL,'13.6g',0.72,'S?','Field galaxy',NULL,NULL,NULL,1,170.051541667,67.24156,0,NULL,62086109069,970095454,15157741,13.6),(79837,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79837,31.48,0.43,19.8,31662,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3622',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79838,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79838,31.64,0.43,21.3,31662,75,NULL,'3.6 micron, color corrected','NGC 3622',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79839,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79839,31.78,0.2,22.7,31662,74.4,NULL,NULL,'NGC 3622',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79840,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79840,32.11,0.4,26.5,31662,NULL,NULL,'mean','NGC 3622',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79841,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79841,32.2,0.47,27.6,31662,NULL,NULL,'H','NGC 3622',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79842,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79842,32.24,0.46,28,31662,NULL,NULL,'J','NGC 3622',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79843,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79843,37.69,0.46,345,31663,70,NULL,NULL,'2MASX J11201296+3317586',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'18.0g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,170.054,33.29967,0.071,NULL,60643703695,947557870,14805591,18),(79844,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79844,36.39,0.46,190,31664,70,NULL,NULL,'2MASX J11201305+0302277',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.85',0.2,NULL,NULL,NULL,NULL,NULL,1,170.0545417,3.04108,0.109,NULL,60361564947,943149452,14736710,17.85),(79845,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79845,37.14,0.46,267,31665,70,NULL,NULL,'2MASX J11201363+0643283',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,170.056875,6.72431,0.205,NULL,60393113598,943642399,14744412,17.7),(79846,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79846,36.77,0.46,226,31666,70,NULL,NULL,'2MASX J11201390+1046543',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,170.0580417,10.78183,0.021,NULL,60333778230,942715284,14729926,17.1),(79847,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79847,37.76,0.21,356,31667,70,NULL,NULL,'SDSS J112014.03+172901.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,170.0585,17.48378,0,NULL,61120578884,955009045,14922016,18.1),(79848,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79848,35.14,0.46,107,31668,70,NULL,NULL,'2MASX J11201407+5001308',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000156,NULL,'16.0g',0.36,'E0',NULL,NULL,NULL,NULL,1,170.058875,50.02531,0,NULL,61778424111,965287876,15082623,16),(79849,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79849,37.45,0.33,309,31669,70,NULL,NULL,'2MASX J11201439+0629163',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,170.059833333,6.48794,0.181,NULL,60393537418,943649022,14744515,17.1),(79850,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79850,29.68,0.04,8.63,31670,73,NULL,'Cepheids periods Gaussian ','MESSIER 066',NULL,'2009RoAJ...19...35A',2009,1,9.1,'The position in 1989H&RHI.C...0000H is incorrect.','G',0.00001,NULL,'9.65',4.2,'SAB(s)b;LINER  Sy2','in a radial-velocity based grouping',NULL,NULL,'LINER',1,170.062333,12.99153,0.01,NULL,60216026983,940875421,14701178,9.65),(79851,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79851,29.7,0.07,8.73,31670,NULL,NULL,'LMC W01','MESSIER 066',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79852,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79852,29.77,0.07,8.99,31670,NULL,NULL,'MW HIPP','MESSIER 066',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79853,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79853,29.78,0.07,9.04,31670,74.4,NULL,NULL,'MESSIER 066',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79854,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79854,29.79,0.03,9.08,31670,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian ','MESSIER 066',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79855,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79855,29.79,0.15,9.08,31670,NULL,NULL,'MW P02','MESSIER 066',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79856,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79856,29.79,0.17,9.09,31670,NULL,NULL,'17, VI','MESSIER 066',NULL,'2001ApJ...547L.103G',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79857,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79857,29.8,0.06,9.12,31670,NULL,NULL,'MW GFG','MESSIER 066',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79858,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79858,29.8,0.06,9.12,31670,NULL,NULL,'369, VI','MESSIER 066',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79859,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79859,29.86,0.08,9.38,31670,NULL,NULL,'16, VI, KEY PROJECT','MESSIER 066',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79860,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79860,29.9,0.02,9.55,31670,73,NULL,'Cepheids magnitudes Gaussian ','MESSIER 066',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79861,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79861,29.94,0.17,9.75,31670,NULL,NULL,'17, VI +Z','MESSIER 066',NULL,'2001ApJ...547L.103G',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79862,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79862,29.97,0.09,9.86,31670,NULL,NULL,'U99 + PSF','MESSIER 066',NULL,'2002AJ....123..207D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79863,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79863,30.01,0.08,10.1,31670,NULL,NULL,'16, VI, +Z, KEY PROJECT','MESSIER 066',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79864,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79864,30.03,0.11,10.1,31670,NULL,NULL,'avg MF91, U99 + PSF','MESSIER 066',NULL,'2002AJ....123..207D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79865,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79865,30.06,0.17,10.3,31670,NULL,NULL,'HST KP Calibrated','MESSIER 066',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79866,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79866,30.06,0.17,10.3,31670,NULL,NULL,'17, VI','MESSIER 066',NULL,'1999ApJ...512...48G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79867,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79867,30.06,0.17,10.3,31670,NULL,NULL,'ALLFRAME','MESSIER 066',NULL,'2000ApJ...529..723G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79868,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79868,30.09,0.1,10.4,31670,NULL,NULL,'MF91 + PSF','MESSIER 066',NULL,'2002AJ....123..207D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79869,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79869,30.13,0.08,10.6,31670,NULL,NULL,'cte LMC K03','MESSIER 066',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79870,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79870,30.13,0.08,10.6,31670,NULL,NULL,'cte U99','MESSIER 066',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79871,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79871,30.15,0.08,10.7,31670,NULL,NULL,'ALLFRAME, Key Project','MESSIER 066',NULL,'2000ApJ...529..723G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79872,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79872,30.16,0.08,10.8,31670,NULL,NULL,'cte LMC STS02','MESSIER 066',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79873,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79873,30.21,0.08,11,31670,NULL,NULL,'cte MW FSG03','MESSIER 066',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79874,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79874,30.22,0.12,11.1,31670,NULL,NULL,'68, VI','MESSIER 066',NULL,'1999ApJ...522..802S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79875,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79875,30.24,0.08,11.2,31670,NULL,NULL,'cte MW GFG98','MESSIER 066',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79876,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79876,30.24,0.08,11.2,31670,NULL,NULL,'cte MF91','MESSIER 066',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79877,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79877,30.31,0.08,11.5,31670,NULL,NULL,'cte MW STS03','MESSIER 066',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79878,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79878,30.5,NULL,12.6,31670,NULL,18.54,NULL,'MESSIER 066',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79879,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79879,30.5,0.09,12.6,31670,NULL,18.54,'LMC ZP','MESSIER 066',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79880,'Cepheids','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79880,30.96,NULL,15.6,31670,NULL,NULL,'104, VI','MESSIER 066',NULL,'2006A&A...452..423P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79881,'PNLF','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79881,29.99,0.08,9.95,31670,NULL,NULL,NULL,'MESSIER 066',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79882,'PNLF','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79882,30.09,0.14,10.4,31670,NULL,NULL,'73','MESSIER 066',NULL,'1999AAS...195.1103K',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79883,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:54','1','SN 1989B',NULL,79883,29.6,0.05,8.32,31670,66,NULL,NULL,'MESSIER 066',NULL,'1994A&A...281...51M',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79884,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:54','1','SN 1989B',NULL,79884,29.7,0.64,8.7,31670,67,NULL,NULL,'MESSIER 066',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79885,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:54','1','SN 1989B',NULL,79885,29.95,0.4,9.8,31670,68,NULL,NULL,'MESSIER 066',NULL,'1996ApJ...465L..83R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79886,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:54','1','SN 1989B',NULL,79886,30.04,0.14,10.1,31670,65,NULL,'MLCS2k2','MESSIER 066',0.002425,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79887,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:54','1','SN 1989B','R',79887,30.41,NULL,12.1,31670,62.3,NULL,NULL,'MESSIER 066',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79888,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:54','1','SN 1989B',NULL,79888,30.5,0.14,12.6,31670,60,NULL,NULL,'MESSIER 066',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79889,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:54','1','SN 1989B',NULL,79889,30.89,0.17,15.1,31670,70.8,NULL,NULL,'MESSIER 066',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79890,'TRGB','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79890,29.78,0.07,9.04,31670,74.4,NULL,NULL,'MESSIER 066',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79891,'TRGB','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79891,29.82,0.1,9.2,31670,NULL,NULL,'I','MESSIER 066',NULL,'2009ApJ...697..996M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79892,'TRGB','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79892,30.1,0.03,10.5,31670,NULL,NULL,'HOST SN 1989B','MESSIER 066',NULL,'2013AAS...22143202J',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79893,'TRGB','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79893,30.12,0.03,10.6,31670,NULL,NULL,'Syst. +/- 0.12','MESSIER 066',NULL,'2013ApJ...773...13L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79894,'SNII optical','2016-12-15 15:14:46','2016-12-16 11:19:54','1','SN 1973R',NULL,79894,29.4,0.58,7.6,31670,NULL,NULL,'EPM','MESSIER 066',NULL,'1992ApJ...395..366S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79895,'SNII optical','2016-12-15 15:14:46','2016-12-16 11:19:54','1','SN 1973R',NULL,79895,30.88,0.95,15,31670,NULL,NULL,NULL,'MESSIER 066',NULL,'1994ApJ...432...42S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79896,'IRAS','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79896,30.29,0.8,11.5,31670,75,NULL,'A82, H','MESSIER 066',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79897,'Sosies','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79897,29.79,0.13,9.08,31670,NULL,NULL,NULL,'MESSIER 066',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79898,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79898,27.94,0.69,3.86,31670,100,NULL,'mid-IR','MESSIER 066',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79899,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79899,29.09,0.4,6.6,31670,75,NULL,'B','MESSIER 066',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79900,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79900,29.32,NULL,7.3,31670,75,NULL,'CO','MESSIER 066',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79901,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79901,29.35,NULL,7.4,31670,75,NULL,'HI','MESSIER 066',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79902,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79902,29.4,0.3,7.59,31670,NULL,18.45,'SN 1989B host','MESSIER 066',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79903,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79903,29.4,0.3,7.59,31670,NULL,18.45,'SN 1973R host','MESSIER 066',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79904,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79904,29.44,0.47,7.72,31670,75,NULL,'A82, H, raw','MESSIER 066',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79905,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79905,29.51,0.43,8,31670,75,NULL,'3.6 micron, color + selection bias corrected','MESSIER 066',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79906,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79906,29.53,0.4,8.05,31670,75,NULL,'HOSTS SN 1989B','MESSIER 066',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79907,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79907,29.54,0.42,8.09,31670,NULL,18.48,'3.6 micron','MESSIER 066',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79908,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79908,29.55,0.43,8.1,31670,75,NULL,'3.6 micron, color corrected','MESSIER 066',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79909,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79909,29.58,0.47,8.23,31670,75,NULL,'A82, H, inv','MESSIER 066',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79910,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79910,29.67,0.35,8.59,31670,NULL,NULL,NULL,'MESSIER 066',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79911,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79911,29.72,NULL,8.8,31670,65.2,NULL,'CO','MESSIER 066',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79912,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79912,29.77,0.4,9,31670,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','MESSIER 066',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79913,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79913,29.78,0.07,9.04,31670,74.4,NULL,NULL,'MESSIER 066',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79914,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79914,29.83,0.3,9.26,31670,55,NULL,'B','MESSIER 066',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79915,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79915,29.84,NULL,9.3,31670,54,NULL,'HI','MESSIER 066',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79916,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79916,29.85,0.47,9.33,31670,75,NULL,'A82, H, cor','MESSIER 066',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79917,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79917,29.91,NULL,9.59,31670,NULL,NULL,'LEDA [April 2006]','MESSIER 066',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79918,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79918,30,NULL,10,31670,NULL,NULL,'I','MESSIER 066',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79919,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79919,30.01,0.4,10,31670,75,NULL,'HOSTS SN 1989B','MESSIER 066',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79920,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79920,30.01,0.08,10,31670,75,NULL,NULL,'MESSIER 066',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79921,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79921,30.04,NULL,10.2,31670,NULL,NULL,'B','MESSIER 066',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79922,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79922,30.07,0.06,10.3,31670,NULL,NULL,'B','MESSIER 066',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79923,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79923,30.1,0.09,10.5,31670,NULL,NULL,'I','MESSIER 066',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79924,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79924,36.89,0.46,238,31671,70,NULL,NULL,'2MASX J11201505+1236153',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,170.062667,12.60436,0.038,NULL,60217047080,940891360,14701427,17.7),(79925,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79925,30.45,NULL,12.3,31672,NULL,NULL,NULL,'UGC 06345',NULL,'2015AstBu..70....1K',2015,1,2.3,'Contains the possible HII region UM 422.','G',0.000013,NULL,'13.8',1.3,'IB(s)m','in a radial-velocity based grouping',NULL,NULL,NULL,1,170.065,2.52528,0.101,NULL,60350828382,942981693,14734088,13.8),(79926,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79926,32.15,0.4,26.9,31672,75,NULL,'B','UGC 06345',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79927,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79927,36.79,0.46,228,31673,70,NULL,NULL,'2MASX J11201583+3754327',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,170.06575,37.90919,0.008,NULL,60424504238,944132878,14752076,17.6),(79928,'Faber-Jackson','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79928,32.22,0.65,27.8,31674,95,NULL,'Weighted Mean','NGC 3630',NULL,'1984ApJS...56...91D',1984,1,4.6,NULL,'G',0.000017,NULL,'12.91',3,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,170.07075,2.96439,0.109,NULL,60361546182,943149159,14736705,12.91),(79929,'Faber-Jackson','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79929,33.72,0.81,55.5,31674,55,NULL,'Visvanathan & Sandage 1979','NGC 3630',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79930,'Tully est','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79930,32.07,0.8,25.9,31674,75,NULL,'B','NGC 3630',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79931,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79931,32.31,0.45,28.9,31674,NULL,NULL,'K','NGC 3630',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79932,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79932,32.43,0.4,30.6,31674,NULL,NULL,'mean','NGC 3630',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79933,'Grav. Stability Gas. Disk','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79933,29.13,NULL,6.7,31675,NULL,NULL,NULL,'NGC 3628',NULL,'1996AstL...22...71Z',1996,1,14.8,NULL,'G',0.000003,NULL,'10.2B',3,'SAb pec sp;HII LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,170.070708333,13.58969,0.021,NULL,61104278378,954754349,14918036,10.2),(79934,'IRAS','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79934,30.76,0.8,14.2,31675,75,NULL,'A82, H','NGC 3628',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79935,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79935,29.44,0.4,7.7,31675,75,NULL,'B','NGC 3628',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79936,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79936,29.49,NULL,7.9,31675,65.2,NULL,'CO','NGC 3628',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79937,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79937,29.87,NULL,9.4,31675,75,NULL,'CO','NGC 3628',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79938,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79938,29.93,NULL,9.7,31675,75,NULL,'HI','NGC 3628',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79939,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79939,30.07,0.2,10.3,31675,74.4,NULL,NULL,'NGC 3628',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79940,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79940,30.11,0.43,10.5,31675,75,NULL,'3.6 micron, color corrected','NGC 3628',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79941,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79941,30.13,0.4,10.6,31675,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 3628',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79942,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79942,30.25,NULL,11.2,31675,54,NULL,'HI','NGC 3628',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79943,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79943,30.26,0.43,11.3,31675,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3628',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79944,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79944,30.32,0.47,11.6,31675,75,NULL,'A82, H, raw','NGC 3628',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79945,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79945,30.52,0.47,12.7,31675,75,NULL,'A82, H, inv','NGC 3628',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79946,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79946,30.59,0.3,13.1,31675,55,NULL,'B','NGC 3628',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79947,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79947,30.7,0.47,13.8,31675,75,NULL,'A82, H, cor','NGC 3628',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79948,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79948,37.07,0.33,259,31676,70,NULL,NULL,'CGCG 039-125',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000103,NULL,'15.0g',0.65,'E',NULL,NULL,NULL,NULL,1,170.074167,4.32036,0.109,NULL,60360494367,943132724,14736448,15),(79949,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79949,39.72,0.46,880,31677,70,NULL,NULL,'SDSS J112018.46+352501.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00016,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,170.076958333,35.41717,0.039,NULL,60422051822,944094559,14751477,18.7),(79950,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79950,36.09,0.6,165,31678,70,NULL,NULL,'LCRS B111746.6-053125',NULL,'2014MNRAS.445.2677S',2014,1,0.31,NULL,'G',0.00015,NULL,'15.49',0.28,NULL,NULL,NULL,NULL,NULL,1,170.0799583,-5.79728,0.085,NULL,41060416433,641569006,10024515,15.49),(79951,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79951,36.03,0.51,160,31679,NULL,NULL,'Malmquist cor.','AGC 211465',NULL,'2009ApJS..182..474S',2009,1,0.3,NULL,'G',NULL,NULL,'19.19',0.08,NULL,NULL,NULL,NULL,NULL,1,170.084167,34.30519,0.057,NULL,60645043549,947578805,14805918,19.19),(79952,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79952,36.11,0.49,167,31679,NULL,NULL,NULL,'AGC 211465',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79953,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79953,38.85,0.46,589,31680,70,NULL,NULL,'2MASX J11202147+2342478',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,170.0895,23.71328,0,NULL,60566813604,946356462,14786819,17.9),(79954,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79954,37.76,0.21,356,31681,70,NULL,NULL,'2MASX J11202211+1730193',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,170.092083,17.50544,0,NULL,61120593007,955009265,14922019,17.5),(79955,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79955,36.15,0.46,169,31682,70,NULL,NULL,'MCG +06-25-046',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000147,NULL,'15.2g',0.61,NULL,NULL,NULL,NULL,NULL,1,170.0932917,35.07097,0.039,NULL,60421490849,944085794,14751340,15.2),(79956,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79956,38.33,0.27,464,31683,70,NULL,NULL,'2MASX J11202290+5015018',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,170.0952917,50.25047,0,NULL,61778192859,965284263,15082566,18),(79957,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79957,36.23,0.46,176,31684,70,NULL,NULL,'2MASX J11202362-0047599',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000089,NULL,'15.8g',0.45,'E0',NULL,NULL,NULL,NULL,1,170.0984583,-0.79994,0.125,NULL,40819305023,637801640,9965650,15.8),(79958,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79958,37.9,0.46,381,31685,70,NULL,NULL,'2MASX J11202440+1210433',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000176,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,170.101667,12.17875,0.031,NULL,60217589782,940899840,14701560,17.3),(79959,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79959,36.99,0.46,250,31686,70,NULL,NULL,'2MASX J11202484+4232482',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,170.103333,42.54678,0.107,NULL,63946295170,999160862,15611888,17.3),(79960,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79960,37.68,0.27,343,31687,70,NULL,NULL,'2MASX J11202505+3440208',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,170.1044583,34.67261,0.063,NULL,60643044237,947547566,14805430,17.4),(79961,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79961,37.17,0.46,271,31688,70,NULL,NULL,'2MASX J11202525+0111007',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000089,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,170.1052083,1.1835,0.113,NULL,60163661513,940057211,14688393,17),(79962,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79962,33,0.45,39.8,31689,NULL,NULL,'K','NGC 3633',NULL,'2007A&A...465...71T',2007,1,1.23,NULL,'G',0.000007,NULL,'14.1g',0.56,'SAa: sp        HII','Group member',NULL,NULL,NULL,1,170.10925,3.58561,0.113,NULL,60364230306,943191098,14737360,14.1),(79963,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79963,33.08,0.47,41.2,31689,NULL,NULL,'H','NGC 3633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79964,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79964,33.13,0.4,42.2,31689,NULL,NULL,'mean','NGC 3633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79965,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79965,33.2,0.46,43.7,31689,NULL,NULL,'J','NGC 3633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79966,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79966,37.68,0.27,343,31690,70,NULL,NULL,'2MASX J11202635+3437248',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000149,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,170.109833,34.62364,0.051,NULL,60643043131,947547548,14805430,17.2),(79967,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79967,38.03,0.33,404,31691,70,NULL,NULL,'2MASX J11202712+3547068',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00018,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,170.113083,35.78528,0.037,NULL,60421776933,944090264,14751410,16.5),(79968,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79968,37.58,0.1,328,31692,70,NULL,NULL,'2MASX J11202781+5425537',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000178,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,170.115791667,54.43169,0,NULL,61761144012,965017875,15078404,17),(79969,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79969,36.99,0.46,250,31693,70,NULL,NULL,'2MASX J11202979+5550297',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000178,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,170.124,55.84169,NULL,NULL,61986938892,968545920,15133530,17),(79970,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79970,34.07,0.49,65.2,31694,75,NULL,'IR','CGCG 039-128',NULL,'2011yCatp016004901K',2011,1,1.01,NULL,'G',0.000013,NULL,'16.4g',0.21,'Sdm',NULL,NULL,NULL,NULL,1,170.12625,6.24689,0.177,NULL,60393480210,943648128,14744502,16.4),(79971,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79971,34.42,0.2,76.6,31694,74.4,NULL,NULL,'CGCG 039-128',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79972,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79972,34.69,NULL,86.6,31694,NULL,NULL,NULL,'CGCG 039-128',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79973,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79973,34.72,NULL,87.9,31694,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 039-128',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79974,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79974,34.72,NULL,88,31694,NULL,NULL,'Dipole + Quadrupole','CGCG 039-128',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79975,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79975,34.74,NULL,88.6,31694,NULL,NULL,'Dipole','CGCG 039-128',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79976,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79976,36.93,0.46,243,31695,70,NULL,NULL,'2MASX J11203042+2912032',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000143,NULL,'16.4g',0.37,'S0',NULL,NULL,NULL,NULL,1,170.1267917,29.20089,0.056,NULL,60604737100,946949017,14796078,16.4),(79977,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79977,37.88,0.46,376,31696,70,NULL,NULL,'2MASX J11203041+0315317',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000131,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,170.126916667,3.25878,0.093,NULL,60363590130,943181095,14737204,17.8),(79978,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79978,37.68,0.27,343,31697,70,NULL,NULL,'2MASX J11203056+3439538',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000154,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,170.127375,34.66481,0.063,NULL,60643043964,947547561,14805430,18.2),(79979,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79979,32.61,0.4,33.3,31698,NULL,NULL,'mean','NGC 3625',NULL,'2007A&A...465...71T',2007,1,1.73,NULL,'G',0.000013,NULL,'14.0g',0.62,'SAB(s)b:','in a radial-velocity based grouping',NULL,NULL,NULL,1,170.130583,57.78142,0,NULL,61980687810,968448247,15132003,14),(79980,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79980,32.78,0.43,36.1,31698,75,NULL,'3.6 micron, color corrected','NGC 3625',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79981,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79981,32.8,0.43,36.3,31698,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3625',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79982,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79982,32.8,0.2,36.3,31698,74.4,NULL,NULL,'NGC 3625',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79983,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79983,33.23,0.47,44.2,31698,NULL,NULL,'H','NGC 3625',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79984,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79984,34.78,0.58,90.3,31699,70,NULL,NULL,'NGC 3635',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00011,NULL,'14.18',0.9,'SAB(rs)bc pec:',NULL,NULL,NULL,NULL,1,170.1307917,-9.01361,0.081,NULL,41019994827,640937419,10014647,14.18),(79985,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79985,38.03,0.33,404,31700,70,NULL,NULL,'SDSS J112031.56+354446.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,170.1315,35.74622,0.037,NULL,60421780584,944090321,14751411,18.5),(79986,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79986,35.84,0.46,147,31701,70,NULL,NULL,'VII Zw 386',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000145,NULL,'16.0g',0.4,'S0',NULL,NULL,NULL,NULL,1,170.13175,60.14517,0,NULL,61850042538,966406914,15100108,16),(79987,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79987,30.71,0.69,13.8,31702,100,NULL,'mid-IR','NGC 3629',NULL,'2013ApJ...771...88L',2013,1,2.3,'HOLM 247B is a star.','G',0.00003,NULL,'12.78',1.6,'SA(s)cd:','Field galaxy',NULL,NULL,NULL,1,170.1325417,26.96336,0,NULL,60605797381,946965584,14796337,12.78),(79988,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79988,32.14,0.4,26.8,31702,75,NULL,'B','NGC 3629',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79989,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79989,32.55,0.2,32.4,31702,74.4,NULL,NULL,'NGC 3629',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79990,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79990,32.59,0.43,33,31702,75,NULL,'3.6 micron, color corrected','NGC 3629',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79991,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79991,32.61,0.4,33.3,31702,NULL,NULL,'mean','NGC 3629',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79992,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79992,32.69,0.43,34.5,31702,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3629',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79993,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79993,32.77,0.78,35.8,31702,NULL,NULL,NULL,'NGC 3629',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79994,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79994,32.78,0.77,36,31702,NULL,NULL,'Malmquist cor.','NGC 3629',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79995,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79995,32.9,0.4,38,31702,NULL,NULL,NULL,'NGC 3629',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79996,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79996,33.54,0.46,51,31702,NULL,NULL,'J','NGC 3629',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79997,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,79997,33.56,0.47,51.5,31702,NULL,NULL,'H','NGC 3629',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79998,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79998,37.7,0.46,347,31703,70,NULL,NULL,'2MASX J11203219+0049497',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000068,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,170.134083,0.83061,0.137,NULL,60163759569,940058743,14688417,17.2),(79999,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',79999,36.7,0.46,219,31704,70,NULL,NULL,'CGCG 242-021',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000103,NULL,'15.4g',0.58,'E0',NULL,NULL,NULL,NULL,1,170.142166667,46.8245,0,NULL,63949975023,999218359,15612786,15.4),(80000,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',80000,37.14,0.46,268,31705,70,NULL,NULL,'2MASX J11203534+4040447',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,170.147167,40.67908,0,NULL,63925899919,998842186,15606909,17),(80001,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',80001,37.51,0.46,317,31706,70,NULL,NULL,'2MASX J11203641+5903477',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000185,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,170.151583,59.06333,0,NULL,61982762938,968480670,15132510,16.4),(80002,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',80002,37.91,0.46,383,31707,70,NULL,NULL,'VII Zw 387',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000081,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,170.15525,65.77425,0.013,NULL,61815553979,965868030,15091687,17.5),(80003,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',80003,37.23,0.46,279,31708,70,NULL,NULL,'2MASX J11203746+6550055',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000088,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,170.1564583,65.83503,0.013,NULL,61815547646,965867931,15091686,17.1),(80004,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',80004,36.32,0.46,184,31709,70,NULL,NULL,'2MASX J11203911+2717373',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000188,NULL,'15.5g',0.48,NULL,NULL,NULL,NULL,NULL,1,170.162917,27.29375,0,NULL,60606497557,946976524,14796508,15.5),(80005,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,80005,36.05,0.48,162,31710,70,NULL,NULL,'MCG -01-29-010 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.25',NULL,NULL,NULL,NULL,NULL,NULL,1,170.164333333,-5.67139,0.097,NULL,41042865460,641294772,10020230,14.25),(80006,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,80006,31.51,0.56,20,31711,70,NULL,NULL,'NGC 3637',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.00003,NULL,'13.20',1.5,'(R)SB(r)0^0^','in a pair',NULL,NULL,NULL,1,170.164875,-10.25736,0.117,NULL,41018743080,640917860,10014341,13.2),(80007,'Tully est','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,80007,32.25,0.8,28.2,31711,75,NULL,'B','NGC 3637',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80008,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,80008,32.44,0.2,30.8,31712,74.4,NULL,NULL,'UGC 06355',NULL,'2013AJ....146...86T',2013,1,2.47,'HOLM 248B does not exist (it is probably a plate defect).','G',0.00003,NULL,'14.7g',0.35,'Sd','in a pair',NULL,NULL,NULL,1,170.1662917,31.22197,0.009,NULL,60665766017,947902594,14810978,14.7),(80009,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,80009,32.55,0.43,32.4,31712,75,NULL,'3.6 micron, color corrected','UGC 06355',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80010,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,80010,32.61,0.74,33.3,31712,NULL,NULL,NULL,'UGC 06355',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80011,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,80011,32.62,0.43,33.4,31712,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06355',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80012,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',80012,32.64,0.4,33.7,31712,75,NULL,NULL,'UGC 06355',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80013,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,80013,32.72,0.71,35,31712,NULL,NULL,'Malmquist cor.','UGC 06355',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80014,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',80014,33.01,0.49,39.9,31712,75,NULL,'IR','UGC 06355',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80015,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',80015,35.74,0.46,141,31713,70,NULL,NULL,'CGCG 268-019',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000093,NULL,'15.3g',0.44,'E0',NULL,NULL,NULL,NULL,1,170.1664583,50.82731,0,NULL,61779590798,965306106,15082907,15.3),(80016,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',80016,37.96,0.46,391,31714,70,NULL,NULL,'2MASX J11204007+0135105',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,170.167083,1.58639,0.105,NULL,60349227567,942956680,14733698,17.5),(80017,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',80017,35.89,0.49,151,31715,75,NULL,'IR','UGC 06357',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000086,NULL,'15.9g',0.18,'Scd',NULL,NULL,NULL,NULL,1,170.1692917,33.10894,0.057,NULL,60643789625,947559212,14805612,15.9),(80018,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,80018,36.23,NULL,176,31715,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06357',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80019,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,80019,36.26,NULL,179,31715,NULL,NULL,'Dipole + Quadrupole','UGC 06357',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80020,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,80020,36.31,NULL,183,31715,NULL,NULL,'Dipole','UGC 06357',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80021,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',80021,37.17,0.46,271,31716,70,NULL,NULL,'2MASX J11204089+5749307',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000176,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,170.1705,57.82536,0,NULL,61980733444,968448960,15132015,16.8),(80022,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,80022,35.58,0.6,131,31717,70,NULL,NULL,'2MASX J11204127-0453440',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.45',0.32,NULL,NULL,NULL,NULL,NULL,1,170.1720417,-4.89553,0.117,NULL,41042703470,641292241,10020191,16.45),(80023,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',80023,38.11,0.11,418,31718,70,NULL,NULL,'2MASX J11204217+5347327',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000195,NULL,'16.3g',0.4,'BrClG',NULL,NULL,NULL,NULL,1,170.175625,53.79242,0,NULL,61791426518,965491039,15085797,16.3),(80024,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',80024,36.86,0.46,236,31719,70,NULL,NULL,'2MASX J11204273+3444298',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,170.178208333,34.74147,0.063,NULL,60643069215,947547956,14805436,17.3),(80025,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,80025,36.01,0.51,159,31720,NULL,NULL,'Malmquist cor.','SDSS J112043.30+340951.8',NULL,'2009ApJS..182..474S',2009,1,0.37,NULL,'G',0.000076,NULL,'17.9g',0.11,NULL,NULL,NULL,NULL,NULL,1,170.180458333,34.16442,0.092,NULL,60645291262,947582675,14805979,17.9),(80026,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,80026,36.06,0.5,163,31720,NULL,NULL,NULL,'SDSS J112043.30+340951.8',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80027,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',80027,38.11,0.11,418,31721,70,NULL,NULL,'2MASX J11204383+5343377',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000162,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,170.1825,53.72708,0,NULL,61791434235,965491159,15085799,16.8),(80028,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,80028,36.08,0.45,165,31722,NULL,NULL,'Malmquist cor.','2MASX J11204415+3429358',NULL,'2009ApJS..182..474S',2009,1,0.63,NULL,'G',0.000123,NULL,'16.3g',0.19,'Sb',NULL,NULL,NULL,NULL,1,170.183875,34.49381,0.051,NULL,60645030533,947578602,14805915,16.3),(80029,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,80029,36.31,0.4,183,31722,NULL,NULL,NULL,'2MASX J11204415+3429358',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80030,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,NULL,80030,36.35,0.2,186,31722,74.4,NULL,NULL,'2MASX J11204415+3429358',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80031,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',80031,38.22,0.46,441,31723,70,NULL,NULL,'SDSS J112044.73+195508.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,170.186417,19.91897,0,NULL,61121704260,955026629,14922291,18.4),(80032,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',80032,35.54,0.46,128,31724,70,NULL,NULL,'2MASX J11204570+2850253',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000127,NULL,'15.9g',0.33,'E',NULL,NULL,NULL,NULL,1,170.1905,28.84047,0.013,NULL,60605587010,946962297,14796285,15.9),(80033,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',80033,37.19,0.46,275,31725,70,NULL,NULL,'2MASX J11204580+0255315',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,170.190833,2.9255,0.085,NULL,60362864609,943169759,14737027,17.6),(80034,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',80034,37.58,0.1,328,31726,70,NULL,NULL,'2MASX J11204674+5431097',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000176,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,170.194917,54.51933,0,NULL,61761375896,965021498,15078460,17.2),(80035,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',80035,37.26,0.46,283,31727,70,NULL,NULL,'2MASX J11204751+5809577',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000151,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,170.1979583,58.16597,0,NULL,61980659511,968447804,15131996,17.4),(80036,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',80036,36.32,0.46,184,31728,70,NULL,NULL,'2MASX J11204780+5734007',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000174,NULL,'16.0g',0.39,'E0',NULL,NULL,NULL,NULL,1,170.199417,57.56703,0,NULL,61988483251,968570050,15133907,16),(80037,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',80037,35.39,0.49,120,31729,75,NULL,'IR','UGC 06361 NED02',NULL,'2011yCatp016004901K',2011,1,1.25,'Component \'b)\' in UGC notes.','G',0.000017,NULL,'14.9g',0.33,'Sb(f)          AGN','in a triple',NULL,NULL,NULL,1,170.2000417,0.46858,0.125,NULL,60166930295,940108285,14689191,14.9),(80038,'FP','2016-12-15 15:14:46','2016-12-16 11:19:54','1',NULL,'R',80038,37.09,0.46,262,31730,70,NULL,NULL,'2MASX J11204879+3959172',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,170.203458333,39.98806,0,NULL,63926098515,998845289,15606957,17.2),(80039,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80039,38.11,0.11,418,31731,70,NULL,NULL,'SDSS J112052.64+534923.9',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000142,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,170.219375,53.82333,0,NULL,61791453820,965491465,15085804,17.9),(80040,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80040,38.31,0.46,459,31732,70,NULL,NULL,'2MASX J11205274+0835100',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000144,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,170.2197917,8.58628,0.081,NULL,60336406577,942756352,14730568,17.7),(80041,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80041,37.12,0.46,265,31733,70,NULL,NULL,'2MASX J11205375+6539293',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000078,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,170.223708333,65.65808,0.013,NULL,61815645893,965869467,15091710,16.9),(80042,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80042,37.37,0.46,298,31734,70,NULL,NULL,'2MASX J11205410+1529479',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.38',0.17,NULL,NULL,NULL,NULL,NULL,1,170.225667,15.49669,0,NULL,61118778713,954980917,14921576,17.38),(80043,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80043,37.35,0.46,295,31735,70,NULL,NULL,'2MASX J11205580+1655539',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.07',0.16,NULL,NULL,NULL,NULL,NULL,1,170.232583,16.93153,0,NULL,61113296501,954895257,14920238,18.07),(80044,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80044,37.76,0.21,356,31736,70,NULL,NULL,'2MASX J11205582+1738539',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.94',0.16,NULL,NULL,NULL,NULL,NULL,1,170.232667,17.64833,0,NULL,61120616096,955009626,14922025,17.94),(80045,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80045,37.59,0.27,330,31737,70,NULL,NULL,'2MASX J11205623+5639016',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000143,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,170.234458333,56.65042,0,NULL,61986407392,968537615,15133400,17.9),(80046,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80046,37.41,0.46,304,31738,70,NULL,NULL,'2MASX J11205655+2833303',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000171,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,170.235666667,28.55839,0,NULL,60605373923,946958967,14796233,17.9),(80047,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80047,37.52,0.33,319,31739,70,NULL,NULL,'2MASX J11205696+2937573',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000133,NULL,'16.9g',0.24,'Sb',NULL,NULL,NULL,NULL,1,170.237333,29.63253,0.151,NULL,60660295427,947817116,14809642,16.9),(80048,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80048,38.33,0.27,464,31740,70,NULL,NULL,'2MASX J11205741+5022185',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000172,NULL,'17.2g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,170.23925,50.37194,0,NULL,61781576435,965337131,15083392,17.2),(80049,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:55','1','SN 2004bg',NULL,80049,34.19,0.18,67.4,31741,74.2,NULL,'SALT 2','UGC 06363',0.021035,'2010ApJ...716..712A',2010,1,1.1,NULL,'G',0.000033,NULL,'15.32',0.3,'Sb/c','Pair member (points to parent)',NULL,NULL,NULL,1,170.2519583,21.33781,0,NULL,61098829284,954669207,14916706,15.32),(80050,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:55','1','SN 2004bg',NULL,80050,34.68,0.03,84.5,31741,72,NULL,'SALT2','UGC 06363',0.021035,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80051,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:55','1','SN 2004bg','R',80051,34.72,0.05,87.9,31741,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 06363',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80052,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:55','1','SN 2004bg',NULL,80052,34.74,0.09,88.7,31741,74.4,NULL,NULL,'UGC 06363',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80053,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:55','1','SN 2004bg','R',80053,34.76,0.05,89.5,31741,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 06363',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80054,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:55','1','SN 2004bg',NULL,80054,34.89,0.16,92.9,31741,73.8,NULL,'SALT 2 (SNANA)','UGC 06363',0.0222,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80055,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:55','1','SN 2004bg',NULL,80055,34.92,0.17,94.4,31741,70,NULL,'SALT 2','UGC 06363',0.021035,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80056,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:55','1','SN 2004bg',NULL,80056,35.02,0.22,98.6,31741,65,NULL,'SALT2','UGC 06363',0.021035,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80057,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:55','1','SN 2004bg',NULL,80057,35.09,0.19,102,31741,65,NULL,'SALT','UGC 06363',0.021035,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80058,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:55','1','SN 2004bg',NULL,80058,35.1,0.18,102,31741,65,NULL,'MLCS17','UGC 06363',0.021035,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80059,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:55','1','SN 2004bg',NULL,80059,35.14,0.18,105,31741,65,NULL,'MLCS31','UGC 06363',0.021035,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80060,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80060,33.92,0.49,60.7,31741,75,NULL,'IR','UGC 06363',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80061,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80061,38.04,0.33,405,31742,70,NULL,NULL,'2MASX J11210212+2740058',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000182,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,170.2589583,27.66822,0,NULL,60606301379,946973459,14796460,16.9),(80062,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80062,37.76,0.23,356,31743,70,NULL,NULL,'2MASX J11210286+1225229',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000149,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,170.261917,12.423,0.063,NULL,60217611306,940900176,14701565,17.4),(80063,'HII region diameter','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80063,31.93,0.13,24.3,31744,NULL,NULL,NULL,'NGC 3631',NULL,'2005JKAS...38....7I',2005,1,5,'One of two 6cm sources associated with [WB92] 1117+5321','G',0.000003,NULL,'11.01',4.8,'SA(s)c','Isolated galaxy',NULL,NULL,NULL,1,170.261958333,53.16956,0,NULL,61794206835,965534481,15086476,11.01),(80064,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80064,29.66,0.45,8.56,31744,NULL,NULL,'K','NGC 3631',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80065,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80065,29.69,0.47,8.69,31744,NULL,NULL,'H','NGC 3631',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80066,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80066,29.81,0.46,9.16,31744,NULL,NULL,'J','NGC 3631',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80067,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80067,31.22,0.4,17.5,31744,NULL,NULL,'mean','NGC 3631',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80068,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80068,31.67,0.4,21.6,31744,75,NULL,'B','NGC 3631',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80069,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80069,37.18,0.46,272,31745,70,NULL,NULL,'2MASX J11210317+5729575',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,170.263416667,57.49942,0,NULL,61988533981,968570843,15133919,16.7),(80070,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80070,35.38,0.49,119,31746,75,NULL,'IR','IC 2735',NULL,'2011yCatp016004901K',2011,1,1.41,'UZC has V = 10349 +- 45 km/sec.','G',0.000043,NULL,'14.6g',0.39,'Sab','Group member',NULL,NULL,NULL,1,170.26625,34.34394,0.048,NULL,60645006293,947578223,14805909,14.6),(80071,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80071,35.44,0.33,122,31746,NULL,NULL,'Malmquist cor.','IC 2735',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80072,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80072,35.45,0.33,123,31746,NULL,NULL,NULL,'IC 2735',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80073,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80073,35.49,0.2,125,31746,74.4,NULL,NULL,'IC 2735',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80074,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80074,36.13,0.73,168,31747,70,NULL,NULL,'2MASX J11210457-4708385',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.7I',0.2,NULL,NULL,NULL,NULL,NULL,1,170.269083,-47.14397,0.565,NULL,41930832848,655169263,10237019,14.7),(80075,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80075,37.69,0.33,345,31748,70,NULL,NULL,'2MASX J11210540+2845389',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000169,NULL,'16.7g',0.29,'E',NULL,NULL,NULL,NULL,1,170.2725417,28.76083,0.051,NULL,60605571775,946962058,14796282,16.7),(80076,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80076,38.04,0.33,405,31749,70,NULL,NULL,'2MASX J11210648+2741159',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00019,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,170.277083,27.68775,0,NULL,60606315100,946973673,14796463,17.6),(80077,'SBF','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80077,32.15,0.14,26.9,31750,74.4,NULL,NULL,'NGC 3640',NULL,'2013AJ....146...86T',2013,1,4,NULL,'G',0.000017,NULL,'11.36',3.2,'E3','in a radial-velocity based grouping',NULL,NULL,NULL,1,170.2785417,3.23483,0.097,NULL,60363620763,943181574,14737212,11.36),(80078,'SBF','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80078,32.16,0.13,27,31750,NULL,NULL,'I','NGC 3640',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80079,'SBF','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80079,32.16,0.13,27,31750,NULL,NULL,NULL,'NGC 3640',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80080,'SBF','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80080,32.16,0.13,27,31750,NULL,NULL,'Malmquist cor.','NGC 3640',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80081,'D-Sigma','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80081,32.15,0.4,26.9,31750,75,NULL,'Edat, raw','NGC 3640',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80082,'D-Sigma','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80082,32.32,0.4,29.1,31750,75,NULL,'Edat, cor','NGC 3640',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80083,'Faber-Jackson','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80083,30.2,0.54,11,31750,95,NULL,'de Vaucouleurs','NGC 3640',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80084,'Faber-Jackson','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80084,30.95,0.3,15.5,31750,95,NULL,'Weighted Mean','NGC 3640',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80085,'Faber-Jackson','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80085,31,NULL,15.8,31750,NULL,NULL,'LEDA [April 2006]','NGC 3640',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80086,'Faber-Jackson','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80086,31.78,0.63,22.7,31750,95,NULL,'Michard 1979b, c','NGC 3640',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80087,'Faber-Jackson','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80087,31.78,0.46,22.7,31750,95,NULL,'Michard 1979a','NGC 3640',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80088,'Faber-Jackson','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80088,32.03,0.81,25.5,31750,55,NULL,'Visvanathan & Sandage 1979','NGC 3640',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80089,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80089,30.97,0.41,15.6,31750,NULL,NULL,NULL,'NGC 3640',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80090,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80090,31.17,0.41,17.2,31750,NULL,NULL,'Malmquist cor.','NGC 3640',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80091,'Tertiary','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80091,31.04,0.71,16.1,31750,95,NULL,NULL,'NGC 3640',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80092,'Tully est','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80092,31.92,0.8,24.2,31750,75,NULL,'B','NGC 3640',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80093,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80093,31.56,0.45,20.5,31750,NULL,NULL,'K','NGC 3640',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80094,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80094,32.19,0.4,27.4,31750,NULL,NULL,'mean','NGC 3640',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80095,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80095,37.69,0.33,345,31751,70,NULL,NULL,'SDSS J112107.90+284527.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00018,NULL,'17.8g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,170.2829583,28.75769,0.051,NULL,60605571416,946962053,14796282,17.8),(80096,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80096,36.05,0.46,162,31752,70,NULL,NULL,'2MASX J11210791+4746004',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000099,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,170.2829583,47.76678,0,NULL,63947253472,999175835,15612122,16.3),(80097,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80097,37.55,0.46,324,31753,70,NULL,NULL,'SDSS J112108.63+142652.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,170.285958333,14.448,0.056,NULL,61117905141,954967267,14921363,17.7),(80098,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80098,36.95,0.19,245,31754,70,NULL,NULL,'2MASXi J1121087+671848',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000069,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,170.2862083,67.31328,0,NULL,62085203105,970081298,15157520,17.3),(80099,'SBF','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80099,32.13,0.25,26.7,31755,NULL,NULL,'I','NGC 3641',NULL,'2001ApJ...546..681T',2001,1,1.1,'This entry was added to CGCG in vol III, \'Errors and Omissions\'.','G',0.000017,NULL,'14.1',1.1,'E pec','in a radial-velocity based grouping',NULL,NULL,NULL,1,170.2867083,3.19458,0.097,NULL,60363398419,943178100,14737157,14.1),(80100,'SBF','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80100,32.16,0.14,27,31755,74.4,NULL,NULL,'NGC 3641',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80101,'D-Sigma','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80101,32.15,0.4,26.9,31755,75,NULL,'Edat, raw','NGC 3641',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80102,'D-Sigma','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80102,32.32,0.4,29.1,31755,75,NULL,'Edat, cor','NGC 3641',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80103,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80103,38.29,0.15,455,31756,70,NULL,NULL,'2MASX J11210945-0012129',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000066,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,170.2892917,-0.20353,0.125,NULL,40822430859,637850482,9966413,18.1),(80104,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80104,35.2,0.46,110,31757,70,NULL,NULL,'VV 510',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.00008,NULL,'14.5g',0.76,'E',NULL,NULL,NULL,NULL,1,170.292333,5.3635,0.121,NULL,60358592941,943103014,14735984,14.5),(80105,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80105,36.62,0.46,211,31758,70,NULL,NULL,'2MASX J11211072+3144268',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000187,NULL,'15.9g',0.41,NULL,NULL,NULL,NULL,NULL,1,170.29475,31.74081,0,NULL,60665015812,947890872,14810794,15.9),(80106,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80106,38.29,0.15,455,31759,70,NULL,NULL,'2MASX J11211158-0017379',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000023,NULL,'16.7g',0.27,'NLAGN',NULL,NULL,NULL,'Sy 2',1,170.298125,-0.29389,0.125,NULL,40822427642,637850431,9966412,16.7),(80107,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80107,35.31,0.4,115,31760,NULL,NULL,'mean','CGCG 011-076',NULL,'2007A&A...465...71T',2007,1,0.8,NULL,'G',0.000077,NULL,'15.26',0.7,'SAB(s)b;HII    Sy2',NULL,NULL,NULL,NULL,1,170.301083,-2.98431,0.125,NULL,41051024444,641422256,10022222,15.26),(80108,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80108,35.37,0.45,118,31760,NULL,NULL,'K','CGCG 011-076',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80109,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80109,35.43,0.47,122,31760,NULL,NULL,'H','CGCG 011-076',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80110,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80110,35.61,0.46,133,31760,NULL,NULL,'J','CGCG 011-076',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80111,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80111,37.76,0.21,356,31761,70,NULL,NULL,'2MASX J11211247+1743493',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.20',0.15,NULL,NULL,NULL,NULL,NULL,1,170.301917,17.73039,0,NULL,61120613390,955009584,14922024,18.2),(80112,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80112,36.52,0.46,201,31762,70,NULL,NULL,'CGCG 039-131',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000187,NULL,'15.5g',0.55,'E0',NULL,NULL,NULL,NULL,1,170.303208333,4.55867,0.137,NULL,60360525020,943133203,14736456,15.5),(80113,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80113,38.33,0.27,464,31763,70,NULL,NULL,'2MASX J11211410+5016204',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000153,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,170.3085417,50.27217,0,NULL,61778178322,965284036,15082563,17.5),(80114,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80114,38.29,0.15,455,31764,70,NULL,NULL,'2MASX J11211425+0003570',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000084,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,170.309417,0.06567,0.101,NULL,60164675456,940073054,14688641,17.5),(80115,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80115,36.1,0.55,166,31765,70,NULL,NULL,'2MASX J11211500-4437497',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,170.3125417,-44.63047,0.425,NULL,41939010193,655297034,10239016,15.1),(80116,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80116,37.59,0.46,329,31766,70,NULL,NULL,'2MASX J11211502+5632598',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000175,NULL,'16.0g',0.44,'AGN',NULL,NULL,NULL,NULL,1,170.312667,56.54997,0,NULL,61986210984,968534546,15133352,16),(80117,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80117,38.1,0.46,418,31767,70,NULL,NULL,'2MASX J11211516+5000104',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000142,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,170.313333,50.00283,0,NULL,61778380977,965287202,15082612,17.8),(80118,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80118,36.36,0.6,187,31768,70,NULL,NULL,'2MASX J11211546-0442479',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,170.314375,-4.71336,0.117,NULL,41042804377,641293818,10020215,17),(80119,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80119,35.71,0.46,139,31769,70,NULL,NULL,'CGCG 039-133',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000083,NULL,'15.3g',0.51,'E',NULL,NULL,NULL,NULL,1,170.326125,3.66475,0.113,NULL,60364277969,943191843,14737372,15.3),(80120,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80120,36.8,0.12,229,31770,70,NULL,NULL,'2MASX J11211907+0300091',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000167,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,170.329417,3.00242,0.085,NULL,60362913862,943170529,14737039,17.1),(80121,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80121,38.29,0.15,455,31771,70,NULL,NULL,'SDSS J112119.30+001322.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000108,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,170.330417,0.22289,0.101,NULL,60166793475,940106148,14689158,18.4),(80122,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80122,37.59,0.27,330,31772,70,NULL,NULL,'2MASX J11211935+5643178',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,170.3304583,56.72156,0,NULL,61986141950,968533467,15133335,17.7),(80123,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80123,36.38,0.46,189,31773,70,NULL,NULL,'2MASX J11211944+3532477',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000173,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,170.3310417,35.54664,0.037,NULL,60421894577,944092102,14751439,16.3),(80124,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80124,36.41,0.46,192,31774,70,NULL,NULL,'2MASX J11211956+0229421',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,170.331333,2.49508,0.105,NULL,60349163054,942955672,14733682,17),(80125,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80125,38.29,0.15,455,31775,70,NULL,NULL,'2MASX J11211952-0000039',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000085,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,170.331375,-0.00125,0.129,NULL,40821334019,637833344,9966146,17.8),(80126,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80126,38.29,0.15,455,31776,70,NULL,NULL,'SDSS J112119.57-001351.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000089,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,170.331583,-0.23108,0.125,NULL,40822412830,637850200,9966409,18.2),(80127,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80127,38.29,0.15,455,31777,70,NULL,NULL,'SDSS J112120.36-001624.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000077,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,170.334875,-0.27342,0.125,NULL,40822417445,637850272,9966410,18.7),(80128,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80128,38.46,0.46,492,31778,70,NULL,NULL,'2MASX J11212046+5539468',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000163,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,170.335417,55.66303,0,NULL,61986908905,968545451,15133522,18.2),(80129,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80129,37.87,0.46,375,31779,70,NULL,NULL,'2MASX J11212078+1918263',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.16',0.16,NULL,NULL,NULL,NULL,NULL,1,170.336583333,19.30739,0,NULL,61122272855,955035513,14922429,18.16),(80130,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80130,38.29,0.15,455,31780,70,NULL,NULL,'2MASX J11212245-0013019',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000083,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,170.343625,-0.21711,0.125,NULL,40822411647,637850181,9966409,17.9),(80131,'BCG','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80131,36.71,0.35,212,31781,60,NULL,'ABELL 1228, BCG','IC 2738',0.0344,'1980ApJ...241..486H',1980,1,0.5,NULL,'G',0.000056,NULL,'15.29',0.5,'S?','Group member, central object',NULL,NULL,NULL,1,170.346083,34.35667,0.048,NULL,60645129961,947580155,14805939,15.29),(80132,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80132,35.79,0.25,144,31781,74.4,NULL,NULL,'IC 2738',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80133,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80133,35.75,0.11,141,31781,70,NULL,'ABELL 1228, BGC','IC 2738',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80134,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80134,37.59,0.27,330,31782,70,NULL,NULL,'2MASX J11212323+5642268',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000163,NULL,'16.7g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,170.346708333,56.70753,0,NULL,61986141505,968533461,15133335,16.7),(80135,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80135,38.18,0.16,432,31783,70,NULL,NULL,'2MASX J11212346+3753160',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,170.347833,37.88781,0,NULL,60426300908,944160951,14752514,17.4),(80136,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80136,36.8,0.12,229,31784,70,NULL,NULL,'SDSS J112123.62+025149.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,170.3484583,2.86381,0.101,NULL,60362876810,943169950,14737030,17.7),(80137,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80137,37.97,0.46,392,31785,70,NULL,NULL,'2MASX J11212369+0036261',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000078,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,170.3487083,0.60725,0.125,NULL,60166941357,940108458,14689194,17.5),(80138,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80138,38.35,0.46,468,31786,70,NULL,NULL,'2MASX J11212394+3629040',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,170.349958333,36.48431,0.015,NULL,60430808994,944231390,14753615,17.3),(80139,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80139,37.29,0.46,287,31787,70,NULL,NULL,'2MASX J11212403+2114023',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000127,NULL,'16.8',0.15,NULL,NULL,NULL,NULL,NULL,1,170.350166667,21.23383,0,NULL,61098495897,954663998,14916624,16.8),(80140,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80140,38.11,0.11,418,31788,70,NULL,NULL,'2MASX J11212450+5344473',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000159,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,170.352041667,53.74653,0,NULL,61791499981,965492187,15085815,18.2),(80141,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80141,37.43,0.46,307,31789,70,NULL,NULL,'2MASX J11212541+3903340',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,170.3557083,39.05942,0,NULL,60426870199,944169846,14752653,17.6),(80142,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80142,36.44,0.19,194,31790,70,NULL,NULL,'2MASX J11212594+3412154',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000137,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,170.358,34.20422,0.092,NULL,60645198921,947581233,14805956,16.4),(80143,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80143,38.11,0.11,418,31791,70,NULL,NULL,'2MASX J11212642+5344563',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000181,NULL,'16.3g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,170.3602083,53.74911,0,NULL,61791499996,965492187,15085815,16.3),(80144,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80144,37.56,0.46,325,31792,70,NULL,NULL,'SDSS J112126.71+173415.7',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,170.361333333,17.57106,0,NULL,61120600327,955009380,14922021,17.3),(80145,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80145,35.62,0.25,133,31793,74.4,NULL,NULL,'CGCG 185-043',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000047,NULL,'15.3g',0.39,NULL,'Group member',NULL,NULL,NULL,1,170.3622917,34.45275,0.048,NULL,60645169793,947580778,14805949,15.3),(80146,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80146,35.84,0.21,147,31793,70,NULL,NULL,'CGCG 185-043',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80147,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80147,37.78,0.46,360,31794,70,NULL,NULL,'2MASX J11212699+1928143',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,170.362583,19.47072,0,NULL,61122143271,955033488,14922398,17.3),(80148,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80148,36.3,0.46,182,31795,70,NULL,NULL,'2MASX J11212787+0337342',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,170.366167,3.62625,0.093,NULL,60364259209,943191550,14737367,17),(80149,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80149,37.91,0.46,382,31796,70,NULL,NULL,'SDSS J112128.17+012607.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000139,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,170.367417,1.43531,0.113,NULL,60165484225,940085691,14688838,18.1),(80150,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80150,37.79,0.46,361,31797,70,NULL,NULL,'2MASX J11212820+2407260',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.66',0.1,NULL,NULL,NULL,NULL,NULL,1,170.367417,24.12381,0,NULL,60580685997,946573218,14790206,18.66),(80151,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80151,36.72,0.46,221,31798,70,NULL,NULL,'2MASX J11212841+3432394',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000036,NULL,'15.5g',0.44,NULL,NULL,NULL,NULL,NULL,1,170.368417,34.54419,0.048,NULL,60645160489,947580632,14805947,15.5),(80152,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80152,38.18,0.16,432,31799,70,NULL,NULL,'SDSS J112128.57+375227.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00014,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,170.369083,37.87425,0,NULL,60426300081,944160938,14752514,18.5),(80153,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80153,38.29,0.15,455,31800,70,NULL,NULL,'SDSS J112129.47-000933.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000075,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,170.372791667,-0.15919,0.125,NULL,40821386868,637834169,9966158,18.4),(80154,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80154,38.95,0.46,617,31801,70,NULL,NULL,'SDSS J112129.59+475907.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000147,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,170.373333,47.9855,0,NULL,63947239699,999175620,15612119,18.6),(80155,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80155,37.46,0.46,310,31802,70,NULL,NULL,'SDSS J112129.61+403405.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,170.373417,40.56808,0,NULL,63925846372,998841349,15606896,17.8),(80156,'BCG','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80156,36.71,0.35,212,31803,60,NULL,NULL,'ABELL 1228',0.0344,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III [BM]',NULL,NULL,NULL,NULL,1,170.3737083,34.32586,0.048,NULL,60645129062,947580141,14805939,NULL),(80157,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80157,35.75,0.11,141,31803,70,NULL,NULL,'ABELL 1228',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80158,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80158,38.05,0.46,407,31804,70,NULL,NULL,'2MASX J11213006+3635580',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,170.37525,36.59942,0.015,NULL,60430763208,944230675,14753604,17.7),(80159,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80159,36.14,0.5,169,31805,NULL,NULL,'Malmquist cor.','2MASX J11213103+3408334',NULL,'2009ApJS..182..474S',2009,1,0.35,NULL,'G',0.000023,NULL,'17.4g',0.13,'Sc',NULL,NULL,NULL,NULL,1,170.379291667,34.14267,0.092,NULL,60645208598,947581384,14805959,17.4),(80160,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80160,36.4,0.44,190,31805,NULL,NULL,NULL,'2MASX J11213103+3408334',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80161,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80161,36.44,0.2,194,31805,74.4,NULL,NULL,'2MASX J11213103+3408334',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80162,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80162,36.8,0.12,229,31806,70,NULL,NULL,'IC 0683',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00022,NULL,'14.99',0.5,'E','Group member',NULL,NULL,NULL,1,170.382416667,2.75181,0.101,NULL,60349184581,942956009,14733687,14.99),(80163,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80163,37.33,0.33,292,31807,70,NULL,NULL,'2MASX J11213251+0325579',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,170.385541667,3.43272,0.097,NULL,60363580734,943180948,14737202,17.1),(80164,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80164,36.8,0.12,229,31808,70,NULL,NULL,'CGCG 039-135',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000113,NULL,'15.2g',0.54,'E','Group member',NULL,NULL,NULL,1,170.385666667,2.88725,0.101,NULL,60362880483,943170007,14737031,15.2),(80165,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80165,37.76,0.23,356,31809,70,NULL,NULL,'2MASX J11213274+1227223',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.14',0.16,'BrClG',NULL,NULL,NULL,NULL,1,170.386417,12.45636,0.03,NULL,60217443961,940897561,14701524,18.14),(80166,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:55','1','SN 1996V',NULL,80166,35.33,0.25,114,31810,65,NULL,NULL,'NGC 3644',0.02377,'2004ApJ...607..665R',2004,1,1.55,NULL,'G',0.000063,NULL,'14.6g',0.54,'(R\')SBa pec:','Group member',NULL,NULL,NULL,1,170.386958333,2.81044,0.101,NULL,60348993425,942953022,14733640,14.6),(80167,'SNIa','2016-12-15 15:14:46','2016-12-16 11:19:55','1','SN 1996V',NULL,80167,35.35,0.17,117,31810,65,NULL,'Snapshot','NGC 3644',NULL,'1998ApJ...504..935R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80168,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80168,34.72,0.2,87.9,31810,74.4,NULL,NULL,'NGC 3644',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80169,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80169,35.17,0.4,108,31810,NULL,NULL,'mean','NGC 3644',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80170,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80170,35.29,0.47,114,31810,NULL,NULL,'H','NGC 3644',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80171,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80171,35.37,0.45,119,31810,NULL,NULL,'K','NGC 3644',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80172,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80172,35.58,0.46,131,31811,70,NULL,NULL,'2MASX J11213517+0426469',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00009,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,170.396541667,4.44644,0.113,NULL,60360729539,943136399,14736506,16.7),(80173,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80173,38.16,0.23,429,31812,70,NULL,NULL,'2MASX J11213542+3523245',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,'PHOT','16.6g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,170.397666667,35.39022,0.065,NULL,60421432497,944084882,14751326,16.6),(80174,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80174,36.8,0.12,229,31813,70,NULL,NULL,'2MASX J11213546+0245489',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,170.39775,2.76356,0.101,NULL,60349171180,942955799,14733684,17.5),(80175,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80175,36.8,0.12,229,31814,70,NULL,NULL,'2MASX J11213546+0252559',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,'FoF','16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,170.3977917,2.88206,0.101,NULL,60362869287,943169832,14737028,16.9),(80176,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80176,34.81,0.4,91.7,31815,NULL,NULL,'mean','NGC 3639',NULL,'2007A&A...465...71T',2007,1,0.6,NULL,'G',0.00002,NULL,'14.6',0.5,'S?','Group member',NULL,NULL,NULL,1,170.398667,18.45858,0,NULL,61120970713,955015167,14922111,14.6),(80177,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80177,35.31,0.47,115,31815,NULL,NULL,'H','NGC 3639',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80178,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80178,35.38,0.45,119,31815,NULL,NULL,'K','NGC 3639',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80179,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80179,35.42,0.46,121,31815,NULL,NULL,'J','NGC 3639',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80180,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80180,38.16,0.23,429,31816,70,NULL,NULL,'2MASX J11213656+3523145',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,'PHOT','16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,170.402416667,35.38725,0.065,NULL,60421432572,944084883,14751326,16.8),(80181,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80181,38.09,0.46,414,31817,70,NULL,NULL,'2MASX J11213725+1931293',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.56',0.12,NULL,NULL,NULL,NULL,NULL,1,170.405333,19.52489,0,NULL,61122145396,955033521,14922398,18.56),(80182,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80182,36.8,0.12,229,31818,70,NULL,NULL,'2MASX J11213759+0241389',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000192,NULL,'15.9g',0.45,'E0',NULL,NULL,NULL,NULL,1,170.4067083,2.69408,0.105,NULL,60349181044,942955953,14733686,15.9),(80183,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80183,38.16,0.23,429,31819,70,NULL,NULL,'2MASX J11213787+3525365',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000185,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,170.4080417,35.42686,0.065,NULL,60421435031,944084922,14751326,17.1),(80184,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80184,36.95,0.19,245,31820,70,NULL,NULL,'2MASXi J1121381+672624',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000074,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,170.409125,67.44011,0.005,NULL,62090197824,970159341,15158739,16.9),(80185,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80185,38.34,0.46,465,31821,70,NULL,NULL,'2MASX J11213826+3819121',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000182,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,170.409583,38.31997,0,NULL,60426485216,944163831,14752559,17.4),(80186,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80186,36.8,0.12,229,31822,70,NULL,NULL,'SDSS J112138.34+025454.9',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,170.40975,2.91525,0.101,NULL,60362882031,943170031,14737031,17),(80187,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80187,37.72,0.46,350,31823,70,NULL,NULL,'2MASX J11213838+0450559',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.0002,NULL,'16.4g',0.35,'AGN',NULL,NULL,NULL,NULL,1,170.4100417,4.84875,0.113,NULL,60358771420,943105803,14736028,16.4),(80188,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80188,36.8,0.12,229,31824,70,NULL,NULL,'NGC 3647',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00017,NULL,'15.4',0.3,'E','Group member',NULL,NULL,NULL,1,170.41075,2.89172,0.101,NULL,60362868193,943169815,14737028,15.4),(80189,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80189,35.91,0.46,152,31825,70,NULL,NULL,'2MASX J11213962+3221295',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000175,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,170.415125,32.35831,0.073,NULL,60651124882,947673826,14807403,16.2),(80190,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80190,36.53,0.46,202,31826,70,NULL,NULL,'2MASX J11214000+6142299',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,170.416916667,61.70817,0,NULL,61859010835,966547044,15102297,17),(80191,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80191,36.8,0.12,229,31827,70,NULL,NULL,'SDSS J112140.85+025353.9',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000175,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,170.42025,2.89833,0.101,NULL,60362868513,943169820,14737028,17.2),(80192,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80192,35.27,0.46,113,31828,70,NULL,NULL,'CGCG 011-078',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000174,NULL,'15.5g',0.46,'E+:',NULL,NULL,NULL,NULL,1,170.4247083,1.52078,0.093,NULL,60165478267,940085597,14688837,15.5),(80193,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80193,38.11,0.11,418,31829,70,NULL,NULL,'2MASX J11214214+5347283',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000178,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,170.425833,53.79117,0,NULL,61791528141,965492627,15085822,16.9),(80194,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80194,38.3,0.46,458,31830,70,NULL,NULL,'SDSS J112142.46+380525.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000119,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,170.4269583,38.09031,0.023,NULL,60426508865,944164201,14752565,18.3),(80195,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80195,35.72,0.25,139,31831,74.4,NULL,NULL,'IC 2744',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000028,NULL,'15.40',0.5,'S0?','Group member, 2nd ranked galaxy',NULL,NULL,NULL,1,170.427125,34.36281,0.048,NULL,60645121092,947580017,14805937,15.4),(80196,'IRAS','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80196,33.91,0.8,60.5,31832,75,NULL,'CF, r','NGC 3646',NULL,'1997ApJS..109..333W',1997,1,3.9,NULL,'G',0.000017,NULL,'11.1B',2.2,'SA:(r)bc pec (ring)','Pair member (points to parent)',NULL,NULL,NULL,1,170.4295,20.16956,0,NULL,61121530600,955023915,14922248,11.1),(80197,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80197,33,0.69,39.8,31832,100,NULL,'mid-IR','NGC 3646',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80198,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80198,33.64,0.33,53.4,31832,NULL,NULL,'Malmquist cor.','NGC 3646',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80199,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80199,33.66,0.2,54,31832,74.4,NULL,NULL,'NGC 3646',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80200,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80200,33.7,0.43,54.9,31832,75,NULL,'3.6 micron, color corrected','NGC 3646',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80201,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80201,33.7,0.38,55.1,31832,75,NULL,'CF, r, raw','NGC 3646',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80202,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80202,33.75,0.32,56.2,31832,NULL,NULL,NULL,'NGC 3646',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80203,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80203,33.89,0.43,59.9,31832,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3646',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80204,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80204,33.89,0.46,60,31832,NULL,NULL,'J','NGC 3646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80205,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80205,33.92,0.38,60.9,31832,75,NULL,'CF, r, cor','NGC 3646',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80206,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80206,33.97,0.45,62.2,31832,NULL,NULL,'K','NGC 3646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80207,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80207,33.98,0.47,62.4,31832,NULL,NULL,'H','NGC 3646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80208,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80208,33.98,0.38,62.5,31832,75,NULL,'CF, r, inv','NGC 3646',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80209,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80209,34.13,0.4,66.9,31832,NULL,NULL,'mean','NGC 3646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80210,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80210,37.5,0.33,316,31833,70,NULL,NULL,'2MASX J11214344+3249025',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000216,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,170.431125,32.81747,0.06,NULL,60651291417,947676428,14807444,16.6),(80211,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80211,38.3,0.27,458,31834,70,NULL,NULL,'SDSS J112143.91+005713.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,170.433,0.95378,0.081,NULL,60167076937,940110577,14689227,18.1),(80212,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80212,36.99,0.46,250,31835,70,NULL,NULL,'IC 2748',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000174,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,170.4335,8.80497,0.065,NULL,60344181210,942877831,14732466,16.3),(80213,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80213,35.9,0.72,151,31836,70,NULL,NULL,'2MASX J11214406-4626547',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,170.433583333,-46.44858,0.561,NULL,41932179956,655190311,10237348,16.7),(80214,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80214,37.84,0.46,369,31837,70,NULL,NULL,'2MASX J11214409+5439147',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,170.433625,54.65419,0,NULL,61761309648,965020463,15078444,18),(80215,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80215,37.26,0.46,284,31838,70,NULL,NULL,'2MASX J11214526+1603199',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.24',0.13,NULL,NULL,NULL,NULL,NULL,1,170.4385417,16.05572,0,NULL,61115910046,954936094,14920876,18.24),(80216,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80216,38.3,0.27,458,31839,70,NULL,NULL,'2MASX J11214613+0057569',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00008,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,170.442083,0.96581,0.081,NULL,60167076397,940110568,14689227,17.8),(80217,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80217,37.69,0.27,345,31840,70,NULL,NULL,'2MASX J11214639+5504467',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,170.4432917,55.07975,0,NULL,61984393340,968506145,15132908,17.7),(80218,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80218,38.02,0.13,402,31841,70,NULL,NULL,'SDSS J112147.19+004653.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000054,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,170.446625,0.78161,0.101,NULL,60167060990,940110327,14689223,18.1),(80219,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80219,38.18,0.16,432,31842,70,NULL,NULL,'SDSS J112147.30+375500.1',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.6g',NULL,'BrClG',NULL,NULL,NULL,NULL,1,170.447083,37.91672,0,NULL,60426351489,944161742,14752527,17.6),(80220,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80220,37.72,0.33,349,31843,70,NULL,NULL,'2MASX J11214735+3515544',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,170.447208333,35.26511,0.065,NULL,60421545317,944086645,14751353,17.4),(80221,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80221,36.8,0.12,229,31844,70,NULL,NULL,'2MASX J11214747+0245009',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000176,NULL,'17.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,170.4479583,2.75017,0.105,NULL,60349178891,942955920,14733686,17.2),(80222,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80222,34.86,0.46,93.7,31845,70,NULL,NULL,'NGC 3679',NULL,'2014MNRAS.445.2677S',2014,1,1.38,'NGC identification is not certain.','G',0.00013,NULL,'14.49',1.05,'E1/SA0-',NULL,NULL,NULL,NULL,1,170.45025,-5.75769,0.089,NULL,41060564544,641571321,10024551,14.49),(80223,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80223,38.14,0.12,425,31846,70,NULL,NULL,'2MASX J11214820+1938380',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,170.450833,19.644,0.044,NULL,61122099243,955032800,14922387,17.5),(80224,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80224,37.68,0.46,343,31847,70,NULL,NULL,'2MASX J11214919+2356041',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.31',0.15,NULL,NULL,NULL,NULL,NULL,1,170.454833,23.93436,0,NULL,60580449978,946569530,14790148,18.31),(80225,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80225,36.8,0.12,229,31848,70,NULL,NULL,'2MASX J11214934+0306599',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000167,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,170.45575,3.1165,0.101,NULL,60363077703,943173089,14737079,16.7),(80226,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80226,37.44,0.46,307,31849,70,NULL,NULL,'SDSS J112149.49+013213.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000156,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,170.45625,1.53719,0.093,NULL,60165480208,940085628,14688837,18.4),(80227,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80227,37.72,0.33,349,31850,70,NULL,NULL,'2MASX J11214988+3515064',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000169,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,170.458,35.25172,0.065,NULL,60421545894,944086654,14751353,17.9),(80228,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80228,38.3,0.27,458,31851,70,NULL,NULL,'SDSS J112149.94+005830.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000079,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,170.458125,0.97525,0.081,NULL,60167064122,940110376,14689224,18.6),(80229,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80229,38.45,0.46,490,31852,70,NULL,NULL,'SDSS J112150.30+230056.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,170.459583,23.01583,0,NULL,61096253871,954628966,14916077,18.6),(80230,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80230,37.5,0.33,316,31853,70,NULL,NULL,'2MASX J11215033+3245534',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000203,NULL,'15.9g',0.41,NULL,NULL,NULL,NULL,NULL,1,170.4597917,32.76469,0.06,NULL,60651700975,947682827,14807544,15.9),(80231,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80231,38.84,0.46,586,31854,70,NULL,NULL,'SDSS J112151.01+241453.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,170.4625417,24.24819,0,NULL,60580629959,946572343,14790192,17.9),(80232,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80232,36.85,0.21,235,31855,70,NULL,NULL,'2MASX J11215122+4051470',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000174,NULL,'15.7g',0.48,'BrClG          AGN',NULL,NULL,NULL,NULL,1,170.463458333,40.86306,0,NULL,63925802010,998840656,15606885,15.7),(80233,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80233,38.16,0.23,429,31856,70,NULL,NULL,'2MASX J11215250+3519174',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,170.468625,35.32156,0.065,NULL,60421418287,944084660,14751322,18.2),(80234,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80234,35.76,0.46,142,31857,70,NULL,NULL,'2MASX J11215297+6231058',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000152,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,170.4704583,62.51833,0.005,NULL,61873550112,966774220,15105847,16.7),(80235,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80235,38.11,0.46,418,31858,70,NULL,NULL,'2MASX J11215354+2050380',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000127,NULL,'17.4',0.2,NULL,NULL,NULL,NULL,NULL,1,170.4732083,20.84386,0,NULL,61096377590,954630899,14916107,17.4),(80236,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80236,38.02,0.13,402,31859,70,NULL,NULL,'2MASX J11215380+0041549',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00009,NULL,'17.5g',0.2,'BrClG',NULL,NULL,NULL,NULL,1,170.474041667,0.69858,0.093,NULL,60166931370,940108302,14689192,17.5),(80237,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80237,37.05,0.46,257,31860,70,NULL,NULL,'2MASX J11215416+3551114',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,170.47575,35.85314,0.036,NULL,60421733826,944089591,14751399,18),(80238,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80238,35.64,0.66,134,31861,70,NULL,NULL,'ESO 216- G 007',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'16.63',0.2,'S...',NULL,NULL,NULL,NULL,1,170.477166667,-48.05228,0.493,NULL,41930550970,655164858,10236950,16.63),(80239,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80239,38.11,0.11,418,31862,70,NULL,NULL,'2MASX J11215488+5341133',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000188,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,170.478667,53.68706,0,NULL,61791315006,965489296,15085770,16.7),(80240,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80240,36.23,0.33,176,31863,70,NULL,NULL,'2MASX J11215489+6635375',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000078,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,170.479125,66.59378,0,NULL,61814472770,965851137,15091424,16.6),(80241,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80241,38.02,0.13,402,31864,70,NULL,NULL,'2MASX J11215593+0042519',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000089,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,170.482917,0.71431,0.101,NULL,60167045976,940110093,14689220,17.8),(80242,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80242,37.69,0.27,345,31865,70,NULL,NULL,'2MASX J11215614+5500393',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000192,NULL,'16.8g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,170.484083,55.01108,0,NULL,61984403880,968506310,15132911,16.8),(80243,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80243,38.11,0.11,418,31866,70,NULL,NULL,'2MASX J11215645+5337403',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000184,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,170.485417,53.62783,0,NULL,61791320691,965489385,15085771,16.7),(80244,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80244,37.91,0.46,382,31867,70,NULL,NULL,'2MASX J11215696+0947412',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000184,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,170.487333,9.79486,0.024,NULL,60347504980,942929765,14733277,17.7),(80245,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80245,35.78,0.46,143,31868,70,NULL,NULL,'CGCG 268-023',NULL,'2015arXiv151105856S',2015,1,0.94,NULL,'G',0.00009,NULL,'14.5g',0.76,'E',NULL,NULL,NULL,NULL,1,170.487667,52.96281,0,NULL,61794386044,965537281,15086520,14.5),(80246,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80246,36.8,0.12,229,31869,70,NULL,NULL,'2MASX J11215722+0243099',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00018,NULL,'16.2g',0.34,'E0',NULL,NULL,NULL,NULL,1,170.488333,2.71939,0.105,NULL,60349112052,942954875,14733669,16.2),(80247,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80247,38.55,0.33,512,31870,70,NULL,NULL,'2MASX J11215746+3351126',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.57',0.14,NULL,NULL,NULL,NULL,NULL,1,170.4892917,33.85339,0.046,NULL,60644861638,947575963,14805874,18.57),(80248,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80248,38.18,0.16,432,31871,70,NULL,NULL,'2MASX J11215747+3754338',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,170.489417,37.90944,0,NULL,60426349997,944161718,14752526,17.6),(80249,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80249,37.33,0.33,292,31872,70,NULL,NULL,'2MASX J11215776+0322319',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000151,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,170.490625,3.3755,0.097,NULL,60363484085,943179438,14737178,17.1),(80250,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80250,36.63,0.89,212,31873,70,NULL,NULL,'2MASX J11215798-4706047',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,170.4915,-47.10136,0.557,NULL,41930951063,655171110,10237048,17),(80251,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80251,33.27,NULL,45.1,31874,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06384',NULL,'2010Ap&SS.325..163P',2010,1,1.26,NULL,'G',0.000027,NULL,'16.2g',0.19,'Sd',NULL,NULL,NULL,NULL,1,170.4915,34.94858,0.046,NULL,60421317602,944083087,14751298,16.2),(80252,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80252,33.29,NULL,45.5,31874,NULL,NULL,'Dipole + Quadrupole','UGC 06384',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80253,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80253,33.3,NULL,45.7,31874,NULL,NULL,'Dipole','UGC 06384',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80254,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80254,33.36,0.2,47,31874,74.4,NULL,NULL,'UGC 06384',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80255,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80255,33.37,NULL,47.2,31874,NULL,NULL,NULL,'UGC 06384',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80256,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80256,33.5,0.35,50.2,31874,NULL,NULL,'Malmquist cor.','UGC 06384',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80257,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80257,33.61,0.34,52.7,31874,NULL,NULL,NULL,'UGC 06384',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80258,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80258,37.36,0.46,296,31875,70,NULL,NULL,'2MASX J11215807+4734388',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000176,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,170.4919583,47.57731,0,NULL,63946979977,999171562,15612055,17.5),(80259,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80259,37.45,0.46,309,31876,70,NULL,NULL,'2MASX J11215850+2420232',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,170.4937917,24.33967,0,NULL,60581413564,946584586,14790384,17.6),(80260,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80260,38.11,0.11,418,31877,70,NULL,NULL,'2MASX J11215881+5337043',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000145,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,170.4952083,53.61769,0,NULL,61791320925,965489389,15085771,18.2),(80261,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80261,38.55,0.33,512,31878,70,NULL,NULL,'2MASX J11215890+3351587',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000176,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,170.49525,33.86631,0.046,NULL,60644743580,947574118,14805845,18.4),(80262,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80262,38.02,0.46,403,31879,70,NULL,NULL,'2MASX J11215889+1924411',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,170.495417,19.41142,0,NULL,61122133868,955033341,14922395,NULL),(80263,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80263,38.24,0.33,445,31880,70,NULL,NULL,'2MASX J11220037+4352388',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000196,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,170.5015,43.8775,0,NULL,63944143704,999127245,15611363,16.7),(80264,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80264,37.89,0.46,378,31881,70,NULL,NULL,'2MASX J11220173+3344247',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000143,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,170.507083,33.74008,0.046,NULL,60644917078,947576829,14805887,17.9),(80265,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80265,33.34,0.2,46.6,31882,74.4,NULL,NULL,'UGC 06383',NULL,'2013AJ....146...86T',2013,1,1.52,NULL,'G',0.000116,NULL,'15.0g',0.32,'Sd','Isolated galaxy',NULL,NULL,NULL,1,170.510875,42.81925,0.02,NULL,63946176244,999159003,15611859,15),(80266,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80266,34.18,0.49,68.5,31882,75,NULL,'IR','UGC 06383',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80267,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80267,37.95,0.33,389,31883,70,NULL,NULL,'2MASX J11220266+3739118',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,170.511125,37.65333,0,NULL,60427654840,944182106,14752845,17.6),(80268,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80268,36.34,0.2,185,31884,74.4,NULL,NULL,'CGCG 185-046',NULL,'2013AJ....146...86T',2013,1,0.93,NULL,'G',0.000083,NULL,'14.9g',0.51,NULL,'Group member',NULL,NULL,NULL,1,170.512917,34.31481,0.048,NULL,60645091557,947579555,14805930,14.9),(80269,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80269,38.4,0.46,478,31885,70,NULL,NULL,'2MASX J11220325+2318440',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,170.5135417,23.31219,0,NULL,61095482682,954616916,14915889,NULL),(80270,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80270,36.96,0.46,246,31886,70,NULL,NULL,'2MASX J11220380+0056528',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000087,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,170.515917,0.94806,0.101,NULL,60167249281,940113270,14689269,16.4),(80271,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80271,38.02,0.13,402,31887,70,NULL,NULL,'2MASX J11220540+0047039',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000099,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,170.522583,0.78428,0.101,NULL,60167260845,940113450,14689272,16.9),(80272,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80272,37.76,0.21,356,31888,70,NULL,NULL,'IC 0685',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00067,NULL,'17.56',0.21,NULL,NULL,NULL,NULL,NULL,1,170.527167,17.75342,0,NULL,61120699751,955010933,14922045,17.56),(80273,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80273,31.42,NULL,19.2,31889,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06378',NULL,'2010Ap&SS.325..163P',2010,1,2.65,NULL,'G',0.000013,NULL,'14.66',0.35,'Sd',NULL,NULL,NULL,NULL,1,170.52875,69.63417,0.005,NULL,62090466277,970163535,15158805,14.66),(80274,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80274,31.45,NULL,19.5,31889,NULL,NULL,'Dipole + Quadrupole','UGC 06378',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80275,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80275,31.46,NULL,19.6,31889,NULL,NULL,'Dipole','UGC 06378',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80276,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80276,31.52,0.43,20.2,31889,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06378',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80277,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80277,31.62,0.43,21.1,31889,75,NULL,'3.6 micron, color corrected','UGC 06378',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80278,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80278,31.66,0.2,21.5,31889,74.4,NULL,NULL,'UGC 06378',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80279,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80279,31.78,0.4,22.7,31889,75,NULL,NULL,'UGC 06378',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80280,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80280,31.82,0.4,23.1,31889,NULL,NULL,NULL,'UGC 06378',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80281,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80281,31.88,0.6,23.8,31889,NULL,NULL,NULL,'UGC 06378',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80282,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80282,31.97,0.58,24.8,31889,NULL,NULL,'Malmquist cor.','UGC 06378',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80283,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80283,32.24,0.49,28,31889,75,NULL,'IR','UGC 06378',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80284,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80284,35.84,0.21,147,31890,70,NULL,NULL,'IC 2751',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000036,NULL,'15.4g',0.52,NULL,'Group member',NULL,NULL,NULL,1,170.5307917,34.36636,0.048,NULL,60645097843,947579653,14805932,15.4),(80285,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80285,36.11,0.25,167,31890,74.4,NULL,NULL,'IC 2751',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80286,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80286,35.86,0.34,148,31890,NULL,NULL,'Malmquist cor.','IC 2751',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80287,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80287,36.3,0.28,182,31890,NULL,NULL,NULL,'IC 2751',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80288,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80288,37.05,0.46,257,31891,70,NULL,NULL,'2MASX J11220749+5622534',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000168,NULL,'16.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,170.531125,56.38144,0,NULL,61986182189,968534096,15133345,16.4),(80289,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80289,37.02,0.46,254,31892,70,NULL,NULL,'2MASX J11220754+1836080',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,170.531375,18.60236,0,NULL,61120750914,955011733,14922058,17.6),(80290,'IRAS','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80290,32.92,0.8,38.4,31893,75,NULL,'MAT, I','ESO 319- G 016',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'16',0.8,'SAB(rs)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,170.532333333,-38.06581,0.525,NULL,41380171796,646565184,10102581,16),(80291,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80291,32.2,0.32,27.5,31893,85,NULL,'I, inv','ESO 319- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80292,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80292,32.2,0.32,27.6,31893,85,NULL,'I, raw','ESO 319- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80293,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80293,32.63,0.43,33.5,31893,75,NULL,'MAT, I, raw','ESO 319- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80294,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80294,32.66,0.43,34,31893,75,NULL,'MAT, I, inv','ESO 319- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80295,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80295,32.83,0.43,36.8,31893,75,NULL,'MAT, I, cor','ESO 319- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80296,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80296,33.39,0.1,47.7,31893,NULL,NULL,NULL,'ESO 319- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80297,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80297,34.79,0.2,90.8,31893,74.4,NULL,NULL,'ESO 319- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80298,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80298,34.87,0.43,94,31893,75,NULL,'3.6 micron, color corrected','ESO 319- G 016',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80299,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80299,35.02,0.43,101,31893,75,NULL,'3.6 micron, color + selection bias corrected','ESO 319- G 016',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80300,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80300,36.94,0.46,244,31894,70,NULL,NULL,'2MASX J11220781+1639263',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.78',0.16,NULL,NULL,NULL,NULL,NULL,1,170.532583333,16.65731,0,NULL,61115369158,954927643,14920744,17.78),(80301,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80301,38.14,0.12,425,31895,70,NULL,NULL,'2MASX J11220817+1939220',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'18.40',0.1,NULL,NULL,NULL,NULL,NULL,1,170.534125,19.65606,0,NULL,61122087001,955032609,14922384,18.4),(80302,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80302,37.09,0.46,262,31896,70,NULL,NULL,'2MASX J11220923+5939294',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000178,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,170.538333,59.65819,0,NULL,61849513681,966398651,15099978,16.5),(80303,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80303,38.44,0.46,488,31897,70,NULL,NULL,'2MASX J11221010+1755450',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,170.5422917,17.92911,0,NULL,61120571388,955008927,14922014,18),(80304,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80304,38.7,0.46,551,31898,70,NULL,NULL,'2MASX J11221166+4947421',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000181,NULL,'17.6g',NULL,NULL,NULL,NULL,NULL,NULL,1,170.548375,49.79494,0,NULL,61795282885,965551295,15086738,17.6),(80305,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80305,37.14,0.46,267,31899,70,NULL,NULL,'2MASX J11221237+3634228',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,170.551625,36.57303,0.022,NULL,60427900339,944185942,14752905,17.6),(80306,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80306,36.93,0.46,243,31900,70,NULL,NULL,'2MASX J11221250+4357208',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,170.552083,43.95581,0,NULL,63944140465,999127194,15611362,17.3),(80307,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80307,37.69,0.27,345,31901,70,NULL,NULL,'2MASX J11221253+5457474',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000169,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,170.5522917,54.96319,0,NULL,61984354895,968505545,15132899,17.2),(80308,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80308,37.92,0.46,384,31902,70,NULL,NULL,'SDSS J112212.71+073239.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000135,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,170.5529583,7.54436,0.137,NULL,60392126442,943626975,14744171,18.2),(80309,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80309,36.73,0.27,222,31903,70,NULL,NULL,'2MASX J11221267+5934264',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000182,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,170.5529583,59.57408,0,NULL,61849508918,966398576,15099977,16.3),(80310,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80310,37.95,0.46,389,31904,70,NULL,NULL,'2MASX J11221301+4525498',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000138,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,170.554125,45.43047,0,NULL,63949325592,999208212,15612628,17.7),(80311,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80311,38.43,0.46,485,31905,70,NULL,NULL,'2MASX J11221526+2615567',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000179,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,170.563583,26.26586,0,NULL,60579524142,946555064,14789922,17.7),(80312,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80312,36.95,0.19,245,31906,70,NULL,NULL,'VII Zw 392',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000128,NULL,'15.8g',0.47,'NLAGN',NULL,NULL,NULL,NULL,1,170.564167,67.22183,0,NULL,62085256214,970082128,15157533,15.8),(80313,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80313,37.66,0.46,340,31907,70,NULL,NULL,'SDSS J112215.44+121318.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000152,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,170.564375,12.22183,0.07,NULL,60214819987,940856562,14700883,18.5),(80314,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80314,37.36,0.46,296,31908,70,NULL,NULL,'SDSS J112216.02-005136.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000079,NULL,'18.1g',0.11,'NLAGN',NULL,NULL,NULL,NULL,1,170.56675,-0.86011,0.105,NULL,40823124858,637861325,9966583,18.1),(80315,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80315,38.02,0.13,402,31909,70,NULL,NULL,'2MASX J11221621+0029559',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000082,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,170.5675417,0.49894,0.101,NULL,60166877601,940107462,14689179,17.6),(80316,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80316,38.18,0.16,432,31910,70,NULL,NULL,'SDSS J112216.66+375924.2',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000184,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,170.5694583,37.99008,0.023,NULL,60426318703,944161229,14752519,16.9),(80317,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80317,36.8,0.12,229,31911,70,NULL,NULL,'2MASX J11221719+0239299',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000163,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,170.5715417,2.65831,0.113,NULL,60349126372,942955099,14733673,16.6),(80318,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80318,36.91,0.46,241,31912,70,NULL,NULL,'2MASX J11221726+2813477',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00018,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,170.571916667,28.23008,0,NULL,60607515733,946992433,14796756,16.6),(80319,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80319,36.97,0.46,247,31913,70,NULL,NULL,'2MASX J11221740+2316384',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.70',0.17,NULL,NULL,NULL,NULL,NULL,1,170.572583,23.27731,0,NULL,61095446925,954616358,14915880,17.7),(80320,'Tully est','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80320,32.2,0.8,27.5,31914,75,NULL,'B','NGC 3642',NULL,'1988NBGC.C....0000T',1988,1,1.76,NULL,'G',0.00003,NULL,'12.6g',1.53,'SA(r)bc:;LINER Sy3','in a radial-velocity based grouping',NULL,NULL,'LINER b',1,170.5745417,59.07453,0,NULL,61982890510,968482664,15132541,12.6),(80321,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,NULL,80321,34.17,0.2,68.2,31915,74.4,NULL,NULL,'IC 2762',NULL,'2013AJ....146...86T',2013,1,0.85,NULL,'G',0.000157,NULL,'16.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,170.574667,12.72253,0.042,NULL,60216691787,940885809,14701340,16),(80322,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80322,38.07,0.46,410,31916,70,NULL,NULL,'SDSS J112218.05+214935.3',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.6g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,170.57525,21.8265,0,NULL,61097102075,954642219,14916284,18.6),(80323,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80323,37.71,0.46,349,31917,70,NULL,NULL,'2MASX J11221818+1240273',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000097,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,170.5757917,12.67433,0.03,NULL,60216660288,940885317,14701333,16.8),(80324,'FP','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80324,37.72,0.46,349,31918,70,NULL,NULL,'2MASX J11221853+6303347',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,170.57725,63.05958,0,NULL,61873944635,966780384,15105943,17.7),(80325,'Tully-Fisher','2016-12-15 15:14:46','2016-12-16 11:19:55','1',NULL,'R',80325,31.11,0.4,16.7,31919,75,NULL,NULL,'IC 2763',NULL,'2008Ap.....51..336K',2008,1,1.65,NULL,'G',0.000007,NULL,'15.0g',0.32,NULL,NULL,NULL,NULL,NULL,1,170.577333,13.06506,0.032,NULL,60216369852,940880778,14701262,15),(80326,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80326,31.69,0.49,21.7,31919,75,NULL,'IR','IC 2763',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80327,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80327,31.97,NULL,24.8,31919,NULL,NULL,NULL,'IC 2763',NULL,'2015AstBu..70....1K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80328,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80328,36.85,0.21,235,31920,70,NULL,NULL,'2MASX J11221916+4050368',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000164,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,170.5799583,40.84361,0,NULL,63925840701,998841260,15606894,16.4),(80329,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80329,37.54,0.46,323,31921,70,NULL,NULL,'2MASX J11222033+3634088',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,170.58475,36.56919,0.022,NULL,60427899943,944185936,14752905,17.6),(80330,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80330,38.18,0.16,432,31922,70,NULL,NULL,'SDSS J112220.80+375700.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000155,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,170.5867083,37.95022,0,NULL,60426316970,944161202,14752518,18.5),(80331,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80331,36.21,0.46,174,31923,70,NULL,NULL,'CGCG 242-026',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.00018,NULL,'15.2g',0.61,'E0',NULL,NULL,NULL,NULL,1,170.588125,46.4305,0,NULL,63948950048,999202344,15612536,15.2),(80332,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80332,37.41,0.33,304,31924,70,NULL,NULL,'2MASX J11222159+4642587',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000196,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,170.589875,46.71644,0,NULL,63949809887,999215779,15612746,16.7),(80333,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80333,38.63,0.46,533,31925,70,NULL,NULL,'2MASX J11222194+0545259',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,170.591375,5.75703,0.121,NULL,60391238331,943613098,14743954,18),(80334,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80334,38.02,0.13,402,31926,70,NULL,NULL,'2MASX J11222220+0041269',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000084,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,170.592583333,0.69075,0.093,NULL,60166858632,940107166,14689174,17.5),(80335,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80335,37.86,0.46,374,31927,70,NULL,NULL,'2MASX J11222259+4356137',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000143,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,170.593916667,43.937,0,NULL,63944139096,999127173,15611362,18),(80336,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80336,37.51,0.46,317,31928,70,NULL,NULL,'IC 2765',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000173,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,170.596333,14.19906,0.072,NULL,61103905186,954748518,14917945,17.1),(80337,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80337,37.67,0.46,342,31929,70,NULL,NULL,'2MASX J11222334+0707554',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,170.597333,7.13211,0.153,NULL,60393131660,943642682,14744416,17.6),(80338,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80338,32.3,NULL,28.8,31930,NULL,NULL,NULL,'SDSS J112223.40+114738.1',NULL,'2015AstBu..70....1K',2015,1,0.3,NULL,'G',0.000102,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,170.5975417,11.79392,0.101,NULL,60215373387,940865209,14701018,17.4),(80339,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80339,38.02,0.13,402,31931,70,NULL,NULL,'2MASX J11222494+0023589',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000072,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,170.603833,0.39981,0.101,NULL,60164832354,940075505,14688679,17.6),(80340,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80340,35.84,0.21,147,31932,70,NULL,NULL,'2MASX J11222603+3421257',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,170.6085417,34.35708,0.045,NULL,60645111771,947579871,14805935,17),(80341,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80341,37.04,0.46,256,31933,70,NULL,NULL,'2MASX J11222681+1935495',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.26',0.14,NULL,NULL,NULL,NULL,NULL,1,170.611625,19.59706,0,NULL,61133482448,955210663,14925166,18.26),(80342,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80342,38.14,0.12,425,31934,70,NULL,NULL,'2MASXi J1122272+194441',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,170.6134583,19.74494,0,NULL,61133948908,955217951,14925280,17.9),(80343,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80343,37.66,0.46,340,31935,70,NULL,NULL,'2MASX J11222753+2750107',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000177,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,170.614875,27.83628,0,NULL,60607562201,946993159,14796768,16.7),(80344,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80344,38.18,0.16,432,31936,70,NULL,NULL,'2MASX J11222815+3757348',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.09',0.19,NULL,NULL,NULL,NULL,NULL,1,170.6172083,37.95975,0.023,NULL,60426315707,944161182,14752518,18.09),(80345,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80345,36.95,0.8,245,31937,70,NULL,NULL,'2MASX J11222832-0742090',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00012,NULL,'17.31',0.29,NULL,NULL,NULL,NULL,NULL,1,170.618083,-7.70244,0.085,NULL,41059684568,641557571,10024337,17.31),(80346,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80346,36.6,0.46,209,31938,70,NULL,NULL,'2MASX J11222837+4127028',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000184,NULL,'16.0g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,170.618417,41.45075,0,NULL,63942862821,999107231,15611050,16),(80347,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80347,38.18,0.16,432,31939,70,NULL,NULL,'2MASX J11222973+3758140',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,170.623833333,37.97044,0.023,NULL,60426319691,944161245,14752519,17.9),(80348,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80348,37.71,0.46,348,31940,70,NULL,NULL,'2MASX J11222987+0146539',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000159,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,170.6245,1.78181,0.093,NULL,60165610993,940087671,14688869,17.7),(80349,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80349,35.21,0.46,110,31941,70,NULL,NULL,'NGC 3653',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000067,NULL,'14.59',0.6,'S0','Group member',NULL,NULL,NULL,1,170.6252917,24.27928,0,NULL,60580521505,946570648,14790166,14.59),(80350,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80350,37.12,0.46,266,31942,70,NULL,NULL,'2MASX J11223024+4315048',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000181,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,170.6260417,43.25133,0.024,NULL,63944054018,999125844,15611341,17.5),(80351,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80351,37.35,0.12,295,31943,70,NULL,NULL,'2MASX J11223064+0107198',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000071,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,170.62775,1.12206,0.101,NULL,60167189146,940112330,14689255,17.6),(80352,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80352,38.11,0.46,420,31944,70,NULL,NULL,'2MASX J11223084+0102108',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000062,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,170.628625,1.03628,0.101,NULL,60167250565,940113290,14689270,18),(80353,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80353,37.47,0.46,312,31945,70,NULL,NULL,'2MASX J11223136+6144597',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00014,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,170.6307917,61.74994,0,NULL,61859014431,966547100,15102298,17.9),(80354,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80354,35.27,0.46,113,31946,70,NULL,NULL,'CGCG 268-026',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000077,NULL,'14.8g',0.7,'E0',NULL,NULL,NULL,NULL,1,170.634166667,51.53314,0,NULL,61796813757,965575214,15087112,14.8),(80355,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80355,36.85,0.21,235,31947,70,NULL,NULL,'2MASX J11223252+4049121',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,170.635625,40.82025,0,NULL,63925785672,998840401,15606881,17),(80356,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80356,38.02,0.13,402,31948,70,NULL,NULL,'2MASX J11223264+0051078',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000059,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,170.635916667,0.85214,0.093,NULL,60167262952,940113483,14689273,17.9),(80357,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80357,36.23,0.33,176,31949,70,NULL,NULL,'2MASX J11223264+6645210',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000076,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,170.636167,66.75597,0,NULL,62085321899,970083154,15157549,16.2),(80358,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80358,38.69,0.46,546,31950,70,NULL,NULL,'2MASX J11223281+0610014',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000169,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,170.636875,6.16722,0.137,NULL,60391331099,943614548,14743977,18.1),(80359,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80359,38.24,0.33,445,31951,70,NULL,NULL,'SDSS J112233.02+435401.4',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,170.637583333,43.90039,0,NULL,63944184822,999127887,15611373,18.1),(80360,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80360,37.35,0.12,295,31952,70,NULL,NULL,'2MASX J11223310+0107318',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000193,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,170.638,1.12558,0.101,NULL,60167189086,940112329,14689255,17.6),(80361,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80361,36.18,0.46,172,31953,70,NULL,NULL,'VII Zw 395',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000177,NULL,'16.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,170.639167,56.83311,0,NULL,61986151780,968533621,15133337,16.1),(80362,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80362,37,0.46,251,31954,70,NULL,NULL,'2MASX J11223345+4101231',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000179,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,170.63925,41.02311,0,NULL,63942810773,999106418,15611037,16.6),(80363,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80363,37.69,0.46,345,31955,70,NULL,NULL,'SDSS J112233.81+274431.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000146,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,170.640917,27.74208,0,NULL,60605938321,946967786,14796371,18.6),(80364,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80364,37.29,0.46,287,31956,70,NULL,NULL,'2MASX J11223391+0909017',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,170.641375,9.1505,0.096,NULL,60344298624,942879666,14732494,17.5),(80365,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80365,36.8,0.12,229,31957,70,NULL,NULL,'SDSS J112235.04+025302.7',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,170.6460417,2.88408,0.089,NULL,60362969858,943171404,14737053,17.5),(80366,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80366,38.34,0.46,466,31958,70,NULL,NULL,'2MASX J11223513+3840241',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000143,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,170.6464583,38.67328,0,NULL,60427176638,944174634,14752728,18),(80367,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80367,35.89,0.44,151,31959,NULL,NULL,'Malmquist cor.','2MASX J11223592+3423364',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000023,NULL,'16.1g',0.32,'Sb',NULL,NULL,NULL,NULL,1,170.6495417,34.39347,0.045,NULL,60645075143,947579299,14805926,16.1),(80368,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80368,36.05,0.41,162,31959,NULL,NULL,NULL,'2MASX J11223592+3423364',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80369,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80369,36.09,0.2,165,31959,74.4,NULL,NULL,'2MASX J11223592+3423364',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80370,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80370,36.65,0.27,214,31960,70,NULL,NULL,'2MASX J11223676+5558173',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000195,NULL,'15.6g',0.45,'E0',NULL,NULL,NULL,NULL,1,170.653083,55.97136,NULL,NULL,61987511360,968554865,15133669,15.6),(80371,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80371,38.02,0.13,402,31961,70,NULL,NULL,'2MASX J11223678+0027378',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000079,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,170.653208333,0.46056,0.101,NULL,60164827782,940075434,14688678,17.6),(80372,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80372,36.95,0.19,245,31962,70,NULL,NULL,'VII Zw 394',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000098,NULL,'16.7g',0.28,'AGN',NULL,NULL,NULL,NULL,1,170.653667,67.1715,0,NULL,62085267387,970082302,15157535,16.7),(80373,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80373,36.85,0.21,235,31963,70,NULL,NULL,'2MASX J11223746+4046591',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000191,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,170.6560417,40.78325,0,NULL,63925791358,998840489,15606882,16.6),(80374,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80374,37.95,0.33,389,31964,70,NULL,NULL,'2MASX J11223789+3736361',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,170.657833,37.61008,0,NULL,60427642289,944181910,14752842,18.1),(80375,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80375,36.73,0.27,222,31965,70,NULL,NULL,'2MASX J11223804+5918553',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000194,NULL,'15.7g',0.45,'BrClG',NULL,NULL,NULL,NULL,1,170.6582917,59.31539,0,NULL,61982663559,968479118,15132486,15.7),(80376,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80376,37.56,0.46,325,31966,70,NULL,NULL,'2MASX J11223810-0017279',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000061,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,170.6587083,-0.29108,0.113,NULL,40821579334,637837177,9966205,17.8),(80377,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80377,37.41,0.33,304,31967,70,NULL,NULL,'2MASX J11223854+4649219',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,170.66075,46.82264,0,NULL,63949831695,999216120,15612751,18.1),(80378,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80378,38.14,0.12,425,31968,70,NULL,NULL,'2MASX J11223878+1938464',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,170.661625,19.64617,0,NULL,61133432932,955209889,14925154,17.4),(80379,'Tully est','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80379,32.62,0.8,33.5,31969,75,NULL,'B','NGC 3652',NULL,'1988NBGC.C....0000T',1988,1,2.26,NULL,'G',0.000013,NULL,'13.1g',0.75,'SBc','in a radial-velocity based grouping',NULL,NULL,NULL,1,170.662625,37.76511,0,NULL,60425792451,944153007,14752390,13.1),(80380,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80380,31.81,0.44,23,31969,NULL,NULL,'Malmquist cor.','NGC 3652',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80381,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80381,31.85,0.43,23.5,31969,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3652',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80382,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80382,31.87,0.43,23.7,31969,75,NULL,'3.6 micron, color corrected','NGC 3652',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80383,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80383,31.93,0.2,24.3,31969,74.4,NULL,NULL,'NGC 3652',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80384,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80384,32.16,0.37,27.1,31969,NULL,NULL,NULL,'NGC 3652',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80385,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80385,32.68,0.4,34.4,31969,NULL,NULL,'mean','NGC 3652',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80386,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80386,32.9,0.47,38,31969,NULL,NULL,'H','NGC 3652',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80387,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80387,32.99,0.46,39.6,31969,NULL,NULL,'J','NGC 3652',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80388,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80388,33.08,0.45,41.3,31969,NULL,NULL,'K','NGC 3652',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80389,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80389,37.76,0.23,356,31970,70,NULL,NULL,'IC 2775',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,170.664833333,12.512,0.03,NULL,60216726059,940886344,14701349,17.6),(80390,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80390,36.37,0.46,188,31971,70,NULL,NULL,'2MASX J11223984+4045291',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000164,NULL,'16.2g',0.42,NULL,NULL,NULL,NULL,NULL,1,170.665875,40.75814,0,NULL,63925791858,998840497,15606882,16.2),(80391,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80391,36.92,0.27,243,31972,70,NULL,NULL,'2MASX J11224028+5815532',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000205,NULL,'16.0g',0.4,'E0',NULL,NULL,NULL,NULL,1,170.66775,58.26489,0,NULL,61982602701,968478167,15132471,16),(80392,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80392,37.66,0.46,340,31973,70,NULL,NULL,'2MASX J11224122+0228518',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,170.67175,2.48119,0.097,NULL,60349682403,942963787,14733809,17.4),(80393,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80393,37.35,0.12,295,31974,70,NULL,NULL,'SDSS J112241.37+010508.0',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000143,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,170.672375,1.08558,0.101,NULL,60167209794,940112653,14689260,18.6),(80394,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80394,37.35,0.12,295,31975,70,NULL,NULL,'2MASX J11224145+0039068',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.0001,NULL,'16.6g',0.28,'AGN',NULL,NULL,NULL,NULL,1,170.672666667,0.65175,0.085,NULL,60166891998,940107687,14689182,16.6),(80395,'IRAS','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80395,33.73,0.8,55.6,31976,75,NULL,'HMCL, I','ESO 377- G 040',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'16.42',0.7,'Sb-c',NULL,NULL,NULL,NULL,1,170.6727083,-36.72119,0.409,NULL,41385699508,646651554,10103930,16.42),(80396,'IRAS','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80396,33.73,0.8,55.6,31976,75,NULL,'A82, H','ESO 377- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80397,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80397,34.33,0.4,73.5,31976,75,NULL,'HMCL, I, raw','ESO 377- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80398,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80398,34.35,0.4,74.2,31976,75,NULL,'HMCL, I, inv','ESO 377- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80399,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80399,34.53,0.4,80.4,31976,75,NULL,'HMCL, I, cor','ESO 377- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80400,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80400,34.77,0.47,89.8,31976,75,NULL,'A82, H, inv','ESO 377- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80401,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80401,34.8,0.72,91.2,31976,NULL,NULL,NULL,'ESO 377- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80402,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80402,34.83,0.47,92.6,31976,75,NULL,'A82, H, raw','ESO 377- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80403,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80403,34.84,0.2,92.9,31976,74.4,NULL,NULL,'ESO 377- G 040',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80404,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80404,35.01,0.65,101,31976,NULL,NULL,'Malmquist cor.','ESO 377- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80405,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80405,35.27,0.47,113,31976,75,NULL,'A82, H, cor','ESO 377- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80406,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80406,32.13,0.2,26.7,31977,74.4,NULL,NULL,'UGC 06390',NULL,'2013AJ....146...86T',2013,1,2.1,NULL,'G',0.00001,NULL,'14.68',0.3,'Scd(f)',NULL,NULL,NULL,NULL,1,170.673625,64.06658,0.013,NULL,61868968794,966702637,15104728,14.68),(80407,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80407,32.17,0.4,27.2,31977,NULL,NULL,NULL,'UGC 06390',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80408,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80408,32.22,0.43,27.9,31977,75,NULL,'3.6 micron, color corrected','UGC 06390',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80409,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80409,32.24,0.43,28.1,31977,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06390',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80410,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80410,32.28,0.49,28.6,31977,75,NULL,'IR','UGC 06390',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80411,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80411,32.28,0.64,28.6,31977,NULL,NULL,NULL,'UGC 06390',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80412,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80412,32.38,0.61,29.9,31977,NULL,NULL,'Malmquist cor.','UGC 06390',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80413,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80413,37.57,0.46,326,31978,70,NULL,NULL,'SDSS J112242.53+094856.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000124,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,170.67725,9.81561,0.09,NULL,60347211562,942925180,14733205,18.2),(80414,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80414,37.76,0.23,356,31979,70,NULL,NULL,'SDSS J112242.57+122910.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,170.677416667,12.48633,0.064,NULL,60216728272,940886379,14701349,18.1),(80415,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80415,38.02,0.13,402,31980,70,NULL,NULL,'SDSS J112242.71+004207.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000075,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,170.6779583,0.70206,0.093,NULL,60166836274,940106816,14689169,18.4),(80416,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80416,37.77,0.46,357,31981,70,NULL,NULL,'2MASX J11224285+2451488',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.82',0.19,NULL,NULL,NULL,NULL,NULL,1,170.678625,24.86375,0,NULL,60581097152,946579643,14790306,17.82),(80417,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80417,34.29,0.35,72.2,31982,NULL,NULL,NULL,'ESO 265- G 028',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.27',0.5,'Sb',NULL,NULL,NULL,NULL,1,170.6807917,-43.9995,0.349,NULL,41936936765,655264636,10238509,15.27),(80418,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80418,34.33,0.2,73.5,31982,74.4,NULL,NULL,'ESO 265- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80419,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80419,34.34,0.34,73.8,31982,NULL,NULL,'Malmquist cor.','ESO 265- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80420,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80420,37.35,0.12,295,31983,70,NULL,NULL,'2MASX J11224378+0039028',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000071,NULL,'17.1g',0.23,'AGN',NULL,NULL,NULL,NULL,1,170.682208333,0.65072,0.085,NULL,60166837845,940106841,14689169,17.1),(80421,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80421,38.02,0.13,402,31984,70,NULL,NULL,'SDSS J112243.97+003232.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000067,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,170.68325,0.54222,0.085,NULL,60166840552,940106883,14689170,18.4),(80422,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80422,37.35,0.12,295,31985,70,NULL,NULL,'2MASX J11224411+0045218',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000076,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,170.68375,0.75608,0.093,NULL,60167150899,940111732,14689245,17.3),(80423,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80423,37.35,0.12,295,31986,70,NULL,NULL,'2MASX J11224417+0053038',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000078,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,170.684041667,0.88442,0.093,NULL,60167114848,940111169,14689237,16.6),(80424,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80424,37.36,0.46,296,31987,70,NULL,NULL,'2MASX J11224484-0020230',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000088,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,170.6869583,-0.33978,0.113,NULL,40821530790,637836418,9966194,17.3),(80425,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80425,36.92,0.27,243,31988,70,NULL,NULL,'2MASX J11225006+5815181',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000189,NULL,'16.1g',0.32,'E0',NULL,NULL,NULL,NULL,1,170.708833,58.25506,0,NULL,61982604513,968478195,15132471,16.1),(80426,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80426,38.02,0.13,402,31989,70,NULL,NULL,'SDSS J112250.60+003042.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000065,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,170.710833,0.51169,0.085,NULL,60164861389,940075959,14688686,18.8),(80427,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80427,32.2,NULL,27.6,31990,NULL,NULL,NULL,'IC 2781',NULL,'2015AstBu..70....1K',2015,1,0.38,NULL,'G',0.00012,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,170.711125,12.34489,0.064,NULL,60214842506,940856914,14700889,16.6),(80428,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80428,36.57,0.27,206,31991,70,NULL,NULL,'2MASX J11225125+5107463',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000186,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,170.713375,51.12953,0,NULL,61797744004,965589750,15087339,16.4),(80429,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80429,38.14,0.12,425,31992,70,NULL,NULL,'SDSS J112252.11+194758.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,170.717125,19.79967,0,NULL,61133952244,955218003,14925281,18.4),(80430,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80430,35.65,0.33,135,31993,70,NULL,NULL,'CGCG 156-068',NULL,'2015arXiv151105856S',2015,1,0.87,NULL,'G',0.000073,NULL,'14.9g',0.67,NULL,NULL,NULL,NULL,NULL,1,170.7202083,27.58381,0,NULL,60605945308,946967895,14796373,14.9),(80431,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80431,37.22,0.33,277,31994,70,NULL,NULL,'SDSS J112253.69+072022.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000125,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,170.723708333,7.33956,0.153,NULL,60392527084,943633235,14744269,17.7),(80432,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80432,36.67,0.46,216,31995,70,NULL,NULL,'2MASX J11225416+6119235',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000192,NULL,'16.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,170.725417,61.32328,0,NULL,61859360893,966552513,15102383,16.3),(80433,'BCG','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80433,38.01,0.35,373,31996,60,NULL,'ABELL 1238, BCG','2MASX J11225431+0106518',0.0716,'1980ApJ...241..486H',1980,1,0.66,NULL,'G',NULL,NULL,'16.78',0.56,'E','Brightest group member',NULL,'radio jet',NULL,1,170.726375,1.11442,0.101,NULL,60167203295,940112551,14689258,16.78),(80434,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80434,38.14,0.12,425,31997,70,NULL,NULL,'2MASX J11225454+1933028',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.74',0.12,NULL,NULL,NULL,NULL,NULL,1,170.72725,19.55094,0,NULL,61133475586,955210556,14925164,18.74),(80435,'Sosies','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80435,31.9,0.25,24,31998,NULL,NULL,NULL,'NGC 3655',NULL,'2002A&A...393...57T',2002,1,1.5,'Multiple SDSS entries describe this object.','G',0.00002,NULL,'12.30',1,'SA(s)c:        HII','X-ray-bright group member',NULL,NULL,NULL,1,170.727583,16.59003,0,NULL,61116062224,954938472,14920913,12.3),(80436,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80436,30.59,0.69,13.1,31998,100,NULL,'mid-IR','NGC 3655',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80437,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80437,32.11,0.4,26.5,31998,75,NULL,'B','NGC 3655',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80438,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80438,32.24,0.4,28.1,31998,NULL,NULL,'mean','NGC 3655',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80439,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80439,32.4,0.45,30.2,31998,NULL,NULL,'K','NGC 3655',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80440,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80440,32.4,0.91,30.3,31998,NULL,NULL,'Malmquist cor.','NGC 3655',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80441,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80441,32.42,0.47,30.5,31998,NULL,NULL,'H','NGC 3655',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80442,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80442,32.46,0.46,31,31998,NULL,NULL,'J','NGC 3655',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80443,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80443,32.56,0.43,32.5,31998,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3655',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80444,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80444,32.75,0.43,35.5,31998,75,NULL,'3.6 micron, color corrected','NGC 3655',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80445,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80445,32.92,0.2,38.4,31998,74.4,NULL,NULL,'NGC 3655',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80446,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80446,32.94,0.3,38.8,31998,55,NULL,'B','NGC 3655',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80447,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80447,32.95,0.71,38.9,31998,NULL,NULL,NULL,'NGC 3655',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80448,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80448,36.1,0.44,166,31999,NULL,NULL,'Malmquist cor.','2MASX J11225464+3403335',NULL,'2009ApJS..182..474S',2009,1,0.3,NULL,'G',0.000162,NULL,'16.93',0.2,'Sab',NULL,NULL,NULL,NULL,1,170.727833,34.05925,0.047,NULL,60644732136,947573939,14805842,16.93),(80449,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80449,36.26,0.41,179,31999,NULL,NULL,NULL,'2MASX J11225464+3403335',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80450,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80450,36.3,0.2,182,31999,74.4,NULL,NULL,'2MASX J11225464+3403335',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80451,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80451,36.88,0.46,238,32000,70,NULL,NULL,'2MASX J11225491-0012080',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000068,NULL,'16.9g',0.33,NULL,NULL,NULL,NULL,NULL,1,170.728625,-0.20219,0.105,NULL,40821501702,637835964,9966186,16.9),(80452,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80452,36.44,0.19,194,32001,70,NULL,NULL,'2MASX J11225503+3348505',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,170.7294583,33.81403,0.046,NULL,60644888575,947576383,14805880,16.7),(80453,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80453,38.19,0.46,435,32002,70,NULL,NULL,'2MASX J11225507+0650207',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,170.729583,6.83919,0.169,NULL,60392934024,943639594,14744368,17.4),(80454,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80454,37.77,0.46,358,32003,70,NULL,NULL,'2MASX J11225519+0810307',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000128,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,170.7300417,8.17517,0.121,NULL,60336286163,942754471,14730538,17.6),(80455,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80455,36.56,0.46,205,32004,70,NULL,NULL,'2MASX J11225525+2739128',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000159,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,170.730167,27.65361,0,NULL,60605986565,946968540,14796383,16.9),(80456,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80456,37.6,0.46,331,32005,70,NULL,NULL,'2MASX J11225536+2654358',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,170.730667,26.91014,0,NULL,60576099843,946501560,14789086,17.1),(80457,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80457,36.92,0.27,243,32006,70,NULL,NULL,'2MASX J11225574+5817582',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000175,NULL,'16.3g',0.4,NULL,NULL,NULL,NULL,NULL,1,170.73225,58.29953,0,NULL,61982601287,968478145,15132471,16.3),(80458,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80458,37.22,0.33,277,32007,70,NULL,NULL,'2MASX J11225581+0721507',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000154,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,170.732625,7.36417,0.153,NULL,60392534632,943633353,14744271,16.9),(80459,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80459,36.44,0.19,194,32008,70,NULL,NULL,'UGC 06394',NULL,'2015arXiv151105856S',2015,1,1.04,NULL,'G',0.000039,NULL,'14.5g',0.84,'E:;cD',NULL,NULL,NULL,NULL,1,170.735375,34.11144,0.047,NULL,60644723311,947573801,14805840,14.5),(80460,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80460,37.35,0.12,295,32009,70,NULL,NULL,'2MASX J11225657+0107558',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000084,NULL,'16.7g',0.26,'S0/Sa',NULL,NULL,NULL,NULL,1,170.735833,1.13228,0.101,NULL,60167210120,940112658,14689260,16.7),(80461,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80461,36.65,0.27,214,32010,70,NULL,NULL,'2MASX J11225707+5600112',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,170.737667,56.00311,0,NULL,61987537722,968555276,15133676,17.2),(80462,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80462,36.57,0.27,206,32011,70,NULL,NULL,'2MASX J11225781+5115333',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00009,NULL,'16.0g',0.31,'S0',NULL,NULL,NULL,NULL,1,170.7407917,51.25939,0,NULL,61796977900,965577779,15087152,16),(80463,'BCG','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80463,38.01,0.35,373,32012,60,NULL,NULL,'ABELL 1238',0.0716,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,170.741625,1.09214,0.101,NULL,60167203989,940112562,14689258,NULL),(80464,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80464,37.35,0.12,295,32013,70,NULL,NULL,'2MASX J11225839+0104119',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00007,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,170.74325,1.07008,0.101,NULL,60167202655,940112541,14689258,18),(80465,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80465,37.73,0.46,352,32014,70,NULL,NULL,'2MASX J11225846+4421228',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,170.74375,44.35628,0.007,NULL,63950703835,999229747,15612964,17.4),(80466,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80466,35.04,0.58,102,32015,70,NULL,NULL,'2MASX J11225891-0752143',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'15.85',NULL,NULL,NULL,NULL,NULL,NULL,1,170.745375,-7.87083,0.093,NULL,41059948838,641561700,10024401,15.85),(80467,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80467,36.39,0.46,190,32016,70,NULL,NULL,'2MASX J11225889+3349305',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000159,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,170.745375,33.82514,0,NULL,60644888248,947576378,14805880,16.6),(80468,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80468,31.37,NULL,18.8,32017,NULL,NULL,NULL,'SDSS J112259.13+122737.6',NULL,'2015AstBu..70....1K',2015,1,NULL,NULL,'G',0.00007,NULL,'17.8g',NULL,NULL,NULL,NULL,NULL,NULL,1,170.74625,12.46056,0.064,NULL,60216723873,940886310,14701348,17.8),(80469,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80469,36.44,0.19,194,32018,70,NULL,NULL,'2MASX J11225917+3417325',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000028,NULL,'16.0g',0.35,NULL,NULL,NULL,NULL,NULL,1,170.746583,34.29233,0.045,NULL,60645054704,947578979,14805921,16),(80470,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80470,32.37,NULL,29.8,32019,NULL,NULL,NULL,'LSBC D570-03',NULL,'2015AstBu..70....1K',2015,1,0.8,NULL,'G',NULL,NULL,'17.72',0.15,'dI',NULL,NULL,NULL,NULL,1,170.747167,17.47403,0,NULL,61120461656,955007213,14921987,17.72),(80471,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80471,36.85,0.21,235,32020,70,NULL,NULL,'2MASX J11225942+4056440',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000178,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,170.7477083,40.94567,0,NULL,63942770301,999105785,15611027,16.9),(80472,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80472,37.42,0.46,304,32021,70,NULL,NULL,'2MASX J11225950+2641188',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'18.06',0.15,NULL,NULL,NULL,NULL,NULL,1,170.7477917,26.68847,0,NULL,60576140288,946502192,14789096,18.06),(80473,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80473,35.95,0.49,155,32022,75,NULL,'IR','2MFGC 08893',NULL,'2011yCatp016004901K',2011,1,0.51,NULL,'G',0.00003,NULL,'17.4g',0.12,'Sc',NULL,NULL,NULL,NULL,1,170.753375,34.39394,0.045,NULL,60641611949,947525186,14805081,17.4),(80474,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80474,36.07,0.46,163,32022,NULL,NULL,'Malmquist cor.','2MFGC 08893',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80475,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80475,36.22,0.43,176,32022,NULL,NULL,NULL,'2MFGC 08893',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80476,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80476,36.26,0.2,179,32022,74.4,NULL,NULL,'2MFGC 08893',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80477,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80477,37.48,0.46,313,32023,70,NULL,NULL,'2MASX J11230084+0219169',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,170.753583,2.32153,0.085,NULL,60349575243,942962113,14733783,16.9),(80478,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80478,33.79,0.49,57.2,32024,75,NULL,'IR','UGC 06397',NULL,'2011yCatp016004901K',2011,1,2.03,NULL,'G',0.000033,NULL,'14.7g',0.33,'Sab','Pair member, S + S',NULL,NULL,NULL,1,170.7587917,34.49769,0.046,NULL,60641609519,947525148,14805080,14.7),(80479,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80479,34.26,0.47,71.1,32024,NULL,NULL,'H','UGC 06397',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80480,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80480,34.34,0.45,73.7,32024,NULL,NULL,'K','UGC 06397',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80481,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80481,34.56,0.46,81.8,32024,NULL,NULL,'J','UGC 06397',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80482,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80482,34.77,0.4,89.8,32024,NULL,NULL,'mean','UGC 06397',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80483,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80483,37.34,0.46,294,32025,70,NULL,NULL,'SDSS J112303.24+000326.7',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000123,NULL,'15.8g',0.46,'E0',NULL,NULL,NULL,NULL,1,170.7635,0.05744,0.109,NULL,60164745823,940074153,14688658,15.8),(80484,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80484,36.48,0.57,197,32026,70,NULL,NULL,'2MASX J11230604-5020190',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,170.775291667,-50.33861,0.617,NULL,40059338550,625927164,9780111,16.2),(80485,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80485,37.5,0.46,317,32027,70,NULL,NULL,'2MASX J11230641+5653402',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,170.77675,56.89461,0,NULL,61988033620,968563025,15133797,18),(80486,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80486,36.53,0.46,202,32028,70,NULL,NULL,'2MASX J11230646+0036459',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000094,NULL,'15.9g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,170.776791667,0.61283,0.085,NULL,60164815018,940075234,14688675,15.9),(80487,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80487,37.5,0.33,316,32029,70,NULL,NULL,'2MASX J11230656+1219301',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00019,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,170.7772083,12.32497,0.064,NULL,60214854007,940857093,14700892,17.2),(80488,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80488,36.67,0.46,216,32030,70,NULL,NULL,'2MASX J11230724+2719429',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,170.780166667,27.32858,0,NULL,60606053486,946969585,14796399,17.3),(80489,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80489,38.1,0.46,417,32031,70,NULL,NULL,'2MASX J11230793+3702285',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000189,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,170.783167,37.04142,0,NULL,60428156479,944189944,14752967,17.5),(80490,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80490,38.02,0.27,403,32032,70,NULL,NULL,'2MASX J11230828+3500328',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,170.7845,35.00911,0.027,NULL,60422372232,944099566,14751555,17.7),(80491,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80491,36.44,0.19,194,32033,70,NULL,NULL,'2MASX J11230864+3409578',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00018,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,170.7860417,34.16614,0.045,NULL,60641902961,947529733,14805152,16.5),(80492,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80492,35.35,0.41,118,32034,NULL,NULL,NULL,'AGC 211492',NULL,'2009ApJS..182..474S',2009,1,0.44,NULL,'G',0.000023,NULL,'15.85',NULL,'Scd',NULL,NULL,NULL,NULL,1,170.793083,34.21031,0.045,NULL,60642034552,947531789,14805184,15.85),(80493,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80493,35.39,0.2,120,32034,74.4,NULL,NULL,'AGC 211492',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80494,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80494,35.67,0.36,136,32034,NULL,NULL,'Malmquist cor.','AGC 211492',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80495,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80495,35.78,0.39,144,32035,NULL,NULL,NULL,'SDSS J112310.39+341748.3',NULL,'2009ApJS..182..474S',2009,1,0.42,NULL,'G',0.000023,NULL,'16.42',0.13,'Sc',NULL,NULL,NULL,NULL,1,170.793291667,34.29675,0.045,NULL,60641589245,947524831,14805075,16.42),(80496,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80496,35.83,0.2,147,32035,74.4,NULL,NULL,'SDSS J112310.39+341748.3',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80497,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80497,35.89,0.37,150,32035,NULL,NULL,'Malmquist cor.','SDSS J112310.39+341748.3',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80498,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80498,35.96,0.46,155,32036,70,NULL,NULL,'CGCG 039-160',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000093,NULL,'15.7g',0.41,'SA0^0^:','Group member',NULL,NULL,NULL,1,170.793417,2.80283,0.085,NULL,60349612718,942962698,14733792,15.7),(80499,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80499,37.76,0.46,357,32037,70,NULL,NULL,'2MASX J11231069+3112249',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,170.794667,31.20703,0,NULL,60666280297,947910629,14811103,17.3),(80500,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80500,30.23,NULL,11.1,32038,NULL,NULL,NULL,'AGC 215414',NULL,'2015AstBu..70....1K',2015,1,NULL,NULL,'G',0.000045,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,170.79625,13.70833,0.066,NULL,60215731482,940870804,14701106,NULL),(80501,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80501,38.02,0.27,403,32039,70,NULL,NULL,'SDSS J112311.34+345844.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,170.7972917,34.97897,0.027,NULL,60419486818,944054481,14750851,18.5),(80502,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80502,37.35,0.12,295,32040,70,NULL,NULL,'2MASX J11231159+0107119',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00009,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,170.7982083,1.12011,0.093,NULL,60167208063,940112625,14689259,16.7),(80503,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80503,36.44,0.19,194,32041,70,NULL,NULL,'2MASX J11231171+3409099',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000107,NULL,'17.15',0.1,NULL,NULL,NULL,NULL,NULL,1,170.7987917,34.15289,0.045,NULL,60641906504,947529789,14805152,17.15),(80504,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80504,38.26,0.21,449,32042,70,NULL,NULL,'2MASX J11231199+0056599',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00011,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,170.8000417,0.94989,0.093,NULL,60167126854,940111357,14689239,17.9),(80505,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80505,38.02,0.27,403,32043,70,NULL,NULL,'2MASX J11231268+3456119',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000187,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,170.803041667,34.93661,0.027,NULL,60419488483,944054507,14750851,17.3),(80506,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80506,36.57,0.27,206,32044,70,NULL,NULL,'MCG +09-19-058',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000211,NULL,'15.4g',0.54,'E0',NULL,NULL,NULL,NULL,1,170.8034583,51.18586,0,NULL,61797728339,965589505,15087336,15.4),(80507,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80507,37.5,0.33,316,32045,70,NULL,NULL,'2MASX J11231339+1220281',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,170.805708333,12.34111,0.064,NULL,60214845593,940856962,14700890,17.4),(80508,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80508,38.26,0.46,448,32046,70,NULL,NULL,'2MASX J11231351+1524311',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000188,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,170.806333333,15.40867,0.013,NULL,61117781670,954965338,14921333,18.1),(80509,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80509,37.35,0.12,295,32047,70,NULL,NULL,'2MASX J11231439+0109439',NULL,'2015arXiv151105856S',2015,1,0.26,'Slinglend et al (1998ApJS..115....1S) have z = 0.06001 +- 0.00028.','G',0.000067,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,170.8100417,1.16228,0.089,NULL,60167199983,940112499,14689257,17.5),(80510,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80510,37.64,0.46,338,32048,70,NULL,NULL,'2MASX J11231446+0038399',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000073,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,170.81025,0.64442,0.085,NULL,60164804174,940075065,14688672,17.6),(80511,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80511,37.03,0.46,255,32049,70,NULL,NULL,'SDSS J112314.72+395931.3',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000182,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,170.811375,39.99203,0,NULL,63926304209,998848503,15607007,16.4),(80512,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80512,36.47,0.46,197,32050,70,NULL,NULL,'IC 2785',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000157,NULL,'15.4g',0.51,NULL,NULL,NULL,NULL,NULL,1,170.814,13.39125,0.058,NULL,60216421683,940881588,14701274,15.4),(80513,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80513,36.95,0.19,245,32051,70,NULL,NULL,'VII Zw 396',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000101,NULL,'16.1g',0.4,'AGN',NULL,NULL,NULL,NULL,1,170.817583333,67.1085,0,NULL,62085246222,970081972,15157530,16.1),(80514,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80514,37.08,0.88,260,32052,70,NULL,NULL,'2MASX J11231643-0840067',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000127,NULL,'15.2R',1.2,'(R)SAa:',NULL,NULL,NULL,NULL,1,170.8185,-8.66847,0.065,NULL,41016220194,640878440,10013725,15.2),(80515,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80515,37.66,0.46,341,32053,70,NULL,NULL,'2MASX J11231714+1952278',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,170.8214583,19.87456,0,NULL,61133997444,955218710,14925292,17),(80516,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80516,37.64,0.46,337,32054,70,NULL,NULL,'2MASX J11231739+2436270',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,170.8225,24.60758,0,NULL,60581429625,946584837,14790388,17.1),(80517,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80517,38.25,0.46,447,32055,70,NULL,NULL,'2MASX J11231739+2514330',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,170.822583,25.24247,0,NULL,60582429722,946600464,14790632,17.5),(80518,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80518,37.64,0.33,337,32056,70,NULL,NULL,'SDSS J112317.44+565636.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000141,NULL,'18.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,170.8227083,56.94342,0,NULL,61988061556,968563461,15133804,18.6),(80519,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80519,37.35,0.12,295,32057,70,NULL,NULL,'2MASX J11231759+0112369',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000079,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,170.8232917,1.21036,0.089,NULL,60167197592,940112462,14689257,17.2),(80520,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80520,38.14,0.12,425,32058,70,NULL,NULL,'2MASX J11231842+1934415',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,'PHOT','17.6g',0.17,'BrClG',NULL,NULL,NULL,NULL,1,170.82675,19.57817,0,NULL,61133494688,955210854,14925169,17.6),(80521,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80521,32.56,0.4,32.4,32059,75,NULL,NULL,'UGC 06402',NULL,'2008Ap.....51..336K',2008,1,1.2,NULL,'G',0.000015,NULL,'14.4g',0.4,'Sc(f)',NULL,NULL,NULL,NULL,1,170.829667,-0.92261,0.113,NULL,40823070122,637860470,9966569,14.4),(80522,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80522,33.43,0.49,48.5,32059,75,NULL,'IR','UGC 06402',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80523,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80523,36.37,0.46,188,32060,70,NULL,NULL,'2MASX J11231975+2606490',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000194,NULL,'16.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,170.832416667,26.11375,0,NULL,60580001970,946562530,14790039,16.3),(80524,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80524,35.27,0.46,113,32061,70,NULL,NULL,'2MASX J11232033+3439399',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000025,NULL,'15.7g',0.46,NULL,NULL,NULL,NULL,NULL,1,170.83475,34.66117,0.046,NULL,60641532485,947523945,14805061,15.7),(80525,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80525,38.02,0.46,402,32062,70,NULL,NULL,'2MASX J11232066+3137179',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000171,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,170.8360417,31.62156,0.02,NULL,60665582822,947899731,14810933,17.9),(80526,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80526,37.39,0.46,300,32063,70,NULL,NULL,'2MASX J11232154+2033285',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.15',0.18,NULL,NULL,NULL,NULL,NULL,1,170.8397917,20.55783,0,NULL,61128852642,955138322,14924036,18.15),(80527,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80527,38.26,0.21,449,32064,70,NULL,NULL,'2MASX J11232239+0055359',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000073,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,170.843417,0.92678,0.093,NULL,60167122437,940111288,14689238,17.6),(80528,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80528,36.65,0.27,214,32065,70,NULL,NULL,'2MASX J11232244+5557372',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000153,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,170.843833,55.96033,0,NULL,61987558297,968555598,15133681,16.9),(80529,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80529,38.24,0.46,444,32066,70,NULL,NULL,'SDSS J112322.73+234122.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,170.8447083,23.68958,0,NULL,60572166884,946440107,14788126,18.5),(80530,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80530,38.23,0.46,443,32067,70,NULL,NULL,'SDSS J112323.17+600618.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,170.8465417,60.10511,0,NULL,61849862339,966404099,15100064,18.2),(80531,'IRAS','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80531,30.93,0.8,15.3,32068,75,NULL,'A82, H','UGC 06399',NULL,'1997ApJS..109..333W',1997,1,2.48,NULL,'G',0.000002,NULL,'14.3g',0.61,'Sm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,170.84675,50.89272,0,NULL,61797715631,965589306,15087332,14.3),(80532,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80532,31.15,0.4,17,32068,75,NULL,'B','UGC 06399',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80533,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80533,31.32,0.36,18.4,32068,NULL,NULL,NULL,'UGC 06399',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80534,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80534,31.35,0.47,18.6,32068,75,NULL,'A82, H, inv','UGC 06399',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80535,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80535,31.54,0.47,20.3,32068,75,NULL,'A82, H, raw','UGC 06399',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80536,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80536,31.63,0.2,21.2,32068,74.4,NULL,NULL,'UGC 06399',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80537,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80537,31.72,0.43,22.1,32068,75,NULL,'3.6 micron, color corrected','UGC 06399',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80538,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80538,31.77,0.47,22.6,32068,75,NULL,'A82, H, cor','UGC 06399',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80539,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80539,31.78,0.43,22.7,32068,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06399',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80540,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80540,37.86,0.46,374,32069,70,NULL,NULL,'2MASX J11232386-0157387',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00014,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,170.8495417,-1.96072,0.141,NULL,40820875417,637826178,9966034,18.1),(80541,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80541,35.83,0.25,147,32070,74.4,NULL,NULL,'CGCG 185-054',NULL,'2013AJ....146...86T',2013,1,0.65,NULL,'G',0.000031,NULL,'15.2g',0.58,NULL,NULL,NULL,NULL,NULL,1,170.852167,33.82914,0,NULL,60641804863,947528200,14805128,15.2),(80542,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80542,35.84,0.21,147,32070,70,NULL,NULL,'CGCG 185-054',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80543,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80543,36.1,0.44,166,32071,NULL,NULL,'Malmquist cor.','2MASX J11232469+3417569',NULL,'2009ApJS..182..474S',2009,1,0.29,NULL,'G',0.000023,NULL,'17.7g',0.15,'Scd',NULL,NULL,NULL,NULL,1,170.852625,34.29925,0.045,NULL,60641589586,947524837,14805075,17.7),(80544,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80544,36.25,0.41,178,32071,NULL,NULL,NULL,'2MASX J11232469+3417569',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80545,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80545,36.29,0.2,181,32071,74.4,NULL,NULL,'2MASX J11232469+3417569',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80546,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80546,35.67,0.46,136,32072,70,NULL,NULL,'2MASX J11232533+0907027',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000177,NULL,'17.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,170.8557083,9.11742,0.112,NULL,60344493253,942882707,14732542,17.1),(80547,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80547,37.16,0.46,271,32073,70,NULL,NULL,'2MASX J11232557+3922046',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00018,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,170.856583,39.36806,0,NULL,60423608318,944118879,14751857,16.7),(80548,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80548,37.3,0.46,289,32074,70,NULL,NULL,'2MASX J11232648+3204599',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000149,NULL,'18.22',0.18,NULL,NULL,NULL,NULL,NULL,1,170.8605,32.08339,0.05,NULL,60650957995,947671218,14807362,18.22),(80549,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80549,38.41,0.21,482,32075,70,NULL,NULL,'2MASX J11232675+2027505',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,170.861416667,20.46411,0,NULL,61133176948,955205889,14925092,18.2),(80550,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80550,37.6,0.46,331,32076,70,NULL,NULL,'2MASX J11232727+0726597',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,170.86375,7.44994,0.161,NULL,60392504689,943632885,14744263,17.5),(80551,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80551,39.1,0.46,660,32077,70,NULL,NULL,'SDSS J112328.41-020916.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'18.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,170.868417,-2.15461,0.145,NULL,40820146646,637814791,9965856,18.3),(80552,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80552,37.74,0.33,353,32078,70,NULL,NULL,'SDSS J112330.56+301106.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000134,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,170.877333,30.18508,0,NULL,60660885532,947826336,14809786,18.6),(80553,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80553,38.72,0.46,556,32079,70,NULL,NULL,'SDSS J112330.86+050035.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000135,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,170.878625,5.00989,0.117,NULL,60360301900,943129717,14736401,18.2),(80554,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80554,37.64,0.46,337,32080,70,NULL,NULL,'2MASX J11233095+2800169',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000131,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,170.878833,28.00469,0,NULL,60607077096,946985579,14796649,17.7),(80555,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80555,37.3,0.46,289,32081,70,NULL,NULL,'2MASX J11233116+4110006',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,170.88,41.16694,0,NULL,63943056960,999110265,15611097,17.2),(80556,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80556,37.87,0.46,374,32082,70,NULL,NULL,'2MASX J11233176+2518199',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.13',0.17,NULL,NULL,NULL,NULL,NULL,1,170.882375,25.30558,0,NULL,60582431736,946600495,14790632,18.13),(80557,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80557,36.98,0.46,249,32083,70,NULL,NULL,'2MASX J11233198+0816580',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000173,NULL,'16.7g',0.27,'AGN',NULL,NULL,NULL,NULL,1,170.883333,8.28272,0.073,NULL,60336337170,942755268,14730551,16.7),(80558,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80558,33.91,0.4,60.4,32084,NULL,NULL,'mean','NGC 3660',NULL,'2007A&A...465...71T',2007,1,2.7,NULL,'G',0.000007,NULL,'13.06',2.2,'SB(r)bc;HII    Sy2',NULL,NULL,NULL,'Starburst',1,170.8845,-8.65856,0.069,NULL,41016210187,640878284,10013723,13.06),(80559,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80559,33.95,0.45,61.7,32084,NULL,NULL,'K','NGC 3660',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80560,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80560,34.03,0.46,64,32084,NULL,NULL,'J','NGC 3660',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80561,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80561,34.04,0.47,64.1,32084,NULL,NULL,'H','NGC 3660',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80562,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80562,38.09,0.46,416,32085,70,NULL,NULL,'SDSS J112333.67+245137.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,170.8902917,24.86056,0,NULL,60580764870,946574451,14790225,18.2),(80563,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80563,37.43,0.46,307,32086,70,NULL,NULL,'2MASX J11233395+0223488',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000181,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,170.891375,2.39681,0.085,NULL,60348871540,942951117,14733611,16.6),(80564,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80564,36.71,0.27,220,32087,70,NULL,NULL,'2MASX J11233407+5623534',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000183,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,170.891916667,56.39806,0,NULL,61986196598,968534321,15133348,16.6),(80565,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80565,38.1,0.46,417,32088,70,NULL,NULL,'2MASX J11233721+3646396',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000133,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,170.905083,36.77769,0.01,NULL,60428096488,944189007,14752953,17.9),(80566,'Tully est','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80566,33.14,0.8,42.6,32089,75,NULL,'B','NGC 3656',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.000037,NULL,'13.28',1.6,'(R\')I0: pec    LINER','Pair member (points to parent)',NULL,NULL,NULL,1,170.9110417,53.84211,0,NULL,61791372912,965490201,15085784,13.28),(80567,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80567,37.82,0.46,366,32090,70,NULL,NULL,'2MASX J11233922+0645030',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000179,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,170.913291667,6.75078,0.173,NULL,60392897329,943639020,14744359,17.4),(80568,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80568,38.23,0.46,442,32091,70,NULL,NULL,'2MASX J11234058+3748475',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00014,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,170.9189583,37.81333,0,NULL,60425999630,944156244,14752441,18.1),(80569,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80569,37.36,0.46,296,32092,70,NULL,NULL,'2MASX J11234087+4253365',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000168,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,170.9202917,42.89353,0,NULL,63943895813,999123372,15611302,16.5),(80570,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2009aa',NULL,80570,35.4,0.13,114,32093,72,NULL,NULL,'ESO 570- G 020',0.0285,'2013ApJ...773...53F',2013,1,1,'Star superposed?','G',0.000047,NULL,'14.90',0.6,'Sbc',NULL,NULL,NULL,NULL,1,170.920667,-22.2705,0.149,NULL,41715703290,651807863,10184497,14.9),(80571,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80571,37.8,0.46,363,32094,70,NULL,NULL,'2MASX J11234177+0652320',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,170.924041667,6.87569,0.169,NULL,60392989711,943640464,14744382,17.2),(80572,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80572,36.47,0.46,197,32095,70,NULL,NULL,'2MASX J11234237+2711189',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000156,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,170.9265,27.18858,0,NULL,60575841781,946497527,14789023,16.6),(80573,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80573,38.14,0.12,425,32096,70,NULL,NULL,'2MASX J11234249+1946055',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,170.927,19.76817,0,NULL,61133965128,955218205,14925284,18),(80574,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80574,36.73,0.27,222,32097,70,NULL,NULL,'2MASX J11234264+5925545',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,170.928,59.43175,0,NULL,61849471388,966397990,15099968,17.3),(80575,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80575,37.4,0.33,302,32098,70,NULL,NULL,'2MASX J11234308+1626418',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,170.9295,16.44503,0,NULL,61108317512,954817461,14919022,17.1),(80576,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80576,37.62,0.46,334,32099,70,NULL,NULL,'2MASX J11234311+5455025',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,170.929875,54.91736,0,NULL,61983825452,968497272,15132769,17.7),(80577,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80577,37.35,0.12,295,32100,70,NULL,NULL,'2MASX J11234317+0059088',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00007,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,170.929958333,0.98589,0.085,NULL,60166418546,940100289,14689067,17.6),(80578,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80578,35.67,0.59,136,32101,70,NULL,NULL,'ESO 570- G 021',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'15.5',1,'S0(r:)',NULL,NULL,NULL,NULL,1,170.931917,-20.72986,0.125,NULL,41731474835,652054294,10188348,15.5),(80579,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80579,38.56,0.33,516,32102,70,NULL,NULL,'SDSS J112345.20+390032.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000142,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,170.938375,39.00914,0,NULL,60426957489,944171210,14752675,18.4),(80580,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80580,31.55,0.43,20.4,32103,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3659',NULL,'2014MNRAS.444..527S',2014,1,2.1,NULL,'G',0.000018,NULL,'12.77',1.1,'SB(s)m?        HII','X-ray-bright group member',NULL,NULL,NULL,1,170.93975,17.81867,0,NULL,61134326074,955223844,14925372,12.77),(80581,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80581,31.75,0.43,22.3,32103,75,NULL,'3.6 micron, color corrected','NGC 3659',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80582,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80582,31.95,0.4,24.5,32103,75,NULL,'B','NGC 3659',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80583,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80583,31.98,0.2,24.9,32103,74.4,NULL,NULL,'NGC 3659',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80584,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80584,32.11,0.52,26.5,32103,NULL,NULL,'Malmquist cor.','NGC 3659',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80585,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80585,32.26,0.48,28.3,32103,NULL,NULL,NULL,'NGC 3659',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80586,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80586,34.52,0.47,80.3,32104,NULL,NULL,'H','NGC 3662',NULL,'2007A&A...465...71T',2007,1,1.4,'Mistakenly called a triple galaxy in MCG and UGC.','G',0.000137,NULL,'13.0r',0.9,'Sb',NULL,NULL,NULL,NULL,1,170.943583,-1.10486,0.113,NULL,40822322448,637848788,9966387,13),(80587,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80587,34.55,0.45,81.3,32104,NULL,NULL,'K','NGC 3662',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80588,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80588,34.56,0.46,81.5,32104,NULL,NULL,'J','NGC 3662',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80589,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80589,34.68,0.4,86.4,32104,NULL,NULL,'mean','NGC 3662',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80590,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80590,34.86,0.35,93.6,32104,NULL,NULL,'Malmquist cor.','NGC 3662',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80591,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80591,34.88,0.35,94.5,32104,NULL,NULL,NULL,'NGC 3662',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80592,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80592,35.25,0.2,112,32104,74.4,NULL,NULL,'NGC 3662',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80593,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80593,35.31,0.25,115,32105,74.4,NULL,NULL,'2MASX J11234700+3526318',NULL,'2013AJ....146...86T',2013,1,0.37,NULL,'G',0.000042,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,170.945916667,35.44231,0.019,NULL,60422560950,944102514,14751601,16.3),(80594,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80594,35.38,0.46,119,32105,70,NULL,NULL,'2MASX J11234700+3526318',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80595,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80595,37.3,0.33,288,32106,70,NULL,NULL,'SDSS J112347.76+471123.5',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000176,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,170.949041667,47.18989,0,NULL,63946909564,999170461,15612038,17.9),(80596,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80596,37.36,0.46,296,32107,70,NULL,NULL,'2MASX J11234797+3345038',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,170.9497083,33.75103,0.027,NULL,60641821880,947528466,14805132,17.3),(80597,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80597,37.74,0.33,353,32108,70,NULL,NULL,'2MASX J11234813+3005358',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000145,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,170.9504583,30.09333,0,NULL,60660900498,947826570,14809790,17.1),(80598,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80598,35.62,0.51,133,32109,70,NULL,NULL,'2MFGC 08908',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'13.6I',0.4,NULL,NULL,NULL,NULL,NULL,1,170.95125,-34.63703,0.309,NULL,41562130530,649408289,10147004,13.6),(80599,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80599,36.97,0.46,248,32110,70,NULL,NULL,'2MASX J11235025+0004428',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000167,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,170.959333,0.07864,0.105,NULL,60164290387,940067037,14688547,16.4),(80600,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80600,38.14,0.12,425,32111,70,NULL,NULL,'2MASX J11235036+1934085',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.19',0.16,NULL,NULL,NULL,NULL,NULL,1,170.959833,19.569,0,NULL,61133380058,955209063,14925141,18.19),(80601,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80601,35.91,0.27,152,32112,70,NULL,NULL,'2MASX J11235039+3750287',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000177,NULL,'16.1g',0.32,NULL,NULL,NULL,NULL,NULL,1,170.9600417,37.84122,0,NULL,60426001938,944156280,14752441,16.1),(80602,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80602,38.41,0.21,482,32113,70,NULL,NULL,'2MASX J11235158+2028465',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,170.964916667,20.47956,0,NULL,61128947769,955139808,14924059,17.4),(80603,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80603,38.41,0.21,482,32114,70,NULL,NULL,'2MASX J11235158+2030175',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.39',0.18,NULL,NULL,NULL,NULL,NULL,1,170.9650417,20.50489,0,NULL,61128948313,955139817,14924059,18.39),(80604,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80604,38.11,0.46,419,32115,70,NULL,NULL,'2MASX J11235215+3937517',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,170.967375,39.63122,0,NULL,60423549295,944117957,14751843,18.1),(80605,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80605,38.69,0.33,546,32116,70,NULL,NULL,'2MASX J11235240+3920317',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000186,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,170.968416667,39.34217,0,NULL,60423604445,944118819,14751856,17.8),(80606,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80606,37.05,0.46,257,32117,70,NULL,NULL,'2MASX J11235250+6434297',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000082,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,170.968625,64.57486,0.009,NULL,61868475416,966694928,15104608,16.9),(80607,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80607,37.45,0.46,308,32118,70,NULL,NULL,'2MASX J11235260+6112307',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000173,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,170.96925,61.20864,0,NULL,61859340480,966552195,15102378,18.2),(80608,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80608,38.41,0.21,482,32119,70,NULL,NULL,'2MASX J11235322+2026305',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,170.972,20.44197,0,NULL,61133186503,955206039,14925094,18),(80609,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80609,37.06,0.46,258,32120,70,NULL,NULL,'2MASX J11235513+5832046',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000182,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,170.979917,58.53472,0,NULL,61982504454,968476632,15132447,16.5),(80610,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80610,37.28,0.33,286,32121,70,NULL,NULL,'2MASX J11235531+4010317',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,170.980417,40.17539,0,NULL,63925552382,998836755,15606824,17.9),(80611,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80611,31.75,0.4,22.4,32122,75,NULL,'B','NGC 3657',NULL,'1988NBGC.C....0000T',1988,1,1.03,NULL,'G',0.000037,NULL,'13.5g',0.79,'SAB(rs)c pec   HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,170.981583333,52.921,0,NULL,61794282687,965535666,15086494,13.5),(80612,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80612,37.27,0.33,284,32123,70,NULL,NULL,'2MASX J11235815+5633026',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,170.9925,56.55069,0,NULL,61986263873,968535373,15133365,17.1),(80613,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80613,37.64,0.33,337,32124,70,NULL,NULL,'2MASX J11235836+5655206',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000143,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,170.993375,56.92225,0,NULL,61988135239,968564613,15133822,17.8),(80614,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80614,38.1,0.46,417,32125,70,NULL,NULL,'2MASX J11235878+1923155',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,170.994875,19.38767,0,NULL,61133392671,955209260,14925144,18.2),(80615,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80615,36.38,0.46,188,32126,70,NULL,NULL,'2MASX J11235882+0246069',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000095,NULL,'17.0g',0.24,'NLAGN',NULL,NULL,NULL,NULL,1,170.995125,2.76858,0.081,NULL,60348798116,942949970,14733593,17),(80616,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80616,36.7,0.46,218,32127,70,NULL,NULL,'2MASX J11235943+2639129',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,170.997625,26.65367,0,NULL,60576136351,946502130,14789095,17.1),(80617,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80617,38.56,0.33,516,32128,70,NULL,NULL,'2MASX J11235984+3900217',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000165,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,170.999417,39.00594,0,NULL,60426958328,944171223,14752675,18),(80618,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2006ax',NULL,80618,33.67,0.19,53.3,32129,74.2,NULL,'SALT 2','NGC 3663',0.016739,'2010ApJ...716..712A',2010,1,1.9,NULL,'G',0.000024,NULL,'12.6B',1.3,'SA(rs)bc pec',NULL,NULL,NULL,NULL,1,170.999625,-12.29644,0.105,NULL,40972669211,640197956,10003093,12.6),(80619,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2006ax',NULL,80619,33.91,0.03,59.4,32129,70,NULL,'SALT 2','NGC 3663',0.016739,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80620,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2006ax',NULL,80620,34.2,0.01,69.2,32129,72,NULL,NULL,'NGC 3663',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80621,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2006ax',NULL,80621,34.24,0.09,70.5,32129,74.4,NULL,NULL,'NGC 3663',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80622,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2006ax',NULL,80622,34.32,0.15,70.6,32129,72,NULL,NULL,'NGC 3663',0.01797,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80623,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2006ax',NULL,80623,34.3,0.04,71.3,32129,72,NULL,NULL,'NGC 3663',0.016739,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80624,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2006ax',NULL,80624,34.3,0.2,71.3,32129,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','NGC 3663',0.016739,'2011A&A...526A..81B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80625,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2006ax',NULL,80625,34.31,0.09,71.6,32129,72,NULL,NULL,'NGC 3663',0.016739,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80626,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2006ax',NULL,80626,34.32,0.17,72,32129,72,NULL,NULL,'NGC 3663',0.016739,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80627,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2006ax',NULL,80627,34.29,0.02,72,32129,72,NULL,'M(H) = -18.317 mag','NGC 3663',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80628,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2006ax',NULL,80628,34.34,0.02,72.6,32129,72,NULL,NULL,'NGC 3663',0.016739,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80629,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2006ax',NULL,80629,34.37,0.09,73.6,32129,72,NULL,NULL,'NGC 3663',0.016739,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80630,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2006ax',NULL,80630,34.41,0.18,74.9,32129,70,NULL,'SALT 2','NGC 3663',0.016739,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80631,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2006ax',NULL,80631,34.43,0.23,75.4,32129,73.8,NULL,'SALT 2 (SNANA)','NGC 3663',0.0174,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80632,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2006ax',NULL,80632,34.45,0.24,76.3,32129,73.8,NULL,'SALT 2 (SNANA)','NGC 3663',0.0174,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80633,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2006ax',NULL,80633,34.52,0.21,79,32129,65,NULL,'SALT','NGC 3663',0.016739,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80634,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2006ax',NULL,80634,34.54,0.22,79.6,32129,65,NULL,'SALT2','NGC 3663',0.016739,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80635,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2006ax',NULL,80635,34.59,0.19,81.5,32129,65,NULL,'MLCS17','NGC 3663',0.016739,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80636,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2006ax',NULL,80636,34.68,0.19,85,32129,65,NULL,'MLCS31','NGC 3663',0.016739,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80637,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80637,34.08,0.65,65.6,32129,70,NULL,NULL,'NGC 3663',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80638,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80638,33.43,0.69,48.6,32129,100,NULL,'mid-IR','NGC 3663',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80639,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80639,33.99,0.4,62.8,32129,75,NULL,'HOSTS SN 2006ax','NGC 3663',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80640,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80640,34.14,0.42,67.3,32129,NULL,18.48,'3.6 micron','NGC 3663',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80641,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80641,34.36,0.43,74.5,32129,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3663',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80642,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80642,34.4,0.4,75.9,32129,NULL,NULL,'mean','NGC 3663',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80643,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80643,34.41,0.47,76.2,32129,NULL,NULL,'H','NGC 3663',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80644,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80644,34.48,0.46,78.6,32129,NULL,NULL,'J','NGC 3663',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80645,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80645,34.5,0.45,79.3,32129,NULL,NULL,'K','NGC 3663',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80646,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80646,37.4,0.33,302,32130,70,NULL,NULL,'2MASX J11240025+1631478',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.36',0.14,NULL,NULL,NULL,NULL,NULL,1,171.001083333,16.52981,0,NULL,61108311672,954817369,14919021,18.36),(80647,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80647,36.71,0.27,220,32131,70,NULL,NULL,'SBS 1121+562A',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000107,NULL,'15.1g',0.61,NULL,NULL,NULL,NULL,NULL,1,171.005333,55.96256,0,NULL,61987569548,968555774,15133683,15.1),(80648,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80648,36.97,0.46,248,32132,70,NULL,NULL,'2MASX J11240141+6233480',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,171.005875,62.56325,0,NULL,61873421137,966772205,15105815,17.3),(80649,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80649,37.28,0.33,286,32133,70,NULL,NULL,'2MASX J11240288+4004106',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.62',0.2,NULL,NULL,NULL,NULL,NULL,1,171.012083,40.06967,0,NULL,63925556031,998836812,15606825,17.62),(80650,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80650,38.14,0.12,425,32134,70,NULL,NULL,'2MASX J11240380+1938505',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,171.015875,19.6475,0,NULL,61133387134,955209173,14925143,17.6),(80651,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80651,36.09,0.2,165,32135,74.4,NULL,NULL,'SDSS J112403.90+280238.3',NULL,'2013AJ....146...86T',2013,1,0.62,NULL,'G',0.000037,NULL,'17.9g',0.1,NULL,NULL,NULL,NULL,NULL,1,171.01625,28.044,0,NULL,60607117478,946986210,14796659,17.9),(80652,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80652,38.26,0.21,449,32136,70,NULL,NULL,'2MASX J11240452+0054599',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000081,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,171.018791667,0.91672,0.085,NULL,60166431188,940100487,14689070,17.2),(80653,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80653,37.58,0.33,328,32137,70,NULL,NULL,'2MASX J11240452+1956305',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.91',0.17,NULL,NULL,NULL,NULL,NULL,1,171.018875,19.942,0,NULL,61134074175,955219908,14925311,17.91),(80654,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80654,38.91,0.46,606,32138,70,NULL,NULL,'SDSS J112404.59+595337.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000133,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,171.019167,59.89375,0,NULL,61853065501,966454148,15100846,18.5),(80655,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80655,38.2,0.46,437,32139,70,NULL,NULL,'2MASX J11240481+4313472',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.00',0.17,NULL,NULL,NULL,NULL,NULL,1,171.0202917,43.22986,0.007,NULL,63943901737,999123464,15611304,18),(80656,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80656,34.91,0.49,95.8,32140,75,NULL,'IR','UGC 06414',NULL,'2011yCatp016004901K',2011,1,1.74,NULL,'G',0.000008,NULL,'16.0',0.15,'Sc',NULL,NULL,NULL,NULL,1,171.021417,24.61544,0,NULL,60580895074,946576485,14790257,16),(80657,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80657,35.21,0.43,110,32140,NULL,NULL,'Malmquist cor.','UGC 06414',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80658,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80658,35.21,NULL,110,32140,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06414',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80659,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80659,35.22,NULL,111,32140,NULL,NULL,'Dipole + Quadrupole','UGC 06414',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80660,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80660,35.23,NULL,111,32140,NULL,NULL,'Dipole','UGC 06414',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80661,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80661,35.26,NULL,113,32140,NULL,NULL,NULL,'UGC 06414',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80662,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80662,35.41,0.39,121,32140,NULL,NULL,NULL,'UGC 06414',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80663,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80663,35.47,0.2,124,32140,74.4,NULL,NULL,'UGC 06414',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80664,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80664,37.43,0.46,306,32141,70,NULL,NULL,'2MASX J11240630+1423445',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,171.0262083,14.39575,0.068,NULL,61117306783,954957918,14921217,17.6),(80665,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80665,38.26,0.21,449,32142,70,NULL,NULL,'2MASX J11240706+0100269',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000072,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,171.0292917,1.00744,0.089,NULL,60166395639,940099931,14689061,17.6),(80666,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80666,35.39,0.33,120,32143,70,NULL,NULL,'2MASX J11240743+3439487',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00013,NULL,'15.5g',0.49,NULL,NULL,NULL,NULL,NULL,1,171.030917,34.66358,0.046,NULL,60641768780,947527637,14805119,15.5),(80667,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80667,37.55,0.46,324,32144,70,NULL,NULL,'SDSS J112408.29-012628.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000132,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,171.0345417,-1.44133,0.189,NULL,40820396915,637818701,9965917,18.4),(80668,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80668,35.36,0.38,118,32145,NULL,NULL,'Malmquist cor.','UGC 06415',NULL,'2009ApJS..182..474S',2009,1,2.1,NULL,'G',0.000007,NULL,'14.80',0.4,'Sab',NULL,NULL,NULL,NULL,1,171.04425,27.01433,0,NULL,60576203013,946503172,14789112,14.8),(80669,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80669,35.44,0.37,122,32145,NULL,NULL,NULL,'UGC 06415',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80670,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80670,35.91,0.2,152,32145,74.4,NULL,NULL,'UGC 06415',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80671,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80671,36.07,0.4,164,32145,NULL,NULL,'mean','UGC 06415',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80672,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80672,36.27,0.47,180,32145,NULL,NULL,'H','UGC 06415',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80673,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80673,32.04,0.43,25.5,32146,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3654',NULL,'2014MNRAS.444..527S',2014,1,1.2,NULL,'G',0.00003,NULL,'13.70',0.6,'S?','Field galaxy',NULL,NULL,NULL,1,171.04475,69.41308,0.009,NULL,62090555956,970164936,15158827,13.7),(80674,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80674,32.13,0.43,26.7,32146,75,NULL,'3.6 micron, color corrected','NGC 3654',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80675,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80675,32.23,0.2,27.9,32146,74.4,NULL,NULL,'NGC 3654',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80676,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80676,32.41,0.4,30.4,32146,NULL,NULL,'mean','NGC 3654',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80677,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80677,33.09,0.47,41.6,32146,NULL,NULL,'H','NGC 3654',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80678,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80678,33.1,0.46,41.7,32146,NULL,NULL,'J','NGC 3654',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80679,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80679,33.14,0.45,42.5,32146,NULL,NULL,'K','NGC 3654',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80680,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80680,38.01,0.46,401,32147,70,NULL,NULL,'2MASX J11241170+2727177',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.0001,NULL,'18.37',0.17,NULL,NULL,NULL,NULL,NULL,1,171.048583,27.45497,0,NULL,60606072370,946969880,14796404,18.37),(80681,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80681,37.58,0.33,328,32148,70,NULL,NULL,'2MASX J11241253+1954255',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.63',0.19,NULL,NULL,NULL,NULL,NULL,1,171.052166667,19.90706,0,NULL,61134064219,955219753,14925308,17.63),(80682,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80682,37.41,0.46,303,32149,70,NULL,NULL,'SDSS J112413.08+305826.9',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.00013,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,171.0545,30.97417,0,NULL,60665989463,947906085,14811032,18.5),(80683,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80683,37.3,0.46,288,32150,70,NULL,NULL,'2MASX J11241312+3211500',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000175,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,171.054583,32.19728,0.05,NULL,60652792622,947699884,14807810,16.9),(80684,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80684,35.39,0.33,120,32151,70,NULL,NULL,'2MASX J11241322+3442190',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00011,NULL,'15.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,171.055083,34.70542,0.045,NULL,60641727500,947526992,14805109,15.9),(80685,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80685,38.14,0.12,425,32152,70,NULL,NULL,'2MASX J11241328+1935505',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,171.055291667,19.5975,0,NULL,61133383687,955209120,14925142,17.8),(80686,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80686,36.82,0.33,231,32153,70,NULL,NULL,'2MASX J11241340+0014509',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000096,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,171.055708333,0.24744,0.077,NULL,60165024396,940078506,14688726,16.3),(80687,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80687,37.27,0.33,284,32154,70,NULL,NULL,'2MASX J11241348+5627016',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000168,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,171.056083,56.45058,0,NULL,61986081589,968532524,15133320,16.3),(80688,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80688,37.73,0.33,352,32155,70,NULL,NULL,'2MASX J11241365+1219175',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'17.9g',0.2,'AGN',NULL,NULL,NULL,NULL,1,171.05675,12.32169,0.08,NULL,60214922036,940858156,14700908,17.9),(80689,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80689,37.73,0.33,352,32156,70,NULL,NULL,'SDSS J112413.82+121954.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.2g',0.17,'AGN',NULL,NULL,NULL,NULL,1,171.057583,12.33178,0.08,NULL,60214921727,940858151,14700908,18.2),(80690,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80690,38.46,0.46,492,32157,70,NULL,NULL,'2MASX J11241409+4913474',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,171.058791667,49.22997,0,NULL,61794922539,965545664,15086651,18),(80691,'IRAS','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80691,34.19,0.8,69,32158,75,NULL,'MAT, I','ESO 038- G 012',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000024,NULL,'12.80',0.7,'SAB(rs)bc:',NULL,NULL,NULL,NULL,1,171.0602083,-77.16078,0.437,NULL,39843126585,622548852,9727325,12.8),(80692,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80692,33.25,0.32,44.7,32158,85,NULL,'I, raw','ESO 038- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80693,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80693,33.28,0.32,45.3,32158,85,NULL,'I, inv','ESO 038- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80694,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80694,33.47,0.55,49.3,32158,NULL,NULL,NULL,'ESO 038- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80695,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80695,33.51,0.2,50.4,32158,74.4,NULL,NULL,'ESO 038- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80696,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80696,33.53,0.43,50.9,32158,75,NULL,'MAT, I, raw','ESO 038- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80697,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80697,33.54,0.53,51,32158,NULL,NULL,'Malmquist cor.','ESO 038- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80698,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80698,33.68,0.43,54.5,32158,75,NULL,'MAT, I, inv','ESO 038- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80699,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80699,33.91,0.43,60.7,32158,75,NULL,'MAT, I, cor','ESO 038- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80700,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80700,34.56,0.4,81.6,32158,NULL,NULL,'mean','ESO 038- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80701,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80701,34.73,0.47,88.4,32158,NULL,NULL,'H','ESO 038- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80702,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80702,36.45,0.46,195,32159,70,NULL,NULL,'2MASX J11241451+5639065',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000175,NULL,'16.0g',0.45,'E0',NULL,NULL,NULL,NULL,1,171.060583,56.65189,0,NULL,61986077001,968532453,15133319,16),(80703,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80703,38.26,0.21,449,32160,70,NULL,NULL,'SDSS J112414.62+005837.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000092,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,171.060958333,0.97706,0.089,NULL,60166402344,940100036,14689063,18.7),(80704,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80704,38.64,0.46,535,32161,70,NULL,NULL,'2MASX J11241504+5748265',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.7g',0.21,'BrClG',NULL,NULL,NULL,NULL,1,171.062667,57.80731,0,NULL,61988169733,968565152,15133830,17.7),(80705,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80705,37.35,0.12,295,32162,70,NULL,NULL,'2MASX J11241525+0100519',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000064,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,171.0635417,1.0145,0.089,NULL,60166395149,940099924,14689061,17.7),(80706,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80706,37.48,0.46,314,32163,70,NULL,NULL,'2MASX J11241556+1508025',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,171.065,15.13406,0.036,NULL,61109503348,954835989,14919312,17.7),(80707,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80707,35.91,0.27,152,32164,70,NULL,NULL,'CGCG 185-057',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000093,NULL,'15.0g',0.69,NULL,NULL,NULL,NULL,NULL,1,171.0697917,38.01544,0,NULL,60425937154,944155268,14752426,15),(80708,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80708,34.5,0.4,79.5,32165,NULL,NULL,'mean','NGC 3667',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00003,NULL,'14.00',1,'(R\')SA(rs)ab:',NULL,NULL,NULL,NULL,1,171.070916667,-13.85731,0.101,NULL,40971111050,640173610,10002712,14),(80709,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80709,34.64,0.47,84.7,32165,NULL,NULL,'H','NGC 3667',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80710,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80710,34.65,0.46,85.1,32165,NULL,NULL,'J','NGC 3667',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80711,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80711,34.66,0.45,85.5,32165,NULL,NULL,'K','NGC 3667',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80712,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80712,35.7,0.46,138,32166,70,NULL,NULL,'IC 0687',NULL,'2015arXiv151105856S',2015,1,0.86,NULL,'G',0.000087,NULL,'14.5g',0.77,'E/S0',NULL,NULL,NULL,NULL,1,171.0722083,47.84753,0,NULL,63892757574,998324337,15598817,14.5),(80713,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80713,37.92,0.27,383,32167,70,NULL,NULL,'2MASX J11241746+0122059',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000162,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,171.072791667,1.36847,0.089,NULL,60166356434,940099319,14689051,16.9),(80714,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80714,38.69,0.33,546,32168,70,NULL,NULL,'2MASX J11241758+3924240',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,171.073083333,39.40683,0.02,NULL,60423602180,944118784,14751856,18),(80715,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80715,37.24,0.46,281,32169,70,NULL,NULL,'2MASX J11241858+2901047',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000136,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,171.0774583,29.018,0,NULL,60605125383,946955084,14796173,17.6),(80716,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80716,34.38,0.51,75.3,32170,70,NULL,NULL,'IC 0690',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000087,NULL,'15.15',0.5,NULL,NULL,NULL,NULL,NULL,1,171.085875,-8.34197,0.089,NULL,41059129772,641548902,10024201,15.15),(80717,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80717,37.92,0.27,383,32171,70,NULL,NULL,'2MASX J11242085+0131129',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000213,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,171.0869583,1.52031,0.089,NULL,60165912368,940092380,14688943,17.1),(80718,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80718,38.41,0.21,482,32172,70,NULL,NULL,'2MASX J11242088+2031147',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,171.087,20.52094,0,NULL,61128957908,955139967,14924061,17.3),(80719,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80719,37.49,0.46,315,32173,70,NULL,NULL,'SDSS J112420.98+002601.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000069,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,171.087417,0.43375,0.077,NULL,60165182881,940080982,14688765,17.9),(80720,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80720,36.33,0.46,185,32174,70,NULL,NULL,'IC 2797',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000166,NULL,'16.0g',0.38,NULL,NULL,NULL,NULL,NULL,1,171.08775,11.70594,0.105,NULL,60214716205,940854940,14700858,16),(80721,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80721,37.92,0.27,383,32175,70,NULL,NULL,'SDSS J112422.46+012832.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000135,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,171.093625,1.47583,0.089,NULL,60165876680,940091823,14688934,17.9),(80722,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80722,38.44,0.46,488,32176,70,NULL,NULL,'2MASX J11242352+0705062',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000182,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,171.098083333,7.08519,0.169,NULL,60392763798,943636934,14744327,18.2),(80723,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80723,31.94,0.4,24.4,32177,75,NULL,'B','NGC 3664',NULL,'1988NBGC.C....0000T',1988,1,2,'The UZC position is for a knot northeast of the nucleus.','G',0.000007,NULL,'13.20',1.9,'SB(s)m pec','in an interacting pair',NULL,NULL,NULL,1,171.1010417,3.325,0.109,NULL,60363314694,943176792,14737137,13.2),(80724,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80724,37.4,0.46,302,32178,70,NULL,NULL,'2MASX J11242473+2643278',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000172,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,171.103083333,26.72453,0,NULL,60576186819,946502919,14789108,16.9),(80725,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80725,32.1,NULL,26.3,32179,NULL,NULL,NULL,'NGC 3664A',NULL,'2015AstBu..70....1K',2015,1,0.8,NULL,'G',0.000013,NULL,'14.86',0.8,'(R)SB(s)m:','in an interacting pair',NULL,NULL,NULL,1,171.104583,3.2225,0.109,NULL,60363311765,943176746,14737136,14.86),(80726,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80726,37.83,0.46,369,32180,70,NULL,NULL,'2MASX J11242534+1941568',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,171.1057083,19.69908,0,NULL,61133856097,955216501,14925257,17.5),(80727,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80727,32.45,0.49,30.9,32181,75,NULL,'IR','UGC 06417',NULL,'2011yCatp016004901K',2011,1,1.21,'1994A&AS..107..265G has V = 1364 +- 3 km/sec.  RC3 agrees with SDSS.','G',0.000152,NULL,'16.5g',0.15,'Sb(f)','Group member',NULL,NULL,NULL,1,171.106583,3.14497,0.085,NULL,60363196681,943174948,14737108,16.5),(80728,'IRAS','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80728,31.26,0.8,17.8,32182,75,NULL,'A82, H','NGC 3666',NULL,'1997ApJS..109..333W',1997,1,2.54,NULL,'G',0.000004,NULL,'12.8g',0.97,'SA(rs)c:','Probable group member',NULL,NULL,NULL,1,171.108625,11.34222,0.116,NULL,60332975736,942702745,14729730,12.8),(80729,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80729,30.86,0.47,14.8,32182,75,NULL,'A82, H, inv','NGC 3666',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80730,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80730,30.86,0.47,14.9,32182,75,NULL,'A82, H, raw','NGC 3666',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80731,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80731,31.06,0.35,16.3,32182,NULL,NULL,NULL,'NGC 3666',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80732,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80732,31.15,0.4,17,32182,75,NULL,'B','NGC 3666',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80733,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80733,31.16,0.43,17,32182,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3666',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80734,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80734,31.17,0.47,17.1,32182,75,NULL,'A82, H, cor','NGC 3666',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80735,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80735,31.26,0.43,17.9,32182,75,NULL,'3.6 micron, color corrected','NGC 3666',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80736,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80736,31.33,0.2,18.5,32182,74.4,NULL,NULL,'NGC 3666',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80737,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80737,31.43,0.46,19.3,32182,NULL,NULL,NULL,'NGC 3666',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80738,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80738,31.45,0.46,19.5,32182,NULL,NULL,'Malmquist cor.','NGC 3666',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80739,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80739,31.62,0.4,21,32182,NULL,NULL,'mean','NGC 3666',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80740,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80740,31.62,0.46,21.1,32182,NULL,NULL,'J','NGC 3666',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80741,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80741,31.65,0.47,21.4,32182,NULL,NULL,'H','NGC 3666',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80742,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80742,31.69,0.49,21.8,32182,75,NULL,'IR','NGC 3666',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80743,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80743,31.72,0.45,22.1,32182,NULL,NULL,'K','NGC 3666',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80744,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80744,31.84,0.3,23.3,32182,55,NULL,'B','NGC 3666',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80745,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80745,37,0.46,251,32183,70,NULL,NULL,'2MASX J11242694+0858122',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,171.112167,8.97022,0.117,NULL,60343538007,942867781,14732309,16.9),(80746,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80746,36.95,0.19,245,32184,70,NULL,NULL,'2MASX J11242720+6658509',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000082,NULL,'16.1g',0.36,'E0',NULL,NULL,NULL,NULL,1,171.1132917,66.98069,0,NULL,62085383389,970084115,15157564,16.1);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (80747,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80747,37.75,0.33,355,32185,70,NULL,NULL,'2MASX J11242779+1227034',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00016,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,171.1157083,12.45106,0.082,NULL,60214954369,940858662,14700916,17.3),(80748,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80748,38.06,0.46,409,32186,70,NULL,NULL,'2MASX J11242791+5711145',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,171.116417,57.18744,0,NULL,61988445851,968569466,15133897,18.5),(80749,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80749,38.21,0.46,438,32187,70,NULL,NULL,'2MASX J11242832+2234188',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,171.117875,22.57208,0,NULL,61098256814,954660262,14916566,17.8),(80750,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80750,35.65,0.33,135,32188,70,NULL,NULL,'CGCG 156-073',NULL,'2015arXiv151105856S',2015,1,0.88,NULL,'G',0.00006,NULL,'15.0g',0.51,NULL,NULL,NULL,NULL,NULL,1,171.119125,27.642,0,NULL,60605909899,946967342,14796364,15),(80751,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80751,37.93,0.33,385,32189,70,NULL,NULL,'2MASX J11242964+5748566',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000175,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,171.1234583,57.81567,0,NULL,61988201886,968565654,15133838,17.3),(80752,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80752,36.67,0.46,215,32190,70,NULL,NULL,'2MASX J11243053+0920002',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000171,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,171.127167,9.33344,0.087,NULL,60343899134,942873423,14732397,17.6),(80753,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80753,38.26,0.46,448,32191,70,NULL,NULL,'SDSS J112430.56+495412.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000156,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,171.127333,49.90339,0,NULL,61795378658,965552791,15086762,18.5),(80754,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80754,38.34,0.46,466,32192,70,NULL,NULL,'SDSS J112430.57+084926.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000148,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,171.127375,8.82392,0.117,NULL,60343699045,942870297,14732348,18.8),(80755,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80755,38.16,0.46,428,32193,70,NULL,NULL,'2MASX J11243122+3914080',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,171.130083333,39.23569,0,NULL,60423983199,944124737,14751949,18.2),(80756,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80756,38.43,0.46,486,32194,70,NULL,NULL,'2MASX J11243137+4024060',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,171.1305417,40.40178,0,NULL,63925595708,998837432,15606834,18.3),(80757,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80757,36.82,0.33,231,32195,70,NULL,NULL,'2MASX J11243359+0015578',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00008,NULL,'17.3g',0.27,'NLAGN',NULL,NULL,NULL,'Sy 2',1,171.14,0.26603,0.077,NULL,60164310082,940067345,14688552,17.3),(80758,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80758,35.91,0.27,152,32196,70,NULL,NULL,'2MASX J11243411+3751240',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000172,NULL,'16.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,171.142333,37.85678,0,NULL,60425852326,944153942,14752405,16.4),(80759,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80759,37.08,0.46,261,32197,70,NULL,NULL,'LCRS B112202.1-031657',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00013,NULL,'18.2g',0.1,NULL,NULL,NULL,NULL,NULL,1,171.146833,-3.55725,0.093,NULL,41051308088,641426688,10022292,18.2),(80760,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80760,37.88,0.46,377,32198,70,NULL,NULL,'SDSS J112436.17+473545.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000135,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,171.150708333,47.59589,0,NULL,63892276876,998316826,15598700,18.7),(80761,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80761,38.24,0.27,446,32199,70,NULL,NULL,'SDSS J112436.69+610326.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000153,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,171.152917,61.05728,0,NULL,61859415142,966553361,15102396,18.6),(80762,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80762,35.11,0.33,105,32200,70,NULL,NULL,'CGCG 011-091',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000078,NULL,'15.1g',0.52,'E0',NULL,NULL,NULL,NULL,1,171.154416667,-0.99186,0.113,NULL,40821738126,637839658,9966244,15.1),(80763,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80763,37.36,0.46,296,32201,70,NULL,NULL,'2MASX J11243763+0145528',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000076,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,171.1567083,1.76453,0.089,NULL,60165996951,940093702,14688964,17.6),(80764,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80764,38.24,0.27,446,32202,70,NULL,NULL,'2MASX J11243770+6112491',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000152,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,171.157417,61.21367,0,NULL,61859379412,966552803,15102387,17.3),(80765,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80765,38.49,0.46,498,32203,70,NULL,NULL,'SDSS J112437.80+443802.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000145,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,171.157541667,44.63397,0,NULL,63950568999,999227640,15612931,18.7),(80766,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80766,38,0.46,398,32204,70,NULL,NULL,'2MASX J11243778+5846586',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,171.1577917,58.78292,0,NULL,61982775928,968480873,15132513,17.6),(80767,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80767,37.35,0.46,295,32205,70,NULL,NULL,'2MASX J11243825+3244170',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000158,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,171.159625,32.73814,0.038,NULL,60653658127,947713408,14808022,17.3),(80768,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80768,38.24,0.27,446,32206,70,NULL,NULL,'2MASX J11243849+6104331',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,171.1602917,61.07572,0,NULL,61859429266,966553582,15102399,17.6),(80769,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80769,38.23,0.46,444,32207,70,NULL,NULL,'SDSS J112438.97+583755.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000139,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,171.162416667,58.63214,0,NULL,61982445435,968475709,15132432,18.2),(80770,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80770,36.76,0.46,225,32208,70,NULL,NULL,'SDSS J112439.12+094954.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000034,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,171.1630417,9.83183,0.085,NULL,60343774126,942871470,14732366,17.7),(80771,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80771,37.61,0.46,332,32209,70,NULL,NULL,'2MASX J11243915+3222090',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000205,NULL,'17.18',0.27,NULL,NULL,NULL,NULL,NULL,1,171.163083,32.36919,0.05,NULL,60652823469,947700366,14807818,17.18),(80772,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80772,33.78,0.51,57.1,32210,70,NULL,NULL,'ESO 265- G 031',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'14.79',1,'E - S0',NULL,NULL,NULL,NULL,1,171.165917,-46.26267,0.589,NULL,41886892563,654482696,10226292,14.79),(80773,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80773,36.56,0.46,205,32211,70,NULL,NULL,'VII Zw 398',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,171.166583333,59.92492,0,NULL,61853069896,966454217,15100847,17.1),(80774,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80774,34.2,0.49,69.2,32212,75,NULL,'IR','UGC 06424',NULL,'2011yCatp016004901K',2011,1,1.42,NULL,'G',0.000013,NULL,'15.2g',0.28,'Sdm:',NULL,NULL,NULL,NULL,1,171.168041667,14.9465,0.05,NULL,61109105378,954829771,14919215,15.2),(80775,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80775,37.76,0.46,356,32213,70,NULL,NULL,'2MASX J11244090+4849158',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,171.1704583,48.82119,0,NULL,61748573547,964821461,15075335,17.4),(80776,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80776,37.93,0.33,385,32214,70,NULL,NULL,'2MASX J11244227+5750126',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000183,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,171.176167,57.83675,0,NULL,61988203500,968565679,15133838,17.4),(80777,'Faber-Jackson','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80777,31.25,0.5,17.8,32215,95,NULL,'Weighted Mean','NGC 3665',NULL,'1984ApJS...56...91D',1984,1,2.23,NULL,'G',0.000017,NULL,'11.9g',1.53,'SA(s)0^0^','in a radial-velocity based grouping',NULL,'radio jet',NULL,1,171.181958333,38.76286,0,NULL,60426635647,944166181,14752596,11.9),(80778,'Faber-Jackson','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80778,31.27,0.54,17.9,32215,95,NULL,'de Vaucouleurs','NGC 3665',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80779,'Faber-Jackson','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80779,32.34,1.61,29.4,32215,55,NULL,'Visvanathan & Sandage 1979','NGC 3665',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80780,'Tertiary','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80780,32.29,0.71,28.7,32215,95,NULL,NULL,'NGC 3665',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80781,'Tully est','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80781,32.56,0.8,32.4,32215,75,NULL,'B','NGC 3665',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80782,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80782,31.8,0.45,22.9,32215,NULL,NULL,'K','NGC 3665',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80783,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80783,32.7,0.4,34.7,32215,NULL,NULL,'mean','NGC 3665',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80784,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80784,37.33,0.46,293,32216,70,NULL,NULL,'2MASX J11244403+3459504',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000144,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,171.183583333,34.99739,0.03,NULL,60419712494,944058007,14750906,17.1),(80785,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80785,37.32,0.46,291,32217,70,NULL,NULL,'2MASX J11244423+0944245',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000169,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,171.1842083,9.74008,0.089,NULL,60343756820,942871200,14732362,17.4),(80786,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80786,32.96,NULL,39.1,32218,NULL,NULL,NULL,'SDSS J112444.50+151631.4',NULL,'2015AstBu..70....1K',2015,1,0.7,NULL,'G',0.000137,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,171.185417,15.27542,0.036,NULL,61109562925,954836920,14919326,16.7),(80787,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80787,36.71,0.27,220,32219,70,NULL,NULL,'2MASX J11244617+5554296',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00017,NULL,'16.0g',0.41,'E0',NULL,NULL,NULL,NULL,1,171.1925417,55.90822,0,NULL,61987445832,968553841,15133653,16),(80788,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80788,37.42,0.46,305,32220,70,NULL,NULL,'SDSS J112447.90+022904.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000069,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,171.199625,2.48456,0.073,NULL,60165210317,940081411,14688772,18.4),(80789,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80789,34.89,0.61,95.1,32221,70,NULL,NULL,'2MASX J11244977-1307595',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.00',NULL,NULL,NULL,NULL,NULL,NULL,1,171.207333,-13.13342,0.089,NULL,40985194790,640393668,10006151,16),(80790,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80790,38.39,0.46,475,32222,70,NULL,NULL,'2MASX J11245240+5726567',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,171.2185,57.44908,0,NULL,61988338423,968567787,15133871,18.3),(80791,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80791,33.22,0.2,44.1,32223,74.4,NULL,NULL,'MCG -02-29-027',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.000023,NULL,'13.5',1.1,'SAB(s)b        HII',NULL,NULL,NULL,NULL,1,171.2205,-13.57239,0.065,NULL,40985232394,640394256,10006160,13.5),(80792,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80792,37.18,0.33,273,32224,70,NULL,NULL,'SDSS J112453.55+441148.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000143,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,171.223125,44.19692,0.005,NULL,63943432548,999116133,15611189,18.4),(80793,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80793,37.5,0.46,316,32225,70,NULL,NULL,'LCRS B112220.8-030532',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000113,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,171.225125,-3.36686,0.121,NULL,41051575509,641430867,10022357,17.3),(80794,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80794,38.21,0.21,439,32226,70,NULL,NULL,'2MASX J11245500+4000576',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,171.229375,40.01611,0,NULL,63925577679,998837151,15606830,18.2),(80795,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80795,35.58,0.57,131,32227,70,NULL,NULL,'2MASX J11245523-4511447',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,'SA(rs:)b',NULL,NULL,NULL,NULL,1,171.230083,-45.19575,0.501,NULL,41931719577,655183118,10237236,14.4),(80796,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80796,38.21,0.21,439,32228,70,NULL,NULL,'2MASX J11245529+3956346',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,171.230375,39.94294,0,NULL,63925576673,998837135,15606830,17.7),(80797,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80797,37.9,0.46,381,32229,70,NULL,NULL,'2MASX J11245568+4848408',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000136,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,171.232041667,48.81147,0,NULL,61748561235,964821269,15075332,17.3),(80798,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80798,37.58,0.46,328,32230,70,NULL,NULL,'2MASX J11245615+1835388',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.03',0.16,NULL,NULL,NULL,NULL,NULL,1,171.234125,18.59411,0,NULL,61134893227,955232706,14925511,18.03),(80799,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80799,37.79,0.23,361,32231,70,NULL,NULL,'2MASX J11245711+3323345',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,171.237833333,33.39283,0.029,NULL,60653341164,947708455,14807944,17.4),(80800,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80800,37.18,0.33,273,32232,70,NULL,NULL,'2MASX J11245782+4407053',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000131,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,171.2407917,44.11817,0.045,NULL,63943442182,999116284,15611191,17.2),(80801,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80801,38.15,0.46,427,32233,70,NULL,NULL,'2MASX J11245787+3444225',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,171.241083,34.73964,0.124,NULL,60641691937,947526436,14805100,17.6),(80802,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80802,38.21,0.21,439,32234,70,NULL,NULL,'2MASX J11245849+3957597',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,171.243833333,39.96656,0,NULL,63925576169,998837127,15606830,18),(80803,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80803,37.3,0.33,288,32235,70,NULL,NULL,'CGCG 242-034',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000063,NULL,'15.6g',0.35,'Sa',NULL,NULL,NULL,NULL,1,171.244625,47.14353,0,NULL,63892147084,998314798,15598668,15.6),(80804,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80804,36.85,0.46,235,32236,70,NULL,NULL,'2MASX J11245901+1527245',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000147,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,171.245833,15.45683,0.034,NULL,61109645253,954838207,14919346,16.9),(80805,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2007bm',NULL,80805,31.62,0.33,21,32237,74.2,NULL,'SALT 2','NGC 3672',0.006211,'2010ApJ...716..712A',2010,1,4.2,NULL,'G',0.000013,NULL,'12.20',1.9,'SA(s)c         HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,171.260291667,-9.79539,0.069,NULL,41016648009,640885125,10013830,12.2),(80806,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2007bm',NULL,80806,32.19,0.09,27.4,32237,74.4,NULL,NULL,'NGC 3672',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80807,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80807,31.54,0.25,20.3,32237,NULL,NULL,'Malmquist cor.','NGC 3672',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80808,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80808,31.87,0.4,23.7,32237,NULL,NULL,NULL,'NGC 3672',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80809,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80809,31.94,0.42,24.4,32237,NULL,18.48,'3.6 micron','NGC 3672',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80810,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80810,31.95,0.4,24.5,32237,75,NULL,'HOSTS SN 2007bm','NGC 3672',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80811,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80811,31.96,0.4,24.7,32237,75,NULL,'HOSTS SN 2007bm','NGC 3672',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80812,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80812,32.08,0.43,26,32237,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3672',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80813,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80813,32.09,0.43,26.2,32237,75,NULL,'3.6 micron, color corrected','NGC 3672',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80814,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80814,32.12,0.46,26.6,32237,NULL,NULL,'J','NGC 3672',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80815,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80815,32.18,0.47,27.3,32237,NULL,NULL,'H','NGC 3672',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80816,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80816,32.19,0.09,27.4,32237,74.4,NULL,NULL,'NGC 3672',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80817,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80817,32.2,0.45,27.5,32237,NULL,NULL,'K','NGC 3672',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80818,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80818,32.25,NULL,28.2,32237,NULL,NULL,'I','NGC 3672',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80819,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80819,32.27,0.4,28.4,32237,75,NULL,'B','NGC 3672',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80820,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80820,32.28,0.18,28.6,32237,NULL,NULL,NULL,'NGC 3672',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80821,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80821,32.35,NULL,29.5,32237,NULL,NULL,'B','NGC 3672',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80822,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80822,32.41,0.4,30.3,32237,NULL,NULL,'mean','NGC 3672',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80823,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80823,32.87,0.3,37.5,32237,55,NULL,'B','NGC 3672',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80824,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80824,38.64,0.46,534,32238,70,NULL,NULL,'2MASX J11250312+0808140',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000168,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,171.263083,8.13733,0.174,NULL,60391834748,943622417,14744100,18.1),(80825,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80825,37.75,0.33,355,32239,70,NULL,NULL,'2MASX J11250442+1225106',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,171.268417,12.41953,0.082,NULL,60228736039,941074000,14704281,17.3),(80826,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80826,36.84,0.46,234,32240,70,NULL,NULL,'2MASX J11250480+0408156',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,171.2699583,4.13764,0.093,NULL,60363691495,943182679,14737229,16.8),(80827,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80827,38.14,0.12,425,32241,70,NULL,NULL,'2MASX J11250517+1929458',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,171.271583333,19.49614,0,NULL,61135270061,955238594,14925603,16.8),(80828,'BCG','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80828,37.71,0.35,328,32242,60,NULL,'ABELL 1254, BCG','MCG +12-11-024',0.0628,'1980ApJ...241..486H',1980,1,0.15,NULL,'G',0.000123,NULL,'16',NULL,NULL,NULL,NULL,NULL,NULL,1,171.27775,70.91697,0.037,NULL,61351770806,958621418,14978459,16),(80829,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80829,37.29,0.46,287,32243,70,NULL,NULL,'2MASX J11250702+5411106',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000186,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,171.279458333,54.18614,0,NULL,61761560342,965024380,15078505,16.4),(80830,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80830,36.44,0.27,194,32244,70,NULL,NULL,'2MASX J11250727+4942023',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000163,NULL,'16.0g',0.33,'S0/a',NULL,NULL,NULL,NULL,1,171.2805417,49.70072,0,NULL,61795706223,965557909,15086842,16),(80831,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80831,37.97,0.46,393,32245,70,NULL,NULL,'LCRS B112234.6-031347',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000132,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,171.2824583,-3.50447,0.105,NULL,41051610372,641431412,10022365,18.4),(80832,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80832,37.95,0.33,388,32246,70,NULL,NULL,'2MASX J11250847+5854576',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000187,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,171.285458333,58.91589,0,NULL,61981703442,968464116,15132251,17.5),(80833,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80833,38.21,0.21,439,32247,70,NULL,NULL,'2MASX J11250867+3956368',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,171.286333,39.94358,0,NULL,63925543829,998836622,15606822,17.3),(80834,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80834,37.79,0.23,361,32248,70,NULL,NULL,'2MASX J11250885+3326204',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000195,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,171.286875,33.43894,0.029,NULL,60649914555,947654914,14807108,16.2),(80835,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80835,37.45,0.46,309,32249,70,NULL,NULL,'KUG 1122+258',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000166,NULL,'16.4g',0.31,'Spiral',NULL,NULL,NULL,NULL,1,171.292417,25.62031,0,NULL,60582283411,946598178,14790596,16.4),(80836,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80836,36.08,0.61,164,32250,70,NULL,NULL,'2MASX J11251112-1603246',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.32',0.4,NULL,NULL,NULL,NULL,NULL,1,171.296333333,-16.05708,0.109,NULL,41702939635,651608431,10181381,16.32),(80837,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80837,37.15,0.46,269,32251,70,NULL,NULL,'2MASX J11251204+2542307',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,171.300167,25.70864,0,NULL,60582168608,946596384,14790568,17.2),(80838,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80838,38.21,0.21,439,32252,70,NULL,NULL,'SDSS J112512.09+395353.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000147,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,171.300417,39.89814,0,NULL,60423262893,944113482,14751773,18.4),(80839,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80839,31.2,0.4,17.4,32253,NULL,NULL,NULL,'NGC 3673',NULL,'2009AJ....138..323T',2009,1,3.6,NULL,'G',0.000017,NULL,'12.34',2.4,'SB(r)b         HII',NULL,NULL,NULL,NULL,1,171.3035417,-26.73672,0.249,NULL,41429936919,647342764,10114730,12.34),(80840,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80840,31.4,0.2,19.1,32253,74.4,NULL,NULL,'NGC 3673',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80841,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80841,31.48,0.43,19.8,32253,75,NULL,'3.6 micron, color corrected','NGC 3673',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80842,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80842,31.62,0.43,21.1,32253,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3673',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80843,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80843,31.97,NULL,24.8,32253,NULL,NULL,'B','NGC 3673',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80844,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80844,32,0.47,25.1,32253,NULL,NULL,'H','NGC 3673',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80845,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80845,32.06,0.45,25.8,32253,NULL,NULL,'K','NGC 3673',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80846,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80846,32.06,0.46,25.9,32253,NULL,NULL,'J','NGC 3673',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80847,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80847,32.15,0.4,26.9,32253,NULL,NULL,'mean','NGC 3673',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80848,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80848,32.2,0.4,27.6,32253,75,NULL,'B','NGC 3673',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80849,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80849,36.33,0.46,184,32254,70,NULL,NULL,'2MASX J11251569-0204339',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000158,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,171.3154583,-2.07614,0.145,NULL,40820971009,637827672,9966057,16.4),(80850,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80850,37.71,0.33,349,32255,70,NULL,NULL,'2MASX J11251631+4839154',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,171.317958333,48.65436,0,NULL,63891981985,998312218,15598628,17.1),(80851,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80851,36.44,0.27,194,32256,70,NULL,NULL,'2MASX J11251677+4938224',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000164,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,171.319916667,49.63953,0,NULL,61795714969,965558046,15086844,17.1),(80852,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80852,38.14,0.12,425,32257,70,NULL,NULL,'2MASX J11251762+1932388',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,171.323417,19.54417,0,NULL,61135271778,955238621,14925603,17.7),(80853,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80853,38.09,0.46,416,32258,70,NULL,NULL,'SDSS J112520.10+025800.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000078,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,171.3337917,2.96689,0.077,NULL,60362367521,943161992,14736906,18.8),(80854,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80854,37.95,0.33,388,32259,70,NULL,NULL,'2MASX J11252094+5855001',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000153,NULL,'17.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,171.337458333,58.91675,0,NULL,61981700553,968464071,15132251,17.3),(80855,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80855,38.14,0.12,425,32260,70,NULL,NULL,'2MASX J11252097+1930522',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,171.337541667,19.51461,0,NULL,61135269455,955238585,14925602,17.4),(80856,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80856,37.79,0.23,361,32261,70,NULL,NULL,'2MASX J11252123+3326349',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000161,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,171.3385417,33.44308,0.021,NULL,60649997218,947656206,14807128,18.2),(80857,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80857,37.7,0.46,347,32262,70,NULL,NULL,'2MASX J11252231+0416056',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,171.3430417,4.26817,0.093,NULL,60360762882,943136920,14736514,17.1),(80858,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80858,37.35,0.46,296,32263,70,NULL,NULL,'2MASX J11252256+0937120',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,171.3439583,9.62014,0.09,NULL,60341990890,942843607,14731931,17.4),(80859,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80859,35.95,0.54,155,32264,70,NULL,NULL,'2MASX J11252392-4502555',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,171.349667,-45.04869,0.325,NULL,41886442966,654475671,10226182,16.9),(80860,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80860,37.08,0.46,261,32265,70,NULL,NULL,'2MASX J11252444+3922018',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000176,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,171.3517917,39.36719,0.02,NULL,60423951357,944124239,14751941,16.6),(80861,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80861,38.16,0.46,429,32266,70,NULL,NULL,'2MASX J11252507-0010280',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000069,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,171.354625,-0.17436,0.093,NULL,40821301861,637832841,9966138,18.2),(80862,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80862,31.66,0.2,21.5,32267,74.4,NULL,NULL,'NGC 3669',NULL,'2013AJ....146...86T',2013,1,2.2,NULL,'G',0.000037,NULL,'13.10',0.5,'SBcd: sp','in a radial-velocity based grouping',NULL,NULL,NULL,1,171.3615,57.72125,0,NULL,61988183082,968565360,15133833,13.1),(80863,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80863,31.79,0.43,22.8,32267,75,NULL,'3.6 micron, color corrected','NGC 3669',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80864,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80864,31.91,0.43,24.1,32267,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3669',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80865,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80865,32.49,0.4,31.5,32267,75,NULL,'B','NGC 3669',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80866,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80866,32.73,0.4,35.2,32267,NULL,NULL,'mean','NGC 3669',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80867,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80867,34.09,0.46,65.7,32267,NULL,NULL,'J','NGC 3669',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80868,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80868,34.22,0.47,69.7,32267,NULL,NULL,'H','NGC 3669',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80869,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80869,34.4,0.45,75.8,32267,NULL,NULL,'K','NGC 3669',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80870,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80870,35.94,0.67,154,32268,70,NULL,NULL,'2MASX J11252694-4505025',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.2R',NULL,'E/D',NULL,NULL,NULL,NULL,1,171.3622083,-45.08403,0.325,NULL,41886448769,654475762,10226183,14.2),(80871,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80871,36.15,0.77,170,32269,70,NULL,NULL,'2MASX J11252707-4403345',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,171.3627083,-44.05956,0.345,NULL,41936849686,655263276,10238488,15.6),(80872,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80872,36.66,0.46,215,32270,70,NULL,NULL,'VII Zw 400',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000094,NULL,'16.6g',0.34,'NLAGN',NULL,NULL,NULL,'Sy 2',1,171.365458333,63.79339,0,NULL,61870575247,966727738,15105120,16.6),(80873,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80873,37.71,0.33,349,32271,70,NULL,NULL,'2MASX J11252862+4834014',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000139,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,171.369375,48.567,0,NULL,63891987695,998312307,15598629,18),(80874,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80874,35.63,0.46,134,32272,70,NULL,NULL,'2MASX J11252883+3216089',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000178,NULL,'15.6g',0.41,NULL,NULL,NULL,NULL,NULL,1,171.370167,32.26917,0.035,NULL,60652304901,947692264,14807691,15.6),(80875,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80875,37.79,0.23,361,32273,70,NULL,NULL,'2MASX J11253010+3325419',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000178,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,171.375375,33.42839,0.021,NULL,60653455655,947710244,14807972,17),(80876,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80876,37.54,0.46,321,32274,70,NULL,NULL,'2MASX J11253020+2207123',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,171.375916667,22.12008,0,NULL,61097835590,954653681,14916463,NULL),(80877,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80877,36.49,0.46,198,32275,70,NULL,NULL,'2MASX J11253032+0207124',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000072,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,171.37625,2.12008,0.089,NULL,60166049979,940094530,14688977,16.5),(80878,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80878,32.79,0.69,36.1,32276,100,NULL,'mid-IR','NGC 3668',NULL,'2013ApJ...771...88L',2013,1,1.9,NULL,'G',0.00002,NULL,'13.0g',1.03,'Sbc            LLIRG','Possible field galaxy',NULL,NULL,NULL,1,171.376833,63.44633,0,NULL,61870524237,966726941,15105108,13),(80879,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80879,33.85,0.46,58.9,32276,NULL,NULL,'Malmquist cor.','NGC 3668',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80880,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80880,34.09,0.41,65.7,32276,NULL,NULL,NULL,'NGC 3668',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80881,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80881,34.49,0.2,79.1,32276,74.4,NULL,NULL,'NGC 3668',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80882,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80882,36.03,0.25,161,32277,74.4,NULL,NULL,'CGCG 185-060',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000028,NULL,'15.4',0.5,'BrClG','Brightest group member',NULL,NULL,NULL,1,171.37875,35.50467,0.021,NULL,60422438146,944100596,14751571,15.4),(80883,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80883,36.49,0.46,199,32278,70,NULL,NULL,'2MASX J11253158-0213280',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000162,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,171.3814583,-2.22433,0.117,NULL,40820143197,637814737,9965855,16.8),(80884,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80884,37.86,0.46,373,32279,70,NULL,NULL,'2MASX J11253172+0739122',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,171.382166667,7.65325,0.189,NULL,60394205171,943659455,14744678,18.2),(80885,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80885,37.41,0.46,304,32280,70,NULL,NULL,'2MASX J11253372+1523319',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,171.390625,15.39217,0.034,NULL,61109928879,954842638,14919416,17.2),(80886,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80886,36.12,0.46,168,32281,70,NULL,NULL,'2MASX J11253413+0143034',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000072,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,171.392125,1.71758,0.097,NULL,60165952852,940093013,14688953,16.8),(80887,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80887,37.17,0.46,272,32282,70,NULL,NULL,'2MASX J11253469+5639082',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000205,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,171.394458333,56.65233,0,NULL,61987934485,968561476,15133773,16.2),(80888,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80888,35.11,0.33,105,32283,70,NULL,NULL,'UGC 06435',NULL,'2015arXiv151105856S',2015,1,1.06,NULL,'G',0.000104,NULL,'14.0g',0.92,'S0^0^:',NULL,NULL,NULL,NULL,1,171.396166667,-0.76825,0.113,NULL,40821714506,637839289,9966238,14),(80889,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80889,38.22,0.46,440,32284,70,NULL,NULL,'2MASX J11253520+0254274',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000072,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,171.3965,2.90761,0.073,NULL,60362380629,943162197,14736909,18.1),(80890,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80890,37.63,0.46,336,32285,70,NULL,NULL,'2MASX J11253525+1943323',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.49',0.14,NULL,NULL,NULL,NULL,NULL,1,171.397125,19.72561,0,NULL,61133686442,955213850,14925216,18.49),(80891,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80891,37.81,0.46,364,32286,70,NULL,NULL,'SDSS J112535.93+195716.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,171.39975,19.95464,0,NULL,61133730649,955214541,14925227,18.2),(80892,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80892,35.74,0.58,140,32287,70,NULL,NULL,'2MASX J11253599-4249275',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,171.399875,-42.82422,0.413,NULL,41937062986,655266609,10238540,15.7),(80893,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80893,35.06,0.46,103,32288,70,NULL,NULL,'NGC 3676',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.57',0.4,'poss. LINER',NULL,NULL,NULL,NULL,1,171.40625,-11.13967,0.089,NULL,41010030947,640781733,10012214,14.57),(80894,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80894,37.6,0.46,331,32289,70,NULL,NULL,'2MASX J11253826-0113150',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000085,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,171.4095417,-1.22092,0.113,NULL,40821645000,637838203,9966221,16.9),(80895,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2004as',NULL,80895,35.16,0.17,104,32290,74.2,NULL,'SALT 2','SDSS J112538.81+224952.2',0.031021,'2010ApJ...716..712A',2010,1,0.38,NULL,'G',NULL,NULL,'16.9g',0.34,'S/Irr',NULL,NULL,NULL,NULL,1,171.41175,22.83117,0,NULL,61097998534,954656227,14916503,16.9),(80896,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2004as','R',80896,35.64,0.05,134,32290,NULL,NULL,'MLCS2k2, R(V) = 3.1','SDSS J112538.81+224952.2',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80897,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2004as','R',80897,35.69,0.05,137,32290,NULL,NULL,'MLCS2k2, R(V) = 1.8','SDSS J112538.81+224952.2',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80898,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2004as',NULL,80898,35.74,0.09,141,32290,74.4,NULL,NULL,'SDSS J112538.81+224952.2',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80899,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2004as',NULL,80899,35.81,0.15,141,32290,70,NULL,'SALT 2','SDSS J112538.81+224952.2',0.031021,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80900,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2004as',NULL,80900,35.9,0.03,147,32290,72,NULL,'SALT','SDSS J112538.81+224952.2',0.031021,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80901,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2004as',NULL,80901,36.01,0.15,154,32290,73.8,NULL,'SALT 2 (SNANA)','SDSS J112538.81+224952.2',0.0325,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80902,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2004as',NULL,80902,36.02,0.17,155,32290,65,NULL,'SALT','SDSS J112538.81+224952.2',0.031021,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80903,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2004as',NULL,80903,36.04,0.2,157,32290,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','SDSS J112538.81+224952.2',0.031021,'2011A&A...526A..81B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80904,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2004as',NULL,80904,36.04,0.19,157,32290,65,NULL,'SALT2','SDSS J112538.81+224952.2',0.031021,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80905,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2004as',NULL,80905,36.15,0.15,164,32290,65,NULL,'MLCS17','SDSS J112538.81+224952.2',0.031021,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80906,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2004as',NULL,80906,36.16,0.16,165,32290,65,NULL,'MLCS31','SDSS J112538.81+224952.2',0.031021,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80907,'SNIa','2016-12-15 15:14:47','2016-12-16 11:19:55','1','SN 2004as',NULL,80907,36.4,0.03,184,32290,70,NULL,'SALT 2','SDSS J112538.81+224952.2',0.031021,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80908,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80908,38.04,0.46,405,32291,70,NULL,NULL,'2MASX J11253960+4442272',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000166,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,171.415125,44.70778,0,NULL,63900221966,998440968,15600640,18.1),(80909,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80909,37.65,0.46,339,32292,70,NULL,NULL,'2MASX J11253996+1205512',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000193,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,171.416333333,12.09756,0.098,NULL,60228285128,941066955,14704171,17.1),(80910,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80910,38.22,0.46,440,32293,70,NULL,NULL,'2MASX J11254008+0804152',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,171.417,8.07086,0.167,NULL,60393903588,943654743,14744605,17.5),(80911,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80911,37,0.46,252,32294,70,NULL,NULL,'2MASX J11254008+0820262',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000155,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,171.417,8.34053,0.174,NULL,60393814427,943653350,14744583,16.7),(80912,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80912,37.72,0.46,350,32295,70,NULL,NULL,'SDSS J112540.31+274220.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000144,NULL,'18.4g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,171.418,27.70575,0,NULL,60605858581,946966540,14796352,18.4),(80913,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80913,37.63,0.27,337,32296,70,NULL,NULL,'2MASX J11254080+2636305',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000167,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,171.419917,26.60858,0,NULL,60575692101,946495189,14788987,17.4),(80914,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80914,37.14,0.46,268,32297,70,NULL,NULL,'2MASX J11254227+1958423',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,171.426083,19.97842,0,NULL,61133728611,955214509,14925226,16.5),(80915,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80915,37.76,0.46,357,32298,70,NULL,NULL,'2MASX J11254235+1641189',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'18.04',0.13,NULL,NULL,NULL,NULL,NULL,1,171.4264583,16.68867,0,NULL,61108694461,954823350,14919114,18.04),(80916,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80916,37.23,0.46,279,32299,70,NULL,NULL,'2MASX J11254266-0040320',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000075,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,171.427791667,-0.67564,0.097,NULL,40821925354,637842583,9966290,17.2),(80917,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80917,36.44,0.27,194,32300,70,NULL,NULL,'2MASX J11254386+4940384',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000196,NULL,'15.9g',0.38,'E0',NULL,NULL,NULL,NULL,1,171.4327917,49.67733,0,NULL,61795508463,965554819,15086794,15.9),(80918,'IRAS','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80918,34.4,0.8,75.7,32301,75,NULL,'MAT, I','ESO 216- G 008',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.00002,NULL,'14.58',0.5,'SAB(r)b:',NULL,NULL,NULL,NULL,1,171.4407917,-48.14178,0.473,NULL,41885306747,654457917,10225904,14.58),(80919,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80919,33.49,0.43,49.9,32301,75,NULL,'MAT, I, raw','ESO 216- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80920,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80920,33.56,0.32,51.5,32301,85,NULL,'I, raw','ESO 216- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80921,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80921,33.61,0.32,52.7,32301,85,NULL,'I, inv','ESO 216- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80922,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80922,33.71,0.43,55.1,32301,75,NULL,'MAT, I, inv','ESO 216- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80923,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80923,33.9,0.43,60.4,32301,75,NULL,'MAT, I, cor','ESO 216- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80924,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80924,34.06,0.47,64.9,32301,NULL,NULL,'H','ESO 216- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80925,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80925,34.14,0.49,67.2,32301,75,NULL,'IR','ESO 216- G 008',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80926,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80926,34.22,0.46,69.7,32301,NULL,NULL,'J','ESO 216- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80927,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80927,34.23,0.45,70,32301,NULL,NULL,'K','ESO 216- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80928,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80928,34.23,0.34,70.2,32301,NULL,NULL,NULL,'ESO 216- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80929,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80929,34.26,0.34,71.1,32301,NULL,NULL,'Malmquist cor.','ESO 216- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80930,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80930,34.27,0.2,71.5,32301,74.4,NULL,NULL,'ESO 216- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80931,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80931,34.47,0.4,78.3,32301,NULL,NULL,'mean','ESO 216- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80932,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80932,38.48,0.46,496,32302,70,NULL,NULL,'SDSS J112546.12+103735.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,171.4422083,10.62647,0.108,NULL,60340743103,942824110,14731626,18.2),(80933,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80933,34.6,0.2,83.2,32303,74.4,NULL,NULL,'UGC 06437',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000137,NULL,'14.92',0.5,'Sbc','Group non-member, foreground',NULL,NULL,NULL,1,171.442917,18.94,0,NULL,61136047534,955250742,14925792,14.92),(80934,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80934,34.73,0.37,88.2,32303,NULL,NULL,NULL,'UGC 06437',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80935,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80935,34.79,0.36,91,32303,NULL,NULL,'Malmquist cor.','UGC 06437',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80936,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80936,37.45,0.46,308,32304,70,NULL,NULL,'2MASX J11254684+2220353',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.32',0.14,NULL,NULL,NULL,NULL,NULL,1,171.44525,22.34308,0,NULL,61098312668,954661135,14916580,18.32),(80937,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80937,37.06,0.46,258,32305,70,NULL,NULL,'2MASX J11254716+6506333',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000102,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,171.44625,65.10936,0,NULL,61812838441,965825600,15091025,16.3),(80938,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80938,38.18,0.46,433,32306,70,NULL,NULL,'2MASX J11254749+5606322',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,171.4479583,56.109,0,NULL,61986791575,968543618,15133494,18),(80939,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80939,38.59,0.46,521,32307,70,NULL,NULL,'2MASX J11254797+5353352',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000184,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,171.450125,53.89319,0,NULL,61791111620,965486119,15085720,17.7),(80940,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80940,36.99,0.56,250,32308,70,NULL,NULL,'2MASX J11254864-4905081',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,171.452791667,-49.08561,0.457,NULL,40001188592,625018571,9765915,16.9),(80941,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80941,37.93,0.46,386,32309,70,NULL,NULL,'2MASX J11254890+3049249',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000136,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,171.4537917,30.82369,0,NULL,60663817426,947872147,14810502,18),(80942,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80942,36.48,0.85,197,32310,70,NULL,NULL,'2MASX J11255083-4403449',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,171.461708333,-44.06253,0.345,NULL,41881324835,654395700,10224932,16.7),(80943,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80943,36.55,0.57,204,32311,70,NULL,NULL,'2MASX J11255122-0418450',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,171.4635,-4.31258,0.101,NULL,41049917926,641404967,10021952,16.2),(80944,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80944,36.2,0.46,173,32312,70,NULL,NULL,'2MASX J11255144+2514194',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.38',0.13,NULL,NULL,NULL,NULL,NULL,1,171.4642917,25.23892,0,NULL,60581977733,946593402,14790521,18.38),(80945,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80945,37.17,0.46,271,32313,70,NULL,NULL,'2MASX J11255211+3629049',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000137,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,171.46725,36.48475,0.006,NULL,60420823837,944075372,14751177,17.4),(80946,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80946,37.39,0.46,301,32314,70,NULL,NULL,'2MASX J11255326+3822019',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000193,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,171.4720417,38.36717,0.057,NULL,60425626290,944150410,14752350,17),(80947,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80947,37.63,0.27,337,32315,70,NULL,NULL,'2MASX J11255332+2640144',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,171.472083,26.67086,0,NULL,60575549881,946492966,14788952,17.7),(80948,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80948,31.18,NULL,17.2,32316,NULL,NULL,NULL,'IC 0692',NULL,'2015AstBu..70....1K',2015,1,0.84,NULL,'G',0.000024,NULL,'14.4g',0.54,'E','Group member',NULL,NULL,NULL,1,171.4727917,9.9875,0.096,NULL,60341919417,942842490,14731913,14.4),(80949,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80949,38.55,0.46,512,32317,70,NULL,NULL,'2MASX J11255408+0218184',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000088,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,171.4754583,2.30503,0.065,NULL,60165351844,940083622,14688806,17.8),(80950,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80950,37.94,0.46,388,32318,70,NULL,NULL,'2MASX J11255411+4631580',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000148,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,171.4755417,46.53278,0,NULL,63893452031,998335187,15598987,17.6),(80951,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80951,37.99,0.46,396,32319,70,NULL,NULL,'2MASX J11255430+1940305',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.96',0.16,NULL,NULL,NULL,NULL,NULL,1,171.476375,19.67506,0,NULL,61135723077,955245673,14925713,17.96),(80952,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80952,38.83,0.46,582,32320,70,NULL,NULL,'2MASX J11255498+4815548',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,171.4790417,48.26528,0,NULL,63892703356,998323489,15598804,18.4),(80953,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80953,37.63,0.27,337,32321,70,NULL,NULL,'2MASX J11255533+2641214',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000198,NULL,'16.1g',0.41,NULL,NULL,NULL,NULL,NULL,1,171.480417,26.68939,0,NULL,60575550116,946492970,14788952,16.1),(80954,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80954,38.93,0.46,612,32322,70,NULL,NULL,'SDSS J112555.64+082009.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000161,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,171.481875,8.33597,0.141,NULL,60394024887,943656638,14744634,18.7),(80955,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80955,36.33,0.46,184,32323,70,NULL,NULL,'2MASX J11255610+6113391',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000176,NULL,'16.1g',0.4,'S0',NULL,NULL,NULL,NULL,1,171.483416667,61.22747,0,NULL,61859530371,966555162,15102424,16.1),(80956,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80956,38.48,0.33,496,32324,70,NULL,NULL,'2MASX J11255702-0005025',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000097,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,171.487416667,-0.08408,0.073,NULL,40821076093,637829313,9966083,17.3),(80957,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80957,38.09,0.46,415,32325,70,NULL,NULL,'2MASX J11255701+4946138',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000153,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,171.4874583,49.7705,0,NULL,61795532486,965555195,15086799,17.1),(80958,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80958,37.82,0.46,366,32326,70,NULL,NULL,'2MASX J11255770+3446470',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000173,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,171.490291667,34.77978,0.124,NULL,60641655948,947525874,14805091,17),(80959,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80959,38.48,0.33,496,32327,70,NULL,NULL,'2MASX J11255822-0005395',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000093,NULL,'17.9g',0.19,'NLAGN',NULL,NULL,NULL,NULL,1,171.492667,-0.09431,0.073,NULL,40821074090,637829282,9966082,17.9),(80960,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80960,36.3,0.46,182,32328,70,NULL,NULL,'2MASX J11255860+0049179',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000107,NULL,'15.9g',0.38,'E0',NULL,NULL,NULL,NULL,1,171.494167,0.8215,0.077,NULL,60164544127,940071001,14688609,15.9),(80961,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80961,37.55,0.33,324,32329,70,NULL,NULL,'2MASX J11255935+5644591',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,171.49725,56.74986,0,NULL,61987907614,968561056,15133766,16.7),(80962,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80962,37.72,0.46,350,32330,70,NULL,NULL,'2MASX J11260031+1808046',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.24',0.14,NULL,NULL,NULL,NULL,NULL,1,171.5012917,18.13464,0,NULL,61134471696,955226120,14925408,18.24),(80963,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80963,35.1,0.4,105,32331,NULL,NULL,'mean','UGC 06440',NULL,'2007A&A...465...71T',2007,1,1.16,NULL,'G',0.000074,NULL,'14.3g',0.71,'SB(rs)bc',NULL,NULL,NULL,NULL,1,171.5042083,1.98414,0.097,NULL,60165795035,940090547,14688914,14.3),(80964,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80964,35.45,0.47,123,32331,NULL,NULL,'H','UGC 06440',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80965,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,NULL,80965,35.56,0.46,129,32331,NULL,NULL,'J','UGC 06440',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80966,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80966,38.5,0.46,502,32332,70,NULL,NULL,'2MASX J11260113+3202360',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,171.504583,32.04331,0.034,NULL,60652490487,947695163,14807736,17.9),(80967,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80967,31.57,NULL,20.6,32333,NULL,NULL,NULL,'SDSS J112603.36+080432.3',NULL,'2015AstBu..70....1K',2015,1,NULL,NULL,'G',0.000058,NULL,'18.5g',NULL,NULL,NULL,NULL,NULL,NULL,1,171.514167,8.07556,0.167,NULL,60393906480,943654788,14744606,18.5),(80968,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80968,37.14,0.33,268,32334,70,NULL,NULL,'2MASX J11260402+6245461',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000166,NULL,'16.2g',0.36,'S0/a',NULL,NULL,NULL,NULL,1,171.516958333,62.76292,0,NULL,61874326083,966786345,15106036,16.2),(80969,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80969,37.93,0.46,386,32335,70,NULL,NULL,'2MASX J11260416+3520360',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000171,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,171.51725,35.34325,0,NULL,60419658507,944057164,14750893,16.4),(80970,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80970,36.72,0.23,221,32336,70,NULL,NULL,'2MASX J11260672+5707517',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,171.528125,57.13122,0,NULL,61987956132,968561814,15133778,17.3),(80971,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80971,36.49,0.46,198,32337,70,NULL,NULL,'2MASX J11260687+0750137',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000167,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,171.52875,7.83717,0.177,NULL,60394213763,943659590,14744681,16.3),(80972,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80972,35.96,0.27,155,32338,70,NULL,NULL,'2MASX J11260726+3514430',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000157,NULL,'16.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,171.5302917,35.24533,0,NULL,60419652344,944057067,14750891,16.7),(80973,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80973,37.53,0.46,321,32339,70,NULL,NULL,'2MASX J11260801+0039129',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000099,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,171.533291667,0.65364,0.073,NULL,60164214099,940065845,14688528,16.4),(80974,'FP','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80974,37.55,0.33,324,32340,70,NULL,NULL,'2MASX J11260809+5644337',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000196,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,171.533916667,56.74275,0,NULL,61987908536,968561070,15133766,16.8),(80975,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:55','1',NULL,'R',80975,31.2,NULL,17.4,32341,NULL,NULL,NULL,'SDSS J112608.29+040344.5',NULL,'2015AstBu..70....1K',2015,1,0.48,NULL,'G',0.000011,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,171.534583333,4.06236,0.085,NULL,60354489144,943038892,14734982,16.7),(80976,'IRAS','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,80976,30.77,0.8,14.3,32342,75,NULL,'W91CL, r','NGC 3675',NULL,'1997ApJS..109..333W',1997,1,5.9,NULL,'G',0.000005,NULL,'11.00',3.1,'SA(s)b;HII     LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,171.53575,43.58592,0,NULL,63898517660,998414338,15600224,11),(80977,'IRAS','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,80977,30.82,0.8,14.6,32342,75,NULL,'A82, H','NGC 3675',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80978,'Sosies','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,80978,31.33,0.1,18.5,32342,NULL,NULL,NULL,'NGC 3675',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80979,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,80979,28.95,0.69,6.16,32342,100,NULL,'mid-IR','NGC 3675',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80980,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,80980,30.53,0.4,12.8,32342,75,NULL,'B','NGC 3675',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80981,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,80981,30.8,0.35,14.5,32342,NULL,NULL,NULL,'NGC 3675',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80982,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,80982,31.03,0.4,16.1,32342,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 3675',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80983,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,80983,31.11,NULL,16.7,32342,NULL,NULL,'B','NGC 3675',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80984,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,80984,31.11,0.06,16.7,32342,NULL,NULL,NULL,'NGC 3675',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80985,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,80985,31.3,0.47,18.2,32342,75,NULL,'A82, H, raw','NGC 3675',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80986,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,80986,31.32,0.38,18.4,32342,75,NULL,'W91CL, r, raw','NGC 3675',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80987,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,80987,31.39,0.43,18.9,32342,75,NULL,'3.6 micron, color corrected','NGC 3675',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80988,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,80988,31.42,0.43,19.2,32342,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3675',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80989,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,80989,31.46,0.2,19.6,32342,74.4,NULL,NULL,'NGC 3675',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80990,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,80990,31.46,0.38,19.6,32342,75,NULL,'W91CL, r, cor','NGC 3675',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80991,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,80991,31.51,0.47,20.1,32342,75,NULL,'A82, H, inv','NGC 3675',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80992,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,80992,31.52,0.38,20.1,32342,75,NULL,'W91CL, r, inv','NGC 3675',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80993,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,80993,31.53,0.47,20.2,32342,75,NULL,'A82, H, cor','NGC 3675',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80994,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',80994,31.83,NULL,23.2,32342,NULL,NULL,'LEDA [April 2006]','NGC 3675',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80995,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,80995,35.43,0.6,122,32343,70,NULL,NULL,'2MASX J11260912-3533473',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,171.537958333,-35.56311,0.289,NULL,41384936165,646639627,10103744,15.2),(80996,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',80996,35.37,0.46,118,32344,70,NULL,NULL,'2MASX J11260983+5210319',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000168,NULL,'16.1g',0.3,'S0',NULL,NULL,NULL,NULL,1,171.540875,52.17556,0,NULL,61791990934,965499858,15085935,16.1),(80997,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',80997,36.91,0.46,241,32345,70,NULL,NULL,'2MASX J11261057+0941367',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,171.544,9.69367,0.063,NULL,60342086865,942845107,14731954,17.5),(80998,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',80998,38.44,0.46,488,32346,70,NULL,NULL,'2MASX J11261090+0203569',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,171.545333333,2.06575,0.097,NULL,60177122910,940267545,14691680,17.9),(80999,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',80999,36.72,0.23,221,32347,70,NULL,NULL,'2MASX J11261102+5706108',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000199,NULL,'15.8g',0.44,'E0',NULL,NULL,NULL,NULL,1,171.545875,57.10306,0,NULL,61987958517,968561851,15133778,15.8),(81000,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81000,37.53,0.46,321,32348,70,NULL,NULL,'2MASX J11261176+2616095',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000142,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,171.549041667,26.26931,0,NULL,60582003330,946593802,14790528,17.3),(81001,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81001,36.43,0.33,193,32349,70,NULL,NULL,'2MASX J11261208+6017322',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000174,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,171.5500417,60.29236,0,NULL,61852825850,966450403,15100787,16.2),(81002,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81002,36.11,0.46,167,32350,70,NULL,NULL,'2MASX J11261350+5559398',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000157,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,171.5564583,55.99439,0,NULL,61986766218,968543222,15133487,16.5),(81003,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81003,35.7,0.46,138,32351,70,NULL,NULL,'2MASX J11261356+3759457',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000173,NULL,'16.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,171.5565,37.99606,0,NULL,60426232460,944159882,14752498,16.1),(81004,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81004,36.71,0.46,220,32352,70,NULL,NULL,'SDSS J112613.64+583902.6',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,171.556875,58.65075,0,NULL,61982127022,968470734,15132355,17.4),(81005,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81005,37.25,0.46,282,32353,70,NULL,NULL,'2MASX J11261377+1501496',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,171.557417,15.03042,0.049,NULL,61109869336,954841708,14919401,17.7),(81006,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81006,37.77,0.46,358,32354,70,NULL,NULL,'SDSS J112613.91+103810.0',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,171.5579583,10.63611,0.125,NULL,60340779733,942824683,14731635,18.1),(81007,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81007,34.81,0.49,91.7,32355,75,NULL,'IR','UGC 06442',NULL,'2011yCatp016004901K',2011,1,1.58,NULL,'G',0.000016,NULL,'16.0g',0.18,'Sd',NULL,NULL,NULL,NULL,1,171.5585,7.84206,0.177,NULL,60394216830,943659637,14744681,16),(81008,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81008,34.96,NULL,98,32355,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06442',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81009,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81009,34.97,NULL,98.5,32355,NULL,NULL,'Dipole + Quadrupole','UGC 06442',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81010,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81010,34.98,NULL,99.1,32355,NULL,NULL,'Dipole','UGC 06442',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81011,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81011,35.01,NULL,100,32355,NULL,NULL,NULL,'UGC 06442',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81012,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81012,35.1,0.53,105,32355,NULL,NULL,'Malmquist cor.','UGC 06442',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81013,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81013,35.24,0.2,112,32355,74.4,NULL,NULL,'UGC 06442',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81014,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81014,35.29,0.49,114,32355,NULL,NULL,NULL,'UGC 06442',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81015,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81015,37.63,0.46,335,32356,70,NULL,NULL,'2MASX J11261401+4824179',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000135,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,171.558375,48.40492,0,NULL,63892020514,998312820,15598637,17.7),(81016,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81016,36.33,0.58,185,32357,70,NULL,NULL,'2MASX J11261402-0455275',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'16.68',0.21,NULL,NULL,NULL,NULL,NULL,1,171.558416667,-4.92439,0.113,NULL,41048151848,641377372,10021521,16.68),(81017,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81017,38.66,0.46,541,32358,70,NULL,NULL,'SDSS J112614.12+323401.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,171.558875,32.56697,0.033,NULL,60652912082,947701751,14807839,18.4),(81018,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81018,37.61,0.46,332,32359,70,NULL,NULL,'2MASX J11261511+1901107',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,171.562917,19.01967,0,NULL,61136048679,955250760,14925793,NULL),(81019,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81019,37.79,0.46,361,32360,70,NULL,NULL,'2MASX J11261557+1540186',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,171.5647917,15.67203,0.053,NULL,61109577894,954837154,14919330,17.4),(81020,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81020,36.11,0.25,167,32361,74.4,NULL,NULL,'2MASX J11261568+3519430',NULL,'2013AJ....146...86T',2013,1,0.34,NULL,'G',0.000031,NULL,'16.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,171.565333,35.32853,0,NULL,60419641977,944056905,14750889,16.8),(81021,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81021,38.11,0.46,419,32362,70,NULL,NULL,'2MASX J11261612+0118399',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000089,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,171.567375,1.31114,0.081,NULL,60178307869,940286060,14691969,17.3),(81022,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81022,35.27,0.72,113,32363,70,NULL,NULL,'2MASX J11261684-4554349',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,171.57025,-45.90972,0.601,NULL,41887362105,654490032,10226406,14.9),(81023,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81023,38.05,0.46,408,32364,70,NULL,NULL,'SDSS J112617.07+564818.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,171.571167,56.80517,0,NULL,61987911135,968561111,15133767,18.3),(81024,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81024,35.96,0.27,155,32365,70,NULL,NULL,'CGCG 185-063 NED01',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000022,NULL,'15.31',0.45,NULL,'Brightest group member',NULL,NULL,NULL,1,171.571916667,35.34019,0,NULL,60419760200,944058753,14750918,15.31),(81025,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81025,34.84,0.48,92.8,32366,70,NULL,NULL,'MCG -02-29-030',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.00015,NULL,'15.22',0.2,NULL,NULL,NULL,NULL,NULL,1,171.5727083,-14.28031,0.073,NULL,40976409654,640256400,10004006,15.22),(81026,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81026,35.25,0.25,112,32367,74.4,NULL,NULL,'CGCG 185-063',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'GPair',0.000093,NULL,NULL,NULL,'14.717','Group member',NULL,NULL,NULL,1,171.574167,35.34472,0,NULL,60419760233,944058753,14750918,NULL),(81027,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81027,37.53,0.46,320,32368,70,NULL,NULL,'2MASX J11261837+3027080',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,171.5767083,30.45228,0,NULL,60661397281,947834332,14809911,17.2),(81028,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81028,35.96,0.27,155,32369,70,NULL,NULL,'CGCG 185-063 NED02',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000019,NULL,'16.0g',0.31,NULL,NULL,NULL,NULL,NULL,1,171.5767083,35.34933,0,NULL,60419760363,944058755,14750918,16),(81029,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81029,37.83,0.46,367,32370,70,NULL,NULL,'2MASX J11261887+5145348',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000174,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,171.578583,51.75986,0,NULL,61806039343,965719364,15089365,16.8),(81030,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81030,37.84,0.46,370,32371,70,NULL,NULL,'2MASX J11262043+2956210',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000185,NULL,'18.27',0.17,NULL,NULL,NULL,NULL,NULL,1,171.58525,29.93903,0,NULL,60662109378,947845459,14810085,18.27),(81031,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81031,36.32,0.46,184,32372,70,NULL,NULL,'LCRS B112347.9-031422',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,171.587917,-3.51467,0.153,NULL,41046587818,641352934,10021139,16.8),(81032,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81032,37.15,0.46,269,32373,70,NULL,NULL,'2MASX J11262203+0242439',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000092,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,171.59175,2.71208,0.065,NULL,60176787898,940262310,14691598,16.5),(81033,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81033,36.73,0.46,222,32374,70,NULL,NULL,'2MASX J11262258+1031047',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000172,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,171.594,10.51803,0.108,NULL,60340801997,942825031,14731641,17),(81034,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81034,37.2,0.46,275,32375,70,NULL,NULL,'2MASX J11262303+4141068',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,171.596125,41.68536,0,NULL,63942622706,999103479,15610991,17.1),(81035,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81035,35.46,0.46,123,32376,70,NULL,NULL,'2MASX J11262391+0604327',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000177,NULL,'16.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,171.5995,6.07567,0.101,NULL,60395077830,943673091,14744892,16.4),(81036,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81036,37.14,0.33,268,32377,70,NULL,NULL,'2MASX J11262441+6244302',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000144,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,171.602,62.74161,0,NULL,61874259661,966785307,15106020,18),(81037,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81037,38.3,0.46,456,32378,70,NULL,NULL,'SDSS J112624.54+061249.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,171.6022917,6.21375,0.101,NULL,60395086168,943673221,14744894,18.3),(81038,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81038,38.04,0.46,405,32379,70,NULL,NULL,'SDSS J112624.75+382107.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00019,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,171.603166667,38.35219,0.057,NULL,60425598781,944149980,14752343,18.3),(81039,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81039,37.36,0.46,296,32380,70,NULL,NULL,'2MASX J11262508+2826561',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000183,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,171.604583,28.44908,0,NULL,60604343009,946942859,14795982,16.5),(81040,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81040,36.85,0.46,235,32381,70,NULL,NULL,'2MASX J11262523+5205038',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000192,NULL,'16.2g',0.4,'AGN',NULL,NULL,NULL,NULL,1,171.6049583,52.08433,0,NULL,61805793506,965715523,15089305,16.2),(81041,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81041,36.01,0.2,159,32382,74.4,NULL,NULL,'IC 2819',NULL,'2013AJ....146...86T',2013,1,0.52,NULL,'G',0.00052,NULL,'15.7',0.15,NULL,NULL,NULL,NULL,NULL,1,171.614333,13.84489,0.066,NULL,60228097951,941064030,14704125,15.7),(81042,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81042,37.83,0.46,368,32383,70,NULL,NULL,'2MASX J11262869+5918068',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,171.619417,59.30175,0,NULL,61850838231,966419347,15100302,18.1),(81043,'Ring Diameter','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81043,32.2,0.84,27,32384,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3681',NULL,'1981ApJS...45..541P',1981,1,2.5,NULL,'G',0.000013,NULL,'11.9',2,'SAB(r)bc       LINER','X-ray-bright group member',NULL,NULL,NULL,1,171.624167,16.86319,0.006,NULL,61108668817,954822950,14919108,11.9),(81044,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81044,31.92,0.4,24.2,32384,75,NULL,'B','NGC 3681',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81045,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81045,36.87,0.46,236,32385,70,NULL,NULL,'2MASX J11263082+0344546',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000159,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,171.628375,3.74864,0.085,NULL,60354587279,943040426,14735006,17),(81046,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81046,34.92,0.46,96.5,32386,70,NULL,NULL,'CGCG 242-036',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000147,NULL,'15.4g',0.31,'E','Pair member (points to parent)',NULL,NULL,NULL,1,171.6285417,46.99842,0,NULL,63895731585,998370806,15599543,15.4),(81047,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81047,37.9,0.46,380,32387,70,NULL,NULL,'SDSS J112631.33+065231.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,171.630583,6.87531,0.153,NULL,60395614809,943681481,14745023,18),(81048,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81048,37.37,0.46,298,32388,70,NULL,NULL,'LCRS B112358.5-023837',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000161,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,171.632416667,-2.91847,0.109,NULL,40825264312,637894754,9967105,17.2),(81049,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81049,37.57,0.27,326,32389,70,NULL,NULL,'2MASX J11263263+5422128',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000182,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,171.635875,54.37014,0,NULL,61761950778,965030480,15078601,17.6),(81050,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81050,37.22,1.04,277,32390,70,NULL,NULL,'2MASX J11263272-4453473',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000103,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,171.636291667,-44.89647,0.301,NULL,41886457834,654475903,10226185,14.1),(81051,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81051,36.35,0.46,187,32391,70,NULL,NULL,'2MASX J11263351+2620551',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000178,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,171.63975,26.34867,0,NULL,60576762230,946511909,14789248,16.4),(81052,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81052,33.53,0.2,50.8,32392,74.4,NULL,NULL,'IC 2822',NULL,'2013AJ....146...86T',2013,1,1.33,NULL,'G',0.00001,NULL,'14.9g',0.61,'SBbc',NULL,NULL,NULL,NULL,1,171.641875,11.44008,0.116,NULL,60340455911,942819623,14731556,14.9),(81053,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81053,33.73,0.49,55.8,32392,NULL,NULL,'Malmquist cor.','IC 2822',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81054,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81054,33.75,0.49,56.2,32392,NULL,NULL,NULL,'IC 2822',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81055,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81055,33.71,0.48,55.2,32393,70,NULL,NULL,'ESO 265- G 033',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00008,NULL,'14.57',0.4,'S0:',NULL,NULL,NULL,NULL,1,171.6452917,-43.05872,0.357,NULL,41881928466,654405132,10225080,14.57),(81056,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81056,36.86,0.46,236,32394,70,NULL,NULL,'2MASX J11263631+6039212',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000189,NULL,'16.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,171.651125,60.65586,0,NULL,61851807832,966434497,15100539,16.2),(81057,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81057,36.96,0.46,246,32395,70,NULL,NULL,'MCG +09-19-077',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000195,NULL,'15.6g',0.48,'E0',NULL,NULL,NULL,NULL,1,171.654,55.35642,0,NULL,61987144294,968549129,15133580,15.6),(81058,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81058,36.08,0.46,164,32396,70,NULL,NULL,'2MASX J11263797+4637320',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000166,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,171.658167,46.62567,0,NULL,63895732656,998370822,15599544,16.6),(81059,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81059,37.57,0.27,326,32397,70,NULL,NULL,'SDSS J112639.56+542100.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000172,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,171.664833333,54.35,0,NULL,61761951731,965030495,15078601,18.5),(81060,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81060,38.5,0.46,500,32398,70,NULL,NULL,'2MASX J11263959+1555011',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,171.6650417,15.917,0.016,NULL,61110087152,954845111,14919454,17.9),(81061,'IRAS','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81061,30.61,0.8,13.2,32399,75,NULL,'W91CL, r','UGC 06446',NULL,'1997ApJS..109..333W',1997,1,1.25,NULL,'G',0.000002,NULL,'14.7g',0.97,'SAd','in a radial-velocity based grouping',NULL,NULL,NULL,1,171.668583,53.74667,0,NULL,61791031561,965484868,15085701,14.7),(81062,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81062,30.88,0.38,15,32399,75,NULL,'W91CL, r, inv','UGC 06446',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81063,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81063,30.96,0.38,15.5,32399,75,NULL,'W91CL, r, raw','UGC 06446',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81064,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81064,30.97,0.11,15.7,32399,NULL,NULL,NULL,'UGC 06446',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81065,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81065,31.14,0.38,16.9,32399,75,NULL,'W91CL, r, cor','UGC 06446',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81066,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81066,31.15,0.4,17,32399,75,NULL,'B','UGC 06446',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81067,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81067,31.28,0.36,18,32399,NULL,NULL,NULL,'UGC 06446',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81068,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81068,37.8,0.46,363,32400,70,NULL,NULL,'SDSS J112640.75+344246.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000054,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,171.669833,34.71286,0.037,NULL,60641320835,947520638,14805009,18.2),(81069,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81069,35.78,0.46,143,32401,70,NULL,NULL,'2MASX J11264134+3520350',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00019,NULL,'15.8g',0.42,NULL,NULL,NULL,NULL,NULL,1,171.672208333,35.34306,0,NULL,60419762411,944058787,14750918,15.8),(81070,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81070,39.39,0.46,756,32402,70,NULL,NULL,'2MASX J11264208+2244569',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,171.675417,22.749,0,NULL,61098041935,954656905,14916514,NULL),(81071,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81071,37.66,0.46,340,32403,70,NULL,NULL,'2MASX J11264227-0127321',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,171.6762083,-1.459,0.097,NULL,40834711040,638042360,9969411,17.3),(81072,'Tully est','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81072,31.87,0.8,23.7,32404,75,NULL,'B','IC 0691',NULL,'1988NBGC.C....0000T',1988,1,0.9,NULL,'G',0.000008,NULL,'14.2g',0.54,'I?;WR?         HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,171.684667,59.15542,0,NULL,61981624941,968462889,15132232,14.2),(81073,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81073,36.32,0.46,184,32405,70,NULL,NULL,'2MASX J11264743+0223136',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000087,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,171.6975417,2.38706,0.065,NULL,60176856160,940263377,14691615,16.2),(81074,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81074,37.41,0.46,303,32406,70,NULL,NULL,'SDSS J112648.17+015352.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000153,NULL,'18.6g',0.09,NULL,NULL,NULL,NULL,NULL,1,171.700708333,1.89792,0.105,NULL,60177214825,940268981,14691702,18.6),(81075,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81075,37.67,0.27,341,32407,70,NULL,NULL,'2MASX J11265021+5358335',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,171.709083,53.976,0,NULL,61761616164,965025252,15078519,17.2),(81076,'Tully est','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81076,31.4,0.8,19,32408,75,NULL,'B','UGC 06448',NULL,'1988NBGC.C....0000T',1988,1,1.09,NULL,'G',0.000007,NULL,'15.0g',0.53,'Pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,171.710166667,64.13794,0,NULL,61868290184,966692034,15104563,15),(81077,'BCG','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81077,37.71,0.35,328,32409,60,NULL,NULL,'ABELL 1254',0.0628,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,171.713917,71.07486,0.041,NULL,61351701830,958620341,14978442,NULL),(81078,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81078,38.04,0.46,406,32410,70,NULL,NULL,'2MASX J11265189+2353113',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,171.716167,23.88647,0,NULL,60572403055,946443797,14788184,NULL),(81079,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81079,37.12,0.46,266,32411,70,NULL,NULL,'2MASX J11265266+3136009',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000179,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,171.719375,31.60036,0.04,NULL,60664307947,947879811,14810622,16.5),(81080,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81080,35.47,0.54,124,32412,70,NULL,NULL,'2MASX J11265274-0805264',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000097,NULL,'16.20',NULL,NULL,NULL,NULL,NULL,NULL,1,171.719667,-8.09075,0.061,NULL,41067425478,641678523,10026226,16.2),(81081,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81081,36.38,0.46,189,32413,70,NULL,NULL,'2MASX J11265303+0937000',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000164,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,171.7207917,9.61678,0.057,NULL,60342384442,942849756,14732027,16.2),(81082,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81082,37.38,0.46,299,32414,70,NULL,NULL,'2MASX J11265384+0236440',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000077,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,171.724375,2.612,0.065,NULL,60176977521,940265273,14691644,17.1),(81083,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81083,35.19,0.68,109,32415,70,NULL,NULL,'2MASX J11265409-7509020',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9b',NULL,'(R\'_2)SB(s)ab:',NULL,NULL,NULL,NULL,1,171.725667,-75.15072,0.569,NULL,39835263653,622425994,9725406,15.9),(81084,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81084,37.67,0.27,341,32416,70,NULL,NULL,'2MASX J11265461+5404163',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000183,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,171.727333333,54.07111,0,NULL,61761650366,965025786,15078527,16.9),(81085,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81085,35.33,0.46,117,32417,70,NULL,NULL,'CGCG 268-037',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000185,NULL,'15.1g',0.61,'E0',NULL,NULL,NULL,NULL,1,171.735666667,50.597,0,NULL,61797907526,965592305,15087379,15.1),(81086,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81086,34.17,0.46,68.4,32418,70,NULL,NULL,'ARK 293',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000092,NULL,'14.3g',0.74,'E?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,171.735917,63.42539,0.005,NULL,61871178836,966737169,15105268,14.3),(81087,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81087,37.15,0.46,270,32419,70,NULL,NULL,'2MASX J11265679+0642356',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,171.736791667,6.70981,0.153,NULL,60395719007,943683109,14745048,17.7),(81088,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81088,37.59,0.46,329,32420,70,NULL,NULL,'2MASX J11265742+5607413',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000142,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,171.739375,56.128,0,NULL,61986718466,968542476,15133476,17.5),(81089,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81089,37.88,0.46,377,32421,70,NULL,NULL,'2MASX J11265877+1528160',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,171.74475,15.47097,0.032,NULL,61109737614,954839650,14919369,18.1),(81090,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81090,37.22,0.46,279,32422,70,NULL,NULL,'2MASX J11265933+5341325',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000164,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,171.7475417,53.69236,0,NULL,61791061184,965485331,15085708,17),(81091,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81091,37.53,0.19,321,32423,70,NULL,NULL,'2MASX J11270034+0123080',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000112,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,171.75125,1.38558,0.081,NULL,60178341885,940286591,14691977,16.7),(81092,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81092,36.91,0.46,241,32424,70,NULL,NULL,'SDSS J112700.72+670038.2',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000062,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,171.753,67.01064,0,NULL,62089368371,970146380,15158537,17.7),(81093,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81093,37.67,0.27,341,32425,70,NULL,NULL,'SDSS J112700.97+540335.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000137,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,171.754083,54.05997,0,NULL,61761650627,965025791,15078527,17.7),(81094,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81094,37.57,0.27,326,32426,70,NULL,NULL,'2MASX J11270109+5422383',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000201,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,171.7547917,54.37736,0,NULL,61761967875,965030748,15078605,16.2),(81095,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81095,38.4,0.46,479,32427,70,NULL,NULL,'2MASX J11270156+2555324',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,171.756417,25.92575,0,NULL,60578701668,946542213,14789722,17.7),(81096,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81096,37.53,0.46,321,32428,70,NULL,NULL,'2MASX J11270198+5740553',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000179,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,171.758417,57.68211,0,NULL,61991076556,968610571,15134540,17.2),(81097,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81097,37.37,0.46,298,32429,70,NULL,NULL,'2MASX J11270216+0703546',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.54',0.16,NULL,NULL,NULL,NULL,NULL,1,171.759125,7.06519,0.153,NULL,60395518093,943679970,14744999,18.54),(81098,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81098,38.87,0.46,595,32430,70,NULL,NULL,'SDSS J112702.24+470001.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000171,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,171.759417,47.00031,0,NULL,63895727444,998370741,15599542,18.7),(81099,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81099,36.72,0.23,221,32431,70,NULL,NULL,'2MASX J11270338+5654083',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000165,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,171.76425,56.90242,0,NULL,61991437468,968616210,15134628,16.5),(81100,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81100,37.5,0.27,316,32432,70,NULL,NULL,'2MASX J11270470+1817018',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.07',0.15,NULL,NULL,NULL,NULL,NULL,1,171.7695,18.28394,0,NULL,61126318047,955098719,14923417,18.07),(81101,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81101,37.67,0.46,343,32433,70,NULL,NULL,'2MASX J11270640+1139517',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000164,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,171.7767083,11.66439,0.115,NULL,60219925208,940936331,14702130,17.2),(81102,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81102,37.73,0.46,352,32434,70,NULL,NULL,'2MASX J11270877+1916488',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,171.786583,19.28028,0,NULL,61135948032,955249188,14925768,17.4),(81103,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81103,37.47,0.46,312,32435,70,NULL,NULL,'2MASX J11270934+0115100',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000087,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,171.788875,1.25261,0.085,NULL,60178519719,940289370,14692021,16.7),(81104,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81104,38.18,0.46,432,32436,70,NULL,NULL,'2MASX J11270936+5002354',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000132,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,171.788875,50.04311,0,NULL,61798667327,965604176,15087565,17.9),(81105,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81105,38.74,0.46,560,32437,70,NULL,NULL,'2MASX J11271030+3518567',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,171.79275,35.31578,0,NULL,60419973201,944062081,14750970,18.1),(81106,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81106,36.9,0.46,239,32438,70,NULL,NULL,'SDSS J112710.55+584811.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000148,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,171.7939583,58.80328,0,NULL,61981674580,968463665,15132244,18.1),(81107,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81107,35.89,0.46,151,32439,70,NULL,NULL,'2MASX J11271075+4230145',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000177,NULL,'16.1g',0.3,'S0^-',NULL,NULL,NULL,NULL,1,171.794917,42.50392,0,NULL,63899436424,998428694,15600448,16.1),(81108,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81108,30.76,NULL,14.2,32440,NULL,NULL,NULL,'IC 2828',NULL,'2015AstBu..70....1K',2015,1,0.73,NULL,'G',0.00004,NULL,'15.1g',0.45,'S0?;WR         HII',NULL,NULL,NULL,NULL,1,171.795583,8.73106,0.134,NULL,60386680703,943541885,14742841,15.1),(81109,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81109,31.57,0.4,20.6,32441,NULL,NULL,NULL,'NGC 3684',NULL,'2009AJ....138..323T',2009,1,3.1,NULL,'G',0.000013,NULL,'12.0',2.1,'SA(rs)bc       HII','X-ray-bright group member',NULL,NULL,NULL,1,171.796667,17.03017,0.006,NULL,61108595107,954821798,14919090,12),(81110,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81110,31.83,0.4,23.2,32441,NULL,NULL,'mean','NGC 3684',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81111,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81111,31.84,0.4,23.4,32441,75,NULL,'B','NGC 3684',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81112,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81112,31.89,0.3,23.9,32441,55,NULL,'B','NGC 3684',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81113,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81113,31.99,0.45,25,32441,NULL,NULL,'K','NGC 3684',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81114,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81114,32.02,0.46,25.3,32441,NULL,NULL,'J','NGC 3684',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81115,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81115,32.02,0.47,25.3,32441,NULL,NULL,'H','NGC 3684',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81116,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81116,38.16,0.33,428,32442,70,NULL,NULL,'2MASX J11271266+2003068',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.40',0.13,NULL,NULL,NULL,NULL,NULL,1,171.802666667,20.05186,0,NULL,61135670296,955244848,14925700,18.4),(81117,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81117,37.66,0.46,340,32443,70,NULL,NULL,'2MASX J11271324+0736437',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,171.805333,7.61206,0.181,NULL,60394158524,943658726,14744667,18.1),(81118,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81118,37.83,0.46,369,32444,70,NULL,NULL,'2MASX J11271484+2140118',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,171.8117917,21.66978,0,NULL,61129424066,955147251,14924175,18.3),(81119,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81119,38.4,0.46,478,32445,70,NULL,NULL,'2MASX J11271732+2545323',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,171.82225,25.75892,0,NULL,60579172355,946549568,14789837,17.7),(81120,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81120,34.03,NULL,64.1,32446,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06454',NULL,'2010Ap&SS.325..163P',2010,1,1.66,NULL,'G',0.000023,NULL,'15.7g',0.2,'Sd',NULL,NULL,NULL,NULL,1,171.828917,38.66425,0,NULL,60425526115,944148845,14752325,15.7),(81121,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81121,34.04,NULL,64.4,32446,NULL,NULL,'Dipole + Quadrupole','UGC 06454',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81122,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81122,34.04,NULL,64.4,32446,NULL,NULL,'Dipole','UGC 06454',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81123,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81123,34.11,NULL,66.3,32446,NULL,NULL,NULL,'UGC 06454',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81124,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81124,34.11,0.49,66.5,32446,75,NULL,'IR','UGC 06454',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81125,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81125,37.53,0.19,321,32447,70,NULL,NULL,'SDSS J112719.86+012822.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000069,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,171.8327917,1.473,0.081,NULL,60178857758,940294652,14692103,17.6),(81126,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81126,37.57,0.46,326,32448,70,NULL,NULL,'LCRS B112446.8-031756',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000147,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,171.833333,-3.57406,0.105,NULL,41047461883,641366591,10021352,17.5),(81127,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81127,35.55,0.46,129,32449,70,NULL,NULL,'2MASX J11272080+3443397',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000173,NULL,'15.5g',0.41,NULL,NULL,NULL,NULL,NULL,1,171.83675,34.72781,0.037,NULL,60641368777,947521387,14805021,15.5),(81128,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81128,36.82,0.46,231,32450,70,NULL,NULL,'MCG +10-16-141',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000207,NULL,'15.6g',0.41,'AGN',NULL,NULL,NULL,NULL,1,171.839083,59.17106,0,NULL,61850796195,966418690,15100292,15.6),(81129,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81129,37.53,0.19,321,32451,70,NULL,NULL,'2MASX J11272207+0132424',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000072,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,171.8419583,1.54508,0.081,NULL,60178876702,940294948,14692108,17.1),(81130,'IRAS','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81130,34.95,0.8,97.9,32452,75,NULL,'MAT, I','ESO 439- G 009',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'14.71',0.4,'(R)SB(r)a?     Sy2','in a triple',NULL,NULL,'Sy 2',1,171.847625,-29.25758,0.253,NULL,41595400259,649928129,10155127,14.71),(81131,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81131,34.87,0.43,94.4,32452,75,NULL,'MAT, I, raw','ESO 439- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81132,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81132,35.04,0.32,102,32452,85,NULL,'I, raw','ESO 439- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81133,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81133,35.13,0.32,106,32452,85,NULL,'I, inv','ESO 439- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81134,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81134,35.17,0.37,108,32452,NULL,NULL,NULL,'ESO 439- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81135,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81135,35.19,0.36,109,32452,NULL,NULL,'Malmquist cor.','ESO 439- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81136,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81136,35.21,0.2,110,32452,74.4,NULL,NULL,'ESO 439- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81137,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81137,35.22,0.43,111,32452,75,NULL,'MAT, I, inv','ESO 439- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81138,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81138,35.29,0.43,114,32452,75,NULL,'MAT, I, cor','ESO 439- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81139,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81139,35.65,NULL,135,32453,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1248',NULL,'2010Ap&SS.325..163P',2010,1,0.92,'Matthews and van Driel (2000A&AS..143..421M) question v=9897.','G',NULL,NULL,'16.4',0.11,'Sd',NULL,NULL,NULL,NULL,1,171.860291667,70.479,0.037,NULL,61351320877,958614388,14978349,16.4),(81140,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81140,35.67,NULL,136,32453,NULL,NULL,'Dipole + Quadrupole','FGC 1248',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81141,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81141,35.69,NULL,138,32453,NULL,NULL,NULL,'FGC 1248',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81142,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81142,35.69,NULL,138,32453,NULL,NULL,'Dipole','FGC 1248',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81143,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81143,35.9,0.49,151,32453,75,NULL,'IR','FGC 1248',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81144,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81144,37.22,0.46,278,32454,70,NULL,NULL,'2MASX J11272653+4048151',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,171.860667,40.80422,0,NULL,63942183668,999096619,15610884,17.5),(81145,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81145,38.08,0.46,412,32455,70,NULL,NULL,'2MASX J11272660+6212023',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000177,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,171.861083,62.20069,0,NULL,61872971032,966765172,15105705,17.7),(81146,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81146,36.62,0.46,211,32456,70,NULL,NULL,'2MASX J11272671+0701095',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000173,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,171.8614583,7.01936,0.153,NULL,60395552610,943680509,14745007,16.2),(81147,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81147,36.9,0.46,240,32457,70,NULL,NULL,'2MASX J11272708+3924491',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000145,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,171.863,39.41358,0,NULL,60423785177,944121643,14751900,17.5),(81148,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81148,36.33,0.33,185,32458,70,NULL,NULL,'2MASX J11272756+4004091',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000193,NULL,'15.7g',0.47,NULL,NULL,NULL,NULL,NULL,1,171.864667,40.06933,0,NULL,60423185726,944112276,14751754,15.7),(81149,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81149,36.59,0.46,208,32459,70,NULL,NULL,'VII Zw 402',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000195,NULL,'15.8g',0.46,'S0^-',NULL,NULL,NULL,NULL,1,171.86475,61.45178,0,NULL,61859603901,966556310,15102442,15.8),(81150,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81150,37.72,0.46,350,32460,70,NULL,NULL,'SDSS J112727.78+054944.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,171.865791667,5.82908,0.089,NULL,60383539748,943492808,14742075,18),(81151,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81151,37.96,0.46,390,32461,70,NULL,NULL,'2MASX J11272826+3936061',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000127,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,171.867625,39.60178,0,NULL,60424009227,944125144,14751955,18.3),(81152,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81152,38,0.33,397,32462,70,NULL,NULL,'SDSS J112729.05+171014.1',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,171.8710417,17.17061,0.023,NULL,61108495494,954820242,14919066,17.4),(81153,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81153,38.16,0.33,428,32463,70,NULL,NULL,'2MASX J11272986+2010240',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,171.874583,20.17347,0,NULL,61133590708,955212354,14925193,17.7),(81154,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81154,38.59,0.46,523,32464,70,NULL,NULL,'2MASX J11273069-0208287',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00018,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,171.877917,-2.14153,0.161,NULL,40834532194,638039565,9969368,17.9),(81155,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81155,37.74,0.46,354,32465,70,NULL,NULL,'2MASX J11273134+4423054',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000156,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,171.880375,44.38481,0.048,NULL,63898341108,998411579,15600180,17.4),(81156,'Sosies','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81156,32.61,0.23,33.3,32466,NULL,NULL,NULL,'NGC 3683',NULL,'2002A&A...393...57T',2002,1,1.84,NULL,'G',0.00002,NULL,'13.0g',0.97,'SB(s)c?        HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,171.8827083,56.87706,0,NULL,61991515662,968617432,15134647,13),(81157,'Tully est','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81157,32.27,0.8,28.4,32466,75,NULL,'B','NGC 3683',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81158,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81158,31.98,0.43,24.8,32466,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3683',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81159,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81159,32.28,0.45,28.6,32466,NULL,NULL,'K','NGC 3683',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81160,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81160,32.34,0.47,29.4,32466,NULL,NULL,'H','NGC 3683',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81161,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81161,32.34,0.43,29.4,32466,75,NULL,'3.6 micron, color corrected','NGC 3683',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81162,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81162,32.41,0.46,30.4,32466,NULL,NULL,'J','NGC 3683',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81163,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81163,32.46,0.4,31.1,32466,NULL,NULL,'mean','NGC 3683',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81164,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81164,32.72,0.4,35,32466,NULL,NULL,NULL,'NGC 3683',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81165,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81165,32.83,0.2,36.8,32466,74.4,NULL,NULL,'NGC 3683',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81166,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81166,32.99,0.49,39.6,32466,NULL,NULL,'Malmquist cor.','NGC 3683',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81167,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81167,33.17,0.45,43.1,32466,NULL,NULL,NULL,'NGC 3683',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81168,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81168,34.64,0.49,84.8,32467,75,NULL,'IR','ESO 439- G 010',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000047,NULL,'15.67',0.5,'Pec','in a triple',NULL,NULL,NULL,1,171.885291667,-29.17783,0.253,NULL,41595337121,649927142,10155111,15.67),(81169,'Tully est','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81169,33.19,0.8,43.5,32468,75,NULL,NULL,'MRK 1446',NULL,'1988NBGC.C....0000T',1988,1,0.54,NULL,'G',0.000037,NULL,'15.9g',0.4,'BlueCG','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,171.886125,53.91514,0,NULL,61761431841,965022372,15078474,15.9),(81170,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81170,36.24,0.46,177,32469,70,NULL,NULL,'2MASX J11273299+1958110',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'16.78',0.18,NULL,NULL,NULL,NULL,NULL,1,171.887625,19.96975,0,NULL,61135888965,955248265,14925754,16.78),(81171,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81171,38.03,0.46,404,32470,70,NULL,NULL,'2MASX J11273305+3617441',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000171,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,171.887875,36.29578,0.011,NULL,60420676627,944073072,14751141,18.4),(81172,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81172,36.33,0.33,185,32471,70,NULL,NULL,'2MASX J11273366+4001331',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000189,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,171.8902917,40.026,0,NULL,60423357608,944114962,14751796,17),(81173,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81173,37.89,0.46,379,32472,70,NULL,NULL,'2MASX J11273463+2602421',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,171.894333,26.04506,0,NULL,60578853366,946544583,14789759,17.3),(81174,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81174,38,0.33,397,32473,70,NULL,NULL,'2MASX J11273473+1709215',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,171.894583,17.15606,0.023,NULL,61108631961,954822374,14919099,17.5),(81175,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81175,37.89,0.46,379,32474,70,NULL,NULL,'SDSS J112737.17+074426.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000135,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,171.904917,7.74058,0.235,NULL,60394121634,943658150,14744658,18.3),(81176,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81176,37.5,0.27,316,32475,70,NULL,NULL,'2MASX J11273739+1826100',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.54',0.13,NULL,NULL,NULL,NULL,NULL,1,171.9057917,18.43628,0,NULL,61126443735,955100683,14923448,18.54),(81177,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81177,37.7,0.46,347,32476,70,NULL,NULL,'2MASX J11273781+0215064',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000079,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,171.9077083,2.25175,0.081,NULL,60177737486,940277148,14691830,17.4),(81178,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81178,37.48,0.46,313,32477,70,NULL,NULL,'SDSS J112738.54+112830.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000166,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,171.910625,11.47511,0.119,NULL,60219788360,940934193,14702096,18.5),(81179,'IRAS','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81179,32.35,0.8,29.5,32478,75,NULL,'MAT, I','ESO 439- G 011',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'15.94',0.4,'S...',NULL,NULL,NULL,NULL,1,171.920916667,-30.83725,0.281,NULL,41597733387,649964584,10155696,15.94),(81180,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81180,32.41,0.32,30.3,32478,85,NULL,'I, inv','ESO 439- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81181,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81181,32.45,0.32,30.9,32478,85,NULL,'I, raw','ESO 439- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81182,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81182,32.72,0.43,35,32478,75,NULL,'MAT, I, inv','ESO 439- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81183,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81183,32.81,0.43,36.5,32478,75,NULL,'MAT, I, raw','ESO 439- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81184,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81184,33.01,0.43,40,32478,75,NULL,'MAT, I, cor','ESO 439- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81185,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81185,30.89,0.69,15.1,32479,100,NULL,'mid-IR','NGC 3682',NULL,'2013ApJ...771...88L',2013,1,1.84,'The 2MASS position is 5 arcsec east of the nucleus.','G',0.000077,NULL,'12.9g',1.09,'SA(s)0/a:?','Isolated galaxy',NULL,NULL,NULL,1,171.921667,66.58983,0,NULL,61813772405,965840193,15091253,12.9),(81186,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81186,38.23,0.46,444,32480,70,NULL,NULL,'2MASX J11274173+2950331',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000195,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,171.924,29.84244,0,NULL,60662010674,947843916,14810061,17.1),(81187,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81187,38.3,0.46,456,32481,70,NULL,NULL,'2MASX J11274177+2443461',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.74',0.13,NULL,NULL,NULL,NULL,NULL,1,171.924083,24.72961,0,NULL,60573131171,946455174,14788362,18.74),(81188,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81188,38.65,0.46,537,32482,70,NULL,NULL,'SDSS J112742.09+470609.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000139,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,171.9254583,47.10267,0,NULL,63895684997,998370078,15599532,18.4),(81189,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81189,30.62,0.4,13.3,32483,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 3 galaxy group','NGC 3686',NULL,'1992ApJS...80..479T',1992,1,3.2,NULL,'G',0.000013,NULL,'11.89',2.5,'SB(s)bc','X-ray-bright group member',NULL,NULL,NULL,1,171.9332083,17.22419,0.023,NULL,61108618806,954822168,14919096,11.89),(81190,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81190,31,0.47,15.9,32483,NULL,NULL,'H','NGC 3686',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81191,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81191,31.01,0.36,15.9,32483,NULL,NULL,NULL,'NGC 3686',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81192,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81192,31.03,0.45,16,32483,NULL,NULL,'K','NGC 3686',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81193,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81193,31.14,0.46,16.9,32483,NULL,NULL,'J','NGC 3686',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81194,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81194,31.82,0.4,23.1,32483,NULL,NULL,'mean','NGC 3686',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81195,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81195,31.86,0.4,23.5,32483,75,NULL,'B','NGC 3686',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81196,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81196,31.92,0.3,24.3,32483,55,NULL,'B','NGC 3686',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81197,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81197,38.14,0.46,424,32484,70,NULL,NULL,'2MASX J11274575+1829210',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,171.94075,18.48922,0,NULL,61126232705,955097386,14923396,17.4),(81198,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81198,37.53,0.19,321,32485,70,NULL,NULL,'2MASX J11274602+0124444',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000069,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,171.941875,1.41242,0.085,NULL,60178450689,940288292,14692004,16.5),(81199,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81199,38.29,0.46,454,32486,70,NULL,NULL,'SDSS J112746.96+560437.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000153,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,171.9457083,56.07694,0,NULL,61984847708,968513245,15133019,18.6),(81200,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81200,37.5,0.27,316,32487,70,NULL,NULL,'2MASX J11274702+1825020',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000117,NULL,'17.28',0.2,NULL,NULL,NULL,NULL,NULL,1,171.945833,18.41719,0,NULL,61126445184,955100706,14923448,17.28),(81201,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81201,37.32,0.46,292,32488,70,NULL,NULL,'2MASX J11274842+4349414',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,171.95175,43.82831,0,NULL,63899077772,998423090,15600360,17.1),(81202,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81202,36.53,0.46,202,32489,70,NULL,NULL,'2MASX J11274906+5344224',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000175,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,171.95425,53.73944,0,NULL,61791018613,965484665,15085697,16.8),(81203,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81203,37.75,0.23,355,32490,70,NULL,NULL,'2MASX J11274910+5731503',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,171.954667,57.53058,0,NULL,61991285265,968613832,15134591,17.4),(81204,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81204,38.72,0.46,554,32491,70,NULL,NULL,'2MASX J11275188+4807374',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000127,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,171.965958333,48.12692,0.013,NULL,63892448470,998319507,15598742,18.2),(81205,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81205,36.43,0.33,193,32492,70,NULL,NULL,'2MASXi J1127522+602651',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000169,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,171.967583,60.44797,0,NULL,61851685800,966432590,15100509,16.4),(81206,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81206,36.53,0.46,203,32493,70,NULL,NULL,'2MASX J11275348+2033243',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.94',0.18,NULL,NULL,NULL,NULL,NULL,1,171.9727083,20.55686,0,NULL,61129155778,955143059,14924110,17.94),(81207,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81207,37.53,0.19,321,32494,70,NULL,NULL,'2MASX J11275366+0121091',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000101,NULL,'15.9g',0.41,'BrClG',NULL,NULL,NULL,NULL,1,171.973667,1.35247,0.085,NULL,60178461043,940288453,14692007,15.9),(81208,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81208,37.75,0.23,355,32495,70,NULL,NULL,'2MASX J11275501+5741383',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000174,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,171.979125,57.69386,0,NULL,61991072816,968610512,15134539,17.8),(81209,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81209,38.65,0.46,536,32496,70,NULL,NULL,'2MASX J11275623+0407161',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00017,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,171.984125,4.12114,0.089,NULL,60354649127,943041392,14735021,17.8),(81210,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81210,37.53,0.19,321,32497,70,NULL,NULL,'SDSS J112756.74+012357.7',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000057,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,171.986417,1.39939,0.085,NULL,60178457703,940288401,14692006,18.1),(81211,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81211,37.77,0.46,358,32498,70,NULL,NULL,'SDSS J112757.67+020855.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000068,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,171.990333,2.14881,0.073,NULL,60177562572,940274415,14691787,18.1),(81212,'Brightest Stars','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81212,27.41,0.4,3.03,32499,NULL,NULL,'3B','UGC 06456',NULL,'1994A&AS..106..555K',1994,1,1.4,'Huchtmeier and Skillman (1998A&AS..127..269H) give v=-132 km/sec.','G',0.000001,NULL,'14.50',0.8,'Pec            HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,171.999583,78.99417,0.093,NULL,61425040394,959766256,14996347,14.5),(81213,'Brightest Stars','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81213,28.4,NULL,4.79,32499,NULL,NULL,NULL,'UGC 06456',NULL,'1998AJ....116.2886S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81214,'CMD','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81214,28.3,0.04,4.57,32499,NULL,NULL,NULL,'UGC 06456',NULL,'2010ApJ...721..297M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81215,'TRGB','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81215,28.17,0.05,4.3,32499,NULL,NULL,NULL,'UGC 06456',NULL,'2014A&A...566A..71L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81216,'TRGB','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81216,28.19,0.04,4.34,32499,NULL,NULL,NULL,'UGC 06456',NULL,'2002AJ....124..213M',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81217,'TRGB','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81217,28.19,0.1,4.35,32499,NULL,NULL,NULL,'UGC 06456',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81218,'TRGB','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81218,28.19,NULL,4.35,32499,NULL,NULL,'I','UGC 06456',NULL,'2006ARep...50..517T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81219,'TRGB','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81219,28.23,NULL,4.4,32499,NULL,NULL,'I','UGC 06456',NULL,'1999ApJ...525..709S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81220,'TRGB','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81220,28.24,0.04,4.45,32499,NULL,NULL,'I','UGC 06456',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81221,'TRGB','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81221,28.25,0.1,4.47,32499,NULL,NULL,'I','UGC 06456',NULL,'1998AJ....116..146L',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81222,'TRGB','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81222,28.28,0.08,4.54,32499,74.4,NULL,NULL,'UGC 06456',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81223,'TRGB','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81223,28.4,0.16,4.8,32499,NULL,NULL,'I','UGC 06456',NULL,'1998ApJ...493L..23S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81224,'Tully est','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81224,25.75,0.8,1.4,32499,75,NULL,'B','UGC 06456',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81225,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81225,37.59,0.33,329,32500,70,NULL,NULL,'IC 2845',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000161,NULL,'16.1g',0.39,'E0',NULL,NULL,NULL,NULL,1,172.001917,12.52975,0.114,NULL,60228568503,941071382,14704240,16.1),(81226,'Ring Diameter','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81226,33.2,0.84,43,32501,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3687',NULL,'1981ApJS...45..541P',1981,1,1.61,NULL,'G',0.00002,NULL,'13.1g',1.3,'(R\')SAB(r)bc?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,172.0025417,29.51106,0,NULL,60658730782,947792668,14809260,13.1),(81227,'Tully est','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81227,32.85,0.8,37.2,32501,75,NULL,'B','NGC 3687',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81228,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81228,31.65,0.47,21.3,32501,NULL,NULL,'H','NGC 3687',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81229,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81229,31.72,0.46,22.1,32501,NULL,NULL,'J','NGC 3687',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81230,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81230,31.77,0.45,22.6,32501,NULL,NULL,'K','NGC 3687',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81231,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81231,32.59,0.4,32.9,32501,NULL,NULL,'mean','NGC 3687',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81232,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81232,36.82,0.23,231,32502,70,NULL,NULL,'2MASX J11280078+2647527',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000188,NULL,'15.3g',0.53,NULL,NULL,NULL,NULL,NULL,1,172.003167,26.79806,0,NULL,60577399100,946521860,14789404,15.3),(81233,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81233,36.82,0.23,231,32503,70,NULL,NULL,'2MASX J11280242+2650397',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000162,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,172.010083,26.84439,0,NULL,60577371707,946521432,14789397,16.5),(81234,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81234,37.43,0.46,306,32504,70,NULL,NULL,'2MASX J11280242+5037522',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000137,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,172.010125,50.63106,0,NULL,61797937389,965592771,15087387,17.7),(81235,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81235,38.67,0.46,542,32505,70,NULL,NULL,'SDSS J112802.65+313241.2',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.1g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,172.0110417,31.54481,0.018,NULL,60663434263,947866160,14810408,17.1),(81236,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81236,38.19,0.46,435,32506,70,NULL,NULL,'SDSS J112803.75+031539.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000079,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,172.015625,3.26094,0.065,NULL,60172693961,940198343,14690599,18.6),(81237,'IRAS','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81237,33,0.8,39.9,32507,75,NULL,'MAT, I','ESO 378- G 003',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000007,NULL,'13.79',1.4,'SAB(s)c:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,172.0167083,-36.54272,0.353,NULL,41383528703,646617635,10103400,13.79),(81238,'IRAS','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81238,33.02,0.8,40.1,32507,75,NULL,'HMCL, I','ESO 378- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81239,'Tully est','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81239,32.99,0.8,39.6,32507,75,NULL,'B','ESO 378- G 003',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81240,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81240,32.37,0.32,29.8,32507,85,NULL,'I, raw','ESO 378- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81241,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81241,32.39,0.32,30,32507,85,NULL,'I, inv','ESO 378- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81242,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81242,32.65,0.38,33.9,32507,NULL,NULL,NULL,'ESO 378- G 003',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81243,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81243,32.67,0.4,34.3,32507,75,NULL,'HMCL, I, raw','ESO 378- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81244,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81244,32.76,0.43,35.6,32507,75,NULL,'MAT, I, raw','ESO 378- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81245,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81245,32.77,0.4,35.8,32507,75,NULL,'HMCL, I, inv','ESO 378- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81246,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81246,32.78,0.2,36,32507,74.4,NULL,NULL,'ESO 378- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81247,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81247,32.84,0.4,37,32507,75,NULL,'HMCL, I, cor','ESO 378- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81248,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81248,32.89,0.43,37.8,32507,75,NULL,'MAT, I, inv','ESO 378- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81249,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81249,32.89,0.43,37.8,32507,75,NULL,'3.6 micron, color corrected','ESO 378- G 003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81250,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81250,32.93,0.43,38.5,32507,75,NULL,'MAT, I, cor','ESO 378- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81251,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81251,33.01,0.43,40,32507,75,NULL,'3.6 micron, color + selection bias corrected','ESO 378- G 003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81252,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81252,33.39,0.1,47.7,32507,NULL,NULL,NULL,'ESO 378- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81253,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81253,33.42,0.4,48.2,32507,NULL,NULL,'mean','ESO 378- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81254,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81254,33.54,0.47,51,32507,NULL,NULL,'H','ESO 378- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81255,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81255,33.56,0.46,51.5,32507,NULL,NULL,'J','ESO 378- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81256,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81256,33.64,0.45,53.4,32507,NULL,NULL,'K','ESO 378- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81257,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81257,36.79,0.46,228,32508,70,NULL,NULL,'2MASX J11280448+5612054',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00018,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,172.0185,56.20153,0,NULL,61984758030,968511844,15132997,16.3),(81258,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81258,38.04,0.46,406,32509,70,NULL,NULL,'2MASX J11280445+2313503',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,172.018708333,23.23058,0,NULL,61094740242,954605316,14915708,17.2),(81259,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81259,36.37,0.46,188,32510,70,NULL,NULL,'2MASX J11280448+4144452',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000174,NULL,'16.1g',0.43,'E0',NULL,NULL,NULL,NULL,1,172.018875,41.74592,0,NULL,63896668371,998385443,15599772,16.1),(81260,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81260,37,0.46,251,32511,70,NULL,NULL,'2MASX J11280557+1435136',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000156,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,172.02325,14.58708,0.056,NULL,60223807030,940996984,14703077,17.2),(81261,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81261,37.2,0.46,275,32512,70,NULL,NULL,'2MASX J11280594+0007561',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000081,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,172.024667,0.13219,0.061,NULL,60169623874,940150373,14689849,17.3),(81262,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81262,36.55,0.62,204,32513,70,NULL,NULL,'2MASX J11280641-0826299',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,172.026625,-8.44164,0.049,NULL,41067354812,641677418,10026209,14.9),(81263,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81263,38.15,0.46,426,32514,70,NULL,NULL,'2MASX J11280662+5731593',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,172.0275417,57.53322,0,NULL,61991283319,968613801,15134590,17.9),(81264,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81264,38.6,0.46,524,32515,70,NULL,NULL,'2MASX J11280765+2020163',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,172.031875,20.33775,0,NULL,61133557111,955211829,14925184,18),(81265,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81265,38.06,0.46,409,32516,70,NULL,NULL,'2MASX J11280797+1905573',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,172.033333,19.09947,0,NULL,61135629007,955244203,14925690,17.8),(81266,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81266,37.84,0.46,370,32517,70,NULL,NULL,'2MASX J11280852+2623517',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000153,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,172.035625,26.39781,0,NULL,60577000448,946515632,14789306,17.3),(81267,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81267,38.57,0.46,518,32518,70,NULL,NULL,'2MASX J11280896+4949413',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000142,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,172.0375417,49.82811,0,NULL,61798543069,965602235,15087534,18.1),(81268,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81268,31.71,0.4,22,32519,NULL,NULL,'mean','NGC 3691',NULL,'2007A&A...465...71T',2007,1,1.3,'The 2MASS position is 22 arcsec northeast of the optical nucleus.','G',0.000013,NULL,'12.6',1,'SBb?','X-ray-bright group member',NULL,NULL,NULL,1,172.0392083,16.92047,0.033,NULL,61108421584,954819087,14919048,12.6),(81269,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81269,32.37,0.47,29.7,32519,NULL,NULL,'H','NGC 3691',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81270,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81270,32.43,0.46,30.6,32519,NULL,NULL,'J','NGC 3691',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81271,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81271,32.44,0.45,30.8,32519,NULL,NULL,'K','NGC 3691',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81272,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81272,37.89,0.27,378,32520,70,NULL,NULL,'2MASX J11280988+0710289',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,172.0412917,7.17456,0.125,NULL,60397532446,943711444,14745491,17.2),(81273,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81273,37.12,0.46,266,32521,70,NULL,NULL,'2MASX J11281059+5132593',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000149,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,172.044291667,51.54964,0,NULL,61805995482,965718679,15089354,17.2),(81274,'Tully est','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81274,33.07,0.8,41.2,32522,75,NULL,'B','NGC 3689',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000027,NULL,'13.03',1.1,'SAB(rs)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,172.0459583,25.66117,0,NULL,60579357718,946552464,14789882,13.03),(81275,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81275,32.1,0.69,26.3,32522,100,NULL,'mid-IR','NGC 3689',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81276,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81276,32.46,0.45,31.1,32522,NULL,NULL,'K','NGC 3689',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81277,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81277,32.48,0.47,31.3,32522,NULL,NULL,'H','NGC 3689',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81278,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81278,32.53,0.46,32,32522,NULL,NULL,'J','NGC 3689',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81279,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81279,33.11,0.43,41.8,32522,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3689',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81280,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81280,33.12,0.4,42,32522,NULL,NULL,'mean','NGC 3689',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81281,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81281,33.19,0.43,43.4,32522,75,NULL,'3.6 micron, color corrected','NGC 3689',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81282,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81282,33.36,0.2,47,32522,74.4,NULL,NULL,'NGC 3689',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81283,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81283,33.4,0.3,47.9,32522,55,NULL,'B','NGC 3689',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81284,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81284,33.42,0.45,48.3,32522,NULL,NULL,'Malmquist cor.','NGC 3689',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81285,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81285,33.45,0.4,49,32522,NULL,NULL,NULL,'NGC 3689',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81286,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81286,33.53,0.43,50.8,32522,NULL,NULL,NULL,'NGC 3689',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81287,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81287,37.12,0.46,265,32523,70,NULL,NULL,'2MASX J11281109+4256034',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000158,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,172.046125,42.93422,0,NULL,63898629494,998416085,15600251,16.9),(81288,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81288,33.04,0.5,40.6,32524,70,NULL,NULL,'NGC 3693',NULL,'2014MNRAS.445.2677S',2014,1,3.2,NULL,'G',0.000017,NULL,'13.50',0.7,'(R\')SA(r)b:    HII',NULL,NULL,NULL,NULL,1,172.0482083,-13.19486,0.057,NULL,40986563464,640415054,10006485,13.5),(81289,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81289,33.88,0.49,59.6,32524,75,NULL,'IR','NGC 3693',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81290,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81290,33.9,0.46,60.2,32524,NULL,NULL,'J','NGC 3693',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81291,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81291,33.91,0.47,60.4,32524,NULL,NULL,'H','NGC 3693',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81292,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81292,34,0.45,63.1,32524,NULL,NULL,'K','NGC 3693',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81293,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81293,34.36,0.4,74.3,32524,NULL,NULL,'mean','NGC 3693',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81294,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81294,38.09,0.46,416,32525,70,NULL,NULL,'2MASX J11281177+1535226',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,172.049041667,15.58961,0.035,NULL,61109418292,954834660,14919291,18.1),(81295,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81295,37.59,0.46,330,32526,70,NULL,NULL,'2MASX J11281233+0141111',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000078,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,172.0515,1.68656,0.085,NULL,60179082108,940298157,14692158,17.6),(81296,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81296,37.95,0.27,389,32527,70,NULL,NULL,'SDSS J112812.45-013226.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000139,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,172.051917,-1.54078,0.109,NULL,40834850469,638044538,9969445,18.4),(81297,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81297,37.76,0.46,357,32528,70,NULL,NULL,'2MASX J11281372+2050483',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.20',0.19,'BrClG',NULL,NULL,NULL,NULL,1,172.0572917,20.84672,0,NULL,61131082574,955173165,14924580,18.2),(81298,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81298,36.3,0.27,182,32529,70,NULL,NULL,'2MASX J11281431+2739097',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000172,NULL,'15.7g',0.45,'AGN',NULL,NULL,NULL,NULL,1,172.05975,27.65283,0,NULL,60577964383,946530693,14789542,15.7),(81299,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81299,37.11,0.46,264,32530,70,NULL,NULL,'2MASX J11281479+3712153',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000183,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,172.061625,37.20411,0,NULL,60420244316,944066317,14751036,16.9),(81300,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81300,33.9,0.69,60.4,32531,100,NULL,'mid-IR','IC 2853',NULL,'2013ApJ...771...88L',2013,1,1,'UGC misprints name as \'MCG +01-29-031\'.','G',0.00002,NULL,'14.5B',0.5,'SBab','Group member',NULL,NULL,NULL,1,172.061916667,9.14703,0.106,NULL,60387353104,943552392,14743006,14.5),(81301,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81301,34.69,0.2,86.7,32531,74.4,NULL,NULL,'IC 2853',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81302,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81302,34.91,0.4,95.8,32531,NULL,NULL,'mean','IC 2853',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81303,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81303,35.03,0.47,101,32531,NULL,NULL,'H','IC 2853',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81304,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81304,35.1,0.45,105,32531,NULL,NULL,'K','IC 2853',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81305,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81305,35.17,0.46,108,32531,NULL,NULL,'J','IC 2853',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81306,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81306,35.89,0.46,150,32532,70,NULL,NULL,'NGC 3685',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000097,NULL,'15.3g',0.45,'E','Pair member (points to parent)',NULL,NULL,NULL,1,172.067583333,4.32728,0.089,NULL,60355106615,943048540,14735133,15.3),(81307,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81307,34.94,0.4,97.1,32533,NULL,NULL,'mean','IC 2856',NULL,'2007A&A...465...71T',2007,1,0.7,NULL,'G',0.000063,NULL,'14.47',0.25,'Sab            HII',NULL,NULL,NULL,NULL,1,172.067958333,-12.89069,0.053,NULL,40986291563,640410805,10006418,14.47),(81308,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81308,35.16,0.47,108,32533,NULL,NULL,'H','IC 2856',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81309,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81309,37.6,0.46,331,32534,70,NULL,NULL,'2MASX J11281639+4032303',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,172.0682083,40.54178,0,NULL,63896032701,998375510,15599617,17.6),(81310,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81310,36.92,0.46,243,32535,70,NULL,NULL,'2MASX J11281776+1218376',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000154,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,172.074167,12.3105,0.126,NULL,60228506607,941070415,14704225,17),(81311,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81311,37.95,0.27,389,32536,70,NULL,NULL,'2MASX J11281786-0130523',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000182,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,172.0744583,-1.51458,0.109,NULL,40834877667,638044963,9969452,17),(81312,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81312,36.9,0.46,240,32537,70,NULL,NULL,'2MASX J11281832-0106233',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000069,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,172.0762917,-1.10639,0.057,NULL,40833427714,638022308,9969098,17.4),(81313,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81313,38.34,0.46,467,32538,70,NULL,NULL,'SDSS J112818.61+080220.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,172.077583,8.03903,0.16,NULL,60394491947,943663936,14744749,18.5),(81314,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81314,36.82,0.23,231,32539,70,NULL,NULL,'CGCG 156-080',NULL,'2015arXiv151105856S',2015,1,1.01,NULL,'G',0.000185,NULL,'15.0g',0.55,NULL,NULL,NULL,NULL,NULL,1,172.07775,26.76014,0,NULL,60577387883,946521685,14789401,15),(81315,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81315,36.03,0.46,161,32540,70,NULL,NULL,'2MASX J11281867+2809347',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000169,NULL,'16.0g',0.37,NULL,NULL,NULL,NULL,NULL,1,172.077833,28.15978,0,NULL,60574589413,946477959,14788718,16),(81316,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81316,36.3,0.27,182,32541,70,NULL,NULL,'2MASX J11281987+2737196',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000031,NULL,'15.8g',0.35,'Sy',NULL,NULL,NULL,NULL,1,172.083,27.62211,0,NULL,60577997453,946531210,14789550,15.8),(81317,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81317,37.59,0.33,329,32542,70,NULL,NULL,'SDSS J112820.72+122655.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,172.086333333,12.44869,0.146,NULL,60228554142,941071158,14704236,18.3),(81318,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81318,32.51,0.4,31.8,32543,NULL,NULL,'mean','NGC 3692',NULL,'2007A&A...465...71T',2007,1,3.52,NULL,'G',0.00002,NULL,'12.9g',0.66,'Sb;LINER       HII','Group member',NULL,NULL,NULL,1,172.100041667,9.40764,0.111,NULL,60341762497,942840039,14731875,12.9),(81319,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81319,32.68,0.4,34.3,32543,75,NULL,NULL,'NGC 3692',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81320,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81320,32.72,0.5,34.9,32543,NULL,NULL,'Malmquist cor.','NGC 3692',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81321,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81321,32.77,0.46,35.8,32543,NULL,NULL,'J','NGC 3692',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81322,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81322,32.8,0.47,36.2,32543,NULL,NULL,'H','NGC 3692',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81323,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81323,32.84,0.2,37,32543,74.4,NULL,NULL,'NGC 3692',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81324,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81324,32.88,0.45,37.7,32543,NULL,NULL,'K','NGC 3692',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81325,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81325,32.94,0.45,38.7,32543,NULL,NULL,NULL,'NGC 3692',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81326,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81326,32.96,0.43,39.1,32543,75,NULL,'3.6 micron, color corrected','NGC 3692',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81327,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81327,33.05,0.49,40.7,32543,75,NULL,'IR','NGC 3692',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81328,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81328,33.13,0.43,42.4,32543,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3692',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81329,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81329,31.25,NULL,17.8,32544,NULL,NULL,NULL,'SDSS J112824.27+060704.2',NULL,'2015AstBu..70....1K',2015,1,0.45,NULL,'G',0.000017,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,172.101166667,6.11786,0.089,NULL,60383476579,943491821,14742059,17.4),(81330,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81330,33.12,0.49,42,32545,75,NULL,'IR','2MFGC 08976',NULL,'2011yCatp016004901K',2011,1,NULL,'This is a part of the galaxy NGC 3692.','PofG',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,172.104417,9.40753,0.111,NULL,60341762486,942840038,14731875,NULL),(81331,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81331,38.08,0.46,413,32546,70,NULL,NULL,'2MASX J11282633+0720192',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,172.109833,7.33856,0.178,NULL,60397818802,943715918,14745561,17.8),(81332,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81332,36.3,0.27,182,32547,70,NULL,NULL,'2MASX J11282732+2723499',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000192,NULL,'15.9g',0.43,NULL,NULL,NULL,NULL,NULL,1,172.113833,27.39733,0,NULL,60578099227,946532800,14789575,15.9),(81333,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81333,36.14,0.46,169,32548,70,NULL,NULL,'2MASX J11282790-0119302',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,172.1162917,-1.32511,0.105,NULL,40832931074,638014548,9968977,16.9),(81334,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81334,37.3,0.46,289,32549,70,NULL,NULL,'SDSS J112828.08+025501.9',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000096,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,172.117,2.91722,0.073,NULL,60172653956,940197718,14690589,16.4),(81335,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81335,34.63,NULL,84.4,32550,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 2857',NULL,'2010Ap&SS.325..163P',2010,1,2.32,NULL,'G',0.000009,NULL,'15.1g',0.26,'Sc','Group member',NULL,NULL,NULL,1,172.129333333,9.10442,0.106,NULL,60387316986,943551827,14742997,15.1),(81336,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81336,34.64,NULL,84.6,32550,NULL,NULL,'Dipole + Quadrupole','IC 2857',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81337,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81337,34.64,NULL,84.8,32550,NULL,NULL,'Dipole','IC 2857',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81338,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81338,34.7,NULL,87,32550,NULL,NULL,NULL,'IC 2857',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81339,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81339,34.74,0.49,88.8,32550,75,NULL,'IR','IC 2857',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81340,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81340,34.86,0.35,93.8,32550,NULL,NULL,'Malmquist cor.','IC 2857',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81341,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81341,35.06,0.32,103,32550,NULL,NULL,NULL,'IC 2857',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81342,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81342,35.1,0.2,105,32550,74.4,NULL,NULL,'IC 2857',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81343,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81343,36.21,0.46,175,32551,70,NULL,NULL,'2MASX J11283116+0338182',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000077,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,172.1299583,3.63836,0.065,NULL,60354916448,943045569,14735087,17),(81344,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81344,37.5,0.46,316,32552,70,NULL,NULL,'2MASX J11283134+4052204',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000174,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,172.1307917,40.87228,0,NULL,63896245905,998378842,15599669,16.7),(81345,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81345,36.23,0.46,176,32553,70,NULL,NULL,'2MASX J11283197+0205312',NULL,'2015arXiv151105856S',2015,1,0.52,'The APM image includes a neighboring star.','G',0.000089,NULL,'15.9g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,172.133208333,2.09211,0.061,NULL,60177071007,940266734,14691667,15.9),(81346,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81346,37.95,0.27,389,32554,70,NULL,NULL,'2MASX J11283243-0129042',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00015,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,172.135083,-1.48442,0.109,NULL,40834886591,638045102,9969454,17.9),(81347,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81347,37.26,0.33,283,32555,70,NULL,NULL,'2MASX J11283365+4717302',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,172.140333,47.29178,0.012,NULL,63895779837,998371559,15599555,17.5),(81348,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81348,37.53,0.46,321,32556,70,NULL,NULL,'2MASX J11283388+1717048',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,172.1412083,17.28464,0.015,NULL,61125992400,955093631,14923337,17),(81349,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81349,37.89,0.27,378,32557,70,NULL,NULL,'2MASX J11283419+0709292',NULL,'2015arXiv151105856S',2015,1,0.09,NULL,'G',0.0001,NULL,'18.8g',0.08,NULL,NULL,NULL,NULL,NULL,1,172.142625,7.15811,0.125,NULL,60397060760,943704074,14745376,18.8),(81350,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81350,36.23,0.46,176,32558,70,NULL,NULL,'IC 0697',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.00015,NULL,'15.2g',0.49,'S0',NULL,NULL,NULL,NULL,1,172.1435417,-1.62958,0.109,NULL,40834870520,638044851,9969450,15.2),(81351,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81351,36.87,0.46,237,32559,70,NULL,NULL,'2MASX J11283483+5012272',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000155,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,172.14525,50.20747,0,NULL,61798863407,965607240,15087613,16.9),(81352,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81352,37.89,0.27,378,32560,70,NULL,NULL,'2MASX J11283600+0710222',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,172.1499583,7.17275,0.125,NULL,60397063471,943704116,14745376,18),(81353,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81353,35.22,0.4,111,32561,NULL,NULL,'mean','UGC 06476',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.00002,NULL,'14.19',1,'Sbc','Group member',NULL,NULL,NULL,1,172.1504583,23.40467,0,NULL,61094707465,954604804,14915700,14.19),(81354,'Tully-Fisher','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,NULL,81354,35.45,0.47,123,32561,NULL,NULL,'H','UGC 06476',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81355,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81355,36.34,0.33,185,32562,70,NULL,NULL,'SDSS J112837.00+212309.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,172.1542083,21.38586,0,NULL,61131580843,955180950,14924702,17.5),(81356,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81356,36.5,0.46,200,32563,70,NULL,NULL,'2MASX J11283701+0745552',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000143,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,172.1542917,7.76531,0.174,NULL,60397727923,943714498,14745539,16.9),(81357,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81357,37.5,0.46,317,32564,70,NULL,NULL,'2MASX J11283708+0935582',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000181,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,172.154583,9.59944,0.095,NULL,60341800680,942840635,14731884,17.3),(81358,'FP','2016-12-15 15:14:47','2016-12-16 11:19:56','1',NULL,'R',81358,38.53,0.46,508,32565,70,NULL,NULL,'2MASX J11283790+2027456',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,172.157833,20.46289,0,NULL,61130947410,955171053,14924547,17.6),(81359,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81359,37.75,0.23,355,32566,70,NULL,NULL,'MCG +10-17-001',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000217,NULL,'15.4g',0.54,'E0',NULL,NULL,NULL,NULL,1,172.161,57.66514,0,NULL,61991242005,968613156,15134580,15.4),(81360,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81360,36.82,0.23,231,32567,70,NULL,NULL,'2MASX J11283867+2657129',NULL,'2015arXiv151105856S',2015,1,0.34,'87GB source with large sky, narrow minor axis, or very bad confusion.','G',0.000241,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,172.161167,26.95375,0,NULL,60577353783,946521152,14789393,17.1),(81361,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81361,37.73,0.46,352,32568,70,NULL,NULL,'2MASX J11283948+3701473',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000183,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,172.1644583,37.02967,0,NULL,60420180782,944065324,14751020,17.4),(81362,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81362,35.32,0.59,116,32569,70,NULL,NULL,'2MASX J11284064-0847544',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.44',NULL,NULL,NULL,NULL,NULL,NULL,1,172.169417,-8.79869,0.053,NULL,41065250079,641644532,10025695,15.44),(81363,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81363,37.08,0.46,260,32570,70,NULL,NULL,'2MASX J11284075+2737579',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000168,NULL,'16.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,172.1699583,27.63292,0,NULL,60577946275,946530410,14789537,16.8),(81364,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81364,36.07,0.49,163,32571,75,NULL,'IR','2MFGC 08981',NULL,'2011yCatp016004901K',2011,1,1.03,NULL,'G',0.000018,NULL,'16.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,172.1737917,27.16431,0,NULL,60578292219,946535815,14789622,16.3),(81365,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81365,36.3,0.49,182,32571,NULL,NULL,'Malmquist cor.','2MFGC 08981',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81366,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81366,36.69,0.41,217,32571,NULL,NULL,NULL,'2MFGC 08981',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81367,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81367,36.71,0.2,220,32571,74.4,NULL,NULL,'2MFGC 08981',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81368,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81368,37.19,0.16,274,32572,70,NULL,NULL,'MCG +09-19-084',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000189,NULL,'15.6g',0.51,'BrClG',NULL,NULL,NULL,NULL,1,172.1749583,54.17225,0,NULL,61764952488,965077382,15079334,15.6),(81369,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81369,35.83,0.27,147,32573,70,NULL,NULL,'2MASX J11284263+2300376',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.82',0.28,NULL,NULL,NULL,NULL,NULL,1,172.177583,23.01036,0,NULL,61094578444,954602788,14915668,16.82),(81370,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81370,37.98,0.19,395,32574,70,NULL,NULL,'2MASX J11284317+0142012',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000099,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,172.179917,1.70033,0.053,NULL,60178908288,940295442,14692116,17),(81371,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81371,34.95,0.48,97.7,32575,70,NULL,NULL,'MCG -02-29-034',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'15.00',1.3,'(R)SB(r)0+:',NULL,NULL,NULL,NULL,1,172.1810417,-14.11978,0.025,NULL,40985124735,640392573,10006133,15),(81372,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81372,38.11,0.46,419,32576,70,NULL,NULL,'2MASX J11284384-0229562',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,172.182625,-2.49897,0.141,NULL,40834581952,638040343,9969380,17.7),(81373,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81373,37.14,0.46,268,32577,70,NULL,NULL,'IC 2860',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000169,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,172.185833,14.04189,0.075,NULL,60227804869,941059451,14704053,16.6),(81374,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81374,37.38,0.46,299,32578,70,NULL,NULL,'2MASX J11284488+1500208',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000175,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,172.187083,15.00592,0.042,NULL,60223586940,940993545,14703024,16.9),(81375,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81375,35.83,0.27,147,32579,70,NULL,NULL,'CGCG 126-062',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000187,NULL,'15.5',0.5,NULL,NULL,NULL,NULL,NULL,1,172.188875,22.92864,0,NULL,61095067235,954610425,14915787,15.5),(81376,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81376,37.27,0.46,285,32580,70,NULL,NULL,'2MASX J11284626+0603242',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000175,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,172.192833,6.05678,0.093,NULL,60384282334,943504411,14742256,17.5),(81377,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81377,38.39,0.46,476,32581,70,NULL,NULL,'2MASX J11284784+4432131',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000171,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,172.199333,44.53719,0,NULL,63900336413,998442756,15600668,18.2),(81378,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81378,38.13,0.46,422,32582,70,NULL,NULL,'2MASX J11284803+6440491',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000085,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,172.200333333,64.68039,0.013,NULL,61813471870,965835497,15091179,17.6),(81379,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81379,37.98,0.19,395,32583,70,NULL,NULL,'2MASX J11284918+0144500',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000084,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,172.204917,1.74725,0.053,NULL,60179022606,940297228,14692144,17.8),(81380,'IRAS','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81380,34.64,0.8,84.7,32584,75,NULL,'W91CL, r','NGC 3697',NULL,'1997ApJS..109..333W',1997,1,2.28,NULL,'G',0.000103,NULL,'13.7g',0.71,'SABb           AGN','Group member',NULL,NULL,NULL,1,172.209917,20.79503,0,NULL,61131150837,955174231,14924597,13.7),(81381,'IRAS','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81381,34.65,0.8,85.2,32584,75,NULL,'HMCL, I','NGC 3697',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81382,'IRAS','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81382,34.65,0.8,85.2,32584,75,NULL,'CF, r','NGC 3697',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81383,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81383,34.47,0.38,78.4,32584,75,NULL,'W91CL, r, raw','NGC 3697',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81384,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81384,34.53,0.4,80.5,32584,75,NULL,'HMCL, I, raw','NGC 3697',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81385,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81385,34.55,0.38,81.3,32584,75,NULL,'CF, r, raw','NGC 3697',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81386,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81386,34.67,0.47,85.8,32584,NULL,NULL,'H','NGC 3697',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81387,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81387,34.69,0.38,86.6,32584,75,NULL,'W91CL, r, inv','NGC 3697',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81388,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81388,34.69,0.2,86.7,32584,74.4,NULL,NULL,'NGC 3697',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81389,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81389,34.72,0.46,87.8,32584,NULL,NULL,'J','NGC 3697',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81390,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81390,34.75,0.38,89,32584,75,NULL,'W91CL, r, cor','NGC 3697',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81391,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81391,34.77,0.38,89.8,32584,75,NULL,'CF, r, inv','NGC 3697',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81392,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81392,34.78,0.45,90.5,32584,NULL,NULL,'K','NGC 3697',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81393,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81393,34.78,0.4,90.5,32584,75,NULL,'HMCL, I, inv','NGC 3697',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81394,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81394,34.8,0.38,91,32584,75,NULL,'CF, r, cor','NGC 3697',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81395,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81395,34.8,0.4,91.3,32584,75,NULL,'HMCL, I, cor','NGC 3697',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81396,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81396,34.83,0.43,92.4,32584,75,NULL,'3.6 micron, color corrected','NGC 3697',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81397,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81397,34.96,0.4,98.2,32584,NULL,NULL,'mean','NGC 3697',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81398,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81398,35.12,0.07,106,32584,NULL,NULL,NULL,'NGC 3697',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81399,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81399,35.14,0.43,107,32584,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3697',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81400,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81400,37.17,0.46,271,32585,70,NULL,NULL,'2MASX J11285045+0125370',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000075,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,172.210125,1.42697,0.077,NULL,60178894300,940295223,14692112,17.7),(81401,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81401,38.16,0.46,429,32586,70,NULL,NULL,'SDSS J112850.72+344814.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000131,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,172.211375,34.80411,0,NULL,60418983315,944046614,14750728,18.5),(81402,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81402,38.4,0.46,479,32587,70,NULL,NULL,'2MASX J11285072+1042512',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00015,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,172.2114583,10.71422,0.126,NULL,60343294315,942863973,14732249,17.6),(81403,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81403,31.87,NULL,23.7,32588,NULL,NULL,NULL,'LSBC D571-06',NULL,'2015AstBu..70....1K',2015,1,1.1,NULL,'G',NULL,NULL,'17.1',0.7,'dE:',NULL,NULL,NULL,NULL,1,172.2125417,18.28425,0,NULL,61126377435,955099647,14923431,17.1),(81404,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81404,36.95,0.33,246,32589,70,NULL,NULL,'2MASX J11285350+4313481',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000181,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,172.223,43.22992,0,NULL,63898480936,998413764,15600215,16.3),(81405,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81405,37.98,0.19,395,32590,70,NULL,NULL,'2MASX J11285392+0143020',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.0001,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,172.2245417,1.71728,0.053,NULL,60178910552,940295477,14692116,16.4),(81406,'Tully est','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81406,32.75,0.8,35.4,32591,75,NULL,'B','NGC 3694',NULL,'1988NBGC.C....0000T',1988,1,0.99,NULL,'G',0.000017,NULL,'13.7g',0.76,'E','Group member',NULL,NULL,NULL,1,172.2255417,35.414,0.007,NULL,60419928041,944061375,14750958,13.7),(81407,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81407,37.26,0.33,283,32592,70,NULL,NULL,'2MASX J11285475+4712431',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,172.227917,47.21183,0.012,NULL,63895825227,998372269,15599566,17.2),(81408,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81408,37.75,0.23,355,32593,70,NULL,NULL,'2MASX J11285490+5732509',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000167,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,172.228875,57.54758,0,NULL,61991179174,968612174,15134565,17.1),(81409,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81409,37.34,0.16,294,32594,70,NULL,NULL,'2MASX J11285580+5533389',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,172.23225,55.56083,0,NULL,61985179209,968518425,15133100,16.9),(81410,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81410,36.78,0.46,227,32595,70,NULL,NULL,'2MASX J11285620+2711099',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000149,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,172.234167,27.18611,0,NULL,60578225021,946534765,14789605,16.8),(81411,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81411,34.45,0.5,77.8,32596,70,NULL,NULL,'2MASX J11285691-4640078',NULL,'2014MNRAS.445.2677S',2014,1,0.21,NULL,'G',0.000097,NULL,'14.5R',NULL,'S',NULL,NULL,NULL,NULL,1,172.237,-46.66889,0.529,NULL,41888440578,654506884,10226670,14.5),(81412,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81412,37.98,0.19,395,32597,70,NULL,NULL,'2MASX J11285852+0143010',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000104,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,172.24375,1.71706,0.053,NULL,60178909495,940295460,14692116,17.9),(81413,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81413,37.98,0.19,395,32598,70,NULL,NULL,'2MASX J11285912+0142030',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000078,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,172.2464583,1.70086,0.049,NULL,60179776640,940309010,14692328,17.2),(81414,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81414,35.83,0.27,147,32599,70,NULL,NULL,'MCG +04-27-043',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00008,NULL,'16.71',0.4,NULL,NULL,NULL,NULL,NULL,1,172.246958333,22.95989,0,NULL,61095245850,954613216,14915831,16.71),(81415,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81415,34.96,0.73,98,32600,70,NULL,NULL,'2MASX J11285963-1507329',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.12',NULL,NULL,NULL,NULL,NULL,NULL,1,172.248583,-15.12592,0.077,NULL,40976724548,640261321,10004083,16.12),(81416,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81416,36,0.46,158,32601,70,NULL,NULL,'2MASX J11285965+2107374',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00008,NULL,'17.06',0.26,NULL,NULL,NULL,NULL,NULL,1,172.248583,21.12711,0,NULL,61131809240,955184519,14924758,17.06),(81417,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81417,33.89,0.49,59.9,32602,75,NULL,'IR','2MFGC 08983',NULL,'2011yCatp016004901K',2011,1,1.23,NULL,'G',0.00069,NULL,'15.3',0.57,NULL,NULL,NULL,NULL,NULL,1,172.249125,-58.42297,NULL,NULL,40225373255,628521457,9820647,15.3),(81418,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81418,38.4,0.33,480,32603,70,NULL,NULL,'2MASX J11290037+3826341',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000176,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,172.251583,38.44272,0,NULL,60458393324,944662395,14760349,18),(81419,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81419,33.76,0.49,56.6,32604,75,NULL,'IR','UGC 06483',NULL,'2011yCatp016004901K',2011,1,2.05,NULL,'G',0.000006,NULL,'14.9g',0.31,'Sc',NULL,NULL,NULL,NULL,1,172.259667,17.23186,0.015,NULL,61108394166,954818658,14919041,14.9),(81420,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81420,33.96,0.4,62,32604,NULL,NULL,'mean','UGC 06483',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81421,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81421,34.02,NULL,63.6,32604,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06483',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81422,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81422,34.02,NULL,63.7,32604,NULL,NULL,'Dipole','UGC 06483',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81423,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81423,34.03,NULL,63.8,32604,NULL,NULL,'Dipole + Quadrupole','UGC 06483',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81424,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81424,34.07,0.2,65.2,32604,74.4,NULL,NULL,'UGC 06483',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81425,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81425,34.08,NULL,65.6,32604,NULL,NULL,NULL,'UGC 06483',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81426,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81426,34.16,0.47,67.9,32604,NULL,NULL,'H','UGC 06483',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81427,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81427,34.25,0.45,70.6,32604,NULL,NULL,'K','UGC 06483',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81428,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81428,34.26,0.52,71,32604,NULL,NULL,NULL,'UGC 06483',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81429,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81429,34.42,0.48,76.5,32604,NULL,NULL,'Malmquist cor.','UGC 06483',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81430,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81430,38.11,0.46,420,32605,70,NULL,NULL,'2MASX J11290503+2228474',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,172.271083333,22.47992,0,NULL,61094961403,954608771,14915762,17.7),(81431,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81431,36.14,0.33,169,32606,70,NULL,NULL,'2MASX J11290518+5110225',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000173,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,172.271625,51.17308,0,NULL,61805649653,965713275,15089269,16.5),(81432,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81432,37.96,0.46,391,32607,70,NULL,NULL,'2MASX J11290613+0702389',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000177,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,172.275625,7.04397,0.105,NULL,60395215090,943675235,14744925,17.8),(81433,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81433,36.72,0.23,221,32608,70,NULL,NULL,'2MASX J11290621+5648509',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,172.2760417,56.81408,0,NULL,61991539280,968617801,15134653,17.2),(81434,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81434,38.4,0.33,480,32609,70,NULL,NULL,'2MASX J11290637+3826468',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000176,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,172.2767083,38.44644,0,NULL,60458391358,944662364,14760349,17.1),(81435,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81435,34.43,0.47,76.8,32610,NULL,NULL,'H','IC 0699',NULL,'2007A&A...465...71T',2007,1,1.34,NULL,'G',0.000033,NULL,'14.2g',0.47,'Sb:','Group member',NULL,NULL,NULL,1,172.277041667,8.98858,0.133,NULL,60387453340,943553958,14743030,14.2),(81436,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81436,34.57,0.46,81.9,32610,NULL,NULL,'J','IC 0699',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81437,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81437,34.57,0.45,82.1,32610,NULL,NULL,'K','IC 0699',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81438,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81438,34.8,0.27,91.2,32610,NULL,NULL,'Malmquist cor.','IC 0699',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81439,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81439,34.88,0.4,94.6,32610,NULL,NULL,'mean','IC 0699',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81440,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81440,34.97,0.25,98.5,32610,NULL,NULL,NULL,'IC 0699',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81441,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81441,35.04,0.2,102,32610,74.4,NULL,NULL,'IC 0699',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81442,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81442,36.95,0.33,246,32611,70,NULL,NULL,'2MASX J11290682+4314254',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,172.2784583,43.24033,0,NULL,63898480418,998413756,15600214,17.2),(81443,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81443,38.33,0.23,463,32612,70,NULL,NULL,'2MASX J11290730+2057095',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,172.280375,20.95258,0,NULL,61131136326,955174005,14924593,18.2),(81444,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81444,36.14,0.46,169,32613,70,NULL,NULL,'2MASX J11290732+2707416',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000172,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,172.280625,27.12825,0,NULL,60578229170,946534830,14789606,17),(81445,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81445,36.34,0.33,185,32614,70,NULL,NULL,'CGCG 126-066',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000103,NULL,'15.4',0.46,NULL,NULL,NULL,NULL,NULL,1,172.2819583,21.58603,0,NULL,61131666426,955182287,14924723,15.4),(81446,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81446,35.62,0.52,133,32615,70,NULL,NULL,'LCRS B112635.3-055611',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00013,NULL,'14.78',NULL,NULL,NULL,NULL,NULL,NULL,1,172.283791667,-6.21186,0.097,NULL,41055855559,641497743,10023402,14.78),(81447,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81447,38.66,0.46,540,32616,70,NULL,NULL,'2MASX J11290851+5933438',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000177,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,172.2857083,59.56236,0,NULL,61850917684,966420588,15100321,17.8),(81448,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81448,37.09,0.46,262,32617,70,NULL,NULL,'2MASX J11290925+2420216',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.56',0.2,NULL,NULL,NULL,NULL,NULL,1,172.2885,24.33931,0,NULL,60574125130,946470705,14788604,17.56),(81449,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81449,35.27,0.54,113,32618,70,NULL,NULL,'NGC 3703',NULL,'2014MNRAS.445.2677S',2014,1,NULL,'Identification as NGC 3703 is uncertain.','G',0.00015,NULL,'15.46',NULL,NULL,NULL,NULL,NULL,NULL,1,172.289,-8.44644,0.053,NULL,41066846686,641669479,10026085,15.46),(81450,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81450,36.08,0.33,164,32619,70,NULL,NULL,'CGCG 011-107',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.00015,NULL,'15.5g',0.48,'E','Group member',NULL,NULL,NULL,1,172.290583,-1.71169,0,NULL,40835579024,638055922,9969623,15.5),(81451,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81451,37.02,0.46,254,32620,70,NULL,NULL,'2MASX J11291051+1529281',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00018,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,172.293917,15.49117,0.022,NULL,61109214919,954831483,14919241,16.4),(81452,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81452,37.33,0.17,293,32621,70,NULL,NULL,'2MASX J11291090+3637289',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000159,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,172.295667,36.62464,0,NULL,60420626022,944072281,14751129,16.5),(81453,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81453,32.87,0.4,37.5,32622,NULL,NULL,NULL,'NGC 3683A',NULL,'2009AJ....138..323T',2009,1,2.3,NULL,'G',0.000017,NULL,'12.60',1.7,'SB(rs)c','in a radial-velocity based grouping',NULL,NULL,NULL,1,172.299,57.13233,0,NULL,61991792163,968621752,15134714,12.6),(81454,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81454,32.99,0.4,39.7,32622,NULL,NULL,'mean','NGC 3683A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81455,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81455,33.03,0.45,40.4,32622,NULL,NULL,'K','NGC 3683A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81456,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81456,33.03,0.47,40.4,32622,NULL,NULL,'H','NGC 3683A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81457,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81457,33.07,0.46,41,32622,NULL,NULL,'J','NGC 3683A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81458,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81458,33.13,0.53,42.3,32622,NULL,NULL,'Malmquist cor.','NGC 3683A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81459,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81459,33.23,0.5,44.4,32622,NULL,NULL,NULL,'NGC 3683A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81460,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81460,33.28,0.2,45.3,32622,74.4,NULL,NULL,'NGC 3683A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81461,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81461,37.85,0.46,371,32623,70,NULL,NULL,'2MASX J11291202+0245370',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000077,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,172.300083333,2.76025,0.065,NULL,60177330945,940270796,14691731,17.5),(81462,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81462,37.23,0.46,279,32624,70,NULL,NULL,'2MASX J11291213+2733136',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.0001,NULL,'15.5g',0.5,NULL,NULL,NULL,NULL,NULL,1,172.300625,27.55389,0,NULL,60578083914,946532561,14789571,15.5),(81463,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81463,36.42,0.46,193,32625,70,NULL,NULL,'UGC 06488',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',NULL,NULL,'16.0',0.5,'E-S',NULL,NULL,NULL,NULL,1,172.301333,41.77739,0,NULL,63896715470,998386179,15599784,16),(81464,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81464,38.26,0.46,448,32626,70,NULL,NULL,'SDSS J112912.58+270445.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,172.3024583,27.07919,0,NULL,60578262298,946535348,14789614,18.6),(81465,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81465,34.15,0.46,67.7,32627,70,NULL,NULL,'MRK 1297',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000163,NULL,'14.87',0.5,'S0',NULL,NULL,NULL,NULL,1,172.304708333,19.77253,0,NULL,61132366481,955193226,14924894,14.87),(81466,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81466,36.11,0.46,167,32628,70,NULL,NULL,'2MASX J11291456+6116133',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000149,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,172.3100417,61.27064,0,NULL,61858821730,966544089,15102251,16.5),(81467,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81467,37.91,0.46,383,32629,70,NULL,NULL,'2MASX J11291505+0116160',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000096,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,172.3127083,1.27106,0.073,NULL,60178165680,940283838,14691934,17.2),(81468,'CMD','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81468,20.2,NULL,0.11,32630,NULL,NULL,NULL,'UGCA 237',NULL,'2008A&A...477..139L',2008,1,NULL,'Galactic globular cluster.','*Cl',NULL,NULL,NULL,NULL,'E',NULL,NULL,NULL,NULL,1,172.315833,28.97297,0,1,60603576338,946930880,14795795,NULL),(81469,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81469,37.98,0.19,395,32631,70,NULL,NULL,'SDSS J112917.14+014858.5',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00008,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,172.3214583,1.81628,0.053,NULL,60179810964,940309546,14692336,18),(81470,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81470,37.9,0.46,380,32632,70,NULL,NULL,'2MASX J11291798+1545241',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00017,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,172.325041667,15.75692,0.036,NULL,61110261266,954847832,14919497,17.5),(81471,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81471,38.43,0.46,486,32633,70,NULL,NULL,'2MASX J11291796+5411264',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000137,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,172.325041667,54.19078,0,NULL,61764989197,965077956,15079343,18),(81472,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81472,37.81,0.46,364,32634,70,NULL,NULL,'2MASX J11291807+3855259',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,172.3252917,38.92383,0,NULL,60458279504,944660617,14760322,17.8),(81473,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81473,37.57,0.46,326,32635,70,NULL,NULL,'2MASX J11291928+0139047',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000092,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,172.3304583,1.65147,0.049,NULL,60179798648,940309353,14692333,16.9),(81474,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81474,37.19,0.16,274,32636,70,NULL,NULL,'2MASX J11291925+5407344',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000196,NULL,'15.8g',0.41,'E0',NULL,NULL,NULL,NULL,1,172.330625,54.12608,0,NULL,61764956298,965077442,15079335,15.8),(81475,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81475,36.41,0.46,192,32637,70,NULL,NULL,'2MASX J11292085+0023457',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000082,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,172.33675,0.39603,0.057,NULL,60170374242,940162097,14690032,16.8),(81476,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81476,36.71,0.46,220,32638,70,NULL,NULL,'SDSS J112921.05+170556.0',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,172.33775,17.09892,0.044,NULL,61110500913,954851576,14919555,17.1),(81477,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81477,35.94,NULL,155,32639,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1255',NULL,'2010Ap&SS.325..163P',2010,1,1.23,NULL,'G',NULL,NULL,'16.2',0.12,'Sc',NULL,NULL,NULL,NULL,1,172.344167,61.97667,0,NULL,61873312480,966770507,15105789,16.2),(81478,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81478,35.96,NULL,156,32639,NULL,NULL,'Dipole + Quadrupole','FGC 1255',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81479,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81479,35.98,NULL,157,32639,NULL,NULL,'Dipole','FGC 1255',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81480,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81480,35.98,NULL,157,32639,NULL,NULL,NULL,'FGC 1255',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81481,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81481,35.72,0.46,139,32640,70,NULL,NULL,'MCG +09-19-089',NULL,'2015arXiv151105856S',2015,1,0.85,'Companion galaxy in contact 26\\\" southeast.','G',0.000168,NULL,'15.1g',0.48,'E0',NULL,NULL,NULL,NULL,1,172.344958333,55.31839,0,NULL,61985235663,968519307,15133114,15.1),(81482,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81482,38.63,0.46,532,32641,70,NULL,NULL,'SDSS J112923.26+183543.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.6g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,172.346916667,18.59544,0,NULL,61126796343,955106192,14923534,18.6),(81483,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81483,36.14,0.33,169,32642,70,NULL,NULL,'2MASX J11292359+5112364',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000182,NULL,'15.9g',0.39,'E0',NULL,NULL,NULL,NULL,1,172.348125,51.21006,0,NULL,61805676261,965713691,15089276,15.9),(81484,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81484,37.51,0.46,318,32643,70,NULL,NULL,'2MASX J11292391-0230510',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00015,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,172.349583,-2.51431,0.113,NULL,40834119350,638033114,9969267,16.9),(81485,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81485,32.94,0.4,38.8,32644,75,NULL,'B','UGC 06491',NULL,'1988NBGC.C....0000T',1988,1,0.89,NULL,'G',0.000037,NULL,'15.5g',0.66,'Sdm',NULL,NULL,NULL,NULL,1,172.3502917,34.87108,0,NULL,60419000198,944046878,14750732,15.5),(81486,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81486,38.33,0.23,463,32645,70,NULL,NULL,'2MASX J11292416+2101134',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'17.49',0.15,'BrClG',NULL,NULL,NULL,NULL,1,172.350583,21.02053,0,NULL,61131130810,955173918,14924592,17.49),(81487,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81487,37.39,0.46,301,32646,70,NULL,NULL,'2MASX J11292591+1947437',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,172.358,19.79553,0,NULL,61132333881,955192716,14924886,17.2),(81488,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81488,37.64,0.46,338,32647,70,NULL,NULL,'2MASX J11292614+4620165',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000174,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,172.3587917,46.338,0,NULL,63895124098,998361314,15599395,16.9),(81489,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81489,35.1,0.52,105,32648,70,NULL,NULL,'NGC 3711 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'15.0R',0.3,'cE0? pec',NULL,NULL,NULL,NULL,1,172.358917,-11.07383,0.033,NULL,41011331523,640802055,10012532,15),(81490,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81490,37.33,0.17,293,32649,70,NULL,NULL,'SDSS J112927.08+363818.6',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'15.7g',0.4,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,172.362833,36.6385,0,NULL,60420625149,944072267,14751129,15.7),(81491,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81491,36.08,0.33,164,32650,70,NULL,NULL,'CGCG 011-110',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000153,NULL,'15.1g',0.6,'E','Group member',NULL,NULL,NULL,1,172.3637917,-1.74692,0.037,NULL,40835571111,638055798,9969621,15.1),(81492,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81492,36.75,0.46,224,32651,70,NULL,NULL,'2MASX J11292798+2845255',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.3g',0.2,'E',NULL,NULL,NULL,NULL,1,172.366625,28.75719,0,NULL,60603711309,946932989,14795827,17.3),(81493,'IRAS','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81493,33.15,0.8,42.6,32652,75,NULL,'A82, H','NGC 3701',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000018,NULL,'13.48',0.9,'Sbc',NULL,NULL,NULL,NULL,1,172.3705,24.09344,0,NULL,60573425365,946459771,14788433,13.48),(81494,'IRAS','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81494,33.15,0.8,42.6,32652,75,NULL,'HMCL, I','NGC 3701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81495,'IRAS','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81495,33.18,0.8,43.3,32652,75,NULL,'CF, r','NGC 3701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81496,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81496,32.14,0.69,26.8,32652,100,NULL,'mid-IR','NGC 3701',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81497,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81497,32.86,0.38,37.3,32652,75,NULL,'CF, r, raw','NGC 3701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81498,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81498,32.89,0.43,37.9,32652,75,NULL,'3.6 micron, color corrected','NGC 3701',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81499,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81499,32.91,0.38,38.2,32652,75,NULL,'CF, r, inv','NGC 3701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81500,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81500,32.91,0.43,38.2,32652,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3701',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81501,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81501,32.92,0.2,38.4,32652,74.4,NULL,NULL,'NGC 3701',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81502,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81502,33.07,0.37,41.1,32652,NULL,NULL,NULL,'NGC 3701',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81503,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81503,33.08,0.3,41.2,32652,55,NULL,'B','NGC 3701',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81504,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81504,33.12,0.38,42.1,32652,75,NULL,'CF, r, cor','NGC 3701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81505,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81505,33.13,0.4,42.4,32652,NULL,NULL,'mean','NGC 3701',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81506,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81506,33.34,0.47,46.6,32652,75,NULL,'A82, H, raw','NGC 3701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81507,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81507,33.37,0.4,47.1,32652,75,NULL,'HMCL, I, raw','NGC 3701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81508,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81508,33.4,0.47,47.9,32652,75,NULL,'A82, H, inv','NGC 3701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81509,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81509,33.45,0.47,49,32652,NULL,NULL,'H','NGC 3701',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81510,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81510,33.49,0.4,49.9,32652,75,NULL,'HMCL, I, inv','NGC 3701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81511,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81511,33.51,0.46,50.4,32652,NULL,NULL,'J','NGC 3701',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81512,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81512,33.52,0.45,50.5,32652,NULL,NULL,'K','NGC 3701',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81513,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81513,33.61,0.4,52.8,32652,75,NULL,'HMCL, I, cor','NGC 3701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81514,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81514,33.7,0.47,54.9,32652,75,NULL,'A82, H, cor','NGC 3701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81515,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81515,37.35,0.46,295,32653,70,NULL,NULL,'SDSS J112929.03+552545.9',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,172.370958333,55.42944,0,NULL,61985254015,968519593,15133118,17.5),(81516,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81516,37.34,0.46,294,32654,70,NULL,NULL,'2MASX J11292916+4559374',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000135,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,172.3715417,45.99367,0,NULL,63893238582,998331852,15598935,16.9),(81517,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81517,37.27,0.46,284,32655,70,NULL,NULL,'2MASX J11292961+1432141',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00019,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,172.3732917,14.53722,0.041,NULL,60223379647,940990306,14702973,16.9),(81518,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81518,38.01,0.46,400,32656,70,NULL,NULL,'2MASX J11293009+0124257',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00008,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,172.3752917,1.40725,0.073,NULL,60178116120,940283064,14691922,17.7),(81519,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81519,38.42,0.46,483,32657,70,NULL,NULL,'LCRS B112656.8-022327',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000171,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,172.376083333,-2.66639,0.085,NULL,40834092762,638032699,9969260,18),(81520,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81520,38.33,0.23,463,32658,70,NULL,NULL,'2MASX J11293040+2100027',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,172.376583,21.00075,0,NULL,61131142627,955174103,14924595,17.9),(81521,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81521,37.19,0.16,274,32659,70,NULL,NULL,'2MASX J11293041+5407015',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000165,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,172.3767083,54.11708,0,NULL,61764949778,965077340,15079333,18),(81522,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81522,37.09,0.46,262,32660,70,NULL,NULL,'SDSS J112930.64+251738.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,172.377667,25.29414,0,NULL,60571441737,946428777,14787949,17.7),(81523,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81523,38.33,0.23,463,32661,70,NULL,NULL,'SDSS J112930.84+210105.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,172.3785417,21.01819,0,NULL,61131131928,955173936,14924592,18.3),(81524,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81524,37.34,0.16,294,32662,70,NULL,NULL,'2MASX J11293234+5525206',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000202,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,172.384875,55.42239,0,NULL,61985255844,968519622,15133119,16.3),(81525,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81525,37.14,0.19,268,32663,70,NULL,NULL,'SDSS J112932.47+561502.4',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,172.385291667,56.25067,0,NULL,61984951954,968514874,15133044,17.8),(81526,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81526,37.22,0.46,278,32664,70,NULL,NULL,'2MASX J11293264+3852059',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000157,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,172.386,38.86825,0,NULL,60458308859,944661075,14760329,17.3),(81527,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81527,37.33,0.46,292,32665,70,NULL,NULL,'SDSS J112934.05+354247.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000134,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,172.391916667,35.71333,0,NULL,60419373678,944052713,14750823,18.2),(81528,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81528,37.22,0.46,278,32666,70,NULL,NULL,'2MASX J11293473+0239417',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00007,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,172.3947917,2.66147,0.065,NULL,60177367922,940271373,14691740,17.6),(81529,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81529,37.09,0.46,261,32667,70,NULL,NULL,'2MASX J11293474+6201532',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,172.394875,62.03172,0,NULL,61873322863,966770669,15105791,17.4),(81530,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81530,38.3,0.46,457,32668,70,NULL,NULL,'2MASX J11293491+2821346',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,172.395417,28.35967,0,NULL,60574219189,946472174,14788627,17.6),(81531,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81531,37.34,0.16,294,32669,70,NULL,NULL,'2MASX J11293528+5524376',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000179,NULL,'17.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,172.396875,55.41042,0,NULL,61985256253,968519628,15133119,17.2),(81532,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81532,38.16,0.46,428,32670,70,NULL,NULL,'SDSS J112936.04+291309.7',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.8g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,172.4002083,29.21939,0,NULL,60658163713,947783808,14809122,17.8),(81533,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81533,37.32,0.27,291,32671,70,NULL,NULL,'2MASX J11293680+3158289',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000181,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,172.4032917,31.97467,0.024,NULL,60651948734,947686698,14807604,16.6),(81534,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81534,37.34,0.16,294,32672,70,NULL,NULL,'2MASX J11293703+5532006',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,172.40425,55.53347,0,NULL,61985174554,968518352,15133099,17.8),(81535,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81535,37.32,0.27,291,32673,70,NULL,NULL,'SDSS J112937.04+320021.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,172.404375,32.00597,0.021,NULL,60651960292,947686879,14807607,18.1),(81536,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81536,37.79,0.46,361,32674,70,NULL,NULL,'SDSS J112937.24+262446.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,172.405167,26.41283,0,NULL,60577124388,946517568,14789337,18),(81537,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81537,37.69,0.46,345,32675,70,NULL,NULL,'2MASX J11293756+3411589',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000172,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,172.4067083,34.19964,0.02,NULL,60649816873,947653388,14807084,17),(81538,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81538,37.33,0.17,293,32676,70,NULL,NULL,'2MASX J11293930+3634349',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,172.413667,36.57625,0,NULL,60450818646,944544041,14758500,17.5),(81539,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81539,38.16,0.46,428,32677,70,NULL,NULL,'SDSS J112941.79+162256.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,172.424167,16.38242,0.083,NULL,61110291659,954848307,14919504,18.4),(81540,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81540,36.75,0.46,224,32678,70,NULL,NULL,'2MASX J11294275+3114119',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000128,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,172.428167,31.23653,0,NULL,60659156687,947799323,14809364,17.9),(81541,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81541,37.34,0.16,294,32679,70,NULL,NULL,'2MASX J11294280+5522496',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000213,NULL,'15.8g',0.46,'BrClG',NULL,NULL,NULL,NULL,1,172.428625,55.38047,0,NULL,61985257951,968519655,15133119,15.8),(81542,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81542,35.38,0.38,119,32680,NULL,NULL,NULL,'ESO 439- G 013',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000033,NULL,'15.08',0.5,'S?             HII',NULL,NULL,NULL,NULL,1,172.429583,-31.8515,0.273,NULL,41605433895,650084904,10157576,15.08),(81543,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81543,35.41,0.38,121,32680,NULL,NULL,'Malmquist cor.','ESO 439- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81544,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81544,35.42,0.2,121,32680,74.4,NULL,NULL,'ESO 439- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81545,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81545,37.69,0.46,346,32681,70,NULL,NULL,'2MASX J11294334+6025241',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,172.430417,60.42331,0,NULL,61852101338,966439083,15100610,17.3),(81546,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81546,36.8,0.33,229,32682,70,NULL,NULL,'SDSS J112943.70+600533.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,172.432125,60.09264,0,NULL,61852446427,966444475,15100694,17.8),(81547,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81547,36.61,0.46,210,32683,70,NULL,NULL,'2MASX J11294374+0346067',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,172.4322917,3.76867,0.057,NULL,60354358867,943036857,14734950,16.5),(81548,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81548,37.34,0.16,294,32684,70,NULL,NULL,'SDSS J112943.89+552259.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000174,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,172.432917,55.38328,0,NULL,61985257766,968519652,15133119,18.6),(81549,'D-Sigma','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81549,32.6,0.4,33.1,32685,75,NULL,'Edat, raw','NGC 3706',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000047,NULL,'12.38',1.8,'SA(rs)0-',NULL,NULL,NULL,NULL,1,172.435125,-36.39131,0.353,NULL,41390990708,646734229,10105222,12.38),(81550,'D-Sigma','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81550,32.94,0.4,38.7,32685,75,NULL,'Edat, cor','NGC 3706',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81551,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81551,32.58,0.49,32.9,32685,70,NULL,NULL,'NGC 3706',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81552,'Tully est','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81552,33.04,0.8,40.5,32685,75,NULL,'B','NGC 3706',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81553,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81553,32.99,0.45,39.5,32685,NULL,NULL,'K','NGC 3706',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81554,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81554,33.39,0.4,47.7,32685,NULL,NULL,'mean','NGC 3706',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81555,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81555,37.81,0.46,364,32686,70,NULL,NULL,'SDSS J112944.57+180007.9',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,172.4357083,18.00219,0,NULL,61127140938,955111577,14923618,17.9),(81556,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81556,37.35,0.46,296,32687,70,NULL,NULL,'2MASX J11294469+1450380',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000152,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,172.436208333,14.84408,0.033,NULL,60223199713,940987495,14702929,17.4),(81557,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81557,37.32,0.27,291,32688,70,NULL,NULL,'2MASX J11294669+3159164',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000194,NULL,'15.9g',0.41,'BrClG',NULL,NULL,NULL,NULL,1,172.444541667,31.988,0.021,NULL,60651961062,947686891,14807607,15.9),(81558,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81558,38.26,0.27,449,32689,70,NULL,NULL,'2MASX J11294847+0318170',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.26',0.18,'BrClG',NULL,NULL,NULL,NULL,1,172.452,3.30464,0.049,NULL,60173581799,940212215,14690815,18.26),(81559,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81559,37.14,0.19,268,32690,70,NULL,NULL,'2MASX J11294868+5616146',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000191,NULL,'16.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,172.45275,56.27069,0,NULL,61989290008,968582656,15134104,16.8),(81560,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81560,35.57,0.46,130,32691,70,NULL,NULL,'2MASX J11294872+4413499',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000161,NULL,'15.2g',0.55,'LINER',NULL,NULL,NULL,NULL,1,172.453125,44.23053,0.011,NULL,63900287590,998441993,15600656,15.2),(81561,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81561,37.2,0.46,275,32692,70,NULL,NULL,'2MASX J11295286+0408060',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000189,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,172.470167,4.13519,0.073,NULL,60354435919,943038061,14734969,16.3),(81562,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81562,36.85,0.46,234,32693,70,NULL,NULL,'2MASX J11295348+1354040',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000147,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,172.4729583,13.90122,0.118,NULL,60229901279,941092207,14704565,17.2),(81563,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81563,38.26,0.27,449,32694,70,NULL,NULL,'2MASX J11295375+0319441',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000084,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,172.474041667,3.32881,0.049,NULL,60173581274,940212207,14690815,18.1),(81564,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81564,38.01,0.46,400,32695,70,NULL,NULL,'SDSS J112955.43+340710.4',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000127,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,172.4809583,34.11958,0.024,NULL,60649822082,947653470,14807085,18.6),(81565,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81565,36.98,0.46,249,32696,70,NULL,NULL,'2MASX J11295616+1953511',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,172.484,19.89744,0,NULL,61132325427,955192584,14924884,17.2),(81566,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81566,37.19,0.16,274,32697,70,NULL,NULL,'2MASX J11295670+5411165',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000194,NULL,'16.1g',0.41,'E0',NULL,NULL,NULL,NULL,1,172.486333,54.18781,0,NULL,61764982894,965077857,15079341,16.1),(81567,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81567,36.24,0.46,177,32698,70,NULL,NULL,'2MASX J11295709+5213248',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.0002,NULL,'15.6g',0.37,'S0/a',NULL,NULL,NULL,NULL,1,172.488125,52.22369,0,NULL,61805694246,965713972,15089280,15.6),(81568,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81568,38.26,0.27,449,32699,70,NULL,NULL,'2MASX J11295722+0318021',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.75',0.14,NULL,NULL,NULL,NULL,NULL,1,172.488458333,3.30058,0.057,NULL,60173579737,940212183,14690815,18.75),(81569,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81569,35.58,0.46,131,32700,70,NULL,NULL,'2MASX J11295830+2057401',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.35',0.23,NULL,NULL,NULL,NULL,NULL,1,172.493083,20.96119,0,NULL,61131049438,955172647,14924572,16.35),(81570,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81570,37.67,0.46,343,32701,70,NULL,NULL,'SDSS J112959.50+221701.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,172.4979583,22.28378,0,NULL,61128200613,955128134,14923877,18),(81571,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81571,32.98,0.49,39.4,32702,70,NULL,NULL,'ESO 571- G 004',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000103,NULL,'14.51',0.4,'S0',NULL,NULL,NULL,NULL,1,172.4982083,-20.58292,0.153,NULL,41730682827,652041919,10188154,14.51),(81572,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81572,36.15,0.46,170,32703,70,NULL,NULL,'2MASX J11300274+5617435',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'16.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,172.511375,56.29542,0,NULL,61989424677,968584760,15134136,16.7),(81573,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81573,37.33,0.17,293,32704,70,NULL,NULL,'2MASX J11300319+3638135',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000182,NULL,'16.3g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,172.5132917,36.63722,0,NULL,60450821499,944544085,14758501,16.3),(81574,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81574,38.22,0.46,441,32705,70,NULL,NULL,'SDSS J113003.37+101537.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00017,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,172.514083333,10.26028,0.085,NULL,60342926174,942858221,14732159,18.3),(81575,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81575,35.45,0.58,123,32706,70,NULL,NULL,'2MASX J11300370-1327256',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.82',NULL,NULL,NULL,NULL,NULL,NULL,1,172.515583,-13.45711,0.053,NULL,40986354942,640411795,10006434,15.82),(81576,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81576,33.84,0.47,58.5,32707,70,NULL,NULL,'NGC 3704',NULL,'2014MNRAS.445.2677S',2014,1,1.6,'The identification with IC 0703 is not certain.','G',0.00015,NULL,'13.75',1.4,'E+',NULL,NULL,NULL,NULL,1,172.519375,-11.54633,0.041,NULL,40979974276,640312098,10004876,13.75),(81577,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81577,34.13,0.5,67,32708,70,NULL,NULL,'2MASX J11300533-0939572',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000107,NULL,'15.43',NULL,NULL,NULL,NULL,NULL,NULL,1,172.522125,-9.66586,0.033,NULL,41064640193,641635003,10025546,15.43),(81578,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81578,37.97,0.46,392,32709,70,NULL,NULL,'2MASX J11300591+4631419',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000198,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,172.5247917,46.52836,0,NULL,63895147171,998361674,15599401,16.9),(81579,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81579,37.19,0.46,275,32710,70,NULL,NULL,'2MASXi J1130068-005331',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000071,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,172.52825,-0.89208,0.069,NULL,40828825646,637950400,9967975,17.2),(81580,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81580,36.18,0.46,172,32711,70,NULL,NULL,'2MASX J11300681+3257445',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000139,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,172.528333,32.96231,0.012,NULL,60652036211,947688065,14807626,17),(81581,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81581,39.57,0.46,820,32712,70,NULL,NULL,'SDSS J113007.32+034343.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,172.5305,3.72875,0.057,NULL,60173166964,940205733,14690714,18.3),(81582,'Ring Diameter','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81582,31,0.98,16,32713,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3705',NULL,'1981ApJS...45..541P',1981,1,4.9,NULL,'G',0.000005,NULL,'11.86',2,'SAB(r)ab;LINER HII','Group member',NULL,NULL,NULL,1,172.531083,9.27664,0.115,NULL,60387254774,943550855,14742982,11.86),(81583,'Ring Diameter','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81583,31.4,0.76,19,32713,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3705',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81584,'IRAS','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81584,31.12,0.8,16.7,32713,75,NULL,'A82, H','NGC 3705',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81585,'Sosies','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81585,31.93,0.14,24.3,32713,NULL,NULL,NULL,'NGC 3705',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81586,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81586,31.07,0.47,16.4,32713,75,NULL,'A82, H, raw','NGC 3705',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81587,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81587,31.15,0.4,17,32713,75,NULL,'B','NGC 3705',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81588,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81588,31.16,NULL,17.1,32713,NULL,NULL,'B','NGC 3705',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81589,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81589,31.18,0.35,17.2,32713,NULL,NULL,NULL,'NGC 3705',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81590,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81590,31.19,0.47,17.3,32713,75,NULL,'A82, H, inv','NGC 3705',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81591,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81591,31.32,0.46,18.3,32713,NULL,NULL,'J','NGC 3705',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81592,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81592,31.32,0.45,18.4,32713,NULL,NULL,'K','NGC 3705',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81593,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81593,31.34,0.47,18.5,32713,75,NULL,'A82, H, cor','NGC 3705',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81594,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81594,31.41,0.2,19.1,32713,74.4,NULL,NULL,'NGC 3705',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81595,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81595,31.44,0.3,19.4,32713,55,NULL,'B','NGC 3705',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81596,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81596,31.45,0.4,19.5,32713,NULL,NULL,'mean','NGC 3705',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81597,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81597,31.46,0.43,19.6,32713,75,NULL,'3.6 micron, color corrected','NGC 3705',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81598,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81598,31.49,0.43,19.9,32713,NULL,NULL,NULL,'NGC 3705',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81599,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81599,31.49,0.43,19.9,32713,NULL,NULL,'Malmquist cor.','NGC 3705',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81600,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81600,31.53,0.43,20.3,32713,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3705',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81601,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81601,31.8,NULL,22.9,32713,NULL,NULL,'LEDA [April 2006]','NGC 3705',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81602,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81602,35.74,0.49,141,32714,75,NULL,'IR','FGC 1259',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000214,NULL,'16.8g',0.14,'Sc',NULL,NULL,NULL,NULL,1,172.532041667,53.08589,0,NULL,61792916518,965514320,15086161,16.8),(81603,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81603,35.92,NULL,152,32714,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1259',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81604,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81604,35.94,NULL,154,32714,NULL,NULL,'Dipole + Quadrupole','FGC 1259',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81605,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81605,35.95,NULL,155,32714,NULL,NULL,NULL,'FGC 1259',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81606,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81606,35.96,NULL,156,32714,NULL,NULL,'Dipole','FGC 1259',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81607,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81607,35.29,0.6,114,32715,70,NULL,NULL,'2MASX J11300902-1223536',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.29',0.4,NULL,NULL,NULL,NULL,NULL,1,172.5374583,-12.39822,0.037,NULL,40979897250,640310894,10004857,16.29),(81608,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81608,34.38,NULL,75.2,32716,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06497',NULL,'2010Ap&SS.325..163P',2010,1,1.81,'The 2MASX position applies to the eastern end of the galaxy.','G',0.000027,NULL,'15.7g',0.25,'Sd',NULL,NULL,NULL,NULL,1,172.5385417,38.62044,0,NULL,60458481185,944663768,14760371,15.7),(81609,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81609,34.39,NULL,75.5,32716,NULL,NULL,'Dipole + Quadrupole','UGC 06497',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81610,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81610,34.39,NULL,75.6,32716,NULL,NULL,'Dipole','UGC 06497',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81611,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81611,34.7,0.49,87.2,32716,75,NULL,'IR','UGC 06497',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81612,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81612,37.51,0.33,318,32717,70,NULL,NULL,'2MASX J11300982+1606568',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.46',0.13,NULL,NULL,NULL,NULL,NULL,1,172.5409583,16.11581,0.055,NULL,61107488263,954804504,14918820,18.46),(81613,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81613,37.99,0.46,397,32718,70,NULL,NULL,'2MASX J11301074+4107215',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000173,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,172.54475,41.12272,0,NULL,63896119007,998376859,15599638,17.8),(81614,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81614,34.79,0.52,90.8,32719,70,NULL,NULL,'NGC 3702',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'14.07',0.7,'SAB(r)a pec:',NULL,NULL,NULL,NULL,1,172.556166667,-8.86292,0.037,NULL,41065115476,641642429,10025662,14.07),(81615,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81615,37.23,0.46,279,32720,70,NULL,NULL,'2MASX J11301347+2313201',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.23',0.16,NULL,NULL,NULL,NULL,NULL,1,172.556166667,23.22236,0,NULL,61095160254,954611878,14915810,18.23),(81616,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81616,37.3,0.46,288,32721,70,NULL,NULL,'2MASX J11301353+0126061',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000091,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,172.5565417,1.43503,0.041,NULL,60179237632,940300588,14692196,16.6),(81617,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81617,37.67,0.46,342,32722,70,NULL,NULL,'SDSS J113013.72+533615.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,172.557208333,53.60428,0,NULL,61762707114,965042298,15078785,18.3),(81618,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81618,36.8,0.33,229,32723,70,NULL,NULL,'2MASX J11301394+5958496',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000175,NULL,'15.6g',0.47,'E/S0',NULL,NULL,NULL,NULL,1,172.557833333,59.98044,0,NULL,61852551556,966446118,15100720,15.6),(81619,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81619,38.86,0.46,592,32724,70,NULL,NULL,'SDSS J113014.43+575255.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000168,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,172.560125,57.88206,0,NULL,61990180119,968596564,15134321,18.2),(81620,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81620,37.34,0.16,294,32725,70,NULL,NULL,'2MASX J11301572+5532591',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,172.565375,55.54981,0,NULL,61985194045,968518656,15133104,17.9),(81621,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81621,37.72,0.46,351,32726,70,NULL,NULL,'2MASX J11301656+1820261',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,172.568875,18.34072,0,NULL,61126834932,955106795,14923543,17.9),(81622,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81622,37.1,0.46,264,32727,70,NULL,NULL,'SDSS J113017.44+165924.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,172.5727083,16.99017,0.044,NULL,61107315134,954801798,14918778,17.7),(81623,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81623,37.1,0.46,263,32728,70,NULL,NULL,'2MASX J11301778+5025491',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000158,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,172.57425,50.43042,0,NULL,61797981941,965593467,15087397,16.8),(81624,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81624,36.44,0.46,194,32729,70,NULL,NULL,'2MASX J11301789+2216501',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.51',0.22,NULL,NULL,NULL,NULL,NULL,1,172.57475,22.28042,0,NULL,61128224756,955128511,14923882,17.51),(81625,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81625,36.9,0.46,240,32730,70,NULL,NULL,'2MASX J11301824+0144400',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000084,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,172.576,1.74453,0.041,NULL,60179251584,940300806,14692200,16.9),(81626,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81626,34.69,0.57,86.7,32731,70,NULL,NULL,'2MASX J11301876-0900281',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000107,NULL,'15.39',0.5,NULL,NULL,NULL,NULL,NULL,1,172.578125,-9.00789,0.037,NULL,41065031739,641641120,10025642,15.39),(81627,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81627,36.79,0.46,228,32732,70,NULL,NULL,'2MASX J11301895+1437257',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,172.578833,14.62372,0.041,NULL,60225175614,941018368,14703412,18),(81628,'IRAS','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81628,33.44,0.8,48.8,32733,75,NULL,'MAT, I','ESO 319- G 026',NULL,'1997ApJS..109..333W',1997,1,2.08,NULL,'G',0.000025,NULL,'14.58',0.2,'Sb',NULL,NULL,NULL,NULL,1,172.579167,-41.06667,0.393,NULL,41880310296,654379848,10224685,14.58),(81629,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81629,32.73,0.32,35.1,32733,85,NULL,'I, inv','ESO 319- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81630,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81630,32.76,0.32,35.7,32733,85,NULL,'I, raw','ESO 319- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81631,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81631,33.07,0.43,41.1,32733,75,NULL,'MAT, I, inv','ESO 319- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81632,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81632,33.09,NULL,41.5,32733,NULL,NULL,NULL,'ESO 319- G 026',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81633,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81633,33.12,0.43,42,32733,75,NULL,'MAT, I, raw','ESO 319- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81634,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81634,33.3,0.43,45.8,32733,75,NULL,'MAT, I, cor','ESO 319- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81635,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81635,33.61,NULL,52.7,32733,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 319- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81636,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81636,33.62,NULL,53,32733,NULL,NULL,'Dipole','ESO 319- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81637,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81637,33.63,NULL,53.1,32733,NULL,NULL,'Dipole + Quadrupole','ESO 319- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81638,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81638,33.74,0.12,56.1,32733,NULL,NULL,NULL,'ESO 319- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81639,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81639,37.69,0.46,345,32734,70,NULL,NULL,'2MASX J11302016+6241166',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000143,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,172.584083,62.68781,0,NULL,61873627366,966775427,15105866,17.9),(81640,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81640,36.18,0.46,172,32735,70,NULL,NULL,'2MASX J11302020+4057102',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000175,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,172.584208333,40.953,0,NULL,63896154756,998377418,15599647,16.4),(81641,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81641,35.62,NULL,133,32736,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1257',NULL,'2010Ap&SS.325..163P',2010,1,0.78,NULL,'G',NULL,NULL,'16.8',0.09,'Sdm',NULL,NULL,NULL,NULL,1,172.585458333,79.96336,0.105,NULL,61237369587,956833899,14950529,16.8),(81642,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81642,35.65,NULL,135,32736,NULL,NULL,'Dipole + Quadrupole','FGC 1257',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81643,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81643,35.66,NULL,136,32736,NULL,NULL,NULL,'FGC 1257',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81644,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81644,35.66,NULL,136,32736,NULL,NULL,'Dipole','FGC 1257',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81645,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81645,37.73,0.46,351,32737,70,NULL,NULL,'2MASX J11302062+3517037',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,172.5860417,35.28442,0,NULL,60448501527,944507836,14757934,17.8),(81646,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81646,37.97,0.46,393,32738,70,NULL,NULL,'2MASX J11302071+5506131',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,172.5864583,55.10375,0,NULL,61763532490,965055195,15078987,17.7),(81647,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81647,36.75,0.46,224,32739,70,NULL,NULL,'2MASX J11302108+4324212',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000206,NULL,'15.9g',0.44,'E',NULL,NULL,NULL,NULL,1,172.588,43.40589,0.01,NULL,63898968086,998421376,15600334,15.9),(81648,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81648,35.75,0.5,142,32740,70,NULL,NULL,'2MASX J11302132-0657408',NULL,'2014MNRAS.445.2677S',2014,1,0.94,NULL,'G',0.00007,NULL,'15.28',0.43,NULL,NULL,NULL,NULL,NULL,1,172.588875,-6.96139,0.069,NULL,41069111190,641704862,10026638,15.28),(81649,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81649,37.33,0.17,293,32741,70,NULL,NULL,'2MASX J11302229+3640183',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000168,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,172.59275,36.67183,0,NULL,60450849757,944544527,14758508,16.6),(81650,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81650,37.28,0.46,285,32742,70,NULL,NULL,'2MASX J11302390+2618299',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000136,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,172.599667,26.30833,0,NULL,60576377713,946505901,14789154,18.2),(81651,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81651,38.59,0.46,523,32743,70,NULL,NULL,'SDSS J113025.11+560723.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000156,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,172.604667,56.12331,0,NULL,61984887978,968513874,15133029,18.7),(81652,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81652,37.65,0.46,338,32744,70,NULL,NULL,'LCRS B112753.1-030402',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,172.609875,-3.34272,0.109,NULL,40826068636,637907322,9967301,17.2),(81653,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81653,37.12,0.33,266,32745,70,NULL,NULL,'2MASX J11302645+1432077',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00016,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,172.610291667,14.53556,0.041,NULL,60225010138,941015783,14703371,17),(81654,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81654,35.48,0.63,125,32746,70,NULL,NULL,'2MASX J11302675-0745398',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'16.69',0.28,NULL,NULL,NULL,NULL,NULL,1,172.6114583,-7.76111,0.061,NULL,41070482633,641726291,10026973,16.69),(81655,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81655,38.74,0.46,560,32747,70,NULL,NULL,'2MASX J11302702+5800562',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,172.612625,58.01542,0,NULL,61990173494,968596460,15134319,17.9),(81656,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81656,37.88,0.46,377,32748,70,NULL,NULL,'2MASX J11302746+1732547',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,172.6145,17.54864,0.007,NULL,61127032219,955109878,14923591,17.9),(81657,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81657,37.19,0.16,274,32749,70,NULL,NULL,'2MASX J11302754+5401422',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000181,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,172.614625,54.02847,0,NULL,61765053089,965078954,15079358,16.3),(81658,'Tully est','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81658,32.57,0.8,32.6,32750,75,NULL,'B','MRK 0424',NULL,'1988NBGC.C....0000T',1988,1,0.78,NULL,'G',0.000017,NULL,'15.0g',0.34,'S?',NULL,NULL,NULL,NULL,1,172.61525,36.73733,0,NULL,60450842656,944544416,14758506,15),(81659,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81659,37.19,0.16,274,32751,70,NULL,NULL,'2MASX J11302888+5410252',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000161,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,172.620125,54.17383,0,NULL,61764975245,965077738,15079339,16.8),(81660,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81660,37.68,0.46,344,32752,70,NULL,NULL,'2MASX J11302905+1536167',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000177,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,172.621,15.60478,0.036,NULL,60225499259,941023425,14703491,17),(81661,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81661,37.12,0.33,266,32753,70,NULL,NULL,'2MASX J11302928+1438567',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,172.622167,14.64911,0.041,NULL,60225178972,941018421,14703412,17.4),(81662,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81662,35.84,0.33,147,32754,70,NULL,NULL,'CGCG 011-112',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000086,NULL,'15.6g',0.47,'SA0-:',NULL,NULL,NULL,NULL,1,172.6222083,0.49431,0.057,NULL,60170219042,940159672,14689994,15.6),(81663,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81663,34.73,0.49,88.2,32755,75,NULL,'IR','NGC 3705A',NULL,'2011yCatp016004901K',2011,1,1.22,NULL,'G',0.000014,NULL,'16.0g',0.2,'Sc',NULL,NULL,NULL,NULL,1,172.623833333,9.38794,0.115,NULL,60387163617,943549431,14742959,16),(81664,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81664,34.7,0.2,87.1,32756,74.4,NULL,NULL,'NGC 3705A',NULL,'2013AJ....146...86T',2013,1,1.22,NULL,'G',0.000014,NULL,'16.0g',0.2,'Sc',NULL,NULL,NULL,NULL,1,172.623833333,9.38794,0.115,NULL,60387163617,943549431,14742959,16),(81665,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81665,37.14,0.19,268,32757,70,NULL,NULL,'2MASX J11303036+5621412',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000156,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,172.626583,56.36158,0,NULL,61989426982,968584796,15134137,17),(81666,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81666,37.51,0.33,318,32758,70,NULL,NULL,'2MASX J11303043+1609127',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,172.62675,16.15358,0.055,NULL,61107561790,954805652,14918838,NULL),(81667,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81667,35.24,0.63,112,32759,70,NULL,NULL,'2MASX J11303200-0802318',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000063,NULL,'16.53',0.4,NULL,NULL,NULL,NULL,NULL,1,172.633583333,-8.04242,0.025,NULL,41070207053,641721985,10026906,16.53),(81668,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81668,37.92,0.46,384,32760,70,NULL,NULL,'2MASX J11303591+4158302',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000051,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,172.649583,41.97508,0,NULL,63896819723,998387808,15599809,17.3),(81669,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81669,37.42,0.46,305,32761,70,NULL,NULL,'2MASX J11303702+5506102',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,172.654416667,55.10278,0,NULL,61763704836,965057888,15079029,17.6),(81670,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81670,37.17,0.12,272,32762,70,NULL,NULL,'2MASX J11303719+5556012',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00008,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,172.654917,55.93367,0,NULL,61985409224,968522019,15133156,16.6),(81671,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81671,38.09,0.19,415,32763,70,NULL,NULL,'2MASX J11303978+1659267',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,172.66575,16.99072,0.052,NULL,61107325794,954801965,14918780,17.4),(81672,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81672,35.85,0.46,148,32764,70,NULL,NULL,'2MASX J11304020+5518422',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000173,NULL,'15.9g',0.3,'Sa',NULL,NULL,NULL,NULL,1,172.66775,55.31161,0,NULL,61985107076,968517298,15133082,15.9),(81673,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81673,37.82,0.46,367,32765,70,NULL,NULL,'2MASX J11304079+4710172',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000191,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,172.669833,47.17133,0,NULL,63895912845,998373638,15599588,17.2),(81674,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81674,37.19,0.16,274,32766,70,NULL,NULL,'2MASX J11304127+5401492',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000166,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,172.6720417,54.03028,0,NULL,61765052423,965078944,15079358,16.2),(81675,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81675,37.18,0.46,273,32767,70,NULL,NULL,'2MASX J11304206+0207260',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000108,NULL,'16.0g',0.36,'E0',NULL,NULL,NULL,NULL,1,172.675375,2.12389,0.057,NULL,60179514412,940304912,14692264,16),(81676,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81676,37.59,0.46,330,32768,70,NULL,NULL,'2MASX J11304266+1626297',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,172.677625,16.44169,0.06,NULL,61107626073,954806657,14918854,18.2),(81677,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81677,37.58,0.46,327,32769,70,NULL,NULL,'2MASX J11304273-0049033',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00006,NULL,'17.7g',0.2,'Candidate      BLAGN',NULL,NULL,NULL,NULL,1,172.678167,-0.81753,0.045,NULL,40828876425,637951194,9967987,17.7),(81678,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81678,37.34,0.46,294,32770,70,NULL,NULL,'2MASX J11304308+0050220',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000089,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,172.679375,0.83953,0.045,NULL,60170121860,940158154,14689971,16.8),(81679,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81679,37.39,0.46,301,32771,70,NULL,NULL,'2MASX J11304365+1438567',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.05',0.15,NULL,NULL,NULL,NULL,NULL,1,172.682,14.64908,0.041,NULL,60225190878,941018607,14703415,18.05),(81680,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81680,35.9,0.46,151,32772,70,NULL,NULL,'CGCG 185-075',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.000189,NULL,'14.9g',0.6,NULL,NULL,NULL,NULL,NULL,1,172.684458333,35.51253,0,NULL,60449172193,944518315,14758098,14.9),(81681,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81681,37.61,0.23,332,32773,70,NULL,NULL,'2MASX J11304446+1640527',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.17',0.15,NULL,NULL,NULL,NULL,NULL,1,172.685333333,16.68136,0.052,NULL,61107168827,954799512,14918742,18.17),(81682,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81682,34.68,0.47,86.2,32774,NULL,NULL,'H','MCG -02-29-039',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.00002,NULL,'13.77',1.3,'(R\')SB(r)b     HII',NULL,NULL,NULL,NULL,1,172.686625,-15.28864,0.065,NULL,40977715487,640276804,10004325,13.77),(81683,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81683,34.76,0.46,89.7,32774,NULL,NULL,'J','MCG -02-29-039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81684,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81684,34.78,0.45,90.2,32774,NULL,NULL,'K','MCG -02-29-039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81685,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81685,34.89,0.4,95.3,32774,NULL,NULL,'mean','MCG -02-29-039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81686,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81686,37.09,0.46,261,32775,70,NULL,NULL,'2MASX J11304625+0126470',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000076,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,172.69275,1.44639,0.041,NULL,60179135081,940298985,14692171,17.1),(81687,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81687,37.14,0.19,268,32776,70,NULL,NULL,'2MASX J11304675+5624551',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000186,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,172.695083,56.41531,0,NULL,61989450470,968585163,15134143,16.3),(81688,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81688,38.42,0.46,483,32777,70,NULL,NULL,'2MASX J11304780+3849513',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000142,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,172.699333,38.83092,0,NULL,60458433817,944663028,14760359,18.1),(81689,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81689,37.46,0.46,311,32778,70,NULL,NULL,'2MASX J11304964+1001158',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,172.706958333,10.02097,0.104,NULL,60342665991,942854156,14732096,17.6),(81690,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81690,37.71,0.46,348,32779,70,NULL,NULL,'SDSS J113049.84+005346.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000052,NULL,'18.1g',0.16,'NLAGN',NULL,NULL,NULL,'Sy 2',1,172.7077083,0.89631,0.045,NULL,60170170467,940158913,14689983,18.1),(81691,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81691,37.55,0.46,323,32780,70,NULL,NULL,'SDSS J113052.02+114408.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,172.7167917,11.73564,0.104,NULL,60221078248,940954347,14702411,18.1),(81692,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81692,36.37,0.6,188,32781,70,NULL,NULL,'2MASX J11305262-0852345',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000063,NULL,'16.27',NULL,NULL,NULL,NULL,NULL,NULL,1,172.71925,-8.87614,0.037,NULL,41065072131,641641752,10025652,16.27),(81693,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81693,29.65,NULL,8.5,32782,NULL,NULL,NULL,'SDSS J113053.17+140843.0',NULL,'2015AstBu..70....1K',2015,1,0.04,NULL,'G',0.000003,NULL,'22.1g',0.03,'Ir',NULL,NULL,NULL,NULL,1,172.721583,14.14531,0.059,NULL,60226337913,941036529,14703695,22.1),(81694,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81694,35.04,0.54,102,32783,NULL,NULL,'Malmquist cor.','2MASX J11305329-0421030',NULL,'2009ApJS..182..474S',2009,1,0.77,NULL,'G',0.00003,NULL,'15.16',0.5,NULL,NULL,NULL,NULL,NULL,1,172.722083,-4.35083,0.157,NULL,41049151473,641392991,10021765,15.16),(81695,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81695,35.44,0.45,123,32783,NULL,NULL,NULL,'2MASX J11305329-0421030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81696,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81696,35.48,0.2,125,32783,74.4,NULL,NULL,'2MASX J11305329-0421030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81697,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81697,37.55,0.46,323,32784,70,NULL,NULL,'2MASX J11305378+0143390',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000083,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,172.724083,1.72761,0.041,NULL,60179295528,940301492,14692210,17.4),(81698,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81698,37.76,0.33,357,32785,70,NULL,NULL,'2MASX J11305645+0638397',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000137,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,172.73525,6.64442,0.077,NULL,60383976361,943499630,14742181,17.6),(81699,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81699,37.86,0.46,372,32786,70,NULL,NULL,'2MASX J11305689+2431239',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,172.7370417,24.52328,0,NULL,60573815852,946465872,14788529,17.8),(81700,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81700,37.19,0.16,274,32787,70,NULL,NULL,'2MASX J11305726+5400220',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000198,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,172.738417,54.00617,0,NULL,61765047919,965078873,15079357,16.3),(81701,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81701,37.34,0.46,294,32788,70,NULL,NULL,'2MASX J11305766+5123289',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000146,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,172.740167,51.39153,0,NULL,61806669243,965729206,15089518,16.8),(81702,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81702,38.56,0.46,515,32789,70,NULL,NULL,'SDSS J113057.78+480813.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000138,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,172.7407917,48.13697,0,NULL,63892385071,998318516,15598726,18.4),(81703,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81703,37.46,0.21,311,32790,70,NULL,NULL,'2MASX J11305802+5631450',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000152,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,172.7420417,56.52925,0,NULL,61989372056,968583938,15134124,16.8),(81704,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81704,35.31,NULL,115,32791,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1263',NULL,'2010Ap&SS.325..163P',2010,1,0.92,NULL,'G',0,NULL,'16.7',0.1,'Sd',NULL,NULL,NULL,NULL,1,172.7432083,-4.085,0.157,NULL,41047089990,641360781,10021262,16.7),(81705,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81705,35.32,NULL,116,32791,NULL,NULL,'Dipole + Quadrupole','FGC 1263',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81706,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81706,35.33,NULL,116,32791,NULL,NULL,'Dipole','FGC 1263',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81707,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81707,35.41,0.49,121,32791,75,NULL,'IR','FGC 1263',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81708,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81708,38.57,0.46,517,32792,70,NULL,NULL,'2MASX J11305965+5921004',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000152,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,172.748417,59.35011,0,NULL,61851071093,966422985,15100359,17.3),(81709,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81709,36.62,0.46,211,32793,70,NULL,NULL,'2MASX J11310076+2714419',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000185,NULL,'15.8g',0.47,NULL,NULL,NULL,NULL,NULL,1,172.753291667,27.24489,0,NULL,60577693926,946526467,14789476,15.8),(81710,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81710,38.09,0.19,415,32794,70,NULL,NULL,'SDSS J113100.88+165659.7',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.27,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,172.7537083,16.94994,0.052,NULL,61107281464,954801272,14918769,17.1),(81711,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81711,38.02,0.46,403,32795,70,NULL,NULL,'2MASX J11310101+1435029',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,172.75425,14.58417,0.013,NULL,60225012333,941015817,14703372,18.1),(81712,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81712,37.85,0.46,371,32796,70,NULL,NULL,'SDSS J113102.15+194036.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,172.759,19.67686,0,NULL,61132882199,955201284,14925020,18.2),(81713,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81713,37.17,0.12,272,32797,70,NULL,NULL,'SDSS J113102.73+554746.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,172.761417,55.79614,0,NULL,61985484195,968523190,15133174,18.3),(81714,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81714,37.25,0.46,282,32798,70,NULL,NULL,'SDSS J113103.14+361143.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000123,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,172.763125,36.1955,0,NULL,60451775508,944558992,14758734,18.2),(81715,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81715,35.34,0.46,117,32799,70,NULL,NULL,'2MASX J11310337+6218168',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000157,NULL,'15.6g',0.45,'E0',NULL,NULL,NULL,NULL,1,172.763875,62.30467,0,NULL,61872745877,966761654,15105650,15.6),(81716,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81716,37.34,0.16,294,32800,70,NULL,NULL,'2MASX J11310365+5527064',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,172.7652917,55.45194,0,NULL,61985088780,968517012,15133078,17.6),(81717,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81717,38.35,0.46,467,32801,70,NULL,NULL,'SDSS J113105.30+291936.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000141,NULL,'18.7g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,172.772125,29.32681,0,NULL,60658232804,947784887,14809138,18.7),(81718,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81718,34.47,0.46,78.4,32802,70,NULL,NULL,'NGC 3710',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000103,NULL,'14.06',0.8,'E','Group member',NULL,NULL,NULL,1,172.778916667,22.76806,0,NULL,61094370516,954599539,14915617,14.06),(81719,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81719,35.01,0.4,100,32802,NULL,NULL,'mean','NGC 3710',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81720,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81720,35.19,0.45,109,32802,NULL,NULL,'K','NGC 3710',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81721,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81721,38.29,0.46,455,32803,70,NULL,NULL,'2MASX J11310769+0529271',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000172,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,172.782167,5.49094,0.069,NULL,60355571733,943055808,14735247,17.4),(81722,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81722,30.57,NULL,13,32804,NULL,NULL,NULL,'SDSS J113108.88+133413.4',NULL,'2015AstBu..70....1K',2015,1,0.39,NULL,'G',0.000028,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,172.787041667,13.57039,0.093,NULL,60226801753,941043777,14703809,17.7),(81723,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81723,35.6,0.46,132,32805,70,NULL,NULL,'2MASX J11310889+2303256',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000093,NULL,'16.54',0.2,NULL,NULL,NULL,NULL,NULL,1,172.787041667,23.05717,0,NULL,61094444310,954600692,14915635,16.54),(81724,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81724,37.33,0.17,293,32806,70,NULL,NULL,'SDSS J113109.01+364316.7',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000174,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,172.787583333,36.72133,0,NULL,60450867726,944544808,14758512,18.7),(81725,'CMD','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81725,21.25,NULL,0.18,32807,NULL,NULL,NULL,'Leo V',NULL,'2008ApJ...686L..83B',2008,1,NULL,NULL,'G',0.00001,NULL,'17.0V',NULL,NULL,NULL,NULL,NULL,NULL,1,172.79,2.22,0.057,1,60179544256,940305379,14692271,17),(81726,'Horizontal Branch','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81726,21.22,0.1,0.175,32807,NULL,NULL,NULL,'Leo V',NULL,'2010ApJ...710.1664D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81727,'Horizontal Branch','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81727,21.36,0.15,0.187,32807,NULL,NULL,'M3/M13 (Fe/H=_1.5)','Leo V',NULL,'2012ApJ...756...79S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81728,'Horizontal Branch','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81728,21.44,0.13,0.194,32807,NULL,NULL,'M92 (Fe/H=_2.4)','Leo V',NULL,'2012ApJ...756...79S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81729,'Horizontal Branch','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81729,21.46,0.16,0.196,32807,NULL,NULL,'Adopted ([Fe/H]=_2.0)','Leo V',NULL,'2012ApJ...756...79S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81730,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81730,37.17,0.12,272,32808,70,NULL,NULL,'2MASX J11310980+5550245',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00008,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,172.790917,55.84017,0,NULL,61985414566,968522102,15133157,16.9),(81731,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81731,36.51,0.46,201,32809,70,NULL,NULL,'2MASX J11311030+0014301',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000076,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,172.793,0.24156,0.061,NULL,60169890189,940154534,14689914,16.9),(81732,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81732,38.4,0.46,478,32810,70,NULL,NULL,'2MASX J11311077+4800190',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000168,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,172.7949583,48.00525,0.015,NULL,63892411802,998318934,15598733,18.2),(81733,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81733,34.79,0.2,90.8,32811,74.4,NULL,NULL,'UGC 06507',NULL,'2013AJ....146...86T',2013,1,1.06,NULL,'G',0.000023,NULL,'15.0g',0.68,'SB(s)c',NULL,NULL,NULL,NULL,1,172.802125,34.20303,0,NULL,60620402621,947193790,14799902,15),(81734,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81734,35.17,0.45,108,32811,NULL,NULL,NULL,'UGC 06507',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81735,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81735,35.36,0.41,118,32811,NULL,NULL,'Malmquist cor.','UGC 06507',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81736,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81736,37.14,0.19,268,32812,70,NULL,NULL,'2MASX J11311292+5627035',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000206,NULL,'15.4g',0.53,'E0',NULL,NULL,NULL,NULL,1,172.8039583,56.45106,0,NULL,61989395598,968584306,15134129,15.4),(81737,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81737,37.17,0.27,272,32813,70,NULL,NULL,'2MASX J11311372+5745595',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000159,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,172.8070417,57.76656,0,NULL,61990062818,968594731,15134292,17.2),(81738,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81738,37.14,0.46,268,32814,70,NULL,NULL,'2MASX J11311525+2548354',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00012,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,172.813417,25.80975,0,NULL,60578480797,946538762,14789668,18.1),(81739,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81739,37.55,0.46,324,32815,70,NULL,NULL,'2MASX J11311579+4708039',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000148,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,172.815708333,47.13436,0.032,NULL,63895921681,998373776,15599590,17.2),(81740,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81740,38.14,0.46,425,32816,70,NULL,NULL,'SDSS J113116.27+671850.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000069,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,172.817875,67.31406,0,NULL,62077972047,969968313,15155754,18.7),(81741,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81741,36.81,0.46,230,32817,70,NULL,NULL,'2MASX J11311627+2813054',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000158,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,172.817917,28.21808,0,NULL,60575017172,946484643,14788822,16.6),(81742,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81742,35.84,0.33,147,32818,70,NULL,NULL,'2MASX J11311665+0013228',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000058,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,172.819375,0.22314,0.057,NULL,60169891515,940154554,14689914,16.5),(81743,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81743,37.61,0.23,332,32819,70,NULL,NULL,'SDSS J113117.95+164325.2',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,172.824833333,16.72369,0.057,NULL,61107815577,954809618,14918900,17.3),(81744,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81744,38.37,0.46,473,32820,70,NULL,NULL,'2MASX J11311937+1809166',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.56',0.12,NULL,NULL,NULL,NULL,NULL,1,172.830917,18.15461,0,NULL,61127743007,955120984,14923765,18.56),(81745,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81745,37.95,0.46,389,32821,70,NULL,NULL,'2MASX J11311960+1559299',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,172.831667,15.99156,0.053,NULL,61107359172,954802487,14918788,17.7),(81746,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81746,38.16,0.46,428,32822,70,NULL,NULL,'2MASX J11311978+0152078',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000084,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,172.8322917,1.86892,0.041,NULL,60179217052,940300266,14692191,17.6),(81747,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81747,38.09,0.19,415,32823,70,NULL,NULL,'2MASX J11312014+1703119',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,172.834083,17.05353,0.04,NULL,61107232501,954800507,14918757,17.6),(81748,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81748,37.46,0.21,311,32824,70,NULL,NULL,'SDSS J113120.35+562059.5',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,172.8347917,56.34986,0,NULL,61989396979,968584327,15134130,17.5),(81749,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81749,37.17,0.12,272,32825,70,NULL,NULL,'2MASX J11312048+5550425',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00012,NULL,'16.1g',0.31,'S0^-',NULL,NULL,NULL,NULL,1,172.8357917,55.84519,0,NULL,61985414755,968522105,15133157,16.1),(81750,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81750,37.76,0.33,357,32826,70,NULL,NULL,'SDSS J113120.67+063152.2',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000147,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,172.836167,6.53119,0.073,NULL,60383960348,943499380,14742177,17.8),(81751,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81751,37.61,0.23,332,32827,70,NULL,NULL,'2MASX J11312130+1638289',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,172.838833,16.64131,0.057,NULL,61107819096,954809673,14918901,17.7),(81752,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81752,38.15,0.33,426,32828,70,NULL,NULL,'2MASX J11312176+0911351',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,172.8407083,9.19311,0.093,NULL,60388683820,943573184,14743331,17.8),(81753,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81753,35.19,0.46,109,32829,70,NULL,NULL,'CGCG 185-078',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.00009,NULL,'15.0g',0.53,'SF',NULL,NULL,NULL,NULL,1,172.841833333,32.70631,0.011,NULL,60621926776,947217605,14800275,15),(81754,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81754,37.53,0.46,321,32830,70,NULL,NULL,'2MASX J11312265+0108058',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000082,NULL,'17.6g',0.2,'AGN',NULL,NULL,NULL,NULL,1,172.844375,1.13492,0.045,NULL,60169963469,940155679,14689932,17.6),(81755,'IRAS','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81755,33.2,0.8,43.6,32831,75,NULL,'HMCL, I','UGC 06509',NULL,'1997ApJS..109..333W',1997,1,2.37,NULL,'G',0.000005,NULL,'15.5',0.12,'Sd',NULL,NULL,NULL,NULL,1,172.844417,23.11514,0,NULL,61094483111,954601298,14915645,15.5),(81756,'IRAS','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81756,33.2,0.8,43.6,32831,75,NULL,'A82, H','UGC 06509',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81757,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81757,32.79,0.4,36.1,32831,75,NULL,'HMCL, I, inv','UGC 06509',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81758,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81758,32.79,NULL,36.2,32831,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06509',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81759,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81759,32.8,0.4,36.3,32831,NULL,NULL,NULL,'UGC 06509',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81760,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81760,32.81,NULL,36.4,32831,NULL,NULL,'Dipole + Quadrupole','UGC 06509',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81761,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81761,32.81,0.4,36.5,32831,75,NULL,'HMCL, I, raw','UGC 06509',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81762,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81762,32.81,NULL,36.5,32831,NULL,NULL,'Dipole','UGC 06509',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81763,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81763,32.89,NULL,37.8,32831,NULL,NULL,NULL,'UGC 06509',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81764,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81764,33.03,0.2,40.4,32831,74.4,NULL,NULL,'UGC 06509',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81765,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81765,33.1,0.4,41.6,32831,75,NULL,'HMCL, I, cor','UGC 06509',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81766,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81766,33.17,0.51,43.1,32831,NULL,NULL,NULL,'UGC 06509',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81767,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81767,33.26,0.43,44.8,32831,75,NULL,'3.6 micron, color corrected','UGC 06509',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81768,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81768,33.32,0.47,46.1,32831,75,NULL,'A82, H, inv','UGC 06509',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81769,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81769,33.36,0.47,47,32831,NULL,NULL,'Malmquist cor.','UGC 06509',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81770,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81770,33.4,0.43,47.9,32831,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06509',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81771,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81771,33.46,0.47,49.2,32831,75,NULL,'A82, H, raw','UGC 06509',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81772,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81772,33.83,0.47,58.2,32831,75,NULL,'A82, H, cor','UGC 06509',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81773,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81773,38.05,0.46,407,32832,70,NULL,NULL,'2MASX J11312277+3355463',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,172.844875,33.92961,0.013,NULL,60620726145,947198846,14799981,17.2),(81774,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81774,38.15,0.33,426,32833,70,NULL,NULL,'SDSS J113123.41+091846.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,172.847583,9.31297,0.093,NULL,60389407339,943584489,14743507,18.1),(81775,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81775,36.59,0.46,208,32834,70,NULL,NULL,'2MASX J11312426+2637094',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000162,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,172.851166667,26.61931,0.006,NULL,60577188392,946518568,14789352,16.5),(81776,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81776,38.52,0.46,506,32835,70,NULL,NULL,'2MASX J11312444+0219558',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000097,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,172.851833,2.33214,0.057,NULL,60179502379,940304724,14692261,17.6),(81777,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81777,37.13,0.33,267,32836,70,NULL,NULL,'2MASX J11312552+1521149',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00018,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,172.856375,15.35425,0.047,NULL,60225697056,941026516,14703539,16.3),(81778,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81778,34.62,0.54,83.8,32837,70,NULL,NULL,'2MASX J11312568-0938451',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000063,NULL,'15.73',0.4,NULL,NULL,NULL,NULL,NULL,1,172.8569583,-9.64603,0.057,NULL,41065867130,641654173,10025846,15.73),(81779,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81779,38.13,0.46,422,32838,70,NULL,NULL,'SDSS J113126.38+024839.7',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000075,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,172.859917,2.81103,0.057,NULL,60177254320,940269598,14691712,17.8),(81780,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81780,37.89,0.46,379,32839,70,NULL,NULL,'SDSS J113127.08+063622.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00016,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,172.862875,6.60622,0.128,NULL,60384449434,943507022,14742297,18.3),(81781,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81781,37.61,0.23,332,32840,70,NULL,NULL,'SDSS J113127.88+163134.9',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',NULL,NULL,'16.2g',0.33,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,172.8662083,16.52636,0.06,NULL,61107844263,954810066,14918907,16.2),(81782,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81782,37,0.46,251,32841,70,NULL,NULL,'2MASX J11312841+6210108',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00016,NULL,'17.0g',0.32,NULL,NULL,NULL,NULL,NULL,1,172.868625,62.16983,0,NULL,61872704188,966761002,15105640,17),(81783,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81783,36.04,0.46,161,32842,70,NULL,NULL,'CGCG 011-113',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000113,NULL,'14.9g',0.56,'SA(r)0-',NULL,NULL,NULL,NULL,1,172.869417,-1.84264,0.089,NULL,40835379374,638052802,9969575,14.9),(81784,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81784,38.28,0.46,454,32843,70,NULL,NULL,'2MASX J11312887+4616029',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000175,NULL,'17.2g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,172.8702083,46.2675,0,NULL,63895207766,998362621,15599415,17.2),(81785,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81785,37.76,0.07,357,32844,70,NULL,NULL,'2MASX J11312904+1434359',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000153,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,172.870917,14.57661,0.013,NULL,60224982108,941015345,14703364,16.8),(81786,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81786,36.75,0.46,224,32845,70,NULL,NULL,'2MASX J11312968+1141371',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000161,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,172.87375,11.69367,0.104,NULL,60221057220,940954019,14702406,16.6),(81787,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81787,38.32,0.46,461,32846,70,NULL,NULL,'2MASX J11313076+1808378',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.55',0.14,NULL,NULL,NULL,NULL,NULL,1,172.8780417,18.14378,0,NULL,61127741655,955120963,14923765,18.55),(81788,'IRAS','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81788,31.63,0.8,21.1,32847,75,NULL,'A82, H','NGC 3717',NULL,'1997ApJS..109..333W',1997,1,6,NULL,'G',0.000013,NULL,'12.24',1.1,'SAb: sp        HII','in a pair',NULL,NULL,NULL,1,172.883291667,-30.30775,0.217,NULL,41595451010,649928922,10155139,12.24),(81789,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81789,30.9,0.47,15.1,32847,75,NULL,'A82, H, raw','NGC 3717',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81790,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81790,31.05,0.47,16.2,32847,75,NULL,'A82, H, inv','NGC 3717',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81791,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81791,31.14,0.35,16.9,32847,NULL,NULL,NULL,'NGC 3717',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81792,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81792,31.14,0.4,16.9,32847,73,NULL,'opt','NGC 3717',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81793,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81793,31.23,0.47,17.6,32847,75,NULL,'A82, H, cor','NGC 3717',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81794,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81794,31.26,NULL,17.9,32847,NULL,NULL,'B','NGC 3717',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81795,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81795,31.27,0.47,18,32847,NULL,NULL,'H','NGC 3717',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81796,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81796,31.28,0.46,18.1,32847,NULL,NULL,'J','NGC 3717',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81797,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81797,31.3,0.45,18.2,32847,NULL,NULL,'K','NGC 3717',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81798,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81798,31.37,0.43,18.8,32847,75,NULL,'3.6 micron, color corrected','NGC 3717',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81799,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81799,31.37,0.43,18.8,32847,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3717',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81800,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81800,31.43,0.2,19.3,32847,74.4,NULL,NULL,'NGC 3717',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81801,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81801,31.92,0.4,24.3,32847,NULL,NULL,'mean','NGC 3717',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81802,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81802,31.95,0.4,24.6,32847,75,NULL,'B','NGC 3717',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81803,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81803,37.82,0.46,366,32848,70,NULL,NULL,'2MASX J11313204+3504171',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,172.883541667,35.07153,0,NULL,60448547918,944508561,14757946,17.9),(81804,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81804,37.47,0.33,312,32849,70,NULL,NULL,'IC 2901',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000192,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,172.883875,12.69972,0.086,NULL,60220989224,940952956,14702389,16.3),(81805,'IRAS','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81805,32.45,0.8,30.9,32850,75,NULL,'MAT, I','NGC 3715',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.00003,NULL,'13.27',0.9,'(R\')SB(rs)bc:  HII',NULL,NULL,NULL,NULL,1,172.88475,-14.23136,0.049,NULL,40983088219,640360753,10005636,13.27),(81806,'Sosies','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81806,32.79,0.14,36.1,32850,NULL,NULL,NULL,'NGC 3715',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81807,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81807,31.28,0.69,18,32850,100,NULL,'mid-IR','NGC 3715',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81808,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81808,32.64,0.43,33.7,32850,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3715',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81809,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81809,32.76,0.4,35.7,32850,NULL,NULL,'mean','NGC 3715',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81810,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81810,32.84,0.43,37,32850,75,NULL,'3.6 micron, color corrected','NGC 3715',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81811,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81811,32.9,0.45,38.1,32850,NULL,NULL,'K','NGC 3715',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81812,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81812,32.94,0.47,38.8,32850,NULL,NULL,'H','NGC 3715',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81813,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81813,32.96,0.46,39,32850,NULL,NULL,'J','NGC 3715',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81814,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81814,33.08,0.2,41.3,32850,74.4,NULL,NULL,'NGC 3715',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81815,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81815,33.11,0.32,41.9,32850,85,NULL,'I, raw','NGC 3715',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81816,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81816,33.16,0.32,42.8,32850,85,NULL,'I, inv','NGC 3715',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81817,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81817,33.25,0.43,44.7,32850,75,NULL,'MAT, I, raw','NGC 3715',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81818,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81818,33.47,0.43,49.4,32850,75,NULL,'MAT, I, inv','NGC 3715',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81819,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81819,33.63,0.43,53.3,32850,75,NULL,'MAT, I, cor','NGC 3715',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81820,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81820,37.62,0.27,334,32851,70,NULL,NULL,'2MASX J11313473+2617283',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000172,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,172.894708333,26.29111,0,NULL,60576464046,946507250,14789175,16.8),(81821,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81821,37.08,0.46,261,32852,70,NULL,NULL,'2MASX J11313557+2041198',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.49',0.24,NULL,NULL,NULL,NULL,NULL,1,172.898166667,20.68897,0,NULL,61130900246,955170316,14924536,17.49),(81822,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81822,36.41,0.46,192,32853,70,NULL,NULL,'2MASX J11313583+4307507',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000185,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,172.899167,43.13056,0.037,NULL,63899243678,998425682,15600401,16.8),(81823,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81823,38.24,0.46,444,32854,70,NULL,NULL,'2MASX J11313594+1901168',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,172.89975,19.02142,0,NULL,61125113040,955079891,14923123,NULL),(81824,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81824,37.29,0.46,287,32855,70,NULL,NULL,'2MASX J11313600+5921034',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,172.900125,59.35092,0,NULL,61851091278,966423301,15100364,17.8),(81825,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81825,36.74,0.46,223,32856,70,NULL,NULL,'2MASX J11313631+3847582',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000181,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,172.901417,38.79944,0,NULL,60458412171,944662690,14760354,16.2),(81826,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81826,37.13,0.33,267,32857,70,NULL,NULL,'SDSS J113137.27+152048.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,172.905291667,15.34672,0.047,NULL,60225683916,941026311,14703536,17.9),(81827,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81827,37.34,0.46,294,32858,70,NULL,NULL,'LCRS B112904.2-023322',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000143,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,172.9065417,-2.83206,0.145,NULL,40825782751,637902855,9967232,17.9),(81828,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81828,37.14,0.19,268,32859,70,NULL,NULL,'2MASX J11313834+5623384',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,172.91,56.39414,0,NULL,61989401945,968584405,15134131,17.7),(81829,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81829,37.7,0.46,347,32860,70,NULL,NULL,'SDSS J113139.15+035142.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000168,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,172.913167,3.86194,0.045,NULL,60173206476,940206351,14690724,18.3),(81830,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81830,38.09,0.19,415,32861,70,NULL,NULL,'SDSS J113139.16+170223.6',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.7g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,172.913208333,17.03989,0.04,NULL,61107272831,954801137,14918767,16.7),(81831,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81831,37.54,0.46,323,32862,70,NULL,NULL,'2MASX J11313919+1546420',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000184,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,172.913333,15.7785,0.056,NULL,60222317694,940973713,14702714,16.9),(81832,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81832,36.47,0.33,197,32863,70,NULL,NULL,'2MASX J11313927+6714296',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.000105,NULL,'15.2g',0.56,'E0',NULL,NULL,NULL,NULL,1,172.9139583,67.24169,0,NULL,62077998890,969968732,15155761,15.2),(81833,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81833,37.17,0.12,272,32864,70,NULL,NULL,'SDSS J113139.67+560254.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000177,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,172.915333,56.0485,0,NULL,61984882363,968513786,15133027,17.6),(81834,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81834,38.09,0.19,415,32865,70,NULL,NULL,'2MASX J11313972+1704270',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,172.915375,17.07417,0.04,NULL,61107271250,954801113,14918767,17.9),(81835,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81835,38,0.46,398,32866,70,NULL,NULL,'2MASX J11314026+0338548',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000082,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,172.917833,3.64869,0.041,NULL,60173195725,940206183,14690721,18.2),(81836,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81836,34.62,0.45,83.9,32867,NULL,NULL,'K','NGC 3716',NULL,'2007A&A...465...71T',2007,1,0.8,NULL,'G',0.000033,NULL,'14.0g',0.77,'(R)SAB0^0^?','Isolated galaxy',NULL,NULL,NULL,1,172.921375,3.488,0.041,NULL,60172864789,940201012,14690640,14),(81837,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81837,35.01,0.4,101,32867,NULL,NULL,'mean','NGC 3716',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81838,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81838,37.62,0.27,334,32868,70,NULL,NULL,'SDSS J113141.34+261538.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000158,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,172.9222917,26.26061,0,NULL,60576449791,946507027,14789172,18.2),(81839,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81839,34.93,0.33,96.9,32869,70,NULL,NULL,'NGC 3713',NULL,'2015arXiv151105856S',2015,1,1.2,NULL,'G',0.000087,NULL,'13.8g',0.83,'S0-:','in a radial-velocity based grouping',NULL,NULL,NULL,1,172.925083333,28.15358,0,NULL,60575001859,946484404,14788818,13.8),(81840,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81840,35.79,NULL,144,32870,NULL,NULL,'Dipole','UGC 06502',NULL,'2010Ap&SS.325..163P',2010,1,1.18,NULL,'G',NULL,NULL,'17.',0.11,'Sc',NULL,NULL,NULL,NULL,1,172.93125,77.25836,0.073,NULL,61369499051,958898422,14982787,17),(81841,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81841,35.8,NULL,144,32870,NULL,NULL,'Dipole + Quadrupole','UGC 06502',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81842,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81842,35.81,NULL,145,32870,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06502',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81843,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81843,35.99,NULL,158,32870,NULL,NULL,NULL,'UGC 06502',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81844,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81844,37.41,0.46,303,32871,70,NULL,NULL,'2MASX J11314413+1228270',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,172.934,12.47431,0.108,NULL,60220852153,940950814,14702356,17.5),(81845,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81845,36.02,0.11,160,32872,70,NULL,NULL,'2MASX J11314422+4905114',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000151,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,172.9342083,49.08661,0,NULL,61749215707,964831495,15075492,16.2),(81846,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81846,38.53,0.33,507,32873,70,NULL,NULL,'2MASX J11314452+5851473',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,172.935417,58.86322,0,NULL,61850401076,966412516,15100195,17.4),(81847,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81847,37.36,0.71,296,32874,70,NULL,NULL,'2MASX J11314450-3644147',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,172.9355,-36.73744,0.365,NULL,41391144278,646736629,10105259,15.3),(81848,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81848,36.35,0.73,186,32875,70,NULL,NULL,'2MASX J11314511-2130591',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.05',0.4,NULL,NULL,NULL,NULL,NULL,1,172.9377917,-21.51656,0.101,NULL,41733010058,652078282,10188723,16.05),(81849,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81849,37.51,0.46,318,32876,70,NULL,NULL,'LCRS B112912.1-032033',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,172.9392083,-3.6185,0.113,NULL,40826701028,637917203,9967456,18.2),(81850,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81850,36.5,0.46,199,32877,70,NULL,NULL,'2MASX J11314552+4754278',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000169,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,172.939666667,47.90775,0.025,NULL,63895248678,998363260,15599425,17.2),(81851,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81851,37.82,0.46,367,32878,70,NULL,NULL,'2MASX J11314665+0128146',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000091,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,172.9442917,1.47069,0.049,NULL,60179089249,940298269,14692160,17.5),(81852,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81852,37.36,0.46,296,32879,70,NULL,NULL,'2MASX J11314745+2019158',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,172.9477083,20.32111,0,NULL,61130018101,955156532,14924320,17.7),(81853,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81853,37.68,0.46,344,32880,70,NULL,NULL,'2MASX J11314777+2704437',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,172.949208333,27.07881,0,NULL,60576755645,946511806,14789246,17.8),(81854,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81854,34.48,0.54,78.6,32881,70,NULL,NULL,'2MASX J11314797-0859191',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000147,NULL,'15.18',NULL,NULL,NULL,NULL,NULL,NULL,1,172.94975,-8.98864,0.037,NULL,41065629518,641650461,10025788,15.18),(81855,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81855,38.39,0.46,476,32882,70,NULL,NULL,'SDSS J113147.99+363417.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,172.9499583,36.57167,0,NULL,60450782541,944543477,14758491,17.9),(81856,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81856,38.65,0.33,537,32883,70,NULL,NULL,'SDSS J113148.96+032442.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000071,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,172.954,3.41175,0.041,NULL,60174769953,940230780,14691105,18.5),(81857,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81857,35.27,0.46,113,32884,70,NULL,NULL,'2MASX J11314902+1553510',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,172.954167,15.89747,0.053,NULL,60222327274,940973863,14702716,16.7),(81858,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81858,37.52,0.46,319,32885,70,NULL,NULL,'2MASX J11314966+3156331',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,172.956958333,31.94264,0,NULL,60628673693,947323026,14801922,18),(81859,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81859,37.17,0.12,272,32886,70,NULL,NULL,'2MASX J11314970+5600564',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,172.957,56.01581,0,NULL,61984876417,968513694,15133026,17.6),(81860,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81860,37.79,0.23,361,32887,70,NULL,NULL,'SDSS J113149.87+340919.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000172,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,172.957833,34.15553,0.012,NULL,60621248554,947207008,14800109,18.4),(81861,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81861,38.65,0.33,537,32888,70,NULL,NULL,'SDSS J113150.89+032741.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000079,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,172.962083,3.46144,0.041,NULL,60174777301,940230895,14691107,18.4),(81862,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81862,36.98,0.46,249,32889,70,NULL,NULL,'2MASX J11315150+0458146',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.07',0.16,NULL,NULL,NULL,NULL,NULL,1,172.9645417,4.97067,0.045,NULL,60352628496,943009820,14734528,18.07),(81863,'G Lens','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81863,39.55,NULL,813,32890,NULL,NULL,NULL,'[SSC2003] G',NULL,'2015JCAP...11..033J',2014,1,NULL,'This galaxy lenses a z = 0.658 QSO into 4 images.','G',0.002,NULL,NULL,NULL,'E',NULL,NULL,NULL,NULL,1,172.964125,-12.53278,0.037,NULL,40981707320,640339176,10005299,NULL),(81864,'G Lens','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81864,39.71,NULL,877,32890,NULL,NULL,'WMAP-7 cosmology','[SSC2003] G',NULL,'2015JCAP...11..033J',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81865,'G Lens','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81865,39.91,0.61,960,32890,NULL,NULL,NULL,'[SSC2003] G',NULL,'2007ApJ...660....1O',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81866,'G Lens','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81866,41.03,0.61,1610,32890,NULL,NULL,NULL,'[SSC2003] G',NULL,'2014MNRAS.437..600S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81867,'G Lens','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81867,41.37,0.1,1880,32890,NULL,NULL,NULL,'[SSC2003] G',NULL,'2013ApJ...766...70S',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81868,'G Lens','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81868,41.47,0.05,1970,32890,NULL,NULL,NULL,'[SSC2003] G',NULL,'2016arXiv160101321C',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81869,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81869,34.92,0.56,96.2,32891,70,NULL,NULL,'LCRS B112920.0-053719',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00011,NULL,'13.96',NULL,NULL,NULL,NULL,NULL,NULL,1,172.970417,-5.89814,0.101,NULL,41057579382,641524677,10023823,13.96),(81870,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81870,37.82,0.46,366,32892,70,NULL,NULL,'2MASX J11315393+5639275',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000183,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,172.9747083,56.65764,0,NULL,61989338851,968583419,15134115,16.6),(81871,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81871,38.47,0.46,494,32893,70,NULL,NULL,'2MASX J11315526+0307036',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000086,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,172.9802083,3.11769,0.041,NULL,60174679105,940229361,14691083,17.6),(81872,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81872,37.62,0.27,334,32894,70,NULL,NULL,'2MASX J11315548+2623337',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,172.9812083,26.39283,0.006,NULL,60576494849,946507732,14789183,18),(81873,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81873,37.46,0.21,311,32895,70,NULL,NULL,'2MASX J11315563+5623095',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000175,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,172.982,56.386,0,NULL,61989391112,968584236,15134128,16.8),(81874,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81874,38.31,0.46,459,32896,70,NULL,NULL,'2MASX J11315632+0343486',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,172.984708333,3.73022,0.041,NULL,60175277682,940238713,14691229,17.8),(81875,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81875,37.41,0.46,303,32897,70,NULL,NULL,'2MASX J11315637+2140548',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,172.984833,21.68172,0,NULL,61131304433,955176631,14924634,17.8),(81876,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81876,36.6,0.46,209,32898,70,NULL,NULL,'2MASX J11315672+0116296',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000077,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,172.986208333,1.27483,0.053,NULL,60170441201,940163143,14690049,17.3),(81877,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81877,37.79,0.23,361,32899,70,NULL,NULL,'2MASX J11315777+3409410',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.39',0.25,NULL,NULL,NULL,NULL,NULL,1,172.990667,34.16139,0.012,NULL,60621236330,947206817,14800106,17.39),(81878,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81878,37.17,0.12,272,32900,70,NULL,NULL,'2MASX J11315880+5556415',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000169,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,172.995083,55.945,0,NULL,61985396171,968521815,15133153,17.6),(81879,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81879,38.47,0.46,494,32901,70,NULL,NULL,'2MASX J11315947+0523026',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000155,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,172.99775,5.384,0.045,NULL,60352347713,943005433,14734459,17.7),(81880,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81880,38.03,0.46,403,32902,70,NULL,NULL,'2MASX J11320035+0630041',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000175,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,173.001583,6.50111,0.112,NULL,60385274551,943519914,14742498,17.6),(81881,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81881,36.85,0.46,234,32903,70,NULL,NULL,'2MASX J11320113+1622358',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000157,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,173.0047083,16.37675,0.061,NULL,61107429696,954803589,14918806,17.1),(81882,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81882,35.66,0.46,136,32904,70,NULL,NULL,'CGCG 126-082',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000137,NULL,'15.3',0.5,NULL,NULL,NULL,NULL,NULL,1,173.005083,25.64417,0,NULL,60571195200,946424925,14787889,15.3),(81883,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81883,38.53,0.33,507,32905,70,NULL,NULL,'2MASX J11320154+5852255',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000165,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,173.0062083,58.87386,0,NULL,61850398877,966412482,15100195,18.2),(81884,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81884,32.99,NULL,39.6,32906,NULL,NULL,NULL,'KUG 1129+148',NULL,'2015AstBu..70....1K',2015,1,0.6,NULL,'G',NULL,NULL,'16.5:',0.2,'Spiral',NULL,NULL,NULL,NULL,1,173.007041667,14.61111,0.005,NULL,60224653710,941010214,14703284,16.5),(81885,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81885,35.55,0.46,129,32907,70,NULL,NULL,'CGCG 156-097',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.000123,NULL,'15.2g',0.47,NULL,NULL,NULL,NULL,NULL,1,173.009125,27.00578,0,NULL,60576681503,946510648,14789228,15.2),(81886,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81886,36.97,0.46,247,32908,70,NULL,NULL,'2MASX J11320245+5701216',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000191,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,173.01,57.02258,0,NULL,61990929414,968608272,15134504,16.3),(81887,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81887,37.76,0.46,356,32909,70,NULL,NULL,'2MASX J11320261+1131361',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000164,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,173.010791667,11.52656,0.074,NULL,60218169864,940908904,14701701,17.2),(81888,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81888,36.02,0.11,160,32910,70,NULL,NULL,'2MASX J11320326+4910255',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000148,NULL,'16.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,173.013833,49.17386,0,NULL,61751981455,964874710,15076167,16.2),(81889,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81889,37.79,0.23,361,32911,70,NULL,NULL,'2MASX J11320350+3413163',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000197,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,173.014583,34.22125,0.012,NULL,60621242180,947206909,14800107,17.3),(81890,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81890,37.27,0.46,285,32912,70,NULL,NULL,'2MASX J11320379+0201566',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000072,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,173.015625,2.03256,0.057,NULL,60176347265,940255426,14691491,17.3),(81891,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81891,37.17,0.12,272,32913,70,NULL,NULL,'2MASX J11320388+5604306',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000184,NULL,'16.4g',NULL,NULL,NULL,NULL,NULL,NULL,1,173.016083,56.07522,0,NULL,61984867497,968513554,15133024,16.4),(81892,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81892,38.12,0.46,421,32914,70,NULL,NULL,'SDSS J113204.35+154712.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,173.018125,15.78683,0.044,NULL,60222314885,940973670,14702713,18.4),(81893,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81893,36.9,0.46,240,32915,70,NULL,NULL,'MCG +09-19-106',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000193,NULL,'15.8g',0.41,'E0',NULL,NULL,NULL,NULL,1,173.01925,53.576,0,NULL,61762939384,965045927,15078842,15.8),(81894,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81894,37.76,0.07,357,32916,70,NULL,NULL,'2MASX J11320504+1440278',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,173.0210417,14.6745,0.005,NULL,60224588631,941009197,14703268,17.8),(81895,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81895,38.07,0.46,411,32917,70,NULL,NULL,'2MASX J11320532+1830363',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,173.022083,18.50997,0.017,NULL,61127644127,955119439,14923741,17.5),(81896,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81896,37.9,0.46,380,32918,70,NULL,NULL,'SDSS J113205.69+214624.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,173.023708333,21.77361,0,NULL,61131307312,955176676,14924635,17.9),(81897,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81897,37.77,0.46,359,32919,70,NULL,NULL,'2MASX J11320581+1414228',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,173.024417,14.23964,0,NULL,60226422914,941037858,14703716,17.4),(81898,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81898,35.59,0.56,131,32920,70,NULL,NULL,'2MASX J11320585-0652544',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'16.31',0.21,NULL,NULL,NULL,NULL,NULL,1,173.0244583,-6.88172,0.061,NULL,41057241548,641519399,10023740,16.31),(81899,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81899,35.95,0.67,155,32921,70,NULL,NULL,'2MASX J11320605-0800354',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.73',0.3,NULL,NULL,NULL,NULL,NULL,1,173.025375,-8.00986,0.053,NULL,41068324389,641692568,10026446,16.73),(81900,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81900,38.17,0.46,431,32922,70,NULL,NULL,'SDSS J113207.28+364513.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000093,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,173.030333,36.75381,0,NULL,60450759423,944543115,14758486,18.2),(81901,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81901,36.23,0.46,176,32923,70,NULL,NULL,'2MASX J11320741+0912461',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000152,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,173.030958333,9.21269,0.118,NULL,60388706893,943573545,14743336,16.7),(81902,'IRAS','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81902,34.1,0.8,66.1,32924,75,NULL,'MAT, I','ESO 320- G 002',NULL,'1997ApJS..109..333W',1997,1,2.02,NULL,'G',0.000033,NULL,'15.51',0.25,'Sbc',NULL,NULL,NULL,NULL,1,173.031875,-41.428,0.381,NULL,41880738052,654386532,10224789,15.51),(81903,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81903,34.18,0.49,68.6,32924,75,NULL,'IR','ESO 320- G 002',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81904,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81904,34.19,0.32,68.8,32924,85,NULL,'I, raw','ESO 320- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81905,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81905,34.2,0.43,69.2,32924,75,NULL,'MAT, I, raw','ESO 320- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81906,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81906,34.22,0.32,69.9,32924,85,NULL,'I, inv','ESO 320- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81907,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81907,34.34,NULL,73.8,32924,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 320- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81908,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81908,34.35,NULL,74.1,32924,NULL,NULL,'Dipole + Quadrupole','ESO 320- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81909,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81909,34.35,NULL,74.3,32924,NULL,NULL,'Dipole','ESO 320- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81910,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81910,34.37,0.43,75,32924,75,NULL,'MAT, I, inv','ESO 320- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81911,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81911,34.4,NULL,75.9,32924,NULL,NULL,NULL,'ESO 320- G 002',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81912,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81912,34.43,0.43,77.1,32924,75,NULL,'MAT, I, cor','ESO 320- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81913,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81913,34.47,0.44,78.3,32924,NULL,NULL,'Malmquist cor.','ESO 320- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81914,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81914,34.57,0.42,81.9,32924,NULL,NULL,NULL,'ESO 320- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81915,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81915,34.61,0.2,83.6,32924,74.4,NULL,NULL,'ESO 320- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81916,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81916,38.09,0.19,415,32925,70,NULL,NULL,'2MASX J11320853+1709018',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000187,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,173.03575,17.15075,0.052,NULL,61107214713,954800229,14918753,17.6),(81917,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81917,37.17,0.27,272,32926,70,NULL,NULL,'2MASX J11320877+5734026',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000121,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,173.036625,57.56742,0,NULL,61990515069,968601797,15134403,17.1),(81918,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81918,35.64,0.46,134,32927,70,NULL,NULL,'CGCG 012-005',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000089,NULL,'15.4g',0.43,'SAB0^0^:',NULL,NULL,NULL,NULL,1,173.038458333,-0.94258,0.057,NULL,40830691231,637979550,9968430,15.4),(81919,'BCG','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81919,38.09,0.35,392,32928,60,NULL,NULL,'ABELL 1291',0.0586,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,173.04125,56.03083,0,NULL,61984868992,968513578,15133024,NULL),(81920,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81920,37.69,0.46,346,32929,70,NULL,NULL,'2MASX J11321027-0134221',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000157,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,173.042833,-1.57294,0.061,NULL,40831821964,637997218,9968706,17),(81921,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81921,34.44,NULL,77.2,32930,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06519',NULL,'2010Ap&SS.325..163P',2010,1,1.32,NULL,'G',0.000015,NULL,'15.68',0.13,'Sd(f)',NULL,NULL,NULL,NULL,1,173.0430417,1.20711,0.053,NULL,60170465895,940163529,14690055,15.68),(81922,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81922,34.46,NULL,78,32930,NULL,NULL,'Dipole + Quadrupole','UGC 06519',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81923,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81923,34.48,NULL,78.6,32930,NULL,NULL,'Dipole','UGC 06519',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81924,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81924,35.02,0.49,101,32930,75,NULL,'IR','UGC 06519',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81925,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81925,35.42,0.55,121,32930,NULL,NULL,'Malmquist cor.','UGC 06519',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81926,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81926,35.45,NULL,123,32930,NULL,NULL,NULL,'UGC 06519',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81927,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81927,35.63,0.2,134,32930,74.4,NULL,NULL,'UGC 06519',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81928,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81928,35.67,0.49,136,32930,NULL,NULL,NULL,'UGC 06519',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81929,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81929,38.18,0.46,433,32931,70,NULL,NULL,'LCRS B112937.0-021758',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000149,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,173.043417,-2.57525,0.145,NULL,40832292973,638004577,9968821,18.1),(81930,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81930,37.19,0.46,274,32932,70,NULL,NULL,'2MASX J11321045+5350004',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000186,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,173.043583,53.83339,0,NULL,61764901074,965076579,15079321,16.3),(81931,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81931,35.73,0.12,140,32933,NULL,NULL,NULL,'SDSS J113210.64+491243.1',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000027,NULL,'17.7g',0.12,'Sc','Group member',NULL,NULL,NULL,1,173.044333333,49.21197,0,NULL,61751978537,964874664,15076166,17.7),(81932,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81932,37.97,0.46,393,32934,70,NULL,NULL,'2MASX J11321124+4143190',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,173.046875,41.722,0.016,NULL,63896404343,998381317,15599708,17.9),(81933,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81933,37.17,0.12,272,32935,70,NULL,NULL,'2MASX J11321189+5602516',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000133,NULL,'15.8g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,173.0495,56.04783,0,NULL,61984870263,968513597,15133024,15.8),(81934,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81934,37.17,0.12,272,32936,70,NULL,NULL,'2MASX J11321249+5559406',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000117,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,173.05225,55.99456,0,NULL,61985392546,968521758,15133152,17.3),(81935,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81935,37.32,0.27,291,32937,70,NULL,NULL,'SDSS J113212.56+572419.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,173.052375,57.40542,0,NULL,61990832754,968606761,15134480,17.7),(81936,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81936,38.77,0.46,567,32938,70,NULL,NULL,'2MASX J11321299+0119585',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000112,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,173.053917,1.33303,0.053,NULL,60170490921,940163920,14690061,17.5),(81937,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81937,33.71,0.69,55.1,32939,100,NULL,'mid-IR','NGC 3719',NULL,'2013ApJ...771...88L',2013,1,1.8,'The APMUKS position is 6\\\" southwest of the nucleus.','G',0.000007,NULL,'13.6g',0.99,'SA(rs)bc pec:  NLAGN','Pair member, S + S',NULL,NULL,NULL,1,173.056083,0.81928,0.077,NULL,60170509146,940164205,14690065,13.6),(81938,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81938,34.68,0.47,86.4,32939,NULL,NULL,'H','NGC 3719',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81939,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81939,34.74,0.4,88.6,32939,NULL,NULL,'mean','NGC 3719',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81940,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81940,34.76,0.46,89.7,32939,NULL,NULL,'J','NGC 3719',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81941,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81941,34.77,0.45,90,32939,NULL,NULL,'K','NGC 3719',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81942,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81942,34.84,0.38,92.8,32939,NULL,NULL,'Malmquist cor.','NGC 3719',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81943,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81943,35.04,0.35,102,32939,NULL,NULL,NULL,'NGC 3719',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81944,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81944,35.08,0.2,104,32939,74.4,NULL,NULL,'NGC 3719',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81945,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81945,37.87,0.46,375,32940,70,NULL,NULL,'2MASX J11321444-0059140',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000075,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,173.060333333,-0.98736,0.057,NULL,40830653594,637978962,9968421,17.8),(81946,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81946,37.32,0.27,291,32941,70,NULL,NULL,'2MASX J11321485+5724326',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,173.062041667,57.40908,0,NULL,61990833023,968606765,15134480,17),(81947,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81947,37.76,0.07,357,32942,70,NULL,NULL,'2MASX J11321517+1413558',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000175,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,173.063167,14.23225,0,NULL,60226430334,941037973,14703718,17.5),(81948,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81948,37.76,0.07,357,32943,70,NULL,NULL,'2MASX J11321593+1430408',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000182,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,173.0662917,14.51131,0,NULL,60224698032,941010906,14703295,17.6),(81949,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81949,37.76,0.07,357,32944,70,NULL,NULL,'2MASX J11321654+1401588',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.71',0.16,NULL,NULL,NULL,NULL,NULL,1,173.069125,14.03289,0.052,NULL,60226443953,941038186,14703721,17.71),(81950,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81950,37.82,0.46,367,32945,70,NULL,NULL,'2MASX J11321935+5932526',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,173.080833,59.54797,0,NULL,61850645905,966416342,15100255,17.3),(81951,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81951,37.79,0.23,361,32946,70,NULL,NULL,'2MASXi J1132193+341827',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,173.080917,34.30767,0.012,NULL,60621259709,947207182,14800112,18),(81952,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81952,38.46,0.46,491,32947,70,NULL,NULL,'SDSS J113219.67+525314.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,173.082,52.88733,0,NULL,61793608445,965525131,15086330,18.4),(81953,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81953,38.22,0.46,441,32948,70,NULL,NULL,'SDSS J113220.86+145542.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,173.0869583,14.92861,0.043,NULL,60225085900,941016967,14703390,18.4),(81954,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81954,34.93,0.33,96.9,32949,70,NULL,NULL,'UGC 06522',NULL,'2015arXiv151105856S',2015,1,1.4,NULL,'G',0.00009,NULL,'14.10',1.4,'S0?',NULL,NULL,NULL,NULL,1,173.089833,28.04825,0,NULL,60574784768,946481012,14788765,14.1),(81955,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81955,37.76,0.07,357,32950,70,NULL,NULL,'2MASX J11322220+1437578',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000175,NULL,'17.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,173.0924583,14.63283,0.005,NULL,60224593232,941009269,14703269,17.7),(81956,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81956,37.47,0.33,312,32951,70,NULL,NULL,'2MASX J11322248+1235108',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000149,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,173.093583333,12.58644,0.099,NULL,60220946603,940952290,14702379,17.3),(81957,'BCG','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,NULL,81957,38.09,0.35,392,32952,60,NULL,'ABELL 1291, BCG','MCG +09-19-110 NED02',0.0586,'1980ApJ...241..486H',1980,1,0.99,NULL,'G',0.000189,NULL,'15.6g',0.46,'cD;BrClG',NULL,NULL,NULL,NULL,1,173.096667,55.96744,0,NULL,61985404161,968521940,15133155,15.6),(81958,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81958,37.46,0.21,311,32953,70,NULL,NULL,'2MASX J11322388+5612455',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000198,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,173.0995417,56.21264,0,NULL,61989314720,968583042,15134110,16.6),(81959,'FP','2016-12-15 15:14:48','2016-12-16 11:19:56','1',NULL,'R',81959,36.78,0.46,227,32954,70,NULL,NULL,'2MASX J11322400+0507355',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.60',0.2,NULL,NULL,NULL,NULL,NULL,1,173.099958333,5.12636,0.045,NULL,60352680645,943010635,14734541,17.6),(81960,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',81960,36.71,0.46,219,32955,70,NULL,NULL,'2MASX J11322456+2756107',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000113,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,173.1022917,27.93622,0,NULL,60574764424,946480694,14788760,16.5),(81961,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',81961,37.76,0.07,357,32956,70,NULL,NULL,'LCSB S1576P',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000201,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,173.1052083,14.62022,0.027,NULL,60224590703,941009229,14703269,16.9),(81962,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',81962,35.94,0.46,154,32957,70,NULL,NULL,'2MASX J11322591-0209510',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00015,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,173.107875,-2.16422,0.085,NULL,40832347549,638005430,9968834,16.4),(81963,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',81963,37.88,0.27,377,32958,70,NULL,NULL,'2MASX J11322624+0357065',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,'FoF','18.61',0.11,NULL,NULL,NULL,NULL,NULL,1,173.109416667,3.95167,0.009,NULL,60175407529,940240742,14691261,18.61),(81964,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',81964,37.76,0.07,357,32959,70,NULL,NULL,'2MASX J11322657+1400038',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00018,NULL,'16.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,173.110667,14.00108,0.052,NULL,60226956317,941046192,14703846,16.2),(81965,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',81965,37.81,0.33,366,32960,70,NULL,NULL,'2MASX J11322696+2953167',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000196,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,173.112375,29.88792,0,NULL,60625114519,947267414,14801053,16.7),(81966,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',81966,37.17,0.27,272,32961,70,NULL,NULL,'2MASX J11322715+5732105',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000157,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,173.113333,57.53628,0,NULL,61990509267,968601707,15134401,16.8),(81967,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',81967,37.32,0.27,291,32962,70,NULL,NULL,'2MASX J11322725+5728495',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000215,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,173.113833,57.48056,0,NULL,61990384728,968599761,15134371,16.7),(81968,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,81968,35.05,0.61,103,32963,70,NULL,NULL,'2MASX J11322774-1110028',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.12',NULL,NULL,NULL,NULL,NULL,NULL,1,173.1155,-11.16761,0.013,NULL,41008330045,640755156,10011799,16.12),(81969,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',81969,37.2,0.46,276,32964,70,NULL,NULL,'2MASX J11322774+1719268',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000143,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,173.115666667,17.32417,0.044,NULL,61124240005,955066250,14922910,17.9),(81970,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,81970,33.77,0.4,56.8,32965,NULL,NULL,'mean','UGC 06520',NULL,'2007A&A...465...71T',2007,1,1.14,NULL,'G',0.000133,NULL,'13.9g',0.77,'SB?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,173.117125,62.50731,0,NULL,61872596249,966759316,15105614,13.9),(81971,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,81971,33.91,0.47,60.5,32965,NULL,NULL,'H','UGC 06520',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81972,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,81972,33.97,0.46,62.3,32965,NULL,NULL,'J','UGC 06520',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81973,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,81973,34.02,0.45,63.7,32965,NULL,NULL,'K','UGC 06520',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81974,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,81974,34.65,0.2,85.1,32965,74.4,NULL,NULL,'UGC 06520',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81975,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',81975,37.88,0.27,377,32966,70,NULL,NULL,'2MASX J11322911+0357295',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000189,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,173.121417,3.95808,0.009,NULL,60175407930,940240748,14691261,18.2),(81976,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',81976,37.57,0.33,326,32967,70,NULL,NULL,'2MASX J11322923+2257472',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,173.121916667,22.96308,0,NULL,61128018354,955125286,14923832,17.8),(81977,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,81977,34.52,0.47,80.2,32968,70,NULL,NULL,'NGC 3723',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.10',0.6,'SA(rs?)0- pec?','Group member',NULL,NULL,NULL,1,173.1272917,-9.96953,0.053,NULL,41065746409,641652287,10025816,14.1),(81978,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',81978,37.88,0.27,377,32969,70,NULL,NULL,'2MASX J11323099+0356255',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000157,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,173.129083,3.94042,0.009,NULL,60175408953,940240764,14691261,17),(81979,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',81979,37.8,0.46,364,32970,70,NULL,NULL,'2MASX J11323146+1133513',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,173.1310417,11.56419,0.073,NULL,60218391824,940912372,14701755,17.5),(81980,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',81980,37.81,0.46,365,32971,70,NULL,NULL,'2MASX J11323197+1425342',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00014,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,173.133166667,14.42628,0,NULL,60224544806,941008512,14703258,18),(81981,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,81981,31.91,0.43,24.1,32972,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3752',NULL,'2014MNRAS.444..527S',2014,1,1.7,NULL,'G',0.00004,NULL,'13.75',0.7,'Sab','Isolated galaxy',NULL,NULL,NULL,1,173.134208333,74.62753,0.141,NULL,61398037593,959344337,14989755,13.75),(81982,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,81982,32.12,0.43,26.5,32972,75,NULL,'3.6 micron, color corrected','NGC 3752',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81983,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,81983,32.31,0.2,29,32972,74.4,NULL,NULL,'NGC 3752',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81984,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,81984,32.49,0.4,31.4,32972,NULL,NULL,'mean','NGC 3752',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81985,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,81985,32.56,0.47,32.5,32972,NULL,NULL,'H','NGC 3752',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81986,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,81986,32.6,0.46,33.1,32972,NULL,NULL,'J','NGC 3752',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81987,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,81987,32.62,0.45,33.4,32972,NULL,NULL,'K','NGC 3752',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81988,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,81988,34.91,0.52,95.8,32973,70,NULL,NULL,'2MASX J11323243-1006498',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000143,NULL,'15.28',0.9,NULL,NULL,NULL,NULL,NULL,1,173.1350417,-10.11381,0.021,NULL,41062988133,641609189,10025143,15.28),(81989,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,81989,37.47,0.77,312,32974,70,NULL,NULL,'2MASX J11323318-5016383',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,173.138333333,-50.27739,0.589,NULL,40058394586,625912415,9779881,16.1),(81990,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',81990,38.32,0.46,461,32975,70,NULL,NULL,'SDSS J113233.96+581612.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000139,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,173.1415,58.27006,0,NULL,61981515854,968461185,15132206,18.7),(81991,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',81991,34.98,0.33,99.1,32976,70,NULL,NULL,'CGCG 268-047',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000097,NULL,'14.5g',0.59,'E',NULL,NULL,NULL,NULL,1,173.141791667,54.92656,0,NULL,61763692366,965057693,15079026,14.5),(81992,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,81992,35.35,0.25,117,32977,74.4,NULL,NULL,'CGCG 242-044',NULL,'2013AJ....146...86T',2013,1,0.59,NULL,'G',0.000019,NULL,'15.3g',0.58,'E0',NULL,NULL,NULL,NULL,1,173.145041667,49.10967,0,NULL,61752195009,964878047,15076219,15.3),(81993,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',81993,36.02,0.11,160,32977,70,NULL,NULL,'CGCG 242-044',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81994,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,81994,31.15,0.4,17,32978,75,NULL,'B','NGC 3718',NULL,'1988NBGC.C....0000T',1988,1,8.1,NULL,'G',0.000003,NULL,'11.59',4,'SB(s)a pec;Sy1 LINER','Pair member (points to parent)',NULL,NULL,'LINER b',1,173.1452083,53.06792,0,NULL,61793519084,965523735,15086308,11.59),(81995,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',81995,36.1,0.46,166,32979,70,NULL,NULL,'2MASX J11323643+1850512',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000077,NULL,'16.41',0.26,'AGN',NULL,NULL,NULL,NULL,1,173.151917,18.84767,0,NULL,61125434115,955084908,14923201,16.41),(81996,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',81996,37.52,0.46,319,32980,70,NULL,NULL,'2MASX J11323649+0950073',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000154,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,173.152125,9.83525,0.076,NULL,60389248677,943582010,14743468,17.1),(81997,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',81997,37.17,0.12,272,32981,70,NULL,NULL,'2MASX J11323648+5614055',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000178,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,173.152166667,56.23492,0,NULL,61989556825,968586825,15134169,17.4),(81998,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',81998,37.22,0.27,277,32982,70,NULL,NULL,'KUG 1129+266',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000169,NULL,'16.5g',0.33,'Compact',NULL,NULL,NULL,NULL,1,173.1537083,26.40572,0,NULL,60576267181,946504174,14789127,16.5),(81999,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',81999,37.67,0.27,342,32983,70,NULL,NULL,'2MASX J11323716+0613243',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,173.15475,6.22342,0.061,NULL,60384816020,943512750,14742386,17.1),(82000,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82000,38.27,0.46,452,32984,70,NULL,NULL,'SDSS J113237.63+081810.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,173.156833,8.30306,0.115,NULL,60396315819,943692434,14745194,18.6),(82001,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82001,33.94,0.5,61.3,32985,70,NULL,NULL,'2MASX J11323769-1635109',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000117,NULL,'14.33',NULL,NULL,NULL,NULL,NULL,NULL,1,173.157083,-16.58636,0.069,NULL,41700726610,651573853,10180841,14.33),(82002,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82002,37.81,0.33,366,32986,70,NULL,NULL,'SDSS J113237.91+295002.8',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000221,NULL,'16.4g',0.33,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,173.158,29.83411,0,NULL,60625067645,947266681,14801041,16.4),(82003,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82003,37.4,0.46,301,32987,70,NULL,NULL,'2MASX J11323817+2736227',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000172,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,173.158875,27.60633,0,NULL,60574664409,946479131,14788736,16.8),(82004,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82004,37.76,0.07,357,32988,70,NULL,NULL,'SDSS J113238.68+143134.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000149,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,173.161208333,14.52611,0.027,NULL,60224647614,941010118,14703283,18.4),(82005,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82005,30.95,0.4,15.5,32989,75,NULL,NULL,'UGC 06526',NULL,'2008Ap.....51..336K',2008,1,1.66,NULL,'G',0.000008,NULL,'14.7g',0.37,'S?;WR          HII','Group member',NULL,NULL,NULL,1,173.164583,35.32839,0,NULL,60448435748,944506808,14757918,14.7),(82006,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82006,31.54,0.49,20.3,32989,75,NULL,'IR','UGC 06526',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82007,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82007,37.67,0.27,342,32990,70,NULL,NULL,'2MASX J11323964+0610043',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000186,NULL,'17.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,173.165125,6.16792,0.081,NULL,60384861486,943513460,14742397,17.3),(82008,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82008,37.04,0.46,256,32991,70,NULL,NULL,'2MASX J11323969+6755225',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000108,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,173.165541667,67.92292,0,NULL,62078501489,969976585,15155884,16.2),(82009,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82009,38.76,0.46,564,32992,70,NULL,NULL,'SDSS J113240.04+085256.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000175,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,173.166833,8.88247,0.059,NULL,60388233123,943566142,14743220,18.6),(82010,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82010,37.7,0.46,347,32993,70,NULL,NULL,'2MASX J11324005+2229343',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.75',0.2,NULL,NULL,NULL,NULL,NULL,1,173.1669583,22.49286,0,NULL,61128667807,955135434,14923991,17.75),(82011,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82011,34.94,0.49,97.2,32994,75,NULL,'IR','UGC 06527 NED03',NULL,'2011yCatp016004901K',2011,1,0.65,'Called \'VV 150d\' in UGC notes.','G',0.000127,NULL,'14.8g',0.36,'SB0;Sy1        Sy2','Compact group member',NULL,NULL,'Sy 1 i',1,173.1677083,52.95039,0,NULL,61793595436,965524928,15086327,14.8),(82012,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82012,38.48,0.46,497,32995,70,NULL,NULL,'2MASX J11324073+3852181',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,173.169708333,38.87158,0.009,NULL,60459975166,944687111,14760736,17),(82013,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82013,38.2,0.46,436,32996,70,NULL,NULL,'2MASX J11324108+1756353',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,173.171125,17.943,0.008,NULL,61123923565,955061305,14922832,17.7),(82014,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82014,37.22,0.27,277,32997,70,NULL,NULL,'2MASX J11324217+2620477',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000172,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,173.1755,26.34647,0,NULL,60576263026,946504109,14789126,17.2),(82015,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82015,37.63,0.46,335,32998,70,NULL,NULL,'2MASX J11324235+5615035',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00017,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,173.17675,56.25108,0,NULL,61989559712,968586870,15134169,16.5),(82016,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82016,36.86,0.46,235,32999,70,NULL,NULL,'2MASX J11324243+3006144',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000178,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,173.1767917,30.104,0,NULL,60625236822,947269325,14801083,16.9),(82017,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82017,37.76,0.07,357,33000,70,NULL,NULL,'2MASX J11324256+1426162',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000197,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,173.1774583,14.43786,0,NULL,60224524603,941008196,14703253,17.2),(82018,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82018,37.22,0.46,279,33001,70,NULL,NULL,'2MASX J11324313+1009213',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,173.1797917,10.15597,0.096,NULL,60385898682,943529666,14742651,17.1),(82019,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82019,37.76,0.07,357,33002,70,NULL,NULL,'2MASX J11324326+1421542',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000192,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,173.180083,14.36506,0,NULL,60224567617,941008869,14703263,18),(82020,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82020,37.49,0.46,314,33003,70,NULL,NULL,'SDSS J113243.59+375109.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,173.181667,37.85258,0,NULL,60462108533,944720445,14761256,18.3),(82021,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82021,38.09,0.46,415,33004,70,NULL,NULL,'2MASX J11324417+0438520',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,173.184083,4.64783,0.057,NULL,60352606523,943009476,14734523,17.4),(82022,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82022,37.76,0.07,357,33005,70,NULL,NULL,'2MASX J11324573+1405462',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000191,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,173.1905,14.09622,0.027,NULL,60226933108,941045829,14703841,17.4),(82023,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82023,37.57,0.33,326,33006,70,NULL,NULL,'2MASX J11324617+2254303',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,173.192583,22.9085,0,NULL,61128026485,955125413,14923834,17.7),(82024,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82024,38.17,0.33,431,33007,70,NULL,NULL,'2MASX J11324637+1316292',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,173.193375,13.27472,0.143,NULL,60219116395,940923693,14701932,17.8),(82025,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82025,35.84,NULL,147,33008,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06527 NOTES02',NULL,'2010Ap&SS.325..163P',2010,1,1.15,'Called \'VV 150e\' in UGC notes.','G',0.000108,NULL,'15.9g',0.19,'Sc             HII','Compact group member',NULL,NULL,NULL,1,173.194583,52.94089,0,NULL,61793625145,965525392,15086334,15.9),(82026,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82026,35.86,NULL,148,33008,NULL,NULL,'Dipole + Quadrupole','UGC 06527 NOTES02',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82027,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82027,35.87,NULL,149,33008,NULL,NULL,NULL,'UGC 06527 NOTES02',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82028,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82028,35.87,NULL,149,33008,NULL,NULL,'Dipole','UGC 06527 NOTES02',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82029,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82029,37.76,0.07,357,33009,70,NULL,NULL,'2MASX J11324677+1401392',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000173,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,173.1949583,14.02761,0.027,NULL,60226993693,941046776,14703855,17.4),(82030,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82030,36.34,0.67,186,33010,70,NULL,NULL,'2MASX J11324684-3339397',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.4b',0.3,'E',NULL,NULL,NULL,NULL,1,173.195083,-33.66108,0.269,NULL,41583004151,649734439,10152100,16.4),(82031,'IRAS','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82031,34.58,0.8,82.3,33011,75,NULL,'W91CL, r','KUG 1130+203',NULL,'1997ApJS..109..333W',1997,1,0.7,NULL,'G',0.000009,NULL,'15.42',0.4,'S0/a:pec',NULL,NULL,NULL,NULL,1,173.195583333,20.03819,0.009,NULL,61132233560,955191149,14924861,15.42),(82032,'IRAS','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82032,34.59,0.8,82.9,33011,75,NULL,'HMCL, I','KUG 1130+203',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82033,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82033,34.68,0.38,86.2,33011,75,NULL,'W91CL, r, raw','KUG 1130+203',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82034,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82034,34.7,0.43,87,33011,75,NULL,'3.6 micron, color + selection bias corrected','KUG 1130+203',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82035,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82035,34.73,0.38,88.4,33011,75,NULL,'W91CL, r, inv','KUG 1130+203',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82036,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82036,34.73,0.43,88.4,33011,75,NULL,'3.6 micron, color corrected','KUG 1130+203',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82037,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82037,34.82,0.2,92,33011,74.4,NULL,NULL,'KUG 1130+203',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82038,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82038,34.9,0.38,95.6,33011,75,NULL,'W91CL, r, cor','KUG 1130+203',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82039,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82039,34.93,0.12,97,33011,NULL,NULL,NULL,'KUG 1130+203',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82040,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82040,34.94,0.4,97.3,33011,75,NULL,'HMCL, I, raw','KUG 1130+203',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82041,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82041,35.06,0.4,103,33011,75,NULL,'HMCL, I, inv','KUG 1130+203',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82042,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82042,35.17,0.4,108,33011,75,NULL,'HMCL, I, cor','KUG 1130+203',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82043,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82043,35.67,0.64,136,33012,70,NULL,NULL,'2MASX J11324723-4612583',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'13.8I',0.3,NULL,NULL,NULL,NULL,NULL,1,173.1967083,-46.21628,0.445,NULL,41887528998,654492640,10226447,13.8),(82044,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82044,34.78,0.46,90.5,33013,70,NULL,NULL,'2MASX J11324859+0530240',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.00009,NULL,'15.1g',0.36,'S0/a',NULL,NULL,NULL,NULL,1,173.202416667,5.50653,0.069,NULL,60352327153,943005111,14734454,15.1),(82045,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82045,37.17,0.12,272,33014,70,NULL,NULL,'CGCG 292-004',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.000107,NULL,'15.0g',0.64,'E0',NULL,NULL,NULL,NULL,1,173.204667,56.42261,0,NULL,61989472024,968585500,15134148,15),(82046,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82046,32.18,0.4,27.3,33015,75,NULL,'B','UGC 06531',NULL,'1988NBGC.C....0000T',1988,1,0.96,NULL,'G',0.000037,NULL,'15.5g',0.89,'SB(r)dm',NULL,NULL,NULL,NULL,1,173.2050417,39.08489,0.011,NULL,60460751608,944699243,14760925,15.5),(82047,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82047,37.46,0.21,311,33016,70,NULL,NULL,'SDSS J113249.30+561043.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000185,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,173.2055,56.17861,0,NULL,61989528283,968586379,15134162,18.3),(82048,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82048,37.33,0.17,293,33017,70,NULL,NULL,'2MASX J11324965+3642174',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,173.207,36.70481,0,NULL,60450736757,944542761,14758480,17.2),(82049,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82049,35.8,0.08,145,33018,NULL,NULL,NULL,'2MASX J11324973+4906020',NULL,'2009ApJS..182..474S',2009,1,0.62,NULL,'G',0.000033,NULL,'16.4g',0.21,'Sc','Group member',NULL,NULL,NULL,1,173.2074583,49.10042,0,NULL,61752191498,964877992,15076218,16.4),(82050,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82050,37.76,0.07,357,33019,70,NULL,NULL,'SDSS J113250.28+143108.9',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000215,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,173.2095417,14.51917,0.027,NULL,60224644321,941010067,14703282,16.2),(82051,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82051,36.21,0.53,174,33020,70,NULL,NULL,'2MASX J11325072-0347274',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00011,NULL,'16.04',0.52,NULL,NULL,NULL,NULL,NULL,1,173.211375,-3.79108,0.117,NULL,40827254684,637925854,9967591,16.04),(82052,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82052,37.76,0.07,357,33021,70,NULL,NULL,'SDSS J113251.16+142740.2',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',NULL,NULL,'15.5g',0.51,'BrClG',NULL,NULL,NULL,NULL,1,173.213208333,14.46119,0.027,NULL,60224525672,941008213,14703253,15.5),(82053,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82053,37.67,0.27,342,33022,70,NULL,NULL,'2MASX J11325144+0617034',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000147,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,173.214333333,6.28436,0.097,NULL,60384814264,943512722,14742386,17.5),(82054,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82054,35.99,0.46,157,33023,70,NULL,NULL,'2MASX J11325162+6449415',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000072,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,173.214916667,64.82819,0.037,NULL,61820496148,965945252,15092894,16.4),(82055,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82055,34.45,0.49,77.7,33024,75,NULL,'IR','UGC 06533',NULL,'2011yCatp016004901K',2011,1,1.05,NULL,'G',0.000033,NULL,'15.2g',0.31,'Sc(f)',NULL,NULL,NULL,NULL,1,173.217958333,5.72736,0.081,NULL,60381742878,943464732,14741636,15.2),(82056,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82056,34.5,0.47,79.4,33024,NULL,NULL,'H','UGC 06533',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82057,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82057,34.56,0.26,81.7,33024,NULL,NULL,NULL,'UGC 06533',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82058,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82058,34.58,0.4,82.6,33024,NULL,NULL,'mean','UGC 06533',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82059,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82059,34.6,0.2,83.2,33024,74.4,NULL,NULL,'UGC 06533',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82060,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82060,34.64,0.25,84.6,33024,NULL,NULL,'Malmquist cor.','UGC 06533',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82061,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82061,34.65,0.45,85,33024,NULL,NULL,'K','UGC 06533',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82062,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82062,34.79,0.46,90.7,33024,NULL,NULL,'J','UGC 06533',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82063,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82063,37.76,0.07,357,33025,70,NULL,NULL,'2MASX J11325234+1429322',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00017,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,173.218167,14.49244,0.027,NULL,60224526968,941008233,14703253,17.6),(82064,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82064,37.83,0.46,368,33026,70,NULL,NULL,'2MASX J11325239+0825364',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,173.2182083,8.42669,0.115,NULL,60396325694,943692588,14745196,17.4),(82065,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82065,38.1,0.46,418,33027,70,NULL,NULL,'2MASX J11325251+2535507',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,173.218625,25.59744,0,NULL,60571184964,946424765,14787886,17.1),(82066,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82066,37.22,0.27,277,33028,70,NULL,NULL,'2MASX J11325295+2610077',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000212,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,173.2205417,26.16875,0,NULL,60576239053,946503735,14789120,16.2),(82067,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82067,36.47,0.33,197,33029,70,NULL,NULL,'2MASX J11325307+6722093',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000088,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,173.2207917,67.36908,0,NULL,62078782828,969980981,15155952,16.2),(82068,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82068,38.45,0.46,490,33030,70,NULL,NULL,'2MASX J11325509+1759133',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,173.229625,17.98711,0.008,NULL,61123936091,955061501,14922835,17.2),(82069,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82069,36.76,0.46,225,33031,70,NULL,NULL,'2MASX J11325514+5531266',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000184,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,173.2300417,55.52403,0,NULL,61985349973,968521093,15133142,16.5),(82070,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82070,37.27,0.46,285,33032,70,NULL,NULL,'SDSS J113255.23+150206.2',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.6g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,173.230167,15.03508,0.043,NULL,60225893046,941029578,14703587,16.6),(82071,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82071,37.93,0.46,385,33033,70,NULL,NULL,'2MASX J11325596+0515400',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.1g',0.27,'BLLAC',NULL,NULL,NULL,NULL,1,173.2332083,5.261,0.053,NULL,60352663038,943010359,14734536,17.1),(82072,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82072,34.34,0.46,73.7,33034,70,NULL,NULL,'IC 0705',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000141,NULL,'14.9g',0.52,'S0^-',NULL,NULL,NULL,NULL,1,173.2347917,50.24186,0,NULL,61796082864,965563794,15086934,14.9),(82073,'CMD','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82073,20.85,NULL,0.148,33035,NULL,NULL,NULL,'LEO IV',NULL,'2014ApJ...789..147W',2014,1,NULL,NULL,'G',NULL,NULL,'15.9V',NULL,'dSph',NULL,NULL,NULL,NULL,1,173.2375,-0.53333,0.057,1,40831226921,637987920,9968561,15.9),(82074,'CMD','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82074,21.15,NULL,0.156,33035,NULL,NULL,NULL,'LEO IV',NULL,'2013ApJ...771...29G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82075,'CMD','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82075,21,0.2,0.16,33035,NULL,NULL,NULL,'LEO IV',NULL,'2007ApJ...654..897B',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82076,'CMD','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82076,21,0.2,0.16,33035,NULL,NULL,NULL,'LEO IV',NULL,'2008AJ....135.1361D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82077,'CMD','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82077,21.15,0.08,0.17,33035,NULL,NULL,NULL,'LEO IV',NULL,'2012ApJ...753L..21B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82078,'Horizontal Branch','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82078,20.94,0.07,0.154,33035,NULL,NULL,NULL,'LEO IV',NULL,'2009ApJ...699L.125M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82079,'Horizontal Branch','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82079,20.99,0.12,0.158,33035,NULL,NULL,NULL,'LEO IV',NULL,'2012ApJ...744...96O',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82080,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82080,37.77,0.19,358,33036,70,NULL,NULL,'2MASX J11325828+0623414',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000177,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,173.243,6.39497,0.097,NULL,60385165746,943518214,14742472,16.8),(82081,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82081,37.77,0.19,358,33037,70,NULL,NULL,'SDSS J113258.78+062613.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000143,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,173.2449583,6.43706,0.097,NULL,60385349152,943521080,14742516,18.3),(82082,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82082,37.76,0.07,357,33038,70,NULL,NULL,'2MASX J11325889+1436242',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00019,NULL,'16.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,173.2455,14.60681,0.027,NULL,60224636492,941009945,14703280,16.4),(82083,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82083,37.77,0.19,358,33039,70,NULL,NULL,'2MASX J11330049+0624354',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000193,NULL,'16.6g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,173.252,6.40978,0.097,NULL,60385166091,943518220,14742472,16.6),(82084,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82084,37.76,0.07,357,33040,70,NULL,NULL,'2MASX J11330145+1432035',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000183,NULL,'17.3g',0.23,'AGN:',NULL,NULL,'NAT',NULL,1,173.2560417,14.53447,0.027,NULL,60224522199,941008159,14703252,17.3),(82085,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82085,36.8,0.33,229,33041,70,NULL,NULL,'2MASX J11330223-0123564',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,173.2592917,-1.39922,0.061,NULL,40830520681,637976885,9968388,17.3),(82086,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82086,36.55,0.27,205,33042,70,NULL,NULL,'2MASX J11330271+6244476',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000193,NULL,'15.6g',0.45,'E0',NULL,NULL,NULL,NULL,1,173.261583333,62.74653,0.005,NULL,61870715603,966729931,15105155,15.6),(82087,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82087,37.14,0.33,268,33043,70,NULL,NULL,'2MASX J11330290+5746516',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000156,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,173.2622917,57.78089,0,NULL,61990751064,968605485,15134460,17),(82088,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82088,36.95,0.46,246,33044,70,NULL,NULL,'2MASX J11330327+2320423',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.50',0.2,NULL,NULL,NULL,NULL,NULL,1,173.2635417,23.34517,0,NULL,60569952683,946405510,14787586,17.5),(82089,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82089,37.7,0.46,346,33045,70,NULL,NULL,'2MASX J11330366+2239503',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.75',0.18,NULL,NULL,NULL,NULL,NULL,1,173.26525,22.66411,0,NULL,61127960717,955124386,14923818,17.75),(82090,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82090,37.77,0.19,358,33046,70,NULL,NULL,'SDSS J113304.21+062226.4',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,173.267583,6.37403,0.097,NULL,60384693040,943510828,14742356,17.6),(82091,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82091,38.01,0.46,399,33047,70,NULL,NULL,'SDSS J113304.28+380417.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000134,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,173.267875,38.07164,0,NULL,60462805554,944731336,14761427,18.5),(82092,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82092,37.76,0.07,357,33048,70,NULL,NULL,'2MASXi J1133045+142353',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000179,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,173.268667,14.39819,0,NULL,60224564711,941008823,14703262,17.5),(82093,'GRB','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82093,44.97,1.59,3300,33049,100,NULL,NULL,'GRB 030226',1.986,'2009EPJC...63..139W',2009,1,NULL,NULL,'G',0.001,NULL,'19.6R',NULL,'Opt.var.',NULL,NULL,NULL,NULL,1,173.270417,25.89878,0,NULL,60571032503,946422382,14787849,19.6),(82094,'GRB','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82094,45.09,1.53,3490,33049,100,NULL,NULL,'GRB 030226',1.986,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82095,'GRB','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82095,46.38,0.48,6320,33049,72,NULL,NULL,'GRB 030226',1.986,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82096,'GRB','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82096,46.5,0.4,6680,33049,69.7,NULL,'Calibrated','GRB 030226',1.986,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82097,'GRB','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82097,46.51,0.47,6710,33049,70,NULL,NULL,'GRB 030226',1.986,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82098,'GRB','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82098,46.66,0.48,7190,33049,69.7,NULL,'Fiducial','GRB 030226',1.986,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82099,'GRB','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82099,46.67,0.54,7230,33049,NULL,NULL,NULL,'GRB 030226',1.986,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82100,'GRB','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82100,42.95,NULL,3890,33050,70,NULL,'Pseudo z = 3.56','GRB 030226',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'G',0.001,NULL,'19.6R',NULL,'Opt.var.',NULL,NULL,NULL,NULL,1,173.270417,25.89878,0,NULL,60571032503,946422382,14787849,19.6),(82101,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82101,37.06,0.46,258,33051,70,NULL,NULL,'SDSS J113305.07+413547.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000048,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,173.271167,41.5965,0.016,NULL,63896529387,998383271,15599738,18.1),(82102,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82102,36.27,0.52,179,33052,70,NULL,NULL,'4C -03.43',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.22',0.9,'E','Brightest group member',NULL,'radio jet','Flat-Spectrum Radio Source',1,173.2712917,-4.01325,0.117,NULL,40826775079,637918360,9967474,15.22),(82103,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82103,37.14,0.33,268,33053,70,NULL,NULL,'2MASX J11330515+5747126',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,173.27175,57.78703,0,NULL,61990761542,968605649,15134463,17.9),(82104,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82104,36.8,0.33,229,33054,70,NULL,NULL,'2MASX J11330577-0122104',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000193,NULL,'16.1g',0.39,'E0',NULL,NULL,NULL,NULL,1,173.274083,-1.36953,0.061,NULL,40830730896,637980170,9968440,16.1),(82105,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82105,38.17,0.33,431,33055,70,NULL,NULL,'2MASX J11330624+1316535',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,173.276,13.28161,0.143,NULL,60219109585,940923587,14701931,17),(82106,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82106,36.81,0.46,230,33056,70,NULL,NULL,'2MASX J11330636+0554599',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000179,NULL,'16.1g',0.37,'E0',NULL,NULL,NULL,NULL,1,173.2765417,5.91669,0.081,NULL,60381943479,943467866,14741685,16.1),(82107,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82107,38.2,0.46,437,33057,70,NULL,NULL,'LCRS B113033.1-030634',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,173.276875,-3.38539,0.117,NULL,40826507978,637914187,9967409,17.9),(82108,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82108,36.93,0.46,243,33058,70,NULL,NULL,'LCRS B113034.7-023804',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,173.283916667,-2.91036,0.109,NULL,40824506404,637882912,9966920,17.2),(82109,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82109,37.59,0.46,329,33059,70,NULL,NULL,'2MASX J11330834+3039173',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,173.28475,30.65469,0,NULL,60626847970,947294499,14801476,18.2),(82110,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82110,34.3,0.2,72.4,33060,74.4,NULL,NULL,'MCG -02-30-003',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000107,NULL,'14.86',0.3,'SABb: sp',NULL,NULL,NULL,NULL,1,173.2940417,-10.22886,0.033,NULL,41062965216,641608831,10025137,14.86),(82111,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82111,34.31,0.49,72.9,33060,75,NULL,'IR','MCG -02-30-003',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82112,'TRGB','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82112,28.74,0.1,5.6,33061,74.4,NULL,NULL,'HIPASS J1133-32',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',NULL,NULL,'16.27',NULL,NULL,NULL,NULL,NULL,NULL,1,173.295417,-32.96244,0.253,NULL,41584773175,649762080,10152532,16.27),(82113,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82113,38.02,0.33,401,33062,70,NULL,NULL,'SDSS J113311.82+021031.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000072,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,173.2992917,2.17556,0.053,NULL,60176697634,940260900,14691576,18.4),(82114,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82114,37.77,0.19,358,33063,70,NULL,NULL,'2MASX J11331210+0625294',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000181,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,173.300333,6.42483,0.097,NULL,60385166627,943518228,14742472,17.6),(82115,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82115,37.4,0.46,302,33064,70,NULL,NULL,'2MASX J11331254+5526165',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000193,NULL,'16.0g',0.4,'E0',NULL,NULL,NULL,NULL,1,173.302083,55.43797,0,NULL,61984616020,968509625,15132962,16),(82116,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82116,33.9,0.51,60.3,33065,70,NULL,NULL,'IC 0706',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'14.90',0.2,'SA(r)0/a? sp',NULL,NULL,NULL,NULL,1,173.302583333,-13.33806,0.045,NULL,40981098153,640329658,10005150,14.9),(82117,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82117,33.31,0.49,46,33066,75,NULL,'IR','UGC 06535',NULL,'2011yCatp016004901K',2011,1,1.31,NULL,'G',0.000013,NULL,'15.1',0.17,'Sc',NULL,NULL,NULL,NULL,1,173.3060417,50.30219,0,NULL,61796075261,965563675,15086932,15.1),(82118,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82118,37.76,0.07,357,33067,70,NULL,NULL,'2MASX J11331550+1427216',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,173.314666667,14.456,0.027,NULL,60224528828,941008262,14703254,17.9),(82119,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82119,34.28,0.69,71.8,33068,100,NULL,'mid-IR','NGC 3728',NULL,'2013ApJ...771...88L',2013,1,1.39,NULL,'G',0.000013,NULL,'13.9g',0.89,'Sb',NULL,NULL,NULL,NULL,1,173.31575,24.44689,0,NULL,60570254008,946410218,14787659,13.9),(82120,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82120,35.01,0.47,101,33068,NULL,NULL,'H','NGC 3728',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82121,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82121,35.11,0.45,105,33068,NULL,NULL,'K','NGC 3728',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82122,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82122,35.11,0.46,105,33068,NULL,NULL,'J','NGC 3728',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82123,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82123,35.14,0.4,107,33068,NULL,NULL,'mean','NGC 3728',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82124,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82124,34.93,0.46,96.7,33069,70,NULL,NULL,'CGCG 126-088',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000163,NULL,'15.4g',0.46,NULL,NULL,NULL,NULL,NULL,1,173.31925,25.24342,0,NULL,60589236290,946706817,14792294,15.4),(82125,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82125,37.77,0.19,358,33070,70,NULL,NULL,'SDSS J113317.02+062710.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000132,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,173.320958333,6.453,0.118,NULL,60385180812,943518450,14742475,18.2),(82126,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82126,38.12,0.46,420,33071,70,NULL,NULL,'2MASX J11331736+3855253',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000177,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,173.3224583,38.92372,0.034,NULL,60459987918,944687311,14760739,17.1),(82127,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82127,38.02,0.33,401,33072,70,NULL,NULL,'2MASX J11331842+0208056',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000098,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,173.326625,2.13483,0.061,NULL,60176565244,940258831,14691544,17.3),(82128,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82128,36.01,0.46,159,33073,70,NULL,NULL,'2MASX J11331978+4950149',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000146,NULL,'17.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,173.332416667,49.83744,0,NULL,61796463147,965569736,15087027,17),(82129,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82129,37.84,0.46,370,33074,70,NULL,NULL,'SDSS J113320.45+114435.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000166,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,173.33525,11.74325,0.063,NULL,60218346724,940911667,14701744,18.4),(82130,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82130,31.08,0.43,16.5,33075,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06534',NULL,'2014MNRAS.444..527S',2014,1,2.52,'The SDSS position is 5.2 arcsec southwest of the center.','G',0.000037,NULL,'13.8g',0.58,'Scd(f)','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,173.336625,63.28014,0.061,NULL,61863235443,966613053,15103328,13.8),(82131,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82131,31.1,0.43,16.6,33075,75,NULL,'3.6 micron, color corrected','UGC 06534',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82132,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82132,31.11,0.2,16.7,33075,74.4,NULL,NULL,'UGC 06534',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82133,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82133,31.38,0.49,18.9,33075,NULL,NULL,NULL,'UGC 06534',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82134,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82134,31.43,0.48,19.4,33075,NULL,NULL,'Malmquist cor.','UGC 06534',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82135,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82135,31.68,0.4,21.6,33075,75,NULL,NULL,'UGC 06534',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82136,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82136,31.74,0.49,22.2,33075,75,NULL,'IR','UGC 06534',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82137,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82137,31.81,0.4,23,33075,75,NULL,'B','UGC 06534',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82138,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82138,38.68,0.46,545,33076,70,NULL,NULL,'SDSS J113320.86+042109.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,173.3369583,4.35269,0.009,NULL,60171992969,940187390,14690427,18.3),(82139,'Ring Diameter','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82139,30.4,0.98,12,33077,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3726',NULL,'1981ApJS...45..541P',1981,1,6.2,'The Bologna position is 7 arcsec southwest of the center.','G',0.000003,NULL,'10.91',4.3,'SAB(r)c        HII','Isolated galaxy',NULL,NULL,NULL,1,173.338,47.02919,0.008,NULL,63894259400,998347803,15599184,10.91),(82140,'Ring Diameter','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82140,31,0.76,16,33077,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3726',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82141,'IRAS','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82141,31.06,0.8,16.3,33077,75,NULL,'A82, H','NGC 3726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82142,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82142,29.33,0.69,7.35,33077,100,NULL,'mid-IR','NGC 3726',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82143,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82143,30.57,0.43,13,33077,75,NULL,'3.6 micron, color corrected','NGC 3726',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82144,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82144,30.56,0.43,13,33077,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3726',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82145,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82145,30.63,0.2,13.4,33077,74.4,NULL,NULL,'NGC 3726',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82146,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82146,30.65,NULL,13.5,33077,NULL,NULL,'B','NGC 3726',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82147,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82147,30.72,0.35,13.9,33077,NULL,NULL,NULL,'NGC 3726',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82148,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82148,30.82,NULL,14.6,33077,NULL,NULL,'I','NGC 3726',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82149,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82149,30.84,NULL,14.7,33077,NULL,NULL,'I','NGC 3726',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82150,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82150,30.83,NULL,14.7,33077,NULL,NULL,'LEDA [Nov 2006]','NGC 3726',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82151,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82151,30.88,NULL,15,33077,NULL,NULL,'I','NGC 3726',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82152,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82152,30.88,0.47,15,33077,NULL,NULL,'H','NGC 3726',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82153,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82153,30.93,0.46,15.3,33077,NULL,NULL,'J','NGC 3726',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82154,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82154,30.94,0.45,15.4,33077,NULL,NULL,'K','NGC 3726',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82155,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82155,30.94,NULL,15.4,33077,NULL,NULL,'B','NGC 3726',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82156,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82156,30.96,NULL,15.6,33077,NULL,NULL,'I, Hubble-type-TF','NGC 3726',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82157,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82157,30.98,0.08,15.7,33077,NULL,NULL,NULL,'NGC 3726',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82158,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82158,31.02,NULL,16,33077,NULL,NULL,'B, Hubble-type-TF','NGC 3726',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82159,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82159,31.05,NULL,16.2,33077,NULL,NULL,'B','NGC 3726',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82160,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82160,31.15,0.4,17,33077,75,NULL,'B','NGC 3726',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82161,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82161,31.19,0.4,17.3,33077,NULL,NULL,'mean','NGC 3726',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82162,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82162,31.48,0.47,19.8,33077,75,NULL,'A82, H, raw','NGC 3726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82163,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82163,31.6,0.47,20.9,33077,75,NULL,'A82, H, inv','NGC 3726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82164,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82164,31.69,0.47,21.8,33077,75,NULL,'A82, H, cor','NGC 3726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82165,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82165,37.91,0.23,381,33078,70,NULL,NULL,'2MASX J11332152+0647309',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000174,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,173.339583,6.79178,0.123,NULL,60385221694,943519088,14742485,18.1),(82166,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82166,37.76,0.07,357,33079,70,NULL,NULL,'2MASX J11332177+1422146',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00022,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,173.340666667,14.37056,0.036,NULL,60224776085,941012126,14703314,16.9),(82167,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82167,36.9,0.46,240,33080,70,NULL,NULL,'2MASX J11332191+6806114',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000092,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,173.3414583,68.10322,0,NULL,62078957366,969983708,15155995,16.8),(82168,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82168,35.73,0.12,140,33081,NULL,NULL,NULL,'2MASX J11332304+4902169',NULL,'2009ApJS..182..474S',2009,1,0.66,NULL,'G',0.00003,NULL,'16.7g',0.19,'Sc','Group member',NULL,NULL,NULL,1,173.345958333,49.03806,0,NULL,61752204315,964878192,15076221,16.7),(82169,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82169,38.03,0.46,404,33082,70,NULL,NULL,'2MASX J11332320+0515586',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000183,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,173.346708333,5.26631,0.057,NULL,60352850969,943013296,14734582,17.2),(82170,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82170,38.72,0.46,556,33083,70,NULL,NULL,'2MASX J11332325+2111133',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,173.346875,21.187,0,NULL,61130348207,955161690,14924401,NULL),(82171,'Tully est','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82171,32.3,0.8,28.9,33084,75,NULL,NULL,'UGCA 239',NULL,'1988NBGC.C....0000T',1988,1,0.41,NULL,'G',0.00024,NULL,'15.7g',0.34,'Pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,173.347791667,55.07225,0,NULL,61764167360,965065115,15079142,15.7),(82172,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82172,37.89,0.46,379,33085,70,NULL,NULL,'2MASX J11332364+2751535',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,173.3487083,27.86486,0,NULL,60582839219,946606862,14790732,17.2),(82173,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82173,34.54,0.2,80.9,33086,74.4,NULL,NULL,'UGC 06539',NULL,'2013AJ....146...86T',2013,1,1.46,'HOLM 262C is a star.','G',0.000033,NULL,'14.8g',0.41,'Sbc','Pair member (points to parent)',NULL,NULL,NULL,1,173.3504583,32.60281,0.016,NULL,60622284001,947223187,14800362,14.8),(82174,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82174,34.68,0.3,86.2,33086,NULL,NULL,NULL,'UGC 06539',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82175,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82175,34.85,0.27,93.3,33086,NULL,NULL,'Malmquist cor.','UGC 06539',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82176,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82176,38.05,0.46,406,33087,70,NULL,NULL,'2MASX J11332470+4158359',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000173,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,173.352833,41.9765,0.014,NULL,63899924222,998436315,15600567,17.9),(82177,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82177,37.76,0.07,357,33088,70,NULL,NULL,'2MASX J11332521+1357206',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000138,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,173.355041667,13.95558,0.027,NULL,60226096553,941032758,14703636,17.9),(82178,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82178,35.01,NULL,100,33089,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1270',NULL,'2010Ap&SS.325..163P',2010,1,0.67,NULL,'G',0.000018,NULL,'17.2g',0.12,'Sc',NULL,NULL,NULL,NULL,1,173.355875,9.98328,0.096,NULL,60389202173,943581283,14743457,17.2),(82179,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82179,35.03,NULL,101,33089,NULL,NULL,'Dipole + Quadrupole','FGC 1270',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82180,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82180,35.05,NULL,102,33089,NULL,NULL,'Dipole','FGC 1270',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82181,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82181,35.07,NULL,103,33089,NULL,NULL,NULL,'FGC 1270',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82182,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82182,35.29,0.2,114,33089,74.4,NULL,NULL,'FGC 1270',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82183,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82183,35.03,0.59,102,33090,NULL,NULL,'Malmquist cor.','2MASX J11332609-0417268',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000033,NULL,'17.15',0.19,NULL,NULL,NULL,NULL,NULL,1,173.3587083,-4.29075,0.125,NULL,40823833905,637872404,9966756,17.15),(82184,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82184,35.06,0.58,103,33090,NULL,NULL,NULL,'2MASX J11332609-0417268',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82185,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82185,35.1,0.2,105,33090,74.4,NULL,NULL,'2MASX J11332609-0417268',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82186,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82186,38.34,0.46,466,33091,70,NULL,NULL,'2MASX J11332624-0035148',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000082,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,173.359208333,-0.58739,0.057,NULL,40831199585,637987493,9968554,18),(82187,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82187,37.28,0.46,286,33092,70,NULL,NULL,'SDSS J113326.44+103123.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000133,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,173.3602083,10.52333,0.093,NULL,60385842431,943528787,14742637,18.2),(82188,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82188,37.17,0.12,272,33093,70,NULL,NULL,'2MASX J11332643+5548025',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000133,NULL,'17.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,173.360291667,55.80078,0,NULL,61984597240,968509331,15132958,17.5),(82189,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82189,38.11,0.46,419,33094,70,NULL,NULL,'SDSS J113326.51+010217.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000076,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,173.3605,1.03808,0.045,NULL,60171422488,940178476,14690288,18.2),(82190,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82190,35.89,0.46,151,33095,70,NULL,NULL,'2MASX J11332691+2856225',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000173,NULL,'15.5g',0.52,'SBb',NULL,NULL,NULL,NULL,1,173.362125,28.93964,0,NULL,60582566206,946602596,14790665,15.5),(82191,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82191,37.31,0.33,290,33096,70,NULL,NULL,'2MASX J11332835+4125354',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000142,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,173.368333,41.42664,0,NULL,63896331314,998380176,15599690,17.7),(82192,'Brightest Stars','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82192,27.73,0.4,3.52,33097,NULL,NULL,'3B + 3R mean','UGC 06541',NULL,'1997AstL...23..514G',1997,1,NULL,'Multiple SDSS entries describe this object.','GPair',0.000002,NULL,NULL,NULL,'Irr+Comp;WR    HII','in a pair',NULL,NULL,NULL,1,173.370417,49.23722,0,NULL,61751999573,964874993,15076171,NULL),(82193,'Brightest Stars','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82193,28.04,NULL,4.06,33097,NULL,NULL,'LF','UGC 06541',NULL,'1997AstL...23..514G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82194,'TRGB','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82194,27.86,0.1,3.73,33097,NULL,NULL,NULL,'UGC 06541',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82195,'TRGB','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82195,27.95,0.29,3.89,33097,NULL,NULL,NULL,'UGC 06541',NULL,'2003A&A...398..467K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82196,'TRGB','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82196,28.12,0.24,4.2,33097,NULL,NULL,NULL,'UGC 06541',NULL,'2000AJ....120.1713S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82197,'TRGB','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82197,28.12,0.1,4.2,33097,NULL,NULL,NULL,'UGC 06541',NULL,'2014A&A...566A..71L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82198,'TRGB','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82198,28.12,0.13,4.21,33097,NULL,NULL,'I','UGC 06541',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82199,'TRGB','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82199,28.13,0.1,4.23,33097,74.4,NULL,NULL,'UGC 06541',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82200,'TRGB','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82200,28.15,0.12,4.26,33097,NULL,NULL,NULL,'UGC 06541',NULL,'2013AstBu..68..125M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82201,'TRGB','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82201,28.16,0.14,4.29,33097,NULL,NULL,NULL,'UGC 06541',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82202,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82202,28.01,0.4,4,33097,75,NULL,'B','UGC 06541',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82203,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82203,36.55,0.27,205,33098,70,NULL,NULL,'2MASX J11332904+6243145',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000179,NULL,'15.6g',0.42,'E0',NULL,NULL,NULL,NULL,1,173.371417,62.72061,0.025,NULL,61870717160,966729955,15105155,15.6),(82204,'IRAS','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82204,31.92,0.8,24.2,33099,75,NULL,'MAT, I','ESO 503- G 022',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00003,NULL,'14.76',0.6,'IB(s)m: pec',NULL,NULL,NULL,NULL,1,173.371875,-26.94578,0.225,NULL,41459522304,647805036,10121953,14.76),(82205,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82205,31.06,0.32,16.3,33099,85,NULL,'I, inv','ESO 503- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82206,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82206,31.13,0.32,16.8,33099,85,NULL,'I, raw','ESO 503- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82207,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82207,31.63,0.43,21.2,33099,75,NULL,'MAT, I, inv','ESO 503- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82208,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82208,31.75,0.43,22.4,33099,75,NULL,'MAT, I, raw','ESO 503- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82209,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82209,31.85,0.4,23.4,33099,NULL,NULL,NULL,'ESO 503- G 022',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82210,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82210,31.98,0.43,24.9,33099,75,NULL,'MAT, I, cor','ESO 503- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82211,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82211,35.7,0.46,138,33100,70,NULL,NULL,'CGCG 126-089',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'15.3',0.2,NULL,NULL,NULL,NULL,NULL,1,173.3752917,22.45586,0,NULL,61128648088,955135126,14923986,15.3),(82212,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82212,38.08,0.46,412,33101,70,NULL,NULL,'2MASX J11333029+2211544',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,173.3762917,22.1985,0,NULL,61128418009,955131531,14923930,17.8),(82213,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82213,37.75,0.46,355,33102,70,NULL,NULL,'2MASX J11333059+0411327',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000186,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,173.377583,4.19239,0.017,NULL,60175313598,940239274,14691238,16.6),(82214,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82214,37.76,0.07,357,33103,70,NULL,NULL,'2MASX J11333081+1437383',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,173.3785,14.62736,0.027,NULL,60224933441,941014585,14703352,18),(82215,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82215,36.52,0.46,202,33104,70,NULL,NULL,'2MASX J11333103+0950479',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.41',0.23,NULL,NULL,NULL,NULL,NULL,1,173.37925,9.84669,0.093,NULL,60389339884,943583435,14743491,17.41),(82216,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82216,37.91,0.23,381,33105,70,NULL,NULL,'SDSS J113331.86+065153.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000127,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,173.3827917,6.86486,0.123,NULL,60385257291,943519645,14742494,18.6),(82217,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82217,38.01,0.46,400,33106,70,NULL,NULL,'SDSS J113332.52+095509.3',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000168,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,173.3855,9.91925,0.093,NULL,60389197909,943581217,14743456,18.6),(82218,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82218,36.55,0.27,205,33107,70,NULL,NULL,'2MASX J11333291+6250175',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00018,NULL,'15.6g',0.53,'E0',NULL,NULL,NULL,NULL,1,173.38725,62.83806,0.025,NULL,61863138035,966611531,15103305,15.6),(82219,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82219,37.62,0.46,335,33108,70,NULL,NULL,'2MASX J11333335+0753399',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,173.389083333,7.89442,0.111,NULL,60396789313,943699833,14745309,NULL),(82220,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82220,36.01,0.46,159,33109,70,NULL,NULL,'2MASX J11333350+1444433',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000179,NULL,'15.4g',0.51,'S0(r)',NULL,NULL,NULL,NULL,1,173.389625,14.74544,0.031,NULL,60224729799,941011403,14703303,15.4),(82221,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82221,37.58,0.46,329,33110,70,NULL,NULL,'2MASX J11333468+5507286',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,173.3942083,55.12469,0,NULL,61764199176,965065612,15079150,17.7),(82222,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82222,37.34,0.23,294,33111,70,NULL,NULL,'2MASX J11333495+1806374',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,173.395583333,18.1105,0.014,NULL,61123965150,955061955,14922843,17.2),(82223,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82223,37.28,0.46,285,33112,70,NULL,NULL,'2MASXi J1133355+590825',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,173.3977917,59.1405,0,NULL,61851217501,966425273,15100394,17.5),(82224,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82224,37.05,0.46,258,33113,70,NULL,NULL,'2MASX J11333573+0834389',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000146,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,173.398833,8.5775,0.09,NULL,60388091255,943563925,14743186,16.9),(82225,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82225,36.89,0.46,239,33114,70,NULL,NULL,'2MASX J11333628+4336441',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,173.401083,43.61225,0.06,NULL,63898657701,998416526,15600258,17.2),(82226,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82226,38.08,0.46,412,33115,70,NULL,NULL,'SDSS J113336.36+003803.9',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000066,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,173.4015,0.63444,0.053,NULL,60170793060,940168641,14690135,17.8),(82227,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82227,36.15,0.6,170,33116,70,NULL,NULL,'2MASX J11333655-1132180',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.64',NULL,NULL,NULL,NULL,NULL,NULL,1,173.402416667,-11.53831,0.017,NULL,40978753198,640293018,10004578,16.64),(82228,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82228,37.91,0.23,381,33117,70,NULL,NULL,'2MASX J11333669+0652539',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000143,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,173.402917,6.88167,0.123,NULL,60385256780,943519637,14742494,17.7),(82229,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82229,38.08,0.46,413,33118,70,NULL,NULL,'2MASX J11333706+1149559',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000191,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,173.404583,11.83225,0.061,NULL,60218312223,940911128,14701736,17.1),(82230,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82230,37.31,0.33,290,33119,70,NULL,NULL,'SDSS J113337.54+412825.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000151,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,173.406417,41.47364,0,NULL,63896333516,998380211,15599690,18.5),(82231,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82231,33.81,0.49,57.7,33120,75,NULL,'IR','FGC 1272',NULL,'2011yCatp016004901K',2011,1,1.46,NULL,'G',0.000017,NULL,'16.0',0.12,'Sd',NULL,NULL,NULL,NULL,1,173.408583333,-15.77081,0.073,NULL,40974490250,640226410,10003537,16),(82232,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82232,34.09,0.2,65.8,33120,74.4,NULL,NULL,'FGC 1272',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82233,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82233,34.27,0.33,71.6,33120,NULL,NULL,NULL,'FGC 1272',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82234,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82234,34.38,0.32,75.2,33120,NULL,NULL,'Malmquist cor.','FGC 1272',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82235,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82235,34.43,NULL,76.7,33120,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1272',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82236,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82236,34.43,NULL,77.1,33120,NULL,NULL,'Dipole + Quadrupole','FGC 1272',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82237,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82237,34.45,NULL,77.5,33120,NULL,NULL,'Dipole','FGC 1272',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82238,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82238,34.48,NULL,78.8,33120,NULL,NULL,NULL,'FGC 1272',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82239,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82239,37.95,0.46,389,33121,70,NULL,NULL,'SDSS J113338.69+123821.7',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.00017,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,173.41125,12.63936,0.099,NULL,60221386541,940959164,14702486,18.8),(82240,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82240,37.68,0.46,343,33122,70,NULL,NULL,'2MASX J11333960+1236373',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,173.4150417,12.61042,0.089,NULL,60221384145,940959127,14702486,17.2),(82241,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82241,37.91,0.23,381,33123,70,NULL,NULL,'2MASX J11334045+0654049',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000158,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,173.418625,6.90144,0.123,NULL,60385258567,943519665,14742494,18.2),(82242,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82242,32.59,0.62,33,33124,NULL,NULL,NULL,'NGC 3725',NULL,'2009ApJS..182..474S',2009,1,1.38,NULL,'G',0.00003,NULL,'13.5g',1.02,'SBc            Sbrst','Isolated galaxy (6 Mpc isolation)',NULL,NULL,'Starburst',1,173.418875,61.888,0,NULL,61872342085,966755345,15105552,13.5),(82243,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82243,32.63,0.2,33.6,33124,74.4,NULL,NULL,'NGC 3725',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82244,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82244,32.64,0.61,33.7,33124,NULL,NULL,'Malmquist cor.','NGC 3725',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82245,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82245,33.13,0.47,42.3,33124,NULL,NULL,'H','NGC 3725',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82246,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82246,33.25,0.46,44.7,33124,NULL,NULL,'J','NGC 3725',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82247,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82247,33.26,0.45,44.9,33124,NULL,NULL,'K','NGC 3725',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82248,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82248,33.53,0.4,50.9,33124,NULL,NULL,'mean','NGC 3725',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82249,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82249,39.04,0.46,644,33125,70,NULL,NULL,'SDSS J113341.85+115600.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000157,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,173.424375,11.93342,0.061,NULL,60218433858,940913029,14701766,18.8),(82250,'IRAS','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82250,35.02,0.8,101,33126,75,NULL,'CF, r','UGC 06544',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000009,NULL,'14.85',0.6,'Sbc',NULL,NULL,NULL,NULL,1,173.425167,23.41272,0,NULL,60569950220,946405472,14787585,14.85),(82251,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82251,34.36,0.69,74.3,33126,100,NULL,'mid-IR','UGC 06544',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82252,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82252,34.61,0.2,83.6,33126,74.4,NULL,NULL,'UGC 06544',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82253,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82253,35.01,0.38,100,33126,75,NULL,'CF, r, raw','UGC 06544',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82254,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82254,35.18,0.4,108,33126,NULL,NULL,'mean','UGC 06544',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82255,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82255,35.18,0.38,108,33126,75,NULL,'CF, r, inv','UGC 06544',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82256,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82256,35.21,0.38,110,33126,75,NULL,'CF, r, cor','UGC 06544',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82257,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82257,35.48,0.47,125,33126,NULL,NULL,'H','UGC 06544',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82258,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82258,36.21,0.46,175,33127,70,NULL,NULL,'2MASX J11334272+3015559',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000169,NULL,'16.0g',0.38,NULL,NULL,NULL,NULL,NULL,1,173.428167,30.26544,0,NULL,60625148127,947267939,14801061,16),(82259,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82259,37.95,0.46,389,33128,70,NULL,NULL,'2MASX J11334323+0245156',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000066,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,173.430167,2.75417,0.041,NULL,60176133373,940252083,14691438,18),(82260,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82260,37.67,0.46,341,33129,70,NULL,NULL,'2MASX J11334325+3905004',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,173.430375,39.08325,0.045,NULL,60460722005,944698781,14760918,18),(82261,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82261,34.25,0.49,70.9,33130,75,NULL,'IR','UGC 06546',NULL,'2011yCatp016004901K',2011,1,1.57,NULL,'G',0.000033,NULL,'15.5g',0.23,'Scd',NULL,NULL,NULL,NULL,1,173.4327083,17.39625,0.021,NULL,61124469893,955069842,14922966,15.5),(82262,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82262,34.72,NULL,87.7,33130,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06546',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82263,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82263,34.73,NULL,88.2,33130,NULL,NULL,'Dipole + Quadrupole','UGC 06546',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82264,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82264,34.74,NULL,88.7,33130,NULL,NULL,'Dipole','UGC 06546',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82265,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82265,34.78,NULL,90.2,33130,NULL,NULL,NULL,'UGC 06546',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82266,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82266,36,0.2,158,33131,74.4,NULL,NULL,'IC 2930',NULL,'2013AJ....146...86T',2013,1,0.74,NULL,'G',0.000159,NULL,'15.7g',0.26,'Sbc(r)',NULL,NULL,NULL,NULL,1,173.433917,10.08867,0.097,NULL,60385729105,943527017,14742609,15.7),(82267,'SNIa','2016-12-15 15:14:48','2016-12-16 11:19:57','1','SN 1998M',NULL,82267,42.62,0.24,2050,33132,65,NULL,NULL,'H-ZSNS J113344.37+040513.4',0.63,'2004ApJ...607..665R',2004,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,173.434875,4.08706,0.021,NULL,60175339846,940239685,14691245,NULL),(82268,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82268,37.76,0.07,357,33133,70,NULL,NULL,'2MASX J11334452+1433553',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,173.435625,14.56533,0.038,NULL,60224810423,941012662,14703322,17.7),(82269,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82269,38.51,0.46,503,33134,70,NULL,NULL,'2MASX J11334460+4244181',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000176,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,173.436,42.73819,0,NULL,63900082519,998438789,15600606,18),(82270,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82270,38.28,0.46,453,33135,70,NULL,NULL,'SDSS J113344.76+264727.8',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00014,NULL,'17.9g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,173.436541667,26.79108,0,NULL,60583743754,946620996,14790953,17.9),(82271,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82271,37.68,0.46,344,33136,70,NULL,NULL,'2MASX J11334523+2252465',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,173.438583,22.87956,0,NULL,61127937718,955124026,14923812,17.6),(82272,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82272,32.41,0.43,30.4,33137,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 012-022',NULL,'2014MNRAS.444..527S',2014,1,1.11,NULL,'G',0.000003,NULL,'15.2g',0.65,'SAB(s)dm',NULL,NULL,NULL,NULL,1,173.438625,-3.437,0.129,NULL,40826499233,637914050,9967407,15.2),(82273,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82273,37.58,0.46,328,33138,70,NULL,NULL,'2MASX J11334559+1530333',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,173.4399583,15.50925,0.039,NULL,60225342790,941020981,14703452,18),(82274,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82274,38.24,0.46,444,33139,70,NULL,NULL,'2MASX J11334689+2308145',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.45',0.15,NULL,NULL,NULL,NULL,NULL,1,173.445375,23.13742,0,NULL,61127794926,955121795,14923778,18.45),(82275,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82275,35.98,0.33,157,33140,70,NULL,NULL,'2MASX J11334835+2027175',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000113,NULL,'16.59',0.22,NULL,NULL,NULL,NULL,NULL,1,173.4514583,20.455,0.017,NULL,61130133337,955158333,14924348,16.59),(82276,'Ring Diameter','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82276,31.5,0.84,20,33141,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3729',NULL,'1981ApJS...45..541P',1981,1,2.8,NULL,'G',0.000003,NULL,'12.03',1.9,'SB(r)a pec','Pair member (points to parent)',NULL,NULL,NULL,1,173.4555,53.12556,0,NULL,61793506796,965523543,15086305,12.03),(82277,'IRAS','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82277,31.57,0.8,20.6,33141,75,NULL,'W91CL, r','NGC 3729',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82278,'Tully est','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82278,31.15,0.8,17,33141,75,NULL,'B','NGC 3729',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82279,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82279,31.44,NULL,19.4,33141,NULL,NULL,'I, Hubble-type-TF','NGC 3729',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82280,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82280,31.52,0.38,20.1,33141,75,NULL,'W91CL, r, raw','NGC 3729',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82281,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82281,31.55,NULL,20.4,33141,NULL,NULL,'I','NGC 3729',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82282,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82282,31.6,NULL,20.9,33141,NULL,NULL,'B, Hubble-type-TF','NGC 3729',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82283,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82283,31.61,0.38,21,33141,75,NULL,'W91CL, r, inv','NGC 3729',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82284,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82284,31.62,0.35,21.1,33141,NULL,NULL,NULL,'NGC 3729',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82285,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82285,31.64,0.38,21.3,33141,75,NULL,'W91CL, r, cor','NGC 3729',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82286,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82286,31.7,NULL,21.9,33141,NULL,NULL,'LEDA [Nov 2006]','NGC 3729',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82287,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82287,31.8,NULL,22.9,33141,NULL,NULL,'B','NGC 3729',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82288,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82288,32.31,NULL,29,33142,NULL,NULL,NULL,'2MASX J11335011+1449313',NULL,'2015AstBu..70....1K',2015,1,0.35,NULL,'G',0.000107,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,173.458583333,14.8245,0.031,NULL,60224752793,941011762,14703308,16.9),(82289,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82289,38.01,0.46,399,33143,70,NULL,NULL,'SDSS J113351.09+032726.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00008,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,173.462875,3.45728,0.045,NULL,60174701782,940229715,14691089,18.4),(82290,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82290,37.61,0.46,333,33144,70,NULL,NULL,'SDSS J113351.15+070118.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000163,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,173.463167,7.02186,0.123,NULL,60384490503,943507664,14742307,18.3),(82291,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82291,38.05,0.46,406,33145,70,NULL,NULL,'2MASX J11335126+3437570',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000142,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,173.463917,34.63244,0.018,NULL,60620407200,947193862,14799904,17.7),(82292,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82292,37.76,0.07,357,33146,70,NULL,NULL,'2MASX J11335203+1432413',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000175,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,173.467,14.54489,0.038,NULL,60224819191,941012799,14703324,18),(82293,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82293,37.34,0.23,294,33147,70,NULL,NULL,'SDSS J113352.09+180432.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000183,NULL,'17.9g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,173.467083,18.07564,0.014,NULL,61123969986,955062031,14922844,17.9),(82294,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82294,37.57,0.46,327,33148,70,NULL,NULL,'2MASX J11335234+3920583',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,173.468041667,39.34961,0,NULL,60460885886,944701341,14760958,17.9),(82295,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82295,37.42,0.33,304,33149,70,NULL,NULL,'2MASX J11335302+2644227',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000164,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,173.471,26.73961,0,NULL,60583752068,946621126,14790955,17),(82296,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82296,37.15,0.46,269,33150,70,NULL,NULL,'2MASX J11335407+1645333',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000137,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,173.47525,16.75936,0.079,NULL,61107040099,954797501,14918710,17.5),(82297,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82297,34.16,NULL,68,33151,NULL,NULL,'Dipole','LSBC F571-08',NULL,'2010Ap&SS.325..163P',2010,1,2.03,NULL,'G',0.000107,NULL,'17.22',0.17,'Sc',NULL,NULL,NULL,NULL,1,173.479667,19.36003,0,NULL,61125521506,955086273,14923223,17.22),(82298,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82298,34.17,NULL,68.1,33151,NULL,NULL,'Dipole + Quadrupole','LSBC F571-08',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82299,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82299,34.18,NULL,68.6,33151,NULL,NULL,'Dipole + Quadrupole + Octopole','LSBC F571-08',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82300,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82300,34.99,0.43,99.4,33151,75,NULL,'3.6 micron, color + selection bias corrected','LSBC F571-08',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82301,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82301,37.87,0.46,374,33152,70,NULL,NULL,'2MASX J11335517+0242546',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000093,NULL,'17.0g',0.28,'AGN',NULL,NULL,NULL,NULL,1,173.479958333,2.71511,0.041,NULL,60176083294,940251301,14691426,17),(82302,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82302,38.01,0.46,400,33153,70,NULL,NULL,'SDSS J113355.49+541352.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,173.48125,54.23125,0,NULL,61764436895,965069326,15079208,18),(82303,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82303,38.09,0.46,415,33154,70,NULL,NULL,'2MASX J11335569+2655167',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,173.482125,26.92122,0,NULL,60584492588,946632696,14791135,17.6),(82304,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82304,37.92,0.33,383,33155,70,NULL,NULL,'SDSS J113355.91+253308.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.1g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,173.483,25.55242,0,NULL,60589747520,946714805,14792418,18.1),(82305,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82305,37.76,0.07,357,33156,70,NULL,NULL,'2MASX J11335592+1413403',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,173.483125,14.22767,0.036,NULL,60226085455,941032585,14703634,17.7),(82306,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82306,37.34,0.23,294,33157,70,NULL,NULL,'SDSS J113355.94+180105.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.6g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,173.483125,18.01808,0.006,NULL,61123942777,955061605,14922837,17.6),(82307,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82307,35.72,0.08,140,33158,NULL,NULL,NULL,'2MASX J11335627+4919532',NULL,'2009ApJS..182..474S',2009,1,0.48,NULL,'G',0.000033,NULL,'16.4g',0.26,'Sc','Group member',NULL,NULL,NULL,1,173.484417,49.33158,0,NULL,61750926037,964858219,15075909,16.4),(82308,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82308,37.1,0.14,263,33159,70,NULL,NULL,'2MASX J11335655+2122355',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.31',0.14,NULL,NULL,NULL,NULL,NULL,1,173.485625,21.37675,0,NULL,61130365054,955161953,14924405,18.31),(82309,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82309,37.29,0.46,287,33160,70,NULL,NULL,'2MASX J11335663+4810462',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000132,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,173.4859583,48.17958,0.03,NULL,61752246243,964878847,15076231,17.5),(82310,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82310,35.28,0.23,114,33161,70,NULL,NULL,'CGCG 268-052',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000093,NULL,'14.9g',0.6,'S0^-',NULL,NULL,NULL,NULL,1,173.487333,51.24978,0,NULL,61807040988,965735015,15089609,14.9),(82311,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82311,37.76,0.07,357,33162,70,NULL,NULL,'2MASX J11335759+1422032',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,173.4900417,14.36761,0.038,NULL,60224055655,941000869,14703138,17.7),(82312,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82312,37.34,0.23,294,33163,70,NULL,NULL,'2MASX J11335880+1804415',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000207,NULL,'17.80',0.17,NULL,NULL,NULL,NULL,NULL,1,173.494875,18.07825,0.006,NULL,61124059165,955063424,14922866,17.8),(82313,'Faber-Jackson','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82313,34.11,0.55,66.4,33164,95,NULL,'Weighted Mean','IC 0708',NULL,'1984ApJS...56...91D',1984,1,1.2,NULL,'G',0.000056,NULL,'14.0g',0.97,'E','in a pair',NULL,'radio jet',NULL,1,173.49675,49.06206,0,NULL,61752208934,964878264,15076222,14),(82314,'Faber-Jackson','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82314,34.11,0.55,66.4,33164,95,NULL,'de Vaucouleurs','IC 0708',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82315,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82315,35.35,0.25,117,33164,74.4,NULL,NULL,'IC 0708',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82316,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82316,36.02,0.11,160,33164,70,NULL,NULL,'IC 0708',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82317,'Tertiary','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82317,34.95,0.5,97.7,33164,95,NULL,NULL,'IC 0708',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82318,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82318,35.79,0.45,144,33164,NULL,NULL,'K','IC 0708',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82319,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82319,35.88,0.4,150,33164,NULL,NULL,'mean','IC 0708',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82320,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82320,37.57,0.23,326,33165,70,NULL,NULL,'2MASX J11340043+2142295',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,173.501708333,21.70828,0,NULL,61131196765,955174949,14924608,18),(82321,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82321,37.47,0.46,312,33166,70,NULL,NULL,'2MASX J11340076+1441357',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,173.503125,14.69331,0.037,NULL,60224960537,941015008,14703359,17.9),(82322,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82322,37.27,0.33,285,33167,70,NULL,NULL,'2MASX J11340097+0120596',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000093,NULL,'15.7g',0.52,'E0',NULL,NULL,NULL,NULL,1,173.50425,1.34989,0.041,NULL,60170573702,940165214,14690081,15.7),(82323,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82323,36.81,0.46,230,33168,70,NULL,NULL,'2MASX J11340202+5522267',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000206,NULL,'16.0g',0.38,'E0',NULL,NULL,NULL,NULL,1,173.508375,55.37417,0,NULL,61984612311,968509567,15132961,16),(82324,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82324,37.42,0.33,304,33169,70,NULL,NULL,'2MASX J11340220+2632247',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.0001,NULL,'15.7g',0.44,NULL,NULL,NULL,NULL,NULL,1,173.509083,26.54014,0,NULL,60583823114,946622236,14790972,15.7),(82325,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82325,37.76,0.07,357,33170,70,NULL,NULL,'2MASX J11340263+1410377',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000146,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,173.511083333,14.17722,0.036,NULL,60226132071,941033313,14703645,17.9),(82326,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82326,37.86,0.46,373,33171,70,NULL,NULL,'2MASX J11340471+0240135',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00009,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,173.519583,2.67033,0.037,NULL,60176604845,940259450,14691553,17),(82327,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82327,36.3,0.46,182,33172,70,NULL,NULL,'2MASX J11340509+1654547',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'17.31',0.32,NULL,NULL,NULL,NULL,NULL,1,173.521333,16.91525,0.079,NULL,61107062363,954797849,14918716,17.31),(82328,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82328,37.97,0.46,392,33173,70,NULL,NULL,'2MASX J11340555+0905051',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,173.523,9.08483,0.083,NULL,60388303599,943567243,14743238,17.5),(82329,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82329,36.38,0.75,189,33174,70,NULL,NULL,'2MASX J11340614-0901165',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,173.525667,-9.02122,0.049,NULL,41064118691,641626854,10025419,15),(82330,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82330,37.5,0.46,316,33175,70,NULL,NULL,'2MASX J11340695+1306307',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000154,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,173.5289583,13.10867,0.085,NULL,60219509626,940929837,14702028,17.9),(82331,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82331,34.44,NULL,77.2,33176,NULL,NULL,'Dipole + Quadrupole','UGC 06551',NULL,'2010Ap&SS.325..163P',2010,1,1.73,NULL,'G',0.000007,NULL,'15.8g',0.22,'Scd','Field galaxy',NULL,NULL,NULL,1,173.53175,36.68308,0,NULL,60452429569,944569212,14758893,15.8),(82332,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82332,34.44,NULL,77.4,33176,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06551',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82333,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82333,34.44,NULL,77.4,33176,NULL,NULL,NULL,'UGC 06551',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82334,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82334,34.45,NULL,77.5,33176,NULL,NULL,'Dipole','UGC 06551',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82335,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82335,34.97,0.39,98.7,33176,NULL,NULL,NULL,'UGC 06551',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82336,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82336,34.99,0.2,99.5,33176,74.4,NULL,NULL,'UGC 06551',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82337,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82337,35.21,0.35,110,33176,NULL,NULL,'Malmquist cor.','UGC 06551',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82338,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82338,37.75,0.46,354,33177,70,NULL,NULL,'2MASX J11340758+5154022',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,173.5317917,51.90061,0,NULL,61804454785,965694606,15088978,18.2),(82339,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82339,37.95,0.33,389,33178,70,NULL,NULL,'2MASX J11340776+4716131',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000141,NULL,'18.3g',0.14,'AGN',NULL,NULL,NULL,NULL,1,173.532083,47.27028,0.028,NULL,63894286520,998348226,15599191,18.3),(82340,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82340,37.63,0.46,336,33179,70,NULL,NULL,'2MASX J11340906+0233453',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000076,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,173.53775,2.56267,0.037,NULL,60176660609,940260322,14691567,17.8),(82341,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82341,37.91,0.46,382,33180,70,NULL,NULL,'2MASX J11341150+0546353',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,173.5479583,5.77656,0.065,NULL,60381797505,943465586,14741649,17.2),(82342,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82342,37.27,0.33,285,33181,70,NULL,NULL,'2MASX J11341157+0120113',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00008,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,173.54825,1.33642,0.045,NULL,60170581664,940165338,14690083,17.3),(82343,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82343,33.88,0.46,59.8,33182,70,NULL,NULL,'NGC 3731',NULL,'2015arXiv151105856S',2015,1,1.21,NULL,'G',0.000047,NULL,'14.1g',0.8,'E',NULL,NULL,NULL,NULL,1,173.548667,12.51231,0.089,NULL,60221497018,940960890,14702513,14.1),(82344,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82344,38.19,0.46,434,33183,70,NULL,NULL,'LCRS B113139.2-030555',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,173.552541667,-3.37458,0.113,NULL,40824549489,637883585,9966931,18.1),(82345,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82345,37.57,0.23,326,33184,70,NULL,NULL,'2MASX J11341342+2140031',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000107,NULL,'17.38',0.22,NULL,NULL,NULL,NULL,NULL,1,173.555875,21.66739,0,NULL,61130148681,955158573,14924352,17.38),(82346,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82346,36.62,0.46,211,33185,70,NULL,NULL,'2MASX J11341364-0030053',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000071,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,173.55675,-0.50158,0.053,NULL,40827744856,637933513,9967711,17.3),(82347,'Tully est','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82347,32.15,0.8,26.9,33186,75,NULL,'B','NGC 3732',NULL,'1988NBGC.C....0000T',1988,1,1.2,NULL,'G',0.000017,NULL,'13.32',1.2,'SAB(s)0/a:     HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,173.558083,-9.84567,0.033,NULL,41066101028,641657828,10025903,13.32),(82348,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82348,37.57,0.23,326,33187,70,NULL,NULL,'2MASX J11341414+2142321',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.30',0.14,NULL,NULL,NULL,NULL,NULL,1,173.558916667,21.709,0,NULL,61130149221,955158581,14924352,18.3),(82349,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82349,35.49,0.25,125,33188,74.4,NULL,NULL,'IC 0709',NULL,'2013AJ....146...86T',2013,1,0.83,NULL,'G',0.000053,NULL,'14.8g',0.74,'E?','Group member',NULL,NULL,NULL,1,173.560583,49.04317,0,NULL,61752205338,964878208,15076222,14.8),(82350,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82350,36.02,0.11,160,33188,70,NULL,NULL,'IC 0709',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82351,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82351,37.95,0.33,389,33189,70,NULL,NULL,'SDSS J113414.75+471649.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,173.5614583,47.28042,0.028,NULL,63894287082,998348235,15599191,18.2),(82352,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82352,36.02,0.11,160,33190,70,NULL,NULL,'2MASX J11341619+4900142',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000156,NULL,'16.3g',0.29,NULL,'Group member',NULL,NULL,NULL,1,173.5675,49.004,0,NULL,61752152617,964877384,15076209,16.3),(82353,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82353,38.18,0.33,432,33191,70,NULL,NULL,'SDSS J113416.48+172904.9',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.3r',0.22,NULL,NULL,NULL,NULL,NULL,1,173.568708333,17.48472,0.016,NULL,61123789792,955059215,14922800,16.3),(82354,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82354,37.1,0.14,263,33192,70,NULL,NULL,'2MASX J11341819+2116000',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000097,NULL,'16.26',0.3,NULL,NULL,NULL,NULL,NULL,1,173.575916667,21.26675,0,NULL,61130307065,955161047,14924391,16.26),(82355,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82355,37.96,0.23,390,33193,70,NULL,NULL,'2MASX J11341895+5657008',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,173.579041667,56.95022,0,NULL,61990991677,968609244,15134519,17.9),(82356,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82356,37.99,0.46,397,33194,70,NULL,NULL,'2MASX J11341946+3851243',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000183,NULL,'17.2g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,173.581083333,38.85686,0.034,NULL,60459994706,944687417,14760740,17.2),(82357,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82357,30.23,NULL,11.1,33195,NULL,NULL,NULL,'IC 2934',NULL,'2015AstBu..70....1K',2015,1,0.77,NULL,'G',0.000031,NULL,'15.4g',0.42,'Sb','Isolated galaxy',NULL,NULL,NULL,1,173.5814583,13.322,0.053,NULL,60219712772,940933012,14702078,15.4),(82358,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82358,35.41,0.56,121,33196,70,NULL,NULL,'2MASX J11341989-0910385',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,173.5829583,-9.17744,0.033,NULL,41064130569,641627040,10025422,15.4),(82359,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82359,36.73,0.46,222,33197,70,NULL,NULL,'2MASX J11342006+1317425',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000121,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,173.58375,13.29503,0.053,NULL,60219716935,940933077,14702079,18.2),(82360,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82360,33.94,0.49,61.5,33198,75,NULL,'IR','MCG -01-30-002',NULL,'2011yCatp016004901K',2011,1,1.94,NULL,'G',0.000013,NULL,'14.52',0.24,'SAc: sp        HII?',NULL,NULL,NULL,NULL,1,173.5839583,-6.38978,0.077,NULL,41054502963,641476608,10023072,14.52),(82361,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82361,34.15,0.2,67.6,33198,74.4,NULL,NULL,'MCG -01-30-002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82362,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82362,34.3,0.47,72.6,33198,NULL,NULL,'H','MCG -01-30-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82363,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82363,34.32,0.31,73,33198,NULL,NULL,NULL,'MCG -01-30-002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82364,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82364,34.33,NULL,73.3,33198,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -01-30-002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82365,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82365,34.35,NULL,74,33198,NULL,NULL,'Dipole + Quadrupole','MCG -01-30-002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82366,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82366,34.36,NULL,74.4,33198,NULL,NULL,'Dipole','MCG -01-30-002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82367,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82367,34.39,0.4,75.5,33198,NULL,NULL,'mean','MCG -01-30-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82368,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82368,34.41,0.45,76,33198,NULL,NULL,'K','MCG -01-30-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82369,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82369,34.41,0.3,76.4,33198,NULL,NULL,'Malmquist cor.','MCG -01-30-002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82370,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82370,34.48,0.46,78.6,33198,NULL,NULL,'J','MCG -01-30-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82371,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82371,36.22,0.33,175,33199,70,NULL,NULL,'2MASX J11342047+0018564',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000116,NULL,'16.3g',0.35,'AGN',NULL,NULL,NULL,NULL,1,173.585417,0.31567,0.057,NULL,60168013115,940125204,14689456,16.3),(82372,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82372,38.2,0.46,437,33200,70,NULL,NULL,'2MASX J11342123+0713309',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,173.5885417,7.22531,0.091,NULL,60383049435,943485147,14741955,17.8),(82373,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82373,38.07,0.46,411,33201,70,NULL,NULL,'2MASX J11342128+0414064',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000177,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,173.5887917,4.23531,0.021,NULL,60175286548,940238852,14691232,17.7),(82374,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82374,37.68,0.23,344,33202,70,NULL,NULL,'2MASX J11342469+1823080',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000117,NULL,'17.15',0.21,NULL,NULL,NULL,NULL,NULL,1,173.6030417,18.38567,0,NULL,61123880937,955060639,14922822,17.15),(82375,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82375,37.35,0.46,296,33203,70,NULL,NULL,'SDSS J113425.13+110649.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000149,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,173.60475,11.11381,0.075,NULL,60339459626,942804056,14731313,18.3),(82376,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82376,38.37,0.46,473,33204,70,NULL,NULL,'SDSS J113425.57+635102.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000065,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,173.606625,63.85083,0.065,NULL,61862876838,966607450,15103241,18),(82377,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82377,35.6,0.07,132,33205,NULL,NULL,NULL,'2MASX J11342606+4924482',NULL,'2009ApJS..182..474S',2009,1,0.32,NULL,'G',0.00003,NULL,'16.9g',0.21,'Sc','Group member',NULL,NULL,NULL,1,173.608583,49.41344,0,NULL,61751121623,964861275,15075957,16.9),(82378,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82378,37.44,0.46,307,33206,70,NULL,NULL,'2MASX J11342623+5411379',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00019,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,173.6092917,54.19403,0,NULL,61764438163,965069346,15079208,17.3),(82379,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82379,37.61,0.46,333,33207,70,NULL,NULL,'2MASX J11342631+6644463',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000066,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,173.609875,66.74608,0,NULL,61808574279,965758973,15089983,17.7),(82380,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82380,37.78,0.46,360,33208,70,NULL,NULL,'LCRS B113152.9-022308',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,173.6099583,-2.66172,0.077,NULL,40832409297,638006395,9968849,18.1),(82381,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82381,36.57,0.46,207,33209,70,NULL,NULL,'2MASX J11342701+1229355',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000142,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,173.612541667,12.49328,0.089,NULL,60221514211,940961159,14702518,17.5),(82382,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82382,36.6,0.46,209,33210,70,NULL,NULL,'2MASX J11342775+5943399',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,173.615333,59.72789,0,NULL,61850575115,966415236,15100238,16.8),(82383,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82383,37.17,0.12,272,33211,70,NULL,NULL,'2MASX J11342773+5611549',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000177,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,173.615458333,56.1985,0,NULL,61989542721,968586605,15134165,16.2),(82384,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82384,36.02,0.11,160,33212,70,NULL,NULL,'2MASX J11342797+4857482',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000156,NULL,'16.6g',0.2,NULL,'Group member',NULL,NULL,NULL,1,173.616625,48.96342,0,NULL,61752125317,964876958,15076202,16.6),(82385,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82385,37.42,0.46,305,33213,70,NULL,NULL,'2MASX J11342806+2238170',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,173.616875,22.638,0,NULL,61074187432,954284178,14910690,17.3),(82386,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82386,38.18,0.33,432,33214,70,NULL,NULL,'2MASX J11342820+1727596',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.62',0.13,NULL,NULL,NULL,NULL,NULL,1,173.6175,17.46669,0.016,NULL,61123791438,955059241,14922800,18.62),(82387,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82387,35.67,0.07,136,33215,NULL,NULL,NULL,'MCG +08-21-059',NULL,'2009ApJS..182..474S',2009,1,0.53,NULL,'G',0.000033,NULL,'16.2g',0.32,'Sbc','Group member',NULL,NULL,NULL,1,173.6212917,48.951,0,NULL,61752128686,964877010,15076203,16.2),(82388,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82388,33.54,0.49,51.1,33216,70,NULL,NULL,'2MASX J11342940-5014138',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000107,NULL,'15.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,173.6225417,-50.23717,0.589,NULL,40058601204,625915643,9779931,15.1),(82389,'GRB','2016-12-15 15:14:48','2016-12-16 11:19:57','1','SN 2001ke','R',82389,41.35,1.08,998,33217,73,NULL,'H const./H=100','SN 2001ke',0.362,'2006astro.ph..9262M',2006,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'SAX/WFC',NULL,NULL,NULL,NULL,1,173.6235,-76.02819,0.421,NULL,39845165424,622580709,9727823,NULL),(82390,'GRB','2016-12-15 15:14:48','2016-12-16 11:19:57','1','SN 2001ke','R',82390,41.23,0.17,1290,33217,73,NULL,'H const./H=100','SN 2001ke',0.362,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82391,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82391,36.89,0.46,239,33218,70,NULL,NULL,'2MASX J11342978+1809560',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.16',0.16,NULL,NULL,NULL,NULL,NULL,1,173.6242083,18.16561,0.006,NULL,61124114967,955064296,14922879,18.16),(82392,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82392,37.57,0.23,326,33219,70,NULL,NULL,'2MASX J11343064+2142470',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,173.627667,21.71297,0,NULL,61074836498,954294320,14910848,17.9),(82393,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82393,37.92,0.33,383,33220,70,NULL,NULL,'2MASX J11343186+2536330',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,173.632833,25.609,0,NULL,60589781909,946715342,14792427,17.4),(82394,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82394,37.74,0.46,353,33221,70,NULL,NULL,'SDSS J113432.12+540343.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,173.633875,54.06217,0,NULL,61764457744,965069652,15079213,18.4),(82395,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82395,37.68,0.23,344,33222,70,NULL,NULL,'2MASX J11343222+1825047',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000161,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,173.634166667,18.41794,0,NULL,61123879255,955060613,14922822,18.1),(82396,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82396,36.02,0.11,160,33223,70,NULL,NULL,'2MASX J11343300+4906051',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000153,NULL,'16.4g',0.33,NULL,'Group member',NULL,NULL,NULL,1,173.637375,49.10156,0,NULL,61752113413,964876772,15076199,16.4),(82397,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82397,36.48,0.6,198,33224,70,NULL,NULL,'2MASX J11343333-5052158',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,173.639083333,-50.87106,0.653,NULL,40060174450,625940225,9780316,17),(82398,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82398,37.9,0.46,381,33225,70,NULL,NULL,'2MASX J11343392+5817549',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000186,NULL,'16.5g',0.38,'AGN',NULL,NULL,NULL,NULL,1,173.641458333,58.29861,0,NULL,61989735492,968589617,15134212,16.5),(82399,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82399,38.01,0.46,400,33226,70,NULL,NULL,'2MASX J11343479+0620359',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000182,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,173.644917,6.34342,0.099,NULL,60382000909,943468764,14741699,16.8),(82400,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82400,35.98,0.33,157,33227,70,NULL,NULL,'CGCG 126-097',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000137,NULL,'15.5',0.32,'E-S0',NULL,NULL,NULL,NULL,1,173.6479583,20.36967,0.016,NULL,61129941641,955155338,14924302,15.5),(82401,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82401,37.68,0.23,344,33228,70,NULL,NULL,'2MASX J11343559+1823558',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,173.648417,18.39878,0,NULL,61123882458,955060663,14922822,16.8),(82402,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82402,37.87,0.46,375,33229,70,NULL,NULL,'SDSS J113436.41+115625.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000143,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,173.65175,11.94053,0.071,NULL,60218657743,940916527,14701820,18.7),(82403,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82403,37.75,0.46,355,33230,70,NULL,NULL,'2MASX J11344045+0533157',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,173.668375,5.55433,0.045,NULL,60351911042,942998610,14734353,17.8),(82404,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82404,37.76,0.07,357,33231,70,NULL,NULL,'2MASX J11344058+1400236',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'18.5g',0.09,NULL,NULL,NULL,NULL,NULL,1,173.669083333,14.00658,0.044,NULL,60226232259,941034879,14703669,18.5),(82405,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82405,38.14,0.46,424,33232,70,NULL,NULL,'2MASX J11344092+0431347',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000199,NULL,'16.3g',0.4,'AGN',NULL,NULL,NULL,NULL,1,173.670417,4.52633,0.029,NULL,60172320143,940192502,14690507,16.3),(82406,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82406,37.76,0.07,357,33233,70,NULL,NULL,'2MASX J11344202+1406506',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,173.675125,14.11394,0.044,NULL,60226252611,941035197,14703674,17.8),(82407,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82407,37.17,0.27,272,33234,70,NULL,NULL,'2MASX J11344212+2230198',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,173.675583,22.50544,0,NULL,61073662975,954275983,14910562,17.5),(82408,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82408,37.88,0.46,377,33235,70,NULL,NULL,'2MASX J11344272+0849189',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,173.678167,8.822,0.081,NULL,60388395038,943568672,14743260,17.9),(82409,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82409,38.83,0.46,584,33236,70,NULL,NULL,'2MASX J11344275+5520100',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,173.67825,55.33608,0,NULL,61763343101,965052235,15078941,18.1),(82410,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82410,34.76,0.53,89.5,33237,70,NULL,NULL,'2MASX J11344327-0931595',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000133,NULL,'15.28',NULL,NULL,NULL,NULL,NULL,NULL,1,173.680375,-9.53319,0.037,NULL,41066010498,641656414,10025881,15.28),(82411,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82411,36.79,0.46,228,33238,70,NULL,NULL,'2MASX J11344335+1213127',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000179,NULL,'16.2g',0.34,'E0',NULL,NULL,NULL,NULL,1,173.680541667,12.22019,0.071,NULL,60217971938,940905811,14701653,16.2),(82412,'FP','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,'R',82412,37.68,0.23,344,33239,70,NULL,NULL,'2MASXi J1134434+182402',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'17.7g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,173.681083,18.40067,0,NULL,61123913406,955061146,14922830,17.7),(82413,'IRAS','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82413,33.19,0.8,43.5,33240,75,NULL,'MAT, I','ESO 378- G 011',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000029,NULL,'15.18',0.2,'Sc: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,173.6815417,-37.21594,0.385,NULL,41390951843,646733622,10105212,15.18),(82414,'IRAS','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82414,33.21,0.8,43.8,33240,75,NULL,'A82, H','ESO 378- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82415,'IRAS','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82415,33.21,0.8,43.8,33240,75,NULL,'HMCL, I','ESO 378- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82416,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82416,32.94,0.32,38.8,33240,85,NULL,'I, raw','ESO 378- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82417,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82417,32.95,0.32,38.9,33240,85,NULL,'I, inv','ESO 378- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82418,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82418,33.17,0.43,43,33240,75,NULL,'MAT, I, raw','ESO 378- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82419,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82419,33.18,0.16,43.3,33240,NULL,NULL,NULL,'ESO 378- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82420,'Tully-Fisher','2016-12-15 15:14:48','2016-12-16 11:19:57','1',NULL,NULL,82420,33.21,0.2,43.9,33240,74.4,NULL,NULL,'ESO 378- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82421,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82421,33.25,0.43,44.7,33240,75,NULL,'MAT, I, inv','ESO 378- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82422,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82422,33.3,0.43,45.8,33240,75,NULL,'MAT, I, cor','ESO 378- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82423,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82423,33.4,0.49,47.9,33240,75,NULL,'IR','ESO 378- G 011',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82424,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82424,33.53,0.38,50.8,33240,NULL,NULL,NULL,'ESO 378- G 011',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82425,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82425,33.83,0.4,58.3,33240,75,NULL,'HMCL, I, raw','ESO 378- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82426,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82426,33.83,0.47,58.3,33240,75,NULL,'A82, H, raw','ESO 378- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82427,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82427,33.87,0.47,59.4,33240,75,NULL,'A82, H, inv','ESO 378- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82428,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82428,33.94,0.4,61.2,33240,75,NULL,'HMCL, I, inv','ESO 378- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82429,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82429,34.04,0.4,64.1,33240,75,NULL,'HMCL, I, cor','ESO 378- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82430,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82430,34.11,0.47,66.3,33240,75,NULL,'A82, H, cor','ESO 378- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82431,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82431,31.54,0.4,20.3,33241,75,NULL,NULL,'ESO 320- G 004',NULL,'2008Ap.....51..336K',2008,1,1.3,NULL,'G',0.000037,NULL,'14.63',0.5,'SB(s)c:',NULL,NULL,NULL,NULL,1,173.68175,-38.25092,0.425,NULL,41404538349,646945911,10108529,14.63),(82432,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82432,31.54,0.4,20.3,33241,73,NULL,'IR','ESO 320- G 004',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82433,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82433,32.13,0.49,26.7,33241,75,NULL,'IR','ESO 320- G 004',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82434,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82434,36.13,0.57,168,33242,70,NULL,NULL,'2MASX J11344576-1356085',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.77',NULL,NULL,NULL,NULL,NULL,NULL,1,173.690625,-13.93575,0.041,NULL,40982777246,640355894,10005560,15.77),(82435,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82435,36.02,0.11,160,33243,70,NULL,NULL,'IC 0711',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000063,NULL,'14.9g',0.64,'E?','Group member',NULL,'radio jet',NULL,1,173.694,48.95611,0,NULL,61752127812,964876997,15076203,14.9),(82436,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82436,37.98,0.46,395,33244,70,NULL,NULL,'SDSS J113446.66+110938.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000151,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,173.694417,11.16083,0.048,NULL,60339516659,942804947,14731327,18.4),(82437,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82437,37.17,0.27,272,33245,70,NULL,NULL,'SDSS J113446.66+222943.5',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',NULL,NULL,'15.5g',0.46,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,173.694417,22.49542,0,NULL,61073707942,954276686,14910573,15.5),(82438,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82438,37.1,0.14,263,33246,70,NULL,NULL,'2MASX J11344734+2101418',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,173.69725,21.02828,0,NULL,61074900498,954295320,14910864,17.3),(82439,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82439,37.76,0.46,356,33247,70,NULL,NULL,'SDSS J113447.40+500122.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.3g',0.1,NULL,NULL,NULL,NULL,NULL,1,173.6975417,50.02306,0,NULL,61796769772,965574527,15087101,18.3),(82440,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82440,35.96,0.46,155,33248,70,NULL,NULL,'CGCG 242-052',NULL,'2015arXiv151105856S',2015,1,0.99,NULL,'G',0.000153,NULL,'14.9g',0.41,'Sa',NULL,NULL,NULL,NULL,1,173.70125,46.98994,0,NULL,63894768745,998355761,15599308,14.9),(82441,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82441,37.36,0.46,296,33249,70,NULL,NULL,'SDSS J113448.66+080626.3',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000129,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,173.702791667,8.10733,0.091,NULL,60396062817,943688481,14745132,18.2),(82442,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82442,38.45,0.46,489,33250,70,NULL,NULL,'2MASX J11344895-0032274',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000081,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,173.703916667,-0.54106,0.053,NULL,40828195496,637940554,9967821,18.6),(82443,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82443,35.7,0.13,138,33251,70,NULL,'ABELL 1314, BGC','IC 0712',NULL,'1999AJ....118.1489D',1999,1,1.44,NULL,'G',0.000028,NULL,'14.2g',0.81,'S?;BrClG','Group member',NULL,NULL,NULL,1,173.705458333,49.07769,0,NULL,61752111344,964876739,15076199,14.2),(82444,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82444,35.88,0.4,150,33251,NULL,NULL,'mean','IC 0712',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82445,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82445,36.14,0.45,169,33251,NULL,NULL,'K','IC 0712',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82446,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82446,37.17,0.27,272,33252,70,NULL,NULL,'2MASX J11344933+2231217',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.34',0.15,NULL,NULL,NULL,NULL,NULL,1,173.705625,22.52272,0,NULL,61074182202,954284096,14910689,18.34),(82447,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82447,37.52,0.46,319,33253,70,NULL,NULL,'2MASX J11344949+6338572',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000076,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,173.7065417,63.64936,0.065,NULL,61863099128,966610923,15103295,17.5),(82448,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82448,35.7,0.13,138,33254,70,NULL,NULL,'ABELL 1314',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,173.710417,49.05778,0,NULL,61752133852,964877091,15076204,NULL),(82449,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82449,36.87,0.46,236,33255,70,NULL,NULL,'2MASX J11345113+5554229',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000182,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,173.713083,55.90636,0,NULL,61988827528,968575430,15133991,16.3),(82450,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82450,37.1,0.46,263,33256,70,NULL,NULL,'2MASX J11345163+0836299',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000151,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,173.7150417,8.60842,0.082,NULL,60387684286,943557566,14743086,16.9),(82451,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82451,38.67,0.46,543,33257,70,NULL,NULL,'2MASX J11345286+4746083',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000211,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,173.7204583,47.76911,0.019,NULL,63894405727,998350089,15599220,17.2),(82452,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82452,29.35,NULL,7.4,33258,NULL,NULL,NULL,'SDSS J113453.11+110116.2',NULL,'2015AstBu..70....1K',2015,1,0.25,NULL,'G',0.00001,NULL,'18.23',0.16,'Ir',NULL,NULL,NULL,NULL,1,173.7212917,11.02119,0.048,NULL,60339407973,942803249,14731300,18.23),(82453,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82453,36.63,0.59,212,33259,70,NULL,NULL,'2MASX J11345325-4201017',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,173.721917,-42.01714,0.373,NULL,41883579847,654430935,10225483,14.1),(82454,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82454,37.1,0.14,263,33260,70,NULL,NULL,'2MASX J11345356+2105227',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.0g',0.42,NULL,NULL,NULL,NULL,NULL,1,173.7232917,21.08975,0,NULL,61074913710,954295526,14910867,16),(82455,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82455,37.67,0.46,342,33261,70,NULL,NULL,'2MASX J11345367+0813239',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000166,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,173.7235417,8.22314,0.091,NULL,60396134776,943689605,14745150,16.4),(82456,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82456,37.21,0.27,277,33262,70,NULL,NULL,'2MASX J11345371+5132008',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000165,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,173.724167,51.53347,0,NULL,61807113860,965736154,15089627,17.2),(82457,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82457,36.19,0.51,173,33263,70,NULL,NULL,'2MASX J11345446-4321277',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.7I',0.5,NULL,NULL,NULL,NULL,NULL,1,173.727,-43.35764,0.293,NULL,41882794280,654418660,10225291,13.7),(82458,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82458,37.28,0.46,285,33264,70,NULL,NULL,'2MASX J11345464+3403205',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000173,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,173.727625,34.05581,0,NULL,60620938880,947202170,14800033,16.7),(82459,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82459,34.15,NULL,67.6,33265,NULL,NULL,'Dipole','UGC 06556',NULL,'2010Ap&SS.325..163P',2010,1,1.7,NULL,'G',0.000007,NULL,'15.8g',0.24,'Scd','Group non-member, foreground',NULL,NULL,NULL,1,173.73,16.116,0.055,NULL,60222707861,940979810,14702809,15.8),(82460,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82460,34.16,NULL,67.8,33265,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06556',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82461,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82461,34.16,NULL,67.9,33265,NULL,NULL,'Dipole + Quadrupole','UGC 06556',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82462,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82462,34.25,0.49,70.7,33265,75,NULL,'IR','UGC 06556',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82463,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82463,34.26,NULL,71,33265,NULL,NULL,NULL,'UGC 06556',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82464,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82464,34.45,0.48,77.5,33265,NULL,NULL,NULL,'UGC 06556',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82465,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82465,34.47,0.2,78.3,33265,74.4,NULL,NULL,'UGC 06556',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82466,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82466,34.63,0.44,84.4,33265,NULL,NULL,'Malmquist cor.','UGC 06556',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82467,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82467,37.43,0.46,307,33266,70,NULL,NULL,'2MASX J11345545+4203584',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,173.730875,42.06633,0.01,NULL,63899715326,998433051,15600516,17.7),(82468,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82468,37.44,0.46,307,33267,70,NULL,NULL,'2MASX J11345764+1303546',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000162,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,173.7402083,13.065,0.063,NULL,60219398423,940928100,14702001,16.9),(82469,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82469,37.99,0.46,396,33268,70,NULL,NULL,'SDSS J113457.78+272913.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000132,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,173.7407917,27.48714,0,NULL,60584257198,946629018,14791078,18.6),(82470,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82470,36.94,0.56,245,33269,70,NULL,NULL,'2MASX J11345787-2331369',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,173.7410417,-23.52683,0.129,NULL,41410393805,647037403,10109959,15.3),(82471,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82471,37.1,0.14,263,33270,70,NULL,NULL,'2MASX J11345920+2106547',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.02',0.16,NULL,NULL,NULL,NULL,NULL,1,173.746875,21.11528,0,NULL,61074906341,954295411,14910865,18.02),(82472,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82472,37.1,0.14,263,33271,70,NULL,NULL,'2MASX J11345984+2105467',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,173.749333,21.09619,0,NULL,61074906091,954295407,14910865,17.5),(82473,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82473,35.28,0.23,114,33272,70,NULL,NULL,'UGC 06555',NULL,'2015arXiv151105856S',2015,1,1.14,NULL,'G',0.000103,NULL,'14.1g',0.82,'S0-:',NULL,NULL,NULL,NULL,1,173.7500417,51.218,0,NULL,61807013981,965734593,15089603,14.1),(82474,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82474,37.23,0.46,279,33273,70,NULL,NULL,'2MASX J11350062+3501326',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000203,NULL,'16.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,173.7525,35.02583,0.051,NULL,60440964288,944390067,14756094,16.3),(82475,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82475,37.56,0.46,325,33274,70,NULL,NULL,'2MASX J11350149+5429018',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000136,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,173.7560417,54.48389,0,NULL,61764374533,965068352,15079193,17.7),(82476,'IRAS','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82476,31.65,0.8,21.3,33275,75,NULL,'A82, H','NGC 3733',NULL,'1997ApJS..109..333W',1997,1,4.8,NULL,'G',0.00002,NULL,'12.93',2.2,'SAB(s)cd:','in a radial-velocity based grouping',NULL,NULL,NULL,1,173.756667,54.8505,0,NULL,61764256210,965066503,15079164,12.93),(82477,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82477,31.67,0.4,21.6,33275,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 3733',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82478,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82478,31.72,0.4,22.1,33275,75,NULL,'B','NGC 3733',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82479,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82479,31.73,0.43,22.2,33275,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3733',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82480,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82480,32.13,0.47,26.7,33275,75,NULL,'A82, H, inv','NGC 3733',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82481,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82481,32.14,0.47,26.8,33275,75,NULL,'A82, H, raw','NGC 3733',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82482,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82482,32.47,0.47,31.2,33275,75,NULL,'A82, H, cor','NGC 3733',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82483,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82483,38.06,0.46,409,33276,70,NULL,NULL,'2MASX J11350175+1817211',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,173.7572083,18.28922,0,NULL,61123898587,955060915,14922826,17.4),(82484,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82484,37.92,0.46,383,33277,70,NULL,NULL,'2MASX J11350179+1532091',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,173.757541667,15.53592,0.043,NULL,60225289427,941020147,14703439,17.6),(82485,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82485,36.8,0.33,229,33278,70,NULL,NULL,'2MASX J11350202+4200224',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000169,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,173.758333,42.00625,0.006,NULL,63899727147,998433236,15600519,16.5),(82486,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82486,37.76,0.07,357,33279,70,NULL,NULL,'SDSS J113503.11+135954.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000161,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,173.7629583,13.99861,0.044,NULL,60226059379,941032177,14703627,18.5),(82487,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82487,36.31,0.46,183,33280,70,NULL,NULL,'2MASXi J1135060+420330',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,173.775333,42.05844,0.01,NULL,63899717412,998433084,15600516,17.3),(82488,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82488,36.02,0.11,160,33281,70,NULL,NULL,'2MASX J11350641+4903277',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000147,NULL,'17.5g',0.23,NULL,'Group member',NULL,NULL,NULL,1,173.7765,49.05775,0,NULL,61752141614,964877212,15076206,17.5),(82489,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82489,35.46,0.66,123,33282,70,NULL,NULL,'2MASX J11350673-5024160',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,173.7780417,-50.40453,0.589,NULL,40058306359,625911036,9779859,17.2),(82490,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82490,36.8,0.33,229,33283,70,NULL,NULL,'2MASX J11350749+4201014',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000172,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,173.781167,42.01703,0.006,NULL,63899716448,998433069,15600516,16.7),(82491,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82491,37.76,0.07,357,33284,70,NULL,NULL,'2MASX J11350781+1359091',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000187,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,173.782583333,13.98581,0.052,NULL,60226058419,941032162,14703627,16.9),(82492,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82492,34.24,NULL,70.4,33285,NULL,NULL,'Dipole + Quadrupole','UGC 06559',NULL,'2010Ap&SS.325..163P',2010,1,1.32,NULL,'G',0.000006,NULL,'16.1g',0.2,'Scd','Group non-member, foreground',NULL,NULL,NULL,1,173.7845417,15.95864,0.059,NULL,60222594814,940978043,14702781,16.1),(82493,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82493,34.24,NULL,70.5,33285,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06559',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82494,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82494,34.24,NULL,70.5,33285,NULL,NULL,'Dipole','UGC 06559',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82495,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82495,34.34,NULL,73.8,33285,NULL,NULL,NULL,'UGC 06559',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82496,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82496,34.8,0.49,91,33285,75,NULL,'IR','UGC 06559',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82497,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82497,34.94,0.36,97.4,33285,NULL,NULL,'Malmquist cor.','UGC 06559',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82498,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82498,35.05,0.2,102,33285,74.4,NULL,NULL,'UGC 06559',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82499,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82499,35.12,0.33,106,33285,NULL,NULL,NULL,'UGC 06559',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82500,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82500,37.1,0.14,263,33286,70,NULL,NULL,'2MASX J11350847+2109041',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,173.785375,21.15122,0,NULL,61074903340,954295364,14910865,17.2),(82501,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82501,37.46,0.46,310,33287,70,NULL,NULL,'2MASX J11350931+1200401',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,173.788833,12.01117,0.056,NULL,60218564020,940915062,14701797,17.4),(82502,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82502,38.11,0.33,418,33288,70,NULL,NULL,'LCRS B113235.9-024932',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000127,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,173.788917,-3.10194,0.113,NULL,40825177547,637893399,9967084,18.5),(82503,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82503,37.11,0.33,264,33289,70,NULL,NULL,'2MASX J11350953+5742296',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,173.789417,57.70831,0,NULL,61990631472,968603616,15134431,17.8),(82504,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82504,36.12,0.46,168,33290,70,NULL,NULL,'2MASX J11351102+2035052',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000123,NULL,'17.44',0.18,NULL,NULL,NULL,NULL,NULL,1,173.795916667,20.58472,0,NULL,61074528432,954289506,14910773,17.44),(82505,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82505,36.54,0.46,203,33291,70,NULL,NULL,'2MASX J11351159-0217356',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,173.798375,-2.29314,0.069,NULL,40831623751,637994121,9968658,16.2),(82506,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82506,37.92,0.46,384,33292,70,NULL,NULL,'2MASX J11351293+0317046',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000071,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,173.8040417,3.28456,0.033,NULL,60174609323,940228270,14691066,17.3),(82507,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82507,36.86,0.46,235,33293,70,NULL,NULL,'2MASX J11351315+5108107',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000164,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,173.804917,51.13636,0,NULL,61807004096,965734439,15089600,17.1),(82508,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82508,37.01,0.33,253,33294,70,NULL,NULL,'2MASX J11351315+4154374',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000197,NULL,'15.8g',0.49,'E0',NULL,NULL,NULL,NULL,1,173.8049583,41.91039,0.006,NULL,63899725457,998433210,15600518,15.8),(82509,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82509,37.53,0.46,321,33295,70,NULL,NULL,'2MASX J11351331+0543446',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000166,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,173.8055,5.72906,0.065,NULL,60381391961,943459249,14741550,16.8),(82510,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82510,35.28,0.23,114,33296,70,NULL,NULL,'CGCG 268-056',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00008,NULL,'15.4g',0.45,'E0',NULL,NULL,NULL,NULL,1,173.806833333,51.16194,0,NULL,61807015205,965734612,15089603,15.4),(82511,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82511,37.1,0.14,263,33297,70,NULL,NULL,'2MASX J11351433+2105422',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,173.809833333,21.09508,0,NULL,61075172703,954299573,14910930,17),(82512,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82512,37.93,0.46,386,33298,70,NULL,NULL,'SDSS J113515.21+661447.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000076,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,173.813417,66.24642,0.009,NULL,61822823585,965981618,15093462,18.4),(82513,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82513,37.7,0.46,346,33299,70,NULL,NULL,'2MASX J11351520+1000550',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,173.813458333,10.01544,0.106,NULL,60386070161,943532346,14742692,16.8),(82514,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82514,38.11,0.33,418,33300,70,NULL,NULL,'LCRS B113242.1-025019',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00015,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,173.814833,-3.11508,0.113,NULL,40825177667,637893401,9967084,17.1),(82515,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82515,35.28,0.23,114,33301,70,NULL,NULL,'2MASX J11351563+5112136',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000176,NULL,'15.9g',0.37,'E0',NULL,NULL,NULL,NULL,1,173.815125,51.20381,0,NULL,61807016198,965734628,15089603,15.9),(82516,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82516,36.69,0.33,218,33302,70,NULL,NULL,'2MASX J11351707+3053315',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000187,NULL,'16.0g',0.34,NULL,NULL,NULL,NULL,NULL,1,173.821083333,30.89203,0,NULL,60628537891,947320904,14801889,16),(82517,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82517,39.21,0.46,695,33303,70,NULL,NULL,'SDSS J113517.19+561559.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,173.821625,56.26644,0,NULL,61989656865,968588388,15134193,18.4),(82518,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82518,37.01,0.33,253,33304,70,NULL,NULL,'2MASX J11351776+4152583',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000175,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,173.824,41.88283,0.006,NULL,63899721793,998433153,15600518,17.3),(82519,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82519,37.11,0.33,264,33305,70,NULL,NULL,'MCG +10-17-018',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000113,NULL,'15.4g',0.48,'E0',NULL,NULL,NULL,NULL,1,173.8257917,57.68564,0,NULL,61990606656,968603229,15134425,15.4),(82520,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82520,31.53,NULL,20.2,33306,NULL,NULL,NULL,'SDSS J113518.39+045717.3',NULL,'2015AstBu..70....1K',2015,1,0.26,NULL,'G',0.00003,NULL,'18.03',0.15,NULL,NULL,NULL,NULL,NULL,1,173.826625,4.95481,0.037,NULL,60171576217,940180878,14690326,18.03),(82521,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82521,35.82,0.46,146,33307,70,NULL,NULL,'2MASX J11351944+2002032',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000083,NULL,'17.16',0.2,NULL,NULL,NULL,NULL,NULL,1,173.831208333,20.03417,0.017,NULL,61079615015,954368984,14912015,17.16),(82522,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82522,38.08,0.46,413,33308,70,NULL,NULL,'2MASX J11351985+1524261',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000173,NULL,'18.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,173.832667,15.40736,0.038,NULL,60224203692,941003182,14703174,18.1),(82523,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82523,35.9,0.5,151,33309,70,NULL,NULL,'AM 1132-324',NULL,'2014MNRAS.445.2677S',2014,1,0.3,'FLASH position points to a star.','G',0.00008,NULL,'16.5b',0.6,'(R)S0/a',NULL,NULL,NULL,NULL,1,173.835083,-33.03425,0.261,NULL,41585135501,649767742,10152620,16.5),(82524,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82524,37.46,0.46,310,33310,70,NULL,NULL,'2MASX J11352048+0628380',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,173.835167,6.47711,0.099,NULL,60381590781,943462355,14741599,17.8),(82525,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82525,35.71,0.37,139,33311,NULL,NULL,'Malmquist cor.','ESO 266- G 007',NULL,'2009ApJS..182..474S',2009,1,1.6,NULL,'G',0.000033,NULL,'15.80',0.3,'S...',NULL,NULL,NULL,NULL,1,173.835625,-46.06025,0.413,NULL,41890119598,654533118,10227079,15.8),(82526,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82526,35.81,0.35,145,33311,NULL,NULL,NULL,'ESO 266- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82527,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82527,35.85,0.2,148,33311,74.4,NULL,NULL,'ESO 266- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82528,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82528,37.22,0.46,278,33312,70,NULL,NULL,'2MASX J11352178+3237024',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,173.840791667,32.61725,0,NULL,60621725371,947214458,14800225,17.3),(82529,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82529,38.18,0.33,433,33313,70,NULL,NULL,'SDSS J113522.61+071705.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,173.84425,7.28481,0.1,NULL,60382948239,943483566,14741930,18.5),(82530,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82530,38.34,0.46,465,33314,70,NULL,NULL,'2MASX J11352288+0134046',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000084,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,173.8452917,1.56797,0.053,NULL,60169048865,940141388,14689709,17.4),(82531,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82531,36.69,0.33,218,33315,70,NULL,NULL,'2MASX J11352285+3043434',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000195,NULL,'15.6g',0.53,NULL,NULL,NULL,NULL,NULL,1,173.8452917,30.72869,0,NULL,60628553092,947321142,14801892,15.6),(82532,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82532,36.22,0.33,175,33316,70,NULL,NULL,'2MASX J11352327+0005256',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000069,NULL,'16.1g',0.36,'E0',NULL,NULL,NULL,NULL,1,173.847,0.09056,0.061,NULL,60167476226,940116816,14689325,16.1),(82533,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82533,39.33,0.46,735,33317,70,NULL,NULL,'2MASX J11352373+1838582',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,173.8489583,18.64939,0,NULL,61079814321,954372098,14912064,18.2),(82534,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82534,37.96,0.46,391,33318,70,NULL,NULL,'2MASX J11352463+3838313',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000149,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,173.852625,38.64211,0.011,NULL,60458062202,944657221,14760269,17.7),(82535,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82535,37.65,0.46,339,33319,70,NULL,NULL,'2MASX J11352481+0037466',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000059,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,173.853375,0.62975,0.041,NULL,60168122512,940126914,14689483,17.7),(82536,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82536,37.58,0.46,327,33320,70,NULL,NULL,'2MASX J11352478+1828512',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,173.853375,18.481,0,NULL,61123866125,955060408,14922818,16.3),(82537,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82537,35.89,0.25,151,33321,74.4,NULL,NULL,'MCG +08-21-064',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000028,NULL,'16.1g',0.34,'S0^-','Group member',NULL,NULL,NULL,1,173.859333333,49.08703,0,NULL,61752139822,964877184,15076206,16.1),(82538,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82538,36.02,0.11,160,33321,70,NULL,NULL,'MCG +08-21-064',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82539,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82539,38.18,0.33,433,33322,70,NULL,NULL,'SDSS J113526.85+071809.0',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000128,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,173.861917,7.30253,0.1,NULL,60382948097,943483564,14741930,18.1),(82540,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82540,38.86,0.46,592,33323,70,NULL,NULL,'2MASX J11352768+2016392',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,173.865333,20.27753,0.016,NULL,61081659926,954400936,14912514,17.6),(82541,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82541,38,0.46,397,33324,70,NULL,NULL,'2MASX J11352848+1133390',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000148,NULL,'17.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,173.868708333,11.56094,0.024,NULL,60217848556,940903883,14701623,17.5),(82542,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82542,37.96,0.23,390,33325,70,NULL,NULL,'2MASX J11352854+5653437',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000158,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,173.8689583,56.89561,0,NULL,61990798536,968606227,15134472,17.2),(82543,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82543,37.87,0.46,374,33326,70,NULL,NULL,'2MASX J11352927+0057096',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000074,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,173.872,0.95256,0.037,NULL,60171119821,940173747,14690214,17.2),(82544,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82544,36.33,0.46,184,33327,70,NULL,NULL,'2MASX J11352928+1713086',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000182,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,173.872125,17.21922,0,NULL,61123652139,955057064,14922766,16.3),(82545,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82545,37.48,0.46,313,33328,70,NULL,NULL,'2MASX J11352941+1511336',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,173.8724583,15.19261,0.038,NULL,60224399680,941006245,14703222,17.9),(82546,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82546,38.15,0.46,426,33329,70,NULL,NULL,'2MASX J11353149+6417581',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000087,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,173.881375,64.29942,0,NULL,61820080334,965938755,15092793,17.7),(82547,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82547,32.71,0.51,34.9,33330,70,NULL,NULL,'NGC 3742',NULL,'2014MNRAS.445.2677S',2014,1,2.4,NULL,'G',0.000043,NULL,'13.03',1.7,'(R\')SAB(rl)a','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,173.8854583,-37.95639,0.417,NULL,41404918814,646951856,10108622,13.03),(82548,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82548,33.15,0.4,42.7,33330,NULL,NULL,'mean','NGC 3742',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82549,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82549,33.23,0.47,44.4,33330,NULL,NULL,'H','NGC 3742',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82550,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82550,33.26,0.45,44.8,33330,NULL,NULL,'K','NGC 3742',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82551,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82551,33.26,0.46,44.8,33330,NULL,NULL,'J','NGC 3742',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82552,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82552,37.23,0.46,279,33331,70,NULL,NULL,'2MASX J11353257+3636313',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,173.885666667,36.60867,0,NULL,60452336340,944567755,14758871,17.3),(82553,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82553,36.46,0.46,196,33332,70,NULL,NULL,'2MASX J11353269+5452317',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,173.886125,54.87561,0,NULL,61764262009,965066593,15079165,17.2),(82554,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82554,37.76,0.07,357,33333,70,NULL,NULL,'2MASX J11353339+1331487',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,173.889083333,13.53006,0.047,NULL,60219547861,940930435,14702038,17.3),(82555,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82555,35.24,NULL,111,33334,NULL,NULL,NULL,'FGC 1282',NULL,'2000BSAO...50....5K',2000,1,1.1,'Matthews (2000A&AS..143..421M) detects another feature at v=9605 km/sec.','G',0.000017,NULL,'17.22',0.1,'Sd',NULL,NULL,NULL,NULL,1,173.890917,24.95967,0,NULL,60590384997,946724765,14792574,17.22),(82556,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82556,35.24,NULL,112,33334,NULL,NULL,'Dipole + Quadrupole','FGC 1282',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82557,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82557,35.24,NULL,112,33334,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1282',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82558,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82558,35.27,NULL,113,33334,NULL,NULL,'Dipole','FGC 1282',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82559,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82559,35.42,0.49,121,33334,75,NULL,'IR','FGC 1282',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82560,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82560,35.6,0.55,132,33334,NULL,NULL,'Malmquist cor.','FGC 1282',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82561,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82561,35.84,0.49,147,33334,NULL,NULL,NULL,'FGC 1282',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82562,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82562,35.88,0.2,150,33334,74.4,NULL,NULL,'FGC 1282',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82563,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82563,36.78,0.16,227,33335,70,NULL,NULL,'2MASX J11353411+5513087',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000166,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,173.8919583,55.21903,0,NULL,61763313248,965051769,15078933,17.7),(82564,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82564,36.13,0.46,168,33336,70,NULL,NULL,'SDSS J113534.14+305648.5',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000179,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,173.8922917,30.94683,0,NULL,60628546361,947321036,14801891,16.4),(82565,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82565,37.64,0.46,337,33337,70,NULL,NULL,'2MASX J11353420+1447577',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000171,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,173.892375,14.79947,0.046,NULL,60223984245,940999753,14703121,17.6),(82566,'IRAS','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82566,34.83,0.8,92.6,33338,75,NULL,'HMCL, I','KUG 1132+207',NULL,'1997ApJS..109..333W',1997,1,0.7,NULL,'G',0.000033,NULL,'15.5',0.3,'S0/a',NULL,NULL,NULL,NULL,1,173.89575,20.50522,0,NULL,61074331332,954286427,14910725,15.5),(82567,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82567,34.94,0.12,97.5,33338,NULL,NULL,NULL,'KUG 1132+207',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82568,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82568,35.41,0.4,121,33338,75,NULL,'HMCL, I, raw','KUG 1132+207',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82569,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82569,35.55,0.4,129,33338,75,NULL,'HMCL, I, inv','KUG 1132+207',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82570,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82570,35.64,0.4,134,33338,75,NULL,'HMCL, I, cor','KUG 1132+207',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82571,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82571,38.74,0.46,560,33339,70,NULL,NULL,'LCRS B113302.7-022524',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000148,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,173.9005417,-2.69975,0.069,NULL,40831772138,637996439,9968694,17.7),(82572,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82572,37.76,0.07,357,33340,70,NULL,NULL,'2MASX J11353613+1339147',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000179,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,173.9005417,13.65406,0.019,NULL,60218852983,940919577,14701868,17.5),(82573,'BCG','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82573,35.62,0.35,131,33341,60,NULL,'ABELL 1318, BCG','NGC 3737',0.0189,'1980ApJ...241..486H',1980,1,1.06,NULL,'G',0.000087,NULL,'13.7g',0.92,'SB0','in a radial-velocity based grouping',NULL,NULL,NULL,1,173.901583,54.94856,0,NULL,61764217845,965065903,15079154,13.7),(82574,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82574,37.21,0.27,277,33342,70,NULL,NULL,'2MASX J11353666+5143138',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000214,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,173.902875,51.72061,0,NULL,61806807552,965731368,15089552,16.3),(82575,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82575,34.13,0.45,67,33343,NULL,NULL,NULL,'UGC 06568',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000033,NULL,'14.70',0.4,'SB(s)m','Isolated galaxy',NULL,NULL,NULL,1,173.9037917,0.12739,0.053,NULL,60167486897,940116982,14689327,14.7),(82576,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82576,34.17,0.2,68.2,33343,74.4,NULL,NULL,'UGC 06568',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82577,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82577,34.52,0.38,80.2,33343,NULL,NULL,'Malmquist cor.','UGC 06568',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82578,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82578,37.76,0.07,357,33344,70,NULL,NULL,'2MASX J11353730+1337487',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000172,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,173.905291667,13.63017,0.019,NULL,60218865672,940919776,14701871,18.3),(82579,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82579,35.26,0.49,113,33345,75,NULL,'IR','NGC 3739',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000027,NULL,'15.25',0.3,'Sbc',NULL,NULL,NULL,NULL,1,173.906667,25.08864,0,NULL,60590289596,946723274,14792551,15.25),(82580,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82580,35.58,0.36,130,33345,NULL,NULL,'Malmquist cor.','NGC 3739',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82581,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82581,35.81,0.2,145,33345,74.4,NULL,NULL,'NGC 3739',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82582,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82582,35.87,0.32,149,33345,NULL,NULL,NULL,'NGC 3739',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82583,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82583,36.02,0.11,160,33346,70,NULL,NULL,'2MASXi J1135384+485753',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.2g',0.22,NULL,'Group member',NULL,NULL,NULL,1,173.9100417,48.96486,0,NULL,61752094134,964876470,15076194,17.2),(82584,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82584,36.09,0.33,165,33347,70,NULL,NULL,'SDSS J113539.22+260549.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000176,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,173.913458333,26.09717,0,NULL,60597325919,946833217,14794269,17.5),(82585,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82585,38.26,0.46,448,33348,70,NULL,NULL,'2MASX J11353952+0614210',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000176,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,173.914666667,6.23914,0.085,NULL,60382211909,943472061,14741750,17.7),(82586,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82586,36.02,0.11,160,33349,70,NULL,NULL,'2MASX J11353953+4855278',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000157,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,173.9149583,48.92436,0,NULL,61752610959,964884546,15076321,16.4),(82587,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82587,38.37,0.46,471,33350,70,NULL,NULL,'2MASX J11353962+0244169',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000078,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,173.9152083,2.73792,0.029,NULL,60175923238,940248800,14691387,17.6),(82588,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82588,35.46,0.46,124,33351,70,NULL,NULL,'2MASX J11353985+1010030',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000158,NULL,'15.8g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,173.9162083,10.16744,0.126,NULL,60386178102,943534032,14742719,15.8),(82589,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82589,35.15,0.46,107,33352,70,NULL,NULL,'CGCG 292-007',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.0001,NULL,'15.1g',0.5,'S0^-',NULL,NULL,NULL,NULL,1,173.921958333,58.32375,0,NULL,61989776756,968590261,15134222,15.1),(82590,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82590,37.76,0.07,357,33353,70,NULL,NULL,'SDSS J113542.72+134012.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000169,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,173.928041667,13.67006,0.019,NULL,60218854552,940919602,14701868,18.5),(82591,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82591,37.76,0.07,357,33354,70,NULL,NULL,'SDSS J113543.23+134545.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000162,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,173.930167,13.76256,0.019,NULL,60218896088,940920251,14701878,18.2),(82592,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82592,36.09,0.33,165,33355,70,NULL,NULL,'2MASX J11354346+2549359',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000175,NULL,'16.0g',0.32,NULL,NULL,NULL,NULL,NULL,1,173.931,25.82661,0,NULL,60589733017,946714578,14792415,16),(82593,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82593,34.98,0.33,99.1,33356,70,NULL,NULL,'2MASX J11354360+5455336',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000117,NULL,'15.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,173.93175,54.92611,0,NULL,61764217103,965065892,15079154,15.9),(82594,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82594,35.86,0.12,149,33357,NULL,NULL,NULL,'MCG +08-21-065',NULL,'2009ApJS..182..474S',2009,1,1.11,NULL,'G',0.000033,NULL,'16.0g',0.2,'Sb','Group member',NULL,NULL,NULL,1,173.9332083,49.03764,0,NULL,61752089715,964876401,15076193,16),(82595,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82595,37.11,0.33,264,33358,70,NULL,NULL,'2MASX J11354528+4916198',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000175,NULL,'16.1g',0.41,NULL,'Group member',NULL,NULL,NULL,1,173.938833,49.27228,0,NULL,61750992315,964859254,15075925,16.1),(82596,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82596,37.76,0.07,357,33359,70,NULL,NULL,'2MASX J11354621+1328477',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000196,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,173.9425417,13.48003,0.047,NULL,60219536106,940930251,14702035,16.5),(82597,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82597,37.41,0.46,304,33360,70,NULL,NULL,'SDSS J113547.35+042204.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000147,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,173.947333,4.36797,0.017,NULL,60172164756,940190074,14690469,18.6),(82598,'IRAS','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82598,34.15,0.8,67.5,33361,75,NULL,'MAT, I','ESO 216- G 021',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.29',1,'SA(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,173.949833,-49.02903,0.573,NULL,40004822504,625075351,9766802,14.29),(82599,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82599,33.56,0.32,51.5,33361,85,NULL,'I, raw','ESO 216- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82600,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82600,33.6,0.32,52.6,33361,85,NULL,'I, inv','ESO 216- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82601,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82601,33.78,0.43,57.1,33361,75,NULL,'MAT, I, raw','ESO 216- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82602,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82602,34,0.43,63.1,33361,75,NULL,'MAT, I, inv','ESO 216- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82603,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82603,34.16,0.43,68.1,33361,75,NULL,'MAT, I, cor','ESO 216- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82604,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82604,34.24,0.6,70.4,33361,NULL,NULL,'Malmquist cor.','ESO 216- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82605,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82605,34.67,0.49,85.9,33361,NULL,NULL,NULL,'ESO 216- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82606,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82606,34.71,0.2,87.5,33361,74.4,NULL,NULL,'ESO 216- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82607,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82607,37.21,0.27,277,33362,70,NULL,NULL,'2MASX J11354829+5145587',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000179,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,173.9510417,51.76622,0.009,NULL,61804774751,965699605,15089056,16.9),(82608,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82608,36.78,0.16,227,33363,70,NULL,NULL,'2MASX J11354863+5501206',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000127,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,173.952625,55.02253,0,NULL,61764210612,965065790,15079152,16.9),(82609,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82609,38.33,0.46,463,33364,70,NULL,NULL,'2MASX J11354866+2043597',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,173.952917,20.73314,0,NULL,61074567398,954290115,14910783,18.4),(82610,'Brightest Stars','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82610,26.29,NULL,1.81,33365,NULL,NULL,'LF','NGC 3738',NULL,'1997AstL...23..514G',1997,1,2.5,NULL,'G',0.000013,NULL,'12.13',1.9,'Irr            HII','in a pair',NULL,NULL,'H II',1,173.9532917,54.52389,0,1,61763930498,965061414,15079084,12.13),(82611,'Brightest Stars','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82611,27.73,0.4,3.52,33365,NULL,NULL,'3B + 3R mean','NGC 3738',NULL,'1997AstL...23..514G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82612,'TRGB','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82612,27.82,NULL,3.66,33365,NULL,NULL,NULL,'NGC 3738',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82613,'TRGB','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82613,28.3,0.1,4.57,33365,NULL,NULL,NULL,'NGC 3738',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82614,'TRGB','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82614,28.45,0.25,4.9,33365,NULL,NULL,NULL,'NGC 3738',NULL,'2003A&A...398..467K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82615,'TRGB','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82615,28.62,0.1,5.3,33365,74.4,NULL,NULL,'NGC 3738',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82616,'TRGB','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82616,28.76,0.08,5.65,33365,NULL,NULL,NULL,'NGC 3738',NULL,'2013AstBu..68..125M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82617,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82617,28.16,0.4,4.3,33365,75,NULL,'B','NGC 3738',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82618,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82618,36.05,0.46,162,33366,70,NULL,NULL,'2MASX J11354913+2144197',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.00009,NULL,'15.9g',0.32,NULL,NULL,NULL,NULL,NULL,1,173.9547083,21.73894,0,NULL,61076947713,954327308,14911364,15.9),(82619,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82619,37.76,0.07,357,33367,70,NULL,NULL,'2MASX J11355040+1403227',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000199,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,173.9599583,14.05617,0.052,NULL,60218730695,940917667,14701838,16.9),(82620,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82620,36.85,0.46,234,33368,70,NULL,NULL,'2MASX J11355191+2753235',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000185,NULL,'16.1g',0.41,NULL,NULL,NULL,NULL,NULL,1,173.96625,27.88983,0,NULL,60586375877,946662123,14791595,16.1),(82621,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82621,37.33,0.46,293,33369,70,NULL,NULL,'2MASX J11355315+4139265',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,173.971583,41.65736,0,NULL,63897601029,998400016,15600000,17.6),(82622,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82622,33.03,0.45,40.5,33370,NULL,NULL,'K','NGC 3749',NULL,'2007A&A...465...71T',2007,1,3.2,NULL,'G',0.000043,NULL,'13.21',0.8,'SA(s)a pec sp  HII','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,173.9717083,-37.99736,0.417,NULL,41404871289,646951113,10108611,13.21),(82623,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82623,33.09,0.47,41.4,33370,NULL,NULL,'H','NGC 3749',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82624,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82624,33.14,0.4,42.4,33370,NULL,NULL,'mean','NGC 3749',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82625,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82625,33.2,0.46,43.6,33370,NULL,NULL,'J','NGC 3749',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82626,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82626,37.76,0.07,357,33371,70,NULL,NULL,'2MASX J11355397+1342147',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000229,NULL,'16.2g',0.45,NULL,NULL,NULL,NULL,NULL,1,173.974833,13.70408,0.047,NULL,60218853594,940919587,14701868,16.2),(82627,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82627,34.35,0.49,74.2,33372,75,NULL,'IR','ESO 216- G 022',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000033,NULL,'15.83',0.4,'S...',NULL,NULL,NULL,NULL,1,173.984833,-48.48625,0.585,NULL,40005203379,625081302,9766895,15.83),(82628,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82628,34.54,0.41,80.9,33372,NULL,NULL,'Malmquist cor.','ESO 216- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82629,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82629,34.83,0.36,92.6,33372,NULL,NULL,NULL,'ESO 216- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82630,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82630,34.87,0.2,94.2,33372,74.4,NULL,NULL,'ESO 216- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82631,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82631,37.3,0.33,288,33373,70,NULL,NULL,'2MASX J11355703+1748447',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.89',0.17,NULL,NULL,NULL,NULL,NULL,1,173.987667,17.81233,0,NULL,61077599618,954337494,14911523,17.89),(82632,'IRAS','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82632,33.09,0.8,41.5,33374,75,NULL,'A82, H','NGC 3735',NULL,'1997ApJS..109..333W',1997,1,4.2,'The 2MASS position is 10 arcsec southeast of the center of the optical bulge.','G',0.000023,NULL,'12.50',0.8,'SAc: sp        Sy2','in a radial-velocity based grouping',NULL,NULL,'Sy 2',1,173.98875,70.53558,0.005,NULL,61351511850,958617372,14978396,12.5),(82633,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82633,32.58,0.4,32.8,33374,75,NULL,NULL,'NGC 3735',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82634,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82634,32.61,0.4,33.3,33374,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 3735',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82635,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82635,32.62,0.46,33.4,33374,NULL,NULL,'J','NGC 3735',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82636,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82636,32.65,0.47,33.9,33374,NULL,NULL,'H','NGC 3735',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82637,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82637,32.71,0.45,34.8,33374,NULL,NULL,'K','NGC 3735',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82638,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82638,32.73,0.38,35.2,33374,NULL,NULL,NULL,'NGC 3735',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82639,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82639,32.91,0.47,38.1,33374,75,NULL,'A82, H, raw','NGC 3735',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82640,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82640,32.91,0.49,38.2,33374,75,NULL,'IR','NGC 3735',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82641,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82641,32.93,0.4,38.6,33374,NULL,NULL,'mean','NGC 3735',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82642,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82642,32.98,0.43,39.4,33374,75,NULL,'3.6 micron, color corrected','NGC 3735',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82643,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82643,33.04,0.43,40.6,33374,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3735',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82644,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82644,33.05,0.35,40.7,33374,NULL,NULL,'Malmquist cor.','NGC 3735',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82645,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82645,33.06,0.4,41,33374,75,NULL,'B','NGC 3735',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82646,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82646,33.07,0.47,41.2,33374,75,NULL,'A82, H, cor','NGC 3735',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82647,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82647,33.12,0.47,42.1,33374,75,NULL,'A82, H, inv','NGC 3735',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82648,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82648,33.13,0.2,42.3,33374,74.4,NULL,NULL,'NGC 3735',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82649,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82649,33.44,0.29,48.6,33374,NULL,NULL,NULL,'NGC 3735',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82650,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82650,35.96,0.46,156,33375,70,NULL,NULL,'NGC 3743',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000083,NULL,'15.2g',0.55,'E-S0',NULL,NULL,NULL,NULL,1,173.989,21.72261,0,NULL,61077159965,954330624,14911416,15.2),(82651,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82651,36.67,0.46,216,33376,70,NULL,NULL,'2MASX J11355736+4309539',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000165,NULL,'16.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,173.9892083,43.16503,0.01,NULL,63897590400,998399850,15599997,16.5),(82652,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82652,37.29,0.66,287,33377,70,NULL,NULL,'2MASX J11355756-1027443',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.79',0.4,NULL,NULL,NULL,NULL,NULL,1,173.98975,-10.46233,0.017,NULL,41062667816,641604184,10025065,16.79),(82653,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82653,37.62,0.46,334,33378,70,NULL,NULL,'LCRS B113324.6-022219',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000177,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,173.992,-2.64825,0.073,NULL,40831795210,637996800,9968700,17.7),(82654,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82654,37.53,0.27,320,33379,70,NULL,NULL,'2MASX J11355828+5522506',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000184,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,173.9927083,55.38081,0,NULL,61763456643,965054010,15078968,16.7),(82655,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82655,37.21,0.33,277,33380,70,NULL,NULL,'2MASX J11355922+3742225',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.59',0.13,NULL,NULL,NULL,NULL,NULL,1,173.9967083,37.70628,0,NULL,60462439771,944725621,14761337,17.59),(82656,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82656,37.31,0.33,290,33381,70,NULL,NULL,'2MASX J11355952+4455169',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000152,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,173.9979583,44.92142,0,NULL,63904198488,998503101,15601610,17.1),(82657,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82657,37.21,0.33,277,33382,70,NULL,NULL,'2MASX J11355997+3742445',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,174.000083,37.71239,0,NULL,60462439789,944725621,14761337,17.6),(82658,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82658,36.85,0.46,234,33383,70,NULL,NULL,'2MASX J11360003+2350547',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.72',0.2,NULL,NULL,NULL,NULL,NULL,1,174.00025,23.84844,0,NULL,60586842043,946669406,14791709,17.72),(82659,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82659,37.51,0.46,318,33384,70,NULL,NULL,'LCRS B113326.9-032121',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'18.0g',0.18,'AGN',NULL,NULL,NULL,NULL,1,174.001083333,-3.63231,0.129,NULL,40824944870,637889763,9967027,18),(82660,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82660,38.07,0.46,412,33385,70,NULL,NULL,'2MASX J11360041+2706306',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000172,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,174.001917,27.10869,0,NULL,60584575335,946633989,14791156,17.5),(82661,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82661,37.3,0.33,288,33386,70,NULL,NULL,'2MASX J11360162+1746209',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.36',0.16,NULL,NULL,NULL,NULL,NULL,1,174.006667,17.77258,0,NULL,61077598718,954337479,14911523,18.36),(82662,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82662,36.78,0.16,227,33387,70,NULL,NULL,'CGCG 1133.2+5521 NED01',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000103,NULL,'15.1g',0.61,'BrClG',NULL,NULL,NULL,NULL,1,174.014625,55.07531,0,NULL,61763420399,965053443,15078960,15.1),(82663,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82663,37.76,0.07,357,33388,70,NULL,NULL,'2MASX J11360355+1343169',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000182,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,174.014917,13.72131,0.047,NULL,60218829738,940919214,14701862,16.7),(82664,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82664,37.96,0.33,392,33389,70,NULL,NULL,'2MASX J11360386+6314531',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000163,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,174.016333,63.24822,0.033,NULL,61863808270,966622004,15103468,17.5),(82665,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82665,36.78,0.16,227,33390,70,NULL,NULL,'CGCG 1133.2+5521 NED02',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000093,NULL,'15.9g',0.36,'E0',NULL,NULL,NULL,NULL,1,174.016375,55.06383,0,NULL,61763387422,965052928,15078952,15.9),(82666,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82666,37.1,0.14,263,33391,70,NULL,NULL,'2MASX J11360517+2117385',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.90',0.17,NULL,NULL,NULL,NULL,NULL,1,174.021667,21.29406,0,NULL,61075325375,954301958,14910968,17.9),(82667,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82667,38.31,0.23,459,33392,70,NULL,NULL,'2MASX J11360523+0711575',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,174.02175,7.19942,0.101,NULL,60382815403,943481490,14741898,17.6),(82668,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82668,37.13,0.46,266,33393,70,NULL,NULL,'2MASX J11360550+4414068',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.0002,NULL,'15.8g',0.41,'E0',NULL,NULL,NULL,NULL,1,174.022666667,44.23508,0.054,NULL,63904126974,998501983,15601593,15.8),(82669,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82669,37.83,0.46,368,33394,70,NULL,NULL,'2MASX J11360570+0819425',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00017,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,174.023833,8.32842,0.083,NULL,60395918069,943686219,14745097,16.9),(82670,'Brightest Stars','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82670,27.7,0.4,3.47,33395,NULL,NULL,'3B + 3R mean','NGC 3741',NULL,'1997AstL...23..514G',1997,1,2,NULL,'G',0.000013,NULL,'14.3',1.1,'ImIII/BCD','Group member',NULL,NULL,NULL,1,174.02575,45.28364,0,NULL,63903803388,998496927,15601514,14.3),(82671,'Brightest Stars','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82671,27.71,NULL,3.48,33395,NULL,NULL,'LF','NGC 3741',NULL,'1997AstL...23..514G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82672,'CMD','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82672,27.49,NULL,3.15,33395,NULL,NULL,NULL,'NGC 3741',NULL,'2012ApJ...748...47M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82673,'TRGB','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82673,27.41,0.23,3.03,33395,NULL,NULL,NULL,'NGC 3741',NULL,'2003A&A...398..467K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82674,'TRGB','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82674,27.48,0.09,3.13,33395,NULL,NULL,NULL,'NGC 3741',NULL,'2013AstBu..68..125M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82675,'TRGB','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82675,27.48,0.13,3.14,33395,NULL,NULL,NULL,'NGC 3741',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82676,'TRGB','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82676,27.52,0.06,3.19,33395,NULL,NULL,NULL,'NGC 3741',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82677,'TRGB','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82677,27.53,0.12,3.21,33395,NULL,NULL,'I','NGC 3741',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82678,'TRGB','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82678,27.54,0.08,3.23,33395,74.4,NULL,NULL,'NGC 3741',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82679,'TRGB','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82679,27.55,0.08,3.24,33395,NULL,NULL,'I','NGC 3741',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82680,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82680,34.52,0.67,80.3,33396,70,NULL,NULL,'NGC 3777',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00011,NULL,'14.31',0.6,'SAB(s)ab:',NULL,NULL,NULL,NULL,1,174.0285417,-12.56908,0.053,NULL,40978932747,640295824,10004622,14.31),(82681,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82681,36.25,0.46,178,33397,70,NULL,NULL,'2MASX J11360880+3243577',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,174.036583,32.73269,0,NULL,60621736369,947214630,14800228,17.4),(82682,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82682,38.54,0.46,511,33398,70,NULL,NULL,'SDSS J113609.28+033355.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000071,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,174.038667,3.56539,0.005,NULL,60174011735,940218933,14690920,18.5),(82683,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82683,37.39,0.46,300,33399,70,NULL,NULL,'2MASX J11360971-0200075',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,174.040625,-2.00197,0.069,NULL,40830414246,637975222,9968362,16.8),(82684,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82684,38.35,0.46,468,33400,70,NULL,NULL,'2MASX J11361003+1713299',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,174.041833,17.22492,0,NULL,61077468086,954335438,14911491,17.6),(82685,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82685,37.66,0.27,341,33401,70,NULL,NULL,'SDSS J113610.07+142453.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,174.042,14.41486,0.061,NULL,60223971446,940999553,14703118,17.9),(82686,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82686,37.31,0.33,290,33402,70,NULL,NULL,'2MASX J11361020+4456544',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000153,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,174.0424583,44.94833,0,NULL,63904373645,998505838,15601653,17.6),(82687,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82687,37.36,0.46,296,33403,70,NULL,NULL,'2MASX J11361136+1638429',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,174.0472083,16.64517,0.046,NULL,60255485344,941491958,14710811,18.3),(82688,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82688,38.2,0.46,436,33404,70,NULL,NULL,'2MASX J11361183+3850574',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000191,NULL,'16.9g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,174.049375,38.84933,0,NULL,60459858405,944685287,14760707,16.9),(82689,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82689,37.36,0.46,297,33405,70,NULL,NULL,'2MASX J11361237+6740260',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000089,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,174.0512917,67.67406,0.005,NULL,62078594727,969978042,15155906,16.6),(82690,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82690,37.11,0.33,264,33406,70,NULL,NULL,'2MASX J11361313+4915582',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,174.054583,49.26617,0,NULL,61751000071,964859376,15075927,16.8),(82691,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82691,35.78,0.58,143,33407,70,NULL,NULL,'6dF J1136131-374522',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,'poss. LINER',NULL,NULL,NULL,NULL,1,174.0550417,-37.75619,0.417,NULL,41404751082,646949235,10108581,14.4),(82692,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82692,37.97,0.46,392,33408,70,NULL,NULL,'2MASX J11361537+0250052',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000091,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,174.064041667,2.83464,0.033,NULL,60173617022,940212765,14690824,16.9),(82693,'CMD','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82693,20.81,0.04,0.145,33409,NULL,NULL,'Crater is not a dwarf galaxy','Crater',NULL,'2015arXiv151008533W',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,174.0675,-10.87722,0.01,0,41062344733,641599136,10024986,NULL),(82694,'CMD','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82694,20.91,0.1,0.152,33409,NULL,NULL,NULL,'Crater',NULL,'2015A&A...579L...6B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82695,'Horizontal Branch','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82695,20.81,0.12,0.145,33409,NULL,NULL,NULL,'Crater',NULL,'2014ApJ...786L...3L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82696,'Red Clump','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82696,21.1,NULL,0.17,33409,NULL,NULL,NULL,'Crater',NULL,'2014MNRAS.441.2124B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82697,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82697,36.85,0.56,234,33410,70,NULL,NULL,'2MASX J11361603-4711393',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,174.066916667,-47.19428,0.577,NULL,41886261854,654472841,10226138,15.3),(82698,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82698,37.76,0.07,357,33411,70,NULL,NULL,'2MASX J11361720+1341309',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000167,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,174.071708333,13.69208,0.047,NULL,60218806477,940918851,14701857,16.9),(82699,'BL Lac Luminosity','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82699,42.1,NULL,1800,33412,NULL,NULL,NULL,'NVSS J113617+160152',0.46,'2005ApJ...635..173S',2005,1,NULL,'VCV give z = 0.574.','QSO',NULL,NULL,'20.04',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,174.072875,16.03142,0.059,NULL,60255850344,941497661,14710900,20.04),(82700,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82700,36.03,0.46,161,33413,70,NULL,NULL,'CGCG 314-037',NULL,'2015arXiv151105856S',2015,1,0.87,NULL,'G',0.000093,NULL,'14.8g',0.61,'S0/a',NULL,NULL,NULL,NULL,1,174.072917,63.09131,0.033,NULL,61863265069,966613516,15103336,14.8),(82701,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82701,37.1,0.14,263,33414,70,NULL,NULL,'2MASX J11361819+2112035',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.70',0.19,NULL,NULL,NULL,NULL,NULL,1,174.075875,21.20106,0,NULL,61075330376,954302037,14910969,17.7),(82702,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82702,36.13,0.84,168,33415,70,NULL,NULL,'2MASX J11361824-5042514',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,174.076,-50.71425,0.593,NULL,40060800116,625950001,9780468,17.6),(82703,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82703,37.71,0.46,348,33416,70,NULL,NULL,'2MASX J11362039+1751069',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,174.085,17.85197,0,NULL,61078311682,954348620,14911697,17.3),(82704,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82704,37.96,0.23,390,33417,70,NULL,NULL,'2MASX J11362120+5655257',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,174.08825,56.92369,0,NULL,61990772971,968605827,15134466,17.9),(82705,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82705,37.96,0.23,390,33418,70,NULL,NULL,'2MASX J11362159+5701357',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000171,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,174.09,57.02636,0,NULL,61990770685,968605791,15134465,17.5),(82706,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82706,37.67,0.46,342,33419,70,NULL,NULL,'2MASX J11362268+2628160',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,174.094583,26.47136,0,NULL,60598077875,946844966,14794452,18.2),(82707,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82707,38.51,0.46,503,33420,70,NULL,NULL,'SDSS J113622.94+002041.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000092,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,174.095583,0.34481,0.025,NULL,60167489759,940117027,14689328,18.4),(82708,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82708,37.6,0.46,331,33421,70,NULL,NULL,'2MASX J11362322+1318399',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000194,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,174.096833333,13.31103,0.019,NULL,60249499146,941398424,14709350,16.7),(82709,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82709,38.31,0.23,459,33422,70,NULL,NULL,'2MASX J11362374+0713367',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000165,NULL,'16.3g',0.38,'BrClG',NULL,NULL,NULL,NULL,1,174.098833333,7.22708,0.101,NULL,60382823978,943481624,14741900,16.3),(82710,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82710,37.02,0.27,254,33423,70,NULL,NULL,'2MASX J11362403+1644539',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000173,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,174.1002083,16.74825,0.019,NULL,60255615804,941493996,14710843,16.4),(82711,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82711,36.78,0.16,227,33424,70,NULL,NULL,'MCG +09-19-132',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00011,NULL,'16.2g',0.32,'E0',NULL,NULL,NULL,NULL,1,174.102875,54.98725,0,NULL,61764107313,965064176,15079127,16.2),(82712,'BCG','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82712,35.62,0.35,131,33425,60,NULL,NULL,'ABELL 1318',0.0189,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II     [BM]',NULL,NULL,NULL,NULL,1,174.108917,54.95667,0,NULL,61764107540,965064180,15079127,NULL),(82713,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82713,36.6,0.46,209,33426,70,NULL,NULL,'2MASX J11362637+5013232',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000153,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,174.109833,50.22328,0,NULL,61795800800,965559387,15086865,16.2),(82714,'BL Lac Luminosity','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82714,36.51,NULL,192,33427,NULL,NULL,NULL,'MRK 0180',0.045278,'2005ApJ...635..173S',2005,1,0.7,NULL,'G',NULL,NULL,'15.5',0.5,'Compact        BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,174.1100417,70.15758,0.005,NULL,61351584103,958618501,14978414,15.5),(82715,'GeV TeV ratio','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82715,38.07,NULL,411,33427,72,NULL,NULL,'MRK 0180',NULL,'2010MNRAS.405L..76P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82716,'GeV TeV ratio','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82716,39.47,0.79,784,33427,72,NULL,NULL,'MRK 0180',NULL,'2011arXiv1111.0913P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82717,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82717,32.63,0.2,33.6,33428,74.4,NULL,NULL,'UGC 06575',NULL,'2013AJ....146...86T',2013,1,2.04,NULL,'G',0.000017,NULL,'14.1g',0.54,'Scd:           HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,174.110291667,58.19136,0,NULL,61989761152,968590018,15134219,14.1),(82718,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82718,32.68,0.4,34.4,33428,NULL,NULL,NULL,'UGC 06575',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82719,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82719,32.68,0.43,34.4,33428,75,NULL,'3.6 micron, color corrected','UGC 06575',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82720,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82720,32.72,0.43,34.9,33428,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06575',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82721,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82721,32.8,0.52,36.3,33428,NULL,NULL,NULL,'UGC 06575',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82722,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82722,32.88,0.5,37.6,33428,NULL,NULL,'Malmquist cor.','UGC 06575',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82723,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82723,38.14,0.46,424,33429,70,NULL,NULL,'2MASX J11362794+1414299',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,174.1164583,14.24156,0.073,NULL,60260615692,941572120,14712064,18.2),(82724,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82724,37.05,0.33,257,33430,70,NULL,NULL,'2MASX J11362824+5746547',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000176,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,174.117541667,57.782,0,NULL,61989856648,968591510,15134242,16.8),(82725,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82725,34.75,0.33,89.1,33431,70,NULL,NULL,'ARK 302',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00007,NULL,'14.6',0.25,'E-SA0',NULL,NULL,NULL,NULL,1,174.1182917,19.81144,0,NULL,61079750403,954371100,14912048,14.6),(82726,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82726,37.22,0.46,278,33432,70,NULL,NULL,'2MASX J11362848+3231003',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00014,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,174.118625,32.51686,0,NULL,60629276823,947332450,14802069,17.9),(82727,'IRAS','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82727,33.13,0.8,42.4,33433,75,NULL,'MAT, I','ESO 266- G 008',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.98',0.3,'Sb: pec sp',NULL,NULL,NULL,NULL,1,174.119875,-45.06183,0.217,NULL,41892677477,654573085,10227704,14.98),(82728,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82728,33.54,0.32,51.1,33433,85,NULL,'I, raw','ESO 266- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82729,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82729,33.55,0.32,51.2,33433,85,NULL,'I, inv','ESO 266- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82730,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82730,33.67,0.68,54.1,33433,NULL,NULL,NULL,'ESO 266- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82731,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82731,33.7,0.43,55.1,33433,75,NULL,'MAT, I, raw','ESO 266- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82732,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82732,33.71,0.2,55.2,33433,74.4,NULL,NULL,'ESO 266- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82733,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82733,33.76,0.49,56.5,33433,75,NULL,'IR','ESO 266- G 008',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82734,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82734,33.78,0.43,57,33433,75,NULL,'MAT, I, inv','ESO 266- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82735,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82735,33.84,0.62,58.7,33433,NULL,NULL,'Malmquist cor.','ESO 266- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82736,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82736,34.08,0.43,65.4,33433,75,NULL,'MAT, I, cor','ESO 266- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82737,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82737,37.96,0.33,392,33434,70,NULL,NULL,'2MASX J11362919+6314530',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000172,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,174.1215417,63.24819,0.061,NULL,61863776291,966621504,15103461,17.5),(82738,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82738,38.31,0.23,459,33435,70,NULL,NULL,'SDSS J113629.23+071211.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,174.121833333,7.20308,0.101,NULL,60382837616,943481837,14741903,18.5),(82739,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82739,37.96,0.33,391,33436,70,NULL,NULL,'2MASX J11362960+0346282',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000149,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,174.123375,3.77439,0.005,NULL,60174104247,940220378,14690943,18),(82740,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82740,37.96,0.33,391,33437,70,NULL,NULL,'2MASX J11363000+0347442',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000146,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,174.125,3.79569,0.021,NULL,60174103855,940220372,14690943,18),(82741,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82741,33.83,0.49,58.4,33438,75,NULL,'IR','NGC 3763',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000027,NULL,'12.38',1.2,'SAB(rs)c pec','Group member',NULL,NULL,NULL,1,174.1257917,-9.84669,0.029,NULL,41063825066,641622266,10025347,12.38),(82742,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82742,37.03,0.46,255,33439,70,NULL,NULL,'MCG +10-17-024',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000186,NULL,'15.8g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,174.12625,57.91564,0,NULL,61989906350,968592286,15134254,15.8),(82743,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82743,36,0.25,158,33440,74.4,NULL,NULL,'CGCG 242-060',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000033,NULL,'14.7g',0.7,'S?','Group member',NULL,NULL,NULL,1,174.1272917,49.13136,0,NULL,61750973429,964858959,15075921,14.7),(82744,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82744,36.02,0.11,160,33440,70,NULL,NULL,'CGCG 242-060',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82745,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82745,37.41,0.46,304,33441,70,NULL,NULL,'SDSS J113630.61+135848.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000105,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,174.127583,13.98025,0.084,NULL,60249111077,941392360,14709255,17.8),(82746,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82746,37.23,0.46,279,33442,70,NULL,NULL,'2MASX J11363075+5642076',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000165,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,174.128083333,56.70208,0,NULL,61989146966,968580421,15134069,16.9),(82747,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82747,37.57,0.46,327,33443,70,NULL,NULL,'2MASX J11363132+5515376',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000179,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,174.130667,55.26053,0,NULL,61763475679,965054307,15078973,16.9),(82748,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82748,37.66,0.27,341,33444,70,NULL,NULL,'2MASX J11363145+1425476',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000182,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,174.131167,14.43,0.061,NULL,60256474910,941507420,14711053,17.1),(82749,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82749,37.32,0.46,292,33445,70,NULL,NULL,'2MASX J11363147+1534506',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000133,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,174.131208333,15.58072,0.033,NULL,60256954483,941514913,14711170,16.3),(82750,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82750,36.71,0.33,220,33446,70,NULL,NULL,'2MASX J11363247+0410512',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000179,NULL,'16.0g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,174.1355,4.18094,0.029,NULL,60174954393,940233662,14691150,16),(82751,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82751,38.17,0.33,431,33447,70,NULL,NULL,'LCRS B113359.5-023626',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000143,NULL,'16.6g',0.37,NULL,NULL,NULL,NULL,NULL,1,174.137291667,-2.88369,0.081,NULL,40824238546,637878727,9966855,16.6),(82752,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82752,37.05,0.46,257,33448,70,NULL,NULL,'2MASX J11363298+2541221',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000183,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,174.1375,25.68944,0,NULL,60589506674,946711041,14792360,16.6),(82753,'IRAS','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82753,32.26,0.8,28.3,33449,75,NULL,'A82, H','NGC 3755',NULL,'1997ApJS..109..333W',1997,1,2.73,NULL,'G',0.000017,NULL,'13.8g',0.9,'SAB(rs)c pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,174.139041667,36.41033,0,NULL,60452109331,944564208,14758815,13.8),(82754,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82754,32.13,0.6,26.7,33449,NULL,NULL,'Malmquist cor.','NGC 3755',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82755,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82755,32.15,0.4,26.9,33449,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 3755',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82756,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82756,32.2,0.4,27.6,33449,75,NULL,'B','NGC 3755',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82757,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82757,32.5,0.2,31.6,33449,74.4,NULL,NULL,'NGC 3755',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82758,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82758,32.53,0.4,32,33449,NULL,NULL,'mean','NGC 3755',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82759,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82759,32.56,0.49,32.6,33449,NULL,NULL,NULL,'NGC 3755',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82760,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82760,32.63,0.43,33.6,33449,75,NULL,'3.6 micron, color corrected','NGC 3755',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82761,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82761,32.75,0.47,35.5,33449,75,NULL,'A82, H, raw','NGC 3755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82762,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82762,32.75,0.43,35.5,33449,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3755',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82763,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82763,32.78,0.47,36,33449,75,NULL,'A82, H, inv','NGC 3755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82764,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82764,33,0.47,39.8,33449,75,NULL,'A82, H, cor','NGC 3755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82765,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82765,33.48,0.46,49.6,33449,NULL,NULL,'J','NGC 3755',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82766,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82766,33.48,0.47,49.7,33449,NULL,NULL,'H','NGC 3755',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82767,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82767,38.48,0.46,496,33450,70,NULL,NULL,'2MASX J11363368+0437562',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000191,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,174.140333,4.63219,0.017,NULL,60172099308,940189051,14690453,17.7),(82768,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82768,37.86,0.46,373,33451,70,NULL,NULL,'2MASX J11363462+1930019',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,174.144375,19.50056,0,NULL,61080493478,954382710,14912229,NULL),(82769,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82769,37.73,0.27,352,33452,70,NULL,NULL,'2MASX J11363492+3312514',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000177,NULL,'16.6g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,174.1455417,33.21425,0,NULL,60623635796,947244309,14800692,16.6),(82770,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82770,37.84,0.46,370,33453,70,NULL,NULL,'SDSS J113635.48+484443.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000121,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,174.147833333,48.74556,0,NULL,61752646328,964885098,15076329,18.7),(82771,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82771,37.41,0.46,303,33454,70,NULL,NULL,'2MASX J11363586+2932391',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000147,NULL,'18.07',0.19,'E',NULL,NULL,NULL,NULL,1,174.149625,29.54439,0,NULL,60554056663,946157135,14783705,18.07),(82772,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82772,35.49,0.5,125,33455,70,NULL,NULL,'2MASX J11363661-3305055',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.4b',NULL,'S0',NULL,NULL,NULL,NULL,1,174.152416667,-33.08478,0.269,NULL,41584999466,649765616,10152587,16.4),(82773,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82773,36.02,0.11,160,33456,70,NULL,NULL,'CGCG 242-061',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000031,NULL,'15.0g',0.64,'S?','Group member',NULL,NULL,NULL,1,174.1527083,49.06306,0,NULL,61750982659,964859104,15075923,15),(82774,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82774,36.12,0.25,167,33456,74.4,NULL,NULL,'CGCG 242-061',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82775,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82775,31.29,NULL,18.1,33457,NULL,NULL,NULL,'UGC 06578',NULL,'2015AstBu..70....1K',2015,1,NULL,'Looks like a single SAB(s)m with several bright HII\'s (HGCJR;2008)','GPair',0.000014,NULL,NULL,NULL,'Irr            HII',NULL,NULL,NULL,NULL,1,174.153333,0.81611,0.033,NULL,60167728292,940120754,14689386,NULL),(82776,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82776,30.93,0.2,15.4,33458,74.4,NULL,NULL,'UGC 06578',NULL,'2013AJ....146...86T',2013,1,NULL,'Looks like a single SAB(s)m with several bright HII\'s (HGCJR;2008)','GPair',0.000014,NULL,NULL,NULL,'Irr            HII',NULL,NULL,NULL,NULL,1,174.153333,0.81611,0.033,NULL,60167728292,940120754,14689386,NULL),(82777,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82777,36.56,0.46,206,33459,70,NULL,NULL,'MCG +09-19-133',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000189,NULL,'15.8g',0.43,'AGN',NULL,NULL,NULL,NULL,1,174.15475,51.00239,0,NULL,61803404594,965678196,15088721,15.8),(82778,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82778,35.62,0.72,133,33460,70,NULL,NULL,'2MASX J11363850-2213434',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.91',0.2,NULL,NULL,NULL,NULL,NULL,1,174.1604583,-22.22875,0.085,NULL,41686523271,651351926,10177373,15.91),(82779,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82779,37.05,0.33,257,33461,70,NULL,NULL,'2MASX J11363912+5746456',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000161,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,174.162833333,57.77936,0,NULL,61989861171,968591580,15134243,16.9),(82780,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82780,37.66,0.27,341,33462,70,NULL,NULL,'SDSS J113639.14+142500.9',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000176,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,174.163083,14.41692,0.061,NULL,60256479262,941507488,14711054,17.2),(82781,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82781,33.92,0.46,60.7,33463,70,NULL,NULL,'CGCG 040-010',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.000151,NULL,'14.6g',0.64,'SA(r)0^0^ pec','Isolated galaxy',NULL,NULL,NULL,1,174.164875,6.29192,0.075,NULL,60382130459,943470788,14741731,14.6),(82782,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82782,36.71,0.33,220,33464,70,NULL,NULL,'2MASX J11363991+0412129',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,174.1662917,4.2035,0.029,NULL,60174900782,940232824,14691137,17.4),(82783,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82783,37.29,0.46,287,33465,70,NULL,NULL,'2MASX J11364016+4802011',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000159,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,174.167333,48.03369,0.018,NULL,61750293123,964848330,15075755,17.6),(82784,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82784,37.05,0.46,257,33466,70,NULL,NULL,'2MASX J11364026+1236286',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,174.167875,12.60819,0.046,NULL,60247535930,941367748,14708871,17.4),(82785,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82785,37.07,0.46,259,33467,70,NULL,NULL,'2MASX J11364089+5503565',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00016,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,174.1705417,55.06592,0,NULL,61763401138,965053142,15078955,16.9),(82786,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82786,37.8,0.46,362,33468,70,NULL,NULL,'2MASX J11364127+5051331',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000226,NULL,'16.9g',0.24,'AGN',NULL,NULL,NULL,NULL,1,174.17175,50.85914,0,NULL,61803908150,965686064,15088844,16.9),(82787,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82787,37.85,0.46,372,33469,70,NULL,NULL,'SDSS J113641.43+312926.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000146,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,174.172625,31.49067,0,NULL,60627308946,947301702,14801589,18.5),(82788,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82788,38.31,0.23,459,33470,70,NULL,NULL,'2MASX J11364203+0718136',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000177,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,174.175167,7.30389,0.101,NULL,60382795259,943481175,14741893,18),(82789,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82789,36.87,0.46,237,33471,70,NULL,NULL,'LCRS B113408.6-021702',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00015,NULL,'15.9g',0.45,'E0',NULL,NULL,NULL,NULL,1,174.175375,-2.56042,0.073,NULL,40829502467,637960976,9968140,15.9),(82790,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82790,38.17,0.33,431,33472,70,NULL,NULL,'2MASX J11364273-0251057',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,174.178167,-2.85153,0.081,NULL,40824267711,637879182,9966862,18.3),(82791,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82791,37.73,0.46,352,33473,70,NULL,NULL,'SDSS J113642.80+164520.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000164,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,174.178375,16.75581,0.019,NULL,60255624463,941494132,14710845,18.1),(82792,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82792,37.02,0.27,254,33474,70,NULL,NULL,'2MASX J11364305+1631366',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,174.1795,16.52703,0.025,NULL,60256297015,941504640,14711010,17.3),(82793,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82793,36.78,0.16,227,33475,70,NULL,NULL,'2MASX J11364346+5454475',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.00013,NULL,'15.6g',0.42,'E0',NULL,NULL,NULL,NULL,1,174.181166667,54.91303,0,NULL,61764126762,965064480,15079132,15.6),(82794,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82794,37.76,0.46,356,33476,70,NULL,NULL,'2MASX J11364351+3833130',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000172,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,174.181417,38.55364,0.018,NULL,60464589912,944759217,14761862,17.9),(82795,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82795,34.75,0.46,89.1,33477,70,NULL,NULL,'NGC 3761',NULL,'2015arXiv151105856S',2015,1,0.87,NULL,'G',0.00007,NULL,'14.8g',0.66,'E',NULL,NULL,NULL,NULL,1,174.183833,22.99203,0,NULL,61074168561,954283883,14910685,14.8),(82796,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82796,37.34,0.46,294,33478,70,NULL,NULL,'2MASX J11364500+4735205',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000147,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,174.187667,47.58914,0.013,NULL,63894324670,998348822,15599200,17.1),(82797,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82797,35.42,0.47,121,33479,NULL,NULL,'Malmquist cor.','ESO 571- G 009',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.28',0.3,'Sb',NULL,NULL,NULL,NULL,1,174.190708333,-22.22228,0.085,NULL,41686530307,651352036,10177375,15.28),(82798,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82798,35.51,0.45,126,33479,NULL,NULL,NULL,'ESO 571- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82799,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82799,35.55,0.2,129,33479,74.4,NULL,NULL,'ESO 571- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82800,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82800,38.25,0.46,447,33480,70,NULL,NULL,'2MASX J11364593+3958380',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000133,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,174.191167,39.97731,0,NULL,60459081217,944673144,14760517,18.4),(82801,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82801,38.59,0.46,523,33481,70,NULL,NULL,'SDSS J113645.88+123046.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,174.1912083,12.51289,0.046,NULL,60247739517,941370929,14708920,18.5),(82802,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82802,37.4,0.46,302,33482,70,NULL,NULL,'2MASX J11364617+3251514',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000182,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,174.192375,32.86425,0,NULL,60621634113,947213033,14800203,16.9),(82803,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82803,37.02,0.27,254,33483,70,NULL,NULL,'2MASX J11364618+1631226',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000174,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,174.192417,16.52308,0.025,NULL,60256342209,941505347,14711021,17.1),(82804,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82804,37.1,0.14,263,33484,70,NULL,NULL,'2MASX J11364651+2119539',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00013,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,174.19375,21.33169,0,NULL,61075119750,954298746,14910917,17.3),(82805,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82805,37.73,0.27,352,33485,70,NULL,NULL,'2MASX J11364735+3323304',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,174.197167,33.39186,0,NULL,60623679659,947244994,14800703,17.6),(82806,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82806,37.73,0.46,351,33486,70,NULL,NULL,'2MASX J11364741+3416384',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000171,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,174.1975,34.2775,0,NULL,60623713116,947245517,14800711,18.2),(82807,'IRAS','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82807,31.8,0.8,23,33487,75,NULL,'A82, H','NGC 3756',NULL,'1997ApJS..109..333W',1997,1,4.2,'SDSS and 2MASXi positions are off-center.','G',0.000016,NULL,'12.11',2.1,'SAB(rs)bc','in a radial-velocity based grouping',NULL,NULL,NULL,1,174.200083333,54.29356,0,NULL,61764302088,965067220,15079175,12.11),(82808,'IRAS','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82808,31.89,0.8,23.9,33487,75,NULL,'W91CL, r','NGC 3756',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82809,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82809,30.98,0.08,15.7,33487,NULL,NULL,NULL,'NGC 3756',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82810,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82810,31.14,0.4,16.9,33487,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 3756',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82811,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82811,31.45,0.36,19.5,33487,NULL,NULL,NULL,'NGC 3756',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82812,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82812,31.47,0.4,19.6,33487,NULL,NULL,'mean','NGC 3756',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82813,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82813,31.56,0.38,20.5,33487,75,NULL,'W91CL, r, raw','NGC 3756',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82814,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82814,31.65,0.38,21.4,33487,75,NULL,'W91CL, r, inv','NGC 3756',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82815,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82815,31.65,0.43,21.4,33487,75,NULL,'3.6 micron, color corrected','NGC 3756',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82816,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82816,31.67,0.2,21.6,33487,74.4,NULL,NULL,'NGC 3756',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82817,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82817,31.68,0.38,21.7,33487,75,NULL,'W91CL, r, cor','NGC 3756',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82818,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82818,31.69,0.43,21.8,33487,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3756',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82819,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82819,31.72,0.47,22,33487,75,NULL,'A82, H, raw','NGC 3756',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82820,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82820,31.74,0.46,22.3,33487,NULL,NULL,'J','NGC 3756',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82821,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82821,31.77,0.45,22.6,33487,NULL,NULL,'K','NGC 3756',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82822,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82822,31.77,0.47,22.6,33487,NULL,NULL,'H','NGC 3756',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82823,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82823,31.78,0.47,22.7,33487,75,NULL,'A82, H, inv','NGC 3756',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82824,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82824,31.86,0.4,23.5,33487,75,NULL,'B','NGC 3756',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82825,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82825,31.98,0.47,24.9,33487,75,NULL,'A82, H, cor','NGC 3756',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82826,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82826,34.43,0.49,76.9,33488,75,NULL,'IR','MCG -02-30-010',NULL,'2011yCatp016004901K',2011,1,1.46,NULL,'G',0.000023,NULL,'15.50',0.15,'SAcd: sp',NULL,NULL,NULL,NULL,1,174.203083,-12.97986,0.037,NULL,40988322392,640442537,10006914,15.5),(82827,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82827,34.61,0.2,83.6,33488,74.4,NULL,NULL,'MCG -02-30-010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82828,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82828,34.75,0.44,89,33488,NULL,NULL,'Malmquist cor.','MCG -02-30-010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82829,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82829,34.85,NULL,93.2,33488,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -02-30-010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82830,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82830,34.86,NULL,93.6,33488,NULL,NULL,'Dipole + Quadrupole','MCG -02-30-010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82831,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82831,34.87,NULL,94,33488,NULL,NULL,'Dipole','MCG -02-30-010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82832,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82832,34.89,0.41,95.1,33488,NULL,NULL,NULL,'MCG -02-30-010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82833,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82833,38.37,0.46,472,33489,70,NULL,NULL,'LCRS B113415.5-025223',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,174.203833333,-3.14967,0.057,NULL,40824434525,637881789,9966902,17.4),(82834,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82834,37.73,0.27,352,33490,70,NULL,NULL,'2MASX J11364927+3321554',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000188,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,174.205083,33.36547,0,NULL,60623683250,947245050,14800703,17.9),(82835,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82835,33.56,0.46,51.4,33491,70,NULL,NULL,'MCG -01-30-012',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000103,NULL,'14.48',0.9,'S0^0^:',NULL,NULL,NULL,NULL,1,174.207417,-9.56783,0.037,NULL,41031190787,641112356,10017380,14.48),(82836,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82836,36.99,0.46,250,33492,70,NULL,NULL,'2MASX J11365006+0527559',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000169,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,174.208833,5.46561,0.037,NULL,60171545517,940180398,14690318,16.9),(82837,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82837,36.56,0.46,205,33493,70,NULL,NULL,'2MASX J11365084+2243099',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000158,NULL,'16.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,174.211875,22.71964,0,NULL,61074078179,954282471,14910663,16.8),(82838,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82838,37.88,0.46,376,33494,70,NULL,NULL,'2MASX J11365140+1633536',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,174.2142083,16.56486,0.025,NULL,60255461776,941491590,14710806,17.3),(82839,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82839,38.01,0.33,400,33495,70,NULL,NULL,'2MASX J11365294+0858476',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,174.220583333,8.97986,0.096,NULL,60387591174,943556112,14743064,17.5),(82840,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82840,37.25,0.46,282,33496,70,NULL,NULL,'2MASX J11365343+0125559',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000078,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,174.2224583,1.43208,0.053,NULL,60168872764,940138636,14689666,17.1),(82841,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82841,36.63,0.46,212,33497,70,NULL,NULL,'2MASX J11365346+2527061',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000185,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,174.22275,25.45169,0,NULL,60589488768,946710762,14792355,16.5),(82842,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82842,37.39,0.19,300,33498,70,NULL,NULL,'2MASX J11365379+1601296',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000187,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,174.224291667,16.02483,0.023,NULL,60255871558,941497993,14710906,16.4),(82843,'D-Sigma','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82843,32.88,0.4,37.7,33499,75,NULL,'Edat, raw','NGC 3759',NULL,'1997ApJS..109..333W',1997,1,1.1,'LEDA 094203 superposed 17 arcsec southwest.','G',0.000083,NULL,'14.24',1.1,'SAB0^0^:','in a radial-velocity based grouping',NULL,NULL,NULL,1,174.225375,54.82331,0,NULL,61764130926,965064545,15079133,14.24),(82844,'D-Sigma','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82844,33.22,0.4,44,33499,75,NULL,'Edat, cor','NGC 3759',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82845,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82845,34.66,0.4,85.4,33499,NULL,NULL,'mean','NGC 3759',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82846,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82846,34.75,0.45,88.9,33499,NULL,NULL,'K','NGC 3759',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82847,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82847,35.61,0.53,133,33500,70,NULL,NULL,'IC 0715nw',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000137,NULL,'15.03',0.5,NULL,NULL,NULL,NULL,NULL,1,174.225875,-8.37581,0.053,NULL,41055949593,641499212,10023425,15.03),(82848,'IRAS','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82848,34.61,0.8,83.4,33501,75,NULL,'W91CL, r','UGC 06583',NULL,'1997ApJS..109..333W',1997,1,0.7,NULL,'G',0.00001,NULL,'14.36',0.4,'SBa pec        HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,174.226667,19.97083,0,NULL,61079733690,954370838,14912044,14.36),(82849,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82849,34.68,0.43,86.2,33501,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06583',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82850,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82850,34.83,0.43,92.3,33501,75,NULL,'3.6 micron, color corrected','UGC 06583',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82851,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82851,34.99,0.38,99.7,33501,75,NULL,'W91CL, r, raw','UGC 06583',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82852,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82852,35.01,0.06,101,33501,NULL,NULL,NULL,'UGC 06583',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82853,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82853,35.05,0.2,102,33501,74.4,NULL,NULL,'UGC 06583',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82854,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82854,35.15,0.38,107,33501,75,NULL,'W91CL, r, inv','UGC 06583',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82855,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82855,35.16,0.38,108,33501,75,NULL,'W91CL, r, cor','UGC 06583',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82856,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82856,38.19,0.27,435,33502,70,NULL,NULL,'LCRS B113421.3-025945',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000141,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,174.228333,-3.27222,0.129,NULL,40824403379,637881302,9966895,18.5),(82857,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82857,36.08,0.2,164,33503,74.4,NULL,NULL,'CGCG 068-010',NULL,'2013AJ....146...86T',2013,1,0.62,NULL,'G',0.000008,NULL,'15.7g',0.24,'Im',NULL,NULL,NULL,NULL,1,174.2307917,11.84822,0.059,NULL,60247208984,941362640,14708791,15.7),(82858,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82858,38.22,0.46,440,33504,70,NULL,NULL,'2MASX J11365552+2703506',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,174.231375,27.06406,0,NULL,60584018399,946625287,14791020,17.7),(82859,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82859,36.37,0.46,188,33505,70,NULL,NULL,'2MASX J11365696+1628526',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000175,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,174.2372917,16.48131,0.025,NULL,60256353778,941505527,14711023,16.3),(82860,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82860,37.52,0.46,319,33506,70,NULL,NULL,'2MASX J11365692+4413399',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000184,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,174.237333,44.22781,0.054,NULL,63904002301,998500035,15601563,16.4),(82861,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82861,35.93,0.56,154,33507,70,NULL,NULL,'2MASX J11365731-7958293',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,174.239167,-79.97481,0.569,NULL,39745732595,621027071,9703547,17.4),(82862,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82862,37.39,0.19,300,33508,70,NULL,NULL,'2MASX J11365796+1551370',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000176,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,174.241583333,15.86022,0.016,NULL,60259078677,941548104,14711689,16.8),(82863,'IRAS','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82863,33.76,0.8,56.4,33509,75,NULL,'A82, H','UGC 06586',NULL,'1997ApJS..109..333W',1997,1,1.22,NULL,'G',0.00001,NULL,'14.6g',0.88,'SABbc','Group member',NULL,NULL,NULL,1,174.257917,15.57061,0.033,NULL,60256992803,941515512,14711179,14.6),(82864,'IRAS','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82864,33.76,0.8,56.4,33509,75,NULL,'HMCL, I','UGC 06586',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82865,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82865,33.84,0.47,58.5,33509,75,NULL,'A82, H, raw','UGC 06586',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82866,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82866,33.9,0.47,60.2,33509,75,NULL,'A82, H, inv','UGC 06586',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82867,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82867,34.17,0.47,68.4,33509,75,NULL,'A82, H, cor','UGC 06586',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82868,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82868,34.19,0.43,68.9,33509,75,NULL,'3.6 micron, color corrected','UGC 06586',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82869,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82869,34.2,0.43,69.1,33509,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06586',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82870,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82870,34.24,0.2,70.5,33509,74.4,NULL,NULL,'UGC 06586',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82871,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82871,34.35,0.4,74,33509,75,NULL,'HMCL, I, raw','UGC 06586',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82872,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82872,34.51,0.4,79.9,33509,75,NULL,'HMCL, I, inv','UGC 06586',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82873,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82873,34.63,0.4,84.5,33509,75,NULL,'HMCL, I, cor','UGC 06586',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82874,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82874,33.16,0.47,42.9,33510,NULL,NULL,'H','ESO 378- G 012',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000103,NULL,'14.29',0.6,'SAab:          HII',NULL,NULL,NULL,NULL,1,174.260375,-36.81536,0.421,NULL,41392656413,646760256,10105629,14.29),(82875,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82875,33.18,0.45,43.2,33510,NULL,NULL,'K','ESO 378- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82876,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82876,33.23,0.4,44.2,33510,NULL,NULL,'mean','ESO 378- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82877,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82877,33.24,0.46,44.5,33510,NULL,NULL,'J','ESO 378- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82878,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82878,35.13,0.69,106,33511,100,NULL,'mid-IR','NGC 3765',NULL,'2013ApJ...771...88L',2013,1,1.15,NULL,'G',0.000007,NULL,'14.6g',0.63,'Sbc',NULL,NULL,NULL,NULL,1,174.267416667,24.09625,0,NULL,60587126227,946673847,14791778,14.6),(82879,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82879,36.6,0.2,209,33511,74.4,NULL,NULL,'NGC 3765',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82880,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82880,35.52,0.46,127,33512,70,NULL,NULL,'IC 2945 NED01',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00011,NULL,'15.93',0.38,'E/S0',NULL,NULL,NULL,NULL,1,174.267917,12.92644,0,NULL,60250401554,941412524,14709570,15.93),(82881,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82881,34.75,0.33,89.1,33513,70,NULL,NULL,'2MASX J11370491+1955257',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000077,NULL,'15.85',0.35,NULL,NULL,NULL,NULL,NULL,1,174.270541667,19.92378,0,NULL,61079723618,954370681,14912041,15.85),(82882,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82882,38.04,0.46,406,33514,70,NULL,NULL,'SDSS J113704.99+185344.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,174.270833,18.89567,0,NULL,61081091458,954392054,14912375,18.5),(82883,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82883,37.92,0.46,383,33515,70,NULL,NULL,'2MASX J11370536+1932367',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,174.2724583,19.54356,0,NULL,61080556787,954383699,14912245,17),(82884,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82884,37.35,0.46,295,33516,70,NULL,NULL,'2MASX J11370564+4435510',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,174.2735417,44.59756,0,NULL,63904267932,998504186,15601627,16.9),(82885,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82885,34.89,0.54,95.2,33517,NULL,NULL,'Malmquist cor.','VV 754 NED01',NULL,'2009ApJS..182..474S',2009,1,0.07,NULL,'G',0.000039,NULL,'19.1g',0.07,'Sc             VLIRG','Pair member (points to parent)',NULL,NULL,NULL,1,174.2785,2.84575,0.029,NULL,60173595725,940212433,14690819,19.1),(82886,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82886,35.02,0.51,101,33517,NULL,NULL,NULL,'VV 754 NED01',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82887,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82887,35.06,0.2,103,33517,74.4,NULL,NULL,'VV 754 NED01',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82888,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82888,35.64,0.58,134,33518,70,NULL,NULL,'ESO 378- G 013',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00012,NULL,'15.45',0.3,'Sa',NULL,NULL,NULL,NULL,1,174.284625,-32.82136,0.269,NULL,41586831725,649794245,10153035,15.45),(82889,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82889,37.39,0.19,300,33519,70,NULL,NULL,'2MASX J11370849+1554071',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000172,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,174.28525,15.90197,0.016,NULL,60259080425,941548131,14711689,18),(82890,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82890,30.85,NULL,14.8,33520,NULL,NULL,NULL,'SDSS J113708.79+131504.9',NULL,'2015AstBu..70....1K',2015,1,0.54,NULL,'G',0.000047,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,174.286667,13.25136,0,NULL,60249589850,941399841,14709372,17.4),(82891,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82891,38.38,0.33,474,33521,70,NULL,NULL,'2MASX J11370908+2714147',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000186,NULL,'17.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,174.287667,27.23742,0,NULL,60584091409,946626428,14791037,17.6),(82892,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82892,38.01,0.33,400,33522,70,NULL,NULL,'2MASX J11371076+0858018',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,174.2949583,8.96725,0.086,NULL,60369814718,943278354,14738724,17.2),(82893,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82893,37.39,0.19,300,33523,70,NULL,NULL,'2MASX J11371160+1556331',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000163,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,174.298375,15.9425,0.023,NULL,60255652473,941494569,14710852,18.1),(82894,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82894,38.19,0.27,435,33524,70,NULL,NULL,'LCRS B113440.0-025959',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000155,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,174.3060417,-3.27614,0.065,NULL,40824368172,637880752,9966886,17.7),(82895,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82895,33.71,0.2,55.2,33525,74.4,NULL,NULL,'UGC 06588',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000003,NULL,'14.71',0.5,'Sbc',NULL,NULL,NULL,NULL,1,174.306333333,15.43253,0.033,NULL,60257203769,941518808,14711231,14.71),(82896,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82896,33.75,0.45,56.3,33525,NULL,NULL,NULL,'UGC 06588',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82897,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82897,33.85,0.43,58.8,33525,NULL,NULL,'Malmquist cor.','UGC 06588',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82898,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82898,37.97,0.46,393,33526,70,NULL,NULL,'2MASX J11371398+1704591',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000203,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,174.3082917,17.08314,0.014,NULL,60200865678,940638526,14697476,16.8),(82899,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82899,38.36,0.46,470,33527,70,NULL,NULL,'2MASX J11371441+3559269',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,174.310167,35.99089,0.03,NULL,60451981067,944562204,14758784,17.5),(82900,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82900,38.97,0.46,623,33528,70,NULL,NULL,'SDSS J113714.63+093507.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000144,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,174.311,9.58533,0.095,NULL,60370298238,943285909,14738842,18.6),(82901,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82901,38.07,0.46,411,33529,70,NULL,NULL,'2MASX J11371522+1542171',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000141,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,174.313417,15.70469,0.016,NULL,60259070305,941547973,14711687,18.7),(82902,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82902,34.8,0.45,91.1,33530,NULL,NULL,'K','NGC 3767',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000103,NULL,'14.35',0.9,'(R)SB(r)0^0^?',NULL,NULL,NULL,NULL,1,174.314833,16.87717,0.012,NULL,60255625493,941494148,14710846,14.35),(82903,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82903,34.97,0.4,98.6,33530,NULL,NULL,'mean','NGC 3767',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82904,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82904,37.53,0.27,320,33531,70,NULL,NULL,'2MASX J11371633+5527253',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000176,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,174.317917,55.45694,0,NULL,61763281728,965051277,15078926,17.2),(82905,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82905,36.85,0.46,234,33532,70,NULL,NULL,'2MASX J11371719+5240469',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,174.32175,52.67989,0,NULL,61792797834,965512466,15086132,17),(82906,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82906,36.9,0.46,240,33533,70,NULL,NULL,'2MASX J11371737+5739183',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000182,NULL,'16.0g',0.44,'S0^-',NULL,NULL,NULL,NULL,1,174.322583,57.65506,0,NULL,61990306329,968598536,15134352,16),(82907,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82907,38.38,0.33,474,33534,70,NULL,NULL,'2MASX J11371746+2706137',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000161,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,174.322833,27.10369,0,NULL,60584062623,946625978,14791030,17.4),(82908,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82908,37.22,0.46,279,33535,70,NULL,NULL,'2MASX J11371771+2720417',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000181,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,174.323833333,27.34503,0,NULL,60583945638,946624150,14791002,16.6),(82909,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82909,38.19,0.27,435,33536,70,NULL,NULL,'LCRS B113444.5-025331',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000181,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,174.3247917,-3.16839,0.065,NULL,40824422594,637881603,9966900,17.3),(82910,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82910,36.34,0.33,186,33537,70,NULL,NULL,'2MASX J11371831-0051570',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00008,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,174.326208333,-0.86572,0.049,NULL,40827998859,637937482,9967773,16.6),(82911,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82911,37.39,0.19,300,33538,70,NULL,NULL,'2MASX J11371909+1558491',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000151,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,174.3295,15.98031,0.023,NULL,60255653538,941494586,14710852,17),(82912,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82912,38.46,0.46,492,33539,70,NULL,NULL,'SDSS J113719.32+435608.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000145,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,174.3305,43.93558,0,NULL,63902019103,998469048,15601078,18.7),(82913,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82913,36.66,0.46,215,33540,70,NULL,NULL,'2MASX J11372051+0412031',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000175,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,174.335583333,4.20089,0.013,NULL,60181446964,940335108,14692736,16.5),(82914,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82914,37.56,0.46,325,33541,70,NULL,NULL,'2MASX J11372109+3211518',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,174.337875,32.19775,0,NULL,60629488410,947335756,14802121,17.6),(82915,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82915,38.67,0.46,542,33542,70,NULL,NULL,'2MASX J11372199+5414182',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,174.341875,54.23839,0,NULL,61764299232,965067175,15079174,18.2),(82916,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82916,35.68,0.07,137,33543,NULL,NULL,NULL,'2MASX J11372321+4910409',NULL,'2009ApJS..182..474S',2009,1,0.38,NULL,'G',0.000037,NULL,'17.0g',0.23,'Sc','Group member',NULL,NULL,NULL,1,174.3464583,49.17819,0,NULL,61751477955,964866843,15076044,17),(82917,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82917,38.05,0.46,407,33544,70,NULL,NULL,'2MASX J11372323+0257581',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000079,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,174.3467917,2.96597,0.029,NULL,60180930854,940327044,14692610,17.4),(82918,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82918,38.68,0.46,544,33545,70,NULL,NULL,'2MASX J11372424+2721426',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,174.3509583,27.36183,0,NULL,60583949404,946624209,14791003,17.9),(82919,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82919,37.39,0.19,300,33546,70,NULL,NULL,'2MASX J11372707+1602541',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,174.362917,16.04833,0.023,NULL,60255864581,941497884,14710904,18),(82920,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,'R',82920,36.34,0.33,186,33547,70,NULL,NULL,'CGCG 012-043',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000093,NULL,'15.5g',0.45,'E0',NULL,NULL,NULL,NULL,1,174.364416667,-0.84658,0.049,NULL,40827953453,637936772,9967762,15.5),(82921,'FP','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82921,36.58,0.85,207,33548,70,NULL,NULL,'2MASX J11372971-1054224',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.48',NULL,NULL,NULL,NULL,NULL,NULL,1,174.3737083,-10.90633,0.005,NULL,41028850338,641075786,10016809,16.48),(82922,'IRAS','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82922,34.9,0.8,95.6,33549,75,NULL,'HMCL, I','KUG 1134+226',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'15.25',0.3,'Sbc',NULL,NULL,NULL,NULL,1,174.37675,22.39969,0,NULL,61077195788,954331184,14911424,15.25),(82923,'IRAS','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82923,34.91,0.8,96,33549,75,NULL,'W91CL, r','KUG 1134+226',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82924,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82924,34.7,0.38,87.1,33549,75,NULL,'W91CL, r, raw','KUG 1134+226',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82925,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82925,34.72,0.4,87.8,33549,75,NULL,'HMCL, I, raw','KUG 1134+226',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82926,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82926,34.74,0.2,88.7,33549,74.4,NULL,NULL,'KUG 1134+226',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82927,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82927,34.74,0.43,88.8,33549,75,NULL,'3.6 micron, color corrected','KUG 1134+226',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82928,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82928,34.77,0.38,89.8,33549,75,NULL,'W91CL, r, inv','KUG 1134+226',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82929,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:57','1',NULL,NULL,82929,34.8,0.43,91.2,33549,75,NULL,'3.6 micron, color + selection bias corrected','KUG 1134+226',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82930,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82930,34.83,0.4,92.5,33549,75,NULL,'HMCL, I, inv','KUG 1134+226',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82931,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82931,34.92,0.38,96.4,33549,75,NULL,'W91CL, r, cor','KUG 1134+226',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82932,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82932,34.93,0.13,97,33549,NULL,NULL,NULL,'KUG 1134+226',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82933,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82933,34.96,0.4,98.4,33549,75,NULL,'HMCL, I, cor','KUG 1134+226',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82934,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',82934,37.53,0.27,320,33550,70,NULL,NULL,'2MASX J11373243+5528140',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,174.38525,55.47056,0,NULL,61763231148,965050486,15078913,17.8),(82935,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',82935,37.37,0.46,298,33551,70,NULL,NULL,'2MASX J11373383+0148570',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000297,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,174.391083,1.81589,0.025,NULL,60186578680,940415291,14693988,16.8),(82936,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',82936,36.78,0.16,227,33552,70,NULL,NULL,'MCG +09-19-139',NULL,'2015arXiv151105856S',2015,1,0.71,'MCG declination is -10 arcmin in error.','G',0.000097,NULL,'15.2g',0.53,'E0',NULL,NULL,NULL,NULL,1,174.392791667,54.85328,0,NULL,61764088008,965063875,15079123,15.2),(82937,'IRAS','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82937,35.19,0.8,109,33553,75,NULL,'HMCL, I','CGCG 097-033',NULL,'1997ApJS..109..333W',1997,1,0.7,NULL,'G',0.00001,NULL,'15.39',0.4,'SB:a','Group non-member, background',NULL,NULL,NULL,1,174.3997917,20.164,0,NULL,61081726176,954401971,14912530,15.39),(82938,'IRAS','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82938,35.2,0.8,110,33553,75,NULL,'W91CL, r','CGCG 097-033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82939,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82939,35.21,0.47,110,33553,NULL,NULL,'Malmquist cor.','CGCG 097-033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82940,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82940,35.41,0.38,121,33553,75,NULL,'W91CL, r, raw','CGCG 097-033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82941,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82941,35.43,0.4,122,33553,75,NULL,'HMCL, I, raw','CGCG 097-033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82942,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82942,35.5,0.41,126,33553,NULL,NULL,NULL,'CGCG 097-033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82943,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82943,35.54,0.2,128,33553,74.4,NULL,NULL,'CGCG 097-033',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82944,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82944,35.57,0.38,130,33553,75,NULL,'W91CL, r, inv','CGCG 097-033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82945,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82945,35.61,0.38,133,33553,75,NULL,'W91CL, r, cor','CGCG 097-033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82946,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82946,35.62,0.4,133,33553,75,NULL,'HMCL, I, inv','CGCG 097-033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82947,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82947,35.67,0.4,136,33553,75,NULL,'HMCL, I, cor','CGCG 097-033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82948,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82948,36.78,0.2,227,33554,74.4,NULL,NULL,'CGCG 068-012',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.000218,NULL,'15.9g',0.23,'Sbc',NULL,NULL,NULL,NULL,1,174.399916667,9.47286,0.095,NULL,60370281169,943285643,14738838,15.9),(82949,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',82949,37.94,0.33,387,33555,70,NULL,NULL,'2MASX J11373633+1729277',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000134,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,174.401375,17.49108,0.014,NULL,61077555100,954336798,14911512,18.2),(82950,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',82950,38.13,0.33,424,33556,70,NULL,NULL,'2MASX J11373672+3226409',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000163,NULL,'16.5g',0.36,'BrClG',NULL,NULL,NULL,NULL,1,174.403125,32.44461,0,NULL,60629376790,947334012,14802093,16.5),(82951,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82951,31.29,NULL,18.1,33557,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06594',NULL,'2010Ap&SS.325..163P',2010,1,2.51,NULL,'G',0.000003,NULL,'14.7g',0.43,'Scd',NULL,NULL,NULL,NULL,1,174.404416667,16.55622,0.012,NULL,60256412404,941506443,14711038,14.7),(82952,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82952,31.3,NULL,18.2,33557,NULL,NULL,'Dipole + Quadrupole','UGC 06594',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82953,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82953,31.31,NULL,18.3,33557,NULL,NULL,'Dipole','UGC 06594',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82954,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82954,31.37,NULL,18.8,33557,NULL,NULL,NULL,'UGC 06594',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82955,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82955,31.6,0.2,20.9,33557,74.4,NULL,NULL,'UGC 06594',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82956,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82956,31.64,0.4,21.3,33557,NULL,NULL,NULL,'UGC 06594',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82957,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82957,31.66,0.43,21.5,33557,75,NULL,'3.6 micron, color corrected','UGC 06594',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82958,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82958,31.66,0.43,21.5,33557,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06594',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82959,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',82959,31.7,0.4,21.8,33557,75,NULL,NULL,'UGC 06594',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82960,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',82960,31.98,0.49,24.8,33557,75,NULL,'IR','UGC 06594',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82961,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',82961,38.42,0.46,484,33558,70,NULL,NULL,'2MASX J11373722+4802129',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,174.40525,48.037,0.005,NULL,61750405180,964850080,15075782,17.7),(82962,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',82962,38.18,0.46,433,33559,70,NULL,NULL,'2MASX J11373759+0617598',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,174.406833,6.3,0.034,NULL,60372953209,943327393,14739490,17.7),(82963,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',82963,36.89,0.46,239,33560,70,NULL,NULL,'LCRS B113504.3-030459',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000143,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,174.407417,-3.35947,0.129,NULL,40854739338,638355302,9974301,16.9),(82964,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',82964,38.02,0.33,401,33561,70,NULL,NULL,'2MASX J11373831+3121289',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000143,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,174.4095417,31.35794,0,NULL,60627639480,947306866,14801669,18.2),(82965,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',82965,37.97,0.46,393,33562,70,NULL,NULL,'SDSS J113738.36+093116.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,174.409833,9.52125,0.095,NULL,60370284621,943285697,14738839,18.3),(82966,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',82966,36.78,0.16,227,33563,70,NULL,NULL,'2MASX J11373916+5456260',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000172,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,174.413,54.94058,0,NULL,61763363604,965052556,15078946,16.5),(82967,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',82967,37.34,0.33,294,33564,70,NULL,NULL,'2MASX J11374023+5704420',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,174.417625,57.07828,0,NULL,61976356697,968380573,15130946,17.7),(82968,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82968,35.83,0.67,147,33565,70,NULL,NULL,'2MASX J11374061-4444180',NULL,'2014MNRAS.445.2677S',2014,1,NULL,'Northwest component of pair.','G',0.00015,NULL,'16.53',NULL,'(R\')SAB(r)0/a',NULL,NULL,NULL,NULL,1,174.41925,-44.73839,0.217,NULL,41892622177,654572221,10227690,16.53),(82969,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',82969,38.13,0.33,424,33566,70,NULL,NULL,'2MASX J11374067+3227229',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000179,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,174.419625,32.45636,0,NULL,60629376143,947334002,14802093,17.5),(82970,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',82970,37.94,0.33,387,33567,70,NULL,NULL,'2MASX J11374339+1737267',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,174.431,17.62414,0.006,NULL,61077584758,954337261,14911519,18.1),(82971,'Ring Diameter','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82971,32.8,0.84,37,33568,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3746',NULL,'1981ApJS...45..541P',1981,1,1.1,'Called \'Arp 320a\' in UGC notes.','G',0.000067,NULL,'15.01',0.5,'SB(r)b         RET','in an interacting septet',NULL,NULL,NULL,1,174.43175,22.00983,0.014,NULL,61077304660,954332885,14911451,15.01),(82972,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',82972,37.56,0.17,326,33569,70,NULL,NULL,'2MASX J11374391+1314117',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,174.433083333,13.23669,0.051,NULL,60249586263,941399785,14709371,17.1),(82973,'IRAS','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82973,30.83,0.8,14.6,33570,75,NULL,'CF, r','NGC 3769',NULL,'1997ApJS..109..333W',1997,1,4.1,'Called \'Arp 280a\' in UGC notes.','G',0.000006,NULL,'12.5g',0.82,'SB(r)b:','Probable group member',NULL,NULL,NULL,1,174.4337917,47.89308,0.005,NULL,61750622944,964853483,15075835,12.5),(82974,'Tully est','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82974,31.15,0.8,17,33570,75,NULL,'B','NGC 3769',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82975,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82975,30,0.4,10,33570,73,NULL,'opt','NGC 3769',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82976,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82976,30.83,NULL,14.7,33570,NULL,NULL,'B','NGC 3769',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82977,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82977,30.84,0.38,14.7,33570,75,NULL,'CF, r, inv','NGC 3769',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82978,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82978,30.86,0.38,14.9,33570,75,NULL,'CF, r, raw','NGC 3769',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82979,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82979,30.98,0.1,15.7,33570,NULL,NULL,NULL,'NGC 3769',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82980,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82980,30.98,NULL,15.7,33570,NULL,NULL,'I','NGC 3769',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82981,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',82981,31.01,NULL,15.9,33570,NULL,NULL,'B, Hubble-type-TF','NGC 3769',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82982,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82982,31.06,0.38,16.3,33570,75,NULL,'CF, r, cor','NGC 3769',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82983,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82983,31.06,0.36,16.3,33570,NULL,NULL,NULL,'NGC 3769',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82984,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82984,31.1,0.4,16.6,33570,NULL,NULL,'mean','NGC 3769',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82985,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',82985,31.16,NULL,17.1,33570,NULL,NULL,'B','NGC 3769',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82986,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',82986,31.19,NULL,17.3,33570,NULL,NULL,'I, Hubble-type-TF','NGC 3769',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82987,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',82987,31.28,NULL,18,33570,NULL,NULL,'I','NGC 3769',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82988,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82988,31.4,0.47,19.1,33570,NULL,NULL,'H','NGC 3769',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82989,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82989,31.43,0.46,19.4,33570,NULL,NULL,'J','NGC 3769',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82990,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,82990,31.49,0.45,19.8,33570,NULL,NULL,'K','NGC 3769',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(82991,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',82991,37.14,0.46,268,33571,70,NULL,NULL,'2MASX J11374439+1239197',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.55',0.21,NULL,NULL,NULL,NULL,NULL,1,174.435083333,12.65539,0,NULL,60247730530,941370789,14708918,17.55),(82992,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',82992,38.02,0.33,401,33572,70,NULL,NULL,'2MASX J11374487+3114229',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000164,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,174.436875,31.23967,0,NULL,60627864543,947310383,14801724,17.3),(82993,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',82993,38.63,0.46,532,33573,70,NULL,NULL,'2MASX J11374546+5653331',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000144,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,174.4395417,56.8925,0,NULL,61977658616,968400915,15131264,17.8),(82994,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',82994,37.63,0.33,336,33574,70,NULL,NULL,'2MASX J11374559+0059260',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000092,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,174.4399583,0.9905,0.049,NULL,60184703785,940385996,14693531,16.7),(82995,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',82995,37.54,0.46,322,33575,70,NULL,NULL,'2MASX J11374751+0647058',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,174.4480417,6.785,0.08,NULL,60373571362,943337052,14739641,17.1),(82996,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',82996,37.34,0.33,294,33576,70,NULL,NULL,'2MASX J11374769+5709191',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000161,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,174.448625,57.15517,0,NULL,61976400507,968381257,15130957,17.4),(82997,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',82997,37.92,0.46,384,33577,70,NULL,NULL,'2MASX J11374798+3103169',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000168,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,174.4499583,31.05469,0,NULL,60627790796,947309231,14801706,17),(82998,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',82998,38.58,0.46,519,33578,70,NULL,NULL,'2MASX J11374891+4904439',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000167,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,174.4537917,49.07897,0,NULL,61751454001,964866468,15076038,18.2),(82999,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',82999,37.68,0.46,344,33579,70,NULL,NULL,'2MASX J11374899+4812269',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,174.4542917,48.20742,0.013,NULL,61749926687,964842604,15075665,17.2),(83000,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83000,32.92,0.2,38.4,33580,74.4,NULL,NULL,'UGC 06596',NULL,'2013AJ....146...86T',2013,1,1.1,'VV misprints R.A. as 11h31.55m.','G',0.000017,NULL,'15.20',0.7,'IBm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,174.459583,56.14503,0,NULL,61988742445,968574100,15133970,15.2),(83001,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83001,35.24,0.5,112,33581,70,NULL,NULL,'2MASX J11375067-5044283',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,174.461125,-50.74122,0.673,NULL,40060826339,625950411,9780475,15.6),(83002,'Tully est','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83002,31.15,0.8,17,33582,75,NULL,'B','NGC 3769A',NULL,'1988NBGC.C....0000T',1988,1,1.1,'Called \'Arp 280b\' in UGC notes.','G',0.000013,NULL,'14.72',0.4,'SBm pec:','Probable group member',NULL,NULL,NULL,1,174.464,47.88133,0.005,NULL,61750623017,964853484,15075835,14.72),(83003,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83003,35.7,0.21,138,33583,70,NULL,NULL,'NGC 3750',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.00012,NULL,'14.91',0.7,'SAB0-?','in an interacting septet',NULL,NULL,NULL,1,174.465167,21.97425,0,NULL,61077301376,954332834,14911450,14.91),(83004,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83004,35.14,0.5,107,33584,70,NULL,NULL,'2MASX J11375168-1702557',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'16.02',0.5,NULL,NULL,NULL,NULL,NULL,1,174.4654583,-17.04894,0.045,NULL,40991038390,640484974,10007577,16.02),(83005,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83005,35.7,0.21,138,33585,70,NULL,NULL,'CGCG 127-011',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.00008,NULL,'14.91',0.5,'S0- pec?','Group member',NULL,NULL,NULL,1,174.468917,21.79931,0,NULL,61077273898,954332404,14911443,14.91),(83006,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83006,37.11,0.46,265,33586,70,NULL,NULL,'2MASX J11375317+2251490',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,174.471417,22.86358,0,NULL,61073989206,954281081,14910641,17.8),(83007,'TRGB','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83007,28.83,0.04,5.83,33587,NULL,NULL,'I','ESO 320- G 014',NULL,'2009AJ....138..332J',2009,1,1.1,'Marginal HIPASS detection.','G',0.000025,NULL,'15.85',0.9,'Dwarf',NULL,NULL,NULL,NULL,1,174.471833,-39.22033,0.441,NULL,41395154010,646799281,10106238,15.85),(83008,'TRGB','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83008,28.86,0.1,5.92,33587,NULL,NULL,NULL,'ESO 320- G 014',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83009,'TRGB','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83009,28.89,0.1,6,33587,74.4,NULL,NULL,'ESO 320- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83010,'TRGB','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83010,28.9,NULL,6.03,33587,NULL,NULL,NULL,'ESO 320- G 014',NULL,'2007AJ....133..504K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83011,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83011,35.7,0.21,138,33588,70,NULL,NULL,'NGC 3751',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.00013,NULL,'15.23',0.4,'E4','in an interacting septet',NULL,NULL,NULL,1,174.474417,21.93647,0,NULL,61077321842,954333153,14911455,15.23),(83012,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83012,36.46,0.46,196,33589,70,NULL,NULL,'LCRS B113520.7-030914',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000127,NULL,'15.8g',0.42,'S0',NULL,NULL,NULL,NULL,1,174.47575,-3.43058,0.129,NULL,40854746781,638355418,9974303,15.8),(83013,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83013,36.99,0.67,250,33589,70,NULL,NULL,'LCRS B113520.7-030914',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83014,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83014,37.63,0.33,336,33590,70,NULL,NULL,'SDSS J113754.63+005834.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000068,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,174.477667,0.97622,0.049,NULL,60184709002,940386078,14693532,18.3),(83015,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83015,35.82,0.33,146,33591,70,NULL,NULL,'VV 653 NED01',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000073,NULL,'15.1g',0.48,'E0',NULL,NULL,NULL,NULL,1,174.478167,47.46636,0,NULL,63894005144,998343830,15599122,15.1),(83016,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83016,37.47,0.46,312,33592,70,NULL,NULL,'2MASX J11375686+0053390',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000073,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,174.486791667,0.894,0.049,NULL,60184718291,940386223,14693534,17.7),(83017,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83017,37.16,0.27,271,33593,70,NULL,NULL,'2MASX J11375723+5542071',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000183,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,174.48825,55.70211,0,NULL,61988728112,968573876,15133966,16.3),(83018,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83018,37.46,0.46,310,33594,70,NULL,NULL,'2MASX J11375785+3129429',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000181,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,174.491125,31.49536,0,NULL,60627623568,947306618,14801665,16.7),(83019,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83019,35.99,0.46,158,33595,70,NULL,NULL,'2MASX J11375801+1148358',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000167,NULL,'16.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,174.491667,11.80989,0.078,NULL,60247213748,941362714,14708792,16.8),(83020,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83020,35.26,0.07,113,33596,70,NULL,NULL,'CGCG 127-010',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000063,NULL,'15.7',0.3,'E',NULL,NULL,NULL,NULL,1,174.492625,20.77858,0,NULL,61082507860,954414185,14912721,15.7),(83021,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83021,37.69,0.33,345,33597,70,NULL,NULL,'2MASX J11375898+1344105',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000154,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,174.49575,13.73619,0.088,NULL,60250120749,941408136,14709502,17.4),(83022,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83022,34.45,0.49,77.6,33598,75,NULL,'IR','MCG -03-30-003',NULL,'2011yCatp016004901K',2011,1,2.41,NULL,'G',0.000027,NULL,'14.40',0.24,'Scd',NULL,NULL,NULL,NULL,1,174.497625,-17.23361,0.045,NULL,40945049903,639766404,9996350,14.4),(83023,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83023,34.66,0.47,85.4,33598,NULL,NULL,'H','MCG -03-30-003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83024,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83024,34.68,0.45,86.3,33598,NULL,NULL,'K','MCG -03-30-003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83025,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83025,34.77,0.46,89.8,33598,NULL,NULL,'J','MCG -03-30-003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83026,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83026,34.86,NULL,93.7,33598,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -03-30-003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83027,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83027,34.86,NULL,93.9,33598,NULL,NULL,'Dipole + Quadrupole','MCG -03-30-003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83028,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83028,34.87,0.4,94,33598,NULL,NULL,'mean','MCG -03-30-003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83029,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83029,34.87,NULL,94.1,33598,NULL,NULL,'Dipole','MCG -03-30-003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83030,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83030,35.06,0.2,103,33598,74.4,NULL,NULL,'MCG -03-30-003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83031,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83031,36.02,0.11,160,33599,70,NULL,NULL,'2MASX J11375977+4855479',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000163,NULL,'16.1g',0.32,'S0^-',NULL,NULL,NULL,NULL,1,174.499083,48.93003,0,NULL,61751357510,964864961,15076015,16.1),(83032,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83032,38.09,0.33,415,33600,70,NULL,NULL,'LCRS B113526.6-025655',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000133,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,174.50025,-3.22511,0.069,NULL,40854858498,638357164,9974330,17.6),(83033,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83033,36.86,0.46,236,33601,70,NULL,NULL,'2MASX J11380027+0741258',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000145,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,174.5010417,7.69067,0.091,NULL,60375344755,943364761,14740074,17.5),(83034,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 2001ba',NULL,83034,34.87,0.09,91.5,33602,74.2,NULL,'SALT 2','ESO 439- G 018',0.02942,'2010ApJ...716..712A',2010,1,1.3,NULL,'G',0.000033,NULL,'14.06',1,'SAB(r)b',NULL,NULL,NULL,NULL,1,174.5020417,-32.32469,0.277,NULL,41587311958,649801749,10153152,14.06),(83035,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 2001ba',NULL,83035,35.14,0.03,104,33602,70,NULL,'SALT 2','ESO 439- G 018',0.02942,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83036,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 2001ba',NULL,83036,35.45,0.08,123,33602,74.4,NULL,NULL,'ESO 439- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83037,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 2001ba',NULL,83037,35.53,0.06,124,33602,72,NULL,NULL,'ESO 439- G 018',0.02942,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83038,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 2001ba',NULL,83038,35.53,0.08,124,33602,72,NULL,NULL,'ESO 439- G 018',0.02942,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83039,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 2001ba',NULL,83039,35.53,0.03,124,33602,72,NULL,NULL,'ESO 439- G 018',0.02942,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83040,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 2001ba',NULL,83040,35.56,0.08,126,33602,70,NULL,NULL,'ESO 439- G 018',0.02942,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83041,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 2001ba',NULL,83041,35.58,0.09,127,33602,70,NULL,'SALT','ESO 439- G 018',0.02942,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83042,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 2001ba',NULL,83042,35.59,0.01,127,33602,72,NULL,NULL,'ESO 439- G 018',0.02942,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83043,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 2001ba',NULL,83043,35.58,0.22,127,33602,72,NULL,NULL,'ESO 439- G 018',0.02942,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83044,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 2001ba',NULL,83044,35.53,0.03,128,33602,72,NULL,'M(H) = -18.317 mag','ESO 439- G 018',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83045,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 2001ba',NULL,83045,35.61,0.17,132,33602,70.8,NULL,NULL,'ESO 439- G 018',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83046,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 2001ba',NULL,83046,35.75,0.06,137,33602,65,NULL,'SALT2','ESO 439- G 018',0.02942,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83047,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 2001ba',NULL,83047,35.75,0.1,137,33602,65,NULL,'SALT','ESO 439- G 018',0.02942,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83048,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 2001ba',NULL,83048,35.89,0.08,142,33602,65,NULL,'MLCS2k2','ESO 439- G 018',0.02942,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83049,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 2001ba',NULL,83049,35.82,0.15,142,33602,65,NULL,'MLCS17','ESO 439- G 018',0.02942,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83050,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 2001ba',NULL,83050,35.84,0.18,143,33602,70,NULL,'SALT 2','ESO 439- G 018',0.02942,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83051,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 2001ba',NULL,83051,35.84,0.19,143,33602,65,NULL,'SALT2','ESO 439- G 018',0.02942,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83052,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 2001ba',NULL,83052,35.87,0.02,145,33602,65,NULL,'SALT','ESO 439- G 018',0.02942,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83053,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 2001ba',NULL,83053,35.88,0.08,145,33602,65,NULL,'MLCS2k2','ESO 439- G 018',0.02942,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83054,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 2001ba',NULL,83054,35.88,0.04,145,33602,65,NULL,'MLCS2k2','ESO 439- G 018',0.02942,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83055,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 2001ba',NULL,83055,35.88,0.18,146,33602,73.8,NULL,'SALT 2 (SNANA)','ESO 439- G 018',0.0303,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83056,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 2001ba',NULL,83056,35.9,0.14,147,33602,65,NULL,'MLCS31','ESO 439- G 018',0.02942,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83057,'IRAS','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83057,35.39,0.8,119,33602,75,NULL,'MAT, I','ESO 439- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83058,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83058,34.78,1.12,90.5,33602,NULL,NULL,'Malmquist cor.','ESO 439- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83059,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83059,35.14,0.43,106,33602,75,NULL,'MAT, I, raw','ESO 439- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83060,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83060,35.2,0.92,110,33602,NULL,NULL,NULL,'ESO 439- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83061,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83061,35.45,0.08,123,33602,74.4,NULL,NULL,'ESO 439- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83062,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83062,35.48,0.43,125,33602,75,NULL,'MAT, I, cor','ESO 439- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83063,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83063,35.49,0.43,125,33602,75,NULL,'MAT, I, inv','ESO 439- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83064,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83064,35.58,0.32,131,33602,85,NULL,'I, raw','ESO 439- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83065,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83065,35.68,0.32,137,33602,85,NULL,'I, inv','ESO 439- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83066,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83066,36.33,0.46,184,33603,70,NULL,NULL,'2MASX J11380130+0246100',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.00007,NULL,'15.8g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,174.505375,2.76969,0.025,NULL,60186221997,940409718,14693901,15.8),(83067,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83067,36.6,0.46,209,33604,70,NULL,NULL,'2MASX J11380158+0142091',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000213,NULL,'16.93',0.36,NULL,NULL,NULL,NULL,NULL,1,174.5064583,1.70247,0.025,NULL,60186480553,940413758,14693964,16.93),(83068,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83068,31.77,0.58,22.6,33605,NULL,NULL,'Malmquist cor.','UGC 06603',NULL,'2009ApJS..182..474S',2009,1,2.57,NULL,'G',0.000017,NULL,'14.6g',0.41,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,174.508875,35.20361,0,NULL,60443735173,944433362,14756771,14.6),(83069,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83069,31.93,0.2,24.3,33605,74.4,NULL,NULL,'UGC 06603',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83070,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83070,31.99,0.43,25,33605,75,NULL,'3.6 micron, color corrected','UGC 06603',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83071,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83071,32,0.43,25.2,33605,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06603',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83072,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83072,32.1,0.5,26.4,33605,NULL,NULL,NULL,'UGC 06603',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83073,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83073,38.65,0.46,536,33606,70,NULL,NULL,'SDSS J113802.20+601128.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.6g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,174.509167,60.19139,0,NULL,61853875687,966466807,15101043,18.6),(83074,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83074,37.43,0.46,306,33607,70,NULL,NULL,'SDSS J113802.32+333349.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000143,NULL,'17.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,174.5097083,33.56378,0,NULL,60623526285,947242598,14800665,17.8),(83075,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83075,38.66,0.46,540,33608,70,NULL,NULL,'SDSS J113802.56+320605.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000171,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,174.5107083,32.10144,0,NULL,60629037296,947328707,14802011,18.1),(83076,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83076,38.49,0.46,498,33609,70,NULL,NULL,'2MASX J11380290+1616115',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00018,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,174.511917,16.26981,0,NULL,60255757802,941496215,14710878,17.5),(83077,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83077,35.96,0.49,155,33610,75,NULL,'IR','FGC 1284',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',NULL,NULL,'16.7',0.1,'Sc',NULL,NULL,NULL,NULL,1,174.5195,79.38478,0.141,NULL,61422324114,959723814,14995684,16.7),(83078,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83078,36.33,NULL,185,33610,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1284',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83079,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83079,36.34,NULL,185,33610,NULL,NULL,NULL,'FGC 1284',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83080,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83080,36.36,NULL,187,33610,NULL,NULL,'Dipole + Quadrupole','FGC 1284',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83081,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83081,36.39,NULL,190,33610,NULL,NULL,'Dipole','FGC 1284',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83082,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83082,37.86,0.46,373,33611,70,NULL,NULL,'2MASX J11380500+0419500',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000159,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,174.520875,4.33044,0,NULL,60183605270,940368832,14693263,17.3),(83083,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83083,38.21,0.46,438,33612,70,NULL,NULL,'2MASX J11380529+4753558',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000189,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,174.5220417,47.899,0.005,NULL,61750621072,964853454,15075835,17.2),(83084,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83084,37.56,0.17,326,33613,70,NULL,NULL,'2MASX J11380648+1313495',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000181,NULL,'16.7g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,174.527,13.23036,0.051,NULL,60249441902,941397529,14709336,16.7),(83085,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83085,36.38,0.46,188,33614,70,NULL,NULL,'2MASX J11380726+2256293',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00011,NULL,'16.1g',0.43,NULL,NULL,NULL,NULL,NULL,1,174.53025,22.94167,0,NULL,61074043563,954281930,14910655,16.1),(83086,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83086,38.42,0.46,484,33615,70,NULL,NULL,'2MASX J11380732+0717478',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000154,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,174.530458333,7.29656,0.09,NULL,60376257900,943379029,14740297,17.6),(83087,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83087,37.3,0.46,289,33616,70,NULL,NULL,'SDSS J113807.32+034252.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000131,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,174.5305417,3.71453,0.017,NULL,60181811429,940340803,14692825,17.6),(83088,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83088,37.71,0.33,349,33617,70,NULL,NULL,'2MASX J11380741+0427150',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,'FoF','18.33',0.15,NULL,NULL,NULL,NULL,NULL,1,174.530833,4.45419,0.009,NULL,60180161332,940315020,14692422,18.33),(83089,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83089,35.7,0.21,138,33618,70,NULL,NULL,'2MASX J11380741+2150403',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00007,NULL,'16.11',0.42,NULL,NULL,NULL,NULL,NULL,1,174.531,21.84467,0,NULL,61077262647,954332228,14911441,16.11),(83090,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83090,36.98,0.46,249,33619,70,NULL,NULL,'2MASX J11380750+0956208',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00019,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,174.531291667,9.93928,0.117,NULL,60370403768,943287558,14738868,17.1),(83091,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83091,37.71,0.33,349,33620,70,NULL,NULL,'SDSS J113809.41+042628.0',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,174.53925,4.44114,0.009,NULL,60183581309,940368457,14693257,17.8),(83092,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83092,35.34,0.52,117,33621,NULL,NULL,'Malmquist cor.','ESO 504- G 005',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.88',0.5,'Sb',NULL,NULL,NULL,NULL,1,174.54175,-23.42886,0.121,NULL,41410979165,647046549,10110102,14.88),(83093,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83093,35.41,0.51,121,33621,NULL,NULL,NULL,'ESO 504- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83094,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83094,35.45,0.2,123,33621,74.4,NULL,NULL,'ESO 504- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83095,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83095,37.69,0.33,345,33622,70,NULL,NULL,'2MASX J11381010+1343116',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,174.542,13.72003,0.088,NULL,60250121286,941408145,14709502,17.7),(83096,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83096,37.65,0.46,339,33623,70,NULL,NULL,'SDSS J113810.46+071235.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,174.543625,7.20978,0.09,NULL,60376282577,943379415,14740303,18.5),(83097,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83097,37.79,0.33,362,33624,70,NULL,NULL,'2MASX J11381125+1106487',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,174.546791667,11.11347,0.09,NULL,60368783682,943262245,14738472,17.9),(83098,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83098,38.68,0.46,544,33625,70,NULL,NULL,'2MASX J11381199+2115544',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000188,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,174.549916667,21.26522,0,NULL,61074774915,954293358,14910833,18.4),(83099,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83099,36.57,0.46,206,33626,70,NULL,NULL,'2MASX J11381238+5222502',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000174,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,174.551583333,52.38064,0,NULL,61804376133,965693377,15088959,16.5),(83100,'Tully est','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83100,31.15,0.8,17,33627,75,NULL,'B','NGC 3773',NULL,'1988NBGC.C....0000T',1988,1,1.2,'Multiple SDSS entries describe this object.','G',0.00001,NULL,'13.01',1,'SA0:           HII','in a radial-velocity based grouping',NULL,NULL,'Starburst',1,174.553666667,12.11206,0.089,NULL,60247066918,941360420,14708756,13.01),(83101,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83101,31.16,NULL,17.1,33627,NULL,NULL,NULL,'NGC 3773',NULL,'2015AstBu..70....1K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83102,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83102,36.9,0.46,240,33628,70,NULL,NULL,'2MASX J11381343+1834064',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,174.555833,18.56844,0,NULL,61080941769,954389715,14912339,17),(83103,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83103,37.62,0.46,334,33629,70,NULL,NULL,'2MASX J11381380+0625097',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000192,NULL,'16.9g',0.22,'AGN',NULL,NULL,NULL,NULL,1,174.5575,6.41933,0.059,NULL,60373691049,943338922,14739670,16.9),(83104,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83104,37.14,0.46,268,33630,70,NULL,NULL,'2MASX J11381381+0021100',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000081,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,174.5575417,0.35281,0.057,NULL,60184305682,940379776,14693434,17),(83105,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83105,37.56,0.17,326,33631,70,NULL,NULL,'2MASX J11381394+1316326',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,174.5579583,13.27581,0.051,NULL,60249446552,941397602,14709337,17.8),(83106,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83106,36.63,0.62,211,33632,70,NULL,NULL,'2MASX J11381406-4954511',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,174.5585417,-49.91419,0.545,NULL,40057940705,625905323,9779770,15.3),(83107,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83107,38.09,0.33,415,33633,70,NULL,NULL,'LCRS B113540.6-030200',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,174.558667,-3.30992,0.069,NULL,40854870581,638357352,9974333,18.2),(83108,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83108,37.79,0.33,362,33634,70,NULL,NULL,'2MASX J11381505+1104507',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.87',0.18,NULL,NULL,NULL,NULL,NULL,1,174.56275,11.08075,0.09,NULL,60369486562,943273227,14738644,17.87),(83109,'IRAS','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83109,33.84,0.8,58.5,33635,75,NULL,'MAT, I','ESO 439- G 020',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'14.22',0.6,'SAB(r)b',NULL,NULL,NULL,NULL,1,174.5645417,-29.72858,0.233,NULL,41448608250,647634503,10119289,14.22),(83110,'Sosies','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83110,34.32,0.09,73.1,33635,NULL,NULL,NULL,'ESO 439- G 020',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83111,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83111,34.12,0.4,66.6,33635,NULL,NULL,'mean','ESO 439- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83112,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83112,34.24,0.47,70.4,33635,NULL,NULL,'H','ESO 439- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83113,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83113,34.24,0.46,70.6,33635,NULL,NULL,'J','ESO 439- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83114,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83114,34.25,0.43,70.7,33635,75,NULL,'MAT, I, raw','ESO 439- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83115,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83115,34.31,0.32,72.9,33635,85,NULL,'I, raw','ESO 439- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83116,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83116,34.35,0.45,74.3,33635,NULL,NULL,'K','ESO 439- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83117,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83117,34.38,0.32,75.1,33635,85,NULL,'I, inv','ESO 439- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83118,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83118,34.52,0.43,80.3,33635,75,NULL,'MAT, I, inv','ESO 439- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83119,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83119,34.65,0.31,85.2,33635,NULL,NULL,NULL,'ESO 439- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83120,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83120,34.66,0.43,85.6,33635,75,NULL,'MAT, I, cor','ESO 439- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83121,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83121,34.69,0.2,86.7,33635,74.4,NULL,NULL,'ESO 439- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83122,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83122,34.82,0.28,92.2,33635,NULL,NULL,'Malmquist cor.','ESO 439- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83123,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83123,35.82,0.33,146,33636,70,NULL,NULL,'UGC 06606 NED01',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000193,NULL,'15.9g',0.31,'S0',NULL,NULL,NULL,NULL,1,174.5659583,47.43689,0,NULL,63894004387,998343818,15599122,15.9),(83124,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83124,37.56,0.17,326,33637,70,NULL,NULL,'2MASX J11381606+1313526',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000188,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,174.567083333,13.23131,0.051,NULL,60250551802,941414871,14709607,17.9),(83125,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83125,36.92,0.46,242,33638,70,NULL,NULL,'2MASX J11381907+5522190',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000153,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,174.579333333,55.37208,0,NULL,61763232379,965050505,15078914,17),(83126,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83126,37.65,0.46,339,33639,70,NULL,NULL,'2MASX J11381921+3343496',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,174.580125,33.73036,0,NULL,60623043914,947235061,14800547,17.2),(83127,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83127,34.66,0.2,85.5,33640,74.4,NULL,NULL,'MCG -02-30-011',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.00003,NULL,'14.85',1.1,'SAB(s)cd pec:',NULL,NULL,NULL,NULL,1,174.583917,-13.04967,0.033,NULL,40990669910,640479217,10007487,14.85),(83128,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83128,34.68,0.46,86.5,33640,NULL,NULL,'Malmquist cor.','MCG -02-30-011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83129,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83129,34.8,0.43,91.4,33640,NULL,NULL,NULL,'MCG -02-30-011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83130,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83130,36.37,0.49,188,33641,70,NULL,NULL,'2MASX J11382025-2107307',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.58',NULL,NULL,NULL,NULL,NULL,NULL,1,174.584333333,-21.12517,0.129,NULL,41685744928,651339764,10177183,15.58),(83131,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83131,35.68,0.33,137,33642,70,NULL,NULL,'SDSS J113820.57+202559.7',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000127,NULL,'17.86',0.16,NULL,NULL,NULL,NULL,NULL,1,174.58575,20.43328,0,NULL,61082615301,954415864,14912747,17.86),(83132,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83132,37.22,0.46,278,33643,70,NULL,NULL,'2MASX J11382066+3246316',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000151,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,174.5860417,32.77544,0,NULL,60632092140,947376439,14802756,17.2),(83133,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83133,37.16,0.27,271,33644,70,NULL,NULL,'2MASX J11382133+5538460',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000195,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,174.589083,55.64597,0,NULL,61988673947,968573030,15133953,16.6),(83134,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83134,37.94,0.27,387,33645,70,NULL,NULL,'2MASX J11382168+1155117',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000189,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,174.5905,11.92003,0.089,NULL,60247093497,941360835,14708763,17.3),(83135,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83135,37.33,0.33,292,33646,70,NULL,NULL,'2MASX J11382184+5642180',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,174.5910417,56.705,0,NULL,61977686827,968401356,15131271,17),(83136,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83136,37.98,0.46,394,33647,70,NULL,NULL,'SDSS J113822.17+165045.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,174.592417,16.84594,0.018,NULL,60256283757,941504433,14711006,18.5),(83137,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83137,37.72,0.46,350,33648,70,NULL,NULL,'2MASX J11382255+3154316',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000134,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,174.594083,31.90889,0,NULL,60628957077,947327454,14801991,17.5),(83138,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83138,35.7,0.21,138,33649,70,NULL,NULL,'2MASX J11382271+2150224',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00009,NULL,'16.05',0.27,NULL,NULL,NULL,NULL,NULL,1,174.594666667,21.83947,0,NULL,61076590744,954321730,14911277,16.05),(83139,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83139,38.12,0.33,420,33650,70,NULL,NULL,'2MASX J11382381+1114118',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,174.5992083,11.2365,0.098,NULL,60368799582,943262493,14738476,17.5),(83140,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83140,37.33,0.33,292,33651,70,NULL,NULL,'2MASX J11382438+5641530',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000162,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,174.6014583,56.69806,0,NULL,61977686703,968401354,15131271,17.8),(83141,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83141,38.26,0.46,450,33652,70,NULL,NULL,'2MASX J11382449+3705514',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000134,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,174.601916667,37.09761,0.01,NULL,60449879798,944529371,14758271,18.1),(83142,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83142,37.24,0.46,280,33653,70,NULL,NULL,'2MASX J11382500+4427341',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000176,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,174.604333333,44.45947,0,NULL,63904233623,998503650,15601619,16.8),(83143,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83143,37.84,0.46,370,33654,70,NULL,NULL,'2MASX J11382504+4741020',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,174.604333333,47.684,0.012,NULL,61750471094,964851110,15075798,18),(83144,'IRAS','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83144,33.49,0.8,49.9,33655,75,NULL,'CF, r','UGC 06607',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00002,NULL,'15.01',0.8,'Sd',NULL,NULL,NULL,NULL,1,174.604417,20.7405,0,NULL,61082566569,954415102,14912735,15.01),(83145,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83145,33.63,0.2,53.2,33655,74.4,NULL,NULL,'UGC 06607',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83146,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83146,33.72,0.38,55.4,33655,75,NULL,'CF, r, raw','UGC 06607',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83147,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83147,33.73,0.38,55.7,33655,75,NULL,'CF, r, inv','UGC 06607',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83148,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83148,33.82,0.48,58,33655,NULL,NULL,NULL,'UGC 06607',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83149,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83149,33.87,0.47,59.6,33655,NULL,NULL,'Malmquist cor.','UGC 06607',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83150,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83150,33.94,0.38,61.3,33655,75,NULL,'CF, r, cor','UGC 06607',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83151,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83151,37.26,0.46,283,33656,70,NULL,NULL,'2MASX J11382584+0259510',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000072,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,174.607833,2.99747,0.009,NULL,60194617351,940540896,14695951,17.8),(83152,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83152,36.42,0.46,192,33657,70,NULL,NULL,'2MASX J11382855+2614087',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000187,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,174.618791667,26.23575,0,NULL,60597726063,946839469,14794366,16.5),(83153,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83153,38.12,0.33,420,33658,70,NULL,NULL,'SDSS J113828.60+111929.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,174.619167,11.32497,0.098,NULL,60368775197,943262112,14738470,18),(83154,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83154,36.65,0.55,213,33659,70,NULL,NULL,'2MASX J11382898-3625135',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,174.620833,-36.42047,0.429,NULL,41392002925,646750045,10105469,14.6),(83155,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83155,35.62,0.62,133,33660,70,NULL,NULL,'2MASX J11382939-0943288',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.20',NULL,NULL,NULL,NULL,NULL,NULL,1,174.622417,-9.72464,0.033,NULL,41031139288,641111551,10017367,16.2),(83156,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 2006bd',NULL,83156,35.25,0.1,112,33661,74.4,NULL,NULL,'UGC 06609',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.00009,NULL,'14.33',0.8,'E',NULL,NULL,NULL,NULL,1,174.62275,20.52772,0,NULL,61082647840,954416372,14912755,14.33),(83157,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 2006bd',NULL,83157,35.56,0.17,126,33661,65,NULL,'MLCS17','UGC 06609',0.025724,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83158,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 2006bd',NULL,83158,35.59,0.2,128,33661,65,NULL,'MLCS31','UGC 06609',0.025724,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83159,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 2006bd',NULL,83159,35.7,0.36,131,33661,72,NULL,NULL,'UGC 06609',0.02681,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83160,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83160,37.85,0.33,372,33662,70,NULL,NULL,'2MASX J11382969+3029016',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000198,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,174.623916667,30.48381,0,NULL,60628157447,947314960,14801796,16.3),(83161,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83161,37.9,0.46,379,33663,70,NULL,NULL,'2MASX J11383040+4207440',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000158,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,174.626875,42.12886,0.03,NULL,63897676500,998401195,15600018,18),(83162,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83162,35.84,0.69,147,33664,70,NULL,NULL,'2MASX J11383067-0923338',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.28',NULL,NULL,NULL,NULL,NULL,NULL,1,174.6275417,-9.39281,0.013,NULL,41031767511,641121367,10017521,16.28),(83163,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83163,37.16,0.27,271,33665,70,NULL,NULL,'2MASX J11383199+5538557',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000176,NULL,'16.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,174.633333,55.64883,0,NULL,61977145161,968392893,15131138,16.4),(83164,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83164,37.05,0.46,257,33666,70,NULL,NULL,'2MASX J11383230+0011387',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000074,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,174.634625,0.19408,0.053,NULL,60137968710,939655761,14682121,17.3),(83165,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83165,34.52,0.28,80.3,33667,NULL,NULL,NULL,'UGC 06608',NULL,'2009ApJS..182..474S',2009,1,0.95,NULL,'G',0.00002,NULL,'14.3g',0.75,'SAB(r)ab?','Isolated galaxy',NULL,NULL,NULL,1,174.638625,-1.1845,0.037,NULL,40861423095,638459735,9975933,14.3),(83166,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83166,34.65,0.27,85,33667,NULL,NULL,'Malmquist cor.','UGC 06608',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83167,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83167,34.83,0.2,92.5,33667,74.4,NULL,NULL,'UGC 06608',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83168,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83168,34.84,0.4,92.9,33667,NULL,NULL,'mean','UGC 06608',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83169,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83169,35.04,0.47,102,33667,NULL,NULL,'H','UGC 06608',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83170,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83170,37.35,0.46,295,33668,70,NULL,NULL,'2MASX J11383360+2241304',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,174.64,22.69183,0,NULL,61076781757,954324714,14911323,17.4),(83171,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83171,37.94,0.27,387,33669,70,NULL,NULL,'2MASX J11383388+1203267',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000196,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,174.6412917,12.05742,0.089,NULL,60247109137,941361080,14708766,17.1),(83172,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83172,38.04,0.46,406,33670,70,NULL,NULL,'2MASX J11383460+1738557',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,174.64425,17.64903,0.006,NULL,60200991823,940640497,14697507,17.2),(83173,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83173,37.35,0.46,296,33671,70,NULL,NULL,'2MASX J11383475+1114428',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000161,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,174.644708333,11.24514,0.098,NULL,60368804838,943262575,14738477,16.6),(83174,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83174,37,0.46,251,33672,70,NULL,NULL,'MCG +10-17-030',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000157,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,174.64725,57.37797,0,NULL,61976498926,968382795,15130981,16.6),(83175,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83175,35.87,0.46,149,33673,70,NULL,NULL,'CGCG 186-015',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.000117,NULL,'14.4g',0.69,NULL,NULL,NULL,NULL,NULL,1,174.651,33.86794,0,NULL,60623175404,947237115,14800579,14.4),(83176,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83176,37.46,0.23,311,33674,70,NULL,NULL,'2MASX J11383626-0137140',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000156,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,174.651125,-1.62058,0.041,NULL,40864608880,638509513,9976711,16.8),(83177,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83177,36.55,0.46,204,33675,70,NULL,NULL,'2MASX J11383691+3828433',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000144,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,174.653916667,38.47867,0.008,NULL,60464736052,944761500,14761898,16.8),(83178,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83178,38.67,0.46,543,33676,70,NULL,NULL,'2MASX J11383702+1213417',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00018,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,174.6542083,12.22836,0.051,NULL,60247945177,941374143,14708970,17.9),(83179,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83179,35.68,0.33,137,33677,70,NULL,NULL,'2MASX J11383746+2031314',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.0g',0.35,NULL,NULL,NULL,NULL,NULL,1,174.656125,20.52544,0,NULL,61082637647,954416213,14912753,16),(83180,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83180,38.24,0.33,444,33678,70,NULL,NULL,'2MASX J11383908+1704427',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,174.6629583,17.0785,0.018,NULL,60200913483,940639273,14697488,17.2),(83181,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83181,37.72,0.46,351,33679,70,NULL,NULL,'2MASX J11383933+1247007',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'18.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,174.663875,12.78364,0.042,NULL,60247695971,941370249,14708910,18.1),(83182,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83182,37.46,0.23,311,33680,70,NULL,NULL,'2MASX J11383940-0132140',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000212,NULL,'16.1g',0.43,'BrClG',NULL,NULL,NULL,NULL,1,174.664,-1.53717,0.041,NULL,40864622885,638509732,9976714,16.1),(83183,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83183,37.5,0.46,316,33681,70,NULL,NULL,'2MASX J11383952+0115527',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000079,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,174.664583,1.26475,0.049,NULL,60184816383,940387755,14693558,16.9),(83184,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83184,37.85,0.33,372,33682,70,NULL,NULL,'2MASX J11383998+3029506',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000179,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,174.6667917,30.49736,0,NULL,60628158220,947314972,14801796,17.2),(83185,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83185,37.92,0.46,384,33683,70,NULL,NULL,'2MASX J11384014+1557597',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000173,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,174.667375,15.96658,0.023,NULL,60259239352,941550614,14711728,17.1),(83186,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83186,36.86,0.63,236,33684,70,NULL,NULL,'2MASX J11384282-3624435',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,174.6785417,-36.41203,0.429,NULL,41392008131,646750127,10105470,15.7),(83187,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83187,37.46,0.23,311,33685,70,NULL,NULL,'SDSS J113843.32-013226.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000172,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,174.680541667,-1.54061,0.041,NULL,40864624102,638509751,9976714,18.2),(83188,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83188,37.77,0.46,358,33686,70,NULL,NULL,'2MASX J11384380+4414430',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,174.6824583,44.24533,0.009,NULL,63902057806,998469653,15601088,17.6),(83189,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83189,32.53,0.2,32.1,33687,74.4,NULL,NULL,'UGC 06610',NULL,'2013AJ....146...86T',2013,1,2.1,NULL,'G',0.000007,NULL,'15.00',0.4,'Scd:',NULL,NULL,NULL,NULL,1,174.684,33.80578,0,NULL,60623166835,947236981,14800577,15),(83190,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83190,32.56,0.43,32.5,33687,75,NULL,'3.6 micron, color corrected','UGC 06610',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83191,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83191,32.61,0.43,33.2,33687,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06610',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83192,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83192,32.75,0.65,35.5,33687,NULL,NULL,NULL,'UGC 06610',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83193,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83193,32.85,0.62,37.1,33687,NULL,NULL,'Malmquist cor.','UGC 06610',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83194,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83194,37.35,0.46,296,33688,70,NULL,NULL,'2MASX J11384429+3125484',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000178,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,174.6845417,31.43031,0,NULL,60625809080,947278266,14801222,16.9),(83195,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83195,37.56,0.17,326,33689,70,NULL,NULL,'2MASX J11384453+1318407',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,174.685666667,13.31122,0.051,NULL,60250582210,941415347,14709614,16.7),(83196,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83196,38.83,0.46,584,33690,70,NULL,NULL,'SDSS J113847.13+551630.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,174.6964583,55.275,0,NULL,61771638237,965181847,15080966,18.3),(83197,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83197,38.89,0.46,600,33691,70,NULL,NULL,'SDSS J113847.26+321618.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,174.696958333,32.27186,0,NULL,60632478554,947382477,14802851,18.4),(83198,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83198,37.56,0.17,326,33692,70,NULL,NULL,'2MASX J11384810+1316497',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,174.700333333,13.28044,0.051,NULL,60250586957,941415421,14709615,18.3),(83199,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83199,37.69,0.46,345,33693,70,NULL,NULL,'2MASX J11384831+2328334',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000184,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,174.701291667,23.47603,0,NULL,60541057786,945954027,14780531,17),(83200,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83200,37.03,0.46,255,33694,70,NULL,NULL,'2MASX J11384911+5500277',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000165,NULL,'16.8g',0.24,'AGN',NULL,NULL,NULL,NULL,1,174.704833,55.00786,0,NULL,61771714629,965183041,15080985,16.8),(83201,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83201,37.56,0.17,326,33695,70,NULL,NULL,'2MASX J11384953+1314367',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,174.706417,13.24356,0.051,NULL,60250572114,941415189,14709612,17.8),(83202,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83202,37.46,0.23,311,33696,70,NULL,NULL,'2MASX J11384993-0127290',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000204,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,174.708083333,-1.45814,0.041,NULL,40864614684,638509604,9976712,17),(83203,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83203,36.42,0.46,192,33697,70,NULL,NULL,'2MASX J11385026+3451414',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000174,NULL,'16.3g',0.4,NULL,NULL,NULL,NULL,NULL,1,174.709291667,34.86142,0,NULL,60443828576,944434821,14756794,16.3),(83204,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83204,37.11,0.46,264,33698,70,NULL,NULL,'2MASX J11385047+0725464',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00015,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,174.7104583,7.4295,0.071,NULL,60376446190,943381971,14740343,16.7),(83205,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83205,37.55,0.46,324,33699,70,NULL,NULL,'2MASX J11385359+3939144',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000163,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,174.723166667,39.65392,0,NULL,60459839801,944684996,14760703,17),(83206,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83206,35.69,0.61,138,33700,70,NULL,NULL,'2MASX J11385370-0925515',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.22',NULL,NULL,NULL,NULL,NULL,NULL,1,174.7237917,-9.43103,0.013,NULL,41031815665,641122119,10017533,16.22),(83207,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83207,38.19,0.46,434,33701,70,NULL,NULL,'2MASX J11385439+0625575',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000162,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,174.726583,6.43272,0.064,NULL,60373795970,943340562,14739696,17.4),(83208,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83208,37.94,0.27,387,33702,70,NULL,NULL,'2MASX J11385439+1154475',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000161,NULL,'16.9g',0.32,NULL,NULL,NULL,NULL,NULL,1,174.72675,11.91325,0.078,NULL,60238785990,941231031,14706734,16.9),(83209,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83209,35.32,0.46,116,33703,70,NULL,NULL,'CGCG 068-016',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000175,NULL,'15.5g',0.53,'E0',NULL,NULL,NULL,NULL,1,174.732875,9.53211,0.102,NULL,60370701116,943292204,14738940,15.5),(83210,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83210,38.02,0.33,402,33704,70,NULL,NULL,'2MASX J11385660-0146300',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000154,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,174.7359583,-1.77506,0.041,NULL,40864678750,638510605,9976728,17.6),(83211,'IRAS','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83211,34.8,0.8,91.3,33705,75,NULL,'MAT, I','ESO 571- G 012',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000027,NULL,'14.20',0.4,'S?             HII?',NULL,NULL,NULL,NULL,1,174.739916667,-17.96956,0.081,NULL,41679446656,651241354,10175646,14.2),(83212,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83212,34.09,0.32,65.8,33705,85,NULL,'I, raw','ESO 571- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83213,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83213,34.09,0.69,65.8,33705,100,NULL,'mid-IR','ESO 571- G 012',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83214,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83214,34.11,0.43,66.4,33705,75,NULL,'MAT, I, raw','ESO 571- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83215,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83215,34.14,0.32,67.2,33705,85,NULL,'I, inv','ESO 571- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83216,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83216,34.31,0.43,72.8,33705,75,NULL,'MAT, I, inv','ESO 571- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83217,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83217,34.39,0.43,75.7,33705,75,NULL,'MAT, I, cor','ESO 571- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83218,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83218,34.66,0.2,85.5,33705,74.4,NULL,NULL,'ESO 571- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83219,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83219,34.71,0.43,87.5,33705,NULL,NULL,'Malmquist cor.','ESO 571- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83220,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83220,34.87,0.39,94.3,33705,NULL,NULL,NULL,'ESO 571- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83221,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83221,38.24,0.33,444,33706,70,NULL,NULL,'2MASX J11385797+1700218',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,174.7417083,17.006,0.018,NULL,60255962832,941499419,14710928,17.1),(83222,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83222,38.24,0.46,445,33707,70,NULL,NULL,'2MASX J11385857+0510268',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,174.744125,5.17411,0.044,NULL,60180916574,940326821,14692606,17.7),(83223,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83223,38.22,0.33,441,33708,70,NULL,NULL,'2MASX J11385864+1933503',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,174.744417,19.56411,0,NULL,61080266665,954379166,14912174,17.3),(83224,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83224,38.1,0.46,417,33709,70,NULL,NULL,'2MASX J11385974+2714532',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00017,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,174.748917,27.24822,0.008,NULL,60597739297,946839676,14794369,17.5),(83225,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83225,36.17,0.79,172,33710,70,NULL,NULL,'2MASX J11390129-1039335',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.30',NULL,NULL,NULL,NULL,NULL,NULL,1,174.7552917,-10.65928,0.005,NULL,41029349218,641083581,10016930,16.3),(83226,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83226,38.22,0.33,441,33711,70,NULL,NULL,'2MASX J11390141+1936483',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,174.755875,19.61336,0,NULL,61080258625,954379041,14912172,NULL),(83227,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83227,37.01,0.46,252,33712,70,NULL,NULL,'SDSS J113901.61+423604.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000116,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,174.75675,42.60125,0.014,NULL,63897946750,998405417,15600084,18),(83228,'Ring Diameter','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83228,33.8,0.84,57,33713,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3783',NULL,'1981ApJS...45..541P',1981,1,1.9,NULL,'G',0.000007,NULL,'12.64',1.7,'(R\')SB(r)a     Sy1',NULL,NULL,NULL,'Sy 1.5',1,174.757333,-37.73867,0.469,NULL,41405283360,646957552,10108711,12.64),(83229,'Tully est','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83229,32.93,0.8,38.5,33713,75,NULL,'B','NGC 3783',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83230,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83230,34.43,0.47,77,33714,NULL,NULL,'H','IC 0716',NULL,'2007A&A...465...71T',2007,1,0.92,NULL,'G',0.00003,NULL,'14.6g',0.3,'Sbc pec sp','Isolated galaxy',NULL,NULL,NULL,1,174.763875,-0.206,0.037,NULL,40806629886,637603591,9962556,14.6),(83231,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83231,34.52,0.2,80.2,33714,74.4,NULL,NULL,'IC 0716',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83232,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83232,34.54,0.4,80.7,33714,NULL,NULL,'mean','IC 0716',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83233,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83233,34.55,0.45,81.3,33714,NULL,NULL,'K','IC 0716',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83234,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83234,34.57,0.29,82.1,33714,NULL,NULL,NULL,'IC 0716',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83235,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83235,34.6,0.46,83.3,33714,NULL,NULL,'J','IC 0716',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83236,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83236,34.67,0.28,85.8,33714,NULL,NULL,'Malmquist cor.','IC 0716',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83237,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83237,36.89,0.33,239,33715,70,NULL,NULL,'2MASX J11390442+3206195',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,174.7685,32.10553,0,NULL,60632557167,947383705,14802870,16.6),(83238,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83238,38.27,0.33,450,33716,70,NULL,NULL,'SDSS J113905.42+034302.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000168,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,174.772625,3.71731,0.013,NULL,60181959884,940343123,14692861,18.4),(83239,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83239,34.82,0.5,92,33717,70,NULL,NULL,'MCG -01-30-017',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000103,NULL,'16',0.2,NULL,NULL,NULL,NULL,NULL,1,174.773,-9.33,0.013,NULL,41031689334,641120145,10017502,16),(83240,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83240,38.37,0.46,473,33718,70,NULL,NULL,'2MASX J11390573+1626288',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,174.774083,16.44153,0.017,NULL,60256040881,941500638,14710947,17.9),(83241,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83241,37.22,0.46,278,33719,70,NULL,NULL,'LCRS B113632.9-031845',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000189,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,174.776375,-3.58936,0.121,NULL,40855487916,638366998,9974484,16.3),(83242,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83242,37.42,0.46,305,33720,70,NULL,NULL,'2MASX J11390653+5333323',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000173,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,174.777,53.55886,0,NULL,61762575491,965040242,15078753,16.9),(83243,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83243,36.04,0.46,161,33721,70,NULL,NULL,'CGCG 097-037',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000073,NULL,'15.6',0.2,'E',NULL,NULL,NULL,NULL,1,174.782083,19.36306,0,NULL,61080725911,954386342,14912286,15.6),(83244,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83244,34.68,0.83,86.1,33722,NULL,NULL,NULL,'ESO 504- G 008',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.78',0.9,'S?             HII',NULL,NULL,NULL,NULL,1,174.785583,-23.30242,0.125,NULL,41411126649,647048853,10110138,14.78),(83245,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83245,34.72,0.2,87.9,33722,74.4,NULL,NULL,'ESO 504- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83246,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83246,34.79,0.79,90.8,33722,NULL,NULL,'Malmquist cor.','ESO 504- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83247,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83247,36.9,0.46,240,33723,70,NULL,NULL,'2MASXi J1139097+330242',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000182,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,174.790708333,33.04492,0,NULL,60632109986,947376718,14802761,17.5),(83248,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83248,35.56,0.46,129,33724,70,NULL,NULL,'2MASX J11391053+2626059',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000095,NULL,'16.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,174.794,26.43494,0,NULL,60597599329,946837489,14794335,16.1),(83249,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83249,37.08,0.46,260,33725,70,NULL,NULL,'2MASX J11391065+4615232',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,174.794375,46.25644,0.016,NULL,63903281904,998488779,15601387,17.5),(83250,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83250,39.07,0.46,651,33726,70,NULL,NULL,'SDSS J113910.82+273631.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000174,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,174.795125,27.60878,0,NULL,60585704779,946651637,14791431,18.5),(83251,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83251,34.73,0.49,88.2,33727,75,NULL,'IR','FGC 1287',NULL,'2011yCatp016004901K',2011,1,1.01,NULL,'G',0.000005,NULL,'14.31',0.12,'Sdm            HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,174.795625,19.585,0,NULL,61080234592,954378665,14912166,14.31),(83252,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83252,35.06,0.2,103,33727,74.4,NULL,NULL,'FGC 1287',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83253,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83253,35.15,NULL,107,33727,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1287',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83254,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83254,35.17,NULL,108,33727,NULL,NULL,'Dipole + Quadrupole','FGC 1287',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83255,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83255,35.18,NULL,109,33727,NULL,NULL,'Dipole','FGC 1287',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83256,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83256,36.86,0.46,235,33728,70,NULL,NULL,'2MASX J11391129+2540249',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000123,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,174.7972083,25.67342,0,NULL,60589916519,946717445,14792460,16.4),(83257,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83257,36.89,0.33,239,33729,70,NULL,NULL,'2MASX J11391143+3213435',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000189,NULL,'15.9g',0.46,'BrClG',NULL,NULL,NULL,NULL,1,174.797667,32.22869,0,NULL,60632529528,947383273,14802863,15.9),(83258,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83258,38.02,0.33,402,33730,70,NULL,NULL,'2MASX J11391149-0148239',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,174.797875,-1.80664,0.041,NULL,40864680450,638510632,9976728,17.3),(83259,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83259,36.63,0.33,212,33731,70,NULL,NULL,'2MASX J11391393+3557363',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,174.808167,35.96022,0.012,NULL,60442297566,944410899,14756420,17.2),(83260,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83260,36.95,0.46,246,33732,70,NULL,NULL,'SBS 1136+580',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000175,NULL,'16.0g',0.42,'E0',NULL,NULL,NULL,NULL,1,174.814917,57.77217,0,NULL,61976175835,968377747,15130902,16),(83261,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83261,37.13,0.46,266,33733,70,NULL,NULL,'2MASX J11391588+1704238',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,174.8162917,17.07322,0.018,NULL,60201239975,940644374,14697568,16.4),(83262,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83262,35.61,0.38,132,33734,NULL,NULL,'Malmquist cor.','CGCG 127-016',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000047,NULL,'15.6',0.3,'S0',NULL,NULL,NULL,NULL,1,174.8175,20.42722,0,NULL,61082586948,954415421,14912740,15.6),(83263,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83263,35.95,0.32,155,33734,NULL,NULL,NULL,'CGCG 127-016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83264,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83264,35.99,0.2,158,33734,74.4,NULL,NULL,'CGCG 127-016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83265,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83265,37.49,0.46,315,33735,70,NULL,NULL,'2MASX J11391619+5741005',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,174.817666667,57.68353,0,NULL,61977057449,968391522,15131117,17.2),(83266,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83266,34.85,0.4,93.5,33736,NULL,NULL,'mean','UGC 06617',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000103,NULL,'14.06',0.3,'S0?','in a radial-velocity based grouping',NULL,NULL,NULL,1,174.8234583,9.96239,0.104,NULL,60372362286,943318160,14739346,14.06),(83267,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83267,35.32,0.45,116,33736,NULL,NULL,'K','UGC 06617',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83268,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83268,37.66,0.46,341,33737,70,NULL,NULL,'2MASX J11391766+1017145',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,174.82375,10.28736,0.115,NULL,60372485411,943320084,14739376,17),(83269,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83269,37.59,0.46,330,33738,70,NULL,NULL,'2MASX J11391775+1835430',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,174.8240417,18.59525,0,NULL,61081261169,954394705,14912417,18),(83270,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83270,38.07,0.46,412,33739,70,NULL,NULL,'2MASX J11391787+1003165',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000187,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,174.8245417,10.05475,0.114,NULL,60372414526,943318976,14739359,17.1),(83271,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83271,37.28,0.46,286,33740,70,NULL,NULL,'2MASX J11391810+3824363',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000163,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,174.8252917,38.41019,0,NULL,60464853453,944763335,14761927,16.7),(83272,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83272,35.98,0.67,157,33741,70,NULL,NULL,'2MASX J11391908-3811392',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,174.8294583,-38.19433,0.509,NULL,41406158107,646971220,10108925,15.8),(83273,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83273,38.03,0.46,403,33742,70,NULL,NULL,'2MASX J11392014+1848500',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.22',0.15,NULL,NULL,NULL,NULL,NULL,1,174.834125,18.81378,0,NULL,61081415892,954397123,14912455,18.22),(83274,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83274,37.96,0.46,390,33743,70,NULL,NULL,'2MASX J11392034+1652058',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.66',0.15,'BrClG',NULL,NULL,NULL,NULL,1,174.834833,16.86833,0.018,NULL,60255982640,941499728,14710933,17.66),(83275,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83275,38.27,0.33,450,33744,70,NULL,NULL,'2MASX J11392062+0340439',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000087,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,174.835917,3.67881,0.005,NULL,60181910245,940342347,14692849,17.2),(83276,'IRAS','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83276,30.76,0.8,14.2,33745,75,NULL,'W91CL, r','NGC 3782',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00002,NULL,'13.10',1.1,'SAB(s)cd:','in a radial-velocity based grouping',NULL,NULL,NULL,1,174.8365,46.51383,0.012,NULL,63902448666,998475760,15601183,13.1),(83277,'IRAS','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83277,30.78,0.8,14.3,33745,75,NULL,'A82, H','NGC 3782',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83278,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83278,30.5,0.47,12.6,33745,75,NULL,'A82, H, inv','NGC 3782',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83279,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83279,30.68,0.38,13.7,33745,75,NULL,'W91CL, r, inv','NGC 3782',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83280,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83280,30.7,0.47,13.8,33745,75,NULL,'A82, H, raw','NGC 3782',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83281,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83281,30.79,0.38,14.4,33745,75,NULL,'W91CL, r, raw','NGC 3782',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83282,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83282,31,0.38,15.8,33745,75,NULL,'W91CL, r, cor','NGC 3782',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83283,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83283,31.01,0.47,15.9,33745,75,NULL,'A82, H, cor','NGC 3782',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83284,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83284,31.15,0.4,17,33745,75,NULL,'B','NGC 3782',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83285,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83285,31.67,0.4,21.6,33746,75,NULL,'B','NGC 3795A',NULL,'1988NBGC.C....0000T',1988,1,1.51,NULL,'G',0.000037,NULL,'14.2g',1.19,'SA(s)d:        HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,174.8387917,58.26869,0,NULL,61842947416,966296053,15098375,14.2),(83286,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83286,31.88,0.63,23.7,33746,NULL,NULL,NULL,'NGC 3795A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83287,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83287,31.89,0.62,23.9,33746,NULL,NULL,'Malmquist cor.','NGC 3795A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83288,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83288,31.92,0.2,24.2,33746,74.4,NULL,NULL,'NGC 3795A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83289,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83289,37.62,0.33,334,33747,70,NULL,NULL,'2MASX J11392146+3214007',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000142,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,174.83925,32.23347,0,NULL,60632508531,947382945,14802858,18.1),(83290,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83290,37.62,0.33,334,33748,70,NULL,NULL,'2MASX J11392233+3213276',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.19',0.14,NULL,NULL,NULL,NULL,NULL,1,174.843083,32.22439,0,NULL,60632509339,947382958,14802858,18.19),(83291,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83291,32.86,0.4,37.2,33749,75,NULL,'B','NGC 3780',NULL,'1988NBGC.C....0000T',1988,1,3.1,NULL,'G',0.000017,NULL,'12.16',2.5,'SA(s)c:','in a pair',NULL,NULL,NULL,1,174.843167,56.27067,0,NULL,61977993956,968406155,15131346,12.16),(83292,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83292,32.97,0.4,39.3,33749,NULL,NULL,'mean','NGC 3780',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83293,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83293,33.28,0.47,45.4,33749,NULL,NULL,'H','NGC 3780',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83294,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83294,33.29,0.46,45.6,33749,NULL,NULL,'J','NGC 3780',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83295,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83295,33.3,0.45,45.6,33749,NULL,NULL,'K','NGC 3780',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83296,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83296,38.39,0.46,477,33750,70,NULL,NULL,'2MASX J11392390+4755543',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000176,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,174.84975,47.93181,0.015,NULL,61750600919,964853139,15075830,17.3),(83297,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83297,35.51,0.7,126,33751,70,NULL,NULL,'2MASX J11392403-7239138',NULL,'2014MNRAS.445.2677S',2014,1,NULL,'Marginal HIPASS detection.','G',0.000046,NULL,'17.3b',NULL,'Sa',NULL,NULL,NULL,NULL,1,174.850125,-72.65392,0.829,NULL,39806548107,621977314,9718395,17.3),(83298,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83298,34.59,0.43,82.7,33752,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 097-041',NULL,'2014MNRAS.444..527S',2014,1,0.8,NULL,'G',0.000007,NULL,'15.5',0.6,'S0',NULL,NULL,NULL,NULL,1,174.851916667,19.53472,0,NULL,61080705757,954386027,14912281,15.5),(83299,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83299,34.62,0.43,83.8,33752,75,NULL,'3.6 micron, color corrected','CGCG 097-041',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83300,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83300,34.7,0.2,87.1,33752,74.4,NULL,NULL,'CGCG 097-041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83301,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83301,34.93,0.08,97,33752,NULL,NULL,NULL,'CGCG 097-041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83302,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83302,38.21,0.33,438,33753,70,NULL,NULL,'2MASX J11392533+1629208',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,174.855625,16.489,0.017,NULL,60256033948,941500530,14710945,17.3),(83303,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83303,37.98,0.46,395,33754,70,NULL,NULL,'2MASX J11392563+1535208',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000142,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,174.8567083,15.589,0.038,NULL,60256763455,941511928,14711123,18),(83304,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83304,36.06,0.51,163,33755,70,NULL,NULL,'2MASX J11392576-3636513',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.5I',0.6,NULL,NULL,NULL,NULL,NULL,1,174.857375,-36.61431,0.441,NULL,41392426158,646756658,10105572,13.5),(83305,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83305,38.07,0.21,410,33756,70,NULL,NULL,'2MASX J11392700+1304298',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,174.862458333,13.07503,0.067,NULL,60250953859,941421154,14709705,17.5),(83306,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83306,37.52,0.78,319,33757,70,NULL,NULL,'2MASX J11392763-4214541',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,174.8652083,-42.24833,0.313,NULL,41882292074,654410813,10225168,14.5),(83307,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83307,36.91,0.46,241,33758,70,NULL,NULL,'2MASX J11392830+1948130',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.0001,NULL,'15.83',0.19,NULL,NULL,NULL,NULL,NULL,1,174.8680417,19.80375,0,NULL,61080324519,954380070,14912188,15.83),(83308,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83308,37.65,0.27,339,33759,70,NULL,NULL,'2MASX J11392894+5557546',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,174.8702917,55.96514,0,NULL,61977314196,968395534,15131180,17.3),(83309,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83309,34.17,0.49,68.3,33760,NULL,NULL,'Malmquist cor.','UGC 06619',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000028,NULL,'15.36',0.3,'S?',NULL,NULL,NULL,NULL,1,174.8715417,60.54619,0.041,NULL,61854276588,966473071,15101141,15.36),(83310,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83310,34.26,0.47,71.1,33760,NULL,NULL,NULL,'UGC 06619',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83311,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83311,34.38,0.49,75.1,33760,75,NULL,'IR','UGC 06619',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83312,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83312,34.54,0.2,80.9,33760,74.4,NULL,NULL,'UGC 06619',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83313,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83313,37.57,0.46,327,33761,70,NULL,NULL,'2MASX J11392936+2729320',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000154,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,174.8725,27.49217,0.008,NULL,60585679298,946651239,14791425,17.6),(83314,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83314,35.11,0.4,105,33762,NULL,NULL,'mean','NGC 3784',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.00004,NULL,'14.6g',0.52,'SBb','Group member',NULL,NULL,NULL,1,174.874167,26.30914,0,NULL,60597702252,946839097,14794360,14.6),(83315,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83315,35.15,0.47,107,33762,NULL,NULL,'H','NGC 3784',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83316,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83316,35.14,0.46,107,33763,70,NULL,NULL,'2MASX J11393005-1702288',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000147,NULL,'15.13',NULL,NULL,NULL,NULL,NULL,NULL,1,174.875125,-17.04153,0.057,NULL,40991330857,640489544,10007649,15.13),(83317,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83317,37.51,0.46,318,33764,70,NULL,NULL,'2MASX J11393131+3210107',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000139,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,174.8805417,32.16964,0,NULL,60632535828,947383372,14802865,17.6),(83318,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83318,37.89,0.23,379,33765,70,NULL,NULL,'SDSS J113932.67+111018.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000142,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,174.886125,11.17192,0.113,NULL,60369508614,943273572,14738649,18.1),(83319,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83319,37.65,0.46,339,33766,70,NULL,NULL,'2MASX J11393295+0350471',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,174.8874583,3.84636,0.005,NULL,60181929586,940342649,14692853,17.8),(83320,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83320,37.33,0.46,292,33767,70,NULL,NULL,'2MASX J11393359+1648198',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.42',0.14,NULL,NULL,NULL,NULL,NULL,1,174.8899583,16.80553,0.018,NULL,60256103504,941501617,14710962,18.42),(83321,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83321,37.63,0.33,335,33768,70,NULL,NULL,'2MASX J11393381+0421021',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.21',0.17,NULL,NULL,NULL,NULL,NULL,1,174.890833333,4.3505,0.025,NULL,60183673420,940369897,14693279,18.21),(83322,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83322,35.73,0.5,140,33769,70,NULL,NULL,'ESO 571- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000133,NULL,'15.26',0.4,'Sb:',NULL,NULL,NULL,NULL,1,174.893583,-21.99864,0.105,NULL,41686342019,651349094,10177329,15.26),(83323,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83323,37.01,0.46,252,33770,70,NULL,NULL,'2MASX J11393469+0659535',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,174.894708333,6.99811,0.061,NULL,60373481322,943335645,14739619,17.6),(83324,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83324,37.34,0.46,294,33771,70,NULL,NULL,'2MASX J11393636+1126270',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,174.901375,11.44081,0.148,NULL,60239512201,941242378,14706912,17.8),(83325,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83325,38.21,0.33,438,33772,70,NULL,NULL,'2MASX J11393847+1627318',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,174.9102917,16.45897,0.017,NULL,60258856859,941544638,14711634,17.5),(83326,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83326,37.63,0.46,336,33773,70,NULL,NULL,'[VCV96] A 1136+486',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000221,NULL,'17.0g',0.28,'Sy2',NULL,NULL,NULL,'Sy 2',1,174.911,48.34581,0.018,NULL,61749872382,964841755,15075652,17),(83327,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83327,37.63,0.33,335,33774,70,NULL,NULL,'2MASX J11393949+0422171',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000203,NULL,'16.1g',0.37,'AGN',NULL,NULL,NULL,NULL,1,174.914417,4.3715,0.025,NULL,60183672120,940369876,14693279,16.1),(83328,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83328,38.1,0.33,416,33775,70,NULL,NULL,'2MASX J11394052+1349318',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000189,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,174.918833333,13.82547,0.076,NULL,60249779204,941402800,14709418,17.1),(83329,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83329,36.91,0.46,241,33776,70,NULL,NULL,'2MASX J11394112+4222285',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000174,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,174.921333,42.3745,0.043,NULL,63897217203,998394018,15599906,16.5),(83330,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83330,37.45,0.46,309,33777,70,NULL,NULL,'2MASX J11394122+0120221',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000081,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,174.921875,1.33936,0.049,NULL,60184736759,940386511,14693539,17.3),(83331,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83331,37.69,0.46,346,33778,70,NULL,NULL,'SDSS J113941.37+080401.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,174.922375,8.06719,0.041,NULL,60375726619,943370728,14740167,17.9),(83332,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83332,34.45,0.48,77.7,33779,70,NULL,NULL,'NGC 3791',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'14.06',1,'(R)SAB pec:',NULL,NULL,NULL,NULL,1,174.92375,-9.36725,0.021,NULL,41031642879,641119419,10017490,14.06),(83333,'AGN time lag','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83333,34.35,0.22,74.3,33780,NULL,NULL,NULL,'NGC 3786',NULL,'2014ApJ...784L..11Y',2014,1,2.2,NULL,'G',0.00002,NULL,'13.0B',1.3,'(R\')SAB(r)a pecSy1.8','Pair member (points to parent)',NULL,NULL,'Sy 1.8',1,174.9272917,31.90928,0,NULL,60632367058,947380735,14802823,13),(83334,'Tully est','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83334,33.1,0.8,41.6,33780,75,NULL,'B','NGC 3786',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83335,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83335,33.21,0.4,43.9,33780,NULL,NULL,'mean','NGC 3786',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83336,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83336,33.36,0.45,47,33780,NULL,NULL,'K','NGC 3786',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83337,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83337,33.4,0.47,47.9,33780,NULL,NULL,'H','NGC 3786',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83338,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83338,33.52,0.46,50.5,33780,NULL,NULL,'J','NGC 3786',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83339,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83339,37.41,0.46,304,33781,70,NULL,NULL,'2MASX J11394315+0943010',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00009,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,174.929917,9.71692,0.104,NULL,60370019912,943281561,14738774,16.8),(83340,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83340,37.78,0.23,360,33782,70,NULL,NULL,'2MASX J11394403+1035110',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,174.9334583,10.58633,0.12,NULL,60372556401,943321193,14739393,17.6),(83341,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83341,38.1,0.33,416,33783,70,NULL,NULL,'2MASX J11394423+1352468',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,174.934333,13.87969,0.076,NULL,60249807008,941403234,14709425,17.8),(83342,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83342,38.28,0.33,453,33784,70,NULL,NULL,'2MASX J11394435+1540528',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,174.93475,15.68144,0.033,NULL,60258653837,941541466,14711585,17.8),(83343,'Tully est','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83343,32.81,0.8,36.5,33785,75,NULL,'B','NGC 3788',NULL,'1988NBGC.C....0000T',1988,1,2.1,'HOLM 272C is a star.','G',0.00002,NULL,'13.4g',0.69,'SAB(rs)ab pec','Pair member (points to parent)',NULL,NULL,NULL,1,174.9360417,31.93119,0,NULL,60632365504,947380711,14802823,13.4),(83344,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83344,33.19,0.4,43.4,33785,NULL,NULL,'mean','NGC 3788',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83345,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83345,33.74,0.46,56,33785,NULL,NULL,'J','NGC 3788',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83346,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83346,33.75,0.47,56.2,33785,NULL,NULL,'H','NGC 3788',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83347,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83347,33.83,0.45,58.3,33785,NULL,NULL,'K','NGC 3788',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83348,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83348,33.87,0.49,59.5,33785,75,NULL,'IR','NGC 3788',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83349,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83349,36.68,0.46,217,33786,70,NULL,NULL,'2MASX J11394551+2307539',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000137,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,174.9397083,23.13169,0,NULL,61073791650,954277994,14910593,16.2),(83350,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83350,37.25,0.46,282,33787,70,NULL,NULL,'2MASX J11394574+0200401',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000074,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,174.9405,2.01111,0.033,NULL,60186502935,940414108,14693970,17.6),(83351,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 1999bp',NULL,83351,36.95,0.09,228,33788,74.2,NULL,'SALT 2','EROS J113946.24-085137.4',0.077,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,174.942667,-8.86039,0.033,NULL,41033040071,641141251,10017832,NULL),(83352,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 1999bp',NULL,83352,37.42,0.03,284,33788,70,NULL,'SALT 2','EROS J113946.24-085137.4',0.077,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83353,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 1999bp',NULL,83353,37.53,0.1,321,33788,74.4,NULL,NULL,'EROS J113946.24-085137.4',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83354,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 1999bp',NULL,83354,37.78,0.07,334,33788,70,NULL,'SALT','EROS J113946.24-085137.4',0.077,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83355,'SNIa','2016-12-15 15:14:49','2016-12-16 11:19:58','1','SN 1999bp',NULL,83355,37.97,0.07,364,33788,65,NULL,'SALT','EROS J113946.24-085137.4',0.077,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83356,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83356,37.13,0.46,267,33789,70,NULL,NULL,'2MASX J11394637+4807030',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,174.943083,48.11756,0.018,NULL,61750063439,964844741,15075699,17.1),(83357,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83357,35.59,0.6,132,33790,70,NULL,NULL,'2MASX J11394632-7743416',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,174.943333,-77.72822,0.409,NULL,39833245986,622394468,9724913,17.1),(83358,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83358,37.88,0.46,377,33791,70,NULL,NULL,'2MASX J11394667+3105206',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,174.944583,31.08906,0,NULL,60626342774,947286605,14801353,18.1),(83359,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83359,36.64,0.46,213,33792,70,NULL,NULL,'2MASX J11394762-0050382',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00008,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,174.9484583,-0.84394,0.017,NULL,40861812004,638465812,9976028,16.4),(83360,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83360,34.9,0.46,95.4,33793,70,NULL,NULL,'CGCG 127-019',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000113,NULL,'15.2g',0.41,'S?',NULL,NULL,NULL,NULL,1,174.9515417,23.53247,0,NULL,60540954057,945952407,14780506,15.2),(83361,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83361,38.84,0.46,587,33794,70,NULL,NULL,'SDSS J113948.38+010020.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000074,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,174.951583,1.00561,0.049,NULL,60185083309,940391926,14693623,18.3),(83362,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83362,34.62,0.93,83.9,33795,NULL,NULL,'Malmquist cor.','ESO 266- G 012',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.73',0.6,'(R\'_2)SAB(s)bc',NULL,NULL,NULL,NULL,1,174.956583333,-44.56083,0.329,NULL,41891764889,654558826,10227481,14.73),(83363,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83363,35.12,0.74,106,33795,NULL,NULL,NULL,'ESO 266- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83364,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83364,35.16,0.2,108,33795,74.4,NULL,NULL,'ESO 266- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83365,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83365,34.48,0.2,78.7,33796,74.4,NULL,NULL,'SDSS J113952.43+171903.5',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000007,NULL,'17.40',0.1,NULL,NULL,NULL,NULL,NULL,1,174.9684583,17.31764,0.016,NULL,60201793065,940653016,14697703,17.4),(83366,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83366,31.72,0.43,22.1,33797,75,NULL,'3.6 micron, color + selection bias corrected','IC 0718',NULL,'2014MNRAS.444..527S',2014,1,1.32,NULL,'G',0.000013,NULL,'14.5g',0.61,'Im:',NULL,NULL,NULL,NULL,1,174.969875,8.87453,0.068,NULL,60377956490,943405570,14740712,14.5),(83367,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83367,32.23,NULL,27.9,33797,NULL,NULL,NULL,'IC 0718',NULL,'2015AstBu..70....1K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83368,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83368,36.95,0.23,246,33798,70,NULL,NULL,'CGCG 012-051',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000137,NULL,'15.2g',0.61,'E+;BrClG',NULL,NULL,NULL,NULL,1,174.973,-3.51853,0.081,NULL,40854752205,638355503,9974304,15.2),(83369,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83369,37.99,0.46,396,33799,70,NULL,NULL,'2MASX J11395375+0127401',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000075,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,174.9739583,1.46117,0.049,NULL,60187552496,940430507,14694226,17.5),(83370,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83370,36.95,0.23,246,33800,70,NULL,NULL,'LCRS B113720.5-031542',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000164,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,174.9747917,-3.53853,0.081,NULL,40855471357,638366739,9974480,17.4),(83371,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83371,38.35,0.33,469,33801,70,NULL,NULL,'2MASX J11395427+4346345',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,174.975958333,43.77631,0,NULL,63902309327,998473583,15601149,17.8),(83372,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83372,37.98,0.46,395,33802,70,NULL,NULL,'2MASXi J1139544+243506',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00014,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,174.976583,24.58525,0,NULL,60590394494,946724913,14792576,18.2),(83373,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83373,37.78,0.23,360,33803,70,NULL,NULL,'2MASX J11395651+1040540',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000127,NULL,'17.21',0.23,NULL,NULL,NULL,NULL,NULL,1,174.985417,10.68161,0.124,NULL,60372092118,943313939,14739280,17.21),(83374,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83374,36.85,0.46,234,33804,70,NULL,NULL,'2MASX J11395683+4226095',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,174.986833,42.43611,0.043,NULL,63897271985,998394874,15599919,17.2),(83375,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83375,38.02,0.46,402,33805,70,NULL,NULL,'2MASX J11395841+2738549',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'18.56',0.13,NULL,NULL,NULL,NULL,NULL,1,174.993333,27.64864,0.041,NULL,60585191595,946643618,14791306,18.56),(83376,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83376,36.12,0.52,167,33806,70,NULL,NULL,'2MASX J11395863-1420344',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,174.9942083,-14.34294,0.049,NULL,41002068435,640657319,10010270,14.6),(83377,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83377,38.04,0.15,406,33807,70,NULL,NULL,'2MASX J11400024+1025420',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000117,NULL,'16.8g',0.34,NULL,NULL,NULL,NULL,NULL,1,175.000833,10.4285,0.127,NULL,60372572289,943321442,14739397,16.8),(83378,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83378,38.45,0.46,490,33808,70,NULL,NULL,'SDSS J114000.79+284244.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'18.2g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,175.003333,28.71247,0,NULL,60584943591,946639743,14791245,18.2),(83379,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83379,36.56,0.46,205,33809,70,NULL,NULL,'2MASX J11400107+1647075',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.65',0.2,NULL,NULL,NULL,NULL,NULL,1,175.0044583,16.78542,0.019,NULL,60256154814,941502418,14710975,17.65),(83380,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83380,36.52,0.46,201,33810,70,NULL,NULL,'2MASX J11400117+2320200',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00009,NULL,'15.7g',0.5,NULL,NULL,NULL,NULL,NULL,1,175.004958333,23.33892,0,NULL,60540873723,945951151,14780486,15.7),(83381,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83381,37.7,0.46,347,33811,70,NULL,NULL,'SDSS J114001.44+131658.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,175.0060417,13.28297,0.067,NULL,60251139545,941424055,14709750,18.5),(83382,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83382,38.78,0.46,570,33812,70,NULL,NULL,'2MASX J11400158+2707429',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000166,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,175.006667,27.12858,0.016,NULL,60598286746,946848230,14794503,18.5),(83383,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83383,35.67,0.2,136,33813,74.4,NULL,NULL,'CGCG 068-020',NULL,'2013AJ....146...86T',2013,1,1.02,NULL,'G',0.000007,NULL,'16.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,175.006875,11.46281,0.148,NULL,60239003616,941234431,14706787,16.2),(83384,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83384,35.58,0.49,131,33814,75,NULL,'IR','CGCG 068-020',NULL,'2011yCatp016004901K',2011,1,1.02,NULL,'G',0.000007,NULL,'16.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,175.006875,11.46281,0.148,NULL,60239003616,941234431,14706787,16.2),(83385,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83385,38.07,0.21,410,33815,70,NULL,NULL,'2MASX J11400180+1303475',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000178,NULL,'16.8g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,175.007541667,13.06336,0.04,NULL,60250977487,941421523,14709711,16.8),(83386,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83386,37.91,0.23,383,33816,70,NULL,NULL,'SDSS J114002.58+095236.0',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,175.010791667,9.87667,0.104,NULL,60370006252,943281347,14738771,17.7),(83387,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83387,37.03,0.46,254,33817,70,NULL,NULL,'2MASX J11400273+1543075',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000127,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,175.011333333,15.71878,0.033,NULL,60258706898,941542295,14711598,16.2),(83388,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83388,38.05,0.46,407,33818,70,NULL,NULL,'2MASX J11400299+0528394',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00017,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,175.0125417,5.47756,0.034,NULL,60180734093,940323970,14692562,17.1),(83389,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83389,35.98,0.46,157,33819,70,NULL,NULL,'2MASX J11400371+3035364',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000185,NULL,'15.5g',0.46,NULL,NULL,NULL,NULL,NULL,1,175.0155417,30.59344,0,NULL,60626290670,947285791,14801340,15.5),(83390,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83390,37.91,0.23,383,33820,70,NULL,NULL,'2MASX J11400377+0955160',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000107,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,175.0157917,9.92108,0.104,NULL,60370003246,943281300,14738770,17),(83391,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83391,37.66,0.46,341,33821,70,NULL,NULL,'2MASX J11400441+1634475',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,175.018375,16.57983,0.017,NULL,60258884474,941545069,14711641,NULL),(83392,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83392,36.66,0.46,215,33822,70,NULL,NULL,'2MASX J11400438+2046280',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000177,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,175.018417,20.77444,0,NULL,61082493186,954413956,14912718,16.3),(83393,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83393,38.35,0.33,469,33823,70,NULL,NULL,'2MASX J11400612+4341362',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000166,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,175.0254583,43.69339,0,NULL,63902261803,998472840,15601138,18),(83394,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83394,34.88,0.46,94.6,33824,70,NULL,NULL,'CGCG 012-054',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000087,NULL,'15.0g',0.56,'E','Group member',NULL,NULL,NULL,1,175.0267083,-0.83775,0.037,NULL,40861818375,638465912,9976029,15),(83395,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83395,29.43,0.49,7.68,33825,75,NULL,'IR','UGC 06628',NULL,'2011yCatp016004901K',2011,1,2.9,NULL,'G',0.000003,NULL,'13.18',2.9,'SAm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,175.0239583,45.94217,0.01,NULL,63903339376,998489677,15601401,13.18),(83396,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83396,31.15,0.4,17,33825,75,NULL,'B','UGC 06628',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83397,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83397,31.81,0.4,23,33826,NULL,NULL,'mean','NGC 3795',NULL,'2007A&A...465...71T',2007,1,2.13,NULL,'G',0.00002,NULL,'13.7g',0.55,'Sc             HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,175.0277917,58.61308,0,NULL,61854558817,966477481,15101210,13.7),(83398,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83398,31.92,0.43,24.2,33826,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3795',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83399,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83399,31.95,0.43,24.6,33826,75,NULL,'3.6 micron, color corrected','NGC 3795',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83400,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83400,32,0.2,25.1,33826,74.4,NULL,NULL,'NGC 3795',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83401,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83401,32.08,0.4,26.1,33826,75,NULL,NULL,'NGC 3795',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83402,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83402,32.23,0.58,28,33826,NULL,NULL,NULL,'NGC 3795',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83403,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83403,32.27,0.57,28.5,33826,NULL,NULL,'Malmquist cor.','NGC 3795',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83404,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83404,32.45,0.46,30.9,33826,NULL,NULL,'J','NGC 3795',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83405,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83405,32.46,0.49,31.1,33826,75,NULL,'IR','NGC 3795',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83406,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83406,32.5,0.47,31.6,33826,NULL,NULL,'H','NGC 3795',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83407,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83407,32.56,0.45,32.5,33826,NULL,NULL,'K','NGC 3795',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83408,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83408,38.07,0.21,410,33827,70,NULL,NULL,'2MASX J11400686+1303025',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.67',0.13,NULL,NULL,NULL,NULL,NULL,1,175.028583,13.05078,0.04,NULL,60250942339,941420974,14709702,18.67),(83409,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83409,35.94,0.54,154,33828,70,NULL,NULL,'2MASX J11400689-5101248',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,175.028833,-51.02353,0.753,NULL,40060353150,625943017,9780359,14.9),(83410,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83410,38.02,0.46,403,33829,70,NULL,NULL,'2MASX J11400792+1803360',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,175.033125,18.05986,0.023,NULL,60201468169,940647940,14697624,17),(83411,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83411,38.07,0.21,410,33830,70,NULL,NULL,'2MASX J11400803+1303425',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.27',0.14,NULL,NULL,NULL,NULL,NULL,1,175.0335,13.06189,0.04,NULL,60250941684,941420963,14709702,18.27),(83412,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83412,37.14,0.46,268,33831,70,NULL,NULL,'2MASX J11400801+4757230',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,175.033583,47.95631,0.015,NULL,61750025096,964844142,15075689,17.5),(83413,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83413,35.91,0.46,152,33832,70,NULL,NULL,'2MASX J11400867+2739453',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000167,NULL,'16.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,175.036125,27.6625,0.041,NULL,60585199143,946643736,14791308,16.1),(83414,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83414,38.07,0.21,410,33833,70,NULL,NULL,'SDSS J114009.04+130444.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000156,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,175.0377083,13.07897,0.04,NULL,60250943529,941420992,14709703,18.4),(83415,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83415,35.07,0.52,103,33834,70,NULL,NULL,'2MASX J11400914-2944562',NULL,'2014MNRAS.445.2677S',2014,1,0.7,'6dF DR2 has z = 0.032497.','G',0.00015,NULL,'15.3b',0.8,'E',NULL,NULL,NULL,NULL,1,175.038083333,-29.74903,0.193,NULL,41451959052,647686860,10120107,15.3),(83416,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83416,33.55,0.4,51.2,33835,NULL,NULL,'mean','NGC 3799',NULL,'2007A&A...465...71T',2007,1,0.8,'Multiple SDSS entries describe this object.','G',0.000023,NULL,'14.7B',0.5,'SB(s)b: pec','Pair member (points to parent)',NULL,NULL,NULL,1,175.039083333,15.32731,0.055,NULL,60256905865,941514154,14711158,14.7),(83417,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83417,35.63,0.47,134,33835,NULL,NULL,'H','NGC 3799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83418,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83418,38.28,0.33,453,33836,70,NULL,NULL,'SDSS J114009.40+154124.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000145,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,175.039167,15.69022,0.037,NULL,60258675553,941541805,14711590,18.6),(83419,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83419,36.69,0.46,218,33837,70,NULL,NULL,'2MASX J11400941+4852230',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000162,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,175.0392083,48.87306,0,NULL,61751425086,964866016,15076031,16.3),(83420,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83420,37.62,0.46,334,33838,70,NULL,NULL,'2MASX J11401018+5156360',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000178,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,175.042583,51.94333,0.005,NULL,61800318785,965629981,15087968,17),(83421,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83421,35.38,0.33,119,33839,70,NULL,NULL,'2MASX J11401026+2519343',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000176,NULL,'16.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,175.0429583,25.32633,0,NULL,60588098915,946689045,14792016,16.1),(83422,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83422,35.38,0.33,119,33840,70,NULL,NULL,'CGCG 127-023',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.000153,NULL,'14.8g',0.65,'E',NULL,NULL,NULL,NULL,1,175.043375,25.30958,0,NULL,60588099227,946689050,14792016,14.8),(83423,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83423,38.56,0.46,515,33841,70,NULL,NULL,'SDSS J114011.25+010446.3',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000077,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,175.046875,1.07956,0.049,NULL,60184890694,940388917,14693576,17.7),(83424,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83424,36.32,0.69,183,33842,70,NULL,NULL,'2MASX J11401127-3353539',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.5b',0.4,'E',NULL,NULL,NULL,NULL,1,175.047,-33.89836,0.305,NULL,41584391107,649756111,10152439,16.5),(83425,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83425,37.54,0.46,322,33843,70,NULL,NULL,'2MASX J11401151+1522264',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000141,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,175.047833333,15.37389,0.055,NULL,60256941305,941514707,14711167,18.1),(83426,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83426,33.75,0.4,56.1,33844,NULL,NULL,'mean','UGC 06631',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000007,NULL,'14.4g',0.55,'Sab','in a radial-velocity based grouping',NULL,NULL,NULL,1,175.048667,17.31233,0.016,NULL,60201272636,940644884,14697576,14.4),(83427,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83427,33.82,0.47,58.1,33844,NULL,NULL,'H','UGC 06631',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83428,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83428,33.95,0.46,61.6,33844,NULL,NULL,'J','UGC 06631',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83429,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83429,33.97,0.45,62.1,33844,NULL,NULL,'K','UGC 06631',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83430,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83430,36.05,0.46,162,33845,70,NULL,NULL,'CGCG 127-021',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000093,NULL,'15.0g',0.54,'S0',NULL,NULL,NULL,NULL,1,175.049875,23.52211,0,NULL,60540944766,945952261,14780504,15),(83431,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83431,36.95,0.23,246,33846,70,NULL,NULL,'2MASX J11401215-0331560',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000198,NULL,'15.5g',0.57,'E0',NULL,NULL,NULL,NULL,1,175.050583333,-3.53236,0.089,NULL,40866545667,638539776,9977184,15.5),(83432,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83432,37.08,0.46,261,33847,70,NULL,NULL,'2MASX J11401235-0120480',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000146,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,175.051417,-1.34658,0.041,NULL,40861697679,638464026,9976000,17.6),(83433,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83433,37.3,0.46,289,33848,70,NULL,NULL,'SDSS J114013.17+343437.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000159,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,175.054917,34.57717,0,NULL,60441729429,944402022,14756281,18.3),(83434,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83434,38.5,0.46,502,33849,70,NULL,NULL,'2MASX J11401334+3150554',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000192,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,175.05575,31.84883,0,NULL,60630283424,947348178,14802315,17.6),(83435,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83435,33.14,0.45,42.5,33850,NULL,NULL,'K','NGC 3800',NULL,'2007A&A...465...71T',2007,1,2,'UZC has V = 5852 +- 31 km/sec.','G',0.000007,NULL,'13.50',0.6,'SAB(rs)b: pec','Possible field galaxy',NULL,NULL,NULL,1,175.0562917,15.34236,0.055,NULL,60256905805,941514153,14711158,13.5),(83436,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83436,33.15,0.47,42.7,33850,NULL,NULL,'H','NGC 3800',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83437,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83437,33.16,0.46,42.9,33850,NULL,NULL,'J','NGC 3800',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83438,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83438,33.54,0.4,51.1,33850,NULL,NULL,'mean','NGC 3800',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83439,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83439,37.68,0.33,343,33851,70,NULL,NULL,'2MASX J11401391+2404543',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000141,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,175.0580417,24.08169,0,NULL,60544096596,946001509,14781273,18.2),(83440,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83440,32.6,0.69,33.2,33852,100,NULL,'mid-IR','NGC 3798',NULL,'2013ApJ...771...88L',2013,1,1.99,NULL,'G',0.00002,NULL,'13.4g',0.8,'SB0            Sy1','in a radial-velocity based grouping',NULL,NULL,'Sy 1',1,175.058083,24.69706,0,NULL,60588306386,946692287,14792066,13.4),(83441,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83441,37.78,0.46,359,33853,70,NULL,NULL,'SDSS J114014.77+002539.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000052,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,175.061583,0.42769,0.037,NULL,60138109077,939657954,14682155,18.4),(83442,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83442,37.2,0.46,275,33854,70,NULL,NULL,'2MASX J11401491+5504454',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,175.062,55.07936,0,NULL,61771865798,965185403,15081021,16.6),(83443,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83443,37.68,0.33,343,33855,70,NULL,NULL,'2MASX J11401538+2405543',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000178,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,175.064,24.09839,0,NULL,60544097138,946001517,14781273,17.1),(83444,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83444,34.95,0.46,97.8,33856,70,NULL,NULL,'2MASX J11401539+2638513',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000164,NULL,'15.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,175.064167,26.64767,0,NULL,60598658763,946854043,14794594,15.9),(83445,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83445,38.23,0.27,442,33857,70,NULL,NULL,'SDSS J114016.56+040328.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,175.069,4.05781,0.013,NULL,60181275258,940332425,14692694,18.7),(83446,'Faber-Jackson','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83446,33.4,0.44,47.9,33858,95,NULL,'Weighted Mean','NGC 3801',NULL,'1984ApJS...56...91D',1984,1,3.5,'The radio pos. in 1996AJ....111.1945D is 4.5 arcsec se of the optical/IR peak.','G',0.000007,NULL,'12.96',2.1,'S0/a','in a radial-velocity based grouping',NULL,'radio jet',NULL,1,175.070583333,17.72806,0,NULL,60201861241,940654081,14697720,12.96),(83447,'Faber-Jackson','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83447,33.79,0.46,57.3,33858,95,NULL,'Michard 1979a','NGC 3801',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83448,'Faber-Jackson','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83448,34.05,0.63,64.6,33858,95,NULL,'Michard 1979b, c','NGC 3801',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83449,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83449,32.9,0.45,37.9,33858,NULL,NULL,'K','NGC 3801',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83450,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83450,33.55,0.4,51.2,33858,NULL,NULL,'mean','NGC 3801',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83451,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83451,37.78,0.23,360,33859,70,NULL,NULL,'2MASX J11401763+1048504',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000113,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,175.073375,10.814,0.124,NULL,60372099629,943314056,14739282,16.6),(83452,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83452,37.54,0.33,323,33860,70,NULL,NULL,'2MASX J11401800+1249574',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,175.075083,12.83278,0.047,NULL,60250809010,941418890,14709670,17.3),(83453,'Tully est','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83453,32.35,0.8,29.5,33861,75,NULL,'B','IC 0719',NULL,'1988NBGC.C....0000T',1988,1,1.08,NULL,'G',0.000017,NULL,'13.6g',0.48,'S0?','Group member',NULL,NULL,NULL,1,175.077125,9.00989,0.061,NULL,60377880859,943404388,14740693,13.6),(83454,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83454,31.8,0.45,23,33861,NULL,NULL,'K','IC 0719',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83455,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83455,31.87,0.4,23.7,33861,75,NULL,NULL,'IC 0719',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83456,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83456,32.4,0.49,30.2,33861,75,NULL,'IR','IC 0719',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83457,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83457,32.61,0.4,33.2,33861,NULL,NULL,'mean','IC 0719',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83458,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83458,38.06,0.46,410,33862,70,NULL,NULL,'SDSS J114018.63+153547.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000142,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,175.077667,15.59653,0.037,NULL,60256784298,941512254,14711128,18.7),(83459,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83459,32.86,0.49,37.2,33863,75,NULL,'IR','NGC 3802',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.00003,NULL,'14.25',0.3,'S0/a','in a pair',NULL,NULL,NULL,1,175.07825,17.76536,0,NULL,60201452471,940647694,14697620,14.25),(83460,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83460,32.94,0.47,38.7,33863,NULL,NULL,'H','NGC 3802',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83461,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83461,33.07,0.45,41.1,33863,NULL,NULL,'K','NGC 3802',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83462,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83462,33.1,0.46,41.7,33863,NULL,NULL,'J','NGC 3802',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83463,'Tully-Fisher','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83463,33.53,0.4,50.8,33863,NULL,NULL,'mean','NGC 3802',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83464,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83464,38.79,0.46,572,33864,70,NULL,NULL,'SDSS J114020.93+112125.2',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,175.08725,11.35703,0.148,NULL,60369247834,943269497,14738585,18),(83465,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83465,37.78,0.23,360,33865,70,NULL,NULL,'2MASX J11402156+1046515',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000056,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,175.089875,10.78086,0.124,NULL,60372145407,943314771,14739293,17),(83466,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83466,38.18,0.46,433,33866,70,NULL,NULL,'SDSS J114022.13+035417.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00014,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,175.0922083,3.90481,0.005,NULL,60181384844,940334138,14692720,18.2),(83467,'SZ effect','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83467,41.97,NULL,2480,33867,NULL,NULL,NULL,'MS 1137.5+6624',NULL,'2005ApJ...625..108D',2005,1,NULL,NULL,'GClstr',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,175.099583,66.13861,0,NULL,61822580751,965977824,15093403,NULL),(83468,'SZ effect','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83468,42.07,NULL,2590,33867,NULL,NULL,'3.1 (red) calibration','MS 1137.5+6624',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83469,'SZ effect','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83469,42.24,NULL,2800,33867,NULL,NULL,'4.1 (blue) calibration','MS 1137.5+6624',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83470,'SZ effect','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83470,42.24,NULL,2810,33867,NULL,NULL,'4.2 (black) calibration','MS 1137.5+6624',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83471,'SZ effect','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83471,42.27,0.44,2850,33867,NULL,NULL,'Hydrost. Eq.','MS 1137.5+6624',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83472,'SZ effect','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83472,42.51,NULL,3180,33867,NULL,NULL,NULL,'MS 1137.5+6624',NULL,'2002ApJ...581...53R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83473,'SZ effect','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83473,42.81,0.68,3650,33867,NULL,NULL,'Isotherm.','MS 1137.5+6624',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83474,'SZ effect','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83474,43.53,0.77,5070,33867,NULL,NULL,'Isotherm., r < 100 kpc','MS 1137.5+6624',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83475,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83475,37.96,0.46,391,33868,70,NULL,NULL,'2MASX J11402334+0006049',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000082,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,175.09725,0.10122,0.037,NULL,60138861740,939669714,14682339,17.7),(83476,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83476,37.65,0.27,339,33869,70,NULL,NULL,'2MASX J11402349+5557355',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000176,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,175.097917,55.95989,0,NULL,61977330893,968395795,15131184,16.6),(83477,'Tully est','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83477,33.22,0.8,44,33870,75,NULL,NULL,'UGC 06637',NULL,'1988NBGC.C....0000T',1988,1,0.8,NULL,'G',0.000033,NULL,'14.5g',0.47,'S0             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,175.103625,28.37397,0,NULL,60584975605,946640243,14791253,14.5),(83478,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83478,37.81,0.46,365,33871,70,NULL,NULL,'SDSS J114024.97+010120.3',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000088,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,175.104083,1.02231,0.033,NULL,60184497313,940382770,14693480,17),(83479,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83479,37.87,0.46,375,33872,70,NULL,NULL,'2MASX J11402578+0159054',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000213,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,175.107416667,1.98492,0.033,NULL,60188139008,940439672,14694369,16.7),(83480,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83480,37.18,0.46,273,33873,70,NULL,NULL,'2MASX J11402585+0118214',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000075,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,175.107625,1.30581,0.037,NULL,60184403192,940381299,14693457,17.7),(83481,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83481,37.5,0.46,316,33874,70,NULL,NULL,'2MASX J11402618+0905015',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000171,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,175.109125,9.08369,0.061,NULL,60377910970,943404858,14740700,17.6),(83482,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83482,37.13,0.46,267,33875,70,NULL,NULL,'4C +12.42',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000212,NULL,'15.9g',0.42,'E',NULL,NULL,NULL,NULL,1,175.115583333,12.05231,0.02,NULL,60239494538,941242102,14706907,15.9),(83483,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83483,38.04,0.46,406,33876,70,NULL,NULL,'SDSS J114028.15+043150.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000143,NULL,'17.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,175.117333,4.53069,0.025,NULL,60183916912,940373701,14693339,17.9),(83484,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83484,38.04,0.15,406,33877,70,NULL,NULL,'2MASX J11402814+1023335',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,175.117417,10.39267,0.127,NULL,60372802223,943325034,14739453,17.2),(83485,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83485,38.06,0.13,409,33878,70,NULL,NULL,'2MASX J11402851+0542174',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,175.118791667,5.70472,0.037,NULL,60150920481,939858132,14685283,17.3),(83486,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83486,37.65,0.27,339,33879,70,NULL,NULL,'2MASX J11402992+5557535',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,175.124917,55.96494,0,NULL,61977331395,968395803,15131184,17.8),(83487,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83487,37.73,0.46,351,33880,70,NULL,NULL,'2MASX J11403160+2141419',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00016,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,175.131875,21.69486,0,NULL,61076412192,954318940,14911233,16.9),(83488,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83488,37.23,0.46,279,33881,70,NULL,NULL,'2MASX J11403162+0051114',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000094,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,175.131917,0.85317,0.041,NULL,60184472177,940382377,14693474,16.5),(83489,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83489,38.04,0.15,406,33882,70,NULL,NULL,'2MASX J11403166+1006515',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000107,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,175.131917,10.11428,0.106,NULL,60371950943,943311733,14739245,17.1),(83490,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83490,37.53,0.46,321,33883,70,NULL,NULL,'2MASX J11403261+2309039',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000173,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,175.135916667,23.15133,0,NULL,60542160540,945971258,14780800,17.7),(83491,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83491,37.38,0.46,299,33884,70,NULL,NULL,'2MASX J11403294+1610178',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,175.13725,16.17175,0.024,NULL,60259455211,941553987,14711781,17.1),(83492,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83492,38.44,0.46,488,33885,70,NULL,NULL,'2MASX J11403357+0017274',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000073,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,175.139833333,0.29103,0.037,NULL,60138897213,939670268,14682347,18.3),(83493,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83493,36.95,0.23,246,33886,70,NULL,NULL,'2MASX J11403463-0336199',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.0002,NULL,'16.2g',0.36,'E0',NULL,NULL,NULL,NULL,1,175.144125,-3.60547,0.089,NULL,40866560166,638540002,9977187,16.2),(83494,'Tully est','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83494,32.18,0.8,27.3,33887,75,NULL,'B','UGCA 241',NULL,'1988NBGC.C....0000T',1988,1,2.7,NULL,'G',0.00001,NULL,'13.65',2.2,'(R\')SAB(rs)cd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,175.144125,-10.08581,0.025,NULL,41031954703,641124292,10017567,13.65),(83495,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83495,37.63,0.46,335,33888,70,NULL,NULL,'2MASX J11403461+1545298',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,175.144417,15.75825,0.037,NULL,60258739762,941542808,14711606,18.3),(83496,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83496,38.04,0.15,406,33889,70,NULL,NULL,'2MASX J11403504+1024060',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,175.146,10.40161,0.127,NULL,60372800809,943325012,14739453,17.5),(83497,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83497,37.33,0.46,293,33890,70,NULL,NULL,'2MASX J11403524+5634354',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,175.146583,56.57644,0,NULL,61977882158,968404408,15131318,17.3),(83498,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83498,38.04,0.15,406,33891,70,NULL,NULL,'2MASX J11403647+1024220',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,175.152125,10.40608,0.127,NULL,60372808291,943325129,14739455,17.6),(83499,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83499,35.26,0.07,113,33892,70,NULL,NULL,'SDSS J114036.64+201849.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'16.3g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,175.1527083,20.31369,0,NULL,61082150168,954408596,14912634,16.3),(83500,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,NULL,83500,35.13,0.57,106,33893,70,NULL,NULL,'ESO 266- G 013',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000133,NULL,'15.19',0.6,'(R)SB(r)0^+',NULL,NULL,NULL,NULL,1,175.154833,-44.52533,0.385,NULL,41891284812,654551325,10227364,15.19),(83501,'FP','2016-12-15 15:14:49','2016-12-16 11:19:58','1',NULL,'R',83501,37.36,0.46,297,33894,70,NULL,NULL,'2MASX J11403784+0736060',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,175.1577083,7.60172,0.042,NULL,60376965136,943390080,14740470,17.1),(83502,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83502,37.14,0.46,268,33895,70,NULL,NULL,'2MASX J11403947+6747339',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000063,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,175.164167,67.79267,0.005,NULL,62079318459,969989350,15156083,17.7),(83503,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83503,36.8,0.46,229,33896,70,NULL,NULL,'2MASX J11403961+4644202',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,175.165125,46.73883,0.035,NULL,63902341838,998474091,15601157,17.8),(83504,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83504,37.91,0.23,383,33897,70,NULL,NULL,'2MASX J11403973+1003220',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000123,NULL,'16.7g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,175.165583,10.05614,0.106,NULL,60371957416,943311834,14739247,16.7),(83505,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83505,38.04,0.15,406,33898,70,NULL,NULL,'2MASX J11403986+1015220',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000171,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,175.166167,10.25617,0.127,NULL,60372647086,943322610,14739415,17.7),(83506,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83506,38.04,0.15,406,33899,70,NULL,NULL,'SDSS J114040.57+102422.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,175.169083333,10.40622,0.127,NULL,60372807834,943325122,14739455,18.4),(83507,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83507,37.91,0.23,383,33900,70,NULL,NULL,'SDSS J114040.83+100134.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000169,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,175.170125,10.02622,0.106,NULL,60371953476,943311773,14739246,18.7),(83508,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83508,38.06,0.13,409,33901,70,NULL,NULL,'2MASX J11404097+0549264',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000157,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,175.1707083,5.82397,0.023,NULL,60151435743,939866183,14685409,16.6),(83509,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83509,37.23,0.46,279,33902,70,NULL,NULL,'2MASX J11404137+1408288',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.97',0.19,NULL,NULL,NULL,NULL,NULL,1,175.172417,14.14133,0.096,NULL,60249836450,941403694,14709432,17.97),(83510,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83510,38.68,0.46,544,33903,70,NULL,NULL,'2MASX J11404135+3437167',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000177,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,175.172417,34.62147,0,NULL,60441579932,944399686,14756245,17.6),(83511,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83511,37.69,0.46,346,33904,70,NULL,NULL,'2MASX J11404155+1644538',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,175.173375,16.74847,0.019,NULL,60255929963,941498905,14710920,18.1),(83512,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83512,34.8,0.25,91.2,33905,74.4,NULL,NULL,'NGC 3805',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000063,NULL,'13.65',1.1,'S0-:','in a radial-velocity based grouping',NULL,NULL,NULL,1,175.173667,20.34294,0,NULL,61082156867,954408701,14912635,13.65),(83513,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83513,35.26,0.07,113,33905,70,NULL,NULL,'NGC 3805',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83514,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83514,34.95,0.45,97.9,33905,NULL,NULL,'K','NGC 3805',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83515,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83515,34.99,0.4,99.5,33905,NULL,NULL,'mean','NGC 3805',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83516,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83516,38.04,0.15,406,33906,70,NULL,NULL,'2MASX J11404209+1023130',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,175.1752917,10.387,0.127,NULL,60372756684,943324323,14739442,17.4),(83517,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83517,35.74,0.46,141,33907,70,NULL,NULL,'2MASX J11404261+1418038',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000165,NULL,'16.0g',0.41,'E',NULL,NULL,NULL,NULL,1,175.177625,14.301,0.109,NULL,60261024781,941578512,14712164,16),(83518,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83518,38.04,0.15,406,33908,70,NULL,NULL,'2MASX J11404352+1024430',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000097,NULL,'17.55',0.18,'BrClG',NULL,NULL,NULL,NULL,1,175.181417,10.41208,0.127,NULL,60372807710,943325120,14739455,17.55),(83519,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83519,38.23,0.27,442,33909,70,NULL,NULL,'2MASX J11404360+0403394',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000174,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,175.181667,4.06092,0.013,NULL,60181270792,940332356,14692693,17.6),(83520,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83520,36.26,0.46,179,33910,70,NULL,NULL,'2MASX J11404377+1928299',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000103,NULL,'16.16',0.25,NULL,NULL,NULL,NULL,NULL,1,175.1822917,19.47503,0,NULL,61080822773,954387855,14912310,16.16),(83521,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83521,37.65,0.46,338,33911,70,NULL,NULL,'2MASX J11404397+0718020',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,175.18325,7.30053,0.057,NULL,60376771900,943387060,14740422,17.3),(83522,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83522,34.36,0.69,74.4,33912,100,NULL,'mid-IR','NGC 3808 NED01',NULL,'2013ApJ...771...88L',2013,1,1.7,'Component \'a)\' in UGC notes. Called \'NGC 3808\' in MCG.','G',0.000009,NULL,'14.1',0.9,'SAB(rs)c: pec  HII','Pair member (points to parent)',NULL,NULL,NULL,1,175.184333,22.42936,0,NULL,61075688629,954307634,14911056,14.1),(83523,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83523,35.15,0.4,107,33912,NULL,NULL,'mean','NGC 3808 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83524,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83524,35.33,0.47,116,33912,NULL,NULL,'H','NGC 3808 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83525,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83525,37.98,0.46,395,33913,70,NULL,NULL,'2MASX J11404424+1133090',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,175.184291667,11.55264,0.089,NULL,60239040118,941235001,14706796,18.1),(83526,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83526,38.23,0.27,442,33914,70,NULL,NULL,'SDSS J114044.83+040107.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,175.186833,4.01872,0.009,NULL,60181389599,940334212,14692722,18.2),(83527,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83527,37.21,0.46,277,33915,70,NULL,NULL,'2MASXi J1140455+414535',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000159,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,175.1895,41.75969,0,NULL,60405078663,943829354,14747333,18),(83528,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83528,36.77,0.33,226,33916,70,NULL,NULL,'2MASX J11404550+4455595',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000192,NULL,'15.7g',0.49,'E0',NULL,NULL,NULL,NULL,1,175.189583,44.93331,0,NULL,63903387919,998490436,15601413,15.7),(83529,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83529,37.82,0.46,366,33917,70,NULL,NULL,'SDSS J114045.80+105616.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,175.190875,10.93786,0.115,NULL,60372138868,943314669,14739291,18.2),(83530,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83530,38.86,0.46,592,33918,70,NULL,NULL,'SDSS J114046.14+001403.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000088,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,175.19225,0.23425,0.037,NULL,60138913754,939670527,14682351,18.4),(83531,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83531,37.44,0.46,307,33919,70,NULL,NULL,'2MASX J11404619+5900574',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,175.192417,59.01611,0,NULL,61855484877,966491951,15101436,16.4),(83532,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83532,34.77,0.2,90,33920,74.4,NULL,NULL,'KUG 1138+175',NULL,'2013AJ....146...86T',2013,1,0.64,NULL,'G',0.000009,NULL,'16.3g',0.2,'Spiral',NULL,NULL,NULL,NULL,1,175.193833333,17.26797,0.032,NULL,60201363995,940646312,14697598,16.3),(83533,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83533,36.32,0.46,184,33921,70,NULL,NULL,'CGCG 242-073',NULL,'2015arXiv151105856S',2015,1,0.95,NULL,'G',0.000157,NULL,'14.6g',0.72,'E0',NULL,NULL,NULL,NULL,1,175.197333,46.5405,0.012,NULL,63902578019,998477781,15601215,14.6),(83534,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83534,37.3,0.33,289,33922,70,NULL,NULL,'2MASX J11404779+5403504',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,175.199125,54.064,0,NULL,61772984595,965202884,15081295,17.3),(83535,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83535,37.91,0.33,383,33923,70,NULL,NULL,'2MASX J11404795+2723100',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,175.199875,27.38622,0.048,NULL,60596448285,946819504,14794054,17.7),(83536,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83536,36.77,0.33,226,33924,70,NULL,NULL,'2MASX J11404796+4452086',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000183,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,175.2,44.869,0.005,NULL,63903416577,998490884,15601420,17),(83537,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83537,38.09,0.46,415,33925,70,NULL,NULL,'2MASX J11404803+4231586',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,175.200125,42.53292,0.043,NULL,63897302020,998395344,15599927,17.6),(83538,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83538,37.38,0.46,299,33926,70,NULL,NULL,'2MASX J11404818+1830219',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.37',0.15,NULL,NULL,NULL,NULL,NULL,1,175.200625,18.50594,0,NULL,61081164893,954393201,14912393,18.37),(83539,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83539,37.44,0.46,308,33927,70,NULL,NULL,'2MASX J11404831+2228019',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000173,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,175.201417,22.46725,0,NULL,61075700842,954307825,14911059,18),(83540,'Tully est','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83540,32.15,0.8,26.9,33928,75,NULL,'B','MRK 0426',NULL,'1988NBGC.C....0000T',1988,1,0.84,NULL,'G',0.000004,NULL,'14.8g',0.42,'dwarf','Group member',NULL,NULL,NULL,1,175.204333,35.20269,0,NULL,60443929467,944436397,14756818,14.8),(83541,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83541,32.08,0.2,26.1,33928,74.4,NULL,NULL,'MRK 0426',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83542,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83542,37.89,0.23,379,33929,70,NULL,NULL,'2MASX J11404968+1057560',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000179,NULL,'17.5g',0.11,'WLAGN',NULL,NULL,NULL,NULL,1,175.207125,10.96567,0.115,NULL,60372125467,943314460,14739288,17.5),(83543,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83543,38.04,0.46,405,33930,70,NULL,NULL,'SDSS J114050.36+081040.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000138,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,175.209875,8.17792,0.036,NULL,60375658473,943369663,14740150,18.1),(83544,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83544,37.16,0.46,270,33931,70,NULL,NULL,'2MASX J11405065+6332353',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000071,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,175.211125,63.54311,0.069,NULL,61818152755,965908636,15092322,17.6),(83545,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83545,37.31,0.46,290,33932,70,NULL,NULL,'2MASXi J1140508-011905',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000157,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,175.2119583,-1.31819,0.037,NULL,40861628143,638462939,9975983,17.2),(83546,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83546,37.3,0.33,289,33933,70,NULL,NULL,'2MASX J11405109+5404293',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,175.2129583,54.07494,0,NULL,61772988223,965202940,15081295,17.8),(83547,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83547,38.16,0.33,428,33934,70,NULL,NULL,'2MASX J11405152+1223138',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,175.214833333,12.38722,0.054,NULL,60239219058,941237797,14706840,17.3),(83548,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83548,38.67,0.46,543,33935,70,NULL,NULL,'SDSS J114052.54+034243.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,175.218917,3.71203,0,NULL,60181372970,940333952,14692718,18.3),(83549,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83549,30.97,0.09,15.7,33936,NULL,NULL,NULL,'NGC 3794',NULL,'2009ApJS..182..474S',2009,1,2.2,NULL,'G',0.000002,NULL,'13.50',1.4,'SAB(s)d','in a radial-velocity based grouping',NULL,NULL,NULL,1,175.222583333,56.20203,0,NULL,61978153669,968408651,15131385,13.5),(83550,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83550,31.42,0.4,19.2,33936,NULL,NULL,NULL,'NGC 3794',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83551,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83551,31.7,0.43,21.9,33936,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3794',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83552,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83552,31.71,0.2,22,33936,74.4,NULL,NULL,'NGC 3794',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83553,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83553,31.71,0.43,22,33936,75,NULL,'3.6 micron, color corrected','NGC 3794',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83554,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83554,31.96,0.4,24.7,33936,75,NULL,'B','NGC 3794',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83555,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83555,37.89,0.23,379,33937,70,NULL,NULL,'2MASX J11405355+1100300',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000207,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,175.223083,11.00847,0.115,NULL,60369289921,943270155,14738596,17.8),(83556,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83556,37.77,0.46,357,33938,70,NULL,NULL,'2MASX J11405390+0610440',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000147,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,175.2245417,6.179,0.029,NULL,60151550528,939867977,14685437,17.3),(83557,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83557,35.28,0.46,114,33939,70,NULL,NULL,'2MASX J11405417-0241409',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00015,NULL,'15.4g',0.5,'E0',NULL,NULL,NULL,NULL,1,175.225708333,-2.69467,0.061,NULL,40862403053,638475047,9976172,15.4),(83558,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83558,36.34,0.46,185,33940,70,NULL,NULL,'2MASX J11405438+1654448',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'17.20',0.14,NULL,NULL,NULL,NULL,NULL,1,175.2265417,16.91233,0.02,NULL,60255960135,941499377,14710927,17.2),(83559,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83559,36.66,0.46,215,33941,70,NULL,NULL,'2MASX J11405438+2251280',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000097,NULL,'16.0g',0.33,NULL,NULL,NULL,NULL,NULL,1,175.2265417,22.85772,0,NULL,61075642439,954306913,14911045,16),(83560,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83560,38.1,0.46,418,33942,70,NULL,NULL,'2MASX J11405561+1945080',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.3r',0.16,NULL,'Group member',NULL,NULL,NULL,1,175.23175,19.75236,0,NULL,61080664864,954385388,14912271,16.3),(83561,'IRAS','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83561,33.1,0.8,41.7,33943,75,NULL,'MAT, I','ESO 266- G 015',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000024,NULL,'13.00',1,'SAB(s)c',NULL,NULL,NULL,NULL,1,175.23225,-44.48125,0.385,NULL,41891362461,654552538,10227383,13),(83562,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83562,32.87,0.47,37.5,33943,NULL,NULL,'H','ESO 266- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83563,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83563,32.89,0.32,37.8,33943,85,NULL,'I, raw','ESO 266- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83564,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83564,32.9,0.45,38,33943,NULL,NULL,'K','ESO 266- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83565,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83565,32.93,0.46,38.5,33943,NULL,NULL,'J','ESO 266- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83566,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83566,32.93,0.32,38.6,33943,85,NULL,'I, inv','ESO 266- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83567,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83567,33.05,0.43,40.8,33943,75,NULL,'MAT, I, raw','ESO 266- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83568,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83568,33.14,0.4,42.5,33943,NULL,NULL,NULL,'ESO 266- G 015',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83569,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83569,33.26,0.43,44.9,33943,75,NULL,'MAT, I, inv','ESO 266- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83570,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83570,33.27,0.43,45,33943,75,NULL,'MAT, I, cor','ESO 266- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83571,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83571,33.3,0.71,45.7,33943,NULL,NULL,'Malmquist cor.','ESO 266- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83572,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83572,33.39,0.4,47.6,33943,NULL,NULL,'mean','ESO 266- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83573,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83573,33.44,0.67,48.7,33943,NULL,NULL,NULL,'ESO 266- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83574,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83574,33.48,0.2,49.7,33943,74.4,NULL,NULL,'ESO 266- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83575,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83575,32.74,NULL,35.3,33944,NULL,NULL,NULL,'SDSS J114056.74+140427.1',NULL,'2015AstBu..70....1K',2015,1,0.86,NULL,'G',0.000183,NULL,'16.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,175.2364583,14.07422,0.108,NULL,60249656810,941400887,14709388,16.3),(83576,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83576,37.12,0.46,265,33945,70,NULL,NULL,'2MASX J11405722+2209170',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,175.238458333,22.15472,0,NULL,61076071566,954313618,14911150,17.7),(83577,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83577,36.15,0.6,170,33946,70,NULL,NULL,'2MASX J11405798-1032486',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.14',0.4,NULL,NULL,NULL,NULL,NULL,1,175.2414583,-10.54692,0.017,NULL,41032850167,641138283,10017785,16.14),(83578,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83578,34.04,0.52,64.2,33947,70,NULL,NULL,'ESO 266- G 016',NULL,'2014MNRAS.445.2677S',2014,1,0.7,'This is not IC 2949; that is probably a nearby double star.','G',0.0001,NULL,'15.37',0.4,'S0',NULL,NULL,NULL,NULL,1,175.2437917,-46.57044,0.401,NULL,41889810194,654528284,10227004,15.37),(83579,'IRAS','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83579,34.94,0.8,97.4,33948,75,NULL,'MAT, I','ESO 571- G 015',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'13.61',0.2,'Sb',NULL,NULL,NULL,NULL,1,175.244917,-22.47728,0.121,NULL,41684706726,651323542,10176930,13.61),(83580,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83580,34.49,0.49,79,33948,75,NULL,'IR','ESO 571- G 015',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83581,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83581,35.02,0.43,101,33948,75,NULL,'MAT, I, raw','ESO 571- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83582,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83582,35.07,0.32,103,33948,85,NULL,'I, raw','ESO 571- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83583,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83583,35.12,0.32,106,33948,85,NULL,'I, inv','ESO 571- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83584,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83584,35.23,0.4,111,33948,NULL,NULL,'mean','ESO 571- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83585,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83585,35.25,0.5,112,33948,NULL,NULL,'Malmquist cor.','ESO 571- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83586,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83586,35.26,0.43,113,33948,75,NULL,'MAT, I, inv','ESO 571- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83587,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83587,35.35,0.48,117,33948,NULL,NULL,NULL,'ESO 571- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83588,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83588,35.35,0.2,117,33948,74.4,NULL,NULL,'ESO 571- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83589,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83589,35.36,0.43,118,33948,75,NULL,'MAT, I, cor','ESO 571- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83590,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83590,35.43,0.47,122,33948,NULL,NULL,'H','ESO 571- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83591,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83591,30.65,0.4,13.5,33949,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 3 galaxy group','NGC 3810',NULL,'1992ApJS...80..479T',1992,1,1.69,NULL,'G',0.000002,NULL,'12.0g',1.5,'SA(rs)c        HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,175.244833,11.47114,0.142,NULL,60239004717,941234448,14706788,12),(83592,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83592,30.78,0.43,14.3,33949,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3810',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83593,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83593,30.91,0.43,15.2,33949,75,NULL,'3.6 micron, color corrected','NGC 3810',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83594,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83594,30.93,0.36,15.3,33949,NULL,NULL,NULL,'NGC 3810',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83595,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83595,31.07,0.2,16.4,33949,74.4,NULL,NULL,'NGC 3810',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83596,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83596,31.14,0.4,16.9,33949,75,NULL,'B','NGC 3810',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83597,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83597,31.26,0.44,17.8,33949,NULL,NULL,NULL,'NGC 3810',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83598,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83598,31.3,0.43,18.2,33949,NULL,NULL,'Malmquist cor.','NGC 3810',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83599,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83599,31.49,0.45,19.8,33949,NULL,NULL,'K','NGC 3810',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83600,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83600,31.49,0.4,19.8,33949,NULL,NULL,'mean','NGC 3810',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83601,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83601,31.98,0.3,24.9,33949,55,NULL,'B','NGC 3810',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83602,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83602,37.89,0.46,379,33950,70,NULL,NULL,'2MASX J11405957+1532325',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,175.248,15.54233,0.037,NULL,60256740402,941511568,14711118,17.9),(83603,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83603,38.06,0.13,409,33951,70,NULL,NULL,'SDSS J114103.53+054751.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000162,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,175.264708333,5.79758,0.023,NULL,60150962790,939858793,14685293,18.4),(83604,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83604,37.92,0.46,383,33952,70,NULL,NULL,'SDSS J114104.11+123802.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000172,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,175.267166667,12.63414,0.077,NULL,60247294434,941363975,14708812,18.2),(83605,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83605,38.03,0.23,404,33953,70,NULL,NULL,'2MASX J11410415+5620231',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000145,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,175.267458333,56.33978,0,NULL,61977936196,968405253,15131332,17.7),(83606,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83606,38.06,0.13,409,33954,70,NULL,NULL,'2MASX J11410470+0534333',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000083,NULL,'16.5g',0.38,NULL,NULL,NULL,NULL,NULL,1,175.269541667,5.57606,0.037,NULL,60180510386,940320474,14692507,16.5),(83607,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83607,38.16,0.33,428,33955,70,NULL,NULL,'2MASX J11410487+1222405',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000145,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,175.270375,12.37797,0.054,NULL,60239362824,941240044,14706875,18.5),(83608,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83608,37.54,0.33,323,33956,70,NULL,NULL,'2MASX J11410486+1247445',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000142,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,175.270375,12.79589,0.077,NULL,60247263536,941363492,14708804,18.1),(83609,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83609,38.01,0.46,399,33957,70,NULL,NULL,'LCRS B113831.6-030355',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,175.271083333,-3.34233,0.089,NULL,40867196640,638549947,9977342,18.4),(83610,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83610,36.55,0.33,204,33958,70,NULL,NULL,'LCRS B113832.8-021613',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,175.276333333,-2.54725,0.061,NULL,40862473449,638476147,9976189,17.2),(83611,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83611,38.04,0.15,406,33959,70,NULL,NULL,'SDSS J114106.37+102747.7',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000175,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,175.276583,10.46328,0.127,NULL,60372722069,943323782,14739434,17.6),(83612,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83612,38.2,0.46,437,33960,70,NULL,NULL,'2MASX J11410649+1450355',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,175.2769583,14.84325,0.091,NULL,60261459113,941585298,14712270,17.9),(83613,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83613,36.99,0.33,250,33961,70,NULL,NULL,'2MASX J11410654+5511182',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000194,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,175.27725,55.18839,0,NULL,61771839303,965184989,15081015,16.6),(83614,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83614,38.08,0.46,413,33962,70,NULL,NULL,'2MASX J11410796+0233133',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000078,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,175.28325,2.55369,0.025,NULL,60186944818,940421012,14694078,17.4),(83615,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83615,38.06,0.13,409,33963,70,NULL,NULL,'2MASX J11410832+0530523',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.0001,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,175.284666667,5.5145,0.037,NULL,60180634860,940322419,14692537,16.7),(83616,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83616,38.01,0.46,400,33964,70,NULL,NULL,'2MASX J11410888+5438192',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000133,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,175.2867083,54.63883,0,NULL,61772548804,965196075,15081188,18.1),(83617,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83617,38.06,0.46,409,33965,70,NULL,NULL,'2MASX J11410925+4834295',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,175.2887083,48.57478,0,NULL,61751180488,964862195,15075971,18),(83618,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83618,37.69,0.46,345,33966,70,NULL,NULL,'2MASX J11410979+0137133',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000076,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,175.290833,1.62028,0.037,NULL,60187909601,940436087,14694313,17.3),(83619,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83619,37.74,0.46,354,33967,70,NULL,NULL,'2MASX J11411077+0222353',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000086,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,175.295,2.37672,0.033,NULL,60186846641,940419478,14694054,17.6),(83620,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83620,38.06,0.13,409,33968,70,NULL,NULL,'2MASX J11411114+0535233',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,175.296416667,5.58986,0.037,NULL,60180510084,940320470,14692507,17.2),(83621,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83621,38.06,0.13,409,33969,70,NULL,NULL,'4C +06.42',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000195,NULL,'16.2g',0.38,'cD;BrClG;E',NULL,NULL,'WAT?',NULL,1,175.2992083,5.73472,0.037,NULL,60150935613,939858368,14685287,16.2),(83622,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83622,38.06,0.13,409,33970,70,NULL,NULL,'SDSS J114113.04+053753.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,175.304375,5.63158,0.037,NULL,60180498361,940320286,14692504,18),(83623,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83623,35.63,0.46,134,33971,70,NULL,NULL,'2MASX J11411310+2739538',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000173,NULL,'15.8g',0.34,NULL,NULL,NULL,NULL,NULL,1,175.3045417,27.66511,0.047,NULL,60596453511,946819586,14794056,15.8),(83624,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83624,38.54,0.46,511,33972,70,NULL,NULL,'SDSS J114113.37+084458.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000174,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,175.305708333,8.74947,0.05,NULL,60377442277,943397535,14740586,18.3),(83625,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83625,37.21,0.46,276,33973,70,NULL,NULL,'2MASX J11411419+5809112',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000193,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,175.309375,58.15308,0,NULL,61843024243,966297253,15098394,16.8),(83626,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83626,37.28,0.46,286,33974,70,NULL,NULL,'SDSS J114114.89+041528.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000132,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,175.312083,4.25797,0.013,NULL,60183180469,940362194,14693159,17.9),(83627,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83627,37.34,0.23,294,33975,70,NULL,NULL,'2MASX J11411499+6039582',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00012,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,175.31275,60.66633,0.053,NULL,61854257081,966472766,15101136,16.3),(83628,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83628,38.43,0.46,485,33976,70,NULL,NULL,'2MASX J11411515+1043155',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000019,NULL,'17.2g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,175.313,10.72097,0.118,NULL,60372223499,943315992,14739312,17.2),(83629,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83629,37.47,0.46,312,33977,70,NULL,NULL,'2MASX J11411619+1541095',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,175.31725,15.68611,0.037,NULL,60258555876,941539935,14711561,17.8),(83630,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83630,36.71,0.46,220,33978,70,NULL,NULL,'2MASX J11411634+2209334',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000097,NULL,'17.58',0.28,NULL,NULL,NULL,NULL,NULL,1,175.317958333,22.15944,0,NULL,61076065778,954313527,14911148,17.58),(83631,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83631,37.5,0.46,316,33979,70,NULL,NULL,'2MASX J11411645+6109012',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000119,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,175.318875,61.15036,0.017,NULL,61846938640,966358416,15099350,17.6),(83632,'SNIa','2016-12-15 15:14:50','2016-12-16 11:19:58','1','SN 1969C',NULL,83632,33.08,0.3,41.3,33980,60,NULL,'M(V) = -19.47 mag','NGC 3811',NULL,'2000ApJ...540..634P',2000,1,2.2,NULL,'G',0.00002,NULL,'12.9',1.7,'SB(r)cd:       Sbrst','Group member',NULL,NULL,'Starburst',1,175.3192917,47.69081,0.018,NULL,61749670757,964838605,15075603,12.9),(83633,'SNIa','2016-12-15 15:14:50','2016-12-16 11:19:58','1','SN 1969C',NULL,83633,33.14,0.3,42.5,33980,60,NULL,'M(B) = -19.48 mag','NGC 3811',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83634,'SNIa','2016-12-15 15:14:50','2016-12-16 11:19:58','1','SN 1969C','R',83634,33.73,NULL,55.7,33980,NULL,NULL,'Photographic','NGC 3811',NULL,'1988SSRv...48....1R',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83635,'Ring Diameter','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83635,32.2,0.84,27,33980,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3811',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83636,'Sosies','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83636,33.21,0.37,43.9,33980,NULL,NULL,NULL,'NGC 3811',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83637,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83637,33.43,0.4,48.5,33980,NULL,NULL,'mean','NGC 3811',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83638,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83638,33.49,0.45,49.8,33980,NULL,NULL,'K','NGC 3811',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83639,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83639,33.51,0.47,50.4,33980,NULL,NULL,'H','NGC 3811',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83640,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83640,33.53,0.46,50.8,33980,NULL,NULL,'J','NGC 3811',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83641,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83641,33.99,0.85,62.8,33980,NULL,NULL,NULL,'NGC 3811',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83642,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83642,34.03,0.2,64,33980,74.4,NULL,NULL,'NGC 3811',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83643,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83643,34.1,0.81,66.2,33980,NULL,NULL,'Malmquist cor.','NGC 3811',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83644,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83644,38.06,0.13,409,33981,70,NULL,NULL,'2MASX J11411669+0537203',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000193,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,175.319541667,5.62233,0.037,NULL,60180500315,940320317,14692504,17.2),(83645,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83645,37.91,0.33,383,33982,70,NULL,NULL,'SDSS J114116.95+272519.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000148,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,175.320667,27.42197,0.048,NULL,60596659207,946822800,14794106,18.4),(83646,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83646,36.99,0.33,250,33983,70,NULL,NULL,'2MASX J11411717+5502542',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000174,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,175.321417,55.04836,0,NULL,61771815418,965184615,15081009,16.8),(83647,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83647,37.26,0.46,284,33984,70,NULL,NULL,'2MASX J11411753+1320375',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000138,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,175.323041667,13.34372,0.064,NULL,60251036502,941422445,14709725,17.6),(83648,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83648,38.06,0.13,409,33985,70,NULL,NULL,'SDSS J114118.24+054808.4',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,175.3260417,5.80233,0.023,NULL,60150960110,939858751,14685292,18.2),(83649,'IRAS','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83649,32.14,0.8,26.8,33986,75,NULL,'A82, H','NGC 3813',NULL,'1997ApJS..109..333W',1997,1,2.35,NULL,'G',0.000017,NULL,'12.1g',1,'SA(rs)b:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,175.32775,36.54681,0.013,NULL,60442087399,944407615,14756368,12.1),(83650,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83650,31.47,0.43,19.7,33986,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3813',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83651,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83651,31.61,0.43,21,33986,75,NULL,'3.6 micron, color corrected','NGC 3813',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83652,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83652,31.68,0.4,21.7,33986,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 3813',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83653,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83653,31.76,0.51,22.5,33986,NULL,NULL,'Malmquist cor.','NGC 3813',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83654,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83654,31.8,0.38,22.9,33986,NULL,NULL,NULL,'NGC 3813',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83655,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83655,31.84,0.2,23.3,33986,74.4,NULL,NULL,'NGC 3813',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83656,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83656,31.96,0.47,24.7,33986,75,NULL,'A82, H, raw','NGC 3813',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83657,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83657,32.04,0.47,25.5,33986,75,NULL,'A82, H, inv','NGC 3813',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83658,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83658,32.04,0.45,25.6,33986,NULL,NULL,'K','NGC 3813',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83659,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83659,32.05,0.46,25.7,33986,NULL,NULL,'J','NGC 3813',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83660,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83660,32.05,0.47,25.7,33986,NULL,NULL,'H','NGC 3813',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83661,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83661,32.1,0.4,26.4,33986,75,NULL,'B','NGC 3813',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83662,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83662,32.13,0.47,26.7,33986,75,NULL,'A82, H, cor','NGC 3813',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83663,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83663,32.13,0.43,26.7,33986,NULL,NULL,NULL,'NGC 3813',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83664,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83664,32.25,0.4,28.2,33986,NULL,NULL,'mean','NGC 3813',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83665,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83665,32.34,0.3,29.4,33986,55,NULL,'B','NGC 3813',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83666,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83666,38.03,0.23,404,33987,70,NULL,NULL,'2MASX J11411955+5625382',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,175.33125,56.42736,0,NULL,61977836822,968403700,15131307,17.4),(83667,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83667,38.09,0.46,416,33988,70,NULL,NULL,'2MASX J11411972+2853288',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,175.332083,28.89128,0.023,NULL,60554979469,946171554,14783930,17.6),(83668,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83668,36.39,0.56,190,33989,70,NULL,NULL,'2MASX J11411977-5106429',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,175.332333333,-51.112,0.753,NULL,40052784812,625824762,9778511,15.3),(83669,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83669,37.02,0.46,254,33990,70,NULL,NULL,'2MASX J11412014+5407292',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000176,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,175.333875,54.12486,0,NULL,61772968405,965202631,15081291,17),(83670,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83670,37.01,0.46,252,33991,70,NULL,NULL,'2MASX J11412023+1230415',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000143,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,175.334333333,12.51161,0.077,NULL,60239148376,941236693,14706823,17.5),(83671,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83671,37.59,0.33,330,33992,70,NULL,NULL,'SDSS J114120.48+133508.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000172,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,175.335375,13.58578,0.095,NULL,60250308133,941411064,14709547,18.6),(83672,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83672,37.69,0.46,344,33993,70,NULL,NULL,'SDSS J114120.49+144527.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000156,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,175.335417,14.75775,0.118,NULL,60261454824,941585231,14712269,18.6),(83673,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83673,37.45,0.46,309,33994,70,NULL,NULL,'2MASX J11412065+3214331',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,175.336083,32.24253,0,NULL,60632407166,947381361,14802833,17.8),(83674,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83674,37.91,0.46,382,33995,70,NULL,NULL,'2MASX J11412075+3840321',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,175.336625,38.67553,0,NULL,60461553397,944711771,14761121,18),(83675,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83675,36.66,0.55,215,33996,70,NULL,NULL,'2MASX J11412083-2012411',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,175.3367917,-20.21142,0.113,NULL,41690653535,651416461,10178382,15.9),(83676,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83676,36.23,0.46,176,33997,70,NULL,NULL,'2MASX J11412130+6304411',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000183,NULL,'16.0g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,175.3385417,63.07808,0.073,NULL,61863563999,966618187,15103409,16),(83677,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83677,38.18,0.46,433,33998,70,NULL,NULL,'2MASX J11412158+3207471',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000139,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,175.339917,32.12967,0,NULL,60630372890,947349576,14802337,18),(83678,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83678,35.26,0.07,113,33999,70,NULL,NULL,'CGCG 097-055',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00007,NULL,'15.14',0.7,'E','Group member',NULL,NULL,NULL,1,175.343,19.96267,0,NULL,61078769386,954355771,14911808,15.14),(83679,'Tully est','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83679,32.18,0.8,27.3,34000,75,NULL,NULL,'UGCA 242',NULL,'1988NBGC.C....0000T',1988,1,1.7,'Position is for center of outer isophotes.','G',0.000017,NULL,'13.87',1.3,'SAB(s)m pec:',NULL,NULL,NULL,NULL,1,175.343625,-6.48139,0.113,NULL,40844569943,638196405,9971818,13.87),(83680,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83680,38.44,0.46,488,34001,70,NULL,NULL,'2MASX J11412248+0708055',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000193,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,175.343791667,7.13489,0.066,NULL,60376631176,943384862,14740388,17.8),(83681,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83681,38.07,0.46,411,34002,70,NULL,NULL,'2MASX J11412272+2834158',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000187,NULL,'17.5g',0.22,'BrClG',NULL,NULL,NULL,NULL,1,175.344583,28.57111,0.035,NULL,60585068206,946641690,14791276,17.5),(83682,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83682,35.5,0.46,126,34003,70,NULL,NULL,'CGCG 157-015',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.00008,NULL,'14.6g',0.67,'S0/a',NULL,NULL,NULL,NULL,1,175.357667,27.85917,0.047,NULL,60585264676,946644760,14791324,14.6),(83683,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83683,38.42,0.23,483,34004,70,NULL,NULL,'SDSS J114125.90+043935.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000162,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,175.3579583,4.65975,0.006,NULL,60184017692,940375276,14693363,18.3),(83684,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83684,38.15,0.46,426,34005,70,NULL,NULL,'2MASX J11412622+1938314',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,175.359208333,19.64203,0,NULL,61078782791,954355981,14911812,17.3),(83685,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83685,36.16,0.53,171,34006,70,NULL,NULL,'2MASX J11412636-1702046',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.51',NULL,NULL,NULL,NULL,NULL,NULL,1,175.359917,-17.03464,0.065,NULL,40991204933,640487577,10007618,16.51),(83686,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83686,36.55,0.33,204,34007,70,NULL,NULL,'CGCG 012-059 NED01',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000114,NULL,'15.9g',0.3,'E0',NULL,NULL,NULL,NULL,1,175.360167,-2.49656,0.029,NULL,40862451148,638475799,9976184,15.9),(83687,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83687,38.06,0.13,409,34008,70,NULL,NULL,'SDSS J114126.81+052634.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,175.36175,5.443,0,NULL,60180615594,940322118,14692533,18.1),(83688,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83688,37.33,0.46,292,34009,70,NULL,NULL,'2MASX J11412724+5418212',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000181,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,175.363583333,54.30575,0,NULL,61772118629,965189353,15081083,16.8),(83689,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83689,35.76,0.15,142,34010,70,NULL,NULL,'UGC 06652 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000172,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,175.366791667,33.68222,0,NULL,60622963457,947233804,14800528,16.9),(83690,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83690,36.67,0.46,216,34011,70,NULL,NULL,'2MASX J11412835+2120174',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,175.368083,21.33825,0,NULL,61085081348,954454396,14913349,17.3),(83691,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83691,36.43,0.62,194,34012,70,NULL,NULL,'2MASX J11412985-3709545',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,175.3742917,-37.16517,0.361,NULL,41391625756,646744152,10105377,14.9),(83692,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83692,38.06,0.13,409,34013,70,NULL,NULL,'SDSS J114130.50+055648.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,175.377125,5.94686,0.023,NULL,60150942165,939858471,14685288,18),(83693,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83693,38.42,0.23,483,34014,70,NULL,NULL,'SDSS J114130.60+044116.5',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000139,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,175.3775417,4.68794,0.006,NULL,60184009564,940375149,14693361,18),(83694,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83694,37.61,0.12,333,34015,70,NULL,NULL,'2MASX J11413065+0815124',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.22',0.18,NULL,NULL,NULL,NULL,NULL,1,175.377625,8.2535,0.036,NULL,60375481496,943366898,14740107,17.22),(83695,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83695,38.15,0.46,426,34016,70,NULL,NULL,'2MASX J11413082+0907244',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,175.378375,9.12336,0.034,NULL,60377814181,943403346,14740677,17.5),(83696,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83696,38.12,0.46,422,34017,70,NULL,NULL,'2MASX J11413101+1824264',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,175.37925,18.40722,0,NULL,61077720456,954339382,14911552,17.9),(83697,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83697,39.19,0.46,690,34018,70,NULL,NULL,'SDSS J114131.76+172036.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,175.382375,17.34353,0.032,NULL,60201339407,940645928,14697592,18.3),(83698,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83698,36.07,0.46,164,34019,70,NULL,NULL,'2MASX J11413203-0219258',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000103,NULL,'16.0g',0.32,'S0',NULL,NULL,NULL,NULL,1,175.3835,-2.32383,0.029,NULL,40864210892,638503295,9976613,16),(83699,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83699,37.37,0.46,298,34020,70,NULL,NULL,'2MASX J11413350+2846599',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,175.389583,28.78331,0.023,NULL,60554853536,946169586,14783899,17.3),(83700,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83700,37.59,0.46,330,34021,70,NULL,NULL,'2MASX J11413346+4817224',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,175.389583,48.28978,0.013,NULL,61749891911,964842061,15075657,17.2),(83701,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83701,37.14,0.46,268,34022,70,NULL,NULL,'2MASX J11413501-0035588',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000073,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,175.3957917,-0.59967,0.033,NULL,40807398356,637615599,9962743,17.6),(83702,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83702,37.61,0.12,333,34023,70,NULL,NULL,'2MASX J11413510+0724510',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000185,NULL,'16.7g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,175.39625,7.41431,0.032,NULL,60376681951,943385655,14740400,16.7),(83703,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83703,37.95,0.46,390,34024,70,NULL,NULL,'2MASX J11413585+3120000',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,175.3995417,31.33333,0.026,NULL,60626496045,947289000,14801390,17.9),(83704,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83704,37.71,0.33,349,34025,70,NULL,NULL,'2MASX J11413625+0936500',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000137,NULL,'16.6g',0.37,NULL,NULL,NULL,NULL,NULL,1,175.401167,9.61394,0.078,NULL,60377562029,943399406,14740615,16.6),(83705,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83705,36.32,0.46,183,34026,70,NULL,NULL,'2MASX J11413747+4704473',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000167,NULL,'15.9g',0.47,'E0',NULL,NULL,NULL,NULL,1,175.4062917,47.07983,0.021,NULL,63893934052,998342719,15599104,15.9),(83706,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83706,36.79,0.46,228,34027,70,NULL,NULL,'2MASX J11413890+2353409',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000152,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,175.4122917,23.89456,0,NULL,60544537870,946008404,14781381,16.5),(83707,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83707,37.17,0.46,272,34028,70,NULL,NULL,'2MASX J11413908+2020374',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.75',0.23,NULL,NULL,NULL,NULL,NULL,1,175.412875,20.34375,0,NULL,61085363432,954458803,14913418,17.75),(83708,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83708,33.93,0.4,61.2,34029,NULL,NULL,'mean','NGC 3815',NULL,'2007A&A...465...71T',2007,1,1.76,NULL,'G',0.00003,NULL,'13.7g',0.72,'Sab','in a radial-velocity based grouping',NULL,NULL,NULL,1,175.4137083,24.8005,0.008,NULL,60542979478,945984054,14781000,13.7),(83709,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83709,33.99,0.47,62.9,34029,NULL,NULL,'H','NGC 3815',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83710,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83710,34.02,0.45,63.7,34029,NULL,NULL,'K','NGC 3815',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83711,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83711,34.07,0.46,65.2,34029,NULL,NULL,'J','NGC 3815',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83712,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83712,38.45,0.46,489,34030,70,NULL,NULL,'2MASX J11413949+5551551',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000174,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,175.41475,55.86536,0,NULL,61977225829,968394153,15131158,17.6),(83713,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83713,33.89,0.49,60,34031,75,NULL,'IR','UGC 06653',NULL,'2011yCatp016004901K',2011,1,1.56,'HOLM 275C is a star.','G',0.000023,NULL,'14.3g',0.39,'SB0/a?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,175.415541667,15.96572,0.036,NULL,60258760848,941543138,14711611,14.3),(83714,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83714,38.03,0.23,404,34032,70,NULL,NULL,'2MASX J11414100+5625140',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,175.4207083,56.42069,0,NULL,61977829027,968403578,15131305,17.4),(83715,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83715,37.6,0.46,330,34033,70,NULL,NULL,'SDSS J114141.00+502020.4',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.00012,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,175.420833,50.33903,0,NULL,61801155052,965643047,15088172,18.4),(83716,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83716,38.42,0.23,483,34034,70,NULL,NULL,'SDSS J114143.00+044213.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00017,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,175.429167,4.70381,0,NULL,60183983789,940374746,14693355,18.2),(83717,'IRAS','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83717,34.84,0.8,92.8,34035,75,NULL,'W91CL, r','CGCG 097-058',NULL,'1997ApJS..109..333W',1997,1,0.8,NULL,'G',0.000073,NULL,'15.3',0.25,'Sc',NULL,NULL,NULL,NULL,1,175.43025,17.00786,0.016,NULL,60255899428,941498428,14710912,15.3),(83718,'IRAS','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83718,34.86,0.8,93.7,34035,75,NULL,'HMCL, I','CGCG 097-058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83719,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83719,34.37,0.38,74.9,34035,75,NULL,'W91CL, r, raw','CGCG 097-058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83720,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83720,34.41,0.38,76.2,34035,75,NULL,'W91CL, r, inv','CGCG 097-058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83721,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83721,34.46,0.4,78,34035,75,NULL,'HMCL, I, raw','CGCG 097-058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83722,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83722,34.55,0.4,81.3,34035,75,NULL,'HMCL, I, inv','CGCG 097-058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83723,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83723,34.66,0.38,85.6,34035,75,NULL,'W91CL, r, cor','CGCG 097-058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83724,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83724,34.75,0.4,89,34035,75,NULL,'HMCL, I, cor','CGCG 097-058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83725,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83725,34.93,0.13,97,34035,NULL,NULL,NULL,'CGCG 097-058',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83726,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83726,37.93,0.46,385,34036,70,NULL,NULL,'LCRS B113909.8-022847',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000131,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,175.4307917,-2.75664,0.065,NULL,40862255234,638472738,9976136,18.4),(83727,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83727,37.59,0.33,330,34037,70,NULL,NULL,'2MASX J11414453+1331374',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000189,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,175.435417,13.52697,0.095,NULL,60250271503,941410492,14709538,16.4),(83728,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83728,37.19,0.46,274,34038,70,NULL,NULL,'SDSS J114144.64+063611.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00013,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,175.436,6.60317,0,NULL,60151273416,939863647,14685369,18.3),(83729,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83729,35.89,0.46,151,34039,70,NULL,NULL,'2MASX J11414605-0214008',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000076,NULL,'16.2g',0.32,NULL,NULL,NULL,NULL,NULL,1,175.4417083,-2.23356,0.029,NULL,40864258677,638504041,9976625,16.2),(83730,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83730,38.57,0.46,517,34040,70,NULL,NULL,'SDSS J114146.01+210648.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000138,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,175.44175,21.11339,0,NULL,61085143298,954455364,14913365,18.5),(83731,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83731,38.74,0.46,560,34041,70,NULL,NULL,'SDSS J114146.07+065948.1',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000162,NULL,'18.3g',NULL,NULL,NULL,NULL,NULL,NULL,1,175.442,6.99672,0.042,NULL,60373103405,943329740,14739527,18.3),(83732,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83732,38.87,0.46,595,34042,70,NULL,NULL,'LCRS B113913.2-032407',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000137,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,175.4445,-3.679,0.057,NULL,40866618555,638540914,9977201,18.3),(83733,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83733,37.71,0.33,349,34043,70,NULL,NULL,'2MASX J11414666+0943120',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00014,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,175.444583,9.72019,0.078,NULL,60377558713,943399354,14740614,16.7),(83734,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83734,37.9,0.46,381,34044,70,NULL,NULL,'2MASX J11414674-0031048',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000091,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,175.444708333,-0.51806,0.033,NULL,40807191472,637612366,9962693,16.6),(83735,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83735,36.63,0.33,212,34045,70,NULL,NULL,'2MASX J11414709+3615317',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000181,NULL,'16.1g',0.34,NULL,NULL,NULL,NULL,NULL,1,175.446333,36.25897,0,NULL,60443028639,944422322,14756598,16.1),(83736,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83736,37.84,0.46,370,34046,70,NULL,NULL,'2MASX J11414771+5645188',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000188,NULL,'16.8g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,175.4487917,56.75531,0,NULL,61978289038,968410766,15131418,16.8),(83737,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83737,37.61,0.12,333,34047,70,NULL,NULL,'2MASX J11414855+0815240',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,175.45225,8.25669,0.036,NULL,60375983980,943374749,14740230,17.2),(83738,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83738,37.31,0.33,290,34048,70,NULL,NULL,'2MASX J11414919+1848087',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,175.455,18.80244,0,NULL,61079064465,954360382,14911880,NULL),(83739,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83739,37.61,0.12,333,34049,70,NULL,NULL,'2MASX J11414929+0748470',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000199,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,175.455333,7.81319,0.026,NULL,60376136635,943377134,14740267,16.5),(83740,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83740,35.98,0.51,157,34050,70,NULL,NULL,'2MASX J11414982-1521546',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.82',0.5,NULL,NULL,NULL,NULL,NULL,1,175.457667,-15.36514,0.049,NULL,41001708415,640651693,10010182,15.82),(83741,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83741,38.01,0.46,400,34051,70,NULL,NULL,'2MASX J11415015+1451414',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,175.459167,14.86144,0.091,NULL,60261403414,941584428,14712256,17.5),(83742,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83742,37.7,0.46,347,34052,70,NULL,NULL,'2MASX J11415032+4036227',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000164,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,175.459708333,40.60647,0,NULL,60404229278,943816082,14747126,17.4),(83743,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83743,37.89,0.23,379,34053,70,NULL,NULL,'2MASX J11415053+1059080',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,175.460583,10.98558,0.109,NULL,60372246133,943316345,14739317,17.1),(83744,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83744,37.22,0.46,278,34054,70,NULL,NULL,'2MASX J11415058+2255367',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,175.4607917,22.927,0,NULL,61075844532,954310070,14911094,16.9),(83745,'Tully est','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83745,31.26,0.8,17.9,34055,75,NULL,'B','UGC 06655',NULL,'1988NBGC.C....0000T',1988,1,0.78,NULL,'G',0.000007,NULL,'14.6g',0.61,'S0             HII','Group member',NULL,NULL,NULL,1,175.461,15.97375,0.036,NULL,60258749955,941542968,14711608,14.6),(83746,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83746,37.94,0.46,387,34056,70,NULL,NULL,'2MASX J11415061+2230077',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,175.460833,22.50225,0,NULL,61076195088,954315548,14911180,17.5),(83747,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83747,37.77,0.27,359,34057,70,NULL,NULL,'2MASX J11415082+1302374',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000169,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,175.46175,13.04372,0.062,NULL,60250892147,941420189,14709690,16.6),(83748,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83748,38.1,0.33,417,34058,70,NULL,NULL,'2MASX J11415141+2215157',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,175.464333333,22.2545,0,NULL,61076048758,954313261,14911144,17.8),(83749,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83749,36.24,0.46,177,34059,70,NULL,NULL,'2MASX J11415178+5238533',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000164,NULL,'16.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,175.46575,52.64806,0.005,NULL,61767469754,965116714,15079948,16.7),(83750,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83750,37.86,0.46,372,34060,70,NULL,NULL,'2MASX J11415254+0425271',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,175.468833333,4.42433,0.009,NULL,60183275351,940363677,14693182,17.3),(83751,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83751,36.06,0.63,163,34061,70,NULL,NULL,'2MASX J11415303-2702085',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000143,NULL,'16.4b',NULL,'E',NULL,NULL,NULL,NULL,1,175.4710417,-27.03575,0.245,NULL,41473194324,648018661,10125291,16.4),(83752,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83752,38.12,0.46,421,34062,70,NULL,NULL,'2MASX J11415321+0513311',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,175.471667,5.22539,0.014,NULL,60183523416,940367553,14693243,17.9),(83753,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83753,38.19,0.33,434,34063,70,NULL,NULL,'LCRS B113919.8-022344',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,175.4722917,-2.67244,0.065,NULL,40862273456,638473022,9976140,17.6),(83754,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83754,38.42,0.23,483,34064,70,NULL,NULL,'2MASX J11415395+0440531',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000172,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,175.474916667,4.68147,0,NULL,60183984175,940374752,14693355,17.3),(83755,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83755,37.64,0.33,338,34065,70,NULL,NULL,'2MASX J11415397+0607190',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'17.2g',0.25,'AGN',NULL,NULL,NULL,NULL,1,175.475,6.12194,0,NULL,60151339605,939864681,14685385,17.2),(83756,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83756,37.62,0.46,334,34066,70,NULL,NULL,'2MASX J11415429-0127208',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000153,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,175.476167,-1.45589,0.033,NULL,40864335407,638505240,9976644,17.5),(83757,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83757,37.11,0.23,265,34067,70,NULL,NULL,'2MASX J11415462+5529548',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,175.4775,55.49867,0,NULL,61758204918,964971951,15077686,17),(83758,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83758,37.11,0.23,265,34068,70,NULL,NULL,'2MASX J11415499+5528009',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000171,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,175.4789583,55.46694,0,NULL,61758239895,964972498,15077695,16.7),(83759,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83759,35.67,0.46,136,34069,70,NULL,NULL,'CGCG 068-029',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000181,NULL,'15.5g',0.47,'E0',NULL,NULL,NULL,NULL,1,175.4835,12.58617,0.066,NULL,60239180564,941237196,14706831,15.5),(83760,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83760,36.94,0.46,245,34070,70,NULL,NULL,'2MASX J11415607+1930338',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.20',0.15,NULL,NULL,NULL,NULL,NULL,1,175.4837083,19.50931,0,NULL,61078881394,954357521,14911836,18.2),(83761,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83761,37.72,0.46,350,34071,70,NULL,NULL,'2MASX J11415706+1948358',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000467,NULL,'16.1r',0.17,NULL,'Group member',NULL,NULL,NULL,1,175.487667,19.80997,0,NULL,61078817132,954356517,14911820,16.1),(83762,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83762,38.42,0.46,484,34072,70,NULL,NULL,'SDSS J114157.16+045127.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000147,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,175.488208333,4.85775,0,NULL,60183995418,940374928,14693358,18.4),(83763,'GCLF','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83763,32.29,0.13,28.7,34073,NULL,NULL,'TOM(g) = -7.2 mag','NGC 3818',NULL,'2012MNRAS.422.3591C',2012,1,2,NULL,'G',0.000025,NULL,'12.74',1.2,'E5','Group member',NULL,NULL,NULL,1,175.489,-6.15567,0.109,NULL,40844946049,638202282,9971910,12.74),(83764,'GCLF','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83764,32.42,0.17,30.5,34073,NULL,NULL,'TOM(z) = -8.4 mag','NGC 3818',NULL,'2012MNRAS.422.3591C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83765,'SBF','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83765,32.8,0.61,36.3,34073,NULL,NULL,'I','NGC 3818',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83766,'SBF','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83766,32.8,0.61,36.3,34073,NULL,NULL,NULL,'NGC 3818',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83767,'SBF','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83767,32.81,0.14,36.5,34073,74.4,NULL,NULL,'NGC 3818',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83768,'SBF','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83768,33.32,0.61,46.1,34073,NULL,NULL,'Malmquist cor.','NGC 3818',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83769,'D-Sigma','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83769,32.74,0.4,35.4,34073,75,NULL,'Edat, raw','NGC 3818',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83770,'D-Sigma','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83770,33.08,0.4,41.3,34073,75,NULL,'Edat, cor','NGC 3818',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83771,'Faber-Jackson','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83771,32.1,0.37,26.3,34073,95,NULL,'Weighted Mean','NGC 3818',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83772,'Faber-Jackson','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83772,32.35,0.63,29.5,34073,95,NULL,'Michard 1979b, c','NGC 3818',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83773,'Faber-Jackson','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83773,32.8,0.46,36.3,34073,95,NULL,'Michard 1979a','NGC 3818',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83774,'Faber-Jackson','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83774,33.13,0.81,42.3,34073,55,NULL,'Visvanathan & Sandage 1979','NGC 3818',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83775,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83775,32.54,0.53,32.2,34073,70,NULL,NULL,'NGC 3818',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83776,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83776,32.81,0.41,36.5,34073,NULL,NULL,NULL,'NGC 3818',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83777,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83777,32.91,0.41,38.1,34073,NULL,NULL,'Malmquist cor.','NGC 3818',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83778,'Tully est','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83778,32,0.8,25.1,34073,75,NULL,'B','NGC 3818',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83779,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83779,32.33,0.4,29.2,34073,NULL,NULL,'mean','NGC 3818',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83780,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83780,32.83,0.45,36.8,34073,NULL,NULL,'K','NGC 3818',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83781,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83781,37.64,0.33,338,34074,70,NULL,NULL,'2MASX J11415813+0609590',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000144,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,175.4922083,6.16642,0,NULL,60151338671,939864666,14685385,17.5),(83782,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83782,37.31,0.33,290,34075,70,NULL,NULL,'2MASX J11415891+1843538',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00011,NULL,'17.36',0.25,NULL,NULL,NULL,NULL,NULL,1,175.495417,18.73164,0,NULL,61079073349,954360521,14911883,17.36),(83783,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83783,37.12,0.33,265,34076,70,NULL,NULL,'2MASX J11415961+1932258',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'16.80',0.18,NULL,'Group member',NULL,NULL,NULL,1,175.498333,19.54058,0,NULL,61078874400,954357412,14911834,16.8),(83784,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83784,37.38,0.46,299,34077,70,NULL,NULL,'2MASX J11415987+1012240',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000107,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,175.499583,10.20661,0.094,NULL,60372003870,943312560,14739258,16.9),(83785,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83785,35.97,NULL,156,34078,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1289',NULL,'2010Ap&SS.325..163P',2010,1,0.87,NULL,'G',0.000163,NULL,'17.1g',0.13,'Sc',NULL,NULL,NULL,NULL,1,175.5030417,52.72269,0.005,NULL,61767466508,965116664,15079947,17.1),(83786,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83786,35.99,NULL,158,34078,NULL,NULL,'Dipole + Quadrupole','FGC 1289',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83787,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83787,36,NULL,158,34078,NULL,NULL,NULL,'FGC 1289',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83788,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83788,36.02,NULL,160,34078,NULL,NULL,'Dipole','FGC 1289',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83789,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83789,36.31,0.49,183,34078,75,NULL,'IR','FGC 1289',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83790,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83790,36.19,0.59,173,34079,70,NULL,NULL,'2MASX J11420120-4625111',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,175.504958333,-46.41978,0.401,NULL,41889675880,654526185,10226971,15.5),(83791,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83791,36.44,0.46,194,34080,70,NULL,NULL,'2MASX J11420173+6511532',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000091,NULL,'15.9g',0.37,'E0',NULL,NULL,NULL,NULL,1,175.5074583,65.19817,0,NULL,61823864833,965997888,15093717,15.9),(83792,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83792,37.84,0.46,370,34081,70,NULL,NULL,'SDSS J114202.11+310618.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000139,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,175.508833,31.10525,0,NULL,60626388766,947287324,14801364,18.7),(83793,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83793,37.34,0.23,294,34082,70,NULL,NULL,'SDSS J114202.31+603821.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000158,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,175.509667,60.63919,0.053,NULL,61853993537,966468649,15101072,18.2),(83794,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83794,37.11,0.23,265,34083,70,NULL,NULL,'2MASX J11420276+5523259',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000197,NULL,'16.0g',0.41,'E0',NULL,NULL,NULL,NULL,1,175.5114583,55.39061,0,NULL,61758233465,964972397,15077693,16),(83795,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83795,37.88,0.46,376,34084,70,NULL,NULL,'2MASX J11420321+1509443',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,175.513333,15.16217,0.075,NULL,60261295222,941582737,14712230,17.8),(83796,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83796,38.4,0.46,479,34085,70,NULL,NULL,'2MASX J11420322+5337244',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000141,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,175.513375,53.62347,0,NULL,61770213280,965159582,15080618,18.3),(83797,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83797,35.65,0.46,135,34086,70,NULL,NULL,'2MASX J11420324+0300166',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000083,NULL,'15.1g',0.64,'E0',NULL,NULL,NULL,NULL,1,175.5135417,3.00469,0.009,NULL,60195063920,940547873,14696060,15.1),(83798,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83798,36.9,0.33,240,34087,70,NULL,NULL,'MCG +10-17-041',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',NULL,NULL,'15.7g',0.36,NULL,NULL,NULL,NULL,NULL,1,175.513583,58.70561,0,NULL,61855383506,966490367,15101411,15.7),(83799,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83799,38.31,0.46,460,34088,70,NULL,NULL,'SDSS J114203.68+074302.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000135,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,175.515375,7.71744,0.013,NULL,60376869203,943388581,14740446,18.2),(83800,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83800,34.22,0.46,69.7,34089,70,NULL,NULL,'CGCG 040-032',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000087,NULL,'15.5g',0.55,'(R)SAB0^0^',NULL,NULL,NULL,NULL,1,175.516375,7.65194,0.032,NULL,60376864412,943388506,14740445,15.5),(83801,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83801,37.59,0.46,329,34090,70,NULL,NULL,'2MASX J11420415+5635199',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000193,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,175.517125,56.589,0,NULL,61978300467,968410944,15131421,16.7),(83802,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83802,39.38,0.46,751,34091,70,NULL,NULL,'SDSS J114204.32+222228.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000141,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,175.518,22.37456,0,NULL,61076161990,954315031,14911172,18.7),(83803,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83803,37.49,0.46,315,34092,70,NULL,NULL,'2MASX J11420434+5556079',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00017,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,175.518375,55.93544,0,NULL,61978088959,968407639,15131369,17.9),(83804,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83804,38.12,0.46,421,34093,70,NULL,NULL,'2MASX J11420451+1210324',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000187,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,175.518708333,12.17567,0.067,NULL,60239261917,941238467,14706851,17.6),(83805,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83805,37.05,0.46,257,34094,70,NULL,NULL,'2MASX J11420489+3340594',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000158,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,175.520541667,33.68308,0,NULL,60631681251,947370019,14802656,16.9),(83806,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83806,38.46,0.46,491,34095,70,NULL,NULL,'2MASX J11420517+6243322',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,175.5215417,62.72561,0.037,NULL,61865586486,966649788,15103902,17.4),(83807,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83807,37.42,0.33,305,34096,70,NULL,NULL,'2MASX J11420554+2811246',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.63',0.13,NULL,NULL,NULL,NULL,NULL,1,175.523166667,28.19011,0.043,NULL,60585497480,946648398,14791381,18.63),(83808,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83808,34.76,0.46,89.7,34097,70,NULL,NULL,'NGC 3819',NULL,'2015arXiv151105856S',2015,1,0.91,NULL,'G',0.000037,NULL,'14.4g',0.73,'E1','Group member',NULL,NULL,NULL,1,175.524417,10.35114,0.094,NULL,60371873153,943310518,14739226,14.4),(83809,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83809,36.1,0.33,166,34098,70,NULL,NULL,'2MASX J11420642+1135597',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000168,NULL,'16.1g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,175.526833333,11.59994,0.087,NULL,60238885629,941232587,14706759,16.1),(83810,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83810,36.58,0.58,207,34099,70,NULL,NULL,'2MASX J11420655-4212412',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,175.5272917,-42.2115,0.349,NULL,41348585947,646071655,10094869,16.8),(83811,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83811,37.56,0.46,325,34100,70,NULL,NULL,'2MASX J11420679+4758084',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000158,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,175.528416667,47.96894,0.02,NULL,61754431917,964912998,15076765,17.1),(83812,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83812,37.11,0.23,265,34101,70,NULL,NULL,'2MASX J11420722+5519589',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,175.529958333,55.33308,0,NULL,61758217646,964972150,15077689,17.7),(83813,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83813,37.56,0.46,325,34102,70,NULL,NULL,'SDSS J114207.48+084057.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,175.531208333,8.68275,0.026,NULL,60377317989,943395593,14740556,18.1),(83814,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83814,38.19,0.33,434,34103,70,NULL,NULL,'LCRS B113934.5-022210',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.0001,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,175.5337083,-2.64647,0.069,NULL,40862279392,638473115,9976142,16.8),(83815,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83815,37.05,0.46,257,34104,70,NULL,NULL,'2MASX J11420850+5315264',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.001432,NULL,'17.0g',0.22,'NLSy1',NULL,NULL,NULL,'AGN',1,175.535333,53.25722,0,NULL,61770511361,965164240,15080691,17),(83816,'IRAS','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83816,33.59,0.8,52.3,34105,75,NULL,'MAT, I','ESO 571- G 016',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00003,NULL,'14.5',0.3,'SB(s)bc: sp',NULL,NULL,NULL,NULL,1,175.537875,-18.169,0.081,NULL,40948500509,639820320,9997192,14.5),(83817,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83817,32.91,0.32,38.2,34105,85,NULL,'I, raw','ESO 571- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83818,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83818,32.93,0.32,38.6,34105,85,NULL,'I, inv','ESO 571- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83819,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83819,33.02,0.43,40.2,34105,75,NULL,'MAT, I, raw','ESO 571- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83820,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83820,33.16,0.43,42.8,34105,75,NULL,'MAT, I, inv','ESO 571- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83821,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83821,33.37,0.43,47.1,34105,75,NULL,'MAT, I, cor','ESO 571- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83822,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83822,33.4,0.47,47.8,34105,NULL,NULL,'H','ESO 571- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83823,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83823,33.42,0.29,48.3,34105,NULL,NULL,NULL,'ESO 571- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83824,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83824,33.46,0.2,49.2,34105,74.4,NULL,NULL,'ESO 571- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83825,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83825,33.49,0.45,49.8,34105,NULL,NULL,'K','ESO 571- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83826,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83826,33.54,0.46,51,34105,NULL,NULL,'J','ESO 571- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83827,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83827,33.63,0.4,53.3,34105,NULL,NULL,'mean','ESO 571- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83828,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83828,33.63,0.26,53.3,34105,NULL,NULL,'Malmquist cor.','ESO 571- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83829,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83829,37.8,0.46,363,34106,70,NULL,NULL,'2MASX J11420932+2649195',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000172,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,175.538875,26.82214,0.045,NULL,60599289500,946863898,14794748,18),(83830,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83830,38.53,0.27,509,34107,70,NULL,NULL,'SDSS J114209.78+100645.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000137,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,175.5407917,10.11258,0.122,NULL,60371814557,943309602,14739212,18.7),(83831,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83831,37.61,0.12,333,34108,70,NULL,NULL,'SDSS J114210.48+074232.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,175.543666667,7.70908,0.013,NULL,60376821912,943387842,14740435,18.2),(83832,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83832,37.83,0.33,368,34109,70,NULL,NULL,'2MASX J11421071+1157294',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000178,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,175.544667,11.95831,0.09,NULL,60238937746,941233402,14706771,16.9),(83833,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83833,37.61,0.12,333,34110,70,NULL,NULL,'2MASX J11421084+0739308',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00017,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,175.545167,7.6585,0.013,NULL,60376821240,943387831,14740434,17),(83834,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83834,36.69,0.33,218,34111,70,NULL,NULL,'2MASX J11421099+2050550',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,175.545833,20.84869,0,NULL,61085639934,954463123,14913486,18),(83835,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83835,38.73,0.46,557,34112,70,NULL,NULL,'SDSS J114211.20+114908.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000168,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,175.546667,11.81903,0.09,NULL,60238967538,941233867,14706779,18.3),(83836,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83836,37.79,0.46,361,34113,70,NULL,NULL,'2MASX J11421122+2159430',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000202,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,175.546875,21.99525,0,NULL,61076126286,954314473,14911163,16.6),(83837,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83837,35.54,0.5,128,34114,70,NULL,NULL,'MCG -02-30-016',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000043,NULL,'14.97',1.2,'(R\')SA(r)ab',NULL,NULL,NULL,NULL,1,175.549416667,-10.77444,0.041,NULL,41032471750,641132371,10017693,14.97),(83838,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83838,37.43,0.46,306,34115,70,NULL,NULL,'2MASX J11421188+5748539',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00019,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,175.5495,57.81508,0,NULL,61976941973,968389718,15131089,17),(83839,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83839,38.53,0.27,509,34116,70,NULL,NULL,'2MASX J11421209+1011588',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000176,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,175.5505,10.19972,0.122,NULL,60371785884,943309154,14739205,17.1),(83840,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83840,37.42,0.33,305,34117,70,NULL,NULL,'2MASX J11421219+2807005',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000139,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,175.550583333,28.11683,0.043,NULL,60585540226,946649066,14791391,17.9),(83841,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83841,36.1,0.33,166,34118,70,NULL,NULL,'2MASX J11421228+1130408',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000175,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,175.55125,11.51142,0.036,NULL,60238916094,941233063,14706766,16.5),(83842,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83842,38.21,0.46,438,34119,70,NULL,NULL,'2MASX J11421267+0526586',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,175.552875,5.44961,0,NULL,60183307202,940364175,14693190,17.4),(83843,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83843,34.99,0.46,99.6,34120,70,NULL,NULL,'CGCG 097-061',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000177,NULL,'15.5',0.2,'S0',NULL,NULL,NULL,NULL,1,175.553917,18.40383,0,NULL,60204264663,940691635,14698306,15.5),(83844,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83844,38,0.46,399,34121,70,NULL,NULL,'2MASX J11421301+0515066',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000172,NULL,'16.8g',0.26,'BrClG',NULL,NULL,NULL,NULL,1,175.554125,5.25169,0,NULL,60183530979,940367671,14693244,16.8),(83845,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83845,36.96,0.27,247,34122,70,NULL,NULL,'2MASX J11421319+5818329',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000145,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,175.5547917,58.30936,0,NULL,61843082231,966298159,15098408,16.3),(83846,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83846,37.42,0.46,304,34123,70,NULL,NULL,'2MASX J11421380+1930010',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'16.5r',0.18,NULL,'Group member',NULL,NULL,NULL,1,175.5577083,19.50042,0,NULL,61078882355,954357536,14911836,16.5),(83847,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83847,36.75,0.46,224,34124,70,NULL,NULL,'2MASX J11421420+0659478',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00017,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,175.5590417,6.99667,0.041,NULL,60373080000,943329375,14739521,16.4),(83848,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83848,37.34,0.23,294,34125,70,NULL,NULL,'2MASX J11421420+6008121',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.48',0.31,NULL,NULL,NULL,NULL,NULL,1,175.559083,60.1365,0,NULL,61854067092,966469798,15101090,16.48),(83849,'IRAS','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83849,35.21,0.8,110,34126,75,NULL,'HMCL, I','KUG 1139+202',NULL,'1997ApJS..109..333W',1997,1,0.8,'The position in 2000MNRAS.312..442S apparently includes a neighboring star.','G',0.000009,NULL,'15.4',0.3,'Sa: pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,175.561583,19.97653,0,NULL,61078803174,954356299,14911817,15.4),(83850,'IRAS','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83850,35.21,0.8,110,34126,75,NULL,'W91CL, r','KUG 1139+202',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83851,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83851,34.37,0.43,74.7,34126,75,NULL,'3.6 micron, color + selection bias corrected','KUG 1139+202',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83852,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83852,34.47,0.43,78.2,34126,75,NULL,'3.6 micron, color corrected','KUG 1139+202',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83853,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83853,34.59,0.2,82.8,34126,74.4,NULL,NULL,'KUG 1139+202',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83854,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83854,34.72,0.38,87.9,34126,75,NULL,'W91CL, r, raw','KUG 1139+202',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83855,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83855,34.76,0.38,89.6,34126,75,NULL,'W91CL, r, inv','KUG 1139+202',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83856,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83856,34.94,0.38,97.1,34126,75,NULL,'W91CL, r, cor','KUG 1139+202',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83857,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83857,34.95,0.4,97.8,34126,75,NULL,'HMCL, I, raw','KUG 1139+202',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83858,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83858,35.05,0.4,102,34126,75,NULL,'HMCL, I, inv','KUG 1139+202',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83859,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83859,35.16,0.4,108,34126,75,NULL,'HMCL, I, cor','KUG 1139+202',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83860,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83860,39.63,0.46,843,34127,70,NULL,NULL,'SDSS J114215.23+041154.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000172,NULL,'18.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,175.563458333,4.19858,0.009,NULL,60181242516,940331914,14692686,18.8),(83861,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83861,36.08,0.46,165,34128,70,NULL,NULL,'2MASX J11421591+5443149',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,175.566375,54.72081,0,NULL,61772658331,965197786,15081215,16.5),(83862,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83862,36.91,0.46,242,34129,70,NULL,NULL,'2MASX J11421593+6049151',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,175.5664583,60.82086,0.057,NULL,61847038097,966359970,15099374,17.3),(83863,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83863,37.83,0.33,368,34130,70,NULL,NULL,'2MASX J11421609+1201048',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000168,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,175.567083333,12.018,0.074,NULL,60238925044,941233203,14706768,17.6),(83864,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83864,37.22,0.33,279,34131,70,NULL,NULL,'2MASX J11421608+5656399',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000197,NULL,'15.9g',0.39,'E0',NULL,NULL,NULL,NULL,1,175.567083333,56.94444,0,NULL,61978357221,968411831,15131434,15.9),(83865,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83865,37.16,0.46,270,34132,70,NULL,NULL,'2MASX J11421615+0959358',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000148,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,175.567417,9.99336,0.101,NULL,60371779093,943309048,14739203,17.5),(83866,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83866,36.21,0.46,174,34133,70,NULL,NULL,'2MASX J11421715+3807197',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,175.571417,38.12217,0.041,NULL,60463363627,944740056,14761563,17.1),(83867,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83867,34.88,NULL,94.8,34134,NULL,NULL,'Dipole','UGC 06664',NULL,'2010Ap&SS.325..163P',2010,1,1.7,NULL,'G',0.00003,NULL,'15.3g',0.3,'Sc',NULL,NULL,NULL,NULL,1,175.575,30.23031,0.013,NULL,60555599606,946181243,14784081,15.3),(83868,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83868,34.89,NULL,94.8,34134,NULL,NULL,'Dipole + Quadrupole','UGC 06664',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83869,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83869,34.89,NULL,95,34134,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06664',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83870,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83870,34.91,NULL,96.1,34134,NULL,NULL,NULL,'UGC 06664',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83871,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83871,31.52,NULL,20.1,34135,NULL,NULL,NULL,'UGC 06669',NULL,'2015AstBu..70....1K',2015,1,1.4,NULL,'G',0.000013,NULL,'17.',0.7,'Im',NULL,NULL,NULL,NULL,1,175.5775,14.99472,0.091,NULL,60263304245,941614128,14712720,17),(83872,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83872,35.18,0.53,109,34136,70,NULL,NULL,'2MASX J11421900-1351443',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.52',NULL,NULL,NULL,NULL,NULL,NULL,1,175.579167,-13.86242,0.033,NULL,40989573364,640462083,10007220,15.52),(83873,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83873,34.8,0.49,91.3,34137,70,NULL,NULL,'MCG -01-30-024',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00013,NULL,'14.77',0.4,'SAB(r)0/a:',NULL,NULL,NULL,NULL,1,175.579833,-8.62233,0.073,NULL,41033462427,641147850,10017935,14.77),(83874,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83874,37.21,0.46,276,34138,70,NULL,NULL,'SDSS J114219.94+210545.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.1g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,175.583125,21.09597,0,NULL,61085142481,954455351,14913364,18.1),(83875,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83875,38.53,0.27,509,34139,70,NULL,NULL,'SDSS J114219.99+101101.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,175.583333,10.18383,0.122,NULL,60371795955,943309311,14739207,18.3),(83876,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83876,37.39,0.46,300,34140,70,NULL,NULL,'2MASX J11422022+4930134',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000148,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,175.584333333,49.50389,0,NULL,61752984577,964890384,15076412,17.3),(83877,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83877,38.02,0.46,402,34141,70,NULL,NULL,'2MASX J11422137+6141413',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000161,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,175.58925,61.69489,0.005,NULL,61864351424,966630491,15103601,17),(83878,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83878,37.7,0.33,346,34142,70,NULL,NULL,'2MASX J11422141+0227106',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000078,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,175.589333,2.453,0.037,NULL,60187459739,940429058,14694204,17.5),(83879,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83879,36.69,0.33,218,34143,70,NULL,NULL,'2MASX J11422176+2052200',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000097,NULL,'16.1g',0.39,NULL,NULL,NULL,NULL,NULL,1,175.590625,20.87239,0,NULL,61085603703,954462557,14913477,16.1),(83880,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83880,37.61,0.12,333,34144,70,NULL,NULL,'2MASX J11422195+0806268',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000191,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,175.591417,8.10733,0.026,NULL,60376185623,943377900,14740279,16.8),(83881,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83881,34,0.47,63,34145,NULL,NULL,'H','IC 0720',NULL,'2007A&A...465...71T',2007,1,NULL,'The position in 1989H&RHI.C...0000H is incorrect.','GPair',0.00004,NULL,NULL,NULL,'S?',NULL,NULL,NULL,NULL,1,175.592917,8.76778,0.026,NULL,60377299001,943395296,14740551,NULL),(83882,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83882,34.22,0.45,69.8,34145,NULL,NULL,'K','IC 0720',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83883,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83883,34.23,0.46,70.1,34145,NULL,NULL,'J','IC 0720',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83884,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83884,34.95,0.4,97.7,34145,NULL,NULL,'mean','IC 0720',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83885,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83885,37.22,0.33,279,34146,70,NULL,NULL,'2MASX J11422307+5658559',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000159,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,175.596,56.98225,0,NULL,61978363787,968411934,15131436,17),(83886,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83886,37.89,0.46,378,34147,70,NULL,NULL,'2MASXi J1142233+232853',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000149,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,175.597333,23.48144,0,NULL,60542319850,945973747,14780839,17.8),(83887,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83887,38.26,0.46,449,34148,70,NULL,NULL,'2MASX J11422343+2701059',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000184,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,175.5977083,27.01833,0.049,NULL,60599159967,946861874,14794716,17.2),(83888,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83888,34.9,0.4,95.7,34149,NULL,NULL,'mean','NGC 3825',NULL,'2007A&A...465...71T',2007,1,1.68,'ALFALFA source is blended with NGC 3822.','G',0.000057,NULL,'13.6g',0.96,'SBa','in a radial-velocity based grouping',NULL,NULL,NULL,1,175.598875,10.26414,0.122,NULL,60371993100,943312392,14739256,13.6),(83889,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83889,35.8,0.47,144,34149,NULL,NULL,'H','NGC 3825',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83890,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83890,35.82,0.45,146,34149,NULL,NULL,'K','NGC 3825',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83891,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83891,35.85,0.46,148,34149,NULL,NULL,'J','NGC 3825',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83892,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83892,37.7,0.33,346,34150,70,NULL,NULL,'SDSS J114224.00+022600.1',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000098,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,175.600041667,2.43336,0.037,NULL,60187434529,940428664,14694197,17.1),(83893,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83893,38.57,0.46,517,34151,70,NULL,NULL,'2MASX J11422417+5234153',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000156,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,175.6005417,52.57078,0.005,NULL,61767440487,965116257,15079941,18.6),(83894,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83894,36.42,0.46,193,34152,70,NULL,NULL,'MCG +09-19-158',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.0002,NULL,'15.4g',0.52,'E0',NULL,NULL,NULL,NULL,1,175.602041667,54.77417,0,NULL,61772650159,965197658,15081213,15.4),(83895,'IRAS','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83895,34.52,0.8,80.1,34153,75,NULL,'W91CL, r','CGCG 097-068',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000006,NULL,'14.55',0.7,'Sbc            HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,175.602083,20.11931,0,NULL,61083286627,954426353,14912911,14.55),(83896,'IRAS','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83896,34.52,0.8,80.1,34153,75,NULL,'HMCL, I','CGCG 097-068',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83897,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83897,33.61,0.69,52.8,34153,100,NULL,'mid-IR','CGCG 097-068',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83898,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83898,34.41,0.43,76.1,34153,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 097-068',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83899,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83899,34.53,0.38,80.6,34153,75,NULL,'W91CL, r, raw','CGCG 097-068',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83900,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83900,34.61,0.43,83.5,34153,75,NULL,'3.6 micron, color corrected','CGCG 097-068',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83901,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83901,34.65,0.38,85.1,34153,75,NULL,'W91CL, r, inv','CGCG 097-068',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83902,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83902,34.76,0.4,89.4,34153,75,NULL,'HMCL, I, raw','CGCG 097-068',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83903,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83903,34.79,0.38,90.9,34153,75,NULL,'W91CL, r, cor','CGCG 097-068',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83904,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83904,34.89,0.2,95.1,34153,74.4,NULL,NULL,'CGCG 097-068',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83905,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83905,34.91,0.4,95.7,34153,NULL,NULL,'mean','CGCG 097-068',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83906,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83906,34.93,0.4,96.9,34153,75,NULL,'HMCL, I, inv','CGCG 097-068',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83907,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83907,34.94,0.07,97.5,34153,NULL,NULL,NULL,'CGCG 097-068',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83908,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83908,34.99,0.4,99.5,34153,75,NULL,'HMCL, I, cor','CGCG 097-068',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83909,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83909,35.23,0.47,111,34153,NULL,NULL,'H','CGCG 097-068',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83910,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83910,36.48,0.79,198,34154,70,NULL,NULL,'2MASX J11422455-2850124',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,175.6022917,-28.83683,0.273,NULL,41450658946,647666546,10119789,15.6),(83911,'FP','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83911,35.12,0.46,106,34155,70,NULL,NULL,'2MASX J11422465+0850168',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00009,NULL,'15.3g',0.4,'E0',NULL,NULL,NULL,NULL,1,175.602917,8.83803,0.026,NULL,60377498970,943398421,14740600,15.3),(83912,'IRAS','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83912,31.3,0.8,18.2,34156,75,NULL,'A82, H','UGC 06667',NULL,'1997ApJS..109..333W',1997,1,3.59,NULL,'G',0.000004,NULL,'14.2g',0.5,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,175.609541667,51.59797,0,NULL,61800439477,965631866,15087997,14.2),(83913,'IRAS','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83913,31.33,0.8,18.5,34156,75,NULL,'W91CL, r','UGC 06667',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83914,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83914,30.98,0.11,15.7,34156,NULL,NULL,NULL,'UGC 06667',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83915,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83915,31.15,0.4,17,34156,75,NULL,'B','UGC 06667',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83916,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83916,31.29,NULL,18.1,34156,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06667',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83917,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83917,31.31,NULL,18.2,34156,NULL,NULL,'Dipole + Quadrupole','UGC 06667',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83918,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83918,31.3,0.2,18.2,34156,74.4,NULL,NULL,'UGC 06667',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83919,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83919,31.31,NULL,18.3,34156,NULL,NULL,'Dipole','UGC 06667',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83920,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83920,31.31,0.38,18.3,34156,75,NULL,'W91CL, r, inv','UGC 06667',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83921,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83921,31.32,0.43,18.3,34156,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06667',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83922,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83922,31.33,0.43,18.4,34156,75,NULL,'3.6 micron, color corrected','UGC 06667',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83923,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83923,31.36,NULL,18.7,34156,NULL,NULL,NULL,'UGC 06667',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83924,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83924,31.39,0.38,19,34156,75,NULL,'W91CL, r, raw','UGC 06667',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83925,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83925,31.39,0.35,19,34156,NULL,NULL,NULL,'UGC 06667',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83926,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83926,31.53,0.38,20.2,34156,75,NULL,'W91CL, r, cor','UGC 06667',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83927,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,NULL,83927,31.7,0.47,21.9,34156,75,NULL,'A82, H, inv','UGC 06667',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83928,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:58','1',NULL,'R',83928,31.83,0.4,23.2,34156,75,NULL,NULL,'UGC 06667',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83929,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,83929,31.83,0.47,23.3,34156,75,NULL,'A82, H, raw','UGC 06667',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83930,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83930,32.04,0.49,25.5,34156,75,NULL,'IR','UGC 06667',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83931,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,83931,32.09,0.47,26.2,34156,75,NULL,'A82, H, cor','UGC 06667',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83932,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83932,37.12,0.33,265,34157,70,NULL,NULL,'2MASX J11422633+1930130',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.1r',0.26,NULL,'Group member',NULL,NULL,NULL,1,175.609625,19.50356,0,NULL,61078860138,954357189,14911831,16.1),(83933,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83933,37.79,0.46,362,34158,70,NULL,NULL,'2MASX J11422743+0904307',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,175.614375,9.07522,0,NULL,60377346451,943396038,14740563,17.6),(83934,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83934,36.87,0.33,237,34159,70,NULL,NULL,'2MASX J11422806+4112334',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000165,NULL,'16.2g',0.41,NULL,NULL,NULL,NULL,NULL,1,175.616833333,41.20922,0,NULL,60405354812,943833668,14747401,16.2),(83935,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,83935,34.1,0.33,66.1,34160,NULL,NULL,NULL,'IC 0721',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.31',0.3,'SB(s)cd? sp    HII',NULL,NULL,NULL,NULL,1,175.620333,-8.34033,0.081,NULL,41027645574,641056962,10016515,15.31),(83936,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,83936,34.14,0.2,67.3,34160,74.4,NULL,NULL,'IC 0721',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83937,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83937,34.17,0.49,68.2,34160,75,NULL,'IR','IC 0721',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83938,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,83938,34.37,0.29,74.7,34160,NULL,NULL,'Malmquist cor.','IC 0721',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83939,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83939,37.61,0.12,333,34161,70,NULL,NULL,'2MASX J11422929+0819077',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000182,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,175.622125,8.31881,0.021,NULL,60376012622,943375197,14740237,16.7),(83940,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,83940,31.18,0.4,17.2,34162,75,NULL,'B','UGC 06670',NULL,'1988NBGC.C....0000T',1988,1,3,'HOLM 281B is a star.  The Kiso position is for a knot in the galaxy.','G',0.000003,NULL,'13.34',0.9,'IBm',NULL,NULL,NULL,NULL,1,175.622583,18.33278,0,NULL,60204303473,940692241,14698316,13.34),(83941,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83941,31.29,NULL,18.1,34162,NULL,NULL,NULL,'UGC 06670',NULL,'2015AstBu..70....1K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83942,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,83942,36.41,0.53,192,34163,70,NULL,NULL,'2MASX J11422955-1513532',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.63',0.5,NULL,NULL,NULL,NULL,NULL,1,175.62325,-15.23156,0.049,NULL,41002883601,640670056,10010469,15.63),(83943,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83943,37.81,0.46,365,34164,70,NULL,NULL,'2MASX J11422962+1455043',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,175.6234583,14.91783,0.091,NULL,60263564520,941618195,14712784,17.3),(83944,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83944,38.1,0.33,417,34165,70,NULL,NULL,'2MASX J11422978+2217470',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,175.6240417,22.29656,0,NULL,61075966852,954311982,14911124,18),(83945,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83945,37.31,0.46,290,34166,70,NULL,NULL,'2MASX J11422978+1028327',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000097,NULL,'16.2g',0.42,'S0',NULL,NULL,NULL,NULL,1,175.624167,10.47578,0.119,NULL,60371882197,943310659,14739229,16.2),(83946,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83946,36.31,0.46,183,34167,70,NULL,NULL,'CGCG 012-062',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000133,NULL,'15.4g',0.48,'SA0-',NULL,NULL,NULL,NULL,1,175.6289583,-2.2515,0.033,NULL,40864173078,638502704,9976604,15.4),(83947,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,83947,36.4,0.53,190,34167,70,NULL,NULL,'CGCG 012-062',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83948,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83948,37.61,0.12,333,34168,70,NULL,NULL,'2MASX J11423131+0750231',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000182,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,175.630375,7.83964,0.013,NULL,60376104607,943376634,14740259,16.7),(83949,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83949,38.03,0.23,404,34169,70,NULL,NULL,'2MASX J11423138+5621558',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000183,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,175.6305,56.36539,0,NULL,61977925144,968405080,15131329,17),(83950,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83950,36.9,0.33,240,34170,70,NULL,NULL,'MCG +10-17-046',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',NULL,NULL,'15.8g',0.41,NULL,NULL,NULL,NULL,NULL,1,175.633125,58.61719,0,NULL,61855367286,966490113,15101408,15.8),(83951,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83951,37.7,0.46,347,34171,70,NULL,NULL,'SDSS J114232.20+111300.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,175.634208333,11.21686,0.095,NULL,60371034271,943297410,14739022,18.3),(83952,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83952,37.58,0.33,329,34172,70,NULL,NULL,'2MASX J11423227+0905301',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00017,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,175.6347083,9.09158,0,NULL,60377343294,943395988,14740562,16.9),(83953,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83953,35.76,0.27,142,34173,70,NULL,NULL,'NGC 3826',NULL,'2015arXiv151105856S',2015,1,1.11,NULL,'G',0.000073,NULL,'14.0g',0.9,'E','Group member',NULL,NULL,NULL,1,175.636875,26.48889,0.039,NULL,60598593490,946853023,14794578,14),(83954,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83954,37,0.46,252,34174,70,NULL,NULL,'2MASX J11423358+1755513',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.55',0.13,NULL,NULL,NULL,NULL,NULL,1,175.639833333,17.93092,0.017,NULL,60204376987,940693390,14698334,18.55),(83955,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83955,37.1,0.46,263,34175,70,NULL,NULL,'2MASX J11423373+4708524',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000174,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,175.6405,47.14797,0.07,NULL,61753793539,964903024,15076609,16.7),(83956,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83956,36.8,0.46,229,34176,70,NULL,NULL,'2MASX J11423379+3433146',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000166,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,175.640875,34.554,0,NULL,60441154261,944393035,14756141,16.4),(83957,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83957,38.01,0.33,399,34177,70,NULL,NULL,'2MASX J11423537-0129134',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000145,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,175.64725,-1.48694,0.033,NULL,40864377561,638505899,9976654,17.7),(83958,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83958,37.61,0.12,333,34178,70,NULL,NULL,'2MASX J11423575+0749051',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,175.649167,7.81817,0.013,NULL,60376102358,943376599,14740259,17.1),(83959,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83959,36.63,0.46,212,34179,70,NULL,NULL,'2MASX J11423718+3837564',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000181,NULL,'15.7g',0.48,NULL,NULL,NULL,NULL,NULL,1,175.654875,38.63236,0.028,NULL,60461633028,944713016,14761140,15.7),(83960,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83960,37.74,0.46,352,34180,70,NULL,NULL,'2MASX J11423746+0930371',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000139,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,175.656375,9.51019,0.067,NULL,60377680776,943401262,14740644,17.5),(83961,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83961,36.89,0.33,239,34181,70,NULL,NULL,'2MASX J11423775+5812551',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000188,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,175.657333,58.21531,0,NULL,61843000687,966296885,15098388,16.5),(83962,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83962,39.06,0.46,649,34182,70,NULL,NULL,'SDSS J114238.31-005941.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000077,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,175.659667,-0.99478,0.021,NULL,40806891484,637607679,9962619,18.6),(83963,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83963,38,0.46,397,34183,70,NULL,NULL,'2MASX J11423855+5348419',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000173,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,175.6605,53.81167,0,NULL,61773027486,965203554,15081305,17.4),(83964,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83964,36.65,0.46,214,34184,70,NULL,NULL,'2MASX J11423874+5625101',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00017,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,175.661333,56.4195,0,NULL,61977925702,968405089,15131329,16.7),(83965,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83965,36.64,0.46,212,34185,70,NULL,NULL,'2MASX J11423901+1558003',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000193,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,175.6624583,15.96689,0.052,NULL,60258034071,941531782,14711434,16.9),(83966,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83966,37.04,0.46,256,34186,70,NULL,NULL,'2MASX J11423978+5739061',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000179,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,175.665625,57.65167,0,NULL,61976983839,968390372,15131099,16.6),(83967,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83967,36.87,0.33,237,34187,70,NULL,NULL,'2MASX J11424029+4113114',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,175.66775,41.21986,0,NULL,60405370994,943833921,14747405,16.7),(83968,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83968,37.71,0.46,349,34188,70,NULL,NULL,'2MASX J11424054+4055394',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000161,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,175.668875,40.92767,0,NULL,60403741828,943808466,14747007,17),(83969,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83969,37.59,0.46,330,34189,70,NULL,NULL,'2MASX J11424102+1734203',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.16',0.15,NULL,NULL,NULL,NULL,NULL,1,175.670833,17.57239,0.023,NULL,60204687471,940698241,14698410,18.16),(83970,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83970,37.61,0.12,333,34190,70,NULL,NULL,'2MASX J11424146+0817081',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,175.6727917,8.28553,0.021,NULL,60375995170,943374924,14740233,17.4),(83971,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83971,37.94,0.46,387,34191,70,NULL,NULL,'2MASX J11424201+3259345',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000195,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,175.675125,32.99286,0,NULL,60631422610,947365978,14802593,16.8),(83972,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83972,39.58,0.46,822,34192,70,NULL,NULL,'SDSS J114242.16+182149.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,175.675708333,18.36389,0,NULL,60204299046,940692172,14698315,18.2),(83973,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83973,38.19,0.46,435,34193,70,NULL,NULL,'2MASX J11424290+1551513',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,175.6787917,15.86419,0.052,NULL,60258055302,941532114,14711439,17),(83974,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83974,37.25,0.46,282,34194,70,NULL,NULL,'2MASX J11424308+0742311',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000182,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,175.6795417,7.70867,0.013,NULL,60376550517,943383601,14740368,16.5),(83975,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,83975,34.62,0.32,83.9,34195,NULL,NULL,NULL,'IC 0722',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000023,NULL,'14.53',0.7,'S?',NULL,NULL,NULL,NULL,1,175.682333,8.97422,0,NULL,60380833624,943450525,14741414,14.53),(83976,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,83976,34.69,0.31,86.7,34195,NULL,NULL,'Malmquist cor.','IC 0722',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83977,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,83977,34.76,0.2,89.5,34195,74.4,NULL,NULL,'IC 0722',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83978,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83978,37.61,0.12,333,34196,70,NULL,NULL,'2MASX J11424389+0809441',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000165,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,175.683,8.16228,0.026,NULL,60375991073,943374860,14740232,16.6),(83979,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,83979,34.21,0.43,69.4,34197,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 097-072',NULL,'2014MNRAS.444..527S',2014,1,0.9,'Sullivan, et al. (2000MNRAS.312..442S) give z=0.0289+/-0.001.','G',0.00001,NULL,'14.92',0.5,'Sa','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,175.688208333,20.03231,0,NULL,61083253363,954425833,14912903,14.92),(83980,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,83980,34.22,0.43,69.7,34197,75,NULL,'3.6 micron, color corrected','CGCG 097-072',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83981,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,83981,34.29,0.2,72.1,34197,74.4,NULL,NULL,'CGCG 097-072',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83982,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,83982,34.93,0.08,97,34197,NULL,NULL,NULL,'CGCG 097-072',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(83983,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83983,37.33,0.33,292,34198,70,NULL,NULL,'2MASX J11424601+5347129',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,175.691625,53.78692,0,NULL,61770196589,965159321,15080614,17.5),(83984,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83984,37.4,0.46,302,34199,70,NULL,NULL,'SDSS J114246.13+480413.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,175.6922917,48.07028,0.039,NULL,61754545756,964914777,15076793,17.6),(83985,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83985,37.14,0.46,268,34200,70,NULL,NULL,'2MASX J11424634+0220103',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000073,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,175.693083,2.33611,0.033,NULL,60187374226,940427722,14694183,17.5),(83986,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83986,36.58,0.46,207,34201,70,NULL,NULL,'2MASX J11424651+6239565',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,175.693833333,62.66578,0.029,NULL,61865555492,966649304,15103895,17.2),(83987,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83987,37.85,0.33,372,34202,70,NULL,NULL,'SDSS J114246.92+230138.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000142,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,175.6955417,23.02744,0,NULL,61075808980,954309515,14911086,18.2),(83988,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83988,36.89,0.33,239,34203,70,NULL,NULL,'MCG +10-17-047',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000203,NULL,'15.3g',0.58,'E0',NULL,NULL,NULL,NULL,1,175.697417,58.23642,0,NULL,61843865846,966310403,15098600,15.3),(83989,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83989,37.48,0.27,314,34204,70,NULL,NULL,'2MASX J11424810+1924289',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'16.6r',0.17,NULL,'Group member',NULL,NULL,NULL,1,175.700583,19.40797,0,NULL,61079333452,954364585,14911946,16.6),(83990,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83990,38.61,0.46,528,34205,70,NULL,NULL,'2MASX J11424875+4455154',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,175.703167,44.92086,0.016,NULL,63890784418,998293506,15598336,17.9),(83991,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,83991,32.57,0.43,32.6,34206,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3901',NULL,'2014MNRAS.444..527S',2014,1,1.8,NULL,'G',0.00006,NULL,'14.39',0.8,'Scd:','Isolated galaxy',NULL,NULL,NULL,1,175.707167,77.37269,0.125,NULL,61357552279,958711754,14979871,14.39),(83992,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83992,37.74,0.46,353,34207,70,NULL,NULL,'2MASX J11425034+3939233',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,175.709833,39.65642,0,NULL,60460915389,944701802,14760965,17.2),(83993,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83993,38,0.46,398,34208,70,NULL,NULL,'2MASX J11425035+0738351',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000152,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,175.709875,7.64317,0.013,NULL,60376555776,943383684,14740370,17.4),(83994,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83994,36.96,0.27,247,34209,70,NULL,NULL,'2MASX J11425116+5816072',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000182,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,175.713458333,58.26872,0,NULL,61843784690,966309135,15098580,16.7),(83995,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83995,36.96,0.27,247,34210,70,NULL,NULL,'2MASX J11425203+5822222',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,175.716875,58.373,0,NULL,61843795823,966309309,15098582,17.4),(83996,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83996,37.48,0.27,314,34211,70,NULL,NULL,'2MASX J11425205+1925439',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000103,NULL,'15.81',0.17,'S0?','Group member',NULL,NULL,NULL,1,175.7170417,19.42897,0,NULL,61079338499,954364664,14911947,15.81),(83997,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83997,37.77,0.27,359,34212,70,NULL,NULL,'SDSS J114252.58+125525.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000158,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,175.719125,12.92381,0.072,NULL,60248562999,941383796,14709121,18.5),(83998,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83998,37.61,0.12,333,34213,70,NULL,NULL,'2MASX J11425285+0819351',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,175.7202917,8.32653,0.021,NULL,60374180793,943346574,14739790,16.6),(83999,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',83999,37.96,0.46,392,34214,70,NULL,NULL,'2MASX J11425350+0337395',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000095,NULL,'17.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,175.7229583,3.62769,0.009,NULL,60195215904,940550248,14696097,17.4),(84000,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84000,38.59,0.46,522,34215,70,NULL,NULL,'2MASX J11425403+0510535',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,175.72525,5.18161,0,NULL,60183439282,940366238,14693222,18.5),(84001,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84001,37.29,0.46,287,34216,70,NULL,NULL,'2MASX J11425427+0423495',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000179,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,175.726125,4.39703,0.017,NULL,60183077753,940360589,14693134,16.4),(84002,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84002,37.84,0.46,370,34217,70,NULL,NULL,'SDSS J114254.63-011357.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00007,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,175.727667,-1.23256,0.033,NULL,40806651416,637603928,9962561,18),(84003,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84003,38.01,0.33,399,34218,70,NULL,NULL,'2MASX J11425493-0131153',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000137,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,175.728916667,-1.52086,0.033,NULL,40864328005,638505125,9976642,18),(84004,'GRB','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84004,47.58,1.96,12100,34219,NULL,NULL,NULL,'GRB 091020',1.71,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,175.730125,50.97847,0.006,NULL,61801711864,965651747,15088308,NULL),(84005,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84005,37.23,0.46,280,34220,70,NULL,NULL,'2MASX J11425571+0921081',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,175.732167,9.35231,0.045,NULL,60380495630,943445244,14741331,17.2),(84006,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84006,36.54,0.57,204,34221,70,NULL,NULL,'MCG -06-26-006',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'17.5',0.1,NULL,NULL,NULL,NULL,NULL,1,175.7322917,-36.28942,0.389,NULL,41362087989,646282624,10098166,17.5),(84007,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84007,36.73,0.46,222,34222,70,NULL,NULL,'2MASX J11425775+3506426',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,175.7405,35.11175,0,NULL,60441315852,944395560,14756180,17.5),(84008,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84008,37.33,0.33,292,34223,70,NULL,NULL,'2MASX J11425818+5343129',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000178,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,175.742458333,53.72042,0,NULL,61770231495,965159867,15080622,17.6),(84009,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84009,37.72,0.46,350,34224,70,NULL,NULL,'SDSS J114258.40+054239.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000131,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,175.743333,5.71092,0.007,NULL,60154186133,939909158,14686080,18.3),(84010,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84010,35.09,0.46,104,34225,70,NULL,NULL,'NGC 3828',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00009,NULL,'15.6',0.7,NULL,NULL,NULL,NULL,NULL,1,175.743416667,16.48761,0.025,NULL,60258311056,941536110,14711501,15.6),(84011,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84011,37.22,0.46,278,34226,70,NULL,NULL,'2MASX J11425858+4758129',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000173,NULL,'16.3g',0.41,NULL,NULL,NULL,NULL,NULL,1,175.7442083,47.97011,0.039,NULL,61754400385,964912506,15076757,16.3),(84012,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84012,37.14,0.46,268,34227,70,NULL,NULL,'2MASX J11425868+0715281',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000176,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,175.744625,7.25775,0.016,NULL,60374438725,943350605,14739853,17.1),(84013,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84013,37.33,0.46,292,34228,70,NULL,NULL,'2MASX J11425942+2142389',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000188,NULL,'17.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,175.747583333,21.71094,0,NULL,61084260667,954441572,14913149,17.5),(84014,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84014,35.25,0.53,112,34229,70,NULL,NULL,'2MASX J11425958-1141198',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.07',0.5,NULL,NULL,NULL,NULL,NULL,1,175.748375,-11.68886,0,NULL,40960838913,640013108,10000204,16.07),(84015,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84015,38.23,0.46,442,34230,70,NULL,NULL,'2MASX J11430005+0132395',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000084,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,175.750083,1.54433,0.045,NULL,60187742591,940433477,14694273,17.8),(84016,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84016,37.39,0.46,301,34231,70,NULL,NULL,'2MASX J11430008+2624540',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000179,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,175.750167,26.41497,0.038,NULL,60595774104,946808970,14793890,16.8),(84017,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84017,38.27,0.46,452,34232,70,NULL,NULL,'SDSS J114300.23+002211.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000076,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,175.751,0.36983,0.049,NULL,60138294654,939660853,14682200,18.6),(84018,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84018,37.09,0.46,262,34233,70,NULL,NULL,'2MASX J11430045+2012309',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00009,NULL,'16.02',0.2,NULL,'Group member',NULL,NULL,NULL,1,175.751708333,20.20853,0,NULL,61083442940,954428795,14912949,16.02),(84019,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84019,38.75,0.46,563,34234,70,NULL,NULL,'2MASX J11430055+0651073',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000179,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,175.7524583,6.85214,0.026,NULL,60153949969,939905468,14686022,17.8),(84020,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84020,35.13,0.46,106,34235,70,NULL,NULL,'CGCG 157-022',NULL,'2015arXiv151105856S',2015,1,0.98,NULL,'G',0.000073,NULL,'14.6g',0.68,'S0',NULL,NULL,NULL,NULL,1,175.7525417,27.39697,0.052,NULL,60596954713,946827417,14794178,14.6),(84021,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84021,37.85,0.46,372,34236,70,NULL,NULL,'2MASX J11430068+0251255',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000072,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,175.75275,2.85719,0.021,NULL,60194819793,940544059,14696000,17.3),(84022,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84022,37.85,0.33,372,34237,70,NULL,NULL,'SDSS J114300.82+230159.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000146,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,175.7534583,23.03317,0,NULL,61075757752,954308714,14911073,18),(84023,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84023,36.64,0.46,213,34238,70,NULL,NULL,'2MASX J11430127-0212523',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000172,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,175.755125,-2.21458,0.029,NULL,40864131014,638502047,9976594,16.5),(84024,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84024,36.02,0.64,160,34239,70,NULL,NULL,'2MASX J11430127-1810033',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.18',0.2,NULL,NULL,NULL,NULL,NULL,1,175.7552917,-18.16769,0.085,NULL,40948674631,639823041,9997235,16.18),(84025,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84025,36.94,0.46,244,34240,70,NULL,NULL,'2MASX J11430198+3457426',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000174,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,175.75825,34.96181,0,NULL,60441982724,944405980,14756343,16.4),(84026,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84026,34.73,0.2,88.3,34241,74.4,NULL,NULL,'UGC 06681',NULL,'2013AJ....146...86T',2013,1,1.24,NULL,'G',0.000032,NULL,'14.9g',0.38,'Sa',NULL,NULL,NULL,NULL,1,175.7585,23.94444,0.031,NULL,60544603312,946009426,14781397,14.9),(84027,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84027,34.92,0.49,96.5,34241,75,NULL,'IR','UGC 06681',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84028,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84028,35.1,0.4,105,34241,NULL,NULL,'mean','UGC 06681',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84029,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84029,35.27,0.47,113,34241,NULL,NULL,'H','UGC 06681',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84030,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84030,35.39,0.45,120,34241,NULL,NULL,'K','UGC 06681',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84031,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84031,37.77,0.27,359,34242,70,NULL,NULL,'2MASX J11430247+1308381',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00018,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,175.7604583,13.14389,0.089,NULL,60248772661,941387072,14709173,17.8),(84032,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84032,37.7,0.46,347,34243,70,NULL,NULL,'2MASX J11430287+2806200',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000179,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,175.762125,28.10572,0.043,NULL,60584769085,946637016,14791203,16.9),(84033,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84033,34.36,0.49,74.5,34244,75,NULL,'IR','UGC 06679',NULL,'2011yCatp016004901K',2011,1,1.28,NULL,'G',0.00003,NULL,'15.8g',0.22,'Sd',NULL,NULL,NULL,NULL,1,175.7625417,40.82753,0,NULL,60403666311,943807286,14746988,15.8),(84034,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84034,34.36,0.43,74.6,34244,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06679',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84035,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84035,34.48,NULL,78.7,34244,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06679',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84036,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84036,34.51,NULL,79.6,34244,NULL,NULL,'Dipole + Quadrupole','UGC 06679',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84037,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84037,34.51,NULL,79.9,34244,NULL,NULL,'Dipole','UGC 06679',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84038,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84038,34.61,NULL,83.4,34244,NULL,NULL,NULL,'UGC 06679',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84039,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84039,37.88,0.46,376,34245,70,NULL,NULL,'2MASX J11430309+4408094',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000161,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,175.762833,44.13594,0,NULL,63890363288,998286926,15598233,17.1),(84040,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84040,37.88,0.46,377,34246,70,NULL,NULL,'SDSS J114303.28+041002.4',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,175.763666667,4.16733,0.005,NULL,60195603542,940556305,14696192,18.1),(84041,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84041,38.76,0.46,565,34247,70,NULL,NULL,'SDSS J114303.41+182322.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,175.76425,18.38969,0,NULL,60204288355,940692005,14698312,18.6),(84042,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84042,38.37,0.46,473,34248,70,NULL,NULL,'2MASX J11430363+0946443',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,175.765,9.77889,0.111,NULL,60380465286,943444770,14741324,18.2),(84043,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84043,37.56,0.46,325,34249,70,NULL,NULL,'2MASX J11430367+4144367',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,175.765167,41.74353,0,NULL,60404901253,943826582,14747290,17.7),(84044,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84044,37.99,0.21,396,34250,70,NULL,NULL,'2MASX J11430390+0726013',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'16.9g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,175.7662083,7.43358,0.016,NULL,60374601432,943353147,14739892,16.9),(84045,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84045,38.47,0.46,494,34251,70,NULL,NULL,'2MASX J11430418+2539540',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,175.7675,25.66511,0.023,NULL,60588741268,946699082,14792173,17.6),(84046,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84046,38.01,0.46,401,34252,70,NULL,NULL,'SDSS J114304.62+013946.2',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000213,NULL,'17.7g',0.17,'NLAGN',NULL,NULL,NULL,'Sy 2',1,175.7692917,1.66283,0.045,NULL,60187763760,940433808,14694278,17.7),(84047,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84047,37.59,0.46,330,34253,70,NULL,NULL,'2MASX J11430505+0356265',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000174,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,175.771167,3.94058,0,NULL,60195622322,940556598,14696196,16.8),(84048,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84048,37.37,0.23,299,34254,70,NULL,NULL,'2MASX J11430532+5934402',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000175,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,175.772125,59.578,0,NULL,61857569745,966524527,15101945,17.4),(84049,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84049,37.78,0.46,360,34255,70,NULL,NULL,'2MASX J11430538+0708113',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,175.772583,7.1365,0.041,NULL,60374386150,943349783,14739840,17.9),(84050,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84050,37.07,0.46,259,34256,70,NULL,NULL,'2MASX J11430587+5939382',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000146,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,175.7742917,59.66075,0,NULL,61857572211,966524565,15101946,17.4),(84051,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84051,37.37,0.23,299,34257,70,NULL,NULL,'2MASX J11430693+5941302',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000213,NULL,'16.4g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,175.778667,59.69186,0,NULL,61857357071,966521204,15101893,16.4),(84052,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84052,36.02,0.54,160,34258,NULL,NULL,'Malmquist cor.','KUG 1140+199',NULL,'2009ApJS..182..474S',2009,1,0.55,NULL,'G',0.000017,NULL,'16.80',0.1,'S','Group non-member, background',NULL,NULL,NULL,1,175.783125,19.69867,0,NULL,61078939090,954358423,14911850,16.8),(84053,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84053,36.17,0.51,171,34258,NULL,NULL,NULL,'KUG 1140+199',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84054,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84054,36.21,0.2,175,34258,74.4,NULL,NULL,'KUG 1140+199',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84055,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84055,36.7,0.46,219,34259,70,NULL,NULL,'2MASX J11430828+1812009',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.08',0.15,NULL,NULL,NULL,NULL,NULL,1,175.784583333,18.20022,0,NULL,60204457573,940694649,14698353,18.08),(84056,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84056,38.34,0.46,467,34260,70,NULL,NULL,'2MASX J11430875+0305405',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000091,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,175.786541667,3.09461,0.021,NULL,60195912630,940561134,14696267,17.6),(84057,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84057,37.61,0.12,333,34261,70,NULL,NULL,'2MASX J11430900+0746563',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,175.7875417,7.78239,0.013,NULL,60374648026,943353875,14739904,17.2),(84058,'Tully est','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84058,31.89,0.8,23.8,34262,75,NULL,NULL,'UGC 06682',NULL,'1988NBGC.C....0000T',1988,1,1.6,'Multiple SDSS entries describe this source.','G',0.000003,NULL,'14.5',1.4,'Sm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,175.787125,59.10531,0,NULL,61854842590,966481915,15101279,14.5),(84059,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84059,37.42,0.46,304,34263,70,NULL,NULL,'2MASX J11430928+3753587',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000179,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,175.7887083,37.89978,0.034,NULL,60463430442,944741100,14761579,16.4),(84060,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84060,38.11,0.46,418,34264,70,NULL,NULL,'SDSS J114309.85+070945.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,175.791083333,7.16261,0.041,NULL,60374399771,943349996,14739843,18.1),(84061,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84061,36.5,0.46,199,34265,70,NULL,NULL,'2MASXi J1143100+192527',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.2r',0.24,NULL,'Group member',NULL,NULL,NULL,1,175.791833,19.42433,0,NULL,61079510392,954367349,14911989,16.2),(84062,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84062,36.41,0.46,191,34266,70,NULL,NULL,'2MASX J11431023+5412031',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,175.7927083,54.20094,0,NULL,61773113237,965204894,15081326,16.4),(84063,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84063,37.72,0.46,350,34267,70,NULL,NULL,'SDSS J114310.27+052607.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000171,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,175.792833,5.43536,0,NULL,60182262052,940347844,14692935,17.7),(84064,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84064,31.36,NULL,18.7,34268,NULL,NULL,NULL,'KDG 079',NULL,'2015AstBu..70....1K',2015,1,1.1,NULL,'G',0.000007,NULL,'18.85',0.4,'Dwarf',NULL,NULL,NULL,NULL,1,175.7937083,14.22469,0.1,NULL,60262215485,941597116,14712454,18.85),(84065,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84065,37.49,0.46,315,34269,70,NULL,NULL,'SDSS J114310.49+112524.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000139,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,175.79375,11.42353,0.036,NULL,60240174593,941252728,14707073,18.5),(84066,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84066,35.76,0.27,142,34270,70,NULL,NULL,'CGCG 157-023 NED02',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00016,NULL,'15.5g',0.38,NULL,NULL,NULL,NULL,NULL,1,175.794833,26.57453,0.046,NULL,60595437799,946803715,14793808,15.5),(84067,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84067,35.26,0.07,113,34271,70,NULL,NULL,'2MASX J11431096+2001469',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00005,NULL,'15.3r',0.3,NULL,'Group member',NULL,NULL,NULL,1,175.795667,20.02972,0,NULL,61083453305,954428957,14912952,15.3),(84068,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84068,37.73,0.46,351,34272,70,NULL,NULL,'2MASX J11431095-0024303',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000077,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,175.7957083,-0.40836,0.033,NULL,40809893483,637654585,9963352,18),(84069,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84069,37.58,0.33,329,34273,70,NULL,NULL,'2MASX J11431175+0902243',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.59',0.2,NULL,NULL,NULL,NULL,NULL,1,175.799,9.03989,0,NULL,60380858769,943450918,14741420,17.59),(84070,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84070,37.37,0.23,299,34274,70,NULL,NULL,'2MASX J11431216+5933431',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000196,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,175.801,59.56214,0,NULL,61857570103,966524532,15101945,16.9),(84071,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84071,38.38,0.46,475,34275,70,NULL,NULL,'2MASX J11431258+1938415',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000117,NULL,'16.2r',0.2,NULL,'Group member',NULL,NULL,NULL,1,175.802541667,19.64483,0,NULL,61078930798,954358293,14911848,16.2),(84072,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84072,34.44,0.49,77.1,34276,75,NULL,'IR','MCG -02-30-021',NULL,'2011yCatp016004901K',2011,1,1.32,NULL,'G',0.000033,NULL,'15.08',0.17,'Sd',NULL,NULL,NULL,NULL,1,175.805333,-12.76472,0.049,NULL,40961077011,640016828,10000262,15.08),(84073,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84073,34.52,0.2,80.2,34276,74.4,NULL,NULL,'MCG -02-30-021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84074,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84074,34.55,0.38,81.3,34276,NULL,NULL,'Malmquist cor.','MCG -02-30-021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84075,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84075,34.67,0.36,86,34276,NULL,NULL,NULL,'MCG -02-30-021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84076,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84076,35.13,NULL,106,34276,NULL,NULL,'Dipole + Quadrupole','MCG -02-30-021',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84077,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84077,35.13,NULL,106,34276,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -02-30-021',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84078,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84078,35.13,NULL,106,34276,NULL,NULL,'Dipole','MCG -02-30-021',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84079,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84079,34.94,0.49,97.5,34277,75,NULL,'IR','KUG 1140+202B',NULL,'2011yCatp016004901K',2011,1,0.5,NULL,'G',0.000023,NULL,'15.7',0.4,'Irr            HII','Group member',NULL,NULL,NULL,1,175.805708333,20.00461,0,NULL,61083323140,954426924,14912920,15.7),(84080,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84080,37.75,0.46,354,34278,70,NULL,NULL,'2MASX J11431375+4842199',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00011,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,175.807333,48.70558,0.013,NULL,61753242055,964894407,15076475,17.9),(84081,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84081,36.86,0.46,236,34279,70,NULL,NULL,'2MASX J11431379+1806565',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.54',0.14,NULL,NULL,NULL,NULL,NULL,1,175.8075,18.11569,0,NULL,60204453731,940694589,14698352,18.54),(84082,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84082,37.72,0.46,350,34280,70,NULL,NULL,'2MASX J11431391+0859103',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000135,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,175.807791667,8.98622,0,NULL,60380898874,943451544,14741430,18),(84083,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84083,35.87,0.46,149,34281,70,NULL,NULL,'2MASX J11431409+2733270',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000144,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,175.808667,27.55756,0.052,NULL,60596993368,946828021,14794187,16.6),(84084,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84084,36.58,0.46,207,34282,70,NULL,NULL,'2MASX J11431445+2815310',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000188,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,175.81025,28.25844,0.039,NULL,60584801163,946637518,14791211,16.5),(84085,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84085,37.48,0.27,314,34283,70,NULL,NULL,'2MASX J11431494+1925355',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'16.65',0.15,NULL,'Group member',NULL,NULL,NULL,1,175.812375,19.42656,0,NULL,61079510757,954367355,14911989,16.65),(84086,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84086,37.88,0.46,376,34284,70,NULL,NULL,'2MASX J11431515-0156043',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,175.813041667,-1.93461,0.037,NULL,40863374857,638490232,9976409,17.7),(84087,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84087,38.32,0.46,461,34285,70,NULL,NULL,'2MASX J11431581-0127053',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000092,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,175.815667,-1.45156,0.041,NULL,40863269384,638488584,9976384,17.7),(84088,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84088,38.43,0.46,486,34286,70,NULL,NULL,'SDSS J114315.88+075406.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000107,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,175.816208333,7.90181,0.016,NULL,60374194979,943346796,14739793,18.2),(84089,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84089,37.84,0.46,371,34287,70,NULL,NULL,'2MASX J11431627+4743543',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000178,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,175.817625,47.73181,0.032,NULL,61754703637,964917244,15076831,16.7),(84090,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84090,38.13,0.46,422,34288,70,NULL,NULL,'SDSS J114316.54-021332.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,175.818917,-2.22569,0.029,NULL,40863678344,638494974,9976483,18.5),(84091,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84091,38.45,0.46,489,34289,70,NULL,NULL,'SDSS J114317.42+265038.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.5g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,175.822625,26.84414,0.049,NULL,60598959577,946858743,14794667,18.5),(84092,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84092,35.26,0.07,113,34290,70,NULL,NULL,'CGCG 097-077',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000063,NULL,'15.13',0.2,'Elliptical','Group member',NULL,NULL,NULL,1,175.823417,19.38403,0,NULL,61079539354,954367802,14911996,15.13),(84093,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84093,37.82,0.46,367,34291,70,NULL,NULL,'2MASX J11431798+5924401',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,175.825083,59.41106,0,NULL,61857459431,966522803,15101918,17.6),(84094,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84094,37.79,0.46,361,34292,70,NULL,NULL,'2MASXi J1143181+294354',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,175.825583,29.73164,0.021,NULL,60556513897,946195529,14784305,17),(84095,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84095,33.46,0.5,49.2,34293,70,NULL,NULL,'NGC 3831',NULL,'2014MNRAS.445.2677S',2014,1,2.7,NULL,'G',0.00015,NULL,'13.60',0.6,'SAB(r)0+ pec   Sy2',NULL,NULL,NULL,'Sy 2',1,175.8275,-12.87836,0.049,NULL,40959015209,639984612,9999759,13.6),(84096,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84096,37.98,0.46,394,34294,70,NULL,NULL,'SDSS J114318.79+004452.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000085,NULL,'18.0g',0.11,NULL,NULL,NULL,NULL,NULL,1,175.828291667,0.74786,0.061,NULL,60141866292,939716660,14683072,18),(84097,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84097,35.76,0.27,142,34295,70,NULL,NULL,'2MASX J11431920+2625123',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.16',0.16,NULL,NULL,NULL,NULL,NULL,1,175.8299583,26.42014,0.038,NULL,60595954389,946811787,14793934,18.16),(84098,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84098,38.31,0.33,458,34296,70,NULL,NULL,'SDSS J114319.86+414355.3',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.6g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,175.8327917,41.73203,0,NULL,60404895616,943826494,14747288,17.6),(84099,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84099,37.17,0.46,272,34297,70,NULL,NULL,'2MASX J11432058+0200085',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000096,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,175.835917,2.00242,0.041,NULL,60185777730,940402777,14693793,16.3),(84100,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84100,38.56,0.46,516,34298,70,NULL,NULL,'SDSS J114320.74+172215.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.0g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,175.836416667,17.37089,0.023,NULL,60204531966,940695811,14698372,18),(84101,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84101,37.78,0.46,360,34299,70,NULL,NULL,'2MASX J11432201+2058215',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000179,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,175.841833333,20.97258,0,NULL,61085832872,954466138,14913533,17.7),(84102,'IRAS','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84102,34.75,0.8,89.1,34300,75,NULL,'W91CL, r','UGC 06686',NULL,'1997ApJS..109..333W',1997,1,3.07,NULL,'G',0.000033,NULL,'14.99',0.34,'Sbc',NULL,NULL,NULL,NULL,1,175.8447083,16.4855,0.046,NULL,60258304939,941536014,14711500,14.99),(84103,'IRAS','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84103,34.78,0.8,90.4,34300,75,NULL,'HMCL, I','UGC 06686',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84104,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84104,33.9,NULL,60.3,34300,NULL,NULL,'Dipole','UGC 06686',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84105,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84105,33.91,NULL,60.5,34300,NULL,NULL,'Dipole + Quadrupole','UGC 06686',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84106,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84106,33.92,NULL,60.7,34300,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06686',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84107,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84107,34.03,0.4,64.1,34300,75,NULL,'HMCL, I, raw','UGC 06686',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84108,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84108,34.09,NULL,65.8,34300,NULL,NULL,NULL,'UGC 06686',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84109,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84109,34.21,0.49,69.5,34300,75,NULL,'IR','UGC 06686',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84110,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84110,34.21,0.4,69.5,34300,75,NULL,'HMCL, I, inv','UGC 06686',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84111,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84111,34.23,0.38,70.1,34300,75,NULL,'W91CL, r, raw','UGC 06686',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84112,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84112,34.25,0.2,70.8,34300,74.4,NULL,NULL,'UGC 06686',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84113,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84113,34.3,0.4,72.5,34300,75,NULL,'HMCL, I, cor','UGC 06686',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84114,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84114,34.36,0.43,74.4,34300,75,NULL,'3.6 micron, color corrected','UGC 06686',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84115,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84115,34.36,0.38,74.5,34300,75,NULL,'W91CL, r, inv','UGC 06686',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84116,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84116,34.53,0.38,80.5,34300,75,NULL,'W91CL, r, cor','UGC 06686',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84117,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84117,34.53,0.43,80.6,34300,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06686',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84118,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84118,35.02,0.15,101,34300,NULL,NULL,NULL,'UGC 06686',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84119,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84119,34.51,NULL,79.7,34301,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 068-042',NULL,'2010Ap&SS.325..163P',2010,1,0.88,NULL,'G',0.000005,NULL,'16.2g',0.19,'Sbc',NULL,NULL,NULL,NULL,1,175.845125,10.80131,0.195,NULL,60371557545,943305586,14739149,16.2),(84120,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84120,34.53,NULL,80.4,34301,NULL,NULL,'Dipole + Quadrupole','CGCG 068-042',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84121,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84121,34.54,NULL,80.9,34301,NULL,NULL,'Dipole','CGCG 068-042',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84122,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84122,34.65,0.2,85.1,34301,74.4,NULL,NULL,'CGCG 068-042',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84123,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84123,34.67,NULL,86,34301,NULL,NULL,NULL,'CGCG 068-042',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84124,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84124,37.83,0.46,368,34302,70,NULL,NULL,'SDSS J114322.85+283540.1',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.7g',0.19,'AGN',NULL,NULL,NULL,NULL,1,175.8452083,28.5945,0.031,NULL,60584744443,946636631,14791197,17.7),(84125,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84125,38.31,0.33,458,34303,70,NULL,NULL,'SDSS J114322.85+414231.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,175.84525,41.70881,0,NULL,60404892185,943826440,14747288,18.8),(84126,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84126,36.03,0.84,161,34304,70,NULL,NULL,'ESO 571- G 019',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'12.0K',0.2,'(R\'_1)SB(s)a:',NULL,NULL,NULL,NULL,1,175.8455417,-19.18806,0.149,NULL,41681833413,651278647,10176228,12),(84127,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84127,38.12,0.46,420,34305,70,NULL,NULL,'2MASX J11432315+3659477',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,175.8465417,36.99653,0.037,NULL,60449413300,944522082,14758157,17.8),(84128,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84128,38.22,0.46,441,34306,70,NULL,NULL,'2MASX J11432355+1053563',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,175.848083333,10.89892,0.091,NULL,60371070555,943297977,14739030,18),(84129,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84129,36.03,0.46,160,34307,70,NULL,NULL,'VII Zw 418',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000152,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,175.8492917,63.19078,0.069,NULL,61863380910,966615326,15103364,16.5),(84130,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84130,33.8,0.49,57.6,34308,75,NULL,'IR','UGC 06689',NULL,'2011yCatp016004901K',2011,1,1.15,NULL,'G',0.00003,NULL,'15.3g',0.32,'Sab',NULL,NULL,NULL,NULL,1,175.8525,21.65067,0,NULL,61084126234,954439472,14913116,15.3),(84131,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84131,37.9,0.46,381,34309,70,NULL,NULL,'2MASX J11432496+1338223',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000137,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,175.854041667,13.6395,0.121,NULL,60248868348,941388567,14709196,18.6),(84132,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84132,37.77,0.46,358,34310,70,NULL,NULL,'2MASX J11432597+5602235',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000185,NULL,'17.1g',0.24,NULL,'Group member',NULL,NULL,NULL,1,175.858417,56.03992,0,NULL,61978070083,968407345,15131364,17.1),(84133,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84133,37.49,0.46,314,34311,70,NULL,NULL,'2MASX J11432680+1347393',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,175.861583333,13.79417,0.121,NULL,60248378172,941380908,14709076,17),(84134,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84134,37.61,0.12,333,34312,70,NULL,NULL,'2MASX J11432690+0749473',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,175.861917,7.82983,0.016,NULL,60374652354,943353943,14739905,17.7),(84135,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84135,31.54,NULL,20.3,34313,NULL,NULL,NULL,'SDSS J114326.98+112354.3',NULL,'2015AstBu..70....1K',2015,1,0.46,NULL,'G',0.000013,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,175.862458333,11.39844,0.021,NULL,60240195149,941253049,14707078,16.3),(84136,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84136,36.43,0.46,194,34314,70,NULL,NULL,'2MASX J11432808+5549515',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000159,NULL,'16.6g',0.27,NULL,'Group member',NULL,NULL,NULL,1,175.867167,55.83092,0,NULL,61978065822,968407278,15131363,16.6),(84137,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84137,38.26,0.14,450,34315,70,NULL,NULL,'SDSS J114328.39+055048.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000182,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,175.868333,5.84678,0.011,NULL,60154243854,939910060,14686094,18.2),(84138,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84138,37.99,0.21,396,34316,70,NULL,NULL,'2MASX J11432844+0728453',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000154,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,175.8684583,7.47922,0.016,NULL,60374610507,943353289,14739895,17.1),(84139,'IRAS','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84139,34.62,0.8,84.1,34317,75,NULL,'CF, r','NGC 3833',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000005,NULL,'14.2g',0.69,'Sc','Group member',NULL,NULL,NULL,1,175.87075,10.16186,0.109,NULL,60371263747,943300996,14739078,14.2),(84140,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84140,34.62,0.38,83.9,34317,75,NULL,'CF, r, raw','NGC 3833',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84141,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84141,34.77,0.38,89.9,34317,75,NULL,'CF, r, cor','NGC 3833',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84142,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84142,34.78,0.38,90.3,34317,75,NULL,'CF, r, inv','NGC 3833',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84143,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84143,34.8,0.27,91.3,34317,NULL,NULL,'Malmquist cor.','NGC 3833',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84144,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84144,34.81,0.4,91.6,34317,NULL,NULL,'mean','NGC 3833',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84145,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84145,34.84,0.47,93,34317,NULL,NULL,'H','NGC 3833',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84146,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84146,34.91,0.2,95.9,34317,74.4,NULL,NULL,'NGC 3833',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84147,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84147,34.92,0.46,96.2,34317,NULL,NULL,'J','NGC 3833',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84148,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84148,34.93,0.45,96.9,34317,NULL,NULL,'K','NGC 3833',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84149,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84149,35,0.24,100,34317,NULL,NULL,NULL,'NGC 3833',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84150,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84150,37.23,0.46,280,34318,70,NULL,NULL,'LCRS B114055.5-023320',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000138,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,175.8705,-2.83292,0.057,NULL,40865375316,638521489,9976898,18.1),(84151,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84151,36.2,0.33,174,34319,70,NULL,NULL,'IC 0725',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000122,NULL,'14.7g',0.71,'E:',NULL,NULL,NULL,NULL,1,175.87225,-1.66797,0.037,NULL,40863331557,638489555,9976399,14.7),(84152,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84152,37.37,0.23,299,34320,70,NULL,NULL,'2MASX J11432959+5938265',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000182,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,175.873083333,59.64089,0,NULL,61857573298,966524582,15101946,16.7),(84153,'BCG','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84153,38.67,0.35,490,34321,60,NULL,'ABELL 1364, BCG','2MASX J11432962-0144298',0.107,'1980ApJ...241..486H',1980,1,0.38,'This galaxy lenses a z = 0.402 object.','G',0.00015,NULL,'17.0g',0.27,'E;BrClG','Brightest group member',NULL,NULL,NULL,1,175.8735,-1.74167,0.037,NULL,40863292258,638488941,9976389,17),(84154,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84154,36.33,0.46,184,34322,70,NULL,NULL,'2MASX J11433065+2411154',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000152,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,175.8777083,24.18769,0.055,NULL,60543813665,945997088,14781204,16.8),(84155,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84155,37.6,0.46,332,34323,70,NULL,NULL,'2MASX J11433086+2306486',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000194,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,175.878583,23.11361,0,NULL,60542224259,945972254,14780816,16.9),(84156,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84156,34.62,0.47,84,34324,NULL,NULL,'H','NGC 3832',NULL,'2007A&A...465...71T',2007,1,1.86,NULL,'G',0.000013,NULL,'13.9g',1.34,'SB(rs)bc','Possible field galaxy',NULL,NULL,NULL,1,175.881,22.72544,0,NULL,61076322967,954317546,14911211,13.9),(84157,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84157,34.88,0.45,94.8,34324,NULL,NULL,'K','NGC 3832',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84158,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84158,34.89,0.46,95,34324,NULL,NULL,'J','NGC 3832',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84159,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84159,35.12,0.4,106,34324,NULL,NULL,'mean','NGC 3832',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84160,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84160,37.99,0.21,396,34325,70,NULL,NULL,'2MASX J11433148+0729001',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000182,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,175.881208333,7.48344,0,NULL,60374602841,943353169,14739893,17.5),(84161,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84161,37.99,0.21,396,34326,70,NULL,NULL,'2MASX J11433262+0722421',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,175.885958333,7.37828,0.016,NULL,60374434466,943350538,14739852,17.6),(84162,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84162,38.21,0.46,438,34327,70,NULL,NULL,'2MASX J11433343+1806406',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,175.889458333,18.11133,0,NULL,60204928338,940702005,14698468,18),(84163,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84163,33.85,0.46,58.9,34328,NULL,NULL,'Malmquist cor.','IC 0724',NULL,'2009ApJS..182..474S',2009,1,2.92,NULL,'G',0.000015,NULL,'13.3g',0.79,'Sa','in a radial-velocity based grouping',NULL,NULL,NULL,1,175.894458333,8.94247,0.028,NULL,60380924437,943451944,14741436,13.3),(84164,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84164,33.86,0.46,59.2,34328,NULL,NULL,NULL,'IC 0724',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84165,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84165,34.15,0.2,67.6,34328,74.4,NULL,NULL,'IC 0724',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84166,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84166,34.25,0.47,70.8,34328,NULL,NULL,'H','IC 0724',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84167,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84167,34.29,0.46,72.1,34328,NULL,NULL,'J','IC 0724',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84168,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84168,34.32,0.45,73.1,34328,NULL,NULL,'K','IC 0724',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84169,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84169,34.75,0.4,89.2,34328,NULL,NULL,'mean','IC 0724',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84170,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84170,36.99,0.46,250,34329,70,NULL,NULL,'2MASX J11433537+2000076',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.38',0.13,NULL,'Group member',NULL,NULL,NULL,1,175.8975,20.00203,0,NULL,61083325868,954426966,14912921,18.38),(84171,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84171,38.19,0.46,434,34330,70,NULL,NULL,'SDSS J114335.42+455631.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000141,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,175.897583333,45.94208,0.014,NULL,63889665487,998276023,15598062,18.5),(84172,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84172,37.25,0.46,281,34331,70,NULL,NULL,'2MASX J11433561+1550333',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000172,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,175.898417,15.84258,0.065,NULL,60260048336,941563255,14711925,16.7),(84173,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84173,36.1,0.46,166,34332,70,NULL,NULL,'2MASX J11433563+4022118',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000175,NULL,'16.1g',0.37,NULL,NULL,NULL,NULL,NULL,1,175.8985417,40.36992,0,NULL,60403334959,943802108,14746907,16.1),(84174,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84174,37.71,0.46,348,34333,70,NULL,NULL,'2MASX J11433647+1758103',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,175.901833333,17.96953,0.007,NULL,60204996424,940703069,14698485,17.3),(84175,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84175,38.14,0.33,424,34334,70,NULL,NULL,'2MASX J11433643+4123438',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,'PRED','17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,175.901833333,41.39564,0,NULL,60404797152,943824955,14747264,17.7),(84176,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84176,36.2,0.33,174,34335,70,NULL,NULL,'CGCG 012-066',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000053,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,175.9019583,-1.63833,0.037,NULL,40863333883,638489591,9976399,16.4),(84177,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84177,35.26,0.07,113,34336,70,NULL,NULL,'ARK 313',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000047,NULL,'15.4g',0.58,'E','Group member',NULL,NULL,NULL,1,175.904125,19.60464,0,NULL,61079452984,954366452,14911975,15.4),(84178,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84178,35,0.46,99.9,34337,70,NULL,NULL,'NGC 3834',NULL,'2015arXiv151105856S',2015,1,1.4,NULL,'G',0.000083,NULL,'14.40',1,'E-S0','Group member',NULL,NULL,NULL,1,175.907208333,19.09047,0,NULL,61079120803,954361262,14911894,14.4),(84179,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84179,38.14,0.33,424,34338,70,NULL,NULL,'2MASX J11433785+4123348',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,175.907583,41.393,0,NULL,60404796989,943824952,14747264,17.5),(84180,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84180,37.21,0.46,276,34339,70,NULL,NULL,'2MASX J11433840+0523541',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000175,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,175.909917,5.39839,0,NULL,60182473635,940351150,14692986,17.4),(84181,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84181,37.82,0.46,366,34340,70,NULL,NULL,'SDSS J114339.12+072557.8',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,175.9130417,7.43275,0.016,NULL,60374630517,943353601,14739900,17.7),(84182,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84182,37.47,0.27,312,34341,70,NULL,NULL,'2MASX J11433939+6448109',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,175.9142083,64.80308,0.005,NULL,61823777456,965996522,15093695,17.8),(84183,'BCG','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84183,38.67,0.35,490,34342,60,NULL,NULL,'ABELL 1364',0.107,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,175.9150417,-1.76092,0.037,NULL,40863289874,638488904,9976389,NULL),(84184,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84184,38.04,0.46,405,34343,70,NULL,NULL,'2MASX J11433964+4139558',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000175,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,175.915417,41.66564,0,NULL,60412956195,943952440,14749256,17.3),(84185,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84185,37.99,0.21,396,34344,70,NULL,NULL,'2MASX J11433982+0730001',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000187,NULL,'16.8g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,175.9160417,7.49989,0,NULL,60374633295,943353645,14739900,16.8),(84186,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84186,38.28,0.15,454,34345,70,NULL,NULL,'2MASX J11434169-0147048',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000094,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,175.923708333,-1.78472,0.037,NULL,40863510331,638492348,9976442,17.4),(84187,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84187,37.37,0.46,298,34346,70,NULL,NULL,'2MASX J11434199+6133519',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,175.9247083,61.56453,0.009,NULL,61864364702,966630698,15103604,17.1),(84188,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84188,36.42,0.46,192,34347,70,NULL,NULL,'2MASX J11434222+5435256',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,175.92575,54.5905,0,NULL,61772430976,965194234,15081159,17.2),(84189,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84189,38.28,0.15,454,34348,70,NULL,NULL,'2MASX J11434322-0146358',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000174,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,175.930083,-1.77672,0.037,NULL,40863507237,638492300,9976442,17.2),(84190,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84190,36.42,0.46,193,34349,70,NULL,NULL,'2MASX J11434387+2818444',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'17.94',0.18,NULL,NULL,NULL,NULL,NULL,1,175.932625,28.31225,0.039,NULL,60584775891,946637123,14791205,17.94),(84191,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84191,34.97,0.08,98.8,34350,NULL,NULL,NULL,'CGCG 127-040',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000047,NULL,'15.3',0.2,'S0/a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,175.93325,20.27269,0,NULL,61083424079,954428501,14912945,15.3),(84192,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84192,35.76,0.15,142,34351,70,NULL,NULL,'IC 0726',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00015,NULL,'15.8g',0.41,'AGN',NULL,NULL,NULL,NULL,1,175.93875,33.39194,0,NULL,60631660130,947369689,14802651,15.8),(84193,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84193,37.67,0.46,343,34352,70,NULL,NULL,'2MASX J11434554+1923333',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00009,NULL,'16.27',0.17,'E','Group member',NULL,NULL,NULL,1,175.93975,19.39264,0,NULL,61079543673,954367869,14911997,16.27),(84194,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84194,35.83,0.52,147,34353,70,NULL,NULL,'2MASX J11434561-4655495',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.4,NULL,NULL,NULL,NULL,NULL,1,175.940125,-46.93047,0.565,NULL,39997978940,624968420,9765131,13.9),(84195,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84195,36.8,0.46,229,34354,70,NULL,NULL,'2MASX J11434673+2808524',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000184,NULL,'18.06',0.15,NULL,NULL,NULL,NULL,NULL,1,175.944625,28.14786,0.05,NULL,60596261014,946816578,14794009,18.06),(84196,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84196,36.95,0.46,245,34355,70,NULL,NULL,'2MASX J11434703+1103221',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000194,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,175.945875,11.05608,0.091,NULL,60371176498,943299632,14739056,16.5),(84197,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84197,35.11,0.12,105,34356,NULL,NULL,NULL,'UGC 06697',NULL,'2009ApJS..182..474S',2009,1,1.9,'Geller et al. (2006AJ....132.2243G) give v = 5969 km/sec.','G',0.000007,NULL,'14.08',0.3,'Im:;HII        Sbrst','in a radial-velocity based grouping',NULL,'NAT',NULL,1,175.9544583,19.96844,0,NULL,61083341249,954427207,14912925,14.08),(84198,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84198,35.19,0.49,109,34356,75,NULL,'IR','UGC 06697',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84199,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84199,36.65,0.66,214,34357,70,NULL,NULL,'2MASX J11435022-7301421',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,175.959291667,-73.02836,0.849,NULL,39850383378,622662240,9729097,17.9),(84200,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84200,37.6,0.46,331,34358,70,NULL,NULL,'SDSS J114350.56+295722.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000169,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,175.9607083,29.95631,0.018,NULL,60556548238,946196066,14784313,18.2),(84201,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84201,37.76,0.46,356,34359,70,NULL,NULL,'2MASX J11435084+1530353',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,175.961833,15.50981,0.08,NULL,60263389121,941615455,14712741,17.7),(84202,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84202,37.44,0.33,307,34360,70,NULL,NULL,'2MASX J11435206+1227583',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000161,NULL,'16.2g',0.43,NULL,NULL,NULL,NULL,NULL,1,175.967083,12.46625,0.091,NULL,60242166503,941283851,14707560,16.2),(84203,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84203,37.57,0.46,327,34361,70,NULL,NULL,'2MASX J11435255+2119373',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000165,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,175.9690417,21.32689,0,NULL,61085723153,954464424,14913506,17.3),(84204,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84204,38.78,0.33,569,34362,70,NULL,NULL,'SDSS J114353.11+451321.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000196,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,175.9712917,45.2225,0,NULL,63888978530,998265289,15597895,18.5),(84205,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84205,37.73,0.46,351,34363,70,NULL,NULL,'2MASX J11435340+0743261',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,175.972625,7.72397,0,NULL,60374563903,943352560,14739883,17.2),(84206,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84206,37.5,0.19,316,34364,70,NULL,NULL,'2MASX J11435391+3050540',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000169,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,175.974583,30.84839,0.021,NULL,60555358734,946177480,14784023,18),(84207,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84207,36.25,0.88,178,34365,70,NULL,NULL,'2MASX J11435431-1303153',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,175.9762083,-13.05425,0.041,NULL,40959195003,639987421,9999803,15.3),(84208,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84208,33.68,0.58,54.4,34366,NULL,NULL,'Malmquist cor.','NGC 3839',NULL,'2009ApJS..182..474S',2009,1,1.14,NULL,'G',0.00001,NULL,'13.9g',0.6,'Sdm:','in a radial-velocity based grouping',NULL,NULL,NULL,1,175.976375,10.78469,0.195,NULL,60371524948,943305077,14739141,13.9),(84209,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84209,33.72,0.43,55.4,34366,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3839',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84210,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84210,33.74,0.57,55.9,34366,NULL,NULL,NULL,'NGC 3839',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84211,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84211,33.86,0.43,59.2,34366,75,NULL,'3.6 micron, color corrected','NGC 3839',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84212,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84212,33.93,0.2,61.1,34366,74.4,NULL,NULL,'NGC 3839',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84213,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84213,37.2,0.46,275,34367,70,NULL,NULL,'2MASX J11435544+1538148',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000183,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,175.9810417,15.63744,0.065,NULL,60259927447,941561366,14711896,16.9),(84214,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84214,38.71,0.33,552,34368,70,NULL,NULL,'2MASX J11435609+0953371',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,175.9835417,9.89361,0.109,NULL,60380627439,943447303,14741364,17.4),(84215,'D-Sigma','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84215,34.62,0.4,83.8,34369,75,NULL,'Edat, raw','NGC 3837',NULL,'1997ApJS..109..333W',1997,1,0.6,NULL,'G',0.000033,NULL,'14.25',0.6,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,175.985125,19.89458,0,NULL,61078903441,954357866,14911841,14.25),(84216,'D-Sigma','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84216,34.8,0.4,91.3,34369,75,NULL,'Edat, cor','NGC 3837',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84217,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84217,34.83,0.25,92.5,34369,74.4,NULL,NULL,'NGC 3837',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84218,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84218,35.26,0.07,113,34369,70,NULL,NULL,'NGC 3837',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84219,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84219,35.26,0.07,113,34370,70,NULL,NULL,'2MASX J11435748+2018023',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00004,NULL,'15.52',0.21,'S0',NULL,NULL,NULL,NULL,1,175.9894583,20.30058,0,NULL,61083433071,954428641,14912947,15.52),(84220,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84220,37.44,0.33,307,34371,70,NULL,NULL,'2MASX J11435831+1227388',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,175.992917,12.46075,0.091,NULL,60242674278,941291785,14707684,18.2),(84221,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84221,38.26,0.14,450,34372,70,NULL,NULL,'SDSS J114358.50+055106.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000138,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,175.9937917,5.85181,0.011,NULL,60152124873,939876951,14685577,18.4),(84222,'IRAS','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84222,35.09,0.8,104,34373,75,NULL,'HMCL, I','NGC 3840',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000007,NULL,'14.54',0.8,'Sa             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,175.995667,20.07703,0,NULL,61083350793,954427356,14912927,14.54),(84223,'IRAS','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84223,35.09,0.8,104,34373,75,NULL,'W91CL, r','NGC 3840',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84224,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84224,34.62,0.38,83.8,34373,75,NULL,'W91CL, r, raw','NGC 3840',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84225,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84225,34.76,0.38,89.4,34373,75,NULL,'W91CL, r, inv','NGC 3840',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84226,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84226,34.83,0.4,92.6,34373,75,NULL,'HMCL, I, raw','NGC 3840',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84227,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84227,34.86,0.38,93.6,34373,75,NULL,'W91CL, r, cor','NGC 3840',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84228,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84228,34.94,0.07,97.5,34373,NULL,NULL,NULL,'NGC 3840',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84229,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84229,35.05,0.4,102,34373,75,NULL,'HMCL, I, cor','NGC 3840',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84230,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84230,35.05,0.4,103,34373,75,NULL,'HMCL, I, inv','NGC 3840',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84231,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84231,38.02,0.46,402,34374,70,NULL,NULL,'SDSS J114359.66+324026.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,175.998625,32.67406,0,NULL,60631858711,947372792,14802699,18),(84232,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84232,37.34,0.23,294,34375,70,NULL,NULL,'2MASX J11440004+6004478',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,176.0005,60.08,0,NULL,61854086190,966470096,15101095,17.1),(84233,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84233,38.78,0.33,569,34376,70,NULL,NULL,'2MASX J11440017+4513524',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000223,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,176.000833,45.23119,0,NULL,63888980250,998265316,15597895,17.9),(84234,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84234,38.71,0.33,552,34377,70,NULL,NULL,'SDSS J114400.57+095416.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000146,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,176.002375,9.90467,0.109,NULL,60380627958,943447311,14741364,18.6),(84235,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84235,34.79,0.09,91,34378,NULL,NULL,NULL,'KUG 1141+200',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.00005,NULL,'15.54',0.3,'Irr','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,176.008083333,19.78444,0,NULL,61079427559,954366055,14911969,15.54),(84236,'BCG','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84236,35.31,0.35,113,34379,60,NULL,'ABELL 1367, BCG','NGC 3842',0.0205,'1980ApJ...241..486H',1980,1,1.4,NULL,'G',0.000031,NULL,'12.78',1,'E;BrClG','in a radial-velocity based grouping',NULL,NULL,NULL,1,176.0089583,19.94981,0,NULL,61083297092,954426517,14912914,12.78),(84237,'D-Sigma','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84237,34.62,0.4,83.8,34379,75,NULL,'Edat, raw','NGC 3842',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84238,'D-Sigma','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84238,34.8,0.4,91.3,34379,75,NULL,'Edat, cor','NGC 3842',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84239,'D-Sigma','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84239,34.94,0.18,97.1,34379,72,NULL,'ABELL 1367 Cluster, 6','NGC 3842',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84240,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84240,35.1,0.23,105,34379,74.4,NULL,NULL,'NGC 3842',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84241,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84241,35.26,0.07,113,34379,70,NULL,NULL,'NGC 3842',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84242,'Magnitude','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84242,35.12,NULL,106,34379,NULL,NULL,'ABELL 1367 CLUSTER','NGC 3842',NULL,'1995A&A...302...21G',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84243,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84243,34.71,NULL,87.5,34379,77,NULL,'BRIK, ABELL 1367 cluster, 20 galaxies','NGC 3842',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84244,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84244,34.71,0.36,87.5,34379,77,NULL,'ABELL 1367, 20 galaxies','NGC 3842',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84245,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84245,34.84,0.04,92.8,34379,75,NULL,'ABELL 1367 CLUSTER','NGC 3842',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84246,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84246,34.86,0.11,93.9,34379,74.4,NULL,'ABELL 1367, 22 galaxies, WISE I-band','NGC 3842',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84247,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84247,34.92,0.14,96.4,34379,75,NULL,'ABELL 1367 cluster, avg. of 19 spiral galaxies','NGC 3842',NULL,'2013ApJ...765...94S',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84248,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84248,34.94,0.1,97.3,34379,75,NULL,'ABELL 1367 cluster, avg. of 19 spiral galaxies','NGC 3842',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84249,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84249,34.95,0.11,97.5,34379,74.4,NULL,'ABELL 1367, 22 galaxies, WISE W2 (4.6 micro-meter), color corrected','NGC 3842',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84250,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84250,34.96,0.11,98.1,34379,74.4,NULL,'ABELL 1367, 22 galaxies, WISE W1 (3.4 micro-meter), color corrected','NGC 3842',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84251,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84251,34.99,0.13,99.5,34379,70,NULL,'ABELL 1367 Cluster','NGC 3842',NULL,'1992ApJ...396..453H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84252,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84252,35,0.4,99.8,34379,NULL,NULL,'mean','NGC 3842',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84253,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84253,35,0.45,100,34379,NULL,NULL,'K','NGC 3842',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84254,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84254,35.02,0.06,101,34379,74.4,NULL,'ABELL 1367, 22 galaxies, WISE W2 (4.6 micro-meter), curved','NGC 3842',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84255,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84255,35.02,0.06,101,34379,74.4,NULL,'ABELL 1367, 22 galaxies, WISE W1 (3.4 micro-meter), curved','NGC 3842',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84256,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84256,35.02,0.23,101,34380,74.4,NULL,NULL,'NGC 3841',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000022,NULL,'14.59',0.7,'E','Group member',NULL,NULL,NULL,1,176.0089583,19.97189,0,NULL,61083298917,954426545,14912914,14.59),(84257,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84257,35.26,0.07,113,34380,70,NULL,NULL,'NGC 3841',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84258,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84258,35,0.4,99.8,34380,NULL,NULL,'mean','NGC 3841',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84259,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84259,35.49,0.45,126,34380,NULL,NULL,'K','NGC 3841',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84260,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84260,37.87,0.46,375,34381,70,NULL,NULL,'2MASX J11440304+6323218',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,176.012917,63.38953,0.065,NULL,61818270890,965910482,15092351,17.4),(84261,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84261,38.26,0.14,450,34382,70,NULL,NULL,'2MASX J11440319+0547440',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000147,NULL,'17.6g',0.19,'AGN',NULL,NULL,NULL,NULL,1,176.0132917,5.79558,0.011,NULL,60152137214,939877143,14685580,17.6),(84262,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84262,35.26,0.07,113,34383,70,NULL,NULL,'CGCG 097-094',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000043,NULL,'15.7',0.2,'E','Group member',NULL,NULL,NULL,1,176.013375,19.80108,0,NULL,61079427459,954366054,14911969,15.7);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (84263,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84263,38.26,0.14,450,34384,70,NULL,NULL,'2MASX J11440366+0543270',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000175,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,176.015375,5.72431,0.011,NULL,60152116129,939876814,14685575,17.2),(84264,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84264,37.66,0.46,341,34385,70,NULL,NULL,'2MASX J11440480+1739018',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.80',0.11,NULL,NULL,NULL,NULL,NULL,1,176.020167,17.65058,0.019,NULL,60204641223,940697519,14698398,18.8),(84265,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84265,33,0.4,39.9,34386,NULL,NULL,'mean','NGC 3835',NULL,'2007A&A...465...71T',2007,1,0.82,NULL,'G',0.000037,NULL,'13.1g',0.72,'Sab: sp','Group member',NULL,NULL,NULL,1,176.020417,60.11978,0,NULL,61854074170,966469908,15101092,13.1),(84266,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84266,33.04,0.41,40.6,34386,NULL,NULL,'Malmquist cor.','NGC 3835',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84267,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84267,33.13,0.4,42.2,34386,NULL,NULL,NULL,'NGC 3835',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84268,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84268,33.28,0.2,45.3,34386,74.4,NULL,NULL,'NGC 3835',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84269,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84269,33.41,0.47,48,34386,NULL,NULL,'H','NGC 3835',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84270,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84270,33.44,0.46,48.7,34386,NULL,NULL,'J','NGC 3835',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84271,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84271,33.45,0.45,48.9,34386,NULL,NULL,'K','NGC 3835',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84272,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84272,33.49,0.43,49.9,34386,75,NULL,'3.6 micron, color corrected','NGC 3835',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84273,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84273,33.65,0.43,53.7,34386,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3835',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84274,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84274,38.14,0.46,425,34387,70,NULL,NULL,'2MASX J11440487+2806075',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000144,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,176.0204583,28.10206,0.05,NULL,60596288463,946817007,14794015,17.8),(84275,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84275,37.35,0.46,295,34388,70,NULL,NULL,'2MASX J11440510+2718155',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.62',0.14,NULL,NULL,NULL,NULL,NULL,1,176.021333,27.30433,0.049,NULL,60596872946,946826139,14794158,18.62),(84276,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84276,36.05,0.46,162,34389,70,NULL,NULL,'CGCG 157-027',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.000093,NULL,'14.9g',0.58,'S0',NULL,NULL,NULL,NULL,1,176.023,29.87314,0.018,NULL,60556558622,946196228,14784316,14.9),(84277,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84277,37.51,0.46,318,34390,70,NULL,NULL,'2MASX J11440555+0324460',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,176.023125,3.41286,0.013,NULL,60196067914,940563561,14696305,17.1),(84278,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84278,35.26,0.07,113,34391,70,NULL,NULL,'2MASX J11440573+2014533',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00006,NULL,'16.15',0.17,'S0',NULL,NULL,NULL,NULL,1,176.024,20.24819,0,NULL,61083421681,954428463,14912944,16.15),(84279,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84279,35.26,0.63,113,34392,70,NULL,NULL,'2MASX J11440669-0914235',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.33',0.4,NULL,NULL,NULL,NULL,NULL,1,176.02775,-9.23989,0.025,NULL,41036841587,641200649,10018760,16.33),(84280,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84280,38.26,0.14,450,34393,70,NULL,NULL,'2MASX J11440681+0547530',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000198,NULL,'16.0g',0.53,'BrClG',NULL,NULL,NULL,NULL,1,176.028416667,5.79819,0.011,NULL,60152139608,939877181,14685580,16),(84281,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84281,37.05,0.46,257,34394,70,NULL,NULL,'2MASX J11440749+1551258',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,176.031125,15.85717,0.063,NULL,60260086138,941563845,14711935,17.2),(84282,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84282,35.26,0.07,113,34395,70,NULL,NULL,'CGCG 097-099',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000025,NULL,'15.7',0.2,'E','Group member',NULL,NULL,NULL,1,176.031875,19.73753,0,NULL,61079426254,954366035,14911969,15.7),(84283,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84283,38.99,0.46,628,34396,70,NULL,NULL,'SDSS J114408.09+110202.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00016,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,176.0337083,11.03406,0.106,NULL,60371648845,943307013,14739172,18.6),(84284,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84284,37.53,0.46,320,34397,70,NULL,NULL,'2MASX J11440849+3150021',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00015,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,176.035458333,31.83403,0.028,NULL,60629795177,947340549,14802196,17.3),(84285,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84285,38.97,0.46,622,34398,70,NULL,NULL,'2MASX J11440858+2316183',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,176.03575,23.27175,0.016,NULL,60542549085,945977329,14780895,18),(84286,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84286,34.16,0.56,68,34399,70,NULL,NULL,'2MASX J11440894-4921189',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,176.037375,-49.35531,0.505,NULL,40009557260,625149332,9767958,14.6),(84287,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84287,35.76,0.15,142,34400,70,NULL,NULL,'2MASX J11440934+3328561',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000103,NULL,'15.8g',0.45,NULL,NULL,NULL,NULL,NULL,1,176.03875,33.48228,0,NULL,60631677257,947369957,14802655,15.8),(84288,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84288,37.93,0.46,385,34401,70,NULL,NULL,'SDSS J114410.68+010205.7',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000077,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,176.0445417,1.03492,0.061,NULL,60141422465,939709726,14682964,17.7),(84289,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84289,37.5,0.19,316,34402,70,NULL,NULL,'2MASX J11441091+3050291',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000123,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,176.045667,30.84147,0.021,NULL,60555473938,946179280,14784051,17.6),(84290,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84290,36.63,0.46,212,34403,70,NULL,NULL,'2MASX J11441123+3830165',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.42',0.37,NULL,NULL,NULL,NULL,NULL,1,176.046875,38.50444,0.039,NULL,60464300642,944754697,14761792,16.42),(84291,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84291,37.52,0.46,319,34404,70,NULL,NULL,'2MASX J11441154+5433594',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000188,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,176.048167,54.56664,0,NULL,61772424323,965194130,15081158,16.5),(84292,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84292,37.55,0.46,324,34405,70,NULL,NULL,'2MASX J11441178-0151561',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000206,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,176.0489583,-1.86567,0.037,NULL,40863524036,638492563,9976446,17.1),(84293,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84293,38.6,0.46,524,34406,70,NULL,NULL,'2MASX J11441259+5701431',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,176.052166667,57.02869,0,NULL,61979044240,968422566,15131602,17.8),(84294,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84294,35.76,0.15,142,34407,70,NULL,NULL,'NGC 3847',NULL,'2015arXiv151105856S',2015,1,1.12,'Identification as NGC 3856 is not certain.','G',0.000063,NULL,'14.0g',0.92,'E','Group member',NULL,NULL,NULL,1,176.0582083,33.51453,0,NULL,60631678509,947369976,14802655,14),(84295,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84295,37.68,0.46,343,34408,70,NULL,NULL,'2MASX J11441469+6208367',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,176.0610417,62.14356,0.017,NULL,61865396890,966646826,15103856,17.8),(84296,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84296,32.01,0.4,25.3,34409,75,NULL,'B','NGC 3846A',NULL,'1988NBGC.C....0000T',1988,1,1.22,NULL,'G',0.00002,NULL,'14.6g',0.67,'SB(s)m:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,176.06175,55.03497,0,NULL,61758374502,964974601,15077728,14.6),(84297,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84297,38.45,0.46,489,34410,70,NULL,NULL,'2MASX J11441529+1114092',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00017,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,176.0637083,11.23597,0.03,NULL,60371160094,943299376,14739052,17.3),(84298,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84298,37.91,0.46,382,34411,70,NULL,NULL,'2MASX J11441546+4803041',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000194,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,176.0642083,48.05106,0.024,NULL,61754494275,964913973,15076780,17),(84299,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84299,37.84,0.46,370,34412,70,NULL,NULL,'2MASX J11441576+4219205',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,176.065875,42.32256,0.022,NULL,60412776302,943949629,14749212,17.8),(84300,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84300,37.45,0.21,309,34413,70,NULL,NULL,'SDSS J114415.84+074225.2',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00018,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,176.0660417,7.707,0,NULL,60374583731,943352870,14739888,17.8),(84301,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84301,37.96,0.46,391,34414,70,NULL,NULL,'2MASXi J1144168-005545',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000061,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,176.070083,-0.92922,0.033,NULL,40810347896,637661685,9963463,17.9),(84302,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84302,37.5,0.19,316,34415,70,NULL,NULL,'2MASX J11441690+3054530',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000097,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,176.070333,30.91464,0.021,NULL,60555469457,946179210,14784050,17.1),(84303,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84303,39.34,0.46,737,34416,70,NULL,NULL,'SDSS J114416.95+092904.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000168,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,176.070667,9.48458,0.052,NULL,60381165838,943455716,14741495,18.5),(84304,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84304,33.72,0.69,55.5,34417,100,NULL,'mid-IR','CGCG 097-102 NED02',NULL,'2013ApJ...771...88L',2013,1,0.3,'The position in 2000MNRAS.312..442S is 9 arcsec south of the optical center.','G',0.000047,NULL,'14.33',0.2,'Sa             PAS',NULL,NULL,NULL,NULL,1,176.071708333,20.22331,0,NULL,61083307233,954426675,14912916,14.33),(84305,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84305,36.28,0.46,180,34418,70,NULL,NULL,'2MASX J11441728+2134298',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00011,NULL,'15.6g',0.4,NULL,NULL,NULL,NULL,NULL,1,176.072041667,21.57503,0,NULL,61084547626,954446056,14913219,15.6),(84306,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84306,36.66,0.46,215,34419,70,NULL,NULL,'2MASX J11441758+4205135',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000175,NULL,'16.0g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,176.073167,42.08711,0,NULL,60413588188,943962315,14749411,16),(84307,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84307,38.28,0.15,454,34420,70,NULL,NULL,'2MASX J11441798-0143101',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000087,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,176.0747917,-1.71953,0.037,NULL,40863305453,638489147,9976392,17.3),(84308,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84308,36.42,0.73,192,34421,70,NULL,NULL,'ESO 571- G 020',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.38',0.6,'SB(rs)b',NULL,NULL,NULL,NULL,1,176.075125,-18.20114,0.085,NULL,40948858353,639825911,9997279,15.38),(84309,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84309,37.71,0.46,349,34422,70,NULL,NULL,'SDSS J114418.67+075024.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,176.077833,7.84025,0,NULL,60374879134,943357486,14739960,18.3),(84310,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84310,36.9,0.46,240,34423,70,NULL,NULL,'MCG +09-19-166',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00018,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,176.0805417,53.69686,0,NULL,61772989874,965202966,15081296,16.2),(84311,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84311,37.04,0.46,256,34424,70,NULL,NULL,'2MASX J11442027+0351103',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00014,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,176.084375,3.85292,0.017,NULL,60196553151,940571142,14696424,16.9),(84312,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84312,37.78,0.46,360,34425,70,NULL,NULL,'2MASX J11442026+4259035',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000159,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,176.0844583,42.98431,0,NULL,63889762803,998277543,15598086,17.8),(84313,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84313,35.26,0.07,113,34426,70,NULL,NULL,'NGC 3851',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000025,NULL,'15.1',0.2,'E/S0','Group member',NULL,NULL,NULL,1,176.085083,19.98086,0,NULL,61083302655,954426603,14912915,15.1),(84314,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84314,35.33,0.25,116,34426,74.4,NULL,NULL,'NGC 3851',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84315,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84315,37.5,0.19,316,34427,70,NULL,NULL,'2MASX J11442084+3054282',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.0002,NULL,'17.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,176.086833,30.90781,0.021,NULL,60555471204,946179237,14784050,17),(84316,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84316,36.33,0.33,185,34428,70,NULL,NULL,'LCRS B114148.0-025634',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000097,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,176.089416667,-3.22017,0.053,NULL,40868989573,638577962,9977780,16.3),(84317,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84317,36.33,0.33,185,34429,70,NULL,NULL,'CGCG 012-069',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000147,NULL,'15.9g',0.3,'E0',NULL,NULL,NULL,NULL,1,176.090583333,-3.18406,0.053,NULL,40868987331,638577927,9977780,15.9),(84318,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84318,35.26,0.07,113,34430,70,NULL,NULL,'2MASX J11442218+1946278',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00004,NULL,'16.57',0.24,'E','Group member',NULL,NULL,NULL,1,176.092583333,19.7745,0,NULL,61079434763,954366168,14911971,16.57),(84319,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84319,36.2,0.46,174,34431,70,NULL,NULL,'2MASX J11442228+1508168',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000117,NULL,'15.9g',0.43,NULL,NULL,NULL,NULL,NULL,1,176.09275,15.13803,0.088,NULL,60263721402,941620646,14712822,15.9),(84320,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84320,37.71,0.27,348,34432,70,NULL,NULL,'2MASX J11442256-0159136',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,176.093916667,-1.98697,0.037,NULL,40863472371,638491755,9976433,17.3),(84321,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84321,37,0.46,251,34433,70,NULL,NULL,'2MASX J11442280+3551402',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00018,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,176.095167,35.86111,0,NULL,60442605246,944415706,14756495,16.5),(84322,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84322,38.28,0.15,454,34434,70,NULL,NULL,'2MASX J11442336-0151046',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000174,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,176.09725,-1.85128,0.037,NULL,40863491486,638492054,9976438,16.8),(84323,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84323,38.26,0.14,450,34435,70,NULL,NULL,'SDSS J114423.34+054515.9',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,176.09725,5.75442,0.011,NULL,60152325309,939880082,14685626,17.9),(84324,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84324,38.43,0.46,485,34436,70,NULL,NULL,'SDSS J114424.49+074407.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000142,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,176.102083,7.73531,0,NULL,60374470481,943351101,14739860,18.3),(84325,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84325,37.07,0.46,259,34437,70,NULL,NULL,'2MASX J11442458+1502417',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000171,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,176.102375,15.04511,0.089,NULL,60263678439,941619975,14712812,17.5),(84326,'BCG','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84326,38.04,0.35,377,34438,60,NULL,NULL,'ABELL 1365',0.0763,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,176.103,30.90575,0.021,NULL,60555471857,946179247,14784050,NULL),(84327,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84327,31.15,0.4,17,34439,75,NULL,'B','UGC 06713',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.00002,NULL,'15.0',1.1,'Sm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,176.104041667,48.83519,0.008,NULL,61753093307,964892082,15076438,15),(84328,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84328,35.26,0.07,113,34440,70,NULL,NULL,'CGCG 097-110',NULL,'2015arXiv151105856S',2015,1,0.6,'Geller et al. (2006AJ....132.2243G) give v = 5367 km/sec.','G',0.000047,NULL,'15.5',0.17,'S0','Group member',NULL,NULL,NULL,1,176.1047083,19.82808,0,NULL,61079423707,954365995,14911968,15.5),(84329,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84329,37.9,0.27,381,34441,70,NULL,NULL,'2MASX J11442553+0434393',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,176.1065,4.57756,0.028,NULL,60193980521,940530945,14695796,17.2),(84330,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84330,35.52,0.38,127,34442,NULL,NULL,'Malmquist cor.','ESO 440- G 001',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.31',0.5,'S?',NULL,NULL,NULL,NULL,1,176.107875,-28.46211,0.329,NULL,41457795241,647778050,10121532,15.31),(84331,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84331,35.69,0.35,138,34442,NULL,NULL,NULL,'ESO 440- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84332,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84332,35.73,0.2,140,34442,74.4,NULL,NULL,'ESO 440- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84333,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84333,37.71,0.27,348,34443,70,NULL,NULL,'2MASX J11442603-0157256',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000195,NULL,'16.1g',0.37,'BrClG          AGN',NULL,NULL,NULL,NULL,1,176.108375,-1.95708,0.037,NULL,40863470395,638491724,9976433,16.1),(84334,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84334,37.2,0.46,275,34444,70,NULL,NULL,'2MASX J11442597+3849225',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,176.1085,38.82281,0.014,NULL,60453848493,944591382,14759240,17.7),(84335,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84335,38.06,0.46,409,34445,70,NULL,NULL,'2MASX J11442664+0711262',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,176.1109583,7.19056,0,NULL,60153113753,939892402,14685818,17.7),(84336,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84336,38.69,0.33,548,34446,70,NULL,NULL,'2MASX J11442713+2350528',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000172,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,176.113167,23.848,0.05,NULL,60542014841,945968981,14780765,17.8),(84337,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84337,35.76,0.15,142,34447,70,NULL,NULL,'CGCG 186-034',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000097,NULL,'14.6g',0.8,NULL,NULL,NULL,NULL,NULL,1,176.113167,32.67658,0.007,NULL,60631847636,947372619,14802697,14.6),(84338,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84338,37.86,0.33,372,34448,70,NULL,NULL,'2MASX J11442785+0722422',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,176.116167,7.3785,0,NULL,60153089116,939892017,14685812,17.6),(84339,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84339,33.54,0.46,51.1,34449,70,NULL,NULL,'NGC 3853',NULL,'2015arXiv151105856S',2015,1,1.7,NULL,'G',0.000043,NULL,'13.41',1,'E','Possible field galaxy',NULL,NULL,NULL,1,176.1180417,16.55811,0.061,NULL,60258461677,941538463,14711538,13.41),(84340,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84340,33.57,0.4,51.8,34449,NULL,NULL,'mean','NGC 3853',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84341,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84341,33.77,0.45,56.7,34449,NULL,NULL,'K','NGC 3853',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84342,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84342,38.26,0.14,450,34450,70,NULL,NULL,'SDSS J114428.37+054634.0',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,176.1182083,5.77611,0,NULL,60152325497,939880085,14685626,17.8),(84343,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84343,38.28,0.15,454,34451,70,NULL,NULL,'2MASX J11442850-0150076',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000175,NULL,'17.1g',0.23,'BrClG',NULL,NULL,NULL,NULL,1,176.118833,-1.83539,0.037,NULL,40863484117,638491939,9976436,17.1),(84344,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84344,34.72,0.49,87.9,34452,75,NULL,'IR','IC 0727',NULL,'2011yCatp016004901K',2011,1,2.44,NULL,'G',0.000002,NULL,'14.8g',0.31,'Sb',NULL,NULL,NULL,NULL,1,176.119167,10.78381,0.106,NULL,60371737065,943308391,14739193,14.8),(84345,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84345,34.83,0.4,92.5,34452,NULL,NULL,'mean','IC 0727',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84346,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84346,34.88,0.29,94.8,34452,NULL,NULL,'Malmquist cor.','IC 0727',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84347,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84347,34.99,0.47,99.5,34452,NULL,NULL,'H','IC 0727',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84348,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84348,35.06,0.46,103,34452,NULL,NULL,'J','IC 0727',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84349,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84349,35.11,0.45,105,34452,NULL,NULL,'K','IC 0727',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84350,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84350,35.22,0.25,111,34452,NULL,NULL,NULL,'IC 0727',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84351,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84351,35.26,0.2,113,34452,74.4,NULL,NULL,'IC 0727',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84352,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84352,35.29,NULL,114,34452,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 0727',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84353,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84353,35.29,NULL,114,34452,NULL,NULL,'Dipole + Quadrupole','IC 0727',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84354,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84354,35.31,NULL,115,34452,NULL,NULL,'Dipole','IC 0727',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84355,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84355,38.26,0.14,450,34453,70,NULL,NULL,'SDSS J114428.70+054942.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000143,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,176.119625,5.82839,0.011,NULL,60152332681,939880198,14685628,18.5),(84356,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84356,38.32,0.27,461,34454,70,NULL,NULL,'2MASX J11442878+0626186',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000155,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,176.119875,6.43858,0.034,NULL,60154677997,939916843,14686200,17.4),(84357,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84357,38.28,0.15,454,34455,70,NULL,NULL,'SDSS J114428.86-015035.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000075,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,176.1202917,-1.84311,0.037,NULL,40863495192,638492112,9976439,18.2),(84358,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84358,37.02,0.46,254,34456,70,NULL,NULL,'SDSS J114428.96+511143.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,176.120666667,51.19553,0,NULL,61802233128,965659892,15088435,17.9),(84359,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84359,37.27,0.46,284,34457,70,NULL,NULL,'2MASX J11442920+5606373',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000179,NULL,'17.0g',0.23,'S0','Group member',NULL,NULL,NULL,1,176.1215,56.11044,0,NULL,61977601995,968400031,15131250,17),(84360,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84360,37.78,0.46,360,34458,70,NULL,NULL,'SDSS J114429.44+044645.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000138,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,176.122667,4.77931,0,NULL,60182610094,940353282,14693020,18),(84361,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84361,35.8,0.51,145,34459,70,NULL,NULL,'2MASX J11442957-4353206',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,176.123167,-43.88914,0.449,NULL,41877960648,654343135,10224111,16.7),(84362,'Tully est','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84362,32.96,0.8,39.1,34460,75,NULL,'B','UGC 06711',NULL,'1988NBGC.C....0000T',1988,1,0.8,NULL,'G',0.00003,NULL,'14.2',0.5,'S?','in a radial-velocity based grouping',NULL,NULL,NULL,1,176.123916667,69.72981,0,NULL,61340755363,958449302,14975770,14.2),(84363,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84363,37.45,0.21,309,34461,70,NULL,NULL,'2MASX J11442983+0744166',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000169,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,176.124125,7.73789,0,NULL,60374469349,943351083,14739860,16.5),(84364,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84364,37.38,0.46,300,34462,70,NULL,NULL,'2MASX J11442995+6031213',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,176.124917,60.5225,0.013,NULL,61846472614,966351134,15099236,17.9),(84365,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84365,37.45,0.21,309,34463,70,NULL,NULL,'2MASX J11443023+0736156',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000181,NULL,'16.1g',0.4,'AGN',NULL,NULL,NULL,NULL,1,176.1260417,7.60436,0,NULL,60374503164,943351611,14739868,16.1),(84366,'BCG','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84366,38.04,0.35,377,34464,60,NULL,'ABELL 1365, BCG','2MASX J11443048+3053003',0.0763,'1980ApJ...241..486H',1980,1,0.52,NULL,'G',0.000083,NULL,'16.1g',0.39,NULL,'Brightest group member',NULL,NULL,NULL,1,176.127208333,30.88339,0.021,NULL,60555473583,946179274,14784051,16.1),(84367,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84367,37.5,0.19,316,34464,70,NULL,NULL,'2MASX J11443048+3053003',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84368,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84368,38.41,0.46,481,34465,70,NULL,NULL,'SDSS J114430.74+065826.6',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,176.128125,6.97408,0,NULL,60154084619,939907572,14686055,17.6),(84369,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84369,35.58,0.46,131,34466,70,NULL,NULL,'MCG +09-19-170',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000163,NULL,'15.8g',0.37,'S0',NULL,NULL,NULL,NULL,1,176.129667,53.68278,0,NULL,61772990027,965202969,15081296,15.8),(84370,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84370,38.14,0.46,425,34467,70,NULL,NULL,'2MASX J11443192+4903371',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,176.132917,49.06028,0,NULL,61753773062,964902704,15076604,18),(84371,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84371,35.76,0.15,142,34468,70,NULL,NULL,'2MASX J11443206+3322033',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000173,NULL,'16.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,176.133541667,33.36761,0,NULL,60631410263,947365785,14802590,16.4),(84372,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84372,36.76,0.46,225,34469,70,NULL,NULL,'2MASX J11443213+2306528',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000107,NULL,'15.5g',0.57,NULL,NULL,NULL,NULL,NULL,1,176.133833333,23.11483,0.023,NULL,60541825953,945966030,14780719,15.5),(84373,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84373,37.09,0.46,261,34470,70,NULL,NULL,'2MASX J11443213+1847428',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.32',0.15,NULL,NULL,NULL,NULL,NULL,1,176.1340417,18.79517,0,NULL,60203371503,940677679,14698088,18.32),(84374,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84374,38.14,0.33,425,34471,70,NULL,NULL,'2MASX J11443217+0833336',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000191,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,176.134083,8.55931,0.02,NULL,60378679466,943416866,14740888,17.4),(84375,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84375,37.71,0.27,348,34472,70,NULL,NULL,'2MASX J11443230-0158396',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000055,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,176.13475,-1.97758,0.037,NULL,40863441391,638491271,9976426,17.6),(84376,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84376,38.32,0.27,461,34473,70,NULL,NULL,'SDSS J114432.66+062525.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000144,NULL,'18.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,176.136083,6.42367,0.034,NULL,60154676551,939916821,14686200,18.4),(84377,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84377,38.26,0.14,450,34474,70,NULL,NULL,'SDSS J114432.84+055045.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000153,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,176.136875,5.846,0.011,NULL,60152332611,939880197,14685628,18.7),(84378,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84378,37.35,0.46,295,34475,70,NULL,NULL,'2MASX J11443290+3047593',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000083,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,176.137,30.79994,0.021,NULL,60555430493,946178601,14784040,16.6),(84379,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84379,36.43,0.46,193,34476,70,NULL,NULL,'2MASX J11443293+2920556',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000154,NULL,'16.4g',0.27,'E',NULL,NULL,NULL,NULL,1,176.137375,29.34875,0.038,NULL,60554641860,946166279,14783848,16.4),(84380,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84380,35.33,0.33,116,34477,70,NULL,NULL,'2MASX J11443300+2631216',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000103,NULL,'16.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,176.137583333,26.52272,0.048,NULL,60595930672,946811416,14793928,16.3),(84381,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84381,38.26,0.14,450,34478,70,NULL,NULL,'SDSS J114433.10+055113.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,176.1379583,5.85369,0.011,NULL,60152335716,939880245,14685628,18.5),(84382,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84382,37.34,0.46,294,34479,70,NULL,NULL,'2MASX J11443322+6246073',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000171,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,176.1385417,62.76867,0.021,NULL,61865699774,966651558,15103930,16.7),(84383,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84383,37.24,0.21,281,34480,70,NULL,NULL,'2MASX J11443362+2128158',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000178,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,176.140083333,21.47097,0,NULL,61084408011,954443875,14913185,17.9),(84384,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84384,38.05,0.33,407,34481,70,NULL,NULL,'2MASX J11443404-0108206',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000114,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,176.141875,-1.13908,0.053,NULL,40810136688,637658385,9963412,16.6),(84385,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84385,36.35,0.46,186,34482,70,NULL,NULL,'2MASX J11443450+5820453',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,176.1435,58.34592,0,NULL,61843813936,966309592,15098587,17.2),(84386,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84386,38.32,0.27,461,34483,70,NULL,NULL,'2MASX J11443495+0624006',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000201,NULL,'16.8g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,176.145375,6.40019,0,NULL,60154546670,939914791,14686168,16.8),(84387,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84387,37.86,0.46,374,34484,70,NULL,NULL,'SDSS J114434.97+024528.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00007,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,176.14575,2.75789,0.033,NULL,60185541195,940399081,14693735,18.6),(84388,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84388,36.8,0.33,229,34485,70,NULL,NULL,'SDSS J114435.34+535626.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000169,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,176.1472917,53.94072,0,NULL,61773480728,965210636,15081416,18.1),(84389,'BCG','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84389,35.31,0.35,113,34486,60,NULL,NULL,'ABELL 1367',0.0205,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III:[BM]',NULL,NULL,NULL,NULL,1,176.152083,19.75889,0,NULL,61078573790,954352715,14911761,NULL),(84390,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84390,37.45,0.21,309,34487,70,NULL,NULL,'2MASX J11443656+0755216',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000189,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,176.15225,7.92267,0,NULL,60374889289,943357645,14739963,17.2),(84391,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84391,37.86,0.46,373,34488,70,NULL,NULL,'SDSS J114436.58+043729.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,176.1524583,4.62481,0.012,NULL,60193918437,940529975,14695780,18.1),(84392,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84392,33.64,0.2,53.5,34489,74.4,NULL,NULL,'CGCG 068-052',NULL,'2013AJ....146...86T',2013,1,1.09,NULL,'G',0.000037,NULL,'15.9g',0.25,'I?',NULL,NULL,NULL,NULL,1,176.15325,10.787,0.114,NULL,60371607872,943306373,14739162,15.9),(84393,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84393,34.04,0.49,64.1,34490,75,NULL,'IR','CGCG 068-052',NULL,'2011yCatp016004901K',2011,1,1.09,NULL,'G',0.000037,NULL,'15.9g',0.25,'I?',NULL,NULL,NULL,NULL,1,176.15325,10.787,0.114,NULL,60371607872,943306373,14739162,15.9),(84394,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84394,37.86,0.33,372,34491,70,NULL,NULL,'2MASX J11443891+0720526',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000168,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,176.1620417,7.34783,0,NULL,60153098664,939892166,14685815,16.9),(84395,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84395,34.78,0.55,90.2,34492,70,NULL,NULL,'2MASX J11443922-1856111',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.57',0.3,NULL,NULL,NULL,NULL,NULL,1,176.163417,-18.93664,0.085,NULL,40946492359,639788943,9996702,15.57),(84396,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84396,37.55,0.46,323,34493,70,NULL,NULL,'2MASX J11444098-0057126',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000084,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,176.170625,-0.9535,0.053,NULL,40810556521,637664945,9963514,16.7),(84397,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84397,38.26,0.14,450,34494,70,NULL,NULL,'SDSS J114441.07+055056.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000146,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,176.171125,5.84917,0,NULL,60152333762,939880215,14685628,18.5),(84398,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84398,37.98,0.46,394,34495,70,NULL,NULL,'2MASX J11444104+1353507',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000176,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,176.171125,13.89756,0.121,NULL,60248999620,941390619,14709228,17.9),(84399,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84399,38.69,0.33,548,34496,70,NULL,NULL,'2MASX J11444134+2349108',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000167,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,176.1722917,23.81967,0.046,NULL,60542023644,945969119,14780767,18),(84400,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84400,38.05,0.46,408,34497,70,NULL,NULL,'2MASX J11444160+5952083',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000147,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,176.1732917,59.86903,0,NULL,61856898123,966514033,15101781,17.4),(84401,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84401,37.5,0.19,316,34498,70,NULL,NULL,'SDSS J114442.52+304825.9',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000175,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,176.1772083,30.80722,0.027,NULL,60555441798,946178778,14784043,18.3),(84402,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84402,37.58,0.19,329,34499,70,NULL,NULL,'2MASX J11444263+0939226',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,176.1775,9.65619,0.052,NULL,60381098377,943454662,14741479,17.3),(84403,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84403,37.45,0.21,309,34500,70,NULL,NULL,'2MASX J11444382+0726146',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,176.182625,7.43758,0,NULL,60153035771,939891183,14685799,17.3),(84404,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84404,38.19,0.46,435,34501,70,NULL,NULL,'SDSS J114444.20+472641.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,176.184167,47.44483,0.026,NULL,61753878406,964904350,15076630,18.1),(84405,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84405,37.18,0.46,273,34502,70,NULL,NULL,'2MASX J11444463+0039233',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000069,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,176.185875,0.6565,0.041,NULL,60141698265,939714035,14683031,17.3),(84406,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84406,38.29,0.46,455,34503,70,NULL,NULL,'SDSS J114445.64-005538.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000082,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,176.190167,-0.92744,0.053,NULL,40810563221,637665050,9963516,18.2),(84407,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84407,37.3,0.33,289,34504,70,NULL,NULL,'2MASX J11444627+2442467',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000185,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,176.192833,24.71292,0.049,NULL,60543486453,945991975,14781124,16.7),(84408,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84408,37.03,0.46,254,34505,70,NULL,NULL,'2MASX J11444636+2102169',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00016,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,176.193083,21.038,0,NULL,61084970806,954452668,14913322,16.6),(84409,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84409,38.74,0.33,560,34506,70,NULL,NULL,'SDSS J114446.61+035437.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,176.19425,3.91028,0.017,NULL,60196472215,940569878,14696404,18.1),(84410,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84410,35.26,0.07,113,34507,70,NULL,NULL,'CGCG 097-113',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000077,NULL,'15.6',0.25,'S0','Group member',NULL,NULL,NULL,1,176.1942917,19.75789,0,NULL,61078628611,954353572,14911774,15.6),(84411,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84411,33.79,0.69,57.2,34508,100,NULL,'mid-IR','UGC 06719',NULL,'2013ApJ...771...88L',2013,1,1.2,NULL,'G',0.00001,NULL,'14.44',0.8,'Sab            LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,176.196,20.12511,0,NULL,61083604299,954431317,14912989,14.44),(84412,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84412,35.04,0.4,102,34508,NULL,NULL,'mean','UGC 06719',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84413,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84413,35.13,0.47,106,34508,NULL,NULL,'H','UGC 06719',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84414,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84414,35.18,0.46,109,34508,NULL,NULL,'J','UGC 06719',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84415,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84415,35.18,0.07,109,34508,NULL,NULL,NULL,'UGC 06719',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84416,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84416,35.19,0.45,109,34508,NULL,NULL,'K','UGC 06719',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84417,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84417,35.26,0.07,113,34509,70,NULL,NULL,'CGCG 097-115',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000033,NULL,'15.4',0.2,'S0','Group member',NULL,NULL,NULL,1,176.1977083,19.87639,0,NULL,61078571603,954352681,14911760,15.4),(84418,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84418,35.26,0.07,113,34510,70,NULL,NULL,'2MASX J11444814+1934509',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000037,NULL,'16.01',0.24,NULL,NULL,NULL,NULL,NULL,1,176.200625,19.58094,0,NULL,61078588999,954352953,14911764,16.01),(84419,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84419,36.95,0.53,246,34511,70,NULL,NULL,'2MASX J11444834-0943266',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.31',NULL,NULL,NULL,NULL,NULL,NULL,1,176.2014583,-9.72411,0.037,NULL,41036910977,641201734,10018777,16.31),(84420,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84420,38.05,0.33,407,34512,70,NULL,NULL,'2MASX J11444838-0109306',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000094,NULL,'17.1g',0.26,'NLAGN',NULL,NULL,NULL,'Sy 2',1,176.201625,-1.15853,0.033,NULL,40810149885,637658591,9963415,17.1),(84421,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84421,38.74,0.33,560,34513,70,NULL,NULL,'SDSS J114448.48+034910.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000134,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,176.2020417,3.81958,0.017,NULL,60196596295,940571817,14696434,18.5),(84422,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84422,38.14,0.33,425,34514,70,NULL,NULL,'2MASX J11444890+0840566',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000146,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,176.20375,8.68225,0.047,NULL,60378829479,943419210,14740925,17.6),(84423,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84423,37.9,0.27,381,34515,70,NULL,NULL,'2MASX J11444918+0436262',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.0002,NULL,'16.0g',0.41,'E0',NULL,NULL,NULL,NULL,1,176.204958333,4.60722,0,NULL,60193929330,940530145,14695783,16),(84424,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84424,34.81,0.4,91.6,34516,NULL,NULL,'mean','NGC 3860',NULL,'2007A&A...465...71T',2007,1,1,'UZC has V = 6320 +- 45 km/sec.','G',0.000027,NULL,'14.22',0.5,'Sa             AGN','in a radial-velocity based grouping',NULL,NULL,NULL,1,176.204833,19.79503,0,NULL,61078574510,954352726,14911761,14.22),(84425,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84425,35.04,0.47,102,34516,NULL,NULL,'H','NGC 3860',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84426,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84426,35.07,0.45,103,34516,NULL,NULL,'K','NGC 3860',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84427,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84427,35.1,0.06,105,34516,NULL,NULL,NULL,'NGC 3860',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84428,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84428,35.11,0.46,105,34516,NULL,NULL,'J','NGC 3860',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84429,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84429,39.5,0.46,796,34517,70,NULL,NULL,'SDSS J114449.25+420449.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,176.2052083,42.0805,0,NULL,60413634360,943963036,14749422,18.6),(84430,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84430,34.89,0.45,95.2,34518,NULL,NULL,'Malmquist cor.','IC 0728',NULL,'2009ApJS..182..474S',2009,1,1.24,NULL,'G',0.000027,NULL,'14.4g',0.65,'SB(rs)b','Group member',NULL,NULL,NULL,1,176.2102917,-1.60133,0.033,NULL,40808205176,637628205,9962940,14.4),(84431,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84431,35.18,0.39,109,34518,NULL,NULL,NULL,'IC 0728',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84432,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84432,35.22,0.2,111,34518,74.4,NULL,NULL,'IC 0728',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84433,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84433,37.22,0.46,278,34519,70,NULL,NULL,'2MASX J11445131+5536323',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,176.2137083,55.60911,0,NULL,61758841657,964981900,15077842,17.2),(84434,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84434,38.28,0.15,454,34520,70,NULL,NULL,'2MASX J11445152-0148302',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000213,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,176.2147083,-1.80828,0.037,NULL,40808056075,637625876,9962904,18),(84435,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84435,37.97,0.23,392,34521,70,NULL,NULL,'2MASX J11445163+0506402',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000178,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,176.215083,5.11122,0,NULL,60182992586,940359259,14693113,16.7),(84436,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84436,37.45,0.46,310,34522,70,NULL,NULL,'2MASX J11445160+0646395',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00018,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,176.215083,6.77769,0,NULL,60154609308,939915770,14686183,16.4),(84437,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84437,37.9,0.27,381,34523,70,NULL,NULL,'2MASX J11445166+0434062',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000173,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,176.215375,4.56833,0.012,NULL,60193990275,940531098,14695798,17.6),(84438,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84438,34.07,0.49,65.1,34524,70,NULL,NULL,'NGC 3854',NULL,'2014MNRAS.445.2677S',2014,1,2,NULL,'G',0.00003,NULL,'13.0',1.5,'SAB(rs)b pec:  HII?','Group member',NULL,NULL,NULL,1,176.216875,-9.23328,0.021,NULL,41036997005,641203078,10018798,13),(84439,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84439,34.78,0.2,90.4,34525,74.4,NULL,NULL,'NGC 3859',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000021,NULL,'14.76',0.3,'Sb             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,176.217667,19.45419,0,NULL,61078682646,954354416,14911787,14.76),(84440,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84440,35.03,0.08,102,34525,NULL,NULL,NULL,'NGC 3859',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84441,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84441,35.59,0.46,131,34526,70,NULL,NULL,'2MASX J11445305+0056222',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000069,NULL,'16.1g',0.27,'S0',NULL,NULL,NULL,NULL,1,176.221,0.93964,0.065,NULL,60142122389,939720662,14683135,16.1),(84442,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84442,37.24,0.21,281,34527,70,NULL,NULL,'2MASX J11445299+2136529',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,176.221,21.61469,0,NULL,61084455397,954444615,14913197,17),(84443,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84443,38.11,0.46,419,34528,70,NULL,NULL,'2MASX J11445368+1303577',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000172,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,176.223667,13.06592,0.113,NULL,60241163701,941268182,14707315,18.6),(84444,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84444,37.77,0.46,358,34529,70,NULL,NULL,'SDSS J114453.82+022044.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000078,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,176.22425,2.34578,0.053,NULL,60186164369,940408818,14693887,18.1),(84445,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84445,35.4,0.49,120,34530,70,NULL,NULL,'ESO 266- G 020',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'14.99',0.7,'(R\'_2)SB(r)a',NULL,NULL,NULL,NULL,1,176.22575,-44.09886,0.501,NULL,41877914225,654342409,10224100,14.99),(84446,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84446,38.64,0.46,535,34531,70,NULL,NULL,'2MASX J11445513+5310341',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000172,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,176.229625,53.17608,0,NULL,61769956343,965155567,15080555,17.9),(84447,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84447,35.26,0.07,113,34532,70,NULL,NULL,'CGCG 097-123',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000043,NULL,'15.7',0.2,'E','Group member',NULL,NULL,NULL,1,176.232625,19.49381,0,NULL,61078670166,954354221,14911784,15.7),(84448,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84448,38.16,0.46,428,34533,70,NULL,NULL,'2MASX J11445610+0136032',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000087,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,176.23375,1.601,0.045,NULL,60140542084,939695970,14682749,17.7),(84449,'SNIa','2016-12-15 15:14:50','2016-12-16 11:19:59','1','PTF10acnz','N',84449,37.01,0.01,238,34534,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10acnz',0.0615,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84450,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84450,35.26,0.07,113,34535,70,NULL,NULL,'CGCG 097-124 NED01',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000053,NULL,'15.50',0.6,'S0','Group member',NULL,NULL,NULL,1,176.237333,19.73192,0,NULL,61078627752,954353558,14911774,15.5),(84451,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84451,37.98,0.46,395,34536,70,NULL,NULL,'2MASX J11445701+0003387',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000088,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,176.237667,0.06083,0.033,NULL,60139617412,939681522,14682523,17.3),(84452,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84452,38.08,0.33,413,34537,70,NULL,NULL,'SDSS J114457.26+073318.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000144,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,176.238583,7.55506,0,NULL,60153029629,939891087,14685798,18.2),(84453,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84453,37.84,0.46,370,34538,70,NULL,NULL,'2MASX J11445822+4401193',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000171,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,176.242583,44.02197,0,NULL,63890623341,998290989,15598296,17.7),(84454,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84454,37.48,0.46,314,34539,70,NULL,NULL,'2MASX J11445854+2409525',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000164,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,176.2437917,24.16458,0.052,NULL,60543949906,945999217,14781237,17.5),(84455,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84455,37.42,0.46,305,34540,70,NULL,NULL,'2MASX J11445927+5646392',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,176.246958333,56.77769,0,NULL,61979226731,968425417,15131647,17.7),(84456,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84456,38.08,0.33,413,34541,70,NULL,NULL,'SDSS J114459.99+073259.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,176.2499583,7.54997,0,NULL,60153029356,939891083,14685798,18.4),(84457,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84457,37.83,0.46,368,34542,70,NULL,NULL,'2MASX J11450015+1753428',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,176.250541667,17.89517,0.015,NULL,60204175763,940690246,14698285,18),(84458,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84458,34.19,NULL,69,34543,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 040-039',NULL,'2010Ap&SS.325..163P',2010,1,0.5,NULL,'G',0.000007,NULL,'15.5B',0.11,'Sdm',NULL,NULL,NULL,NULL,1,176.250875,7.49789,0,NULL,60153030664,939891104,14685798,15.5),(84459,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84459,34.21,NULL,69.6,34543,NULL,NULL,'Dipole + Quadrupole','CGCG 040-039',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84460,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84460,34.22,NULL,69.9,34543,NULL,NULL,'Dipole','CGCG 040-039',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84461,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84461,34.3,NULL,72.4,34543,NULL,NULL,NULL,'CGCG 040-039',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84462,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84462,34.69,0.2,86.7,34543,74.4,NULL,NULL,'CGCG 040-039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84463,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84463,37.58,0.19,329,34544,70,NULL,NULL,'2MASX J11450045+0938240',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00014,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,176.2519583,9.64003,0.026,NULL,60381119818,943454997,14741484,16.7),(84464,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84464,37.3,0.33,289,34545,70,NULL,NULL,'2MASX J11450142+2442555',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,176.2559583,24.71544,0.055,NULL,60543369771,945990152,14781096,16.9),(84465,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84465,37.82,0.46,366,34546,70,NULL,NULL,'2MASX J11450156+2811525',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000142,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,176.2564583,28.19794,0.05,NULL,60596398102,946818720,14794042,17.6),(84466,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84466,37.97,0.23,392,34547,70,NULL,NULL,'2MASX J11450181+0503082',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,176.257667,5.05233,0,NULL,60182866697,940357292,14693082,17.4),(84467,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84467,37.24,0.21,281,34548,70,NULL,NULL,'2MASX J11450187+2113209',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000189,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,176.257667,21.22267,0,NULL,61085048472,954453882,14913341,16.6),(84468,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84468,37.88,0.33,377,34549,70,NULL,NULL,'SDSS J114502.69+133217.8',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000174,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,176.26125,13.53828,0.142,NULL,60248898686,941389041,14709203,17.5),(84469,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84469,37.58,0.46,328,34550,70,NULL,NULL,'LCRS B114229.5-023515',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000159,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,176.2622083,-2.86489,0.053,NULL,40865524432,638523819,9976934,16.9),(84470,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84470,37.04,0.46,255,34551,70,NULL,NULL,'2MASX J11450354+5929087',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,176.264917,59.48589,0,NULL,61857536062,966524000,15101937,17.4),(84471,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84471,35.33,0.33,116,34552,70,NULL,NULL,'CGCG 157-028',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000104,NULL,'15.2g',0.42,'E',NULL,NULL,NULL,NULL,1,176.265625,26.82772,0.052,NULL,60595615062,946806485,14793851,15.2),(84472,'IRAS','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84472,34.21,0.8,69.4,34553,75,NULL,'HMCL, I','NGC 3861',NULL,'1997ApJS..109..333W',1997,1,2.53,NULL,'G',0.000007,NULL,'13.7g',0.99,'(R\')SAB(r)b','Pair member (points to parent)',NULL,NULL,NULL,1,176.266166667,19.97369,0,NULL,61082844919,954419451,14912803,13.7),(84473,'IRAS','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84473,34.21,0.8,69.4,34553,75,NULL,'W91CL, r','NGC 3861',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84474,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84474,33.35,0.69,46.8,34553,100,NULL,'mid-IR','NGC 3861',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84475,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84475,34.44,0.38,77.4,34553,75,NULL,'W91CL, r, raw','NGC 3861',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84476,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84476,34.52,0.4,80.2,34553,75,NULL,'HMCL, I, raw','NGC 3861',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84477,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84477,34.6,0.4,83.3,34553,NULL,NULL,'mean','NGC 3861',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84478,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84478,34.67,0.38,85.7,34553,75,NULL,'W91CL, r, inv','NGC 3861',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84479,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84479,34.67,0.47,86.1,34553,NULL,NULL,'H','NGC 3861',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84480,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84480,34.7,0.46,87.3,34553,NULL,NULL,'J','NGC 3861',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84481,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84481,34.72,0.38,88,34553,75,NULL,'W91CL, r, cor','NGC 3861',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84482,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84482,34.74,0.45,88.8,34553,NULL,NULL,'K','NGC 3861',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84483,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84483,34.78,0.2,90.4,34553,74.4,NULL,NULL,'NGC 3861',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84484,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84484,34.8,0.4,91.1,34553,75,NULL,'HMCL, I, inv','NGC 3861',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84485,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84485,34.8,0.4,91.3,34553,75,NULL,'HMCL, I, cor','NGC 3861',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84486,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84486,34.85,0.43,93.5,34553,75,NULL,'3.6 micron, color corrected','NGC 3861',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84487,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84487,35.1,0.43,105,34553,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3861',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84488,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84488,35.14,0.07,107,34553,NULL,NULL,NULL,'NGC 3861',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84489,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84489,34.8,0.25,91.2,34554,74.4,NULL,NULL,'IC 2955',NULL,'2013AJ....146...86T',2013,1,0.2,NULL,'G',0.000017,NULL,'15.05',0.2,'E              PAS','Group member',NULL,NULL,NULL,1,176.266291667,19.62061,0,NULL,61078591601,954352993,14911765,15.05),(84490,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84490,38.22,0.33,440,34555,70,NULL,NULL,'LCRS B114230.5-022457',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,176.2665,-2.69344,0.053,NULL,40863656701,638494635,9976478,18.6),(84491,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84491,35.26,0.07,113,34556,70,NULL,NULL,'2MASX J11450470+1940549',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000073,NULL,'16.39',0.19,NULL,NULL,NULL,NULL,NULL,1,176.2697917,19.68208,0,NULL,61078591260,954352988,14911765,16.39),(84492,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84492,37.9,0.46,381,34557,70,NULL,NULL,'LCRS B114231.5-030608',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000086,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,176.2705,-3.37975,0.049,NULL,40868965753,638577589,9977774,18.2),(84493,'D-Sigma','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84493,34.62,0.4,83.8,34558,75,NULL,'Edat, raw','NGC 3862',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000019,NULL,'13.67',1.5,'E;LERG         LINER','in a radial-velocity based grouping',NULL,'FR I','AGN',1,176.270875,19.60631,0,NULL,61078709352,954354833,14911794,13.67),(84494,'D-Sigma','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84494,34.8,0.4,91.3,34558,75,NULL,'Edat, cor','NGC 3862',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84495,'D-Sigma','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84495,34.94,0.18,97.1,34558,72,NULL,'ABELL 1367 Cluster, 6','NGC 3862',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84496,'Faber-Jackson','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84496,33.84,0.49,58.6,34558,95,NULL,'de Vaucouleurs','NGC 3862',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84497,'Faber-Jackson','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84497,34,0.33,63.1,34558,95,NULL,'Weighted Mean','NGC 3862',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84498,'Faber-Jackson','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84498,34.61,0.46,83.6,34558,95,NULL,'Michard 1979a','NGC 3862',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84499,'Faber-Jackson','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84499,34.83,0.63,92.5,34558,95,NULL,'Michard 1979b, c','NGC 3862',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84500,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84500,34.8,0.23,91.2,34558,74.4,NULL,NULL,'NGC 3862',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84501,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84501,35.26,0.07,113,34558,70,NULL,NULL,'NGC 3862',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84502,'Tertiary','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84502,34.08,0.5,65.5,34558,95,NULL,NULL,'NGC 3862',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84503,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84503,34.71,NULL,87.5,34558,77,NULL,'BRIK, ABELL 1367 cluster, 20 galaxies','NGC 3862',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84504,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84504,34.71,0.36,87.5,34558,77,NULL,'ABELL 1367, 20 galaxies','NGC 3862',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84505,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84505,34.75,NULL,89.2,34558,71,NULL,'ABELL 1367, 88 galaxies','NGC 3862',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84506,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84506,34.84,0.04,92.8,34558,75,NULL,'ABELL 1367 CLUSTER','NGC 3862',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84507,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84507,34.84,0.3,93,34558,NULL,NULL,'ABELL 1367, 28 galaxies','NGC 3862',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84508,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84508,34.86,0.11,93.8,34558,75,NULL,'ABELL 1367 CLUSTER','NGC 3862',NULL,'2012ApJ...749...78T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84509,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84509,34.99,0.13,99.5,34558,70,NULL,'ABELL 1367 Cluster','NGC 3862',NULL,'1992ApJ...396..453H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84510,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84510,35,0.4,99.8,34558,NULL,NULL,'mean','NGC 3862',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84511,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84511,35.17,0.45,108,34558,NULL,NULL,'K','NGC 3862',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84512,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84512,33.66,0.46,53.8,34559,NULL,NULL,'J','NGC 3863',NULL,'2007A&A...465...71T',2007,1,1.16,'HOLM 286B is a star.','G',0.000022,NULL,'13.6g',0.58,'Sbc','Isolated galaxy (6 Mpc isolation)',NULL,NULL,NULL,1,176.273,8.4695,0,NULL,60374261208,943347831,14739809,13.6),(84513,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84513,33.67,0.47,54.2,34559,NULL,NULL,'H','NGC 3863',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84514,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84514,33.71,0.49,55.2,34559,75,NULL,'IR','NGC 3863',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84515,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84515,33.78,0.45,57,34559,NULL,NULL,'K','NGC 3863',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84516,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84516,34.01,0.2,63.4,34559,74.4,NULL,NULL,'NGC 3863',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84517,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84517,34.07,0.4,65.1,34559,NULL,NULL,'mean','NGC 3863',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84518,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84518,34.23,0.41,70,34559,NULL,NULL,NULL,'NGC 3863',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84519,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84519,34.35,0.39,74.2,34559,NULL,NULL,'Malmquist cor.','NGC 3863',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84520,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84520,34.04,0.2,64.3,34560,74.4,NULL,NULL,'KUG 1142+216A',NULL,'2013AJ....146...86T',2013,1,0.91,NULL,'G',0.000032,NULL,'15.2g',0.42,'SB:bcpec','Group non-member, background',NULL,NULL,NULL,1,176.274,21.41167,0,NULL,61084900461,954451569,14913305,15.2),(84521,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84521,34.22,0.6,69.7,34560,NULL,NULL,NULL,'KUG 1142+216A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84522,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84522,34.46,0.54,77.9,34560,NULL,NULL,'Malmquist cor.','KUG 1142+216A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84523,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84523,35.28,0.27,114,34561,70,NULL,NULL,'CGCG 012-074',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000033,NULL,'15.5g',0.43,'SA0^0^','Group member',NULL,NULL,NULL,1,176.2765417,-1.66919,0.037,NULL,40808215109,637628361,9962943,15.5),(84524,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84524,37.15,0.46,269,34562,70,NULL,NULL,'MCG +09-19-173',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000207,NULL,'15.5g',0.45,'E0',NULL,NULL,NULL,NULL,1,176.2772083,53.648,0,NULL,61773448215,965210128,15081408,15.5),(84525,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84525,37.02,0.46,254,34563,70,NULL,NULL,'2MASX J11450683+4209202',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000187,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,176.278583,42.15578,0,NULL,60413625721,943962901,14749420,16.3),(84526,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84526,37.91,0.46,382,34564,70,NULL,NULL,'2MASX J11450740-0040312',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000067,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,176.2807917,-0.67547,0.021,NULL,40809976437,637655881,9963373,17.9),(84527,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84527,38.68,0.46,545,34565,70,NULL,NULL,'SDSS J114508.22+145514.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,176.2842917,14.92061,0.089,NULL,60263105093,941611017,14712672,18.4),(84528,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84528,38.22,0.33,440,34566,70,NULL,NULL,'LCRS B114235.3-022356',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,176.286833,-2.67622,0.053,NULL,40863654608,638494603,9976478,18.1),(84529,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84529,37.88,0.33,377,34567,70,NULL,NULL,'2MASX J11450904+1337308',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000146,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,176.287667,13.62511,0.142,NULL,60248888209,941388878,14709201,18.5),(84530,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84530,36.97,0.33,248,34568,70,NULL,NULL,'2MASX J11450904+5218581',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,176.2877917,52.31619,0,NULL,61768345500,965130398,15080162,17.6),(84531,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84531,38.82,0.46,582,34569,70,NULL,NULL,'SDSS J114509.23+194845.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.1r',0.13,NULL,'Group member',NULL,NULL,NULL,1,176.2885,19.8125,0,NULL,61078625412,954353522,14911773,17.1),(84532,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84532,35.46,0.46,124,34570,70,NULL,NULL,'UGC 06726',NULL,'2015arXiv151105856S',2015,1,1.15,NULL,'G',0.000153,NULL,'14.5g',0.61,'S0-:',NULL,NULL,NULL,NULL,1,176.288583,49.71881,0,NULL,61745603645,964775056,15074610,14.5),(84533,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84533,37.69,0.46,344,34571,70,NULL,NULL,'2MASX J11450962+5925357',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,176.2897917,59.42647,0,NULL,61857497648,966523400,15101928,17.8),(84534,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84534,38.28,0.15,454,34572,70,NULL,NULL,'2MASX J11450973-0145162',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000101,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,176.2904583,-1.75456,0.037,NULL,40808190194,637627971,9962937,17.8),(84535,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84535,35.28,0.27,114,34573,70,NULL,NULL,'CGCG 012-075',NULL,'2015arXiv151105856S',2015,1,0.97,NULL,'G',0.000153,NULL,'15.0g',0.58,'E+','Group member',NULL,NULL,NULL,1,176.291208333,-1.76261,0.037,NULL,40808063087,637625985,9962906,15),(84536,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84536,37.97,0.23,392,34574,70,NULL,NULL,'SDSS J114510.01+050020.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,176.29175,5.00569,0,NULL,60182878585,940357477,14693085,17.9),(84537,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84537,35.26,0.07,113,34575,70,NULL,NULL,'2MASX J11451064+1931599',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000037,NULL,'16.14',0.25,NULL,NULL,NULL,NULL,NULL,1,176.2945,19.53319,0,NULL,61078706795,954354793,14911793,16.14),(84538,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84538,38.41,0.46,480,34576,70,NULL,NULL,'SDSS J114510.90+023615.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000084,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,176.295417,2.60433,0.025,NULL,60186059321,940407176,14693862,18.4),(84539,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84539,36.94,0.46,244,34577,70,NULL,NULL,'2MASX J11451143+2144439',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000138,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,176.2977917,21.7455,0,NULL,61084562668,954446291,14913223,17.5),(84540,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84540,37.47,0.27,312,34578,70,NULL,NULL,'2MASX J11451175+6441002',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000081,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,176.2987917,64.68344,0.005,NULL,61823548766,965992949,15093639,17.2),(84541,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84541,37.37,0.46,297,34579,70,NULL,NULL,'2MASX J11451217+5045371',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000148,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,176.301,50.76028,0,NULL,61801761978,965652530,15088320,17),(84542,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84542,37.97,0.23,392,34580,70,NULL,NULL,'2MASX J11451265+0509423',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00016,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,176.302833,5.16172,0,NULL,60182962548,940358789,14693106,17.3),(84543,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84543,37.52,0.46,319,34581,70,NULL,NULL,'LCRS B114239.4-025012',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,176.303417,-3.11408,0.049,NULL,40865573782,638524590,9976946,17.7),(84544,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84544,37.71,0.46,348,34582,70,NULL,NULL,'2MASX J11451378+1022130',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,176.3075,10.37042,0.125,NULL,60379542262,943430347,14741099,17.7),(84545,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84545,37.63,0.46,336,34583,70,NULL,NULL,'2MASX J11451450+1222068',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,176.3105,12.36858,0.078,NULL,60242611654,941290807,14707668,17.7),(84546,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84546,36.97,0.33,248,34584,70,NULL,NULL,'2MASX J11451449+5217521',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000159,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,176.3105417,52.29783,0,NULL,61768349677,965130463,15080163,16.5),(84547,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84547,36.21,0.46,175,34585,70,NULL,NULL,'2MASX J11451468+6320522',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000172,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,176.311167,63.34803,0.037,NULL,61818252477,965910194,15092346,16.8),(84548,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84548,35.26,0.07,113,34586,70,NULL,NULL,'ARK 319',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000022,NULL,'14.84',0.3,'Elliptical','Group member',NULL,NULL,NULL,1,176.311916667,19.84553,0,NULL,61078623028,954353484,14911773,14.84),(84549,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84549,34.11,0.49,66.4,34587,70,NULL,NULL,'CGCG 012-076',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00005,NULL,'15.0g',0.41,'SB0^0^?','Group member',NULL,NULL,NULL,1,176.312625,-1.70278,0.037,NULL,40808164242,637627566,9962930,15),(84550,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84550,37.42,0.46,305,34588,70,NULL,NULL,'2MASX J11451514+1321488',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000175,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,176.313083333,13.36367,0.159,NULL,60241094219,941267097,14707298,17),(84551,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84551,36.44,0.93,194,34589,70,NULL,NULL,'2MASX J11451522-5102107',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,176.313417,-51.03625,0.561,NULL,40054726528,625855102,9778985,17.4),(84552,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84552,37.64,0.46,337,34590,70,NULL,NULL,'2MASX J11451521+3516050',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000205,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,176.313625,35.26806,0,NULL,60445800937,944465639,14757275,17.9),(84553,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84553,37.62,0.46,335,34591,70,NULL,NULL,'SDSS J114515.79+062605.4',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,176.3157917,6.43483,0,NULL,60154566128,939915095,14686173,18),(84554,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84554,37.74,0.46,354,34592,70,NULL,NULL,'2MASX J11451601-0011552',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000092,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,176.316667,-0.19883,0.041,NULL,40808944558,637639758,9963121,16.7),(84555,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84555,38.13,0.46,423,34593,70,NULL,NULL,'SDSS J114516.04+112514.3',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000168,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,176.316833,11.42064,0.056,NULL,60240233925,941253655,14707088,18.6),(84556,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84556,38.28,0.15,454,34594,70,NULL,NULL,'2MASX J11451674-0143572',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000143,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,176.319666667,-1.73264,0.037,NULL,40808161944,637627530,9962930,17.8),(84557,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84557,37.24,0.21,281,34595,70,NULL,NULL,'LSBC F571-02',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000157,NULL,'15.5g',0.56,NULL,NULL,NULL,NULL,NULL,1,176.32325,21.42064,0,NULL,61084907706,954451682,14913307,15.5),(84558,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84558,37.85,0.46,372,34596,70,NULL,NULL,'2MASX J11451807+2938545',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00017,NULL,'16.8g',0.26,'E',NULL,NULL,NULL,NULL,1,176.3254583,29.64861,0.025,NULL,60554695426,946167116,14783861,16.8),(84559,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84559,37.96,0.33,390,34597,70,NULL,NULL,'SDSS J114518.14+030630.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000068,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,176.325625,3.10853,0.033,NULL,60193190481,940518601,14695603,18.6),(84560,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84560,35.76,0.15,142,34598,70,NULL,NULL,'IC 0729',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000077,NULL,'15.1g',0.4,NULL,'Group member',NULL,NULL,NULL,1,176.326333,33.33581,0,NULL,60631392135,947365502,14802585,15.1),(84561,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84561,37.89,0.46,379,34599,70,NULL,NULL,'2MASX J11451865+6346423',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,176.327625,63.77842,0.041,NULL,61818542206,965914721,15092417,17.3),(84562,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84562,37.67,0.46,341,34600,70,NULL,NULL,'2MASX J11451942+4233291',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000184,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,176.331,42.55806,0,NULL,60412882525,943951289,14749238,16.7),(84563,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84563,36.42,0.46,192,34601,70,NULL,NULL,'LCRS B114246.0-021819',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.00018,NULL,'15.9g',0.37,'E0',NULL,NULL,NULL,NULL,1,176.331375,-2.58253,0.053,NULL,40863922680,638498791,9976543,15.9),(84564,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84564,36.47,0.46,197,34602,70,NULL,NULL,'2MASX J11451987+3819136',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000174,NULL,'16.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,176.332875,38.32036,0.039,NULL,60455145489,944611648,14759557,16.4),(84565,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84565,37.58,0.19,329,34603,70,NULL,NULL,'2MASX J11452082+1002590',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,176.3367917,10.04972,0.198,NULL,60379438836,943428731,14741073,17.9),(84566,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84566,36.76,0.12,225,34604,70,NULL,NULL,'2MASX J11452181+5546278',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00016,NULL,'16.8g',0.27,NULL,'Group member',NULL,NULL,NULL,1,176.340917,55.77436,0,NULL,61758608044,964978250,15077785,16.8),(84567,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84567,32.73,0.49,35.1,34605,75,NULL,'IR','CGCG 097-132',NULL,'2011yCatp016004901K',2011,1,1.11,NULL,'G',0.000198,NULL,'15.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,176.3427917,14.36658,0.08,NULL,60262571578,941602680,14712541,15.8),(84568,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84568,35.28,0.27,114,34606,70,NULL,NULL,'CGCG 012-077',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000077,NULL,'15.4g',0.47,'SB0-','Group member',NULL,NULL,NULL,1,176.343333,-1.87672,0.037,NULL,40808085867,637626341,9962911,15.4),(84569,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84569,36.66,0.46,215,34607,70,NULL,NULL,'2MASX J11452457+3732067',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000174,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,176.3525,37.53503,0,NULL,60454824532,944606633,14759478,16.5),(84570,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84570,37.58,0.19,329,34608,70,NULL,NULL,'SDSS J114525.01+095208.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000139,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,176.354208333,9.86903,0.066,NULL,60381073193,943454268,14741472,18.2),(84571,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84571,37.03,0.46,255,34609,70,NULL,NULL,'2MASX J11452508+1952377',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'16.81',NULL,NULL,NULL,NULL,NULL,NULL,1,176.3544583,19.87717,0,NULL,61078606663,954353229,14911769,16.81),(84572,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84572,37.73,0.46,351,34610,70,NULL,NULL,'2MASX J11452511+1514370',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000182,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,176.354583,15.24369,0.088,NULL,60263139427,941611553,14712680,17),(84573,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84573,37.56,0.21,325,34611,70,NULL,NULL,'2MASX J11452511-0210176',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000077,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,176.3547083,-2.17164,0.041,NULL,40863984090,638499751,9976558,17.2),(84574,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84574,37.58,0.16,327,34612,70,NULL,NULL,'2MASX J11452524+1530260',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,176.355125,15.50708,0.091,NULL,60263044154,941610064,14712657,17.2),(84575,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84575,37.24,0.21,281,34613,70,NULL,NULL,'2MASX J11452535+2117157',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000168,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,176.355667,21.28778,0,NULL,61085037193,954453706,14913339,17.1),(84576,'FP','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,'R',84576,37.96,0.33,390,34614,70,NULL,NULL,'2MASX J11452606+0304280',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000095,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,176.358458333,3.07433,0.033,NULL,60193187747,940518558,14695602,17.2),(84577,'Tully est','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84577,32.18,0.8,27.2,34615,75,NULL,NULL,'UGCA 245',NULL,'1988NBGC.C....0000T',1988,1,2.8,NULL,'G',0.000007,NULL,'13.5',0.8,'SAB(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,176.3590417,-10.10289,0.005,NULL,41034633372,641166146,10018221,13.5),(84578,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84578,31.76,0.43,22.5,34615,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 245',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84579,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84579,31.82,0.43,23.1,34615,75,NULL,'3.6 micron, color corrected','UGCA 245',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84580,'Tully-Fisher','2016-12-15 15:14:50','2016-12-16 11:19:59','1',NULL,NULL,84580,31.85,0.2,23.4,34615,74.4,NULL,NULL,'UGCA 245',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84581,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84581,37.58,0.19,329,34616,70,NULL,NULL,'2MASX J11452687+0956066',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,176.3620417,9.93517,0.198,NULL,60379431792,943428621,14741072,18),(84582,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84582,37.58,0.16,327,34617,70,NULL,NULL,'2MASX J11452752+1534290',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000159,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,176.364708333,15.57489,0.091,NULL,60263048587,941610134,14712658,18),(84583,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84583,35.26,0.07,113,34618,70,NULL,NULL,'CGCG 127-048',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000093,NULL,'15.0',0.4,'E',NULL,NULL,NULL,NULL,1,176.3652917,20.80717,0,NULL,61083089468,954423272,14912863,15),(84584,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84584,34.5,0.46,79.5,34619,70,NULL,NULL,'2MASX J11452918-0331066',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00008,NULL,'15.6g',0.3,'E0',NULL,NULL,NULL,NULL,1,176.371708333,-3.51847,0.061,NULL,40868918316,638576848,9977763,15.6),(84585,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84585,35.26,0.07,113,34620,70,NULL,NULL,'NGC 3868',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000043,NULL,'15.30',0.3,'S0','Group member',NULL,NULL,NULL,1,176.37475,19.44469,0,NULL,61078658591,954354040,14911781,15.3),(84586,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84586,37.91,0.46,383,34621,70,NULL,NULL,'2MASX J11452994+2806150',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000165,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,176.3747917,28.10425,0.065,NULL,60596379738,946818433,14794038,17.8),(84587,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84587,35.78,0.57,143,34622,70,NULL,NULL,'ESO 266- G 023',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'14.74',1.1,'SB(r)ab',NULL,NULL,NULL,NULL,1,176.3762917,-43.57386,0.485,NULL,41877851639,654341431,10224084,14.74),(84588,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84588,37.96,0.46,391,34623,70,NULL,NULL,'SDSS J114530.33+055100.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000153,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,176.376417,5.85014,0,NULL,60152181681,939877838,14685591,18.2),(84589,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84589,37.92,0.46,383,34624,70,NULL,NULL,'2MASX J11453057+0828106',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,176.377375,8.46975,0,NULL,60374253905,943347717,14739808,17.6),(84590,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84590,36.8,0.33,229,34625,70,NULL,NULL,'2MASX J11453070+5400458',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000174,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,176.378125,54.01261,0,NULL,61773668740,965213574,15081462,16.3),(84591,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84591,38.39,0.46,477,34626,70,NULL,NULL,'2MASX J11453225+0357430',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,'PHOT','17.92',0.15,'BrClG',NULL,NULL,NULL,NULL,1,176.384333,3.96186,0.013,NULL,60196499655,940570307,14696411,17.92),(84592,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84592,36.76,0.12,225,34627,70,NULL,NULL,'2MASX J11453305+5523598',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000241,NULL,'15.7g',0.45,'S0','Group member',NULL,NULL,NULL,1,176.387625,55.40008,0,NULL,61759000888,964984388,15077881,15.7),(84593,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84593,38.57,0.46,517,34628,70,NULL,NULL,'SDSS J114533.26+060414.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,176.388583,6.07069,0,NULL,60152266098,939879157,14685611,18.1),(84594,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84594,37.58,0.16,327,34629,70,NULL,NULL,'2MASX J11453423+1531560',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000197,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,176.392583,15.53242,0.091,NULL,60263093881,941610841,14712669,16.7),(84595,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84595,37.56,0.21,325,34630,70,NULL,NULL,'2MASX J11453451-0201416',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000172,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,176.3937083,-2.02828,0.037,NULL,40863400969,638490640,9976416,17),(84596,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84596,37.14,0.46,268,34631,70,NULL,NULL,'2MASX J11453491+4838436',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00015,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,176.395375,48.64531,0.008,NULL,61756553423,964946147,15077283,16.6),(84597,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84597,35.26,0.07,113,34632,70,NULL,NULL,'2MASX J11453529+1924597',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000057,NULL,'15.99',0.22,'E',NULL,NULL,NULL,NULL,1,176.3970417,19.4165,0,NULL,61078663748,954354121,14911783,15.99),(84598,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84598,30.97,0.12,15.7,34633,NULL,NULL,NULL,'NGC 3850',NULL,'2009ApJS..182..474S',2009,1,0.93,NULL,'G',0.000023,NULL,'14.7g',0.68,'SB(s)c:','in a radial-velocity based grouping',NULL,NULL,NULL,1,176.398166667,55.88689,0,NULL,61977557108,968399329,15131239,14.7),(84599,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84599,31,0.4,15.8,34633,NULL,NULL,NULL,'NGC 3850',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84600,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84600,31.41,0.2,19.1,34633,74.4,NULL,NULL,'NGC 3850',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84601,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84601,31.52,0.43,20.1,34633,75,NULL,'3.6 micron, color corrected','NGC 3850',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84602,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84602,31.61,0.43,21,34633,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3850',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84603,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84603,31.69,0.4,21.8,34633,75,NULL,'B','NGC 3850',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84604,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84604,34.83,0.28,92.5,34634,NULL,NULL,'Malmquist cor.','UGC 06734',NULL,'2009ApJS..182..474S',2009,1,1.37,NULL,'G',0.000008,NULL,'15.2g',0.38,'Sb',NULL,NULL,NULL,NULL,1,176.399417,9.11819,0.024,NULL,60378842120,943419408,14740928,15.2),(84605,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84605,34.85,0.4,93.5,34634,NULL,NULL,'mean','UGC 06734',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84606,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84606,34.92,0.2,96.4,34634,74.4,NULL,NULL,'UGC 06734',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84607,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84607,34.95,0.47,97.6,34634,NULL,NULL,'H','UGC 06734',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84608,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84608,34.97,0.26,98.7,34634,NULL,NULL,NULL,'UGC 06734',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84609,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84609,34.97,0.45,98.8,34634,NULL,NULL,'K','UGC 06734',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84610,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84610,37.58,0.16,327,34635,70,NULL,NULL,'2MASX J11453651+1533320',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,176.402375,15.55908,0.091,NULL,60263050728,941610167,14712658,17.2),(84611,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84611,31.03,0.2,16.1,34636,74.4,NULL,NULL,'IC 2957',NULL,'2013AJ....146...86T',2013,1,0.89,'Not to be confused with IC 2954 which is a star 4.5 degrees away.','G',0.000011,NULL,'14.8g',0.49,'S0-a',NULL,NULL,NULL,NULL,1,176.403916667,31.29956,0.03,NULL,60555277958,946176218,14784003,14.8),(84612,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84612,36.35,0.46,186,34637,70,NULL,NULL,'2MASX J11453721+5207136',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000169,NULL,'16.0g',0.34,'E0',NULL,NULL,NULL,NULL,1,176.405083,52.12039,0,NULL,61800527556,965633243,15088019,16),(84613,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84613,36.26,0.53,179,34638,70,NULL,NULL,'2MASX J11453756-5105165',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000133,NULL,'13.5I',0.6,NULL,NULL,NULL,NULL,NULL,1,176.4065417,-51.08792,0.777,NULL,40055426286,625866035,9779156,13.5),(84614,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84614,34.76,0.57,89.4,34639,70,NULL,NULL,'2MASX J11453770-1702095',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.77',NULL,NULL,NULL,NULL,NULL,NULL,1,176.40725,-17.03606,0.049,NULL,40946967226,639796362,9996818,15.77),(84615,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84615,36.79,0.46,228,34640,70,NULL,NULL,'2MASX J11453832+0810356',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,176.409583,8.17664,0,NULL,60374812320,943356442,14739944,17.8),(84616,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84616,37.21,0.46,277,34641,70,NULL,NULL,'2MASX J11453982+2147167',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000184,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,176.416,21.788,0,NULL,61084467569,954444805,14913200,16.4),(84617,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84617,37.86,0.46,373,34642,70,NULL,NULL,'2MASX J11454059+0442460',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000198,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,176.41925,4.71269,0,NULL,60193939198,940530299,14695785,16.5),(84618,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84618,37.47,0.27,312,34643,70,NULL,NULL,'2MASX J11454072+6428034',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000181,NULL,'16.8g',0.34,NULL,NULL,NULL,NULL,NULL,1,176.4199583,64.46764,0.005,NULL,61823519895,965992498,15093632,16.8),(84619,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84619,35.26,0.07,113,34644,70,NULL,NULL,'2MASX J11454117+1946127',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00007,NULL,'16.03',0.27,NULL,'Group member',NULL,NULL,NULL,1,176.421541667,19.77022,0,NULL,61078611028,954353297,14911770,16.03),(84620,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84620,37.67,0.46,342,34645,70,NULL,NULL,'2MASX J11454126+1208190',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000146,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,176.421917,12.13869,0.056,NULL,60239972541,941249570,14707024,17.6),(84621,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84621,32.61,0.43,33.3,34646,75,NULL,'3.6 micron, color + selection bias corrected','ESO 440- G 004',NULL,'2014MNRAS.444..527S',2014,1,2.5,NULL,'G',0.000013,NULL,'14.18',1,'SB(s)dm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,176.4245,-28.36653,0.377,NULL,41471246149,647988221,10124815,14.18),(84622,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84622,32.67,0.43,34.1,34646,75,NULL,'3.6 micron, color corrected','ESO 440- G 004',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84623,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84623,32.92,0.2,38.4,34646,74.4,NULL,NULL,'ESO 440- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84624,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84624,33.26,0.87,45,34646,NULL,NULL,'Malmquist cor.','ESO 440- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84625,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84625,33.62,0.74,53,34646,NULL,NULL,NULL,'ESO 440- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84626,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84626,37.56,0.21,325,34647,70,NULL,NULL,'2MASX J11454219-0201516',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000187,NULL,'15.9g',0.46,'E0',NULL,NULL,NULL,NULL,1,176.425667,-2.03111,0.041,NULL,40808024823,637625387,9962896,15.9),(84627,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84627,35.01,0.46,101,34648,70,NULL,NULL,'CGCG 097-136',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'15.4',0.3,'E?',NULL,NULL,NULL,NULL,1,176.4277083,17.74775,0.015,NULL,60202279731,940660620,14697822,15.4),(84628,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84628,37.21,0.1,276,34649,70,NULL,NULL,'2MASX J11454288+5432278',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000171,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,176.4287917,54.54117,0,NULL,61772358606,965193103,15081142,16.3),(84629,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84629,37.64,0.46,337,34650,70,NULL,NULL,'SDSS J114543.48+535508.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00017,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,176.4312083,53.91917,0,NULL,61773665439,965213522,15081461,18.2),(84630,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84630,37.96,0.46,391,34651,70,NULL,NULL,'2MASX J11454434+2624460',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'18.51',0.15,NULL,NULL,NULL,NULL,NULL,1,176.434708333,26.41278,0.024,NULL,60596039898,946813123,14793955,18.51),(84631,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84631,36.88,0.46,237,34652,70,NULL,NULL,'SDSS J114544.65+074138.2',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00017,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,176.436083,7.69397,0,NULL,60153529483,939898898,14685920,16.5),(84632,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84632,36.62,0.46,211,34653,70,NULL,NULL,'2MASX J11454498-0110486',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000075,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,176.4372917,-1.18006,0.033,NULL,40810409254,637662644,9963478,17.1),(84633,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84633,37.73,0.46,352,34654,70,NULL,NULL,'2MASX J11454538+1421380',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,176.43925,14.36067,0.105,NULL,60262572602,941602696,14712542,18.1),(84634,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84634,36.48,0.46,197,34655,70,NULL,NULL,'2MASX J11454569+4710292',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000181,NULL,'15.9g',0.4,'E0',NULL,NULL,NULL,NULL,1,176.440583,47.17469,0.026,NULL,61742443433,964725678,15073838,15.9),(84635,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84635,37.56,0.21,325,34656,70,NULL,NULL,'2MASX J11454586-0204566',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000183,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,176.4412083,-2.08244,0.041,NULL,40863400446,638490631,9976416,16.9),(84636,'SNIa','2016-12-15 15:14:51','2016-12-16 11:19:59','1','SN 2007ci',NULL,84636,33.75,0.19,55.2,34657,74.2,NULL,'SALT 2','NGC 3873',0.018126,'2010ApJ...716..712A',2010,1,1.5,NULL,'G',0.000028,NULL,'13.85',1.3,'E','Pair member (points to parent)',NULL,NULL,NULL,1,176.442083,19.77394,0,NULL,61078747138,954355424,14911803,13.85),(84637,'SNIa','2016-12-15 15:14:51','2016-12-16 11:19:59','1','SN 2007ci',NULL,84637,34.29,0.21,70.7,34657,65,NULL,'MLCS31','NGC 3873',0.018126,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84638,'SNIa','2016-12-15 15:14:51','2016-12-16 11:19:59','1','SN 2007ci',NULL,84638,34.29,0.19,70.8,34657,65,NULL,'MLCS17','NGC 3873',0.018126,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84639,'SNIa','2016-12-15 15:14:51','2016-12-16 11:19:59','1','SN 2007ci',NULL,84639,34.41,0.09,76.2,34657,74.4,NULL,NULL,'NGC 3873',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84640,'SNIa','2016-12-15 15:14:51','2016-12-16 11:19:59','1','SN 2007ci',NULL,84640,34.49,0.17,77.6,34657,73.8,NULL,'SALT 2 (SNANA)','NGC 3873',0.0186,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84641,'SNIa','2016-12-15 15:14:51','2016-12-16 11:19:59','1','SN 2007ci',NULL,84641,34.66,0.2,83.8,34657,65,NULL,'SALT','NGC 3873',0.018126,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84642,'SNIa','2016-12-15 15:14:51','2016-12-16 11:19:59','1','SN 2007ci',NULL,84642,34.68,0.18,84.6,34657,70,NULL,'SALT 2','NGC 3873',0.018126,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84643,'SNIa','2016-12-15 15:14:51','2016-12-16 11:19:59','1','SN 2007ci',NULL,84643,34.69,0.23,85.2,34657,65,NULL,'SALT2','NGC 3873',0.018126,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84644,'SNIa','2016-12-15 15:14:51','2016-12-16 11:19:59','1','SN 2007ci',NULL,84644,35.71,0.03,136,34657,70,NULL,'SALT 2','NGC 3873',0.018126,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84645,'D-Sigma','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84645,34.62,0.4,83.8,34657,75,NULL,'Edat, raw','NGC 3873',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84646,'D-Sigma','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84646,34.8,0.4,91.3,34657,75,NULL,'Edat, cor','NGC 3873',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84647,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84647,34.41,0.09,76.2,34657,74.4,NULL,NULL,'NGC 3873',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84648,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84648,35.26,0.07,113,34657,70,NULL,NULL,'NGC 3873',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84649,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84649,34.77,0.4,90,34657,NULL,NULL,'mean','NGC 3873',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84650,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84650,35.13,0.45,106,34657,NULL,NULL,'K','NGC 3873',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84651,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84651,34.5,0.49,79.6,34658,75,NULL,'IR','UGC 06736',NULL,'2011yCatp016004901K',2011,1,1.48,'TXS codes: lobes(W)','G',0.000033,NULL,'15.0g',0.35,'SBcd? sp',NULL,NULL,NULL,NULL,1,176.442333,3.02972,0.025,NULL,60193075028,940516797,14695574,15),(84652,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84652,34.56,0.2,81.7,34658,74.4,NULL,NULL,'UGC 06736',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84653,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84653,34.69,0.28,86.8,34658,NULL,NULL,'Malmquist cor.','UGC 06736',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84654,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84654,34.72,0.28,88.1,34658,NULL,NULL,NULL,'UGC 06736',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84655,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84655,37.31,0.33,289,34659,70,NULL,NULL,'LCRS B114313.2-031556',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000102,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,176.4442917,-3.54317,0.053,NULL,40869036408,638578693,9977792,16.3),(84656,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84656,38.23,0.46,443,34660,70,NULL,NULL,'SDSS J114547.27+305719.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000167,NULL,'18.5g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,176.446958333,30.95556,0.028,NULL,60555424945,946178514,14784039,18.5),(84657,'IRAS','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84657,34.98,0.8,99.2,34661,75,NULL,'HMCL, I','KUG 1143+209A',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000033,NULL,'15.4',0.3,'SBab','Group member',NULL,NULL,NULL,1,176.4535,20.62861,0,NULL,61083517817,954429965,14912968,15.4),(84658,'IRAS','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84658,34.98,0.8,99.3,34661,75,NULL,'W91CL, r','KUG 1143+209A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84659,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84659,34,0.43,63.1,34661,75,NULL,'3.6 micron, color + selection bias corrected','KUG 1143+209A',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84660,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84660,34.12,0.43,66.7,34661,75,NULL,'3.6 micron, color corrected','KUG 1143+209A',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84661,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84661,34.25,0.4,70.9,34661,75,NULL,'HMCL, I, raw','KUG 1143+209A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84662,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84662,34.27,0.2,71.5,34661,74.4,NULL,NULL,'KUG 1143+209A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84663,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84663,34.35,0.38,74,34661,75,NULL,'W91CL, r, raw','KUG 1143+209A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84664,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84664,34.36,0.4,74.5,34661,75,NULL,'HMCL, I, inv','KUG 1143+209A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84665,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84665,34.41,0.38,76.1,34661,75,NULL,'W91CL, r, inv','KUG 1143+209A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84666,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84666,34.58,0.4,82.5,34661,75,NULL,'HMCL, I, cor','KUG 1143+209A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84667,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84667,34.64,0.38,84.8,34661,75,NULL,'W91CL, r, cor','KUG 1143+209A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84668,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84668,34.89,0.1,95.3,34661,NULL,NULL,NULL,'KUG 1143+209A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84669,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84669,37.95,0.33,389,34662,70,NULL,NULL,'2MASX J11454894+1001336',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,176.453916667,10.026,0.098,NULL,60379904972,943436015,14741187,17.9),(84670,'D-Sigma','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84670,32.97,0.4,39.3,34663,75,NULL,'Edat, raw','NGC 3872',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.00009,NULL,'12.74',1.2,'E5','in a radial-velocity based grouping',NULL,NULL,NULL,1,176.454416667,13.76669,0.112,NULL,60248215409,941378365,14709036,12.74),(84671,'D-Sigma','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84671,33.31,0.4,45.9,34663,75,NULL,'Edat, cor','NGC 3872',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84672,'Faber-Jackson','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84672,32.6,0.63,33.1,34663,95,NULL,'Michard 1979b, c','NGC 3872',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84673,'Faber-Jackson','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84673,32.7,0.3,34.7,34663,95,NULL,'Weighted Mean','NGC 3872',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84674,'Faber-Jackson','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84674,32.87,0.46,37.5,34663,95,NULL,'Michard 1979a','NGC 3872',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84675,'Faber-Jackson','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84675,33.07,0.54,41.1,34663,95,NULL,'de Vaucouleurs','NGC 3872',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84676,'Faber-Jackson','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84676,34.47,0.81,78.3,34663,55,NULL,'Visvanathan & Sandage 1979','NGC 3872',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84677,'Tertiary','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84677,32.43,0.5,30.6,34663,95,NULL,NULL,'NGC 3872',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84678,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84678,33.42,0.45,48.3,34663,NULL,NULL,'K','NGC 3872',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84679,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84679,33.44,0.4,48.9,34663,NULL,NULL,'mean','NGC 3872',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84680,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84680,35.83,0.6,147,34664,70,NULL,NULL,'2MASX J11454912-4415547',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,176.45475,-44.26519,0.521,NULL,41877335682,654333370,10223958,16.1),(84681,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84681,38.16,0.46,429,34665,70,NULL,NULL,'LCRS B114316.0-024440',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,176.45625,-3.02183,0.049,NULL,40865534655,638523978,9976937,17.7),(84682,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84682,37.88,0.46,377,34666,70,NULL,NULL,'SDSS J114550.98+560424.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000164,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,176.462416667,56.07358,0,NULL,61977635706,968400557,15131258,18.3),(84683,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84683,38.87,0.46,595,34667,70,NULL,NULL,'SDSS J114551.65+024951.5',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000084,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,176.4652083,2.831,0.025,NULL,60193046614,940516353,14695568,18),(84684,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84684,37.74,0.33,354,34668,70,NULL,NULL,'2MASX J11455171+3306285',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000157,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,176.465625,33.10778,0,NULL,60617430255,947147347,14799177,17.3),(84685,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84685,37.23,0.46,280,34669,70,NULL,NULL,'2MASX J11455216+3415054',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000174,NULL,'16.2g',0.41,NULL,NULL,NULL,NULL,NULL,1,176.467333,34.25167,0,NULL,60617142039,947142844,14799106,16.2),(84686,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84686,37.58,0.19,329,34670,70,NULL,NULL,'2MASX J11455273+0957466',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00014,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,176.4697917,9.96286,0.098,NULL,60379773447,943433960,14741155,17.2),(84687,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84687,38.18,0.46,433,34671,70,NULL,NULL,'2MASX J11455314+6055494',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,176.471417,60.93031,0.037,NULL,61846909168,966357955,15099343,18.3),(84688,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84688,37.02,0.33,253,34672,70,NULL,NULL,'2MASX J11455332+1436220',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,176.472167,14.60597,0.091,NULL,60262683802,941604434,14712569,17.6),(84689,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84689,37.58,0.16,327,34673,70,NULL,NULL,'2MASX J11455379+1517580',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000184,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,176.474291667,15.29928,0.091,NULL,60263229806,941612965,14712702,17.3),(84690,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84690,37.95,0.33,389,34674,70,NULL,NULL,'2MASX J11455489+1000166',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000181,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,176.478833333,10.0045,0.098,NULL,60379772103,943433939,14741155,17.2),(84691,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84691,37.74,0.33,354,34675,70,NULL,NULL,'2MASX J11455497+3307304',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,176.479167,33.125,0,NULL,60617437303,947147457,14799179,17.8),(84692,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84692,38.09,0.33,415,34676,70,NULL,NULL,'2MASX J11455622+0323360',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00009,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,176.484333,3.39339,0.049,NULL,60193247928,940519498,14695617,17.5),(84693,'Tully est','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84693,31.15,0.8,17,34677,75,NULL,NULL,'NGC 3870',NULL,'1988NBGC.C....0000T',1988,1,1.1,NULL,'G',0.000023,NULL,'13.4g',0.72,'S0?','in a radial-velocity based grouping',NULL,NULL,NULL,1,176.485833,50.19975,0,NULL,61801376825,965646512,15088226,13.4),(84694,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84694,30.36,0.2,11.8,34677,74.4,NULL,NULL,'NGC 3870',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84695,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84695,31.05,0.45,16.2,34677,NULL,NULL,'K','NGC 3870',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84696,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84696,31.22,0.4,17.5,34677,NULL,NULL,'mean','NGC 3870',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84697,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84697,37.31,0.33,289,34678,70,NULL,NULL,'LCRS B114323.2-031336',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000085,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,176.486,-3.50433,0.053,NULL,40865891078,638529548,9977024,16.8),(84698,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84698,37.55,0.46,324,34679,70,NULL,NULL,'2MASX J11455682+6303594',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,176.4869583,63.06653,0.025,NULL,61818013905,965906467,15092288,17.5),(84699,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84699,37.73,0.46,351,34680,70,NULL,NULL,'2MASX J11455728+0357320',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00018,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,176.48875,3.95889,0.021,NULL,60196211406,940565803,14696340,17.4),(84700,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84700,36.17,0.46,172,34681,70,NULL,NULL,'2MASX J11455890+2545401',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000168,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,176.495375,25.76125,0,NULL,60587776334,946684005,14791937,16.6),(84701,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84701,34.75,0.48,89,34682,70,NULL,NULL,'2MASX J11455904-1715000',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'15.85',0.4,NULL,NULL,NULL,NULL,NULL,1,176.496083333,-17.25017,0.049,NULL,40946984072,639796626,9996822,15.85),(84702,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84702,37.47,0.46,312,34683,70,NULL,NULL,'2MASX J11455914+3241294',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,176.496541667,32.69136,0.024,NULL,60618761512,947168148,14799502,17.6),(84703,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84703,37.64,0.46,337,34684,70,NULL,NULL,'SDSS J114559.17-021349.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000132,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,176.496583,-2.23047,0.045,NULL,40863079273,638485613,9976337,18.3),(84704,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84704,37.71,0.46,348,34685,70,NULL,NULL,'SDSS J114559.52+064250.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000143,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,176.498,6.71397,0,NULL,60153857757,939904027,14686000,18.4),(84705,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84705,37.79,0.46,361,34686,70,NULL,NULL,'2MASX J11460049+3530334',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,176.5019583,35.50922,0,NULL,60445905054,944467266,14757301,17.7),(84706,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84706,37.61,0.46,333,34687,70,NULL,NULL,'SDSS J114601.62+025724.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000071,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,176.5067917,2.95675,0.025,NULL,60193320154,940520627,14695634,18.2),(84707,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84707,38.09,0.33,415,34688,70,NULL,NULL,'2MASX J11460183+0326090',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000087,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,176.507541667,3.43575,0.033,NULL,60193249804,940519528,14695617,17.7),(84708,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84708,38.29,0.46,456,34689,70,NULL,NULL,'2MASX J11460197+2524571',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,176.5082083,25.41581,0.029,NULL,60542900584,945982821,14780981,18.3),(84709,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84709,37.08,0.46,260,34690,70,NULL,NULL,'2MASX J11460229+6404333',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000094,NULL,'16.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,176.509583,64.07608,0.005,NULL,61818307572,965911055,15092360,16.8),(84710,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84710,37.02,0.33,253,34691,70,NULL,NULL,'2MASX J11460289+1439021',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000189,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,176.5120417,14.65056,0.091,NULL,60262710015,941604843,14712575,16.7),(84711,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84711,37.58,0.46,329,34692,70,NULL,NULL,'SDSS J114602.91+092242.7',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000143,NULL,'18.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,176.512167,9.37853,0.018,NULL,60380288613,943442009,14741281,18.1),(84712,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84712,37.02,0.46,253,34693,70,NULL,NULL,'2MASX J11460297+0539250',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000169,NULL,'16.2g',0.38,'S0',NULL,NULL,NULL,NULL,1,176.5122917,5.65708,0,NULL,60151695052,939870235,14685472,16.2),(84713,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84713,37.66,0.46,340,34694,70,NULL,NULL,'2MASX J11460432+4222577',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000183,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,176.518125,42.38281,0,NULL,60413539814,943961559,14749399,17.5),(84714,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84714,38.62,0.46,529,34695,70,NULL,NULL,'SDSS J114604.60+060635.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000181,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,176.5192083,6.10978,0,NULL,60152380196,939880940,14685639,18.4),(84715,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84715,37.46,0.46,311,34696,70,NULL,NULL,'2MASX J11460524+3036131',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,176.522083,30.60381,0.038,NULL,60564052721,946313323,14786145,18),(84716,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84716,38.74,0.46,559,34697,70,NULL,NULL,'SDSS J114605.73+055656.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000131,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,176.523875,5.94917,0,NULL,60152463090,939882235,14685659,18.6),(84717,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84717,37.74,0.46,354,34698,70,NULL,NULL,'2MASX J11460587+0742419',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000189,NULL,'17.4g',0.24,'AGN',NULL,NULL,NULL,NULL,1,176.5244583,7.71158,0,NULL,60153539133,939899048,14685922,17.4),(84718,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84718,37.46,0.46,311,34699,70,NULL,NULL,'2MASX J11460597+0415050',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.22',0.19,NULL,NULL,NULL,NULL,NULL,1,176.52475,4.25144,0.041,NULL,60194162316,940533786,14695840,17.22),(84719,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84719,35.26,0.07,113,34700,70,NULL,NULL,'CGCG 097-143 NED01',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00004,NULL,'15.3',0.2,'S0/a','Group member',NULL,NULL,NULL,1,176.525791667,19.79022,0,NULL,61078735198,954355237,14911800,15.3),(84720,'Tully est','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84720,31.85,0.8,23.5,34701,75,NULL,'B','NGC 3882',NULL,'1988NBGC.C....0000T',1988,1,2.3,NULL,'G',0.000019,NULL,'13.0',1.3,'SB(s)bc',NULL,NULL,NULL,NULL,1,176.5272917,-56.38814,NULL,NULL,40218743735,628417870,9819029,13),(84721,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84721,31.22,0.45,17.6,34701,NULL,NULL,'K','NGC 3882',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84722,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84722,31.26,0.46,17.8,34701,NULL,NULL,'J','NGC 3882',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84723,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84723,31.31,0.47,18.3,34701,NULL,NULL,'H','NGC 3882',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84724,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84724,31.87,0.4,23.7,34701,NULL,NULL,'mean','NGC 3882',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84725,'GRB','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84725,46.6,1.55,5660,34702,NULL,NULL,NULL,'GRB 080603B',2.69,'2010JCAP...08..020W',2010,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,176.53175,68.06097,0,NULL,62076084418,969938819,15155294,NULL),(84726,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84726,38.55,0.46,513,34703,70,NULL,NULL,'2MASX J11460718+0419540',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000171,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,176.529833,4.33178,0.041,NULL,60194306922,940536045,14695875,17.8),(84727,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84727,37.16,0.46,271,34704,70,NULL,NULL,'2MASX J11460741+0729399',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000147,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,176.530958333,7.49439,0,NULL,60153623597,939900368,14685943,16.7),(84728,'IRAS','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84728,31.13,0.8,16.8,34705,75,NULL,'W91CL, r','NGC 3877',NULL,'1997ApJS..109..333W',1997,1,4.42,NULL,'G',0.000013,NULL,'12.1g',0.78,'Sc             HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,176.532083,47.49433,0.01,NULL,61754731822,964917684,15076838,12.1),(84729,'IRAS','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84729,31.14,0.8,16.9,34705,75,NULL,'A82, H','NGC 3877',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84730,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84730,30.69,0.47,13.7,34705,75,NULL,'A82, H, raw','NGC 3877',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84731,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84731,30.73,NULL,14,34705,NULL,NULL,'I','NGC 3877',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84732,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84732,30.74,NULL,14.1,34705,NULL,NULL,'B','NGC 3877',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84733,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84733,30.75,0.35,14.1,34705,NULL,NULL,NULL,'NGC 3877',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84734,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84734,30.76,0.47,14.2,34705,75,NULL,'A82, H, inv','NGC 3877',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84735,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84735,30.83,0.46,14.7,34705,NULL,NULL,'J','NGC 3877',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84736,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84736,30.89,0.4,15.1,34705,75,NULL,NULL,'NGC 3877',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84737,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84737,30.92,0.43,15.2,34705,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3877',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84738,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84738,30.92,0.43,15.3,34705,75,NULL,'3.6 micron, color corrected','NGC 3877',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84739,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84739,30.94,0.45,15.4,34705,NULL,NULL,'K','NGC 3877',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84740,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84740,30.98,0.1,15.7,34705,NULL,NULL,NULL,'NGC 3877',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84741,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84741,30.99,0.2,15.8,34705,74.4,NULL,NULL,'NGC 3877',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84742,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84742,31,0.38,15.8,34705,75,NULL,'W91CL, r, raw','NGC 3877',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84743,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84743,31,0.47,15.8,34705,75,NULL,'A82, H, cor','NGC 3877',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84744,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84744,31.1,0.38,16.6,34705,75,NULL,'W91CL, r, inv','NGC 3877',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84745,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84745,31.15,0.4,17,34705,75,NULL,'B','NGC 3877',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84746,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84746,31.16,0.49,17.1,34705,75,NULL,'IR','NGC 3877',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84747,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84747,31.18,0.38,17.2,34705,75,NULL,'W91CL, r, cor','NGC 3877',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84748,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84748,31.26,0.4,17.8,34705,NULL,NULL,'mean','NGC 3877',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84749,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84749,37.56,0.21,325,34706,70,NULL,NULL,'2MASX J11460851-0202053',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000073,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,176.535625,-2.03478,0.041,NULL,40808296929,637629639,9962963,17.1),(84750,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84750,33.57,NULL,51.7,34707,NULL,NULL,NULL,'FGC 1303',NULL,'2000BSAO...50....5K',2000,1,0.43,NULL,'G',0.000021,NULL,'17.4g',0.15,'Sdm',NULL,NULL,NULL,NULL,1,176.537333,12.87961,0.09,NULL,60241408601,941272009,14707375,17.4),(84751,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84751,33.6,NULL,52.4,34707,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1303',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84752,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84752,33.6,NULL,52.5,34707,NULL,NULL,'Dipole + Quadrupole','FGC 1303',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84753,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84753,33.63,NULL,53.2,34707,NULL,NULL,'Dipole','FGC 1303',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84754,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84754,36.54,0.46,203,34708,70,NULL,NULL,'2MASX J11460944+3756135',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.22',0.27,NULL,NULL,NULL,NULL,NULL,1,176.539167,37.937,0.018,NULL,60455503399,944617240,14759644,16.22),(84755,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84755,36.67,0.46,216,34709,70,NULL,NULL,'2MASX J11461081+2603342',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000166,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,176.5452083,26.05942,0,NULL,60595341473,946802210,14793784,16.3),(84756,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84756,37.06,0.46,258,34710,70,NULL,NULL,'2MASX J11461094+1547531',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000113,NULL,'16.1g',0.36,'S0',NULL,NULL,NULL,NULL,1,176.5457083,15.79803,0.109,NULL,60260266615,941566665,14711979,16.1),(84757,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84757,37.58,0.46,327,34711,70,NULL,NULL,'SDSS J114611.32+035946.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000134,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,176.5472083,3.99617,0.021,NULL,60196223380,940565990,14696343,18.3),(84758,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84758,36.15,NULL,170,34712,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1304',NULL,'2010Ap&SS.325..163P',2010,1,1.18,NULL,'G',0.000039,NULL,'16.2g',0.16,'Sbc',NULL,NULL,NULL,NULL,1,176.548625,33.734,0,NULL,60617253034,947144578,14799134,16.2),(84759,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84759,36.17,NULL,171,34712,NULL,NULL,'Dipole + Quadrupole','FGC 1304',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84760,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84760,36.18,NULL,172,34712,NULL,NULL,NULL,'FGC 1304',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84761,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84761,36.2,NULL,174,34712,NULL,NULL,'Dipole','FGC 1304',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84762,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84762,36.74,0.2,223,34712,74.4,NULL,NULL,'FGC 1304',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84763,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84763,34.33,0.69,73.6,34713,100,NULL,'mid-IR','NGC 3884',NULL,'2013ApJ...771...88L',2013,1,1.64,NULL,'G',0.00001,NULL,'13.5g',1.1,'SA(r)0/a;LINER Sy1','in a radial-velocity based grouping',NULL,NULL,'LINER b',1,176.55075,20.39164,0,NULL,61083663874,954432248,14913003,13.5),(84764,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84764,35.2,0.06,110,34713,NULL,NULL,NULL,'NGC 3884',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84765,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84765,35.24,0.2,112,34713,74.4,NULL,NULL,'NGC 3884',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84766,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84766,37.19,0.46,275,34714,70,NULL,NULL,'2MASXi J1146124+201736',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,176.5517917,20.29344,0,NULL,61083648257,954432004,14913000,17.5),(84767,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84767,38.06,0.33,410,34715,70,NULL,NULL,'2MASX J11461274+0523480',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,176.553041667,5.39672,0,NULL,60182059106,940344673,14692885,17.6),(84768,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84768,37.17,0.46,272,34716,70,NULL,NULL,'2MASX J11461358+1320241',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000135,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,176.556625,13.33994,0.073,NULL,60241681808,941276278,14707441,18.5),(84769,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84769,37.02,0.33,254,34717,70,NULL,NULL,'2MASX J11461388+3105231',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00018,NULL,'15.8g',0.43,NULL,NULL,NULL,NULL,NULL,1,176.55775,31.08972,0.027,NULL,60563884729,946310698,14786104,15.8),(84770,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84770,37.7,0.46,346,34718,70,NULL,NULL,'2MASX J11461414+5604149',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000179,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,176.5592083,56.07086,0,NULL,61977634578,968400540,15131258,17.4),(84771,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84771,38.02,0.46,403,34719,70,NULL,NULL,'2MASX J11461464+5935169',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,176.560958333,59.58806,0,NULL,61857525468,966523835,15101934,17.6),(84772,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84772,38.06,0.33,410,34720,70,NULL,NULL,'2MASX J11461556+0523020',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000155,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,176.56475,5.38397,0,NULL,60182177155,940346518,14692914,17.5),(84773,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84773,37.97,0.46,393,34721,70,NULL,NULL,'SDSS J114615.56+110912.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000135,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,176.564833,11.15356,0.07,NULL,60370968540,943296383,14739005,17.8),(84774,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84774,36.35,0.21,186,34722,70,NULL,NULL,'2MASX J11461611+5253509',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,176.56725,52.89753,0,NULL,61768062323,965125973,15080093,16.6),(84775,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84775,34.36,NULL,74.4,34723,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 012-079',NULL,'2010Ap&SS.325..163P',2010,1,1.72,NULL,'G',0.000013,NULL,'15.9g',0.19,'Sd(f)',NULL,NULL,NULL,NULL,1,176.57075,-3.17903,0.053,NULL,40866112755,638533011,9977078,15.9),(84776,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84776,34.37,NULL,74.9,34723,NULL,NULL,'Dipole + Quadrupole','CGCG 012-079',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84777,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84777,34.38,NULL,75,34723,NULL,NULL,'Dipole','CGCG 012-079',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84778,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84778,34.43,NULL,77,34723,NULL,NULL,NULL,'CGCG 012-079',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84779,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84779,34.57,0.49,82,34723,75,NULL,'IR','CGCG 012-079',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84780,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84780,35.76,0.15,142,34724,70,NULL,NULL,'NGC 3878',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000087,NULL,'14.9g',0.61,NULL,'Group member',NULL,NULL,NULL,1,176.574083333,33.20447,0,NULL,60617610207,947150159,14799221,14.9),(84781,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84781,37.22,0.46,278,34725,70,NULL,NULL,'2MASX J11461867+3805295',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,176.577667,38.0915,0.018,NULL,60455486344,944616974,14759640,17.7),(84782,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84782,38.22,0.46,441,34726,70,NULL,NULL,'2MASX J11461874+0957329',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,176.578083333,9.95906,0.098,NULL,60379816584,943434634,14741166,17.1),(84783,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84783,37.98,0.46,395,34727,70,NULL,NULL,'SDSS J114619.12+501116.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000133,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,176.579667,50.18803,0,NULL,61801370818,965646419,15088225,17.8),(84784,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84784,35.56,0.48,130,34728,70,NULL,NULL,'2MASX J11462057-4410052',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000117,NULL,'15.2b',NULL,'SA(rl)0^0',NULL,NULL,NULL,NULL,1,176.585541667,-44.16811,0.521,NULL,41877822009,654340968,10224077,15.2),(84785,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84785,36.11,0.46,167,34729,70,NULL,NULL,'2MASX J11462137+2351295',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000167,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,176.5892083,23.85817,0.047,NULL,60542048156,945969502,14780773,16.7),(84786,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84786,37.02,0.33,254,34730,70,NULL,NULL,'2MASX J11462151+3105041',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000176,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,176.589583,31.08444,0.027,NULL,60563897363,946310896,14786107,17.1),(84787,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84787,37.23,0.46,279,34731,70,NULL,NULL,'2MASX J11462162+3342381',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000155,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,176.5902917,33.71056,0,NULL,60618101742,947157839,14799341,16.6),(84788,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84788,37.03,0.46,255,34732,70,NULL,NULL,'2MASX J11462250+1251481',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000179,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,176.593667,12.86342,0.078,NULL,60241409257,941272019,14707375,16.7),(84789,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84789,37.63,0.46,336,34733,70,NULL,NULL,'SDSS J114622.54+510709.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,176.5939583,51.11925,0,NULL,61803017193,965672143,15088627,18.5),(84790,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84790,37.66,0.33,341,34734,70,NULL,NULL,'SDSS J114622.57+140143.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00018,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,176.594083,14.02872,0.106,NULL,60248273916,941379279,14709051,18.3),(84791,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84791,37.3,0.46,289,34735,70,NULL,NULL,'SDSS J114622.69+072605.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000143,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,176.594583,7.43492,0,NULL,60153618052,939900282,14685941,17.9),(84792,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84792,32.1,NULL,26.3,34736,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06747',NULL,'2010Ap&SS.325..163P',2010,1,1.47,'Multiple SDSS entries describe this source.','G',0.000013,NULL,'15.58',0.15,'Sdm',NULL,NULL,NULL,NULL,1,176.600333,13.82744,0.112,NULL,60248246379,941378849,14709044,15.58),(84793,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84793,32.11,NULL,26.5,34736,NULL,NULL,'Dipole + Quadrupole','UGC 06747',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84794,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84794,32.13,NULL,26.7,34736,NULL,NULL,'Dipole','UGC 06747',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84795,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84795,37.21,0.1,276,34737,70,NULL,NULL,'2MASXi J1146251+543255',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,176.604625,54.54878,0,NULL,61772354962,965193046,15081141,17.8),(84796,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84796,35.86,0.68,149,34738,70,NULL,NULL,'2MFGC 09239',NULL,'2014MNRAS.445.2677S',2014,1,0.71,NULL,'G',0.000082,NULL,'16.2g',0.15,'Sb(f)',NULL,NULL,NULL,NULL,1,176.6057083,-3.59692,0.045,NULL,40865772347,638527692,9976995,16.2),(84797,'Tully est','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84797,32,0.8,25.1,34739,75,NULL,'B','MRK 0429',NULL,'1988NBGC.C....0000T',1988,1,0.41,NULL,'G',0.000033,NULL,'16.4g',0.34,'S?',NULL,NULL,NULL,NULL,1,176.608208333,34.85253,0,NULL,60445366396,944458849,14757169,16.4),(84798,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84798,37.94,0.46,387,34740,70,NULL,NULL,'2MASX J11462647+0316096',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000076,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,176.610291667,3.26936,0.041,NULL,60193483794,940523184,14695674,17.9),(84799,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84799,38.35,0.46,468,34741,70,NULL,NULL,'2MASX J11462666+6313454',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000147,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,176.611167,63.22942,0.009,NULL,61818039908,965906873,15092294,17.5),(84800,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84800,37.66,0.33,341,34742,70,NULL,NULL,'2MASX J11462782+1351310',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000138,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,176.615875,13.85856,0.106,NULL,60248258014,941379031,14709047,17.4),(84801,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84801,36.71,0.46,220,34743,70,NULL,NULL,'2MASX J11462878+1608130',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.29',0.14,NULL,NULL,NULL,NULL,NULL,1,176.619916667,16.13683,0.092,NULL,60260557738,941571214,14712050,18.29),(84802,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84802,37.82,0.46,366,34744,70,NULL,NULL,'2MASX J11462909+3732173',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,176.621375,37.53806,0,NULL,60454834727,944606792,14759481,17.6),(84803,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84803,37.71,0.46,348,34745,70,NULL,NULL,'2MASX J11462989+1606070',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,176.624375,16.10192,0.093,NULL,60260585643,941571650,14712057,17.8),(84804,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84804,35.76,0.15,142,34746,70,NULL,NULL,'2MASX J11463068+3305271',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,176.628,33.09072,0,NULL,60617421186,947147206,14799175,16.4),(84805,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84805,37.37,0.46,297,34747,70,NULL,NULL,'2MASX J11463085+5334200',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000191,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,176.6285,53.57233,0,NULL,61773366673,965208854,15081388,16.8),(84806,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84806,36.45,0.46,195,34748,70,NULL,NULL,'2MASX J11463083+4535226',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000185,NULL,'15.6g',0.47,'S0^-',NULL,NULL,NULL,NULL,1,176.6285417,45.58961,0,NULL,63889487327,998273239,15598019,15.6),(84807,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84807,36.63,0.62,212,34749,70,NULL,NULL,'2MASX J11463139-1658264',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000103,NULL,'14.9I',0.2,NULL,NULL,NULL,NULL,NULL,1,176.630875,-16.97403,0.033,NULL,40992017765,640500277,10007816,14.9),(84808,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84808,37.51,0.46,317,34750,70,NULL,NULL,'2MASX J11463155+1146418',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,176.6315417,11.77839,0.036,NULL,60240638775,941259980,14707187,17.2),(84809,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84809,38,0.46,397,34751,70,NULL,NULL,'2MASX J11463160+0025316',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000087,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,176.631625,0.4255,0.033,NULL,60140008394,939687631,14682619,17.5),(84810,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84810,38.53,0.46,508,34752,70,NULL,NULL,'2MASX J11463198+5410479',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000178,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,176.633125,54.18006,0,NULL,61772758387,965199349,15081239,17.7),(84811,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84811,37.21,0.1,276,34753,70,NULL,NULL,'2MASX J11463254+5425529',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000174,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,176.635375,54.4315,0,NULL,61772287619,965191994,15081124,17.6),(84812,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84812,37.37,0.46,299,34754,70,NULL,NULL,'2MASX J11463351+2006396',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'16.70',0.14,NULL,NULL,NULL,NULL,NULL,1,176.63975,20.11086,0,NULL,61082959489,954421242,14912831,16.7),(84813,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84813,37.58,0.16,327,34755,70,NULL,NULL,'2MASX J11463441+1538130',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000161,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,176.6432917,15.63697,0.109,NULL,60260305158,941567268,14711988,16.7),(84814,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84814,35.76,0.15,142,34756,70,NULL,NULL,'NGC 3881',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.000097,NULL,'14.5g',0.74,NULL,'Group member',NULL,NULL,NULL,1,176.643375,33.10642,0,NULL,60617421625,947147212,14799175,14.5),(84815,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84815,35.26,0.07,113,34757,70,NULL,NULL,'ARK 322',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000093,NULL,'15.3',0.2,'S0','Group member',NULL,NULL,NULL,1,176.6434583,19.11011,0.007,NULL,60203812988,940684577,14698196,15.3),(84816,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84816,33.95,0.46,61.6,34758,70,NULL,NULL,'CGCG 292-027',NULL,'2015arXiv151105856S',2015,1,0.99,NULL,'G',0.00007,NULL,'14.5g',0.64,'E0',NULL,NULL,NULL,NULL,1,176.64725,61.75039,0.009,NULL,61865257916,966644654,15103822,14.5),(84817,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84817,37.36,0.46,297,34759,70,NULL,NULL,'2MASX J11463699+4406246',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00018,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,176.654083333,44.10675,0,NULL,63890586546,998290414,15598287,17.4),(84818,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84818,37.1,0.27,263,34760,70,NULL,NULL,'2MASX J11463711+1343311',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000199,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,176.654667,13.72525,0.112,NULL,60240802898,941262545,14707227,16.3),(84819,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84819,36.42,0.46,192,34761,70,NULL,NULL,'2MASX J11463749+3908283',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000149,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,176.656125,39.14114,0.049,NULL,60453909588,944592337,14759255,16.2),(84820,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84820,38.26,0.46,450,34762,70,NULL,NULL,'2MASX J11463788+2543460',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000144,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,176.65775,25.72936,0,NULL,60544778745,946012167,14781440,18.1),(84821,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84821,36.98,0.93,249,34763,70,NULL,NULL,'2MASX J11463799-3813571',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,176.658333,-38.2325,0.373,NULL,41399188748,646862324,10107223,15.7),(84822,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84822,36.76,0.12,225,34764,70,NULL,NULL,'2MASX J11463866+5543388',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000189,NULL,'16.1g',0.39,'E','Group member',NULL,NULL,NULL,1,176.660833,55.72747,0,NULL,61758749617,964980462,15077819,16.1),(84823,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84823,37.3,0.46,289,34765,70,NULL,NULL,'2MASX J11463880+2448480',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,176.661875,24.81322,0.063,NULL,60543310813,945989231,14781081,16.7),(84824,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84824,38.63,0.46,532,34766,70,NULL,NULL,'2MASX J11463925+0632498',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,176.663458333,6.54725,0,NULL,60151927107,939873861,14685529,18),(84825,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84825,35.84,0.46,147,34767,70,NULL,NULL,'2MASX J11463995+3546070',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000073,NULL,'15.5g',0.38,NULL,NULL,NULL,NULL,NULL,1,176.666583333,35.76869,0,NULL,60447809516,944497023,14757765,15.5),(84826,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84826,37.1,0.27,263,34768,70,NULL,NULL,'2MASX J11464040+1344421',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000181,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,176.66825,13.74511,0.112,NULL,60240791633,941262369,14707224,16.7),(84827,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84827,37.21,0.1,276,34769,70,NULL,NULL,'2MASX J11464041+5447561',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000174,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,176.6685417,54.79897,0,NULL,61758391250,964974863,15077732,16.9),(84828,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84828,37.88,0.46,377,34770,70,NULL,NULL,'2MASX J11464094+2129595',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,176.670417,21.5,0.044,NULL,61084334393,954442724,14913167,18.2),(84829,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84829,36.76,0.12,225,34771,70,NULL,NULL,'2MASX J11464172+5541578',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000182,NULL,'16.4g',0.38,'E','Group member',NULL,NULL,NULL,1,176.674041667,55.69953,0,NULL,61758741612,964980337,15077817,16.4),(84830,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84830,37.23,0.46,280,34772,70,NULL,NULL,'2MASX J11464207+2507350',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,176.675708333,25.12636,0.034,NULL,60544846775,946013230,14781456,17.7),(84831,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84831,36.85,0.46,235,34773,70,NULL,NULL,'2MASX J11464242+5336169',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000171,NULL,'16.1g',0.42,'E0',NULL,NULL,NULL,NULL,1,176.6767917,53.60489,0,NULL,61773359705,965208745,15081386,16.1),(84832,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84832,34.1,0.2,66.1,34774,74.4,NULL,NULL,'UGC 06751',NULL,'2013AJ....146...86T',2013,1,1.35,NULL,'G',0.00003,NULL,'14.8g',0.44,'Sbc',NULL,NULL,NULL,NULL,1,176.677375,23.96339,0.047,NULL,60542042887,945969420,14780772,14.8),(84833,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84833,37.72,0.46,351,34775,70,NULL,NULL,'2MASX J11464358+0952548',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000169,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,176.6815417,9.88183,0.066,NULL,60380254128,943441470,14741272,16.7),(84834,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84834,36.76,0.12,225,34776,70,NULL,NULL,'2MASX J11464402+5543031',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000175,NULL,'16.5g',0.28,'S0','Group member',NULL,NULL,NULL,1,176.683583333,55.71753,0,NULL,61758749183,964980455,15077819,16.5),(84835,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84835,36.4,0.46,190,34777,70,NULL,NULL,'2MASX J11464434-0153413',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000077,NULL,'15.9g',0.35,'S0',NULL,NULL,NULL,NULL,1,176.684667,-1.89475,0.045,NULL,40808471670,637632369,9963005,15.9),(84836,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84836,34.41,0.4,76.1,34778,NULL,NULL,'mean','ARP 248 NED02',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00003,NULL,'14.1',0.5,'SB(s)b: pec    HII','in a triple',NULL,NULL,NULL,1,176.688333,-3.84806,0.049,NULL,40868619745,638572183,9977690,14.1),(84837,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84837,34.72,0.47,88,34778,NULL,NULL,'H','ARP 248 NED02',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84838,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84838,37.56,0.46,326,34779,70,NULL,NULL,'2MASX J11464525+1712441',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,176.688667,17.21222,0.075,NULL,60202151135,940658611,14697790,17.2),(84839,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84839,37.21,0.1,276,34780,70,NULL,NULL,'2MASX J11464554+5441531',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,176.689833333,54.69814,0,NULL,61772367976,965193249,15081144,17.1),(84840,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84840,32.45,0.2,30.9,34781,74.4,NULL,NULL,'UGC 06753',NULL,'2013AJ....146...86T',2013,1,1.17,NULL,'G',0.000094,NULL,'14.9g',0.48,'SB(s)dm III-IV',NULL,NULL,NULL,NULL,1,176.692833,14.53306,0.094,NULL,60261745061,941589766,14712340,14.9),(84841,'Tully est','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84841,32.22,0.8,27.8,34782,75,NULL,'B','NGC 3885',NULL,'1988NBGC.C....0000T',1988,1,2.4,NULL,'G',0.000027,NULL,'11.89',1,'SAB(r:)0/a:    HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,176.6937083,-27.92217,0.349,NULL,41463659052,647869672,10122963,11.89),(84842,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84842,31.84,0.2,23.3,34782,74.4,NULL,NULL,'NGC 3885',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84843,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84843,37.94,0.33,388,34783,70,NULL,NULL,'2MASX J11464778+2407360',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000192,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,176.6989583,24.12664,0.058,NULL,60546377266,946037144,14781830,17.1),(84844,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84844,36.86,0.46,235,34784,70,NULL,NULL,'2MASX J11464850+6453365',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000153,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,176.702,64.89344,0.009,NULL,61821613753,965962714,15093167,17),(84845,'IRAS','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84845,31.9,0.8,23.9,34785,75,NULL,'A82, H','NGC 3879',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.00003,NULL,'13.59',0.5,'Sdm:','in a pair',NULL,NULL,NULL,1,176.705916667,69.38369,0,NULL,61341617366,958462771,14975980,13.59),(84846,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84846,32.08,0.47,26.1,34785,75,NULL,'A82, H, inv','NGC 3879',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84847,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84847,32.17,0.47,27.2,34785,75,NULL,'A82, H, raw','NGC 3879',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84848,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84848,32.25,0.43,28.1,34785,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3879',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84849,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84849,32.5,0.47,31.6,34785,75,NULL,'A82, H, cor','NGC 3879',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84850,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84850,38.33,0.46,464,34786,70,NULL,NULL,'2MASX J11464951+2456040',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,176.706417,24.93439,0.063,NULL,60545179645,946018431,14781537,17.8),(84851,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84851,37.21,0.1,276,34787,70,NULL,NULL,'2MASX J11465031+5435141',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,176.709625,54.58714,0,NULL,61772177437,965190272,15081098,17.2),(84852,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84852,38.09,0.33,415,34788,70,NULL,NULL,'SDSS J114650.37+052304.2',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000145,NULL,'17.7g',0.21,'AGN',NULL,NULL,NULL,NULL,1,176.709917,5.3845,0,NULL,60182230061,940347344,14692927,17.7),(84853,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84853,37.14,0.46,268,34789,70,NULL,NULL,'2MASX J11465113+1058478',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000142,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,176.712833333,10.97994,0.079,NULL,60379201784,943425027,14741016,17.6),(84854,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84854,37.1,0.27,263,34790,70,NULL,NULL,'2MASX J11465125+1340131',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,176.713625,13.67033,0.091,NULL,60240941771,941264715,14707261,17.4),(84855,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84855,37.94,0.33,388,34791,70,NULL,NULL,'SDSS J114651.74+240749.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00013,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,176.715625,24.13031,0.058,NULL,60546379336,946037177,14781830,18.8),(84856,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84856,38.06,0.15,409,34792,70,NULL,NULL,'2MASX J11465187+2516450',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,176.7162917,25.27922,0.034,NULL,60544882209,946013784,14781465,17.9),(84857,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84857,38.09,0.33,415,34793,70,NULL,NULL,'2MASX J11465201+0523315',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'17.9g',0.16,'AGN',NULL,NULL,NULL,NULL,1,176.716833,5.39222,0,NULL,60182230240,940347347,14692927,17.9),(84858,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84858,34.39,0.42,75.5,34794,NULL,NULL,NULL,'MCG -02-30-029',NULL,'2009ApJS..182..474S',2009,1,1.3,'Marginal HIPASS detection.','G',0.000033,NULL,'15',0.8,'SB(r)cd',NULL,NULL,NULL,NULL,1,176.7217083,-14.48519,0.029,NULL,41000581854,640634091,10009907,15),(84859,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84859,34.41,0.41,76.4,34794,NULL,NULL,'Malmquist cor.','MCG -02-30-029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84860,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84860,34.43,0.2,76.9,34794,74.4,NULL,NULL,'MCG -02-30-029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84861,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84861,36.95,0.46,245,34795,70,NULL,NULL,'SDSS J114653.33+191046.2',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,176.72225,19.1795,0,NULL,60203119377,940673740,14698027,17.6),(84862,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84862,37.94,0.46,387,34796,70,NULL,NULL,'2MASX J11465384+5613352',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,176.7245,56.22636,0,NULL,61978671302,968416739,15131511,17.5),(84863,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84863,38.17,0.46,431,34797,70,NULL,NULL,'2MASX J11465412+3951384',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,176.725417,39.86072,0,NULL,60408566477,943883851,14748185,18.3),(84864,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84864,36.89,0.46,239,34798,70,NULL,NULL,'2MASX J11465452+1455066',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00019,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,176.7272083,14.91867,0.086,NULL,60262091901,941595185,14712424,16.3),(84865,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84865,37.75,0.17,355,34799,70,NULL,NULL,'2MASX J11465505+0753211',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000196,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,176.729375,7.88925,0,NULL,60152728033,939886375,14685724,16.7),(84866,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84866,36.75,0.46,224,34800,70,NULL,NULL,'SDSS J114655.56+033245.7',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000094,NULL,'17.0g',0.2,'NLAGN',NULL,NULL,NULL,NULL,1,176.7315417,3.54603,0.049,NULL,60192810051,940512657,14695510,17),(84867,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84867,37.2,0.46,276,34801,70,NULL,NULL,'LCRS B114422.3-025201',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000107,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,176.73225,-3.14461,0.049,NULL,40866067850,638532310,9977067,16.6),(84868,'BCG','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84868,37.22,0.35,265,34802,60,NULL,NULL,'ABELL 1377',0.0509,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,176.741333333,55.73889,0,NULL,61758748453,964980444,15077819,NULL),(84869,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84869,37.55,0.46,323,34803,70,NULL,NULL,'2MASX J11465848+0320565',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000101,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,176.74375,3.34903,0.041,NULL,60193466387,940522912,14695670,16.6),(84870,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84870,37.58,0.16,327,34804,70,NULL,NULL,'SDSS J114659.06+151813.6',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000168,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,176.746083333,15.30378,0.089,NULL,60261955508,941593054,14712391,16.5),(84871,'TRGB','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84871,28.32,0.1,4.61,34805,74.4,NULL,NULL,'UGC 06757',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',NULL,NULL,'16.5',0.6,'DWARF',NULL,NULL,NULL,NULL,1,176.746166667,61.33556,0.049,NULL,61846633862,966353654,15099275,16.5),(84872,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84872,37.57,0.46,327,34806,70,NULL,NULL,'2MASX J11465908-0158178',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000077,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,176.74625,-1.97164,0.045,NULL,40808427998,637631687,9962995,17.3),(84873,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84873,37.69,0.21,346,34807,70,NULL,NULL,'2MASX J11465937+0716381',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000149,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,176.7472917,7.27742,0,NULL,60153314817,939895544,14685867,17.1),(84874,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84874,37.61,0.46,332,34808,70,NULL,NULL,'2MASX J11465988+0847171',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,176.749666667,8.78797,0.009,NULL,60378219137,943409674,14740776,17.9),(84875,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84875,38.06,0.15,409,34809,70,NULL,NULL,'2MASX J11470047+2528278',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000093,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,176.7522083,25.47458,0.03,NULL,60545009681,946015776,14781496,18),(84876,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84876,37.21,0.1,276,34810,70,NULL,NULL,'2MASX J11470076+5448242',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000215,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,176.753416667,54.80675,0,NULL,61758459752,964975933,15077748,16.2),(84877,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84877,38.7,0.46,549,34811,70,NULL,NULL,'SDSS J114700.90+051414.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,176.7537917,5.23747,0,NULL,60193605346,940525083,14695704,18.4),(84878,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84878,37.33,0.46,293,34812,70,NULL,NULL,'SDSS J114701.27+310516.4',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,176.755333,31.08792,0.034,NULL,60563904286,946311004,14786109,18.1),(84879,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84879,37.23,0.33,280,34813,70,NULL,NULL,'2MASX J11470175+1705337',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.33',0.15,NULL,NULL,NULL,NULL,NULL,1,176.7572917,17.09281,0.073,NULL,60201937924,940655280,14697738,18.33),(84880,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84880,37.24,0.46,280,34814,70,NULL,NULL,'2MASX J11470200+1551377',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000123,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,176.758417,15.86033,0.093,NULL,60260341682,941567838,14711997,17.9),(84881,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84881,36.12,0.46,167,34815,70,NULL,NULL,'2MASX J11470209+2054543',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000083,NULL,'15.4g',0.51,NULL,NULL,NULL,NULL,NULL,1,176.758583333,20.91519,0.037,NULL,61083186302,954424785,14912887,15.4),(84882,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84882,31.03,0.4,16.1,34816,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 3 galaxy group','NGC 3887',NULL,'1992ApJS...80..479T',1992,1,3.3,NULL,'G',0.000004,NULL,'11.41',2.5,'SB(r)bc        HII',NULL,NULL,NULL,NULL,1,176.769041667,-16.85461,0.049,NULL,40992042947,640500671,10007822,11.41),(84883,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84883,31.3,0.36,18.2,34816,NULL,NULL,NULL,'NGC 3887',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84884,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84884,31.3,0.39,18.2,34816,73,NULL,'opt','NGC 3887',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84885,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84885,31.43,0.4,19.3,34816,75,NULL,'B','NGC 3887',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84886,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84886,31.51,0.47,20.1,34816,NULL,NULL,'H','NGC 3887',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84887,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84887,31.52,0.45,20.1,34816,NULL,NULL,'K','NGC 3887',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84888,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84888,31.54,0.46,20.3,34816,NULL,NULL,'J','NGC 3887',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84889,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84889,31.62,0.4,21,34816,NULL,NULL,'mean','NGC 3887',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84890,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84890,38.13,0.46,422,34817,70,NULL,NULL,'2MASX J11470466+2536598',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000155,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,176.7695,25.61669,0.03,NULL,60544843292,946013176,14781455,17.7),(84891,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84891,37.26,0.21,284,34818,70,NULL,NULL,'2MASX J11470477+3459541',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000187,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,176.77,34.99833,0,NULL,60446150535,944471102,14757360,17.1),(84892,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84892,36.35,0.21,186,34819,70,NULL,NULL,'2MASX J11470530+5240456',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,176.771875,52.67919,0,NULL,61768306329,965129786,15080152,17.2),(84893,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84893,34.67,0.25,85.9,34820,74.4,NULL,NULL,'NGC 3886',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.00007,NULL,'14.11',0.9,'S0-:','in a radial-velocity based grouping',NULL,NULL,NULL,1,176.773333,19.83719,0,NULL,61082706375,954417287,14912770,14.11),(84894,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84894,35.26,0.07,113,34820,70,NULL,NULL,'NGC 3886',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84895,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84895,34.84,0.4,93.1,34820,NULL,NULL,'mean','NGC 3886',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84896,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84896,34.99,0.45,99.6,34820,NULL,NULL,'K','NGC 3886',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84897,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84897,35.62,0.46,133,34821,70,NULL,NULL,'2MASX J11470571+6547154',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000175,NULL,'15.7g',0.46,'S0',NULL,NULL,NULL,NULL,1,176.773833,65.78769,0.021,NULL,61809895819,965779622,15090306,15.7),(84898,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84898,37.61,0.46,333,34822,70,NULL,NULL,'2MASX J11470600+0038085',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000086,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,176.775041667,0.63569,0.029,NULL,60139980652,939687197,14682612,16.8),(84899,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84899,38.03,0.33,404,34823,70,NULL,NULL,'SDSS J114706.44+043939.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,176.776833333,4.66089,0.01,NULL,60194536238,940539628,14695931,18.5),(84900,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84900,38.19,0.33,435,34824,70,NULL,NULL,'2MASX J11470680+6021414',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,176.7782083,60.36142,0.041,NULL,61846383274,966349738,15099214,17.5),(84901,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84901,38.03,0.33,404,34825,70,NULL,NULL,'2MASX J11470721+0438295',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000178,NULL,'17.0g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,176.7800417,4.64161,0.01,NULL,60194522512,940539414,14695928,17),(84902,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84902,38.07,0.46,412,34826,70,NULL,NULL,'2MASX J11470724+0214295',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,176.780333,2.24153,0.057,NULL,60140144954,939689764,14682652,17.2),(84903,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84903,37.26,0.21,284,34827,70,NULL,NULL,'2MASX J11470784+3503390',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00018,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,176.782917,35.06078,0,NULL,60446156081,944471188,14757362,16.9),(84904,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84904,37.75,0.46,354,34828,70,NULL,NULL,'2MASX J11470868+5509412',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.3g',0.23,NULL,'Group member',NULL,NULL,NULL,1,176.78625,55.16161,0,NULL,61758800960,964981265,15077832,17.3),(84905,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84905,36.35,0.21,186,34829,70,NULL,NULL,'SDSS J114709.98+525026.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,176.791625,52.84064,0,NULL,61768057800,965125903,15080092,17.6),(84906,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84906,36.76,0.12,225,34830,70,NULL,NULL,'2MASX J11470996+5551112',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000172,NULL,'16.4g',0.31,'S0','Group member',NULL,NULL,NULL,1,176.79175,55.85319,0,NULL,61977434339,968397411,15131209,16.4),(84907,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84907,36.08,0.46,164,34831,70,NULL,NULL,'2MASX J11471127+2520039',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00014,NULL,'15.5g',0.4,NULL,NULL,NULL,NULL,NULL,1,176.7970417,25.33431,0.034,NULL,60544887217,946013862,14781466,15.5),(84908,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84908,37.88,0.46,376,34832,70,NULL,NULL,'2MASX J11471141-0153208',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000086,NULL,'16.9g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,176.797458333,-1.88906,0.053,NULL,40808443374,637631927,9962998,16.9),(84909,'TRGB','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84909,28.27,NULL,4.51,34833,NULL,NULL,NULL,'LEDA 166115',NULL,'2003A&A...398..467K',2003,1,0.6,NULL,'G',0.000002,NULL,'17.5',0.4,'dwarf Irr?',NULL,NULL,NULL,NULL,1,176.798333,43.67167,0,NULL,63890681547,998291899,15598310,17.5),(84910,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84910,36.11,0.46,167,34834,70,NULL,NULL,'2MASX J11471184+5750452',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,176.799541667,57.84583,0,NULL,61843427364,966303552,15098493,16.5),(84911,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84911,37.88,0.21,377,34835,70,NULL,NULL,'SDSS J114713.32+114409.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00017,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,176.8055417,11.736,0.051,NULL,60239739750,941245933,14706967,17.9),(84912,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84912,37.75,0.17,355,34836,70,NULL,NULL,'2MASX J11471410+0751511',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000151,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,176.8087083,7.86417,0,NULL,60152820875,939887826,14685747,17.4),(84913,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84913,38.24,0.46,444,34837,70,NULL,NULL,'2MASX J11471424+0408525',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,176.809333,4.148,0.041,NULL,60196358185,940568096,14696376,17.9),(84914,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84914,38.06,0.15,409,34838,70,NULL,NULL,'2MASX J11471450+2529389',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000146,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,176.8105417,25.49417,0.03,NULL,60545017157,946015893,14781498,17.5),(84915,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84915,36.83,0.46,232,34839,70,NULL,NULL,'2MASX J11471499+1842572',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.0001,NULL,'17.60',0.21,NULL,NULL,NULL,NULL,NULL,1,176.8125417,18.71589,0.01,NULL,60203703301,940682864,14698169,17.6),(84916,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84916,37.58,0.16,327,34840,70,NULL,NULL,'SDSS J114716.27+153748.8',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000181,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,176.817833333,15.63022,0.087,NULL,60260128290,941564504,14711945,18.7),(84917,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84917,37.75,0.17,355,34841,70,NULL,NULL,'2MASX J11471632+0756031',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000189,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,176.817917,7.93417,0,NULL,60152816227,939887753,14685746,16.4),(84918,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84918,37.77,0.46,358,34842,70,NULL,NULL,'2MASX J11471686+1209247',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000182,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,176.820208333,12.15697,0.06,NULL,60240078840,941251231,14707050,16.9),(84919,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84919,37.75,0.17,355,34843,70,NULL,NULL,'2MASX J11471787+0756381',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.90',0.17,NULL,NULL,NULL,NULL,NULL,1,176.824333,7.94386,0,NULL,60152861175,939888455,14685757,17.9),(84920,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84920,36.63,0.46,212,34844,70,NULL,NULL,'2MASX J11471832+4233430',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000145,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,176.826333,42.56186,0,NULL,60413512957,943961139,14749392,17.3),(84921,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84921,37.23,0.33,280,34845,70,NULL,NULL,'2MASX J11471925+1711267',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000107,NULL,'17.40',0.21,NULL,NULL,NULL,NULL,NULL,1,176.830375,17.19078,0.075,NULL,60201915372,940654927,14697733,17.4),(84922,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84922,38.22,0.33,441,34846,70,NULL,NULL,'LCRS B114445.8-025157',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000071,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,176.8305417,-3.14358,0.057,NULL,40865301192,638520331,9976880,18),(84923,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,'R',84923,36.76,0.12,225,34847,70,NULL,NULL,'MCG +09-19-183',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000173,NULL,'15.8g',0.5,'E','Group member',NULL,NULL,NULL,1,176.831875,56.03644,0,NULL,61977454101,968397720,15131214,15.8),(84924,'FP','2016-12-15 15:14:51','2016-12-16 11:19:59','1',NULL,NULL,84924,36.21,0.51,174,34848,70,NULL,NULL,'2MASX J11471974-5043574',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,176.832166667,-50.73258,0.777,NULL,40055194917,625862420,9779100,15),(84925,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84925,36.76,0.12,225,34849,70,NULL,NULL,'MCG +09-19-181',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000193,NULL,'15.7g',0.41,'S0','Group member',NULL,NULL,NULL,1,176.832667,55.68353,0,NULL,61758745015,964980390,15077818,15.7),(84926,'BCG','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,84926,37.22,0.35,265,34850,60,NULL,'ABELL 1377, BCG','MCG +09-19-182',0.0509,'1980ApJ...241..486H',1980,1,0.74,NULL,'G',0.000187,NULL,'15.1g',0.66,'S0','Group member',NULL,NULL,NULL,1,176.839083,55.73011,0,NULL,61758744282,964980379,15077818,15.1),(84927,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84927,36.76,0.12,225,34850,70,NULL,NULL,'MCG +09-19-182',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84928,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84928,38.86,0.46,592,34851,70,NULL,NULL,'2MASX J11472176+1439007',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000151,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,176.840583333,14.65008,0.094,NULL,60261755140,941589924,14712342,17.7),(84929,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84929,37.26,0.21,284,34852,70,NULL,NULL,'CGCG 186-048',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.00013,NULL,'15.5g',0.46,'BLLAC?         Sy2','Group member',NULL,'radio jet','Flat-Spectrum Radio Source',1,176.8422083,35.01875,0,NULL,60446161115,944471267,14757363,15.5),(84930,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84930,37.26,0.21,284,34853,70,NULL,NULL,'2MASX J11472258+3459411',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000174,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,176.844125,34.99481,0,NULL,60446116033,944470563,14757352,17.9),(84931,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84931,37.32,0.46,291,34854,70,NULL,NULL,'2MASX J11472347+0221333',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000083,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,176.84775,2.35936,0.057,NULL,60140264242,939691628,14682681,16.9),(84932,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84932,38.29,0.46,454,34855,70,NULL,NULL,'2MASX J11472355+2747539',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000177,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,176.848167,27.79817,0.089,NULL,60592402981,946756296,14793067,18),(84933,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84933,36.26,0.21,179,34856,70,NULL,NULL,'2MASX J11472448+3728589',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000163,NULL,'16.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,176.852167,37.48319,0,NULL,60436933415,944327084,14755110,16.6),(84934,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84934,37.75,0.17,355,34857,70,NULL,NULL,'2MASX J11472476+0751484',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,176.853333,7.86344,0,NULL,60152822408,939887850,14685747,16.9),(84935,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84935,37.47,0.46,312,34858,70,NULL,NULL,'2MASX J11472595+0929154',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000155,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,176.858083,9.48764,0.019,NULL,60378557388,943414959,14740858,17.1),(84936,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84936,37.69,0.21,346,34859,70,NULL,NULL,'2MASX J11472642+0702554',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000172,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,176.860083,7.04886,0,NULL,60153678772,939901230,14685956,17.9),(84937,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84937,37.75,0.17,355,34860,70,NULL,NULL,'2MASX J11472685+0752364',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,176.8619583,7.87681,0,NULL,60152823193,939887862,14685747,17.2),(84938,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84938,38.89,0.46,599,34861,70,NULL,NULL,'SDSS J114727.15+400559.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000177,NULL,'18.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,176.863125,40.09994,0,NULL,60408673494,943885523,14748211,18.4),(84939,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84939,36.76,0.12,225,34862,70,NULL,NULL,'2MASX J11472724+5545041',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000186,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,176.863666667,55.75117,0,NULL,61758528128,964977002,15077765,17.5),(84940,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84940,36.79,0.46,228,34863,70,NULL,NULL,'2MASX J11472758+2253411',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000141,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,176.864875,22.89483,0.027,NULL,61070127100,954220735,14909698,17.4),(84941,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84941,37.26,0.21,284,34864,70,NULL,NULL,'2MASX J11472763+3502051',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000177,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,176.865333,35.03483,0,NULL,60446153562,944471149,14757361,17.5),(84942,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,84942,34.98,0.12,99.3,34865,NULL,NULL,NULL,'CGCG 097-151',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000019,NULL,'15.6',0.2,'Sa:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,176.867666667,18.05367,0,NULL,60202198063,940659344,14697802,15.6),(84943,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84943,38.69,0.46,547,34866,70,NULL,NULL,'SDSS J114728.34+190413.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.2g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,176.868125,19.07044,0.011,NULL,60203797718,940684339,14698192,18.2),(84944,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84944,37.88,0.21,377,34867,70,NULL,NULL,'2MASX J11473031+1143474',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,176.87625,11.72986,0.051,NULL,60239728983,941245765,14706965,17.4),(84945,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84945,37.72,0.46,350,34868,70,NULL,NULL,'SDSS J114730.42+101105.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000145,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,176.8767917,10.18478,0.044,NULL,60379880462,943435632,14741181,18.4),(84946,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84946,38.46,0.46,493,34869,70,NULL,NULL,'2MASX J11473071+2928398',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00017,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,176.877917,29.47789,0.037,NULL,60562456356,946288380,14785755,17.9),(84947,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84947,37.21,0.1,276,34870,70,NULL,NULL,'2MASX J11473079+5444380',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000185,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,176.878,54.74383,0,NULL,61758290962,964973296,15077707,17),(84948,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84948,36.78,0.46,227,34871,70,NULL,NULL,'2MASX J11473143+2208331',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.0001,NULL,'16.1g',0.38,NULL,NULL,NULL,NULL,NULL,1,176.8809583,22.14261,0.046,NULL,61070521355,954226896,14909795,16.1),(84949,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84949,38.06,0.15,409,34872,70,NULL,NULL,'2MASX J11473208+2528490',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000083,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,176.883583333,25.48017,0.03,NULL,60545038494,946016226,14781503,17),(84950,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84950,38.06,0.15,409,34873,70,NULL,NULL,'2MASX J11473327+2525490',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000135,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,176.888458333,25.43031,0.03,NULL,60545031624,946016119,14781501,18.3),(84951,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84951,35.87,0.46,150,34874,70,NULL,NULL,'2MASX J11473329+2337201',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.000067,NULL,'15.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,176.888625,23.62214,0.037,NULL,60545966150,946030721,14781730,15.4),(84952,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84952,37.75,0.17,355,34875,70,NULL,NULL,'SDSS J114734.05+075532.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000167,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,176.891916667,7.92556,0,NULL,60152813397,939887709,14685745,18.2),(84953,'Sosies','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,84953,33.09,0.58,41.5,34876,NULL,NULL,NULL,'NGC 3888',NULL,'2002A&A...393...57T',2002,1,1.31,NULL,'G',0.000037,NULL,'12.7g',1.15,'SAB(rs)c       Sbrst','in a pair',NULL,NULL,'Starburst',1,176.8932083,55.96722,0,NULL,61977456832,968397763,15131215,12.7),(84954,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,84954,32.87,0.4,37.5,34876,75,NULL,'B','NGC 3888',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84955,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,84955,33,0.45,39.7,34876,NULL,NULL,'K','NGC 3888',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84956,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,84956,33.03,0.4,40.3,34876,NULL,NULL,'mean','NGC 3888',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84957,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,84957,33.06,0.47,40.9,34876,NULL,NULL,'H','NGC 3888',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84958,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,84958,33.1,0.46,41.8,34876,NULL,NULL,'J','NGC 3888',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84959,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84959,37.88,0.21,377,34877,70,NULL,NULL,'SDSS J114734.42+113833.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000143,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,176.893416667,11.64253,0.053,NULL,60239877701,941248089,14707001,18.2),(84960,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84960,38.06,0.15,409,34878,70,NULL,NULL,'2MASX J11473511+2527540',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000194,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,176.896166667,25.46506,0.03,NULL,60545030732,946016105,14781501,17.4),(84961,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84961,38.19,0.33,435,34879,70,NULL,NULL,'SDSS J114736.56+602324.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000129,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,176.902375,60.39003,0.041,NULL,61846348101,966349189,15099206,18.6),(84962,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84962,38.06,0.15,409,34880,70,NULL,NULL,'SDSS J114736.73+252241.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000133,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,176.903041667,25.37808,0.03,NULL,60544864868,946013513,14781461,18.7),(84963,'IRAS','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,84963,34.61,0.8,83.4,34881,75,NULL,'HMCL, I','CGCG 097-152',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000007,NULL,'15.52',0.4,'Sbc            PAS','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,176.913917,19.93936,0,NULL,61082704234,954417253,14912769,15.52),(84964,'IRAS','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,84964,34.61,0.8,83.6,34881,75,NULL,'W91CL, r','CGCG 097-152',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84965,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,84965,34.93,0.07,97,34881,NULL,NULL,NULL,'CGCG 097-152',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84966,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,84966,35.21,0.4,110,34881,75,NULL,'HMCL, I, raw','CGCG 097-152',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84967,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,84967,35.22,0.2,111,34881,74.4,NULL,NULL,'CGCG 097-152',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84968,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,84968,35.29,0.43,114,34881,75,NULL,'3.6 micron, color corrected','CGCG 097-152',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84969,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,84969,35.33,0.38,116,34881,75,NULL,'W91CL, r, raw','CGCG 097-152',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84970,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,84970,35.39,0.4,120,34881,75,NULL,'HMCL, I, cor','CGCG 097-152',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84971,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,84971,35.41,0.4,121,34881,75,NULL,'HMCL, I, inv','CGCG 097-152',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84972,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,84972,35.47,0.43,124,34881,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 097-152',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84973,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,84973,35.49,0.38,126,34881,75,NULL,'W91CL, r, inv','CGCG 097-152',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84974,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,84974,35.52,0.38,127,34881,75,NULL,'W91CL, r, cor','CGCG 097-152',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(84975,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84975,38.04,0.46,406,34882,70,NULL,NULL,'SDSS J114739.66+344200.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00014,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,176.91525,34.70008,0,NULL,60445269282,944457332,14757145,18.7),(84976,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84976,37.66,0.46,341,34883,70,NULL,NULL,'2MASX J11474075+4008099',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,176.919833,40.13597,0,NULL,60408663446,943885366,14748208,17),(84977,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84977,38.44,0.33,487,34884,70,NULL,NULL,'2MASX J11474294+2741411',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000177,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,176.9287917,27.69458,0.089,NULL,60592436191,946756815,14793075,17),(84978,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84978,37.69,0.21,346,34885,70,NULL,NULL,'2MASX J11474348+0700524',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000182,NULL,'16.5g',0.36,'BrClG',NULL,NULL,NULL,NULL,1,176.93125,7.0145,0,NULL,60153684486,939901320,14685958,16.5),(84979,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84979,37.39,0.33,300,34886,70,NULL,NULL,'2MASX J11474388+3637211',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,176.9327917,36.62256,0,NULL,60445138551,944455289,14757113,18.1),(84980,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84980,37.42,0.46,305,34887,70,NULL,NULL,'2MASX J11474441+1434113',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.0001,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,176.934917,14.56969,0.089,NULL,60261772008,941590187,14712346,16.4),(84981,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84981,38.22,0.33,441,34888,70,NULL,NULL,'LCRS B114510.9-024902',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000087,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,176.935083333,-3.09508,0.057,NULL,40865359954,638521249,9976894,17.8),(84982,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84982,37.49,0.46,315,34889,70,NULL,NULL,'2MASX J11474606+3534364',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,176.942,35.57667,0,NULL,60445876977,944466827,14757294,17.6),(84983,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84983,37.34,0.46,293,34890,70,NULL,NULL,'2MASX J11474652+4441291',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000188,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,176.943917,44.69131,0,NULL,63891767256,998308863,15598575,17.8),(84984,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84984,34.65,0.46,85.2,34891,70,NULL,NULL,'SDSS J114746.55+552324.1',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000148,NULL,'16.1g',0.23,'S0','Group member',NULL,NULL,NULL,1,176.944,55.39003,0,NULL,61758676648,964979322,15077801,16.1),(84985,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84985,37.69,0.21,346,34892,70,NULL,NULL,'2MASX J11474818+0703004',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,176.9505417,7.04994,0,NULL,60153684036,939901313,14685958,17.5),(84986,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84986,36.76,0.12,225,34893,70,NULL,NULL,'NGC 3889',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000188,NULL,'15.4g',0.43,'E0',NULL,NULL,NULL,NULL,1,176.9505417,56.01833,0,NULL,61977399753,968396871,15131201,15.4),(84987,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84987,38.13,0.46,423,34894,70,NULL,NULL,'2MASX J11474849+6831310',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000072,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,176.951583,68.52542,0,NULL,61338046352,958406974,14975108,17.6),(84988,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84988,38.44,0.46,487,34895,70,NULL,NULL,'SDSS J114748.89+122156.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,176.95375,12.36581,0.061,NULL,60240132747,941252074,14707063,18.4),(84989,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84989,37.88,0.21,377,34896,70,NULL,NULL,'SDSS J114749.23+114913.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,176.955167,11.8205,0.051,NULL,60239773586,941246462,14706975,17.8),(84990,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84990,36.87,0.46,236,34897,70,NULL,NULL,'2MASX J11474935+3609501',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,176.9557083,36.16383,0,NULL,60444451768,944444558,14756946,17.1),(84991,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84991,36.67,0.46,216,34898,70,NULL,NULL,'2MASX J11474973+2306218',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000097,NULL,'15.7g',0.47,NULL,NULL,NULL,NULL,NULL,1,176.95725,23.10614,0.025,NULL,60534330199,945848909,14778889,15.7),(84992,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84992,38.24,0.46,445,34899,70,NULL,NULL,'LCRS B114516.3-025443',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000084,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,176.957667,-3.18969,0.049,NULL,40865279561,638519993,9976874,18.3),(84993,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84993,38.17,0.46,431,34900,70,NULL,NULL,'2MASX J11475054-0143402',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000085,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,176.9604583,-1.72794,0.061,NULL,40807898774,637623418,9962865,17.9),(84994,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84994,38.06,0.15,409,34901,70,NULL,NULL,'2MASX J11475069+2531451',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000141,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,176.961167,25.52919,0.03,NULL,60545037511,946016211,14781503,17.4),(84995,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84995,36.76,0.12,225,34902,70,NULL,NULL,'2MASX J11475088+5559212',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000179,NULL,'16.4g',0.26,'S0','Group member',NULL,NULL,NULL,1,176.961833,55.98922,0,NULL,61977400996,968396890,15131201,16.4),(84996,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84996,37.32,0.46,291,34903,70,NULL,NULL,'2MASX J11475093+1114194',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000206,NULL,'16.3g',0.32,'E0',NULL,NULL,NULL,NULL,1,176.9622917,11.23881,0.052,NULL,60370724685,943292573,14738946,16.3),(84997,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84997,38.06,0.15,409,34904,70,NULL,NULL,'2MASX J11475158+2529521',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,176.964875,25.49797,0.03,NULL,60545039880,946016248,14781503,17.7),(84998,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84998,37.93,0.46,385,34905,70,NULL,NULL,'2MASX J11475242+1518173',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,176.9682917,15.30481,0.086,NULL,60261973299,941593332,14712395,18),(84999,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',84999,38.1,0.33,416,34906,70,NULL,NULL,'2MASX J11475257+1529283',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000168,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,176.9690417,15.49119,0.087,NULL,60261926147,941592596,14712384,17.2),(85000,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85000,37.88,0.21,377,34907,70,NULL,NULL,'2MASX J11475266+1147194',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000199,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,176.969458333,11.78878,0.051,NULL,60239758355,941246224,14706972,17.9),(85001,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85001,37.25,0.46,282,34908,70,NULL,NULL,'2MASX J11475430+0423382',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,176.97625,4.39408,0.008,NULL,60194246811,940535106,14695861,17.7),(85002,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85002,36.26,0.21,179,34909,70,NULL,NULL,'2MASX J11475434+3726111',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000182,NULL,'15.8g',0.38,NULL,NULL,NULL,NULL,NULL,1,176.9765,37.43647,0,NULL,60436956378,944327443,14755116,15.8),(85003,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85003,38.02,0.46,402,34910,70,NULL,NULL,'SDSS J114754.37-003222.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000075,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,176.9765417,-0.53967,0.045,NULL,40809393875,637646779,9963230,18.2),(85004,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85004,37.42,0.46,305,34911,70,NULL,NULL,'2MASX J11475894+6817020',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000076,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,176.995333,68.28394,0,NULL,62076215488,969940867,15155326,17.7),(85005,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85005,38.26,0.46,448,34912,70,NULL,NULL,'2MASX J11475909+5238290',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,176.9962083,52.64156,0,NULL,61768109105,965126704,15080104,18.2),(85006,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85006,36.89,0.46,238,34913,70,NULL,NULL,'2MASX J11475984+1248004',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,176.9994583,12.80025,0.069,NULL,60241229152,941269205,14707331,17.4),(85007,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85007,33.96,0.47,61.8,34914,NULL,NULL,'H','UGC 06771',NULL,'2007A&A...465...71T',2007,1,1.64,NULL,'G',0.000027,NULL,'13.8g',1.19,'(R\')SAB(r)ab','Isolated galaxy',NULL,NULL,NULL,1,177.0009583,4.48814,0.008,NULL,60194269390,940535459,14695866,13.8),(85008,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85008,34.09,0.45,65.8,34914,NULL,NULL,'K','UGC 06771',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85009,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85009,34.09,0.46,65.9,34914,NULL,NULL,'J','UGC 06771',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85010,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85010,34.71,0.4,87.5,34914,NULL,NULL,'mean','UGC 06771',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85011,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85011,37.21,0.1,276,34915,70,NULL,NULL,'2MASX J11480023+5438192',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000172,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,177.0009583,54.63869,0,NULL,61772161208,965190018,15081094,17.5),(85012,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85012,29.97,0.2,9.86,34916,74.4,NULL,NULL,'UGC 06773',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.000005,NULL,'14.80',0.8,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,177.002,49.80825,0,NULL,61746414209,964787722,15074808,14.8),(85013,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85013,30.78,0.36,14.3,34916,NULL,NULL,NULL,'UGC 06773',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85014,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85014,37.21,0.1,276,34917,70,NULL,NULL,'2MASX J11480080+5435452',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,177.0035,54.59592,0,NULL,61772197305,965190582,15081102,16.7),(85015,'Tully est','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85015,32.17,0.8,27.2,34918,75,NULL,'B','NGC 3892',NULL,'1988NBGC.C....0000T',1988,1,3,NULL,'G',0.000057,NULL,'13.50',2.2,'SB(rs)0+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,177.004125,-10.96206,0.009,NULL,41034156742,641158699,10018104,13.5),(85016,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85016,37.69,0.21,346,34919,70,NULL,NULL,'2MASX J11480157+0710064',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000143,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,177.006667,7.16831,0,NULL,60153199308,939893739,14685839,17.8),(85017,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85017,37.76,0.46,357,34920,70,NULL,NULL,'SDSS J114801.72+105531.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000138,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,177.007167,10.92542,0.071,NULL,60379319243,943426863,14741044,18.3),(85018,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85018,36.95,0.47,246,34921,NULL,NULL,'Malmquist cor.','LCRS B114528.4-032546',NULL,'2009ApJS..182..474S',2009,1,0.53,NULL,'G',0.000017,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,177.007917,-3.70719,0.053,NULL,40865734676,638527104,9976986,17),(85019,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85019,36.97,0.47,247,34921,NULL,NULL,NULL,'LCRS B114528.4-032546',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85020,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85020,37.01,0.2,252,34921,74.4,NULL,NULL,'LCRS B114528.4-032546',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85021,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85021,36.46,0.46,196,34922,70,NULL,NULL,'CGCG 097-154',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.001251,NULL,'15.7',0.3,'S0/a',NULL,NULL,NULL,NULL,1,177.012625,18.64939,0.015,NULL,60211631445,940806741,14700105,15.7),(85022,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85022,34.79,0.46,90.7,34923,70,NULL,NULL,'CGCG 243-006',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000157,NULL,'15.2g',0.38,'E0',NULL,NULL,NULL,NULL,1,177.0137917,46.17461,0,NULL,63889445679,998272588,15598009,15.2),(85023,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85023,33.89,0.25,60,34924,74.4,NULL,NULL,'CGCG 097-155',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000017,NULL,'14.75',0.7,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,177.014041667,20.00633,0.009,NULL,61071217746,954237777,14909965,14.75),(85024,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85024,34.14,0.46,67.3,34924,70,NULL,NULL,'CGCG 097-155',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85025,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85025,35.1,0.05,105,34924,NULL,NULL,NULL,'CGCG 097-155',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85026,'SNIa','2016-12-15 15:14:51','2016-12-16 11:20:00','1','SN 2006or',NULL,85026,34.25,0.2,69.4,34925,74.2,NULL,'SALT 2','NGC 3891',0.020744,'2010ApJ...716..712A',2010,1,1.54,NULL,'G',0.000168,NULL,'13.3g',1.15,'Sbc            HII','Field galaxy',NULL,NULL,NULL,1,177.014,30.35933,0.036,NULL,60564014244,946312722,14786136,13.3),(85027,'SNIa','2016-12-15 15:14:51','2016-12-16 11:20:00','1','SN 2006or',NULL,85027,35.04,0.08,102,34925,74.4,NULL,NULL,'NGC 3891',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85028,'SNIa','2016-12-15 15:14:51','2016-12-16 11:20:00','1','SN 2006or',NULL,85028,35.59,0.26,129,34925,65,NULL,'MLCS17','NGC 3891',0.020744,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85029,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85029,34.92,0.4,96.3,34925,NULL,NULL,'mean','NGC 3891',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85030,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85030,34.95,0.36,97.8,34925,NULL,NULL,'Malmquist cor.','NGC 3891',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85031,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85031,35.01,0.35,100,34925,NULL,NULL,NULL,'NGC 3891',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85032,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85032,35.04,0.08,102,34925,74.4,NULL,NULL,'NGC 3891',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85033,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85033,35.05,0.4,102,34925,75,NULL,'HOSTS SN 2006or','NGC 3891',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85034,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85034,35.07,0.47,103,34925,NULL,NULL,'H','NGC 3891',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85035,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85035,35.09,0.45,104,34925,NULL,NULL,'K','NGC 3891',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85036,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85036,35.13,0.46,106,34925,NULL,NULL,'J','NGC 3891',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85037,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85037,37.21,0.1,276,34926,70,NULL,NULL,'2MASX J11480349+5446392',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,177.014625,54.77742,0,NULL,61758284296,964973192,15077706,17.9),(85038,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85038,37.01,0.46,253,34927,70,NULL,NULL,'2MASX J11480368+1956308',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,177.015417,19.94203,0,NULL,61071179025,954237172,14909955,17.7),(85039,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85039,38.43,0.46,486,34928,70,NULL,NULL,'SDSS J114803.80+565425.7',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,177.015875,56.90711,0,NULL,61978858678,968419666,15131557,17.6),(85040,'BCG','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85040,38.48,0.35,450,34929,60,NULL,'ABELL 1382, BCG','2MASX J11480396+7124230',0.1046,'1980ApJ...241..486H',1980,1,NULL,NULL,'G',0.000334,NULL,NULL,NULL,'cD','Brightest group member',NULL,NULL,NULL,1,177.016291667,71.40636,0.013,NULL,61344578904,958509045,14976703,NULL),(85041,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85041,36.26,0.21,179,34930,70,NULL,NULL,'VV 673 NED01',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000218,NULL,'14.8g',0.2,'E',NULL,NULL,NULL,NULL,1,177.019125,37.44386,0,NULL,60436943998,944327249,14755113,14.8),(85042,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85042,37.21,0.1,276,34931,70,NULL,NULL,'2MASX J11480494+5435372',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000192,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,177.020833,54.59375,0,NULL,61772196113,965190564,15081102,17.1),(85043,'BCG','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85043,37.94,0.35,365,34932,60,NULL,'ABELL 1383, BCG','MCG +09-19-193 NED01',0.0598,'1980ApJ...241..486H',1980,1,0.67,NULL,'G',0.0002,NULL,'15.6g',0.55,'BrClG','Pair member (points to parent)',NULL,NULL,NULL,1,177.024583,54.64628,0,NULL,61758279688,964973120,15077705,15.6),(85044,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85044,37.54,0.46,323,34933,70,NULL,NULL,'2MASX J11480595-0141192',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000086,NULL,'16.9g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,177.024708333,-1.68869,0.061,NULL,40807919688,637623745,9962871,16.9),(85045,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85045,37.64,0.33,337,34934,70,NULL,NULL,'2MASX J11480692+4158584',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000192,NULL,'16.7g',0.35,NULL,NULL,NULL,NULL,NULL,1,177.029125,41.98303,0,NULL,60413774079,943965219,14749456,16.7),(85046,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85046,37.84,0.46,369,34935,70,NULL,NULL,'2MASX J11480771+1130484',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,177.0322083,11.51356,0.059,NULL,60239700462,941245319,14706958,17),(85047,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85047,37.72,0.46,350,34936,70,NULL,NULL,'2MASX J11480814+5554011',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000191,NULL,'16.9g',0.28,NULL,'Group member',NULL,NULL,NULL,1,177.034,55.90033,0,NULL,61977405092,968396954,15131202,16.9),(85048,'BCG','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85048,37.94,0.35,365,34937,60,NULL,NULL,'ABELL 1383',0.0598,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,177.03825,54.62214,0,NULL,61772140623,965189697,15081089,NULL),(85049,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85049,38.1,0.33,416,34938,70,NULL,NULL,'2MASX J11480972+1532214',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,177.040625,15.53925,0.09,NULL,60253802356,941465661,14710400,17.8),(85050,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85050,37.21,0.1,276,34939,70,NULL,NULL,'2MASX J11480989+5435331',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00018,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,177.0409583,54.59269,0,NULL,61772142138,965189720,15081089,16.4),(85051,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85051,37.76,0.46,357,34940,70,NULL,NULL,'2MASX J11481002+4631434',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000135,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,177.041833,46.52869,0.015,NULL,61742710666,964729854,15073903,17.7),(85052,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85052,37.37,0.46,297,34941,70,NULL,NULL,'2MASX J11481084+6443504',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000083,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,177.044833,64.73061,0.009,NULL,61821676304,965963692,15093182,17.2),(85053,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85053,38.29,0.46,456,34942,70,NULL,NULL,'2MASX J11481097+2404224',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000139,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,177.045833,24.07303,0.044,NULL,60546553572,946039899,14781873,17.8),(85054,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85054,33.18,NULL,43.3,34943,NULL,NULL,'Dipole','UGC 06774',NULL,'2010Ap&SS.325..163P',2010,1,1.55,NULL,'G',0.000047,NULL,'15.2g',0.32,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,177.047167,54.99181,0,NULL,61758349478,964974210,15077722,15.2),(85055,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85055,33.19,NULL,43.5,34943,NULL,NULL,'Dipole + Quadrupole','UGC 06774',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85056,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85056,33.19,NULL,43.5,34943,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06774',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85057,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85057,33.67,0.2,54.2,34943,74.4,NULL,NULL,'UGC 06774',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85058,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85058,33.77,0.43,56.8,34943,75,NULL,'3.6 micron, color corrected','UGC 06774',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85059,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85059,33.9,0.43,60.3,34943,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06774',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85060,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85060,37.7,0.46,346,34944,70,NULL,NULL,'SDSS J114812.09+371232.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,177.050417,37.20892,0,NULL,60436869410,944326084,14755095,18.1),(85061,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85061,36.35,0.21,186,34945,70,NULL,NULL,'2MASX J11481213+5251079',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000186,NULL,'15.7g',0.47,'AGN',NULL,NULL,NULL,NULL,1,177.05075,52.85208,0,NULL,61768189949,965127967,15080124,15.7),(85062,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85062,33.31,0.2,45.9,34946,74.4,NULL,NULL,'IC 0735',NULL,'2013AJ....146...86T',2013,1,1.19,NULL,'G',0.000007,NULL,'15.1g',0.65,'S',NULL,NULL,NULL,NULL,1,177.053333,13.20939,0.074,NULL,60243207321,941300114,14707814,15.1),(85063,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85063,36.35,0.21,186,34947,70,NULL,NULL,'2MASX J11481285+5242219',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00017,NULL,'16.1g',0.32,'E0',NULL,NULL,NULL,NULL,1,177.053583333,52.70619,0,NULL,61768145269,965127269,15080113,16.1),(85064,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85064,37.43,0.33,306,34948,70,NULL,NULL,'2MASX J11481306+0706224',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000181,NULL,'16.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,177.054375,7.10636,0,NULL,60153146102,939892907,14685826,16.4),(85065,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85065,37.77,0.46,358,34949,70,NULL,NULL,'2MASX J11481322+5248169',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000161,NULL,'17.8g',NULL,NULL,NULL,NULL,NULL,NULL,1,177.054917,52.80464,0,NULL,61768204269,965128191,15080127,17.8),(85066,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85066,34.97,0.46,98.6,34950,70,NULL,NULL,'2MASX J11481333+1926528',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00008,NULL,'15.80',0.25,NULL,NULL,NULL,NULL,NULL,1,177.055625,19.44792,0.012,NULL,60211438775,940803730,14700058,15.8),(85067,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85067,37.71,0.66,348,34951,70,NULL,NULL,'2MFGC 09253',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.60',NULL,NULL,NULL,NULL,NULL,NULL,1,177.0564583,-6.38733,0.057,NULL,40846826517,638231664,9972369,16.6),(85068,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85068,38.17,0.27,430,34952,70,NULL,NULL,'2MASX J11481416+5631561',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000153,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,177.0587083,56.53228,0,NULL,61978568708,968415136,15131486,17.6),(85069,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85069,36.46,0.46,196,34953,70,NULL,NULL,'CGCG 157-036',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000173,NULL,'15.3g',0.44,'E?',NULL,NULL,NULL,NULL,1,177.0617083,31.21661,0.043,NULL,60563848536,946310133,14786095,15.3),(85070,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85070,37.18,0.46,273,34954,70,NULL,NULL,'2MASX J11481621+0922034',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000166,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,177.0675417,9.36756,0,NULL,60378474795,943413668,14740838,17.7),(85071,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85071,37.21,0.1,276,34955,70,NULL,NULL,'2MASX J11481621+5434521',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,177.0675417,54.58111,0,NULL,61772142260,965189722,15081089,17.6),(85072,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85072,38.44,0.33,487,34956,70,NULL,NULL,'SDSS J114816.92+273850.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000172,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,177.070583333,27.64739,0.089,NULL,60592342530,946755352,14793052,18.5),(85073,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85073,36.81,0.46,230,34957,70,NULL,NULL,'2MASX J11481710+1628494',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.20',0.15,NULL,NULL,NULL,NULL,NULL,1,177.071333,16.48047,0.105,NULL,60252346125,941442908,14710045,18.2),(85074,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85074,37.28,0.46,286,34958,70,NULL,NULL,'2MASX J11481717+1146594',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000185,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,177.071583,11.78325,0.053,NULL,60243986438,941312288,14708004,16.8),(85075,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85075,38.08,0.33,413,34959,70,NULL,NULL,'2MASX J11481727+5311489',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00017,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,177.07175,53.19686,0,NULL,61769838423,965153725,15080526,18.2),(85076,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85076,37.64,0.33,337,34960,70,NULL,NULL,'SDSS J114817.27+415849.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000132,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,177.0719583,41.98042,0,NULL,60413785760,943965402,14749459,18.5),(85077,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85077,37.81,0.46,364,34961,70,NULL,NULL,'SDSS J114818.67+022100.4',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000082,NULL,'17.8g',0.14,'NLAGN',NULL,NULL,NULL,NULL,1,177.077833,2.35011,0.045,NULL,60140182443,939690350,14682661,17.8),(85078,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85078,36.76,0.12,225,34962,70,NULL,NULL,'2MASX J11481938+5548500',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000173,NULL,'16.9g',0.25,NULL,'Group member',NULL,NULL,NULL,1,177.0805,55.814,0,NULL,61758564436,964977569,15077774,16.9),(85079,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85079,36.26,0.21,179,34963,70,NULL,NULL,'2MASX J11481987+3727231',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000186,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,177.082917,37.45644,0,NULL,60436946823,944327294,14755113,16.5),(85080,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85080,38.26,0.46,448,34964,70,NULL,NULL,'SDSS J114819.97+015700.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000122,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,177.08325,1.95028,0.053,NULL,60140623814,939697247,14682769,17.9),(85081,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85081,38.08,0.33,413,34965,70,NULL,NULL,'SDSS J114819.98+530625.1',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000165,NULL,'16.9g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,177.083291667,53.107,0,NULL,61769834463,965153663,15080525,16.9),(85082,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85082,37.39,0.33,300,34966,70,NULL,NULL,'2MASX J11482083+3632291',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000166,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,177.086583333,36.54136,0,NULL,60444933279,944452082,14757063,16.6),(85083,'BCG','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85083,38.48,0.35,450,34967,60,NULL,NULL,'ABELL 1382',0.1046,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II:    [BM]',NULL,NULL,NULL,NULL,1,177.088083,71.43881,0.013,NULL,61344575423,958508990,14976702,NULL),(85084,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85084,37.64,0.46,337,34968,70,NULL,NULL,'2MASX J11482142+1933371',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,177.08925,19.56028,0.012,NULL,60211571851,940805810,14700090,17.8),(85085,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85085,37.06,0.46,258,34969,70,NULL,NULL,'2MASX J11482176-0040330',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000073,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,177.09075,-0.67592,0.049,NULL,40809346971,637646046,9963219,17.5),(85086,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85086,37.58,0.33,329,34970,70,NULL,NULL,'SDSS J114823.52+332821.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000212,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,177.098041667,33.47272,0,NULL,60617926148,947155096,14799298,18.1),(85087,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85087,37.47,0.46,311,34971,70,NULL,NULL,'2MASX J11482362+6417548',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,177.098583,64.29869,0.037,NULL,61817022425,965890975,15092046,17.4),(85088,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85088,37.58,0.33,329,34972,70,NULL,NULL,'2MASX J11482477+3327363',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000127,NULL,'17.64',0.2,NULL,NULL,NULL,NULL,NULL,1,177.1032083,33.46017,0,NULL,60617464145,947147877,14799185,17.64),(85089,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85089,37.07,0.46,259,34973,70,NULL,NULL,'VII Zw 422',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000176,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,177.105,65.18003,0,NULL,61821241504,965956898,15093076,16.8),(85090,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85090,37.98,0.27,395,34974,70,NULL,NULL,'2MASX J11482637+1004336',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000178,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,177.1099583,10.076,0.044,NULL,60365742314,943214723,14737730,17.5),(85091,'IRAS','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85091,34.89,0.8,95,34975,75,NULL,'HMCL, I','CGCG 127-056',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000018,NULL,'15.6',0.3,'Sb: sp',NULL,NULL,NULL,NULL,1,177.114541667,21.15664,0.09,NULL,61071906521,954248539,14910133,15.6),(85092,'IRAS','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85092,34.9,0.8,95.4,34975,75,NULL,'W91CL, r','CGCG 127-056',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85093,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85093,34.89,0.43,95.1,34975,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 127-056',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85094,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85094,34.92,0.43,96.5,34975,75,NULL,'3.6 micron, color corrected','CGCG 127-056',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85095,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85095,34.97,0.49,98.8,34975,75,NULL,'IR','CGCG 127-056',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85096,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85096,34.98,0.13,99.3,34975,NULL,NULL,NULL,'CGCG 127-056',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85097,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85097,35.04,0.2,102,34975,74.4,NULL,NULL,'CGCG 127-056',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85098,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85098,35.07,0.4,103,34975,75,NULL,'HMCL, I, raw','CGCG 127-056',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85099,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85099,35.22,0.38,111,34975,75,NULL,'W91CL, r, raw','CGCG 127-056',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85100,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85100,35.25,0.4,112,34975,75,NULL,'HMCL, I, cor','CGCG 127-056',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85101,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85101,35.25,0.4,112,34975,75,NULL,'HMCL, I, inv','CGCG 127-056',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85102,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85102,35.37,0.38,118,34975,75,NULL,'W91CL, r, inv','CGCG 127-056',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85103,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85103,35.4,0.38,120,34975,75,NULL,'W91CL, r, cor','CGCG 127-056',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85104,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85104,36.43,0.46,193,34976,70,NULL,NULL,'2MASX J11482799+5725100',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000151,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,177.116875,57.41942,0,NULL,61843181502,966299710,15098432,16.8),(85105,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85105,38.2,0.46,437,34977,70,NULL,NULL,'LCRS B114554.8-031927',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000088,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,177.1180417,-3.60178,0.061,NULL,40865706465,638526663,9976979,17.6),(85106,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85106,37.32,0.33,290,34978,70,NULL,NULL,'2MASX J11482865+0517017',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,177.1192917,5.28378,0,NULL,60193718557,940526852,14695732,16.7),(85107,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85107,35.39,0.36,120,34979,NULL,NULL,'Malmquist cor.','ESO 378- G 021',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.39',0.6,'Sb',NULL,NULL,NULL,NULL,1,177.1205417,-33.08506,0.337,NULL,41577293250,649645207,10150706,15.39),(85108,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85108,35.48,0.35,125,34979,NULL,NULL,NULL,'ESO 378- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85109,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85109,35.52,0.2,127,34979,74.4,NULL,NULL,'ESO 378- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85110,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85110,35.33,0.38,116,34980,NULL,NULL,NULL,'ESO 378- G 022',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.74',0.5,'Sb',NULL,NULL,NULL,NULL,1,177.1217917,-34.28333,0.397,NULL,41357071414,646204240,10096941,15.74),(85111,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85111,35.37,0.2,119,34980,74.4,NULL,NULL,'ESO 378- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85112,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85112,35.37,0.37,119,34980,NULL,NULL,'Malmquist cor.','ESO 378- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85113,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85113,37.59,0.46,330,34981,70,NULL,NULL,'2MASX J11482919+1406453',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000187,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,177.1217917,14.1125,0.088,NULL,60242804457,941293819,14707715,17.4),(85114,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85114,37.11,0.46,265,34982,70,NULL,NULL,'2MASX J11482937+2845103',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,177.1222917,28.75286,0.068,NULL,60559720396,946245631,14785087,17.5),(85115,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85115,37.32,0.33,290,34983,70,NULL,NULL,'2MASX J11482952+0516267',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,177.12275,5.274,0,NULL,60193719048,940526860,14695732,17.8),(85116,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85116,38.51,0.46,502,34984,70,NULL,NULL,'2MASX J11483046+5702410',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,177.126667,57.04486,0,NULL,61978742054,968417844,15131528,17.7),(85117,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85117,38.17,0.27,430,34985,70,NULL,NULL,'2MASX J11483157+5636250',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000184,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,177.131291667,56.60683,0,NULL,61978511138,968414236,15131472,17.8),(85118,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85118,37.73,0.17,352,34986,70,NULL,NULL,'2MASX J11483175+1259073',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000171,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,177.1322083,12.98553,0.059,NULL,60243106801,941298543,14707789,17.7),(85119,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85119,37.73,0.46,351,34987,70,NULL,NULL,'SDSS J114831.73+112524.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000143,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,177.13225,11.4235,0.059,NULL,60243838403,941309975,14707968,18.2),(85120,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85120,34.18,0.2,68.6,34988,74.4,NULL,NULL,'KUG 1145+129',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000086,NULL,'15.9g',0.29,'Sc','Group member',NULL,NULL,NULL,1,177.135208333,12.70531,0.069,NULL,60244377195,941318393,14708099,15.9),(85121,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85121,37.79,0.15,361,34989,70,NULL,NULL,'SDSS J114832.87+110053.7',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000147,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,177.137,11.01492,0.128,NULL,60365704537,943214133,14737720,18.8),(85122,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85122,38.19,0.46,434,34990,70,NULL,NULL,'2MASX J11483310+1457383',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,177.138041667,14.96058,0.081,NULL,60254135380,941470865,14710482,18.2),(85123,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85123,36.51,0.46,201,34991,70,NULL,NULL,'2MASX J11483359+0254048',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000077,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,177.1400417,2.90122,0.057,NULL,60192471358,940507364,14695427,16.9),(85124,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85124,37.48,0.46,314,34992,70,NULL,NULL,'2MASX J11483370+0413448',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,177.140375,4.22897,0.007,NULL,60196127130,940564486,14696320,17.8),(85125,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85125,37.79,0.15,361,34993,70,NULL,NULL,'2MASX J11483453+1110226',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000166,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,177.143917,11.17303,0.128,NULL,60365530826,943211419,14737678,16.5),(85126,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85126,32.39,NULL,30.1,34994,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06776',NULL,'2010Ap&SS.325..163P',2010,1,1.87,'Multiple SDSS entries describe this object.','G',0.000122,NULL,'16.5',0.2,'Scd',NULL,NULL,NULL,NULL,1,177.149417,43.72214,0,NULL,63890219321,998284676,15598198,16.5),(85127,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85127,32.41,NULL,30.4,34994,NULL,NULL,'Dipole + Quadrupole','UGC 06776',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85128,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85128,32.42,NULL,30.5,34994,NULL,NULL,'Dipole','UGC 06776',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85129,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85129,32.5,NULL,31.7,34994,NULL,NULL,NULL,'UGC 06776',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85130,'GRB','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85130,42.52,0.18,3190,34995,70,NULL,'pseudo z = 1.61 +/- 0.14','GRB 090227B',NULL,'2013ApJ...763..125M',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Fermi',NULL,NULL,NULL,NULL,1,177.15,32.17,0.028,NULL,60619147820,947174184,14799596,NULL),(85131,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85131,37.43,0.33,306,34996,70,NULL,NULL,'SDSS J114836.72+070612.9',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000168,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,177.153,7.10361,0,NULL,60161263932,940019748,14687808,18.3),(85132,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85132,37.2,0.46,275,34997,70,NULL,NULL,'2MASX J11483716-0112460',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000086,NULL,'16.6g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,177.154958333,-1.21283,0.033,NULL,40809063318,637641614,9963150,16.6),(85133,'IRAS','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85133,31.3,0.8,18.2,34998,75,NULL,'A82, H','NGC 3893',NULL,'1997ApJS..109..333W',1997,1,4.5,NULL,'G',0.000003,NULL,'11.16',2.8,'SAB(rs)c:      HII','Pair member (points to parent)',NULL,NULL,NULL,1,177.159125,48.71083,0.021,NULL,61756376348,964943380,15077240,11.16),(85134,'IRAS','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85134,31.3,0.8,18.2,34998,75,NULL,'W91CL, r','NGC 3893',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85135,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85135,30.97,0.12,15.7,34998,NULL,NULL,NULL,'NGC 3893',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85136,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85136,31.12,NULL,16.7,34998,NULL,NULL,'B','NGC 3893',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85137,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85137,31.15,0.4,17,34998,75,NULL,'B','NGC 3893',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85138,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85138,31.23,0.38,17.6,34998,75,NULL,'W91CL, r, raw','NGC 3893',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85139,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85139,31.25,NULL,17.8,34998,NULL,NULL,'B','NGC 3893',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85140,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85140,31.27,0.47,18,34998,75,NULL,'A82, H, raw','NGC 3893',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85141,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85141,31.3,0.35,18.2,34998,NULL,NULL,NULL,'NGC 3893',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85142,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85142,31.31,NULL,18.3,34998,NULL,NULL,'B','NGC 3893',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85143,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85143,31.36,0.38,18.7,34998,75,NULL,'W91CL, r, inv','NGC 3893',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85144,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85144,31.38,0.38,18.9,34998,75,NULL,'W91CL, r, cor','NGC 3893',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85145,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85145,31.39,0.47,19,34998,75,NULL,'A82, H, inv','NGC 3893',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85146,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85146,31.41,NULL,19.1,34998,NULL,NULL,'I','NGC 3893',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85147,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85147,31.48,NULL,19.8,34998,NULL,NULL,'I','NGC 3893',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85148,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85148,31.5,0.47,20,34998,75,NULL,'A82, H, cor','NGC 3893',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85149,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85149,31.53,NULL,20.2,34998,NULL,NULL,'I, Hubble-type-TF','NGC 3893',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85150,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85150,31.62,NULL,21.1,34998,NULL,NULL,'B, Hubble-type-TF','NGC 3893',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85151,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85151,31.65,NULL,21.4,34998,NULL,NULL,'LEDA [Nov 2006]','NGC 3893',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85152,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85152,38.5,0.27,502,34999,70,NULL,NULL,'SDSS J114838.31+261644.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,177.159667,26.279,0.049,NULL,60593130080,946767657,14793244,18.4),(85153,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85153,38,0.46,398,35000,70,NULL,NULL,'2MASX J11483976+1838591',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,177.1657917,18.64969,0.018,NULL,60211620698,940806573,14700102,NULL),(85154,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85154,37.21,0.1,276,35001,70,NULL,NULL,'2MASX J11483991+5439101',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000181,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,177.166167,54.65272,0,NULL,61758254006,964972718,15077698,16.8),(85155,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85155,37.91,0.46,382,35002,70,NULL,NULL,'2MASX J11484026+3509563',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,177.167625,35.16558,0,NULL,60446100545,944470321,14757348,17.5),(85156,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85156,36.66,0.46,214,35003,70,NULL,NULL,'2MASX J11484037+4635531',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00017,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,177.168041667,46.59817,0,NULL,61742691750,964729558,15073899,16.6),(85157,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85157,36.78,0.33,227,35004,70,NULL,NULL,'CGCG 012-087 NED01',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000107,NULL,'15.9g',0.34,'BLAGN',NULL,NULL,NULL,'Sy 1',1,177.1684583,-0.28619,0.049,NULL,40808515209,637633050,9963016,15.9),(85158,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85158,37.69,0.46,345,35005,70,NULL,NULL,'2MASX J11484126+0341008',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,177.1720417,3.68342,0.028,NULL,60192854201,940513346,14695521,17),(85159,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85159,36.57,0.46,206,35006,70,NULL,NULL,'2MASX J11484148+3630282',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,177.172875,36.50786,0,NULL,60444810741,944450167,14757033,17.4),(85160,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85160,36.78,0.33,227,35007,70,NULL,NULL,'CGCG 012-087 NED02',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000097,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,177.175958333,-0.27875,0.049,NULL,40808515414,637633053,9963016,16.7),(85161,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85161,37.36,0.46,296,35008,70,NULL,NULL,'2MASX J11484280+0458176',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00014,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,177.178458333,4.97153,0,NULL,60189377297,940459020,14694672,17.4),(85162,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85162,37.25,0.46,282,35009,70,NULL,NULL,'2MASX J11484539+0850046',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,177.1890417,8.83464,0,NULL,60366737005,943230265,14737972,17.1),(85163,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85163,37.97,0.46,392,35010,70,NULL,NULL,'2MASX J11484539+1028416',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000202,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,177.189125,10.47833,0,NULL,60365928162,943217627,14737775,17.3),(85164,'Tully est','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85164,32.2,0.8,27.6,35011,75,NULL,NULL,'UGCA 247',NULL,'1988NBGC.C....0000T',1988,1,2.5,NULL,'G',0.00001,NULL,'12.97',2.2,'SB(s)d:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,177.190083,-28.29303,0.341,NULL,41463746935,647871045,10122985,12.97),(85165,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85165,28.44,0.43,4.9,35011,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 247',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85166,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85166,37.94,0.46,388,35012,70,NULL,NULL,'2MASX J11484590+5000378',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000141,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,177.19125,50.01053,0.041,NULL,61746183062,964784110,15074751,17.5),(85167,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85167,37.27,0.46,285,35013,70,NULL,NULL,'SDSS J114846.11+101219.9',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,177.192167,10.20553,0,NULL,60365779408,943215303,14737739,17.8),(85168,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85168,38.5,0.27,502,35014,70,NULL,NULL,'2MASX J11484653+2615595',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000189,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,177.19375,26.26675,0.049,NULL,60593143221,946767862,14793247,17),(85169,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85169,37.45,0.46,308,35015,70,NULL,NULL,'SDSS J114847.11+044848.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00017,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,177.196333,4.81342,0,NULL,60189712153,940464252,14694753,18),(85170,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85170,37,0.46,251,35016,70,NULL,NULL,'2MASX J11484749+6541448',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000187,NULL,'16.0g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,177.1980417,65.69581,0.021,NULL,61809906467,965779788,15090309,16),(85171,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85171,37.75,0.46,355,35017,70,NULL,NULL,'2MASX J11484827-0153031',NULL,'2015arXiv151105856S',2015,1,0.35,'6dF final data release has z = 0.012635 +- 0.000183.','G',0.000077,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,177.201167,-1.88436,0.049,NULL,40815401791,637740652,9964697,16.9),(85172,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85172,36.76,0.12,225,35018,70,NULL,NULL,'2MASX J11484917+5532191',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000189,NULL,'16.2g',0.29,'S0','Group member',NULL,NULL,NULL,1,177.205083,55.53864,0,NULL,61758654118,964978970,15077796,16.2),(85173,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85173,38.07,0.27,411,35019,70,NULL,NULL,'2MASX J11484965-0228171',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000185,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,177.206958333,-2.47158,0.041,NULL,40814986109,637734157,9964596,16.9),(85174,'IRAS','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85174,32.21,0.8,27.6,35020,75,NULL,'MAT, I','UGC 06780',NULL,'1997ApJS..109..333W',1997,1,2.22,NULL,'G',0.000007,NULL,'14.8g',0.6,'SAB(s)d:','Isolated galaxy',NULL,NULL,NULL,1,177.2100417,-2.03222,0.037,NULL,40815376241,637740253,9964691,14.8),(85175,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85175,32.26,0.4,28.4,35020,75,NULL,'B','UGC 06780',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85176,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85176,32.53,0.67,32.1,35020,NULL,NULL,'Malmquist cor.','UGC 06780',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85177,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85177,32.82,0.2,36.6,35020,74.4,NULL,NULL,'UGC 06780',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85178,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85178,32.96,0.55,39.1,35020,NULL,NULL,NULL,'UGC 06780',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85179,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85179,32.97,0.32,39.2,35020,85,NULL,'I, raw','UGC 06780',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85180,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85180,32.97,0.32,39.2,35020,85,NULL,'I, inv','UGC 06780',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85181,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85181,33,0.43,39.9,35020,75,NULL,'3.6 micron, color corrected','UGC 06780',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85182,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85182,33.03,0.4,40.4,35020,NULL,NULL,NULL,'UGC 06780',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85183,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85183,33.18,0.43,43.3,35020,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06780',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85184,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85184,33.23,0.43,44.2,35020,75,NULL,'MAT, I, raw','UGC 06780',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85185,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85185,33.28,0.43,45.3,35020,75,NULL,'MAT, I, inv','UGC 06780',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85186,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85186,33.52,0.43,50.5,35020,75,NULL,'MAT, I, cor','UGC 06780',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85187,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85187,33.29,0.4,45.6,35021,NULL,NULL,'mean','NGC 3894',NULL,'2007A&A...465...71T',2007,1,2.8,NULL,'G',0.000063,NULL,'12.63',1.7,'E4-5;WLRG      LINER','Pair member (points to parent)',NULL,'radio jet','Flat-Spectrum Radio Source',1,177.209833,59.41567,0,NULL,61856285725,966504464,15101632,12.63),(85188,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85188,33.42,0.45,48.2,35021,NULL,NULL,'K','NGC 3894',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85189,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85189,37.98,0.27,395,35022,70,NULL,NULL,'2MASX J11485133+0941174',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,177.213875,9.68828,0.041,NULL,60367066595,943235415,14738053,17.5),(85190,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85190,38.5,0.27,502,35023,70,NULL,NULL,'2MASX J11485137+2619085',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000207,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,177.2140417,26.31917,0.049,NULL,60593138847,946767794,14793246,17),(85191,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85191,37.98,0.46,395,35024,70,NULL,NULL,'2MASX J11485270+2713105',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,177.21975,27.21969,0.105,NULL,60594171332,946783927,14793498,17.9),(85192,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85192,37.21,0.1,276,35025,70,NULL,NULL,'2MASX J11485317+5440270',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000186,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,177.221791667,54.67428,0,NULL,61758302298,964973473,15077710,16.8),(85193,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85193,38.05,0.27,407,35026,70,NULL,NULL,'2MASX J11485477+2458305',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000158,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,177.2282917,24.97525,0.035,NULL,60545132177,946017690,14781526,18.1),(85194,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85194,38.15,0.33,428,35027,70,NULL,NULL,'SDSS J114854.82+560835.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000152,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,177.228458333,56.14325,0,NULL,61978472127,968413626,15131462,18.5),(85195,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85195,37.96,0.46,391,35028,70,NULL,NULL,'2MASX J11485514+2901085',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00009,NULL,'18.57',0.14,'Sb',NULL,NULL,NULL,NULL,1,177.229875,29.01917,0.048,NULL,60559650146,946244533,14785070,18.57),(85196,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85196,38.04,0.46,405,35029,70,NULL,NULL,'2MASX J11485549+2738345',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,177.23125,27.64289,0.069,NULL,60592300219,946754690,14793042,17.1),(85197,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85197,37.76,0.46,356,35030,70,NULL,NULL,'2MASX J11485653+3545549',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,177.2355417,35.76522,0,NULL,60448166219,944502597,14757853,17.3),(85198,'Brightest Stars','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85198,30.69,NULL,13.7,35031,NULL,NULL,NULL,'UGC 06782',NULL,'1998A&AS..128..459M',1998,1,2,NULL,'G',0.00002,NULL,'15.0',2,'ImV','Field galaxy',NULL,NULL,NULL,1,177.23925,23.8375,0.04,NULL,60546874239,946044909,14781951,15),(85199,'Tully est','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85199,28.52,0.8,5,35031,75,NULL,NULL,'UGC 06782',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85200,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85200,37.73,0.17,352,35032,70,NULL,NULL,'2MASX J11485812+1256481',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000143,NULL,'17.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,177.242167,12.94678,0.059,NULL,60243075202,941298050,14707782,17.7),(85201,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85201,36.01,0.46,159,35033,70,NULL,NULL,'2MASX J11485844+1056524',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000159,NULL,'16.1g',0.35,'E0',NULL,NULL,NULL,NULL,1,177.2434583,10.94792,0.128,NULL,60365586850,943212294,14737692,16.1),(85202,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85202,38.07,0.27,411,35034,70,NULL,NULL,'SDSS J114859.85-022721.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000079,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,177.249417,-2.45606,0.041,NULL,40814920879,637733138,9964580,18.3),(85203,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85203,38.1,0.46,416,35035,70,NULL,NULL,'2MASX J11490080+0308497',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000113,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,177.2534583,3.14719,0.057,NULL,60190405714,940475089,14694923,16.8),(85204,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85204,37.79,0.46,362,35036,70,NULL,NULL,'2MASX J11490114+1124314',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000182,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,177.254875,11.40881,0.068,NULL,60232307851,941129810,14705153,16.7),(85205,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85205,38.15,0.33,428,35037,70,NULL,NULL,'2MASX J11490221+5608460',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000203,NULL,'17.2g',0.25,NULL,'Group member',NULL,NULL,NULL,1,177.259167,56.14603,0,NULL,61978469901,968413592,15131462,17.2),(85206,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85206,37.98,0.27,395,35038,70,NULL,NULL,'SDSS J114903.73+095238.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000179,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,177.2655417,9.87728,0.015,NULL,60367053634,943235213,14738050,18.5),(85207,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85207,35.28,0.46,114,35039,70,NULL,NULL,'CGCG 157-037',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000087,NULL,'15.0g',0.67,'E',NULL,NULL,NULL,NULL,1,177.26825,27.33422,0.105,NULL,60594269254,946785457,14793522,15),(85208,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85208,35.08,0.46,104,35040,70,NULL,NULL,'MCG +08-22-009',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000164,NULL,'15.1g',0.37,'S0',NULL,NULL,NULL,NULL,1,177.269333,48.74964,0.021,NULL,61756177080,964940266,15077191,15.1),(85209,'SNIa','2016-12-15 15:14:51','2016-12-16 11:20:00','1','SN 2001E',NULL,85209,34.65,0.17,83.3,35041,70,NULL,'SALT 2','NGC 3905',0.01926,'2013MNRAS.433.2240G',2013,1,1.9,NULL,'G',0.000023,NULL,'12.9B',1.4,'SB(rs)c        HII',NULL,NULL,NULL,NULL,1,177.2704583,-9.72983,0.037,NULL,41021653440,640963335,10015052,12.9),(85210,'SNIa','2016-12-15 15:14:51','2016-12-16 11:20:00','1','SN 2009ds',NULL,85210,34.82,0.21,90.2,35041,73.8,NULL,'SALT 2 (SNANA)','NGC 3905',0.0206,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85211,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85211,33.77,0.47,56.9,35041,NULL,NULL,'H','NGC 3905',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85212,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85212,33.89,0.45,60.1,35041,NULL,NULL,'K','NGC 3905',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85213,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85213,33.9,0.46,60.3,35041,NULL,NULL,'J','NGC 3905',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85214,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85214,34.44,0.4,77.4,35041,NULL,NULL,'mean','NGC 3905',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85215,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85215,38.2,0.46,437,35042,70,NULL,NULL,'2MASX J11490588+0130227',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000213,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,177.2745417,1.50633,0.025,NULL,60142393389,939724896,14683201,17.2),(85216,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85216,38.17,0.27,430,35043,70,NULL,NULL,'2MASX J11490698+5640209',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,177.279083,56.67244,0,NULL,61975367437,968365116,15130704,17.7),(85217,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85217,37.79,0.15,361,35044,70,NULL,NULL,'2MASX J11490706+1102385',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000188,NULL,'16.2g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,177.279458333,11.04414,0.128,NULL,60365724018,943214437,14737725,16.2),(85218,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85218,38.02,0.33,401,35045,70,NULL,NULL,'SDSS J114907.15+045026.7',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000174,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,177.2797917,4.84075,0,NULL,60189766345,940465099,14694767,16.9),(85219,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85219,37.79,0.15,361,35046,70,NULL,NULL,'2MASX J11490720+1059145',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,177.279958333,10.98736,0.078,NULL,60365676787,943213699,14737714,17.4),(85220,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85220,38.02,0.33,401,35047,70,NULL,NULL,'2MASX J11490736+0456487',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000176,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,177.2805417,4.94706,0,NULL,60190235571,940472430,14694881,16.9),(85221,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85221,37.79,0.15,361,35048,70,NULL,NULL,'2MASX J11490740+1100335',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,177.2807083,11.00936,0.078,NULL,60365722613,943214415,14737725,16.9),(85222,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85222,37.41,0.27,303,35049,70,NULL,NULL,'2MASX J11490749-0121591',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000067,NULL,'16.8g',0.29,'BrClG          NLAGN',NULL,NULL,NULL,NULL,1,177.281333,-1.36653,0.037,NULL,40817138732,637767792,9965121,16.8),(85223,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85223,37.41,0.27,303,35050,70,NULL,NULL,'2MASX J11490942-0123031',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000087,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,177.289417,-1.38431,0.025,NULL,40817138314,637767786,9965121,17.8),(85224,'Ring Diameter','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85224,31.8,0.76,23,35051,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3900',NULL,'1981ApJS...45..541P',1981,1,2.41,NULL,'G',0.000017,NULL,'12.5g',1.16,'SA(r)0+        AGN','Pair member, wide',NULL,NULL,NULL,1,177.289417,27.02203,0.059,NULL,60593681177,946776268,14793379,12.5),(85225,'Ring Diameter','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85225,31.9,0.98,24,35051,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3900',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85226,'Tully est','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85226,32.34,0.8,29.4,35051,75,NULL,'B','NGC 3900',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85227,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85227,31.18,0.69,17.2,35051,100,NULL,'mid-IR','NGC 3900',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85228,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85228,32.77,0.5,35.8,35051,NULL,NULL,NULL,'NGC 3900',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85229,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85229,32.79,0.49,36.2,35051,NULL,NULL,'Malmquist cor.','NGC 3900',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85230,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85230,32.85,0.2,37.2,35051,74.4,NULL,NULL,'NGC 3900',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85231,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85231,37.15,0.46,269,35052,70,NULL,NULL,'2MASX J11490981+0753455',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000166,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,177.291,7.89583,0,NULL,60161925618,940030087,14687970,17.1),(85232,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85232,37.09,0.46,262,35053,70,NULL,NULL,'LCRS B114638.1-022317',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000143,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,177.298458333,-2.66606,0.037,NULL,40814822845,637731606,9964556,17),(85233,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85233,38.23,0.46,444,35054,70,NULL,NULL,'2MASX J11491170+1650201',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,177.298833,16.83886,0.112,NULL,60252451232,941444550,14710071,18),(85234,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85234,37.88,0.46,377,35055,70,NULL,NULL,'2MASX J11491243+1111345',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,177.30175,11.19283,0.068,NULL,60365689584,943213899,14737717,17.3),(85235,'SBF','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85235,32.26,0.28,28.3,35056,NULL,NULL,'I','NGC 3904',NULL,'2001ApJ...546..681T',2001,1,2.7,NULL,'G',0.000027,NULL,'11.83',1.9,'E2-3:','in a pair',NULL,NULL,NULL,1,177.305083,-29.27675,0.177,NULL,41453170771,647705793,10120403,11.83),(85236,'SBF','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85236,32.26,0.28,28.3,35056,NULL,NULL,NULL,'NGC 3904',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85237,'SBF','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85237,32.26,0.14,28.3,35056,74.4,NULL,NULL,'NGC 3904',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85238,'SBF','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85238,32.37,0.28,29.8,35056,NULL,NULL,'Malmquist cor.','NGC 3904',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85239,'D-Sigma','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85239,31.2,0.4,17.3,35056,75,NULL,'Edat, raw','NGC 3904',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85240,'D-Sigma','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85240,31.52,0.4,20.2,35056,75,NULL,'Edat, cor','NGC 3904',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85241,'Faber-Jackson','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85241,31.36,0.37,18.7,35056,95,NULL,'Weighted Mean','NGC 3904',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85242,'Faber-Jackson','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85242,31.47,0.63,19.7,35056,95,NULL,'Michard 1979b, c','NGC 3904',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85243,'Faber-Jackson','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85243,31.74,0.46,22.3,35056,95,NULL,'Michard 1979a','NGC 3904',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85244,'Faber-Jackson','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85244,32.63,0.81,33.6,35056,55,NULL,'Visvanathan & Sandage 1979','NGC 3904',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85245,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85245,31.87,0.41,23.6,35056,NULL,NULL,NULL,'NGC 3904',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85246,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85246,32.1,0.41,26.3,35056,NULL,NULL,'Malmquist cor.','NGC 3904',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85247,'Tully est','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85247,31.84,0.8,23.4,35056,75,NULL,'B','NGC 3904',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85248,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85248,31.95,0.4,24.6,35056,NULL,NULL,'mean','NGC 3904',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85249,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85249,31.97,0.45,24.8,35056,NULL,NULL,'K','NGC 3904',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85250,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85250,38.05,0.27,407,35057,70,NULL,NULL,'2MASX J11491327+2453244',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000219,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,177.3052083,24.89017,0.035,NULL,60545118264,946017472,14781523,17.2),(85251,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85251,36.26,0.21,179,35058,70,NULL,NULL,'2MASX J11491327+3735066',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00019,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,177.3052083,37.58522,0,NULL,60437682722,944338792,14755293,16.7),(85252,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85252,37.39,0.46,301,35059,70,NULL,NULL,'2MASX J11491344+0906025',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.98',0.17,NULL,NULL,NULL,NULL,NULL,1,177.306125,9.10069,0,NULL,60366706798,943229793,14737965,17.98),(85253,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85253,36.5,0.27,200,35060,70,NULL,NULL,'2MASX J11491376+5215155',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000176,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,177.307125,52.25433,0,NULL,61767810861,965122044,15080031,16.7),(85254,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85254,37.73,0.17,352,35061,70,NULL,NULL,'2MASX J11491487+1247340',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000184,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,177.312,12.79292,0.054,NULL,60246485763,941351340,14708614,16.5),(85255,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85255,31.71,0.4,21.9,35062,75,NULL,'B','NGC 3898',NULL,'1988NBGC.C....0000T',1988,1,4.4,NULL,'G',0.000017,NULL,'11.60',2.6,'SA(s)ab;LINER  HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,177.314041667,56.08436,0,NULL,61975614351,968368974,15130765,11.6),(85256,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85256,37.74,0.46,353,35063,70,NULL,NULL,'2MASX J11491624+2153378',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,177.317666667,21.89381,0.073,NULL,61070480533,954226258,14909785,17.6),(85257,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85257,38.21,0.46,439,35064,70,NULL,NULL,'2MASX J11491647+0809255',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000138,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,177.318583,8.15719,0,NULL,60161234491,940019288,14687801,18.3),(85258,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85258,37.04,0.46,256,35065,70,NULL,NULL,'2MASX J11491726+4710412',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,177.3219583,47.17814,0.018,NULL,61743029250,964734832,15073981,17.6),(85259,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85259,37.21,0.1,276,35066,70,NULL,NULL,'2MASX J11491729+5426493',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000185,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,177.3219583,54.447,0,NULL,61772663404,965197865,15081216,16.7),(85260,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85260,37.72,0.46,350,35067,70,NULL,NULL,'2MASX J11491770+0114224',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000078,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,177.323583,1.23947,0.017,NULL,60143750425,939746100,14683532,17.3),(85261,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85261,37.21,0.1,276,35068,70,NULL,NULL,'SDSS J114917.75+542406.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,177.324,54.40169,0,NULL,61772670310,965197973,15081218,17.8),(85262,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85262,37.14,0.46,268,35069,70,NULL,NULL,'2MASX J11491792+0241384',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000088,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,177.32475,2.69392,0.065,NULL,60142175699,939721495,14683148,16.4),(85263,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85263,33.81,0.2,57.8,35070,74.4,NULL,NULL,'NGC 3902',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.00003,NULL,'13.64',1.3,'SAB(s)bc:','in a radial-velocity based grouping',NULL,NULL,NULL,1,177.328166667,26.12161,0.059,NULL,60537633849,945900528,14779695,13.64),(85264,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85264,33.89,0.4,60.1,35070,NULL,NULL,'mean','NGC 3902',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85265,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85265,34.12,0.55,66.5,35070,NULL,NULL,NULL,'NGC 3902',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85266,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85266,34.18,0.54,68.5,35070,NULL,NULL,'Malmquist cor.','NGC 3902',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85267,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85267,34.24,0.47,70.3,35070,NULL,NULL,'H','NGC 3902',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85268,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85268,34.33,0.46,73.5,35070,NULL,NULL,'J','NGC 3902',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85269,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85269,36.76,0.46,225,35071,70,NULL,NULL,'2MASX J11491883+1857418',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.83',0.17,NULL,NULL,NULL,NULL,NULL,1,177.328333,18.96167,0.022,NULL,60211799607,940809368,14700146,17.83),(85270,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85270,38.07,0.27,411,35072,70,NULL,NULL,'2MASX J11491892-0218352',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,177.328917,-2.30981,0.041,NULL,40814960294,637733754,9964589,17.6),(85271,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85271,36.59,0.46,208,35073,70,NULL,NULL,'2MASX J11491959+2936595',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000107,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,177.331667,29.61667,0.06,NULL,60562390450,946287350,14785739,17.1),(85272,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85272,38.47,0.46,495,35074,70,NULL,NULL,'2MASXi J1149200+141004',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,177.333375,14.16817,0.073,NULL,60235466905,941179170,14705924,17.7),(85273,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85273,37.88,0.23,377,35075,70,NULL,NULL,'2MASX J11492029+2634295',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'18.43',0.15,NULL,NULL,NULL,NULL,NULL,1,177.334541667,26.57483,0.049,NULL,60593954371,946780537,14793445,18.43),(85274,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85274,38.14,0.46,425,35076,70,NULL,NULL,'2MASX J11492038+0953502',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000173,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,177.334917,9.89728,0.015,NULL,60367081984,943235656,14738057,17.9),(85275,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85275,37.27,0.46,285,35077,70,NULL,NULL,'2MASX J11492091+1221080',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.0002,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,177.3370417,12.35217,0.031,NULL,60244457997,941319656,14708119,16.2),(85276,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85276,38.05,0.46,408,35078,70,NULL,NULL,'SDSS J114922.38+350034.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,177.3432917,35.0095,0,NULL,60445562232,944461909,14757217,18.2),(85277,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85277,37.97,0.33,392,35079,70,NULL,NULL,'SDSS J114922.63-013029.5',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000171,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,177.3442917,-1.50822,0.025,NULL,40818186232,637784159,9965377,18),(85278,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85278,30.97,0.1,15.7,35080,NULL,NULL,NULL,'UGC 06792',NULL,'2009ApJS..182..474S',2009,1,2.8,NULL,'G',0.000007,NULL,'14.2g',0.4,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,177.347,39.77128,0,NULL,60408882796,943888793,14748262,14.2),(85279,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85279,31.59,0.2,20.8,35080,74.4,NULL,NULL,'UGC 06792',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85280,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85280,31.64,0.43,21.3,35080,75,NULL,'3.6 micron, color corrected','UGC 06792',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85281,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85281,31.64,0.43,21.3,35080,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06792',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85282,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85282,31.72,0.4,22.1,35080,NULL,NULL,NULL,'UGC 06792',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85283,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85283,32.05,0.49,25.8,35080,75,NULL,'IR','UGC 06792',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85284,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85284,38.25,0.33,447,35081,70,NULL,NULL,'SDSS J114923.44+082444.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,177.347667,8.41233,0,NULL,60161037675,940016213,14687753,18.2),(85285,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85285,34.87,0.42,94.3,35082,NULL,NULL,'Malmquist cor.','NGC 3907B',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000007,NULL,'14.61',0.3,'Scd(f)','Pair member (points to parent)',NULL,NULL,NULL,1,177.348083333,-1.08378,0.037,NULL,40817353365,637771146,9965174,14.61),(85286,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85286,35.08,0.49,104,35082,75,NULL,'IR','NGC 3907B',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85287,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85287,35.18,0.36,109,35082,NULL,NULL,NULL,'NGC 3907B',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85288,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85288,35.22,0.2,111,35082,74.4,NULL,NULL,'NGC 3907B',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85289,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85289,32.05,0.4,25.7,35083,75,NULL,NULL,'UGC 06791',NULL,'2008Ap.....51..336K',2008,1,1.98,NULL,'G',0.00003,NULL,'14.6g',0.38,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,177.348375,26.74158,0.049,NULL,60593842081,946778782,14793418,14.6),(85290,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85290,32.48,0.43,31.4,35083,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06791',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85291,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85291,32.51,0.2,31.8,35083,74.4,NULL,NULL,'UGC 06791',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85292,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85292,32.51,0.43,31.8,35083,75,NULL,'3.6 micron, color corrected','UGC 06791',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85293,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85293,32.61,0.49,33.3,35083,75,NULL,'IR','UGC 06791',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85294,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85294,32.67,0.69,34.2,35083,NULL,NULL,NULL,'UGC 06791',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85295,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85295,32.71,NULL,34.8,35083,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06791',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85296,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85296,32.72,NULL,34.9,35083,NULL,NULL,'Dipole + Quadrupole','UGC 06791',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85297,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85297,32.72,NULL,35,35083,NULL,NULL,'Dipole','UGC 06791',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85298,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85298,32.75,NULL,35.4,35083,NULL,NULL,NULL,'UGC 06791',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85299,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85299,32.85,0.63,37.2,35083,NULL,NULL,'Malmquist cor.','UGC 06791',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85300,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85300,37.84,0.15,370,35084,70,NULL,NULL,'2MASX J11492381+1217238',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,177.34925,12.28989,0.031,NULL,60244736945,941324014,14708187,17.8),(85301,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85301,33.63,0.49,53.1,35085,75,NULL,'IR','UGC 06794',NULL,'2011yCatp016004901K',2011,1,1.65,NULL,'G',0.000013,NULL,'14.6g',0.45,'SBdm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,177.34975,16.64192,0.14,NULL,60252422943,941444108,14710064,14.6),(85302,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85302,37.73,0.17,352,35086,70,NULL,NULL,'2MASX J11492445+1250598',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000223,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,177.351916667,12.84978,0.051,NULL,60246480059,941351250,14708613,16.8),(85303,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85303,37.84,0.15,370,35087,70,NULL,NULL,'2MASX J11492469+1218348',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000146,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,177.3530417,12.30969,0.031,NULL,60244722927,941323795,14708184,18.1),(85304,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85304,36.5,0.27,200,35088,70,NULL,NULL,'MCG +09-19-203',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000179,NULL,'15.7g',0.43,'E0',NULL,NULL,NULL,NULL,1,177.3564583,52.28939,0,NULL,61767755788,965121184,15080018,15.7),(85305,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85305,37.73,0.17,352,35089,70,NULL,NULL,'2MASX J11492568+1252398',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,177.3570417,12.87758,0.051,NULL,60246509888,941351717,14708620,17.9),(85306,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85306,38,0.46,399,35090,70,NULL,NULL,'2MASXi J1149257+392218',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,177.357583,39.37181,0.01,NULL,60454239632,944597494,14759335,17.7),(85307,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85307,37.85,0.46,372,35091,70,NULL,NULL,'2MASX J11492583+2427595',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000143,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,177.357667,24.46656,0.038,NULL,60548534915,946070858,14782357,17.5),(85308,'IRAS','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85308,32.94,0.8,38.7,35092,75,NULL,'MAT, I','ESO 320- G 024',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'15',1.1,'Sc?            HII',NULL,NULL,NULL,NULL,1,177.3585417,-38.82594,0.405,NULL,41401971070,646905797,10107903,15),(85309,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85309,31.45,0.32,19.5,35092,85,NULL,'I, inv','ESO 320- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85310,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85310,31.48,0.32,19.8,35092,85,NULL,'I, raw','ESO 320- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85311,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85311,31.68,0.43,21.7,35092,75,NULL,'MAT, I, inv','ESO 320- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85312,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85312,31.74,0.43,22.3,35092,75,NULL,'MAT, I, raw','ESO 320- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85313,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85313,32.09,0.43,26.2,35092,75,NULL,'MAT, I, cor','ESO 320- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85314,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85314,33.31,0.09,46,35092,NULL,NULL,NULL,'ESO 320- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85315,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85315,37.9,0.46,380,35093,70,NULL,NULL,'2MASX J11492616-0018182',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000102,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,177.358833,-0.30503,0.049,NULL,40816922118,637764408,9965068,16.4),(85316,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85316,37.79,0.15,361,35094,70,NULL,NULL,'2MASX J11492614+1102152',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,177.358875,11.03764,0.078,NULL,60365681054,943213766,14737715,17.8),(85317,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85317,36.83,0.46,232,35095,70,NULL,NULL,'2MASX J11492615+1734358',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000172,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,177.359083,17.57658,0.069,NULL,60209322049,940770657,14699541,16.9),(85318,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85318,37.79,0.15,361,35096,70,NULL,NULL,'2MASX J11492619+1117173',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000137,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,177.3592917,11.28822,0.068,NULL,60365507285,943211051,14737672,17.6),(85319,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85319,39.03,0.46,639,35097,70,NULL,NULL,'SDSS J114927.01+540109.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000169,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,177.362625,54.01922,0,NULL,61772817166,965200268,15081254,18.5),(85320,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85320,37.02,0.46,253,35098,70,NULL,NULL,'2MASX J11492792-0155292',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,177.3664583,-1.92478,0.037,NULL,40815546537,637742914,9964733,17.7),(85321,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85321,37.84,0.15,370,35099,70,NULL,NULL,'SDSS J114928.36+121101.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,177.3682083,12.18383,0.031,NULL,60244742059,941324094,14708188,17.7),(85322,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85322,37.84,0.15,370,35100,70,NULL,NULL,'2MASX J11492865+1223448',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000164,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,177.3692917,12.39581,0.031,NULL,60244560313,941321254,14708144,17.3),(85323,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85323,37.84,0.15,370,35101,70,NULL,NULL,'SDSS J114929.25+121906.8',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.26,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,177.371916667,12.31856,0.031,NULL,60244723679,941323807,14708184,17.1),(85324,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85324,36.93,0.33,243,35102,70,NULL,NULL,'2MASX J11492935+5833403',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000179,NULL,'16.1g',0.41,NULL,NULL,NULL,NULL,NULL,1,177.372417,58.56103,0,NULL,61844027715,966312933,15098639,16.1),(85325,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85325,35.16,0.49,108,35103,75,NULL,'IR','ESO 378- G 026',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.79',0.2,'Sb',NULL,NULL,NULL,NULL,1,177.374333,-34.58581,0.401,NULL,41357883867,646216935,10097139,15.79),(85326,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85326,35.27,0.38,113,35103,NULL,NULL,NULL,'ESO 378- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85327,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85327,35.31,0.2,115,35103,74.4,NULL,NULL,'ESO 378- G 026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85328,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85328,35.32,0.38,116,35103,NULL,NULL,'Malmquist cor.','ESO 378- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85329,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85329,34.17,0.46,68.1,35104,70,NULL,NULL,'NGC 3907',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00014,NULL,'14.94',0.9,'SB(s)00-:      AGN','Pair member (points to parent)',NULL,NULL,NULL,1,177.375583,-1.08653,0.037,NULL,40817386482,637771663,9965182,14.94),(85330,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85330,37.41,0.27,303,35105,70,NULL,NULL,'SDSS J114930.74-012243.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000073,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,177.378125,-1.37886,0.025,NULL,40817159550,637768117,9965126,18.1),(85331,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85331,37.79,0.15,361,35106,70,NULL,NULL,'SDSS J114931.16+110325.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,177.379833,11.05703,0.078,NULL,60365681232,943213769,14737715,18.1),(85332,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85332,37.64,0.46,338,35107,70,NULL,NULL,'2MASX J11493132+6114166',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,177.3802917,61.23789,0.045,NULL,61848901337,966389083,15099829,18),(85333,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85333,36.84,0.46,233,35108,70,NULL,NULL,'2MASX J11493174+5438543',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'16.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,177.382166667,54.64853,0,NULL,61760086497,965001351,15078146,16.9),(85334,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85334,37.62,0.14,334,35109,70,NULL,NULL,'2MASX J11493281+4355142',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000176,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,177.386666667,43.92064,0,NULL,63890018815,998281543,15598149,18),(85335,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85335,38.05,0.27,407,35110,70,NULL,NULL,'2MASX J11493304+2454524',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,177.387875,24.91475,0.035,NULL,60545121494,946017523,14781523,17.9),(85336,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85336,37.43,0.16,306,35111,70,NULL,NULL,'SDSS J114933.86+054656.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000158,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,177.391125,5.78236,0,NULL,60156868907,939951076,14686735,18.1),(85337,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85337,39.21,0.46,694,35112,70,NULL,NULL,'2MASX J11493424+1625558',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,177.392833,16.43217,0.113,NULL,60253233968,941456780,14710262,18.4),(85338,'SZ effect','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85338,39.52,0.48,800,35113,NULL,NULL,'Hydrost. Eq.','MACS J1149.5+2223',NULL,'2006ApJ...647...25B',2006,1,NULL,'Boehringer et al. (2000ApJS..129..435B) give z=0.1761.','GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,177.3962083,22.40303,0.05,NULL,61071136696,954236510,14909945,NULL),(85339,'SZ effect','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85339,40.5,0.49,1260,35113,NULL,NULL,'Isotherm.','MACS J1149.5+2223',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85340,'SZ effect','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85340,40.68,NULL,1370,35113,NULL,NULL,'4.2 (black) calibration','MACS J1149.5+2223',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85341,'SZ effect','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85341,40.75,NULL,1410,35113,NULL,NULL,'3.1 (red) calibration','MACS J1149.5+2223',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85342,'SZ effect','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85342,40.97,0.51,1560,35113,NULL,NULL,'Isotherm., r < 100 kpc','MACS J1149.5+2223',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85343,'SZ effect','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85343,41.02,NULL,1600,35113,NULL,NULL,'4.1 (blue) calibration','MACS J1149.5+2223',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85344,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85344,37.1,0.46,263,35114,70,NULL,NULL,'LCRS B114701.4-023420',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000074,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,177.395583333,-2.84989,0.037,NULL,40812712240,637698628,9964041,17),(85345,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85345,35.38,0.46,119,35115,70,NULL,NULL,'MCG +08-22-011',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000172,NULL,'15.4g',0.53,'E0',NULL,NULL,NULL,NULL,1,177.396583,47.83119,0.104,NULL,61756133199,964939581,15077180,15.4),(85346,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85346,35.48,0.46,125,35116,70,NULL,NULL,'CGCG 012-095',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000123,NULL,'14.9g',0.56,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,177.3975,-3.48814,0.049,NULL,40857855248,638403988,9975062,14.9),(85347,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85347,37.43,0.16,306,35117,70,NULL,NULL,'2MASX J11493609+0541554',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00016,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,177.400333333,5.69864,0,NULL,60156832198,939950503,14686726,16.5),(85348,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85348,37.79,0.15,361,35118,70,NULL,NULL,'2MASX J11493613+1104363',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000149,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,177.400667,11.07681,0.078,NULL,60365673747,943213652,14737713,17.8),(85349,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85349,37.38,0.46,299,35119,70,NULL,NULL,'2MASX J11493622+4145283',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00022,NULL,'15.8g',0.44,'E0',NULL,NULL,NULL,NULL,1,177.400917,41.75783,0,NULL,60414703450,943979741,14749683,15.8),(85350,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85350,34.24,0.52,70.6,35120,70,NULL,NULL,'ARK 326',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.000077,NULL,'14.7g',0.6,'E/S0',NULL,NULL,NULL,NULL,1,177.4014583,-1.45553,0.025,NULL,40818236725,637784948,9965389,14.7),(85351,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85351,34.34,0.46,73.7,35120,70,NULL,NULL,'ARK 326',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85352,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85352,37.74,0.46,354,35121,70,NULL,NULL,'2MASX J11493687+3539520',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.96',0.17,NULL,NULL,NULL,NULL,NULL,1,177.403916667,35.66436,0,NULL,60447402484,944490663,14757666,17.96),(85353,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85353,37.36,0.46,296,35122,70,NULL,NULL,'2MASX J11493898+4236272',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000154,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,177.4125417,42.6075,0,NULL,60399504690,943742260,14745972,16.9),(85354,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85354,37.65,0.46,339,35123,70,NULL,NULL,'2MASX J11493913+1414418',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,177.413167,14.245,0.073,NULL,60235686917,941182608,14705978,17.5),(85355,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85355,38.25,0.33,447,35124,70,NULL,NULL,'2MASX J11493935+0826033',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,177.4139583,8.43436,0,NULL,60161033642,940016150,14687752,17.9),(85356,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85356,36.5,0.27,200,35125,70,NULL,NULL,'2MASX J11493948+5217264',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,177.414583,52.29056,0,NULL,61767756536,965121195,15080018,16.8),(85357,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85357,38.23,0.46,442,35126,70,NULL,NULL,'2MASX J11493958+4429322',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000181,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,177.4150417,44.49219,0,NULL,63891248989,998300765,15598449,17.5),(85358,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85358,35.87,0.72,150,35127,70,NULL,NULL,'CGCG 012-098',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.000092,NULL,'15.8g',0.35,'SAB0+:','Group member',NULL,NULL,NULL,1,177.4155,-3.52969,0.049,NULL,40858720710,638417511,9975273,15.8),(85359,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85359,36.81,0.46,230,35128,70,NULL,NULL,'2MASX J11494035+0941153',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,177.418041667,9.68767,0,NULL,60367302634,943239103,14738110,17.1),(85360,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85360,38.38,0.46,474,35129,70,NULL,NULL,'SDSS J114940.49+314902.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,177.41875,31.81744,0.056,NULL,60550931594,946108306,14782942,18.2),(85361,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85361,35.97,0.46,157,35130,70,NULL,NULL,'2MASX J11494062+0942553',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000167,NULL,'16.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,177.419417,9.71533,0,NULL,60367268304,943238567,14738102,16.3),(85362,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85362,37.84,0.15,370,35131,70,NULL,NULL,'2MASX J11494093+1212408',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,177.4204583,12.2115,0.031,NULL,60244738283,941324035,14708188,17.6),(85363,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85363,37.18,0.46,273,35132,70,NULL,NULL,'2MASX J11494095+0410330',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.0002,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,177.4207917,4.17575,0.009,NULL,60190932219,940483315,14695051,16.7),(85364,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85364,36.66,0.46,215,35133,70,NULL,NULL,'SDSS J114941.50+022050.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'17.5g',0.17,'NLAGN',NULL,NULL,NULL,'Sy 2',1,177.4229583,2.34747,0.033,NULL,60143081908,939735654,14683369,17.5),(85365,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85365,37.86,0.46,373,35134,70,NULL,NULL,'2MASX J11494189+1601308',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000181,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,177.4245,16.02536,0.091,NULL,60252600077,941446876,14710107,17),(85366,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85366,37.66,0.46,341,35135,70,NULL,NULL,'2MASX J11494219+0748033',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000178,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,177.425708333,7.80081,0,NULL,60161949281,940030457,14687975,16.5),(85367,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85367,38.02,0.46,402,35136,70,NULL,NULL,'2MASX J11494261+5213284',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,177.4272917,52.22453,0,NULL,61767802128,965121908,15080029,17.8),(85368,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85368,37.97,0.46,393,35137,70,NULL,NULL,'2MASX J11494285+1016373',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000181,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,177.4285417,10.27708,0,NULL,60365966755,943218230,14737784,17.5),(85369,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85369,38.48,0.46,496,35138,70,NULL,NULL,'SDSS J114943.46+015451.3',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000101,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,177.431125,1.91428,0.025,NULL,60142645336,939728833,14683263,18.3),(85370,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85370,37.84,0.15,370,35139,70,NULL,NULL,'2MASX J11494367+1225398',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.04',0.18,NULL,NULL,NULL,NULL,NULL,1,177.432,12.42761,0.014,NULL,60244525585,941320712,14708136,18.04),(85371,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85371,38.39,0.46,476,35140,70,NULL,NULL,'SDSS J114944.83+563944.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000172,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,177.436791667,56.66239,0,NULL,61975831770,968372371,15130818,18.6),(85372,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85372,37.21,0.1,276,35141,70,NULL,NULL,'2MASX J11494536+5443172',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000185,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,177.439,54.72147,0,NULL,61760117888,965001842,15078153,16.2),(85373,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85373,37.62,0.14,334,35142,70,NULL,NULL,'2MASX J11494571+4342272',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000186,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,177.4404583,43.70747,0,NULL,63890032025,998281750,15598152,16.6),(85374,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85374,37.83,0.46,369,35143,70,NULL,NULL,'SDSS J114945.73+101021.9',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,177.440583,10.17278,0,NULL,60367604310,943243817,14738184,18.2),(85375,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85375,35.49,0.56,125,35144,70,NULL,NULL,'2MASX J11494679-1555385',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.73',0.5,NULL,NULL,NULL,NULL,NULL,1,177.445167,-15.92736,0.033,NULL,40998373862,640599591,10009368,15.73),(85376,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85376,37.43,0.46,306,35145,70,NULL,NULL,'2MASX J11494760+0256350',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000088,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,177.4484583,2.94292,0.065,NULL,60134836786,939606824,14681356,17.5),(85377,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85377,37.62,0.14,334,35146,70,NULL,NULL,'SDSS J114948.11+435412.6',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000193,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,177.4504583,43.9035,0,NULL,63890049671,998282026,15598156,16.8),(85378,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85378,37.63,0.46,335,35147,70,NULL,NULL,'2MASX J11494873+4306207',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000172,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,177.453125,43.10586,0,NULL,60399865652,943747900,14746060,18),(85379,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85379,37.62,0.14,334,35148,70,NULL,NULL,'SDSS J114948.79+435726.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000168,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,177.453333,43.95731,0,NULL,63890019569,998281555,15598149,18.6),(85380,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85380,37.92,0.27,384,35149,70,NULL,NULL,'2MASX J11494881+0617429',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000192,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,177.4535417,6.29517,0,NULL,60159068636,939985447,14687272,17.7),(85381,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85381,36.48,0.46,197,35150,70,NULL,NULL,'2MASX J11494890+5319020',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,177.453875,53.31722,0,NULL,61771125310,965173832,15080841,16.9),(85382,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85382,37.92,0.27,384,35151,70,NULL,NULL,'2MASX J11494981+0621199',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000177,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,177.4575,6.35561,0,NULL,60159773125,939996455,14687444,17.4),(85383,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85383,37.64,0.46,337,35152,70,NULL,NULL,'2MASX J11494981+3622583',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000183,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,177.4575,36.383,0,NULL,60447644211,944494440,14757725,16.5),(85384,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85384,37.92,0.27,384,35153,70,NULL,NULL,'SDSS J114949.94+062249.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000172,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,177.458125,6.38039,0,NULL,60159773417,939996459,14687444,17.8),(85385,'IRAS','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85385,32.76,0.8,35.6,35154,75,NULL,'MAT, I','ESO 320- G 026',NULL,'1997ApJS..109..333W',1997,1,2.4,'Confused HIPASS source','G',0.000021,NULL,'12.83',0.9,'Sb             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,177.459625,-38.78447,0.405,NULL,41401954702,646905542,10107899,12.83),(85386,'Sosies','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85386,33.5,0.03,50.1,35154,NULL,NULL,NULL,'ESO 320- G 026',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85387,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85387,32.99,0.43,39.6,35154,75,NULL,'MAT, I, raw','ESO 320- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85388,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85388,33.03,0.46,40.4,35154,NULL,NULL,'J','ESO 320- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85389,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85389,33.04,0.47,40.6,35154,NULL,NULL,'H','ESO 320- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85390,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85390,33.08,0.45,41.2,35154,NULL,NULL,'K','ESO 320- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85391,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85391,33.1,0.32,41.7,35154,85,NULL,'I, raw','ESO 320- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85392,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85392,33.15,0.43,42.7,35154,75,NULL,'MAT, I, cor','ESO 320- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85393,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85393,33.17,0.32,43.1,35154,85,NULL,'I, inv','ESO 320- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85394,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85394,33.22,0.4,44.1,35154,NULL,NULL,'mean','ESO 320- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85395,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85395,33.29,0.43,45.6,35154,75,NULL,'MAT, I, inv','ESO 320- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85396,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85396,33.48,0.08,49.8,35154,NULL,NULL,NULL,'ESO 320- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85397,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85397,37.47,0.46,312,35155,70,NULL,NULL,'2MASX J11495070+0849239',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,177.461167,8.82336,0,NULL,60366750416,943230475,14737976,17.8),(85398,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85398,37.66,0.46,340,35156,70,NULL,NULL,'2MASX J11495089+4655271',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,177.462,46.92417,0.009,NULL,61742944672,964733510,15073961,17.7),(85399,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85399,37.62,0.14,334,35157,70,NULL,NULL,'2MASX J11495109+4356317',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000189,NULL,'16.0g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,177.4629583,43.94225,0,NULL,63890049265,998282019,15598156,16),(85400,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85400,37.7,0.46,346,35158,70,NULL,NULL,'2MASX J11495147+0539130',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000157,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,177.464375,5.65361,0,NULL,60156824052,939950375,14686724,17.2),(85401,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85401,37.34,0.46,294,35159,70,NULL,NULL,'2MASX J11495169+2645353',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000171,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,177.465333,26.75986,0.049,NULL,60593359117,946771236,14793300,16.4),(85402,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85402,37.71,0.46,348,35160,70,NULL,NULL,'2MASX J11495168+0915569',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000188,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,177.4654583,9.26597,0,NULL,60367395654,943240557,14738133,16.8),(85403,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85403,34.33,0.46,73.3,35161,70,NULL,NULL,'CGCG 040-047',NULL,'2015arXiv151105856S',2015,1,0.96,NULL,'G',0.000117,NULL,'14.8g',0.57,'SA(r)0^0^:',NULL,NULL,NULL,NULL,1,177.467167,6.66775,0,NULL,60159509214,939992331,14687380,14.8),(85404,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85404,37.84,0.15,370,35162,70,NULL,NULL,'NGC 3908',NULL,'2015arXiv151105856S',2015,1,0.6,'NGC identification is not certain.','G',0.000197,NULL,'15.7g',0.53,'BrClG',NULL,NULL,NULL,NULL,1,177.4695,12.18592,0.031,NULL,60244832175,941325502,14708210,15.7),(85405,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85405,37.21,0.46,277,35163,70,NULL,NULL,'2MASX J11495287+4703077',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000043,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,177.470167,47.05231,0.014,NULL,61742948487,964733570,15073962,17.1),(85406,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85406,38.67,0.46,542,35164,70,NULL,NULL,'SDSS J114953.10+571541.2',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000213,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,177.47125,57.2615,0,NULL,61841347078,966271048,15097985,17.4),(85407,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85407,37.86,0.46,374,35165,70,NULL,NULL,'SDSS J114953.43+421816.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000156,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,177.472625,42.30469,0,NULL,60413228412,943956693,14749323,18.7),(85408,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85408,37.13,0.46,266,35166,70,NULL,NULL,'2MASX J11495384+1346316',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000179,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,177.4745,13.7755,0.066,NULL,60243774034,941308969,14707952,16.4),(85409,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85409,37.97,0.33,392,35167,70,NULL,NULL,'SDSS J114954.22-013706.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000071,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,177.475958333,-1.61856,0.037,NULL,40818209527,637784523,9965383,18.5),(85410,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85410,37.69,0.46,344,35168,70,NULL,NULL,'2MASX J11495310+5715412',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,177.476667,57.25706,0,NULL,61975306533,968364164,15130690,18.1),(85411,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85411,35.73,0.46,140,35169,70,NULL,NULL,'2MASX J11495484+3843253',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000159,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,177.4785417,38.72383,0,NULL,60456651518,944635179,14759924,16.4),(85412,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85412,34.98,0.5,99.1,35170,70,NULL,NULL,'CGCG 012-101',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00009,NULL,'15.10',0.5,'E pec:','Group member',NULL,NULL,NULL,1,177.480333,-3.66289,0.073,NULL,40858734303,638417723,9975276,15.1),(85413,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85413,37.8,0.46,364,35171,70,NULL,NULL,'2MASXi J1149553+250805',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000181,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,177.480458333,25.13492,0.048,NULL,60545590084,946024845,14781638,17.2),(85414,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85414,37.69,0.46,345,35172,70,NULL,NULL,'2MASX J11495603+1049070',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000145,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,177.483333,10.81867,0.078,NULL,60366512730,943226761,14737918,17.3),(85415,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85415,36.53,0.46,202,35173,70,NULL,NULL,'2MASX J11495640+2917013',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000143,NULL,'16.1g',0.39,'E',NULL,NULL,NULL,NULL,1,177.4850417,29.28378,0.041,NULL,60561963787,946280684,14785635,16.1),(85416,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85416,37.23,0.46,279,35174,70,NULL,NULL,'2MASX J11495688+0300320',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000068,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,177.4870417,3.009,0.065,NULL,60134828362,939606693,14681354,17.8),(85417,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85417,38.12,0.46,420,35175,70,NULL,NULL,'2MASX J11495700+1633006',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000176,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,177.487625,16.55017,0.14,NULL,60253263029,941457234,14710269,17.1),(85418,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85418,36.97,0.46,248,35176,70,NULL,NULL,'2MASX J11495872+2208152',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.40',0.18,NULL,NULL,NULL,NULL,NULL,1,177.494875,22.13769,0.068,NULL,61070913982,954233030,14909891,18.4),(85419,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85419,37.32,0.46,290,35177,70,NULL,NULL,'SDSS J114959.25+350245.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,177.496917,35.04589,0,NULL,60434259218,944285300,14754457,18.2),(85420,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85420,38,0.33,399,35178,70,NULL,NULL,'LCRS B114725.9-023003',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,177.4977083,-2.77844,0.037,NULL,40815002140,637734408,9964600,18.2),(85421,'SNIa','2016-12-15 15:14:51','2016-12-16 11:20:00','1','SN 1994F',NULL,85421,40.57,0.49,960,35179,74.2,NULL,'SALT 2','[PPG94] 114725.33+105938.6',0.354,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,'20.2',NULL,NULL,NULL,NULL,NULL,NULL,1,177.4987917,10.716,0.02,NULL,60366484834,943226325,14737911,20.2),(85422,'SNIa','2016-12-15 15:14:51','2016-12-16 11:20:00','1','SN 1994F',NULL,85422,41.45,0.33,1440,35179,70,NULL,'SALT','[PPG94] 114725.33+105938.6',0.354,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85423,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85423,37.05,0.46,257,35180,70,NULL,NULL,'2MASX J11500005+4310388',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000164,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,177.5000417,43.17756,0,NULL,60399842184,943747534,14746055,16.7),(85424,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85424,36.51,0.46,200,35181,70,NULL,NULL,'2MASX J11500037+6414355',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000153,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,177.501583,64.24319,0.037,NULL,61817203815,965893809,15092090,17.1),(85425,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85425,37.88,0.23,377,35182,70,NULL,NULL,'2MASX J11500065+2635133',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000147,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,177.502917,26.58703,0.049,NULL,60593446888,946772607,14793321,17.1),(85426,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85426,36.28,0.46,180,35183,70,NULL,NULL,'2MASX J11500193+0650100',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,177.5080417,6.83617,0,NULL,60159598856,939993732,14687402,17.2),(85427,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85427,37.88,0.23,377,35184,70,NULL,NULL,'2MASX J11500199+2631063',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000187,NULL,'16.6g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,177.50825,26.51844,0.049,NULL,60593414803,946772106,14793314,16.6),(85428,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85428,37.43,0.16,306,35185,70,NULL,NULL,'2MASX J11500252+0537560',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000204,NULL,'16.1g',0.36,'AGN',NULL,NULL,NULL,NULL,1,177.510583,5.63231,0,NULL,60189524180,940461315,14694708,16.1),(85429,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85429,37.43,0.16,306,35186,70,NULL,NULL,'SDSS J115002.54+054229.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,177.510625,5.70808,0,NULL,60156823372,939950365,14686724,18),(85430,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85430,36.43,0.46,193,35187,70,NULL,NULL,'2MASX J11500267+1109490',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,177.51125,11.16372,0.053,NULL,60365653709,943213339,14737708,17.2),(85431,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85431,30.67,NULL,13.6,35188,NULL,NULL,NULL,'MRK 0750',NULL,'2015AstBu..70....1K',2015,1,0.55,NULL,'G',0.000007,NULL,'15.3g',0.36,'BCD;WR         HII',NULL,NULL,NULL,NULL,1,177.511375,15.02319,0.066,NULL,60254263166,941472861,14710513,15.3),(85432,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85432,30.04,0.2,10.2,35189,74.4,NULL,NULL,'MRK 0750',NULL,'2013AJ....146...86T',2013,1,0.55,NULL,'G',0.000007,NULL,'15.3g',0.36,'BCD;WR         HII',NULL,NULL,NULL,NULL,1,177.511375,15.02319,0.066,NULL,60254263166,941472861,14710513,15.3),(85433,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85433,37.04,0.46,256,35190,70,NULL,NULL,'2MASX J11500281+4137093',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000143,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,177.511875,41.61922,0,NULL,60414607084,943978235,14749659,16.9),(85434,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85434,36.93,0.33,243,35191,70,NULL,NULL,'2MASX J11500334+5834349',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000161,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,177.513666667,58.57633,0,NULL,61844004679,966312573,15098633,17.1),(85435,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85435,35.26,0.07,113,35192,70,NULL,NULL,'2MASX J11500404+2116472',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00008,NULL,'15.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,177.516916667,21.27983,0.117,NULL,61071825831,954247278,14910113,15.8),(85436,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85436,37.84,0.15,370,35193,70,NULL,NULL,'SDSS J115004.27+122948.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,177.517833,12.49675,0.014,NULL,60244540301,941320942,14708139,18.1),(85437,'Tully est','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85437,32.39,0.8,30,35194,75,NULL,'B','NGC 3899',NULL,'1988NBGC.C....0000T',1988,1,1.85,NULL,'G',0.000023,NULL,'13.21',0.79,'SAB(s)b? pec','Pair member, wide',NULL,NULL,NULL,1,177.518583,26.47925,0.049,NULL,60593419832,946772184,14793315,13.21),(85438,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85438,31.49,0.4,19.9,35194,NULL,NULL,NULL,'NGC 3899',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85439,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85439,31.9,0.47,24,35194,NULL,NULL,'H','NGC 3899',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85440,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85440,31.94,0.45,24.4,35194,NULL,NULL,'K','NGC 3899',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85441,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85441,32,0.46,25.2,35194,NULL,NULL,'J','NGC 3899',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85442,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85442,32.29,0.4,28.7,35194,NULL,NULL,'mean','NGC 3899',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85443,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85443,37.03,0.27,255,35195,70,NULL,NULL,'MCG +10-17-083',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000198,NULL,'15.4g',0.52,'BrClG',NULL,NULL,NULL,NULL,1,177.522083,56.48097,0,NULL,61975748347,968371067,15130797,15.4),(85444,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85444,37.29,0.46,286,35196,70,NULL,NULL,'2MASX J11500540+5334021',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,177.5222917,53.56717,0,NULL,61771246279,965175723,15080870,17.9),(85445,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85445,37.13,0.46,267,35197,70,NULL,NULL,'2MASX J11500544+0951250',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000183,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,177.522666667,9.85706,0,NULL,60367194664,943237416,14738084,17.1),(85446,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85446,37.58,0.33,328,35198,70,NULL,NULL,'2MASX J11500574+1048200',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,177.524,10.80564,0.02,NULL,60366514147,943226783,14737918,17.7),(85447,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85447,30.98,0.09,15.7,35199,NULL,NULL,NULL,'UGC 06802',NULL,'2009ApJS..182..474S',2009,1,2.29,NULL,'G',0.000027,NULL,'15.2g',0.34,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,177.527083,51.85592,0.01,NULL,61767684231,965120066,15080001,15.2),(85448,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85448,31.57,NULL,20.6,35199,NULL,NULL,NULL,'UGC 06802',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85449,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85449,31.78,NULL,22.7,35199,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06802',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85450,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85450,31.8,NULL,22.9,35199,NULL,NULL,'Dipole + Quadrupole','UGC 06802',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85451,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85451,31.81,NULL,23,35199,NULL,NULL,'Dipole','UGC 06802',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85452,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85452,31.86,0.4,23.5,35199,75,NULL,NULL,'UGC 06802',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85453,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85453,32.06,0.2,25.8,35199,74.4,NULL,NULL,'UGC 06802',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85454,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85454,32.31,0.49,28.9,35199,75,NULL,'IR','UGC 06802',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85455,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85455,32.36,0.4,29.6,35199,NULL,NULL,NULL,'UGC 06802',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85456,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85456,37.43,0.16,306,35200,70,NULL,NULL,'2MASX J11500748+0536590',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00018,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,177.531167,5.61631,0,NULL,60189458804,940460293,14694692,17.6),(85457,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85457,37.97,0.23,392,35201,70,NULL,NULL,'SDSS J115007.58+063044.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000145,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,177.531625,6.51244,0,NULL,60159894368,939998349,14687474,18.3),(85458,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85458,36.66,0.46,215,35202,70,NULL,NULL,'2MASX J11500791+2557393',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000166,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,177.532917,25.96097,0.035,NULL,60538391611,945912368,14779880,16.7),(85459,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85459,38.22,0.46,441,35203,70,NULL,NULL,'2MASX J11500880+1216437',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,177.5367917,12.27911,0.031,NULL,60244884256,941326316,14708223,17.7),(85460,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85460,38.15,0.46,427,35204,70,NULL,NULL,'2MASX J11500932-0110153',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000078,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,177.538875,-1.17103,0.025,NULL,40817219973,637769062,9965141,18.2),(85461,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85461,38.48,0.46,497,35205,70,NULL,NULL,'2MASX J11500945+2730033',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,177.5395,27.50097,0.046,NULL,60594944217,946796003,14793687,17.9),(85462,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85462,37.09,0.46,261,35206,70,NULL,NULL,'2MASX J11500987+1654177',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,177.54125,16.90486,0.116,NULL,60252416990,941444015,14710062,17.7),(85463,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85463,36.37,0.56,188,35207,70,NULL,NULL,'2MASX J11501061-1941095',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.91',0.4,NULL,NULL,NULL,NULL,NULL,1,177.544208333,-19.68608,0.113,NULL,40950109543,639845461,9997585,15.91),(85464,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85464,37.97,0.23,392,35208,70,NULL,NULL,'2MASX J11501093+0633400',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000213,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,177.545583,6.56128,0,NULL,60159922476,939998788,14687481,16.4),(85465,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85465,36.8,0.46,229,35209,70,NULL,NULL,'2MASX J11501171+3808141',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000177,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,177.548833,38.13728,0,NULL,60455080012,944610625,14759541,16.3),(85466,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85466,34.12,0.49,66.7,35210,75,NULL,'IR','UGC 06804',NULL,'2011yCatp016004901K',2011,1,1.73,NULL,'G',0.000006,NULL,'15.5g',0.27,'Sd',NULL,NULL,NULL,NULL,1,177.5502917,6.99911,0,NULL,60159588902,939993576,14687399,15.5),(85467,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85467,34.29,NULL,72.2,35210,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06804',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85468,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85468,34.3,NULL,72.5,35210,NULL,NULL,'Dipole + Quadrupole','UGC 06804',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85469,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85469,34.31,NULL,72.7,35210,NULL,NULL,'Dipole','UGC 06804',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85470,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85470,34.36,NULL,74.5,35210,NULL,NULL,NULL,'UGC 06804',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85471,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85471,34.44,0.2,77.3,35210,74.4,NULL,NULL,'UGC 06804',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85472,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85472,34.53,0.33,80.6,35210,NULL,NULL,NULL,'UGC 06804',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85473,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85473,34.64,0.31,84.7,35210,NULL,NULL,'Malmquist cor.','UGC 06804',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85474,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85474,37.13,0.46,267,35211,70,NULL,NULL,'2MASX J11501246+0433155',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000217,NULL,'16.0g',0.38,'E0',NULL,NULL,NULL,NULL,1,177.551833,4.55417,0,NULL,60191625202,940494143,14695220,16),(85475,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85475,37.94,0.46,387,35212,70,NULL,NULL,'2MASX J11501363+2711571',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,177.556625,27.19911,0.055,NULL,60594991724,946796745,14793699,17.8),(85476,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85476,37.52,0.46,319,35213,70,NULL,NULL,'2MASX J11501378+6343094',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00017,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,177.557791667,63.71919,0.033,NULL,61819783819,965934122,15092720,16.6),(85477,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85477,37.97,0.46,393,35214,70,NULL,NULL,'2MASX J11501446+3001570',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,177.560333333,30.03256,0.029,NULL,60565492638,946335822,14786497,17),(85478,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85478,37.38,0.46,299,35215,70,NULL,NULL,'2MASX J11501445+1429486',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000172,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,177.560375,14.49683,0.075,NULL,60235669945,941182342,14705974,17.2),(85479,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85479,37.72,0.46,351,35216,70,NULL,NULL,'2MASX J11501471+2029532',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.66',0.15,NULL,NULL,NULL,NULL,NULL,1,177.561333,20.49811,0.165,NULL,61071235972,954238062,14909969,18.66),(85480,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85480,37.43,0.16,306,35217,70,NULL,NULL,'2MASX J11501503+0538215',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000174,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,177.56275,5.63944,0,NULL,60189460799,940460324,14694692,17.1),(85481,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85481,37.51,0.46,318,35218,70,NULL,NULL,'2MASX J11501643+2127171',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000117,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,177.5685,21.45469,0.094,NULL,61072338519,954255289,14910238,16.3),(85482,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85482,37.43,0.16,306,35219,70,NULL,NULL,'2MASX J11501657+0537285',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,177.568917,5.62481,0,NULL,60189461269,940460332,14694692,16.7),(85483,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85483,36.34,0.46,185,35220,70,NULL,NULL,'2MASX J11501660+1138050',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000153,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,177.569375,11.63478,0.051,NULL,60232526135,941133220,14705206,17.1),(85484,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85484,37.33,0.46,293,35221,70,NULL,NULL,'2MASX J11501725+5848569',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,177.571708333,58.81583,0,NULL,61842168271,966283879,15098185,17.5),(85485,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85485,36.16,NULL,171,35222,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1316',NULL,'2010Ap&SS.325..163P',2010,1,0.67,NULL,'G',0.000058,NULL,'17.4g',0.12,'Sd(f)',NULL,NULL,NULL,NULL,1,177.574125,66.48114,0.005,NULL,61811216977,965800265,15090629,17.4),(85486,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85486,36.18,NULL,172,35222,NULL,NULL,NULL,'FGC 1316',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85487,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85487,36.19,NULL,173,35222,NULL,NULL,'Dipole + Quadrupole','FGC 1316',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85488,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85488,36.22,NULL,176,35222,NULL,NULL,'Dipole','FGC 1316',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85489,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85489,37.5,0.46,316,35223,70,NULL,NULL,'2MASX J11501798+0649270',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,177.574875,6.82428,0,NULL,60159606104,939993845,14687403,17.1),(85490,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85490,37.89,0.27,379,35224,70,NULL,NULL,'SDSS J115018.05+065310.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000144,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,177.57525,6.88633,0,NULL,60159608800,939993887,14687404,18),(85491,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85491,34.57,NULL,82.1,35225,NULL,NULL,'Dipole','UGC 06808',NULL,'2010Ap&SS.325..163P',2010,1,1.35,NULL,'G',0.00002,NULL,'16.4g',0.18,'Sc',NULL,NULL,NULL,NULL,1,177.5755417,35.25408,0,NULL,60445651814,944463309,14757239,16.4),(85492,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85492,34.58,NULL,82.4,35225,NULL,NULL,'Dipole + Quadrupole','UGC 06808',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85493,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85493,34.58,NULL,82.4,35225,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06808',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85494,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85494,34.7,NULL,86.9,35225,NULL,NULL,NULL,'UGC 06808',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85495,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85495,35.33,0.49,116,35225,75,NULL,'IR','UGC 06808',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85496,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85496,35.52,0.2,127,35225,74.4,NULL,NULL,'UGC 06808',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85497,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85497,37.3,0.46,289,35226,70,NULL,NULL,'2MASX J11501831+0827210',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000162,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,177.5762917,8.45583,0,NULL,60161148950,940017952,14687780,16.7),(85498,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85498,38,0.46,399,35227,70,NULL,NULL,'SDSS J115019.55+120257.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.1g',0.13,'Cand.grav.lens',NULL,NULL,NULL,NULL,1,177.5815,12.04925,0.014,NULL,60244794860,941324919,14708201,18.1),(85499,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85499,37.47,0.46,312,35228,70,NULL,NULL,'2MASX J11501968+2541441',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00018,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,177.5822083,25.6955,0.028,NULL,60537834183,945903659,14779744,17.1),(85500,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85500,34.62,0.33,83.8,35229,NULL,NULL,'Malmquist cor.','CGCG 012-102',NULL,'2009ApJS..182..474S',2009,1,1.46,NULL,'G',0.000033,NULL,'14.5g',0.59,'SAB(s)b pec:',NULL,NULL,NULL,NULL,1,177.585583333,-2.81108,0.037,NULL,40814872300,637732379,9964568,14.5),(85501,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85501,34.8,0.31,91.1,35229,NULL,NULL,NULL,'CGCG 012-102',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85502,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85502,34.84,0.2,92.9,35229,74.4,NULL,NULL,'CGCG 012-102',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85503,'Tully est','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85503,31.76,0.8,22.5,35230,75,NULL,NULL,'ESO 039- G 002',NULL,'1988NBGC.C....0000T',1988,1,3,NULL,'G',0.00001,NULL,'13.9',1.7,'IAB(s)m',NULL,NULL,NULL,NULL,1,177.5857917,-75.37086,0.673,NULL,39836239991,622441249,9725644,13.9),(85504,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85504,37.55,0.46,324,35231,70,NULL,NULL,'SDSS J115023.07+121957.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000138,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,177.596167,12.3325,0.031,NULL,60244872646,941326135,14708220,18.1),(85505,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85505,37.88,0.23,377,35232,70,NULL,NULL,'2MASX J11502401+2629031',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000182,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,177.600125,26.48425,0.043,NULL,60593413313,946772083,14793313,17.9),(85506,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85506,37.21,0.1,276,35233,70,NULL,NULL,'2MASX J11502412+5440030',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000202,NULL,'15.4g',0.47,'S0^-',NULL,NULL,NULL,NULL,1,177.6005,54.66761,0,NULL,61760142556,965002227,15078159,15.4),(85507,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85507,38,0.33,399,35234,70,NULL,NULL,'LCRS B114751.3-022847',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000173,NULL,'16.7g',0.35,NULL,NULL,NULL,NULL,NULL,1,177.603833,-2.75744,0.037,NULL,40814886270,637732597,9964571,16.7),(85508,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85508,38.03,0.23,404,35235,70,NULL,NULL,'2MASX J11502494+4223227',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000148,NULL,'17.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,177.603833,42.38972,0,NULL,60413238382,943956849,14749325,17.1),(85509,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85509,37.77,0.46,358,35236,70,NULL,NULL,'2MASX J11502509+2525261',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,177.6045,25.424,0.028,NULL,60545391628,946021744,14781589,17.3),(85510,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85510,37.61,0.46,332,35237,70,NULL,NULL,'2MASX J11502520+4220537',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000171,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,177.604833,42.34808,0,NULL,60413222544,943956602,14749321,17.7),(85511,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85511,37.89,0.46,379,35238,70,NULL,NULL,'2MASX J11502668+3142340',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,177.6110417,31.70944,0.085,NULL,60551069223,946110456,14782975,17.9),(85512,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85512,37.11,0.46,265,35239,70,NULL,NULL,'2MASX J11502674+2720451',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,177.611375,27.34589,0.055,NULL,60595031778,946797371,14793708,17.6),(85513,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85513,37.81,0.46,365,35240,70,NULL,NULL,'2MASX J11502718+5412399',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000194,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,177.6134583,54.21108,0,NULL,61770849698,965169526,15080773,16.9),(85514,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85514,37.31,0.46,290,35241,70,NULL,NULL,'2MASX J11502749+1415410',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000161,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,177.6145,14.2615,0.073,NULL,60235564949,941180702,14705948,18.1),(85515,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85515,37.16,0.46,271,35242,70,NULL,NULL,'2MASX J11502750+0456245',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,177.614541667,4.94008,0,NULL,60190136375,940470880,14694857,16.8),(85516,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85516,37.23,0.46,279,35243,70,NULL,NULL,'LCRS B114754.7-024139',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000161,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,177.617583333,-2.97208,0.037,NULL,40812900474,637701569,9964087,17.6),(85517,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85517,36.79,0.33,228,35244,70,NULL,NULL,'2MASX J11502827+0643570',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000187,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,177.617666667,6.73264,0,NULL,60159720237,939995628,14687431,16.7),(85518,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85518,37.67,0.46,342,35245,70,NULL,NULL,'2MASX J11502842+2528171',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,177.618583333,25.47144,0.028,NULL,60545419466,946022179,14781596,17.7),(85519,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85519,36.79,0.33,228,35246,70,NULL,NULL,'2MASX J11502861+0641430',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000164,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,177.6192083,6.69525,0,NULL,60159928141,939998877,14687482,16.8),(85520,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85520,37.59,0.46,329,35247,70,NULL,NULL,'2MASX J11502888-0020591',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000076,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,177.620417,-0.34972,0.049,NULL,40803468343,637554192,9961784,17.1),(85521,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85521,36.6,0.46,209,35248,70,NULL,NULL,'2MASX J11502930+2835401',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000189,NULL,'15.7g',0.52,NULL,NULL,NULL,NULL,NULL,1,177.622083,28.59458,0.046,NULL,60559860473,946247819,14785122,15.7),(85522,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85522,35.98,0.46,157,35249,70,NULL,NULL,'2MASX J11502945+2415072',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000149,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,177.622833,24.25211,0.057,NULL,60548069510,946063586,14782243,16.6),(85523,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85523,37.03,0.46,255,35250,70,NULL,NULL,'2MASX J11503011+3425001',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00017,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,177.625625,34.41667,0,NULL,60434056764,944282136,14754408,16.3),(85524,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85524,37.89,0.27,379,35251,70,NULL,NULL,'2MASX J11503021+0656310',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000188,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,177.626083333,6.942,0,NULL,60159622746,939994105,14687407,16.5),(85525,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85525,37.72,0.46,351,35252,70,NULL,NULL,'2MASX J11503038+1312230',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,177.626583,13.20639,0.071,NULL,60246648732,941353886,14708654,17.9),(85526,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85526,38.03,0.23,404,35253,70,NULL,NULL,'2MASX J11503089+4228433',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,177.6287083,42.47878,0,NULL,60413243180,943956924,14749326,17.5),(85527,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85527,36.93,0.46,243,35254,70,NULL,NULL,'LCRS B114757.7-022618',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000151,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,177.6302917,-2.71614,0.037,NULL,40814901410,637732834,9964575,17.1),(85528,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85528,34.41,0.47,76.3,35255,NULL,NULL,'H','NGC 3914',NULL,'2007A&A...465...71T',2007,1,1.28,NULL,'G',0.000033,NULL,'13.8g',0.72,'(R\')SB(rs)b','Group member',NULL,NULL,NULL,1,177.6360417,6.56758,0,NULL,60159950374,939999224,14687487,13.8),(85529,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85529,34.52,0.2,80.2,35255,74.4,NULL,NULL,'NGC 3914',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85530,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85530,34.55,0.45,81.3,35255,NULL,NULL,'K','NGC 3914',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85531,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85531,34.56,0.46,81.6,35255,NULL,NULL,'J','NGC 3914',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85532,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85532,34.61,0.33,83.7,35255,NULL,NULL,NULL,'NGC 3914',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85533,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85533,34.63,0.33,84.2,35255,NULL,NULL,'Malmquist cor.','NGC 3914',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85534,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85534,34.8,0.4,91.2,35255,NULL,NULL,'mean','NGC 3914',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85535,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85535,37.89,0.27,379,35256,70,NULL,NULL,'SDSS J115032.85+065743.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000159,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,177.636917,6.96219,0,NULL,60159620614,939994072,14687407,18.2),(85536,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85536,37.58,0.33,328,35257,70,NULL,NULL,'SDSS J115033.24+105224.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000143,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,177.6385,10.8735,0.02,NULL,60366497812,943226528,14737914,17.9),(85537,'SNIa','2016-12-15 15:14:51','2016-12-16 11:20:00','1','SN 1996U','R',85537,41.1,NULL,1160,35258,65,NULL,'SALT','[GC96a] J115033.54+102646.7',0.43,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,177.63975,10.44631,0.014,NULL,60365852741,943216449,14737757,NULL),(85538,'SNIa','2016-12-15 15:14:51','2016-12-16 11:20:00','1','SN 1996U',NULL,85538,41.7,0.47,1530,35258,74.2,NULL,'SALT 2','[GC96a] J115033.54+102646.7',0.43,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85539,'SNIa','2016-12-15 15:14:51','2016-12-16 11:20:00','1','SN 1996U',NULL,85539,42.29,0.35,2010,35258,70,NULL,'SALT','[GC96a] J115033.54+102646.7',0.43,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85540,'SNIa','2016-12-15 15:14:51','2016-12-16 11:20:00','1','SN 1996U',NULL,85540,42.34,0.17,2050,35258,65,NULL,'Template','[GC96a] J115033.54+102646.7',0.43,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85541,'SNIa','2016-12-15 15:14:51','2016-12-16 11:20:00','1','SN 1996U',NULL,85541,42.33,0.34,2050,35258,65,NULL,NULL,'[GC96a] J115033.54+102646.7',0.43,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85542,'SNIa','2016-12-15 15:14:51','2016-12-16 11:20:00','1','SN 1996U',NULL,85542,42.52,0.33,2230,35258,65,NULL,'SALT','[GC96a] J115033.54+102646.7',0.43,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85543,'SNIa','2016-12-15 15:14:51','2016-12-16 11:20:00','1','SN 1996U',NULL,85543,42.55,0.25,2260,35258,65,NULL,'MLCS','[GC96a] J115033.54+102646.7',0.43,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85544,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85544,37.62,0.14,334,35259,70,NULL,NULL,'SDSS J115033.80+435435.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000167,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,177.640833333,43.90992,0,NULL,63890003008,998281297,15598145,17.9),(85545,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85545,38.52,0.33,506,35260,70,NULL,NULL,'2MASX J11503382+5644249',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000184,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,177.641125,56.74025,0,NULL,61975390864,968365482,15130710,18.2),(85546,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85546,38.03,0.23,404,35261,70,NULL,NULL,'2MASX J11503396+4229044',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000179,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,177.641333,42.48442,0,NULL,60413242727,943956917,14749326,17.6),(85547,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85547,37.28,0.46,285,35262,70,NULL,NULL,'2MASX J11503492+1903144',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,177.645667,19.05414,0.079,NULL,60211662706,940807229,14700112,18.1),(85548,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85548,37.73,0.17,352,35263,70,NULL,NULL,'2MASX J11503595+1250560',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,177.649625,12.84881,0.039,NULL,60246588069,941352938,14708639,17.5),(85549,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85549,37.22,0.46,278,35264,70,NULL,NULL,'2MASX J11503680+2607451',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000166,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,177.6532917,26.12933,0.037,NULL,60538429842,945912966,14779890,16.8),(85550,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85550,37.91,0.46,382,35265,70,NULL,NULL,'2MASX J11503776+5130268',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000179,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,177.657333,51.50739,0.007,NULL,61799198637,965612478,15087694,17.3),(85551,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85551,37.52,0.46,320,35266,70,NULL,NULL,'2MASX J11503837+0137325',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00009,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,177.659917,1.62572,0.037,NULL,60146055450,939782116,14684095,16.8),(85552,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85552,37,0.46,252,35267,70,NULL,NULL,'LCRS B114805.3-030844',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000139,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,177.661583,-3.42356,0.057,NULL,40857959711,638405620,9975087,17.7),(85553,'SNIa','2016-12-15 15:14:51','2016-12-16 11:20:00','1','SN 1979B','R',85553,31.61,NULL,21,35268,NULL,NULL,'Photographic','NGC 3913',NULL,'1988SSRv...48....1R',1988,1,2.6,'HOLM 296B does not exist (it is probably a plate defect).','G',0.000013,NULL,'13.17',2.6,'(R\')SA(rs)d:','in an interacting pair',NULL,NULL,NULL,1,177.66225,55.35386,0,NULL,61760689172,965010768,15078293,13.17),(85554,'SNIa','2016-12-15 15:14:51','2016-12-16 11:20:00','1','SN 1963J','R',85554,33.33,NULL,46.3,35268,NULL,NULL,'Photographic','NGC 3913',NULL,'1988SSRv...48....1R',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85555,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85555,31.15,0.4,17,35268,75,NULL,'B','NGC 3913',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85556,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85556,36.52,0.46,201,35269,70,NULL,NULL,'2MASX J11503916+0251136',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000086,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,177.663375,2.85367,0.045,NULL,60134890039,939607656,14681369,16.3),(85557,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85557,37.22,0.46,278,35270,70,NULL,NULL,'2MASX J11503957+3500251',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000148,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,177.664916667,35.00703,0,NULL,60434260869,944285326,14754458,17.7),(85558,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85558,37.51,0.46,318,35271,70,NULL,NULL,'2MASX J11504009+0926000',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,177.667083,9.43325,0,NULL,60367530047,943242656,14738166,17.2),(85559,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85559,37.58,0.46,328,35272,70,NULL,NULL,'2MASX J11504035+2557231',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000166,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,177.668,25.95653,0,NULL,60538405816,945912590,14779884,17.3),(85560,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85560,35.26,0.07,113,35273,70,NULL,NULL,'NGC 3919',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000067,NULL,'14.34',0.9,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,177.6730417,20.01519,0.129,NULL,60197791149,940590486,14696726,14.34),(85561,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85561,37.73,0.17,352,35274,70,NULL,NULL,'2MASX J11504183+1249140',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000176,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,177.674375,12.82061,0.039,NULL,60246578571,941352790,14708637,17.9),(85562,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85562,36.1,0.46,166,35275,70,NULL,NULL,'CGCG 186-055',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000203,NULL,'15.2g',0.59,NULL,NULL,NULL,NULL,NULL,1,177.674625,32.69725,0.033,NULL,60619639409,947181865,14799716,15.2),(85563,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85563,38.03,0.23,404,35276,70,NULL,NULL,'2MASX J11504247+4220184',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,177.676917,42.3385,0,NULL,60413763688,943965057,14749454,17.3),(85564,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85564,33.38,0.89,47.5,35277,NULL,NULL,NULL,'2MASX J11504398+2111034',NULL,'2009ApJS..182..474S',2009,1,0.57,'1997AJ....113.1197H: V = 7755 +- 17 km/s; 2003AJ....126.2152R same as SDSS.','G',0.000162,NULL,'16.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,177.683333,21.18439,0.138,NULL,61071506431,954242287,14910035,16.6),(85565,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85565,33.56,0.82,51.4,35277,NULL,NULL,'Malmquist cor.','2MASX J11504398+2111034',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85566,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85566,37.75,0.46,355,35278,70,NULL,NULL,'2MASX J11504443+6542495',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000157,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,177.685417,65.71364,0.017,NULL,61810142482,965783476,15090366,17),(85567,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85567,38.37,0.46,472,35279,70,NULL,NULL,'SDSS J115044.96+242634.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000148,NULL,'18.7g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,177.687375,24.44286,0.027,NULL,60548836506,946075570,14782430,18.7),(85568,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85568,37.98,0.33,394,35280,70,NULL,NULL,'SDSS J115044.98+312519.4',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000253,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,177.687416667,31.42208,0.05,NULL,60550464685,946101010,14782828,17.7),(85569,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85569,38.31,0.46,459,35281,70,NULL,NULL,'2MASX J11504522+2442344',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,177.6885417,24.70956,0.029,NULL,60548948303,946077317,14782458,17.3),(85570,'IRAS','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85570,31.29,0.8,18.1,35282,75,NULL,'A82, H','NGC 3917',NULL,'1997ApJS..109..333W',1997,1,5.1,NULL,'G',0.000005,NULL,'12.51',1.3,'SAcd:;LINER    HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,177.6892917,51.82467,0.01,NULL,61768790204,965137346,15080271,12.51),(85571,'IRAS','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85571,31.33,0.8,18.5,35282,75,NULL,'W91CL, r','NGC 3917',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85572,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85572,30.79,NULL,14.4,35282,NULL,NULL,'B, Hubble-type-TF','NGC 3917',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85573,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85573,30.93,NULL,15.3,35282,NULL,NULL,'B','NGC 3917',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85574,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85574,30.96,0.38,15.5,35282,75,NULL,'W91CL, r, raw','NGC 3917',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85575,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85575,30.96,0.4,15.6,35282,75,NULL,NULL,'NGC 3917',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85576,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85576,30.98,0.12,15.7,35282,NULL,NULL,NULL,'NGC 3917',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85577,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85577,30.99,0.38,15.8,35282,75,NULL,'W91CL, r, inv','NGC 3917',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85578,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85578,31.03,NULL,16.1,35282,NULL,NULL,'I','NGC 3917',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85579,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85579,31.05,NULL,16.2,35282,NULL,NULL,'B','NGC 3917',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85580,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85580,31.09,NULL,16.5,35282,NULL,NULL,'I, Hubble-type-TF','NGC 3917',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85581,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85581,31.1,0.35,16.6,35282,NULL,NULL,NULL,'NGC 3917',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85582,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85582,31.15,0.38,16.9,35282,75,NULL,'W91CL, r, cor','NGC 3917',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85583,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85583,31.14,0.2,16.9,35282,74.4,NULL,NULL,'NGC 3917',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85584,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85584,31.15,0.4,17,35282,75,NULL,'B','NGC 3917',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85585,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85585,31.17,0.43,17.1,35282,75,NULL,'3.6 micron, color corrected','NGC 3917',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85586,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85586,31.19,NULL,17.3,35282,NULL,NULL,'I','NGC 3917',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85587,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85587,31.21,0.47,17.4,35282,75,NULL,'A82, H, raw','NGC 3917',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85588,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85588,31.21,0.47,17.4,35282,75,NULL,'A82, H, inv','NGC 3917',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85589,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85589,31.23,0.43,17.6,35282,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3917',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85590,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85590,31.33,0.46,18.5,35282,NULL,NULL,'J','NGC 3917',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85591,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85591,31.37,0.47,18.8,35282,NULL,NULL,'H','NGC 3917',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85592,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85592,31.39,0.4,18.9,35282,NULL,NULL,'mean','NGC 3917',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85593,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85593,31.4,0.49,19,35282,75,NULL,'IR','NGC 3917',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85594,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85594,31.46,0.47,19.6,35282,75,NULL,'A82, H, cor','NGC 3917',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85595,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85595,31.54,0.45,20.3,35282,NULL,NULL,'K','NGC 3917',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85596,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85596,37.43,0.16,306,35283,70,NULL,NULL,'2MASX J11504609+0540346',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000176,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,177.692,5.67642,0,NULL,60156907808,939951684,14686745,16.8),(85597,'IRAS','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85597,30.91,0.8,15.2,35284,75,NULL,'W91CL, r','UGC 06818',NULL,'1997ApJS..109..333W',1997,1,1.92,NULL,'G',0.000007,NULL,'14.6g',0.59,'SB?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,177.695625,45.80719,0,NULL,63891363150,998302549,15598477,14.6),(85598,'IRAS','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85598,30.94,0.8,15.4,35284,75,NULL,'A82, H','UGC 06818',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85599,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85599,31.15,0.4,17,35284,75,NULL,'B','UGC 06818',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85600,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85600,31.45,0.2,19.5,35284,74.4,NULL,NULL,'UGC 06818',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85601,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85601,31.72,0.38,22.1,35284,75,NULL,'W91CL, r, inv','UGC 06818',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85602,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85602,31.83,0.38,23.2,35284,75,NULL,'W91CL, r, raw','UGC 06818',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85603,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85603,31.87,0.47,23.7,35284,75,NULL,'A82, H, inv','UGC 06818',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85604,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85604,31.95,0.38,24.5,35284,75,NULL,'W91CL, r, cor','UGC 06818',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85605,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85605,32.05,0.47,25.7,35284,75,NULL,'A82, H, raw','UGC 06818',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85606,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85606,32.27,0.47,28.4,35284,75,NULL,'A82, H, cor','UGC 06818',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85607,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85607,31.15,0.4,17,35285,75,NULL,'B','UGC 06816',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.000007,NULL,'14.12',1.3,'IB(s)m IV','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,177.69875,56.45586,0,NULL,61975730628,968370791,15130793,14.12),(85608,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85608,32.16,0.36,27,35285,NULL,NULL,NULL,'UGC 06816',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85609,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85609,35.99,0.33,158,35286,70,NULL,NULL,'2MASX J11504872+2751504',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00016,NULL,'16.1g',0.31,NULL,NULL,NULL,NULL,NULL,1,177.703125,27.86406,0.039,NULL,60594715922,946792436,14793631,16.1),(85610,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85610,37.62,0.14,334,35287,70,NULL,NULL,'2MASX J11504960+4401544',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000174,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,177.706667,44.03172,0,NULL,63891057745,998297777,15598402,17.1),(85611,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85611,37.69,0.46,345,35288,70,NULL,NULL,'2MASX J11504990+2202074',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.43',0.16,NULL,NULL,NULL,NULL,NULL,1,177.7079583,22.03542,0.076,NULL,61073073372,954266771,14910418,18.43),(85612,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85612,37.98,0.33,394,35289,70,NULL,NULL,'2MASX J11505032+3124262',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00015,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,177.709708333,31.40731,0.05,NULL,60550467193,946101049,14782828,17.4),(85613,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85613,38.03,0.46,404,35290,70,NULL,NULL,'2MASX J11505114+3544162',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00019,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,177.713125,35.73789,0,NULL,60447463133,944491611,14757681,17.4),(85614,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85614,37.5,0.27,316,35291,70,NULL,NULL,'2MASX J11505127+3221102',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000184,NULL,'16.3g',0.36,'BrClG',NULL,NULL,NULL,NULL,1,177.7135417,32.35294,0.049,NULL,60618655039,947166484,14799476,16.3),(85615,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85615,37.97,0.23,392,35292,70,NULL,NULL,'2MASX J11505126+0638262',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000241,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,177.713625,6.64047,0,NULL,60159907249,939998550,14687477,16.2),(85616,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85616,37.55,0.46,324,35293,70,NULL,NULL,'2MASX J11505151+3307431',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000158,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,177.71475,33.12844,0,NULL,60620233722,947191151,14799861,17.3),(85617,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85617,37.97,0.23,392,35294,70,NULL,NULL,'2MASX J11505160+0639292',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,177.7149583,6.65817,0,NULL,60159909047,939998578,14687477,17.6),(85618,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85618,34.18,0.43,68.7,35295,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 127-068',NULL,'2014MNRAS.444..527S',2014,1,0.6,NULL,'G',0.000069,NULL,'15.3',0.4,'Scd-Irr',NULL,NULL,NULL,NULL,1,177.719625,21.16897,0.138,NULL,61071503984,954242249,14910035,15.3),(85619,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85619,34.28,0.43,71.9,35295,75,NULL,'3.6 micron, color corrected','CGCG 127-068',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85620,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85620,34.41,0.2,76.2,35295,74.4,NULL,NULL,'CGCG 127-068',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85621,'Brightest Stars','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85621,27.97,0.4,3.92,35296,NULL,NULL,'3B + 3R mean','UGC 06817',NULL,'1997AstL...23..514G',1997,1,4.1,NULL,'G',0.000003,NULL,'13.4',1.5,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,177.720833,38.88028,0,NULL,60456499480,944632804,14759887,13.4),(85622,'TRGB','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85622,27.07,0.13,2.59,35296,NULL,NULL,'I','UGC 06817',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85623,'TRGB','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85623,27.1,0.08,2.63,35296,74.4,NULL,NULL,'UGC 06817',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85624,'TRGB','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85624,27.11,0.17,2.64,35296,NULL,NULL,NULL,'UGC 06817',NULL,'2002A&A...389..812K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85625,'TRGB','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85625,27.11,0.04,2.64,35296,NULL,NULL,NULL,'UGC 06817',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85626,'TRGB','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85626,27.11,0.08,2.64,35296,NULL,NULL,'I','UGC 06817',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85627,'TRGB','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85627,27.11,0.1,2.64,35296,NULL,NULL,NULL,'UGC 06817',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85628,'TRGB','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85628,27.13,0.08,2.66,35296,NULL,NULL,NULL,'UGC 06817',NULL,'2013AstBu..68..125M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85629,'TRGB','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85629,27.13,0.12,2.67,35296,NULL,NULL,NULL,'UGC 06817',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85630,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85630,27.49,0.4,3.1,35296,75,NULL,'B','UGC 06817',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85631,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85631,38,0.46,399,35297,70,NULL,NULL,'SDSS J115053.47+204741.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'19.11',0.12,NULL,NULL,NULL,NULL,NULL,1,177.7227917,20.79486,0.15,NULL,61071604045,954243813,14910059,19.11),(85632,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85632,37.34,0.46,293,35298,70,NULL,NULL,'2MASX J11505363+5933052',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000146,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,177.723417,59.55142,0,NULL,61855842488,966497538,15101524,17.8),(85633,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85633,38.26,0.46,448,35299,70,NULL,NULL,'LCRS B114821.0-024136',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,177.727166667,-2.971,0.037,NULL,40812856071,637700876,9964076,17.7),(85634,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85634,34.96,0.46,98.3,35300,70,NULL,NULL,'IC 2967',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000077,NULL,'14.6g',0.65,'E?',NULL,NULL,NULL,NULL,1,177.7297083,30.85069,0.026,NULL,60564326679,946317604,14786212,14.6),(85635,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85635,37.29,0.46,287,35301,70,NULL,NULL,'SDSS J115055.29+064057.8',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000132,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,177.730417,6.68272,0,NULL,60159909275,939998582,14687477,18.5),(85636,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85636,34.36,0.2,74.5,35302,74.4,NULL,NULL,'MRK 1461',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.00002,NULL,'15.70',0.3,'Irr            HII',NULL,NULL,NULL,NULL,1,177.731,21.14547,0.138,NULL,61071496383,954242130,14910033,15.7),(85637,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85637,37.62,0.14,334,35303,70,NULL,NULL,'2MASX J11505591+4402474',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000207,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,177.732875,44.04661,0,NULL,63891057378,998297771,15598402,16.8),(85638,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85638,30.32,NULL,11.6,35304,NULL,NULL,NULL,'CGCG 097-163',NULL,'2015AstBu..70....1K',2015,1,0.59,NULL,'G',0.000023,NULL,'15.9g',0.34,NULL,NULL,NULL,NULL,NULL,1,177.7332917,14.59483,0.075,NULL,60235619551,941181555,14705961,15.9),(85639,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85639,30.07,0.2,10.3,35305,74.4,NULL,NULL,'CGCG 097-163',NULL,'2013AJ....146...86T',2013,1,0.59,NULL,'G',0.000023,NULL,'15.9g',0.34,NULL,NULL,NULL,NULL,NULL,1,177.7332917,14.59483,0.075,NULL,60235619551,941181555,14705961,15.9),(85640,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85640,36.34,0.46,185,35306,70,NULL,NULL,'2MASX J11505599+5301558',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000167,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,177.7332917,53.03222,0,NULL,61766639430,965103741,15079745,16.6),(85641,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85641,38.39,0.46,477,35307,70,NULL,NULL,'2MASX J11505608+5641372',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000215,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,177.733875,56.69369,0,NULL,61975861408,968372834,15130825,17),(85642,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85642,37.93,0.46,385,35308,70,NULL,NULL,'2MASX J11505624+4826068',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,177.734125,48.43525,0.027,NULL,61755210621,964925165,15076955,18),(85643,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85643,37.5,0.27,316,35309,70,NULL,NULL,'2MASX J11505624+3224051',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,177.734167,32.40158,0.049,NULL,60618660713,947166573,14799477,18),(85644,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85644,38.52,0.33,506,35310,70,NULL,NULL,'2MASX J11505650+5649142',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000145,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,177.7355,56.82072,0,NULL,61975504804,968367262,15130738,17.7),(85645,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85645,37,0.46,252,35311,70,NULL,NULL,'2MASX J11505675+3622173',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,177.7362917,36.37144,0,NULL,60447729711,944495776,14757746,17.3),(85646,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85646,35.34,0.49,117,35312,75,NULL,'IR','FGC 1319',NULL,'2011yCatp016004901K',2011,1,1.34,NULL,'G',0.000007,NULL,'17.06',0.15,'Sc','Group non-member, background',NULL,NULL,NULL,1,177.736875,21.19719,0.138,NULL,61071503840,954242247,14910035,17.06),(85647,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85647,35.34,0.55,117,35312,NULL,NULL,'Malmquist cor.','FGC 1319',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85648,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85648,35.35,NULL,118,35312,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1319',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85649,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85649,35.37,NULL,118,35312,NULL,NULL,'Dipole + Quadrupole','FGC 1319',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85650,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85650,35.38,NULL,119,35312,NULL,NULL,'Dipole','FGC 1319',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85651,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85651,35.4,NULL,120,35312,NULL,NULL,NULL,'FGC 1319',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85652,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85652,35.78,0.45,143,35312,NULL,NULL,NULL,'FGC 1319',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85653,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85653,35.86,0.2,149,35312,74.4,NULL,NULL,'FGC 1319',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85654,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85654,37.28,0.33,286,35313,70,NULL,NULL,'2MASX J11505717+1524192',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000167,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,177.738125,15.40544,0.077,NULL,60254072598,941469884,14710466,16.9),(85655,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85655,36.95,0.58,246,35314,70,NULL,NULL,'2MASX J11505819-0523095',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'17.44',0.28,NULL,NULL,NULL,NULL,NULL,1,177.7425417,-5.38589,0.061,NULL,40859794482,638434288,9975535,17.44),(85656,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85656,35.67,0.46,136,35315,70,NULL,NULL,'2MASX J11505884+1346232',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.0001,NULL,'16.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,177.745125,13.77311,0.066,NULL,60243804983,941309452,14707960,16.5),(85657,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85657,34.92,0.46,96.4,35316,70,NULL,NULL,'CGCG 157-043',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000168,NULL,'15.4g',0.51,'E',NULL,NULL,NULL,NULL,1,177.745375,30.56956,0.026,NULL,60564785804,946324778,14786324,15.4),(85658,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85658,37.9,0.21,381,35317,70,NULL,NULL,'LCRS B114827.1-024755',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000083,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,177.752833333,-3.07642,0.057,NULL,40812878345,637701224,9964081,17.5),(85659,'Tully-Fisher','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85659,34.94,0.12,97.5,35318,NULL,NULL,NULL,'UGC 06821',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000007,NULL,'14.44',1.2,'SAB(rs)bc:',NULL,NULL,NULL,NULL,1,177.754625,20.39933,0.158,NULL,60198564589,940602571,14696915,14.44),(85660,'SBF','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85660,31.49,0.16,19.9,35319,NULL,NULL,'BV A01','NGC 3923',NULL,'2007ApJ...668..130C',2007,1,5.9,NULL,'G',0.00003,NULL,'10.8',3.9,'E4-5','in a pair',NULL,NULL,NULL,1,177.757041667,-28.80603,0.237,NULL,41445983307,647593489,10118648,10.8),(85661,'SBF','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85661,31.64,0.14,21.3,35319,74.4,NULL,NULL,'NGC 3923',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85662,'SBF','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85662,31.7,0.1,21.9,35319,NULL,NULL,'J03','NGC 3923',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85663,'SBF','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85663,31.7,0.1,21.9,35319,NULL,NULL,'M06','NGC 3923',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85664,'SBF','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85664,31.8,0.28,22.9,35319,NULL,NULL,'I','NGC 3923',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85665,'SBF','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85665,31.8,0.28,22.9,35319,NULL,NULL,NULL,'NGC 3923',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85666,'SBF','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85666,31.86,0.1,23.6,35319,NULL,NULL,'T01','NGC 3923',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85667,'SBF','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85667,31.9,0.28,24,35319,NULL,NULL,'Malmquist cor.','NGC 3923',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85668,'D-Sigma','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85668,31.2,0.4,17.3,35319,75,NULL,'Edat, raw','NGC 3923',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85669,'D-Sigma','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85669,31.52,0.4,20.2,35319,75,NULL,'Edat, cor','NGC 3923',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85670,'Faber-Jackson','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85670,30.62,0.63,13.3,35319,95,NULL,'Michard 1979b, c','NGC 3923',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85671,'Faber-Jackson','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85671,30.95,0.46,15.5,35319,95,NULL,'Michard 1979a','NGC 3923',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85672,'Faber-Jackson','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85672,31.02,0.37,16,35319,95,NULL,'Weighted Mean','NGC 3923',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85673,'Faber-Jackson','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,'R',85673,31.19,NULL,17.3,35319,NULL,NULL,'LEDA [April 2006]','NGC 3923',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85674,'Faber-Jackson','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85674,33.25,0.81,44.7,35319,55,NULL,'Visvanathan & Sandage 1979','NGC 3923',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85675,'FP','2016-12-15 15:14:51','2016-12-16 11:20:00','1',NULL,NULL,85675,30.77,0.41,14.2,35319,NULL,NULL,NULL,'NGC 3923',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85676,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85676,31.02,0.41,16,35319,NULL,NULL,'Malmquist cor.','NGC 3923',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85677,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85677,31.02,0.53,16,35319,70,NULL,NULL,'NGC 3923',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85678,'Tully est','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85678,32.06,0.8,25.8,35319,75,NULL,'B','NGC 3923',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85679,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85679,37.28,0.33,286,35320,70,NULL,NULL,'2MASX J11510187+1521122',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,177.7579583,15.35319,0.077,NULL,60254098265,941470285,14710473,18.1),(85680,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85680,37.42,0.33,304,35321,70,NULL,NULL,'2MASX J11510243+4327023',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000181,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,177.76,43.45053,0,NULL,60399712646,943745510,14746023,16.4),(85681,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85681,37.47,0.46,311,35322,70,NULL,NULL,'SDSS J115103.50+122056.1',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000167,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,177.764625,12.34894,0.025,NULL,60244771216,941324550,14708196,16.6),(85682,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85682,37.33,0.46,293,35323,70,NULL,NULL,'2MASX J11510453+4325013',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,177.769,43.41694,0,NULL,60399710810,943745481,14746023,17.6),(85683,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85683,38.19,0.81,434,35324,70,NULL,NULL,'2MASX J11510535-2813591',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.5b',0.5,'SB',NULL,NULL,NULL,NULL,1,177.772333,-28.23308,0.301,NULL,41463303237,647864113,10122876,15.5),(85684,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85684,37.9,0.46,380,35325,70,NULL,NULL,'2MASX J11510538+0920353',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000155,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,177.7725,9.34319,0,NULL,60367496344,943242130,14738158,17.6),(85685,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85685,37.56,0.46,325,35326,70,NULL,NULL,'SDSS J115105.59+562135.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,177.773333,56.35983,0,NULL,61975726230,968370722,15130792,18.2),(85686,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85686,36.27,0.46,179,35327,70,NULL,NULL,'2MASX J11510563+2813074',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000183,NULL,'15.6g',0.49,NULL,NULL,NULL,NULL,NULL,1,177.7735,28.21894,0.049,NULL,60592737351,946761521,14793148,15.6),(85687,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85687,35.95,0.27,155,35328,70,NULL,NULL,'2MASX J11510593+0839303',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000176,NULL,'15.8g',0.44,NULL,NULL,NULL,NULL,NULL,1,177.774708333,8.65844,0,NULL,60147462998,939804109,14684439,15.8),(85688,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85688,38.1,0.46,418,35329,70,NULL,NULL,'2MASX J11510717+0623153',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,177.779916667,6.38739,0,NULL,60159833612,939997400,14687459,17.1),(85689,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85689,38.09,0.46,415,35330,70,NULL,NULL,'2MASX J11510848+3704093',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,177.785458333,37.06942,0,NULL,60437257743,944332152,14755189,17.5),(85690,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85690,37.52,0.33,319,35331,70,NULL,NULL,'LCRS B114835.0-025823',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000175,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,177.7857083,-3.25089,0.057,NULL,40812791848,637699872,9964060,16.6),(85691,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85691,36.93,0.21,243,35332,70,NULL,NULL,'2MASX J11510912+0502346',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000144,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,177.787917,5.04286,0,NULL,60190156940,940471202,14694862,17),(85692,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85692,37.62,0.14,334,35333,70,NULL,NULL,'B3 1148+442',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000189,NULL,'16.1g',0.38,'E0',NULL,NULL,NULL,NULL,1,177.789167,43.98853,0,NULL,63891049184,998297643,15598400,16.1),(85693,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85693,37.72,0.27,350,35334,70,NULL,NULL,'SDSS J115109.52+550645.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000162,NULL,'18.4g',0.1,'Poss. dwarf gal.',NULL,NULL,NULL,NULL,1,177.789666667,55.11253,0,NULL,61760989091,965015454,15078366,18.4),(85694,'BCG','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85694,38.65,0.35,492,35335,60,NULL,NULL,'ABELL 1399',0.0913,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,177.79,-3.09481,0.057,NULL,40812886180,637701346,9964083,NULL),(85695,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85695,37.59,0.46,330,35336,70,NULL,NULL,'2MASX J11511055+4428331',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000184,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,177.793917,44.47583,0,NULL,63891148036,998299188,15598424,16.7),(85696,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85696,37.9,0.21,381,35337,70,NULL,NULL,'LCRS B114837.1-024501',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00015,NULL,'16.8g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,177.7945417,-3.02811,0.045,NULL,40812849721,637700776,9964074,16.8),(85697,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85697,37.42,0.33,304,35338,70,NULL,NULL,'2MASX J11511215+4329211',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,177.800417,43.48931,0,NULL,60399699820,943745309,14746020,17.4),(85698,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85698,31.15,0.4,17,35339,75,NULL,'B','NGC 3922',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.000023,NULL,'13.4g',0.76,'S0/a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,177.8059583,50.15689,0,NULL,61748030859,964812982,15075202,13.4),(85699,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85699,37.72,0.27,350,35340,70,NULL,NULL,'2MASX J11511349+5506594',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000179,NULL,'16.1g',0.47,'Poss. dwarf gal.','Group member',NULL,NULL,NULL,1,177.806125,55.11644,0,NULL,61760992413,965015506,15078367,16.1),(85700,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85700,37.7,0.46,347,35341,70,NULL,NULL,'2MASX J11511361+5507364',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000188,NULL,'17.4g',0.22,'Poss. dwarf gal.',NULL,NULL,NULL,NULL,1,177.806875,55.12681,0,NULL,61760993218,965015519,15078367,17.4),(85701,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85701,36.9,0.46,240,35342,70,NULL,NULL,'2MASX J11511375+0647233',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000165,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,177.8072917,6.78958,0,NULL,60159727027,939995734,14687433,16.8),(85702,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85702,38.31,0.33,458,35343,70,NULL,NULL,'2MASX J11511371+1205482',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000162,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,177.8072917,12.09683,0.014,NULL,60244233146,941316142,14708064,18.3),(85703,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85703,38.21,0.46,439,35344,70,NULL,NULL,'2MASX J11511578+1927161',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,177.815667,19.45461,0.111,NULL,60212067316,940813551,14700211,17.3),(85704,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85704,38.31,0.33,458,35345,70,NULL,NULL,'2MASX J11511773+1205002',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000156,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,177.823833333,12.08353,0.014,NULL,60244233632,941316150,14708064,17.3),(85705,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85705,38.31,0.46,459,35346,70,NULL,NULL,'2MASX J11511829+2602278',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,177.8264583,26.04119,0.036,NULL,60538450639,945913291,14779895,17.8),(85706,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85706,36.93,0.21,243,35347,70,NULL,NULL,'2MASX J11511849+0502506',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000162,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,177.826875,5.04744,0,NULL,60190103180,940470362,14694849,16.7),(85707,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85707,37.2,0.46,275,35348,70,NULL,NULL,'2MASX J11511914+2737518',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000142,NULL,'17.1r',0.16,NULL,NULL,NULL,NULL,NULL,1,177.829833,27.63111,0.039,NULL,60595090839,946798294,14793723,17.1),(85708,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85708,37.64,0.46,337,35349,70,NULL,NULL,'2MASX J11511939+2529458',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,177.8307917,25.496,0.015,NULL,60545547701,946024182,14781627,17.6),(85709,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85709,37.4,0.46,302,35350,70,NULL,NULL,'2MASX J11512001+1659362',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.001124,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,177.83325,16.99328,0.135,NULL,60207531414,940742678,14699104,17.7),(85710,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85710,37.9,0.21,381,35351,70,NULL,NULL,'LCRS B114847.0-024900',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00014,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,177.835541667,-3.09464,0.057,NULL,40812841655,637700650,9964072,18.4),(85711,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85711,35.99,0.33,158,35352,70,NULL,NULL,'2MASX J11512078+2745068',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000153,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,177.8365,27.75194,0.039,NULL,60594671390,946791740,14793620,17),(85712,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85712,37.52,0.33,319,35353,70,NULL,NULL,'LCRS B114847.3-023259',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000079,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,177.8369583,-2.82761,0.037,NULL,40812807828,637700122,9964064,17.5),(85713,'BCG','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85713,38.65,0.35,492,35354,60,NULL,'ABELL 1399, BCG','LCRS B114850.5-025128',0.0913,'1980ApJ...241..486H',1980,1,0.39,NULL,'G',0.00009,NULL,'16.8g',0.28,NULL,'Brightest group member',NULL,NULL,NULL,1,177.850125,-3.13575,0.057,NULL,40812872158,637701127,9964080,16.8),(85714,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85714,35.56,0.46,130,35355,70,NULL,NULL,'2MASX J11512413+3024474',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000171,NULL,'15.8g',0.33,NULL,NULL,NULL,NULL,NULL,1,177.8504583,30.41308,0.026,NULL,60565577569,946337149,14786517,15.8),(85715,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85715,36.93,0.21,243,35356,70,NULL,NULL,'2MASX J11512498+0502186',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000158,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,177.854083,5.03856,0,NULL,60190104348,940470380,14694849,17),(85716,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85716,35.43,0.46,122,35357,70,NULL,NULL,'ARK 329',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000107,NULL,'15.1g',0.54,NULL,NULL,NULL,NULL,NULL,1,177.8552917,35.20389,0,NULL,60434182934,944284108,14754439,15.1),(85717,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85717,37.69,0.27,345,35358,70,NULL,NULL,'2MASX J11512539+6006233',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000135,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,177.8560417,60.10642,0.013,NULL,61847853000,966372703,15099573,17.7),(85718,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85718,36.8,0.46,229,35359,70,NULL,NULL,'2MASX J11512646+0712103',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000167,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,177.860417,7.20278,0,NULL,60162380611,940037197,14688081,16.6),(85719,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85719,37.3,0.46,288,35360,70,NULL,NULL,'2MASX J11512689+1218229',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000153,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,177.862125,12.30644,0.025,NULL,60244275864,941316810,14708075,17.6),(85720,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85720,37.03,0.27,255,35361,70,NULL,NULL,'2MASX J11512735+5628293',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000171,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,177.8639583,56.47472,0,NULL,61975853406,968372709,15130823,17.1),(85721,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85721,38.3,0.46,457,35362,70,NULL,NULL,'LCRS B114853.9-030310',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000133,NULL,'17.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,177.8645,-3.33072,0.057,NULL,40812798047,637699969,9964062,17.6),(85722,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85722,37.74,0.46,353,35363,70,NULL,NULL,'2MASX J11512752+2329054',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,177.8647917,23.48481,0.083,NULL,60535179030,945862172,14779096,18.3),(85723,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85723,33.14,0.46,42.5,35364,70,NULL,NULL,'UGC 06827',NULL,'2015arXiv151105856S',2015,1,1.19,NULL,'G',0.00008,NULL,'13.9g',0.62,'S0/a',NULL,NULL,NULL,NULL,1,177.866917,35.43436,0,NULL,60445486457,944460725,14757198,13.9),(85724,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85724,37.38,0.46,299,35365,70,NULL,NULL,'2MASX J11512827+1442089',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000171,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,177.867666667,14.70239,0.068,NULL,60236363289,941193176,14706143,16.6),(85725,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85725,38.02,0.46,402,35366,70,NULL,NULL,'SDSS J115128.50+182418.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,177.868791667,18.40519,0.07,NULL,60213042409,940828787,14700449,18.2),(85726,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85726,37.67,0.33,343,35367,70,NULL,NULL,'2MASX J11512876-0012518',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000088,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,177.869916667,-0.2145,0.025,NULL,40803409335,637553270,9961769,17.3),(85727,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85727,34.9,0.33,95.6,35368,70,NULL,NULL,'ARK 330',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000097,NULL,'15.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,177.871417,15.77042,0.072,NULL,60255305076,941489141,14710767,15.1),(85728,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85728,36.11,0.33,166,35369,70,NULL,NULL,'2MASX J11513008+4658491',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000172,NULL,'16.0g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,177.8755417,46.98028,0,NULL,61743411375,964740802,15074075,16),(85729,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85729,37.57,0.46,326,35370,70,NULL,NULL,'SDSS J115130.23+110425.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,177.876,11.07369,0.026,NULL,60366093381,943220209,14737815,18.3),(85730,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85730,36.93,0.21,243,35371,70,NULL,NULL,'2MASX J11513033+0448416',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000184,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,177.876375,4.81142,0,NULL,60192266531,940504164,14695377,16.3),(85731,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85731,38.49,0.46,500,35372,70,NULL,NULL,'SDSS J115130.64+111657.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,177.8777083,11.28256,0.026,NULL,60366075659,943219932,14737811,18.1),(85732,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85732,37.5,0.27,316,35373,70,NULL,NULL,'2MASX J11513074+3213014',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000159,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,177.87825,32.21711,0.086,NULL,60550785859,946106029,14782906,17.1),(85733,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85733,37.85,0.46,372,35374,70,NULL,NULL,'SDSS J115131.88+100259.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'17.9g',0.11,NULL,NULL,NULL,NULL,NULL,1,177.882833,10.04975,0,NULL,60368497124,943257767,14738402,17.9),(85734,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85734,37.15,0.46,270,35375,70,NULL,NULL,'2MASX J11513296+1213189',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000128,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,177.88725,12.22206,0.025,NULL,60244285324,941316958,14708077,18.4),(85735,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85735,37.67,0.33,343,35376,70,NULL,NULL,'SDSS J115133.05-000922.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00008,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,177.88775,-0.15625,0.037,NULL,40803377221,637552769,9961762,18.2),(85736,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85736,36.93,0.21,243,35377,70,NULL,NULL,'CGCG 040-053',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00016,NULL,'15.4g',0.56,'E;BrClG',NULL,NULL,NULL,NULL,1,177.8877917,5.10147,0,NULL,60189975391,940468365,14694818,15.4),(85737,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85737,37.62,0.14,334,35378,70,NULL,NULL,'2MASX J11513317+4357311',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,177.8882083,43.95869,0,NULL,63888166163,998252596,15597696,17.3),(85738,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85738,37.69,0.27,345,35379,70,NULL,NULL,'2MASX J11513381+6011384',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,177.890791667,60.19406,0.013,NULL,61847848985,966372640,15099572,18),(85739,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85739,34.9,0.33,95.6,35380,70,NULL,NULL,'UGC 06831',NULL,'2015arXiv151105856S',2015,1,1.01,NULL,'G',0.000188,NULL,'14.4g',0.72,'S0',NULL,NULL,NULL,NULL,1,177.8942083,15.47533,0.077,NULL,60253656874,941463388,14710365,14.4),(85740,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85740,35.26,0.07,113,35381,70,NULL,NULL,'CGCG 127-079',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000093,NULL,'15.7',0.15,'E',NULL,NULL,NULL,NULL,1,177.8952917,22.0585,0.076,NULL,61072827653,954262932,14910358,15.7),(85741,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85741,35.95,0.27,155,35382,70,NULL,NULL,'CGCG 068-078 NED01',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000167,NULL,'14.9g',0.62,NULL,NULL,NULL,NULL,NULL,1,177.896083333,8.75214,0,NULL,60148333201,939817706,14684651,14.9),(85742,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85742,38.12,0.46,421,35383,70,NULL,NULL,'2MASXi J1151357+140601',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,177.899167,14.10025,0.07,NULL,60243390391,941302974,14707858,17.9),(85743,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85743,36.53,0.46,203,35384,70,NULL,NULL,'2MASX J11514106+5537564',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000179,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,177.921166667,55.6325,0,NULL,61760815479,965012741,15078324,16.2),(85744,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85744,37.9,0.21,381,35385,70,NULL,NULL,'LCRS B114907.6-025349',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000089,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,177.921625,-3.17478,0.057,NULL,40813658879,637713419,9964272,16.7),(85745,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85745,37.86,0.33,373,35386,70,NULL,NULL,'2MASX J11514130+4636340',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,177.922,46.60958,0,NULL,61743748159,964746064,15074157,17.5),(85746,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85746,36.34,0.46,185,35387,70,NULL,NULL,'2MASX J11514155+4646060',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000165,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,177.92325,46.76833,0,NULL,61744232272,964753629,15074275,16.4),(85747,'SGRB','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85747,40.2,NULL,1100,35388,70,NULL,'Amati relation, minimum D','GRB 080218B',NULL,'2012A&A...545A..77R',2012,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,177.956875,-53.09681,NULL,NULL,40037282641,625582541,9774727,NULL),(85748,'SGRB','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85748,43.02,NULL,4030,35388,70,NULL,'Photometric Distance, Host A, M(R) = -20 mag and spectral slope Beta = 1.0 ','GRB 080218B',NULL,'2012A&A...545A..77R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85749,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85749,35.26,0.07,113,35389,70,NULL,NULL,'NGC 3929',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.00008,NULL,'14.7g',0.53,'E-S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,177.9272083,21.00272,0.169,NULL,61071686046,954245094,14910079,14.7),(85750,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85750,37.15,0.33,270,35390,70,NULL,NULL,'2MASX J11514374+5328433',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000171,NULL,'17.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,177.93225,53.47881,0,NULL,61771300143,965176564,15080883,17),(85751,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85751,38.23,0.33,442,35391,70,NULL,NULL,'2MASX J11514457+0604486',NULL,'2015arXiv151105856S',2015,1,0.51,'Two MAPS entries for the same object.','G',0.000202,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,177.935666667,6.07997,0,NULL,60157674563,939963665,14686932,16.1),(85752,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85752,36.71,0.46,220,35392,70,NULL,NULL,'2MASX J11514462+2916398',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000143,NULL,'16.5g',0.34,'cD?',NULL,NULL,NULL,NULL,1,177.9360417,29.27772,0.031,NULL,60560191707,946252995,14785203,16.5),(85753,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85753,38.25,0.46,448,35393,70,NULL,NULL,'2MASX J11514479+1248488',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,177.936583,12.81353,0.036,NULL,60246077758,941344964,14708515,18.2),(85754,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85754,35.95,0.27,155,35394,70,NULL,NULL,'2MASX J11514597+0845313',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,177.941583333,8.75867,0,NULL,60148330804,939817668,14684651,16.9),(85755,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85755,30.47,0.2,12.4,35395,74.4,NULL,NULL,'NGC 3930',NULL,'2013AJ....146...86T',2013,1,3.2,NULL,'G',0.000005,NULL,'13.1',2.4,'SAB(s)c','in a radial-velocity based grouping',NULL,NULL,NULL,1,177.9417083,38.01511,0,NULL,60437354499,944333664,14755213,13.1),(85756,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85756,30.56,0.43,13,35395,75,NULL,'3.6 micron, color corrected','NGC 3930',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85757,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85757,30.63,0.43,13.4,35395,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3930',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85758,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85758,31.11,0.11,16.7,35395,NULL,NULL,NULL,'NGC 3930',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85759,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85759,31.33,0.4,18.5,35395,75,NULL,'B','NGC 3930',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85760,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85760,36.22,0.46,175,35396,70,NULL,NULL,'2MASX J11514605+6640375',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000093,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,177.94175,66.67703,0,NULL,61811068819,965797950,15090592,16.4),(85761,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85761,38.85,0.46,588,35397,70,NULL,NULL,'SDSS J115146.23+031309.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000103,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,177.942667,3.21936,0.033,NULL,60135770621,939621415,14681584,18.5),(85762,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85762,37.59,0.33,329,35398,70,NULL,NULL,'2MASX J11514654+4109414',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,177.943917,41.16156,0,NULL,60414245013,943972578,14749571,17),(85763,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85763,38.17,0.46,430,35399,70,NULL,NULL,'SDSS J115146.93+055053.9',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,177.945583333,5.84831,0,NULL,60157777251,939965269,14686957,17.9),(85764,'SBF','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85764,30.76,0.09,14.2,35400,NULL,NULL,'I','NGC 3928',NULL,'1997ApJ...475..399T',1997,1,1.29,NULL,'G',0.000013,NULL,'13.0g',1.19,'SA(s)b?        HII','in a radial-velocity based grouping',NULL,NULL,'Starburst',1,177.948417,48.68314,0.038,NULL,61755153407,964924271,15076941,13),(85765,'SBF','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85765,31,0.6,15.8,35400,NULL,NULL,'I','NGC 3928',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85766,'SBF','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85766,31.14,0.64,16.9,35400,NULL,NULL,'I','NGC 3928',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85767,'SBF','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85767,31.14,0.14,16.9,35400,74.4,NULL,NULL,'NGC 3928',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85768,'Tully est','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85768,31.15,0.8,17,35400,75,NULL,'B','NGC 3928',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85769,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85769,37.05,0.46,257,35401,70,NULL,NULL,'2MASX J11514849+0310326',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000076,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,177.952,3.17586,0.033,NULL,60135769966,939621405,14681584,17.1),(85770,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85770,36.35,0.46,186,35402,70,NULL,NULL,'2MASX J11514853+3608264',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000096,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,177.9520417,36.14064,0,NULL,60448192926,944503014,14757859,16.8),(85771,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85771,37.26,0.46,284,35403,70,NULL,NULL,'2MASX J11514874+2554310',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,177.9529583,25.90853,0.036,NULL,60537900060,945904688,14779760,17.8),(85772,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85772,33.75,0.2,56.2,35404,74.4,NULL,NULL,'KUG 1149+238',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000039,NULL,'15.7',0.1,'S0',NULL,NULL,NULL,NULL,1,177.954667,23.528,0.083,NULL,60535014110,945859595,14779056,15.7),(85773,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85773,38.03,0.46,403,35405,70,NULL,NULL,'2MASX J11515017+2303454',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.66',0.15,NULL,NULL,NULL,NULL,NULL,1,177.9589583,23.06267,0.086,NULL,60534752505,945855507,14778992,18.66),(85774,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85774,36.81,0.46,230,35406,70,NULL,NULL,'2MASX J11515062+5631205',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,177.961125,56.52233,0,NULL,61976060925,968375951,15130874,16.8),(85775,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85775,37.86,0.33,373,35407,70,NULL,NULL,'2MASX J11515072+4647121',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,177.961333,46.78678,0,NULL,61744228039,964753563,15074274,18.3),(85776,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85776,38.35,0.46,468,35408,70,NULL,NULL,'2MASX J11515205+2121069',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00017,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,177.9667917,21.35186,0.109,NULL,61072656770,954260262,14910316,17.7),(85777,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85777,36.7,0.33,219,35409,70,NULL,NULL,'2MASX J11515240+5537055',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000172,NULL,'16.1g',0.43,'BrClG',NULL,NULL,NULL,NULL,1,177.968416667,55.61828,0,NULL,61760815673,965012744,15078324,16.1),(85778,'IRAS','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85778,34.52,0.8,80.2,35410,75,NULL,'W91CL, r','UGC 06837',NULL,'1997ApJS..109..333W',1997,1,1.18,NULL,'G',0.000033,NULL,'16.1g',0.17,'Sd',NULL,NULL,NULL,NULL,1,177.968625,18.54644,0.07,NULL,60213073459,940829272,14700457,16.1),(85779,'IRAS','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85779,34.52,0.8,80.3,35410,75,NULL,'HMCL, I','UGC 06837',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85780,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85780,34.93,0.16,97,35410,NULL,NULL,NULL,'UGC 06837',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85781,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85781,35.23,0.43,111,35410,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06837',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85782,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85782,35.37,0.43,119,35410,75,NULL,'3.6 micron, color corrected','UGC 06837',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85783,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85783,35.39,0.49,120,35410,75,NULL,'IR','UGC 06837',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85784,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85784,35.42,0.4,122,35410,75,NULL,'HMCL, I, raw','UGC 06837',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85785,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85785,35.52,0.38,127,35410,75,NULL,'W91CL, r, raw','UGC 06837',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85786,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85786,35.52,0.2,127,35410,74.4,NULL,NULL,'UGC 06837',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85787,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85787,35.56,NULL,130,35410,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06837',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85788,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85788,35.57,0.4,130,35410,75,NULL,'HMCL, I, inv','UGC 06837',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85789,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85789,35.58,NULL,131,35410,NULL,NULL,'Dipole + Quadrupole','UGC 06837',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85790,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85790,35.6,NULL,132,35410,NULL,NULL,'Dipole','UGC 06837',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85791,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85791,35.61,NULL,133,35410,NULL,NULL,NULL,'UGC 06837',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85792,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85792,35.62,0.38,133,35410,75,NULL,'W91CL, r, inv','UGC 06837',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85793,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85793,35.62,0.4,133,35410,75,NULL,'HMCL, I, cor','UGC 06837',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85794,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85794,35.74,0.38,141,35410,75,NULL,'W91CL, r, cor','UGC 06837',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85795,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85795,37.54,0.46,322,35411,70,NULL,NULL,'2MASX J11515291+1210370',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,177.970417,12.17703,0.019,NULL,60232901537,941139086,14705298,17.8),(85796,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85796,37.73,0.46,352,35412,70,NULL,NULL,'2MASX J11515352-0045533',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000066,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,177.972917,-0.76478,0.045,NULL,40803633028,637556766,9961824,17.7),(85797,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85797,37.3,0.46,289,35413,70,NULL,NULL,'2MASX J11515350+5444595',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000176,NULL,'16.3g',0.41,NULL,NULL,NULL,NULL,NULL,1,177.973,54.74978,0,NULL,61760311618,965004869,15078201,16.3),(85798,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85798,38.23,0.33,442,35414,70,NULL,NULL,'2MASX J11515392+0609461',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000171,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,177.97475,6.16278,0,NULL,60157679482,939963741,14686933,17.5),(85799,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85799,37.54,0.46,323,35415,70,NULL,NULL,'2MASXi J1151544+674926',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00011,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,177.976375,67.82406,0,NULL,62076653424,969947709,15155432,17.8),(85800,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85800,34.94,0.61,97.3,35416,70,NULL,NULL,'2MASX J11515466-4701174',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.8I',0.4,NULL,NULL,NULL,NULL,NULL,1,177.977667,-47.02156,0.413,NULL,40000253486,625003960,9765686,13.8),(85801,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85801,36.59,0.46,208,35417,70,NULL,NULL,'2MASX J11515585+6702414',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000078,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,177.9827917,67.04492,0.017,NULL,61807690478,965745163,15089768,17.2),(85802,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85802,37.03,0.27,255,35418,70,NULL,NULL,'2MASX J11515606+5631055',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,177.983875,56.51814,0,NULL,61976060614,968375947,15130874,17.7),(85803,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85803,38.44,0.46,488,35419,70,NULL,NULL,'2MASX J11515635+0832231',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,177.9849583,8.53961,0,NULL,60147777029,939809016,14684515,18.1),(85804,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85804,37.69,0.27,345,35420,70,NULL,NULL,'2MASX J11515719+6015503',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,177.9880417,60.26411,0.009,NULL,61847791371,966371740,15099558,17.3),(85805,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85805,37.72,0.27,350,35421,70,NULL,NULL,'2MASX J11515770+5508085',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00022,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,177.990417,55.13567,0,NULL,61760970802,965015168,15078362,16.6),(85806,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85806,37.15,0.33,270,35422,70,NULL,NULL,'2MASX J11515792+5328452',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000195,NULL,'16.2g',0.35,'E0',NULL,NULL,NULL,NULL,1,177.9912083,53.47933,0,NULL,61771300051,965176563,15080883,16.2),(85807,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85807,37.84,0.46,371,35423,70,NULL,NULL,'2MASX J11515959-0227393',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000084,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,177.998125,-2.46081,0.017,NULL,40815122826,637736294,9964629,17.3),(85808,'IRAS','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85808,34.81,0.8,91.6,35424,75,NULL,'HMCL, I','CGCG 127-082',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.00002,NULL,'14.7',0.7,'SAc',NULL,NULL,NULL,NULL,1,177.999291667,21.10844,0.169,NULL,61071670520,954244851,14910075,14.7),(85809,'IRAS','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85809,34.82,0.8,92.2,35424,75,NULL,'W91CL, r','CGCG 127-082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85810,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85810,33.35,0.43,46.8,35424,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 127-082',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85811,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85811,33.48,0.43,49.7,35424,75,NULL,'3.6 micron, color corrected','CGCG 127-082',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85812,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85812,33.62,0.2,53,35424,74.4,NULL,NULL,'CGCG 127-082',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85813,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85813,34.11,0.38,66.3,35424,75,NULL,'W91CL, r, raw','CGCG 127-082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85814,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85814,34.15,0.4,67.5,35424,75,NULL,'HMCL, I, raw','CGCG 127-082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85815,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85815,34.19,0.38,68.9,35424,75,NULL,'W91CL, r, inv','CGCG 127-082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85816,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85816,34.28,0.4,71.8,35424,75,NULL,'HMCL, I, inv','CGCG 127-082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85817,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85817,34.4,0.38,75.7,35424,75,NULL,'W91CL, r, cor','CGCG 127-082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85818,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85818,34.47,0.4,78.3,35424,75,NULL,'HMCL, I, cor','CGCG 127-082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85819,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85819,34.92,0.12,96.6,35424,NULL,NULL,NULL,'CGCG 127-082',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85820,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85820,36.34,0.96,185,35425,70,NULL,NULL,'2MASX J11520006-4902465',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.4,NULL,NULL,NULL,NULL,NULL,1,178.000125,-49.04625,0.389,NULL,40008462301,625132223,9767690,14.6),(85821,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85821,36.11,0.33,166,35426,70,NULL,NULL,'CGCG 243-021',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.00012,NULL,'15.1g',0.66,'E0',NULL,NULL,NULL,NULL,1,178.000417,46.88414,0,NULL,61743424937,964741014,15074078,15.1),(85822,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85822,37.79,0.33,362,35427,70,NULL,NULL,'SDSS J115200.37+001528.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000083,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,178.001583,0.25792,0.033,NULL,60132620891,939572201,14680815,17.9),(85823,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85823,37.79,0.33,362,35428,70,NULL,NULL,'2MASX J11520050+0017056',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000075,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,178.002125,0.28494,0.033,NULL,60132607810,939571997,14680812,17),(85824,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85824,37.9,0.21,381,35429,70,NULL,NULL,'LCRS B114927.3-025208',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00016,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,178.0035417,-3.14689,0.045,NULL,40813551023,637711734,9964245,17.2),(85825,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85825,35.74,0.46,141,35430,70,NULL,NULL,'2MASX J11520109+1820350',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000177,NULL,'16.1g',0.31,NULL,NULL,NULL,NULL,NULL,1,178.0045417,18.34294,0.07,NULL,60209608843,940775138,14699611,16.1),(85826,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85826,34.2,0.46,69.3,35431,70,NULL,NULL,'CGCG 040-056',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00008,NULL,'14.5g',0.5,'SB(r)0-:',NULL,NULL,NULL,NULL,1,178.007041667,6.40961,0,NULL,60157407910,939959498,14686867,14.5),(85827,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85827,31.31,NULL,18.3,35432,NULL,NULL,NULL,'CGCG 068-079',NULL,'2015AstBu..70....1K',2015,1,0.64,NULL,'G',0.000073,NULL,'16.3g',0.48,'Sm','Isolated galaxy',NULL,NULL,NULL,1,178.007917,13.87869,0.056,NULL,60243571190,941305799,14707903,16.3),(85828,'IRAS','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85828,33.64,0.8,53.4,35433,75,NULL,'A82, H','NGC 3933',NULL,'1997ApJS..109..333W',1997,1,1.13,NULL,'G',0.000033,NULL,'14.1g',0.6,'S?','in a pair',NULL,NULL,NULL,1,178.008541667,16.80969,0.113,NULL,60252986555,941452914,14710201,14.1),(85829,'IRAS','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85829,33.64,0.8,53.4,35433,75,NULL,'HMCL, I','NGC 3933',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85830,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85830,33.34,0.62,46.7,35433,NULL,NULL,NULL,'NGC 3933',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85831,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85831,33.39,0.2,47.6,35433,74.4,NULL,NULL,'NGC 3933',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85832,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85832,33.4,0.61,47.8,35433,NULL,NULL,'Malmquist cor.','NGC 3933',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85833,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85833,33.86,0.4,59,35433,75,NULL,'HMCL, I, raw','NGC 3933',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85834,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85834,33.91,0.47,60.5,35433,NULL,NULL,'H','NGC 3933',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85835,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85835,33.91,0.4,60.7,35433,NULL,NULL,'mean','NGC 3933',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85836,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85836,33.98,0.46,62.5,35433,NULL,NULL,'J','NGC 3933',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85837,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85837,34.01,0.45,63.5,35433,NULL,NULL,'K','NGC 3933',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85838,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85838,34.02,0.4,63.6,35433,75,NULL,'HMCL, I, inv','NGC 3933',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85839,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85839,34.08,0.4,65.5,35433,75,NULL,'HMCL, I, cor','NGC 3933',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85840,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85840,34.2,0.47,69.1,35433,75,NULL,'A82, H, raw','NGC 3933',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85841,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85841,34.33,0.47,73.3,35433,75,NULL,'A82, H, inv','NGC 3933',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85842,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85842,34.57,0.47,82.2,35433,75,NULL,'A82, H, cor','NGC 3933',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85843,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85843,37.95,0.46,389,35434,70,NULL,NULL,'2MASX J11520325+5721505',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000191,NULL,'16.7g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,178.013333,57.36408,0,NULL,61841569240,966274519,15098039,16.7),(85844,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85844,36.96,0.46,246,35435,70,NULL,NULL,'2MASX J11520351+0340136',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000076,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,178.01475,3.67058,0.02,NULL,60190760258,940480629,14695009,17),(85845,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85845,37.16,0.46,271,35436,70,NULL,NULL,'2MASX J11520398+6050382',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,178.016541667,60.84389,0.073,NULL,61848966005,966390093,15099845,16.9),(85846,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85846,36.72,0.46,220,35437,70,NULL,NULL,'2MASX J11520496+4451511',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,178.020791667,44.86436,0,NULL,63888305791,998254777,15597730,17.3),(85847,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85847,37.21,0.1,276,35438,70,NULL,NULL,'2MASX J11520516+5459575',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000191,NULL,'16.6g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,178.0217917,54.99925,0.005,NULL,61761063185,965016612,15078384,16.6),(85848,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85848,37.14,0.46,268,35439,70,NULL,NULL,'2MASX J11520537+0004266',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000098,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,178.0222917,0.07408,0.025,NULL,60132048541,939563258,14680675,16.5),(85849,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85849,37.21,0.1,276,35440,70,NULL,NULL,'2MASX J11520574+5458175',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000185,NULL,'18.1g',0.12,'AGN',NULL,NULL,NULL,NULL,1,178.0240417,54.97139,0,NULL,61761061747,965016589,15078384,18.1),(85850,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85850,37.23,0.46,280,35441,70,NULL,NULL,'2MASX J11520626+0641152',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,178.026,6.68769,0,NULL,60159336650,939989635,14687338,17.3),(85851,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85851,31.15,0.4,17,35442,75,NULL,'B','UGC 06840',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000017,NULL,'14.3',0.6,'SB(rs)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,178.029208333,52.108,0.006,NULL,61768927226,965139487,15080304,14.3),(85852,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85852,37.61,0.46,333,35443,70,NULL,NULL,'2MASX J11520826+1917279',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.19',0.16,NULL,NULL,NULL,NULL,NULL,1,178.0342917,19.29114,0.119,NULL,60212494047,940820219,14700315,18.19),(85853,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85853,36.34,0.46,185,35444,70,NULL,NULL,'2MASX J11520875+4815083',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000156,NULL,'16.8g',0.33,NULL,NULL,NULL,NULL,NULL,1,178.0364583,48.25236,0.029,NULL,61755191274,964924863,15076950,16.8),(85854,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85854,39.06,0.46,648,35445,70,NULL,NULL,'SDSS J115208.96+005430.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000089,NULL,'18.2g',0.16,'Cand.grav.lens',NULL,NULL,NULL,NULL,1,178.037375,0.90858,0.049,NULL,60143628273,939744191,14683502,18.2),(85855,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85855,38.01,0.46,400,35446,70,NULL,NULL,'2MASX J11521138+0827241',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,178.047458333,8.45667,0,NULL,60147785838,939809153,14684518,17.2),(85856,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85856,37.55,0.33,323,35447,70,NULL,NULL,'LCRS B114938.8-023136',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000153,NULL,'16.1g',0.39,'E0',NULL,NULL,NULL,NULL,1,178.0517917,-2.80456,0.045,NULL,40815222992,637737859,9964654,16.1),(85857,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85857,37.84,0.46,369,35448,70,NULL,NULL,'2MASX J11521288+3104092',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,178.053875,31.06942,0.026,NULL,60564185556,946315399,14786178,17.2),(85858,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85858,38.5,0.46,501,35449,70,NULL,NULL,'SDSS J115213.42+210202.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,178.055917,21.03392,0.169,NULL,61071663211,954244737,14910074,18.3),(85859,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85859,36.7,0.33,219,35450,70,NULL,NULL,'2MASX J11521430+5554475',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000183,NULL,'16.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,178.0597083,55.91311,0,NULL,61757422797,964959731,15077495,16.2),(85860,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,NULL,85860,36.55,0.63,204,35451,70,NULL,NULL,'2MASX J11521510-1126561',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.02',NULL,NULL,NULL,NULL,NULL,NULL,1,178.062958333,-11.44894,0.073,NULL,40954887300,639920114,9998751,17.02),(85861,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85861,38.01,0.46,400,35452,70,NULL,NULL,'2MASX J11521542+2159139',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,178.0644583,21.98731,0.082,NULL,61073017308,954265895,14910404,18.2),(85862,'FP','2016-12-15 15:14:52','2016-12-16 11:20:00','1',NULL,'R',85862,37.49,0.46,315,35453,70,NULL,NULL,'2MASX J11521578+1412409',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,178.065917,14.21125,0.056,NULL,60235870410,941185475,14706023,17.3),(85863,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85863,37.39,0.46,301,35454,70,NULL,NULL,'2MASX J11521613+5753415',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00014,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,178.067333,57.89486,0,NULL,61844998369,966328099,15098876,17.9),(85864,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85864,37.59,0.33,329,35455,70,NULL,NULL,'2MASX J11521642+4103425',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000187,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,178.068583,41.06181,0,NULL,60409514079,943898657,14748416,16.6),(85865,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85865,37.9,0.46,380,35456,70,NULL,NULL,'2MASX J11521680+2809340',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000134,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,178.07,28.15953,0.04,NULL,60594612664,946790822,14793606,18),(85866,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85866,34.78,0.47,90.3,35457,70,NULL,NULL,'2MASX J11521965-7229436',NULL,'2014MNRAS.445.2677S',2014,1,0.17,NULL,'G',0.00009,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,178.0817083,-72.49542,0.845,NULL,39804795566,621949930,9717967,16),(85867,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85867,37.27,0.23,284,35458,70,NULL,NULL,'2MASX J11522001+0805040',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000175,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,178.083417,8.08461,0,NULL,60161678089,940026220,14687909,17.5),(85868,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85868,37.67,0.46,343,35459,70,NULL,NULL,'2MASX J11522008+1254479',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000165,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,178.083583,12.91317,0.035,NULL,60246108317,941345442,14708522,17),(85869,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85869,37.52,0.46,319,35460,70,NULL,NULL,'2MASX J11522029+2349249',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000176,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,178.0845,23.82375,0.035,NULL,60534839586,945856868,14779013,17),(85870,'IRAS','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85870,32.06,0.8,25.9,35461,75,NULL,'MAT, I','NGC 3936',NULL,'1997ApJS..109..333W',1997,1,3.9,NULL,'G',0.00001,NULL,'12.76',0.6,'SB(s)bc: sp    HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,178.0857917,-26.90589,0.377,NULL,41462322338,647848786,10122637,12.76),(85871,'IRAS','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85871,32.07,0.8,25.9,35461,75,NULL,'A82, H','NGC 3936',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85872,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85872,31.3,0.32,18.2,35461,85,NULL,'I, raw','NGC 3936',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85873,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85873,31.32,0.32,18.4,35461,85,NULL,'I, inv','NGC 3936',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85874,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85874,31.34,0.43,18.5,35461,75,NULL,'MAT, I, raw','NGC 3936',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85875,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85875,31.35,0.38,18.6,35461,NULL,NULL,NULL,'NGC 3936',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85876,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85876,31.36,0.39,18.7,35461,73,NULL,'IR','NGC 3936',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85877,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85877,31.36,0.4,18.7,35461,75,NULL,NULL,'NGC 3936',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85878,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85878,31.42,0.2,19.2,35461,74.4,NULL,NULL,'NGC 3936',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85879,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85879,31.43,0.43,19.3,35461,75,NULL,'3.6 micron, color corrected','NGC 3936',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85880,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85880,31.44,0.4,19.4,35461,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 3936',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85881,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85881,31.46,0.43,19.6,35461,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3936',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85882,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85882,31.48,0.43,19.8,35461,75,NULL,'MAT, I, inv','NGC 3936',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85883,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85883,31.55,0.46,20.4,35461,NULL,NULL,'J','NGC 3936',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85884,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85884,31.6,0.43,20.9,35461,75,NULL,'MAT, I, cor','NGC 3936',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85885,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85885,31.6,0.47,20.9,35461,NULL,NULL,'H','NGC 3936',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85886,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85886,31.62,0.45,21,35461,NULL,NULL,NULL,'NGC 3936',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85887,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85887,31.64,0.45,21.3,35461,NULL,NULL,'Malmquist cor.','NGC 3936',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85888,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85888,31.69,0.49,21.8,35461,75,NULL,'IR','NGC 3936',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85889,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85889,31.71,0.45,21.9,35461,NULL,NULL,'K','NGC 3936',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85890,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85890,31.77,0.47,22.6,35461,75,NULL,'A82, H, raw','NGC 3936',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85891,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85891,31.83,0.47,23.2,35461,75,NULL,'A82, H, inv','NGC 3936',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85892,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85892,32.04,0.47,25.6,35461,75,NULL,'A82, H, cor','NGC 3936',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85893,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85893,32.31,0.4,29,35461,75,NULL,'B','NGC 3936',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85894,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85894,32.38,0.4,30,35461,NULL,NULL,'mean','NGC 3936',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85895,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85895,37.27,0.23,284,35462,70,NULL,NULL,'2MASX J11522069+0802560',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000181,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,178.086125,8.04906,0,NULL,60161687028,940026359,14687911,16.2),(85896,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85896,37.94,0.46,388,35463,70,NULL,NULL,'2MASX J11522121+2549250',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000191,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,178.08825,25.82364,0,NULL,60537961284,945905645,14779775,16.9),(85897,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85897,36.61,0.46,210,35464,70,NULL,NULL,'2MASX J11522136+5410485',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000183,NULL,'15.9g',0.43,'E0',NULL,NULL,NULL,NULL,1,178.088875,54.18028,0,NULL,61770974556,965171477,15080804,15.9),(85898,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85898,38.59,0.46,521,35465,70,NULL,NULL,'SDSS J115221.96+060833.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000148,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,178.0915,6.14275,0,NULL,60157844101,939966314,14686973,18.5),(85899,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85899,37.71,0.46,348,35466,70,NULL,NULL,'SDSS J115222.16+560116.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000142,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,178.092375,56.02125,0,NULL,61757343861,964958497,15077476,18.5),(85900,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85900,37.3,0.46,288,35467,70,NULL,NULL,'2MASX J11522325+3330173',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,178.09675,33.50481,0,NULL,60619941494,947186585,14799790,17.6),(85901,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85901,37.55,0.33,323,35468,70,NULL,NULL,'LCRS B114949.9-022936',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000127,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,178.09775,-2.77111,0.045,NULL,40815192614,637737384,9964646,16.8),(85902,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85902,32.63,0.47,33.6,35469,NULL,NULL,'H','NGC 3935',NULL,'2007A&A...465...71T',2007,1,1.33,NULL,'G',0.000057,NULL,'13.6g',0.64,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,178.1002917,32.40381,0.086,NULL,60550600124,946103126,14782861,13.6),(85903,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85903,32.77,0.45,35.8,35469,NULL,NULL,'K','NGC 3935',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85904,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85904,32.8,0.46,36.4,35469,NULL,NULL,'J','NGC 3935',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85905,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85905,33.41,0.4,48.1,35469,NULL,NULL,'mean','NGC 3935',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85906,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85906,37.63,0.23,336,35470,70,NULL,NULL,'2MASX J11522609+0550529',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000178,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,178.108667,5.84792,0,NULL,60157239239,939956863,14686825,17),(85907,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85907,37.79,0.46,362,35471,70,NULL,NULL,'SDSS J115226.56+222100.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.66',0.11,NULL,NULL,NULL,NULL,NULL,1,178.1107083,22.35019,0.067,NULL,61072977730,954265277,14910394,18.66),(85908,'Tully est','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85908,32.7,0.8,34.7,35472,75,NULL,NULL,'MRK 0641',NULL,'1988NBGC.C....0000T',1988,1,0.43,NULL,'G',0.000233,NULL,'16.2g',0.25,'Compact',NULL,NULL,NULL,NULL,1,178.1140417,34.89436,0,NULL,60434289593,944285774,14754465,16.2),(85909,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85909,37.07,0.46,259,35473,70,NULL,NULL,'2MASX J11522803+2253317',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,178.116917,22.89219,0.086,NULL,60534599382,945853115,14778954,16.8),(85910,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85910,37.19,0.46,274,35474,70,NULL,NULL,'2MASX J11522816+1344049',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000171,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,178.117417,13.73483,0.047,NULL,60246294802,941348356,14708568,16.5),(85911,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85911,37.52,0.21,319,35475,70,NULL,NULL,'2MASX J11522936+0417489',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,178.1222917,4.29686,0,NULL,60191860568,940497821,14695278,17.3),(85912,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85912,36.81,0.46,230,35476,70,NULL,NULL,'2MASX J11523048+1413399',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000165,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,178.126875,14.22775,0.056,NULL,60235864931,941185389,14706021,16.5),(85913,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85913,38.05,0.46,407,35477,70,NULL,NULL,'SDSS J115230.82+071254.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000139,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,178.128417,7.215,0,NULL,60162766886,940043232,14688175,18),(85914,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85914,37.76,0.46,357,35478,70,NULL,NULL,'2MASX J11523091+3527223',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,178.128875,35.45614,0,NULL,60446736595,944480259,14757504,17.6),(85915,'Tully est','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85915,32.2,0.8,27.5,35479,75,NULL,NULL,'IC 2969',NULL,'1988NBGC.C....0000T',1988,1,1.2,'Confused HIPASS source','G',0.000013,NULL,'13.74',0.8,'SB(r)bc?       HII',NULL,NULL,NULL,NULL,1,178.1302917,-3.87225,0.037,NULL,40858523720,638414433,9975225,13.74),(85916,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85916,37.77,0.46,358,35480,70,NULL,NULL,'2MASX J11523166+1330559',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000139,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,178.1320417,13.51558,0.047,NULL,60246284865,941348201,14708565,18),(85917,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85917,37.52,0.21,319,35481,70,NULL,NULL,'2MASX J11523190+0422409',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000178,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,178.133,4.37794,0,NULL,60191865681,940497901,14695279,17.1),(85918,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85918,37.01,0.46,252,35482,70,NULL,NULL,'2MASX J11523194+3447433',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000112,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,178.133125,34.79536,0,NULL,60434286334,944285723,14754464,17.5),(85919,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85919,37.27,0.23,284,35483,70,NULL,NULL,'2MASX J11523307+0806040',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000181,NULL,'16.0g',0.42,NULL,NULL,NULL,NULL,NULL,1,178.137875,8.10122,0,NULL,60161672348,940026130,14687908,16),(85920,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85920,38.04,0.46,405,35484,70,NULL,NULL,'SDSS J115233.51+293651.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000142,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,178.139666667,29.61436,0.011,NULL,60560042001,946250656,14785166,18.5),(85921,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85921,35.91,0.68,152,35485,70,NULL,NULL,'MCG -01-30-042',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.13',0.5,'HII',NULL,NULL,NULL,NULL,1,178.146583,-8.76808,0.133,NULL,40838729546,638105149,9970392,15.13),(85922,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85922,35.77,0.46,143,35486,70,NULL,NULL,'2MASX J11523546+2118417',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00006,NULL,'16.0g',0.36,NULL,NULL,NULL,NULL,NULL,1,178.147666667,21.31156,0.11,NULL,61072693289,954260832,14910325,16),(85923,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85923,37.88,0.46,377,35487,70,NULL,NULL,'2MASX J11523559+2454111',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000181,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,178.1485417,24.90314,0,NULL,60548371226,946068300,14782317,16.7),(85924,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85924,35.07,0.49,103,35488,75,NULL,'IR','UGC 06845',NULL,'2011yCatp016004901K',2011,1,1.55,NULL,'G',0.000111,NULL,'15.2g',0.28,'Sb?',NULL,NULL,NULL,NULL,1,178.150708333,13.46803,0.047,NULL,60246281733,941348152,14708564,15.2),(85925,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85925,35.1,0.2,105,35488,74.4,NULL,NULL,'UGC 06845',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85926,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85926,38.02,0.46,402,35489,70,NULL,NULL,'2MASX J11523732+5439330',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000204,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,178.155541667,54.65925,0,NULL,61760190837,965002981,15078171,16.5),(85927,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85927,37.47,0.46,312,35490,70,NULL,NULL,'2MASX J11523744+0927050',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,178.156166667,9.45139,0,NULL,60147992313,939812379,14684568,17.4),(85928,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85928,37.73,0.33,351,35491,70,NULL,NULL,'2MASX J11523755+0328219',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.000189,NULL,'15.8g',0.47,'E0',NULL,NULL,NULL,NULL,1,178.1565417,3.47269,0.043,NULL,60135672365,939619880,14681560,15.8),(85929,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85929,34.03,0.2,64,35492,74.4,NULL,NULL,'UGC 06847',NULL,'2013AJ....146...86T',2013,1,1.28,NULL,'G',0.000007,NULL,'15.2g',0.39,'Sbc','Isolated galaxy',NULL,NULL,NULL,1,178.158333,24.30764,0.016,NULL,60547976882,946062138,14782220,15.2),(85930,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85930,37.27,0.23,284,35493,70,NULL,NULL,'2MASX J11523813+0809470',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000167,NULL,'16.1g',0.39,NULL,NULL,NULL,NULL,NULL,1,178.158875,8.16308,0,NULL,60161753003,940027390,14687927,16.1),(85931,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85931,37.52,0.21,319,35494,70,NULL,NULL,'2MASX J11523826+0422029',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,178.1595417,4.36744,0,NULL,60191853784,940497715,14695276,17.6),(85932,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85932,36.82,0.46,231,35495,70,NULL,NULL,'2MASX J11523859+1414289',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,178.1609583,14.24122,0.056,NULL,60235933521,941186461,14706038,17.3),(85933,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85933,37.62,0.14,334,35496,70,NULL,NULL,'2MASX J11523885+4403552',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,178.161917,44.06536,0,NULL,63888188339,998252942,15597702,17.9),(85934,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85934,37.37,0.46,298,35497,70,NULL,NULL,'2MASX J11523917+0528479',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000158,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,178.163291667,5.48003,0,NULL,60190075762,940469933,14694842,16.8),(85935,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85935,37.57,0.46,327,35498,70,NULL,NULL,'2MASX J11523946+1613529',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000206,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,178.164417,16.23142,0.083,NULL,60255129070,941486391,14710724,16.5),(85936,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85936,37.58,0.46,328,35499,70,NULL,NULL,'2MASX J11523948+5447370',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,178.1644583,54.7935,0,NULL,61760194577,965003040,15078172,17.3),(85937,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85937,37.55,0.46,324,35500,70,NULL,NULL,'2MASX J11524147+2130347',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,178.172833333,21.50967,0.1,NULL,61072725802,954261340,14910333,16.5),(85938,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85938,37.62,0.46,334,35501,70,NULL,NULL,'SDSS J115242.28+075048.3',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,178.1762083,7.84678,0,NULL,60162137114,940033392,14688021,17.4),(85939,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85939,35.26,0.07,113,35502,70,NULL,NULL,'NGC 3937',NULL,'2015arXiv151105856S',2015,1,1.8,NULL,'G',0.00009,NULL,'13.43',1.6,'S0-:','in a radial-velocity based grouping',NULL,NULL,NULL,1,178.177583,20.63131,0.157,NULL,60198425685,940600401,14696881,13.43),(85940,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85940,35.07,0.4,103,35502,NULL,NULL,'mean','NGC 3937',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85941,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85941,35.32,0.45,116,35502,NULL,NULL,'K','NGC 3937',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85942,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85942,37.63,0.23,336,35503,70,NULL,NULL,'2MASX J11524331+0549079',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000173,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,178.180583,5.81886,0,NULL,60157242633,939956916,14686826,16.4),(85943,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85943,37.38,0.46,299,35504,70,NULL,NULL,'SDSS J115243.49+454522.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,178.18125,45.75633,0,NULL,63887947352,998249177,15597643,18.1),(85944,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85944,36.07,0.46,164,35505,70,NULL,NULL,'2MASX J11524516+0314119',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000066,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,178.18825,3.23656,0.045,NULL,60135800254,939621878,14681591,16.9),(85945,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85945,37.19,0.33,274,35506,70,NULL,NULL,'2MASX J11524606+0111409',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000076,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,178.1919583,1.19481,0.049,NULL,60143685098,939745079,14683516,16.6),(85946,'D-Sigma','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85946,34.62,0.4,83.8,35507,75,NULL,'Edat, raw','NGC 3940',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000031,NULL,'13.8',1.6,'E              PAS','in a radial-velocity based grouping',NULL,NULL,NULL,1,178.1935417,20.98928,0.169,NULL,61071464104,954241626,14910025,13.8),(85947,'D-Sigma','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85947,34.8,0.4,91.3,35507,75,NULL,'Edat, cor','NGC 3940',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85948,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85948,34.82,0.45,92.2,35507,NULL,NULL,'K','NGC 3940',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85949,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85949,35.03,0.4,101,35507,NULL,NULL,'mean','NGC 3940',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85950,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85950,35.35,0.46,118,35508,70,NULL,NULL,'UGC 06853',NULL,'2015arXiv151105856S',2015,1,1.15,NULL,'G',0.000113,NULL,'14.4g',0.63,'S0',NULL,NULL,NULL,NULL,1,178.1972917,29.32903,0.032,NULL,60560145512,946252273,14785191,14.4),(85951,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85951,37.01,0.67,253,35509,70,NULL,NULL,'2MASX J11524794-2956094',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.8I',0.2,NULL,NULL,NULL,NULL,NULL,1,178.1997917,-29.93594,0.217,NULL,41455771264,647746426,10121037,14.8),(85952,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85952,38.42,0.46,483,35510,70,NULL,NULL,'2MASX J11524801+0518559',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000194,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,178.200167,5.31558,0.021,NULL,60190052331,940469567,14694836,17.5),(85953,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85953,37.73,0.46,352,35511,70,NULL,NULL,'SDSS J115249.00-001551.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000073,NULL,'18.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,178.204167,-0.26422,0.021,NULL,40803845412,637560084,9961876,18.5),(85954,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85954,37.77,0.46,358,35512,70,NULL,NULL,'2MASX J11524942+1225468',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,178.206,12.42981,0,NULL,60244135755,941314621,14708040,17.1),(85955,'SNII optical','2016-12-15 15:14:52','2016-12-16 11:20:01','1','SN 2005ay',NULL,85955,31.27,0.13,17.9,35513,NULL,NULL,'SEAM','NGC 3938',0.002699,'2009ApJ...694.1067P',2009,1,5.4,NULL,'G',0.000013,NULL,'10.8B',4.9,'SA(s)c         HII','Possible field galaxy',NULL,NULL,NULL,1,178.2060417,44.12072,0,NULL,63888188902,998252951,15597702,10.8),(85956,'SNII optical','2016-12-15 15:14:52','2016-12-16 11:20:01','1','SN 2005ay',NULL,85956,31.7,0.23,21.9,35513,NULL,NULL,'I, photospheric magnitude method','NGC 3938',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85957,'SNII optical','2016-12-15 15:14:52','2016-12-16 11:20:01','1','SN 2005ay',NULL,85957,31.75,0.24,22.4,35513,NULL,NULL,'V, photospheric magnitude method','NGC 3938',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85958,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85958,31.15,0.4,17,35513,75,NULL,'B','NGC 3938',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85959,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85959,38.41,0.46,481,35514,70,NULL,NULL,'2MASX J11524987+4920338',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,178.207917,49.34278,0.014,NULL,61748364262,964818191,15075284,17.7),(85960,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85960,36.71,0.46,220,35515,70,NULL,NULL,'2MASX J11525060+1951027',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000097,NULL,'17.10',0.18,NULL,NULL,NULL,NULL,NULL,1,178.210833,19.85083,0.146,NULL,60198008423,940593881,14696779,17.1),(85961,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85961,37.73,0.33,351,35516,70,NULL,NULL,'2MASX J11525077+0317099',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000087,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,178.211791667,3.28597,0.045,NULL,60135792605,939621759,14681589,17.3),(85962,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85962,36.9,0.33,239,35517,70,NULL,NULL,'VII Zw 425 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000186,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,178.21625,63.77308,0.029,NULL,61819664363,965932255,15092691,16.4),(85963,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85963,39.15,0.46,675,35518,70,NULL,NULL,'SDSS J115252.94+112450.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,178.220583333,11.41406,0.008,NULL,60232793246,941137394,14705271,18.3),(85964,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85964,36.92,0.46,242,35519,70,NULL,NULL,'2MASX J11525310+1411336',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000196,NULL,'15.5g',0.53,'E',NULL,NULL,NULL,NULL,1,178.221166667,14.19269,0.056,NULL,60235746178,941183534,14705992,15.5),(85965,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85965,36.61,0.46,210,35520,70,NULL,NULL,'2MASX J11525342+4136249',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000178,NULL,'15.7g',0.4,'S0/a',NULL,NULL,NULL,NULL,1,178.2227083,41.60689,0,NULL,60412306114,943942283,14749098,15.7),(85966,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85966,36.3,0.46,182,35521,70,NULL,NULL,'2MASX J11525383+2150075',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.77',0.23,NULL,NULL,NULL,NULL,NULL,1,178.224417,21.83544,0.082,NULL,61073008914,954265764,14910402,17.77),(85967,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85967,37.21,0.1,276,35522,70,NULL,NULL,'2MASX J11525409+5503590',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000178,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,178.225125,55.0665,0.005,NULL,61761120869,965017513,15078398,17.4),(85968,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85968,37.52,0.21,319,35523,70,NULL,NULL,'SDSS J115254.13+041840.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,178.225583,4.31128,0,NULL,60191832090,940497376,14695271,18.1),(85969,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85969,37.54,0.27,321,35524,70,NULL,NULL,'2MASX J11525466+5213478',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,178.227625,52.22992,0.006,NULL,61769478417,965148100,15080439,17.6),(85970,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85970,37.97,0.33,393,35525,70,NULL,NULL,'SDSS J115254.68+121419.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000137,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,178.227875,12.23886,0.019,NULL,60233079145,941141861,14705341,18.4),(85971,'SBF','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85971,30.43,0.18,12.2,35526,NULL,NULL,'I','NGC 3941',NULL,'2001ApJ...546..681T',2001,1,3.5,NULL,'G',0.000017,NULL,'11.25',2.3,'SB(s)0^0^      Sy2','Possible field galaxy',NULL,NULL,'Sy 2',1,178.230667,36.98633,0,NULL,60438877508,944357461,14755585,11.25),(85972,'SBF','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85972,30.47,0.14,12.4,35526,74.4,NULL,NULL,'NGC 3941',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85973,'Faber-Jackson','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85973,29.65,0.65,8.51,35526,95,NULL,'Weighted Mean','NGC 3941',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85974,'Faber-Jackson','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85974,30.39,NULL,12,35526,NULL,NULL,'LEDA [April 2006]','NGC 3941',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85975,'Faber-Jackson','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85975,31.05,0.81,16.2,35526,55,NULL,'Visvanathan & Sandage 1979','NGC 3941',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85976,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85976,30.23,0.45,11.1,35526,NULL,NULL,'K','NGC 3941',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85977,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85977,30.81,0.4,14.5,35526,NULL,NULL,'mean','NGC 3941',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85978,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85978,31.38,0.4,18.9,35526,75,NULL,'B','NGC 3941',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85979,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85979,37.52,0.21,319,35527,70,NULL,NULL,'2MASX J11525651+0421379',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.97',0.16,NULL,NULL,NULL,NULL,NULL,1,178.2355417,4.36047,0,NULL,60191891718,940498308,14695286,17.97),(85980,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85980,36.47,0.46,197,35528,70,NULL,NULL,'2MASX J11525654+1414236',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,178.235625,14.23994,0.056,NULL,60235938219,941186534,14706039,16.8),(85981,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85981,38.47,0.46,495,35529,70,NULL,NULL,'2MASX J11525673+1559176',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,178.236375,15.98828,0.063,NULL,60255148256,941486691,14710729,17.8),(85982,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85982,37.19,0.33,274,35530,70,NULL,NULL,'2MASX J11525800+0117159',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000081,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,178.241667,1.28781,0.049,NULL,60143458707,939741542,14683461,16.8),(85983,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85983,38.06,0.46,410,35531,70,NULL,NULL,'2MASX J11525804+2902134',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00014,NULL,'18.50',0.15,NULL,NULL,NULL,NULL,NULL,1,178.241833,29.03719,0.043,NULL,60559786360,946246661,14785104,18.5),(85984,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85984,38.05,0.46,407,35532,70,NULL,NULL,'2MASX J11525814+3519498',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,178.242417,35.33064,0,NULL,60434737193,944292768,14754574,18),(85985,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85985,33.53,0.2,50.8,35533,74.4,NULL,NULL,'UGC 06858',NULL,'2013AJ....146...86T',2013,1,1.22,NULL,'G',0.000127,NULL,'14.8g',0.73,'Scd:',NULL,NULL,NULL,NULL,1,178.243041667,61.21608,0.045,NULL,61845400132,966334377,15098974,14.8),(85986,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85986,33.66,0.55,53.9,35533,NULL,NULL,NULL,'UGC 06858',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85987,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85987,33.66,0.55,53.9,35533,NULL,NULL,'Malmquist cor.','UGC 06858',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85988,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85988,37.53,0.46,320,35534,70,NULL,NULL,'2MASX J11525854+0831546',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,178.243833333,8.53181,0,NULL,60147845842,939810091,14684532,17),(85989,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85989,37.48,0.46,314,35535,70,NULL,NULL,'2MASX J11525915+5325188',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000163,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,178.246375,53.42183,0,NULL,61771180780,965174699,15080854,16.9),(85990,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85990,36.16,0.46,170,35536,70,NULL,NULL,'2MASX J11530192+2041105',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00007,NULL,'16.07',0.28,NULL,NULL,NULL,NULL,NULL,1,178.258,20.68628,0.157,NULL,60198479406,940601240,14696894,16.07),(85991,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85991,38.09,0.46,415,35537,70,NULL,NULL,'2MASX J11530298+5453079',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000177,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,178.2622917,54.88547,0.005,NULL,61761035281,965016176,15078377,17.6),(85992,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85992,37.63,0.23,336,35538,70,NULL,NULL,'2MASX J11530301+0546239',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000145,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,178.262833,5.77336,0,NULL,60157291564,939957680,14686838,17.1),(85993,'IRAS','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85993,32.91,0.8,38.3,35539,75,NULL,'MAT, I','ESO 379- G 006',NULL,'1997ApJS..109..333W',1997,1,3.02,NULL,'G',0.000033,NULL,'14.13',0.4,'Sc             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,178.2637083,-36.63881,0.345,NULL,41370037753,646406839,10100106,14.13),(85994,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85994,32.27,0.4,28.5,35539,75,NULL,NULL,'ESO 379- G 006',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85995,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',85995,32.53,0.49,32,35539,75,NULL,'IR','ESO 379- G 006',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85996,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85996,32.82,0.43,36.6,35539,75,NULL,'MAT, I, raw','ESO 379- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85997,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85997,32.87,0.2,37.5,35539,74.4,NULL,NULL,'ESO 379- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85998,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85998,32.88,0.43,37.6,35539,75,NULL,'3.6 micron, color + selection bias corrected','ESO 379- G 006',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85999,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,85999,32.88,0.32,37.7,35539,85,NULL,'I, raw','ESO 379- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86000,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86000,32.91,0.43,38.1,35539,75,NULL,'3.6 micron, color corrected','ESO 379- G 006',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86001,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86001,32.92,0.32,38.4,35539,85,NULL,'I, inv','ESO 379- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86002,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86002,32.93,0.41,38.5,35539,NULL,NULL,'Malmquist cor.','ESO 379- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86003,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86003,32.94,0.4,38.7,35539,NULL,NULL,NULL,'ESO 379- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86004,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86004,33,0.43,39.8,35539,75,NULL,'MAT, I, cor','ESO 379- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86005,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86005,33.01,0.43,40,35539,75,NULL,'MAT, I, inv','ESO 379- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86006,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86006,33.31,NULL,45.9,35539,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 379- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86007,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86007,33.33,NULL,46.3,35539,NULL,NULL,'Dipole + Quadrupole','ESO 379- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86008,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86008,33.34,NULL,46.6,35539,NULL,NULL,'Dipole','ESO 379- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86009,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86009,33.45,NULL,49,35539,NULL,NULL,NULL,'ESO 379- G 006',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86010,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86010,33.53,0.46,50.9,35540,70,NULL,NULL,'NGC 3944',NULL,'2015arXiv151105856S',2015,1,1.4,NULL,'G',0.000087,NULL,'13.90',1.1,'S0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,178.271167,26.20694,0.026,NULL,60537769523,945902648,14779728,13.9),(86011,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86011,33.82,0.45,58.1,35540,NULL,NULL,'K','NGC 3944',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86012,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86012,33.94,0.4,61.3,35540,NULL,NULL,'mean','NGC 3944',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86013,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86013,37.63,0.23,336,35541,70,NULL,NULL,'2MASX J11530570+0555015',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000184,NULL,'16.2g',0.42,NULL,NULL,NULL,NULL,NULL,1,178.273833,5.91694,0,NULL,60157279706,939957495,14686835,16.2),(86014,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86014,36.64,0.46,213,35542,70,NULL,NULL,'2MASX J11530574+1749496',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.0001,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,178.274083,17.83036,0.111,NULL,60207915591,940748681,14699198,16.9),(86015,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86015,38.53,0.46,508,35543,70,NULL,NULL,'2MASX J11530629+0937306',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,178.276291667,9.62497,0,NULL,60366830983,943231734,14737995,17.9),(86016,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86016,38.17,0.46,431,35544,70,NULL,NULL,'SDSS J115306.98+140248.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000139,NULL,'18.6g',0.09,NULL,NULL,NULL,NULL,NULL,1,178.279125,14.04686,0.016,NULL,60243371459,941302679,14707854,18.6),(86017,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86017,37.15,0.46,269,35545,70,NULL,NULL,'2MASX J11530753+5427069',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,178.281375,54.45183,0,NULL,61759811077,964997048,15078078,17.5),(86018,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86018,38.25,0.46,447,35546,70,NULL,NULL,'2MASX J11530756+2656595',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,178.2815,26.95,0.029,NULL,60593274968,946769921,14793280,17.4),(86019,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86019,37.87,0.27,374,35547,70,NULL,NULL,'2MASX J11530762+2213595',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,178.281625,22.23333,0.064,NULL,61072890051,954263907,14910373,17.9),(86020,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86020,37.97,0.33,393,35548,70,NULL,NULL,'SDSS J115307.90+121615.8',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000161,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,178.282917,12.27108,0.019,NULL,60233087578,941141993,14705343,18.8),(86021,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86021,35.41,0.49,121,35549,70,NULL,NULL,'ESO 440- G 025',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000093,NULL,'14.06',0.9,'S0?',NULL,NULL,NULL,NULL,1,178.284333333,-32.566,0.365,NULL,41443133382,647548959,10117952,14.06),(86022,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86022,37.75,0.46,355,35550,70,NULL,NULL,'2MASX J11530895+0225335',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000075,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,178.287333,2.42608,0.025,NULL,60145764923,939777576,14684024,17.1),(86023,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86023,37.75,0.46,355,35551,70,NULL,NULL,'2MASX J11530993-0023567',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00008,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,178.291375,-0.399,0.021,NULL,40803927610,637561368,9961896,17.1),(86024,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86024,37.9,0.46,380,35552,70,NULL,NULL,'SDSS J115310.01+121954.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000161,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,178.2917083,12.33181,0,NULL,60233068432,941141694,14705338,18.4),(86025,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86025,35.45,0.62,123,35553,70,NULL,NULL,'2MASX J11531003-7235530',NULL,'2014MNRAS.445.2677S',2014,1,0.11,NULL,'G',0.00015,NULL,'17.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,178.292125,-72.59814,0.845,NULL,39804981192,621952831,9718012,17.6),(86026,'Faber-Jackson','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86026,31.36,0.37,18.7,35554,95,NULL,'Weighted Mean','NGC 3945',NULL,'1984ApJS...56...91D',1984,1,5.2,NULL,'G',0.000017,NULL,'11.8',3.5,'SB(rs)0+       LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,178.307208333,60.67556,0.073,NULL,61849160634,966393134,15099892,11.8),(86027,'Faber-Jackson','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86027,31.67,0.46,21.6,35554,95,NULL,'Michard 1979a','NGC 3945',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86028,'Faber-Jackson','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86028,31.79,0.63,22.8,35554,95,NULL,'Michard 1979b, c','NGC 3945',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86029,'Faber-Jackson','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86029,32.93,0.81,38.5,35554,55,NULL,'Visvanathan & Sandage 1979','NGC 3945',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86030,'Tertiary','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86030,31.34,0.41,18.5,35554,95,NULL,NULL,'NGC 3945',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86031,'Tully est','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86031,31.76,0.8,22.5,35554,75,NULL,'B','NGC 3945',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86032,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86032,31.63,0.45,21.2,35554,NULL,NULL,'K','NGC 3945',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86033,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86033,31.67,0.4,21.6,35554,NULL,NULL,'mean','NGC 3945',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86034,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86034,37.23,0.46,279,35555,70,NULL,NULL,'2MASX J11531378+6354597',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000158,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,178.3072917,63.91661,0.029,NULL,61817490353,965898286,15092160,16.8),(86035,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86035,38.28,0.46,452,35556,70,NULL,NULL,'2MASX J11531415+2144315',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.94',0.13,NULL,NULL,NULL,NULL,NULL,1,178.309125,21.74222,0.084,NULL,61072601283,954259395,14910303,18.94),(86036,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86036,33.55,NULL,51.2,35557,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06862',NULL,'2010Ap&SS.325..163P',2010,1,1.43,NULL,'G',0.000005,NULL,'16.3g',0.2,'Sdm',NULL,NULL,NULL,NULL,1,178.3142083,11.63411,0.008,NULL,60232770216,941137034,14705266,16.3),(86037,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86037,33.55,NULL,51.3,35557,NULL,NULL,'Dipole + Quadrupole','UGC 06862',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86038,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86038,33.56,NULL,51.5,35557,NULL,NULL,'Dipole','UGC 06862',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86039,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86039,33.56,NULL,51.6,35557,NULL,NULL,NULL,'UGC 06862',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86040,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86040,33.75,0.2,56.2,35557,74.4,NULL,NULL,'UGC 06862',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86041,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86041,33.92,0.73,60.9,35557,NULL,NULL,NULL,'UGC 06862',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86042,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86042,34.01,0.7,63.4,35557,NULL,NULL,'Malmquist cor.','UGC 06862',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86043,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86043,34.03,0.43,64,35557,75,NULL,'3.6 micron, color corrected','UGC 06862',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86044,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86044,34.28,0.43,71.8,35557,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06862',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86045,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86045,37.92,0.33,383,35558,70,NULL,NULL,'2MASX J11531556+1251306',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000174,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,178.3147917,12.85856,0.018,NULL,60245975513,941343367,14708490,17.4),(86046,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86046,37.54,0.46,322,35559,70,NULL,NULL,'2MASX J11531616+5409278',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,178.317458333,54.15769,0,NULL,61759659385,964994677,15078041,17.3),(86047,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86047,34.68,0.2,86.3,35560,74.4,NULL,NULL,'KUG 1150+237',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.00001,NULL,'15.0',0.4,'S0/a           HII',NULL,NULL,NULL,NULL,1,178.320625,23.46453,0,NULL,60534951903,945858623,14779040,15),(86048,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86048,38.14,0.46,425,35561,70,NULL,NULL,'2MASX J11531795+3044096',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,178.324875,30.736,0,NULL,60562977615,946296525,14785883,17.8),(86049,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86049,38.28,0.33,454,35562,70,NULL,NULL,'2MASX J11531840+1701006',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,178.3265417,17.01692,0.136,NULL,60207455026,940741484,14699085,18.4),(86050,'IRAS','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86050,33.28,0.8,45.3,35563,75,NULL,'MAT, I','ESO 217- G 012',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000021,NULL,'14.28',1.2,'SAB(s)c:',NULL,NULL,NULL,NULL,1,178.3302917,-49.58456,0.369,NULL,40009431703,625147370,9767927,14.28),(86051,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86051,32.55,0.32,32.3,35563,85,NULL,'I, raw','ESO 217- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86052,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86052,32.57,0.32,32.6,35563,85,NULL,'I, inv','ESO 217- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86053,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86053,32.61,0.43,33.3,35563,75,NULL,'MAT, I, raw','ESO 217- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86054,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86054,32.72,0.43,34.9,35563,75,NULL,'MAT, I, inv','ESO 217- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86055,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86055,32.85,0.43,37.1,35563,75,NULL,'MAT, I, cor','ESO 217- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86056,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86056,33,NULL,39.8,35563,NULL,NULL,'I','ESO 217- G 012',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86057,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86057,33.08,NULL,41.3,35563,NULL,NULL,'B','ESO 217- G 012',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86058,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86058,34.27,0.49,71.5,35563,75,NULL,'IR','ESO 217- G 012',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86059,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86059,36.91,0.21,241,35564,70,NULL,NULL,'2MASX J11531912+4918128',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000207,NULL,'16.3g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,178.3297083,49.30358,0.021,NULL,61748449044,964819516,15075304,16.3),(86060,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86060,36.77,0.46,226,35565,70,NULL,NULL,'2MASX J11531974+1550116',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000156,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,178.332166667,15.83644,0.053,NULL,60254819990,941481562,14710649,17.3),(86061,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86061,34.57,0.43,82,35566,75,NULL,'3.6 micron, color corrected','NGC 3947',NULL,'2014MNRAS.444..527S',2014,1,1.4,NULL,'G',0.000017,NULL,'13.88',1.2,'(R)SB(rs)b     HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,178.334667,20.75172,0.215,NULL,60198453116,940600829,14696887,13.88),(86062,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86062,34.62,0.2,84,35566,74.4,NULL,NULL,'NGC 3947',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86063,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86063,34.64,0.43,84.6,35566,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3947',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86064,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86064,35.07,0.07,103,35566,NULL,NULL,NULL,'NGC 3947',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86065,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86065,37.29,0.46,288,35567,70,NULL,NULL,'2MASX J11532202+0935135',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,178.341833333,9.58706,0,NULL,60147921168,939811268,14684551,17.3),(86066,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86066,38.25,0.46,447,35568,70,NULL,NULL,'2MASX J11532220+1003235',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000184,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,178.342541667,10.05644,0,NULL,60368080147,943251252,14738300,17.4),(86067,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86067,36.6,0.59,209,35569,70,NULL,NULL,'2MASX J11532284-4758436',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,178.345125,-47.97886,0.425,NULL,40011528956,625180139,9768439,15.3),(86068,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86068,37.54,0.27,321,35570,70,NULL,NULL,'2MASX J11532310+5217537',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000159,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,178.346167,52.29814,0.008,NULL,61769514257,965148660,15080447,18.4),(86069,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86069,36.66,0.46,215,35571,70,NULL,NULL,'2MASX J11532338+3953530',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,178.347333,39.89817,0.008,NULL,60409804377,943903193,14748487,17.4),(86070,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86070,38.12,0.46,422,35572,70,NULL,NULL,'2MASX J11532388+0849495',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,178.3494583,8.83033,0,NULL,60147720074,939808126,14684501,17.5),(86071,'IRAS','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86071,31.6,0.8,20.9,35573,75,NULL,'MAT, I','UGCA 250',NULL,'1997ApJS..109..333W',1997,1,4.4,NULL,'G',0.00001,NULL,'13.18',0.6,'Sd: sp         HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,178.35025,-28.55317,0.257,NULL,41447648703,647619510,10119054,13.18),(86072,'Tully est','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86072,31.96,0.8,24.7,35573,75,NULL,NULL,'UGCA 250',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86073,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86073,31.14,0.4,16.9,35573,73,NULL,'IR','UGCA 250',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86074,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86074,31.14,0.4,16.9,35573,75,NULL,NULL,'UGCA 250',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86075,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86075,31.34,0.4,18.5,35573,NULL,NULL,NULL,'UGCA 250',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86076,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86076,31.4,0.43,19.1,35573,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 250',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86077,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86077,31.44,0.32,19.4,35573,85,NULL,'I, raw','UGCA 250',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86078,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86078,31.45,0.32,19.5,35573,85,NULL,'I, inv','UGCA 250',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86079,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86079,31.5,0.43,20,35573,75,NULL,'3.6 micron, color corrected','UGCA 250',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86080,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86080,31.57,0.43,20.6,35573,75,NULL,'MAT, I, raw','UGCA 250',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86081,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86081,31.59,0.2,20.8,35573,74.4,NULL,NULL,'UGCA 250',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86082,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86082,31.68,0.43,21.7,35573,75,NULL,'MAT, I, inv','UGCA 250',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86083,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86083,31.74,0.49,22.3,35573,75,NULL,'IR','UGCA 250',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86084,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86084,31.83,0.43,23.2,35573,75,NULL,'MAT, I, cor','UGCA 250',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86085,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86085,35.76,0.33,142,35574,70,NULL,NULL,'CGCG 127-097',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000087,NULL,'15.0g',0.61,'E',NULL,NULL,NULL,NULL,1,178.3515417,23.07092,0.031,NULL,60534571247,945852675,14778948,15),(86086,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86086,38.58,0.46,519,35575,70,NULL,NULL,'SDSS J115325.03+063117.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000157,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,178.354291667,6.52153,0,NULL,60157585671,939962276,14686910,18.7),(86087,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86087,37.28,0.46,286,35576,70,NULL,NULL,'2MASX J11532633+5302410',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,178.359875,53.04458,0,NULL,61766885886,965107591,15079806,17.9),(86088,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86088,36.12,0.46,168,35577,70,NULL,NULL,'2MASX J11532641+6336187',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000188,NULL,'16.0g',0.38,'S0a',NULL,NULL,NULL,NULL,1,178.360291667,63.60528,0,NULL,61819413841,965928341,15092630,16),(86089,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86089,37.39,0.16,300,35578,70,NULL,NULL,'2MASX J11532694+5245110',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000193,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,178.362417,52.75297,0,NULL,61766737357,965105271,15079769,16.4),(86090,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86090,35.78,0.46,143,35579,70,NULL,NULL,'IC 2971',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000172,NULL,'15.3g',0.47,'E?',NULL,NULL,NULL,NULL,1,178.36475,30.69692,0,NULL,60562995565,946296805,14785887,15.3),(86091,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86091,38.06,0.21,409,35580,70,NULL,NULL,'SDSS J115327.79+094925.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000132,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,178.365833,9.82375,0,NULL,60366840501,943231882,14737998,18.2),(86092,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86092,36.23,0.46,176,35581,70,NULL,NULL,'2MASX J11532894+4355596',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000167,NULL,'16.2g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,178.370833,43.93325,0,NULL,60398262948,943722858,14745669,16.2),(86093,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86093,38.13,0.46,423,35582,70,NULL,NULL,'2MASX J11532973+1238473',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000179,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,178.373875,12.64656,0.018,NULL,60244112202,941314253,14708035,17.7),(86094,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86094,36.91,0.23,241,35583,70,NULL,NULL,'2MASX J11532985+4334486',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000179,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,178.374375,43.58036,0,NULL,60401851058,943778922,14746545,16.4),(86095,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86095,37.39,0.16,300,35584,70,NULL,NULL,'2MASX J11533061+5241221',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000183,NULL,'15.8g',0.53,'AGN',NULL,NULL,NULL,NULL,1,178.377417,52.68944,0,NULL,61768655216,965135237,15080238,15.8),(86096,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86096,37.82,0.46,366,35585,70,NULL,NULL,'2MASX J11533109+3239547',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,178.379667,32.66519,0,NULL,60549245974,946081968,14782530,17.3),(86097,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86097,36.57,0.46,207,35586,70,NULL,NULL,'2MASX J11533143+2741035',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000191,NULL,'16.0g',0.36,NULL,NULL,NULL,NULL,NULL,1,178.381083333,27.68433,0.029,NULL,60591705338,946745395,14792896,16),(86098,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86098,37.43,0.27,306,35587,70,NULL,NULL,'2MASX J11533196+3148237',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.30',0.15,NULL,NULL,NULL,NULL,NULL,1,178.38325,31.80669,0,NULL,60552304287,946129754,14783277,18.3),(86099,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86099,37.5,0.46,316,35588,70,NULL,NULL,'2MASX J11533229+6426368',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000172,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,178.384583333,64.4435,0.021,NULL,61817634255,965900535,15092195,16.6),(86100,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86100,38.3,0.46,458,35589,70,NULL,NULL,'2MASX J11533241+2702285',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000153,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,178.385,27.04139,0.022,NULL,60591454880,946741482,14792835,18.3),(86101,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86101,37.53,0.46,321,35590,70,NULL,NULL,'2MASX J11533256+4033400',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00017,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,178.385875,40.561,0,NULL,60410476924,943913701,14748651,16.5),(86102,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86102,37.1,0.46,263,35591,70,NULL,NULL,'2MASX J11533333+2101437',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.72',0.14,NULL,NULL,NULL,NULL,NULL,1,178.38875,21.02869,0.133,NULL,60198236542,940597445,14696835,18.72),(86103,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86103,34.64,NULL,84.7,35592,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06864',NULL,'2010Ap&SS.325..163P',2010,1,0.77,NULL,'G',0.000007,NULL,'16.3g',0.25,'Sbc',NULL,NULL,NULL,NULL,1,178.39,10.87786,0,NULL,60368319307,943254989,14738359,16.3),(86104,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86104,34.65,NULL,85.1,35592,NULL,NULL,'Dipole + Quadrupole','UGC 06864',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86105,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86105,34.66,NULL,85.5,35592,NULL,NULL,'Dipole','UGC 06864',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86106,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86106,34.84,0.2,92.9,35592,74.4,NULL,NULL,'UGC 06864',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86107,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86107,36.68,0.27,216,35593,70,NULL,NULL,'2MASX J11533412+0331398',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000076,NULL,'17.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,178.392166667,3.52769,0.032,NULL,60135478127,939616845,14681513,17.4),(86108,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86108,37.9,0.46,381,35594,70,NULL,NULL,'2MASX J11533420+6327517',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000187,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,178.392417,63.46447,0,NULL,61819486752,965929480,15092648,16.7),(86109,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86109,37.82,0.46,366,35595,70,NULL,NULL,'2MASX J11533505+2126467',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,178.3960417,21.44644,0.1,NULL,61072504159,954257877,14910279,17.7),(86110,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86110,35.65,0.46,135,35596,70,NULL,NULL,'2MASX J11533613+0250038',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000073,NULL,'16.1g',0.24,'Sa',NULL,NULL,NULL,NULL,1,178.4004583,2.83447,0.039,NULL,60135085022,939610703,14681417,16.1),(86111,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86111,36.36,0.57,187,35597,70,NULL,NULL,'2MASX J11533673-5148113',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,178.403,-51.80311,0.725,NULL,40034999666,625546869,9774169,16.8),(86112,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86112,38.14,0.46,424,35598,70,NULL,NULL,'2MASX J11533715+1948597',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,178.404833,19.81664,0.178,NULL,60197978109,940593407,14696771,17.6),(86113,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86113,37.54,0.27,321,35599,70,NULL,NULL,'2MASX J11533713+5214551',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00018,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,178.404917,52.24869,0.008,NULL,61769500463,965148444,15080444,17.2),(86114,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86114,36.91,0.21,241,35600,70,NULL,NULL,'2MASX J11533765+4906271',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,178.406958333,49.10753,0.036,NULL,61747624697,964806635,15075103,17.6),(86115,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86115,31.84,0.43,23.3,35601,75,NULL,'3.6 micron, color + selection bias corrected','ESO 504- G 024',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.00002,NULL,'15.14',1,'SB(s)m',NULL,NULL,NULL,NULL,1,178.407875,-26.99581,0.369,NULL,41415083442,647110678,10111104,15.14),(86116,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86116,37.92,0.33,383,35602,70,NULL,NULL,'2MASX J11533819+1254243',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000172,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,178.40925,12.90675,0.018,NULL,60245958219,941343097,14708485,17.7),(86117,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86117,34.24,0.47,70.4,35603,NULL,NULL,'H','UGC 06865',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'GPair',0.00003,NULL,NULL,NULL,'Sy2',NULL,NULL,NULL,NULL,1,178.4125,43.45667,0,NULL,60402008253,943781378,14746584,NULL),(86118,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86118,34.28,0.45,71.9,35603,NULL,NULL,'K','UGC 06865',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86119,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86119,34.39,0.46,75.6,35603,NULL,NULL,'J','UGC 06865',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86120,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86120,34.52,0.4,80.2,35603,NULL,NULL,'mean','UGC 06865',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86121,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86121,37.92,0.46,384,35604,70,NULL,NULL,'SDSS J115339.26+104102.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,178.413625,10.68392,0,NULL,60368289070,943254516,14738351,18.2),(86122,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86122,38.28,0.33,454,35605,70,NULL,NULL,'2MASX J11533990+1702463',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,178.416416667,17.04644,0.124,NULL,60207458407,940741537,14699086,17.8),(86123,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86123,34.07,0.49,65.1,35606,75,NULL,'IR','UGC 06865 NED02',NULL,'2011yCatp016004901K',2011,1,1.87,'Component \'b)\' in UGC notes.','G',0.00007,NULL,'14.8g',0.39,'SB',NULL,NULL,NULL,NULL,1,178.4165417,43.46094,0,NULL,60402008211,943781378,14746584,14.8),(86124,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86124,36.91,0.21,241,35607,70,NULL,NULL,'SDSS J115340.07+491209.9',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,178.4169583,49.20278,0.036,NULL,61747588341,964806067,15075094,17.7),(86125,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86125,37.76,0.46,356,35608,70,NULL,NULL,'2MASX J11534044+2446305',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,178.418583,24.77517,0,NULL,60547546787,946055418,14782115,17),(86126,'Tully est','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86126,32.16,0.8,27,35609,75,NULL,'B','NGC 3952',NULL,'1988NBGC.C....0000T',1988,1,1.6,'Confused HIPASS source','G',0.000017,NULL,'13.76',0.7,'IBm: sp        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,178.4192917,-3.99653,0.041,NULL,40812993009,637703015,9964109,13.76),(86127,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86127,37.5,0.33,316,35610,70,NULL,NULL,'2MASX J11534084+4749156',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000149,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,178.420125,47.82086,0.029,NULL,61755455334,964928989,15077015,18),(86128,'IRAS','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86128,34.71,0.8,87.4,35611,75,NULL,'HMCL, I','NGC 3951',NULL,'1997ApJS..109..333W',1997,1,1.16,NULL,'G',0.000013,NULL,'14.0g',0.62,'Sa',NULL,NULL,NULL,NULL,1,178.421875,23.38222,0,NULL,60535747856,945871060,14779235,14),(86129,'IRAS','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86129,34.75,0.8,89,35611,75,NULL,'W91CL, r','NGC 3951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86130,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86130,34.52,0.43,80.2,35611,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3951',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86131,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86131,34.54,0.43,80.9,35611,75,NULL,'3.6 micron, color corrected','NGC 3951',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86132,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86132,34.59,0.4,82.9,35611,75,NULL,'HMCL, I, raw','NGC 3951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86133,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86133,34.66,0.2,85.5,35611,74.4,NULL,NULL,'NGC 3951',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86134,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86134,34.67,0.38,86,35611,75,NULL,'W91CL, r, raw','NGC 3951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86135,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86135,34.8,0.4,91.3,35611,75,NULL,'HMCL, I, inv','NGC 3951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86136,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86136,34.84,0.38,93.1,35611,75,NULL,'W91CL, r, inv','NGC 3951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86137,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86137,34.86,0.4,93.8,35611,75,NULL,'HMCL, I, cor','NGC 3951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86138,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86138,34.87,0.47,94.2,35611,NULL,NULL,'H','NGC 3951',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86139,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86139,34.9,0.38,95.5,35611,75,NULL,'W91CL, r, cor','NGC 3951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86140,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86140,34.94,0.45,97.1,35611,NULL,NULL,'K','NGC 3951',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86141,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86141,34.97,0.46,98.8,35611,NULL,NULL,'J','NGC 3951',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86142,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86142,35.03,0.4,101,35611,NULL,NULL,'mean','NGC 3951',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86143,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86143,35.04,0.11,102,35611,NULL,NULL,NULL,'NGC 3951',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86144,'IRAS','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86144,30.94,0.8,15.4,35612,75,NULL,'W91CL, r','NGC 3949',NULL,'1997ApJS..109..333W',1997,1,2.92,NULL,'G',0.000004,NULL,'11.7g',1.24,'SA(s)bc:       HII','Probable group member',NULL,NULL,NULL,1,178.423833,47.85869,0.029,NULL,61755720932,964933139,15077080,11.7),(86145,'IRAS','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86145,30.95,0.8,15.5,35612,75,NULL,'A82, H','NGC 3949',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86146,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86146,29.19,0.69,6.89,35612,100,NULL,'mid-IR','NGC 3949',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86147,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86147,30.93,NULL,15.3,35612,NULL,NULL,'LEDA [Nov 2006]','NGC 3949',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86148,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86148,30.98,0.07,15.7,35612,NULL,NULL,NULL,'NGC 3949',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86149,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86149,30.98,NULL,15.7,35612,NULL,NULL,'B','NGC 3949',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86150,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86150,31.15,0.4,17,35612,75,NULL,'B','NGC 3949',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86151,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86151,31.16,NULL,17.1,35612,NULL,NULL,'B, Hubble-type-TF','NGC 3949',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86152,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86152,31.23,0.4,17.6,35612,NULL,NULL,'mean','NGC 3949',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86153,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86153,31.26,0.43,17.8,35612,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3949',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86154,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86154,31.29,0.46,18.1,35612,NULL,NULL,'J','NGC 3949',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86155,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86155,31.3,0.47,18.2,35612,NULL,NULL,'H','NGC 3949',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86156,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86156,31.31,0.43,18.3,35612,75,NULL,'3.6 micron, color corrected','NGC 3949',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86157,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86157,31.35,0.45,18.6,35612,NULL,NULL,'K','NGC 3949',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86158,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86158,31.38,0.47,18.8,35612,75,NULL,'A82, H, raw','NGC 3949',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86159,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86159,31.38,NULL,18.9,35612,NULL,NULL,'B','NGC 3949',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86160,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86160,31.4,0.35,19.1,35612,NULL,NULL,NULL,'NGC 3949',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86161,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86161,31.41,0.2,19.1,35612,74.4,NULL,NULL,'NGC 3949',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86162,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86162,31.42,NULL,19.2,35612,NULL,NULL,'I, Hubble-type-TF','NGC 3949',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86163,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86163,31.44,0.6,19.4,35612,53.9,NULL,'NGC 3949/NGC 4051 pair','NGC 3949',NULL,'1984A&A...132..253R',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86164,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86164,31.44,0.47,19.4,35612,75,NULL,'A82, H, inv','NGC 3949',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86165,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86165,31.49,NULL,19.9,35612,NULL,NULL,'I','NGC 3949',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86166,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86166,31.5,0.38,19.9,35612,75,NULL,'W91CL, r, raw','NGC 3949',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86167,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86167,31.54,NULL,20.3,35612,NULL,NULL,'I','NGC 3949',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86168,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86168,31.59,0.47,20.8,35612,75,NULL,'A82, H, cor','NGC 3949',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86169,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86169,31.61,0.38,21,35612,75,NULL,'W91CL, r, inv','NGC 3949',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86170,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86170,31.62,0.38,21.1,35612,75,NULL,'W91CL, r, cor','NGC 3949',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86171,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86171,37.5,0.33,316,35613,70,NULL,NULL,'NGC 3950',NULL,'2015arXiv151105856S',2015,1,0.4,'NGC identification is not certain.','G',0.000187,NULL,'16.5g',0.36,'E0;cand. dwarf','Dwarf, within FOV of cluster',NULL,NULL,NULL,1,178.4225417,47.88458,0.029,NULL,61755721017,964933140,15077080,16.5),(86172,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86172,35.26,0.07,113,35614,70,NULL,NULL,'NGC 3954',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00007,NULL,'14.65',0.6,'E?','in a radial-velocity based grouping',NULL,NULL,NULL,1,178.423667,20.8825,0.215,NULL,60198271985,940597999,14696843,14.65),(86173,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86173,37.49,0.33,315,35615,70,NULL,NULL,'SDSS J115342.20+341022.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000167,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,178.425875,34.17292,0.021,NULL,60432110190,944251721,14753933,18.1),(86174,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86174,37.52,0.46,319,35616,70,NULL,NULL,'2MASX J11534255+4829052',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,178.427166667,48.48486,0.078,NULL,61755255378,964925865,15076966,17.2),(86175,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86175,37.87,0.27,374,35617,70,NULL,NULL,'2MASX J11534400+2222087',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000117,NULL,'16.78',0.31,NULL,NULL,NULL,NULL,NULL,1,178.4334583,22.36903,0.066,NULL,61069558313,954211848,14909560,16.78),(86176,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86176,35.76,0.33,142,35618,70,NULL,NULL,'2MASX J11534449+2307347',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000083,NULL,'16.41',0.31,NULL,NULL,NULL,NULL,NULL,1,178.435375,23.12619,0.031,NULL,60535818691,945872167,14779252,16.41),(86177,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86177,37.39,0.16,300,35619,70,NULL,NULL,'2MASX J11534665+5246052',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000169,NULL,'17.0g',0.32,NULL,NULL,NULL,NULL,NULL,1,178.4445,52.76811,0,NULL,61766753245,965105519,15079773,17),(86178,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86178,36.49,0.46,198,35620,70,NULL,NULL,'2MASX J11534664+5254132',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000172,NULL,'16.1g',0.29,'S0',NULL,NULL,NULL,NULL,1,178.444541667,52.90369,0,NULL,61766837233,965106831,15079794,16.1),(86179,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86179,37.6,0.46,331,35621,70,NULL,NULL,'2MASX J11534703+4305557',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,178.445916667,43.09878,0,NULL,60401206224,943768847,14746388,17.6),(86180,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86180,37.76,0.33,357,35622,70,NULL,NULL,'2MASX J11534718+2009167',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,178.4465,20.15458,0.136,NULL,60198061707,940594714,14696792,17.2),(86181,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86181,36.68,0.27,216,35623,70,NULL,NULL,'2MASX J11534788+0333478',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000082,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,178.449417,3.56344,0.032,NULL,60135497254,939617144,14681517,16.7),(86182,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86182,36.68,0.27,216,35624,70,NULL,NULL,'2MASX J11534821+0329268',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000079,NULL,'16.2g',0.37,'S0',NULL,NULL,NULL,NULL,1,178.450791667,3.49075,0.032,NULL,60135579556,939618430,14681537,16.2),(86183,'IRAS','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86183,34.48,0.8,78.6,35625,75,NULL,'MAT, I','IC 2974',NULL,'1997ApJS..109..333W',1997,1,2.2,'The identification as IC 2975 is not certain.','G',0.000027,NULL,'13.5',0.5,'SA(s)c? sp',NULL,NULL,NULL,NULL,1,178.453041667,-5.16783,0.109,NULL,40860359018,638443109,9975673,13.5),(86184,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86184,34.02,0.43,63.7,35625,75,NULL,'MAT, I, raw','IC 2974',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86185,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86185,34.13,0.47,67,35625,NULL,NULL,'H','IC 2974',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86186,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86186,34.17,0.46,68.2,35625,NULL,NULL,'J','IC 2974',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86187,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86187,34.24,0.49,70.5,35625,75,NULL,'IR','IC 2974',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86188,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86188,34.28,0.45,71.8,35625,NULL,NULL,'K','IC 2974',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86189,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86189,34.33,0.32,73.4,35625,85,NULL,'I, raw','IC 2974',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86190,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86190,34.33,0.43,73.6,35625,75,NULL,'MAT, I, inv','IC 2974',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86191,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86191,34.38,0.29,75.2,35625,NULL,NULL,'Malmquist cor.','IC 2974',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86192,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86192,34.4,0.32,76,35625,85,NULL,'I, inv','IC 2974',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86193,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86193,34.41,0.43,76.3,35625,75,NULL,'MAT, I, cor','IC 2974',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86194,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86194,34.42,0.2,76.6,35625,74.4,NULL,NULL,'IC 2974',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86195,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86195,34.45,0.28,77.7,35625,NULL,NULL,NULL,'IC 2974',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86196,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86196,34.51,0.4,79.7,35625,NULL,NULL,'mean','IC 2974',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86197,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86197,37.39,0.16,300,35626,70,NULL,NULL,'2MASX J11534885+5248212',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000163,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,178.4535417,52.80583,0,NULL,61766748084,965105438,15079772,17.1),(86198,'Ring Diameter','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86198,31.5,0.76,20,35627,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3953',NULL,'1981ApJS...45..541P',1981,1,6.9,NULL,'G',0.000007,NULL,'9.88B',3.5,'SB(r)bc    HII/LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,178.453833333,52.32678,0.008,NULL,61769486755,965148230,15080441,9.88),(86199,'Ring Diameter','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86199,31.8,0.6,23,35627,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 3953',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86200,'SNII optical','2016-12-15 15:14:52','2016-12-16 11:20:01','1','SN 2006bp',NULL,86200,30.48,0.1,12.5,35627,NULL,NULL,'EPM, H01','NGC 3953',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86201,'SNII optical','2016-12-15 15:14:52','2016-12-16 11:20:01','1','SN 2006bp',NULL,86201,31.09,0.08,16.5,35627,NULL,NULL,'SCM','NGC 3953',NULL,'2015ApJ...799..215P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86202,'SNII optical','2016-12-15 15:14:52','2016-12-16 11:20:01','1','SN 2006bp',NULL,86202,31.16,NULL,17.1,35627,NULL,NULL,'SEAM','NGC 3953',NULL,'2008ApJ...675..644D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86203,'SNII optical','2016-12-15 15:14:52','2016-12-16 11:20:01','1','SN 2006bp',NULL,86203,31.22,0.07,17.5,35627,NULL,NULL,'SCM','NGC 3953',NULL,'2008ApJ...675..644D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86204,'SNII optical','2016-12-15 15:14:52','2016-12-16 11:20:01','1','SN 2006bp',NULL,86204,31.35,0.17,18.6,35627,NULL,NULL,'EPM, expansion velocity modeled','NGC 3953',NULL,'2012MNRAS.419.2783T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86205,'SNII optical','2016-12-15 15:14:52','2016-12-16 11:20:01','1','SN 2006bp',NULL,86205,31.37,0.12,18.8,35627,NULL,NULL,'EPM, D05','NGC 3953',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86206,'SNII optical','2016-12-15 15:14:52','2016-12-16 11:20:01','1','SN 2006bp',NULL,86206,31.58,0.18,20.7,35627,NULL,NULL,'EPM','NGC 3953',NULL,'2012MNRAS.419.2783T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86207,'IRAS','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86207,31.45,0.8,19.5,35627,75,NULL,'A82, H','NGC 3953',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86208,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86208,29.95,0.69,9.79,35627,100,NULL,'mid-IR','NGC 3953',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86209,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86209,30.98,0.11,15.7,35627,NULL,NULL,NULL,'NGC 3953',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86210,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86210,31.13,NULL,16.8,35627,NULL,NULL,'B','NGC 3953',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86211,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86211,31.15,0.4,17,35627,75,NULL,'B','NGC 3953',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86212,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86212,31.25,0.35,17.8,35627,NULL,NULL,NULL,'NGC 3953',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86213,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86213,31.25,NULL,17.8,35627,NULL,NULL,'I','NGC 3953',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86214,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86214,31.25,NULL,17.8,35627,NULL,NULL,'I','NGC 3953',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86215,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86215,31.25,NULL,17.8,35627,NULL,NULL,'LEDA [Nov 2006]','NGC 3953',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86216,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86216,31.3,NULL,18.2,35627,NULL,NULL,'B','NGC 3953',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86217,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86217,31.36,0.43,18.7,35627,75,NULL,'3.6 micron, color corrected','NGC 3953',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86218,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86218,31.37,0.47,18.8,35627,75,NULL,'A82, H, raw','NGC 3953',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86219,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86219,31.37,NULL,18.8,35627,NULL,NULL,'I, Hubble-type-TF','NGC 3953',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86220,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86220,31.38,NULL,18.9,35627,NULL,NULL,'I','NGC 3953',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86221,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86221,31.39,NULL,19,35627,NULL,NULL,'B','NGC 3953',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86222,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86222,31.39,NULL,19,35627,NULL,NULL,'B, Hubble-type-TF','NGC 3953',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86223,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86223,31.4,0.43,19,35627,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3953',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86224,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86224,31.42,0.2,19.2,35627,74.4,NULL,NULL,'NGC 3953',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86225,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86225,31.57,0.47,20.6,35627,75,NULL,'A82, H, inv','NGC 3953',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86226,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86226,31.61,0.47,21,35627,75,NULL,'A82, H, cor','NGC 3953',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86227,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86227,36.92,0.33,243,35628,70,NULL,NULL,'2MASX J11534887+1755247',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000175,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,178.4537917,17.92356,0.111,NULL,60207811692,940747057,14699172,16.4),(86228,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86228,37.49,0.33,315,35629,70,NULL,NULL,'2MASX J11534889+3412407',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,178.4537917,34.21142,0,NULL,60432096557,944251508,14753929,17.1),(86229,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86229,37.77,0.46,358,35630,70,NULL,NULL,'SDSS J115349.18+093230.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,178.454958333,9.54183,0,NULL,60147936451,939811507,14684554,17.8),(86230,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86230,37.76,0.33,357,35631,70,NULL,NULL,'2MASX J11534972+2003236',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,178.457167,20.05669,0.123,NULL,60197981477,940593460,14696772,17.8),(86231,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86231,37.76,0.46,357,35632,70,NULL,NULL,'SDSS J115349.71+223747.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000138,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,178.457167,22.63,0.066,NULL,61069341533,954208461,14909507,18.4),(86232,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86232,37.48,0.46,313,35633,70,NULL,NULL,'2MASX J11535015+0536508',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,178.459,5.61417,0,NULL,60189842001,940466281,14694785,17.1),(86233,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86233,31.91,0.4,24.1,35634,NULL,NULL,NULL,'ESO 504- G 025',NULL,'2009AJ....138..323T',2009,1,1.8,'Marginal HIPASS detection.','G',0.000007,NULL,'14.30',1.3,'SB(s)m',NULL,NULL,NULL,NULL,1,178.461,-27.35,0.337,NULL,41461199171,647831237,10122363,14.3),(86234,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86234,32.11,0.66,26.4,35634,NULL,NULL,'Malmquist cor.','ESO 504- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86235,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86235,32.19,0.64,27.4,35634,NULL,NULL,NULL,'ESO 504- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86236,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86236,32.23,0.2,27.9,35634,74.4,NULL,NULL,'ESO 504- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86237,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86237,32.69,0.2,34.5,35635,74.4,NULL,NULL,'IC 2973',NULL,'2013AJ....146...86T',2013,1,1.41,NULL,'G',0.000004,NULL,'14.3g',0.72,'SB(s)d:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,178.4615,33.3655,0,NULL,60616929594,947139524,14799055,14.3),(86238,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86238,32.73,0.67,35.1,35635,NULL,NULL,NULL,'IC 2973',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86239,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86239,32.93,0.61,38.5,35635,NULL,NULL,'Malmquist cor.','IC 2973',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86240,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86240,37.96,0.16,391,35636,70,NULL,NULL,'SDSS J115352.06+122919.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000177,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,178.4669583,12.48864,0,NULL,60232882549,941138789,14705293,18.3),(86241,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86241,37.81,0.46,365,35637,70,NULL,NULL,'2MASX J11535215-0158294',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000195,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,178.467417,-1.97494,0.029,NULL,40818061033,637782203,9965346,16.7),(86242,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86242,36.96,0.46,247,35638,70,NULL,NULL,'2MASX J11535326+3352393',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,178.471875,33.8775,0,NULL,60616386171,947131033,14798922,17),(86243,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86243,37.37,0.46,298,35639,70,NULL,NULL,'2MASX J11535366+2421105',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,178.473708333,24.35311,0,NULL,60547464622,946054134,14782095,17.4),(86244,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86244,38.06,0.21,409,35640,70,NULL,NULL,'2MASX J11535391+0938321',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,178.4745,9.64236,0,NULL,60147954182,939811784,14684559,17.4),(86245,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86245,35.32,0.46,116,35641,70,NULL,NULL,'CGCG 068-086',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.00008,NULL,'15.2g',0.55,'E0',NULL,NULL,NULL,NULL,1,178.475,13.27811,0.039,NULL,60246012168,941343940,14708499,15.2),(86246,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86246,38.8,0.46,576,35642,70,NULL,NULL,'2MASX J11535518+1808008',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,178.479958333,18.13367,0.102,NULL,60207698667,940745291,14699145,17.7),(86247,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86247,36.54,0.46,204,35643,70,NULL,NULL,'2MASX J11535539-0128004',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000154,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,178.4807917,-1.46669,0.029,NULL,40817923707,637780057,9965313,16.8),(86248,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86248,38.35,0.33,467,35644,70,NULL,NULL,'2MASX J11535667+6030196',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000214,NULL,'16.1g',0.36,'BrClG',NULL,NULL,NULL,NULL,1,178.486125,60.50533,0.073,NULL,61848604720,966384448,15099757,16.1),(86249,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86249,31,0.2,15.9,35645,74.4,NULL,NULL,'ESO 572- G 012',NULL,'2013AJ....146...86T',2013,1,2.4,'Confused HIPASS source','G',0.000013,NULL,'15',0.6,'S...',NULL,NULL,NULL,NULL,1,178.488,-20.13783,0.073,NULL,40939652064,639682063,9995032,15),(86250,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86250,31.28,0.4,18,35645,73,NULL,'opt','ESO 572- G 012',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86251,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86251,31.29,0.61,18.1,35645,NULL,NULL,NULL,'ESO 572- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86252,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86252,31.37,0.58,18.8,35645,NULL,NULL,'Malmquist cor.','ESO 572- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86253,'Tully est','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86253,31.57,0.8,20.6,35646,75,NULL,'B','NGC 3955',NULL,'1988NBGC.C....0000T',1988,1,2.9,NULL,'G',0.00003,NULL,'12.89',0.9,'S0/a pec       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,178.488125,-23.16417,0.149,NULL,41410074704,647032417,10109881,12.89),(86254,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86254,37.28,0.46,286,35647,70,NULL,NULL,'SDSS J115358.30+045133.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000147,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,178.492917,4.85944,0,NULL,60192207948,940503249,14695363,18),(86255,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86255,35.73,0.46,140,35648,70,NULL,NULL,'CGCG 068-087',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000103,NULL,'15.2g',0.49,'E0','Group member',NULL,NULL,NULL,1,178.494583,9.62722,0,NULL,60147948510,939811695,14684557,15.2),(86256,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86256,38.06,0.21,409,35649,70,NULL,NULL,'2MASX J11535891+0939301',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000204,NULL,'16.3g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,178.495333,9.65828,0,NULL,60147948686,939811698,14684557,16.3),(86257,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86257,35.11,0.4,105,35650,NULL,NULL,'mean','UGC 06876',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.00002,NULL,'14.77',0.7,'Sab',NULL,NULL,NULL,NULL,1,178.498625,20.57247,0.15,NULL,60200400631,940631259,14697363,14.77),(86258,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86258,36.31,0.47,182,35650,NULL,NULL,'H','UGC 06876',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86259,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86259,38.68,0.46,545,35651,70,NULL,NULL,'SDSS J115400.19+112850.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.00015,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,178.500833,11.48058,0.008,NULL,60232589855,941134216,14705222,18.7),(86260,'IRAS','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86260,31.7,0.8,21.9,35652,75,NULL,'MAT, I','NGC 3956',NULL,'1997ApJS..109..333W',1997,1,3.4,'Confused HIPASS source','G',0.000017,NULL,'13.05',1,'SA(s)c         HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,178.502875,-20.56733,0.073,NULL,40939960699,639686885,9995107,13.05),(86261,'IRAS','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86261,31.71,0.8,22,35652,75,NULL,'A82, H','NGC 3956',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86262,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86262,31.68,0.38,21.7,35652,NULL,NULL,NULL,'NGC 3956',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86263,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86263,31.69,0.32,21.8,35652,85,NULL,'I, raw','NGC 3956',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86264,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86264,31.7,0.32,21.9,35652,85,NULL,'I, inv','NGC 3956',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86265,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86265,31.72,0.2,22.1,35652,74.4,NULL,NULL,'NGC 3956',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86266,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86266,31.74,0.37,22.2,35652,NULL,NULL,'Malmquist cor.','NGC 3956',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86267,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86267,31.73,0.43,22.2,35652,75,NULL,'3.6 micron, color corrected','NGC 3956',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86268,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86268,31.78,0.43,22.7,35652,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3956',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86269,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86269,31.85,0.43,23.5,35652,75,NULL,'MAT, I, raw','NGC 3956',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86270,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86270,31.96,0.43,24.7,35652,75,NULL,'MAT, I, inv','NGC 3956',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86271,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86271,31.96,0.4,24.7,35652,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 3956',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86272,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86272,31.98,0.33,24.8,35652,NULL,NULL,NULL,'NGC 3956',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86273,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86273,32,0.4,25.1,35652,75,NULL,'B','NGC 3956',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86274,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86274,32.01,0.43,25.2,35652,75,NULL,'MAT, I, cor','NGC 3956',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86275,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86275,32.28,0.4,28.6,35652,NULL,NULL,'mean','NGC 3956',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86276,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86276,32.48,0.47,31.3,35652,75,NULL,'A82, H, raw','NGC 3956',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86277,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86277,32.53,0.46,32,35652,NULL,NULL,'J','NGC 3956',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86278,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86278,32.53,0.47,32.1,35652,75,NULL,'A82, H, inv','NGC 3956',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86279,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86279,32.67,0.45,34.2,35652,NULL,NULL,'K','NGC 3956',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86280,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86280,32.7,0.47,34.7,35652,75,NULL,'A82, H, cor','NGC 3956',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86281,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86281,32.74,0.47,35.3,35652,NULL,NULL,'H','NGC 3956',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86282,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86282,38.17,0.33,430,35653,70,NULL,NULL,'2MASX J11540112+1846258',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,178.504667,18.774,0.106,NULL,60210956962,940796202,14699940,18.1),(86283,'Faber-Jackson','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86283,31.33,0.65,18.5,35654,95,NULL,'Weighted Mean','NGC 3957',NULL,'1984ApJS...56...91D',1984,1,3.1,'ESO 572- ? 004 applies to the nominal position for IC 2965.','G',0.000063,NULL,'13.08',0.7,'SA0+: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,178.5062917,-19.56889,0.053,NULL,40951648745,639869511,9997961,13.08),(86284,'Faber-Jackson','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86284,32.62,0.81,33.4,35654,55,NULL,'Visvanathan & Sandage 1979','NGC 3957',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86285,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86285,31.76,0.61,22.5,35654,70,NULL,NULL,'NGC 3957',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86286,'Tertiary','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86286,30.44,0.38,12.2,35654,95,NULL,NULL,'NGC 3957',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86287,'Tully est','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86287,32.2,0.8,27.5,35654,75,NULL,'B','NGC 3957',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86288,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86288,38.03,0.46,405,35655,70,NULL,NULL,'2MASX J11540189+0916501',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00018,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,178.507875,9.28056,0,NULL,60148083186,939813799,14684590,16.5),(86289,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86289,37.2,0.46,276,35656,70,NULL,NULL,'LCRS B115129.4-022141',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000132,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,178.5127917,-2.63925,0.033,NULL,40818447392,637788240,9965441,18.3),(86290,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86290,36.32,0.46,184,35657,70,NULL,NULL,'SDSS J115404.78+050928.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000135,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,178.519917,5.15797,0.034,NULL,60192096063,940501500,14695335,18),(86291,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86291,37.43,0.27,306,35658,70,NULL,NULL,'2MASX J11540499+3156323',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000175,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,178.520875,31.94222,0.031,NULL,60553033311,946141145,14783455,16.9),(86292,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86292,38.16,0.46,429,35659,70,NULL,NULL,'2MASX J11540524+2050288',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,178.522,20.84128,0.137,NULL,60200554399,940633662,14697400,18.3),(86293,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86293,38.27,0.46,451,35660,70,NULL,NULL,'2MASX J11540537+1222209',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,178.522333,12.37247,0,NULL,60232860585,941138446,14705288,17.5),(86294,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86294,33.24,NULL,44.4,35661,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 320- G 031',NULL,'2010Ap&SS.325..163P',2010,1,3.19,'IRAS 11516-3935 identified as a star by de Grijp, et al (1992, A&AS, 96, 389).','G',0.000023,NULL,'14.17',0.45,'SB(s)c? sp     HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,178.524375,-39.86392,0.457,NULL,41343755374,645996177,10093690,14.17),(86295,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86295,33.25,NULL,44.7,35661,NULL,NULL,'Dipole + Quadrupole','ESO 320- G 031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86296,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86296,33.26,NULL,45,35661,NULL,NULL,'Dipole','ESO 320- G 031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86297,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86297,37.24,0.46,280,35662,70,NULL,NULL,'2MASX J11540640+5501242',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000167,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,178.526917,55.02344,0,NULL,61761079411,965016865,15078388,16.9),(86298,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86298,34.98,0.46,99.3,35663,70,NULL,NULL,'2MASX J11540662+2534027',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000165,NULL,'15.9g',0.37,NULL,NULL,NULL,NULL,NULL,1,178.527625,25.56742,0.011,NULL,60539016919,945922139,14780033,15.9),(86299,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86299,37.18,0.46,273,35664,70,NULL,NULL,'2MASX J11540756+0830161',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00019,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,178.531541667,8.50461,0,NULL,60147644956,939806952,14684483,16.6),(86300,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86300,38.87,0.33,593,35665,70,NULL,NULL,'2MASX J11540774+0259176',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.0001,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,178.5322083,2.98828,0.039,NULL,60135106157,939611033,14681422,17.7),(86301,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86301,38.25,0.46,447,35666,70,NULL,NULL,'2MASX J11540911+4920305',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000185,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,178.537875,49.34181,0.034,NULL,61748461637,964819713,15075308,17.7),(86302,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86302,38.87,0.33,593,35667,70,NULL,NULL,'SDSS J115409.55+025249.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000082,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,178.5397917,2.8805,0.044,NULL,60135063448,939610366,14681411,18.3),(86303,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86303,36.94,0.46,245,35668,70,NULL,NULL,'2MASX J11540974+2352289',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000185,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,178.540541667,23.87475,0.008,NULL,60535581046,945868453,14779194,16.9),(86304,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86304,31.16,NULL,17.1,35669,NULL,NULL,NULL,'AGC 215145',NULL,'2015AstBu..70....1K',2015,1,NULL,NULL,'G',0.000053,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,178.540833,12.43306,0,NULL,60233369681,941146401,14705412,NULL),(86305,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86305,37.96,0.16,391,35670,70,NULL,NULL,'2MASX J11541042+1225099',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00024,NULL,'16.9g',0.29,'FSRQ',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,178.543333,12.41939,0,NULL,60233370057,941146407,14705412,16.9),(86306,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86306,37.97,0.33,392,35671,70,NULL,NULL,'2MASX J11541039+0754108',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,178.5434583,7.90294,0,NULL,60162237287,940034957,14688046,17.7),(86307,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86307,37.59,0.21,330,35672,70,NULL,NULL,'2MASX J11541048+5202375',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,178.5437083,52.04369,0.034,NULL,61769307590,965145431,15080397,18.1),(86308,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86308,37.59,0.21,330,35673,70,NULL,NULL,'2MASX J11541113+5203015',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,178.5464583,52.05047,0.034,NULL,61769307536,965145430,15080397,18.1),(86309,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86309,38.28,0.46,453,35674,70,NULL,NULL,'2MASX J11541148+1140441',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,178.5477917,11.67892,0.008,NULL,60233761622,941152525,14705508,17.6),(86310,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86310,37.43,0.27,306,35675,70,NULL,NULL,'2MASX J11541198+3149434',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000175,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,178.5499583,31.82861,0,NULL,60552296606,946129634,14783275,17.7),(86311,'SBF','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86311,31.31,0.3,18.3,35676,NULL,NULL,'I','IC 0745',NULL,'2001ApJ...546..681T',2001,1,0.8,NULL,'G',0.000002,NULL,'13.8g',0.74,'S0;HII;Sy2;WR  Sbrst','Group member of poor cluster',NULL,NULL,'Starburst',1,178.551125,0.13664,0.029,NULL,60131959306,939561864,14680654,13.8),(86312,'SBF','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86312,31.38,0.14,18.9,35676,74.4,NULL,NULL,'IC 0745',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86313,'Tully est','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86313,30.94,0.8,15.4,35676,75,NULL,'B','IC 0745',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86314,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86314,37.97,0.33,392,35677,70,NULL,NULL,'2MASX J11541241+0750269',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000178,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,178.551625,7.84075,0,NULL,60162186058,940034157,14688033,17.2),(86315,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86315,37.72,0.46,350,35678,70,NULL,NULL,'SDSS J115412.65+034657.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,178.55275,3.78261,0.031,NULL,60135459353,939616552,14681508,18),(86316,'IRAS','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86316,34.6,0.8,83.2,35679,75,NULL,'HMCL, I','KUG 1151+203',NULL,'1997ApJS..109..333W',1997,1,0.7,NULL,'G',0.00001,NULL,'15.5',0.2,'Sb',NULL,NULL,NULL,NULL,1,178.558083,20.0275,0.123,NULL,60199841905,940622529,14697227,15.5),(86317,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86317,34.56,0.4,81.7,35679,75,NULL,'HMCL, I, raw','KUG 1151+203',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86318,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86318,34.66,0.4,85.6,35679,75,NULL,'HMCL, I, inv','KUG 1151+203',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86319,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86319,34.8,0.13,91.4,35679,NULL,NULL,NULL,'KUG 1151+203',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86320,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86320,34.83,0.4,92.4,35679,75,NULL,'HMCL, I, cor','KUG 1151+203',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86321,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86321,37.55,0.46,324,35680,70,NULL,NULL,'2MASX J11541439+5629291',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000142,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,178.560125,56.49156,0,NULL,61975989600,968374837,15130856,18.1),(86322,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86322,36.91,0.21,241,35681,70,NULL,NULL,'2MASX J11541489+4854586',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000192,NULL,'16.0g',0.4,'E0',NULL,NULL,NULL,NULL,1,178.562041667,48.91625,0.036,NULL,61747164177,964799440,15074991,16),(86323,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86323,36.21,0.46,174,35682,70,NULL,NULL,'2MASX J11541486+4634028',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,178.562083,46.56758,0,NULL,61744304569,964754758,15074293,16.9),(86324,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86324,37.03,0.46,255,35683,70,NULL,NULL,'2MASX J11541526+2510177',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000171,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,178.563583,25.1715,0,NULL,60547342543,946052227,14782066,16.8),(86325,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86325,37.01,0.46,253,35684,70,NULL,NULL,'2MASX J11541721+4935226',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000179,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,178.571625,49.58969,0.028,NULL,61748333210,964817706,15075276,16.5),(86326,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86326,37.05,0.33,258,35685,70,NULL,NULL,'2MASX J11541723+3430054',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000168,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,178.57175,34.50142,0.044,NULL,60435190173,944299846,14754685,16.3),(86327,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86327,36.92,0.33,243,35686,70,NULL,NULL,'2MASX J11541771+1755149',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,178.573875,17.921,0.102,NULL,60208296895,940754638,14699291,16.7),(86328,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86328,37.96,0.16,391,35687,70,NULL,NULL,'SDSS J115418.44+123748.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,178.576875,12.63028,0,NULL,60233365856,941146341,14705411,18.3),(86329,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86329,37.99,0.33,396,35688,70,NULL,NULL,'2MASX J11541872+6044378',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000144,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,178.578125,60.74394,0.057,NULL,61848517747,966383089,15099735,17.5),(86330,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86330,38.35,0.33,467,35689,70,NULL,NULL,'2MASX J11541961+6031418',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,178.5817917,60.52839,0.057,NULL,61848590018,966384219,15099753,17.5),(86331,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86331,34.54,0.49,80.7,35690,70,NULL,NULL,'MCG -03-30-018',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.96',0.5,NULL,NULL,NULL,NULL,NULL,1,178.581917,-18.95011,0.069,NULL,40951476426,639866819,9997919,14.96),(86332,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86332,36.84,0.46,233,35691,70,NULL,NULL,'2MASX J11541979+3120053',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000181,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,178.582375,31.33478,0.029,NULL,60551639944,946119374,14783115,16.4),(86333,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86333,34.55,0.48,81.4,35692,70,NULL,NULL,'2MASX J11542038-5146519',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'15.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,178.5850417,-51.78106,0.717,NULL,40034970535,625546414,9774162,15.2),(86334,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86334,37.96,0.16,391,35693,70,NULL,NULL,'2MASX J11542127+1247375',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000202,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,178.588666667,12.79358,0.018,NULL,60245411219,941334550,14708352,17.5),(86335,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86335,37.05,0.33,258,35694,70,NULL,NULL,'2MASX J11542216+3429463',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000185,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,178.5924583,34.49619,0.044,NULL,60435189865,944299841,14754685,16.7),(86336,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86336,36.59,0.59,208,35695,70,NULL,NULL,'2MASX J11542315-1052003',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.47',NULL,NULL,NULL,NULL,NULL,NULL,1,178.5962917,-10.86686,0.045,NULL,41020980851,640952825,10014887,16.47),(86337,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86337,37.23,0.46,279,35696,70,NULL,NULL,'SDSS J115423.17+580118.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000149,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,178.5965417,58.02175,0.017,NULL,61844579269,966321551,15098774,18.5),(86338,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86338,36.81,0.46,230,35697,70,NULL,NULL,'2MASX J11542326+1512195',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000152,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,178.596916667,15.20528,0.086,NULL,60238302254,941223472,14706616,16.8),(86339,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86339,36.59,0.46,208,35698,70,NULL,NULL,'2MASX J11542393+2111019',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.97',0.19,NULL,NULL,NULL,NULL,NULL,1,178.5997917,21.18389,0.133,NULL,60196920420,940576881,14696513,17.97),(86340,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86340,36.04,0.46,161,35699,70,NULL,NULL,'2MASX J11542441+5249577',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00014,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,178.601833,52.83269,0,NULL,61766726607,965105103,15079767,16.9),(86341,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86341,37.79,0.46,362,35700,70,NULL,NULL,'2MASX J11542465+5827142',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000161,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,178.602667,58.45422,0.021,NULL,61842692783,966292074,15098313,17),(86342,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86342,37.96,0.16,391,35701,70,NULL,NULL,'2MASX J11542489+1247065',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000176,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,178.60375,12.78522,0,NULL,60245411020,941334547,14708352,16.4),(86343,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86343,32.53,0.43,32.1,35702,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06879',NULL,'2014MNRAS.444..527S',2014,1,1.45,NULL,'G',0.000013,NULL,'14.2g',0.55,'SAB(r)d? sp','Isolated galaxy',NULL,NULL,NULL,1,178.604333333,-2.31956,0.041,NULL,40816501713,637757839,9964966,14.2),(86344,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86344,32.98,0.4,39.4,35702,NULL,NULL,'mean','UGC 06879',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86345,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86345,33.4,0.47,47.9,35702,NULL,NULL,'H','UGC 06879',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86346,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86346,37.96,0.16,391,35703,70,NULL,NULL,'2MASX J11542531+1238095',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.65',0.12,NULL,NULL,NULL,NULL,NULL,1,178.605417,12.63603,0,NULL,60233364272,941146316,14705411,18.65),(86347,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86347,37.57,0.46,326,35704,70,NULL,NULL,'2MASX J11542598+1916334',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,178.608166667,19.27581,0.126,NULL,60210675401,940791803,14699871,17.3),(86348,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86348,37.53,0.46,321,35705,70,NULL,NULL,'2MASX J11542605+4101019',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000177,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,178.6085417,41.01728,0,NULL,60407790159,943871721,14747995,17.2),(86349,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86349,38.06,0.21,409,35706,70,NULL,NULL,'SDSS J115426.26+093756.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000174,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,178.6094583,9.63242,0,NULL,60150019620,939844056,14685063,18.5),(86350,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86350,37.88,0.46,376,35707,70,NULL,NULL,'SDSS J115426.45+602332.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00013,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,178.610291667,60.39228,0.005,NULL,61848567694,966383870,15099747,18.1),(86351,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86351,37.26,0.46,283,35708,70,NULL,NULL,'2MASX J11542712+6123578',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000075,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,178.61325,61.39936,0.049,NULL,61846014006,966343968,15099124,17.6),(86352,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86352,38.06,0.21,409,35709,70,NULL,NULL,'SDSS J115427.58+094058.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,178.6149583,9.68286,0,NULL,60150048312,939844504,14685070,18.3),(86353,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86353,37.87,0.27,374,35710,70,NULL,NULL,'SDSS J115428.13+222523.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,178.61725,22.42311,0.066,NULL,61069589360,954212333,14909567,18.2),(86354,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86354,37.41,0.46,303,35711,70,NULL,NULL,'2MASX J11542820+1130589',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000166,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,178.6175,11.51642,0,NULL,60233669662,941151088,14705485,16.9),(86355,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86355,37.97,0.46,393,35712,70,NULL,NULL,'2MASX J11542863+3142502',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000182,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,178.6194583,31.71408,0.03,NULL,60552328939,946130139,14783283,17.5),(86356,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86356,37.39,0.16,300,35713,70,NULL,NULL,'2MASX J11542972+5246127',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,178.6239583,52.77011,0,NULL,61766758236,965105597,15079774,16.8),(86357,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86357,37.99,0.33,396,35714,70,NULL,NULL,'2MASX J11543059+6050168',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000183,NULL,'17.2g',0.27,'AGN',NULL,NULL,NULL,NULL,1,178.6272917,60.838,0.037,NULL,61848546328,966383536,15099742,17.2),(86358,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86358,36.9,0.33,239,35715,70,NULL,NULL,'2MASX J11543064+6341158',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000181,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,178.6277917,63.68775,0.029,NULL,61819444840,965928825,15092637,17.3),(86359,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86359,38.39,0.46,477,35716,70,NULL,NULL,'2MASX J11543166+4228161',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000183,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,178.631833,42.47117,0,NULL,60400713267,943761144,14746267,17.5),(86360,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86360,37.46,0.46,310,35717,70,NULL,NULL,'2MASX J11543212+2223515',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.81',0.14,NULL,NULL,NULL,NULL,NULL,1,178.6337917,22.39769,0.059,NULL,61069581318,954212208,14909565,18.81),(86361,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86361,32.79,0.47,36.1,35718,NULL,NULL,'H','NGC 3958',NULL,'2007A&A...465...71T',2007,1,1.67,NULL,'G',0.000023,NULL,'13.5g',0.69,'SB(s)a','in a radial-velocity based grouping',NULL,NULL,NULL,1,178.640333,58.36703,0.021,NULL,61842706698,966292292,15098317,13.5),(86362,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86362,32.82,0.45,36.6,35718,NULL,NULL,'K','NGC 3958',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86363,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86363,32.86,0.46,37.3,35718,NULL,NULL,'J','NGC 3958',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86364,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86364,33.35,0.4,46.8,35718,NULL,NULL,'mean','NGC 3958',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86365,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86365,37.88,0.46,377,35719,70,NULL,NULL,'2MASX J11543534+5934042',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000185,NULL,'16.5g',0.39,NULL,NULL,NULL,NULL,NULL,1,178.6474583,59.568,0.005,NULL,61855565906,966493217,15101456,16.5),(86366,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86366,36.91,0.23,241,35720,70,NULL,NULL,'2MASX J11543558+4314581',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000177,NULL,'15.9g',0.34,'LINER',NULL,NULL,NULL,NULL,1,178.648417,43.24944,0,NULL,60402111346,943782989,14746609,15.9),(86367,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86367,38.19,0.46,435,35721,70,NULL,NULL,'2MASX J11543623-0024580',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000088,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,178.6510417,-0.41608,0.013,NULL,40805960111,637593126,9962392,17.6),(86368,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86368,37.34,0.46,294,35722,70,NULL,NULL,'LCRS B115203.3-031127',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00013,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,178.654083333,-3.46939,0.037,NULL,40813805447,637715710,9964307,17.6),(86369,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86369,36.91,0.21,241,35723,70,NULL,NULL,'MCG +08-22-034',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000197,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,178.65875,49.31431,0.034,NULL,61748434770,964819293,15075301,16.4),(86370,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86370,37.59,0.21,330,35724,70,NULL,NULL,'2MASX J11543834+5206057',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000176,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,178.659917,52.10161,0.034,NULL,61769280465,965145007,15080390,16.6),(86371,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86371,34.51,0.51,79.7,35725,NULL,NULL,'Malmquist cor.','ESO 320- G 032',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.75',0.6,'(R\')SB(r)b',NULL,NULL,NULL,NULL,1,178.662667,-40.93231,0.469,NULL,41346521381,646039396,10094365,14.75),(86372,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86372,34.6,0.48,83.3,35725,NULL,NULL,NULL,'ESO 320- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86373,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86373,34.64,0.2,84.7,35725,74.4,NULL,NULL,'ESO 320- G 032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86374,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86374,35.06,0.4,103,35725,NULL,NULL,'mean','ESO 320- G 032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86375,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86375,35.07,0.47,103,35725,NULL,NULL,'H','ESO 320- G 032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86376,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86376,35.18,0.45,109,35725,NULL,NULL,'K','ESO 320- G 032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86377,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86377,35.22,0.46,111,35725,NULL,NULL,'J','ESO 320- G 032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86378,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86378,38.03,0.46,403,35726,70,NULL,NULL,'2MASX J11543931+0917229',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000191,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,178.663625,9.28964,0,NULL,60150062141,939844720,14685073,16.8),(86379,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86379,37.58,0.46,328,35727,70,NULL,NULL,'2MASX J11543944+2937124',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,178.664333333,29.62003,0,NULL,60560734157,946261471,14785335,18.2),(86380,'GCLF','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86380,32.47,0.2,31.2,35728,NULL,NULL,NULL,'NGC 3962',NULL,'2015A&A...577A..59S',2015,1,2.6,NULL,'G',0.000057,NULL,'12.50',2.2,'E1       poss. LINER','Isolated elliptical galaxy',NULL,NULL,NULL,1,178.667083,-13.97503,0.033,NULL,40967392488,640115507,10001804,12.5),(86381,'SBF','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86381,32.74,0.49,35.3,35728,NULL,NULL,'I','NGC 3962',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86382,'SBF','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86382,32.74,0.49,35.3,35728,NULL,NULL,NULL,'NGC 3962',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86383,'SBF','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86383,32.8,0.14,36.3,35728,74.4,NULL,NULL,'NGC 3962',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86384,'SBF','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86384,33.08,0.49,41.4,35728,NULL,NULL,'Malmquist cor.','NGC 3962',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86385,'D-Sigma','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86385,31.84,0.4,23.4,35728,75,NULL,'Edat, raw','NGC 3962',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86386,'D-Sigma','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86386,32.18,0.4,27.3,35728,75,NULL,'Edat, cor','NGC 3962',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86387,'Faber-Jackson','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86387,30.89,0.65,15.1,35728,95,NULL,'Weighted Mean','NGC 3962',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86388,'Faber-Jackson','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86388,32.08,0.81,26.1,35728,55,NULL,'Visvanathan & Sandage 1979','NGC 3962',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86389,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86389,32.07,0.41,25.9,35728,NULL,NULL,NULL,'NGC 3962',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86390,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86390,32.14,0.41,26.8,35728,NULL,NULL,'Malmquist cor.','NGC 3962',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86391,'Tertiary','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86391,30.44,0.38,12.2,35728,95,NULL,NULL,'NGC 3962',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86392,'Tully est','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86392,32.23,0.8,28,35728,75,NULL,'B','NGC 3962',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86393,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86393,32.5,0.45,31.6,35728,NULL,NULL,'K','NGC 3962',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86394,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86394,32.55,0.4,32.3,35728,NULL,NULL,'mean','NGC 3962',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86395,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86395,38.14,0.46,425,35729,70,NULL,NULL,'SDSS J115440.23+465034.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000148,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,178.6677083,46.84281,0,NULL,61744213070,964753329,15074270,18.7),(86396,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86396,38.17,0.33,430,35730,70,NULL,NULL,'SDSS J115442.85+184509.8',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,178.678583,18.75275,0.106,NULL,60211055054,940797735,14699964,18.5),(86397,'TRGB','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86397,28.48,0.1,4.97,35731,NULL,NULL,NULL,'ESO 379- G 007',NULL,'2012A&A...540A..49M',2012,1,1.3,NULL,'G',0.000013,NULL,'16.60',1.1,'dwarf Irr',NULL,NULL,NULL,NULL,1,178.6812083,-33.56,0.373,NULL,41574960340,649608755,10150136,16.6),(86398,'TRGB','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86398,28.58,NULL,5.2,35731,NULL,NULL,NULL,'ESO 379- G 007',NULL,'2002A&A...385...21K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86399,'TRGB','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86399,28.68,0.1,5.45,35731,74.4,NULL,NULL,'ESO 379- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86400,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86400,31.07,NULL,16.4,35732,NULL,NULL,NULL,'UGC 06881',NULL,'2013AJ....145..101K',2013,1,1.4,NULL,'G',0.000013,NULL,'17.',0.7,'Im:',NULL,NULL,NULL,NULL,1,178.687083,20.05647,0.123,NULL,60199820426,940622194,14697221,17),(86401,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86401,37.53,0.46,321,35733,70,NULL,NULL,'2MASX J11544536-0125470',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000166,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,178.688917,-1.42967,0.033,NULL,40804824998,637575390,9962115,17.1),(86402,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86402,37.25,0.46,282,35734,70,NULL,NULL,'2MASX J11544715+5539242',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'17.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,178.69675,55.65667,0,NULL,61757766221,964965097,15077579,17.8),(86403,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86403,38.01,0.46,399,35735,70,NULL,NULL,'2MASX J11544762+5429271',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000169,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,178.698375,54.49078,0,NULL,61759840348,964997505,15078086,18.1),(86404,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86404,37.39,0.16,300,35736,70,NULL,NULL,'2MASX J11544758+5249186',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000181,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,178.698417,52.82189,0,NULL,61766723536,965105055,15079766,16.9),(86405,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86405,38.3,0.46,456,35737,70,NULL,NULL,'2MASX J11544803+0001549',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000088,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,178.7002083,0.03175,0.025,NULL,60130081758,939532527,14680195,17.2),(86406,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86406,36.91,0.23,241,35738,70,NULL,NULL,'2MASX J11544822+4316441',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000184,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,178.700791667,43.27894,0,NULL,60402131139,943783299,14746614,17.2),(86407,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86407,37.95,0.33,389,35739,70,NULL,NULL,'SDSS J115448.72+094837.7',NULL,'2015arXiv151105856S',2015,1,0.15,'cz = 5696 km/s in (2010MNRAS.406.1583W)','G',0.000127,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,178.703,9.8105,0,NULL,60150046270,939844472,14685069,18.7),(86408,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86408,37.1,0.46,263,35740,70,NULL,NULL,'2MASX J11544884+0118561',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000077,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,178.703625,1.31556,0.005,NULL,60132749894,939574217,14680847,17.4),(86409,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86409,37.35,0.16,296,35741,70,NULL,NULL,'2MASX J11544914+4355231',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000174,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,178.7047917,43.92303,0,NULL,60398358374,943724349,14745692,17.4),(86410,'Tully est','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86410,32.2,0.8,27.5,35742,75,NULL,NULL,'UGCA 254',NULL,'1988NBGC.C....0000T',1988,1,2.1,'Double star (11\\\" sep) superposed on east edge.','G',0.000019,NULL,'13.8b',1.1,'SAB(s)cd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,178.706625,-16.8645,0.041,NULL,40995678336,640557474,10008710,13.8),(86411,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86411,37.39,0.16,300,35743,70,NULL,NULL,'2MASX J11544979+5248516',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00017,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,178.707417,52.81433,0,NULL,61766723385,965105052,15079766,16.8),(86412,'GRB','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86412,43.76,0.53,2450,35744,69.7,NULL,'Calibrated','VLA J115450.1-2640.6',1.30658,'2009MNRAS.400..775C',2009,1,NULL,NULL,'G',0.00004,NULL,NULL,NULL,'BAT/PCA',NULL,NULL,NULL,NULL,1,178.70875,-26.67667,0.333,NULL,41418174089,647158970,10111858,NULL),(86413,'GRB','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86413,43.94,0.56,2660,35744,69.7,NULL,'Fiducial','VLA J115450.1-2640.6',1.30658,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86414,'GRB','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86414,44.18,0.56,2970,35744,72,NULL,NULL,'VLA J115450.1-2640.6',1.30658,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86415,'GRB','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86415,44.31,0.57,3150,35744,70,NULL,NULL,'VLA J115450.1-2640.6',1.30658,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86416,'GRB','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86416,44.87,0.22,4080,35744,69.7,NULL,'Calibrated','VLA J115450.1-2640.6',1.30658,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86417,'GRB','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86417,44.81,0.07,9160,35744,NULL,NULL,NULL,'VLA J115450.1-2640.6',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86418,'GRB','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86418,44.82,0.26,9200,35744,NULL,NULL,NULL,'VLA J115450.1-2640.6',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86419,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86419,35.94,0.48,154,35745,70,NULL,NULL,'AM 1152-311 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000097,NULL,'15.5',0.3,'INTERACTING',NULL,NULL,NULL,NULL,1,178.714417,-31.57353,0.281,NULL,41443031835,647547372,10117927,15.5),(86420,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86420,36.91,0.23,241,35746,70,NULL,NULL,'2MASX J11545174+4330280',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,178.71575,43.50786,0,NULL,60401961635,943780650,14746572,17.8),(86421,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86421,37.04,0.33,256,35747,70,NULL,NULL,'2MASX J11545196+4950547',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000184,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,178.716583333,49.84839,0.029,NULL,61744692401,964760818,15074387,16.3),(86422,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86422,38.15,0.46,426,35748,70,NULL,NULL,'2MASX J11545225+4713070',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000196,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,178.717875,47.21881,0,NULL,61741553098,964711767,15073621,17.8),(86423,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86423,37.55,0.46,324,35749,70,NULL,NULL,'2MASX J11545230+5237097',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,178.717958333,52.61931,0,NULL,61766700762,965104699,15079760,17.4),(86424,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86424,37.96,0.16,391,35750,70,NULL,NULL,'2MASX J11545255+1239446',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000177,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,178.719,12.66247,0,NULL,60233391627,941146744,14705417,17.7),(86425,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86425,37.4,0.46,302,35751,70,NULL,NULL,'2MASX J11545276+1003522',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000177,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,178.7199583,10.06458,0,NULL,60365008550,943203258,14737550,17.3),(86426,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86426,37.62,0.46,335,35752,70,NULL,NULL,'2MASX J11545304+2613204',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,178.721166667,26.22247,0.008,NULL,60540404069,945943813,14780372,17.4),(86427,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86427,37.31,0.46,290,35753,70,NULL,NULL,'2MASX J11545322+3602128',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000151,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,178.721583,36.03678,0,NULL,60446828326,944481692,14757526,17.2),(86428,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86428,38.42,0.46,484,35754,70,NULL,NULL,'2MASX J11545344+4828037',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,178.722625,48.46778,0.078,NULL,61747048819,964797637,15074963,17.8),(86429,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86429,36.95,0.46,245,35755,70,NULL,NULL,'2MASX J11545373+5020087',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000181,NULL,'16.2g',0.32,'E0',NULL,NULL,NULL,NULL,1,178.723833,50.33575,0.025,NULL,61744752970,964761765,15074402,16.2),(86430,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86430,38,0.46,398,35756,70,NULL,NULL,'SDSS J115454.12+571301.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000157,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,178.7255417,57.217,0,NULL,61841636011,966275562,15098055,18.4),(86431,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86431,35.83,0.27,146,35757,70,NULL,NULL,'2MASX J11545464+2455294',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000186,NULL,'16.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,178.72775,24.925,0,NULL,60547683083,946057548,14782149,16),(86432,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86432,37.3,0.46,288,35758,70,NULL,NULL,'2MASX J11545515+3153152',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,178.72975,31.88747,0.036,NULL,60553103132,946142236,14783472,17.4),(86433,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86433,38,0.46,398,35759,70,NULL,NULL,'2MASX J11545605+1639026',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000175,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,178.733625,16.65075,0.098,NULL,60251690350,941432661,14709885,17.8),(86434,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86434,37.28,0.46,285,35760,70,NULL,NULL,'SDSS J115456.10+311334.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,178.73375,31.22611,0.017,NULL,60551838856,946122482,14783163,17.8),(86435,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86435,37.55,0.46,324,35761,70,NULL,NULL,'2MASX J11545659+4423570',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000186,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,178.7357917,44.39917,0,NULL,63888238053,998253719,15597714,17),(86436,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86436,37.59,0.46,330,35762,70,NULL,NULL,'2MASX J11545688+0616392',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000176,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,178.736875,6.27758,0,NULL,60158303623,939973494,14687085,16.8),(86437,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86437,38.12,0.46,420,35763,70,NULL,NULL,'2MASX J11545715+0325221',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000104,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,178.738167,3.42275,0.042,NULL,60137077689,939641838,14681903,17.7),(86438,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86438,38.25,0.46,446,35764,70,NULL,NULL,'SDSS J115457.87+431820.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000143,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,178.741167,43.30575,0,NULL,60402134775,943783355,14746614,18.4),(86439,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86439,37.58,0.46,328,35765,70,NULL,NULL,'2MASX J11545819+6455386',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000187,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,178.742791667,64.92728,0.021,NULL,61821129618,965955150,15093049,17),(86440,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86440,37.95,0.33,389,35766,70,NULL,NULL,'2MASX J11550101+0951292',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,178.754291667,9.85817,0,NULL,60146606096,939790720,14684230,17.7),(86441,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86441,35.78,0.37,143,35767,NULL,NULL,'Malmquist cor.','ESO 266- G 032',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.96',0.3,'S...',NULL,NULL,NULL,NULL,1,178.7545417,-47.44589,0.421,NULL,39999596744,624993699,9765526,15.96),(86442,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86442,35.94,0.35,154,35767,NULL,NULL,NULL,'ESO 266- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86443,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86443,35.98,0.2,157,35767,74.4,NULL,NULL,'ESO 266- G 032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86444,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86444,35.55,0.46,129,35768,70,NULL,NULL,'2MASX J11550160+3738288',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00016,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,178.756708333,37.64122,0,NULL,60439913210,944373643,14755838,16.2),(86445,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86445,37.04,0.33,256,35769,70,NULL,NULL,'2MASX J11550187+4953587',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000202,NULL,'15.9g',0.41,'E0',NULL,NULL,NULL,NULL,1,178.757583,49.89956,0.029,NULL,61744685038,964760703,15074385,15.9),(86446,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86446,37.42,0.46,305,35770,70,NULL,NULL,'2MASX J11550241+0034214',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00007,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,178.760083,0.57272,0.033,NULL,60133131811,939580184,14680940,17.9),(86447,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86447,38.61,0.46,526,35771,70,NULL,NULL,'SDSS J115502.56+134632.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000146,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,178.7607083,13.77561,0.046,NULL,60245356203,941333690,14708338,18.7),(86448,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86448,38.15,0.46,426,35772,70,NULL,NULL,'LCRS B115229.9-032458',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000117,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,178.7650417,-3.69475,0.033,NULL,40814170112,637721408,9964397,17.6),(86449,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86449,37.23,0.46,279,35773,70,NULL,NULL,'SDSS J115503.89+514724.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,178.7662083,51.79014,0.069,NULL,61766108198,965095440,15079616,18.2),(86450,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86450,36.94,0.46,245,35774,70,NULL,NULL,'2MASX J11550420+4545183',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000179,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,178.767416667,45.75514,0,NULL,61740803456,964700054,15073438,16.9),(86451,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86451,38.14,0.46,425,35775,70,NULL,NULL,'SDSS J115504.65+002212.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000064,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,178.769417,0.37003,0.029,NULL,60133195910,939581186,14680956,18.3),(86452,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86452,32.14,NULL,26.8,35776,NULL,NULL,NULL,'CGCG 012-116',NULL,'2015AstBu..70....1K',2015,1,0.59,NULL,'G',0.000077,NULL,'15.2g',0.39,'S0','Isolated galaxy',NULL,NULL,NULL,1,178.7704583,1.71981,0,NULL,60144767242,939761988,14683781,15.2),(86453,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86453,37.86,0.46,373,35777,70,NULL,NULL,'2MASX J11550624+6736114',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000081,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,178.77625,67.60325,0,NULL,62075922590,969936290,15155254,17.6),(86454,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86454,35.68,0.46,137,35778,70,NULL,NULL,'2MASX J11550706+5514334',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000183,NULL,'16.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,178.779208333,55.24275,0,NULL,61760411560,965006430,15078225,16.2),(86455,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86455,37.08,0.46,261,35779,70,NULL,NULL,'2MASX J11550767-0218112',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000125,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,178.7817917,-2.30308,0.033,NULL,40816513178,637758018,9964969,17.7),(86456,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86456,35.78,0.51,143,35780,70,NULL,NULL,'2MASX J11550841-2238586',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.39',NULL,NULL,NULL,NULL,NULL,NULL,1,178.785167,-22.64981,0.181,NULL,41675228007,651175437,10174616,16.39),(86457,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86457,36.11,0.46,167,35781,70,NULL,NULL,'2MASX J11550892+1049402',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000174,NULL,'15.6g',0.5,'E0',NULL,NULL,NULL,NULL,1,178.7872917,10.82775,0,NULL,60364777431,943199647,14737494,15.6),(86458,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86458,37.07,0.46,259,35782,70,NULL,NULL,'2MASX J11550906+1150592',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,178.787833,11.84989,0,NULL,60233817255,941153394,14705521,17),(86459,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86459,33.66,0.49,53.9,35783,70,NULL,NULL,'NGC 3967',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000107,NULL,'14.27',1.1,'(R\')S0-:',NULL,NULL,NULL,NULL,1,178.793333,-7.84378,0.121,NULL,40851272403,638301131,9973455,14.27),(86460,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86460,37.08,0.46,261,35784,70,NULL,NULL,'SDSS J115511.29+002026.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00007,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,178.7970417,0.34061,0.029,NULL,60132971156,939577674,14680901,17.9),(86461,'IRAS','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86461,34.97,0.8,98.6,35785,75,NULL,'A82, H','UGC 06886',NULL,'1997ApJS..109..333W',1997,1,1.35,NULL,'G',0.00002,NULL,'14.1g',0.88,'SB(rs)bc pec','Group member of poor cluster',NULL,NULL,NULL,1,178.7972083,6.169,0,NULL,60158316823,939973700,14687089,14.1),(86462,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86462,34.47,0.33,78.3,35785,91,NULL,'H','UGC 06886',NULL,'1984ApJ...278..475B',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86463,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86463,35.04,0.47,102,35785,75,NULL,'A82, H, raw','UGC 06886',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86464,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86464,35.14,0.4,107,35785,NULL,NULL,'mean','UGC 06886',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86465,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86465,35.16,0.47,108,35785,NULL,NULL,'H','UGC 06886',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86466,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86466,35.25,0.47,112,35785,75,NULL,'A82, H, inv','UGC 06886',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86467,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86467,35.3,0.45,115,35785,NULL,NULL,'K','UGC 06886',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86468,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86468,35.31,0.46,115,35785,NULL,NULL,'J','UGC 06886',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86469,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86469,35.32,0.47,116,35785,75,NULL,'A82, H, cor','UGC 06886',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86470,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86470,36.71,0.46,220,35786,70,NULL,NULL,'2MASX J11551192+0159314',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000213,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,178.799667,1.99192,0.009,NULL,60144922606,939764415,14683818,17),(86471,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86471,38.31,0.46,459,35787,70,NULL,NULL,'SDSS J115513.03+521732.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,178.804333,52.29239,0.02,NULL,61769086398,965141974,15080343,18.2),(86472,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86472,38.17,0.46,430,35788,70,NULL,NULL,'2MASX J11551394+5548585',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000176,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,178.8082083,55.81625,0,NULL,61757879009,964966859,15077607,17.4),(86473,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86473,32.66,NULL,34.1,35789,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -01-30-048',NULL,'2010Ap&SS.325..163P',2010,1,2.13,'The APM position is on the northeast end of the spindle.','G',0.000027,NULL,'16.62',0.13,'Sd',NULL,NULL,NULL,NULL,1,178.8085,-6.45547,0.085,NULL,40844001055,638187516,9971679,16.62),(86474,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86474,32.66,NULL,34.1,35789,NULL,NULL,'Dipole + Quadrupole','MCG -01-30-048',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86475,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86475,32.67,NULL,34.2,35789,NULL,NULL,'Dipole','MCG -01-30-048',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86476,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86476,35.83,0.27,146,35790,70,NULL,NULL,'2MASX J11551401+2454511',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000081,NULL,'16.0g',0.31,NULL,NULL,NULL,NULL,NULL,1,178.808416667,24.91433,0,NULL,60547901957,946060968,14782202,16),(86477,'D-Sigma','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86477,33.04,0.4,40.5,35791,75,NULL,'Edat, raw','IC 2977',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.00005,NULL,'13.19',1,'I0?            HII?','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,178.811083,-37.69631,0.373,NULL,41368393719,646381151,10099705,13.19),(86478,'D-Sigma','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86478,33.37,0.4,47.3,35791,75,NULL,'Edat, cor','IC 2977',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86479,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86479,35.31,0.46,115,35792,70,NULL,NULL,'CGCG 292-045',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000178,NULL,'15.1g',0.47,'E0',NULL,NULL,NULL,NULL,1,178.8122917,59.31897,0.005,NULL,61855584942,966493514,15101461,15.1),(86480,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86480,37,0.46,251,35793,70,NULL,NULL,'2MASX J11551573+6616024',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000102,NULL,'16.1g',0.38,'E0',NULL,NULL,NULL,NULL,1,178.815667,66.26736,0.029,NULL,61810931931,965795811,15090559,16.1),(86481,'IRAS','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86481,34.86,0.8,93.9,35794,75,NULL,'W91CL, r','UGC 06891',NULL,'1997ApJS..109..333W',1997,1,1.65,NULL,'G',0.000047,NULL,'15.2g',0.35,'Sab',NULL,NULL,NULL,NULL,1,178.81975,17.48758,0.113,NULL,60208654883,940760232,14699378,15.2),(86482,'IRAS','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86482,34.87,0.8,94.2,35794,75,NULL,'HMCL, I','UGC 06891',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86483,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86483,34.52,0.4,80.1,35794,75,NULL,'HMCL, I, raw','UGC 06891',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86484,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86484,34.57,0.2,82,35794,74.4,NULL,NULL,'UGC 06891',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86485,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86485,34.58,0.43,82.6,35794,75,NULL,'3.6 micron, color corrected','UGC 06891',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86486,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86486,34.67,0.43,86,35794,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06891',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86487,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86487,34.68,0.4,86.4,35794,75,NULL,'HMCL, I, inv','UGC 06891',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86488,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86488,34.73,0.38,88.4,35794,75,NULL,'W91CL, r, raw','UGC 06891',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86489,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86489,34.8,0.4,91,35794,75,NULL,'HMCL, I, cor','UGC 06891',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86490,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86490,34.85,0.38,93.5,35794,75,NULL,'W91CL, r, inv','UGC 06891',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86491,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86491,34.95,0.38,97.5,35794,75,NULL,'W91CL, r, cor','UGC 06891',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86492,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86492,34.97,0.14,98.8,35794,NULL,NULL,NULL,'UGC 06891',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86493,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86493,38.28,0.46,452,35795,70,NULL,NULL,'2MASX J11551679+5421115',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000177,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,178.819875,54.35308,0,NULL,61759833276,964997394,15078084,17.7),(86494,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86494,38.7,0.46,551,35796,70,NULL,NULL,'SDSS J115517.45+302208.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00014,NULL,'18.6g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,178.82275,30.369,0,NULL,60563222352,946300349,14785942,18.6),(86495,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86495,38.06,0.33,410,35797,70,NULL,NULL,'2MASX J11551835+2626231',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,178.8265,26.43983,0.008,NULL,60540556524,945946195,14780409,17.7),(86496,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86496,38.29,0.46,456,35798,70,NULL,NULL,'2MASX J11551860+4347484',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000165,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,178.8272917,43.79672,0,NULL,60398319589,943723743,14745683,17),(86497,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86497,38.2,0.46,437,35799,70,NULL,NULL,'2MASX J11551880+1203154',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00017,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,178.8282083,12.05425,0,NULL,60234301119,941160954,14705639,18),(86498,'SZ effect','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86498,38.4,NULL,478,35800,NULL,NULL,NULL,'ABELL 1413',NULL,'2005ApJ...625..108D',2005,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I      [BM]',NULL,NULL,NULL,NULL,1,178.82875,23.40861,0.022,NULL,60536163797,945877559,14779336,NULL),(86499,'SZ effect','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86499,38.58,NULL,520,35800,NULL,NULL,NULL,'ABELL 1413',NULL,'2011A&A...532A..14C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86500,'SZ effect','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86500,38.79,NULL,573,35800,NULL,NULL,NULL,'ABELL 1413',NULL,'2002ApJ...581...53R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86501,'SZ effect','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86501,38.85,NULL,588,35800,NULL,NULL,'3.1 (red) calibration','ABELL 1413',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86502,'SZ effect','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86502,38.91,NULL,605,35800,NULL,NULL,'4.2 (black) calibration','ABELL 1413',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86503,'SZ effect','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86503,38.96,0.61,620,35800,NULL,NULL,'Isotherm., r < 100 kpc','ABELL 1413',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86504,'SZ effect','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86504,38.96,0.65,620,35800,NULL,NULL,'Isotherm.','ABELL 1413',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86505,'SZ effect','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86505,39.19,NULL,690,35800,NULL,NULL,'4.1 (blue) calibration','ABELL 1413',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86506,'SZ effect','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86506,39.22,0.74,697,35800,NULL,NULL,NULL,'ABELL 1413',NULL,'2002MNRAS.333..318G',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86507,'SZ effect','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86507,39.46,0.46,780,35800,NULL,NULL,'Hydrost. Eq.','ABELL 1413',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86508,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86508,34.54,NULL,80.8,35801,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06889',NULL,'2010Ap&SS.325..163P',2010,1,1.16,NULL,'G',0.000127,NULL,'16.8g',0.13,'Sb(f)',NULL,NULL,NULL,NULL,1,178.8294583,67.40256,0.017,NULL,61807376514,965740258,15089691,16.8),(86509,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86509,34.55,NULL,81.3,35801,NULL,NULL,'Dipole + Quadrupole','UGC 06889',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86510,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86510,34.56,NULL,81.7,35801,NULL,NULL,'Dipole','UGC 06889',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86511,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86511,34.6,NULL,83.1,35801,NULL,NULL,NULL,'UGC 06889',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86512,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86512,38.33,0.46,463,35802,70,NULL,NULL,'SDSS J115519.93-021242.1',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000174,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,178.833083,-2.21172,0.013,NULL,40816671058,637760485,9965007,17.9),(86513,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86513,37.69,0.46,346,35803,70,NULL,NULL,'2MASX J11551999+1111159',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000158,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,178.833208333,11.18781,0.006,NULL,60364913641,943201775,14737527,17.5),(86514,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86514,36.13,0.46,168,35804,70,NULL,NULL,'2MASX J11552076+2243557',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000097,NULL,'16.93',0.21,NULL,NULL,NULL,NULL,NULL,1,178.8365417,22.73219,0.042,NULL,60532950802,945827356,14778552,16.93),(86515,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86515,36.63,0.46,212,35805,70,NULL,NULL,'2MASX J11552088+1621144',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,178.8369583,16.35408,0.086,NULL,60251984188,941437252,14709957,16.8),(86516,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86516,37.39,0.16,300,35806,70,NULL,NULL,'2MASX J11552145+5251438',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000171,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,178.8392917,52.86225,0,NULL,61767191394,965112365,15079880,17),(86517,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86517,37.17,0.46,272,35807,70,NULL,NULL,'2MASX J11552150+3538116',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,178.83975,35.63653,0,NULL,60433045198,944266331,14754161,17.1),(86518,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86518,37.6,0.46,331,35808,70,NULL,NULL,'2MASX J11552258+1051349',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.10',0.16,NULL,NULL,NULL,NULL,NULL,1,178.844125,10.85972,0,NULL,60365244229,943206941,14737608,18.1),(86519,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86519,31.2,0.43,17.4,35809,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06894',NULL,'2014MNRAS.444..527S',2014,1,1.84,'Multiple SDSS entries describe this object.','G',0.000006,NULL,'14.9g',0.32,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,178.847875,54.65733,0,NULL,61759371783,964990184,15077971,14.9),(86520,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86520,31.43,0.43,19.3,35809,75,NULL,'3.6 micron, color corrected','UGC 06894',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86521,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86521,31.56,0.2,20.5,35809,74.4,NULL,NULL,'UGC 06894',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86522,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86522,36.87,0.46,236,35810,70,NULL,NULL,'2MASX J11552388+5353585',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00019,NULL,'15.7g',0.43,'E0',NULL,NULL,NULL,NULL,1,178.849417,53.89953,0,NULL,61770643282,965166301,15080723,15.7),(86523,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86523,37.51,0.46,317,35811,70,NULL,NULL,'2MASX J11552389+1013509',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000163,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,178.8495,10.23086,0,NULL,60365190222,943206097,14737595,16.6),(86524,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86524,32.88,0.52,37.6,35812,70,NULL,NULL,'ESO 217- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00012,NULL,'14.3',0.5,'IB(s)m:',NULL,NULL,NULL,NULL,1,178.852125,-50.30106,0.429,NULL,40006132443,625095819,9767122,14.3),(86525,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86525,33.86,0.69,59,35813,100,NULL,'mid-IR','NGC 3968',NULL,'2013ApJ...771...88L',2013,1,2.35,NULL,'G',0.000004,NULL,'13.1g',1.16,'SAB(rs)bc','Group member',NULL,NULL,NULL,1,178.869583,11.96836,0,NULL,60233777778,941152777,14705512,13.1),(86526,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86526,34.49,0.47,78.9,35813,NULL,NULL,'H','NGC 3968',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86527,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86527,34.53,0.45,80.5,35813,NULL,NULL,'K','NGC 3968',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86528,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86528,34.56,0.46,81.6,35813,NULL,NULL,'J','NGC 3968',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86529,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86529,34.7,0.31,87,35813,NULL,NULL,'Malmquist cor.','NGC 3968',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86530,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86530,34.73,0.3,88.2,35813,NULL,NULL,NULL,'NGC 3968',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86531,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86531,34.74,0.2,88.7,35813,74.4,NULL,NULL,'NGC 3968',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86532,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86532,34.95,0.4,97.5,35813,NULL,NULL,'mean','NGC 3968',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86533,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86533,36.07,0.46,164,35814,70,NULL,NULL,'CGCG 186-069',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000127,NULL,'15.1g',0.52,NULL,NULL,NULL,NULL,NULL,1,178.877333,37.40761,0,NULL,60438952337,944358630,14755603,15.1),(86534,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86534,37.13,0.46,267,35815,70,NULL,NULL,'2MASX J11553075+4110015',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,178.877917,41.16703,0,NULL,60407771830,943871434,14747991,17.6),(86535,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86535,37.35,0.16,296,35816,70,NULL,NULL,'2MASX J11553100+4356063',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,178.879208333,43.93511,0,NULL,60398330424,943723912,14745686,17.5),(86536,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86536,37.54,0.1,322,35817,70,NULL,NULL,'SDSS J115531.21+045114.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,178.880041667,4.85392,0,NULL,60188985342,940452895,14694576,18),(86537,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86537,36.82,0.27,231,35818,70,NULL,NULL,'MCG +09-20-030',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000205,NULL,'15.9g',0.3,'S0/a?',NULL,NULL,NULL,NULL,1,178.8807917,54.86678,0,NULL,61760521281,965008145,15078252,15.9),(86538,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86538,36.82,0.27,231,35819,70,NULL,NULL,'2MASX J11553166+5453565',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.00011,NULL,'15.1g',0.48,NULL,NULL,NULL,NULL,NULL,1,178.8819583,54.89889,0,NULL,61760514387,965008037,15078250,15.1),(86539,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86539,36.37,0.46,188,35820,70,NULL,NULL,'2MASX J11553278+1340454',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.00018,NULL,'15.5g',0.44,NULL,NULL,NULL,NULL,NULL,1,178.886541667,13.67919,0.037,NULL,60245706843,941339169,14708424,15.5),(86540,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86540,38.71,0.46,552,35821,70,NULL,NULL,'SDSS J115533.76+240638.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00016,NULL,'18.6g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,178.890708333,24.11069,0.006,NULL,60533620617,945837822,14778715,18.6),(86541,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86541,36.93,0.46,244,35822,70,NULL,NULL,'2MASX J11553488+0251394',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000083,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,178.895333,2.86094,0.088,NULL,60136389685,939631088,14681735,16.6),(86542,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86542,34.3,0.46,72.6,35823,70,NULL,NULL,'NGC 3971',NULL,'2015arXiv151105856S',2015,1,1.06,NULL,'G',0.000173,NULL,'13.7g',0.99,'S0','Possible field galaxy',NULL,NULL,NULL,1,178.901625,29.99592,0,NULL,60558926372,946233224,14784894,13.7),(86543,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86543,38.04,0.46,405,35824,70,NULL,NULL,'2MASX J11553648+2314116',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.44',0.17,'BrClG','Group member',NULL,NULL,NULL,1,178.901917,23.2365,0.022,NULL,60535734193,945870846,14779231,18.44),(86544,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86544,32.42,0.4,30.5,35825,75,NULL,'B','UGC 06903',NULL,'1988NBGC.C....0000T',1988,1,1.59,NULL,'G',0.000017,NULL,'14.4g',1.53,'SB(s)cd','Isolated galaxy',NULL,NULL,NULL,1,178.903916667,1.23717,0.009,NULL,60132912444,939576756,14680886,14.4),(86545,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86545,36.84,0.46,233,35826,70,NULL,NULL,'2MASX J11553846+6645344',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000087,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,178.909875,66.75969,0,NULL,61808070393,965751099,15089860,16.9),(86546,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86546,37.35,0.16,296,35827,70,NULL,NULL,'2MASX J11553937+4403043',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000174,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,178.9139583,44.05128,0,NULL,60398325209,943723831,14745684,16.6),(86547,'Tully est','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86547,28.84,0.8,5.9,35828,75,NULL,'B','UGC 06900',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.000017,NULL,'14.80',1.3,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,178.915417,31.51847,0.019,NULL,60551777249,946121519,14783148,14.8),(86548,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86548,31.1,NULL,16.6,35828,NULL,NULL,NULL,'UGC 06900',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86549,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86549,37.09,0.46,261,35829,70,NULL,NULL,'2MASX J11553988+0022114',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000064,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,178.916125,0.36986,0.025,NULL,60133182847,939580981,14680952,17.4),(86550,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86550,33.77,0.51,56.6,35830,70,NULL,NULL,'NGC 3974',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00011,NULL,'14.38',1.1,'(R\')SB(r)0/a: LINER?',NULL,NULL,NULL,NULL,1,178.91725,-12.02744,0.069,NULL,40957346604,639958540,9999352,14.38),(86551,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86551,36.38,0.46,189,35831,70,NULL,NULL,'2MASX J11554127+2418371',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000147,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,178.922083,24.31036,0,NULL,60533764439,945840069,14778751,17.2),(86552,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86552,35.65,NULL,135,35832,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1332',NULL,'2010Ap&SS.325..163P',2010,1,1.36,NULL,'G',0.000018,NULL,'16.4g',0.14,'Sdm',NULL,NULL,NULL,NULL,1,178.925917,24.92019,0,NULL,60547896293,946060879,14782201,16.4),(86553,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86553,35.68,NULL,137,35832,NULL,NULL,'Dipole + Quadrupole','FGC 1332',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86554,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86554,35.71,NULL,139,35832,NULL,NULL,'Dipole','FGC 1332',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86555,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86555,35.74,0.49,140,35832,75,NULL,'IR','FGC 1332',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86556,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86556,35.88,NULL,150,35832,NULL,NULL,NULL,'FGC 1332',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86557,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86557,36.21,0.2,175,35832,74.4,NULL,NULL,'FGC 1332',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86558,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86558,37.53,0.46,321,35833,70,NULL,NULL,'2MASXi J1155431-012407',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000143,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,178.9295417,-1.40203,0.025,NULL,40805351640,637583619,9962244,17.8),(86559,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86559,37.49,0.19,314,35834,70,NULL,NULL,'2MASX J11554354+1130339',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000177,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,178.931375,11.50947,0,NULL,60230950532,941108602,14704821,16.5),(86560,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86560,37.95,0.46,389,35835,70,NULL,NULL,'2MASX J11554362+4415042',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000173,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,178.9315,44.25111,0,NULL,60398920068,943733126,14745830,17.6),(86561,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86561,37.89,0.46,378,35836,70,NULL,NULL,'2MASX J11554385+0748460',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000186,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,178.932667,7.81267,0,NULL,60160969613,940015150,14687736,17.3),(86562,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86562,37.64,0.46,338,35837,70,NULL,NULL,'2MASX J11554386+4723369',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000149,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,178.9329583,47.39367,0.013,NULL,61742146828,964721044,15073766,17.2),(86563,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86563,37.49,0.19,314,35838,70,NULL,NULL,'SDSS J115544.04+112307.7',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,178.9335,11.3855,0,NULL,60230973340,941108958,14704827,18.1),(86564,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86564,37.36,0.46,297,35839,70,NULL,NULL,'2MASX J11554402+0301004',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00008,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,178.933583333,3.01686,0.088,NULL,60136399308,939631239,14681738,17.4),(86565,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86565,37.35,0.16,296,35840,70,NULL,NULL,'2MASX J11554440+4333399',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,178.9349583,43.56097,0,NULL,60401946873,943780419,14746569,17.4),(86566,'IRAS','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86566,34.67,0.8,86,35841,75,NULL,'W91CL, r','LSBC F572-02',NULL,'1997ApJS..109..333W',1997,1,0.53,NULL,'G',0.000033,NULL,'15.3g',0.41,'S0:',NULL,NULL,NULL,NULL,1,178.9365,17.88814,0.098,NULL,60209173568,940768337,14699505,15.3),(86567,'IRAS','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86567,34.68,0.8,86.3,35841,75,NULL,'HMCL, I','LSBC F572-02',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86568,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86568,34.83,0.2,92.5,35841,74.4,NULL,NULL,'LSBC F572-02',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86569,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86569,34.86,0.43,93.9,35841,75,NULL,'3.6 micron, color corrected','LSBC F572-02',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86570,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86570,34.87,0.4,94,35841,75,NULL,'HMCL, I, raw','LSBC F572-02',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86571,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86571,34.87,0.38,94,35841,75,NULL,'W91CL, r, raw','LSBC F572-02',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86572,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86572,34.93,0.14,97,35841,NULL,NULL,NULL,'LSBC F572-02',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86573,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86573,34.96,0.38,98.1,35841,75,NULL,'W91CL, r, inv','LSBC F572-02',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86574,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86574,34.96,0.43,98.3,35841,75,NULL,'3.6 micron, color + selection bias corrected','LSBC F572-02',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86575,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86575,35,0.4,100,35841,75,NULL,'HMCL, I, inv','LSBC F572-02',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86576,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86576,35.05,0.38,102,35841,75,NULL,'W91CL, r, cor','LSBC F572-02',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86577,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86577,35.05,0.4,103,35841,75,NULL,'HMCL, I, cor','LSBC F572-02',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86578,'SNIa','2016-12-15 15:14:52','2016-12-16 11:20:01','1','SN 2011by',NULL,86578,32.01,0.07,25.2,35842,70,NULL,'SiFTO+SALT2, SN 2011by','NGC 3972',0.002843,'2012MNRAS.426.2359M',2012,1,3.4,'One of two 6cm sources associated with [WB92] 1154+5537','G',0.000005,NULL,'13.1g',0.77,'SA(s)bc','in a radial-velocity based grouping',NULL,NULL,NULL,1,178.937875,55.32075,0,NULL,61757592934,964962389,15077537,13.1),(86579,'IRAS','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86579,31.05,0.8,16.2,35842,75,NULL,'A82, H','NGC 3972',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86580,'IRAS','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86580,31.13,0.8,16.9,35842,75,NULL,'W91CL, r','NGC 3972',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86581,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86581,31.15,0.4,17,35842,75,NULL,'B','NGC 3972',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86582,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86582,31.19,NULL,17.3,35842,NULL,NULL,'B','NGC 3972',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86583,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86583,31.28,NULL,18,35842,NULL,NULL,'I','NGC 3972',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86584,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86584,31.34,0.36,18.5,35842,NULL,NULL,NULL,'NGC 3972',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86585,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86585,31.34,0.4,18.5,35842,75,NULL,NULL,'NGC 3972',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86586,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86586,31.37,0.47,18.8,35842,75,NULL,'A82, H, inv','NGC 3972',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86587,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86587,31.37,0.4,18.8,35842,NULL,NULL,'mean','NGC 3972',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86588,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86588,31.4,0.47,19,35842,75,NULL,'A82, H, raw','NGC 3972',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86589,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86589,31.45,0.38,19.5,35842,75,NULL,'W91CL, r, raw','NGC 3972',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86590,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86590,31.47,0.38,19.7,35842,75,NULL,'W91CL, r, inv','NGC 3972',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86591,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86591,31.5,0.43,20,35842,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3972',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86592,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86592,31.51,0.43,20.1,35842,75,NULL,'3.6 micron, color corrected','NGC 3972',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86593,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86593,31.53,NULL,20.2,35842,NULL,NULL,'B, Hubble-type-TF','NGC 3972',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86594,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86594,31.55,0.2,20.4,35842,74.4,NULL,NULL,'NGC 3972',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86595,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86595,31.58,0.38,20.7,35842,75,NULL,'W91CL, r, cor','NGC 3972',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86596,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86596,31.63,0.49,21.2,35842,75,NULL,'IR','NGC 3972',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86597,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86597,31.66,0.47,21.5,35842,75,NULL,'A82, H, cor','NGC 3972',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86598,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86598,31.68,0.46,21.7,35842,NULL,NULL,'J','NGC 3972',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86599,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86599,31.69,0.47,21.8,35842,NULL,NULL,'H','NGC 3972',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86600,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86600,31.7,NULL,21.9,35842,NULL,NULL,'B','NGC 3972',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86601,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86601,31.71,NULL,22,35842,NULL,NULL,'I, Hubble-type-TF','NGC 3972',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86602,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86602,31.81,NULL,23,35842,NULL,NULL,'I','NGC 3972',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86603,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86603,31.82,0.45,23.2,35842,NULL,NULL,'K','NGC 3972',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86604,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86604,37.38,0.46,299,35843,70,NULL,NULL,'2MASX J11554519+4453439',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000209,NULL,'15.9g',0.45,'E0',NULL,NULL,NULL,NULL,1,178.938083,44.89547,0,NULL,63887804391,998246943,15597608,15.9),(86605,'BCG','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86605,38.45,0.35,452,35844,60,NULL,NULL,'ABELL 1412',0.0839,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,178.938625,73.47175,0.041,NULL,61362882400,958795037,14981172,NULL),(86606,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86606,36.55,0.46,204,35845,70,NULL,NULL,'2MASX J11554545+5440334',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000157,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,178.9394583,54.67592,0,NULL,61759368220,964990128,15077970,16.7),(86607,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86607,37.6,0.46,331,35846,70,NULL,NULL,'2MASX J11554597+2916231',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00016,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,178.9417083,29.27314,0,NULL,60561528735,946273886,14785529,17.5),(86608,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86608,36.89,0.46,239,35847,70,NULL,NULL,'2MASX J11554623+0545234',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,178.9425,5.75658,0,NULL,60155471562,939929243,14686394,17.4),(86609,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86609,37.96,0.16,391,35848,70,NULL,NULL,'2MASX J11554640+1242523',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000194,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,178.943375,12.71447,0,NULL,60231614786,941118981,14704984,18.1),(86610,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86610,34.85,0.49,93.5,35849,75,NULL,'IR','UGC 06905',NULL,'2011yCatp016004901K',2011,1,1.45,NULL,'G',0.000033,NULL,'15.6g',0.25,'Sc',NULL,NULL,NULL,NULL,1,178.944333,29.94144,0,NULL,60558879339,946232489,14784882,15.6),(86611,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86611,35.08,NULL,104,35849,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06905',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86612,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86612,35.09,NULL,104,35849,NULL,NULL,'Dipole + Quadrupole','UGC 06905',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86613,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86613,35.1,NULL,105,35849,NULL,NULL,'Dipole','UGC 06905',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86614,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86614,35.13,NULL,106,35849,NULL,NULL,NULL,'UGC 06905',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86615,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86615,37.37,0.27,298,35850,70,NULL,NULL,'2MASX J11554684+2117096',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'18.46',0.12,NULL,NULL,NULL,NULL,NULL,1,178.945333,21.28606,0.127,NULL,60197148138,940580439,14696569,18.46),(86616,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86616,36.59,0.46,208,35851,70,NULL,NULL,'2MASX J11554714+0814400',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,178.9462917,8.24433,0,NULL,60160388794,940006074,14687594,17.1),(86617,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86617,36.82,0.27,231,35852,70,NULL,NULL,'2MASX J11554728+5453222',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,178.946833,54.88947,0,NULL,61760520661,965008135,15078252,17.4),(86618,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86618,36.43,0.46,193,35853,70,NULL,NULL,'VIII Zw 154',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000199,NULL,'16.2g',0.3,'S0^-',NULL,NULL,NULL,NULL,1,178.9474583,9.68069,0,NULL,60150169987,939846406,14685100,16.2),(86619,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86619,39.14,0.46,672,35854,70,NULL,NULL,'SDSS J115547.66+335649.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000174,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,178.948583,33.94703,0,NULL,60432131436,944252053,14753938,18.2),(86620,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86620,38.08,0.46,412,35855,70,NULL,NULL,'SDSS J115548.55+044918.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,178.952333333,4.82172,0.02,NULL,60188875769,940451183,14694549,18.4),(86621,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86621,37.75,0.27,355,35856,70,NULL,NULL,'2MASX J11554877+2719311',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,178.953333,27.32528,0,NULL,60536841299,945888145,14779502,17.5),(86622,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86622,37.75,0.27,355,35857,70,NULL,NULL,'2MASX J11554914+2719161',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,178.9547083,27.32119,0,NULL,60536841329,945888145,14779502,17.4),(86623,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86623,36.93,0.46,243,35858,70,NULL,NULL,'2MASX J11554950+3612425',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000188,NULL,'16.1g',0.39,NULL,NULL,NULL,NULL,NULL,1,178.956333333,36.21203,0,NULL,60447090847,944485794,14757590,16.1),(86624,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86624,38.06,0.33,410,35859,70,NULL,NULL,'2MASX J11555025+2626351',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,178.959333,26.44314,0,NULL,60540540107,945945939,14780405,17.6),(86625,'IRAS','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86625,31.66,0.8,21.5,35860,75,NULL,'MAT, I','ESO 572- G 018',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000028,NULL,'14.00',0.8,'SB(rs)c:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,178.960917,-18.1965,0.049,NULL,40943877121,639748080,9996063,14),(86626,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86626,31.47,0.32,19.7,35860,85,NULL,'I, inv','ESO 572- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86627,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86627,31.49,0.32,19.9,35860,85,NULL,'I, raw','ESO 572- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86628,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86628,31.59,0.4,20.8,35860,NULL,NULL,NULL,'ESO 572- G 018',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86629,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86629,31.76,0.49,22.5,35860,NULL,NULL,'Malmquist cor.','ESO 572- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86630,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86630,31.93,0.43,24.3,35860,75,NULL,'MAT, I, raw','ESO 572- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86631,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86631,31.93,0.43,24.3,35860,75,NULL,'MAT, I, inv','ESO 572- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86632,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86632,32.07,0.43,25.9,35860,75,NULL,'MAT, I, cor','ESO 572- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86633,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86633,32.19,0.4,27.4,35860,NULL,NULL,NULL,'ESO 572- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86634,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86634,32.23,0.2,27.9,35860,74.4,NULL,NULL,'ESO 572- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86635,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86635,32.24,0.4,28.1,35860,NULL,NULL,'mean','ESO 572- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86636,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86636,32.79,0.47,36.1,35860,NULL,NULL,'H','ESO 572- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86637,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86637,37.59,0.21,330,35861,70,NULL,NULL,'2MASX J11555187+5205171',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,178.966375,52.08828,0.02,NULL,61769165153,965143205,15080362,17),(86638,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86638,37.49,0.19,314,35862,70,NULL,NULL,'2MASX J11555347+1131240',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000179,NULL,'15.6g',0.47,'E0',NULL,NULL,NULL,NULL,1,178.972666667,11.52328,0,NULL,60230978456,941109038,14704828,15.6),(86639,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86639,37.6,0.46,331,35863,70,NULL,NULL,'2MASX J11555438+5730412',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,178.9765,57.5115,0.005,NULL,61841202873,966268794,15097949,17.5),(86640,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86640,36.27,0.46,179,35864,70,NULL,NULL,'2MASX J11555487+5429562',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,178.9785417,54.49911,0,NULL,61759871746,964997996,15078093,16.6),(86641,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86641,36.55,0.46,204,35865,70,NULL,NULL,'2MASX J11555492+6455431',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000178,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,178.978667,64.92853,0.025,NULL,61821139482,965955304,15093051,16.6),(86642,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86642,36.01,0.46,159,35866,70,NULL,NULL,'2MASX J11555490-0136119',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00015,NULL,'16.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,178.97875,-1.60333,0.049,NULL,40805057315,637579020,9962172,16.3),(86643,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86643,37.02,0.46,253,35867,70,NULL,NULL,'2MASX J11555512+2438001',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000182,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,178.9797917,24.63336,0,NULL,60547476894,946054326,14782098,16.3),(86644,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86644,37,0.46,251,35868,70,NULL,NULL,'2MASX J11555524+0000219',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000076,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,178.980167,0.00597,0.025,NULL,60130165241,939533831,14680216,17.2),(86645,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86645,37.86,0.33,374,35869,70,NULL,NULL,'SDSS J115555.97+001310.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000078,NULL,'18.0g',0.15,'NLAGN',NULL,NULL,NULL,'Sy 2',1,178.9832083,0.21947,0.025,NULL,60130283800,939535684,14680245,18),(86646,'IRAS','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86646,32.94,0.8,38.7,35870,75,NULL,'A82, H','NGC 3976',NULL,'1997ApJS..109..333W',1997,1,3.8,NULL,'G',0.00001,NULL,'12.30',1.2,'SAB(s)b        Sy2','Group member',NULL,NULL,'Sy 2',1,178.9887083,6.74944,0,NULL,60158019184,939969049,14687016,12.3),(86647,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86647,32.44,0.47,30.8,35870,75,NULL,'A82, H, raw','NGC 3976',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86648,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86648,32.48,0.38,31.3,35870,NULL,NULL,NULL,'NGC 3976',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86649,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86649,32.58,0.47,32.8,35870,75,NULL,'A82, H, cor','NGC 3976',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86650,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86650,32.62,0.47,33.5,35870,75,NULL,'A82, H, inv','NGC 3976',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86651,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86651,32.64,0.46,33.7,35870,NULL,NULL,'J','NGC 3976',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86652,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86652,32.65,0.47,33.9,35870,NULL,NULL,'H','NGC 3976',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86653,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86653,32.73,0.43,35.1,35870,75,NULL,'3.6 micron, color corrected','NGC 3976',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86654,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86654,32.75,0.45,35.5,35870,NULL,NULL,'K','NGC 3976',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86655,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86655,32.79,0.35,36.1,35870,NULL,NULL,'Malmquist cor.','NGC 3976',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86656,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86656,32.83,0.2,36.8,35870,74.4,NULL,NULL,'NGC 3976',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86657,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86657,32.84,0.43,37,35870,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3976',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86658,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86658,32.88,0.4,37.7,35870,75,NULL,'B','NGC 3976',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86659,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86659,33,0.4,39.8,35870,NULL,NULL,'mean','NGC 3976',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86660,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86660,33.19,0.29,43.4,35870,NULL,NULL,NULL,'NGC 3976',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86661,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86661,35.18,0.46,108,35871,70,NULL,NULL,'CGCG 315-003',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000183,NULL,'15.2g',0.47,'S0',NULL,NULL,NULL,NULL,1,178.9910417,63.66017,0,NULL,61817386328,965896661,15092135,15.2),(86662,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86662,36.55,0.46,205,35872,70,NULL,NULL,'2MASX J11555783+3605335',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000103,NULL,'15.6g',0.51,NULL,NULL,NULL,NULL,NULL,1,178.9912083,36.09275,0,NULL,60447079900,944485623,14757587,15.6),(86663,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86663,36.8,0.46,229,35873,70,NULL,NULL,'2MASX J11555805+0153404',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000098,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,178.991833,1.89467,0.029,NULL,60144855559,939763368,14683802,16.4),(86664,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86664,38.58,0.46,521,35874,70,NULL,NULL,'2MASX J11555931+2443331',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,178.99725,24.72589,0,NULL,60547473193,946054268,14782097,17.6),(86665,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86665,37.49,0.19,314,35875,70,NULL,NULL,'2MASX J11555932+1130339',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000159,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,178.997333,11.50953,0,NULL,60230989070,941109204,14704831,17.3),(86666,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86666,37.49,0.46,314,35876,70,NULL,NULL,'2MASX J11555956+3259342',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000182,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,178.9980417,32.99272,0.018,NULL,60549420951,946084702,14782573,17),(86667,'BCG','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86667,38.45,0.35,452,35877,60,NULL,'ABELL 1412, BCG','2MASX J11555984+7324566',0.0839,'1980ApJ...241..486H',1980,1,NULL,NULL,'G',0.000334,NULL,'14.5',NULL,NULL,'Brightest group member',NULL,NULL,NULL,1,178.9995417,73.41567,0.041,NULL,61362701685,958792213,14981128,14.5),(86668,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86668,37.87,0.46,374,35878,70,NULL,NULL,'2MASX J11560003+2101409',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,179.0002083,21.028,0.099,NULL,60200514131,940633033,14697391,18),(86669,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86669,37.59,0.46,329,35879,70,NULL,NULL,'2MASX J11560057+0050268',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000093,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,179.002417,0.84083,0.021,NULL,60133700081,939589063,14681079,17),(86670,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86670,38.26,0.27,448,35880,70,NULL,NULL,'2MASX J11560075+0000138',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000082,NULL,'17.0g',0.32,NULL,NULL,NULL,NULL,NULL,1,179.003291667,0.00369,0.025,NULL,60130166502,939533851,14680216,17),(86671,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86671,37.28,0.46,285,35881,70,NULL,NULL,'2MASX J11560131+4812352',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,179.00525,48.20981,0.049,NULL,61754910890,964920482,15076882,17.5),(86672,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86672,38.26,0.27,448,35882,70,NULL,NULL,'2MASX J11560168-0013051',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000078,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,179.0072083,-0.218,0.025,NULL,40802700879,637542201,9961596,17.3),(86673,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86673,38.46,0.46,491,35883,70,NULL,NULL,'SDSS J115601.77+022840.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000092,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,179.007375,2.47794,0.039,NULL,60145157815,939768090,14683876,18.4),(86674,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86674,34.99,0.46,99.7,35884,70,NULL,NULL,'2MASX J11560208+0750339',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000083,NULL,'15.3g',0.39,'SB0(r)',NULL,NULL,NULL,NULL,1,179.008708333,7.84264,0,NULL,60160981187,940015331,14687739,15.3),(86675,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86675,37.4,0.46,302,35885,70,NULL,NULL,'2MASX J11560329+4849221',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,179.0137083,48.82272,0.104,NULL,61747296191,964801502,15075023,17.4),(86676,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86676,37.86,0.33,374,35886,70,NULL,NULL,'2MASX J11560437+0011578',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000071,NULL,'17.3g',0.21,'AGN',NULL,NULL,NULL,NULL,1,179.01825,0.19931,0.025,NULL,60130313562,939536149,14680252,17.3),(86677,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86677,37.11,0.46,264,35887,70,NULL,NULL,'2MASX J11560498+3710596',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000175,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,179.020833,37.18331,0,NULL,60438519192,944351862,14755497,16.6),(86678,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86678,37.59,0.21,330,35888,70,NULL,NULL,'2MASX J11560543+5204421',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000168,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,179.022625,52.07825,0.02,NULL,61769171391,965143302,15080364,16.4),(86679,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86679,34.87,0.2,94.2,35889,74.4,NULL,NULL,'UGC 06911',NULL,'2013AJ....146...86T',2013,1,0.61,NULL,'G',0.000155,NULL,'15.2g',0.39,'Sbc','Group member, peripheral',NULL,NULL,NULL,1,179.024875,15.13197,0.104,NULL,60238570112,941227658,14706682,15.2),(86680,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86680,34.92,0.09,96.6,35889,NULL,NULL,NULL,'UGC 06911',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86681,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86681,37.35,0.16,296,35890,70,NULL,NULL,'2MASX J11560604+4357140',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,179.025375,43.95386,0,NULL,60398820799,943731574,14745805,17.8),(86682,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86682,38.06,0.46,410,35891,70,NULL,NULL,'2MASX J11560621-0030561',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000081,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,179.0259583,-0.51556,0.005,NULL,40806019287,637594051,9962407,17.8),(86683,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86683,37.43,0.46,306,35892,70,NULL,NULL,'2MASX J11560630+0317348',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000119,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,179.026417,3.29308,0.056,NULL,60136995079,939640548,14681883,16.8),(86684,'Sosies','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86684,32.01,0.18,25.2,35893,NULL,NULL,NULL,'NGC 3981',NULL,'2002A&A...393...57T',2002,1,5.2,'Confused and extended HIPASS source','G',0.000013,NULL,'12.08',2.3,'SAB(s)bc pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,179.0310417,-19.89617,0.073,NULL,40937869344,639654208,9994597,12.08),(86685,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86685,31,0.43,15.9,35893,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3981',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86686,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86686,31.22,0.43,17.6,35893,75,NULL,'3.6 micron, color corrected','NGC 3981',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86687,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86687,31.38,0.36,18.9,35893,NULL,NULL,NULL,'NGC 3981',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86688,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86688,31.42,0.49,19.3,35893,75,NULL,'IR','NGC 3981',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86689,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86689,31.51,0.2,20,35893,74.4,NULL,NULL,'NGC 3981',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86690,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86690,31.72,0.44,22.1,35893,NULL,NULL,'Malmquist cor.','NGC 3981',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86691,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86691,31.8,0.45,22.9,35893,NULL,NULL,'K','NGC 3981',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86692,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86692,31.8,0.47,22.9,35893,NULL,NULL,'H','NGC 3981',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86693,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86693,31.8,0.42,23,35893,NULL,NULL,NULL,'NGC 3981',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86694,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86694,31.86,0.46,23.5,35893,NULL,NULL,'J','NGC 3981',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86695,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86695,32.07,0.4,26,35893,75,NULL,'B','NGC 3981',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86696,'Tully-Fisher','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86696,32.35,0.4,29.5,35893,NULL,NULL,'mean','NGC 3981',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86697,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86697,36.99,0.46,250,35894,70,NULL,NULL,'2MASX J11560756+5310381',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000192,NULL,'16.1g',0.33,'E0',NULL,NULL,NULL,NULL,1,179.031625,53.17736,0,NULL,61766439420,965100615,15079697,16.1),(86698,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86698,37.75,0.27,355,35895,70,NULL,NULL,'2MASX J11560786+2715284',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,179.032667,27.25783,0,NULL,60536826566,945887915,14779498,17.7),(86699,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86699,36.68,0.46,217,35896,70,NULL,NULL,'2MASX J11560891+1006269',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,179.03725,10.10744,0,NULL,60146841294,939794395,14684287,17.5),(86700,'SNIa','2016-12-15 15:14:52','2016-12-16 11:20:01','1','SN 2003cq',NULL,86700,35.1,0.17,101,35897,74.2,NULL,'SALT 2','NGC 3978',0.033283,'2010ApJ...716..712A',2010,1,1.29,NULL,'G',0.00011,NULL,'13.4g',1.16,'SABbc:         HII','in a pair',NULL,NULL,NULL,1,179.043,60.52253,0,NULL,61848645943,966385092,15099767,13.4),(86701,'SNIa','2016-12-15 15:14:52','2016-12-16 11:20:01','1','SN 2003cq',NULL,86701,35.61,0.16,128,35897,70,NULL,'SALT 2','NGC 3978',0.033283,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86702,'SNIa','2016-12-15 15:14:52','2016-12-16 11:20:01','1','SN 2003cq','R',86702,35.58,0.09,131,35897,NULL,NULL,'MLCS2k2, R(V) = 3.1','NGC 3978',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86703,'SNIa','2016-12-15 15:14:52','2016-12-16 11:20:01','1','SN 2003cq','R',86703,35.65,0.08,135,35897,NULL,NULL,'MLCS2k2, R(V) = 1.8','NGC 3978',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86704,'SNIa','2016-12-15 15:14:52','2016-12-16 11:20:01','1','SN 2003cq',NULL,86704,35.68,0.09,137,35897,74.4,NULL,NULL,'NGC 3978',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86705,'SNIa','2016-12-15 15:14:52','2016-12-16 11:20:01','1','SN 2003cq',NULL,86705,35.87,0.18,144,35897,73.8,NULL,'SALT 2 (SNANA)','NGC 3978',0.0339,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86706,'SNIa','2016-12-15 15:14:52','2016-12-16 11:20:01','1','SN 2003cq',NULL,86706,35.91,0.29,147,35897,65,NULL,'MLCS31','NGC 3978',0.033283,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86707,'SNIa','2016-12-15 15:14:52','2016-12-16 11:20:01','1','SN 2003cq',NULL,86707,35.99,0.21,152,35897,65,NULL,'SALT2','NGC 3978',0.033283,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86708,'SNIa','2016-12-15 15:14:52','2016-12-16 11:20:01','1','SN 2003cq',NULL,86708,36.02,0.2,155,35897,65,NULL,'MLCS17','NGC 3978',0.033283,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86709,'SNIa','2016-12-15 15:14:52','2016-12-16 11:20:01','1','SN 2003cq',NULL,86709,36.02,0.17,155,35897,65,NULL,'SALT','NGC 3978',0.033283,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86710,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86710,38.12,0.46,421,35898,70,NULL,NULL,'2MASX J11561071+0432328',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000189,NULL,'17.2g',0.23,'AGN',NULL,NULL,NULL,NULL,1,179.044583,4.54233,0.007,NULL,60134223004,939597234,14681206,17.2),(86711,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,NULL,86711,35.33,0.61,116,35899,70,NULL,NULL,'2MASX J11561078-4949186',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,179.044833,-49.82181,0.429,NULL,40006066903,625094795,9767106,16.6),(86712,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86712,36.94,0.46,244,35900,70,NULL,NULL,'SDSS J115611.04+583022.2',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000153,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,179.0460417,58.50622,0.013,NULL,61842915109,966295548,15098367,17.5),(86713,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86713,36.63,0.23,212,35901,70,NULL,NULL,'2MASX J11561134+2731235',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,179.047375,27.52331,0,NULL,60591506902,946742295,14792848,16.7),(86714,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86714,37.71,0.46,348,35902,70,NULL,NULL,'2MASX J11561174+1019085',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000157,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,179.048875,10.31903,0,NULL,60146738857,939792794,14684262,16.9),(86715,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86715,36.91,0.33,241,35903,70,NULL,NULL,'2MASX J11561244+4439280',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000168,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,179.0519583,44.65789,0,NULL,63887779852,998246560,15597602,17.7),(86716,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86716,36.28,0.46,181,35904,70,NULL,NULL,'2MASX J11561280+3741367',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00017,NULL,'16.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,179.05325,37.69347,0,NULL,60439299187,944364049,14755688,16.2),(86717,'FP','2016-12-15 15:14:52','2016-12-16 11:20:01','1',NULL,'R',86717,36.78,0.46,227,35905,70,NULL,NULL,'2MASX J11561350+6810247',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000074,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,179.0559583,68.17347,0.009,NULL,61337583634,958399744,14974996,17.9),(86718,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86718,38.51,0.46,504,35906,70,NULL,NULL,'SDSS J115613.57+093601.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000149,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,179.056583,9.60044,0,NULL,60150277603,939848087,14685126,18.6),(86719,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:01','1','PTF11bju','N',86719,35.98,0.01,152,35907,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF11bju',0.0323,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86720,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86720,31.93,0.4,24.4,35908,75,NULL,'B','UGC 06912',NULL,'1988NBGC.C....0000T',1988,1,2.1,'Position is for main body of galaxy.','G',0.000003,NULL,'14.6',1,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,179.0602083,58.19686,0.013,NULL,61842577501,966290273,15098285,14.6),(86721,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86721,37.54,0.1,322,35909,70,NULL,NULL,'2MASX J11561513+0458048',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.0002,NULL,'15.5g',0.62,'E0',NULL,NULL,NULL,NULL,1,179.062917,4.96789,0.02,NULL,60189161756,940455652,14694619,15.5),(86722,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86722,37.9,0.46,381,35910,70,NULL,NULL,'2MASX J11561557+5504453',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,179.0647917,55.07925,0,NULL,61760574196,965008971,15078265,18),(86723,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86723,38.56,0.46,516,35911,70,NULL,NULL,'SDSS J115615.74+181206.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000145,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,179.065625,18.20192,0.097,NULL,60208328080,940755126,14699298,18.4),(86724,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86724,37.35,0.16,296,35912,70,NULL,NULL,'2MASX J11561602+4352419',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000165,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,179.0670417,43.87844,0,NULL,60398776950,943730889,14745795,16.2),(86725,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86725,37.07,0.46,259,35913,70,NULL,NULL,'2MASX J11561709+5157300',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000146,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,179.071,51.95819,0.069,NULL,61769148674,965142948,15080358,16.8),(86726,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86726,38.57,0.46,518,35914,70,NULL,NULL,'SDSS J115618.43+031659.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000089,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,179.076833,3.28328,0.06,NULL,60136517238,939633081,14681766,18.6),(86727,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86727,38.06,0.46,409,35915,70,NULL,NULL,'2MASX J11561900+3456224',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000192,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,179.079167,34.93947,0,NULL,60435365974,944302593,14754728,16.4),(86728,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86728,37.35,0.16,296,35916,70,NULL,NULL,'2MASX J11562086+4358259',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00017,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,179.087167,43.97389,0,NULL,60398828509,943731695,14745807,16.5),(86729,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86729,36.58,0.46,207,35917,70,NULL,NULL,'2MASX J11562196+4430379',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000159,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,179.0912917,44.51047,0,NULL,60398057317,943719645,14745619,17.1),(86730,'IRAS','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86730,32.09,0.8,26.2,35918,75,NULL,'MAT, I','ESO 572- G 022',NULL,'1997ApJS..109..333W',1997,1,1.3,'HOLM 307B is a star.','G',0.000033,NULL,'14.85',0.4,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,179.09375,-19.55208,0.073,NULL,40951993857,639874904,9998045,14.85),(86731,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86731,31.46,0.32,19.6,35918,85,NULL,'I, inv','ESO 572- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86732,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86732,31.51,0.32,20,35918,85,NULL,'I, raw','ESO 572- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86733,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86733,31.87,0.43,23.7,35918,75,NULL,'MAT, I, inv','ESO 572- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86734,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86734,31.96,0.43,24.7,35918,75,NULL,'MAT, I, raw','ESO 572- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86735,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86735,32.1,0.43,26.3,35918,75,NULL,'MAT, I, cor','ESO 572- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86736,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86736,32.42,0.4,30.5,35918,NULL,NULL,NULL,'ESO 572- G 022',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86737,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86737,32.72,1.18,35,35918,NULL,NULL,'Malmquist cor.','ESO 572- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86738,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86738,32.99,1.05,39.6,35918,NULL,NULL,NULL,'ESO 572- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86739,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86739,33.03,0.2,40.4,35918,74.4,NULL,NULL,'ESO 572- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86740,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86740,37.81,0.46,364,35919,70,NULL,NULL,'2MASX J11562328-0021511',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000085,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,179.0972083,-0.36408,0.005,NULL,40802558303,637539973,9961562,17.2),(86741,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86741,38.35,0.46,468,35920,70,NULL,NULL,'SDSS J115624.89+584907.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,179.10375,58.81886,0,NULL,61841984345,966281005,15098140,18.1),(86742,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86742,36.32,0.46,183,35921,70,NULL,NULL,'2MASX J11562516+6810446',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000099,NULL,'15.9g',0.43,'E',NULL,NULL,NULL,NULL,1,179.1045,68.17894,0.009,NULL,61337584196,958399753,14974996,15.9),(86743,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86743,38.34,0.46,466,35922,70,NULL,NULL,'2MASX J11562563+1025275',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000183,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,179.106875,10.42444,0,NULL,60365021733,943203464,14737554,16.8),(86744,'IRAS','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86744,34.89,0.8,95.1,35923,75,NULL,'HMCL, I','CGCG 041-009',NULL,'1997ApJS..109..333W',1997,1,0.83,NULL,'G',0.000027,NULL,'15.7g',0.33,'HII',NULL,NULL,NULL,NULL,1,179.108625,3.76678,0.038,NULL,60137923813,939655059,14682110,15.7),(86745,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86745,35.14,0.4,107,35923,75,NULL,'HMCL, I, raw','CGCG 041-009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86746,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86746,35.31,0.4,115,35923,75,NULL,'HMCL, I, inv','CGCG 041-009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86747,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86747,35.32,0.4,116,35923,75,NULL,'HMCL, I, cor','CGCG 041-009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86748,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86748,35.42,0.49,121,35923,75,NULL,'IR','CGCG 041-009',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86749,'GRB','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86749,47.83,0.37,6080,35924,73,NULL,'H const./H=100','GRB 971214',3.418,'2006astro.ph..9262M',2006,1,NULL,NULL,'G',0.01,NULL,'25.6',NULL,'Irregular',NULL,NULL,NULL,NULL,1,180.83,66.21,0.029,NULL,57314689329,895542020,13992844,25.6),(86750,'GRB','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86750,47.45,1.57,6990,35924,100,NULL,NULL,'GRB 971214',3.418,'2009EPJC...63..139W',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86751,'GRB','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86751,47.54,0.59,7290,35924,69.7,NULL,'Calibrated','GRB 971214',3.418,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86752,'GRB','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86752,47.63,1.51,7600,35924,73,NULL,'H const./H=100','GRB 971214',3.418,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86753,'GRB','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86753,47.77,0.59,8110,35924,69.7,NULL,'Fiducial','GRB 971214',3.418,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86754,'GRB','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86754,48.31,0.62,10400,35924,72,NULL,NULL,'GRB 971214',3.418,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86755,'GRB','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86755,48.44,0.62,11000,35924,70,NULL,NULL,'GRB 971214',3.418,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86756,'GRB','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86756,48.67,0.74,12300,35924,NULL,NULL,NULL,'GRB 971214',3.418,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86757,'GRB','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86757,47.5,0.73,31600,35924,NULL,NULL,NULL,'GRB 971214',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86758,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86758,36.56,0.33,205,35925,70,NULL,NULL,'2MASX J11562650+5827343',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000183,NULL,'16.1g',0.34,'S0',NULL,NULL,NULL,NULL,1,179.11025,58.45958,0.013,NULL,61842905343,966295395,15098365,16.1),(86759,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86759,38.02,0.46,402,35926,70,NULL,NULL,'2MASX J11562659+5559193',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,179.110583333,55.98878,0,NULL,61757056124,964954001,15077406,17.2),(86760,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86760,38.17,0.33,431,35927,70,NULL,NULL,'2MASX J11562669+4553221',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000139,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,179.111083,45.88944,0,NULL,61741182101,964705970,15073530,18.1),(86761,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86761,36.2,0.46,174,35928,70,NULL,NULL,'2MASX J11562675+5006522',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00017,NULL,'16.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,179.1115417,50.11458,0.038,NULL,61745389865,964771716,15074558,16.2),(86762,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86762,38.17,0.33,431,35929,70,NULL,NULL,'2MASX J11562689+4551311',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,179.111917,45.85861,0,NULL,61741183359,964705989,15073531,17.5),(86763,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86763,36.45,0.46,195,35930,70,NULL,NULL,'CGCG 292-049',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000103,NULL,'15.3g',0.48,'S0',NULL,NULL,NULL,NULL,1,179.113583333,60.41822,0,NULL,61848571863,966383935,15099748,15.3),(86764,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86764,38.26,0.27,448,35931,70,NULL,NULL,'2MASX J11562797-0008576',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000073,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,179.1164583,-0.14933,0.029,NULL,40802603908,637540686,9961573,17.7),(86765,'Cepheids','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86765,31.56,0.08,20.5,35932,NULL,NULL,'32, VI','NGC 3982',NULL,'2001MNRAS.328L...1S',2001,1,1.69,NULL,'G',0.00002,NULL,'12.0g',1.49,'SAB(r)b:;HII   Sy2','in a radial-velocity based grouping',NULL,NULL,'Sy 1.9',1,179.1172083,55.12525,0,NULL,61760452297,965007067,15078235,12),(86766,'Cepheids','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86766,31.59,0.13,20.8,35932,NULL,NULL,'cte LMC K03','NGC 3982',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86767,'Cepheids','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86767,31.59,0.06,20.8,35932,NULL,NULL,'STR 04 LMC non-linear','NGC 3982',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86768,'Cepheids','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86768,31.6,0.13,20.9,35932,NULL,NULL,'cte U99','NGC 3982',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86769,'Cepheids','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86769,31.6,0.08,20.9,35932,NULL,NULL,NULL,'NGC 3982',NULL,'2005ApJ...627..579R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86770,'Cepheids','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86770,31.61,0.06,21,35932,NULL,NULL,'STR04 LMC linear','NGC 3982',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86771,'Cepheids','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86771,31.62,0.03,21.1,35932,NULL,NULL,'KN04 LMC non-linear','NGC 3982',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86772,'Cepheids','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86772,31.62,0.14,21.1,35932,NULL,NULL,'cte LMC STS02','NGC 3982',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86773,'Cepheids','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86773,31.63,0.06,21.2,35932,NULL,NULL,'KN04 LMC linear','NGC 3982',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86774,'Cepheids','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86774,31.63,0.06,21.2,35932,NULL,NULL,'KN06 LMC linear','NGC 3982',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86775,'Cepheids','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86775,31.63,0.06,21.2,35932,NULL,NULL,'TR02 LMC linear','NGC 3982',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86776,'Cepheids','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86776,31.64,0.07,21.3,35932,NULL,NULL,'KN06 LMC non-linear','NGC 3982',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86777,'Cepheids','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86777,31.66,0.06,21.5,35932,NULL,NULL,'TR02 LMC non-linear','NGC 3982',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86778,'Cepheids','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86778,31.67,0.07,21.6,35932,74.4,NULL,NULL,'NGC 3982',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86779,'Cepheids','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86779,31.68,0.14,21.7,35932,NULL,NULL,'cte MW FSG03','NGC 3982',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86780,'Cepheids','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86780,31.7,0.08,21.9,35932,NULL,NULL,'SNIa calibrated','NGC 3982',NULL,'2011ApJ...730..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86781,'Cepheids','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86781,31.71,0.14,22,35932,NULL,NULL,'cte MF91','NGC 3982',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86782,'Cepheids','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86782,31.72,0.14,22.1,35932,NULL,NULL,'26, VI','NGC 3982',NULL,'2001ApJ...562..314S',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86783,'Cepheids','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86783,31.73,0.14,22.1,35932,NULL,NULL,'cte MW GFG98','NGC 3982',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86784,'Cepheids','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86784,31.73,0.07,22.2,35932,NULL,NULL,'NK04 GAL','NGC 3982',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86785,'Cepheids','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86785,31.76,0.1,22.5,35932,NULL,NULL,NULL,'NGC 3982',NULL,'2009ApJ...699..539R',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86786,'Cepheids','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86786,31.77,0.07,22.6,35932,NULL,NULL,'STR04 GAL','NGC 3982',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86787,'Cepheids','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86787,31.79,0.06,22.8,35932,NULL,NULL,'V, I, NIR (W), 22, Syst. +/- 0.32 mag','NGC 3982',NULL,'2013MNRAS.434.2866F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86788,'Cepheids','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86788,31.8,0.14,22.9,35932,NULL,NULL,'cte MW STS03','NGC 3982',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86789,'Cepheids','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86789,31.87,NULL,23.7,35932,NULL,18.54,NULL,'NGC 3982',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86790,'Cepheids','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86790,31.87,0.15,23.7,35932,NULL,18.54,'LMC ZP','NGC 3982',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86791,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:01','1','SN 1998aq',NULL,86791,30.89,0.56,15.1,35932,NULL,NULL,'Snapshot D','NGC 3982',NULL,'1999A&A...345..592V',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86792,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:01','1','SN 1998aq',NULL,86792,31.67,0.07,21.6,35932,74.4,NULL,NULL,'NGC 3982',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86793,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:01','1','SN 1998aq',NULL,86793,31.7,0.08,21.9,35932,NULL,NULL,'MLCS2k2, Cepheids calibrated','NGC 3982',NULL,'2011ApJ...730..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86794,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:01','1','SN 1998aq',NULL,86794,31.91,0.14,24.1,35932,60,NULL,NULL,'NGC 3982',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86795,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:01','1','SN 1998aq',NULL,86795,31.97,0.05,24.6,35932,65,NULL,'MLCS2k2','NGC 3982',0.003699,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86796,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:01','1','SN 1998aq','R',86796,32.02,NULL,25.4,35932,62.3,NULL,NULL,'NGC 3982',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86797,'Sosies','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86797,32.41,0.74,30.3,35932,NULL,NULL,NULL,'NGC 3982',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86798,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86798,31.15,0.4,17,35932,75,NULL,'B','NGC 3982',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86799,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86799,34.73,0.2,88.3,35933,74.4,NULL,NULL,'UGC 06916',NULL,'2013AJ....146...86T',2013,1,1.34,NULL,'G',0.00015,NULL,'14.4g',0.53,'SBbc:',NULL,NULL,NULL,NULL,1,179.1175,39.74192,0,NULL,60407274191,943863659,14747869,14.4),(86800,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86800,34.8,0.34,91.1,35933,NULL,NULL,NULL,'UGC 06916',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86801,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86801,35.03,0.3,101,35933,NULL,NULL,'Malmquist cor.','UGC 06916',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86802,'IRAS','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86802,31.2,0.8,17.4,35934,75,NULL,'W91CL, r','UGC 06917',NULL,'1997ApJS..109..333W',1997,1,3.5,NULL,'G',0.000005,NULL,'13.13',2,'SBm','in a radial-velocity based grouping',NULL,NULL,NULL,1,179.1105,50.42867,0.029,NULL,61744469164,964757330,15074333,13.13),(86803,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86803,31.15,0.4,17,35934,75,NULL,'B','UGC 06917',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86804,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86804,31.33,0.36,18.5,35934,NULL,NULL,NULL,'UGC 06917',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86805,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86805,31.39,0.2,19,35934,74.4,NULL,NULL,'UGC 06917',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86806,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86806,31.47,0.38,19.7,35934,75,NULL,'W91CL, r, inv','UGC 06917',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86807,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86807,31.47,0.38,19.7,35934,75,NULL,'W91CL, r, raw','UGC 06917',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86808,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86808,31.55,0.43,20.4,35934,75,NULL,'3.6 micron, color corrected','UGC 06917',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86809,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86809,31.6,0.38,20.9,35934,75,NULL,'W91CL, r, cor','UGC 06917',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86810,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86810,31.71,0.43,21.9,35934,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06917',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86811,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86811,37.54,0.1,322,35935,70,NULL,NULL,'2MASX J11562896+0501183',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000161,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,179.120791667,5.02164,0.02,NULL,60189164601,940455696,14694620,17.2),(86812,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86812,38.95,0.46,617,35936,70,NULL,NULL,'2MASX J11562924+1608021',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000161,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,179.121875,16.134,0.091,NULL,60251782901,941434107,14709907,18.7),(86813,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86813,35.95,0.52,155,35937,70,NULL,NULL,'LCRS B115355.7-060814',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00009,NULL,'14.88',0.39,NULL,NULL,NULL,NULL,NULL,1,179.122,-6.41567,0.085,NULL,40843928781,638186387,9971662,14.88),(86814,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86814,37.64,0.27,338,35938,70,NULL,NULL,'2MASX J11562952+0405483',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,179.1232083,4.09661,0.014,NULL,60137548058,939649188,14682018,18),(86815,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86815,37.62,0.46,335,35939,70,NULL,NULL,'2MASX J11563126+5319342',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000179,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,179.130083333,53.32617,0.005,NULL,61766473991,965101156,15079705,17),(86816,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86816,38.19,0.46,435,35940,70,NULL,NULL,'2MASX J11563168+0543593',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,179.131875,5.73317,0,NULL,60155361452,939927522,14686367,17.5),(86817,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86817,38.35,0.46,468,35941,70,NULL,NULL,'2MASX J11563280+2604065',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000171,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,179.136708333,26.06858,0,NULL,60539145018,945924140,14780064,18.1),(86818,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86818,38.2,0.46,436,35942,70,NULL,NULL,'2MASX J11563320+5954597',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000139,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,179.138291667,59.91672,0.005,NULL,61848119591,966376868,15099638,18.4),(86819,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86819,37.14,0.46,267,35943,70,NULL,NULL,'2MASX J11563435+1621152',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,179.1432083,16.35419,0.088,NULL,60252092412,941438943,14709983,17),(86820,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86820,36.48,0.33,198,35944,70,NULL,NULL,'2MASX J11563516+6640545',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000083,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,179.146667,66.68194,0,NULL,61807988633,965749822,15089840,16.2),(86821,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86821,38.26,0.46,449,35945,70,NULL,NULL,'2MASX J11563574+1052325',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,179.149083,10.87589,0.022,NULL,60365420819,943209700,14737651,17.6),(86822,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86822,36.51,0.46,201,35946,70,NULL,NULL,'2MASX J11563681+0650055',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,179.1535417,6.83486,0,NULL,60158766196,939980721,14687198,16.4),(86823,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86823,35.74,0.46,140,35947,70,NULL,NULL,'2MASX J11563710+1646312',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000147,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,179.1545417,16.77539,0.1,NULL,60252099848,941439060,14709985,16.4),(86824,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86824,37.35,0.16,296,35948,70,NULL,NULL,'2MASX J11563861+4351323',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000191,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,179.1610417,43.85903,0,NULL,60398641658,943728775,14745762,17.4),(86825,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86825,37.54,0.1,322,35949,70,NULL,NULL,'2MASX J11563873+0504473',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,179.161375,5.07978,0,NULL,60189166337,940455724,14694620,17.8),(86826,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86826,35.15,0.46,107,35950,70,NULL,NULL,'ESO 440- G 032',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000073,NULL,'14.06',0.6,'SB(r)0/a','Pair member (points to parent)',NULL,NULL,NULL,1,179.172625,-32.38575,0.317,NULL,41443540701,647555323,10118051,14.06),(86827,'Tully est','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86827,29.58,0.8,8.3,35951,75,NULL,'B','NGC 3985',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000007,NULL,'13.12',0.8,'SB(s)m:','Pair member (points to parent)',NULL,NULL,NULL,1,179.1754583,48.33394,0.049,NULL,61746634575,964791165,15074861,13.12),(86828,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86828,29.6,0.69,8.33,35951,100,NULL,'mid-IR','NGC 3985',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86829,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86829,30.81,0.43,14.5,35951,75,NULL,'3.6 micron, color + selection bias corrected','NGC 3985',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86830,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86830,30.98,0.43,15.7,35951,75,NULL,'3.6 micron, color corrected','NGC 3985',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86831,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86831,31.12,0.2,16.8,35951,74.4,NULL,NULL,'NGC 3985',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86832,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86832,31.2,0.35,17.4,35951,NULL,NULL,NULL,'NGC 3985',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86833,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86833,37.37,0.27,298,35952,70,NULL,NULL,'2MASX J11564226+2114355',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000133,NULL,'16.72',0.26,NULL,NULL,NULL,NULL,NULL,1,179.176167,21.24322,0.093,NULL,60196984460,940577882,14696529,16.72),(86834,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86834,36.91,0.33,241,35953,70,NULL,NULL,'2MASX J11564261+4443023',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000172,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,179.177583,44.71744,0,NULL,63887827987,998247312,15597614,16.8),(86835,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,'R',86835,36.63,0.23,212,35954,70,NULL,NULL,'2MASX J11564267+2732031',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000083,NULL,'16.0g',0.37,NULL,NULL,NULL,NULL,NULL,1,179.177791667,27.53406,0,NULL,60537307717,945895433,14779616,16),(86836,'FP','2016-12-15 15:14:53','2016-12-16 11:20:01','1',NULL,NULL,86836,36.69,0.77,218,35955,70,NULL,NULL,'2MASX J11564302-0407216',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.84',0.24,NULL,NULL,NULL,NULL,NULL,1,179.179333,-4.12267,0.037,NULL,40814058324,637719661,9964369,16.84),(86837,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86837,37.49,0.19,314,35956,70,NULL,NULL,'2MASX J11564359+1120518',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,179.1815,11.34758,0,NULL,60230808463,941106382,14704787,17.4),(86838,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86838,38.08,0.33,413,35957,70,NULL,NULL,'2MASX J11564385+0153443',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00009,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,179.1827083,1.89558,0.021,NULL,60131045717,939547589,14680431,17.5),(86839,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86839,35.83,0.27,146,35958,70,NULL,NULL,'2MASX J11564419+2528361',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000182,NULL,'15.9g',0.35,NULL,NULL,NULL,NULL,NULL,1,179.184083,25.47664,0,NULL,60539342186,945927221,14780112,15.9),(86840,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86840,33.82,0.49,58,35959,75,NULL,'IR','NGC 3966',NULL,'2011yCatp016004901K',2011,1,2.97,NULL,'G',0.00003,NULL,'13.5g',0.58,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,179.184125,32.02178,0.022,NULL,60552557157,946133705,14783339,13.5),(86841,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86841,36.63,0.23,212,35960,70,NULL,NULL,'2MASX J11564484+2735021',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000103,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,179.186833,27.58394,0,NULL,60591050389,946735162,14792736,16.3),(86842,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86842,38.47,0.46,495,35961,70,NULL,NULL,'SDSS J115645.30+604706.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000142,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,179.18875,60.78528,0.033,NULL,61845685040,966338828,15099044,18.6),(86843,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86843,38.08,0.33,413,35962,70,NULL,NULL,'2MASX J11564545+0155053',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000098,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,179.18925,1.91828,0.021,NULL,60131043516,939547554,14680430,17.9),(86844,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86844,37.49,0.19,314,35963,70,NULL,NULL,'SDSS J115645.64+111715.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,179.1902083,11.28775,0,NULL,60230797526,941106211,14704784,18.3),(86845,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86845,36.17,0.27,171,35964,70,NULL,NULL,'MCG +09-20-039',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000178,NULL,'15.4g',0.56,'E0',NULL,NULL,NULL,NULL,1,179.19025,52.50706,0.01,NULL,61767089401,965110771,15079855,15.4),(86846,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86846,36.61,0.23,210,35965,70,NULL,NULL,'2MASX J11564586+1339342',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000169,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,179.191,13.65942,0.029,NULL,60245754970,941339921,14708436,17),(86847,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86847,37.08,0.46,261,35966,70,NULL,NULL,'2MASX J11564612+1813345',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.21',0.15,NULL,NULL,NULL,NULL,NULL,1,179.19225,18.22639,0.093,NULL,60209052686,940766448,14699475,18.21),(86848,'IRAS','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86848,32.95,0.8,38.9,35967,75,NULL,'MAT, I','ESO 320- G 035',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000013,NULL,'13.55',1.5,'SAB(rs)bc      HII','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,179.1935417,-38.19244,0.477,NULL,41364560738,646321261,10098769,13.55),(86849,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86849,31.94,0.69,24.4,35967,100,NULL,'mid-IR','ESO 320- G 035',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86850,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86850,32.16,0.4,27,35967,NULL,NULL,NULL,'ESO 320- G 035',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86851,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86851,32.18,0.43,27.3,35967,75,NULL,'MAT, I, raw','ESO 320- G 035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86852,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86852,32.19,0.32,27.4,35967,85,NULL,'I, raw','ESO 320- G 035',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86853,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86853,32.2,0.32,27.5,35967,85,NULL,'I, inv','ESO 320- G 035',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86854,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86854,32.25,0.43,28.2,35967,75,NULL,'MAT, I, inv','ESO 320- G 035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86855,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86855,32.51,0.43,31.8,35967,75,NULL,'MAT, I, cor','ESO 320- G 035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86856,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86856,32.53,0.43,32.1,35967,75,NULL,'3.6 micron, color + selection bias corrected','ESO 320- G 035',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86857,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86857,32.59,0.43,33,35967,75,NULL,'3.6 micron, color corrected','ESO 320- G 035',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86858,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86858,32.7,0.2,34.7,35967,74.4,NULL,NULL,'ESO 320- G 035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86859,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86859,33.03,0.6,40.3,35967,NULL,NULL,'Malmquist cor.','ESO 320- G 035',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86860,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86860,33.03,0.6,40.5,35967,NULL,NULL,NULL,'ESO 320- G 035',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86861,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86861,33.33,0.4,46.3,35967,NULL,NULL,'mean','ESO 320- G 035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86862,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86862,33.71,0.46,55.2,35967,NULL,NULL,'J','ESO 320- G 035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86863,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86863,33.72,0.45,55.4,35967,NULL,NULL,'K','ESO 320- G 035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86864,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86864,33.72,0.47,55.5,35967,NULL,NULL,'H','ESO 320- G 035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86865,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86865,37.64,0.27,338,35968,70,NULL,NULL,'2MASX J11564697+0349173',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000182,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,179.1957083,3.82144,0.038,NULL,60137896983,939654640,14682103,17),(86866,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86866,37.94,0.46,387,35969,70,NULL,NULL,'2MASX J11564716+0536033',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,179.196541667,5.60083,0,NULL,60188670579,940447977,14694499,17.9),(86867,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86867,36.35,0.46,186,35970,70,NULL,NULL,'2MASX J11564732+1127458',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000173,NULL,'16.2g',0.35,'E0',NULL,NULL,NULL,NULL,1,179.19725,11.46281,0,NULL,60230821974,941106593,14704790,16.2),(86868,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86868,37.07,0.46,259,35971,70,NULL,NULL,'2MASX J11564738+2438291',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,179.197333,24.64156,0,NULL,60534176692,945846510,14778851,17.1),(86869,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86869,36.31,0.46,183,35972,70,NULL,NULL,'2MASX J11564809+2359221',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00017,NULL,'16.0g',0.49,NULL,NULL,NULL,NULL,NULL,1,179.2005,23.98953,0,NULL,60535934625,945873978,14779280,16),(86870,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86870,37.64,0.27,338,35973,70,NULL,NULL,'2MASX J11564837+0359083',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00017,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,179.2015417,3.98564,0.038,NULL,60137732568,939652071,14682063,17),(86871,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86871,38.18,0.46,432,35974,70,NULL,NULL,'2MASX J11564841+0921028',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'18.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,179.2017917,9.35078,0,NULL,60150412146,939850189,14685159,18.1),(86872,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86872,37.96,0.46,390,35975,70,NULL,NULL,'2MASX J11564902+4703103',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,179.2042083,47.053,0,NULL,61742019001,964719046,15073735,17.9),(86873,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86873,35.01,0.2,100,35976,74.4,NULL,NULL,'UGC 06924',NULL,'2013AJ....146...86T',2013,1,1.02,NULL,'G',0.000109,NULL,'16.1g',0.27,'Scd:',NULL,NULL,NULL,NULL,1,179.2055,12.77603,0,NULL,60231587228,941118550,14704977,16.1),(86874,'IRAS','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86874,31.49,0.8,19.9,35977,75,NULL,'A82, H','UGC 06923',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000007,NULL,'15.1g',0.56,'Im:','in a radial-velocity based grouping',NULL,NULL,NULL,1,179.2059583,53.16036,0,NULL,61766463502,965100992,15079703,15.1),(86875,'IRAS','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86875,31.56,0.8,20.5,35977,75,NULL,'W91CL, r','UGC 06923',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86876,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86876,31.05,0.38,16.3,35977,75,NULL,'W91CL, r, inv','UGC 06923',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86877,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86877,31.09,0.35,16.5,35977,NULL,NULL,NULL,'UGC 06923',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86878,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86878,31.09,0.47,16.5,35977,75,NULL,'A82, H, inv','UGC 06923',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86879,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86879,31.08,0.43,16.5,35977,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06923',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86880,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86880,31.11,0.2,16.7,35977,74.4,NULL,NULL,'UGC 06923',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86881,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86881,31.12,0.43,16.8,35977,75,NULL,'3.6 micron, color corrected','UGC 06923',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86882,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86882,31.15,0.4,17,35977,75,NULL,'B','UGC 06923',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86883,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86883,31.16,0.38,17,35977,75,NULL,'W91CL, r, raw','UGC 06923',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86884,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86884,31.27,0.47,17.9,35977,75,NULL,'A82, H, raw','UGC 06923',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86885,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86885,31.32,0.38,18.4,35977,75,NULL,'W91CL, r, cor','UGC 06923',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86886,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86886,31.53,0.47,20.2,35977,75,NULL,'A82, H, cor','UGC 06923',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86887,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86887,37.43,0.46,306,35978,70,NULL,NULL,'2MASX J11564978+5509379',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000177,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,179.207667,55.16053,0,NULL,61760439901,965006873,15078232,16.7),(86888,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86888,38.17,0.46,431,35979,70,NULL,NULL,'2MASX J11565085+5904319',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,179.211791667,59.07542,0,NULL,61855712700,966495510,15101492,18.2),(86889,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86889,38.17,0.46,431,35980,70,NULL,NULL,'2MASX J11565126+1338248',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000163,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,179.213458333,13.64033,0.029,NULL,60245769427,941340147,14708439,17.2),(86890,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86890,37.54,0.1,322,35981,70,NULL,NULL,'2MASX J11565131+0457313',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000183,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,179.21375,4.95883,0.02,NULL,60189128397,940455131,14694611,16.7),(86891,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86891,36.61,0.23,210,35982,70,NULL,NULL,'2MASX J11565133+1341098',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000191,NULL,'15.4g',0.56,'BrClG',NULL,NULL,NULL,NULL,1,179.213917,13.686,0.029,NULL,60245755426,941339928,14708436,15.4),(86892,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86892,37.26,0.46,283,35983,70,NULL,NULL,'2MASX J11565174+1307198',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000178,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,179.215667,13.12222,0.01,NULL,60231695617,941120244,14705003,17.5),(86893,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86893,37.88,0.46,377,35984,70,NULL,NULL,'2MASX J11565196+5039361',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,179.2164583,50.65989,0.039,NULL,61799099589,965610931,15087670,17.5),(86894,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86894,36.61,0.23,210,35985,70,NULL,NULL,'2MASX J11565278+1336428',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000173,NULL,'16.2g',0.36,'E0',NULL,NULL,NULL,NULL,1,179.219875,13.61203,0.029,NULL,60245767686,941340120,14708439,16.2),(86895,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86895,37.54,0.1,322,35986,70,NULL,NULL,'2MASX J11565305+0516043',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000206,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,179.221,5.26797,0,NULL,60189247339,940456989,14694640,16.4),(86896,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86896,37.4,0.46,302,35987,70,NULL,NULL,'2MASX J11565323+1430578',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000175,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,179.2217083,14.51603,0.05,NULL,60237200172,941206252,14706347,17),(86897,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86897,36.17,0.27,171,35988,70,NULL,NULL,'2MASX J11565353+5232491',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000155,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,179.222917,52.54714,0.01,NULL,61767067660,965110432,15079850,16.5),(86898,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86898,37.11,0.46,264,35989,70,NULL,NULL,'2MASX J11565424+6511179',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000181,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,179.225708333,65.18842,0.029,NULL,61809562992,965774421,15090225,16.5),(86899,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86899,34.19,0.46,68.9,35990,70,NULL,NULL,'IC 2979',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.00009,NULL,'14.3g',0.65,'SB0','in a radial-velocity based grouping',NULL,NULL,NULL,1,179.226,32.15881,0.038,NULL,60552590835,946134231,14783347,14.3),(86900,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86900,38.35,0.46,468,35991,70,NULL,NULL,'2MASX J11565538+2302055',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'18.35',0.14,NULL,NULL,NULL,NULL,NULL,1,179.230625,23.03486,0.032,NULL,60533001375,945828146,14778564,18.35),(86901,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86901,37.15,0.46,269,35992,70,NULL,NULL,'2MASX J11565623+4104172',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,179.234291667,41.07153,0,NULL,60408078342,943876224,14748066,17.8),(86902,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86902,35.41,0.46,121,35993,70,NULL,NULL,'CGCG 292-052',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000171,NULL,'15.4g',0.47,'E0',NULL,NULL,NULL,NULL,1,179.236333,62.17194,0,NULL,61815866252,965872910,15091764,15.4),(86903,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86903,37.63,0.46,336,35994,70,NULL,NULL,'SDSS J115657.37+013231.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000076,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,179.2390417,1.54219,0.005,NULL,60130979250,939546550,14680414,18.2),(86904,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86904,33.23,0.54,44.2,35995,70,NULL,NULL,'ESO 572- G 023',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000063,NULL,'13.85',1.4,'SAB(s)0^0^:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,179.2412083,-19.85511,0.045,NULL,40938380580,639662196,9994721,13.85),(86905,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86905,36.64,0.46,213,35996,70,NULL,NULL,'2MASX J11565864+3712152',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000159,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,179.2442917,37.20431,0,NULL,60438630795,944353606,14755525,16.3),(86906,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86906,37.11,0.46,265,35997,70,NULL,NULL,'2MASX J11565891+5220221',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,179.2455417,52.3395,0.01,NULL,61769090854,965142044,15080344,17.3),(86907,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86907,32.17,0.43,27.1,35998,75,NULL,'3.6 micron, color + selection bias corrected','ESO 572- G 024',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.000103,NULL,'16.13',0.3,'SBd?',NULL,NULL,NULL,NULL,1,179.24825,-19.98669,0.045,NULL,40938402962,639662546,9994727,16.13),(86908,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86908,38.41,0.46,480,35999,70,NULL,NULL,'2MASX J11565999+5022025',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,179.249875,50.36731,0.029,NULL,61744477250,964757457,15074335,17.7),(86909,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:02','1','SN 1999bn',NULL,86909,38.25,0.13,399,36000,74.2,NULL,'SALT 2','EROS J115700.46-112638.6',0.12,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,179.251917,-11.44406,0.101,NULL,40953630965,639900483,9998445,NULL),(86910,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:02','1','SN 1999bn',NULL,86910,39,0.06,563,36000,70,NULL,'SALT','EROS J115700.46-112638.6',0.12,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86911,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:02','1','SN 1999bn',NULL,86911,39.15,0.08,604,36000,65,NULL,'SALT','EROS J115700.46-112638.6',0.12,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86912,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86912,37.37,0.46,298,36001,70,NULL,NULL,'2MASX J11570090+0332305',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000082,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,179.253875,3.54169,0.074,NULL,60137803661,939653182,14682080,17.3),(86913,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86913,36.74,0.58,223,36002,70,NULL,NULL,'2MASX J11570119-4933158',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,179.254958333,-49.55436,0.413,NULL,40009102388,625142224,9767847,16.6),(86914,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86914,36.3,0.46,182,36003,70,NULL,NULL,'2MASX J11570128+2555422',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000181,NULL,'16.1g',0.33,NULL,NULL,NULL,NULL,NULL,1,179.25525,25.92836,0,NULL,60539302092,945926595,14780103,16.1),(86915,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86915,34.77,0.47,89.9,36004,70,NULL,NULL,'IC 0747',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.01',NULL,NULL,NULL,NULL,NULL,NULL,1,179.270417,-8.29233,0.093,NULL,40851280551,638301258,9973457,15.01),(86916,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86916,36.86,0.46,236,36005,70,NULL,NULL,'2MASX J11570594+1938518',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,179.274833,19.64775,0.072,NULL,60210363174,940786924,14699795,NULL),(86917,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86917,37.06,0.46,258,36006,70,NULL,NULL,'2MASX J11570637-0058378',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000089,NULL,'16.2g',0.36,'AGN',NULL,NULL,NULL,NULL,1,179.2764583,-0.97719,0.017,NULL,40806156177,637596190,9962440,16.2),(86918,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86918,37.34,0.33,293,36007,70,NULL,NULL,'LCRS B115432.8-030403',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,179.2769583,-3.34589,0.045,NULL,40811959176,637686862,9963857,17.8),(86919,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86919,37.29,0.46,287,36008,70,NULL,NULL,'LCRS B115432.8-022015',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,179.2772917,-2.61583,0.021,NULL,40816698182,637760909,9965014,17.9),(86920,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86920,36.48,0.33,198,36009,70,NULL,NULL,'2MASX J11570742+6635119',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000077,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,179.2810417,66.58658,0,NULL,61807997167,965749955,15089843,16.3),(86921,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86921,37.49,0.33,315,36010,70,NULL,NULL,'2MASX J11570789+5404069',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,179.283083333,54.06858,0,NULL,61759898278,964998410,15078100,17.1),(86922,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86922,36.21,0.46,174,36011,70,NULL,NULL,'LCRS B115434.7-025716',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00014,NULL,'16.2g',0.26,'E0',NULL,NULL,NULL,NULL,1,179.285167,-3.233,0.045,NULL,40811972803,637687075,9963860,16.2),(86923,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86923,33.64,0.46,53.5,36012,70,NULL,NULL,'UGC 06927',NULL,'2015arXiv151105856S',2015,1,1.14,NULL,'G',0.000107,NULL,'14.0g',0.87,'S0','Group member',NULL,NULL,NULL,1,179.285417,30.39231,0,NULL,60558490978,946226421,14784787,14),(86924,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86924,37.37,0.27,298,36013,70,NULL,NULL,'2MASX J11570849+2110188',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.36',0.18,NULL,NULL,NULL,NULL,NULL,1,179.285458333,21.17183,0.093,NULL,60197308701,940582948,14696608,18.36),(86925,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86925,37.99,0.46,397,36014,70,NULL,NULL,'2MASX J11570862+2701374',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000144,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,179.285875,27.02706,0,NULL,60537237921,945894342,14779599,17.5),(86926,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86926,36.7,0.46,219,36015,70,NULL,NULL,'2MASX J11570889+5057306',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000184,NULL,'16.1g',0.35,'E0',NULL,NULL,NULL,NULL,1,179.287167,50.95844,0.039,NULL,61765471183,965085487,15079460,16.1),(86927,'GRB','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86927,42.47,NULL,3120,36016,70,NULL,'Pseudo z = 1.52','GRB 010126',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'ASM/Ulysses/Ko',NULL,NULL,NULL,NULL,1,179.2875,49.75,0.032,NULL,61745050610,964766415,15074475,NULL),(86928,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86928,37.87,0.46,375,36017,70,NULL,NULL,'2MASX J11570938+0338565',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000079,NULL,'18.3g',0.1,NULL,NULL,NULL,NULL,NULL,1,179.289083333,3.64911,0.044,NULL,60137804296,939653192,14682081,18.3),(86929,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86929,36.76,0.46,225,36018,70,NULL,NULL,'SBS 1154+578',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,179.291125,57.55431,0,NULL,61841179167,966268424,15097944,16.9),(86930,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86930,37.58,0.46,328,36019,70,NULL,NULL,'2MASX J11571003+0129425',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000082,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,179.2917917,1.49522,0.005,NULL,60130924552,939545696,14680401,17.2),(86931,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86931,35.25,0.56,112,36020,NULL,NULL,'Malmquist cor.','MCG -02-31-003',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'15.37',0.6,'SAB(rs)d:',NULL,NULL,NULL,NULL,1,179.292667,-14.27675,0.057,NULL,40963597281,640056207,10000878,15.37),(86932,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86932,35.51,0.5,127,36020,NULL,NULL,NULL,'MCG -02-31-003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86933,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86933,35.55,0.2,129,36020,74.4,NULL,NULL,'MCG -02-31-003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86934,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86934,37.49,0.33,315,36021,70,NULL,NULL,'2MASX J11571062+5404589',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,179.29425,54.08317,0,NULL,61759898045,964998406,15078100,17.2),(86935,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86935,38.57,0.46,517,36022,70,NULL,NULL,'SDSS J115711.71+030546.2',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000087,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,179.2987917,3.09619,0.053,NULL,60136719551,939636242,14681816,18.1),(86936,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86936,36.35,0.46,186,36023,70,NULL,NULL,'2MASX J11571201+5434169',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000163,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,179.299875,54.57136,0,NULL,61759377753,964990277,15077973,16.7),(86937,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86937,37.34,0.33,293,36024,70,NULL,NULL,'LCRS B115438.7-030425',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000143,NULL,'17.0g',0.28,'AGN',NULL,NULL,NULL,NULL,1,179.301583333,-3.35214,0.045,NULL,40812421163,637694080,9963970,17),(86938,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86938,36.63,0.23,212,36025,70,NULL,NULL,'2MASX J11571365+2736155',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000175,NULL,'18.06',0.18,NULL,NULL,NULL,NULL,NULL,1,179.30675,27.60439,0,NULL,60536471053,945882360,14779411,18.06),(86939,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86939,37.88,0.46,376,36026,70,NULL,NULL,'2MASX J11571605+1230579',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000166,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,179.316875,12.516,0,NULL,60234001968,941156280,14705566,17.4),(86940,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86940,37.54,0.1,322,36027,70,NULL,NULL,'2MASX J11571669+0511085',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,179.319625,5.18553,0,NULL,60188433009,940444265,14694441,17.3),(86941,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86941,36.21,0.33,175,36028,70,NULL,NULL,'2MASX J11571716+5010057',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00017,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,179.321417,50.16825,0.038,NULL,61745333938,964770842,15074544,16.2),(86942,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86942,38.09,0.46,415,36029,70,NULL,NULL,'2MASX J11571728+5003117',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,179.322167,50.05339,0.038,NULL,61745387012,964771672,15074557,17.9),(86943,'Tertiary','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86943,31.61,0.13,21,36030,NULL,NULL,'Ursa Major cluster','UGC 06930',NULL,'2002AJ....123.1179S',2002,1,4.4,NULL,'G',0.000001,NULL,'12.65',2.8,'SAB(s)d','in a radial-velocity based grouping',NULL,NULL,NULL,1,179.3222917,49.28308,0.054,NULL,61747975976,964812124,15075189,12.65),(86944,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86944,30.5,0.35,12.6,36030,NULL,NULL,'Ursa Major CLUSTER, 22 galaxies, Diameter relation','UGC 06930',NULL,'1977A&A....54..661T',1977,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86945,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86945,30.95,0.2,15.5,36030,85,NULL,'Ursa Major cluster','UGC 06930',NULL,'1988PASP..100R1224P',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86946,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86946,31.11,0.12,16.7,36030,75,NULL,'Ursa Major cluster, avg. of 32 spiral galaxies','UGC 06930',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86947,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86947,31.15,0.4,17,36030,75,NULL,'B','UGC 06930',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86948,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86948,31.16,0.12,17.1,36030,74.4,NULL,'Ursa Major CLUSTER, 34 galaxies, WISE W2 (4.6 micro-meter), color corrected','UGC 06930',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86949,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86949,31.17,0.12,17.2,36030,74.4,NULL,'Ursa Major CLUSTER, 34 galaxies, WISE W1 (3.4 micro-meter), color corrected','UGC 06930',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86950,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86950,31.18,0.07,17.2,36030,74.4,NULL,'Ursa Major CLUSTER, 34 galaxies, WISE W2 (4.6 micro-meter), curved','UGC 06930',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86951,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86951,31.2,0.1,17.4,36030,75,NULL,'Ursa Major CLUSTER','UGC 06930',NULL,'2012ApJ...749...78T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86952,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86952,31.21,0.07,17.5,36030,74.4,NULL,'Ursa Major CLUSTER, 34 galaxies, WISE W1 (3.4 micro-meter), curved','UGC 06930',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86953,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86953,31.21,0.12,17.5,36030,74.4,NULL,'Ursa Major CLUSTER, 34 galaxies, WISE I-band','UGC 06930',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86954,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86954,31.28,0.11,18,36030,75,NULL,'Ursa Major cluster, avg. of 32 spiral galaxies','UGC 06930',NULL,'2013ApJ...765...94S',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86955,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86955,31.35,0.4,18.6,36030,77,NULL,'Ursa Major CLUSTER, 38 galaxies','UGC 06930',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86956,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86956,31.35,NULL,18.6,36030,77,NULL,'BRIK, Ursa Major cluster, 38 galaxies','UGC 06930',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86957,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86957,31.48,NULL,19.8,36030,71,NULL,'Ursa Major CLUSTER, 40 galaxies','UGC 06930',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86958,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86958,31.55,0.18,20.4,36030,NULL,NULL,'Ursa Major CLUSTER, 6 galaxies, H(T)(T<=5)','UGC 06930',NULL,'2001ApJ...555..215W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86959,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86959,31.56,0.14,20.5,36030,NULL,NULL,'Ursa Major CLUSTER, 15 galaxies (H(-0.5)','UGC 06930',NULL,'2001ApJ...555..215W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86960,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86960,31.56,0.14,20.5,36030,NULL,NULL,'Ursa Major CLUSTER, 15 galaxies, H(19)','UGC 06930',NULL,'2001ApJ...555..215W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86961,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86961,31.57,0.14,20.6,36030,NULL,NULL,'Ursa Major CLUSTER, 15 galaxies, H(T)','UGC 06930',NULL,'2001ApJ...555..215W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86962,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86962,31.58,0.3,20.7,36030,NULL,NULL,'Ursa Major CLUSTER, 16 galaxies','UGC 06930',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86963,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86963,31.59,0.17,20.8,36030,NULL,NULL,'Ursa Major CLUSTER, 9 galaxies, H(T)(T<=4)','UGC 06930',NULL,'2001ApJ...555..215W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86964,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86964,38,0.46,398,36031,70,NULL,NULL,'2MASX J11571759+0318525',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000097,NULL,'17.1g',0.26,'NLAGN',NULL,NULL,NULL,NULL,1,179.3232083,3.31472,0.074,NULL,60136648488,939635132,14681798,17.1),(86965,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86965,36.17,0.27,171,36032,70,NULL,NULL,'2MASX J11571757+5226407',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,179.3234583,52.44456,0.01,NULL,61767049202,965110143,15079845,17.7),(86966,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86966,37.29,0.46,287,36033,70,NULL,NULL,'2MASX J11571769+4309011',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000146,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,179.32375,43.15028,0,NULL,60400466045,943757281,14746207,17.4),(86967,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86967,37.39,0.46,301,36034,70,NULL,NULL,'2MASX J11571812+0249545',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000104,NULL,'16.4g',0.36,'AGN',NULL,NULL,NULL,NULL,1,179.325375,2.83192,0.061,NULL,60135965670,939624463,14681632,16.4),(86968,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86968,37.54,0.1,322,36035,70,NULL,NULL,'2MASX J11571863+0503125',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,179.3275,5.05342,0,NULL,60188402972,940443796,14694434,17.2),(86969,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86969,36.79,0.46,228,36036,70,NULL,NULL,'2MASX J11571901+5711578',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,179.329,57.19953,0.021,NULL,61841752446,966277381,15098084,17.2),(86970,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:02','1','PTF10gmd','N',86970,36.95,0.02,233,36037,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10gmd',0.0552,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86971,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:02','1','SN 2001V',NULL,86971,33.09,0.2,40.9,36038,74.2,NULL,'SALT 2','NGC 3987',0.01502,'2010ApJ...716..712A',2010,1,2.2,NULL,'G',0.000017,NULL,'12.9B',0.4,'Sb             LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,179.337167,25.19539,0,NULL,60547080662,946048135,14782002,12.9),(86972,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:02','1','SN 2001V',NULL,86972,33.73,0.02,54.9,36038,70,NULL,'SALT 2','NGC 3987',0.01502,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86973,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:02','1','SN 2001V',NULL,86973,33.75,0.09,56.2,36038,74.4,NULL,NULL,'NGC 3987',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86974,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:02','1','SN 2001V',NULL,86974,33.81,0.25,56.9,36038,73.8,NULL,'SALT 2 (SNANA)','NGC 3987',0.0164,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86975,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:02','1','SN 2001V',NULL,86975,33.83,0.05,57.5,36038,72,NULL,NULL,'NGC 3987',0.01502,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86976,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:02','1','SN 2001V',NULL,86976,33.84,0.19,57.8,36038,70,NULL,'SALT 2','NGC 3987',0.01502,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86977,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:02','1','SN 2001V',NULL,86977,33.86,0.26,58.1,36038,73.8,NULL,'SALT 2 (SNANA)','NGC 3987',0.0165,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86978,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:02','1','SN 2001V',NULL,86978,33.92,0.26,59.9,36038,72,NULL,NULL,'NGC 3987',0.01502,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86979,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:02','1','SN 2001V',NULL,86979,34.05,0.2,63.5,36038,65,NULL,'MLCS17','NGC 3987',0.01502,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86980,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:02','1','SN 2001V',NULL,86980,34.08,0.21,64.6,36038,65,NULL,'MLCS31','NGC 3987',0.01502,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86981,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:02','1','SN 2001V',NULL,86981,34.08,0.14,65.5,36038,60,NULL,NULL,'NGC 3987',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86982,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:02','1','SN 2001V',NULL,86982,34.11,0.01,65.5,36038,65,NULL,'SALT','NGC 3987',0.01502,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86983,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:02','1','SN 2001V',NULL,86983,34.13,0.23,66,36038,65,NULL,NULL,'NGC 3987',0.01502,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86984,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:02','1','SN 2001V',NULL,86984,34.14,0.08,66.4,36038,65,NULL,'MLCS2k2','NGC 3987',0.01502,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86985,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:02','1','SN 2001V',NULL,86985,34.19,0.07,66.8,36038,65,NULL,'MLCS2k2','NGC 3987',0.01502,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86986,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:02','1','SN 2001V',NULL,86986,34.17,0.17,68.2,36038,70.8,NULL,NULL,'NGC 3987',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86987,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:02','1','SN 2001V',NULL,86987,34.36,0.14,74.5,36038,NULL,NULL,'MLCS','NGC 3987',NULL,'2003A&A...397..115V',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86988,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86988,33.68,0.45,54.5,36038,NULL,NULL,'K','NGC 3987',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86989,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86989,33.74,0.47,56,36038,NULL,NULL,'H','NGC 3987',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86990,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86990,33.86,0.46,59.3,36038,NULL,NULL,'J','NGC 3987',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86991,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86991,33.95,0.49,61.6,36038,75,NULL,'IR','NGC 3987',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86992,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,86992,34.22,0.4,70,36038,NULL,NULL,'mean','NGC 3987',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86993,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86993,38.14,0.46,424,36039,70,NULL,NULL,'2MASX J11572121+3119199',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,179.338416667,31.32231,0,NULL,60551943756,946124121,14783189,18.1),(86994,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86994,37.38,0.46,299,36040,70,NULL,NULL,'2MASX J11572132+4235431',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000174,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,179.338875,42.59533,0,NULL,60400958489,943764976,14746327,16.4),(86995,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86995,36.56,0.33,205,36041,70,NULL,NULL,'VII Zw 431',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000117,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,179.3405417,58.53478,0,NULL,61842749847,966292966,15098327,16.5),(86996,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86996,37.61,0.46,333,36042,70,NULL,NULL,'SDSS J115721.87+081756.2',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,179.341125,8.29894,0,NULL,60160077609,940001212,14687518,17.4),(86997,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86997,37.47,0.46,311,36043,70,NULL,NULL,'2MASX J11572212+2525436',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00017,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,179.3422917,25.42872,0,NULL,60538625800,945916028,14779937,16.7),(86998,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86998,36.61,0.23,210,36044,70,NULL,NULL,'2MASX J11572322+1335187',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000177,NULL,'16.1g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,179.346667,13.58842,0.029,NULL,60245071356,941329239,14708269,16.1),(86999,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',86999,35.9,0.46,151,36045,70,NULL,NULL,'2MASX J11572401+2955376',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000073,NULL,'15.8g',0.39,NULL,NULL,NULL,NULL,NULL,1,179.35,29.92708,0,NULL,60559218226,946237784,14784965,15.8),(87000,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87000,37.53,0.33,321,36046,70,NULL,NULL,'2MASX J11572404+4826057',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000167,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,179.35,48.435,0.046,NULL,61747318240,964801847,15075028,18.3),(87001,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87001,34.59,0.46,82.9,36047,70,NULL,NULL,'NGC 3988',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000077,NULL,'14.3g',0.7,'E','Group member',NULL,NULL,NULL,1,179.350916667,27.87753,0,NULL,60591116374,946736193,14792753,14.3),(87002,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87002,31.2,0.43,17.3,36048,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06931',NULL,'2014MNRAS.444..527S',2014,1,1.4,'VV misprints R.A. as 11h41.4m.','G',0.000017,NULL,'14.31',1,'SBm:           HII','Group member',NULL,NULL,NULL,1,179.35375,57.93,0,NULL,61842424788,966287887,15098248,14.31),(87003,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87003,38.33,0.46,463,36049,70,NULL,NULL,'2MASX J11572638+2956009',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000148,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,179.3599583,29.93369,0,NULL,60559220450,946237819,14784965,17.5),(87004,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87004,37.54,0.1,322,36050,70,NULL,NULL,'SDSS J115726.42+050552.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,179.360083,5.09797,0,NULL,60188403790,940443809,14694434,17.9),(87005,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87005,36.24,0.46,177,36051,70,NULL,NULL,'2MASX J11572877+1631227',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000113,NULL,'15.5g',0.5,NULL,NULL,NULL,NULL,NULL,1,179.3700417,16.52289,0.098,NULL,60251352955,941427389,14709802,15.5),(87006,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87006,37.12,0.46,266,36052,70,NULL,NULL,'2MASX J11572893+4435171',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000184,NULL,'16.2g',0.32,NULL,NULL,NULL,NULL,NULL,1,179.370583,44.58817,0,NULL,60398086776,943720105,14745626,16.2),(87007,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87007,37.54,0.1,322,36053,70,NULL,NULL,'MCG +01-31-003',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',NULL,NULL,'15.4g',0.49,'BrClG',NULL,NULL,NULL,NULL,1,179.370708333,5.08906,0,NULL,60188405776,940443840,14694435,15.4),(87008,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87008,36.5,0.46,200,36054,70,NULL,NULL,'2MASX J11573004+0036089',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000066,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,179.375041667,0.60256,0.041,NULL,60130388206,939537315,14680270,16.8),(87009,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87009,37.54,0.1,322,36055,70,NULL,NULL,'2MASX J11573073+0504469',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000177,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,179.3780417,5.07978,0,NULL,60188405898,940443842,14694435,17.7),(87010,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87010,34.3,0.49,72.5,36056,75,NULL,'IR','UGC 06934',NULL,'2011yCatp016004901K',2011,1,1.85,NULL,'G',0.000017,NULL,'14.99',0.24,'SA(r)cd: sp',NULL,NULL,NULL,NULL,1,179.382625,-1.25294,0.041,NULL,40805784129,637590377,9962349,14.99),(87011,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87011,34.4,NULL,76,36056,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 06934',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87012,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87012,34.41,NULL,76.2,36056,NULL,NULL,'Dipole','UGC 06934',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87013,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87013,34.42,NULL,76.4,36056,NULL,NULL,'Dipole + Quadrupole','UGC 06934',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87014,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87014,34.61,0.2,83.6,36056,74.4,NULL,NULL,'UGC 06934',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87015,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87015,34.68,0.34,86.5,36056,NULL,NULL,'Malmquist cor.','UGC 06934',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87016,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87016,34.78,0.33,90.5,36056,NULL,NULL,NULL,'UGC 06934',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87017,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87017,34.95,NULL,97.5,36056,NULL,NULL,NULL,'UGC 06934',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87018,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87018,36.45,0.46,195,36057,70,NULL,NULL,'2MASX J11573223+3000520',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00019,NULL,'15.6g',0.48,NULL,NULL,NULL,NULL,NULL,1,179.384417,30.01433,0,NULL,60559442272,946241285,14785020,15.6),(87019,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87019,37.54,0.1,322,36058,70,NULL,NULL,'2MASX J11573261+0502509',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000187,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,179.385875,5.04761,0,NULL,60188400362,940443755,14694433,16.9),(87020,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87020,36.04,0.33,162,36059,70,NULL,NULL,'2MASX J11573279+1112117',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000167,NULL,'15.9g',0.45,'S0',NULL,NULL,NULL,NULL,1,179.386583333,11.20322,0,NULL,60364543823,943195997,14737437,15.9),(87021,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87021,36.96,0.46,247,36060,70,NULL,NULL,'2MASX J11573282+3232530',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000152,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,179.38675,32.54808,0.041,NULL,60549692798,946088949,14782639,17.1),(87022,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87022,37.44,0.46,307,36061,70,NULL,NULL,'2MASX J11573318+2650506',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000161,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,179.388291667,26.84756,0,NULL,60537102989,945892234,14779566,17.1),(87023,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87023,37.54,0.1,322,36062,70,NULL,NULL,'2MASX J11573435+0505519',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,179.393041667,5.09772,0,NULL,60188398750,940443730,14694433,16.7),(87024,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87024,38.01,0.19,401,36063,70,NULL,NULL,'2MASX J11573546+3343309',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,179.397917,33.72547,0,NULL,60616317358,947129958,14798905,18.1),(87025,'SBF','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87025,30.01,0.14,10.1,36064,74.4,NULL,NULL,'NGC 3990',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000133,NULL,'13.43',0.8,'S0-: sp','in a radial-velocity based grouping',NULL,NULL,NULL,1,179.398166667,55.45867,0,NULL,61757539135,964961548,15077524,13.43),(87026,'SBF','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87026,30.06,0.28,10.3,36064,NULL,NULL,'I','NGC 3990',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87027,'Tully est','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87027,31.15,0.8,17,36064,75,NULL,'B','NGC 3990',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87028,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87028,31.87,0.4,23.7,36064,NULL,NULL,'mean','NGC 3990',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87029,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87029,32.96,0.45,39.1,36064,NULL,NULL,'K','NGC 3990',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87030,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:02','1','SN 1956A',NULL,87030,31.78,0.3,22.7,36065,60,NULL,'M(V) = -19.47 mag','MESSIER 109',NULL,'2000ApJ...540..634P',2000,1,7.6,NULL,'G',0.000004,NULL,'10.60',4.7,'SB(rs)bc;LINER HII','Possible field galaxy',NULL,NULL,NULL,1,179.399916667,53.37453,0.005,NULL,61770597264,965165582,15080712,10.6),(87031,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:02','1','SN 1956A',NULL,87031,31.96,0.3,24.7,36065,60,NULL,'M(B) = -19.48 mag','MESSIER 109',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87032,'Ring Diameter','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87032,30.2,0.76,11,36065,NULL,NULL,'Published at H = 100 km/s/Mpc','MESSIER 109',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87033,'Ring Diameter','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87033,30.6,0.6,13,36065,NULL,NULL,'Published at H = 100 km/s/Mpc','MESSIER 109',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87034,'IRAS','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87034,31.44,0.8,19.4,36065,75,NULL,'A82, H','MESSIER 109',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87035,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87035,31.15,0.4,17,36065,75,NULL,'B','MESSIER 109',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87036,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87036,31.4,0.3,19.1,36065,NULL,18.45,'SN 1956A host','MESSIER 109',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87037,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87037,31.46,NULL,19.6,36065,NULL,NULL,'B','MESSIER 109',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87038,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87038,31.47,NULL,19.7,36065,NULL,NULL,'I','MESSIER 109',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87039,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87039,31.53,NULL,20.2,36065,NULL,NULL,'B','MESSIER 109',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87040,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87040,31.58,NULL,20.7,36065,NULL,NULL,'I, Hubble-type-TF','MESSIER 109',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87041,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87041,31.68,NULL,21.7,36065,NULL,NULL,'B, Hubble-type-TF','MESSIER 109',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87042,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87042,31.79,NULL,22.8,36065,NULL,NULL,'I','MESSIER 109',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87043,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87043,31.8,0.35,22.9,36065,NULL,NULL,NULL,'MESSIER 109',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87044,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87044,31.96,NULL,24.7,36065,NULL,NULL,'LEDA [Nov 2006]','MESSIER 109',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87045,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87045,32.14,0.2,26.8,36065,74.4,NULL,NULL,'MESSIER 109',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87046,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87046,32.16,0.43,27,36065,75,NULL,'3.6 micron, color corrected','MESSIER 109',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87047,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87047,32.31,0.43,29,36065,75,NULL,'3.6 micron, color + selection bias corrected','MESSIER 109',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87048,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87048,32.46,0.47,31,36065,75,NULL,'A82, H, raw','MESSIER 109',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87049,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87049,32.74,0.47,35.3,36065,75,NULL,'A82, H, inv','MESSIER 109',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87050,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87050,32.79,0.47,36.2,36065,75,NULL,'A82, H, cor','MESSIER 109',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87051,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87051,37.2,0.46,275,36066,70,NULL,NULL,'2MASX J11573650+3107130',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000188,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,179.4022083,31.12036,0,NULL,60551265821,946113528,14783023,16.2),(87052,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87052,38.31,0.46,460,36067,70,NULL,NULL,'2MASX J11573656+1647477',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,179.402333333,16.79661,0.1,NULL,60251306984,941426671,14709791,17.6),(87053,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87053,33.95,0.49,61.7,36068,75,NULL,'IR','NGC 3993',NULL,'2011yCatp016004901K',2011,1,1.89,NULL,'G',0.00003,NULL,'14.2g',0.46,'Sb: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,179.407583,25.24061,0,NULL,60547109738,946048589,14782009,14.2),(87054,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87054,34.39,0.4,75.4,36068,NULL,NULL,'mean','NGC 3993',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87055,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87055,34.49,0.47,79.2,36068,NULL,NULL,'H','NGC 3993',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87056,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87056,34.6,0.46,83.1,36068,NULL,NULL,'J','NGC 3993',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87057,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87057,34.66,0.45,85.4,36068,NULL,NULL,'K','NGC 3993',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87058,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87058,36.97,0.46,248,36069,70,NULL,NULL,'2MASX J11573800+4908306',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000165,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,179.4082917,49.14194,0.054,NULL,61747970100,964812032,15075188,16.9),(87059,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87059,36,0.72,158,36070,70,NULL,NULL,'2MASX J11573808-3203500',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.2b',0.3,'S0',NULL,NULL,NULL,NULL,1,179.408625,-32.06394,0.341,NULL,41443502028,647554719,10118042,16.2),(87060,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87060,37.86,0.46,374,36071,70,NULL,NULL,'2MASX J11573811+0802222',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00017,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,179.4087917,8.0395,0,NULL,60160125218,940001956,14687530,17.2),(87061,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87061,38.01,0.19,401,36072,70,NULL,NULL,'2MASX J11573819+3348379',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00018,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,179.40925,33.81058,0,NULL,60616194835,947128044,14798875,17.7),(87062,'GRB','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87062,42.28,NULL,2860,36073,71,NULL,NULL,'GRB 090530',NULL,'2011A&A...526A.153K',2011,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,179.418666667,26.59358,0,NULL,60540050531,945938289,14780285,NULL),(87063,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87063,37.46,0.46,310,36074,70,NULL,NULL,'2MASX J11574064+3942265',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00017,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,179.4195,39.70742,0,NULL,60406546342,943852286,14747691,16.5),(87064,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87064,38.63,0.46,533,36075,70,NULL,NULL,'2MASX J11574100+0242089',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.0001,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,179.420875,2.70247,0.07,NULL,60144353208,939755518,14683679,17.9),(87065,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87065,37.53,0.33,321,36076,70,NULL,NULL,'2MASX J11574110+4841146',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000186,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,179.4212917,48.68725,0.053,NULL,61747386384,964802912,15075045,16.9),(87066,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87066,37.54,0.1,322,36077,70,NULL,NULL,'2MASX J11574245+0512029',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00017,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,179.426875,5.20081,0,NULL,60188445906,940444467,14694444,17.8),(87067,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87067,38.01,0.19,401,36078,70,NULL,NULL,'2MASX J11574258+3335429',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,179.427416667,33.59539,0,NULL,60616340877,947130326,14798911,17.3),(87068,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87068,37.76,0.46,356,36079,70,NULL,NULL,'2MASX J11574261+3308099',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000199,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,179.427667,33.13622,0.009,NULL,60549063926,946079123,14782486,17.1),(87069,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87069,36.04,0.33,162,36080,70,NULL,NULL,'2MASX J11574286+1107442',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000162,NULL,'16.3g',0.42,NULL,NULL,NULL,NULL,NULL,1,179.428583,11.12889,0,NULL,60364541814,943195965,14737436,16.3),(87070,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87070,34.26,0.46,71.2,36081,70,NULL,NULL,'UGC 06939',NULL,'2015arXiv151105856S',2015,1,1.05,NULL,'G',0.000123,NULL,'14.2g',0.86,'S0^-',NULL,NULL,NULL,NULL,1,179.4287083,57.56583,0,NULL,61841099950,966267186,15097924,14.2),(87071,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87071,38.18,0.46,432,36082,70,NULL,NULL,'SDSS J115743.17+070250.4',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,179.429917,7.04733,0,NULL,60156419345,939944052,14686625,18),(87072,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87072,37.54,0.1,322,36083,70,NULL,NULL,'SDSS J115743.76+050816.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000168,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,179.432375,5.13789,0,NULL,60188454130,940444595,14694446,18),(87073,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87073,32.47,0.69,31.2,36084,100,NULL,'mid-IR','NGC 3995',NULL,'2013ApJ...771...88L',2013,1,1.89,NULL,'G',0.000017,NULL,'12.9g',0.78,'SAm pec;WR?    HII','in a triple',NULL,NULL,NULL,1,179.43375,32.29406,0.018,NULL,60552616503,946134632,14783353,12.9),(87074,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87074,37.52,0.46,320,36085,70,NULL,NULL,'2MASX J11574464+6345284',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000202,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,179.435833,63.75794,0,NULL,61817476961,965898077,15092157,16.5),(87075,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87075,37.54,0.1,322,36086,70,NULL,NULL,'2MASX J11574499+0511359',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000192,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,179.4372917,5.19339,0,NULL,60188445424,940444459,14694444,16.9),(87076,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87076,37.95,0.46,389,36087,70,NULL,NULL,'2MASX J11574589+0336329',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000179,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,179.441083,3.60922,0.044,NULL,60136172263,939627691,14681682,17.9),(87077,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87077,37.54,0.1,322,36088,70,NULL,NULL,'2MASX J11574653+0503119',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,179.443875,5.05319,0,NULL,60133813903,939590842,14681106,17.1),(87078,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87078,36.61,0.51,210,36089,70,NULL,NULL,'2MASX J11574658-1701301',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.98',NULL,NULL,NULL,NULL,NULL,NULL,1,179.444083333,-17.02511,0.065,NULL,40940726782,639698855,9995294,15.98),(87079,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87079,38.09,0.33,415,36090,70,NULL,NULL,'SDSS J115746.70+001751.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000083,NULL,'18.5g',0.13,'NLAGN',NULL,NULL,NULL,'Sy 2',1,179.444625,0.2975,0.057,NULL,60130447127,939538236,14680284,18.5),(87080,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87080,37.54,0.1,322,36091,70,NULL,NULL,'2MASX J11574706+0515159',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000178,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,179.4459583,5.25436,0,NULL,60188435264,940444301,14694442,17.2),(87081,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87081,37.79,0.27,361,36092,70,NULL,NULL,'LCRS B115513.5-021523',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000186,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,179.4467083,-2.53481,0.049,NULL,40816030633,637750478,9964851,18.1),(87082,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87082,31.98,0.36,24.9,36093,NULL,NULL,NULL,'UGC 06940',NULL,'2009AJ....138..323T',2009,1,1,NULL,'G',0.000006,NULL,'16.1g',0.26,'Scd',NULL,NULL,NULL,NULL,1,179.4482917,53.23447,0,NULL,61766604041,965103188,15079737,16.1),(87083,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87083,36.73,0.46,222,36094,70,NULL,NULL,'2MASX J11574813+4252420',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000185,NULL,'16.0g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,179.45075,42.87828,0,NULL,60401087689,943766995,14746359,16),(87084,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87084,34.35,0.4,74.3,36095,NULL,NULL,'mean','NGC 3997',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000017,NULL,'14.02',0.6,'SBb pec        HII','in a radial-velocity based grouping',NULL,NULL,'Emission-Line Galaxy',1,179.450958333,25.27064,0,NULL,60547111330,946048614,14782009,14.02),(87085,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87085,34.62,0.47,84.1,36095,NULL,NULL,'H','NGC 3997',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87086,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87086,36.15,0.46,170,36096,70,NULL,NULL,'2MASX J11574951+3721094',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000163,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,179.4564583,37.35256,0,NULL,60438169871,944346404,14755412,16.2),(87087,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87087,38.01,0.19,401,36097,70,NULL,NULL,'2MASX J11575076+3340029',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,179.4614583,33.66742,0,NULL,60616321961,947130030,14798906,17.7),(87088,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87088,35.52,0.33,127,36098,70,NULL,NULL,'CGCG 127-113',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00007,NULL,'15.5',0.4,'E',NULL,NULL,NULL,NULL,1,179.463458333,22.25811,0.053,NULL,61069321901,954208154,14909502,15.5),(87089,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87089,38.01,0.19,401,36099,70,NULL,NULL,'2MASX J11575130+3343189',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,179.463791667,33.72181,0,NULL,60616327094,947130110,14798907,17.8),(87090,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87090,37.54,0.1,322,36100,70,NULL,NULL,'SDSS J115751.42+050654.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000178,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,179.4642917,5.11528,0,NULL,60188450936,940444545,14694446,17.8),(87091,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87091,37.54,0.1,322,36101,70,NULL,NULL,'2MASX J11575181+0503369',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000201,NULL,'16.1g',0.39,NULL,NULL,NULL,NULL,NULL,1,179.465917,5.06044,0,NULL,60133810738,939590792,14681106,16.1),(87092,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87092,38.04,0.46,406,36102,70,NULL,NULL,'2MASX J11575343+4549060',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000175,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,179.4727083,45.81844,0,NULL,61741093865,964704591,15073509,17.8),(87093,'TRGB','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87093,29.71,0.1,8.75,36103,74.4,NULL,NULL,'SDSS J115754.18+563816.6',NULL,'2013AJ....146...86T',2013,1,0.35,NULL,'G',0.000169,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,179.47575,56.63797,0,NULL,61841043460,966266304,15097911,16.9),(87094,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87094,37.54,0.1,322,36104,70,NULL,NULL,'SDSS J115754.49+050251.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000167,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,179.477083,5.04769,0,NULL,60133857023,939591515,14681117,18.3),(87095,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87095,38.27,0.46,450,36105,70,NULL,NULL,'SDSS J115754.73+091603.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,179.478041667,9.26758,0,NULL,60148799252,939824988,14684765,18.3),(87096,'SBF','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87096,30.75,0.19,14.1,36106,NULL,NULL,'I','NGC 3998',NULL,'2001ApJ...546..681T',2001,1,2.7,NULL,'G',0.000017,NULL,'11.61',2.2,'SA(r)0^0^?;Sy1;LINER','in a radial-velocity based grouping',NULL,NULL,'Flat-Spectrum Radio Source',1,179.483875,55.45358,0,NULL,61757540907,964961576,15077524,11.61),(87097,'SBF','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87097,30.76,0.14,14.2,36106,74.4,NULL,NULL,'NGC 3998',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87098,'Faber-Jackson','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87098,29.8,0.63,9.12,36106,95,NULL,'Michard 1979b, c','NGC 3998',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87099,'Faber-Jackson','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87099,30.51,0.46,12.6,36106,95,NULL,'Michard 1979a','NGC 3998',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87100,'Faber-Jackson','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87100,31.26,0.26,17.9,36106,95,NULL,'Weighted Mean','NGC 3998',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87101,'Faber-Jackson','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87101,32,0.38,25.1,36106,95,NULL,'de Vaucouleurs','NGC 3998',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87102,'Faber-Jackson','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87102,32.78,NULL,36,36106,NULL,NULL,'LEDA [April 2006]','NGC 3998',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87103,'Faber-Jackson','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87103,32.92,0.81,38.4,36106,55,NULL,'Visvanathan & Sandage 1979','NGC 3998',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87104,'Tertiary','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87104,31,0.21,15.8,36106,95,NULL,NULL,'NGC 3998',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87105,'Tully est','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87105,31.67,0.8,21.6,36106,75,NULL,'B','NGC 3998',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87106,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87106,31.43,0.4,19.4,36106,NULL,NULL,'mean','NGC 3998',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87107,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87107,32.57,0.45,32.6,36106,NULL,NULL,'K','NGC 3998',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87108,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87108,38.93,0.46,610,36107,70,NULL,NULL,'2MASX J11575636+1340090',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,179.4850417,13.66928,0.019,NULL,60245045959,941328843,14708263,18.2),(87109,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87109,38.33,0.46,462,36108,70,NULL,NULL,'2MASX J11575650+2034320',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,179.485625,20.57556,0.068,NULL,60199132146,940611439,14697053,17.7),(87110,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87110,38.09,0.33,415,36109,70,NULL,NULL,'2MASX J11575682+0012212',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000086,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,179.48675,0.20581,0.069,NULL,60130419710,939537807,14680278,17.4),(87111,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87111,34.03,0.49,63.8,36110,75,NULL,'IR','NGC 4000',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.00002,NULL,'15.47',0.2,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,179.487583333,25.14447,0,NULL,60547124056,946048813,14782012,15.47),(87112,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87112,37.19,0.46,275,36111,70,NULL,NULL,'2MASX J11575717+3135470',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,179.488291667,31.59636,0,NULL,60552085359,946126333,14783223,17.8),(87113,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87113,37.53,0.46,321,36112,70,NULL,NULL,'2MASX J11575730+4508490',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000182,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,179.488875,45.14692,0,NULL,63887669391,998244834,15597575,17.1),(87114,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87114,37.63,0.46,336,36113,70,NULL,NULL,'2MASX J11575737+0322242',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000033,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,179.489,3.37344,0.062,NULL,60136661974,939635343,14681802,16.8),(87115,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87115,35.07,0.4,103,36114,NULL,NULL,'mean','NGC 4003',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000107,NULL,'14.28',0.9,'SB0','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,179.496,23.12489,0.039,NULL,60533207933,945831373,14778615,14.28),(87116,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87116,35.33,0.45,116,36114,NULL,NULL,'K','NGC 4003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87117,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87117,36.65,0.46,213,36115,70,NULL,NULL,'2MASX J11575920+4918378',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,179.496833,49.31047,0.041,NULL,61747809782,964809527,15075148,17.8),(87118,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87118,37.85,0.46,371,36116,70,NULL,NULL,'2MASX J11580084+3545570',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000188,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,179.503375,35.76589,0,NULL,60433572686,944274573,14754290,17.2),(87119,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87119,38.12,0.46,422,36117,70,NULL,NULL,'2MASX J11580146-0122454',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000179,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,179.5060417,-1.37931,0.041,NULL,40805756784,637589949,9962342,17.4),(87120,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87120,38,0.46,398,36118,70,NULL,NULL,'SDSS J115801.77+421841.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,179.507417,42.31142,0,NULL,60400291187,943754549,14746164,18.1),(87121,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87121,36.37,0.33,188,36119,70,NULL,NULL,'ARK 338',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.000097,NULL,'14.8g',0.72,'E0',NULL,NULL,NULL,NULL,1,179.5115417,5.91225,0,NULL,60155588937,939931077,14686423,14.8),(87122,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87122,38.15,0.46,426,36120,70,NULL,NULL,'SDSS J115803.05+064723.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,179.51275,6.78978,0,NULL,60158639803,939978746,14687167,17.9),(87123,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87123,36.98,0.15,249,36121,70,NULL,NULL,'SDSS J115803.85+103853.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,179.5160417,10.64822,0,NULL,60146447913,939788248,14684191,17.9),(87124,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87124,37.81,0.46,364,36122,70,NULL,NULL,'2MASX J11580557+1315440',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,179.523375,13.26233,0,NULL,60232244164,941128815,14705137,17.3),(87125,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87125,36.14,0.46,169,36123,70,NULL,NULL,'2MASX J11580592+4425310',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,179.524833,44.42544,0,NULL,60398177919,943721529,14745648,16.5),(87126,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87126,37.72,0.17,350,36124,70,NULL,NULL,'2MASX J11580596+3049080',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000137,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,179.524875,30.81878,0,NULL,60562850808,946294543,14785852,17.3),(87127,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87127,37.68,0.46,343,36125,70,NULL,NULL,'2MASX J11580672+4814048',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000174,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,179.528,48.23461,0.037,NULL,61746704202,964792253,15074878,17),(87128,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87128,36.52,0.46,202,36126,70,NULL,NULL,'2MASX J11580676+3701110',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000148,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,179.528083333,37.01978,0,NULL,60438774387,944355849,14755560,16.9),(87129,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87129,36.88,0.46,238,36127,70,NULL,NULL,'2MASX J11580750+1733490',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,179.531208333,17.56358,0.078,NULL,60205860158,940716564,14698696,17.1),(87130,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87130,35.93,0.46,153,36128,70,NULL,NULL,'2MASX J11580754+2631221',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00014,NULL,'15.8g',0.5,NULL,NULL,NULL,NULL,NULL,1,179.531333,26.52289,0,NULL,60540017159,945937768,14780277,15.8),(87131,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87131,37.79,0.27,361,36129,70,NULL,NULL,'LCRS B115533.9-021633',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.00015,NULL,'16.2g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,179.5317917,-2.55408,0.049,NULL,40816081300,637751270,9964863,16.2),(87132,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87132,36.83,0.46,232,36130,70,NULL,NULL,'2MASX J11580808+1506030',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000174,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,179.5337083,15.10097,0.067,NULL,60237970146,941218283,14706535,16.3),(87133,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87133,37.97,0.33,392,36131,70,NULL,NULL,'2MASX J11580958+0457122',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,179.5397083,4.95342,0,NULL,60133829809,939591090,14681110,18),(87134,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87134,38.19,0.46,434,36132,70,NULL,NULL,'2MASX J11580979+3302361',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,179.5409583,33.04333,0.009,NULL,60549958588,946093102,14782704,17.8),(87135,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87135,34.23,0.4,70.2,36133,NULL,NULL,'mean','NGC 4005',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000017,NULL,'13.89',0.7,'Sb','in a radial-velocity based grouping',NULL,NULL,NULL,1,179.542375,25.12225,0,NULL,60547095086,946048360,14782005,13.89),(87136,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87136,34.49,0.47,79.2,36133,NULL,NULL,'H','NGC 4005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87137,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87137,34.53,0.46,80.4,36133,NULL,NULL,'J','NGC 4005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87138,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87138,34.55,0.45,81.2,36133,NULL,NULL,'K','NGC 4005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87139,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87139,38.01,0.19,401,36134,70,NULL,NULL,'2MASX J11581022+3337331',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000177,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,179.54275,33.62592,0,NULL,60616298680,947129666,14798901,17.3),(87140,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87140,35.27,0.49,113,36135,75,NULL,'IR','ESO 572- G 029',NULL,'2011yCatp016004901K',2011,1,1.34,NULL,'G',0.000023,NULL,'15.35',0.18,'Sb',NULL,NULL,NULL,NULL,1,179.545833,-21.80844,0.105,NULL,40937277943,639644967,9994452,15.35),(87141,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87141,35.78,NULL,143,36135,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 572- G 029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87142,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87142,35.79,NULL,144,36135,NULL,NULL,'Dipole + Quadrupole','ESO 572- G 029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87143,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87143,35.81,NULL,145,36135,NULL,NULL,'Dipole','ESO 572- G 029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87144,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87144,37.28,0.1,286,36136,70,NULL,NULL,'SDSS J115813.54+555258.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000148,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,179.556417,55.88289,0,NULL,61757136589,964955259,15077425,18.4),(87145,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87145,37.63,0.23,335,36137,70,NULL,NULL,'2MASX J11581356+3104591',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,179.556667,31.08311,0,NULL,60551218228,946112784,14783012,17.4),(87146,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87146,36.12,0.46,168,36138,70,NULL,NULL,'2MASX J11581396+0625189',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,179.5582917,6.422,0,NULL,60155057154,939922768,14686293,16.6),(87147,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87147,37.53,0.46,320,36139,70,NULL,NULL,'2MASX J11581439+1629420',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000225,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,179.559875,16.495,0.098,NULL,60251326837,941426981,14709796,17.7),(87148,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87148,36.21,0.33,175,36140,70,NULL,NULL,'2MASX J11581545+5011217',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000194,NULL,'16.2g',0.34,'E0',NULL,NULL,NULL,NULL,1,179.564375,50.18944,0.038,NULL,61744527295,964758238,15074347,16.2),(87149,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87149,36.37,0.33,188,36141,70,NULL,NULL,'2MASX J11581579+0553382',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000171,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,179.565667,5.89408,0,NULL,60154872863,939919888,14686248,16.3),(87150,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87150,37.63,0.23,335,36142,70,NULL,NULL,'2MASX J11581651+3104101',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,179.568917,31.06942,0,NULL,60551285682,946113838,14783028,17.3),(87151,'D-Sigma','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87151,33.03,0.4,40.3,36143,75,NULL,'Edat, raw','NGC 4008',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000073,NULL,'12.96',1.3,'E5','in a radial-velocity based grouping',NULL,NULL,NULL,1,179.571,28.1925,0,NULL,60557508612,946211072,14784548,12.96),(87152,'D-Sigma','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87152,33.36,0.4,47.1,36143,75,NULL,'Edat, cor','NGC 4008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87153,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87153,33.28,0.45,45.2,36143,NULL,NULL,'K','NGC 4008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87154,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87154,33.87,0.4,59.5,36143,NULL,NULL,'mean','NGC 4008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87155,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87155,37.14,0.46,269,36144,70,NULL,NULL,'SDSS J115817.58+101629.8',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,179.5732917,10.27497,0,NULL,60147348129,939802314,14684411,17.6),(87156,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87156,38.14,0.46,425,36145,70,NULL,NULL,'2MASX J11581842+2448320',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.78',0.14,NULL,NULL,NULL,NULL,NULL,1,179.576625,24.80886,0,NULL,60533330687,945833291,14778645,18.78),(87157,'IRAS','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87157,33.54,0.8,51,36146,75,NULL,'MAT, I','ESO 321- G 001',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'13.53',1.1,'SA(s)c         HII',NULL,NULL,NULL,NULL,1,179.578667,-39.55069,0.441,NULL,41343499347,645992177,10093627,13.53),(87158,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87158,32.81,0.69,36.5,36146,100,NULL,'mid-IR','ESO 321- G 001',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87159,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87159,32.92,0.32,38.4,36146,85,NULL,'I, raw','ESO 321- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87160,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87160,32.96,0.32,39.1,36146,85,NULL,'I, inv','ESO 321- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87161,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87161,33.06,0.2,40.9,36146,74.4,NULL,NULL,'ESO 321- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87162,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87162,33.09,0.43,41.4,36146,75,NULL,'MAT, I, raw','ESO 321- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87163,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87163,33.21,0.43,43.8,36146,NULL,NULL,'Malmquist cor.','ESO 321- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87164,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87164,33.26,0.43,44.9,36146,75,NULL,'MAT, I, inv','ESO 321- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87165,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87165,33.26,0.43,44.9,36146,75,NULL,'MAT, I, cor','ESO 321- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87166,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87166,33.31,0.41,46,36146,NULL,NULL,NULL,'ESO 321- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87167,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87167,33.81,0.4,57.8,36146,NULL,NULL,'mean','ESO 321- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87168,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87168,34.04,0.47,64.3,36146,NULL,NULL,'H','ESO 321- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87169,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87169,34.07,0.46,65.3,36146,NULL,NULL,'J','ESO 321- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87170,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87170,34.15,0.45,67.5,36146,NULL,NULL,'K','ESO 321- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87171,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87171,38.94,0.46,614,36147,70,NULL,NULL,'2MASX J11581961+2739510',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000141,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,179.58175,27.66425,0,NULL,60536623131,945884736,14779449,18.1),(87172,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87172,37.43,0.46,307,36148,70,NULL,NULL,'2MASX J11581965+1225043',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,179.5817917,12.41794,0,NULL,60234094055,941157719,14705589,17.3),(87173,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87173,37.86,0.46,373,36149,70,NULL,NULL,'2MASX J11582059-0209464',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000195,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,179.585833,-2.16292,0.037,NULL,40804466581,637569790,9962027,16.9),(87174,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87174,37.97,0.33,392,36150,70,NULL,NULL,'2MASX J11582162+0456202',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00014,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,179.59,4.93892,0,NULL,60133821424,939590959,14681108,17.5),(87175,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87175,37.77,0.46,358,36151,70,NULL,NULL,'2MASX J11582177+6519288',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,179.5910417,65.32464,0.029,NULL,61809484596,965773196,15090206,17.8),(87176,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87176,37.72,0.17,350,36152,70,NULL,NULL,'2MASX J11582230+3045432',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,179.592833333,30.76214,0,NULL,60562646461,946291350,14785802,17.6),(87177,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87177,37.66,0.46,340,36153,70,NULL,NULL,'2MASX J11582317+3502552',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000182,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,179.5965,35.04864,0,NULL,60435254790,944300856,14754700,17.8),(87178,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87178,37.49,0.46,315,36154,70,NULL,NULL,'2MASX J11582342+0033072',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000085,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,179.5974583,0.55192,0.069,NULL,60130552495,939539882,14680310,16.5),(87179,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87179,37.14,0.33,268,36155,70,NULL,NULL,'2MASX J11582424+1525443',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000168,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,179.6009583,15.42892,0.086,NULL,60238041046,941219391,14706552,16.8),(87180,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87180,35.81,0.46,145,36156,70,NULL,NULL,'2MASX J11582426+3038582',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00006,NULL,'15.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,179.601125,30.64961,0,NULL,60558426536,946225414,14784772,15.5),(87181,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87181,38.01,0.33,400,36157,70,NULL,NULL,'2MASX J11582481-0004252',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000093,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,179.60325,-0.07383,0.033,NULL,40802303598,637535993,9961499,17),(87182,'IRAS','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87182,31.85,0.8,23.5,36158,75,NULL,'MAT, I','UGCA 257',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.000017,NULL,'13.6',1.7,'SB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,179.605875,-22.44008,0.141,NULL,41674647421,651166365,10174474,13.6),(87183,'Tully est','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87183,32.12,0.8,26.5,36158,75,NULL,NULL,'UGCA 257',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87184,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87184,30.76,0.32,14.2,36158,85,NULL,'I, inv','UGCA 257',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87185,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87185,30.81,0.32,14.5,36158,85,NULL,'I, raw','UGCA 257',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87186,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87186,30.97,0.4,15.6,36158,NULL,NULL,NULL,'UGCA 257',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87187,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87187,30.97,0.39,15.6,36158,73,NULL,'opt','UGCA 257',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87188,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87188,31.01,0.2,15.9,36158,74.4,NULL,NULL,'UGCA 257',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87189,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87189,31.03,0.43,16.1,36158,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 257',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87190,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87190,31.06,0.43,16.3,36158,75,NULL,'3.6 micron, color corrected','UGCA 257',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87191,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87191,31.52,0.43,20.2,36158,75,NULL,'MAT, I, inv','UGCA 257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87192,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87192,31.61,0.43,21,36158,75,NULL,'MAT, I, raw','UGCA 257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87193,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87193,31.8,0.43,23,36158,75,NULL,'MAT, I, cor','UGCA 257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87194,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87194,37.79,0.27,361,36159,70,NULL,NULL,'2MASX J11582548-0226322',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,179.606125,-2.44233,0.037,NULL,40815919757,637748746,9964824,18),(87195,'Tully est','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87195,31.15,0.8,17,36160,75,NULL,NULL,'UGC 06956',NULL,'1988NBGC.C....0000T',1988,1,0.83,NULL,'G',0.000013,NULL,'16.3g',0.4,'SB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,179.606667,50.917,0.037,NULL,61765363404,965083803,15079434,16.3),(87196,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87196,37.72,0.17,350,36161,70,NULL,NULL,'SDSS J115825.63+304533.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.4g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,179.6067917,30.75942,0,NULL,60562650873,946291419,14785803,17.4),(87197,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87197,37.13,0.46,266,36162,70,NULL,NULL,'2MASX J11582575+5512046',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000157,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,179.60725,55.20139,0,NULL,61757705567,964964149,15077564,16.9),(87198,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87198,37.72,0.17,350,36163,70,NULL,NULL,'2MASX J11582580+3044042',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000087,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,179.6075417,30.73456,0,NULL,60562650408,946291412,14785803,16.4),(87199,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87199,37.52,0.46,319,36164,70,NULL,NULL,'SDSS J115825.86-022202.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000094,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,179.60775,-2.36728,0.037,NULL,40804448811,637569512,9962023,18.2),(87200,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87200,37.72,0.17,350,36165,70,NULL,NULL,'2MASX J11582603+3045062',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000133,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,179.608375,30.75167,0,NULL,60562650884,946291420,14785803,17.4),(87201,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87201,33.99,0.4,62.7,36166,NULL,NULL,'mean','NGC 4012',NULL,'2007A&A...465...71T',2007,1,1.85,NULL,'G',0.000002,NULL,'14.0g',0.56,'Sb',NULL,NULL,NULL,NULL,1,179.614708333,10.0215,0,NULL,60147024269,939797254,14684332,14),(87202,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87202,34.01,0.47,63.5,36166,NULL,NULL,'H','NGC 4012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87203,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87203,34.06,0.46,64.9,36166,NULL,NULL,'J','NGC 4012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87204,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87204,34.11,0.2,66.4,36166,74.4,NULL,NULL,'NGC 4012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87205,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87205,34.13,0.45,66.8,36166,NULL,NULL,'K','NGC 4012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87206,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87206,37.14,0.33,268,36167,70,NULL,NULL,'2MASX J11582748+1531013',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000192,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,179.614708333,15.51719,0.086,NULL,60235075283,941173051,14705828,16.5),(87207,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87207,37.08,0.46,260,36168,70,NULL,NULL,'SDSS J115828.26+561921.4',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000174,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,179.6177917,56.32264,0,NULL,61975096143,968360877,15130638,16.9),(87208,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87208,37.25,0.46,282,36169,70,NULL,NULL,'2MASX J11582887+5234128',NULL,'2015arXiv151105856S',2015,1,0.43,'May contribute to the IR source IRAS F11559+5251.','G',0.000189,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,179.6202917,52.57028,0.009,NULL,61766983078,965109110,15079829,16.6),(87209,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87209,37.72,0.17,350,36170,70,NULL,NULL,'2MASX J11582928+3045462',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000172,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,179.622167,30.76294,0,NULL,60562652918,946291451,14785803,17.8),(87210,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87210,36.7,0.46,218,36171,70,NULL,NULL,'2MASX J11582949+2702231',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'17.44',0.19,NULL,NULL,NULL,NULL,NULL,1,179.622917,27.03978,0,NULL,60537125169,945892580,14779571,17.44),(87211,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87211,30.96,0.43,15.5,36172,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06955',NULL,'2014MNRAS.444..527S',2014,1,5,NULL,'G',0.000004,NULL,'13.8',2.6,'IB(s)m:','Probable group member',NULL,NULL,NULL,1,179.6242083,38.07633,0,NULL,60436286172,944316971,14754952,13.8),(87212,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87212,31.03,0.36,16.1,36172,NULL,NULL,NULL,'UGC 06955',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87213,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87213,31.2,0.43,17.4,36172,75,NULL,'3.6 micron, color corrected','UGC 06955',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87214,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87214,31.36,0.4,18.7,36172,75,NULL,'B','UGC 06955',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87215,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87215,31.37,0.2,18.8,36172,74.4,NULL,NULL,'UGC 06955',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87216,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87216,37.63,0.23,335,36173,70,NULL,NULL,'2MASX J11583042+3059072',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,179.626875,30.98547,0,NULL,60562622968,946290983,14785796,17.9),(87217,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87217,37.36,0.46,297,36174,70,NULL,NULL,'SBS 1155+578',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,179.62775,57.58986,0,NULL,61841105619,966267275,15097926,17.3),(87218,'SBF','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87218,32.4,0.48,30.2,36175,NULL,NULL,NULL,'NGC 4024',NULL,'2001MNRAS.327.1004B',2001,1,1.9,NULL,'G',0.00005,NULL,'13.18',1.5,'SB0^-','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,179.6302083,-18.34683,0.053,NULL,40943193650,639737400,9995896,13.18),(87219,'SBF','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87219,32.55,0.48,32.3,36175,NULL,NULL,'Malmquist cor.','NGC 4024',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87220,'D-Sigma','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87220,31.51,0.4,20.1,36175,75,NULL,'Edat, raw','NGC 4024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87221,'D-Sigma','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87221,31.71,0.4,22,36175,75,NULL,'Edat, cor','NGC 4024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87222,'Faber-Jackson','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87222,30.97,0.65,15.6,36175,95,NULL,'Weighted Mean','NGC 4024',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87223,'Faber-Jackson','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87223,32.18,0.81,27.3,36175,55,NULL,'Visvanathan & Sandage 1979','NGC 4024',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87224,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87224,31.8,0.41,22.9,36175,NULL,NULL,NULL,'NGC 4024',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87225,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87225,31.91,0.41,24.1,36175,NULL,NULL,'Malmquist cor.','NGC 4024',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87226,'Tertiary','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87226,30.44,0.38,12.2,36175,95,NULL,NULL,'NGC 4024',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87227,'Tully est','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87227,32.07,0.8,25.9,36175,75,NULL,'B','NGC 4024',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87228,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87228,32.27,0.4,28.4,36175,NULL,NULL,'mean','NGC 4024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87229,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87229,32.45,0.45,30.9,36175,NULL,NULL,'K','NGC 4024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87230,'IRAS','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87230,30.97,0.8,15.6,36176,75,NULL,'W91CL, r','NGC 4013',NULL,'1997ApJS..109..333W',1997,1,5.2,NULL,'G',0.000002,NULL,'12.1B',1,'SAb;HII        LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,179.63075,43.94658,0,NULL,60398709549,943729836,14745778,12.1),(87231,'IRAS','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87231,31.02,0.8,16,36176,75,NULL,'A82, H','NGC 4013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87232,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87232,30.98,0.07,15.7,36176,NULL,NULL,NULL,'NGC 4013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87233,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87233,31.1,0.4,16.6,36176,75,NULL,NULL,'NGC 4013',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87234,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87234,31.14,0.47,16.9,36176,75,NULL,'A82, H, raw','NGC 4013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87235,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87235,31.15,0.4,17,36176,75,NULL,'B','NGC 4013',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87236,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87236,31.26,0.43,17.8,36176,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4013',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87237,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87237,31.26,0.47,17.9,36176,75,NULL,'A82, H, inv','NGC 4013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87238,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87238,31.36,0.47,18.7,36176,75,NULL,'A82, H, cor','NGC 4013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87239,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87239,31.38,0.35,18.9,36176,NULL,NULL,NULL,'NGC 4013',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87240,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87240,31.42,0.43,19.2,36176,75,NULL,'3.6 micron, color corrected','NGC 4013',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87241,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87241,31.46,0.38,19.6,36176,75,NULL,'W91CL, r, raw','NGC 4013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87242,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87242,31.48,NULL,19.8,36176,NULL,NULL,'I','NGC 4013',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87243,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87243,31.59,0.38,20.8,36176,75,NULL,'W91CL, r, cor','NGC 4013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87244,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87244,31.59,0.38,20.8,36176,75,NULL,'W91CL, r, inv','NGC 4013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87245,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87245,31.62,0.49,21.1,36176,75,NULL,'IR','NGC 4013',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87246,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87246,31.65,0.2,21.4,36176,74.4,NULL,NULL,'NGC 4013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87247,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87247,31.91,NULL,24.1,36176,NULL,NULL,'B','NGC 4013',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87248,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87248,35.4,0.49,120,36177,70,NULL,NULL,'2MASX J11583168-2157166',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.49',NULL,NULL,NULL,NULL,NULL,NULL,1,179.6319583,-21.95486,0.105,NULL,40936611278,639634551,9994289,15.49),(87249,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87249,36.78,0.46,227,36178,70,NULL,NULL,'2MASX J11583229+1343103',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000187,NULL,'16.0g',0.35,NULL,NULL,NULL,NULL,NULL,1,179.63475,13.71975,0.028,NULL,60231483442,941116928,14704952,16),(87250,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87250,37.34,0.46,293,36179,70,NULL,NULL,'2MASX J11583262+3710128',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000185,NULL,'16.8g',0.29,'AGN',NULL,NULL,NULL,NULL,1,179.635958333,37.17042,0,NULL,60438791563,944356118,14755564,16.8),(87251,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87251,37.63,0.23,335,36180,70,NULL,NULL,'2MASX J11583298+3058162',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,179.6375417,30.97114,0,NULL,60562623356,946290989,14785796,17.5),(87252,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87252,38.8,0.33,576,36181,70,NULL,NULL,'2MASX J11583314+0409452',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00006,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,179.63825,4.16247,0.019,NULL,60137376236,939646503,14681976,17),(87253,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87253,36.69,0.46,218,36182,70,NULL,NULL,'2MASX J11583346+0122122',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000076,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,179.639416667,1.37,0,NULL,60133442298,939585035,14681016,17.1),(87254,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87254,38.01,0.33,400,36183,70,NULL,NULL,'SDSS J115833.63-000501.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000076,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,179.640167,-0.08381,0.037,NULL,40802300977,637535952,9961499,18.7),(87255,'Tully est','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87255,31.15,0.8,17,36184,75,NULL,'B','IC 0749',NULL,'1988NBGC.C....0000T',1988,1,2.15,NULL,'G',0.000011,NULL,'13.4g',1.27,'SAB(rs)cd','Pair member (points to parent)',NULL,NULL,NULL,1,179.641875,42.73403,0,NULL,60401033121,943766142,14746345,13.4),(87256,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87256,31.58,0.4,20.7,36184,NULL,NULL,'mean','IC 0749',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87257,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87257,33.25,0.46,44.6,36184,NULL,NULL,'J','IC 0749',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87258,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87258,33.26,0.45,44.9,36184,NULL,NULL,'K','IC 0749',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87259,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87259,33.28,0.47,45.2,36184,NULL,NULL,'H','IC 0749',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87260,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87260,38.8,0.33,576,36185,70,NULL,NULL,'2MASX J11583522+0413342',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000175,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,179.646958333,4.22633,0.019,NULL,60134473764,939601152,14681268,18.6),(87261,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87261,37.58,0.46,328,36186,70,NULL,NULL,'2MASX J11583563+1312074',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,179.6485417,13.20222,0.018,NULL,60232155364,941127427,14705116,17.2),(87262,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87262,38.1,0.46,416,36187,70,NULL,NULL,'2MASX J11583563+5711396',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,179.648708333,57.19431,0.021,NULL,61841254419,966269600,15097962,17.9),(87263,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87263,36.98,0.15,249,36188,70,NULL,NULL,'2MASX J11583595+1051278',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000187,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,179.6497917,10.85764,0,NULL,60146550304,939789848,14684216,17),(87264,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87264,37.49,0.46,315,36189,70,NULL,NULL,'2MASX J11583783+2537071',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,179.6577083,25.61872,0,NULL,60538689463,945917022,14779953,18),(87265,'IRAS','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87265,31.16,0.8,17,36190,75,NULL,'W91CL, r','NGC 4010',NULL,'1997ApJS..109..333W',1997,1,3.17,NULL,'G',0.000003,NULL,'13.2g',0.73,'SB(s)d: sp','in a pair',NULL,NULL,NULL,1,179.657875,47.2615,0,NULL,61742080343,964720005,15073750,13.2),(87266,'IRAS','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87266,31.17,0.8,17.1,36190,75,NULL,'A82, H','NGC 4010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87267,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87267,30.98,0.13,15.7,36190,NULL,NULL,NULL,'NGC 4010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87268,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87268,31.07,0.43,16.4,36190,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4010',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87269,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87269,31.15,0.4,17,36190,75,NULL,'B','NGC 4010',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87270,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87270,31.22,0.4,17.6,36190,75,NULL,NULL,'NGC 4010',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87271,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87271,31.22,0.47,17.6,36190,75,NULL,'A82, H, inv','NGC 4010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87272,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87272,31.24,0.47,17.7,36190,75,NULL,'A82, H, raw','NGC 4010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87273,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87273,31.25,NULL,17.8,36190,NULL,NULL,'B','NGC 4010',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87274,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87274,31.25,0.43,17.8,36190,75,NULL,'3.6 micron, color corrected','NGC 4010',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87275,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87275,31.26,0.4,17.9,36190,NULL,NULL,'mean','NGC 4010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87276,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87276,31.33,NULL,18.5,36190,NULL,NULL,'I','NGC 4010',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87277,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87277,31.35,0.35,18.6,36190,NULL,NULL,NULL,'NGC 4010',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87278,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87278,31.4,0.2,19.1,36190,74.4,NULL,NULL,'NGC 4010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87279,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87279,31.46,0.47,19.6,36190,75,NULL,'A82, H, cor','NGC 4010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87280,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87280,31.52,0.38,20.2,36190,75,NULL,'W91CL, r, raw','NGC 4010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87281,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87281,31.55,0.38,20.4,36190,75,NULL,'W91CL, r, inv','NGC 4010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87282,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87282,31.65,0.38,21.4,36190,75,NULL,'W91CL, r, cor','NGC 4010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87283,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87283,31.7,0.47,21.9,36190,NULL,NULL,'H','NGC 4010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87284,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87284,31.71,0.46,22,36190,NULL,NULL,'J','NGC 4010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87285,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87285,31.78,0.45,22.7,36190,NULL,NULL,'K','NGC 4010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87286,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87286,31.85,0.49,23.5,36190,75,NULL,'IR','NGC 4010',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87287,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87287,38.02,0.46,402,36191,70,NULL,NULL,'2MASX J11583826+3108123',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000174,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,179.659417,31.13683,0,NULL,60551295871,946113997,14783031,17.4),(87288,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87288,37.72,0.17,350,36192,70,NULL,NULL,'2MASX J11583891+3042493',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000182,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,179.66225,30.71361,0,NULL,60558428188,946225440,14784772,17.8),(87289,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87289,37.17,0.46,272,36193,70,NULL,NULL,'2MASX J11583916+4600487',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000169,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,179.663333,46.01367,0,NULL,61740618458,964697163,15073393,16.6),(87290,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87290,33.99,0.49,62.9,36194,75,NULL,'IR','NGC 4018',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.00002,NULL,'14.73',0.3,'Sab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,179.669583,25.31642,0,NULL,60546905753,946045402,14781959,14.73),(87291,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87291,34.15,0.47,67.5,36194,NULL,NULL,'H','NGC 4018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87292,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87292,34.17,0.45,68.2,36194,NULL,NULL,'K','NGC 4018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87293,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87293,34.22,0.4,69.7,36194,NULL,NULL,'mean','NGC 4018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87294,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87294,34.43,0.46,76.9,36194,NULL,NULL,'J','NGC 4018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87295,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87295,37.97,0.33,392,36195,70,NULL,NULL,'2MASX J11584079+0036342',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000075,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,179.67,0.60944,0.069,NULL,60130483060,939538797,14680293,17.9),(87296,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87296,35.99,0.46,158,36196,70,NULL,NULL,'2MASX J11584227+2348585',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.83',0.2,NULL,NULL,NULL,NULL,NULL,1,179.676083,23.81631,0,NULL,60535917802,945873715,14779276,17.83),(87297,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87297,37.9,0.46,380,36197,70,NULL,NULL,'2MASX J11584276+2740243',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,179.678208333,27.6735,0,NULL,60536640926,945885014,14779453,17.8),(87298,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87298,37.61,0.19,333,36198,70,NULL,NULL,'SDSS J115842.76+545039.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,179.678208333,54.84428,0,NULL,61760348724,965005448,15078210,18.3),(87299,'D-Sigma','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87299,33.69,0.4,54.7,36199,75,NULL,'Edat, raw','NGC 4015',NULL,'1997ApJS..109..333W',1997,1,NULL,NULL,'GPair',0.000067,NULL,NULL,NULL,'DBL SYS','in a radial-velocity based grouping',NULL,NULL,NULL,1,179.67875,25.04028,0,NULL,60533261590,945832212,14778628,NULL),(87300,'D-Sigma','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87300,34.03,0.4,63.9,36199,75,NULL,'Edat, cor','NGC 4015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87301,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87301,36.12,0.46,167,36200,70,NULL,NULL,'2MASX J11584305+4236297',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000177,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,179.6795,42.60836,0,NULL,60400164234,943752566,14746133,16.4),(87302,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87302,37.67,0.21,342,36201,70,NULL,NULL,'SDSS J115843.11+553330.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000154,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,179.679667,55.55853,0,NULL,61757794799,964965543,15077586,18.3),(87303,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87303,34.18,0.4,68.5,36202,NULL,NULL,'mean','NGC 4015 NED02',NULL,'2007A&A...465...71T',2007,1,0.9,'Component \'b)\' in UGC notes.','G',0.00003,NULL,'12.81',0.2,'S?','Pair member (points to parent)',NULL,NULL,NULL,1,179.680083,25.04383,0,NULL,60533261595,945832212,14778628,12.81),(87304,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87304,34.18,0.45,68.6,36202,NULL,NULL,'K','NGC 4015 NED02',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87305,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87305,35.52,0.33,127,36203,70,NULL,NULL,'2MASX J11584362+2213025',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.63',0.24,NULL,NULL,NULL,NULL,NULL,1,179.6817083,22.21742,0.053,NULL,60196669891,940572967,14696452,16.63),(87306,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87306,38.41,0.46,481,36204,70,NULL,NULL,'2MASX J11584389-0119022',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,179.682875,-1.31728,0.033,NULL,40805639470,637588116,9962314,17.3),(87307,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87307,37.97,0.33,392,36205,70,NULL,NULL,'2MASX J11584492+0035212',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000088,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,179.687083,0.58906,0.069,NULL,60130484040,939538813,14680293,17.4),(87308,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87308,38.73,0.46,557,36206,70,NULL,NULL,'2MASX J11584503+6411237',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,179.687416667,64.18981,0.013,NULL,61816896981,965889015,15092015,17.5),(87309,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87309,38,0.46,398,36207,70,NULL,NULL,'2MASX J11584500+5123230',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,179.687583333,51.38969,0.013,NULL,61766297839,965098403,15079662,17.4),(87310,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87310,37.28,0.1,286,36208,70,NULL,NULL,'2MASX J11584558+5606006',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000174,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,179.6897083,56.10014,0,NULL,61756984264,964952879,15077388,16.8),(87311,'Sosies','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87311,33.58,0.56,52,36209,NULL,NULL,NULL,'NGC 4017',NULL,'2002A&A...393...57T',2002,1,1.8,'Misidentified in CGCG as \'NGC 4016\'.','G',0.000017,NULL,'13.0',1.4,'SABbc','in a radial-velocity based grouping',NULL,NULL,NULL,1,179.690291667,27.45244,0.014,NULL,60537267293,945894801,14779606,13),(87312,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87312,33.79,0.4,57.3,36209,NULL,NULL,'mean','NGC 4017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87313,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87313,34.53,0.46,80.5,36209,NULL,NULL,'J','NGC 4017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87314,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87314,34.54,0.47,80.9,36209,NULL,NULL,'H','NGC 4017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87315,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87315,34.57,0.45,82,36209,NULL,NULL,'K','NGC 4017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87316,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87316,36.98,0.15,249,36210,70,NULL,NULL,'VIII Zw 157 NOTES02',NULL,'2015arXiv151105856S',2015,1,0.35,'55\\\" South of NPM1G +11.0298.','G',0.000174,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,179.693167,10.85025,0,NULL,60146564348,939790067,14684219,16.6),(87317,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87317,37.28,0.1,286,36211,70,NULL,NULL,'2MASX J11584723+5600476',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000162,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,179.696917,56.01325,0,NULL,61757150070,964955469,15077429,17.8),(87318,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87318,31.95,0.36,24.5,36212,NULL,NULL,NULL,'UGC 06969',NULL,'2009AJ....138..323T',2009,1,1.6,NULL,'G',0.000007,NULL,'15.20',0.5,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,179.6984583,53.42475,0.005,NULL,61770572483,965165195,15080706,15.2),(87319,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87319,37.07,0.46,260,36213,70,NULL,NULL,'2MASX J11584770+1835116',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.22',0.15,NULL,NULL,NULL,NULL,NULL,1,179.69875,18.5865,0.066,NULL,60206821732,940731589,14698931,18.22),(87320,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87320,38.34,0.46,466,36214,70,NULL,NULL,'2MASX J11584881+2236546',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.80',0.13,NULL,NULL,NULL,NULL,NULL,1,179.703583,22.61533,0.046,NULL,60532242348,945816286,14778379,18.8),(87321,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87321,37.33,0.46,293,36215,70,NULL,NULL,'2MASX J11584998+5300380',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,179.708375,53.01064,0,NULL,61766549885,965102341,15079724,17.7),(87322,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87322,37.38,0.33,299,36216,70,NULL,NULL,'2MASX J11585142+0506112',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000179,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,179.714375,5.10303,0,NULL,60133988170,939593565,14681149,16.4),(87323,'Sosies','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87323,32.83,0.13,36.8,36217,NULL,NULL,NULL,'IC 0750',NULL,'2002A&A...393...57T',2002,1,2.48,NULL,'G',0.000003,NULL,'12.8g',0.91,'Sab: sp','Pair member (points to parent)',NULL,NULL,NULL,1,179.7175,42.72247,0,NULL,60400165657,943752588,14746134,12.8),(87324,'Tully est','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87324,31.15,0.8,17,36217,75,NULL,'B','IC 0750',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87325,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87325,31.48,0.4,19.8,36217,NULL,NULL,'mean','IC 0750',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87326,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87326,31.51,0.45,20.1,36217,NULL,NULL,'K','IC 0750',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87327,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87327,31.64,NULL,21.3,36217,NULL,NULL,'I','IC 0750',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87328,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87328,31.71,0.46,21.9,36217,NULL,NULL,'J','IC 0750',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87329,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87329,31.85,0.36,23.4,36217,NULL,NULL,NULL,'IC 0750',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87330,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87330,32.22,NULL,27.8,36217,NULL,NULL,'B','IC 0750',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87331,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87331,37.71,0.46,348,36218,70,NULL,NULL,'2MASX J11585290+4710526',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000181,NULL,'16.7g',0.35,NULL,NULL,NULL,NULL,NULL,1,179.720333,47.18119,0,NULL,61742061133,964719705,15073745,16.7),(87332,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87332,37.93,0.46,386,36219,70,NULL,NULL,'2MASX J11585303+0604322',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000132,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,179.7212083,6.07556,0,NULL,60155672739,939932386,14686443,17.9),(87333,'Tully est','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87333,31.15,0.8,17,36220,75,NULL,NULL,'UGCA 259',NULL,'1988NBGC.C....0000T',1988,1,1.1,NULL,'G',0.000033,NULL,'15.0',0.9,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,179.721958333,45.73447,0,NULL,61741126843,964705106,15073517,15),(87334,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87334,37.61,0.19,333,36221,70,NULL,NULL,'SDSS J115855.23+544814.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000159,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,179.730167,54.80414,0,NULL,61759296081,964989001,15077953,18.5),(87335,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87335,37.47,0.46,312,36222,70,NULL,NULL,'2MASXi J1158554+223147',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.93',0.12,NULL,NULL,NULL,NULL,NULL,1,179.7312083,22.52992,0.046,NULL,61069092574,954204571,14909446,18.93),(87336,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87336,36.18,0.33,173,36223,70,NULL,NULL,'CGCG 157-071',NULL,'2015arXiv151105856S',2015,1,0.97,NULL,'G',0.00009,NULL,'14.7g',0.65,'E',NULL,NULL,NULL,NULL,1,179.73125,28.39897,0,NULL,60557622374,946212849,14784575,14.7),(87337,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87337,37.56,0.33,325,36224,70,NULL,NULL,'2MASX J11585596+4657056',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,179.733083333,46.95156,0,NULL,61741844897,964716326,15073692,18.1),(87338,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87338,37.71,0.33,348,36225,70,NULL,NULL,'2MASX J11585669+0329252',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000037,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,179.7362917,3.49028,0.039,NULL,60136777095,939637142,14681830,17.6),(87339,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87339,37.28,0.1,286,36226,70,NULL,NULL,'2MASX J11585686+5610315',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,179.736708333,56.17544,0,NULL,61756992775,964953012,15077390,16.9),(87340,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87340,29.53,0.4,8,36227,75,NULL,'B','NGC 4020',NULL,'1988NBGC.C....0000T',1988,1,2.24,NULL,'G',0.000013,NULL,'13.1g',0.91,'SBd? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,179.736125,30.41189,0,NULL,60558582054,946227844,14784810,13.1),(87341,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87341,30.35,0.43,11.8,36227,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4020',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87342,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87342,30.49,0.43,12.5,36227,75,NULL,'3.6 micron, color corrected','NGC 4020',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87343,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87343,30.57,0.2,13,36227,74.4,NULL,NULL,'NGC 4020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87344,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87344,30.78,0.4,14.3,36227,75,NULL,NULL,'NGC 4020',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87345,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87345,31.32,0.49,18.4,36227,75,NULL,'IR','NGC 4020',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87346,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87346,36.36,0.46,187,36228,70,NULL,NULL,'2MASX J11585693+4508396',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000151,NULL,'16.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,179.737166667,45.14419,0,NULL,61740208370,964690755,15073293,16.8),(87347,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87347,37.81,0.46,365,36229,70,NULL,NULL,'SBS 1156+581',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000179,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,179.737625,57.85214,0,NULL,61842455809,966288372,15098255,16.6),(87348,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87348,36.71,0.46,219,36230,70,NULL,NULL,'2MASX J11585715+3123070',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000158,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,179.7379583,31.38544,0,NULL,60551164525,946111945,14782999,16.6),(87349,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87349,37.48,0.46,313,36231,70,NULL,NULL,'2MASXi J1158582+430140',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,179.7425,43.02789,0,NULL,60400518185,943758096,14746220,17.8),(87350,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87350,29.65,NULL,8.51,36232,NULL,NULL,NULL,'ESO 572- G 034',NULL,'2013AJ....145..101K',2013,1,1,'The 2MASX position is for a bright knot south of the center.','G',0.000007,NULL,'14.27',0.5,'IBm            HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,179.743,-19.02811,0.081,NULL,40942794324,639731161,9995799,14.27),(87351,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87351,36.81,0.46,230,36233,70,NULL,NULL,'2MASX J11585829+1249154',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00015,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,179.743,12.82097,0,NULL,60231997192,941124956,14705077,16.5),(87352,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87352,36.18,0.33,173,36234,70,NULL,NULL,'2MASX J11585843+2822015',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,179.743375,28.36708,0,NULL,60557610923,946212670,14784572,17.2),(87353,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87353,37.07,0.46,259,36235,70,NULL,NULL,'2MASX J11585893-0044040',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00006,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,179.745583333,-0.73439,0.017,NULL,40802809746,637543902,9961623,17.8),(87354,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87354,37.38,0.33,299,36236,70,NULL,NULL,'SDSS J115859.01+050654.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00017,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,179.745875,5.11511,0,NULL,60133994696,939593667,14681151,18.4),(87355,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87355,35.69,0.46,137,36237,70,NULL,NULL,'2MASX J11585974+4858460',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000177,NULL,'16.1g',0.32,'E0',NULL,NULL,NULL,NULL,1,179.7489583,48.97953,0.051,NULL,61746926203,964795721,15074933,16.1),(87356,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87356,37.66,0.46,340,36238,70,NULL,NULL,'2MASX J11590039+3242050',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000158,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,179.7515417,32.70153,0.01,NULL,60549747606,946089806,14782653,17.9),(87357,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87357,37.21,0.46,277,36239,70,NULL,NULL,'2MASX J11590065+2530555',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,179.7527917,25.51556,0,NULL,60538704290,945917254,14779957,17.8),(87358,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87358,31.44,NULL,19.4,36240,NULL,NULL,NULL,'SDSS J115900.74+044010.7',NULL,'2015AstBu..70....1K',2015,1,0.34,NULL,'G',0.000008,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,179.753125,4.66964,0,NULL,60134352070,939599251,14681238,16.7),(87359,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87359,37.61,0.19,333,36241,70,NULL,NULL,'SDSS J115901.12+544857.9',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000181,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,179.7547083,54.81608,0,NULL,61760349697,965005464,15078210,18.5),(87360,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87360,36.76,0.46,225,36242,70,NULL,NULL,'2MASX J11590190+1129378',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,179.757875,11.49389,0,NULL,60230467578,941101055,14704703,16.9),(87361,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87361,37.46,0.46,311,36243,70,NULL,NULL,'2MASX J11590212+4300050',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000139,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,179.758917,43.00122,0,NULL,60400524284,943758191,14746221,18),(87362,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87362,37.61,0.19,333,36244,70,NULL,NULL,'2MASX J11590217+5448384',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000162,NULL,'16.5g',0.38,'BrClG',NULL,NULL,NULL,NULL,1,179.7589583,54.81056,0,NULL,61759298826,964989044,15077953,16.5),(87363,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87363,37.63,0.33,336,36245,70,NULL,NULL,'2MASX J11590220-0118470',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00015,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,179.759167,-1.31308,0.045,NULL,40805661108,637588454,9962319,16.7),(87364,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87364,35.7,0.46,138,36246,70,NULL,NULL,'NGC 4021',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000173,NULL,'15.3',0.2,'E','Group member',NULL,NULL,NULL,1,179.760791667,25.08322,0,NULL,60533271112,945832361,14778630,15.3),(87365,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87365,37.01,0.46,252,36247,70,NULL,NULL,'2MASX J11590368+5246390',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,179.76525,52.77758,0,NULL,61767236967,965113077,15079891,17.5),(87366,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87366,38.13,0.46,423,36248,70,NULL,NULL,'2MASX J11590426+4622331',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000153,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,179.7677083,46.37597,0,NULL,61743833495,964747398,15074178,18.7),(87367,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87367,36.08,0.46,165,36249,70,NULL,NULL,'2MASX J11590437+2617006',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000164,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,179.768125,26.28347,0,NULL,60539004889,945921951,14780030,16.6),(87368,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87368,38.23,0.46,442,36250,70,NULL,NULL,'2MASX J11590453+1200055',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,179.769083,12.00167,0,NULL,60230638095,941103720,14704745,17.9),(87369,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87369,36.13,0.46,169,36251,70,NULL,NULL,'2MASX J11590521+0154362',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000094,NULL,'16.5g',0.22,'NLAGN',NULL,NULL,NULL,'Sy 2',1,179.771833333,1.90992,0.033,NULL,60131483418,939554428,14680537,16.5),(87370,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87370,37.61,0.19,333,36252,70,NULL,NULL,'2MASX J11590548+5447375',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00018,NULL,'17.4g',0.18,'Cand.grav.lens',NULL,NULL,NULL,NULL,1,179.7727083,54.79392,0,NULL,61759299537,964989055,15077953,17.4),(87371,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87371,37.33,0.46,292,36253,70,NULL,NULL,'2MASX J11590583+5301460',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000192,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,179.7745,53.0295,0,NULL,61766524582,965101946,15079717,16.6),(87372,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87372,37.62,0.46,334,36254,70,NULL,NULL,'2MASX J11590802+3609372',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00018,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,179.783625,36.16022,0,NULL,60432805997,944262593,14754103,17.7),(87373,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:02','1','SN 1964E','R',87373,31.95,NULL,24.5,36255,NULL,NULL,'Photographic','UGC 06983',NULL,'1988SSRv...48....1R',1988,1,3.5,NULL,'G',0.000003,NULL,'13.12',2.4,'SB(rs)cd','in a radial-velocity based grouping',NULL,NULL,NULL,1,179.788667,52.7075,0.009,NULL,61766965661,965108838,15079825,13.12),(87374,'IRAS','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87374,31.53,0.8,20.2,36255,75,NULL,'W91CL, r','UGC 06983',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87375,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87375,30.98,0.12,15.7,36255,NULL,NULL,NULL,'UGC 06983',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87376,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87376,31.15,0.4,17,36255,75,NULL,'B','UGC 06983',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87377,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87377,31.6,NULL,20.9,36255,NULL,NULL,'I','UGC 06983',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87378,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87378,31.64,0.35,21.3,36255,NULL,NULL,NULL,'UGC 06983',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87379,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87379,31.64,0.38,21.3,36255,75,NULL,'W91CL, r, inv','UGC 06983',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87380,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87380,31.65,NULL,21.4,36255,NULL,NULL,'B','UGC 06983',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87381,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87381,31.65,0.38,21.4,36255,75,NULL,'W91CL, r, raw','UGC 06983',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87382,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87382,31.77,0.38,22.6,36255,75,NULL,'W91CL, r, cor','UGC 06983',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87383,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87383,31.96,NULL,24.7,36255,NULL,NULL,'I, Hubble-type-TF','UGC 06983',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87384,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87384,31.96,NULL,24.7,36255,NULL,NULL,'B, Hubble-type-TF','UGC 06983',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87385,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87385,32.04,NULL,25.6,36255,NULL,NULL,'I','UGC 06983',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87386,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87386,32.09,NULL,26.2,36255,NULL,NULL,'B','UGC 06983',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87387,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87387,38.55,0.46,513,36256,70,NULL,NULL,'2MASX J11590943+1523415',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,179.7892917,15.39483,0.074,NULL,60237867611,941216681,14706510,17.8),(87388,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87388,32.58,0.2,32.8,36257,74.4,NULL,NULL,'NGC 4025',NULL,'2013AJ....146...86T',2013,1,1.51,NULL,'G',0.00001,NULL,'14.8g',0.74,'SB(s)cd','Possible group member',NULL,NULL,NULL,1,179.7924583,37.79342,0,NULL,60438147041,944346047,14755406,14.8),(87389,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87389,32.69,1,34.5,36257,NULL,NULL,'Malmquist cor.','NGC 4025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87390,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87390,32.84,0.93,37,36257,NULL,NULL,NULL,'NGC 4025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87391,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87391,33.39,0.49,47.6,36257,75,NULL,'IR','NGC 4025',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87392,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87392,38.33,0.46,464,36258,70,NULL,NULL,'2MASX J11591072+2809246',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,179.794583,28.15689,0,NULL,60557369370,946208896,14784514,18.2),(87393,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87393,37.67,0.46,342,36259,70,NULL,NULL,'2MASX J11591110+5520165',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000161,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,179.79625,55.33794,0,NULL,61757565846,964961966,15077530,17.1),(87394,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87394,37.4,0.46,302,36260,70,NULL,NULL,'2MASX J11591135+0142362',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000082,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,179.7975,1.71022,0.033,NULL,60131368587,939552634,14680509,17.2),(87395,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87395,37.56,0.46,326,36261,70,NULL,NULL,'2MASX J11591141+1156495',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000191,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,179.797667,11.94719,0,NULL,60231147697,941111682,14704870,17.7),(87396,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87396,37.44,0.46,308,36262,70,NULL,NULL,'2MASX J11591209+3008211',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000177,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,179.800333,30.13936,0,NULL,60559273468,946238647,14784978,16.1),(87397,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87397,38.07,0.46,412,36263,70,NULL,NULL,'2MASX J11591263+2947157',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000171,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,179.8027917,29.78775,0,NULL,60559175114,946237111,14784954,17.7),(87398,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87398,37.25,0.46,282,36264,70,NULL,NULL,'2MASX J11591317+6542056',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000188,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,179.805167,65.70161,0.033,NULL,61809785850,965777903,15090279,16.8),(87399,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87399,37.28,0.1,286,36265,70,NULL,NULL,'2MASX J11591337+5606105',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,179.8055,56.10297,0,NULL,61756997104,964953079,15077391,17.2),(87400,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87400,37.67,0.21,342,36266,70,NULL,NULL,'2MASX J11591340+5531265',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000188,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,179.805625,55.52389,0,NULL,61757528174,964961377,15077521,16.9),(87401,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87401,37.89,0.46,378,36267,70,NULL,NULL,'2MASX J11591370+1428295',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,179.807,14.47481,0.051,NULL,60236584650,941196635,14706197,18),(87402,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87402,37.63,0.33,336,36268,70,NULL,NULL,'2MASX J11591400-0117550',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000159,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,179.8085,-1.29867,0.021,NULL,40805656759,637588386,9962318,17.7),(87403,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87403,36.83,0.46,232,36269,70,NULL,NULL,'SDSS J115914.33+084100.6',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,179.80975,8.6835,0,NULL,60148663377,939822865,14684732,17),(87404,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87404,36.96,0.46,246,36270,70,NULL,NULL,'2MASX J11591591+0450542',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000185,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,179.816166667,4.84828,0,NULL,60134647897,939603873,14681310,16.7),(87405,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87405,36.94,0.46,244,36271,70,NULL,NULL,'2MASX J11591591+1144055',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000187,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,179.8164583,11.73497,0,NULL,60230297864,941098404,14704662,16.6),(87406,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87406,37.05,0.46,257,36272,70,NULL,NULL,'SDSS J115916.37+050043.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000163,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,179.81825,5.01219,0,NULL,60133910583,939592352,14681130,18.3),(87407,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87407,37.28,0.1,286,36273,70,NULL,NULL,'2MASX J11591642+5621265',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,179.818333333,56.35753,0,NULL,61840827890,966262935,15097858,17.1),(87408,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87408,37.05,0.46,257,36274,70,NULL,NULL,'2MASX J11591714+4954110',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000172,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,179.821333,49.90294,0.027,NULL,61745210545,964768914,15074514,16.8),(87409,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87409,37.49,0.46,315,36275,70,NULL,NULL,'2MASX J11591728-0149140',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000155,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,179.822083,-1.82069,0.049,NULL,40804723085,637573798,9962090,18.3),(87410,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87410,37.65,0.46,339,36276,70,NULL,NULL,'SDSS J115918.12+282731.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00017,NULL,'17.9g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,179.8255,28.45875,0,NULL,60557597904,946212467,14784569,17.9),(87411,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87411,38.33,0.46,464,36277,70,NULL,NULL,'2MASX J11591814+1308430',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000181,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,179.825583,13.14517,0,NULL,60231902755,941123480,14705054,17.7),(87412,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87412,36.48,0.46,198,36278,70,NULL,NULL,'2MASX J11591959+6501146',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,179.8315,65.02072,0.005,NULL,61809378470,965771538,15090180,17.3),(87413,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87413,37.67,0.21,342,36279,70,NULL,NULL,'SDSS J115923.44+553016.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,179.8477083,55.50469,0,NULL,61757537201,964961518,15077523,18.4),(87414,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87414,38.12,0.46,420,36280,70,NULL,NULL,'LCRS B115649.7-021708',NULL,'2015arXiv151105856S',2015,1,0.15,'2dF final data release has z = 0.09940: +- 0.00041.','G',0.000132,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,179.847791667,-2.56408,0.037,NULL,40804350892,637567982,9961999,18.5),(87415,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87415,34.52,0.46,80,36281,70,NULL,NULL,'IC 0754',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000123,NULL,'13.81',1,'E+',NULL,NULL,NULL,NULL,1,179.848125,-1.65453,0.049,NULL,40804767099,637574485,9962101,13.81),(87416,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87416,38.06,0.46,408,36282,70,NULL,NULL,'2MASX J11592425+0506051',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,179.851,5.10153,0,NULL,60133888437,939592006,14681125,18),(87417,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87417,37.36,0.46,296,36283,70,NULL,NULL,'SDSS J115924.31+682205.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000062,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,179.8512917,68.36814,0,NULL,61337900746,958404699,14975073,18.2),(87418,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87418,34.85,0.49,93.3,36284,70,NULL,NULL,'LCRS B115650.9-062730',NULL,'2014MNRAS.445.2677S',2014,1,0.89,NULL,'G',0.000107,NULL,'15.42',0.34,NULL,NULL,NULL,NULL,NULL,1,179.852417,-6.73711,0.077,NULL,40840515542,638133055,9970828,15.42),(87419,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87419,37.71,0.33,348,36285,70,NULL,NULL,'2MASX J11592485+0333541',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00009,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,179.8535417,3.56503,0.039,NULL,60136283830,939629434,14681709,17.1),(87420,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87420,36.79,0.46,228,36286,70,NULL,NULL,'2MASX J11592484+2036195',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.47',0.15,NULL,NULL,NULL,NULL,NULL,1,179.853583,20.60553,0.058,NULL,60199162579,940611915,14697061,18.47),(87421,'SBF','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87421,30.67,0.28,13.6,36287,NULL,NULL,'I','NGC 4026',NULL,'2001ApJ...546..681T',2001,1,5.2,NULL,'G',0.000017,NULL,'11.67',1.3,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,179.8549583,50.96169,0.037,NULL,61765552191,965086752,15079480,11.67),(87422,'SBF','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87422,30.83,0.12,14.7,36287,74.4,NULL,NULL,'NGC 4026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87423,'Faber-Jackson','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87423,30.45,0.65,12.3,36287,95,NULL,'Weighted Mean','NGC 4026',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87424,'Faber-Jackson','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87424,31.38,NULL,18.9,36287,NULL,NULL,'LEDA [April 2006]','NGC 4026',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87425,'Faber-Jackson','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87425,32.03,0.81,25.5,36287,55,NULL,'Visvanathan & Sandage 1979','NGC 4026',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87426,'Tully est','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87426,31.15,0.8,17,36287,75,NULL,'B','NGC 4026',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87427,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87427,30.35,0.45,11.7,36287,NULL,NULL,'K','NGC 4026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87428,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87428,30.83,0.12,14.7,36287,74.4,NULL,NULL,'NGC 4026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87429,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87429,31.32,0.4,18.4,36287,NULL,NULL,'mean','NGC 4026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87430,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87430,37.28,0.1,286,36288,70,NULL,NULL,'2MASX J11592630+5624135',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000201,NULL,'15.9g',0.42,'E0',NULL,NULL,NULL,NULL,1,179.859875,56.40369,0,NULL,61840823541,966262867,15097857,15.9),(87431,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87431,37.61,0.19,333,36289,70,NULL,NULL,'SDSS J115926.56+545120.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000156,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,179.860667,54.85558,0,NULL,61760342682,965005354,15078208,18.2),(87432,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87432,34.23,0.55,70,36290,NULL,NULL,'Malmquist cor.','ESO 267- G 005',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.91',0.6,'SA(s)bc',NULL,NULL,NULL,NULL,1,179.8652917,-47.16194,0.445,NULL,39999899799,624998434,9765600,14.91),(87433,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87433,34.34,0.52,73.6,36290,NULL,NULL,NULL,'ESO 267- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87434,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87434,34.38,0.2,75.2,36290,74.4,NULL,NULL,'ESO 267- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87435,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87435,37.44,0.46,307,36291,70,NULL,NULL,'2MASX J11592825+2526039',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.80',0.22,NULL,NULL,NULL,NULL,NULL,1,179.867875,25.43442,0,NULL,60538548901,945914826,14779919,17.8),(87436,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87436,37.7,0.46,346,36292,70,NULL,NULL,'2MASX J11592881+1637180',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.54',0.17,NULL,NULL,NULL,NULL,NULL,1,179.8702083,16.62161,0.112,NULL,60234463792,941163496,14705679,18.54),(87437,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87437,38.42,0.46,483,36293,70,NULL,NULL,'2MASX J11592878+4218230',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000176,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,179.8702917,42.30642,0,NULL,60400136416,943752131,14746127,18),(87438,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87438,36.74,0.46,222,36294,70,NULL,NULL,'2MASX J11592908+0258571',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000053,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,179.871083,2.98236,0.042,NULL,60135885077,939623204,14681612,17.1),(87439,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87439,35.47,0.46,124,36295,70,NULL,NULL,'CGCG 127-129',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00015,NULL,'15.5',0.2,'S',NULL,NULL,NULL,NULL,1,179.8735417,25.46881,0,NULL,60538550074,945914844,14779919,15.5),(87440,'SNII optical','2016-12-15 15:14:53','2016-12-16 11:20:02','1','SN 1996W',NULL,87440,31.46,0.12,19.6,36296,NULL,NULL,'SCM','NGC 4027',NULL,'2015ApJ...799..215P',2015,1,3.2,NULL,'G',0.00002,NULL,'11.66',2.4,'SB(s)dm        HII','in a pair',NULL,NULL,NULL,1,179.8757083,-19.26522,0.057,NULL,40942942548,639733477,9995835,11.66),(87441,'Tully est','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87441,32.04,0.8,25.6,36296,75,NULL,'B','NGC 4027',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87442,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87442,37.89,0.46,378,36297,70,NULL,NULL,'2MASX J11593144+5721585',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,179.881333,57.36631,0.017,NULL,61841116155,966267439,15097928,17.3),(87443,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87443,37.87,0.33,374,36298,70,NULL,NULL,'SDSS J115931.98+281442.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,179.883291667,28.24514,0,NULL,60557423526,946209742,14784527,18.4),(87444,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87444,37.37,0.46,298,36299,70,NULL,NULL,'2MASX J11593363+0931404',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,179.890125,9.528,0,NULL,60148722882,939823795,14684746,17.4),(87445,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87445,30.27,NULL,11.3,36300,NULL,NULL,NULL,'KUG 1156+141',NULL,'2015AstBu..70....1K',2015,1,0.79,NULL,'G',0.000025,NULL,'15.1g',0.52,'SmIII',NULL,NULL,NULL,NULL,1,179.890833333,13.88719,0.033,NULL,60231313514,941114273,14704910,15.1),(87446,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87446,37.58,0.46,329,36301,70,NULL,NULL,'2MASX J11593463+4943231',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00017,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,179.894375,49.72322,0.012,NULL,61744977778,964765277,15074457,16.9),(87447,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87447,37.02,0.46,254,36302,70,NULL,NULL,'2MASX J11593489+4039582',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000206,NULL,'15.8g',0.41,NULL,NULL,NULL,NULL,NULL,1,179.8952083,40.66617,0,NULL,60406644070,943853813,14747715,15.8),(87448,'IRAS','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87448,34.5,0.8,79.5,36303,75,NULL,'HMCL, I','CGCG 041-016',NULL,'1997ApJS..109..333W',1997,1,0.72,'Pimbblet et al. (2006MNRAS.366..645P) give v = 34821 +/- 23 km/sec.','G',0.000027,NULL,'15.5',0.21,'Sc(f)',NULL,NULL,NULL,NULL,1,179.89525,3.33806,0.031,NULL,60135958646,939624353,14681630,15.5),(87449,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87449,34.5,0.4,79.5,36303,75,NULL,'HMCL, I, raw','CGCG 041-016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87450,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87450,34.59,0.4,82.8,36303,75,NULL,'HMCL, I, inv','CGCG 041-016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87451,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87451,34.72,0.4,88.1,36303,75,NULL,'HMCL, I, cor','CGCG 041-016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87452,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87452,34.99,0.49,99.5,36303,75,NULL,'IR','CGCG 041-016',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87453,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87453,37.87,0.46,375,36304,70,NULL,NULL,'2MASX J11593504+0152011',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000089,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,179.896,1.86706,0.033,NULL,60131244836,939550700,14680479,16.9),(87454,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87454,36.49,0.46,199,36305,70,NULL,NULL,'2MASX J11593537+3458557',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,179.8974583,34.982,0,NULL,60431849385,944247646,14753869,17.6),(87455,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87455,36.12,0.75,167,36306,70,NULL,NULL,'2MASX J11593565-0713485',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'15.79',0.48,NULL,NULL,NULL,NULL,NULL,1,179.898708333,-7.23025,0.077,NULL,40842341024,638161578,9971274,15.79),(87456,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87456,35.8,0.46,145,36307,70,NULL,NULL,'CGCG 069-011',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.00018,NULL,'15.2g',0.55,NULL,NULL,NULL,NULL,NULL,1,179.901333,13.77878,0.02,NULL,60231297915,941114029,14704906,15.2),(87457,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87457,36.98,0.46,248,36308,70,NULL,NULL,'2MASX J11593657+3342457',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00017,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,179.902416667,33.71278,0,NULL,60616084143,947126314,14798848,16.4),(87458,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87458,37.56,0.33,325,36309,70,NULL,NULL,'2MASX J11593819+4654070',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000154,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,179.909,46.902,0,NULL,61741832157,964716127,15073689,17.1),(87459,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87459,35.09,0.46,104,36310,70,NULL,NULL,'CGCG 013-028',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000083,NULL,'15.9g',0.34,'E:',NULL,NULL,NULL,NULL,1,179.909917,-3.37761,0.045,NULL,40811768379,637683880,9963810,15.9),(87460,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87460,38.45,0.46,490,36311,70,NULL,NULL,'2MASX J11594026+1316120',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000189,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,179.9177083,13.26994,0.01,NULL,60231858394,941122787,14705043,17.1),(87461,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87461,36.47,0.46,197,36312,70,NULL,NULL,'2MASX J11594049+5019311',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000168,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,179.918583,50.32517,0.032,NULL,61744384383,964756005,15074312,16.7),(87462,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87462,37.76,0.46,356,36313,70,NULL,NULL,'2MASX J11594055+2659189',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000182,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,179.919125,26.98856,0,NULL,60536945480,945889773,14779527,17.4),(87463,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87463,37.8,0.46,363,36314,70,NULL,NULL,'2MASX J11594091+0754392',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000176,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,179.920625,7.91097,0,NULL,60155914256,939936160,14686502,17.4),(87464,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87464,36.95,0.46,245,36315,70,NULL,NULL,'2MASX J11594110+4858071',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,179.921125,48.96869,0.051,NULL,61746757518,964793086,15074891,17.8),(87465,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87465,38.35,0.46,468,36316,70,NULL,NULL,'2MASX J11594278-0002527',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000073,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,179.928167,-0.04781,0.061,NULL,40802205079,637534454,9961475,17.8),(87466,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87466,35.83,0.46,146,36317,70,NULL,NULL,'CGCG 127-131',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00068,NULL,'15.7',0.1,'S',NULL,NULL,NULL,NULL,1,179.9342083,25.62106,0,NULL,60538718686,945917479,14779960,15.7),(87467,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87467,38.14,0.46,426,36318,70,NULL,NULL,'SDSS J115944.84+005628.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000061,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,179.936875,0.94125,0.013,NULL,60129968060,939530750,14680167,18.6),(87468,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87468,36.89,0.46,239,36319,70,NULL,NULL,'2MASX J11594541+0433212',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000158,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,179.93925,4.55583,0.028,NULL,60134491833,939601434,14681272,17),(87469,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87469,37.74,0.46,353,36320,70,NULL,NULL,'2MASX J11594628+0342292',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000092,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,179.942833,3.70814,0.025,NULL,60136254442,939628975,14681702,17),(87470,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87470,36.11,0.46,167,36321,70,NULL,NULL,'2MASX J11594659+3308117',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000203,NULL,'15.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,179.9439583,33.13672,0,NULL,60549118232,946079972,14782499,15.8),(87471,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87471,37.15,0.27,269,36322,70,NULL,NULL,'2MASX J11594657+1830213',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.90',0.18,NULL,NULL,NULL,NULL,NULL,1,179.944083333,18.50611,0.031,NULL,60206644781,940728824,14698887,17.9),(87472,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87472,37.28,0.1,286,36323,70,NULL,NULL,'2MASX J11594665+5611594',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000184,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,179.9442083,56.19989,0,NULL,61756934808,964952106,15077376,16.6),(87473,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87473,37.28,0.1,286,36324,70,NULL,NULL,'2MASX J11594704+5614464',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000173,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,179.94575,56.24631,0,NULL,61975036533,968359945,15130624,16.4),(87474,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87474,36.84,0.46,234,36325,70,NULL,NULL,'2MASX J11594705+5417244',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,179.9460417,54.29019,0,NULL,61759430326,964991098,15077985,17.3),(87475,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87475,37.45,0.46,310,36326,70,NULL,NULL,'2MASX J11594797+3605276',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000165,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,179.9499583,36.09092,0,NULL,60432737596,944261524,14754086,16.8),(87476,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87476,37.37,0.33,298,36327,70,NULL,NULL,'2MASX J11594838+0941542',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000207,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,179.951291667,9.69842,0,NULL,60148689625,939823275,14684738,16.8),(87477,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87477,36.89,0.46,239,36328,70,NULL,NULL,'2MASX J11594849+3755067',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000145,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,179.9519583,37.91864,0,NULL,60438089582,944345149,14755392,17.4),(87478,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87478,36.55,0.46,205,36329,70,NULL,NULL,'2MASX J11594884+2751144',NULL,'2015arXiv151105856S',2015,1,0.82,'1978AJ.....83.1549K has V = 5663 +- 150 km/s.','G',0.000205,NULL,'15.0g',0.68,'E','Field galaxy',NULL,NULL,NULL,1,179.953583,27.85411,0,NULL,60536437082,945881829,14779403,15),(87479,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87479,34.45,0.46,77.5,36330,70,NULL,NULL,'IC 2986',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000063,NULL,'14.5g',0.68,'S0?',NULL,NULL,NULL,NULL,1,179.9567083,30.84442,0,NULL,60558423379,946225365,14784771,14.5),(87480,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87480,37.51,0.46,318,36331,70,NULL,NULL,'2MASX J11594989+0402142',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00004,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,179.9577917,4.03728,0.018,NULL,60136149274,939627332,14681677,16.2),(87481,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87481,36.08,0.46,164,36332,70,NULL,NULL,'2MASX J11595072+1411495',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000205,NULL,'15.3g',0.47,NULL,NULL,NULL,NULL,NULL,1,179.961541667,14.19703,0.04,NULL,60236501275,941195332,14706177,15.3),(87482,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87482,34.4,0.47,75.7,36333,NULL,NULL,NULL,'SDSS J115950.79+084735.3',NULL,'2009ApJS..182..474S',2009,1,0.39,NULL,'G',0.00002,NULL,'16.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,179.961667,8.79317,0,NULL,60148515381,939820552,14684696,16.3),(87483,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87483,34.56,0.44,81.5,36333,NULL,NULL,'Malmquist cor.','SDSS J115950.79+084735.3',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87484,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87484,37.67,0.21,342,36334,70,NULL,NULL,'2MASX J11595215+5532053',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000217,NULL,'15.3g',0.58,'BrClG',NULL,NULL,NULL,NULL,1,179.9670417,55.53453,0,NULL,61757522865,964961294,15077520,15.3),(87485,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87485,38.39,0.46,476,36335,70,NULL,NULL,'2MASX J11595240+5205200',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,179.968416667,52.08878,0.01,NULL,61766897227,965107769,15079808,17.8),(87486,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87486,38.47,0.46,495,36336,70,NULL,NULL,'2MASX J11595462+3027267',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000187,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,179.977791667,30.4575,0,NULL,60558567047,946227610,14784806,17.3),(87487,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87487,36.6,0.33,209,36337,70,NULL,NULL,'2MASX J11595497+5201290',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000154,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,179.9790417,52.02467,0,NULL,61765582955,965087233,15079488,16.7),(87488,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87488,37.18,0.46,273,36338,70,NULL,NULL,'LCRS B115721.9-022924',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,179.981833,-2.76828,0.049,NULL,40804290183,637567034,9961984,18.2),(87489,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87489,37.28,0.1,286,36339,70,NULL,NULL,'2MASX J11595583+5600059',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000187,NULL,'16.2g',0.41,NULL,NULL,NULL,NULL,NULL,1,179.98275,56.00158,0,NULL,61756971212,964952675,15077385,16.2),(87490,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87490,36.8,0.33,230,36340,70,NULL,NULL,'2MASX J11595914+5237561',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000183,NULL,'16.1g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,179.996333,52.63233,0.009,NULL,61766968476,965108882,15079826,16.1),(87491,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87491,37.59,0.33,329,36341,70,NULL,NULL,'2MASX J11595964-0027510',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000072,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,179.9984583,-0.46417,0.033,NULL,40802346572,637536665,9961510,18),(87492,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87492,36.98,0.15,249,36342,70,NULL,NULL,'2MASX J11595997+1041282',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000155,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,179.9997917,10.69106,0,NULL,60146455139,939788361,14684193,16.9),(87493,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87493,37.93,0.46,386,36343,70,NULL,NULL,'2MASX J11595999+0024535',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000081,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,180,0.41489,0.061,NULL,57982208385,905972006,14155812,17.6),(87494,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87494,37.15,0.27,269,36344,70,NULL,NULL,'2MASX J12000028+1834393',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00011,NULL,'17.46',0.22,NULL,NULL,NULL,NULL,NULL,1,180.001125,18.57747,0.043,NULL,58122864352,908169755,14190152,17.46),(87495,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87495,37.15,0.27,269,36345,70,NULL,NULL,'2MASX J12000233+1834399',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,180.009583,18.57781,0.043,NULL,58122864337,908169755,14190152,17.3),(87496,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87496,38.17,0.46,430,36346,70,NULL,NULL,'2MASX J12000247+1019236',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,180.0102083,10.32325,0,NULL,58016034347,906500536,14164070,17.4),(87497,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87497,38.16,0.13,428,36347,70,NULL,NULL,'2MASX J12000243+5803370',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,180.010291667,58.06028,0,NULL,57330256179,895785252,13996644,17.3),(87498,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87498,37.86,0.46,374,36348,70,NULL,NULL,'2MASX J12000258+6034314',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,180.010583,60.57536,0,NULL,57336407222,895881362,13998146,17.2),(87499,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87499,38.08,0.46,412,36349,70,NULL,NULL,'VIII Zw 159',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000175,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,180.0115,9.20192,0,NULL,58017254340,906519599,14164368,17.8),(87500,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87500,38.23,0.46,443,36350,70,NULL,NULL,'2MASX J12000296+2319309',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.66',0.15,NULL,NULL,NULL,NULL,NULL,1,180.012333,23.32525,0.027,NULL,58586638032,915416219,14303378,18.66),(87501,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87501,34.81,0.47,91.8,36351,NULL,NULL,'H','NGC 4029',NULL,'2007A&A...465...71T',2007,1,1.37,NULL,'G',0.00001,NULL,'14.2g',0.7,'Sb:',NULL,NULL,NULL,NULL,1,180.0132083,8.18172,0,NULL,58021930077,906592657,14165510,14.2),(87502,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87502,34.82,0.4,92,36351,NULL,NULL,'mean','NGC 4029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87503,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87503,34.9,0.46,95.6,36351,NULL,NULL,'J','NGC 4029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87504,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87504,34.99,0.45,99.4,36351,NULL,NULL,'K','NGC 4029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87505,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87505,37.28,0.1,286,36352,70,NULL,NULL,'2MASX J12000390+5606430',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000204,NULL,'16.1g',0.36,'E0',NULL,NULL,NULL,NULL,1,180.016125,56.112,0,NULL,57210311388,893911115,13967361,16.1),(87506,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87506,34.82,0.33,92.2,36353,70,NULL,NULL,'2MASX J12000415+3147483',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000162,NULL,'16.0g',0.32,NULL,NULL,NULL,NULL,NULL,1,180.01725,31.79678,0,NULL,58621240146,915956877,14311826,16),(87507,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87507,37.67,0.21,342,36354,70,NULL,NULL,'SDSS J120004.18+553607.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,180.017458333,55.60217,0,NULL,57210374636,893912103,13967376,18.3),(87508,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87508,37.59,0.33,329,36355,70,NULL,NULL,'2MASX J12000564-0029430',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000085,NULL,'16.5g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,180.023417,-0.49533,0.033,NULL,42949775778,671090246,10485785,16.5),(87509,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87509,37.75,0.46,355,36356,70,NULL,NULL,'2MASX J12000604+2936114',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,180.025167,29.60314,0,NULL,58626159682,916033745,14313027,17.6),(87510,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87510,37.87,0.33,374,36357,70,NULL,NULL,'2MASX J12000603+2759184',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000169,NULL,'17.9',0.11,NULL,NULL,NULL,NULL,NULL,1,180.025291667,27.98847,0,NULL,58594434465,915538038,14305281,17.9),(87511,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87511,38.09,0.46,415,36358,70,NULL,NULL,'2MASX J12000806+0040255',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00009,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,180.033667,0.67383,0.013,NULL,57982910939,905982983,14155984,17),(87512,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87512,36.5,0.46,200,36359,70,NULL,NULL,'2MASX J12000888+1628145',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.68',0.2,NULL,NULL,NULL,NULL,NULL,1,180.036916667,16.47075,0.117,NULL,58141543873,908461623,14194712,17.68),(87513,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87513,38.04,0.27,406,36360,70,NULL,NULL,'SDSS J120010.03+570631.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,180.041833,57.10875,0.017,NULL,57328345880,895755404,13996178,18.4),(87514,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87514,37.95,0.46,390,36361,70,NULL,NULL,'2MASX J12001040+0332095',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000084,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,180.043417,3.53589,0.024,NULL,57992089154,906126393,14158224,17.5),(87515,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87515,34.72,0.51,87.8,36362,NULL,NULL,NULL,'ESO 572- G 039',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'15.36',0.6,'Sb:',NULL,NULL,NULL,NULL,1,180.0482917,-20.55514,0.117,NULL,43019333266,672177082,10502766,15.36),(87516,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87516,34.74,0.51,88.7,36362,NULL,NULL,'Malmquist cor.','ESO 572- G 039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87517,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87517,34.76,0.2,89.5,36362,74.4,NULL,NULL,'ESO 572- G 039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87518,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87518,37.05,0.46,258,36363,70,NULL,NULL,'2MASX J12001227+5017011',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000172,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,180.051125,50.28364,0.024,NULL,57185371109,893521423,13961272,17.3),(87519,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87519,37.99,0.46,396,36364,70,NULL,NULL,'2MASX J12001282+6109104',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00014,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,180.053375,61.153,0.017,NULL,57336529590,895883274,13998176,18.1),(87520,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87520,34.82,0.33,92.2,36365,70,NULL,NULL,'CGCG 157-081',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.00009,NULL,'14.9g',0.58,NULL,'Group member',NULL,NULL,NULL,1,180.054917,31.83,0,NULL,58621271608,915957368,14311833,14.9),(87521,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87521,37.57,0.46,327,36366,70,NULL,NULL,'2MASX J12001350-0025189',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000073,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,180.0564583,-0.42183,0.033,NULL,42949786995,671090421,10485787,17.7),(87522,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87522,37.33,0.46,292,36367,70,NULL,NULL,'2MASX J12001354+0401075',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00004,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,180.0565417,4.01875,0.018,NULL,57992081362,906126271,14158222,16.7),(87523,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87523,38.59,0.46,522,36368,70,NULL,NULL,'SDSS J120013.65+215241.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,180.056917,21.87817,0.056,NULL,58116357679,908068088,14188563,18.4),(87524,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87524,38.15,0.33,426,36369,70,NULL,NULL,'2MASX J12001370+3406044',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,180.057,34.10131,0,NULL,58535920163,914623752,14290996,17.5),(87525,'BCG','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87525,37.54,0.35,303,36370,60,NULL,'ABELL 1436, BCG','MCG +09-20-056',0.0646,'1980ApJ...241..486H',1980,1,0.2,NULL,'G',0.0002,NULL,'17.06',0.2,'BrClG','Brightest group member',NULL,NULL,NULL,1,180.057917,56.25069,0,NULL,57394856358,896794630,14012416,17.06),(87526,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87526,36.98,0.15,249,36371,70,NULL,NULL,'CGCG 069-015 NED01',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000103,NULL,'15.4g',0.59,'E0',NULL,NULL,NULL,NULL,1,180.059583,10.69675,0,NULL,58015735770,906495871,14163997,15.4),(87527,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87527,38.97,0.46,622,36372,70,NULL,NULL,'2MASX J12001534+2547372',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,180.064083333,25.79372,0,NULL,58595633619,915556775,14305574,17.6),(87528,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87528,37.6,0.27,331,36373,70,NULL,NULL,'2MASX J12001589+3820418',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,180.0662917,38.34506,0,NULL,58544506559,914757914,14293092,17.9),(87529,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87529,36.8,0.33,230,36374,70,NULL,NULL,'MCG +09-20-058',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000176,NULL,'15.8g',0.52,'E0',NULL,NULL,NULL,NULL,1,180.0664583,52.66814,0.009,NULL,57217006333,894015723,13968995,15.8),(87530,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87530,31.83,NULL,23.2,36375,NULL,NULL,NULL,'KUG 1157+315',NULL,'2013AJ....145..101K',2013,1,0.58,NULL,'G',0.000063,NULL,'15.0g',0.42,'Irr',NULL,NULL,NULL,NULL,1,180.067375,31.22506,0,NULL,58620676895,915948076,14311688,15),(87531,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87531,37.51,0.27,318,36376,70,NULL,NULL,'SDSS J120016.24-000837.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000069,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,180.0677083,-0.14372,0.037,NULL,42949733538,671089586,10485774,18.3),(87532,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87532,37.28,0.1,286,36377,70,NULL,NULL,'2MASX J12001646+5617281',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000165,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,180.068583,56.29108,0,NULL,57327750878,895746107,13996032,18.3),(87533,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87533,35.53,0.46,127,36378,70,NULL,NULL,'2MASX J12001659+0655416',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000178,NULL,'15.5g',0.47,NULL,NULL,NULL,NULL,NULL,1,180.069208333,6.92828,0,NULL,58020345644,906567900,14165123,15.5),(87534,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87534,37.5,0.21,316,36379,70,NULL,NULL,'2MASX J12001710+4330493',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,180.071417,43.51375,0,NULL,58520515846,914383060,14287235,17.8),(87535,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87535,38.35,0.46,468,36380,70,NULL,NULL,'2MASX J12001773+1720454',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.39',0.14,NULL,NULL,NULL,NULL,NULL,1,180.0739583,17.34589,0.083,NULL,58120660842,908135325,14189614,18.39),(87536,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87536,38.19,0.46,435,36381,70,NULL,NULL,'2MASX J12001888+1623446',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.44',0.15,NULL,NULL,NULL,NULL,NULL,1,180.078667,16.39575,0.117,NULL,58141556381,908461818,14194715,18.44),(87537,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87537,30.85,0.43,14.8,36382,75,NULL,'3.6 micron, color + selection bias corrected','UGC 06992',NULL,'2014MNRAS.444..527S',2014,1,1.35,NULL,'G',0.000033,NULL,'14.6g',0.56,'Sdm:',NULL,NULL,NULL,NULL,1,180.078667,50.65275,0.023,NULL,57231281434,894238772,13972480,14.6),(87538,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87538,31.02,0.43,16,36382,75,NULL,'3.6 micron, color corrected','UGC 06992',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87539,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87539,31.11,0.2,16.7,36382,74.4,NULL,NULL,'UGC 06992',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87540,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87540,37.08,0.27,261,36383,70,NULL,NULL,'2MASX J12001940+4535197',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,180.0810417,45.58883,0,NULL,57176889126,893388892,13959201,17.1),(87541,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87541,37.6,0.27,331,36384,70,NULL,NULL,'2MASX J12001986+3822122',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000166,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,180.0825417,38.36992,0,NULL,58544519930,914758123,14293095,17.3),(87542,'BCG','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87542,37.54,0.35,303,36385,60,NULL,NULL,'ABELL 1436',0.0646,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,180.091667,56.23028,0,NULL,57210309103,893911079,13967360,NULL),(87543,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87543,35.93,0.46,153,36386,70,NULL,NULL,'2MASX J12002318+4759251',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000175,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,180.096833333,47.9905,0,NULL,57186246244,893535097,13961485,16.3),(87544,'IRAS','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87544,31.77,0.8,22.6,36387,75,NULL,'MAT, I','NGC 4030',NULL,'1997ApJS..109..333W',1997,1,3.27,'Extended HIPASS source','G',0.000013,NULL,'11.6g',1.71,'SA(s)bc        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,180.0984583,-1.10008,0.029,NULL,42949978835,671093419,10485834,11.6),(87545,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87545,30.12,0.69,10.6,36387,100,NULL,'mid-IR','NGC 4030',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87546,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87546,31.55,0.43,20.4,36387,75,NULL,'MAT, I, raw','NGC 4030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87547,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87547,31.73,0.43,22.2,36387,75,NULL,'MAT, I, cor','NGC 4030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87548,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87548,31.82,0.43,23.1,36387,75,NULL,'MAT, I, inv','NGC 4030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87549,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87549,31.88,0.32,23.8,36387,85,NULL,'I, raw','NGC 4030',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87550,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87550,31.95,0.32,24.6,36387,85,NULL,'I, inv','NGC 4030',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87551,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87551,31.99,0.52,25,36387,NULL,NULL,'Malmquist cor.','NGC 4030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87552,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87552,32.07,0.4,25.9,36387,75,NULL,'B','NGC 4030',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87553,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87553,32.09,NULL,26.2,36387,NULL,NULL,'I','NGC 4030',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87554,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87554,32.17,0.4,27.2,36387,NULL,NULL,NULL,'NGC 4030',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87555,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87555,32.34,0.44,29.3,36387,NULL,NULL,NULL,'NGC 4030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87556,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87556,32.38,0.2,29.9,36387,74.4,NULL,NULL,'NGC 4030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87557,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87557,32.46,NULL,31,36387,NULL,NULL,'LEDA [Nov 2006]','NGC 4030',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87558,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87558,32.64,NULL,33.7,36387,NULL,NULL,'B','NGC 4030',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87559,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87559,38.46,0.46,493,36388,70,NULL,NULL,'2MASX J12002490+1835009',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,180.10375,18.58369,0.034,NULL,58123057709,908172776,14190199,17.7),(87560,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87560,37.03,0.33,254,36389,70,NULL,NULL,'SDSS J120025.28+344441.7',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'15.9g',0.39,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,180.105333333,34.74492,0,NULL,58536461526,914632211,14291128,15.9),(87561,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87561,38.3,0.46,457,36390,70,NULL,NULL,'2MASX J12002609+0521070',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,180.1087083,5.35206,0,NULL,57990498497,906101539,14157836,17.3),(87562,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87562,37.37,0.33,298,36391,70,NULL,NULL,'2MASX J12002638+0948136',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000165,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,180.109875,9.80392,0,NULL,58019297037,906551516,14164867,16.7),(87563,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87563,37.28,0.1,286,36392,70,NULL,NULL,'SDSS J120027.28+561554.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000172,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,180.113708333,56.26508,0,NULL,57394860005,896794687,14012416,17.6),(87564,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87564,37.89,0.33,379,36393,70,NULL,NULL,'2MASX J12002768+2125259',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,180.1152083,21.42392,0.052,NULL,58116765552,908074461,14188663,18.3),(87565,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87565,36.92,0.46,242,36394,70,NULL,NULL,'2MASX J12002775+2337309',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.98',0.21,NULL,NULL,NULL,NULL,NULL,1,180.1157083,23.62536,0.022,NULL,58586584400,915415381,14303365,17.98),(87566,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87566,36.2,0.2,174,36395,74.4,NULL,NULL,'CGCG 069-016',NULL,'2013AJ....146...86T',2013,1,0.69,NULL,'G',0.000027,NULL,'15.6g',0.5,'Sab',NULL,NULL,NULL,NULL,1,180.116917,9.61564,0,NULL,58017251120,906519548,14164367,15.6),(87567,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87567,37.28,0.1,286,36396,70,NULL,NULL,'2MASX J12002830+5607010',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00019,NULL,'16.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,180.117917,56.11706,0,NULL,57210366384,893911974,13967374,16.7),(87568,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87568,37.51,0.27,318,36397,70,NULL,NULL,'2MASX J12002886-0007248',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000101,NULL,'16.1g',0.35,'BrClG          AGN',NULL,NULL,NULL,NULL,1,180.1202917,-0.12358,0.061,NULL,42949737634,671089650,10485775,16.1),(87569,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87569,37.56,0.33,324,36398,70,NULL,NULL,'2MASX J12002888+2909142',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000123,NULL,'18.16',0.18,'E',NULL,NULL,NULL,NULL,1,180.120375,29.15394,0,NULL,58624554256,916008660,14312635,18.16),(87570,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87570,37.5,0.21,316,36399,70,NULL,NULL,'2MASX J12002934+4324087',NULL,'2015arXiv151105856S',2015,1,0.35,'2004AJ....127.1943G has z = 0.0335 +- 0.0028.','G',0.000179,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,180.122333,43.40258,0,NULL,58520562219,914383784,14287246,16.8),(87571,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87571,37.59,0.46,329,36400,70,NULL,NULL,'2MASX J12003038+4453177',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,180.1264583,44.88836,0,NULL,58518945332,914358520,14286851,17.4),(87572,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87572,38.15,0.33,426,36401,70,NULL,NULL,'2MASX J12003085+3406094',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,180.1285,34.10267,0,NULL,58535933123,914623955,14290999,18),(87573,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87573,36.29,0.46,181,36402,70,NULL,NULL,'2MASX J12003108+0846256',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,180.129583,8.77386,0,NULL,58016884360,906513818,14164278,16.6),(87574,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87574,34.79,0.34,90.7,36403,NULL,NULL,'Malmquist cor.','UGC 06994',NULL,'2009ApJS..182..474S',2009,1,1.25,NULL,'G',0.000012,NULL,'15.5g',0.34,'Sd',NULL,NULL,NULL,NULL,1,180.130417,8.86375,0,NULL,58016844479,906513194,14164268,15.5),(87575,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87575,34.82,0.49,92,36403,75,NULL,'IR','UGC 06994',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87576,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87576,34.87,0.2,94.2,36403,74.4,NULL,NULL,'UGC 06994',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87577,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87577,34.89,0.32,95.1,36403,NULL,NULL,NULL,'UGC 06994',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87578,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87578,37.47,0.46,312,36404,70,NULL,NULL,'2MASX J12003193+2900172',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000127,NULL,'16.4g',0.33,'E',NULL,NULL,NULL,NULL,1,180.133,29.00492,0,NULL,58624427087,916006673,14312604,16.4),(87579,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87579,37.35,0.46,295,36405,70,NULL,NULL,'2MASX J12003192+1422576',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000177,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,180.1330417,14.38272,0.04,NULL,58142713125,908479892,14194998,17.3),(87580,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87580,37.08,0.27,261,36406,70,NULL,NULL,'2MASX J12003197+4535177',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000176,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,180.133375,45.58817,0,NULL,57176942646,893389728,13959214,16.5),(87581,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87581,38.79,0.46,574,36407,70,NULL,NULL,'2MASX J12003224+4147403',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,180.134375,41.79467,0,NULL,58525465213,914460393,14288443,17.8),(87582,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87582,37.19,0.46,274,36408,70,NULL,NULL,'VIII Zw 162 NED01',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000143,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,180.138291667,13.55422,0.017,NULL,58135257753,908363402,14193178,17.8),(87583,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87583,35.69,0.68,137,36409,70,NULL,NULL,'2MASX J12003324-1027513',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,180.1385417,-10.46428,0.093,NULL,42967314751,671364292,10490067,16.8),(87584,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87584,37.4,0.46,303,36410,70,NULL,NULL,'2MASX J12003399+2153180',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'18.04',0.13,NULL,NULL,NULL,NULL,NULL,1,180.14175,21.8885,0.048,NULL,58116401724,908068776,14188574,18.04),(87585,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87585,37.32,0.46,290,36411,70,NULL,NULL,'2MASX J12003438+5209450',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000179,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,180.143167,52.16233,0.01,NULL,57216873334,894013645,13968963,16.9),(87586,'GCLF','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87586,32.08,0.24,26.1,36412,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4033',NULL,'2012MNRAS.422.3591C',2012,1,2.6,NULL,'G',0.000067,NULL,'13.18',1.1,'E6','Pair member (points to parent)',NULL,NULL,NULL,1,180.14475,-17.84261,0.061,NULL,43025656892,672275888,10504310,13.18),(87587,'GCLF','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87587,32.41,0.33,30.3,36412,NULL,NULL,'TOM(z) = -8.4 mag','NGC 4033',NULL,'2012MNRAS.422.3591C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87588,'SBF','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87588,31.62,0.23,21.1,36412,NULL,NULL,'I','NGC 4033',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87589,'SBF','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87589,31.62,0.23,21.1,36412,NULL,NULL,NULL,'NGC 4033',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87590,'SBF','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87590,31.66,0.14,21.5,36412,74.4,NULL,NULL,'NGC 4033',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87591,'SBF','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87591,31.67,0.23,21.6,36412,NULL,NULL,'Malmquist cor.','NGC 4033',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87592,'D-Sigma','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87592,31.51,0.4,20.1,36412,75,NULL,'Edat, raw','NGC 4033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87593,'D-Sigma','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87593,31.71,0.4,22,36412,75,NULL,'Edat, cor','NGC 4033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87594,'Faber-Jackson','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87594,30.73,0.65,14,36412,95,NULL,'Weighted Mean','NGC 4033',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87595,'Faber-Jackson','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87595,31.88,0.81,23.8,36412,55,NULL,'Visvanathan & Sandage 1979','NGC 4033',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87596,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87596,31.63,0.41,21.1,36412,NULL,NULL,NULL,'NGC 4033',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87597,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87597,31.76,0.41,22.5,36412,NULL,NULL,'Malmquist cor.','NGC 4033',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87598,'Tertiary','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87598,30.44,0.38,12.2,36412,95,NULL,NULL,'NGC 4033',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87599,'Tully est','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87599,31.89,0.8,23.9,36412,75,NULL,'B','NGC 4033',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87600,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87600,37.07,0.33,259,36413,70,NULL,NULL,'2MASX J12003497+3239520',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000192,NULL,'15.7g',0.42,NULL,NULL,NULL,NULL,NULL,1,180.1457917,32.66456,0,NULL,58620084094,915938813,14311543,15.7),(87601,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87601,37.56,0.33,324,36414,70,NULL,NULL,'2MASX J12003560+2911462',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00011,NULL,'16.6g',0.36,'Sb',NULL,NULL,NULL,NULL,1,180.148417,29.19619,0,NULL,58624550512,916008601,14312634,16.6),(87602,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87602,36.71,0.46,220,36415,70,NULL,NULL,'2MASX J12003631-0058448',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000072,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,180.151333,-0.97903,0.029,NULL,42950161347,671096271,10485879,17),(87603,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87603,37.07,0.33,259,36416,70,NULL,NULL,'2MASX J12003662+3243220',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000161,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,180.1525417,32.72286,0,NULL,58620008946,915937639,14311525,18),(87604,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87604,37.5,0.21,316,36417,70,NULL,NULL,'2MASX J12003687+4327337',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.00011,NULL,'15.6g',0.46,'BrClG',NULL,NULL,NULL,NULL,1,180.15375,43.45944,0,NULL,58520513513,914383023,14287234,15.6),(87605,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87605,37.03,0.33,254,36418,70,NULL,NULL,'2MASX J12003767+3443400',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000189,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,180.156958333,34.72775,0,NULL,58536467434,914632303,14291129,16.3),(87606,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87606,37.5,0.21,316,36419,70,NULL,NULL,'2MASX J12003769+4326197',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000187,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,180.157167,43.43869,0,NULL,58520556722,914383698,14287245,17.3),(87607,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87607,38.29,0.46,455,36420,70,NULL,NULL,'2MASX J12003776+2213250',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.84',0.13,NULL,NULL,NULL,NULL,NULL,1,180.1575,22.22361,0.038,NULL,58116328643,908067635,14188556,18.84),(87608,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:02','1','SN 1996I',NULL,87608,41.78,0.4,1450,36421,74.2,NULL,'SALT 2','[GC96] J120039.43-001602.4',0.57,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,':',NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,180.1642917,-0.26733,0.033,NULL,42949914857,671092419,10485819,NULL),(87609,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:02','1','SN 1996I','R',87609,41.86,NULL,1500,36421,65,NULL,'SALT','[GC96] J120039.43-001602.4',0.57,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87610,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:02','1','SN 1996I',NULL,87610,42.63,0.33,2140,36421,70,NULL,'SALT','[GC96] J120039.43-001602.4',0.57,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87611,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:02','1','SN 1996I',NULL,87611,42.76,0.19,2270,36421,65,NULL,'MLCS','[GC96] J120039.43-001602.4',0.57,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87612,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:02','1','SN 1996I',NULL,87612,42.8,0.31,2310,36421,65,NULL,'SALT','[GC96] J120039.43-001602.4',0.57,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87613,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:02','1','SN 1996I',NULL,87613,42.81,0.25,2320,36421,65,NULL,NULL,'[GC96] J120039.43-001602.4',0.57,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87614,'SNIa','2016-12-15 15:14:53','2016-12-16 11:20:02','1','SN 1996I',NULL,87614,42.83,0.21,2340,36421,65,NULL,'Template','[GC96] J120039.43-001602.4',0.57,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87615,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87615,37.28,0.1,286,36422,70,NULL,NULL,'2MASX J12003952+5617129',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000177,NULL,'16.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,180.1647083,56.28708,0,NULL,57394858734,896794667,14012416,16.4),(87616,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87616,37.2,0.46,275,36423,70,NULL,NULL,'SDSS J120039.73+093209.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000146,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,180.165583,9.53586,0,NULL,58017235308,906519301,14164364,17.8),(87617,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87617,38.45,0.33,489,36424,70,NULL,NULL,'2MASX J12004145+4553237',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,180.1727083,45.89,0,NULL,57177403737,893396933,13959327,17.9),(87618,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87618,36.04,0.46,161,36425,70,NULL,NULL,'2MASX J12004196+2106270',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.55',0.22,NULL,NULL,NULL,NULL,NULL,1,180.174916667,21.10756,0.051,NULL,58116542632,908070978,14188609,16.55),(87619,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87619,37.51,0.27,318,36426,70,NULL,NULL,'2MASX J12004239-0013518',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000069,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,180.17675,-0.23114,0.033,NULL,42949920355,671092505,10485820,17.3),(87620,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87620,37.89,0.33,379,36427,70,NULL,NULL,'2MASX J12004314+2128421',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,180.179875,21.47833,0.052,NULL,58116719554,908073743,14188652,17.5),(87621,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87621,37.38,0.33,299,36428,70,NULL,NULL,'2MASX J12004356+0110560',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000074,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,180.1814583,1.18217,0.021,NULL,57982623288,905978488,14155913,17.2),(87622,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87622,37.8,0.46,364,36429,70,NULL,NULL,'2MASX J12004520+2643182',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000183,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,180.1885,26.72178,0,NULL,58598105742,915595402,14306178,17.6),(87623,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87623,37.15,0.2,269,36430,74.4,NULL,NULL,'CGCG 069-020',NULL,'2013AJ....146...86T',2013,1,0.79,NULL,'G',0.00016,NULL,'15.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,180.192,14.15956,0,NULL,58142512156,908476752,14194949,15.7),(87624,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87624,37.73,0.33,352,36431,70,NULL,NULL,'2MASX J12004687+4651556',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'17.1g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,180.1955,46.86536,0,NULL,57179266527,893426039,13959781,17.1),(87625,'Tully est','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87625,32.45,0.8,31,36432,75,NULL,NULL,'NGC 4030b',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.000017,NULL,'17.',1.3,'SAB(s)m','Group member of poor cluster',NULL,NULL,NULL,1,180.198708333,-0.02333,0.061,NULL,42949713667,671089276,10485769,17),(87626,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87626,37.41,0.46,303,36433,70,NULL,NULL,'2MASX J12004801+3255501',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,180.200125,32.93061,0,NULL,58620515297,915945551,14311649,17.1),(87627,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87627,37.79,0.33,361,36434,70,NULL,NULL,'2MASX J12004861+6546253',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000188,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,180.2025,65.77375,0.021,NULL,57312774864,895512107,13992376,16.9),(87628,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87628,37.73,0.33,352,36435,70,NULL,NULL,'2MASX J12004873+4651596',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,180.203208333,46.86661,0,NULL,57179266324,893426036,13959781,17.5),(87629,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87629,38.18,0.46,433,36436,70,NULL,NULL,'SDSS J120049.09+582526.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000141,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,180.204583,58.42403,0,NULL,57330775188,895793362,13996771,18.6),(87630,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87630,37.02,0.46,254,36437,70,NULL,NULL,'2MASX J12004936+0141370',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000089,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,180.205583,1.69372,0.021,NULL,57984675679,906010557,14156414,16.5),(87631,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87631,37.28,0.1,286,36438,70,NULL,NULL,'SDSS J120049.35+561300.4',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,180.205667,56.21686,0,NULL,57210316648,893911197,13967362,17.6),(87632,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87632,36.89,0.46,238,36439,70,NULL,NULL,'2MASX J12004972+1001307',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000156,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,180.207208333,10.02525,0,NULL,58016121277,906501894,14164092,16.8),(87633,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87633,36.68,0.46,217,36440,70,NULL,NULL,'2MASX J12004977+4239156',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,180.207375,42.65433,0,NULL,58520159538,914377492,14287148,17.4),(87634,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87634,38.47,0.33,494,36441,70,NULL,NULL,'SDSS J120050.09+150442.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00013,NULL,'18.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,180.2087083,15.07853,0.055,NULL,58143264393,908488506,14195132,18.8),(87635,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87635,37.38,0.33,299,36442,70,NULL,NULL,'2MASX J12005045+0109271',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000107,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,180.2102917,1.15764,0.021,NULL,57982622969,905978483,14155913,16.8),(87636,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87636,37.3,0.33,288,36443,70,NULL,NULL,'2MASX J12005047+6815263',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000087,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,180.210625,68.25731,0.013,NULL,56976280551,890254383,13910224,17.3),(87637,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87637,37.49,0.46,315,36444,70,NULL,NULL,'2MASX J12005217+5911196',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000141,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,180.2172083,59.18864,0,NULL,57337191580,895893618,13998337,17),(87638,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87638,37.97,0.46,393,36445,70,NULL,NULL,'2MASX J12005227+1135087',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,180.217958333,11.58564,0,NULL,58133254593,908332103,14192689,17.6),(87639,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87639,38.45,0.33,489,36446,70,NULL,NULL,'SDSS J120052.84+455022.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000163,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,180.2202083,45.83972,0,NULL,57177346555,893396039,13959313,18.6),(87640,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87640,38.71,0.46,552,36447,70,NULL,NULL,'SDSS J120052.99+282037.7',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.6g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,180.220833,28.34383,0,NULL,58624032984,916000515,14312508,17.6),(87641,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87641,37.84,0.46,371,36448,70,NULL,NULL,'2MASX J12005312+0048501',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000091,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,180.22125,0.81383,0.005,NULL,57982671169,905979237,14155925,17.2),(87642,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87642,37.1,0.46,263,36449,70,NULL,NULL,'2MASX J12005443+1253183',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000161,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,180.226833333,12.88842,0,NULL,58135672073,908369876,14193279,16.7),(87643,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87643,37.28,0.1,286,36450,70,NULL,NULL,'2MASX J12005469+5612026',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000177,NULL,'16.2g',0.3,'S0^-',NULL,NULL,NULL,NULL,1,180.228041667,56.20094,0,NULL,57210318703,893911229,13967362,16.2),(87644,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87644,37.75,0.46,354,36451,70,NULL,NULL,'SDSS J120054.94+651321.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000166,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,180.2289583,65.22253,0.033,NULL,57312212803,895503325,13992239,18.5),(87645,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87645,38.03,0.46,404,36452,70,NULL,NULL,'2MASX J12005499+6805153',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000115,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,180.229083333,68.08756,0.013,NULL,56975616839,890244013,13910062,17),(87646,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87646,38.19,0.46,435,36453,70,NULL,NULL,'2MASX J12005504+1515193',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,180.229416667,15.25533,0.055,NULL,58143055162,908485236,14195081,18.2),(87647,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87647,36.23,0.46,176,36454,70,NULL,NULL,'2MASX J12005528+2348571',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,180.230375,23.81586,0.022,NULL,58589506329,915461036,14304078,16.4),(87648,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87648,38.09,0.46,415,36455,70,NULL,NULL,'SDSS J120055.85+194348.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.79',0.14,NULL,NULL,NULL,NULL,NULL,1,180.23275,19.73011,0.064,NULL,58117352619,908083634,14188806,18.79),(87649,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87649,36.96,0.46,247,36456,70,NULL,NULL,'2MASX J12005618+0239571',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000073,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,180.234083,2.66592,0.015,NULL,57995748761,906183574,14159118,17.1),(87650,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87650,36.04,0.46,161,36457,70,NULL,NULL,'2MASX J12005709+2016241',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00008,NULL,'16.25',0.26,NULL,NULL,NULL,NULL,NULL,1,180.237833333,20.27336,0.034,NULL,58118238477,908097476,14189023,16.25),(87651,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87651,38.16,0.13,428,36458,70,NULL,NULL,'2MASX J12005831+5803286',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000134,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,180.243083,58.05819,0,NULL,57330335339,895786489,13996663,18.3),(87652,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87652,36.98,0.15,249,36459,70,NULL,NULL,'2MASX J12010024+1036526',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000176,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,180.251083333,10.61456,0.027,NULL,58015709837,906495466,14163991,17.5),(87653,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87653,38.08,0.46,413,36460,70,NULL,NULL,'LCRS B115826.6-021645',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,180.25175,-2.55753,0.033,NULL,42950747358,671105427,10486022,18.1),(87654,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87654,36.82,0.46,231,36461,70,NULL,NULL,'2MASX J12010066+5315006',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00017,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,180.253,53.25011,0,NULL,57216650665,894010166,13968908,16.7),(87655,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87655,36.23,0.49,176,36462,75,NULL,'IR','ESO 379-IG 021',NULL,'2011yCatp016004901K',2011,1,1.6,NULL,'G',0.00005,NULL,'14.85',0.4,'SB(s)b? pec sp HII','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,180.254958333,-35.21539,0.329,NULL,43253273387,675832396,10559881,14.85),(87656,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87656,38.16,0.13,428,36463,70,NULL,NULL,'SDSS J120102.09+581406.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,180.25875,58.23506,0,NULL,57330302421,895785975,13996655,18.1),(87657,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87657,38.1,0.46,417,36464,70,NULL,NULL,'2MASX J12010311+4522038',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000202,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,180.262917,45.36758,0,NULL,57176970836,893390169,13959221,17.3),(87658,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87658,37.47,0.46,312,36465,70,NULL,NULL,'2MASX J12010391+3312561',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000193,NULL,'16.4g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,180.266166667,33.2155,0,NULL,58619682158,915932533,14311445,16.4),(87659,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87659,37.24,0.46,281,36466,70,NULL,NULL,'2MASX J12010503+4643348',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000141,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,180.270833,46.72631,0,NULL,57179328746,893427011,13959797,17.9),(87660,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87660,37.47,0.46,312,36467,70,NULL,NULL,'2MASX J12010553+5020405',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,180.273,50.34453,0.016,NULL,57185381164,893521580,13961274,17.4),(87661,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87661,36.33,0.46,184,36468,70,NULL,NULL,'2MASX J12010572+0027351',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000086,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,180.273708333,0.45972,0,NULL,57982941026,905983453,14155991,17.1),(87662,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87662,38.16,0.13,428,36469,70,NULL,NULL,'2MASX J12010624+5800106',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000093,NULL,'16.6g',0.38,'BrClG',NULL,NULL,NULL,NULL,1,180.27575,58.00297,0,NULL,57330326922,895786358,13996661,16.6),(87663,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87663,38.19,0.46,434,36470,70,NULL,NULL,'2MASX J12010669+5058445',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,180.277875,50.97911,0.019,NULL,57214721782,893980027,13968437,17.3),(87664,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87664,36.6,0.33,209,36471,70,NULL,NULL,'2MASX J12010688+5201045',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,180.278916667,52.01786,0,NULL,57217913608,894029900,13969217,16.9),(87665,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87665,38.76,0.46,565,36472,70,NULL,NULL,'2MASX J12010701+4441318',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,180.279167,44.69233,0,NULL,58518970396,914358912,14286858,17.6),(87666,'IRAS','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87666,31.8,0.8,22.9,36473,75,NULL,'MAT, I','UGCA 263',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000018,NULL,'14.10',0.39,'Sm             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,180.280166667,-24.56869,0.237,NULL,43354286015,677410718,10584542,14.1),(87667,'Tully est','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87667,32.12,0.8,26.6,36473,75,NULL,NULL,'UGCA 263',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87668,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87668,30.98,0.39,15.7,36473,73,NULL,'IR','UGCA 263',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87669,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87669,30.98,0.4,15.7,36473,75,NULL,NULL,'UGCA 263',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87670,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87670,31.2,0.32,17.4,36473,85,NULL,'I, inv','UGCA 263',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87671,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87671,31.22,0.32,17.5,36473,85,NULL,'I, raw','UGCA 263',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87672,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87672,31.45,0.43,19.5,36473,75,NULL,'MAT, I, inv','UGCA 263',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87673,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87673,31.46,0.43,19.6,36473,75,NULL,'MAT, I, raw','UGCA 263',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87674,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87674,31.52,0.4,20.1,36473,NULL,NULL,NULL,'UGCA 263',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87675,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87675,31.61,0.2,21,36473,74.4,NULL,NULL,'UGCA 263',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87676,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87676,31.65,0.43,21.4,36473,75,NULL,'3.6 micron, color corrected','UGCA 263',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87677,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87677,31.65,0.43,21.4,36473,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 263',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87678,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87678,31.66,0.49,21.5,36473,75,NULL,'IR','UGCA 263',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87679,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87679,31.69,0.43,21.8,36473,75,NULL,'MAT, I, cor','UGCA 263',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87680,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87680,32.19,NULL,27.4,36473,NULL,NULL,'Dipole + Quadrupole + Octopole','UGCA 263',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87681,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87681,32.21,NULL,27.7,36473,NULL,NULL,'Dipole','UGCA 263',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87682,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87682,32.21,NULL,27.7,36473,NULL,NULL,'Dipole + Quadrupole','UGCA 263',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87683,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87683,32.47,NULL,31.2,36473,NULL,NULL,NULL,'UGCA 263',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87684,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87684,37.95,0.46,390,36474,70,NULL,NULL,'2MASX J12010741+0900263',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000149,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,180.280917,9.00728,0,NULL,58017565911,906524467,14164444,17.6),(87685,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87685,38.74,0.46,559,36475,70,NULL,NULL,'2MASX J12010793-0136360',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000174,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,180.2832083,-1.61003,0.061,NULL,42951503029,671117234,10486206,17.7),(87686,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87686,38.04,0.27,406,36476,70,NULL,NULL,'2MASX J12010824+5706546',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000194,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,180.2842917,57.11519,0.017,NULL,57328397666,895756213,13996190,17.5),(87687,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87687,38.47,0.33,494,36477,70,NULL,NULL,'2MASX J12010992+1500462',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,180.291375,15.01286,0.017,NULL,58143270904,908488607,14195134,18),(87688,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87688,37.63,0.46,335,36478,70,NULL,NULL,'2MASX J12011024+2240162',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.56',0.17,NULL,NULL,NULL,NULL,NULL,1,180.29225,22.67094,0.032,NULL,58586277227,915410581,14303290,18.56),(87689,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87689,30.98,0.49,15.7,36479,75,NULL,'IR','2MFGC 09444',NULL,'2011yCatp016004901K',2011,1,0.74,NULL,'G',0.000183,NULL,'16.8r',0.74,NULL,NULL,NULL,NULL,NULL,1,180.2922917,-1.29281,0.033,NULL,42953365116,671146329,10486661,16.8),(87690,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87690,31.72,0.4,22.1,36480,75,NULL,NULL,'NGC 4019',NULL,'2008Ap.....51..336K',2008,1,2.91,NULL,'G',0.00001,NULL,'13.1B',0.34,'SBb? sp','in a radial-velocity based grouping',NULL,NULL,NULL,1,180.293417,14.10431,0,NULL,58142510188,908476721,14194948,13.1),(87691,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87691,32.33,NULL,29.2,36480,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 4019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87692,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87692,32.33,NULL,29.2,36480,NULL,NULL,'Dipole','NGC 4019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87693,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87693,32.34,NULL,29.4,36480,NULL,NULL,'Dipole + Quadrupole','NGC 4019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87694,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87694,32.42,NULL,30.5,36480,NULL,NULL,NULL,'NGC 4019',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87695,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87695,32.46,0.49,31,36480,75,NULL,'IR','NGC 4019',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87696,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87696,35.4,0.64,120,36481,70,NULL,NULL,'2MASX J12011123-3837143',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000103,NULL,'12.4I',1,NULL,NULL,NULL,NULL,NULL,1,180.296833,-38.62064,0.381,NULL,43256771060,675887047,10560735,12.4),(87697,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87697,37.43,0.46,306,36482,70,NULL,NULL,'SDSS J120112.70+050511.4',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,180.3029583,5.08653,0,NULL,57990649515,906103898,14157873,17.8),(87698,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87698,38.16,0.13,428,36483,70,NULL,NULL,'SDSS J120112.72+575923.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000176,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,180.303,57.98978,0,NULL,57330324167,895786315,13996661,18.6),(87699,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87699,37.5,0.21,316,36484,70,NULL,NULL,'2MASX J12011371+4334158',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000173,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,180.306917,43.571,0,NULL,58522655932,914416498,14287757,16.8),(87700,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87700,37.28,0.1,286,36485,70,NULL,NULL,'2MASX J12011368+5623096',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,180.307125,56.386,0,NULL,57327751367,895746115,13996033,16.8),(87701,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87701,37.3,0.33,288,36486,70,NULL,NULL,'2MASX J12011475+6813572',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000098,NULL,'15.8g',0.41,'E0',NULL,NULL,NULL,NULL,1,180.311167,68.23253,0.021,NULL,56976292290,890254567,13910227,15.8),(87702,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87702,37.48,0.33,314,36487,70,NULL,NULL,'2MASX J12011472+0056231',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000086,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,180.3115,0.93981,0.005,NULL,57982807435,905981366,14155958,16.4),(87703,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87703,37.87,0.46,375,36488,70,NULL,NULL,'SDSS J120115.06+561830.0',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,180.3127917,56.30839,0,NULL,57394866363,896794786,14012418,17.7),(87704,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87704,37.49,0.33,315,36489,70,NULL,NULL,'2MASX J12011553+0218091',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000103,NULL,'17.98',0.16,'BrClG',NULL,NULL,NULL,NULL,1,180.314666667,2.30267,0.025,NULL,57984410427,906006412,14156350,17.98),(87705,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87705,38.36,0.46,471,36490,70,NULL,NULL,'2MASX J12011612+0122081',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000084,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,180.317083333,1.36886,0.021,NULL,57985502455,906023475,14156616,17.7),(87706,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87706,37.68,0.46,343,36491,70,NULL,NULL,'2MASX J12011695+3211583',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000232,NULL,'16.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,180.3205,32.19961,0,NULL,58623290313,915988911,14312326,16.2),(87707,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87707,36.98,0.15,249,36492,70,NULL,NULL,'2MASX J12011696+1038373',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000182,NULL,'16.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,180.32075,10.64375,0,NULL,58015824404,906497256,14164019,16.2),(87708,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87708,34.29,NULL,72,36493,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1348',NULL,'2010Ap&SS.325..163P',2010,1,1.17,'SDSS has z = 0.023135 +- 0.000100; 2000A&AS..143..421M has a line at this z.','G',0.000037,NULL,'16.7g',0.15,'Sd',NULL,NULL,NULL,NULL,1,180.3222083,31.278,0,NULL,58620843430,915950678,14311729,16.7),(87709,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87709,34.29,NULL,72.2,36493,NULL,NULL,'Dipole + Quadrupole','FGC 1348',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87710,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87710,34.3,NULL,72.4,36493,NULL,NULL,'Dipole','FGC 1348',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87711,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87711,34.31,NULL,72.6,36493,NULL,NULL,NULL,'FGC 1348',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87712,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87712,37.49,0.33,315,36494,70,NULL,NULL,'2MASX J12011780+0223471',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000076,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,180.3242083,2.39653,0.009,NULL,57984382388,906005974,14156343,17.7),(87713,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87713,36.04,0.46,161,36495,70,NULL,NULL,'2MASX J12011832+5926216',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,180.3265417,59.43944,0,NULL,57337403171,895896924,13998389,16.8),(87714,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87714,37.62,0.46,335,36496,70,NULL,NULL,'2MASX J12011846+0153331',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000084,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,180.326958333,1.89278,0,NULL,57985097609,906017150,14156517,17),(87715,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87715,37.83,0.46,368,36497,70,NULL,NULL,'2MASX J12011867+5241195',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,180.327958333,52.68875,0,NULL,57217028309,894016067,13969001,18.1),(87716,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87716,36.51,0.33,200,36498,70,NULL,NULL,'MCG +09-20-065',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.00009,NULL,'15.3g',0.5,'E0',NULL,NULL,NULL,NULL,1,180.328291667,53.47414,0,NULL,57225046120,894141345,13970958,15.3),(87717,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87717,35.13,0.46,106,36499,70,NULL,NULL,'CGCG 069-026',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000143,NULL,'15.1g',0.38,'S0',NULL,NULL,NULL,NULL,1,180.3285417,9.16511,0,NULL,58017268637,906519822,14164372,15.1),(87718,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87718,36.81,0.46,230,36500,70,NULL,NULL,'2MASX J12011905+1947593',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00012,NULL,'17.72',0.2,NULL,NULL,NULL,NULL,NULL,1,180.329375,19.79975,0.052,NULL,58117569585,908087024,14188859,17.72),(87719,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87719,33.3,0.4,45.7,36501,NULL,NULL,'mean','ESO 379- G 022',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000047,NULL,'14.05',0.8,'S?             HII',NULL,NULL,NULL,NULL,1,180.3360417,-33.87656,0.353,NULL,43251709860,675807966,10559499,14.05),(87720,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87720,33.76,0.47,56.5,36501,NULL,NULL,'H','ESO 379- G 022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87721,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87721,36.98,0.15,249,36502,70,NULL,NULL,'SDSS J120120.91+104106.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,180.337167,10.68522,0,NULL,58015817601,906497150,14164017,18.2),(87722,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87722,30.73,NULL,14,36503,NULL,NULL,NULL,'SHOC 357',NULL,'2014A&A...562A..49M',2014,1,0.35,NULL,'G',0.000067,NULL,'17.6g',0.19,'BlueCG;LSBG    HII',NULL,NULL,NULL,NULL,1,180.3429583,2.18564,0.025,NULL,57984353443,906005522,14156336,17.6),(87723,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87723,37.48,0.46,313,36504,70,NULL,NULL,'2MASX J12012237+1604001',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000171,NULL,'16.7g',0.29,'Irr ?',NULL,NULL,NULL,NULL,1,180.3430417,16.06672,0.13,NULL,58142404595,908475071,14194922,16.7),(87724,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87724,31.18,0.4,17.2,36505,75,NULL,'B','NGC 4037',NULL,'1988NBGC.C....0000T',1988,1,1.93,NULL,'G',0.000023,NULL,'13.7g',1.31,'SB(rs)b:','in a radial-velocity based grouping',NULL,NULL,NULL,1,180.348625,13.40103,0.016,NULL,58135348074,908364813,14193200,13.7),(87725,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87725,36.37,0.57,188,36506,70,NULL,NULL,'2MASX J12012397-3703392',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.7I',0.3,NULL,NULL,NULL,NULL,NULL,1,180.349833333,-37.061,0.313,NULL,43258045500,675906960,10561046,14.7),(87726,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87726,37.21,0.46,277,36507,70,NULL,NULL,'2MASX J12012424+6830001',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000116,NULL,'16.4g',0.34,'BLAGN',NULL,NULL,NULL,'Sy 1',1,180.3507083,68.50011,0,NULL,56976058684,890250916,13910170,16.4),(87727,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87727,36.78,0.17,227,36508,70,NULL,NULL,'SDSS J120124.17+545532.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000175,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,180.35075,54.92556,0,NULL,57214031553,893969243,13968269,17.3),(87728,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87728,36.51,0.33,200,36509,70,NULL,NULL,'2MASX J12012471+5329027',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,180.353083333,53.48408,0,NULL,57225048136,894141377,13970959,17.3),(87729,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87729,36.98,0.15,249,36510,70,NULL,NULL,'2MASX J12012530+1038162',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000184,NULL,'15.8g',0.42,'BrClG',NULL,NULL,NULL,NULL,1,180.3555,10.63789,0,NULL,58015810616,906497040,14164016,15.8),(87730,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87730,36.08,0.46,164,36511,70,NULL,NULL,'2MASX J12012616+1257261',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000161,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,180.3590417,12.95719,0,NULL,58135612332,908368942,14193264,16.5),(87731,'Faber-Jackson','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87731,30.72,0.51,13.9,36512,95,NULL,'de Vaucouleurs','NGC 4036',NULL,'1984ApJS...56...91D',1984,1,3.82,NULL,'G',0.000017,NULL,'11.7g',1.03,'S0-            LINER','in a radial-velocity based grouping',NULL,NULL,'LINER b',1,180.3614583,61.89578,0.025,NULL,57369696056,896401500,14006273,11.7),(87732,'Faber-Jackson','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87732,31.22,0.3,17.5,36512,95,NULL,'Weighted Mean','NGC 4036',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87733,'Faber-Jackson','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87733,31.66,0.46,21.5,36512,95,NULL,'Michard 1979a','NGC 4036',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87734,'Faber-Jackson','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87734,32.05,0.63,25.7,36512,95,NULL,'Michard 1979b, c','NGC 4036',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87735,'Faber-Jackson','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87735,32.67,0.81,34.2,36512,55,NULL,'Visvanathan & Sandage 1979','NGC 4036',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87736,'Tertiary','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87736,31.34,0.41,18.5,36512,95,NULL,NULL,'NGC 4036',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87737,'Tully est','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87737,31.95,0.8,24.6,36512,75,NULL,'B','NGC 4036',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87738,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87738,30.67,0.45,13.6,36512,NULL,NULL,'K','NGC 4036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87739,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87739,31.92,0.4,24.2,36512,NULL,NULL,'mean','NGC 4036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87740,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87740,36.95,0.46,245,36513,70,NULL,NULL,'2MASX J12012935+3015063',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000185,NULL,'15.9g',0.48,NULL,NULL,NULL,NULL,NULL,1,180.3722917,30.25167,0,NULL,58626849309,916044520,14313195,15.9),(87741,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87741,37.77,0.46,357,36514,70,NULL,NULL,'SDSS J120129.55+100753.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.7g',0.09,NULL,NULL,NULL,NULL,NULL,1,180.373167,10.13144,0,NULL,58015958801,906499356,14164052,18.7),(87742,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87742,33.1,0.43,41.6,36515,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4034',NULL,'2014MNRAS.444..527S',2014,1,1.7,NULL,'G',0.000043,NULL,'14.20',1.1,'Scd:           HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,180.373583,69.32392,0.045,NULL,56978013846,890281466,13910647,14.2),(87743,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87743,33.14,0.43,42.4,36515,75,NULL,'3.6 micron, color corrected','NGC 4034',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87744,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87744,33.19,0.2,43.5,36515,74.4,NULL,NULL,'NGC 4034',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87745,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87745,37.95,0.46,389,36516,70,NULL,NULL,'2MASX J12012989+0021047',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000084,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,180.3745417,0.35133,0.061,NULL,57983009344,905984521,14156008,17.5),(87746,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87746,37.8,0.33,364,36517,70,NULL,NULL,'2MASX J12013035+2343183',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.21',0.15,NULL,NULL,NULL,NULL,NULL,1,180.3765,23.72167,0.022,NULL,58589477310,915460582,14304071,18.21),(87747,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87747,38.16,0.13,428,36518,70,NULL,NULL,'2MASX J12013080+5802014',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,180.37825,58.03369,0,NULL,57330354632,895786791,13996668,18.1),(87748,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87748,37.78,0.46,360,36519,70,NULL,NULL,'SDSS J120131.82+115622.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000137,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,180.382583,11.93969,0,NULL,58134070260,908344847,14192888,18.6),(87749,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87749,36.68,0.46,217,36520,70,NULL,NULL,'2MASX J12013188+2425029',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.00',0.21,NULL,NULL,NULL,NULL,NULL,1,180.383,24.41744,0,NULL,58589084595,915454446,14303975,18),(87750,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87750,36.69,0.46,217,36521,70,NULL,NULL,'2MASX J12013246+3413262',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000171,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,180.385291667,34.224,0,NULL,58536577434,914634022,14291156,16.2),(87751,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87751,38.01,0.46,399,36522,70,NULL,NULL,'2MASX J12013318+2959552',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000185,NULL,'18.60',0.14,NULL,NULL,NULL,NULL,NULL,1,180.3882083,29.99853,0,NULL,58626821559,916044086,14313188,18.6),(87752,'Tully est','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,NULL,87752,29.74,0.8,8.9,36523,75,NULL,NULL,'UGC 07007',NULL,'1988NBGC.C....0000T',1988,1,0.84,'SDSS position refers to a knot southeast of the center of the bar.','G',0.000013,NULL,'15.5g',0.79,'SB(s)m IV','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,180.388167,33.34133,0,NULL,58619816284,915934629,14311478,15.5),(87753,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87753,36.51,0.46,200,36524,70,NULL,NULL,'LCRS B115859.6-025114',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000127,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,180.389167,-3.13247,0.061,NULL,42956833513,671200523,10487508,16.8),(87754,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87754,37.6,0.27,331,36525,70,NULL,NULL,'2MASX J12013454+3826206',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000182,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,180.3940417,38.43914,0,NULL,58544523107,914758173,14293096,16.2),(87755,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87755,38.11,0.46,419,36526,70,NULL,NULL,'2MASX J12013628+4311505',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000158,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,180.401291667,43.19733,0,NULL,58520757362,914386833,14287294,17.1),(87756,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87756,37.54,0.46,323,36527,70,NULL,NULL,'2MASX J12013632+5520292',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000174,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,180.401291667,55.3415,0,NULL,57210770218,893918284,13967473,16.9),(87757,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87757,38.12,0.46,421,36528,70,NULL,NULL,'SDSS J120137.75+021142.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000082,NULL,'18.4g',0.15,'NLAGN',NULL,NULL,NULL,'Sy 2',1,180.407333,2.19514,0.025,NULL,57984332241,906005191,14156331,18.4),(87758,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87758,38.14,0.46,425,36529,70,NULL,NULL,'2MASX J12013789+6559519',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,180.407875,65.99767,0.021,NULL,57312598791,895509356,13992333,17.4),(87759,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87759,35.17,0.46,108,36530,70,NULL,NULL,'2MASX J12013803+0612447',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000087,NULL,'16.1g',0.23,'S0',NULL,NULL,NULL,NULL,1,180.4085,6.21253,0,NULL,58020838817,906575606,14165243,16.1),(87760,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87760,36.35,0.46,186,36531,70,NULL,NULL,'CGCG 013-040',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000087,NULL,'15.6g',0.42,'S0a',NULL,NULL,NULL,NULL,1,180.409583,1.99189,0.031,NULL,57985155065,906018047,14156531,15.6),(87761,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87761,38.16,0.13,428,36532,70,NULL,NULL,'SDSS J120138.46+575232.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000146,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,180.41025,57.87581,0,NULL,57330133704,895783339,13996614,18.3),(87762,'FP','2016-12-15 15:14:53','2016-12-16 11:20:02','1',NULL,'R',87762,37.8,0.33,364,36533,70,NULL,NULL,'2MASX J12013915+2346063',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.77',0.15,NULL,NULL,NULL,NULL,NULL,1,180.413125,23.7685,0.013,NULL,58589683779,915463809,14304122,18.77),(87763,'FP','2016-12-15 15:14:53','2016-12-16 11:20:03','1',NULL,'R',87763,39.08,0.46,656,36534,70,NULL,NULL,'2MASX J12014078+1357151',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,180.419917,13.95414,0.038,NULL,58146913750,908545527,14196023,18.4),(87764,'IRAS','2016-12-15 15:14:53','2016-12-16 11:20:03','1',NULL,NULL,87764,34.71,0.8,87.5,36535,75,NULL,'HMCL, I','UGC 07008',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000027,NULL,'15.0g',0.39,'Sa? sp',NULL,NULL,NULL,NULL,1,180.421166667,4.76983,0,NULL,57991443265,906116301,14158067,15),(87765,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:03','1',NULL,'R',87765,34.77,0.49,90.1,36535,75,NULL,'IR','UGC 07008',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87766,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:03','1',NULL,NULL,87766,34.78,0.4,90.3,36535,75,NULL,'HMCL, I, raw','UGC 07008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87767,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:03','1',NULL,NULL,87767,34.87,0.4,94,36535,NULL,NULL,'mean','UGC 07008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87768,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:03','1',NULL,NULL,87768,34.96,0.4,98.1,36535,75,NULL,'HMCL, I, cor','UGC 07008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87769,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:03','1',NULL,NULL,87769,34.98,0.4,99.1,36535,75,NULL,'HMCL, I, inv','UGC 07008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87770,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:03','1',NULL,NULL,87770,35.05,0.47,102,36535,NULL,NULL,'H','UGC 07008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87771,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:03','1',NULL,NULL,87771,35.1,0.45,105,36535,NULL,NULL,'K','UGC 07008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87772,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:03','1',NULL,NULL,87772,35.2,0.46,110,36535,NULL,NULL,'J','UGC 07008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87773,'FP','2016-12-15 15:14:53','2016-12-16 11:20:03','1',NULL,'R',87773,37.42,0.46,305,36536,70,NULL,NULL,'2MASX J12014139+4629386',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00015,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,180.422208333,46.49428,0,NULL,57180210623,893440790,13960012,18.5),(87774,'FP','2016-12-15 15:14:53','2016-12-16 11:20:03','1',NULL,'R',87774,34.73,0.46,88.5,36537,70,NULL,NULL,'CGCG 041-024',NULL,'2015arXiv151105856S',2015,1,1.06,NULL,'G',0.000157,NULL,'14.2g',0.68,NULL,NULL,NULL,NULL,NULL,1,180.427791667,6.44958,0,NULL,58020513782,906570527,14165164,14.2),(87775,'FP','2016-12-15 15:14:53','2016-12-16 11:20:03','1',NULL,'R',87775,36.17,0.46,171,36538,70,NULL,NULL,'2MASX J12014308+0808037',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000154,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,180.4295417,8.13439,0,NULL,58030538168,906727158,14167611,16.6),(87776,'FP','2016-12-15 15:14:53','2016-12-16 11:20:03','1',NULL,'R',87776,37.08,0.27,261,36539,70,NULL,NULL,'CGPG 1159.0+4556',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000156,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,180.429958333,45.63447,0,NULL,57176917171,893389330,13959208,16.5),(87777,'FP','2016-12-15 15:14:53','2016-12-16 11:20:03','1',NULL,'R',87777,37.24,0.46,280,36540,70,NULL,NULL,'2MASX J12014361+4307386',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000183,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,180.43175,43.12733,0,NULL,58520704843,914386013,14287281,16.2),(87778,'FP','2016-12-15 15:14:53','2016-12-16 11:20:03','1',NULL,'R',87778,35.56,0.46,129,36541,70,NULL,NULL,'2MASX J12014368+0733377',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000163,NULL,'16.1g',0.33,NULL,NULL,NULL,NULL,NULL,1,180.432167,7.56033,0,NULL,58022946924,906608545,14165758,16.1),(87779,'Tully-Fisher','2016-12-15 15:14:53','2016-12-16 11:20:03','1',NULL,NULL,87779,31.63,0.4,21.2,36542,75,NULL,'B','UGC 07009',NULL,'1988NBGC.C....0000T',1988,1,2.02,NULL,'G',0.000008,NULL,'14.4g',0.47,'Im             HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,180.4337083,62.32589,0.005,NULL,57315421792,895553465,13993022,14.4);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (87780,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87780,36.97,0.27,248,36543,70,NULL,NULL,'2MASX J12014439+4553466',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00017,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,180.43475,45.89628,0,NULL,57177651365,893400802,13959387,16.4),(87781,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87781,36.76,0.46,225,36544,70,NULL,NULL,'2MASX J12014531+3101442',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000185,NULL,'16.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,180.43875,31.02886,0,NULL,58620871098,915951110,14311736,16.2),(87782,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87782,39.07,0.46,650,36545,70,NULL,NULL,'SDSS J120145.61+304523.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,180.440083,30.75661,0,NULL,58634511489,916164242,14315066,18.1),(87783,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87783,35.65,0.58,135,36546,70,NULL,NULL,'2MASX J12014693-3002384',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'14.4I',0.2,NULL,NULL,NULL,NULL,NULL,1,180.4455417,-30.04394,0.213,NULL,43379562741,677805667,10590713,14.4),(87784,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87784,35.09,0.46,104,36547,70,NULL,NULL,'2MASX J12014697+5807112',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000113,NULL,'16.0g',0.26,'S0',NULL,NULL,NULL,NULL,1,180.44575,58.11983,0,NULL,57330364288,895786942,13996670,16),(87785,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87785,37.4,0.46,302,36548,70,NULL,NULL,'2MASX J12014932+3007193',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000097,NULL,'16.5g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,180.455541667,30.12203,0,NULL,58626924703,916045698,14313214,16.5),(87786,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87786,37.68,0.46,343,36549,70,NULL,NULL,'2MASX J12014935+0328222',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000088,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,180.455667,3.47278,0,NULL,57992312166,906129877,14158279,16.7),(87787,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87787,37.73,0.46,351,36550,70,NULL,NULL,'SDSS J120151.90+232427.6',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,180.46625,23.40769,0.038,NULL,58586746410,915417912,14303404,18.4),(87788,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87788,38.03,0.46,403,36551,70,NULL,NULL,'2MASX J12015238+2017033',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,180.468333,20.28433,0.046,NULL,58118356521,908099320,14189051,17.6),(87789,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87789,37.79,0.33,361,36552,70,NULL,NULL,'2MASX J12015270+6550581',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000184,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,180.469541667,65.84942,0.021,NULL,57312788796,895512324,13992380,17.2),(87790,'IRAS','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87790,34.83,0.8,92.4,36553,75,NULL,'HMCL, I','UGC 07010',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.00003,NULL,'15.64',0.2,'Sa',NULL,NULL,NULL,NULL,1,180.469625,22.53142,0.032,NULL,58854624960,919603515,14368804,15.64),(87791,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87791,35.1,0.4,105,36553,NULL,NULL,'mean','UGC 07010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87792,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87792,35.19,0.49,109,36553,75,NULL,'IR','UGC 07010',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87793,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87793,35.29,0.4,114,36553,75,NULL,'HMCL, I, raw','UGC 07010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87794,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87794,35.4,0.47,120,36553,NULL,NULL,'H','UGC 07010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87795,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87795,35.43,0.45,122,36553,NULL,NULL,'K','UGC 07010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87796,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87796,35.44,0.4,122,36553,75,NULL,'HMCL, I, cor','UGC 07010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87797,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87797,35.47,0.46,124,36553,NULL,NULL,'J','UGC 07010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87798,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87798,35.55,0.4,129,36553,75,NULL,'HMCL, I, inv','UGC 07010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87799,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87799,38.16,0.13,428,36554,70,NULL,NULL,'2MASX J12015288+5758062',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,180.47,57.96836,0,NULL,57330345705,895786651,13996666,17.7),(87800,'Cepheids','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87800,31.55,0.06,20.4,36555,NULL,NULL,'V, I, NIR (W), 32, Syst. +/- 0.36 mag','NGC 4038',NULL,'2013MNRAS.434.2866F',2013,1,5.2,'ESO-LV has two entries for this object.','G',0.00004,NULL,'11.20',3.1,'SB(s)m pec','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,180.470875,-18.86761,0.053,NULL,43027214868,672300232,10504691,11.2),(87801,'Cepheids','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87801,31.57,0.07,20.6,36555,74.4,NULL,'NGC 4039','NGC 4038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87802,'Cepheids','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87802,31.66,0.08,21.5,36555,NULL,NULL,'SNIa calibrated','NGC 4038',NULL,'2011ApJ...730..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87803,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2007sr',NULL,87803,30.92,0.36,15.2,36555,74.2,NULL,'SALT 2','NGC 4038',0.005688,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87804,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2007sr',NULL,87804,31.57,0.07,20.6,36555,74.4,NULL,'NGC 4039','NGC 4038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87805,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2007sr',NULL,87805,31.66,0.08,21.5,36555,NULL,NULL,'MLCS2k2, Cepheids calibrated','NGC 4038',NULL,'2011ApJ...730..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87806,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2007sr',NULL,87806,31.74,0.27,22.3,36555,72,NULL,'NGC 4038, vgsr = 1470','NGC 4038',NULL,'2008AJ....136.1482S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87807,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2007sr',NULL,87807,31.99,NULL,25,36555,NULL,NULL,'light curve fit, NGC 4038, vgsr = 1470','NGC 4038',NULL,'2008MNRAS.388..487N',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87808,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2007sr',NULL,87808,32.2,0.23,27.5,36555,NULL,NULL,'peak IR, V, NGC 4038, vgsr = 1470','NGC 4038',NULL,'2008MNRAS.388..487N',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87809,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2007sr','R',87809,32.39,NULL,30,36555,NULL,NULL,NULL,'NGC 4038',NULL,'2007ATel.1343....1B',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87810,'TRGB','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87810,30.4,NULL,12,36555,NULL,NULL,NULL,'NGC 4038',NULL,'2011noao.prop..466C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87811,'TRGB','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87811,30.62,0.17,13.3,36555,NULL,NULL,'I, NGC 4038/39','NGC 4038',NULL,'2008ApJ...678..179S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87812,'TRGB','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87812,30.7,0.25,13.8,36555,NULL,NULL,'I, NGC 4038/39','NGC 4038',NULL,'2004AJ....127..660S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87813,'TRGB','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87813,31.51,0.17,20,36555,NULL,NULL,'I, NGC 4038/39','NGC 4038',NULL,'2008AJ....136.1482S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87814,'TRGB','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87814,31.67,0.05,21.6,36555,NULL,NULL,'I','NGC 4038',NULL,'2015ApJ...807..133J',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87815,'TRGB','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87815,31.72,0.1,22.1,36555,74.4,NULL,'NGC 4038','NGC 4038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87816,'Tully est','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87816,32.01,0.8,25.3,36555,75,NULL,'NGC 4039, vgsr = 1498','NGC 4038',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87817,'Tully est','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87817,32.04,0.8,25.5,36555,75,NULL,'B, NGC 4038, vgsr = 1470','NGC 4038',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87818,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87818,30.58,NULL,13.1,36555,NULL,NULL,'LEDA [April 2006]','NGC 4038',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87819,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87819,31.35,NULL,18.6,36555,65.2,NULL,'CO','NGC 4038',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87820,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87820,31.78,0.4,22.7,36555,75,NULL,'HOSTS SN 2007sr','NGC 4038',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87821,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87821,32.23,NULL,27.9,36555,54,NULL,'HI','NGC 4038',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87822,'Cepheids','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87822,31.55,0.06,20.4,36556,NULL,NULL,'V, I, NIR (W), 32, Syst. +/- 0.36 mag','NGC 4039',NULL,'2013MNRAS.434.2866F',2013,1,3.1,'ESO-LV has two entries for this object.','G',0.00003,NULL,'11.08',1.6,'SA(s)m pecLINERSbrst','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,180.4729583,-18.88619,0.053,NULL,43027216851,672300263,10504691,11.08),(87823,'Cepheids','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87823,31.57,0.07,20.6,36556,74.4,NULL,NULL,'NGC 4039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87824,'Cepheids','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87824,31.66,0.08,21.5,36556,NULL,NULL,'SNIa calibrated','NGC 4039',NULL,'2011ApJ...730..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87825,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2007sr',NULL,87825,30.92,0.36,15.2,36556,74.2,NULL,'SALT 2','NGC 4039',0.005688,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87826,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2007sr',NULL,87826,31.57,0.07,20.6,36556,74.4,NULL,NULL,'NGC 4039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87827,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2007sr',NULL,87827,31.66,0.08,21.5,36556,NULL,NULL,'MLCS2k2, Cepheids calibrated','NGC 4039',NULL,'2011ApJ...730..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87828,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2007sr',NULL,87828,31.74,0.27,22.3,36556,72,NULL,'NGC 4038, vgsr = 1470','NGC 4039',NULL,'2008AJ....136.1482S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87829,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2007sr',NULL,87829,31.99,NULL,25,36556,NULL,NULL,'light curve fit, NGC 4038, vgsr = 1470','NGC 4039',NULL,'2008MNRAS.388..487N',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87830,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2007sr',NULL,87830,32.2,0.23,27.5,36556,NULL,NULL,'peak IR, V, NGC 4038, vgsr = 1470','NGC 4039',NULL,'2008MNRAS.388..487N',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87831,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2007sr','R',87831,32.39,NULL,30,36556,NULL,NULL,NULL,'NGC 4039',NULL,'2007ATel.1343....1B',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87832,'TRGB','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87832,30.4,NULL,12,36556,NULL,NULL,NULL,'NGC 4039',NULL,'2011noao.prop..466C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87833,'TRGB','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87833,30.62,0.17,13.3,36556,NULL,NULL,'I, NGC 4038/39','NGC 4039',NULL,'2008ApJ...678..179S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87834,'TRGB','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87834,30.7,0.25,13.8,36556,NULL,NULL,'I, NGC 4038/39','NGC 4039',NULL,'2004AJ....127..660S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87835,'TRGB','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87835,31.51,0.17,20,36556,NULL,NULL,'I, NGC 4038/39','NGC 4039',NULL,'2008AJ....136.1482S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87836,'TRGB','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87836,31.67,0.05,21.6,36556,NULL,NULL,'I','NGC 4039',NULL,'2015ApJ...807..133J',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87837,'TRGB','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87837,31.72,0.1,22.1,36556,74.4,NULL,'NGC 4038','NGC 4039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87838,'Tully est','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87838,32.01,0.8,25.3,36556,75,NULL,'NGC 4039, vgsr = 1498','NGC 4039',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87839,'Tully est','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87839,32.04,0.8,25.5,36556,75,NULL,'B, NGC 4038, vgsr = 1470','NGC 4039',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87840,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87840,30.58,NULL,13.1,36556,NULL,NULL,'LEDA [April 2006]','NGC 4039',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87841,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87841,31.35,NULL,18.6,36556,65.2,NULL,'CO','NGC 4039',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87842,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87842,31.78,0.4,22.7,36556,75,NULL,'HOSTS SN 2007sr','NGC 4039',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87843,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87843,32.23,NULL,27.9,36556,54,NULL,'HI','NGC 4039',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87844,'Cepheids','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87844,31.55,0.06,20.4,36557,NULL,NULL,'V, I, NIR (W), 32, Syst. +/- 0.36 mag','ARP 244',NULL,'2013MNRAS.434.2866F',2013,1,NULL,'Confused and extended HIPASS source','GPair',0.000017,NULL,NULL,NULL,'HII','in a pair',NULL,NULL,NULL,1,180.472083,-18.87694,0.053,NULL,43027217673,672300276,10504691,NULL),(87845,'Cepheids','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87845,31.57,0.07,20.6,36557,74.4,NULL,'NGC 4039','ARP 244',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87846,'Cepheids','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87846,31.66,0.08,21.5,36557,NULL,NULL,'SNIa calibrated','ARP 244',NULL,'2011ApJ...730..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87847,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2007sr',NULL,87847,30.92,0.36,15.2,36557,74.2,NULL,'SALT 2','ARP 244',0.005688,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87848,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2007sr',NULL,87848,31.57,0.07,20.6,36557,74.4,NULL,'NGC 4039','ARP 244',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87849,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2007sr',NULL,87849,31.66,0.08,21.5,36557,NULL,NULL,'MLCS2k2, Cepheids calibrated','ARP 244',NULL,'2011ApJ...730..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87850,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2007sr',NULL,87850,31.74,0.27,22.3,36557,72,NULL,'NGC 4038, vgsr = 1470','ARP 244',NULL,'2008AJ....136.1482S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87851,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2007sr',NULL,87851,31.99,NULL,25,36557,NULL,NULL,'light curve fit, NGC 4038, vgsr = 1470','ARP 244',NULL,'2008MNRAS.388..487N',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87852,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2007sr',NULL,87852,32.2,0.23,27.5,36557,NULL,NULL,'peak IR, V, NGC 4038, vgsr = 1470','ARP 244',NULL,'2008MNRAS.388..487N',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87853,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2007sr','R',87853,32.39,NULL,30,36557,NULL,NULL,NULL,'ARP 244',NULL,'2007ATel.1343....1B',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87854,'TRGB','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87854,30.4,NULL,12,36557,NULL,NULL,NULL,'ARP 244',NULL,'2011noao.prop..466C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87855,'TRGB','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87855,30.62,0.17,13.3,36557,NULL,NULL,'I, NGC 4038/39','ARP 244',NULL,'2008ApJ...678..179S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87856,'TRGB','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87856,30.7,0.25,13.8,36557,NULL,NULL,'I, NGC 4038/39','ARP 244',NULL,'2004AJ....127..660S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87857,'TRGB','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87857,31.51,0.17,20,36557,NULL,NULL,'I, NGC 4038/39','ARP 244',NULL,'2008AJ....136.1482S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87858,'TRGB','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87858,31.67,0.05,21.6,36557,NULL,NULL,'I','ARP 244',NULL,'2015ApJ...807..133J',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87859,'TRGB','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87859,31.72,0.1,22.1,36557,74.4,NULL,'NGC 4038','ARP 244',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87860,'Tully est','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87860,32.01,0.8,25.3,36557,75,NULL,'NGC 4039, vgsr = 1498','ARP 244',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87861,'Tully est','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87861,32.04,0.8,25.5,36557,75,NULL,'B, NGC 4038, vgsr = 1470','ARP 244',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87862,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87862,30.58,NULL,13.1,36557,NULL,NULL,'LEDA [April 2006]','ARP 244',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87863,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87863,31.35,NULL,18.6,36557,65.2,NULL,'CO','ARP 244',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87864,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87864,31.78,0.4,22.7,36557,75,NULL,'HOSTS SN 2007sr','ARP 244',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87865,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87865,32.23,NULL,27.9,36557,54,NULL,'HI','ARP 244',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87866,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87866,35.94,0.63,154,36558,70,NULL,NULL,'2MASX J12015349-7907220',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,180.472375,-79.12272,0.513,NULL,44057212288,688393942,10756155,17.4),(87867,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87867,37.79,0.46,362,36559,70,NULL,NULL,'2MASX J12015490+3653426',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000185,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,180.4787083,36.89522,0,NULL,58545231896,914769248,14293269,16.9),(87868,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87868,35.24,0.11,112,36560,70,NULL,NULL,'CGCG 127-138',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00008,NULL,'15.5',0.3,'S',NULL,NULL,NULL,NULL,1,180.4812083,20.74789,0.047,NULL,58120046724,908125730,14189464,15.5),(87869,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87869,37.98,0.46,395,36561,70,NULL,NULL,'2MASX J12015741-0224473',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000161,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,180.489333333,-2.413,0.041,NULL,42964505864,671320404,10489381,17.2),(87870,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87870,38.4,0.33,478,36562,70,NULL,NULL,'2MASX J12015786+1332292',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000203,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,180.491125,13.54131,0.016,NULL,58135341031,908364703,14193198,18.3),(87871,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87871,37.59,0.33,329,36563,70,NULL,NULL,'2MASX J12015802-0019123',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000096,NULL,'16.9g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,180.491833,-0.32008,0.033,NULL,42950548562,671102321,10485973,16.9),(87872,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87872,38.16,0.13,428,36564,70,NULL,NULL,'2MASX J12015818+5801492',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,180.4925417,58.03039,0,NULL,57330353282,895786770,13996668,18.2),(87873,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87873,38.04,0.27,406,36565,70,NULL,NULL,'2MASX J12015844+5700262',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000152,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,180.4932917,57.00725,0.017,NULL,57328662474,895760351,13996255,16.6),(87874,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87874,37.59,0.33,329,36566,70,NULL,NULL,'2MASX J12015842-0023153',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000064,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,180.4935417,-0.38742,0.033,NULL,42950709549,671104836,10486013,17.8),(87875,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87875,37.99,0.46,397,36567,70,NULL,NULL,'2MASX J12015936+2600190',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.27',0.18,NULL,NULL,NULL,NULL,NULL,1,180.497583333,26.00533,0,NULL,58596494168,915570221,14305784,18.27),(87876,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87876,36.44,0.46,194,36568,70,NULL,NULL,'2MASX J12015955+2319483',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.61',0.22,NULL,NULL,NULL,NULL,NULL,1,180.4980417,23.33008,0.034,NULL,58586742114,915417845,14303403,17.61),(87877,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87877,38.16,0.13,428,36569,70,NULL,NULL,'2MASX J12020068+5800002',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,180.503083,57.99997,0,NULL,57330347236,895786675,13996666,18.1),(87878,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87878,37.28,0.1,286,36570,70,NULL,NULL,'2MASX J12020187+5626372',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000187,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,180.507583,56.44383,0.009,NULL,57394894986,896795234,14012425,16.7),(87879,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87879,33.25,0.2,44.7,36571,74.4,NULL,NULL,'UGC 07012',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.000003,NULL,'14.30',0.9,'Scd:','Pair member (points to parent)',NULL,NULL,NULL,1,180.513125,29.848,0,NULL,58626243721,916035058,14313047,14.3),(87880,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87880,33.49,0.45,50,36571,NULL,NULL,NULL,'UGC 07012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87881,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87881,33.68,0.41,54.3,36571,NULL,NULL,'Malmquist cor.','UGC 07012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87882,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87882,36.55,0.6,205,36572,70,NULL,NULL,'ESO 379- G 023',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000127,NULL,'15.98',1,'(R\'_2)SAB(s)b',NULL,NULL,NULL,NULL,1,180.5147917,-37.04836,0.313,NULL,43258938821,675920919,10561264,15.98),(87883,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87883,36.97,0.27,248,36573,70,NULL,NULL,'2MASX J12020355+4556236',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000179,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,180.515,45.94,0,NULL,57177637208,893400581,13959384,16.6),(87884,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87884,37.85,0.33,372,36574,70,NULL,NULL,'2MASX J12020472+3746426',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000192,NULL,'16.1g',0.44,NULL,NULL,NULL,NULL,NULL,1,180.519583,37.77844,0,NULL,58548008830,914812637,14293947,16.1),(87885,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87885,36.63,0.46,212,36575,70,NULL,NULL,'2MASX J12020506+0213232',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000088,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,180.5210417,2.22308,0.01,NULL,57984347071,906005422,14156334,16.4),(87886,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87886,37.69,0.46,346,36576,70,NULL,NULL,'2MASX J12020521+1411292',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000175,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,180.521833333,14.19142,0.038,NULL,58142618515,908478414,14194975,17.2),(87887,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87887,34.95,0.46,97.9,36577,70,NULL,NULL,'NGC 4040',NULL,'2015arXiv151105856S',2015,1,1.9,NULL,'G',0.000177,NULL,'14.30',1.3,'E','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,180.522666667,17.82322,0.01,NULL,58123984140,908187252,14190425,14.3),(87888,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87888,37.47,0.46,312,36578,70,NULL,NULL,'SDSS J120205.57+093529.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'18.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,180.523208333,9.59142,0,NULL,58019541210,906555331,14164927,18),(87889,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87889,38.07,0.46,411,36579,70,NULL,NULL,'2MASX J12020591+5130077',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000182,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,180.524875,51.50217,0.021,NULL,57215401816,893990653,13968603,17.1),(87890,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87890,36.96,0.46,247,36580,70,NULL,NULL,'2MASX J12020669+1241262',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,180.528,12.6905,0,NULL,58135516070,908367438,14193241,17.6),(87891,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87891,37.34,0.46,294,36581,70,NULL,NULL,'2MASX J12020763+1010303',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,180.53175,10.17517,0.009,NULL,58016441035,906506891,14164170,17.1),(87892,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87892,37.64,0.46,337,36582,70,NULL,NULL,'2MASX J12020786+0228182',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000081,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,180.532625,2.47164,0.009,NULL,57995895003,906185859,14159154,16.8),(87893,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87893,37.52,0.46,319,36583,70,NULL,NULL,'2MASX J12020843+1728382',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,180.535083,17.47725,0.093,NULL,58121281319,908145020,14189765,NULL),(87894,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87894,36.56,0.46,205,36584,70,NULL,NULL,'2MASX J12020857+1733062',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.07',0.15,NULL,NULL,NULL,NULL,NULL,1,180.535833,17.55169,0.074,NULL,58121284347,908145067,14189766,18.07),(87895,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87895,36.65,0.46,214,36585,70,NULL,NULL,'2MASX J12020876+2242161',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000123,NULL,'16.99',0.29,NULL,NULL,NULL,NULL,NULL,1,180.536583,22.70439,0.031,NULL,58586169156,915408893,14303263,16.99),(87896,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87896,37.85,0.46,371,36586,70,NULL,NULL,'2MASX J12020937+2009261',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.38',0.14,NULL,NULL,NULL,NULL,NULL,1,180.5392083,20.15736,0.046,NULL,58118371044,908099547,14189055,18.38),(87897,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87897,38.41,0.46,480,36587,70,NULL,NULL,'2MASX J12020984+5724111',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,180.541208333,57.40306,0.013,NULL,57328526791,895758231,13996222,17.9),(87898,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87898,37.47,0.46,312,36588,70,NULL,NULL,'SBS 1159+516B',NULL,'2015arXiv151105856S',2015,1,0.32,'2002AJ....123.2280P has V = 4227 km/s.','G',0.000167,NULL,'17.2g',0.19,'BCD',NULL,NULL,NULL,NULL,1,180.5489583,51.406,0.021,NULL,57215402746,893990667,13968604,17.2),(87899,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87899,37.48,0.33,314,36589,70,NULL,NULL,'2MASX J12021187+0109362',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000095,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,180.549583,1.16006,0.025,NULL,57985668420,906026069,14156657,17.2),(87900,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87900,31.78,0.4,22.7,36590,75,NULL,'B','NGC 4041',NULL,'1988NBGC.C....0000T',1988,1,2.14,NULL,'G',0.00003,NULL,'12.1g',1.72,'SA(rs)bc:      HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,180.550833,62.13722,0.005,NULL,57315196801,895549950,13992967,12.1),(87901,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87901,37.43,0.46,307,36591,70,NULL,NULL,'2MASX J12021225+5105316',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000181,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,180.550917,51.09217,0.009,NULL,57214706384,893979787,13968434,16.7),(87902,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87902,36.1,0.46,166,36592,70,NULL,NULL,'2MASX J12021244+0853063',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00016,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,180.551833,8.88506,0,NULL,58017666149,906526033,14164469,16.4),(87903,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87903,37.85,0.33,372,36593,70,NULL,NULL,'2MASX J12021250+3743518',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000177,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,180.551833,37.73114,0,NULL,58547996148,914812439,14293944,18.1),(87904,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87904,38.16,0.13,428,36594,70,NULL,NULL,'SDSS J120212.53+580319.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000142,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,180.5522917,58.05544,0,NULL,57330358294,895786848,13996669,18.7),(87905,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87905,37.21,0.46,276,36595,70,NULL,NULL,'2MASX J12021291+1634062',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.83',0.17,NULL,NULL,NULL,NULL,NULL,1,180.553875,16.56861,0.146,NULL,58175247270,908988238,14202941,17.83),(87906,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87906,38.4,0.33,478,36596,70,NULL,NULL,'2MASX J12021479+1327472',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,180.56175,13.46303,0.016,NULL,58135294002,908363968,14193187,18),(87907,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87907,36.78,0.46,227,36597,70,NULL,NULL,'VIII Zw 165',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000194,NULL,'16.2g',0.29,'E0',NULL,NULL,NULL,NULL,1,180.562833,13.03192,0,NULL,58136174830,908377731,14193402,16.2),(87908,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87908,36.97,0.27,248,36598,70,NULL,NULL,'2MASX J12021545+4552444',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000185,NULL,'16.1g',0.29,'S0^-',NULL,NULL,NULL,NULL,1,180.564375,45.87906,0,NULL,57177774303,893402723,13959417,16.1),(87909,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87909,38.08,0.46,413,36599,70,NULL,NULL,'2MASX J12021557+1244352',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,180.5649583,12.74297,0,NULL,58135489362,908367021,14193234,17.5),(87910,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87910,37.68,0.46,344,36600,70,NULL,NULL,'2MASX J12021628+0516032',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000195,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,180.567875,5.26761,0,NULL,58036671226,906822987,14169109,17.4),(87911,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87911,37.75,0.46,355,36601,70,NULL,NULL,'2MASX J12021726+0506373',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000134,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,180.571875,5.11053,0,NULL,58036706838,906823544,14169117,17.4),(87912,'GRB','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87912,45.09,0.72,4660,36602,69.7,NULL,'Calibrated','GRB 050408',1.2357,'2009MNRAS.400..775C',2009,1,NULL,NULL,'VisS',0.0002,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,180.572167,10.85278,0,NULL,58200281047,909379391,14209052,NULL),(87913,'GRB','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87913,45.4,0.81,5380,36602,72,NULL,NULL,'GRB 050408',1.2357,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87914,'GRB','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87914,45.51,0.84,5660,36602,70,NULL,NULL,'GRB 050408',1.2357,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87915,'GRB','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87915,45.52,0.76,5680,36602,69.7,NULL,'Fiducial','GRB 050408',1.2357,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87916,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87916,36.87,0.46,236,36603,70,NULL,NULL,'2MASX J12021769+1347424',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000175,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,180.573791667,13.795,0.029,NULL,58146892668,908545197,14196018,17.2),(87917,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87917,37.26,0.46,283,36604,70,NULL,NULL,'2MASX J12021940+5410299',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,180.5807083,54.17486,0,NULL,57212230904,893941107,13967829,17),(87918,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87918,38.05,0.46,407,36605,70,NULL,NULL,'2MASX J12021996+5634219',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,180.583,56.57275,0,NULL,57327979253,895749675,13996088,17.3),(87919,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87919,37.24,0.46,280,36606,70,NULL,NULL,'SDSS J120219.95+033059.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000072,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,180.583125,3.51642,0,NULL,57992288547,906129508,14158273,17.8),(87920,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87920,37.49,0.46,315,36607,70,NULL,NULL,'2MASX J12022051+0111543',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000079,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,180.585541667,1.1985,0.025,NULL,57985642470,906025663,14156650,17.4),(87921,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87921,37.28,0.1,286,36608,70,NULL,NULL,'2MASX J12022091+5618059',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000188,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,180.586917,56.30172,0,NULL,57394878148,896794971,14012421,16.4),(87922,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87922,36.95,0.46,245,36609,70,NULL,NULL,'2MASX J12022109+4955546',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000179,NULL,'16.3g',0.4,NULL,NULL,NULL,NULL,NULL,1,180.588,49.93192,0.018,NULL,57186080821,893532512,13961445,16.3),(87923,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87923,32.54,0.49,32.2,36610,75,NULL,'IR','UGC 07017',NULL,'2011yCatp016004901K',2011,1,1.73,'Multiple SDSS entries describe this object.','G',0.000007,NULL,'14.1g',0.44,'Sb','Pair member (points to parent)',NULL,NULL,NULL,1,180.5932917,29.86133,0,NULL,58626710284,916042348,14313161,14.1),(87924,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87924,33.51,0.4,50.4,36610,NULL,NULL,'mean','UGC 07017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87925,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87925,33.56,0.45,51.6,36610,NULL,NULL,'K','UGC 07017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87926,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87926,33.57,0.47,51.7,36610,NULL,NULL,'H','UGC 07017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87927,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87927,33.71,0.46,55.3,36610,NULL,NULL,'J','UGC 07017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87928,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87928,37.28,0.33,285,36611,70,NULL,NULL,'2MASX J12022258+2939050',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000133,NULL,'17.3g',0.18,'E',NULL,NULL,NULL,NULL,1,180.5939583,29.65136,0,NULL,58626252509,916035195,14313049,17.3),(87929,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87929,36.71,0.46,219,36612,70,NULL,NULL,'LCRS B115949.3-030140',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00012,NULL,'16.1g',0.4,'E0',NULL,NULL,NULL,NULL,1,180.596167,-3.30633,0.057,NULL,42956774483,671199601,10487493,16.1),(87930,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87930,35.28,0.43,114,36613,75,NULL,'3.6 micron, color + selection bias corrected','UGC 07016',NULL,'2014MNRAS.444..527S',2014,1,1.81,NULL,'G',0.000122,NULL,'14.2g',0.47,'SBab:',NULL,NULL,NULL,NULL,1,180.599917,14.84364,0.011,NULL,58143158550,908486852,14195107,14.2),(87931,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87931,36.03,0.46,160,36614,70,NULL,NULL,'CGCG 069-030',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000167,NULL,'14.9g',0.55,'E0',NULL,NULL,NULL,NULL,1,180.605333333,12.33772,0,NULL,58136667841,908385435,14193522,14.9),(87932,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87932,37.67,0.46,342,36615,70,NULL,NULL,'2MASXi J1202253+611212',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,180.60575,61.20353,0.013,NULL,57337082098,895891907,13998311,17.8),(87933,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87933,36.16,0.46,170,36616,70,NULL,NULL,'2MASX J12022561+1711314',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000097,NULL,'16.66',0.21,NULL,NULL,NULL,NULL,NULL,1,180.606833,17.19214,0.136,NULL,58121441156,908147518,14189804,16.66),(87934,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87934,34.31,0.49,72.9,36617,75,NULL,'IR','MCG -01-31-002',NULL,'2011yCatp016004901K',2011,1,1.48,NULL,'G',0.000017,NULL,'15.0b',0.19,'Scd',NULL,NULL,NULL,NULL,1,180.607458333,-4.30606,0.061,NULL,42954536146,671164627,10486947,15),(87935,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87935,34.34,0.2,73.8,36617,74.4,NULL,NULL,'MCG -01-31-002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87936,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87936,34.45,0.3,77.6,36617,NULL,NULL,'Malmquist cor.','MCG -01-31-002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87937,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87937,34.45,0.3,77.7,36617,NULL,NULL,NULL,'MCG -01-31-002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87938,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87938,34.51,NULL,79.9,36617,NULL,NULL,NULL,'MCG -01-31-002',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87939,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87939,34.63,NULL,84.2,36617,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -01-31-002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87940,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87940,34.64,NULL,84.6,36617,NULL,NULL,'Dipole + Quadrupole','MCG -01-31-002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87941,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87941,34.64,NULL,84.8,36617,NULL,NULL,'Dipole','MCG -01-31-002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87942,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87942,37.67,0.33,342,36618,70,NULL,NULL,'2MASX J12022591+3809430',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,180.608083,38.16197,0,NULL,58544486608,914757603,14293087,17.5),(87943,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87943,36.7,0.46,219,36619,70,NULL,NULL,'2MASX J12022595+5027326',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000195,NULL,'15.5g',0.5,'E0',NULL,NULL,NULL,NULL,1,180.608166667,50.45906,0.016,NULL,57185302536,893520352,13961255,15.5),(87944,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87944,37.75,0.46,355,36620,70,NULL,NULL,'2MASX J12022613+5712345',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000171,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,180.609208333,57.20967,0.013,NULL,57328356633,895755572,13996180,16.8),(87945,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87945,35.11,0.46,105,36621,70,NULL,NULL,'CGCG 127-141',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00016,NULL,'15.0',0.45,'E',NULL,NULL,NULL,NULL,1,180.6105,23.81883,0.023,NULL,58589667364,915463552,14304118,15),(87946,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87946,35.92,0.46,153,36622,70,NULL,NULL,'CGCG 069-031',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000157,NULL,'15.1g',0.6,'E0',NULL,NULL,NULL,NULL,1,180.613125,8.93008,0,NULL,58017492178,906523315,14164426,15.1),(87947,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87947,37.58,0.46,327,36623,70,NULL,NULL,'2MASX J12022778-0107575',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000096,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,180.6157083,-1.13256,0.041,NULL,42953541664,671149088,10486704,16.5),(87948,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87948,37.42,0.46,304,36624,70,NULL,NULL,'2MASX J12022804+0527353',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000181,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,180.616791667,5.45994,0,NULL,58036779061,906824672,14169135,17),(87949,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87949,37.92,0.46,384,36625,70,NULL,NULL,'2MASX J12022845+3209087',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,180.618583333,32.15253,0,NULL,58623515754,915992433,14312381,17.9),(87950,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87950,37.81,0.46,365,36626,70,NULL,NULL,'2MASX J12022858+1513374',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,180.619125,15.227,0.043,NULL,58145323422,908520678,14195635,18.3),(87951,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87951,31.22,0.43,17.6,36627,75,NULL,'3.6 micron, color + selection bias corrected','UGC 07019',NULL,'2014MNRAS.444..527S',2014,1,1.5,'Multiple SDSS entries describe this source.','G',NULL,NULL,'15.2',0.8,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,180.622417,62.41719,0.005,NULL,57315375550,895552742,13993011,15.2),(87952,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87952,37.68,0.46,344,36628,70,NULL,NULL,'2MASX J12022939+2935182',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000107,NULL,'17.3g',0.23,'E',NULL,NULL,NULL,NULL,1,180.622583,29.58839,0,NULL,58627354578,916052415,14313318,17.3),(87953,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87953,37.1,0.46,264,36629,70,NULL,NULL,'2MASX J12023458+1431114',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000152,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,180.644125,14.51981,0.043,NULL,58143504598,908492259,14195191,17.1),(87954,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87954,36.9,0.27,240,36630,70,NULL,NULL,'2MASX J12023541+6050531',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,180.647625,60.84817,0.017,NULL,57336640229,895885003,13998203,17.7),(87955,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87955,35.24,0.11,112,36631,70,NULL,NULL,'2MASX J12023598+2032418',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00012,NULL,'16.40',0.18,NULL,NULL,NULL,NULL,NULL,1,180.65,20.54508,0.043,NULL,58120021787,908125340,14189458,16.4),(87956,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87956,36.62,0.79,211,36632,70,NULL,NULL,'2MASX J12023610-2847293',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000103,NULL,'14.8I',0.2,NULL,NULL,NULL,NULL,NULL,1,180.650417,-28.79142,0.293,NULL,43378329097,677786392,10590412,14.8),(87957,'Tully est','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87957,32.02,0.8,25.4,36633,75,NULL,'B','UGC 07020A',NULL,'1988NBGC.C....0000T',1988,1,1.13,NULL,'G',0.000003,NULL,'14.2g',0.56,'S0?            HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,180.6545,64.37647,0.017,NULL,57317470208,895585472,13993523,14.2),(87958,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87958,35.24,0.11,112,36634,70,NULL,NULL,'CGCG 128-001',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000077,NULL,'15.5',0.45,'E?',NULL,NULL,NULL,NULL,1,180.6557917,21.15925,0.046,NULL,58116618034,908072156,14188627,15.5),(87959,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87959,38.63,0.46,533,36635,70,NULL,NULL,'2MASX J12023778+0016093',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000091,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,180.657333,0.26939,0.049,NULL,57983008314,905984504,14156007,17.5),(87960,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87960,37.67,0.33,342,36636,70,NULL,NULL,'2MASX J12023787+3805270',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,180.6577083,38.09078,0,NULL,58544463196,914757237,14293081,17.4),(87961,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87961,36.78,0.17,227,36637,70,NULL,NULL,'2MASX J12023811+5447356',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000173,NULL,'16.6g',0.24,'AGN',NULL,NULL,NULL,NULL,1,180.658833,54.79319,0,NULL,57213993403,893968646,13968260,16.6),(87962,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87962,37.13,0.33,266,36638,70,NULL,NULL,'2MASX J12023818+1731554',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.25',0.16,'AGN',NULL,NULL,NULL,NULL,1,180.659167,17.53197,0.093,NULL,58121262176,908144721,14189761,18.25),(87963,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87963,37.42,0.46,304,36639,70,NULL,NULL,'2MASX J12023851+4141150',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,180.6605,41.68761,0,NULL,58525416444,914459631,14288431,17.4),(87964,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87964,37.13,0.33,266,36640,70,NULL,NULL,'2MASX J12023937+1732564',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.50',0.14,'AGN',NULL,NULL,NULL,NULL,1,180.664167,17.54911,0.093,NULL,58121269865,908144841,14189763,18.5),(87965,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87965,37.1,0.33,263,36641,70,NULL,NULL,'2MASX J12023984+5434366',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000179,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,180.666083,54.57694,0,NULL,57212051571,893938305,13967786,16.7),(87966,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87966,36.78,0.17,227,36642,70,NULL,NULL,'2MASX J12024007+5447006',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000241,NULL,'16.5g',0.36,'AGN',NULL,NULL,NULL,NULL,1,180.6669583,54.78342,0,NULL,57214206143,893971970,13968312,16.5),(87967,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87967,37.42,0.46,305,36643,70,NULL,NULL,'2MASX J12024014+3722390',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000156,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,180.667125,37.37747,0,NULL,58545836759,914778699,14293417,17.4),(87968,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87968,37.86,0.46,373,36644,70,NULL,NULL,'2MASX J12024067+4036117',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000172,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,180.669333,40.60322,0,NULL,58526784405,914481006,14288765,18),(87969,'Tully est','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87969,32.49,0.8,31.5,36645,75,NULL,'B','NGC 4045',NULL,'1988NBGC.C....0000T',1988,1,2.38,NULL,'G',0.00001,NULL,'12.9g',1.14,'SAB(r)a;HII    LINER','in a pair',NULL,NULL,NULL,1,180.676,1.97681,0.018,NULL,57985016475,906015882,14156498,12.9),(87970,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87970,31.79,0.36,22.8,36645,NULL,NULL,NULL,'NGC 4045',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87971,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87971,32.28,0.45,28.6,36645,NULL,NULL,'K','NGC 4045',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87972,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87972,32.36,0.47,29.6,36645,NULL,NULL,'H','NGC 4045',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87973,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87973,32.42,0.46,30.4,36645,NULL,NULL,'J','NGC 4045',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87974,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87974,32.51,0.44,31.8,36645,NULL,NULL,'Malmquist cor.','NGC 4045',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87975,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87975,32.54,0.43,32.2,36645,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4045',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87976,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87976,32.57,0.43,32.7,36645,75,NULL,'3.6 micron, color corrected','NGC 4045',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87977,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87977,32.6,0.4,33.1,36645,NULL,NULL,'mean','NGC 4045',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87978,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87978,32.64,0.2,33.7,36645,74.4,NULL,NULL,'NGC 4045',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87979,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87979,32.71,0.3,34.9,36645,55,NULL,'B','NGC 4045',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87980,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87980,32.77,0.39,35.8,36645,NULL,NULL,NULL,'NGC 4045',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87981,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87981,37.85,0.46,371,36646,70,NULL,NULL,'2MASX J12024231-0048215',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,180.676333,-0.80592,0.037,NULL,42953488331,671148255,10486691,18),(87982,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87982,38.61,0.46,528,36647,70,NULL,NULL,'2MASX J12024231+6133220',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000143,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,180.6765417,61.55619,0.025,NULL,57336337710,895880276,13998129,18.3),(87983,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87983,35,0.56,100,36648,70,NULL,NULL,'2MASX J12024344-5157003',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.8I',0.5,NULL,NULL,NULL,NULL,NULL,1,180.6810417,-51.95014,0.413,NULL,44589269733,696707339,10886052,13.8),(87984,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87984,36.59,0.46,208,36649,70,NULL,NULL,'2MASX J12024556+2900042',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000143,NULL,'18.06',0.18,'E',NULL,NULL,NULL,NULL,1,180.68975,29.00111,0,NULL,58624455446,916007116,14312611,18.06),(87985,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87985,37.55,0.46,324,36650,70,NULL,NULL,'2MASX J12024610+2922582',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000153,NULL,'17.3g',0.21,'E',NULL,NULL,NULL,NULL,1,180.691916667,29.38297,0,NULL,58627398872,916053107,14313329,17.3),(87986,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87986,35.06,0.49,103,36651,75,NULL,'IR','UGC 07024',NULL,'2011yCatp016004901K',2011,1,1.1,'UGC Dec. of +22d23\' incorrect.','G',0.000029,NULL,'16.0',0.1,'Scd:',NULL,NULL,NULL,NULL,1,180.692583,22.33456,0.032,NULL,58854647734,919603870,14368810,16),(87987,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87987,29.82,0.4,9.2,36652,NULL,NULL,NULL,'ESO 440- G 044',NULL,'2009AJ....138..323T',2009,1,1.6,NULL,'G',0.000007,NULL,'13.90',1,'SB(s)m pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,180.693333,-29.0925,0.293,NULL,43381297502,677832773,10591137,13.9),(87988,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87988,30.22,0.77,11.1,36652,NULL,NULL,NULL,'ESO 440- G 044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87989,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87989,30.26,0.2,11.3,36652,74.4,NULL,NULL,'ESO 440- G 044',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87990,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87990,30.62,0.4,13.3,36652,73,NULL,'opt','ESO 440- G 044',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87991,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87991,30.72,0.61,13.9,36652,NULL,NULL,'Malmquist cor.','ESO 440- G 044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(87992,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87992,35.24,0.11,112,36653,70,NULL,NULL,'NGC 4042',NULL,'2015arXiv151105856S',2015,1,0.26,'NGC identification is not certain.','G',0.000107,NULL,'17.41',0.2,NULL,NULL,NULL,NULL,NULL,1,180.694917,20.16325,0.038,NULL,58118158215,908096222,14189003,17.41),(87993,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87993,37.73,0.46,352,36654,70,NULL,NULL,'2MASX J12024709+0434389',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000183,NULL,'17.1g',0.24,'BrClG',NULL,NULL,NULL,NULL,1,180.6962917,4.57758,0,NULL,57991462960,906116608,14158072,17.1),(87994,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87994,38.12,0.46,421,36655,70,NULL,NULL,'2MASX J12024717+3740097',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000165,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,180.696375,37.66961,0,NULL,58547874787,914810543,14293914,18.1),(87995,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87995,37.95,0.46,390,36656,70,NULL,NULL,'2MASX J12024741+5246025',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,180.697583333,52.7675,0,NULL,57217611496,894025179,13969143,17.5),(87996,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87996,38.16,0.13,428,36657,70,NULL,NULL,'2MASX J12024794+5747155',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,180.699625,57.78772,0,NULL,57331196804,895799950,13996874,17.7),(87997,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',87997,35.64,0.46,134,36658,70,NULL,NULL,'2MASX J12024903+0653372',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000165,NULL,'16.1g',0.41,NULL,NULL,NULL,NULL,NULL,1,180.70425,6.89364,0,NULL,58023354799,906614918,14165858,16.1),(87998,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87998,34.47,0.4,78.5,36659,NULL,NULL,'mean','VV 384',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'GGroup',NULL,NULL,NULL,NULL,'S?',NULL,NULL,NULL,NULL,1,180.709458333,18.01533,0.037,NULL,58124044560,908188196,14190440,NULL),(87999,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,87999,34.71,0.47,87.4,36659,NULL,NULL,'H','VV 384',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88000,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88000,33.63,0.4,53.1,36660,NULL,NULL,'mean','NGC 4047',NULL,'2007A&A...465...71T',2007,1,1.65,NULL,'G',0.000057,NULL,'12.8g',1.21,'(R)SA(rs)b:','Group member',NULL,NULL,NULL,1,180.711167,48.63619,0,NULL,57187228206,893550440,13961725,12.8),(88001,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88001,33.68,0.45,54.4,36660,NULL,NULL,'K','NGC 4047',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88002,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88002,33.72,0.47,55.4,36660,NULL,NULL,'H','NGC 4047',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88003,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88003,33.8,0.46,57.5,36660,NULL,NULL,'J','NGC 4047',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88004,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88004,37.8,0.33,364,36661,70,NULL,NULL,'2MASX J12025135+1306122',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.0002,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,180.714083,13.10333,0.011,NULL,58136037131,908375580,14193368,17.1),(88005,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88005,37.86,0.46,374,36662,70,NULL,NULL,'2MASX J12025153+0904392',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,180.7147917,9.07744,0,NULL,58017450103,906522657,14164416,17.6),(88006,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88006,35.83,0.46,146,36663,70,NULL,NULL,'CGCG 157-089',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.000097,NULL,'15.1g',0.49,'E','Isolated galaxy',NULL,NULL,NULL,1,180.717125,26.25281,0,NULL,58598173847,915596466,14306194,15.1),(88007,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88007,37.74,0.46,353,36664,70,NULL,NULL,'SDSS J120252.68+101236.9',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000147,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,180.7195,10.21025,0.018,NULL,58016219175,906503424,14164116,17),(88008,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88008,36.9,0.33,240,36665,70,NULL,NULL,'2MASX J12025284+2740142',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000177,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,180.720167,27.67078,0,NULL,58640641144,916260017,14316562,16.8),(88009,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88009,37.28,0.33,285,36666,70,NULL,NULL,'2MASXi J1202528+293852',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.9g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,180.720375,29.64767,0,NULL,58626221841,916034716,14313042,17.9),(88010,'Ring Diameter','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88010,30.7,0.76,14,36667,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4050',NULL,'1981ApJS...45..541P',1981,1,3.1,NULL,'G',0.000027,NULL,'13.1',2.1,'SB(r)ab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,180.7247917,-16.37361,0.089,NULL,43071447622,672991369,10515490,13.1),(88011,'Ring Diameter','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88011,31,0.6,16,36667,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4050',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88012,'Sosies','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88012,33.21,0.31,43.9,36667,NULL,NULL,NULL,'NGC 4050',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88013,'Tully est','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88013,32.29,0.8,28.8,36667,75,NULL,'B','NGC 4050',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88014,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88014,31.95,0.46,24.5,36667,NULL,NULL,'Malmquist cor.','NGC 4050',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88015,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88015,32.09,0.2,26.2,36667,74.4,NULL,NULL,'NGC 4050',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88016,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88016,32.11,0.43,26.4,36667,NULL,NULL,NULL,'NGC 4050',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88017,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88017,32.29,0.43,28.8,36667,75,NULL,'3.6 micron, color corrected','NGC 4050',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88018,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88018,32.49,0.43,31.5,36667,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4050',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88019,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88019,32.55,0.4,32.3,36667,NULL,NULL,'mean','NGC 4050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88020,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88020,32.79,0.46,36.1,36667,NULL,NULL,'J','NGC 4050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88021,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88021,32.8,0.47,36.3,36667,NULL,NULL,'H','NGC 4050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88022,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88022,32.81,0.45,36.5,36667,NULL,NULL,'K','NGC 4050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88023,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88023,32.94,NULL,38.7,36667,NULL,NULL,'B','NGC 4050',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88024,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88024,36.91,0.46,241,36668,70,NULL,NULL,'2MASX J12025521+0654392',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,180.7300417,6.91097,0,NULL,58023877387,906623084,14165985,17.3),(88025,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88025,34.64,0.46,84.9,36669,70,NULL,NULL,'CGCG 041-028',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000185,NULL,'14.6g',0.68,'E',NULL,NULL,NULL,NULL,1,180.731667,4.23406,0,NULL,57991102834,906110981,14157984,14.6),(88026,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88026,38.16,0.13,428,36670,70,NULL,NULL,'2MASX J12025574+5751585',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000141,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,180.7322917,57.86631,0,NULL,57331369188,895802643,13996916,17.3),(88027,'IRAS','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88027,34.71,0.8,87.3,36671,75,NULL,'HMCL, I','IC 0756',NULL,'1997ApJS..109..333W',1997,1,1.81,NULL,'G',0.000027,NULL,'14.2g',0.73,'(R\')SA(s)c:    AGN',NULL,NULL,NULL,'AGN',1,180.740875,4.84586,0,NULL,57991038224,906109972,14157968,14.2),(88028,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88028,34.55,0.4,81.4,36671,75,NULL,'HMCL, I, raw','IC 0756',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88029,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88029,34.77,0.4,89.8,36671,75,NULL,'HMCL, I, inv','IC 0756',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88030,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88030,34.77,0.4,89.9,36671,75,NULL,'HMCL, I, cor','IC 0756',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88031,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88031,34.77,0.37,90.1,36671,NULL,NULL,'Malmquist cor.','IC 0756',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88032,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88032,34.83,0.2,92.5,36671,74.4,NULL,NULL,'IC 0756',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88033,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88033,34.86,0.4,93.8,36671,NULL,NULL,'mean','IC 0756',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88034,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88034,34.87,0.47,94.3,36671,NULL,NULL,'H','IC 0756',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88035,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88035,34.92,0.35,96.2,36671,NULL,NULL,NULL,'IC 0756',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88036,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88036,34.99,0.45,99.7,36671,NULL,NULL,'K','IC 0756',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88037,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88037,35,0.46,99.9,36671,NULL,NULL,'J','IC 0756',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88038,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88038,38.01,0.46,399,36672,70,NULL,NULL,'2MASX J12025828+0001483',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000093,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,180.742667,0.03022,0.037,NULL,57982454961,905975858,14155872,17.1),(88039,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88039,35.76,0.46,142,36673,70,NULL,NULL,'2MASX J12025852+3906538',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000167,NULL,'16.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,180.7439583,39.11503,0,NULL,58577765263,915277582,14301212,16.3),(88040,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88040,37.85,0.46,371,36674,70,NULL,NULL,'SDSS J120300.16+344048.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00018,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,180.750708333,34.68011,0,NULL,58536369226,914630769,14291105,18.7),(88041,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88041,38.25,0.33,446,36675,70,NULL,NULL,'2MASX J12030039+2541574',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,180.7514583,25.69933,0.007,NULL,58596422640,915569103,14305767,17.2),(88042,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88042,36.78,0.17,227,36676,70,NULL,NULL,'2MASX J12030058+5452164',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000164,NULL,'16.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,180.752417,54.87133,0,NULL,57214221946,893972217,13968315,16.3),(88043,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88043,37.8,0.33,364,36677,70,NULL,NULL,'2MASX J12030066+1304392',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000136,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,180.752667,13.07756,0,NULL,58135760282,908371254,14193300,18),(88044,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88044,36.9,0.33,240,36678,70,NULL,NULL,'2MASX J12030090+2740404',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000093,NULL,'16.4g',0.33,NULL,'Field galaxy',NULL,NULL,NULL,1,180.753667,27.67783,0,NULL,58640643003,916260046,14316563,16.4),(88045,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88045,37.21,0.46,276,36679,70,NULL,NULL,'2MASX J12030099+1009421',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000183,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,180.754041667,10.16178,0.018,NULL,58016301615,906504712,14164136,16.8),(88046,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88046,36.78,0.17,227,36680,70,NULL,NULL,'2MASX J12030221+5441114',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000194,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,180.759167,54.68658,0,NULL,57212042658,893938166,13967783,16.5),(88047,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88047,37.07,0.46,259,36681,70,NULL,NULL,'2MASX J12030250+1557002',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000161,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,180.760333,15.95008,0.144,NULL,58142058447,908469663,14194838,18.2),(88048,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88048,36.93,0.46,243,36682,70,NULL,NULL,'2MASX J12030254+3711418',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00017,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,180.760791667,37.19483,0,NULL,58545972202,914780815,14293450,16.6),(88049,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88049,38.25,0.33,446,36683,70,NULL,NULL,'SDSS J120302.79+254124.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.5g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,180.761625,25.69025,0.007,NULL,58596422053,915569094,14305767,18.5),(88050,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88050,36.28,0.46,180,36684,70,NULL,NULL,'SBS 1200+608',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.0002,NULL,'16.0g',0.37,'LINER;BLLAC',NULL,NULL,NULL,'BL Lac',1,180.764625,60.522,0,NULL,57339828625,895934822,13998981,16),(88051,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88051,37.31,0.46,290,36685,70,NULL,NULL,'2MASX J12030430+1343332',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000163,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,180.7680417,13.72586,0.029,NULL,58147668988,908557327,14196208,16.7),(88052,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88052,38.06,0.46,410,36686,70,NULL,NULL,'SDSS J120304.59+282728.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000157,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,180.769167,28.45803,0,NULL,58624763244,916011925,14312686,18.6),(88053,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88053,37.46,0.46,310,36687,70,NULL,NULL,'2MASX J12030494+4655395',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000176,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,180.770583333,46.92772,0,NULL,57179237505,893425586,13959774,17),(88054,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88054,37.78,0.46,360,36688,70,NULL,NULL,'2MASX J12030604+4119509',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,180.775125,41.33089,0,NULL,58526246958,914472608,14288634,18),(88055,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88055,36.38,0.46,189,36689,70,NULL,NULL,'2MASX J12030623+4641405',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000196,NULL,'16.1g',0.31,'S0^-',NULL,NULL,NULL,NULL,1,180.776125,46.69461,0,NULL,57180320282,893442504,13960039,16.1),(88056,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88056,38.59,0.46,521,36690,70,NULL,NULL,'SDSS J120306.91+104958.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,180.7787917,10.83289,0,NULL,58201115365,909392427,14209256,18),(88057,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88057,35.24,0.11,112,36691,70,NULL,NULL,'CGCG 128-002',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000093,NULL,'15.7',0.4,'E?',NULL,NULL,NULL,'Emission-Line Galaxy',1,180.779583,20.80544,0.042,NULL,58120225525,908128523,14189508,15.7),(88058,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88058,38.27,0.46,451,36692,70,NULL,NULL,'SDSS J120307.61+473940.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000174,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,180.7817083,47.66131,0,NULL,57179005476,893421960,13959718,18.2),(88059,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88059,37.03,0.46,255,36693,70,NULL,NULL,'2MASX J12030802+3023411',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000193,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,180.783541667,30.39478,0,NULL,58626016627,916031509,14312992,16.5),(88060,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88060,35.93,0.46,153,36694,70,NULL,NULL,'2MASX J12030810+1109211',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000181,NULL,'15.7g',0.44,'E/S0',NULL,NULL,NULL,NULL,1,180.783583,11.15567,0,NULL,58201030051,909391094,14209235,15.7),(88061,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88061,37.98,0.46,395,36695,70,NULL,NULL,'2MASX J12030888+5638273',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000175,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,180.786875,56.64089,0,NULL,57327861604,895747837,13996059,16.8),(88062,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88062,36.29,0.46,181,36696,70,NULL,NULL,'2MASX J12030936+5413213',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000182,NULL,'15.8g',0.36,'S0',NULL,NULL,NULL,NULL,1,180.789167,54.22258,0,NULL,57212392601,893943634,13967869,15.8),(88063,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88063,37.74,0.46,354,36697,70,NULL,NULL,'SDSS J120309.52-022535.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000142,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,180.7897083,-2.42656,0.041,NULL,42965337388,671333396,10489584,18.4),(88064,'AGN time lag','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88064,31.23,0.07,17.6,36698,NULL,NULL,NULL,'NGC 4051',NULL,'2014ApJ...784L..11Y',2014,1,5.2,NULL,'G',0.000004,NULL,'10.83',3.9,'SAB(rs)bc;Sy1.2Sy1.5','in a radial-velocity based grouping',NULL,NULL,'Sy 1',1,180.790041667,44.53133,0,NULL,58519120785,914361262,14286894,10.83),(88065,'AGN time lag','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88065,31.39,1.39,19,36698,44,NULL,NULL,'NGC 4051',NULL,'2007MNRAS.380..669C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88066,'Black Hole','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88066,31.26,0.6,17.9,36698,NULL,NULL,NULL,'NGC 4051',NULL,'2014ApJ...793..108W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88067,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88067,29.73,0.43,8.8,36698,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4051',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88068,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88068,29.96,0.43,9.8,36698,75,NULL,'3.6 micron, color corrected','NGC 4051',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88069,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88069,30.21,0.2,11,36698,74.4,NULL,NULL,'NGC 4051',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88070,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88070,30.43,0.36,12.2,36698,NULL,NULL,NULL,'NGC 4051',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88071,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88071,30.43,0.39,12.2,36698,73,NULL,'opt','NGC 4051',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88072,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88072,30.62,NULL,13.3,36698,NULL,NULL,'I','NGC 4051',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88073,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88073,30.72,NULL,13.9,36698,NULL,NULL,'I','NGC 4051',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88074,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88074,30.83,NULL,14.7,36698,NULL,NULL,'B','NGC 4051',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88075,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88075,30.86,NULL,14.9,36698,NULL,NULL,'I, Hubble-type-TF','NGC 4051',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88076,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88076,30.91,NULL,15.2,36698,NULL,NULL,NULL,'NGC 4051',NULL,'2013MNRAS.433.1369P',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88077,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88077,30.99,NULL,15.8,36698,NULL,NULL,'B','NGC 4051',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88078,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88078,31.15,0.4,17,36698,75,NULL,'B','NGC 4051',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88079,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88079,31.2,NULL,17.4,36698,NULL,NULL,'B, Hubble-type-TF','NGC 4051',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88080,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88080,31.44,0.6,19.4,36698,53.9,NULL,'NGC 3949/NGC 4051 pair','NGC 4051',NULL,'1984A&A...132..253R',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88081,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88081,31.68,NULL,21.7,36698,NULL,NULL,'LEDA [Nov 2006]','NGC 4051',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88082,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88082,36.94,0.19,244,36699,70,NULL,NULL,'2MASX J12030956+5140417',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000157,NULL,'16.9g',0.28,'S0','Compact group member',NULL,NULL,NULL,1,180.790083333,51.67817,0,NULL,57215195232,893987425,13968553,16.9),(88083,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88083,38.57,0.46,518,36700,70,NULL,NULL,'2MASX J12030964+2423235',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,180.790166667,24.38978,0,NULL,58589152209,915455503,14303992,18.4),(88084,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88084,37.49,0.33,315,36701,70,NULL,NULL,'SDSS J120309.86+013301.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000075,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,180.791083333,1.55031,0,NULL,57984866912,906013545,14156461,17.8),(88085,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88085,38.21,0.46,438,36702,70,NULL,NULL,'2MASX J12031163+1050031',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000181,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,180.7985417,10.83408,0,NULL,58201114840,909392419,14209256,17.3),(88086,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88086,36.94,0.19,244,36703,70,NULL,NULL,'2MASX J12031171+5136087',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,180.799,51.60253,0,NULL,57215318974,893989358,13968583,16.9),(88087,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88087,36.78,0.17,227,36704,70,NULL,NULL,'MCG +09-20-070',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000187,NULL,'15.9g',0.49,'E0',NULL,NULL,NULL,NULL,1,180.799916667,54.84722,0,NULL,57214221150,893972205,13968315,15.9),(88088,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88088,37.56,0.46,325,36705,70,NULL,NULL,'MCG +09-20-072',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000178,NULL,'16.2g',0.43,NULL,NULL,NULL,NULL,NULL,1,180.800167,51.8125,0,NULL,57215220888,893987826,13968559,16.2),(88089,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88089,32.74,0.49,35.3,36706,70,NULL,NULL,'2MASX J12031262-1438389',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00011,NULL,'16.50',0.5,'S0^0^',NULL,NULL,NULL,NULL,1,180.802541667,-14.64417,0.109,NULL,43057293914,672770217,10512034,16.5),(88090,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88090,36.53,0.64,202,36707,70,NULL,NULL,'LCRS B120039.3-063725',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'15.91',0.43,NULL,NULL,NULL,NULL,NULL,1,180.80475,-6.90211,0.085,NULL,42978841863,671544404,10492881,15.91),(88091,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88091,37.46,0.46,310,36708,70,NULL,NULL,'2MASX J12031369+5621258',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000188,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,180.807333,56.35725,0,NULL,57395103367,896798490,14012476,16.6),(88092,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88092,37.98,0.46,394,36709,70,NULL,NULL,'SDSS J120313.97+324948.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000189,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,180.80825,32.83028,0,NULL,58620611355,915947052,14311672,18.1),(88093,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88093,36.49,0.46,199,36710,70,NULL,NULL,'CGCG 292-063',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000189,NULL,'15.4g',0.25,'E0',NULL,NULL,NULL,NULL,1,180.809958333,62.11264,0.017,NULL,57369904666,896404760,14006324,15.4),(88094,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88094,37.51,0.46,318,36711,70,NULL,NULL,'2MASX J12031439+4803167',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,180.810083,48.05461,0,NULL,57190535934,893602123,13962533,17.2),(88095,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88095,37.1,0.33,263,36712,70,NULL,NULL,'2MASX J12031454+5432499',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000193,NULL,'16.1g',0.33,'E0',NULL,NULL,NULL,NULL,1,180.810417,54.54717,0,NULL,57212056442,893938381,13967787,16.1),(88096,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88096,36.39,0.46,190,36713,70,NULL,NULL,'2MASX J12031635+0138075',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000078,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,180.8180417,1.63547,0.01,NULL,57984853708,906013339,14156458,16.6),(88097,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88097,37.49,0.33,315,36714,70,NULL,NULL,'2MASX J12031648+0136425',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000076,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,180.8185417,1.61181,0,NULL,57984856005,906013375,14156458,18),(88098,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88098,36.41,0.46,191,36715,70,NULL,NULL,'2MASX J12031661+5121457',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,180.819125,51.36269,0,NULL,57215491491,893992054,13968625,16.8),(88099,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88099,39.39,0.46,753,36716,70,NULL,NULL,'SDSS J120316.73+615134.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000175,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,180.81975,61.85953,0.021,NULL,57369922854,896405044,14006328,18.6),(88100,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88100,37.73,0.46,352,36717,70,NULL,NULL,'2MASX J12031790+2830124',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000186,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,180.8244583,28.5035,0,NULL,58624730587,916011415,14312678,17.5),(88101,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88101,37.61,0.46,332,36718,70,NULL,NULL,'2MASX J12031796+0055115',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000083,NULL,'17.1g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,180.825041667,0.91992,0.033,NULL,57986035438,906031803,14156746,17.1),(88102,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88102,37.24,0.46,281,36719,70,NULL,NULL,'2MASX J12031811+0634371',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00018,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,180.825417,6.57697,0,NULL,58023958925,906624358,14166005,16.5),(88103,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88103,36.74,0.46,223,36720,70,NULL,NULL,'2MASX J12031889+1047541',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00019,NULL,'16.2g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,180.8287917,10.79842,0,NULL,58201122780,909392543,14209258,16.2),(88104,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88104,36.94,0.19,244,36721,70,NULL,NULL,'SDSS J120319.62+514216.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000163,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,180.831833,51.70458,0,NULL,57215195410,893987428,13968553,18.2),(88105,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88105,36.01,0.46,159,36722,70,NULL,NULL,'2MASX J12031987+0721421',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000174,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,180.832917,7.36164,0,NULL,58022634911,906603670,14165682,16.6),(88106,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88106,36.83,0.46,233,36723,70,NULL,NULL,'2MASX J12032061+1319316',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000199,NULL,'16.7g',0.25,'AGN',NULL,NULL,NULL,NULL,1,180.836083,13.32539,0.011,NULL,58147093081,908548329,14196067,16.7),(88107,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88107,37.79,0.33,361,36724,70,NULL,NULL,'2MASX J12032096+1359376',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,180.837458333,13.99375,0.023,NULL,58147546353,908555411,14196178,17.3),(88108,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88108,33.41,0.2,48.1,36725,74.4,NULL,NULL,'UGC 07031',NULL,'2013AJ....146...86T',2013,1,1.54,NULL,'G',0.000008,NULL,'14.8g',0.32,'Sbc',NULL,NULL,NULL,NULL,1,180.8397917,29.41981,0,NULL,58627365458,916052585,14313321,14.8),(88109,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88109,33.42,0.49,48.3,36725,75,NULL,'IR','UGC 07031',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88110,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88110,33.65,0.44,53.7,36725,NULL,NULL,NULL,'UGC 07031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88111,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88111,33.66,NULL,53.9,36725,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88112,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88112,33.67,NULL,54.1,36725,NULL,NULL,'Dipole + Quadrupole','UGC 07031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88113,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88113,33.67,NULL,54.2,36725,NULL,NULL,'Dipole','UGC 07031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88114,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88114,33.73,NULL,55.8,36725,NULL,NULL,NULL,'UGC 07031',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88115,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88115,33.78,0.41,56.9,36725,NULL,NULL,'Malmquist cor.','UGC 07031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88116,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88116,36.94,0.19,244,36726,70,NULL,NULL,'2MASX J12032240+5149157',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000196,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,180.84325,51.82103,0,NULL,57215221398,893987834,13968559,16.6),(88117,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88117,37.84,0.46,370,36727,70,NULL,NULL,'2MASX J12032361+4636265',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000155,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,180.8485417,46.60731,0,NULL,57180361133,893443142,13960049,17.5),(88118,'IRAS','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88118,31.69,0.8,21.7,36728,75,NULL,'MAT, I','ESO 572- G 049',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000025,NULL,'14.95',0.4,'SB(s)cd: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,180.851875,-19.52244,0.081,NULL,43031385594,672365399,10505709,14.95),(88119,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88119,31.16,0.32,17.1,36728,85,NULL,'I, inv','ESO 572- G 049',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88120,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88120,31.22,0.32,17.5,36728,85,NULL,'I, raw','ESO 572- G 049',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88121,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88121,31.61,0.43,21,36728,75,NULL,'MAT, I, inv','ESO 572- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88122,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88122,31.71,0.43,22,36728,75,NULL,'MAT, I, raw','ESO 572- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88123,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88123,31.88,0.43,23.8,36728,75,NULL,'MAT, I, cor','ESO 572- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88124,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88124,32.04,0.39,25.6,36728,NULL,NULL,'Malmquist cor.','ESO 572- G 049',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88125,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88125,32.12,0.2,26.6,36728,74.4,NULL,NULL,'ESO 572- G 049',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88126,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88126,32.24,0.43,28.1,36728,75,NULL,'3.6 micron, color corrected','ESO 572- G 049',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88127,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88127,32.36,0.43,29.6,36728,75,NULL,'3.6 micron, color + selection bias corrected','ESO 572- G 049',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88128,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88128,32.38,0.33,29.9,36728,NULL,NULL,NULL,'ESO 572- G 049',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88129,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88129,32.5,0.4,31.6,36728,NULL,NULL,NULL,'ESO 572- G 049',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88130,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88130,36.78,0.17,227,36729,70,NULL,NULL,'MCG +09-20-073',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000184,NULL,'15.3g',0.52,'BrClG',NULL,NULL,NULL,NULL,1,180.86025,54.86864,0,NULL,57214212920,893972076,13968313,15.3),(88131,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88131,37.19,0.46,274,36730,70,NULL,NULL,'2MASX J12032778+2039164',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000143,NULL,'17.92',0.17,NULL,NULL,NULL,NULL,NULL,1,180.86575,20.65456,0.042,NULL,58120320516,908130008,14189531,17.92),(88132,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88132,37.8,0.46,364,36731,70,NULL,NULL,'2MASX J12032809+4255025',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000145,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,180.867125,42.91742,0,NULL,58520829591,914387962,14287311,17.4),(88133,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88133,37.24,0.46,281,36732,70,NULL,NULL,'2MASX J12032838+0003366',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000089,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,180.868167,0.06014,0.029,NULL,57982510808,905976731,14155886,16.5),(88134,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88134,36.94,0.19,244,36733,70,NULL,NULL,'MCG +09-20-074',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000228,NULL,'15.4g',0.59,'E0',NULL,NULL,NULL,NULL,1,180.8682083,51.71558,0,NULL,57215193707,893987401,13968553,15.4),(88135,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88135,35,0.16,100,36734,70,NULL,NULL,'CGCG 013-050',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000061,NULL,'15.3g',0.46,'SB(r)0+:',NULL,NULL,NULL,NULL,1,180.873041667,1.22936,0.033,NULL,57986175002,906033984,14156781,15.3),(88136,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88136,37.8,0.46,363,36735,70,NULL,NULL,'2MASX J12032983+1514177',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000175,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,180.8742917,15.23825,0.036,NULL,58145425938,908522280,14195660,17.4),(88137,'D-Sigma','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88137,33.39,0.4,47.7,36736,75,NULL,'Edat, raw','ESO 267- G 011',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00005,NULL,'13.80',1.3,'S0: pec',NULL,NULL,NULL,NULL,1,180.880917,-43.65386,0.497,NULL,43221637093,675338079,10552157,13.8),(88138,'D-Sigma','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88138,33.73,0.4,55.6,36736,75,NULL,'Edat, cor','ESO 267- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88139,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88139,33.76,0.47,56.4,36736,70,NULL,NULL,'ESO 267- G 011',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88140,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88140,33.45,0.45,48.9,36736,NULL,NULL,'K','ESO 267- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88141,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88141,34,0.4,63.2,36736,NULL,NULL,'mean','ESO 267- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88142,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88142,36.94,0.19,244,36737,70,NULL,NULL,'2MASX J12033160+5140366',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,180.8814583,51.67694,0,NULL,57215315842,893989310,13968582,17.5),(88143,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88143,37.79,0.33,361,36738,70,NULL,NULL,'2MASX J12033353+1403137',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000175,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,180.88975,14.05386,0,NULL,58147286114,908551345,14196114,18.1),(88144,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88144,38.38,0.27,475,36739,70,NULL,NULL,'2MASX J12033381+3636190',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000178,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,180.890917,36.60522,0,NULL,58549479971,914835624,14294306,17.9),(88145,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88145,36.47,0.46,197,36740,70,NULL,NULL,'2MASX J12033443+5952210',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000173,NULL,'16.0g',0.43,'E0',NULL,NULL,NULL,NULL,1,180.8934583,59.87247,0,NULL,57338222160,895909721,13998589,16),(88146,'IRAS','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88146,31.95,0.8,24.6,36741,75,NULL,'MAT, I','ESO 505- G 008',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'15.30',0.4,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,180.89575,-25.38022,0.429,NULL,43367925498,677623835,10587872,15.3),(88147,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88147,31.24,0.32,17.7,36741,85,NULL,'I, inv','ESO 505- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88148,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88148,31.28,0.4,18.1,36741,75,NULL,NULL,'ESO 505- G 008',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88149,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88149,31.29,0.39,18.1,36741,73,NULL,'IR','ESO 505- G 008',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88150,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88150,31.29,0.32,18.1,36741,85,NULL,'I, raw','ESO 505- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88151,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88151,31.64,0.43,21.3,36741,75,NULL,'MAT, I, inv','ESO 505- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88152,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88152,31.76,0.43,22.5,36741,75,NULL,'MAT, I, raw','ESO 505- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88153,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88153,31.97,0.43,24.8,36741,75,NULL,'MAT, I, cor','ESO 505- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88154,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88154,32.22,0.49,27.7,36741,75,NULL,'IR','ESO 505- G 008',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88155,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88155,32.8,0.58,36.3,36741,NULL,NULL,'Malmquist cor.','ESO 505- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88156,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88156,33.03,0.52,40.4,36741,NULL,NULL,NULL,'ESO 505- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88157,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88157,33.07,0.2,41.1,36741,74.4,NULL,NULL,'ESO 505- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88158,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88158,37.22,0.46,278,36742,70,NULL,NULL,'2MASX J12033606+4942337',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000187,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,180.9000417,49.70953,0.025,NULL,57185480729,893523136,13961299,16.7),(88159,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88159,37.8,0.46,363,36743,70,NULL,NULL,'2MASX J12033698+5550539',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,180.9039583,55.84825,0,NULL,57211191191,893924862,13967575,17.4),(88160,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88160,37.88,0.33,377,36744,70,NULL,NULL,'SDSS J120337.59+011220.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000071,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,180.906667,1.20572,0.033,NULL,57985294725,906020230,14156566,18.1),(88161,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88161,35,0.16,100,36745,70,NULL,NULL,'UGC 07034',NULL,'2015arXiv151105856S',2015,1,0.82,'Beers et al. (1995AJ....109..874B) gives v = 6150 +/- 46 km/sec.','G',0.000047,NULL,'14.5g',0.59,'SA(r)0^0^?','Group member of poor cluster',NULL,NULL,NULL,1,180.90675,2.04692,0.006,NULL,57996140413,906189693,14159213,14.5),(88162,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88162,38.1,0.46,417,36746,70,NULL,NULL,'2MASX J12033799+2536467',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.34',0.14,NULL,NULL,NULL,NULL,NULL,1,180.908333,25.61292,0.031,NULL,58595924400,915561318,14305645,18.34),(88163,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88163,37.88,0.33,377,36747,70,NULL,NULL,'2MASX J12033976+0112166',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000084,NULL,'16.9g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,180.9157917,1.20458,0.033,NULL,57985294795,906020231,14156566,16.9),(88164,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88164,37.31,0.27,290,36748,70,NULL,NULL,'SDSS J120340.44+022548.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000064,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,180.9185417,2.43011,0,NULL,57996710384,906198599,14159353,18.3),(88165,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88165,37.2,0.46,275,36749,70,NULL,NULL,'2MASX J12034280+2152529',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,180.928375,21.88147,0.04,NULL,58855399055,919615610,14368993,17.3),(88166,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88166,37.24,0.46,281,36750,70,NULL,NULL,'2MASX J12034306+5050228',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000195,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,180.9295,50.83983,0.017,NULL,57231479756,894241871,13972529,16.2),(88167,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88167,37.7,0.46,346,36751,70,NULL,NULL,'LCRS B120109.7-024737',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.00015,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,180.931083,-3.07211,0.089,NULL,42956750360,671199224,10487487,16.5),(88168,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88168,37.95,0.33,388,36752,70,NULL,NULL,'2MASX J12034358-0217226',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000141,NULL,'18.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,180.9315417,-2.28964,0.045,NULL,42965391657,671334244,10489597,18),(88169,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88169,37.45,0.46,309,36753,70,NULL,NULL,'2MASX J12034382+4744459',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000213,NULL,'16.1g',0.38,NULL,NULL,NULL,NULL,NULL,1,180.932333,47.74603,0,NULL,57190504202,893601628,13962525,16.1),(88170,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88170,37.21,0.46,277,36754,70,NULL,NULL,'2MASX J12034392-0228583',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,180.932917,-2.48294,0.041,NULL,42965293853,671332716,10489573,17.6),(88171,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88171,36.46,0.46,196,36755,70,NULL,NULL,'2MASX J12034402+0214216',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00007,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,180.933375,2.23917,0.006,NULL,57996699178,906198424,14159350,17.4),(88172,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88172,38.09,0.46,416,36756,70,NULL,NULL,'SDSS J120344.79-013119.8',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000151,NULL,'17.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,180.936625,-1.52219,0.037,NULL,42951091818,671110809,10486106,17.9),(88173,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88173,37.57,0.46,327,36757,70,NULL,NULL,'2MASX J12034498-0122496',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00015,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,180.93725,-1.38039,0.037,NULL,42952978405,671140287,10486566,16.6),(88174,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88174,37.26,0.46,284,36758,70,NULL,NULL,'2MASX J12034597+6812172',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000087,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,180.941375,68.20467,0.029,NULL,56976294304,890254598,13910228,17.1),(88175,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88175,37.95,0.33,388,36759,70,NULL,NULL,'SDSS J120347.46-021952.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,180.9477917,-2.33131,0.045,NULL,42965400642,671334385,10489599,18),(88176,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88176,37.4,0.46,303,36760,70,NULL,NULL,'2MASX J12034781+5017388',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000173,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,180.9489583,50.29408,0.018,NULL,57186054102,893532095,13961438,16.7),(88177,'IRAS','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88177,34.4,0.8,76,36761,75,NULL,'HMCL, I','UGC 07037',NULL,'1997ApJS..109..333W',1997,1,0.98,NULL,'G',0.00001,NULL,'14.7g',0.5,'SB(r)b',NULL,NULL,NULL,NULL,1,180.953125,4.22181,0,NULL,57991128196,906111378,14157990,14.7),(88178,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88178,34.52,0.4,80.3,36761,75,NULL,'HMCL, I, raw','UGC 07037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88179,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88179,34.67,0.4,85.7,36761,75,NULL,'HMCL, I, inv','UGC 07037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88180,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88180,34.75,0.4,89,36761,75,NULL,'HMCL, I, cor','UGC 07037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88181,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88181,37.02,0.33,254,36762,70,NULL,NULL,'SBS 1201+578A',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000179,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,180.954583,57.54328,0.005,NULL,57328430758,895756730,13996198,16.3),(88182,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88182,33.48,NULL,49.6,36763,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07041',NULL,'2010Ap&SS.325..163P',2010,1,1.84,'Multiple SDSS entries describe this object.','G',0.000023,NULL,'15.4g',0.26,'Sd',NULL,NULL,NULL,NULL,1,180.957041667,29.71547,0.008,NULL,58626555327,916039926,14313123,15.4),(88183,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88183,33.49,NULL,49.9,36763,NULL,NULL,'Dipole + Quadrupole','UGC 07041',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88184,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88184,33.5,NULL,50,36763,NULL,NULL,'Dipole','UGC 07041',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88185,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88185,33.78,0.49,57,36763,75,NULL,'IR','UGC 07041',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88186,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88186,32.96,0.2,39.1,36764,74.4,NULL,NULL,'UGC 07039',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000024,NULL,'15.1',1,'Scd?','Group member',NULL,NULL,NULL,1,180.9607083,16.55453,0.177,NULL,58176016545,909000258,14203129,15.1),(88187,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88187,32.67,0.43,34.2,36765,75,NULL,'3.6 micron, color + selection bias corrected','ESO 505- G 009',NULL,'2014MNRAS.444..527S',2014,1,1.6,NULL,'G',0.00002,NULL,'15.11',0.5,'SA(s)c:',NULL,NULL,NULL,NULL,1,180.961917,-27.602,0.361,NULL,43411909129,678311080,10598610,15.11),(88188,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88188,37.7,0.46,347,36766,70,NULL,NULL,'SDSS J120350.96+105544.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,180.962375,10.92911,0,NULL,58201057004,909391515,14209242,17.7),(88189,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88189,37,0.46,252,36767,70,NULL,NULL,'2MASX J12035141+4521339',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000192,NULL,'15.5g',0.44,'E0',NULL,NULL,NULL,NULL,1,180.964375,45.35928,0,NULL,59055943855,922749122,14417955,15.5),(88190,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88190,37.79,0.23,362,36768,70,NULL,NULL,'2MASX J12035162+0117425',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000087,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,180.9650417,1.29506,0.033,NULL,57985333839,906020841,14156575,17.4),(88191,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88191,36.31,0.46,183,36769,70,NULL,NULL,'2MASX J12035236+6233235',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000183,NULL,'16.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,180.968167,62.55647,0,NULL,57316116931,895564327,13993192,16.2),(88192,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88192,38.07,0.46,410,36770,70,NULL,NULL,'2MASX J12035254+4602319',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000163,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,180.969083333,46.04219,0,NULL,57177594882,893399920,13959373,17),(88193,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88193,36.9,0.27,240,36771,70,NULL,NULL,'MCG +10-17-135',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000191,NULL,'16.1g',0.44,'BrClG',NULL,NULL,NULL,NULL,1,180.9765,60.81858,0,NULL,57339966485,895936976,13999015,16.1),(88194,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88194,37.4,0.33,302,36772,70,NULL,NULL,'2MASX J12035598+1317046',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,180.983167,13.28475,0,NULL,58147143579,908549118,14196079,17.2),(88195,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88195,35.24,0.11,112,36773,70,NULL,NULL,'2MASX J12035600+2025499',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000073,NULL,'16.36',0.21,NULL,NULL,NULL,NULL,NULL,1,180.9832917,20.43047,0.033,NULL,58119590071,908118594,14189353,16.36),(88196,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88196,35.24,0.11,112,36774,70,NULL,NULL,'2MASX J12035622+2013039',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,180.9845417,20.21789,0.033,NULL,58117689997,908088906,14188889,17.2),(88197,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88197,37.79,0.23,362,36775,70,NULL,NULL,'SDSS J120357.51+012806.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000087,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,180.989666667,1.46847,0.013,NULL,57984828998,906012953,14156452,18.2),(88198,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88198,35.24,0.11,112,36776,70,NULL,NULL,'NGC 4056',NULL,'2015arXiv151105856S',2015,1,0.26,'NGC identification is not certain.','G',0.000143,NULL,'17.68',0.18,NULL,NULL,NULL,NULL,NULL,1,180.990708333,20.3125,0.033,NULL,58119613173,908118955,14189358,17.68),(88199,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88199,37.22,0.46,278,36777,70,NULL,NULL,'2MASX J12035795+2409007',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,180.9915,24.15011,0.012,NULL,58588854044,915450844,14303919,17.4),(88200,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88200,37.1,0.33,263,36778,70,NULL,NULL,'2MASX J12035818+3621325',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,180.992375,36.35914,0,NULL,58550321865,914848779,14294512,17.6),(88201,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88201,35.86,0.46,149,36779,70,NULL,NULL,'2MASX J12035863+3204049',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000133,NULL,'16.0g',0.4,NULL,NULL,NULL,NULL,NULL,1,180.9942083,32.06797,0.006,NULL,58623756199,915996190,14312440,16),(88202,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88202,37.6,0.46,332,36780,70,NULL,NULL,'2MASX J12035919-0206276',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,180.996625,-2.10761,0.045,NULL,42964961722,671327526,10489492,17.1),(88203,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88203,37.02,0.46,253,36781,70,NULL,NULL,'2MASX J12035947+5259178',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,180.9977083,52.98836,0,NULL,57217499527,894023430,13969116,17.5),(88204,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88204,35.84,0.33,147,36782,70,NULL,NULL,'CGCG 069-035',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000183,NULL,'15.1g',0.48,'E0',NULL,NULL,NULL,NULL,1,180.9980417,9.21647,0,NULL,58019628880,906556701,14164948,15.1),(88205,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88205,37.31,0.27,290,36783,70,NULL,NULL,'2MASX J12035955+0226155',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000073,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,180.99825,2.43761,0,NULL,57996707262,906198550,14159352,17),(88206,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88206,38.51,0.27,504,36784,70,NULL,NULL,'2MASX J12035990+1026466',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,180.9994583,10.44622,0,NULL,58200606618,909384478,14209132,17.4),(88207,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88207,36.23,0.46,177,36785,70,NULL,NULL,'VII Zw 435',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.0002,NULL,'15.3g',0.53,'E0',NULL,NULL,NULL,NULL,1,181.0009583,65.09714,0.021,NULL,57312130574,895502040,13992219,15.3),(88208,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88208,38.57,0.46,517,36786,70,NULL,NULL,'SDSS J120400.24+484727.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,181.001,48.79094,0.01,NULL,57187019602,893547181,13961674,18.2),(88209,'Brightest Stars','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88209,28.6,0.4,5.25,36787,NULL,NULL,'3B + 3R mean','NGC 4068',NULL,'1997AstL...23..656G',1997,1,3.3,NULL,'G',0.00001,NULL,'13.00',1.7,'IAm','in a radial-velocity based grouping',NULL,NULL,NULL,1,181.00325,52.58828,0,NULL,57216933314,894014583,13968977,13),(88210,'Brightest Stars','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88210,28.94,NULL,6.14,36787,NULL,NULL,'LF','NGC 4068',NULL,'1997AstL...23..656G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88211,'CMD','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88211,28.17,0.04,4.31,36787,NULL,NULL,NULL,'NGC 4068',NULL,'2009ApJ...695..561M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88212,'CMD','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88212,28.25,0.04,4.47,36787,NULL,NULL,NULL,'NGC 4068',NULL,'2010ApJ...721..297M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88213,'TRGB','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88213,28.15,0.1,4.27,36787,NULL,NULL,NULL,'NGC 4068',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88214,'TRGB','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88214,28.17,0.05,4.3,36787,NULL,NULL,NULL,'NGC 4068',NULL,'2014A&A...566A..71L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88215,'TRGB','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88215,28.17,NULL,4.31,36787,NULL,NULL,NULL,'NGC 4068',NULL,'2006AJ....131.1361K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88216,'TRGB','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88216,28.2,0.06,4.36,36787,NULL,NULL,NULL,'NGC 4068',NULL,'2013AstBu..68..125M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88217,'TRGB','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88217,28.2,0.02,4.37,36787,NULL,NULL,'I','NGC 4068',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88218,'TRGB','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88218,28.21,0.1,4.39,36787,74.4,NULL,NULL,'NGC 4068',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88219,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88219,27.93,0.4,3.8,36787,75,NULL,'B','NGC 4068',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88220,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2008bf',NULL,88220,34.21,0.17,67.9,36788,74.2,NULL,'SALT 2','NGC 4061',0.024027,'2010ApJ...716..712A',2010,1,1.2,NULL,'G',0.00009,NULL,'14.12',0.9,'E:','in a radial-velocity based grouping',NULL,'radio jet',NULL,1,181.006167,20.23233,0.033,NULL,58119577957,908118405,14189350,14.12),(88221,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2008bf',NULL,88221,34.94,0.02,95.1,36788,70,NULL,'SALT 2','NGC 4061',0.024027,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88222,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2008bf',NULL,88222,34.94,0.16,95.1,36788,73.8,NULL,'SALT 2 (SNANA)','NGC 4061',0.0221,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88223,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2008bf',NULL,88223,34.96,0.03,95.9,36788,72,NULL,'SALT2','NGC 4061',0.024027,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88224,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2008bf',NULL,88224,35.08,0.2,101,36788,65,NULL,'SALT2','NGC 4061',0.024027,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88225,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2008bf','R',88225,35.04,0.05,102,36788,NULL,NULL,'MLCS2k2, R(V) = 1.8','NGC 4061',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88226,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2008bf',NULL,88226,35.11,0.2,103,36788,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','NGC 4061',0.024027,'2011A&A...526A..81B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88227,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2008bf','R',88227,35.09,0.05,104,36788,NULL,NULL,'MLCS2k2, R(V) = 3.1','NGC 4061',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88228,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2008bf',NULL,88228,35.17,0.16,106,36788,65,NULL,'MLCS17','NGC 4061',0.024027,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88229,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2008bf',NULL,88229,35.18,0.18,106,36788,65,NULL,'SALT','NGC 4061',0.024027,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88230,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2008bf',NULL,88230,35.26,0.13,107,36788,72,NULL,NULL,'NGC 4061',0.0251,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88231,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2008bf',NULL,88231,35.24,0.17,109,36788,70,NULL,'SALT 2','NGC 4061',0.024027,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88232,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2008bf',NULL,88232,35.25,0.16,110,36788,65,NULL,'MLCS31','NGC 4061',0.024027,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88233,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88233,35.24,0.11,112,36788,70,NULL,NULL,'NGC 4061',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88234,'Tully est','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88234,30.82,0.8,14.6,36788,75,NULL,'B','NGC 4061',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88235,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88235,36.79,0.46,228,36789,70,NULL,NULL,'2MASX J12040167+1340286',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000137,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,181.006875,13.67456,0.021,NULL,58147706109,908557907,14196217,17.6),(88236,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88236,36.36,0.46,187,36790,70,NULL,NULL,'2MASX J12040182+0205515',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00004,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,181.007541667,2.09767,0.006,NULL,57996117683,906189338,14159208,16.9),(88237,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88237,37.79,0.23,362,36791,70,NULL,NULL,'2MASX J12040196+0126415',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000018,NULL,'16.6g',0.3,'NLAGN',NULL,NULL,NULL,'Sy 2',1,181.0082083,1.44486,0.013,NULL,57984831018,906012984,14156452,16.6),(88238,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88238,37.82,0.46,366,36792,70,NULL,NULL,'2MASX J12040265+4940548',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000154,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,181.010875,49.68183,0.025,NULL,57185477790,893523090,13961298,18.1),(88239,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88239,35.73,0.46,140,36793,70,NULL,NULL,'2MASX J12040285+1128326',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000178,NULL,'15.7g',0.41,'S0',NULL,NULL,NULL,NULL,1,181.01175,11.47564,0,NULL,58133563564,908336930,14192764,15.7),(88240,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88240,37.79,0.23,362,36794,70,NULL,NULL,'2MASX J12040356+0122255',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00008,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,181.01475,1.37358,0.033,NULL,57985305817,906020403,14156568,17.2),(88241,'IRAS','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88241,30.84,0.8,14.7,36795,75,NULL,'A82, H','NGC 4062',NULL,'1997ApJS..109..333W',1997,1,1.59,NULL,'G',0.000003,NULL,'12.5g',1.16,'SA(s)c         HII','Possible group member',NULL,NULL,NULL,1,181.0159583,31.89581,0.006,NULL,58623652547,915994571,14312415,12.5),(88242,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88242,29.93,0.4,9.7,36795,75,NULL,'B','NGC 4062',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88243,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88243,30.65,0.4,13.5,36795,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 4062',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88244,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88244,30.81,0.43,14.5,36795,75,NULL,'3.6 micron, color corrected','NGC 4062',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88245,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88245,30.82,0.43,14.6,36795,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4062',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88246,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88246,30.84,0.2,14.7,36795,74.4,NULL,NULL,'NGC 4062',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88247,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88247,31,0.4,15.8,36795,NULL,NULL,'mean','NGC 4062',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88248,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88248,31.08,0.46,16.5,36795,NULL,NULL,'J','NGC 4062',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88249,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88249,31.11,0.47,16.7,36795,75,NULL,'A82, H, raw','NGC 4062',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88250,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88250,31.16,0.45,17.1,36795,NULL,NULL,'K','NGC 4062',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88251,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88251,31.16,0.47,17.1,36795,75,NULL,'A82, H, inv','NGC 4062',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88252,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88252,31.33,0.47,18.4,36795,75,NULL,'A82, H, cor','NGC 4062',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88253,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88253,31.9,0.3,23.9,36795,55,NULL,'B','NGC 4062',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88254,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88254,38.54,0.46,510,36796,70,NULL,NULL,'2MASX J12040385+4314388',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,181.016125,43.24414,0,NULL,58522690119,914417033,14287766,17.9),(88255,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88255,37.15,0.33,269,36797,70,NULL,NULL,'2MASX J12040508+2201249',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.27',0.16,NULL,NULL,NULL,NULL,NULL,1,181.0212083,22.0235,0.04,NULL,58855412470,919615819,14368997,18.27),(88256,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88256,37.4,0.33,302,36798,70,NULL,NULL,'2MASX J12040550+1315366',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000159,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,181.0227917,13.26014,0,NULL,58147130416,908548912,14196076,17),(88257,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88257,36.9,0.27,240,36799,70,NULL,NULL,'2MASX J12040581+6052185',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,181.024083,60.87186,0,NULL,57336504246,895882878,13998169,17.1),(88258,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88258,37.45,0.46,309,36800,70,NULL,NULL,'2MASX J12040578+2052409',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,181.024208333,20.87814,0.044,NULL,58120248033,908128875,14189513,17.3),(88259,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88259,35.24,0.11,112,36801,70,NULL,NULL,'NGC 4069',NULL,'2015arXiv151105856S',2015,1,0.39,'NGC identification is not certain.','G',0.000087,NULL,'16.94',0.2,NULL,NULL,NULL,NULL,NULL,1,181.025167,20.32378,0.033,NULL,58119618455,908119038,14189359,16.94),(88260,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2008bf',NULL,88260,34.78,0.09,90.4,36802,74.4,NULL,NULL,'NGC 4065',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.00009,NULL,'13.58',1,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,181.0257083,20.23508,0.022,NULL,58119581589,908118462,14189350,13.58),(88261,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88261,35.24,0.11,112,36802,70,NULL,NULL,'NGC 4065',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88262,'Tully est','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88262,31.02,0.8,16,36802,75,NULL,'B','NGC 4065',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88263,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88263,35.06,0.4,103,36802,NULL,NULL,'mean','NGC 4065',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88264,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88264,35.29,0.45,114,36802,NULL,NULL,'K','NGC 4065',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88265,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88265,37.31,0.27,290,36803,70,NULL,NULL,'PKS 1201+027',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00007,NULL,'15.7g',0.52,'Elliptical',NULL,NULL,NULL,NULL,1,181.026625,2.41156,0,NULL,57996708605,906198571,14159352,15.7),(88266,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88266,38.27,0.46,451,36804,70,NULL,NULL,'2MASX J12040661+3711005',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,181.027375,37.18339,0,NULL,58545498919,914773420,14293334,18.2),(88267,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88267,37.29,0.46,287,36805,70,NULL,NULL,'2MASX J12040784+3847265',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000144,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,181.03275,38.79083,0,NULL,58544685624,914760712,14293136,17.7),(88268,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88268,36.85,0.46,235,36806,70,NULL,NULL,'2MASX J12040850-0006476',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000075,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,181.035541667,-0.11322,0.025,NULL,42950436796,671100574,10485946,17),(88269,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88269,35.24,0.11,112,36807,70,NULL,NULL,'NGC 4066',NULL,'2015arXiv151105856S',2015,1,1.2,NULL,'G',0.000097,NULL,'13.95',1.2,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,181.03925,20.34794,0.033,NULL,58119616631,908119009,14189359,13.95),(88270,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88270,35.61,0.49,133,36808,75,NULL,'IR','UGC 07049',NULL,'2011yCatp016004901K',2011,1,1.31,NULL,'G',0.00003,NULL,'15.90',0.12,'Sc','Group member',NULL,NULL,NULL,1,181.039833,20.18469,0.022,NULL,58117691497,908088929,14188889,15.9),(88271,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88271,35.74,NULL,141,36808,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07049',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88272,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88272,35.76,NULL,142,36808,NULL,NULL,'Dipole + Quadrupole','UGC 07049',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88273,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88273,35.77,NULL,143,36808,NULL,NULL,'Dipole','UGC 07049',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88274,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88274,35.85,NULL,148,36808,NULL,NULL,NULL,'UGC 07049',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88275,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88275,36.8,0.46,229,36809,70,NULL,NULL,'2MASX J12040979+3148369',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000145,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,181.0407917,31.81025,0,NULL,58623598482,915993726,14312401,17),(88276,'Tully est','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88276,31.14,0.8,16.9,36810,75,NULL,'B','NGC 4064',NULL,'1988NBGC.C....0000T',1988,1,4.4,NULL,'G',0.000033,NULL,'12.22',1.7,'SB(s)a: pec','in a radial-velocity based grouping',NULL,NULL,NULL,1,181.0465,18.44342,0.023,NULL,58123318890,908176857,14190263,12.22),(88277,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88277,27.94,0.69,3.87,36810,NULL,NULL,NULL,'NGC 4064',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88278,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88278,27.94,0.69,3.87,36810,NULL,NULL,'Malmquist cor.','NGC 4064',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88279,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88279,29.45,0.43,7.7,36810,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4064',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88280,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88280,29.59,0.43,8.3,36810,75,NULL,'3.6 micron, color corrected','NGC 4064',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88281,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88281,29.64,0.35,8.47,36810,NULL,NULL,NULL,'NGC 4064',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88282,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88282,29.75,0.92,8.9,36810,NULL,NULL,'CO','NGC 4064',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88283,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88283,29.94,0.45,9.71,36810,NULL,NULL,'K','NGC 4064',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88284,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88284,29.94,0.47,9.74,36810,NULL,NULL,'H','NGC 4064',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88285,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88285,30.01,0.46,10,36810,NULL,NULL,'J','NGC 4064',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88286,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88286,30.02,0.39,10.1,36810,73,NULL,'opt','NGC 4064',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88287,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88287,30.27,0.7,11.3,36810,NULL,NULL,'HI','NGC 4064',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88288,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88288,31.04,0.4,16.2,36810,NULL,NULL,'mean','NGC 4064',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88289,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88289,31.3,0.2,18,36810,NULL,NULL,'stellar kinematics','NGC 4064',NULL,'2008ApJ...683...78C',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88290,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2005bl',NULL,88290,35.3,0.14,109,36811,72,NULL,NULL,'NGC 4070',0.02513,'2013ApJ...773...53F',2013,1,1,NULL,'G',0.00008,NULL,'14.14',1,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,181.047083,20.40983,0.033,NULL,58119592698,908118635,14189353,14.14),(88291,'SNIa','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2005bl',NULL,88291,35.45,0.07,120,36811,72,NULL,NULL,'NGC 4070',0.02406,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88292,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88292,35.24,0.11,112,36811,70,NULL,NULL,'NGC 4070',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88293,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88293,34.67,0.45,86,36811,NULL,NULL,'K','NGC 4070',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88294,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88294,35.19,0.4,109,36811,NULL,NULL,'mean','NGC 4070',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88295,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88295,37.45,0.46,309,36812,70,NULL,NULL,'LCRS B120137.5-025242',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00013,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,181.047375,-3.15683,0.089,NULL,42956701889,671198467,10487476,17.3),(88296,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88296,31.75,0.69,22.4,36813,100,NULL,'mid-IR','NGC 4067',NULL,'2013ApJ...771...88L',2013,1,1.4,NULL,'G',0.000013,NULL,'13.33',1,'SA(s)b:;Sy     LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,181.048083,10.85439,0,NULL,58201192072,909393626,14209275,13.33),(88297,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88297,33.01,0.4,40,36813,NULL,NULL,'mean','NGC 4067',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88298,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88298,33.07,0.47,41.1,36813,NULL,NULL,'H','NGC 4067',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88299,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88299,33.1,0.45,41.7,36813,NULL,NULL,'K','NGC 4067',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88300,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88300,33.1,0.46,41.8,36813,NULL,NULL,'J','NGC 4067',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88301,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88301,33.12,0.43,42,36813,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4067',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88302,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88302,33.15,0.43,42.8,36813,75,NULL,'3.6 micron, color corrected','NGC 4067',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88303,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88303,33.26,0.2,44.9,36813,74.4,NULL,NULL,'NGC 4067',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88304,'SNII optical','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 1999bg',NULL,88304,32.41,0.18,30.1,36814,NULL,NULL,'SEAM','IC 0758',0.004253,'2009ApJ...694.1067P',2009,1,1.65,'UZC has V = 44383 +- 40 km/sec.','G',0.000037,NULL,'14.2g',1.15,'SB(rs)cd:','in a radial-velocity based grouping',NULL,NULL,NULL,1,181.0495,62.50536,0,NULL,57316120785,895564387,13993193,14.2),(88305,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88305,31.83,0.4,23.3,36814,75,NULL,'B','IC 0758',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88306,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88306,36.92,0.46,242,36815,70,NULL,NULL,'2MASX J12041193-0148505',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000145,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,181.0497083,-1.81406,0.041,NULL,42964978160,671327783,10489496,17.3),(88307,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88307,36.91,0.46,241,36816,70,NULL,NULL,'2MASX J12041239+5254458',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000185,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,181.0514583,52.91272,0,NULL,57217628641,894025447,13969147,16.4),(88308,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88308,34.92,0.46,96.4,36817,70,NULL,NULL,'CGCG 215-019',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000169,NULL,'14.8g',0.63,'S0/a',NULL,NULL,NULL,NULL,1,181.0522917,43.68144,0,NULL,58522732666,914417697,14287776,14.8),(88309,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88309,37.38,0.46,299,36818,70,NULL,NULL,'SDSS J120412.66+114131.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,181.05275,11.69214,0,NULL,58136874273,908388660,14193572,18.3),(88310,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88310,35,0.16,100,36819,70,NULL,NULL,'2MASX J12041309+0154005',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00003,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,181.0545417,1.90017,0.005,NULL,57996104211,906189128,14159205,16.5),(88311,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88311,36.36,0.2,187,36820,74.4,NULL,NULL,'CGCG 098-043',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.00015,NULL,'15.4',0.23,'SABbc',NULL,NULL,NULL,NULL,1,181.057833333,14.49881,0.024,NULL,58142852647,908482072,14195032,15.4),(88312,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88312,37.76,0.46,356,36821,70,NULL,NULL,'2MASX J12041426+5529248',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000148,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,181.059458333,55.49036,0.005,NULL,57211149382,893924209,13967565,17.2),(88313,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88313,38.38,0.27,475,36822,70,NULL,NULL,'2MASX J12041500+3626375',NULL,'2015arXiv151105856S',2015,1,0.23,'1998A&AS..131..295U has z = 0.001981: +- 0.000334.','G',0.000175,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,181.062583333,36.44381,0,NULL,58550219593,914847181,14294487,17.7),(88314,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88314,37.23,0.46,279,36823,70,NULL,NULL,'2MASX J12041592+5222487',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000176,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,181.0665,52.38031,0,NULL,57218101944,894032842,13969263,17.4),(88315,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88315,37.68,0.46,344,36824,70,NULL,NULL,'2MASX J12041617+1306052',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000166,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,181.067417,13.10147,0,NULL,58147098049,908548407,14196068,17.2),(88316,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88316,38.51,0.27,504,36825,70,NULL,NULL,'2MASX J12041630+1028466',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,181.067875,10.47967,0,NULL,58200601758,909384402,14209131,17.5),(88317,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88317,36.39,0.46,190,36826,70,NULL,NULL,'UGC 07055 NED02',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000534,NULL,'15.84',0.8,'E',NULL,NULL,NULL,NULL,1,181.069875,24.14697,0.008,NULL,58588812752,915450199,14303909,15.84),(88318,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88318,37.06,0.46,258,36827,70,NULL,NULL,'SDSS J120417.04+023216.7',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000071,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,181.071,2.538,0,NULL,57996424303,906194129,14159283,17.8),(88319,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88319,37.26,0.46,282,36828,70,NULL,NULL,'2MASX J12041721+3900014',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000176,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,181.071667,39.00036,0,NULL,58578622814,915290981,14301421,16.3),(88320,'IRAS','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88320,34.46,0.8,77.8,36829,75,NULL,'HMCL, I','CGCG 041-036',NULL,'1997ApJS..109..333W',1997,1,0.84,NULL,'G',0.000027,NULL,'15.7g',0.25,'Sc(f)',NULL,NULL,NULL,NULL,1,181.07225,3.87294,0.015,NULL,57994051697,906157057,14158704,15.7),(88321,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88321,34.87,0.4,94,36829,75,NULL,'HMCL, I, raw','CGCG 041-036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88322,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88322,34.98,0.4,99.2,36829,75,NULL,'HMCL, I, inv','CGCG 041-036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88323,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88323,35.04,0.4,102,36829,75,NULL,'HMCL, I, cor','CGCG 041-036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88324,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88324,37.1,0.33,263,36830,70,NULL,NULL,'2MASX J12041731+3622564',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,181.072167,36.38236,0,NULL,58550212669,914847072,14294485,17.2),(88325,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88325,38.41,0.46,480,36831,70,NULL,NULL,'2MASX J12041814+3836274',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,181.0757083,38.60764,0,NULL,58544744241,914761628,14293150,17.6),(88326,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88326,37.32,0.46,291,36832,70,NULL,NULL,'2MASX J12041813+4856034',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000175,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,181.0757083,48.93431,0.022,NULL,57186988307,893546692,13961667,16.7),(88327,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88327,38.38,0.27,475,36833,70,NULL,NULL,'2MASX J12041855+3620584',NULL,'2015arXiv151105856S',2015,1,0.29,'1998A&AS..131..295U has z = 0.036382: +- 0.000334.','G',0.000171,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,181.077417,36.34956,0,NULL,58550335389,914848990,14294515,17.2),(88328,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88328,38.16,0.46,429,36834,70,NULL,NULL,'2MASX J12041865+0237306',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000067,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,181.07775,2.62511,0,NULL,57996464221,906194753,14159293,17.4),(88329,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88329,34.52,0.49,80.3,36835,75,NULL,'IR','UGC 07057',NULL,'2011yCatp016004901K',2011,1,2.03,NULL,'G',0.000063,NULL,'14.2g',0.45,'SAb: sp','Group member',NULL,NULL,NULL,1,181.083333,1.56758,0.065,NULL,57984730106,906011407,14156428,14.2),(88330,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88330,34.74,0.46,88.9,36835,NULL,NULL,'J','UGC 07057',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88331,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88331,34.75,0.47,89.3,36835,NULL,NULL,'H','UGC 07057',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88332,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88332,34.76,0.4,89.5,36835,NULL,NULL,'mean','UGC 07057',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88333,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88333,34.8,0.45,91,36835,NULL,NULL,'K','UGC 07057',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88334,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88334,37.02,0.33,254,36836,70,NULL,NULL,'2MASX J12042006+5727588',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000177,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,181.08375,57.46631,0.005,NULL,57328414829,895756481,13996195,17),(88335,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88335,37.97,0.33,392,36837,70,NULL,NULL,'2MASX J12042045+0225306',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000074,NULL,'16.3g',0.39,'S0/a',NULL,NULL,NULL,NULL,1,181.085291667,2.42503,0,NULL,57996493563,906195211,14159300,16.3),(88336,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88336,38.8,0.46,575,36838,70,NULL,NULL,'2MASX J12042056+0423466',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,181.085541667,4.39622,0.006,NULL,57991021129,906109705,14157964,17.7),(88337,'Tully est','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88337,32.07,0.8,25.9,36839,75,NULL,NULL,'UGC 07053',NULL,'1988NBGC.C....0000T',1988,1,1.6,'Multiple SDSS entries describe this object.','G',0.00002,NULL,'15.89',1.3,'IAB(s)m','Dwarf, possible member',NULL,NULL,NULL,1,181.0844583,-1.53028,0.049,NULL,42951008025,671109500,10486085,15.89),(88338,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88338,38.09,0.46,416,36840,70,NULL,NULL,'SDSS J120421.10+394704.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,181.087917,39.78467,0.009,NULL,58523565891,914430717,14287979,18.1),(88339,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88339,34.63,0.2,84.3,36841,74.4,NULL,NULL,'CGCG 069-039',NULL,'2013AJ....146...86T',2013,1,0.94,NULL,'G',0.000003,NULL,'15.5g',0.36,'Sbc',NULL,NULL,NULL,NULL,1,181.0890417,9.20075,0,NULL,58019711357,906557989,14164968,15.5),(88340,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88340,38.48,0.46,497,36842,70,NULL,NULL,'SDSS J120421.74+240039.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,181.090625,24.01108,0.026,NULL,58589287960,915457624,14304025,18.2),(88341,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88341,38.02,0.46,403,36843,70,NULL,NULL,'2MASX J12042240+2233181',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.97',0.11,NULL,NULL,NULL,NULL,NULL,1,181.0932917,22.55492,0.055,NULL,58855127950,919611374,14368927,18.97),(88342,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88342,38.07,0.46,412,36844,70,NULL,NULL,'2MASX J12042312+3042528',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000168,NULL,'18.66',0.15,NULL,NULL,NULL,NULL,NULL,1,181.096583,30.71483,0,NULL,58635264630,916176009,14315250,18.66),(88343,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88343,36.2,0.46,174,36845,70,NULL,NULL,'2MASX J12042371+0854466',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000174,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,181.0989583,8.91303,0,NULL,58018983756,906546621,14164790,16.4),(88344,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88344,36.71,0.19,220,36846,70,NULL,NULL,'2MASX J12042469+4233432',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.00019,NULL,'15.4g',0.47,'E0',NULL,NULL,NULL,NULL,1,181.1030417,42.56183,0,NULL,58520411280,914381426,14287209,15.4),(88345,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88345,37.38,0.17,300,36847,70,NULL,NULL,'2MASX J12042570+4835495',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000175,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,181.1070417,48.59697,0.01,NULL,57187137114,893549017,13961703,17),(88346,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88346,38.06,0.33,409,36848,70,NULL,NULL,'2MASX J12042611+5612318',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000183,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,181.108833,56.20872,0,NULL,57394977804,896796528,14012445,17),(88347,'D-Sigma','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88347,34.25,0.4,70.7,36849,75,NULL,'Edat, raw','NGC 4073',NULL,'1997ApJS..109..333W',1997,1,1.93,NULL,'G',0.000037,NULL,'12.9g',1.22,'E;BrClG','in a radial-velocity based grouping',NULL,NULL,NULL,1,181.1127917,1.89597,0.008,NULL,57996209749,906190777,14159230,12.9),(88348,'D-Sigma','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88348,34.58,0.4,82.5,36849,75,NULL,'Edat, cor','NGC 4073',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88349,'Faber-Jackson','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88349,33.27,0.5,45.1,36849,95,NULL,'Weighted Mean','NGC 4073',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88350,'Faber-Jackson','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88350,33.27,0.5,45.1,36849,95,NULL,'de Vaucouleurs','NGC 4073',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88351,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88351,35,0.16,100,36849,70,NULL,NULL,'NGC 4073',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88352,'Tertiary','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88352,33.78,0.5,57,36849,95,NULL,NULL,'NGC 4073',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88353,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88353,37.36,0.33,297,36850,70,NULL,NULL,'2MASX J12042764+3220138',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000196,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,181.115125,32.33711,0.043,NULL,58623070447,915985475,14312273,16.4),(88354,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88354,37.36,0.46,296,36851,70,NULL,NULL,'2MASX J12042773+5226055',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,181.115583333,52.43486,0,NULL,57218052182,894032065,13969251,17),(88355,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88355,33.84,0.45,58.7,36852,NULL,NULL,'K','CGCG 013-059',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'GPair',0.00004,NULL,NULL,NULL,'E',NULL,NULL,NULL,NULL,1,181.11625,1.89556,0.008,NULL,57996209784,906190777,14159230,NULL),(88356,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88356,34.69,0.4,86.5,36852,NULL,NULL,'mean','CGCG 013-059',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88357,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88357,37.78,0.46,359,36853,70,NULL,NULL,'2MASX J12042811+3003358',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,181.117125,30.06,0,NULL,58626515722,916039308,14313114,17),(88358,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88358,37.38,0.17,300,36854,70,NULL,NULL,'2MASX J12042873+4837115',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000174,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,181.119875,48.61992,0.01,NULL,57187125827,893548841,13961700,16.9),(88359,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88359,38.44,0.46,488,36855,70,NULL,NULL,'2MASX J12042911+2159441',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,181.121417,21.99556,0.04,NULL,58855488667,919617010,14369015,17.6),(88360,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88360,38.14,0.33,425,36856,70,NULL,NULL,'2MASX J12042984+6838410',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000087,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,181.124375,68.64483,0.025,NULL,56976129607,890252025,13910187,17.1),(88361,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88361,38.13,0.46,423,36857,70,NULL,NULL,'SDSS J120431.26+014243.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000084,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,181.1302917,1.71197,0.005,NULL,57995986284,906187285,14159176,17.8),(88362,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88362,36.17,0.46,172,36858,70,NULL,NULL,'2MASX J12043143+1318013',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000161,NULL,'16.0g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,181.1310417,13.30044,0,NULL,58147158990,908549359,14196083,16),(88363,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88363,34.85,0.46,93.2,36859,70,NULL,NULL,'2MASX J12043154-1729151',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00014,NULL,'15.35',NULL,NULL,NULL,NULL,NULL,NULL,1,181.131416667,-17.48753,0.105,NULL,43028664861,672322888,10505045,15.35),(88364,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88364,38.01,0.46,401,36860,70,NULL,NULL,'2MASX J12043171+1425493',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000182,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,181.132,14.43042,0.024,NULL,58142770039,908480781,14195012,17.2),(88365,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88365,38.19,0.33,434,36861,70,NULL,NULL,'SDSS J120432.24+612954.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000141,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,181.134375,61.49844,0.009,NULL,57337017209,895890893,13998295,18.4),(88366,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88366,36.51,0.23,201,36862,70,NULL,NULL,'2MASX J12043243+5356295',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000179,NULL,'15.9g',0.46,'E0',NULL,NULL,NULL,NULL,1,181.135375,53.94172,0,NULL,57211423304,893928489,13967632,15.9),(88367,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88367,35.75,0.19,142,36863,70,NULL,NULL,'2MASX J12043338+2822552',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'16.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,181.139125,28.38192,0.017,NULL,58624203493,916003179,14312549,16.8),(88368,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88368,37.38,0.17,300,36864,70,NULL,NULL,'SDSS J120433.60+483410.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000165,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,181.1400417,48.56969,0.01,NULL,57187135006,893548984,13961702,18.5),(88369,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88369,31.19,0.43,17.3,36865,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4081',NULL,'2014MNRAS.444..527S',2014,1,1.5,NULL,'G',0.000047,NULL,'13.75',0.6,'Sa?','in a radial-velocity based grouping',NULL,NULL,NULL,1,181.1412917,64.43675,0.025,NULL,57317447874,895585123,13993517,13.75),(88370,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88370,31.43,0.43,19.3,36865,75,NULL,'3.6 micron, color corrected','NGC 4081',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88371,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88371,31.94,0.4,24.5,36865,75,NULL,NULL,'NGC 4081',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88372,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88372,32.06,0.2,25.8,36865,74.4,NULL,NULL,'NGC 4081',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88373,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88373,32.15,0.4,26.9,36865,NULL,NULL,'mean','NGC 4081',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88374,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88374,32.44,0.45,30.8,36865,NULL,NULL,'K','NGC 4081',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88375,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88375,32.45,0.47,31,36865,NULL,NULL,'H','NGC 4081',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88376,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88376,32.54,0.46,32.2,36865,NULL,NULL,'J','NGC 4081',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88377,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88377,32.63,0.49,33.5,36865,75,NULL,'IR','NGC 4081',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88378,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88378,34.58,0.4,82.2,36866,NULL,NULL,'mean','NGC 4139',NULL,'2007A&A...465...71T',2007,1,1.14,NULL,'G',0.00003,NULL,'14.4g',0.52,'SB(rs)0^0^','in a pair',NULL,NULL,NULL,1,181.141791667,1.80161,0.005,NULL,57996179713,906190308,14159223,14.4),(88379,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88379,34.92,0.45,96.4,36866,NULL,NULL,'K','NGC 4139',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88380,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88380,35,0.16,100,36867,70,NULL,NULL,'CGCG 013-060',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000027,NULL,'15.8g',0.35,'S0','Group member',NULL,NULL,NULL,1,181.141916667,1.73822,0.005,NULL,57995987074,906187298,14159176,15.8),(88381,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88381,37.4,0.46,303,36868,70,NULL,NULL,'2MASX J12043430+4126125',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,181.143,41.43678,0,NULL,58525869319,914466708,14288542,18.1),(88382,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88382,36.16,0.46,171,36869,70,NULL,NULL,'2MASX J12043521+3006317',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000158,NULL,'16.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,181.1467083,30.10881,0,NULL,58626519373,916039365,14313115,16.7),(88383,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88383,36.71,0.19,220,36870,70,NULL,NULL,'2MASX J12043582+4232362',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,181.149125,42.54342,0,NULL,58520409329,914381395,14287209,17.3),(88384,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88384,38.19,0.46,434,36871,70,NULL,NULL,'2MASX J12043744+2325471',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,181.156,23.42972,0.038,NULL,58589988430,915468569,14304196,17.5),(88385,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88385,35.2,0.4,110,36872,NULL,NULL,'mean','NGC 4077',NULL,'2007A&A...465...71T',2007,1,1.18,'The APM image includes two superposed stars.','G',0.000043,NULL,'14.0g',0.72,'SB(r)0^0^      NLAGN','in a pair',NULL,NULL,NULL,1,181.1585417,1.78772,0.005,NULL,57996172390,906190193,14159221,14),(88386,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88386,35.23,0.45,111,36872,NULL,NULL,'K','NGC 4077',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88387,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88387,35.5,0.2,126,36873,74.4,NULL,NULL,'IC 2990',NULL,'2013AJ....146...86T',2013,1,0.87,NULL,'G',0.000023,NULL,'15.3g',0.37,'Sbc',NULL,NULL,NULL,NULL,1,181.160833,11.05006,0,NULL,58200938340,909389661,14209213,15.3),(88388,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88388,36.7,0.46,219,36874,70,NULL,NULL,'2MASX J12043858+5910298',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,181.160833,59.17489,0,NULL,57341583691,895962245,13999410,17.7),(88389,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88389,37.3,0.46,288,36875,70,NULL,NULL,'2MASX J12043921+5220455',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,181.163667,52.34606,0,NULL,57218078391,894032474,13969257,18.1),(88390,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88390,37.07,0.46,259,36876,70,NULL,NULL,'2MASX J12043975+2116111',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.26',0.16,NULL,NULL,NULL,NULL,NULL,1,181.165583,21.26992,0.045,NULL,58116843062,908075672,14188682,18.26),(88391,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88391,38.23,0.46,442,36877,70,NULL,NULL,'SDSS J120439.93+544018.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,181.166416667,54.67192,0,NULL,57212012008,893937687,13967776,18.6),(88392,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88392,37.93,0.46,385,36878,70,NULL,NULL,'2MASX J12044027+3200307',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,181.167833,32.00864,0,NULL,58623777978,915996530,14312445,17.7),(88393,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88393,36.71,0.19,220,36879,70,NULL,NULL,'2MASX J12044088+4230301',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000176,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,181.170417,42.50836,0,NULL,58520435103,914381798,14287215,16.3),(88394,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88394,36.68,0.33,217,36880,70,NULL,NULL,'2MASX J12044104+5924027',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000184,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,181.170916667,59.40092,0,NULL,57341572996,895962078,13999407,16.3),(88395,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88395,37.58,0.23,329,36881,70,NULL,NULL,'2MASX J12044111+5403597',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,181.1715,54.06667,0,NULL,57212285749,893941964,13967843,17.4),(88396,'IRAS','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88396,31.66,0.8,21.5,36882,75,NULL,'MAT, I','UGCA 267',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000017,NULL,'13.60',1.5,'SB(s)m:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,181.1715,-28.11631,0.353,NULL,43411477556,678304336,10598505,13.6),(88397,'Tully est','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88397,32.06,0.8,25.9,36882,75,NULL,NULL,'UGCA 267',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88398,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88398,29.65,0.32,8.48,36882,85,NULL,'I, inv','UGCA 267',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88399,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88399,29.7,0.32,8.75,36882,85,NULL,'I, raw','UGCA 267',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88400,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88400,29.8,0.43,9.1,36882,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 267',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88401,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88401,29.98,0.43,9.9,36882,75,NULL,'3.6 micron, color corrected','UGCA 267',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88402,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88402,30,0.4,10,36882,73,NULL,'opt','UGCA 267',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88403,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88403,30.04,0.2,10.2,36882,74.4,NULL,NULL,'UGCA 267',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88404,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88404,30.06,0.43,10.3,36882,75,NULL,'MAT, I, inv','UGCA 267',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88405,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88405,30.18,0.4,10.9,36882,NULL,NULL,NULL,'UGCA 267',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88406,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88406,30.24,0.43,11.2,36882,75,NULL,'MAT, I, raw','UGCA 267',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88407,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88407,30.53,0.43,12.8,36882,75,NULL,'MAT, I, cor','UGCA 267',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88408,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88408,38.16,0.46,429,36883,70,NULL,NULL,'2MASX J12044178+3744185',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,181.174083,37.73842,0,NULL,58548267643,914816681,14294010,18.2),(88409,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88409,36.68,0.33,217,36884,70,NULL,NULL,'2MASX J12044224+5926067',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000165,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,181.175958333,59.43517,0,NULL,57341568360,895962005,13999406,16.5),(88410,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88410,36.71,0.19,220,36885,70,NULL,NULL,'2MASX J12044241+4229251',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000174,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,181.176875,42.49033,0,NULL,58520435992,914381812,14287215,16.4),(88411,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88411,39.04,0.46,642,36886,70,NULL,NULL,'SDSS J120443.03+045610.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,181.179333,4.93611,0,NULL,58037410294,906834535,14169289,18.1),(88412,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88412,37.89,0.46,379,36887,70,NULL,NULL,'SDSS J120443.46+013024.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000071,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,181.181083,1.50686,0.065,NULL,57984744944,906011639,14156431,18),(88413,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88413,37.95,0.46,390,36888,70,NULL,NULL,'2MASX J12044354+6144429',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,181.1812917,61.74539,0.017,NULL,57336324701,895880073,13998126,17.5),(88414,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88414,38.19,0.33,434,36889,70,NULL,NULL,'2MASX J12044442+6131532',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,181.185125,61.53133,0,NULL,57337015170,895890862,13998294,18.3),(88415,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88415,37.38,0.17,300,36890,70,NULL,NULL,'2MASX J12044445+4835495',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,181.1852917,48.59708,0.01,NULL,57186622437,893540975,13961577,17.4),(88416,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88416,35.1,0.52,105,36891,70,NULL,NULL,'2MASX J12044518-5039100',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,181.18825,-50.65289,0.453,NULL,44619174737,697174605,10893353,16.1),(88417,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88417,35.84,0.33,147,36892,70,NULL,NULL,'2MASX J12044583+0925209',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000163,NULL,'16.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,181.1910417,9.42253,0,NULL,58019199402,906549990,14164843,16.5),(88418,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88418,34.97,0.46,98.6,36893,70,NULL,NULL,'CGCG 243-041',NULL,'2015arXiv151105856S',2015,1,0.96,NULL,'G',0.000163,NULL,'14.9g',0.43,'Sa',NULL,NULL,NULL,NULL,1,181.192458333,49.18658,0.169,NULL,57189150444,893580475,13962194,14.9),(88419,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88419,38.59,0.46,522,36894,70,NULL,NULL,'2MASX J12044631+4512300',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000181,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,181.192917,45.20844,0,NULL,59056678986,922760609,14418134,17.6),(88420,'D-Sigma','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88420,34.25,0.4,70.8,36895,75,NULL,'Edat, raw','ESO 171- G 008',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',NULL,NULL,'14.33',0.9,'SA0- pec:',NULL,NULL,NULL,NULL,1,181.19325,-53.17467,NULL,NULL,44587433350,696678646,10885603,14.33),(88421,'D-Sigma','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88421,34.59,0.4,82.6,36895,75,NULL,'Edat, cor','ESO 171- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88422,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88422,34.37,0.4,74.9,36895,NULL,NULL,'mean','ESO 171- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88423,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88423,34.83,0.45,92.3,36895,NULL,NULL,'K','ESO 171- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88424,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88424,38.1,0.46,417,36896,70,NULL,NULL,'2MASX J12044660+3910505',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,181.194,39.18083,0.006,NULL,58578644784,915291324,14301426,18),(88425,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88425,36.71,0.19,220,36897,70,NULL,NULL,'2MASX J12044659+4232540',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,181.1940417,42.54828,0,NULL,58520415156,914381486,14287210,17.3),(88426,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88426,37.34,0.46,294,36898,70,NULL,NULL,'2MASX J12044719+2318081',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.68',0.13,NULL,NULL,NULL,NULL,NULL,1,181.196541667,23.30236,0.035,NULL,58589886427,915466975,14304171,18.68),(88427,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88427,37.38,0.17,300,36899,70,NULL,NULL,'MCG +08-22-064a',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.00019,NULL,'16.0g',0.49,'E0',NULL,NULL,NULL,NULL,1,181.197333,48.56981,0.01,NULL,57186623292,893540988,13961577,16),(88428,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88428,33.08,0.4,41.3,36900,NULL,NULL,'mean','NGC 4078',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000017,NULL,'14.16',0.5,'S0?','in a pair',NULL,NULL,NULL,1,181.1985,10.59558,0,NULL,58200988736,909390449,14209225,14.16),(88429,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88429,33.76,0.45,56.4,36900,NULL,NULL,'K','NGC 4078',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88430,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88430,36.8,0.46,229,36901,70,NULL,NULL,'2MASX J12044790+5151085',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00016,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,181.1997917,51.85228,0,NULL,57215288207,893988878,13968576,16.8),(88431,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88431,37.63,0.46,336,36902,70,NULL,NULL,'2MASX J12044877+2746554',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,181.2029583,27.78222,0.03,NULL,58641598810,916274981,14316796,17.7),(88432,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88432,37.26,0.46,283,36903,70,NULL,NULL,'2MASX J12044872+1634576',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,181.203041667,16.58272,0.162,NULL,58175718647,908995603,14203056,18),(88433,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88433,38.02,0.46,403,36904,70,NULL,NULL,'2MASX J12044974+2257541',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.56',0.13,NULL,NULL,NULL,NULL,NULL,1,181.207417,22.96506,0.041,NULL,58586532839,915414575,14303352,18.56),(88434,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88434,34.4,0.49,76,36905,70,NULL,NULL,'NGC 4079',NULL,'2014MNRAS.445.2677S',2014,1,2.2,NULL,'G',0.00003,NULL,'13.20',1.6,'(R\')SAB(rs)bc:','Group member of poor cluster',NULL,NULL,NULL,1,181.2077083,-2.38239,0.081,NULL,42964710334,671323598,10489431,13.2),(88435,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88435,34.34,0.45,73.7,36905,NULL,NULL,'K','NGC 4079',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88436,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88436,34.34,0.47,73.9,36905,NULL,NULL,'H','NGC 4079',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88437,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88437,34.37,0.46,75,36905,NULL,NULL,'J','NGC 4079',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88438,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88438,34.57,0.6,82.2,36905,NULL,NULL,'Malmquist cor.','NGC 4079',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88439,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88439,34.7,0.4,87.2,36905,NULL,NULL,'mean','NGC 4079',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88440,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88440,35.01,0.49,101,36905,NULL,NULL,NULL,'NGC 4079',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88441,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88441,35.05,0.2,102,36905,74.4,NULL,NULL,'NGC 4079',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88442,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88442,35.24,0.11,112,36906,70,NULL,NULL,'CGCG 098-048',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000083,NULL,'15.2',1,'E',NULL,NULL,NULL,NULL,1,181.2114583,19.24772,0,NULL,58131772105,908308939,14192327,15.2),(88443,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88443,38.06,0.46,409,36907,70,NULL,NULL,'2MASX J12045171+1518426',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000168,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,181.215541667,15.31172,0.104,NULL,58145110971,908517358,14195583,17),(88444,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88444,30.88,NULL,15,36908,NULL,NULL,NULL,'NGC 4080',NULL,'2013AJ....145..101K',2013,1,1.5,NULL,'G',0.000013,NULL,'13.7g',0.7,'Im?','Group member',NULL,NULL,NULL,1,181.215958333,26.99253,0.025,NULL,58595179620,915549681,14305463,13.7),(88445,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88445,31.06,0.43,16.3,36908,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4080',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88446,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88446,37,0.46,251,36909,70,NULL,NULL,'2MASX J12045204+4550190',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000175,NULL,'16.0g',0.35,'E0',NULL,NULL,NULL,NULL,1,181.21675,45.83856,0,NULL,57177192431,893393631,13959275,16),(88447,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88447,37.14,0.46,268,36910,70,NULL,NULL,'2MASX J12045256+0322151',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000089,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,181.218917,3.371,0.005,NULL,57993679863,906151247,14158613,16.6),(88448,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88448,37.74,0.46,353,36911,70,NULL,NULL,'2MASX J12045275-0059151',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000083,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,181.2197917,-0.9875,0.041,NULL,42952905809,671139153,10486549,16.6),(88449,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88449,36.51,0.23,201,36912,70,NULL,NULL,'MCG +09-20-083',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000193,NULL,'15.5g',0.44,'BrClG',NULL,NULL,NULL,NULL,1,181.220625,54.23178,0,NULL,57212304961,893942265,13967847,15.5),(88450,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88450,36.94,0.46,244,36913,70,NULL,NULL,'2MASX J12045317+2215202',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.43',0.14,NULL,NULL,NULL,NULL,NULL,1,181.2214583,22.25569,0.025,NULL,58855277426,919613709,14368964,18.43),(88451,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88451,38.18,0.46,433,36914,70,NULL,NULL,'2MASX J12045463+0114031',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000108,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,181.227667,1.23408,0.037,NULL,57985441798,906022528,14156602,16.9),(88452,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88452,37.08,0.46,260,36915,70,NULL,NULL,'2MASX J12045486+6122260',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,181.2287083,61.37381,0,NULL,57337157251,895893082,13998329,17.3),(88453,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88453,37.38,0.17,300,36916,70,NULL,NULL,'2MASX J12045502+4832564',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00019,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,181.22925,48.54914,0.01,NULL,57186639120,893541236,13961581,16.6),(88454,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88454,37.51,0.46,318,36917,70,NULL,NULL,'LCRS B120221.7-025129',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,181.231583333,-3.1365,0.057,NULL,42957033886,671203654,10487557,17.4),(88455,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88455,36.04,0.46,161,36918,70,NULL,NULL,'2MASX J12045596+4659000',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000172,NULL,'15.9g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,181.233333,46.98339,0,NULL,57179966425,893436975,13959952,15.9),(88456,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88456,37.09,0.46,262,36919,70,NULL,NULL,'2MASX J12045639+1325216',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000181,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,181.235,13.42264,0,NULL,58147511759,908554871,14196169,17.1),(88457,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88457,38.62,0.46,530,36920,70,NULL,NULL,'SDSS J120457.61+260442.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.2g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,181.240083,26.07847,0.047,NULL,58597746357,915589786,14306090,18.2),(88458,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88458,37.67,0.46,342,36921,70,NULL,NULL,'SDSS J120457.99+560343.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,181.241667,56.06219,0,NULL,57210440002,893913125,13967392,18.4),(88459,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88459,38.51,0.27,504,36922,70,NULL,NULL,'SDSS J120458.07+102800.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,181.2419583,10.46683,0,NULL,58200511832,909382997,14209109,17.9),(88460,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88460,36.6,0.33,208,36923,70,NULL,NULL,'SDSS J120458.62+061928.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00017,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,181.2442917,6.3245,0,NULL,58023600230,906618753,14165918,17.6),(88461,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88461,36.6,0.33,208,36924,70,NULL,NULL,'CGCG 041-038',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.0001,NULL,'15.0g',0.59,NULL,NULL,NULL,NULL,NULL,1,181.244708333,6.30297,0,NULL,58023600430,906618756,14165918,15),(88462,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88462,37.36,0.33,297,36925,70,NULL,NULL,'2MASX J12045941+3221167',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000205,NULL,'16.3g',0.38,'AGN',NULL,NULL,NULL,NULL,1,181.247417,32.35472,0.043,NULL,58623118273,915986223,14312284,16.3),(88463,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88463,37.53,0.46,320,36926,70,NULL,NULL,'2MASX J12045980+2224442',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,181.249167,22.41242,0.04,NULL,58855206818,919612606,14368946,17.6),(88464,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88464,38.13,0.33,422,36927,70,NULL,NULL,'2MASX J12050036+1033562',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000191,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,181.251583,10.56569,0,NULL,58200515494,909383054,14209110,16.4),(88465,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88465,38.59,0.46,522,36928,70,NULL,NULL,'2MASX J12050053+2235312',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,181.252125,22.59203,0.055,NULL,58855228872,919612951,14368952,17.7),(88466,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88466,38.09,0.46,415,36929,70,NULL,NULL,'2MASX J12050176+0021481',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000088,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,181.2572917,0.36339,0.029,NULL,57985966420,906030725,14156730,17.6),(88467,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88467,37.97,0.46,392,36930,70,NULL,NULL,'2MASX J12050211-0205051',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,181.25875,-2.08492,0.049,NULL,42965017163,671328393,10489506,17.6),(88468,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88468,37,0.46,251,36931,70,NULL,NULL,'2MASX J12050220+0739172',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,181.259125,7.65486,0,NULL,58030683177,906729424,14167647,17),(88469,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88469,36.71,0.19,220,36932,70,NULL,NULL,'2MASX J12050246+4231320',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,181.260333,42.52567,0,NULL,58520424254,914381628,14287212,17.4),(88470,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88470,36.51,0.23,201,36933,70,NULL,NULL,'2MASX J12050280+5411403',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,181.261833333,54.19461,0,NULL,57212301072,893942204,13967846,16.9),(88471,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88471,38.13,0.33,422,36934,70,NULL,NULL,'2MASX J12050321+1035422',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000151,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,181.2635,10.59494,0,NULL,58201002053,909390657,14209229,17.7),(88472,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88472,36.6,0.17,209,36935,70,NULL,NULL,'2MASX J12050363+3928105',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000201,NULL,'15.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,181.265,39.46958,0.067,NULL,58578301013,915285953,14301343,15.8),(88473,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88473,36.97,0.33,248,36936,70,NULL,NULL,'2MASX J12050401+5051339',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000155,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,181.26675,50.85936,0.017,NULL,57232150178,894252346,13972692,17.3),(88474,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88474,36.32,0.46,184,36937,70,NULL,NULL,'2MASX J12050449+4047275',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00018,NULL,'15.8g',0.41,NULL,NULL,NULL,NULL,NULL,1,181.268625,40.79097,0,NULL,58527223871,914487872,14288873,15.8),(88475,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88475,38.57,0.46,518,36938,70,NULL,NULL,'2MASX J12050519+2520084',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,181.271667,25.33575,0.039,NULL,58600428345,915631692,14306745,18.5),(88476,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88476,38.06,0.33,409,36939,70,NULL,NULL,'SDSS J120505.32+560840.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,181.2722083,56.14461,0,NULL,57394935093,896795860,14012435,18.3),(88477,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88477,34.69,NULL,86.5,36940,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1359',NULL,'2010Ap&SS.325..163P',2010,1,1.01,NULL,'G',0.00011,'?','16.50',0.13,'Sd',NULL,NULL,NULL,NULL,1,181.27375,-3.87633,0.069,NULL,42957774136,671215220,10487737,16.5),(88478,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88478,34.69,NULL,86.7,36940,NULL,NULL,'Dipole + Quadrupole','FGC 1359',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88479,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88479,34.7,NULL,87,36940,NULL,NULL,NULL,'FGC 1359',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88480,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88480,34.7,NULL,87.1,36940,NULL,NULL,'Dipole','FGC 1359',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88481,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88481,37.7,0.16,347,36941,70,NULL,NULL,'2MASX J12050585+5118359',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000169,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,181.2745417,51.30983,0.013,NULL,57214906332,893982911,13968482,16.8),(88482,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88482,38.07,0.46,412,36942,70,NULL,NULL,'2MASX J12050609+1534366',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000176,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,181.27525,15.57672,0.135,NULL,58142023528,908469117,14194829,17.3),(88483,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88483,37.83,0.46,368,36943,70,NULL,NULL,'2MASX J12050648+5123419',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000146,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,181.276791667,51.395,0.007,NULL,57214935030,893983359,13968489,17.5),(88484,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88484,36.76,0.46,225,36944,70,NULL,NULL,'2MASXi J1205068+312010',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000139,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,181.2785417,31.33622,0,NULL,58621141515,915955336,14311802,17.4),(88485,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88485,37.69,0.46,345,36945,70,NULL,NULL,'2MASX J12050714+2115012',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.32',0.16,NULL,NULL,NULL,NULL,NULL,1,181.2797917,21.25047,0.042,NULL,58116864800,908076012,14188687,18.32),(88486,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88486,37.15,0.33,269,36946,70,NULL,NULL,'2MASX J12050764+2207451',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.97',0.18,NULL,NULL,NULL,NULL,NULL,1,181.2817083,22.12928,0.025,NULL,58855289850,919613903,14368967,17.97),(88487,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88487,37.48,0.46,313,36947,70,NULL,NULL,'2MASX J12050991+4447440',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000176,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,181.2914583,44.79572,0,NULL,59056770651,922762041,14418156,17.2),(88488,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88488,37.49,0.46,314,36948,70,NULL,NULL,'2MASX J12051035+1246116',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,181.293208333,12.76994,0,NULL,58135685211,908370081,14193282,17.1),(88489,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88489,36.6,0.17,209,36949,70,NULL,NULL,'2MASX J12051040+3920476',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000217,NULL,'15.8g',0.44,'cD',NULL,NULL,NULL,NULL,1,181.293208333,39.34672,0.006,NULL,58578541865,915289716,14301401,15.8),(88490,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88490,35.4,NULL,120,36950,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1360',NULL,'2010Ap&SS.325..163P',2010,1,1.12,NULL,'G',0.000235,NULL,'17.0g',0.12,'Sd',NULL,NULL,NULL,NULL,1,181.2965417,40.24742,0,NULL,58526962077,914483782,14288809,17),(88491,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88491,35.41,NULL,121,36950,NULL,NULL,'Dipole + Quadrupole','FGC 1360',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88492,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88492,35.44,NULL,122,36950,NULL,NULL,'Dipole','FGC 1360',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88493,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88493,35.45,NULL,123,36950,NULL,NULL,NULL,'FGC 1360',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88494,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88494,35.92,0.66,152,36951,70,NULL,NULL,'2MASX J12051178-0939460',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.72',NULL,NULL,NULL,NULL,NULL,NULL,1,181.299083,-9.66281,0.229,NULL,42970141007,671408453,10490757,16.72),(88495,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88495,35.61,0.2,132,36952,74.4,NULL,NULL,'IC 2991',NULL,'2013AJ....146...86T',2013,1,0.62,NULL,'G',0.000002,NULL,'16.2g',0.26,NULL,'Group member',NULL,NULL,NULL,1,181.302125,10.64036,0,NULL,58200961473,909390023,14209219,16.2),(88496,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88496,36.6,0.17,209,36953,70,NULL,NULL,'2MASX J12051255+3921416',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,181.302417,39.36167,0.006,NULL,58578267690,915285432,14301334,16.4),(88497,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88497,36.6,0.17,209,36954,70,NULL,NULL,'2MASX J12051331+3926446',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,181.305333,39.44586,0.067,NULL,58578304519,915286008,14301343,16.7),(88498,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88498,35.79,0.33,144,36955,70,NULL,NULL,'NGC 4083',NULL,'2015arXiv151105856S',2015,1,0.96,NULL,'G',0.000147,NULL,'14.9g',0.52,'E0','Group member',NULL,NULL,NULL,1,181.3085417,10.61322,0,NULL,58200960214,909390003,14209218,14.9),(88499,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88499,38.2,0.46,436,36956,70,NULL,NULL,'2MASX J12051479+5752493',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000169,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,181.311583,57.88036,0,NULL,57331353312,895802395,13996912,17.1),(88500,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88500,37.44,0.46,307,36957,70,NULL,NULL,'2MASX J12051520-0045009',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000084,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,181.313333,-0.75028,0.041,NULL,42953751562,671152368,10486755,16.6),(88501,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88501,35.23,0.46,111,36958,70,NULL,NULL,'NGC 4084',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000103,NULL,'15.40',0.4,'S?',NULL,NULL,NULL,NULL,1,181.313583,21.21444,0.042,NULL,58116857790,908075902,14188685,15.4),(88502,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88502,30.52,NULL,12.7,36959,NULL,NULL,NULL,'IC 2992',NULL,'2013AJ....145..101K',2013,1,0.69,NULL,'G',0.000033,NULL,'14.8g',0.62,'S0?',NULL,NULL,NULL,NULL,1,181.3159583,30.85564,0,NULL,58634880050,916170000,14315156,14.8),(88503,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88503,38.34,0.46,465,36960,70,NULL,NULL,'2MASXi J1205164+212242',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,181.318833333,21.37828,0.047,NULL,58854776292,919605879,14368841,17.8),(88504,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88504,37.1,0.46,263,36961,70,NULL,NULL,'2MASX J12051655+2100368',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000103,NULL,'16.75',0.4,NULL,NULL,NULL,NULL,NULL,1,181.3190417,21.01033,0.042,NULL,58119705319,908120395,14189381,16.75),(88505,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88505,36.6,0.17,209,36962,70,NULL,NULL,'2MASXi J1205168+392237',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000176,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,181.320125,39.37711,0.006,NULL,58578268055,915285438,14301334,17.6),(88506,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88506,36.6,0.17,209,36963,70,NULL,NULL,'2MASX J12051684+3852546',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000197,NULL,'15.7g',0.41,NULL,NULL,NULL,NULL,NULL,1,181.320167,38.88194,0,NULL,58578592931,915290514,14301414,15.7),(88507,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88507,37.78,0.46,360,36964,70,NULL,NULL,'2MASX J12051772+1517235',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,181.323875,15.28994,0.104,NULL,58145070753,908516730,14195573,17.3),(88508,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88508,37.79,0.33,361,36965,70,NULL,NULL,'SDSS J120517.85+051738.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000145,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,181.324417,5.29389,0,NULL,58037335272,906833363,14169271,17.9),(88509,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88509,35,0.16,100,36966,70,NULL,NULL,'2MASX J12051801+0217221',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000064,NULL,'15.6g',0.34,'S0',NULL,NULL,NULL,NULL,1,181.324917,2.28953,0.006,NULL,57996404793,906193824,14159278,15.6),(88510,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88510,37.79,0.33,361,36967,70,NULL,NULL,'SDSS J120519.28+051425.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000149,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,181.330375,5.24039,0,NULL,58037270797,906832356,14169255,18.5),(88511,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88511,37.97,0.33,392,36968,70,NULL,NULL,'SDSS J120519.31+022152.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00008,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,181.3305,2.36458,0.006,NULL,57996403744,906193808,14159278,18),(88512,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88512,37.85,0.46,372,36969,70,NULL,NULL,'2MASX J12051984+6205451',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,181.3327083,62.09581,0.005,NULL,57369893650,896404588,14006321,17.4),(88513,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88513,37.45,0.33,309,36970,70,NULL,NULL,'2MASX J12052064+2252528',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.84',0.19,NULL,NULL,NULL,NULL,NULL,1,181.336125,22.88142,0.041,NULL,58586327896,915411373,14303302,17.84),(88514,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88514,35,0.16,100,36971,70,NULL,NULL,'CGCG 013-069',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000033,NULL,'15.3g',0.43,'S0/a',NULL,NULL,NULL,NULL,1,181.3397917,2.08631,0.006,NULL,57996032844,906188013,14159187,15.3),(88515,'Tully est','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88515,31.15,0.8,17,36972,75,NULL,'B','NGC 4085',NULL,'1988NBGC.C....0000T',1988,1,2.8,NULL,'G',0.000017,NULL,'12.95',0.8,'SAB(s)c:?      HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,181.344625,50.35294,0.012,NULL,57185742860,893527232,13961363,12.95),(88516,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88516,30.97,0.12,15.7,36972,NULL,NULL,NULL,'NGC 4085',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88517,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88517,31.07,0.4,16.4,36972,NULL,NULL,'mean','NGC 4085',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88518,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88518,31.15,0.43,17,36972,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4085',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88519,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88519,31.31,0.4,18.3,36972,75,NULL,NULL,'NGC 4085',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88520,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88520,31.37,0.43,18.8,36972,75,NULL,'3.6 micron, color corrected','NGC 4085',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88521,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88521,31.54,NULL,20.3,36972,NULL,NULL,'I, Hubble-type-TF','NGC 4085',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88522,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88522,31.55,0.35,20.4,36972,NULL,NULL,NULL,'NGC 4085',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88523,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88523,31.57,NULL,20.6,36972,NULL,NULL,'B','NGC 4085',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88524,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88524,31.59,NULL,20.8,36972,NULL,NULL,'B, Hubble-type-TF','NGC 4085',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88525,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88525,31.59,0.2,20.8,36972,74.4,NULL,NULL,'NGC 4085',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88526,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88526,31.62,NULL,21.1,36972,NULL,NULL,'I','NGC 4085',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88527,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88527,31.64,NULL,21.3,36972,NULL,NULL,'I','NGC 4085',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88528,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88528,31.76,NULL,22.5,36972,NULL,NULL,'B','NGC 4085',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88529,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88529,31.86,0.46,23.6,36972,NULL,NULL,'J','NGC 4085',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88530,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88530,31.9,0.49,24,36972,75,NULL,'IR','NGC 4085',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88531,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88531,31.9,0.47,24,36972,NULL,NULL,'H','NGC 4085',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88532,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88532,31.91,0.45,24.1,36972,NULL,NULL,'K','NGC 4085',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88533,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88533,38.78,0.46,570,36973,70,NULL,NULL,'LCRS B120248.9-030004',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000169,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,181.344958333,-3.2795,0.045,NULL,42957176710,671205886,10487591,18.3),(88534,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88534,35.83,0.46,146,36974,70,NULL,NULL,'2MASX J12052297+1411565',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000185,NULL,'15.6g',0.5,NULL,NULL,NULL,NULL,NULL,1,181.34575,14.19906,0.024,NULL,58142767370,908480740,14195011,15.6),(88535,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88535,34.29,0.4,72.2,36975,NULL,NULL,'mean','UGC 07073',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.00002,NULL,'14.06',0.8,'SB(rs)c:','Pair member (points to parent)',NULL,NULL,NULL,1,181.3465,17.886,0.082,NULL,58123810905,908184545,14190383,14.06),(88536,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88536,34.51,0.47,79.7,36975,NULL,NULL,'H','UGC 07073',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88537,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88537,34.62,0.46,84,36975,NULL,NULL,'J','UGC 07073',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88538,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88538,38.24,0.23,445,36976,70,NULL,NULL,'2MASX J12052321+1022461',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000137,NULL,'15.6g',0.46,'BrClG',NULL,NULL,NULL,NULL,1,181.3467917,10.3795,0,NULL,58200533881,909383341,14209114,15.6),(88539,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88539,34.24,0.4,70.5,36977,NULL,NULL,'mean','UGC 07074',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000033,NULL,'14.67',0.3,'Sa','Pair member (points to parent)',NULL,NULL,NULL,1,181.3475417,17.91992,0.123,NULL,58123798274,908184348,14190380,14.67),(88540,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88540,34.41,0.47,76.3,36977,NULL,NULL,'H','UGC 07074',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88541,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88541,34.46,0.45,77.9,36977,NULL,NULL,'K','UGC 07074',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88542,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88542,34.53,0.46,80.6,36977,NULL,NULL,'J','UGC 07074',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88543,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88543,37.76,0.46,356,36978,70,NULL,NULL,'2MASX J12052375+3603577',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.49',0.15,NULL,NULL,NULL,NULL,NULL,1,181.3490417,36.06594,0,NULL,58549765653,914840088,14294376,18.49),(88544,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88544,37.53,0.46,320,36979,70,NULL,NULL,'2MASXi J1205237+410357',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000171,NULL,'17.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,181.3490417,41.06617,0,NULL,58525907435,914467303,14288551,17.9),(88545,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88545,38.14,0.33,425,36980,70,NULL,NULL,'SDSS J120523.83+683440.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000074,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,181.3492917,68.57803,0.025,NULL,56976244193,890253815,13910215,18.7),(88546,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88546,37.81,0.46,365,36981,70,NULL,NULL,'2MASX J12052392+5924353',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000159,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,181.349875,59.40992,0,NULL,57341565359,895961958,13999405,17.3),(88547,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88547,36.96,0.46,246,36982,70,NULL,NULL,'2MASX J12052402+6152311',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000017,NULL,'16.2g',0.44,NULL,NULL,NULL,NULL,NULL,1,181.35025,61.87533,0.005,NULL,57369820935,896403452,14006303,16.2),(88548,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88548,37.04,0.46,255,36983,70,NULL,NULL,'2MASX J12052556+2944385',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000171,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,181.356416667,29.74408,0.026,NULL,58626444871,916038201,14313096,16.8),(88549,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88549,37.58,0.23,329,36984,70,NULL,NULL,'2MASX J12052556+5402313',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,181.3564583,54.04222,0,NULL,57211751519,893933617,13967712,18.1),(88550,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88550,36.8,0.46,229,36985,70,NULL,NULL,'2MASX J12052577+6308540',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000189,NULL,'17.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,181.3570417,63.14847,0.017,NULL,57315826308,895559786,13993121,17.1),(88551,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88551,37.7,0.16,347,36986,70,NULL,NULL,'2MASX J12052606+5129548',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000196,NULL,'18.0g',0.1,NULL,NULL,NULL,NULL,NULL,1,181.3585417,51.4985,0.007,NULL,57214929133,893983267,13968488,18),(88552,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88552,38.48,0.46,496,36987,70,NULL,NULL,'SDSS J120526.24+531302.1',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,181.359333333,53.21728,0,NULL,57217203257,894018800,13969043,18),(88553,'BCG','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88553,38.37,0.35,435,36988,60,NULL,'ABELL 1468, BCG','2MASX J12052655+5120228',0.0853,'1980ApJ...241..486H',1980,1,0.33,NULL,'G',0.000417,NULL,'16.8g',0.28,'E int?','Brightest group member',NULL,NULL,NULL,1,181.3605,51.33967,0.046,NULL,57214949294,893983582,13968493,16.8),(88554,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88554,37.7,0.16,347,36989,70,NULL,NULL,'SDSS J120526.74+512515.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,181.361416667,51.421,0.046,NULL,57214939333,893983427,13968491,17.8),(88555,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88555,38.08,0.46,414,36990,70,NULL,NULL,'2MASX J12052686+3945517',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000172,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,181.362,39.76447,0,NULL,58523640839,914431888,14287998,17.6),(88556,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88556,35.79,0.33,144,36991,70,NULL,NULL,'2MASX J12052744+1042048',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000176,NULL,'16.0g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,181.3645,10.70122,0,NULL,58200831720,909387995,14209187,16),(88557,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88557,37.7,0.16,347,36992,70,NULL,NULL,'2MASX J12052838+5124098',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,181.368167,51.40275,0.046,NULL,57214949427,893983584,13968493,17),(88558,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88558,37.7,0.16,347,36993,70,NULL,NULL,'2MASX J12052841+5128478',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00017,NULL,'16.3g',0.4,'BrClG',NULL,NULL,NULL,NULL,1,181.36825,51.47994,0.046,NULL,57214940325,893983442,13968491,16.3),(88559,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88559,37.62,0.46,334,36994,70,NULL,NULL,'2MASX J12052882+3812367',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,181.37,38.21011,0,NULL,58544771010,914762047,14293156,17.6),(88560,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88560,38.24,0.23,445,36995,70,NULL,NULL,'SDSS J120528.85+102328.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000138,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,181.37025,10.39114,0,NULL,58200528123,909383251,14209113,18.2),(88561,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88561,37.37,0.46,298,36996,70,NULL,NULL,'2MASX J12052889+2048208',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,181.370333,20.80589,0.031,NULL,58119906189,908123534,14189430,17.6),(88562,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88562,37.7,0.16,347,36997,70,NULL,NULL,'2MASX J12053094+5122288',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,181.379167,51.37472,0.046,NULL,57214957868,893983716,13968495,17.7),(88563,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88563,37.7,0.46,347,36998,70,NULL,NULL,'SDSS J120531.55+195007.9',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,181.3815,19.83556,0.025,NULL,58117599771,908087496,14188867,18.6),(88564,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88564,37.58,0.23,329,36999,70,NULL,NULL,'2MASX J12053170+5404523',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000186,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,181.381875,54.08122,0,NULL,57211763840,893933810,13967715,16.4),(88565,'IRAS','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88565,35.34,0.8,117,37000,75,NULL,'CF, r','UGC 07082',NULL,'1997ApJS..109..333W',1997,1,1.48,NULL,'G',0.000143,NULL,'14.7g',0.56,'Sb',NULL,NULL,NULL,NULL,1,181.383875,51.50456,0.046,NULL,57214974007,893983968,13968499,14.7),(88566,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88566,35.02,0.38,101,37000,75,NULL,'CF, r, raw','UGC 07082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88567,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88567,35.2,0.38,109,37000,75,NULL,'CF, r, inv','UGC 07082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88568,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88568,35.33,0.38,116,37000,75,NULL,'CF, r, cor','UGC 07082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88569,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88569,36.87,0.46,237,37001,70,NULL,NULL,'2MASX J12053249+4946298',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000167,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,181.3855,49.77478,0.023,NULL,57188629909,893572342,13962067,16.4),(88570,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88570,37.34,0.46,294,37002,70,NULL,NULL,'SDSS J120532.64+005837.7',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000057,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,181.386,0.97717,0.041,NULL,57985365184,906021331,14156583,17.8),(88571,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88571,34.96,0.41,98.1,37003,NULL,NULL,NULL,'ESO 440- G 048',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.5R',0.5,'Sb             HII',NULL,NULL,NULL,NULL,1,181.38675,-30.16103,0.213,NULL,43383501540,677867211,10591675,14.5),(88572,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88572,35,0.2,100,37003,74.4,NULL,NULL,'ESO 440- G 048',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88573,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88573,35.11,0.38,105,37003,NULL,NULL,'Malmquist cor.','ESO 440- G 048',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88574,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88574,36.61,0.46,210,37004,70,NULL,NULL,'2MASX J12053320+2635084',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000083,NULL,'15.9g',0.39,'Elliptical','Field galaxy',NULL,NULL,NULL,1,181.388416667,26.58578,0.038,NULL,58598038206,915594346,14306161,15.9),(88575,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88575,36.97,0.33,248,37005,70,NULL,NULL,'2MASX J12053340+5054418',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,181.3892917,50.91167,0.017,NULL,57232153365,894252396,13972693,17),(88576,'SNII optical','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 2009dd',NULL,88576,30.18,0.3,10.9,37006,NULL,NULL,'SCM','NGC 4088',NULL,'2015ApJ...799..215P',2015,1,5.8,NULL,'G',0.000004,NULL,'11.15',2.2,'SAB(rs)bc      HII','Probable group member',NULL,NULL,NULL,1,181.392458333,50.53903,0.012,NULL,57231681351,894245021,13972578,11.15),(88577,'SNII optical','2016-12-15 15:14:54','2016-12-16 11:20:03','1','SN 1991G',NULL,88577,31.7,0.36,21.8,37006,NULL,NULL,'SEAM','NGC 4088',0.002524,'2009ApJ...694.1067P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88578,'IRAS','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88578,30.86,0.8,14.9,37006,75,NULL,'A82, H','NGC 4088',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88579,'IRAS','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88579,30.87,0.8,14.9,37006,75,NULL,'W91CL, r','NGC 4088',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88580,'Sosies','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88580,30.93,0.07,15.3,37006,NULL,NULL,NULL,'NGC 4088',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88581,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88581,29.12,0.69,6.66,37006,100,NULL,'mid-IR','NGC 4088',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88582,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88582,30.38,NULL,11.9,37006,65.2,NULL,'CO','NGC 4088',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88583,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88583,30.43,NULL,12.2,37006,NULL,NULL,'B, Hubble-type-TF','NGC 4088',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88584,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88584,30.53,0.43,12.8,37006,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4088',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88585,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88585,30.64,0.43,13.4,37006,75,NULL,'3.6 micron, color corrected','NGC 4088',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88586,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88586,30.65,NULL,13.5,37006,NULL,NULL,'B','NGC 4088',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88587,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88587,30.66,NULL,13.6,37006,NULL,NULL,'B','NGC 4088',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88588,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88588,30.72,NULL,13.9,37006,NULL,NULL,'I, Hubble-type-TF','NGC 4088',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88589,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88589,30.77,0.35,14.3,37006,NULL,NULL,NULL,'NGC 4088',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88590,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88590,30.8,0.2,14.5,37006,74.4,NULL,NULL,'NGC 4088',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88591,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88591,30.85,NULL,14.8,37006,NULL,NULL,'I','NGC 4088',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88592,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88592,30.9,NULL,15.1,37006,NULL,NULL,'I','NGC 4088',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88593,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88593,30.89,NULL,15.1,37006,54,NULL,'HI','NGC 4088',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88594,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88594,30.91,0.38,15.2,37006,75,NULL,'W91CL, r, raw','NGC 4088',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88595,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88595,30.97,0.08,15.7,37006,NULL,NULL,NULL,'NGC 4088',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88596,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88596,31.04,0.38,16.1,37006,75,NULL,'W91CL, r, inv','NGC 4088',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88597,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88597,31.1,0.38,16.6,37006,75,NULL,'W91CL, r, cor','NGC 4088',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88598,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88598,31.12,0.47,16.7,37006,75,NULL,'A82, H, raw','NGC 4088',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88599,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88599,31.13,NULL,16.8,37006,NULL,NULL,'LEDA [April 2006]','NGC 4088',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88600,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88600,31.15,0.4,17,37006,75,NULL,'B','NGC 4088',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88601,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88601,31.24,0.47,17.7,37006,75,NULL,'A82, H, inv','NGC 4088',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88602,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88602,31.37,0.47,18.8,37006,75,NULL,'A82, H, cor','NGC 4088',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88603,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88603,37.08,0.46,261,37007,70,NULL,NULL,'2MASX J12053449+5543153',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000141,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,181.3937083,55.72075,0,NULL,57210995487,893921804,13967528,17.2),(88604,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88604,37.72,0.46,350,37008,70,NULL,NULL,'2MASX J12053482+2014017',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,181.3952917,20.23381,0.021,NULL,58119532037,908117688,14189338,18.2),(88605,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88605,34.68,0.49,86.3,37009,75,NULL,'IR','UGC 07080',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.00003,NULL,'15.53',0.2,'Sbc','Field galaxy',NULL,NULL,NULL,1,181.3962917,25.09714,0.051,NULL,58600374042,915630844,14306731,15.53),(88606,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88606,35.05,0.47,103,37009,NULL,NULL,'H','UGC 07080',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88607,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88607,35.19,0.4,109,37009,NULL,NULL,'mean','UGC 07080',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88608,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88608,35.19,0.45,109,37009,NULL,NULL,'K','UGC 07080',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88609,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88609,35.23,0.46,111,37009,NULL,NULL,'J','UGC 07080',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88610,'D-Sigma','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88610,33.04,0.4,40.5,37010,75,NULL,'Edat, raw','NGC 4087',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000043,NULL,'13.30',1.7,'SA0-:',NULL,NULL,NULL,NULL,1,181.397208333,-26.52264,0.493,NULL,43360287044,677504485,10586007,13.3),(88611,'D-Sigma','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88611,33.37,0.4,47.3,37010,75,NULL,'Edat, cor','NGC 4087',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88612,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88612,33.54,0.4,51.1,37010,NULL,NULL,'mean','NGC 4087',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88613,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88613,33.67,0.45,54.1,37010,NULL,NULL,'K','NGC 4087',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88614,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88614,38.19,0.46,434,37011,70,NULL,NULL,'2MASX J12053555+3438094',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,181.39825,34.63586,0,NULL,58539573744,914680839,14291888,17.6),(88615,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88615,37.71,0.46,349,37012,70,NULL,NULL,'2MASX J12053713+5121427',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000171,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,181.40475,51.36192,0.046,NULL,57214956164,893983690,13968495,17.2),(88616,'BCG','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88616,38.37,0.35,435,37013,60,NULL,NULL,'ABELL 1468',0.0853,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I:     [BM]',NULL,NULL,NULL,NULL,1,181.4089583,51.42172,0.046,NULL,57214944444,893983506,13968492,NULL),(88617,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88617,36.7,0.46,218,37014,70,NULL,NULL,'IC 2993',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000187,NULL,'15.6g',0.54,NULL,NULL,NULL,NULL,NULL,1,181.409708333,32.82219,0,NULL,58620136066,915939626,14311556,15.6),(88618,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88618,37.8,0.46,363,37015,70,NULL,NULL,'2MASX J12053885+4351309',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000146,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,181.411833,43.8585,0,NULL,58519617515,914369023,14287015,18),(88619,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88619,38.24,0.23,445,37016,70,NULL,NULL,'2MASX J12053945+1020348',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000166,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,181.414375,10.34303,0,NULL,58200529639,909383275,14209113,17.8),(88620,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88620,37.46,0.46,310,37017,70,NULL,NULL,'2MASX J12054017+4116547',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,181.4175417,41.28183,0,NULL,58525987491,914468554,14288571,17.8),(88621,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88621,38.24,0.23,445,37018,70,NULL,NULL,'2MASX J12054040+1022458',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,181.418333,10.37925,0,NULL,58200530574,909383290,14209113,17.1),(88622,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88622,36.23,0.46,176,37019,70,NULL,NULL,'2MASX J12054053+3728267',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,181.418875,37.47397,0,NULL,58547405747,914803214,14293800,17.1),(88623,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88623,35,0.16,100,37020,70,NULL,NULL,'CGCG 013-073',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000047,NULL,'15.3g',0.44,'E','Pair member (points to parent)',NULL,NULL,NULL,1,181.419417,1.5935,0.024,NULL,57997824928,906216014,14159625,15.3),(88624,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88624,37.27,0.46,285,37021,70,NULL,NULL,'SDSS J120541.35+090138.2',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000145,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,181.422333,9.02728,0,NULL,58018836011,906544312,14164754,17.1),(88625,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88625,37.38,0.17,300,37022,70,NULL,NULL,'SDSS J120542.01+482215.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000191,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,181.4250417,48.37089,0,NULL,57190979442,893609053,13962641,18.1),(88626,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88626,38.06,0.46,410,37023,70,NULL,NULL,'LCRS B120308.4-030627',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,181.426291667,-3.38567,0.097,NULL,42955255399,671175865,10487122,17.5),(88627,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88627,36.94,0.95,244,37024,70,NULL,NULL,'2MASX J12054508-4517155',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,181.437833333,-45.28756,0.385,NULL,46708719132,729823736,11403495,15.8),(88628,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88628,36.51,0.23,201,37025,70,NULL,NULL,'MCG +09-20-090',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000179,NULL,'15.8g',0.5,'S0',NULL,NULL,NULL,NULL,1,181.438291667,54.38719,0,NULL,57211700357,893932818,13967700,15.8),(88629,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88629,37.49,0.46,315,37026,70,NULL,NULL,'2MASX J12054620+2410046',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.0001,NULL,'17.37',0.23,NULL,NULL,NULL,NULL,NULL,1,181.442583,24.16803,0.03,NULL,58588714604,915448665,14303885,17.37),(88630,'IRAS','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88630,31.79,0.8,22.8,37027,75,NULL,'MAT, I','IC 2995',NULL,'1997ApJS..109..333W',1997,1,3.2,NULL,'G',0.00002,NULL,'12.88',1,'SB(s)c:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,181.4454583,-27.94014,0.337,NULL,43411397658,678303088,10598485,12.88),(88631,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88631,31.06,0.32,16.3,37027,85,NULL,'I, raw','IC 2995',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88632,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88632,31.06,0.32,16.3,37027,85,NULL,'I, inv','IC 2995',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88633,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88633,31.12,0.4,16.7,37027,NULL,NULL,NULL,'IC 2995',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88634,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88634,31.11,0.39,16.7,37027,73,NULL,'opt','IC 2995',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88635,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88635,31.29,0.43,18.1,37027,75,NULL,'MAT, I, raw','IC 2995',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88636,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88636,31.35,0.43,18.6,37027,75,NULL,'MAT, I, inv','IC 2995',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88637,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88637,31.4,0.47,19.1,37027,NULL,NULL,NULL,'IC 2995',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88638,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88638,31.42,0.47,19.2,37027,NULL,NULL,'H','IC 2995',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88639,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88639,31.44,0.2,19.4,37027,74.4,NULL,NULL,'IC 2995',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88640,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88640,31.46,0.49,19.6,37027,75,NULL,'IR','IC 2995',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88641,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88641,31.47,0.45,19.7,37027,NULL,NULL,'Malmquist cor.','IC 2995',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88642,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88642,31.56,0.43,20.5,37027,75,NULL,'MAT, I, cor','IC 2995',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88643,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88643,31.61,0.46,21,37027,NULL,NULL,'J','IC 2995',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88644,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88644,31.73,0.45,22.2,37027,NULL,NULL,'K','IC 2995',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88645,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88645,32.13,0.4,26.7,37027,75,NULL,'B','IC 2995',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88646,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88646,32.19,0.4,27.4,37027,NULL,NULL,'mean','IC 2995',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88647,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88647,36.87,0.23,236,37028,70,NULL,NULL,'2MASX J12054745+4326449',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,181.4477083,43.44589,0,NULL,58523080739,914423136,14287861,18.1),(88648,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88648,37.88,0.46,377,37029,70,NULL,NULL,'2MASX J12054806+0308368',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000078,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,181.4502917,3.14353,0,NULL,57993281863,906145029,14158516,17.8),(88649,'IRAS','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88649,32.26,0.8,28.3,37030,75,NULL,'MAT, I','IC 2996',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000017,NULL,'14.23',0.4,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,181.452625,-29.97192,0.213,NULL,43378842008,677794406,10590537,14.23),(88650,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88650,31.52,0.32,20.1,37030,85,NULL,'I, inv','IC 2996',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88651,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88651,31.54,0.32,20.3,37030,85,NULL,'I, raw','IC 2996',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88652,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88652,31.88,0.4,23.7,37030,75,NULL,NULL,'IC 2996',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88653,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88653,31.95,0.43,24.5,37030,75,NULL,'MAT, I, inv','IC 2996',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88654,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88654,31.95,0.43,24.6,37030,75,NULL,'MAT, I, raw','IC 2996',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88655,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88655,32.23,0.43,27.9,37030,75,NULL,'MAT, I, cor','IC 2996',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88656,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88656,32.36,0.49,29.7,37030,75,NULL,'IR','IC 2996',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88657,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88657,32.52,0.66,31.9,37030,NULL,NULL,NULL,'IC 2996',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88658,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88658,32.56,0.2,32.5,37030,74.4,NULL,NULL,'IC 2996',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88659,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88659,32.58,0.64,32.8,37030,NULL,NULL,'Malmquist cor.','IC 2996',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88660,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88660,32.71,0.4,34.8,37030,NULL,NULL,'mean','IC 2996',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88661,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88661,33,0.47,39.9,37030,NULL,NULL,'H','IC 2996',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88662,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88662,36.09,0.46,166,37031,70,NULL,NULL,'2MASX J12054901-0018543',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000058,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,181.4542083,-0.31514,0.041,NULL,42952265193,671129143,10486392,16.5),(88663,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88663,37.37,0.46,298,37032,70,NULL,NULL,'SDSS J120549.30+003224.7',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000069,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,181.455458333,0.54022,0.029,NULL,57983768243,905996378,14156193,17.5),(88664,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88664,37.88,0.27,376,37033,70,NULL,NULL,'2MASX J12054946+3924148',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00017,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,181.4560417,39.40419,0.067,NULL,58578260746,915285324,14301333,17.1),(88665,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88665,37.85,0.46,372,37034,70,NULL,NULL,'2MASX J12054981+0727058',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000143,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,181.4574583,7.45169,0,NULL,58031753827,906746153,14167908,17.5),(88666,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88666,36.92,0.46,242,37035,70,NULL,NULL,'2MASX J12055028+1435455',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,181.459583,14.59586,0.024,NULL,58144692998,908510828,14195481,17.5),(88667,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88667,37.88,0.27,376,37036,70,NULL,NULL,'2MASX J12055118+3925548',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000141,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,181.463375,39.43183,0.067,NULL,58578288892,915285763,14301340,17.5),(88668,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88668,37.7,0.16,347,37037,70,NULL,NULL,'2MASX J12055137+5128000',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00015,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,181.4640417,51.46669,0.046,NULL,57214935813,893983372,13968490,17.1),(88669,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88669,37.61,0.27,333,37038,70,NULL,NULL,'2MASX J12055144+3927138',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00013,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,181.4642083,39.45381,0.067,NULL,58578281471,915285647,14301338,18.4),(88670,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88670,35.24,0.11,112,37039,70,NULL,NULL,'NGC 4093',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000097,NULL,'14.52',0.25,'E?','Group member',NULL,NULL,NULL,1,181.4644583,20.52197,0.024,NULL,58120340611,908130322,14189536,14.52),(88671,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88671,37.14,0.46,267,37040,70,NULL,NULL,'2MASX J12055169+1944371',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000093,NULL,'16.64',0.29,NULL,NULL,NULL,NULL,NULL,1,181.465333,19.74378,0.022,NULL,58131482469,908304413,14192256,16.64),(88672,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88672,34.23,0.54,70.3,37041,70,NULL,NULL,'IC 0761',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00014,NULL,'15.43',0.2,NULL,NULL,NULL,NULL,NULL,1,181.47375,-12.67333,0.173,NULL,43052958444,672702475,10510976,15.43),(88673,'IRAS','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88673,31.41,0.8,19.1,37042,75,NULL,'A82, H','NGC 4094',NULL,'1997ApJS..109..333W',1997,1,4.2,NULL,'G',0.000013,NULL,'12.64',1.5,'SAB(rs)cd:',NULL,NULL,NULL,NULL,1,181.474833,-14.52642,0.085,NULL,43057826303,672778535,10512164,12.64),(88674,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88674,31.14,0.43,16.9,37042,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4094',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88675,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88675,31.31,0.47,18.3,37042,75,NULL,'A82, H, inv','NGC 4094',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88676,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88676,31.32,0.47,18.4,37042,75,NULL,'A82, H, raw','NGC 4094',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88677,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88677,31.53,0.46,20.2,37042,NULL,NULL,'J','NGC 4094',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88678,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88678,31.57,0.47,20.6,37042,75,NULL,'A82, H, cor','NGC 4094',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88679,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88679,31.57,0.47,20.6,37042,NULL,NULL,'H','NGC 4094',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88680,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88680,31.66,0.45,21.5,37042,NULL,NULL,'K','NGC 4094',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88681,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88681,31.84,0.4,23.3,37042,75,NULL,'B','NGC 4094',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88682,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88682,31.99,0.4,25,37042,NULL,NULL,'mean','NGC 4094',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88683,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88683,35.24,0.11,112,37043,70,NULL,NULL,'NGC 4095',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000083,NULL,'14.6',0.6,'E','Group member',NULL,NULL,NULL,1,181.475917,20.57253,0.031,NULL,58119831549,908122367,14189411,14.6),(88684,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88684,37.78,0.46,359,37044,70,NULL,NULL,'2MASX J12055472+2602486',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.54',0.11,NULL,NULL,NULL,NULL,NULL,1,181.478083,26.04694,0.059,NULL,58597687321,915588864,14306076,18.54),(88685,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88685,37.9,0.46,380,37045,70,NULL,NULL,'SDSS J120555.17+635231.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,181.479958333,63.8755,0,NULL,57318057174,895594643,13993666,17.9),(88686,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88686,37.61,0.27,333,37046,70,NULL,NULL,'SDSS J120555.20+393239.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,181.48,39.54431,0.067,NULL,58578274742,915285542,14301336,18.3),(88687,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88687,37.61,0.33,332,37047,70,NULL,NULL,'2MASX J12055522+2516076',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000107,NULL,'16.1g',0.39,'E','Field galaxy',NULL,NULL,NULL,1,181.480167,25.269,0.051,NULL,58600413146,915631455,14306741,16.1),(88688,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88688,38.24,0.27,445,37048,70,NULL,NULL,'2MASX J12055554+5130280',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,181.481375,51.50769,0.046,NULL,57214967598,893983868,13968497,17.9),(88689,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88689,37.45,0.46,309,37049,70,NULL,NULL,'2MASX J12055567+2223231',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,181.4817917,22.38981,0.04,NULL,58855227285,919612926,14368951,17.7),(88690,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88690,37.36,0.46,296,37050,70,NULL,NULL,'2MASX J12055561+3042503',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000171,NULL,'18.19',0.17,NULL,NULL,NULL,NULL,NULL,1,181.481833,30.71408,0,NULL,58634976569,916171508,14315179,18.19),(88691,'FP','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88691,37.93,0.46,386,37051,70,NULL,NULL,'2MASX J12055583+0629293',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,181.482583,6.49153,0,NULL,58021240725,906581886,14165341,17.4),(88692,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88692,32.27,0.4,28.4,37052,75,NULL,NULL,'UGC 07086',NULL,'2008Ap.....51..336K',2008,1,2.69,NULL,'G',0.000033,NULL,'15.10',0.38,'Sb','X-ray-bright group member',NULL,NULL,NULL,1,181.483833,77.50506,0.161,NULL,57012691513,890823304,13919114,15.1),(88693,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88693,32.28,0.43,28.6,37052,75,NULL,'3.6 micron, color + selection bias corrected','UGC 07086',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88694,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88694,32.34,0.43,29.4,37052,75,NULL,'3.6 micron, color corrected','UGC 07086',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88695,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88695,32.41,0.2,30.3,37052,74.4,NULL,NULL,'UGC 07086',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88696,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88696,32.58,0.4,32.8,37052,NULL,NULL,'mean','UGC 07086',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88697,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,'R',88697,32.69,0.49,34.5,37052,75,NULL,'IR','UGC 07086',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88698,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88698,32.8,0.47,36.3,37052,NULL,NULL,'H','UGC 07086',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88699,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88699,32.82,0.45,36.6,37052,NULL,NULL,'K','UGC 07086',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88700,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88700,32.82,0.46,36.7,37052,NULL,NULL,'J','UGC 07086',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88701,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88701,32.95,NULL,38.9,37052,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07086',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88702,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88702,32.95,NULL,38.9,37052,NULL,NULL,'Dipole + Quadrupole','UGC 07086',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88703,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:03','1',NULL,NULL,88703,32.96,NULL,39,37052,NULL,NULL,'Dipole','UGC 07086',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88704,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88704,36.03,0.27,160,37053,70,NULL,NULL,'2MASX J12055662+4009438',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000177,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,181.486083,40.16228,0,NULL,58526966176,914483846,14288810,16.4),(88705,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88705,37.15,0.46,269,37054,70,NULL,NULL,'2MASX J12055697+5546050',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000161,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,181.487375,55.76814,0.005,NULL,57211030145,893922346,13967536,17.1),(88706,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88706,34.36,0.5,74.5,37055,70,NULL,NULL,'MCG -02-31-015',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15',0.2,'poss. LINER',NULL,NULL,NULL,NULL,1,181.488291667,-12.664,0.173,NULL,43052961098,672702517,10510976,15),(88707,'IRAS','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88707,30.89,0.8,15.1,37056,75,NULL,'A82, H','UGC 07089',NULL,'1997ApJS..109..333W',1997,1,2.75,NULL,'G',0.000005,NULL,'14.0g',0.67,'Sdm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,181.490625,43.14336,0,NULL,58522947424,914421053,14287828,14),(88708,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88708,30.23,0.43,11.1,37056,75,NULL,'3.6 micron, color + selection bias corrected','UGC 07089',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88709,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88709,30.29,0.47,11.5,37056,75,NULL,'A82, H, inv','UGC 07089',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88710,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88710,30.32,0.43,11.6,37056,75,NULL,'3.6 micron, color corrected','UGC 07089',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88711,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88711,30.34,0.2,11.7,37056,74.4,NULL,NULL,'UGC 07089',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88712,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88712,30.39,0.35,12,37056,NULL,NULL,NULL,'UGC 07089',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88713,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88713,30.4,0.4,12,37056,73,NULL,'opt','UGC 07089',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88714,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88714,30.53,0.47,12.8,37056,75,NULL,'A82, H, raw','UGC 07089',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88715,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88715,30.85,0.47,14.8,37056,75,NULL,'A82, H, cor','UGC 07089',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88716,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88716,31.15,0.4,17,37056,75,NULL,'B','UGC 07089',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88717,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88717,37.58,0.23,329,37057,70,NULL,NULL,'SDSS J120559.13+540358.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,181.496417,54.06617,0,NULL,57211754566,893933665,13967713,18.4),(88718,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88718,37.03,0.46,255,37058,70,NULL,NULL,'2MASX J12055930+3805278',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.00011,NULL,'15.6g',0.5,NULL,NULL,NULL,NULL,NULL,1,181.497083,38.09108,0,NULL,58547747804,914808559,14293883,15.6),(88719,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88719,36.96,0.46,247,37059,70,NULL,NULL,'2MASX J12060008+5039220',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,181.500375,50.65625,0,NULL,57232254535,894253977,13972718,17.1),(88720,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88720,38.88,0.46,597,37060,70,NULL,NULL,'2MASX J12060098+1550045',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000169,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,181.504167,15.83458,0.131,NULL,58178699744,909042183,14203784,18.3),(88721,'IRAS','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88721,30.32,0.8,11.6,37061,75,NULL,'W91CL, r','NGC 4096',NULL,'1997ApJS..109..333W',1997,1,4.39,NULL,'G',0.000013,NULL,'12.3g',1.04,'SAB(rs)c       HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,181.5047083,47.47844,0,NULL,57179481680,893429401,13959834,12.3),(88722,'IRAS','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88722,30.33,0.8,11.6,37061,75,NULL,'A82, H','NGC 4096',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88723,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88723,29.72,0.4,8.8,37061,75,NULL,'B','NGC 4096',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88724,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88724,29.99,0.46,9.96,37061,NULL,NULL,'J','NGC 4096',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88725,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88725,30.03,0.47,10.1,37061,NULL,NULL,'H','NGC 4096',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88726,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88726,30.11,0.45,10.5,37061,NULL,NULL,'K','NGC 4096',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88727,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88727,30.16,0.4,10.8,37061,75,NULL,NULL,'NGC 4096',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88728,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88728,30.17,0.39,10.8,37061,73,NULL,'IR','NGC 4096',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88729,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88729,30.25,0.4,11.2,37061,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 4096',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88730,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88730,30.38,0.35,11.9,37061,NULL,NULL,NULL,'NGC 4096',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88731,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88731,30.41,0.43,12.1,37061,75,NULL,'3.6 micron, color corrected','NGC 4096',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88732,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88732,30.41,0.43,12.1,37061,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4096',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88733,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88733,30.46,0.2,12.4,37061,74.4,NULL,NULL,'NGC 4096',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88734,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88734,30.7,0.49,13.8,37061,75,NULL,'IR','NGC 4096',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88735,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88735,30.72,0.38,13.9,37061,75,NULL,'W91CL, r, raw','NGC 4096',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88736,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88736,30.8,0.47,14.4,37061,75,NULL,'A82, H, raw','NGC 4096',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88737,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88737,30.81,0.38,14.5,37061,75,NULL,'W91CL, r, inv','NGC 4096',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88738,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88738,30.87,0.47,14.9,37061,75,NULL,'A82, H, inv','NGC 4096',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88739,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88739,30.91,0.4,15.2,37061,NULL,NULL,'mean','NGC 4096',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88740,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88740,30.93,0.38,15.4,37061,75,NULL,'W91CL, r, cor','NGC 4096',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88741,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88741,30.98,0.11,15.7,37061,NULL,NULL,NULL,'NGC 4096',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88742,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88742,31.08,0.47,16.5,37061,75,NULL,'A82, H, cor','NGC 4096',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88743,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88743,37.88,0.27,376,37062,70,NULL,NULL,'SDSS J120601.11+392448.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000132,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,181.504625,39.4135,0.067,NULL,58578378937,915287170,14301362,18.4),(88744,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88744,36.05,0.48,162,37063,70,NULL,NULL,'ESO 217- G 023',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000147,NULL,'15.40',0.5,'N',NULL,NULL,NULL,NULL,1,181.505333,-49.73131,0.505,NULL,44568334500,696380226,10880941,15.4),(88745,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88745,37.64,0.46,337,37064,70,NULL,NULL,'2MASX J12060143+0443058',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,181.5059583,4.71828,0,NULL,58040447441,906881991,14170031,17.8),(88746,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88746,36.41,0.46,192,37065,70,NULL,NULL,'2MASX J12060170+3218153',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.43',0.14,NULL,NULL,NULL,NULL,NULL,1,181.507125,32.30439,0.009,NULL,58623262313,915988473,14312319,18.43),(88747,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88747,34.37,0.46,74.8,37066,70,NULL,NULL,'NGC 4097',NULL,'2015arXiv151105856S',2015,1,1.21,NULL,'G',0.00008,NULL,'14.1g',0.75,'S0',NULL,NULL,NULL,NULL,1,181.5104583,36.86367,0,NULL,58545454774,914772730,14293323,14.1),(88748,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88748,36.72,0.46,221,37067,70,NULL,NULL,'2MASX J12060257+1401235',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00017,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,181.510833,14.02331,0.022,NULL,58149321311,908583145,14196611,16.8),(88749,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88749,37.96,0.46,390,37068,70,NULL,NULL,'2MASX J12060299+5653590',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,181.512667,56.89983,0,NULL,57328155331,895752427,13996131,17.1),(88750,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88750,37.18,0.33,273,37069,70,NULL,NULL,'2MASX J12060314+5435270',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,181.513166667,54.59081,0,NULL,57211693130,893932705,13967698,17.2),(88751,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88751,37.61,0.33,332,37070,70,NULL,NULL,'SDSS J120603.28+251515.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,181.5137083,25.25428,0.051,NULL,58600422715,915631604,14306743,18.2),(88752,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88752,37.63,0.46,335,37071,70,NULL,NULL,'SDSS J120603.70+175535.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,181.5154583,17.92664,0.078,NULL,58121881409,908154397,14189912,18.5),(88753,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88753,34.91,0.47,95.9,37072,NULL,NULL,'H','NGC 4098',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'GPair',0.000037,NULL,NULL,NULL,'S?','in a radial-velocity based grouping',NULL,NULL,NULL,1,181.51625,20.60611,0.031,NULL,58119822663,908122229,14189409,NULL),(88754,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88754,34.98,0.46,99,37072,NULL,NULL,'J','NGC 4098',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88755,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88755,34.98,0.45,99,37072,NULL,NULL,'K','NGC 4098',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88756,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88756,35.2,0.4,110,37072,NULL,NULL,'mean','NGC 4098',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88757,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88757,37.45,0.33,309,37073,70,NULL,NULL,'2MASX J12060387+2242230',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.85',0.17,NULL,NULL,NULL,NULL,NULL,1,181.51625,22.7065,0.041,NULL,58855004255,919609441,14368897,17.85),(88758,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88758,38.28,0.33,452,37074,70,NULL,NULL,'2MASX J12060555+3244393',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,181.523083,32.74431,0,NULL,58620142271,915939722,14311558,18.3),(88759,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88759,38.24,0.27,445,37075,70,NULL,NULL,'2MASX J12060657+5130140',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,181.527375,51.50406,0.046,NULL,57214964159,893983814,13968497,17.2),(88760,'Tully est','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88760,32.05,0.8,25.7,37076,75,NULL,NULL,'UGCA 270',NULL,'1988NBGC.C....0000T',1988,1,2.9,NULL,'G',0.000007,NULL,'13.03',2.1,'SB(s)m pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,181.530083,-22.84939,0.205,NULL,43355741198,677433456,10584897,13.03),(88761,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88761,38.24,0.27,445,37077,70,NULL,NULL,'2MASX J12060744+5133330',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,181.531167,51.559,0.046,NULL,57214964790,893983824,13968497,17.3),(88762,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88762,38.28,0.33,452,37078,70,NULL,NULL,'2MASX J12060770+3245523',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000172,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,181.531917,32.7645,0,NULL,58620141856,915939716,14311558,16.9),(88763,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88763,36.03,0.27,160,37079,70,NULL,NULL,'CGCG 215-024',NULL,'2015arXiv151105856S',2015,1,0.94,NULL,'G',0.00016,NULL,'14.6g',0.67,NULL,NULL,NULL,NULL,NULL,1,181.532667,40.15069,0,NULL,58526994777,914484293,14288817,14.6),(88764,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88764,36.05,0.46,162,37080,70,NULL,NULL,'2MASX J12060799+3719329',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000179,NULL,'15.5g',0.51,NULL,NULL,NULL,NULL,NULL,1,181.533417,37.32594,0,NULL,58547442830,914803794,14293809,15.5),(88765,'IRAS','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88765,31.5,0.8,19.9,37081,75,NULL,'A82, H','NGC 4100',NULL,'1997ApJS..109..333W',1997,1,5.4,NULL,'G',0.000004,NULL,'11.89',1.8,'(R\')SA(rs)bc   HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,181.535208333,49.58269,0.033,NULL,57189117641,893579963,13962186,11.89),(88766,'IRAS','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88766,31.52,0.8,20.1,37081,75,NULL,'W91CL, r','NGC 4100',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88767,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88767,30.98,0.13,15.7,37081,NULL,NULL,NULL,'NGC 4100',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88768,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88768,31.1,NULL,16.6,37081,NULL,NULL,'B','NGC 4100',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88769,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88769,31.13,NULL,16.8,37081,NULL,NULL,'I','NGC 4100',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88770,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88770,31.15,0.4,17,37081,75,NULL,'B','NGC 4100',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88771,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88771,31.25,0.46,17.8,37081,NULL,NULL,'J','NGC 4100',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88772,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88772,31.27,NULL,17.9,37081,NULL,NULL,'I, Hubble-type-TF','NGC 4100',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88773,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88773,31.28,0.4,18,37081,NULL,NULL,'mean','NGC 4100',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88774,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88774,31.35,0.45,18.6,37081,NULL,NULL,'K','NGC 4100',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88775,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88775,31.37,0.4,18.8,37081,75,NULL,NULL,'NGC 4100',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88776,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88776,31.46,NULL,19.6,37081,NULL,NULL,'B, Hubble-type-TF','NGC 4100',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88777,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88777,31.47,0.35,19.7,37081,NULL,NULL,NULL,'NGC 4100',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88778,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88778,31.51,0.43,20.1,37081,75,NULL,'3.6 micron, color corrected','NGC 4100',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88779,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88779,31.54,0.2,20.3,37081,74.4,NULL,NULL,'NGC 4100',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88780,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88780,31.56,0.43,20.5,37081,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4100',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88781,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88781,31.61,NULL,21.1,37081,NULL,NULL,'I','NGC 4100',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88782,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88782,31.66,NULL,21.5,37081,NULL,NULL,'I','NGC 4100',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88783,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88783,31.7,NULL,21.9,37081,NULL,NULL,'B','NGC 4100',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88784,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88784,31.73,0.38,22.1,37081,75,NULL,'W91CL, r, raw','NGC 4100',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88785,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88785,31.73,0.49,22.1,37081,75,NULL,'IR','NGC 4100',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88786,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88786,31.75,NULL,22.4,37081,NULL,NULL,'B','NGC 4100',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88787,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88787,31.76,NULL,22.5,37081,NULL,NULL,'LEDA [Nov 2006]','NGC 4100',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88788,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88788,31.8,0.47,23,37081,75,NULL,'A82, H, raw','NGC 4100',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88789,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88789,31.84,0.38,23.4,37081,75,NULL,'W91CL, r, cor','NGC 4100',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88790,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88790,31.89,0.38,23.8,37081,75,NULL,'W91CL, r, inv','NGC 4100',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88791,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88791,31.96,0.47,24.7,37081,75,NULL,'A82, H, inv','NGC 4100',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88792,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88792,32.03,0.47,25.5,37081,75,NULL,'A82, H, cor','NGC 4100',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88793,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88793,36.48,0.46,198,37082,70,NULL,NULL,'2MASX J12060845+0710473',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000175,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,181.535208333,7.17969,0,NULL,58031667982,906744812,14167887,16.2),(88794,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88794,37.29,0.46,287,37083,70,NULL,NULL,'2MASX J12060943+3110023',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000199,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,181.5392917,31.16747,0.009,NULL,58620956926,915952451,14311757,16.3),(88795,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88795,38.62,0.46,529,37084,70,NULL,NULL,'2MASX J12060962+5535230',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,181.540166667,55.58975,0,NULL,57211026920,893922295,13967535,17.8),(88796,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88796,37.71,0.46,348,37085,70,NULL,NULL,'2MASX J12060974+3359002',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00016,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,181.540417,33.98331,0,NULL,58754361038,918036891,14344326,18.2),(88797,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88797,35.11,0.14,105,37086,70,NULL,NULL,'NGC 4101',NULL,'2015arXiv151105856S',2015,1,1,'Beers et al. (1995,AJ,109,874) give v = 8123 +/- 78 km/sec.','G',0.000103,NULL,'14.52',0.8,'S0/a','Field galaxy',NULL,NULL,'Emission-Line Galaxy',1,181.5440417,25.557,0.055,NULL,58595751788,915558621,14305603,14.52),(88798,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88798,29.6,0.2,8.32,37087,74.4,NULL,NULL,'UGC 07094',NULL,'2013AJ....146...86T',2013,1,1.32,NULL,'G',0.000005,NULL,'15.0g',0.53,'Sdm:','Group member',NULL,NULL,NULL,1,181.5447917,42.95581,0,NULL,58522255466,914410241,14287660,15),(88799,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88799,30.15,0.36,10.7,37087,NULL,NULL,NULL,'UGC 07094',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88800,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88800,30.15,0.39,10.7,37087,73,NULL,'opt','UGC 07094',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88801,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88801,37.8,0.46,363,37088,70,NULL,NULL,'SDSS J120610.71+052346.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,181.544625,5.39619,0,NULL,58040057782,906875902,14169935,17.9),(88802,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88802,37.94,0.46,388,37089,70,NULL,NULL,'2MASX J12061088+3207432',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000139,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,181.5455,32.12861,0.009,NULL,58623176933,915987139,14312299,17.9),(88803,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88803,38.13,0.46,422,37090,70,NULL,NULL,'2MASX J12061120+0452263',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000183,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,181.546791667,4.87411,0,NULL,58040532638,906883322,14170051,17.1),(88804,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88804,37.12,0.33,266,37091,70,NULL,NULL,'2MASX J12061249+2942502',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000184,NULL,'16.2g',0.39,'S0',NULL,NULL,NULL,NULL,1,181.552,29.71383,0.026,NULL,58626990766,916046730,14313230,16.2),(88805,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88805,37.12,0.33,266,37092,70,NULL,NULL,'2MASX J12061311+2940382',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000133,NULL,'17.4g',0.23,'E',NULL,NULL,NULL,NULL,1,181.554583,29.67733,0.026,NULL,58626991487,916046741,14313230,17.4),(88806,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88806,36.63,0.46,211,37093,70,NULL,NULL,'2MASX J12061425+1300440',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000199,NULL,'15.7g',0.44,'S0',NULL,NULL,NULL,NULL,1,181.559167,13.01236,0,NULL,58148996567,908578071,14196532,15.7),(88807,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88807,36.93,0.46,243,37094,70,NULL,NULL,'2MASX J12061431+3542312',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000167,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,181.559833333,35.70867,0,NULL,58549647029,914838234,14294347,16.7),(88808,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88808,36.37,0.46,188,37095,70,NULL,NULL,'2MASX J12061476+6254057',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,181.56125,62.90156,0.017,NULL,57315990591,895562352,13993161,16.7),(88809,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88809,38.6,0.46,525,37096,70,NULL,NULL,'2MASX J12061526+4644371',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000169,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,181.563667,46.74361,0,NULL,57180896638,893451509,13960179,18.4),(88810,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88810,36.98,0.33,249,37097,70,NULL,NULL,'2MASX J12061556+5025310',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000176,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,181.564833,50.42528,0.012,NULL,57231696693,894245260,13972582,16.5),(88811,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88811,37.56,0.46,326,37098,70,NULL,NULL,'2MASX J12061587+2456552',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.46',0.14,NULL,NULL,NULL,NULL,NULL,1,181.566208333,24.94881,0.061,NULL,58600339184,915630299,14306723,18.46),(88812,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88812,38.18,0.46,432,37099,70,NULL,NULL,'SDSS J120616.23+574122.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,181.567625,57.68969,0,NULL,57331734353,895808349,13997005,18.5),(88813,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88813,36.71,0.46,220,37100,70,NULL,NULL,'2MASX J12061695+4334232',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000158,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,181.57075,43.57306,0,NULL,58522425567,914412899,14287701,17.1),(88814,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88814,37.61,0.27,333,37101,70,NULL,NULL,'2MASX J12061827+3922133',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.69',0.17,NULL,NULL,NULL,NULL,NULL,1,181.576166667,39.37028,0.067,NULL,58578381704,915287214,14301362,17.69),(88815,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88815,36.6,0.17,209,37102,70,NULL,NULL,'2MASX J12061886+3924594',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,181.578375,39.41653,0.067,NULL,58578426945,915287921,14301373,16.9),(88816,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88816,35.29,0.47,114,37103,70,NULL,NULL,'AM 1203-275 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000133,NULL,'15',0.5,'(R\'_2)SB(s)b. LINER?',NULL,NULL,NULL,NULL,1,181.5787083,-28.19728,0.281,NULL,43411360322,678302505,10598476,15),(88817,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88817,37.41,0.46,303,37104,70,NULL,NULL,'2MASX J12061981+5305449',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000159,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,181.5827083,53.09597,0,NULL,57217237297,894019332,13969052,16.6),(88818,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88818,36.98,0.33,249,37105,70,NULL,NULL,'SDSS J120620.67+502852.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000141,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,181.586125,50.48114,0.012,NULL,57231730032,894245781,13972590,17.8),(88819,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88819,36.75,0.55,224,37106,70,NULL,NULL,'2MASX J12062156-1748374',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,181.58975,-17.81033,0.121,NULL,43027982280,672312223,10504878,15.1),(88820,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88820,38.03,0.46,403,37107,70,NULL,NULL,'2MASX J12062197+2038145',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,181.591667,20.63742,0.031,NULL,58118739461,908105304,14189145,17.7),(88821,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88821,37.52,0.46,319,37108,70,NULL,NULL,'2MASX J12062281+0128193',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00009,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,181.595125,1.47203,0.024,NULL,57997814720,906215855,14159622,16.6),(88822,'IRAS','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88822,31.14,0.8,16.9,37109,75,NULL,'W91CL, r','NGC 4102',NULL,'1997ApJS..109..333W',1997,1,2.81,NULL,'G',0.000007,NULL,'12.3g',1.17,'SAB(s)b?;HII   LINER','in a radial-velocity based grouping',NULL,NULL,'LINER',1,181.595791667,52.71108,0.013,NULL,57217749232,894027331,13969177,12.3),(88823,'IRAS','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88823,31.2,0.8,17.3,37109,75,NULL,'CF, r','NGC 4102',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88824,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88824,31.01,0.12,16,37109,NULL,NULL,NULL,'NGC 4102',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88825,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88825,31.06,0.45,16.3,37109,NULL,NULL,'K','NGC 4102',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88826,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88826,31.07,0.43,16.4,37109,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4102',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88827,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88827,31.15,0.4,17,37109,75,NULL,'B','NGC 4102',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88828,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88828,31.2,0.46,17.4,37109,NULL,NULL,'J','NGC 4102',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88829,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88829,31.3,0.43,18.2,37109,75,NULL,'3.6 micron, color corrected','NGC 4102',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88830,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88830,31.39,NULL,19,37109,NULL,NULL,'I','NGC 4102',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88831,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88831,31.39,0.4,19,37109,NULL,NULL,'mean','NGC 4102',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88832,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88832,31.41,0.35,19.1,37109,NULL,NULL,NULL,'NGC 4102',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88833,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88833,31.43,NULL,19.3,37109,NULL,NULL,'I, Hubble-type-TF','NGC 4102',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88834,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88834,31.52,0.38,20.2,37109,75,NULL,'W91CL, r, raw','NGC 4102',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88835,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88835,31.56,NULL,20.5,37109,NULL,NULL,'I','NGC 4102',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88836,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88836,31.57,NULL,20.6,37109,NULL,NULL,'B','NGC 4102',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88837,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88837,31.59,0.2,20.8,37109,74.4,NULL,NULL,'NGC 4102',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88838,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88838,31.65,0.38,21.4,37109,75,NULL,'W91CL, r, inv','NGC 4102',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88839,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88839,31.65,0.38,21.4,37109,75,NULL,'W91CL, r, cor','NGC 4102',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88840,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88840,31.68,NULL,21.7,37109,NULL,NULL,'B, Hubble-type-TF','NGC 4102',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88841,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88841,31.92,NULL,24.2,37109,NULL,NULL,'B','NGC 4102',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88842,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88842,32.12,0.38,26.6,37109,75,NULL,'CF, r, raw','NGC 4102',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88843,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88843,32.29,0.38,28.8,37109,75,NULL,'CF, r, inv','NGC 4102',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88844,'Tully-Fisher','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,NULL,88844,32.32,0.38,29.1,37109,75,NULL,'CF, r, cor','NGC 4102',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88845,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88845,37.45,0.46,310,37110,70,NULL,NULL,'2MASX J12062322+4234472',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000167,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,181.596625,42.57981,0,NULL,58520290181,914379534,14287180,16.8),(88846,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88846,37.7,0.16,347,37111,70,NULL,NULL,'2MASX J12062414+5109289',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000169,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,181.6007917,51.15794,0.013,NULL,57231894787,894248356,13972630,16.7),(88847,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88847,37.63,0.46,336,37112,70,NULL,NULL,'2MASX J12062462+2247475',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,181.602667,22.79669,0.041,NULL,58589711544,915464242,14304128,17.2),(88848,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88848,37.96,0.46,390,37113,70,NULL,NULL,'2MASX J12062464-0041003',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000089,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,181.6027917,-0.68347,0.021,NULL,42952581249,671134082,10486470,17.2),(88849,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88849,36.32,0.46,184,37114,70,NULL,NULL,'2MASX J12062489+5632519',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000155,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,181.603583,56.54767,0,NULL,57395730837,896808294,14012629,16.6),(88850,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88850,37.28,0.46,285,37115,70,NULL,NULL,'2MASX J12062497+4943218',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00018,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,181.603917,49.72267,0.023,NULL,57188640108,893572501,13962070,16.7),(88851,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88851,37.01,0.46,252,37116,70,NULL,NULL,'2MASX J12062502+3856594',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000165,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,181.604208333,38.94981,0,NULL,58578475560,915288680,14301385,16.5),(88852,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88852,37.06,0.46,258,37117,70,NULL,NULL,'2MASX J12062530+5805179',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000184,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,181.605667,58.08828,0,NULL,57331870325,895810473,13997038,16.7),(88853,'FP','2016-12-15 15:14:54','2016-12-16 11:20:04','1',NULL,'R',88853,38.75,0.46,563,37118,70,NULL,NULL,'2MASX J12062664+5847199',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,181.6112083,58.78886,0,NULL,57330494231,895788972,13996702,18.4),(88854,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88854,36.87,0.23,236,37119,70,NULL,NULL,'2MASX J12062681+4321532',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000173,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,181.611625,43.36478,0,NULL,58523016009,914422125,14287845,16.4),(88855,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88855,37.77,0.46,359,37120,70,NULL,NULL,'SDSS J120626.92+102106.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000129,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,181.612167,10.35183,0,NULL,58204019502,909437804,14209965,18.2),(88856,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88856,36.45,0.46,195,37121,70,NULL,NULL,'2MASX J12062797+3848354',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000156,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,181.616667,38.80997,0,NULL,58578117765,915283090,14301298,16.9),(88857,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88857,38.04,0.46,406,37122,70,NULL,NULL,'SDSS J120629.24-001020.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000073,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,181.621875,-0.17239,0.049,NULL,42952249662,671128900,10486389,18.2),(88858,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88858,36.64,0.46,212,37123,70,NULL,NULL,'2MASX J12062945+1606311',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000151,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,181.622875,16.10867,0.118,NULL,58178807509,909043867,14203810,16.7),(88859,'G Lens','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88859,42.08,NULL,2610,37124,NULL,NULL,'R(H) = ct','SDSS J1206+4332',NULL,'2014ApJ...788..190W',2014,1,NULL,NULL,'QSO',0.000478,NULL,'18.9g',NULL,'Candidate      QSO',NULL,NULL,NULL,'QSO',1,181.6235417,43.53822,0,NULL,58522536567,914414633,14287728,18.9),(88860,'G Lens','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88860,42.1,NULL,2630,37124,NULL,NULL,'Standard','SDSS J1206+4332',NULL,'2014ApJ...788..190W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88861,'G Lens','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88861,42.55,0.57,3230,37124,NULL,NULL,NULL,'SDSS J1206+4332',NULL,'2014MNRAS.437..600S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88862,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88862,37.72,0.46,350,37125,70,NULL,NULL,'2MASX J12062975+1914505',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000107,NULL,'17.87',0.19,NULL,NULL,NULL,NULL,NULL,1,181.623875,19.24722,0.011,NULL,58132113548,908314274,14192410,17.87),(88863,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88863,35.75,0.19,142,37126,70,NULL,NULL,'CGCG 158-022',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00008,NULL,'15.1g',0.54,'S0','Field galaxy',NULL,NULL,NULL,1,181.623916667,27.94992,0.028,NULL,58641251786,916269559,14316711,15.1),(88864,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88864,36.69,0.46,218,37127,70,NULL,NULL,'SDSS J120630.10+001054.5',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000074,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,181.625417,0.18181,0.013,NULL,57983880760,905998136,14156220,17.3),(88865,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88865,35.75,0.19,142,37128,70,NULL,NULL,'CGCG 158-023',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000083,NULL,'15.0g',0.58,'E','Group member',NULL,NULL,NULL,1,181.628625,28.13781,0.028,NULL,58641133900,916267717,14316683,15),(88866,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88866,38.33,0.46,464,37129,70,NULL,NULL,'2MASX J12063145+0700215',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,181.631,7.00589,0,NULL,58028774104,906699595,14167181,17.7),(88867,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88867,38.11,0.46,420,37130,70,NULL,NULL,'2MASX J12063155+3650365',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,181.631416667,36.8435,0,NULL,58545459813,914772809,14293325,17.8),(88868,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88868,37.87,0.46,375,37131,70,NULL,NULL,'2MASX J12063202+3127462',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000187,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,181.633458333,31.46303,0.016,NULL,58622760643,915980635,14312197,17.3),(88869,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88869,37.92,0.46,384,37132,70,NULL,NULL,'2MASX J12063208+0428503',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000136,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,181.6337083,4.48075,0,NULL,58040514095,906883032,14170047,17.5),(88870,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88870,37.39,0.27,301,37133,70,NULL,NULL,'SDSS J120632.30+221330.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,181.634625,22.22514,0.04,NULL,58857995185,919656174,14369627,18),(88871,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88871,37.39,0.27,301,37134,70,NULL,NULL,'4C +22.33',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.0003,NULL,'15.5',0.6,'E',NULL,NULL,NULL,NULL,1,181.6389583,22.26044,0.04,NULL,58857981302,919655957,14369624,15.5),(88872,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88872,37.18,0.33,273,37135,70,NULL,NULL,'2MASX J12063386+5441588',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,181.641125,54.69975,0,NULL,57213589104,893962329,13968161,17.5),(88873,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88873,35.03,0.49,101,37136,70,NULL,NULL,'2MASX J12063406-4354264',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.3I',0.5,NULL,NULL,NULL,NULL,NULL,1,181.642,-43.90731,0.485,NULL,43218402257,675287535,10551367,13.3),(88874,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88874,36.99,0.46,251,37137,70,NULL,NULL,'2MASX J12063436+5725168',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,181.643167,57.42139,0,NULL,57328130035,895752031,13996125,17.7),(88875,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88875,38.3,0.33,456,37138,70,NULL,NULL,'2MASX J12063446+2350185',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,181.643583,23.83836,0.049,NULL,58589218325,915456536,14304008,17.9),(88876,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88876,37.77,0.46,358,37139,70,NULL,NULL,'2MASX J12063444+1004375',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000177,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,181.643625,10.07697,0,NULL,58204081501,909438773,14209980,16.8),(88877,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88877,30.34,NULL,11.7,37140,NULL,NULL,NULL,'SDSS J120634.52+312034.7',NULL,'2013AJ....145..101K',2013,1,0.66,NULL,'G',0.00009,NULL,'15.8g',0.55,NULL,NULL,NULL,NULL,NULL,1,181.643833333,31.34297,0.016,NULL,58622792850,915981138,14312205,15.8),(88878,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88878,37.35,0.46,295,37141,70,NULL,NULL,'2MASX J12063658+6319272',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,181.652791667,63.32414,0.009,NULL,57318695145,895604611,13993822,17.6),(88879,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88879,37.43,0.46,307,37142,70,NULL,NULL,'2MASX J12063674+1620371',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.43',0.15,NULL,NULL,NULL,NULL,NULL,1,181.653,16.34381,0.118,NULL,58178533340,909039583,14203743,18.43),(88880,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88880,36.03,0.27,160,37143,70,NULL,NULL,'2MASX J12063735+4010365',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000182,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,181.6557917,40.17678,0,NULL,58527001219,914484394,14288818,16.6),(88881,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88881,38.46,0.46,492,37144,70,NULL,NULL,'2MASX J12063895+1305391',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,181.662166667,13.09419,0,NULL,58148954708,908577417,14196522,18),(88882,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88882,35.75,0.19,142,37145,70,NULL,NULL,'2MASX J12063981+2801324',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000163,NULL,'16.2g',0.3,NULL,'Field galaxy',NULL,NULL,NULL,1,181.66575,28.02553,0.028,NULL,58641302328,916270348,14316724,16.2),(88883,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88883,37.21,0.46,277,37146,70,NULL,NULL,'2MASX J12064012-0107235',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000073,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,181.6672083,-1.12342,0.033,NULL,42952325005,671130078,10486407,17.6),(88884,'SBF','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88884,32.12,0.17,26.5,37147,NULL,NULL,'I','NGC 4105',NULL,'2001ApJ...546..681T',2001,1,2.7,NULL,'G',0.000067,NULL,'11.6',2,'E3       poss. LINER','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,181.669875,-29.76022,0.237,NULL,43380640165,677822502,10590976,11.6),(88885,'SBF','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88885,32.12,0.17,26.5,37147,NULL,NULL,NULL,'NGC 4105',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88886,'SBF','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88886,32.13,0.14,26.7,37147,74.4,NULL,NULL,'NGC 4105',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88887,'SBF','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88887,32.16,0.17,27.1,37147,NULL,NULL,'Malmquist cor.','NGC 4105',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88888,'D-Sigma','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88888,31.74,0.4,22.3,37147,75,NULL,'Edat, raw','NGC 4105',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88889,'D-Sigma','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88889,32.04,0.4,25.6,37147,75,NULL,'Edat, cor','NGC 4105',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88890,'Faber-Jackson','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88890,32.05,NULL,25.7,37147,NULL,NULL,'LEDA [April 2006]','NGC 4105',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88891,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88891,32.37,0.41,29.7,37147,NULL,NULL,NULL,'NGC 4105',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88892,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88892,32.61,0.41,33.3,37147,NULL,NULL,'Malmquist cor.','NGC 4105',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88893,'Tully est','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88893,32.16,0.8,27.1,37147,75,NULL,'B','NGC 4105',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88894,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88894,32.21,0.4,27.6,37147,NULL,NULL,'mean','NGC 4105',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88895,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88895,32.48,0.45,31.3,37147,NULL,NULL,'K','NGC 4105',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88896,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88896,37.66,0.46,340,37148,70,NULL,NULL,'2MASX J12064097+4927076',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,181.670667,49.45206,0.033,NULL,57189329299,893583270,13962238,17.2),(88897,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88897,38.39,0.46,476,37149,70,NULL,NULL,'2MASX J12064137+4602432',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,181.6725417,46.04542,0,NULL,57177037764,893391215,13959237,17.4),(88898,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88898,36.87,0.23,236,37150,70,NULL,NULL,'2MASX J12064175+4321111',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000168,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,181.673917,43.35306,0,NULL,58523021964,914422218,14287847,17.7),(88899,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88899,38.3,0.46,457,37151,70,NULL,NULL,'SDSS J120643.20+481147.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,181.6800417,48.19661,0,NULL,57191402170,893615658,13962744,18.2),(88900,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88900,38.14,0.46,424,37152,70,NULL,NULL,'2MASX J12064335+2721174',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,181.680625,27.35489,0.038,NULL,58640928507,916264507,14316632,17.7),(88901,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88901,33.64,0.49,53.3,37153,75,NULL,'IR','UGC 07100',NULL,'2011yCatp016004901K',2011,1,1.85,NULL,'G',0.000023,NULL,'14.3g',0.47,'Sc I.5','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,181.685333333,17.71536,0.078,NULL,58121905945,908154780,14189918,14.3),(88902,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88902,33.91,0.2,60.5,37153,74.4,NULL,NULL,'UGC 07100',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88903,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88903,34.11,0.45,66.3,37153,NULL,NULL,NULL,'UGC 07100',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88904,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88904,34.11,0.45,66.4,37153,NULL,NULL,'Malmquist cor.','UGC 07100',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88905,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88905,34.2,0.47,69.1,37153,NULL,NULL,'H','UGC 07100',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88906,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88906,34.27,0.4,71.3,37153,NULL,NULL,'mean','UGC 07100',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88907,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88907,34.31,0.46,72.9,37153,NULL,NULL,'J','UGC 07100',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88908,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88908,34.39,0.45,75.6,37153,NULL,NULL,'K','UGC 07100',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88909,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88909,37.08,0.46,261,37154,70,NULL,NULL,'SDSS J120644.56+482050.5',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,181.6857083,48.34739,0,NULL,57191005098,893609454,13962647,17.6),(88910,'D-Sigma','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88910,31.74,0.4,22.3,37155,75,NULL,'Edat, raw','NGC 4106',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000057,NULL,'12.36',1.3,'SB(s)0+','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,181.686667,-29.76831,0.237,NULL,43378804224,677793816,10590528,12.36),(88911,'D-Sigma','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88911,32.04,0.4,25.6,37155,75,NULL,'Edat, cor','NGC 4106',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88912,'Faber-Jackson','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88912,30.76,0.63,14.2,37155,95,NULL,'Michard 1979b, c','NGC 4106',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88913,'Faber-Jackson','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88913,30.96,0.44,15.6,37155,95,NULL,'Weighted Mean','NGC 4106',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88914,'Faber-Jackson','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88914,31.44,0.46,19.4,37155,95,NULL,'Michard 1979a','NGC 4106',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88915,'Tully est','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88915,32.43,0.8,30.6,37155,75,NULL,'B','NGC 4106',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88916,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88916,37.59,0.46,329,37156,70,NULL,NULL,'2MASX J12064492+1332330',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,181.687333,13.54253,0.009,NULL,58149396275,908584316,14196629,18),(88917,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88917,37.03,0.33,255,37157,70,NULL,NULL,'MCG +08-22-069',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000103,NULL,'15.2g',0.64,'E0',NULL,NULL,NULL,NULL,1,181.68825,48.74775,0,NULL,57186672298,893541754,13961589,15.2),(88918,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88918,37.9,0.46,381,37158,70,NULL,NULL,'2MASX J12064602+5814549',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000155,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,181.6920417,58.24858,0,NULL,57330974197,895796471,13996819,16.9),(88919,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88919,36.99,0.46,250,37159,70,NULL,NULL,'2MASX J12064697+2321331',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.63',0.12,NULL,NULL,NULL,NULL,NULL,1,181.695833,23.35917,0.052,NULL,58587744805,915433512,14303648,18.63),(88920,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88920,35.64,0.46,135,37160,70,NULL,NULL,'2MASX J12064725+0117100',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000074,NULL,'15.9g',0.34,'SF',NULL,NULL,NULL,NULL,1,181.696791667,1.28606,0.028,NULL,57997313622,906208025,14159500,15.9),(88921,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88921,37.91,0.46,381,37161,70,NULL,NULL,'SDSS J120648.22+241928.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,181.700958333,24.32458,0.068,NULL,58601807368,915653240,14307081,18.2),(88922,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88922,37.03,0.33,255,37162,70,NULL,NULL,'2MASX J12064852+4845256',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000184,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,181.7019583,48.75703,0,NULL,57186668923,893541701,13961589,17.5),(88923,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88923,38.3,0.33,456,37163,70,NULL,NULL,'2MASX J12064846+2351381',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.15',0.18,NULL,NULL,NULL,NULL,NULL,1,181.702125,23.86064,0.08,NULL,58587381327,915427833,14303559,18.15),(88924,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88924,37.16,0.46,271,37164,70,NULL,NULL,'SDSS J120650.28+005536.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000056,NULL,'18.0g',0.18,'NLAGN',NULL,NULL,NULL,NULL,1,181.7095417,0.92692,0.037,NULL,57983624711,905994136,14156158,18),(88925,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88925,33.85,0.49,58.8,37165,75,NULL,'IR','MCG -02-31-017',NULL,'2011yCatp016004901K',2011,1,1.9,NULL,'G',0.00002,NULL,'14.50',0.3,'Scd: sp        HII',NULL,NULL,NULL,NULL,1,181.712917,-11.09442,0.165,NULL,43186166991,674783859,10543497,14.5),(88926,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88926,33.93,0.47,61.2,37165,NULL,NULL,'H','MCG -02-31-017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88927,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88927,33.94,0.2,61.4,37165,74.4,NULL,NULL,'MCG -02-31-017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88928,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88928,33.95,0.45,61.5,37165,NULL,NULL,'K','MCG -02-31-017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88929,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88929,34.08,0.35,65.5,37165,NULL,NULL,NULL,'MCG -02-31-017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88930,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88930,34.08,0.35,65.6,37165,NULL,NULL,'Malmquist cor.','MCG -02-31-017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88931,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88931,34.1,0.46,66.1,37165,NULL,NULL,'J','MCG -02-31-017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88932,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88932,34.12,0.4,66.6,37165,NULL,NULL,'mean','MCG -02-31-017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88933,'IRAS','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88933,32.81,0.8,36.5,37166,75,NULL,'MAT, I','ESO 379- G 027',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000017,NULL,'15.06',1,'Sc',NULL,NULL,NULL,NULL,1,181.721417,-36.27225,0.241,NULL,43266678139,676041845,10563153,15.06),(88934,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88934,32.98,0.2,39.5,37166,74.4,NULL,NULL,'ESO 379- G 027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88935,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88935,33.07,0.4,41.1,37166,NULL,NULL,NULL,'ESO 379- G 027',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88936,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88936,33.07,0.32,41.2,37166,85,NULL,'I, inv','ESO 379- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88937,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88937,33.08,0.32,41.3,37166,85,NULL,'I, raw','ESO 379- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88938,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88938,33.14,0.43,42.5,37166,75,NULL,'MAT, I, raw','ESO 379- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88939,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88939,33.15,0.43,42.7,37166,75,NULL,'MAT, I, inv','ESO 379- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88940,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88940,33.28,0.43,45.4,37166,75,NULL,'MAT, I, cor','ESO 379- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88941,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88941,37.26,0.46,283,37167,70,NULL,NULL,'2MASX J12065357+2712344',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000175,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,181.7232917,27.20947,0.038,NULL,58644281427,916316897,14317451,17),(88942,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88942,38.12,0.33,421,37168,70,NULL,NULL,'2MASX J12065400+2812594',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000186,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,181.724875,28.21656,0.035,NULL,58643976797,916312137,14317377,17.9),(88943,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88943,37.64,0.46,338,37169,70,NULL,NULL,'2MASX J12065481+4259511',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00019,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,181.728583,42.99769,0,NULL,58522283135,914410673,14287666,16.7),(88944,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88944,37.39,0.27,301,37170,70,NULL,NULL,'2MASX J12065533+2213301',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.37',0.16,NULL,NULL,NULL,NULL,NULL,1,181.7305,22.22511,0.04,NULL,58857989990,919656093,14369626,17.37),(88945,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88945,36.66,0.46,215,37171,70,NULL,NULL,'2MASX J12065540+1230240',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000174,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,181.7309583,12.50672,0,NULL,58148285677,908566963,14196358,17.1),(88946,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88946,36.37,0.46,188,37172,70,NULL,NULL,'2MASX J12065582+3005143',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000181,NULL,'16.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,181.732541667,30.08731,0.032,NULL,58634554867,916164919,14315076,16.9),(88947,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88947,38.3,0.23,456,37173,70,NULL,NULL,'2MASX J12065619+4643051',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,181.734333,46.71797,0,NULL,57180773928,893449592,13960149,18),(88948,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88948,36.95,0.33,245,37174,70,NULL,NULL,'2MASX J12065663+5655259',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,181.736208333,56.92383,0,NULL,57395499421,896804678,14012573,17.4),(88949,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88949,38.29,0.46,454,37175,70,NULL,NULL,'2MASX J12065815+1316100',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,181.742167,13.26961,0.009,NULL,58149697445,908589022,14196703,17.7),(88950,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88950,38.05,0.46,408,37176,70,NULL,NULL,'2MASX J12065824+4758486',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000198,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,181.742791667,47.98028,0,NULL,57191205868,893612591,13962696,17.7),(88951,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88951,37.24,0.33,281,37177,70,NULL,NULL,'SDSS J120659.27+013015.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000067,NULL,'18.6g',0.09,NULL,NULL,NULL,NULL,NULL,1,181.746958333,1.50433,0.057,NULL,57998031087,906219235,14159675,18.6),(88952,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88952,38.12,0.33,421,37178,70,NULL,NULL,'2MASX J12065945+2814424',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000174,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,181.747833333,28.24525,0.035,NULL,58643978929,916312170,14317377,16.9),(88953,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88953,37.63,0.46,335,37179,70,NULL,NULL,'2MASX J12065950+3546453',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00018,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,181.747875,35.77928,0,NULL,58549839059,914841235,14294394,17.2),(88954,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88954,38.14,0.46,425,37180,70,NULL,NULL,'2MASX J12065969+4704422',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,181.7487917,47.07836,0,NULL,57180135026,893439609,13959993,17.4),(88955,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88955,36.31,0.46,183,37181,70,NULL,NULL,'2MASX J12070007+6226163',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00018,NULL,'16.0g',0.33,'E0',NULL,NULL,NULL,NULL,1,181.749916667,62.438,0,NULL,57370281529,896410648,14006416,16),(88956,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88956,35.66,0.46,136,37182,70,NULL,NULL,'SDSS J120700.50+352709.0',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000156,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,181.752083,35.45253,0,NULL,58538341769,914661590,14291587,16.9),(88957,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88957,37.24,0.33,281,37183,70,NULL,NULL,'2MASX J12070073+0129510',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00008,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,181.7530417,1.4975,0.057,NULL,57998030901,906219232,14159675,16.1),(88958,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88958,35.62,0.49,133,37184,75,NULL,'IR','FGC 1367',NULL,'2011yCatp016004901K',2011,1,1.18,NULL,'G',0.000154,NULL,'16.2g',0.2,'Sc',NULL,NULL,NULL,NULL,1,181.761875,40.19983,0,NULL,58526909169,914482955,14288796,16.2),(88959,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88959,36.03,NULL,161,37184,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1367',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88960,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88960,36.05,NULL,162,37184,NULL,NULL,'Dipole + Quadrupole','FGC 1367',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88961,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88961,36.07,NULL,163,37184,NULL,NULL,NULL,'FGC 1367',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88962,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88962,36.08,NULL,164,37184,NULL,NULL,'Dipole','FGC 1367',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88963,'SBF','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88963,29.9,0.12,9.55,37185,74.4,NULL,NULL,'NGC 4111',NULL,'2013AJ....146...86T',2013,1,4.6,NULL,'G',0.000017,NULL,'11.63',1,'SA(r)0+: sp;HIILINER','Probable group member',NULL,NULL,NULL,1,181.763041667,43.06572,0,NULL,58522172682,914408948,14287639,11.63),(88964,'SBF','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88964,30.88,0.23,15,37185,NULL,NULL,'I','NGC 4111',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88965,'Faber-Jackson','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88965,30.15,0.77,10.7,37185,95,NULL,'de Vaucouleurs','NGC 4111',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88966,'Faber-Jackson','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88966,30.24,0.5,11.2,37185,95,NULL,'Weighted Mean','NGC 4111',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88967,'Faber-Jackson','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88967,31.36,0.81,18.7,37185,55,NULL,'Visvanathan & Sandage 1979','NGC 4111',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88968,'Tertiary','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88968,29.78,0.2,9.04,37185,95,NULL,NULL,'NGC 4111',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88969,'Tully est','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88969,31.15,0.8,17,37185,75,NULL,'B','NGC 4111',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88970,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88970,29.28,0.49,7.17,37185,75,NULL,'IR','NGC 4111',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88971,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88971,29.9,0.12,9.55,37185,74.4,NULL,NULL,'NGC 4111',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88972,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88972,30.09,0.45,10.4,37185,NULL,NULL,'K','NGC 4111',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88973,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88973,31.48,0.4,19.8,37185,NULL,NULL,'mean','NGC 4111',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88974,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88974,34.06,NULL,65,37186,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 128-031 NED02',NULL,'2010Ap&SS.325..163P',2010,1,1.12,NULL,'G',0.000053,NULL,'16.5',0.11,'Scd',NULL,NULL,NULL,NULL,1,181.7639583,25.72947,0.056,NULL,58597103731,915579745,14305933,16.5),(88975,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88975,34.09,NULL,65.7,37186,NULL,NULL,'Dipole','CGCG 128-031 NED02',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88976,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88976,34.09,NULL,65.8,37186,NULL,NULL,'Dipole + Quadrupole','CGCG 128-031 NED02',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88977,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88977,34.31,0.49,72.8,37186,75,NULL,'IR','CGCG 128-031 NED02',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88978,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88978,35.01,0.31,100,37187,NULL,NULL,'Malmquist cor.','NGC 4110',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.00003,NULL,'14.49',0.7,'SBb            RET',NULL,NULL,NULL,NULL,1,181.764375,18.53172,0.028,NULL,58132514329,908320536,14192508,14.49),(88979,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88979,35.16,0.47,108,37187,NULL,NULL,'H','NGC 4110',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88980,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88980,35.19,0.4,109,37187,NULL,NULL,'mean','NGC 4110',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88981,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88981,35.25,0.46,112,37187,NULL,NULL,'J','NGC 4110',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88982,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88982,35.28,0.45,114,37187,NULL,NULL,'K','NGC 4110',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88983,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88983,35.37,0.27,119,37187,NULL,NULL,NULL,'NGC 4110',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88984,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,88984,35.41,0.2,121,37187,74.4,NULL,NULL,'NGC 4110',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(88985,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88985,37.08,0.46,260,37188,70,NULL,NULL,'SDSS J120703.78+540939.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,181.7657917,54.16089,0,NULL,57225616297,894150254,13971097,18.1),(88986,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88986,38.42,0.33,484,37189,70,NULL,NULL,'2MASX J12070390+0738207',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,181.766166667,7.63911,0,NULL,58032301706,906754714,14168042,18.1),(88987,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88987,37.27,0.46,284,37190,70,NULL,NULL,'2MASX J12070416+5642439',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000161,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,181.767333333,56.71236,0,NULL,57395746594,896808540,14012633,17),(88988,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88988,37.94,0.46,388,37191,70,NULL,NULL,'2MASX J12070418+0011050',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000071,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,181.767625,0.18478,0,NULL,57983717581,905995587,14156181,17.5),(88989,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88989,38.52,0.46,505,37192,70,NULL,NULL,'2MASX J12070470+2217481',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.47',0.15,NULL,NULL,NULL,NULL,NULL,1,181.769417,22.29667,0.04,NULL,58858123762,919658183,14369659,18.47),(88990,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88990,38.28,0.46,453,37193,70,NULL,NULL,'2MASX J12070598+3756235',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,181.774958333,37.93983,0,NULL,58547732329,914808317,14293879,18.1),(88991,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88991,37.77,0.46,358,37194,70,NULL,NULL,'2MASX J12070651+5559199',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,181.7772083,55.98886,0,NULL,57210941979,893920968,13967515,17.1),(88992,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88992,36.95,0.33,245,37195,70,NULL,NULL,'2MASX J12070689+5655229',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000196,NULL,'15.8g',0.41,'E0',NULL,NULL,NULL,NULL,1,181.77875,56.92311,0,NULL,57395502854,896804732,14012573,15.8),(88993,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88993,37.91,0.33,381,37196,70,NULL,NULL,'2MASX J12070724+1630019',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.19',0.14,NULL,NULL,NULL,NULL,NULL,1,181.7802917,16.50053,0.114,NULL,58178663470,909041616,14203775,18.19),(88994,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88994,38.08,0.23,412,37197,70,NULL,NULL,'B2 1204+24',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'15.2',0.2,'BrClG;E',NULL,NULL,NULL,NULL,1,181.7807083,23.90692,0.08,NULL,58587411834,915428309,14303567,15.2),(88995,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88995,38.08,0.23,412,37198,70,NULL,NULL,'SDSS J120707.49+240158.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,181.78125,24.033,0.08,NULL,58587358915,915427483,14303554,18.3),(88996,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88996,37.97,0.33,393,37199,70,NULL,NULL,'2MASX J12070766+5134515',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,181.781917,51.581,0.019,NULL,57214980394,893984068,13968501,17.4),(88997,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88997,37.38,0.33,300,37200,70,NULL,NULL,'SDSS J120708.28+523338.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000171,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,181.7845417,52.56078,0,NULL,57217744838,894027263,13969175,18.1),(88998,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88998,37.37,0.46,297,37201,70,NULL,NULL,'2MASX J12070859+2530274',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.47',0.14,NULL,NULL,NULL,NULL,NULL,1,181.785916667,25.50764,0.056,NULL,58598898209,915607784,14306371,18.47),(88999,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',88999,37.19,0.46,274,37202,70,NULL,NULL,'2MASX J12070860+3111473',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.0002,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,181.785916667,31.19658,0.009,NULL,58622215074,915972110,14312064,16.2),(89000,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89000,37.73,0.46,352,37203,70,NULL,NULL,'2MASX J12070882+0024229',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000082,NULL,'17.4g',0.21,'NLAGN',NULL,NULL,NULL,NULL,1,181.786916667,0.40642,0,NULL,57984125668,906001963,14156280,17.4),(89001,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89001,36.71,0.46,220,37204,70,NULL,NULL,'2MASX J12070977+2450404',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000093,NULL,'16.1g',0.4,'E','Field galaxy',NULL,NULL,NULL,1,181.790667,24.84447,0.061,NULL,58602628187,915666065,14307282,16.1),(89002,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89002,34.37,0.2,74.8,37205,74.4,NULL,NULL,'IC 3004',NULL,'2013AJ....146...86T',2013,1,0.76,NULL,'G',0.000099,NULL,'16.0g',0.58,'Scd',NULL,NULL,NULL,NULL,1,181.792667,13.24753,0.009,NULL,58149656070,908588376,14196693,16),(89003,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89003,37.23,0.46,279,37206,70,NULL,NULL,'SDSS J120710.41+600836.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000164,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,181.7934583,60.14358,0,NULL,57337563506,895899429,13998428,18.4),(89004,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89004,38.55,0.46,512,37207,70,NULL,NULL,'2MASX J12071129+1941110',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,181.797167,19.68636,0.023,NULL,58130225357,908284771,14191949,NULL),(89005,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89005,38.3,0.23,456,37208,70,NULL,NULL,'2MASX J12071145+4645372',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000176,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,181.797625,46.76039,0,NULL,57180779457,893449679,13960151,18),(89006,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89006,38.08,0.23,412,37209,70,NULL,NULL,'2MASX J12071166+2352275',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,181.7985417,23.87442,0.08,NULL,58587400974,915428140,14303564,17.5),(89007,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89007,37.66,0.46,340,37210,70,NULL,NULL,'2MASX J12071201+5603219',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00017,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,181.7999583,56.05594,0,NULL,57395277501,896801210,14012518,17),(89008,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89008,35.75,0.19,142,37211,70,NULL,NULL,'2MASX J12071220+2821019',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000113,NULL,'16.0g',0.32,'S0','Field galaxy',NULL,NULL,NULL,1,181.80075,28.35044,0.035,NULL,58642926682,916295729,14317120,16),(89009,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89009,33.82,0.47,58.2,37212,70,NULL,NULL,'NGC 4114',NULL,'2014MNRAS.445.2677S',2014,1,1.9,NULL,'G',0.0001,NULL,'13.97',0.9,'(R\')SAB(rs)a:',NULL,NULL,NULL,NULL,1,181.8012083,-14.18547,0.085,NULL,43056055953,672750874,10511732,13.97),(89010,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89010,33.97,0.4,62.3,37212,NULL,NULL,'mean','NGC 4114',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89011,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89011,34.04,0.45,64.2,37212,NULL,NULL,'K','NGC 4114',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89012,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89012,34.04,0.47,64.4,37212,NULL,NULL,'H','NGC 4114',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89013,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89013,34.05,0.46,64.6,37212,NULL,NULL,'J','NGC 4114',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89014,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89014,38.72,0.46,556,37213,70,NULL,NULL,'2MASX J12071244+6457493',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,181.8020417,64.96364,0.033,NULL,57326520817,895726887,13995732,18.2),(89015,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89015,36.9,0.46,240,37214,70,NULL,NULL,'2MASX J12071271+2657409',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'16.6g',0.32,NULL,'Field galaxy',NULL,NULL,NULL,1,181.802875,26.96131,0.031,NULL,58642150460,916283600,14316931,16.6),(89016,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89016,38.5,0.46,500,37215,70,NULL,NULL,'2MASX J12071275+5348138',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000178,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,181.8029583,53.80372,0,NULL,57226017115,894156517,13971195,17.5),(89017,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89017,37.04,0.46,255,37216,70,NULL,NULL,'2MASX J12071272+1353019',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000168,NULL,'16.9g',0.28,'AGN',NULL,NULL,NULL,NULL,1,181.803083,13.88394,0.01,NULL,58145929858,908530154,14195783,16.9),(89018,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89018,38.3,0.23,456,37217,70,NULL,NULL,'2MASX J12071408+4644042',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000186,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,181.80875,46.73456,0,NULL,57180801238,893450019,13960156,17.4),(89019,'IRAS','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89019,31.57,0.8,20.6,37218,75,NULL,'MAT, I','IC 3005',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.000007,NULL,'13.77',0.4,'SBcd? sp       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,181.8090417,-30.02464,0.197,NULL,43385388920,677896701,10592135,13.77),(89020,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89020,31.8,0.43,23,37218,75,NULL,'3.6 micron, color + selection bias corrected','IC 3005',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89021,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89021,31.86,0.4,23.6,37218,75,NULL,NULL,'IC 3005',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89022,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89022,31.93,0.4,24.3,37218,NULL,NULL,NULL,'IC 3005',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89023,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89023,31.95,0.32,24.6,37218,85,NULL,'I, raw','IC 3005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89024,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89024,31.96,0.32,24.7,37218,85,NULL,'I, inv','IC 3005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89025,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89025,32.03,0.43,25.5,37218,75,NULL,'3.6 micron, color corrected','IC 3005',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89026,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89026,32.09,0.43,26.1,37218,75,NULL,'MAT, I, raw','IC 3005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89027,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89027,32.17,0.43,27.2,37218,75,NULL,'MAT, I, inv','IC 3005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89028,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89028,32.21,0.2,27.7,37218,74.4,NULL,NULL,'IC 3005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89029,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89029,32.34,0.53,29.3,37218,NULL,NULL,'Malmquist cor.','IC 3005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89030,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89030,32.33,0.53,29.3,37218,NULL,NULL,NULL,'IC 3005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89031,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89031,32.36,0.43,29.6,37218,75,NULL,'MAT, I, cor','IC 3005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89032,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89032,32.67,0.49,34.2,37218,75,NULL,'IR','IC 3005',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89033,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89033,37.12,0.46,265,37219,70,NULL,NULL,'2MASX J12071463+5142009',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000177,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,181.8110417,51.70028,0.019,NULL,57215005767,893984465,13968507,16.8),(89034,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89034,37.27,0.46,284,37220,70,NULL,NULL,'2MASX J12071534+0749197',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,181.813917,7.82225,0,NULL,58031519704,906742495,14167851,17.7),(89035,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89035,38.42,0.33,484,37221,70,NULL,NULL,'SDSS J120715.53+073455.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000145,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,181.81475,7.58217,0,NULL,58032329201,906755143,14168049,18.2),(89036,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89036,35.11,0.14,105,37222,70,NULL,NULL,'2MASX J12071580+2517069',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.0001,NULL,'17.52',0.19,NULL,NULL,NULL,NULL,NULL,1,181.81575,25.28536,0.056,NULL,58602343194,915661612,14307212,17.52),(89037,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89037,37.61,0.46,333,37223,70,NULL,NULL,'2MASX J12071623+1950215',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.11',0.14,NULL,NULL,NULL,NULL,NULL,1,181.8177083,19.83925,0.025,NULL,58118928539,908108258,14189191,18.11),(89038,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89038,36.87,0.23,236,37224,70,NULL,NULL,'2MASX J12071642+4310232',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000172,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,181.8184583,43.17328,0,NULL,58523046064,914422594,14287853,16.4),(89039,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89039,37.92,0.46,384,37225,70,NULL,NULL,'2MASX J12071672+4654192',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,181.819833333,46.90542,0,NULL,57180063899,893438498,13959976,17.1),(89040,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89040,37.91,0.33,381,37226,70,NULL,NULL,'2MASX J12071678+1628158',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,181.820041667,16.47122,0.114,NULL,58178659866,909041560,14203774,17.7),(89041,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89041,37.12,0.27,266,37227,70,NULL,NULL,'2MASX J12071738+2049135',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.25',0.17,NULL,NULL,NULL,NULL,NULL,1,181.8225417,20.82039,0.025,NULL,58118677542,908104336,14189130,18.25),(89042,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89042,37.63,0.46,336,37228,70,NULL,NULL,'2MASX J12071813+1025206',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000137,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,181.8255417,10.42225,0,NULL,58204312493,909442382,14210037,17.3),(89043,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89043,38.2,0.33,438,37229,70,NULL,NULL,'SDSS J120718.32+613247.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000153,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,181.826375,61.54647,0,NULL,57336776791,895887137,13998236,18.5),(89044,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89044,37.12,0.27,266,37230,70,NULL,NULL,'2MASX J12071837+2044505',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.78',0.2,'AGN',NULL,NULL,NULL,NULL,1,181.8265,20.74747,0.025,NULL,58118853739,908107089,14189173,17.78),(89045,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89045,35.75,0.19,142,37231,70,NULL,NULL,'2MASX J12071849+2814469',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000103,NULL,'15.5g',0.37,'E','Field galaxy',NULL,NULL,NULL,1,181.827125,28.24642,0.035,NULL,58643982858,916312232,14317378,15.5),(89046,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89046,37.69,0.46,345,37232,70,NULL,NULL,'2MASX J12072025+1243448',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000174,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,181.834416667,12.72922,0,NULL,58149011506,908578304,14196536,17.4),(89047,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89047,37.79,0.46,361,37233,70,NULL,NULL,'2MASX J12072098+1949494',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00018,NULL,'17.01',0.23,NULL,NULL,NULL,NULL,NULL,1,181.837375,19.83036,0.025,NULL,58118915963,908108061,14189188,17.01),(89048,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89048,37.12,0.27,266,37234,70,NULL,NULL,'2MASX J12072094+2045034',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.17',0.16,'AGN',NULL,NULL,NULL,NULL,1,181.8375,20.75097,0.025,NULL,58118861692,908107213,14189175,18.17),(89049,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89049,37.38,0.33,300,37235,70,NULL,NULL,'2MASX J12072179+5235249',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000176,NULL,'16.1g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,181.840666667,52.59014,0,NULL,57217735253,894027113,13969173,16.1),(89050,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89050,37.39,0.46,301,37236,70,NULL,NULL,'2MASX J12072359+1026029',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000164,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,181.848167,10.434,0,NULL,58204315231,909442425,14210037,16.3),(89051,'Tully est','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89051,31.22,0.8,17.5,37237,75,NULL,NULL,'UGCA 271',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.00002,NULL,'15.20',1.1,'Im:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,181.848333,39.81278,0.036,NULL,58526804973,914481327,14288770,15.2),(89052,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89052,38.2,0.33,438,37238,70,NULL,NULL,'SDSS J120725.07+613251.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00016,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,181.8544583,61.54758,0,NULL,57336777619,895887150,13998236,18.4),(89053,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89053,37.97,0.46,392,37239,70,NULL,NULL,'SDSS J120725.19+595757.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00014,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,181.855,59.96589,0,NULL,57337647915,895900748,13998449,18.5),(89054,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89054,37.58,0.46,328,37240,70,NULL,NULL,'2MASX J12072553+2513259',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000103,NULL,'17.84',0.18,NULL,NULL,NULL,NULL,NULL,1,181.856583,25.22397,0.056,NULL,58602311828,915661122,14307205,17.84),(89055,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89055,36.93,0.46,243,37241,70,NULL,NULL,'2MASX J12072601+0132439',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000075,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,181.8585,1.54558,0.057,NULL,57997915592,906217431,14159647,17.1),(89056,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89056,35.35,0.46,118,37242,70,NULL,NULL,'CGCG 041-040',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000073,NULL,'15.3g',0.52,'E',NULL,NULL,NULL,NULL,1,181.862,6.35411,0,NULL,58021296148,906582752,14165355,15.3),(89057,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89057,36.58,0.46,207,37243,70,NULL,NULL,'2MASX J12072735+5745322',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000188,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,181.864167,57.75903,0,NULL,57331711744,895807996,13996999,16.2),(89058,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89058,37.15,0.46,269,37244,70,NULL,NULL,'2MASX J12072808+3624485',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000175,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,181.8669583,36.41344,0,NULL,58550024007,914844125,14294439,17.2),(89059,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89059,36.59,0.46,208,37245,70,NULL,NULL,'2MASX J12072854+4038105',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00018,NULL,'16.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,181.869083,40.63639,0,NULL,58526451814,914475809,14288684,16.2),(89060,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89060,37.53,0.33,320,37246,70,NULL,NULL,'SDSS J120729.28+261559.2',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.1g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,181.872041667,26.26644,0.048,NULL,58597319614,915583118,14305986,17.1),(89061,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89061,37.76,0.23,356,37247,70,NULL,NULL,'2MASX J12072997+4413311',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000195,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,181.875041667,44.22522,0,NULL,59056113385,922751771,14417996,16.7),(89062,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89062,37.15,0.46,269,37248,70,NULL,NULL,'VII Zw 440',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,181.877083,56.74828,0,NULL,57395747059,896808547,14012633,17.3),(89063,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89063,38.33,0.46,463,37249,70,NULL,NULL,'SDSS J120730.64+633457.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000163,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,181.877667,63.58278,0,NULL,57319258273,895613410,13993959,18.5),(89064,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89064,35.33,0.27,116,37250,70,NULL,NULL,'IC 3007',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000077,NULL,'15.4g',0.49,'S0',NULL,NULL,NULL,NULL,1,181.87825,31.34811,0.016,NULL,58622270079,915972969,14312077,15.4),(89065,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89065,38.33,0.46,463,37251,70,NULL,NULL,'2MASX J12073217+1927444',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,181.8839583,19.46233,0.023,NULL,58130190082,908284220,14191940,17.5),(89066,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89066,37.1,0.46,263,37252,70,NULL,NULL,'SDSS J120732.92+335240.1',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.1g',0.36,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,181.8872083,33.87783,0,NULL,58757226219,918081659,14345025,16.1),(89067,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89067,38.43,0.46,485,37253,70,NULL,NULL,'2MASX J12073316+1124259',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,181.888125,11.40725,0,NULL,58134735487,908355241,14193050,17.7),(89068,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89068,37.8,0.46,362,37254,70,NULL,NULL,'2MASX J12073338+2119043',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,181.889041667,21.31792,0.046,NULL,58858386793,919662293,14369723,18),(89069,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89069,37.74,0.23,354,37255,70,NULL,NULL,'2MASXi J1207335+360531',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000143,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,181.889583,36.092,0,NULL,58551567969,914868249,14294816,17.6),(89070,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89070,36.44,0.46,194,37256,70,NULL,NULL,'2MASX J12073397+1435058',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,181.891458333,14.58492,0.067,NULL,58144566527,908508851,14195450,17.4),(89071,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89071,36.45,0.46,195,37257,70,NULL,NULL,'2MASX J12073461+0337369',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.14',0.15,NULL,NULL,NULL,NULL,NULL,1,181.8942917,3.62681,0,NULL,57993002319,906140661,14158447,18.14),(89072,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89072,37.85,0.33,372,37258,70,NULL,NULL,'2MASX J12073519+2346173',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.48',0.14,NULL,NULL,NULL,NULL,NULL,1,181.8967083,23.7715,0.08,NULL,58587598103,915431220,14303612,18.48),(89073,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89073,36.69,0.46,218,37259,70,NULL,NULL,'2MASX J12073630+4342132',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000192,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,181.9012083,43.70361,0,NULL,58522386784,914412293,14287692,16.2),(89074,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89074,37.76,0.23,356,37260,70,NULL,NULL,'2MASXi J1207371+441401',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,181.904625,44.23372,0,NULL,59056115559,922751805,14417996,17.6),(89075,'IRAS','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89075,31.53,0.8,20.3,37261,75,NULL,'A82, H','NGC 4116',NULL,'1997ApJS..109..333W',1997,1,3.8,'Host galaxy of UM 476.','G',0.000003,NULL,'12.41',2.2,'SB(rs)dm       HII','Pair member (points to parent)',NULL,NULL,NULL,1,181.9047917,2.6905,0,NULL,57995058635,906172791,14158949,12.41),(89076,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89076,31.17,0.35,17.1,37261,NULL,NULL,NULL,'NGC 4116',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89077,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89077,31.48,0.4,19.8,37261,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 4116',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89078,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89078,31.64,0.47,21.2,37261,75,NULL,'A82, H, inv','NGC 4116',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89079,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89079,31.65,0.47,21.4,37261,75,NULL,'A82, H, raw','NGC 4116',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89080,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89080,31.85,0.47,23.4,37261,75,NULL,'A82, H, cor','NGC 4116',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89081,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89081,31.99,0.4,25,37261,75,NULL,'B','NGC 4116',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89082,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89082,33.91,0.47,60.5,37262,NULL,NULL,'H','MCG -02-31-019',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.00003,NULL,'13.94',1,'(R\')SB(rs)b pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,181.909833,-14.96961,0.093,NULL,43056221483,672753460,10511772,13.94),(89083,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89083,33.93,0.45,61.2,37262,NULL,NULL,'K','MCG -02-31-019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89084,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89084,34.06,0.46,64.9,37262,NULL,NULL,'J','MCG -02-31-019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89085,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89085,34.33,0.4,73.5,37262,NULL,NULL,'mean','MCG -02-31-019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89086,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89086,37.8,0.46,362,37263,70,NULL,NULL,'2MASX J12073969+3655086',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,181.915375,36.91906,0,NULL,58546719626,914792494,14293632,18.3),(89087,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89087,36.35,0.46,186,37264,70,NULL,NULL,'2MASX J12074041+1236588',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000165,NULL,'16.0g',0.43,'S0',NULL,NULL,NULL,NULL,1,181.918375,12.61622,0,NULL,58148484975,908570077,14196407,16),(89088,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89088,34.68,0.89,86.3,37265,NULL,NULL,'Malmquist cor.','ESO 573- G 002',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.00003,NULL,'15',0.9,'SAB(s)bc',NULL,NULL,NULL,NULL,1,181.919333,-18.07378,0.117,NULL,43029854786,672341481,10505335,15),(89089,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89089,34.74,0.86,88.8,37265,NULL,NULL,NULL,'ESO 573- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89090,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89090,34.78,0.2,90.4,37265,74.4,NULL,NULL,'ESO 573- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89091,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89091,36.61,0.46,210,37266,70,NULL,NULL,'2MASX J12074081+3804486',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000178,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,181.920083,38.08022,0,NULL,58547540071,914805313,14293833,16.5),(89092,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89092,37.74,0.23,354,37267,70,NULL,NULL,'2MASX J12074104+3601586',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,181.9210417,36.033,0,NULL,58551573193,914868331,14294817,18),(89093,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89093,37.93,0.46,385,37268,70,NULL,NULL,'2MASX J12074150+3341471',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,181.922875,33.6965,0,NULL,58757235880,918081810,14345028,17.4),(89094,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89094,38.3,0.23,456,37269,70,NULL,NULL,'2MASX J12074164+4640442',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000173,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,181.9235,46.67889,0,NULL,57180806783,893450105,13960157,18.2),(89095,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89095,35.9,0.6,152,37270,70,NULL,NULL,'2MASX J12074394-2743272',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,181.9330417,-27.72425,0.341,NULL,43414884832,678357575,10599337,15.4),(89096,'GRB','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89096,37.14,NULL,268,37271,65,NULL,'L = 10e57 photons/s','GRB 781124',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,181.927625,23.65214,0.088,NULL,58587600711,915431261,14303613,NULL),(89097,'GRB','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89097,38.43,NULL,486,37271,75,NULL,NULL,'GRB 781124',NULL,'1995ApJ...453..583W',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89098,'GRB','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89098,40.3,NULL,1150,37271,65,NULL,'L = 2 x 10e58 photons/s','GRB 781124',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89099,'GRB','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89099,41.99,NULL,2500,37271,NULL,NULL,NULL,'GRB 781124',NULL,'1992grbo.book..107S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89100,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89100,37.44,0.46,307,37272,70,NULL,NULL,'2MASX J12074474+2912531',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00011,NULL,'16.9g',0.3,'E',NULL,NULL,NULL,NULL,1,181.9364583,29.21481,0.02,NULL,58625215380,916018990,14312796,16.9),(89101,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89101,37.85,0.33,372,37273,70,NULL,NULL,'SDSS J120745.10+234733.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,181.9379583,23.79267,0.08,NULL,58587569259,915430769,14303605,18.4),(89102,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89102,38.29,0.46,456,37274,70,NULL,NULL,'SDSS J120745.25+272958.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,181.938583,27.49947,0.035,NULL,58644521084,916320641,14317510,18.3),(89103,'SNIa','2016-12-15 15:14:55','2016-12-16 11:20:04','1','PTF10hdv',NULL,89103,36.54,0.03,193,37275,70,NULL,'SiFTO+SALT2, SN PTF10hdv','PTF10hdv',0.0542,'2012MNRAS.426.2359M',2012,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,181.930833,41.49108,0,NULL,58534102232,914595347,14290552,NULL),(89104,'SNIa','2016-12-15 15:14:55','2016-12-16 11:20:04','1','PTF10hdv',NULL,89104,36.84,0.03,234,37275,NULL,NULL,'J','PTF10hdv',NULL,'2012MNRAS.425.1007B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89105,'SNIa','2016-12-15 15:14:55','2016-12-16 11:20:04','1','PTF10hdv',NULL,89105,36.88,0.04,238,37275,NULL,NULL,'H','PTF10hdv',NULL,'2012MNRAS.425.1007B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89106,'SNIa','2016-12-15 15:14:55','2016-12-16 11:20:04','1','PTF10hdv',NULL,89106,37,0.01,238,37275,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10hdv',0.0542,'2014MNRAS.438.1391P',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89107,'SNIa','2016-12-15 15:14:55','2016-12-16 11:20:04','1','PTF10hdv',NULL,89107,36.93,0.02,243,37275,72,NULL,'M(H) = -18.317 mag','PTF10hdv',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89108,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89108,37.76,0.23,356,37276,70,NULL,NULL,'SDSS J120745.90+441452.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000171,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,181.9412917,44.24783,0,NULL,59056114046,922751781,14417996,17.9),(89109,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89109,31.19,0.4,17.3,37277,NULL,NULL,'mean','NGC 4117',NULL,'2007A&A...465...71T',2007,1,1.72,NULL,'G',0.000005,NULL,'13.7g',0.63,'S0^0^:         Sy2','in a radial-velocity based grouping',NULL,NULL,'Sy 2',1,181.942125,43.12636,0,NULL,58522146172,914408533,14287633,13.7),(89110,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89110,31.82,0.45,23.1,37277,NULL,NULL,'K','NGC 4117',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89111,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89111,37.42,0.46,304,37278,70,NULL,NULL,'SDSS J120747.50+474210.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000142,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,181.947917,47.70306,0,NULL,57190892235,893607691,13962620,18.2),(89112,'Tully est','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89112,32.74,0.8,35.4,37279,75,NULL,'B','UGCA 272',NULL,'1988NBGC.C....0000T',1988,1,0.77,NULL,'G',0.000063,NULL,'14.1g',0.76,'E0/S0          NLAGN',NULL,NULL,NULL,NULL,1,181.948417,67.38375,0.017,NULL,57847906410,903873537,14123024,14.1),(89113,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89113,37.46,0.46,311,37280,70,NULL,NULL,'2MASX J12074759+1542561',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,181.948375,15.71547,0.13,NULL,58178783470,909043491,14203804,17.8),(89114,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89114,37.65,0.21,338,37281,70,NULL,NULL,'I Zw 030',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000178,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,181.950167,40.17089,0,NULL,58526900095,914482813,14288793,17.2),(89115,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89115,37.53,0.33,320,37282,70,NULL,NULL,'2MASX J12074888+2618231',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000138,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,181.9537917,26.30628,0.048,NULL,58596878116,915576220,14305878,17.9),(89116,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89116,37.97,0.33,393,37283,70,NULL,NULL,'SDSS J120750.14+513633.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000138,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,181.9589583,51.60936,0.019,NULL,57214813860,893981466,13968460,18.4),(89117,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89117,35.79,0.46,144,37284,70,NULL,NULL,'2MASX J12075098+4234192',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000174,NULL,'15.4g',0.54,'S0^-',NULL,NULL,NULL,NULL,1,181.9622917,42.57186,0,NULL,58522088655,914407635,14287619,15.4),(89118,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89118,37.65,0.14,339,37285,70,NULL,NULL,'2MASX J12075133+1457241',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000175,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,181.963875,14.95675,0.124,NULL,58143997026,908499953,14195311,17.6),(89119,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89119,38.08,0.23,412,37286,70,NULL,NULL,'2MASX J12075210+2352004',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.64',0.2,NULL,NULL,NULL,NULL,NULL,1,181.9672083,23.86675,0.08,NULL,58587384853,915427888,14303560,17.64),(89120,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89120,37.65,0.21,338,37287,70,NULL,NULL,'2MASX J12075269+4021026',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000196,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,181.969458333,40.35081,0,NULL,58526863163,914482236,14288784,17.2),(89121,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89121,38.29,0.46,455,37288,70,NULL,NULL,'2MASX J12075342+0927391',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000152,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,181.972625,9.46092,0,NULL,58201844002,909403812,14209434,17.7),(89122,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89122,37.38,0.46,299,37289,70,NULL,NULL,'2MASX J12075363+5635383',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,181.9735,56.59383,0,NULL,57395882709,896810667,14012666,17.7),(89123,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89123,36.72,0.46,221,37290,70,NULL,NULL,'2MASX J12075367+3402133',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.00018,NULL,'15.9g',0.37,NULL,NULL,NULL,NULL,NULL,1,181.9735417,34.03683,0,NULL,58756183214,918065362,14344771,15.9),(89124,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89124,38.12,0.16,421,37291,70,NULL,NULL,'2MASX J12075388+4104226',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,181.974583,41.07286,0,NULL,58526269749,914472964,14288640,17.3),(89125,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89125,36.79,0.46,228,37292,70,NULL,NULL,'2MASX J12075400+2039285',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00012,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,181.97525,20.65806,0.025,NULL,58118788653,908106072,14189157,16.4),(89126,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89126,37.76,0.23,356,37293,70,NULL,NULL,'2MASX J12075547+4416582',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,181.9812917,44.28297,0,NULL,59056084775,922751324,14417989,17.3),(89127,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89127,36.79,0.46,228,37294,70,NULL,NULL,'2MASX J12075559+5030013',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,181.9817083,50.50039,0.015,NULL,57231758712,894246229,13972597,17.4),(89128,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89128,37.55,0.46,323,37295,70,NULL,NULL,'2MASX J12075608+3309113',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000199,NULL,'18.14',0.18,NULL,NULL,NULL,NULL,NULL,1,181.983666667,33.15325,0,NULL,58757666340,918088536,14345133,18.14),(89129,'D-Sigma','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89129,31.85,0.4,23.4,37296,75,NULL,'Edat, raw','NGC 4121',NULL,'1997ApJS..109..333W',1997,1,0.62,NULL,'G',0.00004,NULL,'14.2g',0.6,'E','in a pair',NULL,NULL,NULL,1,181.9859583,65.11394,0.033,NULL,57326561937,895727530,13995742,14.2),(89130,'D-Sigma','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89130,32.02,0.4,25.3,37296,75,NULL,'Edat, cor','NGC 4121',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89131,'Tully est','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89131,32.04,0.8,25.5,37296,75,NULL,'B','NGC 4121',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89132,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89132,37.69,0.46,345,37297,70,NULL,NULL,'2MASX J12075696+2315245',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.45',0.14,NULL,NULL,NULL,NULL,NULL,1,181.987333,23.25678,0.069,NULL,58587905510,915436023,14303687,18.45),(89133,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89133,37.89,0.46,379,37298,70,NULL,NULL,'2MASX J12075705+2257505',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.35',0.16,NULL,NULL,NULL,NULL,NULL,1,181.988,22.96394,0.063,NULL,58587864363,915435380,14303677,18.35),(89134,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89134,37.65,0.14,339,37299,70,NULL,NULL,'2MASX J12075712+1458411',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000162,NULL,'16.8g',0.34,NULL,NULL,NULL,NULL,NULL,1,181.988125,14.97811,0.124,NULL,58143991087,908499860,14195310,16.8),(89135,'BCG','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89135,38.57,0.35,480,37300,60,NULL,NULL,'ABELL 1474',0.0778,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,181.988458333,14.95508,0.124,NULL,58143997606,908499962,14195311,NULL),(89136,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89136,31.51,0.45,20.1,37301,NULL,NULL,'K','IC 3010',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.00004,NULL,'13.16',1.8,'(R\'_2)SAB(s)0/a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,181.9892083,-30.33947,0.205,NULL,43385737406,677902146,10592221,13.16),(89137,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89137,32.28,0.4,28.5,37301,NULL,NULL,'mean','IC 3010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89138,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89138,37.41,0.33,304,37302,70,NULL,NULL,'UGC 07114 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000207,NULL,'16.0g',0.42,'E',NULL,NULL,NULL,NULL,1,181.9897917,9.77989,0,NULL,58201928725,909405136,14209455,16),(89139,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89139,37.18,0.46,273,37303,70,NULL,NULL,'2MASX J12075804+4818213',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000152,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,181.99175,48.30597,0,NULL,57191084270,893610691,13962667,16.9),(89140,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89140,36.97,0.46,248,37304,70,NULL,NULL,'2MASX J12075817+0352386',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,181.9922917,3.87742,0,NULL,58038363880,906849435,14169522,17.1),(89141,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89141,37.74,0.23,354,37305,70,NULL,NULL,'2MASX J12075820+3607386',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000178,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,181.9925417,36.12731,0,NULL,58552290539,914879539,14294992,16.8),(89142,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89142,35.11,0.14,105,37306,70,NULL,NULL,'2MASX J12075827+2519161',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000093,NULL,'15.5g',0.29,'S0','Field galaxy',NULL,NULL,NULL,1,181.99275,25.32119,0.056,NULL,58598901802,915607840,14306372,15.5),(89143,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89143,35.66,0.46,135,37307,70,NULL,NULL,'2MASX J12075837+2247445',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000083,NULL,'16.23',0.27,NULL,NULL,NULL,NULL,NULL,1,181.993167,22.79567,0.063,NULL,58587628164,915431690,14303620,16.23),(89144,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89144,38.42,0.46,482,37308,70,NULL,NULL,'2MASX J12075920+3410123',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,181.996791667,34.17014,0,NULL,58537344676,914646010,14291343,18.1),(89145,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89145,37.96,0.46,391,37309,70,NULL,NULL,'2MASX J12075921+3738186',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,181.996917,37.6385,0,NULL,58546536180,914789627,14293587,17.2),(89146,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89146,38.28,0.46,453,37310,70,NULL,NULL,'2MASX J12080104+5236353',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000184,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,182.0042083,52.60978,0,NULL,57217856264,894029004,13969203,17.9),(89147,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89147,37.65,0.14,339,37311,70,NULL,NULL,'2MASX J12080147+1504251',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000168,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,182.006125,15.07367,0.124,NULL,58176675733,909010558,14203289,16.7),(89148,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89148,38.41,0.46,481,37312,70,NULL,NULL,'SDSS J120802.12+453043.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000166,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,182.008875,45.51217,0,NULL,59056553802,922758653,14418103,18.3),(89149,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89149,37.84,0.46,369,37313,70,NULL,NULL,'2MASX J12080259+1921455',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.51',0.14,NULL,NULL,NULL,NULL,NULL,1,182.010916667,19.36275,0.029,NULL,58130283262,908285675,14191963,18.51),(89150,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89150,37.35,0.46,294,37314,70,NULL,NULL,'SDSS J120802.77+231455.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.46',0.13,NULL,NULL,NULL,NULL,NULL,1,182.011583333,23.24886,0.069,NULL,58587904472,915436007,14303687,18.46),(89151,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89151,37.8,0.46,363,37315,70,NULL,NULL,'2MASX J12080283+3542463',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000195,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,182.011875,35.71281,0,NULL,58551477396,914866834,14294794,16.4),(89152,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89152,35.88,0.46,150,37316,70,NULL,NULL,'CGCG 069-057',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000147,NULL,'15.5g',0.42,'S0/a',NULL,NULL,NULL,NULL,1,182.012875,11.23847,0,NULL,58202711260,909417363,14209646,15.5),(89153,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89153,37.53,0.33,321,37317,70,NULL,NULL,'2MASX J12080344+3429373',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000184,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,182.01425,34.49375,0,NULL,58537462469,914647851,14291372,16.4),(89154,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89154,36.75,0.46,224,37318,70,NULL,NULL,'2MASX J12080495+4451151',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,182.020583333,44.85419,0,NULL,59056134716,922752104,14418001,17.7),(89155,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89155,36.5,0.46,200,37319,70,NULL,NULL,'2MASX J12080500+1407501',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000169,NULL,'16.5g',0.32,'AGN',NULL,NULL,NULL,NULL,1,182.020791667,14.13067,0.019,NULL,58146054259,908532097,14195814,16.5),(89156,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89156,35.11,0.14,105,37320,70,NULL,NULL,'CGCG 128-035',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000063,NULL,'14.70',0.25,'E','Field galaxy',NULL,NULL,NULL,1,182.0210417,25.59025,0.039,NULL,58598917733,915608089,14306376,14.7),(89157,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89157,35.11,0.14,105,37321,70,NULL,NULL,'UGC 07115',NULL,'2015arXiv151105856S',2015,1,0.9,'May be a resolved component of another radio source.','G',0.000093,NULL,'14.36',0.8,'E','Isolated elliptical galaxy',NULL,NULL,'Flat-Spectrum Radio Source',1,182.023125,25.23731,0.056,NULL,58602505961,915664155,14307252,14.36),(89158,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89158,38.67,0.46,542,37322,70,NULL,NULL,'SDSS J120805.64+185755.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,182.0235417,18.9655,0.019,NULL,58132880292,908326254,14192597,18.5),(89159,'GCLF','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89159,32.8,0.3,36.3,37323,NULL,NULL,'TOM(V) = -7.3 mag','NGC 4125',NULL,'2009ApJ...690..512H',2009,1,5.8,NULL,'G',0.000063,NULL,'10.65',3.2,'E6 pec         LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,182.025083,65.17414,0.037,NULL,57326512269,895726754,13995730,10.65),(89160,'SBF','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89160,31.89,0.25,23.9,37323,NULL,NULL,'I','NGC 4125',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89161,'SBF','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89161,31.89,0.25,23.9,37323,NULL,NULL,NULL,'NGC 4125',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89162,'SBF','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89162,31.9,0.14,24,37323,74.4,NULL,NULL,'NGC 4125',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89163,'SBF','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89163,31.96,0.25,24.7,37323,NULL,NULL,'Malmquist cor.','NGC 4125',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89164,'D-Sigma','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89164,31.85,0.4,23.4,37323,75,NULL,'Edat, raw','NGC 4125',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89165,'D-Sigma','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89165,32.02,0.4,25.3,37323,75,NULL,'Edat, cor','NGC 4125',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89166,'Faber-Jackson','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89166,30.04,0.48,10.2,37323,95,NULL,'de Vaucouleurs','NGC 4125',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89167,'Faber-Jackson','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89167,30.29,0.39,11.4,37323,95,NULL,'Weighted Mean','NGC 4125',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89168,'Faber-Jackson','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89168,31.02,NULL,16,37323,NULL,NULL,'LEDA [April 2006]','NGC 4125',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89169,'Faber-Jackson','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89169,31.92,0.81,24.2,37323,55,NULL,'Visvanathan & Sandage 1979','NGC 4125',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89170,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89170,31.28,0.41,18,37323,NULL,NULL,NULL,'NGC 4125',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89171,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89171,31.51,0.41,20.1,37323,NULL,NULL,'Malmquist cor.','NGC 4125',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89172,'Tertiary','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89172,31.34,0.41,18.5,37323,95,NULL,NULL,'NGC 4125',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89173,'Tully est','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89173,31.92,0.8,24.2,37323,75,NULL,'B','NGC 4125',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89174,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89174,37.81,0.46,365,37324,70,NULL,NULL,'2MASX J12080604+2409311',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.0001,NULL,'18.49',0.14,NULL,NULL,NULL,NULL,NULL,1,182.025125,24.15861,0.079,NULL,58601279317,915644989,14306952,18.49),(89175,'BCG','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89175,38.57,0.35,480,37325,60,NULL,'ABELL 1474, BCG','2MASX J12080769+1503221',0.0778,'1980ApJ...241..486H',1980,1,0.62,NULL,'G',0.000127,NULL,'16.3g',0.25,NULL,'Brightest group member',NULL,NULL,NULL,1,182.032167,15.05622,0.124,NULL,58176672225,909010503,14203289,16.3),(89176,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89176,37.56,0.46,325,37326,70,NULL,NULL,'2MASX J12080862-0218136',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,182.036,-2.30378,0.069,NULL,42962966440,671296350,10489005,17.1),(89177,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89177,37.8,0.46,363,37327,70,NULL,NULL,'SDSS J120808.83+251305.3',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000063,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,182.036833,25.21814,0.056,NULL,58602508102,915664189,14307252,17.5),(89178,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89178,36.19,0.83,173,37328,70,NULL,NULL,'2MASX J12080897-1811427',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.66',NULL,NULL,NULL,NULL,NULL,NULL,1,182.037375,-18.19525,0.089,NULL,43029860664,672341572,10505337,16.66),(89179,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89179,35.11,0.14,105,37329,70,NULL,NULL,'CGCG 128-033',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00009,NULL,'15.6',0.3,'E','Field galaxy',NULL,NULL,NULL,1,182.037875,25.07889,0.068,NULL,58602545833,915664778,14307262,15.6),(89180,'Faber-Jackson','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89180,28.9,0.65,6.03,37330,95,NULL,'Weighted Mean','NGC 4119',NULL,'1984ApJS...56...91D',1984,1,4.48,'Identification as NGC 4119 is not certain.','G',0.000017,NULL,'12.3g',0.98,'SA(r)0+','in a radial-velocity based grouping',NULL,NULL,NULL,1,182.040083333,10.37889,0,NULL,58204270142,909441720,14210026,12.3),(89181,'Faber-Jackson','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89181,29.63,0.81,8.43,37330,55,NULL,'Visvanathan & Sandage 1979','NGC 4119',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89182,'Tertiary','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89182,30.49,0.25,12.5,37330,95,NULL,NULL,'NGC 4119',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89183,'Tully est','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89183,31.13,0.8,16.8,37330,75,NULL,'B','NGC 4119',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89184,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89184,29.91,0.45,9.61,37330,NULL,NULL,'K','NGC 4119',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89185,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89185,32.16,0.4,27,37330,NULL,NULL,'mean','NGC 4119',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89186,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89186,37.41,0.33,304,37331,70,NULL,NULL,'SDSS J120809.90+094522.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000163,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,182.04125,9.75633,0,NULL,58201931771,909405183,14209455,18.2),(89187,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89187,37.99,0.33,396,37332,70,NULL,NULL,'2MASX J12080996+4005412',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00018,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,182.04125,40.09467,0,NULL,58524857785,914450902,14288295,17.4),(89188,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89188,37.62,0.15,335,37333,70,NULL,NULL,'SDSS J120809.98+532152.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,182.041625,53.36453,0,NULL,57225504529,894148508,13971070,17.9),(89189,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89189,37.31,0.46,290,37334,70,NULL,NULL,'LCRS B120536.8-023352',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00014,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,182.044375,-2.84278,0.065,NULL,42955312263,671176754,10487136,17),(89190,'Ring Diameter','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89190,30,0.76,10,37335,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4123',NULL,'1981ApJS...45..541P',1981,1,4.71,'Dultzin-Hacyan and Benitez (1994,A&A,291,720) give z=0.029.','G',0.000003,NULL,'12.9g',0.95,'SB(r)c;WR;HII  Sbrst','Pair member (points to parent)',NULL,NULL,'Starburst',1,182.046291667,2.87828,0,NULL,57993135989,906142749,14158480,12.9),(89191,'Ring Diameter','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89191,30.6,0.6,13,37335,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4123',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89192,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89192,30.86,0.36,14.9,37335,NULL,NULL,NULL,'NGC 4123',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89193,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89193,31.78,0.45,22.7,37335,NULL,NULL,'K','NGC 4123',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89194,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89194,31.8,0.4,22.9,37335,NULL,NULL,'mean','NGC 4123',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89195,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89195,31.8,0.47,22.9,37335,NULL,NULL,'H','NGC 4123',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89196,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89196,31.8,0.46,22.9,37335,NULL,NULL,'J','NGC 4123',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89197,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89197,32.02,0.4,25.3,37335,75,NULL,'B','NGC 4123',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89198,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89198,36.79,0.46,228,37336,70,NULL,NULL,'2MASX J12081178+6121543',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000173,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,182.0487083,61.36497,0,NULL,57336881824,895888778,13998262,16.8),(89199,'IRAS','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89199,35.03,0.8,101,37337,75,NULL,'HMCL, I','IC 0762',NULL,'1997ApJS..109..333W',1997,1,0.6,NULL,'G',0.000027,NULL,'15.20',0.4,'Sbc','Field galaxy',NULL,NULL,NULL,1,182.049833,25.75714,0.055,NULL,58597285631,915582587,14305977,15.2),(89200,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89200,34.83,0.4,92.5,37337,75,NULL,'HMCL, I, raw','IC 0762',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89201,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89201,35,0.4,100,37337,75,NULL,'HMCL, I, inv','IC 0762',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89202,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89202,35.04,0.4,102,37337,75,NULL,'HMCL, I, cor','IC 0762',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89203,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89203,37.99,0.33,396,37338,70,NULL,NULL,'2MASX J12081211+4011172',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00014,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,182.05025,40.18822,0,NULL,58524885440,914451335,14288302,18.2),(89204,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89204,37.85,0.46,372,37339,70,NULL,NULL,'2MASX J12081231+5847218',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000181,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,182.051167,58.78953,0,NULL,57330599086,895790610,13996728,16.7),(89205,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89205,36.44,0.46,194,37340,70,NULL,NULL,'VIII Zw 168',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,182.051667,13.60433,0.017,NULL,58145972363,908530818,14195794,16.8),(89206,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89206,37.65,0.14,339,37341,70,NULL,NULL,'2MASX J12081321+1503591',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,182.055167,15.0665,0.124,NULL,58176690518,909010789,14203293,17.6),(89207,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89207,38.66,0.46,540,37342,70,NULL,NULL,'SDSS J120813.67+091420.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000146,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,182.0569583,9.23908,0,NULL,58018117855,906533091,14164579,18.6),(89208,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89208,37.62,0.15,335,37343,70,NULL,NULL,'2MASX J12081387+5324214',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000147,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,182.057625,53.40603,0,NULL,57225505773,894148527,13971070,17.8),(89209,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89209,38.19,0.46,435,37344,70,NULL,NULL,'2MASX J12081486+1156182',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,182.061916667,11.93828,0,NULL,58135079439,908360616,14193134,17.4),(89210,'IRAS','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89210,32.17,0.8,27.2,37345,75,NULL,'MAT, I','ESO 441- G 007',NULL,'1997ApJS..109..333W',1997,1,2.35,NULL,'G',0.00002,NULL,'14.97',0.31,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,182.065166667,-32.00872,0.305,NULL,43370855949,677669624,10588587,14.97),(89211,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89211,31.74,0.43,22.3,37345,75,NULL,'3.6 micron, color + selection bias corrected','ESO 441- G 007',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89212,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89212,31.82,0.43,23.1,37345,75,NULL,'3.6 micron, color corrected','ESO 441- G 007',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89213,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89213,31.87,0.32,23.7,37345,85,NULL,'I, inv','ESO 441- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89214,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89214,31.89,0.2,23.9,37345,74.4,NULL,NULL,'ESO 441- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89215,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89215,31.91,0.32,24.1,37345,85,NULL,'I, raw','ESO 441- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89216,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89216,32.21,NULL,27.7,37345,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 441- G 007',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89217,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89217,32.22,NULL,27.8,37345,NULL,NULL,'Dipole + Quadrupole','ESO 441- G 007',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89218,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89218,32.23,0.56,27.9,37345,NULL,NULL,NULL,'ESO 441- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89219,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89219,32.24,NULL,28.1,37345,NULL,NULL,'Dipole','ESO 441- G 007',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89220,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89220,32.25,0.43,28.2,37345,75,NULL,'MAT, I, inv','ESO 441- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89221,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89221,32.29,0.43,28.7,37345,75,NULL,'MAT, I, raw','ESO 441- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89222,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89222,32.3,0.54,28.8,37345,NULL,NULL,'Malmquist cor.','ESO 441- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89223,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89223,32.53,NULL,32.1,37345,NULL,NULL,NULL,'ESO 441- G 007',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89224,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89224,32.57,0.43,32.7,37345,75,NULL,'MAT, I, cor','ESO 441- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89225,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89225,37.65,0.14,339,37346,70,NULL,NULL,'2MASX J12081577+1502180',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00011,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,182.065625,15.03833,0.124,NULL,58176691520,909010805,14203293,16.6),(89226,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89226,37.65,0.21,338,37347,70,NULL,NULL,'2MASX J12081644+4018493',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00017,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,182.068375,40.31369,0,NULL,58524830817,914450481,14288288,16.9),(89227,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89227,37.65,0.14,339,37348,70,NULL,NULL,'2MASX J12081729+1458510',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000164,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,182.0719583,14.98089,0.124,NULL,58143937271,908499019,14195297,18.5),(89228,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89228,35.11,0.14,105,37349,70,NULL,NULL,'2MASX J12081845+2509410',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000107,NULL,'16.75',0.16,NULL,NULL,NULL,NULL,NULL,1,182.0767917,25.16142,0.068,NULL,58602517512,915664336,14307255,16.75),(89229,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89229,36.92,0.46,243,37350,70,NULL,NULL,'2MASX J12081922+0528159',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000174,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,182.080041667,5.47097,0,NULL,58039131447,906861428,14169709,17.5),(89230,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89230,37.65,0.21,338,37351,70,NULL,NULL,'2MASX J12081958+4024583',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000206,NULL,'15.4g',0.51,NULL,NULL,NULL,NULL,NULL,1,182.0815417,40.41633,0,NULL,58524501332,914445333,14288208,15.4),(89231,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89231,36.59,0.33,208,37352,70,NULL,NULL,'SDSS J120819.92+121712.0',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.1g',0.31,'E0',NULL,NULL,NULL,NULL,1,182.083,12.28669,0.005,NULL,58148386181,908568534,14196383,16.1),(89232,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89232,37.53,0.33,321,37353,70,NULL,NULL,'2MASX J12082003+3432473',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000175,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,182.083583,34.54644,0,NULL,58537466144,914647908,14291373,17),(89233,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89233,32.53,NULL,32,37354,NULL,NULL,NULL,'VCC 0001',NULL,'2014A&A...562A..49M',2014,1,0.81,NULL,'G',0.00009,NULL,'15.5g',0.28,'S0_1_(9)       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,182.0847083,13.68392,0.017,NULL,58146028757,908531699,14195807,15.5),(89234,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89234,37.73,0.46,351,37355,70,NULL,NULL,'2MASX J12082041+3504213',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,182.084875,35.07272,0,NULL,58537257423,914644647,14291322,17.4),(89235,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89235,37.75,0.46,355,37356,70,NULL,NULL,'2MASX J12082097+2458070',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'18.36',0.15,NULL,NULL,NULL,NULL,NULL,1,182.087541667,24.96864,0.062,NULL,58602457288,915663395,14307240,18.36),(89236,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89236,36.59,0.33,208,37357,70,NULL,NULL,'2MASX J12082112+1218500',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,182.088125,12.31397,0.005,NULL,58148345674,908567901,14196373,17.5),(89237,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89237,37.19,0.46,274,37358,70,NULL,NULL,'2MASX J12082172+1227020',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000184,NULL,'16.8g',0.28,'AGN',NULL,NULL,NULL,NULL,1,182.090625,12.4505,0.014,NULL,58148469545,908569836,14196403,16.8),(89238,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89238,37.54,0.27,322,37359,70,NULL,NULL,'2MASX J12082185+0201279',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000076,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,182.0909583,2.02431,0.048,NULL,57998587008,906227922,14159811,17.3),(89239,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89239,37.65,0.14,339,37360,70,NULL,NULL,'2MASX J12082308+1503150',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000139,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,182.09625,15.05433,0.124,NULL,58176689444,909010772,14203293,17.7),(89240,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89240,37.42,0.46,304,37361,70,NULL,NULL,'2MASX J12082307+2237534',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.74',0.12,NULL,NULL,NULL,NULL,NULL,1,182.0962917,22.63164,0.076,NULL,58857051613,919641431,14369397,18.74),(89241,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89241,37.96,0.46,390,37362,70,NULL,NULL,'2MASX J12082328+6114053',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000143,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,182.096833333,61.23497,0,NULL,57336817660,895887775,13998246,17.5),(89242,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89242,37.73,0.11,352,37363,70,NULL,NULL,'2MASX J12082398+0527099',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000175,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,182.099833333,5.45286,0,NULL,58039112043,906861125,14169705,17.6),(89243,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89243,37.26,0.46,283,37364,70,NULL,NULL,'2MASX J12082448+4456088',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,182.101833,44.93592,0,NULL,59056131634,922752056,14418000,17.2),(89244,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89244,36.48,0.66,198,37365,70,NULL,NULL,'2MASX J12082474-4654200',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,182.1030417,-46.90553,0.413,NULL,44563551647,696305494,10879773,15.7),(89245,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89245,36.52,0.46,201,37366,70,NULL,NULL,'SDSS J120825.12+465036.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,182.1047083,46.84358,0,NULL,57180041695,893438151,13959971,17.7),(89246,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89246,37.24,0.46,281,37367,70,NULL,NULL,'2MASX J12082627+5749549',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,182.1092917,57.83189,0,NULL,57331912400,895811131,13997048,17.8),(89247,'IRAS','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89247,32.29,0.8,28.7,37368,75,NULL,'A82, H','NGC 4127',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000023,NULL,'13.35',1.2,'SAc?','X-ray-bright group member',NULL,NULL,NULL,1,182.109833,76.80403,0.181,NULL,57011071956,890797999,13918718,13.35),(89248,'IRAS','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89248,32.35,0.8,29.5,37368,75,NULL,'CF, r','NGC 4127',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89249,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89249,31.32,0.69,18.4,37368,100,NULL,'mid-IR','NGC 4127',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89250,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89250,31.58,0.4,20.7,37368,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 4127',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89251,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89251,32.17,0.47,27.1,37368,75,NULL,'A82, H, raw','NGC 4127',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89252,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89252,32.2,0.47,27.5,37368,75,NULL,'A82, H, inv','NGC 4127',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89253,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89253,32.37,0.4,29.8,37368,75,NULL,'B','NGC 4127',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89254,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89254,32.41,0.43,30.4,37368,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4127',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89255,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89255,32.43,0.36,30.6,37368,NULL,NULL,NULL,'NGC 4127',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89256,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89256,32.44,0.4,30.8,37368,NULL,NULL,'mean','NGC 4127',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89257,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89257,32.45,0.47,30.9,37368,75,NULL,'A82, H, cor','NGC 4127',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89258,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89258,32.49,0.43,31.5,37368,75,NULL,'3.6 micron, color corrected','NGC 4127',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89259,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89259,32.51,0.44,31.7,37368,NULL,NULL,'Malmquist cor.','NGC 4127',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89260,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89260,32.58,0.2,32.8,37368,74.4,NULL,NULL,'NGC 4127',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89261,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89261,32.74,0.46,35.4,37368,NULL,NULL,'J','NGC 4127',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89262,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89262,32.75,0.39,35.4,37368,NULL,NULL,NULL,'NGC 4127',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89263,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89263,32.75,0.47,35.5,37368,NULL,NULL,'H','NGC 4127',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89264,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89264,32.8,0.45,36.3,37368,NULL,NULL,'K','NGC 4127',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89265,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89265,32.99,0.38,39.6,37368,75,NULL,'CF, r, raw','NGC 4127',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89266,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89266,33.09,0.38,41.4,37368,75,NULL,'CF, r, inv','NGC 4127',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89267,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89267,33.1,0.38,41.7,37368,75,NULL,'CF, r, cor','NGC 4127',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89268,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89268,38.57,0.46,518,37369,70,NULL,NULL,'SDSS J120827.47+082923.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,182.1145,8.48981,0,NULL,58018562658,906540041,14164688,17.9),(89269,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89269,37.43,0.46,307,37370,70,NULL,NULL,'LCRS B120553.6-032345',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000146,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,182.114583,-3.67392,0.077,NULL,43010892673,672045198,10500706,17),(89270,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89270,36.77,0.46,226,37371,70,NULL,NULL,'2MASX J12082770+2242384',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.29',0.14,NULL,NULL,NULL,NULL,NULL,1,182.1155,22.71061,0.076,NULL,58857048144,919641377,14369396,18.29),(89271,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89271,39.01,0.46,633,37372,70,NULL,NULL,'SDSS J120828.43+034524.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,182.1184583,3.75683,0.017,NULL,58038524292,906851942,14169561,18.1),(89272,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89272,36.72,0.46,221,37373,70,NULL,NULL,'2MASX J12082872+2652370',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000165,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,182.119625,26.87703,0.037,NULL,58642357513,916286836,14316981,16.6),(89273,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89273,37.44,0.46,308,37374,70,NULL,NULL,'2MASX J12082977+1608371',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000165,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,182.124,16.14372,0.089,NULL,58179124996,909048828,14203887,17.7),(89274,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89274,38.12,0.16,421,37375,70,NULL,NULL,'2MASXi J1208299+412224',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,182.125,41.37336,0,NULL,58534956028,914608687,14290760,18),(89275,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89275,38.12,0.16,421,37376,70,NULL,NULL,'2MASX J12083016+4107073',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000175,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,182.1257917,41.11872,0,NULL,58534935104,914608361,14290755,17.1),(89276,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89276,35.63,0.46,133,37377,70,NULL,NULL,'2MASX J12083053+5559220',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000164,NULL,'15.8g',0.42,'SB0a',NULL,NULL,NULL,NULL,1,182.127125,55.98944,0,NULL,57210850615,893919540,13967492,15.8),(89277,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89277,31.99,0.4,25,37378,75,NULL,NULL,'NGC 4120',NULL,'2008Ap.....51..336K',2008,1,1.8,NULL,'G',0.000017,NULL,'14.17',0.4,'SA(rs)cd:      HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,182.12925,69.54483,0.025,NULL,56979489454,890304522,13911008,14.17),(89278,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89278,32.32,0.43,29.1,37378,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4120',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89279,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89279,32.52,0.49,31.9,37378,75,NULL,'IR','NGC 4120',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89280,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89280,37.79,0.27,362,37379,70,NULL,NULL,'2MASX J12083178+2416570',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000097,NULL,'18.38',0.16,NULL,NULL,NULL,NULL,NULL,1,182.132625,24.28239,0.079,NULL,58601877995,915654343,14307099,18.38),(89281,'Faber-Jackson','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89281,32.28,0.6,28.6,37380,95,NULL,'Weighted Mean','NGC 4128',NULL,'1984ApJS...56...91D',1984,1,2.6,NULL,'G',0.00009,NULL,'12.93',0.9,'SA0: sp','in a radial-velocity based grouping',NULL,NULL,NULL,1,182.1347083,68.76761,0.021,NULL,56975766073,890246344,13910099,12.93),(89282,'Faber-Jackson','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89282,32.28,0.6,28.6,37380,95,NULL,'de Vaucouleurs','NGC 4128',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89283,'Tertiary','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89283,32.06,0.5,25.8,37380,95,NULL,NULL,'NGC 4128',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89284,'Tully est','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89284,32.8,0.8,36.4,37380,75,NULL,'B','NGC 4128',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89285,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89285,32.21,0.45,27.6,37380,NULL,NULL,'K','NGC 4128',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89286,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89286,32.66,0.4,34.1,37380,NULL,NULL,'mean','NGC 4128',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89287,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89287,38.12,0.16,421,37381,70,NULL,NULL,'SDSS J120833.56+411503.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000125,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,182.139875,41.25106,0,NULL,58534976164,914609002,14290765,18.6),(89288,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89288,37.81,0.46,364,37382,70,NULL,NULL,'SBS 1206+599',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000206,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,182.1400417,59.70742,0,NULL,57342021067,895969079,13999516,16.5),(89289,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89289,38.12,0.16,421,37383,70,NULL,NULL,'2MASX J12083449+4104233',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00018,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,182.143625,41.07311,0,NULL,58532039375,914563115,14290048,17.2),(89290,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89290,37.62,0.15,335,37384,70,NULL,NULL,'2MASX J12083623+5324083',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000191,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,182.150791667,53.40222,0,NULL,57225510788,894148606,13971071,17.1),(89291,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89291,37.33,0.46,293,37385,70,NULL,NULL,'2MASX J12083624+0342337',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000089,NULL,'16.1g',0.39,NULL,NULL,NULL,NULL,NULL,1,182.151083,3.70931,0.017,NULL,58038525650,906851963,14169561,16.1),(89292,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89292,34.65,0.46,85.1,37386,70,NULL,NULL,'CGCG 098-066',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000193,NULL,'15.4',0.4,NULL,NULL,NULL,NULL,NULL,1,182.151917,17.21183,0.148,NULL,58122434551,908163039,14190047,15.4),(89293,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89293,38.12,0.16,421,37387,70,NULL,NULL,'2MASX J12083729+4108282',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,182.155291667,41.14125,0,NULL,58534934794,914608356,14290755,18.3),(89294,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89294,37.54,0.27,322,37388,70,NULL,NULL,'2MASX J12083741+0204207',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000079,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,182.1557917,2.07239,0.048,NULL,57995297031,906176516,14159008,18.1),(89295,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89295,37.1,0.46,263,37389,70,NULL,NULL,'2MASX J12083739+1139580',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.48',0.15,NULL,NULL,NULL,NULL,NULL,1,182.1557917,11.66617,0,NULL,58134973995,908358968,14193108,18.48),(89296,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89296,34.23,0.46,70.3,37390,70,NULL,NULL,'NGC 4126',NULL,'2015arXiv151105856S',2015,1,0.95,NULL,'G',0.000157,NULL,'14.2g',0.76,'S0',NULL,NULL,NULL,NULL,1,182.156,16.14278,0.089,NULL,58179114886,909048670,14203885,14.2),(89297,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89297,37.66,0.46,341,37391,70,NULL,NULL,'2MASX J12083819+2742380',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000168,NULL,'17.80',0.16,'BrClG',NULL,NULL,NULL,NULL,1,182.159041667,27.71039,0.028,NULL,58644643920,916322561,14317540,17.8),(89298,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89298,37.62,0.15,335,37392,70,NULL,NULL,'2MASX J12083832+5320082',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,182.1597917,53.33556,0,NULL,57225495043,894148360,13971068,17.6),(89299,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89299,37.3,0.46,288,37393,70,NULL,NULL,'2MASX J12084000+0241177',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00007,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,182.166667,2.68817,0,NULL,57995574764,906180855,14159075,17.5),(89300,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89300,37.45,0.46,309,37394,70,NULL,NULL,'2MASX J12084104+2356040',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.32',0.14,NULL,NULL,NULL,NULL,NULL,1,182.171125,23.93458,0.086,NULL,58601477169,915648080,14307001,18.32),(89301,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89301,37.79,0.27,362,37395,70,NULL,NULL,'2MASX J12084107+2417110',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000103,NULL,'17.25',0.26,NULL,NULL,NULL,NULL,NULL,1,182.1712917,24.28644,0.071,NULL,58601870361,915654224,14307097,17.25),(89302,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89302,37.26,0.46,283,37396,70,NULL,NULL,'2MASX J12084184+4918362',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,182.1745417,49.30997,0.017,NULL,57188396008,893568687,13962010,17.3),(89303,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89303,29.68,NULL,8.61,37397,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07125',NULL,'2010Ap&SS.325..163P',2010,1,3.11,NULL,'G',0.000023,NULL,'14.1g',0.62,'Sdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,182.176375,36.80275,0.012,NULL,58548613955,914822093,14294095,14.1),(89304,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89304,29.69,NULL,8.66,37397,NULL,NULL,'Dipole + Quadrupole','UGC 07125',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89305,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89305,29.69,NULL,8.67,37397,NULL,NULL,'Dipole','UGC 07125',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89306,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89306,29.81,NULL,9.14,37397,NULL,NULL,NULL,'UGC 07125',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89307,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89307,31.22,0.43,17.5,37397,75,NULL,'3.6 micron, color + selection bias corrected','UGC 07125',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89308,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89308,31.71,0.4,22,37397,75,NULL,'B','UGC 07125',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89309,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89309,32.66,0.4,34,37397,NULL,NULL,NULL,'UGC 07125',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89310,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89310,36.76,0.46,225,37398,70,NULL,NULL,'2MASX J12084256+2112593',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,182.177333333,21.21636,0.033,NULL,58856235640,919628681,14369198,17.5),(89311,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89311,37.27,0.46,284,37399,70,NULL,NULL,'2MASX J12084363+4929322',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000164,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,182.1817917,49.49225,0.028,NULL,57188359083,893568110,13962001,16.8),(89312,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89312,37.63,0.46,336,37400,70,NULL,NULL,'2MASX J12084474+4733398',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000178,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,182.18625,47.56097,0,NULL,57190661401,893604084,13962563,17.4),(89313,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89313,37.51,0.46,318,37401,70,NULL,NULL,'SDSS J120845.05+095349.1',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,182.18775,9.897,0,NULL,58203439449,909428741,14209824,17.3),(89314,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89314,36.76,0.6,225,37402,70,NULL,NULL,'2MASX J12084509-1619272',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,182.187833333,-16.32433,0.105,NULL,43073013603,673015837,10515872,17.1),(89315,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89315,37.65,0.21,338,37403,70,NULL,NULL,'2MASX J12084526+4031023',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000176,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,182.188417,40.51722,0,NULL,58524565354,914446333,14288223,17),(89316,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89316,38.12,0.16,421,37404,70,NULL,NULL,'2MASX J12084616+4121463',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'18.2g',0.13,'AGN',NULL,NULL,NULL,NULL,1,182.19225,41.36294,0,NULL,58535139505,914611554,14290805,18.2),(89317,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89317,35.11,0.14,105,37405,70,NULL,NULL,'UGC 07124',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000073,NULL,'15.22',0.3,'S0','Field galaxy',NULL,NULL,NULL,1,182.19275,24.94639,0.068,NULL,58602461743,915663464,14307241,15.22),(89318,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89318,38.25,0.46,446,37406,70,NULL,NULL,'2MASX J12084642+3329449',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,182.193375,33.496,0,NULL,58757430946,918084858,14345075,17.5),(89319,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89319,37.62,0.15,335,37407,70,NULL,NULL,'MCG +09-20-099',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00016,NULL,'16.3g',0.4,'BrClG',NULL,NULL,NULL,NULL,1,182.1937917,53.33372,0,NULL,57225495109,894148361,13971068,16.3),(89320,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89320,37.74,0.23,354,37408,70,NULL,NULL,'2MASX J12084700+3608063',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,182.1957083,36.13525,0,NULL,58552343037,914880359,14295005,17.2),(89321,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89321,37.06,0.33,258,37409,70,NULL,NULL,'2MASX J12084728+5200022',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000196,NULL,'16.0g',0.42,'E0',NULL,NULL,NULL,NULL,1,182.196833,52.00075,0,NULL,57218410681,894037666,13969338,16),(89322,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89322,33.54,0.46,51,37410,70,NULL,NULL,'NGC 4131',NULL,'2015arXiv151105856S',2015,1,1.4,NULL,'G',0.000033,NULL,'13.8g',0.63,'Sb','in a radial-velocity based grouping',NULL,NULL,NULL,1,182.1970417,29.30478,0.02,NULL,58625278796,916019981,14312812,13.8),(89323,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89323,33.87,0.4,59.5,37410,NULL,NULL,'mean','NGC 4131',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89324,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89324,34.67,0.47,86,37410,NULL,NULL,'H','NGC 4131',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89325,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89325,34.68,0.46,86.2,37410,NULL,NULL,'J','NGC 4131',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89326,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89326,34.72,0.45,88,37410,NULL,NULL,'K','NGC 4131',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89327,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89327,37.06,0.33,258,37411,70,NULL,NULL,'2MASX J12084739+5200362',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,182.1974583,52.01014,0,NULL,57218412796,894037699,13969339,17.4),(89328,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89328,37.54,0.27,322,37412,70,NULL,NULL,'2MASX J12084795+0204097',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000086,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,182.1997083,2.06942,0.048,NULL,57995299331,906176552,14159008,17.5),(89329,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89329,37.95,0.46,390,37413,70,NULL,NULL,'2MASX J12084796+2724363',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000139,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,182.199833,27.41003,0.035,NULL,58644740805,916324075,14317563,18.4),(89330,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89330,36.81,0.46,230,37414,70,NULL,NULL,'2MASX J12084806+3257268',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.0002,NULL,'16.1g',0.42,NULL,NULL,NULL,NULL,NULL,1,182.200333333,32.95756,0,NULL,58757692638,918088947,14345139,16.1),(89331,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89331,37.47,0.46,312,37415,70,NULL,NULL,'SDSS J120848.83+045225.0',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,182.2035,4.87364,0,NULL,58039338928,906864670,14169760,17.6),(89332,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89332,37.78,0.46,360,37416,70,NULL,NULL,'2MASX J12084897+6220190',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000201,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,182.203916667,62.33856,0,NULL,57370590425,896415475,14006491,16.9),(89333,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89333,37.62,0.15,335,37417,70,NULL,NULL,'2MASX J12084941+5318452',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000175,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,182.206,53.31264,0.028,NULL,57225466008,894147906,13971061,17),(89334,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89334,34.89,0.46,95,37418,70,NULL,NULL,'CGCG 215-032',NULL,'2015arXiv151105856S',2015,1,0.88,NULL,'G',0.000167,NULL,'14.7g',0.62,'E0',NULL,NULL,NULL,NULL,1,182.207917,42.24869,0,NULL,58534720542,914605008,14290703,14.7),(89335,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89335,30.83,0.45,14.7,37419,NULL,NULL,'K','NGC 4133',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.00006,NULL,'13.11',1.3,'SABb:','X-ray-bright group member',NULL,NULL,NULL,1,182.208167,74.90431,0.125,NULL,57016766046,890886969,13920108,13.11),(89336,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89336,30.88,0.47,15,37419,NULL,NULL,'H','NGC 4133',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89337,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89337,31.01,0.46,15.9,37419,NULL,NULL,'J','NGC 4133',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89338,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89338,31.27,0.4,18,37419,NULL,NULL,'mean','NGC 4133',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89339,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89339,37.73,0.11,352,37420,70,NULL,NULL,'2MASX J12085010+0521187',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000189,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,182.2087917,5.35531,0,NULL,58039628646,906869197,14169831,17.2),(89340,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89340,37.76,0.46,356,37421,70,NULL,NULL,'2MASX J12085045+5440289',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,182.209917,54.67456,0,NULL,57213495089,893960860,13968138,17.9),(89341,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89341,38.12,0.16,421,37422,70,NULL,NULL,'2MASX J12085073+4111573',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000181,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,182.2112917,41.19936,0,NULL,58534981937,914609092,14290767,16.9),(89342,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89342,36.69,0.33,218,37423,70,NULL,NULL,'2MASX J12085094+2922523',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000188,NULL,'15.8g',0.46,'E',NULL,NULL,NULL,NULL,1,182.21225,29.38122,0.027,NULL,58625260339,916019692,14312807,15.8),(89343,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89343,37.63,0.46,336,37424,70,NULL,NULL,'2MASX J12085138+0505227',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000185,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,182.2142917,5.08969,0.015,NULL,58039524160,906867565,14169805,17),(89344,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89344,37.65,0.14,339,37425,70,NULL,NULL,'2MASX J12085164+1448309',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00019,NULL,'15.9g',0.44,NULL,NULL,NULL,NULL,NULL,1,182.215167,14.80872,0.131,NULL,58144460049,908507188,14195424,15.9),(89345,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89345,37.8,0.33,363,37426,70,NULL,NULL,'SDSS J120851.69+275045.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000129,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,182.215375,27.84592,0.028,NULL,58644153944,916314905,14317420,18.1),(89346,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89346,38.46,0.46,492,37427,70,NULL,NULL,'SDSS J120852.48-000131.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000089,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,182.2187083,-0.02544,0.009,NULL,42951847049,671122610,10486290,18.2),(89347,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89347,37.85,0.46,372,37428,70,NULL,NULL,'2MASX J12085269+2604503',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,182.219417,26.08075,0.051,NULL,58597571247,915587050,14306047,17.5),(89348,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89348,36.79,0.46,228,37429,70,NULL,NULL,'2MASX J12085280+2623513',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000097,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,182.219917,26.39758,0.045,NULL,58596955181,915577424,14305897,16.6),(89349,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89349,38.62,0.27,530,37430,70,NULL,NULL,'SDSS J120853.00+071358.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000137,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,182.220833,7.23283,0,NULL,58032042023,906750656,14167979,18.2),(89350,'Tully est','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89350,31.63,0.8,21.2,37431,75,NULL,'B','NGC 4129',NULL,'1988NBGC.C....0000T',1988,1,2.3,NULL,'G',0.000013,NULL,'13.50',0.6,'SB(s)ab: sp    HII',NULL,NULL,NULL,NULL,1,182.22175,-9.0365,0.165,NULL,42967645642,671369463,10490147,13.5),(89351,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89351,31.18,0.43,17.2,37431,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4129',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89352,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89352,31.28,0.4,18.1,37431,75,NULL,NULL,'NGC 4129',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89353,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89353,31.42,0.43,19.2,37431,75,NULL,'3.6 micron, color corrected','NGC 4129',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89354,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89354,31.45,0.47,19.5,37431,NULL,NULL,'H','NGC 4129',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89355,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89355,31.49,0.45,19.8,37431,NULL,NULL,'K','NGC 4129',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89356,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89356,31.53,0.46,20.2,37431,NULL,NULL,'J','NGC 4129',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89357,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89357,31.57,0.4,20.6,37431,NULL,NULL,'mean','NGC 4129',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89358,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89358,31.63,0.2,21.2,37431,74.4,NULL,NULL,'NGC 4129',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89359,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89359,31.83,0.54,23.2,37431,NULL,NULL,NULL,'NGC 4129',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89360,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89360,31.84,0.53,23.4,37431,NULL,NULL,'Malmquist cor.','NGC 4129',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89361,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89361,32.06,0.49,25.8,37431,75,NULL,'IR','NGC 4129',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89362,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89362,38.15,0.46,426,37432,70,NULL,NULL,'SDSS J120853.72+620021.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000144,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,182.223833,62.00594,0.017,NULL,57370625499,896416023,14006500,18.4),(89363,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89363,37.65,0.14,339,37433,70,NULL,NULL,'2MASX J12085383+1457320',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000141,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,182.2244583,14.95892,0.124,NULL,58176641417,909010022,14203281,18),(89364,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89364,38.62,0.27,530,37434,70,NULL,NULL,'2MASX J12085397+0710327',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000172,NULL,'17.6g',NULL,NULL,NULL,NULL,NULL,NULL,1,182.224833,7.17572,0,NULL,58032051493,906750804,14167981,17.6),(89365,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89365,37.21,0.46,276,37435,70,NULL,NULL,'2MASX J12085395+4133093',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,182.224833,41.55258,0,NULL,58535114045,914611156,14290799,17.1),(89366,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89366,37.22,0.46,278,37436,70,NULL,NULL,'2MASX J12085487+4835133',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000183,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,182.228625,48.58692,0,NULL,57190956274,893608691,13962635,17.9),(89367,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89367,29.56,0.43,8.1,37437,75,NULL,'3.6 micron, color + selection bias corrected','UGC 07129',NULL,'2014MNRAS.444..527S',2014,1,1.25,'HOLM 338B is a double star.','G',0.000014,NULL,'13.9g',0.91,'Sab            HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,182.2295,41.74086,0,NULL,58535591365,914618615,14290915,13.9),(89368,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89368,29.89,0.43,9.5,37437,75,NULL,'3.6 micron, color corrected','UGC 07129',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89369,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89369,31.32,0.4,18.4,37437,NULL,NULL,'mean','UGC 07129',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89370,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89370,31.9,0.47,24,37437,NULL,NULL,'H','UGC 07129',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89371,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89371,31.93,0.45,24.4,37437,NULL,NULL,'K','UGC 07129',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89372,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89372,31.96,0.46,24.7,37437,NULL,NULL,'J','UGC 07129',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89373,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89373,35.11,0.14,105,37438,70,NULL,NULL,'CGCG 128-040',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000103,NULL,'15.50',0.4,'S0/a','Field galaxy',NULL,NULL,NULL,1,182.230583,25.19172,0.068,NULL,58598997462,915609335,14306395,15.5),(89374,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89374,37.28,0.46,285,37439,70,NULL,NULL,'B3 1206+469',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,182.231667,46.68717,0,NULL,57180489744,893445152,13960080,17.2),(89375,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89375,37.62,0.15,335,37440,70,NULL,NULL,'SDSS J120855.83+531924.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,182.232625,53.3235,0.028,NULL,57225465858,894147904,13971061,17.6),(89376,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89376,37.44,0.33,308,37441,70,NULL,NULL,'2MASX J12085694+5101413',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000135,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,182.237166667,51.02817,0.049,NULL,57231943249,894249113,13972642,18.2),(89377,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89377,37.65,0.14,339,37442,70,NULL,NULL,'SDSS J120857.18+144947.7',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00018,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,182.238291667,14.82992,0.131,NULL,58143604886,908493826,14195216,16.7),(89378,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89378,37.59,0.46,330,37443,70,NULL,NULL,'2MASX J12085721+1302090',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000154,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,182.238583,13.03597,0.023,NULL,58149211483,908581429,14196584,17.4),(89379,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89379,37.77,0.46,358,37444,70,NULL,NULL,'2MASX J12085735+0250358',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000073,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,182.239167,2.84336,0,NULL,57992683290,906135676,14158369,17.6),(89380,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89380,38.62,0.27,530,37445,70,NULL,NULL,'SDSS J120857.81+072016.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000147,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,182.240917,7.33792,0,NULL,58032077487,906751210,14167987,18.6),(89381,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89381,37.79,0.27,362,37446,70,NULL,NULL,'2MASX J12085785+2410383',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,182.241,24.17725,0.086,NULL,58601402248,915646910,14306982,NULL),(89382,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89382,37.4,0.46,302,37447,70,NULL,NULL,'2MASX J12085863+5505067',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,182.244458333,55.08536,0,NULL,57214410285,893975160,13968361,18.1),(89383,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89383,36.89,0.46,239,37448,70,NULL,NULL,'2MASX J12085981+2255090',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.93',0.14,NULL,NULL,NULL,NULL,NULL,1,182.249167,22.91925,0.089,NULL,58587736139,915433377,14303646,17.93),(89384,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89384,37.57,0.46,327,37449,70,NULL,NULL,'2MASX J12085989+6040121',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,182.249417,60.67003,0,NULL,57340265945,895941655,13999088,17.5),(89385,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89385,37.7,0.46,347,37450,70,NULL,NULL,'2MASX J12090004+0833057',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,182.25,8.55147,0,NULL,58017902682,906529729,14164527,17.9),(89386,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89386,31.94,0.4,24.5,37451,75,NULL,NULL,'IC 3015',NULL,'2008Ap.....51..336K',2008,1,2.9,NULL,'G',0.000017,NULL,'13.14',0.7,'Sbc: sp        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,182.251167,-31.51989,0.305,NULL,43370580678,677665323,10588520,13.14),(89387,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89387,31.96,0.46,24.7,37451,NULL,NULL,'J','IC 3015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89388,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89388,32.02,0.47,25.4,37451,NULL,NULL,'H','IC 3015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89389,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89389,32.07,0.45,25.9,37451,NULL,NULL,'K','IC 3015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89390,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89390,32.2,0.49,27.6,37451,75,NULL,'IR','IC 3015',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89391,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89391,32.46,0.4,31.1,37451,NULL,NULL,'mean','IC 3015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89392,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89392,38.29,0.46,455,37452,70,NULL,NULL,'SDSS J120901.24+354431.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000166,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,182.2552083,35.74194,0,NULL,58551686280,914870098,14294845,18.3),(89393,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89393,36.35,0.46,187,37453,70,NULL,NULL,'2MASX J12090167+2558163',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00008,NULL,'16.3g',0.3,'Elliptical','Field galaxy',NULL,NULL,NULL,1,182.256875,25.97117,0.053,NULL,58597420546,915584696,14306010,16.3),(89394,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89394,35.11,0.14,105,37454,70,NULL,NULL,'2MASX J12090199+2457173',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000083,NULL,'15.6g',0.39,'E','Field galaxy',NULL,NULL,NULL,1,182.258375,24.95489,0.068,NULL,58602476227,915663691,14307245,15.6),(89395,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89395,37.22,0.46,278,37455,70,NULL,NULL,'2MASX J12090204+3208552',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00018,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,182.258417,32.14872,0,NULL,58622104198,915970378,14312037,16.4),(89396,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89396,38.3,0.33,457,37456,70,NULL,NULL,'SDSS J120902.02+064132.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,182.258458333,6.69239,0,NULL,58029221604,906706587,14167290,18.1),(89397,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89397,38.19,0.46,435,37457,70,NULL,NULL,'2MASX J12090236+6209101',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,182.2597083,62.15267,0.025,NULL,57370725363,896417583,14006524,17.9),(89398,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89398,37.54,0.46,323,37458,70,NULL,NULL,'SDSS J120902.39+132707.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000154,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,182.2599583,13.45211,0.011,NULL,58146424477,908537882,14195904,18),(89399,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89399,37.9,0.46,380,37459,70,NULL,NULL,'2MASX J12090724+6044371',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000175,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,182.2802083,60.74378,0,NULL,57340271947,895941749,13999089,17.6),(89400,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89400,38.92,0.46,608,37460,70,NULL,NULL,'SDSS J120907.34+660804.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000182,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,182.280583,66.13461,0.033,NULL,57315028668,895547322,13992926,18.1),(89401,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89401,37.88,0.46,377,37461,70,NULL,NULL,'2MASX J12090751+3101023',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,182.281208333,31.01744,0.054,NULL,58633733735,916152089,14314876,17.6),(89402,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89402,37.16,0.46,270,37462,70,NULL,NULL,'2MASX J12090778+6240121',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000204,NULL,'15.8g',0.5,'S0^-',NULL,NULL,NULL,NULL,1,182.2822917,62.67,0,NULL,57315576052,895555875,13993060,15.8),(89403,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89403,36.11,0.65,167,37463,70,NULL,NULL,'2MASX J12090775-1115312',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.74',NULL,NULL,NULL,NULL,NULL,NULL,1,182.282375,-11.25889,0.161,NULL,43185747010,674777297,10543395,16.74),(89404,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89404,38.51,0.46,503,37464,70,NULL,NULL,'2MASX J12090834+1412530',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000147,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,182.284666667,14.21481,0.022,NULL,58143682932,908495045,14195235,18.6),(89405,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89405,36.78,0.46,227,37465,70,NULL,NULL,'2MASX J12090847+6042141',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,182.2850417,60.70381,0,NULL,57340270783,895941730,13999089,17.4),(89406,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89406,37.74,0.46,353,37466,70,NULL,NULL,'2MASX J12090878+0957177',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,182.286417,9.95489,0,NULL,58203499421,909429678,14209838,17.1),(89407,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89407,35.33,0.27,116,37467,70,NULL,NULL,'UGC 07132',NULL,'2015arXiv151105856S',2015,1,1.02,NULL,'G',0.00008,NULL,'14.0g',0.98,'E',NULL,NULL,NULL,NULL,1,182.2909583,31.5695,0.041,NULL,58622578656,915977791,14312152,14),(89408,'IRAS','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89408,33.71,0.8,55.2,37468,75,NULL,'CF, r','NGC 4134',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.00002,NULL,'13.59',0.9,'Sb','in a radial-velocity based grouping',NULL,NULL,NULL,1,182.2917083,29.17692,0.022,NULL,58625268847,916019825,14312809,13.59),(89409,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89409,33.58,0.38,52.1,37468,75,NULL,'CF, r, raw','NGC 4134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89410,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89410,33.62,0.47,52.9,37468,NULL,NULL,'H','NGC 4134',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89411,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89411,33.66,0.46,53.9,37468,NULL,NULL,'J','NGC 4134',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89412,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89412,33.71,0.45,55.2,37468,NULL,NULL,'K','NGC 4134',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89413,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89413,33.71,0.38,55.3,37468,75,NULL,'CF, r, inv','NGC 4134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89414,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89414,33.74,0.38,55.9,37468,75,NULL,'CF, r, cor','NGC 4134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89415,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89415,33.87,0.4,59.5,37468,NULL,NULL,'mean','NGC 4134',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89416,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89416,37.68,0.46,344,37469,70,NULL,NULL,'2MASX J12090997+2733383',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000179,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,182.2917917,27.56056,0.035,NULL,58644753922,916324280,14317566,17.2),(89417,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89417,37.65,0.14,339,37470,70,NULL,NULL,'2MASX J12091005+1503000',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000177,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,182.291917,15.04994,0.117,NULL,58176935357,909014614,14203353,17.1),(89418,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89418,38.19,0.46,434,37471,70,NULL,NULL,'2MASX J12091119+2504263',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,182.296583,25.07392,0.068,NULL,58602427320,915662926,14307233,17.9),(89419,'Brightest Stars','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89419,30.8,NULL,14,37472,NULL,NULL,NULL,'UGC 07131',NULL,'1998A&AS..128..459M',1998,1,1.5,'Multiple SDSS entries describe this source.','G',0.000013,NULL,'15.10',0.4,'Sdm:',NULL,NULL,NULL,NULL,1,182.299083,30.90678,0.048,NULL,58633716949,916151827,14314872,15.1),(89420,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89420,31.13,NULL,16.8,37472,NULL,NULL,NULL,'UGC 07131',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89421,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89421,38.42,0.46,483,37473,70,NULL,NULL,'2MASX J12091257+3537253',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,182.302375,35.62367,0,NULL,58551679448,914869991,14294843,17.5),(89422,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89422,36.86,0.46,236,37474,70,NULL,NULL,'2MASX J12091466+6738251',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000107,NULL,'16.0g',0.37,'E0',NULL,NULL,NULL,NULL,1,182.311375,67.64036,0.021,NULL,57848808764,903887636,14123244,16),(89423,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89423,37.25,0.46,282,37475,70,NULL,NULL,'2MASX J12091475+2330226',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.11',0.15,NULL,NULL,NULL,NULL,NULL,1,182.311541667,23.50622,0.094,NULL,58588009092,915437642,14303713,18.11),(89424,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89424,34.88,0.46,94.7,37476,70,NULL,NULL,'CGCG 215-035',NULL,'2015arXiv151105856S',2015,1,0.95,NULL,'G',0.00016,NULL,'14.5g',0.78,'E0',NULL,NULL,NULL,NULL,1,182.313833,41.61103,0,NULL,58535088639,914610759,14290793,14.5),(89425,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89425,37.73,0.11,352,37477,70,NULL,NULL,'2MASX J12091624+0535324',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000147,NULL,'15.6g',0.49,'E0',NULL,NULL,NULL,NULL,1,182.317625,5.59244,0,NULL,58038803988,906856312,14169629,15.6),(89426,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89426,36.31,0.46,182,37478,70,NULL,NULL,'2MASX J12091644+3352313',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'15.99',0.26,NULL,NULL,NULL,NULL,NULL,1,182.3184583,33.87525,0,NULL,58756411086,918068923,14344826,15.99),(89427,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89427,37.8,0.33,363,37479,70,NULL,NULL,'2MASX J12091647+2749273',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,182.318625,27.82419,0.028,NULL,58644157865,916314966,14317421,18.1),(89428,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89428,36.3,0.46,182,37480,70,NULL,NULL,'2MASX J12091715+3639026',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000167,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,182.321417,36.65061,0,NULL,58548582913,914821608,14294087,16.9),(89429,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89429,37.73,0.11,352,37481,70,NULL,NULL,'2MASX J12091725+0519074',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,182.321875,5.31869,0.015,NULL,58039643510,906869429,14169834,17.3),(89430,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89430,37.39,0.33,300,37482,70,NULL,NULL,'2MASX J12091757+1502200',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000162,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,182.32325,15.03886,0.12,NULL,58176940185,909014690,14203354,17),(89431,'Ring Diameter','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89431,29.5,0.98,7.9,37483,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4136',NULL,'1981ApJS...45..541P',1981,1,4,NULL,'G',0.00002,NULL,'11.69',3.7,'SAB(r)c        HII','Probable group member',NULL,NULL,NULL,1,182.3237083,29.92761,0.022,NULL,58635705291,916182895,14315357,11.69),(89432,'Ring Diameter','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89432,31.5,0.76,20,37483,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4136',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89433,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89433,29.93,0.4,9.7,37483,75,NULL,'B','NGC 4136',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89434,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89434,36.07,0.46,163,37484,70,NULL,NULL,'2MASX J12091813+2112056',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.87',0.2,NULL,NULL,NULL,NULL,NULL,1,182.325625,21.20178,0.029,NULL,58856180315,919627817,14369184,17.87),(89435,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89435,37.62,0.15,335,37485,70,NULL,NULL,'2MASX J12091853+5318242',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000193,NULL,'16.5g',0.33,'BrClG          AGN',NULL,NULL,NULL,NULL,1,182.327125,53.30656,0.028,NULL,57225300436,894145319,13971020,16.5),(89436,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89436,37.44,0.33,308,37486,70,NULL,NULL,'2MASX J12091895+5056132',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000203,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,182.329167,50.93708,0.049,NULL,57231607776,894243871,13972560,16.5),(89437,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89437,36.77,0.46,226,37487,70,NULL,NULL,'2MASX J12092010+3036503',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000157,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,182.333875,30.61381,0.053,NULL,58635491182,916179549,14315305,16.8),(89438,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89438,36.82,0.46,231,37488,70,NULL,NULL,'2MASX J12092090+2831527',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000177,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,182.3372917,28.53144,0.018,NULL,58625480111,916023126,14312861,16.4),(89439,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89439,35.79,0.8,144,37489,70,NULL,NULL,'2MASX J12092106-1235584',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,182.33775,-12.59958,0.189,NULL,43064761650,672886900,10513857,14.7),(89440,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89440,38.32,0.33,461,37490,70,NULL,NULL,'2MASX J12092130+5900079',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,182.338583333,59.00231,0,NULL,57341864879,895966638,13999478,17.5),(89441,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89441,38.51,0.46,503,37491,70,NULL,NULL,'SDSS J120921.31+181147.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,182.338833,18.19667,0.064,NULL,58129705364,908276646,14191822,18.5),(89442,'GCLF','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89442,31.06,0.55,16.3,37492,NULL,NULL,'TOM(g) = -7.2 mag','IC 3019',NULL,'2007ApJS..171..101J',2007,1,1.17,NULL,'G',0.000111,NULL,'14.7g',1.04,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,182.34275,13.99242,0.022,NULL,58146566033,908540094,14195938,14.7),(89443,'GCLF','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89443,31.14,0.39,16.9,37492,NULL,NULL,'TOM(g) = -7.2 mag','IC 3019',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89444,'GCLF','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89444,31.23,0.37,17.6,37492,NULL,NULL,'TOM(u) = -8.4 mag','IC 3019',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89445,'GCLF','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89445,31.36,0.26,18.7,37492,NULL,NULL,'TOM(z) = -8.53 mag','IC 3019',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89446,'SBF','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89446,31,0.1,15.9,37492,NULL,NULL,'R','IC 3019',NULL,'2004AJ....127..771J',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89447,'SBF','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89447,31.15,0.14,17,37492,74.4,NULL,NULL,'IC 3019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89448,'SBF','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89448,31.17,0.09,17.1,37492,NULL,NULL,'HST ACS VCS','IC 3019',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89449,'SBF','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89449,31.17,0.09,17.1,37492,NULL,NULL,NULL,'IC 3019',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89450,'GC radius','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89450,30.44,0.14,12.2,37492,NULL,NULL,NULL,'IC 3019',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89451,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89451,37.04,0.46,256,37493,70,NULL,NULL,'2MASX J12092303+0931518',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000026,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,182.346083,9.53108,0,NULL,58202038294,909406848,14209482,17.8),(89452,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89452,32.53,NULL,32,37494,NULL,NULL,NULL,'IC 3018',NULL,'2014A&A...562A..49M',2014,1,0.68,'Often mistakenly called IC 3017.','G',0.000033,NULL,'15.7g',0.29,'BCD            HII','Group member',NULL,NULL,NULL,1,182.354,13.57444,0.011,NULL,58146475022,908538672,14195916,15.7),(89453,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89453,38.06,0.46,410,37495,70,NULL,NULL,'SDSS J120925.12+264836.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00019,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,182.3547083,26.81011,0.041,NULL,58642341858,916286591,14316977,18),(89454,'IRAS','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89454,32.16,0.8,27,37496,75,NULL,'MAT, I','ESO 441- G 011',NULL,'1997ApJS..109..333W',1997,1,2.13,NULL,'G',0.000013,NULL,'15.55',0.25,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,182.354875,-28.80153,0.257,NULL,43380527289,677820738,10590949,15.55),(89455,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89455,31.89,0.32,23.9,37496,85,NULL,'I, inv','ESO 441- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89456,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89456,31.93,0.32,24.3,37496,85,NULL,'I, raw','ESO 441- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89457,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89457,32.18,0.2,27.3,37496,74.4,NULL,NULL,'ESO 441- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89458,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89458,32.28,0.43,28.6,37496,75,NULL,'MAT, I, inv','ESO 441- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89459,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89459,32.29,0.43,28.7,37496,75,NULL,'3.6 micron, color corrected','ESO 441- G 011',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89460,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89460,32.33,0.43,29.3,37496,75,NULL,'3.6 micron, color + selection bias corrected','ESO 441- G 011',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89461,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89461,32.35,0.76,29.5,37496,NULL,NULL,NULL,'ESO 441- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89462,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89462,32.37,0.43,29.8,37496,75,NULL,'MAT, I, raw','ESO 441- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89463,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89463,32.39,0.75,30,37496,NULL,NULL,'Malmquist cor.','ESO 441- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89464,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89464,32.52,NULL,31.9,37496,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 441- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89465,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89465,32.54,NULL,32.1,37496,NULL,NULL,'Dipole + Quadrupole','ESO 441- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89466,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89466,32.54,NULL,32.2,37496,NULL,NULL,'Dipole','ESO 441- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89467,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89467,32.6,0.43,33.2,37496,75,NULL,'MAT, I, cor','ESO 441- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89468,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89468,32.62,NULL,33.4,37496,NULL,NULL,NULL,'ESO 441- G 011',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89469,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89469,32.69,0.4,34.5,37496,75,NULL,NULL,'ESO 441- G 011',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89470,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89470,32.98,0.49,39.5,37496,75,NULL,'IR','ESO 441- G 011',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89471,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89471,36.98,0.46,249,37497,70,NULL,NULL,'2MASX J12092528+4155207',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000181,NULL,'16.1g',0.39,'E0',NULL,NULL,NULL,NULL,1,182.3552917,41.92261,0,NULL,58534745595,914605399,14290709,16.1),(89472,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89472,37.36,0.46,296,37498,70,NULL,NULL,'2MASX J12092549+4632582',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000173,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,182.356291667,46.54939,0,NULL,57178484907,893413826,13959591,16.6),(89473,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89473,36.16,0.46,170,37499,70,NULL,NULL,'2MASX J12092609+4411380',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000178,NULL,'16.1g',0.26,'S0',NULL,NULL,NULL,NULL,1,182.35875,44.19386,0,NULL,59059522279,922805035,14418828,16.1),(89474,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89474,38.3,0.33,457,37500,70,NULL,NULL,'SDSS J120926.72+063550.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000155,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,182.361375,6.59728,0,NULL,58029243628,906706931,14167295,18.3),(89475,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89475,32.37,0.4,29.8,37501,75,NULL,NULL,'ESO 441- G 012',NULL,'2008Ap.....51..336K',2008,1,1.6,NULL,'G',0.000033,NULL,'14.52',0.3,'Sab: sp',NULL,NULL,NULL,NULL,1,182.363125,-32.51514,0.289,NULL,43438806925,678731358,10605177,14.52),(89476,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89476,32.67,0.4,34.2,37501,NULL,NULL,'mean','ESO 441- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89477,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89477,32.71,0.47,34.8,37501,NULL,NULL,'H','ESO 441- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89478,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89478,32.76,0.45,35.6,37501,NULL,NULL,'K','ESO 441- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89479,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89479,32.78,0.46,36,37501,NULL,NULL,'J','ESO 441- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89480,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89480,32.97,0.49,39.3,37501,75,NULL,'IR','ESO 441- G 012',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89481,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89481,36.54,0.46,203,37502,70,NULL,NULL,'IC 3020',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00019,NULL,'16.2g',0.32,NULL,NULL,NULL,NULL,NULL,1,182.363416667,14.2245,0.022,NULL,58143730739,908495792,14195246,16.2),(89482,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89482,37.19,0.46,274,37503,70,NULL,NULL,'2MASX J12092745+2212257',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.21',0.13,NULL,NULL,NULL,NULL,NULL,1,182.364541667,22.20725,0.058,NULL,58856905936,919639155,14369361,18.21),(89483,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89483,37.53,0.27,320,37504,70,NULL,NULL,'2MASX J12092754+1048408',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000216,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,182.364667,10.81142,0,NULL,58203291776,909426434,14209788,16.6),(89484,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89484,35.55,NULL,129,37505,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG +11-15-029',NULL,'2010Ap&SS.325..163P',2010,1,0.91,NULL,'G',0.000159,NULL,'16.7g',0.15,'Sd(f)',NULL,NULL,NULL,NULL,1,182.367917,66.17544,0.033,NULL,57314995149,895546799,13992918,16.7),(89485,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89485,35.57,NULL,130,37505,NULL,NULL,'Dipole + Quadrupole','MCG +11-15-029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89486,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89486,35.59,NULL,131,37505,NULL,NULL,'Dipole','MCG +11-15-029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89487,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89487,35.6,NULL,132,37505,NULL,NULL,NULL,'MCG +11-15-029',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89488,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89488,35.82,0.49,146,37505,75,NULL,'IR','MCG +11-15-029',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89489,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89489,37.53,0.27,320,37506,70,NULL,NULL,'2MASX J12092863+1051068',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,182.369083,10.852,0,NULL,58203294090,909426470,14209788,17.4),(89490,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89490,37.25,0.46,281,37507,70,NULL,NULL,'2MASX J12092922+4843353',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,182.371833333,48.72656,0,NULL,57193009631,893640775,13963137,16.8),(89491,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89491,37.78,0.33,360,37508,70,NULL,NULL,'2MASX J12092927+1604160',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000178,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,182.372,16.07125,0.11,NULL,58178263024,909035359,14203677,18.5),(89492,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89492,37.87,0.46,375,37509,70,NULL,NULL,'2MASX J12092969+3607497',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,182.373625,36.13044,0,NULL,58552465454,914882272,14295035,17.3),(89493,'SBF','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89493,30.7,0.26,13.8,37510,NULL,NULL,'I','NGC 4138',NULL,'2001ApJ...546..681T',2001,1,2.6,'Bright foreground star 4\\\" from nucleus.','G',0.000007,NULL,'12.16',1.7,'SA(r)0+        Sy1.9','in a radial-velocity based grouping',NULL,NULL,'Sy 1.9',1,182.374083333,43.68531,0,NULL,58521344112,914396001,14287437,12.16),(89494,'SBF','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89494,31.02,0.12,16,37510,74.4,NULL,NULL,'NGC 4138',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89495,'Ring Diameter','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89495,32.8,0.84,36,37510,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4138',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89496,'Tully est','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89496,31.15,0.8,17,37510,75,NULL,'B','NGC 4138',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89497,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89497,31,0.07,15.9,37510,NULL,NULL,NULL,'NGC 4138',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89498,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89498,31.02,0.12,16,37510,74.4,NULL,NULL,'NGC 4138',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89499,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89499,31.12,NULL,16.7,37510,NULL,NULL,'I, Hubble-type-TF','NGC 4138',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89500,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89500,31.23,NULL,17.6,37510,NULL,NULL,'I','NGC 4138',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89501,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89501,31.78,NULL,22.7,37510,NULL,NULL,'B, Hubble-type-TF','NGC 4138',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89502,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89502,31.97,NULL,24.8,37510,NULL,NULL,'B','NGC 4138',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89503,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89503,37.96,0.46,392,37511,70,NULL,NULL,'SDSS J120929.81+015816.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000076,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,182.3742083,1.97125,0,NULL,57995359710,906177495,14159023,18.7),(89504,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89504,36.31,0.46,183,37512,70,NULL,NULL,'2MASX J12092991+0507154',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,182.374833333,5.121,0.015,NULL,58039715020,906870547,14169852,17.2),(89505,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89505,37.98,0.46,395,37513,70,NULL,NULL,'2MASX J12092995+4207561',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,182.375,42.13222,0,NULL,58534907370,914607927,14290748,17.8),(89506,'IRAS','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89506,31.63,0.8,21.2,37514,75,NULL,'A82, H','NGC 4142',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000023,NULL,'13.89',1.2,'SB(s)d:','in a radial-velocity based grouping',NULL,NULL,NULL,1,182.3757917,53.10494,0.028,NULL,57217137479,894017773,13969027,13.89),(89507,'IRAS','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89507,31.7,0.8,21.9,37514,75,NULL,'W91CL, r','NGC 4142',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89508,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89508,31.73,0.4,22.1,37514,75,NULL,'B','NGC 4142',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89509,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89509,31.93,0.36,24.3,37514,NULL,NULL,NULL,'NGC 4142',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89510,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89510,32.06,0.47,25.9,37514,75,NULL,'A82, H, inv','NGC 4142',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89511,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89511,32.12,0.2,26.6,37514,74.4,NULL,NULL,'NGC 4142',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89512,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89512,32.15,0.43,27,37514,75,NULL,'3.6 micron, color corrected','NGC 4142',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89513,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89513,32.17,0.47,27.2,37514,75,NULL,'A82, H, raw','NGC 4142',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89514,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89514,32.17,0.43,27.2,37514,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4142',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89515,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89515,32.21,0.38,27.6,37514,75,NULL,'W91CL, r, inv','NGC 4142',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89516,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89516,32.25,0.38,28.1,37514,75,NULL,'W91CL, r, raw','NGC 4142',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89517,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89517,32.43,0.38,30.6,37514,75,NULL,'W91CL, r, cor','NGC 4142',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89518,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89518,32.5,0.47,31.6,37514,75,NULL,'A82, H, cor','NGC 4142',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89519,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89519,37.62,0.15,335,37515,70,NULL,NULL,'2MASX J12093028+5317233',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,182.376,53.28994,0.028,NULL,57225311463,894145491,13971023,17.3),(89520,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89520,37.78,0.33,360,37516,70,NULL,NULL,'2MASX J12093030+1557390',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000145,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,182.37625,15.96083,0.116,NULL,58178229784,909034840,14203669,17),(89521,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89521,37.92,0.46,383,37517,70,NULL,NULL,'2MASX J12093142+2228476',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,182.381,22.47997,0.075,NULL,58857029917,919641092,14369392,17.9),(89522,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89522,36.69,0.33,218,37518,70,NULL,NULL,'2MASX J12093231+2930108',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000137,NULL,'16.7g',0.26,'Sa',NULL,NULL,NULL,NULL,1,182.384541667,29.50294,0.024,NULL,58632806443,916137600,14314650,16.7),(89523,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89523,38.96,0.46,619,37519,70,NULL,NULL,'2MASX J12093282+5518458',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,182.3867917,55.31278,0,NULL,57213902247,893967222,13968237,18),(89524,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89524,37.09,0.46,262,37520,70,NULL,NULL,'2MASX J12093318+0340434',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000066,NULL,'17.5g',0.16,'NLAGN',NULL,NULL,NULL,NULL,1,182.388333333,3.67878,0,NULL,58038628466,906853569,14169587,17.5),(89525,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89525,38.32,0.33,461,37521,70,NULL,NULL,'2MASX J12093349+5904088',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000172,NULL,'17.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,182.389333333,59.06911,0,NULL,57341897293,895967145,13999486,17.3),(89526,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89526,37.73,0.11,352,37522,70,NULL,NULL,'2MASX J12093463+0530326',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000187,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,182.394333,5.50914,0,NULL,58038809859,906856404,14169631,16.9),(89527,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89527,36.8,0.46,230,37523,70,NULL,NULL,'2MASX J12093522-0054450',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000107,NULL,'15.9g',0.43,'E0',NULL,NULL,NULL,NULL,1,182.396791667,-0.91247,0.037,NULL,42964344768,671317887,10489341,15.9),(89528,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89528,36.89,0.46,238,37524,70,NULL,NULL,'2MASX J12093519+3051201',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00015,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,182.396791667,30.85572,0.048,NULL,58633595750,916149933,14314842,17.1),(89529,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89529,37.09,0.46,262,37525,70,NULL,NULL,'2MASX J12093535+1847586',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.90',0.17,NULL,NULL,NULL,NULL,NULL,1,182.3972917,18.79981,0.043,NULL,58132616327,908322130,14192533,17.9),(89530,'SBF','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89530,30.85,0.19,14.8,37526,NULL,NULL,'I','NGC 4143',NULL,'2003ApJ...583..712J',2003,1,2.32,NULL,'G',0.000017,NULL,'11.9g',1.15,'SAB(s)0^0^     LINER','Probable group member',NULL,NULL,'LINER b',1,182.40025,42.53417,0,NULL,58532860419,914575944,14290249,11.9),(89531,'SBF','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89531,31,0.14,15.9,37526,74.4,NULL,NULL,'NGC 4143',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89532,'SBF','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89532,31.01,0.19,15.9,37526,NULL,NULL,'I','NGC 4143',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89533,'Faber-Jackson','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89533,31.74,0.65,22.3,37526,95,NULL,'Weighted Mean','NGC 4143',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89534,'Faber-Jackson','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89534,33.13,0.81,42.3,37526,55,NULL,'Visvanathan & Sandage 1979','NGC 4143',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89535,'Tully est','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89535,31.15,0.8,17,37526,75,NULL,'B','NGC 4143',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89536,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89536,31.39,0.4,19,37526,NULL,NULL,'mean','NGC 4143',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89537,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89537,31.79,0.45,22.8,37526,NULL,NULL,'K','NGC 4143',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89538,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89538,32.28,0.43,28.6,37527,75,NULL,'3.6 micron, color + selection bias corrected','ESO 505- G 023',NULL,'2014MNRAS.444..527S',2014,1,1.8,NULL,'G',0.000017,NULL,'15.26',0.7,'SB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,182.400958333,-23.41194,0.333,NULL,43355334947,677427108,10584798,15.26),(89539,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89539,37.52,0.46,319,37528,70,NULL,NULL,'2MASX J12093631+0614048',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,182.40125,6.23481,0,NULL,58028377985,906693406,14167084,17),(89540,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89540,37.65,0.46,339,37529,70,NULL,NULL,'2MASX J12093741+4633111',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000145,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,182.405875,46.55319,0,NULL,57178478165,893413721,13959589,18.4),(89541,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89541,37.29,0.46,287,37530,70,NULL,NULL,'2MASX J12093781+2208396',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.00',0.18,NULL,NULL,NULL,NULL,NULL,1,182.407583,22.1445,0.058,NULL,58856899629,919639056,14369360,18),(89542,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89542,36.46,0.33,196,37531,70,NULL,NULL,'2MASX J12093806+5802258',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00017,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,182.4087083,58.04058,0,NULL,57331803619,895809431,13997022,16.3),(89543,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89543,38.35,0.46,468,37532,70,NULL,NULL,'2MASX J12093897+6015264',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000175,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,182.4125,60.25725,0,NULL,57339315871,895926810,13998856,17.7),(89544,'IRAS','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89544,34.92,0.8,96.2,37533,75,NULL,'HMCL, I','UGC 07141',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.00004,NULL,'15.20',0.3,'S?',NULL,NULL,NULL,NULL,1,182.414666667,23.28939,0.094,NULL,58588052149,915438314,14303723,15.2),(89545,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89545,34.89,0.4,95.2,37533,75,NULL,'HMCL, I, raw','UGC 07141',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89546,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89546,34.9,0.49,95.4,37533,75,NULL,'IR','UGC 07141',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89547,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89547,35.07,0.4,103,37533,75,NULL,'HMCL, I, cor','UGC 07141',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89548,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89548,35.07,0.4,103,37533,75,NULL,'HMCL, I, inv','UGC 07141',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89549,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89549,38.55,0.46,512,37534,70,NULL,NULL,'2MASX J12094016+1317030',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000179,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,182.417458333,13.284,0.04,NULL,58146349876,908536716,14195886,18.2),(89550,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89550,37.46,0.46,310,37535,70,NULL,NULL,'2MASX J12094031+5745508',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,182.417833,57.76422,0,NULL,57331503712,895804745,13996949,17.1),(89551,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89551,37.71,0.46,348,37536,70,NULL,NULL,'2MASX J12094086+0110226',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000097,NULL,'16.2g',0.36,'NLAGN',NULL,NULL,NULL,'Sy 2',1,182.420333,1.17283,0.039,NULL,57997097326,906204645,14159447,16.2),(89552,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89552,37.93,0.46,385,37537,70,NULL,NULL,'2MASX J12094100+2550028',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,182.4207917,25.83414,0.055,NULL,58597436254,915584941,14306014,17.2),(89553,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89553,37.53,0.27,320,37538,70,NULL,NULL,'SDSS J120941.25+104533.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,182.421917,10.75936,0,NULL,58203287533,909426367,14209786,18),(89554,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89554,38.21,0.46,438,37539,70,NULL,NULL,'SDSS J120941.38+452347.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000126,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,182.4224583,45.39642,0,NULL,59059441793,922803778,14418809,18.7),(89555,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89555,36.91,0.46,241,37540,70,NULL,NULL,'LCRS B120707.7-031024',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000133,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,182.423125,-3.45142,0.077,NULL,43010588090,672040438,10500631,16.7),(89556,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89556,37.76,0.33,356,37541,70,NULL,NULL,'2MASX J12094167+3722027',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000151,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,182.423625,37.36731,0,NULL,58547217530,914800273,14293754,17.5),(89557,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89557,37.39,0.33,300,37542,70,NULL,NULL,'2MASX J12094222+1459550',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000144,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,182.425875,14.99869,0.12,NULL,58176918430,909014350,14203349,17.7),(89558,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89558,36.58,0.33,207,37543,70,NULL,NULL,'2MASX J12094221+3202592',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000099,NULL,'17.63',0.2,NULL,NULL,NULL,NULL,NULL,1,182.425958333,32.04967,0.01,NULL,58622137774,915970902,14312045,17.63),(89559,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89559,37.43,0.46,306,37544,70,NULL,NULL,'2MASX J12094324+1853016',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.09',0.17,NULL,NULL,NULL,NULL,NULL,1,182.4302083,18.88372,0.043,NULL,58132651854,908322685,14192541,18.09),(89560,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89560,38.59,0.46,522,37545,70,NULL,NULL,'2MASX J12094339+0757408',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,182.430916667,7.96119,0,NULL,58030283866,906723185,14167549,17.7),(89561,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89561,38.03,0.46,404,37546,70,NULL,NULL,'2MASX J12094363-0205000',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00015,NULL,'17.0g',0.27,'AGN',NULL,NULL,NULL,NULL,1,182.4317917,-2.08322,0.033,NULL,42962603947,671290686,10488916,17),(89562,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89562,38.44,0.46,488,37547,70,NULL,NULL,'2MASX J12094376+3549552',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000175,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,182.432333,35.83206,0,NULL,58552387225,914881050,14295016,17.9),(89563,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89563,36.67,0.46,216,37548,70,NULL,NULL,'2MASXi J1209443+151802',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,182.43475,15.30056,0.109,NULL,58176869467,909013585,14203337,17.8),(89564,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89564,36.34,0.2,185,37549,74.4,NULL,NULL,'VCC 0012',NULL,'2013AJ....146...86T',2013,1,0.82,NULL,'G',0.000013,NULL,'15.4g',0.42,'SBa(s)','Group member',NULL,NULL,NULL,1,182.434833,12.12575,0.01,NULL,58148608538,908572008,14196437,15.4),(89565,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89565,38.12,0.33,420,37550,70,NULL,NULL,'2MASX J12094456+2922288',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000119,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,182.435666667,29.37442,0.024,NULL,58632821981,916137843,14314653,18.4),(89566,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89566,36.87,0.46,236,37551,70,NULL,NULL,'2MASX J12094551+3210212',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000133,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,182.4397917,32.17253,0,NULL,58755486550,918054477,14344601,17.5),(89567,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89567,36.82,0.46,231,37552,70,NULL,NULL,'2MASX J12094556+5324043',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000173,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,182.4397917,53.40122,0.006,NULL,57225266356,894144786,13971012,16.6),(89568,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89568,33.21,NULL,43.8,37552,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07153',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89569,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89569,33.22,NULL,44,37552,NULL,NULL,'Dipole','UGC 07153',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89570,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89570,33.22,NULL,44,37552,NULL,NULL,'Dipole + Quadrupole','UGC 07153',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89571,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89571,33.23,0.2,44.3,37552,74.4,NULL,NULL,'UGC 07153',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89572,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89572,33.29,0.4,45.6,37552,75,NULL,NULL,'UGC 07153',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89573,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89573,33.31,0.52,46,37552,NULL,NULL,'Malmquist cor.','UGC 07153',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89574,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89574,33.32,0.52,46.1,37552,NULL,NULL,NULL,'UGC 07153',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89575,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89575,33.33,0.43,46.3,37552,75,NULL,'3.6 micron, color corrected','UGC 07153',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89576,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89576,33.38,0.43,47.4,37552,75,NULL,'3.6 micron, color + selection bias corrected','UGC 07153',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89577,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89577,33.57,0.4,51.8,37552,NULL,NULL,NULL,'UGC 07153',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89578,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89578,33.65,0.49,53.7,37552,75,NULL,'IR','UGC 07153',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89579,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89579,32.87,0.43,37.5,37553,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4141',NULL,'2014MNRAS.444..527S',2014,1,0.96,NULL,'G',0.000027,NULL,'14.6g',0.74,'SBcd:          HII',NULL,NULL,NULL,NULL,1,182.447167,58.84919,0,NULL,57341680329,895963755,13999433,14.6),(89580,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89580,38.26,0.46,448,37554,70,NULL,NULL,'SDSS J120947.47+464807.0',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000175,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,182.4477917,46.80194,0,NULL,57178599796,893415621,13959619,17.5),(89581,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89581,35.97,0.54,156,37555,70,NULL,NULL,'2MASX J12094835-1628117',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.16',0.5,NULL,NULL,NULL,NULL,NULL,1,182.451333,-16.47003,0.101,NULL,43073388915,673021701,10515964,16.16),(89582,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89582,37.96,0.46,391,37556,70,NULL,NULL,'2MASX J12094829+1420292',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000185,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,182.451417,14.34147,0.078,NULL,58143796852,908496825,14195262,17.5),(89583,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89583,37.73,0.11,352,37557,70,NULL,NULL,'SDSS J120949.38+053126.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000163,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,182.4557917,5.52414,0,NULL,58038792177,906856127,14169626,18.4),(89584,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89584,34.87,0.49,94.3,37558,75,NULL,'IR','UGC 07156',NULL,'2011yCatp016004901K',2011,1,1.39,NULL,'G',NULL,NULL,'16.5',0.12,'Scd',NULL,NULL,NULL,NULL,1,182.455875,77.7425,0.193,NULL,57012809979,890825155,13919143,16.5),(89585,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89585,35.36,NULL,118,37558,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07156',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89586,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89586,35.37,NULL,119,37558,NULL,NULL,'Dipole + Quadrupole','UGC 07156',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89587,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89587,35.38,NULL,119,37558,NULL,NULL,'Dipole','UGC 07156',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89588,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89588,35.4,NULL,120,37558,NULL,NULL,NULL,'UGC 07156',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89589,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89589,38.43,0.46,485,37559,70,NULL,NULL,'2MASX J12094942+3312532',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,182.456,33.21489,0,NULL,58758000273,918093754,14345214,18.4),(89590,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89590,37.6,0.46,331,37560,70,NULL,NULL,'2MASX J12094994+6751020',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00007,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,182.4577917,67.8505,0.029,NULL,57848878965,903888733,14123261,17.3),(89591,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89591,38.4,0.46,480,37561,70,NULL,NULL,'2MASX J12095048+6222275',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,182.460166667,62.37425,0,NULL,57370378302,896412160,14006440,17.7),(89592,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89592,38,0.46,398,37562,70,NULL,NULL,'SDSS J120950.52+503545.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,182.4605417,50.59606,0,NULL,57234984905,894296639,13973384,18.4),(89593,'IRAS','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89593,34.79,0.8,90.9,37563,75,NULL,'CF, r','UGC 07145',NULL,'1997ApJS..109..333W',1997,1,1.52,NULL,'G',0.000168,NULL,'14.7g',0.53,'Scd:',NULL,NULL,NULL,NULL,1,182.4624583,38.21861,0,NULL,58579442296,915303785,14301621,14.7),(89594,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89594,34.57,0.38,82.2,37563,75,NULL,'CF, r, raw','UGC 07145',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89595,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89595,34.7,0.38,86.9,37563,75,NULL,'CF, r, inv','UGC 07145',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89596,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89596,34.82,0.38,92,37563,75,NULL,'CF, r, cor','UGC 07145',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89597,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89597,37.31,0.46,290,37564,70,NULL,NULL,'2MASX J12095115+6817160',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000071,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,182.463,68.28786,0.009,NULL,57848484257,903882566,14123165,17.2),(89598,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89598,38.28,0.46,452,37565,70,NULL,NULL,'2MASX J12095148+2217587',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,182.464375,22.29958,0.058,NULL,58857397460,919646835,14369481,17.2),(89599,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89599,36.87,0.46,237,37566,70,NULL,NULL,'SDSS J120952.72-003250.9',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00009,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,182.469708333,-0.54747,0.005,NULL,42963510170,671304846,10489138,17.3),(89600,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89600,37.08,0.46,260,37567,70,NULL,NULL,'2MASX J12095436+6002255',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000181,NULL,'16.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,182.4767917,60.04061,0,NULL,57337485210,895898206,13998409,16.9),(89601,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89601,37.24,0.46,280,37568,70,NULL,NULL,'2MASX J12095443-0055050',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000095,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,182.476875,-0.91817,0.037,NULL,42964201206,671315643,10489306,16.7),(89602,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89602,37.86,0.46,372,37569,70,NULL,NULL,'2MASX J12095446+3110092',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00014,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,182.4769583,31.16917,0.054,NULL,58633680702,916151260,14314863,17.4),(89603,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89603,36.63,0.46,212,37570,70,NULL,NULL,'2MASX J12095595+5836398',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000177,NULL,'16.0g',0.41,'E0',NULL,NULL,NULL,NULL,1,182.4830417,58.61108,0,NULL,57330917788,895795590,13996806,16),(89604,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89604,37.76,0.46,357,37571,70,NULL,NULL,'2MASX J12095631+2918077',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00017,NULL,'16.7g',0.36,'E',NULL,NULL,NULL,NULL,1,182.484708333,29.30225,0.024,NULL,58632774939,916137108,14314642,16.7),(89605,'TRGB','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89605,28.43,0.1,4.85,37572,74.4,NULL,NULL,'KUG 1207+367',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000133,NULL,'15.5',0.25,'Spiral',NULL,NULL,NULL,NULL,1,182.4852917,36.43433,0,NULL,58552120206,914876878,14294951,15.5),(89606,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89606,37.99,0.46,397,37573,70,NULL,NULL,'2MASX J12095651+5646498',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000183,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,182.4852917,56.7805,0,NULL,57395575697,896805870,14012591,17),(89607,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89607,36.97,0.33,248,37574,70,NULL,NULL,'2MASX J12095656+5307113',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00016,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,182.4854583,53.11983,0.028,NULL,57225249494,894144523,13971008,16.6),(89608,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89608,35.62,0.46,133,37575,70,NULL,NULL,'2MASX J12095669+4705461',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000176,NULL,'15.9g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,182.4862917,47.096,0,NULL,57178299722,893410933,13959545,15.9),(89609,'FP','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89609,35.12,0.33,106,37576,70,NULL,NULL,'2MASX J12095696+3825263',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000177,NULL,'16.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,182.4875,38.42411,0,NULL,58581431838,915334872,14302107,16),(89610,'Brightest Stars','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89610,29.93,NULL,9.7,37577,NULL,NULL,NULL,'NGC 4144',NULL,'1998A&AS..131....1K',1998,1,6,NULL,'G',0.000003,NULL,'12.05',1.3,'SAB(s)cd? sp   HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,182.494167,46.45717,0,NULL,57178548235,893414816,13959606,12.05),(89611,'TRGB','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89611,28.32,0.05,4.61,37577,NULL,NULL,'I','NGC 4144',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89612,'TRGB','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89612,29.17,0.09,6.81,37577,74.4,NULL,NULL,'NGC 4144',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89613,'TRGB','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89613,29.3,0.1,7.24,37577,NULL,NULL,NULL,'NGC 4144',NULL,'2005Ap.....48..221T',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89614,'TRGB','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89614,29.36,0.03,7.45,37577,NULL,NULL,NULL,'NGC 4144',NULL,'2005AJ....129.1331S',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89615,'IRAS','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89615,29.02,0.8,6.37,37577,75,NULL,'A82, H','NGC 4144',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89616,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89616,28.07,0.4,4.1,37577,75,NULL,'B','NGC 4144',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89617,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89617,28.78,0.4,5.7,37577,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 4144',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89618,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89618,28.96,0.47,6.19,37577,75,NULL,'A82, H, inv','NGC 4144',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89619,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89619,28.99,0.43,6.3,37577,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4144',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89620,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89620,29.07,0.43,6.5,37577,75,NULL,'3.6 micron, color corrected','NGC 4144',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89621,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89621,29.12,0.35,6.67,37577,NULL,NULL,NULL,'NGC 4144',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89622,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89622,29.16,0.47,6.79,37577,75,NULL,'A82, H, raw','NGC 4144',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89623,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89623,29.17,0.09,6.81,37577,74.4,NULL,NULL,'NGC 4144',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89624,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89624,29.3,0.08,7.26,37577,NULL,NULL,NULL,'NGC 4144',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89625,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,NULL,89625,29.55,0.47,8.15,37577,75,NULL,'A82, H, cor','NGC 4144',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89626,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:04','1',NULL,'R',89626,30.12,0.49,10.5,37577,75,NULL,'IR','NGC 4144',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89627,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89627,37.48,0.46,314,37578,70,NULL,NULL,'2MASX J12095860+1550202',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000172,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,182.4942917,15.83906,0.101,NULL,58178395087,909037423,14203709,16.7),(89628,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89628,36.46,0.33,196,37579,70,NULL,NULL,'2MASX J12095878+5803368',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000165,NULL,'15.9g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,182.494917,58.06022,0,NULL,57331804420,895809444,13997022,15.9),(89629,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89629,37.68,0.33,344,37580,70,NULL,NULL,'2MASX J12095915+2511258',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000093,NULL,'18.08',0.18,'AGN',NULL,NULL,NULL,NULL,1,182.496541667,25.19053,0.06,NULL,58598975098,915608985,14306390,18.08),(89630,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89630,38.15,0.46,426,37581,70,NULL,NULL,'2MASX J12095920+2956002',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000129,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,182.496667,29.93347,0.033,NULL,58635664088,916182251,14315347,18.2),(89631,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89631,36.97,0.33,248,37582,70,NULL,NULL,'2MASX J12095953+5302073',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000146,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,182.4979583,53.03542,0.028,NULL,57217649326,894025770,13969152,17.1),(89632,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89632,35.65,0.46,135,37583,70,NULL,NULL,'2MASX J12100038+1036294',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000169,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,182.501625,10.608,0,NULL,58202951220,909421112,14209704,16.2),(89633,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89633,38.79,0.46,573,37584,70,NULL,NULL,'2MASX J12100064+6419246',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000141,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,182.502917,64.32356,0.005,NULL,57318026534,895594164,13993658,18.1),(89634,'IRAS','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89634,31.37,0.8,18.8,37585,75,NULL,'A82, H','NGC 4145',NULL,'1997ApJS..109..333W',1997,1,5.9,NULL,'G',0.000003,NULL,'11.78',4.3,'SAB(rs)d   HII/LINER','Pair member (points to parent)',NULL,NULL,NULL,1,182.506333,39.88386,0,NULL,58524803566,914450055,14288282,11.78),(89635,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89635,30.19,0.4,10.9,37585,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 4145',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89636,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89636,30.44,0.35,12.2,37585,NULL,NULL,NULL,'NGC 4145',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89637,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89637,30.97,0.3,15.7,37585,55,NULL,'B','NGC 4145',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89638,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89638,31.08,0.4,16.5,37585,NULL,NULL,'mean','NGC 4145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89639,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89639,31.56,0.46,20.5,37585,NULL,NULL,'J','NGC 4145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89640,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89640,31.57,0.45,20.6,37585,NULL,NULL,'K','NGC 4145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89641,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89641,31.58,0.4,20.7,37585,75,NULL,'B','NGC 4145',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89642,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89642,31.58,0.47,20.7,37585,NULL,NULL,'H','NGC 4145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89643,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89643,31.61,0.47,21,37585,75,NULL,'A82, H, raw','NGC 4145',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89644,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89644,31.67,0.47,21.6,37585,75,NULL,'A82, H, inv','NGC 4145',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89645,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89645,31.74,0.47,22.3,37585,75,NULL,'A82, H, cor','NGC 4145',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89646,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89646,29.43,NULL,7.69,37586,NULL,NULL,NULL,'IC 3023',NULL,'2013AJ....145..101K',2013,1,0.72,NULL,'G',0.000017,NULL,'16.2g',0.51,'Im:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,182.5072917,14.36686,0.078,NULL,58143788086,908496688,14195260,16.2),(89647,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89647,38.42,0.46,482,37587,70,NULL,NULL,'SDSS J121001.95+395602.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,182.508167,39.93414,0,NULL,58524782787,914449731,14288277,18.2),(89648,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89648,35.12,0.33,106,37588,70,NULL,NULL,'IC 3022',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000173,NULL,'14.2g',0.95,'E?',NULL,NULL,NULL,NULL,1,182.509916667,38.73997,0,NULL,58581824769,915341012,14302203,14.2),(89649,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89649,36.58,0.33,207,37589,70,NULL,NULL,'2MASX J12100252+3210412',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000151,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,182.510583,32.17808,0.01,NULL,58755505735,918054777,14344605,16.7),(89650,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89650,38.12,0.33,420,37590,70,NULL,NULL,'2MASX J12100341+2924168',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'19.02',0.13,NULL,NULL,NULL,NULL,NULL,1,182.514083333,29.40467,0.024,NULL,58632824617,916137884,14314654,19.02),(89651,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89651,37.61,0.27,332,37591,70,NULL,NULL,'2MASX J12100359+3156192',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,182.515083333,31.93878,0.01,NULL,58622615066,915978360,14312161,17.2),(89652,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89652,36.21,0.58,174,37592,70,NULL,NULL,'2MASX J12100433-3432537',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,182.517958333,-34.54822,0.261,NULL,43254804356,675856318,10560254,15.8),(89653,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89653,37.73,0.11,352,37593,70,NULL,NULL,'SDSS J121004.69+052809.7',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,182.519541667,5.46939,0,NULL,58038915372,906858052,14169657,17.7),(89654,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89654,35.51,0.46,127,37594,70,NULL,NULL,'2MASX J12100502+1737303',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'16.85',0.21,NULL,NULL,NULL,NULL,NULL,1,182.5210417,17.62519,0.11,NULL,58129028811,908266075,14191657,16.85),(89655,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89655,37.61,0.27,332,37595,70,NULL,NULL,'2MASX J12100543+3157402',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,182.522583,31.96108,0.01,NULL,58622614944,915978358,14312161,17.2),(89656,'CMD','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89656,16.32,NULL,0.0184,37596,NULL,NULL,NULL,'NGC 4147',NULL,'2011MNRAS.416.2903D',2011,1,NULL,NULL,'*Cl',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,182.5257083,18.54214,0.057,1,58132753868,908324279,14192566,NULL),(89657,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89657,37.35,0.46,296,37597,70,NULL,NULL,'2MASX J12100741+3101202',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000176,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,182.530958333,31.02225,0.067,NULL,58633689148,916151392,14314865,17.1),(89658,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89658,38.59,0.46,523,37598,70,NULL,NULL,'2MASX J12100803+3103563',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000126,NULL,'18.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,182.533541667,31.06569,0.054,NULL,58633661452,916150960,14314858,18.1),(89659,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89659,37.58,0.46,328,37599,70,NULL,NULL,'2MASX J12100827+1205233',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,182.5345417,12.08989,0.01,NULL,58148719963,908573749,14196464,17.9),(89660,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89660,37.26,0.23,284,37600,70,NULL,NULL,'2MASX J12100871+5733359',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000204,NULL,'15.7g',0.46,'E0',NULL,NULL,NULL,NULL,1,182.536083,57.56,0,NULL,57331469806,895804215,13996940,15.7),(89661,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89661,38.59,0.46,521,37601,70,NULL,NULL,'2MASX J12100886+2544278',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,182.536958333,25.74089,0.053,NULL,58596668580,915572946,14305827,18.2),(89662,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89662,37.09,0.46,262,37602,70,NULL,NULL,'2MASX J12100932+2834508',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000174,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,182.5387917,28.58075,0.018,NULL,58625702682,916026604,14312915,17.2),(89663,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89663,36.99,0.46,250,37603,70,NULL,NULL,'2MASX J12100937+3251283',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000104,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,182.539125,32.85794,0,NULL,58757816641,918090885,14345170,17.3),(89664,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89664,37.26,0.23,284,37604,70,NULL,NULL,'2MASX J12101110+5749199',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.0002,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,182.5465,57.82225,0,NULL,57331534951,895805233,13996956,16.5),(89665,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89665,35.33,0.2,116,37605,74.4,NULL,NULL,'IC 3024',NULL,'2013AJ....146...86T',2013,1,1.15,NULL,'G',0.000033,NULL,'15.0g',0.38,'Sc','Group member',NULL,NULL,NULL,1,182.5497083,12.32567,0.017,NULL,58148735815,908573997,14196468,15),(89666,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89666,35.67,0.46,136,37606,70,NULL,NULL,'2MASX J12101248+0023037',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000068,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,182.551917,0.38431,0.017,NULL,57996958434,906202475,14159413,16.6),(89667,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89667,36.56,0.46,205,37607,70,NULL,NULL,'2MASX J12101319+3054263',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000173,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,182.5550417,30.90742,0.067,NULL,58633583560,916149743,14314839,17),(89668,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89668,37.61,0.27,332,37608,70,NULL,NULL,'2MASX J12101385+3154243',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00019,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,182.557625,31.90678,0.01,NULL,58622612543,915978320,14312161,17),(89669,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89669,37.9,0.46,381,37609,70,NULL,NULL,'2MASXi J1210139-002612',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000079,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,182.5579583,-0.43658,0.021,NULL,42963551282,671305488,10489148,17.3),(89670,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89670,33.24,0.2,44.5,37610,74.4,NULL,NULL,'ESO 441- G 014',NULL,'2013AJ....146...86T',2013,1,2.1,NULL,'G',0.000027,NULL,'15',0.6,'S...','in an interacting pair',NULL,NULL,NULL,1,182.558916667,-30.07817,0.245,NULL,43385675439,677901178,10592205,15),(89671,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89671,33.35,0.43,46.7,37610,75,NULL,'3.6 micron, color corrected','ESO 441- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89672,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89672,33.46,0.43,49.2,37610,75,NULL,'3.6 micron, color + selection bias corrected','ESO 441- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89673,'IRAS','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89673,32.12,0.8,26.6,37611,75,NULL,'A82, H','IC 0764',NULL,'1997ApJS..109..333W',1997,1,4.8,NULL,'G',0.00001,NULL,'12.75',1.6,'SA(s)c?        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,182.559125,-29.73681,0.245,NULL,43382071965,677844874,10591326,12.75),(89674,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89674,31.44,0.4,19.4,37611,73,NULL,'IR','IC 0764',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89675,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89675,31.44,0.4,19.5,37611,75,NULL,NULL,'IC 0764',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89676,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89676,31.63,0.38,21.2,37611,NULL,NULL,NULL,'IC 0764',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89677,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89677,31.69,0.2,21.8,37611,74.4,NULL,NULL,'IC 0764',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89678,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89678,31.81,0.43,23,37611,75,NULL,'3.6 micron, color corrected','IC 0764',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89679,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89679,31.85,0.46,23.5,37611,NULL,NULL,'Malmquist cor.','IC 0764',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89680,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89680,31.88,0.46,23.7,37611,NULL,NULL,NULL,'IC 0764',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89681,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89681,31.96,0.43,24.6,37611,75,NULL,'3.6 micron, color + selection bias corrected','IC 0764',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89682,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89682,32.05,0.49,25.7,37611,75,NULL,'IR','IC 0764',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89683,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89683,32.18,0.47,27.3,37611,75,NULL,'A82, H, raw','IC 0764',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89684,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89684,32.22,0.47,27.7,37611,75,NULL,'A82, H, inv','IC 0764',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89685,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89685,32.4,0.4,30.2,37611,75,NULL,'B','IC 0764',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89686,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89686,32.47,0.47,31.1,37611,NULL,NULL,'H','IC 0764',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89687,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89687,32.47,0.46,31.2,37611,NULL,NULL,'J','IC 0764',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89688,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89688,32.48,0.47,31.4,37611,75,NULL,'A82, H, cor','IC 0764',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89689,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89689,32.59,0.45,33,37611,NULL,NULL,'K','IC 0764',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89690,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89690,32.6,0.4,33.2,37611,NULL,NULL,'mean','IC 0764',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89691,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89691,35.28,0.33,114,37612,70,NULL,NULL,'CGCG 098-076',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00022,NULL,'15.81',0.4,'E',NULL,NULL,NULL,NULL,1,182.560958333,19.19372,0.035,NULL,58130932915,908295826,14192122,15.81),(89692,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89692,35.11,0.14,105,37613,70,NULL,NULL,'UGC 07157',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000087,NULL,'14.64',0.5,'S0','Group member',NULL,NULL,NULL,1,182.561125,25.30894,0.06,NULL,58599622922,915619108,14306548,14.64),(89693,'IRAS','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89693,34.77,0.8,89.7,37614,75,NULL,'HMCL, I','UGC 07162',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00007,NULL,'15.7',0.2,'S',NULL,NULL,NULL,NULL,1,182.561083,23.88797,0.091,NULL,58601737197,915652143,14307064,15.7),(89694,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89694,34.68,0.49,86.3,37614,75,NULL,'IR','UGC 07162',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89695,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89695,34.79,0.4,90.6,37614,75,NULL,'HMCL, I, raw','UGC 07162',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89696,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89696,34.97,0.4,98.8,37614,75,NULL,'HMCL, I, inv','UGC 07162',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89697,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89697,35,0.4,99.9,37614,75,NULL,'HMCL, I, cor','UGC 07162',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89698,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89698,35.09,0.4,104,37614,NULL,NULL,'mean','UGC 07162',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89699,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89699,35.35,0.47,117,37614,NULL,NULL,'H','UGC 07162',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89700,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89700,37.26,0.23,284,37615,70,NULL,NULL,'2MASX J12101486+5750129',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,182.562083,57.83692,0,NULL,57331545382,895805396,13996959,17.5),(89701,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89701,38.56,0.46,515,37616,70,NULL,NULL,'2MASX J12101522+4909481',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,182.5635417,49.16344,0.006,NULL,57187803804,893559434,13961866,18),(89702,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89702,37.73,0.11,352,37617,70,NULL,NULL,'SDSS J121015.54+052721.5',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,182.56475,5.456,0,NULL,58038933673,906858338,14169661,17.6),(89703,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89703,35.6,0.46,132,37618,70,NULL,NULL,'CGCG 013-090',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000107,NULL,'15.4g',0.58,'S0/a?',NULL,NULL,NULL,NULL,1,182.567625,-1.99303,0.033,NULL,42962721777,671292527,10488945,15.4),(89704,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89704,37.73,0.11,352,37619,70,NULL,NULL,'SDSS J121016.41+051027.4',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,182.568417,5.17428,0,NULL,58039563877,906868185,14169815,18),(89705,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89705,37.27,0.46,284,37620,70,NULL,NULL,'2MASX J12101643+4755354',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000133,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,182.568625,47.92658,0.006,NULL,57192702528,893635977,13963062,17.6),(89706,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89706,37.73,0.11,352,37621,70,NULL,NULL,'2MASX J12101679+0523097',NULL,'2015arXiv151105856S',2015,1,1.04,NULL,'G',0.00022,NULL,'15.2g',0.67,'BrClG',NULL,NULL,NULL,NULL,1,182.570083,5.38603,0,NULL,58038932537,906858320,14169661,15.2),(89707,'SNIa','2016-12-15 15:14:55','2016-12-16 11:20:05','1','SN 1963D','R',89707,35.63,NULL,134,37622,NULL,NULL,'Photographic','NGC 4146',NULL,'1988SSRv...48....1R',1988,1,1.4,NULL,'G',0.000023,NULL,'13.59',1.3,'(R)SAB(s)ab:   PAS','Possible group member',NULL,NULL,NULL,1,182.576083333,26.43075,0.048,NULL,58642478406,916288725,14317011,13.59),(89708,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89708,38.23,0.46,442,37623,70,NULL,NULL,'SDSS J121018.66+354943.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000138,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,182.5777917,35.82872,0,NULL,58552395870,914881185,14295018,18.6),(89709,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89709,35.33,0.27,116,37624,70,NULL,NULL,'2MASX J12101905+3133003',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000113,NULL,'15.6g',0.4,NULL,NULL,NULL,NULL,NULL,1,182.579375,31.55011,0.029,NULL,58622568579,915977634,14312150,15.6),(89710,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89710,36.74,0.46,223,37625,70,NULL,NULL,'2MASX J12102013+5357408',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000164,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,182.584,53.96139,0,NULL,57225646970,894150733,13971105,17.2),(89711,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89711,38.07,0.46,411,37626,70,NULL,NULL,'SDSS J121020.48+624018.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000138,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,182.585458333,62.67178,0.005,NULL,57370457401,896413396,14006459,18.5),(89712,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89712,36.96,0.46,247,37627,70,NULL,NULL,'2MASX J12102135+2808138',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000113,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,182.589,28.13731,0.025,NULL,58643595355,916306177,14317284,16.5),(89713,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89713,37.63,0.46,335,37628,70,NULL,NULL,'2MASX J12102143+2811148',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000136,NULL,'18.57',0.15,NULL,NULL,NULL,NULL,NULL,1,182.589458333,28.18756,0.022,NULL,58643598295,916306223,14317284,18.57),(89714,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89714,38.27,0.46,452,37629,70,NULL,NULL,'UM 479',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000085,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,182.590917,-0.32947,0.021,NULL,42963327618,671301994,10489093,17.4),(89715,'Tully est','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89715,32.65,0.8,33.9,37630,75,NULL,NULL,'UGC 07164',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000037,NULL,'17.',1.4,'Sm:','Group member',NULL,NULL,NULL,1,182.591667,70.51528,0.033,NULL,56990026269,890469160,13913580,17),(89716,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89716,37.26,0.23,284,37631,70,NULL,NULL,'2MASX J12102273+5747068',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000174,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,182.594833333,57.78531,0,NULL,57331527129,895805111,13996954,16.8),(89717,'GCLF','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89717,31.27,0.64,17.9,37632,NULL,NULL,'TOM(g) = -7.2 mag','IC 3025',NULL,'2010ApJ...717..603V',2010,1,0.94,NULL,'G',0.000072,NULL,'15.0g',0.56,'dS0(4)','Group member',NULL,NULL,NULL,1,182.5962083,10.18856,0,NULL,58203326884,909426982,14209796,15),(89718,'GCLF','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89718,31.49,0.56,19.9,37632,NULL,NULL,'TOM(z) = -8.53 mag','IC 3025',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89719,'GCLF','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89719,31.53,0.8,20.2,37632,NULL,NULL,'TOM(g) = -7.2 mag','IC 3025',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89720,'GCLF','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89720,31.69,0.7,21.8,37632,NULL,NULL,'TOM(u) = -8.4 mag','IC 3025',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89721,'SBF','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89721,31.4,0.14,19.1,37632,74.4,NULL,NULL,'IC 3025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89722,'SBF','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89722,31.42,0.13,19.2,37632,NULL,NULL,'HST ACS VCS','IC 3025',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89723,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89723,36.3,0.46,182,37633,70,NULL,NULL,'2MASX J12102318+3220363',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.84',0.19,NULL,NULL,NULL,NULL,NULL,1,182.59675,32.3435,0,NULL,58755466489,918054163,14344596,17.84),(89724,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89724,37.76,0.33,356,37634,70,NULL,NULL,'2MASX J12102366+3728304',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00018,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,182.5984583,37.47514,0.005,NULL,58547233059,914800516,14293758,17.8),(89725,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89725,32.53,NULL,32,37635,NULL,NULL,NULL,'KUG 1207+134',NULL,'2014A&A...562A..49M',2014,1,0.43,NULL,'G',0.000033,NULL,'16.2g',0.35,'BCD?','Group member',NULL,NULL,NULL,1,182.601583,13.17061,0.04,NULL,58146387878,908537310,14195895,16.2),(89726,'BL Lac Luminosity','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89726,42.77,NULL,2220,37636,NULL,NULL,NULL,'[HB89] 1207+397',0.616935,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.000369,NULL,'19.8g',NULL,'Opt.var.       BLLAC',NULL,NULL,NULL,'BL Lac',1,182.610833,39.48561,0,NULL,58580243711,915316307,14301817,19.8),(89727,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89727,37.05,0.46,257,37637,70,NULL,NULL,'2MASX J12102796+0615296',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000147,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,182.616417,6.25819,0,NULL,58028284473,906691944,14167061,16.9),(89728,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89728,36.97,0.55,248,37638,70,NULL,NULL,'2MASX J12102839-1803045',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,182.6182917,-18.05128,0.113,NULL,43030168561,672346383,10505412,16.2),(89729,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89729,35.93,0.46,153,37639,70,NULL,NULL,'2MASX J12102850+2731023',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000127,NULL,'15.9g',0.4,'S0','Field galaxy',NULL,NULL,NULL,1,182.618667,27.51725,0.03,NULL,58643804462,916309444,14317335,15.9),(89730,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89730,37.73,0.11,352,37640,70,NULL,NULL,'SDSS J121028.70+052810.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,182.619625,5.46969,0,NULL,58038919685,906858120,14169658,17.9),(89731,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89731,38.42,0.46,484,37641,70,NULL,NULL,'2MASXi J1210288+403911',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,182.620417,40.65325,0,NULL,58524587133,914446673,14288229,17.9),(89732,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89732,38.05,0.46,407,37642,70,NULL,NULL,'2MASX J12102969+6019084',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000153,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,182.623625,60.31894,0,NULL,57339325021,895926953,13998858,17.4),(89733,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89733,37.73,0.11,352,37643,70,NULL,NULL,'SDSS J121030.07+052034.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000176,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,182.625333,5.34297,0,NULL,58038939082,906858423,14169662,18.3),(89734,'Tully est','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89734,32.69,0.8,34.5,37644,75,NULL,'B','UGC 07168',NULL,'1988NBGC.C....0000T',1988,1,1.2,NULL,'G',0.000033,NULL,'15.43',0.2,'Pec?','Group member',NULL,NULL,NULL,1,182.6280417,70.36956,0.017,NULL,56989461928,890460342,13913442,15.43),(89735,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89735,36.73,0.46,221,37645,70,NULL,NULL,'2MASX J12103160+3857272',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000167,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,182.63175,38.95747,0,NULL,58581736249,915339628,14302181,16.4),(89736,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89736,38.34,0.33,465,37646,70,NULL,NULL,'2MASX J12103168+1559215',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,182.6322083,15.98936,0.053,NULL,58177833137,909028642,14203572,17.7),(89737,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89737,36.16,0.46,171,37647,70,NULL,NULL,'MRK 1311',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00015,NULL,'15.9g',0.29,'S0/a',NULL,NULL,NULL,NULL,1,182.634083,-1.31428,0.041,NULL,42963871976,671310499,10489226,15.9),(89738,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89738,36.55,0.64,204,37647,70,NULL,NULL,'MRK 1311',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89739,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89739,37.68,0.27,343,37648,70,NULL,NULL,'SDSS J121032.35+563757.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000155,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,182.634833,56.63261,0,NULL,57395646278,896806973,14012608,18.5),(89740,'AGN time lag','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89740,31.39,0.22,19,37649,44,NULL,NULL,'NGC 4151',NULL,'2007MNRAS.380..669C',2007,1,6.3,NULL,'G',0.00001,NULL,'11.5',4.5,'(R\')SAB(rs)ab: Sy1.5','Pair member (points to parent)',NULL,'radio jet','Sy 1.5',1,182.63575,39.40572,0,NULL,58580117363,915314333,14301786,11.5),(89741,'AGN time lag','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89741,31.39,0.28,19,37649,NULL,NULL,NULL,'NGC 4151',NULL,'2014Natur.515..528H',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89742,'AGN time lag','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89742,32.33,0.03,29.2,37649,NULL,NULL,NULL,'NGC 4151',NULL,'2014ApJ...784L..11Y',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89743,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89743,27.95,0.36,3.89,37649,NULL,NULL,NULL,'NGC 4151',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89744,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89744,28.79,0.45,5.73,37649,NULL,NULL,'K','NGC 4151',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89745,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89745,29.04,0.47,6.41,37649,NULL,NULL,'H','NGC 4151',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89746,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89746,29.18,0.46,6.86,37649,NULL,NULL,'J','NGC 4151',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89747,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89747,31.04,0.4,16.2,37649,NULL,NULL,'mean','NGC 4151',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89748,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89748,31.54,0.4,20.3,37649,75,NULL,'B','NGC 4151',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89749,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89749,38.65,0.46,538,37650,70,NULL,NULL,'2MASX J12103282+3133573',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000169,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,182.636875,31.56589,0.029,NULL,58622571686,915977682,14312151,18.4),(89750,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89750,36.74,0.46,223,37651,70,NULL,NULL,'2MASX J12103312+0311190',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000073,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,182.638083,3.18878,0.017,NULL,58037878879,906841857,14169404,17.6),(89751,'GCLF','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89751,31.51,NULL,20,37652,NULL,NULL,NULL,'NGC 4150',NULL,'2003A&A...398..467K',2003,1,2.3,NULL,'G',0.000017,NULL,'12.44',1.6,'SA(r)0^0^?','Probable group member',NULL,NULL,NULL,1,182.6402083,30.40153,0.044,NULL,58635935947,916186499,14315414,12.44),(89752,'SBF','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89752,30.53,0.24,12.8,37652,NULL,NULL,'I','NGC 4150',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89753,'SBF','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89753,30.58,0.14,13.1,37652,74.4,NULL,NULL,'NGC 4150',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89754,'SBF','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89754,30.69,0.24,13.7,37652,NULL,NULL,'I','NGC 4150',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89755,'SBF','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89755,30.79,0.11,14.4,37652,NULL,NULL,'R','NGC 4150',NULL,'2005A&A...437..823R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89756,'Faber-Jackson','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89756,29.44,0.65,7.73,37652,95,NULL,'Weighted Mean','NGC 4150',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89757,'Faber-Jackson','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89757,30.29,0.81,11.4,37652,55,NULL,'Visvanathan & Sandage 1979','NGC 4150',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89758,'Tully est','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89758,29.93,0.8,9.7,37652,75,NULL,'B','NGC 4150',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89759,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89759,37.88,0.46,377,37653,70,NULL,NULL,'2MASX J12103390+4509534',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000127,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,182.641375,45.16503,0,NULL,59059766655,922808853,14418888,17.7),(89760,'IRAS','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89760,34.69,0.8,86.6,37654,75,NULL,'HMCL, I','KUG 1208+262',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.00003,NULL,'14.87',0.6,'Sc','Field galaxy',NULL,NULL,NULL,1,182.6445,25.92822,0.054,NULL,58596726959,915573858,14305841,14.87),(89761,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89761,34.31,0.4,72.7,37654,75,NULL,'HMCL, I, raw','KUG 1208+262',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89762,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89762,34.44,0.4,77.2,37654,75,NULL,'HMCL, I, inv','KUG 1208+262',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89763,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89763,34.64,0.4,84.6,37654,75,NULL,'HMCL, I, cor','KUG 1208+262',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89764,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89764,37.55,0.46,324,37655,70,NULL,NULL,'2MASX J12103503+2535433',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00009,NULL,'18.11',0.19,NULL,NULL,NULL,NULL,NULL,1,182.646,25.59528,0.053,NULL,58598701512,915604711,14306323,18.11),(89765,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89765,32.53,NULL,32,37656,NULL,NULL,NULL,'IC 3028',NULL,'2014A&A...562A..49M',2014,1,0.62,NULL,'G',0.000005,NULL,'15.5g',0.35,'BCD            HII','Group member',NULL,NULL,NULL,1,182.648708333,11.76081,0.014,NULL,58147959620,908561869,14196279,15.5),(89766,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89766,37.28,0.46,286,37657,70,NULL,NULL,'2MASX J12103633+1117566',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,182.6514583,11.29911,0,NULL,58202289470,909410772,14209543,17.2),(89767,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89767,37.51,0.46,318,37658,70,NULL,NULL,'SDSS J121036.81+062521.7',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,182.653417,6.42272,0,NULL,58029168581,906705759,14167277,17.7),(89768,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89768,32.24,NULL,28.1,37659,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07170',NULL,'2010Ap&SS.325..163P',2010,1,3.25,'The position in 1999AISAO..47....3K is -1 second in error (typo?).','G',0.000006,NULL,'14.96',0.28,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,182.6540417,18.82781,0.043,NULL,58130593825,908290528,14192039,14.96),(89769,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89769,32.25,NULL,28.2,37659,NULL,NULL,'Dipole + Quadrupole','UGC 07170',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89770,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89770,32.25,NULL,28.2,37659,NULL,NULL,'Dipole','UGC 07170',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89771,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89771,32.32,0.4,29.2,37659,75,NULL,NULL,'UGC 07170',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89772,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89772,32.33,NULL,29.2,37659,NULL,NULL,NULL,'UGC 07170',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89773,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89773,32.73,0.49,35.1,37659,75,NULL,'IR','UGC 07170',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89774,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89774,32.89,0.4,37.8,37659,75,NULL,'B','UGC 07170',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89775,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89775,32.35,0.47,29.5,37660,NULL,NULL,'H','NGC 4152',NULL,'2007A&A...465...71T',2007,1,2.2,NULL,'G',0.000013,NULL,'12.66',1.7,'SAB(rs)c;HII   Sbrst','in a radial-velocity based grouping',NULL,NULL,'Starburst',1,182.65625,16.03292,0.053,NULL,58177843116,909028798,14203574,12.66),(89776,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89776,32.39,0.46,30.1,37660,NULL,NULL,'J','NGC 4152',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89777,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89777,32.41,0.45,30.3,37660,NULL,NULL,'K','NGC 4152',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89778,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89778,32.43,0.36,30.6,37660,NULL,NULL,NULL,'NGC 4152',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89779,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89779,32.69,0.4,34.5,37660,75,NULL,'B','NGC 4152',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89780,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89780,32.85,NULL,37.2,37660,NULL,NULL,NULL,'NGC 4152',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89781,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89781,32.95,0.4,38.9,37660,NULL,NULL,'mean','NGC 4152',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89782,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89782,33.05,0.3,40.7,37660,55,NULL,'B','NGC 4152',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89783,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89783,37.68,0.33,344,37661,70,NULL,NULL,'2MASX J12103864+2511133',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,182.661,25.18708,0.06,NULL,58599448843,915616388,14306506,17.2),(89784,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89784,38.58,0.46,520,37662,70,NULL,NULL,'2MASX J12103878+3310003',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,182.661583,33.16664,0,NULL,58757909051,918092328,14345192,18.4),(89785,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89785,34.02,0.49,63.7,37663,70,NULL,NULL,'ESO 379- G 031',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00005,NULL,'14.31',1,'S?',NULL,NULL,NULL,NULL,1,182.663875,-34.05736,0.297,NULL,43437855965,678716499,10604945,14.31),(89786,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89786,37.21,0.46,277,37664,70,NULL,NULL,'2MASX J12103976+2008570',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.44',0.22,NULL,NULL,NULL,NULL,NULL,1,182.6657917,20.14928,0.087,NULL,58118471813,908101122,14189080,17.44),(89787,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89787,37.73,0.11,352,37665,70,NULL,NULL,'2MASX J12103995+0519251',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000179,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,182.666375,5.32372,0,NULL,58038903508,906857867,14169654,17.4),(89788,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89788,38.07,0.33,412,37666,70,NULL,NULL,'2MASX J12104038+4458474',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000174,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,182.66825,44.97997,0,NULL,59059782533,922809102,14418892,18),(89789,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89789,38.2,0.46,437,37667,70,NULL,NULL,'2MASX J12104051+1539285',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,182.66875,15.658,0.102,NULL,58178185954,909034155,14203658,17.7),(89790,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89790,37.6,0.27,331,37668,70,NULL,NULL,'2MASX J12104098+3635253',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000171,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,182.6709583,36.59044,0,NULL,58548638465,914822476,14294101,16.9),(89791,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89791,37.6,0.27,331,37669,70,NULL,NULL,'2MASX J12104157+3628383',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,182.6732083,36.47744,0,NULL,58548679169,914823112,14294111,17.4),(89792,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89792,34.58,0.2,82.4,37670,74.4,NULL,NULL,'IC 3029',NULL,'2013AJ....146...86T',2013,1,1.02,NULL,'G',0.000023,NULL,'14.8g',0.44,'SB(s)c I','Group member',NULL,NULL,NULL,1,182.674417,13.33128,0.04,NULL,58146366878,908536982,14195890,14.8),(89793,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89793,37.91,0.46,381,37671,70,NULL,NULL,'2MASX J12104364+2138290',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,182.681833,21.64136,0.045,NULL,58857861856,919654091,14369595,17.8),(89794,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89794,37.36,0.46,296,37672,70,NULL,NULL,'2MASX J12104394+4951581',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,182.6830417,49.86597,0.036,NULL,57187586981,893556046,13961813,17.5),(89795,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89795,37.42,0.33,305,37673,70,NULL,NULL,'2MASX J12104526+1451450',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,182.6885,14.86261,0.124,NULL,58176996367,909015568,14203368,17.6),(89796,'IRAS','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89796,34.81,0.8,91.5,37674,75,NULL,'HMCL, I','CGCG 128-050',NULL,'1997ApJS..109..333W',1997,1,0.7,NULL,'G',0.000027,NULL,'15.7',0.4,'E?',NULL,NULL,NULL,NULL,1,182.688917,23.71033,0.092,NULL,58601591127,915649861,14307029,15.7),(89797,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89797,34.57,0.4,82.2,37674,75,NULL,'HMCL, I, raw','CGCG 128-050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89798,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89798,34.74,0.4,88.8,37674,75,NULL,'HMCL, I, inv','CGCG 128-050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89799,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89799,34.85,0.4,93.4,37674,75,NULL,'HMCL, I, cor','CGCG 128-050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89800,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89800,35.28,0.33,114,37675,70,NULL,NULL,'NGC 4155',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.000173,NULL,'14.34',1,'E',NULL,NULL,NULL,NULL,1,182.690375,19.04083,0.04,NULL,58130632366,908291130,14192048,14.34),(89801,'GRB','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89801,43.29,1.56,1810,37676,100,NULL,NULL,'GRB 030328',1.52,'2009EPJC...63..139W',2009,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,182.691667,-9.36667,0.161,NULL,43187265564,674801024,10543766,NULL),(89802,'GRB','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89802,43.43,1.5,1930,37676,100,NULL,NULL,'GRB 030328',1.52,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89803,'GRB','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89803,44.65,0.47,3380,37676,72,NULL,NULL,'GRB 030328',1.52,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89804,'GRB','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89804,44.68,0.37,3420,37676,69.7,NULL,'Calibrated','GRB 030328',1.52,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89805,'GRB','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89805,44.78,0.46,3590,37676,70,NULL,NULL,'GRB 030328',1.52,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89806,'GRB','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89806,44.8,0.5,3620,37676,69.7,NULL,'Fiducial','GRB 030328',1.52,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89807,'GRB','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89807,44.96,0.54,3900,37676,NULL,NULL,NULL,'GRB 030328',1.52,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89808,'GRB','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89808,42.39,NULL,3010,37677,70,NULL,'Pseudo z = 1.39','GRB 030328',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,182.691667,-9.36667,0.161,NULL,43187265564,674801024,10543766,NULL),(89809,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89809,38.49,0.46,498,37678,70,NULL,NULL,'2MASX J12104613+0609438',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000212,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,182.6922083,6.16214,0,NULL,58028303188,906692237,14167066,17.8),(89810,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89810,37.27,0.27,285,37679,70,NULL,NULL,'2MASX J12104669+2647293',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000162,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,182.694583,26.79158,0.039,NULL,58642450798,916288293,14317004,18),(89811,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89811,37.68,0.27,343,37680,70,NULL,NULL,'2MASX J12104900+5643345',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000182,NULL,'16.2g',0.4,'BrClG',NULL,NULL,NULL,NULL,1,182.704167,56.72639,0,NULL,57395526622,896805103,14012579,16.2),(89812,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89812,38.41,0.46,482,37681,70,NULL,NULL,'2MASX J12104923+3038285',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00014,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,182.705291667,30.64139,0.048,NULL,58634025520,916156648,14314947,17.4),(89813,'Tully est','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89813,30.95,0.8,15.5,37682,75,NULL,'B','NGC 4156',NULL,'1988NBGC.C....0000T',1988,1,0.96,NULL,'G',0.000025,NULL,'14.0g',0.77,'SB(rs)b        LINER','in a pair',NULL,NULL,'AGN',1,182.7067083,39.47272,0,NULL,58580262623,915316603,14301821,14),(89814,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89814,37.73,0.11,352,37683,70,NULL,NULL,'2MASX J12105086+0525191',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000193,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,182.712,5.42214,0,NULL,58038724151,906855064,14169610,16.4),(89815,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89815,37.27,0.27,285,37684,70,NULL,NULL,'2MASX J12105117+2646272',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000179,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,182.71325,26.77433,0.039,NULL,58642449147,916288267,14317004,16.6),(89816,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89816,37.42,0.33,305,37685,70,NULL,NULL,'2MASX J12105126+1452251',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.32',0.25,'BrClG',NULL,NULL,NULL,NULL,1,182.713625,14.87358,0.124,NULL,58177002451,909015663,14203369,17.32),(89817,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89817,37.73,0.11,352,37686,70,NULL,NULL,'2MASX J12105133+0517221',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,182.713791667,5.28928,0,NULL,58038835503,906856804,14169637,17.6),(89818,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89818,37.68,0.27,343,37687,70,NULL,NULL,'2MASX J12105142+5646495',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,182.71425,56.78053,0,NULL,57395519166,896804986,14012577,17.5),(89819,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89819,37.73,0.11,352,37688,70,NULL,NULL,'2MASX J12105140+0521591',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000176,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,182.714333333,5.36631,0,NULL,58038910431,906857975,14169655,17),(89820,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89820,34.92,0.46,96.2,37689,70,NULL,NULL,'CGCG 187-017',NULL,'2015arXiv151105856S',2015,1,0.94,NULL,'G',0.000093,NULL,'14.3g',0.79,NULL,NULL,NULL,NULL,NULL,1,182.7147917,36.62436,0,NULL,58548757759,914824339,14294130,14.3),(89821,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89821,38,0.46,398,37690,70,NULL,NULL,'2MASX J12105195+5453535',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000131,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,182.7164583,54.89828,0,NULL,57213075728,893954308,13968036,18.2),(89822,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89822,38.26,0.46,449,37691,70,NULL,NULL,'LCRS B120818.2-032156',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,182.717,-3.64358,0.077,NULL,43011087313,672048239,10500753,18),(89823,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89823,37.73,0.11,352,37692,70,NULL,NULL,'2MASX J12105347+0520111',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000174,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,182.72275,5.33628,0,NULL,58038910537,906857977,14169655,18.2),(89824,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89824,33.35,0.49,46.8,37693,70,NULL,NULL,'IC 0766',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'15.00',0.3,'SAB(r)0+? sp',NULL,NULL,NULL,NULL,1,182.723333,-12.65525,0.157,NULL,43064535786,672883371,10513802,15),(89825,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89825,31.26,0.43,17.8,37694,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4159',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.000137,NULL,'14.38',0.5,'Sdm            HII','X-ray-bright group member',NULL,NULL,NULL,1,182.723417,76.12586,0.153,NULL,57023758121,890996220,13921815,14.38),(89826,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89826,37.46,0.17,311,37695,70,NULL,NULL,'2MASX J12105370+3051425',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,182.7237917,30.86192,0.067,NULL,58634057132,916157142,14314955,17.3),(89827,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89827,37.09,0.46,262,37696,70,NULL,NULL,'SDSS J121053.79+114840.0',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,182.724167,11.81111,0.014,NULL,58147986286,908562285,14196285,17.3),(89828,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89828,37.56,0.46,326,37697,70,NULL,NULL,'2MASX J12105395+1316591',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000179,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,182.7247917,13.28306,0.046,NULL,58146366195,908536971,14195890,17.7),(89829,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89829,37.8,0.46,363,37698,70,NULL,NULL,'2MASX J12105417+1350061',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000133,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,182.725875,13.83503,0.027,NULL,58145837410,908528709,14195761,18),(89830,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89830,38.07,0.33,412,37699,70,NULL,NULL,'2MASX J12105425+4454224',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000143,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,182.726125,44.90628,0,NULL,59059973782,922812090,14418938,17.5),(89831,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89831,31.8,0.4,22.9,37700,75,NULL,'B','NGC 4145A',NULL,'1988NBGC.C....0000T',1988,1,1.33,NULL,'G',0.0001,NULL,'14.7g',0.48,'Spiral','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,182.72725,39.75736,0,NULL,58580165208,915315081,14301798,14.7),(89832,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89832,36.86,0.46,236,37701,70,NULL,NULL,'VIII Zw 174 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.27',0.2,NULL,NULL,NULL,NULL,NULL,1,182.7345417,9.64117,0,NULL,58201691497,909401429,14209397,18.27),(89833,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89833,37.37,0.46,297,37702,70,NULL,NULL,'2MASX J12105705+2203477',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.05',0.19,NULL,NULL,NULL,NULL,NULL,1,182.73775,22.06328,0.06,NULL,58857273943,919644905,14369451,18.05),(89834,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89834,33.5,0.2,50.1,37703,74.4,NULL,NULL,'VCC 0031',NULL,'2013AJ....146...86T',2013,1,0.55,NULL,'G',0.000007,NULL,'15.6g',0.29,'dE','Group member',NULL,NULL,NULL,1,182.7379583,9.21942,0,NULL,58202139702,909408432,14209506,15.6),(89835,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89835,37.46,0.17,311,37704,70,NULL,NULL,'2MASX J12105735+3052536',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000103,NULL,'15.8g',0.54,NULL,NULL,NULL,NULL,NULL,1,182.7392083,30.88142,0.067,NULL,58634045539,916156961,14314952,15.8),(89836,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89836,37.46,0.17,311,37705,70,NULL,NULL,'2MASX J12105828+3051225',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,182.7427083,30.85628,0.067,NULL,58634057567,916157149,14314955,17.6),(89837,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89837,37.17,0.46,272,37706,70,NULL,NULL,'2MASX J12105895+2814399',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,182.745583333,28.24436,0.022,NULL,58643643116,916306923,14317295,17.9),(89838,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89838,38.65,0.46,537,37707,70,NULL,NULL,'SDSS J121101.37+091619.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,182.75575,9.27194,0,NULL,58202135148,909408361,14209505,18),(89839,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89839,35.5,0.65,126,37708,70,NULL,NULL,'2MASX J12110160-0152473',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.00015,NULL,'15.5g',0.4,'S0',NULL,NULL,NULL,NULL,1,182.756708333,-1.87992,0.033,NULL,42962681840,671291903,10488935,15.5),(89840,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89840,35.73,0.46,140,37708,70,NULL,NULL,'2MASX J12110160-0152473',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89841,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89841,38.66,0.46,539,37709,70,NULL,NULL,'2MASX J12110336+2245477',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.80',0.13,NULL,NULL,NULL,NULL,NULL,1,182.7639583,22.76339,0.086,NULL,58856686789,919635731,14369308,18.8),(89842,'Tully est','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89842,32.02,0.8,25.3,37710,75,NULL,NULL,'UGC 07178',NULL,'1988NBGC.C....0000T',1988,1,1.4,NULL,'G',0.000019,NULL,'16.20',1.1,'IAB(rs)m:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,182.76525,2.00631,0.018,NULL,57995242301,906175660,14158994,16.2),(89843,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89843,37.77,0.46,358,37711,70,NULL,NULL,'2MASX J12110350+0611089',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000193,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,182.764625,6.18583,0,NULL,58028317523,906692461,14167069,18),(89844,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89844,34.52,0.46,80.2,37712,70,NULL,NULL,'UGC 07177',NULL,'2015arXiv151105856S',2015,1,1.02,NULL,'G',0.000033,NULL,'14.4g',0.95,'S0-?',NULL,NULL,NULL,NULL,1,182.766916667,0.97233,0.031,NULL,57997164043,906205688,14159463,14.4),(89845,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89845,38.45,0.46,490,37713,70,NULL,NULL,'SDSS J121104.23+040627.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,182.767667,4.10756,0,NULL,58037950152,906842971,14169421,18.1),(89846,'IRAS','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89846,30.89,0.8,15.1,37714,75,NULL,'A82, H','NGC 4157',NULL,'1997ApJS..109..333W',1997,1,7.95,NULL,'G',0.000006,NULL,'12.15',1.06,'SAB(s)b? sp    HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,182.7682083,50.48467,0.018,NULL,57234975268,894296488,13973382,12.15),(89847,'IRAS','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89847,30.92,0.8,15.3,37714,75,NULL,'W91CL, r','NGC 4157',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89848,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89848,30.61,0.4,13.3,37714,75,NULL,NULL,'NGC 4157',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89849,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89849,30.89,0.43,15.1,37714,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4157',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89850,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89850,30.98,0.12,15.7,37714,NULL,NULL,NULL,'NGC 4157',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89851,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89851,31.06,0.43,16.3,37714,75,NULL,'3.6 micron, color corrected','NGC 4157',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89852,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89852,31.15,0.4,17,37714,75,NULL,'B','NGC 4157',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89853,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89853,31.23,0.35,17.6,37714,NULL,NULL,NULL,'NGC 4157',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89854,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89854,31.25,0.49,17.8,37714,75,NULL,'IR','NGC 4157',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89855,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89855,31.27,0.2,18,37714,74.4,NULL,NULL,'NGC 4157',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89856,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89856,31.28,0.47,18.1,37714,75,NULL,'A82, H, raw','NGC 4157',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89857,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89857,31.44,NULL,19.4,37714,NULL,NULL,'I','NGC 4157',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89858,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89858,31.44,0.47,19.4,37714,75,NULL,'A82, H, inv','NGC 4157',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89859,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89859,31.51,0.38,20,37714,75,NULL,'W91CL, r, raw','NGC 4157',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89860,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89860,31.52,0.47,20.1,37714,75,NULL,'A82, H, cor','NGC 4157',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89861,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89861,31.53,NULL,20.2,37714,NULL,NULL,'Dipole','NGC 4157',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89862,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89862,31.53,NULL,20.2,37714,NULL,NULL,'Dipole + Quadrupole','NGC 4157',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89863,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89863,31.53,NULL,20.2,37714,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 4157',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89864,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89864,31.63,0.38,21.2,37714,75,NULL,'W91CL, r, cor','NGC 4157',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89865,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89865,31.65,0.38,21.4,37714,75,NULL,'W91CL, r, inv','NGC 4157',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89866,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89866,31.7,NULL,21.9,37714,NULL,NULL,NULL,'NGC 4157',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89867,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89867,31.75,NULL,22.4,37714,NULL,NULL,'B','NGC 4157',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89868,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89868,37.46,0.17,311,37715,70,NULL,NULL,'2MASX J12110449+3047586',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000103,NULL,'16.5g',0.29,'AGN',NULL,NULL,NULL,NULL,1,182.768625,30.79953,0.067,NULL,58634054604,916157103,14314954,16.5),(89869,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89869,38.89,0.46,601,37716,70,NULL,NULL,'2MASX J12110496+5038340',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000173,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,182.770833,50.64275,0.022,NULL,57235197780,894299965,13973436,18.1),(89870,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89870,37.67,0.33,341,37717,70,NULL,NULL,'2MASX J12110742+2822419',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00011,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,182.781125,28.37839,0.022,NULL,58642734639,916292728,14317073,16.3),(89871,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89871,37.81,0.33,366,37718,70,NULL,NULL,'2MASX J12110757+0907119',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,182.781667,9.12,0,NULL,58201281977,909395030,14209297,17.8),(89872,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89872,30.92,0.69,15.3,37719,100,NULL,'mid-IR','ESO 441- G 017',NULL,'2013ApJ...771...88L',2013,1,1.7,NULL,'G',0.00001,NULL,'13.73',0.5,'Sab            HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,182.7824583,-31.127,0.233,NULL,43384694932,677885858,10591966,13.73),(89873,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89873,32.6,0.4,33.1,37719,NULL,NULL,'mean','ESO 441- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89874,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89874,32.73,0.47,35.1,37719,NULL,NULL,'H','ESO 441- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89875,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89875,32.81,0.46,36.5,37719,NULL,NULL,'J','ESO 441- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89876,'SBF','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89876,30.86,0.14,14.9,37720,74.4,NULL,NULL,'IC 3032',NULL,'2013AJ....146...86T',2013,1,0.72,NULL,'G',0.00008,NULL,'15.1g',0.63,'E?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,182.782333333,14.27481,0.078,NULL,58143545078,908492891,14195201,15.1),(89877,'SBF','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89877,30.89,0.13,15,37720,NULL,NULL,'HST ACS VCS','IC 3032',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89878,'SBF','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89878,30.89,0.09,15.1,37720,NULL,NULL,NULL,'IC 3032',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89879,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89879,35.75,0.5,141,37721,70,NULL,NULL,'2MASX J12110780-4641240',NULL,'2014MNRAS.445.2677S',2014,1,4.85,NULL,'G',0.000117,NULL,'2.09',0.6,'E/D',NULL,NULL,NULL,NULL,1,182.7825,-46.68994,0.401,NULL,44563202184,696300034,10879688,2.09),(89880,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89880,37.6,0.27,331,37722,70,NULL,NULL,'2MASX J12110807+3634340',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000174,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,182.783375,36.57606,0,NULL,58548649203,914822643,14294103,17.8),(89881,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89881,37.27,0.27,285,37723,70,NULL,NULL,'2MASX J12110885+2648149',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000153,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,182.787041667,26.80431,0.039,NULL,58642444702,916288198,14317003,16.9),(89882,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89882,37.15,0.33,270,37724,70,NULL,NULL,'LCRS B120835.4-025907',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000143,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,182.788667,-3.26336,0.077,NULL,43010651640,672041431,10500647,17.2),(89883,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89883,37.67,0.33,341,37725,70,NULL,NULL,'2MASX J12110962+2820449',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000185,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,182.79025,28.34586,0.022,NULL,58642731107,916292673,14317073,17.3),(89884,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89884,30.9,0.2,15.1,37726,74.4,NULL,NULL,'IC 3033',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000017,NULL,'14.92',0.7,'Sdm?','Group member',NULL,NULL,NULL,1,182.7914583,13.5875,0.027,NULL,58146493059,908538954,14195921,14.92),(89885,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89885,31.16,0.43,17,37726,75,NULL,'3.6 micron, color corrected','IC 3033',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89886,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89886,31.31,0.36,18.3,37726,NULL,NULL,NULL,'IC 3033',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89887,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89887,31.34,0.43,18.5,37726,75,NULL,'3.6 micron, color + selection bias corrected','IC 3033',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89888,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89888,38.71,0.33,551,37727,70,NULL,NULL,'SDSS J121110.13+093546.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,182.79225,9.59631,0,NULL,58201700881,909401576,14209399,18.2),(89889,'Tully est','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89889,32.95,0.8,38.9,37728,75,NULL,'B','NGC 4158',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000023,NULL,'12.86',1.7,'SA(r)b:','in a radial-velocity based grouping',NULL,NULL,NULL,1,182.792375,20.17567,0.087,NULL,58855741618,919620962,14369077,12.86),(89890,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89890,33.26,0.4,45,37728,NULL,NULL,'mean','NGC 4158',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89891,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89891,34.1,0.45,66,37728,NULL,NULL,'K','NGC 4158',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89892,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89892,34.1,0.47,66.2,37728,NULL,NULL,'H','NGC 4158',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89893,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89893,34.15,0.46,67.7,37728,NULL,NULL,'J','NGC 4158',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89894,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89894,37.99,0.46,396,37729,70,NULL,NULL,'SDSS J121110.42+250050.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,182.7934583,25.01394,0.061,NULL,58599438274,915616223,14306503,18.3),(89895,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89895,33.96,0.46,62,37730,70,NULL,NULL,'CGCG 041-046',NULL,'2015arXiv151105856S',2015,1,0.98,NULL,'G',0.000157,NULL,'14.7g',0.55,'S0','Isolated galaxy',NULL,NULL,NULL,1,182.795125,2.25553,0.018,NULL,57994780624,906168447,14158881,14.7),(89896,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89896,36.86,0.46,236,37731,70,NULL,NULL,'2MASX J12111132+1127099',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000157,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,182.79725,11.45264,0.005,NULL,58134108961,908345452,14192897,16.5),(89897,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89897,37.64,0.46,337,37732,70,NULL,NULL,'2MASX J12111203+5529384',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,182.799833,55.49397,0,NULL,57212780486,893949695,13967963,16.8),(89898,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89898,37.96,0.46,390,37733,70,NULL,NULL,'2MASX J12111203+1342171',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,182.8,13.70478,0.027,NULL,58145831926,908528623,14195759,17.9),(89899,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89899,37.52,0.46,319,37734,70,NULL,NULL,'2MASX J12111211+1016449',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000186,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,182.800583333,10.27911,0,NULL,58203026634,909422291,14209723,17.9),(89900,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89900,37.46,0.17,311,37735,70,NULL,NULL,'2MASX J12111235+3103055',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000118,NULL,'18.76',0.12,NULL,NULL,NULL,NULL,NULL,1,182.8014583,31.05156,0.067,NULL,58634193633,916159275,14314988,18.76),(89901,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89901,37.72,0.46,349,37736,70,NULL,NULL,'2MASX J12111249+2940429',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,182.802,29.67861,0.026,NULL,58633017944,916140905,14314701,18.2),(89902,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89902,37.81,0.33,366,37737,70,NULL,NULL,'2MASX J12111250+0907129',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00016,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,182.802166667,9.12022,0,NULL,58201292150,909395189,14209299,17),(89903,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89903,38.34,0.33,465,37738,70,NULL,NULL,'2MASX J12111281+1556358',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'18.62',0.27,NULL,NULL,NULL,NULL,NULL,1,182.803417,15.94339,0.053,NULL,58177863755,909029121,14203580,18.62),(89904,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89904,37.46,0.17,311,37739,70,NULL,NULL,'2MASX J12111293+3103353',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000195,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,182.8040417,31.05994,0.067,NULL,58634204444,916159444,14314991,16.5),(89905,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89905,35.21,0.46,110,37740,70,NULL,NULL,'2MASX J12111446+3223043',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000171,NULL,'15.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,182.8102083,32.38442,0,NULL,58755668031,918057312,14344645,15.6),(89906,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89906,36.04,0.46,162,37741,70,NULL,NULL,'2MASX J12111632+5442544',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000158,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,182.8182083,54.71522,0,NULL,57212991770,893952996,13968015,16.4),(89907,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89907,37.77,0.33,358,37742,70,NULL,NULL,'2MASX J12111641+3648391',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,182.81825,36.81089,0,NULL,58548736627,914824009,14294125,17.7),(89908,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89908,37.32,0.46,291,37743,70,NULL,NULL,'2MASX J12111738+4041051',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000142,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,182.8225417,40.68492,0,NULL,58532159182,914564987,14290077,16.5),(89909,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89909,37.46,0.17,311,37744,70,NULL,NULL,'SDSS J121119.14+305944.0',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',NULL,NULL,'15.8g',0.39,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,182.8297917,30.99558,0.067,NULL,58634162611,916158790,14314981,15.8),(89910,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89910,32.55,0.2,32.4,37745,74.4,NULL,NULL,'UGC 07184',NULL,'2013AJ....146...86T',2013,1,1.31,NULL,'G',0.000097,NULL,'14.7g',0.58,'SB(rs)d pec',NULL,NULL,NULL,NULL,1,182.8329583,1.49225,0.033,NULL,57987577010,906055890,14157123,14.7),(89911,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89911,32.59,0.51,32.9,37745,NULL,NULL,'Malmquist cor.','UGC 07184',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89912,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89912,32.59,0.43,33,37745,75,NULL,'3.6 micron, color corrected','UGC 07184',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89913,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89913,32.63,0.43,33.5,37745,75,NULL,'3.6 micron, color + selection bias corrected','UGC 07184',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89914,'Tully-Fisher','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89914,32.75,0.47,35.5,37745,NULL,NULL,NULL,'UGC 07184',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89915,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89915,37.79,0.46,362,37746,70,NULL,NULL,'2MASX J12111988+6125033',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,182.833125,61.41758,0,NULL,57339604781,895931324,13998926,17),(89916,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89916,36.97,0.46,248,37747,70,NULL,NULL,'2MASX J12112070+4432574',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,182.836333333,44.54925,0,NULL,59059563216,922805675,14418838,17.7),(89917,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89917,36.88,0.46,237,37748,70,NULL,NULL,'2MASX J12112111+1414389',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000197,NULL,'15.8g',0.47,'Im/S',NULL,NULL,NULL,NULL,1,182.8380417,14.24422,0.078,NULL,58143553941,908493030,14195203,15.8),(89918,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89918,38.05,0.46,406,37749,70,NULL,NULL,'SDSS J121122.56+034535.2',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,182.8440417,3.75981,0,NULL,58045602664,906962541,14171289,17.7),(89919,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89919,38.71,0.33,551,37750,70,NULL,NULL,'SDSS J121122.99+093508.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000179,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,182.845833,9.58558,0,NULL,58201506359,909398536,14209352,18.1),(89920,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,NULL,89920,35.41,0.54,121,37751,70,NULL,NULL,'2MASX J12112454-1739407',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.3,NULL,NULL,NULL,NULL,NULL,1,182.852208333,-17.66142,0.069,NULL,43029550043,672336719,10505261,14.1),(89921,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89921,38,0.33,398,37752,70,NULL,NULL,'SDSS J121125.10+160710.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000165,NULL,'18.7g',0.12,'AGN',NULL,NULL,NULL,NULL,1,182.854625,16.11964,0.096,NULL,58177734328,909027098,14203548,18.7),(89922,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89922,37.51,0.46,318,37753,70,NULL,NULL,'2MASX J12112508+1915448',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.94',0.17,NULL,NULL,NULL,NULL,NULL,1,182.8547083,19.26258,0.037,NULL,58130817195,908294018,14192094,17.94),(89923,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89923,37.77,0.33,358,37754,70,NULL,NULL,'2MASX J12112614+3656441',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,182.858917,36.9455,0,NULL,58548686092,914823220,14294112,17.5),(89924,'FP','2016-12-15 15:14:55','2016-12-16 11:20:05','1',NULL,'R',89924,37.54,0.46,322,37755,70,NULL,NULL,'SDSS J121127.00+233928.1',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.5g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,182.8625,23.65783,0.092,NULL,58601703095,915651610,14307056,17.5),(89925,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89925,37.39,0.46,301,37756,70,NULL,NULL,'SDSS J121127.30+162653.1',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.2g',0.36,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,182.8637917,16.44811,0.116,NULL,58177236245,909019316,14203426,16.2),(89926,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89926,37.9,0.46,381,37757,70,NULL,NULL,'2MASX J12112808+1338349',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,182.867,13.64314,0.027,NULL,58145827012,908528547,14195758,17.8),(89927,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89927,39.24,0.46,706,37758,70,NULL,NULL,'SDSS J121128.44+275040.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,182.8685417,27.84447,0.027,NULL,58643478490,916304351,14317255,18.3),(89928,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89928,36.44,0.46,194,37759,70,NULL,NULL,'2MASX J12112915+3647181',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000175,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,182.871417,36.78842,0,NULL,58549232554,914831758,14294246,17),(89929,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89929,37.15,0.33,270,37760,70,NULL,NULL,'LCRS B120855.3-025445',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000156,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,182.872,-3.19058,0.077,NULL,43012688696,672073260,10501144,17.2),(89930,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89930,37.59,0.46,329,37761,70,NULL,NULL,'2MASX J12112976+6147366',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,182.873916667,61.79358,0.005,NULL,57369973136,896405830,14006341,17.6),(89931,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89931,36.27,0.58,180,37762,70,NULL,NULL,'2MASX J12113126-1947012',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.7I',0.2,NULL,NULL,NULL,NULL,NULL,1,182.8802083,-19.78364,0.121,NULL,43031515334,672367427,10505741,14.7),(89932,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89932,37.21,0.46,277,37763,70,NULL,NULL,'2MASX J12113332+6708386',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000084,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,182.888666667,67.144,0.013,NULL,57311732141,895495814,13992122,16.7),(89933,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:05','1','SN 2010dm',NULL,89933,35.79,0.01,144,37764,NULL,NULL,'H, SN 2010dm','SDSS J121133.31+471628.6',NULL,'2012MNRAS.425.1007B',2012,1,0.1,NULL,'G',NULL,NULL,'19.9g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,182.888833,47.27461,0,NULL,57178216963,893409640,13959525,19.9),(89934,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:05','1','SN 2010dm',NULL,89934,35.85,0.02,148,37764,72,NULL,'M(H) = -18.317 mag','SDSS J121133.31+471628.6',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89935,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:05','1','SN 2010dm',NULL,89935,36.13,0.06,163,37764,70,NULL,'SiFTO+SALT2, SN PTF10hmv, SN 2010dm','SDSS J121133.31+471628.6',0.032,'2012MNRAS.426.2359M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89936,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:05','1','PS1 SN PS10nq','N',89936,36.18,0.26,166,37765,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10nq HOST',0.0357,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89937,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89937,33.43,0.69,48.4,37766,100,NULL,'mid-IR','NGC 4161',NULL,'2013ApJ...771...88L',2013,1,1.37,NULL,'G',0.00003,NULL,'13.6g',0.77,'S?','Group member',NULL,NULL,NULL,1,182.889416667,57.7375,0,NULL,57329467780,895772934,13996452,13.6),(89938,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89938,37.38,0.46,299,37767,70,NULL,NULL,'2MASX J12113402+0302581',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000172,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,182.891833333,3.0495,0,NULL,58045021808,906953465,14171147,17.1),(89939,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89939,35.23,0.46,111,37768,70,NULL,NULL,'2MASX J12113495+0921070',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000159,NULL,'15.9g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,182.895625,9.35194,0,NULL,58215485547,909616961,14212765,15.9),(89940,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89940,37.77,0.46,358,37769,70,NULL,NULL,'2MASX J12113496+3806371',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000181,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,182.89575,38.11039,0,NULL,58579388387,915302943,14301608,17),(89941,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89941,38,0.33,398,37770,70,NULL,NULL,'2MASX J12113548+1612099',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000144,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,182.897833333,16.20272,0.096,NULL,58177688627,909026384,14203537,18),(89942,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89942,35.92,0.46,153,37771,70,NULL,NULL,'CGCG 098-088',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000717,NULL,'15.7',0.2,'S0',NULL,NULL,NULL,NULL,1,182.8997083,19.89575,0.038,NULL,58118378934,908099670,14189057,15.7),(89943,'Tully est','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89943,32.9,0.8,38,37772,75,NULL,'B','ARK 350',NULL,'1988NBGC.C....0000T',1988,1,0.4,NULL,'G',0.000294,NULL,'15.1',0.3,'Compact','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,182.908666667,16.4785,0.116,NULL,58177284226,909020066,14203438,15.1),(89944,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89944,37.34,0.46,293,37773,70,NULL,NULL,'2MASX J12114035+2622432',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,182.918,26.37861,0.053,NULL,58641780702,916277823,14316840,18),(89945,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89945,37.57,0.46,327,37774,70,NULL,NULL,'2MASXi J1211411+154048',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000169,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,182.921166667,15.68011,0.102,NULL,58177631607,909025493,14203523,16.9),(89946,'IRAS','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89946,33.07,0.8,41.1,37775,75,NULL,'MAT, I','ESO 321- G 010',NULL,'1997ApJS..109..333W',1997,1,2.13,'Exactly edge-on.  SGC classification (S0/a: sp) is wrong.','G',0.000006,NULL,'14.22',0.3,'Sbc: sp        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,182.925583,-38.5485,0.325,NULL,43276706227,676198534,10565602,14.22),(89947,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89947,32.84,0.43,37,37775,75,NULL,'3.6 micron, color + selection bias corrected','ESO 321- G 010',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89948,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89948,32.85,0.32,37.2,37775,85,NULL,'I, raw','ESO 321- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89949,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89949,32.86,0.43,37.3,37775,75,NULL,'MAT, I, raw','ESO 321- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89950,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89950,32.88,0.32,37.7,37775,85,NULL,'I, inv','ESO 321- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89951,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89951,33,0.43,39.8,37775,75,NULL,'MAT, I, inv','ESO 321- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89952,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89952,33,0.43,39.9,37775,75,NULL,'3.6 micron, color corrected','ESO 321- G 010',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89953,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89953,33.09,0.49,41.4,37775,75,NULL,'IR','ESO 321- G 010',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89954,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89954,33.1,0.43,41.6,37775,75,NULL,'MAT, I, cor','ESO 321- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89955,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89955,33.14,0.2,42.5,37775,74.4,NULL,NULL,'ESO 321- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89956,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89956,33.47,0.15,49.5,37775,NULL,NULL,NULL,'ESO 321- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89957,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89957,34.09,NULL,65.7,37775,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 321- G 010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89958,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89958,34.1,NULL,66,37775,NULL,NULL,'Dipole + Quadrupole','ESO 321- G 010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89959,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89959,34.1,NULL,66.1,37775,NULL,NULL,'Dipole','ESO 321- G 010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89960,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89960,34.15,NULL,67.7,37775,NULL,NULL,NULL,'ESO 321- G 010',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89961,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89961,36.01,0.46,159,37776,70,NULL,NULL,'2MASX J12114530+6246138',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000157,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,182.9385417,62.77067,0,NULL,57370277762,896410590,14006415,16.6),(89962,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89962,37.47,0.46,312,37777,70,NULL,NULL,'2MASX J12114527+0922181',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,182.9387083,9.37175,0,NULL,58215470687,909616729,14212761,17.2),(89963,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89963,36.8,0.46,229,37778,70,NULL,NULL,'2MASX J12114617+2138578',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.69',0.22,NULL,NULL,NULL,NULL,NULL,1,182.94225,21.64933,0.042,NULL,58857140933,919642827,14369419,17.69),(89964,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89964,38.46,0.46,493,37779,70,NULL,NULL,'SDSS J121147.05+084016.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000177,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,182.946083333,8.67122,0,NULL,58214888371,909607630,14212619,18.4),(89965,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89965,33.48,0.6,49.6,37780,NULL,NULL,'Malmquist cor.','IC 0768',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.00002,NULL,'14.5g',0.65,'Scd:','Group member',NULL,NULL,NULL,1,182.948417,12.14372,0.027,NULL,58139944061,908436625,14194322,14.5),(89966,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89966,33.57,0.2,51.8,37780,74.4,NULL,NULL,'IC 0768',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89967,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89967,33.62,0.56,53,37780,NULL,NULL,NULL,'IC 0768',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89968,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89968,37.4,0.46,301,37781,70,NULL,NULL,'2MASX J12114872+0036531',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000077,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,182.953083,0.61464,0.013,NULL,57989207335,906081364,14157521,17.3),(89969,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89969,37.12,0.46,265,37782,70,NULL,NULL,'2MASX J12114899+4954491',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,182.953916667,49.91375,0.032,NULL,57187697893,893557779,13961840,17.6),(89970,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89970,37.4,0.46,302,37783,70,NULL,NULL,'2MASX J12114992-0213599',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000178,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,182.958125,-2.23331,0.033,NULL,42960353809,671255528,10488367,17.1),(89971,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89971,37.96,0.46,390,37784,70,NULL,NULL,'2MASX J12115025+1340496',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000163,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,182.9595417,13.68061,0.028,NULL,58138401050,908412516,14193945,17.1),(89972,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89972,37.03,0.46,255,37785,70,NULL,NULL,'2MASX J12115048+6149358',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000174,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,182.960625,61.82675,0.033,NULL,57369975925,896405873,14006341,17.3),(89973,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89973,38.24,0.46,445,37786,70,NULL,NULL,'2MASX J12115084+3057087',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000103,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,182.96175,30.95247,0.054,NULL,58634214498,916159601,14314993,17.2),(89974,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89974,37.56,0.46,325,37787,70,NULL,NULL,'2MASX J12115084+1300386',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,182.961833,13.01089,0.033,NULL,58138605770,908415715,14193995,17.3),(89975,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89975,37.61,0.33,332,37788,70,NULL,NULL,'2MASX J12115089+1508566',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00018,NULL,'16.9g',0.28,'AGN',NULL,NULL,NULL,NULL,1,182.962125,15.14917,0.14,NULL,58176456857,909007138,14203236,16.9),(89976,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89976,36.74,0.46,223,37789,70,NULL,NULL,'2MASX J12115098+1323326',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000194,NULL,'16.0g',0.4,'E0',NULL,NULL,NULL,NULL,1,182.962416667,13.39225,0.031,NULL,58138691347,908417052,14194016,16),(89977,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89977,37.14,0.33,268,37790,70,NULL,NULL,'2MASX J12115112+0516021',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,182.962917,5.26719,0,NULL,58047309142,906989205,14171706,17),(89978,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89978,38.3,0.46,456,37791,70,NULL,NULL,'SDSS J121152.21+442810.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000162,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,182.9675417,44.46947,0,NULL,59059541700,922805339,14418833,18.4),(89979,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89979,38.19,0.46,435,37792,70,NULL,NULL,'2MASX J12115232+5509167',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000132,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,182.967833,55.15472,0,NULL,57213067393,893954178,13968034,17.8),(89980,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:05','1','SN 1971G','R',89980,32.77,NULL,35.8,37793,NULL,NULL,'Photographic','NGC 4162',NULL,'1988SSRv...48....1R',1988,1,2.3,NULL,'G',0.00002,NULL,'12.87',1.4,'(R)SA(rs)bc    AGN','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,182.968625,24.12367,0.089,NULL,58601232800,915644262,14306941,12.87),(89981,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:05','1','SN 1971G',NULL,89981,33.12,0.25,42.1,37793,60,NULL,'M(B) = -19.48 mag','NGC 4162',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89982,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:05','1','SN 1971G',NULL,89982,33.22,0.25,44.1,37793,60,NULL,'M(V) = -19.47 mag','NGC 4162',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89983,'Sosies','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89983,32.14,0.27,26.8,37793,NULL,NULL,NULL,'NGC 4162',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89984,'Tully est','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89984,32.93,0.8,38.5,37793,75,NULL,'B','NGC 4162',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89985,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89985,31.95,0.69,24.5,37793,100,NULL,'mid-IR','NGC 4162',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89986,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89986,32.92,0.47,38.4,37793,NULL,NULL,'H','NGC 4162',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89987,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89987,32.93,0.45,38.6,37793,NULL,NULL,'K','NGC 4162',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89988,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89988,32.94,0.46,38.7,37793,NULL,NULL,'J','NGC 4162',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89989,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89989,32.98,0.4,39.4,37793,NULL,NULL,NULL,'NGC 4162',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89990,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89990,33.07,0.5,41.1,37793,NULL,NULL,'Malmquist cor.','NGC 4162',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89991,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89991,33.12,0.43,42.1,37793,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4162',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89992,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89992,33.16,0.43,42.8,37793,75,NULL,'3.6 micron, color corrected','NGC 4162',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89993,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89993,33.21,0.2,43.9,37793,74.4,NULL,NULL,'NGC 4162',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89994,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89994,33.25,0.46,44.6,37793,NULL,NULL,NULL,'NGC 4162',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89995,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,89995,33.32,0.4,46.1,37793,NULL,NULL,'mean','NGC 4162',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89996,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89996,37.42,0.46,304,37794,70,NULL,NULL,'SDSS J121152.57+633452.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000155,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,182.969083333,63.58128,0.017,NULL,57319170200,895612034,13993938,18.5),(89997,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89997,37.12,0.46,266,37795,70,NULL,NULL,'2MASX J12115285-0113109',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000074,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,182.970125,-1.21956,0.021,NULL,42959430419,671241100,10488142,16.7),(89998,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89998,38,0.33,398,37796,70,NULL,NULL,'2MASX J12115388+5033491',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00014,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,182.9747083,50.56394,0.018,NULL,57235178266,894299660,13973432,17.6),(89999,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',89999,35.14,0.46,107,37797,70,NULL,NULL,'2MASX J12115472+5838137',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000158,NULL,'16.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,182.977875,58.63706,0,NULL,57329065720,895766651,13996353,16.2),(90000,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90000,36.59,0.33,208,37798,70,NULL,NULL,'2MASX J12115583+3335467',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00018,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,182.9827917,33.5965,0,NULL,58756716114,918073689,14344901,16.3),(90001,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90001,33.93,0.46,61.1,37799,70,NULL,NULL,'CGCG 158-040',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000073,NULL,'14.8g',0.39,'S0?','Field galaxy',NULL,NULL,NULL,1,182.986708333,27.64322,0.032,NULL,58643406867,916303232,14317238,14.8),(90002,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90002,36.16,0.27,170,37800,70,NULL,NULL,'2MASX J12115703+6542258',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,182.987667,65.70708,0.037,NULL,57312344281,895505379,13992271,17.5),(90003,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90003,38,0.33,398,37801,70,NULL,NULL,'2MASX J12115723+5029011',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000169,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,182.9887083,50.48383,0.018,NULL,57232886218,894263847,13972872,17.6),(90004,'CMD','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'N',90004,20,NULL,0.1,37802,NULL,NULL,NULL,'Uma Y',NULL,'2009AJ....137..450W',2009,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90005,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90005,37.41,0.46,303,37803,70,NULL,NULL,'2MASX J12115831+0628142',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000188,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,182.992958333,6.47053,0,NULL,58026740322,906667817,14166684,16.3),(90006,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90006,35.1,0.27,105,37804,NULL,NULL,'Malmquist cor.','UGC 07196',NULL,'2009ApJS..182..474S',2009,1,1.44,NULL,'G',0.000027,NULL,'14.6g',0.39,'Sbc (on edge)','Group member',NULL,NULL,NULL,1,182.9972917,15.40133,0.105,NULL,58180767846,909074497,14204289,14.6),(90007,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90007,35.2,0.4,110,37804,NULL,NULL,'mean','UGC 07196',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90008,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90008,35.3,0.46,115,37804,NULL,NULL,'J','UGC 07196',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90009,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90009,35.35,0.47,118,37804,NULL,NULL,'H','UGC 07196',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90010,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90010,35.38,0.45,119,37804,NULL,NULL,'K','UGC 07196',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90011,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90011,35.4,0.49,120,37804,75,NULL,'IR','UGC 07196',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90012,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90012,35.56,0.22,130,37804,NULL,NULL,NULL,'UGC 07196',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90013,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90013,35.6,0.2,132,37804,74.4,NULL,NULL,'UGC 07196',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90014,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90014,37.29,0.46,287,37805,70,NULL,NULL,'SDSS J121159.63+102448.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000176,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,182.9985,10.41361,0,NULL,58214248923,909597639,14212463,18),(90015,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90015,37.57,0.46,326,37806,70,NULL,NULL,'2MASX J12115998+5811377',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000136,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,182.999875,58.19381,0,NULL,57329136073,895767751,13996371,17.7),(90016,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90016,37.14,0.33,268,37807,70,NULL,NULL,'2MASX J12120002+0512383',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000187,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,183,5.21061,0,NULL,58047312125,906989251,14171707,16.5),(90017,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90017,38.67,0.46,542,37808,70,NULL,NULL,'2MASX J12120036+5839517',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,183.001333,58.66428,0,NULL,57329064993,895766640,13996353,18),(90018,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90018,36.87,0.46,236,37809,70,NULL,NULL,'2MASX J12120320+3627368',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00017,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,183.0135,36.46039,0,NULL,58549126482,914830101,14294220,16.2),(90019,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90019,36.95,0.46,246,37810,70,NULL,NULL,'2MASX J12120368+6305098',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000164,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,183.0154583,63.08625,0.017,NULL,57318891116,895607673,13993869,17.4),(90020,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90020,37.39,0.33,300,37811,70,NULL,NULL,'2MASX J12120427+0233033',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000153,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,183.017875,2.55111,0.014,NULL,57987347008,906052297,14157067,17.1),(90021,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90021,36.19,0.46,173,37812,70,NULL,NULL,'2MASX J12120432+1029162',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000158,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,183.0180417,10.48778,0,NULL,58214198436,909596850,14212450,16.8),(90022,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90022,35.68,0.56,137,37813,70,NULL,NULL,'2MASX J12120478-5155535',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,183.019917,-51.9315,0.497,NULL,44587843896,696685060,10885704,16.6),(90023,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90023,38.13,0.33,422,37814,70,NULL,NULL,'SDSS J121204.89+444612.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,183.020417,44.77025,0,NULL,59059850703,922810167,14418908,18),(90024,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90024,36.51,0.85,201,37815,70,NULL,NULL,'2MASX J12120525-1649385',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.45',0.3,NULL,NULL,NULL,NULL,NULL,1,183.021916667,-16.82758,0.081,NULL,43079705549,673120399,10517506,16.45),(90025,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90025,36.94,0.27,244,37816,70,NULL,NULL,'NGC 4164',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000167,NULL,'15.4g',0.52,'E3','Group member',NULL,NULL,NULL,1,183.02275,13.20564,0.033,NULL,58138716407,908417443,14194022,15.4),(90026,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90026,35.96,0.46,155,37817,70,NULL,NULL,'2MASX J12120628+2248377',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.47',0.22,NULL,NULL,NULL,NULL,NULL,1,183.026125,22.81044,0.077,NULL,58856592858,919634263,14369285,17.47),(90027,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90027,37.61,0.33,332,37818,70,NULL,NULL,'2MASX J12120677+1514137',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,183.028333,15.23717,0.14,NULL,58180781718,909074714,14204292,17.2),(90028,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90028,37.38,0.33,299,37819,70,NULL,NULL,'LCRS B120933.2-022344',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,183.029583,-2.67353,0.069,NULL,43005304003,671957875,10499341,17.9),(90029,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90029,36.97,0.73,248,37820,70,NULL,NULL,'FAIRALL 1381',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.5B',0.33,NULL,NULL,NULL,NULL,NULL,1,183.029583,-73.99908,0.749,NULL,44183453494,690366460,10786975,16.5),(90030,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90030,37.61,0.46,333,37821,70,NULL,NULL,'SDSS J121207.09+450401.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000137,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,183.029583,45.06708,0,NULL,59059933934,922811467,14418929,18.6),(90031,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90031,35.93,0.46,154,37822,70,NULL,NULL,'2MASX J12120714+3233187',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,183.0297083,32.55528,0,NULL,58755213868,918050216,14344534,16.7),(90032,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90032,37.27,0.33,284,37823,70,NULL,NULL,'2MASX J12120747+0255263',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000167,NULL,'16.4g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,183.031333,2.92394,0,NULL,58044996814,906953075,14171141,16.4),(90033,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90033,38.43,0.46,485,37824,70,NULL,NULL,'2MASX J12120772+1357277',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000179,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,183.0322083,13.95789,0.079,NULL,58138356842,908411825,14193934,18),(90034,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90034,37.95,0.21,389,37825,70,NULL,NULL,'SDSS J121207.91+591326.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,183.0329583,59.22397,0,NULL,57343637273,895994332,13999911,18.2),(90035,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90035,36.95,0.46,246,37826,70,NULL,NULL,'2MASX J12120804+4415067',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,183.033625,44.25197,0,NULL,59057510084,922773595,14418337,17.3),(90036,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90036,37.61,0.46,333,37827,70,NULL,NULL,'SDSS J121208.56+060504.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,183.0357083,6.08472,0,NULL,58026274975,906660546,14166571,18),(90037,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90037,36.73,0.46,222,37828,70,NULL,NULL,'2MASX J12120885+5518236',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,183.036667,55.30653,0,NULL,57213247010,893956984,13968077,16.9),(90038,'Brightest Stars','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90038,27.75,NULL,3.55,37829,NULL,NULL,NULL,'NGC 4163',NULL,'1998A&AS..128..325T',1998,1,1.8,NULL,'G',0.000017,NULL,'14.5',1.6,'IAm            BCD','in a radial-velocity based grouping',NULL,NULL,NULL,1,183.038167,36.16919,0,NULL,58548949705,914827339,14294177,14.5),(90039,'CMD','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90039,27.36,NULL,2.96,37829,NULL,NULL,NULL,'NGC 4163',NULL,'2012ApJ...748...47M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90040,'CMD','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90040,27.4,0.04,3.02,37829,NULL,NULL,NULL,'NGC 4163',NULL,'2009ApJ...695..561M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90041,'CMD','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90041,27.4,0.04,3.02,37829,NULL,NULL,NULL,'NGC 4163',NULL,'2010ApJ...721..297M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90042,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90042,27.24,0.1,2.81,37829,NULL,NULL,NULL,'NGC 4163',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90043,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90043,27.28,0.03,2.86,37829,NULL,NULL,'I','NGC 4163',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90044,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90044,27.3,0.03,2.88,37829,NULL,NULL,'I','NGC 4163',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90045,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90045,27.33,0.11,2.92,37829,NULL,NULL,NULL,'NGC 4163',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90046,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90046,27.34,0.02,2.94,37829,NULL,NULL,NULL,'NGC 4163',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90047,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90047,27.35,0.08,2.95,37829,74.4,NULL,NULL,'NGC 4163',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90048,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90048,27.36,NULL,2.96,37829,NULL,NULL,NULL,'NGC 4163',NULL,'2006AJ....131.1361K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90049,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90049,27.35,0.06,2.96,37829,NULL,NULL,NULL,'NGC 4163',NULL,'2013AstBu..68..125M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90050,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90050,27.37,0.02,2.98,37829,NULL,NULL,'I','NGC 4163',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90051,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90051,27.39,0.07,3,37829,NULL,NULL,NULL,'NGC 4163',NULL,'2014A&A...566A..71L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90052,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90052,26.62,0.4,2.1,37829,75,NULL,'B','NGC 4163',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90053,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90053,37.26,0.27,284,37830,70,NULL,NULL,'2MASX J12120971+6814154',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.0001,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,183.0404583,68.23769,0.033,NULL,57848573867,903883966,14123186,17.3),(90054,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90054,36.94,0.27,244,37831,70,NULL,NULL,'2MASX J12121001+4540357',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000179,NULL,'16.1g',0.4,'E0',NULL,NULL,NULL,NULL,1,183.041833,45.6765,0,NULL,59058279219,922785612,14418525,16.1),(90055,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90055,38.57,0.46,517,37832,70,NULL,NULL,'2MASX J12121021+2513593',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,183.042583,25.23328,0.055,NULL,58599500996,915617203,14306518,18.1),(90056,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90056,38.34,0.46,466,37833,70,NULL,NULL,'2MASX J12121071+3313067',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000133,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,183.0445417,33.21844,0,NULL,58757069707,918079214,14344987,18.1),(90057,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90057,38.16,0.46,428,37834,70,NULL,NULL,'2MASX J12121089+4531307',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000188,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,183.0455,45.52517,0,NULL,59059344828,922802262,14418785,17),(90058,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90058,36.59,0.33,208,37835,70,NULL,NULL,'2MASX J12121176+3331187',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000175,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,183.049041667,33.522,0,NULL,58756724348,918073817,14344903,16.3),(90059,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:05','1','SN 1971G',NULL,90059,32.7,0.06,34.7,37836,66,NULL,NULL,'NGC 4165',NULL,'1994A&A...281...51M',1994,1,1.33,NULL,'G',0.00003,NULL,'14.4g',0.68,'SAB(r)a:?;HII  LINER','in a pair',NULL,NULL,NULL,1,183.049167,13.24653,0.026,NULL,58138751461,908417991,14194031,14.4),(90060,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:05','1','SN 1971G',NULL,90060,32.8,0.48,36,37836,67,NULL,NULL,'NGC 4165',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90061,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90061,32.42,0.4,30.5,37836,NULL,NULL,'mean','NGC 4165',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90062,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90062,33.8,0.46,57.6,37836,NULL,NULL,'J','NGC 4165',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90063,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90063,33.89,0.47,59.9,37836,NULL,NULL,'H','NGC 4165',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90064,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90064,36.65,0.46,214,37837,70,NULL,NULL,'2MASX J12121174+5925446',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00016,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,183.0492083,59.42889,0,NULL,57343610107,895993907,13999904,16.7),(90065,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90065,36.37,0.46,188,37838,70,NULL,NULL,'2MASX J12121374+5250519',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000179,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,183.057083,52.84792,0.006,NULL,57216067310,894001051,13968766,16.3),(90066,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90066,37.44,0.46,308,37839,70,NULL,NULL,'2MASX J12121413+3812358',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,183.059,38.21008,0,NULL,58579547122,915305423,14301647,17.8),(90067,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90067,36.83,0.46,232,37840,70,NULL,NULL,'2MASX J12121420+6702566',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000101,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,183.059167,67.04917,0.013,NULL,57311543274,895492863,13992075,16.3),(90068,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:05','1','SN 2006az',NULL,90068,34.92,0.16,93.5,37841,74.2,NULL,'SALT 2','NGC 4172',0.030935,'2010ApJ...716..712A',2010,1,1.04,NULL,'G',0.000167,NULL,'13.9g',0.98,'S?',NULL,NULL,NULL,NULL,1,183.062041667,56.17756,0,NULL,57398577647,896852775,14013324,13.9),(90069,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:05','1','SN 2006az','R',90069,35.42,0.05,121,37841,NULL,NULL,'MLCS2k2, R(V) = 1.8','NGC 4172',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90070,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:05','1','SN 2006az','R',90070,35.47,0.05,124,37841,NULL,NULL,'MLCS2k2, R(V) = 3.1','NGC 4172',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90071,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:05','1','SN 2006az',NULL,90071,35.51,0.09,126,37841,74.4,NULL,NULL,'NGC 4172',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90072,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:05','1','SN 2006az',NULL,90072,35.62,0.15,129,37841,73.8,NULL,'SALT 2 (SNANA)','NGC 4172',0.0315,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90073,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:05','1','SN 2006az',NULL,90073,35.62,0.15,129,37841,70,NULL,'SALT 2','NGC 4172',0.030935,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90074,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:05','1','SN 2006az',NULL,90074,35.66,0.04,131,37841,72,NULL,'SALT','NGC 4172',0.030935,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90075,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:05','1','SN 2006az',NULL,90075,35.72,0.02,135,37841,70,NULL,'SALT 2','NGC 4172',0.030935,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90076,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:05','1','SN 2006az',NULL,90076,35.8,0.14,140,37841,65,NULL,'MLCS17','NGC 4172',0.030935,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90077,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:05','1','SN 2006az',NULL,90077,35.81,0.17,141,37841,65,NULL,'SALT','NGC 4172',0.030935,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90078,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:05','1','SN 2006az',NULL,90078,35.82,0.18,142,37841,65,NULL,'SALT2','NGC 4172',0.030935,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90079,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:05','1','SN 2006az',NULL,90079,35.85,0.14,144,37841,65,NULL,'MLCS31','NGC 4172',0.030935,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90080,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90080,37.95,0.21,389,37842,70,NULL,NULL,'2MASX J12121494+5908576',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000178,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,183.062083,59.14942,0,NULL,57343692250,895995191,13999924,17.5),(90081,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90081,37.82,0.46,366,37843,70,NULL,NULL,'2MASX J12121497+1330362',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,183.0622917,13.51011,0.031,NULL,58138367755,908411996,14193937,17.6),(90082,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90082,38.59,0.46,523,37844,70,NULL,NULL,'2MASXi J1212159+641140',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000139,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,183.066375,64.19469,0.017,NULL,57318368370,895599505,13993742,18.3),(90083,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90083,37.84,0.46,370,37845,70,NULL,NULL,'2MASX J12121592+3640568',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000184,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,183.0665417,36.68239,0,NULL,58549227599,914831681,14294245,17.4),(90084,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90084,35.7,0.46,138,37846,70,NULL,NULL,'2MASX J12121606+1525452',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000158,NULL,'15.9g',0.43,NULL,NULL,NULL,NULL,NULL,1,183.066875,15.42931,0.105,NULL,58180776894,909074638,14204291,15.9),(90085,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90085,37.9,0.46,379,37847,70,NULL,NULL,'SDSS J121216.60+154957.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000144,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,183.069208333,15.83264,0.072,NULL,58179499983,909054687,14203979,18.5),(90086,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90086,36.74,0.46,223,37848,70,NULL,NULL,'2MASX J12121660+4431127',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000177,NULL,'16.1g',0.41,'E0',NULL,NULL,NULL,NULL,1,183.069333333,44.52017,0,NULL,59059808218,922809503,14418898,16.1),(90087,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90087,36.94,0.27,244,37849,70,NULL,NULL,'2MASX J12121669+4536257',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000166,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,183.069666667,45.60722,0,NULL,59058233636,922784900,14418514,16.7),(90088,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90088,37.95,0.21,389,37850,70,NULL,NULL,'2MASX J12121688+5905383',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000161,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,183.070333,59.09392,0,NULL,57343511543,895992367,13999880,17.4),(90089,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90089,36.68,0.46,217,37851,70,NULL,NULL,'2MASX J12121699+5755363',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000145,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,183.0705417,57.92694,0,NULL,57329516215,895773690,13996463,17.2),(90090,'SBF','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90090,32.45,0.42,30.9,37852,NULL,NULL,'I','NGC 4168',NULL,'2001ApJ...546..681T',2001,1,2.03,'The 2MASS peak is 6 arcsec northwest of the optical nucleus.','G',0.000017,NULL,'12.4g',1.58,'E2             Sy1.9','in a radial-velocity based grouping',NULL,NULL,'Sy 1.9',1,183.0719583,13.20519,0.026,NULL,58138752499,908418007,14194031,12.4),(90091,'SBF','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90091,32.54,0.12,32.2,37852,74.4,NULL,NULL,'NGC 4168',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90092,'D-Sigma','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90092,32.36,0.4,29.6,37852,75,NULL,'Edat, raw','NGC 4168',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90093,'D-Sigma','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90093,32.69,0.4,34.6,37852,75,NULL,'Edat, cor','NGC 4168',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90094,'Faber-Jackson','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90094,31.42,0.65,19.2,37852,95,NULL,'Weighted Mean','NGC 4168',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90095,'Faber-Jackson','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90095,31.42,0.65,19.2,37852,95,NULL,'de Vaucouleurs','NGC 4168',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90096,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90096,32.54,0.12,32.2,37852,74.4,NULL,NULL,'NGC 4168',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90097,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90097,32.67,NULL,34.2,37852,NULL,NULL,NULL,'NGC 4168',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90098,'Tertiary','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90098,30.49,0.25,12.5,37852,95,NULL,NULL,'NGC 4168',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90099,'Tully est','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90099,31.13,0.8,16.8,37852,75,NULL,'B','NGC 4168',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90100,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90100,32.88,0.4,37.7,37852,NULL,NULL,'mean','NGC 4168',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90101,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90101,32.93,0.45,38.6,37852,NULL,NULL,'K','NGC 4168',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90102,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90102,37.49,0.46,315,37853,70,NULL,NULL,'2MASX J12121802+3747247',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000173,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,183.075041667,37.79011,0,NULL,58579610290,915306410,14301662,16.5),(90103,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90103,35.61,0.54,132,37854,70,NULL,NULL,'2MASX J12121825-5159090',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'15.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,183.076083333,-51.98592,0.497,NULL,44588024492,696687882,10885748,15.2),(90104,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90104,37.8,0.46,362,37855,70,NULL,NULL,'2MASX J12121849+0432323',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,183.077167,4.54231,0,NULL,58047536259,906992754,14171761,18),(90105,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90105,33.58,0.45,52,37856,NULL,NULL,'K','NGC 4169',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.00006,NULL,'13.15',0.9,'S0/a           Sy2','in a triple',NULL,NULL,'Sy 2',1,183.07825,29.17942,0.02,NULL,58632375386,916130865,14314544,13.15),(90106,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90106,33.87,0.4,59.3,37856,NULL,NULL,'mean','NGC 4169',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90107,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90107,37.43,0.46,306,37857,70,NULL,NULL,'2MASX J12121896+2039418',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.25',0.15,NULL,NULL,NULL,NULL,NULL,1,183.079041667,20.66158,0.033,NULL,58855918674,919623729,14369120,18.25),(90108,'Tully est','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90108,31.68,0.8,21.7,37858,75,NULL,NULL,'UGC 07207',NULL,'1988NBGC.C....0000T',1988,1,2.3,'z = 0.6165 in (2010MNRAS.405.2302H)','G',0.000023,NULL,'21.1i',1.1,'IB(s)m V','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,183.0782083,37.01481,0,NULL,58548364163,914818190,14294034,21.1),(90109,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90109,37.38,0.33,299,37859,70,NULL,NULL,'LCRS B120945.5-021837',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000137,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,183.080833,-2.58828,0.077,NULL,43005286942,671957608,10499337,17.2),(90110,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90110,37.39,0.33,300,37860,70,NULL,NULL,'2MASX J12121996+0236123',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000091,NULL,'17.3g',0.21,'NLAGN',NULL,NULL,NULL,NULL,1,183.083125,2.60342,0.014,NULL,58042904870,906920388,14170631,17.3),(90111,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90111,38.25,0.33,448,37861,70,NULL,NULL,'SDSS J121221.14+063824.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,183.088125,6.64003,0,NULL,58026841673,906669401,14166709,18.2),(90112,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90112,29.29,NULL,7.2,37862,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 4173',NULL,'2010Ap&SS.325..163P',2010,1,5.04,NULL,'G',0.000067,NULL,'13.59',0.69,'Sdm','in a triple',NULL,NULL,NULL,1,183.089416667,29.20706,0.02,NULL,58632261130,916129080,14314516,13.59),(90113,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90113,29.31,NULL,7.27,37862,NULL,NULL,'Dipole + Quadrupole','NGC 4173',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90114,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90114,29.33,NULL,7.33,37862,NULL,NULL,'Dipole','NGC 4173',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90115,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90115,29.42,NULL,7.64,37862,NULL,NULL,NULL,'NGC 4173',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90116,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90116,29.93,0.4,9.7,37862,75,NULL,'B','NGC 4173',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90117,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90117,30.49,0.2,12.5,37862,74.4,NULL,NULL,'NGC 4173',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90118,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90118,30.62,0.43,13.3,37862,75,NULL,'3.6 micron, color corrected','NGC 4173',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90119,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90119,30.71,0.43,13.8,37862,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4173',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90120,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90120,37.76,0.46,357,37863,70,NULL,NULL,'2MASX J12122225+2650194',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'18.55',0.15,NULL,NULL,NULL,NULL,NULL,1,183.092583333,26.83889,0.044,NULL,58642077459,916282460,14316913,18.55),(90121,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90121,38.59,0.46,523,37864,70,NULL,NULL,'SDSS J121222.24+191451.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,183.092666667,19.24758,0.044,NULL,58125832489,908216132,14190877,18.1),(90122,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90122,36.5,0.2,200,37865,74.4,NULL,NULL,'VCC 0053',NULL,'2013AJ....146...86T',2013,1,0.53,NULL,'G',0.000013,NULL,'15.9g',0.36,'Sa:','Group member',NULL,NULL,NULL,1,183.094375,8.77669,0,NULL,58215098648,909610916,14212670,15.9),(90123,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90123,38.76,0.46,564,37866,70,NULL,NULL,'2MASX J12122284+2929464',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00013,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,183.095125,29.49644,0.028,NULL,58633124504,916142570,14314727,17.5),(90124,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90124,38.5,0.46,500,37867,70,NULL,NULL,'SDSS J121223.34+135749.8',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,183.0972917,13.96383,0.08,NULL,58138352773,908411762,14193933,17.6),(90125,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90125,36.94,0.27,244,37868,70,NULL,NULL,'2MASX J12122352+1315473',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,183.097917,13.26314,0.026,NULL,58138746851,908417919,14194029,17.5),(90126,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90126,36.65,0.46,213,37869,70,NULL,NULL,'2MASX J12122355+3642177',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,183.098083333,36.70489,0,NULL,58549248569,914832008,14294250,17.3),(90127,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90127,38.35,0.23,469,37870,70,NULL,NULL,'2MASX J12122369+3035045',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000141,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,183.098625,30.58456,0.046,NULL,58633946887,916155420,14314928,17.8),(90128,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90128,38.28,0.46,453,37871,70,NULL,NULL,'2MASX J12122428+2257169',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,183.101125,22.95475,0.099,NULL,58587099128,915423423,14303490,17.5),(90129,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90129,37.4,0.46,302,37872,70,NULL,NULL,'2MASX J12122445+0505003',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,183.101875,5.08336,0.018,NULL,58047277792,906988715,14171698,17.5),(90130,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90130,36.67,0.46,216,37873,70,NULL,NULL,'SDSS J121225.37+075912.7',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000102,NULL,'17.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,183.1057083,7.98686,0,NULL,58025311950,906645499,14166335,17.2),(90131,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90131,37.31,0.46,289,37874,70,NULL,NULL,'2MASX J12122559+0520233',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,183.10675,5.33983,0,NULL,58047104268,906986004,14171656,17.8),(90132,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90132,36.99,0.13,250,37875,70,NULL,NULL,'2MASX J12122585+5942254',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000158,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,183.107625,59.70703,0,NULL,57344104251,896001628,14000025,17),(90133,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90133,37.11,0.46,264,37876,70,NULL,NULL,'2MASX J12122600+3627027',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,183.108333,36.45086,0,NULL,58549100164,914829690,14294213,16.7),(90134,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90134,37.08,0.46,260,37877,70,NULL,NULL,'SDSS J121226.85+313705.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'17.8g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,183.111917,31.61814,0.031,NULL,58621707279,915964176,14311940,17.8),(90135,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90135,33.53,0.47,50.8,37878,NULL,NULL,'H','NGC 4174',NULL,'2007A&A...465...71T',2007,1,0.82,NULL,'G',0.000063,NULL,'14.1g',0.5,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,183.1120417,29.14922,0.02,NULL,58632386342,916131036,14314547,14.1),(90136,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90136,33.67,0.46,54.1,37878,NULL,NULL,'J','NGC 4174',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90137,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90137,33.73,0.45,55.8,37878,NULL,NULL,'K','NGC 4174',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90138,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90138,33.87,0.4,59.4,37878,NULL,NULL,'mean','NGC 4174',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90139,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90139,35.44,0.46,122,37879,70,NULL,NULL,'2MASX J12122720+3553005',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000174,NULL,'16.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,183.113333,35.8835,0,NULL,58551948596,914874196,14294909,16.1),(90140,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90140,34.94,0.5,97.4,37880,70,NULL,NULL,'2MASX J12122752-4202287',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,183.114583,-42.04139,0.685,NULL,43233581436,675524709,10555073,14.1),(90141,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90141,35.49,0.33,125,37881,70,NULL,NULL,'2MASX J12122799+4647477',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000163,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,183.116625,46.79661,0,NULL,57178673545,893416774,13959637,16.4),(90142,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90142,36.84,0.46,234,37882,70,NULL,NULL,'2MASX J12123012+1034091',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,183.1255,10.56911,0,NULL,58214768562,909605758,14212589,17),(90143,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90143,38.13,0.33,422,37883,70,NULL,NULL,'SDSS J121230.83+445208.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000168,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,183.1285,44.86897,0,NULL,59059828901,922809826,14418903,18.6),(90144,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90144,32.67,0.47,34.2,37884,NULL,NULL,'H','NGC 4175',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000022,NULL,'14.17',0.4,'Sbc            HII','in a triple',NULL,NULL,NULL,1,183.129375,29.16844,0.02,NULL,58632374334,916130848,14314544,14.17),(90145,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90145,32.73,0.45,35.2,37884,NULL,NULL,'K','NGC 4175',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90146,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90146,32.95,0.46,38.9,37884,NULL,NULL,'J','NGC 4175',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90147,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90147,33.91,0.4,60.5,37884,NULL,NULL,'mean','NGC 4175',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90148,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90148,35.2,0.4,110,37885,NULL,NULL,'mean','UGC 07210',NULL,'2007A&A...465...71T',2007,1,0.94,NULL,'G',0.000033,NULL,'14.8g',0.41,'Sb (on edge)','Group member',NULL,NULL,NULL,1,183.1302917,15.27033,0.105,NULL,58180813357,909075208,14204300,14.8),(90149,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90149,35.6,0.47,132,37885,NULL,NULL,'H','UGC 07210',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90150,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90150,35.62,0.45,133,37885,NULL,NULL,'K','UGC 07210',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90151,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90151,31.13,0.4,16.8,37886,75,NULL,'B','IC 0769',NULL,'1988NBGC.C....0000T',1988,1,2.39,NULL,'G',0.000013,NULL,'13.7g',1.12,'SA(rs)bc       HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,183.1347083,12.12381,0.028,NULL,58139961483,908436898,14194326,13.7),(90152,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90152,31.55,0.69,20.4,37886,100,NULL,'mid-IR','IC 0769',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90153,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90153,32.48,0.56,31.4,37886,NULL,NULL,'Malmquist cor.','IC 0769',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90154,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90154,32.66,0.2,34,37886,74.4,NULL,NULL,'IC 0769',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90155,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90155,32.71,0.51,34.8,37886,NULL,NULL,NULL,'IC 0769',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90156,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90156,32.85,0.36,37.2,37886,NULL,NULL,NULL,'IC 0769',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90157,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90157,32.86,0.43,37.4,37886,75,NULL,'3.6 micron, color corrected','IC 0769',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90158,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90158,32.88,0.4,37.7,37886,NULL,NULL,'mean','IC 0769',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90159,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90159,32.92,NULL,38.4,37886,NULL,NULL,NULL,'IC 0769',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90160,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90160,33.07,0.43,41.1,37886,75,NULL,'3.6 micron, color + selection bias corrected','IC 0769',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90161,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90161,33.52,0.3,50.5,37886,55,NULL,'B','IC 0769',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90162,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90162,33.78,0.47,57.1,37886,NULL,NULL,'H','IC 0769',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90163,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90163,33.85,0.46,58.9,37886,NULL,NULL,'J','IC 0769',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90164,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90164,33.86,0.45,59.1,37886,NULL,NULL,'K','IC 0769',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90165,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90165,35.06,0.39,103,37887,NULL,NULL,'Malmquist cor.','IC 3039',NULL,'2009ApJS..182..474S',2009,1,1,'Springob et al. (2005ApJS..160..149S) give v= 6996 km/sec.','G',0.000017,NULL,'15.37',0.3,'Sc','Group member',NULL,NULL,NULL,1,183.1357083,12.30989,0.048,NULL,58140129524,908439523,14194367,15.37),(90166,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90166,35.41,0.34,121,37887,NULL,NULL,NULL,'IC 3039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90167,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90167,35.52,0.2,127,37887,74.4,NULL,NULL,'IC 3039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90168,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90168,37.9,0.46,381,37888,70,NULL,NULL,'2MASX J12123274+1652484',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.66',0.17,NULL,NULL,NULL,NULL,NULL,1,183.1364583,16.88017,0.102,NULL,58171857303,908935270,14202113,18.66),(90169,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90169,36.16,0.27,170,37889,70,NULL,NULL,'2MASX J12123293+6546320',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000182,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,183.137167,65.7755,0.017,NULL,57312340734,895505323,13992270,16.9),(90170,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90170,37.95,0.21,389,37890,70,NULL,NULL,'SDSS J121233.54+592623.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,183.139791667,59.43989,0,NULL,57343620296,895994067,13999907,17.8),(90171,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90171,36.94,0.27,244,37891,70,NULL,NULL,'2MASX J12123652+4537306',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000213,NULL,'15.7g',0.49,'E0',NULL,NULL,NULL,NULL,1,183.152083,45.62519,0,NULL,59058239035,922784984,14418515,15.7),(90172,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90172,38.35,0.23,469,37892,70,NULL,NULL,'2MASX J12123677+3033465',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000179,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,183.153333,30.56303,0.046,NULL,58633958854,916155607,14314931,16.9),(90173,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90173,37.76,0.46,356,37893,70,NULL,NULL,'2MASX J12123683+0011378',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000076,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,183.153458333,0.19381,0.021,NULL,57988554920,906071170,14157362,17.5),(90174,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90174,37.73,0.46,351,37894,70,NULL,NULL,'2MASX J12123701+5853484',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,183.154375,58.89681,0,NULL,57343483022,895991922,13999873,17.3),(90175,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90175,35.12,0.33,106,37895,NULL,NULL,NULL,'ESO 441- G 019',NULL,'2009ApJS..182..474S',2009,1,1.3,'FLASH project (2003MNRAS.339..652K) gives v = 6689 +/- 47 km/sec.','G',0.000033,NULL,'15.5',0.7,'Sb',NULL,NULL,NULL,NULL,1,183.159,-32.58286,0.293,NULL,43439035208,678734925,10605233,15.5),(90176,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90176,35.16,0.2,108,37895,74.4,NULL,NULL,'ESO 441- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90177,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90177,35.22,0.31,111,37895,NULL,NULL,'Malmquist cor.','ESO 441- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90178,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90178,37.62,0.46,334,37896,70,NULL,NULL,'2MASX J12123926+6018560',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000168,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,183.163417,60.31547,0,NULL,57338768068,895918251,13998722,16.9),(90179,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90179,36.11,0.46,166,37897,70,NULL,NULL,'CGCG 013-102',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000198,NULL,'15.6g',0.49,'S0',NULL,NULL,NULL,NULL,1,183.1635417,-2.72125,0.077,NULL,43005270213,671957347,10499333,15.6),(90180,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90180,33.86,0.49,59.2,37898,75,NULL,'IR','UGC 07212',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000023,NULL,'16.0g',0.19,'Sd',NULL,NULL,NULL,NULL,1,183.164333333,34.68942,0,NULL,58550550341,914852349,14294567,16),(90181,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90181,34.26,NULL,71.1,37898,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07212',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90182,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90182,34.26,NULL,71.2,37898,NULL,NULL,'Dipole + Quadrupole','UGC 07212',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90183,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90183,34.27,NULL,71.4,37898,NULL,NULL,'Dipole','UGC 07212',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90184,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90184,34.27,NULL,71.5,37898,NULL,NULL,NULL,'UGC 07212',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90185,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90185,34.32,0.52,73.1,37898,NULL,NULL,NULL,'UGC 07212',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90186,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90186,34.32,0.2,73.1,37898,74.4,NULL,NULL,'UGC 07212',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90187,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90187,34.7,0.43,86.9,37898,NULL,NULL,'Malmquist cor.','UGC 07212',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90188,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90188,37.84,0.33,370,37899,70,NULL,NULL,'2MASX J12123947+1830510',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,183.1645,18.51408,0.055,NULL,58126040740,908219386,14190927,17),(90189,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90189,37.84,0.33,370,37900,70,NULL,NULL,'2MASX J12123947+1827130',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.72',0.13,NULL,NULL,NULL,NULL,NULL,1,183.164583,18.45356,0.055,NULL,58125981402,908218459,14190913,18.72),(90190,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90190,36.99,0.13,250,37901,70,NULL,NULL,'2MASX J12123973+5943425',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000165,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,183.165375,59.7285,0,NULL,57344110761,896001730,14000027,16.8),(90191,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90191,37.86,0.46,374,37902,70,NULL,NULL,'2MASX J12124104+4133288',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,183.171,41.55783,0,NULL,58535382135,914615345,14290864,17.2),(90192,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90192,33.98,0.4,62.4,37903,NULL,NULL,'mean','NGC 4177',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.00003,NULL,'13.32',1.1,'SA(rs)c pec:   HII',NULL,NULL,NULL,NULL,1,183.171917,-14.01456,0.097,NULL,43068218712,672940917,10514701,13.32),(90193,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90193,34.27,0.46,71.4,37903,NULL,NULL,'J','NGC 4177',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90194,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90194,34.29,0.47,72.1,37903,NULL,NULL,'H','NGC 4177',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90195,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90195,34.29,0.45,72.2,37903,NULL,NULL,'K','NGC 4177',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90196,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90196,37.58,0.46,328,37904,70,NULL,NULL,'2MASX J12124131+6053570',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000197,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,183.172083,60.89922,0,NULL,57339019900,895922185,13998784,17.6),(90197,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90197,38,0.46,398,37905,70,NULL,NULL,'2MASX J12124161+1413082',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000156,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,183.1735417,14.21892,0.131,NULL,58180266673,909066666,14204166,17.3),(90198,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90198,38.25,0.33,448,37906,70,NULL,NULL,'2MASX J12124212+0636165',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000134,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,183.1755417,6.60475,0,NULL,58026845643,906669463,14166710,18),(90199,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90199,37.96,0.33,391,37907,70,NULL,NULL,'2MASX J12124228+2924280',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00012,NULL,'16.9g',0.28,'E',NULL,NULL,NULL,NULL,1,183.176083,29.40786,0.023,NULL,58633156165,916143065,14314735,16.9),(90200,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90200,37.27,0.33,284,37908,70,NULL,NULL,'2MASX J12124228+0256238',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000097,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,183.176125,2.93992,0,NULL,58045081105,906954392,14171162,16.5),(90201,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90201,36.59,0.46,208,37909,70,NULL,NULL,'2MASX J12124236+5756534',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000172,NULL,'16.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,183.176333,57.94825,0,NULL,57329506484,895773538,13996461,16.3),(90202,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90202,38.02,0.33,401,37910,70,NULL,NULL,'SDSS J121242.35+350952.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,183.1765,35.16447,0,NULL,58551428965,914866077,14294782,17.8),(90203,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90203,36.54,0.46,203,37911,70,NULL,NULL,'2MASX J12124267+2320400',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00012,NULL,'18.39',0.15,NULL,NULL,NULL,NULL,NULL,1,183.177791667,23.34458,0.097,NULL,58600962686,915640041,14306875,18.39),(90204,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90204,37.88,0.46,377,37912,70,NULL,NULL,'SDSS J121242.76+512725.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000165,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,183.178167,51.457,0.033,NULL,57234868549,894294821,13973356,18.4),(90205,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90205,37.87,0.46,375,37913,70,NULL,NULL,'2MASX J12124287+4825482',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'18.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,183.178625,48.43008,0,NULL,57193318663,893645604,13963212,18),(90206,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90206,35.81,0.46,145,37914,70,NULL,NULL,'CGCG 292-082',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.000186,NULL,'15.2g',0.48,'E0',NULL,NULL,NULL,NULL,1,183.1792917,61.97086,0.013,NULL,57370054298,896407098,14006360,15.2),(90207,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90207,37.81,0.33,364,37915,70,NULL,NULL,'2MASX J12124312+5647154',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00016,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,183.179917,56.78767,0,NULL,57398825958,896856655,14013385,16.8),(90208,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90208,38.02,0.33,401,37916,70,NULL,NULL,'2MASX J12124367+3510235',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000144,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,183.181958333,35.17314,0,NULL,58551397263,914865582,14294774,18.3),(90209,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90209,38.1,0.23,417,37917,70,NULL,NULL,'SDSS J121243.67+342142.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,183.182,34.36172,0,NULL,58536974857,914640232,14291253,18.5),(90210,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90210,37.73,0.46,352,37918,70,NULL,NULL,'2MASX J12124396+6642198',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000095,NULL,'16.9g',0.25,'NLAGN',NULL,NULL,NULL,NULL,1,183.183416667,66.70539,0.037,NULL,57314581921,895540342,13992817,16.9),(90211,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90211,37.58,0.33,327,37919,70,NULL,NULL,'2MASX J12124519+5732464',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000159,NULL,'17.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,183.188291667,57.54644,0,NULL,57329347903,895771060,13996422,17.3),(90212,'IRAS','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90212,31.43,0.8,19.3,37920,75,NULL,'A82, H','NGC 4178',NULL,'1997ApJS..109..333W',1997,1,5.1,NULL,'G',0.000002,NULL,'11.90',1.8,'SB(rs)dm       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,183.1935417,10.86597,0,NULL,58214049267,909594519,14212414,11.9),(90213,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90213,30.59,0.3,13.1,37920,55,NULL,'B','NGC 4178',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90214,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90214,30.59,0.43,13.1,37920,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4178',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90215,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90215,30.6,0.43,13.2,37920,75,NULL,'3.6 micron, color corrected','NGC 4178',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90216,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90216,30.64,0.2,13.4,37920,74.4,NULL,NULL,'NGC 4178',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90217,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90217,30.73,0.35,14,37920,NULL,NULL,NULL,'NGC 4178',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90218,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90218,30.86,NULL,14.9,37920,NULL,NULL,NULL,'NGC 4178',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90219,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90219,30.88,0.42,15,37920,NULL,NULL,NULL,'NGC 4178',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90220,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90220,31.02,0.42,16,37920,65,NULL,NULL,'NGC 4178',NULL,'1980ApJ...238..458M',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90221,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90221,31.03,0.4,16.1,37920,NULL,NULL,'Malmquist cor.','NGC 4178',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90222,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90222,31.13,0.4,16.8,37920,75,NULL,'B','NGC 4178',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90223,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90223,31.38,0.47,18.9,37920,75,NULL,'A82, H, raw','NGC 4178',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90224,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90224,31.39,0.47,19,37920,75,NULL,'A82, H, inv','NGC 4178',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90225,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90225,31.59,0.47,20.8,37920,75,NULL,'A82, H, cor','NGC 4178',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90226,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90226,38.1,0.23,417,37921,70,NULL,NULL,'2MASX J12124647+3416105',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000168,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,183.19375,34.2695,0,NULL,58536968955,914640139,14291252,16.9),(90227,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90227,36.2,0.58,174,37922,70,NULL,NULL,'2MASX J12124671-4610164',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,183.194667,-46.17117,0.413,NULL,46709439787,729834996,11403671,15.4),(90228,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90228,36.99,0.13,250,37923,70,NULL,NULL,'2MASXi J1212475+594708',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000178,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,183.198333,59.78572,0,NULL,57344107585,896001681,14000026,17.3),(90229,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90229,35.74,0.72,141,37924,70,NULL,NULL,'2MASX J12124773-3134301',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.5b',NULL,'E',NULL,NULL,NULL,NULL,1,183.198917,-31.57511,0.313,NULL,43370197788,677659340,10588427,16.5),(90230,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90230,37.58,0.33,327,37925,70,NULL,NULL,'2MASX J12124791+5729204',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000183,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,183.199583,57.489,0,NULL,57397269339,896832333,14013005,16.4),(90231,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90231,35.71,0.46,139,37926,70,NULL,NULL,'2MASX J12124842+2730030',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000087,NULL,'15.8g',0.31,'S0','Field galaxy',NULL,NULL,NULL,1,183.2017917,27.50089,0.035,NULL,58643206204,916300096,14317189,15.8),(90232,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90232,31.24,0.36,17.7,37927,NULL,NULL,NULL,'IC 3044',NULL,'2009AJ....138..323T',2009,1,1.9,NULL,'G',0.000023,NULL,'14.24',0.8,'SB(s)cd pec:   HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,183.202166667,13.97647,0.08,NULL,58168733106,908886454,14201350,14.24),(90233,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90233,35.76,0.46,142,37928,70,NULL,NULL,'NGC 4181',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.000097,NULL,'14.7g',0.62,'E',NULL,NULL,NULL,NULL,1,183.204125,52.90331,0.006,NULL,57215965976,893999468,13968741,14.7),(90234,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90234,37.64,0.46,337,37929,70,NULL,NULL,'2MASX J12124939+1315113',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000154,NULL,'16.6g',0.37,NULL,NULL,NULL,NULL,NULL,1,183.205875,13.25306,0.026,NULL,58139241671,908425651,14194150,16.6),(90235,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90235,36.16,0.27,170,37930,70,NULL,NULL,'CGCG 315-025',NULL,'2015arXiv151105856S',2015,1,1.03,NULL,'G',0.000107,NULL,'14.5g',0.71,'E0',NULL,NULL,NULL,NULL,1,183.206875,65.81508,0.017,NULL,57312338666,895505291,13992270,14.5),(90236,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90236,35.49,0.33,125,37931,70,NULL,NULL,'CGCG 243-051',NULL,'2015arXiv151105856S',2015,1,0.91,NULL,'G',0.000163,NULL,'14.3g',0.85,'S?','Dwarf, within FOV of cluster',NULL,NULL,NULL,1,183.2080417,46.77308,0,NULL,57178715142,893417424,13959647,14.3),(90237,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90237,38.85,0.46,590,37932,70,NULL,NULL,'SDSS J121250.53-013024.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000125,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,183.210583,-1.50683,0.045,NULL,42960837667,671263088,10488485,18.5),(90238,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90238,35.35,0.46,118,37933,70,NULL,NULL,'2MASX J12125066-0050135',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000062,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,183.210917,-0.837,0.033,NULL,42959490307,671242036,10488156,16.3),(90239,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:05','1','PS1 SN PS11sk','N',90239,40.57,0.1,1030,37934,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11sk HOST',0.2707,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90240,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90240,36.94,0.27,244,37935,70,NULL,NULL,'2MASX J12125151+1314493',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000166,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,183.214625,13.24714,0.026,NULL,58139241518,908425648,14194150,16.3),(90241,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90241,37.33,0.46,292,37936,70,NULL,NULL,'2MASX J12125197+1442463',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,183.216833,14.71286,0.127,NULL,58181150694,909080479,14204382,17.3),(90242,'Faber-Jackson','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90242,30.88,0.37,15,37937,95,NULL,'Weighted Mean','NGC 4179',NULL,'1984ApJS...56...91D',1984,1,3.07,NULL,'G',0.000017,NULL,'12.1g',0.87,'Sb(f)','in a radial-velocity based grouping',NULL,NULL,NULL,1,183.217125,1.29969,0.038,NULL,57989626970,906087921,14157623,12.1),(90243,'Faber-Jackson','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90243,31.07,0.63,16.4,37937,95,NULL,'Michard 1979b, c','NGC 4179',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90244,'Faber-Jackson','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90244,31.27,0.46,17.9,37937,95,NULL,'Michard 1979a','NGC 4179',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90245,'Faber-Jackson','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90245,31.8,0.81,22.9,37937,55,NULL,'Visvanathan & Sandage 1979','NGC 4179',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90246,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90246,31.05,0.25,16.2,37937,74.4,NULL,NULL,'NGC 4179',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90247,'Tully est','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90247,31.95,0.8,24.5,37937,75,NULL,'B','NGC 4179',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90248,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90248,30.57,0.45,13,37937,NULL,NULL,'K','NGC 4179',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90249,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90249,31.64,0.4,21.3,37937,NULL,NULL,'mean','NGC 4179',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90250,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90250,35.87,0.46,149,37938,70,NULL,NULL,'2MASX J12125266+1438413',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'16.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,183.219541667,14.64492,0.127,NULL,58181117524,909079961,14204374,16.9),(90251,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90251,38.14,0.46,425,37939,70,NULL,NULL,'2MASX J12125301+5732184',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000182,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,183.221,57.5385,0,NULL,57329344834,895771013,13996422,17.4),(90252,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90252,36.82,0.46,232,37940,70,NULL,NULL,'2MASX J12125302+1311353',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,183.2210417,13.19322,0.026,NULL,58138736849,908417763,14194027,17.1),(90253,'Tully est','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90253,31.9,0.8,24,37941,75,NULL,NULL,'UGCA 274',NULL,'1988NBGC.C....0000T',1988,1,1.7,'Position in 1998AJ....116....1D is for a superposed star.','G',0.000003,NULL,'14.88',0.9,'Sm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,183.2300417,-20.42114,0.113,NULL,43902899805,685982809,10718481,14.88),(90254,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90254,37.49,0.46,315,37942,70,NULL,NULL,'2MASX J12125526+1653493',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.93',0.21,NULL,NULL,NULL,NULL,NULL,1,183.230083,16.89714,0.102,NULL,58171913194,908936143,14202127,17.93),(90255,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90255,38.11,0.46,418,37943,70,NULL,NULL,'2MASX J12125545+2546530',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,183.230916667,25.7815,0.054,NULL,58596537695,915570901,14305795,17.4),(90256,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90256,30.88,0.36,15,37944,NULL,NULL,NULL,'UGC 07218',NULL,'2009AJ....138..323T',2009,1,1.3,'There is a star superposed.','G',0.000023,NULL,'14.75',0.7,'Im:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,183.2355,52.26536,0.015,NULL,57216169352,894002646,13968791,14.75),(90257,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90257,31.15,0.4,17,37944,75,NULL,'B','UGC 07218',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90258,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90258,38.35,0.23,469,37945,70,NULL,NULL,'2MASX J12125680+3033586',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000172,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,183.236583,30.56622,0.05,NULL,58633837245,916153706,14314901,17.8),(90259,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90259,35.4,0.21,120,37946,70,NULL,NULL,'2MASX J12125714+2125375',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.38',0.24,NULL,NULL,NULL,NULL,NULL,1,183.238083,21.42694,0.047,NULL,58868382457,919818475,14372163,16.38),(90260,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90260,35.3,0.49,115,37947,75,NULL,'IR','FGC 1385',NULL,'2011yCatp016004901K',2011,1,0.99,NULL,'G',NULL,NULL,'16.4',0.12,'Sc',NULL,NULL,NULL,NULL,1,183.241,50.85225,0.024,NULL,57235041822,894297528,13973398,16.4),(90261,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90261,35.61,NULL,132,37947,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1385',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90262,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90262,35.62,NULL,133,37947,NULL,NULL,'Dipole + Quadrupole','FGC 1385',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90263,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90263,35.64,NULL,134,37947,NULL,NULL,'Dipole','FGC 1385',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90264,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90264,35.65,NULL,135,37947,NULL,NULL,NULL,'FGC 1385',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90265,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90265,38.35,0.23,469,37948,70,NULL,NULL,'2MASX J12125834+3035376',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,183.243167,30.59381,0.05,NULL,58633843359,916153802,14314903,17.4),(90266,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90266,38.1,0.23,417,37949,70,NULL,NULL,'2MASX J12125935+3428096',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000155,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,183.2472917,34.46925,0,NULL,58536778152,914637158,14291205,18.5),(90267,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90267,34.57,NULL,82,37950,NULL,NULL,NULL,'FGC 1384',NULL,'2000BSAO...50....5K',2000,1,0.95,NULL,'G',0.000027,NULL,'16.5g',0.2,'Sdm',NULL,NULL,NULL,NULL,1,183.249375,7.299,0,NULL,58025409295,906647020,14166359,16.5),(90268,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90268,38.49,0.46,499,37951,70,NULL,NULL,'2MASX J12125992+3358096',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,183.2497083,33.96933,0,NULL,58756118093,918064345,14344755,17.7),(90269,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90269,37.3,0.46,288,37952,70,NULL,NULL,'2MASX J12130013+4050283',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000179,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,183.250375,40.84128,0,NULL,58532538965,914570921,14290170,17.4),(90270,'IRAS','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90270,35.08,0.8,104,37953,75,NULL,'HMCL, I','UGC 07217',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000009,NULL,'15.50',0.2,'Sbc','Field galaxy',NULL,NULL,NULL,1,183.250833,25.28167,0.055,NULL,58598811639,915606431,14306350,15.5),(90271,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90271,34.62,0.49,83.8,37953,75,NULL,'IR','UGC 07217',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90272,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90272,34.66,0.4,85.7,37953,75,NULL,'HMCL, I, raw','UGC 07217',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90273,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90273,34.79,0.4,90.9,37953,75,NULL,'HMCL, I, inv','UGC 07217',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90274,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90274,34.93,0.4,96.8,37953,75,NULL,'HMCL, I, cor','UGC 07217',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90275,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90275,34.95,0.2,97.7,37953,74.4,NULL,NULL,'UGC 07217',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90276,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90276,38,0.46,399,37954,70,NULL,NULL,'SDSS J121300.17+323916.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000145,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,183.25075,32.65447,0,NULL,58755363797,918052559,14344571,18.4),(90277,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90277,37.74,0.46,354,37955,70,NULL,NULL,'2MASX J12130065+0942126',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000182,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,183.2527083,9.70347,0,NULL,58216128923,909627014,14212922,17.6),(90278,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90278,38.13,0.46,422,37956,70,NULL,NULL,'2MASX J12130099+2645420',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000173,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,183.254041667,26.76175,0.044,NULL,58642029702,916281714,14316901,17.5),(90279,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90279,37.6,0.46,330,37957,70,NULL,NULL,'2MASX J12130121+2136105',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,183.254958333,21.60292,0.042,NULL,58868406204,919818846,14372169,17.2),(90280,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90280,38.31,0.46,460,37958,70,NULL,NULL,'2MASX J12130120+5719153',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000174,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,183.255,57.32097,0,NULL,57397243610,896831931,14012998,17.5),(90281,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90281,32.65,0.4,34,37959,NULL,NULL,'mean','NGC 4180',NULL,'2007A&A...465...71T',2007,1,1.6,'Identification as NGC 4182 is not certain.','G',0.000027,NULL,'13.49',0.6,'Sab:;Sy        LINER','X-ray-bright group member',NULL,NULL,NULL,1,183.2627083,7.03894,0,NULL,58027298196,906676534,14166820,13.49),(90282,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90282,32.72,NULL,35,37959,NULL,NULL,NULL,'NGC 4180',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90283,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90283,32.87,0.45,37.5,37959,NULL,NULL,'K','NGC 4180',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90284,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90284,32.91,0.47,38.2,37959,NULL,NULL,'H','NGC 4180',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90285,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90285,32.94,0.46,38.8,37959,NULL,NULL,'J','NGC 4180',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90286,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90286,33.57,0.3,51.9,37959,55,NULL,'B','NGC 4180',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90287,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90287,37.96,0.33,391,37960,70,NULL,NULL,'2MASX J12130371+2924000',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000154,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,183.265375,29.39981,0.023,NULL,58633100837,916142200,14314721,18.5),(90288,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90288,36.99,0.13,250,37961,70,NULL,NULL,'2MASX J12130367+5944103',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,183.265375,59.73619,0,NULL,57344116428,896001819,14000028,16.2),(90289,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90289,38.02,0.46,402,37962,70,NULL,NULL,'2MASX J12130375+2930222',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000103,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,183.2655417,29.50622,0.023,NULL,58632625028,916134766,14314605,17.5),(90290,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90290,37.95,0.21,389,37963,70,NULL,NULL,'2MASX J12130447+5912303',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,183.26875,59.20831,0,NULL,57343700948,895995327,13999926,17.8),(90291,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90291,31.15,NULL,17,37964,NULL,NULL,NULL,'VCC 0074',NULL,'2014A&A...562A..49M',2014,1,0.79,NULL,'G',0.000127,NULL,'16.6g',0.24,'BCD?','Group member',NULL,NULL,NULL,1,183.269625,15.89292,0.095,NULL,58179654922,909057108,14204017,16.6),(90292,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90292,37.94,0.33,387,37965,70,NULL,NULL,'2MASX J12130509+0541232',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000172,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,183.27125,5.68967,0,NULL,58026211695,906659557,14166555,16.4),(90293,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90293,36.7,0.46,219,37966,70,NULL,NULL,'2MASX J12130562+3038346',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00018,NULL,'16.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,183.2735417,30.64297,0.05,NULL,58633842041,916153781,14314902,16.4),(90294,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90294,35.04,0.46,102,37967,70,NULL,NULL,'VCC 0075',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000093,NULL,'15.2g',0.53,'S0?','Group member',NULL,NULL,NULL,1,183.279208333,16.08556,0.095,NULL,58180137365,909064646,14204135,15.2),(90295,'GRB','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90295,46.08,1.57,4480,37968,100,NULL,NULL,'GRB 030429',2.658,'2009EPJC...63..139W',2009,1,NULL,NULL,'G',0.004,NULL,'26.3R',NULL,'HETE',NULL,NULL,NULL,NULL,1,183.28125,-20.91375,0.165,NULL,43903319613,685989368,10718583,26.3),(90296,'GRB','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90296,46.16,1.51,4660,37968,100,NULL,NULL,'GRB 030429',2.658,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90297,'GRB','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90297,46.28,0.59,4930,37968,72,NULL,NULL,'GRB 030429',2.658,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90298,'GRB','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90298,46.46,0.56,5350,37968,70,NULL,NULL,'GRB 030429',2.658,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90299,'GRB','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90299,46.56,0.67,5600,37968,NULL,NULL,NULL,'GRB 030429',2.658,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90300,'GRB','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90300,46.61,0.53,5740,37968,69.7,NULL,'Calibrated','GRB 030429',2.658,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90301,'GRB','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90301,46.8,0.58,6260,37968,69.7,NULL,'Fiducial','GRB 030429',2.658,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90302,'GRB','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90302,42.42,NULL,3050,37969,70,NULL,'Pseudo z = 1.44','GRB 030429',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'G',0.004,NULL,'26.3R',NULL,'HETE',NULL,NULL,NULL,NULL,1,183.28125,-20.91375,0.165,NULL,43903319613,685989368,10718583,26.3),(90303,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90303,35.08,0.2,104,37970,74.4,NULL,NULL,'IC 3046',NULL,'2013AJ....146...86T',2013,1,1.74,NULL,'G',0.000023,NULL,'14.9g',0.33,'S?','Group member',NULL,NULL,NULL,1,183.2827917,12.91822,0,NULL,58138795780,908418684,14194041,14.9),(90304,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90304,35.24,0.49,112,37971,75,NULL,'IR','IC 3046',NULL,'2011yCatp016004901K',2011,1,1.74,NULL,'G',0.000023,NULL,'14.9g',0.33,'S?','Group member',NULL,NULL,NULL,1,183.2827917,12.91822,0,NULL,58138795780,908418684,14194041,14.9),(90305,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90305,38.45,0.27,490,37972,70,NULL,NULL,'2MASX J12130864+5516565',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00014,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,183.286,55.28244,0,NULL,57213240002,893956875,13968076,17.6),(90306,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90306,37.71,0.46,348,37973,70,NULL,NULL,'2MASX J12130979+0228102',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,183.290833,2.46967,0.018,NULL,58043111895,906923623,14170681,17.4),(90307,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90307,37.06,0.27,259,37974,70,NULL,NULL,'2MASX J12131118+5632515',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000195,NULL,'16.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,183.29675,56.54767,0,NULL,57398691731,896854558,14013352,16.4),(90308,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90308,37.64,0.46,337,37975,70,NULL,NULL,'SDSS J121311.24+491253.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000144,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,183.296833,49.21483,0,NULL,57189788207,893590440,13962350,18.3),(90309,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90309,37.6,0.46,332,37976,70,NULL,NULL,'2MASX J12131219-0204542',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000184,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,183.3007083,-2.08178,0.041,NULL,42961115794,671267434,10488553,17.1),(90310,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90310,37.79,0.46,362,37977,70,NULL,NULL,'SDSS J121312.94+143006.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000127,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,183.303917,14.50189,0.127,NULL,58180440046,909069375,14204208,18.7),(90311,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90311,35.4,0.21,120,37978,70,NULL,NULL,'2MASX J12131398+2147255',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.17',0.25,NULL,NULL,NULL,NULL,NULL,1,183.3082083,21.79042,0.048,NULL,58868521160,919820643,14372197,17.17),(90312,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90312,37.53,0.46,320,37979,70,NULL,NULL,'SDSS J121314.11+582755.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000142,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,183.308791667,58.46556,0,NULL,57329318789,895770606,13996415,18.2),(90313,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90313,37.94,0.46,387,37980,70,NULL,NULL,'SDSS J121314.19+362859.9',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,183.309167,36.48333,0,NULL,58549312816,914833012,14294265,17.8),(90314,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90314,37.1,0.46,263,37981,70,NULL,NULL,'2MASX J12131491+2003005',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.07',0.16,NULL,NULL,NULL,NULL,NULL,1,183.312167,20.05008,0.053,NULL,58869399910,919834373,14372412,18.07),(90315,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90315,37.06,0.27,259,37982,70,NULL,NULL,'2MASX J12131504+5635086',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,183.3127917,56.58569,0,NULL,57398817864,896856529,14013383,17.2),(90316,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90316,37.78,0.46,359,37983,70,NULL,NULL,'2MASX J12131534+1728583',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,183.313833,17.48303,0.103,NULL,58127646253,908244472,14191319,17.7),(90317,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90317,38.71,0.33,553,37984,70,NULL,NULL,'SDSS J121315.37+642731.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,183.314083333,64.45867,0.021,NULL,57325926058,895717594,13995587,18.1),(90318,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90318,38.38,0.46,475,37985,70,NULL,NULL,'2MASX J12131561+3450167',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,183.315166667,34.83786,0,NULL,58550599555,914853118,14294579,17.8),(90319,'IRAS','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90319,31.19,0.8,17.3,37986,75,NULL,'W91CL, r','NGC 4183',NULL,'1997ApJS..109..333W',1997,1,6.39,NULL,'G',0.000003,NULL,'12.9g',0.69,'SA(s)cd? sp    HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,183.320333,43.69858,0,NULL,59057744767,922777261,14418394,12.9),(90320,'IRAS','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90320,31.22,0.8,17.6,37986,75,NULL,'A82, H','NGC 4183',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90321,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90321,30.58,NULL,13.1,37986,NULL,NULL,'B','NGC 4183',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90322,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90322,30.63,0.4,13.4,37986,75,NULL,NULL,'NGC 4183',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90323,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90323,30.98,0.12,15.7,37986,NULL,NULL,NULL,'NGC 4183',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90324,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90324,31.01,0.35,15.9,37986,NULL,NULL,NULL,'NGC 4183',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90325,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90325,31.05,0.38,16.2,37986,75,NULL,'W91CL, r, inv','NGC 4183',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90326,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90326,31.05,0.38,16.3,37986,75,NULL,'W91CL, r, raw','NGC 4183',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90327,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90327,31.06,NULL,16.3,37986,NULL,NULL,'I','NGC 4183',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90328,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90328,31.08,0.2,16.4,37986,74.4,NULL,NULL,'NGC 4183',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90329,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90329,31.09,NULL,16.5,37986,NULL,NULL,'Dipole','NGC 4183',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90330,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90330,31.09,NULL,16.5,37986,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 4183',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90331,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90331,31.1,NULL,16.6,37986,NULL,NULL,'Dipole + Quadrupole','NGC 4183',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90332,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90332,31.15,0.4,17,37986,75,NULL,'B','NGC 4183',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90333,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90333,31.17,0.47,17.1,37986,75,NULL,'A82, H, inv','NGC 4183',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90334,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90334,31.18,NULL,17.2,37986,NULL,NULL,NULL,'NGC 4183',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90335,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90335,31.18,0.43,17.3,37986,75,NULL,'3.6 micron, color corrected','NGC 4183',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90336,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90336,31.22,0.47,17.5,37986,75,NULL,'A82, H, raw','NGC 4183',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90337,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90337,31.23,0.38,17.6,37986,75,NULL,'W91CL, r, cor','NGC 4183',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90338,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90338,31.24,0.43,17.7,37986,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4183',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90339,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90339,31.41,0.4,19.1,37986,NULL,NULL,'mean','NGC 4183',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90340,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90340,31.42,0.47,19.2,37986,75,NULL,'A82, H, cor','NGC 4183',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90341,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90341,31.44,0.49,19.4,37986,75,NULL,'IR','NGC 4183',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90342,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90342,31.65,0.46,21.4,37986,NULL,NULL,'J','NGC 4183',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90343,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90343,31.83,0.47,23.2,37986,NULL,NULL,'H','NGC 4183',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90344,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90344,31.96,0.45,24.6,37986,NULL,NULL,'K','NGC 4183',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90345,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90345,38.38,0.21,475,37987,70,NULL,NULL,'2MASX J12131747+3028337',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'18.46',0.16,NULL,NULL,NULL,NULL,NULL,1,183.322833,30.47606,0.046,NULL,58633982586,916155977,14314937,18.46),(90346,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90346,37.35,0.33,296,37988,70,NULL,NULL,'2MASX J12131829+4426449',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00018,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,183.326,44.44581,0,NULL,59057179611,922768431,14418256,16.3),(90347,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90347,35.4,0.21,120,37989,70,NULL,NULL,'UGC 07224',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.00013,NULL,'14.38',0.8,'E',NULL,NULL,NULL,NULL,1,183.326083333,21.63431,0.047,NULL,58868412140,919818939,14372170,14.38),(90348,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90348,38.31,0.46,460,37990,70,NULL,NULL,'2MASXi J1213185+382709',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000166,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,183.327333,38.45275,0,NULL,58579060290,915297817,14301528,18.1),(90349,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90349,37.48,0.46,314,37991,70,NULL,NULL,'2MASX J12131877+5104202',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000153,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,183.328291667,51.07217,0.066,NULL,57235463696,894304120,13973501,16.8),(90350,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90350,38.1,0.23,417,37992,70,NULL,NULL,'2MASX J12131930+3405197',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,183.330333333,34.08869,0,NULL,58756149332,918064833,14344763,17.8),(90351,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90351,37.63,0.46,336,37993,70,NULL,NULL,'SDSS J121319.87+372520.3',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.6g',0.31,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,183.332833,37.42233,0,NULL,58546291072,914785798,14293528,16.6),(90352,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90352,37.76,0.46,357,37994,70,NULL,NULL,'2MASX J12132063+3436066',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,183.335917,34.60175,0,NULL,58550600839,914853138,14294580,18),(90353,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90353,37.94,0.33,387,37995,70,NULL,NULL,'2MASX J12132130+0557402',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000185,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,183.338875,5.96119,0,NULL,58027060470,906672819,14166762,17.8),(90354,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90354,34.86,0.68,93.8,37996,NULL,NULL,'Malmquist cor.','ESO 321- G 013',NULL,'2009ApJS..182..474S',2009,1,1.15,NULL,'G',0.000033,NULL,'16.77',0.13,'Sd',NULL,NULL,NULL,NULL,1,183.339583,-42.24006,0.685,NULL,43233809498,675528273,10555129,16.77),(90355,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90355,34.9,0.67,95.4,37996,NULL,NULL,NULL,'ESO 321- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90356,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90356,34.94,0.2,97.3,37996,74.4,NULL,NULL,'ESO 321- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90357,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90357,34.96,NULL,98.1,37996,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 321- G 013',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90358,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90358,34.97,NULL,98.8,37996,NULL,NULL,'Dipole + Quadrupole','ESO 321- G 013',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90359,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90359,34.99,0.49,99.5,37996,75,NULL,'IR','ESO 321- G 013',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90360,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90360,34.99,NULL,99.5,37996,NULL,NULL,'Dipole','ESO 321- G 013',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90361,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90361,35.02,NULL,101,37996,NULL,NULL,NULL,'ESO 321- G 013',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90362,'BCG','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90362,38.77,0.35,518,37997,60,NULL,NULL,'ABELL 1496',0.0961,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,183.3407083,59.27208,0,NULL,57343647895,895994498,13999914,NULL),(90363,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90363,33.89,0.4,60,37998,NULL,NULL,'mean','NGC 4185',NULL,'2007A&A...465...71T',2007,1,2.6,NULL,'G',0.000017,NULL,'12.90',1.9,'Sbc','in a radial-velocity based grouping',NULL,NULL,NULL,1,183.3425,28.51097,NULL,NULL,58642674533,916291789,14317059,12.9),(90364,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90364,34.09,0.46,65.7,37998,NULL,NULL,'J','NGC 4185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90365,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90365,34.09,0.45,65.7,37998,NULL,NULL,'K','NGC 4185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90366,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90366,34.1,0.47,66,37998,NULL,NULL,'H','NGC 4185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90367,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90367,38.45,0.33,489,37999,70,NULL,NULL,'2MASX J12132273+6402557',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000178,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,183.3445,64.04894,0.021,NULL,57318523247,895601925,13993780,18.3),(90368,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90368,31.19,NULL,17.3,38000,NULL,NULL,NULL,'KUG 1210+301B',NULL,'2013AJ....145..101K',2013,1,1,NULL,'G',NULL,NULL,'15.7',0.4,'S..',NULL,NULL,NULL,NULL,1,183.3482083,29.92189,0.04,NULL,58632443492,916131929,14314561,15.7),(90369,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90369,35.4,0.21,120,38001,70,NULL,NULL,'2MASX J12132477+2140081',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.45',0.2,NULL,NULL,NULL,NULL,NULL,1,183.3532083,21.66894,0.048,NULL,58868587695,919821682,14372213,17.45),(90370,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90370,38.71,0.33,553,38002,70,NULL,NULL,'2MASX J12132480+6434157',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000159,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,183.353625,64.57103,0.017,NULL,57325973314,895718333,13995598,17.7),(90371,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90371,37.27,0.46,285,38003,70,NULL,NULL,'2MASX J12132492+2228291',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,183.35375,22.47486,0.059,NULL,58868349157,919817955,14372155,17),(90372,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90372,37.04,0.46,256,38004,70,NULL,NULL,'2MASX J12132561+0158202',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00007,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,183.356667,1.97233,0.011,NULL,57988206057,906065719,14157276,17.5),(90373,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90373,38.45,0.33,489,38005,70,NULL,NULL,'2MASX J12132612+6359076',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000178,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,183.359,63.98556,0.021,NULL,57318460654,895600947,13993764,16.9),(90374,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90374,32.68,1.01,34.4,38006,NULL,NULL,NULL,'NGC 4192A',NULL,'2009ApJS..182..474S',2009,1,0.81,'This is probably misidentified as NGC 4186 in UGC according to RC2 notes.','G',0.000013,NULL,'15.9g',0.71,'SAdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,183.359541667,14.77203,0.145,NULL,58181261476,909082210,14204409,15.9),(90375,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90375,32.71,0.99,34.8,38006,NULL,NULL,'Malmquist cor.','NGC 4192A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90376,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90376,32.72,0.2,35,38006,74.4,NULL,NULL,'NGC 4192A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90377,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90377,37.81,0.33,364,38007,70,NULL,NULL,'VII Zw 442',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000189,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,183.3642083,56.76183,0,NULL,57398831934,896856748,14013386,16.9),(90378,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90378,36.69,0.46,218,38008,70,NULL,NULL,'2MASXi J1213278+280223',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000158,NULL,'17.6g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,183.366167,28.03989,0.029,NULL,58642798259,916293722,14317089,17.6),(90379,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90379,38.7,0.46,548,38009,70,NULL,NULL,'2MASX J12132916+0938331',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,183.371625,9.64244,0,NULL,58216143485,909627241,14212925,17.5),(90380,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90380,35.09,0.46,104,38010,70,NULL,NULL,'NGC 4187',NULL,'2015arXiv151105856S',2015,1,1.43,NULL,'G',0.000093,NULL,'13.8g',0.93,'E',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,183.372,50.7415,0.024,NULL,57235024600,894297259,13973394,13.8),(90381,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90381,35.49,0.45,125,38010,NULL,NULL,'K','NGC 4187',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90382,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90382,35.55,0.4,129,38010,NULL,NULL,'mean','NGC 4187',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90383,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90383,37.26,0.27,284,38011,70,NULL,NULL,'2MASX J12132937+6829184',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000075,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,183.3727083,68.48847,0.049,NULL,57848388763,903881074,14123141,17.6),(90384,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90384,38.16,0.46,428,38012,70,NULL,NULL,'2MASX J12132998+4945532',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,183.374958333,49.76469,0.007,NULL,57188227157,893566049,13961969,17.9),(90385,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90385,37.54,0.46,322,38013,70,NULL,NULL,'2MASX J12133036+1646354',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,183.376583,16.77653,0.098,NULL,58171873776,908935527,14202117,18),(90386,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90386,38.37,0.46,473,38014,70,NULL,NULL,'2MASX J12133171+1621445',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,183.3822917,16.36247,0.113,NULL,58179357607,909052462,14203944,17.6),(90387,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90387,36.86,0.46,236,38015,70,NULL,NULL,'2MASX J12133259+1234295',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000155,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,183.385875,12.57475,0.026,NULL,58140642292,908447535,14194492,17),(90388,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90388,37.49,0.46,315,38016,70,NULL,NULL,'2MASX J12133281-0119284',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000154,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,183.386833,-1.32469,0.045,NULL,42961329163,671270768,10488605,17.1),(90389,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90389,37.28,0.46,285,38017,70,NULL,NULL,'2MASX J12133302+2851452',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00009,NULL,'16.4g',0.28,'E',NULL,NULL,NULL,NULL,1,183.387583333,28.86269,0,NULL,58632208120,916128251,14314503,16.4),(90390,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90390,38.29,0.46,454,38018,70,NULL,NULL,'SDSS J121333.11+251248.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,183.388,25.2135,0.061,NULL,58591403662,915490682,14304541,18.3),(90391,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90391,37.35,0.46,295,38019,70,NULL,NULL,'2MASX J12133362+6148437',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,183.389833333,61.81211,0,NULL,57373415600,896459618,14007181,17.7),(90392,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90392,37.23,0.33,280,38020,70,NULL,NULL,'2MASX J12133476+1526545',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,183.394833,15.44839,0.084,NULL,58183081157,909110643,14204853,17.2),(90393,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:05','1','SN 2007sw',NULL,90393,35.1,0.2,102,38021,73.8,NULL,'SALT 2 (SNANA)','UGC 07228',0.0262,'2014ApJ...795...44R',2014,1,1.3,NULL,'G',0.00006,NULL,'15.1',0.3,NULL,NULL,NULL,NULL,NULL,1,183.403375,46.49397,0,NULL,59058818159,922794033,14418656,15.1),(90394,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90394,38.94,0.46,614,38022,70,NULL,NULL,'2MASX J12133889+2742411',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,183.412,27.71144,0.038,NULL,58643259397,916300928,14317202,18.3),(90395,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90395,37.98,0.46,394,38023,70,NULL,NULL,'2MASXi J1213398+255553',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,183.416167,25.93139,0.039,NULL,58649009651,916390775,14318605,17.5),(90396,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90396,37.26,0.27,284,38024,70,NULL,NULL,'2MASX J12134090+6819250',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000074,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,183.42075,68.32367,0.049,NULL,57848620257,903884691,14123198,16.9),(90397,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90397,37.14,0.46,268,38025,70,NULL,NULL,'2MASX J12134131+0011469',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000083,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,183.4222917,0.1965,0.033,NULL,57989328986,906083265,14157551,16.6),(90398,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90398,37.35,0.33,296,38026,70,NULL,NULL,'2MASX J12134173+4420373',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000169,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,183.423833,44.34381,0,NULL,59057184676,922768510,14418257,17.7),(90399,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90399,36.57,0.46,206,38027,70,NULL,NULL,'2MASX J12134331+4757003',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00019,NULL,'15.7g',0.48,'S0^-',NULL,NULL,NULL,NULL,1,183.430417,47.95,0,NULL,57192219024,893628422,13962944,15.7),(90400,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90400,29.15,0.49,6.75,38028,75,NULL,'IR','VV 104a',NULL,'2011yCatp016004901K',2011,1,NULL,NULL,'PofG',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,183.4339583,36.63125,0,NULL,58549159984,914830624,14294228,NULL),(90401,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90401,36.8,0.46,229,38029,70,NULL,NULL,'2MASX J12134406-0030014',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000071,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,183.43375,-0.50042,0.029,NULL,42959925880,671248841,10488263,17),(90402,'Brightest Stars','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90402,27.7,NULL,3.47,38030,NULL,NULL,NULL,'NGC 4190',NULL,'1998A&AS..128..325T',1998,1,1.52,NULL,'G',0.000003,NULL,'13.4g',1.17,'Im pec','in a radial-velocity based grouping',NULL,NULL,NULL,1,183.436541667,36.63403,0,NULL,58549159965,914830624,14294228,13.4),(90403,'CMD','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90403,27.35,0.05,2.95,38030,NULL,NULL,NULL,'NGC 4190',NULL,'2015MNRAS.450.3886M',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90404,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90404,27.26,0.1,2.83,38030,74.4,NULL,NULL,'NGC 4190',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90405,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90405,27.24,0.4,2.8,38030,75,NULL,'B','NGC 4190',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90406,'BCG','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90406,38.77,0.35,518,38031,60,NULL,'ABELL 1496, BCG','2MASX J12134467+5919215',0.0961,'1980ApJ...241..486H',1980,1,0.34,NULL,'G',0.000334,NULL,'16.99',0.22,NULL,NULL,NULL,NULL,NULL,1,183.436375,59.32267,0,NULL,57343649129,895994517,13999914,16.99),(90407,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90407,38.12,0.33,421,38032,70,NULL,NULL,'2MASX J12134536+2941031',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.4g',0.22,'E',NULL,NULL,NULL,NULL,1,183.439167,29.68428,0.023,NULL,58632471086,916132360,14314568,17.4),(90408,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90408,38.96,0.46,620,38033,70,NULL,NULL,'SDSS J121345.59+221259.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.6g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,183.44,22.21653,0.049,NULL,58868196011,919815562,14372118,18.6),(90409,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90409,38.45,0.27,490,38034,70,NULL,NULL,'2MASX J12134599+5533355',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000144,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,183.441375,55.56006,0,NULL,57212843514,893950679,13967979,18.2),(90410,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90410,37.35,0.46,295,38035,70,NULL,NULL,'2MASX J12134718+2956102',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00012,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,183.446541667,29.93622,0.024,NULL,58632451570,916132055,14314563,16.5),(90411,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90411,31.13,0.4,16.8,38036,75,NULL,'B','NGC 4189',NULL,'1988NBGC.C....0000T',1988,1,2.4,NULL,'G',0.000007,NULL,'12.5B',1.7,'SAB(rs)cd?     HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,183.446958333,13.42481,0.025,NULL,58139180783,908424699,14194135,12.5),(90412,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90412,31.63,0.43,21.2,38036,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4189',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90413,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90413,31.73,0.43,22.2,38036,75,NULL,'3.6 micron, color corrected','NGC 4189',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90414,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90414,31.88,0.36,23.8,38036,NULL,NULL,NULL,'NGC 4189',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90415,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90415,32.01,0.2,25.2,38036,74.4,NULL,NULL,'NGC 4189',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90416,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90416,32.25,0.67,28.2,38036,NULL,NULL,'Malmquist cor.','NGC 4189',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90417,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90417,32.5,0.59,31.6,38036,NULL,NULL,NULL,'NGC 4189',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90418,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90418,32.53,0.46,32.1,38036,NULL,NULL,'J','NGC 4189',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90419,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90419,32.53,0.45,32.1,38036,NULL,NULL,'K','NGC 4189',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90420,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90420,32.57,0.47,32.6,38036,NULL,NULL,'H','NGC 4189',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90421,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90421,32.81,0.4,36.5,38036,NULL,NULL,'mean','NGC 4189',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90422,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90422,33.01,0.3,40,38036,55,NULL,'B','NGC 4189',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90423,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90423,36.99,0.13,250,38037,70,NULL,NULL,'2MASX J12134734+5950225',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,183.4474583,59.83958,0,NULL,57344253864,896003966,14000061,16.8),(90424,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90424,37.21,0.46,277,38038,70,NULL,NULL,'2MASX J12134744+0652420',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,183.4475417,6.87842,0,NULL,58027321743,906676902,14166826,17.1),(90425,'IRAS','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90425,31.44,0.8,19.4,38039,75,NULL,'A82, H','MESSIER 098',NULL,'1997ApJS..109..333W',1997,1,9.8,'UZC has V = 786 +- 40 km/sec.','G',0.000013,NULL,'10.95',2.8,'SAB(s)ab;HII;SyLINER','in a radial-velocity based grouping',NULL,NULL,'LINER',1,183.4512083,14.90033,0.145,NULL,58180934603,909077103,14204329,10.95),(90426,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90426,30.36,NULL,11.8,38039,NULL,NULL,NULL,'MESSIER 098',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90427,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90427,30.43,0.92,12.2,38039,NULL,NULL,'CO','MESSIER 098',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90428,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90428,30.61,NULL,13.2,38039,NULL,NULL,'B','MESSIER 098',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90429,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90429,30.67,0.35,13.6,38039,NULL,NULL,NULL,'MESSIER 098',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90430,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90430,30.67,0.42,13.6,38039,65,NULL,NULL,'MESSIER 098',NULL,'1980ApJ...238..458M',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90431,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90431,30.76,0.7,14.2,38039,NULL,NULL,'HI','MESSIER 098',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90432,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90432,31.1,0.47,16.6,38039,75,NULL,'A82, H, raw','MESSIER 098',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90433,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90433,31.13,0.4,16.8,38039,75,NULL,'B','MESSIER 098',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90434,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90434,31.17,0.3,17.1,38039,55,NULL,'B','MESSIER 098',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90435,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90435,31.29,0.47,18.1,38039,75,NULL,'A82, H, inv','MESSIER 098',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90436,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90436,31.36,0.47,18.7,38039,75,NULL,'A82, H, cor','MESSIER 098',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90437,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90437,37.43,0.46,306,38040,70,NULL,NULL,'2MASX J12134948+6251358',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000167,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,183.4565,62.85997,0.005,NULL,57373157839,896455591,14007118,17.1),(90438,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90438,38.11,0.46,419,38041,70,NULL,NULL,'SDSS J121349.57+435529.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000148,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,183.456583333,43.92483,0,NULL,59057882628,922779416,14418428,18.4),(90439,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90439,27.5,0.1,3.16,38042,NULL,NULL,NULL,'ESO 321- G 014',NULL,'2012A&A...540A..49M',2012,1,1.4,NULL,'G',0.00001,NULL,'15.16',0.6,'IBm',NULL,NULL,NULL,NULL,1,183.45675,-38.23136,0.349,NULL,43275460476,676179069,10565297,15.16),(90440,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90440,27.51,0.14,3.18,38042,NULL,NULL,'I','ESO 321- G 014',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90441,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90441,27.52,NULL,3.19,38042,NULL,NULL,'I','ESO 321- G 014',NULL,'2006ARep...50..517T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90442,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90442,27.52,NULL,3.2,38042,NULL,NULL,NULL,'ESO 321- G 014',NULL,'2002A&A...385...21K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90443,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90443,27.57,0.1,3.27,38042,NULL,NULL,'I','ESO 321- G 014',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90444,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90444,27.58,0.08,3.28,38042,74.4,NULL,NULL,'ESO 321- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90445,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90445,27.58,0.11,3.28,38042,NULL,NULL,NULL,'ESO 321- G 014',NULL,'2015ApJ...802L..25T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90446,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90446,37.2,0.46,276,38043,70,NULL,NULL,'2MASX J12134978+1221254',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000201,NULL,'16.0g',0.38,'E0',NULL,NULL,NULL,NULL,1,183.4575,12.35703,0.026,NULL,58140502628,908445353,14194458,16),(90447,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90447,38.45,0.27,490,38044,70,NULL,NULL,'2MASX J12134978+5535175',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000192,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,183.457583,55.58825,0,NULL,57212843572,893950680,13967979,16.2),(90448,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90448,33.14,0.4,42.4,38045,NULL,NULL,'mean','NGC 4191',NULL,'2007A&A...465...71T',2007,1,1.33,NULL,'G',0.000017,NULL,'13.5g',0.97,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,183.46,7.20089,0,NULL,58025847919,906653873,14166466,13.5),(90449,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90449,33.4,0.45,47.8,38045,NULL,NULL,'K','NGC 4191',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90450,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90450,37.7,0.46,346,38046,70,NULL,NULL,'2MASX J12135039-0014234',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000077,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,183.46,-0.23989,0.037,NULL,42960000606,671250009,10488281,17.3),(90451,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90451,38.8,0.46,575,38047,70,NULL,NULL,'2MASX J12135045+1440594',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000165,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,183.46025,14.68319,0.127,NULL,58181286477,909082601,14204415,18.4),(90452,'IRAS','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90452,34.36,0.8,74.4,38048,75,NULL,'MAT, I','ESO 267- G 029',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.15',1,'SB pec         HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,183.467791667,-47.27372,0.449,NULL,44573986095,696468532,10882320,14.15),(90453,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90453,33.82,0.62,58,38048,NULL,NULL,'Malmquist cor.','ESO 267- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90454,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90454,33.84,0.43,58.5,38048,75,NULL,'MAT, I, raw','ESO 267- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90455,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90455,33.84,0.32,58.7,38048,85,NULL,'I, raw','ESO 267- G 029',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90456,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90456,33.9,0.32,60.3,38048,85,NULL,'I, inv','ESO 267- G 029',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90457,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90457,34,0.57,63,38048,NULL,NULL,NULL,'ESO 267- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90458,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90458,34.04,0.2,64.3,38048,74.4,NULL,NULL,'ESO 267- G 029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90459,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90459,34.1,0.43,65.9,38048,75,NULL,'MAT, I, inv','ESO 267- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90460,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90460,34.14,0.43,67.3,38048,75,NULL,'MAT, I, cor','ESO 267- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90461,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90461,34.21,0.47,69.4,38048,NULL,NULL,'H','ESO 267- G 029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90462,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90462,34.24,0.45,70.5,38048,NULL,NULL,'K','ESO 267- G 029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90463,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90463,34.36,0.46,74.5,38048,NULL,NULL,'J','ESO 267- G 029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90464,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90464,34.41,0.4,76.3,38048,NULL,NULL,'mean','ESO 267- G 029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90465,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90465,38.06,0.46,409,38049,70,NULL,NULL,'2MASX J12135253+3036012',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.62',0.15,NULL,NULL,NULL,NULL,NULL,1,183.4689583,30.6005,0.048,NULL,58633825317,916153520,14314898,18.62),(90466,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90466,36.87,0.46,237,38050,70,NULL,NULL,'2MASX J12135328+5417374',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,183.472167,54.29375,0.009,NULL,57226229614,894159837,13971247,17.6),(90467,'IRAS','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90467,32.93,0.8,38.5,38051,75,NULL,'CF, r','NGC 4193',NULL,'1997ApJS..109..333W',1997,1,2.65,NULL,'G',0.000017,NULL,'13.1g',0.93,'SAB(s)c:?;HII  LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,183.4732917,13.17286,0.019,NULL,58139332409,908427068,14194172,13.1),(90468,'Sosies','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90468,32.86,0.1,37.3,38051,NULL,NULL,NULL,'NGC 4193',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90469,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90469,32.39,0.38,30,38051,75,NULL,'CF, r, raw','NGC 4193',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90470,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90470,32.45,0.38,30.9,38051,75,NULL,'CF, r, cor','NGC 4193',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90471,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90471,32.47,0.38,31.2,38051,75,NULL,'CF, r, inv','NGC 4193',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90472,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90472,32.64,NULL,33.7,38051,NULL,NULL,NULL,'NGC 4193',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90473,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90473,32.77,0.47,35.8,38051,NULL,NULL,'H','NGC 4193',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90474,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90474,32.83,0.36,36.8,38051,NULL,NULL,NULL,'NGC 4193',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90475,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90475,32.84,0.46,37,38051,NULL,NULL,'J','NGC 4193',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90476,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90476,32.86,0.45,37.4,38051,NULL,NULL,'K','NGC 4193',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90477,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90477,32.87,0.4,37.5,38051,NULL,NULL,'Malmquist cor.','NGC 4193',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90478,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90478,32.9,0.43,38,38051,75,NULL,'3.6 micron, color corrected','NGC 4193',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90479,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90479,32.92,0.2,38.4,38051,74.4,NULL,NULL,'NGC 4193',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90480,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90480,32.95,0.43,38.9,38051,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4193',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90481,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90481,33.06,0.4,41,38051,NULL,NULL,'mean','NGC 4193',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90482,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90482,33.07,0.36,41.2,38051,NULL,NULL,NULL,'NGC 4193',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90483,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90483,33.54,0.3,51,38051,55,NULL,'B','NGC 4193',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90484,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90484,32.33,NULL,29.2,38052,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07238',NULL,'2010Ap&SS.325..163P',2010,1,1.53,NULL,'G',NULL,NULL,'16.0',0.17,'Scd','X-ray-bright group member',NULL,NULL,NULL,1,183.474375,74.50017,0.053,NULL,57017033180,890891143,13920174,16),(90485,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90485,32.36,NULL,29.6,38052,NULL,NULL,'Dipole + Quadrupole','UGC 07238',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90486,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90486,32.36,NULL,29.7,38052,NULL,NULL,'Dipole','UGC 07238',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90487,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90487,33.62,NULL,53,38052,NULL,NULL,NULL,'UGC 07238',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90488,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90488,38.52,0.46,505,38053,70,NULL,NULL,'2MASX J12135381+2348260',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,183.47425,23.80708,0.094,NULL,58592972684,915515198,14304924,18),(90489,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90489,37.86,0.46,373,38054,70,NULL,NULL,'SDSS J121354.26+605924.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,183.476167,60.99011,0,NULL,57339028474,895922319,13998786,18),(90490,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90490,37.11,0.46,264,38055,70,NULL,NULL,'2MASX J12135435+4156516',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,183.4764583,41.94753,0,NULL,58533263749,914582246,14290347,16.7),(90491,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90491,38.34,0.33,466,38056,70,NULL,NULL,'2MASX J12135468-0105043',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00009,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,183.477791667,-1.08461,0.045,NULL,42961404567,671271946,10488624,17.7),(90492,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90492,35.4,0.21,120,38057,70,NULL,NULL,'CGCG 128-055',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.001101,NULL,'15.7',0.4,'S0',NULL,NULL,NULL,NULL,1,183.478833333,21.75606,0.048,NULL,58868571289,919821426,14372209,15.7),(90493,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90493,37.63,0.46,335,38058,70,NULL,NULL,'2MASX J12135518+0413265',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,183.479833,4.22422,0,NULL,58048513903,907008029,14172000,17.6),(90494,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90494,37.09,0.46,261,38059,70,NULL,NULL,'SDSS J121356.92+282858.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000123,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,183.4872083,28.48289,NULL,NULL,58651064661,916422885,14319107,18.1),(90495,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90495,36.83,0.46,232,38060,70,NULL,NULL,'2MASX J12135786+2746001',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000093,NULL,'16.3g',0.34,NULL,'Field galaxy',NULL,NULL,NULL,1,183.4912917,27.76667,NULL,NULL,58651459383,916429052,14319203,16.3),(90496,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90496,37.34,0.46,294,38061,70,NULL,NULL,'2MASX J12135823+6121418',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000196,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,183.492417,61.36181,0,NULL,57338516395,895914318,13998661,16.9),(90497,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90497,38.29,0.46,454,38062,70,NULL,NULL,'2MASX J12140035+3737276',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,183.5017917,37.62439,0,NULL,58578905715,915295401,14301490,17.6),(90498,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90498,38.08,0.46,413,38063,70,NULL,NULL,'2MASX J12140054+2229140',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,183.502417,22.48722,0.039,NULL,58868364552,919818196,14372159,17.5),(90499,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90499,36.42,0.46,192,38064,70,NULL,NULL,'2MASX J12140064+1411384',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00017,NULL,'16.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,183.502833333,14.19397,0.128,NULL,58180358301,909068098,14204189,16.1),(90500,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90500,37.65,0.46,339,38065,70,NULL,NULL,'2MASX J12140133+0217125',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000168,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,183.505583,2.28678,0.016,NULL,58042945612,906921025,14170641,16.9),(90501,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90501,38.11,0.46,418,38066,70,NULL,NULL,'SDSS J121401.33+070449.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,183.505583,7.08031,0,NULL,58025381843,906646591,14166352,18.3),(90502,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90502,37.95,0.46,389,38067,70,NULL,NULL,'2MASX J12140198+3225062',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,183.508417,32.41853,0,NULL,58755284349,918051317,14344551,18.1),(90503,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90503,38.38,0.21,475,38068,70,NULL,NULL,'2MASX J12140297+3017532',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'18.62',0.13,NULL,NULL,NULL,NULL,NULL,1,183.5125,30.29803,0.044,NULL,58629326378,916083224,14313800,18.62),(90504,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90504,36.99,0.69,250,38069,70,NULL,NULL,'2MASX J12140438-4657553',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,183.518375,-46.96528,0.449,NULL,44562594399,696290537,10879539,17.2),(90505,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90505,38.12,0.33,421,38070,70,NULL,NULL,'2MASX J12140447+2942511',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00012,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,183.518583,29.71419,0.023,NULL,58630632885,916103638,14314119,17.2),(90506,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90506,36.87,0.46,236,38071,70,NULL,NULL,'2MASX J12140459+0026465',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000078,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,183.5192083,0.44639,0.033,NULL,57988703276,906073488,14157398,16.5),(90507,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90507,37.67,0.27,342,38072,70,NULL,NULL,'2MASX J12140493-0053384',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000096,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,183.5205,-0.89411,0.045,NULL,42962083958,671282561,10488790,16.8),(90508,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90508,35.13,0.27,106,38073,70,NULL,NULL,'CGCG 128-056',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000047,NULL,'15.5',0.4,'E?',NULL,NULL,NULL,NULL,1,183.520875,24.06739,0.092,NULL,58592898353,915514036,14304906,15.5),(90509,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90509,36.99,0.13,250,38074,70,NULL,NULL,'2MASX J12140570+5958278',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000175,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,183.523916667,59.97439,0,NULL,57344221162,896003455,14000053,16.8),(90510,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90510,38.82,0.46,580,38075,70,NULL,NULL,'SDSS J121406.44+115911.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000141,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,183.526833333,11.98642,0.041,NULL,58140191270,908440488,14194382,18.5),(90511,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90511,34.87,0.47,94.4,38076,NULL,NULL,'Malmquist cor.','NGC 4186',NULL,'2009ApJS..182..474S',2009,1,1.03,NULL,'G',0.000017,NULL,'14.3g',0.83,'SA(s)ab:','in a pair',NULL,NULL,NULL,1,183.5272083,14.72581,0.137,NULL,58181046374,909078849,14204357,14.3),(90512,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90512,35.07,0.43,103,38076,NULL,NULL,NULL,'NGC 4186',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90513,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90513,35.11,0.2,105,38076,74.4,NULL,NULL,'NGC 4186',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90514,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90514,35.35,0.47,117,38076,NULL,NULL,'H','NGC 4186',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90515,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90515,35.39,0.4,120,38076,NULL,NULL,'mean','NGC 4186',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90516,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90516,35.44,0.45,123,38076,NULL,NULL,'K','NGC 4186',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90517,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90517,35.5,0.46,126,38076,NULL,NULL,'J','NGC 4186',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90518,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90518,36.67,0.46,216,38077,70,NULL,NULL,'2MASX J12140768+1029190',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000182,NULL,'16.0g',0.36,'S0',NULL,NULL,NULL,NULL,1,183.532125,10.48867,0,NULL,58214710185,909604846,14212575,16),(90519,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90519,28.67,NULL,5.42,38078,NULL,NULL,NULL,'UGC 07242',NULL,'2006AJ....131.1361K',2006,1,1.9,NULL,'G',0.000007,NULL,'14.60',0.8,'Scd:','Group member',NULL,NULL,NULL,1,183.535,66.09472,0.013,NULL,57314133104,895533329,13992708,14.6),(90520,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90520,28.67,0.03,5.42,38078,NULL,NULL,'I','UGC 07242',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90521,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90521,28.68,0.1,5.45,38078,74.4,NULL,NULL,'UGC 07242',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90522,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90522,31.98,0.4,24.9,38079,75,NULL,'B','UGC 07239',NULL,'1988NBGC.C....0000T',1988,1,1.08,NULL,'G',0.000013,NULL,'15.2g',1,'Im:            HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,183.536833,7.77625,0,NULL,58025182195,906643471,14166304,15.2),(90523,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90523,35.81,0.33,145,38080,70,NULL,NULL,'2MASX J12140880+1334354',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,183.536875,13.57658,0.025,NULL,58138434706,908413042,14193953,17),(90524,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90524,32.96,0.4,39.1,38081,75,NULL,'B','NGC 4194',NULL,'1988NBGC.C....0000T',1988,1,1.8,'Multiple SDSS entries describe this object.','G',0.000003,NULL,'13.0B',1.1,'IBm pec;BlueCG HII','Field galaxy',NULL,NULL,'Starburst',1,183.5394583,54.52683,0,NULL,57224434385,894131787,13970809,13),(90525,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90525,36.12,0.46,167,38082,70,NULL,NULL,'2MASX J12140979+4107370',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000179,NULL,'16.0g',0.31,NULL,NULL,NULL,NULL,NULL,1,183.540667,41.12703,0,NULL,58531881158,914560643,14290010,16),(90526,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90526,37.64,0.46,338,38083,70,NULL,NULL,'2MASX J12141023+0116365',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,183.542583,1.27689,0.04,NULL,57990257281,906097770,14157777,17.8),(90527,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90527,37.47,0.33,311,38084,70,NULL,NULL,'SDSS J121410.43+174746.0',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'16.2g',0.41,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,183.5435,17.79611,0.092,NULL,58127473163,908241768,14191277,16.2),(90528,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90528,38.15,0.46,426,38085,70,NULL,NULL,'2MASX J12141057+4323172',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,183.544291667,43.38825,0,NULL,59057035327,922766176,14418221,17.8),(90529,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90529,37.59,0.46,330,38086,70,NULL,NULL,'2MASX J12141066+0500555',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000146,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,183.544417,5.01531,0,NULL,58033505435,906773522,14168336,17.4),(90530,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90530,37.05,0.64,257,38087,70,NULL,NULL,'2MASX J12141195-4757599',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.4,NULL,NULL,NULL,NULL,NULL,1,183.549833,-47.96658,0.493,NULL,44574574717,696477729,10882464,14.2),(90531,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90531,37.23,0.33,280,38088,70,NULL,NULL,'2MASX J12141278+1531495',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.82',0.19,NULL,NULL,NULL,NULL,NULL,1,183.553167,15.53053,0.084,NULL,58183050847,909110169,14204846,17.82),(90532,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90532,38.02,0.46,402,38089,70,NULL,NULL,'SDSS J121412.77+004455.9',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000113,NULL,'18.1g',0.12,'NLAGN',NULL,NULL,NULL,NULL,1,183.553208333,0.74889,0.026,NULL,57990318638,906098728,14157792,18.1),(90533,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90533,36.99,0.13,250,38090,70,NULL,NULL,'2MASX J12141274+5949370',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,183.553375,59.82703,0,NULL,57344207720,896003245,14000050,17),(90534,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90534,37.47,0.33,311,38091,70,NULL,NULL,'SDSS J121413.40+174846.9',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,183.555875,17.81306,0.092,NULL,58127479571,908241868,14191279,NULL),(90535,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90535,35.04,0.33,102,38092,70,NULL,NULL,'CGCG 187-025',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.000093,NULL,'14.7g',0.62,'SB0','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,183.5582917,32.42117,0,NULL,58755282366,918051286,14344551,14.7),(90536,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90536,35.81,0.33,145,38093,70,NULL,NULL,'2MASX J12141536+1330556',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000149,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,183.564041667,13.5155,0.022,NULL,58138441439,908413147,14193955,16.4),(90537,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90537,37.82,0.33,366,38094,70,NULL,NULL,'2MASX J12141590+1532096',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,183.566166667,15.53594,0.084,NULL,58183052923,909110201,14204846,17.6),(90538,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90538,38.34,0.33,466,38095,70,NULL,NULL,'2MASX J12141606-0108094',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00009,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,183.566791667,-1.13589,0.041,NULL,42962173235,671283956,10488811,17.6),(90539,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90539,35.49,0.27,125,38096,70,NULL,NULL,'CGCG 187-026',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.00009,NULL,'14.9g',0.58,NULL,NULL,NULL,NULL,NULL,1,183.56725,34.61994,0,NULL,58550410193,914850159,14294533,14.9),(90540,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90540,37.45,0.46,309,38097,70,NULL,NULL,'2MASX J12141653+1427086',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,183.568875,14.45236,0.123,NULL,58181209144,909081392,14204396,17.9),(90541,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90541,37.83,0.46,369,38098,70,NULL,NULL,'2MASX J12141689+4426273',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000085,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,183.570583333,44.44094,0,NULL,59057240354,922769380,14418271,17),(90542,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90542,37.67,0.27,342,38099,70,NULL,NULL,'2MASXi J1214169-010530',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000075,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,183.570667,-1.09164,0.041,NULL,42962160157,671283752,10488808,18),(90543,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90543,37.7,0.46,346,38100,70,NULL,NULL,'2MASX J12141760+1357336',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,183.573417,13.95944,0.128,NULL,58168878750,908888730,14201386,17.1),(90544,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90544,36.73,0.46,222,38101,70,NULL,NULL,'2MASX J12141768+3447023',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000188,NULL,'16.0g',0.35,NULL,NULL,NULL,NULL,NULL,1,183.573583,34.78389,0,NULL,58550496322,914851505,14294554,16),(90545,'Black Hole','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,NULL,90545,37.94,0.72,387,38102,NULL,NULL,NULL,'PG 1211+143',NULL,'2014ApJ...793..108W',2014,1,0.6,NULL,'G',0.0005,NULL,'14.3V',0.3,'RQQ            Sy1',NULL,NULL,NULL,'NL Sy 1',1,183.573625,14.05364,0.128,NULL,58168900712,908889073,14201391,14.3),(90546,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90546,37.82,0.33,366,38103,70,NULL,NULL,'2MASX J12141881+1530136',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000178,NULL,'16.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,183.578375,15.50386,0.084,NULL,58183054955,909110233,14204847,16.2),(90547,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90547,36.95,0.46,245,38104,70,NULL,NULL,'2MASX J12141922+0527575',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000144,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,183.580041667,5.46606,0,NULL,58034348629,906786697,14168542,17.4),(90548,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90548,37.99,0.46,396,38105,70,NULL,NULL,'2MASX J12142028+2646474',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000168,NULL,'18.63',0.16,NULL,NULL,NULL,NULL,NULL,1,183.5844583,26.77975,NULL,NULL,58649716819,916401825,14318778,18.63),(90549,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90549,37.44,0.46,307,38106,70,NULL,NULL,'SDSS J121420.86+251637.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.6g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,183.5869583,25.27719,0.061,NULL,58591534841,915492731,14304573,18.6),(90550,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90550,38.38,0.21,475,38107,70,NULL,NULL,'2MASX J12142104+3015563',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'18.24',0.2,'BrClG',NULL,NULL,NULL,NULL,1,183.587833,30.26561,0.044,NULL,58629339035,916083422,14313803,18.24),(90551,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90551,37.61,0.46,333,38108,70,NULL,NULL,'SDSS J121422.14+580545.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000138,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,183.59225,58.09589,0,NULL,57329821562,895778461,13996538,18.1),(90552,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90552,35.04,0.33,102,38109,70,NULL,NULL,'UGC 07243',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000093,NULL,'14.45',0.8,'S0','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,183.5962083,32.41464,0,NULL,58755270753,918051105,14344548,14.45),(90553,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90553,37.8,0.46,363,38110,70,NULL,NULL,'2MASX J12142350+3614350',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000184,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,183.598,36.24294,0,NULL,58548931753,914827058,14294172,17.2),(90554,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90554,36.63,0.46,212,38111,70,NULL,NULL,'2MASX J12142407+0241395',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,183.600333,2.6945,0.022,NULL,58043743999,906933499,14170835,17.6),(90555,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90555,38.38,0.21,475,38112,70,NULL,NULL,'SDSS J121424.60+300743.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000151,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,183.6025417,30.12869,0.022,NULL,58629346750,916083542,14313805,18.6),(90556,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90556,37.25,0.46,282,38113,70,NULL,NULL,'2MASX J12142507-0203213',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00015,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,183.6045417,-2.05606,0.045,NULL,43005839984,671966249,10499472,16.3),(90557,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90557,37.67,0.27,342,38114,70,NULL,NULL,'2MASX J12142566-0056513',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000009,NULL,'16.4g',0.29,'NLAGN',NULL,NULL,NULL,NULL,1,183.606917,-0.94775,0.041,NULL,42962081921,671282530,10488789,16.4),(90558,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90558,36.93,0.46,243,38115,70,NULL,NULL,'2MASXi J1214260+465023',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000169,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,183.608667,46.83989,0,NULL,57177981574,893405962,13959468,17.5),(90559,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90559,36.7,0.33,219,38116,70,NULL,NULL,'2MASX J12142613+2803314',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000087,NULL,'16.3g',0.39,'E','Field galaxy',NULL,NULL,NULL,1,183.6087917,28.05867,NULL,NULL,58651168570,916424508,14319132,16.3),(90560,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90560,37.54,0.46,321,38117,70,NULL,NULL,'2MASX J12142693+4511433',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000178,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,183.6122083,45.19544,0,NULL,59059060465,922797819,14418715,16.5),(90561,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90561,38.26,0.46,448,38118,70,NULL,NULL,'SDSS J121427.39+144537.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000154,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,183.614125,14.7605,0.137,NULL,58181090622,909079540,14204367,18.7),(90562,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90562,36.78,0.46,227,38119,70,NULL,NULL,'2MASX J12142957+4636353',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000198,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,183.6234583,46.60969,0,NULL,59058017908,922781529,14418461,16.7),(90563,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90563,37.06,0.27,259,38120,70,NULL,NULL,'2MASX J12143009+5642510',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,183.6255417,56.71422,0,NULL,57399035120,896859923,14013436,17),(90564,'FP','2016-12-15 15:14:56','2016-12-16 11:20:05','1',NULL,'R',90564,38.06,0.46,410,38121,70,NULL,NULL,'2MASX J12143084+1615526',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.65',0.14,NULL,NULL,NULL,NULL,NULL,1,183.6284583,16.26469,0.12,NULL,58180050764,909063293,14204113,18.65),(90565,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90565,37.31,0.46,290,38122,70,NULL,NULL,'2MASX J12143124+0822252',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000218,NULL,'16.8g',0.29,'AGN',NULL,NULL,NULL,NULL,1,183.630166667,8.37381,0,NULL,58207321163,909489393,14210771,16.8),(90566,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90566,37.32,0.46,291,38123,70,NULL,NULL,'2MASX J12143134+0308475',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000186,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,183.6305417,3.14653,0,NULL,58045446087,906960095,14171251,16.3),(90567,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90567,37.44,0.27,308,38124,70,NULL,NULL,'2MASX J12143191+0426065',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000182,NULL,'16.1g',0.32,'E0',NULL,NULL,NULL,NULL,1,183.6329583,4.43508,0.006,NULL,58047769157,906996393,14171818,16.1),(90568,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90568,38.2,0.46,436,38125,70,NULL,NULL,'SDSS J121431.99+095330.3',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000146,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,183.633291667,9.89178,0,NULL,58216743902,909636623,14213072,17.9),(90569,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90569,39.01,0.46,635,38126,70,NULL,NULL,'SDSS J121432.69+224010.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,183.63625,22.66969,0.053,NULL,58863930950,919748921,14371076,18.5),(90570,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90570,37.93,0.46,386,38127,70,NULL,NULL,'SDSS J121433.15+104745.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000134,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,183.638125,10.79606,0,NULL,58209669737,909526089,14211345,18),(90571,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90571,37.11,0.46,265,38128,70,NULL,NULL,'2MASX J12143318+2817503',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000103,NULL,'16.1g',0.36,'E','Field galaxy',NULL,NULL,NULL,1,183.638291667,28.29744,NULL,NULL,58651099596,916423431,14319116,16.1),(90572,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90572,37.34,0.33,294,38129,70,NULL,NULL,'SDSS J121434.63+053058.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,183.644333,5.51628,0,NULL,58034300184,906785940,14168530,17.9),(90573,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90573,29.57,NULL,8.2,38130,NULL,NULL,NULL,'VCC 0114',NULL,'2013AJ....145..101K',2013,1,0.6,'Multiple SDSS entries describe this source.','G',0.000033,NULL,'16.0',0.3,'Im?','X-ray-bright group member',NULL,NULL,NULL,1,183.647333,5.67625,0,NULL,58026498810,906664043,14166625,16),(90574,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90574,35.49,0.27,125,38131,70,NULL,NULL,'2MASX J12143617+3432480',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000174,NULL,'15.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,183.650667,34.54678,0,NULL,58550414367,914850224,14294534,15.7),(90575,'IRAS','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90575,34.59,0.8,82.9,38132,75,NULL,'HMCL, I, Authors give as UGC 07267','UGC 07248',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.00004,NULL,'15.20',0.5,'SBb',NULL,NULL,NULL,NULL,1,183.652833,24.30078,0.088,NULL,58593421912,915522217,14305034,15.2),(90576,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90576,34.92,0.4,96.4,38132,75,NULL,'HMCL, I, raw, Authors give as UGC 07267','UGC 07248',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90577,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90577,35.07,0.4,103,38132,75,NULL,'HMCL, I, inv, Authors give as UGC 07267','UGC 07248',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90578,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90578,35.06,0.49,103,38132,75,NULL,'IR','UGC 07248',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90579,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90579,35.09,0.4,104,38132,75,NULL,'HMCL, I, cor, Authors give as UGC 07267','UGC 07248',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90580,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90580,31.13,0.4,16.8,38133,75,NULL,'B','IC 3056',NULL,'1988NBGC.C....0000T',1988,1,1.04,NULL,'G',0.00002,NULL,'16.1g',0.43,'Im             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,183.653916667,12.81186,0.018,NULL,58139083428,908423178,14194112,16.1),(90581,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90581,31.96,0.2,24.7,38133,74.4,NULL,NULL,'IC 3056',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90582,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90582,31.97,0.69,24.7,38133,NULL,NULL,NULL,'IC 3056',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90583,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90583,31.99,0.68,25,38133,NULL,NULL,'Malmquist cor.','IC 3056',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90584,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90584,32.09,0.43,26.2,38133,75,NULL,'3.6 micron, color + selection bias corrected','IC 3056',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90585,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90585,32.13,0.43,26.6,38133,75,NULL,'3.6 micron, color corrected','IC 3056',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90586,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90586,32.27,0.36,28.4,38133,NULL,NULL,NULL,'IC 3056',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90587,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90587,36.76,0.46,225,38134,70,NULL,NULL,'2MASX J12143691+4212252',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000155,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,183.653833333,42.207,0,NULL,58533437373,914584958,14290389,16.9),(90588,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90588,38.31,0.46,459,38135,70,NULL,NULL,'2MASX J12143840+3107490',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,183.660125,31.13036,0.034,NULL,58629052356,916078943,14313733,18.3),(90589,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90589,31.8,0.4,22.9,38136,75,NULL,NULL,'NGC 4197',NULL,'2008Ap.....51..336K',2008,1,3.23,NULL,'G',0.000013,NULL,'13.4g',0.57,'Scd(f)         HII','X-ray-bright group member',NULL,NULL,NULL,1,183.660625,5.80572,0,NULL,58026542159,906664721,14166636,13.4),(90590,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90590,31.91,NULL,24.1,38136,NULL,NULL,NULL,'NGC 4197',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90591,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90591,32.01,0.36,25.2,38136,NULL,NULL,NULL,'NGC 4197',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90592,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90592,32.02,0.43,25.3,38136,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4197',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90593,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90593,32.08,0.43,26.1,38136,75,NULL,'3.6 micron, color corrected','NGC 4197',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90594,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90594,32.1,NULL,26.3,38136,NULL,NULL,'Dipole','NGC 4197',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90595,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90595,32.1,NULL,26.3,38136,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 4197',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90596,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90596,32.11,NULL,26.4,38136,NULL,NULL,'Dipole + Quadrupole','NGC 4197',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90597,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90597,32.16,0.2,27,38136,74.4,NULL,NULL,'NGC 4197',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90598,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90598,32.18,NULL,27.3,38136,NULL,NULL,NULL,'NGC 4197',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90599,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90599,32.31,0.49,29,38136,75,NULL,'IR','NGC 4197',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90600,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90600,32.61,0.46,33.3,38136,NULL,NULL,'J','NGC 4197',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90601,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90601,32.64,0.4,33.7,38136,NULL,NULL,'mean','NGC 4197',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90602,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90602,32.65,0.47,33.9,38136,NULL,NULL,'H','NGC 4197',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90603,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90603,32.74,0.45,35.4,38136,NULL,NULL,'K','NGC 4197',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90604,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:06','1','SN 2006an',NULL,90604,36.61,0.15,197,38137,74.2,NULL,'SALT 2','SDSS J121438.73+121347.7',0.0651,'2010ApJ...716..712A',2010,1,0.06,NULL,'G',NULL,NULL,'21.9r',0.04,NULL,NULL,NULL,NULL,NULL,1,183.661417,12.22992,0.029,NULL,58140463992,908444749,14194449,21.9),(90605,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:06','1','SN 2006an',NULL,90605,37.36,0.15,278,38137,73.8,NULL,'SALT 2 (SNANA)','SDSS J121438.73+121347.7',0.0651,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90606,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:06','1','SN 2006an','R',90606,37.23,0.07,279,38137,NULL,NULL,'MLCS2k2, R(V) = 1.8','SDSS J121438.73+121347.7',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90607,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:06','1','SN 2006an',NULL,90607,37.37,0.04,280,38137,70,NULL,'SALT 2','SDSS J121438.73+121347.7',0.0651,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90608,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:06','1','SN 2006an','R',90608,37.27,0.07,284,38137,NULL,NULL,'MLCS2k2, R(V) = 3.1','SDSS J121438.73+121347.7',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90609,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:06','1','SN 2006an',NULL,90609,37.4,0.15,302,38137,65,NULL,'SALT','SDSS J121438.73+121347.7',NULL,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90610,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:06','1','SN 2006an',NULL,90610,37.43,0.17,306,38137,65,NULL,'SALT2','SDSS J121438.73+121347.7',NULL,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90611,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:06','1','SN 2006an',NULL,90611,37.65,0.14,339,38137,65,NULL,'MLCS17','SDSS J121438.73+121347.7',NULL,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90612,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:06','1','SN 2006an',NULL,90612,37.7,0.12,346,38137,65,NULL,'MLCS31','SDSS J121438.73+121347.7',NULL,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90613,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90613,37.95,0.33,389,38138,70,NULL,NULL,'SDSS J121439.04+094903.1',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,183.662667,9.81753,0,NULL,58216757895,909636842,14213075,17.7),(90614,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90614,37.96,0.33,391,38139,70,NULL,NULL,'2MASX J12143910+1612336',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000188,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,183.662875,16.20931,0.12,NULL,58180053021,909063328,14204114,16.9),(90615,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90615,37.26,0.46,284,38140,70,NULL,NULL,'2MASX J12143926+3139390',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000169,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,183.6635417,31.66089,0.021,NULL,58768537342,918258395,14347787,16.4),(90616,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90616,37.34,0.33,294,38141,70,NULL,NULL,'2MASX J12143951+0528035',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000192,NULL,'15.6g',0.5,'BrClG          AGN',NULL,NULL,NULL,NULL,1,183.66475,5.46775,0,NULL,58034345540,906786649,14168541,15.6),(90617,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90617,38.38,0.21,475,38142,70,NULL,NULL,'2MASX J12143975+3015030',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,183.665625,30.25078,0.022,NULL,58629511522,916086117,14313845,17.5),(90618,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90618,37.95,0.33,389,38143,70,NULL,NULL,'2MASX J12144000+0946407',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000202,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,183.666625,9.77806,0,NULL,58216748521,909636695,14213073,16.3),(90619,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90619,38.36,0.46,469,38144,70,NULL,NULL,'2MASX J12144092+2524184',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,183.670417,25.40517,0.068,NULL,58591508839,915492325,14304567,17.8),(90620,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90620,38.21,0.46,439,38145,70,NULL,NULL,'2MASX J12144124+2217061',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,183.671958333,22.28492,0.039,NULL,58868282792,919816918,14372139,17.7),(90621,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90621,36.96,0.46,246,38146,70,NULL,NULL,'SDSS J121442.49+125924.7',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',NULL,NULL,'15.7g',0.39,'E0',NULL,NULL,NULL,NULL,1,183.677083,12.99022,0.021,NULL,58139107638,908423556,14194118,15.7),(90622,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90622,37.68,0.46,344,38147,70,NULL,NULL,'2MASX J12144285+5300508',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000154,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,183.67875,53.01406,0.008,NULL,57223492436,894117069,13970579,17),(90623,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90623,37.44,0.27,308,38148,70,NULL,NULL,'2MASX J12144307+0425035',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000198,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,183.679625,4.41767,0.006,NULL,58047767280,906996363,14171818,16.7),(90624,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90624,37.96,0.33,391,38149,70,NULL,NULL,'2MASX J12144346+1611373',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,183.681166667,16.19358,0.108,NULL,58180053388,909063334,14204114,17.5),(90625,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90625,38.08,0.46,413,38150,70,NULL,NULL,'SDSS J121443.67+081448.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,183.682,8.24683,0,NULL,58207368912,909490139,14210783,17.9),(90626,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90626,37.47,0.46,312,38151,70,NULL,NULL,'2MASX J12144374-0122523',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,183.682333,-1.38122,0.033,NULL,42961604977,671275077,10488673,18.1),(90627,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90627,31.92,NULL,24.2,38152,NULL,NULL,NULL,'NGC 4200',NULL,'1999MNRAS.304..595G',1999,1,1.51,NULL,'G',0.000093,NULL,'13.7g',0.89,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,183.684291667,12.18075,0.029,NULL,58141321016,908458140,14194658,13.7),(90628,'Tully est','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90628,32.81,0.8,36.5,38153,75,NULL,NULL,'ESO 380- G 001',NULL,'1988NBGC.C....0000T',1988,1,3.4,NULL,'G',0.000023,NULL,'12.96',2.1,'SB(rs)b        HII','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,183.688,-35.50981,0.305,NULL,43265845610,676028837,10562950,12.96),(90629,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90629,31.31,0.4,18.3,38153,NULL,NULL,NULL,'ESO 380- G 001',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90630,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90630,31.58,0.47,20.7,38153,NULL,NULL,'H','ESO 380- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90631,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90631,31.62,0.45,21,38153,NULL,NULL,'K','ESO 380- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90632,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90632,31.64,0.46,21.3,38153,NULL,NULL,'J','ESO 380- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90633,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90633,32.94,0.4,38.8,38153,NULL,NULL,'mean','ESO 380- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90634,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90634,37.47,0.46,312,38154,70,NULL,NULL,'2MASX J12144541+2918534',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000133,NULL,'17.1g',0.25,'E',NULL,NULL,NULL,NULL,1,183.6890417,29.31481,NULL,NULL,58630983739,916109120,14314205,17.1),(90635,'IRAS','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90635,34.68,0.8,86.4,38155,75,NULL,'HMCL, I','UGC 07250',NULL,'1997ApJS..109..333W',1997,1,1.15,NULL,'G',0.000056,NULL,'15.5g',0.29,'Sb(f)',NULL,NULL,NULL,NULL,1,183.689375,0.74353,0.028,NULL,57990373681,906099588,14157806,15.5),(90636,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90636,34.28,0.4,71.7,38155,75,NULL,'HMCL, I, raw','UGC 07250',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90637,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90637,34.36,0.4,74.4,38155,75,NULL,'HMCL, I, inv','UGC 07250',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90638,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90638,34.57,0.4,82.1,38155,75,NULL,'HMCL, I, cor','UGC 07250',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90639,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90639,37.44,0.27,308,38156,70,NULL,NULL,'2MASX J12144548+0425035',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00017,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,183.6895,4.41756,0.006,NULL,58047767128,906996361,14171818,17.1),(90640,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90640,37.92,0.33,384,38157,70,NULL,NULL,'SDSS J121445.65+135443.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00013,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,183.6902083,13.91206,0.128,NULL,58168870137,908888595,14201384,17.7),(90641,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90641,37.7,0.46,347,38158,70,NULL,NULL,'2MASX J12144700+2342561',NULL,'2015arXiv151105856S',2015,1,0.28,'2011ApJ...735..125S gives z = 0.106796.','G',0.000233,NULL,'17.33',0.23,NULL,NULL,NULL,NULL,NULL,1,183.6957917,23.71572,0.096,NULL,58593050828,915516419,14304944,17.33),(90642,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90642,36.61,0.33,210,38159,70,NULL,NULL,'2MASX J12144718+1053337',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,183.696791667,10.89258,0,NULL,58210566070,909540094,14211563,17.3),(90643,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90643,36.61,0.33,210,38160,70,NULL,NULL,'2MASX J12144738+1055047',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.44',0.24,NULL,NULL,NULL,NULL,NULL,1,183.6974583,10.91786,0,NULL,58210552345,909539880,14211560,17.44),(90644,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90644,38.36,0.21,470,38161,70,NULL,NULL,'2MASX J12144762+5915304',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00017,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,183.698583,59.25847,0,NULL,57343684099,895995064,13999922,17.5),(90645,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90645,35.95,0.46,155,38162,70,NULL,NULL,'2MASX J12144814+6235389',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000161,NULL,'16.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,183.700958333,62.59419,0.005,NULL,57373184233,896456003,14007125,16.7),(90646,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90646,37.28,0.46,286,38163,70,NULL,NULL,'LCRS B121214.7-023929',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000185,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,183.7025417,-2.93583,0.065,NULL,43013228101,672081689,10501276,16.8),(90647,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90647,36.99,0.13,250,38164,70,NULL,NULL,'NGC 4199 NED01',NULL,'2015arXiv151105856S',2015,1,0.88,NULL,'G',0.00011,NULL,'15.2g',0.6,'E;BrClG',NULL,NULL,NULL,NULL,1,183.702625,59.90619,0,NULL,57344254947,896003983,14000062,15.2),(90648,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90648,37.49,0.46,315,38165,70,NULL,NULL,'2MASX J12144895+0543355',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,183.703833333,5.72664,0,NULL,58026550723,906664855,14166638,17.3),(90649,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90649,38.19,0.46,434,38166,70,NULL,NULL,'2MASX J12144974+1823491',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.22',0.16,NULL,NULL,NULL,NULL,NULL,1,183.7072917,18.39689,0.063,NULL,58127956919,908249326,14191395,18.22),(90650,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90650,36.92,0.46,242,38167,70,NULL,NULL,'2MASX J12144985+1026097',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000184,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,183.70775,10.43617,0,NULL,58214444140,909600689,14212510,16.4),(90651,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90651,37.48,0.46,313,38168,70,NULL,NULL,'2MASX J12145122+0826087',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000168,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,183.713458333,8.43567,0,NULL,58207059689,909485307,14210707,16.7),(90652,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90652,37.92,0.33,384,38169,70,NULL,NULL,'2MASX J12145214+1351193',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,183.717333,13.85553,0.087,NULL,58169574019,908899594,14201556,18),(90653,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90653,37.33,0.46,292,38170,70,NULL,NULL,'SDSS J121452.83+141149.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000148,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,183.720167,14.19711,0.128,NULL,58180633512,909072398,14204256,18.3),(90654,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90654,37.48,0.46,313,38171,70,NULL,NULL,'2MASX J12145342+0913377',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000186,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,183.722583333,9.22722,0,NULL,58216816011,909637750,14213089,17.4),(90655,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90655,38.49,0.46,500,38172,70,NULL,NULL,'2MASX J12145393+2200246',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.87',0.14,NULL,NULL,NULL,NULL,NULL,1,183.724833,22.007,0.049,NULL,58869149791,919830465,14372351,18.87),(90656,'IRAS','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90656,32.53,0.8,32.1,38173,75,NULL,'MAT, I','ESO 380- G 002',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00003,NULL,'15.28',0.7,'Sbc','in a triple',NULL,NULL,NULL,1,183.727791667,-35.59956,0.313,NULL,43265825563,676028524,10562945,15.28),(90657,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90657,30.81,0.32,14.5,38173,85,NULL,'I, inv','ESO 380- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90658,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90658,30.87,0.32,14.9,38173,85,NULL,'I, raw','ESO 380- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90659,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90659,31.43,0.43,19.3,38173,75,NULL,'MAT, I, inv','ESO 380- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90660,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90660,31.58,0.43,20.7,38173,75,NULL,'MAT, I, raw','ESO 380- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90661,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90661,31.91,0.43,24.1,38173,75,NULL,'MAT, I, cor','ESO 380- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90662,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90662,36.7,0.33,219,38174,70,NULL,NULL,'2MASX J12145475+2802104',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000166,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,183.72825,28.03639,NULL,NULL,58651256776,916425887,14319154,16.7),(90663,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90663,30.81,0.43,14.5,38175,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4205',NULL,'2014MNRAS.444..527S',2014,1,1.7,NULL,'G',0.00003,NULL,'13.89',0.6,'Sbc','in a radial-velocity based grouping',NULL,NULL,NULL,1,183.731417,63.78278,0.021,NULL,57317009036,895578266,13993410,13.89),(90664,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90664,31.03,0.43,16.1,38175,75,NULL,'3.6 micron, color corrected','NGC 4205',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90665,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90665,31.21,0.2,17.5,38175,74.4,NULL,NULL,'NGC 4205',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90666,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90666,31.26,0.4,17.8,38175,75,NULL,NULL,'NGC 4205',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90667,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90667,31.85,0.49,23.5,38175,75,NULL,'IR','NGC 4205',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90668,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:06','1','PS1 SN PS11iv','N',90668,41.01,0.15,1230,38176,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11iv HOST',0.2937,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90669,'SNIa','2016-12-15 15:14:56','2016-12-16 11:20:06','1','PS1 SN PS11mz','N',90669,38.33,0.11,420,38177,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11mz HOST',0.1017,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90670,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90670,38.36,0.21,470,38178,70,NULL,NULL,'2MASX J12145737+5923154',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000144,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,183.739125,59.38758,0,NULL,57343557776,895993090,13999892,17.1),(90671,'Brightest Stars','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90671,28.06,NULL,4.09,38179,NULL,NULL,NULL,'UGCA 276',NULL,'1997AstL...23..378M',1997,1,1,NULL,'G',0.00002,NULL,'15.40',1,'Im:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,183.741333333,36.21883,0,NULL,58548916704,914826823,14294169,15.4),(90672,'SBF','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90672,27.44,0.18,3.1,38179,NULL,NULL,NULL,'UGCA 276',NULL,'2001A&A...380...90J',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90673,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90673,27.28,0.11,2.86,38179,NULL,NULL,NULL,'UGCA 276',NULL,'2002A&A...389..812K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90674,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90674,27.34,0.1,2.93,38179,NULL,NULL,NULL,'UGCA 276',NULL,'2013AstBu..68..125M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90675,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90675,27.35,NULL,2.95,38179,NULL,NULL,NULL,'UGCA 276',NULL,'2010ApJ...724.1030G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90676,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90676,27.35,0.06,2.95,38179,NULL,NULL,'I','UGCA 276',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90677,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90677,27.36,0.13,2.96,38179,NULL,NULL,NULL,'UGCA 276',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90678,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90678,27.36,0.08,2.96,38179,NULL,NULL,'I','UGCA 276',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90679,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90679,27.36,0.08,2.97,38179,74.4,NULL,NULL,'UGCA 276',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90680,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90680,27.51,0.06,3.18,38179,NULL,NULL,NULL,'UGCA 276',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90681,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90681,38.29,0.46,454,38180,70,NULL,NULL,'2MASX J12145856+0432542',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,183.7439583,4.54825,0,NULL,58047845045,906997578,14171837,17.8),(90682,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90682,36.94,0.46,245,38181,70,NULL,NULL,'SDSS J121500.52+070756.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,183.7522083,7.13225,0,NULL,58025732241,906652066,14166438,17.6),(90683,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90683,38.3,0.46,456,38182,70,NULL,NULL,'SDSS J121501.61+273526.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000139,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,183.75675,27.59081,0.059,NULL,58651478793,916429356,14319208,18.7),(90684,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90684,35.4,0.2,120,38183,74.4,NULL,NULL,'IC 3060',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000004,NULL,'15.1g',0.6,'Sab','Group member',NULL,NULL,NULL,1,183.758708333,12.54711,0.026,NULL,58141304312,908457879,14194654,15.1),(90685,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90685,30.47,0.4,12.4,38184,NULL,NULL,NULL,'UGC 07257',NULL,'2009AJ....138..323T',2009,1,1.3,NULL,'G',0.000017,NULL,'14.08',0.9,'Sdm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,183.762333,35.9585,0,NULL,58548839622,914825619,14294150,14.08),(90686,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90686,31.52,0.4,20.2,38184,75,NULL,'B','UGC 07257',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90687,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90687,37.55,0.46,324,38185,70,NULL,NULL,'2MASX J12150344+3354400',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.0002,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,183.764333,33.91114,0,NULL,58767674538,918244914,14347576,16.4),(90688,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90688,37.99,0.46,396,38186,70,NULL,NULL,'2MASX J12150351+2906024',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000127,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,183.764667,29.10058,NULL,NULL,58630956820,916108700,14314198,17.4),(90689,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90689,36.43,0.46,193,38187,70,NULL,NULL,'2MASX J12150361+6553049',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000159,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,183.765417,65.88475,0.013,NULL,57313594100,895524907,13992576,16.8),(90690,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90690,31.15,NULL,17,38188,NULL,NULL,NULL,'VCC 0130',NULL,'2014A&A...562A..49M',2014,1,0.45,NULL,'G',0.000012,NULL,'16.8g',0.24,'BCD?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,183.7667083,9.75367,0,NULL,58216751730,909636745,14213074,16.8),(90691,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90691,32.95,0.4,38.9,38189,NULL,NULL,'mean','IC 3061',NULL,'2007A&A...465...71T',2007,1,2.53,NULL,'G',0.000006,NULL,'14.2g',0.41,'SBc? sp;LINER  HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,183.7685,14.02897,0.128,NULL,58169563019,908899422,14201553,14.2),(90692,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90692,32.96,0.48,39.1,38189,NULL,NULL,'Malmquist cor.','IC 3061',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90693,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90693,33.01,0.2,40,38189,74.4,NULL,NULL,'IC 3061',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90694,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90694,33.01,0.4,40,38189,NULL,NULL,NULL,'IC 3061',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90695,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90695,33.08,0.46,41.2,38189,NULL,NULL,NULL,'IC 3061',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90696,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90696,33.08,0.43,41.4,38189,75,NULL,'3.6 micron, color corrected','IC 3061',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90697,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90697,33.15,0.43,42.7,38189,75,NULL,'3.6 micron, color + selection bias corrected','IC 3061',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90698,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90698,33.17,0.49,43.1,38189,75,NULL,'IR','IC 3061',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90699,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90699,33.32,0.47,46.1,38189,NULL,NULL,'H','IC 3061',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90700,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90700,33.37,0.46,47.2,38189,NULL,NULL,'J','IC 3061',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90701,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90701,33.37,0.3,47.3,38189,55,NULL,'B','IC 3061',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90702,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90702,33.45,0.45,49,38189,NULL,NULL,'K','IC 3061',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90703,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90703,37.08,0.33,260,38190,70,NULL,NULL,'2MASX J12150453+1219163',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000183,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,183.768875,12.32119,0.029,NULL,58141353205,908458643,14194666,17),(90704,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90704,38.19,0.46,434,38191,70,NULL,NULL,'2MASX J12150460+6358098',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000178,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,183.769625,63.96933,0.017,NULL,57316593174,895571768,13993308,17.5),(90705,'GCLF','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90705,30.49,0.1,12.5,38192,NULL,NULL,NULL,'NGC 4203',NULL,'2001AJ....122.1251K',2001,1,3.4,NULL,'G',0.000013,NULL,'11.8',3.2,'SAB0-:;LINER   Sy3','in a radial-velocity based grouping',NULL,NULL,'LINER b',1,183.771083333,33.19733,0,NULL,58767931178,918248924,14347639,11.8),(90706,'SBF','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90706,30.9,0.18,15.1,38192,NULL,NULL,'I','NGC 4203',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90707,'SBF','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90707,30.92,0.14,15.3,38192,74.4,NULL,NULL,'NGC 4203',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90708,'Faber-Jackson','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90708,30.55,0.56,12.9,38192,95,NULL,'de Vaucouleurs','NGC 4203',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90709,'Faber-Jackson','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90709,31.07,0.31,16.4,38192,95,NULL,'Weighted Mean','NGC 4203',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90710,'Faber-Jackson','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90710,31.19,0.63,17.3,38192,95,NULL,'Michard 1979b, c','NGC 4203',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90711,'Faber-Jackson','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90711,31.41,0.46,19.1,38192,95,NULL,'Michard 1979a','NGC 4203',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90712,'Faber-Jackson','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90712,33.63,0.81,53.2,38192,55,NULL,'Visvanathan & Sandage 1979','NGC 4203',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90713,'Tertiary','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90713,30.98,0.27,15.7,38192,95,NULL,NULL,'NGC 4203',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90714,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90714,29.93,0.4,9.7,38192,75,NULL,'B','NGC 4203',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90715,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90715,31.2,0.4,17.4,38192,NULL,NULL,'mean','NGC 4203',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90716,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90716,31.5,0.45,20,38192,NULL,NULL,'K','NGC 4203',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90717,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90717,37.55,0.46,323,38193,70,NULL,NULL,'2MASX J12150578+4414428',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,183.7742917,44.24531,0,NULL,59057321027,922770641,14418291,17.9),(90718,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90718,36.12,0.46,168,38194,70,NULL,NULL,'2MASX J12150601+6118338',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00017,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,183.774917,61.30942,0,NULL,57338752150,895918002,13998718,16.3),(90719,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90719,37.49,0.46,314,38195,70,NULL,NULL,'2MASX J12150604+1853106',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.21',0.22,NULL,NULL,NULL,NULL,NULL,1,183.77525,18.88619,0.045,NULL,58126612918,908228326,14191067,17.21),(90720,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90720,38.21,0.46,439,38196,70,NULL,NULL,'2MASX J12150772+0437262',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000172,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,183.7822083,4.62406,0,NULL,58047706831,906995419,14171803,17.8),(90721,'IRAS','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90721,34.75,0.8,89.2,38197,75,NULL,'MAT, I','ESO 441- G 022',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000013,NULL,'13.98',0.6,'SAB(rs)bc?',NULL,NULL,NULL,NULL,1,183.782917,-30.76639,0.209,NULL,43375566672,677743229,10589737,13.98),(90722,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90722,34.41,0.43,76.1,38197,75,NULL,'MAT, I, raw','ESO 441- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90723,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90723,34.46,0.46,77.8,38197,NULL,NULL,'J','ESO 441- G 022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90724,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90724,34.49,0.47,79.1,38197,NULL,NULL,'H','ESO 441- G 022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90725,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90725,34.54,0.45,81,38197,NULL,NULL,'K','ESO 441- G 022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90726,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90726,34.66,0.32,85.5,38197,85,NULL,'I, raw','ESO 441- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90727,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90727,34.75,0.4,89,38197,NULL,NULL,'mean','ESO 441- G 022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90728,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90728,34.75,0.43,89.2,38197,75,NULL,'MAT, I, cor','ESO 441- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90729,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90729,34.75,0.32,89.3,38197,85,NULL,'I, inv','ESO 441- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90730,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90730,34.78,0.43,90.4,38197,75,NULL,'MAT, I, inv','ESO 441- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90731,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90731,34.85,0.2,93.3,38197,74.4,NULL,NULL,'ESO 441- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90732,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90732,35.16,0.34,108,38197,NULL,NULL,NULL,'ESO 441- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90733,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90733,35.18,0.34,109,38197,NULL,NULL,'Malmquist cor.','ESO 441- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90734,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90734,37.74,0.46,353,38198,70,NULL,NULL,'SDSS J121508.10+033346.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000131,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,183.78375,3.563,0,NULL,58048935724,907014620,14172103,18.5),(90735,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90735,38.13,0.23,422,38199,70,NULL,NULL,'2MASX J12150843+6225018',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000168,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,183.785083,62.41717,0.037,NULL,57373660682,896463448,14007241,18),(90736,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90736,39.17,0.46,681,38200,70,NULL,NULL,'2MASX J12150908+1546572',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000199,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,183.787875,15.78264,0.093,NULL,58179884607,909060696,14204073,17.5),(90737,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90737,38.7,0.46,549,38201,70,NULL,NULL,'SDSS J121509.82+652619.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000179,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,183.790917,65.43886,0.029,NULL,57326799751,895731246,13995800,18.8),(90738,'BL Lac Luminosity','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90738,39.03,NULL,563,38202,NULL,NULL,NULL,'2MASX J12151097+0732048',0.136465,'2005ApJ...635..173S',2005,1,0.29,NULL,'G',0.00018,NULL,'17.2g',0.23,'BrClG          BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,183.7957083,7.53464,0,NULL,58025679140,906651236,14166425,17.2),(90739,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90739,35.49,0.27,125,38203,70,NULL,NULL,'CGCG 187-031',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000117,NULL,'14.5g',0.66,NULL,NULL,NULL,NULL,NULL,1,183.7955417,34.61192,0,NULL,58542212889,914722076,14292532,14.5),(90740,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90740,33.81,0.53,57.8,38204,NULL,NULL,NULL,'CGCG 013-112',NULL,'2009ApJS..182..474S',2009,1,1.53,NULL,'G',0.000033,NULL,'15.1g',0.32,'SB(s)d pec sp',NULL,NULL,NULL,NULL,1,183.798167,-3.44114,0.101,NULL,43016087554,672126368,10501974,15.1),(90741,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90741,34.04,0.49,64.3,38204,75,NULL,'IR','CGCG 013-112',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90742,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90742,34.13,0.46,67.1,38204,NULL,NULL,'Malmquist cor.','CGCG 013-112',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90743,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90743,36.53,0.46,202,38205,70,NULL,NULL,'2MASX J12151197+3242480',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,183.799875,32.71342,0,NULL,58769023997,918265999,14347906,17.2),(90744,'GCLF','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90744,31.19,0.25,17.3,38206,NULL,NULL,'TOM(g) = -7.2 mag','IC 3065',NULL,'2010ApJ...717..603V',2010,1,0.99,NULL,'G',0.000066,NULL,'14.2g',0.77,'S0?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,183.802333,14.43289,0.12,NULL,58180674627,909073041,14204266,14.2),(90745,'GCLF','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90745,31.23,0.32,17.6,38206,NULL,NULL,'TOM(g) = -7.2 mag','IC 3065',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90746,'GCLF','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90746,31.43,0.3,19.3,38206,NULL,NULL,'TOM(u) = -8.4 mag','IC 3065',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90747,'GCLF','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90747,31.51,0.25,20,38206,NULL,NULL,'TOM(z) = -8.53 mag','IC 3065',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90748,'SBF','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90748,31.06,0.14,16.3,38206,74.4,NULL,NULL,'IC 3065',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90749,'SBF','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90749,31.07,0.07,16.4,38206,NULL,NULL,NULL,'IC 3065',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90750,'SBF','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90750,31.08,0.07,16.5,38206,NULL,NULL,'HST ACS VCS','IC 3065',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90751,'GC radius','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90751,30.7,0.05,13.8,38206,NULL,NULL,NULL,'IC 3065',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90752,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90752,34.82,0.47,92.2,38207,NULL,NULL,NULL,'ESO 505- G 028',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15',0.6,'Sb:            HII',NULL,NULL,NULL,NULL,1,183.802917,-27.66047,0.317,NULL,43417176810,678393387,10599896,15),(90753,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90753,34.87,0.2,94.2,38207,74.4,NULL,NULL,'ESO 505- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90754,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90754,35.03,0.43,101,38207,NULL,NULL,'Malmquist cor.','ESO 505- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90755,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90755,37.43,0.46,307,38208,70,NULL,NULL,'2MASX J12151353+0833268',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,183.806417,8.55733,0,NULL,58215265078,909613516,14212711,17.3),(90756,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90756,36.89,0.46,239,38209,70,NULL,NULL,'2MASX J12151363+4204498',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,183.806875,42.08064,0,NULL,58533470082,914585470,14290397,17.4),(90757,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90757,29.48,0.4,7.9,38210,75,NULL,'B','NGC 4204',NULL,'1988NBGC.C....0000T',1988,1,3.6,NULL,'G',0.00001,NULL,'12.9',2.9,'SB(s)dm','in a radial-velocity based grouping',NULL,NULL,NULL,1,183.810167,20.65858,0.065,NULL,58869947245,919842925,14372545,12.9),(90758,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90758,30.61,0.49,13.3,38210,75,NULL,'IR','NGC 4204',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90759,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90759,37.52,0.33,318,38211,70,NULL,NULL,'SDSS J121514.40+284005.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'18.0g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,183.8100417,28.66833,NULL,NULL,58630098512,916095289,14313988,18),(90760,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90760,37.33,0.46,292,38212,70,NULL,NULL,'2MASX J12151486-0052520',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000088,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,183.812,-0.88122,0.033,NULL,42962241121,671285017,10488828,16.8),(90761,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90761,35.13,0.27,106,38213,70,NULL,NULL,'IC 0772',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000047,NULL,'15.5',0.3,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,183.816208333,23.95817,0.095,NULL,58593010760,915515793,14304934,15.5),(90762,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90762,36.64,0.33,213,38214,70,NULL,NULL,'2MASX J12151657+1928386',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.93',0.18,NULL,NULL,NULL,NULL,NULL,1,183.8189583,19.47742,0.042,NULL,58860850677,919700791,14370324,17.93),(90763,'IRAS','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90763,31.44,0.8,19.4,38215,75,NULL,'A82, H','NGC 4206',NULL,'1997ApJS..109..333W',1997,1,5.18,NULL,'G',0.000007,NULL,'13.0g',0.77,'SA(s)bc:       LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,183.820041667,13.02397,0.021,NULL,58139024458,908422257,14194097,13),(90764,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90764,31.13,0.4,16.8,38215,75,NULL,'B','NGC 4206',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90765,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90765,31.29,NULL,18.1,38215,NULL,NULL,NULL,'NGC 4206',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90766,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90766,31.34,0.35,18.5,38215,NULL,NULL,NULL,'NGC 4206',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90767,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90767,31.34,0.4,18.6,38215,NULL,NULL,'mean','NGC 4206',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90768,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90768,31.36,0.42,18.7,38215,65,NULL,NULL,'NGC 4206',NULL,'1980ApJ...238..458M',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90769,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90769,31.36,0.2,18.7,38215,74.4,NULL,NULL,'NGC 4206',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90770,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90770,31.47,0.43,19.7,38215,75,NULL,'3.6 micron, color corrected','NGC 4206',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90771,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90771,31.53,0.47,20.2,38215,NULL,NULL,NULL,'NGC 4206',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90772,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90772,31.53,0.46,20.3,38215,NULL,NULL,'Malmquist cor.','NGC 4206',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90773,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90773,31.55,0.43,20.4,38215,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4206',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90774,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90774,31.59,0.47,20.8,38215,75,NULL,'A82, H, raw','NGC 4206',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90775,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90775,31.62,0.47,21.1,38215,75,NULL,'A82, H, inv','NGC 4206',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90776,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90776,31.73,0.46,22.2,38215,NULL,NULL,'J','NGC 4206',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90777,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90777,31.75,0.47,22.4,38215,75,NULL,'A82, H, cor','NGC 4206',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90778,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90778,31.79,0.47,22.8,38215,NULL,NULL,'H','NGC 4206',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90779,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90779,31.88,0.49,23.8,38215,75,NULL,'IR','NGC 4206',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90780,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90780,31.9,0.45,24,38215,NULL,NULL,'K','NGC 4206',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90781,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90781,38.36,0.21,470,38216,70,NULL,NULL,'SDSS J121518.16+591507.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000151,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,183.825667,59.252,0,NULL,57343592956,895993639,13999900,18.6),(90782,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90782,36.87,0.46,237,38217,70,NULL,NULL,'2MASX J12151825-0106360',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000081,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,183.8260417,-1.10986,0.033,NULL,42961634849,671275544,10488680,16.5),(90783,'Tully est','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90783,32.73,0.8,35.1,38218,75,NULL,'B','HARO 06',NULL,'1988NBGC.C....0000T',1988,1,0.49,'This galaxy was added to CGCG in vol III \'Errors and Omissions\'.','G',0.000007,NULL,'14.9g',0.37,'E0 pec?;WR?    HII','X-ray-bright group member',NULL,NULL,NULL,1,183.8262917,5.76106,0,NULL,58026587729,906665433,14166647,14.9),(90784,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90784,32.53,NULL,32,38218,NULL,NULL,NULL,'HARO 06',NULL,'2014A&A...562A..49M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90785,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90785,36.72,0.46,221,38219,70,NULL,NULL,'SDSS J121518.69+260758.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,183.827917,26.133,0.113,NULL,58649035321,916391176,14318612,18),(90786,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90786,36.99,0.13,250,38220,70,NULL,NULL,'2MASX J12151933+5958034',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000189,NULL,'15.7g',0.47,'E0',NULL,NULL,NULL,NULL,1,183.830583,59.9675,0,NULL,57344155426,896002428,14000037,15.7),(90787,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90787,38.2,0.46,437,38221,70,NULL,NULL,'SDSS J121520.09+424333.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000131,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,183.83375,42.72589,0,NULL,58521066794,914391668,14287369,18.7),(90788,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90788,36.73,0.33,222,38222,70,NULL,NULL,'2MASX J12152039+4942312',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000211,NULL,'15.7g',0.43,'E0',NULL,NULL,NULL,NULL,1,183.8347917,49.70883,0,NULL,57187438680,893553729,13961777,15.7),(90789,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90789,38.14,0.33,425,38223,70,NULL,NULL,'SDSS J121520.54+053201.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000192,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,183.835583333,5.53364,0,NULL,58034079606,906782493,14168476,18.2),(90790,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90790,36.9,0.46,239,38224,70,NULL,NULL,'2MASX J12152068+2724376',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000174,NULL,'17.87',0.19,NULL,NULL,NULL,NULL,NULL,1,183.836083,27.41039,0.096,NULL,58651398195,916428096,14319189,17.87),(90791,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90791,36.99,0.13,250,38225,70,NULL,NULL,'2MASX J12152076+5953024',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,183.836375,59.88406,0,NULL,57344176090,896002751,14000042,17.4),(90792,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90792,37.82,0.46,367,38226,70,NULL,NULL,'2MASX J12152107+6039011',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000172,NULL,'17.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,183.837917,60.65039,0,NULL,57338962378,895921287,13998770,17.2),(90793,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90793,35.89,0.46,151,38227,70,NULL,NULL,'2MASX J12152315+2737346',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,183.846417,27.62622,0.059,NULL,58652052788,916438324,14319348,16.5),(90794,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90794,37.29,0.46,287,38228,70,NULL,NULL,'SDSS J121523.42+075412.4',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000144,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,183.847583,7.90347,0,NULL,58207465735,909491652,14210807,17.6),(90795,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90795,37.61,0.17,332,38229,70,NULL,NULL,'2MASX J12152440+0334547',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,183.851833,3.582,0,NULL,58049138119,907017783,14172152,16.9),(90796,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90796,29.47,0.4,7.8,38230,75,NULL,'B','UGC 07267',NULL,'1988NBGC.C....0000T',1988,1,1.61,'HOLM 352B is a star.','G',0.000023,NULL,'14.5g',0.6,'Sdm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,183.8485417,51.34989,0.048,NULL,57234554606,894289915,13973279,14.5),(90797,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90797,30.55,NULL,12.9,38230,NULL,NULL,NULL,'UGC 07267',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90798,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90798,37.99,0.33,397,38231,70,NULL,NULL,'2MASX J12152544+1555433',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,183.855917,15.92858,0.108,NULL,58179925871,909061341,14204083,17.9),(90799,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90799,37.99,0.33,397,38232,70,NULL,NULL,'SDSS J121525.59+155638.8',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'16.6g',0.3,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,183.856667,15.94411,0.108,NULL,58179920989,909061265,14204082,16.6),(90800,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90800,36.88,0.33,237,38233,70,NULL,NULL,'2MASX J12152628+1247443',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000045,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,183.859541667,12.7955,0.025,NULL,58139009124,908422017,14194094,17.4),(90801,'IRAS','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90801,33.12,0.8,42,38234,75,NULL,'MAT, I','ESO 321- G 016',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.000033,NULL,'13.80',0.7,'SB(rl)bc:','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,183.861416667,-38.14417,0.449,NULL,43275357882,676177466,10565272,13.8),(90802,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90802,31.87,0.32,23.7,38234,85,NULL,'I, raw','ESO 321- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90803,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90803,31.87,0.32,23.7,38234,85,NULL,'I, inv','ESO 321- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90804,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90804,32.01,0.43,25.2,38234,75,NULL,'3.6 micron, color + selection bias corrected','ESO 321- G 016',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90805,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90805,32.11,0.43,26.4,38234,75,NULL,'3.6 micron, color corrected','ESO 321- G 016',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90806,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90806,32.14,0.43,26.8,38234,75,NULL,'MAT, I, raw','ESO 321- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90807,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90807,32.17,0.2,27.2,38234,74.4,NULL,NULL,'ESO 321- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90808,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90808,32.2,0.43,27.6,38234,75,NULL,'MAT, I, inv','ESO 321- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90809,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90809,32.51,0.43,31.8,38234,75,NULL,'MAT, I, cor','ESO 321- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90810,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90810,33.33,0.4,46.4,38234,NULL,NULL,'mean','ESO 321- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90811,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90811,33.39,0.11,47.7,38234,NULL,NULL,NULL,'ESO 321- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90812,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90812,33.6,0.47,52.4,38234,NULL,NULL,'H','ESO 321- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90813,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90813,37.32,0.27,292,38235,70,NULL,NULL,'2MASX J12152757-0225468',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00015,NULL,'16.2g',0.4,'E0',NULL,NULL,NULL,NULL,1,183.8649583,-2.42956,0.049,NULL,43006250739,671972667,10499572,16.2),(90814,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90814,36.99,0.13,250,38236,70,NULL,NULL,'2MASX J12152796+5959122',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000184,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,183.86675,59.98658,0,NULL,57344154664,896002416,14000037,16.3),(90815,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90815,37.91,0.46,381,38237,70,NULL,NULL,'2MASX J12152844+1420593',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000143,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,183.868708333,14.34983,0.12,NULL,58180682052,909073157,14204268,18.5),(90816,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90816,37.61,0.17,332,38238,70,NULL,NULL,'2MASX J12152863+0311027',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000207,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,183.869333,3.18403,0.034,NULL,58045333732,906958339,14171224,16.5),(90817,'IRAS','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90817,34.92,0.8,96.2,38239,75,NULL,'HMCL, I','UGC 07266',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000027,NULL,'14.96',0.6,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,183.870333,24.09244,0.095,NULL,58593615616,915525244,14305081,14.96),(90818,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90818,34.99,0.4,99.4,38239,75,NULL,'HMCL, I, raw','UGC 07266',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90819,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90819,35.14,0.4,106,38239,75,NULL,'HMCL, I, cor','UGC 07266',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90820,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90820,35.15,0.4,107,38239,75,NULL,'HMCL, I, inv','UGC 07266',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90821,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90821,37.04,0.46,256,38240,70,NULL,NULL,'2MASX J12153002+1440313',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000205,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,183.8752917,14.67539,0.098,NULL,58180622979,909072234,14204253,16.2),(90822,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90822,30.31,0.43,11.5,38241,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4207',NULL,'2014MNRAS.444..527S',2014,1,1.59,NULL,'G',0.000002,NULL,'13.3g',0.91,'Scd            HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,183.877083,9.58489,0,NULL,58216789245,909637331,14213083,13.3),(90823,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90823,30.74,0.43,14.1,38241,75,NULL,'3.6 micron, color corrected','NGC 4207',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90824,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90824,31.08,NULL,16.4,38241,NULL,NULL,NULL,'NGC 4207',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90825,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90825,31.14,0.4,16.9,38241,NULL,NULL,'mean','NGC 4207',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90826,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90826,31.14,0.2,16.9,38241,74.4,NULL,NULL,'NGC 4207',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90827,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90827,31.19,0.45,17.3,38241,NULL,NULL,'K','NGC 4207',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90828,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90828,31.22,0.47,17.6,38241,NULL,NULL,'H','NGC 4207',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90829,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90829,31.32,0.46,18.4,38241,NULL,NULL,'J','NGC 4207',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90830,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90830,31.5,0.36,20,38241,NULL,NULL,NULL,'NGC 4207',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90831,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90831,37.87,0.46,375,38242,70,NULL,NULL,'2MASX J12153072+2203394',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,183.877875,22.06106,0.047,NULL,58869008048,919828250,14372316,18.1),(90832,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90832,37.73,0.33,352,38243,70,NULL,NULL,'2MASX J12153097+1913394',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.38',0.18,NULL,NULL,NULL,NULL,NULL,1,183.8789583,19.22761,0.015,NULL,58861695283,919713988,14370531,17.38),(90833,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90833,36.99,0.13,250,38244,70,NULL,NULL,'2MASX J12153105+6014132',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000184,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,183.879417,60.23708,0,NULL,57340833757,895950527,13999226,16.8),(90834,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90834,34.67,0.46,86,38245,70,NULL,NULL,'2MASX J12153177+2443426',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.61',0.17,NULL,NULL,NULL,NULL,NULL,1,183.8822917,24.72853,0.086,NULL,58592116253,915501816,14304715,17.61),(90835,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90835,38.13,0.23,422,38246,70,NULL,NULL,'2MASX J12153202+6227042',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000128,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,183.883208333,62.45128,0.037,NULL,57373669647,896463588,14007243,17.6),(90836,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90836,34.71,NULL,87.4,38247,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07272',NULL,'2010Ap&SS.325..163P',2010,1,1.11,NULL,'G',0.000113,NULL,'16.3g',0.19,'Sc',NULL,NULL,NULL,NULL,1,183.8839583,51.91311,0.03,NULL,57234388170,894287315,13973239,16.3),(90837,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90837,34.72,NULL,88,38247,NULL,NULL,'Dipole + Quadrupole','UGC 07272',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90838,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90838,34.73,NULL,88.3,38247,NULL,NULL,'Dipole','UGC 07272',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90839,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90839,34.74,0.49,88.8,38247,75,NULL,'IR','UGC 07272',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90840,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90840,34.78,NULL,90.2,38247,NULL,NULL,NULL,'UGC 07272',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90841,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90841,37.32,0.27,292,38248,70,NULL,NULL,'2MASX J12153237-0223338',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000167,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,183.8847917,-2.39286,0.049,NULL,43006068827,671969825,10499528,17),(90842,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90842,36.73,0.33,222,38249,70,NULL,NULL,'2MASX J12153276+4940222',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000171,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,183.886333333,49.67294,0,NULL,57187390123,893552970,13961765,16.7),(90843,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90843,37.29,0.46,287,38250,70,NULL,NULL,'2MASX J12153287+0352557',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,183.887,3.88219,0.009,NULL,58049069065,907016704,14172136,17.1),(90844,'Tully est','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90844,29.37,0.8,7.5,38251,75,NULL,'B','UGC 07271',NULL,'1988NBGC.C....0000T',1988,1,1.78,NULL,'G',0.000006,NULL,'14.6g',0.56,'SBd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,183.889333333,43.43411,0,NULL,59057054360,922766474,14418226,14.6),(90845,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90845,31.35,NULL,18.6,38251,NULL,NULL,NULL,'UGC 07271',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90846,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90846,37.85,0.46,371,38252,70,NULL,NULL,'2MASX J12153415+1356353',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000212,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,183.892417,13.94306,0.135,NULL,58169595762,908899933,14201561,16.3),(90847,'IRAS','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90847,32.9,0.8,37.9,38253,75,NULL,'MAT, I','ESO 380- G 006',NULL,'1997ApJS..109..333W',1997,1,3.6,NULL,'G',0.00002,NULL,'12.66',1.5,'(R\'_2)SAB(rs)ab','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,183.892791667,-35.62975,0.313,NULL,43263206655,675987603,10562306,12.66),(90848,'Sosies','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90848,32.34,0.08,29.4,38253,NULL,NULL,NULL,'ESO 380- G 006',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90849,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90849,32.3,0.46,28.8,38253,NULL,NULL,'J','ESO 380- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90850,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90850,32.33,0.47,29.2,38253,NULL,NULL,'H','ESO 380- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90851,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90851,32.38,0.45,30,38253,NULL,NULL,'K','ESO 380- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90852,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90852,32.41,0.43,30.4,38253,75,NULL,'MAT, I, raw','ESO 380- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90853,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90853,32.51,0.32,31.8,38253,85,NULL,'I, raw','ESO 380- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90854,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90854,32.59,0.32,32.9,38253,85,NULL,'I, inv','ESO 380- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90855,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90855,32.63,0.2,33.6,38253,74.4,NULL,NULL,'ESO 380- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90856,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90856,32.71,0.43,34.8,38253,75,NULL,'MAT, I, inv','ESO 380- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90857,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90857,32.71,0.43,34.9,38253,75,NULL,'3.6 micron, color corrected','ESO 380- G 006',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90858,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90858,32.73,0.43,35.2,38253,75,NULL,'MAT, I, cor','ESO 380- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90859,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90859,32.9,0.43,38,38253,75,NULL,'3.6 micron, color + selection bias corrected','ESO 380- G 006',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90860,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90860,33.12,0.4,42.2,38253,NULL,NULL,'mean','ESO 380- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90861,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90861,33.36,0.08,47.1,38253,NULL,NULL,NULL,'ESO 380- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90862,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90862,37.41,0.46,304,38254,70,NULL,NULL,'2MASX J12153433+6026412',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00015,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,183.892917,60.445,0,NULL,57340740536,895949070,13999204,17.3),(90863,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90863,35.13,0.4,106,38255,NULL,NULL,'mean','UGC 07270',NULL,'2007A&A...465...71T',2007,1,1.6,'Multiple SDSS entries describe this object.','G',0.00003,NULL,'14.92',0.4,'Sa',NULL,NULL,NULL,NULL,1,183.8932917,21.83225,0.035,NULL,58868915040,919826797,14372293,14.92),(90864,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90864,35.21,0.47,110,38255,NULL,NULL,'H','UGC 07270',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90865,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90865,35.22,0.45,111,38255,NULL,NULL,'K','UGC 07270',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90866,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90866,35.38,0.46,119,38255,NULL,NULL,'J','UGC 07270',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90867,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90867,36.5,0.46,199,38256,70,NULL,NULL,'2MASX J12153460+2605506',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'15.7g',0.4,'E','Field galaxy',NULL,NULL,NULL,1,183.894167,26.09731,0.113,NULL,58649917480,916404960,14318827,15.7),(90868,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90868,37.71,0.19,348,38257,70,NULL,NULL,'2MASX J12153476+4441481',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,183.894875,44.69683,0,NULL,59057130367,922767661,14418244,17.6),(90869,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90869,38.36,0.21,470,38258,70,NULL,NULL,'2MASX J12153496+5905382',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,183.895375,59.09389,0,NULL,57343112353,895986130,13999783,17.4),(90870,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90870,36.87,0.46,237,38259,70,NULL,NULL,'2MASX J12153667+6018262',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000177,NULL,'16.7g',0.36,NULL,NULL,NULL,NULL,NULL,1,183.902917,60.30731,0,NULL,57340812854,895950200,13999221,16.7),(90871,'IRAS','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90871,34.85,0.8,93.4,38260,75,NULL,'HMCL, I','CGCG 128-064',NULL,'1997ApJS..109..333W',1997,1,0.6,NULL,'G',0.000027,NULL,'15.1',0.2,'S0',NULL,NULL,NULL,NULL,1,183.903833333,21.90928,0.035,NULL,58869136444,919830256,14372347,15.1),(90872,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90872,34.69,0.4,86.6,38260,75,NULL,'HMCL, I, raw','CGCG 128-064',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90873,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90873,34.88,0.4,94.4,38260,75,NULL,'HMCL, I, inv','CGCG 128-064',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90874,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90874,34.93,0.4,96.9,38260,75,NULL,'HMCL, I, cor','CGCG 128-064',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90875,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90875,35.42,0.46,122,38261,70,NULL,NULL,'CGCG 158-052',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000097,NULL,'15.2g',0.57,'E','Isolated elliptical galaxy',NULL,NULL,NULL,1,183.9045,27.01197,0.101,NULL,58652607834,916446997,14319484,15.2),(90876,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90876,35.39,0.64,120,38262,70,NULL,NULL,'MCG -01-31-010',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000113,NULL,'16',0.5,'SA(s)a?',NULL,NULL,NULL,NULL,1,183.9064583,-7.78928,0.129,NULL,43194876748,674919949,10545624,16),(90877,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90877,35.13,0.27,106,38263,70,NULL,NULL,'NGC 4213',NULL,'2015arXiv151105856S',2015,1,1.7,NULL,'G',0.000073,NULL,'13.48',1.7,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,183.9065,23.98189,0.095,NULL,58593481832,915523153,14305049,13.48),(90878,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90878,35.1,0.45,105,38263,NULL,NULL,'K','NGC 4213',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90879,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90879,35.13,0.4,106,38263,NULL,NULL,'mean','NGC 4213',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90880,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90880,38.13,0.23,422,38264,70,NULL,NULL,'2MASX J12153778+6228573',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000178,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,183.907625,62.48269,0.037,NULL,57373669574,896463587,14007243,17.3),(90881,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90881,37.32,0.27,292,38265,70,NULL,NULL,'2MASX J12153804-0225338',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000161,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,183.9084583,-2.42608,0.049,NULL,43006067174,671969799,10499528,16.9),(90882,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90882,37.56,0.27,325,38266,70,NULL,NULL,'2MASX J12153817+1709452',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,183.909041667,17.16253,0.081,NULL,58127207571,908237618,14191212,17.2),(90883,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90883,36.88,0.33,237,38267,70,NULL,NULL,'2MASX J12153852+1245183',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000162,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,183.9105,12.75494,0.025,NULL,58141024007,908453500,14194585,16.4),(90884,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90884,37.73,0.33,352,38268,70,NULL,NULL,'2MASX J12153873+1911464',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,183.9115,19.19614,0.015,NULL,58861695550,919713992,14370531,17),(90885,'Brightest Stars','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90885,27.45,0.9,3.09,38269,NULL,NULL,'3, B, blue stars','NGC 4214',NULL,'1994MNRAS.271..530R',1994,1,8.5,'IRAS F12131+3636 (in FSC version 1) was removed from version 2.','G',0.00001,NULL,'10.24',6.6,'IAB(s)m        HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,183.913208333,36.32689,0,NULL,58541352173,914708627,14292322,10.24),(90886,'Brightest Stars','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90886,27.49,0.88,3.15,38269,NULL,NULL,'3, B, blue stars','NGC 4214',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90887,'Brightest Stars','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90887,28.06,NULL,4.09,38269,NULL,NULL,NULL,'NGC 4214',NULL,'1997AstL...23..378M',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90888,'Brightest Stars','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90888,29.02,NULL,6.37,38269,NULL,NULL,'Photographic','NGC 4214',NULL,'1982ApJ...256..339S',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90889,'CMD','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90889,27.2,0.04,2.75,38269,NULL,NULL,NULL,'NGC 4214',NULL,'2010ApJ...721..297M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90890,'PNLF','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90890,27.52,NULL,3.19,38269,NULL,NULL,NULL,'NGC 4214',NULL,'2010Ap&SS.330..123D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90891,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90891,27.13,0.15,2.7,38269,NULL,NULL,NULL,'NGC 4214',NULL,'2002AJ....124..811D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90892,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90892,27.16,0.16,2.7,38269,NULL,NULL,NULL,'NGC 4214',NULL,'2014A&A...566A..71L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90893,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90893,27.26,0.05,2.84,38269,NULL,NULL,NULL,'NGC 4214',NULL,'2013AstBu..68..125M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90894,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90894,27.33,0.03,2.92,38269,NULL,NULL,NULL,'NGC 4214',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90895,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90895,27.34,0.08,2.93,38269,74.4,NULL,NULL,'NGC 4214',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90896,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90896,27.34,0.16,2.94,38269,NULL,NULL,NULL,'NGC 4214',NULL,'2002AJ....123.1307M',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90897,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90897,27.35,0.04,2.95,38269,NULL,NULL,'I','NGC 4214',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90898,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90898,27.39,0.1,3.01,38269,NULL,NULL,NULL,'NGC 4214',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90899,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90899,27.41,0.03,3.04,38269,NULL,NULL,'I','NGC 4214',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90900,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90900,27.57,0.12,3.26,38269,NULL,NULL,NULL,'NGC 4214',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90901,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90901,26.98,NULL,2.49,38269,NULL,NULL,'LEDA [April 2006]','NGC 4214',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90902,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90902,27.6,0.5,3.31,38269,NULL,18.45,'SN 1954A host','NGC 4214',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90903,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90903,27.71,0.4,3.5,38269,75,NULL,'B','NGC 4214',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90904,'Tully est','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90904,31.13,0.8,16.8,38270,75,NULL,'B','NGC 4208',NULL,'1988NBGC.C....0000T',1988,1,3.2,'HMS has V = 2125 +- 61 km/sec; UZC has 835 +- 36 km/sec.','G',0.000033,NULL,'11.83',1.9,'SAc:;LINER     HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,183.914,13.9015,0.135,NULL,58169602494,908900038,14201563,11.83),(90905,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90905,30.96,0.43,15.6,38270,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4208',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90906,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90906,31.04,NULL,16.1,38270,NULL,NULL,NULL,'NGC 4208',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90907,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90907,31.06,0.43,16.3,38270,75,NULL,'3.6 micron, color corrected','NGC 4208',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90908,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90908,31.08,0.47,16.5,38270,NULL,NULL,NULL,'NGC 4208',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90909,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90909,31.09,0.2,16.5,38270,74.4,NULL,NULL,'NGC 4208',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90910,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90910,31.18,0.45,17.3,38270,NULL,NULL,'Malmquist cor.','NGC 4208',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90911,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90911,31.19,0.92,17.3,38270,NULL,NULL,'CO','NGC 4208',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90912,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90912,31.3,0.7,18.2,38270,NULL,NULL,'HI','NGC 4208',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90913,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90913,31.72,0.35,22.1,38270,NULL,NULL,NULL,'NGC 4208',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90914,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90914,31.98,0.3,24.9,38270,55,NULL,'B','NGC 4208',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90915,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90915,35,0.62,100,38271,70,NULL,NULL,'2MASX J12153994-5155247',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,183.916416667,-51.92356,0.461,NULL,44621077365,697204333,10893817,16.6),(90916,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90916,37.37,0.46,297,38272,70,NULL,NULL,'2MASX J12154025+4533531',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000192,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,183.917625,45.56478,0,NULL,59058623901,922790998,14418609,16.5),(90917,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90917,37.33,0.46,292,38273,70,NULL,NULL,'2MASX J12154079+1340278',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,183.92,13.67425,0.087,NULL,58169749229,908902331,14201598,17.6),(90918,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90918,38.14,0.33,425,38274,70,NULL,NULL,'2MASX J12154083+0532347',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000191,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,183.920167,5.54297,0,NULL,58034198714,906784354,14168505,17.6),(90919,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90919,36.64,0.33,213,38275,70,NULL,NULL,'2MASX J12154093+1933384',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.40',0.14,NULL,NULL,NULL,NULL,NULL,1,183.920625,19.56069,0.037,NULL,58861648751,919713261,14370519,18.4),(90920,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90920,37.61,0.17,332,38276,70,NULL,NULL,'2MASX J12154097+0324097',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000172,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,183.920667,3.40269,0.01,NULL,58048846358,907013224,14172081,17.1),(90921,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90921,35.95,0.49,155,38277,75,NULL,'IR','UGC 07273',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.00001,NULL,'15.2g',0.33,'Sbc(s)II','Group member',NULL,NULL,NULL,1,183.92225,8.13403,0,NULL,58207338674,909489666,14210776,15.2),(90922,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90922,38.55,0.33,514,38278,70,NULL,NULL,'2MASX J12154149+2655346',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,183.92275,26.92628,0.093,NULL,58652596789,916446824,14319481,18.5),(90923,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90923,38.53,0.46,509,38279,70,NULL,NULL,'SBS 1213+516',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000192,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,183.925708333,51.39172,0.031,NULL,57234545762,894289777,13973277,17.3),(90924,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90924,37.69,0.46,345,38280,70,NULL,NULL,'2MASX J12154298+0106497',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000084,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,183.929,1.11375,0.028,NULL,57990135802,906095871,14157747,17.7),(90925,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90925,37.71,0.19,348,38281,70,NULL,NULL,'2MASX J12154376+4431371',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,183.9325,44.52694,0,NULL,59057352642,922771135,14418298,17.4),(90926,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90926,37.56,0.27,325,38282,70,NULL,NULL,'2MASX J12154383+1709178',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000197,NULL,'16.90',0.29,NULL,NULL,NULL,NULL,NULL,1,183.932625,17.15492,0.081,NULL,58127207819,908237622,14191212,16.9),(90927,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90927,37.08,0.33,260,38283,70,NULL,NULL,'SDSS J121544.57+121249.8',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000172,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,183.93575,12.21383,0.03,NULL,58141404219,908459440,14194678,16.9),(90928,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90928,37.13,0.46,267,38284,70,NULL,NULL,'2MASX J12154472+2623097',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000132,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,183.936417,26.38611,0.085,NULL,58649980895,916405951,14318842,17.6),(90929,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90929,37.61,0.17,332,38285,70,NULL,NULL,'2MASX J12154518+0314567',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000172,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,183.938333,3.24919,0.034,NULL,58048872156,907013627,14172087,17.8),(90930,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90930,37,0.46,251,38286,70,NULL,NULL,'2MASX J12154534+2835237',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000093,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,183.938875,28.58997,0.123,NULL,58637633989,916213031,14315828,16.4),(90931,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90931,31.13,0.4,16.8,38287,75,NULL,'B','IC 3074',NULL,'1988NBGC.C....0000T',1988,1,2.69,NULL,'G',0.000002,NULL,'14.73',0.25,'SB(s)dm: sp    HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,183.942458333,10.69919,0,NULL,58210535067,909539610,14211556,14.73),(90932,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90932,32.56,NULL,32.5,38287,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 3074',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90933,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90933,32.57,NULL,32.7,38287,NULL,NULL,'Dipole','IC 3074',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90934,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90934,32.57,NULL,32.7,38287,NULL,NULL,'Dipole + Quadrupole','IC 3074',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90935,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90935,32.65,NULL,33.8,38287,NULL,NULL,NULL,'IC 3074',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90936,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90936,32.75,0.36,35.5,38287,NULL,NULL,NULL,'IC 3074',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90937,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90937,33.01,0.83,39.9,38287,NULL,NULL,'Malmquist cor.','IC 3074',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90938,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90938,33.12,0.2,42.1,38287,74.4,NULL,NULL,'IC 3074',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90939,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90939,33.34,0.71,46.5,38287,NULL,NULL,NULL,'IC 3074',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90940,'Tully est','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90940,32.02,0.8,25.3,38288,75,NULL,'B','NGC 4218',NULL,'1988NBGC.C....0000T',1988,1,0.92,NULL,'G',0.000006,NULL,'13.8g',0.64,'Sa?','in a radial-velocity based grouping',NULL,NULL,NULL,1,183.943375,48.13083,0,NULL,57191806617,893621978,13962843,13.8),(90941,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90941,30.41,0.43,12.1,38288,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4218',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90942,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90942,30.62,0.43,13.3,38288,75,NULL,'3.6 micron, color corrected','NGC 4218',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90943,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90943,30.75,0.2,14.1,38288,74.4,NULL,NULL,'NGC 4218',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90944,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90944,31.04,0.4,16.2,38288,NULL,NULL,'mean','NGC 4218',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90945,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90945,31.19,0.36,17.3,38288,NULL,NULL,NULL,'NGC 4218',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90946,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90946,31.75,0.47,22.4,38288,NULL,NULL,'H','NGC 4218',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90947,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90947,31.91,0.46,24.1,38288,NULL,NULL,'J','NGC 4218',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90948,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90948,26.01,0.05,1.6,38289,NULL,NULL,'I','CGCG 269-049',NULL,'2009ApJS..183...67D',2009,1,0.95,'Multiple SDSS entries describe this object.','G',0.000011,NULL,'15.2g',0.57,'LSB',NULL,NULL,NULL,NULL,1,183.9442917,52.38719,0.018,1,57215742909,893995982,13968687,15.2),(90949,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90949,27.55,0.08,3.23,38289,74.4,NULL,NULL,'CGCG 269-049',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90950,'TRGB','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90950,28.45,0.16,4.9,38289,NULL,NULL,'I','CGCG 269-049',NULL,'2008ApJ...675..194C',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90951,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90951,38.09,0.33,414,38290,70,NULL,NULL,'2MASX J12154663+3911317',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,183.944167,39.19208,0,NULL,58580339970,915317812,14301840,17.8),(90952,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90952,37.37,0.46,298,38291,70,NULL,NULL,'2MASX J12154742+0204117',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000162,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,183.9474583,2.06997,0.006,NULL,58043223192,906925362,14170708,17.1),(90953,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90953,33.77,NULL,56.7,38292,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG +09-20-132',NULL,'2010Ap&SS.325..163P',2010,1,1.26,'Matthews (2000A&AS..143..421M) says v=3487 km/sec may refer to FGC 1392.','G',0.000027,NULL,'16.6g',0.16,'Sd',NULL,NULL,NULL,NULL,1,183.9487917,52.12572,0.043,NULL,57234347536,894286680,13973229,16.6),(90954,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90954,33.78,NULL,56.9,38292,NULL,NULL,'Dipole + Quadrupole','MCG +09-20-132',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90955,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90955,33.79,NULL,57.3,38292,NULL,NULL,'Dipole','MCG +09-20-132',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90956,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90956,33.81,NULL,57.7,38292,NULL,NULL,NULL,'MCG +09-20-132',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90957,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90957,37.94,0.46,387,38293,70,NULL,NULL,'SDSS J121547.75+573752.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000142,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,183.9489583,57.63139,0,NULL,57397399323,896834364,14013036,18.4),(90958,'IRAS','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90958,34.81,0.8,91.6,38294,75,NULL,'MAT, I','ESO 321- G 017',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'15.93',0.24,'SB(s)cd? sp',NULL,NULL,NULL,NULL,1,183.949666667,-42.74289,0.553,NULL,43219161776,675299402,10551553,15.93),(90959,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90959,34.47,0.66,78.5,38294,NULL,NULL,'Malmquist cor.','ESO 321- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90960,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90960,34.5,0.32,79.3,38294,85,NULL,'I, raw','ESO 321- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90961,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90961,34.53,0.32,80.5,38294,85,NULL,'I, inv','ESO 321- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90962,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90962,34.56,0.43,81.5,38294,75,NULL,'MAT, I, raw','ESO 321- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90963,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90963,34.58,0.49,82.6,38294,75,NULL,'IR','ESO 321- G 017',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90964,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90964,34.59,NULL,82.9,38294,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 321- G 017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90965,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90965,34.6,NULL,83.3,38294,NULL,NULL,'Dipole + Quadrupole','ESO 321- G 017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90966,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90966,34.61,NULL,83.5,38294,NULL,NULL,'Dipole','ESO 321- G 017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90967,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90967,34.65,NULL,85.1,38294,NULL,NULL,NULL,'ESO 321- G 017',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90968,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90968,34.68,0.6,86.2,38294,NULL,NULL,NULL,'ESO 321- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90969,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90969,34.72,0.2,87.9,38294,74.4,NULL,NULL,'ESO 321- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90970,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90970,34.72,0.43,88,38294,75,NULL,'MAT, I, inv','ESO 321- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90971,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90971,34.76,0.43,89.5,38294,75,NULL,'MAT, I, cor','ESO 321- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90972,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90972,37.79,0.46,361,38295,70,NULL,NULL,'2MASX J12154885+1540598',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000177,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,183.953625,15.68328,0.088,NULL,58179875815,909060559,14204071,16.6),(90973,'FP','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,'R',90973,38.09,0.33,414,38296,70,NULL,NULL,'2MASX J12154905+3913487',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000193,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,183.9542917,39.23011,0,NULL,58582237247,915347456,14302304,16.8),(90974,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90974,37.51,0.5,317,38297,NULL,NULL,'Malmquist cor.','2MASX J12154918+1311478',NULL,'2009ApJS..182..474S',2009,1,0.44,NULL,'G',0.000023,NULL,'17.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,183.954917,13.19675,0.022,NULL,58138933887,908420841,14194075,17.5),(90975,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90975,37.57,0.48,327,38297,NULL,NULL,NULL,'2MASX J12154918+1311478',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90976,'Tully-Fisher','2016-12-15 15:14:56','2016-12-16 11:20:06','1',NULL,NULL,90976,37.61,0.2,333,38297,74.4,NULL,NULL,'2MASX J12154918+1311478',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90977,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,90977,35.16,0.49,108,38298,70,NULL,NULL,'2MASX J12154977-5140426',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.0001,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,183.9575,-51.6785,0.461,NULL,44620898213,697201534,10893773,16.2),(90978,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',90978,37.71,0.19,348,38299,70,NULL,NULL,'SDSS J121550.04+443804.1',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000171,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,183.9585417,44.63447,0,NULL,59057143086,922767860,14418247,17.8),(90979,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',90979,37.86,0.46,374,38300,70,NULL,NULL,'2MASX J12155040+2248248',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,183.96,22.80678,0.064,NULL,58864085694,919751338,14371114,18.1),(90980,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',90980,38.55,0.33,514,38301,70,NULL,NULL,'2MASX J12155038+2701377',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000169,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,183.960083333,27.02725,0.093,NULL,58652620509,916447195,14319487,17),(90981,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',90981,37.97,0.33,392,38302,70,NULL,NULL,'2MASX J12155071+1737278',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000167,NULL,'17.36',0.21,'D/cD',NULL,NULL,NULL,NULL,1,183.961417,17.62433,0.083,NULL,58128209044,908253266,14191457,17.36),(90982,'IRAS','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,90982,31.41,0.8,19.2,38303,75,NULL,'W91CL, r','NGC 4217',NULL,'1997ApJS..109..333W',1997,1,5.2,NULL,'G',0.00001,NULL,'12.04',1.5,'SAb sp         HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,183.962083,47.09178,0,NULL,57177831531,893403617,13959431,12.04),(90983,'IRAS','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,90983,31.42,0.8,19.2,38303,75,NULL,'A82, H','NGC 4217',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90984,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',90984,31.04,NULL,16.1,38303,NULL,NULL,'I, Hubble-type-TF','NGC 4217',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90985,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,90985,31.05,0.08,16.3,38303,NULL,NULL,NULL,'NGC 4217',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90986,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,90986,31.15,0.4,17,38303,75,NULL,'B','NGC 4217',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90987,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',90987,31.17,NULL,17.1,38303,NULL,NULL,'I','NGC 4217',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90988,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,90988,31.16,0.43,17.1,38303,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4217',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90989,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,90989,31.24,NULL,17.7,38303,NULL,NULL,'I','NGC 4217',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90990,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',90990,31.25,0.4,17.8,38303,75,NULL,NULL,'NGC 4217',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90991,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,90991,31.3,0.43,18.2,38303,75,NULL,'3.6 micron, color corrected','NGC 4217',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90992,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',90992,31.38,NULL,18.9,38303,NULL,NULL,'B, Hubble-type-TF','NGC 4217',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90993,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,90993,31.45,0.35,19.5,38303,NULL,NULL,NULL,'NGC 4217',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90994,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,90994,31.47,0.38,19.7,38303,75,NULL,'W91CL, r, raw','NGC 4217',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90995,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,90995,31.52,0.47,20.1,38303,75,NULL,'A82, H, raw','NGC 4217',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90996,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,90996,31.52,0.2,20.1,38303,74.4,NULL,NULL,'NGC 4217',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90997,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,90997,31.55,NULL,20.4,38303,NULL,NULL,'B','NGC 4217',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90998,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,90998,31.6,0.38,20.9,38303,75,NULL,'W91CL, r, cor','NGC 4217',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90999,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',90999,31.62,NULL,21.1,38303,NULL,NULL,'B','NGC 4217',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91000,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91000,31.62,0.38,21.1,38303,75,NULL,'W91CL, r, inv','NGC 4217',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91001,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91001,31.66,0.47,21.5,38303,75,NULL,'A82, H, inv','NGC 4217',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91002,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91002,31.7,0.47,21.9,38303,75,NULL,'A82, H, cor','NGC 4217',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91003,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91003,32.01,0.49,25.3,38303,75,NULL,'IR','NGC 4217',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91004,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91004,37.14,0.46,269,38304,70,NULL,NULL,'2MASX J12155161+2225068',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,183.9652083,22.41869,0.05,NULL,58863989705,919749839,14371091,18),(91005,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91005,37.32,0.46,291,38305,70,NULL,NULL,'2MASX J12155169+1955428',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.16',0.18,NULL,NULL,NULL,NULL,NULL,1,183.965667,19.92864,0.044,NULL,58869561397,919836896,14372451,18.16),(91006,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91006,37.52,0.33,318,38306,70,NULL,NULL,'2MASX J12155187+2835397',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00014,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,183.966125,28.59436,0.123,NULL,58637567995,916211999,14315812,16.4),(91007,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91007,35.96,0.46,156,38307,70,NULL,NULL,'VCC 0165',NULL,'2015arXiv151105856S',2015,1,1.05,NULL,'G',0.000143,NULL,'14.87',0.72,'S0_1_(0,2):','Group member',NULL,NULL,NULL,1,183.972,13.21586,0.022,NULL,58169116912,908892451,14201444,14.87),(91008,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91008,32.97,0.49,39.3,38308,75,NULL,'IR','ESO 321- G 018',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.000033,NULL,'14.13',1.1,'IB(s)m','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,183.976167,-38.09342,0.441,NULL,43283544904,676305389,10567271,14.13),(91009,'IRAS','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91009,31.44,0.8,19.4,38309,75,NULL,'A82, H','NGC 4216',NULL,'1997ApJS..109..333W',1997,1,8.1,NULL,'G',0.000013,NULL,'10.99',1.8,'SAB(s)b:   HII/LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,183.976833333,13.14939,0.022,NULL,58138921940,908420655,14194072,10.99),(91010,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91010,30.65,NULL,13.5,38309,NULL,NULL,NULL,'NGC 4216',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91011,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91011,30.75,0.35,14.1,38309,NULL,NULL,NULL,'NGC 4216',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91012,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91012,30.8,NULL,14.5,38309,NULL,NULL,'B','NGC 4216',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91013,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91013,30.81,0.42,14.5,38309,65,NULL,NULL,'NGC 4216',NULL,'1980ApJ...238..458M',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91014,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91014,30.89,0.92,15.1,38309,NULL,NULL,'CO','NGC 4216',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91015,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91015,31.01,0.7,15.9,38309,NULL,NULL,'HI','NGC 4216',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91016,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91016,31.13,0.4,16.8,38309,75,NULL,'B','NGC 4216',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91017,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91017,31.22,0.47,17.6,38309,75,NULL,'A82, H, raw','NGC 4216',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91018,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91018,31.34,0.3,18.5,38309,55,NULL,'B','NGC 4216',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91019,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91019,31.46,0.47,19.6,38309,75,NULL,'A82, H, cor','NGC 4216',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91020,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91020,31.46,0.47,19.6,38309,75,NULL,'A82, H, inv','NGC 4216',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91021,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91021,31.78,NULL,22.7,38310,NULL,NULL,NULL,'NGC 4215',NULL,'1999MNRAS.304..595G',1999,1,1.9,NULL,'G',0.000017,NULL,'13.00',0.7,'SA(r)0+: sp','X-ray-bright group member',NULL,NULL,NULL,1,183.97725,6.40114,0,NULL,58027982734,906687230,14166987,13),(91022,'Tully est','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91022,32.73,0.8,35.1,38310,75,NULL,'B','NGC 4215',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91023,'IRAS','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91023,33.33,0.8,46.3,38311,75,NULL,'MAT, I','ESO 441- G 024',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000023,NULL,'15',0.3,'Sb:',NULL,NULL,NULL,NULL,1,183.9837917,-29.05628,0.249,NULL,43375345406,677739771,10589683,15),(91024,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91024,33.06,0.32,40.9,38311,85,NULL,'I, inv','ESO 441- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91025,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91025,33.07,0.32,41.1,38311,85,NULL,'I, raw','ESO 441- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91026,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91026,33.24,0.64,44.4,38311,NULL,NULL,'Malmquist cor.','ESO 441- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91027,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91027,33.32,0.43,46,38311,75,NULL,'MAT, I, raw','ESO 441- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91028,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91028,33.33,0.2,46.3,38311,74.4,NULL,NULL,'ESO 441- G 024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91029,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91029,33.34,0.43,46.6,38311,75,NULL,'MAT, I, inv','ESO 441- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91030,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91030,33.43,0.43,48.5,38311,75,NULL,'MAT, I, cor','ESO 441- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91031,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91031,33.49,0.57,49.9,38311,NULL,NULL,NULL,'ESO 441- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91032,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91032,29.87,NULL,9.42,38312,NULL,NULL,NULL,'VCC 0169',NULL,'2013AJ....145..101K',2013,1,0.8,'Multiple SDSS entries describe this source.','G',0.000002,NULL,'16.5:',0.4,'ImV','Group member',NULL,NULL,NULL,1,183.984375,9.64925,0,NULL,58216614142,909634595,14213040,16.5),(91033,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91033,29.8,NULL,9.12,38313,NULL,NULL,NULL,'IC 3077',NULL,'2013AJ....145..101K',2013,1,1.14,NULL,'G',0.000033,NULL,'15.0g',0.72,'Sd             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,183.98475,14.43303,0.098,NULL,58180762229,909074409,14204287,15),(91034,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91034,37.76,0.46,357,38314,70,NULL,NULL,'2MASX J12155688+1624038',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,183.987166667,16.40117,0.084,NULL,58172800258,908950004,14202343,17),(91035,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91035,37.26,0.46,283,38315,70,NULL,NULL,'2MASX J12155694+4731521',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000188,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,183.9872083,47.53111,0,NULL,57191514338,893617411,13962772,16.5),(91036,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91036,37.61,0.17,332,38316,70,NULL,NULL,'2MASX J12155719+0311211',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000199,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,183.988291667,3.18936,0.034,NULL,58048863231,907013487,14172085,16.8),(91037,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91037,38.18,0.46,433,38317,70,NULL,NULL,'SDSS J121557.32+351726.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,183.988875,35.29061,0,NULL,58542782690,914730979,14292671,18.6),(91038,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91038,38.36,0.21,470,38318,70,NULL,NULL,'2MASX J12155750+5910566',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,183.989833333,59.18231,0,NULL,57343595039,895993672,13999901,17.9),(91039,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91039,34.15,0.46,67.5,38319,70,NULL,NULL,'ARK 354',NULL,'2015arXiv151105856S',2015,1,0.88,NULL,'G',0.00015,NULL,'14.5g',0.47,'Sa;BrClG',NULL,NULL,NULL,NULL,1,183.990583,3.30592,0.01,NULL,58048904858,907014138,14172095,14.5),(91040,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91040,37.61,0.17,332,38320,70,NULL,NULL,'2MASX J12155873+0322141',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000177,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,183.99475,3.37064,0.01,NULL,58048850698,907013292,14172082,17.4),(91041,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91041,37.97,0.33,392,38321,70,NULL,NULL,'SDSS J121559.08+173456.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,183.9962083,17.58231,0.083,NULL,58128265129,908254142,14191470,18.6),(91042,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91042,35.32,0.4,116,38322,NULL,NULL,'mean','UGC 07286',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00003,NULL,'14.83',0.6,'Sab            AGN','Field galaxy',NULL,NULL,NULL,1,183.996875,27.44219,0.096,NULL,58651402888,916428170,14319190,14.83),(91043,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91043,35.93,0.47,153,38322,NULL,NULL,'H','UGC 07286',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91044,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91044,32.53,NULL,32,38323,NULL,NULL,NULL,'VCC 0172',NULL,'2014A&A...562A..49M',2014,1,1.08,NULL,'G',0.000023,NULL,'14.9g',0.49,'IAm?           HII','X-ray-bright group member',NULL,NULL,NULL,1,184.0015417,4.65097,0.037,NULL,58033919944,906779999,14168437,14.9),(91045,'SNIa','2016-12-15 15:14:57','2016-12-16 11:20:06','1','PS1 SN PS11jo','N',91045,41.34,0.15,1400,38324,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11jo HOST',0.3307,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91046,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91046,36.78,0.46,227,38325,70,NULL,NULL,'2MASX J12160218+1229528',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000186,NULL,'16.1g',0.37,'E0',NULL,NULL,NULL,NULL,1,184.00925,12.49814,0.03,NULL,58141002916,908453170,14194580,16.1),(91047,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91047,36.2,0.53,174,38326,NULL,NULL,'Malmquist cor.','SDSS J121603.25+140046.4',NULL,'2009ApJS..182..474S',2009,1,0.55,NULL,'G',0.000013,NULL,'17.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,184.0135417,14.01289,0.135,NULL,58169317095,908895579,14201493,17.7),(91048,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91048,36.23,0.52,176,38326,NULL,NULL,NULL,'SDSS J121603.25+140046.4',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91049,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91049,36.96,0.46,247,38327,70,NULL,NULL,'2MASX J12160347+3047153',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000201,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,184.014625,30.7875,NULL,NULL,58629196938,916081202,14313768,16.6),(91050,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91050,37.04,0.33,256,38328,70,NULL,NULL,'2MASX J12160364+4520400',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000169,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,184.015167,45.34444,0,NULL,59058642621,922791290,14418613,16.2),(91051,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91051,37.85,0.46,372,38329,70,NULL,NULL,'2MASX J12160454+0907410',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000176,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,184.019041667,9.12814,0,NULL,58216352492,909630507,14212976,17.1),(91052,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91052,37.04,0.33,256,38330,70,NULL,NULL,'2MASX J12160572+4521490',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000179,NULL,'16.4g',0.43,NULL,NULL,NULL,NULL,NULL,1,184.024083,45.36381,0,NULL,59058639116,922791236,14418613,16.4),(91053,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91053,37.59,0.46,329,38331,70,NULL,NULL,'2MASX J12160619+0929096',NULL,'2015arXiv151105856S',2015,1,0.42,'TXS codes: confusion(C)','G',NULL,NULL,'16.3g',0.35,'candidate      BLLAC',NULL,NULL,NULL,'BL Lac ?',1,184.025875,9.486,0,NULL,58216696346,909635880,14213060,16.3),(91054,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91054,37.81,0.46,365,38332,70,NULL,NULL,'2MASX J12160659+6035132',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000171,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,184.0277917,60.58703,0,NULL,57338867967,895919811,13998747,16.5),(91055,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91055,37.71,0.19,348,38333,70,NULL,NULL,'2MASX J12160672+4438560',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000187,NULL,'16.2g',0.43,'E0',NULL,NULL,NULL,NULL,1,184.028125,44.649,0,NULL,59057132572,922767696,14418245,16.2),(91056,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91056,37.82,0.46,367,38334,70,NULL,NULL,'SDSS J121606.85+580351.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,184.028583,58.06442,0,NULL,57329710338,895776724,13996511,18.1),(91057,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91057,36.24,0.79,177,38335,70,NULL,NULL,'2MASX J12160726-5209584',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,184.0302917,-52.16619,0.461,NULL,44620910627,697201728,10893777,17),(91058,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91058,37.97,0.46,393,38336,70,NULL,NULL,'2MASX J12160752+0039231',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000085,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,184.031333,0.65631,0.05,NULL,57989753201,906089893,14157654,17.7),(91059,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91059,37.64,0.46,337,38337,70,NULL,NULL,'SDSS J121607.58+011601.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,184.031583,1.26711,0.023,NULL,57989944111,906092876,14157701,18.2),(91060,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91060,37.56,0.27,325,38338,70,NULL,NULL,'2MASX J12160846+1715078',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,184.035291667,17.25217,0.076,NULL,58127285479,908238835,14191231,16.7),(91061,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91061,36.07,0.53,164,38339,70,NULL,NULL,'2MASX J12160876-1831464',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.99',NULL,NULL,NULL,NULL,NULL,NULL,1,184.036583,-18.52958,0.097,NULL,43023443299,672241301,10503770,15.99),(91062,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91062,35.62,0.46,133,38340,70,NULL,NULL,'MCG +09-20-135',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000186,NULL,'15.2g',0.55,'E',NULL,NULL,NULL,NULL,1,184.038,55.45014,0,NULL,57212487780,893945121,13967892,15.2),(91063,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91063,37.61,0.17,332,38341,70,NULL,NULL,'SDSS J121609.30+031139.1',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,184.03875,3.19425,0.014,NULL,58048861069,907013454,14172085,17.5),(91064,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91064,37.34,0.33,293,38342,70,NULL,NULL,'2MASX J12160936+3333352',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,184.039125,33.55978,0,NULL,58768408225,918256378,14347755,17.2),(91065,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91065,37.75,0.46,354,38343,70,NULL,NULL,'2MASX J12160946+2535587',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.12',0.16,NULL,NULL,NULL,NULL,NULL,1,184.039625,25.59964,0.063,NULL,58647059414,916360303,14318129,18.12),(91066,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91066,37.12,0.46,266,38344,70,NULL,NULL,'2MASX J12161053+5752376',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000162,NULL,'16.4g',0.32,'AGN',NULL,NULL,NULL,NULL,1,184.044083,57.87703,0,NULL,57329401781,895771902,13996435,16.4),(91067,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91067,37.34,0.33,293,38345,70,NULL,NULL,'2MASX J12161120+3335092',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000184,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,184.046958333,33.586,0,NULL,58768407077,918256360,14347755,17.5),(91068,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91068,34.68,0.4,86.3,38346,NULL,NULL,NULL,'FGC 1395',NULL,'2009ApJS..182..474S',2009,1,1.03,NULL,'G',0.000017,NULL,'16.9g',0.14,'Sd',NULL,NULL,NULL,NULL,1,184.04875,13.99236,0.135,NULL,58169318732,908895605,14201493,16.9),(91069,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91069,34.72,0.2,87.9,38346,74.4,NULL,NULL,'FGC 1395',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91070,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91070,34.85,0.37,93.3,38346,NULL,NULL,'Malmquist cor.','FGC 1395',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91071,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91071,35.13,0.49,106,38346,75,NULL,'IR','FGC 1395',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91072,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91072,35.25,NULL,112,38346,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1395',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91073,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91073,35.25,NULL,112,38346,NULL,NULL,'Dipole + Quadrupole','FGC 1395',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91074,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91074,35.27,NULL,113,38346,NULL,NULL,'Dipole','FGC 1395',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91075,'Faber-Jackson','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91075,30.65,0.65,13.5,38347,95,NULL,'Weighted Mean','NGC 4220',NULL,'1984ApJS...56...91D',1984,1,3.84,NULL,'G',0.000004,NULL,'12.2g',0.92,'SA(r)0+;LINER  HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,184.0487917,47.88325,0,NULL,57191858594,893622790,13962856,12.2),(91076,'Faber-Jackson','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91076,31.78,0.81,22.7,38347,55,NULL,'Visvanathan & Sandage 1979','NGC 4220',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91077,'Tully est','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91077,31.15,0.8,17,38347,75,NULL,'B','NGC 4220',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91078,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91078,31.37,0.36,18.8,38347,NULL,NULL,NULL,'NGC 4220',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91079,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91079,31.54,0.2,20.3,38347,74.4,NULL,NULL,'NGC 4220',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91080,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91080,31.71,0.4,22,38347,75,NULL,NULL,'NGC 4220',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91081,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91081,31.78,0.49,22.7,38347,75,NULL,'IR','NGC 4220',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91082,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91082,38.51,0.46,503,38348,70,NULL,NULL,'2MASX J12161167+5754206',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,184.048917,57.90581,0,NULL,57329392450,895771757,13996433,17.5),(91083,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91083,38.01,0.46,400,38349,70,NULL,NULL,'SDSS J121611.95+050313.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,184.049833,5.05375,0,NULL,58034287012,906785734,14168527,18.5),(91084,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91084,38.35,0.46,467,38350,70,NULL,NULL,'2MASX J12161228+1213554',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,184.0512083,12.23225,0.03,NULL,58141221722,908456589,14194634,17.8),(91085,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91085,37.83,0.46,367,38351,70,NULL,NULL,'2MASX J12161245+5627345',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000145,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,184.051875,56.45961,0,NULL,57398591803,896852996,14013328,16.8),(91086,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91086,36.61,0.46,210,38352,70,NULL,NULL,'CGCG 098-120',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000674,NULL,'15.7',0.2,'E',NULL,NULL,NULL,NULL,1,184.0565417,19.45722,0.037,NULL,58861803453,919715678,14370557,15.7),(91087,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91087,37.07,0.46,259,38353,70,NULL,NULL,'2MASX J12161406+0708016',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000163,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,184.0585417,7.13383,0,NULL,58025630963,906650483,14166413,17),(91088,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91088,35.08,0.49,104,38354,75,NULL,'IR','UGC 07289',NULL,'2011yCatp016004901K',2011,1,1.36,NULL,'G',0.00003,NULL,'15.1g',0.3,'Irr/Pec',NULL,NULL,NULL,NULL,1,184.058833333,28.76261,0.123,NULL,58630206307,916096973,14314015,15.1),(91089,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91089,36.3,0.46,182,38355,70,NULL,NULL,'2MASX J12161450+4148445',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000168,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,184.0605417,41.81242,0,NULL,58533198296,914581223,14290331,16.4),(91090,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91090,38.19,0.46,435,38356,70,NULL,NULL,'SDSS J121615.62+615104.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,184.065125,61.85131,0.009,NULL,57371411333,896428302,14006692,18.4),(91091,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91091,35.82,0.53,146,38357,70,NULL,NULL,'2MASX J12161573-5136495',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,184.065583,-51.61378,0.461,NULL,44620443179,697194424,10893662,17),(91092,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91092,38.21,0.46,438,38358,70,NULL,NULL,'SDSS J121615.84+054714.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000162,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,184.0660417,5.78733,0,NULL,58026421680,906662838,14166606,18.1),(91093,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91093,35.85,0.46,148,38359,70,NULL,NULL,'2MASX J12161590+4845517',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000164,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,184.066083333,48.76436,0,NULL,57190060035,893594688,13962417,16.5),(91094,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91094,37.23,0.46,279,38360,70,NULL,NULL,'2MASX J12161621+4718150',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000192,NULL,'16.1g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,184.067791667,47.30431,0,NULL,57191658483,893619663,13962807,16.1),(91095,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91095,36.56,0.46,205,38361,70,NULL,NULL,'VII Zw 445',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000188,NULL,'15.9g',0.42,'E0',NULL,NULL,NULL,NULL,1,184.068583,60.48156,0,NULL,57340753224,895949269,13999207,15.9),(91096,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91096,36.99,0.13,250,38362,70,NULL,NULL,'2MASX J12161973+6020566',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,184.082583,60.34903,0,NULL,57340847970,895950749,13999230,17.2),(91097,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91097,37.18,0.46,272,38363,70,NULL,NULL,'LCRS B121346.0-030809',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'16.9g',0.3,'AGN',NULL,NULL,NULL,NULL,1,184.083083,-3.41361,0.061,NULL,43016177597,672127774,10501996,16.9),(91098,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91098,37.33,0.46,292,38364,70,NULL,NULL,'2MASX J12161999+1554174',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000163,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,184.083166667,15.90492,0.089,NULL,58179958169,909061846,14204091,16.3),(91099,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91099,36.24,0.46,177,38365,70,NULL,NULL,'2MASX J12162032+2053219',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.68',0.21,NULL,NULL,NULL,NULL,NULL,1,184.084667,20.88953,0.076,NULL,58871170699,919862042,14372844,17.68),(91100,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91100,36.11,0.46,167,38366,70,NULL,NULL,'SDSS J121621.17+174609.2',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.1g',0.38,'AGN',NULL,NULL,NULL,NULL,1,184.0882083,17.76922,0.083,NULL,58128748353,908261693,14191588,16.1),(91101,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91101,36.08,0.2,164,38367,74.4,NULL,NULL,'VCC 0189',NULL,'2013AJ....146...86T',2013,1,0.93,NULL,'G',0.000007,NULL,'14.9g',0.57,'Scd(r)','Group member',NULL,NULL,NULL,1,184.0922917,15.26203,0.1,NULL,58183155769,909111808,14204872,14.9),(91102,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91102,31.2,0.43,17.4,38368,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4222',NULL,'2014MNRAS.444..527S',2014,1,3.25,'Often mistakenly called IC 3087; that is a Galactic double star.','G',0.000003,NULL,'13.86',0.45,'Sc             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,184.093833,13.30706,0.023,NULL,58169221875,908894091,14201470,13.86),(91103,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91103,31.41,0.43,19.2,38368,75,NULL,'3.6 micron, color corrected','NGC 4222',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91104,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91104,31.52,0.2,20.1,38368,74.4,NULL,NULL,'NGC 4222',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91105,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91105,31.62,0.5,21,38368,NULL,NULL,'Malmquist cor.','NGC 4222',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91106,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91106,31.62,0.5,21.1,38368,NULL,NULL,NULL,'NGC 4222',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91107,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91107,31.64,0.36,21.3,38368,NULL,NULL,NULL,'NGC 4222',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91108,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91108,31.94,NULL,24.5,38368,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 4222',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91109,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91109,31.95,NULL,24.6,38368,NULL,NULL,NULL,'NGC 4222',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91110,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91110,31.96,NULL,24.7,38368,NULL,NULL,'Dipole + Quadrupole','NGC 4222',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91111,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91111,31.97,NULL,24.8,38368,NULL,NULL,'Dipole','NGC 4222',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91112,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91112,32.91,0.3,38.1,38368,55,NULL,'B','NGC 4222',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91113,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91113,36.88,0.46,238,38369,70,NULL,NULL,'2MASX J12162350+6001546',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000195,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,184.097958333,60.03175,0,NULL,57344156272,896002441,14000038,16.2),(91114,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91114,38.13,0.23,422,38370,70,NULL,NULL,'2MASX J12162390+6227186',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,184.0995417,62.45517,0.021,NULL,57373841499,896466273,14007285,16.9),(91115,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91115,35.9,0.51,151,38371,70,NULL,NULL,'2MASX J12162395-1833348',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000147,NULL,'15.34',0.7,NULL,NULL,NULL,NULL,NULL,1,184.09975,-18.55961,0.097,NULL,43023580521,672243445,10503803,15.34),(91116,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91116,37.95,0.46,390,38372,70,NULL,NULL,'2MASX J12162412+2814505',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,184.100583,28.24733,0.083,NULL,58637535030,916211484,14315804,17.6),(91117,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91117,35.37,0.46,118,38373,70,NULL,NULL,'CGCG 243-056',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000162,NULL,'15.2g',0.53,'S0',NULL,NULL,NULL,NULL,1,184.1035,50.02706,0,NULL,57232478084,894257470,13972772,15.2),(91118,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91118,35.31,0.4,115,38374,NULL,NULL,'Malmquist cor.','NGC 4226',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'14.36',0.6,'Sa pec?','in a radial-velocity based grouping',NULL,NULL,NULL,1,184.1095,47.02519,0,NULL,57177866156,893404158,13959439,14.36),(91119,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91119,35.39,0.38,120,38374,NULL,NULL,NULL,'NGC 4226',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91120,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91120,35.43,0.2,122,38374,74.4,NULL,NULL,'NGC 4226',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91121,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91121,37.61,0.46,333,38375,70,NULL,NULL,'2MASX J12162656+5647571',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000174,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,184.110541667,56.79928,0,NULL,57398985572,896859149,14013424,16.9),(91122,'IRAS','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91122,31.71,0.8,22,38376,75,NULL,'MAT, I','NGC 4219',NULL,'1997ApJS..109..333W',1997,1,4.3,NULL,'G',0.00001,NULL,'12.71',1.3,'SA(s)bc',NULL,NULL,NULL,NULL,1,184.113833,-43.32425,0.569,NULL,46710081863,729845029,11403828,12.71),(91123,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91123,31.52,0.43,20.2,38376,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4219',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91124,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91124,31.58,0.32,20.7,38376,85,NULL,'I, raw','NGC 4219',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91125,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91125,31.61,0.36,21,38376,NULL,NULL,NULL,'NGC 4219',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91126,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91126,31.61,0.43,21,38376,75,NULL,'MAT, I, raw','NGC 4219',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91127,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91127,31.61,0.4,21,38376,73,NULL,'opt','NGC 4219',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91128,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91128,31.63,0.32,21.2,38376,85,NULL,'I, inv','NGC 4219',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91129,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91129,31.65,0.43,21.3,38376,75,NULL,'3.6 micron, color corrected','NGC 4219',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91130,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91130,31.78,0.2,22.7,38376,74.4,NULL,NULL,'NGC 4219',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91131,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91131,31.83,0.43,23.2,38376,75,NULL,'MAT, I, inv','NGC 4219',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91132,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91132,31.95,0.43,24.6,38376,75,NULL,'MAT, I, cor','NGC 4219',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91133,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91133,31.96,0.49,24.7,38376,NULL,NULL,NULL,'NGC 4219',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91134,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91134,32.06,0.47,25.8,38376,NULL,NULL,'Malmquist cor.','NGC 4219',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91135,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91135,32.17,0.4,27.1,38376,75,NULL,'B','NGC 4219',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91136,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91136,34.68,0.46,86.4,38377,70,NULL,NULL,'MRK 0048',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000176,NULL,'15.0g',0.48,'S0',NULL,NULL,NULL,NULL,1,184.1140417,57.87719,0,NULL,57329388566,895771696,13996432,15),(91137,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91137,37.87,0.46,375,38378,70,NULL,NULL,'2MASX J12162831+5612092',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000173,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,184.1182083,56.20261,0.009,NULL,57396717380,896823709,14012870,17),(91138,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91138,37.84,0.46,370,38379,70,NULL,NULL,'SDSS J121628.38+055633.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000086,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,184.11825,5.94256,0,NULL,58027462616,906679103,14166860,18.3),(91139,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91139,38.07,0.46,412,38380,70,NULL,NULL,'2MASX J12162846+1539144',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,184.118667,15.65397,0.078,NULL,58179751215,909058612,14204040,17.5),(91140,'Tully est','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91140,31.57,0.8,20.6,38381,75,NULL,NULL,'DDO 116',NULL,'1988NBGC.C....0000T',1988,1,1.5,'Confused HIPASS source','G',0.000022,NULL,'16',0.3,'IB(s)m: sp',NULL,NULL,NULL,NULL,1,184.120833,-11.52825,0.081,NULL,43060362101,672818157,10512783,16),(91141,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91141,34.95,0.46,97.7,38382,70,NULL,NULL,'VCC 0194',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000107,NULL,'14.7g',0.69,'S0','Group member',NULL,NULL,NULL,1,184.1224583,14.49747,0.161,NULL,58180521465,909070647,14204228,14.7),(91142,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91142,36.76,0.46,225,38383,70,NULL,NULL,'2MASX J12162942+4448250',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,184.122625,44.80689,0,NULL,59057118703,922767479,14418241,17.6),(91143,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91143,37.37,0.46,298,38384,70,NULL,NULL,'2MASX J12162949+0520418',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,184.12275,5.34508,0,NULL,58034188556,906784196,14168503,17.6),(91144,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91144,37.29,0.46,287,38385,70,NULL,NULL,'SDSS J121629.78+064754.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,184.124125,6.79839,0,NULL,58027890137,906685783,14166965,17.9),(91145,'Brightest Stars','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91145,29.67,NULL,8.59,38386,NULL,NULL,NULL,'UGC 07298',NULL,'1998A&AS..128..325T',1998,1,1.3,NULL,'G',0.000001,NULL,'15.0',0.6,'Im:','Group member',NULL,NULL,NULL,1,184.125417,52.2275,0.041,NULL,57233501401,894273459,13973022,15),(91146,'TRGB','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91146,28.11,0.1,4.19,38386,74.4,NULL,NULL,'UGC 07298',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91147,'TRGB','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91147,28.12,0.17,4.21,38386,NULL,NULL,NULL,'UGC 07298',NULL,'2003A&A...398..467K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91148,'TRGB','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91148,28.16,0.3,4.28,38386,NULL,NULL,NULL,'UGC 07298',NULL,'2013AstBu..68..125M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91149,'TRGB','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91149,28.18,NULL,4.32,38386,NULL,NULL,NULL,'UGC 07298',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91150,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91150,36.85,0.46,235,38387,70,NULL,NULL,'SDSS J121630.34+331154.2',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,184.126417,33.19839,0,NULL,58767787462,918246679,14347604,17.4),(91151,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91151,37.44,0.46,307,38388,70,NULL,NULL,'2MASX J12163044+6600495',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,184.12675,66.01369,0.009,NULL,57313649734,895525777,13992590,17.3),(91152,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91152,37.67,0.46,342,38389,70,NULL,NULL,'2MASX J12163049+1220384',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,184.127083,12.34414,0.03,NULL,58141209613,908456400,14194631,18.3),(91153,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91153,36.78,0.46,227,38390,70,NULL,NULL,'2MASX J12163130+2706115',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000167,NULL,'16.8g',0.31,NULL,'Field galaxy',NULL,NULL,NULL,1,184.1305417,27.10331,0.093,NULL,58652555518,916446179,14319471,16.8),(91154,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91154,36.04,0.46,161,38391,70,NULL,NULL,'2MASX J12163184+1244324',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,184.1325417,12.74225,0.028,NULL,58140937218,908452144,14194564,16.8),(91155,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91155,37.78,0.46,359,38392,70,NULL,NULL,'2MASX J12163262+0923086',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000177,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,184.135833,9.38589,0,NULL,58216735636,909636494,14213070,17.5),(91156,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91156,38.16,0.46,429,38393,70,NULL,NULL,'2MASX J12163318+2741045',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000142,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,184.138416667,27.68456,0.085,NULL,58652080902,916438764,14319355,17.7),(91157,'GCLF','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91157,31.66,0.22,21.5,38394,NULL,NULL,'TOM(g) = -7.2 mag','VCC 0200',NULL,'2010ApJ...717..603V',2010,1,0.84,NULL,'G',0.000068,NULL,'15.0g',0.76,'dE2,N','Group member',NULL,NULL,NULL,1,184.140458333,13.03158,0.023,NULL,58138846281,908419473,14194054,15),(91158,'GCLF','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91158,31.67,0.33,21.6,38394,NULL,NULL,'TOM(g) = -7.2 mag','VCC 0200',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91159,'GCLF','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91159,31.98,0.4,24.9,38394,NULL,NULL,'TOM(u) = -8.4 mag','VCC 0200',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91160,'GCLF','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91160,32.11,0.33,26.4,38394,NULL,NULL,'TOM(z) = -8.53 mag','VCC 0200',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91161,'SBF','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91161,31.29,0.14,18.1,38394,74.4,NULL,NULL,'VCC 0200',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91162,'SBF','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91162,31.3,0.07,18.2,38394,NULL,NULL,NULL,'VCC 0200',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91163,'SBF','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91163,31.31,0.08,18.3,38394,NULL,NULL,'HST ACS VCS','VCC 0200',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91164,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91164,34.92,0.45,96.2,38395,NULL,NULL,'K','NGC 4227',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000087,NULL,'13.70',0.9,'SAB0^0^:','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,184.140416667,33.52206,0,NULL,58768431704,918256745,14347761,13.7),(91165,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91165,34.95,0.4,97.7,38395,NULL,NULL,'mean','NGC 4227',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91166,'Tully est','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91166,32.73,0.8,35.1,38396,75,NULL,'B','NGC 4224',NULL,'1988NBGC.C....0000T',1988,1,2.71,NULL,'G',0.00002,NULL,'12.8g',0.96,'SA(s)a: sp;Sy  LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,184.140791667,7.46208,0,NULL,58206956069,909483688,14210682,12.8),(91167,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91167,33.06,0.4,40.9,38396,NULL,NULL,'mean','NGC 4224',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91168,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91168,33.21,0.47,43.9,38396,NULL,NULL,'H','NGC 4224',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91169,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91169,33.24,0.46,44.5,38396,NULL,NULL,'J','NGC 4224',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91170,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91170,33.27,0.45,45.2,38396,NULL,NULL,'K','NGC 4224',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91171,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91171,33.55,0.2,51.3,38396,74.4,NULL,NULL,'NGC 4224',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91172,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91172,33.68,0.43,54.4,38396,75,NULL,'3.6 micron, color corrected','NGC 4224',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91173,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91173,33.99,0.43,62.7,38396,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4224',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91174,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91174,35.31,0.52,115,38397,70,NULL,NULL,'CGCG 013-117',NULL,'2014MNRAS.445.2677S',2014,1,0.84,NULL,'G',0.00008,NULL,'15.1g',0.41,'SAB(r)0^0^:',NULL,NULL,NULL,NULL,1,184.152125,-0.95594,0.037,NULL,42961573035,671274578,10488665,15.1),(91175,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91175,35.62,0.46,133,38397,70,NULL,NULL,'CGCG 013-117',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91176,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91176,38.38,0.33,474,38398,70,NULL,NULL,'2MASX J12163658+5852252',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00018,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,184.152166667,58.87369,0,NULL,57343158117,895986845,13999794,17.2),(91177,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91177,37.11,0.27,264,38399,70,NULL,NULL,'2MASX J12163717+1939548',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.87',0.19,NULL,NULL,NULL,NULL,NULL,1,184.154833,19.66525,0.049,NULL,58861384923,919709139,14370455,17.87),(91178,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91178,38.15,0.46,427,38400,70,NULL,NULL,'2MASX J12163754+2216318',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,184.156333333,22.27553,0.047,NULL,58864313490,919754898,14371170,17.8),(91179,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91179,37.66,0.46,341,38401,70,NULL,NULL,'2MASX J12163823+1622284',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.34',0.15,NULL,NULL,NULL,NULL,NULL,1,184.159375,16.3745,0.068,NULL,58172672736,908948011,14202312,18.34),(91180,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91180,37.71,0.19,348,38402,70,NULL,NULL,'2MASX J12163895+4435207',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000185,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,184.1622917,44.58906,0,NULL,59057174536,922768352,14418255,16.8),(91181,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91181,38.24,0.46,444,38403,70,NULL,NULL,'2MASX J12163949+5131093',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,184.164333333,51.51917,0.042,NULL,57234052115,894282064,13973157,18.1),(91182,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91182,36.75,0.46,224,38404,70,NULL,NULL,'2MASXi J1216396+122805',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000147,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,184.165083,12.46825,0.03,NULL,58141122240,908455035,14194609,17.4),(91183,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91183,36.61,0.77,210,38405,70,NULL,NULL,'2MASX J12163990-3800201',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,184.166333333,-38.00569,0.441,NULL,43283583597,676305993,10567281,15.7),(91184,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91184,37.04,0.46,255,38406,70,NULL,NULL,'2MASX J12164004+2138008',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,184.167,21.63361,0.05,NULL,58868812369,919825193,14372268,17.6),(91185,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91185,37.79,0.08,361,38407,70,NULL,NULL,'2MASX J12164011+0342318',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000187,NULL,'16.7g',0.26,'AGN',NULL,NULL,NULL,NULL,1,184.1672083,3.70875,0.014,NULL,58048309357,907004833,14171950,16.7),(91186,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91186,37.36,0.46,296,38408,70,NULL,NULL,'2MASX J12164112+0413148',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00016,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,184.1715,4.22092,0.022,NULL,58048133271,907002082,14171907,16.9),(91187,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91187,30.98,0.13,15.7,38409,NULL,NULL,NULL,'UGC 07301',NULL,'2009ApJS..182..474S',2009,1,2.19,NULL,'G',0.000019,NULL,'15.3g',0.33,'Sdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,184.175333333,46.07878,0,NULL,59058757281,922793082,14418641,15.3),(91188,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91188,31.63,NULL,21.2,38409,NULL,NULL,NULL,'UGC 07301',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91189,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91189,31.65,NULL,21.4,38409,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07301',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91190,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91190,31.66,NULL,21.5,38409,NULL,NULL,'Dipole + Quadrupole','UGC 07301',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91191,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91191,31.67,NULL,21.5,38409,NULL,NULL,'Dipole','UGC 07301',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91192,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91192,32.02,0.2,25.4,38409,74.4,NULL,NULL,'UGC 07301',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91193,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91193,32.03,0.43,25.5,38409,75,NULL,'3.6 micron, color + selection bias corrected','UGC 07301',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91194,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91194,32.07,0.43,25.9,38409,75,NULL,'3.6 micron, color corrected','UGC 07301',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91195,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91195,32.2,0.36,27.5,38409,NULL,NULL,NULL,'UGC 07301',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91196,'Brightest Stars','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91196,27.28,NULL,2.86,38410,NULL,NULL,'3V','NGC 4236',NULL,'1991A&AS...89....1T',1991,1,21.9,NULL,'G',0.000013,NULL,'10.05',7.2,'SB(s)dm','Isolated galaxy',NULL,NULL,NULL,1,184.1755,69.46258,0.057,0,56977130240,890267660,13910432,10.05),(91197,'TRGB','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91197,28.22,0.1,4.41,38410,74.4,NULL,NULL,'NGC 4236',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91198,'TRGB','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91198,28.24,0.22,4.45,38410,NULL,NULL,'I','NGC 4236',NULL,'2002A&A...383..125K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91199,'TRGB','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91199,28.46,0.45,4.92,38410,NULL,NULL,'I','NGC 4236',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91200,'HII region diameter','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91200,26.46,0.13,1.96,38410,NULL,NULL,'Method 2','NGC 4236',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91201,'HII region diameter','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91201,26.75,0.15,2.24,38410,NULL,NULL,'Method 1','NGC 4236',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91202,'IRAS','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91202,28.54,0.8,5.09,38410,75,NULL,'A82, H','NGC 4236',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91203,'Magnitude','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91203,27.15,0.11,2.69,38410,NULL,NULL,NULL,'NGC 4236',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91204,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91204,26.74,0.4,2.2,38410,75,NULL,'B','NGC 4236',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91205,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91205,27.09,NULL,2.62,38410,NULL,NULL,'LEDA [April 2006]','NGC 4236',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91206,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91206,28.18,0.47,4.32,38410,75,NULL,'A82, H, inv','NGC 4236',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91207,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91207,28.22,0.35,4.41,38410,NULL,NULL,NULL,'NGC 4236',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91208,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91208,28.25,NULL,4.47,38410,NULL,NULL,'IR','NGC 4236',NULL,'1980ApJ...237..655A',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91209,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91209,28.33,0.47,4.63,38410,75,NULL,'A82, H, raw','NGC 4236',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91210,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91210,28.69,0.47,5.47,38410,75,NULL,'A82, H, cor','NGC 4236',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91211,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91211,35.43,0.46,122,38411,70,NULL,NULL,'CGCG 098-127',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000677,NULL,'15.7',0.3,'E?',NULL,NULL,NULL,NULL,1,184.176333,18.37822,0.072,NULL,58128565986,908258843,14191544,15.7),(91212,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91212,34.69,0.2,86.7,38412,74.4,NULL,NULL,'IC 3093',NULL,'2013AJ....146...86T',2013,1,0.51,NULL,'G',0.000033,NULL,'15.3g',0.32,'Sc','Group member',NULL,NULL,NULL,1,184.1765,14.27781,0.132,NULL,58180539434,909070928,14204233,15.3),(91213,'Tully est','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91213,29.93,0.8,9.7,38413,75,NULL,'B','UGC 07300',NULL,'1988NBGC.C....0000T',1988,1,1.4,NULL,'G',0.000013,NULL,'14.9',1.2,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,184.180458333,28.73114,0.123,NULL,58630159566,916096243,14314003,14.9),(91214,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91214,37.19,0.46,274,38414,70,NULL,NULL,'2MASX J12164362+1536160',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000163,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,184.18175,15.60453,0.078,NULL,58182618034,909103406,14204740,16.5),(91215,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91215,37.12,0.46,266,38415,70,NULL,NULL,'2MASX J12164394+5706452',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000179,NULL,'16.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,184.183083333,57.11253,0,NULL,57398921642,896858150,14013408,16.6),(91216,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91216,38.25,0.46,446,38416,70,NULL,NULL,'SDSS J121644.61+305428.1',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,184.185917,30.90783,NULL,NULL,58629220661,916081572,14313774,18),(91217,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91217,37.06,0.46,258,38417,70,NULL,NULL,'LCRS B121411.1-025544',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000127,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,184.188083,-3.20647,0.061,NULL,43016211804,672128309,10502004,16.9),(91218,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91218,37.62,0.27,334,38418,70,NULL,NULL,'2MASX J12164567+4054535',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000197,NULL,'15.8g',0.47,NULL,NULL,NULL,NULL,NULL,1,184.190167,40.915,0,NULL,58530047196,914531987,14289562,15.8),(91219,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91219,38.49,0.46,499,38419,70,NULL,NULL,'SDSS J121645.68+303828.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000181,NULL,'18.5g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,184.190333,30.64133,NULL,NULL,58629934366,916092724,14313948,18.5),(91220,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91220,37.13,0.33,267,38420,70,NULL,NULL,'2MASX J12164632+4442408',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,184.1932083,44.71128,0,NULL,59057165344,922768208,14418253,17.7),(91221,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91221,37.13,0.33,267,38421,70,NULL,NULL,'2MASX J12164652+4440158',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000175,NULL,'16.1g',0.39,'E0',NULL,NULL,NULL,NULL,1,184.1939583,44.67106,0,NULL,59057165653,922768213,14418253,16.1),(91222,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91222,37.13,0.46,267,38422,70,NULL,NULL,'2MASX J12164689+1311530',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,184.195333,13.19803,0.023,NULL,58169216446,908894006,14201468,17.9),(91223,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91223,37.7,0.46,347,38423,70,NULL,NULL,'2MASX J12164709+2608215',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.82',0.14,NULL,NULL,NULL,NULL,NULL,1,184.1962083,26.13944,0.088,NULL,58649888982,916404515,14318820,18.82),(91224,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91224,37.34,0.46,293,38424,70,NULL,NULL,'2MASX J12164727+2738395',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'17.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,184.196958333,27.64433,0.085,NULL,58652069292,916438582,14319352,17.9),(91225,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91225,35.92,0.46,153,38425,70,NULL,NULL,'2MASX J12164746+6422408',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000172,NULL,'16.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,184.197875,64.37817,0.009,NULL,57324107520,895689180,13995143,16.3),(91226,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91226,35.36,0.54,118,38426,70,NULL,NULL,'LCRS B121413.5-062940',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'15.46',0.47,NULL,NULL,NULL,NULL,NULL,1,184.198875,-6.77258,0.157,NULL,42974283864,671473185,10491768,15.46),(91227,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91227,32.53,NULL,32,38427,NULL,NULL,NULL,'VCC 0207',NULL,'2014A&A...562A..49M',2014,1,0.32,NULL,'G',0.000011,NULL,'16.8g',0.19,'BCD?','Group member',NULL,NULL,NULL,1,184.1995417,8.04897,0,NULL,58207160365,909486880,14210732,16.8),(91228,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91228,37.05,0.6,256,38428,70,NULL,NULL,'2MASX J12164859-2240279',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.30',NULL,NULL,NULL,NULL,NULL,NULL,1,184.2025,-22.67447,0.233,NULL,43896448619,685882009,10716906,16.3),(91229,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91229,37.3,0.46,289,38429,70,NULL,NULL,'2MASX J12164874+5244133',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,184.203208333,52.73711,0,NULL,57215657590,893994649,13968666,17.5),(91230,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91230,36.31,0.57,183,38430,70,NULL,NULL,'2MASX J12164899-1833289',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.93',0.4,NULL,NULL,NULL,NULL,NULL,1,184.204167,-18.55808,0.097,NULL,43023359781,672239996,10503749,15.93),(91231,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91231,35.54,0.49,128,38431,70,NULL,NULL,'2MASX J12164903-5122078',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000143,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,184.204375,-51.36889,0.741,NULL,44622367037,697224484,10894132,15.8),(91232,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91232,37.1,0.33,263,38432,70,NULL,NULL,'2MASX J12164911-0044305',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00011,NULL,'15.8g',0.46,'AGN',NULL,NULL,NULL,NULL,1,184.204583,-0.74181,0.041,NULL,42961535768,671273996,10488656,15.8),(91233,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91233,37.85,0.46,372,38433,70,NULL,NULL,'SDSS J121650.33+021526.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000163,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,184.209708333,2.25731,0.012,NULL,58043538848,906930294,14170785,18.6),(91234,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91234,38.31,0.46,460,38434,70,NULL,NULL,'2MASX J12165033+2754025',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000166,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,184.209708333,27.90083,0.081,NULL,58651914723,916436167,14319315,17.7),(91235,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91235,37.1,0.33,263,38435,70,NULL,NULL,'2MASXi J1216516-010212',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000068,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,184.215375,-1.03669,0.053,NULL,42961568698,671274510,10488664,17.9),(91236,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91236,37.91,0.46,383,38436,70,NULL,NULL,'2MASX J12165240-0036030',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000082,NULL,'18.0g',0.14,'ELG',NULL,NULL,NULL,NULL,1,184.218416667,-0.601,0.041,NULL,42961868919,671279201,10488737,18),(91237,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91237,38.66,0.46,540,38437,70,NULL,NULL,'2MASX J12165382+5211564',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,184.224167,52.19897,0.041,NULL,57233469897,894272967,13973015,17.8),(91238,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91238,37.94,0.46,387,38438,70,NULL,NULL,'2MASX J12165429+5059384',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000172,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,184.226125,50.99403,0,NULL,57232689530,894260773,13972824,17.1),(91239,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91239,37.79,0.08,361,38439,70,NULL,NULL,'2MASX J12165446+0339503',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,184.227,3.664,0.014,NULL,58048257434,907004022,14171937,17.5),(91240,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91240,37.43,0.46,306,38440,70,NULL,NULL,'2MASX J12165521+0524513',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000152,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,184.23,5.41433,0,NULL,58034002532,906781289,14168457,17.4),(91241,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91241,32.8,0.2,36.3,38441,74.4,NULL,NULL,'NGC 4238',NULL,'2013AJ....146...86T',2013,1,1.86,NULL,'G',0.000037,NULL,'14.2g',0.52,'Sd;BrClG       HII',NULL,NULL,NULL,NULL,1,184.2325,63.40992,0.025,NULL,57316844017,895575687,13993370,14.2),(91242,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91242,32.84,0.43,37,38441,75,NULL,'3.6 micron, color corrected','NGC 4238',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91243,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91243,32.9,0.43,38.1,38441,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4238',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91244,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91244,37.11,0.27,264,38442,70,NULL,NULL,'2MASX J12165686+1940419',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.76',0.2,NULL,NULL,NULL,NULL,NULL,1,184.236833,19.67833,0.049,NULL,58861377683,919709026,14370453,17.76),(91245,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91245,37.79,0.08,361,38443,70,NULL,NULL,'2MASX J12165787+0334223',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,184.2412083,3.57286,0.015,NULL,58048250113,907003908,14171936,18),(91246,'IRAS','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91246,31.93,0.8,24.3,38444,75,NULL,'MAT, I','ESO 380- G 008',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000017,NULL,'14.67',1.4,'SB(s)dm',NULL,NULL,NULL,NULL,1,184.242667,-37.47114,0.325,NULL,43283332941,676302077,10567219,14.67),(91247,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91247,29.84,0.32,9.31,38444,85,NULL,'I, inv','ESO 380- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91248,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91248,29.91,0.32,9.63,38444,85,NULL,'I, raw','ESO 380- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91249,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91249,30.5,0.43,12.6,38444,75,NULL,'MAT, I, inv','ESO 380- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91250,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91250,30.69,0.43,13.8,38444,75,NULL,'MAT, I, raw','ESO 380- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91251,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91251,30.99,0.43,15.8,38444,75,NULL,'MAT, I, cor','ESO 380- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91252,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91252,31.02,0.4,16,38444,NULL,NULL,NULL,'ESO 380- G 008',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91253,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91253,31.02,0.4,16,38444,73,NULL,'opt','ESO 380- G 008',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91254,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91254,37.11,0.27,264,38445,70,NULL,NULL,'2MASX J12165863+1939039',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.03',0.17,NULL,NULL,NULL,NULL,NULL,1,184.244333,19.65119,0.049,NULL,58861372594,919708946,14370452,18.03),(91255,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91255,36.71,0.46,220,38446,70,NULL,NULL,'2MASX J12165898+3907505',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000172,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,184.245667,39.13061,0,NULL,58582822036,915356594,14302446,16.7),(91256,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91256,36.31,0.65,183,38447,70,NULL,NULL,'2MASX J12165946-1813138',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.4,NULL,NULL,NULL,NULL,NULL,1,184.2477083,-18.22056,0.097,NULL,43024641252,672260019,10504062,14.3),(91257,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91257,37.63,0.46,335,38448,70,NULL,NULL,'2MASX J12170053-0009490',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000095,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,184.252375,-0.16358,0.025,NULL,42958381859,671224716,10487886,16.8),(91258,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91258,37.52,0.46,320,38449,70,NULL,NULL,'SDSS J121701.34+112543.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000143,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,184.255625,11.42881,0.023,NULL,58139622933,908431608,14194243,17.9),(91259,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91259,37.66,0.46,340,38450,70,NULL,NULL,'2MASX J12170187+2629565',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,184.258,26.49897,0.095,NULL,58649281888,916395029,14318672,17.3),(91260,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91260,37.79,0.08,361,38451,70,NULL,NULL,'2MASX J12170363+0316013',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000167,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,184.2652083,3.26703,0.014,NULL,58046703036,906979734,14171558,16.2),(91261,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91261,37.02,0.46,253,38452,70,NULL,NULL,'2MASX J12170391+4403288',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000153,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,184.266125,44.05794,0,NULL,59071078864,922985607,14421650,16.7),(91262,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91262,37.53,0.46,321,38453,70,NULL,NULL,'2MASX J12170405+0751019',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000173,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,184.2667917,7.85039,0,NULL,58207112327,909486130,14210720,17.7),(91263,'Tully est','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91263,31.13,0.8,16.8,38454,75,NULL,NULL,'UGC 07307',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000002,NULL,'16.5',1.1,'ImIV-V:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,184.268583,10.00514,0,NULL,58214320049,909598750,14212480,16.5),(91264,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91264,37.05,0.46,257,38455,70,NULL,NULL,'2MASX J12170522+4009214',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000153,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,184.27175,40.15583,0,NULL,58529661033,914525953,14289468,16.5),(91265,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91265,36.88,0.46,237,38456,70,NULL,NULL,'2MASX J12170702+2945365',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,184.279208333,29.76006,0.06,NULL,58631327118,916114486,14314288,17),(91266,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91266,38.38,0.33,474,38457,70,NULL,NULL,'2MASX J12170718+5843492',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000148,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,184.280125,58.73039,0,NULL,57343022750,895984730,13999761,17.2),(91267,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91267,37.79,0.08,361,38458,70,NULL,NULL,'SDSS J121707.41+034002.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00017,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,184.280917,3.66725,0.014,NULL,58046358075,906974344,14171474,18),(91268,'SBF','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91268,32.65,0.94,33.9,38459,NULL,NULL,'I','NGC 4233',NULL,'2001ApJ...546..681T',2001,1,2.34,NULL,'G',0.000017,NULL,'12.8g',0.98,'S0^0^','X-ray-bright group member',NULL,NULL,NULL,1,184.282,7.62439,0,NULL,58206790583,909481102,14210642,12.8),(91269,'SBF','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91269,32.75,0.14,35.5,38459,74.4,NULL,NULL,'NGC 4233',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91270,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91270,32.59,NULL,33,38459,NULL,NULL,NULL,'NGC 4233',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91271,'Tully est','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91271,32.73,0.8,35.1,38459,75,NULL,'B','NGC 4233',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91272,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91272,32.9,0.4,38,38459,NULL,NULL,'mean','NGC 4233',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91273,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91273,33,0.45,39.9,38459,NULL,NULL,'K','NGC 4233',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91274,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91274,38.21,0.46,439,38460,70,NULL,NULL,'2MASX J12170844+4318558',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000197,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,184.285417,43.3155,0,NULL,59070696916,922979639,14421556,17.2),(91275,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91275,36.6,0.46,209,38461,70,NULL,NULL,'2MASX J12170864+1245190',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000144,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,184.285916667,12.75536,0.028,NULL,58140925523,908451961,14194561,17.4),(91276,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91276,37.79,0.08,361,38462,70,NULL,NULL,'2MASX J12170869+0337013',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,184.2862917,3.61703,0.015,NULL,58046363139,906974424,14171475,17.7),(91277,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91277,37.71,0.19,348,38463,70,NULL,NULL,'2MASX J12170882+4437428',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000138,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,184.286833,44.6285,0,NULL,59057147996,922767937,14418249,17),(91278,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91278,37.99,0.46,395,38464,70,NULL,NULL,'2MASX J12170893+0003239',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00008,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,184.287333,0.05672,0.025,NULL,57986792796,906043637,14156931,18.4),(91279,'Tully est','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91279,32.59,0.8,32.9,38465,75,NULL,'B','NGC 4234',NULL,'1988NBGC.C....0000T',1988,1,1.37,'The 2MASS position refers to a knot 19 arcsec west of the nucleus.','G',0.000023,NULL,'13.7g',1.05,'(R\')SB(s)m     HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,184.288167,3.68306,0.014,NULL,58046406272,906975098,14171485,13.7),(91280,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91280,37.32,0.46,291,38466,70,NULL,NULL,'2MASXi J1217092+325837',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,184.2887083,32.97725,0,NULL,58767823661,918247244,14347613,17.9),(91281,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91281,32.62,0.2,33.4,38467,74.4,NULL,NULL,'IC 3099',NULL,'2013AJ....146...86T',2013,1,2.09,NULL,'G',0.000023,NULL,'14.8g',0.36,'Sbc            HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,184.288625,12.45403,0.035,NULL,58141140901,908455326,14194614,14.8),(91282,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91282,32.66,0.49,34.1,38467,NULL,NULL,'Malmquist cor.','IC 3099',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91283,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91283,32.66,0.43,34.1,38467,75,NULL,'3.6 micron, color corrected','IC 3099',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91284,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91284,32.73,0.43,35.2,38467,75,NULL,'3.6 micron, color + selection bias corrected','IC 3099',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91285,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91285,32.79,NULL,36.2,38467,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 3099',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91286,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91286,32.8,NULL,36.3,38467,NULL,NULL,'Dipole + Quadrupole','IC 3099',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91287,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91287,32.81,NULL,36.4,38467,NULL,NULL,'Dipole','IC 3099',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91288,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91288,32.82,0.49,36.7,38467,75,NULL,'IR','IC 3099',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91289,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91289,32.88,NULL,37.7,38467,NULL,NULL,NULL,'IC 3099',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91290,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91290,32.89,0.44,37.8,38467,NULL,NULL,NULL,'IC 3099',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91291,'Tully est','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91291,32.73,0.8,35.1,38468,75,NULL,'B','NGC 4235',NULL,'1988NBGC.C....0000T',1988,1,3.5,NULL,'G',0.000033,NULL,'12.5g',0.79,'SA(s)a         Sy1','in a radial-velocity based grouping',NULL,NULL,'Sy 1.2',1,184.291166667,7.19158,0,NULL,58207776466,909496507,14210882,12.5),(91292,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91292,31.31,0.45,18.3,38468,NULL,NULL,'K','NGC 4235',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91293,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91293,31.32,0.46,18.4,38468,NULL,NULL,'J','NGC 4235',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91294,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91294,31.32,0.47,18.4,38468,NULL,NULL,'H','NGC 4235',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91295,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91295,31.76,0.3,22.5,38468,55,NULL,'B','NGC 4235',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91296,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91296,32.85,0.4,37.1,38468,NULL,NULL,'mean','NGC 4235',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91297,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91297,32.53,NULL,32,38469,NULL,NULL,NULL,'VCC 0223',NULL,'2014A&A...562A..49M',2014,1,0.42,NULL,'G',0.000033,NULL,'16.3g',0.29,'BCD?','X-ray-bright group member',NULL,NULL,NULL,1,184.294625,6.43181,0,NULL,58024343380,906630365,14166099,16.3),(91298,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91298,35.94,0.46,154,38470,70,NULL,NULL,'UGC 07317',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000196,NULL,'15.0g',0.5,'S0^-',NULL,NULL,NULL,NULL,1,184.296416667,41.32175,0,NULL,58530474590,914538665,14289666,15),(91299,'Tully est','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91299,31.13,0.8,16.8,38471,75,NULL,'B','NGC 4237',NULL,'1988NBGC.C....0000T',1988,1,2.33,NULL,'G',0.000013,NULL,'12.4g',1.07,'SAB(rs)bc;Sy   LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,184.297583,15.32397,0.05,NULL,58182822834,909106606,14204790,12.4),(91300,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91300,28.54,0.69,5.1,38471,100,NULL,'mid-IR','NGC 4237',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91301,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91301,31.16,0.43,17.1,38471,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4237',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91302,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91302,31.22,0.4,17.5,38471,NULL,NULL,'mean','NGC 4237',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91303,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91303,31.31,0.43,18.3,38471,75,NULL,'3.6 micron, color corrected','NGC 4237',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91304,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91304,31.48,NULL,19.8,38471,NULL,NULL,NULL,'NGC 4237',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91305,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91305,31.52,0.2,20.1,38471,74.4,NULL,NULL,'NGC 4237',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91306,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91306,31.54,0.45,20.4,38471,NULL,NULL,'K','NGC 4237',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91307,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91307,31.55,0.47,20.4,38471,NULL,NULL,'H','NGC 4237',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91308,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91308,31.62,0.46,21.1,38471,NULL,NULL,'J','NGC 4237',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91309,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91309,31.67,0.36,21.6,38471,NULL,NULL,NULL,'NGC 4237',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91310,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91310,31.73,0.47,22.2,38471,NULL,NULL,'Malmquist cor.','NGC 4237',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91311,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91311,31.8,0.45,23,38471,NULL,NULL,NULL,'NGC 4237',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91312,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91312,31.82,0.92,23.1,38471,NULL,NULL,'CO','NGC 4237',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91313,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91313,32.07,0.7,25.9,38471,NULL,NULL,'HI','NGC 4237',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91314,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91314,32.52,0.3,31.9,38471,55,NULL,'B','NGC 4237',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91315,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91315,37.42,0.46,304,38472,70,NULL,NULL,'2MASX J12171139+3517107',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,184.297583,35.28622,0,NULL,58542682911,914729420,14292647,17.1),(91316,'Tully est','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91316,31.72,0.8,22.1,38473,75,NULL,NULL,'UGCA 277',NULL,'1988NBGC.C....0000T',1988,1,1,'Confused HIPASS source','G',0.000022,NULL,'17',0.5,'IB(s)m',NULL,NULL,NULL,NULL,1,184.302125,-11.67914,0.069,NULL,43062440401,672850631,10513291,17);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (91317,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91317,37.86,0.27,373,38474,70,NULL,NULL,'SDSS J121713.08+085452.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000138,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,184.3045417,8.9145,0,NULL,58216255180,909628987,14212952,18.1),(91318,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91318,37.79,0.08,361,38475,70,NULL,NULL,'2MASX J12171352+0316534',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000189,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,184.3064583,3.28144,0.014,NULL,58046703684,906979745,14171558,16.4),(91319,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91319,37.65,0.33,339,38476,70,NULL,NULL,'2MASX J12171406+0135194',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000179,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,184.308583,1.58883,0.016,NULL,58044224519,906941008,14170953,17.1),(91320,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91320,37.45,0.46,309,38477,70,NULL,NULL,'2MASX J12171407+6046337',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,184.3087083,60.77611,0,NULL,57339138968,895924046,13998813,17.8),(91321,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91321,37.79,0.08,361,38478,70,NULL,NULL,'2MASX J12171451+0330144',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000172,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,184.3105,3.50408,0.015,NULL,58046811213,906981425,14171584,16.5),(91322,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91322,30.54,0.25,12.8,38479,74.4,NULL,NULL,'NGC 4239',NULL,'2013AJ....146...86T',2013,1,1.8,NULL,'G',0.000053,NULL,'13.7',1.2,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,184.3122083,16.53139,0.028,NULL,58172543411,908945990,14202281,13.7),(91323,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91323,31.34,0.4,18.5,38479,NULL,NULL,'mean','NGC 4239',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91324,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91324,31.6,0.45,20.9,38479,NULL,NULL,'K','NGC 4239',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91325,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91325,36.19,NULL,173,38480,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07318',NULL,'2010Ap&SS.325..163P',2010,1,1.08,NULL,'G',0.000092,NULL,'16.7g',0.14,'Sd',NULL,NULL,NULL,NULL,1,184.3165,49.49683,0,NULL,57189597111,893587454,13962303,16.7),(91326,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91326,36.21,NULL,175,38480,NULL,NULL,'Dipole + Quadrupole','UGC 07318',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91327,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91327,36.22,NULL,175,38480,NULL,NULL,NULL,'UGC 07318',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91328,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91328,36.24,NULL,177,38480,NULL,NULL,'Dipole','UGC 07318',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91329,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91329,36.28,0.49,181,38480,75,NULL,'IR','UGC 07318',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91330,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91330,37.62,0.46,335,38481,70,NULL,NULL,'2MASX J12171617+0520044',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,184.317291667,5.3345,0,NULL,58036091643,906813931,14168967,17.4),(91331,'SNIa','2016-12-15 15:14:57','2016-12-16 11:20:06','1','SN 2005bg',NULL,91331,34.96,0.2,93.6,38482,72,NULL,NULL,'KUG 1214+166',0.02417,'2013ApJ...773...53F',2013,1,0.7,'Multiple SDSS entries describe this object.','G',0.000133,NULL,'15.2',0.7,'S: ab',NULL,NULL,NULL,NULL,1,184.3217917,16.3715,0.028,NULL,58172647917,908947623,14202306,15.2),(91332,'SNIa','2016-12-15 15:14:57','2016-12-16 11:20:06','1','SN 2005bg',NULL,91332,34.97,0.03,96.5,38482,70,NULL,NULL,'KUG 1214+166',0.023086,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91333,'SNIa','2016-12-15 15:14:57','2016-12-16 11:20:06','1','SN 2005bg','R',91333,34.99,0.05,99.5,38482,NULL,NULL,'MLCS2k2, R(V) = 1.8','KUG 1214+166',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91334,'SNIa','2016-12-15 15:14:57','2016-12-16 11:20:06','1','SN 2005bg','R',91334,35.01,0.06,100,38482,NULL,NULL,'MLCS2k2, R(V) = 3.1','KUG 1214+166',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91335,'SNIa','2016-12-15 15:14:57','2016-12-16 11:20:06','1','SN 2005bg',NULL,91335,35.02,0.1,101,38482,74.4,NULL,NULL,'KUG 1214+166',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91336,'SNIa','2016-12-15 15:14:57','2016-12-16 11:20:06','1','SN 2005bg',NULL,91336,35.08,0.06,101,38482,72,NULL,NULL,'KUG 1214+166',0.023086,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91337,'SNIa','2016-12-15 15:14:57','2016-12-16 11:20:06','1','SN 2005bg',NULL,91337,35.11,0.16,103,38482,70,NULL,'SALT 2','KUG 1214+166',0.023086,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91338,'SNIa','2016-12-15 15:14:57','2016-12-16 11:20:06','1','SN 2005bg',NULL,91338,35.06,0.03,103,38482,72,NULL,NULL,'KUG 1214+166',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91339,'SNIa','2016-12-15 15:14:57','2016-12-16 11:20:06','1','SN 2005bg',NULL,91339,35.16,0.14,105,38482,73.8,NULL,'SALT 2 (SNANA)','KUG 1214+166',0.0246,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91340,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91340,37.86,0.27,373,38483,70,NULL,NULL,'2MASX J12171725+0853259',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000155,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,184.3217917,8.89047,0,NULL,58216251803,909628934,14212952,17.4),(91341,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91341,37.79,0.08,361,38484,70,NULL,NULL,'2MASX J12171776+0400074',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,184.324083333,4.00208,0.018,NULL,58046343062,906974110,14171470,17.4),(91342,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91342,37.63,0.46,335,38485,70,NULL,NULL,'SDSS J121718.47+135943.2',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000132,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,184.327,13.99536,0.142,NULL,58169273439,908894897,14201482,18.8),(91343,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91343,37.45,0.33,310,38486,70,NULL,NULL,'2MASX J12171890+0602289',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000172,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,184.328833,6.04139,0,NULL,58024688310,906635754,14166183,17.3),(91344,'GCLF','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91344,31.14,0.13,16.9,38487,NULL,NULL,'TOM(g) = -7.2 mag','IC 3101',NULL,'2010ApJ...717..603V',2010,1,0.68,NULL,'G',0.000067,NULL,'15.7g',0.51,'dE4:,N:','Group member',NULL,NULL,NULL,1,184.331875,11.94347,0.026,NULL,58140778443,908449663,14194525,15.7),(91345,'GCLF','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91345,31.16,0.22,17,38487,NULL,NULL,'TOM(g) = -7.2 mag','IC 3101',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91346,'GCLF','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91346,31.5,0.34,19.9,38487,NULL,NULL,'TOM(u) = -8.4 mag','IC 3101',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91347,'GCLF','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91347,31.61,0.14,21,38487,NULL,NULL,'TOM(z) = -8.53 mag','IC 3101',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91348,'SBF','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91348,31.24,0.14,17.7,38487,74.4,NULL,NULL,'IC 3101',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91349,'SBF','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91349,31.25,0.1,17.8,38487,NULL,NULL,NULL,'IC 3101',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91350,'SBF','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91350,31.26,0.11,17.9,38487,NULL,NULL,'HST ACS VCS','IC 3101',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91351,'GC radius','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91351,30.64,0.15,13.4,38487,NULL,NULL,NULL,'IC 3101',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91352,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91352,38.31,0.46,459,38488,70,NULL,NULL,'2MASX J12172074+1310412',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000148,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,184.336291667,13.17811,0.023,NULL,58169199149,908893736,14201464,17.9),(91353,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91353,34.72,NULL,87.9,38489,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 041-064',NULL,'2010Ap&SS.325..163P',2010,1,0.95,NULL,'G',0.00004,NULL,'16.0g',0.2,'Sc(f)',NULL,NULL,NULL,NULL,1,184.339083,2.57964,0.018,NULL,58043987592,906937306,14170895,16),(91354,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91354,34.74,NULL,88.7,38489,NULL,NULL,'Dipole + Quadrupole','CGCG 041-064',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91355,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91355,34.76,NULL,89.4,38489,NULL,NULL,'Dipole','CGCG 041-064',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91356,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91356,37.65,0.33,339,38490,70,NULL,NULL,'2MASX J12172194+0134398',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000166,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,184.341417,1.57772,0.016,NULL,58044237669,906941213,14170956,17),(91357,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91357,37.37,0.46,298,38491,70,NULL,NULL,'2MASX J12172257-0141345',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,184.3440417,-1.69289,0.057,NULL,43008114301,672001785,10500027,17.4),(91358,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91358,37.99,0.46,396,38492,70,NULL,NULL,'2MASX J12172294+0451398',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00019,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,184.345708333,4.86117,0,NULL,58036402218,906818784,14169043,16.6),(91359,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91359,37.59,0.46,330,38493,70,NULL,NULL,'2MASX J12172301+0338568',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,184.345791667,3.64925,0.015,NULL,58046414190,906975221,14171487,17.3),(91360,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91360,37.62,0.27,334,38494,70,NULL,NULL,'2MASX J12172318+4054575',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,184.3465417,40.91603,0,NULL,58530191983,914534249,14289597,17.7),(91361,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91361,37.86,0.27,373,38495,70,NULL,NULL,'2MASX J12172326+0852219',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000176,NULL,'16.2g',0.44,NULL,NULL,NULL,NULL,NULL,1,184.346875,8.87292,0,NULL,58213417297,909584645,14212260,16.2),(91362,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91362,37.79,0.08,361,38496,70,NULL,NULL,'2MASX J12172422+0326368',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000188,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,184.350875,3.44342,0.015,NULL,58046823299,906981614,14171587,17.2),(91363,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91363,31.55,0.69,20.4,38497,100,NULL,'mid-IR','NGC 4223',NULL,'2013ApJ...771...88L',2013,1,2.49,'CGCG incorrectly calls this NGC 4241.','G',0.000083,NULL,'13.0g',1.03,'SA(s)0+:;Sy    LINER','X-ray-bright group member',NULL,NULL,NULL,1,184.3575417,6.69008,0,NULL,58024495237,906632738,14166136,13),(91364,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91364,32.23,0.45,27.9,38497,NULL,NULL,'Malmquist cor.','NGC 4223',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91365,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91365,32.37,0.42,29.8,38497,NULL,NULL,NULL,'NGC 4223',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91366,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91366,32.65,0.2,33.9,38497,74.4,NULL,NULL,'NGC 4223',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91367,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91367,37.62,0.27,334,38498,70,NULL,NULL,'2MASX J12172636+4048145',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,184.3599583,40.80414,0,NULL,58530028957,914531702,14289557,17.1),(91368,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91368,37.85,0.46,371,38499,70,NULL,NULL,'2MASX J12172638+0721529',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,184.3600417,7.36481,0,NULL,58207979299,909499676,14210932,17.4),(91369,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91369,37.46,0.46,311,38500,70,NULL,NULL,'2MASX J12172647+1947435',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'18.53',0.1,NULL,NULL,NULL,NULL,NULL,1,184.3602083,19.7955,0.068,NULL,58861529223,919711394,14370490,18.53),(91370,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91370,37.79,0.08,361,38501,70,NULL,NULL,'2MASX J12172669+0337038',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000196,NULL,'17.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,184.361125,3.61786,0.015,NULL,58046409318,906975145,14171486,17.4),(91371,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91371,37.79,0.08,361,38502,70,NULL,NULL,'SDSS J121727.02+034138.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000178,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,184.362625,3.69411,0.015,NULL,58046400485,906975007,14171484,18.2),(91372,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91372,37.1,0.46,263,38503,70,NULL,NULL,'2MASX J12172717+1543552',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,184.363167,15.73208,0.059,NULL,58179721607,909058150,14204033,17.7),(91373,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91373,36.78,0.46,227,38504,70,NULL,NULL,'2MASX J12172770+4616209',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000209,NULL,'16.1g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,184.365458333,46.27258,0,NULL,59058086211,922782597,14418478,16.1),(91374,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91374,29.82,NULL,9.2,38505,NULL,NULL,NULL,'UGC 07320',NULL,'2013AJ....145..101K',2013,1,0.97,NULL,'G',0.000057,NULL,'15.8g',0.43,'(dS0, N)?;cand. dwar','Dwarf, within FOV of cluster',NULL,NULL,NULL,1,184.3689583,44.81125,0,NULL,59071006174,922984471,14421632,15.8),(91375,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91375,37.32,0.46,291,38506,70,NULL,NULL,'2MASX J12172862+3529490',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000138,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,184.3692917,35.49711,0,NULL,58543281737,914738777,14292793,17.5),(91376,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91376,37.35,0.33,295,38507,70,NULL,NULL,'2MASXi J1217289+133651',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000125,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,184.3704583,13.61428,0.168,NULL,58169376757,908896511,14201507,17.4),(91377,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91377,36.9,0.46,240,38508,70,NULL,NULL,'2MASX J12172894+3234490',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00019,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,184.370666667,32.58036,0,NULL,58769627939,918275436,14348053,16.6),(91378,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91378,37.2,0.46,275,38509,70,NULL,NULL,'2MASX J12172952+4752299',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000166,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,184.372875,47.87517,0,NULL,57191880303,893623129,13962861,17.2),(91379,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91379,36.95,0.46,246,38510,70,NULL,NULL,'2MASX J12172959+2824047',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000161,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,184.373167,28.40144,0.091,NULL,58638303166,916223486,14315991,17.1),(91380,'Brightest Stars','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91380,28.28,NULL,4.53,38511,NULL,NULL,NULL,'NGC 4244',NULL,'1998A&AS..131....1K',1998,1,19.38,NULL,'G',0.000001,NULL,'10.88',2.13,'SA(s)cd: sp    HII','Probable group member',NULL,NULL,NULL,1,184.373583,37.80711,0,NULL,58583910319,915373598,14302712,10.88),(91381,'TRGB','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91381,27.88,0.06,3.77,38511,NULL,NULL,NULL,'NGC 4244',NULL,'2005ApJ...633..810M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91382,'TRGB','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91382,28.16,0.07,4.29,38511,NULL,NULL,'I','NGC 4244',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91383,'TRGB','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91383,28.16,0.08,4.29,38511,NULL,NULL,NULL,'NGC 4244',NULL,'2005Ap.....48..221T',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91384,'TRGB','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91384,28.17,0.14,4.3,38511,NULL,NULL,NULL,'NGC 4244',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91385,'TRGB','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91385,28.19,0.12,4.34,38511,NULL,NULL,NULL,'NGC 4244',NULL,'2013AstBu..68..125M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91386,'TRGB','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91386,28.2,0.03,4.37,38511,NULL,NULL,NULL,'NGC 4244',NULL,'2005AJ....129.1331S',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91387,'TRGB','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91387,28.21,0.11,4.4,38511,NULL,NULL,'I','NGC 4244',NULL,'2011ApJS..195...18R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91388,'TRGB','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91388,28.26,NULL,4.49,38511,NULL,NULL,NULL,'NGC 4244',NULL,'2003A&A...398..467K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91389,'TRGB','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91389,28.32,0.09,4.62,38511,74.4,NULL,NULL,'NGC 4244',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91390,'IRAS','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91390,28.6,0.8,5.24,38511,75,NULL,'A82, H','NGC 4244',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91391,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91391,21.8,NULL,0.229,38511,NULL,NULL,'Dipole + Quadrupole','NGC 4244',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91392,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91392,22.58,NULL,0.329,38511,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 4244',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91393,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91393,27.43,0.4,3.1,38511,75,NULL,'B','NGC 4244',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91394,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91394,28.12,0.4,4.2,38511,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 4244',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91395,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91395,28.32,0.09,4.62,38511,74.4,NULL,NULL,'NGC 4244',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91396,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91396,28.33,NULL,4.63,38511,NULL,NULL,NULL,'NGC 4244',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91397,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91397,28.54,0.47,5.09,38511,75,NULL,'A82, H, inv','NGC 4244',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91398,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91398,28.54,NULL,5.11,38511,NULL,NULL,'LEDA [April 2006]','NGC 4244',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91399,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91399,28.65,0.47,5.37,38511,75,NULL,'A82, H, raw','NGC 4244',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91400,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91400,28.66,NULL,5.4,38511,NULL,NULL,'Dipole','NGC 4244',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91401,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91401,28.79,0.43,5.7,38511,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4244',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91402,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91402,28.87,0.43,5.9,38511,75,NULL,'3.6 micron, color corrected','NGC 4244',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91403,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91403,29.05,0.47,6.47,38511,75,NULL,'A82, H, cor','NGC 4244',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91404,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91404,28.58,0.43,5.2,38512,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4242',NULL,'2014MNRAS.444..527S',2014,1,5,NULL,'G',0.000007,NULL,'11.2B',3.8,'SAB(s)dm','Probable group member',NULL,NULL,NULL,1,184.37575,45.61931,0,NULL,59058526335,922789473,14418585,11.2),(91405,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91405,28.64,0.43,5.3,38512,75,NULL,'3.6 micron, color corrected','NGC 4242',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91406,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91406,28.68,0.2,5.45,38512,74.4,NULL,NULL,'NGC 4242',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91407,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91407,28.82,0.41,5.8,38512,73,NULL,'opt','NGC 4242',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91408,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91408,28.82,0.36,5.81,38512,NULL,NULL,NULL,'NGC 4242',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91409,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91409,29.38,0.4,7.5,38512,75,NULL,'B','NGC 4242',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91410,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91410,29.49,NULL,7.91,38512,NULL,NULL,NULL,'NGC 4242',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91411,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91411,30.08,0.07,10.4,38512,NULL,NULL,NULL,'NGC 4242',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91412,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91412,37.79,0.08,361,38513,70,NULL,NULL,'SDSS J121730.62+033612.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,184.377583,3.6035,0.015,NULL,58046409839,906975153,14171486,18.3),(91413,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91413,38.15,0.21,426,38514,70,NULL,NULL,'SDSS J121730.89+121849.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000147,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,184.37875,12.31381,0.035,NULL,58141077304,908454332,14194598,18.7),(91414,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91414,37.79,0.08,361,38515,70,NULL,NULL,'4C +04.41',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000215,NULL,'16.2g',0.41,'FR II','Group member of poor cluster',NULL,NULL,NULL,1,184.3809583,3.61569,0.015,NULL,58046407948,906975124,14171486,16.2),(91415,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91415,38.07,0.46,411,38516,70,NULL,NULL,'SDSS J121731.66-013238.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000166,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,184.3819583,-1.54414,0.065,NULL,43007921781,671998777,10499980,18.2),(91416,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91416,37.55,0.33,323,38517,70,NULL,NULL,'2MASX J12173266+5439560',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000126,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,184.386083,54.66583,0.005,NULL,57224971798,894140184,13970940,17.6),(91417,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91417,30.75,0.36,14.1,38518,NULL,NULL,NULL,'IC 3105',NULL,'2009AJ....138..323T',2009,1,1.8,NULL,'G',0.000013,NULL,'15.0g',0.48,'Im:            HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,184.390625,12.38811,0.035,NULL,58141067602,908454181,14194596,15),(91418,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91418,27.89,0.4,3.8,38519,75,NULL,'B','UGC 07321',NULL,'1988NBGC.C....0000T',1988,1,6.74,NULL,'G',0.000005,NULL,'14.0g',0.43,'Sd             HII','Isolated galaxy',NULL,NULL,NULL,1,184.3917083,22.54014,0.044,NULL,58864947068,919764797,14371324,14),(91419,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91419,31.18,NULL,17.2,38519,NULL,NULL,NULL,'UGC 07321',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91420,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91420,31.21,NULL,17.5,38519,NULL,NULL,NULL,'UGC 07321',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91421,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91421,31.26,NULL,17.8,38519,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07321',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91422,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91422,31.26,NULL,17.9,38519,NULL,NULL,'Dipole + Quadrupole','UGC 07321',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91423,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91423,31.26,NULL,17.9,38519,NULL,NULL,'Dipole','UGC 07321',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91424,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91424,31.73,0.2,22.2,38519,74.4,NULL,NULL,'UGC 07321',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91425,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91425,31.82,0.43,23.1,38519,75,NULL,'3.6 micron, color + selection bias corrected','UGC 07321',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91426,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91426,31.85,0.43,23.5,38519,75,NULL,'3.6 micron, color corrected','UGC 07321',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91427,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91427,37.55,0.1,324,38520,70,NULL,NULL,'2MASX J12173406+0521528',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000191,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,184.391875,5.36467,0,NULL,58036112451,906814257,14168972,16.8),(91428,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91428,37.45,0.33,310,38521,70,NULL,NULL,'2MASXi J1217353+055204',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,184.397125,5.86806,0,NULL,58024567042,906633860,14166154,17.6),(91429,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91429,38.15,0.46,426,38522,70,NULL,NULL,'2MASX J12173532+2222085',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.69',0.12,NULL,NULL,NULL,NULL,NULL,1,184.397125,22.36925,0.047,NULL,58864912870,919764263,14371316,18.69),(91430,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91430,37.79,0.08,361,38523,70,NULL,NULL,'SDSS J121735.40+035430.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,184.3975,3.90844,0.018,NULL,58046304654,906973510,14171461,18),(91431,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91431,36.99,0.46,250,38524,70,NULL,NULL,'2MASX J12173549+2037335',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,184.397875,20.62597,0.083,NULL,58870677071,919854329,14372723,17.7),(91432,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91432,37.38,0.46,300,38525,70,NULL,NULL,'2MASX J12173555+1356542',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000147,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,184.3982917,13.94844,0.142,NULL,58169277151,908894955,14201483,17.5),(91433,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91433,37.79,0.08,361,38526,70,NULL,NULL,'2MASX J12173611+0336018',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,184.400333333,3.60053,0.015,NULL,58046408503,906975132,14171486,17.7),(91434,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91434,38.38,0.46,474,38527,70,NULL,NULL,'2MASX J12173619+0500128',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,184.400833,5.00356,0,NULL,58036187131,906815423,14168990,17.9),(91435,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91435,37.99,0.46,396,38528,70,NULL,NULL,'2MASX J12173628+0137408',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000171,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,184.401291667,1.62808,0.016,NULL,58044403970,906943812,14170997,18),(91436,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91436,37.08,0.46,261,38529,70,NULL,NULL,'2MASX J12173635+3846175',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000173,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,184.4014583,38.77167,0,NULL,58582356018,915349312,14302333,16.7),(91437,'Ring Diameter','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91437,31,0.76,16,38530,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4245',NULL,'1981ApJS...45..541P',1981,1,2.9,NULL,'G',0.000071,NULL,'12.31',2.2,'SB(r)0/a:      HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,184.403208333,29.608,0.083,NULL,58632084664,916126322,14314473,12.31),(91438,'Ring Diameter','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91438,31.2,0.6,17,38530,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4245',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91439,'Tully est','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91439,29.93,0.8,9.7,38530,75,NULL,'B','NGC 4245',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91440,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91440,37.79,0.08,361,38531,70,NULL,NULL,'2MASX J12173711+0349378',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,184.4047083,3.82717,0.016,NULL,58046524395,906976943,14171514,17.3),(91441,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91441,36.15,0.33,170,38532,70,NULL,NULL,'2MASX J12173735+1900525',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.49',0.24,NULL,NULL,NULL,NULL,NULL,1,184.405833,19.01467,0.069,NULL,58861142229,919705347,14370396,16.49),(91442,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91442,34.2,NULL,69,38533,NULL,NULL,'Dipole','UGC 07327',NULL,'2010Ap&SS.325..163P',2010,1,2.35,NULL,'G',0.000006,NULL,'15.50',0.26,'Sbc',NULL,NULL,NULL,NULL,1,184.407,16.72742,0.055,NULL,58172603453,908946928,14202295,15.5),(91443,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91443,34.2,NULL,69.2,38533,NULL,NULL,'Dipole + Quadrupole','UGC 07327',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91444,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91444,34.21,NULL,69.5,38533,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07327',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91445,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91445,34.42,NULL,76.7,38533,NULL,NULL,NULL,'UGC 07327',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91446,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91446,35.11,0.49,105,38533,75,NULL,'IR','UGC 07327',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91447,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91447,35.15,0.36,107,38533,NULL,NULL,'Malmquist cor.','UGC 07327',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91448,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91448,35.38,0.2,119,38533,74.4,NULL,NULL,'UGC 07327',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91449,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91449,35.53,0.3,128,38533,NULL,NULL,NULL,'UGC 07327',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91450,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91450,37.79,0.08,361,38534,70,NULL,NULL,'2MASX J12173878+0339478',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000214,NULL,'16.8g',0.26,'AGN',NULL,NULL,NULL,NULL,1,184.411541667,3.66339,0.015,NULL,58046401825,906975028,14171484,16.8),(91451,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91451,37.45,0.46,308,38535,70,NULL,NULL,'2MASX J12173885+1350282',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000172,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,184.41175,13.84111,0.163,NULL,58169377105,908896517,14201508,17.8),(91452,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91452,36.76,0.46,225,38536,70,NULL,NULL,'2MASX J12173928+4034525',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000188,NULL,'16.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,184.413625,40.58119,0,NULL,58530318214,914536222,14289628,16.4),(91453,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91453,37.92,0.46,383,38537,70,NULL,NULL,'2MASX J12173961+0519248',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000171,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,184.4149583,5.32344,0,NULL,58036110197,906814221,14168972,17.6),(91454,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91454,37.79,0.08,361,38538,70,NULL,NULL,'2MASX J12174112+0339208',NULL,'2015arXiv151105856S',2015,1,0.64,'TXS codes: model(W);confusion(C);lobes(C)','G',0.000191,NULL,'15.9g',0.48,'E;BrClG','Group member of poor cluster',NULL,NULL,NULL,1,184.421333,3.65583,0.015,NULL,58046371352,906974552,14171477,15.9),(91455,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91455,36.14,0.46,169,38539,70,NULL,NULL,'2MASX J12174199+0410048',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000171,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,184.425,4.168,0.024,NULL,58035021897,906797217,14168706,16.4),(91456,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91456,37.6,0.27,331,38540,70,NULL,NULL,'CGPG 1215.4+6432',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,184.425167,64.25867,0.017,NULL,57316623825,895572247,13993316,17.6),(91457,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91457,38.15,0.21,426,38541,70,NULL,NULL,'2MASX J12174224+1227097',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000152,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,184.4260417,12.45275,0.027,NULL,58137527250,908398863,14193732,17.6),(91458,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91458,36.77,0.46,226,38542,70,NULL,NULL,'2MASX J12174286+2012005',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.17',0.14,NULL,NULL,NULL,NULL,NULL,1,184.4287917,20.20011,0.089,NULL,58869444396,919835068,14372422,18.17),(91459,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91459,37.79,0.08,361,38543,70,NULL,NULL,'2MASX J12174380+0412168',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000167,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,184.4325,4.20478,0.024,NULL,58035065257,906797894,14168717,17.1),(91460,'IRAS','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91460,35.13,0.8,106,38544,75,NULL,'MAT, I','ESO 573- G 006',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'14.5',0.7,'Sc:',NULL,NULL,NULL,NULL,1,184.43675,-22.17336,0.217,NULL,43896101158,685876580,10716821,14.5),(91461,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91461,34.64,0.32,84.9,38544,85,NULL,'I, raw','ESO 573- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91462,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91462,34.65,0.32,85.1,38544,85,NULL,'I, inv','ESO 573- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91463,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91463,34.85,0.43,93.5,38544,75,NULL,'MAT, I, raw','ESO 573- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91464,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91464,34.93,0.43,96.6,38544,75,NULL,'MAT, I, inv','ESO 573- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91465,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91465,35,0.2,100,38544,74.4,NULL,NULL,'ESO 573- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91466,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91466,35.17,0.43,108,38544,75,NULL,'MAT, I, cor','ESO 573- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91467,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91467,35.23,0.51,111,38544,NULL,NULL,NULL,'ESO 573- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91468,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91468,35.24,0.5,112,38544,NULL,NULL,'Malmquist cor.','ESO 573- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91469,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91469,38.06,0.46,410,38545,70,NULL,NULL,'2MASX J12174593+1319127',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,184.44125,13.32017,0.105,NULL,58170204309,908909442,14201710,17.4),(91470,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91470,36.96,0.46,246,38546,70,NULL,NULL,'2MASX J12174673+0038308',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000079,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,184.444708333,0.642,0.045,NULL,57987094909,906048357,14157005,17.4),(91471,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91471,34.41,0.69,76.3,38547,100,NULL,'mid-IR','IC 3107',NULL,'2013ApJ...771...88L',2013,1,1.38,NULL,'G',0.00001,NULL,'14.3g',0.61,'Sbc(s)I-II','Group member',NULL,NULL,NULL,1,184.4455417,10.84464,0.015,NULL,58212341835,909567841,14211997,14.3),(91472,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91472,35.02,0.25,101,38547,NULL,NULL,'Malmquist cor.','IC 3107',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91473,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91473,35.03,0.2,101,38547,74.4,NULL,NULL,'IC 3107',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91474,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91474,35.1,0.24,105,38547,NULL,NULL,NULL,'IC 3107',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91475,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91475,35.31,0.4,115,38547,NULL,NULL,'mean','IC 3107',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91476,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91476,35.31,0.47,115,38547,NULL,NULL,'H','IC 3107',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91477,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91477,35.43,0.45,122,38547,NULL,NULL,'K','IC 3107',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91478,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91478,35.46,0.46,124,38547,NULL,NULL,'J','IC 3107',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91479,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91479,38.05,0.46,408,38548,70,NULL,NULL,'SDSS J121747.26+095207.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,184.446958333,9.86881,0,NULL,58211186862,909549794,14211715,18.2),(91480,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91480,37.55,0.1,324,38549,70,NULL,NULL,'2MASX J12174901+0424293',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,184.454125,4.40817,0.024,NULL,58035774324,906808973,14168890,17.9),(91481,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91481,37.84,0.23,370,38550,70,NULL,NULL,'2MASX J12174978+0807051',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,184.457541667,8.11797,0,NULL,58207743804,909495996,14210874,17.7),(91482,'Tully est','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91482,29.32,0.8,7.3,38551,75,NULL,'B','NGC 4248',NULL,'1988NBGC.C....0000T',1988,1,2.85,NULL,'G',0.000037,NULL,'13.2g',0.92,'I0 sp          HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,184.4577083,47.40919,0,NULL,57191662114,893619720,13962808,13.2),(91483,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91483,29.35,NULL,7.41,38551,NULL,NULL,NULL,'NGC 4248',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91484,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91484,37.79,0.08,361,38552,70,NULL,NULL,'SDSS J121750.76+033437.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,184.461541667,3.57706,0.015,NULL,58046378242,906974660,14171479,17.7),(91485,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91485,38.15,0.21,426,38553,70,NULL,NULL,'2MASX J12175126+1221237',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000175,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,184.463667,12.35658,0.035,NULL,58137610860,908400169,14193752,17),(91486,'BL Lac Luminosity','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,NULL,91486,38.93,NULL,541,38554,NULL,NULL,NULL,'FBQS J1217+3007',0.13,'2005ApJ...635..173S',2005,1,NULL,'White, et al. (2000ApJS..126..133W) give z = 0.237.','QSO',NULL,NULL,'15.5',NULL,'Opt.var.       BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,184.467,30.11683,0.053,NULL,58629686487,916088851,14313888,15.5),(91487,'FP','2016-12-15 15:14:57','2016-12-16 11:20:06','1',NULL,'R',91487,37.42,0.46,305,38555,70,NULL,NULL,'2MASX J12175212+3825525',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,184.467125,38.43125,0,NULL,58585732811,915402075,14303157,16.8),(91488,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91488,37.53,0.46,321,38556,70,NULL,NULL,'2MASX J12175226+0640571',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00018,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,184.467791667,6.68258,0,NULL,58024510277,906632973,14166140,16.9),(91489,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91489,38.09,0.46,415,38557,70,NULL,NULL,'2MASX J12175288+0526483',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,184.470375,5.44667,0,NULL,58032677317,906760583,14168134,17.8),(91490,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91490,37.79,0.08,361,38558,70,NULL,NULL,'SDSS J121752.90+033826.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000174,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,184.470417,3.64058,0.015,NULL,58046372660,906974572,14171477,18.3),(91491,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91491,38.99,0.46,629,38559,70,NULL,NULL,'2MASX J12175315+2952580',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000157,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,184.471541667,29.88289,0.06,NULL,58632042208,916125659,14314463,18.5),(91492,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91492,37.79,0.08,361,38560,70,NULL,NULL,'2MASX J12175333+0341403',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000238,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,184.472333,3.69458,0.015,NULL,58046492117,906976439,14171506,16.6),(91493,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91493,37.44,0.33,308,38561,70,NULL,NULL,'2MASX J12175346+4749319',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000172,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,184.472666667,47.82547,0,NULL,57191828080,893622313,13962848,17.2),(91494,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91494,37.54,0.46,323,38562,70,NULL,NULL,'2MASX J12175348+4916409',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,184.4727917,49.27817,0,NULL,57189522969,893586296,13962285,17.5),(91495,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91495,35.79,0.46,144,38563,70,NULL,NULL,'2MASX J12175410+4902079',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000171,NULL,'15.6g',0.47,'E0',NULL,NULL,NULL,NULL,1,184.4752083,49.03561,0,NULL,57189985174,893593518,13962398,15.6),(91496,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91496,36.15,0.33,170,38564,70,NULL,NULL,'2MASX J12175467+1901243',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.03',0.23,NULL,NULL,NULL,NULL,NULL,1,184.477833,19.02344,0.065,NULL,58861143213,919705362,14370396,16.03),(91497,'Black Hole','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91497,35.02,1.04,101,38565,NULL,NULL,NULL,'MRK 0202',NULL,'2014ApJ...793..108W',2014,1,0.53,NULL,'G',0.000367,NULL,'15.4g',0.42,'Compact',NULL,NULL,NULL,'Sy 1',1,184.479167,58.65986,0,NULL,57343280937,895988764,13999824,15.4),(91498,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91498,37.79,0.46,361,38566,70,NULL,NULL,'2MASX J12175564+3000260',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000184,NULL,'18.26',0.15,NULL,NULL,NULL,NULL,NULL,1,184.481875,30.00728,0.053,NULL,58631988348,916124817,14314450,18.26),(91499,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91499,38.57,0.46,518,38567,70,NULL,NULL,'SDSS J121755.74+621903.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000171,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,184.4822917,62.31778,0.021,NULL,57373737869,896464654,14007260,18.2),(91500,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91500,38.15,0.21,426,38568,70,NULL,NULL,'2MASX J12175577+1221517',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,184.482375,12.36439,0.035,NULL,58137610465,908400163,14193752,18.2),(91501,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91501,31.23,0.4,17.6,38569,75,NULL,'B','UGC 07332',NULL,'1988NBGC.C....0000T',1988,1,2.3,'The APM position is about 6 arcsec northwest of the center of the bar.','G',0.000013,NULL,'14.0B',1.3,'SB(s)m IV-V','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,184.484625,0.4355,0.024,NULL,57986941959,906045968,14156968,14),(91502,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91502,37.55,0.1,324,38570,70,NULL,NULL,'2MASX J12175636+0427153',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,184.4847917,4.45425,0.039,NULL,58035796703,906809323,14168895,17.1),(91503,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91503,36.74,0.33,223,38571,70,NULL,NULL,'2MASX J12175642+2155403',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.83',0.29,NULL,NULL,NULL,NULL,NULL,1,184.4849583,21.92781,0.052,NULL,58864387694,919756057,14371188,16.83),(91504,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91504,37.79,0.08,361,38572,70,NULL,NULL,'2MASX J12175641+0340383',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000166,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,184.485083333,3.67739,0.015,NULL,58046492589,906976446,14171506,17.6),(91505,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91505,37.79,0.08,361,38573,70,NULL,NULL,'2MASX J12175662+0331323',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000159,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,184.485875,3.52575,0.015,NULL,58046847876,906981998,14171593,17.4),(91506,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91506,37.84,0.23,370,38574,70,NULL,NULL,'2MASX J12175672+0809231',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,'PHOT','18.37',0.18,NULL,NULL,NULL,NULL,NULL,1,184.48625,8.15642,0,NULL,58207543454,909492866,14210826,18.37),(91507,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91507,37.84,0.23,370,38575,70,NULL,NULL,'2MASX J12175767+0809581',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,184.49025,8.16619,0,NULL,58207544180,909492877,14210826,16.7),(91508,'IRAS','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91508,33.63,0.8,53.2,38576,75,NULL,'A82, H','NGC 4246',NULL,'1997ApJS..109..333W',1997,1,2.59,NULL,'G',0.00001,NULL,'13.6g',0.89,'SA(s)c','in a pair',NULL,NULL,NULL,1,184.492167,7.18592,0,NULL,58207789010,909496703,14210885,13.6),(91509,'IRAS','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91509,33.63,0.8,53.3,38576,75,NULL,'CF, r','NGC 4246',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91510,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91510,32.71,0.69,34.9,38576,100,NULL,'mid-IR','NGC 4246',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91511,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91511,33.35,NULL,46.8,38576,NULL,NULL,'I','NGC 4246',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91512,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91512,33.37,0.38,47.2,38576,75,NULL,'CF, r, raw','NGC 4246',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91513,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91513,33.49,0.38,49.9,38576,75,NULL,'CF, r, inv','NGC 4246',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91514,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91514,33.51,0.33,50.4,38576,91,NULL,'H','NGC 4246',NULL,'1984ApJ...278..475B',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91515,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91515,33.55,0.2,51.3,38576,74.4,NULL,NULL,'NGC 4246',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91516,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91516,33.59,0.38,52.1,38576,75,NULL,'CF, r, cor','NGC 4246',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91517,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91517,33.71,NULL,55.2,38576,NULL,NULL,'B','NGC 4246',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91518,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91518,33.75,0.52,56.1,38576,NULL,NULL,NULL,'NGC 4246',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91519,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91519,33.76,0.51,56.5,38576,NULL,NULL,'Malmquist cor.','NGC 4246',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91520,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91520,33.79,0.4,57.3,38576,NULL,NULL,'mean','NGC 4246',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91521,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91521,33.97,0.46,62.2,38576,NULL,NULL,'J','NGC 4246',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91522,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91522,33.99,0.47,62.7,38576,NULL,NULL,'H','NGC 4246',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91523,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91523,34.08,0.45,65.5,38576,NULL,NULL,'K','NGC 4246',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91524,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91524,34.22,0.47,69.9,38576,75,NULL,'A82, H, raw','NGC 4246',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91525,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91525,34.37,0.47,74.8,38576,75,NULL,'A82, H, inv','NGC 4246',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91526,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91526,34.58,0.47,82.4,38576,75,NULL,'A82, H, cor','NGC 4246',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91527,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91527,37.5,0.46,316,38577,70,NULL,NULL,'2MASX J12175940+0745581',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000176,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,184.497625,7.76625,0,NULL,58208457608,909507150,14211049,17.3),(91528,'IRAS','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91528,34.54,0.8,80.9,38578,75,NULL,'MAT, I','NGC 4219A',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.38',0.6,'SAB(s)bc',NULL,NULL,NULL,NULL,1,184.4995417,-43.54003,0.561,NULL,46721488092,730023251,11406613,14.38),(91529,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91529,34.26,0.43,71,38578,75,NULL,'MAT, I, raw','NGC 4219A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91530,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91530,34.28,0.47,71.9,38578,NULL,NULL,'H','NGC 4219A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91531,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91531,34.32,0.49,73,38578,NULL,NULL,'Malmquist cor.','NGC 4219A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91532,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91532,34.33,0.45,73.3,38578,NULL,NULL,'K','NGC 4219A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91533,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91533,34.37,0.46,74.9,38578,NULL,NULL,'J','NGC 4219A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91534,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91534,34.42,0.32,76.6,38578,85,NULL,'I, raw','NGC 4219A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91535,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91535,34.49,0.43,78.9,38578,75,NULL,'MAT, I, cor','NGC 4219A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91536,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91536,34.49,0.32,79,38578,85,NULL,'I, inv','NGC 4219A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91537,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91537,34.53,0.43,80.7,38578,75,NULL,'MAT, I, inv','NGC 4219A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91538,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91538,34.58,0.43,82.5,38578,NULL,NULL,NULL,'NGC 4219A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91539,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91539,34.61,0.4,83.6,38578,NULL,NULL,'mean','NGC 4219A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91540,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91540,34.62,0.2,84,38578,74.4,NULL,NULL,'NGC 4219A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91541,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91541,30.9,0.2,15.1,38579,74.4,NULL,NULL,'NGC 4241',NULL,'2013AJ....146...86T',2013,1,1.19,'1983ApJS...52...89H gives v=2261 km/sec, but mistakes N4241 for N4223.','G',0.000022,NULL,'14.5g',0.95,'SB(s)cd        HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,184.499583,6.65419,0,NULL,58024511791,906632996,14166140,14.5),(91542,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91542,30.94,0.43,15.4,38579,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4241',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91543,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91543,30.97,0.43,15.7,38579,75,NULL,'3.6 micron, color corrected','NGC 4241',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91544,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91544,31.03,0.79,16.1,38579,NULL,NULL,NULL,'NGC 4241',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91545,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91545,31.4,0.67,19.1,38579,NULL,NULL,'Malmquist cor.','NGC 4241',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91546,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91546,31.79,0.36,22.8,38579,NULL,NULL,NULL,'NGC 4241',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91547,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91547,32.08,NULL,26.1,38579,NULL,NULL,NULL,'NGC 4241',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91548,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91548,37.79,0.08,361,38580,70,NULL,NULL,'SDSS J121800.17+034333.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,184.500708333,3.72583,0.016,NULL,58046542031,906977219,14171519,18.1),(91549,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91549,37.9,0.46,380,38581,70,NULL,NULL,'2MASX J12180191+0606141',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000171,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,184.507833,6.10394,0,NULL,58024696739,906635886,14166185,17.1),(91550,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91550,38.15,0.21,426,38582,70,NULL,NULL,'2MASX J12180204+1229298',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,184.508458333,12.49167,0.027,NULL,58137531879,908398935,14193733,18),(91551,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91551,34.94,0.7,97.2,38583,70,NULL,NULL,'ESO 573- G 007',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000103,NULL,'15.10',1,'Sb',NULL,NULL,NULL,NULL,1,184.508625,-20.85319,0.113,NULL,43905772236,686027691,10719182,15.1),(91552,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91552,34.88,0.46,94.5,38584,70,NULL,NULL,'CGCG 269-050',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000174,NULL,'15.2g',0.56,'E0',NULL,NULL,NULL,NULL,1,184.50925,50.45372,0.012,NULL,57232449615,894257025,13972766,15.2),(91553,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91553,37.55,0.33,323,38585,70,NULL,NULL,'2MASX J12180231+5442159',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,184.509667,54.70442,0.005,NULL,57224959559,894139993,13970937,17.4),(91554,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91554,37.48,0.46,313,38586,70,NULL,NULL,'2MASX J12180385+1850043',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,184.516083,18.83447,0.069,NULL,58861259205,919707175,14370424,NULL),(91555,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91555,37.55,0.1,324,38587,70,NULL,NULL,'SDSS J121804.59+044021.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000173,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,184.519167,4.67264,0.009,NULL,58035700792,906807824,14168872,18.1),(91556,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91556,37.32,0.46,291,38588,70,NULL,NULL,'2MASX J12180478+2923450',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000048,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,184.519917,29.39581,0.105,NULL,58631532306,916117692,14314338,17.5),(91557,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91557,34.48,0.49,78.8,38589,75,NULL,'IR','UGC 07336',NULL,'2011yCatp016004901K',2011,1,1.12,'RC3 gives v=5697 +/- 12 km/sec.','G',0.000013,NULL,'15.3g',0.29,'Sc','Group member',NULL,NULL,NULL,1,184.5197917,15.96553,0.056,NULL,58174161776,908971277,14202676,15.3),(91558,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91558,37.55,0.1,324,38590,70,NULL,NULL,'2MASX J12180515+0503054',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,184.5215417,5.05153,0,NULL,58036270214,906816722,14169011,17.4),(91559,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91559,38.1,0.46,416,38591,70,NULL,NULL,'2MASX J12180530+4245117',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000175,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,184.5220417,42.75319,0,NULL,59062157241,922846206,14419471,17.7),(91560,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91560,37.79,0.08,361,38592,70,NULL,NULL,'2MASX J12180623+0342114',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000183,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,184.526,3.70325,0.016,NULL,58046485655,906976338,14171505,17.2),(91561,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91561,35.53,0.46,128,38593,70,NULL,NULL,'VCC 0272',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000087,NULL,'15.5g',0.36,'S0_1_(6)','Group member',NULL,NULL,NULL,1,184.528583,10.89625,0.015,NULL,58212457799,909569653,14212025,15.5),(91562,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91562,32.53,NULL,32,38594,NULL,NULL,NULL,'VCC 0274',NULL,'2014A&A...562A..49M',2014,1,0.72,NULL,'G',NULL,NULL,'17.5',0.29,'BCD?','Group member',NULL,NULL,NULL,1,184.531375,5.93028,0,NULL,58024734907,906636482,14166195,17.5),(91563,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91563,37.75,0.46,354,38595,70,NULL,NULL,'CGPG 1215.8+6337',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000134,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,184.531583,63.34278,0.013,NULL,57372208966,896440765,14006886,17.7),(91564,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91564,35.53,0.49,128,38596,NULL,NULL,'Malmquist cor.','ESO 573- G 008',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'13.55',0.5,'Sb:',NULL,NULL,NULL,NULL,1,184.533375,-18.47633,0.081,NULL,43899159504,685924367,10717568,13.55),(91565,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91565,35.57,0.48,130,38596,NULL,NULL,NULL,'ESO 573- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91566,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91566,35.61,0.2,132,38596,74.4,NULL,NULL,'ESO 573- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91567,'SBF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91567,31.45,0.14,19.5,38597,74.4,NULL,NULL,'NGC 4251',NULL,'2013AJ....146...86T',2013,1,3.6,NULL,'G',0.000017,NULL,'11.58',1.5,'SB0? sp','in a radial-velocity based grouping',NULL,NULL,NULL,1,184.534375,28.17539,0.084,NULL,58638427057,916225422,14316022,11.58),(91568,'SBF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91568,31.46,0.2,19.6,38597,NULL,NULL,'I','NGC 4251',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91569,'Faber-Jackson','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91569,30.22,0.65,11.1,38597,95,NULL,'Weighted Mean','NGC 4251',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91570,'Faber-Jackson','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91570,31.26,0.81,17.9,38597,55,NULL,'Visvanathan & Sandage 1979','NGC 4251',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91571,'Tertiary','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91571,30.98,0.27,15.7,38597,95,NULL,NULL,'NGC 4251',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91572,'Tully est','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91572,29.93,0.8,9.7,38597,75,NULL,'B','NGC 4251',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91573,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91573,29.92,0.45,9.66,38597,NULL,NULL,'K','NGC 4251',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91574,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91574,30.83,0.4,14.7,38597,NULL,NULL,'mean','NGC 4251',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91575,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91575,33.67,0.69,54.3,38598,100,NULL,'mid-IR','NGC 4202',NULL,'2013ApJ...771...88L',2013,1,1.2,NULL,'G',0.000017,NULL,'14.4g',0.62,'SAB(rs)bc',NULL,NULL,NULL,NULL,1,184.535625,-1.06411,0.065,NULL,42958602750,671228167,10487940,14.4),(91576,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91576,34.47,0.2,78.3,38598,74.4,NULL,NULL,'NGC 4202',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91577,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91577,34.53,0.36,80.6,38598,NULL,NULL,'Malmquist cor.','NGC 4202',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91578,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91578,34.64,0.34,84.7,38598,NULL,NULL,NULL,'NGC 4202',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91579,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91579,37.4,0.46,302,38599,70,NULL,NULL,'2MASX J12180874+1414329',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,184.536583,14.24244,0.139,NULL,58181827033,909091047,14204547,17.7),(91580,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91580,37.35,0.33,295,38600,70,NULL,NULL,'2MASX J12180893+1336489',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000137,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,184.537167,13.61364,0.168,NULL,58169881251,908904394,14201631,17.5),(91581,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91581,37.34,0.46,293,38601,70,NULL,NULL,'2MASX J12181005+3728215',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000186,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,184.542,37.47269,0,NULL,58583855943,915372749,14302699,16.5),(91582,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91582,37.73,0.46,351,38602,70,NULL,NULL,'SDSS J121810.21+150336.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000163,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,184.542583,15.06025,0.081,NULL,58181672023,909088625,14204509,18.3),(91583,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91583,35.08,0.46,104,38603,70,NULL,NULL,'CGCG 243-065',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.0001,NULL,'14.8g',0.62,'E0',NULL,NULL,NULL,NULL,1,184.54375,44.40047,0,NULL,59071245227,922988206,14421690,14.8),(91584,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91584,37.12,0.33,265,38604,70,NULL,NULL,'2MASX J12181072+2802300',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000162,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,184.544708333,28.04181,0.084,NULL,58638364490,916224445,14316006,16.4),(91585,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91585,37.59,0.46,329,38605,70,NULL,NULL,'2MASX J12181200+3048038',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000132,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,184.550125,30.80103,NULL,NULL,58760504756,918132886,14345826,17.9),(91586,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91586,37.55,0.1,324,38606,70,NULL,NULL,'SDSS J121812.19+051216.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,184.5507917,5.20461,0,NULL,58036284027,906816937,14169014,18),(91587,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91587,37.79,0.08,361,38607,70,NULL,NULL,'2MASX J12181237+0346374',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000179,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,184.551541667,3.77711,0.016,NULL,58046507657,906976682,14171510,17.4),(91588,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91588,37.12,0.33,265,38608,70,NULL,NULL,'2MASX J12181291+2802180',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000178,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,184.553875,28.03833,0.084,NULL,58638362369,916224412,14316006,17.4),(91589,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91589,37.79,0.08,361,38609,70,NULL,NULL,'2MASX J12181531+0347184',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,184.5639583,3.78839,0.016,NULL,58046506271,906976660,14171510,17.1),(91590,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91590,37.21,0.46,276,38610,70,NULL,NULL,'2MASX J12181599+0734082',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,184.566625,7.56881,0,NULL,58208449023,909507015,14211047,17.2),(91591,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91591,37.56,0.33,326,38611,70,NULL,NULL,'SDSS J121817.03+444059.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,184.571,44.68308,0,NULL,59071060392,922985318,14421645,17.9),(91592,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91592,37.47,0.33,311,38612,70,NULL,NULL,'2MASX J12181765+0221204',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,184.5735,2.35572,0,NULL,58044147371,906939802,14170934,17),(91593,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91593,36.98,0.33,249,38613,70,NULL,NULL,'2MASX J12181778+4352337',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000188,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,184.574167,43.876,0,NULL,59071388926,922990451,14421725,16.7),(91594,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91594,37.79,0.08,361,38614,70,NULL,NULL,'2MASX J12181803+0343534',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,184.575125,3.73161,0.016,NULL,58046505539,906976649,14171510,17),(91595,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91595,37.6,0.27,331,38615,70,NULL,NULL,'2MASX J12181828+6419118',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,184.576166667,64.31994,0.017,NULL,57324190531,895690477,13995163,17.3),(91596,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91596,37.47,0.33,311,38616,70,NULL,NULL,'2MASX J12181844+0229194',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,184.576833,2.48875,0.018,NULL,58042106062,906907907,14170436,17.9),(91597,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91597,37.62,0.46,334,38617,70,NULL,NULL,'2MASX J12181853+1010532',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000171,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,184.577167,10.18139,0,NULL,58211956005,909561812,14211903,17.5),(91598,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91598,37.55,0.1,324,38618,70,NULL,NULL,'2MASX J12181962+0456064',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000177,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,184.58175,4.93506,0,NULL,58036421066,906819079,14169048,16.5),(91599,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91599,36.93,0.46,244,38619,70,NULL,NULL,'2MASX J12181974+2652150',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000113,NULL,'16.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,184.582375,26.871,0.091,NULL,58653092729,916454573,14319602,16.3),(91600,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91600,38.16,0.46,429,38620,70,NULL,NULL,'2MASX J12182111+1637510',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,184.588083,16.63078,0.055,NULL,58174702929,908979733,14202808,17.9),(91601,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91601,37.44,0.33,308,38621,70,NULL,NULL,'2MASX J12182135+4755029',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000228,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,184.589167,47.91739,0,NULL,57183645399,893494459,13960850,16.5),(91602,'IRAS','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91602,34.93,0.8,96.7,38622,75,NULL,'HMCL, I','IC 3122',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000007,NULL,'14.31',0.8,'Sb',NULL,NULL,NULL,NULL,1,184.58925,25.21681,0.054,NULL,58647675089,916369923,14318280,14.31),(91603,'IRAS','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91603,34.93,0.8,96.8,38622,75,NULL,'CF, r','IC 3122',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91604,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91604,34.1,0.49,66.1,38622,NULL,NULL,NULL,'IC 3122',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91605,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91605,34.14,0.2,67.3,38622,74.4,NULL,NULL,'IC 3122',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91606,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91606,34.16,0.48,68,38622,NULL,NULL,'Malmquist cor.','IC 3122',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91607,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91607,34.23,0.4,70.2,38622,75,NULL,'HMCL, I, raw','IC 3122',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91608,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91608,34.39,0.4,75.3,38622,75,NULL,'HMCL, I, inv','IC 3122',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91609,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91609,34.39,0.38,75.6,38622,75,NULL,'CF, r, raw','IC 3122',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91610,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91610,34.52,0.38,80.3,38622,75,NULL,'CF, r, inv','IC 3122',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91611,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91611,34.56,0.4,81.7,38622,75,NULL,'HMCL, I, cor','IC 3122',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91612,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91612,34.71,0.38,87.3,38622,75,NULL,'CF, r, cor','IC 3122',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91613,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91613,36.98,0.33,249,38623,70,NULL,NULL,'2MASX J12182204+4354237',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000152,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,184.591833333,43.90658,0,NULL,59071388134,922990439,14421725,17.5),(91614,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91614,37.96,0.46,392,38624,70,NULL,NULL,'2MASX J12182221+5127029',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000194,NULL,'17.1g',0.27,'AGN',NULL,NULL,NULL,NULL,1,184.592417,51.45075,0.024,NULL,57233942576,894280352,13973130,17.1),(91615,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91615,37.95,0.46,389,38625,70,NULL,NULL,'2MASX J12182243+0508464',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000173,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,184.5935417,5.14642,0,NULL,58036282237,906816909,14169014,18.1),(91616,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91616,37.6,0.27,331,38626,70,NULL,NULL,'CGPG 1215.9+6433',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000146,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,184.594,64.26339,0.017,NULL,57316631905,895572373,13993318,17.7),(91617,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91617,36.27,0.46,179,38627,70,NULL,NULL,'2MASX J12182428+2818311',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.00013,NULL,'15.8g',0.43,NULL,NULL,NULL,NULL,NULL,1,184.601166667,28.30872,0.087,NULL,58638439585,916225618,14316025,15.8),(91618,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91618,37.79,0.08,361,38628,70,NULL,NULL,'2MASX J12182458+0327134',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000183,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,184.6022917,3.45358,0.013,NULL,58047022248,906984722,14171636,17.1),(91619,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91619,36.91,0.46,241,38629,70,NULL,NULL,'2MASX J12182505+3358177',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000173,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,184.604375,33.97156,0,NULL,58764198938,918190608,14346728,16.5),(91620,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91620,38.05,0.46,407,38630,70,NULL,NULL,'SDSS J121825.30+660746.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000121,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,184.6054583,66.12961,0.013,NULL,57313822475,895528476,13992632,18.3),(91621,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91621,38.26,0.46,450,38631,70,NULL,NULL,'2MASX J12182592+6159399',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000178,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,184.60775,61.99453,0.013,NULL,57371399655,896428119,14006689,17),(91622,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91622,37.51,0.33,318,38632,70,NULL,NULL,'2MASX J12182640+3152438',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.37',0.22,NULL,NULL,NULL,NULL,NULL,1,184.6102083,31.87878,0,NULL,58768963192,918265049,14347891,17.37),(91623,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91623,37.55,0.1,324,38633,70,NULL,NULL,'SDSS J121826.81+051825.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,184.6117083,5.30697,0,NULL,58032668690,906760448,14168132,18.5),(91624,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91624,36.76,0.46,225,38634,70,NULL,NULL,'2MASX J12182725+0319324',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000166,NULL,'16.5g',0.38,NULL,NULL,NULL,NULL,NULL,1,184.613708333,3.32567,0.013,NULL,58047046506,906985101,14171642,16.5),(91625,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91625,35.69,0.65,137,38635,70,NULL,NULL,'2MASX J12182740-1857217',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.4,NULL,NULL,NULL,NULL,NULL,1,184.614125,-18.95603,0.081,NULL,43901360951,685958764,10718105,14.3),(91626,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91626,35.54,NULL,128,38636,NULL,NULL,'Dipole + Quadrupole','FGC 1405',NULL,'2010Ap&SS.325..163P',2010,1,0.89,NULL,'G',0.000007,NULL,'16.4g',0.21,'Sbc',NULL,NULL,NULL,NULL,1,184.6152083,12.6965,0.025,NULL,58167193695,908862401,14200975,16.4),(91627,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91627,35.55,NULL,129,38636,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1405',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91628,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91628,35.55,NULL,129,38636,NULL,NULL,'Dipole','FGC 1405',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91629,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91629,35.55,0.49,129,38636,75,NULL,'IR','FGC 1405',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91630,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91630,35.73,NULL,140,38636,NULL,NULL,NULL,'FGC 1405',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91631,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91631,36.06,0.2,163,38636,74.4,NULL,NULL,'FGC 1405',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91632,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91632,37.15,0.46,269,38637,70,NULL,NULL,'VII Zw 448',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00018,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,184.618083,57.23844,0,NULL,57397663131,896838486,14013101,16.4),(91633,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91633,37.32,0.27,291,38638,70,NULL,NULL,'2MASX J12182884+4227397',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000176,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,184.6202083,42.46097,0,NULL,58528399888,914506248,14289160,16.2),(91634,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91634,36.82,0.46,231,38639,70,NULL,NULL,'2MASX J12182919+5501307',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000184,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,184.621583,55.02528,0.005,NULL,57224026955,894125421,13970709,16.7),(91635,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91635,37.55,0.1,324,38640,70,NULL,NULL,'SDSS J121829.30+042925.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,184.622083,4.49028,0.039,NULL,58035632243,906806753,14168855,17.8),(91636,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91636,36.8,0.46,229,38641,70,NULL,NULL,'2MASX J12183083+4025122',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000183,NULL,'15.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,184.6285417,40.42019,0,NULL,58530414077,914537719,14289651,15.7),(91637,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91637,37.99,0.46,396,38642,70,NULL,NULL,'2MASX J12183125+2937371',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,184.6302917,29.62708,0.087,NULL,58632169252,916127644,14314494,18),(91638,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91638,38.11,0.46,420,38643,70,NULL,NULL,'2MASX J12183246+1348290',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000172,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,184.635291667,13.80803,0.163,NULL,58170003184,908906299,14201660,17.9),(91639,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91639,38.31,0.27,460,38644,70,NULL,NULL,'SDSS J121833.27+275621.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000095,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,184.638666667,27.93936,0.075,NULL,58637855329,916216489,14315882,18.4),(91640,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91640,37.79,0.08,361,38645,70,NULL,NULL,'2MASX J12183433+0338424',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000195,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,184.642958333,3.64506,0.015,NULL,58046458187,906975909,14171498,17.4),(91641,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91641,38.01,0.33,400,38646,70,NULL,NULL,'SDSS J121834.56+054427.7',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.5g',0.26,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,184.6440417,5.74106,0,NULL,58024633754,906634902,14166170,16.5),(91642,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91642,37.12,0.46,266,38647,70,NULL,NULL,'2MASX J12183475+3230281',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00019,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,184.644875,32.50775,0,NULL,58770499553,918289055,14348266,16.2),(91643,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91643,37.72,0.46,351,38648,70,NULL,NULL,'2MASX J12183587+0330484',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,184.6494583,3.51353,0.013,NULL,58046959052,906983735,14171620,17.2),(91644,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91644,37.59,0.46,329,38649,70,NULL,NULL,'2MASX J12183586+2848131',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00016,NULL,'16.8g',0.27,'S0',NULL,NULL,NULL,NULL,1,184.649583,28.80356,0.099,NULL,58630489285,916101395,14314084,16.8),(91645,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91645,37.65,0.46,338,38650,70,NULL,NULL,'2MASXi J1218361+005338',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00007,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,184.650417,0.89375,0.019,NULL,57986674909,906041795,14156903,17.4),(91646,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91646,37.55,0.1,324,38651,70,NULL,NULL,'2MASX J12183628+0434394',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00017,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,184.651,4.57753,0.039,NULL,58036489569,906820149,14169064,16.2),(91647,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91647,36.87,0.46,237,38652,70,NULL,NULL,'2MASX J12183660+6141089',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000178,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,184.65275,61.68586,0.013,NULL,57371359975,896427499,14006679,16.4),(91648,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91648,36.71,0.46,219,38653,70,NULL,NULL,'2MASX J12183670-0131007',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,184.653041667,-1.51681,0.053,NULL,43008051314,672000801,10500012,17.4),(91649,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91649,37.32,0.46,291,38654,70,NULL,NULL,'2MASX J12183694+1028525',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000136,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,184.6539583,10.48131,0.005,NULL,58212570314,909571411,14212053,17.8),(91650,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91650,38.31,0.27,460,38655,70,NULL,NULL,'SDSS J121837.57+275959.4',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000147,NULL,'17.8g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,184.656583333,27.99986,0.075,NULL,58637847698,916216370,14315880,17.8),(91651,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91651,36.39,0.23,190,38656,70,NULL,NULL,'2MASX J12183780+4843080',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000185,NULL,'15.7g',0.45,'E0',NULL,NULL,NULL,NULL,1,184.657333,48.719,0,NULL,57182296522,893473383,13960521,15.7),(91652,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91652,36.39,0.23,190,38657,70,NULL,NULL,'2MASX J12183779+4831490',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000184,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,184.6575,48.53028,0,NULL,57182260574,893472821,13960512,16.5),(91653,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91653,36,0.46,158,38658,70,NULL,NULL,'2MASX J12183786+3539401',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000176,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,184.657875,35.66106,0,NULL,58543231999,914737999,14292781,16.5),(91654,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91654,32.26,0.2,28.3,38659,74.4,NULL,NULL,'VCC 0297',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.00001,NULL,'15.6g',0.26,'Sc (on edge)','X-ray-bright group member',NULL,NULL,NULL,1,184.6609583,6.70839,0,NULL,58205110560,909454852,14210232,15.6),(91655,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91655,33.37,NULL,47.1,38659,NULL,NULL,'Dipole + Quadrupole + Octopole','VCC 0297',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91656,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91656,33.39,NULL,47.6,38659,NULL,NULL,'Dipole + Quadrupole','VCC 0297',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91657,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91657,33.41,NULL,48.1,38659,NULL,NULL,'Dipole','VCC 0297',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91658,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91658,33.47,NULL,49.3,38659,NULL,NULL,NULL,'VCC 0297',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91659,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91659,37.51,0.33,318,38660,70,NULL,NULL,'2MASX J12183870+3154191',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'18.22',0.21,NULL,NULL,NULL,NULL,NULL,1,184.6612917,31.90517,0,NULL,58768957900,918264967,14347890,18.22),(91660,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91660,37.55,0.1,324,38661,70,NULL,NULL,'2MASX J12183969+0500014',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000184,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,184.6654583,5.00042,0,NULL,58036240320,906816255,14169003,17.1),(91661,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91661,36.39,0.23,190,38662,70,NULL,NULL,'MCG +08-22-102',NULL,'2015arXiv151105856S',2015,1,0.88,NULL,'G',0.000083,NULL,'15.0g',0.62,'E0',NULL,NULL,NULL,NULL,1,184.667417,48.87936,0,NULL,57182407992,893475124,13960548,15),(91662,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91662,36.55,0.46,204,38663,70,NULL,NULL,'2MASX J12184025-0015227',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000088,NULL,'16.0g',0.34,'S0',NULL,NULL,NULL,NULL,1,184.667625,-0.25647,0.041,NULL,42959004718,671234448,10488038,16),(91663,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91663,38.29,0.21,454,38664,70,NULL,NULL,'2MASX J12184177+6331220',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000138,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,184.674167,63.52292,0.013,NULL,57316808405,895575131,13993361,18.1),(91664,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91664,37.13,0.2,267,38665,74.4,NULL,NULL,'IC 3128A',NULL,'2013AJ....146...86T',2013,1,0.6,'ALFALFA source may include the galaxy VIII Zw 180 NOTES03.','G',0.000005,NULL,'15.19',0.4,'Sc','Group member',NULL,NULL,NULL,1,184.6744583,11.73183,0.022,NULL,58137983190,908405987,14193843,15.19),(91665,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91665,36.39,0.23,190,38666,70,NULL,NULL,'2MASX J12184213+4834540',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,184.6754583,48.58156,0,NULL,57182271336,893472989,13960515,16.5),(91666,'Tully est','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91666,32.96,0.8,39.1,38667,75,NULL,'B','NGC 4256',NULL,'1988NBGC.C....0000T',1988,1,4.5,NULL,'G',0.000047,NULL,'12.70',0.8,'SA(s)b: sp','in a radial-velocity based grouping',NULL,NULL,NULL,1,184.6795417,65.89825,0.013,NULL,57325110153,895704846,13995388,12.7),(91667,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91667,32.77,0.49,35.8,38667,75,NULL,'IR','NGC 4256',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91668,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91668,33.02,0.4,40.2,38667,75,NULL,NULL,'NGC 4256',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91669,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91669,37.53,0.46,321,38668,70,NULL,NULL,'2MASXi J1218431+341311',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,184.68,34.21961,0,NULL,58764160825,918190012,14346718,17.5),(91670,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91670,37.55,0.1,324,38669,70,NULL,NULL,'2MASX J12184485+0513234',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,184.687,5.22319,0,NULL,58032751762,906761746,14168152,17.2),(91671,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91671,36.52,0.75,201,38670,70,NULL,NULL,'2MASX J12184532-0531377',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'17.12',0.26,NULL,NULL,NULL,NULL,NULL,1,184.688791667,-5.52722,0.061,NULL,43000774108,671887095,10498235,17.12),(91672,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91672,35.33,0.33,117,38671,70,NULL,NULL,'2MASX J12184561+1153345',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000151,NULL,'16.1g',0.29,'S0/a',NULL,NULL,NULL,NULL,1,184.690083,11.89289,0.022,NULL,58138063735,908407245,14193863,16.1),(91673,'TRGB','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91673,26.75,0.1,2.24,38672,NULL,NULL,NULL,'IC 3104',NULL,'2012A&A...540A..49M',2012,1,3.8,'The diameter in the AM catalogue is incorrect.','G',0.000013,NULL,'13.63',1.8,'IB(s)m:',NULL,NULL,NULL,NULL,1,184.691916667,-79.72606,0.517,0,44057583323,688399739,10756245,13.63),(91674,'TRGB','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91674,26.78,0.18,2.27,38672,NULL,NULL,NULL,'IC 3104',NULL,'2002A&A...389..812K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91675,'TRGB','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91675,26.8,0.04,2.29,38672,NULL,NULL,'I','IC 3104',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91676,'TRGB','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91676,26.81,NULL,2.3,38672,NULL,NULL,'I','IC 3104',NULL,'2006ARep...50..517T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91677,'TRGB','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91677,26.86,0.1,2.36,38672,74.4,NULL,NULL,'IC 3104',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91678,'Tully est','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91678,27.46,0.8,3.1,38672,75,NULL,NULL,'IC 3104',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91679,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91679,31.41,0.1,19.1,38673,NULL,NULL,'HST KP Calibrated','NGC 4062 GROUP',NULL,'2000ApJ...529..745F',2000,1,NULL,NULL,'GGroup',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,184.7044583,30.16108,0.053,NULL,58629704259,916089129,14313892,NULL),(91680,'GCLF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91680,30.74,0.28,14.1,38673,NULL,NULL,'HST KP Calibrated, V','NGC 4062 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91681,'PNLF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91681,30.12,0.18,10.6,38673,NULL,NULL,'HST KP Calibrated','NGC 4062 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91682,'SBF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91682,30.79,0.09,14.4,38673,NULL,NULL,'HST KP Calibrated, I','NGC 4062 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91683,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91683,37.21,0.46,276,38674,70,NULL,NULL,'2MASX J12184936+3349461',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000175,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,184.70575,33.82947,0,NULL,58764227191,918191049,14346735,17.2),(91684,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91684,37.56,0.33,326,38675,70,NULL,NULL,'2MASX J12184950+4442155',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,184.7062917,44.70431,0,NULL,59071043611,922985056,14421641,17.8),(91685,'Grav. Stability Gas. Disk','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91685,31.11,NULL,16.7,38676,NULL,NULL,NULL,'MESSIER 099',NULL,'1996AstL...22...71Z',1996,1,5.4,NULL,'G',0.00001,NULL,'10.44',4.7,'SA(s)c;LINER   HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,184.706667,14.4165,0.102,NULL,58182072903,909094889,14204607,10.44),(91686,'SNII optical','2016-12-15 15:14:57','2016-12-16 11:20:07','1','SN 1986I',NULL,91686,30.82,0.29,14.4,38676,NULL,NULL,'SEAM','MESSIER 099',0.008029,'2009ApJ...694.1067P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91687,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91687,30.67,0.55,13.6,38676,NULL,NULL,NULL,'MESSIER 099',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91688,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91688,30.68,0.92,13.7,38676,NULL,NULL,'CO','MESSIER 099',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91689,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91689,30.71,0.2,13.9,38676,74.4,NULL,NULL,'MESSIER 099',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91690,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91690,30.77,0.52,14.3,38676,NULL,NULL,'Malmquist cor.','MESSIER 099',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91691,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91691,31.13,0.4,16.8,38676,75,NULL,'B','MESSIER 099',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91692,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91692,31.13,0.7,16.8,38676,NULL,NULL,'HI','MESSIER 099',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91693,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91693,31.17,NULL,17.1,38676,NULL,NULL,'B','MESSIER 099',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91694,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91694,31.41,NULL,19.1,38676,84,NULL,'RSA Hubble type','MESSIER 099',NULL,'1986AJ.....91.1286S',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91695,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91695,37.55,0.1,324,38677,70,NULL,NULL,'2MASX J12185021+0513563',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000184,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,184.709167,5.23236,0,NULL,58032765522,906761961,14168155,17.6),(91696,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91696,37.11,0.46,265,38678,70,NULL,NULL,'2MASX J12185230+3237501',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000179,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,184.717917,32.63058,0,NULL,58770531262,918289550,14348274,17.3),(91697,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91697,38.01,0.33,400,38679,70,NULL,NULL,'2MASX J12185328+0538433',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000174,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,184.722125,5.64525,0,NULL,58032809130,906762642,14168166,17.5),(91698,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91698,35.45,0.46,123,38680,70,NULL,NULL,'IC 0775',NULL,'2015arXiv151105856S',2015,1,1.06,'Haynes et al. (2011AJ....142..170H) give v = 6133 km/s.','G',0.000063,NULL,'14.2g',0.75,'SB0- pec:','in a pair',NULL,NULL,NULL,1,184.723625,12.91267,0.025,NULL,58170261343,908910333,14201723,14.2),(91699,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91699,37.18,0.46,273,38681,70,NULL,NULL,'SDSS J121853.84+011557.6',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00018,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,184.724291667,1.26592,0.005,NULL,58041455208,906897737,14170277,16.4),(91700,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91700,38.19,0.46,434,38682,70,NULL,NULL,'2MASX J12185399+0403003',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000179,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,184.7249583,4.05006,0.017,NULL,58035267234,906801050,14168766,17.9),(91701,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91701,34.7,NULL,87.1,38683,NULL,NULL,'Dipole','IC 3137',NULL,'2010Ap&SS.325..163P',2010,1,1.02,NULL,'G',0.000033,NULL,'16.7g',0.17,'Sc',NULL,NULL,NULL,NULL,1,184.727791667,12.47006,0.024,NULL,58137543424,908399116,14193736,16.7),(91702,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91702,34.71,NULL,87.4,38683,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 3137',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91703,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91703,34.71,NULL,87.5,38683,NULL,NULL,'Dipole + Quadrupole','IC 3137',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91704,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91704,34.85,NULL,93.4,38683,NULL,NULL,NULL,'IC 3137',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91705,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91705,38.34,0.46,465,38684,70,NULL,NULL,'2MASX J12185547+2825455',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,184.731166667,28.42944,0.087,NULL,58638139909,916220936,14315952,18),(91706,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91706,38.02,0.46,401,38685,70,NULL,NULL,'2MASX J12185557+1842235',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,184.731667,18.70658,0.084,NULL,58862296347,919723380,14370677,18),(91707,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91707,35.91,0.46,152,38686,70,NULL,NULL,'2MASX J12185593+3908242',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.00019,NULL,'15.3g',0.6,NULL,NULL,NULL,NULL,NULL,1,184.732917,39.14014,0,NULL,58582737712,915355276,14302426,15.3),(91708,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91708,32.29,NULL,28.7,38687,NULL,NULL,NULL,'NGC 4255',NULL,'1999MNRAS.304..595G',1999,1,1.3,NULL,'G',0.000017,NULL,'13.82',0.5,'SB(r)0^0^','X-ray-bright group member',NULL,NULL,NULL,1,184.7339583,4.78614,0,NULL,58036563287,906821301,14169082,13.82),(91709,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91709,32.39,0.25,30.1,38687,74.4,NULL,NULL,'NGC 4255',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91710,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91710,32.38,0.4,29.9,38687,NULL,NULL,'mean','NGC 4255',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91711,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91711,32.61,0.45,33.3,38687,NULL,NULL,'K','NGC 4255',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91712,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91712,34.02,0.46,63.7,38688,70,NULL,NULL,'IC 3134',NULL,'2015arXiv151105856S',2015,1,0.86,NULL,'G',0.000063,NULL,'14.7g',0.46,'Sa','Group member',NULL,NULL,NULL,1,184.733833,8.96161,0,NULL,58213771777,909590184,14212346,14.7),(91713,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91713,37.32,0.27,291,38689,70,NULL,NULL,'2MASX J12185741+4225365',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00019,NULL,'15.9g',0.46,'E0',NULL,NULL,NULL,NULL,1,184.739375,42.42672,0,NULL,59062191620,922846744,14419480,15.9),(91714,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91714,29.06,0.1,6.49,38690,NULL,18.45,'LMC ZP','MESSIER 106',NULL,'2009AcA....59..403M',2009,1,18.6,NULL,'G',0.00001,NULL,'8.41V',7.2,'SAB(s)bc;LINER Sy1.9','in a radial-velocity based grouping',NULL,'radio jet','Sy 2',1,184.739583,47.30397,0,NULL,57183095355,893485864,13960716,8.41),(91715,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91715,29.12,0.23,6.67,38690,NULL,NULL,'inner','MESSIER 106',NULL,'2008ApJ...684..102B',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91716,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91716,29.15,0.21,6.76,38690,NULL,NULL,'BV(W), inner','MESSIER 106',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91717,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91717,29.18,0.21,6.85,38690,NULL,NULL,'VI(W), inner','MESSIER 106',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91718,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91718,29.18,0.23,6.85,38690,NULL,18.493,'40, gri','MESSIER 106',NULL,'2015AJ....149..183H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91719,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91719,29.21,0.02,6.95,38690,NULL,NULL,'W','MESSIER 106',NULL,'2007AJ....133.1810B',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91720,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91720,29.22,0.03,6.98,38690,NULL,NULL,'GAL+LMC PL','MESSIER 106',NULL,'2007MNRAS.379..723V',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91721,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91721,29.22,0.03,6.98,38690,NULL,NULL,'VI, inner','MESSIER 106',NULL,'2007MNRAS.379..723V',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91722,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91722,29.24,0.08,7.05,38690,NULL,NULL,'GAL PL','MESSIER 106',NULL,'2014MNRAS.440.1138E',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91723,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91723,29.26,0.03,7.11,38690,NULL,NULL,'281, VI(W), outer','MESSIER 106',NULL,'2008ApJ...689..721M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91724,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91724,29.28,0.1,7.18,38690,NULL,NULL,NULL,'MESSIER 106',NULL,'2007ApJ...671.1640A',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91725,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91725,29.28,0.03,7.18,38690,NULL,NULL,'Surface Brightness','MESSIER 106',NULL,'2008MNRAS.390.1762D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91726,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91726,29.28,0.08,7.18,38690,NULL,NULL,'W, Z','MESSIER 106',NULL,'2007AJ....133.1810B',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91727,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91727,29.28,0.02,7.18,38690,NULL,NULL,'113, VI','MESSIER 106',NULL,'2008ApJ...689..721M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91728,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91728,29.28,0.05,7.18,38690,NULL,NULL,'VI(W), Z, Baade-Wesselink','MESSIER 106',NULL,'2013MNRAS.430..546D',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91729,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91729,29.29,0.04,7.21,38690,NULL,18.41,'281, W+Z, LMC ZP','MESSIER 106',NULL,'2006ApJ...652.1133M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91730,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91730,29.29,0.09,7.21,38690,NULL,18.45,'LMC ZP','MESSIER 106',NULL,'2009AcA....59..403M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91731,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91731,29.29,0.08,7.21,38690,NULL,NULL,'LMC PL','MESSIER 106',NULL,'2014MNRAS.440.1138E',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91732,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91732,29.31,0.06,7.28,38690,NULL,NULL,'15, VI, HST cte correction of -0.07 mag','MESSIER 106',NULL,'2003ApJ...586..959N',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91733,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91733,29.31,0.04,7.28,38690,NULL,NULL,'inner','MESSIER 106',NULL,'2010Ap&SS.326..219T',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91734,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91734,29.32,0.16,7.3,38690,NULL,NULL,'HSTKP','MESSIER 106',NULL,'2002ApJ...566..833C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91735,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91735,29.32,0.05,7.31,38690,74.4,NULL,NULL,'MESSIER 106',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91736,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91736,29.33,0.12,7.35,38690,NULL,18.45,'VI(W), Z','MESSIER 106',NULL,'2009MmSAI..80..141M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91737,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91737,29.35,NULL,7.4,38690,NULL,NULL,'V, I, NIR (W), 117, Syst. +/- 0.34 mag','MESSIER 106',NULL,'2013MNRAS.434.2866F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91738,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91738,29.35,0.12,7.41,38690,NULL,NULL,'outer','MESSIER 106',NULL,'2008ApJ...684..102B',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91739,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91739,29.35,0.12,7.41,38690,NULL,18.45,'VI(W)','MESSIER 106',NULL,'2009MmSAI..80..141M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91740,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91740,29.37,0.06,7.48,38690,NULL,NULL,'cte LMC K03','MESSIER 106',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91741,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91741,29.38,0.06,7.51,38690,NULL,NULL,'cte MW GFG98','MESSIER 106',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91742,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91742,29.38,0.06,7.53,38690,NULL,NULL,'cte U99','MESSIER 106',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91743,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91743,29.38,0.06,7.53,38690,NULL,NULL,'15, VI','MESSIER 106',NULL,'2003ApJ...586..959N',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91744,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91744,29.39,0.06,7.56,38690,NULL,NULL,'cte LMC STS02','MESSIER 106',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91745,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91745,29.4,0.08,7.59,38690,NULL,18.57,'81, BVIH, Z, syst. +/- 0.09 mag','MESSIER 106',NULL,'2015MNRAS.450.3597F',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91746,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91746,29.4,0.13,7.59,38690,NULL,NULL,'VI(W), outer','MESSIER 106',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91747,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91747,29.4,0.06,7.59,38690,NULL,NULL,'29, VI, DaPHOT','MESSIER 106',NULL,'2001ApJ...553..562N',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91748,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91748,29.4,0.06,7.59,38690,NULL,NULL,'cte MW FSG03','MESSIER 106',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91749,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91749,29.4,0.08,7.59,38690,NULL,18.57,'43, BVI(W), Z','MESSIER 106',NULL,'2015MNRAS.450.3597F',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91750,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91750,29.44,0.06,7.71,38690,NULL,NULL,'cte MF91','MESSIER 106',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91751,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91751,29.44,0.07,7.73,38690,NULL,NULL,'15, VI, KEY PROJECT','MESSIER 106',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91752,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91752,29.44,0.06,7.73,38690,NULL,NULL,'cte MW STS03','MESSIER 106',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91753,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91753,29.45,0.07,7.76,38690,NULL,NULL,'MW HIPP','MESSIER 106',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91754,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91754,29.45,0.08,7.76,38690,NULL,NULL,'281, VI(W), inner','MESSIER 106',NULL,'2008ApJ...689..721M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91755,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91755,29.46,0.12,7.8,38690,NULL,NULL,'outer, Z = -0.29 mag dex-1','MESSIER 106',NULL,'2008ApJ...684..102B',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91756,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91756,29.46,0.16,7.8,38690,NULL,18.45,'LMC ZP','MESSIER 106',NULL,'2009AcA....59..403M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91757,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91757,29.47,0.09,7.8,38690,NULL,NULL,'HSTKP','MESSIER 106',NULL,'2002ApJ...566..833C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91758,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91758,29.47,0.09,7.83,38690,NULL,NULL,'29, VI, adopt','MESSIER 106',NULL,'2001ApJ...553..562N',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91759,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91759,29.48,0.16,7.87,38690,NULL,NULL,'MW P02','MESSIER 106',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91760,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91760,29.49,0.12,7.9,38690,NULL,NULL,'LMC W01','MESSIER 106',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91761,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91761,29.49,0.21,7.91,38690,NULL,NULL,'BV(W), outer','MESSIER 106',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91762,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91762,29.49,0.17,7.91,38690,NULL,18.41,'Z = -0.62 mag dex-1','MESSIER 106',NULL,'2011ApJ...743..176G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91763,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91763,29.49,NULL,7.91,38690,NULL,NULL,'15, VI, GAL PL','MESSIER 106',NULL,'2004MNRAS.349.1130N',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91764,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91764,29.51,0.05,7.98,38690,NULL,NULL,'outer','MESSIER 106',NULL,'2010Ap&SS.326..219T',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91765,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91765,29.51,0.07,7.98,38690,NULL,NULL,'15, VI, +Z, KEY PROJECT','MESSIER 106',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91766,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91766,29.51,0.06,7.98,38690,NULL,NULL,'29, VI, Feast99','MESSIER 106',NULL,'2001ApJ...553..562N',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91767,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91767,29.51,0.11,7.98,38690,NULL,NULL,NULL,'MESSIER 106',NULL,'2014AAS...22431809T',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91768,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91768,29.53,0.1,8.05,38690,NULL,NULL,'MW GFG','MESSIER 106',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91769,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91769,29.53,0.1,8.05,38690,NULL,NULL,'65, VI','MESSIER 106',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91770,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91770,29.54,0.1,8.1,38690,NULL,NULL,NULL,'MESSIER 106',NULL,'1999Natur.401..351M',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91771,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91771,29.63,0.05,8.43,38690,NULL,18.54,'LMC ZP','MESSIER 106',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91772,'Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91772,29.81,NULL,9.16,38690,NULL,NULL,'15, VI','MESSIER 106',NULL,'2006A&A...452..423P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91773,'PNLF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91773,29.4,0.1,7.59,38690,NULL,NULL,NULL,'MESSIER 106',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91774,'SNII radio','2016-12-15 15:14:57','2016-12-16 11:20:07','1','SN 1981K',NULL,91774,27.59,0.67,3.3,38690,NULL,NULL,NULL,'MESSIER 106',NULL,'1998ApJ...500...51W',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91775,'SBF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91775,29.31,0.14,7.28,38690,NULL,NULL,'I','MESSIER 106',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91776,'SBF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91776,29.32,0.05,7.31,38690,74.4,NULL,NULL,'MESSIER 106',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91777,'TRGB','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91777,29.24,0.06,7.05,38690,NULL,NULL,'WFPC2','MESSIER 106',NULL,'2008ApJ...689..721M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91778,'TRGB','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91778,29.28,0.04,7.18,38690,NULL,NULL,'ACS','MESSIER 106',NULL,'2008ApJ...689..721M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91779,'TRGB','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91779,29.32,0.09,7.31,38690,NULL,NULL,NULL,'MESSIER 106',NULL,'2005ApJ...633..810M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91780,'TRGB','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91780,29.32,0.05,7.31,38690,74.4,NULL,NULL,'MESSIER 106',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91781,'TRGB','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91781,29.42,0.06,7.66,38690,NULL,NULL,'I','MESSIER 106',NULL,'2007ApJ...661..815R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91782,'TRGB','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91782,29.44,0.11,7.73,38690,NULL,NULL,'m(I)-MTRGB = 25.39 - -4.05 mag','MESSIER 106',NULL,'2009ApJ...690..389M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91783,'Type II Cepheids','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91783,29.19,0.18,6.89,38690,NULL,18.45,'LMC ZP','MESSIER 106',NULL,'2009AcA....59..403M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91784,'HII region diameter','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91784,27.72,0.29,3.5,38690,NULL,NULL,NULL,'MESSIER 106',NULL,'1993A&A...268..419C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91785,'Maser','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91785,28.66,0.47,5.4,38690,NULL,NULL,NULL,'MESSIER 106',NULL,'1995ApJ...440..619G',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91786,'Maser','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91786,29.03,0.29,6.4,38690,NULL,NULL,NULL,'MESSIER 106',NULL,'1995Natur.373..127M',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91787,'Maser','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91787,29.29,0.08,7.2,38690,NULL,NULL,NULL,'MESSIER 106',NULL,'1999Natur.400..539H',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91788,'Maser','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91788,29.29,0.03,7.2,38690,NULL,NULL,NULL,'MESSIER 106',NULL,'2005ASPC..340..466H',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91789,'Maser','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91789,29.29,0.02,7.2,38690,NULL,NULL,NULL,'MESSIER 106',NULL,'2008ApJ...672..800H',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91790,'Maser','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91790,29.31,NULL,7.28,38690,NULL,NULL,NULL,'MESSIER 106',NULL,'2012ApJ...752...76R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91791,'Maser','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91791,29.32,0.09,7.3,38690,NULL,NULL,NULL,'MESSIER 106',NULL,'1997AAS...191.2507H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91792,'Maser','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91792,29.4,0.05,7.6,38690,NULL,NULL,NULL,'MESSIER 106',NULL,'2013ApJ...775...13H',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91793,'SNII optical','2016-12-15 15:14:57','2016-12-16 11:20:07','1','SN 2014bc',NULL,91793,29.16,0.16,6.79,38690,NULL,NULL,'SCM, Nugent et al. 2006','MESSIER 106',NULL,'2015A&A...580L..15P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91794,'SNII optical','2016-12-15 15:14:57','2016-12-16 11:20:07','1','SN 2014bc',NULL,91794,29.25,0.16,7.08,38690,NULL,NULL,'SCM, Hamuy 2003','MESSIER 106',NULL,'2015A&A...580L..15P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91795,'SNII optical','2016-12-15 15:14:57','2016-12-16 11:20:07','1','SN 2014bc',NULL,91795,29.25,0.25,7.08,38690,NULL,NULL,'SCM','MESSIER 106',NULL,'2015A&A...580L..15P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91796,'SNII optical','2016-12-15 15:14:57','2016-12-16 11:20:07','1','SN 2014bc',NULL,91796,29.37,0.16,7.48,38690,NULL,NULL,'SCM, Poznanski et al. 2009','MESSIER 106',NULL,'2015A&A...580L..15P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91797,'SNII optical','2016-12-15 15:14:57','2016-12-16 11:20:07','1','SN 2014bc',NULL,91797,29.73,0.16,8.83,38690,NULL,NULL,'SCM, D\'Andrea et al. 2010','MESSIER 106',NULL,'2015A&A...580L..15P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91798,'IRAS','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91798,29.89,0.8,9.49,38690,75,NULL,'A82, H','MESSIER 106',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91799,'Sosies','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91799,29.48,0.08,7.87,38690,NULL,NULL,NULL,'MESSIER 106',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91800,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91800,29.13,0.4,6.7,38690,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','MESSIER 106',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91801,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91801,29.15,0.4,6.8,38690,75,NULL,'B','MESSIER 106',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91802,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91802,29.19,0.43,6.9,38690,75,NULL,'3.6 micron, color corrected','MESSIER 106',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91803,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91803,29.26,0.35,7.11,38690,NULL,NULL,NULL,'MESSIER 106',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91804,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91804,29.29,0.43,7.2,38690,75,NULL,'3.6 micron, color + selection bias corrected','MESSIER 106',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91805,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91805,29.32,0.05,7.31,38690,74.4,NULL,NULL,'MESSIER 106',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91806,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91806,29.39,0.12,7.55,38690,NULL,NULL,'I','MESSIER 106',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91807,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91807,29.42,0.47,7.64,38690,75,NULL,'A82, H, raw','MESSIER 106',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91808,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91808,29.43,NULL,7.69,38690,NULL,NULL,'LEDA [April 2006]','MESSIER 106',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91809,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91809,29.44,NULL,7.73,38690,NULL,NULL,'B','MESSIER 106',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91810,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91810,29.47,0.04,7.83,38690,NULL,NULL,'B','MESSIER 106',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91811,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91811,29.51,NULL,7.98,38690,NULL,NULL,'I','MESSIER 106',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91812,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91812,29.6,0.47,8.32,38690,75,NULL,'A82, H, inv','MESSIER 106',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91813,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91813,29.64,0.42,8.47,38690,53.9,NULL,'Canes Venatici II Group','MESSIER 106',NULL,'1984A&A...132..253R',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91814,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91814,29.8,0.47,9.13,38690,75,NULL,'A82, H, cor','MESSIER 106',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91815,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91815,38.31,0.46,460,38691,70,NULL,NULL,'2MASX J12185827+6418389',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000142,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,184.7425417,64.31083,0.009,NULL,57324183217,895690362,13995161,18.1),(91816,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91816,37.55,0.1,324,38692,70,NULL,NULL,'SDSS J121858.26+051516.2',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'16.0g',0.38,'E0',NULL,NULL,NULL,NULL,1,184.742791667,5.25453,0,NULL,58032764419,906761944,14168155,16),(91817,'IRAS','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91817,35.11,0.8,105,38693,75,NULL,'HMCL, I','IC 3141',NULL,'1997ApJS..109..333W',1997,1,0.8,NULL,'G',0.000027,NULL,'15.7',0.5,'S0',NULL,NULL,NULL,NULL,1,184.7435,24.18628,0.089,NULL,58594156786,915533699,14305214,15.7),(91818,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91818,35.9,0.4,151,38693,75,NULL,'HMCL, I, raw','IC 3141',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91819,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91819,36.14,0.4,169,38693,75,NULL,'HMCL, I, cor','IC 3141',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91820,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91820,36.17,0.4,171,38693,75,NULL,'HMCL, I, inv','IC 3141',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91821,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91821,37.84,0.23,370,38694,70,NULL,NULL,'2MASX J12185904+0809175',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000174,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,184.746,8.15494,0,NULL,58205897779,909467152,14210424,17.2),(91822,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91822,35.42,0.49,122,38695,75,NULL,'IR','KUG 1216+215',NULL,'2011yCatp016004901K',2011,1,0.79,NULL,'G',NULL,NULL,'16.55',0.18,'Spiral',NULL,NULL,NULL,NULL,1,184.746083333,21.30572,0.082,NULL,58870774158,919855846,14372747,16.55),(91823,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91823,38.31,0.27,460,38696,70,NULL,NULL,'2MASX J12185917+2753465',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000164,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,184.7465,27.89617,0.075,NULL,58637885267,916216957,14315889,17.1),(91824,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91824,37.74,0.46,353,38697,70,NULL,NULL,'SDSS J121900.15+185033.0',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,184.750625,18.84253,0.076,NULL,58862297574,919723399,14370678,NULL),(91825,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91825,38.64,0.46,534,38698,70,NULL,NULL,'2MASX J12190140+0823485',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,184.755875,8.397,0,NULL,58205894235,909467097,14210423,17.9),(91826,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91826,31.13,0.4,16.8,38699,75,NULL,'B','IC 0776',NULL,'1988NBGC.C....0000T',1988,1,1.8,NULL,'G',0.000002,NULL,'14.30',1.1,'Sdm            HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,184.762083,8.85611,0,NULL,58213632971,909588015,14212312,14.3),(91827,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91827,32.42,0.43,30.5,38699,75,NULL,'3.6 micron, color + selection bias corrected','IC 0776',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91828,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91828,32.49,0.43,31.5,38699,75,NULL,'3.6 micron, color corrected','IC 0776',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91829,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91829,32.53,0.49,32.1,38699,NULL,NULL,'Malmquist cor.','IC 0776',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91830,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91830,32.57,0.2,32.7,38699,74.4,NULL,NULL,'IC 0776',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91831,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91831,32.6,0.36,33.1,38699,NULL,NULL,NULL,'IC 0776',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91832,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91832,32.84,0.42,36.9,38699,NULL,NULL,NULL,'IC 0776',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91833,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91833,37.84,0.46,370,38700,70,NULL,NULL,'SDSS J121903.02+130349.0',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,184.762583,13.06364,0.118,NULL,58170222005,908909718,14201714,17.3),(91834,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91834,37.32,0.27,291,38701,70,NULL,NULL,'2MASX J12190301+4225255',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000137,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,184.7627083,42.42386,0,NULL,59062191709,922846745,14419480,18.1),(91835,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91835,37.04,0.46,256,38702,70,NULL,NULL,'2MASX J12190365+4440304',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000168,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,184.765375,44.67508,0,NULL,59071547793,922992934,14421764,16.5),(91836,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91836,36.62,0.46,211,38703,70,NULL,NULL,'2MASX J12190400+3105036',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,184.7667083,31.08442,NULL,NULL,58761135562,918142743,14345980,17.2),(91837,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91837,37.39,0.46,301,38704,70,NULL,NULL,'2MASX J12190443+0740316',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000165,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,184.7685417,7.67539,0,NULL,58208495177,909507737,14211058,16.9),(91838,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91838,37.55,0.1,324,38705,70,NULL,NULL,'SDSS J121905.75+051553.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000162,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,184.7739583,5.26486,0,NULL,58032762342,906761911,14168154,18.4),(91839,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91839,36.74,0.33,223,38706,70,NULL,NULL,'2MASX J12190626+2148166',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,184.776,21.80467,0.065,NULL,58864198368,919753099,14371142,17.3),(91840,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91840,37.55,0.1,324,38707,70,NULL,NULL,'SDSS J121906.61+052002.1',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000097,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,184.7775417,5.33392,0,NULL,58032902481,906764101,14168189,16.7),(91841,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91841,38.63,0.46,532,38708,70,NULL,NULL,'2MASX J12190746+2946105',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00017,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,184.781167,29.7695,0.087,NULL,58632143611,916127243,14314488,18),(91842,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91842,37.03,0.55,254,38709,70,NULL,NULL,'2MASX J12190812-2144321',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.42',0.4,NULL,NULL,NULL,NULL,NULL,1,184.783875,-21.74233,0.165,NULL,43896024706,685875386,10716802,16.42),(91843,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91843,38.06,0.27,409,38710,70,NULL,NULL,'2MASX J12190837+5352131',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000194,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,184.784916667,53.8705,0.015,NULL,57223175403,894112115,13970501,17.8),(91844,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91844,38.29,0.21,454,38711,70,NULL,NULL,'2MASX J12190928+6331418',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'17.1g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,184.7887917,63.52836,0.017,NULL,57316809443,895575147,13993361,17.1),(91845,'SBF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91845,29.12,0.18,6.7,38712,NULL,NULL,NULL,'UGC 07356',NULL,'2001A&A...380...90J',2001,1,0.9,NULL,'G',0.000023,NULL,'17.',0.9,'dE; N','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,184.789125,47.09097,0,NULL,59065291955,922895186,14420237,17),(91846,'TRGB','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91846,29.31,0.1,7.28,38712,74.4,NULL,NULL,'UGC 07356',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91847,'TRGB','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91847,29.4,0.03,7.59,38712,NULL,NULL,'I','UGC 07356',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91848,'Tully est','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91848,30.82,0.8,14.6,38713,75,NULL,'B','UGC 07354',NULL,'1988NBGC.C....0000T',1988,1,0.7,NULL,'G',0.000007,NULL,'14.0',0.6,'E pec:;WR?     HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,184.791166667,3.85653,0.015,NULL,58035127292,906798863,14168732,14),(91849,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91849,30.94,NULL,15.4,38713,NULL,NULL,NULL,'UGC 07354',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91850,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91850,31.15,NULL,17,38713,NULL,NULL,NULL,'UGC 07354',NULL,'2014A&A...562A..49M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91851,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91851,37.6,0.46,331,38714,70,NULL,NULL,'SDSS J121910.14+194206.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.2g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,184.79225,19.70181,0.091,NULL,58861865418,919716647,14370572,18.2),(91852,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91852,37.86,0.46,374,38715,70,NULL,NULL,'2MASXi J1219108+120511',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000183,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,184.7950417,12.08639,0.025,NULL,58138182631,908409103,14193892,17.8),(91853,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91853,37.5,0.46,316,38716,70,NULL,NULL,'2MASX J12191127+1402486',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000213,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,184.7970417,14.04697,0.186,NULL,58167967989,908874499,14201164,17.2),(91854,'IRAS','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91854,33.68,0.8,54.5,38717,75,NULL,'CF, r','UGC 07358',NULL,'1997ApJS..109..333W',1997,1,2.02,NULL,'G',0.000099,NULL,'14.0g',0.56,'Scd:           HII','Group member',NULL,NULL,NULL,1,184.800958333,49.35467,0,NULL,57182115578,893470555,13960477,14),(91855,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91855,33.27,0.38,45.1,38717,75,NULL,'CF, r, raw','UGC 07358',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91856,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91856,33.32,0.38,46.2,38717,75,NULL,'CF, r, inv','UGC 07358',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91857,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91857,33.41,0.38,48,38717,75,NULL,'CF, r, cor','UGC 07358',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91858,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91858,33.41,0.2,48.1,38717,74.4,NULL,NULL,'UGC 07358',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91859,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91859,33.45,0.49,48.9,38717,75,NULL,'IR','UGC 07358',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91860,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91860,33.46,0.5,49.2,38717,NULL,NULL,NULL,'UGC 07358',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91861,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91861,33.54,0.48,51.1,38717,NULL,NULL,'Malmquist cor.','UGC 07358',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91862,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91862,36.05,0.46,162,38718,70,NULL,NULL,'2MASX J12191289+4231584',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000168,NULL,'15.8g',0.37,'S0',NULL,NULL,NULL,NULL,1,184.8037917,42.53292,0,NULL,59062335503,922848992,14419515,15.8),(91863,'SNIa','2016-12-15 15:14:57','2016-12-16 11:20:07','1','SN 2006cp',NULL,91863,34.14,0.18,65.8,38719,74.2,NULL,'SALT 2','UGC 07357',0.022289,'2010ApJ...716..712A',2010,1,1.6,NULL,'G',0.000004,NULL,'14.3',1.4,'SAB(s)c',NULL,NULL,NULL,NULL,1,184.805791667,22.43153,0.04,NULL,58864568968,919758890,14371232,14.3),(91864,'SNIa','2016-12-15 15:14:57','2016-12-16 11:20:07','1','SN 2006cp',NULL,91864,34.72,0.09,87.9,38719,74.4,NULL,NULL,'UGC 07357',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91865,'SNIa','2016-12-15 15:14:57','2016-12-16 11:20:07','1','SN 2006cp',NULL,91865,34.84,0.09,90.9,38719,72,NULL,NULL,'UGC 07357',0.022289,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91866,'SNIa','2016-12-15 15:14:57','2016-12-16 11:20:07','1','SN 2006cp',NULL,91866,34.85,0.19,91.1,38719,65,NULL,'MLCS31','UGC 07357',0.022289,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91867,'SNIa','2016-12-15 15:14:57','2016-12-16 11:20:07','1','SN 2006cp',NULL,91867,34.92,0.17,94.2,38719,70,NULL,'SALT 2','UGC 07357',0.022289,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91868,'SNIa','2016-12-15 15:14:57','2016-12-16 11:20:07','1','SN 2006cp',NULL,91868,34.92,0.14,94.3,38719,72,NULL,NULL,'UGC 07357',0.022289,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91869,'SNIa','2016-12-15 15:14:57','2016-12-16 11:20:07','1','SN 2006cp',NULL,91869,34.93,0.16,94.5,38719,73.8,NULL,'SALT 2 (SNANA)','UGC 07357',0.0233,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91870,'SNIa','2016-12-15 15:14:57','2016-12-16 11:20:07','1','SN 2006cp',NULL,91870,34.94,0.04,95.2,38719,72,NULL,NULL,'UGC 07357',0.022289,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91871,'SNIa','2016-12-15 15:14:57','2016-12-16 11:20:07','1','SN 2006cp','R',91871,34.9,0.07,95.5,38719,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 07357',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91872,'SNIa','2016-12-15 15:14:57','2016-12-16 11:20:07','1','SN 2006cp','R',91872,34.92,0.06,96.4,38719,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 07357',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91873,'SNIa','2016-12-15 15:14:57','2016-12-16 11:20:07','1','SN 2006cp',NULL,91873,34.98,0.18,96.8,38719,65,NULL,'SALT','UGC 07357',0.022289,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91874,'SNIa','2016-12-15 15:14:57','2016-12-16 11:20:07','1','SN 2006cp',NULL,91874,35.01,0.18,98,38719,65,NULL,'MLCS17','UGC 07357',0.022289,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91875,'SNIa','2016-12-15 15:14:57','2016-12-16 11:20:07','1','SN 2006cp',NULL,91875,35.03,0.2,99.1,38719,65,NULL,'SALT2','UGC 07357',0.022289,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91876,'SNIa','2016-12-15 15:14:57','2016-12-16 11:20:07','1','SN 2006cp',NULL,91876,35.06,0.11,103,38719,72,NULL,'M(H) = -18.317 mag','UGC 07357',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91877,'SNIa','2016-12-15 15:14:57','2016-12-16 11:20:07','1','SN 2006cp',NULL,91877,35.46,0.03,121,38719,70,NULL,'SALT 2','UGC 07357',0.022289,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91878,'Tully est','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91878,31.13,0.8,16.8,38720,75,NULL,NULL,'KUG 1216+141',NULL,'1988NBGC.C....0000T',1988,1,0.49,NULL,'G',0.00002,NULL,'15.7g',0.44,'Blue Compact Dwarf','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,184.809333,13.88239,0.188,NULL,58167935042,908873985,14201156,15.7),(91879,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91879,31.15,NULL,17,38720,NULL,NULL,NULL,'KUG 1216+141',NULL,'2014A&A...562A..49M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91880,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91880,37.66,0.46,341,38721,70,NULL,NULL,'LCRS B121640.6-025147',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000136,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,184.810583,-3.14064,0.081,NULL,43015643711,672119432,10501866,18.2),(91881,'IRAS','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91881,34.82,0.8,92,38722,75,NULL,'HMCL, I','UGC 07362',NULL,'1997ApJS..109..333W',1997,1,1.19,NULL,'G',0.000027,NULL,'16.5',0.11,'Scd',NULL,NULL,NULL,NULL,1,184.813875,25.93022,0.07,NULL,58647404629,916365697,14318214,16.5),(91882,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91882,35.25,0.49,112,38722,75,NULL,'IR','UGC 07362',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91883,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91883,35.39,0.4,120,38722,75,NULL,'HMCL, I, raw','UGC 07362',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91884,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91884,35.53,0.4,127,38722,75,NULL,'HMCL, I, cor','UGC 07362',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91885,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91885,35.54,0.4,128,38722,75,NULL,'HMCL, I, inv','UGC 07362',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91886,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91886,35.59,NULL,131,38722,NULL,NULL,'Dipole + Quadrupole','UGC 07362',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91887,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91887,35.59,NULL,131,38722,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07362',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91888,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91888,35.6,NULL,132,38722,NULL,NULL,'Dipole','UGC 07362',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91889,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91889,37.55,0.1,324,38723,70,NULL,NULL,'SDSS J121915.94+051613.3',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.0g',0.43,'E0',NULL,NULL,NULL,NULL,1,184.8164583,5.27036,0,NULL,58032767604,906761993,14168156,16),(91890,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91890,37.55,0.1,324,38724,70,NULL,NULL,'2MASX J12191598+0506004',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,184.816708333,5.10017,0,NULL,58032726939,906761358,14168146,17),(91891,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91891,37.41,0.46,303,38725,70,NULL,NULL,'2MASX J12191826+4117553',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000155,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,184.826208333,41.29858,0,NULL,58530615757,914540871,14289701,17.1),(91892,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91892,35.03,0.49,101,38726,75,NULL,'IR','FGC 1411',NULL,'2011yCatp016004901K',2011,1,1.04,NULL,'G',0.000169,NULL,'16.0g',0.18,'Sc',NULL,NULL,NULL,NULL,1,184.827208333,43.23681,0,NULL,59070596813,922978075,14421532,16),(91893,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91893,35.65,NULL,135,38726,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1411',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91894,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91894,35.67,NULL,136,38726,NULL,NULL,'Dipole + Quadrupole','FGC 1411',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91895,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91895,35.69,NULL,137,38726,NULL,NULL,'Dipole','FGC 1411',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91896,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91896,35.7,NULL,138,38726,NULL,NULL,NULL,'FGC 1411',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91897,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91897,37.05,0.46,257,38727,70,NULL,NULL,'SDSS J121918.68+154619.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000137,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,184.827875,15.77214,0.036,NULL,58174185378,908971646,14202681,17.8),(91898,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91898,38.62,0.46,529,38728,70,NULL,NULL,'SDSS J121919.03+083039.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000164,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,184.829333333,8.51103,0,NULL,58205823418,909465990,14210406,18.1),(91899,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91899,38.35,0.46,467,38729,70,NULL,NULL,'2MASX J12192068+3540136',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,184.836167,35.67036,0,NULL,58543908983,914748577,14292946,17.5),(91900,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91900,36.9,0.46,240,38730,70,NULL,NULL,'2MASX J12192085+0826436',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.40',0.16,NULL,NULL,NULL,NULL,NULL,1,184.8369583,8.44536,0,NULL,58205825860,909466029,14210406,18.4),(91901,'Sosies','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91901,32.88,0.11,37.7,38731,NULL,NULL,NULL,'NGC 4260',NULL,'2002A&A...393...57T',2002,1,3.34,NULL,'G',0.000033,NULL,'12.5g',1.03,'SB(s)a;Sy      LINER','X-ray-bright group member',NULL,NULL,NULL,1,184.842666667,6.09867,0,NULL,58024991270,906640488,14166257,12.5),(91902,'Tully est','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91902,32.73,0.8,35.1,38731,75,NULL,'B','NGC 4260',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91903,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91903,32.43,0.4,30.7,38731,NULL,NULL,'mean','NGC 4260',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91904,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91904,32.94,0.46,38.8,38731,NULL,NULL,'J','NGC 4260',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91905,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91905,32.96,0.45,39.2,38731,NULL,NULL,'K','NGC 4260',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91906,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91906,33.42,0.3,48.4,38731,55,NULL,'B','NGC 4260',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91907,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91907,33.78,NULL,57,38732,NULL,NULL,NULL,'NGC 4259',NULL,'1999MNRAS.304..595G',1999,1,1.2,NULL,'G',0.000017,NULL,'14.2g',0.51,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,184.842541667,5.37639,0,NULL,58032864557,906763508,14168179,14.2),(91908,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91908,38.16,0.46,428,38733,70,NULL,NULL,'2MASX J12192253+0513194',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000141,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,184.844083,5.22225,0,NULL,58032769808,906762028,14168156,17.7),(91909,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91909,35.33,0.33,117,38734,70,NULL,NULL,'VCC 0347',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000157,NULL,'15.7g',0.38,'S0/a','Group member',NULL,NULL,NULL,1,184.8452083,12.04161,0.025,NULL,58138183571,908409118,14193892,15.7),(91910,'GCLF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91910,31.9,0.3,24,38735,NULL,NULL,'TOM(V) = -7.3 mag','NGC 4261',NULL,'2009ApJ...690..512H',2009,1,4.1,'Additional radio sources may contribute to the WMAP flux.','G',0.000017,NULL,'11.41',3.6,'E2-3;LINER     Sy3','X-ray-bright group member',NULL,'radio jet','LINER h',1,184.84675,5.82522,0,NULL,58024864037,906638500,14166226,11.41),(91911,'GCLF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91911,32.5,1,31.6,38735,NULL,NULL,'TOM(V) = -7.4 mag','NGC 4261',NULL,'2012hell.conf...18B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91912,'SBF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91912,32.34,0.19,29.4,38735,NULL,NULL,'I','NGC 4261',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91913,'SBF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91913,32.5,0.19,31.6,38735,NULL,NULL,'I','NGC 4261',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91914,'SBF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91914,32.5,0.19,31.6,38735,NULL,NULL,NULL,'NGC 4261',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91915,'SBF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91915,32.51,0.19,31.8,38735,NULL,NULL,'Malmquist cor.','NGC 4261',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91916,'SBF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91916,32.55,0.14,32.4,38735,74.4,NULL,NULL,'NGC 4261',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91917,'D-Sigma','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91917,32.41,0.4,30.4,38735,75,NULL,'Edat, raw','NGC 4261',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91918,'D-Sigma','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91918,32.75,0.4,35.5,38735,75,NULL,'Edat, cor','NGC 4261',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91919,'Faber-Jackson','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91919,31.98,0.25,24.9,38735,95,NULL,'Weighted Mean','NGC 4261',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91920,'Faber-Jackson','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91920,32.05,0.3,25.7,38735,95,NULL,'de Vaucouleurs','NGC 4261',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91921,'Faber-Jackson','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91921,32.08,0.46,26.1,38735,95,NULL,'Michard 1979a','NGC 4261',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91922,'Faber-Jackson','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91922,32.21,0.63,27.7,38735,95,NULL,'Michard 1979b, c','NGC 4261',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91923,'Faber-Jackson','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91923,32.55,NULL,32.4,38735,NULL,NULL,'LEDA [April 2006]','NGC 4261',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91924,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91924,32.52,0.41,31.9,38735,NULL,NULL,NULL,'NGC 4261',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91925,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91925,32.52,0.41,31.9,38735,NULL,NULL,'Malmquist cor.','NGC 4261',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91926,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91926,32.79,NULL,36.1,38735,NULL,NULL,NULL,'NGC 4261',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91927,'Tertiary','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91927,31.75,0.29,22.4,38735,95,NULL,NULL,'NGC 4261',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91928,'Tully est','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91928,32.73,0.8,35.1,38735,75,NULL,'B','NGC 4261',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91929,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91929,36.49,0.46,199,38736,70,NULL,NULL,'2MASX J12192334+1658427',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.94',0.18,NULL,NULL,NULL,NULL,NULL,1,184.8475417,16.97858,0.049,NULL,58171110732,908923605,14201931,17.94),(91930,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91930,33.29,0.4,45.6,38737,NULL,NULL,'mean','IC 0777',NULL,'2007A&A...465...71T',2007,1,1.2,'RC3 gives v = 4307 +/- 12 km/sec.','G',0.000057,NULL,'14.37',0.7,'Sa','Group member',NULL,NULL,NULL,1,184.849,28.30994,0.075,NULL,58638113017,916220515,14315945,14.37),(91931,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91931,34.3,0.47,72.6,38737,NULL,NULL,'H','IC 0777',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91932,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91932,38.13,0.46,422,38738,70,NULL,NULL,'2MASX J12192389+5612229',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,184.849417,56.20639,0.009,NULL,57396842853,896825669,14012901,17.4),(91933,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91933,36.31,0.46,183,38739,70,NULL,NULL,'2MASX J12192391+4402297',NULL,'2015arXiv151105856S',2015,1,0.38,'2004AJ....127.1943G has z = 0.0718 +- 0.0028.','G',0.000162,NULL,'16.3g',0.32,'LINER',NULL,NULL,NULL,'LINER',1,184.849667,44.04164,0,NULL,59071499536,922992180,14421752,16.3),(91934,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91934,37.74,0.46,353,38740,70,NULL,NULL,'2MASX J12192427+0711126',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,184.851208333,7.18681,0,NULL,58207838033,909497469,14210897,17),(91935,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91935,38.29,0.21,454,38741,70,NULL,NULL,'CGPG 1217.0+6348',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000165,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,184.8525,63.50875,0.017,NULL,57316817976,895575280,13993363,18),(91936,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91936,37.42,0.46,305,38742,70,NULL,NULL,'SDSS J121924.65-021226.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,184.85275,-2.20744,0.057,NULL,43006965770,671983840,10499747,18.2),(91937,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91937,37.43,0.33,307,38743,70,NULL,NULL,'2MASX J12192521+1019216',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,'FoF','18.45',0.17,NULL,NULL,NULL,NULL,NULL,1,184.855083333,10.32275,0,NULL,58212687166,909573236,14212081,18.45),(91938,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91938,37,0.46,251,38744,70,NULL,NULL,'2MASX J12192555+3101546',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000133,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,184.856625,31.03192,NULL,NULL,58761105556,918142274,14345973,16.6),(91939,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91939,30.74,NULL,14.1,38745,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1412',NULL,'2010Ap&SS.325..163P',2010,1,1.08,NULL,'G',0.000023,NULL,'16.97',0.19,'dIn',NULL,NULL,NULL,NULL,1,184.85775,0.21253,0.025,NULL,57987166043,906049469,14157022,16.97),(91940,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91940,30.75,NULL,14.1,38745,NULL,NULL,NULL,'FGC 1412',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91941,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91941,30.8,NULL,14.5,38745,NULL,NULL,'Dipole + Quadrupole','FGC 1412',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91942,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91942,30.88,NULL,15,38745,NULL,NULL,'Dipole','FGC 1412',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91943,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91943,37.43,0.33,307,38746,70,NULL,NULL,'2MASX J12192764+1019316',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,184.8652917,10.32553,0,NULL,58212684504,909573195,14212081,17.4),(91944,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91944,37.97,0.33,393,38747,70,NULL,NULL,'SDSS J121927.68-013157.5',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,184.865375,-1.53264,0.049,NULL,43008146768,672002293,10500035,17.8),(91945,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91945,32.46,0.4,31,38748,NULL,NULL,'mean','MRK 1321',NULL,'2007A&A...465...71T',2007,1,1.06,NULL,'G',0.000123,NULL,'15.0g',0.44,'E7','Group member',NULL,NULL,NULL,1,184.86575,5.0475,0,NULL,58032727257,906761363,14168146,15),(91946,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91946,33.21,0.45,43.9,38748,NULL,NULL,'K','MRK 1321',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91947,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91947,38.88,0.46,596,38749,70,NULL,NULL,'2MASX J12192815+0528114',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000174,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,184.8674583,5.46994,0,NULL,58032826480,906762913,14168170,18.1),(91948,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91948,36.76,0.46,224,38750,70,NULL,NULL,'2MASX J12192875+2736421',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00017,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,184.86975,27.61169,0.085,NULL,58637719005,916214359,14315849,16.9),(91949,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91949,39.15,0.46,676,38751,70,NULL,NULL,'SDSS J121928.82+053548.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,184.870125,5.59692,0,NULL,58032788928,906762327,14168161,18.4),(91950,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91950,38.24,0.46,445,38752,70,NULL,NULL,'2MASX J12192969+5819149',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000145,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,184.873375,58.32094,0,NULL,57329042750,895766292,13996348,18.3),(91951,'GCLF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91951,31.7,0.28,21.9,38753,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4262',NULL,'2010ApJ...717..603V',2010,1,1.9,NULL,'G',0.000013,NULL,'12.49',1.7,'SB(s)0-?','in a radial-velocity based grouping',NULL,NULL,NULL,1,184.877375,14.87767,0.091,NULL,58182290745,909098292,14204660,12.49),(91952,'GCLF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91952,31.81,0.24,23,38753,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4262',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91953,'GCLF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91953,31.82,0.36,23.1,38753,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4262',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91954,'GCLF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91954,31.85,0.21,23.4,38753,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4262',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91955,'SBF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91955,30.94,0.06,15.4,38753,NULL,NULL,NULL,'NGC 4262',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91956,'SBF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91956,30.95,0.07,15.5,38753,NULL,NULL,'HST ACS VCS','NGC 4262',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91957,'SBF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91957,31.1,0.12,16.6,38753,74.4,NULL,NULL,'NGC 4262',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91958,'GC radius','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91958,30.82,0.17,14.6,38753,NULL,NULL,NULL,'NGC 4262',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91959,'Faber-Jackson','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91959,31.18,0.62,17.2,38753,95,NULL,'de Vaucouleurs','NGC 4262',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91960,'Faber-Jackson','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91960,31.22,0.32,17.5,38753,95,NULL,'Weighted Mean','NGC 4262',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91961,'Faber-Jackson','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91961,31.5,0.63,20,38753,95,NULL,'Michard 1979b, c','NGC 4262',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91962,'Faber-Jackson','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91962,31.91,0.46,24.1,38753,95,NULL,'Michard 1979a','NGC 4262',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91963,'Faber-Jackson','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91963,32.33,0.81,29.2,38753,55,NULL,'Visvanathan & Sandage 1979','NGC 4262',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91964,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91964,30.86,NULL,14.9,38753,NULL,NULL,NULL,'NGC 4262',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91965,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91965,31.1,0.12,16.6,38753,74.4,NULL,NULL,'NGC 4262',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91966,'Tertiary','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91966,30.49,0.25,12.5,38753,95,NULL,NULL,'NGC 4262',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91967,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91967,31.13,0.4,16.8,38753,75,NULL,'B','NGC 4262',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91968,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91968,31.67,0.4,21.5,38753,NULL,NULL,'mean','NGC 4262',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91969,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91969,32.38,0.45,29.9,38753,NULL,NULL,'K','NGC 4262',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91970,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91970,37.59,0.33,330,38754,70,NULL,NULL,'2MASX J12193074+2836111',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00012,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,184.8780417,28.603,0.095,NULL,58638183818,916221622,14315962,16.4),(91971,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91971,36.37,0.46,188,38755,70,NULL,NULL,'2MASX J12193130+0749148',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,184.8804583,7.82078,0,NULL,58207644812,909494450,14210850,17.2),(91972,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91972,33.42,0.46,48.3,38756,70,NULL,NULL,'UGC 07367',NULL,'2015arXiv151105856S',2015,1,1.6,NULL,'G',0.000133,NULL,'13.3g',0.8,'S0/a','Group member',NULL,NULL,NULL,1,184.8837083,49.81575,0,NULL,57182007608,893468868,13960451,13.3),(91973,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91973,37.55,0.1,324,38757,70,NULL,NULL,'2MASX J12193231+0504304',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000182,NULL,'16.2g',0.37,'E0',NULL,NULL,NULL,NULL,1,184.884667,5.07517,0,NULL,58032733740,906761464,14168147,16.2),(91974,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91974,37.8,0.46,362,38758,70,NULL,NULL,'2MASX J12193235+3755417',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000182,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,184.884875,37.92814,0,NULL,58585121690,915392526,14303008,16.9),(91975,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91975,33.6,0.46,52.5,38759,70,NULL,NULL,'NGC 4271',NULL,'2015arXiv151105856S',2015,1,1.5,NULL,'G',0.000103,NULL,'13.5g',1.3,'S0-:','Field galaxy',NULL,NULL,NULL,1,184.885833,56.73658,0,NULL,57398035396,896844303,14013192,13.5),(91976,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91976,37.02,0.46,253,38760,70,NULL,NULL,'2MASX J12193269+2856322',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000177,NULL,'16.2g',0.38,'E',NULL,NULL,NULL,NULL,1,184.886417,28.94239,0.104,NULL,58630368153,916099502,14314054,16.2),(91977,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91977,37.59,0.33,330,38761,70,NULL,NULL,'2MASX J12193287+2833292',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,184.887083,28.55811,0.095,NULL,58638190025,916221719,14315964,17.8),(91978,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91978,37.89,0.46,379,38762,70,NULL,NULL,'2MASX J12193333+0402434',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,184.888875,4.04539,0.023,NULL,58035180632,906799697,14168745,17.8),(91979,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91979,35.21,0.23,110,38763,70,NULL,NULL,'IC 3154',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.12',0.23,NULL,NULL,NULL,NULL,NULL,1,184.891625,25.58592,0.064,NULL,58647534482,916367726,14318245,16.12),(91980,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91980,37.97,0.46,393,38764,70,NULL,NULL,'2MASX J12193400+2212240',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,184.891916667,22.20661,0.055,NULL,58866146525,919783539,14371617,17.8),(91981,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91981,38.11,0.46,419,38765,70,NULL,NULL,'2MASX J12193465+1539078',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,184.894417,15.65217,0.006,NULL,58174049875,908969529,14202648,17.4),(91982,'D-Sigma','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91982,32.02,0.4,25.3,38766,75,NULL,'Edat, raw','IC 3152',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.00003,NULL,'13.05',1.5,'SA0-','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,184.8999583,-26.1455,0.429,NULL,43418708646,678417322,10600270,13.05),(91983,'D-Sigma','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91983,32.35,0.4,29.5,38766,75,NULL,'Edat, cor','IC 3152',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91984,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91984,33.29,0.45,45.6,38766,NULL,NULL,'K','IC 3152',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91985,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91985,33.5,0.4,50,38766,NULL,NULL,'mean','IC 3152',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91986,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91986,38.12,0.46,421,38767,70,NULL,NULL,'2MASX J12193595+0044434',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000093,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,184.8997083,0.74542,0.016,NULL,58041369269,906896394,14170256,17.4),(91987,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91987,36.29,0.46,181,38768,70,NULL,NULL,'2MASX J12193659+0845068',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,184.902333333,8.75178,0,NULL,58213661168,909588455,14212319,17.4),(91988,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91988,37.79,0.46,362,38769,70,NULL,NULL,'SDSS J121936.92+110702.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000142,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,184.903833333,11.11747,0.028,NULL,58209064850,909516638,14211197,18.2),(91989,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91989,37.03,0.46,254,38770,70,NULL,NULL,'2MASX J12193818+4753557',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000162,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,184.909125,47.899,0,NULL,57183932893,893498951,13960921,16.6),(91990,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91990,35.63,0.15,134,38771,70,NULL,NULL,'CGCG 158-065',NULL,'2015arXiv151105856S',2015,1,0.67,'2005A&A...430..373T have V = 2401 +- 29 km/s.','G',0.000204,NULL,'15.1g',0.57,'E?','Group member',NULL,NULL,NULL,1,184.91075,28.49542,0.087,NULL,58638198166,916221846,14315966,15.1),(91991,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91991,37.03,0.46,254,38772,70,NULL,NULL,'2MASX J12193866+1007378',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000158,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,184.911125,10.12731,0,NULL,58212622353,909572224,14212066,17),(91992,'SBF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91992,30.94,0.14,15.4,38773,NULL,NULL,'BV A01','IC 0779',NULL,'2007ApJ...668..130C',2007,1,1,NULL,'G',0.000093,NULL,'14.70',1,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,184.911375,29.88319,0.073,NULL,58631853162,916122705,14314417,14.7),(91993,'SBF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91993,31.11,0.14,16.7,38773,74.4,NULL,NULL,'IC 0779',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91994,'SBF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91994,31.19,0.1,17.3,38773,NULL,NULL,'J03','IC 0779',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91995,'SBF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91995,31.35,0.1,18.6,38773,NULL,NULL,'T01','IC 0779',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91996,'SBF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91996,31.47,0.23,19.7,38773,NULL,NULL,'M06','IC 0779',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91997,'TRGB','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,91997,30.32,NULL,11.6,38773,NULL,NULL,NULL,'IC 0779',NULL,'2006AJ....131.1361K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(91998,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91998,37.25,0.46,282,38774,70,NULL,NULL,'VPC 0056',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00019,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,184.912416667,11.99833,0.025,NULL,58138188958,908409202,14193893,16.7),(91999,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',91999,38.06,0.27,409,38775,70,NULL,NULL,'2MASX J12193929+5352132',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00018,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,184.9135417,53.87025,0.02,NULL,57223204842,894112575,13970508,18.3),(92000,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',92000,35.09,0.46,104,38776,70,NULL,NULL,'VPC 0057',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,184.9137083,13.47894,0.206,NULL,58170636259,908916191,14201815,16.3),(92001,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',92001,35.64,0.46,134,38777,70,NULL,NULL,'2MASX J12193989+0354374',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000178,NULL,'15.6g',0.4,'E/S0',NULL,NULL,NULL,NULL,1,184.916125,3.9105,0.023,NULL,58035208533,906800133,14168752,15.6),(92002,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',92002,37.84,0.46,370,38778,70,NULL,NULL,'2MASX J12194019+2656262',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000179,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,184.9175417,26.94061,0.088,NULL,58652282796,916441918,14319404,17),(92003,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,92003,32.06,0.2,25.8,38779,74.4,NULL,NULL,'UGC 07370',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000133,NULL,'14.9',0.3,'SBbc pec sp',NULL,NULL,NULL,NULL,1,184.917958333,2.08047,0,NULL,58044779945,906949686,14171088,14.9),(92004,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',92004,36.98,0.46,249,38780,70,NULL,NULL,'2MASX J12194073+3224250',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000177,NULL,'16.0g',0.42,NULL,NULL,NULL,NULL,NULL,1,184.919583,32.407,0,NULL,58770553801,918289903,14348279,16),(92005,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',92005,35.63,0.15,134,38781,70,NULL,NULL,'CGCG 158-069',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.000087,NULL,'15.1g',0.52,'E','Group member',NULL,NULL,NULL,1,184.9220417,28.8255,0.104,NULL,58630397865,916099966,14314061,15.1),(92006,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',92006,35.63,0.15,134,38782,70,NULL,NULL,'CGCG 158-068',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00011,NULL,'15.5g',0.4,'E','Group member',NULL,NULL,NULL,1,184.922083,28.78572,0.104,NULL,58630377891,916099654,14314057,15.5),(92007,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',92007,37.81,0.46,364,38783,70,NULL,NULL,'2MASX J12194131+4154358',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,184.922333,41.91008,0,NULL,58529390410,914521725,14289401,17),(92008,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',92008,37.1,0.46,263,38784,70,NULL,NULL,'2MASX J12194134+3925318',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000147,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,184.9225,39.42553,0,NULL,58574571272,915227676,14300432,17.2),(92009,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',92009,35.63,0.15,134,38785,70,NULL,NULL,'CGCG 158-067',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000123,NULL,'15.0g',0.64,'E','Group member',NULL,NULL,NULL,1,184.923333,28.72478,0.095,NULL,58637970552,916218289,14315910,15),(92010,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',92010,37.36,0.46,296,38786,70,NULL,NULL,'2MASX J12194166+5235302',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000147,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,184.923333,52.59172,0.005,NULL,57233387992,894271687,13972995,18.4),(92011,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,92011,33.38,0.47,47.3,38787,NULL,NULL,'H','NGC 4263',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.00003,NULL,'13.42',0.5,'SAB(rs)b pec   HII',NULL,NULL,NULL,NULL,1,184.925833,-12.22556,0.061,NULL,43059369311,672802645,10512541,13.42),(92012,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,92012,33.47,0.45,49.5,38787,NULL,NULL,'K','NGC 4263',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92013,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,92013,33.5,0.46,50.2,38787,NULL,NULL,'J','NGC 4263',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92014,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,92014,33.98,0.4,62.5,38787,NULL,NULL,'mean','NGC 4263',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92015,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',92015,36.77,0.33,226,38788,70,NULL,NULL,'2MASX J12194365+5232322',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000172,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,184.9317917,52.54228,0.005,NULL,57233432305,894272379,13973005,17),(92016,'FP','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,'R',92016,37.97,0.33,393,38789,70,NULL,NULL,'2MASX J12194383-0133269',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000139,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,184.932583,-1.5575,0.049,NULL,43007677030,671994953,10499921,17.9),(92017,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,92017,37.22,0.65,277,38790,NULL,NULL,'Malmquist cor.','LCSB S1709O',NULL,'2009ApJS..182..474S',2009,1,0.43,NULL,'G',0.000017,NULL,'16.4g',0.36,'Sb',NULL,NULL,NULL,NULL,1,184.93375,29.58042,0.09,NULL,58631978775,916124668,14314447,16.4),(92018,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,92018,37.5,0.57,317,38790,NULL,NULL,NULL,'LCSB S1709O',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92019,'Tully-Fisher','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,92019,37.54,0.2,322,38790,74.4,NULL,NULL,'LCSB S1709O',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92020,'GCLF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,92020,30.81,0.1,14.5,38791,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4267',NULL,'2010ApJ...717..603V',2010,1,3.2,NULL,'G',0.000017,NULL,'11.86',3,'SB(s)0-?','in a radial-velocity based grouping',NULL,NULL,NULL,1,184.9385,12.79828,0.024,NULL,58167288263,908863879,14200998,11.86),(92021,'GCLF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,92021,30.82,0.12,14.6,38791,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4267',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92022,'GCLF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,92022,30.85,0.11,14.8,38791,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4267',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92023,'GCLF','2016-12-15 15:14:57','2016-12-16 11:20:07','1',NULL,NULL,92023,30.94,0.1,15.4,38791,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4267',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92024,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92024,31,0.07,15.8,38791,NULL,NULL,'HST ACS VCS','NGC 4267',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92025,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92025,31,0.06,15.8,38791,NULL,NULL,NULL,'NGC 4267',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92026,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92026,31.06,0.12,16.3,38791,74.4,NULL,NULL,'NGC 4267',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92027,'GC radius','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92027,30.76,0.05,14.2,38791,NULL,NULL,NULL,'NGC 4267',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92028,'Faber-Jackson','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92028,30.61,0.5,13.2,38791,95,NULL,'de Vaucouleurs','NGC 4267',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92029,'Faber-Jackson','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92029,30.72,0.4,13.9,38791,95,NULL,'Weighted Mean','NGC 4267',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92030,'Faber-Jackson','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92030,32.59,0.81,33,38791,55,NULL,'Visvanathan & Sandage 1979','NGC 4267',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92031,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92031,30.83,NULL,14.7,38791,NULL,NULL,NULL,'NGC 4267',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92032,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92032,31.06,0.12,16.3,38791,74.4,NULL,NULL,'NGC 4267',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92033,'Tertiary','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92033,30.49,0.25,12.5,38791,95,NULL,NULL,'NGC 4267',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92034,'Tully est','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92034,31.13,0.8,16.8,38791,75,NULL,'B','NGC 4267',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92035,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92035,31.57,0.4,20.6,38791,NULL,NULL,'mean','NGC 4267',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92036,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92036,31.97,0.45,24.8,38791,NULL,NULL,'K','NGC 4267',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92037,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92037,37.67,0.46,342,38792,70,NULL,NULL,'2MASX J12194653+2821512',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,184.943875,28.36425,0.075,NULL,58638124602,916220696,14315948,17.2),(92038,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92038,32.27,0.54,28.4,38793,NULL,NULL,'Malmquist cor.','NGC 4268',NULL,'2009ApJS..182..474S',2009,1,1.61,'v=2374 km/s (1991RC3.9.C...0000d)','G',0.000017,NULL,'13.3g',0.74,'SB0/a: sp','in a radial-velocity based grouping',NULL,NULL,NULL,1,184.94675,5.28378,0,NULL,58032735021,906761484,14168148,13.3),(92039,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92039,32.44,0.5,30.8,38793,NULL,NULL,NULL,'NGC 4268',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92040,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92040,32.48,0.2,31.3,38793,74.4,NULL,NULL,'NGC 4268',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92041,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92041,37.8,0.33,362,38794,70,NULL,NULL,'2MASX J12194737+0307321',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000196,NULL,'16.8g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,184.947375,3.12569,0.007,NULL,58046187033,906971672,14171432,16.8),(92042,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92042,37.37,0.46,298,38795,70,NULL,NULL,'2MASX J12194739+0834458',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000174,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,184.947583333,8.57947,0,NULL,58213349963,909583593,14212243,16.9),(92043,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92043,35.97,0.27,156,38796,70,NULL,NULL,'NGC 4272',NULL,'2015arXiv151105856S',2015,1,1.25,'87GB source with large sky, narrow minor axis, or very bad confusion.','G',0.000073,NULL,'13.9g',0.93,'S0-',NULL,NULL,NULL,NULL,1,184.9485,30.33908,0.06,NULL,58629612703,916087698,14313870,13.9),(92044,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92044,35,0.45,100,38796,NULL,NULL,'K','NGC 4272',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92045,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92045,35.45,0.4,123,38796,NULL,NULL,'mean','NGC 4272',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92046,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92046,36.9,0.46,240,38797,70,NULL,NULL,'IC 3157',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',NULL,NULL,'15.2g',0.45,'S0_1_(6);BrClG','Group member',NULL,NULL,NULL,1,184.949666667,12.42194,0.024,NULL,58167239411,908863115,14200986,15.2),(92047,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92047,37.65,0.46,339,38798,70,NULL,NULL,'SDSS J121948.44+162806.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,184.951875,16.46856,0.046,NULL,58174653774,908978965,14202796,18.5),(92048,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92048,35.97,0.27,156,38799,70,NULL,NULL,'2MASX J12194871+3021581',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000163,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,184.952917,30.36608,0.06,NULL,58629581445,916087210,14313862,16.8),(92049,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92049,36.87,0.46,237,38800,70,NULL,NULL,'2MASX J12194892+2336049',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.91',0.22,NULL,NULL,NULL,NULL,NULL,1,184.9537917,23.6015,0.11,NULL,58590914324,915483036,14304422,16.91),(92050,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92050,37.44,0.46,308,38801,70,NULL,NULL,'2MASX J12194917+2928202',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,184.955167,29.47231,0.09,NULL,58631950932,916124233,14314441,17.7),(92051,'Faber-Jackson','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92051,30.96,0.81,15.6,38802,55,NULL,'Visvanathan & Sandage 1979','NGC 4270',NULL,'1984ApJS...56...91D',1984,1,2.05,NULL,'G',0.000017,NULL,'12.7g',0.9,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,184.956125,5.46344,0,NULL,58032821187,906762831,14168169,12.7),(92052,'Faber-Jackson','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92052,31.03,0.37,16.1,38802,95,NULL,'Weighted Mean','NGC 4270',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92053,'Faber-Jackson','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92053,31.66,0.63,21.5,38802,95,NULL,'Michard 1979b, c','NGC 4270',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92054,'Faber-Jackson','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92054,31.86,0.46,23.6,38802,95,NULL,'Michard 1979a','NGC 4270',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92055,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92055,31.89,0.25,23.9,38802,74.4,NULL,NULL,'NGC 4270',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92056,'Tertiary','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92056,31.75,0.29,22.4,38802,95,NULL,NULL,'NGC 4270',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92057,'Tully est','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92057,32.73,0.8,35.1,38802,75,NULL,'B','NGC 4270',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92058,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92058,32.27,0.45,28.4,38802,NULL,NULL,'K','NGC 4270',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92059,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92059,32.88,0.4,37.8,38802,NULL,NULL,'mean','NGC 4270',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92060,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92060,37.68,0.21,343,38803,70,NULL,NULL,'2MASX J12195047+0410131',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,184.960333333,4.17025,0.063,NULL,58035275599,906801181,14168768,17.2),(92061,'Ring Diameter','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92061,29.8,0.76,9,38804,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4274',NULL,'1981ApJS...45..541P',1981,1,6.8,NULL,'G',0.000023,NULL,'11.34',2.5,'(R)SB(r)ab     LINER','in a radial-velocity based grouping',NULL,NULL,'LINER',1,184.9607917,29.61447,0.09,NULL,58631974743,916124605,14314446,11.34),(92062,'Ring Diameter','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92062,30,0.6,9.9,38804,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4274',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92063,'Tully est','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92063,29.93,0.8,9.7,38804,75,NULL,'B','NGC 4274',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92064,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92064,31.44,0.36,19.4,38804,NULL,NULL,NULL,'NGC 4274',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92065,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92065,31.65,0.3,21.4,38804,55,NULL,'B','NGC 4274',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92066,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92066,38.56,0.46,515,38805,70,NULL,NULL,'2MASX J12195081+6117207',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000173,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,184.961917,61.28911,0,NULL,57338360699,895911885,13998623,17.9),(92067,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92067,36.46,0.27,196,38806,70,NULL,NULL,'2MASX J12195090+4145168',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000174,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,184.962333,41.75464,0,NULL,58529175188,914518362,14289349,17.2),(92068,'IRAS','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92068,33.72,0.8,55.4,38807,75,NULL,'MAT, I','ESO 380- G 014',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'14.30',0.6,'SB(rs)c:',NULL,NULL,NULL,NULL,1,184.96275,-36.4595,0.321,NULL,43270089557,676095149,10563986,14.3),(92069,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92069,33.35,0.32,46.7,38807,85,NULL,'I, raw','ESO 380- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92070,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92070,33.39,0.32,47.6,38807,85,NULL,'I, inv','ESO 380- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92071,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92071,33.45,0.43,49.1,38807,75,NULL,'MAT, I, raw','ESO 380- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92072,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92072,33.55,0.39,51.4,38807,NULL,NULL,'Malmquist cor.','ESO 380- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92073,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92073,33.58,0.43,52.1,38807,75,NULL,'MAT, I, cor','ESO 380- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92074,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92074,33.66,0.43,53.9,38807,75,NULL,'MAT, I, inv','ESO 380- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92075,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92075,33.72,0.36,55.5,38807,NULL,NULL,NULL,'ESO 380- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92076,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92076,33.76,0.2,56.5,38807,74.4,NULL,NULL,'ESO 380- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92077,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92077,38.31,0.46,460,38808,70,NULL,NULL,'2MASX J12195152+2813182',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00017,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,184.9645,28.22175,0.075,NULL,58638082997,916220046,14315938,18),(92078,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92078,37.55,0.1,324,38809,70,NULL,NULL,'2MASX J12195190+0515181',NULL,'2015arXiv151105856S',2015,1,0.22,'Multiple SDSS entries describe this object.','G',0.000159,NULL,'18.01',0.15,NULL,NULL,NULL,NULL,NULL,1,184.966833,5.25469,0,NULL,58033209600,906768900,14168264,18.01),(92079,'Tully est','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92079,32.82,0.8,36.7,38810,75,NULL,'B','NGC 4275',NULL,'1988NBGC.C....0000T',1988,1,0.82,NULL,'G',0.000033,NULL,'13.4g',0.76,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,184.969083333,27.621,0.085,NULL,58637743417,916214740,14315855,13.4),(92080,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92080,35.63,0.15,134,38811,70,NULL,NULL,'CGCG 158-074',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000153,NULL,'15.3g',0.41,'E?','Group member',NULL,NULL,NULL,1,184.9725417,28.38586,0.087,NULL,58638123605,916220681,14315948,15.3),(92081,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92081,38.06,0.27,409,38812,70,NULL,NULL,'2MASX J12195365+5355173',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000169,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,184.973667,53.92139,0.02,NULL,57223217147,894112767,13970511,17),(92082,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92082,37.17,0.46,272,38813,70,NULL,NULL,'2MASX J12195384+0255511',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,184.9744583,2.93078,0,NULL,58046164159,906971314,14171426,16.9),(92083,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92083,36.46,0.27,196,38814,70,NULL,NULL,'2MASX J12195385+4150448',NULL,'2015arXiv151105856S',2015,1,0.87,NULL,'G',0.000186,NULL,'15.3g',0.48,'E0',NULL,NULL,NULL,NULL,1,184.9744583,41.84581,0,NULL,58529396364,914521818,14289403,15.3),(92084,'SNIa','2016-12-15 15:14:58','2016-12-16 11:20:07','1','PS1 SN PS11xw','N',92084,40.66,0.12,1060,38815,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11xw HOST',0.2707,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92085,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92085,38.56,0.46,516,38816,70,NULL,NULL,'SDSS J121954.00+143749.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000136,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,184.975,14.6305,0.097,NULL,58182327729,909098870,14204669,18.2),(92086,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92086,37.56,0.46,325,38817,70,NULL,NULL,'2MASX J12195420+4249455',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,184.975791667,42.82947,0,NULL,59062293423,922848334,14419505,17.5),(92087,'Sosies','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92087,32.77,0.39,35.8,38818,NULL,NULL,NULL,'NGC 4273',NULL,'2002A&A...393...57T',2002,1,2.32,NULL,'G',0.000013,NULL,'12.6g',1.13,'SB(s)c         HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,184.983666667,5.34333,0,NULL,58033326452,906770725,14168292,12.6),(92088,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92088,31.68,0.69,21.7,38818,100,NULL,'mid-IR','NGC 4273',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92089,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92089,32.16,0.43,27,38818,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4273',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92090,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92090,32.19,NULL,27.4,38818,NULL,NULL,NULL,'NGC 4273',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92091,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92091,32.28,0.48,28.5,38818,NULL,NULL,'Malmquist cor.','NGC 4273',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92092,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92092,32.35,0.43,29.5,38818,75,NULL,'3.6 micron, color corrected','NGC 4273',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92093,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92093,32.45,0.44,30.8,38818,NULL,NULL,NULL,'NGC 4273',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92094,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92094,32.49,0.2,31.5,38818,74.4,NULL,NULL,'NGC 4273',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92095,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92095,32.73,0.4,35.1,38818,75,NULL,'B','NGC 4273',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92096,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92096,32.82,0.45,36.6,38818,NULL,NULL,'K','NGC 4273',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92097,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92097,32.83,0.4,36.8,38818,NULL,NULL,'mean','NGC 4273',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92098,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92098,32.85,0.46,37.1,38818,NULL,NULL,'J','NGC 4273',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92099,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92099,32.89,0.47,37.8,38818,NULL,NULL,'H','NGC 4273',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92100,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92100,32.91,0.3,38.2,38818,55,NULL,'B','NGC 4273',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92101,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92101,36.76,0.46,225,38819,70,NULL,NULL,'2MASX J12195642+1904311',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.25',0.14,NULL,NULL,NULL,NULL,NULL,1,184.985166667,19.07539,0.088,NULL,58862751846,919730497,14370789,18.25),(92102,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92102,35.21,0.23,110,38820,70,NULL,NULL,'IC 0780',NULL,'2015arXiv151105856S',2015,1,1.6,NULL,'G',0.000103,NULL,'13.87',1.2,'S0-:',NULL,NULL,NULL,NULL,1,184.99325,25.77169,0.07,NULL,58647417315,916365895,14318217,13.87),(92103,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92103,37.03,0.46,255,38821,70,NULL,NULL,'2MASX J12195988+6519217',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,184.9994583,65.32272,0.025,NULL,57327718617,895745603,13996025,17.2),(92104,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92104,36.99,0.46,250,38822,70,NULL,NULL,'2MASX J12200047+4751216',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00017,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,185.001917,47.85608,0,NULL,57183946628,893499166,13960924,17.4),(92105,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92105,34.81,0.52,91.8,38823,70,NULL,NULL,'2MASX J12200050-1729189',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'13.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,185.002083,-17.48856,0.093,NULL,43022021638,672219088,10503423,13.4),(92106,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92106,37.8,0.33,362,38824,70,NULL,NULL,'2MASX J12200059+0308161',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,185.002583,3.13783,0,NULL,58046221929,906972217,14171440,17.5),(92107,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92107,37.57,0.46,327,38825,70,NULL,NULL,'2MASX J12200148+3211591',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000203,NULL,'16.81',0.15,NULL,NULL,NULL,NULL,NULL,1,185.006125,32.19992,NULL,NULL,58770014141,918281470,14348147,16.81),(92108,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92108,36.18,0.27,173,38826,70,NULL,NULL,'MCG +09-20-146',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000067,NULL,'15.0g',0.45,'S0',NULL,NULL,NULL,NULL,1,185.0062917,56.16292,0.009,NULL,57396885888,896826342,14012911,15),(92109,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92109,37.03,0.46,255,38827,70,NULL,NULL,'2MASX J12200184+5738307',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,185.007667,57.64194,0,NULL,57397825966,896841030,14013141,17.3),(92110,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92110,37.7,0.46,346,38828,70,NULL,NULL,'2MASX J12200290+0052571',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000079,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,185.012,0.88242,0.02,NULL,58041668611,906901072,14170329,17.6),(92111,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92111,37.3,0.46,289,38829,70,NULL,NULL,'SDSS J122002.98+123455.1',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,185.012417,12.582,0.024,NULL,58167305784,908864152,14201002,17.4),(92112,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92112,35.93,0.46,154,38830,70,NULL,NULL,'2MASX J12200368+2024061',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'15.95',0.29,NULL,NULL,NULL,NULL,NULL,1,185.0152083,20.40186,0.094,NULL,58867792291,919809254,14372019,15.95),(92113,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92113,36,0.46,159,38831,70,NULL,NULL,'2MASX J12200375+4331296',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000152,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,185.015833,43.52483,0,NULL,59071435838,922991184,14421737,16.9),(92114,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92114,35.63,0.15,134,38832,70,NULL,NULL,'2MASX J12200454+2853502',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00016,NULL,'16.1g',0.3,'E',NULL,NULL,NULL,NULL,1,185.018917,28.89728,0.104,NULL,58630348078,916099188,14314049,16.1),(92115,'SNIa','2016-12-15 15:14:58','2016-12-16 11:20:07','1','SN PTF11qpc',NULL,92115,38,0.08,399,38833,72,NULL,'M(H) = -18.317 mag','SDSS J122005.45+092418.3',NULL,'2014ApJ...784..105W',2013,1,0.26,NULL,'G',0.000179,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,185.02275,9.40508,0,NULL,58211245809,909550715,14211729,18),(92116,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92116,37.96,0.46,391,38834,70,NULL,NULL,'2MASX J12200631+1531312',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000141,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,185.026375,15.52558,0.047,NULL,58173576977,908962140,14202533,17.9),(92117,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92117,38.09,0.33,416,38835,70,NULL,NULL,'SDSS J122006.45+300435.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000146,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,185.026917,30.07647,0.06,NULL,58631702544,916120352,14314380,18.4),(92118,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92118,37.95,0.46,389,38836,70,NULL,NULL,'2MASX J12200655+6205136',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000182,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,185.027083,62.08711,0.017,NULL,57371527201,896430112,14006720,17.2),(92119,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92119,36.52,0.46,201,38837,70,NULL,NULL,'2MASX J12200648+3123030',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,185.027167,31.38397,NULL,NULL,58760886948,918138858,14345919,17.4),(92120,'GCLF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92120,30.61,0.14,13.2,38838,NULL,NULL,NULL,'NGC 4278',NULL,'1996AJ....112.1409F',1996,1,4.1,NULL,'G',0.000017,NULL,'11.20',3.8,'E1-2;LINER     Sy1','in a radial-velocity based grouping',NULL,NULL,'Flat-Spectrum Radio Source',1,185.028416667,29.28075,0.102,NULL,58631496490,916117132,14314330,11.2),(92121,'GCLF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92121,30.74,0.28,14.1,38838,NULL,NULL,'HST KP Calibrated, V','NGC 4278',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92122,'GCLF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92122,31.13,0.11,16.8,38838,NULL,NULL,NULL,'NGC 4278',NULL,'2001AJ....121.2950K',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92123,'PNLF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92123,30,0.19,10,38838,NULL,NULL,NULL,'NGC 4278',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92124,'PNLF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92124,30.04,0.16,10.2,38838,NULL,NULL,'23 PNe','NGC 4278',NULL,'1996ApJ...462....1J',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92125,'PNLF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92125,30.12,0.18,10.6,38838,NULL,NULL,'HST KP Calibrated','NGC 4278',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92126,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92126,30.87,0.2,14.9,38838,NULL,NULL,'I','NGC 4278',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92127,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92127,30.93,0.14,15.4,38838,74.4,NULL,NULL,'NGC 4278',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92128,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92128,30.95,0.08,15.5,38838,NULL,NULL,'I','NGC 4278',NULL,'1997ApJ...475..399T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92129,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92129,31.03,0.2,16.1,38838,NULL,NULL,'I','NGC 4278',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92130,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92130,31.03,0.2,16.1,38838,NULL,NULL,NULL,'NGC 4278',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92131,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92131,31.08,0.2,16.5,38838,NULL,NULL,'Malmquist cor.','NGC 4278',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92132,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92132,31.09,0.21,16.5,38838,NULL,NULL,'HST KP Calibrated, I','NGC 4278',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92133,'D-Sigma','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92133,31.19,0.4,17.3,38838,75,NULL,'Edat, raw','NGC 4278',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92134,'D-Sigma','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92134,31.36,0.4,18.7,38838,75,NULL,'Edat, cor','NGC 4278',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92135,'Faber-Jackson','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92135,30.37,0.63,11.9,38838,95,NULL,'Michard 1979b, c','NGC 4278',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92136,'Faber-Jackson','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92136,30.96,0.23,15.6,38838,95,NULL,'Weighted Mean','NGC 4278',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92137,'Faber-Jackson','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92137,30.98,0.46,15.7,38838,95,NULL,'Michard 1979a','NGC 4278',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92138,'Faber-Jackson','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92138,31.06,0.29,16.3,38838,95,NULL,'de Vaucouleurs','NGC 4278',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92139,'Faber-Jackson','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92139,31.67,NULL,21.6,38838,NULL,NULL,'LEDA [April 2006]','NGC 4278',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92140,'Faber-Jackson','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92140,32.55,0.81,32.4,38838,55,NULL,'Visvanathan & Sandage 1979','NGC 4278',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92141,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92141,31.31,0.41,18.3,38838,NULL,NULL,NULL,'NGC 4278',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92142,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92142,31.41,0.41,19.2,38838,NULL,NULL,'Malmquist cor.','NGC 4278',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92143,'Tertiary','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92143,30.98,0.27,15.7,38838,95,NULL,NULL,'NGC 4278',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92144,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92144,29.93,0.4,9.7,38838,75,NULL,'B','NGC 4278',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92145,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92145,31.03,0.4,16.1,38838,NULL,NULL,'mean','NGC 4278',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92146,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92146,31.96,0.45,24.7,38838,NULL,NULL,'K','NGC 4278',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92147,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92147,38.09,0.33,416,38839,70,NULL,NULL,'2MASX J12200721+3002430',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000148,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,185.029916667,30.04536,0.06,NULL,58631702842,916120356,14314380,17),(92148,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92148,37.59,0.23,329,38840,70,NULL,NULL,'2MASXi J1220092+330635',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000189,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,185.0387917,33.10972,0,NULL,58768013276,918250207,14347659,17),(92149,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92149,37.51,0.46,318,38841,70,NULL,NULL,'2MASX J12200997-0137159',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,185.041583333,-1.62122,0.053,NULL,43007696065,671995251,10499925,17.2),(92150,'IRAS','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92150,33.76,0.8,56.5,38842,75,NULL,'MAT, I','ESO 506- G 002',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000017,NULL,'14.80',0.34,'Sbc','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,185.0422917,-26.06675,0.429,NULL,43418657941,678416530,10600258,14.8),(92151,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92151,33.15,NULL,42.7,38842,NULL,NULL,NULL,'ESO 506- G 002',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92152,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92152,33.84,0.43,58.7,38842,75,NULL,'MAT, I, raw','ESO 506- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92153,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92153,33.94,0.4,61.5,38842,NULL,NULL,'mean','ESO 506- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92154,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92154,34.04,0.32,64.2,38842,85,NULL,'I, raw','ESO 506- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92155,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92155,34.1,0.32,66,38842,85,NULL,'I, inv','ESO 506- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92156,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92156,34.1,0.43,66.1,38842,75,NULL,'MAT, I, inv','ESO 506- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92157,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92157,34.21,0.43,69.5,38842,75,NULL,'MAT, I, cor','ESO 506- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92158,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92158,34.22,0.46,69.8,38842,NULL,NULL,'J','ESO 506- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92159,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92159,34.23,0.2,70.2,38842,74.4,NULL,NULL,'ESO 506- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92160,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92160,34.28,0.47,71.7,38842,NULL,NULL,'H','ESO 506- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92161,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92161,34.3,0.49,72.4,38842,75,NULL,'IR','ESO 506- G 002',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92162,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92162,34.31,0.38,72.8,38842,NULL,NULL,NULL,'ESO 506- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92163,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92163,34.31,0.38,72.9,38842,NULL,NULL,'Malmquist cor.','ESO 506- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92164,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92164,34.33,NULL,73.5,38842,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 506- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92165,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92165,34.33,NULL,73.6,38842,NULL,NULL,'Dipole + Quadrupole','ESO 506- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92166,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92166,34.34,NULL,73.8,38842,NULL,NULL,'Dipole','ESO 506- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92167,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92167,34.34,0.45,73.9,38842,NULL,NULL,'K','ESO 506- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92168,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92168,35.63,0.15,134,38843,70,NULL,NULL,'CGCG 158-078',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000181,NULL,'15.5g',0.34,'E?','Group member',NULL,NULL,NULL,1,185.0425417,28.38897,0.087,NULL,58638096933,916220264,14315941,15.5),(92169,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92169,38.75,0.46,561,38844,70,NULL,NULL,'SDSS J122010.65+002808.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000076,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,185.044417,0.46894,0.021,NULL,57986383767,906037246,14156831,18.6),(92170,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92170,37.21,0.46,277,38845,70,NULL,NULL,'2MASX J12201128+2740482',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000113,NULL,'16.1g',0.42,NULL,NULL,NULL,NULL,NULL,1,185.047125,27.68006,0.076,NULL,58637712005,916214250,14315847,16.1),(92171,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92171,37.68,0.21,343,38846,70,NULL,NULL,'VCC 0396',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000167,NULL,'17.1g',0.26,'dE4?,N','Group member',NULL,NULL,NULL,1,185.0512083,4.26989,0.063,NULL,58035935978,906811499,14168929,17.1),(92172,'IRAS','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92172,33.93,0.8,61.2,38847,75,NULL,'CF, r','NGC 4284',NULL,'1997ApJS..109..333W',1997,1,2.02,NULL,'G',0.000013,NULL,'13.9g',0.77,'Sbc','Pair member (points to parent)',NULL,NULL,NULL,1,185.052583333,58.09289,0,NULL,57397184407,896831006,14012984,13.9),(92173,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92173,33.1,0.69,41.7,38847,100,NULL,'mid-IR','NGC 4284',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92174,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92174,34.13,0.38,66.9,38847,75,NULL,'CF, r, raw','NGC 4284',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92175,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92175,34.13,0.2,67,38847,74.4,NULL,NULL,'NGC 4284',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92176,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92176,34.14,0.43,67.3,38847,75,NULL,'3.6 micron, color corrected','NGC 4284',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92177,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92177,34.23,0.4,70,38847,NULL,NULL,'Malmquist cor.','NGC 4284',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92178,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92178,34.25,0.4,70.9,38847,NULL,NULL,'mean','NGC 4284',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92179,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92179,34.26,0.38,71,38847,75,NULL,'CF, r, cor','NGC 4284',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92180,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92180,34.28,0.38,71.7,38847,75,NULL,'CF, r, inv','NGC 4284',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92181,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92181,34.28,0.43,71.9,38847,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4284',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92182,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92182,34.3,0.39,72.3,38847,NULL,NULL,NULL,'NGC 4284',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92183,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92183,34.45,0.47,77.5,38847,NULL,NULL,'H','NGC 4284',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92184,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92184,34.5,0.46,79.5,38847,NULL,NULL,'J','NGC 4284',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92185,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92185,34.54,0.45,80.9,38847,NULL,NULL,'K','NGC 4284',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92186,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92186,36.69,0.46,217,38848,70,NULL,NULL,'2MASX J12201287+3728494',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,185.0535417,37.48047,0,NULL,58583355692,915364932,14302577,17.5),(92187,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92187,37.28,0.46,286,38849,70,NULL,NULL,'2MASX J12201353+2828562',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000183,NULL,'17.89',0.2,NULL,NULL,NULL,NULL,NULL,1,185.056333333,28.48231,0.087,NULL,58638157201,916221206,14315956,17.89),(92188,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92188,36.75,0.46,224,38850,70,NULL,NULL,'2MASX J12201541+6228458',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000166,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,185.064,62.47947,0.017,NULL,57373035656,896453682,14007088,16.7),(92189,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92189,38.84,0.46,587,38851,70,NULL,NULL,'2MASX J12201634+5620257',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000137,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,185.067917,56.34039,0.037,NULL,57396337287,896817770,14012777,18),(92190,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92190,37.59,0.23,329,38852,70,NULL,NULL,'2MASX J12201651+3305280',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000155,NULL,'17.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,185.068833333,33.09103,0,NULL,58768014564,918250227,14347659,17.3),(92191,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92191,37.28,0.46,285,38853,70,NULL,NULL,'VPC 0087',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,185.069708333,10.66281,0.016,NULL,58212483447,909570053,14212032,16.9),(92192,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92192,36.69,0.46,217,38854,70,NULL,NULL,'2MASX J12201697+4658416',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000151,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,185.070833,46.97831,0,NULL,59065476752,922898074,14420282,16.8),(92193,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92193,32.86,0.4,37.3,38855,NULL,NULL,NULL,'UGC 07387',NULL,'2009AJ....138..323T',2009,1,2.53,'Giovanelli(1997,Priv.Comm.) says v=4969 km/s (1997,AJ,114,122) in error.','G',0.00001,NULL,'15.2g',0.3,'Sd(f)          HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,185.0722917,4.20167,0.063,NULL,58034828999,906794203,14168659,15.2),(92194,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92194,32.88,0.43,37.6,38855,75,NULL,'3.6 micron, color + selection bias corrected','UGC 07387',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92195,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92195,32.9,0.49,38,38855,75,NULL,'IR','UGC 07387',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92196,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92196,32.98,0.43,39.4,38855,75,NULL,'3.6 micron, color corrected','UGC 07387',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92197,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92197,32.98,0.66,39.5,38855,NULL,NULL,'Malmquist cor.','UGC 07387',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92198,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92198,33.05,0.2,40.7,38855,74.4,NULL,NULL,'UGC 07387',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92199,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92199,33.24,0.59,44.4,38855,NULL,NULL,NULL,'UGC 07387',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92200,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92200,33.57,NULL,51.8,38855,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07387',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92201,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92201,33.58,NULL,52,38855,NULL,NULL,'Dipole + Quadrupole','UGC 07387',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92202,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92202,33.58,NULL,52.1,38855,NULL,NULL,'Dipole','UGC 07387',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92203,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92203,33.62,NULL,53,38855,NULL,NULL,NULL,'UGC 07387',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92204,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92204,31.93,0.32,24.3,38856,NULL,NULL,'I','NGC 4291',NULL,'2003ApJ...583..712J',2003,1,1.9,NULL,'G',0.000083,NULL,'12.43',1.6,'E3;Candidate   AGN','X-ray-bright group member',NULL,NULL,NULL,1,185.075833,75.37083,0.061,NULL,57016543873,890883498,13920054,12.43),(92205,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92205,32.09,0.32,26.2,38856,NULL,NULL,'I','NGC 4291',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92206,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92206,32.09,0.32,26.2,38856,NULL,NULL,NULL,'NGC 4291',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92207,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92207,32.1,0.14,26.3,38856,74.4,NULL,NULL,'NGC 4291',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92208,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92208,32.22,0.32,27.7,38856,NULL,NULL,'Malmquist cor.','NGC 4291',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92209,'D-Sigma','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92209,32.79,0.4,36.1,38856,75,NULL,'Edat, raw','NGC 4291',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92210,'D-Sigma','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92210,32.93,0.4,38.6,38856,75,NULL,'Edat, cor','NGC 4291',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92211,'Faber-Jackson','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92211,32.34,0.4,29.4,38856,95,NULL,'Weighted Mean','NGC 4291',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92212,'Faber-Jackson','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92212,32.77,0.81,35.8,38856,55,NULL,'Visvanathan & Sandage 1979','NGC 4291',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92213,'Faber-Jackson','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92213,32.88,0.51,37.7,38856,95,NULL,'de Vaucouleurs','NGC 4291',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92214,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92214,32.83,0.41,36.8,38856,NULL,NULL,NULL,'NGC 4291',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92215,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92215,32.97,0.41,39.2,38856,NULL,NULL,'Malmquist cor.','NGC 4291',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92216,'Tertiary','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92216,31.72,0.71,22.1,38856,95,NULL,NULL,'NGC 4291',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92217,'Tully est','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92217,32.34,0.8,29.4,38856,75,NULL,'B','NGC 4291',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92218,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92218,32.47,0.4,31.2,38856,NULL,NULL,'mean','NGC 4291',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92219,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92219,33.61,0.45,52.7,38856,NULL,NULL,'K','NGC 4291',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92220,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92220,37.66,0.46,341,38857,70,NULL,NULL,'SDSS J122018.18+323505.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,185.07575,32.58472,0,NULL,58770355234,918286800,14348231,17.8),(92221,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92221,37.58,0.46,328,38858,70,NULL,NULL,'2MASX J12201845+0300331',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000193,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,185.076833,3.00922,0,NULL,58046197018,906971828,14171434,16.9),(92222,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92222,37.71,0.46,348,38859,70,NULL,NULL,'SDSS J122018.99+182813.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,185.079167,18.47053,0.075,NULL,58859353694,919677401,14369959,18.5),(92223,'CMD','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'N',92223,18.01,NULL,0.04,38860,NULL,NULL,NULL,'Vir Z',NULL,'2009AJ....137..450W',2009,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92224,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92224,37.68,0.21,343,38861,70,NULL,NULL,'2MASX J12201928+0419591',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,185.0802917,4.33317,0.063,NULL,58035990804,906812356,14168943,17.1),(92225,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92225,38.11,0.46,420,38862,70,NULL,NULL,'2MASX J12201970+3611035',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,185.082166667,36.18444,0,NULL,58541709850,914714216,14292409,17.3),(92226,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92226,36.73,0.46,221,38863,70,NULL,NULL,'2MASX J12202024+4136465',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000187,NULL,'16.2g',0.33,'E0',NULL,NULL,NULL,NULL,1,185.0842917,41.61289,0.025,NULL,58529161005,914518140,14289345,16.2),(92227,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92227,38.31,0.46,458,38864,70,NULL,NULL,'SDSS J122020.29+053311.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,185.084583,5.55308,0,NULL,58032462676,906757229,14168081,18.1),(92228,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92228,30.98,0.19,15.7,38865,NULL,NULL,'I','NGC 4283',NULL,'2001ApJ...546..681T',2001,1,1.5,NULL,'G',0.000017,NULL,'13.10',1.5,'E0','in a radial-velocity based grouping',NULL,NULL,NULL,1,185.086875,29.31094,0.102,NULL,58631504953,916117264,14314332,13.1),(92229,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92229,30.98,0.19,15.7,38865,NULL,NULL,NULL,'NGC 4283',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92230,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92230,30.99,0.14,15.8,38865,74.4,NULL,NULL,'NGC 4283',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92231,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92231,31.03,0.19,16.1,38865,NULL,NULL,'Malmquist cor.','NGC 4283',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92232,'D-Sigma','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92232,31.19,0.4,17.3,38865,75,NULL,'Edat, raw','NGC 4283',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92233,'D-Sigma','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92233,31.36,0.4,18.7,38865,75,NULL,'Edat, cor','NGC 4283',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92234,'Faber-Jackson','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92234,29.64,0.89,8.47,38865,95,NULL,'de Vaucouleurs','NGC 4283',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92235,'Faber-Jackson','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92235,31.59,0.53,20.8,38865,95,NULL,'Weighted Mean','NGC 4283',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92236,'Faber-Jackson','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92236,34.25,0.81,70.8,38865,55,NULL,'Visvanathan & Sandage 1979','NGC 4283',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92237,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92237,30.95,0.41,15.5,38865,NULL,NULL,NULL,'NGC 4283',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92238,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92238,31.14,0.41,16.9,38865,NULL,NULL,'Malmquist cor.','NGC 4283',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92239,'Tertiary','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92239,30.23,0.29,11.1,38865,95,NULL,NULL,'NGC 4283',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92240,'Tully est','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92240,29.93,0.8,9.7,38865,75,NULL,'B','NGC 4283',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92241,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92241,36.26,0.46,179,38866,70,NULL,NULL,'2MASX J12202139+4220286',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000174,NULL,'15.9g',0.38,'E0',NULL,NULL,NULL,NULL,1,185.0890417,42.34139,0,NULL,59062170280,922846410,14419475,15.9),(92242,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92242,35.21,0.23,110,38867,70,NULL,NULL,'IC 3169',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.75',0.18,NULL,NULL,NULL,NULL,NULL,1,185.089125,25.5995,0.069,NULL,58648137128,916377142,14318392,17.75),(92243,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92243,38.09,0.46,414,38868,70,NULL,NULL,'2MASX J12202142+1142011',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000173,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,185.0892083,11.70031,0.02,NULL,58138118889,908408107,14193876,17.8),(92244,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92244,31.94,0.28,24.4,38869,NULL,NULL,'I','NGC 4281',NULL,'2001ApJ...546..681T',2001,1,3,NULL,'G',0.000017,NULL,'12.25',1.5,'S0+: sp','in a radial-velocity based grouping',NULL,NULL,NULL,1,185.089667,5.38639,0,NULL,58033359584,906771243,14168300,12.25),(92245,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92245,32.02,0.14,25.4,38869,74.4,NULL,NULL,'NGC 4281',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92246,'Faber-Jackson','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92246,31.51,0.81,20,38869,55,NULL,'Visvanathan & Sandage 1979','NGC 4281',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92247,'Faber-Jackson','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92247,32.16,0.29,27,38869,95,NULL,'Weighted Mean','NGC 4281',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92248,'Faber-Jackson','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92248,32.55,0.63,32.4,38869,95,NULL,'Michard 1979b, c','NGC 4281',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92249,'Faber-Jackson','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92249,32.8,0.46,36.3,38869,95,NULL,'Michard 1979a','NGC 4281',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92250,'Faber-Jackson','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92250,32.9,0.48,38,38869,95,NULL,'de Vaucouleurs','NGC 4281',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92251,'Tertiary','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92251,31.75,0.29,22.4,38869,95,NULL,NULL,'NGC 4281',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92252,'Tully est','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92252,32.73,0.8,35.1,38869,75,NULL,'B','NGC 4281',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92253,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92253,32.69,0.45,34.6,38869,NULL,NULL,'K','NGC 4281',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92254,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92254,33.15,0.4,42.6,38869,NULL,NULL,'mean','NGC 4281',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92255,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92255,37.59,0.23,329,38870,70,NULL,NULL,'I Zw 034 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00021,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,185.090375,33.30714,0,NULL,58767996408,918249943,14347655,17.3),(92256,'Tully est','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92256,31.13,0.8,16.8,38871,75,NULL,NULL,'VCC 0410',NULL,'1988NBGC.C....0000T',1988,1,0.2,'Haynes et al. (2011AJ....142..170H) give v = 236 km/s.','G',0.00003,NULL,'17.1',0.1,'BCD','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,185.09075,12.18783,0.021,NULL,58167200780,908862512,14200976,17.1),(92257,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92257,31.15,NULL,17,38871,NULL,NULL,NULL,'VCC 0410',NULL,'2014A&A...562A..49M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92258,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92258,37.68,0.21,343,38872,70,NULL,NULL,'2MASX J12202188+0420431',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.38',0.13,NULL,NULL,NULL,NULL,NULL,1,185.091333,4.34539,0.063,NULL,58035992198,906812378,14168943,17.38),(92259,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92259,37.66,0.46,341,38873,70,NULL,NULL,'2MASX J12202197+0554561',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,185.0915,5.91569,0,NULL,58024204902,906628201,14166065,17.3),(92260,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92260,36.46,0.27,196,38874,70,NULL,NULL,'2MASX J12202234+4155065',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000189,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,185.0929583,41.91853,0,NULL,58529266461,914519788,14289371,16.6),(92261,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92261,37.04,0.46,255,38875,70,NULL,NULL,'2MASX J12202280+5633166',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,185.095375,56.5545,0,NULL,57396426393,896819162,14012799,17),(92262,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92262,35.83,0.46,147,38876,70,NULL,NULL,'2MASX J12202312+0851371',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000214,NULL,'16.6g',0.29,'SF',NULL,NULL,NULL,NULL,1,185.09625,8.86031,0,NULL,58212945279,909577269,14212144,16.6),(92263,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92263,37.59,0.46,330,38877,70,NULL,NULL,'2MASX J12202337+4044215',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000166,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,185.0974583,40.73922,0,NULL,58529743584,914527243,14289488,17),(92264,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92264,35.21,0.23,110,38878,70,NULL,NULL,'IC 3171',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00013,NULL,'14.7',0.25,'E?',NULL,NULL,NULL,NULL,1,185.10025,25.56058,0.069,NULL,58648135250,916377113,14318392,14.7),(92265,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92265,36.24,0.33,177,38879,70,NULL,NULL,'2MASX J12202429+1906081',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'16.94',0.14,NULL,NULL,NULL,NULL,NULL,1,185.10125,19.10228,0.095,NULL,58862809312,919731395,14370803,16.94),(92266,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92266,37.89,0.46,378,38880,70,NULL,NULL,'2MASX J12202450+0708271',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,185.101958333,7.14081,0,NULL,58208163780,909502559,14210977,17.4),(92267,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92267,37.15,0.46,269,38881,70,NULL,NULL,'UGC 07406 NOTES03',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00018,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,185.102041667,61.09994,0,NULL,57338490904,895913920,13998655,16.3),(92268,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92268,33.93,0.61,61.2,38882,70,NULL,NULL,'NGC 4279',NULL,'2014MNRAS.445.2677S',2014,1,1.1,'Da Costa, et al. (1998,AJ,116,1) give v = 7627 +/- 44 km/sec.','G',0.000123,NULL,'14.5',0.7,'(R)SB(r)0+:',NULL,NULL,NULL,NULL,1,185.104167,-11.66661,0.061,NULL,43059689591,672807649,10512619,14.5),(92269,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92269,35.97,0.27,156,38883,70,NULL,NULL,'2MASX J12202511+3031161',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000133,NULL,'15.6g',0.38,NULL,NULL,NULL,NULL,NULL,1,185.10475,30.52128,0.048,NULL,58760385210,918131018,14345797,15.6),(92270,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92270,38.22,0.46,440,38884,70,NULL,NULL,'SDSS J122025.50+305940.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.4g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,185.10625,30.99456,0.038,NULL,58760894387,918138974,14345921,18.4),(92271,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92271,37.03,0.33,255,38885,70,NULL,NULL,'2MASX J12202572+1925451',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'16.51',0.17,NULL,NULL,NULL,NULL,NULL,1,185.1072917,19.42914,0.104,NULL,58861995337,919718677,14370604,16.51),(92272,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92272,38.6,0.46,524,38886,70,NULL,NULL,'SDSS J122026.48+160919.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000186,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,185.110375,16.15542,0.036,NULL,58174778664,908980916,14202826,18.1),(92273,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92273,37.59,0.23,329,38887,70,NULL,NULL,'I Zw 034 NOTES02',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000182,NULL,'17.8',0.16,NULL,NULL,NULL,NULL,NULL,1,185.111917,33.30364,0,NULL,58767996864,918249951,14347655,17.8),(92274,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92274,31.98,0.4,24.9,38888,75,NULL,NULL,'UGC 07394',NULL,'2008Ap.....51..336K',2008,1,2.05,NULL,'G',0.000011,NULL,'15.2g',0.3,'Sd(f)',NULL,NULL,NULL,NULL,1,185.11525,1.46975,0,NULL,58044606886,906946982,14171046,15.2),(92275,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92275,32.22,0.49,27.8,38888,75,NULL,'IR','UGC 07394',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92276,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92276,32.34,0.2,29.4,38888,74.4,NULL,NULL,'UGC 07394',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92277,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92277,32.42,0.54,30.5,38888,NULL,NULL,'Malmquist cor.','UGC 07394',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92278,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92278,32.43,NULL,30.6,38888,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07394',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92279,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92279,32.44,NULL,30.8,38888,NULL,NULL,'Dipole + Quadrupole','UGC 07394',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92280,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92280,32.44,0.43,30.8,38888,75,NULL,'3.6 micron, color corrected','UGC 07394',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92281,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92281,32.46,NULL,31,38888,NULL,NULL,'Dipole','UGC 07394',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92282,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92282,32.47,0.43,31.2,38888,75,NULL,'3.6 micron, color + selection bias corrected','UGC 07394',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92283,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92283,32.51,0.52,31.7,38888,NULL,NULL,NULL,'UGC 07394',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92284,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92284,32.92,NULL,38.3,38888,NULL,NULL,NULL,'UGC 07394',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92285,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92285,37.32,0.27,290,38889,70,NULL,NULL,'2MASX J12202883+1007451',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,185.120375,10.12925,0,NULL,58212143785,909564746,14211949,16.9),(92286,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92286,37.25,0.46,282,38890,70,NULL,NULL,'2MASX J12202893+4850294',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000141,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,185.120666667,48.84144,0,NULL,57182491723,893476433,13960569,16.8),(92287,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92287,37.78,0.46,360,38891,70,NULL,NULL,'SDSS J122029.09+112743.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,185.12125,11.46219,0.025,NULL,58137381258,908396582,14193696,18.4),(92288,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92288,37.32,0.27,290,38892,70,NULL,NULL,'2MASX J12202943+1012359',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,185.122833,10.20997,0,NULL,58212137783,909564652,14211947,17.4),(92289,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92289,36.63,0.2,212,38893,74.4,NULL,NULL,'IC 3174',NULL,'2013AJ....146...86T',2013,1,0.73,NULL,'G',0.000005,NULL,'15.6g',0.42,'Sb(r)I','Group member',NULL,NULL,NULL,1,185.123041667,10.24517,0,NULL,58212125949,909564467,14211944,15.6),(92290,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92290,36.22,0.46,176,38894,70,NULL,NULL,'IC 3173',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000182,NULL,'15.4g',0.44,'Sa','Group member',NULL,NULL,NULL,1,185.12575,11.34094,0.054,NULL,58209470171,909522971,14211296,15.4),(92291,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92291,37.68,0.21,343,38895,70,NULL,NULL,'SDSS J122031.37+042513.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000148,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,185.13075,4.42044,0.007,NULL,58035970052,906812032,14168938,18.2),(92292,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92292,35.25,0.46,112,38896,70,NULL,NULL,'CGCG 215-062',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000174,NULL,'15.2g',0.56,NULL,NULL,NULL,NULL,NULL,1,185.1317917,39.63308,0,NULL,58575493994,915242093,14300657,15.2),(92293,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92293,37.32,0.27,290,38897,70,NULL,NULL,'2MASX J12203160+1007359',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000267,NULL,'15.9g',0.46,NULL,NULL,NULL,NULL,NULL,1,185.131833,10.12653,0,NULL,58212146663,909564791,14211949,15.9),(92294,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92294,36.4,0.46,191,38898,70,NULL,NULL,'2MASX J12203212+2103023',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.22',0.26,NULL,NULL,NULL,NULL,NULL,1,185.1337917,21.05067,0.089,NULL,58867572856,919805825,14371966,17.22),(92295,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92295,36.28,0.46,180,38899,70,NULL,NULL,'2MASX J12203217+2938184',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'16.6g',0.31,'E',NULL,NULL,NULL,NULL,1,185.134166667,29.63858,0.09,NULL,58631795576,916121805,14314403,16.6),(92296,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92296,36.56,0.33,205,38900,70,NULL,NULL,'2MASX J12203286+1847343',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'16.85',0.14,NULL,NULL,NULL,NULL,NULL,1,185.136875,18.79275,0.08,NULL,58862640161,919728752,14370761,16.85),(92297,'SNIa','2016-12-15 15:14:58','2016-12-16 11:20:07','1','PS1 SN PS11wv','N',92297,38.9,0.1,532,38901,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11wv HOST',0.1326,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92298,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92298,35.91,0.33,152,38902,70,NULL,NULL,'2MASX J12203313+5535443',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000176,NULL,'15.8g',0.41,'S0',NULL,NULL,NULL,NULL,1,185.137917,55.59567,0.009,NULL,57395913467,896811147,14012674,15.8),(92299,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92299,37.91,0.46,382,38903,70,NULL,NULL,'2MASX J12203361+6511220',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,185.140125,65.1895,0.025,NULL,57327508450,895742319,13995973,17.2),(92300,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92300,37.03,0.33,255,38904,70,NULL,NULL,'2MASX J12203388+1921013',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,185.141125,19.35039,0.104,NULL,58861983722,919718495,14370601,17.6),(92301,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92301,37.97,0.46,393,38905,70,NULL,NULL,'2MASX J12203470+1938003',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,185.144583,19.6335,0.104,NULL,58860090632,919688916,14370139,17.7),(92302,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92302,38.68,0.46,544,38906,70,NULL,NULL,'2MASX J12203574+2917594',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00017,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,185.1489583,29.29981,0.102,NULL,58631493266,916117082,14314329,17.6),(92303,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92303,35.95,0.49,155,38907,70,NULL,NULL,'2MASX J12203613-2117213',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.85',NULL,NULL,NULL,NULL,NULL,NULL,1,185.1505417,-21.28942,0.129,NULL,43894738720,685855292,10716488,15.85),(92304,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92304,34.19,0.59,69,38908,70,NULL,NULL,'ESO 573- G 012',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.00002,NULL,'14.45',0.6,'(R\'_2)SAB(rs)bc',NULL,NULL,NULL,NULL,1,185.155333,-18.66706,0.109,NULL,43901443627,685960056,10718125,14.45),(92305,'IRAS','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92305,35.27,0.8,113,38908,75,NULL,'MAT, I','ESO 573- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92306,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92306,34.67,0.43,85.9,38908,75,NULL,'MAT, I, raw','ESO 573- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92307,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92307,34.79,0.32,90.8,38908,85,NULL,'I, raw','ESO 573- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92308,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92308,34.87,0.32,94.1,38908,85,NULL,'I, inv','ESO 573- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92309,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92309,34.93,0.43,96.7,38908,75,NULL,'MAT, I, cor','ESO 573- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92310,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92310,34.98,0.43,99.1,38908,75,NULL,'MAT, I, inv','ESO 573- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92311,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92311,35.24,0.5,111,38908,NULL,NULL,'Malmquist cor.','ESO 573- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92312,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92312,35.42,0.46,121,38908,NULL,NULL,NULL,'ESO 573- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92313,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92313,35.46,0.2,124,38908,74.4,NULL,NULL,'ESO 573- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92314,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92314,37.1,0.46,263,38909,70,NULL,NULL,'2MASX J12203758+4738596',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000184,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,185.15675,47.64975,0,NULL,57183128911,893486389,13960724,16.4),(92315,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92315,37.52,0.46,319,38910,70,NULL,NULL,'2MASX J12203780+0350551',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000166,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,185.157667,3.84881,0.016,NULL,58035520199,906805003,14168828,17.5),(92316,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92316,37.95,0.46,390,38911,70,NULL,NULL,'CGPG 1218.1+6407',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,185.1577917,63.85378,0.021,NULL,57316377007,895568390,13993256,17.7),(92317,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92317,29.52,0.4,8,38912,75,NULL,'B','NGC 4288',NULL,'1988NBGC.C....0000T',1988,1,1.64,NULL,'G',0.000011,NULL,'13.6g',1.16,'SB(s)dm        HII','Possible group member',NULL,NULL,NULL,1,185.1587917,46.29167,0,NULL,59070313606,922973650,14421463,13.6),(92318,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92318,30.09,0.09,10.4,38912,NULL,NULL,NULL,'NGC 4288',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92319,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92319,32.08,0.4,26.1,38912,NULL,NULL,NULL,'NGC 4288',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92320,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92320,38.47,0.46,495,38913,70,NULL,NULL,'SDSS J122038.74+515858.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,185.1614583,51.98294,0.024,NULL,57242688436,894417006,13975265,18.3),(92321,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92321,37.86,0.71,373,38914,70,NULL,NULL,'2MASX J12203888-4629000',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.2I',0.4,NULL,NULL,NULL,NULL,NULL,1,185.1620417,-46.48339,0.473,NULL,46722577825,730040278,11406879,14.2),(92322,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92322,37.17,0.33,272,38915,70,NULL,NULL,'2MASX J12203962+3752448',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000178,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,185.165125,37.87925,0,NULL,58585185695,915393526,14303023,16.5),(92323,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92323,34.81,0.57,91.8,38916,70,NULL,NULL,'NGC 4285',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00003,NULL,'15.12',0.4,'Sa             HII',NULL,NULL,NULL,NULL,1,185.165833,-11.64192,0.073,NULL,43058820751,672794074,10512407,15.12),(92324,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92324,31.15,NULL,17,38917,NULL,NULL,NULL,'VCC 0428',NULL,'2014A&A...562A..49M',2014,1,0.44,NULL,'G',0.000023,NULL,'17.0g',0.21,'Blue Compact Dwarf','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,185.167833,13.88956,0.28,NULL,58168082602,908876290,14201192,17),(92325,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92325,36.24,0.33,177,38918,70,NULL,NULL,'CGCG 099-019',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000107,NULL,'15.7',0.4,'E?',NULL,NULL,NULL,NULL,1,185.170041667,19.10678,0.095,NULL,58862805861,919731341,14370802,15.7),(92326,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92326,37.87,0.46,375,38919,70,NULL,NULL,'VPC 0107',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000176,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,185.173917,12.25647,0.021,NULL,58167513545,908867399,14201053,17),(92327,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92327,37.11,0.46,264,38920,70,NULL,NULL,'2MASX J12204289-0017243',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000071,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,185.178625,-0.29003,0.049,NULL,42958285695,671223213,10487862,17.7),(92328,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92328,36.77,0.33,226,38921,70,NULL,NULL,'MCG +09-20-152',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000103,NULL,'15.3g',0.62,'E0',NULL,NULL,NULL,NULL,1,185.185666667,52.60492,0.005,NULL,57241776143,894402752,13975043,15.3),(92329,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92329,37.91,0.46,383,38922,70,NULL,NULL,'2MASX J12204471+2741264',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,185.186541667,27.69069,0.089,NULL,58639730238,916245784,14316340,17.4),(92330,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92330,37.17,0.33,272,38923,70,NULL,NULL,'2MASX J12204486+3752528',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,185.186791667,37.88133,0,NULL,58585185267,915393519,14303023,17.3),(92331,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92331,38.15,0.46,427,38924,70,NULL,NULL,'2MASX J12204503+4358087',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,185.187583333,43.96919,0,NULL,59071310662,922989229,14421706,17.2),(92332,'IRAS','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92332,34.76,0.8,89.6,38925,75,NULL,'HMCL, I','IC 3184',NULL,'1997ApJS..109..333W',1997,1,0.8,NULL,'G',0.00035,NULL,'15.6',0.5,'S',NULL,NULL,NULL,NULL,1,185.195,24.91558,0.051,NULL,58648387803,916381059,14318454,15.6),(92333,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92333,34.43,0.4,77.1,38925,75,NULL,'HMCL, I, raw','IC 3184',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92334,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92334,34.52,0.4,80.1,38925,75,NULL,'HMCL, I, inv','IC 3184',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92335,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92335,34.77,0.4,90.1,38925,75,NULL,'HMCL, I, cor','IC 3184',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92336,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92336,38.21,0.33,438,38926,70,NULL,NULL,'2MASX J12204684+3912029',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000133,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,185.195333,39.20089,0,NULL,58582470697,915351104,14302361,17.6),(92337,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92337,37.69,0.46,345,38927,70,NULL,NULL,'SDSS J122046.99+103530.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000139,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,185.195833,10.59183,0.016,NULL,58209212449,909518944,14211233,18.4),(92338,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92338,36.78,0.46,227,38928,70,NULL,NULL,'VPC 0110',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00017,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,185.196083333,10.51175,0.016,NULL,58212034643,909563041,14211922,16.4),(92339,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92339,37.88,0.33,377,38929,70,NULL,NULL,'2MASX J12204744+3140024',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000142,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,185.197583333,31.66728,NULL,NULL,58768766499,918261976,14347843,17.6),(92340,'IRAS','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92340,34.38,0.8,75.3,38930,75,NULL,'MAT, I','MCG -01-32-004',NULL,'1997ApJS..109..333W',1997,1,1.99,NULL,'G',0.000017,NULL,'15.31',0.24,'SAc: sp',NULL,NULL,NULL,NULL,1,185.197917,-6.97167,0.069,NULL,43193659533,674900930,10545327,15.31),(92341,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92341,34.01,0.43,63.5,38930,75,NULL,'MAT, I, raw','MCG -01-32-004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92342,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92342,34.06,0.32,64.8,38930,85,NULL,'I, raw','MCG -01-32-004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92343,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92343,34.09,0.32,65.9,38930,85,NULL,'I, inv','MCG -01-32-004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92344,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92344,34.19,0.43,68.9,38930,75,NULL,'MAT, I, inv','MCG -01-32-004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92345,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92345,34.25,0.49,70.9,38930,75,NULL,'IR','MCG -01-32-004',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92346,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92346,34.29,0.43,72.2,38930,75,NULL,'MAT, I, cor','MCG -01-32-004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92347,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92347,34.42,NULL,76.6,38930,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -01-32-004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92348,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92348,34.43,NULL,76.9,38930,NULL,NULL,'Dipole + Quadrupole','MCG -01-32-004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92349,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92349,34.43,NULL,77,38930,NULL,NULL,'Dipole','MCG -01-32-004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92350,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92350,34.55,0.43,81.2,38930,NULL,NULL,'Malmquist cor.','MCG -01-32-004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92351,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92351,34.69,0.2,86.7,38930,74.4,NULL,NULL,'MCG -01-32-004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92352,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92352,34.82,0.37,92,38930,NULL,NULL,NULL,'MCG -01-32-004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92353,'Tully est','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92353,33.12,0.8,42.1,38931,75,NULL,'B','NGC 4290',NULL,'1988NBGC.C....0000T',1988,1,2.02,NULL,'G',0.00003,NULL,'12.9g',1.26,'SB(rs)ab:      HII','Pair member (points to parent)',NULL,NULL,NULL,1,185.1980417,58.0925,0,NULL,57397191947,896831124,14012986,12.9),(92354,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92354,33.34,0.45,46.5,38931,NULL,NULL,'K','NGC 4290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92355,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92355,33.34,0.4,46.6,38931,NULL,NULL,'mean','NGC 4290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92356,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92356,33.38,0.47,47.5,38931,NULL,NULL,'H','NGC 4290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92357,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92357,33.39,0.46,47.6,38931,NULL,NULL,'J','NGC 4290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92358,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92358,32.28,0.43,28.5,38932,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4287',NULL,'2014MNRAS.444..527S',2014,1,1.82,NULL,'G',0.00001,NULL,'14.65',0.36,'Sc(f)          HII','X-ray-bright group member',NULL,NULL,NULL,1,185.202083,5.63989,0,NULL,58032496083,906757751,14168089,14.65),(92359,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92359,36.56,0.46,205,38933,70,NULL,NULL,'2MASX J12204871+4125089',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000157,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,185.203083,41.41908,0,NULL,58531055434,914547741,14289808,16.7),(92360,'GCLF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92360,31.13,0.16,16.8,38934,NULL,NULL,'TOM(g) = -7.2 mag','UGC 07399A',NULL,'2010ApJ...717..603V',2010,1,1.51,NULL,'G',0.000153,NULL,'14.54',0.76,'dE5,N','Group member',NULL,NULL,NULL,1,185.203417,17.48706,0.038,NULL,58125617373,908212771,14190824,14.54),(92361,'GCLF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92361,31.14,0.2,16.9,38934,NULL,NULL,'TOM(g) = -7.2 mag','UGC 07399A',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92362,'GCLF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92362,31.46,0.18,19.6,38934,NULL,NULL,'TOM(u) = -8.4 mag','UGC 07399A',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92363,'GCLF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92363,31.59,0.17,20.8,38934,NULL,NULL,'TOM(z) = -8.53 mag','UGC 07399A',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92364,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92364,31.16,0.14,17.1,38934,74.4,NULL,NULL,'UGC 07399A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92365,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92365,31.17,0.07,17.1,38934,NULL,NULL,NULL,'UGC 07399A',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92366,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92366,31.18,0.08,17.2,38934,NULL,NULL,'HST ACS VCS','UGC 07399A',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92367,'GC radius','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,NULL,92367,29.94,0.22,9.7,38934,NULL,NULL,NULL,'UGC 07399A',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92368,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92368,37.51,0.27,318,38935,70,NULL,NULL,'2MASX J12204886+0820470',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00018,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,185.2035417,8.34644,0,NULL,58206330928,909473920,14210530,16.9),(92369,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92369,38.29,0.21,454,38936,70,NULL,NULL,'CGPG 1218.3+6351 NED01',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000158,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,185.204583,63.56761,0.021,NULL,57316345407,895567896,13993248,18.3),(92370,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92370,38.21,0.33,438,38937,70,NULL,NULL,'SDSS J122049.41+391112.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,185.205916667,39.18686,0,NULL,58582471508,915351117,14302361,18.5),(92371,'FP','2016-12-15 15:14:58','2016-12-16 11:20:07','1',NULL,'R',92371,38.25,0.46,446,38938,70,NULL,NULL,'2MASX J12205049+1936323',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,185.2105417,19.60911,0.104,NULL,58860090266,919688910,14370139,18.1),(92372,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92372,37.51,0.27,318,38939,70,NULL,NULL,'2MASX J12205169+0818370',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000196,NULL,'16.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,185.2155,8.31028,0,NULL,58206359964,909474374,14210537,16.4),(92373,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92373,36.71,0.46,220,38940,70,NULL,NULL,'2MASX J12205206-0209229',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000184,NULL,'16.6g',0.29,'AGN',NULL,NULL,NULL,NULL,1,185.217,-2.15625,0.069,NULL,43007118577,671986227,10499784,16.6),(92374,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92374,36.52,0.46,202,38941,70,NULL,NULL,'2MASX J12205341+4245477',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000029,NULL,'17.3g',0.2,'Sy2',NULL,NULL,NULL,'Sy 2',1,185.222666667,42.76339,0,NULL,59062960879,922858763,14419668,17.3),(92375,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92375,36.25,0.33,178,38942,70,NULL,NULL,'MCG +08-23-009',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000201,NULL,'16.1g',0.4,'E3;cand. dwarf','Dwarf, within FOV of cluster',NULL,NULL,NULL,1,185.225667,46.16169,0,NULL,59070308005,922973562,14421461,16.1),(92376,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92376,37.51,0.27,318,38943,70,NULL,NULL,'2MASX J12205418+0816369',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000185,NULL,'16.5g',0.38,NULL,NULL,NULL,NULL,NULL,1,185.22575,8.27697,0,NULL,58206361260,909474394,14210537,16.5),(92377,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92377,36.56,0.33,205,38944,70,NULL,NULL,'2MASX J12205490+1853153',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.69',0.19,NULL,NULL,NULL,NULL,NULL,1,185.2287083,18.88744,0.08,NULL,58862621451,919728460,14370757,17.69),(92378,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92378,36.25,0.33,178,38945,70,NULL,NULL,'MCG +08-23-010',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000182,NULL,'16.1g',0.39,'E3;cand. dwarf','Dwarf, within FOV of cluster',NULL,NULL,NULL,1,185.2289583,46.15328,0,NULL,59070304587,922973509,14421461,16.1),(92379,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92379,35.41,0.2,121,38946,74.4,NULL,NULL,'IC 3188',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000013,NULL,'15.26',0.4,'Sbc(s)II','Group member',NULL,NULL,NULL,1,185.229583,11.00889,0.038,NULL,58209564385,909524443,14211319,15.26),(92380,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92380,37.88,0.33,377,38947,70,NULL,NULL,'SDSS J122055.30+313518.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,185.230458333,31.58844,NULL,NULL,58760632885,918134888,14345857,18.3),(92381,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92381,38.46,0.46,492,38948,70,NULL,NULL,'SDSS J122055.66+050456.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,185.231958333,5.08222,0,NULL,58033418504,906772164,14168315,18.4),(92382,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92382,37.62,0.46,334,38949,70,NULL,NULL,'2MASX J12205608+0410239',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,185.233833,4.17336,0.063,NULL,58034860704,906794698,14168667,17.3),(92383,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92383,37.37,0.46,298,38950,70,NULL,NULL,'2MASX J12205809+2122590',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,185.242167,21.38311,0.086,NULL,58865731127,919777048,14371516,17.1),(92384,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92384,36.01,0.46,160,38951,70,NULL,NULL,'MCG +10-18-030',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.00017,NULL,'15.4g',0.5,'E0',NULL,NULL,NULL,NULL,1,185.253083,60.91889,0,NULL,57338393716,895912401,13998631,15.4),(92385,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92385,38.03,0.46,405,38952,70,NULL,NULL,'2MASX J12210136+5447265',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,185.2559583,54.79069,0.009,NULL,57224528199,894133253,13970832,17.3),(92386,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92386,32.73,NULL,35.2,38953,NULL,NULL,'Dipole','NGC 4289',NULL,'2010Ap&SS.325..163P',2010,1,4.93,NULL,'G',0.000003,NULL,'14.55',0.47,'SA(s)cd: sp    HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,185.259375,3.72214,0.016,NULL,58035531246,906805175,14168830,14.55),(92387,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92387,32.75,NULL,35.4,38953,NULL,NULL,'Dipole + Quadrupole','NGC 4289',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92388,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92388,32.75,0.4,35.4,38953,75,NULL,NULL,'NGC 4289',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92389,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92389,32.75,NULL,35.5,38953,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 4289',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92390,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92390,32.9,0.52,37.9,38953,NULL,NULL,'Malmquist cor.','NGC 4289',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92391,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92391,32.91,NULL,38.2,38953,NULL,NULL,NULL,'NGC 4289',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92392,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92392,33.01,0.4,40,38953,NULL,NULL,'mean','NGC 4289',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92393,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92393,33.1,0.47,41.8,38953,NULL,NULL,'H','NGC 4289',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92394,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92394,33.14,0.43,42.4,38953,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4289',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92395,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92395,33.14,0.46,42.5,38953,NULL,NULL,'J','NGC 4289',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92396,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92396,33.21,0.45,43.8,38953,NULL,NULL,'K','NGC 4289',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92397,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92397,33.24,0.44,44.5,38953,NULL,NULL,NULL,'NGC 4289',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92398,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92398,33.28,0.43,45.3,38953,75,NULL,'3.6 micron, color corrected','NGC 4289',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92399,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92399,33.33,0.36,46.3,38953,NULL,NULL,NULL,'NGC 4289',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92400,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92400,33.34,0.2,46.6,38953,74.4,NULL,NULL,'NGC 4289',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92401,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92401,33.53,0.49,50.9,38953,75,NULL,'IR','NGC 4289',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92402,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92402,33.75,0.3,56.3,38953,55,NULL,'B','NGC 4289',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92403,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92403,38.15,0.46,427,38954,70,NULL,NULL,'SDSS J122103.64+124250.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000178,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,185.2652083,12.71394,0.104,NULL,58166942656,908858479,14200913,18.6),(92404,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92404,37.47,0.46,312,38955,70,NULL,NULL,'2MASX J12210386+3051476',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,185.2662083,30.86336,0.038,NULL,58760432301,918131754,14345808,17.6),(92405,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92405,36.9,0.46,240,38956,70,NULL,NULL,'2MASX J12210445+4209326',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000143,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,185.2685417,42.15911,0,NULL,59062488249,922851378,14419552,16.9),(92406,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92406,36.18,0.87,172,38957,70,NULL,NULL,'2MASX J12210487-5207129',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,185.27025,-52.12025,0.245,NULL,44625105064,697267266,10894801,17.1),(92407,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92407,37.39,0.46,300,38958,70,NULL,NULL,'2MASX J12210572+3204076',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000174,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,185.273916667,32.06883,NULL,NULL,58770031849,918281747,14348152,17.2),(92408,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92408,36.63,0.46,212,38959,70,NULL,NULL,'2MASX J12210606+3228506',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,185.275375,32.48086,NULL,NULL,58770203973,918284437,14348194,17.2),(92409,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92409,36.77,0.46,226,38960,70,NULL,NULL,'CGPG 1218.8+6334',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00015,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,185.280833,63.28422,0.009,NULL,57372728545,896448883,14007013,17),(92410,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92410,37.47,0.46,312,38961,70,NULL,NULL,'2MASX J12210742+2901578',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,185.281125,29.03278,0.116,NULL,58628554338,916071161,14313611,17.7),(92411,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92411,37.97,0.33,392,38962,70,NULL,NULL,'2MASX J12210812+4146579',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00019,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,185.283833333,41.78281,0,NULL,58529102957,914517233,14289331,16.9),(92412,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92412,35.14,0.55,107,38963,70,NULL,NULL,'CGCG 014-013',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.000127,NULL,'15.2g',0.46,'E',NULL,NULL,NULL,NULL,1,185.284083333,-3.04464,0.073,NULL,43014902459,672107850,10501685,15.2),(92413,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92413,35.41,0.46,121,38963,70,NULL,NULL,'CGCG 014-013',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92414,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92414,37.46,0.46,311,38964,70,NULL,NULL,'VPC 0127',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000173,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,185.2860417,14.38914,0.074,NULL,58181474489,909085538,14204461,17.9),(92415,'D-Sigma','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92415,33.93,0.4,61.1,38965,75,NULL,'Edat, raw','ESO 218- G 002',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00015,NULL,'13.83',1.1,'E2:;l.env',NULL,NULL,NULL,NULL,1,185.286083,-52.58608,0.389,NULL,44624307488,697254804,10894606,13.83),(92416,'D-Sigma','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92416,34.27,0.4,71.3,38965,75,NULL,'Edat, cor','ESO 218- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92417,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92417,33.44,0.47,48.8,38965,70,NULL,NULL,'ESO 218- G 002',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92418,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92418,34.2,0.45,69.2,38965,NULL,NULL,'K','ESO 218- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92419,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92419,34.24,0.4,70.5,38965,NULL,NULL,'mean','ESO 218- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92420,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92420,36.39,0.46,190,38966,70,NULL,NULL,'IC 3194',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.43',0.23,NULL,NULL,NULL,NULL,NULL,1,185.2875,25.1335,0.035,NULL,58648881027,916388766,14318574,17.43),(92421,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92421,37.88,0.23,377,38967,70,NULL,NULL,'SDSS J122109.12+080554.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,185.288041667,8.0985,0,NULL,58206394284,909474910,14210545,18),(92422,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92422,35.63,0.15,134,38968,70,NULL,NULL,'NGC 4295',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.000077,NULL,'14.6g',0.59,'S?',NULL,NULL,NULL,NULL,1,185.29075,28.16511,0.059,NULL,58640165292,916252582,14316446,14.6),(92423,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92423,31.15,NULL,17,38969,NULL,NULL,NULL,'KUG 1218+179',NULL,'2014A&A...562A..49M',2014,1,0.4,NULL,'G',0.00003,NULL,'15.5',0.2,'BCD            HII','Group member',NULL,NULL,NULL,1,185.297083,17.63864,0.039,NULL,58124737433,908199022,14190609,15.5),(92424,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92424,37.65,0.46,339,38970,70,NULL,NULL,'SDSS J122112.20+570611.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000107,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,185.300875,57.10308,0,NULL,57397533301,896836457,14013069,18.1),(92425,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92425,36.02,0.46,160,38971,70,NULL,NULL,'2MASX J12211284+5509124',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000192,NULL,'15.4g',0.46,'E0',NULL,NULL,NULL,NULL,1,185.303417,55.15339,0.013,NULL,57224085924,894126342,13970724,15.4),(92426,'Tully est','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92426,31.15,0.8,17,38972,75,NULL,'B','NGC 4293',NULL,'1988NBGC.C....0000T',1988,1,5.6,NULL,'G',0.000027,NULL,'11.26',2.6,'(R)SB(s)0/a    LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,185.303708333,18.38239,0.075,NULL,58859332138,919677064,14369954,11.26),(92427,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92427,29.57,0.92,8.2,38972,NULL,NULL,'CO','NGC 4293',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92428,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92428,30.53,NULL,12.8,38972,NULL,NULL,NULL,'NGC 4293',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92429,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92429,30.8,0.2,14.5,38972,NULL,NULL,'stellar kinematics','NGC 4293',NULL,'2008ApJ...683...78C',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92430,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92430,31.01,0.7,15.9,38972,NULL,NULL,'HI','NGC 4293',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92431,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92431,31.03,0.3,16,38972,55,NULL,'B','NGC 4293',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92432,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92432,36.53,0.68,202,38973,70,NULL,NULL,'CGCG 014-015',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000077,NULL,'15.6g',0.38,'(R)SB(s)ab:    NLAGN',NULL,NULL,NULL,'Sy 2',1,185.303917,-0.86425,0.049,NULL,43005100923,671954701,10499292,15.6),(92433,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92433,38.06,0.46,410,38974,70,NULL,NULL,'2MASX J12211294+0843259',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000141,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,185.304125,8.72394,0,NULL,58213004450,909578194,14212159,17.5),(92434,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92434,37.81,0.46,365,38975,70,NULL,NULL,'2MASX J12211304+5757204',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,185.304333,57.95578,0,NULL,57397210439,896831413,14012990,17.8),(92435,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92435,37.97,0.33,392,38976,70,NULL,NULL,'B3 1218+421',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000186,NULL,'16.3g',0.4,'BrClG',NULL,NULL,NULL,NULL,1,185.304708333,41.87064,0,NULL,58528980898,914515326,14289301,16.3),(92436,'TRGB','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92436,29.31,0.1,7.28,38977,74.4,NULL,NULL,'UGC 07408',NULL,'2013AJ....146...86T',2013,1,2.6,'There may be a superposed white dwarf star near the nucleus.','G',0.000017,NULL,'13.35',1.2,'IAm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,185.3125417,45.81133,0,NULL,59070242391,922972537,14421445,13.35),(92437,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92437,29.13,0.4,6.7,38977,75,NULL,'B','UGC 07408',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92438,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92438,33.88,0.5,59.7,38978,70,NULL,NULL,'2MASX J12211507-1300475',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000103,NULL,'15.26',0.5,NULL,NULL,NULL,NULL,NULL,1,185.3127917,-13.01314,0.069,NULL,43070608228,672978253,10515285,15.26),(92439,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92439,37.88,0.23,377,38979,70,NULL,NULL,'2MASX J12211509+0805229',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.87',0.14,NULL,NULL,NULL,NULL,NULL,1,185.313041667,8.08969,0,NULL,58206401521,909475023,14210547,17.87),(92440,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92440,38.07,0.46,411,38980,70,NULL,NULL,'2MASX J12211520+0531014',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,185.31325,5.51708,0,NULL,58032497121,906757767,14168090,17.2),(92441,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92441,35.83,0.64,146,38981,70,NULL,NULL,'2MASX J12211553-5155230',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,185.314833,-51.92303,0.245,NULL,44624867121,697263548,10894742,16.3),(92442,'SNIa','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 2000bh',NULL,92442,34.24,0.11,68.9,38982,74.2,NULL,'SALT 2','ESO 573- G 014',0.02281,'2010ApJ...716..712A',2010,1,1.4,NULL,'G',0.000033,NULL,'14.08',0.9,'S?',NULL,NULL,NULL,NULL,1,185.315875,-21.99575,0.197,NULL,43897406837,685896981,10717140,14.08),(92443,'SNIa','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 2000bh',NULL,92443,34.86,0.06,91.7,38982,72,NULL,NULL,'ESO 573- G 014',0.02281,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92444,'SNIa','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 2000bh',NULL,92444,34.88,0.22,92.5,38982,72,NULL,NULL,'ESO 573- G 014',0.02281,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92445,'SNIa','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 2000bh',NULL,92445,34.9,0.04,93.4,38982,72,NULL,NULL,'ESO 573- G 014',0.02281,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92446,'SNIa','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 2000bh',NULL,92446,34.86,0.05,93.7,38982,72,NULL,'M(H) = -18.317 mag','ESO 573- G 014',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92447,'SNIa','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 2000bh',NULL,92447,34.94,0.12,95.1,38982,70,NULL,'SALT','ESO 573- G 014',0.02281,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92448,'SNIa','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 2000bh',NULL,92448,34.94,0.03,95.1,38982,72,NULL,NULL,'ESO 573- G 014',0.02281,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92449,'SNIa','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 2000bh',NULL,92449,34.9,0.08,95.5,38982,74.4,NULL,NULL,'ESO 573- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92450,'SNIa','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 2000bh',NULL,92450,34.95,0.17,95.6,38982,70,NULL,'SALT 2','ESO 573- G 014',0.02281,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92451,'SNIa','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 2000bh',NULL,92451,34.95,0.17,97.7,38982,70.8,NULL,NULL,'ESO 573- G 014',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92452,'SNIa','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 2000bh',NULL,92452,35.07,0.14,101,38982,65,NULL,'SALT','ESO 573- G 014',0.02281,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92453,'SNIa','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 2000bh',NULL,92453,35.12,0.02,103,38982,72,NULL,NULL,'ESO 573- G 014',0.02281,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92454,'SNIa','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 2000bh',NULL,92454,35.13,0.21,104,38982,65,NULL,'SALT2','ESO 573- G 014',0.02281,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92455,'SNIa','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 2000bh',NULL,92455,35.25,0.2,109,38982,65,NULL,'MLCS17','ESO 573- G 014',0.02281,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92456,'SNIa','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 2000bh',NULL,92456,35.31,0.13,110,38982,65,NULL,'MLCS2k2','ESO 573- G 014',0.02281,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92457,'SNIa','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 2000bh',NULL,92457,35.28,0.2,111,38982,65,NULL,'MLCS31','ESO 573- G 014',0.02281,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92458,'IRAS','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92458,34.9,0.8,95.4,38982,75,NULL,'MAT, I','ESO 573- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92459,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92459,34.11,0.32,66.3,38982,85,NULL,'I, raw','ESO 573- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92460,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92460,34.11,0.32,66.5,38982,85,NULL,'I, inv','ESO 573- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92461,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92461,34.35,0.43,74.2,38982,75,NULL,'MAT, I, raw','ESO 573- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92462,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92462,34.44,0.43,77.2,38982,75,NULL,'MAT, I, inv','ESO 573- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92463,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92463,34.67,0.43,85.9,38982,75,NULL,'MAT, I, cor','ESO 573- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92464,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92464,34.9,0.08,95.5,38982,74.4,NULL,NULL,'ESO 573- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92465,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92465,35.34,0.53,117,38982,NULL,NULL,'Malmquist cor.','ESO 573- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92466,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92466,35.46,0.51,124,38982,NULL,NULL,NULL,'ESO 573- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92467,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92467,29.88,NULL,9.46,38983,NULL,NULL,NULL,'NGC 4292',NULL,'1999MNRAS.304..595G',1999,1,1.7,NULL,'G',0.000083,NULL,'13.09',1.1,'(R)SB(r)0^0^','X-ray-bright group member',NULL,NULL,NULL,1,185.318583,4.59569,0.007,NULL,58033127487,906767616,14168244,13.09),(92468,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92468,31.06,0.45,16.3,38983,NULL,NULL,'K','NGC 4292',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92469,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92469,32.68,0.4,34.4,38983,NULL,NULL,'mean','NGC 4292',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92470,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92470,36.62,0.46,211,38984,70,NULL,NULL,'2MASX J12211647+1929561',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'16.69',0.17,NULL,NULL,NULL,NULL,NULL,1,185.318791667,19.49881,0.114,NULL,58860054634,919688353,14370130,16.69),(92471,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92471,37.62,0.46,335,38985,70,NULL,NULL,'2MASX J12211670+1516437',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,185.319708333,15.27892,0.047,NULL,58173928497,908967632,14202619,17.6),(92472,'IRAS','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92472,31.43,0.8,19.3,38986,75,NULL,'A82, H','NGC 4294',NULL,'1997ApJS..109..333W',1997,1,3.2,'ALFALFA source also includes UGC 07414.','G',0.000003,NULL,'12.5B',1.2,'SB(s)cd        HII','Pair member (points to parent)',NULL,NULL,NULL,1,185.3242917,11.51044,0.025,NULL,58137401096,908396892,14193701,12.5),(92473,'Tully est','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92473,31.13,0.8,16.8,38986,75,NULL,'B','NGC 4294',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92474,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92474,30.86,NULL,14.9,38986,NULL,NULL,NULL,'NGC 4294',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92475,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92475,30.91,0.4,15.2,38986,NULL,NULL,'mean','NGC 4294',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92476,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92476,31.03,0.43,16.1,38986,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4294',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92477,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92477,31.06,0.43,16.3,38986,75,NULL,'3.6 micron, color corrected','NGC 4294',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92478,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92478,31.09,0.2,16.5,38986,74.4,NULL,NULL,'NGC 4294',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92479,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92479,31.14,0.47,16.9,38986,75,NULL,'A82, H, inv','NGC 4294',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92480,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92480,31.15,0.42,17,38986,65,NULL,NULL,'NGC 4294',NULL,'1980ApJ...238..458M',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92481,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92481,31.21,0.47,17.4,38986,75,NULL,'A82, H, raw','NGC 4294',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92482,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92482,31.45,0.47,19.5,38986,75,NULL,'A82, H, cor','NGC 4294',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92483,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92483,31.69,0.46,21.8,38986,NULL,NULL,'J','NGC 4294',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92484,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92484,31.81,0.45,23,38986,NULL,NULL,'K','NGC 4294',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92485,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92485,31.83,0.47,23.2,38986,NULL,NULL,'H','NGC 4294',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92486,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92486,37.83,0.46,368,38987,70,NULL,NULL,'SDSS J122118.92+481145.3',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000154,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,185.328833,48.19592,0,NULL,57183762595,893496290,13960879,18.6),(92487,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92487,31.02,0.25,16,38988,NULL,NULL,'R','CS 1036',NULL,'2005A&A...437..823R',2005,1,0.9,NULL,'G',0.000088,NULL,'15.9g',0.48,'(dE5,N)?;cand. dwarf','Dwarf, within FOV of cluster',NULL,NULL,NULL,1,185.3337917,29.71547,0.078,NULL,58628354512,916068039,14313563,15.9),(92488,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92488,37.21,0.46,277,38989,70,NULL,NULL,'2MASX J12212090+6330488',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,185.3370417,63.51358,0.021,NULL,57371859114,896435298,14006801,17.8),(92489,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92489,37.02,0.46,254,38990,70,NULL,NULL,'2MASX J12212089+5028371',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000139,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,185.337083,50.47703,0,NULL,57239831224,894372362,13974568,16.8),(92490,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92490,37.88,0.23,377,38991,70,NULL,NULL,'SDSS J122121.40+080317.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000165,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,185.3392083,8.05486,0,NULL,58206399117,909474986,14210546,18),(92491,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92491,37.84,0.27,369,38992,70,NULL,NULL,'2MASX J12212141+5018551',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000168,NULL,'16.9g',0.3,'AGN',NULL,NULL,NULL,NULL,1,185.3392917,50.31542,0,NULL,57239916963,894373702,13974589,16.9),(92492,'BL Lac Luminosity','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92492,39.71,NULL,740,38993,NULL,NULL,NULL,'FBQS J1221+3010',0.183648,'2005ApJ...635..173S',2005,1,0.24,NULL,'G',0.000259,NULL,'16.1g',0.17,'BLLAC',NULL,NULL,NULL,'HP BL Lac',1,185.341417,30.17697,0.061,NULL,58758532203,918102065,14345344,16.1),(92493,'GeV TeV ratio','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92493,38.26,NULL,448,38993,72,NULL,NULL,'FBQS J1221+3010',NULL,'2010MNRAS.405L..76P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92494,'GeV TeV ratio','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92494,39.47,0.61,784,38993,72,NULL,NULL,'FBQS J1221+3010',NULL,'2011arXiv1111.0913P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92495,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92495,37.99,0.27,396,38994,70,NULL,NULL,'2MASX J12212254+1701287',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,'PHOT','16.7g',0.28,'BrClG',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,185.34375,17.02478,0.035,NULL,58170870908,908919857,14201872,16.7),(92496,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92496,37.43,0.46,306,38995,70,NULL,NULL,'2MASX J12212273-0209088',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000183,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,185.34475,-2.15233,0.065,NULL,43007232529,671988008,10499812,17.1),(92497,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92497,39.11,0.46,664,38996,70,NULL,NULL,'2MASS J12212299+0016207',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000091,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,185.345833,0.27236,0.028,NULL,57986271477,906035491,14156804,18.6),(92498,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92498,35.5,0.46,126,38997,70,NULL,NULL,'2MASX J12212323+0950529',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000159,NULL,'15.9g',0.28,'S0',NULL,NULL,NULL,NULL,1,185.346916667,9.84806,0,NULL,58211039816,909547497,14211679,15.9),(92499,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92499,38.85,0.46,590,38998,70,NULL,NULL,'CGPG 1219.0+6417',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,185.3475417,64.00228,0.005,NULL,57316307742,895567308,13993239,17.9),(92500,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92500,37.84,0.27,369,38999,70,NULL,NULL,'2MASXi J1221237+502015',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000172,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,185.348667,50.33744,0,NULL,57239872154,894373002,13974578,17.6),(92501,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92501,36.73,0.46,222,39000,70,NULL,NULL,'2MASX J12212401+0853149',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000139,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,185.350125,8.88758,0,NULL,58212845983,909575718,14212120,17.1),(92502,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92502,38.58,0.46,520,39001,70,NULL,NULL,'SDSS J122124.27+615550.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,185.351166667,61.93061,0,NULL,57371744726,896433511,14006773,18.3),(92503,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92503,37.88,0.23,377,39002,70,NULL,NULL,'SDSS J122124.51+080257.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000138,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,185.352208333,8.04931,0,NULL,58206400425,909475006,14210546,18.3),(92504,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92504,37.57,0.46,326,39003,70,NULL,NULL,'2MASX J12212616+3557246',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000166,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,185.358917,35.95692,0,NULL,58541529394,914711396,14292365,16.6),(92505,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92505,37.96,0.46,392,39004,70,NULL,NULL,'2MASX J12212638+6236068',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,185.360083,62.60181,0.029,NULL,57373069363,896454208,14007097,17.9),(92506,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92506,29.87,NULL,9.42,39005,NULL,NULL,NULL,'VCC 0477',NULL,'2013AJ....145..101K',2013,1,0.9,NULL,'G',0.000033,NULL,'16.7',0.5,'I?','Group member',NULL,NULL,NULL,1,185.362917,15.02,0.073,NULL,58173809962,908965780,14202590,16.7),(92507,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92507,37.73,0.21,352,39006,70,NULL,NULL,'SDSS J122127.21+012131.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,185.363416667,1.35864,0,NULL,58041058767,906891543,14170180,18.3),(92508,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92508,37.99,0.46,397,39007,70,NULL,NULL,'VPC 0142',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000194,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,185.3662083,11.56356,0.026,NULL,58137472389,908398006,14193718,16.8),(92509,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92509,37.74,0.15,353,39008,70,NULL,NULL,'SDSS J122128.49+134846.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,185.36875,13.81294,0.28,NULL,58168698495,908885913,14201342,18.4),(92510,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92510,34.87,0.54,94.4,39009,70,NULL,NULL,'2MASX J12212968-1625085',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.74',NULL,NULL,NULL,NULL,NULL,NULL,1,185.373791667,-16.41906,0.069,NULL,43076343666,673067869,10516685,15.74),(92511,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92511,38.29,0.21,454,39010,70,NULL,NULL,'SDSS J122130.37+633056.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000137,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,185.376583,63.51575,0.021,NULL,57371859740,896435308,14006801,18.7),(92512,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92512,37.26,0.46,283,39011,70,NULL,NULL,'SDSS J122131.27+024255.2',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,185.380333333,2.71536,0,NULL,58042070856,906907357,14170427,17.2),(92513,'GeV TeV ratio','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92513,38.57,NULL,517,39012,72,NULL,NULL,'W Com',NULL,'2010MNRAS.405L..76P',2010,1,NULL,NULL,'QSO',NULL,NULL,'16.5',NULL,'Opt.var.       BLLAC',NULL,NULL,'radio jet','Flat-Spectrum Radio Source',1,185.3820417,28.23292,0.08,NULL,58640129765,916252027,14316437,16.5),(92514,'GeV TeV ratio','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92514,39.73,0.35,882,39012,72,NULL,NULL,'W Com',NULL,'2011arXiv1111.0913P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92515,'Tully est','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92515,31.13,0.8,16.8,39013,75,NULL,'B','NGC 4298',NULL,'1988NBGC.C....0000T',1988,1,3.3,NULL,'G',0.000013,NULL,'12.5g',1.24,'SA(rs)c        HII','Pair member (points to parent)',NULL,NULL,NULL,1,185.3865,14.60617,0.074,NULL,58181403011,909084422,14204444,12.5),(92516,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92516,30.67,0.92,13.6,39013,NULL,NULL,'CO','NGC 4298',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92517,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92517,30.83,0.47,14.7,39013,NULL,NULL,'H','NGC 4298',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92518,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92518,30.84,0.7,14.7,39013,NULL,NULL,'HI','NGC 4298',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92519,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92519,30.91,0.45,15.2,39013,NULL,NULL,'K','NGC 4298',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92520,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92520,30.95,0.46,15.5,39013,NULL,NULL,'J','NGC 4298',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92521,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92521,31.64,0.4,21.3,39013,NULL,NULL,'mean','NGC 4298',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92522,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92522,36.99,0.46,251,39014,70,NULL,NULL,'2MASX J12213353+5904105',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000143,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,185.389666667,59.0695,0,NULL,57343409990,895990781,13999855,17.5),(92523,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92523,37.8,0.46,363,39015,70,NULL,NULL,'2MASX J12213436+4020026',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000138,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,185.393041667,40.33408,0,NULL,58529937977,914530280,14289535,18),(92524,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92524,37.74,0.15,353,39016,70,NULL,NULL,'VPC 0147',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,185.39475,13.78017,0.28,NULL,58168702822,908885981,14201343,17),(92525,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92525,38.12,0.46,420,39017,70,NULL,NULL,'2MASX J12213487+6050399',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,185.3957917,60.84458,0,NULL,57340438279,895944348,13999130,17.5),(92526,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92526,37.46,0.46,311,39018,70,NULL,NULL,'2MASX J12213511+0128334',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000142,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,185.39625,1.47589,0,NULL,58044487233,906945113,14171017,17.4),(92527,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92527,37.35,0.46,295,39019,70,NULL,NULL,'LCRS B121901.4-023805',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,185.397375,-2.91183,0.069,NULL,43014743070,672105360,10501646,17.7),(92528,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92528,36.99,0.46,250,39020,70,NULL,NULL,'2MASX J12213604+2637345',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00018,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,185.400083333,26.62636,0.087,NULL,58650833148,916419267,14319051,16.8),(92529,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92529,37.79,0.46,361,39021,70,NULL,NULL,'SDSS J122136.16+290814.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000162,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,185.400708333,29.13742,0.116,NULL,58628727546,916073867,14313654,18.2),(92530,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92530,37.7,0.23,346,39022,70,NULL,NULL,'2MASX J12213718+0630208',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000181,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,185.404917,6.50592,0,NULL,58205326968,909458233,14210284,17.4),(92531,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92531,37.63,0.46,336,39023,70,NULL,NULL,'SDSS J122137.18+133137.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,185.404958333,13.52714,0.199,NULL,58168469045,908882328,14201286,18.2),(92532,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92532,38.1,0.46,416,39024,70,NULL,NULL,'SDSS J122137.45+571456.9',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,185.406083,57.24917,0,NULL,57397500810,896835950,14013061,17.9),(92533,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92533,37.99,0.27,396,39025,70,NULL,NULL,'SDSS J122137.55+170219.9',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,185.4065,17.03889,0.035,NULL,58170877623,908919962,14201874,17.1),(92534,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92534,31.31,0.16,18.3,39026,NULL,NULL,'R','IC 0783',NULL,'2004AJ....127..771J',2004,1,1.14,NULL,'G',0.00004,NULL,'14.5g',0.87,'SAB(rs)0/a?','Group member',NULL,NULL,NULL,1,185.411625,15.74511,0.043,NULL,58174392569,908974883,14202732,14.5),(92535,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92535,38.14,0.46,425,39027,70,NULL,NULL,'2MASX J12213890+2341187',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.47',0.13,NULL,NULL,NULL,NULL,NULL,1,185.41225,23.68853,0.102,NULL,58591268556,915488571,14304508,18.47),(92536,'Ring Diameter','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92536,33.5,0.84,50,39028,NULL,NULL,'Published at H = 100 km/s/Mpc','UGC 07416',NULL,'1981ApJS...45..541P',1981,1,1.35,NULL,'G',0.000033,NULL,'13.9g',1.15,'SB(r)b','Isolated galaxy',NULL,NULL,NULL,1,185.413208333,40.84894,0,NULL,58531411279,914553301,14289895,13.9),(92537,'Tully est','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92537,31.13,0.8,16.8,39029,75,NULL,'B','NGC 4299',NULL,'1988NBGC.C....0000T',1988,1,1.7,'ALFALFA source also includes UGC 07407.','G',0.000007,NULL,'12.88',1.6,'SAB(s)dm:      HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,185.4189583,11.49992,0.025,NULL,58137474494,908398038,14193719,12.88),(92538,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92538,36.18,0.27,173,39030,70,NULL,NULL,'MCG +09-20-155',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000221,NULL,'15.1g',0.6,'E0',NULL,NULL,NULL,NULL,1,185.4230417,55.78717,0,NULL,57395930157,896811408,14012678,15.1),(92539,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92539,37.92,0.33,384,39031,70,NULL,NULL,'2MASX J12214199+1928488',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,185.42525,19.48025,0.114,NULL,58860049131,919688267,14370129,17.5),(92540,'CMD','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'N',92540,20.64,0.16,0.134,39032,NULL,NULL,NULL,'Hydra II',NULL,'2015ApJ...804L...5M',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92541,'RR Lyrae','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'N',92541,20.89,0.11,0.151,39032,NULL,NULL,NULL,'Hydra II',NULL,'2016AJ....151..118V',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92542,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92542,36.44,0.33,194,39033,70,NULL,NULL,'2MASX J12214217+3729006',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000166,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,185.42575,37.48339,0,NULL,58583213063,915362704,14302542,16.7),(92543,'SNII radio','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 1986E',NULL,92543,33.45,0.34,49,39034,NULL,NULL,NULL,'NGC 4302',NULL,'1998ApJ...500...51W',1998,1,2.78,NULL,'G',0.00001,NULL,'13.6g',0.75,'Sc: sp;Sy      LINER','Pair member (points to parent)',NULL,NULL,NULL,1,185.427,14.59831,0.074,NULL,58181398270,909084347,14204442,13.6),(92544,'Tully est','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92544,31.13,0.8,16.8,39034,75,NULL,'B','NGC 4302',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92545,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92545,30.78,NULL,14.3,39034,NULL,NULL,NULL,'NGC 4302',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92546,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92546,30.85,0.92,14.8,39034,NULL,NULL,'CO','NGC 4302',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92547,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92547,31.08,0.47,16.4,39034,NULL,NULL,'H','NGC 4302',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92548,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92548,31.1,0.45,16.6,39034,NULL,NULL,'K','NGC 4302',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92549,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92549,31.14,0.46,16.9,39034,NULL,NULL,'J','NGC 4302',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92550,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92550,31.34,0.7,18.5,39034,NULL,NULL,'HI','NGC 4302',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92551,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92551,31.6,0.4,20.9,39034,NULL,NULL,'mean','NGC 4302',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92552,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92552,31.96,0.49,24.7,39034,75,NULL,'IR','NGC 4302',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92553,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92553,32.01,0.3,25.3,39034,55,NULL,'B','NGC 4302',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92554,'IRAS','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92554,31.93,0.8,24.3,39035,75,NULL,'A82, H','ESO 321- G 025',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000033,NULL,'12.66',1.1,'SB(r)d         HII',NULL,NULL,NULL,NULL,1,185.4287917,-39.7695,0.385,NULL,43279860164,676247815,10566372,12.66),(92555,'IRAS','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92555,31.94,0.8,24.4,39035,75,NULL,'MAT, I','ESO 321- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92556,'Sosies','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92556,31.05,0.28,16.2,39035,NULL,NULL,NULL,'ESO 321- G 025',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92557,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92557,32,0.32,25.1,39035,85,NULL,'I, raw','ESO 321- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92558,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92558,32.03,0.32,25.5,39035,85,NULL,'I, inv','ESO 321- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92559,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92559,32.28,0.43,28.6,39035,75,NULL,'MAT, I, raw','ESO 321- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92560,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92560,32.34,0.38,29.4,39035,NULL,NULL,NULL,'ESO 321- G 025',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92561,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92561,32.45,0.43,30.9,39035,75,NULL,'MAT, I, inv','ESO 321- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92562,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92562,32.67,0.43,34.1,39035,75,NULL,'MAT, I, cor','ESO 321- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92563,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92563,32.87,0.4,37.5,39035,NULL,NULL,'mean','ESO 321- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92564,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92564,33.03,0.46,40.4,39035,NULL,NULL,'J','ESO 321- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92565,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92565,33.13,0.47,42.2,39035,NULL,NULL,'H','ESO 321- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92566,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92566,33.14,0.47,42.4,39035,75,NULL,'A82, H, raw','ESO 321- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92567,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92567,33.14,0.45,42.5,39035,NULL,NULL,'K','ESO 321- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92568,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92568,33.23,0.47,44.3,39035,75,NULL,'A82, H, inv','ESO 321- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92569,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92569,33.37,0.47,47.3,39035,75,NULL,'A82, H, cor','ESO 321- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92570,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92570,29.4,NULL,7.59,39036,NULL,NULL,NULL,'SDSS J122143.14+375913.8',NULL,'2013AJ....145..101K',2013,1,0.6,'Multiple SDSS entries describe this object.','G',0.000003,NULL,'16.0',0.5,'dwarf Irr','Dwarf, within FOV of cluster',NULL,NULL,NULL,1,185.4292083,37.98717,0,NULL,58585074758,915391793,14302996,16),(92571,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92571,37.74,0.15,353,39037,70,NULL,NULL,'SDSS J122143.77+134516.4',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.5g',0.31,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,185.432375,13.75458,0.234,NULL,58168704915,908886014,14201343,16.5),(92572,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92572,37.84,0.27,369,39038,70,NULL,NULL,'2MASX J12214382+5019355',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000159,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,185.432583,50.32644,0,NULL,57239781513,894371586,13974556,17.3),(92573,'Ring Diameter','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92573,31.6,0.84,21,39039,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4319',NULL,'1981ApJS...45..541P',1981,1,3,'RC3 has V = 1700 +- 48 km/sec.','G',0.00008,NULL,'12.80',2.3,'SB(r)ab        AGN','X-ray-bright group member',NULL,NULL,NULL,1,185.4327917,75.32258,0.061,NULL,57016480150,890882502,13920039,12.8),(92574,'Tully est','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92574,32.25,0.8,28.2,39039,75,NULL,'B','NGC 4319',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92575,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92575,37.1,0.46,263,39040,70,NULL,NULL,'2MASX J12214390+0234011',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,185.4329583,2.56703,0,NULL,58042086952,906907608,14170431,17.3),(92576,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92576,38.58,0.46,521,39041,70,NULL,NULL,'KUG 1219+281',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00017,NULL,'18.2g',0.14,'Spiral',NULL,NULL,NULL,NULL,1,185.433125,27.86861,0.064,NULL,58639685748,916245089,14316329,18.2),(92577,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92577,37.71,0.27,349,39042,70,NULL,NULL,'IC 3202',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000093,NULL,'16.1g',0.43,NULL,NULL,NULL,NULL,NULL,1,185.434708333,27.05711,0.095,NULL,58650477745,916413714,14318964,16.1),(92578,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92578,38.48,0.46,497,39043,70,NULL,NULL,'2MASX J12214441+1810027',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,185.435,18.16758,0.061,NULL,58859477195,919679331,14369989,17.8),(92579,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92579,36.94,0.46,245,39044,70,NULL,NULL,'2MASX J12214545+2210258',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.09',0.15,NULL,NULL,NULL,NULL,NULL,1,185.439625,22.17386,0.035,NULL,58867042762,919797543,14371836,18.09),(92580,'IRAS','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92580,34.91,0.8,95.8,39045,75,NULL,'HMCL, I','IC 3203',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000027,NULL,'15.51',0.2,'Sb             RET',NULL,NULL,NULL,NULL,1,185.440125,25.88467,0.063,NULL,58646114038,916345531,14317898,15.51),(92581,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92581,35.16,0.4,108,39045,NULL,NULL,'mean','IC 3203',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92582,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92582,35.27,0.47,113,39045,NULL,NULL,'H','IC 3203',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92583,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92583,35.35,0.45,118,39045,NULL,NULL,'K','IC 3203',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92584,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92584,35.36,0.49,118,39045,75,NULL,'IR','IC 3203',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92585,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92585,35.43,0.46,122,39045,NULL,NULL,'J','IC 3203',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92586,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92586,35.46,0.4,124,39045,75,NULL,'HMCL, I, raw','IC 3203',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92587,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92587,35.62,0.4,133,39045,75,NULL,'HMCL, I, cor','IC 3203',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92588,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92588,35.74,0.4,140,39045,75,NULL,'HMCL, I, inv','IC 3203',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92589,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92589,38.25,0.33,447,39046,70,NULL,NULL,'SDSS J122145.95+664353.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00008,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,185.4415417,66.73153,0.029,NULL,57314027325,895531676,13992682,18.3),(92590,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92590,37.3,0.46,289,39047,70,NULL,NULL,'LCRS B121912.1-024817',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000143,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,185.441875,-3.08192,0.069,NULL,43001080861,671891888,10498310,16.5),(92591,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92591,37.93,0.46,385,39048,70,NULL,NULL,'2MASX J12214650+0942018',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000175,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,185.443666667,9.70053,0,NULL,58211116271,909548691,14211698,17.2),(92592,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92592,37.74,0.15,353,39049,70,NULL,NULL,'SDSS J122146.86+134146.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,185.4452917,13.69636,0.234,NULL,58168682732,908885667,14201338,17.8),(92593,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92593,35.65,0.54,135,39050,70,NULL,NULL,'2MASX J12214813-5101210',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,185.4505417,-51.02253,0.661,NULL,44623712414,697245506,10894461,16.7),(92594,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92594,37.93,0.46,385,39051,70,NULL,NULL,'2MASX J12214830+2837405',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,185.4512083,28.62803,0.07,NULL,58636660164,916197815,14315590,17.6),(92595,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92595,37.2,0.33,275,39052,70,NULL,NULL,'VPC 0163',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00017,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,185.451417,13.56258,0.199,NULL,58168461880,908882216,14201284,16.4),(92596,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92596,36.44,0.33,194,39053,70,NULL,NULL,'2MASX J12214862+3723526',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000165,NULL,'16.0g',0.4,NULL,NULL,NULL,NULL,NULL,1,185.452791667,37.39792,0,NULL,58583210620,915362665,14302541,16),(92597,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92597,35.61,0.51,132,39054,70,NULL,NULL,'2MASX J12214873-5144210',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,185.453,-51.73925,0.245,NULL,44625029627,697266087,10894782,17),(92598,'IRAS','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92598,33.76,0.8,56.5,39055,75,NULL,'MAT, I','ESO 506- G 004',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.00003,NULL,'12.65',1.1,'SB(rs)ab poss. LINER',NULL,NULL,NULL,NULL,1,185.454375,-24.16828,0.313,NULL,43361338494,677520913,10586264,12.65),(92599,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92599,33.52,0.45,50.6,39055,NULL,NULL,'K','ESO 506- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92600,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92600,33.53,0.46,50.7,39055,NULL,NULL,'J','ESO 506- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92601,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92601,33.54,0.47,51.1,39055,NULL,NULL,'H','ESO 506- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92602,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92602,33.77,0.43,56.8,39055,75,NULL,'MAT, I, raw','ESO 506- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92603,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92603,33.89,0.32,59.9,39055,85,NULL,'I, raw','ESO 506- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92604,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92604,33.93,0.4,61.1,39055,NULL,NULL,'mean','ESO 506- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92605,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92605,33.97,0.32,62.3,39055,85,NULL,'I, inv','ESO 506- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92606,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92606,34.11,0.43,66.3,39055,75,NULL,'MAT, I, cor','ESO 506- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92607,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92607,34.11,0.43,66.5,39055,75,NULL,'MAT, I, inv','ESO 506- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92608,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92608,34.23,0.38,70,39055,NULL,NULL,'Malmquist cor.','ESO 506- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92609,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92609,34.41,0.35,76.2,39055,NULL,NULL,NULL,'ESO 506- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92610,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92610,34.45,0.2,77.6,39055,74.4,NULL,NULL,'ESO 506- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92611,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92611,38.24,0.27,445,39056,70,NULL,NULL,'SDSS J122149.50+070956.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,185.45625,7.16564,0,NULL,58208064745,909501011,14210953,18.2),(92612,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92612,38.12,0.27,422,39057,70,NULL,NULL,'2MASX J12215032+0457402',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,185.459708333,4.96117,0,NULL,58033279772,906769996,14168281,16.9),(92613,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92613,36.28,0.46,180,39058,70,NULL,NULL,'IC 3205',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.00016,NULL,'15.2g',0.59,'E?',NULL,NULL,NULL,NULL,1,185.46225,26.341,0.073,NULL,58650723099,916417548,14319024,15.2),(92614,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92614,38.03,0.69,404,39059,70,NULL,NULL,'LCRS B121916.0-124220',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000133,NULL,'16.78',0.3,NULL,NULL,NULL,NULL,NULL,1,185.4627083,-12.98317,0.069,NULL,43070761976,672980655,10515322,16.78),(92615,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92615,38.12,0.27,422,39060,70,NULL,NULL,'2MASX J12215159+0501422',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,185.464875,5.02844,0,NULL,58033296853,906770263,14168285,17.7),(92616,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92616,37.39,0.46,301,39061,70,NULL,NULL,'2MASX J12215195+1912417',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'16.95',0.16,NULL,NULL,NULL,NULL,NULL,1,185.466667,19.21153,0.114,NULL,58862419191,919725299,14370707,16.95),(92617,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92617,38.12,0.27,422,39062,70,NULL,NULL,'2MASX J12215226+0457092',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,185.467833,4.95256,0,NULL,58033279845,906769997,14168281,NULL),(92618,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92618,36.45,0.46,195,39063,70,NULL,NULL,'2MASX J12215254+1024268',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00018,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,185.4687917,10.40742,0.011,NULL,58209301734,909520339,14211255,16.7),(92619,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92619,37.74,0.15,353,39064,70,NULL,NULL,'VPC 0166',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,185.469541667,13.84103,0.234,NULL,58168654283,908885223,14201331,17.6),(92620,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92620,37.7,0.46,346,39065,70,NULL,NULL,'VPC 0167',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000185,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,185.4702083,13.69208,0.234,NULL,58168677623,908885587,14201337,16.7),(92621,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92621,38.24,0.27,445,39066,70,NULL,NULL,'SDSS J122153.44+071048.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,185.4727083,7.18014,0,NULL,58208091021,909501422,14210959,18.2),(92622,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92622,37.2,0.33,275,39067,70,NULL,NULL,'VPC 0168',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000188,NULL,'17.1g',0.24,'AGN',NULL,NULL,NULL,NULL,1,185.473083,13.66078,0.234,NULL,58168685321,908885708,14201339,17.1),(92623,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92623,37.74,0.15,353,39068,70,NULL,NULL,'2MASX J12215363+1347458',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000132,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,185.4735417,13.79614,0.234,NULL,58168652708,908885198,14201331,18.3),(92624,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92624,37.82,0.46,367,39069,70,NULL,NULL,'2MASX J12215370+4133192',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000144,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,185.473833,41.55525,0,NULL,58529053828,914516466,14289319,17.9),(92625,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92625,37.94,0.46,387,39070,70,NULL,NULL,'SDSS J122154.11+083450.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,185.4754583,8.58078,0.007,NULL,58212793797,909574903,14212107,17.9),(92626,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92626,38.56,0.46,515,39071,70,NULL,NULL,'2MASX J12215440+2538385',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,185.47675,25.64417,0.101,NULL,58646168490,916346382,14317912,17.4),(92627,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92627,37.92,0.33,384,39072,70,NULL,NULL,'2MASX J12215458+1932417',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.49',0.11,NULL,NULL,NULL,NULL,NULL,1,185.4775417,19.54483,0.114,NULL,58860543577,919695993,14370249,18.49),(92628,'Grav. Stability Gas. Disk','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92628,30.11,NULL,10.5,39073,NULL,NULL,NULL,'MESSIER 061',NULL,'1996AstL...22...71Z',1996,1,6.5,NULL,'G',0.000007,NULL,'10.18',5.8,'SAB(rs)bc;HII  Sy2','in a radial-velocity based grouping',NULL,NULL,'Sy 2',1,185.47875,4.47364,0,NULL,58032952990,906764890,14168201,10.18),(92629,'SNII optical','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 2008in',NULL,92629,30.43,0.32,12.2,39073,NULL,NULL,'SCM','MESSIER 061',NULL,'2011ApJ...736...76R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92630,'SNII optical','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 2008in',NULL,92630,30.45,0.1,12.3,39073,NULL,NULL,'EPM, H01','MESSIER 061',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92631,'SNII optical','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 2008in',NULL,92631,30.81,0.2,14.5,39073,NULL,NULL,'EPM, D05','MESSIER 061',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92632,'SNII optical','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 2008in',NULL,92632,31.36,0.65,18.7,39073,NULL,NULL,'SCM','MESSIER 061',NULL,'2015ApJ...799..215P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92633,'SNII optical','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 2008in',NULL,92633,31.43,0.07,19.3,39073,NULL,NULL,'I, photospheric magnitude method','MESSIER 061',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92634,'SNII optical','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 2008in',NULL,92634,31.58,0.1,20.7,39073,NULL,NULL,'V, photospheric magnitude method','MESSIER 061',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92635,'SNII optical','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 1926A',NULL,92635,32.75,0.25,35.5,39073,50,NULL,NULL,'MESSIER 061',NULL,'1994ApJ...433...19S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92636,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92636,30.02,0.92,10.1,39073,NULL,NULL,'CO','MESSIER 061',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92637,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92637,30.21,0.7,11,39073,NULL,NULL,'HI','MESSIER 061',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92638,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92638,30.91,0.4,15.2,39073,75,NULL,'B','MESSIER 061',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92639,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92639,37.71,0.27,349,39074,70,NULL,NULL,'2MASX J12215494+2701005',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000174,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,185.479,27.01689,0.095,NULL,58650479347,916413739,14318964,17.5),(92640,'CMD','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92640,27.39,NULL,3,39075,NULL,NULL,NULL,'AGC 226067',NULL,'2015ApJ...806...95S',2015,1,NULL,NULL,'G',0.000093,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,185.480417,13.46944,0.199,1,58168360897,908880639,14201259,NULL),(92641,'Tertiary','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92641,27.39,NULL,3,39075,NULL,NULL,NULL,'AGC 226067',NULL,'2015A&A...575A.126B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92642,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92642,32.73,0.36,35.2,39076,NULL,NULL,NULL,'UGC 07423',NULL,'2009AJ....138..323T',2009,1,1.1,NULL,'G',0.000017,NULL,'15.55',0.7,'Sm:            HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,185.4815,6.45061,0,NULL,58205330487,909458288,14210285,15.55),(92643,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92643,37.47,0.46,312,39077,70,NULL,NULL,'2MASX J12215557+4032422',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000141,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,185.4817917,40.54514,0,NULL,58530876437,914544944,14289764,17.1),(92644,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92644,36.78,0.46,227,39078,70,NULL,NULL,'2MASX J12215611+2915545',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,185.4837917,29.26525,0.118,NULL,58628676335,916073067,14313641,17.5),(92645,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92645,37.73,0.21,352,39079,70,NULL,NULL,'2MASX J12215627+0122572',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000202,NULL,'16.3g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,185.484417,1.38253,0,NULL,58041098841,906892169,14170190,16.3),(92646,'Tully est','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92646,29.93,0.8,9.7,39080,75,NULL,'B','NGC 4308',NULL,'1988NBGC.C....0000T',1988,1,0.81,NULL,'G',0.000033,NULL,'14.0g',0.77,'E:','in a radial-velocity based grouping',NULL,NULL,NULL,1,185.486875,30.07436,0.061,NULL,58758587014,918102922,14345358,14),(92647,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92647,31.15,NULL,17,39081,NULL,NULL,NULL,'VCC 0513',NULL,'2014A&A...562A..49M',2014,1,0.43,NULL,'G',0.000008,NULL,'17.0g',0.32,'SB0/a pec?     HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,185.490833,2.34508,0,NULL,58042014469,906906476,14170413,17),(92648,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92648,37.48,0.46,314,39082,70,NULL,NULL,'2MASX J12215869+2625585',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000127,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,185.494458333,26.43297,0.087,NULL,58651019359,916422177,14319096,16.4),(92649,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92649,38.06,0.27,408,39083,70,NULL,NULL,'2MASX J12215879+4934317',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000127,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,185.4949583,49.57533,0,NULL,57182164096,893471314,13960489,17.5),(92650,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92650,37.68,0.46,344,39084,70,NULL,NULL,'SDSS J122159.39+102246.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000152,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,185.4974583,10.37961,0,NULL,58209301816,909520340,14211255,18.3),(92651,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92651,36.54,0.46,203,39085,70,NULL,NULL,'2MASX J12215941+4331089',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000166,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,185.497666667,43.51914,0,NULL,59070936413,922983381,14421615,16.7),(92652,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92652,37.54,0.46,321,39086,70,NULL,NULL,'2MASX J12215987+4954117',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00013,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,185.499333,49.90336,0,NULL,57237804433,894340694,13974073,17.4),(92653,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92653,38.84,0.46,586,39087,70,NULL,NULL,'SDSS J122200.15+235234.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,185.500625,23.87628,0.102,NULL,58591176080,915487126,14304486,18.4),(92654,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92654,35.63,0.15,134,39088,70,NULL,NULL,'IC 3210',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.0001,NULL,'15.1g',0.58,'E?',NULL,NULL,NULL,NULL,1,185.504083,28.43108,0.08,NULL,58640268679,916254198,14316471,15.1),(92655,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92655,35.86,0.46,149,39089,70,NULL,NULL,'2MASX J12220154+2020296',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.14',0.23,NULL,NULL,NULL,NULL,NULL,1,185.506583333,20.34169,0.107,NULL,58867225143,919800392,14371881,16.14),(92656,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92656,37.7,0.23,346,39090,70,NULL,NULL,'SDSS J122201.61+062849.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,185.506708333,6.48039,0,NULL,58205333668,909458338,14210286,18.2),(92657,'IRAS','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92657,32.88,0.8,37.7,39091,75,NULL,'MAT, I','ESO 380- G 019',NULL,'1997ApJS..109..333W',1997,1,3.1,NULL,'G',0.000023,NULL,'13.46',0.5,'Scd: sp        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,185.509333,-35.79275,0.257,NULL,43263524463,675992569,10562383,13.46),(92658,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92658,32.53,0.46,32,39091,NULL,NULL,'J','ESO 380- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92659,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92659,32.59,0.49,33,39091,75,NULL,'IR','ESO 380- G 019',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92660,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92660,32.62,0.47,33.3,39091,NULL,NULL,'H','ESO 380- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92661,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92661,32.7,0.4,34.7,39091,75,NULL,NULL,'ESO 380- G 019',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92662,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92662,32.76,0.45,35.7,39091,NULL,NULL,'K','ESO 380- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92663,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92663,32.84,0.2,37,39091,74.4,NULL,NULL,'ESO 380- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92664,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92664,32.9,0.43,38,39091,75,NULL,'MAT, I, raw','ESO 380- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92665,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92665,32.93,0.43,38.6,39091,75,NULL,'3.6 micron, color corrected','ESO 380- G 019',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92666,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92666,33.11,0.43,41.9,39091,75,NULL,'3.6 micron, color + selection bias corrected','ESO 380- G 019',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92667,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92667,33.12,0.32,42.1,39091,85,NULL,'I, raw','ESO 380- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92668,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92668,33.12,0.43,42.1,39091,75,NULL,'MAT, I, cor','ESO 380- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92669,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92669,33.13,0.4,42.2,39091,NULL,NULL,'mean','ESO 380- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92670,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92670,33.2,0.32,43.6,39091,85,NULL,'I, inv','ESO 380- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92671,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92671,33.2,0.43,43.7,39091,75,NULL,'MAT, I, inv','ESO 380- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92672,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92672,33.22,0.12,44.1,39091,NULL,NULL,NULL,'ESO 380- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92673,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92673,33.8,0.52,57.6,39092,70,NULL,NULL,'ESO 267- G 043',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.38',0.7,'(RL)SB(l)0^0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,185.5092917,-46.216,0.389,NULL,46723424377,730053505,11407086,14.38),(92674,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92674,37.73,0.21,352,39093,70,NULL,NULL,'2MASX J12220240+0123422',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000192,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,185.510125,1.395,0,NULL,58041048435,906891381,14170177,16.7),(92675,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92675,34.76,0.46,89.7,39094,70,NULL,NULL,'CGCG 014-017',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000123,NULL,'15.2g',0.53,'cE?',NULL,NULL,NULL,NULL,1,185.514333,-2.61672,0.069,NULL,43006317278,671973707,10499589,15.2),(92676,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92676,35.91,0.33,152,39095,70,NULL,NULL,'2MASX J12220372+5532235',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,185.515583,55.53989,0,NULL,57401151436,896892991,14013952,16.8),(92677,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92677,37.87,0.46,375,39096,70,NULL,NULL,'2MASX J12220520+0148422',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000213,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,185.52175,1.81183,0,NULL,58042596962,906915577,14170555,17),(92678,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92678,38.1,0.46,416,39097,70,NULL,NULL,'2MASX J12220557+6123297',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000143,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,185.522917,61.39161,0,NULL,57370887385,896420115,14006564,17.8),(92679,'Tully est','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92679,31.13,0.8,16.8,39098,75,NULL,'B','NGC 4307',NULL,'1988NBGC.C....0000T',1988,1,3.59,NULL,'G',0.000033,NULL,'13.0g',0.82,'Sb;LINER       HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,185.523666667,9.04364,0,NULL,58210907001,909545421,14211647,13),(92680,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92680,31.46,0.43,19.6,39098,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4307',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92681,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92681,31.48,0.43,19.8,39098,75,NULL,'3.6 micron, color corrected','NGC 4307',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92682,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92682,31.55,0.2,20.4,39098,74.4,NULL,NULL,'NGC 4307',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92683,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92683,31.68,0.4,21.6,39098,NULL,NULL,'mean','NGC 4307',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92684,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92684,31.7,0.46,21.9,39098,NULL,NULL,'J','NGC 4307',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92685,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92685,31.71,0.46,22,39098,NULL,NULL,'Malmquist cor.','NGC 4307',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92686,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92686,31.72,0.47,22,39098,NULL,NULL,'H','NGC 4307',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92687,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92687,31.74,0.49,22.3,39098,75,NULL,'IR','NGC 4307',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92688,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92688,31.77,0.45,22.6,39098,NULL,NULL,NULL,'NGC 4307',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92689,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92689,31.77,0.45,22.6,39098,NULL,NULL,'K','NGC 4307',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92690,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92690,32.05,NULL,25.7,39098,NULL,NULL,NULL,'NGC 4307',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92691,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92691,32.49,0.3,31.5,39098,55,NULL,'B','NGC 4307',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92692,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92692,35.12,0.49,106,39099,75,NULL,'IR','IC 3209',NULL,'2011yCatp016004901K',2011,1,1.05,NULL,'G',0.000013,NULL,'15.2g',0.3,'Sbc(s)I-II','Group member',NULL,NULL,NULL,1,185.525625,11.75472,0.026,NULL,58166641396,908853771,14200840,15.2),(92693,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92693,35.49,0.2,125,39100,74.4,NULL,NULL,'IC 3209',NULL,'2013AJ....146...86T',2013,1,1.05,NULL,'G',0.000013,NULL,'15.2g',0.3,'Sbc(s)I-II','Group member',NULL,NULL,NULL,1,185.525625,11.75472,0.026,NULL,58166641396,908853771,14200840,15.2),(92694,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92694,37.74,0.15,353,39101,70,NULL,NULL,'VPC 0184',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.0002,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,185.52725,13.74886,0.234,NULL,58168651407,908885178,14201330,16.8),(92695,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92695,38.76,0.46,566,39102,70,NULL,NULL,'2MASX J12220695+2059366',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,185.528916667,20.99347,0.099,NULL,58865564496,919774445,14371475,18.6),(92696,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92696,36.18,0.27,173,39103,70,NULL,NULL,'MCG +09-20-157',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000192,NULL,'15.0g',0.58,'S0',NULL,NULL,NULL,NULL,1,185.5292917,55.81911,0,NULL,57409584382,897024755,14016011,15),(92697,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92697,38,0.46,398,39104,70,NULL,NULL,'2MASX J12220725+4224399',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000149,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,185.530083,42.411,0,NULL,59063041620,922860025,14419687,17.6),(92698,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92698,29.75,NULL,8.91,39105,NULL,NULL,NULL,'VCC 0530',NULL,'2013AJ....145..101K',2013,1,1.1,NULL,'G',0.00002,NULL,'15.8',0.9,'I?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,185.531541667,15.79911,0.043,NULL,58174436185,908975565,14202743,15.8),(92699,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92699,37.64,0.46,337,39106,70,NULL,NULL,'VPC 0186',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,185.532083,13.23992,0.177,NULL,58168330051,908880157,14201252,17.5),(92700,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92700,38.06,0.27,408,39107,70,NULL,NULL,'2MASX J12220774+4935157',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000161,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,185.5322917,49.58778,0,NULL,57182181708,893471589,13960493,17.1),(92701,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92701,38.51,0.46,502,39108,70,NULL,NULL,'2MASX J12220817+2751121',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000148,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,185.5339583,27.85331,0.064,NULL,58640385939,916256030,14316500,18.3),(92702,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92702,38.34,0.46,467,39109,70,NULL,NULL,'SDSS J122208.73+100623.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000158,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,185.536417,10.10661,0,NULL,58212010497,909562664,14211916,18.7),(92703,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92703,37.48,0.46,313,39110,70,NULL,NULL,'2MASX J12221034+0155156',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000189,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,185.543083,1.92103,0,NULL,58042460944,906913452,14170522,17.7),(92704,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92704,37.17,0.46,271,39111,70,NULL,NULL,'2MASX J12221038+3356473',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000186,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,185.543417,33.94653,0,NULL,58765946505,918217914,14347154,16.3),(92705,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92705,37.71,0.27,349,39112,70,NULL,NULL,'2MASX J12221040+2659401',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,185.5434583,26.99453,0.078,NULL,58650412462,916412694,14318948,18),(92706,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92706,37.53,0.46,320,39113,70,NULL,NULL,'VPC 0189',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,185.544,12.12736,0.016,NULL,58167561966,908868155,14201064,17.6),(92707,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92707,37.74,0.15,353,39114,70,NULL,NULL,'VPC 0190',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000192,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,185.5445417,13.78019,0.234,NULL,58168648920,908885139,14201330,17),(92708,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92708,35.96,0.46,156,39115,70,NULL,NULL,'2MASX J12221222+5559358',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000165,NULL,'16.1g',0.25,'S0',NULL,NULL,NULL,NULL,1,185.55075,55.99339,0,NULL,57409699418,897026553,14016039,16.1),(92709,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92709,32.78,0.4,36,39116,75,NULL,'B','NGC 4304',NULL,'1988NBGC.C....0000T',1988,1,2.6,NULL,'G',0.00001,NULL,'12.34',2.5,'(R\':)SB(rs)bc  HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,185.553,-33.4845,0.309,NULL,43443653321,678807083,10606360,12.34),(92710,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92710,36.91,0.33,241,39117,70,NULL,NULL,'2MASX J12221339+6202131',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000174,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,185.555417,62.03694,0,NULL,57371083273,896423176,14006612,16.2),(92711,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92711,37.86,0.46,374,39118,70,NULL,NULL,'2MASX J12221336+3825163',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,185.555666667,38.42125,0,NULL,58585509120,915398580,14303102,18.1),(92712,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92712,38.1,0.27,418,39119,70,NULL,NULL,'SDSS J122213.81+614645.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000149,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,185.5575417,61.77922,0,NULL,57371728661,896433260,14006769,18.6),(92713,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92713,38.66,0.46,539,39120,70,NULL,NULL,'2MASX J12221408+2107046',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,185.558791667,21.11792,0.096,NULL,58865574312,919774598,14371478,17.5),(92714,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92714,31.79,0.14,22.8,39121,74.4,NULL,NULL,'NGC 4309A',NULL,'2013AJ....146...86T',2013,1,0.48,NULL,'G',0.000063,NULL,'16.0g',0.41,'E0','in a pair',NULL,NULL,NULL,1,185.561417,7.16714,0,NULL,58208038999,909500609,14210947,16),(92715,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92715,31.8,0.09,22.9,39121,NULL,NULL,NULL,'NGC 4309A',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92716,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92716,31.81,0.09,23,39121,NULL,NULL,'HST ACS VCS','NGC 4309A',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92717,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92717,36.88,0.46,238,39122,70,NULL,NULL,'UGC 07437 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000177,NULL,'16.1g',0.4,'E',NULL,NULL,NULL,NULL,1,185.561958333,28.81283,0.086,NULL,58636668537,916197945,14315592,16.1),(92718,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92718,37.6,0.46,331,39123,70,NULL,NULL,'2MASX J12221492+0557456',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,185.562,5.96267,0,NULL,58204378668,909443416,14210053,17.5),(92719,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92719,35.09,0.46,104,39124,70,NULL,NULL,'2MASX J12221564+3319533',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000165,NULL,'15.8g',0.43,NULL,NULL,NULL,NULL,NULL,1,185.565166667,33.33164,0,NULL,58765393656,918209275,14347019,15.8),(92720,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92720,38.24,0.27,445,39125,70,NULL,NULL,'SDSS J122215.93+070415.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000137,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,185.566417,7.07089,0,NULL,58204623807,909447246,14210113,18),(92721,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92721,37.75,0.46,354,39126,70,NULL,NULL,'SDSS J122216.38+041519.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,185.56825,4.25533,0,NULL,58035811578,906809555,14168899,18.5),(92722,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92722,35.58,0.51,130,39127,70,NULL,NULL,'ESO 573- G 015',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.84',0.6,'(R\'_2)SB(rs)0/a',NULL,NULL,NULL,NULL,1,185.568375,-17.99078,0.065,NULL,43898628549,685916071,10717438,15.84),(92723,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92723,37.95,0.46,389,39128,70,NULL,NULL,'VII Zw 450',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00018,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,185.568917,56.87461,0,NULL,57396175924,896815248,14012738,17),(92724,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92724,37.58,0.46,328,39129,70,NULL,NULL,'SDSS J122216.74+080734.0',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000137,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,185.5697917,8.12611,0,NULL,58205577731,909462152,14210346,18.6),(92725,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92725,37.14,0.46,268,39130,70,NULL,NULL,'2MASX J12221690+4344109',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000174,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,185.5704583,43.73633,0,NULL,59070944884,922983513,14421617,16.7),(92726,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92726,37.74,0.15,353,39131,70,NULL,NULL,'VPC 0199',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000143,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,185.5732083,13.76497,0.234,NULL,58168531527,908883305,14201301,17.5),(92727,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92727,38.28,0.46,452,39132,70,NULL,NULL,'VPC 0200',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000177,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,185.575375,13.55856,0.234,NULL,58168545231,908883519,14201304,17.5),(92728,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92728,36.26,0.33,178,39133,70,NULL,NULL,'2MASX J12221888+2037047',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'15.89',0.28,NULL,NULL,NULL,NULL,NULL,1,185.578667,20.61789,0.1,NULL,58867149451,919799210,14371862,15.89),(92729,'GCLF','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92729,31.05,0.2,16.2,39134,NULL,NULL,'TOM(g) = -7.2 mag','UGC 07436',NULL,'2010ApJ...717..603V',2010,1,1.37,NULL,'G',0.00004,NULL,'14.5g',0.71,'dE5','Group member',NULL,NULL,NULL,1,185.581375,14.76078,0.078,NULL,58173153281,908955520,14202430,14.5),(92730,'GCLF','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92730,31.11,0.24,16.7,39134,NULL,NULL,'TOM(g) = -7.2 mag','UGC 07436',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92731,'GCLF','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92731,31.24,0.2,17.7,39134,NULL,NULL,'TOM(u) = -8.4 mag','UGC 07436',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92732,'GCLF','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92732,31.32,0.18,18.4,39134,NULL,NULL,'TOM(z) = -8.53 mag','UGC 07436',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92733,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92733,30.97,0.14,15.6,39134,74.4,NULL,NULL,'UGC 07436',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92734,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92734,30.98,0.07,15.7,39134,NULL,NULL,NULL,'UGC 07436',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92735,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92735,30.99,0.08,15.8,39134,NULL,NULL,'HST ACS VCS','UGC 07436',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92736,'GC radius','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92736,30.43,0.14,12.2,39134,NULL,NULL,NULL,'UGC 07436',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92737,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92737,31.57,0.4,20.6,39135,NULL,NULL,'mean','IC 0783A',NULL,'2007A&A...465...71T',2007,1,0.78,NULL,'G',0.00004,NULL,'15.5g',0.58,'SB(r)0?','Group member',NULL,NULL,NULL,1,185.5817083,15.73358,0.053,NULL,58174424449,908975382,14202740,15.5),(92738,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92738,32.22,0.45,27.8,39135,NULL,NULL,'K','IC 0783A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92739,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92739,37.73,0.21,352,39136,70,NULL,NULL,'2MASX J12221995+0120046',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,185.583,1.33472,0,NULL,58041053456,906891460,14170179,17.3),(92740,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92740,37.79,0.46,361,39137,70,NULL,NULL,'LCRS B121946.3-025217',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,185.5847083,-3.14861,0.065,NULL,43001100252,671892191,10498315,18.3),(92741,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92741,37.82,0.46,366,39138,70,NULL,NULL,'2MASX J12222050+6544502',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,185.58525,65.74725,0.029,NULL,57325397444,895709335,13995458,17.9),(92742,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92742,38.15,0.46,426,39139,70,NULL,NULL,'2MASX J12222187+6219482',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000185,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,185.5912083,62.33006,0.029,NULL,57371100889,896423451,14006616,17.3),(92743,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92743,36.91,0.33,241,39140,70,NULL,NULL,'2MASX J12222222+6200132',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000176,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,185.592875,62.00358,0,NULL,57371739014,896433422,14006772,17.2),(92744,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92744,38.06,0.27,408,39141,70,NULL,NULL,'SDSS J122222.28+493408.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000171,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,185.592917,49.56908,0,NULL,57182179533,893471555,13960493,18.3),(92745,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92745,38.17,0.46,431,39142,70,NULL,NULL,'2MASX J12222245+1420011',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,185.593667,14.33364,0.088,NULL,58181330260,909083285,14204426,18.1),(92746,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92746,37.95,0.46,389,39143,70,NULL,NULL,'SDSS J122222.56+084115.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000179,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,185.5940417,8.68767,0,NULL,58212749401,909574209,14212097,18.3),(92747,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92747,37.86,0.46,373,39144,70,NULL,NULL,'2MASX J12222251+6553470',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00017,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,185.5940417,65.89628,0,NULL,57325435005,895709921,13995467,17.1),(92748,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92748,36.52,0.69,201,39145,70,NULL,NULL,'2MASX J12222324-5136560',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,185.596833333,-51.61561,0.933,NULL,44624923805,697264434,10894756,14.4),(92749,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92749,34.72,0.49,87.9,39146,75,NULL,'IR','ESO 573- G 016',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000023,NULL,'15',0.3,'S(r)ab:',NULL,NULL,NULL,NULL,1,185.5997083,-21.19428,0.137,NULL,43895376577,685865259,10716644,15),(92750,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92750,37.52,0.46,320,39147,70,NULL,NULL,'2MASX J12222432+1219221',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000161,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,185.601417,12.32294,0.014,NULL,58167552610,908868009,14201062,18.2),(92751,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92751,35.92,0.46,153,39148,70,NULL,NULL,'2MASX J12222450+0530336',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.02',0.2,NULL,NULL,NULL,NULL,NULL,1,185.602041667,5.50919,0,NULL,58032446691,906756979,14168077,17.02),(92752,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92752,37.7,0.23,346,39149,70,NULL,NULL,'2MASX J12222571+0630088',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000193,NULL,'16.1g',0.42,'BrClG',NULL,NULL,NULL,NULL,1,185.607125,6.5025,0,NULL,58204759317,909449364,14210146,16.1),(92753,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92753,37.19,0.46,274,39150,70,NULL,NULL,'SDSS J122225.86+422915.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,185.60775,42.48761,0,NULL,59063093492,922860835,14419700,17.9),(92754,'Tully est','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92754,29.93,0.8,9.7,39151,75,NULL,'B','NGC 4310',NULL,'1988NBGC.C....0000T',1988,1,2.2,'Often mistakenly called NGC 4311.','G',0.00003,NULL,'13.22',1.2,'(R\')SAB(r)0+?','in a radial-velocity based grouping',NULL,NULL,NULL,1,185.609583,29.20903,0.118,NULL,58628784265,916074754,14313668,13.22),(92755,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92755,38.37,0.46,472,39152,70,NULL,NULL,'2MASX J12222737+3221320',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000182,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,185.614125,32.35889,NULL,NULL,58767188688,918237323,14347458,17.8),(92756,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92756,38.37,0.46,471,39153,70,NULL,NULL,'SDSS J122227.40+042414.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,185.6142083,4.40408,0,NULL,58032920226,906764378,14168193,17.9),(92757,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92757,37.96,0.46,391,39154,70,NULL,NULL,'SDSS J122227.82+131639.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000154,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,185.615917,13.27767,0.177,NULL,58168435929,908881811,14201278,18.6),(92758,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92758,37.7,0.46,346,39155,70,NULL,NULL,'2MASX J12222808+0052516',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000093,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,185.617125,0.881,0.04,NULL,58041176181,906893377,14170209,17.1),(92759,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92759,37.7,0.23,346,39156,70,NULL,NULL,'2MASX J12222887+0630011',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,185.6204583,6.50031,0,NULL,58204765752,909449464,14210147,17.5),(92760,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92760,34.96,0.69,98.2,39157,100,NULL,'mid-IR','ESO 573-G 017',NULL,'2013ApJ...771...88L',2013,1,1.6,NULL,'G',0.000027,NULL,'15.28',1,'(R)SAB(l)0/a',NULL,NULL,NULL,NULL,1,185.622167,-22.34506,0.217,NULL,43897330186,685895784,10717121,15.28),(92761,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92761,36.26,0.33,178,39158,70,NULL,NULL,'2MASX J12222941+2036418',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.35',0.22,NULL,NULL,NULL,NULL,NULL,1,185.6225417,20.61161,0.107,NULL,58867180600,919799696,14371870,17.35),(92762,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92762,37.73,0.21,352,39159,70,NULL,NULL,'2MASX J12222995+0128316',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000164,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,185.624833333,1.4755,0,NULL,58042353343,906911770,14170496,17.5),(92763,'IRAS','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92763,34.12,0.8,66.7,39160,75,NULL,'MAT, I','IC 0784',NULL,'1997ApJS..109..333W',1997,1,1.9,'HOLM 384B is a star.','G',0.000007,NULL,'13.98',0.7,'SAB(rs)bc:',NULL,NULL,NULL,NULL,1,185.6252083,-4.65269,0.093,NULL,43000415896,671881498,10498148,13.98),(92764,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92764,33.42,0.32,48.3,39160,85,NULL,'I, raw','IC 0784',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92765,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92765,33.45,0.43,49,39160,75,NULL,'MAT, I, raw','IC 0784',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92766,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92766,33.46,0.32,49.3,39160,85,NULL,'I, inv','IC 0784',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92767,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92767,33.66,0.43,54.1,39160,75,NULL,'MAT, I, inv','IC 0784',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92768,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92768,33.68,0.43,54.5,39160,75,NULL,'MAT, I, cor','IC 0784',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92769,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92769,33.84,0.2,58.6,39160,74.4,NULL,NULL,'IC 0784',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92770,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92770,33.89,0.47,60.1,39160,NULL,NULL,'H','IC 0784',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92771,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92771,33.96,0.46,62,39160,NULL,NULL,'J','IC 0784',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92772,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92772,34.01,0.45,63.4,39160,NULL,NULL,'K','IC 0784',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92773,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92773,34.05,0.39,64.5,39160,NULL,NULL,NULL,'IC 0784',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92774,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92774,34.05,0.39,64.6,39160,NULL,NULL,'Malmquist cor.','IC 0784',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92775,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92775,34.3,0.4,72.5,39160,NULL,NULL,'mean','IC 0784',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92776,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92776,37.99,0.27,396,39161,70,NULL,NULL,'2MASX J12223047+1648151',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,185.626958333,16.80428,0.028,NULL,58170898656,908920291,14201879,17.4),(92777,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92777,37.72,0.46,350,39162,70,NULL,NULL,'CGPG 1220.2+6411',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000202,NULL,'16.2g',0.36,'BrClG',NULL,NULL,NULL,NULL,1,185.6282083,63.90322,0.025,NULL,57316469730,895569839,13993278,16.2),(92778,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92778,29.84,NULL,9.29,39163,NULL,NULL,NULL,'NGC 4312',NULL,'1999MNRAS.304..595G',1999,1,4.6,NULL,'G',0.000023,NULL,'12.53',1.1,'SA(rs)ab: sp   HII','in a pair',NULL,NULL,NULL,1,185.630667,15.53792,0.047,NULL,58173406137,908959470,14202491,12.53),(92779,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92779,29.96,0.92,9.8,39163,NULL,NULL,'CO','NGC 4312',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92780,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92780,30.1,0.43,10.5,39163,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4312',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92781,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92781,30.2,0.43,10.9,39163,75,NULL,'3.6 micron, color corrected','NGC 4312',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92782,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92782,30.25,NULL,11.2,39163,NULL,NULL,'B','NGC 4312',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92783,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92783,30.28,0.2,11.4,39163,74.4,NULL,NULL,'NGC 4312',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92784,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92784,30.36,0.7,11.8,39163,NULL,NULL,'HI','NGC 4312',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92785,'Tully est','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92785,29.93,0.8,9.7,39164,75,NULL,'B','NGC 4314',NULL,'1988NBGC.C....0000T',1988,1,4.2,NULL,'G',0.000017,NULL,'11.43',3.7,'SB(rs)a        LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,185.632583,29.89589,0.083,NULL,58628276822,916066825,14313544,11.43),(92786,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92786,38.23,0.46,443,39165,70,NULL,NULL,'2MASX J12223342+5354160',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000179,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,185.6392917,53.90456,0.023,NULL,57221536939,894086514,13970101,17.4),(92787,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92787,36.9,0.46,240,39166,70,NULL,NULL,'2MASX J12223350+5634310',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000174,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,185.639625,56.57536,0.029,NULL,57410161640,897033775,14016152,16.5),(92788,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92788,38.08,0.46,412,39167,70,NULL,NULL,'2MASX J12223396+3135301',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.34',0.18,NULL,NULL,NULL,NULL,NULL,1,185.641583333,31.59189,0.023,NULL,58759371502,918115179,14345549,18.34),(92789,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92789,37.53,0.46,321,39168,70,NULL,NULL,'VPC 0217',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,185.645667,14.80214,0.078,NULL,58173108907,908954826,14202419,17.7),(92790,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92790,35.41,0.46,121,39169,70,NULL,NULL,'CGCG 269-053',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000174,NULL,'15.2g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,185.645916667,51.15486,0,NULL,57240347766,894380433,13974694,15.2),(92791,'Tully est','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92791,31.13,0.8,16.8,39170,75,NULL,NULL,'IC 3224',NULL,'1988NBGC.C....0000T',1988,1,0.3,NULL,'G',0.0001,NULL,'16.6',0.3,'BCD            PAS','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,185.649625,12.15803,0.013,NULL,58167579178,908868424,14201069,16.6),(92792,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92792,31.15,NULL,17,39170,NULL,NULL,NULL,'IC 3224',NULL,'2014A&A...562A..49M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92793,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92793,31.59,0.43,20.8,39171,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4331',NULL,'2014MNRAS.444..527S',2014,1,2.2,NULL,'G',0.000017,NULL,'14.64',0.4,'Im?','X-ray-bright group member',NULL,NULL,NULL,1,185.649833,76.17247,0.145,NULL,57024022537,891000352,13921880,14.64),(92794,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92794,32.13,0.4,26.6,39171,75,NULL,'B','NGC 4331',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92795,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92795,36.14,0.46,169,39172,70,NULL,NULL,'VPC 0219',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00017,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,185.6502083,13.71703,0.234,NULL,58168535203,908883362,14201302,16.5),(92796,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92796,37.74,0.15,353,39173,70,NULL,NULL,'VPC 0220',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,185.6519583,13.689,0.234,NULL,58168571028,908883922,14201311,17.7),(92797,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92797,36.89,0.46,239,39174,70,NULL,NULL,'2MASX J12223725+4311282',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00017,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,185.655417,43.19125,0,NULL,59062732987,922855202,14419612,16.7),(92798,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92798,38.48,0.46,497,39175,70,NULL,NULL,'SDSS J122238.04+625600.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00014,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,185.6585,62.9335,0.009,NULL,57372485712,896445089,14006954,18.6),(92799,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92799,29.91,NULL,9.59,39176,NULL,NULL,NULL,'VCC 0565',NULL,'2013AJ....145..101K',2013,1,0.5,'Multiple SDSS entries describe this source.','G',0.000033,NULL,'15.7',0.3,'I?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,185.659625,6.01467,0,NULL,58204586622,909446665,14210104,15.7),(92800,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92800,30.34,NULL,11.7,39177,NULL,NULL,NULL,'NGC 4313',NULL,'1999MNRAS.304..595G',1999,1,4.99,'HOLM 385B is a star.','G',0.00002,NULL,'12.5g',0.79,'SA(rs)ab: sp   LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,185.660583,11.80094,0.009,NULL,58166853977,908857093,14200892,12.5),(92801,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92801,30.51,0.43,12.7,39177,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4313',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92802,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92802,30.57,0.43,13,39177,75,NULL,'3.6 micron, color corrected','NGC 4313',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92803,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92803,30.65,0.2,13.5,39177,74.4,NULL,NULL,'NGC 4313',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92804,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92804,30.74,0.47,14.1,39177,NULL,NULL,'H','NGC 4313',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92805,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92805,30.75,0.45,14.2,39177,NULL,NULL,'K','NGC 4313',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92806,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92806,30.77,0.46,14.3,39177,NULL,NULL,'J','NGC 4313',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92807,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92807,30.88,NULL,15,39177,NULL,NULL,'B','NGC 4313',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92808,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92808,31.04,0.49,16.1,39177,75,NULL,'IR','NGC 4313',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92809,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92809,31.82,0.4,23.1,39177,NULL,NULL,'mean','NGC 4313',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92810,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92810,37.27,0.46,284,39178,70,NULL,NULL,'2MASX J12223902+3008431',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000133,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,185.66275,30.14558,0.029,NULL,58758571814,918102684,14345354,16.6),(92811,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92811,37.11,0.46,264,39179,70,NULL,NULL,'LCRS B122006.5-023858',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00008,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,185.66875,-2.92644,0.065,NULL,42993720264,671776879,10496513,16.8),(92812,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92812,37.61,0.33,333,39180,70,NULL,NULL,'2MASX J12224068+1952068',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,185.669583,19.86864,0.116,NULL,58860672755,919698011,14370281,18.1),(92813,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92813,37.65,0.46,339,39181,70,NULL,NULL,'2MASX J12224091+2205478',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.06',0.17,NULL,NULL,NULL,NULL,NULL,1,185.6704583,22.09678,NULL,NULL,58866355549,919786805,14371668,18.06),(92814,'GCLF','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92814,31.56,0.68,20.5,39182,NULL,NULL,'TOM(g) = -7.2 mag','VCC 0571',NULL,'2007ApJS..171..101J',2007,1,0.99,NULL,'G',0.000123,NULL,'15.2g',0.51,'SB0_1_(6)','Group member',NULL,NULL,NULL,1,185.6715,7.95036,0,NULL,58205548924,909461701,14210339,15.2),(92815,'GCLF','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92815,31.59,0.54,20.8,39182,NULL,NULL,'TOM(g) = -7.2 mag','VCC 0571',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92816,'GCLF','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92816,32.77,1.73,35.7,39182,NULL,NULL,'TOM(u) = -8.4 mag','VCC 0571',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92817,'GCLF','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92817,32.78,1.54,36,39182,NULL,NULL,'TOM(z) = -8.53 mag','VCC 0571',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92818,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92818,31.86,0.14,23.6,39182,74.4,NULL,NULL,'VCC 0571',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92819,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92819,31.88,0.1,23.8,39182,NULL,NULL,NULL,'VCC 0571',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92820,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92820,31.89,0.1,23.8,39182,NULL,NULL,'HST ACS VCS','VCC 0571',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92821,'GC radius','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92821,31.79,NULL,22.8,39182,NULL,NULL,NULL,'VCC 0571',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92822,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92822,31.7,NULL,21.9,39183,NULL,NULL,NULL,'NGC 4316',NULL,'1999MNRAS.304..595G',1999,1,2.79,NULL,'G',0.000002,NULL,'13.5g',0.63,'Sbc;Sy         LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,185.676,9.33247,0,NULL,58211580828,909555950,14211811,13.5),(92823,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92823,31.83,0.4,23.2,39183,NULL,NULL,'mean','NGC 4316',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92824,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92824,31.88,0.43,23.8,39183,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4316',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92825,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92825,32.02,0.47,25.3,39183,NULL,NULL,'H','NGC 4316',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92826,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92826,32.04,0.46,25.6,39183,NULL,NULL,'J','NGC 4316',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92827,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92827,32.05,0.45,25.7,39183,NULL,NULL,'K','NGC 4316',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92828,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92828,32.08,0.43,26.1,39183,75,NULL,'3.6 micron, color corrected','NGC 4316',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92829,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92829,32.23,0.36,27.9,39183,NULL,NULL,NULL,'NGC 4316',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92830,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92830,32.34,0.2,29.4,39183,74.4,NULL,NULL,'NGC 4316',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92831,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92831,32.41,0.44,30.4,39183,NULL,NULL,'Malmquist cor.','NGC 4316',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92832,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92832,32.48,0.49,31.3,39183,75,NULL,'IR','NGC 4316',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92833,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92833,32.61,0.4,33.2,39183,NULL,NULL,NULL,'NGC 4316',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92834,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92834,32.88,0.3,37.6,39183,55,NULL,'B','NGC 4316',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92835,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92835,35.3,0.46,115,39184,70,NULL,NULL,'VCC 0572',NULL,'2015arXiv151105856S',2015,1,0.87,NULL,'G',0.000077,NULL,'14.8g',0.64,'E6','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,185.676417,3.14183,0,NULL,58004112152,906314252,14161160,14.8),(92836,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92836,37.74,0.46,354,39185,70,NULL,NULL,'SDSS J122242.86+085407.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000147,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,185.678625,8.90203,0,NULL,58210890800,909545168,14211643,18.4),(92837,'GCLF','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92837,32.05,0.27,25.7,39186,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4318',NULL,'2010ApJ...717..603V',2010,1,0.84,'RC3 has V = -337 +- 10 km/sec.','G',0.00003,NULL,'13.8g',0.69,'E4','in a radial-velocity based grouping',NULL,NULL,NULL,1,185.680375,8.19828,0,NULL,58205620871,909462826,14210356,13.8),(92838,'GCLF','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92838,32.15,0.26,26.9,39186,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4318',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92839,'GCLF','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92839,32.28,0.33,28.6,39186,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4318',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92840,'GCLF','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92840,32.36,0.13,29.6,39186,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4318',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92841,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92841,31.7,0.12,21.9,39186,74.4,NULL,NULL,'NGC 4318',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92842,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92842,31.72,0.08,22,39186,NULL,NULL,'HST ACS VCS','NGC 4318',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92843,'SBF','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92843,31.72,0.06,22.1,39186,NULL,NULL,NULL,'NGC 4318',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92844,'GC radius','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92844,31.98,NULL,24.9,39186,NULL,NULL,NULL,'NGC 4318',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92845,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92845,31.7,0.12,21.9,39186,74.4,NULL,NULL,'NGC 4318',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92846,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92846,32.02,NULL,25.4,39186,NULL,NULL,NULL,'NGC 4318',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92847,'Tully est','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92847,31.13,0.8,16.8,39186,75,NULL,'B','NGC 4318',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92848,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92848,36.21,0.46,175,39187,70,NULL,NULL,'2MASX J12224413+2744133',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'16.83',0.27,NULL,NULL,NULL,NULL,NULL,1,185.683917,27.73711,0.021,NULL,58640481474,916257523,14316523,16.83),(92849,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92849,37.13,0.46,267,39188,70,NULL,NULL,'2MASX J12224459+1019181',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00018,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,185.685917,10.32161,0,NULL,58209099051,909517172,14211205,17.2),(92850,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92850,37.3,0.46,288,39189,70,NULL,NULL,'2MASX J12224483-0108133',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00008,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,185.686625,-1.13703,0.045,NULL,42987732456,671683319,10495051,17.4),(92851,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92851,37.82,0.46,367,39190,70,NULL,NULL,'2MASX J12224508+2159128',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.95',0.2,NULL,NULL,NULL,NULL,NULL,1,185.6880417,21.98683,NULL,NULL,58866436740,919788074,14371688,17.95),(92852,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92852,37.61,0.33,333,39191,70,NULL,NULL,'2MASX J12224586+1956338',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,185.691167,19.94289,0.116,NULL,58859840412,919685006,14370078,17.1),(92853,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92853,36.87,0.46,237,39192,70,NULL,NULL,'2MASX J12224607+1946128',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'16.61',0.17,NULL,NULL,NULL,NULL,NULL,1,185.691875,19.77033,0.116,NULL,58860678996,919698109,14370282,16.61),(92854,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92854,36.65,0.46,214,39193,70,NULL,NULL,'2MASX J12224688+3055561',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000183,NULL,'16.0g',0.37,NULL,NULL,NULL,NULL,NULL,1,185.695333,30.93231,0.026,NULL,58762103849,918157872,14346216,16),(92855,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92855,37.82,0.46,367,39194,70,NULL,NULL,'2MASX J12224717+5822140',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000144,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,185.696333,58.37075,0,NULL,57396956903,896827451,14012928,17.5),(92856,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92856,37.82,0.46,367,39195,70,NULL,NULL,'2MASX J12224713+1941338',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,185.696541667,19.69269,0.114,NULL,58860757504,919699336,14370302,17.3),(92857,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92857,38.14,0.46,424,39196,70,NULL,NULL,'2MASX J12224714+4832365',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,185.696583,48.54353,0,NULL,57184188961,893502952,13960983,17.4),(92858,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92858,37.45,0.33,309,39197,70,NULL,NULL,'VPC 0228',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000177,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,185.696958333,12.12267,0.013,NULL,58167533672,908867713,14201058,16.6),(92859,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92859,37.5,0.46,317,39198,70,NULL,NULL,'SDSS J122247.46+031206.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000141,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,185.69775,3.20181,0,NULL,58004229954,906316093,14161188,18.3),(92860,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92860,38.99,0.46,629,39199,70,NULL,NULL,'SDSS J122247.91+050627.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,185.699625,5.10769,0,NULL,58003149737,906299214,14160925,18),(92861,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92861,37.37,0.46,298,39200,70,NULL,NULL,'SDSS J122248.03+130153.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,185.700125,13.03142,0.165,NULL,58168218589,908878415,14201225,18.2),(92862,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92862,36.66,0.46,215,39201,70,NULL,NULL,'VPC 0232',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000173,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,185.706375,12.58053,0.091,NULL,58167088999,908860765,14200949,16.4),(92863,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92863,37.77,0.46,357,39202,70,NULL,NULL,'2MASX J12224952+5242205',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000166,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,185.706417,52.70567,0,NULL,57228375219,894193362,13971771,16.7),(92864,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92864,34.42,0.49,76.7,39203,75,NULL,'IR','FGC 1419',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.000033,NULL,'15.80',0.1,'Sd',NULL,NULL,NULL,NULL,1,185.7127083,-16.29042,0.061,NULL,43075930956,673061421,10516584,15.8),(92865,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92865,35.06,NULL,103,39203,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1419',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92866,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92866,35.06,NULL,103,39203,NULL,NULL,'Dipole + Quadrupole','FGC 1419',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92867,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92867,35.08,NULL,104,39203,NULL,NULL,'Dipole','FGC 1419',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92868,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92868,35.1,NULL,105,39203,NULL,NULL,NULL,'FGC 1419',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92869,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92869,38.3,0.46,457,39204,70,NULL,NULL,'CGPG 1220.5+6357',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,185.7129583,63.67339,0.025,NULL,57371892954,896435827,14006809,17.4),(92870,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92870,38.2,0.46,437,39205,70,NULL,NULL,'2MASX J12225127+2521253',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.47',0.15,NULL,NULL,NULL,NULL,NULL,1,185.7135,25.35714,0.059,NULL,58648045444,916375710,14318370,18.47),(92871,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92871,37.95,0.46,388,39206,70,NULL,NULL,'2MASX J12225204+5424359',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000209,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,185.716625,54.41,0.011,NULL,57220245451,894066335,13969786,16.6),(92872,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92872,37.9,0.46,380,39207,70,NULL,NULL,'2MASX J12225251-0200543',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000156,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,185.718833333,-2.01519,0.065,NULL,42989075449,671704303,10495379,17.6),(92873,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92873,38.77,0.46,568,39208,70,NULL,NULL,'2MASX J12225340+6149522',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000203,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,185.722417,61.83108,0,NULL,57371699510,896432804,14006762,17.8),(92874,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92874,37.41,0.46,304,39209,70,NULL,NULL,'SDSS J122253.55+435321.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000149,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,185.723125,43.88922,0,NULL,59070984929,922984139,14421627,18.3),(92875,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92875,37.68,0.46,343,39210,70,NULL,NULL,'2MASX J12225369+4802195',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000165,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,185.723708333,48.03875,0,NULL,57183869343,893497958,13960905,16.9),(92876,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92876,36.65,0.46,213,39211,70,NULL,NULL,'2MASX J12225373+3110471',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000133,NULL,'16.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,185.723833,31.17981,0.025,NULL,58761404888,918146951,14346046,16.1),(92877,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92877,37.31,0.46,290,39212,70,NULL,NULL,'2MASX J12225384+0916271',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,185.7245417,9.27439,0,NULL,58211569063,909555766,14211808,16.7),(92878,'FP','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92878,37.19,0.56,274,39213,70,NULL,NULL,'2MASX J12225428-4350280',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,185.726291667,-43.84108,0.481,NULL,46722143289,730033488,11406773,14.1),(92879,'Brightest Stars','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92879,31.02,NULL,16,39214,NULL,NULL,'Photographic','MESSIER 100',NULL,'1981PASP...93...36D',1981,1,7.4,NULL,'G',0.000003,NULL,'9.84B',6.3,'SAB(s)bc;LINER HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,185.728458333,15.82181,0.053,NULL,58174269263,908972957,14202702,9.84),(92880,'Brightest Stars','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92880,31.42,NULL,19.2,39214,NULL,NULL,'Blue','MESSIER 100',NULL,'1997AstL...23..644G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92881,'Brightest Stars','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92881,31.81,NULL,23,39214,NULL,NULL,'Red + Blue','MESSIER 100',NULL,'1997AstL...23..644G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92882,'Brightest Stars','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92882,31.87,NULL,23.7,39214,NULL,NULL,'Red','MESSIER 100',NULL,'1997AstL...23..644G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92883,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92883,30.54,0.03,12.8,39214,73,NULL,'Cepheids magnitudes Gaussian, Data 2','MESSIER 100',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92884,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92884,30.57,0.11,13,39214,73,NULL,'Cepheids periods Gaussian, Data 1','MESSIER 100',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92885,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92885,30.58,0.22,13.1,39214,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian, Data 2','MESSIER 100',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92886,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92886,30.63,0.07,13.4,39214,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian, Data 1','MESSIER 100',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92887,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92887,30.64,0.5,13.4,39214,73,NULL,'Cepheids periods Gaussian, Data 2','MESSIER 100',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92888,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92888,30.7,0.03,13.8,39214,73,NULL,'Cepheids magnitudes Gaussian, Data 1','MESSIER 100',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92889,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92889,30.72,0.06,13.9,39214,74.4,NULL,NULL,'MESSIER 100',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92890,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92890,30.76,0.07,14.2,39214,NULL,NULL,'cte LMC K03','MESSIER 100',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92891,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92891,30.77,0.07,14.3,39214,NULL,NULL,'cte U99','MESSIER 100',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92892,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92892,30.78,0.07,14.3,39214,NULL,NULL,'42, VI, KEY PROJECT','MESSIER 100',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92893,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92893,30.8,0.07,14.4,39214,NULL,NULL,'cte LMC STS02','MESSIER 100',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92894,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92894,30.8,0.06,14.5,39214,NULL,NULL,'LMC W01','MESSIER 100',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92895,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92895,30.82,0.09,14.6,39214,NULL,NULL,'51, VI','MESSIER 100',NULL,'1997ApJ...491...13K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92896,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92896,30.87,0.07,14.9,39214,NULL,NULL,'cte MW FSG03','MESSIER 100',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92897,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92897,30.9,0.07,15.1,39214,NULL,NULL,'cte MF91','MESSIER 100',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92898,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92898,30.91,0.07,15.2,39214,NULL,NULL,'42, VI, +Z, KEY PROJECT','MESSIER 100',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92899,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92899,30.93,0.07,15.3,39214,NULL,NULL,'cte MW GFG98','MESSIER 100',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92900,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92900,30.96,0.07,15.6,39214,NULL,NULL,'35, VI (WF)','MESSIER 100',NULL,'2000ApJ...530L...5G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92901,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92901,30.98,0.08,15.7,39214,NULL,NULL,'MW HIPP','MESSIER 100',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92902,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92902,31.01,0.07,15.9,39214,NULL,NULL,'cte MW STS03','MESSIER 100',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92903,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92903,31.04,0.09,16.1,39214,NULL,NULL,'42, VI','MESSIER 100',NULL,'1996ApJ...464..568F',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92904,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92904,31.03,0.06,16.1,39214,NULL,NULL,'VK(BW)','MESSIER 100',NULL,'1997ApJ...486...60D',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92905,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92905,31.03,0.06,16.1,39214,NULL,NULL,'VI(BW)','MESSIER 100',NULL,'1997ApJ...486...60D',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92906,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92906,31.04,0.09,16.1,39214,NULL,NULL,'HST KP Calibrated','MESSIER 100',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92907,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92907,31.1,0.15,16.6,39214,NULL,NULL,'51, VI +Z','MESSIER 100',NULL,'1997ApJ...491...13K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92908,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92908,31.15,0.18,17,39214,NULL,NULL,'6, VI (PC)','MESSIER 100',NULL,'2000ApJ...530L...5G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92909,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92909,31.16,0.22,17.1,39214,NULL,NULL,NULL,'MESSIER 100',NULL,'1994Natur.371..757F',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92910,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92910,31.16,0.22,17.1,39214,NULL,NULL,'60, VI','MESSIER 100',NULL,'1994AAS...185.2403F',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92911,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92911,31.18,0.05,17.2,39214,NULL,18.54,'LMC ZP','MESSIER 100',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92912,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92912,31.18,NULL,17.2,39214,NULL,18.54,NULL,'MESSIER 100',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92913,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92913,31.19,0.1,17.3,39214,NULL,NULL,'Z, Key Project','MESSIER 100',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92914,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92914,31.22,0.24,17.5,39214,NULL,NULL,'MW P02','MESSIER 100',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92915,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92915,31.35,0.06,18.6,39214,NULL,NULL,'MW GFG','MESSIER 100',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92916,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92916,31.35,0.06,18.6,39214,NULL,NULL,'78, VI','MESSIER 100',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92917,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92917,31.44,0.03,19.4,39214,NULL,NULL,'BVRI','MESSIER 100',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92918,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92918,31.46,0.18,19.6,39214,NULL,NULL,NULL,'MESSIER 100',NULL,'1999Prama..53..933M',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92919,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92919,31.6,0.03,20.9,39214,NULL,NULL,'BVRI+','MESSIER 100',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92920,'Cepheids','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92920,31.65,NULL,21.4,39214,NULL,NULL,'42, VI','MESSIER 100',NULL,'2006A&A...452..423P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92921,'Novae','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92921,31,0.3,15.8,39214,NULL,NULL,'novae, VI','MESSIER 100',NULL,'1996ApJ...468L..95F',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92922,'Novae','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92922,31,0.3,15.8,39214,NULL,NULL,NULL,'MESSIER 100',NULL,'1997eds..proc..186L',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92923,'SNIa','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 2006X',NULL,92923,30.34,0.37,11.6,39214,74.2,NULL,'SALT 2','MESSIER 100',0.00524,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92924,'SNIa','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 2006X',NULL,92924,30.72,0.06,13.9,39214,74.4,NULL,NULL,'MESSIER 100',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92925,'SNIa','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 2006X',NULL,92925,30.8,0.3,14.4,39214,72,NULL,NULL,'MESSIER 100',0.00524,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92926,'SNIa','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 2006X',NULL,92926,31,0.03,15.8,39214,72,NULL,NULL,'MESSIER 100',0.00524,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92927,'SNIa','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 2006X',NULL,92927,30.99,0.02,15.8,39214,72,NULL,NULL,'MESSIER 100',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92928,'SNIa','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 2006X',NULL,92928,31.05,0.05,16.1,39214,72,NULL,NULL,'MESSIER 100',0.00524,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92929,'SNIa','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 2006X',NULL,92929,31.12,0.03,16.7,39214,72,NULL,NULL,'MESSIER 100',0.00524,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92930,'SNIa','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 2006X',NULL,92930,32.23,0.22,27.6,39214,72,NULL,NULL,'MESSIER 100',0.00633,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92931,'SNII radio','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 1979C',NULL,92931,31.52,0.22,20.1,39214,NULL,NULL,NULL,'MESSIER 100',NULL,'1998ApJ...500...51W',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92932,'Grav. Stability Gas. Disk','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92932,31.29,NULL,18.1,39214,NULL,NULL,NULL,'MESSIER 100',NULL,'1996AstL...22...71Z',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92933,'HII region diameter','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,'R',92933,31.43,0.13,19.3,39214,NULL,NULL,NULL,'MESSIER 100',NULL,'2005JKAS...38....7I',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92934,'SNII optical','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 1979C',NULL,92934,30.88,0.55,15,39214,NULL,NULL,NULL,'MESSIER 100',NULL,'1994ApJ...432...42S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92935,'SNII optical','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 1979C',NULL,92935,31.09,0.3,16.5,39214,NULL,NULL,NULL,'MESSIER 100',NULL,'2003ApJ...591..301B',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92936,'SNII optical','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 1979C','R',92936,31.26,0.67,17.9,39214,NULL,NULL,NULL,'MESSIER 100',NULL,'1985LNP...224..107B',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92937,'SNII optical','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 1979C',NULL,92937,31.39,0.53,19,39214,NULL,NULL,'EPM','MESSIER 100',NULL,'1992ApJ...395..366S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92938,'SNII optical','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 1979C',NULL,92938,31.39,0.76,19,39214,NULL,NULL,NULL,'MESSIER 100',NULL,'1985Natur.318...25B',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92939,'SNII optical','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 1979C',NULL,92939,31.48,0.3,19.8,39214,NULL,NULL,NULL,'MESSIER 100',NULL,'2003ApJ...591..301B',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92940,'SNII optical','2016-12-15 15:14:58','2016-12-16 11:20:08','1','SN 1979C',NULL,92940,31.8,0.5,23,39214,NULL,NULL,'Photographic','MESSIER 100',NULL,'1981ApJ...244..780B',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92941,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92941,30.2,0.78,11,39214,NULL,NULL,NULL,'MESSIER 100',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92942,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92942,30.44,0.7,12.3,39214,NULL,NULL,'Malmquist cor.','MESSIER 100',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92943,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92943,30.45,0.45,12.3,39214,NULL,NULL,'K','MESSIER 100',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92944,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92944,30.49,0.46,12.5,39214,NULL,NULL,'J','MESSIER 100',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92945,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92945,30.54,0.92,12.8,39214,NULL,NULL,'CO','MESSIER 100',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92946,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92946,30.72,0.06,13.9,39214,74.4,NULL,NULL,'MESSIER 100',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92947,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92947,30.74,0.27,14.1,39214,NULL,NULL,'TF and disk scale length','MESSIER 100',NULL,'1995ApJ...442...82C',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92948,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:08','1',NULL,NULL,92948,30.75,NULL,14.1,39214,84,NULL,'RC2 Hubble type','MESSIER 100',NULL,'1986AJ.....91.1286S',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92949,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',92949,30.78,NULL,14.3,39214,NULL,NULL,'LEDA [April 2006]','MESSIER 100',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92950,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,92950,30.8,0.4,14.5,39214,NULL,18.45,'SN 1979C host','MESSIER 100',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92951,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,92951,30.82,NULL,14.6,39214,NULL,NULL,NULL,'MESSIER 100',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92952,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',92952,30.91,NULL,15.2,39214,NULL,NULL,'B','MESSIER 100',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92953,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',92953,30.94,NULL,15.4,39214,NULL,NULL,'I','MESSIER 100',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92954,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,92954,30.94,0.3,15.4,39214,55,NULL,'B','MESSIER 100',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92955,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,92955,30.97,NULL,15.6,39214,NULL,NULL,'B','MESSIER 100',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92956,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,92956,31.02,0.4,16,39214,75,NULL,'HOSTS SN 2006X','MESSIER 100',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92957,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,92957,31.05,0.7,16.2,39214,NULL,NULL,'HI','MESSIER 100',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92958,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,92958,31.13,0.4,16.8,39214,75,NULL,'B','MESSIER 100',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92959,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,92959,31.2,NULL,17.4,39214,84,NULL,'RSA Hubble type','MESSIER 100',NULL,'1986AJ.....91.1286S',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92960,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,92960,31.86,0.4,23.5,39214,NULL,NULL,'mean','MESSIER 100',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92961,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,92961,35.56,0.45,130,39215,NULL,NULL,'Malmquist cor.','ESO 506- G 005',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.45',0.5,'(R\')SA(r)b?    HII',NULL,NULL,NULL,NULL,1,185.7300417,-23.347,0.285,NULL,43361642437,677525663,10586338,15.45),(92962,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,92962,35.76,0.42,142,39215,NULL,NULL,NULL,'ESO 506- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92963,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,92963,35.8,0.2,145,39215,74.4,NULL,NULL,'ESO 506- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92964,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',92964,38.21,0.46,439,39216,70,NULL,NULL,'2MASX J12225703+5937539',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,185.7375417,59.63172,0,NULL,57342751072,895980485,13999695,17.5),(92965,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',92965,37.45,0.33,309,39217,70,NULL,NULL,'VPC 0241',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000186,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,185.738417,12.22844,0.013,NULL,58167532297,908867692,14201057,16.9),(92966,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',92966,36.4,0.46,191,39218,70,NULL,NULL,'2MASX J12225753+5336095',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000168,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,185.7397083,53.60275,0.05,NULL,57221680246,894088753,13970136,16.7),(92967,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',92967,37.36,0.46,297,39219,70,NULL,NULL,'2MASX J12225852+2238048',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.84',0.18,NULL,NULL,NULL,NULL,NULL,1,185.743917,22.63467,0.102,NULL,58863705445,919745397,14371021,17.84),(92968,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',92968,39.07,0.46,653,39220,70,NULL,NULL,'2MASX J12225876+1657016',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,185.744708333,16.95036,0.025,NULL,58171041700,908922526,14201914,17.3),(92969,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',92969,38.1,0.27,418,39221,70,NULL,NULL,'2MASX J12230109+6142262',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000197,NULL,'16.7g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,185.754417,61.70717,0,NULL,57370823665,896419119,14006548,16.7),(92970,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',92970,35.64,0.46,134,39222,70,NULL,NULL,'2MASX J12230170+5158095',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,185.756958333,51.96928,0.019,NULL,57242592300,894415504,13975242,16.7),(92971,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',92971,38.41,0.33,480,39223,70,NULL,NULL,'2MASX J12230299+1959113',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,185.7624583,19.98636,0.116,NULL,58859845101,919685079,14370079,18.2),(92972,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',92972,36.72,0.46,220,39224,70,NULL,NULL,'CGPG 1220.7+6434',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00014,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,185.764041667,64.30472,0.005,NULL,57323740162,895683440,13995053,16.9),(92973,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',92973,37.45,0.46,309,39225,70,NULL,NULL,'2MASX J12230484+5919349',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,185.7702083,59.32631,0.005,NULL,57342849258,895982019,13999719,17.1),(92974,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',92974,37.83,0.46,367,39226,70,NULL,NULL,'2MASX J12230525+3516337',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000161,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,185.771875,35.27597,0.021,NULL,58540236112,914691189,14292049,17.2),(92975,'Ring Diameter','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,92975,32.7,0.76,34,39227,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4324',NULL,'1981ApJS...45..541P',1981,1,2.8,'HOLM 388B is a star.','G',0.000017,NULL,'12.51',1.2,'SA(r)0+;Sy     LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,185.77575,5.25033,0,NULL,58003274967,906301171,14160955,12.51),(92976,'Ring Diameter','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,92976,32.8,0.98,36,39227,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4324',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92977,'Tully est','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,92977,32.73,0.8,35.1,39227,75,NULL,'B','NGC 4324',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92978,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,92978,31.19,NULL,17.3,39227,NULL,NULL,NULL,'NGC 4324',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92979,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,92979,32.09,0.2,26.2,39227,74.4,NULL,NULL,'NGC 4324',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92980,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,92980,32.3,0.46,28.8,39227,NULL,NULL,'Malmquist cor.','NGC 4324',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92981,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,92981,32.45,0.43,31,39227,NULL,NULL,NULL,'NGC 4324',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92982,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',92982,35.05,0.46,102,39228,70,NULL,NULL,'NGC 4325',NULL,'2015arXiv151105856S',2015,1,1.25,NULL,'G',0.00013,NULL,'14.2g',0.8,'E4;BrClG','Group member',NULL,NULL,NULL,1,185.777833333,10.62119,0.016,NULL,58209156724,909518073,14211219,14.2),(92983,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',92983,38.1,0.27,418,39229,70,NULL,NULL,'2MASX J12230672+6142561',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000173,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,185.777917,61.71561,0,NULL,57370822838,896419106,14006548,18.6),(92984,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',92984,37.8,0.46,364,39230,70,NULL,NULL,'2MASX J12230696+4214232',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,185.778875,42.23981,0,NULL,59062563432,922852553,14419571,17.9),(92985,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',92985,36.95,0.46,245,39231,70,NULL,NULL,'2MASX J12230696+1530349',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000164,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,185.779125,15.50964,0.027,NULL,58173182460,908955975,14202437,16.5),(92986,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',92986,36.36,0.46,187,39232,70,NULL,NULL,'IC 3241',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000097,NULL,'15.7g',0.39,NULL,NULL,NULL,NULL,NULL,1,185.785167,26.90528,0.078,NULL,58639068510,916235445,14316178,15.7),(92987,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,92987,36.36,0.71,187,39233,70,NULL,NULL,'2MASX J12230873-5116179',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,185.786375,-51.27158,0.933,NULL,44627025644,697297275,10895269,15.9),(92988,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',92988,38.25,0.33,447,39234,70,NULL,NULL,'2MASX J12230932+6641589',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000092,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,185.788917,66.69978,0.029,NULL,57313264463,895519757,13992496,16.6),(92989,'Tully est','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,92989,31.47,0.8,19.7,39235,75,NULL,NULL,'UGCA 278',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.00001,NULL,'16.2',0.9,'IAB(s)m',NULL,NULL,NULL,NULL,1,185.792917,-13.94583,0.105,NULL,43069456180,672960252,10515003,16.2),(92990,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,92990,30.58,0.4,13.1,39235,NULL,NULL,NULL,'UGCA 278',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(92991,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',92991,37.7,0.46,346,39236,70,NULL,NULL,'2MASX J12231067+3317017',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000153,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,185.794375,33.28375,0,NULL,58765585069,918212266,14347066,17.3),(92992,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',92992,37.31,0.46,290,39237,70,NULL,NULL,'SDSS J122311.55+171051.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,185.798167,17.18111,0.025,NULL,58124726769,908198855,14190607,18.2),(92993,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',92993,37.95,0.33,390,39238,70,NULL,NULL,'VPC 0258',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000183,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,185.800125,12.18717,0.013,NULL,58167526531,908867602,14201056,17.1),(92994,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',92994,37.53,0.46,320,39239,70,NULL,NULL,'VPC 0259',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000186,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,185.800375,13.96244,0.154,NULL,58167884257,908873191,14201143,17.2),(92995,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',92995,37.02,0.46,253,39240,70,NULL,NULL,'SDSS J122312.86+163857.6',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.8g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,185.803625,16.64936,0.026,NULL,58170977128,908921517,14201898,16.8),(92996,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',92996,37.41,0.46,303,39241,70,NULL,NULL,'2MASX J12231295+6447544',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,185.803917,64.79844,0.025,NULL,57324384484,895693507,13995211,17.7),(92997,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',92997,36.87,0.46,237,39242,70,NULL,NULL,'2MASX J12231393+0324309',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000163,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,185.808167,3.40858,0.007,NULL,58004938559,906327164,14161361,16.8),(92998,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,92998,31.55,0.43,20.4,39243,75,NULL,'3.6 micron, color + selection bias corrected','IC 3247',NULL,'2014MNRAS.444..527S',2014,1,1.68,NULL,'G',0.000013,NULL,'15.2g',0.29,'Sd',NULL,NULL,NULL,NULL,1,185.8082917,28.89375,0.086,NULL,58628625202,916072268,14313629,15.2),(92999,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,92999,31.75,0.43,22.4,39243,75,NULL,'3.6 micron, color corrected','IC 3247',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93000,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93000,31.84,0.2,23.3,39243,74.4,NULL,NULL,'IC 3247',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93001,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93001,31.85,0.61,23.5,39243,NULL,NULL,'Malmquist cor.','IC 3247',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93002,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93002,31.94,NULL,24.4,39243,NULL,NULL,NULL,'IC 3247',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93003,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93003,31.98,NULL,24.9,39243,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 3247',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93004,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93004,31.98,NULL,24.9,39243,NULL,NULL,'Dipole + Quadrupole','IC 3247',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93005,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93005,31.99,NULL,25,39243,NULL,NULL,'Dipole','IC 3247',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93006,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93006,32.01,0.4,25.2,39243,NULL,NULL,NULL,'IC 3247',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93007,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93007,32.07,0.56,26,39243,NULL,NULL,NULL,'IC 3247',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93008,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93008,32.08,NULL,26,39243,NULL,NULL,NULL,'IC 3247',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93009,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93009,35.18,0.54,109,39244,70,NULL,NULL,'2MASX J12231407-1641328',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.76',NULL,NULL,NULL,NULL,NULL,NULL,1,185.808625,-16.69267,0.069,NULL,43075589106,673056079,10516501,15.76),(93010,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',93010,37.8,0.46,363,39245,70,NULL,NULL,'2MASX J12231479+3605444',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,185.811833,36.09567,0,NULL,58572733238,915198956,14299983,17.7),(93011,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',93011,37.22,0.46,279,39246,70,NULL,NULL,'2MASX J12231553+4421539',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,185.814583,44.36508,0,NULL,59071965615,922999462,14421866,17.6),(93012,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',93012,36.78,0.46,227,39247,70,NULL,NULL,'2MASX J12231659+2857418',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000177,NULL,'16.3g',0.33,'S0',NULL,NULL,NULL,NULL,1,185.81925,28.96175,0.086,NULL,58628630686,916072354,14313630,16.3),(93013,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93013,31.31,NULL,18.3,39248,NULL,NULL,NULL,'NGC 4330',NULL,'1999MNRAS.304..595G',1999,1,5.04,NULL,'G',0.00001,NULL,'13.09',0.67,'Scd            HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,185.821875,11.36797,0.022,NULL,58208553615,909508650,14211072,13.09),(93014,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93014,31.32,0.43,18.4,39248,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4330',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93015,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93015,31.35,0.43,18.7,39248,75,NULL,'3.6 micron, color corrected','NGC 4330',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93016,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93016,31.4,0.2,19.1,39248,74.4,NULL,NULL,'NGC 4330',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93017,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93017,31.45,0.36,19.5,39248,NULL,NULL,NULL,'NGC 4330',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93018,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93018,31.55,NULL,20.4,39248,NULL,NULL,'Dipole','NGC 4330',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93019,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93019,31.55,NULL,20.4,39248,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 4330',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93020,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93020,31.56,NULL,20.5,39248,NULL,NULL,'Dipole + Quadrupole','NGC 4330',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93021,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93021,31.64,NULL,21.2,39248,NULL,NULL,NULL,'NGC 4330',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93022,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',93022,31.82,0.49,23.1,39248,75,NULL,'IR','NGC 4330',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93023,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',93023,37.73,0.46,352,39249,70,NULL,NULL,'2MASX J12231812+2205073',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,185.8254583,22.08539,0.054,NULL,58866356406,919786818,14371669,18),(93024,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',93024,36.49,0.46,199,39250,70,NULL,NULL,'VPC 0273',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000149,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,185.826667,11.91417,0.009,NULL,58166714205,908854909,14200857,16.8),(93025,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',93025,36.97,0.46,247,39251,70,NULL,NULL,'2MASX J12231849+2809118',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.0001,NULL,'15.9g',0.4,NULL,NULL,NULL,NULL,NULL,1,185.827,28.15325,0.068,NULL,58640306802,916254793,14316481,15.9),(93026,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',93026,38.24,0.17,444,39252,70,NULL,NULL,'CGPG 1220.9+6324',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.0002,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,185.82975,63.12772,0,NULL,57372806675,896450104,14007032,17.4),(93027,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',93027,38.27,0.46,451,39253,70,NULL,NULL,'SDSS J122319.70+104834.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000149,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,185.832083,10.80956,0.026,NULL,58242180687,910034073,14219282,18.1),(93028,'IRAS','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93028,32.64,0.8,33.7,39254,75,NULL,'MAT, I','ESO 380- G 023',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000027,NULL,'15.78',0.22,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,185.832625,-37.38264,0.381,NULL,43282336845,676286513,10566976,15.78),(93029,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93029,32.46,0.32,31,39254,85,NULL,'I, raw','ESO 380- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93030,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93030,32.46,0.32,31,39254,85,NULL,'I, inv','ESO 380- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93031,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93031,32.65,0.43,33.9,39254,75,NULL,'MAT, I, raw','ESO 380- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93032,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93032,32.7,0.43,34.7,39254,75,NULL,'MAT, I, inv','ESO 380- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93033,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93033,32.96,0.43,39.1,39254,75,NULL,'MAT, I, cor','ESO 380- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93034,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93034,33.21,0.12,43.9,39254,NULL,NULL,NULL,'ESO 380- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93035,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93035,33.46,NULL,49.2,39254,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 380- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93036,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93036,33.48,NULL,49.6,39254,NULL,NULL,'Dipole + Quadrupole','ESO 380- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93037,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93037,33.51,NULL,50.3,39254,NULL,NULL,'Dipole','ESO 380- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93038,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93038,33.52,NULL,50.5,39254,NULL,NULL,NULL,'ESO 380- G 023',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93039,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93039,33.55,0.2,51.3,39254,74.4,NULL,NULL,'ESO 380- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93040,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93040,33.62,0.43,53,39254,75,NULL,'3.6 micron, color corrected','ESO 380- G 023',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93041,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93041,33.71,0.43,55.3,39254,75,NULL,'3.6 micron, color + selection bias corrected','ESO 380- G 023',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93042,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93042,31.11,0.4,16.7,39255,NULL,NULL,'mean','NGC 4328',NULL,'2007A&A...465...71T',2007,1,1.22,NULL,'G',0.000037,NULL,'14.3g',0.98,'SA0-:','Group member',NULL,NULL,NULL,1,185.833458333,15.82039,0.041,NULL,58171335412,908927115,14201986,14.3),(93043,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93043,31.87,0.45,23.7,39255,NULL,NULL,'K','NGC 4328',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93044,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',93044,37.83,0.46,368,39256,70,NULL,NULL,'SDSS J122320.04+463906.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,185.8335417,46.65181,0,NULL,59066213142,922909580,14420462,18),(93045,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',93045,38.39,0.46,477,39257,70,NULL,NULL,'2MASX J12232034+3428287',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000138,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,185.834833,34.47478,0,NULL,58762523160,918164424,14346319,18.4),(93046,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',93046,38.26,0.46,449,39258,70,NULL,NULL,'2MASX J12232071+2618128',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,185.8362083,26.30364,0.028,NULL,58650880672,916420010,14319062,18),(93047,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93047,33.23,0.48,44.2,39259,70,NULL,NULL,'NGC 4329',NULL,'2014MNRAS.445.2677S',2014,1,2.4,NULL,'G',0.00015,NULL,'14.5',1.4,'E+:',NULL,NULL,NULL,NULL,1,185.836291667,-12.55861,0.049,NULL,43067655430,672932116,10514564,14.5),(93048,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',93048,37.95,0.33,390,39260,70,NULL,NULL,'VPC 0276',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,185.8395,12.14019,0.013,NULL,58167526302,908867598,14201056,17.4),(93049,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93049,34.59,0.49,82.8,39261,70,NULL,NULL,'2MASX J12232157-0541008',NULL,'2014MNRAS.445.2677S',2014,1,0.76,NULL,'G',0.000103,NULL,'15.40',0.54,NULL,NULL,NULL,NULL,NULL,1,185.8400417,-5.68356,0.069,NULL,43201385371,675021646,10547213,15.4),(93050,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',93050,38.45,0.46,489,39262,70,NULL,NULL,'2MASX J12232220+5752360',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000176,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,185.8422083,57.87686,0,NULL,57408610112,897009533,14015773,16.8),(93051,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',93051,37.38,0.27,299,39263,70,NULL,NULL,'SDSS J122322.30+215229.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,185.842917,21.87494,NULL,NULL,58866421904,919787842,14371685,18.3),(93052,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',93052,38.77,0.46,567,39264,70,NULL,NULL,'SDSS J122323.00+391214.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000129,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,185.845875,39.20392,0,NULL,58574878195,915232471,14300507,18.4),(93053,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',93053,36.94,0.46,244,39265,70,NULL,NULL,'2MASX J12232344+2340083',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.75',0.19,NULL,NULL,NULL,NULL,NULL,1,185.847791667,23.66894,0.108,NULL,58590327804,915473871,14304279,17.75),(93054,'FP','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,'R',93054,38.2,0.46,437,39266,70,NULL,NULL,'2MASX J12232367+0418289',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.19',0.14,NULL,NULL,NULL,NULL,NULL,1,185.848791667,4.30808,0,NULL,58003318874,906301857,14160966,18.19),(93055,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93055,32.72,0.47,35.1,39267,NULL,NULL,'H','NGC 4334',NULL,'2007A&A...465...71T',2007,1,2.3,NULL,'G',0.00003,NULL,'13.8B',1.1,'SB(s)ab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,185.8495,7.47319,0,NULL,58236229963,909941093,14217829,13.8),(93056,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93056,32.78,0.45,36,39267,NULL,NULL,'K','NGC 4334',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93057,'Tully-Fisher','2016-12-15 15:14:58','2016-12-16 11:20:09','1',NULL,NULL,93057,32.83,0.46,36.7,39267,NULL,NULL,'J','NGC 4334',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93058,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93058,33.8,0.4,57.6,39267,NULL,NULL,'mean','NGC 4334',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93059,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93059,38.41,0.33,480,39268,70,NULL,NULL,'SDSS J122324.15+195325.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,185.850625,19.89033,0.116,NULL,58859805648,919684463,14370069,18.2),(93060,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93060,39.05,0.46,645,39269,70,NULL,NULL,'SDSS J122324.17+613530.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000153,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,185.85075,61.59181,0,NULL,57370946855,896421044,14006578,18.7),(93061,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93061,37.05,0.46,257,39270,70,NULL,NULL,'2MASX J12232513+0821501',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000172,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,185.854667,8.36378,0,NULL,58235824348,909934755,14217730,16.8),(93062,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93062,37.43,0.46,306,39271,70,NULL,NULL,'2MASX J12232524+1554329',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000154,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,185.855333333,15.90922,0.041,NULL,58171389210,908927956,14201999,17.3),(93063,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93063,38.05,0.46,407,39272,70,NULL,NULL,'2MASX J12232530+0007599',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000077,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,185.8555417,0.13328,0.054,NULL,58007465491,906366648,14161978,17.9),(93064,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93064,37.38,0.27,299,39273,70,NULL,NULL,'2MASX J12232609+2155103',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,185.858583,21.91958,NULL,NULL,58866527559,919789493,14371710,17.3),(93065,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93065,38.36,0.46,470,39274,70,NULL,NULL,'SDSS J122327.44+065858.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000174,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,185.864375,6.983,0,NULL,58237131856,909955185,14218049,18.4),(93066,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93066,30.74,0.14,14.1,39275,74.4,NULL,NULL,'NGC 4346',NULL,'2013AJ....146...86T',2013,1,3.3,NULL,'G',0.000017,NULL,'12.14',1.3,'SB0           LINER2','in a radial-velocity based grouping',NULL,NULL,NULL,1,185.866417,46.99383,0,NULL,59066226616,922909790,14420465,12.14),(93067,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93067,30.78,0.17,14.3,39275,NULL,NULL,'I','NGC 4346',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93068,'Tully est','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93068,31.15,0.8,17,39275,75,NULL,'B','NGC 4346',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93069,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93069,31.81,NULL,23,39276,NULL,NULL,NULL,'VCC 0641',NULL,'2014A&A...562A..49M',2014,1,0.4,NULL,'G',0.000033,NULL,'16.5',0.1,'BCD?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,185.8685,5.81642,0,NULL,58233737340,909902145,14217221,16.5),(93070,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93070,37.24,0.46,280,39277,70,NULL,NULL,'SDSS J122328.85+492950.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000143,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,185.87025,49.49744,0,NULL,57182900473,893482819,13960669,18.2),(93071,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93071,37.38,0.27,299,39278,70,NULL,NULL,'SDSS J122330.31+215144.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,185.8762917,21.86228,NULL,NULL,58866491774,919788933,14371702,18),(93072,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93072,38.64,0.46,535,39279,70,NULL,NULL,'SDSS J122330.33+044228.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,185.876417,4.70792,0,NULL,58003464139,906304127,14161001,18.4),(93073,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93073,38.15,0.46,426,39280,70,NULL,NULL,'2MASX J12233122+0941111',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000176,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,185.879917,9.68628,0,NULL,58243707754,910057933,14219655,17),(93074,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93074,38.24,0.46,444,39281,70,NULL,NULL,'2MASX J12233127+3813154',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,185.8805417,38.22111,0,NULL,58584322995,915380046,14302813,17.9),(93075,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93075,36.88,0.46,237,39282,70,NULL,NULL,'2MASX J12233183+1920328',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'16.70',0.19,NULL,NULL,NULL,NULL,NULL,1,185.8825,19.34225,0.12,NULL,58860326899,919692607,14370196,16.7),(93076,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93076,37.9,0.46,379,39283,70,NULL,NULL,'2MASX J12233268+0821411',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000182,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,185.886,8.36147,0,NULL,58235824434,909934756,14217730,16.7),(93077,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93077,37.5,0.46,316,39284,70,NULL,NULL,'LCRS B122058.6-030502',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00015,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,185.886125,-3.36075,0.097,NULL,42994686428,671791975,10496749,16.8),(93078,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93078,37.8,0.46,363,39285,70,NULL,NULL,'2MASX J12233369+4405429',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,185.890333,44.09533,0,NULL,59072007440,923000116,14421876,17.7),(93079,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93079,31.05,0.12,16.2,39286,74.4,NULL,NULL,'NGC 4339',NULL,'2013AJ....146...86T',2013,1,2.4,NULL,'G',0.000017,NULL,'12.26',2.3,'E0             Sy2','in a radial-velocity based grouping',NULL,NULL,NULL,1,185.895625,6.08175,0,NULL,58233891650,909904557,14217258,12.26),(93080,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93080,31.08,0.18,16.4,39286,NULL,NULL,'I','NGC 4339',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93081,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93081,31.08,0.18,16.4,39286,NULL,NULL,NULL,'NGC 4339',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93082,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93082,31.13,0.18,16.8,39286,NULL,NULL,'Malmquist cor.','NGC 4339',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93083,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93083,30.17,0.8,10.8,39286,95,NULL,'Weighted Mean','NGC 4339',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93084,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93084,30.17,0.8,10.8,39286,95,NULL,'de Vaucouleurs','NGC 4339',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93085,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93085,30.77,0.41,14.2,39286,NULL,NULL,NULL,'NGC 4339',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93086,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93086,31.03,0.41,16.1,39286,NULL,NULL,'Malmquist cor.','NGC 4339',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93087,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93087,31.05,0.12,16.2,39286,74.4,NULL,NULL,'NGC 4339',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93088,'Tertiary','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93088,30.59,0.2,13.1,39286,95,NULL,NULL,'NGC 4339',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93089,'Tully est','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93089,32.03,0.8,25.5,39286,75,NULL,'B','NGC 4339',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93090,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93090,31.61,0.45,21,39286,NULL,NULL,'K','NGC 4339',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93091,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93091,31.84,0.4,23.3,39286,NULL,NULL,'mean','NGC 4339',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93092,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93092,31.18,0.2,17.2,39287,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4340',NULL,'2007ApJS..171..101J',2007,1,3.5,NULL,'G',0.000017,NULL,'12.10',2.8,'SB(r)0+','in a radial-velocity based grouping',NULL,NULL,NULL,1,185.8970417,16.72236,0.026,NULL,58171024465,908922257,14201910,12.1),(93093,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93093,31.19,0.18,17.3,39287,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4340',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93094,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93094,31.45,0.21,19.5,39287,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4340',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93095,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93095,31.59,0.2,20.8,39287,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4340',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93096,'Ring Diameter','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93096,30.4,0.84,12,39287,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4340',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93097,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93097,29.24,0.85,7.05,39287,95,NULL,'de Vaucouleurs','NGC 4340',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93098,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93098,29.57,0.71,8.2,39287,95,NULL,'Weighted Mean','NGC 4340',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93099,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93099,31.4,1.61,19.1,39287,55,NULL,'Visvanathan & Sandage 1979','NGC 4340',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93100,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93100,30.83,NULL,14.7,39287,NULL,NULL,NULL,'NGC 4340',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93101,'Tertiary','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93101,30.49,0.25,12.5,39287,95,NULL,NULL,'NGC 4340',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93102,'Tully est','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93102,31.13,0.8,16.8,39287,75,NULL,'B','NGC 4340',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93103,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93103,31.32,0.4,18.4,39287,NULL,NULL,'mean','NGC 4340',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93104,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93104,31.48,0.45,19.8,39287,NULL,NULL,'K','NGC 4340',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93105,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93105,37.39,0.46,300,39288,70,NULL,NULL,'2MASX J12233733+2902027',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000139,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,185.905417,29.034,0.084,NULL,58628843795,916075684,14313682,18.1),(93106,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93106,36.62,0.46,211,39289,70,NULL,NULL,'VPC 0295',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,185.9059583,13.19511,0.15,NULL,58160726205,908761346,14199396,16.9),(93107,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93107,37.92,0.46,384,39290,70,NULL,NULL,'2MASX J12233834+4040314',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000141,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,185.9099583,40.67531,0,NULL,58530835397,914544303,14289754,18.1),(93108,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93108,31.59,0.4,20.8,39291,NULL,NULL,'mean','NGC 4343',NULL,'2007A&A...465...71T',2007,1,2.5,NULL,'G',0.000017,NULL,'13.3g',0.7,'SA(rs)b:;Sy    LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,185.91125,6.95408,0,NULL,58237185515,909956023,14218062,13.3),(93109,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93109,31.71,NULL,22,39291,NULL,NULL,NULL,'NGC 4343',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93110,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93110,32.14,NULL,26.8,39291,NULL,NULL,'B','NGC 4343',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93111,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93111,32.24,0.47,28.1,39291,NULL,NULL,'H','NGC 4343',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93112,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93112,32.27,0.45,28.4,39291,NULL,NULL,'K','NGC 4343',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93113,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93113,32.28,0.36,28.6,39291,NULL,NULL,NULL,'NGC 4343',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93114,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93114,32.29,0.46,28.7,39291,NULL,NULL,'J','NGC 4343',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93115,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93115,32.54,0.3,32.2,39291,55,NULL,'B','NGC 4343',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93116,'Tully est','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93116,31.13,0.8,16.8,39292,75,NULL,'B','NGC 4342',NULL,'1988NBGC.C....0000T',1988,1,1.3,'POSS-I E print shows star-like flaw on northeast side (Wei-Dong Li).','G',0.000017,NULL,'13.41',0.6,'S0-','in a radial-velocity based grouping',NULL,NULL,NULL,1,185.9125,7.054,0,NULL,58237178337,909955911,14218061,13.41),(93117,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93117,37.9,0.46,381,39293,70,NULL,NULL,'SDSS J122339.92+670027.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000072,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,185.916375,67.00772,0.009,NULL,57313136024,895517750,13992464,18.3),(93118,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93118,38.33,0.46,464,39294,70,NULL,NULL,'2MASX J12234049+5950240',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,185.9187083,59.83992,0,NULL,57340856828,895950887,13999232,18),(93119,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93119,35.12,0.49,106,39295,75,NULL,'IR','UGC 07464',NULL,'2011yCatp016004901K',2011,1,1.54,NULL,'G',0.00001,NULL,'14.6g',0.36,'Sb(f)','Group member',NULL,NULL,NULL,1,185.92325,2.96128,0,NULL,58004320569,906317508,14161211,14.6),(93120,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93120,35.35,0.37,117,39295,NULL,NULL,'Malmquist cor.','UGC 07464',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93121,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93121,35.42,0.2,121,39295,74.4,NULL,NULL,'UGC 07464',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93122,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93122,35.44,0.4,122,39295,NULL,NULL,'mean','UGC 07464',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93123,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93123,35.5,0.47,126,39295,NULL,NULL,'H','UGC 07464',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93124,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93124,35.54,0.34,128,39295,NULL,NULL,NULL,'UGC 07464',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93125,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93125,35.65,0.46,135,39295,NULL,NULL,'J','UGC 07464',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93126,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93126,35.68,0.45,137,39295,NULL,NULL,'K','UGC 07464',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93127,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93127,38.09,0.46,416,39296,70,NULL,NULL,'SDSS J122343.33+054452.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,185.930541667,5.74786,0,NULL,58233740096,909902189,14217221,17.7),(93128,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93128,36.09,0.46,166,39297,70,NULL,NULL,'LCRS B122109.4-022628',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000096,NULL,'16.8g',0.26,'NLAGN',NULL,NULL,NULL,NULL,1,185.930625,-2.71817,0.077,NULL,42995861627,671810337,10497036,16.8),(93129,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93129,30.54,0.36,12.8,39298,NULL,NULL,NULL,'IC 3258',NULL,'2009AJ....138..323T',2009,1,1.6,'Multiple SDSS entries describe this object.','G',0.000013,NULL,'13.57',1.4,'IB(s)m pec:;WR HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,185.9352917,12.47833,0.075,NULL,58158761698,908730651,14198916,13.57),(93130,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93130,31.13,0.4,16.8,39298,75,NULL,'B','IC 3258',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93131,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93131,38.75,0.46,561,39299,70,NULL,NULL,'2MASX J12234512+1702250',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,185.9379583,17.04031,0.025,NULL,58170817452,908919022,14201859,17.2),(93132,'IRAS','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93132,32.66,0.8,34.1,39300,75,NULL,'MAT, I','IC 3253',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.000023,NULL,'12.57',1.1,'SA(s)c:        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,185.938417,-34.62219,0.221,NULL,43260349058,675942954,10561608,12.57),(93133,'Sosies','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93133,32.27,0.15,28.4,39300,NULL,NULL,NULL,'IC 3253',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93134,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93134,32.57,0.46,32.6,39300,NULL,NULL,'J','IC 3253',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93135,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93135,32.59,0.47,33,39300,NULL,NULL,'H','IC 3253',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93136,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93136,32.64,0.45,33.7,39300,NULL,NULL,'K','IC 3253',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93137,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93137,32.84,0.4,37,39300,75,NULL,'B','IC 3253',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93138,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93138,32.94,0.4,38.7,39300,NULL,NULL,'mean','IC 3253',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93139,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93139,34.16,0.32,67.8,39300,85,NULL,'I, raw','IC 3253',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93140,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93140,34.17,0.43,68.3,39300,75,NULL,'MAT, I, raw','IC 3253',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93141,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93141,34.2,0.32,69.1,39300,85,NULL,'I, inv','IC 3253',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93142,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93142,34.37,0.43,74.8,39300,75,NULL,'MAT, I, inv','IC 3253',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93143,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93143,34.47,0.43,78.2,39300,75,NULL,'MAT, I, cor','IC 3253',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93144,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93144,37.02,0.33,254,39301,70,NULL,NULL,'2MASX J12234762+2007298',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.19',0.12,NULL,NULL,NULL,NULL,NULL,1,185.948417,20.12494,0.113,NULL,58859737075,919683391,14370052,18.19),(93145,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93145,37.41,0.27,304,39302,70,NULL,NULL,'2MASX J12234781+0248276',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000218,NULL,'16.1g',0.38,'BrClG',NULL,NULL,NULL,NULL,1,185.949291667,2.80744,0,NULL,58011453406,906428959,14162952,16.1),(93146,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93146,31.1,0.43,16.6,39303,75,NULL,'3.6 micron, color + selection bias corrected','IC 3259',NULL,'2014MNRAS.444..527S',2014,1,1.82,'CGCG misprints R.A. as 12h21.2m; corrected in CGCG errata in vol III.','G',0.000009,NULL,'14.2g',0.79,'SAB(s)dm?      HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,185.952166667,7.18683,0,NULL,58236107008,909939172,14217799,14.2),(93147,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93147,31.22,0.43,17.5,39303,75,NULL,'3.6 micron, color corrected','IC 3259',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93148,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93148,31.32,0.2,18.4,39303,74.4,NULL,NULL,'IC 3259',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93149,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93149,31.63,0.51,21.2,39303,NULL,NULL,NULL,'IC 3259',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93150,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93150,31.64,0.51,21.3,39303,NULL,NULL,'Malmquist cor.','IC 3259',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93151,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93151,38.34,0.33,466,39304,70,NULL,NULL,'SDSS J122349.21+071743.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000193,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,185.955083,7.29544,0,NULL,58236323463,909942554,14217852,18.2),(93152,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93152,36.41,0.46,191,39305,70,NULL,NULL,'2MASX J12234964+5939029',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,185.956833,59.65081,0,NULL,57342698310,895979661,13999682,17.1),(93153,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93153,38.11,0.46,418,39306,70,NULL,NULL,'SDSS J122350.78+184902.9',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,185.961625,18.8175,0.099,NULL,58860277979,919691843,14370185,18),(93154,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93154,37.23,0.46,279,39307,70,NULL,NULL,'2MASX J12235120+1827598',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.66',0.17,NULL,NULL,NULL,NULL,NULL,1,185.963291667,18.46672,0.051,NULL,58858981703,919671589,14369868,17.66),(93155,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93155,35.28,0.15,114,39308,70,NULL,NULL,'2MASX J12235156+0907491',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000175,NULL,'15.9g',0.32,'S0^-',NULL,NULL,NULL,NULL,1,185.9650417,9.13039,0,NULL,58244065583,910063524,14219742,15.9),(93156,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93156,38.07,0.46,412,39309,70,NULL,NULL,'2MASX J12235207+5210454',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,185.966875,52.17939,0.015,NULL,57242784439,894418506,13975289,17.3),(93157,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93157,37.98,0.33,394,39310,70,NULL,NULL,'SDSS J122352.28+033136.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000144,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,185.967875,3.52689,0.008,NULL,58004966936,906327608,14161368,17.8),(93158,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93158,38.01,0.46,400,39311,70,NULL,NULL,'VPC 0314',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,185.971958333,13.46611,0.159,NULL,58160712598,908761134,14199392,17.4),(93159,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93159,35.18,0.74,109,39312,70,NULL,NULL,'2MASX J12235285-2123485',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000103,NULL,'15.71',0.5,NULL,NULL,NULL,NULL,NULL,1,185.97225,-21.40044,0.129,NULL,43895130900,685861420,10716584,15.71),(93160,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93160,37.41,0.27,304,39313,70,NULL,NULL,'SDSS J122353.78+024817.3',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,185.974083,2.80481,0,NULL,58011455150,906428986,14162952,17.4),(93161,'IRAS','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93161,32.47,0.8,31.2,39314,75,NULL,'MAT, I','NGC 4348',NULL,'1997ApJS..109..333W',1997,1,3.05,NULL,'G',0.000027,NULL,'13.2g',0.64,'SAbc: sp','Isolated galaxy',NULL,NULL,NULL,1,185.9749583,-3.44292,0.101,NULL,42994653722,671791464,10496741,13.2),(93162,'Tully est','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93162,32.64,0.8,33.8,39314,75,NULL,'B','NGC 4348',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93163,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93163,32.21,0.46,27.7,39314,NULL,NULL,'J','NGC 4348',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93164,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93164,32.25,0.4,28.2,39314,75,NULL,NULL,'NGC 4348',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93165,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93165,32.26,0.47,28.3,39314,NULL,NULL,'H','NGC 4348',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93166,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93166,32.29,0.45,28.8,39314,NULL,NULL,'K','NGC 4348',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93167,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93167,32.36,0.32,29.7,39314,85,NULL,'I, raw','NGC 4348',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93168,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93168,32.38,0.4,30,39314,NULL,NULL,'mean','NGC 4348',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93169,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93169,32.41,0.32,30.3,39314,85,NULL,'I, inv','NGC 4348',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93170,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93170,32.42,0.4,30.5,39314,NULL,NULL,NULL,'NGC 4348',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93171,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93171,32.45,0.43,30.9,39314,75,NULL,'MAT, I, raw','NGC 4348',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93172,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93172,32.54,0.43,32.3,39314,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4348',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93173,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93173,32.58,0.43,32.8,39314,75,NULL,'3.6 micron, color corrected','NGC 4348',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93174,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93174,32.61,0.43,33.3,39314,75,NULL,'MAT, I, cor','NGC 4348',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93175,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93175,32.62,0.49,33.4,39314,75,NULL,'IR','NGC 4348',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93176,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93176,32.66,0.43,34,39314,75,NULL,'MAT, I, inv','NGC 4348',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93177,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93177,32.73,0.2,35.2,39314,74.4,NULL,NULL,'NGC 4348',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93178,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93178,32.85,0.42,37.2,39314,NULL,NULL,'Malmquist cor.','NGC 4348',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93179,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93179,33,0.39,39.7,39314,NULL,NULL,NULL,'NGC 4348',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93180,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93180,33.01,0.3,40,39314,55,NULL,'B','NGC 4348',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93181,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93181,37.28,0.46,286,39315,70,NULL,NULL,'2MASX J12235435+0855438',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000178,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,185.9765417,8.92886,0,NULL,58243329405,910052021,14219562,17),(93182,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93182,37.05,0.46,257,39316,70,NULL,NULL,'2MASX J12235484+4202055',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000179,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,185.978333,42.03486,0,NULL,59062591977,922852999,14419578,16.5),(93183,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93183,37.98,0.33,394,39317,70,NULL,NULL,'2MASX J12235609+0331256',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,185.983666667,3.52372,0.008,NULL,58004963831,906327559,14161368,17.2),(93184,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93184,37.39,0.46,300,39318,70,NULL,NULL,'LCRS B122122.5-025025',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,185.985625,-3.11722,0.073,NULL,42993911686,671779870,10496560,17.4),(93185,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93185,34.11,0.89,66.3,39319,NULL,NULL,'Malmquist cor.','ESO 322- G 003',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.48',0.6,'Sb:',NULL,NULL,NULL,NULL,1,185.989583,-40.27081,0.377,NULL,43225986243,675406035,10553219,15.48),(93186,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93186,34.44,0.76,77.2,39319,NULL,NULL,NULL,'ESO 322- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93187,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93187,34.48,0.2,78.7,39319,74.4,NULL,NULL,'ESO 322- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93188,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93188,30.84,0.12,14.7,39320,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4350',NULL,'2010ApJ...717..603V',2010,1,3,NULL,'G',0.000017,NULL,'11.94',1.4,'SA0            LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,185.991125,16.69342,0.026,NULL,58170950453,908921100,14201892,11.94),(93189,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93189,30.89,0.14,15.1,39320,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4350',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93190,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93190,30.98,0.13,15.7,39320,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4350',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93191,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93191,31.09,0.12,16.5,39320,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4350',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93192,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93192,31.11,0.43,16.7,39320,95,NULL,'Weighted Mean','NGC 4350',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93193,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93193,31.45,0.57,19.5,39320,95,NULL,'de Vaucouleurs','NGC 4350',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93194,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93194,31.8,0.81,22.9,39320,55,NULL,'Visvanathan & Sandage 1979','NGC 4350',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93195,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93195,30.86,NULL,14.9,39320,NULL,NULL,NULL,'NGC 4350',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93196,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93196,31.54,0.25,20.3,39320,74.4,NULL,NULL,'NGC 4350',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93197,'Tertiary','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93197,30.49,0.25,12.5,39320,95,NULL,NULL,'NGC 4350',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93198,'Tully est','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93198,31.13,0.8,16.8,39320,75,NULL,'B','NGC 4350',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93199,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93199,30.61,0.45,13.2,39320,NULL,NULL,'K','NGC 4350',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93200,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93200,31.62,0.4,21.1,39320,NULL,NULL,'mean','NGC 4350',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93201,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93201,38.34,0.33,466,39321,70,NULL,NULL,'2MASX J12235786+0724298',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000192,NULL,'16.8g',0.33,NULL,NULL,NULL,NULL,NULL,1,185.991083,7.40828,0,NULL,58236278120,909941845,14217841,16.8),(93202,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93202,35.28,0.15,114,39322,70,NULL,NULL,'2MASX J12235785+0915108',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000157,NULL,'15.6g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,185.991125,9.25311,0,NULL,58244043591,910063181,14219737,15.6),(93203,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93203,36.86,0.46,236,39323,70,NULL,NULL,'2MASX J12235837+0629588',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.78',0.16,NULL,NULL,NULL,NULL,NULL,1,185.993375,6.49981,0,NULL,58234453617,909913337,14217395,17.78),(93204,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93204,33.74,0.44,56,39324,NULL,NULL,NULL,'NGC 4357',NULL,'2009ApJS..182..474S',2009,1,3.6,NULL,'G',0.00002,NULL,'13.20',1.3,'SAbc','Isolated galaxy',NULL,NULL,NULL,1,185.995083,48.77947,0,NULL,57184996191,893515565,13961180,13.2),(93205,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93205,33.75,0.43,56.2,39324,NULL,NULL,'Malmquist cor.','NGC 4357',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93206,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93206,33.77,0.46,56.7,39324,NULL,NULL,'J','NGC 4357',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93207,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93207,33.78,0.2,57,39324,74.4,NULL,NULL,'NGC 4357',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93208,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93208,33.82,0.47,58,39324,NULL,NULL,'H','NGC 4357',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93209,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93209,33.88,0.4,59.6,39324,NULL,NULL,'mean','NGC 4357',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93210,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93210,33.91,0.45,60.4,39324,NULL,NULL,'K','NGC 4357',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93211,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93211,37.62,0.46,334,39325,70,NULL,NULL,'2MASX J12235931+1247220',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000204,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,185.99725,12.78953,0.132,NULL,58161640831,908775637,14199619,18.1),(93212,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93212,32.28,0.36,28.6,39326,NULL,NULL,NULL,'NGC 4353',NULL,'2009AJ....138..323T',2009,1,1.05,'2MASS position is on western edge.','G',0.000033,NULL,'14.1g',0.74,'IBm:           HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,186.001083333,7.78519,0,NULL,58236771427,909949553,14217961,14.1),(93213,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93213,32.58,0.49,32.9,39326,75,NULL,'IR','NGC 4353',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93214,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93214,30.48,NULL,12.5,39327,NULL,NULL,NULL,'NGC 4351',NULL,'1999MNRAS.304..595G',1999,1,1.86,NULL,'G',0.000006,NULL,'13.2g',1.23,'SB(rs)ab pec:  HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.00625,12.20478,0.014,NULL,58158869033,908732328,14198942,13.2),(93215,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93215,31.13,0.4,16.8,39327,75,NULL,'B','NGC 4351',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93216,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93216,31.5,0.1,20,39327,NULL,NULL,'stellar kinematics','NGC 4351',NULL,'2008ApJ...683...78C',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93217,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93217,31.67,0.69,21.5,39327,100,NULL,'mid-IR','NGC 4351',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93218,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93218,32.35,0.47,29.5,39327,NULL,NULL,'H','NGC 4351',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93219,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93219,32.5,0.46,31.6,39327,NULL,NULL,'J','NGC 4351',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93220,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93220,32.63,0.45,33.6,39327,NULL,NULL,'K','NGC 4351',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93221,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93221,32.74,0.4,35.4,39327,NULL,NULL,'mean','NGC 4351',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93222,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93222,37.87,0.21,376,39328,70,NULL,NULL,'2MASXi J1224015+663416',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00008,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,186.007125,66.57128,0.033,NULL,57313248692,895519510,13992492,17.7),(93223,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93223,38.3,0.46,457,39329,70,NULL,NULL,'2MASX J12240177+0211076',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000185,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,186.0074583,2.18558,0.034,NULL,58009488289,906398254,14162472,16.9),(93224,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93224,34.33,0.46,73.3,39330,70,NULL,NULL,'NGC 4358',NULL,'2015arXiv151105856S',2015,1,1.09,'Incorrectly identified as NGC 4364 in MCG and UGC.','G',0.00013,NULL,'14.0g',0.93,'S0','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,186.008417,58.38522,0,NULL,57404300169,896942190,14014721,14),(93225,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93225,38.59,0.46,522,39331,70,NULL,NULL,'2MASX J12240252+1558420',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,186.0104583,15.97833,0.041,NULL,58154320748,908661261,14197832,18.1),(93226,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93226,37.73,0.33,352,39332,70,NULL,NULL,'2MASX J12240271+4258416',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000181,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,186.011417,42.97811,0,NULL,59062791088,922856110,14419626,17.4),(93227,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93227,37.87,0.21,376,39333,70,NULL,NULL,'2MASX J12240376+6642038',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000079,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,186.0154583,66.70117,0.033,NULL,57313279049,895519985,13992499,17.6),(93228,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93228,37.06,0.46,258,39334,70,NULL,NULL,'2MASX J12240412+3354371',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000193,NULL,'15.8g',0.42,NULL,NULL,NULL,NULL,NULL,1,186.016916667,33.91011,0.006,NULL,58766036199,918219315,14347176,15.8),(93229,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93229,36.87,0.46,236,39335,70,NULL,NULL,'2MASX J12240464+0740378',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'17.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,186.019375,7.67717,0,NULL,58236783642,909949744,14217964,17.1),(93230,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93230,37.37,0.46,298,39336,70,NULL,NULL,'2MASX J12240477+4001411',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000158,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,186.020041667,40.02817,0,NULL,58577130170,915267658,14301057,17.6),(93231,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93231,30.99,0.09,15.8,39337,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4352',NULL,'2010ApJ...717..603V',2010,1,1.43,NULL,'G',0.000023,NULL,'13.3g',0.83,'SA0: sp','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.020917,11.21806,0.024,NULL,58242159434,910033741,14219277,13.3),(93232,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93232,30.99,0.1,15.8,39337,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4352',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93233,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93233,31.2,0.09,17.4,39337,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4352',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93234,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93234,31.31,0.09,18.3,39337,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4352',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93235,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93235,31.32,0.14,18.4,39337,74.4,NULL,NULL,'NGC 4352',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93236,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93236,31.34,0.07,18.5,39337,NULL,NULL,'HST ACS VCS','NGC 4352',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93237,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93237,31.36,0.05,18.7,39337,NULL,NULL,NULL,'NGC 4352',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93238,'GC radius','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93238,30.64,0.1,13.4,39337,NULL,NULL,NULL,'NGC 4352',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93239,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93239,31.49,0.45,19.8,39337,NULL,NULL,'K','NGC 4352',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93240,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93240,32.65,0.4,33.9,39337,NULL,NULL,'mean','NGC 4352',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93241,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93241,36.45,0.81,195,39338,70,NULL,NULL,'2MASX J12240507-5002331',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,186.0212083,-50.04256,0.769,NULL,44616843601,697138181,10892784,17.4),(93242,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93242,36.16,0.46,171,39339,70,NULL,NULL,'2MASX J12240523+2818320',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00018,NULL,'15.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,186.0217917,28.30892,0.066,NULL,58637168167,916205752,14315714,15.9),(93243,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93243,37.76,0.46,357,39340,70,NULL,NULL,'VPC 0333',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,186.021875,14.88708,0.034,NULL,58155927116,908686361,14198224,17.5),(93244,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93244,37.64,0.46,337,39341,70,NULL,NULL,'2MASX J12240561+6532237',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000152,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,186.023083,65.53989,0.021,NULL,57327328511,895739507,13995929,18.3),(93245,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93245,38.08,0.33,413,39342,70,NULL,NULL,'2MASX J12240606+4905575',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00015,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,186.02525,49.09933,0,NULL,57182656317,893479004,13960609,17.2),(93246,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93246,37.07,0.46,260,39343,70,NULL,NULL,'2MASX J12240610+0051476',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00007,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,186.0255417,0.86322,0.027,NULL,58007929614,906373900,14162092,17.3),(93247,'Tully est','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93247,31.69,0.8,21.8,39344,75,NULL,'B','IC 3268',NULL,'1988NBGC.C....0000T',1988,1,0.84,'HOLM 392B is a star.','G',0.000023,NULL,'14.2g',0.7,'IAm V          HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.031,6.60747,0,NULL,58234465559,909913524,14217398,14.2),(93248,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93248,35.73,0.49,140,39345,75,NULL,'IR','FGC 1426',NULL,'2011yCatp016004901K',2011,1,1.09,NULL,'G',0.000172,NULL,'16.2g',0.18,'Scd',NULL,NULL,NULL,NULL,1,186.030667,45.43447,0,NULL,59072287408,923004490,14421945,16.2),(93249,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93249,35.96,NULL,156,39345,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1426',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93250,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93250,35.98,NULL,157,39345,NULL,NULL,'Dipole + Quadrupole','FGC 1426',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93251,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93251,36,NULL,159,39345,NULL,NULL,'Dipole','FGC 1426',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93252,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93252,36,NULL,159,39345,NULL,NULL,NULL,'FGC 1426',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93253,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93253,36.55,0.46,204,39346,70,NULL,NULL,'2MASX J12240770+5626383',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,186.032167,56.44406,0,NULL,57410144264,897033504,14016148,17.1),(93254,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93254,35.28,0.15,114,39347,70,NULL,NULL,'VCC 0700',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000087,NULL,'15.1g',0.54,'S0_1_(0)','Group member',NULL,NULL,NULL,1,186.032333333,9.38369,0,NULL,58243884775,910060699,14219698,15.1),(93255,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93255,37.41,0.27,304,39348,70,NULL,NULL,'2MASX J12240794+0251516',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,186.033167,2.86419,0,NULL,58004180900,906315326,14161176,17.6),(93256,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93256,38.16,0.46,430,39349,70,NULL,NULL,'SDSS J122408.28+262419.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000157,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,186.0345417,26.40539,0.028,NULL,58650211463,916409554,14318899,18.7),(93257,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93257,37.32,0.46,291,39350,70,NULL,NULL,'VPC 0336',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,186.0377083,13.18997,0.15,NULL,58160733498,908761460,14199397,17.7),(93258,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93258,36.03,0.46,161,39351,70,NULL,NULL,'2MASX J12240943+2028041',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.46',0.22,NULL,NULL,NULL,NULL,NULL,1,186.0392083,20.46786,0.112,NULL,58865007008,919765734,14371339,17.46),(93259,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93259,37.96,0.46,391,39352,70,NULL,NULL,'SDSS J122409.42+011336.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000081,NULL,'18.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,186.03925,1.22678,0,NULL,58010881323,906420020,14162812,18.1),(93260,'IRAS','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93260,31.81,0.8,23,39353,75,NULL,'A82, H','NGC 4359',NULL,'1997ApJS..109..333W',1997,1,2.57,NULL,'G',0.000037,NULL,'13.6g',0.8,'SB(rs)c? sp','Possible group member',NULL,NULL,NULL,1,186.0465417,31.52194,0.025,NULL,58759516749,918117449,14345585,13.6),(93261,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93261,29.93,0.4,9.7,39353,75,NULL,'B','NGC 4359',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93262,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93262,30.76,0.4,14.2,39353,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 4359',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93263,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93263,31.1,0.47,16.6,39353,75,NULL,'A82, H, inv','NGC 4359',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93264,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93264,31.2,0.47,17.4,39353,75,NULL,'A82, H, raw','NGC 4359',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93265,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93265,31.39,0.47,18.9,39353,75,NULL,'A82, H, cor','NGC 4359',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93266,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93266,31.49,0.4,19.9,39353,75,NULL,NULL,'NGC 4359',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93267,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93267,31.95,0.49,24.5,39353,75,NULL,'IR','NGC 4359',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93268,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93268,37.8,0.46,362,39354,70,NULL,NULL,'SDSS J122412.11+172435.9',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.7g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,186.050458333,17.40997,0.034,NULL,58858684930,919666952,14369796,17.7),(93269,'Tully est','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93269,32.56,0.8,32.6,39355,75,NULL,NULL,'DDO 121',NULL,'1988NBGC.C....0000T',1988,1,1.7,'Confused HIPASS source','G',0.00002,NULL,'16.13',1.3,'IB(s)m:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,186.051875,0.56717,0.03,NULL,58008253244,906378956,14162171,16.13),(93270,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93270,37.62,0.46,334,39356,70,NULL,NULL,'IC 3276',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,186.05875,25.81878,0.051,NULL,58646788955,916356077,14318063,NULL),(93271,'Tully est','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93271,31.77,0.8,22.6,39357,75,NULL,'B','UGCA 279',NULL,'1988NBGC.C....0000T',1988,1,0.8,NULL,'G',0.000033,NULL,'15.38',0.3,'dSO','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,186.0605,4.22594,0,NULL,58006848185,906357002,14161828,15.38),(93272,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93272,30.96,0.43,15.5,39358,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4356',NULL,'2014MNRAS.444..527S',2014,1,3.14,NULL,'G',0.000023,NULL,'14.02',0.39,'Sc;LINER       HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.0605417,8.53586,0,NULL,58247382854,910115357,14220552,14.02),(93273,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93273,31.04,0.43,16.2,39358,75,NULL,'3.6 micron, color corrected','NGC 4356',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93274,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93274,31.12,0.2,16.8,39358,74.4,NULL,NULL,'NGC 4356',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93275,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93275,31.58,0.49,20.7,39358,75,NULL,'IR','NGC 4356',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93276,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93276,32.18,NULL,27.3,39358,NULL,NULL,NULL,'NGC 4356',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93277,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93277,32.33,NULL,29.2,39358,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 4356',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93278,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93278,32.34,NULL,29.3,39358,NULL,NULL,'Dipole + Quadrupole','NGC 4356',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93279,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93279,32.34,NULL,29.3,39358,NULL,NULL,'Dipole','NGC 4356',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93280,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93280,35.28,0.15,114,39359,70,NULL,NULL,'NGC 4360B',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000087,NULL,'14.7g',0.62,'S0?','Group member',NULL,NULL,NULL,1,186.061333,9.26686,0,NULL,58243762223,910058784,14219668,14.7),(93281,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93281,37.77,0.46,358,39360,70,NULL,NULL,'2MASX J12241606+3507168',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000154,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,186.0670417,35.12144,0.022,NULL,58540904486,914701632,14292213,17.3),(93282,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93282,38.01,0.46,400,39361,70,NULL,NULL,'SDSS J122416.42+100323.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,186.0684583,10.05664,0,NULL,58242399180,910037487,14219335,18.2),(93283,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93283,37.96,0.46,392,39362,70,NULL,NULL,'VPC 0340',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,186.068708333,11.01244,0.029,NULL,58242323969,910036312,14219317,17.2),(93284,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93284,38.14,0.46,425,39363,70,NULL,NULL,'LCRS B122142.6-023937',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000137,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,186.069333333,-2.93706,0.073,NULL,42993866573,671779165,10496549,17.5),(93285,'Tully est','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93285,31.03,0.8,16.1,39364,75,NULL,'B','UGCA 280',NULL,'1988NBGC.C....0000T',1988,1,0.68,NULL,'G',0.000013,NULL,'15.0g',0.55,'BlueCG;HII     Sbrst','Group member, radial-velocity confirmed',NULL,NULL,'Starburst',1,186.0710417,67.43997,0.009,NULL,57849906537,903904789,14123512,15),(93286,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93286,37.02,0.33,254,39365,70,NULL,NULL,'MCG +04-29-069 NED03',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,186.072041667,20.28083,0.112,NULL,58867119009,919798734,14371855,16.5),(93287,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93287,37.38,0.46,300,39366,70,NULL,NULL,'2MASX J12241757+2557053',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,186.073167,25.95161,0.051,NULL,58645880516,916341883,14317841,17.1),(93288,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93288,39.13,0.46,668,39367,70,NULL,NULL,'SDSS J122417.73+422211.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00014,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,186.073875,42.36975,0,NULL,59062483934,922851311,14419551,18.6),(93289,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93289,35.25,0.46,112,39368,70,NULL,NULL,'2MASX J12241837+0149107',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,186.0765,1.81969,0.01,NULL,58010333738,906411464,14162679,16.5),(93290,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93290,38.08,0.33,413,39369,70,NULL,NULL,'2MASX J12241859+4905495',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'16.9g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,186.077417,49.09719,0,NULL,57182654964,893478983,13960609,16.9),(93291,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93291,37.7,0.46,346,39370,70,NULL,NULL,'2MASX J12242128+0358187',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,186.088625,3.97208,0.024,NULL,58006941820,906358465,14161851,17.2),(93292,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93292,36.14,0.46,169,39371,70,NULL,NULL,'MRK 1473',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000221,NULL,'15.0g',0.65,'Compact',NULL,NULL,NULL,NULL,1,186.088833,60.11142,0,NULL,57333286507,895832601,13997384,15),(93293,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93293,37.77,0.46,359,39372,70,NULL,NULL,'SDSS J122422.90+172432.9',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'18.43',0.07,NULL,NULL,NULL,NULL,NULL,1,186.0954583,17.40917,0.026,NULL,58913230101,920519220,14383112,18.43),(93294,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93294,37.34,0.15,294,39373,70,NULL,NULL,'SDSS J122423.03+612748.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000171,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,186.095958333,61.46342,0,NULL,57370762332,896418161,14006533,18),(93295,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93295,37.87,0.21,376,39374,70,NULL,NULL,'2MASX J12242405+6634590',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000073,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,186.100333,66.58297,0.033,NULL,57313251262,895519550,13992492,17.6),(93296,'BL Lac Luminosity','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93296,40.13,NULL,872,39375,NULL,NULL,NULL,'FBQS J122424.1+243623',0.218,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.003,NULL,'17.65',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,186.100833,24.60656,0.073,NULL,58645124230,916330066,14317657,17.65),(93297,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93297,37.26,0.46,282,39376,70,NULL,NULL,'CGPG 1222.0+6418',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000181,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,186.102041667,64.03817,0.005,NULL,57316235903,895566185,13993221,16.3),(93298,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93298,38.1,0.46,417,39377,70,NULL,NULL,'SDSS J122424.68+255031.0',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,186.102833,25.84194,0.051,NULL,58646763185,916355674,14318057,NULL),(93299,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93299,37.55,0.27,324,39378,70,NULL,NULL,'2MASX J12242489+3301108',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000206,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,186.103583,33.01961,NULL,NULL,58764972816,918202700,14346917,16.9),(93300,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93300,30.22,0.4,11.1,39379,75,NULL,'B','UGC 07490',NULL,'1988NBGC.C....0000T',1988,1,3.3,NULL,'G',0.000017,NULL,'13.05',3.3,'SAm','Dwarf, possible member',NULL,NULL,NULL,1,186.105417,70.33361,0,NULL,56990718764,890479980,13913749,13.05),(93301,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93301,37.77,0.33,358,39380,70,NULL,NULL,'2MASX J12242547+5544183',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,186.106375,55.73831,0,NULL,57401360652,896896260,14014004,17.8),(93302,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93302,35.06,0.57,103,39381,70,NULL,NULL,'2MASX J12242586-1733031',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,186.1077083,-17.55086,0.037,NULL,43943836138,686622439,10728475,15.3),(93303,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93303,37.34,0.15,294,39382,70,NULL,NULL,'2MASX J12242622+6131488',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000167,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,186.109125,61.53025,0,NULL,57370982172,896421596,14006587,16.3),(93304,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93304,38,0.46,399,39383,70,NULL,NULL,'2MASX J12242677+3149338',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000164,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,186.1115417,31.82606,0.024,NULL,58766989932,918234217,14347409,17.4),(93305,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93305,34.89,0.65,94.9,39384,NULL,NULL,'Malmquist cor.','UGC 07487',NULL,'2009ApJS..182..474S',2009,1,0.88,NULL,'G',0.000017,NULL,'14.8g',0.72,'(R)SA(s)b      NLAGN',NULL,NULL,NULL,NULL,1,186.113833,0.15289,0.036,NULL,58007351119,906364861,14161950,14.8),(93306,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93306,35.2,0.56,110,39384,NULL,NULL,NULL,'UGC 07487',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93307,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93307,35.24,0.2,112,39384,74.4,NULL,NULL,'UGC 07487',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93308,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93308,36.84,0.17,234,39385,70,NULL,NULL,'2MASX J12242793+3202198',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00013,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,186.116375,32.03875,0.026,NULL,58767296818,918239012,14347484,16.5),(93309,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93309,37.72,0.27,351,39386,70,NULL,NULL,'VPC 0343',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,186.1172917,13.93267,0.108,NULL,58160360758,908755636,14199306,17),(93310,'Cepheids','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93310,31.86,0.15,23.6,39387,NULL,NULL,'HST KP Calibrated, K\'','NGC 4365',NULL,'2000ApJ...529..745F',2000,1,6.9,NULL,'G',0.000017,NULL,'10.52',5,'E3','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.117833333,7.31767,0,NULL,58236166079,909940094,14217813,10.52),(93311,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93311,31.18,0.14,17.2,39387,NULL,NULL,'blue GCs, TOM(V) = -7.17 mag','NGC 4365',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93312,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93312,31.3,0.2,18.2,39387,NULL,NULL,'TOM(V) = -7.3 mag','NGC 4365',NULL,'2009ApJ...690..512H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93313,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93313,31.54,0.06,20.3,39387,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4365',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93314,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93314,31.6,0.3,20.9,39387,NULL,NULL,NULL,'NGC 4365',NULL,'1996AJ....112..954F',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93315,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93315,31.6,0.06,20.9,39387,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4365',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93316,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93316,31.61,0.06,21,39387,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4365',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93317,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93317,31.68,0.17,21.7,39387,NULL,NULL,NULL,'NGC 4365',NULL,'2001AJ....121.2950K',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93318,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93318,31.7,0.06,21.9,39387,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4365',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93319,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93319,31.8,0.27,22.9,39387,NULL,NULL,NULL,'NGC 4365',NULL,'1993AJ....105.1358S',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93320,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93320,31.8,0.39,22.9,39387,NULL,NULL,'HST KP Calibrated, V','NGC 4365',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93321,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93321,31.96,0.14,24.7,39387,NULL,NULL,'B','NGC 4365',NULL,'1991ApJS...76..115H',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93322,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93322,32,0.16,25.1,39387,NULL,NULL,'all GCs, TOM(V) = -7.63 mag','NGC 4365',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93323,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93323,32.08,0.2,26.1,39387,NULL,NULL,'TOM(V) = -7.62 mag, Gaussian','NGC 4365',NULL,'1995ApJ...446....1S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93324,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93324,32.24,0.36,28.1,39387,NULL,NULL,'TOM(V) = -7.62 mag, t5 function','NGC 4365',NULL,'1995ApJ...446....1S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93325,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93325,32.31,0.68,29,39387,NULL,NULL,'HST KP Calibrated, B','NGC 4365',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93326,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93326,32.31,NULL,29,39387,NULL,NULL,'TOM(B) = -7.0 mag','NGC 4365',NULL,'1988ASPC....4..231H',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93327,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93327,32.38,0.23,29.9,39387,NULL,NULL,'red GCs, TOM(V) = -7.55 mag','NGC 4365',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93328,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93328,31.14,0.16,16.9,39387,NULL,NULL,'HST KP Calibrated, Ks','NGC 4365',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93329,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93329,31.55,0.17,20.4,39387,NULL,NULL,'I','NGC 4365',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93330,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93330,31.55,0.17,20.4,39387,NULL,NULL,NULL,'NGC 4365',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93331,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93331,31.57,0.17,20.6,39387,NULL,NULL,'Malmquist cor.','NGC 4365',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93332,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93332,31.61,0.19,21,39387,NULL,NULL,'HST KP Calibrated, I','NGC 4365',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93333,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93333,31.7,0.09,21.9,39387,NULL,NULL,'I','NGC 4365',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93334,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93334,31.7,0.11,21.9,39387,NULL,NULL,'K','NGC 4365',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93335,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93335,31.71,0.1,22,39387,NULL,NULL,'K','NGC 4365',NULL,'1996ApJ...468..519J',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93336,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93336,31.71,0.1,22,39387,NULL,NULL,'K','NGC 4365',NULL,'1994ApJ...433..567P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93337,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93337,31.79,0.12,22.8,39387,74.4,NULL,NULL,'NGC 4365',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93338,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93338,31.8,0.2,22.9,39387,NULL,NULL,'I','NGC 4365',NULL,'1993A&A...275..433B',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93339,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93339,31.82,0.07,23.1,39387,NULL,NULL,'HST ACS VCS','NGC 4365',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93340,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93340,31.84,0.06,23.3,39387,NULL,NULL,NULL,'NGC 4365',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93341,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93341,31.94,0.16,24.4,39387,NULL,NULL,'I','NGC 4365',NULL,'1990AJ....100.1416T',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93342,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93342,31.94,0.15,24.4,39387,NULL,NULL,'I','NGC 4365',NULL,'2000ApJ...536..255N',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93343,'GC radius','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93343,31.69,0.04,21.8,39387,NULL,NULL,NULL,'NGC 4365',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93344,'D-Sigma','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93344,31.13,0.4,16.8,39387,75,NULL,'Edat, raw','NGC 4365',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93345,'D-Sigma','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93345,31.15,0.4,17,39387,75,NULL,'Edat, cor','NGC 4365',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93346,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93346,30.77,0.45,14.3,39387,95,NULL,'de Vaucouleurs','NGC 4365',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93347,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93347,30.88,0.31,15,39387,95,NULL,'Weighted Mean','NGC 4365',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93348,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93348,31.14,0.63,16.9,39387,95,NULL,'Michard 1979b, c','NGC 4365',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93349,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93349,31.18,0.46,17.2,39387,95,NULL,'Michard 1979a','NGC 4365',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93350,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93350,31.27,NULL,17.9,39387,NULL,NULL,'LEDA [April 2006]','NGC 4365',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93351,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93351,32.44,1.61,30.8,39387,55,NULL,'Visvanathan & Sandage 1979','NGC 4365',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93352,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93352,31.52,0.41,20.1,39387,NULL,NULL,NULL,'NGC 4365',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93353,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93353,31.59,NULL,20.8,39387,NULL,NULL,NULL,'NGC 4365',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93354,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93354,31.64,0.41,21.3,39387,NULL,NULL,'Malmquist cor.','NGC 4365',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93355,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93355,31.79,0.12,22.8,39387,74.4,NULL,NULL,'NGC 4365',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93356,'Tertiary','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93356,30.49,0.25,12.5,39387,95,NULL,NULL,'NGC 4365',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93357,'Tully est','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93357,31.13,0.8,16.8,39387,75,NULL,'B','NGC 4365',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93358,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93358,32.16,0.49,27,39388,NULL,NULL,'I','NGC 4386',NULL,'2001ApJ...546..681T',2001,1,2.5,NULL,'G',0.00009,NULL,'12.67',1.3,'SAB0^0^:','X-ray-bright group member',NULL,NULL,NULL,1,186.118125,75.52892,0.069,NULL,57014727685,890855120,13919611,12.67),(93359,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93359,32.17,0.14,27.2,39388,74.4,NULL,NULL,'NGC 4386',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93360,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93360,31.57,0.58,20.6,39388,95,NULL,'de Vaucouleurs','NGC 4386',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93361,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93361,31.85,0.43,23.4,39388,95,NULL,'Weighted Mean','NGC 4386',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93362,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93362,33.7,0.81,55,39388,55,NULL,'Visvanathan & Sandage 1979','NGC 4386',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93363,'Tertiary','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93363,31.72,0.71,22.1,39388,95,NULL,NULL,'NGC 4386',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93364,'Tully est','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93364,32.24,0.8,28.1,39388,75,NULL,'B','NGC 4386',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93365,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93365,32.29,0.45,28.7,39388,NULL,NULL,'K','NGC 4386',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93366,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93366,32.47,0.4,31.2,39388,NULL,NULL,'mean','NGC 4386',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93367,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93367,37.72,0.27,351,39389,70,NULL,NULL,'VPC 0344',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000184,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,186.118667,14.01536,0.108,NULL,58160354853,908755544,14199305,16.8),(93368,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93368,38.38,0.46,474,39390,70,NULL,NULL,'2MASX J12242863+4348336',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,186.1192917,43.80922,0,NULL,59070748209,922980440,14421569,18.2),(93369,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93369,37.53,0.46,320,39391,70,NULL,NULL,'2MASX J12242891+0105247',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000075,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,186.120333,1.09017,0,NULL,58010866030,906419781,14162809,17.5),(93370,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93370,37.87,0.21,376,39392,70,NULL,NULL,'SDSS J122429.94+662438.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000064,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,186.1247917,66.41078,0,NULL,57324677420,895698084,13995282,18.4),(93371,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93371,37.34,0.15,294,39393,70,NULL,NULL,'2MASX J12243097+6129328',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00015,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,186.129041667,61.49253,0,NULL,57370761414,896418147,14006533,16.8),(93372,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93372,37.77,0.33,358,39394,70,NULL,NULL,'2MASX J12243127+5543333',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000174,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,186.1304583,55.72586,0,NULL,57401362101,896896282,14014004,16.8),(93373,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93373,38.61,0.46,527,39395,70,NULL,NULL,'2MASX J12243187+3733107',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,186.1329583,37.55303,0,NULL,58584705996,915386031,14302906,17.8),(93374,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93374,36.26,0.46,179,39396,70,NULL,NULL,'2MASX J12243197+4823504',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000163,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,186.133083,48.39739,0,NULL,57184526012,893508218,13961065,16.6),(93375,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93375,36.84,0.17,234,39397,70,NULL,NULL,'2MASX J12243202+3154598',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000158,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,186.133541667,31.91658,0.026,NULL,58767299726,918239058,14347485,17),(93376,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93376,35.97,0.51,156,39398,70,NULL,NULL,'2MASX J12243218-4447355',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,186.134208333,-44.79319,0.405,NULL,46724343072,730067860,11407310,14.6),(93377,'IRAS','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93377,32.73,0.8,35.1,39399,75,NULL,'MAT, I','ESO 380- G 025',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000027,NULL,'14.71',0.3,'SB(s)d: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,186.1432083,-35.40878,0.213,NULL,43260665422,675947897,10561685,14.71),(93378,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93378,31.2,0.32,17.4,39399,85,NULL,'I, inv','ESO 380- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93379,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93379,31.24,0.32,17.7,39399,85,NULL,'I, raw','ESO 380- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93380,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93380,31.53,0.2,20.2,39399,74.4,NULL,NULL,'ESO 380- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93381,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93381,31.57,0.4,20.6,39399,NULL,NULL,NULL,'ESO 380- G 025',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93382,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93382,31.63,0.43,21.2,39399,75,NULL,'MAT, I, inv','ESO 380- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93383,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93383,31.7,0.43,21.9,39399,75,NULL,'MAT, I, raw','ESO 380- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93384,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93384,32.04,0.43,25.6,39399,75,NULL,'MAT, I, cor','ESO 380- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93385,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93385,32.13,0.4,26.7,39399,75,NULL,NULL,'ESO 380- G 025',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93386,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93386,32.13,0.49,26.7,39399,75,NULL,'IR','ESO 380- G 025',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93387,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93387,37.55,0.27,324,39400,70,NULL,NULL,'IC 3286',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.03',0.28,NULL,NULL,NULL,NULL,NULL,1,186.143666667,23.74789,0.143,NULL,58644912870,916326763,14317605,17.03),(93388,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93388,37.77,0.46,357,39401,70,NULL,NULL,'2MASX J12243478+0636513',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,186.144917,6.61436,0,NULL,58234404599,909912571,14217383,16.6),(93389,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93389,31.67,0.4,21.6,39402,75,NULL,'B','NGC 4369',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.00002,NULL,'12.33',2,'(R)SA(rs)a     HII','Group member',NULL,NULL,'Starburst',1,186.150833,39.383,0,NULL,58577460404,915272818,14301137,12.33),(93390,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93390,38.35,0.46,467,39403,70,NULL,NULL,'SDSS J122436.97+283310.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000169,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,186.154083333,28.55278,0.09,NULL,58637310891,916207982,14315749,18),(93391,'SNIa','2016-12-15 15:14:59','2016-12-16 11:20:09','1','SN 2008ar',NULL,93391,35.28,0.18,108,39404,72,NULL,NULL,'IC 3284',0.02727,'2013ApJ...773...53F',2013,1,0.62,NULL,'G',0.000096,NULL,'15.5g',0.52,'SBa(r)','Group member',NULL,NULL,NULL,1,186.1565,10.83903,0,NULL,58242309178,910036080,14219313,15.5),(93392,'SNIa','2016-12-15 15:14:59','2016-12-16 11:20:09','1','SN 2008ar',NULL,93392,35.48,0.2,122,39404,73.8,NULL,'SALT 2 (SNANA)','IC 3284',0.0274,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93393,'SNIa','2016-12-15 15:14:59','2016-12-16 11:20:09','1','SN 2008ar',NULL,93393,35.52,0.16,124,39404,70,NULL,'SALT 2','IC 3284',0.026147,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93394,'SNIa','2016-12-15 15:14:59','2016-12-16 11:20:09','1','SN 2008ar','R',93394,35.5,0.06,126,39404,NULL,NULL,'MLCS2k2, R(V) = 1.8','IC 3284',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93395,'SNIa','2016-12-15 15:14:59','2016-12-16 11:20:09','1','SN 2008ar','R',93395,35.53,0.07,128,39404,NULL,NULL,'MLCS2k2, R(V) = 3.1','IC 3284',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93396,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93396,36.84,0.17,234,39405,70,NULL,NULL,'2MASX J12243791+3153278',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,186.158125,31.89111,0.024,NULL,58767257989,918238406,14347475,17.3),(93397,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93397,35.96,0.46,156,39406,70,NULL,NULL,'IC 3288',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.54',0.19,NULL,NULL,NULL,NULL,NULL,1,186.1642083,24.94986,0.061,NULL,58648671115,916385486,14318523,17.54),(93398,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93398,35.79,0.46,144,39407,70,NULL,NULL,'2MASX J12244153+2951582',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000087,NULL,'16.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,186.173,29.86597,0.045,NULL,58758892059,918107688,14345432,16),(93399,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93399,38.24,0.17,444,39408,70,NULL,NULL,'CGPG 1222.4+6340',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.0002,NULL,'16.3g',0.38,'BrClG',NULL,NULL,NULL,NULL,1,186.174125,63.39228,0.025,NULL,57372665539,896447899,14006998,16.3),(93400,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93400,36.84,0.33,233,39409,70,NULL,NULL,'2MASX J12244184+0746513',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000174,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,186.174333,7.78092,0,NULL,58236685492,909948210,14217940,17.3),(93401,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93401,38.24,0.17,444,39410,70,NULL,NULL,'CGPG 1222.4+6340 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,186.177625,63.39153,0.025,NULL,57372665550,896447899,14006998,18.2),(93402,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93402,37.34,0.15,294,39411,70,NULL,NULL,'MCG +10-18-041',NULL,'2015arXiv151105856S',2015,1,0.81,'Two MAPS entries for the same object.','G',0.000137,NULL,'15.3g',0.6,'BrClG',NULL,NULL,NULL,NULL,1,186.178167,61.47072,0,NULL,57370770936,896418295,14006535,15.3),(93403,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93403,39.06,0.46,649,39412,70,NULL,NULL,'SDSS J122442.87+555539.9',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,186.178667,55.92775,0,NULL,57409646389,897025724,14016026,18.1),(93404,'SNIa','2016-12-15 15:14:59','2016-12-16 11:20:09','1','PS1 SN PS11abm','N',93404,41.28,0.19,1370,39413,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11abm HOST',0.3207,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93405,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93405,37.67,0.46,341,39414,70,NULL,NULL,'2MASX J12244447+4531266',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,186.185583,45.52397,0,NULL,59072292196,923004565,14421946,17.5),(93406,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93406,36.84,0.33,233,39415,70,NULL,NULL,'2MASX J12244534+0747293',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000155,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,186.189,7.79142,0,NULL,58236685055,909948203,14217940,16.9),(93407,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93407,36.84,0.17,234,39416,70,NULL,NULL,'2MASX J12244536+3156514',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000103,NULL,'17.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,186.189125,31.94758,0.026,NULL,58767306633,918239166,14347486,17),(93408,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93408,39.03,0.46,639,39417,70,NULL,NULL,'2MASX J12244634+2714505',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,186.1932083,27.24731,0.074,NULL,58639292212,916238940,14316233,17.6),(93409,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93409,35.69,0.46,137,39418,70,NULL,NULL,'VII Zw 452',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000158,NULL,'16.2g',0.32,NULL,NULL,NULL,NULL,NULL,1,186.194,60.92075,0,NULL,57340364426,895943194,13999112,16.2),(93410,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93410,38.51,0.46,503,39419,70,NULL,NULL,'SDSS J122447.49+155733.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000144,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,186.197917,15.95939,0.03,NULL,58154544806,908664762,14197886,18.6),(93411,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93411,30.71,0.27,13.9,39420,NULL,NULL,'TOM(g) = -7.2 mag','IC 3292',NULL,'2007ApJS..171..101J',2007,1,0.76,NULL,'G',0.00012,NULL,'15.3',0.54,'dS0','Group member',NULL,NULL,NULL,1,186.2015,18.19511,0.04,NULL,58913949055,920530453,14383288,15.3),(93412,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93412,30.73,0.19,14,39420,NULL,NULL,'TOM(g) = -7.2 mag','IC 3292',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93413,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93413,31.07,0.25,16.4,39420,NULL,NULL,'TOM(u) = -8.4 mag','IC 3292',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93414,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93414,31.23,0.21,17.6,39420,NULL,NULL,'TOM(z) = -8.53 mag','IC 3292',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93415,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93415,30.97,0.14,15.6,39420,74.4,NULL,NULL,'IC 3292',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93416,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93416,30.99,0.06,15.8,39420,NULL,NULL,NULL,'IC 3292',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93417,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93417,30.99,0.08,15.8,39420,NULL,NULL,'HST ACS VCS','IC 3292',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93418,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93418,38.24,0.17,444,39421,70,NULL,NULL,'CGPG 1222.6+6341',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000172,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,186.202583,63.40911,0.025,NULL,57371957697,896436839,14006825,17.1),(93419,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93419,36.7,0.46,218,39422,70,NULL,NULL,'2MASX J12244913+0233052',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000152,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,186.20475,2.55147,0.008,NULL,58011628372,906431693,14162995,16.5),(93420,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93420,36.79,0.46,228,39423,70,NULL,NULL,'2MASX J12245018+4450016',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000131,NULL,'16.0g',0.39,'S0/a',NULL,NULL,NULL,NULL,1,186.2092083,44.83369,0,NULL,59072376889,923005888,14421967,16),(93421,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93421,36.71,0.46,220,39424,70,NULL,NULL,'2MASX J12245117+3827467',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000181,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,186.213125,38.46297,0,NULL,58584245345,915378833,14302794,16.2),(93422,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93422,37.01,0.46,252,39425,70,NULL,NULL,'2MASX J12245131+5049390',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000148,NULL,'16.7g',0.35,NULL,NULL,NULL,NULL,NULL,1,186.213791667,50.82753,0,NULL,57240017507,894375273,13974613,16.7),(93423,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93423,37.13,0.46,267,39426,70,NULL,NULL,'2MASX J12245140+6536527',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,186.214125,65.61483,0.021,NULL,57325289109,895707642,13995431,17.1),(93424,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93424,37.05,0.46,257,39427,70,NULL,NULL,'2MASXi J1224522+211056',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.6g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,186.217791667,21.18236,NULL,NULL,58865409916,919772029,14371437,17.6),(93425,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93425,37.27,0.46,285,39428,70,NULL,NULL,'2MASX J12245314+2822346',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000172,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,186.221375,28.37644,0.066,NULL,58637197356,916206208,14315722,16.9),(93426,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93426,37.68,0.46,344,39429,70,NULL,NULL,'2MASX J12245366+3344245',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000214,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,186.223708333,33.74019,0.006,NULL,58766184253,918221628,14347212,17.4),(93427,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93427,37.12,0.46,265,39430,70,NULL,NULL,'2MASX J12245409+1750423',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,186.2255,17.84508,0.028,NULL,58914055956,920532124,14383314,17.4),(93428,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93428,35.61,0.5,132,39431,70,NULL,NULL,'2MASX J12245466-1536034',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.81',NULL,NULL,NULL,NULL,NULL,NULL,1,186.227875,-15.60114,0.049,NULL,43045382578,672584102,10509126,15.81),(93429,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93429,31.57,0.4,20.6,39432,NULL,NULL,'mean','NGC 4370',NULL,'2007A&A...465...71T',2007,1,1.48,NULL,'G',0.000023,NULL,'13.4g',0.99,'Sa','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.22875,7.44489,0,NULL,58236642956,909947546,14217930,13.4),(93430,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93430,32.78,0.45,35.9,39432,NULL,NULL,'K','NGC 4370',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93431,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93431,32.93,0.46,38.6,39432,NULL,NULL,'J','NGC 4370',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93432,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93432,37.6,0.33,332,39433,70,NULL,NULL,'VPC 0374',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000188,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,186.229416667,12.1125,0.053,NULL,58159104164,908736002,14199000,16.9),(93433,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93433,31,0.11,15.8,39434,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4371',NULL,'2010ApJ...717..603V',2010,1,4,NULL,'G',0.000017,NULL,'11.79',2.2,'SB(r)0+','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.2309583,11.70422,0.021,NULL,58158303101,908723485,14198804,11.79),(93434,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93434,31.01,0.12,15.9,39434,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4371',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93435,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93435,31.09,0.11,16.5,39434,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4371',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93436,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93436,31.22,0.11,17.5,39434,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4371',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93437,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93437,31.12,0.14,16.8,39434,74.4,NULL,NULL,'NGC 4371',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93438,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93438,31.14,0.07,16.9,39434,NULL,NULL,'HST ACS VCS','NGC 4371',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93439,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93439,31.15,0.06,17,39434,NULL,NULL,NULL,'NGC 4371',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93440,'GC radius','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93440,30.82,0.06,14.6,39434,NULL,NULL,NULL,'NGC 4371',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93441,'Ring Diameter','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93441,30.4,0.84,12,39434,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4371',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93442,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93442,30.23,0.8,11.1,39434,95,NULL,'de Vaucouleurs','NGC 4371',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93443,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93443,30.88,0.51,15,39434,95,NULL,'Weighted Mean','NGC 4371',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93444,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93444,32.61,0.81,33.3,39434,55,NULL,'Visvanathan & Sandage 1979','NGC 4371',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93445,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93445,30.2,NULL,11,39434,NULL,NULL,NULL,'NGC 4371',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93446,'Tertiary','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93446,30.49,0.25,12.5,39434,95,NULL,NULL,'NGC 4371',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93447,'Tully est','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93447,31.13,0.8,16.8,39434,75,NULL,'B','NGC 4371',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93448,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93448,31.07,0.45,16.4,39434,NULL,NULL,'K','NGC 4371',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93449,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93449,31.57,0.4,20.6,39434,NULL,NULL,'mean','NGC 4371',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93450,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93450,38.53,0.46,509,39435,70,NULL,NULL,'SDSS J122455.53+682027.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00007,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,186.231417,68.34083,0.041,NULL,57851081279,903923144,14123799,18.5),(93451,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93451,37.6,0.33,332,39436,70,NULL,NULL,'VPC 0376',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000186,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,186.2315,12.09953,0.021,NULL,58159104619,908736009,14199000,16.4),(93452,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93452,35.55,0.46,129,39437,70,NULL,NULL,'2MASX J12245654+0246452',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000173,NULL,'15.7g',0.47,'S0^-',NULL,NULL,NULL,NULL,1,186.2355,2.77914,0,NULL,58011555542,906430555,14162977,15.7),(93453,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93453,36.68,0.46,217,39438,70,NULL,NULL,'2MASX J12245726+6100476',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000169,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,186.238458333,61.01331,0,NULL,57340367464,895943241,13999113,16.3),(93454,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93454,37.72,0.27,351,39439,70,NULL,NULL,'SDSS J122457.43+140121.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000167,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,186.239333333,14.02272,0.108,NULL,58162445677,908788213,14199815,18.5),(93455,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93455,37.21,0.46,277,39440,70,NULL,NULL,'2MASX J12245740+4145233',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000167,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,186.239375,41.75639,0,NULL,59063413475,922865835,14419778,16.9),(93456,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93456,36.18,0.46,172,39441,70,NULL,NULL,'2MASX J12245762+2949456',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000113,NULL,'15.5g',0.52,NULL,NULL,NULL,NULL,NULL,1,186.2400417,29.82933,0.045,NULL,58758899019,918107797,14345434,15.5),(93457,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93457,37.34,0.15,294,39442,70,NULL,NULL,'2MASX J12245795+6130456',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,186.241167,61.51286,0,NULL,57370756476,896418069,14006532,17.7),(93458,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93458,38.68,0.46,545,39443,70,NULL,NULL,'SDSS J122458.24+271646.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000161,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,186.242667,27.2795,0.074,NULL,58638820996,916231578,14316118,18.5),(93459,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93459,38.05,0.46,407,39444,70,NULL,NULL,'SDSS J122459.42+104615.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000157,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,186.247583333,10.77097,0,NULL,58242285124,910035705,14219307,18.6),(93460,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93460,37.87,0.21,376,39445,70,NULL,NULL,'SDSS J122459.80+662946.8',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00008,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,186.249208333,66.49633,0.033,NULL,57313222937,895519108,13992486,17.2),(93461,'Ring Diameter','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93461,33.3,0.84,46,39446,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4375',NULL,'1981ApJS...45..541P',1981,1,1.4,NULL,'G',0.000027,NULL,'13.68',1.2,'SB(r)ab pec:','Possible group member',NULL,NULL,NULL,1,186.2519583,28.55861,0.09,NULL,58637328625,916208259,14315754,13.68),(93462,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93462,35.46,0.47,123,39446,NULL,NULL,'H','NGC 4375',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93463,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93463,35.48,0.45,125,39446,NULL,NULL,'K','NGC 4375',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93464,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93464,35.53,0.46,128,39446,NULL,NULL,'J','NGC 4375',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93465,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93465,35.54,0.4,128,39446,NULL,NULL,'mean','NGC 4375',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93466,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93466,37.57,0.46,326,39447,70,NULL,NULL,'2MASX J12250096+0415352',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.50',0.16,NULL,NULL,NULL,NULL,NULL,1,186.253917,4.25986,0,NULL,58003367830,906302622,14160978,17.5),(93467,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93467,37.54,0.46,322,39448,70,NULL,NULL,'2MASX J12250201+2647126',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,186.258625,26.78697,0.079,NULL,58638645459,916228835,14316075,17.4),(93468,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93468,37.16,0.33,270,39449,70,NULL,NULL,'2MASX J12250255+4318095',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,186.2605,43.30267,0,NULL,59062650115,922853908,14419592,17.4),(93469,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93469,37.34,0.15,294,39450,70,NULL,NULL,'2MASX J12250264+6133456',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000179,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,186.260875,61.56269,0.005,NULL,57370968832,896421388,14006584,16.8),(93470,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93470,35.28,0.15,114,39451,70,NULL,NULL,'2MASX J12250327+0922234',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000152,NULL,'15.8g',0.4,'S0',NULL,NULL,NULL,NULL,1,186.263625,9.37306,0,NULL,58243873596,910060524,14219695,15.8),(93471,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93471,30.03,0.1,10.1,39452,NULL,NULL,'Photographic, TOM(B) = -6.40 mag','MESSIER 084',NULL,'1987AJ.....94..906H',1987,1,6.5,NULL,'G',0.000017,NULL,'10.09',5.6,'E1;LERG;LINER  Sy2','in a radial-velocity based grouping',NULL,'FR I','Sy 2',1,186.265583,12.88697,0.125,NULL,58160679388,908760615,14199384,10.09),(93472,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93472,30.13,0.1,10.6,39452,NULL,NULL,'Photographic, TOM(B) = -6.40 mag','MESSIER 084',NULL,'1987AJ.....94..906H',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93473,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93473,31.07,0.06,16.4,39452,NULL,NULL,'TOM(g) = -7.2 mag','MESSIER 084',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93474,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93474,31.08,0.3,16.4,39452,NULL,NULL,'R','MESSIER 084',NULL,'1994AJ....108.2087A',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93475,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93475,31.17,0.07,17.2,39452,NULL,NULL,'TOM(g) = -7.2 mag','MESSIER 084',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93476,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93476,31.24,0.07,17.7,39452,NULL,NULL,'TOM(u) = -8.4 mag','MESSIER 084',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93477,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93477,31.29,0.06,18.1,39452,NULL,NULL,'TOM(z) = -8.53 mag','MESSIER 084',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93478,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93478,31.61,0.2,21,39452,NULL,NULL,NULL,'MESSIER 084',NULL,'2004A&A...415..499G',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93479,'PNLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93479,30.89,0.11,15.1,39452,NULL,NULL,NULL,'MESSIER 084',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93480,'PNLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93480,30.98,0.06,15.7,39452,NULL,NULL,'37 PNe','MESSIER 084',NULL,'1990ApJ...356..332J',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93481,'PNLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93481,30.99,0.15,15.8,39452,NULL,NULL,'HST KP Calibrated','MESSIER 084',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93482,'PNLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93482,31,0.1,15.8,39452,NULL,NULL,'I','MESSIER 084',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93483,'SNIa','2016-12-15 15:14:59','2016-12-16 11:20:09','1','SN 1991bg',NULL,93483,30.35,0.19,11.7,39452,72,NULL,NULL,'MESSIER 084',0.00354,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93484,'SNIa','2016-12-15 15:14:59','2016-12-16 11:20:09','1','SN 1957B',NULL,93484,30.7,0.36,13.8,39452,NULL,NULL,NULL,'MESSIER 084',NULL,'1992ApJ...390L..45P',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93485,'SNIa','2016-12-15 15:14:59','2016-12-16 11:20:09','1','SN 1957B',NULL,93485,31.1,0.4,16,39452,NULL,NULL,'Photographic','MESSIER 084',NULL,'1982ApJ...254....1A',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93486,'SNIa','2016-12-15 15:14:59','2016-12-16 11:20:09','1','SN 1957B',NULL,93486,31.1,0.3,16.6,39452,NULL,NULL,NULL,'MESSIER 084',NULL,'2011A&A...532A.154C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93487,'SNIa','2016-12-15 15:14:59','2016-12-16 11:20:09','1','SN 1991bg',NULL,93487,31.1,0.3,16.6,39452,NULL,NULL,NULL,'MESSIER 084',NULL,'2011A&A...532A.154C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93488,'SNIa','2016-12-15 15:14:59','2016-12-16 11:20:09','1','SN 1991bg',NULL,93488,31.14,0.08,16.9,39452,74.4,NULL,NULL,'MESSIER 084',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93489,'SNIa','2016-12-15 15:14:59','2016-12-16 11:20:09','1','SN 1991bg',NULL,93489,31.17,0.1,17.1,39452,NULL,NULL,'MLCS2k2','MESSIER 084',NULL,'2011A&A...532A.154C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93490,'SNIa','2016-12-15 15:14:59','2016-12-16 11:20:09','1','SN 1991bg',NULL,93490,31.3,0.53,18,39452,67,NULL,NULL,'MESSIER 084',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93491,'SNIa','2016-12-15 15:14:59','2016-12-16 11:20:09','1','SN 1991bg',NULL,93491,31.42,0.1,19.1,39452,65,NULL,'MLCS2k2','MESSIER 084',0.00354,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93492,'SNIa','2016-12-15 15:14:59','2016-12-16 11:20:09','1','SN 1991bg',NULL,93492,31.41,0.22,19.1,39452,65,NULL,'avg. of 6 SNIa and hosts','MESSIER 084',NULL,'1996AJ....112.2398H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93493,'SNIa','2016-12-15 15:14:59','2016-12-16 11:20:09','1','SN 1957B',NULL,93493,31.42,NULL,19.2,39452,56,NULL,'M(B) = -19.8 mag','MESSIER 084',NULL,'1992ARA&A..30..359B',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93494,'SNIa','2016-12-15 15:14:59','2016-12-16 11:20:09','1','SN 1957B','R',93494,32.32,NULL,29.1,39452,NULL,NULL,'Photographic','MESSIER 084',NULL,'1988SSRv...48....1R',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93495,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93495,30.91,0.2,15.2,39452,NULL,NULL,'V Theoretical - SSP','MESSIER 084',NULL,'2011A&A...532A.154C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93496,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93496,31.05,0.2,16.2,39452,NULL,NULL,'I','MESSIER 084',NULL,'1993A&A...275..433B',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93497,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93497,31.08,0.2,16.4,39452,NULL,NULL,'V Empirical','MESSIER 084',NULL,'2011A&A...532A.154C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93498,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93498,31.09,0.08,16.5,39452,NULL,NULL,'I','MESSIER 084',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93499,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93499,31.14,0.1,16.9,39452,NULL,NULL,'K','MESSIER 084',NULL,'1994ApJ...433..567P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93500,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93500,31.14,0.08,16.9,39452,74.4,NULL,NULL,'MESSIER 084',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93501,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93501,31.17,0.1,17.1,39452,NULL,NULL,'I','MESSIER 084',NULL,'2000ApJ...536..255N',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93502,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93502,31.17,0.2,17.1,39452,NULL,NULL,'V Theoretical - CSP','MESSIER 084',NULL,'2011A&A...532A.154C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93503,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93503,31.21,0.17,17.5,39452,NULL,NULL,'Median','MESSIER 084',NULL,'2011A&A...532A.154C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93504,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93504,31.25,0.22,17.8,39452,NULL,NULL,'R Empirical','MESSIER 084',NULL,'2011A&A...532A.154C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93505,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93505,31.27,0.22,17.9,39452,NULL,NULL,'R Theoretical - SSP','MESSIER 084',NULL,'2011A&A...532A.154C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93506,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93506,31.32,0.11,18.4,39452,NULL,NULL,'I','MESSIER 084',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93507,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93507,31.32,0.11,18.4,39452,NULL,NULL,'I','MESSIER 084',NULL,'2001ApJ...559..584A',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93508,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93508,31.32,0.11,18.4,39452,NULL,NULL,NULL,'MESSIER 084',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93509,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93509,31.33,0.05,18.5,39452,NULL,NULL,NULL,'MESSIER 084',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93510,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93510,31.33,0.06,18.5,39452,NULL,NULL,'I','MESSIER 084',NULL,'1990AJ....100.1416T',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93511,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93511,31.33,0.11,18.5,39452,NULL,NULL,'Malmquist cor.','MESSIER 084',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93512,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93512,31.34,0.07,18.5,39452,NULL,NULL,'HST ACS VCS','MESSIER 084',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93513,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93513,31.4,0.14,19.1,39452,NULL,NULL,'HST KP Calibrated, I','MESSIER 084',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93514,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93514,31.41,0.22,19.1,39452,NULL,NULL,'R Theoretical - CSP','MESSIER 084',NULL,'2011A&A...532A.154C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93515,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93515,31.42,0.25,19.2,39452,NULL,NULL,'HST KP Calibrated, Ks','MESSIER 084',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93516,'GC radius','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93516,31.22,0.07,17.5,39452,NULL,NULL,NULL,'MESSIER 084',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93517,'D-Sigma','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93517,31.13,0.4,16.8,39452,75,NULL,'Edat, raw','MESSIER 084',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93518,'D-Sigma','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93518,31.15,0.4,17,39452,75,NULL,'Edat, cor','MESSIER 084',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93519,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93519,30.54,0.24,12.8,39452,95,NULL,'Weighted Mean','MESSIER 084',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93520,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93520,30.55,0.31,12.9,39452,95,NULL,'de Vaucouleurs','MESSIER 084',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93521,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93521,30.72,0.63,13.9,39452,95,NULL,'Michard 1979b, c','MESSIER 084',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93522,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93522,30.75,0.46,14.1,39452,95,NULL,'Michard 1979a','MESSIER 084',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93523,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93523,31,NULL,15.8,39452,NULL,NULL,'LEDA [April 2006]','MESSIER 084',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93524,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93524,31.54,0.81,20.3,39452,55,NULL,'Visvanathan & Sandage 1979','MESSIER 084',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93525,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93525,31.1,0.41,16.6,39452,NULL,NULL,NULL,'MESSIER 084',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93526,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93526,31.14,0.08,16.9,39452,74.4,NULL,NULL,'MESSIER 084',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93527,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93527,31.26,NULL,17.9,39452,NULL,NULL,NULL,'MESSIER 084',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93528,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93528,31.29,0.41,18.1,39452,NULL,NULL,'Malmquist cor.','MESSIER 084',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93529,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93529,31.36,NULL,18.7,39452,NULL,NULL,NULL,'MESSIER 084',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93530,'Tertiary','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93530,30.49,0.25,12.5,39452,95,NULL,NULL,'MESSIER 084',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93531,'Tully est','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93531,31.13,0.8,16.8,39452,75,NULL,'B','MESSIER 084',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93532,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93532,31.02,0.4,16,39452,75,NULL,'HOSTS SN 1991bg','MESSIER 084',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93533,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93533,33,0.49,39.8,39453,75,NULL,'IR','IC 3298',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000023,NULL,'15.37',0.3,'SB?','Group member',NULL,NULL,NULL,1,186.265833,17.01533,0.009,NULL,58879695944,919995249,14374925,15.37),(93534,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93534,37.55,0.27,324,39454,70,NULL,NULL,'2MASX J12250416+2343468',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.21',0.15,NULL,NULL,NULL,NULL,NULL,1,186.267375,23.72983,0.143,NULL,58644981971,916327843,14317622,18.21),(93535,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93535,38,0.46,398,39455,70,NULL,NULL,'2MASX J12250486+0812464',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,186.270375,8.21278,0,NULL,58247598692,910118729,14220605,17.7),(93536,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93536,34.55,0.49,81.4,39456,75,NULL,'IR','IC 3300',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.40',0.3,'Sc',NULL,NULL,NULL,NULL,1,186.27075,25.95756,0.051,NULL,58645914357,916342411,14317850,15.4),(93537,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93537,35.55,0.49,129,39457,70,NULL,NULL,'2MASX J12250539-5017462',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,186.272417,-50.29617,0.849,NULL,44616835411,697138053,10892782,14.3),(93538,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93538,38.24,0.17,444,39458,70,NULL,NULL,'2MASX J12250579+6317165',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000129,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,186.273833,63.28797,0.009,NULL,57372700817,896448450,14007007,18.2),(93539,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93539,37.29,0.46,286,39459,70,NULL,NULL,'2MASX J12250641+2135178',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.06',0.23,NULL,NULL,NULL,NULL,NULL,1,186.276625,21.58833,NULL,NULL,58865285886,919770091,14371407,17.06),(93540,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93540,35.38,0.49,119,39460,75,NULL,'IR','VCC 0770',NULL,'2011yCatp016004901K',2011,1,1.03,NULL,'G',0.000007,NULL,'15.19',0.12,'Sc','Group member',NULL,NULL,NULL,1,186.2840417,4.47344,0,NULL,58003879651,906310619,14161103,15.19),(93541,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93541,35.83,NULL,147,39460,NULL,NULL,'Dipole + Quadrupole + Octopole','VCC 0770',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93542,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93542,35.85,NULL,148,39460,NULL,NULL,'Dipole + Quadrupole','VCC 0770',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93543,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93543,35.87,NULL,149,39460,NULL,NULL,'Dipole','VCC 0770',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93544,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93544,35.87,NULL,150,39460,NULL,NULL,NULL,'VCC 0770',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93545,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93545,37.46,0.46,311,39461,70,NULL,NULL,'2MASX J12250858-0220498',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000079,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,186.285916667,-2.34706,0.069,NULL,42995997016,671812453,10497069,17.1),(93546,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93546,37.55,0.27,324,39462,70,NULL,NULL,'2MASX J12250883+3249394',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000174,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,186.2867917,32.82761,NULL,NULL,58764903936,918201624,14346900,17.6),(93547,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93547,35.85,0.63,148,39463,70,NULL,NULL,'2MASX J12251010-1530327',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.37',NULL,NULL,NULL,NULL,NULL,NULL,1,186.2920417,-15.50925,0.049,NULL,43045408574,672584508,10509132,16.37),(93548,'Tully est','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93548,32.82,0.8,36.6,39464,75,NULL,'B','NGC 4384',NULL,'1988NBGC.C....0000T',1988,1,1.21,NULL,'G',0.000023,NULL,'13.6g',0.96,'Sa             HII','Field galaxy',NULL,NULL,NULL,1,186.299916667,54.50622,0,NULL,57220080004,894063750,13969746,13.6),(93549,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93549,31.05,0.43,16.2,39464,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4384',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93550,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93550,31.34,0.43,18.5,39464,75,NULL,'3.6 micron, color corrected','NGC 4384',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93551,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93551,31.58,0.2,20.7,39464,74.4,NULL,NULL,'NGC 4384',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93552,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93552,37.16,0.33,270,39465,70,NULL,NULL,'2MASX J12251227+4317017',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,186.301083,43.28372,0,NULL,59062650558,922853914,14419592,17.3),(93553,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93553,31.27,0.18,17.9,39466,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4377',NULL,'2010ApJ...717..603V',2010,1,1.7,NULL,'G',0.000017,NULL,'12.76',1.4,'SA0-','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.301417,14.76217,0.078,NULL,58155946797,908686668,14198229,12.76),(93554,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93554,31.4,0.22,19,39466,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4377',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93555,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93555,31.5,0.17,20,39466,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4377',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93556,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93556,31.52,0.2,20.1,39466,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4377',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93557,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93557,31.24,0.07,17.7,39466,NULL,NULL,'HST ACS VCS','NGC 4377',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93558,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93558,31.24,0.12,17.7,39466,74.4,NULL,NULL,'NGC 4377',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93559,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93559,31.25,0.06,17.8,39466,NULL,NULL,NULL,'NGC 4377',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93560,'GC radius','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93560,31.22,0.13,17.5,39466,NULL,NULL,NULL,'NGC 4377',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93561,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93561,30.51,0.48,12.6,39466,95,NULL,'Weighted Mean','NGC 4377',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93562,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93562,30.89,0.71,15.1,39466,95,NULL,'de Vaucouleurs','NGC 4377',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93563,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93563,31.22,0.81,17.5,39466,55,NULL,'Visvanathan & Sandage 1979','NGC 4377',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93564,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93564,30.95,NULL,15.5,39466,NULL,NULL,NULL,'NGC 4377',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93565,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93565,31.24,0.12,17.7,39466,74.4,NULL,NULL,'NGC 4377',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93566,'Tertiary','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93566,30.49,0.25,12.5,39466,95,NULL,NULL,'NGC 4377',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93567,'Tully est','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93567,31.13,0.8,16.8,39466,75,NULL,'B','NGC 4377',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93568,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93568,31.66,0.4,21.5,39466,NULL,NULL,'mean','NGC 4377',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93569,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93569,32.28,0.45,28.6,39466,NULL,NULL,'K','NGC 4377',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93570,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93570,37.34,0.15,294,39467,70,NULL,NULL,'VII Zw 453',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,186.301417,61.66436,0,NULL,57370851832,896419559,14006555,16.8),(93571,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93571,37.8,0.46,364,39468,70,NULL,NULL,'2MASX J12251243+5612210',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,186.301667,56.20583,0.009,NULL,57410520133,897039377,14016240,17.7),(93572,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93572,38.59,0.23,522,39469,70,NULL,NULL,'2MASX J12251274+3722224',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000159,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,186.303,37.37303,0,NULL,58570785303,915168520,14299508,17.3),(93573,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93573,38.36,0.46,470,39470,70,NULL,NULL,'2MASX J12251264+6838590',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000101,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,186.303,68.64983,0.065,NULL,57850607039,903915734,14123683,17.7),(93574,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93574,37.47,0.46,312,39471,70,NULL,NULL,'2MASX J12251277+4327437',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000136,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,186.303167,43.46214,0,NULL,59062670205,922854221,14419597,17.9),(93575,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93575,36.84,0.17,234,39472,70,NULL,NULL,'2MASX J12251310+3214020',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000179,NULL,'15.1g',0.63,'Radio galaxy   Sy2',NULL,NULL,NULL,'Sy 2',1,186.304708333,32.23381,0.028,NULL,58766485238,918226331,14347286,15.1),(93576,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93576,37.22,0.17,278,39473,70,NULL,NULL,'2MASX J12251406+3137020',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000174,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,186.3085,31.61742,0.023,NULL,58759976247,918124628,14345697,17.2),(93577,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93577,36.84,0.17,234,39474,70,NULL,NULL,'2MASX J12251449+3157070',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.86',0.18,NULL,NULL,NULL,NULL,NULL,1,186.3102917,31.95181,0.026,NULL,58766561639,918227525,14347305,17.86),(93578,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93578,37.45,0.46,310,39475,70,NULL,NULL,'VPC 0396',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000178,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,186.3107917,14.39231,0.096,NULL,58155180435,908674694,14198042,17.5),(93579,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93579,31.47,0.16,19.7,39476,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4379',NULL,'2010ApJ...717..603V',2010,1,1.9,NULL,'G',0.000017,NULL,'12.63',1.6,'S0- pec:','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.311417,15.60747,0.035,NULL,58157741350,908714708,14198667,12.63),(93580,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93580,31.5,0.2,19.9,39476,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4379',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93581,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93581,31.52,0.18,20.2,39476,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4379',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93582,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93582,31.63,0.16,21.2,39476,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4379',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93583,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93583,30.76,0.41,14.2,39476,NULL,NULL,'I','NGC 4379',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93584,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93584,30.86,0.12,14.9,39476,74.4,NULL,NULL,'NGC 4379',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93585,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93585,31,0.06,15.8,39476,NULL,NULL,NULL,'NGC 4379',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93586,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93586,31,0.07,15.9,39476,NULL,NULL,'HST ACS VCS','NGC 4379',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93587,'GC radius','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93587,31.01,0.06,15.9,39476,NULL,NULL,NULL,'NGC 4379',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93588,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93588,29.88,0.65,9.46,39476,95,NULL,'Weighted Mean','NGC 4379',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93589,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93589,30.83,0.81,14.7,39476,55,NULL,'Visvanathan & Sandage 1979','NGC 4379',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93590,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93590,29.39,NULL,7.55,39476,NULL,NULL,NULL,'NGC 4379',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93591,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93591,30.86,0.12,14.9,39476,74.4,NULL,NULL,'NGC 4379',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93592,'Tertiary','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93592,30.49,0.25,12.5,39476,95,NULL,NULL,'NGC 4379',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93593,'Tully est','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93593,31.13,0.8,16.8,39476,75,NULL,'B','NGC 4379',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93594,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93594,31.52,0.45,20.1,39476,NULL,NULL,'K','NGC 4379',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93595,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93595,31.66,0.4,21.5,39476,NULL,NULL,'mean','NGC 4379',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93596,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93596,36.84,0.46,234,39477,70,NULL,NULL,'2MASX J12251526+4023474',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000172,NULL,'15.8g',0.45,NULL,NULL,NULL,NULL,NULL,1,186.3137083,40.39664,0,NULL,58528088409,914501381,14289084,15.8),(93597,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93597,37.72,0.46,350,39478,70,NULL,NULL,'2MASX J12251546+4827179',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000174,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,186.31425,48.45503,0,NULL,57184522115,893508158,13961064,17.3),(93598,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93598,36.26,0.46,178,39479,70,NULL,NULL,'2MASX J12251605+3200450',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000183,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,186.3169583,32.0125,0.026,NULL,58766572542,918227695,14347307,16.5),(93599,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93599,38.14,0.21,425,39480,70,NULL,NULL,'SDSS J122517.01+092415.0',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,186.320916667,9.40417,0,NULL,58243870100,910060470,14219694,17.6),(93600,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93600,38.24,0.17,444,39481,70,NULL,NULL,'CGPG 1222.9+6347',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,186.321333,63.49933,0.025,NULL,57371961695,896436901,14006826,18),(93601,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93601,37.6,0.46,331,39482,70,NULL,NULL,'2MASX J12251725+0621104',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00019,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,186.322,6.35289,0.025,NULL,58234509982,909914218,14217409,16.7),(93602,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93602,32.76,0.23,35.6,39483,NULL,NULL,'HST KP Calibrated, F814W','NGC 4373',NULL,'2000ApJ...529..745F',2000,1,3.4,NULL,'G',0.00006,NULL,'11.90',2.5,'SAB(rs)0-:','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,186.32425,-39.75972,0.369,NULL,43280497637,676257775,10566527,11.9),(93603,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93603,32.84,0.23,37,39483,NULL,NULL,'HST KP Calibrated, F814W','NGC 4373',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93604,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93604,33.23,0.22,44.3,39483,NULL,NULL,'HST KP Calibrated, I','NGC 4373',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93605,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93605,33.23,0.19,44.3,39483,NULL,NULL,NULL,'NGC 4373',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93606,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93606,33.29,0.19,45.5,39483,NULL,NULL,'Malmquist cor.','NGC 4373',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93607,'D-Sigma','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93607,31.77,0.4,22.6,39483,75,NULL,'Edat, raw','NGC 4373',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93608,'D-Sigma','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93608,32.21,0.4,27.7,39483,75,NULL,'Edat, cor','NGC 4373',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93609,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93609,31.3,0.44,18.2,39483,95,NULL,'Weighted Mean','NGC 4373',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93610,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93610,31.45,0.63,19.5,39483,95,NULL,'Michard 1979b, c','NGC 4373',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93611,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93611,31.62,0.46,21.1,39483,95,NULL,'Michard 1979a','NGC 4373',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93612,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93612,32.32,0.41,29.1,39483,NULL,NULL,NULL,'NGC 4373',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93613,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93613,32.71,0.41,34.9,39483,NULL,NULL,'Malmquist cor.','NGC 4373',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93614,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93614,32.6,0.45,33.1,39483,NULL,NULL,'K','NGC 4373',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93615,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93615,33.29,0.4,45.4,39483,NULL,NULL,'mean','NGC 4373',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93616,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93616,37.47,0.46,313,39484,70,NULL,NULL,'VPC 0400',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000145,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,186.324833333,12.62328,0.108,NULL,58161876174,908779315,14199676,17.5),(93617,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93617,33.14,0.49,42.4,39485,70,NULL,NULL,'ESO 268- G 003',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'14.35',0.8,'SB(s)0^0^',NULL,NULL,NULL,NULL,1,186.324875,-43.44547,0.429,NULL,46717493443,729960835,11405638,14.35),(93618,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93618,32.84,0.23,37,39486,NULL,NULL,'HST KP Calibrated, F814W','NGC 4373 GROUP',NULL,'2000ApJ...529..745F',2000,1,NULL,NULL,'GGroup',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,186.324167,-39.75972,0.369,NULL,43280497637,676257775,10566527,NULL),(93619,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93619,31.55,0.36,20.4,39487,NULL,NULL,NULL,'NGC 4378',NULL,'2009AJ....138..323T',2009,1,2.9,NULL,'G',0.00001,NULL,'12.63',2.7,'(R)SA(s)a      Sy2','in a radial-velocity based grouping',NULL,NULL,'Sy 2',1,186.325417,4.92514,0,NULL,58003883344,906310677,14161104,12.63),(93620,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93620,32.73,0.4,35.1,39487,75,NULL,'B','NGC 4378',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93621,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93621,31.89,NULL,23.9,39488,NULL,NULL,NULL,'NGC 4376',NULL,'1999MNRAS.304..595G',1999,1,1.4,NULL,'G',0.000017,NULL,'13.88',0.9,'Im             HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.32525,5.74119,0,NULL,58233783518,909902867,14217232,13.88),(93622,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93622,30.54,NULL,12.8,39489,NULL,NULL,NULL,'IC 3308',NULL,'2013AJ....145..101K',2013,1,1.3,NULL,'G',0.000017,NULL,'15.41',0.2,'Sdm:',NULL,NULL,NULL,NULL,1,186.325875,26.71511,0.079,NULL,58638640198,916228753,14316074,15.41),(93623,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93623,38.09,0.46,415,39490,70,NULL,NULL,'2MASX J12251875+6418177',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,186.328083333,64.305,0.005,NULL,57323812030,895684562,13995071,17.8),(93624,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93624,31.88,0.14,23.8,39491,74.4,NULL,NULL,'NGC 4391',NULL,'2013AJ....146...86T',2013,1,1.08,NULL,'G',0.000067,NULL,'13.5g',1.05,'SA0-:','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.328291667,64.93347,0.009,NULL,57324025621,895687900,13995123,13.5),(93625,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93625,31.9,0.27,24,39491,NULL,NULL,'I','NGC 4391',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93626,'GRB','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93626,42.97,1.43,1350,39492,73,NULL,'H const./H=100','GRB 000418',1.1181,'2006astro.ph..9262M',2006,1,NULL,NULL,'G',0.0001,NULL,'24.1R',NULL,'Sbrst',NULL,NULL,NULL,NULL,1,186.330417,20.10306,0.118,NULL,58915292417,920551444,14383616,24.1),(93627,'GRB','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93627,44.44,0.21,3650,39492,73,NULL,'H const./H=100','GRB 000418',1.1181,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93628,'SNIa','2016-12-15 15:14:59','2016-12-16 11:20:09','1','PS1 SN PS10hu','N',93628,38.55,0.14,455,39493,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10hu HOST',0.1267,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93629,'D-Sigma','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93629,34.1,0.4,65.9,39494,75,NULL,'Edat, raw','ESO 268- G 004',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.00015,NULL,'13.61',1.2,'SA0^0^: pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,186.338083,-47.47408,0.561,NULL,46714525532,729914461,11404913,13.61),(93630,'D-Sigma','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93630,34.43,0.4,76.9,39494,75,NULL,'Edat, cor','ESO 268- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93631,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93631,34.33,0.46,73.3,39494,70,NULL,NULL,'ESO 268- G 004',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93632,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93632,34.23,0.45,70.3,39494,NULL,NULL,'K','ESO 268- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93633,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93633,34.38,0.4,75.2,39494,NULL,NULL,'mean','ESO 268- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93634,'IRAS','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93634,31.41,0.8,19.2,39495,75,NULL,'A82, H','NGC 4380',NULL,'1997ApJS..109..333W',1997,1,2.39,NULL,'G',0.000002,NULL,'13.0g',1.59,'SA(rs)b:?;Sy   LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.342375,10.01681,0,NULL,58242487260,910038863,14219357,13),(93635,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93635,30.83,0.43,14.7,39495,NULL,NULL,NULL,'NGC 4380',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93636,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93636,30.91,0.2,15.2,39495,74.4,NULL,NULL,'NGC 4380',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93637,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93637,30.98,0.4,15.7,39495,NULL,NULL,'Malmquist cor.','NGC 4380',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93638,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93638,31.13,0.4,16.8,39495,75,NULL,'B','NGC 4380',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93639,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93639,31.12,0.43,16.8,39495,75,NULL,'3.6 micron, color corrected','NGC 4380',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93640,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93640,31.2,0.42,17.4,39495,65,NULL,NULL,'NGC 4380',NULL,'1980ApJ...238..458M',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93641,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93641,31.23,0.43,17.6,39495,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4380',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93642,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93642,31.43,0.35,19.3,39495,NULL,NULL,NULL,'NGC 4380',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93643,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93643,31.47,0.47,19.7,39495,75,NULL,'A82, H, raw','NGC 4380',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93644,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93644,31.47,0.4,19.7,39495,NULL,NULL,'mean','NGC 4380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93645,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93645,31.51,0.47,20.1,39495,75,NULL,'A82, H, inv','NGC 4380',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93646,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93646,31.56,0.45,20.5,39495,NULL,NULL,'K','NGC 4380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93647,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93647,31.57,0.47,20.6,39495,NULL,NULL,'H','NGC 4380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93648,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93648,31.59,0.46,20.8,39495,NULL,NULL,'J','NGC 4380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93649,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93649,31.66,0.47,21.5,39495,75,NULL,'A82, H, cor','NGC 4380',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93650,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93650,31.7,NULL,21.9,39495,NULL,NULL,'B','NGC 4380',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93651,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93651,31.73,NULL,22.2,39495,NULL,NULL,NULL,'NGC 4380',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93652,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93652,32.42,0.3,30.5,39495,55,NULL,'B','NGC 4380',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93653,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93653,38.14,0.21,425,39496,70,NULL,NULL,'2MASX J12252267+0922051',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000188,NULL,'17.0g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,186.344375,9.36797,0,NULL,58243814575,910059602,14219681,17),(93654,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93654,31.09,0.12,16.5,39497,NULL,NULL,'TOM(g) = -7.2 mag','MESSIER 085',NULL,'2010ApJ...717..603V',2010,1,7.1,NULL,'G',0.000006,NULL,'10.00',5.5,'SA(s)0+ pec','Pair member (points to parent)',NULL,NULL,NULL,1,186.3504583,18.1915,0.028,NULL,58913967961,920530749,14383292,10),(93655,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93655,31.29,0.12,18.1,39497,NULL,NULL,'TOM(z) = -8.53 mag','MESSIER 085',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93656,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93656,32.12,0.18,26.6,39497,NULL,NULL,'TOM(u) = -8.4 mag','MESSIER 085',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93657,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93657,32.32,0.23,29.1,39497,NULL,NULL,'TOM(g) = -7.2 mag','MESSIER 085',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93658,'PNLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93658,30.73,0.1,14,39497,NULL,NULL,NULL,'MESSIER 085',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93659,'PNLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93659,30.79,0.06,14.4,39497,NULL,NULL,'59 PNe','MESSIER 085',NULL,'1990ApJ...356..332J',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93660,'PNLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93660,30.83,0.14,14.7,39497,NULL,NULL,'HST KP Calibrated','MESSIER 085',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93661,'SNIa','2016-12-15 15:14:59','2016-12-16 11:20:09','1','SN 1960R',NULL,93661,30.7,0.36,13.8,39497,NULL,NULL,NULL,'MESSIER 085',NULL,'1992ApJ...390L..45P',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93662,'SNIa','2016-12-15 15:14:59','2016-12-16 11:20:09','1','SN 1960R',NULL,93662,31.1,0.4,16,39497,NULL,NULL,'Photographic','MESSIER 085',NULL,'1982ApJ...254....1A',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93663,'SNIa','2016-12-15 15:14:59','2016-12-16 11:20:09','1','SN 1960R','R',93663,31.37,NULL,18.8,39497,NULL,NULL,'Photographic','MESSIER 085',NULL,'1988SSRv...48....1R',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93664,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93664,31,0.12,15.9,39497,74.4,NULL,NULL,'MESSIER 085',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93665,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93665,31.26,0.05,17.9,39497,NULL,NULL,NULL,'MESSIER 085',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93666,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93666,31.26,0.07,17.9,39497,NULL,NULL,'HST ACS VCS','MESSIER 085',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93667,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93667,31.33,0.14,18.5,39497,NULL,NULL,'I','MESSIER 085',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93668,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93668,31.33,0.14,18.5,39497,NULL,NULL,NULL,'MESSIER 085',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93669,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93669,31.35,0.14,18.6,39497,NULL,NULL,'Malmquist cor.','MESSIER 085',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93670,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93670,31.39,0.17,19,39497,NULL,NULL,'HST KP Calibrated, I','MESSIER 085',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93671,'GC radius','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93671,30.88,0.06,15,39497,NULL,NULL,NULL,'MESSIER 085',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93672,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93672,29.15,0.81,6.76,39497,55,NULL,'Visvanathan & Sandage 1979','MESSIER 085',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93673,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93673,29.3,0.46,7.24,39497,95,NULL,'de Vaucouleurs','MESSIER 085',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93674,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93674,29.46,0.29,7.8,39497,95,NULL,'Weighted Mean','MESSIER 085',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93675,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93675,29.75,NULL,8.91,39497,NULL,NULL,'LEDA [April 2006]','MESSIER 085',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93676,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93676,30.14,0.63,10.7,39497,95,NULL,'Michard 1979b, c','MESSIER 085',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93677,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93677,30.15,0.46,10.7,39497,95,NULL,'Michard 1979a','MESSIER 085',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93678,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93678,29.66,0.41,8.56,39497,NULL,NULL,NULL,'MESSIER 085',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93679,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93679,30.01,0.41,10.1,39497,NULL,NULL,'Malmquist cor.','MESSIER 085',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93680,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93680,31,0.12,15.9,39497,74.4,NULL,NULL,'MESSIER 085',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93681,'Tertiary','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93681,30.49,0.25,12.5,39497,95,NULL,NULL,'MESSIER 085',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93682,'Tully est','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93682,31.13,0.8,16.8,39497,75,NULL,'B','MESSIER 085',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93683,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93683,37.57,0.46,327,39498,70,NULL,NULL,'2MASX J12252418+2947312',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000176,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,186.350625,29.792,0.045,NULL,58758996151,918109314,14345458,16.6),(93684,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93684,37.6,0.46,332,39499,70,NULL,NULL,'SDSS J122524.66+252600.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,186.3527917,25.43342,0.052,NULL,58646707046,916354797,14318043,17.7),(93685,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93685,37.57,0.46,327,39500,70,NULL,NULL,'2MASX J12252499+4427348',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000161,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,186.354208333,44.45978,0,NULL,59071902330,922998473,14421851,17),(93686,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93686,36.84,0.17,234,39501,70,NULL,NULL,'SDSS J122525.26+321002.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000165,NULL,'18.0g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,186.3552917,32.16733,0.028,NULL,58766490650,918226416,14347287,18),(93687,'Tully est','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93687,31.13,0.8,16.8,39502,75,NULL,'B','NGC 4383',NULL,'1988NBGC.C....0000T',1988,1,1.69,NULL,'G',0.00001,NULL,'12.8g',1.02,'Sa? pec        HII','in a radial-velocity based grouping',NULL,NULL,'Starburst',1,186.356333,16.47014,0.024,NULL,58154235992,908659937,14197811,12.8),(93688,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93688,31.19,NULL,17.3,39502,NULL,NULL,NULL,'NGC 4383',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93689,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93689,31.27,0.36,17.9,39502,NULL,NULL,NULL,'NGC 4383',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93690,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93690,31.44,0.45,19.4,39502,NULL,NULL,'K','NGC 4383',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93691,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93691,31.47,0.47,19.7,39502,NULL,NULL,'H','NGC 4383',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93692,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93692,31.52,0.46,20.1,39502,NULL,NULL,'J','NGC 4383',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93693,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93693,32.06,0.4,25.8,39502,NULL,NULL,'mean','NGC 4383',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93694,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93694,37.72,0.46,350,39503,70,NULL,NULL,'LCRS B122252.0-032553',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000102,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,186.3587083,-3.70828,0.073,NULL,42995163181,671799424,10496866,16.6),(93695,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93695,37.22,0.17,278,39504,70,NULL,NULL,'2MASX J12252652+3124141',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000107,NULL,'15.8g',0.48,NULL,NULL,NULL,NULL,NULL,1,186.360417,31.40397,0.023,NULL,58760062111,918125970,14345718,15.8),(93696,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93696,37.68,0.46,343,39505,70,NULL,NULL,'2MASX J12252695+2049288',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,186.3622917,20.82469,0.096,NULL,58910187003,920471671,14382369,17.5),(93697,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93697,35.29,0.33,115,39506,70,NULL,NULL,'2MASX J12252698+4545398',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000164,NULL,'15.6g',0.33,'S0',NULL,NULL,NULL,NULL,1,186.362333333,45.76094,0,NULL,59072058252,923000910,14421889,15.6),(93698,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93698,38.59,0.23,522,39507,70,NULL,NULL,'2MASX J12252778+3722366',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000146,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,186.365875,37.37692,0,NULL,58570722366,915167536,14299492,18.2),(93699,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93699,31.15,NULL,17,39508,NULL,NULL,NULL,'VCC 0802',NULL,'2014A&A...562A..49M',2014,1,0.81,NULL,'G',0.000067,NULL,'17.4',0.27,'BCD','Group member',NULL,NULL,NULL,1,186.3710417,13.49811,0.111,NULL,58161186049,908768532,14199508,17.4),(93700,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93700,37.22,0.17,278,39509,70,NULL,NULL,'2MASX J12253011+3135041',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.41',0.14,NULL,NULL,NULL,NULL,NULL,1,186.3754583,31.58458,0.023,NULL,58760025247,918125394,14345709,18.41),(93701,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93701,38.45,0.46,491,39510,70,NULL,NULL,'2MASX J12253011+0904211',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000169,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,186.3755417,9.07253,0,NULL,58243984878,910062263,14219722,16.9),(93702,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93702,38.14,0.21,425,39511,70,NULL,NULL,'2MASX J12253071+0923401',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00019,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,186.377958333,9.39442,0,NULL,58243816744,910059636,14219681,18.3),(93703,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93703,37.3,0.46,289,39512,70,NULL,NULL,'2MASX J12253093+0351500',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.16',0.13,NULL,NULL,NULL,NULL,NULL,1,186.378917,3.864,0,NULL,58007061411,906360334,14161880,18.16),(93704,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93704,37.22,0.17,278,39513,70,NULL,NULL,'2MASX J12253144+3124141',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.59',0.13,NULL,NULL,NULL,NULL,NULL,1,186.380917,31.40406,0.019,NULL,58760062577,918125977,14345718,18.59),(93705,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93705,34.35,0.66,74.2,39514,70,NULL,NULL,'MCG -01-32-007',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000093,NULL,'15',0.3,NULL,NULL,NULL,NULL,NULL,1,186.381167,-7.2365,0.065,NULL,43203181946,675049717,10547651,15),(93706,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93706,37.66,0.46,341,39515,70,NULL,NULL,'SDSS J122531.57+510707.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000137,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,186.3815417,51.11867,0,NULL,57243480307,894429379,13975459,18.5),(93707,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93707,37.62,0.33,334,39516,70,NULL,NULL,'2MASX J12253199+0418270',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,186.383166667,4.30761,0,NULL,58003687504,906307617,14161056,17.5),(93708,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93708,37.23,0.46,279,39517,70,NULL,NULL,'2MASX J12253207+2642452',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000179,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,186.383833333,26.71267,0.079,NULL,58638679014,916229359,14316083,16.9),(93709,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93709,38.88,0.46,596,39518,70,NULL,NULL,'SDSS J122532.13+051712.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,186.383917,5.28669,0,NULL,58225410943,909772045,14215188,18.5),(93710,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93710,37.55,0.27,324,39519,70,NULL,NULL,'2MASX J12253227+2340108',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.31',0.16,NULL,NULL,NULL,NULL,NULL,1,186.384417,23.66964,0.143,NULL,58644996234,916328066,14317626,18.31),(93711,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93711,38.1,0.46,417,39520,70,NULL,NULL,'VPC 0418',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000186,NULL,'17.0g',0.25,'AGN?',NULL,NULL,NULL,NULL,1,186.385916667,12.41675,0.093,NULL,58161738498,908777164,14199643,17),(93712,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93712,31.38,0.43,18.9,39521,75,NULL,'3.6 micron, color + selection bias corrected','IC 3311',NULL,'2014MNRAS.444..527S',2014,1,2.35,NULL,'G',0.000027,NULL,'14.87',0.32,'Sc (on edge)   HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,186.3879583,12.26033,0.053,NULL,58158934575,908733352,14198958,14.87),(93713,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93713,31.54,0.43,20.3,39521,75,NULL,'3.6 micron, color corrected','IC 3311',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93714,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93714,31.61,NULL,21,39521,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 3311',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93715,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93715,31.63,0.2,21.2,39521,74.4,NULL,NULL,'IC 3311',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93716,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93716,31.63,NULL,21.2,39521,NULL,NULL,'Dipole + Quadrupole','IC 3311',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93717,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93717,31.64,NULL,21.3,39521,NULL,NULL,'Dipole','IC 3311',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93718,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93718,37.62,0.33,334,39522,70,NULL,NULL,'SDSS J122533.14+041534.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,186.388125,4.25964,0,NULL,58003686165,906307596,14161056,17.6),(93719,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93719,30.76,0.13,14.2,39523,NULL,NULL,'R','MESSIER 087 DW27',NULL,'2004AJ....127..771J',2004,1,0.45,NULL,'G',0.000167,NULL,'16.5',0.45,'dE0,N','Group member',NULL,NULL,NULL,1,186.389708333,13.22722,0.112,NULL,58161323900,908770685,14199541,16.5),(93720,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93720,31.16,0.22,17.1,39523,NULL,NULL,'R','MESSIER 087 DW27',NULL,'2004AJ....127..771J',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93721,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93721,33.96,0.5,62,39524,70,NULL,NULL,'ESO 268- G 005',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00012,NULL,'14.73',0.6,'S0',NULL,NULL,NULL,NULL,1,186.39175,-45.26328,0.393,NULL,46723868593,730060446,11407194,14.73),(93722,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93722,38.2,0.46,436,39525,70,NULL,NULL,'2MASX J12253425+4317048',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000168,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,186.3927083,43.28458,0,NULL,59063158066,922861844,14419716,18.4),(93723,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93723,38.35,0.46,468,39526,70,NULL,NULL,'SDSS J122534.29+082832.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,186.392875,8.47558,0,NULL,58247484501,910116945,14220577,18.2),(93724,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93724,34.84,NULL,93.1,39527,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG +08-23-027',NULL,'2010Ap&SS.325..163P',2010,1,0.75,'1994A&AS..107..265G has V = 736 +- 11 km/s.','G',0.000092,NULL,'15.9g',0.23,'Sc',NULL,NULL,NULL,NULL,1,186.39475,45.43167,0,NULL,59072272590,923004259,14421941,15.9),(93725,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93725,34.86,NULL,93.6,39527,NULL,NULL,'Dipole + Quadrupole','MCG +08-23-027',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93726,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93726,34.87,NULL,94.3,39527,NULL,NULL,'Dipole','MCG +08-23-027',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93727,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93727,34.9,NULL,95.4,39527,NULL,NULL,NULL,'MCG +08-23-027',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93728,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93728,29.38,0.43,7.5,39528,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4389',NULL,'2014MNRAS.444..527S',2014,1,2.14,'Multiple SDSS entries describe this object.','G',0.000004,NULL,'12.6g',1.36,'SB(rs)bc pec:  HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.39625,45.68467,0,NULL,59072113393,923001771,14421902,12.6),(93729,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93729,29.65,0.43,8.5,39528,75,NULL,'3.6 micron, color corrected','NGC 4389',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93730,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93730,29.87,0.2,9.42,39528,74.4,NULL,NULL,'NGC 4389',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93731,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93731,30.15,0.39,10.7,39528,73,NULL,'opt','NGC 4389',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93732,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93732,30.73,0.35,14,39528,NULL,NULL,NULL,'NGC 4389',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93733,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93733,30.8,0.45,14.4,39528,NULL,NULL,'K','NGC 4389',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93734,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93734,30.81,0.47,14.5,39528,NULL,NULL,'H','NGC 4389',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93735,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93735,30.85,NULL,14.8,39528,NULL,NULL,'I, Hubble-type-TF','NGC 4389',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93736,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93736,30.87,0.46,14.9,39528,NULL,NULL,'J','NGC 4389',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93737,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93737,30.92,NULL,15.3,39528,NULL,NULL,'I','NGC 4389',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93738,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93738,30.96,0.4,15.5,39528,NULL,NULL,'mean','NGC 4389',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93739,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93739,31.15,0.4,17,39528,75,NULL,'B','NGC 4389',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93740,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93740,31.21,NULL,17.5,39528,NULL,NULL,'B, Hubble-type-TF','NGC 4389',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93741,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93741,31.34,NULL,18.5,39528,NULL,NULL,'B','NGC 4389',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93742,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93742,37.03,0.46,255,39529,70,NULL,NULL,'VPC 0421',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000179,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,186.3965,10.47472,0,NULL,58243129148,910048892,14219513,16.6),(93743,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93743,37.92,0.46,384,39530,70,NULL,NULL,'2MASX J12253582+2517031',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.57',0.13,NULL,NULL,NULL,NULL,NULL,1,186.399333,25.28417,0.059,NULL,58646537900,916352154,14318002,18.57),(93744,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93744,37.34,0.15,294,39531,70,NULL,NULL,'2MASX J12253607+6129167',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,186.40025,61.48786,0,NULL,57374981062,896484079,14007563,17.8),(93745,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93745,35.58,0.46,131,39532,70,NULL,NULL,'CGCG 014-030',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000107,NULL,'15.5g',0.39,'S0^0^','Group member',NULL,NULL,NULL,1,186.402875,-2.90056,0.069,NULL,42994318747,671786230,10496659,15.5),(93746,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93746,31.48,0.17,19.8,39533,NULL,NULL,'R','VCC 0815',NULL,'2004AJ....127..771J',2004,1,0.69,NULL,'G',0.000167,NULL,'16.1',0.55,'dE2,N','Group member',NULL,NULL,NULL,1,186.4050417,13.14372,0.112,NULL,58161151503,908767992,14199499,16.1),(93747,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93747,37.73,0.33,352,39534,70,NULL,NULL,'2MASX J12253733+4258048',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.89',0.17,NULL,NULL,NULL,NULL,NULL,1,186.4057083,42.96803,0,NULL,59063261391,922863459,14419741,17.89),(93748,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93748,37.22,0.17,278,39535,70,NULL,NULL,'2MASX J12253754+3129191',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000157,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,186.4064583,31.48875,0.023,NULL,58760023264,918125363,14345708,16.4),(93749,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93749,31.31,0.05,18.3,39536,NULL,NULL,'I','NGC 4373A',NULL,'1999ApJ...515...79P',1999,1,2.6,NULL,'G',0.000063,NULL,'12.6',0.8,'SA0+: sp       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,186.407208333,-39.31967,0.337,NULL,43280933194,676264581,10566634,12.6),(93750,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93750,32.86,0.52,37.3,39536,NULL,NULL,'I','NGC 4373A',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93751,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93751,32.94,0.14,38.7,39536,74.4,NULL,NULL,'NGC 4373A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93752,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93752,38.14,0.21,425,39537,70,NULL,NULL,'SDSS J122538.07+092415.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000148,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,186.408666667,9.40425,0,NULL,58245852346,910091442,14220178,18.7),(93753,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93753,37.46,0.46,310,39538,70,NULL,NULL,'VPC 0425',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000158,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,186.409041667,12.48722,0.108,NULL,58161860745,908779074,14199673,17.2),(93754,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93754,37.55,0.27,324,39539,70,NULL,NULL,'2MASX J12253878+3249031',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000176,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,186.411667,32.81761,NULL,NULL,58765315884,918208060,14347000,16.9),(93755,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93755,35.68,0.2,137,39540,74.4,NULL,NULL,'VCC 0822',NULL,'2013AJ....146...86T',2013,1,0.63,NULL,'G',0.000013,NULL,'16.1g',0.32,'SBc','Group member',NULL,NULL,NULL,1,186.4142083,8.91217,0,NULL,58244155444,910064928,14219764,16.1),(93756,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93756,37.73,0.46,351,39541,70,NULL,NULL,'VPC 0429',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000184,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,186.416333333,13.411,0.111,NULL,58161192192,908768628,14199509,17.3),(93757,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93757,38.09,0.46,415,39542,70,NULL,NULL,'2MASX J12253994+1605352',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00017,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,186.416583333,16.09314,0.03,NULL,58155040279,908672504,14198007,17.4),(93758,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93758,36.89,0.46,239,39543,70,NULL,NULL,'2MASX J12254098+2702151',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'18.22',0.18,NULL,NULL,NULL,NULL,NULL,1,186.420875,27.03739,0.084,NULL,58639416585,916240884,14316263,18.22),(93759,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93759,30.13,NULL,10.6,39544,NULL,NULL,NULL,'UGC 07512',NULL,'2013AJ....145..101K',2013,1,1.3,NULL,'G',0.000017,NULL,'15.00',0.6,'ImIV','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,186.422208333,2.15897,0.035,NULL,58012350840,906442981,14163171,15),(93760,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93760,30.89,0.4,15.1,39544,75,NULL,'B','UGC 07512',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93761,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93761,35.97,0.52,157,39545,NULL,NULL,'Malmquist cor.','2MASX J12254169+0710021',NULL,'2009ApJS..182..474S',2009,1,0.51,NULL,'G',0.000017,NULL,'16.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,186.423625,7.16719,0,NULL,58236604266,909946941,14217920,16.2),(93762,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93762,36.04,0.5,162,39545,NULL,NULL,NULL,'2MASX J12254169+0710021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93763,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93763,36.08,0.2,164,39545,74.4,NULL,NULL,'2MASX J12254169+0710021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93764,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93764,31,0.16,15.8,39546,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4387',NULL,'2010ApJ...717..603V',2010,1,1.59,'z=0.001574 (2003AJ....125.2891C)','G',0.000017,NULL,'12.8g',0.98,'E5','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.423667,12.81053,0.111,NULL,58161786184,908777909,14199654,12.8),(93765,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93765,31.02,0.18,16,39546,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4387',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93766,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93766,31.2,0.15,17.4,39546,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4387',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93767,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93767,31.32,0.13,18.4,39546,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4387',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93768,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93768,31.14,0.12,16.9,39546,74.4,NULL,NULL,'NGC 4387',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93769,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93769,31.27,0.06,17.9,39546,NULL,NULL,NULL,'NGC 4387',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93770,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93770,31.28,0.07,18,39546,NULL,NULL,'HST ACS VCS','NGC 4387',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93771,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93771,31.65,0.73,21.4,39546,NULL,NULL,'I','NGC 4387',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93772,'GC radius','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93772,31.07,0.13,16.4,39546,NULL,NULL,NULL,'NGC 4387',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93773,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93773,31.06,0.55,16.3,39546,95,NULL,'Weighted Mean','NGC 4387',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93774,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93774,31.08,0.55,16.4,39546,95,NULL,'de Vaucouleurs','NGC 4387',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93775,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93775,31,NULL,15.8,39546,NULL,NULL,NULL,'NGC 4387',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93776,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93776,31.14,0.12,16.9,39546,74.4,NULL,NULL,'NGC 4387',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93777,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93777,31.39,NULL,19,39546,NULL,NULL,NULL,'NGC 4387',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93778,'Tertiary','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93778,30.49,0.25,12.5,39546,95,NULL,NULL,'NGC 4387',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93779,'Tully est','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93779,31.13,0.8,16.8,39546,75,NULL,'B','NGC 4387',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93780,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93780,30.87,0.4,14.9,39546,NULL,NULL,'mean','NGC 4387',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93781,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93781,31.47,0.45,19.7,39546,NULL,NULL,'K','NGC 4387',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93782,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93782,36.28,0.46,180,39547,70,NULL,NULL,'2MASX J12254174+3632498',NULL,'2015arXiv151105856S',2015,1,0.36,'1998A&AS..131..295U has z = 0.017949: +- 0.000334.','G',0.000161,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,186.424,36.54719,0,NULL,58573426702,915209792,14300153,16.3),(93783,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93783,37.34,0.15,294,39548,70,NULL,NULL,'2MASX J12254239+6133327',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000189,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,186.426375,61.55906,0,NULL,57374966501,896483851,14007560,16.4),(93784,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93784,37.97,0.27,393,39549,70,NULL,NULL,'2MASX J12254237+6251207',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000174,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,186.426667,62.85575,0.009,NULL,57372340813,896442825,14006919,17.5),(93785,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93785,38.04,0.46,405,39550,70,NULL,NULL,'2MASX J12254246+5051521',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000145,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,186.4269583,50.86456,0,NULL,57240163102,894377548,13974649,17.6),(93786,'IRAS','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93786,31.39,0.8,19,39551,75,NULL,'A82, H','IC 3322A',NULL,'1997ApJS..109..333W',1997,1,3.43,NULL,'G',0.000013,NULL,'13.8g',0.54,'SB(s)cd: sp    HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.427333333,7.21667,0,NULL,58236615565,909947118,14217923,13.8),(93787,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93787,31.13,0.4,16.8,39551,75,NULL,'B','IC 3322A',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93788,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93788,31.51,0.42,20,39551,65,NULL,NULL,'IC 3322A',NULL,'1980ApJ...238..458M',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93789,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93789,31.69,0.4,21.8,39551,75,NULL,NULL,'IC 3322A',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93790,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93790,31.86,0.43,23.6,39551,75,NULL,'3.6 micron, color + selection bias corrected','IC 3322A',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93791,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93791,32,0.35,25.1,39551,NULL,NULL,NULL,'IC 3322A',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93792,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93792,32,0.43,25.1,39551,75,NULL,'3.6 micron, color corrected','IC 3322A',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93793,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93793,32.04,0.47,25.5,39551,75,NULL,'A82, H, raw','IC 3322A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93794,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93794,32.04,0.47,25.6,39551,75,NULL,'A82, H, inv','IC 3322A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93795,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93795,32.07,0.2,25.9,39551,74.4,NULL,NULL,'IC 3322A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93796,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93796,32.08,0.51,26.1,39551,NULL,NULL,'Malmquist cor.','IC 3322A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93797,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93797,32.16,0.49,27,39551,NULL,NULL,NULL,'IC 3322A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93798,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93798,32.16,0.47,27,39551,75,NULL,'A82, H, cor','IC 3322A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93799,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93799,32.29,0.3,28.8,39551,55,NULL,'B','IC 3322A',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93800,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93800,32.31,0.49,28.9,39551,75,NULL,'IR','IC 3322A',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93801,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93801,32.42,NULL,30.4,39551,NULL,NULL,NULL,'IC 3322A',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93802,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93802,32.44,NULL,30.7,39551,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 3322A',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93803,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93803,32.44,NULL,30.8,39551,NULL,NULL,'Dipole','IC 3322A',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93804,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93804,32.44,NULL,30.8,39551,NULL,NULL,'Dipole + Quadrupole','IC 3322A',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93805,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93805,32.62,0.4,33.5,39552,75,NULL,'B','NGC 4385',NULL,'1988NBGC.C....0000T',1988,1,2.02,'Confused HIPASS source','G',0.000017,NULL,'13.3g',1,'SB(rs)0+:;HII  Sbrst','Group member, radial-velocity confirmed',NULL,NULL,'Starburst',1,186.428333,0.57261,0.028,NULL,58007563319,906368176,14162002,13.3),(93806,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93806,37.97,0.27,393,39553,70,NULL,NULL,'2MASX J12254333+6245377',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'17.1g',0.25,'AGN',NULL,NULL,NULL,NULL,1,186.430375,62.7605,0.013,NULL,57372371024,896443297,14006926,17.1),(93807,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93807,37.34,0.15,294,39554,70,NULL,NULL,'2MASX J12254405+6131127',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000182,NULL,'15.9g',0.47,'E0',NULL,NULL,NULL,NULL,1,186.433583333,61.52014,0,NULL,57374968877,896483888,14007560,15.9),(93808,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93808,38.27,0.46,450,39555,70,NULL,NULL,'2MASX J12254465+2818311',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000174,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,186.43625,28.30869,0.081,NULL,58637400116,916209376,14315771,17.5),(93809,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93809,35.47,0.53,124,39556,70,NULL,NULL,'2MASX J12254550-3458170',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.6b',0.5,'E',NULL,NULL,NULL,NULL,1,186.439583,-34.97136,0.217,NULL,43261004720,675953198,10561768,15.6),(93810,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93810,37.48,0.46,313,39557,70,NULL,NULL,'2MASX J12254574+1842411',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,186.440625,18.71144,0.113,NULL,58915585157,920556018,14383687,16.6),(93811,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93811,35.29,0.33,115,39558,70,NULL,NULL,'CGCG 244-015',NULL,'2015arXiv151105856S',2015,1,0.97,NULL,'G',0.000173,NULL,'14.6g',0.71,'S0^-',NULL,NULL,NULL,NULL,1,186.442917,45.29019,0,NULL,59072202657,923003166,14421924,14.6),(93812,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93812,33.78,0.2,57,39559,74.4,NULL,NULL,'UGC 07516',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000033,NULL,'14.78',0.6,'Scd:','Group member',NULL,NULL,NULL,1,186.444667,4.50986,0,NULL,58003720383,906308130,14161064,14.78),(93813,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93813,33.95,0.56,61.8,39559,NULL,NULL,NULL,'UGC 07516',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93814,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93814,33.98,0.55,62.5,39559,NULL,NULL,'Malmquist cor.','UGC 07516',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93815,'IRAS','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93815,31.43,0.8,19.3,39560,75,NULL,'A82, H','NGC 4388',NULL,'1997ApJS..109..333W',1997,1,4.84,NULL,'G',0.000003,NULL,'12.1g',0.92,'SA(s)b: sp;Sy2 Sy1.9','Possible group member',NULL,'radio jet','Sy 1 h',1,186.4447917,12.66208,0.108,NULL,58161807389,908778240,14199660,12.1),(93816,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93816,30.67,0.92,13.6,39560,NULL,NULL,'CO','NGC 4388',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93817,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93817,30.89,NULL,15.1,39560,84,NULL,'RSA Hubble type','NGC 4388',NULL,'1986AJ.....91.1286S',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93818,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93818,30.91,0.7,15.2,39560,NULL,NULL,'HI','NGC 4388',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93819,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93819,31.09,0.42,16.5,39560,65,NULL,NULL,'NGC 4388',NULL,'1980ApJ...238..458M',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93820,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93820,31.13,0.4,16.8,39560,75,NULL,'B','NGC 4388',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93821,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93821,31.13,NULL,16.8,39560,NULL,NULL,NULL,'NGC 4388',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93822,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93822,31.16,0.47,17.1,39560,75,NULL,'A82, H, raw','NGC 4388',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93823,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93823,31.25,0.43,17.8,39560,75,NULL,'3.6 micron, color corrected','NGC 4388',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93824,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93824,31.27,0.47,18,39560,75,NULL,'A82, H, inv','NGC 4388',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93825,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93825,31.27,0.43,18,39560,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4388',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93826,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93826,31.29,0.2,18.1,39560,74.4,NULL,NULL,'NGC 4388',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93827,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93827,31.41,NULL,19.1,39560,NULL,NULL,'B','NGC 4388',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93828,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93828,31.41,NULL,19.1,39560,84,NULL,'RC2 Hubble type','NGC 4388',NULL,'1986AJ.....91.1286S',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93829,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93829,31.41,0.47,19.2,39560,75,NULL,'A82, H, cor','NGC 4388',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93830,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93830,31.96,0.46,24.7,39560,NULL,NULL,'J','NGC 4388',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93831,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93831,31.97,0.47,24.8,39560,NULL,NULL,'H','NGC 4388',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93832,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93832,32,0.49,25.1,39560,75,NULL,'IR','NGC 4388',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93833,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93833,32.04,0.45,25.6,39560,NULL,NULL,'K','NGC 4388',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93834,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93834,32.05,0.3,25.7,39560,55,NULL,'B','NGC 4388',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93835,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93835,32.94,0.4,38.7,39560,NULL,NULL,'mean','NGC 4388',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93836,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93836,37.06,0.46,258,39561,70,NULL,NULL,'SDSS J122547.21+463126.8',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000133,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,186.4467083,46.52414,0,NULL,59065736967,922902140,14420345,18.4),(93837,'Tully est','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93837,31.13,0.8,16.8,39562,75,NULL,NULL,'VCC 0841',NULL,'1988NBGC.C....0000T',1988,1,0.99,NULL,'G',0.000009,NULL,'15.5g',0.47,'BCD','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,186.448083,14.952,0.051,NULL,58155886411,908685725,14198214,15.5),(93838,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93838,29.49,NULL,7.91,39562,NULL,NULL,NULL,'VCC 0841',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93839,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93839,31.15,NULL,17,39562,NULL,NULL,NULL,'VCC 0841',NULL,'2014A&A...562A..49M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93840,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93840,37.23,0.46,279,39563,70,NULL,NULL,'KAZ 603',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.98',0.14,NULL,NULL,NULL,NULL,NULL,1,186.4482083,21.41186,NULL,NULL,58910590237,920477972,14382468,17.98),(93841,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93841,35.33,0.57,116,39564,70,NULL,NULL,'ESO 573- G 021',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000103,NULL,'15.10',1,'(R\')SB(rs)ab',NULL,NULL,NULL,NULL,1,186.448667,-21.74583,0.149,NULL,43951325356,686739458,10730304,15.1),(93842,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93842,37.16,0.46,270,39565,70,NULL,NULL,'2MASX J12254811+5952488',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000165,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,186.450667,59.88028,0,NULL,57335142393,895861599,13997837,16.8),(93843,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93843,38.14,0.46,425,39566,70,NULL,NULL,'SDSS J122548.81+645721.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000136,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,186.453375,64.95586,0.009,NULL,57324024564,895687883,13995123,18.3),(93844,'Brightest Stars','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93844,27.36,0.9,2.96,39567,NULL,NULL,'3, B, blue stars','NGC 4395',NULL,'1994MNRAS.271..530R',1994,1,13.2,'NGC 4399, 4400 and 4401 are HII regions in NGC 4395.','G',0.000004,NULL,'10.64',11,'SA(s)m:;LINER  Sy1.8','Probable group member',NULL,NULL,'Sy 1.8',1,186.453583,33.54692,0.014,1,58765804214,918215690,14347120,10.64),(93845,'Brightest Stars','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93845,27.49,0.88,3.15,39567,NULL,NULL,'3, B, blue stars','NGC 4395',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93846,'Brightest Stars','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93846,28.13,NULL,4.23,39567,NULL,NULL,NULL,'NGC 4395',NULL,'1998A&AS..131....1K',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93847,'Brightest Stars','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93847,28.8,0.6,5.75,39567,NULL,NULL,'3, B, red stars','NGC 4395',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93848,'Brightest Stars','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93848,28.82,0.03,5.81,39567,NULL,NULL,'Photographic','NGC 4395',NULL,'1982ApJ...256..339S',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93849,'Brightest Stars','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93849,29,0.6,6.31,39567,NULL,NULL,'V, 3, red stars','NGC 4395',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93850,'Cepheids','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93850,28.15,0.18,4.3,39567,NULL,NULL,'11, gri','NGC 4395',NULL,'2004AJ....127.2322T',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93851,'TRGB','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93851,28.32,NULL,4.61,39567,NULL,NULL,NULL,'NGC 4395',NULL,'2003A&A...398..467K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93852,'TRGB','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93852,28.39,0.1,4.76,39567,74.4,NULL,NULL,'NGC 4395',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93853,'TRGB','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93853,28.42,0.02,4.83,39567,NULL,NULL,'I','NGC 4395',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93854,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93854,27.78,0.4,3.6,39567,75,NULL,'B','NGC 4395',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93855,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93855,27.93,0.36,3.85,39567,NULL,NULL,NULL,'NGC 4395',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93856,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93856,28.21,NULL,4.39,39567,NULL,NULL,'LEDA [April 2006]','NGC 4395',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93857,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93857,31.3,0.19,18.2,39568,NULL,NULL,'R','VCC 0846',NULL,'2004AJ....127..771J',2004,1,0.4,NULL,'G',0.000167,NULL,'16.18',0.3,'E?','Group member',NULL,NULL,NULL,1,186.4605,13.19764,0.112,NULL,58161340628,908770947,14199546,16.18),(93858,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93858,29.21,0.69,6.96,39569,100,NULL,'mid-IR','NGC 4390',NULL,'2013ApJ...771...88L',2013,1,1.6,NULL,'G',0.000002,NULL,'13.5g',1.07,'Sbc(s) II      HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.461125,10.45906,0,NULL,58242999363,910046865,14219482,13.5),(93859,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93859,31.2,0.36,17.4,39569,NULL,NULL,NULL,'NGC 4390',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93860,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93860,31.68,0.4,21.6,39569,NULL,NULL,'mean','NGC 4390',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93861,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93861,32.09,NULL,26.2,39569,NULL,NULL,NULL,'NGC 4390',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93862,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93862,32.31,0.47,29,39569,NULL,NULL,'H','NGC 4390',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93863,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93863,32.32,0.46,29.2,39569,NULL,NULL,'J','NGC 4390',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93864,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93864,32.35,0.45,29.5,39569,NULL,NULL,'K','NGC 4390',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93865,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93865,35.15,0.2,107,39570,74.4,NULL,NULL,'VCC 0847',NULL,'2013AJ....146...86T',2013,1,0.63,NULL,'G',0.000023,NULL,'15.7g',0.32,'SBc','Group member',NULL,NULL,NULL,1,186.4622917,8.92081,0,NULL,58244154005,910064906,14219764,15.7),(93866,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93866,29.93,0.4,9.7,39571,75,NULL,'B','NGC 4393',NULL,'1988NBGC.C....0000T',1988,1,3.2,NULL,'G',0.000037,NULL,'12.7',3,'SABd','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.463458333,27.56156,0.077,NULL,58639825450,916247272,14316363,12.7),(93867,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93867,30.31,0.4,11.5,39571,NULL,NULL,NULL,'NGC 4393',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93868,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93868,30.3,0.4,11.5,39571,73,NULL,'opt','NGC 4393',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93869,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93869,37.64,0.46,338,39572,70,NULL,NULL,'2MASX J12255152+1523122',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,186.464666667,15.38669,0,NULL,58157947732,908717933,14198717,17.8),(93870,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93870,38.14,0.21,425,39573,70,NULL,NULL,'2MASX J12255171+0926093',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.64',0.13,NULL,NULL,NULL,NULL,NULL,1,186.465541667,9.43611,0,NULL,58245846690,910091354,14220177,18.64),(93871,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93871,37.45,0.46,309,39574,70,NULL,NULL,'2MASX J12255189+3503109',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000181,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,186.4662917,35.05311,0.021,NULL,58540853903,914700842,14292200,16.9),(93872,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93872,37.16,0.23,270,39575,70,NULL,NULL,'2MASX J12255302+0644263',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00018,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,186.471,6.74061,0,NULL,58237862644,909966603,14218228,16.4),(93873,'FP','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93873,38.36,0.27,471,39576,70,NULL,NULL,'2MASX J12255371+4051118',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,186.473708333,40.85331,0,NULL,58528150303,914502348,14289099,17.7),(93874,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,'R',93874,31.31,0.49,18.3,39577,75,NULL,'IR','IC 3322',NULL,'2011yCatp016004901K',2011,1,2.67,NULL,'G',0.00001,NULL,'14.0g',0.58,'SAB(s)cd: sp   HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,186.475417,7.55478,0,NULL,58236433553,909944274,14217879,14),(93875,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93875,31.37,0.43,18.8,39577,75,NULL,'3.6 micron, color + selection bias corrected','IC 3322',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93876,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93876,31.46,0.5,19.6,39577,NULL,NULL,NULL,'IC 3322',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93877,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:09','1',NULL,NULL,93877,31.5,0.2,20,39577,74.4,NULL,NULL,'IC 3322',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93878,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93878,31.51,0.49,20,39577,NULL,NULL,'Malmquist cor.','IC 3322',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93879,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93879,31.51,0.43,20.1,39577,75,NULL,'3.6 micron, color corrected','IC 3322',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93880,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93880,31.53,0.36,20.2,39577,NULL,NULL,NULL,'IC 3322',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93881,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93881,31.58,NULL,20.7,39577,NULL,NULL,NULL,'IC 3322',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93882,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93882,31.73,0.4,22.2,39577,NULL,NULL,'mean','IC 3322',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93883,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93883,32.01,0.47,25.2,39577,NULL,NULL,'H','IC 3322',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93884,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93884,32.03,0.46,25.5,39577,NULL,NULL,'J','IC 3322',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93885,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93885,32.11,0.45,26.4,39577,NULL,NULL,'K','IC 3322',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93886,'Ring Diameter','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93886,31,0.76,16,39578,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4394',NULL,'1981ApJS...45..541P',1981,1,3.6,NULL,'G',0.000013,NULL,'11.73',3.2,'(R)SB(r)b      LINER','Pair member (points to parent)',NULL,NULL,NULL,1,186.481375,18.21406,0.028,NULL,58913944990,920530390,14383287,11.73),(93887,'Ring Diameter','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93887,31.4,0.6,19,39578,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4394',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93888,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93888,31.13,0.4,16.8,39578,75,NULL,'B','NGC 4394',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93889,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',93889,38.24,0.17,444,39579,70,NULL,NULL,'CGPG 1223.6+6345',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000156,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,186.484667,63.48703,0.025,NULL,57371983822,896437247,14006831,17.3),(93890,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',93890,38.01,0.46,400,39580,70,NULL,NULL,'2MASX J12255662+4647207',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,186.485875,46.78917,0,NULL,59065626411,922900412,14420318,17.7),(93891,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',93891,37.91,0.46,381,39581,70,NULL,NULL,'2MASX J12255661+5131140',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000166,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,186.486,51.52056,0,NULL,57243856636,894435259,13975550,16.9),(93892,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',93892,38.02,0.46,402,39582,70,NULL,NULL,'2MASX J12255728+1550052',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,186.4885417,15.83489,0.03,NULL,58154411756,908662683,14197854,17.5),(93893,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',93893,37.5,0.46,316,39583,70,NULL,NULL,'VPC 0444',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,186.4900417,14.73689,0.08,NULL,58156109208,908689206,14198268,17.6),(93894,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93894,30.99,0.19,15.8,39584,NULL,NULL,'TOM(g) = -7.2 mag','IC 3328',NULL,'2010ApJ...717..603V',2010,1,0.97,NULL,'G',0.000033,NULL,'14.5g',0.92,'dE,N','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,186.491375,10.05378,0,NULL,58242894149,910045221,14219456,14.5),(93895,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93895,31.09,0.26,16.5,39584,NULL,NULL,'TOM(g) = -7.2 mag','IC 3328',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93896,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93896,31.2,0.19,17.4,39584,NULL,NULL,'TOM(u) = -8.4 mag','IC 3328',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93897,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93897,31.3,0.16,18.2,39584,NULL,NULL,'TOM(z) = -8.53 mag','IC 3328',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93898,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93898,31.12,0.14,16.8,39584,74.4,NULL,NULL,'IC 3328',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93899,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93899,31.13,0.07,16.8,39584,NULL,NULL,NULL,'IC 3328',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93900,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93900,31.14,0.08,16.9,39584,NULL,NULL,'HST ACS VCS','IC 3328',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93901,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93901,31.28,0.25,18,39584,NULL,NULL,'R','IC 3328',NULL,'2004AJ....127..771J',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93902,'GC radius','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93902,30.28,0.13,11.4,39584,NULL,NULL,NULL,'IC 3328',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93903,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93903,31.4,0.45,19.1,39584,NULL,NULL,'K','IC 3328',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93904,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93904,31.53,0.4,20.2,39584,NULL,NULL,'mean','IC 3328',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93905,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',93905,36.57,0.27,206,39585,70,NULL,NULL,'2MASX J12255801+3101190',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00009,NULL,'15.3g',0.56,NULL,NULL,NULL,NULL,NULL,1,186.491833,31.02203,0.019,NULL,58759749358,918121083,14345641,15.3),(93906,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',93906,37.16,0.23,270,39586,70,NULL,NULL,'SDSS J122558.23+064253.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,186.492667,6.71472,0,NULL,58237865954,909966655,14218228,18.4),(93907,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',93907,37.02,0.46,254,39587,70,NULL,NULL,'2MASX J12255834+1745372',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.02',0.16,NULL,NULL,NULL,NULL,NULL,1,186.49325,17.76042,0.023,NULL,58914216927,920534639,14383353,18.02),(93908,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93908,32.64,0.43,33.7,39588,75,NULL,'3.6 micron, color + selection bias corrected','UGC 07522',NULL,'2014MNRAS.444..527S',2014,1,3.64,'The 2MASS position refers to the southeastern part of the galaxy.','G',0.000007,NULL,'14.1g',0.42,'Sd(f);Sy       LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,186.493167,3.43028,0.024,NULL,58006313658,906348650,14161697,14.1),(93909,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',93909,32.69,0.49,34.5,39588,75,NULL,'IR','UGC 07522',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93910,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93910,32.75,0.43,35.4,39588,75,NULL,'3.6 micron, color corrected','UGC 07522',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93911,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93911,32.8,0.36,36.3,39588,NULL,NULL,NULL,'UGC 07522',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93912,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93912,32.85,0.51,37.1,39588,NULL,NULL,'Malmquist cor.','UGC 07522',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93913,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93913,32.87,0.2,37.5,39588,74.4,NULL,NULL,'UGC 07522',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93914,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93914,33.11,0.45,41.8,39588,NULL,NULL,NULL,'UGC 07522',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93915,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93915,33.26,NULL,44.8,39588,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07522',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93916,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93916,33.26,NULL,44.9,39588,NULL,NULL,'Dipole','UGC 07522',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93917,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93917,33.26,NULL,44.9,39588,NULL,NULL,'Dipole + Quadrupole','UGC 07522',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93918,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93918,33.33,NULL,46.4,39588,NULL,NULL,NULL,'UGC 07522',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93919,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93919,33.37,0.3,47.2,39588,55,NULL,'B','UGC 07522',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93920,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93920,34.17,0.73,68.1,39589,NULL,NULL,'Malmquist cor.','ESO 268- G 006',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.44',0.2,'S',NULL,NULL,NULL,NULL,1,186.494,-44.67989,0.405,NULL,46720693488,730010835,11406419,16.44),(93921,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93921,34.25,0.71,70.7,39589,NULL,NULL,NULL,'ESO 268- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93922,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93922,34.29,0.2,72.1,39589,74.4,NULL,NULL,'ESO 268- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93923,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93923,31,NULL,15.8,39590,NULL,NULL,NULL,'NGC 4396',NULL,'1999MNRAS.304..595G',1999,1,3.3,'HOLM 400B is a double star.','G',0.00001,NULL,'13.06',1,'SAd: sp        HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.495083,15.67147,0.035,NULL,58154390238,908662347,14197849,13.06),(93924,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',93924,37.16,0.23,270,39591,70,NULL,NULL,'2MASX J12255946+0645463',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000188,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,186.4977083,6.76294,0,NULL,58237798393,909965599,14218212,16.2),(93925,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',93925,36.66,0.46,215,39592,70,NULL,NULL,'2MASX J12255987+3147110',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000093,NULL,'17.08',0.2,NULL,NULL,NULL,NULL,NULL,1,186.499625,31.78642,0.025,NULL,58766549078,918227329,14347302,17.08),(93926,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',93926,37.33,0.46,293,39593,70,NULL,NULL,'2MASX J12260058+0439163',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.16',0.14,NULL,NULL,NULL,NULL,NULL,1,186.5022917,4.65442,0,NULL,58003671543,906307367,14161052,18.16),(93927,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',93927,37.07,0.46,259,39594,70,NULL,NULL,'2MASX J12260161+6242432',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000166,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,186.506375,62.71217,0.013,NULL,57372326266,896442597,14006915,17.3),(93928,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93928,34.25,NULL,70.7,39595,NULL,NULL,'Dipole + Quadrupole + Octopole','KUG 1223+260',NULL,'2010Ap&SS.325..163P',2010,1,1.06,'The KUG position refers to a neighboring star.','G',0.00006,NULL,'17.08',0.15,'Sd',NULL,NULL,NULL,NULL,1,186.509375,25.79494,0.06,NULL,58646028869,916344201,14317878,17.08),(93929,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93929,34.27,NULL,71.3,39595,NULL,NULL,'Dipole + Quadrupole','KUG 1223+260',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93930,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93930,34.28,NULL,71.6,39595,NULL,NULL,'Dipole','KUG 1223+260',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93931,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93931,34.33,NULL,73.5,39595,NULL,NULL,NULL,'KUG 1223+260',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93932,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',93932,34.44,0.49,77.3,39595,75,NULL,'IR','KUG 1223+260',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93933,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',93933,38.36,0.27,471,39596,70,NULL,NULL,'2MASX J12260253+4053578',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000182,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,186.510583,40.89939,0,NULL,58528138590,914502165,14289096,17.3),(93934,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',93934,38,0.46,399,39597,70,NULL,NULL,'2MASX J12260346-0042250',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000077,NULL,'17.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,186.5145,-0.70694,0.041,NULL,42991390729,671740480,10495945,17.9),(93935,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',93935,37.76,0.33,357,39598,70,NULL,NULL,'2MASX J12260529+6131282',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000134,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,186.5222083,61.52447,0,NULL,57374980047,896484063,14007563,18.1),(93936,'TRGB','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93936,31.2,0.17,17.4,39599,NULL,NULL,NULL,'VCC 0871',NULL,'2006ApJ...651..822C',2006,1,0.82,NULL,'G',0.000117,NULL,'16.1g',0.52,'dE,N','Group member',NULL,NULL,NULL,1,186.5235,12.55964,0.093,NULL,58161838234,908778722,14199667,16.1),(93937,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',93937,37.69,0.46,345,39600,70,NULL,NULL,'SDSS J122606.07+292958.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000175,NULL,'18.5g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,186.525333,29.49958,0.055,NULL,58758205962,918096968,14345265,18.5),(93938,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',93938,38.36,0.27,471,39601,70,NULL,NULL,'2MASX J12260683+4055254',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,186.52825,40.92369,0,NULL,58528137487,914502148,14289096,17.4),(93939,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93939,30.95,0.69,15.5,39602,100,NULL,'mid-IR','NGC 4405',NULL,'2013ApJ...771...88L',2013,1,1.82,NULL,'G',0.000033,NULL,'12.8g',1.16,'SA(rs)0/a:     HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.5297917,16.181,0.024,NULL,58155061598,908672837,14198013,12.8),(93940,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',93940,36.57,0.27,206,39603,70,NULL,NULL,'2MASX J12260726+3100250',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000107,NULL,'15.4g',0.53,NULL,NULL,NULL,NULL,NULL,1,186.530417,31.00689,0.015,NULL,58759747002,918121046,14345641,15.4),(93941,'SNIa','2016-12-15 15:14:59','2016-12-16 11:20:10','1','SN 1976B','R',93941,34.24,NULL,70.5,39604,NULL,NULL,'Photographic','NGC 4402',NULL,'1988SSRv...48....1R',1988,1,3.9,NULL,'G',0.000017,NULL,'12.55',1.1,'Sb             HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.531875,13.11333,0.119,NULL,58161154275,908768035,14199500,12.55),(93942,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93942,29.8,NULL,9.1,39604,84,NULL,'RC2 Hubble type','NGC 4402',NULL,'1986AJ.....91.1286S',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93943,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93943,30.29,NULL,11.4,39604,NULL,NULL,NULL,'NGC 4402',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93944,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93944,30.49,0.43,12.5,39604,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4402',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93945,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93945,30.5,0.92,12.6,39604,NULL,NULL,'CO','NGC 4402',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93946,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93946,30.75,0.43,14.2,39604,75,NULL,'3.6 micron, color corrected','NGC 4402',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93947,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93947,30.8,0.3,14.5,39604,NULL,18.45,'SN 1976B host','NGC 4402',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93948,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93948,30.81,NULL,14.5,39604,84,NULL,'RSA Hubble type','NGC 4402',NULL,'1986AJ.....91.1286S',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93949,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93949,30.91,NULL,15.2,39604,NULL,NULL,'B','NGC 4402',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93950,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93950,30.99,0.7,15.8,39604,NULL,NULL,'HI','NGC 4402',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93951,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93951,31.02,0.2,16,39604,74.4,NULL,NULL,'NGC 4402',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93952,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93952,31.05,0.35,16.2,39604,NULL,NULL,NULL,'NGC 4402',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93953,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93953,32.07,0.3,26,39604,55,NULL,'B','NGC 4402',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93954,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93954,34.78,0.53,90.4,39605,70,NULL,NULL,'2MASX J12260773-5132500',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,186.532333333,-51.54717,0.713,NULL,44627382543,697302852,10895357,16.8),(93955,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93955,30.11,NULL,10.5,39606,NULL,NULL,NULL,'UGC 07534',NULL,'2013AJ....145..101K',2013,1,2.6,NULL,'G',0.000003,NULL,'14.5',2.1,'IBm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,186.53375,58.3225,0,NULL,57404522564,896945665,14014776,14.5),(93956,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93956,30.88,0.4,15,39606,75,NULL,'B','UGC 07534',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93957,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',93957,35.54,0.46,128,39607,70,NULL,NULL,'CGCG 128-088',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.001284,NULL,'15.7',0.4,'E?',NULL,NULL,NULL,NULL,1,186.5347083,20.33572,0.117,NULL,58910070088,920469845,14382341,15.7),(93958,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',93958,37.35,0.46,296,39608,70,NULL,NULL,'2MASX J12260892+3948274',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000153,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,186.537041667,39.80764,0,NULL,58577276002,915269937,14301092,18.3),(93959,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',93959,37.97,0.27,393,39609,70,NULL,NULL,'2MASX J12260931+6243472',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000139,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,186.5389583,62.72992,0.013,NULL,57372318312,896442473,14006913,17.7),(93960,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93960,31.8,0.43,22.9,39610,75,NULL,'3.6 micron, color + selection bias corrected','ESO 322- G 009',NULL,'2014MNRAS.444..527S',2014,1,1.6,NULL,'G',0.000023,NULL,'14.10',0.9,'SB(rs)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,186.540917,-39.12397,0.337,NULL,43280856476,676263382,10566615,14.1),(93961,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93961,31.87,0.43,23.7,39610,75,NULL,'3.6 micron, color corrected','ESO 322- G 009',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93962,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93962,31.9,0.2,24,39610,74.4,NULL,NULL,'ESO 322- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93963,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',93963,36.35,0.46,186,39611,70,NULL,NULL,'2MASX J12261115+6713540',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000074,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,186.546667,67.23158,0.009,NULL,57849060173,903891565,14123305,16.4),(93964,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',93964,35.1,0.46,105,39612,70,NULL,NULL,'CGCG 014-036',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000064,NULL,'15.2g',0.56,'SA(r)0-?',NULL,NULL,NULL,NULL,1,186.546791667,-2.36064,0.065,NULL,42996848572,671825758,10497277,15.2),(93965,'Cepheids','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93965,31.22,0.15,17.5,39613,NULL,NULL,'HST KP Calibrated, K\'','MESSIER 086',NULL,'2000ApJ...529..745F',2000,1,8.9,'HOLM 403H is a star.','G',0.000017,NULL,'9.83',5.8,'S0(3)/E3','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.548917,12.94622,0.111,NULL,58161117035,908767453,14199491,9.83),(93966,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93966,30.35,0.1,11.7,39613,NULL,NULL,'Photographic, TOM(B) = -6.40 mag','MESSIER 086',NULL,'1987AJ.....94..906H',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93967,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93967,30.45,0.14,12.3,39613,NULL,NULL,'blue GCs, TOM(V) = -7.17 mag','MESSIER 086',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93968,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93968,30.46,0.1,12.4,39613,NULL,NULL,'Photographic, TOM(B) = -6.40 mag','MESSIER 086',NULL,'1987AJ.....94..906H',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93969,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93969,31.01,0.11,15.9,39613,NULL,NULL,'all GCs, TOM(V) = -7.63 mag','MESSIER 086',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93970,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93970,31.07,0.17,16.4,39613,NULL,NULL,'red GCs, TOM(V) = -7.55 mag','MESSIER 086',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93971,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93971,31.09,0.09,16.5,39613,NULL,NULL,'TOM(g) = -7.2 mag','MESSIER 086',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93972,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93972,31.15,0.1,17,39613,NULL,NULL,'TOM(g) = -7.2 mag','MESSIER 086',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93973,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93973,31.21,0.07,17.5,39613,NULL,NULL,NULL,'MESSIER 086',NULL,'2001AJ....121.2950K',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93974,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93974,31.23,0.3,17.6,39613,NULL,NULL,'R','MESSIER 086',NULL,'1994AJ....108.2087A',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93975,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93975,31.23,0.09,17.7,39613,NULL,NULL,'TOM(u) = -8.4 mag','MESSIER 086',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93976,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93976,31.31,0.08,18.3,39613,NULL,NULL,'TOM(z) = -8.53 mag','MESSIER 086',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93977,'GCLF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',93977,32.19,NULL,27.4,39613,NULL,NULL,'TOM(B) = -7.0 mag','MESSIER 086',NULL,'1988ASPC....4..231H',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93978,'PNLF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93978,30.92,0.09,15.3,39613,NULL,NULL,NULL,'MESSIER 086',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93979,'PNLF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93979,30.98,0.05,15.7,39613,NULL,NULL,'59 PNe','MESSIER 086',NULL,'1990ApJ...356..332J',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93980,'PNLF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93980,31.01,0.08,15.9,39613,NULL,NULL,'I','MESSIER 086',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93981,'PNLF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93981,31.03,0.13,16.1,39613,NULL,NULL,'HST KP Calibrated','MESSIER 086',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93982,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93982,30.8,NULL,14.7,39613,NULL,NULL,'I','MESSIER 086',NULL,'1989ApJ...346L..57T',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93983,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93983,31.01,0.14,15.9,39613,NULL,NULL,'I','MESSIER 086',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93984,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93984,31.06,0.1,16.3,39613,NULL,NULL,'K','MESSIER 086',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93985,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93985,31.08,0.06,16.4,39613,NULL,NULL,'K','MESSIER 086',NULL,'1996ApJ...468..519J',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93986,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93986,31.13,0.07,16.8,39613,NULL,NULL,NULL,'MESSIER 086',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93987,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93987,31.16,0.12,17.1,39613,74.4,NULL,NULL,'MESSIER 086',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93988,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93988,31.16,0.11,17.1,39613,NULL,NULL,'I','MESSIER 086',NULL,'1998MNRAS.298..451M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93989,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93989,31.17,0.14,17.1,39613,NULL,NULL,'I','MESSIER 086',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93990,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93990,31.17,0.14,17.1,39613,NULL,NULL,NULL,'MESSIER 086',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93991,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93991,31.17,0.14,17.1,39613,NULL,NULL,NULL,'MESSIER 086',NULL,'2001ApJ...550..503J',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93992,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93992,31.19,0.07,17.3,39613,NULL,NULL,'I','MESSIER 086',NULL,'1997AJ....114..626A',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93993,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93993,31.19,0.07,17.3,39613,NULL,NULL,'I','MESSIER 086',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93994,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93994,31.2,0.1,17.4,39613,NULL,NULL,'I','MESSIER 086',NULL,'1999ApJ...515...79P',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93995,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93995,31.2,0.14,17.4,39613,NULL,NULL,'Malmquist cor.','MESSIER 086',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93996,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93996,31.2,0.2,17.4,39613,NULL,NULL,'I','MESSIER 086',NULL,'1993A&A...275..433B',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93997,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93997,31.24,0.08,17.7,39613,NULL,NULL,'I','MESSIER 086',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93998,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93998,31.26,0.07,17.9,39613,NULL,NULL,'HST ACS VCS','MESSIER 086',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93999,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,93999,31.27,0.12,17.9,39613,NULL,NULL,'HST KP Calibrated, F814W','MESSIER 086',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94000,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94000,31.32,0.06,18.4,39613,NULL,NULL,'I','MESSIER 086',NULL,'1990AJ....100.1416T',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94001,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94001,31.33,0.12,18.5,39613,NULL,NULL,'HST KP Calibrated, I','MESSIER 086',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94002,'SBF','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94002,31.45,0.12,19.5,39613,NULL,NULL,'I','MESSIER 086',NULL,'2000ApJ...536..255N',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94003,'GC radius','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94003,30.82,0.06,14.6,39613,NULL,NULL,NULL,'MESSIER 086',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94004,'D-Sigma','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94004,31.13,0.4,16.8,39613,75,NULL,'Edat, raw','MESSIER 086',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94005,'D-Sigma','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94005,31.15,0.4,17,39613,75,NULL,'Edat, cor','MESSIER 086',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94006,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94006,30.15,0.31,10.7,39613,95,NULL,'de Vaucouleurs','MESSIER 086',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94007,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94007,30.26,0.24,11.3,39613,95,NULL,'Weighted Mean','MESSIER 086',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94008,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94008,30.33,NULL,11.6,39613,NULL,NULL,'LEDA [April 2006]','MESSIER 086',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94009,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94009,30.72,0.63,13.9,39613,95,NULL,'Michard 1979b, c','MESSIER 086',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94010,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94010,30.74,0.46,14.1,39613,95,NULL,'Michard 1979a','MESSIER 086',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94011,'Faber-Jackson','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94011,31.08,0.81,16.4,39613,55,NULL,'Visvanathan & Sandage 1979','MESSIER 086',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94012,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94012,30.56,0.41,13,39613,NULL,NULL,NULL,'MESSIER 086',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94013,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94013,30.85,0.41,14.8,39613,NULL,NULL,'Malmquist cor.','MESSIER 086',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94014,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94014,30.88,NULL,15,39613,NULL,NULL,NULL,'MESSIER 086',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94015,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94015,31.16,0.12,17.1,39613,74.4,NULL,NULL,'MESSIER 086',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94016,'Tertiary','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94016,30.49,0.25,12.5,39613,95,NULL,NULL,'MESSIER 086',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94017,'Tully est','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94017,31.13,0.8,16.8,39613,75,NULL,'B','MESSIER 086',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94018,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94018,37.82,0.46,367,39614,70,NULL,NULL,'SDSS J122611.94+682703.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000069,NULL,'18.3g',0.13,'NLAGN',NULL,NULL,NULL,NULL,1,186.549875,68.45086,0.065,NULL,57851095191,903923362,14123802,18.3),(94019,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94019,37.21,0.46,276,39615,70,NULL,NULL,'2MASX J12261268+0645103',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,186.55275,6.75306,0,NULL,58237802934,909965670,14218213,17.4),(94020,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94020,33.06,0.57,40.9,39616,70,NULL,NULL,'NGC 4403',NULL,'2014MNRAS.445.2677S',2014,1,1.9,NULL,'G',0.00003,NULL,'13.04',0.6,'SA(r)ab pec sp',NULL,NULL,NULL,NULL,1,186.5532917,-7.68494,0.065,NULL,43202786025,675043531,10547555,13.04),(94021,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94021,34.48,0.4,78.5,39616,NULL,NULL,'mean','NGC 4403',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94022,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94022,34.7,0.47,87,39616,NULL,NULL,'H','NGC 4403',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94023,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94023,34.75,0.45,89.2,39616,NULL,NULL,'K','NGC 4403',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94024,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94024,34.76,0.46,89.4,39616,NULL,NULL,'J','NGC 4403',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94025,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94025,37.98,0.46,394,39617,70,NULL,NULL,'2MASX J12261329+3424150',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,186.5555417,34.40419,0.013,NULL,58763175499,918174617,14346478,17.6),(94026,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94026,38.59,0.23,522,39618,70,NULL,NULL,'2MASX J12261344+3725285',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000182,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,186.556,37.42472,0,NULL,58570707635,915167306,14299489,18.2),(94027,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94027,38.26,0.46,448,39619,70,NULL,NULL,'SDSS J122613.62+250646.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,186.556791667,25.11292,0.06,NULL,58646574580,916352727,14318011,18.2),(94028,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94028,37.76,0.21,357,39620,70,NULL,NULL,'2MASX J12261439+4952543',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,186.5597083,49.88172,0,NULL,57238032030,894344250,13974128,17.4),(94029,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94029,37.45,0.46,309,39621,70,NULL,NULL,'2MASX J12261488+2529408',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.53',0.13,NULL,NULL,NULL,NULL,NULL,1,186.562041667,25.49478,0.058,NULL,58646674822,916354294,14318035,18.53),(94030,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94030,37.91,0.08,383,39622,70,NULL,NULL,'2MASX J12261509+0851453',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000142,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,186.562833,8.86264,0,NULL,58243614366,910056474,14219632,17.5),(94031,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94031,37.89,0.46,379,39623,70,NULL,NULL,'2MASX J12261547+4710018',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000182,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,186.564666667,47.16711,0,NULL,59065947890,922905435,14420397,16.6),(94032,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94032,38.59,0.23,522,39624,70,NULL,NULL,'2MASX J12261561+3729205',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000201,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,186.564917,37.48903,0,NULL,58584543545,915383492,14302867,16.5),(94033,'Brightest Stars','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94033,28.56,NULL,5.15,39625,NULL,NULL,'LF','UGCA 281',NULL,'1997AstL...23..656G',1997,1,0.8,'Multiple SDSS entries describe this object.','G',0.000013,NULL,'15.15',0.6,'Sm pec;BCDG;WR?HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,186.566333,48.4935,0,NULL,57184443143,893506924,13961045,15.15),(94034,'Brightest Stars','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94034,28.79,0.4,5.73,39625,NULL,NULL,'3B + 3R mean','UGCA 281',NULL,'1997AstL...23..656G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94035,'TRGB','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94035,28.78,0.1,5.7,39625,74.4,NULL,NULL,'UGCA 281',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94036,'TRGB','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94036,28.9,0.2,5.9,39625,NULL,NULL,'H','UGCA 281',NULL,'2001AJ....121.3007S',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94037,'TRGB','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94037,28.85,0.18,5.9,39625,NULL,NULL,NULL,'UGCA 281',NULL,'2014A&A...566A..71L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94038,'Tully est','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94038,28.36,0.8,4.7,39625,75,NULL,'B','UGCA 281',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94039,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94039,34.7,0.48,87,39626,70,NULL,NULL,'NGC 4404',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000067,NULL,'13.13',0.9,'SA(r)0- pec:  LINER?',NULL,NULL,NULL,NULL,1,186.5675417,-7.68083,0.065,NULL,43202778595,675043415,10547553,13.13),(94040,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94040,35.29,0.46,114,39627,70,NULL,NULL,'NGC 4408',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.00008,NULL,'15.1g',0.44,'S0',NULL,NULL,NULL,NULL,1,186.571833333,27.87117,0.087,NULL,58636936880,916202138,14315658,15.1),(94041,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94041,37.07,0.46,259,39628,70,NULL,NULL,'2MASX J12261726+5232303',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000151,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,186.572041667,52.54189,0.046,NULL,57228535944,894195874,13971810,17.3),(94042,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94042,37.53,0.46,321,39629,70,NULL,NULL,'2MASX J12261777+6429413',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000148,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,186.573916667,64.49486,0,NULL,57323640431,895681881,13995029,17.7),(94043,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94043,31.14,0.2,16.9,39630,74.4,NULL,NULL,'VCC 0888',NULL,'2013AJ....146...86T',2013,1,0.98,NULL,'G',0.000008,NULL,'15.8g',0.45,'I?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,186.5775,8.34975,0,NULL,58248259713,910129058,14220766,15.8),(94044,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94044,31.31,0.36,18.3,39630,NULL,NULL,NULL,'VCC 0888',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94045,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94045,37.89,0.33,378,39631,70,NULL,NULL,'SDSS J122618.65+594433.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000142,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,186.57775,59.74272,0.009,NULL,57335112704,895861136,13997830,18.4),(94046,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94046,36.51,0.33,201,39632,70,NULL,NULL,'2MASX J12261894+1743280',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.31',0.16,NULL,NULL,NULL,NULL,NULL,1,186.5789583,17.72447,0.023,NULL,58914220213,920534690,14383354,16.31),(94047,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94047,37.76,0.33,357,39633,70,NULL,NULL,'2MASX J12261898+6137053',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,186.57925,61.61819,0,NULL,57375159418,896486865,14007607,17.9),(94048,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94048,36.12,0.33,167,39634,70,NULL,NULL,'IC 3335',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.25',0.13,'AGN',NULL,NULL,NULL,NULL,1,186.5797083,26.12931,0.068,NULL,58645813507,916340836,14317825,18.25),(94049,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94049,37.16,0.23,270,39635,70,NULL,NULL,'2MASX J12261933+0640023',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,186.580375,6.66722,0,NULL,58237874893,909966795,14218231,17.5),(94050,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94050,38.43,0.46,485,39636,70,NULL,NULL,'CGPG 1224.0+6403',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000182,NULL,'17.4g',0.22,'AGN',NULL,NULL,NULL,NULL,1,186.581125,63.77256,0.025,NULL,57371831262,896434863,14006794,17.4),(94051,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94051,38.34,0.46,466,39637,70,NULL,NULL,'2MASX J12261994+5613596',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000127,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,186.583208333,56.23317,0,NULL,57410506176,897039159,14016236,18.2),(94052,'TRGB','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94052,30.9,0.11,15.1,39638,NULL,NULL,NULL,'SDSS J122620.08+123428.8',NULL,'2006ApJ...651..822C',2006,1,NULL,NULL,'G',NULL,NULL,'17.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,186.5837083,12.57469,0.093,NULL,58161792464,908778007,14199656,17.7),(94053,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94053,36.51,0.46,201,39639,70,NULL,NULL,'VPC 0459',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,186.584208333,11.77558,0.029,NULL,58159153384,908736771,14199012,16.6),(94054,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94054,36.12,0.33,167,39640,70,NULL,NULL,'2MASX J12262077+2608382',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00009,NULL,'16.57',0.21,'AGN',NULL,NULL,NULL,NULL,1,186.5865,26.14386,0.068,NULL,58650011308,916406426,14318850,16.57),(94055,'SNIa','2016-12-15 15:14:59','2016-12-16 11:20:10','1','PS1 SN PS11yr','N',94055,42.9,0.28,2490,39641,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11yr HOST',0.5307,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94056,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94056,31.81,NULL,23,39642,NULL,NULL,NULL,'VCC 0890',NULL,'2014A&A...562A..49M',2014,1,0.34,NULL,'G',0.000011,NULL,'16.6g',0.3,'BCD?','Group member',NULL,NULL,NULL,1,186.589833,6.66967,0,NULL,58237875030,909966797,14218231,16.6),(94057,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94057,38.26,0.46,449,39643,70,NULL,NULL,'SDSS J122622.89+171734.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,186.595375,17.293,0.031,NULL,58913320831,920520637,14383134,18),(94058,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94058,36.95,0.46,246,39644,70,NULL,NULL,'VPC 0462',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000156,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,186.5965,12.28053,0.093,NULL,58161697430,908776522,14199633,17),(94059,'TRGB','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94059,29.89,0.1,9.52,39645,74.4,NULL,NULL,'IC 3341',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000108,NULL,'16.5:',0.3,'Spiral',NULL,NULL,NULL,NULL,1,186.596625,27.74553,0.087,NULL,58636931745,916202058,14315657,16.5),(94060,'TRGB','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94060,30.33,0.04,11.6,39645,NULL,NULL,'I','IC 3341',NULL,'2014ApJ...785....3M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94061,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94061,30.73,NULL,14,39645,NULL,NULL,NULL,'IC 3341',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94062,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94062,38.76,0.46,566,39646,70,NULL,NULL,'SDSS J122623.59+400107.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00013,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,186.5982917,40.01881,0,NULL,58573964616,915218197,14300284,18.6),(94063,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94063,36.51,0.33,201,39647,70,NULL,NULL,'2MASX J12262461+1738420',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'16.88',0.19,NULL,NULL,NULL,NULL,NULL,1,186.6027083,17.64492,0.023,NULL,58914242549,920535039,14383359,16.88),(94064,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94064,36.75,0.46,224,39648,70,NULL,NULL,'2MASX J12262611+3945146',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000189,NULL,'15.9g',0.4,NULL,NULL,NULL,NULL,NULL,1,186.6089583,39.75411,0,NULL,58577284145,915270064,14301094,15.9),(94065,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94065,38.17,0.46,430,39649,70,NULL,NULL,'SDSS J122626.60+140852.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000135,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,186.610875,14.14778,0.096,NULL,58162555866,908789935,14199842,18.5),(94066,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94066,37.15,0.46,269,39650,70,NULL,NULL,'2MASX J12262671+4043366',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,186.611125,40.72669,0,NULL,58528342766,914505355,14289146,17.7),(94067,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94067,36.38,0.68,189,39651,70,NULL,NULL,'2MASX J12262689-2038188',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000103,NULL,'15.75',0.4,NULL,NULL,NULL,NULL,NULL,1,186.6119583,-20.63864,0.109,NULL,43950110789,686720481,10730007,15.75),(94068,'Cepheids','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94068,31.1,0.04,16.6,39652,NULL,NULL,'cte LMC K03','NGC 4414',NULL,'2003A&A...411..361K',2003,1,3.6,NULL,'G',0.00002,NULL,'10.96',2,'SA(rs)c?;HII   LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,186.612917,31.22353,0.019,NULL,58760076436,918126194,14345721,10.96),(94069,'Cepheids','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94069,31.1,0.05,16.6,39652,NULL,NULL,'8, VI, KEY PROJECT','NGC 4414',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94070,'Cepheids','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94070,31.1,0.04,16.6,39652,NULL,NULL,'cte U99','NGC 4414',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94071,'Cepheids','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94071,31.13,0.05,16.9,39652,NULL,NULL,'cte LMC STS02','NGC 4414',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94072,'Cepheids','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94072,31.15,0.11,17,39652,NULL,NULL,'9, VI','NGC 4414',NULL,'2001ApJ...547L.103G',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94073,'Cepheids','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94073,31.17,0.13,17.1,39652,NULL,NULL,'LMC W01','NGC 4414',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94074,'Cepheids','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94074,31.2,0.05,17.4,39652,NULL,NULL,'cte MW FSG03','NGC 4414',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94075,'Cepheids','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94075,31.24,0.05,17.7,39652,NULL,NULL,'cte MF91','NGC 4414',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94076,'Cepheids','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94076,31.24,0.05,17.7,39652,NULL,NULL,'8, VI, +Z, KEY PROJECT','NGC 4414',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94077,'Cepheids','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94077,31.26,0.09,17.9,39652,74.4,NULL,NULL,'NGC 4414',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94078,'Cepheids','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94078,31.27,0.05,17.9,39652,NULL,NULL,'MW HIPP','NGC 4414',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94079,'Cepheids','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94079,31.27,0.06,17.9,39652,NULL,NULL,'cte MW GFG98','NGC 4414',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94080,'Cepheids','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94080,31.29,0.11,18.1,39652,NULL,NULL,'9, VI +Z','NGC 4414',NULL,'2001ApJ...547L.103G',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94081,'Cepheids','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94081,31.34,0.06,18.6,39652,NULL,NULL,'cte MW STS03','NGC 4414',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94082,'Cepheids','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94082,31.35,0.26,18.6,39652,NULL,NULL,'MW P02','NGC 4414',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94083,'Cepheids','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94083,31.41,0.1,19.1,39652,NULL,NULL,'7, VI','NGC 4414',NULL,'1998ApJ...505..207T',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94084,'Cepheids','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94084,31.41,0.1,19.1,39652,NULL,NULL,'ALLFRAME','NGC 4414',NULL,'2000ApJ...529..723G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94085,'Cepheids','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94085,31.41,0.1,19.1,39652,NULL,NULL,'HST KP Calibrated','NGC 4414',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94086,'Cepheids','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94086,31.5,0.27,20,39652,NULL,NULL,'20, VI','NGC 4414',NULL,'2000ASPC..203..231T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94087,'Cepheids','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94087,31.62,0.09,21.1,39652,NULL,NULL,'18, VI','NGC 4414',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94088,'Cepheids','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94088,31.62,0.09,21.1,39652,NULL,NULL,'MW GFG','NGC 4414',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94089,'Cepheids','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94089,31.65,NULL,21.4,39652,NULL,18.54,NULL,'NGC 4414',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94090,'Cepheids','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94090,31.65,0.17,21.4,39652,NULL,18.54,'LMC ZP','NGC 4414',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94091,'SNIa','2016-12-15 15:14:59','2016-12-16 11:20:10','1','SN 1974G',NULL,94091,31.2,0.06,17.4,39652,66,NULL,NULL,'NGC 4414',NULL,'1994A&A...281...51M',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94092,'SNIa','2016-12-15 15:14:59','2016-12-16 11:20:10','1','SN 1974G',NULL,94092,31.2,0.55,17.5,39652,67,NULL,NULL,'NGC 4414',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94093,'SNIa','2016-12-15 15:14:59','2016-12-16 11:20:10','1','SN 1974G','R',94093,31.28,NULL,18,39652,62.3,NULL,NULL,'NGC 4414',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94094,'SNIa','2016-12-15 15:14:59','2016-12-16 11:20:10','1','SN 1974G',NULL,94094,31.37,0.14,18.8,39652,60,NULL,NULL,'NGC 4414',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94095,'SNIa','2016-12-15 15:14:59','2016-12-16 11:20:10','1','SN 1974G','R',94095,31.65,NULL,21.4,39652,NULL,NULL,'Photographic','NGC 4414',NULL,'1988SSRv...48....1R',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94096,'IRAS','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94096,30.75,0.8,14.1,39652,75,NULL,'A82, H','NGC 4414',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94097,'Sosies','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94097,31.35,0.18,18.6,39652,NULL,NULL,NULL,'NGC 4414',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94098,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94098,28.45,0.69,4.89,39652,100,NULL,'mid-IR','NGC 4414',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94099,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94099,29.93,0.4,9.7,39652,75,NULL,'B','NGC 4414',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94100,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94100,31.24,0.05,17.7,39652,75,NULL,NULL,'NGC 4414',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94101,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94101,31.24,0.43,17.7,39652,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4414',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94102,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94102,31.25,NULL,17.8,39652,NULL,NULL,'I','NGC 4414',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94103,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94103,31.25,NULL,17.8,39652,NULL,NULL,'B','NGC 4414',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94104,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94104,31.26,0.09,17.9,39652,74.4,NULL,NULL,'NGC 4414',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94105,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94105,31.27,0.35,17.9,39652,NULL,NULL,NULL,'NGC 4414',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94106,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94106,31.29,0.05,18.1,39652,NULL,NULL,'B','NGC 4414',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94107,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94107,31.3,0.3,18.2,39652,NULL,18.45,'SN 1974G host','NGC 4414',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94108,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94108,31.33,0.43,18.4,39652,75,NULL,'3.6 micron, color corrected','NGC 4414',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94109,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94109,31.41,0.47,19.2,39652,75,NULL,'A82, H, raw','NGC 4414',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94110,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94110,31.43,0.53,19.3,39652,NULL,NULL,'Malmquist cor.','NGC 4414',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94111,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94111,31.44,0.4,19.4,39652,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 4414',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94112,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94112,31.46,0.22,19.6,39652,NULL,NULL,'I','NGC 4414',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94113,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94113,31.56,0.47,20.5,39652,75,NULL,'A82, H, cor','NGC 4414',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94114,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94114,31.58,0.5,20.7,39652,NULL,NULL,NULL,'NGC 4414',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94115,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94115,31.62,0.47,21.1,39652,75,NULL,'A82, H, inv','NGC 4414',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94116,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94116,31.62,NULL,21.1,39652,NULL,NULL,'LEDA [April 2006]','NGC 4414',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94117,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94117,31.95,0.3,24.6,39652,55,NULL,'B','NGC 4414',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94118,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94118,38.22,0.46,440,39653,70,NULL,NULL,'2MASX J12262717+0513123',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,186.613333,5.22017,0,NULL,58226373121,909787080,14215423,17.2),(94119,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94119,37.44,0.27,307,39654,70,NULL,NULL,'2MASX J12263000+0111543',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000095,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,186.625083,1.19831,0.014,NULL,58010465080,906413516,14162711,17.3),(94120,'Tully est','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94120,31.13,0.8,16.8,39655,75,NULL,'B','NGC 4411',NULL,'1988NBGC.C....0000T',1988,1,2,'The position in 1995ApJS...96..359Y includes a superposed star.','G',0.000002,NULL,'13.41',1.9,'SB(rs)c        HII','Pair member (points to parent)',NULL,NULL,NULL,1,186.625417,8.87222,0,NULL,58243626749,910056667,14219635,13.41),(94121,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94121,35.98,0.46,157,39656,70,NULL,NULL,'VCC 0911',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',NULL,NULL,'15.2g',0.52,'E3','Group member',NULL,NULL,NULL,1,186.627875,16.63383,0.019,NULL,58879769711,919996401,14374943,15.2),(94122,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94122,37.89,0.33,378,39657,70,NULL,NULL,'2MASX J12263137+5948164',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000181,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,186.630583,59.8045,0,NULL,57335116554,895861196,13997831,17.3),(94123,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94123,35.28,0.15,114,39658,70,NULL,NULL,'NGC 4410E',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000167,NULL,'15.4g',0.35,'S',NULL,NULL,NULL,NULL,1,186.631875,9.12308,0,NULL,58243493879,910054591,14219602,15.4),(94124,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94124,36.94,0.46,245,39659,70,NULL,NULL,'2MASX J12263200+3351408',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,186.633375,33.86142,0.016,NULL,58762866782,918169793,14346403,16.9),(94125,'TRGB','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94125,30.89,0.1,15.1,39660,74.4,NULL,NULL,'NGC 4407',NULL,'2013AJ....146...86T',2013,1,2.3,NULL,'G',0.00002,NULL,'12.25',1.5,'(R\')SB(rs)ab:  HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.634375,12.61097,0.1,NULL,58162310902,908786107,14199782,12.25),(94126,'TRGB','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94126,31.05,0.06,16.2,39660,NULL,NULL,'I','NGC 4407',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94127,'TRGB','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94127,31.1,0.12,16.6,39660,NULL,NULL,NULL,'NGC 4407',NULL,'2006ApJ...651..822C',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94128,'Tully est','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94128,31.13,0.8,16.8,39660,75,NULL,'B','NGC 4407',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94129,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94129,31.01,NULL,15.9,39660,NULL,NULL,NULL,'NGC 4407',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94130,'Tully-Fisher','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,NULL,94130,31.16,NULL,17.1,39660,NULL,NULL,'B','NGC 4407',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94131,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94131,37.29,0.46,287,39661,70,NULL,NULL,'2MASX J12263256+0342546',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000183,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,186.635875,3.71508,0.069,NULL,58007218226,906362784,14161918,16.3),(94132,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94132,37.22,0.17,278,39662,70,NULL,NULL,'2MASX J12263281+3125528',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.0001,NULL,'15.4g',0.56,NULL,NULL,NULL,NULL,NULL,1,186.6367917,31.43133,0.023,NULL,58760036631,918125572,14345712,15.4),(94133,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94133,36.95,0.46,245,39663,70,NULL,NULL,'VPC 0476',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000165,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,186.639583,14.35631,0.1,NULL,58156006055,908687594,14198243,16.3),(94134,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94134,37.76,0.21,357,39664,70,NULL,NULL,'2MASX J12263395+4954213',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000148,NULL,'16.8g',0.34,NULL,NULL,NULL,NULL,NULL,1,186.641333,49.90583,0,NULL,57237915383,894342427,13974100,16.8),(94135,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94135,37.72,0.33,350,39665,70,NULL,NULL,'2MASX J12263488+4029466',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,186.6452083,40.49611,0,NULL,58527938487,914499038,14289047,18.1),(94136,'FP','2016-12-15 15:14:59','2016-12-16 11:20:10','1',NULL,'R',94136,37.88,0.46,376,39666,70,NULL,NULL,'2MASX J12263511+0257346',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,186.6462083,2.95964,0,NULL,58004569408,906321397,14161271,17.2),(94137,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94137,35.28,0.15,114,39667,70,NULL,NULL,'NGC 4410C',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000083,NULL,'14.7g',0.56,'S0?            AGN','Group member',NULL,NULL,NULL,1,186.647917,9.03547,0,NULL,58243545366,910055396,14219615,14.7),(94138,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94138,37.29,0.46,287,39668,70,NULL,NULL,'2MASX J12263552+3259168',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000174,NULL,'18.07',0.15,NULL,NULL,NULL,NULL,NULL,1,186.648,32.98794,0.028,NULL,58765122023,918205031,14346953,18.07),(94139,'Tully est','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94139,32.75,0.8,35.6,39669,75,NULL,'B','NGC 4412',NULL,'1988NBGC.C....0000T',1988,1,1.4,'UZC has V = 1735 +- 10 km/sec.','G',0.000023,NULL,'13.16',1.3,'SB(r)b? pec    LINER','in a radial-velocity based grouping',NULL,NULL,'Sy 2',1,186.650333333,3.96469,0.028,NULL,58006521960,906351905,14161748,13.16),(94140,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94140,37.01,0.46,252,39670,70,NULL,NULL,'2MASX J12263706+4019016',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.4g',0.21,'AGN',NULL,NULL,NULL,NULL,1,186.654625,40.31703,0,NULL,58527945953,914499155,14289049,17.4),(94141,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94141,37.37,0.33,298,39671,70,NULL,NULL,'VPC 0481',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00021,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,186.656125,14.60078,0.1,NULL,58156007933,908687623,14198244,17.1),(94142,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94142,36.35,0.46,186,39672,70,NULL,NULL,'2MASX J12263887+5740214',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000183,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,186.661875,57.67264,0,NULL,57409316360,897020568,14015946,16.4),(94143,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94143,31.42,0.14,19.2,39673,NULL,NULL,'R','VCC 0928',NULL,'2004AJ....127..771J',2004,1,0.6,NULL,'G',0.00018,NULL,'16.23',0.3,'dE6, N','Group member',NULL,NULL,NULL,1,186.665875,12.51353,0.093,NULL,58162300287,908785941,14199780,16.23),(94144,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94144,37.76,0.21,357,39674,70,NULL,NULL,'2MASX J12263994+4953283',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,186.6662917,49.89128,0,NULL,57238030562,894344227,13974128,17.3),(94145,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94145,37.72,0.33,350,39675,70,NULL,NULL,'2MASX J12264010+4031399',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,186.667125,40.52783,0,NULL,58528204685,914503198,14289112,17.5),(94146,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94146,37.88,0.46,376,39676,70,NULL,NULL,'2MASX J12264038+2724232',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,186.6682083,27.40642,0.101,NULL,58638793259,916231144,14316111,17.9),(94147,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94147,30.86,0.14,14.9,39677,NULL,NULL,'R','NGC 4415',NULL,'2004AJ....127..771J',2004,1,1.22,NULL,'G',0.000033,NULL,'13.8g',0.99,'S0/a','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.6687083,8.43569,0,NULL,58247943797,910124121,14220689,13.8),(94148,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94148,31.17,0.25,17.1,39677,74.4,NULL,NULL,'NGC 4415',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94149,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94149,37.17,0.33,271,39678,70,NULL,NULL,'MRK 1474',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000201,NULL,'15.9g',0.42,'E0',NULL,NULL,NULL,NULL,1,186.670167,43.08592,0,NULL,59063348151,922864814,14419762,15.9),(94150,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94150,36.41,0.64,191,39679,70,NULL,NULL,'2MASX J12264167-5107580',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,186.673708333,-51.13281,0.845,NULL,44626715464,697292429,10895194,16.7),(94151,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94151,36.34,0.68,185,39680,70,NULL,NULL,'2MASX J12264183-1328091',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,186.6744583,-13.46925,0.097,NULL,43039197902,672487467,10507616,15.5),(94152,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94152,30.9,0.17,15.1,39681,NULL,NULL,NULL,'[C2006a] N dSph',NULL,'2006ApJ...651..822C',2006,1,NULL,NULL,'G',NULL,NULL,'21.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,186.675417,13.37583,0.094,NULL,58160910811,908764231,14199441,21.3),(94153,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94153,37.3,0.46,288,39682,70,NULL,NULL,'2MASX J12264234+2635172',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00014,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,186.676667,26.58825,0.123,NULL,58638579625,916227806,14316059,16.2),(94154,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94154,37.22,0.17,278,39683,70,NULL,NULL,'2MASX J12264306+3115478',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000123,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,186.679416667,31.26344,0.019,NULL,58759954464,918124288,14345692,16.4),(94155,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94155,37.26,0.46,283,39684,70,NULL,NULL,'VPC 0490',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000196,NULL,'16.1g',0.39,'E',NULL,NULL,NULL,NULL,1,186.6809583,10.77289,0,NULL,58188502645,909195353,14206177,16.1),(94156,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94156,37.17,0.33,271,39685,70,NULL,NULL,'2MASX J12264390+4307161',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000159,NULL,'17.3g',0.21,'AGN',NULL,NULL,NULL,NULL,1,186.682875,43.12111,0,NULL,59063398545,922865602,14419775,17.3),(94157,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94157,35.46,0.49,124,39686,70,NULL,NULL,'2MASX J12264441-4443044',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'15.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,186.6850417,-44.718,0.389,NULL,46721150483,730017976,11406530,15.6),(94158,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94158,38.17,0.46,430,39687,70,NULL,NULL,'2MASX J12264517+4144139',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00019,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,186.688125,41.73719,0,NULL,59060733658,922823963,14419124,17.6),(94159,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94159,35.43,0.5,122,39688,70,NULL,NULL,'2MASX J12264545-1807404',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.72',0.7,NULL,NULL,NULL,NULL,NULL,1,186.6895,-18.12806,0.057,NULL,43947548748,686680449,10729382,15.72),(94160,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94160,37.98,0.46,394,39689,70,NULL,NULL,'2MASX J12264628+6646391',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000087,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,186.692833,66.77767,0.033,NULL,57313304689,895520385,13992506,17.4),(94161,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94161,31.36,0.2,18.7,39690,NULL,NULL,'R','IC 3349',NULL,'2004AJ....127..771J',2004,1,0.97,NULL,'G',0.00007,NULL,'15.0g',0.85,'dE1','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,186.696083333,12.45397,0.093,NULL,58162367009,908786984,14199796,15),(94162,'Tully est','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94162,31.13,0.8,16.8,39691,75,NULL,'B','NGC 4411B',NULL,'1988NBGC.C....0000T',1988,1,2.5,'NGC 4411 and UGC 07590 may contribute to the HIPASS detection.','G',0.000003,NULL,'12.9B',2.5,'SAB(s)cd;Sy    LINER','Pair member (points to parent)',NULL,NULL,NULL,1,186.696791667,8.88461,0,NULL,58243666856,910057294,14219645,12.9),(94163,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94163,30.96,0.27,15.6,39692,NULL,NULL,'BV A01','VCC 0941',NULL,'2007ApJ...668..130C',2007,1,0.22,NULL,'G',NULL,NULL,'19.1',0.22,'dE4:','Group member',NULL,NULL,NULL,1,186.6994583,13.37911,0.094,NULL,58160912124,908764251,14199441,19.1),(94164,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94164,31.14,0.2,16.9,39692,74.4,NULL,NULL,'VCC 0941',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94165,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94165,31.31,0.27,18.3,39692,NULL,NULL,'T01','VCC 0941',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94166,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94166,31.31,0.27,18.3,39692,NULL,NULL,'J03','VCC 0941',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94167,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94167,31.7,0.23,21.9,39692,NULL,NULL,'M06','VCC 0941',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94168,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94168,31.1,0.11,16.6,39692,NULL,NULL,NULL,'VCC 0941',NULL,'2006ApJ...651..822C',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94169,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94169,31,0.12,15.8,39693,NULL,NULL,NULL,'[C2006a] N lsb10',NULL,'2006ApJ...651..822C',2006,1,NULL,NULL,'G',NULL,NULL,'18.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,186.700417,13.35486,0.094,NULL,58160967160,908765111,14199454,18.5),(94170,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94170,36.82,0.46,231,39694,70,NULL,NULL,'LCRS B122414.0-024649',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000083,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,186.7004583,-3.05683,0.081,NULL,42994458070,671788407,10496693,16.8),(94171,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94171,37.37,0.33,298,39695,70,NULL,NULL,'VPC 0500',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,186.7035417,14.65717,0.07,NULL,58155420018,908678437,14198100,17.2),(94172,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94172,38.15,0.27,427,39696,70,NULL,NULL,'SDSS J122649.50+330020.5',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000176,NULL,'18.4g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,186.70625,33.00569,0.028,NULL,58764656135,918197752,14346839,18.4),(94173,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94173,30.63,0.2,13.4,39697,74.4,NULL,NULL,'IC 3356',NULL,'2013AJ....146...86T',2013,1,1.5,'The position in 1995ApJS...96..359Y is for a superposed star.','G',0.000002,NULL,'15.1B',0.9,'SmIV           HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,186.710375,11.55903,0.031,NULL,58158677230,908729331,14198895,15.1),(94174,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94174,31.13,0.4,16.8,39697,75,NULL,'B','IC 3356',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94175,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94175,31.19,0.71,17.3,39697,NULL,NULL,NULL,'IC 3356',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94176,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94176,31.4,0.65,19,39697,NULL,NULL,'Malmquist cor.','IC 3356',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94177,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94177,30.91,0.12,15.2,39698,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4417',NULL,'2010ApJ...717..603V',2010,1,3.4,NULL,'G',0.000017,NULL,'12.00',1.3,'SB0: sp','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.710875,9.58425,0,NULL,58246284813,910098200,14220284,12),(94178,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94178,30.92,0.14,15.3,39698,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4417',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94179,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94179,31.11,0.14,16.7,39698,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4417',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94180,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94180,31.18,0.12,17.2,39698,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4417',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94181,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94181,30.87,0.12,14.9,39698,74.4,NULL,NULL,'NGC 4417',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94182,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94182,31.02,0.06,16,39698,NULL,NULL,NULL,'NGC 4417',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94183,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94183,31.02,0.07,16,39698,NULL,NULL,'HST ACS VCS','NGC 4417',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94184,'GC radius','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94184,31.01,0.06,15.9,39698,NULL,NULL,NULL,'NGC 4417',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94185,'Faber-Jackson','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94185,30.96,0.37,15.6,39698,95,NULL,'Weighted Mean','NGC 4417',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94186,'Faber-Jackson','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94186,31.37,0.63,18.8,39698,95,NULL,'Michard 1979b, c','NGC 4417',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94187,'Faber-Jackson','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94187,31.48,0.81,19.8,39698,55,NULL,'Visvanathan & Sandage 1979','NGC 4417',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94188,'Faber-Jackson','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94188,31.52,0.46,20.1,39698,95,NULL,'Michard 1979a','NGC 4417',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94189,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94189,28.76,NULL,5.65,39698,NULL,NULL,NULL,'NGC 4417',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94190,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94190,30.87,0.12,14.9,39698,74.4,NULL,NULL,'NGC 4417',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94191,'Tertiary','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94191,30.49,0.25,12.5,39698,95,NULL,NULL,'NGC 4417',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94192,'Tully est','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94192,31.13,0.8,16.8,39698,75,NULL,'B','NGC 4417',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94193,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94193,30.23,0.45,11.1,39698,NULL,NULL,'K','NGC 4417',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94194,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94194,31.57,0.4,20.6,39698,NULL,NULL,'mean','NGC 4417',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94195,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94195,38.15,0.27,427,39699,70,NULL,NULL,'SDSS J122650.93+330105.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000142,NULL,'18.0g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,186.71225,33.01833,0.026,NULL,58764653004,918197703,14346839,18),(94196,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94196,38.79,0.33,574,39700,70,NULL,NULL,'2MASX J12265126+6237031',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000153,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,186.7137083,62.61756,0,NULL,57377556202,896524315,14008192,17.5),(94197,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94197,36.8,0.2,229,39701,74.4,NULL,NULL,'IC 3357',NULL,'2013AJ....146...86T',2013,1,0.58,NULL,'G',0.000012,NULL,'16.0g',0.25,'Sc:','Group member',NULL,NULL,NULL,1,186.7139583,9.7775,0,NULL,58246091283,910095176,14220237,16),(94198,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94198,37.07,0.55,259,39702,NULL,NULL,'Malmquist cor.','2MASX J12265180+3105389',NULL,'2009ApJS..182..474S',2009,1,0.74,NULL,'G',0.000033,NULL,'15.4g',0.47,NULL,NULL,NULL,NULL,NULL,1,186.715875,31.09422,0.015,NULL,58759939816,918124059,14345688,15.4),(94199,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94199,37.29,0.5,288,39702,NULL,NULL,NULL,'2MASX J12265180+3105389',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94200,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94200,37.33,0.2,292,39702,74.4,NULL,NULL,'2MASX J12265180+3105389',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94201,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94201,37.91,0.08,383,39703,70,NULL,NULL,'2MASX J12265202+0846478',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000154,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,186.716667,8.77997,0,NULL,58243672785,910057387,14219646,17.5),(94202,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94202,36.73,0.46,221,39704,70,NULL,NULL,'2MASX J12265409+6452181',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000189,NULL,'16.1g',0.41,'S0',NULL,NULL,NULL,NULL,1,186.72575,64.87167,0.009,NULL,57324009550,895687649,13995119,16.1),(94203,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94203,36.71,0.46,220,39705,70,NULL,NULL,'2MASXi J1226542+273753',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,186.726417,27.63172,0.077,NULL,58639778829,916246544,14316352,17.6),(94204,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94204,37.13,0.46,267,39706,70,NULL,NULL,'2MASX J12265437+2540169',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.63',0.19,'AGN',NULL,NULL,NULL,NULL,1,186.7265417,25.67142,0.058,NULL,58613406506,915834476,14309913,17.63),(94205,'IRAS','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94205,33.78,0.8,57,39707,75,NULL,'MAT, I','ESO 380- G 029',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000029,NULL,'14.96',0.6,'SB(s)m:',NULL,NULL,NULL,NULL,1,186.726875,-36.42422,0.269,NULL,43272014833,676125231,10564456,14.96),(94206,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94206,31.58,0.32,20.7,39707,85,NULL,'I, inv','ESO 380- G 029',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94207,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94207,31.62,0.32,21.1,39707,85,NULL,'I, raw','ESO 380- G 029',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94208,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94208,32.15,0.43,26.9,39707,75,NULL,'MAT, I, inv','ESO 380- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94209,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94209,32.23,0.43,27.9,39707,75,NULL,'MAT, I, raw','ESO 380- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94210,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94210,32.6,0.43,33.1,39707,75,NULL,'MAT, I, cor','ESO 380- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94211,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94211,33.46,0.67,49.1,39707,NULL,NULL,'Malmquist cor.','ESO 380- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94212,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94212,33.54,0.64,51.1,39707,NULL,NULL,NULL,'ESO 380- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94213,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94213,33.58,0.2,52,39707,74.4,NULL,NULL,'ESO 380- G 029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94214,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94214,33.99,0.49,62.7,39707,75,NULL,'IR','ESO 380- G 029',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94215,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94215,31.69,0.47,21.7,39708,NULL,NULL,'H','NGC 4355',NULL,'2007A&A...465...71T',2007,1,1.59,NULL,'G',0.000027,NULL,'13.7g',0.72,'(R\')SAB(s)a;LIRG;Sy2','Pair member (points to parent)',NULL,NULL,'Sy 2',1,186.727583,-0.87761,0.045,NULL,42991534356,671742724,10495980,13.7),(94216,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94216,31.84,0.46,23.3,39708,NULL,NULL,'J','NGC 4355',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94217,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94217,31.89,0.45,23.9,39708,NULL,NULL,'K','NGC 4355',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94218,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94218,32.56,0.4,32.5,39708,NULL,NULL,'mean','NGC 4355',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94219,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94219,37.95,0.46,388,39709,70,NULL,NULL,'SDSS J122654.65+212437.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,186.72775,21.41036,NULL,NULL,58910607791,920478246,14382472,18.1),(94220,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94220,37.76,0.21,357,39710,70,NULL,NULL,'2MASX J12265517+4954110',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000141,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,186.729875,49.90325,0,NULL,57237920589,894342509,13974101,17.2),(94221,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94221,35.18,0.46,109,39711,70,NULL,NULL,'CGCG 269-058',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.00009,NULL,'14.8g',0.5,'E0',NULL,NULL,NULL,NULL,1,186.730083,52.07567,0.019,NULL,57242503299,894414114,13975220,14.8),(94222,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94222,37.94,0.46,387,39712,70,NULL,NULL,'2MASX J12265622+1754577',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,186.7342083,17.916,0.023,NULL,58913985080,920531016,14383297,17.6),(94223,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94223,37.44,0.27,307,39713,70,NULL,NULL,'2MASX J12265640+0112496',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000079,NULL,'17.0g',0.32,NULL,NULL,NULL,NULL,NULL,1,186.734917,1.21372,0.014,NULL,58010620227,906415941,14162749,17),(94224,'SNIa','2016-12-15 15:15:00','2016-12-16 11:20:10','1','SN 1984A',NULL,94224,30.7,0.36,13.8,39714,NULL,NULL,NULL,'NGC 4419',NULL,'1992ApJ...390L..45P',1992,1,3.38,'UZC has V = 767 +- 29 km/sec.','G',0.000017,NULL,'12.2g',0.93,'SB(s)a;LINER   HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.735166667,15.04739,0.025,NULL,58158036588,908719321,14198739,12.2),(94225,'SNIa','2016-12-15 15:15:00','2016-12-16 11:20:10','1','SN 1984A',NULL,94225,31.1,0.48,16,39714,67,NULL,NULL,'NGC 4419',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94226,'SNIa','2016-12-15 15:15:00','2016-12-16 11:20:10','1','SN 1984A','R',94226,31.15,NULL,17,39714,62.3,NULL,NULL,'NGC 4419',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94227,'SNIa','2016-12-15 15:15:00','2016-12-16 11:20:10','1','SN 1984A',NULL,94227,31.24,0.14,17.7,39714,60,NULL,NULL,'NGC 4419',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94228,'SNIa','2016-12-15 15:15:00','2016-12-16 11:20:10','1','SN 1984A',NULL,94228,31.3,0.02,18.2,39714,66,NULL,NULL,'NGC 4419',NULL,'1994A&A...281...51M',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94229,'SNIa','2016-12-15 15:15:00','2016-12-16 11:20:10','1','SN 1984A',NULL,94229,31.41,0.22,19.1,39714,65,NULL,'avg. of 6 SNIa and hosts','NGC 4419',NULL,'1996AJ....112.2398H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94230,'SNIa','2016-12-15 15:15:00','2016-12-16 11:20:10','1','SN 1984A','R',94230,31.44,NULL,19.4,39714,NULL,NULL,'Photographic','NGC 4419',NULL,'1988SSRv...48....1R',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94231,'SNIa','2016-12-15 15:15:00','2016-12-16 11:20:10','1','SN 1984A',NULL,94231,31.56,0.25,20.5,39714,60,NULL,'M(V) = -19.47 mag','NGC 4419',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94232,'SNIa','2016-12-15 15:15:00','2016-12-16 11:20:10','1','SN 1984A',NULL,94232,31.73,0.25,22.2,39714,60,NULL,'M(B) = -19.48 mag','NGC 4419',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94233,'SNIa','2016-12-15 15:15:00','2016-12-16 11:20:10','1','SN 1984A',NULL,94233,31.8,NULL,22.9,39714,56,NULL,'M(B) = -19.8 mag','NGC 4419',NULL,'1992ARA&A..30..359B',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94234,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94234,30.65,0.14,13.5,39714,74.4,NULL,NULL,'NGC 4419',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94235,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94235,30.65,0.25,13.5,39714,NULL,NULL,'I','NGC 4419',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94236,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94236,30.3,0.4,11.5,39714,NULL,18.45,'SN 1984A host','NGC 4419',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94237,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94237,30.6,NULL,13.2,39714,84,NULL,'RC2 Hubble type','NGC 4419',NULL,'1986AJ.....91.1286S',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94238,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94238,30.97,NULL,15.6,39714,NULL,NULL,NULL,'NGC 4419',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94239,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94239,31.05,0.7,16.2,39714,NULL,NULL,'HI','NGC 4419',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94240,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94240,31.1,NULL,16.6,39714,84,NULL,'RSA Hubble type','NGC 4419',NULL,'1986AJ.....91.1286S',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94241,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94241,31.13,0.4,16.8,39714,75,NULL,'B','NGC 4419',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94242,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94242,31.68,0.92,21.7,39714,NULL,NULL,'CO','NGC 4419',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94243,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94243,37.17,0.46,272,39715,70,NULL,NULL,'2MASX J12265650+1603137',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,186.735417,16.05386,0.026,NULL,58154910162,908670471,14197976,17.2),(94244,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94244,36.95,0.46,246,39716,70,NULL,NULL,'2MASX J12265685+5217250',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000172,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,186.7370417,52.29017,0.046,NULL,57242532127,894414564,13975227,16.7),(94245,'SZ effect','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94245,39.54,0.69,810,39717,NULL,NULL,'Isotherm., r < 100 kpc','400d J1226+3332',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,186.741667,33.54836,NULL,NULL,58765841671,918216276,14347129,NULL),(94246,'SZ effect','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94246,39.96,0.71,980,39717,NULL,NULL,'Isotherm.','400d J1226+3332',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94247,'SZ effect','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94247,40.02,NULL,1010,39717,NULL,NULL,'3.1 (red) calibration','400d J1226+3332',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94248,'SZ effect','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94248,40.17,0.78,1080,39717,NULL,NULL,'Hydrost. Eq.','400d J1226+3332',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94249,'SZ effect','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94249,40.3,NULL,1150,39717,NULL,NULL,'4.2 (black) calibration','400d J1226+3332',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94250,'SZ effect','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94250,40.62,NULL,1330,39717,NULL,NULL,'4.1 (blue) calibration','400d J1226+3332',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94251,'IRAS','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94251,31.34,0.8,18.5,39718,75,NULL,'CF, r','NGC 4409',NULL,'1997ApJS..109..333W',1997,1,1.44,NULL,'G',0.00002,NULL,'12.7g',0.87,'SB(r)bc:;HII   LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.74375,2.49436,0,NULL,58012143194,906439737,14163120,12.7),(94252,'Tully est','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94252,30.72,0.8,13.9,39718,75,NULL,'B','NGC 4409',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94253,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94253,30.41,0.43,12.1,39718,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4409',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94254,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94254,30.63,0.43,13.4,39718,75,NULL,'3.6 micron, color corrected','NGC 4409',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94255,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94255,30.89,0.2,15.1,39718,74.4,NULL,NULL,'NGC 4409',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94256,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94256,30.93,NULL,15.3,39718,NULL,NULL,NULL,'NGC 4409',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94257,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94257,31.07,0.36,16.4,39718,NULL,NULL,NULL,'NGC 4409',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94258,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94258,31.21,0.46,17.5,39718,NULL,NULL,NULL,'NGC 4409',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94259,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94259,31.29,0.45,18.1,39718,NULL,NULL,'Malmquist cor.','NGC 4409',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94260,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94260,31.36,0.47,18.7,39718,NULL,NULL,'H','NGC 4409',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94261,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94261,31.38,0.46,18.9,39718,NULL,NULL,'J','NGC 4409',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94262,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94262,31.44,0.45,19.4,39718,NULL,NULL,'K','NGC 4409',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94263,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94263,31.57,0.38,20.6,39718,75,NULL,'CF, r, raw','NGC 4409',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94264,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94264,31.57,0.38,20.6,39718,75,NULL,'CF, r, inv','NGC 4409',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94265,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94265,31.71,0.38,22,39718,75,NULL,'CF, r, cor','NGC 4409',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94266,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94266,31.98,0.4,24.9,39718,NULL,NULL,'mean','NGC 4409',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94267,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94267,38.04,0.46,405,39719,70,NULL,NULL,'SDSS J122658.56+645624.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000124,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,186.7440417,64.94017,0.009,NULL,57323995960,895687436,13995116,18.6),(94268,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94268,37.73,0.46,352,39720,70,NULL,NULL,'SDSS J122658.68+111651.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000123,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,186.744541667,11.28092,0.049,NULL,58188174329,909190223,14206097,18.3),(94269,'CMD','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94269,18.2,0.2,0.044,39721,NULL,NULL,NULL,'COMA SATELLITE',NULL,'2007ApJ...654..897B',2007,1,NULL,NULL,'G',NULL,NULL,'14.5V',NULL,'dSph',NULL,NULL,NULL,NULL,1,186.745833,23.90417,0.067,1,58611347190,915802299,14309410,14.5),(94270,'CMD','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94270,18.2,0.2,0.044,39721,NULL,NULL,NULL,'COMA SATELLITE',NULL,'2008AJ....135.1361D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94271,'CMD','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94271,18.4,0.4,0.0479,39721,NULL,NULL,NULL,'COMA SATELLITE',NULL,'2008AJ....135.1361D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94272,'Horizontal Branch','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94272,18.13,0.08,0.042,39721,NULL,NULL,NULL,'COMA SATELLITE',NULL,'2009ApJ...695L..83M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94273,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94273,35.28,0.15,114,39722,70,NULL,NULL,'NGC 4410H',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000067,NULL,'15.0g',0.4,'SB0','Group member',NULL,NULL,NULL,1,186.7467083,8.95878,0,NULL,58243530337,910055161,14219611,15),(94274,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94274,37.7,0.46,347,39723,70,NULL,NULL,'2MASX J12265972+0544206',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,186.7487917,5.73919,0,NULL,58234193670,909909276,14217332,17.4),(94275,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94275,37.55,0.33,324,39724,70,NULL,NULL,'2MASX J12270017+4328570',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,186.750833,43.48256,0,NULL,59063174232,922862097,14419720,17.4),(94276,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94276,37.92,0.46,384,39725,70,NULL,NULL,'VPC 0513',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000172,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,186.752375,12.91153,0.095,NULL,58161032086,908766126,14199470,17),(94277,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94277,37.44,0.27,307,39726,70,NULL,NULL,'2MASX J12270135+0111358',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000081,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,186.755625,1.19333,0.014,NULL,58010623555,906415993,14162749,17.5),(94278,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94278,37.91,0.08,383,39727,70,NULL,NULL,'SDSS J122702.25+085058.4',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,186.759375,8.84958,0,NULL,58243651415,910057053,14219641,17.6),(94279,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94279,30.7,NULL,13.8,39728,NULL,NULL,NULL,'NGC 4421',NULL,'1999MNRAS.304..595G',1999,1,2.54,NULL,'G',0.000033,NULL,'12.6g',1.38,'SB(s)0/a','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.760583,15.46147,0.031,NULL,58158014825,908718981,14198734,12.6),(94280,'Tully est','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94280,31.13,0.8,16.8,39728,75,NULL,'B','NGC 4421',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94281,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94281,37.91,0.08,383,39729,70,NULL,NULL,'SDSS J122702.61+085312.2',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000146,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,186.760916667,8.88675,0,NULL,58243652282,910057066,14219641,17.6),(94282,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94282,35.12,NULL,106,39730,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07553',NULL,'2010Ap&SS.325..163P',2010,1,1.07,NULL,'G',NULL,NULL,'16.7g',0.16,'Sd(f)',NULL,NULL,NULL,NULL,1,186.765375,-1.51597,0.033,NULL,42988754109,671699282,10495301,16.7),(94283,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94283,35.13,NULL,106,39730,NULL,NULL,'Dipole + Quadrupole','UGC 07553',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94284,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94284,35.15,NULL,107,39730,NULL,NULL,'Dipole','UGC 07553',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94285,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94285,35.17,NULL,108,39730,NULL,NULL,NULL,'UGC 07553',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94286,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94286,37.54,0.27,323,39731,70,NULL,NULL,'2MASX J12270495+0654598',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000189,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,186.770583333,6.91661,0,NULL,58236952281,909952379,14218005,17.1),(94287,'Brightest Stars','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94287,27.4,NULL,3.02,39732,NULL,NULL,NULL,'UGC 07559',NULL,'1998AJ....116.2886S',1998,1,3.2,NULL,'G',0.000017,NULL,'14.2',2,'IBm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,186.7714583,37.14258,0,NULL,58571246740,915175730,14299620,14.2),(94288,'Brightest Stars','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94288,27.97,0.4,3.93,39732,NULL,NULL,'3B + 3R mean','UGC 07559',NULL,'1997AstL...23..514G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94289,'Brightest Stars','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94289,28.17,NULL,4.31,39732,NULL,NULL,'LF','UGC 07559',NULL,'1997AstL...23..514G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94290,'Brightest Stars','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94290,28.49,0.4,5,39732,NULL,NULL,NULL,'UGC 07559',NULL,'2000IAPPP..81...29Z',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94291,'Brightest Stars','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94291,28.53,NULL,5.1,39732,NULL,NULL,NULL,'UGC 07559',NULL,'1998A&AS..128..459M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94292,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94292,28.32,0.08,4.61,39732,NULL,NULL,NULL,'UGC 07559',NULL,'2013AstBu..68..125M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94293,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94293,28.37,0.12,4.71,39732,NULL,NULL,NULL,'UGC 07559',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94294,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94294,28.44,0.26,4.87,39732,NULL,NULL,NULL,'UGC 07559',NULL,'2003A&A...398..467K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94295,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94295,28.48,0.07,4.97,39732,NULL,NULL,'I','UGC 07559',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94296,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94296,28.48,0.1,4.97,39732,74.4,NULL,NULL,'UGC 07559',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94297,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94297,27.24,0.4,2.8,39732,75,NULL,'B','UGC 07559',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94298,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94298,37.76,0.21,357,39733,70,NULL,NULL,'2MASXi J1227058+495347',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000138,NULL,'17.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,186.7745,49.8965,0,NULL,57237921691,894342526,13974101,17.9),(94299,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94299,34.58,0.57,82.4,39734,70,NULL,NULL,'2MASX J12270607-4723385',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.6I',0.4,NULL,NULL,NULL,NULL,NULL,1,186.775167,-47.39403,0.565,NULL,46714422384,729912849,11404888,13.6),(94300,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94300,38.79,0.33,574,39735,70,NULL,NULL,'2MASX J12270656+6234105',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000174,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,186.7772917,62.56967,0,NULL,57375466784,896491668,14007682,17.9),(94301,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94301,37.54,0.27,323,39736,70,NULL,NULL,'2MASX J12270656+0654198',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000195,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,186.777333333,6.90558,0,NULL,58236952381,909952380,14218005,16.3),(94302,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94302,35.8,0.5,145,39737,NULL,NULL,'Malmquist cor.','2MFGC 09808',NULL,'2009ApJS..182..474S',2009,1,0.74,NULL,'G',0.000013,NULL,'16.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,186.777583,6.42592,0,NULL,58237879072,909966860,14218232,16.3),(94303,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94303,35.84,0.49,147,39737,NULL,NULL,NULL,'2MFGC 09808',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94304,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94304,35.88,0.2,150,39737,74.4,NULL,NULL,'2MFGC 09808',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94305,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94305,37.74,0.46,354,39738,70,NULL,NULL,'2MASX J12270674+0801138',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000185,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,186.778166667,8.02039,0,NULL,58248382970,910130983,14220796,17.7),(94306,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94306,37.21,0.27,277,39739,70,NULL,NULL,'2MASX J12270762+1701062',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,186.78175,17.01836,0.016,NULL,58879782765,919996605,14374946,16.9),(94307,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94307,34.5,0.62,79.5,39740,70,NULL,NULL,'CGCG 014-041',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.000086,NULL,'15.0g',0.69,'(R)SA0^0^',NULL,NULL,NULL,NULL,1,186.782125,-1.35419,0.033,NULL,42990613913,671728342,10495755,15),(94308,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94308,34.83,0.2,92.5,39741,74.4,NULL,NULL,'IC 0792',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.000007,NULL,'14.80',0.6,'Sc(s)II','Group member',NULL,NULL,NULL,1,186.786541667,16.32539,0.02,NULL,58154618347,908665911,14197904,14.8),(94309,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94309,34.9,0.24,95.7,39741,NULL,NULL,NULL,'IC 0792',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94310,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94310,34.97,0.23,98.6,39741,NULL,NULL,'Malmquist cor.','IC 0792',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94311,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94311,30.13,0.39,10.6,39742,73,NULL,'IR','NGC 4423',NULL,'2011A&A...532A.104N',2011,1,2.3,NULL,'G',0.00002,NULL,'14.01',0.4,'Sdm:           HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.787375,5.88017,0,NULL,58234000026,909906250,14217285,14.01),(94312,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94312,30.13,0.4,10.6,39742,75,NULL,NULL,'NGC 4423',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94313,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94313,31.14,0.49,16.9,39742,75,NULL,'IR','NGC 4423',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94314,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94314,31.38,0.36,18.9,39742,NULL,NULL,NULL,'NGC 4423',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94315,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94315,31.55,NULL,20.4,39742,NULL,NULL,NULL,'NGC 4423',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94316,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94316,31.81,0.4,23,39742,75,NULL,'B','NGC 4423',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94317,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94317,36.57,0.27,206,39743,70,NULL,NULL,'2MASX J12270894+3046296',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000192,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,186.787167,30.77492,0.016,NULL,58759798491,918121851,14345653,17.4),(94318,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94318,37.84,0.23,369,39744,70,NULL,NULL,'2MASX J12271101+6818382',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000092,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,186.7959583,68.31081,0.065,NULL,57851234098,903925532,14123836,16.5),(94319,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94319,31.13,0.4,16.8,39745,75,NULL,'B','UGC 07557',NULL,'1988NBGC.C....0000T',1988,1,3,NULL,'G',0.000013,NULL,'13.39',2.8,'Sm             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,186.796125,7.26314,0.014,NULL,58236558716,909946229,14217909,13.39),(94320,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94320,31.13,0.4,16.8,39746,75,NULL,'B','IC 3365',NULL,'1988NBGC.C....0000T',1988,1,1.79,NULL,'G',0.000017,NULL,'14.6g',0.64,'Im             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,186.796583,15.89667,0.03,NULL,58154729253,908667644,14197931,14.6),(94321,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94321,31.29,0.43,18.1,39746,75,NULL,'3.6 micron, color + selection bias corrected','IC 3365',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94322,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94322,31.31,0.36,18.3,39746,NULL,NULL,NULL,'IC 3365',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94323,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94323,31.38,0.43,18.9,39746,75,NULL,'3.6 micron, color corrected','IC 3365',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94324,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94324,31.39,0.2,19,39746,74.4,NULL,NULL,'IC 3365',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94325,'SNIa','2016-12-15 15:15:00','2016-12-16 11:20:10','1','SN 2012cg',NULL,94325,30.73,NULL,14,39747,NULL,NULL,'B','NGC 4424',NULL,'2013NewA...20...30M',2013,1,3.6,NULL,'G',0.000007,NULL,'12.34',1.8,'SB(s)a:        HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.798375,9.42067,0,NULL,58246246807,910097606,14220275,12.34),(94326,'SNIa','2016-12-15 15:15:00','2016-12-16 11:20:10','1','SN 2012cg',NULL,94326,30.92,NULL,15.3,39747,NULL,NULL,'Rc','NGC 4424',NULL,'2013NewA...20...30M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94327,'SNIa','2016-12-15 15:15:00','2016-12-16 11:20:10','1','SN 2012cg',NULL,94327,30.92,NULL,15.3,39747,NULL,NULL,'Ic','NGC 4424',NULL,'2013NewA...20...30M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94328,'SNIa','2016-12-15 15:15:00','2016-12-16 11:20:10','1','SN 2012cg',NULL,94328,31.02,NULL,16,39747,NULL,NULL,'V','NGC 4424',NULL,'2013NewA...20...30M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94329,'Tully est','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94329,31.13,0.8,16.8,39747,75,NULL,'B','NGC 4424',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94330,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94330,30.9,0.3,15.1,39747,NULL,NULL,'stellar kinematics','NGC 4424',NULL,'2008ApJ...683...78C',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94331,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94331,34.73,0.48,88.4,39748,70,NULL,NULL,'MCG -01-32-011',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5',0.5,'poss. LINER',NULL,NULL,NULL,NULL,1,186.79875,-7.69975,0.041,NULL,43216625306,675259770,10550933,14.5),(94332,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94332,34.89,0.46,94.9,39749,70,NULL,NULL,'NGC 4422',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.97',1.2,'SA0- pec?',NULL,NULL,NULL,NULL,1,186.800458333,-5.831,0.073,NULL,43201905509,675029773,10547340,14.97),(94333,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94333,37.67,0.33,341,39750,70,NULL,NULL,'2MASX J12271283+0411488',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'17.92',0.16,NULL,NULL,NULL,NULL,NULL,1,186.8034583,4.19686,0,NULL,58006455571,906350868,14161732,17.92),(94334,'Tully est','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94334,31.13,0.8,16.8,39751,75,NULL,'B','NGC 4425',NULL,'1988NBGC.C....0000T',1988,1,2.39,NULL,'G',0.000017,NULL,'12.6g',0.92,'SB0+: sp','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.8055417,12.73472,0.1,NULL,58161435778,908772434,14199569,12.6),(94335,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94335,36.88,0.46,238,39752,70,NULL,NULL,'2MASX J12271358+6143216',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,186.806333333,61.72269,0,NULL,57375105908,896486029,14007594,17.4),(94336,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94336,35.28,0.15,114,39753,70,NULL,NULL,'VCC 0981',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.0001,NULL,'15.4g',0.45,'SB0_1_(1)','Group member',NULL,NULL,NULL,1,186.807125,9.7085,0,NULL,58246071403,910094865,14220232,15.4),(94337,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94337,36.81,0.46,230,39754,70,NULL,NULL,'2MASX J12271399+2524358',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.95',0.13,NULL,NULL,NULL,NULL,NULL,1,186.8082083,25.40986,0.088,NULL,58614232545,915847383,14310115,17.95),(94338,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94338,38.27,0.46,450,39755,70,NULL,NULL,'2MASX J12271422+3239376',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,186.809083,32.66064,0.028,NULL,58765258373,918207162,14346986,18.1),(94339,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94339,37.17,0.46,272,39756,70,NULL,NULL,'VPC 0519',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000173,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,186.810125,13.89506,0.089,NULL,58163405081,908803204,14200050,17.1),(94340,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94340,37.91,0.08,383,39757,70,NULL,NULL,'2MASX J12271489+0858148',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000093,NULL,'16.39',0.5,'BrClG',NULL,NULL,NULL,NULL,1,186.81225,8.97083,0,NULL,58243516003,910054937,14219608,16.39),(94341,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94341,37.77,0.46,358,39758,70,NULL,NULL,'VPC 0520',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000162,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,186.815083333,10.90517,0.019,NULL,58188621763,909197215,14206206,16.9),(94342,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94342,37.94,0.46,387,39759,70,NULL,NULL,'2MASX J12271575+3510336',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,186.81575,35.17625,0.012,NULL,58569417517,915147148,14299174,17.8),(94343,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94343,37.91,0.08,383,39760,70,NULL,NULL,'2MASX J12271617+0856388',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000147,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,186.8175417,8.94406,0,NULL,58243518119,910054970,14219608,17.7),(94344,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94344,37.55,0.33,324,39761,70,NULL,NULL,'SDSS J122716.74+431956.9',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000158,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,186.81975,43.3325,0,NULL,59063355996,922864937,14419764,17.2),(94345,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94345,37.54,0.27,323,39762,70,NULL,NULL,'SDSS J122717.88+065745.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,186.8245417,6.96261,0,NULL,58237099390,909954677,14218041,17.9),(94346,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94346,37.67,0.33,341,39763,70,NULL,NULL,'2MASX J12271797+0412308',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.14',0.14,NULL,NULL,NULL,NULL,NULL,1,186.824875,4.2085,0,NULL,58006468560,906351071,14161735,18.14),(94347,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94347,37.81,0.46,365,39764,70,NULL,NULL,'2MASX J12271817+1829397',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'18.11',0.1,NULL,NULL,NULL,NULL,NULL,1,186.825875,18.49428,0.108,NULL,58916776911,920574639,14383978,18.11),(94348,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94348,37.91,0.08,383,39765,70,NULL,NULL,'2MASX J12271831+0850364',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000093,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,186.826375,8.84356,0,NULL,58243659525,910057180,14219643,16.8),(94349,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94349,35.27,0.46,113,39766,70,NULL,NULL,'2MASX J12271846+5110290',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000097,NULL,'15.5g',0.45,'S0^-',NULL,NULL,NULL,NULL,1,186.82725,51.17481,0,NULL,57243594126,894431158,13975486,15.5),(94350,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94350,31.4,0.45,19,39767,NULL,NULL,'I','NGC 4441',NULL,'2001ApJ...546..681T',2001,1,1.47,'RC3 has V = 1466 +- 48 km/sec.','G',0.000003,NULL,'13.5g',0.93,'SAB0+ pec','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.8347917,64.8015,0.009,NULL,57323957444,895686835,13995106,13.5),(94351,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94351,31.43,0.14,19.3,39767,74.4,NULL,NULL,'NGC 4441',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94352,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94352,34.95,0.65,97.8,39768,NULL,NULL,'Malmquist cor.','ESO 573- G 024',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.20',0.6,'SAB(r)ab',NULL,NULL,NULL,NULL,1,186.835667,-17.91019,0.045,NULL,43944511868,686632997,10728640,15.2),(94353,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94353,35.18,0.58,109,39768,NULL,NULL,NULL,'ESO 573- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94354,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94354,35.22,0.2,111,39768,74.4,NULL,NULL,'ESO 573- G 024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94355,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94355,37.28,0.46,286,39769,70,NULL,NULL,'2MASX J12272063+0057208',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000073,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,186.835917,0.95581,0.008,NULL,58010541211,906414706,14162729,17.5),(94356,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94356,32.28,0.2,28.6,39770,74.4,NULL,NULL,'IC 3371',NULL,'2013AJ....146...86T',2013,1,1.58,NULL,'G',0.000002,NULL,'15.2g',0.27,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,186.8427083,10.86678,0.019,NULL,58188591497,909196742,14206199,15.2),(94357,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94357,32.36,0.53,29.6,39770,NULL,NULL,'Malmquist cor.','IC 3371',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94358,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94358,32.44,0.43,30.8,39770,75,NULL,'3.6 micron, color corrected','IC 3371',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94359,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94359,32.51,0.5,31.8,39770,NULL,NULL,NULL,'IC 3371',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94360,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94360,32.56,0.43,32.5,39770,75,NULL,'3.6 micron, color + selection bias corrected','IC 3371',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94361,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94361,32.8,NULL,36.3,39770,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 3371',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94362,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94362,32.81,NULL,36.5,39770,NULL,NULL,'Dipole','IC 3371',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94363,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94363,32.83,NULL,36.8,39770,NULL,NULL,'Dipole + Quadrupole','IC 3371',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94364,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94364,32.92,NULL,38.4,39770,NULL,NULL,NULL,'IC 3371',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94365,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94365,35.54,0.46,128,39771,70,NULL,NULL,'LCRS B122448.9-022832',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000074,NULL,'16.1g',0.32,NULL,NULL,NULL,NULL,NULL,1,186.845417,-2.75186,0.073,NULL,42996117872,671814341,10497099,16.1),(94366,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94366,37.21,0.27,277,39772,70,NULL,NULL,'2MASX J12272303+1701032',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.17',0.19,NULL,NULL,NULL,NULL,NULL,1,186.845875,17.01761,0,NULL,58880498408,920007787,14375121,17.17),(94367,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94367,34.2,0.57,69,39773,70,NULL,NULL,'2MASX J12272367-5041536',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000137,NULL,'15.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,186.84875,-50.69825,0.845,NULL,44616161674,697127526,10892617,15.3),(94368,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94368,37.65,0.46,338,39774,70,NULL,NULL,'2MASX J12272457+2008437',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,186.8525,20.14544,0.116,NULL,58917541344,920586583,14384165,17.1),(94369,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94369,37.91,0.08,383,39775,70,NULL,NULL,'SDSS J122724.65+085944.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00017,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,186.85275,8.99575,0,NULL,58245400498,910084382,14220068,18.3),(94370,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94370,35.65,0.47,135,39776,70,NULL,NULL,'2MFGC 09813',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.83',NULL,NULL,NULL,NULL,NULL,NULL,1,186.852917,-14.47464,0.089,NULL,43044774589,672574602,10508978,15.83),(94371,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94371,37.86,0.46,373,39777,70,NULL,NULL,'2MASX J12272493+3817187',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,186.853833,38.28844,0,NULL,58576416450,915256507,14300882,17.8),(94372,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94372,36.04,0.33,161,39778,70,NULL,NULL,'2MASX J12272497+5306129',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000182,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,186.854041667,53.10356,0,NULL,57229018233,894203409,13971928,16.4),(94373,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94373,37.91,0.08,383,39779,70,NULL,NULL,'2MASX J12272547+0857035',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000127,NULL,'16.7g',0.33,'S',NULL,NULL,NULL,NULL,1,186.856,8.95081,0,NULL,58245399342,910084364,14220068,16.7),(94374,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94374,38.61,0.46,526,39780,70,NULL,NULL,'LCRS B122452.0-023907',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000078,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,186.8585417,-2.92828,0.085,NULL,42994299864,671785935,10496655,18.1),(94375,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94375,30.15,0.69,10.7,39781,100,NULL,'mid-IR','NGC 4430',NULL,'2013ApJ...771...88L',2013,1,1.86,NULL,'G',0.000013,NULL,'13.4g',1.18,'SB(rs)b:;HII   LINER','Pair member (points to parent)',NULL,NULL,NULL,1,186.8600417,6.26278,0,NULL,58237599451,909962491,14218163,13.4),(94376,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94376,30.98,0.84,15.7,39781,NULL,NULL,NULL,'NGC 4430',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94377,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94377,31.02,0.2,16,39781,74.4,NULL,NULL,'NGC 4430',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94378,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94378,31.32,0.72,18.3,39781,NULL,NULL,'Malmquist cor.','NGC 4430',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94379,'Ring Diameter','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94379,30,0.84,9.9,39782,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4429',NULL,'1981ApJS...45..541P',1981,1,5.6,'v=916 km/s(2003A&A...412...57P)','G',0.000017,NULL,'11.02',2.6,'SA(r)0+;LINER  HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.860458333,11.10772,0.049,NULL,58188467431,909194803,14206168,11.02),(94380,'Faber-Jackson','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94380,30.69,0.46,13.7,39782,95,NULL,'de Vaucouleurs','NGC 4429',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94381,'Faber-Jackson','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94381,30.99,0.32,15.8,39782,95,NULL,'Weighted Mean','NGC 4429',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94382,'Faber-Jackson','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94382,31.37,0.46,18.8,39782,95,NULL,'Michard 1979a','NGC 4429',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94383,'Faber-Jackson','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94383,31.73,0.63,22.2,39782,95,NULL,'Michard 1979b, c','NGC 4429',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94384,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94384,30.57,NULL,13,39782,NULL,NULL,NULL,'NGC 4429',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94385,'Tertiary','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94385,30.49,0.25,12.5,39782,95,NULL,NULL,'NGC 4429',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94386,'Tully est','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94386,31.13,0.8,16.8,39782,75,NULL,'B','NGC 4429',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94387,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94387,30.54,0.45,12.8,39782,NULL,NULL,'K','NGC 4429',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94388,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94388,31.1,0.1,16.6,39782,NULL,NULL,'stellar kinematics','NGC 4429',NULL,'2008ApJ...683...78C',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94389,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94389,31.84,0.4,23.3,39782,NULL,NULL,'mean','NGC 4429',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94390,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94390,37.21,0.27,277,39783,70,NULL,NULL,'2MASX J12272728+1657492',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.38',0.13,NULL,NULL,NULL,NULL,NULL,1,186.8635417,16.96367,0.016,NULL,58880551201,920008612,14375134,18.38),(94391,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94391,30.94,0.12,15.4,39784,NULL,NULL,'R','NGC 4431',NULL,'2004AJ....127..771J',2004,1,1.7,NULL,'G',0.000033,NULL,'13.74',1.1,'SA(r)0','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.864083,12.29028,0.079,NULL,58162391694,908787370,14199802,13.74),(94392,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94392,31.05,0.15,16.2,39784,NULL,NULL,'R','NGC 4431',NULL,'2004AJ....127..771J',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94393,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94393,30.45,NULL,12.3,39784,NULL,NULL,NULL,'NGC 4431',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94394,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94394,31,0.45,15.8,39784,NULL,NULL,'K','NGC 4431',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94395,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94395,31.56,0.4,20.6,39784,NULL,NULL,'mean','NGC 4431',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94396,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94396,38.3,0.46,458,39785,70,NULL,NULL,'2MASX J12272763+2615471',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,186.865,26.26314,0.062,NULL,58608120805,915751887,14308623,17.3),(94397,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94397,37.27,0.46,284,39786,70,NULL,NULL,'2MASX J12272772-0005381',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000079,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,186.865417,-0.094,0.035,NULL,42987956473,671686819,10495106,17.1),(94398,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94398,37.91,0.08,383,39787,70,NULL,NULL,'SDSS J122727.83+084919.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000165,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,186.866,8.822,0,NULL,58243654665,910057104,14219642,18),(94399,'BCG','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94399,38.16,0.35,393,39788,60,NULL,NULL,'ABELL 1541',0.0892,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I-II   [BM]',NULL,NULL,NULL,NULL,1,186.866667,8.82889,0,NULL,58243433481,910053648,14219588,NULL),(94400,'Tully est','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94400,33.18,0.8,43.3,39789,75,NULL,'B','NGC 4428',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000023,NULL,'13.07',0.8,'SAB(rs)c       HII','in a pair',NULL,NULL,NULL,1,186.867917,-8.16789,0.041,NULL,43216830857,675262982,10550984,13.07),(94401,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94401,32.84,0.43,37,39789,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4428',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94402,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94402,32.96,0.45,39,39789,NULL,NULL,'K','NGC 4428',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94403,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94403,32.96,0.46,39.1,39789,NULL,NULL,'J','NGC 4428',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94404,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94404,32.99,0.43,39.7,39789,75,NULL,'3.6 micron, color corrected','NGC 4428',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94405,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94405,33,0.47,39.8,39789,NULL,NULL,'H','NGC 4428',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94406,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94406,33.21,0.2,43.9,39789,74.4,NULL,NULL,'NGC 4428',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94407,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94407,33.26,0.4,44.9,39789,NULL,NULL,'mean','NGC 4428',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94408,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94408,32.31,0.36,29,39790,NULL,NULL,NULL,'UGC 07567',NULL,'2009AJ....138..323T',2009,1,1.25,NULL,'G',0.000017,NULL,'15.2g',0.58,'Im:            HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,186.871333,7.64347,0,NULL,58247865043,910122891,14220670,15.2),(94409,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94409,35.28,0.15,114,39791,70,NULL,NULL,'NGC 4410K',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000093,NULL,'17.11',0.28,NULL,NULL,NULL,NULL,NULL,1,186.87125,9.04336,0,NULL,58245404972,910084452,14220069,17.11),(94410,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94410,37.82,0.33,367,39792,70,NULL,NULL,'2MASX J12272972-0212591',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00009,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,186.873833333,-2.21636,0.065,NULL,42996651065,671822672,10497229,17),(94411,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94411,36.83,0.46,232,39793,70,NULL,NULL,'LCRS B122456.2-031005',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000065,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,186.87625,-3.4445,0.109,NULL,42994935994,671795874,10496810,17.6),(94412,'BCG','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94412,38.16,0.35,393,39794,60,NULL,'ABELL 1541, BCG','IRAS F12249+0905',0.0892,'1980ApJ...241..486H',1980,1,0.47,NULL,'G',0.000133,NULL,'11.4',0.24,'Sc(r);BrClG','Group member, central object',NULL,NULL,NULL,1,186.87775,8.82431,0,NULL,58243446816,910053856,14219591,11.4),(94413,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94413,38.42,0.46,484,39795,70,NULL,NULL,'2MASX J12273206+5604037',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,186.8835,56.06761,0,NULL,57409932942,897030202,14016096,17.6),(94414,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94414,37.49,0.46,315,39796,70,NULL,NULL,'2MASX J12273266+6606151',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000178,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,186.886291667,66.10408,0.005,NULL,57325515245,895711175,13995487,16.6),(94415,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94415,37.38,0.46,299,39797,70,NULL,NULL,'2MASX J12273287+1754367',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.20',0.15,NULL,NULL,NULL,NULL,NULL,1,186.886875,17.91019,0.02,NULL,58913981251,920530957,14383296,18.2),(94416,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94416,34.21,0.91,69.6,39798,NULL,NULL,'Malmquist cor.','NGC 4432',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000003,NULL,'14.82',0.7,'Sc(s)I-II','Pair member (points to parent)',NULL,NULL,NULL,1,186.887375,6.23325,0,NULL,58237594605,909962415,14218162,14.82),(94417,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94417,34.27,0.89,71.4,39798,NULL,NULL,NULL,'NGC 4432',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94418,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94418,34.31,0.2,72.8,39798,74.4,NULL,NULL,'NGC 4432',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94419,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94419,37.01,0.27,253,39799,70,NULL,NULL,'2MASX J12273343+2613481',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.16',0.16,NULL,NULL,NULL,NULL,NULL,1,186.889458333,26.23006,0.062,NULL,58608118570,915751852,14308622,18.16),(94420,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94420,36.87,0.46,236,39800,70,NULL,NULL,'2MASX J12273346+0346064',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,186.8895,3.76847,0.077,NULL,58006607603,906353243,14161769,17.2),(94421,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94421,37.49,0.46,315,39801,70,NULL,NULL,'2MASX J12273365+2320377',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,186.890416667,23.34381,0.073,NULL,58892256481,920191507,14377992,17.6),(94422,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94422,37.31,0.46,290,39802,70,NULL,NULL,'2MASX J12273428+2655271',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00017,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,186.892667,26.92428,0.081,NULL,58608653703,915760214,14308753,17.4),(94423,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94423,37.91,0.08,383,39803,70,NULL,NULL,'2MASX J12273498+0852415',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000142,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,186.8957083,8.87808,0,NULL,58243433159,910053643,14219588,17.9),(94424,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94424,37.85,0.46,372,39804,70,NULL,NULL,'2MASX J12273589+0517034',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,186.8995,5.28422,0,NULL,58226028382,909781693,14215338,17.4),(94425,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94425,37.91,0.08,383,39805,70,NULL,NULL,'SDSS J122736.40+084943.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,186.9017083,8.82881,0,NULL,58243433769,910053652,14219588,18.4),(94426,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94426,31.45,0.11,19.5,39806,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4434',NULL,'2010ApJ...717..603V',2010,1,1.4,NULL,'G',0.000017,NULL,'13.03',1.4,'E0/S0(0)','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.902833,8.15433,0,NULL,58248040043,910125625,14220712,13.03),(94427,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94427,31.47,0.13,19.6,39806,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4434',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94428,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94428,31.76,0.15,22.5,39806,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4434',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94429,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94429,31.87,0.14,23.7,39806,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4434',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94430,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94430,31.66,0.12,21.5,39806,74.4,NULL,NULL,'NGC 4434',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94431,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94431,31.75,0.06,22.4,39806,NULL,NULL,NULL,'NGC 4434',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94432,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94432,31.76,0.07,22.5,39806,NULL,NULL,'HST ACS VCS','NGC 4434',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94433,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94433,31.98,0.17,24.9,39806,NULL,NULL,'I','NGC 4434',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94434,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94434,32.14,0.17,26.8,39806,NULL,NULL,'I','NGC 4434',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94435,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94435,32.14,0.17,26.8,39806,NULL,NULL,NULL,'NGC 4434',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94436,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94436,32.14,0.17,26.8,39806,NULL,NULL,'Malmquist cor.','NGC 4434',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94437,'D-Sigma','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94437,31.13,0.4,16.8,39806,75,NULL,'Edat, raw','NGC 4434',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94438,'D-Sigma','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94438,31.15,0.4,17,39806,75,NULL,'Edat, cor','NGC 4434',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94439,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94439,31.05,NULL,16.2,39806,NULL,NULL,NULL,'NGC 4434',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94440,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94440,31.28,NULL,18,39806,NULL,NULL,NULL,'NGC 4434',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94441,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94441,31.66,0.12,21.5,39806,74.4,NULL,NULL,'NGC 4434',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94442,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94442,31.69,0.41,21.7,39806,NULL,NULL,NULL,'NGC 4434',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94443,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94443,31.77,0.41,22.6,39806,NULL,NULL,'Malmquist cor.','NGC 4434',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94444,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94444,31.82,0.4,23.1,39806,NULL,NULL,'mean','NGC 4434',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94445,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94445,32.27,0.45,28.4,39806,NULL,NULL,'K','NGC 4434',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94446,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94446,32.14,0.12,26.8,39807,74.4,NULL,NULL,'IC 3370',NULL,'2013AJ....146...86T',2013,1,2.9,NULL,'G',0.00008,NULL,'11.99',2.3,'E2-3     poss. LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,186.905541667,-39.33778,0.329,NULL,43280787418,676262303,10566598,11.99),(94447,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94447,32.14,0.17,26.8,39807,NULL,NULL,'I','IC 3370',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94448,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94448,32.14,0.17,26.8,39807,NULL,NULL,NULL,'IC 3370',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94449,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94449,32.2,0.17,27.5,39807,NULL,NULL,'Malmquist cor.','IC 3370',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94450,'D-Sigma','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94450,31.77,0.4,22.6,39807,75,NULL,'Edat, raw','IC 3370',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94451,'D-Sigma','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94451,32.21,0.4,27.7,39807,75,NULL,'Edat, cor','IC 3370',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94452,'D-Sigma','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94452,32.96,0.1,39.1,39807,72,NULL,'Cen 30 cluster, 21 galaxies','IC 3370',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94453,'D-Sigma','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94453,33.23,0.22,44.2,39807,70,NULL,'Cen 30 CLUSTER','IC 3370',NULL,'1988MNRAS.235.1177L',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94454,'D-Sigma','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94454,33.24,0.18,44.5,39807,70,NULL,'Cen 30 CLUSTER','IC 3370',NULL,'1988MNRAS.235.1177L',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94455,'Faber-Jackson','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94455,31.36,0.63,18.7,39807,95,NULL,'Michard 1979b, c','IC 3370',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94456,'Faber-Jackson','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94456,31.68,0.37,21.7,39807,95,NULL,'Weighted Mean','IC 3370',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94457,'Faber-Jackson','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94457,31.94,0.46,24.4,39807,95,NULL,'Michard 1979a','IC 3370',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94458,'Faber-Jackson','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94458,33.67,0.81,54.2,39807,55,NULL,'Visvanathan & Sandage 1979','IC 3370',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94459,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94459,31.92,0.41,24.2,39807,NULL,NULL,NULL,'IC 3370',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94460,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94460,32.14,0.12,26.8,39807,74.4,NULL,NULL,'IC 3370',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94461,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94461,32.28,0.41,28.6,39807,NULL,NULL,'Malmquist cor.','IC 3370',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94462,'Magnitude','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94462,33.7,NULL,55,39807,NULL,NULL,'Centaurus cluster','IC 3370',NULL,'1995A&A...302...21G',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94463,'Tully est','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94463,33,0.8,39.9,39807,75,NULL,'B','IC 3370',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94464,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94464,32.43,0.45,30.7,39807,NULL,NULL,'K','IC 3370',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94465,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94465,32.89,0.17,37.8,39807,75,NULL,'Cen 30 cluster, avg. of 11 spiral galaxies','IC 3370',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94466,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94466,32.91,0.17,38.2,39807,75,NULL,'Cen 30 CLUSTER','IC 3370',NULL,'2012ApJ...749...78T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94467,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94467,32.92,0.16,38.4,39807,74.4,NULL,'Centaurus CLUSTER, 13 galaxies, WISE W2 (4.6 micro-meter), color corrected','IC 3370',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94468,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94468,32.93,0.2,38.5,39807,75,NULL,'Cen 30 cluster, avg. of 11 spiral galaxies','IC 3370',NULL,'2013ApJ...765...94S',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94469,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94469,32.93,0.16,38.6,39807,74.4,NULL,'Centaurus CLUSTER, 13 galaxies, WISE W1 (3.4 micro-meter), color corrected','IC 3370',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94470,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94470,32.93,0.15,38.6,39807,74.4,NULL,'Centaurus CLUSTER, 13 galaxies, WISE I-band','IC 3370',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94471,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94471,32.95,0.09,38.9,39807,74.4,NULL,'Centaurus CLUSTER, 13 galaxies, WISE W2 (4.6 micro-meter), curved','IC 3370',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94472,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94472,32.97,0.09,39.3,39807,74.4,NULL,'Centaurus CLUSTER, 13 galaxies, WISE W1 (3.4 micro-meter), curved','IC 3370',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94473,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94473,32.98,0.16,39.4,39807,70,NULL,'Cen 30 Cluster','IC 3370',NULL,'1992ApJ...396..453H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94474,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94474,33.02,0.6,40.2,39807,77,NULL,'Cen 30 cluster, 13 galaxies','IC 3370',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94475,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94475,33.02,NULL,40.2,39807,77,NULL,'BRIK, Cen 30 cluster, 13 galaxies','IC 3370',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94476,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94476,33.13,0.4,42.3,39807,NULL,NULL,'mean','IC 3370',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94477,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94477,33.18,NULL,43.2,39807,71,NULL,'IC 3370 GROUP, Cen 30, 150 galaxies','IC 3370',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94478,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94478,33.25,0.3,44.7,39807,NULL,NULL,'IC 3370 GROUP, Cen 30, 22 galaxies','IC 3370',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94479,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94479,37.91,0.08,383,39808,70,NULL,NULL,'SDSS J122737.35+083959.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000134,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,186.905667,8.66642,0,NULL,58243460173,910054065,14219594,18.2),(94480,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94480,37.91,0.08,383,39809,70,NULL,NULL,'2MASX J12273775+0844065',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000206,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,186.9074583,8.73522,0,NULL,58243465729,910054152,14219596,17),(94481,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94481,37.91,0.08,383,39810,70,NULL,NULL,'2MASX J12273842+0849165',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000182,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,186.910166667,8.82133,0,NULL,58243447351,910053864,14219591,17.3),(94482,'Tully est','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94482,33.11,0.8,41.8,39811,75,NULL,'B','NGC 4433',NULL,'1988NBGC.C....0000T',1988,1,2.2,NULL,'G',0.00002,NULL,'12.90',1,'SAB(s)ab       HII','in a pair',NULL,NULL,NULL,1,186.9107917,-8.27842,0.069,NULL,43216483061,675257547,10550899,12.9),(94483,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94483,33.03,0.45,40.4,39811,NULL,NULL,'K','NGC 4433',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94484,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94484,33.1,0.47,41.8,39811,NULL,NULL,'H','NGC 4433',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94485,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94485,33.15,0.46,42.7,39811,NULL,NULL,'J','NGC 4433',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94486,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94486,33.22,0.2,44.1,39811,74.4,NULL,NULL,'NGC 4433',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94487,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94487,33.26,0.4,44.9,39811,NULL,NULL,'mean','NGC 4433',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94488,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94488,33.53,0.43,50.7,39811,NULL,NULL,NULL,'NGC 4433',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94489,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94489,33.55,0.43,51.2,39811,NULL,NULL,'Malmquist cor.','NGC 4433',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94490,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94490,37.52,0.46,320,39812,70,NULL,NULL,'LCRS B122506.3-023554',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000076,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,186.918041667,-2.87475,0.085,NULL,42994243043,671785047,10496641,18.5),(94491,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94491,37.91,0.08,383,39813,70,NULL,NULL,'SDSS J122740.38+084603.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000147,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,186.9182917,8.76764,0,NULL,58243438037,910053719,14219589,18.6),(94492,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94492,30.91,0.09,15.2,39814,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4435',NULL,'2010ApJ...717..603V',2010,1,2.35,NULL,'G',0.000017,NULL,'11.8g',1.43,'SB(s)0^0^;LINERHII','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.9187083,13.07894,0.095,NULL,58161087918,908766998,14199484,11.8),(94493,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94493,30.94,0.1,15.4,39814,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4435',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94494,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94494,31.02,0.1,16,39814,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4435',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94495,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94495,31.13,0.09,16.8,39814,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4435',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94496,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94496,31.09,0.14,16.5,39814,74.4,NULL,NULL,'NGC 4435',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94497,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94497,31.11,0.07,16.7,39814,NULL,NULL,'HST ACS VCS','NGC 4435',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94498,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94498,31.12,0.05,16.7,39814,NULL,NULL,NULL,'NGC 4435',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94499,'Faber-Jackson','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94499,30.75,0.56,14.1,39814,95,NULL,'de Vaucouleurs','NGC 4435',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94500,'Faber-Jackson','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94500,31,0.43,15.8,39814,95,NULL,'Weighted Mean','NGC 4435',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94501,'Faber-Jackson','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94501,32.65,0.81,33.9,39814,55,NULL,'Visvanathan & Sandage 1979','NGC 4435',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94502,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94502,30.59,NULL,13.1,39814,NULL,NULL,NULL,'NGC 4435',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94503,'Tertiary','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94503,30.49,0.25,12.5,39814,95,NULL,NULL,'NGC 4435',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94504,'Tully est','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94504,31.13,0.8,16.8,39814,75,NULL,'B','NGC 4435',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94505,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94505,30.9,0.45,15.1,39814,NULL,NULL,'K','NGC 4435',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94506,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94506,31.56,0.4,20.5,39814,NULL,NULL,'mean','NGC 4435',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94507,'Brightest Stars','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94507,28.42,NULL,4.83,39815,NULL,NULL,NULL,'UGC 07577',NULL,'1998A&AS..128..325T',1998,1,4.3,NULL,'G',0.000001,NULL,'12.84',2.4,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,186.920417,43.49556,0,NULL,59061538793,922836543,14419320,12.84),(94508,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94508,26.98,0.07,2.49,39815,NULL,NULL,NULL,'UGC 07577',NULL,'2002AJ....124..213M',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94509,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94509,27.02,0.13,2.54,39815,NULL,NULL,NULL,'UGC 07577',NULL,'2002A&A...389..812K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94510,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94510,27.06,0.05,2.58,39815,NULL,NULL,'I','UGC 07577',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94511,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94511,27.06,0.06,2.58,39815,NULL,NULL,NULL,'UGC 07577',NULL,'2013AstBu..68..125M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94512,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94512,27.07,0.05,2.59,39815,NULL,NULL,'I','UGC 07577',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94513,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94513,27.07,0.08,2.6,39815,74.4,NULL,NULL,'UGC 07577',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94514,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94514,27.09,0.11,2.62,39815,NULL,NULL,NULL,'UGC 07577',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94515,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94515,27.19,0.03,2.74,39815,NULL,NULL,NULL,'UGC 07577',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94516,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94516,27.4,0.4,3,39815,75,NULL,'B','UGC 07577',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94517,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94517,37.79,0.46,361,39816,70,NULL,NULL,'2MASX J12274104+1622494',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,186.921125,16.38044,0.02,NULL,58880041408,920000647,14375010,17.6),(94518,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94518,31.13,0.17,16.8,39817,NULL,NULL,'R','NGC 4436',NULL,'2004AJ....127..771J',2004,1,1.91,NULL,'G',0.000037,NULL,'14.0g',0.67,'dE6/dS0,N','in a pair',NULL,NULL,NULL,1,186.921833,12.31589,0.079,NULL,58162403622,908787556,14199805,14),(94519,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94519,30.87,0.45,14.9,39817,NULL,NULL,'K','NGC 4436',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94520,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94520,31.72,0.4,22,39817,NULL,NULL,'mean','NGC 4436',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94521,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94521,37.24,0.64,281,39818,70,NULL,NULL,'2MASX J12274170-0757354',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,186.92375,-7.95992,0.041,NULL,43216849636,675263275,10550988,15.3),(94522,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94522,38.15,0.27,427,39819,70,NULL,NULL,'2MASX J12274273+3304241',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000199,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,186.92825,33.07336,0.026,NULL,58764810291,918200160,14346877,17.2),(94523,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94523,36.84,0.46,233,39820,70,NULL,NULL,'2MASX J12274360+2404282',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.37',0.18,NULL,NULL,NULL,NULL,NULL,1,186.931958333,24.07439,0.027,NULL,58611813213,915809581,14309524,17.37),(94524,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94524,37.61,0.46,333,39821,70,NULL,NULL,'2MASX J12274422+3414291',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000166,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,186.9342083,34.24142,0.016,NULL,58763068433,918172944,14346452,17.5),(94525,'Tully est','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94525,31.13,0.8,16.8,39822,75,NULL,'B','NGC 4438',NULL,'1988NBGC.C....0000T',1988,1,8.5,NULL,'G',0.00001,NULL,'11.02',3.2,'SA(s)0/a pec:  LINER','in a radial-velocity based grouping',NULL,NULL,'LINER b',1,186.9399583,13.00883,0.095,NULL,58161059813,908766559,14199477,11.02),(94526,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94526,29.79,0.42,9.08,39822,65,NULL,NULL,'NGC 4438',NULL,'1980ApJ...238..458M',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94527,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94527,30.21,NULL,11,39822,84,NULL,'RC2 Hubble type','NGC 4438',NULL,'1986AJ.....91.1286S',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94528,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94528,30.26,NULL,11.3,39822,NULL,NULL,NULL,'NGC 4438',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94529,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94529,30.32,0.92,11.6,39822,NULL,NULL,'CO','NGC 4438',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94530,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94530,30.57,0.7,13,39822,NULL,NULL,'HI','NGC 4438',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94531,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94531,30.8,0.3,14.4,39822,55,NULL,'B','NGC 4438',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94532,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94532,31.2,NULL,17.4,39822,84,NULL,'RSA Hubble type','NGC 4438',NULL,'1986AJ.....91.1286S',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94533,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94533,37.62,0.46,334,39823,70,NULL,NULL,'2MASX J12274599+3020121',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000139,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,186.941833,30.33689,0.027,NULL,58758279868,918098122,14345283,17.8),(94534,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94534,37.91,0.08,383,39824,70,NULL,NULL,'2MASX J12274618+0848565',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,186.9425,8.81581,0,NULL,58243446701,910053854,14219591,17.5),(94535,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94535,37.91,0.08,383,39825,70,NULL,NULL,'SDSS J122747.04+084631.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000139,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,186.9460417,8.77531,0,NULL,58243445239,910053831,14219591,18.7),(94536,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94536,37.01,0.27,253,39826,70,NULL,NULL,'2MASX J12274801+2620271',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00014,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,186.949916667,26.341,0.074,NULL,58608107550,915751680,14308620,16.3),(94537,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94537,37.85,0.15,372,39827,70,NULL,NULL,'VPC 0554',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000184,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,186.9510417,11.99589,0.043,NULL,58162062114,908782220,14199722,17.6),(94538,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94538,37.71,0.46,348,39828,70,NULL,NULL,'VPC 0555',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000173,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,186.9524583,10.67939,0.019,NULL,58188038860,909188107,14206064,16.6),(94539,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94539,39.04,0.46,644,39829,70,NULL,NULL,'SDSS J122748.84+075713.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000137,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,186.9535417,7.95381,0,NULL,58248200118,910128126,14220751,18.7),(94540,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94540,37.43,0.46,306,39830,70,NULL,NULL,'2MASXi J1227501+275507',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,186.959125,27.91861,0.072,NULL,58607494150,915742096,14308470,17.5),(94541,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94541,35.2,0.4,110,39831,NULL,NULL,'mean','IC 3376',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000027,NULL,'13.80',1.3,'(R)SBa         LINER',NULL,NULL,NULL,NULL,1,186.95975,26.99353,0.081,NULL,58608699935,915760936,14308764,13.8),(94542,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94542,35.22,0.47,110,39831,NULL,NULL,'H','IC 3376',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94543,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94543,35.23,0.45,111,39831,NULL,NULL,'K','IC 3376',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94544,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94544,35.31,0.46,115,39831,NULL,NULL,'J','IC 3376',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94545,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94545,37.82,0.33,367,39832,70,NULL,NULL,'2MASX J12275106-0212522',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000079,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,186.96275,-2.2145,0.049,NULL,42996144135,671814752,10497105,16.9),(94546,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94546,36.14,0.46,169,39833,70,NULL,NULL,'2MASX J12275122+3517510',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000192,NULL,'15.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,186.9635,35.29761,0.012,NULL,58569434381,915147412,14299178,15.6),(94547,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94547,37.2,0.46,276,39834,70,NULL,NULL,'2MASX J12275137+2530161',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,186.964083,25.50456,0.088,NULL,58613392695,915834260,14309910,17.5),(94548,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94548,34.93,NULL,96.7,39835,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 506- G 010',NULL,'2010Ap&SS.325..163P',2010,1,1.25,NULL,'G',0.000033,NULL,'16.75',0.13,'Sc',NULL,NULL,NULL,NULL,1,186.96475,-25.84528,0.445,NULL,43391148025,677986687,10593541,16.75),(94549,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94549,34.95,NULL,97.6,39835,NULL,NULL,'Dipole + Quadrupole','ESO 506- G 010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94550,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94550,34.95,NULL,97.9,39835,NULL,NULL,'Dipole','ESO 506- G 010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94551,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94551,34.99,0.51,99.7,39835,NULL,NULL,NULL,'ESO 506- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94552,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94552,34.99,NULL,99.7,39835,NULL,NULL,NULL,'ESO 506- G 010',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94553,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94553,35.03,0.2,101,39835,74.4,NULL,NULL,'ESO 506- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94554,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94554,35.08,0.49,104,39835,NULL,NULL,'Malmquist cor.','ESO 506- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94555,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94555,35.13,0.49,106,39835,75,NULL,'IR','ESO 506- G 010',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94556,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94556,34.33,0.49,73.4,39836,NULL,NULL,'Malmquist cor.','NGC 4456',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.05',0.6,'Sbc            HII',NULL,NULL,NULL,NULL,1,186.968333,-30.09789,0.369,NULL,43445145339,678830395,10606724,14.05),(94557,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94557,34.35,0.47,74.1,39836,NULL,NULL,'H','NGC 4456',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94558,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94558,34.44,0.45,77.3,39836,NULL,NULL,'K','NGC 4456',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94559,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94559,34.45,0.46,77.6,39836,NULL,NULL,NULL,'NGC 4456',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94560,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94560,34.49,0.2,79.1,39836,74.4,NULL,NULL,'NGC 4456',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94561,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94561,34.5,0.46,79.5,39836,NULL,NULL,'J','NGC 4456',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94562,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94562,34.62,0.4,83.8,39836,NULL,NULL,'mean','NGC 4456',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94563,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94563,38,0.33,398,39837,70,NULL,NULL,'2MASX J12275270+3654447',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000147,NULL,'17.3g',0.23,'AGN',NULL,NULL,NULL,NULL,1,186.969625,36.9125,0,NULL,58571119949,915173749,14299589,17.3),(94564,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94564,31.19,NULL,17.3,39838,NULL,NULL,NULL,'NGC 4440',NULL,'1999MNRAS.304..595G',1999,1,1.9,NULL,'G',0.00006,NULL,'12.70',1.5,'SB(rs)a','in a radial-velocity based grouping',NULL,NULL,NULL,1,186.9732083,12.29328,0.079,NULL,58162385486,908787273,14199801,12.7),(94565,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94565,36.82,0.46,231,39839,70,NULL,NULL,'2MASX J12275420+3924287',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000165,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,186.975708333,39.40797,0,NULL,58576933368,915264583,14301009,16.8),(94566,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94566,37.84,0.23,369,39840,70,NULL,NULL,'2MASX J12275437+6826167',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000066,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,186.9764583,68.438,0,NULL,57851218264,903925285,14123832,18),(94567,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94567,31.25,0.26,17.8,39841,NULL,NULL,'TOM(g) = -7.2 mag','UGC 07580',NULL,'2010ApJ...717..603V',2010,1,0.73,NULL,'G',0.000076,NULL,'14.9g',0.68,'S0(4)','Group member',NULL,NULL,NULL,1,186.978458333,8.09042,0,NULL,58248043160,910125674,14220713,14.9),(94568,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94568,31.31,0.56,18.3,39841,NULL,NULL,'TOM(g) = -7.2 mag','UGC 07580',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94569,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94569,31.62,0.46,21.1,39841,NULL,NULL,'TOM(u) = -8.4 mag','UGC 07580',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94570,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94570,31.64,0.4,21.3,39841,NULL,NULL,'TOM(z) = -8.53 mag','UGC 07580',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94571,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94571,31,0.14,15.9,39841,74.4,NULL,NULL,'UGC 07580',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94572,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94572,31.02,0.08,16,39841,NULL,NULL,NULL,'UGC 07580',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94573,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94573,31.02,0.08,16,39841,NULL,NULL,'HST ACS VCS','UGC 07580',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94574,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94574,31.35,0.45,18.6,39841,NULL,NULL,'K','UGC 07580',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94575,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94575,31.44,0.4,19.4,39841,NULL,NULL,'mean','UGC 07580',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94576,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94576,37.4,0.46,302,39842,70,NULL,NULL,'2MASX J12275485+4036507',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000168,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,186.978625,40.61419,0,NULL,58528187986,914502937,14289108,16.9),(94577,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94577,32.43,0.4,30.6,39843,75,NULL,NULL,'UGC 07579',NULL,'2008Ap.....51..336K',2008,1,1.3,'HOLM 410B is a star.','G',0.000033,NULL,'15.34',0.2,'Sdm:','Group member',NULL,NULL,NULL,1,186.9807917,5.72122,0,NULL,58233989779,909906090,14217282,15.34),(94578,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94578,32.85,0.49,37.1,39843,75,NULL,'IR','UGC 07579',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94579,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94579,37.73,0.46,352,39844,70,NULL,NULL,'2MASX J12275548+0619366',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,186.98125,6.32683,0,NULL,58237511442,909961116,14218142,17.3),(94580,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94580,37.66,0.33,340,39845,70,NULL,NULL,'2MASX J12275558+0123144',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000199,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,186.9815417,1.38733,0,NULL,58010384975,906412265,14162691,16.6),(94581,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94581,37.95,0.33,390,39846,70,NULL,NULL,'SDSS J122755.63+523221.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000166,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,186.981833,52.53936,0.021,NULL,57228619245,894197175,13971830,18.4),(94582,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94582,37.17,0.46,271,39847,70,NULL,NULL,'VPC 0563',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000173,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,186.984041667,10.92658,0.019,NULL,58188387825,909193559,14206149,16.7),(94583,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94583,37.73,0.46,351,39848,70,NULL,NULL,'2MASX J12275624-0142252',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000072,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,186.984417,-1.70708,0.041,NULL,42996383515,671818492,10497163,17.5),(94584,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94584,37.95,0.33,390,39849,70,NULL,NULL,'2MASX J12275636+5231244',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000169,NULL,'16.2g',0.42,'AGN',NULL,NULL,NULL,NULL,1,186.985083333,52.52347,0.021,NULL,57228619656,894197182,13971830,16.2),(94585,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94585,38,0.33,398,39850,70,NULL,NULL,'2MASX J12275671+3655177',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000133,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,186.986167,36.92161,0,NULL,58571117083,915173704,14299589,18.3),(94586,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94586,37.74,0.33,353,39851,70,NULL,NULL,'SDSS J122757.38+074813.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000137,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,186.989125,7.80383,0,NULL,58247704541,910120383,14220630,18.2),(94587,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94587,37.91,0.08,383,39852,70,NULL,NULL,'2MASX J12275750+0855266',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,186.989875,8.924,0,NULL,58245470715,910085479,14220085,18),(94588,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94588,36.04,0.33,161,39853,70,NULL,NULL,'2MASX J12275794+5302344',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000175,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,186.991583333,53.04281,0.014,NULL,57229150474,894205476,13971960,16.8),(94589,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94589,37.32,0.46,291,39854,70,NULL,NULL,'2MASX J12275834+3012530',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000156,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,186.993167,30.21475,0.027,NULL,58758304093,918098501,14345289,16.9),(94590,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94590,38.5,0.46,501,39855,70,NULL,NULL,'2MASX J12275873+1108006',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,186.9947917,11.13342,0.049,NULL,58188316610,909192447,14206131,17.8),(94591,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94591,37.64,0.33,337,39856,70,NULL,NULL,'2MASX J12275884+0914066',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000185,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,186.99525,9.23531,0,NULL,58245346953,910083546,14220055,16.8),(94592,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94592,37.66,0.33,340,39857,70,NULL,NULL,'2MASX J12275885+0117034',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000175,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,186.995333,1.28436,0,NULL,58010424837,906412888,14162701,17.1),(94593,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94593,37.25,0.46,281,39858,70,NULL,NULL,'2MASX J12280030+2627550',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,187.0012917,26.46542,0.074,NULL,58608316414,915754943,14308670,17.7),(94594,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94594,32.3,0.4,28.8,39859,NULL,NULL,NULL,'ESO 380- G 034',NULL,'2009AJ....138..323T',2009,1,1.7,NULL,'G',0.000025,NULL,'15.59',0.3,'SB(s)m: sp',NULL,NULL,NULL,NULL,1,187.0015,-37.33097,0.197,NULL,43270722313,676105036,10564141,15.59),(94595,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94595,35.91,0.8,152,39860,70,NULL,NULL,'2MASX J12280165-1407170',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,187.007,-14.12133,0.117,NULL,43046556144,672602439,10509413,15.6),(94596,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94596,37.91,0.08,383,39861,70,NULL,NULL,'2MASX J12280215+0850056',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00014,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,187.009167,8.83475,0,NULL,58245296855,910082763,14220043,17.3),(94597,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94597,37.85,0.15,372,39862,70,NULL,NULL,'2MASX J12280235+1155534',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,187.0099583,11.93158,0.043,NULL,58162146961,908783546,14199742,18.1),(94598,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94598,38.2,0.46,436,39863,70,NULL,NULL,'CGPG 1225.8+6349',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000173,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,187.010041667,63.53539,0.025,NULL,57374013747,896468964,14007327,17.6),(94599,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94599,37.91,0.08,383,39864,70,NULL,NULL,'2MASX J12280249+0849246',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,187.0104583,8.82358,0,NULL,58245289279,910082644,14220041,17.8),(94600,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94600,29.82,NULL,9.2,39865,NULL,NULL,NULL,'UGC 07584',NULL,'2013AJ....145..101K',2013,1,0.9,NULL,'G',0.000002,NULL,'16.0',0.5,'Sdm:',NULL,NULL,NULL,NULL,1,187.0117917,22.58772,0.074,NULL,58909870116,920466720,14382292,16),(94601,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94601,29.99,0.2,9.95,39865,74.4,NULL,NULL,'UGC 07584',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94602,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94602,37.35,0.46,295,39866,70,NULL,NULL,'VPC 0568',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,187.0135417,14.92908,0.073,NULL,58157349406,908708584,14198571,17.1),(94603,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94603,35.78,0.46,143,39867,70,NULL,NULL,'CGCG 269-062',NULL,'2015arXiv151105856S',2015,1,0.93,NULL,'G',0.000093,NULL,'14.9g',0.5,'E0',NULL,NULL,NULL,NULL,1,187.0152083,54.19597,0,NULL,57222849929,894107030,13970422,14.9),(94604,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94604,30.84,0.11,14.7,39868,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4442',NULL,'2010ApJ...717..603V',2010,1,4.6,NULL,'G',0.000017,NULL,'11.38',1.8,'SB(s)0^0^','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.016166667,9.80372,0,NULL,58245760966,910090015,14220156,11.38),(94605,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94605,30.89,0.13,15,39868,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4442',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94606,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94606,30.95,0.12,15.5,39868,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4442',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94607,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94607,31.03,0.11,16.1,39868,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4442',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94608,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94608,30.92,0.06,15.3,39868,NULL,NULL,NULL,'NGC 4442',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94609,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94609,30.93,0.07,15.3,39868,NULL,NULL,'HST ACS VCS','NGC 4442',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94610,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94610,30.93,0.12,15.4,39868,74.4,NULL,NULL,'NGC 4442',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94611,'GC radius','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94611,30.7,0.05,13.8,39868,NULL,NULL,NULL,'NGC 4442',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94612,'Faber-Jackson','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94612,30.28,0.63,11.4,39868,95,NULL,'Michard 1979b, c','NGC 4442',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94613,'Faber-Jackson','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94613,30.57,0.27,13,39868,95,NULL,'Weighted Mean','NGC 4442',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94614,'Faber-Jackson','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94614,30.59,0.46,13.1,39868,95,NULL,'Michard 1979a','NGC 4442',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94615,'Faber-Jackson','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94615,30.83,0.39,14.7,39868,95,NULL,'de Vaucouleurs','NGC 4442',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94616,'Faber-Jackson','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94616,31.44,0.81,19.4,39868,55,NULL,'Visvanathan & Sandage 1979','NGC 4442',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94617,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94617,30.93,0.12,15.4,39868,74.4,NULL,NULL,'NGC 4442',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94618,'Tertiary','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94618,30.49,0.25,12.5,39868,95,NULL,NULL,'NGC 4442',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94619,'Tully est','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94619,31.13,0.8,16.8,39868,75,NULL,'B','NGC 4442',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94620,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94620,30.66,0.45,13.6,39868,NULL,NULL,'K','NGC 4442',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94621,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94621,30.87,0.4,15,39868,NULL,NULL,'mean','NGC 4442',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94622,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94622,36.32,0.68,183,39869,70,NULL,NULL,'2MASX J12280470-1407590',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.41',NULL,NULL,NULL,NULL,NULL,NULL,1,187.0197917,-14.13317,0.117,NULL,43046559066,672602485,10509413,16.41),(94623,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94623,37.91,0.08,383,39870,70,NULL,NULL,'2MASX J12280513+0839106',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000172,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,187.021375,8.65292,0,NULL,58243477684,910054338,14219599,17.9),(94624,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94624,37.85,0.15,372,39871,70,NULL,NULL,'VCC 1068',NULL,'2015arXiv151105856S',2015,1,0.63,'SDSS has z = 0.089191 +- 0.000201.','G',0.000167,NULL,'16.0g',0.39,'E?;BrClG','Group member',NULL,NULL,NULL,1,187.023583,12.08008,0.071,NULL,58162088443,908782631,14199728,16),(94625,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94625,37.01,0.27,253,39872,70,NULL,NULL,'2MASX J12280604+2621541',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.15',0.19,NULL,NULL,NULL,NULL,NULL,1,187.025167,26.36514,0.072,NULL,58608305951,915754780,14308668,17.15),(94626,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94626,36.47,0.46,197,39873,70,NULL,NULL,'2MASX J12280654+0814076',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000192,NULL,'16.0g',0.35,NULL,NULL,NULL,NULL,NULL,1,187.02725,8.2355,0,NULL,58248126767,910126980,14220734,16),(94627,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94627,37.85,0.15,372,39874,70,NULL,NULL,'2MASX J12280681+1157186',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,187.028333,11.95531,0.043,NULL,58162145742,908783527,14199742,17.5),(94628,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94628,37.04,0.46,255,39875,70,NULL,NULL,'2MASX J12280728+3044198',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00017,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,187.030583,30.73878,0.016,NULL,58759598065,918118719,14345604,16.7),(94629,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94629,37.91,0.08,383,39876,70,NULL,NULL,'SDSS J122808.08+083651.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,187.0337083,8.61442,0,NULL,58243471062,910054235,14219597,17.9),(94630,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94630,31.53,0.45,20.2,39877,NULL,NULL,'K','IC 0794',NULL,'2007A&A...465...71T',2007,1,1.17,NULL,'G',0.000063,NULL,'14.5g',0.9,'dE3','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,187.035875,12.09331,0.071,NULL,58161972875,908780826,14199700,14.5),(94631,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94631,32.16,0.4,27,39877,NULL,NULL,'mean','IC 0794',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94632,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94632,31.23,0.17,17.6,39878,NULL,NULL,'I','[WCD2007] IGC-4',NULL,'2007ApJ...656..746D',2007,1,NULL,NULL,'*Cl',NULL,NULL,NULL,NULL,'Intracluster GC?',NULL,NULL,NULL,NULL,1,187.0362917,12.57381,0.092,NULL,58161577534,908774648,14199603,NULL),(94633,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94633,36.38,0.46,189,39879,70,NULL,NULL,'2MASX J12280990+2123180',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.48',0.22,NULL,NULL,NULL,NULL,NULL,1,187.041333,21.38836,NULL,NULL,58912785104,920512267,14383004,17.48),(94634,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94634,37.68,0.46,344,39880,70,NULL,NULL,'SDSS J122811.54+013704.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000165,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,187.048083,1.61786,0.009,NULL,58011705732,906432902,14163014,18.4),(94635,'Brightest Stars','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94635,27.33,NULL,2.93,39881,NULL,NULL,NULL,'NGC 4449',NULL,'1998A&AS..131....1K',1998,1,6.2,'One of two 6cm sources associated with [WB92] 1225+4417','G',0.000013,NULL,'9.99',4.4,'IBm;HII        Sbrst','Possible field galaxy',NULL,NULL,NULL,1,187.04625,44.09364,0,0,59069022087,922953470,14421147,9.99),(94636,'Carbon Stars','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94636,28.07,0.18,4.11,39881,NULL,NULL,NULL,'NGC 4449',NULL,'2008AJ....135.1900A',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94637,'CMD','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94637,27.95,0.04,3.89,39881,NULL,NULL,'HSB','NGC 4449',NULL,'2010ApJ...721..297M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94638,'CMD','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94638,28.05,0.04,4.07,39881,NULL,NULL,'LSB','NGC 4449',NULL,'2010ApJ...721..297M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94639,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94639,27.3,0.1,2.9,39881,NULL,NULL,'TOM(V) = -7.30 mag','NGC 4449',NULL,'1986AJ.....91..507B',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94640,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94640,27.91,0.15,3.82,39881,NULL,NULL,NULL,'NGC 4449',NULL,'2008AJ....135.1900A',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94641,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94641,28.11,0.09,4.19,39881,NULL,NULL,NULL,'NGC 4449',NULL,'2013AstBu..68..125M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94642,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94642,28.12,0.24,4.2,39881,NULL,NULL,NULL,'NGC 4449',NULL,'2014A&A...566A..71L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94643,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94643,28.12,0.27,4.21,39881,NULL,NULL,NULL,'NGC 4449',NULL,'2003A&A...398..467K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94644,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94644,28.15,0.1,4.27,39881,74.4,NULL,NULL,'NGC 4449',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94645,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94645,28.17,0.22,4.31,39881,NULL,NULL,'I','NGC 4449',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94646,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94646,28.17,0.12,4.31,39881,NULL,NULL,NULL,'NGC 4449',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94647,'Tully est','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94647,27.42,0.8,3,39881,75,NULL,'B','NGC 4449',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94648,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94648,27.44,NULL,3.08,39881,NULL,NULL,'LEDA [April 2006]','NGC 4449',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94649,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94649,30.71,0.17,13.9,39882,NULL,NULL,'TOM(g) = -7.2 mag','IC 3383',NULL,'2010ApJ...717..603V',2010,1,0.93,NULL,'G',0.000133,NULL,'15.3g',0.66,'dE4,N','Group member',NULL,NULL,NULL,1,187.051333,10.29767,0.009,NULL,58187890328,909185786,14206027,15.3),(94650,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94650,30.71,0.24,13.9,39882,NULL,NULL,'TOM(g) = -7.2 mag','IC 3383',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94651,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94651,30.92,0.2,15.3,39882,NULL,NULL,'TOM(u) = -8.4 mag','IC 3383',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94652,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94652,31.05,0.16,16.2,39882,NULL,NULL,'TOM(z) = -8.53 mag','IC 3383',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94653,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94653,31.03,0.14,16.1,39882,74.4,NULL,NULL,'IC 3383',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94654,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94654,31.04,0.09,16.1,39882,NULL,NULL,NULL,'IC 3383',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94655,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94655,31.05,0.1,16.2,39882,NULL,NULL,'HST ACS VCS','IC 3383',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94656,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94656,37.85,0.15,372,39883,70,NULL,NULL,'VPC 0580',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000193,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,187.052541667,12.14244,0.071,NULL,58162250799,908785168,14199768,16.6),(94657,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94657,38.07,0.46,410,39884,70,NULL,NULL,'2MASX J12281339+0500015',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,187.05575,5.00039,0,NULL,58226118204,909783096,14215360,17.3),(94658,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94658,34.49,0.49,79,39885,75,NULL,'IR','IC 3382',NULL,'2011yCatp016004901K',2011,1,1.26,NULL,'G',0.000033,NULL,'16.0g',0.21,'Scd',NULL,NULL,NULL,NULL,1,187.056417,13.57069,0.076,NULL,58163236551,908800571,14200008,16),(94659,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94659,35.14,NULL,107,39885,NULL,NULL,'Dipole + Quadrupole','IC 3382',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94660,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94660,35.14,NULL,107,39885,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 3382',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94661,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94661,35.15,NULL,107,39885,NULL,NULL,'Dipole','IC 3382',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94662,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94662,30.93,0.13,15.3,39886,NULL,NULL,'TOM(g) = -7.2 mag','IC 3381',NULL,'2010ApJ...717..603V',2010,1,1.35,NULL,'G',0.00004,NULL,'14.2g',0.91,'dE3,N','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,187.062,11.78983,0.038,NULL,58162108525,908782945,14199733,14.2),(94663,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94663,30.94,0.15,15.4,39886,NULL,NULL,'TOM(g) = -7.2 mag','IC 3381',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94664,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94664,31.12,0.14,16.8,39886,NULL,NULL,'TOM(u) = -8.4 mag','IC 3381',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94665,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94665,31.24,0.13,17.7,39886,NULL,NULL,'TOM(z) = -8.53 mag','IC 3381',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94666,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94666,31.09,0.14,16.5,39886,74.4,NULL,NULL,'IC 3381',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94667,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94667,31.11,0.06,16.7,39886,NULL,NULL,NULL,'IC 3381',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94668,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94668,31.11,0.08,16.7,39886,NULL,NULL,'HST ACS VCS','IC 3381',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94669,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94669,31.27,0.14,18,39886,NULL,NULL,'R','IC 3381',NULL,'2004AJ....127..771J',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94670,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94670,31.39,0.18,19,39886,NULL,NULL,'R','IC 3381',NULL,'2004AJ....127..771J',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94671,'GC radius','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94671,30.48,0.1,12.5,39886,NULL,NULL,NULL,'IC 3381',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94672,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94672,31.2,0.4,17.4,39886,NULL,NULL,'mean','IC 3381',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94673,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94673,31.9,0.45,23.9,39886,NULL,NULL,'K','IC 3381',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94674,'Ring Diameter','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94674,30.7,0.76,14,39887,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4448',NULL,'1981ApJS...45..541P',1981,1,3.9,NULL,'G',0.00002,NULL,'12.00',1.4,'SB(r)ab        HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.0642917,28.62031,0.104,NULL,58607251157,915738299,14308410,12),(94675,'Ring Diameter','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94675,31,0.6,16,39887,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4448',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94676,'Sosies','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94676,33.38,0.6,47.4,39887,NULL,NULL,NULL,'NGC 4448',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94677,'Tully est','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94677,29.93,0.8,9.7,39887,75,NULL,'B','NGC 4448',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94678,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94678,31.76,0.3,22.5,39887,55,NULL,'B','NGC 4448',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94679,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94679,31.85,0.43,23.5,39887,75,NULL,'3.6 micron, color corrected','NGC 4448',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94680,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94680,31.86,0.2,23.6,39887,74.4,NULL,NULL,'NGC 4448',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94681,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94681,31.94,0.43,24.5,39887,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4448',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94682,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94682,37.85,0.15,372,39888,70,NULL,NULL,'SDSS J122815.44+120420.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000138,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,187.064333,12.07231,0.071,NULL,58161986380,908781037,14199703,18.4),(94683,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94683,30.02,0.4,10.1,39889,NULL,NULL,'mean','NGC 4445',NULL,'2007A&A...465...71T',2007,1,3.05,NULL,'G',0.000017,NULL,'13.6g',0.57,'Sab: sp;LINER  HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.066375,9.43619,0,NULL,58246226510,910097289,14220270,13.6),(94684,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94684,31.26,NULL,17.9,39889,NULL,NULL,NULL,'NGC 4445',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94685,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94685,31.32,NULL,18.4,39889,NULL,NULL,'B','NGC 4445',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94686,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94686,31.34,0.43,18.5,39889,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4445',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94687,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94687,31.46,0.46,19.6,39889,NULL,NULL,'J','NGC 4445',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94688,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94688,31.49,0.47,19.9,39889,NULL,NULL,'H','NGC 4445',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94689,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94689,31.5,0.45,20,39889,NULL,NULL,'K','NGC 4445',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94690,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94690,38.26,0.46,450,39890,70,NULL,NULL,'2MASX J12281612+0027075',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000082,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,187.067333,0.45194,0,NULL,58008954337,906389911,14162342,17.9),(94691,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94691,38.09,0.46,415,39891,70,NULL,NULL,'2MASX J12281641+6220235',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,187.068166667,62.33986,0,NULL,57375718552,896495602,14007743,17.3),(94692,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94692,37.58,0.46,328,39892,70,NULL,NULL,'2MASX J12281664+2118310',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.07',0.16,NULL,NULL,NULL,NULL,NULL,1,187.069375,21.3085,NULL,NULL,58912800610,920512509,14383007,18.07),(94693,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94693,36.25,0.46,178,39893,70,NULL,NULL,'2MASX J12281805+1528109',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00016,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,187.07525,15.46969,0.036,NULL,58157519549,908711242,14198613,16.4),(94694,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94694,32.15,0.43,27,39894,75,NULL,'3.6 micron, color + selection bias corrected','UGC 07590',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.000002,NULL,'14.12',0.4,'Sbc            HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,187.0782083,8.72944,0,NULL,58245259858,910082185,14220034,14.12),(94695,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94695,32.24,0.43,28.1,39894,75,NULL,'3.6 micron, color corrected','UGC 07590',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94696,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94696,32.32,0.36,29.1,39894,NULL,NULL,NULL,'UGC 07590',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94697,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94697,32.33,0.2,29.2,39894,74.4,NULL,NULL,'UGC 07590',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94698,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94698,32.42,0.51,30.5,39894,NULL,NULL,'Malmquist cor.','UGC 07590',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94699,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94699,32.64,0.46,33.7,39894,NULL,NULL,NULL,'UGC 07590',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94700,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94700,37.41,0.46,303,39895,70,NULL,NULL,'SDSS J122819.46+622805.6',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,187.081167,62.46822,0,NULL,57375499773,896492183,14007690,17.6),(94701,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94701,37.16,0.79,270,39896,70,NULL,NULL,'2MASX J12282055-3132369',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,187.085667,-31.54356,0.357,NULL,43446718182,678854971,10607108,15.8),(94702,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94702,37.74,0.33,353,39897,70,NULL,NULL,'2MASX J12282131+0751250',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000188,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,187.088917,7.85686,0,NULL,58248148102,910127314,14220739,16.4),(94703,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94703,37.84,0.23,369,39898,70,NULL,NULL,'2MASXi J1228215+681845',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000073,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,187.089667,68.31272,0,NULL,57851036560,903922446,14123788,17.9),(94704,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94704,37.52,0.46,319,39899,70,NULL,NULL,'2MASX J12282278+2445320',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,187.095083,24.75906,0.052,NULL,58614760333,915855630,14310244,17.5),(94705,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94705,38.13,0.46,422,39900,70,NULL,NULL,'2MASX J12282335+6532295',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000173,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,187.0975,65.54161,0.005,NULL,57325138168,895705283,13995395,17.5),(94706,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94706,37.14,0.46,268,39901,70,NULL,NULL,'2MASX J12282453+4330351',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000181,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,187.10225,43.50975,0,NULL,59061415556,922834618,14419290,16.9),(94707,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94707,37.45,0.46,309,39902,70,NULL,NULL,'2MASX J12282491-0222370',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000084,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,187.10375,-2.37694,0.069,NULL,42999643178,671869424,10497959,17.1),(94708,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94708,37.09,0.46,262,39903,70,NULL,NULL,'SDSS J122824.94+081614.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000136,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,187.1039583,8.27058,0,NULL,58248100658,910126572,14220727,17.9),(94709,'IRAS','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94709,33.3,0.8,45.6,39904,75,NULL,'MAT, I','ESO 322- G 017',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'15.28',0.9,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,187.10425,-38.48731,0.341,NULL,43278911970,676232999,10566140,15.28),(94710,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94710,32.39,0.32,30.1,39904,85,NULL,'I, inv','ESO 322- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94711,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94711,32.42,0.32,30.5,39904,85,NULL,'I, raw','ESO 322- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94712,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94712,32.52,0.2,31.9,39904,74.4,NULL,NULL,'ESO 322- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94713,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94713,32.59,0.43,32.9,39904,75,NULL,'3.6 micron, color + selection bias corrected','ESO 322- G 017',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94714,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94714,32.59,0.43,33,39904,75,NULL,'3.6 micron, color corrected','ESO 322- G 017',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94715,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94715,32.85,0.43,37.1,39904,75,NULL,'MAT, I, inv','ESO 322- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94716,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94716,32.9,0.43,38,39904,75,NULL,'MAT, I, raw','ESO 322- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94717,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94717,33.17,0.43,43,39904,75,NULL,'MAT, I, cor','ESO 322- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94718,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94718,33.39,0.09,47.7,39904,NULL,NULL,NULL,'ESO 322- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94719,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94719,37.87,0.1,375,39905,70,NULL,NULL,'VPC 0598',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,187.113125,11.48267,0.034,NULL,58158538389,908727162,14198861,17.8),(94720,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94720,32.14,0.4,26.8,39906,NULL,NULL,'mean','IC 3391',NULL,'2007A&A...465...71T',2007,1,1.27,NULL,'G',0.000023,NULL,'13.9g',0.99,'Scd:','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.11375,18.41503,0.1,NULL,58917308042,920582938,14384108,13.9),(94721,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94721,32.48,0.47,31.4,39906,NULL,NULL,'H','IC 3391',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94722,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94722,32.56,0.46,32.5,39906,NULL,NULL,'J','IC 3391',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94723,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94723,38.34,0.46,466,39907,70,NULL,NULL,'2MASX J12282795+1537488',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,187.116333,15.63008,0.036,NULL,58157662530,908713477,14198648,17.7),(94724,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94724,31.15,0.19,17,39908,NULL,NULL,'R','IC 3388',NULL,'2004AJ....127..771J',2004,1,0.88,NULL,'G',0.000103,NULL,'15.4g',0.57,'dE,N','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,187.116917,12.82367,0.081,NULL,58161391013,908771734,14199558,15.4),(94725,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94725,30.84,0.1,14.7,39908,NULL,NULL,'HST KP Calibrated','IC 3388',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94726,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94726,30.98,0.2,15.7,39908,NULL,NULL,'M(I) = -4.2 mag','IC 3388',NULL,'1998Natur.395...45H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94727,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94727,30.98,0.14,15.7,39908,74.4,NULL,NULL,'IC 3388',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94728,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94728,36.96,0.46,246,39909,70,NULL,NULL,'2MASX J12282832+6759478',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000075,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,187.117833333,67.99658,0.017,NULL,57849386371,903896662,14123385,17.3),(94729,'Brightest Stars','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94729,29.19,NULL,6.9,39910,NULL,NULL,NULL,'UGC 07599',NULL,'1998A&AS..128..459M',1998,1,2,'ultiple SDSS entries describe this object.','G',0.000017,NULL,'14.90',1,'Sm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,187.119,37.23364,0,NULL,58570394176,915162409,14299412,14.9),(94730,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94730,28.37,0.1,4.72,39910,74.4,NULL,NULL,'UGC 07599',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94731,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94731,27.72,0.4,3.5,39910,75,NULL,'B','UGC 07599',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94732,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94732,37.85,0.15,372,39911,70,NULL,NULL,'VPC 0601',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,187.122875,12.06197,0.071,NULL,58161984369,908781005,14199703,17.8),(94733,'IRAS','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94733,31.44,0.8,19.4,39912,75,NULL,'A82, H','NGC 4450',NULL,'1997ApJS..109..333W',1997,1,5.2,NULL,'G',0.000013,NULL,'10.90',3.9,'SA(s)ab;LINER  Sy3','in a radial-velocity based grouping',NULL,NULL,'LINER b',1,187.1234583,17.08494,0.025,NULL,58880272429,920004256,14375066,10.9),(94734,'Sosies','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94734,31.29,0.23,18.1,39912,NULL,NULL,NULL,'NGC 4450',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94735,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94735,29.62,0.92,8.4,39912,NULL,NULL,'CO','NGC 4450',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94736,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94736,30.22,0.42,11.1,39912,65,NULL,NULL,'NGC 4450',NULL,'1980ApJ...238..458M',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94737,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94737,30.48,NULL,12.5,39912,NULL,NULL,'B','NGC 4450',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94738,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94738,30.5,0.2,12.6,39912,NULL,NULL,'stellar kinematics','NGC 4450',NULL,'2008ApJ...683...78C',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94739,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94739,30.51,NULL,12.6,39912,NULL,NULL,NULL,'NGC 4450',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94740,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94740,30.9,0.43,15.2,39912,75,NULL,'3.6 micron, color corrected','NGC 4450',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94741,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94741,30.92,0.35,15.3,39912,NULL,NULL,NULL,'NGC 4450',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94742,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94742,30.93,0.2,15.4,39912,74.4,NULL,NULL,'NGC 4450',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94743,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94743,30.96,0.43,15.6,39912,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4450',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94744,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94744,31.07,0.7,16.4,39912,NULL,NULL,'HI','NGC 4450',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94745,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94745,31.13,0.4,16.8,39912,75,NULL,'B','NGC 4450',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94746,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94746,31.19,0.47,17.3,39912,75,NULL,'A82, H, raw','NGC 4450',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94747,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94747,31.36,0.47,18.7,39912,75,NULL,'A82, H, inv','NGC 4450',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94748,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94748,31.42,0.47,19.2,39912,75,NULL,'A82, H, cor','NGC 4450',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94749,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94749,31.6,NULL,20.9,39912,NULL,NULL,'LEDA [April 2006]','NGC 4450',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94750,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94750,31.88,0.3,23.8,39912,55,NULL,'B','NGC 4450',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94751,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94751,37.96,0.46,391,39913,70,NULL,NULL,'SDSS J122830.21+084625.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,187.125875,8.77381,0,NULL,58245313312,910083020,14220047,18.1),(94752,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94752,35.99,0.46,158,39914,70,NULL,NULL,'VII Zw 459',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,187.126667,61.97622,0,NULL,57375837608,896497462,14007772,16.8),(94753,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94753,37.43,0.46,307,39915,70,NULL,NULL,'SDSS J122830.91+423408.3',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000135,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,187.1287917,42.569,0,NULL,59064170350,922877661,14419963,18.1),(94754,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94754,35.32,0.46,116,39916,70,NULL,NULL,'IC 0795',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000143,NULL,'15.3',0.3,'S0',NULL,NULL,NULL,NULL,1,187.130583,23.30494,0.05,NULL,58892382977,920193484,14378023,15.3),(94755,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94755,38.55,0.46,512,39917,70,NULL,NULL,'SDSS J122831.60+064815.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000195,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,187.1317083,6.80439,0,NULL,58236898671,909951541,14217992,18.4),(94756,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94756,37.64,0.33,337,39918,70,NULL,NULL,'2MASX J12283164+0917321',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000183,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,187.131917,9.29236,0,NULL,58246178720,910096542,14220258,16.7),(94757,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94757,36.06,0.46,163,39919,70,NULL,NULL,'2MASXi J1228316+543548',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'16.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,187.1322083,54.59686,0,NULL,57222459995,894100937,13970327,16.5),(94758,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94758,34.53,0.45,80.5,39920,NULL,NULL,NULL,'ESO 574- G 001',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'15.80',0.7,'SA(r)c',NULL,NULL,NULL,NULL,1,187.135125,-22.23758,0.189,NULL,43948923255,686701925,10729717,15.8),(94759,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94759,34.57,0.2,82,39920,74.4,NULL,NULL,'ESO 574- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94760,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94760,34.58,0.44,82.4,39920,NULL,NULL,'Malmquist cor.','ESO 574- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94761,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94761,38.06,0.46,409,39921,70,NULL,NULL,'SDSS J122832.47+382740.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,187.135333333,38.46128,0,NULL,58576586025,915259156,14300924,18.4),(94762,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94762,37.26,0.46,283,39922,70,NULL,NULL,'CGPG 1226.3+6413 NED02',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,187.1354583,63.93742,0.029,NULL,57373894773,896467105,14007298,17.7),(94763,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94763,37.85,0.15,372,39923,70,NULL,NULL,'VPC 0603',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00016,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,187.138875,11.96411,0.071,NULL,58162139165,908783424,14199741,16.5),(94764,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94764,28.31,NULL,4.59,39924,NULL,NULL,NULL,'UGC 07596',NULL,'2013AJ....145..101K',2013,1,1.34,NULL,'G',0.000033,NULL,'15.2g',0.57,'Im:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,187.141375,8.63961,0,NULL,58243417129,910053392,14219584,15.2),(94765,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94765,36.69,0.46,218,39925,70,NULL,NULL,'SDSS J122834.48+014815.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000135,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,187.1437083,1.80433,0.017,NULL,58015242806,906488168,14163877,17.7),(94766,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94766,36.14,0.46,169,39926,70,NULL,NULL,'2MASX J12283494+1835250',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.05',0.15,NULL,NULL,NULL,NULL,NULL,1,187.145625,18.59017,0.098,NULL,58916412941,920568952,14383889,18.05),(94767,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94767,35.48,0.54,125,39927,NULL,NULL,'Malmquist cor.','ESO 574- G 002',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.3R',0.7,'SAB(rs)b',NULL,NULL,NULL,NULL,1,187.146333,-22.49594,0.233,NULL,43948899117,686701548,10729711,14.3),(94768,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94768,35.67,0.49,136,39927,NULL,NULL,NULL,'ESO 574- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94769,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94769,35.71,0.2,139,39927,74.4,NULL,NULL,'ESO 574- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94770,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94770,38.01,0.21,400,39928,70,NULL,NULL,'2MASX J12283577+5117024',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,187.14925,51.28397,0,NULL,57243447211,894428862,13975450,16.9),(94771,'Tully est','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94771,32.94,0.8,38.8,39929,75,NULL,NULL,'NGC 4444',NULL,'1988NBGC.C....0000T',1988,1,2.5,NULL,'G',0.000017,NULL,'12.99',2.3,'SAB(rs)bc',NULL,NULL,NULL,NULL,1,187.1517083,-43.26175,0.345,NULL,46719377799,729990278,11406098,12.99),(94772,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94772,37.84,0.23,369,39930,70,NULL,NULL,'SDSS J122836.96+682333.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000073,NULL,'17.9g',0.19,'NLAGN',NULL,NULL,NULL,NULL,1,187.1540417,68.39272,0,NULL,57851008308,903922004,14123781,17.9),(94773,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94773,37.47,0.46,313,39931,70,NULL,NULL,'2MASX J12283862+3045341',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000178,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,187.160833,30.75953,0,NULL,58777357080,918396204,14349940,17),(94774,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94774,36.8,0.46,229,39932,70,NULL,NULL,'2MASX J12283879+4005500',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000163,NULL,'16.1g',0.33,NULL,NULL,NULL,NULL,NULL,1,187.161625,40.09717,0,NULL,58574427200,915225425,14300397,16.1),(94775,'Brightest Stars','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94775,28.24,NULL,4.4,39933,NULL,NULL,NULL,'UGC 07605',NULL,'1998A&AS..128..459M',1998,1,1.17,NULL,'G',0.000001,NULL,'15.1g',0.64,'Im','Isolated galaxy',NULL,NULL,NULL,1,187.161417,35.71747,0.022,NULL,58569690324,915151411,14299240,15.1),(94776,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94776,28.17,0.1,4.31,39933,NULL,NULL,NULL,'UGC 07605',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94777,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94777,28.23,0.28,4.43,39933,NULL,NULL,NULL,'UGC 07605',NULL,'2003A&A...398..467K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94778,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94778,28.32,0.1,4.61,39933,NULL,NULL,NULL,'UGC 07605',NULL,'2013AstBu..68..125M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94779,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94779,28.32,NULL,4.62,39933,NULL,NULL,NULL,'UGC 07605',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94780,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94780,28.38,0.15,4.74,39933,NULL,NULL,'I','UGC 07605',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94781,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94781,28.38,0.1,4.74,39933,74.4,NULL,NULL,'UGC 07605',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94782,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94782,27.83,0.4,3.7,39933,75,NULL,'B','UGC 07605',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94783,'FP','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,'R',94783,38.01,0.21,400,39934,70,NULL,NULL,'2MASX J12284046+5115564',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,187.1685,51.26561,0,NULL,57243445201,894428831,13975450,18.1),(94784,'Tully est','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94784,31.13,0.8,16.8,39935,75,NULL,'B','NGC 4451',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.000023,NULL,'13.29',1,'Sbc:           HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.1689583,9.25881,0,NULL,58245331110,910083298,14220051,13.29),(94785,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94785,31.69,0.4,21.8,39935,NULL,NULL,'mean','NGC 4451',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94786,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94786,31.81,0.43,23,39935,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4451',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94787,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94787,31.92,0.43,24.2,39935,75,NULL,'3.6 micron, color corrected','NGC 4451',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94788,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94788,32.07,0.2,25.9,39935,74.4,NULL,NULL,'NGC 4451',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94789,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94789,32.16,NULL,27,39935,NULL,NULL,NULL,'NGC 4451',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94790,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94790,32.2,0.52,27.6,39935,NULL,NULL,'Malmquist cor.','NGC 4451',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94791,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94791,32.21,0.36,27.7,39935,NULL,NULL,NULL,'NGC 4451',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94792,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:10','1',NULL,NULL,94792,32.34,0.49,29.3,39935,NULL,NULL,NULL,'NGC 4451',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94793,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94793,32.34,0.47,29.4,39935,NULL,NULL,'H','NGC 4451',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94794,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94794,32.38,0.45,30,39935,NULL,NULL,'K','NGC 4451',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94795,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94795,32.4,0.46,30.2,39935,NULL,NULL,'J','NGC 4451',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94796,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94796,35.86,0.46,149,39936,70,NULL,NULL,'2MASX J12284071+3136001',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00012,NULL,'15.9g',0.36,'AGN',NULL,NULL,NULL,NULL,1,187.169625,31.60017,0.035,NULL,58776905518,918389148,14349830,15.9),(94797,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94797,37.85,0.15,372,39937,70,NULL,NULL,'2MASX J12284131+1151141',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,187.17225,11.85392,0.038,NULL,58162131383,908783302,14199739,17.9),(94798,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94798,30.83,0.4,14.7,39938,NULL,NULL,'mean','IC 3393',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000033,NULL,'14.9g',0.48,'dE7,N','Group member',NULL,NULL,NULL,1,187.1737917,12.91592,0.081,NULL,58160895847,908763997,14199437,14.9),(94799,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94799,31.78,0.45,22.7,39938,NULL,NULL,'K','IC 3393',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94800,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94800,37.22,0.46,277,39939,70,NULL,NULL,'2MASX J12284282+2025358',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'18.94',NULL,NULL,NULL,NULL,NULL,NULL,1,187.178458333,20.42661,NULL,NULL,58910496277,920476504,14382445,18.94),(94801,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94801,30.87,0.13,14.9,39940,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4452',NULL,'2010ApJ...717..603V',2010,1,2.53,'v=165 km/s (2003AJ....125.2891C)','G',0.000017,NULL,'12.6g',0.82,'S0(9)','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,187.180458333,11.75503,0.038,NULL,58161910064,908779844,14199685,12.6),(94802,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94802,30.9,0.14,15.1,39940,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4452',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94803,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94803,31.05,0.15,16.2,39940,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4452',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94804,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94804,31.18,0.14,17.2,39940,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4452',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94805,'Tully est','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94805,31.13,0.8,16.8,39940,75,NULL,'B','NGC 4452',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94806,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94806,29.98,0.43,9.9,39941,75,NULL,'3.6 micron, color + selection bias corrected','IC 3392',NULL,'2014MNRAS.444..527S',2014,1,1.59,NULL,'G',0.000033,NULL,'13.0g',0.95,'SAb:           HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.18025,14.9995,0.073,NULL,58158128238,908720753,14198761,13),(94807,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94807,30.21,0.43,11,39941,75,NULL,'3.6 micron, color corrected','IC 3392',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94808,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94808,30.36,NULL,11.8,39941,NULL,NULL,NULL,'IC 3392',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94809,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94809,30.38,0.2,11.9,39941,74.4,NULL,NULL,'IC 3392',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94810,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94810,30.56,0.52,12.9,39941,NULL,NULL,NULL,'IC 3392',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94811,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94811,30.79,0.47,14.4,39941,NULL,NULL,'Malmquist cor.','IC 3392',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94812,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94812,30.82,0.47,14.6,39941,NULL,NULL,'H','IC 3392',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94813,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94813,30.89,0.45,15.1,39941,NULL,NULL,'K','IC 3392',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94814,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94814,30.9,0.46,15.1,39941,NULL,NULL,'J','IC 3392',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94815,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94815,31.95,0.4,24.6,39941,NULL,NULL,'mean','IC 3392',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94816,'IRAS','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94816,30.33,0.8,11.6,39942,75,NULL,'A82, H','NGC 4455',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.000013,NULL,'12.93',0.8,'SB(s)d? sp','in a radial-velocity based grouping',NULL,NULL,'Emission-Line Galaxy',1,187.1837917,22.82044,0.052,NULL,58892345062,920192891,14378013,12.93),(94817,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94817,28.95,0.4,6.2,39942,75,NULL,'B','NGC 4455',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94818,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94818,29.18,0.2,6.85,39942,74.4,NULL,NULL,'NGC 4455',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94819,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94819,29.27,0.72,7.16,39942,NULL,NULL,NULL,'NGC 4455',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94820,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94820,29.49,0.65,7.9,39942,NULL,NULL,'Malmquist cor.','NGC 4455',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94821,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94821,29.62,NULL,8.39,39942,NULL,NULL,NULL,'NGC 4455',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94822,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94822,29.84,0.47,9.31,39942,75,NULL,'A82, H, inv','NGC 4455',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94823,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94823,30.08,0.47,10.4,39942,75,NULL,'A82, H, raw','NGC 4455',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94824,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94824,30.11,0.36,10.5,39942,NULL,NULL,NULL,'NGC 4455',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94825,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94825,30.11,0.4,10.5,39942,73,NULL,'opt','NGC 4455',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94826,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94826,30.48,0.47,12.5,39942,75,NULL,'A82, H, cor','NGC 4455',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94827,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94827,29.4,0.4,7.6,39943,75,NULL,'B','UGC 07608',NULL,'1988NBGC.C....0000T',1988,1,3.4,NULL,'G',0.00002,NULL,'13.67',3.3,'Im','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.184167,43.22414,0,NULL,59063277911,922863717,14419745,13.67),(94828,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94828,29.75,NULL,8.91,39943,NULL,NULL,NULL,'UGC 07608',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94829,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94829,37.28,0.46,286,39944,70,NULL,NULL,'2MASX J12284517+1651078',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.91',0.13,NULL,NULL,NULL,NULL,NULL,1,187.18825,16.85211,0.025,NULL,58880246016,920003844,14375060,17.91),(94830,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94830,29.82,0.14,9.2,39945,74.4,NULL,NULL,'NGC 4460',NULL,'2013AJ....146...86T',2013,1,4,NULL,'G',0.000063,NULL,'12.26',1.2,'SB(s)0+? sp    HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.189833333,44.86422,0,NULL,59069393102,922959267,14421238,12.26),(94831,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94831,29.91,0.19,9.59,39945,NULL,NULL,'I','NGC 4460',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94832,'Tully est','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94832,29.53,0.8,8.1,39945,75,NULL,'B','NGC 4460',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94833,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94833,28.89,0.4,6,39945,73,NULL,'IR','NGC 4460',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94834,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94834,28.9,0.39,6.02,39945,75,NULL,NULL,'NGC 4460',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94835,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94835,29.29,0.49,7.23,39945,75,NULL,'IR','NGC 4460',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94836,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94836,38.01,0.21,400,39946,70,NULL,NULL,'2MASX J12284579+5117214',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000202,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,187.190667,51.28917,0,NULL,57243445772,894428840,13975450,16.3),(94837,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94837,38.01,0.21,400,39947,70,NULL,NULL,'2MASX J12284739+5115554',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000181,NULL,'16.2g',0.44,'BrClG          AGN',NULL,NULL,NULL,NULL,1,187.197333,51.26525,0,NULL,57243449165,894428893,13975451,16.2),(94838,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94838,37.66,0.46,340,39948,70,NULL,NULL,'2MASX J12284843+2644136',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,187.201917,26.73722,0.072,NULL,58609079109,915766861,14308857,17.8),(94839,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94839,37.44,0.46,308,39949,70,NULL,NULL,'2MASX J12284887+4915204',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000157,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,187.20375,49.25572,0,NULL,57181271266,893457363,13960271,16.6),(94840,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94840,37.91,0.08,383,39950,70,NULL,NULL,'SDSS J122849.07+084548.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'18.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,187.2045,8.76356,0,NULL,58245309313,910082958,14220046,18),(94841,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94841,37.65,0.46,339,39951,70,NULL,NULL,'SDSS J122850.02+071759.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,187.2084583,7.3,0,NULL,58249482680,910148166,14221065,17.9),(94842,'Ring Diameter','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94842,32.2,0.84,27,39952,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4454',NULL,'1981ApJS...45..541P',1981,1,1.81,NULL,'G',0.000033,NULL,'13.2g',1.44,'(R)SB(r)0/a',NULL,NULL,NULL,NULL,1,187.2114583,-1.93919,0.057,NULL,42999341236,671864706,10497886,13.2),(94843,'Tully est','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94843,32.77,0.8,35.7,39952,75,NULL,'B','NGC 4454',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94844,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94844,39.02,0.46,636,39953,70,NULL,NULL,'SDSS J122852.00+661448.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.0001,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,187.2167083,66.24667,0.009,NULL,57324786893,895699795,13995309,18.5),(94845,'TRGB','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94845,29.65,0.1,8.51,39954,74.4,NULL,NULL,'MCG +07-26-011',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000027,NULL,'15.01',0.45,'dwarf Irr',NULL,NULL,NULL,NULL,1,187.217625,42.17792,0,NULL,59063927884,922873873,14419904,15.01),(94846,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94846,29.75,NULL,8.91,39954,NULL,NULL,NULL,'MCG +07-26-011',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94847,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94847,33.74,0.49,55.9,39955,75,NULL,'IR','UGC 07607',NULL,'2011yCatp016004901K',2011,1,2.24,NULL,'G',0.000006,NULL,'15.52',0.11,'Sd','Group member',NULL,NULL,NULL,1,187.217875,4.29317,0.011,NULL,58229058869,909829044,14216078,15.52),(94848,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94848,34.25,NULL,70.9,39955,NULL,NULL,NULL,'UGC 07607',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94849,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94849,34.26,NULL,71,39955,NULL,NULL,'Dipole','UGC 07607',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94850,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94850,34.26,NULL,71,39955,NULL,NULL,'Dipole + Quadrupole','UGC 07607',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94851,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94851,34.26,NULL,71.1,39955,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07607',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94852,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94852,34.32,0.2,73.1,39955,74.4,NULL,NULL,'UGC 07607',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94853,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94853,34.4,0.48,75.7,39955,NULL,NULL,NULL,'UGC 07607',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94854,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94854,34.4,0.48,75.8,39955,NULL,NULL,'Malmquist cor.','UGC 07607',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94855,'SNIa','2016-12-15 15:15:00','2016-12-16 11:20:11','1','SN 1996H','R',94855,41.91,NULL,1490,39956,65,NULL,'SALT','[GC96] J122852.78-000541.0',0.62,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,'23.7g',NULL,NULL,NULL,NULL,NULL,NULL,1,187.220041667,-0.09447,0.026,NULL,42989824171,671716002,10495562,23.7),(94856,'SNIa','2016-12-15 15:15:00','2016-12-16 11:20:11','1','SN 1996H',NULL,94856,42.51,0.4,1960,39956,74.2,NULL,'SALT 2','[GC96] J122852.78-000541.0',0.62,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94857,'SNIa','2016-12-15 15:15:00','2016-12-16 11:20:11','1','SN 1996H',NULL,94857,42.98,0.17,2430,39956,65,NULL,'MLCS','[GC96] J122852.78-000541.0',0.62,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94858,'SNIa','2016-12-15 15:15:00','2016-12-16 11:20:11','1','SN 1996H',NULL,94858,43.01,0.15,2470,39956,65,NULL,'Template','[GC96] J122852.78-000541.0',0.62,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94859,'SNIa','2016-12-15 15:15:00','2016-12-16 11:20:11','1','SN 1996H',NULL,94859,43.11,0.3,2590,39956,65,NULL,NULL,'[GC96] J122852.78-000541.0',0.62,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94860,'SNIa','2016-12-15 15:15:00','2016-12-16 11:20:11','1','SN 1996H',NULL,94860,43.21,0.37,2710,39956,70,NULL,'SALT','[GC96] J122852.78-000541.0',0.62,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94861,'SNIa','2016-12-15 15:15:00','2016-12-16 11:20:11','1','SN 1996H',NULL,94861,43.4,0.34,2950,39956,65,NULL,'SALT','[GC96] J122852.78-000541.0',0.62,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94862,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94862,37.61,0.46,333,39957,70,NULL,NULL,'2MASX J12285310+0228343',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000205,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,187.221333,2.47606,0,NULL,58014847123,906481986,14163781,16.4),(94863,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94863,35.87,0.46,150,39958,70,NULL,NULL,'2MASX J12285353+4009480',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000171,NULL,'16.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,187.2232917,40.16339,0,NULL,58573525652,915211338,14300177,16.1),(94864,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94864,31.81,NULL,23,39959,NULL,NULL,NULL,'VCC 1141',NULL,'2014A&A...562A..49M',2014,1,0.45,NULL,'G',0.000033,NULL,'16.2g',0.37,'BCD?','Group member',NULL,NULL,NULL,1,187.229,9.42111,0,NULL,58245651848,910088310,14220129,16.2),(94865,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94865,36.44,0.46,194,39960,70,NULL,NULL,'VPC 0619',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00009,NULL,'15.5g',0.48,'E',NULL,NULL,NULL,NULL,1,187.22925,13.79083,0.065,NULL,58163125233,908798831,14199981,15.5),(94866,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94866,37.03,0.46,255,39961,70,NULL,NULL,'2MASX J12285590+3856540',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,187.2329583,38.94828,0,NULL,58577026190,915266034,14301031,16.9),(94867,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94867,37.39,0.46,301,39962,70,NULL,NULL,'SDSS J122857.42+101230.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00014,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,187.2392917,10.20853,0.016,NULL,58187899339,909185927,14206030,17.8),(94868,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94868,31.1,0.15,16.6,39963,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4458',NULL,'2007ApJS..171..101J',2007,1,1.7,'Bingelli, et al. (1985,AJ,90,1681) give v=1951 +/- 17 km/sec.','G',0.000017,NULL,'12.93',1.6,'E0-1','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.239875,13.24189,0.069,NULL,58162914564,908795540,14199930,12.93),(94869,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94869,31.14,0.14,16.9,39963,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4458',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94870,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94870,31.16,0.18,17,39963,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4458',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94871,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94871,31.28,0.13,18,39963,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4458',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94872,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94872,31.33,0.2,18.5,39963,NULL,NULL,NULL,'NGC 4458',NULL,'2001AJ....121.2950K',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94873,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94873,30.6,NULL,13,39963,NULL,NULL,'I','NGC 4458',NULL,'1989ApJ...346L..57T',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94874,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94874,30.85,0.2,14.8,39963,NULL,NULL,'I','NGC 4458',NULL,'1993A&A...275..433B',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94875,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94875,30.92,0.13,15.3,39963,NULL,NULL,'HST KP Calibrated, F814W','NGC 4458',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94876,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94876,30.98,0.08,15.7,39963,NULL,NULL,'I','NGC 4458',NULL,'1997AJ....114..626A',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94877,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94877,31.01,0.06,15.9,39963,NULL,NULL,'I','NGC 4458',NULL,'1990AJ....100.1416T',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94878,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94878,31.02,0.12,16,39963,NULL,NULL,'I','NGC 4458',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94879,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94879,31.06,0.07,16.3,39963,NULL,NULL,'HST ACS VCS','NGC 4458',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94880,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94880,31.07,0.05,16.4,39963,NULL,NULL,NULL,'NGC 4458',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94881,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94881,31.15,0.12,17,39963,74.4,NULL,NULL,'NGC 4458',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94882,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94882,31.17,0.24,17.1,39963,NULL,NULL,'HST KP Calibrated, I','NGC 4458',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94883,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94883,31.18,0.12,17.2,39963,NULL,NULL,'I','NGC 4458',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94884,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94884,31.18,0.12,17.2,39963,NULL,NULL,NULL,'NGC 4458',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94885,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94885,31.2,0.12,17.4,39963,NULL,NULL,'Malmquist cor.','NGC 4458',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94886,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94886,31.78,0.59,22.7,39963,NULL,NULL,'I','NGC 4458',NULL,'2000ApJ...536..255N',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94887,'GC radius','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94887,30.7,0.11,13.8,39963,NULL,NULL,NULL,'NGC 4458',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94888,'D-Sigma','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94888,31.13,0.4,16.8,39963,75,NULL,'Edat, raw','NGC 4458',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94889,'D-Sigma','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94889,31.15,0.4,17,39963,75,NULL,'Edat, cor','NGC 4458',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94890,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94890,31.15,0.12,17,39963,74.4,NULL,NULL,'NGC 4458',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94891,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94891,31.28,NULL,18,39963,NULL,NULL,NULL,'NGC 4458',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94892,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94892,31.45,0.41,19.5,39963,NULL,NULL,NULL,'NGC 4458',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94893,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94893,31.56,0.41,20.5,39963,NULL,NULL,'Malmquist cor.','NGC 4458',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94894,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94894,31.99,NULL,25,39963,NULL,NULL,NULL,'NGC 4458',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (94895,'Tully est','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94895,31.13,0.8,16.8,39963,75,NULL,'B','NGC 4458',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94896,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94896,31.12,0.4,16.7,39963,NULL,NULL,'mean','NGC 4458',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94897,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94897,32.19,0.45,27.4,39963,NULL,NULL,'K','NGC 4458',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94898,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94898,37.7,0.46,346,39964,70,NULL,NULL,'2MASX J12285790+0704049',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000176,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,187.2412083,7.06814,0,NULL,58248922904,910139420,14220928,17.7),(94899,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94899,37.21,0.46,276,39965,70,NULL,NULL,'2MASX J12285844+0211271',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000173,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,187.2435,2.19086,0,NULL,58014918826,906483106,14163798,16.3),(94900,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94900,38.97,0.46,622,39966,70,NULL,NULL,'2MASX J12285897+4708211',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000192,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,187.2457083,47.13919,0,NULL,59068221230,922940956,14420952,18.2),(94901,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94901,30.15,NULL,10.7,39967,NULL,NULL,NULL,'NGC 4457',NULL,'1999MNRAS.304..595G',1999,1,2.7,NULL,'G',0.00002,NULL,'11.76',2.3,'(R)SAB(s)0/a   LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.245875,3.57058,0.035,NULL,58005512483,906336132,14161502,11.76),(94902,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94902,31.2,0.4,17.4,39967,75,NULL,'B','NGC 4457',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94903,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94903,35.54,0.49,128,39968,75,NULL,'IR','IC 3402',NULL,'2011yCatp016004901K',2011,1,1.39,NULL,'G',0.000033,NULL,'15.6g',0.24,'Sc',NULL,NULL,NULL,NULL,1,187.247167,28.86194,0.089,NULL,58728696352,917635880,14338060,15.6),(94904,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94904,35.83,NULL,147,39968,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 3402',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94905,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94905,35.84,NULL,147,39968,NULL,NULL,'Dipole + Quadrupole','IC 3402',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94906,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94906,35.86,NULL,149,39968,NULL,NULL,NULL,'IC 3402',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94907,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94907,35.87,NULL,149,39968,NULL,NULL,'Dipole','IC 3402',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94908,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94908,38.16,0.46,428,39969,70,NULL,NULL,'2MASX J12285975+6308591',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,187.249041667,63.14975,0.009,NULL,57374320372,896473755,14007402,18.3),(94909,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94909,31.09,0.09,16.5,39970,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4459',NULL,'2010ApJ...717..603V',2010,1,3.5,NULL,'G',0.000017,NULL,'11.32',2.7,'SA(r)0+;HII   LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.2500417,13.97836,0.078,NULL,58163164060,908799438,14199991,11.32),(94910,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94910,31.1,0.09,16.6,39970,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4459',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94911,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94911,31.21,0.09,17.5,39970,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4459',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94912,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94912,31.29,0.09,18.1,39970,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4459',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94913,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94913,31,0.14,15.9,39970,74.4,NULL,NULL,'NGC 4459',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94914,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94914,31.02,0.07,16,39970,NULL,NULL,'HST ACS VCS','NGC 4459',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94915,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94915,31.03,0.06,16.1,39970,NULL,NULL,NULL,'NGC 4459',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94916,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94916,31.04,0.22,16.1,39970,NULL,NULL,'I','NGC 4459',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94917,'GC radius','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94917,31.14,0.06,16.9,39970,NULL,NULL,NULL,'NGC 4459',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94918,'Faber-Jackson','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94918,30.25,0.42,11.2,39970,95,NULL,'de Vaucouleurs','NGC 4459',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94919,'Faber-Jackson','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94919,30.52,0.28,12.7,39970,95,NULL,'Weighted Mean','NGC 4459',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94920,'Faber-Jackson','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94920,30.69,0.63,13.7,39970,95,NULL,'Michard 1979b, c','NGC 4459',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94921,'Faber-Jackson','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94921,30.88,NULL,15,39970,NULL,NULL,'LEDA [April 2006]','NGC 4459',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94922,'Faber-Jackson','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94922,30.93,0.46,15.3,39970,95,NULL,'Michard 1979a','NGC 4459',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94923,'Faber-Jackson','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94923,32.04,0.81,25.6,39970,55,NULL,'Visvanathan & Sandage 1979','NGC 4459',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94924,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94924,30.72,NULL,13.9,39970,NULL,NULL,NULL,'NGC 4459',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94925,'Tertiary','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94925,30.49,0.25,12.5,39970,95,NULL,NULL,'NGC 4459',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94926,'Tully est','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94926,31.13,0.8,16.8,39970,75,NULL,'B','NGC 4459',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94927,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94927,31.08,0.45,16.4,39970,NULL,NULL,'K','NGC 4459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94928,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94928,31.66,0.4,21.5,39970,NULL,NULL,'mean','NGC 4459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94929,'SNIa','2016-12-15 15:15:00','2016-12-16 11:20:11','1','SN 1997bb',NULL,94929,42.83,0.3,2420,39971,65,NULL,NULL,'H-ZSNS J122900.72+000911.3',0.52,'2004ApJ...607..665R',2004,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,187.253,0.15314,0.053,NULL,58009038467,906391226,14162362,NULL),(94930,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94930,30.82,0.4,14.6,39972,75,NULL,'B','UGC 07612',NULL,'1988NBGC.C....0000T',1988,1,2.1,'Nearest galaxy of comparable redshift to [HB89] 1226+023 ABS06.','G',0.000017,NULL,'14.79',1.1,'Sm:            HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,187.258917,2.72319,0,NULL,58013839428,906466241,14163535,14.79),(94931,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94931,32.65,0.36,33.9,39972,NULL,NULL,NULL,'UGC 07612',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94932,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94932,38.01,0.21,400,39973,70,NULL,NULL,'2MASX J12290257+5114514',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,187.260916667,51.24769,0,NULL,57243437377,894428709,13975448,17.5),(94933,'Faber-Jackson','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94933,30.49,0.63,12.5,39974,95,NULL,'Michard 1979b, c','NGC 4461',NULL,'1984ApJS...56...91D',1984,1,3.5,'Identification as NGC 4443 is not certain.','G',0.000017,NULL,'12.09',1.4,'SB(s)0+:','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.2625417,13.18375,0.069,NULL,58162699020,908792172,14199877,12.09),(94934,'Faber-Jackson','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94934,30.72,0.35,13.9,39974,95,NULL,'Weighted Mean','NGC 4461',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94935,'Faber-Jackson','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94935,30.81,0.59,14.5,39974,95,NULL,'de Vaucouleurs','NGC 4461',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94936,'Faber-Jackson','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94936,31.07,0.46,16.4,39974,95,NULL,'Michard 1979a','NGC 4461',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94937,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94937,30.4,NULL,12,39974,NULL,NULL,NULL,'NGC 4461',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94938,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94938,31.48,0.25,19.8,39974,74.4,NULL,NULL,'NGC 4461',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94939,'Tertiary','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94939,30.49,0.25,12.5,39974,95,NULL,NULL,'NGC 4461',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94940,'Tully est','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94940,31.13,0.8,16.8,39974,75,NULL,'B','NGC 4461',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94941,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94941,37.91,0.08,383,39975,70,NULL,NULL,'2MASX J12290338+0840269',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00015,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,187.264,8.67408,0,NULL,58244738137,910074033,14219906,16.5),(94942,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94942,37.53,0.46,321,39976,70,NULL,NULL,'VPC 0630',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,187.2642917,10.80969,0.03,NULL,58188249700,909191401,14206115,17),(94943,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94943,34.58,0.46,82.5,39977,70,NULL,NULL,'MRK 1475',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000156,NULL,'15.6g',0.5,'Compact',NULL,NULL,NULL,NULL,1,187.267958333,43.97958,0,NULL,59061499400,922835928,14419311,15.6),(94944,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94944,37.89,0.27,378,39978,70,NULL,NULL,'SDSS J122904.36+061702.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000155,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,187.2682083,6.28397,0,NULL,58235558335,909930598,14217665,18.4),(94945,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94945,37.02,0.46,253,39979,70,NULL,NULL,'2MASX J12290525+5438591',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000188,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,187.271916667,54.64975,0,NULL,57222570889,894102670,13970354,16.3),(94946,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94946,37.88,0.46,377,39980,70,NULL,NULL,'2MASX J12290561+6218122',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,187.273417,62.30336,0,NULL,57375661866,896494716,14007729,17.4),(94947,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94947,36.95,0.46,246,39981,70,NULL,NULL,'2MASX J12290577+3251442',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,187.273916667,32.86225,0.024,NULL,58772260853,918316575,14348696,17.6),(94948,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94948,37.55,0.46,324,39982,70,NULL,NULL,'2MASX J12290580+4108299',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,187.274333,41.14169,0,NULL,59060852710,922825823,14419153,18.1),(94949,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94949,36.09,0.46,165,39983,70,NULL,NULL,'IC 3410',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000834,NULL,'15.7',0.4,'E?',NULL,NULL,NULL,NULL,1,187.2757083,19.00478,0.087,NULL,58916076255,920563691,14383807,15.7),(94950,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94950,34.29,NULL,72.2,39984,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07617',NULL,'2010Ap&SS.325..163P',2010,1,2.41,NULL,'G',0.00005,NULL,'14.9g',0.33,'Sc',NULL,NULL,NULL,NULL,1,187.276,44.65525,0,NULL,59069419604,922959681,14421245,14.9),(94951,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94951,34.3,NULL,72.4,39984,NULL,NULL,'Dipole + Quadrupole','UGC 07617',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94952,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94952,34.3,NULL,72.5,39984,NULL,NULL,'Dipole','UGC 07617',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94953,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94953,34.47,0.49,78.2,39984,75,NULL,'IR','UGC 07617',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94954,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94954,35.01,0.2,100,39984,74.4,NULL,NULL,'UGC 07617',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94955,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94955,35.13,0.39,106,39984,NULL,NULL,NULL,'UGC 07617',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94956,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94956,35.18,0.38,109,39984,NULL,NULL,'Malmquist cor.','UGC 07617',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94957,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94957,37.87,0.1,375,39985,70,NULL,NULL,'SDSS J122906.29+114500.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,187.2762083,11.75,0.038,NULL,58161906950,908779796,14199684,18.4),(94958,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94958,37.32,0.46,291,39986,70,NULL,NULL,'2MASX J12290632+3952289',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000198,NULL,'16.1g',0.43,NULL,NULL,NULL,NULL,NULL,1,187.2762083,39.87453,0,NULL,58574497278,915226519,14300414,16.1),(94959,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94959,37.33,0.46,293,39987,70,NULL,NULL,'2MASX J12290666+5519311',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,187.277667,55.32519,0,NULL,57401562979,896899421,14014053,17.1),(94960,'IRAS','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94960,32.97,0.8,39.3,39988,75,NULL,'MAT, I','ESO 322- G 019',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.79',0.3,'SB(s)cd? sp','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,187.28,-40.67339,0.369,NULL,43222475384,675351177,10552362,14.79),(94961,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94961,33.39,0.12,47.7,39988,NULL,NULL,NULL,'ESO 322- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94962,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94962,33.74,0.32,56,39988,85,NULL,'I, raw','ESO 322- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94963,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94963,33.77,0.32,56.7,39988,85,NULL,'I, inv','ESO 322- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94964,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94964,33.87,0.43,59.4,39988,75,NULL,'MAT, I, raw','ESO 322- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94965,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94965,34.02,0.43,63.7,39988,75,NULL,'MAT, I, inv','ESO 322- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94966,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94966,34.03,0.43,64.1,39988,75,NULL,'MAT, I, cor','ESO 322- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94967,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94967,34.05,0.49,64.5,39988,75,NULL,'IR','ESO 322- G 019',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94968,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94968,37.91,0.08,383,39989,70,NULL,NULL,'SDSS J122907.18+083951.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,187.2800417,8.66417,0,NULL,58244737709,910074026,14219906,18.5),(94969,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94969,36.6,0.46,209,39990,70,NULL,NULL,'2MASX J12290747+4049519',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000179,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,187.281125,40.83106,0,NULL,58527392468,914490507,14288914,16.2),(94970,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94970,37.91,0.08,383,39991,70,NULL,NULL,'2MASX J12290769+0838299',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,187.282125,8.64172,0,NULL,58244739344,910074052,14219907,17.2),(94971,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94971,33.92,0.49,60.8,39992,75,NULL,'IR','UGC 07618',NULL,'2011yCatp016004901K',2011,1,1.8,NULL,'G',0.000043,NULL,'15.5g',0.25,'Sd',NULL,NULL,NULL,NULL,1,187.28425,57.91478,0,NULL,57409108652,897017322,14015895,15.5),(94972,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94972,34.28,NULL,71.8,39992,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07618',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94973,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94973,34.29,NULL,72.3,39992,NULL,NULL,'Dipole + Quadrupole','UGC 07618',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94974,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94974,34.3,NULL,72.4,39992,NULL,NULL,'Dipole','UGC 07618',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94975,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94975,34.41,NULL,76.2,39992,NULL,NULL,NULL,'UGC 07618',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94976,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94976,36.99,0.46,249,39993,70,NULL,NULL,'2MASX J12290881+6144182',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000173,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,187.286916667,61.73825,0,NULL,57375029572,896484837,14007575,16.6),(94977,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94977,38.1,0.46,417,39994,70,NULL,NULL,'2MASX J12291167+0854349',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,187.2987083,8.90975,0,NULL,58244942194,910077221,14219956,17.3),(94978,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94978,36.55,0.46,204,39995,70,NULL,NULL,'2MASX J12291185+6800195',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000074,NULL,'16.1g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,187.299167,68.00542,0.017,NULL,57849398967,903896858,14123388,16.1),(94979,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94979,38.46,0.46,492,39996,70,NULL,NULL,'2MASX J12291245+5828181',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000138,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,187.302083,58.47164,0,NULL,57405258584,896957165,14014955,18.1),(94980,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94980,37.24,0.46,281,39997,70,NULL,NULL,'2MASX J12291274+1158460',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,187.303167,11.97953,0.06,NULL,58162009035,908781391,14199709,18),(94981,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94981,37.87,0.1,375,39998,70,NULL,NULL,'SDSS J122912.97+120638.9',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.27,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,187.304083333,12.11081,0.06,NULL,58161958829,908780606,14199696,17.1),(94982,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94982,38.64,0.46,534,39999,70,NULL,NULL,'SDSS J122913.18+542157.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000132,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,187.305,54.36586,0,NULL,57222649535,894103898,13970373,18.4),(94983,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94983,36.49,0.46,199,40000,70,NULL,NULL,'LCRS B122640.7-032021',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000094,NULL,'15.9g',0.46,'E0',NULL,NULL,NULL,NULL,1,187.311958333,-3.61547,0.097,NULL,42993366609,671771353,10496427,15.9),(94984,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94984,37.75,0.46,355,40001,70,NULL,NULL,'2MASXi J1229154+413808',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000173,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,187.3145417,41.63592,0,NULL,59060804145,922825064,14419141,17.7),(94985,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94985,36.94,0.46,244,40002,70,NULL,NULL,'2MASX J12291642-0103437',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000075,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,187.318333333,-1.06206,0.037,NULL,42990060703,671719698,10495620,16.9),(94986,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94986,37.87,0.1,375,40003,70,NULL,NULL,'VPC 0644',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000183,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,187.319083,12.10408,0.06,NULL,58161958295,908780598,14199696,16.9),(94987,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94987,36.73,0.46,222,40004,70,NULL,NULL,'2MASX J12291745+3013254',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000171,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,187.3225417,30.22386,0.042,NULL,58778218312,918409661,14350150,16.7),(94988,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94988,38.96,0.46,619,40005,70,NULL,NULL,'SDSS J122917.83+121351.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000141,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,187.3242917,12.231,0.088,NULL,58161497206,908773393,14199584,18.5),(94989,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94989,37.87,0.1,375,40006,70,NULL,NULL,'VPC 0646',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000137,NULL,'16.9g',0.31,'FR I',NULL,NULL,NULL,NULL,1,187.325333,11.73483,0.038,NULL,58159826671,908747291,14199176,16.9),(94990,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94990,37.87,0.1,375,40007,70,NULL,NULL,'2MASX J12291840+1200520',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000203,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,187.3267917,12.01444,0.06,NULL,58161966602,908780728,14199698,17.7),(94991,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',94991,37.51,0.46,317,40008,70,NULL,NULL,'2MASX J12291973+5214275',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,187.3320417,52.24094,0.023,NULL,57242301895,894410967,13975171,17.3),(94992,'Ring Diameter','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94992,31.2,0.76,17,40009,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4462',NULL,'1981ApJS...45..541P',1981,1,3.2,NULL,'G',0.000013,NULL,'13.12',1.2,'SB(r)ab',NULL,NULL,NULL,NULL,1,187.338416667,-23.16636,0.229,NULL,43914456923,686163389,10721302,13.12),(94993,'Ring Diameter','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94993,31.4,0.6,19,40009,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4462',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94994,'Tully est','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94994,32.21,0.8,27.7,40009,75,NULL,'B','NGC 4462',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94995,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94995,31.98,0.46,24.8,40009,NULL,NULL,'J','NGC 4462',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94996,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94996,31.99,0.47,25.1,40009,NULL,NULL,'H','NGC 4462',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94997,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94997,32.03,0.45,25.5,40009,NULL,NULL,'K','NGC 4462',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94998,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94998,32.23,0.4,27.9,40009,NULL,NULL,'mean','NGC 4462',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(94999,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,94999,32.43,0.43,30.6,40009,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4462',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95000,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95000,30.81,0.13,14.5,40010,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4464',NULL,'2010ApJ...717..603V',2010,1,1.1,NULL,'G',0.000008,NULL,'13.46',0.8,'E3','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.338708333,8.15661,0,NULL,58250214939,910159608,14221243,13.46),(95001,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95001,30.82,0.15,14.6,40010,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4464',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95002,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95002,30.97,0.13,15.7,40010,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4464',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95003,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95003,31.09,0.12,16.5,40010,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4464',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95004,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95004,30.97,0.14,15.6,40010,74.4,NULL,NULL,'NGC 4464',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95005,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95005,30.99,0.07,15.8,40010,NULL,NULL,'HST ACS VCS','NGC 4464',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95006,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95006,31,0.06,15.8,40010,NULL,NULL,NULL,'NGC 4464',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95007,'GC radius','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95007,30.59,0.1,13.1,40010,NULL,NULL,NULL,'NGC 4464',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95008,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95008,31.32,NULL,18.4,40010,NULL,NULL,NULL,'NGC 4464',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95009,'Tully est','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95009,31.13,0.8,16.8,40010,75,NULL,'B','NGC 4464',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95010,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95010,36.82,0.46,231,40011,70,NULL,NULL,'SDSS J122922.37+094702.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000135,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,187.34325,9.78406,0,NULL,58244525268,910070707,14219854,17.7),(95011,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95011,31.84,0.4,23.3,40012,NULL,NULL,'mean','IC 3413',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.00004,NULL,'14.72',0.6,'dS0,N','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,187.343791667,11.43389,0.03,NULL,58189939315,909217801,14206528,14.72),(95012,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95012,33.36,0.45,46.9,40012,NULL,NULL,'K','IC 3413',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95013,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95013,37.46,0.46,311,40013,70,NULL,NULL,'2MASX J12292278+3713410',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,187.344958333,37.22819,0,NULL,58570512346,915164255,14299441,18.1),(95014,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95014,38.24,0.46,445,40014,70,NULL,NULL,'SDSS J122923.22+070445.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,187.3467917,7.07936,0,NULL,58248932670,910139572,14220930,18.4),(95015,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95015,31.04,0.2,16.1,40015,NULL,NULL,'TOM(g) = -7.2 mag','MESSIER 087 DW07',NULL,'2007ApJS..171..101J',2007,1,0.6,NULL,'G',0.000167,NULL,'15.38',0.6,'dE1','Group member',NULL,NULL,NULL,1,187.347958333,12.45078,0.09,NULL,58159629830,908744216,14199128,15.38),(95016,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95016,31.04,0.17,16.1,40015,NULL,NULL,'TOM(g) = -7.2 mag','MESSIER 087 DW07',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95017,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95017,31.31,0.16,18.3,40015,NULL,NULL,'TOM(u) = -8.4 mag','MESSIER 087 DW07',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95018,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95018,31.44,0.16,19.4,40015,NULL,NULL,'TOM(z) = -8.53 mag','MESSIER 087 DW07',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95019,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95019,31.13,0.14,16.8,40015,74.4,NULL,NULL,'MESSIER 087 DW07',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95020,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95020,31.15,0.11,16.9,40015,NULL,NULL,'HST ACS VCS','MESSIER 087 DW07',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95021,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95021,31.14,0.1,16.9,40015,NULL,NULL,NULL,'MESSIER 087 DW07',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95022,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95022,37.87,0.1,375,40016,70,NULL,NULL,'VPC 0654',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000144,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,187.349125,11.78925,0.038,NULL,58160005954,908750093,14199220,17.8),(95023,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95023,37.16,0.46,270,40017,70,NULL,NULL,'2MASX J12292444+2713171',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000174,NULL,'18.51',0.19,NULL,NULL,NULL,NULL,NULL,1,187.352083,27.22156,0.06,NULL,58610791771,915793621,14309275,18.51),(95024,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95024,36.99,0.46,250,40018,70,NULL,NULL,'2MASX J12292510+4340507',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000104,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,187.354667,43.68075,0,NULL,59061505848,922836028,14419312,17.2),(95025,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95025,37.39,0.46,301,40019,70,NULL,NULL,'SDSS J122925.18+054857.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,187.3549583,5.81592,0,NULL,58235313414,909926772,14217605,17.5),(95026,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95026,37.91,0.08,383,40020,70,NULL,NULL,'2MASX J12292583+0850336',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,187.3577917,8.84261,0,NULL,58244954385,910077412,14219959,17.9),(95027,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95027,37.29,0.46,287,40021,70,NULL,NULL,'VPC 0660',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000131,NULL,'18.3g',0.1,NULL,NULL,NULL,NULL,NULL,1,187.35875,14.03858,0.078,NULL,58162986294,908796660,14199947,18.3),(95028,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95028,37.56,0.46,325,40022,70,NULL,NULL,'2MASX J12292684+1625350',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,187.3619583,16.42658,0.025,NULL,58879971559,919999555,14374993,17.3),(95029,'SNIa','2016-12-15 15:15:00','2016-12-16 11:20:11','1','SCP 06C00',NULL,95029,44.09,0.07,3140,40023,70,NULL,'SALT2, M(B) -19.289 mag, Alpha -0.019, Beta 3.480, Delta -0.151','[SRG2009] 20014',1.092,'2012ApJ...746...85S',2012,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'S0',NULL,NULL,NULL,NULL,1,187.365458333,1.84856,0.029,NULL,58015370279,906490160,14163908,NULL),(95030,'Tully est','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95030,31.13,0.8,16.8,40024,75,NULL,'B','NGC 4469',NULL,'1988NBGC.C....0000T',1988,1,2.5,NULL,'G',0.00006,NULL,'12.0g',1.04,'SB(s)0/a? sp   LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.366791667,8.74992,0,NULL,58244768295,910074504,14219914,12),(95031,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95031,31.12,NULL,16.7,40024,NULL,NULL,NULL,'NGC 4469',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95032,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95032,37.89,0.27,378,40025,70,NULL,NULL,'2MASX J12292833+0621086',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000162,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,187.3680417,6.35242,0,NULL,58235608553,909931383,14217677,16.6),(95033,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95033,37.89,0.27,378,40026,70,NULL,NULL,'2MASX J12292840+0613526',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000192,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,187.3682917,6.23117,0,NULL,58235612693,909931448,14217678,16.4),(95034,'IRAS','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95034,35.3,0.8,115,40027,75,NULL,'MAT, I','ESO 268- G 011',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'15.16',0.9,'SB(r)a',NULL,NULL,NULL,NULL,1,187.3692083,-46.73506,0.517,NULL,46716095462,729938991,11405296,15.16),(95035,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95035,34.77,0.43,89.7,40027,75,NULL,'MAT, I, raw','ESO 268- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95036,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95036,34.94,0.32,97.3,40027,85,NULL,'I, raw','ESO 268- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95037,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95037,35,0.32,100,40027,85,NULL,'I, inv','ESO 268- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95038,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95038,35,0.43,100,40027,75,NULL,'MAT, I, cor','ESO 268- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95039,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95039,35.03,0.43,101,40027,75,NULL,'MAT, I, inv','ESO 268- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95040,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95040,35.59,0.39,131,40027,NULL,NULL,'Malmquist cor.','ESO 268- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95041,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95041,35.73,0.36,140,40027,NULL,NULL,NULL,'ESO 268- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95042,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95042,35.77,0.2,143,40027,74.4,NULL,NULL,'ESO 268- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95043,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95043,30.4,0.2,12,40028,74.4,NULL,NULL,'IC 3414',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.00002,NULL,'13.94',0.9,'SABdm?         HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.369916667,6.77181,0,NULL,58235068877,909922951,14217546,13.94),(95044,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95044,31.32,0.36,18.4,40028,NULL,NULL,NULL,'IC 3414',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95045,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95045,38.33,0.46,464,40029,70,NULL,NULL,'SDSS J122929.02+050812.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,187.370958333,5.13669,0,NULL,58228943095,909827235,14216050,18),(95046,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95046,38.14,0.46,424,40030,70,NULL,NULL,'2MASX J12292919+6631475',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000086,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,187.371417,66.52983,0.033,NULL,57324647597,895697618,13995275,17.2),(95047,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95047,38.17,0.46,430,40031,70,NULL,NULL,'SDSS J122929.40+034128.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,187.3725417,3.69111,0.045,NULL,58005591846,906337372,14161521,18.5),(95048,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95048,30.98,0.09,15.7,40032,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4467',NULL,'2007ApJS..171..101J',2007,1,0.62,NULL,'G',0.000037,NULL,'14.8g',0.57,'E2','in a pair',NULL,NULL,NULL,1,187.3760417,7.99286,0,NULL,58250085082,910157579,14221212,14.8),(95049,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95049,30.98,0.09,15.7,40032,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4467',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95050,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95050,31.06,0.09,16.3,40032,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4467',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95051,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95051,31.19,0.09,17.3,40032,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4467',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95052,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95052,31.08,0.09,16.4,40032,NULL,NULL,'I','NGC 4467',NULL,'2010ApJ...724..657B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95053,'Tully est','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95053,31.13,0.8,16.8,40032,75,NULL,'B','NGC 4467',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95054,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95054,31.82,0.4,23.1,40032,NULL,NULL,'mean','NGC 4467',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95055,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95055,32.68,0.45,34.3,40032,NULL,NULL,'K','NGC 4467',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95056,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95056,32.26,0.54,28.3,40033,NULL,NULL,'Malmquist cor.','NGC 4466',NULL,'2009ApJS..182..474S',2009,1,1.54,'HOLM 412B is a star.','G',0.00003,NULL,'14.2g',0.51,'Sab? sp        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,187.377375,7.69642,0,NULL,58250355426,910161803,14221278,14.2),(95057,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95057,32.33,NULL,29.2,40033,NULL,NULL,'B','NGC 4466',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95058,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95058,32.41,0.51,30.3,40033,NULL,NULL,NULL,'NGC 4466',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95059,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95059,32.45,0.2,30.9,40033,74.4,NULL,NULL,'NGC 4466',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95060,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95060,32.46,0.36,31,40033,NULL,NULL,NULL,'NGC 4466',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95061,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95061,37.57,0.33,327,40034,70,NULL,NULL,'2MASX J12293060+0329425',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000162,NULL,'17.3g',0.2,'LINER',NULL,NULL,NULL,NULL,1,187.377625,3.49517,0.045,NULL,58005947654,906342932,14161608,17.3),(95062,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95062,30.18,0.08,10.9,40035,NULL,NULL,'I','NGC 4468',NULL,'1990AJ....100.1416T',1990,1,1.45,'RC3 also has V_21 = 2422 +- 11 km/sec.','G',0.000037,NULL,'13.7g',0.96,'SA0-?','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.37875,14.04908,0.081,NULL,58162977912,908796529,14199945,13.7),(95063,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95063,30.4,0.2,12,40035,NULL,NULL,'I','NGC 4468',NULL,'1993A&A...275..433B',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95064,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95064,30.99,0.14,15.8,40035,74.4,NULL,NULL,'NGC 4468',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95065,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95065,31,0.14,15.8,40035,NULL,NULL,'I','NGC 4468',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95066,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95066,30.72,0.45,13.9,40035,NULL,NULL,'K','NGC 4468',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95067,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95067,31.19,0.4,17.3,40035,NULL,NULL,'mean','NGC 4468',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95068,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95068,38.11,0.46,420,40036,70,NULL,NULL,'2MASX J12293088+5642020',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000143,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,187.37875,56.70056,0,NULL,57411006080,897046970,14016358,17.9),(95069,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95069,37.19,0.46,275,40037,70,NULL,NULL,'2MASX J12293233+0106095',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000086,NULL,'16.7g',0.23,'S0',NULL,NULL,NULL,NULL,1,187.384625,1.1025,0,NULL,58013008355,906453255,14163332,16.7),(95070,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95070,32.92,NULL,38.3,40038,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07625',NULL,'2010Ap&SS.325..163P',2010,1,1.01,'Nearest galaxy of comparable redshift to [HB89] 1226+023 ABS18.','G',0.000017,NULL,'16.7g',0.13,'Sd(f)',NULL,NULL,NULL,NULL,1,187.386541667,0.83964,0.035,NULL,58008739080,906386548,14162289,16.7),(95071,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95071,32.94,NULL,38.8,40038,NULL,NULL,'Dipole + Quadrupole','UGC 07625',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95072,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95072,32.97,NULL,39.2,40038,NULL,NULL,'Dipole','UGC 07625',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95073,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95073,38.14,0.46,425,40039,70,NULL,NULL,'2MASX J12293284+3844290',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,187.387,38.7415,0,NULL,58576064697,915251010,14300797,17.9),(95074,'SNIa','2016-12-15 15:15:00','2016-12-16 11:20:11','1','SCP 06C01',NULL,95074,43.86,0.03,2980,40040,70,NULL,'SALT2, M(B) -19.307 mag, Alpha 0.124, Beta 1.460, Delta 0.023','[SRG2009] 04126',0.98,'2012ApJ...746...85S',2012,1,NULL,NULL,'G',NULL,NULL,'23.5R',NULL,'E',NULL,NULL,NULL,NULL,1,187.3900417,1.86289,0.029,NULL,58015381747,906490339,14163911,23.5),(95075,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95075,37.57,0.33,327,40041,70,NULL,NULL,'2MASX J12293407+0321195',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000178,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,187.3919583,3.35539,0.045,NULL,58005934487,906342726,14161605,17.3),(95076,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95076,37.45,0.33,309,40042,70,NULL,NULL,'SDSS J122934.65+304209.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000156,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,187.394375,30.70261,0,NULL,58777399487,918396866,14349951,18.6),(95077,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95077,31.03,0.1,16.1,40043,NULL,NULL,'TOM(g) = -7.2 mag','VCC 1199',NULL,'2007ApJS..171..101J',2007,1,0.3,NULL,'G',0.000065,NULL,'16.1g',0.28,'E2','Group member',NULL,NULL,NULL,1,187.3957917,8.058,0,NULL,58250220077,910159688,14221245,16.1),(95078,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95078,31.03,0.09,16.1,40043,NULL,NULL,'TOM(g) = -7.2 mag','VCC 1199',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95079,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95079,31.08,0.09,16.4,40043,NULL,NULL,'TOM(u) = -8.4 mag','VCC 1199',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95080,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95080,31.21,0.09,17.5,40043,NULL,NULL,'TOM(z) = -8.53 mag','VCC 1199',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95081,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95081,31.06,0.2,16.3,40043,NULL,NULL,'I','VCC 1199',NULL,'2010ApJ...724..657B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95082,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95082,38.81,0.46,578,40044,70,NULL,NULL,'SDSS J122935.21+670101.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000069,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,187.39675,67.017,0.029,NULL,57848954013,903889906,14123279,18.5),(95083,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95083,34.52,0.4,80.3,40045,NULL,NULL,'mean','MCG -01-32-016',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000027,NULL,'14.65',0.6,'(R\')SA(rs)bc pec?',NULL,NULL,NULL,NULL,1,187.401917,-8.43539,0.061,NULL,43214493211,675226456,10550413,14.65),(95084,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95084,35.7,0.47,138,40045,NULL,NULL,'H','MCG -01-32-016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95085,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95085,37.75,0.33,355,40046,70,NULL,NULL,'2MASX J12293744+1806353',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,187.406,18.10992,0.082,NULL,58917255758,920582121,14384095,16.9),(95086,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95086,30.32,0.43,11.6,40047,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4470',NULL,'2014MNRAS.444..527S',2014,1,1.61,NULL,'G',0.000003,NULL,'12.9g',0.98,'Sa?            HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.407417,7.82419,0,NULL,58250335165,910161486,14221273,12.9),(95087,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95087,30.56,0.43,12.9,40047,75,NULL,'3.6 micron, color corrected','NGC 4470',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95088,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95088,30.71,0.2,13.9,40047,74.4,NULL,NULL,'NGC 4470',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95089,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95089,30.84,0.45,14.7,40047,NULL,NULL,NULL,'NGC 4470',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95090,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95090,31.06,0.4,16.3,40047,NULL,NULL,'Malmquist cor.','NGC 4470',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95091,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95091,31.09,0.36,16.5,40047,NULL,NULL,NULL,'NGC 4470',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95092,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95092,31.26,NULL,17.9,40047,NULL,NULL,NULL,'NGC 4470',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95093,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95093,31.65,0.69,21.4,40047,100,NULL,'mid-IR','NGC 4470',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95094,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95094,31.91,0.47,24.1,40047,NULL,NULL,'H','NGC 4470',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95095,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95095,31.96,0.46,24.7,40047,NULL,NULL,'J','NGC 4470',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95096,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95096,32.11,0.45,26.4,40047,NULL,NULL,'K','NGC 4470',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95097,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95097,32.7,0.4,34.6,40047,NULL,NULL,'mean','NGC 4470',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95098,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95098,37.73,0.46,351,40048,70,NULL,NULL,'2MASX J12293832+3245213',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000152,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,187.409625,32.75606,0.026,NULL,58772277016,918316828,14348700,17.4),(95099,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95099,37.87,0.1,375,40049,70,NULL,NULL,'VPC 0673',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,187.411375,11.38319,0.03,NULL,58189953747,909218027,14206531,17.7),(95100,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95100,37.91,0.08,383,40050,70,NULL,NULL,'2MASX J12293898+0839506',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00017,NULL,'16.5g',0.38,NULL,NULL,NULL,NULL,NULL,1,187.4125417,8.664,0,NULL,58244748511,910074195,14219909,16.5),(95101,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95101,36.97,0.46,248,40051,70,NULL,NULL,'2MASX J12294060+1749572',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,187.4192083,17.83272,0.054,NULL,58917072583,920579259,14384050,17.4),(95102,'Tully-Fisher','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95102,36.06,0.2,163,40052,74.4,NULL,NULL,'2MASX J12294104+2201426',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',NULL,NULL,'17.23',0.16,NULL,NULL,NULL,NULL,NULL,1,187.421083333,22.02831,0.046,NULL,58909707406,920464178,14382252,17.23),(95103,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95103,37.87,0.1,375,40053,70,NULL,NULL,'VPC 0680',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000087,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,187.4222917,11.83958,0.06,NULL,58159945017,908749140,14199205,16.8),(95104,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95104,37.47,0.46,311,40054,70,NULL,NULL,'SDSS J122943.46+501508.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,187.431083,50.25222,0,NULL,57238688480,894354507,13974289,18.1),(95105,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95105,37.75,0.46,355,40055,70,NULL,NULL,'2MASX J12294484+1814126',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,187.436833,18.23678,0.092,NULL,58917218057,920581532,14384086,16.7),(95106,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95106,37.37,0.46,298,40056,70,NULL,NULL,'IC 3424',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.40',0.12,NULL,NULL,NULL,NULL,NULL,1,187.437667,24.40867,0.037,NULL,58614696754,915854636,14310228,18.4),(95107,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95107,34.59,0.46,82.6,40057,70,NULL,NULL,'UGC 07635',NULL,'2015arXiv151105856S',2015,1,1.16,NULL,'G',0.000083,NULL,'14.0g',0.73,'S0',NULL,NULL,NULL,NULL,1,187.438917,56.82633,0,NULL,57411041678,897047526,14016367,14),(95108,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95108,37.75,0.33,355,40058,70,NULL,NULL,'2MASX J12294568+1803316',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,187.440333,18.05886,0.082,NULL,58917247435,920581991,14384093,16.6),(95109,'FP','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95109,38.59,0.46,522,40059,70,NULL,NULL,'LCRS B122711.8-025406',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000088,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,187.4412917,-3.17786,0.081,NULL,42993599371,671774990,10496484,18.3),(95110,'Cepheids','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95110,31.07,0.15,16.4,40060,NULL,NULL,'HST KP Calibrated, K\'','MESSIER 049',NULL,'2000ApJ...529..745F',2000,1,10.2,'HOLM 413B is a star.','G',0.000017,NULL,'9.37',8.3,'E2/S0;Sy2      LINER','in a radial-velocity based grouping',NULL,NULL,'Sy 2',1,187.444833,8.00047,0,NULL,58250178449,910159038,14221234,9.37),(95111,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95111,30.17,0.1,10.8,40060,NULL,NULL,'Photographic, TOM(B) = -6.40 mag','MESSIER 049',NULL,'1987AJ.....94..906H',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95112,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95112,30.41,0.1,12.1,40060,NULL,NULL,'Photographic, TOM(B) = -6.40 mag','MESSIER 049',NULL,'1987AJ.....94..906H',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95113,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95113,30.55,0.15,12.9,40060,NULL,NULL,'blue GCs, TOM(V) = -7.17 mag','MESSIER 049',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95114,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95114,30.78,0.3,14.3,40060,NULL,NULL,'R','MESSIER 049',NULL,'1994AJ....108.2087A',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95115,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95115,30.8,0.2,14.5,40060,NULL,NULL,'TOM(V) = -7.4 mag','MESSIER 049',NULL,'2000AJ....120..260L',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95116,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95116,30.95,0.25,15.5,40060,NULL,NULL,NULL,'MESSIER 049',NULL,'1993AJ....105.1358S',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95117,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95117,30.99,0.11,15.8,40060,NULL,NULL,NULL,'MESSIER 049',NULL,'1999AJ....118.2734P',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95118,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95118,31.04,0.11,16.1,40060,NULL,NULL,NULL,'MESSIER 049',NULL,'2000AJ....120.1160P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95119,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95119,31.1,0.2,16.6,40060,NULL,NULL,'TOM(V) = -7.3 mag','MESSIER 049',NULL,'2009ApJ...690..512H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95120,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95120,31.15,0.07,17,40060,NULL,NULL,'TOM(g) = -7.2 mag','MESSIER 049',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95121,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95121,31.15,0.04,17,40060,NULL,NULL,NULL,'MESSIER 049',NULL,'2001AJ....121.2950K',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95122,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95122,31.19,0.08,17.3,40060,NULL,NULL,'TOM(u) = -8.4 mag','MESSIER 049',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95123,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95123,31.2,0.06,17.4,40060,NULL,NULL,'TOM(z) = -8.53 mag','MESSIER 049',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95124,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95124,31.2,0.2,17.4,40060,NULL,NULL,NULL,'MESSIER 049',NULL,'1998AJ....115..947L',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95125,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95125,31.3,0.27,18.2,40060,NULL,NULL,'HST KP Calibrated, V','MESSIER 049',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95126,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95126,31.31,0.09,18.2,40060,NULL,NULL,'TOM(g) = -7.2 mag','MESSIER 049',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95127,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95127,31.41,0.13,19.1,40060,NULL,NULL,'all GCs, TOM(V) = -7.63 mag','MESSIER 049',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95128,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95128,31.52,0.1,20.1,40060,NULL,NULL,'B','MESSIER 049',NULL,'1991ApJS...76..115H',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95129,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95129,31.54,0.17,20.3,40060,NULL,NULL,'TOM(V) = -7.62 mag, t5 function','MESSIER 049',NULL,'1995ApJ...446....1S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95130,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95130,31.63,0.14,21.2,40060,NULL,NULL,'TOM(V) = -7.62 mag, Gaussian','MESSIER 049',NULL,'1995ApJ...446....1S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95131,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95131,31.71,0.55,22,40060,NULL,NULL,'HST KP Calibrated, B','MESSIER 049',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95132,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95132,31.76,0.23,22.5,40060,NULL,NULL,'red GCs, TOM(V) = -7.55 mag','MESSIER 049',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95133,'GCLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,'R',95133,31.79,NULL,22.8,40060,NULL,NULL,'TOM(B) = -7.0 mag','MESSIER 049',NULL,'1988ASPC....4..231H',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95134,'PNLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95134,30.69,0.13,13.7,40060,NULL,NULL,NULL,'MESSIER 049',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95135,'PNLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95135,30.71,0.09,13.9,40060,NULL,NULL,'26 PNe','MESSIER 049',NULL,'1990ApJ...356..332J',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95136,'PNLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95136,30.79,0.15,14.4,40060,NULL,NULL,'HST KP Calibrated','MESSIER 049',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95137,'PNLF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95137,30.84,0.11,14.7,40060,NULL,NULL,'I','MESSIER 049',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95138,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95138,30.78,0.07,14.3,40060,NULL,NULL,'I','MESSIER 049',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95139,'SBF','2016-12-15 15:15:00','2016-12-16 11:20:11','1',NULL,NULL,95139,30.81,0.1,14.5,40060,NULL,NULL,'K','MESSIER 049',NULL,'1994ApJ...433..567P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95140,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95140,30.8,0.2,14.5,40060,NULL,NULL,'I','MESSIER 049',NULL,'1993A&A...275..433B',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95141,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95141,30.81,0.05,14.5,40060,NULL,NULL,'K','MESSIER 049',NULL,'1996ApJ...468..519J',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95142,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95142,30.9,0.1,15.1,40060,NULL,NULL,'I','MESSIER 049',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95143,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95143,30.91,0.11,15.2,40060,NULL,NULL,'K','MESSIER 049',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95144,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95144,30.94,0.06,15.4,40060,NULL,NULL,'I','MESSIER 049',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95145,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95145,30.94,0.07,15.4,40060,NULL,NULL,'I','MESSIER 049',NULL,'1997AJ....114..626A',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95146,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95146,30.94,0.09,15.4,40060,NULL,NULL,'I','MESSIER 049',NULL,'2000ApJ...536..255N',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95147,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95147,31,NULL,15.6,40060,NULL,NULL,'I','MESSIER 049',NULL,'1989ApJ...346L..57T',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95148,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95148,30.97,0.12,15.6,40060,NULL,NULL,'I','MESSIER 049',NULL,'1998MNRAS.298..451M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95149,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95149,31.03,0.12,16.1,40060,74.4,NULL,NULL,'MESSIER 049',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95150,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95150,31.06,0.1,16.3,40060,NULL,NULL,NULL,'MESSIER 049',NULL,'2001ApJ...550..503J',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95151,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95151,31.06,0.1,16.3,40060,NULL,NULL,'I','MESSIER 049',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95152,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95152,31.06,0.1,16.3,40060,NULL,NULL,NULL,'MESSIER 049',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95153,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95153,31.08,0.1,16.4,40060,NULL,NULL,'Malmquist cor.','MESSIER 049',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95154,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95154,31.11,0.13,16.7,40060,NULL,NULL,'HST KP Calibrated, I','MESSIER 049',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95155,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95155,31.12,0.08,16.7,40060,NULL,NULL,'HST ACS VCS','MESSIER 049',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95156,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95156,31.17,0.07,17.1,40060,NULL,NULL,NULL,'MESSIER 049',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95157,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95157,31.18,0.06,17.2,40060,NULL,NULL,'I','MESSIER 049',NULL,'1990AJ....100.1416T',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95158,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95158,31.24,0.13,17.7,40060,NULL,NULL,'HST KP Calibrated, F814W','MESSIER 049',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95159,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95159,31.25,0.17,17.8,40060,NULL,NULL,'HST KP Calibrated, Ks','MESSIER 049',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95160,'GC radius','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95160,31.01,0.06,15.9,40060,NULL,NULL,NULL,'MESSIER 049',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95161,'D-Sigma','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95161,31.13,0.4,16.8,40060,75,NULL,'Edat, raw','MESSIER 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95162,'D-Sigma','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95162,31.15,0.4,17,40060,75,NULL,'Edat, cor','MESSIER 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95163,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95163,30.08,0.46,10.4,40060,95,NULL,'Michard 1979a','MESSIER 049',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95164,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95164,30.13,0.28,10.6,40060,95,NULL,'Weighted Mean','MESSIER 049',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95165,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95165,30.17,0.45,10.8,40060,95,NULL,'de Vaucouleurs','MESSIER 049',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95166,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95166,30.27,0.63,11.3,40060,95,NULL,'Michard 1979b, c','MESSIER 049',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95167,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95167,30.35,NULL,11.7,40060,NULL,NULL,'LEDA [April 2006]','MESSIER 049',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95168,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95168,31.31,0.81,18.3,40060,55,NULL,'Visvanathan & Sandage 1979','MESSIER 049',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95169,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95169,30.35,0.41,11.8,40060,NULL,NULL,NULL,'MESSIER 049',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95170,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95170,30.67,0.41,13.6,40060,NULL,NULL,'Malmquist cor.','MESSIER 049',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95171,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95171,30.67,NULL,13.6,40060,NULL,NULL,NULL,'MESSIER 049',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95172,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95172,31.03,0.12,16.1,40060,74.4,NULL,NULL,'MESSIER 049',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95173,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95173,31.18,NULL,17.2,40060,NULL,NULL,NULL,'MESSIER 049',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95174,'Tertiary','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95174,30.49,0.25,12.5,40060,95,NULL,NULL,'MESSIER 049',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95175,'Tully est','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95175,31.13,0.8,16.8,40060,75,NULL,'B','MESSIER 049',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95176,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95176,31.02,0.04,16,40061,NULL,NULL,'HST KP Calibrated','NGC 4472 GROUP',NULL,'2000ApJ...529..745F',2000,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,187.4457083,8.00208,0,NULL,58250177958,910159030,14221234,NULL),(95177,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95177,31.18,0.12,17.2,40061,NULL,NULL,'HST KP Calibrated, K\'','NGC 4472 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95178,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95178,31.3,0.27,18.2,40061,NULL,NULL,'HST KP Calibrated, V','NGC 4472 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95179,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95179,31.71,0.55,22,40061,NULL,NULL,'HST KP Calibrated, B','NGC 4472 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95180,'PNLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95180,30.79,0.15,14.4,40061,NULL,NULL,'HST KP Calibrated','NGC 4472 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95181,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95181,31.01,0.12,15.9,40061,NULL,NULL,'HST KP Calibrated, Ks','NGC 4472 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95182,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95182,31.07,0.08,16.4,40061,NULL,NULL,'HST KP Calibrated, I','NGC 4472 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95183,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95183,31.24,0.13,17.7,40061,NULL,NULL,'HST KP Calibrated, F814W','NGC 4472 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95184,'IRAS','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95184,35.12,0.8,106,40062,75,NULL,'A82, H','NGC 4475',NULL,'1997ApJS..109..333W',1997,1,1.65,NULL,'G',0.000007,NULL,'14.3g',0.87,'SAbc',NULL,NULL,NULL,NULL,1,187.44825,27.24333,0.06,NULL,58610795397,915793678,14309276,14.3),(95185,'IRAS','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95185,35.14,0.8,106,40062,75,NULL,'CF, r','NGC 4475',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95186,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95186,34.29,0.33,72.2,40062,91,NULL,'H','NGC 4475',NULL,'1984ApJ...278..475B',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95187,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95187,34.81,0.35,91.7,40062,NULL,NULL,NULL,'NGC 4475',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95188,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95188,34.84,0.34,93,40062,NULL,NULL,'Malmquist cor.','NGC 4475',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95189,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95189,34.91,0.47,96,40062,75,NULL,'A82, H, raw','NGC 4475',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95190,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95190,34.92,0.2,96.4,40062,74.4,NULL,NULL,'NGC 4475',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95191,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95191,35.09,0.47,104,40062,75,NULL,'A82, H, inv','NGC 4475',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95192,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95192,35.13,0.38,106,40062,75,NULL,'CF, r, raw','NGC 4475',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95193,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95193,35.14,0.47,107,40062,75,NULL,'A82, H, cor','NGC 4475',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95194,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95194,35.23,0.38,111,40062,75,NULL,'CF, r, cor','NGC 4475',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95195,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95195,35.33,0.38,116,40062,75,NULL,'CF, r, inv','NGC 4475',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95196,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95196,36.73,0.46,221,40063,70,NULL,NULL,'2MASX J12294867+3129558',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.0001,NULL,'15.6g',0.45,NULL,NULL,NULL,NULL,NULL,1,187.452667,31.49878,0.02,NULL,58777098907,918392170,14349877,15.6),(95197,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95197,30.63,0.15,13.4,40064,NULL,NULL,'blue GCs, TOM(V) = -7.17 mag','NGC 4473',NULL,'2001AJ....121.2974L',2001,1,4.5,NULL,'G',0.000006,NULL,'11.16',2.5,'E5','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.453625,13.42936,0.059,NULL,58166230658,908847354,14200739,11.16),(95198,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95198,30.91,0.08,15.2,40064,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4473',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95199,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95199,30.92,0.09,15.2,40064,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4473',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95200,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95200,30.99,0.09,15.8,40064,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4473',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95201,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95201,31.1,0.08,16.6,40064,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4473',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95202,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95202,31.29,0.12,18.1,40064,NULL,NULL,'all GCs, TOM(V) = -7.63 mag','NGC 4473',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95203,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95203,31.32,0.08,18.4,40064,NULL,NULL,NULL,'NGC 4473',NULL,'2001AJ....121.2950K',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95204,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95204,31.41,0.15,19.1,40064,NULL,NULL,'red GCs, TOM(V) = -7.55 mag','NGC 4473',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95205,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95205,30.88,0.12,15,40064,74.4,NULL,NULL,'NGC 4473',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95206,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95206,30.92,0.07,15.2,40064,NULL,NULL,'HST ACS VCS','NGC 4473',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95207,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95207,30.92,0.06,15.3,40064,NULL,NULL,NULL,'NGC 4473',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95208,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95208,30.93,0.11,15.3,40064,NULL,NULL,'I','NGC 4473',NULL,'1997AJ....114..626A',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95209,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95209,30.98,0.13,15.7,40064,NULL,NULL,'I','NGC 4473',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95210,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95210,30.98,0.13,15.7,40064,NULL,NULL,NULL,'NGC 4473',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95211,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95211,31.01,0.13,15.9,40064,NULL,NULL,'Malmquist cor.','NGC 4473',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95212,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95212,31.04,0.16,16.1,40064,NULL,NULL,'HST KP Calibrated, I','NGC 4473',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95213,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95213,31.07,0.11,16.4,40064,NULL,NULL,'I','NGC 4473',NULL,'2000ApJ...536..255N',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95214,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95214,31.11,0.13,16.7,40064,NULL,NULL,'HST KP Calibrated, F814W','NGC 4473',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95215,'GC radius','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95215,30.94,0.06,15.4,40064,NULL,NULL,NULL,'NGC 4473',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95216,'D-Sigma','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95216,31.13,0.4,16.8,40064,75,NULL,'Edat, raw','NGC 4473',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95217,'D-Sigma','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95217,31.15,0.4,17,40064,75,NULL,'Edat, cor','NGC 4473',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95218,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95218,30.47,0.36,12.4,40064,95,NULL,'de Vaucouleurs','NGC 4473',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95219,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95219,30.66,0.26,13.6,40064,95,NULL,'Weighted Mean','NGC 4473',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95220,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95220,30.8,NULL,14.5,40064,NULL,NULL,'LEDA [April 2006]','NGC 4473',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95221,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95221,31.01,0.63,15.9,40064,95,NULL,'Michard 1979b, c','NGC 4473',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95222,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95222,31.25,0.46,17.8,40064,95,NULL,'Michard 1979a','NGC 4473',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95223,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95223,31.78,0.81,22.7,40064,55,NULL,'Visvanathan & Sandage 1979','NGC 4473',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95224,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95224,30.19,NULL,10.9,40064,NULL,NULL,NULL,'NGC 4473',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95225,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95225,30.59,NULL,13.1,40064,NULL,NULL,NULL,'NGC 4473',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95226,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95226,30.67,0.41,13.6,40064,NULL,NULL,NULL,'NGC 4473',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95227,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95227,30.88,0.12,15,40064,74.4,NULL,NULL,'NGC 4473',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95228,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95228,30.94,0.41,15.4,40064,NULL,NULL,'Malmquist cor.','NGC 4473',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95229,'Tertiary','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95229,30.49,0.25,12.5,40064,95,NULL,NULL,'NGC 4473',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95230,'Tully est','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95230,31.13,0.8,16.8,40064,75,NULL,'B','NGC 4473',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95231,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95231,30.9,0.45,15.1,40064,NULL,NULL,'K','NGC 4473',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95232,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95232,32.61,0.4,33.2,40064,NULL,NULL,'mean','NGC 4473',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95233,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95233,36.85,0.46,235,40065,70,NULL,NULL,'VPC 0688',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000186,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,187.458083333,12.03981,0.06,NULL,58160061398,908750959,14199233,16.4),(95234,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95234,37.87,0.1,375,40066,70,NULL,NULL,'VPCX 26',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,187.4600417,11.75808,0.05,NULL,58160016417,908750256,14199222,17.9),(95235,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95235,37.86,0.46,373,40067,70,NULL,NULL,'SDSS J122951.08+092828.0',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,187.462875,9.47447,0,NULL,58244714959,910073671,14219901,17.4),(95236,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95236,37.87,0.1,375,40068,70,NULL,NULL,'VPC 0697',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.00037,NULL,'15.6',0.4,'E',NULL,NULL,NULL,NULL,1,187.467958333,11.78036,0.05,NULL,58160017139,908750267,14199222,15.6),(95237,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95237,36.95,0.46,245,40069,70,NULL,NULL,'2MASX J12295268+2124146',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.24',0.25,NULL,NULL,NULL,NULL,NULL,1,187.4695,21.40422,0.053,NULL,58913180476,920518444,14383100,17.24),(95238,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95238,36.03,0.46,161,40070,70,NULL,NULL,'MCG +10-18-056',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000168,NULL,'15.7g',0.47,'E/S0',NULL,NULL,NULL,NULL,1,187.470417,57.7255,0,NULL,57409194247,897018660,14015916,15.7),(95239,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95239,37.45,0.33,309,40071,70,NULL,NULL,'2MASX J12295317+3042498',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,187.4714583,30.71394,0,NULL,58777347424,918396053,14349938,17.4),(95240,'Brightest Stars','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95240,29.52,NULL,8,40072,NULL,NULL,NULL,'UGC 07639',NULL,'1998A&AS..128..459M',1998,1,2.3,NULL,'G',0.000017,NULL,'14.3',1.6,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,187.4725,47.53111,0,NULL,59068012512,922937695,14420901,14.3),(95241,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95241,29.27,0.16,7.1,40072,NULL,NULL,'R','UGC 07639',NULL,'2005A&A...437..823R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95242,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95242,28.82,0.4,5.8,40072,75,NULL,'B','UGC 07639',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95243,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95243,30.93,0.11,15.3,40073,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4474',NULL,'2010ApJ...717..603V',2010,1,2.11,NULL,'G',0.000017,NULL,'12.5g',1.12,'S0 pec:','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.473125,14.06858,0.081,NULL,58165882251,908841910,14200654,12.5),(95244,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95244,30.94,0.13,15.4,40073,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4474',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95245,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95245,31.02,0.13,16,40073,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4474',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95246,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95246,31.17,0.12,17.1,40073,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4474',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95247,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95247,30.74,0.12,14.1,40073,74.4,NULL,NULL,'NGC 4474',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95248,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95248,30.95,0.08,15.5,40073,NULL,NULL,'HST ACS VCS','NGC 4474',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95249,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95249,30.96,0.07,15.6,40073,NULL,NULL,NULL,'NGC 4474',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95250,'GC radius','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95250,30.82,0.06,14.6,40073,NULL,NULL,NULL,'NGC 4474',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95251,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95251,30.74,0.12,14.1,40073,74.4,NULL,NULL,'NGC 4474',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95252,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95252,30.9,NULL,15.1,40073,NULL,NULL,NULL,'NGC 4474',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95253,'Tully est','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95253,31.13,0.8,16.8,40073,75,NULL,'B','NGC 4474',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95254,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95254,30.5,0.45,12.6,40073,NULL,NULL,'K','NGC 4474',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95255,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95255,31.82,0.4,23.1,40073,NULL,NULL,'mean','NGC 4474',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95256,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95256,37.87,0.1,375,40074,70,NULL,NULL,'VPC 0699',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,187.4735,11.84533,0.05,NULL,58159975883,908749623,14199212,17.7),(95257,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95257,36.64,0.46,213,40075,70,NULL,NULL,'2MASX J12295415+2743092',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,187.4755,27.71931,0.059,NULL,58607342624,915739728,14308433,17.3),(95258,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95258,37.44,0.33,308,40076,70,NULL,NULL,'2MASX J12295551+6545198',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000179,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,187.481166667,65.75542,0,NULL,57320704335,895636005,13994312,16.9),(95259,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95259,37.91,0.08,383,40077,70,NULL,NULL,'2MASX J12295563+0842471',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000183,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,187.481875,8.71306,0,NULL,58244967511,910077617,14219962,16.9),(95260,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95260,37.99,0.46,397,40078,70,NULL,NULL,'2MASX J12295581+3020318',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,187.48275,30.34219,0.019,NULL,58778409354,918412646,14350197,17.2),(95261,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95261,35.81,0.2,145,40079,74.4,NULL,NULL,'IC 3425',NULL,'2013AJ....146...86T',2013,1,0.96,NULL,'G',0.000003,NULL,'15.3g',0.51,'Sb(s)I-II','Group member',NULL,NULL,NULL,1,187.4849583,10.61533,0.022,NULL,58191571133,909243298,14206926,15.3),(95262,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95262,36.07,0.46,164,40080,70,NULL,NULL,'2MASX J12295671+0835381',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000192,NULL,'15.6g',0.46,NULL,NULL,NULL,NULL,NULL,1,187.486333,8.59394,0,NULL,58244757424,910074334,14219911,15.6),(95263,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95263,37.61,0.46,333,40081,70,NULL,NULL,'2MASX J12295825+0945141',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,187.492625,9.75378,0,NULL,58244504199,910070378,14219849,17.1),(95264,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95264,30.78,0.15,14.3,40082,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4476',NULL,'2010ApJ...717..603V',2010,1,1.67,NULL,'G',0.000017,NULL,'13.0g',1.14,'SA(r)0-:','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.496166667,12.34867,0.088,NULL,58159636926,908744326,14199130,13),(95265,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95265,30.79,0.16,14.4,40082,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4476',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95266,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95266,31.01,0.17,15.9,40082,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4476',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95267,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95267,31.14,0.15,16.9,40082,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4476',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95268,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95268,31.42,0.35,19.2,40082,NULL,NULL,NULL,'NGC 4476',NULL,'1997ApJ...483..745N',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95269,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95269,31.18,0.17,17.2,40082,NULL,NULL,'I','NGC 4476',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95270,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95270,31.22,0.14,17.5,40082,74.4,NULL,NULL,'NGC 4476',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95271,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95271,31.23,0.07,17.6,40082,NULL,NULL,NULL,'NGC 4476',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95272,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95272,31.24,0.08,17.7,40082,NULL,NULL,'HST ACS VCS','NGC 4476',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95273,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95273,31.6,0.16,20.9,40082,NULL,NULL,'I','NGC 4476',NULL,'2000ApJ...536..255N',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95274,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95274,31.61,NULL,21,40082,NULL,NULL,NULL,'NGC 4476',NULL,'1999LNP...530...50N',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95275,'GC radius','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95275,30.54,0.34,12.8,40082,NULL,NULL,NULL,'NGC 4476',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95276,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95276,30.25,0.65,11.2,40082,95,NULL,'Weighted Mean','NGC 4476',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95277,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95277,31.29,0.81,18.1,40082,55,NULL,'Visvanathan & Sandage 1979','NGC 4476',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95278,'Tertiary','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95278,30.49,0.25,12.5,40082,95,NULL,NULL,'NGC 4476',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95279,'Tully est','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95279,31.13,0.8,16.8,40082,75,NULL,'B','NGC 4476',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95280,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95280,32.08,0.45,26.1,40082,NULL,NULL,'K','NGC 4476',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95281,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95281,32.5,0.4,31.6,40082,NULL,NULL,'mean','NGC 4476',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95282,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95282,37.74,0.46,353,40083,70,NULL,NULL,'VPC 0707',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000181,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,187.498917,11.11539,0.02,NULL,58191031650,909234869,14206794,16.6),(95283,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95283,38.4,0.46,479,40084,70,NULL,NULL,'SDSS J123000.46+453605.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000162,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,187.5019583,45.6015,0,NULL,59066938869,922920919,14420639,18.2),(95284,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95284,28.58,NULL,5.2,40085,NULL,NULL,NULL,'UGC 07636',NULL,'2013AJ....145..101K',2013,1,1.1,NULL,'G',0.000003,NULL,'14.80',0.9,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,187.504041667,7.92936,0,NULL,58250168920,910158889,14221232,14.8),(95285,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95285,30.54,0.46,12.8,40086,95,NULL,'de Vaucouleurs','NGC 4477',NULL,'1984ApJS...56...91D',1984,1,3.8,NULL,'G',0.000017,NULL,'11.38',3.5,'SB(s)0:?       Sy2','in a radial-velocity based grouping',NULL,NULL,'Sy 2',1,187.509167,13.63661,0.02,NULL,58165947331,908842927,14200670,11.38),(95286,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95286,30.99,0.29,15.8,40086,95,NULL,'Weighted Mean','NGC 4477',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95287,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95287,31.51,0.46,20,40086,95,NULL,'Michard 1979a','NGC 4477',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95288,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95288,31.64,0.63,21.3,40086,95,NULL,'Michard 1979b, c','NGC 4477',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95289,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95289,32.5,0.81,31.6,40086,55,NULL,'Visvanathan & Sandage 1979','NGC 4477',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95290,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95290,31.08,NULL,16.4,40086,NULL,NULL,NULL,'NGC 4477',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95291,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95291,31.48,0.25,19.8,40086,74.4,NULL,NULL,'NGC 4477',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95292,'Tertiary','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95292,30.49,0.25,12.5,40086,95,NULL,NULL,'NGC 4477',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95293,'Tully est','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95293,31.13,0.8,16.8,40086,75,NULL,'B','NGC 4477',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95294,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95294,31.66,0.4,21.5,40086,NULL,NULL,'mean','NGC 4477',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95295,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95295,31.82,0.45,23.1,40086,NULL,NULL,'K','NGC 4477',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95296,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95296,37.87,0.1,375,40087,70,NULL,NULL,'VPC 0710',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'18.41',0.26,NULL,NULL,NULL,NULL,NULL,1,187.51175,11.65331,0.03,NULL,58160041245,908750644,14199228,18.41),(95297,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95297,37.4,0.46,303,40088,70,NULL,NULL,'2MASX J12300287+2824071',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000151,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,187.511917,28.40206,0.041,NULL,58607195298,915737426,14308397,17),(95298,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95298,37.87,0.1,375,40089,70,NULL,NULL,'SDSS J123004.42+115117.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000162,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,187.518458333,11.85492,0.05,NULL,58159967154,908749486,14199210,18.4),(95299,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95299,37.54,0.23,322,40090,70,NULL,NULL,'VPC 0713',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,187.5197917,13.44225,0.059,NULL,58166352233,908849253,14200769,17.8),(95300,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95300,31.82,0.4,23.1,40091,NULL,NULL,'mean','VIII Zw 189',NULL,'2007A&A...465...71T',2007,1,0.72,NULL,'G',0.000061,NULL,'15.5g',0.69,'dE0,N','Group member',NULL,NULL,NULL,1,187.521125,8.07333,0,NULL,58250225166,910159768,14221246,15.5),(95301,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95301,32.67,0.45,34.2,40091,NULL,NULL,'K','VIII Zw 189',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95302,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95302,37.44,0.46,308,40092,70,NULL,NULL,'VPC 0717',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000152,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,187.52575,10.83078,0.019,NULL,58191075978,909235562,14206805,17),(95303,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95303,37.14,0.27,268,40093,70,NULL,NULL,'2MASX J12300626+0301519',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000189,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,187.526083333,3.03094,0.018,NULL,58005744718,906339761,14161558,16.8),(95304,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95304,38.32,0.46,461,40094,70,NULL,NULL,'2MASX J12300639+2436471',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,187.526667,24.613,0.037,NULL,58615328401,915864506,14310382,17.2),(95305,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95305,37.61,0.46,333,40095,70,NULL,NULL,'SDSS J123007.22-020536.9',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000069,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,187.530125,-2.09361,0.069,NULL,42999847674,671872619,10498009,17.8),(95306,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95306,36.82,0.46,231,40096,70,NULL,NULL,'2MASX J12300786+0309339',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000156,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,187.532833,3.15956,0.018,NULL,58006021515,906344086,14161626,16.4),(95307,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95307,37.89,0.46,379,40097,70,NULL,NULL,'2MASX J12300852+2342582',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,187.535625,23.71608,0.037,NULL,58611678408,915807475,14309491,18),(95308,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95308,37.97,0.46,392,40098,70,NULL,NULL,'SDSS J123008.70+541124.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,187.53625,54.19025,0,NULL,57222227037,894097297,13970270,18.6),(95309,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95309,31.16,0.28,17.1,40099,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4482',NULL,'2010ApJ...717..603V',2010,1,1.41,NULL,'G',0.000053,NULL,'13.9g',0.84,'dE5,N','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.5430417,10.77947,0.019,NULL,58191085392,909235709,14206807,13.9),(95310,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95310,31.24,0.35,17.7,40099,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4482',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95311,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95311,31.46,0.36,19.6,40099,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4482',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95312,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95312,31.53,0.33,20.2,40099,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4482',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95313,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95313,31.28,0.14,18,40099,74.4,NULL,NULL,'NGC 4482',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95314,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95314,31.29,0.06,18.1,40099,NULL,NULL,NULL,'NGC 4482',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95315,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95315,31.3,0.07,18.2,40099,NULL,NULL,'HST ACS VCS','NGC 4482',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95316,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95316,31.34,0.16,18.5,40099,NULL,NULL,'R','NGC 4482',NULL,'2004AJ....127..771J',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95317,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95317,31.74,0.21,22.3,40099,NULL,NULL,'R','NGC 4482',NULL,'2004AJ....127..771J',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95318,'GC radius','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95318,30.94,0.12,15.4,40099,NULL,NULL,NULL,'NGC 4482',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95319,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95319,30.85,0.45,14.8,40099,NULL,NULL,'K','NGC 4482',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95320,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95320,32.16,0.4,27,40099,NULL,NULL,'mean','NGC 4482',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95321,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95321,37.87,0.1,375,40100,70,NULL,NULL,'VPC 0723',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,187.5470417,11.80489,0.05,NULL,58159967784,908749496,14199210,17.4),(95322,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95322,37.41,0.46,304,40101,70,NULL,NULL,'SDSS J123011.42-021703.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000067,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,187.547625,-2.28436,0.061,NULL,42999602686,671868791,10497949,18),(95323,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95323,35.79,0.46,144,40102,70,NULL,NULL,'CGCG 244-025',NULL,'2015arXiv151105856S',2015,1,0.98,NULL,'G',0.000255,NULL,'14.5g',0.88,'E              AGN?',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,187.549375,47.00628,0,NULL,59068370613,922943290,14420988,14.5),(95324,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95324,37.54,0.23,322,40103,70,NULL,NULL,'VPC 0726',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000171,NULL,'16.9g',0.21,'BrClG',NULL,NULL,NULL,NULL,1,187.5529583,13.45528,0.02,NULL,58166351636,908849244,14200769,16.9),(95325,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95325,37.87,0.1,375,40104,70,NULL,NULL,'VPC 0727',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000123,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,187.5555,11.74467,0.05,NULL,58160048436,908750756,14199230,17.9),(95326,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95326,38.22,0.46,440,40105,70,NULL,NULL,'SDSS J123013.36+063114.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,187.555666667,6.52083,0,NULL,58235203519,909925054,14217578,18.5),(95327,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95327,37.54,0.23,322,40106,70,NULL,NULL,'VPC 0731',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,187.5610417,13.38789,0.059,NULL,58166222906,908847232,14200738,17.6),(95328,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95328,37.58,0.46,328,40107,70,NULL,NULL,'2MASX J12301508+6632420',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000074,NULL,'17.2g',0.21,'BrClG',NULL,NULL,NULL,NULL,1,187.562583333,66.54494,0.029,NULL,57324636128,895697439,13995272,17.2),(95329,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95329,37.39,0.46,301,40108,70,NULL,NULL,'2MASX J12301616+3352418',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,187.5672083,33.87811,NULL,NULL,58771509417,918304834,14348513,17.5),(95330,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95330,38.43,0.46,486,40109,70,NULL,NULL,'2MASX J12301706+3000498',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,187.570916667,30.01383,0.034,NULL,58778294301,918410848,14350169,18.3),(95331,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95331,37.34,0.46,294,40110,70,NULL,NULL,'VPC 0738',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,187.57175,15.21139,0.069,NULL,58156492362,908695193,14198362,17.7),(95332,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95332,30.85,0.11,14.8,40111,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4478',NULL,'2010ApJ...717..603V',2010,1,1.9,'Multiple SDSS entries describe this object.','G',0.000011,NULL,'12.36',1.6,'E2','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.572583,12.32856,0.088,NULL,58159783428,908746616,14199165,12.36),(95333,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95333,30.87,0.11,14.9,40111,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4478',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95334,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95334,31.01,0.11,15.9,40111,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4478',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95335,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95335,31.08,0.38,16.4,40111,NULL,NULL,NULL,'NGC 4478',NULL,'2000ApJ...533..125K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95336,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95336,31.07,0.45,16.4,40111,NULL,NULL,NULL,'NGC 4478',NULL,'1997ApJ...483..745N',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95337,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95337,31.15,0.11,17,40111,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4478',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95338,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95338,31.34,0.46,18.5,40111,NULL,NULL,'HST KP Calibrated, V','NGC 4478',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95339,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95339,30.31,0.2,11.5,40111,NULL,NULL,'I','NGC 4478',NULL,'1990AJ....100.1416T',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95340,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95340,30.6,NULL,13.2,40111,NULL,NULL,'I','NGC 4478',NULL,'1989ApJ...346L..57T',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95341,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95341,30.89,0.13,15.1,40111,NULL,NULL,'I','NGC 4478',NULL,'1997ApJ...483..745N',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95342,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95342,31.02,NULL,16,40111,NULL,NULL,NULL,'NGC 4478',NULL,'1999LNP...530...50N',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95343,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95343,31.1,0.11,16.4,40111,NULL,NULL,'I','NGC 4478',NULL,'2000ApJ...536..255N',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95344,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95344,31.08,0.12,16.4,40111,74.4,NULL,NULL,'NGC 4478',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95345,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95345,31.15,0.06,17,40111,NULL,NULL,NULL,'NGC 4478',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95346,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95346,31.17,0.1,17.1,40111,NULL,NULL,'K','NGC 4478',NULL,'1994ApJ...433..567P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95347,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95347,31.16,0.07,17.1,40111,NULL,NULL,'HST ACS VCS','NGC 4478',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95348,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95348,31.24,0.17,17.7,40111,NULL,NULL,'HST KP Calibrated, Ks','NGC 4478',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95349,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95349,31.29,0.28,18.1,40111,NULL,NULL,'I','NGC 4478',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95350,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95350,31.29,0.28,18.1,40111,NULL,NULL,NULL,'NGC 4478',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95351,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95351,31.35,0.29,18.6,40111,NULL,NULL,'HST KP Calibrated, I','NGC 4478',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95352,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95352,31.37,0.28,18.8,40111,NULL,NULL,'Malmquist cor.','NGC 4478',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95353,'GC radius','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95353,30.64,0.1,13.4,40111,NULL,NULL,NULL,'NGC 4478',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95354,'D-Sigma','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95354,31.13,0.4,16.8,40111,75,NULL,'Edat, raw','NGC 4478',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95355,'D-Sigma','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95355,31.15,0.4,17,40111,75,NULL,'Edat, cor','NGC 4478',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95356,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95356,29.74,0.53,8.87,40111,95,NULL,'de Vaucouleurs','NGC 4478',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95357,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95357,30.35,0.3,11.7,40111,95,NULL,'Weighted Mean','NGC 4478',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95358,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95358,30.47,0.63,12.4,40111,95,NULL,'Michard 1979b, c','NGC 4478',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95359,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95359,31.25,0.81,17.8,40111,55,NULL,'Visvanathan & Sandage 1979','NGC 4478',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95360,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95360,31.4,0.46,19.1,40111,95,NULL,'Michard 1979a','NGC 4478',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95361,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95361,30.69,0.41,13.7,40111,NULL,NULL,NULL,'NGC 4478',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95362,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95362,30.82,NULL,14.6,40111,NULL,NULL,NULL,'NGC 4478',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95363,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95363,30.89,NULL,15.1,40111,NULL,NULL,NULL,'NGC 4478',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95364,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95364,30.96,0.41,15.5,40111,NULL,NULL,'Malmquist cor.','NGC 4478',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95365,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95365,31.08,0.12,16.4,40111,74.4,NULL,NULL,'NGC 4478',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95366,'Tertiary','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95366,30.49,0.25,12.5,40111,95,NULL,NULL,'NGC 4478',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95367,'Tully est','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95367,31.13,0.8,16.8,40111,75,NULL,'B','NGC 4478',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95368,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95368,31.73,0.45,22.2,40111,NULL,NULL,'K','NGC 4478',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95369,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95369,31.84,0.4,23.3,40111,NULL,NULL,'mean','NGC 4478',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95370,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95370,37.11,0.46,264,40112,70,NULL,NULL,'VPC 0737',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,187.574333,11.469,0.021,NULL,58159822788,908747231,14199175,17.7),(95371,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95371,35.08,0.49,104,40113,70,NULL,NULL,'MCG -01-32-018',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000097,NULL,'15.54',1.1,'(R\')SA(s)0/a?',NULL,NULL,NULL,NULL,1,187.576417,-5.96203,0.057,NULL,43203855602,675060243,10547816,15.54),(95372,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95372,31.25,0.15,17.8,40114,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4479',NULL,'2010ApJ...717..603V',2010,1,1.38,NULL,'G',0.000033,NULL,'13.4g',1.1,'SB(s)0^0^:?','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.5765417,13.57764,0.02,NULL,58165911685,908842370,14200662,13.4),(95373,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95373,31.26,0.17,17.8,40114,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4479',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95374,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95374,31.46,0.18,19.6,40114,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4479',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95375,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95375,31.55,0.17,20.4,40114,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4479',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95376,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95376,31.2,0.06,17.4,40114,NULL,NULL,NULL,'NGC 4479',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95377,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95377,31.2,0.07,17.4,40114,NULL,NULL,'HST ACS VCS','NGC 4479',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95378,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95378,31.28,0.12,18,40114,74.4,NULL,NULL,'NGC 4479',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95379,'GC radius','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95379,31.07,0.13,16.4,40114,NULL,NULL,NULL,'NGC 4479',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95380,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95380,31.28,0.12,18,40114,74.4,NULL,NULL,'NGC 4479',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95381,'Tully est','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95381,31.13,0.8,16.8,40114,75,NULL,'B','NGC 4479',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95382,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95382,31.28,0.4,18.1,40114,NULL,NULL,'mean','NGC 4479',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95383,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95383,31.7,0.45,21.9,40114,NULL,NULL,'K','NGC 4479',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95384,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95384,33.83,0.49,58.3,40115,70,NULL,NULL,'2MASX J12301849-4943598',NULL,'2014MNRAS.445.2677S',2014,1,0.19,NULL,'G',0.00015,NULL,'15.7b',NULL,'E?',NULL,NULL,NULL,NULL,1,187.577167,-49.73333,0.717,NULL,44618709155,697167330,10893239,15.7),(95385,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95385,37.32,0.46,291,40116,70,NULL,NULL,'SDSS J123018.95-021835.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000069,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,187.579,-2.30989,0.061,NULL,42997539056,671836547,10497446,18.1),(95386,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95386,37.44,0.46,308,40117,70,NULL,NULL,'SDSS J123019.74+214957.3',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.73',0.21,NULL,NULL,NULL,NULL,NULL,1,187.5822917,21.83261,0.047,NULL,58912520844,920508138,14382939,18.73),(95387,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95387,36.86,0.46,236,40118,70,NULL,NULL,'2MASX J12302024+2817032',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000143,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,187.584333333,28.28417,0.067,NULL,58607867612,915747931,14308561,16.3),(95388,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95388,33.71,0.49,55.2,40119,75,NULL,'IR','UGC 07644',NULL,'2011yCatp016004901K',2011,1,2.4,NULL,'G',0.000033,NULL,'14.5g',0.4,'Scd(f)','Group member',NULL,NULL,NULL,1,187.58625,3.74014,0.028,NULL,58227004360,909796943,14215577,14.5),(95389,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95389,33.82,0.2,58.1,40119,74.4,NULL,NULL,'UGC 07644',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95390,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95390,33.97,0.47,62.1,40119,NULL,NULL,NULL,'UGC 07644',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95391,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95391,34.01,0.46,63.2,40119,NULL,NULL,'Malmquist cor.','UGC 07644',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95392,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95392,36.38,0.46,189,40120,70,NULL,NULL,'2MASX J12302100+4220008',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,187.587583,42.33353,0,NULL,59063824905,922872264,14419879,17.1),(95393,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95393,37.87,0.1,375,40121,70,NULL,NULL,'VPC 0744',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00015,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,187.590417,11.75156,0.05,NULL,58159995940,908749936,14199217,17),(95394,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95394,38.09,0.46,415,40122,70,NULL,NULL,'SDSS J123022.32+084526.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,187.5930417,8.75736,0,NULL,58244931602,910077056,14219954,18.2),(95395,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95395,37.44,0.46,308,40123,70,NULL,NULL,'2MASX J12302369+6153269',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,187.598791667,61.89083,0,NULL,57375894969,896498358,14007786,17.9),(95396,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95396,36.89,0.46,239,40124,70,NULL,NULL,'2MASX J12302375+5801578',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,187.5989583,58.03278,0,NULL,57409120879,897017513,14015898,17.2),(95397,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95397,36.58,0.46,207,40125,70,NULL,NULL,'2MASX J12302405+2026443',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,187.600166667,20.44564,NULL,NULL,58910353531,920474273,14382410,17.2),(95398,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95398,37.72,0.46,350,40126,70,NULL,NULL,'2MASX J12302447+1012484',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,187.601875,10.21344,0.018,NULL,58191499604,909242181,14206909,17.5),(95399,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95399,37.54,0.23,322,40127,70,NULL,NULL,'VPC 0748',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000162,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,187.604208333,13.46206,0.02,NULL,58166408032,908850125,14200783,17),(95400,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95400,36.05,0.51,162,40128,70,NULL,NULL,'2MASX J12302519-5007599',NULL,'2014MNRAS.445.2677S',2014,1,0.13,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,187.604917,-50.13333,0.853,NULL,44618848177,697169502,10893273,16.5),(95401,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95401,37.87,0.1,375,40129,70,NULL,NULL,'SDSS J123026.32+120614.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000171,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,187.6097083,12.10406,0.09,NULL,58160092416,908751444,14199241,18.4),(95402,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95402,35.02,0.63,101,40130,70,NULL,NULL,'MCG -01-32-020',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.91',0.4,NULL,NULL,NULL,NULL,NULL,1,187.610875,-6.00761,0.037,NULL,43204377406,675068396,10547943,15.91),(95403,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95403,32.64,NULL,33.7,40131,NULL,NULL,NULL,'NGC 4480',NULL,'1999MNRAS.304..595G',1999,1,2.07,NULL,'G',0.000013,NULL,'13.2g',0.96,'SAB(s)c;Sy     LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.611583333,4.24658,0.013,NULL,58227056877,909797763,14215590,13.2),(95404,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95404,32.82,0.47,36.7,40131,NULL,NULL,'Malmquist cor.','NGC 4480',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95405,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95405,32.9,0.4,38.1,40131,NULL,NULL,'mean','NGC 4480',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95406,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95406,33.01,0.36,40,40131,NULL,NULL,NULL,'NGC 4480',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95407,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95407,33.13,0.46,42.2,40131,NULL,NULL,'J','NGC 4480',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95408,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95408,33.15,0.4,42.7,40131,NULL,NULL,NULL,'NGC 4480',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95409,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95409,33.19,0.2,43.5,40131,74.4,NULL,NULL,'NGC 4480',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95410,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95410,33.19,0.47,43.5,40131,NULL,NULL,'H','NGC 4480',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95411,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95411,33.22,0.45,44.1,40131,NULL,NULL,'K','NGC 4480',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95412,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95412,33.36,0.3,46.9,40131,55,NULL,'B','NGC 4480',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95413,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95413,38.16,0.46,429,40132,70,NULL,NULL,'2MASX J12302731+0956074',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,187.613833,9.93536,0.018,NULL,58189198411,909206225,14206347,17.6),(95414,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95414,39.46,0.46,780,40133,70,NULL,NULL,'SDSS J123027.55+341823.8',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,187.614833,34.30661,NULL,NULL,58770822167,918294096,14348345,18.2),(95415,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95415,33.86,0.2,59.2,40134,74.4,NULL,NULL,'IC 3432',NULL,'2013AJ....146...86T',2013,1,0.72,'ASIAGO3 320 is the bar of IC 3432.','G',0.00006,NULL,'14.9g',0.42,'Sc','Group member',NULL,NULL,NULL,1,187.616,14.16019,0.134,NULL,58164832399,908825506,14200398,14.9),(95416,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95416,36.76,0.46,225,40135,70,NULL,NULL,'2MASX J12302837+4514219',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,187.6180417,45.23936,0,NULL,59069301444,922957835,14421216,17.6),(95417,'TRGB','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95417,29.75,0.1,8.91,40136,74.4,NULL,NULL,'NGC 4485',NULL,'2013AJ....146...86T',2013,1,2.3,NULL,'G',0.000023,NULL,'12.32',1.6,'IB(s)m pec     HII','Probable group member',NULL,NULL,NULL,1,187.6297083,41.70117,0,NULL,59060995761,922828058,14419188,12.32),(95418,'Tully est','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95418,29.85,0.8,9.3,40136,75,NULL,'B','NGC 4485',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95419,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95419,37.11,0.46,265,40137,70,NULL,NULL,'2MASX J12303157+4258219',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000122,NULL,'16.8g',0.29,'Sy2',NULL,NULL,NULL,'Sy 2',1,187.631667,42.97283,0,NULL,59061723262,922839425,14419366,16.8),(95420,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95420,30.6,0.11,13.2,40138,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4486B',NULL,'2010ApJ...717..603V',2010,1,0.6,NULL,'G',0.000014,NULL,'14.36',0.6,'cE0','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.633208333,12.49017,0.09,NULL,58159757526,908746211,14199159,14.36),(95421,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95421,30.6,0.12,13.2,40138,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4486B',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95422,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95422,30.7,0.11,13.8,40138,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4486B',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95423,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95423,30.83,0.11,14.7,40138,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4486B',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95424,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95424,31.06,0.03,16.3,40138,NULL,NULL,NULL,'NGC 4486B',NULL,'2001AJ....121.2950K',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95425,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95425,31.02,NULL,16,40138,NULL,NULL,NULL,'NGC 4486B',NULL,'1999LNP...530...50N',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95426,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95426,31.04,0.14,16.1,40138,74.4,NULL,NULL,'NGC 4486B',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95427,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95427,31.06,0.07,16.3,40138,NULL,NULL,NULL,'NGC 4486B',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95428,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95428,31.06,0.08,16.3,40138,NULL,NULL,'HST ACS VCS','NGC 4486B',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95429,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95429,31.14,0.16,16.9,40138,NULL,NULL,'I','NGC 4486B',NULL,'2000ApJ...536..255N',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95430,'Tully est','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95430,31.13,0.8,16.8,40138,75,NULL,'B','NGC 4486B',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95431,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95431,37.87,0.1,375,40139,70,NULL,NULL,'SDSS J123032.57+113258.4',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,187.6357083,11.54958,0.021,NULL,58160036494,908750570,14199227,18.1),(95432,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95432,37.46,0.46,310,40140,70,NULL,NULL,'SDSS J123032.72+382515.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,187.636333333,38.421,0,NULL,58576000514,915250008,14300781,18.1),(95433,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95433,37.6,0.33,331,40141,70,NULL,NULL,'LCRS B122758.6-023902',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000067,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,187.636625,-2.92675,0.065,NULL,42993067283,671766676,10496354,17.9),(95434,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95434,39.27,0.46,715,40142,70,NULL,NULL,'SDSS J123033.65+105716.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000178,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,187.6402083,10.95456,0,NULL,58191212168,909237690,14206838,18),(95435,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95435,37.27,0.46,284,40143,70,NULL,NULL,'SDSS J123034.51+170447.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.8g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,187.643833333,17.07986,0.025,NULL,58883054755,920047730,14375745,17.8),(95436,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95436,37.6,0.33,331,40144,70,NULL,NULL,'LCRS B122801.1-023735',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000075,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,187.64675,-2.90269,0.065,NULL,42993073769,671766777,10496355,17.7),(95437,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95437,38.02,0.46,402,40145,70,NULL,NULL,'LCRS B122802.3-022019',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000091,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,187.651167,-2.61511,0.065,NULL,42997473215,671835518,10497429,17.4),(95438,'Sosies','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95438,29.9,1.16,9.55,40146,NULL,NULL,NULL,'NGC 4490',NULL,'2002A&A...393...57T',2002,1,6.3,NULL,'G',0.00001,NULL,'10.22',3.1,'SB(s)d pec     HII','Pair member (points to parent)',NULL,NULL,NULL,1,187.651,41.64389,0,NULL,59061007771,922828246,14419191,10.22),(95439,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95439,28.14,NULL,4.25,40146,NULL,NULL,'LEDA [April 2006]','NGC 4490',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95440,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95440,28.82,NULL,5.81,40146,NULL,NULL,NULL,'NGC 4490',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95441,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95441,29.17,0.46,6.81,40146,NULL,NULL,'J','NGC 4490',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95442,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95442,29.27,0.45,7.14,40146,NULL,NULL,'K','NGC 4490',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95443,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95443,29.27,0.47,7.16,40146,NULL,NULL,'H','NGC 4490',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95444,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95444,29.46,0.4,7.8,40146,75,NULL,'B','NGC 4490',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95445,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95445,30.02,0.4,10.1,40146,NULL,NULL,'mean','NGC 4490',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95446,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95446,37.87,0.1,375,40147,70,NULL,NULL,'2MASX J12303717+1146014',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000171,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,187.654958333,11.76714,0.05,NULL,58159992776,908749887,14199216,17.9),(95447,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95447,36.97,0.46,248,40148,70,NULL,NULL,'2MASX J12303726+0457323',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000192,NULL,'15.8g',0.41,'E0',NULL,NULL,NULL,NULL,1,187.655083,4.95911,0,NULL,58229395474,909834304,14216161,15.8),(95448,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95448,38.05,0.46,408,40149,70,NULL,NULL,'SDSS J123038.06+105208.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000137,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,187.658583333,10.86889,0.019,NULL,58191188511,909237320,14206833,18.4),(95449,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95449,38.34,0.46,466,40150,70,NULL,NULL,'2MASX J12303866+2556379',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,187.661208333,25.94392,0.063,NULL,58616279806,915879371,14310615,17.7),(95450,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95450,37.1,0.46,263,40151,70,NULL,NULL,'2MASX J12303945+0532433',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,187.6644583,5.54539,0,NULL,58227839269,909809988,14215781,17.2),(95451,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95451,37.84,0.46,370,40152,70,NULL,NULL,'2MASX J12303952-0129418',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000076,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,187.6645417,-1.49497,0.013,NULL,42999351333,671864864,10497888,17.7),(95452,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95452,30.84,0.15,14.7,40153,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4483',NULL,'2007ApJS..171..101J',2007,1,1.74,NULL,'G',0.000017,NULL,'12.9g',0.92,'SB(s)0+:','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.669375,9.01567,0,NULL,58245230986,910081734,14220027,12.9),(95453,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95453,30.88,0.14,15,40153,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4483',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95454,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95454,31.24,0.16,17.7,40153,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4483',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95455,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95455,31.32,0.14,18.4,40153,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4483',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95456,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95456,31.1,0.14,16.6,40153,74.4,NULL,NULL,'NGC 4483',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95457,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95457,31.12,0.07,16.7,40153,NULL,NULL,'HST ACS VCS','NGC 4483',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95458,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95458,31.12,0.06,16.7,40153,NULL,NULL,NULL,'NGC 4483',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95459,'GC radius','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95459,31.01,0.06,15.9,40153,NULL,NULL,NULL,'NGC 4483',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95460,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95460,31.53,NULL,20.2,40153,NULL,NULL,NULL,'NGC 4483',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95461,'Tully est','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95461,31.13,0.8,16.8,40153,75,NULL,'B','NGC 4483',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95462,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95462,36.08,0.46,165,40154,70,NULL,NULL,'2MASX J12304099+6809372',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000075,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,187.6705417,68.16033,0.021,NULL,57849215804,903893996,14123343,16.7),(95463,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95463,36.81,0.46,230,40155,70,NULL,NULL,'2MASX J12304170+2947039',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000157,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,187.67375,29.78436,0.034,NULL,58775446282,918366348,14349474,16.8),(95464,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95464,38.69,0.46,548,40156,70,NULL,NULL,'2MASX J12304183+4532219',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000183,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,187.674291667,45.53933,0,NULL,59066880144,922920002,14420625,17.5),(95465,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95465,38.28,0.33,452,40157,70,NULL,NULL,'2MASX J12304219+3400448',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000195,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,187.675708333,34.01261,NULL,NULL,58771545969,918305405,14348521,16.7),(95466,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95466,37.14,0.27,268,40158,70,NULL,NULL,'2MASX J12304223+0309503',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000173,NULL,'16.0g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,187.675917,3.16389,0.028,NULL,58006002556,906343789,14161621,16),(95467,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95467,37.48,0.46,313,40159,70,NULL,NULL,'2MASX J12304254-0313378',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00008,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,187.67725,-3.22717,0.069,NULL,42993663000,671775984,10496499,17.6),(95468,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95468,37.75,0.46,355,40160,70,NULL,NULL,'2MASX J12304483+3212058',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000103,NULL,'16.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,187.686708333,32.20178,0.02,NULL,58771722069,918308157,14348564,16.4),(95469,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95469,38.28,0.33,452,40161,70,NULL,NULL,'SDSS J123046.15+340223.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000143,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,187.692333,34.03983,NULL,NULL,58771545000,918305390,14348521,18.7),(95470,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95470,38.43,0.27,486,40162,70,NULL,NULL,'SDSS J123047.44+102759.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000139,NULL,'18.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,187.6977083,10.46664,0.024,NULL,58191751901,909246123,14206970,18.5),(95471,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95471,38.35,0.46,468,40163,70,NULL,NULL,'SDSS J123047.62+664527.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000065,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,187.6984583,66.75769,0.029,NULL,57320421529,895631586,13994243,18.5),(95472,'Tully est','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95472,31.13,0.8,16.8,40164,75,NULL,NULL,'VCC 1313',NULL,'1988NBGC.C....0000T',1988,1,0.29,NULL,'G',0.00003,NULL,'16.7g',0.16,'Blue Compact Dwarf','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,187.702166667,12.04503,0.09,NULL,58160273516,908754273,14199285,16.7),(95473,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95473,31.15,NULL,17,40164,NULL,NULL,NULL,'VCC 1313',NULL,'2014A&A...562A..49M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95474,'Brightest Stars','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95474,31.4,0.25,19.1,40165,NULL,NULL,'Photographic, Virgo Cluster, brrightest HII regions, Avg. of 21 spiral galaxies','MESSIER 087',NULL,'1981ApJ...247....9K',1981,1,8.3,NULL,'G',0.000017,NULL,'9.59',6.6,'E+0-1 pec;NLRG Sy','in a radial-velocity based grouping',NULL,'FR I','LINER',1,187.705916667,12.39111,0.09,NULL,58159752795,908746137,14199158,9.59),(95475,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95475,31.04,0.06,16.1,40165,NULL,NULL,'HST KP Calibrated','MESSIER 087',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95476,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95476,31.18,0.1,17.2,40165,NULL,NULL,'HST KP Calibrated, K\'','MESSIER 087',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95477,'CMD','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95477,31.04,0.16,16.1,40165,NULL,NULL,'Avg. for Virgo spiral galaxies','MESSIER 087',NULL,'1982ApJ...257..527T',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95478,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95478,29.82,0.1,9.2,40165,NULL,NULL,'Photographic, TOM(B) = -6.40 mag','MESSIER 087',NULL,'1987AJ.....94..906H',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95479,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95479,29.91,0.1,9.59,40165,NULL,NULL,'Photographic, TOM(B) = -6.40 mag','MESSIER 087',NULL,'1987AJ.....94..906H',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95480,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95480,30.53,0.1,12.8,40165,NULL,NULL,'blue GCs, TOM(V) = -7.17 mag','MESSIER 087',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95481,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95481,30.76,0.24,14.2,40165,NULL,NULL,NULL,'MESSIER 087',NULL,'1997ApJ...483..745N',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95482,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95482,30.81,0.17,14.5,40165,NULL,NULL,NULL,'MESSIER 087',NULL,'1997ApJ...487..667O',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95483,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95483,30.81,0.13,14.5,40165,NULL,NULL,'TOM(I) = -8.53 mag,Harris et al. 1991, Fornax - Virgo = +0.08 mag','MESSIER 087',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95484,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95484,31.02,NULL,16,40165,NULL,NULL,NULL,'MESSIER 087',NULL,'2011ApJ...743..149Y',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95485,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95485,31.03,0.06,16.1,40165,NULL,NULL,'TOM(V) = -7.41 mag(V)','MESSIER 087',NULL,'2006MNRAS.373..588T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95486,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95486,31.07,0.04,16.4,40165,NULL,NULL,'TOM(g) = -7.2 mag','MESSIER 087',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95487,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95487,31.08,0.07,16.4,40165,NULL,NULL,'1057 GCs, TOM(V) = -7.41 mag','MESSIER 087',NULL,'1999ApJ...513..733K',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95488,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95488,31.09,0.04,16.5,40165,NULL,NULL,'TOM(u) = -8.4 mag','MESSIER 087',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95489,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95489,31.12,0.06,16.7,40165,NULL,NULL,NULL,'MESSIER 087',NULL,'1995ApJ...454L..73W',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95490,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95490,31.12,0.04,16.7,40165,NULL,NULL,'TOM(z) = -8.53 mag','MESSIER 087',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95491,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95491,31.12,0.13,16.7,40165,NULL,NULL,'TOM(V) = -7.4 mag,Harris et al. 1991, Fornax - Virgo = +0.08 mag','MESSIER 087',NULL,'1996A&A...309L..39K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95492,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95492,31.13,0.06,16.8,40165,NULL,NULL,'all GCs, TOM(V) = -7.63 mag','MESSIER 087',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95493,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95493,31.13,0.07,16.8,40165,NULL,NULL,'red GCs, TOM(V) = -7.55 mag','MESSIER 087',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95494,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95494,31.22,0.05,17.5,40165,NULL,NULL,'TOM(g) = -7.2 mag','MESSIER 087',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95495,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95495,31.27,0.26,17.9,40165,NULL,NULL,'HST KP Calibrated, V','MESSIER 087',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95496,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95496,31.29,0.23,18.1,40165,NULL,NULL,'HST KP Calibrated, V','MESSIER 087',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95497,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95497,31.4,0.4,19.1,40165,NULL,NULL,NULL,'MESSIER 087',NULL,'1994ApJ...422..486M',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95498,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95498,31.41,0.28,19.1,40165,NULL,NULL,'TOM(V) = -7.62 mag','MESSIER 087',NULL,'1996ApJ...464L..51S',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95499,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95499,31.43,0.3,19.3,40165,NULL,NULL,'TOM(V) = -7.3 mag','MESSIER 087',NULL,'1985AJ.....90..595V',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95500,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95500,31.63,0.13,21.2,40165,NULL,NULL,NULL,'MESSIER 087',NULL,'1991ApJS...76..115H',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95501,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95501,31.7,NULL,21.9,40165,NULL,NULL,'Virgo Cluster, 5 galaxy avg., TOM(B) = -7.0 mag','MESSIER 087',NULL,'1988ASPC....4..231H',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95502,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95502,31.71,0.15,22,40165,NULL,NULL,'TOM(V) = -7.62 mag, Gaussian','MESSIER 087',NULL,'1995ApJ...446....1S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95503,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95503,32.29,NULL,28.7,40165,NULL,NULL,'TOM(B) = -7.0 mag','MESSIER 087',NULL,'1988ASPC....4..231H',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95504,'HII LF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95504,30.9,0.15,15.1,40165,NULL,NULL,'Virgo Cluster, 4 galaxy avg.','MESSIER 087',NULL,'1988MNRAS.235..297M',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95505,'Novae','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95505,31.3,0.4,18.2,40165,NULL,NULL,NULL,'MESSIER 087',NULL,'1990ApJ...350..110C',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95506,'Novae','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95506,31.35,NULL,18.6,40165,NULL,NULL,'Virgo cluster','MESSIER 087',NULL,'1995ApJ...452..704D',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95507,'Novae','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95507,31.35,0.35,18.6,40165,NULL,NULL,'Virgo cluster','MESSIER 087',NULL,'1997eds..proc..186L',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95508,'Novae','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95508,31.4,NULL,19.1,40165,NULL,NULL,NULL,'MESSIER 087',NULL,'1985ApJ...288L..41P',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95509,'Novae','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95509,31.45,NULL,19.5,40165,NULL,NULL,'Virgo cluster','MESSIER 087',NULL,'1987ApJ...318..507P',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95510,'Novae','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95510,31.57,0.43,20.6,40165,NULL,NULL,'Photographic, APPARENT BLUE m-M, Virgo cluster, Avg. novae','MESSIER 087',NULL,'1988ApJ...328....1S',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95511,'PNLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95511,30.71,0.1,13.9,40165,NULL,NULL,NULL,'MESSIER 087',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95512,'PNLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95512,30.73,0.19,14,40165,NULL,NULL,'201','MESSIER 087',NULL,'1997eds..proc..197J',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95513,'PNLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95513,30.74,NULL,14.1,40165,NULL,NULL,NULL,'MESSIER 087',NULL,'2013A&A...558A..42L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95514,'PNLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95514,30.79,0.16,14.4,40165,NULL,NULL,'187 PNe','MESSIER 087',NULL,'1998ApJ...492...62C',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95515,'PNLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95515,30.8,NULL,14.5,40165,NULL,NULL,NULL,'MESSIER 087',NULL,'2015A&A...579A.135L',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95516,'PNLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95516,30.81,0.06,14.5,40165,NULL,NULL,'36 PNe','MESSIER 087',NULL,'1990ApJ...356..332J',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95517,'PNLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95517,30.82,0.12,14.6,40165,NULL,NULL,'HST KP Calibrated','MESSIER 087',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95518,'PNLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95518,30.86,0.25,14.9,40165,NULL,NULL,NULL,'MESSIER 087',NULL,'1992ApJ...389...27D',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95519,'PNLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95519,30.86,0.09,14.9,40165,NULL,NULL,'I','MESSIER 087',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95520,'PNLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95520,30.8,NULL,15,40165,NULL,NULL,'Virgo Cluster','MESSIER 087',NULL,'2013IAUS..289..287A',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95521,'PNLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95521,30.9,0.4,15.1,40165,NULL,NULL,NULL,'MESSIER 087',NULL,'1993A&A...275..534M',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95522,'PNLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95522,30.9,0.07,15.1,40165,NULL,NULL,'HST KP Calibrated','MESSIER 087',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95523,'PNLF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95523,30.92,0.16,15.3,40165,NULL,NULL,'M(5007) = -4.67 mag','MESSIER 087',NULL,'2010A&A...524A..71B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95524,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:11','1','SN 1919A',NULL,95524,30.7,0.36,13.8,40165,NULL,NULL,NULL,'MESSIER 087',NULL,'1992ApJ...390L..45P',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95525,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:11','1','SN 1937C','R',95525,31,0.4,15.8,40165,NULL,NULL,NULL,'MESSIER 087',NULL,'1991BAAS...23.1465C',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95526,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:11','1','SN 1919A',NULL,95526,31.1,0.4,16,40165,NULL,NULL,'Photographic','MESSIER 087',NULL,'1982ApJ...254....1A',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95527,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:11','1','SN 1919A',NULL,95527,31.89,0.21,23.9,40165,NULL,NULL,'Photographic','MESSIER 087',NULL,'1993ApJ...415....1S',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95528,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95528,30.87,0.1,14.9,40165,NULL,NULL,'I','MESSIER 087',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95529,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95529,30.87,0.09,14.9,40165,NULL,NULL,'HST KP Calibrated, Ks','MESSIER 087',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95530,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95530,31.03,0.16,16.1,40165,NULL,NULL,'I','MESSIER 087',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95531,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95531,31.03,0.16,16.1,40165,NULL,NULL,NULL,'MESSIER 087',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95532,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95532,31.03,0.05,16.1,40165,NULL,NULL,'I','MESSIER 087',NULL,'1997ApJ...475..399T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95533,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95533,31.07,0.16,16.4,40165,NULL,NULL,'Malmquist cor.','MESSIER 087',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95534,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95534,31.09,0.06,16.5,40165,NULL,NULL,'HST KP Calibrated, F814W','MESSIER 087',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95535,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95535,31.09,0.14,16.5,40165,74.4,NULL,NULL,'MESSIER 087',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95536,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95536,31.11,0.08,16.7,40165,NULL,NULL,'HST ACS VCS','MESSIER 087',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95537,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95537,31.15,0.12,17,40165,NULL,NULL,'I','MESSIER 087',NULL,'2000ApJ...536..255N',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95538,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95538,31.18,0.07,17.2,40165,NULL,NULL,NULL,'MESSIER 087',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95539,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95539,31.19,0.04,17.3,40165,NULL,NULL,'HST KP Calibrated, I','MESSIER 087',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95540,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95540,31.22,0.16,17.5,40165,NULL,NULL,'HST KP Calibrated, I','MESSIER 087',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95541,'TRGB','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95541,30.9,0.13,15.1,40165,NULL,NULL,'Lee & Jang 2016, in preparation','MESSIER 087',NULL,'2016ApJ...819...77L',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95542,'TRGB','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95542,30.91,0.1,15.2,40165,NULL,NULL,'HST KP Calibrated','MESSIER 087',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95543,'TRGB','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95543,31.12,0.14,16.7,40165,NULL,NULL,'I','MESSIER 087',NULL,'2010A&A...524A..71B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95544,'TRGB','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95544,31.44,0.31,19.4,40165,NULL,NULL,'HST KP Calibrated','MESSIER 087',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95545,'Statistical','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95545,30.98,0.09,15.7,40165,65,NULL,NULL,'MESSIER 087',NULL,'1980ApJ...238..458M',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95546,'Statistical','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95546,31.28,0.29,18,40165,NULL,NULL,NULL,'MESSIER 087',NULL,'1996AN....317..197S',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95547,'GC radius','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95547,31.07,0.3,16.4,40165,NULL,NULL,NULL,'MESSIER 087',NULL,'2010A&A...524A..71B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95548,'GC radius','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95548,31.09,0.02,16.5,40165,NULL,NULL,NULL,'MESSIER 087',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95549,'D-Sigma','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95549,30.93,NULL,15.3,40165,69,NULL,'Virgo Cluster, D-Sigma/Faber-Jackson hybrid indicator [for Coma D = 100 Mpc]','MESSIER 087',NULL,'1991BAAS...23..956G',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95550,'D-Sigma','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95550,30.95,NULL,15.5,40165,NULL,NULL,NULL,'MESSIER 087',NULL,'1993ESOC...45..159D',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95551,'D-Sigma','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95551,31.12,0.07,16.8,40165,72,NULL,'Virgo Cluster, 44 galaxies','MESSIER 087',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95552,'D-Sigma','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95552,31.13,0.4,16.8,40165,75,NULL,'Edat, raw','MESSIER 087',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95553,'D-Sigma','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95553,31.15,0.4,17,40165,75,NULL,'Edat, cor','MESSIER 087',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95554,'Diameter','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95554,30.93,NULL,15.3,40165,NULL,NULL,NULL,'MESSIER 087',NULL,'1991ApJ...382....1G',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95555,'Diameter','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95555,31.51,0.3,20,40165,NULL,NULL,'Photographic, Virgo Cluster avg. spiral vs. Messier 031','MESSIER 087',NULL,'1986A&A...157..230V',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95556,'Diameter','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95556,31.71,0.52,22,40165,NULL,NULL,'Photographic, Virgo Cluster avg. spiral vs. Milky Way','MESSIER 087',NULL,'1986A&A...157..230V',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95557,'Dwarf Galaxy Diameter','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95557,31.28,0.87,18,40165,NULL,NULL,'Virgo cluster, bias corr.','MESSIER 087',NULL,'2011MNRAS.414.3699M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95558,'Dwarf Galaxy Diameter','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95558,31.35,0.53,18.6,40165,NULL,NULL,'Virgo cluster','MESSIER 087',NULL,'2011MNRAS.414.3699M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95559,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95559,30.42,0.46,12.1,40165,95,NULL,'Michard 1979a','MESSIER 087',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95560,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95560,30.59,0.25,13.1,40165,95,NULL,'Weighted Mean','MESSIER 087',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95561,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95561,30.66,0.63,13.6,40165,95,NULL,'Michard 1979b, c','MESSIER 087',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95562,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95562,30.72,0.32,13.9,40165,95,NULL,'de Vaucouleurs','MESSIER 087',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95563,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95563,30.97,NULL,15.6,40165,NULL,NULL,'LEDA [April 2006]','MESSIER 087',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95564,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95564,31.08,0.32,16.4,40165,88,NULL,'Virgo cluster, I','MESSIER 087',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95565,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95565,31.08,0.32,16.4,40165,88,NULL,'Virgo Cluster, 5 galaxies, I','MESSIER 087',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95566,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95566,31.09,0.33,16.5,40165,88,NULL,'Virgo Cluster, 5 galaxies, R','MESSIER 087',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95567,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95567,31.09,0.33,16.5,40165,88,NULL,'Virgo cluster, R','MESSIER 087',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95568,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95568,31.11,0.33,16.7,40165,88,NULL,'Virgo cluster, BRI mean','MESSIER 087',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95569,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95569,31.18,0.37,17.2,40165,88,NULL,'Virgo cluster, B','MESSIER 087',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95570,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95570,31.18,0.37,17.2,40165,88,NULL,'Virgo Cluster, 5 galaxies, B','MESSIER 087',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95571,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95571,31.54,1.61,20.3,40165,55,NULL,'Visvanathan & Sandage 1979','MESSIER 087',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95572,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95572,30.76,0.23,14.2,40165,88,NULL,'Virgo Cluster, 5 galaxies, R','MESSIER 087',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95573,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95573,30.76,0.23,14.2,40165,88,NULL,'Virgo cluster, R','MESSIER 087',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95574,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95574,30.78,0.25,14.3,40165,88,NULL,'Virgo Cluster, 5 galaxies, B','MESSIER 087',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95575,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95575,30.78,0.25,14.3,40165,88,NULL,'Virgo cluster, B','MESSIER 087',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95576,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95576,30.79,0.23,14.4,40165,88,NULL,'Virgo cluster, BRI mean','MESSIER 087',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95577,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95577,30.85,0.22,14.8,40165,88,NULL,'Virgo Cluster, 5 galaxies, I','MESSIER 087',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95578,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95578,30.85,0.22,14.8,40165,88,NULL,'Virgo cluster, I','MESSIER 087',NULL,'1989ApJ...344L..57P',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95579,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95579,31.16,0.41,17.1,40165,NULL,NULL,NULL,'MESSIER 087',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95580,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95580,31.31,NULL,18.3,40165,NULL,NULL,NULL,'MESSIER 087',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95581,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95581,31.34,0.41,18.5,40165,NULL,NULL,'Malmquist cor.','MESSIER 087',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95582,'FP','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95582,31.62,NULL,21.1,40165,NULL,NULL,NULL,'MESSIER 087',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95583,'Magnitude','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95583,30.85,0.2,14.8,40165,NULL,NULL,'Virgo CLUSTER','MESSIER 087',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95584,'Sosies','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95584,30.79,NULL,14.4,40165,NULL,NULL,'Virgo Cluster, vs. Messier 031 m-M = 24.07 mag','MESSIER 087',NULL,'1986ApJ...308..487D',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95585,'Tertiary','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95585,30.49,0.25,12.5,40165,95,NULL,NULL,'MESSIER 087',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95586,'Tertiary','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95586,31.95,0.15,24.5,40165,NULL,NULL,'Virgo Cluster','MESSIER 087',NULL,'2002AJ....123.1179S',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95587,'Tully est','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95587,31.13,0.8,16.8,40165,75,NULL,'B','MESSIER 087',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95588,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95588,30.6,0.2,13.2,40165,NULL,NULL,'Virgo Cluster, Avg. of 13 spiral galaxies','MESSIER 087',NULL,'1977A&A....54..661T',1977,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95589,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95589,30.65,0.4,13.5,40165,NULL,NULL,'Virgo Cluster, Avg. of 8 spiral galaxies, Diameter relation','MESSIER 087',NULL,'1977A&A....54..661T',1977,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95590,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95590,30.8,0.4,14.5,40165,NULL,NULL,'Virgo Cluster, Avg. of 11 spiral galaxies, Diameter relation','MESSIER 087',NULL,'1977A&A....54..661T',1977,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95591,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95591,30.83,0.14,14.7,40165,75,NULL,'Virgo cluster, avg. of 24 spiral galaxies','MESSIER 087',NULL,'2013ApJ...765...94S',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95592,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95592,30.94,0.12,15.4,40165,75,NULL,'Virgo cluster, avg. of 24 spiral galaxies','MESSIER 087',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95593,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95593,30.97,0.4,15.6,40165,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 92 galaxy group','MESSIER 087',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95594,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95594,30.97,0.2,15.6,40165,85,NULL,'Virgo CLUSTER','MESSIER 087',NULL,'1988PASP..100R1224P',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95595,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95595,31.01,0.11,15.9,40165,75,NULL,'Virgo CLUSTER','MESSIER 087',NULL,'2012ApJ...749...78T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95596,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95596,31.04,0.12,16.2,40165,74.4,NULL,'Virgo CLUSTER, 30 galaxies, WISE W2 (4.6 micro-meter), color corrected','MESSIER 087',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95597,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95597,31.05,0.12,16.2,40165,74.4,NULL,'Virgo CLUSTER, 30 galaxies, WISE W1 (3.4 micro-meter), color corrected','MESSIER 087',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95598,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95598,31.1,0.11,16.6,40165,74.4,NULL,'Virgo CLUSTER, 30 galaxies, WISE I-band','MESSIER 087',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95599,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95599,31.12,0.08,16.8,40165,74.4,NULL,'Virgo CLUSTER, 30 galaxies, WISE W2 (4.6 micro-meter), curved','MESSIER 087',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95600,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95600,31.14,0.08,16.9,40165,74.4,NULL,'Virgo CLUSTER, 30 galaxies, WISE W1 (3.4 micro-meter), curved','MESSIER 087',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95601,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95601,31.15,0.57,17,40165,NULL,NULL,'Virgo cluster','MESSIER 087',NULL,'1999Ap.....42...25B',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95602,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95602,31.23,0.1,17.6,40165,NULL,NULL,'Virgo CLUSTER','MESSIER 087',NULL,'1996AuJA....6..195V',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95603,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95603,31.28,0.14,18,40165,NULL,NULL,'Virgo Cluster, 51 spiral galaxies','MESSIER 087',NULL,'2001A&A...375..770F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95604,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95604,31.3,0.2,18.2,40165,NULL,NULL,'Virgo cluster, Avg. spiral galaxies','MESSIER 087',NULL,'1990AuJPh..43..189V',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95605,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,NULL,95605,31.34,0.15,18.5,40165,NULL,NULL,'Virgo Cluster, Avg. of 25 spiral galaxies','MESSIER 087',NULL,'1985PASAu...6..140V',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95606,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:11','1',NULL,'R',95606,31.43,0.06,19.3,40165,71,NULL,'Virgo Cluster','MESSIER 087',NULL,'1982PASAu...4..419V',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95607,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95607,31.47,0.34,19.7,40165,NULL,NULL,'Virgo Cluster, 17 spirals avg.','MESSIER 087',NULL,'1984Natur.307..326S',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95608,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95608,31.58,0.24,20.7,40165,55,NULL,'Virgo cluster, 49 spirals','MESSIER 087',NULL,'1998ApJ...495..115F',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95609,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95609,31.79,0.09,22.8,40165,NULL,NULL,'Virgo Cluster, Avg. of spiral galaxies','MESSIER 087',NULL,'1996swhs.conf....9T',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95610,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95610,31.8,0.3,23.4,40165,NULL,NULL,'Virgo Cluster, Avg. spirals, TF diamter relation','MESSIER 087',NULL,'1988ASPC....4..211T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95611,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95611,32.06,0.31,25.8,40165,53.9,NULL,'Virgo Cluster','MESSIER 087',NULL,'1984A&A...132..253R',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95612,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95612,37.71,0.27,348,40166,70,NULL,NULL,'2MASX J12305025+0802064',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000181,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,187.70925,8.03508,0,NULL,58250125866,910158216,14221222,17.5),(95613,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95613,37.14,0.27,268,40167,70,NULL,NULL,'SDSS J123050.80+030231.2',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,187.711708333,3.04203,0.01,NULL,58006040157,906344377,14161630,17.7),(95614,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95614,37.4,0.46,302,40168,70,NULL,NULL,'2MASX J12305128+4100301',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00016,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,187.7135417,41.00842,0,NULL,59060196546,922815571,14418993,17),(95615,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95615,29.53,NULL,8.05,40169,NULL,NULL,NULL,'NGC 4488',NULL,'1999MNRAS.304..595G',1999,1,3.17,NULL,'G',0.000027,NULL,'13.1g',0.87,'SB(s)0/a pec:','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.7140417,8.36,0,NULL,58246817132,910106517,14220414,13.1),(95616,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95616,37.86,0.46,373,40170,70,NULL,NULL,'2MASX J12305184+0557563',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,187.7160417,5.96572,0,NULL,58235667730,909932308,14217692,17.8),(95617,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95617,30.75,0.37,14.1,40171,NULL,NULL,'HST KP Calibrated, K\'','NGC 4489',NULL,'2000ApJ...529..745F',2000,1,1.7,NULL,'G',0.000017,NULL,'12.84',1.5,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.7177083,16.75886,0.021,NULL,58883283518,920051304,14375801,12.84),(95618,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95618,31.23,0.28,17.6,40171,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4489',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95619,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95619,31.36,0.23,18.7,40171,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4489',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95620,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95620,31.46,0.26,19.6,40171,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4489',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95621,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95621,31.68,0.22,21.7,40171,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4489',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95622,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95622,29.56,0.25,8.17,40171,NULL,NULL,'HST KP Calibrated, Ks','NGC 4489',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95623,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95623,30.44,0.08,12.3,40171,NULL,NULL,'I','NGC 4489',NULL,'1990AJ....100.1416T',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95624,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95624,30.55,0.12,12.9,40171,74.4,NULL,NULL,'NGC 4489',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95625,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95625,30.6,0.35,13.2,40171,NULL,NULL,'K','NGC 4489',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95626,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95626,30.81,0.11,14.5,40171,NULL,NULL,'K','NGC 4489',NULL,'1994ApJ...433..567P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95627,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95627,30.81,0.11,14.5,40171,NULL,NULL,'K','NGC 4489',NULL,'1996ApJ...468..519J',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95628,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95628,30.94,0.07,15.4,40171,NULL,NULL,'HST ACS VCS','NGC 4489',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95629,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95629,30.94,0.05,15.4,40171,NULL,NULL,NULL,'NGC 4489',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95630,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95630,31.26,0.13,17.9,40171,NULL,NULL,'I, MK = -6.29 mag','NGC 4489',NULL,'2001A&A...366...54M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95631,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95631,31.26,0.15,17.9,40171,NULL,NULL,'I','NGC 4489',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95632,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95632,31.31,0.18,18.3,40171,NULL,NULL,'HST KP Calibrated, I','NGC 4489',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95633,'GC radius','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95633,30.94,0.12,15.4,40171,NULL,NULL,NULL,'NGC 4489',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95634,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95634,30.22,NULL,11.1,40171,NULL,NULL,NULL,'NGC 4489',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95635,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95635,30.36,NULL,11.8,40171,NULL,NULL,NULL,'NGC 4489',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95636,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95636,30.55,0.12,12.9,40171,74.4,NULL,NULL,'NGC 4489',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95637,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95637,30.7,0.45,13.8,40171,NULL,NULL,'K','NGC 4489',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95638,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95638,31.18,0.4,17.2,40171,NULL,NULL,'mean','NGC 4489',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95639,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95639,37.05,0.46,257,40172,70,NULL,NULL,'2MASX J12305219+2835249',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000152,NULL,'16.8g',0.34,NULL,NULL,NULL,NULL,NULL,1,187.717667,28.59019,0.073,NULL,58728737953,917636530,14338070,16.8),(95640,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95640,37.39,0.46,301,40173,70,NULL,NULL,'2MASX J12305254+2114155',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.29',0.19,NULL,NULL,NULL,NULL,NULL,1,187.718875,21.23756,0.063,NULL,58913127192,920517612,14383087,17.29),(95641,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95641,38.22,0.46,441,40174,70,NULL,NULL,'2MASX J12305274+3758351',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,187.719667,37.97636,0,NULL,58575654143,915244595,14300696,17.5),(95642,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95642,36.18,0.46,172,40175,70,NULL,NULL,'2MASX J12305302+5052503',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000143,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,187.720833,50.88083,0,NULL,57236846555,894325727,13973839,16.3),(95643,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95643,35.97,0.46,156,40176,70,NULL,NULL,'2MASX J12305320+0904564',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000169,NULL,'16.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,187.7215,9.0825,0,NULL,58245248588,910082009,14220031,16.5),(95644,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95644,37.36,0.27,296,40177,70,NULL,NULL,'2MASX J12305391+0606234',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000232,NULL,'16.0g',0.43,'E0',NULL,NULL,NULL,NULL,1,187.724666667,6.10644,0,NULL,58235761125,909933767,14217715,16),(95645,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95645,36.8,0.46,229,40178,70,NULL,NULL,'2MASX J12305516+4454028',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000176,NULL,'16.0g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,187.7300417,44.90069,0,NULL,59068470716,922944854,14421013,16),(95646,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95646,35.91,0.46,152,40179,70,NULL,NULL,'2MASX J12305602+6549571',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000098,NULL,'15.7g',0.47,'N',NULL,NULL,NULL,NULL,1,187.733625,65.83247,0,NULL,57320894734,895638980,13994359,15.7),(95647,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95647,37.87,0.1,375,40180,70,NULL,NULL,'VPC 0776',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000193,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,187.734667,11.62744,0.039,NULL,58159879895,908748123,14199189,16.5),(95648,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95648,37.58,0.46,328,40181,70,NULL,NULL,'VPC 0777',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000175,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,187.7352083,11.85889,0.05,NULL,58160297343,908754645,14199291,17),(95649,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95649,37.07,0.16,259,40182,70,NULL,NULL,'2MASX J12305667+2851449',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00011,NULL,'15.8g',0.43,'E',NULL,NULL,NULL,NULL,1,187.7362917,28.86264,0.06,NULL,58728816212,917637753,14338089,15.8),(95650,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95650,37.92,0.46,383,40183,70,NULL,NULL,'2MASX J12305672+2250385',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,187.7364583,22.844,0,NULL,58893226954,920206671,14378229,17.5),(95651,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95651,30.89,0.13,15,40184,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4486A',NULL,'2007ApJS..171..101J',2007,1,1,'Literature v=150 km/sec is for superposed star.','G',0.000017,NULL,'14.',0.9,'E2','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.7404583,12.27036,0.088,NULL,58159706065,908745407,14199146,14),(95652,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95652,30.89,0.12,15.1,40184,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4486A',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95653,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95653,31.02,0.12,16,40184,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4486A',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95654,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95654,31.16,0.12,17.1,40184,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4486A',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95655,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95655,31.3,0.14,18.2,40184,74.4,NULL,NULL,'NGC 4486A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95656,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95656,31.31,0.06,18.3,40184,NULL,NULL,NULL,'NGC 4486A',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95657,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95657,31.32,0.07,18.4,40184,NULL,NULL,'HST ACS VCS','NGC 4486A',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95658,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95658,38.17,0.46,431,40185,70,NULL,NULL,'SDSS J123058.70+031554.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000142,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,187.744583,3.26506,0.028,NULL,58006078968,906344983,14161640,18.6),(95659,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95659,36.34,0.46,186,40186,70,NULL,NULL,'2MASX J12305870+2006265',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,187.74475,20.10742,NULL,NULL,58917957132,920593080,14384266,16.7),(95660,'Tully est','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95660,31.13,0.8,16.8,40187,75,NULL,'B','NGC 4492',NULL,'1988NBGC.C....0000T',1988,1,1.58,NULL,'G',0.000015,NULL,'13.0g',1.25,'SA(s)a?        RET','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.7487917,8.07786,0,NULL,58246667782,910104184,14220377,13),(95661,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95661,37.71,0.46,349,40188,70,NULL,NULL,'2MASX J12305983+4935432',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000141,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,187.749333,49.59536,0,NULL,57236224485,894316007,13973687,17.7),(95662,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95662,36.49,0.46,198,40189,70,NULL,NULL,'2MASX J12305989+4505304',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000149,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,187.749583,45.09183,0,NULL,59068461075,922944704,14421011,16.5),(95663,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95663,37.07,0.16,259,40190,70,NULL,NULL,'2MASX J12310018+2858149',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000133,NULL,'16.2g',0.34,'E',NULL,NULL,NULL,NULL,1,187.750917,28.97092,0.06,NULL,58728789520,917637336,14338083,16.2),(95664,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95664,36.53,0.46,202,40191,70,NULL,NULL,'2MASX J12310030+5121332',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000177,NULL,'16.5g',0.36,'AGN',NULL,NULL,NULL,NULL,1,187.7515417,51.35919,0,NULL,57241442575,894397540,13974961,16.5),(95665,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95665,37.87,0.46,375,40192,70,NULL,NULL,'2MASX J12310102+0702484',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000183,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,187.7542083,7.04675,0,NULL,58249112622,910142384,14220974,17),(95666,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95666,37.55,0.33,324,40193,70,NULL,NULL,'2MASX J12310111+1032224',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,187.754583,10.5395,0.02,NULL,58191766763,909246355,14206974,17.6),(95667,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95667,37.36,0.27,296,40194,70,NULL,NULL,'2MASX J12310115+0604024',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,187.754833,6.06739,0,NULL,58235761806,909933778,14217715,17.3),(95668,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95668,38.43,0.27,486,40195,70,NULL,NULL,'VIII Zw 192 NOTES02',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000176,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,187.755125,10.48353,0.024,NULL,58191772351,909246442,14206975,16.5),(95669,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95669,36.66,0.46,215,40196,70,NULL,NULL,'2MASX J12310146+2503259',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,187.7562083,25.05728,0.037,NULL,58614082580,915845040,14310078,16.9),(95670,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95670,37.42,0.46,305,40197,70,NULL,NULL,'2MASX J12310225+6723502',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00008,NULL,'17.6g',0.23,'NLAGN',NULL,NULL,NULL,'Sy 2',1,187.7595417,67.39742,0.009,NULL,57848992708,903890511,14123289,17.6),(95671,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95671,38.43,0.27,486,40198,70,NULL,NULL,'SDSS J123102.57+101909.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000145,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,187.76075,10.31925,0.024,NULL,58191626061,909244157,14206939,18.7),(95672,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95672,37.86,0.46,373,40199,70,NULL,NULL,'SDSS J123102.64+121053.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000149,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,187.7610417,12.18156,0.09,NULL,58159695314,908745239,14199144,18),(95673,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95673,38.42,0.46,483,40200,70,NULL,NULL,'SDSS J123103.38+012933.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,187.764125,1.49264,0.011,NULL,58014708974,906479827,14163747,18.2),(95674,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95674,38.36,0.14,470,40201,70,NULL,NULL,'2MASX J12310341+6700512',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000078,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,187.764167,67.01428,0.029,NULL,57862529876,904102029,14126594,17.3),(95675,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95675,29.91,NULL,9.59,40202,NULL,NULL,NULL,'CGCG 014-054',NULL,'2013AJ....145..101K',2013,1,1.2,NULL,'G',0.000017,NULL,'15.6B',0.7,'IAB(s)m pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,187.765917,1.67569,0.013,NULL,58014742751,906480355,14163755,15.6),(95676,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95676,29.91,0.4,9.6,40202,NULL,NULL,NULL,'CGCG 014-054',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95677,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95677,37.71,0.27,348,40203,70,NULL,NULL,'2MASX J12310407+2414129',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,187.767083333,24.23706,0.045,NULL,58615379198,915865299,14310395,16.6),(95678,'SNII optical','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 2009N',NULL,95678,31.52,0.06,20.1,40204,NULL,NULL,'SCM','NGC 4487',NULL,'2015ApJ...799..215P',2015,1,4.2,NULL,'G',0.000007,NULL,'12.26',2.8,'SAB(rs)cd','X-ray-faint group member',NULL,NULL,NULL,1,187.768583,-8.05392,0.069,NULL,43214627195,675228549,10550446,12.26),(95679,'SNII optical','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 2009N',NULL,95679,31.61,0.14,21,40204,NULL,NULL,'SCM','NGC 4487',NULL,'2014MNRAS.438..368T',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95680,'SNII optical','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 2009N',NULL,95680,31.67,0.11,21.6,40204,NULL,NULL,'avg. of EPM + SCM','NGC 4487',NULL,'2014MNRAS.438..368T',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95681,'SNII optical','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 2009N',NULL,95681,31.77,0.19,22.6,40204,NULL,NULL,'V, photospheric magnitude method','NGC 4487',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95682,'SNII optical','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 2009N',NULL,95682,31.83,0.1,23.2,40204,NULL,NULL,'I, photospheric magnitude method','NGC 4487',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95683,'SNII optical','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 2009N',NULL,95683,31.84,0.18,23.3,40204,NULL,NULL,'EPM','NGC 4487',NULL,'2014MNRAS.438..368T',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95684,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95684,30.25,0.43,11.2,40204,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4487',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95685,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95685,30.77,0.4,14.2,40204,NULL,NULL,NULL,'NGC 4487',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95686,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95686,31.43,0.47,19.4,40204,NULL,NULL,'H','NGC 4487',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95687,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95687,31.44,0.45,19.4,40204,NULL,NULL,'K','NGC 4487',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95688,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95688,31.46,0.46,19.6,40204,NULL,NULL,'J','NGC 4487',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95689,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95689,31.49,0.4,19.9,40204,75,NULL,'B','NGC 4487',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95690,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95690,31.7,0.4,21.9,40204,NULL,NULL,'mean','NGC 4487',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95691,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95691,37.62,0.46,335,40205,70,NULL,NULL,'2MASX J12310512+3517141',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000179,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,187.771417,35.28725,0.014,NULL,58561749746,915027339,14297302,16.6),(95692,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95692,37.07,0.16,259,40206,70,NULL,NULL,'2MASX J12310626+2852099',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,187.776083333,28.86958,0.06,NULL,58728812711,917637698,14338089,17.9),(95693,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95693,36.77,0.46,226,40207,70,NULL,NULL,'2MASX J12310702+0307496',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000187,NULL,'16.0g',0.39,'E0',NULL,NULL,NULL,NULL,1,187.7792917,3.13031,0.017,NULL,58005294621,906332728,14161448,16),(95694,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95694,37.71,0.27,348,40208,70,NULL,NULL,'SDSS J123108.09+241451.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'19.18',0.15,NULL,NULL,NULL,NULL,NULL,1,187.78375,24.24756,0.045,NULL,58615379751,915865308,14310395,19.18),(95695,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95695,37.87,0.1,375,40209,70,NULL,NULL,'2MASX J12310929+1144014',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000173,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,187.788833,11.73378,0.039,NULL,58160167618,908752619,14199259,18.2),(95696,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95696,37.15,0.46,269,40210,70,NULL,NULL,'2MASX J12310958+3109511',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,187.790166667,31.16425,0,NULL,58777788911,918402951,14350046,16.8),(95697,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994M',NULL,95697,34.37,0.18,73.1,40211,74.2,NULL,'SALT 2','NGC 4493',0.02316,'2010ApJ...716..712A',2010,1,1.16,NULL,'G',0.000093,NULL,'14.5g',0.74,'SA?0- pec',NULL,NULL,NULL,NULL,1,187.784875,0.61369,0.014,NULL,58008353796,906380528,14162195,14.5),(95698,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 2004br','R',95698,34.66,0.04,85.5,40211,NULL,NULL,'MLCS2k2, R(V) = 1.8','NGC 4493',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95699,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 2004br','R',95699,34.71,0.05,87.5,40211,NULL,NULL,'MLCS2k2, R(V) = 3.1','NGC 4493',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95700,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994M',NULL,95700,34.88,0.16,92.3,40211,70,NULL,'SALT 2','NGC 4493',0.02316,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95701,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994M',NULL,95701,34.93,0.03,94.6,40211,72,NULL,NULL,'NGC 4493',0.02316,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95702,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994M',NULL,95702,34.9,0.08,95.5,40211,74.4,NULL,NULL,'NGC 4493',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95703,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994M',NULL,95703,34.98,0.17,97,40211,70,NULL,'SALT 2','NGC 4493',0.02316,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95704,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994M',NULL,95704,34.99,0.19,97.3,40211,72,NULL,NULL,'NGC 4493',0.02316,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95705,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994M',NULL,95705,34.98,0.12,99.1,40211,70.8,NULL,NULL,'NGC 4493',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95706,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994M',NULL,95706,35.04,0.12,99.7,40211,65,NULL,'SALT2','NGC 4493',0.02316,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95707,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994M',NULL,95707,35.08,0.19,101,40211,70,NULL,'SALT','NGC 4493',0.02316,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95708,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994M',NULL,95708,35.09,0.2,102,40211,65,NULL,NULL,'NGC 4493',0.02316,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95709,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994M',NULL,95709,35.24,0.12,107,40211,65,NULL,'MLCS2k2','NGC 4493',0.02316,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95710,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994M',NULL,95710,35.21,0.21,108,40211,65,NULL,'SALT','NGC 4493',0.02316,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95711,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994M',NULL,95711,35.21,0.19,108,40211,65,NULL,'MLCS31','NGC 4493',0.02316,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95712,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994M',NULL,95712,35.23,0.09,108,40211,70,NULL,NULL,'NGC 4493',0.02316,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95713,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994M',NULL,95713,35.22,0.07,108,40211,65,NULL,'MLCS2k2','NGC 4493',0.02316,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95714,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994M',NULL,95714,35.23,0.18,109,40211,65,NULL,'MLCS17','NGC 4493',0.02316,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95715,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994M',NULL,95715,35.24,0.12,109,40211,65,NULL,'MLCS2k2','NGC 4493',0.02316,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95716,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994M',NULL,95716,35.28,0.21,111,40211,65,NULL,'SALT2','NGC 4493',0.02316,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95717,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994M',NULL,95717,35.32,0.1,113,40211,65,NULL,'MLCS','NGC 4493',0.02316,'1996ApJ...473..588R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95718,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994M',NULL,95718,35.37,0.03,116,40211,65,NULL,'SALT','NGC 4493',0.02316,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95719,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994M',NULL,95719,35.32,0.09,116,40211,65,NULL,'Snapshot','NGC 4493',NULL,'1996ApJ...473...88R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95720,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994M',NULL,95720,35.39,0.18,117,40211,65,NULL,'MLCS','NGC 4493',0.02316,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95721,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994M',NULL,95721,35.41,0.14,121,40211,60,NULL,NULL,'NGC 4493',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95722,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994M',NULL,95722,35.49,0.2,122,40211,65,NULL,'Template','NGC 4493',0.02316,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95723,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994M',NULL,95723,35.46,0.06,124,40211,60,NULL,'M(I) = -19.19 mag','NGC 4493',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95724,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994M',NULL,95724,35.63,0.07,134,40211,60,NULL,'M(V) = -19.47 mag','NGC 4493',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95725,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994M',NULL,95725,35.66,0.08,136,40211,60,NULL,'M(B) = -19.48 mag','NGC 4493',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95726,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994M',NULL,95726,35.86,0.04,145,40211,70,NULL,'SALT 2','NGC 4493',0.02316,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95727,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95727,38.29,0.33,454,40212,70,NULL,NULL,'SDSS J123110.02+683856.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000062,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,187.791833,68.64894,0.045,NULL,57850484523,903913820,14123653,18.4),(95728,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95728,37.07,0.16,259,40213,70,NULL,NULL,'2MASX J12311013+2852048',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,187.792125,28.86792,0.06,NULL,58729521239,917648769,14338262,17.1),(95729,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95729,37.57,0.46,326,40214,70,NULL,NULL,'SDSS J123110.13+111531.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000176,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,187.79225,11.25881,0.014,NULL,58190194264,909221785,14206590,18.1),(95730,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95730,38.27,0.46,450,40215,70,NULL,NULL,'2MASX J12311045+3410421',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000199,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,187.7934583,34.17836,NULL,NULL,58770799095,918293735,14348339,16.9),(95731,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95731,35.59,0.46,131,40216,70,NULL,NULL,'CGCG 014-056 NED02',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000083,NULL,'15.9g',0.43,'SA?0- pec',NULL,NULL,NULL,NULL,1,187.7960417,0.60622,0.014,NULL,58008353936,906380530,14162195,15.9),(95732,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95732,37.71,0.27,348,40217,70,NULL,NULL,'2MASX J12311159+0745424',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000193,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,187.798416667,7.76175,0,NULL,58250291937,910160811,14221262,16.5),(95733,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95733,37.32,0.33,291,40218,70,NULL,NULL,'SDSS J123113.21+053430.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,187.805083,5.57519,0,NULL,58227830659,909809854,14215778,17.9),(95734,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95734,37.47,0.46,312,40219,70,NULL,NULL,'2MASX J12311348+3143591',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,187.8062083,31.73303,0.021,NULL,58785522589,918523790,14351934,17.4),(95735,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95735,36.92,0.46,242,40220,70,NULL,NULL,'2MASX J12311423+2329153',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00009,NULL,'16.95',0.25,NULL,NULL,NULL,NULL,NULL,1,187.80925,23.48761,0.033,NULL,58611679490,915807492,14309492,16.95),(95736,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95736,37.11,0.46,264,40221,70,NULL,NULL,'2MASX J12311455+2305223',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.28',0.25,NULL,NULL,NULL,NULL,NULL,1,187.8105,23.08958,0.028,NULL,58892947431,920202303,14378160,17.28),(95737,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95737,38.36,0.14,470,40222,70,NULL,NULL,'SDSS J123114.75+665456.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000057,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,187.8115,66.91569,0.029,NULL,57862523916,904101936,14126592,18.5),(95738,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95738,36.8,0.46,229,40223,70,NULL,NULL,'2MASX J12311484+3525251',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000172,NULL,'17.08',0.2,NULL,NULL,NULL,NULL,NULL,1,187.812041667,35.42358,0.014,NULL,58561763029,915027547,14297305,17.08),(95739,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95739,34.77,0.46,89.9,40224,70,NULL,NULL,'VPC 0800',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000077,NULL,'15.1g',0.53,'E',NULL,NULL,NULL,NULL,1,187.812416667,14.19667,0.134,NULL,58164987254,908827925,14200436,15.1),(95740,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95740,37.43,0.46,307,40225,70,NULL,NULL,'2MASX J12311597-0006292',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000077,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,187.8165,-0.10811,0.065,NULL,42989643951,671713186,10495518,17.6),(95741,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95741,37.77,0.46,358,40226,70,NULL,NULL,'2MASX J12311724+5543048',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,187.82175,55.71789,0,NULL,57401945443,896905397,14014146,17.5),(95742,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95742,37.07,0.46,259,40227,70,NULL,NULL,'LCRS B122843.1-031856',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000098,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,187.822667,-3.59181,0.053,NULL,43175001104,674609392,10540771,16.8),(95743,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95743,37.32,0.33,291,40228,70,NULL,NULL,'2MASX J12311774+0534056',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000161,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,187.823875,5.56828,0,NULL,58227830638,909809853,14215778,16.9),(95744,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95744,37.73,0.23,352,40229,70,NULL,NULL,'2MASX J12311778-0210142',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000084,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,187.824167,-2.17067,0.057,NULL,42997661515,671838461,10497475,17.2),(95745,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95745,37.71,0.27,348,40230,70,NULL,NULL,'2MASX J12311780+2419159',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,187.8242083,24.32125,0.045,NULL,58615370038,915865156,14310393,16.8),(95746,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95746,37.44,0.33,308,40231,70,NULL,NULL,'VII Zw 464',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000173,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,187.830333333,65.73017,0,NULL,57320689718,895635776,13994309,16.5),(95747,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95747,31.74,0.96,22.2,40232,NULL,NULL,'TOM(g) = -7.2 mag','IC 3442',NULL,'2007ApJS..171..101J',2007,1,1.2,'Bingelli et al. (1993,A&AS,98,275) give v = 1332 +/- 63 km/sec.','G',0.000167,NULL,'14.47',1.1,'dE0:','Group member',NULL,NULL,NULL,1,187.834125,14.11519,0.091,NULL,58164991781,908827996,14200437,14.47),(95748,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95748,31.75,0.78,22.4,40232,NULL,NULL,'TOM(g) = -7.2 mag','IC 3442',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95749,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95749,32.1,0.79,26.3,40232,NULL,NULL,'TOM(u) = -8.4 mag','IC 3442',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95750,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95750,32.21,0.73,27.7,40232,NULL,NULL,'TOM(z) = -8.53 mag','IC 3442',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95751,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95751,30.92,0.17,15.3,40232,NULL,NULL,'R','IC 3442',NULL,'2004AJ....127..771J',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95752,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95752,31.12,0.14,16.8,40232,74.4,NULL,NULL,'IC 3442',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95753,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95753,31.15,0.09,16.9,40232,NULL,NULL,'HST ACS VCS','IC 3442',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95754,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95754,31.14,0.08,16.9,40232,NULL,NULL,NULL,'IC 3442',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95755,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95755,37.22,0.46,278,40233,70,NULL,NULL,'2MASX J12312190+3536231',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000173,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,187.841167,35.60644,0,NULL,58561605184,915025081,14297266,16.4),(95756,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95756,32.69,0.2,34.5,40234,74.4,NULL,NULL,'NGC 4500',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.000043,NULL,'13.1',1,'SB(s)a         Sbrst','Group member',NULL,NULL,'Starburst',1,187.842333,57.96464,0,NULL,57409251256,897019550,14015930,13.1),(95757,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95757,33.46,0.4,49.1,40234,NULL,NULL,'mean','NGC 4500',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95758,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95758,33.61,0.45,52.7,40234,NULL,NULL,'K','NGC 4500',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95759,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95759,33.68,0.47,54.4,40234,NULL,NULL,'H','NGC 4500',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95760,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95760,33.71,0.46,55.1,40234,NULL,NULL,'J','NGC 4500',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95761,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95761,37.55,0.33,324,40235,70,NULL,NULL,'VPC 0812',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000149,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,187.84325,10.73692,0.02,NULL,58191126748,909236355,14206818,17.6),(95762,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95762,37.07,0.16,259,40236,70,NULL,NULL,'2MASX J12312245+2903529',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,187.8435,29.06489,0.063,NULL,58729235048,917644297,14338192,17),(95763,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95763,35.48,0.55,125,40237,70,NULL,NULL,'2MASX J12312250-1440316',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,187.843791667,-14.6755,0.065,NULL,43044010553,672562664,10508791,14),(95764,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95764,33.3,0.36,45.7,40238,NULL,NULL,NULL,'IC 3446',NULL,'2009AJ....138..323T',2009,1,0.73,NULL,'G',0.000002,NULL,'15.4g',0.38,'SmIII/BCD','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,187.845583,11.49239,0.021,NULL,58159914647,908748666,14199197,15.4),(95765,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994S',NULL,95765,33.37,0.22,46.5,40239,74.2,NULL,'SALT 2','NGC 4495',0.01518,'2010ApJ...716..712A',2010,1,1.48,NULL,'G',0.00002,NULL,'14.1g',0.66,'Sab            LINER',NULL,NULL,NULL,'LINER',1,187.845333,29.13647,0.063,NULL,58775189403,918362334,14349411,14.1),(95766,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994S',NULL,95766,33.85,0.03,58,40239,70,NULL,'SALT 2','NGC 4495',0.01518,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95767,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994S',NULL,95767,34,0.08,63.1,40239,74.4,NULL,NULL,'NGC 4495',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95768,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994S',NULL,95768,34.07,0.15,64.2,40239,70,NULL,NULL,'NGC 4495',0.01518,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95769,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994S',NULL,95769,34.11,0.2,65.3,40239,70,NULL,'SALT 2','NGC 4495',0.01518,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95770,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994S',NULL,95770,34.14,0.27,66.3,40239,72,NULL,NULL,'NGC 4495',0.01518,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95771,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994S',NULL,95771,34.16,0.19,66.8,40239,73.8,NULL,'SALT 2 (SNANA)','NGC 4495',0.0163,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95772,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994S',NULL,95772,34.2,0.23,68.1,40239,70,NULL,'SALT','NGC 4495',0.01518,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95773,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994S',NULL,95773,34.17,0.06,68.2,40239,60,NULL,'M(V) = -19.47 mag','NGC 4495',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95774,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994S',NULL,95774,34.18,0.17,68.5,40239,70.8,NULL,NULL,'NGC 4495',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95775,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994S',NULL,95775,34.19,0.07,68.9,40239,60,NULL,'M(B) = -19.48 mag','NGC 4495',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95776,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994S',NULL,95776,34.23,0.24,69.2,40239,65,NULL,'SALT2','NGC 4495',0.01518,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95777,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994S',NULL,95777,34.25,0.01,69.6,40239,72,NULL,NULL,'NGC 4495',0.01518,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95778,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994S',NULL,95778,34.25,0.06,69.6,40239,65,NULL,'MLCS','NGC 4495',0.01518,'1996ApJ...473..588R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95779,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994S',NULL,95779,34.22,0.06,69.8,40239,60,NULL,'M(I) = -19.19 mag','NGC 4495',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95780,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994S',NULL,95780,34.27,0.12,70.4,40239,65,NULL,'MLCS','NGC 4495',0.01518,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95781,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994S',NULL,95781,34.24,0.05,70.5,40239,65,NULL,'Snapshot','NGC 4495',NULL,'1996ApJ...473...88R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95782,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994S',NULL,95782,34.31,0.21,71.8,40239,65,NULL,'MLCS17','NGC 4495',0.01518,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95783,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994S',NULL,95783,34.36,0.08,72.1,40239,65,NULL,'MLCS2k2','NGC 4495',0.01518,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95784,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994S',NULL,95784,34.34,0.14,72.7,40239,65,NULL,'Template','NGC 4495',0.01518,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95785,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994S',NULL,95785,34.35,0.08,73,40239,65,NULL,'MLCS2k2','NGC 4495',0.01518,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95786,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994S',NULL,95786,34.36,0.21,73.3,40239,65,NULL,'MLCS31','NGC 4495',0.01518,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95787,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994S',NULL,95787,34.37,0.28,73.8,40239,65,NULL,'SALT','NGC 4495',0.01518,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95788,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994S',NULL,95788,34.47,0.04,77.2,40239,65,NULL,'SALT','NGC 4495',0.01518,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95789,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994S',NULL,95789,34.5,0.24,78.2,40239,65,NULL,NULL,'NGC 4495',0.01518,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95790,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1994S',NULL,95790,34.48,0.14,78.7,40239,60,NULL,NULL,'NGC 4495',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95791,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95791,34.06,0.45,64.8,40239,NULL,NULL,'K','NGC 4495',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95792,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95792,34.09,0.47,65.9,40239,NULL,NULL,'H','NGC 4495',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95793,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95793,34.26,0.4,71.1,40239,NULL,NULL,'mean','NGC 4495',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95794,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95794,34.26,0.46,71.2,40239,NULL,NULL,'J','NGC 4495',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95795,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95795,35.82,0.54,146,40240,70,NULL,NULL,'2MASX J12312300-4508175',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,187.846,-45.13819,0.393,NULL,46720488435,730007631,11406369,17),(95796,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95796,37.77,0.46,358,40241,70,NULL,NULL,'2MASX J12312317+1656184',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,187.846708333,16.93847,0.026,NULL,58883096346,920048380,14375755,17.4),(95797,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95797,35.83,0.6,147,40242,70,NULL,NULL,'2MASX J12312363-3524440',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,187.8485417,-35.41217,0.205,NULL,43240024898,675625389,10556646,15.6),(95798,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95798,30.41,0.13,12.1,40243,NULL,NULL,'blue GCs, TOM(V) = -7.17 mag','NGC 4494',NULL,'2001AJ....121.2974L',2001,1,4.8,'The position given in 1996ApJS..106....1W is 11 arcsec west of the nucleus.','G',0.000017,NULL,'10.71',3.5,'E1-2           LINER','Possible field galaxy',NULL,NULL,NULL,1,187.850417,25.77525,0.051,NULL,58616446162,915881971,14310655,10.71),(95799,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95799,30.5,0.15,12.6,40243,NULL,NULL,NULL,'NGC 4494',NULL,'1998AJ....116.2841K',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95800,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95800,30.64,0.28,13.4,40243,NULL,NULL,'HST KP Calibrated, V','NGC 4494',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95801,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95801,30.8,0.2,14.5,40243,NULL,NULL,'TOM(V) = -7.3 mag','NGC 4494',NULL,'2009ApJ...690..512H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95802,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95802,30.8,0.4,14.5,40243,NULL,NULL,NULL,'NGC 4494',NULL,'1995AJ....109.1044F',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95803,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95803,31.03,0.11,16.1,40243,NULL,NULL,'all GCs, TOM(V) = -7.63 mag','NGC 4494',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95804,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95804,31.12,0.14,16.7,40243,NULL,NULL,NULL,'NGC 4494',NULL,'2001AJ....121.2950K',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95805,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95805,31.31,0.22,18.3,40243,NULL,NULL,'red GCs, TOM(V) = -7.55 mag','NGC 4494',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95806,'PNLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95806,30.51,0.08,12.6,40243,NULL,NULL,NULL,'NGC 4494',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95807,'PNLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95807,30.54,0.05,12.8,40243,NULL,NULL,'101 PNe','NGC 4494',NULL,'1996ApJ...462....1J',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95808,'PNLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95808,30.61,0.09,13.2,40243,NULL,NULL,'HST KP Calibrated','NGC 4494',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95809,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95809,30.88,0.31,15,40243,NULL,NULL,'V','NGC 4494',NULL,'1994AJ....107..503S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95810,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95810,31.01,0.08,15.9,40243,NULL,NULL,'I','NGC 4494',NULL,'1997ApJ...475..399T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95811,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95811,31.14,0.14,16.9,40243,74.4,NULL,NULL,'NGC 4494',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95812,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95812,31.16,0.11,17.1,40243,NULL,NULL,'I','NGC 4494',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95813,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95813,31.16,0.11,17.1,40243,NULL,NULL,NULL,'NGC 4494',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95814,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95814,31.17,0.11,17.2,40243,NULL,NULL,'Malmquist cor.','NGC 4494',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95815,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95815,31.22,0.13,17.5,40243,NULL,NULL,'HST KP Calibrated, I','NGC 4494',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95816,'D-Sigma','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95816,29.4,0.4,7.59,40243,75,NULL,'Edat, raw','NGC 4494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95817,'D-Sigma','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95817,29.74,0.4,8.86,40243,75,NULL,'Edat, cor','NGC 4494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95818,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95818,29.96,NULL,9.82,40243,NULL,NULL,'LEDA [April 2006]','NGC 4494',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95819,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95819,29.98,0.4,9.91,40243,95,NULL,'de Vaucouleurs','NGC 4494',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95820,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95820,30.15,0.27,10.7,40243,95,NULL,'Weighted Mean','NGC 4494',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95821,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95821,30.53,0.63,12.8,40243,95,NULL,'Michard 1979b, c','NGC 4494',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95822,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95822,30.57,0.81,13,40243,55,NULL,'Visvanathan & Sandage 1979','NGC 4494',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95823,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95823,30.9,0.46,15.1,40243,95,NULL,'Michard 1979a','NGC 4494',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95824,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95824,29.6,0.41,8.3,40243,NULL,NULL,NULL,'NGC 4494',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95825,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95825,29.94,0.41,9.71,40243,NULL,NULL,'Malmquist cor.','NGC 4494',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95826,'Tertiary','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95826,30.23,0.29,11.1,40243,95,NULL,NULL,'NGC 4494',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95827,'Tully est','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95827,29.93,0.8,9.7,40243,75,NULL,'B','NGC 4494',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95828,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95828,30.72,0.45,13.9,40243,NULL,NULL,'K','NGC 4494',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95829,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95829,31.52,0.4,20.1,40243,NULL,NULL,'mean','NGC 4494',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95830,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95830,37.07,0.16,259,40244,70,NULL,NULL,'IC 3451',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000103,NULL,'15.2g',0.57,'S0',NULL,NULL,NULL,NULL,1,187.8502917,28.85519,0.06,NULL,58729557707,917649339,14338270,15.2),(95831,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95831,38.29,0.33,454,40245,70,NULL,NULL,'SDSS J123125.55+683749.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000075,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,187.8565417,68.63042,0.061,NULL,57850490909,903913920,14123655,18.3),(95832,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95832,38.36,0.14,470,40246,70,NULL,NULL,'SDSS J123126.28+670647.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000075,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,187.859541667,67.11322,0.021,NULL,57862560770,904102512,14126601,18.6),(95833,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95833,37.81,0.46,365,40247,70,NULL,NULL,'2MASX J12312645+0329590',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000188,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,187.860375,3.49967,0.038,NULL,58226510399,909789224,14215456,16.7),(95834,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95834,37.36,0.27,296,40248,70,NULL,NULL,'2MASX J12312700+0610021',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000166,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,187.862666667,6.16731,0,NULL,58235722164,909933158,14217705,17.2),(95835,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95835,38.42,0.46,482,40249,70,NULL,NULL,'LCRS B122853.6-023941',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000077,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,187.86575,-2.93742,0.061,NULL,42992792479,671762382,10496287,18.2),(95836,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95836,37.73,0.23,352,40250,70,NULL,NULL,'2MASX J12312938-0218397',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00007,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,187.872625,-2.31089,0.053,NULL,42997667501,671838554,10497477,17.6),(95837,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95837,36.77,0.46,226,40251,70,NULL,NULL,'2MASX J12312957+0940021',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000175,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,187.87325,9.66717,0,NULL,58189359020,909208734,14206386,16.4),(95838,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95838,38.24,0.46,444,40252,70,NULL,NULL,'2MASX J12312969+0701111',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,187.8737083,7.01967,0,NULL,58249061699,910141589,14220962,17.5),(95839,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95839,37.75,0.23,355,40253,70,NULL,NULL,'SDSS J123129.77+104313.4',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,187.874083333,10.72042,0.02,NULL,58191647435,909244491,14206945,18),(95840,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95840,37.86,0.46,374,40254,70,NULL,NULL,'2MASX J12312990+4917159',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000129,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,187.874583,49.28786,0,NULL,57236099808,894314059,13973657,17.7),(95841,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95841,36.78,0.46,227,40255,70,NULL,NULL,'2MASX J12313062-0121287',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000076,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,187.8777083,-1.35819,0.033,NULL,42998578539,671852789,10497699,16.9),(95842,'BL Lac Luminosity','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95842,39.45,NULL,668,40256,NULL,NULL,NULL,'[HB89] 1229+645',0.16294,'2005ApJ...635..173S',2005,1,0.23,NULL,'G',0.000197,NULL,'17.4g',0.19,'BLLAC',NULL,NULL,NULL,NULL,1,187.8807917,64.23842,0.005,NULL,57366761048,896355641,14005556,17.4),(95843,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95843,37.88,0.46,376,40257,70,NULL,NULL,'SDSS J123132.20+471503.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,187.88425,47.25089,0,NULL,59068132983,922939577,14420930,18.6),(95844,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95844,37.93,0.33,385,40258,70,NULL,NULL,'2MASX J12313230+3416076',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000137,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,187.884541667,34.26878,0.026,NULL,58770742913,918292858,14348325,17.8),(95845,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95845,37.87,0.33,374,40259,70,NULL,NULL,'2MASX J12313478+0648091',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,187.894917,6.80253,0,NULL,58249200363,910143755,14220996,17.2),(95846,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95846,37.7,0.46,347,40260,70,NULL,NULL,'2MASX J12313484+0038190',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000098,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,187.895083,0.63853,0.014,NULL,58012610625,906447041,14163235,16.7),(95847,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95847,35.88,0.65,150,40261,70,NULL,NULL,'2MASX J12313637-4610084',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,187.9017083,-46.16897,0.425,NULL,46713804000,729903187,11404737,14.5),(95848,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95848,38.03,0.46,403,40262,70,NULL,NULL,'2MASX J12313685+6727464',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000083,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,187.903458333,67.46297,0.009,NULL,57862659741,904104058,14126625,17.1),(95849,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95849,35.77,0.27,142,40263,70,NULL,NULL,'2MASX J12313733+5042169',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000176,NULL,'15.6g',0.32,'S0^-',NULL,NULL,NULL,NULL,1,187.905833,50.70481,0,NULL,57238769439,894355772,13974308,15.6),(95850,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95850,34.48,0.61,78.8,40264,70,NULL,NULL,'2MFGC 09866',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.000083,NULL,'16.36',0.19,NULL,NULL,NULL,NULL,NULL,1,187.907,-3.99136,0.089,NULL,43174918777,674608105,10540751,16.36),(95851,'Tully est','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95851,31.13,0.8,16.8,40265,75,NULL,'B','IC 3453',NULL,'1988NBGC.C....0000T',1988,1,1.53,'MRK 1328 is the \'head\' of the \\\"comet-like\\\" galaxy UGC 07666.','G',0.000017,NULL,'14.7g',0.43,'IBm: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,187.90725,14.85981,0.099,NULL,58157131198,908705174,14198518,14.7),(95852,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95852,37.51,0.33,318,40266,70,NULL,NULL,'2MASX J12313799-0009076',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000085,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,187.908375,-0.15225,0.065,NULL,42989633973,671713030,10495516,16.7),(95853,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95853,38.51,0.46,503,40267,70,NULL,NULL,'VPC 0828',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00018,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,187.908625,14.80492,0.099,NULL,58157131798,908705184,14198518,18.1),(95854,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95854,39.01,0.46,633,40268,70,NULL,NULL,'VPC 0826',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000181,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,187.909083,12.66797,0.125,NULL,58164187234,908815425,14200241,17.5),(95855,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95855,39.02,0.46,637,40269,70,NULL,NULL,'2MASX J12313824+1545371',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,187.909333,15.76039,0.037,NULL,58883411137,920053299,14375832,17.8),(95856,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95856,37.75,0.23,355,40270,70,NULL,NULL,'VPC 0825',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000181,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,187.910375,10.72056,0.02,NULL,58191649727,909244526,14206945,16.8),(95857,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95857,34.34,0.49,73.8,40271,75,NULL,'IR','IC 3454',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000033,NULL,'15.65',0.2,'Sb:            HII',NULL,NULL,NULL,NULL,1,187.9110417,27.49572,0.057,NULL,58610541465,915789710,14309214,15.65),(95858,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95858,30.3,0.02,11.5,40272,73,NULL,'Cepheids periods Gaussian ','NGC 4496A',NULL,'2009RoAJ...19...35A',2009,1,4,NULL,'G',0.00001,NULL,'11.94',3.2,'SB(rs)m        HII','Pair member (points to parent)',NULL,NULL,NULL,1,187.913375,3.93947,0.015,NULL,58227187298,909799801,14215621,11.94),(95859,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95859,30.56,0.03,12.9,40272,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian ','NGC 4496A',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95860,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95860,30.67,0.13,13.6,40272,NULL,NULL,'56, VI +Z','NGC 4496A',NULL,'1997ApJ...491...13K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95861,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95861,30.75,0.07,14.1,40272,NULL,NULL,'51, VI','NGC 4496A',NULL,'2001ApJ...547L.103G',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95862,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95862,30.77,0.1,14.3,40272,NULL,NULL,'56, VI','NGC 4496A',NULL,'1997ApJ...491...13K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95863,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95863,30.8,0.05,14.4,40272,NULL,NULL,'LMC W01','NGC 4496A',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95864,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95864,30.8,0.07,14.5,40272,NULL,NULL,'51, VI +z','NGC 4496A',NULL,'2001ApJ...547L.103G',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95865,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95865,30.81,0.03,14.5,40272,NULL,NULL,'94, VI, KEY PROJECT','NGC 4496A',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95866,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95866,30.81,0.03,14.5,40272,NULL,NULL,'MW HIPP','NGC 4496A',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95867,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95867,30.83,0.03,14.7,40272,73,NULL,'Cepheids magnitudes Gaussian ','NGC 4496A',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95868,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95868,30.83,0.04,14.7,40272,NULL,NULL,'cte LMC K03','NGC 4496A',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95869,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95869,30.84,0.04,14.7,40272,NULL,NULL,'cte U99','NGC 4496A',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95870,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95870,30.84,0.1,14.7,40272,74.4,NULL,NULL,'NGC 4496A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95871,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95871,30.87,0.04,14.9,40272,NULL,NULL,'cte LMC STS02','NGC 4496A',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95872,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95872,30.86,0.03,14.9,40272,NULL,NULL,'94, VI, +Z, KEY PROJECT','NGC 4496A',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95873,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95873,30.89,0.18,15.1,40272,NULL,NULL,'MW P02','NGC 4496A',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95874,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95874,30.93,0.04,15.3,40272,NULL,NULL,'cte MW FSG03','NGC 4496A',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95875,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95875,30.95,0.04,15.5,40272,NULL,NULL,'45, VI WF)','NGC 4496A',NULL,'2000ApJ...530L...5G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95876,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95876,30.96,0.04,15.6,40272,NULL,NULL,'cte MF91','NGC 4496A',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95877,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95877,30.97,0.04,15.7,40272,NULL,NULL,'cte MW GFG98','NGC 4496A',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95878,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95878,30.98,0.1,15.7,40272,NULL,NULL,'6, VI (PC)','NGC 4496A',NULL,'2000ApJ...530L...5G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95879,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95879,30.99,0.07,15.8,40272,NULL,NULL,'ALLFRAME, Key Project','NGC 4496A',NULL,'2000ApJ...529..723G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95880,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95880,31.02,0.07,16,40272,NULL,NULL,'HST KP Calibrated','NGC 4496A',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95881,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95881,31.02,0.07,16,40272,NULL,NULL,'ALLFRAME','NGC 4496A',NULL,'2000ApJ...529..723G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95882,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95882,31.02,0.07,16,40272,NULL,NULL,'51, VI','NGC 4496A',NULL,'2000ApJS..128..431F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95883,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95883,31.03,0.04,16.1,40272,NULL,NULL,'280, VI','NGC 4496A',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95884,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95884,31.03,0.14,16.1,40272,NULL,NULL,'45, VI','NGC 4496A',NULL,'1996ApJS..107..693S',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95885,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95885,31.03,0.04,16.1,40272,NULL,NULL,'MW GFG','NGC 4496A',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95886,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95886,31.05,0.04,16.2,40272,NULL,NULL,'cte MW STS03','NGC 4496A',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95887,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95887,31.09,0.04,16.5,40272,NULL,NULL,'45, I','NGC 4496A',NULL,'1996ApJS..107..693S',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95888,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95888,31.12,0.07,16.7,40272,NULL,NULL,'7, H','NGC 4496A',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95889,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95889,31.12,0.09,16.7,40272,NULL,NULL,'7, I','NGC 4496A',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95890,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95890,31.12,0.07,16.7,40272,NULL,NULL,'7, H','NGC 4496A',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95891,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95891,31.12,0.09,16.7,40272,NULL,NULL,'7, I','NGC 4496A',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95892,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95892,31.13,0.04,16.8,40272,NULL,NULL,'45, V','NGC 4496A',NULL,'1996ApJS..107..693S',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95893,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95893,31.13,0.07,16.8,40272,NULL,NULL,'Z, Key Project','NGC 4496A',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95894,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95894,31.18,0.05,17.2,40272,NULL,18.54,'LMC ZP','NGC 4496A',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95895,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95895,31.18,NULL,17.2,40272,NULL,18.54,NULL,'NGC 4496A',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95896,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95896,31.29,0.14,18.1,40272,NULL,NULL,'7, V','NGC 4496A',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95897,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95897,31.29,0.14,18.1,40272,NULL,NULL,'7, V','NGC 4496A',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95898,'Cepheids','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95898,31.37,NULL,18.8,40272,NULL,NULL,'142, VI','NGC 4496A',NULL,'2006A&A...452..423P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95899,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1960F',NULL,95899,30.7,0.36,13.8,40272,NULL,NULL,NULL,'NGC 4496A',NULL,'1992ApJ...390L..45P',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95900,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1960F','R',95900,30.77,NULL,14.3,40272,62.3,NULL,NULL,'NGC 4496A',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95901,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1960F',NULL,95901,30.82,0.15,14.6,40272,60,NULL,'M(V) = -19.47 mag','NGC 4496A',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95902,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1960F',NULL,95902,30.86,0.14,14.9,40272,60,NULL,NULL,'NGC 4496A',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95903,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1960F',NULL,95903,30.89,0.1,15.1,40272,60,NULL,'M(B) = -19.48 mag','NGC 4496A',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95904,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1960F','R',95904,31.23,NULL,17.6,40272,NULL,NULL,'Photographic','NGC 4496A',NULL,'1988SSRv...48....1R',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95905,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1960F',NULL,95905,31.5,NULL,20,40272,56,NULL,'M(B) = -19.8 mag','NGC 4496A',NULL,'1992ARA&A..30..359B',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95906,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95906,30.4,0.3,12,40272,NULL,18.45,'SN 1960F host','NGC 4496A',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95907,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95907,31.34,0.36,18.5,40272,NULL,NULL,NULL,'NGC 4496A',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95908,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95908,37.51,0.33,318,40273,70,NULL,NULL,'2MASX J12313919-0005056',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000099,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,187.913333,-0.085,0.065,NULL,42989622286,671712848,10495513,16.9),(95909,'IRAS','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95909,31.44,0.8,19.4,40274,75,NULL,'A82, H','NGC 4498',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000013,NULL,'12.79',1.6,'SAB(s)d        HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.914833333,16.85278,0.026,NULL,58883261869,920050966,14375796,12.79),(95910,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95910,30.34,0.42,11.7,40274,65,NULL,NULL,'NGC 4498',NULL,'1980ApJ...238..458M',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95911,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95911,30.66,0.43,13.6,40274,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4498',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95912,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95912,30.68,0.47,13.7,40274,75,NULL,'A82, H, inv','NGC 4498',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95913,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95913,30.72,0.43,13.9,40274,75,NULL,'3.6 micron, color corrected','NGC 4498',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95914,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95914,30.73,0.2,14,40274,74.4,NULL,NULL,'NGC 4498',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95915,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95915,30.74,0.35,14.1,40274,NULL,NULL,NULL,'NGC 4498',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95916,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95916,30.78,0.47,14.3,40274,75,NULL,'A82, H, raw','NGC 4498',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95917,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95917,30.91,0.46,15.2,40274,NULL,NULL,NULL,'NGC 4498',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95918,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95918,30.99,NULL,15.8,40274,NULL,NULL,NULL,'NGC 4498',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95919,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95919,31.05,0.43,16.2,40274,NULL,NULL,'Malmquist cor.','NGC 4498',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95920,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95920,31.1,0.47,16.6,40274,75,NULL,'A82, H, cor','NGC 4498',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95921,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95921,31.13,0.4,16.8,40274,75,NULL,'B','NGC 4498',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95922,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95922,31.66,0.47,21.5,40274,NULL,NULL,'H','NGC 4498',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95923,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95923,31.74,0.46,22.2,40274,NULL,NULL,'J','NGC 4498',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95924,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95924,31.77,0.45,22.6,40274,NULL,NULL,'K','NGC 4498',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95925,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95925,31.8,0.4,22.9,40274,NULL,NULL,'mean','NGC 4498',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95926,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95926,36.82,0.46,231,40275,70,NULL,NULL,'VPC 0830',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000176,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,187.915167,14.98483,0.084,NULL,58156554483,908696163,14198377,16.6),(95927,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95927,37.87,0.33,374,40276,70,NULL,NULL,'SDSS J123140.07+064927.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000155,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,187.9169583,6.82422,0,NULL,58249202382,910143787,14220996,18.3),(95928,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95928,37.07,0.16,259,40277,70,NULL,NULL,'2MASX J12314005+2842548',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,187.9169583,28.71519,0.07,NULL,58729637461,917650585,14338290,17.2),(95929,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95929,30.59,0.4,13.1,40278,75,NULL,'B','NGC 4496',NULL,'1988NBGC.C....0000T',1988,1,NULL,'Delta V > 1000 km/sec; probably an optical pair.','GPair',0.000255,NULL,NULL,NULL,'SBc',NULL,NULL,NULL,NULL,1,187.916667,3.93278,0.015,NULL,58227187397,909799803,14215621,NULL),(95930,'Tully est','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95930,30.64,0.8,13.4,40279,75,NULL,NULL,'NGC 4496B',NULL,'1988NBGC.C....0000T',1988,1,1.33,NULL,'G',0.000016,NULL,'14.0g',0.74,'IB(s)m:','Pair member (points to parent)',NULL,NULL,NULL,1,187.920333,3.92633,0.015,NULL,58227187382,909799802,14215621,14),(95931,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95931,36.44,0.46,194,40280,70,NULL,NULL,'2MASX J12314139+5441199',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00017,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,187.922583333,54.68886,0,NULL,57222513196,894101768,13970340,17),(95932,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95932,37.93,0.33,385,40281,70,NULL,NULL,'2MASX J12314166+3410027',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,187.923667,34.16744,NULL,NULL,58770762568,918293165,14348330,17.7),(95933,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95933,38.55,0.46,512,40282,70,NULL,NULL,'2MASX J12314210+5640059',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000138,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,187.92525,56.66836,0,NULL,57410892696,897045198,14016331,18.4),(95934,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95934,38.36,0.14,470,40283,70,NULL,NULL,'2MASX J12314237+6702254',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000065,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,187.926875,67.04058,0.021,NULL,57862575463,904102741,14126605,17.7),(95935,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95935,35.77,0.27,142,40284,70,NULL,NULL,'2MASX J12314301+5040189',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000161,NULL,'16.1g',0.34,'E0',NULL,NULL,NULL,NULL,1,187.929083333,50.67189,0,NULL,57238780639,894355947,13974311,16.1),(95936,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95936,37.67,0.33,342,40285,70,NULL,NULL,'2MASX J12314366+0633001',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000191,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,187.931958333,6.54994,0,NULL,58249305648,910145400,14221021,16.9),(95937,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95937,37.71,0.27,348,40286,70,NULL,NULL,'2MASX J12314423+0757361',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000135,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,187.93425,7.96011,0,NULL,58247095435,910110866,14220482,17.5),(95938,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95938,38.05,0.46,407,40287,70,NULL,NULL,'2MASX J12314579+3537257',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000166,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,187.940875,35.62378,0,NULL,58561600765,915025011,14297265,17.3),(95939,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95939,37.71,0.46,348,40288,70,NULL,NULL,'2MASX J12314662+0508400',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,187.94425,5.14442,0,NULL,58228262063,909816594,14215884,17.1),(95940,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95940,36.94,0.46,245,40289,70,NULL,NULL,'2MASX J12314669+0850431',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000188,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,187.9445,8.84536,0,NULL,58245084345,910079442,14219991,16.5),(95941,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95941,38.48,0.46,497,40290,70,NULL,NULL,'SDSS J123147.20+102604.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,187.9467083,10.43447,0.02,NULL,58191677825,909244966,14206952,18.4),(95942,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95942,37.67,0.33,342,40291,70,NULL,NULL,'2MASX J12314789+0632351',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,187.949375,6.54308,0,NULL,58249303809,910145372,14221021,17),(95943,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95943,37.75,0.23,355,40292,70,NULL,NULL,'SDSS J123147.98+104113.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000094,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,187.9499583,10.68717,0.02,NULL,58191657743,909244652,14206947,18.5),(95944,'Tully est','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95944,32.68,0.8,34.4,40293,75,NULL,NULL,'ARK 373',NULL,'1988NBGC.C....0000T',1988,1,0.25,NULL,'G',0.000009,NULL,'16.40',0.2,'WR             HII',NULL,NULL,NULL,NULL,1,187.9500417,-2.97031,0.057,NULL,42992771813,671762059,10496282,16.4),(95945,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95945,37.75,0.23,355,40294,70,NULL,NULL,'VPC 0833',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,187.9502083,10.74064,0.02,NULL,58191121373,909236271,14206816,17.1),(95946,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95946,37.73,0.23,352,40295,70,NULL,NULL,'2MASXi J1231488-020848',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000075,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,187.953375,-2.14697,0.053,NULL,42997682505,671838789,10497481,18.2),(95947,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95947,38.36,0.14,470,40296,70,NULL,NULL,'2MASX J12314935+6706405',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000083,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,187.955625,67.11147,0.021,NULL,57862566136,904102595,14126603,17.5),(95948,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95948,37.57,0.46,326,40297,70,NULL,NULL,'SDSS J123150.13+080613.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,187.958917,8.10372,0,NULL,58247134089,910111470,14220491,17.7),(95949,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95949,36.71,0.46,219,40298,70,NULL,NULL,'2MASX J12315225+2338029',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,187.967833,23.63419,0.033,NULL,58611525179,915805080,14309454,16.2),(95950,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95950,37.45,0.46,308,40299,70,NULL,NULL,'2MASX J12315301+0449424',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,187.9710417,4.82836,0,NULL,58228085486,909813835,14215841,16.8),(95951,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95951,37.91,0.23,381,40300,70,NULL,NULL,'SDSS J123153.29+051302.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000166,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,187.972083,5.21736,0,NULL,58228432257,909819254,14215925,18.4),(95952,'Tully est','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95952,32.69,0.8,34.5,40301,75,NULL,NULL,'ESO 218- G 008',NULL,'1988NBGC.C....0000T',1988,1,3.25,'Star superposed.','G',0.000022,NULL,'14.0',0.32,'SB?',NULL,NULL,NULL,NULL,1,187.973667,-51.74775,0.509,NULL,44626104204,697282878,10895044,14),(95953,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95953,32.76,NULL,35.6,40301,NULL,NULL,'Dipole','ESO 218- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95954,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95954,32.78,NULL,36,40301,NULL,NULL,'Dipole + Quadrupole','ESO 218- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95955,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95955,32.78,NULL,36,40301,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 218- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95956,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95956,37.73,0.23,352,40302,70,NULL,NULL,'2MASX J12315408-0205499',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00008,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,187.9754583,-2.09719,0.053,NULL,42997211829,671831434,10497366,17.3),(95957,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95957,30.48,0.43,12.5,40303,75,NULL,'3.6 micron, color + selection bias corrected','IC 0797',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.00002,NULL,'13.55',0.9,'SB(s)c II.5    HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,187.978167,15.12394,0.084,NULL,58156576730,908696511,14198382,13.55),(95958,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95958,30.68,0.43,13.6,40303,75,NULL,'3.6 micron, color corrected','IC 0797',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95959,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95959,30.81,0.2,14.5,40303,74.4,NULL,NULL,'IC 0797',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95960,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95960,31.3,0.36,18.2,40303,NULL,NULL,NULL,'IC 0797',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95961,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95961,31.83,NULL,23.2,40303,NULL,NULL,NULL,'IC 0797',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95962,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95962,36.11,0.59,167,40304,NULL,NULL,'Malmquist cor.','ESO 268- G 014',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'15.38',0.6,'S...',NULL,NULL,NULL,NULL,1,187.979083333,-46.13594,0.437,NULL,46713859266,729904051,11404750,15.38),(95963,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95963,36.61,0.47,210,40304,NULL,NULL,NULL,'ESO 268- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95964,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95964,36.65,0.2,214,40304,74.4,NULL,NULL,'ESO 268- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95965,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95965,37.07,0.16,259,40305,70,NULL,NULL,'2MASX J12315571+2849128',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00017,NULL,'16.4g',0.34,'E',NULL,NULL,NULL,NULL,1,187.982167,28.82019,0.07,NULL,58729560285,917649379,14338271,16.4),(95966,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95966,37.91,0.23,381,40306,70,NULL,NULL,'2MASX J12315600+0520054',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000192,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,187.98325,5.33503,0,NULL,58228363806,909818184,14215909,17.1),(95967,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95967,37.93,0.46,385,40307,70,NULL,NULL,'SDSS J123156.11+413639.7',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,187.9837917,41.61103,0,NULL,59060396876,922818701,14419042,17.8),(95968,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95968,37.78,0.46,360,40308,70,NULL,NULL,'SDSS J123156.44+113436.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000134,NULL,'18.0g',0.2,'AGN:',NULL,NULL,NULL,NULL,1,187.9852083,11.57675,0.025,NULL,58160135541,908752117,14199251,18),(95969,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95969,36.75,0.46,224,40309,70,NULL,NULL,'2MASX J12315763+5321039',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000143,NULL,'17.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,187.990125,53.35103,0,NULL,57230995496,894234304,13972411,17.6),(95970,'Tully est','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95970,29.93,0.8,9.7,40310,75,NULL,NULL,'UGC 07673',NULL,'1988NBGC.C....0000T',1988,1,1.4,NULL,'G',0.000017,NULL,'15.28',1.3,'ImIII-IV','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,187.9940417,29.70961,0.043,NULL,58778597492,918415585,14350243,15.28),(95971,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95971,36.48,0.46,198,40311,70,NULL,NULL,'2MASX J12315841-0229339',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000083,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,187.9932917,-2.49283,0.057,NULL,42997734192,671839596,10497493,16.3),(95972,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95972,38.19,0.46,436,40312,70,NULL,NULL,'2MASX J12315911+5729188',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,187.9959583,57.48867,0,NULL,57411311565,897051743,14016433,17.7),(95973,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95973,37.91,0.23,381,40313,70,NULL,NULL,'SDSS J123159.10+051320.2',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000145,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,187.99625,5.22231,0,NULL,58228430604,909819228,14215925,17.5),(95974,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1999cl',NULL,95974,30.12,0.24,10.5,40314,72,NULL,NULL,'MESSIER 088',0.00761,'2006ApJ...645..488W',2006,1,6.9,NULL,'G',0.00001,NULL,'9.56B',3.7,'SA(rs)b;HII    Sy2','in a radial-velocity based grouping',NULL,NULL,'Sy 2',1,187.9965,14.42039,0.087,NULL,58156717030,908698703,14198417,9.56),(95975,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1999cl',NULL,95975,30.35,0.26,11.7,40314,74.2,NULL,'SALT 2','MESSIER 088',0.00761,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95976,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1999cl',NULL,95976,30.6,0.16,13,40314,65,NULL,'MLCS2k2','MESSIER 088',0.00761,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95977,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1999cl',NULL,95977,30.77,0.4,14.1,40314,72,NULL,NULL,'MESSIER 088',0.00761,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95978,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1999cl',NULL,95978,30.83,0.6,14.5,40314,70,NULL,NULL,'MESSIER 088',0.00761,'2000ApJ...539..658K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95979,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1999cl','R',95979,30.84,NULL,14.7,40314,62.3,NULL,NULL,'MESSIER 088',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95980,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1999cl',NULL,95980,30.93,0.3,15.3,40314,60,NULL,NULL,'MESSIER 088',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95981,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1999cl',NULL,95981,30.94,0.05,15.3,40314,72,NULL,NULL,'MESSIER 088',0.00761,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95982,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1999cl',NULL,95982,30.96,0.2,15.6,40314,72,NULL,NULL,'MESSIER 088',NULL,'2006AJ....131.1639K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95983,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1999cl',NULL,95983,30.99,0.08,15.7,40314,72,NULL,NULL,'MESSIER 088',0.00761,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95984,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1999cl',NULL,95984,31.62,0.26,20.9,40314,70,NULL,'SALT','MESSIER 088',0.00761,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95985,'SNIa','2016-12-15 15:15:01','2016-12-16 11:20:12','1','SN 1999cl',NULL,95985,32.83,0.17,36.8,40314,70.8,NULL,NULL,'MESSIER 088',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95986,'Grav. Stability Gas. Disk','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95986,31.44,0.07,19.4,40314,58,NULL,'Assuming Virgo D = 20 Mpc','MESSIER 088',NULL,'1997ApJ...485..439B',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95987,'IRAS','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95987,31.43,0.8,19.3,40314,75,NULL,'A82, H','MESSIER 088',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95988,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95988,30.87,NULL,14.9,40314,NULL,NULL,NULL,'MESSIER 088',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95989,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95989,31.02,0.4,16,40314,75,NULL,'HOSTS SN 1999cl','MESSIER 088',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95990,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95990,31.11,0.92,16.7,40314,NULL,NULL,'CO','MESSIER 088',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95991,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95991,31.12,0.42,16.7,40314,65,NULL,NULL,'MESSIER 088',NULL,'1980ApJ...238..458M',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95992,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95992,31.13,0.4,16.8,40314,75,NULL,'B','MESSIER 088',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95993,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95993,31.2,0.7,17.4,40314,NULL,NULL,'HI','MESSIER 088',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95994,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95994,31.31,NULL,18.3,40314,NULL,NULL,'B','MESSIER 088',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95995,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95995,31.35,0.35,18.6,40314,NULL,NULL,NULL,'MESSIER 088',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95996,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95996,31.47,0.2,19.7,40314,74.4,NULL,NULL,'MESSIER 088',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95997,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95997,31.49,0.43,19.9,40314,75,NULL,'3.6 micron, color corrected','MESSIER 088',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95998,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',95998,31.5,NULL,20,40314,NULL,NULL,'LEDA [April 2006]','MESSIER 088',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95999,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,95999,31.51,0.4,20,40314,75,NULL,'HOSTS SN 1999cl','MESSIER 088',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96000,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96000,31.58,0.42,20.7,40314,NULL,18.48,'3.6 micron','MESSIER 088',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96001,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96001,31.59,0.39,20.8,40314,NULL,NULL,'Malmquist cor.','MESSIER 088',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96002,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96002,31.61,0.43,20.9,40314,75,NULL,'3.6 micron, color + selection bias corrected','MESSIER 088',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96003,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96003,31.61,0.39,21,40314,NULL,NULL,NULL,'MESSIER 088',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96004,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96004,31.64,0.69,21.3,40314,100,NULL,'mid-IR','MESSIER 088',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96005,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96005,31.79,0.47,22.8,40314,75,NULL,'A82, H, raw','MESSIER 088',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96006,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96006,31.89,0.47,23.9,40314,75,NULL,'A82, H, cor','MESSIER 088',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96007,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96007,31.98,0.3,24.9,40314,55,NULL,'B','MESSIER 088',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96008,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96008,32.09,0.47,26.2,40314,75,NULL,'A82, H, inv','MESSIER 088',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96009,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96009,37.36,0.46,297,40315,70,NULL,NULL,'2MASX J12320097+3427235',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,188.004,34.4565,0.026,NULL,58741464047,917835375,14341177,17),(96010,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96010,32.95,0.4,38.9,40316,NULL,NULL,'mean','NGC 4513',NULL,'2007A&A...465...71T',2007,1,1.21,NULL,'G',0.000088,NULL,'13.7g',0.88,'(R)SA0^0^','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,188.006333,66.33258,0.013,NULL,57320499311,895632801,13994262,13.7),(96011,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96011,33.57,0.45,51.7,40316,NULL,NULL,'K','NGC 4513',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96012,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96012,34.88,0.49,94.7,40317,75,NULL,'IR','MCG +08-23-050',NULL,'2011yCatp016004901K',2011,1,0.97,NULL,'G',0.000122,NULL,'15.8g',0.23,'Sc',NULL,NULL,NULL,NULL,1,188.0087917,46.34681,0,NULL,59066626837,922916044,14420563,15.8),(96013,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96013,35.38,NULL,119,40317,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG +08-23-050',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96014,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96014,35.4,NULL,120,40317,NULL,NULL,'Dipole + Quadrupole','MCG +08-23-050',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96015,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96015,35.42,NULL,121,40317,NULL,NULL,'Dipole','MCG +08-23-050',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96016,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96016,35.44,NULL,123,40317,NULL,NULL,NULL,'MCG +08-23-050',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96017,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96017,37.91,0.46,382,40318,70,NULL,NULL,'2MASX J12320255+5134059',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,188.010958333,51.56847,0,NULL,57241524515,894398820,13974981,17.5),(96018,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96018,31.6,0.12,20.9,40319,NULL,NULL,'TOM(g) = -7.2 mag','IC 3461',NULL,'2010ApJ...717..603V',2010,1,0.78,NULL,'G',0.000011,NULL,'15.1g',0.66,'dE,N','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,188.011417,11.89008,0.085,NULL,58160231681,908753620,14199275,15.1),(96019,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96019,31.65,0.14,21.4,40319,NULL,NULL,'TOM(g) = -7.2 mag','IC 3461',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96020,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96020,31.87,0.15,23.6,40319,NULL,NULL,'TOM(u) = -8.4 mag','IC 3461',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96021,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96021,31.95,0.14,24.5,40319,NULL,NULL,'TOM(z) = -8.53 mag','IC 3461',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96022,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96022,31.11,0.14,16.7,40319,74.4,NULL,NULL,'IC 3461',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96023,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96023,31.12,0.05,16.7,40319,NULL,NULL,NULL,'IC 3461',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96024,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96024,31.13,0.07,16.8,40319,NULL,NULL,'HST ACS VCS','IC 3461',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96025,'GC radius','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96025,30.38,0.14,11.9,40319,NULL,NULL,NULL,'IC 3461',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96026,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96026,31.84,0.4,23.3,40319,NULL,NULL,'mean','IC 3461',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96027,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96027,33.05,0.45,40.7,40319,NULL,NULL,'K','IC 3461',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96028,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96028,37.65,0.33,338,40320,70,NULL,NULL,'2MASX J12320312+6442295',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000184,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,188.0132083,64.70833,0.009,NULL,57322441589,895663149,13994736,16.8),(96029,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96029,32.2,0.36,27.5,40321,NULL,NULL,NULL,'NGC 4502',NULL,'2009AJ....138..323T',2009,1,1.1,NULL,'G',0.000017,NULL,'14.57',0.6,'Scd:           HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,188.0139583,16.68772,0.03,NULL,58883231004,920050484,14375788,14.57),(96030,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96030,32.52,0.62,32,40321,NULL,NULL,'Malmquist cor.','NGC 4502',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96031,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96031,32.6,0.6,33.2,40321,NULL,NULL,NULL,'NGC 4502',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96032,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96032,32.64,0.2,33.7,40321,74.4,NULL,NULL,'NGC 4502',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96033,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96033,36.49,0.46,199,40322,70,NULL,NULL,'2MASX J12320457+5108320',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000164,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,188.01925,51.14228,0,NULL,57241339535,894395930,13974936,16.4),(96034,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96034,38.23,0.46,443,40323,70,NULL,NULL,'2MASX J12320484+1606347',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,188.020333,16.10972,0.03,NULL,58883679479,920057491,14375898,17.6),(96035,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96035,31.15,NULL,17,40324,NULL,NULL,NULL,'IC 3466',NULL,'2014A&A...562A..49M',2014,1,0.58,'Noted in MCG as a possible interacting system.','G',0.000005,NULL,'15.8g',0.52,'pec,N','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,188.023666667,11.81792,0.085,NULL,58160251863,908753935,14199280,15.8),(96036,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96036,37.93,0.46,385,40325,70,NULL,NULL,'CGPG 1229.8+6423 NED01',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00018,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,188.024917,64.11111,0.005,NULL,57366805104,896356329,14005567,17.3),(96037,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96037,29.19,1.03,6.89,40326,95,NULL,'Weighted Mean','NGC 4503',NULL,'1984ApJS...56...91D',1984,1,3.5,NULL,'G',0.000017,NULL,'12.05',1.7,'SB0-:          PAS','in a radial-velocity based grouping',NULL,NULL,NULL,1,188.0259583,11.17642,0.014,NULL,58190103569,909220368,14206568,12.05),(96038,'Faber-Jackson','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96038,29.19,1.03,6.89,40326,95,NULL,'de Vaucouleurs','NGC 4503',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96039,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96039,30.35,NULL,11.7,40326,NULL,NULL,NULL,'NGC 4503',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96040,'Tertiary','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96040,30.49,0.25,12.5,40326,95,NULL,NULL,'NGC 4503',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96041,'Tully est','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96041,31.13,0.8,16.8,40326,75,NULL,'B','NGC 4503',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96042,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96042,30.2,0.45,11,40326,NULL,NULL,'K','NGC 4503',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96043,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96043,31.84,0.4,23.3,40326,NULL,NULL,'mean','NGC 4503',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96044,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96044,36.85,0.46,235,40327,70,NULL,NULL,'VII Zw 465',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000189,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,188.0269583,65.22614,0.013,NULL,57322206975,895659483,13994679,16.3),(96045,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96045,37.95,0.46,389,40328,70,NULL,NULL,'2MASX J12320714+2937528',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,188.029667,29.63122,0.058,NULL,58775118589,918361227,14349394,17.8),(96046,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96046,38.03,0.46,404,40329,70,NULL,NULL,'2MASX J12320713+1050271',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,188.029916667,10.84089,0.02,NULL,58190473032,909226141,14206658,18.1),(96047,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96047,35.77,0.27,142,40330,70,NULL,NULL,'2MASX J12320750+5037230',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,188.031583,50.62303,0,NULL,57238807664,894356369,13974318,16.3),(96048,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96048,37.55,0.33,324,40331,70,NULL,NULL,'2MASX J12320803+4320138',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000173,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,188.033333,43.33711,0,NULL,59061650882,922838295,14419348,17.1),(96049,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96049,37.64,0.46,337,40332,70,NULL,NULL,'SDSS J123209.15+130542.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,188.038167,13.09525,0.071,NULL,58166470510,908851101,14200798,18),(96050,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96050,37.72,0.46,350,40333,70,NULL,NULL,'SDSS J123209.18+021709.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000139,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,188.0382917,2.28589,0,NULL,58014536801,906477137,14163705,18.6),(96051,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96051,36.83,0.46,232,40334,70,NULL,NULL,'2MASX J12321359+6621294',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000075,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,188.056791667,66.35828,0.009,NULL,57320494155,895632721,13994261,17.7),(96052,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96052,37.54,0.46,322,40335,70,NULL,NULL,'2MASX J12321387+3010286',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,188.058,30.1745,0.031,NULL,58778868065,918419813,14350309,17.9),(96053,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96053,37.05,0.46,256,40336,70,NULL,NULL,'2MASX J12321416+0432514',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000166,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,188.059083,4.54761,0,NULL,58228726659,909823854,14215997,16.4),(96054,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96054,30.83,0.17,14.7,40337,NULL,NULL,'TOM(g) = -7.2 mag','IC 3468',NULL,'2010ApJ...717..603V',2010,1,1.18,NULL,'G',0.000033,NULL,'14.0g',1.03,'E1,N','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,188.0592083,10.25147,0.052,NULL,58190904743,909232886,14206763,14),(96055,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96055,30.91,0.28,15.2,40337,NULL,NULL,'TOM(g) = -7.2 mag','IC 3468',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96056,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96056,31,0.24,15.8,40337,NULL,NULL,'TOM(u) = -8.4 mag','IC 3468',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96057,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96057,31.05,0.17,16.2,40337,NULL,NULL,'TOM(z) = -8.53 mag','IC 3468',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96058,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96058,30.92,0.14,15.3,40337,74.4,NULL,NULL,'IC 3468',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96059,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96059,30.93,0.06,15.3,40337,NULL,NULL,NULL,'IC 3468',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96060,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96060,30.94,0.07,15.4,40337,NULL,NULL,'HST ACS VCS','IC 3468',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96061,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96061,31.64,0.18,21.3,40337,NULL,NULL,'R','IC 3468',NULL,'2004AJ....127..771J',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96062,'GC radius','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96062,30.38,0.14,11.9,40337,NULL,NULL,NULL,'IC 3468',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96063,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96063,30.82,0.45,14.6,40337,NULL,NULL,'K','IC 3468',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96064,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96064,31.84,0.4,23.3,40337,NULL,NULL,'mean','IC 3468',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96065,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96065,36.91,0.46,241,40338,70,NULL,NULL,'CGPG 1230.0+6414',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000167,NULL,'16.2g',0.39,'S0',NULL,NULL,NULL,NULL,1,188.070958333,63.95608,0.029,NULL,57366658818,896354044,14005531,16.2),(96066,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96066,35.49,0.52,125,40339,NULL,NULL,'Malmquist cor.','ESO 506- G 016',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.83',0.6,'SA(rs)b',NULL,NULL,NULL,NULL,1,188.071167,-22.98214,0.209,NULL,43914745864,686167904,10721373,15.83),(96067,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96067,35.7,0.47,138,40339,NULL,NULL,NULL,'ESO 506- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96068,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96068,35.74,0.2,141,40339,74.4,NULL,NULL,'ESO 506- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96069,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96069,36.14,0.46,169,40340,70,NULL,NULL,'CGCG 244-026',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.000163,NULL,'14.6g',0.65,'E0',NULL,NULL,NULL,NULL,1,188.072625,47.33717,0,NULL,59067671679,922932369,14420818,14.6),(96070,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96070,28.61,0.69,5.27,40341,100,NULL,'mid-IR','NGC 4504',NULL,'2013ApJ...771...88L',2013,1,4.4,NULL,'G',0.000007,NULL,'12.50',2.7,'SA(s)cd','X-ray-faint group member',NULL,NULL,NULL,1,188.0727083,-7.56344,0.037,NULL,43217767501,675277617,10551212,12.5),(96071,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96071,31.11,0.2,16.7,40341,74.4,NULL,NULL,'NGC 4504',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96072,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96072,31.19,0.43,17.3,40341,75,NULL,'3.6 micron, color corrected','NGC 4504',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96073,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96073,31.28,0.47,18,40341,NULL,NULL,NULL,'NGC 4504',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96074,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96074,31.27,0.43,18,40341,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4504',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96075,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96075,31.29,0.4,18.1,40341,NULL,NULL,NULL,'NGC 4504',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96076,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96076,31.3,0.47,18.2,40341,NULL,NULL,'Malmquist cor.','NGC 4504',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96077,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96077,31.45,0.4,19.5,40341,75,NULL,'B','NGC 4504',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96078,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96078,31.64,0.4,21.3,40341,NULL,NULL,'mean','NGC 4504',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96079,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96079,31.97,0.46,24.8,40341,NULL,NULL,'J','NGC 4504',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96080,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96080,31.98,0.47,24.9,40341,NULL,NULL,'H','NGC 4504',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96081,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96081,32.07,0.45,26,40341,NULL,NULL,'K','NGC 4504',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96082,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96082,37.31,0.46,289,40342,70,NULL,NULL,'2MASX J12321815+1202017',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,188.075875,12.03386,0.085,NULL,58159340435,908739694,14199057,18.4),(96083,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96083,36.42,0.46,193,40343,70,NULL,NULL,'VPC 0860',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000179,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,188.076208333,11.26114,0.014,NULL,58190652147,909228939,14206702,16.6),(96084,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96084,38.28,0.46,453,40344,70,NULL,NULL,'VPC 0862',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000202,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,188.078417,12.23656,0.099,NULL,58164316168,908817440,14200272,16.6),(96085,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96085,37.81,0.46,365,40345,70,NULL,NULL,'2MASX J12321906+0628475',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000179,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,188.0795,6.48003,0,NULL,58249276230,910144941,14221014,16.7),(96086,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96086,37.78,0.46,359,40346,70,NULL,NULL,'2MASX J12321947+2055354',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,188.081083333,20.92658,0.107,NULL,58911814065,920497094,14382767,17.9),(96087,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96087,38.16,0.46,429,40347,70,NULL,NULL,'2MASX J12321963-0051189',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000081,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,188.081667,-0.85544,0.045,NULL,42998899045,671857797,10497778,17.5),(96088,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96088,38.07,0.46,412,40348,70,NULL,NULL,'SDSS J123220.14+050722.1',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000203,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,188.083917,5.12283,0,NULL,58228452437,909819569,14215930,17.2),(96089,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96089,37.35,0.46,295,40349,70,NULL,NULL,'2MASX J12322016+2916594',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000133,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,188.084167,29.28333,0.058,NULL,58775298528,918364039,14349438,17),(96090,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96090,37.55,0.33,324,40350,70,NULL,NULL,'2MASX J12322147+4316406',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000184,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,188.089583,43.27794,0,NULL,59061655971,922838374,14419349,17),(96091,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96091,38.19,0.46,434,40351,70,NULL,NULL,'SDSS J123221.51+033719.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000144,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,188.089625,3.62211,0.025,NULL,58227362517,909802539,14215664,18.2),(96092,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96092,36.96,0.46,246,40352,70,NULL,NULL,'2MASX J12322215+4108535',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00017,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,188.092417,41.14825,0,NULL,59060097301,922814020,14418969,16.6),(96093,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96093,38.02,0.46,402,40353,70,NULL,NULL,'SDSS J123222.34+272455.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000174,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,188.093125,27.41544,0.049,NULL,58610616323,915790880,14309232,18.5),(96094,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96094,36.48,0.33,197,40354,70,NULL,NULL,'II Zw 065',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'15.6g',0.42,'S0?','Group member',NULL,NULL,NULL,1,188.095,16.30972,0.032,NULL,58883826113,920059783,14375934,15.6),(96095,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96095,37.18,0.33,272,40355,70,NULL,NULL,'2MASXi J1232230+000155',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000076,NULL,'17.6g',0.18,'NLAGN',NULL,NULL,NULL,NULL,1,188.095708333,0.03186,0.065,NULL,58008306398,906379787,14162184,17.6),(96096,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96096,36.48,0.33,197,40356,70,NULL,NULL,'2MASX J12322317+1614527',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,188.096625,16.24789,0.03,NULL,58883827848,920059810,14375934,17.3),(96097,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96097,31.29,0.17,18.1,40357,NULL,NULL,'TOM(g) = -7.2 mag','IC 3470',NULL,'2010ApJ...717..603V',2010,1,0.84,'1985AJ.....90.1681B has V = 2025 +- 75 km/sec.','G',0.00007,NULL,'14.4g',0.82,'dE0,N','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,188.0974583,11.26297,0.014,NULL,58190653914,909228967,14206702,14.4),(96098,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96098,31.33,0.19,18.5,40357,NULL,NULL,'TOM(g) = -7.2 mag','IC 3470',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96099,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96099,31.51,0.2,20.1,40357,NULL,NULL,'TOM(u) = -8.4 mag','IC 3470',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96100,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96100,31.58,0.19,20.7,40357,NULL,NULL,'TOM(z) = -8.53 mag','IC 3470',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96101,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96101,31,0.14,15.9,40357,74.4,NULL,NULL,'IC 3470',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96102,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96102,31.03,0.08,16,40357,NULL,NULL,'HST ACS VCS','IC 3470',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96103,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96103,31.04,0.06,16.1,40357,NULL,NULL,NULL,'IC 3470',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96104,'GC radius','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96104,30.82,0.06,14.6,40357,NULL,NULL,NULL,'IC 3470',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96105,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96105,38.14,0.46,424,40358,70,NULL,NULL,'2MASX J12322414+2322344',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,188.1007083,23.37631,0.033,NULL,58892808216,920200128,14378127,17.5),(96106,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96106,34.73,0.2,88.3,40359,74.4,NULL,NULL,'IC 3467',NULL,'2013AJ....146...86T',2013,1,1.42,NULL,'G',0.00001,NULL,'15.5g',0.26,'Scd:','Group member',NULL,NULL,NULL,1,188.102375,11.78758,0.085,NULL,58159467873,908741685,14199088,15.5),(96107,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96107,37.18,0.33,272,40360,70,NULL,NULL,'2MASX J12322466-0009266',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000092,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,188.102583,-0.15756,0.042,NULL,42989539455,671711553,10495493,16.5),(96108,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96108,37.66,0.46,341,40361,70,NULL,NULL,'2MASX J12322507+4054305',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000164,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,188.104667,40.90844,0,NULL,59060224008,922816000,14419000,17.1),(96109,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96109,37.06,0.46,258,40362,70,NULL,NULL,'2MASX J12322553-0226056',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00007,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,188.106375,-2.43483,0.057,NULL,42997845565,671841336,10497520,17.5),(96110,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96110,37.85,0.46,372,40363,70,NULL,NULL,'2MASX J12322617+0602445',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000175,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,188.1090417,6.04561,0,NULL,58235001257,909921894,14217529,17.7),(96111,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96111,29.37,0.4,7.5,40364,75,NULL,'B','UGC 07690',NULL,'1988NBGC.C....0000T',1988,1,1.46,'2004AJ....127.1943G: z = 0.0317 +- 0.0028; SDSS DR4: 0.001704 +- 0.000091.','G',0.00003,NULL,'13.5g',1.15,'Im:            HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,188.1120417,42.70411,0,NULL,59061621698,922837839,14419341,13.5),(96112,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96112,30.25,NULL,11.2,40364,NULL,NULL,NULL,'UGC 07690',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96113,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96113,37.17,0.46,272,40365,70,NULL,NULL,'2MASX J12322722+5953350',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,188.113333,59.89317,0,NULL,57336095848,895876497,13998070,17.5),(96114,'IRAS','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96114,31.91,0.8,24.1,40366,75,NULL,'A82, H','NGC 4517A',NULL,'1997ApJS..109..333W',1997,1,4,'Multiple SDSS entries describe this object.','G',0.000007,NULL,'12.9B',2.6,'SB(rs)dm:      HII','Pair member (points to parent)',NULL,NULL,NULL,1,188.117333,0.38967,0.03,NULL,58012684214,906448190,14163252,12.9),(96115,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96115,30.81,0.4,14.5,40366,75,NULL,'B','NGC 4517A',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96116,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96116,31.86,0.47,23.6,40366,75,NULL,'A82, H, inv','NGC 4517A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96117,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96117,31.95,0.47,24.5,40366,75,NULL,'A82, H, raw','NGC 4517A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96118,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96118,32.13,0.47,26.7,40366,75,NULL,'A82, H, cor','NGC 4517A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96119,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96119,36.84,0.46,233,40367,70,NULL,NULL,'2MASX J12322864+5757480',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000179,NULL,'16.0g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,188.1192083,57.96347,0,NULL,57409070933,897016733,14015886,16),(96120,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96120,34.75,0.49,89,40368,75,NULL,'IR','UGC 07689',NULL,'2011yCatp016004901K',2011,1,1.98,NULL,'G',0.00004,NULL,'15.0g',0.29,'Sc',NULL,NULL,NULL,NULL,1,188.12075,39.59006,0,NULL,58557602390,914962537,14296289,15),(96121,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96121,34.84,NULL,92.8,40368,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07689',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96122,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96122,34.85,NULL,93.2,40368,NULL,NULL,'Dipole + Quadrupole','UGC 07689',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96123,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96123,34.85,NULL,93.4,40368,NULL,NULL,'Dipole','UGC 07689',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96124,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96124,35.01,0.31,100,40368,NULL,NULL,NULL,'UGC 07689',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96125,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96125,35,0.2,100,40368,74.4,NULL,NULL,'UGC 07689',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96126,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96126,35.02,0.31,101,40368,NULL,NULL,'Malmquist cor.','UGC 07689',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96127,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96127,35.16,NULL,108,40368,NULL,NULL,NULL,'UGC 07689',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96128,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96128,35.69,0.46,137,40369,70,NULL,NULL,'2MASX J12323039+3122301',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00008,NULL,'16.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,188.12675,31.37492,0.026,NULL,58786241590,918535024,14352109,16),(96129,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96129,37.69,0.46,346,40370,70,NULL,NULL,'VPC 0868',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00017,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,188.12725,12.47914,0.074,NULL,58164478316,908819973,14200312,17.2),(96130,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96130,37.5,0.33,316,40371,70,NULL,NULL,'VPC 0869',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000174,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,188.132833,11.20636,0.013,NULL,58190657108,909229017,14206703,16.8),(96131,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96131,37.73,0.46,351,40372,70,NULL,NULL,'2MASX J12323192+2003414',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,188.133125,20.06167,NULL,NULL,58920841726,920638151,14384971,17),(96132,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96132,38.14,0.46,425,40373,70,NULL,NULL,'SDSS J123232.08+073633.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,188.1337083,7.60933,0,NULL,58249813955,910153343,14221145,17.8),(96133,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96133,37.9,0.46,380,40374,70,NULL,NULL,'2MASX J12323215+4106005',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000133,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,188.134166667,41.10017,0,NULL,59060099373,922814052,14418969,17.9),(96134,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96134,31.47,0.24,19.7,40375,NULL,NULL,'TOM(g) = -7.2 mag','IC 0798',NULL,'2010ApJ...717..603V',2010,1,0.63,NULL,'G',0.00007,NULL,'14.92',0.63,'E0','Group member',NULL,NULL,NULL,1,188.1392083,15.41539,0.066,NULL,58881410539,920022039,14375344,14.92),(96135,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96135,31.48,0.28,19.8,40375,NULL,NULL,'TOM(g) = -7.2 mag','IC 0798',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96136,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96136,31.7,0.23,21.9,40375,NULL,NULL,'TOM(u) = -8.4 mag','IC 0798',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96137,'GCLF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96137,31.8,0.22,22.9,40375,NULL,NULL,'TOM(z) = -8.53 mag','IC 0798',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96138,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96138,31.01,0.14,15.9,40375,74.4,NULL,NULL,'IC 0798',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96139,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96139,31.02,0.07,16,40375,NULL,NULL,NULL,'IC 0798',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96140,'SBF','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96140,31.03,0.08,16.1,40375,NULL,NULL,'HST ACS VCS','IC 0798',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96141,'Tully est','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96141,31.13,0.8,16.8,40376,75,NULL,'B','UGCA 284',NULL,'1988NBGC.C....0000T',1988,1,0.68,NULL,'G',0.000002,NULL,'14.9g',0.46,'E:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,188.139583,9.17367,0,NULL,58188766827,909199481,14206241,14.9),(96142,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96142,31.15,NULL,17,40376,NULL,NULL,NULL,'UGCA 284',NULL,'2014A&A...562A..49M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96143,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96143,33.49,0.49,49.8,40377,75,NULL,'IR','UGC 07700',NULL,'2011yCatp016004901K',2011,1,2,'Often mistakenly called NGC 4512.','G',0.000017,NULL,'14.3',1.4,'SB(s)dm','Pair member (points to parent)',NULL,NULL,NULL,1,188.139833333,63.87761,0.029,NULL,57374040095,896469376,14007334,14.3),(96144,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96144,37.07,0.46,260,40378,70,NULL,NULL,'2MASX J12323371+0113296',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00008,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,188.140541667,1.225,0.011,NULL,58012979861,906452810,14163325,17),(96145,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96145,37.5,0.33,316,40379,70,NULL,NULL,'VPC 0875',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,188.150667,11.21642,0.013,NULL,58190659355,909229052,14206703,17.7),(96146,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96146,31.21,0.2,17.5,40380,74.4,NULL,NULL,'IC 3474',NULL,'2013AJ....146...86T',2013,1,2.52,'ultiple SDSS entries describe this object.','G',0.000017,NULL,'14.76',0.25,'Sd(f)          HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,188.152125,2.66153,0,NULL,58013749522,906464836,14163513,14.76),(96147,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96147,31.23,0.56,17.6,40380,NULL,NULL,NULL,'IC 3474',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96148,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96148,31.29,0.43,18.1,40380,75,NULL,'3.6 micron, color + selection bias corrected','IC 3474',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96149,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96149,31.34,0.43,18.5,40380,75,NULL,'3.6 micron, color corrected','IC 3474',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96150,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96150,31.37,0.52,18.8,40380,NULL,NULL,'Malmquist cor.','IC 3474',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96151,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96151,31.46,0.4,19.6,40380,NULL,NULL,NULL,'IC 3474',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96152,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96152,31.51,NULL,20,40380,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 3474',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96153,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96153,31.53,NULL,20.2,40380,NULL,NULL,'Dipole + Quadrupole','IC 3474',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96154,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96154,31.54,NULL,20.3,40380,NULL,NULL,'Dipole','IC 3474',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96155,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96155,31.61,NULL,21,40380,NULL,NULL,NULL,'IC 3474',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96156,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96156,37.43,0.46,306,40381,70,NULL,NULL,'2MASX J12323661+0347546',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000159,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,188.1524583,3.79844,0.025,NULL,58227316976,909801827,14215653,16.5),(96157,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96157,36.96,0.46,246,40382,70,NULL,NULL,'2MASX J12323761+0359226',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000156,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,188.156667,3.98961,0,NULL,58226848777,909794512,14215539,16.9),(96158,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96158,37.64,0.46,337,40383,70,NULL,NULL,'2MASX J12323830+2319074',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,188.159375,23.31886,0.041,NULL,58892800485,920200007,14378125,17),(96159,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96159,38.28,0.46,453,40384,70,NULL,NULL,'LCRS B123004.5-024310',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000086,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,188.161,-2.99539,0.053,NULL,42992714215,671761159,10496268,18),(96160,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96160,38.15,0.46,427,40385,70,NULL,NULL,'SDSS J123238.66-022729.9',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000083,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,188.161083,-2.45833,0.053,NULL,42996944569,671827258,10497300,18.5),(96161,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96161,37.61,0.46,332,40386,70,NULL,NULL,'2MASX J12324090+4015364',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000136,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,188.170583333,40.26017,0,NULL,58556687728,914948245,14296066,17.7),(96162,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96162,37.66,0.46,340,40387,70,NULL,NULL,'2MASX J12324099+1721388',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,188.17075,17.36069,0.038,NULL,58914888057,920545125,14383517,17.2),(96163,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96163,30.39,0.43,12,40388,75,NULL,'3.6 micron, color + selection bias corrected','IC 3476',NULL,'2014MNRAS.444..527S',2014,1,2.1,'ASIAGO3 396 is a knot in IC 3476.','G',0.000017,NULL,'13.19',1.8,'IB(s)m:        HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,188.1745,14.05044,0.108,NULL,58165456649,908835260,14200550,13.19),(96164,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96164,30.43,0.62,12.2,40388,NULL,NULL,NULL,'IC 3476',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96165,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96165,30.62,0.2,13.3,40388,74.4,NULL,NULL,'IC 3476',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96166,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96166,30.65,0.43,13.5,40388,75,NULL,'3.6 micron, color corrected','IC 3476',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96167,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96167,30.83,0.51,14.7,40388,NULL,NULL,'Malmquist cor.','IC 3476',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96168,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96168,37.98,0.46,395,40389,70,NULL,NULL,'2MASX J12324244+1544478',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000168,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,188.176833333,15.74661,0.039,NULL,58881344726,920021011,14375328,18.3),(96169,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96169,35.4,0.4,120,40390,NULL,NULL,'mean','NGC 4514',NULL,'2007A&A...465...71T',2007,1,1.08,NULL,'G',0.000027,NULL,'14.3g',0.97,'Sbc            Sbrst',NULL,NULL,NULL,NULL,1,188.1790417,29.71239,0.058,NULL,58778647543,918416367,14350255,14.3),(96170,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96170,35.72,0.47,139,40390,NULL,NULL,'H','NGC 4514',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96171,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96171,37.27,0.46,285,40391,70,NULL,NULL,'2MASX J12324317+0231276',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000145,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,188.1797917,2.52431,0,NULL,58013728652,906464510,14163507,17.4),(96172,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96172,37.42,0.33,305,40392,70,NULL,NULL,'2MASX J12324324+3551532',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000175,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,188.1802083,35.86492,0,NULL,58564516113,915070564,14297977,16.2),(96173,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96173,36.99,0.46,250,40393,70,NULL,NULL,'2MASX J12324354+4135404',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000159,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,188.1815,41.59467,0,NULL,59060402279,922818785,14419043,17.2),(96174,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96174,37.42,0.33,305,40394,70,NULL,NULL,'2MASX J12324530+3550282',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,188.1885417,35.84114,0,NULL,58564388538,915068570,14297946,17.9),(96175,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96175,36.9,0.64,240,40395,70,NULL,NULL,'2MASX J12324526-5103237',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,188.1887083,-51.0565,0.953,NULL,44617539961,697149061,10892954,17.6),(96176,'TRGB','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96176,29.67,0.09,8.58,40396,74.4,NULL,NULL,'NGC 4517',NULL,'2013AJ....146...86T',2013,1,11.54,'Host galaxy of UM 505.','G',0.000017,NULL,'11.10',1.46,'SA(s)cd: sp    HII','Pair member (points to parent)',NULL,NULL,NULL,1,188.1899583,0.11503,0.03,NULL,58008337081,906380266,14162191,11.1),(96177,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96177,29.52,0.4,8,40396,73,NULL,'IR','NGC 4517',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96178,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96178,29.52,0.4,8,40396,75,NULL,NULL,'NGC 4517',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96179,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96179,29.67,0.09,8.58,40396,74.4,NULL,NULL,'NGC 4517',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96180,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96180,29.92,0.43,9.6,40396,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4517',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96181,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96181,29.93,NULL,9.68,40396,NULL,NULL,NULL,'NGC 4517',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96182,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96182,29.94,0.4,9.7,40396,NULL,NULL,NULL,'NGC 4517',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96183,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96183,29.94,0.36,9.73,40396,NULL,NULL,NULL,'NGC 4517',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96184,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96184,29.95,0.46,9.77,40396,NULL,NULL,'J','NGC 4517',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96185,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96185,29.96,0.4,9.8,40396,75,NULL,'B','NGC 4517',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96186,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96186,29.96,0.43,9.8,40396,75,NULL,'3.6 micron, color corrected','NGC 4517',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96187,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96187,30.02,0.47,10.1,40396,NULL,NULL,'H','NGC 4517',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96188,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96188,30.14,0.45,10.7,40396,NULL,NULL,'K','NGC 4517',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96189,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96189,30.25,NULL,11.2,40396,NULL,NULL,'Dipole','NGC 4517',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96190,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96190,30.25,NULL,11.2,40396,NULL,NULL,'Dipole + Quadrupole','NGC 4517',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96191,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96191,30.25,NULL,11.2,40396,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 4517',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96192,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96192,30.36,NULL,11.8,40396,NULL,NULL,NULL,'NGC 4517',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96193,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96193,30.88,0.49,15,40396,75,NULL,'IR','NGC 4517',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96194,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96194,31.5,0.4,20,40396,NULL,NULL,'mean','NGC 4517',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96195,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96195,38.29,0.46,456,40397,70,NULL,NULL,'2MASX J12324597+0559196',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000192,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,188.191416667,5.98892,0,NULL,58235008429,909922006,14217531,17),(96196,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96196,36.58,0.46,207,40398,70,NULL,NULL,'2MASX J12324617+0422096',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000174,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,188.192458333,4.36928,0,NULL,58228518030,909820594,14215946,16.8),(96197,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96197,37.78,0.46,360,40399,70,NULL,NULL,'2MASX J12324735+1703388',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,188.197208333,17.06086,0.028,NULL,58882199854,920034372,14375537,18.4),(96198,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96198,36.88,0.33,238,40400,70,NULL,NULL,'2MASX J12324742+1637568',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.17',0.15,NULL,NULL,NULL,NULL,NULL,1,188.197583333,16.63258,0.03,NULL,58883185899,920049779,14375777,18.17),(96199,'IRAS','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96199,30.01,0.8,10,40401,75,NULL,'A82, H','UGC 07699',NULL,'1997ApJS..109..333W',1997,1,2.84,NULL,'G',0.000003,NULL,'13.3g',0.78,'SBcd:          HII','Isolated galaxy',NULL,NULL,NULL,1,188.200083333,37.62178,0,NULL,58557956288,914968067,14296376,13.3),(96200,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96200,28.96,0.4,6.2,40401,75,NULL,'B','UGC 07699',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96201,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96201,30.78,0.4,14.3,40401,NULL,NULL,'Virgo cluster at 15.6 Mpc','UGC 07699',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96202,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96202,30.81,NULL,14.5,40401,NULL,NULL,NULL,'UGC 07699',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96203,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96203,31.26,0.47,17.9,40401,75,NULL,'A82, H, inv','UGC 07699',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96204,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96204,31.32,0.38,18.4,40401,NULL,NULL,NULL,'UGC 07699',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96205,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96205,31.32,0.43,18.4,40401,75,NULL,'3.6 micron, color + selection bias corrected','UGC 07699',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96206,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96206,31.38,0.47,18.9,40401,75,NULL,'A82, H, raw','UGC 07699',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96207,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96207,31.52,0.47,20.2,40401,75,NULL,'A82, H, cor','UGC 07699',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96208,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96208,36.88,0.46,237,40402,70,NULL,NULL,'2MASX J12324888+1649538',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.28',0.13,NULL,NULL,NULL,NULL,NULL,1,188.20375,16.83161,0.03,NULL,58882116740,920033074,14375516,18.28),(96209,'FP','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,'R',96209,37.65,0.33,338,40403,70,NULL,NULL,'2MASX J12324933+6437529',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,188.205875,64.63153,0.013,NULL,57322421205,895662831,13994731,17.9),(96210,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96210,34.52,0.6,80,40404,NULL,NULL,NULL,'VCC 1456',NULL,'2009ApJS..182..474S',2009,1,0.86,NULL,'G',0.000033,NULL,'15.3g',0.65,'SB?','Group member',NULL,NULL,NULL,1,188.207417,3.29989,0.035,NULL,58226632619,909791134,14215486,15.3),(96211,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96211,34.57,0.59,81.9,40404,NULL,NULL,'Malmquist cor.','VCC 1456',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96212,'Tully-Fisher','2016-12-15 15:15:01','2016-12-16 11:20:12','1',NULL,NULL,96212,34.61,0.2,83.6,40404,74.4,NULL,NULL,'VCC 1456',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96213,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96213,37.02,0.46,253,40405,70,NULL,NULL,'2MASX J12324985+0449296',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00019,NULL,'16.1g',0.38,NULL,NULL,NULL,NULL,NULL,1,188.207625,4.82492,0,NULL,58228154167,909814908,14215857,16.1),(96214,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96214,36.88,0.33,238,40406,70,NULL,NULL,'2MASX J12325006+1642018',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.37',0.18,NULL,NULL,NULL,NULL,NULL,1,188.208666667,16.70053,0.03,NULL,58882073243,920032394,14375506,17.37),(96215,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96215,36.41,0.46,192,40407,70,NULL,NULL,'2MASX J12325087+5030413',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000159,NULL,'15.9g',0.36,'LINER',NULL,NULL,NULL,NULL,1,188.212166667,50.51139,0,NULL,57239477889,894366842,13974481,15.9),(96216,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96216,31.15,NULL,17,40408,NULL,NULL,NULL,'VCC 1459',NULL,'2014A&A...562A..49M',2014,1,0.4,NULL,'G',0.000033,NULL,'16.3',0.2,'BCD:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,188.2140417,2.62972,0,NULL,58013776801,906465262,14163519,16.3),(96217,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96217,33.03,0.4,40.4,40409,NULL,NULL,NULL,'NGC 4529',NULL,'2009AJ....138..323T',2009,1,2.1,'Identification as NGC 4529 is uncertain; N4529 may be CGCG 129-006.','G',0.000037,NULL,'15.00',0.4,'Scd:',NULL,NULL,NULL,NULL,1,188.2152083,20.1835,NULL,NULL,58919776475,920621507,14384711,15),(96218,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96218,33.36,0.2,47,40409,74.4,NULL,NULL,'NGC 4529',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96219,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96219,33.4,0.4,47.9,40409,75,NULL,NULL,'NGC 4529',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96220,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96220,33.43,0.43,48.5,40409,75,NULL,'3.6 micron, color corrected','NGC 4529',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96221,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96221,33.5,0.43,50.2,40409,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4529',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96222,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96222,33.88,0.49,59.7,40409,75,NULL,'IR','NGC 4529',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96223,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96223,37.74,0.46,354,40410,70,NULL,NULL,'2MASX J12325198+0049266',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000087,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,188.216667,0.824,0.008,NULL,58013450004,906460156,14163439,17),(96224,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96224,35.26,0.5,113,40411,70,NULL,NULL,'2MASX J12325236-4724181',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00011,NULL,'15.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,188.218125,-47.40497,0.565,NULL,46712301584,729879712,11404370,15.3),(96225,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96225,36.67,0.46,216,40412,70,NULL,NULL,'VPC 0886',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000179,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,188.222,11.02058,0.013,NULL,58190718828,909229981,14206718,16.5),(96226,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96226,37.09,0.46,261,40413,70,NULL,NULL,'2MASX J12325352+2453292',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,188.223,24.89133,0.05,NULL,58613827646,915841056,14310016,17.2),(96227,'Brightest Stars','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96227,28.93,NULL,6.1,40414,NULL,NULL,NULL,'UGC 07698',NULL,'1998A&AS..128..459M',1998,1,6.5,NULL,'G',0.000003,NULL,'13.0',4.5,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,188.226625,31.54111,0.026,NULL,58786263461,918535366,14352115,13),(96228,'TRGB','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96228,28.54,0.09,5.11,40414,74.4,NULL,NULL,'UGC 07698',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96229,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96229,27.88,0.4,3.8,40414,75,NULL,'B','UGC 07698',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96230,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96230,28.54,0.09,5.11,40414,74.4,NULL,NULL,'UGC 07698',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96231,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96231,37.41,0.46,303,40415,70,NULL,NULL,'2MASX J12325465+5642539',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000166,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,188.227917,56.715,0.013,NULL,57410873746,897044902,14016326,17.8),(96232,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96232,38.72,0.46,555,40416,70,NULL,NULL,'CGPG 1230.6+6424',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,188.22825,64.13017,0.013,NULL,57366795486,896356179,14005565,18.1),(96233,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96233,37.91,0.23,381,40417,70,NULL,NULL,'2MASX J12325489+0522246',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000175,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,188.228583,5.37367,0,NULL,58227625919,909806654,14215728,17.4),(96234,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96234,38.36,0.14,470,40418,70,NULL,NULL,'SDSS J123254.90+670940.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00008,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,188.2287917,67.16133,0.009,NULL,57862570193,904102659,14126604,18.5),(96235,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96235,37.77,0.46,359,40419,70,NULL,NULL,'SDSS J123255.09-014334.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000077,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,188.2295417,-1.72625,0.029,NULL,42997152028,671830500,10497351,18.3),(96236,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96236,38.36,0.14,470,40420,70,NULL,NULL,'SDSS J123256.06+670113.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00007,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,188.233583333,67.02053,0.021,NULL,57862546065,904102282,14126598,18.5),(96237,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96237,35.61,0.46,132,40421,70,NULL,NULL,'SDSS J123256.75+112324.2',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',NULL,NULL,'15.8g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,188.2365,11.39008,0.011,NULL,58189797022,909215578,14206493,15.8),(96238,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96238,37,0.46,251,40422,70,NULL,NULL,'2MASX J12325765+4815433',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000176,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,188.240125,48.26203,0,NULL,59065168667,922893260,14420207,16.4),(96239,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96239,36.32,0.44,184,40423,NULL,NULL,'Malmquist cor.','2MASX J12325971+0323386',NULL,'2009ApJS..182..474S',2009,1,0.52,NULL,'G',0.000013,NULL,'16.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,188.24875,3.39397,0.035,NULL,58226585543,909790399,14215474,16.4),(96240,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96240,36.35,0.43,186,40423,NULL,NULL,NULL,'2MASX J12325971+0323386',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96241,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96241,36.39,0.2,190,40423,74.4,NULL,NULL,'2MASX J12325971+0323386',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96242,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96242,37.98,0.46,394,40424,70,NULL,NULL,'SDSS J123300.63+060231.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,188.252625,6.042,0,NULL,58248430543,910131727,14220808,18.1),(96243,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96243,37.53,0.33,320,40425,70,NULL,NULL,'2MASX J12330076+3508282',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,188.252958333,35.14114,0,NULL,58561814421,915028350,14297317,17),(96244,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96244,37.45,0.46,309,40426,70,NULL,NULL,'2MASX J12330102+0144436',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000178,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,188.254417,1.74531,0.009,NULL,58014084891,906470076,14163594,16.9),(96245,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96245,37.47,0.46,311,40427,70,NULL,NULL,'2MASX J12330423+4927163',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000141,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,188.267416667,49.45456,0,NULL,57236364178,894318190,13973721,17.7),(96246,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96246,31.27,0.14,17.9,40428,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4515',NULL,'2010ApJ...717..603V',2010,1,1.3,NULL,'G',0.000037,NULL,'13.3',1.1,'S0-:','in a radial-velocity based grouping',NULL,NULL,NULL,1,188.2707083,16.26553,0.032,NULL,58883750212,920058597,14375915,13.3),(96247,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96247,31.29,0.16,18.1,40428,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4515',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96248,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96248,31.64,0.19,21.3,40428,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4515',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96249,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96249,31.73,0.18,22.2,40428,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4515',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96250,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96250,31.01,0.12,15.9,40428,74.4,NULL,NULL,'NGC 4515',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96251,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96251,31.1,0.06,16.6,40428,NULL,NULL,NULL,'NGC 4515',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96252,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96252,31.11,0.07,16.7,40428,NULL,NULL,'HST ACS VCS','NGC 4515',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96253,'GC radius','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96253,30.7,0.16,13.8,40428,NULL,NULL,NULL,'NGC 4515',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96254,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96254,30.82,NULL,14.6,40428,NULL,NULL,NULL,'NGC 4515',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96255,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96255,31.01,0.12,15.9,40428,74.4,NULL,NULL,'NGC 4515',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96256,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96256,35.59,0.46,131,40429,70,NULL,NULL,'2MASX J12330605+0046416',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000074,NULL,'16.1g',0.22,'S0',NULL,NULL,NULL,NULL,1,188.275167,0.77833,0.008,NULL,58013395059,906459297,14163426,16.1),(96257,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96257,30.02,NULL,10.1,40430,NULL,NULL,NULL,'NGC 4509',NULL,'2013AJ....145..101K',2013,1,0.9,NULL,'G',0.00003,NULL,'14.10',0.6,'Sab pec?       HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,188.2782917,32.09156,0.02,NULL,58772092192,918313940,14348655,14.1),(96258,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96258,37.21,0.46,276,40431,70,NULL,NULL,'2MASX J12330943+2047303',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,188.289417,20.79164,0.107,NULL,58911787401,920496678,14382760,16.9),(96259,'Tully est','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96259,31.13,0.8,16.8,40432,75,NULL,'B','IC 3483',NULL,'1988NBGC.C....0000T',1988,1,0.5,NULL,'G',0.00003,NULL,'15.7',0.4,'SAB(s)b pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,188.291917,11.34733,0.011,NULL,58189806371,909215724,14206495,15.7),(96260,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96260,36.76,0.46,225,40433,70,NULL,NULL,'2MASX J12331096+0004539',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000073,NULL,'17.2g',0.22,'NLAGN',NULL,NULL,NULL,NULL,1,188.295667,0.08164,0.029,NULL,58008285896,906379467,14162179,17.2),(96261,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96261,37.66,0.46,340,40434,70,NULL,NULL,'2MASX J12331137-0136220',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000075,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,188.2975,-1.60628,0.029,NULL,42997179370,671830927,10497358,17.2),(96262,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96262,37.53,0.33,320,40435,70,NULL,NULL,'2MASX J12331140+3504244',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000142,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,188.2977083,35.07342,0,NULL,58561816803,915028387,14297318,18.1),(96263,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96263,38.04,0.46,405,40436,70,NULL,NULL,'2MASX J12331241+4010344',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,188.301917,40.17636,0,NULL,58556718862,914948732,14296073,18.3),(96264,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96264,37.65,0.46,339,40437,70,NULL,NULL,'2MASX J12331286+1544297',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,188.303666667,15.74167,0.039,NULL,58881016629,920015884,14375248,17.5),(96265,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96265,36.69,0.46,218,40438,70,NULL,NULL,'2MASX J12331335+3424434',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,188.305583,34.41219,NULL,NULL,58741312278,917833004,14341140,17.2),(96266,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96266,31.34,0.42,18.5,40439,NULL,NULL,'TOM(g) = -7.2 mag','IC 3487',NULL,'2007ApJS..171..101J',2007,1,1.02,NULL,'G',0.000082,NULL,'14.9g',0.58,'dE','Group member',NULL,NULL,NULL,1,188.306,9.39736,0,NULL,58189626052,909212907,14206451,14.9),(96267,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96267,31.35,0.3,18.6,40439,NULL,NULL,'TOM(g) = -7.2 mag','IC 3487',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96268,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96268,31.43,0.54,19.3,40439,NULL,NULL,'TOM(u) = -8.4 mag','IC 3487',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96269,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96269,31.62,0.39,21.1,40439,NULL,NULL,'TOM(z) = -8.53 mag','IC 3487',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96270,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96270,31.03,0.14,16.1,40439,74.4,NULL,NULL,'IC 3487',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96271,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96271,31.05,0.13,16.2,40439,NULL,NULL,'HST ACS VCS','IC 3487',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96272,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96272,31.18,0.44,17.2,40440,NULL,NULL,'TOM(g) = -7.2 mag','IC 3490',NULL,'2007ApJS..171..101J',2007,1,0.6,NULL,'G',0.000167,NULL,'15.89',0.3,'E?','Group member',NULL,NULL,NULL,1,188.307917,10.92853,0.006,NULL,58190715736,909229933,14206717,15.89),(96273,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96273,31.18,0.15,17.2,40440,NULL,NULL,'TOM(g) = -7.2 mag','IC 3490',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96274,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96274,31.56,0.38,20.5,40440,NULL,NULL,'TOM(u) = -8.4 mag','IC 3490',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96275,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96275,31.69,0.28,21.8,40440,NULL,NULL,'TOM(z) = -8.53 mag','IC 3490',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96276,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96276,31.28,0.14,18,40440,74.4,NULL,NULL,'IC 3490',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96277,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96277,31.3,0.16,18.2,40440,NULL,NULL,'HST ACS VCS','IC 3490',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96278,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96278,31.01,0.4,15.9,40441,NULL,NULL,'mean','IC 3486',NULL,'2007A&A...465...71T',2007,1,0.84,'Identified incorrectly as IC 3492 in CGCG.','G',0.00014,NULL,'15.2g',0.57,'dE,N','Group member',NULL,NULL,NULL,1,188.308375,12.85783,0.078,NULL,58163827525,908809805,14200153,15.2),(96279,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96279,32.36,0.45,29.6,40441,NULL,NULL,'K','IC 3486',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96280,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96280,37.01,0.46,252,40442,70,NULL,NULL,'2MASX J12331400+0311056',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000176,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,188.308333,3.18486,0.035,NULL,58226397193,909787456,14215429,17.2),(96281,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96281,37.7,0.46,346,40443,70,NULL,NULL,'SDSS J123316.70+034534.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000142,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,188.319625,3.75964,0.025,NULL,58226807258,909793863,14215529,17.9),(96282,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96282,36.62,0.46,211,40444,70,NULL,NULL,'2MASX J12331679+3501094',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000093,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,188.3199583,35.01933,0,NULL,58561850784,915028918,14297326,16.7),(96283,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96283,37.88,0.46,377,40445,70,NULL,NULL,'2MASX J12331703+3719403',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000149,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,188.320958333,37.32783,0,NULL,58565302109,915082845,14298169,18.4),(96284,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96284,37.11,0.46,264,40446,70,NULL,NULL,'2MASX J12331763+4934149',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000123,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,188.323333,49.57072,0,NULL,57236489202,894320143,13973752,16.7),(96285,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96285,37.51,0.46,318,40447,70,NULL,NULL,'SDSS J123319.64+273320.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000144,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,188.331875,27.55569,0.062,NULL,58610467481,915788554,14309196,18.1),(96286,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96286,31.7,0.69,21.8,40448,NULL,NULL,'TOM(g) = -7.2 mag','IC 3492',NULL,'2007ApJS..171..101J',2007,1,0.5,NULL,'G',0.000117,NULL,'15.09',0.4,'E?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,188.332416667,12.85344,0.078,NULL,58163830039,908809844,14200153,15.09),(96287,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96287,31.76,0.6,22.5,40448,NULL,NULL,'TOM(g) = -7.2 mag','IC 3492',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96288,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96288,32.02,0.53,25.4,40448,NULL,NULL,'TOM(z) = -8.53 mag','IC 3492',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96289,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96289,32.21,0.67,27.6,40448,NULL,NULL,'TOM(u) = -8.4 mag','IC 3492',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96290,'Tully est','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96290,31.13,0.8,16.8,40448,75,NULL,'B','IC 3492',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96291,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96291,35.45,0.58,123,40449,70,NULL,NULL,'2MASX J12332028-4730151',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,188.334583,-47.50414,0.557,NULL,46712318395,729879974,11404374,17.4),(96292,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96292,37.48,0.46,313,40450,70,NULL,NULL,'VPC 0902',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000123,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,188.335667,12.378,0.097,NULL,58164510343,908820474,14200319,16.5),(96293,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96293,36.42,0.46,192,40451,70,NULL,NULL,'2MASX J12332177+5241159',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00017,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,188.34075,52.68783,0.048,NULL,57230347514,894224179,13972252,16.5),(96294,'IRAS','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96294,33.49,0.8,49.9,40452,75,NULL,'MAT, I','ESO 442- G 002',NULL,'1997ApJS..109..333W',1997,1,1.66,NULL,'G',0.00003,NULL,'16.42',0.13,'Sc',NULL,NULL,NULL,NULL,1,188.342083,-28.72667,0.289,NULL,43423988533,678499820,10601559,16.42),(96295,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96295,33.67,NULL,54.2,40452,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 442- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96296,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96296,33.69,NULL,54.7,40452,NULL,NULL,'Dipole + Quadrupole','ESO 442- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96297,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96297,33.7,NULL,54.8,40452,NULL,NULL,'Dipole','ESO 442- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96298,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96298,33.72,NULL,55.4,40452,NULL,NULL,NULL,'ESO 442- G 002',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96299,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96299,33.78,0.32,57,40452,85,NULL,'I, inv','ESO 442- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96300,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96300,33.81,0.32,57.8,40452,85,NULL,'I, raw','ESO 442- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96301,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96301,34.04,0.43,64.4,40452,75,NULL,'MAT, I, inv','ESO 442- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96302,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96302,34.09,0.43,65.6,40452,75,NULL,'MAT, I, raw','ESO 442- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96303,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96303,34.25,0.2,70.8,40452,74.4,NULL,NULL,'ESO 442- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96304,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96304,34.39,0.58,75.4,40452,NULL,NULL,NULL,'ESO 442- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96305,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96305,34.45,0.57,77.6,40452,NULL,NULL,'Malmquist cor.','ESO 442- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96306,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96306,34.46,0.43,77.9,40452,75,NULL,'MAT, I, cor','ESO 442- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96307,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96307,29.19,NULL,6.89,40453,NULL,NULL,NULL,'KUG 1230+336',NULL,'2013AJ....145..101K',2013,1,0.3,NULL,'G',0.000003,NULL,'18.6g',0.13,'dwarf Irr',NULL,NULL,NULL,NULL,1,188.3537083,33.35125,0.032,NULL,58774076657,918344947,14349139,18.6),(96308,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96308,37.72,0.46,350,40454,70,NULL,NULL,'SDSS J123326.20+265924.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,188.359167,26.99006,0.044,NULL,58610228219,915784815,14309137,18.1),(96309,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96309,37.48,0.46,314,40455,70,NULL,NULL,'2MASX J12332633+1613587',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,188.3597917,16.23311,0.032,NULL,58882881176,920045018,14375703,17.5),(96310,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96310,38,0.46,398,40456,70,NULL,NULL,'2MASX J12332810+0607337',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,188.36725,6.12614,0,NULL,58248645711,910135089,14220860,17.7),(96311,'IRAS','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96311,31.49,0.8,19.9,40457,75,NULL,'A82, H','NGC 4519',NULL,'1997ApJS..109..333W',1997,1,2.69,NULL,'G',0.000003,NULL,'12.9g',1.75,'SB(rs)d        HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,188.3760417,8.65475,0,NULL,58244251355,910066427,14219787,12.9),(96312,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96312,31.13,0.4,16.8,40457,75,NULL,'B','NGC 4519',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96313,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96313,31.33,NULL,18.5,40457,NULL,NULL,NULL,'NGC 4519',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96314,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96314,31.46,0.35,19.6,40457,NULL,NULL,NULL,'NGC 4519',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96315,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96315,31.82,0.42,23.1,40457,65,NULL,NULL,'NGC 4519',NULL,'1980ApJ...238..458M',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96316,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96316,32.2,0.6,27.6,40457,NULL,NULL,'Malmquist cor.','NGC 4519',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96317,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96317,32.45,0.54,30.9,40457,NULL,NULL,NULL,'NGC 4519',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96318,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96318,32.49,0.2,31.5,40457,74.4,NULL,NULL,'NGC 4519',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96319,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96319,32.57,0.3,32.6,40457,55,NULL,'B','NGC 4519',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96320,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96320,32.73,0.47,35.1,40457,75,NULL,'A82, H, raw','NGC 4519',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96321,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96321,32.8,0.47,36.3,40457,75,NULL,'A82, H, inv','NGC 4519',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96322,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96322,32.84,0.47,36.9,40457,75,NULL,'A82, H, cor','NGC 4519',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96323,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96323,36.89,0.46,238,40458,70,NULL,NULL,'2MASX J12333216-0041316',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00008,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,188.383917,-0.69206,0.057,NULL,42998041431,671844397,10497568,17.4),(96324,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96324,38.36,0.14,470,40459,70,NULL,NULL,'2MASXi J1233338+670618',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00007,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,188.390917,67.10489,0.033,NULL,57862552964,904102390,14126599,18.1),(96325,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96325,38.36,0.46,469,40460,70,NULL,NULL,'2MASX J12333412+3101525',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000175,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,188.3922917,31.03139,0.024,NULL,58785692118,918526439,14351975,17.2),(96326,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96326,37.23,0.46,279,40461,70,NULL,NULL,'LCRS B123100.0-030727',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.0001,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,188.393083,-3.4,0.041,NULL,43174262466,674597851,10540591,16.9),(96327,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96327,31.29,0.14,18.1,40462,74.4,NULL,NULL,'VCC 1512',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000117,NULL,'15.73',0.4,'S0?','Group member',NULL,NULL,NULL,1,188.394417,11.26194,0.011,NULL,58189762757,909215043,14206485,15.73),(96328,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96328,31.31,0.07,18.3,40462,NULL,NULL,'HST ACS VCS','VCC 1512',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96329,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96329,31.32,0.05,18.4,40462,NULL,NULL,NULL,'VCC 1512',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96330,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96330,37.4,0.46,302,40463,70,NULL,NULL,'2MASX J12333557+3402585',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000187,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,188.398125,34.04953,0.049,NULL,58741621967,917837843,14341216,17.1),(96331,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96331,35.71,0.46,139,40464,70,NULL,NULL,'2MASX J12333580+2248042',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000063,NULL,'16.55',0.27,NULL,NULL,NULL,NULL,NULL,1,188.399291667,22.80114,0.036,NULL,58895724883,920245701,14378839,16.55),(96332,'Tully est','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96332,31.9,0.8,24,40465,75,NULL,NULL,'UGCA 286',NULL,'1988NBGC.C....0000T',1988,1,2.3,'One APM position refers to the southeast end of the galaxy.','G',0.000003,NULL,'14.38',0.4,'SBm: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,188.4042083,-4.885,0.081,NULL,43173476820,674585575,10540399,14.38),(96333,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96333,30.62,0.4,13.3,40465,NULL,NULL,NULL,'UGCA 286',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96334,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96334,31.39,0.43,19,40465,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 286',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96335,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96335,37.19,0.46,275,40466,70,NULL,NULL,'2MASX J12333718+3957084',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000185,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,188.404917,39.95233,0,NULL,58556902333,914951598,14296118,16.8),(96336,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96336,38.66,0.46,540,40467,70,NULL,NULL,'2MASX J12333774+3741224',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000199,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,188.4072917,37.68947,0,NULL,58557848693,914966385,14296349,17),(96337,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96337,37.46,0.13,310,40468,70,NULL,NULL,'2MASX J12333789+1635033',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,188.4077083,16.58414,0.029,NULL,58882538217,920039659,14375619,17.4),(96338,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96338,37.87,0.46,375,40469,70,NULL,NULL,'2MASX J12333852+2847010',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000134,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,188.410583,28.78367,0.055,NULL,58729369684,917646401,14338225,17.8),(96339,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96339,37.68,0.46,344,40470,70,NULL,NULL,'2MASX J12333858+1640473',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,188.410625,16.67972,0.029,NULL,58882533694,920039588,14375618,17.2),(96340,'IRAS','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96340,31.4,0.8,19.1,40471,75,NULL,'A82, H','NGC 4522',NULL,'1997ApJS..109..333W',1997,1,3.95,NULL,'G',0.000003,NULL,'13.0g',0.84,'SB(s)cd: sp    HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,188.4154583,9.17503,0,NULL,58188840673,909200635,14206259,13),(96341,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96341,30.48,0.42,12.5,40471,65,NULL,NULL,'NGC 4522',NULL,'1980ApJ...238..458M',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96342,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96342,30.63,0.43,13.4,40471,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4522',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96343,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96343,30.71,NULL,13.9,40471,NULL,NULL,NULL,'NGC 4522',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96344,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96344,30.73,0.43,14,40471,75,NULL,'3.6 micron, color corrected','NGC 4522',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96345,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96345,30.8,0.2,14.5,40471,74.4,NULL,NULL,'NGC 4522',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96346,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96346,30.96,0.47,15.6,40471,75,NULL,'A82, H, inv','NGC 4522',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96347,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96347,30.97,0.46,15.6,40471,NULL,NULL,NULL,'NGC 4522',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96348,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96348,31.02,0.47,16,40471,75,NULL,'A82, H, raw','NGC 4522',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96349,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96349,31.03,0.35,16.1,40471,NULL,NULL,NULL,'NGC 4522',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96350,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96350,31.1,0.43,16.6,40471,NULL,NULL,'Malmquist cor.','NGC 4522',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96351,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96351,31.13,0.4,16.8,40471,75,NULL,'B','NGC 4522',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96352,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96352,31.31,0.47,18.3,40471,75,NULL,'A82, H, cor','NGC 4522',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96353,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96353,31.44,0.49,19.4,40471,75,NULL,'IR','NGC 4522',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96354,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96354,31.81,0.47,23,40471,NULL,NULL,'H','NGC 4522',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96355,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96355,31.84,0.46,23.3,40471,NULL,NULL,'J','NGC 4522',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96356,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96356,31.89,0.45,23.9,40471,NULL,NULL,'K','NGC 4522',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96357,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96357,32.56,0.4,32.6,40471,NULL,NULL,'mean','NGC 4522',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96358,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96358,35.93,0.57,153,40472,70,NULL,NULL,'2MASX J12334007-0839268',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000097,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,188.4169583,-8.65747,0.061,NULL,43206600947,675103139,10548486,15.8),(96359,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96359,37.61,0.46,333,40473,70,NULL,NULL,'2MASX J12334076+5055420',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000142,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,188.419917,50.92828,0,NULL,57236866765,894326043,13973844,16.8),(96360,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96360,33.72,NULL,55.5,40474,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 506- G 018',NULL,'2010Ap&SS.325..163P',2010,1,1.55,NULL,'G',0.000023,NULL,'16.93',0.11,'Sc',NULL,NULL,NULL,NULL,1,188.423708333,-23.68064,0.277,NULL,43392454765,678007105,10593861,16.93),(96361,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96361,33.73,NULL,55.8,40474,NULL,NULL,'Dipole + Quadrupole','ESO 506- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96362,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,NULL,96362,33.75,NULL,56.3,40474,NULL,NULL,'Dipole','ESO 506- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96363,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96363,38.36,0.14,470,40475,70,NULL,NULL,'2MASX J12334194+6712531',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000077,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,188.424125,67.21472,0.005,NULL,57862760877,904105638,14126650,18.2),(96364,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96364,36.82,0.46,231,40476,70,NULL,NULL,'2MASX J12334230+0423479',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000155,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,188.426291667,4.39661,0,NULL,58227959139,909811861,14215810,16.7),(96365,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96365,37.8,0.21,364,40477,70,NULL,NULL,'2MASX J12334471+0532219',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000181,NULL,'16.1g',0.4,'BrClG',NULL,NULL,NULL,NULL,1,188.43625,5.53939,0,NULL,58227476227,909804316,14215692,16.1),(96366,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96366,37.95,0.46,390,40478,70,NULL,NULL,'2MASX J12334475+0807575',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,188.436583,8.13278,0,NULL,58246479118,910101236,14220331,17.5),(96367,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96367,38.36,0.14,470,40479,70,NULL,NULL,'SDSS J123346.20+670310.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00008,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,188.4425417,67.05281,0.033,NULL,57862550591,904102352,14126599,18.3),(96368,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96368,38.16,0.46,429,40480,70,NULL,NULL,'SDSS J123346.23+334806.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00017,NULL,'18.49',0.21,NULL,NULL,NULL,NULL,NULL,1,188.442625,33.80178,0.025,NULL,58771198224,918299972,14348437,18.49),(96369,'FP','2016-12-15 15:15:02','2016-12-16 11:20:12','1',NULL,'R',96369,37.3,0.46,288,40481,70,NULL,NULL,'2MASX J12334708+2125295',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,188.446166667,21.42503,0.112,NULL,58911514105,920492407,14382693,17.3),(96370,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96370,35.77,0.41,143,40482,NULL,NULL,'Malmquist cor.','ESO 268- G 018',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'16.17',0.3,'S...',NULL,NULL,NULL,NULL,1,188.4464583,-46.42197,0.453,NULL,46713762284,729902535,11404727,16.17),(96371,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96371,36.02,0.36,160,40482,NULL,NULL,NULL,'ESO 268- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96372,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96372,36.06,0.2,163,40482,74.4,NULL,NULL,'ESO 268- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96373,'Brightest Stars','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96373,29.03,NULL,6.4,40483,NULL,NULL,NULL,'NGC 4523',NULL,'2000Ap.....43..367T',2000,1,2,'The 2MASS position applies to the compact object 11 arcsec southeast.','G',0.000013,NULL,'14.42',1.9,'SAB(s)m        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,188.45,15.16831,0.077,NULL,58881683099,920026298,14375410,14.42),(96374,'Brightest Stars','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96374,30.6,0.3,13.2,40483,NULL,NULL,NULL,'NGC 4523',NULL,'1992MNRAS.256p..29S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96375,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96375,31.13,0.4,16.8,40483,75,NULL,'B','NGC 4523',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96376,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96376,37.09,0.46,262,40484,70,NULL,NULL,'2MASX J12334865+1831395',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.70',0.13,NULL,NULL,NULL,NULL,NULL,1,188.4527083,18.52761,0.053,NULL,58919160976,920611890,14384560,17.7),(96377,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96377,35.25,0.55,112,40485,NULL,NULL,NULL,'ESO 380- G 043',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'15.5',0.8,'Sb',NULL,NULL,NULL,NULL,1,188.454416667,-37.75539,0.313,NULL,43245559393,675711865,10557997,15.5),(96378,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96378,35.28,0.54,114,40485,NULL,NULL,'Malmquist cor.','ESO 380- G 043',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96379,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96379,35.29,0.2,114,40485,74.4,NULL,NULL,'ESO 380- G 043',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96380,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96380,34.72,0.2,87.9,40486,74.4,NULL,NULL,'IC 3500',NULL,'2013AJ....146...86T',2013,1,0.62,NULL,'G',0.000007,NULL,'16.2g',0.41,'SBc','Group member',NULL,NULL,NULL,1,188.456958333,13.96278,0.074,NULL,58165464820,908835387,14200552,16.2),(96381,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96381,37.27,0.46,284,40487,70,NULL,NULL,'2MASX J12334969+4324334',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,188.45725,43.40928,0,NULL,59061642781,922838168,14419346,17.7),(96382,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96382,38.03,0.46,404,40488,70,NULL,NULL,'VPC 0921',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000192,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,188.4577917,12.62242,0.097,NULL,58163930691,908811417,14200178,16.9),(96383,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 2000bk',NULL,96383,34.63,0.12,82.2,40489,74.2,NULL,'SALT 2','NGC 4520',0.02544,'2010ApJ...716..712A',2010,1,3.5,NULL,'G',0.00013,NULL,'14.47',2.2,'SA0- pec sp',NULL,NULL,NULL,NULL,1,188.457917,-7.37556,0.045,NULL,43214235361,675222427,10550350,14.47),(96384,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 2000bk',NULL,96384,35.13,0.09,106,40489,74.4,NULL,NULL,'NGC 4520',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96385,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 2000bk',NULL,96385,35.18,0.12,109,40489,70.8,NULL,NULL,'NGC 4520',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96386,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 2000bk',NULL,96386,35.27,0.05,110,40489,72,NULL,NULL,'NGC 4520',0.02544,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96387,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 2000bk',NULL,96387,35.34,0.06,114,40489,72,NULL,NULL,'NGC 4520',0.025444,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96388,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 2000bk',NULL,96388,35.34,0.08,114,40489,72,NULL,NULL,'NGC 4520',0.02544,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96389,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 2000bk',NULL,96389,35.39,0.16,114,40489,65,NULL,'MLCS2k2','NGC 4520',0.02544,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96390,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 2000bk',NULL,96390,35.36,0.21,115,40489,65,NULL,NULL,'NGC 4520',0.02544,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96391,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 2000bk',NULL,96391,35.36,0.05,115,40489,72,NULL,NULL,'NGC 4520',0.02544,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96392,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 2000bk',NULL,96392,35.41,0.18,118,40489,70,NULL,'SALT 2','NGC 4520',0.02544,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96393,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 2000bk',NULL,96393,35.52,0.09,124,40489,70,NULL,'SALT','NGC 4520',0.02544,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96394,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 2000bk',NULL,96394,35.47,0.07,124,40489,72,NULL,'M(H) = -18.317 mag','NGC 4520',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96395,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 2000bk',NULL,96395,35.48,0.23,125,40489,65,NULL,'LC','NGC 4520',NULL,'2001AJ....122.1616K',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96396,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 2000bk',NULL,96396,35.53,0.21,128,40489,65,NULL,'MLCS','NGC 4520',NULL,'2001AJ....122.1616K',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96397,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 2000bk',NULL,96397,35.78,0.14,143,40489,60,NULL,NULL,'NGC 4520',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96398,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96398,35.32,0.48,116,40489,70,NULL,NULL,'NGC 4520',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96399,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96399,37.62,0.46,334,40490,70,NULL,NULL,'2MASX J12335039+0216455',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000183,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,188.459917,2.27939,0,NULL,58013651788,906463309,14163489,16.7),(96400,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96400,36.93,0.46,244,40491,70,NULL,NULL,'2MASX J12335046+0152455',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00018,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,188.460375,1.87931,0.009,NULL,58000303680,906254745,14160230,16.2),(96401,'Tully est','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96401,29.93,0.8,9.7,40492,75,NULL,'B','NGC 4525',NULL,'1988NBGC.C....0000T',1988,1,2.37,NULL,'G',0.000013,NULL,'13.4g',0.96,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,188.463083,30.27747,0.031,NULL,58778136742,918408386,14350131,13.4),(96402,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96402,29.9,0.69,9.53,40492,100,NULL,'mid-IR','NGC 4525',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96403,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96403,30.07,0.43,10.3,40492,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4525',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96404,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96404,30.23,0.43,11.1,40492,75,NULL,'3.6 micron, color corrected','NGC 4525',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96405,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96405,30.32,0.4,11.6,40492,NULL,NULL,NULL,'NGC 4525',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96406,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96406,30.39,0.2,12,40492,74.4,NULL,NULL,'NGC 4525',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96407,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96407,30.71,0.47,13.9,40492,NULL,NULL,NULL,'NGC 4525',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96408,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96408,30.9,0.43,15.1,40492,NULL,NULL,'Malmquist cor.','NGC 4525',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96409,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96409,31.32,0.47,18.3,40492,NULL,NULL,'H','NGC 4525',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96410,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96410,31.33,0.46,18.4,40492,NULL,NULL,'J','NGC 4525',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96411,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96411,31.4,0.4,19.1,40492,NULL,NULL,'mean','NGC 4525',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96412,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96412,31.44,0.45,19.4,40492,NULL,NULL,'K','NGC 4525',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96413,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96413,34.78,0.48,90.5,40493,70,NULL,NULL,'2MASX J12335124-4616323',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000087,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,188.463583,-46.27572,0.453,NULL,46713792677,729903010,11404734,16),(96414,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96414,30.75,0.14,14.1,40494,NULL,NULL,'TOM(g) = -7.2 mag','IC 3501',NULL,'2010ApJ...717..603V',2010,1,0.89,NULL,'G',0.000082,NULL,'14.6g',0.72,'d:E1','Group member',NULL,NULL,NULL,1,188.465083,13.32244,0.069,NULL,58165196920,908831201,14200487,14.6),(96415,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96415,30.75,0.15,14.1,40494,NULL,NULL,'TOM(g) = -7.2 mag','IC 3501',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96416,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96416,31.02,0.14,16,40494,NULL,NULL,'TOM(u) = -8.4 mag','IC 3501',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96417,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96417,31.14,0.13,16.9,40494,NULL,NULL,'TOM(z) = -8.53 mag','IC 3501',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96418,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96418,31.05,0.14,16.2,40494,74.4,NULL,NULL,'IC 3501',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96419,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96419,31.06,0.06,16.3,40494,NULL,NULL,NULL,'IC 3501',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96420,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96420,31.07,0.08,16.3,40494,NULL,NULL,'HST ACS VCS','IC 3501',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96421,'GC radius','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96421,30.64,0.1,13.4,40494,NULL,NULL,NULL,'IC 3501',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96422,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96422,38.65,0.46,537,40495,70,NULL,NULL,'SDSS J123352.14+024846.4',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,188.46725,2.81292,0.02,NULL,58013515959,906461186,14163456,18.1),(96423,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96423,36.01,0.82,160,40496,70,NULL,NULL,'2MASX J12335274-5025184',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,188.4697917,-50.42181,0.801,NULL,44618387813,697162309,10893161,15.6),(96424,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96424,35.59,0.46,131,40497,70,NULL,NULL,'2MASX J12335353+4739244',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000174,NULL,'16.1g',0.32,'S0^-',NULL,NULL,NULL,NULL,1,188.472917,47.65667,0,NULL,59064992288,922890504,14420164,16.1),(96425,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96425,33.35,0.69,46.8,40498,100,NULL,'mid-IR','NGC 4524',NULL,'2013ApJ...771...88L',2013,1,1.2,NULL,'G',0.00012,NULL,'14.27',0.8,'SAB(r)bc       HII',NULL,NULL,NULL,NULL,1,188.476625,-12.02761,0.105,NULL,43048449539,672632024,10509875,14.27),(96426,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96426,33.81,0.2,57.8,40498,74.4,NULL,NULL,'NGC 4524',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96427,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96427,33.88,0.37,59.6,40498,NULL,NULL,'Malmquist cor.','NGC 4524',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96428,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96428,33.98,0.36,62.6,40498,NULL,NULL,NULL,'NGC 4524',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96429,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96429,34.27,0.4,71.6,40498,NULL,NULL,'mean','NGC 4524',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96430,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96430,34.44,0.47,77.2,40498,NULL,NULL,'H','NGC 4524',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96431,'GRB','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96431,41.44,1.2,1170,40499,69.7,NULL,'Fiducial','GRB 050416',0.6535,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,188.477375,21.05747,0.108,NULL,58912112357,920501755,14382839,NULL),(96432,'GRB','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96432,42.83,0.88,2230,40499,72,NULL,NULL,'GRB 050416',0.6535,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96433,'GRB','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96433,42.84,0.84,2240,40499,70,NULL,NULL,'GRB 050416',0.6535,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96434,'GRB','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96434,43.32,0.81,2790,40499,69.7,NULL,'Calibrated','GRB 050416',0.6535,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96435,'GRB','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96435,43.98,0.85,3780,40499,69.7,NULL,'Fiducial','GRB 050416',0.6535,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96436,'GRB','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96436,44.73,1.14,5340,40499,69.7,NULL,'Fiducial','GRB 050416',0.6535,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96437,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96437,36.61,0.46,210,40500,70,NULL,NULL,'2MASX J12335495+0551455',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000133,NULL,'15.4g',0.46,'AGN',NULL,NULL,NULL,NULL,1,188.478875,5.86269,0,NULL,58248408011,910131375,14220802,15.4),(96438,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96438,31.56,0.4,20.5,40501,NULL,NULL,NULL,'UGCA 287',NULL,'2013MNRAS.429.2677K',2013,1,1.8,NULL,'G',0.00003,NULL,'15',0.9,'SAB(s)m:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,188.479833,-10.67989,0.081,NULL,43160876337,674388692,10537323,15),(96439,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96439,35.39,0.49,120,40502,75,NULL,'IR','ESO 268- G 019',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'16.14',0.4,'S',NULL,NULL,NULL,NULL,1,188.4827917,-45.84283,0.441,NULL,46713920905,729905014,11404765,16.14),(96440,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96440,35.62,0.43,133,40502,NULL,NULL,'Malmquist cor.','ESO 268- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96441,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96441,35.74,0.4,140,40502,NULL,NULL,NULL,'ESO 268- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96442,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96442,35.78,0.2,143,40502,74.4,NULL,NULL,'ESO 268- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96443,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96443,37.8,0.21,364,40503,70,NULL,NULL,'2MASX J12335609+0537435',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,188.4837917,5.62867,0,NULL,58227437697,909803714,14215683,17.3),(96444,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96444,30.42,0.43,12.1,40504,75,NULL,'3.6 micron, color + selection bias corrected','IC 0800',NULL,'2014MNRAS.444..527S',2014,1,1.51,NULL,'G',0.000016,NULL,'13.9g',1.01,'SB(rs)c pec?   HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,188.486083,15.35483,0.043,NULL,58881695588,920026493,14375413,13.9),(96445,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96445,30.61,0.43,13.2,40504,75,NULL,'3.6 micron, color corrected','IC 0800',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96446,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96446,30.72,0.2,13.9,40504,74.4,NULL,NULL,'IC 0800',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96447,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96447,30.93,NULL,15.3,40504,NULL,NULL,NULL,'IC 0800',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96448,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96448,32.61,0.4,33.2,40504,NULL,NULL,'mean','IC 0800',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96449,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96449,35.08,0.47,104,40504,NULL,NULL,'H','IC 0800',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96450,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96450,37.59,0.46,330,40505,70,NULL,NULL,'2MASX J12335688+1342093',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,188.487083,13.70258,0.062,NULL,58165533029,908836453,14200569,18.2),(96451,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96451,37.51,0.46,317,40506,70,NULL,NULL,'2MASX J12335715+0612025',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000168,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,188.488208333,6.20069,0,NULL,58248506620,910132915,14220826,16.8),(96452,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96452,36.69,0.46,218,40507,70,NULL,NULL,'2MASX J12335762+0954575',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000182,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,188.4900417,9.91606,0,NULL,58188913348,909201771,14206277,16.6),(96453,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96453,37.8,0.21,364,40508,70,NULL,NULL,'2MASX J12335784+0536155',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.95',0.16,NULL,NULL,NULL,NULL,NULL,1,188.4910417,5.60431,0,NULL,58227435571,909803680,14215682,17.95),(96454,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96454,36.47,0.46,197,40509,70,NULL,NULL,'2MASX J12335831+4901549',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.0002,NULL,'15.9g',0.4,'E0',NULL,NULL,NULL,NULL,1,188.492958333,49.03186,0,NULL,57181055328,893453989,13960218,15.9),(96455,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96455,29.75,0.4,8.9,40510,75,NULL,'B','UGC 07719',NULL,'1988NBGC.C....0000T',1988,1,0.62,NULL,'G',0.000017,NULL,'15.7g',0.4,'Sdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,188.50225,39.01917,0,NULL,58560508942,915007952,14296999,15.7),(96456,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96456,37.46,0.13,310,40511,70,NULL,NULL,'2MASX J12340196+1620438',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.02',0.16,NULL,NULL,NULL,NULL,NULL,1,188.508333,16.34558,0.026,NULL,58882904927,920045389,14375709,18.02),(96457,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96457,29.96,0.5,9.82,40512,NULL,NULL,NULL,'NGC 4526',NULL,'1995A&A...294L...9W',1995,1,7.2,'z=0.001494 (1991RC3.9.C...0000d)','G',0.000017,NULL,'10.66',2.4,'SAB(s)0^0^:','in a radial-velocity based grouping',NULL,NULL,NULL,1,188.512875,7.69953,0.01,NULL,58246940294,910108442,14220444,10.66),(96458,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96458,30.4,0.3,12,40512,NULL,NULL,NULL,'NGC 4526',NULL,'1999A&A...349..877D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96459,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96459,30.7,0.16,13.8,40512,NULL,NULL,NULL,'NGC 4526',NULL,'1998AGM....14..P95D',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96460,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96460,30.86,0.09,14.9,40512,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4526',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96461,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96461,30.89,0.1,15,40512,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4526',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96462,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96462,30.91,0.09,15.2,40512,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4526',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96463,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96463,31.03,0.09,16.1,40512,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4526',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96464,'PNLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96464,30.51,0.05,12.6,40512,NULL,NULL,'94','NGC 4526',NULL,'2007ApJ...657...76F',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96465,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1994D',NULL,96465,30.07,0.42,10.3,40512,85,NULL,NULL,'NGC 4526',NULL,'1995A&A...294L...9W',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96466,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1994D',NULL,96466,30.24,0.12,11.2,40512,70.8,NULL,NULL,'NGC 4526',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96467,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1994D',NULL,96467,30.4,0.3,12,40512,NULL,NULL,NULL,'NGC 4526',NULL,'1999A&A...349..877D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96468,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1994D',NULL,96468,30.8,0.3,14.5,40512,NULL,NULL,NULL,'NGC 4526',NULL,'2001ApJ...557..266L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96469,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1994D',NULL,96469,30.88,0.08,15,40512,74.4,NULL,NULL,'NGC 4526',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96470,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1994D',NULL,96470,31.02,0.19,16,40512,72,NULL,NULL,'NGC 4526',0.00149,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96471,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1994D',NULL,96471,31.1,0.26,16,40512,67,NULL,NULL,'NGC 4526',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96472,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1994D',NULL,96472,31.02,0.25,16,40512,68,NULL,NULL,'NGC 4526',NULL,'1996ApJ...465L..83R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96473,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1994D',NULL,96473,31.05,0.25,16.2,40512,NULL,NULL,NULL,'NGC 4526',NULL,'1995ApJ...443...89H',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96474,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1994D',NULL,96474,31.15,0.05,17,40512,60,NULL,'M(I) = -19.19 mag','NGC 4526',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96475,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1994D',NULL,96475,31.19,0.07,17.2,40512,65,NULL,'MLCS2k2','NGC 4526',0.00149,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96476,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1994D',NULL,96476,31.18,0.07,17.2,40512,60,NULL,'M(B) = -19.48 mag','NGC 4526',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96477,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1994D',NULL,96477,31.2,0.06,17.4,40512,60,NULL,'M(V) = -19.47 mag','NGC 4526',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96478,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1994D','R',96478,31.3,NULL,18.2,40512,62.3,NULL,NULL,'NGC 4526',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96479,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1994D',NULL,96479,31.39,0.14,19,40512,60,NULL,NULL,'NGC 4526',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96480,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1994D',NULL,96480,31.41,0.22,19.1,40512,65,NULL,'avg. of 6 SNIa and hosts','NGC 4526',NULL,'1996AJ....112.2398H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96481,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96481,30.88,0.08,15,40512,74.4,NULL,NULL,'NGC 4526',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96482,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96482,31.14,0.2,16.9,40512,NULL,NULL,'I','NGC 4526',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96483,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96483,31.14,0.2,16.9,40512,NULL,NULL,'I','NGC 4526',NULL,'2001ApJ...559..584A',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96484,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96484,31.19,0.22,17.3,40512,NULL,NULL,'HST KP Calibrated, I','NGC 4526',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96485,'Faber-Jackson','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96485,30.23,0.63,11.1,40512,95,NULL,'Michard 1979b, c','NGC 4526',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96486,'Faber-Jackson','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96486,30.25,0.46,11.2,40512,95,NULL,'Michard 1979a','NGC 4526',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96487,'Faber-Jackson','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96487,30.91,0.28,15.2,40512,95,NULL,'Weighted Mean','NGC 4526',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96488,'Faber-Jackson','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96488,31.43,NULL,19.3,40512,NULL,NULL,'LEDA [April 2006]','NGC 4526',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96489,'Faber-Jackson','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96489,31.47,0.37,19.7,40512,95,NULL,'de Vaucouleurs','NGC 4526',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96490,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96490,30.91,NULL,15.2,40512,NULL,NULL,NULL,'NGC 4526',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96491,'Tertiary','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96491,30.49,0.25,12.5,40512,95,NULL,NULL,'NGC 4526',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96492,'Tully est','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96492,31.13,0.8,16.8,40512,75,NULL,'B','NGC 4526',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96493,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96493,31.02,0.4,16,40512,75,NULL,'HOSTS SN 1994D','NGC 4526',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96494,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96494,37.6,0.46,331,40513,70,NULL,NULL,'2MASX J12340326-0148469',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00007,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,188.513583,-1.81306,0.041,NULL,42985962528,671655664,10494619,17.5),(96495,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96495,37.8,0.21,364,40514,70,NULL,NULL,'2MASX J12340360+0536225',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00018,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,188.514958333,5.60636,0,NULL,58227436141,909803689,14215682,17.5),(96496,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96496,37.43,0.27,306,40515,70,NULL,NULL,'2MASX J12340380+0550365',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,188.515875,5.84361,0,NULL,58248409795,910131403,14220803,17.3),(96497,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96497,38.36,0.14,470,40516,70,NULL,NULL,'SDSS J123403.98+670435.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000054,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,188.516625,67.07642,0.033,NULL,57862540176,904102190,14126596,18.5),(96498,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96498,36.78,0.46,227,40517,70,NULL,NULL,'IC 3507',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,188.5185417,25.36283,0.041,NULL,58619263709,915925995,14311343,16.8),(96499,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96499,29.95,0.4,9.8,40518,75,NULL,'B','NGC 4534',NULL,'1988NBGC.C....0000T',1988,1,1.93,'HOLM 419B superposed on southeast side.','G',0.000003,NULL,'13.2g',1.28,'SA(s)dm:','Isolated galaxy',NULL,NULL,NULL,1,188.522583,35.51833,0,NULL,58564677056,915073079,14298016,13.2),(96500,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96500,29.96,NULL,9.82,40518,NULL,NULL,NULL,'NGC 4534',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96501,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96501,30.89,0.4,15.1,40518,NULL,NULL,NULL,'NGC 4534',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96502,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96502,30.97,0.43,15.6,40518,NULL,NULL,NULL,'NGC 4534',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96503,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96503,31.01,0.2,15.9,40518,74.4,NULL,NULL,'NGC 4534',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96504,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96504,31.08,0.41,16.4,40518,NULL,NULL,'Malmquist cor.','NGC 4534',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96505,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96505,37.4,0.46,301,40519,70,NULL,NULL,'2MASX J12340589+3941327',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,188.524417,39.69231,0,NULL,58557550267,914961722,14296276,17.3),(96506,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96506,30.86,0.24,14.9,40520,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4528',NULL,'2010ApJ...717..603V',2010,1,1.7,NULL,'G',0.000017,NULL,'12.97',1,'S0^0^:','in a radial-velocity based grouping',NULL,NULL,NULL,1,188.525291667,11.32125,0,NULL,58189915799,909217434,14206522,12.97),(96507,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96507,30.89,0.28,15.1,40520,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4528',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96508,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96508,31.19,0.33,17.3,40520,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4528',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96509,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96509,31.28,0.31,18,40520,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4528',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96510,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96510,30.91,0.12,15.2,40520,74.4,NULL,NULL,'NGC 4528',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96511,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96511,30.98,0.07,15.7,40520,NULL,NULL,'HST ACS VCS','NGC 4528',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96512,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96512,31,0.05,15.8,40520,NULL,NULL,NULL,'NGC 4528',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96513,'GC radius','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96513,31.07,0.19,16.4,40520,NULL,NULL,NULL,'NGC 4528',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96514,'Faber-Jackson','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96514,29.7,1.24,8.71,40520,95,NULL,'Weighted Mean','NGC 4528',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96515,'Faber-Jackson','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96515,29.7,1.24,8.71,40520,95,NULL,'de Vaucouleurs','NGC 4528',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96516,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96516,30.81,NULL,14.5,40520,NULL,NULL,NULL,'NGC 4528',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96517,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96517,30.91,0.12,15.2,40520,74.4,NULL,NULL,'NGC 4528',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96518,'Tertiary','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96518,30.49,0.25,12.5,40520,95,NULL,NULL,'NGC 4528',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96519,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96519,31.66,0.45,21.5,40520,NULL,NULL,'K','NGC 4528',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96520,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96520,31.84,0.4,23.3,40520,NULL,NULL,'mean','NGC 4528',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96521,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96521,37.45,0.46,309,40521,70,NULL,NULL,'VPC 0936',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000167,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,188.526583,13.57572,0.076,NULL,58165395861,908834310,14200536,17.9),(96522,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96522,37.43,0.27,306,40522,70,NULL,NULL,'2MASX J12340661+0552265',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000187,NULL,'16.5g',0.38,'AGN',NULL,NULL,NULL,NULL,1,188.5275,5.87408,0,NULL,58248402661,910131291,14220801,16.5),(96523,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96523,31.01,0.21,15.9,40523,NULL,NULL,'TOM(g) = -7.2 mag','IC 3506',NULL,'2007ApJS..171..101J',2007,1,0.62,NULL,'G',0.000085,NULL,'16.1g',0.58,'dE0,N','Group member',NULL,NULL,NULL,1,188.528083333,12.74161,0.097,NULL,58163969813,908812028,14200187,16.1),(96524,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96524,31.01,0.18,15.9,40523,NULL,NULL,'TOM(g) = -7.2 mag','IC 3506',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96525,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96525,31.22,0.21,17.5,40523,NULL,NULL,'TOM(u) = -8.4 mag','IC 3506',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96526,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96526,31.35,0.2,18.6,40523,NULL,NULL,'TOM(z) = -8.53 mag','IC 3506',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96527,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96527,31.13,0.14,16.8,40523,74.4,NULL,NULL,'IC 3506',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96528,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96528,31.14,0.11,16.9,40523,NULL,NULL,NULL,'IC 3506',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96529,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96529,31.15,0.12,17,40523,NULL,NULL,'HST ACS VCS','IC 3506',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96530,'GC radius','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96530,30.44,0.09,12.2,40523,NULL,NULL,NULL,'IC 3506',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96531,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96531,35.2,0.15,110,40524,70,NULL,NULL,'IC 3508',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.00007,NULL,'14.8g',0.66,'S0?',NULL,NULL,NULL,NULL,1,188.5289583,26.67078,0.033,NULL,58609780342,915777817,14309028,14.8),(96532,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96532,37.57,0.23,326,40525,70,NULL,NULL,'SDSS J123407.04+333928.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.0001,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,188.529333,33.65783,0.025,NULL,58771370459,918302663,14348479,18.3),(96533,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96533,38.15,0.46,427,40526,70,NULL,NULL,'2MASX J12340715+5037465',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000179,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,188.529667,50.6295,0,NULL,57237176969,894330890,13973920,18),(96534,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96534,37.59,0.33,330,40527,70,NULL,NULL,'2MASX J12340785+0629227',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000157,NULL,'17.3g',0.17,'AGN',NULL,NULL,NULL,NULL,1,188.532667,6.48958,0,NULL,58249315468,910145554,14221024,17.3),(96535,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96535,36.83,0.46,232,40528,70,NULL,NULL,'2MASX J12340801+4535444',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000187,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,188.533625,45.59564,0,NULL,59066409971,922912655,14420510,16.6),(96536,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96536,30.48,0.09,12.5,40529,NULL,NULL,'16, VI','NGC 4527',NULL,'2001ApJ...547L.103G',2001,1,6.2,NULL,'G',0.000003,NULL,'11.38',2.1,'SAB(s)bc;HII   LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,188.535083,2.65367,0.017,NULL,57999890240,906248285,14160129,11.38),(96537,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96537,30.56,0.09,13,40529,NULL,NULL,'16, VI +Z','NGC 4527',NULL,'2001ApJ...547L.103G',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96538,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96538,30.63,0.13,13.4,40529,NULL,NULL,'cte LMC K03','NGC 4527',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96539,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96539,30.64,0.13,13.4,40529,NULL,NULL,'cte U99','NGC 4527',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96540,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96540,30.66,0.13,13.6,40529,NULL,NULL,'cte LMC STS02','NGC 4527',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96541,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96541,30.67,0.09,13.6,40529,74.4,NULL,NULL,'NGC 4527',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96542,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96542,30.72,0.13,14,40529,NULL,NULL,'cte MW FSG03','NGC 4527',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96543,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96543,30.74,0.12,14.1,40529,NULL,NULL,'86, VI','NGC 4527',NULL,'2001ApJ...551..973S',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96544,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96544,30.76,0.13,14.2,40529,NULL,NULL,'cte MF91','NGC 4527',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96545,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96545,30.76,NULL,14.2,40529,NULL,18.54,NULL,'NGC 4527',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96546,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96546,30.76,0.2,14.2,40529,NULL,18.54,'LMC ZP','NGC 4527',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96547,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96547,30.77,0.13,14.3,40529,NULL,NULL,'cte MW GFG98','NGC 4527',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96548,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96548,30.85,0.13,14.8,40529,NULL,NULL,'cte MW STS03','NGC 4527',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96549,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1991T',NULL,96549,30.36,0.31,11.8,40529,NULL,NULL,NULL,'NGC 4527',NULL,'1993ApJ...417..547R',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96550,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1991T',NULL,96550,30.4,0.33,12,40529,67,NULL,NULL,'NGC 4527',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96551,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1991T',NULL,96551,30.57,0.17,13,40529,68,NULL,NULL,'NGC 4527',NULL,'1996ApJ...465L..83R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96552,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1991T',NULL,96552,30.57,0.21,13,40529,NULL,NULL,NULL,'NGC 4527',NULL,'2014MNRAS.445..711S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96553,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1991T',NULL,96553,30.73,0.15,14,40529,NULL,NULL,'Light Echo','NGC 4527',NULL,'1999ApJ...523..585S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96554,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1991T',NULL,96554,30.78,0.08,14.1,40529,65,NULL,'MLCS2k2','NGC 4527',0.005791,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96555,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1991T',NULL,96555,30.79,0.05,14.4,40529,60,NULL,'M(I) = -19.19 mag','NGC 4527',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96556,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1991T',NULL,96556,30.91,0.05,15.2,40529,60,NULL,'M(V) = -19.47 mag','NGC 4527',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96557,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1991T',NULL,96557,31.11,0.06,16.7,40529,60,NULL,'M(B) = -19.48 mag','NGC 4527',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96558,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1991T',NULL,96558,31.41,0.22,19.1,40529,65,NULL,'avg. of 6 SNIa and hosts','NGC 4527',NULL,'1996AJ....112.2398H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96559,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1991T',NULL,96559,32.34,0.17,29.4,40529,70.8,NULL,NULL,'NGC 4527',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96560,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96560,30.26,0.09,11.3,40529,NULL,NULL,NULL,'NGC 4527',NULL,'2001A&A...368..391R',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96561,'Tully est','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96561,30.65,0.8,13.5,40529,75,NULL,'B','NGC 4527',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96562,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96562,30.03,NULL,10.1,40529,NULL,NULL,NULL,'NGC 4527',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96563,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96563,30.22,0.43,11.1,40529,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4527',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96564,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96564,30.39,0.43,12,40529,75,NULL,'3.6 micron, color corrected','NGC 4527',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96565,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96565,30.44,0.42,12.2,40529,NULL,18.48,'3.6 micron','NGC 4527',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96566,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96566,30.45,0.47,12.3,40529,NULL,NULL,'H','NGC 4527',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96567,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96567,30.45,0.45,12.3,40529,NULL,NULL,'K','NGC 4527',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96568,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96568,30.53,0.46,12.7,40529,NULL,NULL,'J','NGC 4527',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96569,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96569,30.6,0.4,13.2,40529,75,NULL,'HOSTS SN 1991T','NGC 4527',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96570,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96570,30.6,0.3,13.2,40529,NULL,18.45,'SN 1991T host','NGC 4527',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96571,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96571,30.64,0.35,13.4,40529,NULL,NULL,NULL,'NGC 4527',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96572,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96572,30.63,NULL,13.4,40529,NULL,NULL,'I','NGC 4527',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96573,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96573,30.67,0.09,13.6,40529,74.4,NULL,NULL,'NGC 4527',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96574,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96574,30.75,NULL,14.1,40529,NULL,NULL,'B','NGC 4527',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96575,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96575,30.78,NULL,14.3,40529,NULL,NULL,'B','NGC 4527',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96576,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96576,30.82,0.7,14.6,40529,NULL,NULL,'HI','NGC 4527',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96577,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96577,30.86,0.4,14.9,40529,75,NULL,'HOSTS SN 1991T','NGC 4527',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96578,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96578,30.87,0.92,14.9,40529,NULL,NULL,'CO','NGC 4527',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96579,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96579,31.38,0.3,18.9,40529,55,NULL,'B','NGC 4527',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96580,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96580,31.45,NULL,19.5,40529,NULL,NULL,'LEDA [April 2006]','NGC 4527',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96581,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96581,32.03,0.4,25.4,40529,NULL,NULL,'mean','NGC 4527',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96582,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96582,38.13,0.19,423,40530,70,NULL,NULL,'2MASX J12340864+0406105',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,188.5360417,4.10303,0.007,NULL,58231100211,909860940,14216577,17.6),(96583,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96583,37.81,0.46,365,40531,70,NULL,NULL,'2MASX J12340883+0905427',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,'FoF','18.35',0.16,'BrClG',NULL,NULL,NULL,NULL,1,188.536916667,9.09514,0,NULL,58188862282,909200973,14206265,18.35),(96584,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96584,36.24,0.67,177,40532,70,NULL,NULL,'2MASX J12340901-1036092',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,188.5374583,-10.60258,0.081,NULL,43160874639,674388666,10537322,15.5),(96585,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96585,35.3,0.46,115,40533,70,NULL,NULL,'2MASX J12340907+2807501',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000063,NULL,'16.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,188.537917,28.13072,0.074,NULL,58729008553,917640758,14338136,16),(96586,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96586,37.43,0.46,306,40534,70,NULL,NULL,'SDSS J123409.53+601939.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,188.5397917,60.32769,0,NULL,57335818978,895872171,13998002,18.5),(96587,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96587,37.05,0.46,257,40535,70,NULL,NULL,'SDSS J123411.09+044215.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000177,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,188.54625,4.70428,0,NULL,58229934124,909842720,14216292,18.1),(96588,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96588,31.28,0.18,18,40536,NULL,NULL,'TOM(g) = -7.2 mag','IC 3509',NULL,'2007ApJS..171..101J',2007,1,0.84,NULL,'G',0.000073,NULL,'15.1g',0.6,'E4','Group member',NULL,NULL,NULL,1,188.5480417,12.04897,0.116,NULL,58163551104,908805486,14200085,15.1),(96589,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96589,31.3,0.16,18.2,40536,NULL,NULL,'TOM(g) = -7.2 mag','IC 3509',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96590,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96590,31.55,0.18,20.4,40536,NULL,NULL,'TOM(u) = -8.4 mag','IC 3509',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96591,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96591,31.69,0.18,21.8,40536,NULL,NULL,'TOM(z) = -8.53 mag','IC 3509',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96592,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96592,31.1,0.14,16.6,40536,74.4,NULL,NULL,'IC 3509',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96593,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96593,31.12,0.08,16.8,40536,NULL,NULL,'HST ACS VCS','IC 3509',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96594,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96594,31.13,0.07,16.8,40536,NULL,NULL,NULL,'IC 3509',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96595,'GC radius','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96595,30.43,0.14,12.2,40536,NULL,NULL,NULL,'IC 3509',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96596,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96596,38.41,0.46,480,40537,70,NULL,NULL,'2MASX J12341215+1705178',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,188.550667,17.08844,0.031,NULL,58882710584,920042352,14375661,17.3),(96597,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96597,35.24,0.46,112,40538,70,NULL,NULL,'2MASX J12341259+0355135',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000165,NULL,'15.7g',0.5,'E',NULL,NULL,NULL,NULL,1,188.5524583,3.92044,0.029,NULL,58231115494,909861179,14216580,15.7),(96598,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96598,37.37,0.46,298,40539,70,NULL,NULL,'VPC 0946',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,188.5537917,11.40042,0.011,NULL,58189703708,909214120,14206470,17.3),(96599,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96599,38.15,0.46,426,40540,70,NULL,NULL,'2MASX J12341319+1002367',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,188.555083,10.04364,0,NULL,58190734025,909230219,14206722,17.5),(96600,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96600,37.71,0.46,348,40541,70,NULL,NULL,'2MASX J12341319+1220088',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000139,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,188.555083,12.33589,0.124,NULL,58164406344,908818849,14200294,18.2),(96601,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96601,37.59,0.33,330,40542,70,NULL,NULL,'2MASX J12341335+0629067',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000177,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,188.5555417,6.48517,0,NULL,58248792442,910137381,14220896,16.4),(96602,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96602,37.57,0.23,326,40543,70,NULL,NULL,'2MASX J12341344+3340270',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00017,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,188.555917,33.67417,0.025,NULL,58771373563,918302711,14348479,16.9),(96603,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96603,38.05,0.27,407,40544,70,NULL,NULL,'2MASX J12341585+2817074',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,188.566083333,28.28525,0.073,NULL,58728981118,917640329,14338130,18.6),(96604,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96604,30.89,0.14,15.1,40545,74.4,NULL,NULL,'NGC 4531',NULL,'2013AJ....146...86T',2013,1,3.1,NULL,'G',0.000043,NULL,'12.42',2,'SB0+;Sy        LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,188.566208333,13.07533,0.084,NULL,58165588369,908837318,14200583,12.42),(96605,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96605,30.91,0.22,15.2,40545,NULL,NULL,'I','NGC 4531',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96606,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96606,37.43,0.27,306,40546,70,NULL,NULL,'2MASX J12341606+0554175',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000131,NULL,'17.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,188.567,5.90503,0,NULL,58248422229,910131597,14220806,17.6),(96607,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96607,38.13,0.19,423,40547,70,NULL,NULL,'2MASX J12341620+0355005',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000187,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,188.567625,3.91692,0.029,NULL,58231113408,909861147,14216580,16.9),(96608,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96608,36.28,0.46,180,40548,70,NULL,NULL,'2MASX J12341649+4802035',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000169,NULL,'15.9g',0.46,'E',NULL,NULL,NULL,NULL,1,188.569,48.03433,0,NULL,59065181991,922893468,14420210,15.9),(96609,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96609,34.75,NULL,89.3,40549,NULL,NULL,'Dipole + Quadrupole','IC 3516',NULL,'2010Ap&SS.325..163P',2010,1,0.59,'The position in 1989H&RHI.C...0000H is incorrect.','G',0.000012,NULL,'16.1g',0.21,'Scd','Group member, peripheral',NULL,NULL,NULL,1,188.571417,27.45231,0.057,NULL,58609399342,915771864,14308935,16.1),(96610,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96610,34.76,NULL,89.4,40549,NULL,NULL,'Dipole','IC 3516',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96611,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96611,34.76,NULL,89.4,40549,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 3516',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96612,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96612,34.83,NULL,92.5,40549,NULL,NULL,NULL,'IC 3516',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96613,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96613,35.07,0.14,103,40549,NULL,NULL,NULL,'IC 3516',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96614,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96614,35.14,0.49,107,40549,75,NULL,'IR','IC 3516',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96615,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96615,35.67,0.2,136,40549,74.4,NULL,NULL,'IC 3516',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96616,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96616,35.98,0.21,157,40550,70,NULL,NULL,'2MASX J12341782+4745591',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000174,NULL,'16.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,188.574417,47.76642,0,NULL,59065076665,922891822,14420184,16.5),(96617,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96617,36.59,0.46,208,40551,70,NULL,NULL,'2MASX J12341829+3437521',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000157,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,188.576333,34.63128,0,NULL,58742136088,917845876,14341341,17),(96618,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96618,38.01,0.46,400,40552,70,NULL,NULL,'2MASX J12341845+4049347',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000145,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,188.5767917,40.82622,0,NULL,59114757764,923668090,14432313,18.1),(96619,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96619,38.13,0.19,423,40553,70,NULL,NULL,'SDSS J123418.49+040212.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000132,NULL,'18.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,188.577041667,4.03686,0.007,NULL,58231154327,909861786,14216590,18),(96620,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96620,37.55,0.46,323,40554,70,NULL,NULL,'2MASX J12341854+0544193',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,188.577167,5.73878,0,NULL,58248397108,910131204,14220800,17.6),(96621,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96621,38.34,0.46,466,40555,70,NULL,NULL,'2MASX J12341881+3225391',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,188.578375,32.42747,0.028,NULL,58773882039,918341906,14349092,18),(96622,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96622,38.53,0.46,507,40556,70,NULL,NULL,'2MASX J12341918+0647077',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000144,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,188.580041667,6.78564,0,NULL,58248872677,910138635,14220916,17.9),(96623,'IRAS','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96623,31.38,0.8,18.8,40557,75,NULL,'A82, H','NGC 4532',NULL,'1997ApJS..109..333W',1997,1,2.61,'The SDSS position is for a knot at the northwest end of the galaxy.','G',0.000013,NULL,'12.2g',0.92,'IBm            HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,188.5805417,6.46769,0,NULL,58248793857,910137404,14220896,12.2),(96624,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96624,30.15,0.43,10.7,40557,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4532',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96625,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96625,30.23,NULL,11.1,40557,NULL,NULL,NULL,'NGC 4532',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96626,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96626,30.25,0.57,11.2,40557,NULL,NULL,NULL,'NGC 4532',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96627,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96627,30.27,0.43,11.3,40557,75,NULL,'3.6 micron, color corrected','NGC 4532',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96628,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96628,30.48,0.51,12.5,40557,NULL,NULL,'Malmquist cor.','NGC 4532',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96629,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96629,30.67,0.4,13.6,40557,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 4532',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96630,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96630,30.7,0.35,13.8,40557,NULL,NULL,NULL,'NGC 4532',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96631,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96631,30.95,0.4,15.5,40557,75,NULL,'B','NGC 4532',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96632,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96632,31.1,0.42,16.6,40557,65,NULL,NULL,'NGC 4532',NULL,'1980ApJ...238..458M',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96633,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96633,31.2,0.47,17.4,40557,75,NULL,'A82, H, inv','NGC 4532',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96634,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96634,31.24,0.47,17.7,40557,75,NULL,'A82, H, raw','NGC 4532',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96635,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96635,31.49,0.47,19.8,40557,75,NULL,'A82, H, cor','NGC 4532',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96636,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96636,37.39,0.46,301,40558,70,NULL,NULL,'2MASX J12341955+4103567',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.32',0.16,NULL,NULL,NULL,NULL,NULL,1,188.5815,41.06589,0,NULL,59114718570,923667477,14432304,18.32),(96637,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96637,38.34,0.46,466,40559,70,NULL,NULL,'2MASX J12341962+2517534',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,188.581833,25.29828,0.041,NULL,58619243876,915925685,14311338,17.6),(96638,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96638,37.71,0.46,348,40560,70,NULL,NULL,'2MASX J12342017+0937527',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,188.5840417,9.63139,0,NULL,58189045384,909203834,14206309,17.2),(96639,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96639,30.42,0.38,12.1,40561,73,NULL,'Cepheids periods Gaussian ','NGC 4535',NULL,'2009RoAJ...19...35A',2009,1,7.1,NULL,'G',0.000002,NULL,'10.59',5,'SAB(s)c;LINER  HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,188.584625,8.19775,0,NULL,58246462373,910100974,14220327,10.59),(96640,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96640,30.44,0.2,12.2,40561,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian ','NGC 4535',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96641,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96641,30.48,0.02,12.5,40561,73,NULL,'Cepheids magnitudes Gaussian ','NGC 4535',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96642,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96642,30.85,0.05,14.8,40561,NULL,NULL,'47, VI, KEY PROJECT','NGC 4535',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96643,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96643,30.87,0.07,14.9,40561,NULL,NULL,'MW HIPP','NGC 4535',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96644,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96644,30.87,0.05,15,40561,NULL,NULL,'cte LMC K03','NGC 4535',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96645,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96645,30.88,0.05,15,40561,NULL,NULL,'cte U99','NGC 4535',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96646,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96646,30.88,0.06,15,40561,NULL,NULL,'LMC W01','NGC 4535',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96647,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96647,30.91,0.05,15.2,40561,NULL,NULL,'cte LMC STS02','NGC 4535',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96648,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96648,30.97,0.05,15.6,40561,NULL,NULL,'cte MW FSG03','NGC 4535',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96649,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96649,30.98,0.2,15.7,40561,NULL,NULL,'MW P02','NGC 4535',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96650,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96650,30.99,0.05,15.8,40561,NULL,NULL,'47, VI, +Z, KEY PROJECT','NGC 4535',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96651,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96651,31,0.05,15.9,40561,NULL,NULL,'cte MF91','NGC 4535',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96652,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96652,31.02,0.06,16,40561,NULL,NULL,'cte MW GFG98','NGC 4535',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96653,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96653,31.04,0.09,16.1,40561,74.4,NULL,NULL,'NGC 4535',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96654,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96654,31.08,0.07,16.4,40561,NULL,NULL,'MW GFG','NGC 4535',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96655,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96655,31.08,0.07,16.4,40561,NULL,NULL,'64, VI','NGC 4535',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96656,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96656,31.1,0.07,16.6,40561,NULL,NULL,'HST KP Calibrated','NGC 4535',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96657,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96657,31.1,0.06,16.6,40561,NULL,NULL,'cte MW STS03','NGC 4535',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96658,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96658,31.1,0.07,16.6,40561,NULL,NULL,'25, VI','NGC 4535',NULL,'1999ApJ...521..155M',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96659,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96659,31.25,NULL,17.8,40561,NULL,18.54,NULL,'NGC 4535',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96660,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96660,31.25,0.04,17.8,40561,NULL,18.54,'LMC ZP','NGC 4535',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96661,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96661,31.27,0.07,17.9,40561,NULL,NULL,'Z, Key Project','NGC 4535',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96662,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96662,31.6,NULL,20.9,40561,NULL,NULL,'27, VI','NGC 4535',NULL,'2006A&A...452..423P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96663,'Grav. Stability Gas. Disk','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96663,30.59,NULL,13.1,40561,NULL,NULL,NULL,'NGC 4535',NULL,'1996AstL...22...71Z',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96664,'IRAS','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96664,31.39,0.8,19,40561,75,NULL,'A82, H','NGC 4535',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96665,'Sosies','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96665,30.98,0.31,15.7,40561,NULL,NULL,NULL,'NGC 4535',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96666,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96666,30.3,0.92,11.5,40561,NULL,NULL,'CO','NGC 4535',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96667,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96667,30.65,0.7,13.5,40561,NULL,NULL,'HI','NGC 4535',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96668,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96668,30.67,NULL,13.6,40561,NULL,NULL,NULL,'NGC 4535',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96669,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96669,30.82,0.35,14.6,40561,NULL,NULL,NULL,'NGC 4535',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96670,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96670,30.91,NULL,15.2,40561,NULL,NULL,'B','NGC 4535',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96671,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96671,30.93,0.06,15.3,40561,NULL,NULL,'I','NGC 4535',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96672,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96672,30.95,NULL,15.5,40561,NULL,NULL,'I','NGC 4535',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96673,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96673,30.99,0.05,15.8,40561,75,NULL,NULL,'NGC 4535',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96674,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96674,31,0.01,15.8,40561,NULL,NULL,'B','NGC 4535',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96675,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96675,30.99,NULL,15.8,40561,84,NULL,'RSA Hubble type','NGC 4535',NULL,'1986AJ.....91.1286S',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96676,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96676,31.04,0.09,16.1,40561,74.4,NULL,NULL,'NGC 4535',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96677,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96677,31.13,0.4,16.8,40561,75,NULL,'B','NGC 4535',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96678,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96678,31.13,NULL,16.8,40561,NULL,NULL,'B','NGC 4535',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96679,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96679,31.19,0.42,17.3,40561,65,NULL,NULL,'NGC 4535',NULL,'1980ApJ...238..458M',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96680,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96680,31.23,NULL,17.6,40561,NULL,NULL,'LEDA [April 2006]','NGC 4535',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96681,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96681,31.3,0.51,18.2,40561,NULL,NULL,NULL,'NGC 4535',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96682,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96682,31.33,0.5,18.4,40561,NULL,NULL,'Malmquist cor.','NGC 4535',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96683,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96683,31.41,0.47,19.1,40561,75,NULL,'A82, H, raw','NGC 4535',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96684,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96684,31.47,0.45,19.6,40561,NULL,NULL,'K','NGC 4535',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96685,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96685,31.48,0.47,19.8,40561,NULL,NULL,'H','NGC 4535',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96686,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96686,31.49,0.46,19.9,40561,NULL,NULL,'J','NGC 4535',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96687,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96687,31.55,0.47,20.4,40561,75,NULL,'A82, H, inv','NGC 4535',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96688,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96688,31.62,0.47,21.1,40561,75,NULL,'A82, H, cor','NGC 4535',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96689,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96689,31.68,0.3,21.7,40561,55,NULL,'B','NGC 4535',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96690,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96690,32.2,0.4,27.6,40561,NULL,NULL,'mean','NGC 4535',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96691,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96691,38.01,0.46,399,40562,70,NULL,NULL,'2MASX J12342064+0943587',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000159,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,188.586083,9.73294,0,NULL,58189118827,909204981,14206327,17.8),(96692,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96692,37.86,0.46,374,40563,70,NULL,NULL,'2MASX J12342063+6056013',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000142,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,188.586083,60.93389,0,NULL,57363874531,896310539,14004852,18),(96693,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96693,37.57,0.23,326,40564,70,NULL,NULL,'2MASX J12342200+3343541',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,188.59175,33.73169,0.025,NULL,58771346773,918302293,14348473,17.1),(96694,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96694,38.13,0.19,423,40565,70,NULL,NULL,'2MASX J12342230+0349313',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000138,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,188.593083,3.82536,0.029,NULL,58231325758,909864464,14216632,17.7),(96695,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96695,38.13,0.19,423,40566,70,NULL,NULL,'2MASX J12342390+0350564',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,188.599667,3.84917,0.029,NULL,58231339619,909864681,14216635,17.6),(96696,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96696,37.1,0.46,263,40567,70,NULL,NULL,'2MASX J12342415+0836127',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00014,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,188.6005417,8.60358,0,NULL,58244205423,910065709,14219776,17.4),(96697,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96697,37.85,0.27,372,40568,70,NULL,NULL,'SDSS J123424.34+070739.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,188.6014583,7.12761,0,NULL,58248659314,910135301,14220864,17.8),(96698,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96698,30.57,0.08,13,40569,NULL,NULL,'HST KP Calibrated','NGC 4565 GROUP',NULL,'2000ApJ...529..745F',2000,1,NULL,NULL,'GGroup',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,188.6060417,25.90261,0.029,NULL,58619045996,915922593,14311290,NULL),(96699,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96699,30.44,0.21,12.2,40569,NULL,NULL,'HST KP Calibrated, V','NGC 4565 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96700,'PNLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96700,30.51,0.08,12.6,40569,NULL,NULL,'HST KP Calibrated','NGC 4565 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96701,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96701,31.18,0.1,17.2,40569,NULL,NULL,'HST KP Calibrated, I','NGC 4565 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96702,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96702,37.46,0.13,310,40570,70,NULL,NULL,'2MASX J12342558+1615318',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,188.6067083,16.25894,0.026,NULL,58882898074,920045282,14375707,16.9),(96703,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96703,37.76,0.46,356,40571,70,NULL,NULL,'2MASX J12342649+6639122',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000078,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,188.610417,66.65339,0.033,NULL,57320555722,895633683,13994276,17.9),(96704,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96704,35.61,0.54,133,40572,70,NULL,NULL,'2MASX J12342655-4432367',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,188.610625,-44.5435,0.473,NULL,46718269487,729972960,11405827,16.5),(96705,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96705,38.18,0.14,433,40573,70,NULL,NULL,'2MASX J12342706+6426442',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000158,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,188.612458333,64.44558,0.025,NULL,57366690511,896354539,14005539,17.2),(96706,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96706,30.35,0.02,11.7,40574,73,NULL,'Cepheids periods Gaussian ','NGC 4536',NULL,'2009RoAJ...19...35A',2009,1,7.6,'Contains the possible HII region UM 506.','G',0.000003,NULL,'11.16',3.2,'SAB(rs)bc;HII  Sbrst','in a radial-velocity based grouping',NULL,NULL,NULL,1,188.6127083,2.18814,0,NULL,58000011076,906250173,14160158,11.16),(96707,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96707,30.43,0.09,12.2,40574,NULL,NULL,NULL,'NGC 4536',NULL,'2009ApJ...699..539R',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96708,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96708,30.6,0.03,13.2,40574,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian ','NGC 4536',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96709,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96709,30.61,0.12,13.2,40574,NULL,NULL,'32, VI +Z','NGC 4536',NULL,'1997ApJ...491...13K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96710,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96710,30.69,0.07,13.8,40574,NULL,NULL,'27, VI','NGC 4536',NULL,'2001ApJ...547L.103G',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96711,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96711,30.72,0.09,13.9,40574,NULL,NULL,'32, VI','NGC 4536',NULL,'1997ApJ...491...13K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96712,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96712,30.76,0.12,14.2,40574,NULL,NULL,'ALLFRAME, Key Project','NGC 4536',NULL,'2000ApJ...529..723G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96713,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96713,30.76,0.07,14.2,40574,NULL,NULL,'27, VI +Z','NGC 4536',NULL,'2001ApJ...547L.103G',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96714,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96714,30.77,0.04,14.3,40574,NULL,NULL,'STR 04 LMC non-linear','NGC 4536',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96715,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96715,30.77,0.07,14.3,40574,NULL,NULL,'LMC W01','NGC 4536',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96716,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96716,30.78,0.07,14.3,40574,NULL,NULL,'35','NGC 4536',NULL,'2005ApJ...627..579R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96717,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96717,30.78,0.04,14.4,40574,NULL,NULL,'STR04 LMC linear','NGC 4536',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96718,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96718,30.79,0.07,14.4,40574,NULL,NULL,'MW HIPP','NGC 4536',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96719,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96719,30.79,0.04,14.4,40574,NULL,NULL,'KN04 LMC non-linear','NGC 4536',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96720,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96720,30.8,0.04,14.5,40574,NULL,NULL,'KN04 LMC linear','NGC 4536',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96721,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96721,30.8,0.04,14.5,40574,NULL,NULL,'35, VI, KEY PROJECT','NGC 4536',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96722,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96722,30.81,0.04,14.5,40574,NULL,NULL,'KN06 LMC linear','NGC 4536',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96723,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96723,30.81,0.04,14.5,40574,NULL,NULL,'TR02 LMC linear','NGC 4536',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96724,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96724,30.82,0.04,14.6,40574,NULL,NULL,'KN06 LMC non-linear','NGC 4536',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96725,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96725,30.83,0.1,14.6,40574,NULL,NULL,'cte LMC K03','NGC 4536',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96726,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96726,30.83,0.09,14.7,40574,74.4,NULL,NULL,'NGC 4536',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96727,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96727,30.83,0.1,14.7,40574,NULL,NULL,'cte U99','NGC 4536',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96728,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96728,30.83,0.04,14.7,40574,NULL,NULL,'TR02 LMC non-linear','NGC 4536',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96729,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96729,30.85,0.03,14.8,40574,73,NULL,'Cepheids magnitudes Gaussian ','NGC 4536',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96730,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96730,30.85,0.1,14.8,40574,NULL,NULL,'6, VI (PC)','NGC 4536',NULL,'2000ApJ...530L...5G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96731,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96731,30.86,0.1,14.9,40574,NULL,NULL,'cte LMC STS02','NGC 4536',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96732,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96732,30.87,0.04,14.9,40574,NULL,NULL,'35, VI, +Z, KEY PROJECT','NGC 4536',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96733,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96733,30.89,0.05,15,40574,NULL,NULL,'21, VI (WF)','NGC 4536',NULL,'2000ApJ...530L...5G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96734,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96734,30.9,0.04,15.2,40574,NULL,NULL,'NK04 GAL','NGC 4536',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96735,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96735,30.91,0.07,15.2,40574,NULL,NULL,'SNIa calibrated','NGC 4536',NULL,'2011ApJ...730..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96736,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96736,30.92,0.05,15.3,40574,NULL,NULL,'V, I, NIR (W), 49, Syst. +/- 0.32 mag','NGC 4536',NULL,'2013MNRAS.434.2866F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96737,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96737,30.93,0.19,15.3,40574,NULL,NULL,'MW P02','NGC 4536',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96738,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96738,30.93,0.1,15.3,40574,NULL,NULL,'cte MW FSG03','NGC 4536',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96739,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96739,30.94,0.04,15.4,40574,NULL,NULL,'STR04 GAL','NGC 4536',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96740,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96740,30.95,0.07,15.5,40574,NULL,NULL,'HST KP Calibrated','NGC 4536',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96741,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96741,30.95,0.07,15.5,40574,NULL,NULL,'ALLFRAME','NGC 4536',NULL,'2000ApJ...529..723G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96742,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96742,30.96,0.1,15.6,40574,NULL,NULL,'cte MF91','NGC 4536',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96743,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96743,30.99,0.1,15.8,40574,NULL,NULL,'cte MW GFG98','NGC 4536',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96744,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96744,31.03,0.07,16.1,40574,NULL,NULL,'Z, Key Project','NGC 4536',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96745,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96745,31.04,0.06,16.1,40574,NULL,NULL,'MW GFG','NGC 4536',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96746,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96746,31.04,0.06,16.1,40574,NULL,NULL,'153, VI','NGC 4536',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96747,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96747,31.07,0.1,16.4,40574,NULL,NULL,'cte MW STS03','NGC 4536',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96748,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96748,31.1,0.13,16.6,40574,NULL,NULL,'73, VI','NGC 4536',NULL,'1996ApJ...466...55S',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96749,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96749,31.18,0.03,17.2,40574,NULL,NULL,'BVRI','NGC 4536',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96750,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96750,31.24,0.09,17.7,40574,NULL,18.54,'LMC ZP','NGC 4536',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96751,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96751,31.24,NULL,17.7,40574,NULL,18.54,NULL,'NGC 4536',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96752,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96752,31.4,0.03,19.1,40574,NULL,NULL,'BVRI+','NGC 4536',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96753,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96753,31.46,0.15,19.6,40574,NULL,NULL,'2, I','NGC 4536',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96754,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96754,31.46,0.15,19.6,40574,NULL,NULL,'2, I','NGC 4536',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96755,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96755,31.47,0.15,19.7,40574,NULL,NULL,'2, H','NGC 4536',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96756,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96756,31.47,0.15,19.7,40574,NULL,NULL,'2, H','NGC 4536',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96757,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96757,31.51,0.21,20,40574,NULL,NULL,'2, V','NGC 4536',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96758,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96758,31.51,0.21,20,40574,NULL,NULL,'2, V','NGC 4536',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96759,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96759,31.6,NULL,20.9,40574,NULL,NULL,'75, VI','NGC 4536',NULL,'2006A&A...452..423P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96760,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1981B',NULL,96760,30.29,0.2,11.4,40574,NULL,NULL,'m-M(B) = 11.79 - -18.5 mag','NGC 4536',NULL,'1983PASP...95...72B',1983,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96761,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1981B',NULL,96761,30.38,0.07,11.9,40574,65,NULL,'Snapshot','NGC 4536',NULL,'1996ApJ...473...88R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96762,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1981B',NULL,96762,30.7,0.36,13.8,40574,NULL,NULL,NULL,'NGC 4536',NULL,'1992ApJ...390L..45P',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96763,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1981B',NULL,96763,30.91,0.07,15.2,40574,NULL,NULL,'MLCS2k2, Cepheids calibrated','NGC 4536',NULL,'2011ApJ...730..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96764,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1981B',NULL,96764,31.1,0.14,16.4,40574,65,NULL,'MLCS2k2','NGC 4536',0.006031,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96765,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1981B','R',96765,31.13,NULL,16.8,40574,NULL,NULL,'Photographic','NGC 4536',NULL,'1988SSRv...48....1R',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96766,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1981B','R',96766,31.28,NULL,18,40574,62.3,NULL,NULL,'NGC 4536',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96767,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1981B',NULL,96767,31.37,0.14,18.8,40574,60,NULL,NULL,'NGC 4536',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96768,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1981B','R',96768,31.39,0.32,19,40574,NULL,NULL,NULL,'NGC 4536',NULL,'1994AAS...185.7908F',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96769,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1981B',NULL,96769,31.4,0.41,19,40574,67,NULL,NULL,'NGC 4536',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96770,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1981B',NULL,96770,31.41,0.22,19.1,40574,65,NULL,'avg. of 6 SNIa and hosts','NGC 4536',NULL,'1996AJ....112.2398H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96771,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1981B',NULL,96771,31.57,NULL,20.6,40574,56,NULL,'M(B) = -19.8 mag','NGC 4536',NULL,'1992ARA&A..30..359B',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96772,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1981B',NULL,96772,31.6,NULL,20.9,40574,66,NULL,NULL,'NGC 4536',NULL,'1994A&A...281...51M',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96773,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 1981B',NULL,96773,32.24,0.55,28,40574,NULL,NULL,NULL,'NGC 4536',NULL,'1983ApJ...270..123B',1983,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96774,'IRAS','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96774,31.32,0.8,18.4,40574,75,NULL,'A82, H','NGC 4536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96775,'Sosies','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96775,30.93,0.11,15.3,40574,NULL,NULL,NULL,'NGC 4536',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96776,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96776,30.04,0.4,10.2,40574,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 4536',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96777,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96777,30.21,0.92,11,40574,NULL,NULL,'CO','NGC 4536',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96778,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96778,30.41,0.7,12.1,40574,NULL,NULL,'HI','NGC 4536',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96779,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96779,30.46,0.43,12.4,40574,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4536',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96780,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96780,30.5,0.3,12.6,40574,NULL,18.45,'SN 1981B host','NGC 4536',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96781,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96781,30.56,0.43,12.9,40574,75,NULL,'3.6 micron, color corrected','NGC 4536',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96782,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96782,30.57,0.47,13,40574,75,NULL,'A82, H, raw','NGC 4536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96783,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96783,30.6,0.42,13.2,40574,NULL,18.48,'3.6 micron','NGC 4536',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96784,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96784,30.62,0.4,13.3,40574,75,NULL,'B','NGC 4536',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96785,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96785,30.65,NULL,13.5,40574,NULL,NULL,NULL,'NGC 4536',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96786,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96786,30.67,0.47,13.6,40574,75,NULL,'A82, H, inv','NGC 4536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96787,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96787,30.66,0.35,13.6,40574,NULL,NULL,NULL,'NGC 4536',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96788,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96788,30.71,0.4,13.9,40574,75,NULL,'HOSTS SN 1981B','NGC 4536',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96789,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96789,30.83,0.09,14.7,40574,74.4,NULL,NULL,'NGC 4536',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96790,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96790,30.83,0.04,14.7,40574,NULL,NULL,'I','NGC 4536',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96791,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96791,30.86,0.4,14.9,40574,75,NULL,'HOSTS SN 1981B','NGC 4536',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96792,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96792,30.87,0.04,14.9,40574,75,NULL,NULL,'NGC 4536',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96793,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96793,30.92,NULL,15.3,40574,NULL,NULL,'I','NGC 4536',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96794,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96794,30.94,0.47,15.4,40574,75,NULL,'A82, H, cor','NGC 4536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96795,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96795,31.02,NULL,16,40574,NULL,NULL,'B','NGC 4536',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96796,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96796,31.08,NULL,16.4,40574,NULL,NULL,'LEDA [April 2006]','NGC 4536',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96797,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96797,31.08,0.21,16.4,40574,NULL,NULL,'B','NGC 4536',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96798,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96798,37.17,0.46,272,40575,70,NULL,NULL,'2MASX J12342711+0421213',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000163,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,188.613125,4.35589,0,NULL,58229794827,909840544,14216258,16.8),(96799,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96799,36.9,0.46,240,40576,70,NULL,NULL,'2MASX J12342902+5904160',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000182,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,188.620791667,59.07128,0,NULL,57405036934,896953702,14014901,16.2),(96800,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96800,38.05,0.27,407,40577,70,NULL,NULL,'2MASX J12342926+2806205',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000191,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,188.622041667,28.10569,0.071,NULL,58732466016,917694781,14338980,16.7),(96801,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96801,36.6,0.33,209,40578,70,NULL,NULL,'CGCG 270-010',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000177,NULL,'15.6g',0.45,'E0',NULL,NULL,NULL,NULL,1,188.624,50.67119,0,NULL,57237189653,894331088,13973923,15.6),(96802,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96802,34.27,0.52,71.5,40579,70,NULL,NULL,'2MASX J12343078-0732472',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.000063,NULL,'14.49',0.43,NULL,NULL,NULL,NULL,NULL,1,188.6282083,-7.5465,0.081,NULL,43214324379,675223818,10550372,14.49),(96803,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96803,30.72,0.2,13.9,40580,74.4,NULL,NULL,'IC 3517',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000003,NULL,'15.38',0.7,'Sdm:','Group member',NULL,NULL,NULL,1,188.628166667,9.15475,0,NULL,58188749910,909199217,14206237,15.38),(96804,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96804,31.49,0.64,19.8,40580,NULL,NULL,NULL,'IC 3517',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96805,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96805,31.6,0.61,20.9,40580,NULL,NULL,'Malmquist cor.','IC 3517',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96806,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96806,32.32,0.36,29.1,40580,NULL,NULL,NULL,'IC 3517',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96807,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96807,38.13,0.19,423,40581,70,NULL,NULL,'2MASX J12343099+0358343',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000162,NULL,'16.7g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,188.62925,3.97631,0,NULL,58231147397,909861678,14216588,16.7),(96808,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96808,36.9,0.46,240,40582,70,NULL,NULL,'LCRS B123158.0-030910',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000074,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,188.634583333,-3.42828,0.033,NULL,43183386204,674740409,10542818,16.8),(96809,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96809,37.46,0.13,310,40583,70,NULL,NULL,'2MASX J12343283+1640042',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,188.6367917,16.66789,0.027,NULL,58882545879,920039779,14375621,17.3),(96810,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96810,37.46,0.13,310,40584,70,NULL,NULL,'2MASX J12343360+1631162',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,188.639917,16.52108,0.032,NULL,58882439483,920038116,14375595,17.4),(96811,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96811,38,0.19,398,40585,70,NULL,NULL,'2MASX J12343418+2834435',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000134,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,188.642375,28.57883,0.065,NULL,58732126708,917689479,14338898,18),(96812,'IRAS','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96812,33.16,0.8,42.9,40586,75,NULL,'A82, H','NGC 4545',NULL,'1997ApJS..109..333W',1997,1,2.06,NULL,'G',0.000023,NULL,'13.3g',1.03,'SB(s)cd:','in a radial-velocity based grouping',NULL,NULL,NULL,1,188.6422917,63.52506,0,NULL,57374492620,896476447,14007444,13.3),(96813,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96813,32.27,0.69,28.5,40586,100,NULL,'mid-IR','NGC 4545',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96814,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96814,32.3,0.4,28.9,40586,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 4545',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96815,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96815,32.65,0.43,33.8,40586,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4545',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96816,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96816,32.65,0.43,33.9,40586,75,NULL,'3.6 micron, color corrected','NGC 4545',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96817,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96817,32.73,0.2,35.2,40586,74.4,NULL,NULL,'NGC 4545',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96818,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96818,32.85,0.38,37.2,40586,NULL,NULL,NULL,'NGC 4545',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96819,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96819,32.91,0.43,38.2,40586,NULL,NULL,'Malmquist cor.','NGC 4545',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96820,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96820,32.96,0.42,39,40586,NULL,NULL,NULL,'NGC 4545',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96821,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96821,32.98,0.47,39.5,40586,NULL,NULL,'H','NGC 4545',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96822,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96822,32.99,0.46,39.6,40586,NULL,NULL,'J','NGC 4545',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96823,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96823,33.03,0.45,40.4,40586,NULL,NULL,'K','NGC 4545',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96824,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96824,33.09,0.4,41.5,40586,75,NULL,'B','NGC 4545',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96825,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96825,33.15,0.4,42.6,40586,NULL,NULL,'mean','NGC 4545',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96826,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96826,33.2,0.47,43.6,40586,75,NULL,'A82, H, raw','NGC 4545',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96827,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96827,33.26,0.47,44.8,40586,75,NULL,'A82, H, cor','NGC 4545',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96828,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96828,33.29,0.47,45.5,40586,75,NULL,'A82, H, inv','NGC 4545',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96829,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96829,38,0.19,398,40587,70,NULL,NULL,'2MASX J12343455+2832595',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,188.643917,28.54994,0.073,NULL,58732128019,917689500,14338898,17.4),(96830,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96830,31.94,0.49,24.4,40588,75,NULL,'IR','NGC 4539',NULL,'2011yCatp016004901K',2011,1,3.37,NULL,'G',0.000073,NULL,'12.88',0.84,'SB(s)a: sp','in a radial-velocity based grouping',NULL,NULL,NULL,1,188.64475,18.20269,0.047,NULL,58919348967,920614827,14384606,12.88),(96831,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96831,31.15,NULL,17,40589,NULL,NULL,NULL,'VCC 1572',NULL,'2014A&A...562A..49M',2014,1,0.62,NULL,'G',0.000033,NULL,'16.2g',0.39,'BCD','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,188.64575,2.56883,0.017,NULL,57999922228,906248784,14160137,16.2),(96832,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96832,34.6,0.49,83.3,40590,75,NULL,'IR','UGC 07738',NULL,'2011yCatp016004901K',2011,1,1.59,NULL,'G',0.000194,NULL,'15.7g',0.21,'Scd',NULL,NULL,NULL,NULL,1,188.647917,42.43781,0,NULL,59117989050,923718578,14433102,15.7),(96833,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96833,34.7,NULL,87,40590,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07738',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96834,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96834,34.72,NULL,88.1,40590,NULL,NULL,'Dipole + Quadrupole','UGC 07738',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96835,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96835,34.74,NULL,88.6,40590,NULL,NULL,'Dipole','UGC 07738',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96836,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96836,34.74,NULL,88.9,40590,NULL,NULL,NULL,'UGC 07738',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96837,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96837,37.8,0.46,362,40591,70,NULL,NULL,'SDSS J123435.65+015510.3',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,188.648583,1.91956,0,NULL,58000315342,906254927,14160233,17.5),(96838,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96838,37.28,0.46,286,40592,70,NULL,NULL,'2MASX J12343579+0324363',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,188.649167,3.41003,0.09,NULL,58231427767,909866058,14216657,17.7),(96839,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96839,35.98,0.21,157,40593,70,NULL,NULL,'I Zw 039 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000178,NULL,'16.1g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,188.649291667,47.76011,0,NULL,59065088534,922892008,14420187,16.1),(96840,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96840,38.04,0.46,405,40594,70,NULL,NULL,'2MASX J12343612+5259505',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000147,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,188.65075,52.99736,0.017,NULL,57231237407,894238084,13972470,17.5),(96841,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96841,37.11,0.46,264,40595,70,NULL,NULL,'2MASX J12343792-0219178',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000086,NULL,'16.2g',0.39,'E0',NULL,NULL,NULL,NULL,1,188.6580417,-2.32161,0.037,NULL,42985578820,671649669,10494526,16.2),(96842,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96842,38.18,0.14,433,40596,70,NULL,NULL,'2MASX J12343818+6418031',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000151,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,188.6587083,64.30075,0.025,NULL,57366716375,896354943,14005545,17.3),(96843,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96843,37.46,0.13,310,40597,70,NULL,NULL,'2MASX J12343832+1638522',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,188.659667,16.64786,0.023,NULL,58882540760,920039699,14375620,NULL),(96844,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96844,35.32,0.46,116,40598,70,NULL,NULL,'MCG +08-23-058',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000153,NULL,'15.5g',0.5,'S0^-',NULL,NULL,NULL,NULL,1,188.659667,49.60767,0,NULL,57236520021,894320625,13973759,15.5),(96845,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96845,36.6,0.33,209,40599,70,NULL,NULL,'2MASX J12343860+5042384',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00017,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,188.661208333,50.71058,0,NULL,57237314314,894333036,13973953,16.9),(96846,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96846,37.49,0.46,314,40600,70,NULL,NULL,'2MASX J12343868+4844305',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,188.661333,48.74181,0,NULL,57181094690,893454604,13960228,17.3),(96847,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96847,38.11,0.46,419,40601,70,NULL,NULL,'SDSS J123438.77+115043.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,188.661583,11.84533,0.12,NULL,58163705401,908807896,14200123,18.1),(96848,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96848,29.2,0.49,6.93,40602,75,NULL,'IR','IC 3521',NULL,'2011yCatp016004901K',2011,1,1.43,'2MASS position is in the southwestern portion.','G',0.00002,NULL,'13.9g',0.93,'SBm pec;BCD    HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,188.664625,7.16019,0,NULL,58239225543,909987899,14218560,13.9),(96849,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96849,31.12,0.36,16.7,40602,NULL,NULL,NULL,'IC 3521',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96850,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96850,31.23,NULL,17.6,40602,NULL,NULL,NULL,'IC 3521',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96851,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96851,37.85,0.27,372,40603,70,NULL,NULL,'2MASX J12343955+0707050',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000202,NULL,'16.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,188.6647083,7.11811,0,NULL,58241057105,910016517,14219008,16.4),(96852,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96852,38.05,0.27,407,40604,70,NULL,NULL,'SDSS J123440.74+281117.0',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00021,NULL,'16.8g',0.27,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,188.6697917,28.18808,0.071,NULL,58732473280,917694895,14338982,16.8),(96853,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96853,37.9,0.46,381,40605,70,NULL,NULL,'2MASX J12344199+2734295',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000162,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,188.6750417,27.57497,0.065,NULL,58609380779,915771574,14308930,16.9),(96854,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96854,38.85,0.46,590,40606,70,NULL,NULL,'VPC 0970',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000193,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,188.6754583,12.30333,0.124,NULL,58163867346,908810427,14200162,17.9),(96855,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96855,37.85,0.27,372,40607,70,NULL,NULL,'SDSS J123442.26+070558.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000168,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,188.676125,7.09953,0,NULL,58241060410,910016568,14219008,18.3),(96856,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96856,37.21,0.46,276,40608,70,NULL,NULL,'2MASX J12344228+0419583',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000159,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,188.676417,4.33278,0,NULL,58229845853,909841341,14216270,17),(96857,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96857,37.19,0.46,274,40609,70,NULL,NULL,'2MASX J12344305+0655160',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,188.679375,6.92097,0,NULL,58240593521,910009273,14218894,17.6),(96858,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96858,35.22,0.49,111,40610,75,NULL,'IR','UGC 07744',NULL,'2011yCatp016004901K',2011,1,1.05,NULL,'G',0.000097,NULL,'15.9g',0.21,'Scd',NULL,NULL,NULL,NULL,1,188.680875,46.95783,0,NULL,59067654543,922932102,14420814,15.9),(96859,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96859,35.52,NULL,127,40610,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07744',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96860,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96860,35.54,NULL,128,40610,NULL,NULL,'Dipole + Quadrupole','UGC 07744',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96861,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96861,35.55,NULL,129,40610,NULL,NULL,'Dipole','UGC 07744',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96862,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96862,35.56,NULL,130,40610,NULL,NULL,NULL,'UGC 07744',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96863,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96863,36.2,0.67,174,40611,70,NULL,NULL,'2MASX J12344452-4902244',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,188.685625,-49.04011,0.625,NULL,44568890168,696388908,10881076,16.5),(96864,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96864,37.79,0.46,361,40612,70,NULL,NULL,'2MASX J12344471+0156413',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000181,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,188.68625,1.94469,0,NULL,58000828680,906262948,14160358,18.1),(96865,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96865,39.14,0.46,673,40613,70,NULL,NULL,'2MASX J12344493+5606561',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,188.6869583,56.11569,0,NULL,57402404737,896912574,14014258,18.2),(96866,'Tully est','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96866,30.91,0.8,15.2,40614,75,NULL,'B','Holmberg VII',NULL,'1988NBGC.C....0000T',1988,1,1.3,'Multiple SDSS entries describe this object.','G',0.000013,NULL,'14.62',1.2,'Im             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,188.68875,6.30056,0,NULL,58240148882,910002326,14218786,14.62),(96867,'Tully est','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96867,31.13,0.8,16.8,40615,75,NULL,NULL,'IC 3522',NULL,'1988NBGC.C....0000T',1988,1,1.03,NULL,'G',0.000013,NULL,'15.8g',0.52,'ImIII-IV pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,188.689916667,15.22078,0.045,NULL,58881657069,920025891,14375404,15.8),(96868,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96868,32.15,0.42,26.9,40615,65,NULL,NULL,'IC 3522',NULL,'1980ApJ...238..458M',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96869,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96869,38,0.19,398,40616,70,NULL,NULL,'2MASX J12344586+2828244',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,188.691,28.4735,0.073,NULL,58732119450,917689366,14338896,17.8),(96870,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96870,37.44,0.33,308,40617,70,NULL,NULL,'2MASX J12344700+0815110',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000174,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,188.6957917,8.253,0,NULL,58238979883,909984060,14218500,16.6),(96871,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96871,37.57,0.23,327,40618,70,NULL,NULL,'2MASX J12344758+0450285',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,188.6984583,4.84108,0,NULL,58230444748,909850699,14216417,17.1),(96872,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96872,38,0.19,398,40619,70,NULL,NULL,'2MASX J12344775+2830014',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00017,NULL,'16.8g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,188.698917,28.50033,0.073,NULL,58732134292,917689598,14338899,16.8),(96873,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96873,38.15,0.46,427,40620,70,NULL,NULL,'2MASX J12344772+2714348',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,188.6989583,27.24308,0.057,NULL,58609603361,915775052,14308985,17.8),(96874,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96874,33.57,0.5,51.9,40621,70,NULL,NULL,'ESO 268- G 022',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00013,NULL,'14.63',0.5,'S0',NULL,NULL,NULL,NULL,1,188.703208333,-44.73547,0.421,NULL,46768590840,730759231,11418112,14.63),(96875,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96875,37.73,0.46,352,40622,70,NULL,NULL,'2MASX J12344914-0104357',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00008,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,188.704667,-1.07661,0.045,NULL,42984569079,671633891,10494279,17.6),(96876,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96876,38.18,0.14,433,40623,70,NULL,NULL,'2MASX J12344958+6417417',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000181,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,188.706333333,64.29489,0.025,NULL,57366714644,896354916,14005545,17.5),(96877,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96877,37.8,0.21,364,40624,70,NULL,NULL,'2MASX J12345017+0531255',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,188.7092083,5.52369,0,NULL,58229531141,909836424,14216194,17.7),(96878,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96878,38,0.19,398,40625,70,NULL,NULL,'2MASX J12345057+2827568',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000153,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,188.710666667,28.46583,0.073,NULL,58732132529,917689570,14338899,18.5),(96879,'Tully est','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96879,31.13,0.8,16.8,40626,75,NULL,'B','NGC 4540',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000007,NULL,'12.44',1.5,'SAB(rs)cd;LINERSy1','in a radial-velocity based grouping',NULL,NULL,NULL,1,188.7119583,15.55172,0.045,NULL,58881201942,920018780,14375293,12.44),(96880,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96880,30.51,NULL,12.6,40626,NULL,NULL,NULL,'NGC 4540',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96881,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96881,37.05,0.46,257,40627,70,NULL,NULL,'2MASX J12345124+1916595',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,188.713375,19.28328,0.068,NULL,58920630285,920634848,14384919,17.2),(96882,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96882,36.79,0.46,228,40628,70,NULL,NULL,'2MASX J12345126+3437433',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000234,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,188.713791667,34.62861,0,NULL,58741849619,917841400,14341271,17.1),(96883,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96883,37.71,0.46,348,40629,70,NULL,NULL,'2MASX J12345151+1008480',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,188.7145,10.14661,0,NULL,58190207799,909221996,14206593,17.5),(96884,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96884,37.16,0.46,270,40630,70,NULL,NULL,'2MASX J12345493-0018237',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000078,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,188.728833333,-0.30664,0.05,NULL,42984488782,671632637,10494259,17.2),(96885,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96885,37.89,0.21,379,40631,70,NULL,NULL,'SDSS J123456.56+014713.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000164,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,188.7357083,1.78719,0,NULL,58000313327,906254895,14160232,18.4),(96886,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96886,37.59,0.46,330,40632,70,NULL,NULL,'2MASX J12345745+2612078',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000142,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,188.7394583,26.20219,0.025,NULL,58617809422,915903272,14310988,17.5),(96887,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96887,37.57,0.46,326,40633,70,NULL,NULL,'2MASX J12345747+0251236',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000153,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,188.739583,2.85675,0.045,NULL,58230601613,909853150,14216455,17.5),(96888,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96888,37.15,0.46,269,40634,70,NULL,NULL,'VPC 0980',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,188.7404583,11.52947,0.037,NULL,58163465436,908804147,14200064,17),(96889,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96889,37.54,0.46,322,40635,70,NULL,NULL,'2MASX J12345809+2026286',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,188.7419583,20.44136,0.116,NULL,58919551030,920617984,14384656,17.1),(96890,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96890,38.1,0.46,417,40636,70,NULL,NULL,'2MASX J12345873+6218257',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000177,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,188.744833,62.30728,0,NULL,57375308651,896489197,14007643,17.5),(96891,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96891,38.02,0.46,401,40637,70,NULL,NULL,'2MASX J12345883+2114316',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,188.745041667,21.24208,0.119,NULL,58911493513,920492086,14382688,17.5),(96892,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 2009do','R',96892,36.05,0.07,162,40638,NULL,NULL,'MLCS2k2, R(V) = 1.8','MCG +09-21-022',NULL,'2015Sci...347.1459K',2015,1,0.9,'z=0.2267 from 2010AJ....139.2525H applies to QSO 40\\\" southeast.','G',NULL,'SN','16.53',0.3,'(R)SBab',NULL,NULL,NULL,NULL,1,188.74725,50.85111,0,NULL,57237359720,894333745,13973964,16.53),(96893,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN 2009do','R',96893,36.07,0.08,164,40638,NULL,NULL,'MLCS2k2, R(V) = 3.1','MCG +09-21-022',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96894,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96894,35.05,0.49,102,40639,75,NULL,'IR','FGC 1464',NULL,'2011yCatp016004901K',2011,1,1.22,NULL,'G',0.00008,':','16.9g',0.13,'Sd',NULL,NULL,NULL,NULL,1,188.7474583,36.05989,0,NULL,58564989507,915077961,14298093,16.9),(96895,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96895,35.13,NULL,106,40639,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1464',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96896,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96896,35.13,NULL,106,40639,NULL,NULL,'Dipole + Quadrupole','FGC 1464',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96897,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96897,35.14,NULL,107,40639,NULL,NULL,NULL,'FGC 1464',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96898,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96898,35.14,NULL,107,40639,NULL,NULL,'Dipole','FGC 1464',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96899,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96899,37.57,0.23,327,40640,70,NULL,NULL,'2MASX J12345996+0449496',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000159,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,188.75,4.83044,0.015,NULL,58230501132,909851580,14216430,17.3),(96900,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96900,37.57,0.23,326,40641,70,NULL,NULL,'2MASX J12350047+3347473',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000189,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,188.752,33.79653,0.02,NULL,58741522587,917836290,14341192,16.7),(96901,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96901,38.18,0.14,433,40642,70,NULL,NULL,'2MASX J12350046+6421118',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00013,NULL,'17.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,188.752166667,64.35325,0.025,NULL,57367400509,896365632,14005713,17.7),(96902,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96902,37.88,0.15,377,40643,70,NULL,NULL,'SDSS J123500.64+064056.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,188.7527083,6.68228,0,NULL,58240769044,910012016,14218937,17.7),(96903,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96903,37.89,0.21,379,40644,70,NULL,NULL,'SDSS J123501.18+014413.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000158,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,188.754917,1.73697,0.046,NULL,58000344467,906255382,14160240,18.6),(96904,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96904,37.99,0.46,396,40645,70,NULL,NULL,'2MASX J12350181+2748488',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,188.757667,27.81361,0.071,NULL,58732373885,917693341,14338958,18.1),(96905,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96905,36.41,0.33,192,40646,70,NULL,NULL,'CGCG 014-069',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000101,NULL,'15.5g',0.5,'E0',NULL,NULL,NULL,NULL,1,188.761833333,-3.67864,0.037,NULL,43182922408,674733162,10542705,15.5),(96906,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96906,35.96,0.46,156,40647,70,NULL,NULL,'2MASX J12350362+1546504',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000153,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,188.765167,15.78058,0.018,NULL,58880980927,920015326,14375239,16.3),(96907,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96907,36.13,0.46,168,40648,70,NULL,NULL,'2MASX J12350396+2158596',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,188.766583,21.98317,0.073,NULL,58893933501,920217710,14378401,16.1),(96908,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96908,37.88,0.15,377,40649,70,NULL,NULL,'2MASX J12350492+0619310',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,188.770667,6.32522,0,NULL,58240865482,910013523,14218961,18.1),(96909,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96909,37.89,0.21,379,40650,70,NULL,NULL,'2MASX J12350523+0146086',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.0002,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,188.771667,1.76914,0,NULL,58000310840,906254856,14160232,17.3),(96910,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96910,37.28,0.46,285,40651,70,NULL,NULL,'2MASX J12350552+6643437',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000077,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,188.772917,66.72892,0.033,NULL,57854234229,903972409,14124568,17.3),(96911,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96911,37.05,0.46,257,40652,70,NULL,NULL,'VPC 0983',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000257,NULL,'17.25',0.17,NULL,NULL,NULL,NULL,NULL,1,188.773166667,11.62269,0.037,NULL,58163466492,908804163,14200065,17.25),(96912,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96912,37.28,0.46,286,40653,70,NULL,NULL,'VPC 0984',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000158,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,188.77625,12.78725,0.106,NULL,58163736863,908808388,14200131,16.9),(96913,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96913,38.14,0.46,425,40654,70,NULL,NULL,'2MASX J12350655+1152054',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000159,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,188.77725,11.86819,0.12,NULL,58163562138,908805658,14200088,18.3),(96914,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96914,35.12,0.5,106,40655,70,NULL,NULL,'2MASX J12350695-0746107',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.000073,NULL,'14.83',0.28,NULL,NULL,NULL,NULL,NULL,1,188.7789583,-7.76972,0.109,NULL,43212678620,675198103,10549970,14.83),(96915,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96915,36.68,0.46,217,40656,70,NULL,NULL,'2MASX J12350848+3726166',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000146,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,188.785333,37.43786,0,NULL,58565979173,915093424,14298334,17.9),(96916,'IRAS','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96916,35.29,0.8,114,40657,75,NULL,'W91CL, r','UGC 07750',NULL,'1997ApJS..109..333W',1997,1,1.34,'Position in 1997AJ....113...22G is incorrect.','G',0.000023,NULL,'14.6g',0.49,'Sbc',NULL,NULL,NULL,NULL,1,188.7887083,29.74419,0.098,NULL,58776492697,918382698,14349729,14.6),(96917,'IRAS','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96917,35.3,0.8,115,40657,75,NULL,'CF, r','UGC 07750',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96918,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96918,35.06,0.33,103,40657,NULL,NULL,'Malmquist cor.','UGC 07750',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96919,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96919,35.08,0.38,104,40657,75,NULL,'CF, r, raw','UGC 07750',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96920,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96920,35.18,0.38,109,40657,75,NULL,'CF, r, cor','UGC 07750',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96921,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96921,35.23,0.38,111,40657,75,NULL,'W91CL, r, raw','UGC 07750',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96922,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96922,35.26,0.38,113,40657,75,NULL,'CF, r, inv','UGC 07750',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96923,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96923,35.26,0.3,113,40657,NULL,NULL,NULL,'UGC 07750',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96924,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96924,35.27,0.38,113,40657,75,NULL,'W91CL, r, cor','UGC 07750',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96925,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96925,35.32,0.2,116,40657,74.4,NULL,NULL,'UGC 07750',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96926,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96926,35.39,0.4,120,40657,NULL,NULL,'mean','UGC 07750',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96927,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96927,35.42,0.38,121,40657,75,NULL,'W91CL, r, inv','UGC 07750',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96928,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96928,35.57,0.47,130,40657,NULL,NULL,'H','UGC 07750',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96929,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96929,37.58,0.46,328,40658,70,NULL,NULL,'2MASX J12350939+2844178',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00017,NULL,'16.5g',0.34,'E',NULL,NULL,NULL,NULL,1,188.78925,28.73839,0.065,NULL,58732296520,917692133,14338939,16.5),(96930,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96930,37.57,0.23,327,40659,70,NULL,NULL,'2MASX J12351013+0446176',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.1g',0.26,'BrClG',NULL,NULL,NULL,NULL,1,188.792208333,4.77156,0.015,NULL,58230467776,909851059,14216422,17.1),(96931,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96931,34.46,0.49,78,40660,70,NULL,NULL,'NGC 4541',NULL,'2014MNRAS.445.2677S',2014,1,1.58,'UZC has V = 9083 +- 36 km/sec.','G',0.000017,NULL,'13.6g',0.68,'(R\')SAB(r)bc:','Group member',NULL,NULL,NULL,1,188.794417,-0.22114,0.05,NULL,42984449549,671632024,10494250,13.6),(96932,'IRAS','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96932,34.94,0.8,97.5,40660,75,NULL,'CF, r','NGC 4541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96933,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96933,34.4,NULL,75.9,40660,NULL,NULL,'B','NGC 4541',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96934,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96934,34.8,0.51,91.3,40660,NULL,NULL,'Malmquist cor.','NGC 4541',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96935,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96935,34.81,NULL,91.6,40660,NULL,NULL,'I','NGC 4541',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96936,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96936,34.84,0.38,92.9,40660,75,NULL,'CF, r, raw','NGC 4541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96937,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96937,35,0.47,99.8,40660,NULL,NULL,NULL,'NGC 4541',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96938,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96938,35.03,0.38,101,40660,75,NULL,'CF, r, cor','NGC 4541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96939,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96939,35.04,0.2,102,40660,74.4,NULL,NULL,'NGC 4541',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96940,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96940,35.07,0.38,103,40660,75,NULL,'CF, r, inv','NGC 4541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96941,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96941,38.18,0.14,433,40661,70,NULL,NULL,'SDSS J123510.88+642139.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000136,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,188.795375,64.361,0.025,NULL,57367453824,896366466,14005726,18.3),(96942,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96942,37.96,0.46,391,40662,70,NULL,NULL,'2MASX J12351111+5718212',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000125,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,188.7964583,57.30589,0,NULL,57408237012,897003703,14015682,17.8),(96943,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96943,37.89,0.21,379,40663,70,NULL,NULL,'SDSS J123511.33+014646.5',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,188.7972083,1.77958,0,NULL,58000310497,906254851,14160232,17.6),(96944,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96944,36.23,0.33,176,40664,70,NULL,NULL,'2MASX J12351147+0550276',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000187,NULL,'15.9g',0.45,'S0',NULL,NULL,NULL,NULL,1,188.797875,5.84089,0,NULL,58240029226,910000456,14218757,15.9),(96945,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96945,36.41,0.33,192,40665,70,NULL,NULL,'LCRS B123237.1-031218',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000064,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,188.797917,-3.48047,0.037,NULL,43183406421,674740725,10542823,17.1),(96946,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96946,37.3,0.46,288,40666,70,NULL,NULL,'2MASX J12351155+1724594',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.45',0.31,NULL,NULL,NULL,NULL,NULL,1,188.798375,17.4165,0.036,NULL,58914459503,920538429,14383412,17.45),(96947,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96947,29.49,NULL,7.91,40667,NULL,NULL,NULL,'UGC 07751',NULL,'2013AJ....145..101K',2013,1,1,NULL,'G',0.00002,NULL,'16.5',0.3,'Im:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,188.799041667,41.06094,0.014,NULL,59115477234,923679331,14432489,16.5),(96948,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96948,38,0.19,398,40668,70,NULL,NULL,'2MASX J12351303+2836238',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,188.8045417,28.6065,0.065,NULL,58732171128,917690173,14338908,17.7),(96949,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96949,37.57,0.23,327,40669,70,NULL,NULL,'2MASX J12351401+0445496',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,188.808375,4.76372,0.015,NULL,58230467594,909851056,14216422,17.7),(96950,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96950,38.37,0.46,471,40670,70,NULL,NULL,'2MASX J12351510+4159276',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,188.812958333,41.99128,0,NULL,59115197058,923674954,14432421,18.1),(96951,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96951,38.13,0.46,423,40671,70,NULL,NULL,'SDSS J123515.93+103759.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00019,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,188.816417,10.63325,0,NULL,58198472486,909351132,14208611,17.9),(96952,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96952,37.23,0.46,280,40672,70,NULL,NULL,'2MASX J12351618+4343138',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000179,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,188.817375,43.72061,0,NULL,59117572696,923712073,14433001,16.6),(96953,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96953,35.98,0.21,157,40673,70,NULL,NULL,'2MASX J12351695+4717598',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000186,NULL,'15.5g',0.41,'E0',NULL,NULL,NULL,NULL,1,188.820791667,47.29997,0,NULL,59064954655,922889916,14420154,15.5),(96954,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96954,37.08,0.46,260,40674,70,NULL,NULL,'2MASX J12351775+0353233',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000136,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,188.823916667,3.88981,0,NULL,58231310081,909864220,14216628,17.7),(96955,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96955,37.88,0.15,377,40675,70,NULL,NULL,'SDSS J123518.29+061604.4',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,188.826208333,6.26789,0,NULL,58240918860,910014357,14218974,18.2),(96956,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96956,37.3,0.46,288,40676,70,NULL,NULL,'2MASX J12351840+1658494',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.47',0.12,NULL,NULL,NULL,NULL,NULL,1,188.826583,16.98031,0.031,NULL,58881936919,920030264,14375472,18.47),(96957,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96957,35.39,0.46,119,40677,70,NULL,NULL,'2MASX J12351892+3555417',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000165,NULL,'16.0g',0.38,NULL,NULL,NULL,NULL,NULL,1,188.8287917,35.92828,0,NULL,58564977777,915077777,14298090,16),(96958,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96958,38.44,0.27,487,40678,70,NULL,NULL,'2MASX J12351919+2734408',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000195,NULL,'17.2g',0.22,'BrClG',NULL,NULL,NULL,NULL,1,188.829833,27.57806,0.065,NULL,58730276036,917660563,14338446,17.2),(96959,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96959,36.8,0.46,230,40679,70,NULL,NULL,'2MASX J12351950+3919537',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00017,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,188.831167,39.33156,0,NULL,58557497007,914960890,14296263,16.4),(96960,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96960,38.44,0.27,487,40680,70,NULL,NULL,'2MASX J12351972+2735588',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,188.832083,27.59961,0.065,NULL,58730280808,917660637,14338447,17.3),(96961,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96961,35.98,0.21,157,40681,70,NULL,NULL,'2MASX J12352078+4718358',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,188.836583333,47.30997,0,NULL,59064954747,922889917,14420154,17.7),(96962,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96962,37.2,0.46,276,40682,70,NULL,NULL,'2MASX J12352082+2139399',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,188.836875,21.66114,0.081,NULL,58893962886,920218170,14378408,17.7),(96963,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96963,38.57,0.46,517,40683,70,NULL,NULL,'2MASX J12352179+5728282',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000192,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,188.841125,57.47436,0,NULL,57407818229,896997159,14015580,18),(96964,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96964,38.53,0.46,507,40684,70,NULL,NULL,'2MASX J12352221+1001301',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,188.8427083,10.02494,0,NULL,58198333876,909348966,14208577,17.5),(96965,'IRAS','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96965,34.01,0.8,63.3,40685,75,NULL,'HMCL, I','UGC 07754',NULL,'1997ApJS..109..333W',1997,1,1.09,NULL,'G',0.000033,NULL,'14.9g',0.41,'Sbc            Sbrst',NULL,NULL,NULL,NULL,1,188.849917,29.49208,0.065,NULL,58776581568,918384087,14349751,14.9),(96966,'IRAS','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96966,34.01,0.8,63.3,40685,75,NULL,'A82, H','UGC 07754',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96967,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96967,34.34,0.47,73.6,40685,75,NULL,'A82, H, raw','UGC 07754',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96968,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96968,34.37,0.47,74.7,40685,75,NULL,'A82, H, inv','UGC 07754',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96969,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96969,34.4,0.4,75.8,40685,75,NULL,'HMCL, I, raw','UGC 07754',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96970,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96970,34.41,0.49,76.3,40685,NULL,NULL,NULL,'UGC 07754',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96971,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96971,34.45,0.2,77.6,40685,74.4,NULL,NULL,'UGC 07754',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96972,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96972,34.51,0.4,79.7,40685,75,NULL,'HMCL, I, inv','UGC 07754',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96973,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96973,34.66,0.44,85.7,40685,NULL,NULL,'Malmquist cor.','UGC 07754',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96974,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96974,34.72,0.4,87.8,40685,75,NULL,'HMCL, I, cor','UGC 07754',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96975,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96975,34.73,0.47,88.3,40685,75,NULL,'A82, H, cor','UGC 07754',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96976,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96976,37.46,0.13,310,40686,70,NULL,NULL,'2MASX J12352430+1635114',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000227,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,188.85125,16.5865,0.023,NULL,58882352160,920036752,14375574,16.7),(96977,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96977,37.12,0.46,265,40687,70,NULL,NULL,'2MASX J12352441+2144149',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.61',0.15,NULL,NULL,NULL,NULL,NULL,1,188.851916667,21.73736,0.081,NULL,58893966286,920218223,14378409,17.61),(96978,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96978,37.88,0.15,377,40688,70,NULL,NULL,'2MASX J12352457+0637281',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000207,NULL,'15.9g',0.44,NULL,NULL,NULL,NULL,NULL,1,188.852375,6.62442,0,NULL,58240784284,910012254,14218941,15.9),(96979,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96979,36.49,0.46,198,40689,70,NULL,NULL,'2MASX J12352471+1619144',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'16.91',0.14,NULL,NULL,NULL,NULL,NULL,1,188.852917,16.32078,0.006,NULL,58882522207,920039409,14375615,16.91),(96980,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96980,37.5,0.33,317,40690,70,NULL,NULL,'VPC 0994',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000169,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,188.8532083,14.91714,0.073,NULL,58880815826,920012747,14375199,16.9),(96981,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96981,37.88,0.15,377,40691,70,NULL,NULL,'2MASX J12352490+0610371',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000096,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,188.8537083,6.17694,0,NULL,58240886720,910013855,14218966,18),(96982,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96982,37.46,0.46,310,40692,70,NULL,NULL,'2MASX J12352533+1009381',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,188.855417,10.16069,0,NULL,58198391538,909349867,14208591,17.3),(96983,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96983,30.52,0.13,12.7,40693,73,NULL,'Cepheids periods Gaussian ','MESSIER 091',NULL,'2009RoAJ...19...35A',2009,1,5.4,NULL,'G',0.000013,NULL,'10.96',4.3,'SBb(rs);LINER  Sy','in a radial-velocity based grouping',NULL,NULL,'LINER',1,188.8602083,14.49633,0.065,NULL,58880749359,920011708,14375182,10.96),(96984,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96984,30.64,0.03,13.4,40693,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian ','MESSIER 091',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96985,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96985,30.77,0.55,14.3,40693,73,NULL,'Cepheids magnitudes Gaussian ','MESSIER 091',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96986,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96986,30.77,0.08,14.3,40693,NULL,NULL,'cte LMC K03','MESSIER 091',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96987,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96987,30.78,0.08,14.3,40693,NULL,NULL,'cte U99','MESSIER 091',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96988,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96988,30.8,0.08,14.5,40693,NULL,NULL,'cte LMC STS02','MESSIER 091',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96989,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96989,30.83,0.08,14.7,40693,NULL,NULL,'cte MW FSG03','MESSIER 091',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96990,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96990,30.85,0.08,14.8,40693,NULL,NULL,'cte MW GFG98','MESSIER 091',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96991,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96991,30.87,0.08,14.9,40693,NULL,NULL,'cte MF91','MESSIER 091',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96992,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96992,30.88,0.05,15,40693,NULL,NULL,'24, VI, KEY PROJECT','MESSIER 091',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96993,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96993,30.91,0.05,15.2,40693,NULL,NULL,'MW HIPP','MESSIER 091',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96994,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96994,30.92,0.08,15.3,40693,NULL,NULL,'cte MW STS03','MESSIER 091',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96995,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96995,30.94,0.09,15.4,40693,NULL,NULL,'LMC W01','MESSIER 091',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96996,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96996,30.94,0.17,15.4,40693,NULL,NULL,'MW P02','MESSIER 091',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96997,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',96997,30.99,NULL,15.8,40693,NULL,18.54,NULL,'MESSIER 091',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96998,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96998,30.99,0.03,15.8,40693,NULL,NULL,'4, VI (PC)','MESSIER 091',NULL,'2000ApJ...530L...5G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(96999,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,96999,30.99,0.04,15.8,40693,NULL,18.54,'LMC ZP','MESSIER 091',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97000,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97000,31.01,0.07,15.9,40693,NULL,NULL,'20, VI (WF)','MESSIER 091',NULL,'2000ApJ...530L...5G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97001,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97001,31.03,0.08,16.1,40693,NULL,NULL,'100, VI','MESSIER 091',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97002,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97002,31.04,0.08,16.1,40693,NULL,NULL,'26, VI','MESSIER 091',NULL,'1999ApJ...516..626G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97003,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97003,31.03,0.08,16.1,40693,NULL,NULL,'MW GFG','MESSIER 091',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97004,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97004,31.04,0.08,16.1,40693,NULL,NULL,'HST KP Calibrated','MESSIER 091',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97005,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97005,31.05,0.05,16.2,40693,NULL,NULL,'24, VI, +Z, KEY PROJECT','MESSIER 091',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97006,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97006,31.17,0.08,17.1,40693,74.4,NULL,NULL,'MESSIER 091',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97007,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97007,31.24,0.08,17.7,40693,NULL,NULL,'Z, Key Project','MESSIER 091',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97008,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97008,31.39,NULL,19,40693,NULL,NULL,'24, VI','MESSIER 091',NULL,'2006A&A...452..423P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97009,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97009,31.17,0.08,17.1,40693,74.4,NULL,NULL,'MESSIER 091',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97010,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97010,31.42,0.54,19.2,40693,NULL,NULL,'I','MESSIER 091',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97011,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97011,31.48,0.55,19.8,40693,NULL,NULL,'HST KP Calibrated, I','MESSIER 091',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97012,'Grav. Stability Gas. Disk','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97012,31.61,0.1,21,40693,58,NULL,'Assuming Virgo D = 20 Mpc','MESSIER 091',NULL,'1997ApJ...485..439B',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97013,'Sosies','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97013,30.94,0.37,15.4,40693,NULL,NULL,NULL,'MESSIER 091',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97014,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97014,30.74,NULL,14.1,40693,NULL,NULL,'I','MESSIER 091',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97015,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97015,30.88,NULL,15,40693,NULL,NULL,NULL,'MESSIER 091',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97016,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97016,30.92,NULL,15.3,40693,NULL,NULL,'B','MESSIER 091',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97017,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97017,30.98,0.07,15.7,40693,NULL,NULL,'B','MESSIER 091',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97018,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97018,30.98,NULL,15.7,40693,NULL,NULL,'B','MESSIER 091',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97019,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97019,31.05,0.05,16.2,40693,75,NULL,NULL,'MESSIER 091',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97020,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97020,31.13,0.4,16.8,40693,75,NULL,'B','MESSIER 091',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97021,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97021,31.17,0.08,17.1,40693,74.4,NULL,NULL,'MESSIER 091',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97022,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97022,31.23,0.7,17.6,40693,NULL,NULL,'HI','MESSIER 091',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97023,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97023,31.28,0.53,18,40693,NULL,NULL,NULL,'MESSIER 091',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97024,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97024,31.29,0.52,18.1,40693,NULL,NULL,'Malmquist cor.','MESSIER 091',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97025,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97025,31.31,0.92,18.3,40693,NULL,NULL,'CO','MESSIER 091',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97026,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97026,31.65,0.3,21.3,40693,55,NULL,'B','MESSIER 091',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97027,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97027,31.74,NULL,22.3,40693,NULL,NULL,'LEDA [April 2006]','MESSIER 091',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97028,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97028,37.44,0.33,308,40694,70,NULL,NULL,'2MASX J12352646+0811541',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000159,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,188.860375,8.19831,0,NULL,58239206320,909987598,14218556,17.5),(97029,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97029,38.18,0.14,433,40695,70,NULL,NULL,'2MASX J12352743+6423168',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000141,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,188.864333,64.38792,0.025,NULL,57367402192,896365659,14005713,18.3),(97030,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97030,38.02,0.46,402,40696,70,NULL,NULL,'2MASX J12352850+4552308',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00019,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,188.868833,45.87517,0,NULL,59111978921,923624670,14431635,17),(97031,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97031,37.81,0.33,365,40697,70,NULL,NULL,'2MASX J12352934+3521175',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000202,NULL,'15.7g',0.47,NULL,NULL,NULL,NULL,NULL,1,188.872333,35.35483,0,NULL,58564697485,915073398,14298021,15.7),(97032,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97032,30.73,0.14,14,40698,74.4,NULL,NULL,'NGC 4546',NULL,'2013AJ....146...86T',2013,1,3.3,'The APM position refers to the northeast side of the galaxy.','G',0.000017,NULL,'11.30',1.4,'SB(s)0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,188.872958333,-3.79319,0.057,NULL,43182827076,674731673,10542682,11.3),(97033,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97033,30.74,0.2,14.1,40698,NULL,NULL,'I','NGC 4546',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97034,'Faber-Jackson','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97034,32.09,NULL,26.2,40698,NULL,NULL,'LEDA [April 2006]','NGC 4546',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97035,'Tully est','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97035,31.56,0.8,20.5,40698,75,NULL,'B','NGC 4546',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97036,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97036,31.37,0.4,18.8,40698,NULL,NULL,'mean','NGC 4546',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97037,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97037,31.4,0.45,19,40698,NULL,NULL,'K','NGC 4546',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97038,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97038,37.82,0.46,366,40699,70,NULL,NULL,'2MASX J12352961+0748461',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000155,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,188.873583,7.81264,0,NULL,58239933951,909998967,14218733,17.4),(97039,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97039,37.37,0.46,298,40700,70,NULL,NULL,'2MASX J12353005+2314569',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,188.875125,23.24925,0.029,NULL,58894793008,920231140,14378611,17.3),(97040,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97040,37.53,0.46,321,40701,70,NULL,NULL,'2MASX J12353026+3859477',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000179,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,188.87625,38.99661,0,NULL,58560612086,915009563,14297024,17.7),(97041,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97041,31.46,0.24,19.5,40702,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4550',NULL,'2007ApJS..171..101J',2007,1,2.85,'v=381 km/s (1991RC3.9.C...0000d)','G',0.000017,NULL,'12.3g',0.82,'SB0^0^: sp     LINER','in a radial-velocity based grouping',NULL,NULL,'LINER',1,188.877417,12.22083,0.146,NULL,58152533339,908633333,14197395,12.3),(97042,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97042,31.46,0.22,19.6,40702,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4550',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97043,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97043,31.56,0.14,20.5,40702,NULL,NULL,NULL,'NGC 4550',NULL,'2001AJ....121.2950K',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97044,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97044,31.58,0.24,20.7,40702,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4550',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97045,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97045,31.7,0.23,21.9,40702,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4550',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97046,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97046,30.64,0.12,13.4,40702,74.4,NULL,NULL,'NGC 4550',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97047,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97047,30.82,0.22,14.6,40702,NULL,NULL,'I','NGC 4550',NULL,'2000ApJ...536..255N',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97048,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97048,30.93,0.07,15.3,40702,NULL,NULL,'HST ACS VCS','NGC 4550',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97049,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97049,30.95,0.05,15.5,40702,NULL,NULL,NULL,'NGC 4550',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97050,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97050,31,0.2,15.8,40702,NULL,NULL,'I','NGC 4550',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97051,'GC radius','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97051,30.76,0.11,14.2,40702,NULL,NULL,NULL,'NGC 4550',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97052,'Faber-Jackson','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97052,31.21,0.42,17.5,40702,95,NULL,'Weighted Mean','NGC 4550',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97053,'Faber-Jackson','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97053,31.29,0.63,18.1,40702,95,NULL,'Michard 1979b, c','NGC 4550',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97054,'Faber-Jackson','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97054,31.47,1.61,19.7,40702,55,NULL,'Visvanathan & Sandage 1979','NGC 4550',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97055,'Faber-Jackson','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97055,31.73,0.46,22.2,40702,95,NULL,'Michard 1979a','NGC 4550',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97056,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97056,30.64,0.12,13.4,40702,74.4,NULL,NULL,'NGC 4550',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97057,'Tertiary','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97057,30.49,0.25,12.5,40702,95,NULL,NULL,'NGC 4550',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97058,'Tully est','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97058,31.13,0.8,16.8,40702,75,NULL,'B','NGC 4550',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97059,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97059,29.5,0.45,7.94,40702,NULL,NULL,'K','NGC 4550',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97060,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97060,29.96,0.4,9.83,40702,NULL,NULL,'mean','NGC 4550',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97061,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97061,30.08,0.42,10.4,40702,65,NULL,NULL,'NGC 4550',NULL,'1980ApJ...238..458M',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97062,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97062,38.3,0.46,456,40703,70,NULL,NULL,'2MASX J12353164+3702527',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,188.881833,37.04806,0,NULL,58566012968,915093952,14298343,17.5),(97063,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97063,37.57,0.46,327,40704,70,NULL,NULL,'2MASX J12353208+1720424',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.12',0.15,NULL,NULL,NULL,NULL,NULL,1,188.883625,17.34519,0.036,NULL,58881755502,920027429,14375428,18.12),(97064,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97064,32.22,0.97,27.8,40705,NULL,NULL,'I','UGC 07767',NULL,'2001ApJ...546..681T',2001,1,0.9,NULL,'G',0.00009,NULL,'13.60',0.9,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,188.885208333,73.67486,0.049,NULL,57031348632,891114822,13923669,13.6),(97065,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97065,32.23,0.14,27.9,40705,74.4,NULL,NULL,'UGC 07767',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97066,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97066,37.46,0.46,310,40706,70,NULL,NULL,'2MASX J12353305+3651247',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000163,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,188.8877917,36.85683,0,NULL,58565522320,915086286,14298223,18),(97067,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97067,36.75,0.46,224,40707,70,NULL,NULL,'2MASX J12353342+2841108',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,188.88925,28.68644,0.065,NULL,58732305027,917692266,14338941,16.4),(97068,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97068,36.4,0.88,190,40708,70,NULL,NULL,'2MASX J12353352-5222030',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,188.88975,-52.36747,0.285,NULL,44612667892,697072935,10891764,17.3),(97069,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97069,38.23,0.46,442,40709,70,NULL,NULL,'2MASX J12353372+0559013',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,188.890625,5.98372,0,NULL,58240217583,910003399,14218803,17.5),(97070,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97070,37.96,0.33,391,40710,70,NULL,NULL,'2MASX J12353471+1106121',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,188.894833,11.10344,0,NULL,58198089015,909345140,14208517,17.8),(97071,'Tully est','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97071,29.93,0.8,9.7,40711,75,NULL,'B','NGC 4562',NULL,'1988NBGC.C....0000T',1988,1,2.32,NULL,'G',0.00001,NULL,'13.9g',0.69,'SB(s)dm: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,188.895,25.85,0.04,NULL,58618966859,915921357,14311271,13.9),(97072,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97072,29.94,0.43,9.7,40711,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4562',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97073,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97073,30.09,0.43,10.4,40711,75,NULL,'3.6 micron, color corrected','NGC 4562',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97074,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97074,30.21,0.2,11,40711,74.4,NULL,NULL,'NGC 4562',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97075,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97075,30.48,0.4,12.5,40711,NULL,NULL,NULL,'NGC 4562',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97076,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97076,30.55,0.49,12.9,40711,NULL,NULL,NULL,'NGC 4562',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97077,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97077,30.87,0.42,14.9,40711,NULL,NULL,'Malmquist cor.','NGC 4562',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97078,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97078,37.89,0.21,379,40712,70,NULL,NULL,'2MASX J12353567+0146313',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000204,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,188.898708333,1.77528,0,NULL,58000898072,906264032,14160375,16.2),(97079,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97079,37.5,0.33,317,40713,70,NULL,NULL,'VPC 1006',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000174,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,188.8987917,14.99339,0.073,NULL,58880769951,920012030,14375187,18.1),(97080,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97080,35.2,0.15,110,40714,70,NULL,NULL,'2MASX J12353589+2633598',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00005,NULL,'16.1g',0.33,NULL,NULL,NULL,NULL,NULL,1,188.899583,26.56669,0.021,NULL,58609721230,915776894,14309013,16.1),(97081,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97081,38.52,0.46,505,40715,70,NULL,NULL,'SDSS J123535.97+323036.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000139,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,188.899875,32.51022,0.028,NULL,58773841612,918341275,14349082,18.2),(97082,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97082,36.31,0.46,183,40716,70,NULL,NULL,'2MASX J12353626+3946537',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00017,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,188.901375,39.78158,0,NULL,58556812991,914950202,14296096,16.3),(97083,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97083,30.79,0.43,14.4,40717,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4544',NULL,'2014MNRAS.444..527S',2014,1,2,NULL,'G',0.000017,NULL,'14.00',0.6,'SB0/a? sp      HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,188.902375,3.03453,0.045,NULL,58230659001,909854046,14216469,14),(97084,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97084,31.02,0.43,16,40717,75,NULL,'3.6 micron, color corrected','NGC 4544',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97085,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97085,31.13,0.4,16.8,40717,75,NULL,NULL,'NGC 4544',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97086,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97086,31.17,NULL,17.1,40717,NULL,NULL,NULL,'NGC 4544',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97087,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97087,31.29,0.2,18.1,40717,74.4,NULL,NULL,'NGC 4544',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97088,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97088,31.51,0.4,20.1,40717,NULL,NULL,'mean','NGC 4544',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97089,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97089,31.58,0.45,20.7,40717,NULL,NULL,'K','NGC 4544',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97090,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97090,31.64,0.51,21.2,40717,NULL,NULL,'Malmquist cor.','NGC 4544',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97091,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97091,31.63,0.47,21.2,40717,NULL,NULL,'H','NGC 4544',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97092,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97092,31.68,0.5,21.7,40717,NULL,NULL,NULL,'NGC 4544',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97093,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97093,31.76,0.46,22.5,40717,NULL,NULL,'J','NGC 4544',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97094,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97094,31.8,0.49,22.9,40717,75,NULL,'IR','NGC 4544',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97095,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97095,37.88,0.15,377,40718,70,NULL,NULL,'SDSS J123536.67+063806.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,188.902833,6.63514,0,NULL,58240789594,910012337,14218942,18.1),(97096,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97096,30.94,0.14,15.4,40719,74.4,NULL,NULL,'VCC 1627',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000137,NULL,'15.0g',0.48,'E0','Group member',NULL,NULL,NULL,1,188.9052083,12.38203,0.188,NULL,58152562947,908633796,14197403,15),(97097,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97097,30.96,0.22,15.6,40719,NULL,NULL,'HST ACS VCS','VCC 1627',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97098,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97098,30.97,0.27,15.6,40719,NULL,NULL,NULL,'VCC 1627',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97099,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97099,38.03,0.46,404,40720,70,NULL,NULL,'SDSS J123537.42+112827.2',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000147,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,188.9059583,11.47422,0.037,NULL,58151935317,908623989,14197249,17.7),(97100,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97100,36.49,0.46,199,40721,70,NULL,NULL,'2MASX J12353753+3157285',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000093,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,188.9062083,31.958,0.024,NULL,58785804620,918528197,14352003,16.3),(97101,'Tully est','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97101,31.44,0.8,19.4,40722,75,NULL,NULL,'UGCA 289',NULL,'1988NBGC.C....0000T',1988,1,4.1,NULL,'G',0.000007,NULL,'15.09',2.1,'SAB(s)dm','X-ray-faint group member',NULL,NULL,NULL,1,188.906333333,-7.87781,0.065,NULL,43211987104,675187298,10549801,15.09),(97102,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97102,30.65,0.4,13.5,40722,NULL,NULL,NULL,'UGCA 289',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97103,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97103,30.88,0.43,15,40722,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 289',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97104,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97104,37.49,0.46,315,40723,70,NULL,NULL,'2MASX J12353767+0340003',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000166,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,188.907041667,3.66672,0.04,NULL,58231270786,909863606,14216618,16.8),(97105,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97105,37.96,0.33,391,40724,70,NULL,NULL,'VPC 1009',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00017,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,188.907375,11.10322,0,NULL,58198086385,909345099,14208517,16.7),(97106,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97106,38.18,0.14,433,40725,70,NULL,NULL,'2MASX J12353776+6422587',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000164,NULL,'16.9g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,188.9077083,64.38308,0.025,NULL,57367456170,896366502,14005726,16.9),(97107,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97107,31.32,0.33,18.4,40726,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4551',NULL,'2010ApJ...717..603V',2010,1,1.8,NULL,'G',0.000017,NULL,'12.97',1.4,'E2','in a radial-velocity based grouping',NULL,NULL,NULL,1,188.908125,12.26397,0.146,NULL,58152579244,908634050,14197407,12.97),(97108,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97108,31.4,0.41,19.1,40726,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4551',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97109,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97109,31.55,0.36,20.4,40726,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4551',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97110,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97110,31.63,0.33,21.2,40726,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4551',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97111,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97111,30.81,0.06,14.5,40726,NULL,NULL,'I','NGC 4551',NULL,'1990AJ....100.1416T',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97112,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97112,30.94,0.12,15.4,40726,74.4,NULL,NULL,'NGC 4551',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97113,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97113,31.04,0.06,16.1,40726,NULL,NULL,NULL,'NGC 4551',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97114,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97114,31.05,0.07,16.2,40726,NULL,NULL,'HST ACS VCS','NGC 4551',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97115,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97115,31.19,0.17,17.3,40726,NULL,NULL,'I','NGC 4551',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97116,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97116,31.19,0.17,17.3,40726,NULL,NULL,NULL,'NGC 4551',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97117,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97117,31.23,0.17,17.6,40726,NULL,NULL,'Malmquist cor.','NGC 4551',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97118,'GC radius','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97118,31.36,0.14,18.7,40726,NULL,NULL,NULL,'NGC 4551',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97119,'Faber-Jackson','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97119,30.53,0.45,12.8,40726,95,NULL,'Weighted Mean','NGC 4551',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97120,'Faber-Jackson','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97120,30.53,0.45,12.8,40726,95,NULL,'de Vaucouleurs','NGC 4551',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97121,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97121,30.94,0.12,15.4,40726,74.4,NULL,NULL,'NGC 4551',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97122,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97122,31.01,0.41,15.9,40726,NULL,NULL,NULL,'NGC 4551',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97123,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97123,31.06,NULL,16.3,40726,NULL,NULL,NULL,'NGC 4551',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97124,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97124,31.13,NULL,16.8,40726,NULL,NULL,NULL,'NGC 4551',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97125,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97125,31.22,0.41,17.5,40726,NULL,NULL,'Malmquist cor.','NGC 4551',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97126,'Tertiary','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97126,30.49,0.25,12.5,40726,95,NULL,NULL,'NGC 4551',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97127,'Tully est','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97127,31.13,0.8,16.8,40726,75,NULL,'B','NGC 4551',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97128,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97128,31.41,0.45,19.1,40726,NULL,NULL,'K','NGC 4551',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97129,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97129,31.66,0.4,21.5,40726,NULL,NULL,'mean','NGC 4551',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97130,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97130,36.8,0.46,229,40727,70,NULL,NULL,'2MASX J12353829+2650128',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00013,NULL,'16.0g',0.42,NULL,NULL,NULL,NULL,NULL,1,188.909667,26.83689,0.018,NULL,58610131306,915783301,14309114,16),(97131,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97131,37.81,0.33,365,40728,70,NULL,NULL,'SDSS J123538.34+351948.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000175,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,188.9097917,35.33008,0,NULL,58564765552,915074461,14298038,18.1),(97132,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97132,38.52,0.46,506,40729,70,NULL,NULL,'SDSS J123538.51+094927.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000144,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,188.9105,9.82439,0,NULL,58196529396,909320771,14208137,18.4),(97133,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97133,35.98,0.21,157,40730,70,NULL,NULL,'MCG +08-23-063',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000067,NULL,'15.3g',0.33,'S0/a',NULL,NULL,NULL,NULL,1,188.910625,47.75742,0.028,NULL,59064783336,922887239,14420113,15.3),(97134,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97134,38.5,0.46,500,40731,70,NULL,NULL,'2MASX J12353867+3709317',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000147,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,188.911333,37.15878,0,NULL,58566107956,915095436,14298366,17.8),(97135,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97135,38.18,0.14,433,40732,70,NULL,NULL,'2MASX J12353883+6433587',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000141,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,188.911583,64.56628,0.025,NULL,57321852524,895653945,13994592,17.7),(97136,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97136,30.01,0.4,10,40733,NULL,NULL,NULL,'2MASXi J1235396-110359',NULL,'2013MNRAS.429.2677K',2013,1,NULL,'Stars superposed? or 3-4 compact galaxies?','G',0.00015,NULL,'15.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,188.914,-11.06711,0.117,NULL,43164852223,674450815,10538293,15.7),(97137,'Cepheids','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97137,31.21,0.15,17.5,40734,NULL,NULL,'HST KP Calibrated, K\'','MESSIER 089',NULL,'2000ApJ...529..745F',2000,1,5.1,NULL,'G',0.000014,NULL,'10.73',4.7,'E;LINER;HII    Sy2','in a radial-velocity based grouping',NULL,NULL,'Flat-Spectrum Radio Source',1,188.915875,12.55633,0.141,NULL,58152475149,908632424,14197381,10.73),(97138,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97138,30.18,0.21,10.9,40734,NULL,NULL,'blue GCs, TOM(V) = -7.17 mag','MESSIER 089',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97139,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97139,30.66,0.3,13.6,40734,NULL,NULL,'R','MESSIER 089',NULL,'1994AJ....108.2087A',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97140,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97140,30.7,0.2,13.8,40734,NULL,NULL,'TOM(V) = -7.3 mag','MESSIER 089',NULL,'2009ApJ...690..512H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97141,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97141,30.84,0.09,14.7,40734,NULL,NULL,NULL,'MESSIER 089',NULL,'2001AJ....121.2950K',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97142,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97142,30.95,0.16,15.5,40734,NULL,NULL,'all GCs, TOM(V) = -7.63 mag','MESSIER 089',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97143,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97143,30.97,0.2,15.6,40734,NULL,NULL,'TOM(V) = -7.41 mag(V)','MESSIER 089',NULL,'2006MNRAS.373..588T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97144,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97144,31.06,0.09,16.3,40734,NULL,NULL,'TOM(g) = -7.2 mag','MESSIER 089',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97145,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97145,31.12,0.1,16.7,40734,NULL,NULL,'TOM(u) = -8.4 mag','MESSIER 089',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97146,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97146,31.15,0.1,17,40734,NULL,NULL,'TOM(g) = -7.2 mag','MESSIER 089',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97147,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97147,31.16,0.24,17.1,40734,NULL,NULL,'red GCs, TOM(V) = -7.55 mag','MESSIER 089',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97148,'GCLF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97148,31.17,0.09,17.1,40734,NULL,NULL,'TOM(z) = -8.53 mag','MESSIER 089',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97149,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97149,30.5,0.2,12.6,40734,NULL,NULL,'I','MESSIER 089',NULL,'1993A&A...275..433B',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97150,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97150,30.6,NULL,13.2,40734,NULL,NULL,'I','MESSIER 089',NULL,'1989ApJ...346L..57T',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97151,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97151,30.72,0.1,13.9,40734,NULL,NULL,'K','MESSIER 089',NULL,'1994ApJ...433..567P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97152,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97152,30.72,0.09,13.9,40734,NULL,NULL,'K','MESSIER 089',NULL,'1996ApJ...468..519J',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97153,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97153,30.85,0.13,14.8,40734,NULL,NULL,'HST KP Calibrated, Ks','MESSIER 089',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97154,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97154,30.87,0.06,14.9,40734,NULL,NULL,'I','MESSIER 089',NULL,'1990AJ....100.1416T',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97155,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97155,30.86,0.08,14.9,40734,NULL,NULL,'I','MESSIER 089',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97156,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97156,30.86,0.11,14.9,40734,NULL,NULL,'I','MESSIER 089',NULL,'1997AJ....114..626A',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97157,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97157,30.93,0.14,15.3,40734,NULL,NULL,'I','MESSIER 089',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97158,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97158,30.93,0.14,15.3,40734,NULL,NULL,NULL,'MESSIER 089',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97159,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97159,30.96,0.14,15.6,40734,NULL,NULL,'Malmquist cor.','MESSIER 089',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97160,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97160,30.99,0.17,15.8,40734,NULL,NULL,'HST KP Calibrated, I','MESSIER 089',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97161,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97161,31,0.06,15.8,40734,NULL,NULL,NULL,'MESSIER 089',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97162,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97162,31,0.1,15.8,40734,NULL,NULL,'I','MESSIER 089',NULL,'2000ApJ...536..255N',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97163,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97163,31,0.14,15.9,40734,74.4,NULL,NULL,'MESSIER 089',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97164,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97164,31.02,0.14,16,40734,NULL,NULL,'HST KP Calibrated, F814W','MESSIER 089',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97165,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97165,31.02,0.07,16,40734,NULL,NULL,'HST ACS VCS','MESSIER 089',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97166,'SBF','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97166,31.05,0.11,16.2,40734,NULL,NULL,'K','MESSIER 089',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97167,'GC radius','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97167,31.14,0.06,16.9,40734,NULL,NULL,NULL,'MESSIER 089',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97168,'D-Sigma','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97168,31.13,0.4,16.8,40734,75,NULL,'Edat, raw','MESSIER 089',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97169,'D-Sigma','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97169,31.15,0.4,17,40734,75,NULL,'Edat, cor','MESSIER 089',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97170,'Faber-Jackson','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97170,30.73,0.35,14,40734,95,NULL,'de Vaucouleurs','MESSIER 089',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97171,'Faber-Jackson','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97171,30.87,0.25,14.9,40734,95,NULL,'Weighted Mean','MESSIER 089',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97172,'Faber-Jackson','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97172,31.11,0.63,16.7,40734,95,NULL,'Michard 1979b, c','MESSIER 089',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97173,'Faber-Jackson','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97173,31.18,0.46,17.2,40734,95,NULL,'Michard 1979a','MESSIER 089',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97174,'Faber-Jackson','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97174,31.29,NULL,18.1,40734,NULL,NULL,'LEDA [April 2006]','MESSIER 089',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97175,'Faber-Jackson','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97175,32.5,0.81,31.6,40734,55,NULL,'Visvanathan & Sandage 1979','MESSIER 089',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97176,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97176,31.09,NULL,16.5,40734,NULL,NULL,NULL,'MESSIER 089',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97177,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97177,31.16,0.41,17.1,40734,NULL,NULL,NULL,'MESSIER 089',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97178,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97178,31.34,0.41,18.5,40734,NULL,NULL,'Malmquist cor.','MESSIER 089',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97179,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97179,31.46,NULL,19.6,40734,NULL,NULL,NULL,'MESSIER 089',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97180,'Tertiary','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97180,30.49,0.25,12.5,40734,95,NULL,NULL,'MESSIER 089',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97181,'Tully est','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97181,31.13,0.8,16.8,40734,75,NULL,'B','MESSIER 089',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97182,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97182,35.96,0.75,156,40735,70,NULL,NULL,'LCRS B123305.2-061329',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'16.69',0.16,NULL,NULL,NULL,NULL,NULL,1,188.916667,-6.5,0.033,NULL,43211228506,675175445,10549616,16.69),(97183,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97183,35.2,0.15,110,40736,70,NULL,NULL,'2MASX J12354052+2638348',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000063,NULL,'15.5g',0.48,NULL,NULL,NULL,NULL,NULL,1,188.9187917,26.64294,0.021,NULL,58609717140,915776830,14309012,15.5),(97184,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN HST04Haw',NULL,97184,41.31,0.26,1220,40737,74.2,NULL,'SALT 2','GOODS J123540.97+621136.5',0.49673,'2010ApJ...716..712A',2010,1,0.035,NULL,'G',0.00033,NULL,'22.3R',0.027,NULL,NULL,NULL,NULL,NULL,1,188.920833,62.19336,0,NULL,57375434621,896491165,14007674,22.3),(97185,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN HST04Haw',NULL,97185,42.36,0.3,1980,40737,65,NULL,'MLCS2k2','GOODS J123540.97+621136.5',0.49673,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97186,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN HST04Haw',NULL,97186,42.49,0.26,2100,40737,65,NULL,'MLCS17','GOODS J123540.97+621136.5',0.49673,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97187,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN HST04Haw',NULL,97187,42.54,0.24,2160,40737,65,NULL,NULL,'GOODS J123540.97+621136.5',0.49673,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97188,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN HST04Haw',NULL,97188,42.88,0.36,2510,40737,65,NULL,'SALT2','GOODS J123540.97+621136.5',0.49673,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97189,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97189,35.2,0.15,110,40738,70,NULL,NULL,'NGC 4555',NULL,'2015arXiv151105856S',2015,1,1.55,NULL,'G',0.00008,NULL,'13.1g',1.06,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,188.921583,26.52311,0.021,NULL,58609746440,915777288,14309020,13.1),(97190,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97190,37.88,0.15,377,40739,70,NULL,NULL,'SDSS J123541.18+061923.3',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,188.921625,6.32317,0,NULL,58240904424,910014131,14218970,17),(97191,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97191,35.2,0.15,110,40740,70,NULL,NULL,'2MASX J12354133+2628567',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000171,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,188.92225,26.48244,0.021,NULL,58609747471,915777304,14309020,16.4),(97192,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97192,34.42,0.49,76.5,40741,75,NULL,'IR','NGC 4565C',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.00003,NULL,'16.2g',0.18,'Sd',NULL,NULL,NULL,NULL,1,188.922583333,26.28583,0.031,NULL,58617973688,915905838,14311028,16.2),(97193,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97193,34.67,NULL,85.9,40741,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 4565C',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97194,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97194,34.68,NULL,86.4,40741,NULL,NULL,'Dipole + Quadrupole','NGC 4565C',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97195,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97195,34.7,NULL,87.2,40741,NULL,NULL,'Dipole','NGC 4565C',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97196,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97196,34.74,NULL,88.5,40741,NULL,NULL,NULL,'NGC 4565C',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97197,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97197,37.61,0.46,333,40742,70,NULL,NULL,'2MASX J12354145-0133076',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000076,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,188.922625,-1.55222,0.017,NULL,42986043763,671656933,10494639,17.9),(97198,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97198,37.11,0.46,264,40743,70,NULL,NULL,'2MASX J12354190+4728211',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,188.924417,47.47256,0,NULL,59064821723,922887839,14420122,17),(97199,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97199,38.16,0.33,428,40744,70,NULL,NULL,'SDSS J123542.30+075621.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,188.92625,7.93925,0,NULL,58239056008,909985250,14218519,17.9),(97200,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97200,37.88,0.15,377,40745,70,NULL,NULL,'2MASX J12354331+0619330',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,188.930333,6.32583,0,NULL,58240902629,910014103,14218970,17.4),(97201,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97201,38.22,0.46,441,40746,70,NULL,NULL,'2MASX J12354351+3414555',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,188.931333333,34.24892,0.007,NULL,58742070124,917844845,14341325,17.4),(97202,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97202,30.69,0.43,13.7,40747,75,NULL,'3.6 micron, color + selection bias corrected','VCC 1636',NULL,'2014MNRAS.444..527S',2014,1,0.87,NULL,'G',0.00001,NULL,'15.5g',0.37,'Sb(r)II','Group member',NULL,NULL,NULL,1,188.932541667,14.41197,0.065,NULL,58884894330,920076473,14376194,15.5),(97203,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97203,33.26,0.43,44.8,40747,75,NULL,'3.6 micron, color corrected','VCC 1636',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97204,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97204,35.73,0.2,140,40747,74.4,NULL,NULL,'VCC 1636',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97205,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97205,37.94,0.46,387,40748,70,NULL,NULL,'2MASX J12354433+6149109',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000143,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,188.934833,61.81975,0,NULL,57364158099,896314970,14004921,18.4),(97206,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97206,36.37,0.46,188,40749,70,NULL,NULL,'2MASX J12354471+4155461',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000169,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,188.936083,41.92967,0,NULL,59115240529,923675633,14432431,16.6),(97207,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97207,38.16,0.33,428,40750,70,NULL,NULL,'2MASX J12354530+0756430',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00019,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,188.938583,7.94533,0,NULL,58239042774,909985043,14218516,16.6),(97208,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97208,37.62,0.46,334,40751,70,NULL,NULL,'2MASX J12354538+0436470',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,188.93925,4.61303,0.013,NULL,58230342327,909849098,14216392,17.3),(97209,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97209,37.56,0.46,325,40752,70,NULL,NULL,'2MASX J12354560+1635074',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00033,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,188.939916667,16.58539,0.023,NULL,58882383903,920037248,14375582,17.2),(97210,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97210,35.2,0.15,110,40753,70,NULL,NULL,'NGC 4556',NULL,'2015arXiv151105856S',2015,1,1.35,NULL,'G',0.000093,NULL,'13.8g',0.93,'E+:','in a radial-velocity based grouping',NULL,NULL,NULL,1,188.941083,26.90889,0.018,NULL,58610114398,915783037,14309109,13.8),(97211,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97211,35.05,0.45,102,40753,NULL,NULL,'K','NGC 4556',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97212,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97212,35.28,0.4,114,40753,NULL,NULL,'mean','NGC 4556',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97213,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN HST05Dic',NULL,97213,42.69,0.13,2110,40754,70,NULL,'SALT','SN HST05Dic',0.638,'2008ApJ...686..749K',2008,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia?',NULL,NULL,NULL,NULL,1,188.9567083,62.17,0,NULL,57375218961,896487796,14007621,NULL),(97214,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN HST05Dic',NULL,97214,42.89,0.18,2310,40754,65,NULL,NULL,'SN HST05Dic',0.638,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97215,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97215,37.59,0.46,330,40755,70,NULL,NULL,'VPC 1018',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,188.957083,10.97161,0,NULL,58198317871,909348716,14208573,17.2),(97216,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97216,38.04,0.46,405,40756,70,NULL,NULL,'2MASX J12355235+3820488',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000167,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,188.96825,38.34692,0,NULL,58559964803,914999450,14296866,16.7),(97217,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97217,35.2,0.15,110,40757,70,NULL,NULL,'NGC 4558',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000073,NULL,'14.7g',0.72,'E','Group member',NULL,NULL,NULL,1,188.969375,26.99214,0.036,NULL,58610108765,915782949,14309108,14.7),(97218,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97218,37.94,0.46,386,40758,70,NULL,NULL,'2MASX J12355267+2739360',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000173,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,188.9695,27.66003,0.065,NULL,58730436705,917663073,14338485,17.1),(97219,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97219,37.88,0.15,377,40759,70,NULL,NULL,'2MASX J12355277+0622460',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,188.969833,6.3795,0,NULL,58241027636,910016056,14219000,17.3),(97220,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97220,36.84,0.46,234,40760,70,NULL,NULL,'2MASX J12355297+6319020',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000168,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,188.9705,63.31728,0,NULL,57374572095,896477688,14007463,16.7),(97221,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97221,37.42,0.33,305,40761,70,NULL,NULL,'2MASX J12355339+0946110',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000144,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,188.9724583,9.76967,0,NULL,58196531276,909320801,14208137,17.3),(97222,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97222,36.23,0.33,176,40762,70,NULL,NULL,'VCC 1643',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.0001,NULL,'15.4g',0.54,'dE4,N or S0','Group member',NULL,NULL,NULL,1,188.974167,5.76106,0,NULL,58240109152,910001705,14218776,15.4),(97223,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97223,37.22,0.19,278,40763,70,NULL,NULL,'2MASX J12355430+1639393',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000354,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,188.9762083,16.66089,0.023,NULL,58882599530,920040617,14375634,17.2),(97224,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97224,37.91,0.46,382,40764,70,NULL,NULL,'2MASX J12355448+1755482',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,188.977083,17.93028,0.033,NULL,58918694984,920604609,14384447,17.3),(97225,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97225,34.87,0.46,94.4,40765,70,NULL,NULL,'CGCG 014-076',NULL,'2015arXiv151105856S',2015,1,0.85,'RC3 gives v = 3000 km/sec.','G',0.000093,NULL,'14.9g',0.35,'SA0^0^',NULL,NULL,NULL,NULL,1,188.978625,-2.38586,0.037,NULL,43168983180,674515362,10539302,14.9),(97226,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97226,36.8,0.46,229,40766,70,NULL,NULL,'2MASX J12355491+2233072',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.63',0.21,NULL,NULL,NULL,NULL,NULL,1,188.978833333,22.552,0.044,NULL,58895459060,920241547,14378774,17.63),(97227,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97227,36.34,0.27,185,40767,70,NULL,NULL,'VPC 1024',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000165,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,188.97975,12.37011,0.188,NULL,58152686570,908635727,14197433,16.5),(97228,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97228,38.52,0.21,505,40768,70,NULL,NULL,'2MASX J12355534+5556431',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000204,NULL,'16.3g',0.38,'BrClG',NULL,NULL,NULL,NULL,1,188.980667,55.94533,0,NULL,57403194713,896924917,14014451,16.3),(97229,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97229,37.77,0.46,359,40769,70,NULL,NULL,'VPC 1025',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000164,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,188.9832083,11.32311,0.011,NULL,58184493727,909132714,14205198,16.7),(97230,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97230,37.42,0.33,305,40770,70,NULL,NULL,'2MASX J12355616+0946590',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000158,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,188.984083,9.78308,0,NULL,58199402386,909365662,14208838,17.1),(97231,'IRAS','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97231,30.97,0.8,15.6,40771,75,NULL,'A82, H','NGC 4559',NULL,'1997ApJS..109..333W',1997,1,10.7,NULL,'G',0.000003,NULL,'10.46',4.4,'SAB(rs)cd      HII','Possible field galaxy',NULL,NULL,NULL,1,188.9902083,27.96,0.071,NULL,58732519631,917695619,14338994,10.46),(97232,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97232,28.82,0.4,5.8,40771,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 4559',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97233,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97233,29.19,0.47,6.89,40771,75,NULL,'A82, H, inv','NGC 4559',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97234,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97234,29.22,0.47,6.97,40771,75,NULL,'A82, H, raw','NGC 4559',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97235,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97235,29.22,0.35,6.98,40771,NULL,NULL,NULL,'NGC 4559',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97236,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97236,29.32,0.43,7.3,40771,75,NULL,'3.6 micron, color corrected','NGC 4559',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97237,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97237,29.32,0.43,7.3,40771,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4559',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97238,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97238,29.32,0.2,7.31,40771,74.4,NULL,NULL,'NGC 4559',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97239,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97239,29.48,0.53,7.87,40771,NULL,NULL,NULL,'NGC 4559',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97240,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97240,29.54,NULL,8.09,40771,NULL,NULL,NULL,'NGC 4559',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97241,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97241,29.54,0.39,8.1,40771,73,NULL,'opt','NGC 4559',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97242,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97242,29.63,0.5,8.41,40771,NULL,NULL,'Malmquist cor.','NGC 4559',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97243,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97243,29.64,0.47,8.45,40771,75,NULL,'A82, H, cor','NGC 4559',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97244,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97244,29.93,0.4,9.7,40771,75,NULL,'B','NGC 4559',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97245,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97245,29.96,0.46,9.8,40771,NULL,NULL,'J','NGC 4559',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97246,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97246,30.06,0.47,10.3,40771,NULL,NULL,'H','NGC 4559',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97247,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97247,30.12,0.45,10.6,40771,NULL,NULL,'K','NGC 4559',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97248,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97248,30.64,0.4,13.4,40771,NULL,NULL,'mean','NGC 4559',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97249,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97249,38.52,0.21,505,40772,70,NULL,NULL,'2MASX J12355975+5556010',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000168,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,188.999,55.93375,0,NULL,57403192301,896924879,14014451,18.4),(97250,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97250,37.9,0.19,380,40773,70,NULL,NULL,'VPC 1030',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000146,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,189.0035417,12.93608,0.078,NULL,58151200519,908612508,14197070,16.9),(97251,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97251,37.1,0.46,263,40774,70,NULL,NULL,'2MASX J12360129+0917370',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,189.00525,9.29356,0,NULL,58196854640,909325853,14208216,17),(97252,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97252,37.25,0.46,282,40775,70,NULL,NULL,'VPC 1031',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00019,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,189.010417,11.55908,0.113,NULL,58151951037,908624234,14197253,16.9),(97253,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97253,38.06,0.46,409,40776,70,NULL,NULL,'2MASX J12360280+3655338',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,189.0115,36.92589,0,NULL,58565509031,915086078,14298219,17.4),(97254,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97254,38.41,0.46,480,40777,70,NULL,NULL,'2MASX J12360320+2101183',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,189.013375,21.02178,0.152,NULL,58911200201,920487503,14382617,18),(97255,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97255,38.16,0.46,428,40778,70,NULL,NULL,'SDSS J123603.61+550211.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,189.0150417,55.03647,0.005,NULL,57399689535,896870148,14013596,18.6),(97256,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97256,37.22,0.19,278,40779,70,NULL,NULL,'SDSS J123603.69+164458.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000267,NULL,'18.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,189.015417,16.74972,0.023,NULL,58881879777,920029371,14375458,18.1),(97257,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97257,35.2,0.15,110,40780,70,NULL,NULL,'2MASX J12360465+2635451',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000083,NULL,'16.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,189.0194583,26.59583,0.021,NULL,58609998228,915781222,14309081,16.3),(97258,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97258,35.2,0.15,110,40781,70,NULL,NULL,'IC 3561',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.00009,NULL,'15.3g',0.3,'S0','Group member',NULL,NULL,NULL,1,189.0199583,26.89961,0.018,NULL,58610117581,915783087,14309110,15.3),(97259,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97259,37.5,0.46,316,40782,70,NULL,NULL,'2MASX J12360484+5903070',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,189.020167,59.052,0,NULL,57407146654,896986666,14015416,17.3),(97260,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97260,37.46,0.13,310,40783,70,NULL,NULL,'2MASX J12360514+1632191',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000223,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,189.021417,16.53864,0.015,NULL,58882332572,920036446,14375569,17.5),(97261,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97261,38.44,0.27,487,40784,70,NULL,NULL,'2MASX J12360532+2730441',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,189.022125,27.51222,0.062,NULL,58730457955,917663405,14338490,18.1),(97262,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97262,37.88,0.15,377,40785,70,NULL,NULL,'2MASX J12360537+0619100',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,189.022417,6.31939,0,NULL,58241039512,910016242,14219003,17.6),(97263,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97263,36.48,0.46,198,40786,70,NULL,NULL,'2MASX J12360586+3312486',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00012,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,189.0242917,33.21336,0.026,NULL,58774042461,918344413,14349131,16.1),(97264,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97264,32.85,0.49,37.2,40787,70,NULL,NULL,'NGC 4553',NULL,'2014MNRAS.445.2677S',2014,1,2.1,NULL,'G',0.00006,NULL,'13.19',1,'(RL)SA(r)0^+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,189.031667,-39.43867,0.329,NULL,43243714496,675683039,10557547,13.19),(97265,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97265,36.81,0.46,230,40788,70,NULL,NULL,'2MASX J12360771+2640411',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000176,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,189.03225,26.67808,0.018,NULL,58610001194,915781268,14309082,16.5),(97266,'Tully est','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97266,30.46,0.8,12.3,40789,75,NULL,'B','NGC 4561',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.000003,NULL,'12.9',1.3,'SB(rs)dm','Pair member (points to parent)',NULL,NULL,NULL,1,189.034166667,19.32292,NULL,NULL,58920223680,920628495,14384820,12.9),(97267,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97267,38.38,0.46,475,40790,70,NULL,NULL,'2MASX J12360856+3301395',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,189.035458333,33.02769,0.026,NULL,58774155540,918346180,14349159,17.9),(97268,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97268,37.63,0.46,336,40791,70,NULL,NULL,'SDSS J123609.05+054129.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,189.03775,5.69156,0,NULL,58222343388,909724115,14214439,18.2),(97269,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97269,37.41,0.27,304,40792,70,NULL,NULL,'2MASX J12360940+1944583',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'16.9',0.2,NULL,'Group member',NULL,NULL,NULL,1,189.03925,19.74944,NULL,NULL,58920505102,920632892,14384888,16.9),(97270,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97270,38.34,0.46,466,40793,70,NULL,NULL,'2MASX J12360964+1355241',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000145,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,189.040083333,13.92347,0.096,NULL,58151117226,908611206,14197050,18.5),(97271,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97271,31.38,0.2,18.9,40794,74.4,NULL,NULL,'IC 3562',NULL,'2013AJ....146...86T',2013,1,0.86,NULL,'G',0.000007,NULL,'16.0g',0.32,'ImIII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,189.044,9.92261,0,NULL,58199419922,909365936,14208842,16),(97272,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97272,35.19,0.49,109,40795,75,NULL,'IR','FGC 1469',NULL,'2011yCatp016004901K',2011,1,0.87,NULL,'G',NULL,NULL,'15.85',0.1,'Scd',NULL,NULL,NULL,NULL,1,189.0455,48.82189,0,NULL,59064247290,922878863,14419982,15.85),(97273,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97273,35.52,NULL,127,40795,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1469',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97274,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97274,35.54,NULL,128,40795,NULL,NULL,'Dipole + Quadrupole','FGC 1469',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97275,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97275,35.56,NULL,130,40795,NULL,NULL,'Dipole','FGC 1469',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97276,'Tully-Fisher','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97276,35.57,NULL,130,40795,NULL,NULL,NULL,'FGC 1469',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97277,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97277,38.46,0.46,491,40796,70,NULL,NULL,'SDSS J123611.76+483242.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,189.049041667,48.545,0,NULL,59064409357,922881396,14420021,18.3),(97278,'SGRB','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,NULL,97278,38.73,NULL,557,40797,71,NULL,NULL,'2MASX J12361286+2858580',NULL,'2010ApJ...709..664R',2010,1,0.17,NULL,'G',0.000167,NULL,'18.6g',0.15,'Elliptical',NULL,NULL,NULL,NULL,1,189.053666667,28.98303,0.063,NULL,58731025769,917672277,14338629,18.6),(97279,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97279,37.07,0.46,260,40798,70,NULL,NULL,'2MASX J12361289+2438381',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,189.053833,24.64394,0.046,NULL,58617171149,915893299,14310832,16.7),(97280,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN HST05Gab','R',97280,43.32,NULL,2180,40799,65,NULL,'SALT','[RSC2007] J123613.83+621207.56',1.12,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,189.057625,62.20211,0,NULL,57375224373,896487880,14007623,NULL),(97281,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN HST05Gab',NULL,97281,43.71,0.21,2600,40799,74.2,NULL,'SALT 2','[RSC2007] J123613.83+621207.56',1.12,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97282,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN HST05Gab',NULL,97282,44.15,0.07,3190,40799,70,NULL,'SALT','[RSC2007] J123613.83+621207.56',1.12,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97283,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN HST05Gab',NULL,97283,44.25,0.24,3340,40799,70,NULL,'SALT','[RSC2007] J123613.83+621207.56',1.12,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97284,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN HST05Gab',NULL,97284,44.41,0.21,3590,40799,65,NULL,'SALT','[RSC2007] J123613.83+621207.56',1.12,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97285,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN HST05Gab',NULL,97285,44.44,0.15,3640,40799,65,NULL,'SALT2','[RSC2007] J123613.83+621207.56',1.12,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97286,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN HST05Gab',NULL,97286,44.51,0.2,3760,40799,65,NULL,'SALT2','[RSC2007] J123613.83+621207.56',1.12,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97287,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN HST05Gab',NULL,97287,44.57,0.19,3870,40799,65,NULL,'MLCS17','[RSC2007] J123613.83+621207.56',1.12,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97288,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN HST05Gab',NULL,97288,44.6,0.2,3920,40799,65,NULL,'MLCS2k2','[RSC2007] J123613.83+621207.56',1.12,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97289,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN HST05Gab',NULL,97289,44.64,0.19,3990,40799,65,NULL,'MLCS31','[RSC2007] J123613.83+621207.56',1.12,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97290,'SNIa','2016-12-15 15:15:02','2016-12-16 11:20:13','1','SN HST05Gab',NULL,97290,44.67,0.18,4050,40799,65,NULL,NULL,'[RSC2007] J123613.83+621207.56',1.12,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97291,'FP','2016-12-15 15:15:02','2016-12-16 11:20:13','1',NULL,'R',97291,38.52,0.21,505,40800,70,NULL,NULL,'2MASX J12361391+5600018',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,189.0579583,56.00044,0,NULL,57403188235,896924816,14014450,18.3),(97292,'FP','2016-12-15 15:15:03','2016-12-16 11:20:13','1',NULL,'R',97292,37.07,0.46,260,40801,70,NULL,NULL,'SDSS J123617.16+161421.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,189.0715417,16.23925,0.006,NULL,58882491309,920038926,14375608,17.5),(97293,'FP','2016-12-15 15:15:03','2016-12-16 11:20:13','1',NULL,'R',97293,37.46,0.46,311,40802,70,NULL,NULL,'2MASX J12361768+5442308',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00016,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,189.0737083,54.70856,0,NULL,57219618812,894056543,13969633,16.9),(97294,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97294,37.46,0.13,310,40803,70,NULL,NULL,'2MASX J12361773+1624271',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000167,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,189.073833333,16.40747,0.015,NULL,58882367013,920036984,14375577,16.5),(97295,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97295,37.84,0.33,370,40804,70,NULL,NULL,'2MASX J12361780+5654308',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00018,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,189.0742917,56.90858,0,NULL,57408197452,897003085,14015673,16.2),(97296,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97296,38.58,0.33,521,40805,70,NULL,NULL,'2MASX J12361819+0524315',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000183,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,189.0757917,5.40869,0,NULL,58222436344,909725567,14214461,17.2),(97297,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97297,38.18,0.14,433,40806,70,NULL,NULL,'2MASX J12361962+6435332',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000131,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,189.0822083,64.59247,0.017,NULL,57367143556,896361618,14005650,18.1),(97298,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Str','R',97298,43.43,NULL,2400,40807,65,NULL,'MLCS17','GOODS J123620.63+621050.9',1.02733,'2010arXiv1006.2112L',2010,1,0.023,NULL,'G',0.00033,NULL,'24.3R',0.017,NULL,NULL,NULL,NULL,NULL,1,189.085917,62.18069,0,NULL,57375217502,896487773,14007621,24.3),(97299,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Str',NULL,97299,43.68,0.09,2690,40807,70,NULL,'MLCS17','GOODS J123620.63+621050.9',1.02733,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97300,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Str',NULL,97300,44.11,0.32,3270,40807,74.2,NULL,'SALT 2','GOODS J123620.63+621050.9',1.02733,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97301,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Str',NULL,97301,44.45,0.2,3830,40807,70,NULL,'SALT','GOODS J123620.63+621050.9',1.02733,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97302,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Str',NULL,97302,44.5,0.22,3920,40807,65,NULL,'MLCS17','GOODS J123620.63+621050.9',1.02733,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97303,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Str',NULL,97303,44.52,0.19,3960,40807,65,NULL,'MLCS2k2','GOODS J123620.63+621050.9',1.02733,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97304,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Str',NULL,97304,44.6,0.22,4100,40807,65,NULL,'MLCS31','GOODS J123620.63+621050.9',1.02733,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97305,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Str',NULL,97305,44.62,0.18,4140,40807,65,NULL,'SALT','GOODS J123620.63+621050.9',1.02733,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97306,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Str',NULL,97306,44.77,0.19,4480,40807,65,NULL,NULL,'GOODS J123620.63+621050.9',1.02733,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97307,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Str',NULL,97307,44.8,0.32,4490,40807,65,NULL,'SALT2','GOODS J123620.63+621050.9',1.02733,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97308,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Str',NULL,97308,44.8,0.33,4510,40807,65,NULL,'SALT2','GOODS J123620.63+621050.9',1.02733,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97309,'GCLF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97309,30,0.3,10,40808,NULL,NULL,NULL,'NGC 4565',NULL,'1995AJ....109.1044F',1995,1,15.9,'HOLM 426D is a star.','G',0.000017,NULL,'10.42',1.85,'SA(s)b? sp Sy3 Sy1.9','in a radial-velocity based grouping',NULL,NULL,'unobscured Seyfert 2',1,189.086583333,25.98767,0.031,NULL,58617844076,915903813,14310997,10.42),(97310,'GCLF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97310,30.18,0.32,10.9,40808,NULL,NULL,'HST KP Calibrated, V','NGC 4565',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97311,'GCLF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97311,30.23,0.2,11.1,40808,NULL,NULL,NULL,'NGC 4565',NULL,'2000ApJS..128..431F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97312,'GCLF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97312,30.4,NULL,12,40808,NULL,NULL,'Photographic, vs. Local Group galaxies','NGC 4565',NULL,'1982AJ.....87..494V',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97313,'GCLF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97313,30.9,NULL,15.1,40808,NULL,NULL,'Photographic, vs. Virgo elliptical galaxies','NGC 4565',NULL,'1982AJ.....87..494V',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97314,'PNLF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97314,30.08,0.15,10.4,40808,NULL,NULL,NULL,'NGC 4565',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97315,'PNLF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97315,30.12,0.13,10.5,40808,NULL,NULL,'17','NGC 4565',NULL,'1996ApJ...462....1J',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97316,'PNLF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97316,30.2,0.16,11,40808,NULL,NULL,'HST KP Calibrated','NGC 4565',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97317,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97317,30.08,0.07,10.4,40808,NULL,NULL,'V','NGC 4565',NULL,'1994AJ....107..503S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97318,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97318,30.65,0.08,13.5,40808,74.4,NULL,NULL,'NGC 4565',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97319,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97319,31.05,0.17,16.2,40808,NULL,NULL,'I','NGC 4565',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97320,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97320,31.21,0.17,17.5,40808,NULL,NULL,'I','NGC 4565',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97321,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97321,31.26,0.19,17.9,40808,NULL,NULL,'HST KP Calibrated, I','NGC 4565',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97322,'TRGB','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97322,30.38,0.05,11.9,40808,NULL,NULL,'I','NGC 4565',NULL,'2011ApJS..195...18R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97323,'TRGB','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97323,30.65,0.08,13.5,40808,74.4,NULL,NULL,'NGC 4565',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97324,'Grav. Stability Gas. Disk','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97324,29.8,NULL,9.1,40808,NULL,NULL,NULL,'NGC 4565',NULL,'1996AstL...22...71Z',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97325,'IRAS','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97325,31.71,0.8,22,40808,75,NULL,'A82, H','NGC 4565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97326,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97326,23.89,NULL,0.6,40808,NULL,NULL,'Dipole + Quadrupole','NGC 4565',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97327,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97327,24.59,NULL,0.829,40808,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 4565',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97328,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97328,29.93,0.4,9.7,40808,75,NULL,'B','NGC 4565',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97329,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97329,30.04,NULL,10.2,40808,75,NULL,'HI','NGC 4565',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97330,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97330,30.3,NULL,11.5,40808,75,NULL,'CO','NGC 4565',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97331,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97331,30.34,0.47,11.7,40808,75,NULL,'A82, H, raw','NGC 4565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97332,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97332,30.4,0.4,12,40808,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 4565',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97333,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97333,30.41,0.35,12.1,40808,NULL,NULL,NULL,'NGC 4565',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97334,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97334,30.54,0.43,12.8,40808,75,NULL,'3.6 micron, color corrected','NGC 4565',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97335,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97335,30.57,0.47,13,40808,75,NULL,'A82, H, inv','NGC 4565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97336,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97336,30.58,NULL,13.1,40808,NULL,NULL,'Dipole','NGC 4565',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97337,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97337,30.65,0.08,13.5,40808,74.4,NULL,NULL,'NGC 4565',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97338,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97338,30.68,0.43,13.7,40808,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4565',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97339,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97339,30.7,0.47,13.8,40808,75,NULL,'A82, H, cor','NGC 4565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97340,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97340,30.96,0.3,15.5,40808,55,NULL,'B','NGC 4565',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97341,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97341,31.2,NULL,17.4,40808,NULL,NULL,'LEDA [April 2006]','NGC 4565',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97342,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97342,37.9,0.19,380,40809,70,NULL,NULL,'VPC 1045',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,189.091791667,12.91211,0.078,NULL,58151171843,908612060,14197063,17.8),(97343,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97343,38.42,0.46,483,40810,70,NULL,NULL,'SDSS J123622.19+005000.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000081,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,189.0925,0.83342,0.011,NULL,58002062683,906282229,14160659,18),(97344,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97344,37.46,0.13,310,40811,70,NULL,NULL,'2MASX J12362239+1629481',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000213,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,189.0934583,16.49661,0.015,NULL,58882337944,920036530,14375570,17.4),(97345,'IRAS','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97345,30.16,0.8,10.8,40812,75,NULL,'A82, H','UGC 07774',NULL,'1997ApJS..109..333W',1997,1,2.83,NULL,'G',0.000033,NULL,'14.5g',0.43,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,189.094666667,40.00519,0,NULL,59081940811,923155325,14424301,14.5),(97346,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97346,29.17,0.4,6.8,40812,75,NULL,'B','UGC 07774',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97347,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97347,30.09,0.11,10.4,40812,NULL,NULL,NULL,'UGC 07774',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97348,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97348,31.52,NULL,20.1,40812,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07774',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97349,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97349,31.53,NULL,20.2,40812,NULL,NULL,'Dipole + Quadrupole','UGC 07774',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97350,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97350,31.53,NULL,20.2,40812,NULL,NULL,'Dipole','UGC 07774',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97351,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97351,31.54,0.4,20.3,40812,NULL,NULL,'Virgo cluster at 15.6 Mpc','UGC 07774',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97352,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97352,31.68,NULL,21.6,40812,NULL,NULL,NULL,'UGC 07774',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97353,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97353,31.77,NULL,22.6,40812,NULL,NULL,NULL,'UGC 07774',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97354,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97354,31.89,0.47,23.9,40812,75,NULL,'A82, H, inv','UGC 07774',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97355,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97355,31.97,0.38,24.8,40812,NULL,NULL,NULL,'UGC 07774',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97356,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97356,32.03,0.47,25.5,40812,75,NULL,'A82, H, raw','UGC 07774',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97357,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97357,32.17,0.47,27.1,40812,75,NULL,'A82, H, cor','UGC 07774',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97358,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97358,32.18,0.2,27.3,40812,74.4,NULL,NULL,'UGC 07774',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97359,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97359,32.22,0.43,27.8,40812,75,NULL,'3.6 micron, color + selection bias corrected','UGC 07774',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97360,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97360,32.23,0.43,27.9,40812,75,NULL,'3.6 micron, color corrected','UGC 07774',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97361,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Koe',NULL,97361,43.99,0.26,2820,40813,74.2,NULL,'SALT 2','[RSC2007] J123622.92+621823.20',1.23,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,'25.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,189.095625,62.30636,0,NULL,57377066658,896516666,14008072,25.6),(97362,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Koe',NULL,97362,44.58,0.21,3700,40813,70,NULL,'SALT','[RSC2007] J123622.92+621823.20',1.23,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97363,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Koe',NULL,97363,44.81,0.27,4110,40813,65,NULL,'SALT2','[RSC2007] J123622.92+621823.20',1.23,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97364,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Koe',NULL,97364,44.82,0.25,4140,40813,65,NULL,'SALT2','[RSC2007] J123622.92+621823.20',1.23,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97365,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Koe',NULL,97365,44.99,0.24,4460,40813,65,NULL,'MLCS17','[RSC2007] J123622.92+621823.20',1.23,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97366,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Koe',NULL,97366,45.03,0.27,4540,40813,65,NULL,'MLCS31','[RSC2007] J123622.92+621823.20',1.23,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97367,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Koe',NULL,97367,45.07,0.21,4630,40813,65,NULL,'MLCS2k2','[RSC2007] J123622.92+621823.20',1.23,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97368,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Koe',NULL,97368,45.17,0.23,4850,40813,65,NULL,NULL,'[RSC2007] J123622.92+621823.20',1.23,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97369,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97369,36.89,0.46,239,40814,70,NULL,NULL,'SDSS J123623.54+114433.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,189.098125,11.74258,0.113,NULL,58152140371,908627193,14197299,17.8),(97370,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97370,37.9,0.19,380,40815,70,NULL,NULL,'SDSS J123623.85+125530.3',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,'PHOT','16.6g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,189.099417,12.92508,0.078,NULL,58151173350,908612083,14197063,16.6),(97371,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97371,37.22,0.19,278,40816,70,NULL,NULL,'2MASXi J1236243+162320',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,189.101333,16.38908,0.015,NULL,58882364080,920036938,14375577,17.8),(97372,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97372,34.97,0.4,98.8,40817,NULL,NULL,'mean','ESO 574- G 012',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000067,NULL,'14.30',0.8,'E',NULL,NULL,NULL,NULL,1,189.101625,-19.39514,0.085,NULL,43953664693,686776010,10730875,14.3),(97373,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97373,35.09,0.45,104,40817,NULL,NULL,'K','ESO 574- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97374,'GCLF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97374,31.24,0.28,17.7,40818,NULL,NULL,'TOM(g) = -7.2 mag','VCC 1661',NULL,'2010ApJ...717..603V',2010,1,0.61,NULL,'G',0.000112,NULL,'16.3g',0.58,'dE0,N','Group member',NULL,NULL,NULL,1,189.10325,10.38467,0,NULL,58198999054,909359360,14208740,16.3),(97375,'GCLF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97375,31.38,0.15,18.9,40818,NULL,NULL,'TOM(g) = -7.2 mag','VCC 1661',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97376,'GCLF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97376,31.46,0.42,19.6,40818,NULL,NULL,'TOM(u) = -8.4 mag','VCC 1661',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97377,'GCLF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97377,31.59,0.29,20.8,40818,NULL,NULL,'TOM(z) = -8.53 mag','VCC 1661',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97378,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97378,30.98,0.14,15.7,40818,74.4,NULL,NULL,'VCC 1661',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97379,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97379,31,0.17,15.8,40818,NULL,NULL,'HST ACS VCS','VCC 1661',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97380,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97380,31,0.16,15.8,40818,NULL,NULL,NULL,'VCC 1661',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97381,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97381,37.22,0.19,278,40819,70,NULL,NULL,'2MASX J12362484+1649001',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.72',0.11,NULL,NULL,NULL,NULL,NULL,1,189.103375,16.81681,0.026,NULL,58881928688,920030135,14375470,18.72),(97382,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Fer','R',97382,43.12,NULL,2090,40820,65,NULL,'MLCS17','[RSC2007] J123625.10+621523.84',1.02,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,189.104583,62.25661,0,NULL,57375225223,896487894,14007623,NULL),(97383,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Fer',NULL,97383,43.35,0.23,2320,40820,74.2,NULL,'SALT 2','[RSC2007] J123625.10+621523.84',1.02,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97384,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Fer',NULL,97384,43.98,0.24,3090,40820,70,NULL,'SALT','[RSC2007] J123625.10+621523.84',1.02,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97385,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Fer',NULL,97385,43.99,0.27,3110,40820,65,NULL,NULL,'[RSC2007] J123625.10+621523.84',1.02,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97386,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Fer',NULL,97386,44.03,0.26,3160,40820,65,NULL,'MLCS17','[RSC2007] J123625.10+621523.84',1.02,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97387,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Fer',NULL,97387,44.03,0.19,3170,40820,65,NULL,'SALT2','[RSC2007] J123625.10+621523.84',1.02,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97388,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Fer',NULL,97388,44.07,0.09,3220,40820,70,NULL,'MLCS17','[RSC2007] J123625.10+621523.84',1.02,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97389,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Fer',NULL,97389,44.08,0.24,3250,40820,65,NULL,'MLCS2k2','[RSC2007] J123625.10+621523.84',1.02,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97390,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Fer',NULL,97390,44.09,0.33,3260,40820,65,NULL,'MLCS31','[RSC2007] J123625.10+621523.84',1.02,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97391,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Fer',NULL,97391,44.11,0.22,3280,40820,65,NULL,'SALT','[RSC2007] J123625.10+621523.84',1.02,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97392,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Fer',NULL,97392,44.11,0.23,3290,40820,65,NULL,'SALT2','[RSC2007] J123625.10+621523.84',1.02,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97393,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97393,37.64,0.46,337,40821,70,NULL,NULL,'2MASX J12362568+5155566',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000135,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,189.107083,51.93261,0,NULL,57240820513,894387820,13974809,18.2),(97394,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003be',NULL,97394,42.18,0.19,1660,40822,74.2,NULL,'SALT 2','GOODS J123625.99+620655.5',0.64,'2010ApJ...716..712A',2010,1,0.028,NULL,'G',0.00033,NULL,'21.2R',0.028,NULL,NULL,NULL,NULL,NULL,1,189.108291667,62.11544,0,NULL,57375245402,896488209,14007628,21.2),(97395,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003be',NULL,97395,42.8,0.39,2210,40822,65,NULL,'SN Qiqirn, MLCS31','GOODS J123625.99+620655.5',0.64,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97396,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003be',NULL,97396,42.85,0.88,2260,40822,65,NULL,'SN Qiqirn, SALT2','GOODS J123625.99+620655.5',0.64,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97397,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003be',NULL,97397,42.86,0.24,2270,40822,65,NULL,'SN Qiqirn, MLCS2k2','GOODS J123625.99+620655.5',0.64,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97398,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003be',NULL,97398,42.89,0.29,2310,40822,65,NULL,'SN Qiqirn, MLCS17','GOODS J123625.99+620655.5',0.64,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97399,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003be',NULL,97399,42.97,0.13,2390,40822,70,NULL,'SALT','GOODS J123625.99+620655.5',0.64,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97400,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003be',NULL,97400,43.01,0.25,2440,40822,65,NULL,NULL,'GOODS J123625.99+620655.5',0.64,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97401,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003be',NULL,97401,43.07,0.21,2510,40822,65,NULL,NULL,'GOODS J123625.99+620655.5',0.64,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97402,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003be',NULL,97402,43.09,0.41,2520,40822,65,NULL,'SN Qiqirn, SALT2','GOODS J123625.99+620655.5',0.64,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97403,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97403,37.41,0.27,304,40823,70,NULL,NULL,'2MASX J12362603+1944432',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.04',0.16,NULL,'Group member',NULL,NULL,NULL,1,189.108583,19.74528,NULL,NULL,58920373488,920630835,14384856,18.04),(97404,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97404,36.8,0.46,229,40824,70,NULL,NULL,'2MASX J12362634+0809255',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000143,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,189.1097083,8.15719,0,NULL,58193970372,909280787,14207512,17.4),(97405,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97405,37.22,0.19,278,40825,70,NULL,NULL,'2MASX J12362636+1636581',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00025,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,189.10975,16.61611,0.015,NULL,58882589513,920040461,14375632,17),(97406,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97406,37.15,0.46,269,40826,70,NULL,NULL,'2MASX J12362661+3558549',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000152,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,189.11075,35.98194,0,NULL,58564222162,915065971,14297905,17.1),(97407,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97407,37.46,0.13,310,40827,70,NULL,NULL,'SDSS J123626.71+163112.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000223,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,189.111333333,16.52,0.015,NULL,58882340057,920036563,14375571,18.4),(97408,'GCLF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97408,30.87,0.11,14.9,40828,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4564',NULL,'2010ApJ...717..603V',2010,1,3.5,NULL,'G',0.000008,NULL,'12.05',1.5,'E6','in a radial-velocity based grouping',NULL,NULL,NULL,1,189.112417,11.43928,0.083,NULL,58184466760,909132293,14205192,12.05),(97409,'GCLF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97409,30.88,0.12,15,40828,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4564',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97410,'GCLF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97410,30.9,0.11,15.1,40828,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4564',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97411,'GCLF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97411,31,0.1,15.8,40828,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4564',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97412,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 1961H',NULL,97412,30.7,0.36,13.8,40828,NULL,NULL,NULL,'NGC 4564',NULL,'1992ApJ...390L..45P',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97413,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 1951H','R',97413,31.12,NULL,16.7,40828,NULL,NULL,'Photographic','NGC 4564',NULL,'1988SSRv...48....1R',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97414,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97414,30.88,0.17,15,40828,NULL,NULL,'I','NGC 4564',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97415,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97415,30.88,0.17,15,40828,NULL,NULL,NULL,'NGC 4564',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97416,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97416,30.93,0.17,15.3,40828,NULL,NULL,'Malmquist cor.','NGC 4564',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97417,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97417,31,0.06,15.8,40828,NULL,NULL,NULL,'NGC 4564',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97418,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97418,31.01,0.07,15.9,40828,NULL,NULL,'HST ACS VCS','NGC 4564',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97419,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97419,31.04,0.12,16.1,40828,74.4,NULL,NULL,'NGC 4564',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97420,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97420,31.8,NULL,22.9,40828,56,NULL,'M(B) = -19.8 mag, SN 1961H','NGC 4564',NULL,'1992ARA&A..30..359B',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97421,'GC radius','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97421,30.82,0.06,14.6,40828,NULL,NULL,NULL,'NGC 4564',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97422,'D-Sigma','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97422,31.13,0.4,16.8,40828,75,NULL,'Edat, raw','NGC 4564',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97423,'D-Sigma','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97423,31.15,0.4,17,40828,75,NULL,'Edat, cor','NGC 4564',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97424,'Faber-Jackson','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97424,30.76,0.54,14.2,40828,95,NULL,'de Vaucouleurs','NGC 4564',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97425,'Faber-Jackson','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97425,31.19,0.3,17.3,40828,95,NULL,'Weighted Mean','NGC 4564',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97426,'Faber-Jackson','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97426,31.56,0.63,20.5,40828,95,NULL,'Michard 1979b, c','NGC 4564',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97427,'Faber-Jackson','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97427,31.91,0.46,24.1,40828,95,NULL,'Michard 1979a','NGC 4564',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97428,'Faber-Jackson','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97428,32.37,0.81,29.8,40828,55,NULL,'Visvanathan & Sandage 1979','NGC 4564',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97429,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97429,30.72,NULL,13.9,40828,NULL,NULL,NULL,'NGC 4564',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97430,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97430,30.95,NULL,15.5,40828,NULL,NULL,NULL,'NGC 4564',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97431,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97431,31.04,0.12,16.1,40828,74.4,NULL,NULL,'NGC 4564',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97432,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97432,31.12,0.41,16.7,40828,NULL,NULL,NULL,'NGC 4564',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97433,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97433,31.31,0.41,18.2,40828,NULL,NULL,'Malmquist cor.','NGC 4564',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97434,'Tertiary','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97434,30.49,0.25,12.5,40828,95,NULL,NULL,'NGC 4564',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97435,'Tully est','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97435,31.13,0.8,16.8,40828,75,NULL,'B','NGC 4564',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97436,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97436,30.93,0.45,15.3,40828,NULL,NULL,'K','NGC 4564',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97437,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97437,31.66,0.4,21.5,40828,NULL,NULL,'mean','NGC 4564',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97438,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97438,36.91,0.46,241,40829,70,NULL,NULL,'SDSS J123627.13+472604.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000171,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,189.113083,47.43456,0,NULL,59110739343,923605302,14431332,17.6),(97439,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97439,36.34,0.27,185,40830,70,NULL,NULL,'IC 3574',NULL,'2015arXiv151105856S',2015,1,0.58,'Bingelli et al. (1993A&AS...98..275B) give z = 0.066713 +/- 0.000167.','G',0.000127,NULL,'15.3',0.36,'E4','Group member',NULL,NULL,NULL,1,189.1159583,12.40517,0.188,NULL,58152675715,908635558,14197430,15.3),(97440,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97440,36.34,0.27,185,40831,70,NULL,NULL,'VPC 1053',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00017,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,189.121125,12.60636,0.128,NULL,58153006147,908640721,14197511,16.9),(97441,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97441,36.65,0.46,214,40832,70,NULL,NULL,'2MASX J12363009+5509210',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,189.125333,55.15597,0,NULL,57399787057,896871672,14013619,17.4),(97442,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97442,35.14,0.47,107,40833,NULL,NULL,'H','UGC 07778',NULL,'2007A&A...465...71T',2007,1,0.4,'Often mistakenly called IC 3582.','G',0.00003,NULL,'15.5',0.2,'Sab?           RET','in a radial-velocity based grouping',NULL,NULL,NULL,1,189.12625,26.19944,0.031,NULL,58617939524,915905305,14311020,15.5),(97443,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97443,35.18,0.4,109,40833,NULL,NULL,'mean','UGC 07778',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97444,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97444,35.3,0.45,115,40833,NULL,NULL,'K','UGC 07778',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97445,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97445,35.31,0.46,115,40833,NULL,NULL,'J','UGC 07778',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97446,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97446,36.39,0.46,189,40834,70,NULL,NULL,'MCG +08-23-066',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.000221,NULL,'15.0g',0.6,'E0',NULL,NULL,NULL,NULL,1,189.126833,48.50264,0,NULL,59064402983,922881296,14420020,15),(97447,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97447,37.46,0.13,310,40835,70,NULL,NULL,'2MASX J12363072+1631195',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00025,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,189.1280417,16.52197,0.015,NULL,58882328583,920036384,14375568,17.5),(97448,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97448,37.9,0.19,380,40836,70,NULL,NULL,'VPC 1056',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000181,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,189.1302917,12.99536,0.078,NULL,58151386858,908615419,14197115,17.2),(97449,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97449,38.05,0.46,408,40837,70,NULL,NULL,'2MASX J12363199+0223575',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,189.1335,2.39925,0,NULL,58219132451,909673944,14213655,17.5),(97450,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97450,37.04,0.46,256,40838,70,NULL,NULL,'2MASX J12363207+0827255',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000176,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,189.133667,8.45697,0,NULL,58194093365,909282708,14207542,16.5),(97451,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97451,35.85,0.46,148,40839,70,NULL,NULL,'VCC 1671',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000077,NULL,'15.0g',0.49,'d:S0_1/2_','Group member',NULL,NULL,NULL,1,189.134375,6.16961,0,NULL,58241042659,910016291,14219004,15),(97452,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97452,36.4,0.46,191,40840,70,NULL,NULL,'2MASX J12363241+6029322',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000182,NULL,'15.8g',0.4,'E',NULL,NULL,NULL,NULL,1,189.134916667,60.49222,0,NULL,57335646727,895869480,13997960,15.8),(97453,'Tully est','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97453,31.13,0.8,16.8,40841,75,NULL,'B','NGC 4567',NULL,'1988NBGC.C....0000T',1988,1,2.92,'ALFALFA source is a blend of this and NGC 4568.','G',0.000005,NULL,'12.6g',1.39,'SA(rs)bc       HII','Pair member (points to parent)',NULL,NULL,NULL,1,189.136291667,11.258,0.011,NULL,58184671308,909135489,14205242,12.6),(97454,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97454,32.68,0.3,34.3,40841,55,NULL,'B','NGC 4567',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97455,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97455,38.58,0.33,521,40842,70,NULL,NULL,'SDSS J123633.49+053141.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,189.1395417,5.52833,0,NULL,58222363015,909724422,14214444,18.4),(97456,'Sosies','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97456,31.47,0.11,19.7,40843,NULL,NULL,NULL,'NGC 4568',NULL,'2002A&A...393...57T',2002,1,4.25,NULL,'G',0.00001,NULL,'12.5g',0.98,'SA(rs)bc       HII','Pair member (points to parent)',NULL,NULL,NULL,1,189.14275,11.23889,0.011,NULL,58184671734,909135495,14205242,12.5),(97457,'Tully est','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97457,31.13,0.8,16.8,40843,75,NULL,'B','NGC 4568',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97458,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97458,31.18,0.47,17.3,40843,NULL,NULL,'H','NGC 4568',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97459,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97459,31.19,0.45,17.3,40843,NULL,NULL,'K','NGC 4568',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97460,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97460,31.2,0.46,17.4,40843,NULL,NULL,'J','NGC 4568',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97461,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97461,31.84,NULL,23.3,40843,NULL,NULL,'LEDA [April 2006]','NGC 4568',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97462,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97462,32.1,0.3,26.3,40843,55,NULL,'B','NGC 4568',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97463,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97463,32.54,0.4,32.2,40843,NULL,NULL,'mean','NGC 4568',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97464,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97464,37.86,0.46,373,40844,70,NULL,NULL,'2MASX J12363439+4719297',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00017,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,189.1435,47.32497,0,NULL,59110805018,923606328,14431348,17.5),(97465,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Yow',NULL,97465,41.42,0.2,1320,40845,74.2,NULL,'SALT 2','GOODS J123634.47+621213.4',0.45733,'2010ApJ...716..712A',2010,1,0.043,NULL,'G',0.00033,NULL,'19.5',0.035,'Sp/mrg;HEG     Sbrst',NULL,NULL,NULL,NULL,1,189.143625,62.20361,0,NULL,57375223925,896487873,14007623,19.5),(97466,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Yow',NULL,97466,42.16,0.19,1860,40845,70,NULL,'SALT','GOODS J123634.47+621213.4',0.45733,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97467,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Yow',NULL,97467,42.23,0.25,1910,40845,65,NULL,'SALT2','GOODS J123634.47+621213.4',0.45733,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97468,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Yow',NULL,97468,42.23,0.32,1910,40845,65,NULL,NULL,'GOODS J123634.47+621213.4',0.45733,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97469,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Yow',NULL,97469,42.26,0.18,1940,40845,65,NULL,'SALT','GOODS J123634.47+621213.4',0.45733,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97470,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Yow',NULL,97470,42.29,0.35,1970,40845,65,NULL,'MLCS2k2','GOODS J123634.47+621213.4',0.45733,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97471,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Yow',NULL,97471,42.33,0.35,2000,40845,65,NULL,'MLCS17','GOODS J123634.47+621213.4',0.45733,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97472,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Yow','R',97472,42.35,NULL,2020,40845,65,NULL,'SALT','GOODS J123634.47+621213.4',0.45733,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97473,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97473,29.38,NULL,7.52,40846,NULL,NULL,NULL,'VCC 1675',NULL,'2013AJ....145..101K',2013,1,1.14,NULL,'G',0.000033,NULL,'14.8g',0.65,'S?             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,189.1457083,8.05475,0,NULL,58239117716,909986214,14218534,14.8),(97474,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Man',NULL,97474,42.89,0.21,2040,40847,74.2,NULL,'SALT 2','GOODS J123634.92+621549.1',0.85454,'2010ApJ...716..712A',2010,1,0.024,'Bauer et al. (2002AJ....123.1163B) give z = 0.337.','G',0.00033,NULL,'21.61',0.022,NULL,NULL,NULL,NULL,NULL,1,189.145333,62.26364,0,NULL,57375225068,896487891,14007623,21.61),(97475,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Man','R',97475,42.96,NULL,2100,40847,65,NULL,'MLCS17','GOODS J123634.92+621549.1',0.85454,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97476,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Man',NULL,97476,43.6,0.21,2830,40847,65,NULL,'SALT2','GOODS J123634.92+621549.1',0.85454,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97477,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Man',NULL,97477,43.61,0.25,2850,40847,65,NULL,'MLCS2k2','GOODS J123634.92+621549.1',0.85454,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97478,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Man',NULL,97478,43.76,0.25,3040,40847,65,NULL,'MLCS17','GOODS J123634.92+621549.1',0.85454,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97479,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Man',NULL,97479,43.81,0.21,3120,40847,65,NULL,'SALT2','GOODS J123634.92+621549.1',0.85454,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97480,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Man',NULL,97480,43.9,0.24,3240,40847,65,NULL,'MLCS31','GOODS J123634.92+621549.1',0.85454,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97481,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Man',NULL,97481,43.92,0.22,3280,40847,70,NULL,'SALT','GOODS J123634.92+621549.1',0.85454,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97482,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Man',NULL,97482,43.96,0.29,3340,40847,65,NULL,NULL,'GOODS J123634.92+621549.1',0.85454,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97483,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Man',NULL,97483,44.1,0.19,3570,40847,65,NULL,'SALT','GOODS J123634.92+621549.1',0.85454,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97484,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97484,37.24,0.46,281,40848,70,NULL,NULL,'SDSS J123635.91+043254.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000139,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,189.149625,4.54842,0.013,NULL,58230360232,909849378,14216396,18),(97485,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97485,37.32,0.46,291,40849,70,NULL,NULL,'2MASX J12363656+6624463',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000079,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,189.152625,66.41292,0.017,NULL,57321324430,895645694,13994463,17.5),(97486,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97486,37.39,0.46,300,40850,70,NULL,NULL,'2MASX J12363707+6304162',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000138,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,189.154667,63.07103,0,NULL,57377376155,896521502,14008148,17.5),(97487,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN GND12Col',NULL,97487,42.5,0.6,3160,40851,NULL,NULL,'z = 2.26','GOODS J123637.63+621830.5',NULL,'2015AJ....150..156R',2015,1,0.026,NULL,'G',NULL,NULL,'22.9R',0.025,NULL,NULL,NULL,NULL,NULL,1,189.15675,62.30842,0,NULL,57377064431,896516631,14008072,22.9),(97488,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97488,31.13,0.4,16.8,40852,75,NULL,'B','IC 3576',NULL,'1988NBGC.C....0000T',1988,1,2.3,NULL,'G',0.000013,NULL,'14.0B',2.1,'Sm             HII','Group member, radial-velocity confirmed',NULL,NULL,'H II',1,189.157,6.62089,0,NULL,58241175701,910018370,14219037,14),(97489,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97489,35.14,0.4,107,40853,NULL,NULL,'mean','IC 3581',NULL,'2007A&A...465...71T',2007,1,0.4,NULL,'G',0.00002,NULL,'15.5',0.3,'S0',NULL,NULL,NULL,NULL,1,189.1587917,24.42903,0.049,NULL,58617352988,915896140,14310877,15.5),(97490,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97490,35.29,0.47,114,40853,NULL,NULL,'H','IC 3581',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97491,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97491,35.33,0.45,116,40853,NULL,NULL,'K','IC 3581',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97492,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97492,35.45,0.46,123,40853,NULL,NULL,'J','IC 3581',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97493,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97493,35.18,0.49,109,40854,75,NULL,'IR','ESO 574- G 013',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'16.43',0.2,'Sb:',NULL,NULL,NULL,NULL,1,189.160125,-19.67336,0.121,NULL,43953601122,686775017,10730859,16.43),(97494,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97494,35.39,0.55,120,40854,NULL,NULL,'Malmquist cor.','ESO 574- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97495,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97495,35.53,0.51,128,40854,NULL,NULL,NULL,'ESO 574- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97496,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97496,35.57,0.2,130,40854,74.4,NULL,NULL,'ESO 574- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97497,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97497,35.2,0.15,110,40855,70,NULL,NULL,'IC 3585',NULL,'2015arXiv151105856S',2015,1,0.98,NULL,'G',0.00008,NULL,'14.7g',0.68,'SA(s)0^0^:','Group member',NULL,NULL,NULL,1,189.16625,26.82994,0.018,NULL,58610096956,915782764,14309105,14.7),(97498,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97498,36.65,0.98,214,40856,70,NULL,NULL,'2MASX J12364017-1418133',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,189.167417,-14.30364,0.049,NULL,43923826247,686309785,10723590,15.8),(97499,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97499,36.53,0.27,203,40857,70,NULL,NULL,'2MASX J12364077+4751457',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00021,NULL,'16.0g',0.4,'E0',NULL,NULL,NULL,NULL,1,189.169708333,47.86261,0,NULL,59110720425,923605006,14431328,16),(97500,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97500,36.53,0.27,203,40858,70,NULL,NULL,'2MASX J12364077+4752247',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000187,NULL,'16.2g',0.32,NULL,NULL,NULL,NULL,NULL,1,189.169708333,47.87358,0,NULL,59110719695,923604995,14431328,16.2),(97501,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97501,38.2,0.46,436,40859,70,NULL,NULL,'2MASX J12364171+0648509',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000183,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,189.173833,6.81425,0,NULL,58241262250,910019722,14219058,17),(97502,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97502,37.4,0.33,302,40860,70,NULL,NULL,'2MASX J12364243+2212273',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.71',0.17,NULL,NULL,NULL,NULL,NULL,1,189.1767083,22.2075,0.064,NULL,58895592926,920243639,14378806,17.71),(97503,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97503,36.53,0.46,202,40861,70,NULL,NULL,'2MASX J12364248+1653485',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.9g',0.26,'AGN',NULL,NULL,NULL,NULL,1,189.1772083,16.89675,0.019,NULL,58883938337,920061536,14375961,16.9),(97504,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97504,37.84,0.33,370,40862,70,NULL,NULL,'2MASX J12364258+5657250',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000146,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,189.1772917,56.95706,0,NULL,57408078341,897001224,14015644,17.7),(97505,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97505,37.41,0.27,304,40863,70,NULL,NULL,'2MASX J12364310+1945403',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'15.9',0.2,NULL,'Group member',NULL,NULL,NULL,1,189.1794583,19.76125,NULL,NULL,58920375777,920630871,14384857,15.9),(97506,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97506,37.33,0.46,293,40864,70,NULL,NULL,'2MASX J12364320+4633207',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00014,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,189.180291667,46.55581,0,NULL,59111955018,923624297,14431629,17.7),(97507,'Brightest Stars','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97507,30.7,NULL,13.8,40865,NULL,NULL,NULL,'IC 3583',NULL,'1991MNRAS.253p..21T',1991,1,2.2,NULL,'G',0.000023,NULL,'13.31',1.1,'SmIII          HII','is a companion galaxy',NULL,NULL,NULL,1,189.1812083,13.25933,0.087,NULL,58151305514,908614148,14197096,13.31),(97508,'TRGB','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97508,29.89,0.1,9.52,40865,74.4,NULL,NULL,'IC 3583',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97509,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97509,29.4,NULL,7.59,40865,NULL,NULL,NULL,'IC 3583',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97510,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97510,29.56,0.43,8.2,40865,75,NULL,'3.6 micron, color + selection bias corrected','IC 3583',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97511,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97511,29.65,0.43,8.5,40865,75,NULL,'3.6 micron, color corrected','IC 3583',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97512,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97512,29.89,0.1,9.52,40865,74.4,NULL,NULL,'IC 3583',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97513,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97513,30.32,0.36,11.6,40865,NULL,NULL,NULL,'IC 3583',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97514,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97514,30.32,0.39,11.6,40865,73,NULL,'opt','IC 3583',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97515,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97515,30.68,NULL,13.7,40865,NULL,NULL,NULL,'IC 3583',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97516,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97516,31.13,0.4,16.8,40865,75,NULL,'B','IC 3583',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97517,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 1997ff',NULL,97517,45.15,0.34,4620,40866,65,NULL,NULL,'GOODS J123644.13+621245.2',1.32,'2001ApJ...560...49R',2001,1,0.0083,'z=1.755 (2011MNRAS.412.2707S)','G',NULL,NULL,'24.73',0.0072,'E0 tides',NULL,NULL,NULL,NULL,1,189.183875,62.21244,0,NULL,57375222769,896487855,14007622,24.73),(97518,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 1997ff',NULL,97518,45.35,0.35,5060,40866,65,NULL,NULL,'GOODS J123644.13+621245.2',1.32,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97519,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 1997ff',NULL,97519,45.49,0.34,5400,40866,65,NULL,'Magnified by 0.34 +/- 0.12 mag','GOODS J123644.13+621245.2',1.32,'2002ApJ...577L...1B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97520,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 1997ff',NULL,97520,45.53,0.35,5500,40866,65,NULL,NULL,'GOODS J123644.13+621245.2',1.32,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97521,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97521,38.31,0.46,459,40867,70,NULL,NULL,'2MASX J12364482+0846119',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000172,NULL,'17.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,189.186541667,8.76994,0,NULL,58196061441,909313460,14208022,17.9),(97522,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97522,36.59,0.46,208,40868,70,NULL,NULL,'2MASX J12364528+4338367',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000123,NULL,'15.8g',0.34,'E0',NULL,NULL,NULL,NULL,1,189.188667,43.64358,0,NULL,59117612031,923712687,14433010,15.8),(97523,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97523,36.41,0.46,192,40869,70,NULL,NULL,'2MASX J12364554+0942599',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000183,NULL,'16.0g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,189.1897083,9.71669,0,NULL,58199611173,909368924,14208889,16),(97524,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97524,38.02,0.46,402,40870,70,NULL,NULL,'2MASX J12364597+4558077',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,189.191416667,45.96886,0,NULL,59111993631,923624900,14431639,17.6),(97525,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97525,37.9,0.19,380,40871,70,NULL,NULL,'VPC 1076',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.0001,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,189.1942083,12.93608,0.087,NULL,58151372451,908615194,14197112,17.4),(97526,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97526,38.06,0.46,410,40872,70,NULL,NULL,'2MASX J12364787+4615337',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,189.199333,46.25922,0,NULL,59112159434,923627491,14431679,17.9),(97527,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97527,34.77,NULL,89.8,40873,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 3587',NULL,'2010Ap&SS.325..163P',2010,1,1.64,'Multiple SDSS entries describe this object.','G',0.000003,NULL,'16.0',0.16,'Scd',NULL,NULL,NULL,NULL,1,189.201375,27.54853,0.062,NULL,58730422126,917662845,14338481,16),(97528,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97528,34.79,NULL,90.8,40873,NULL,NULL,'Dipole + Quadrupole','IC 3587',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97529,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97529,34.81,NULL,91.4,40873,NULL,NULL,'Dipole','IC 3587',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97530,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97530,34.82,NULL,91.9,40873,NULL,NULL,NULL,'IC 3587',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97531,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97531,34.86,0.49,93.9,40873,75,NULL,'IR','IC 3587',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97532,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97532,38.19,0.46,434,40874,70,NULL,NULL,'2MASX J12364860+3734017',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000179,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,189.2027083,37.56731,0,NULL,58565827353,915091052,14298297,17.3),(97533,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002dc',NULL,97533,41.39,0.25,1290,40875,74.2,NULL,'SALT 2','MDS uhdfk-27',0.47452,'2010ApJ...716..712A',2010,1,0.0243,'Several HDF galaxies may contribute to the ISO source.','G',0.00033,NULL,'21.51',0.0092,'Sb pec;ELG;HII Sbrst',NULL,NULL,NULL,NULL,1,189.20725,62.22031,0,NULL,57375222095,896487845,14007622,21.51),(97534,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002dc','R',97534,41.63,NULL,1440,40875,65,NULL,'MLCS17','MDS uhdfk-27',0.47452,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97535,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002dc',NULL,97535,42.14,0.19,1820,40875,65,NULL,NULL,'MDS uhdfk-27',0.47452,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97536,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002dc',NULL,97536,42.19,0.22,1860,40875,70,NULL,'SALT','MDS uhdfk-27',0.47452,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97537,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002dc',NULL,97537,42.2,0.23,1870,40875,65,NULL,'MLCS','MDS uhdfk-27',0.47452,'2003ApJ...589..693B',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97538,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002dc',NULL,97538,42.24,0.2,1900,40875,65,NULL,NULL,'MDS uhdfk-27',0.47452,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97539,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002dc',NULL,97539,42.25,0.29,1910,40875,65,NULL,'MLCS17','MDS uhdfk-27',0.47452,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97540,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002dc',NULL,97540,42.3,0.38,1960,40875,65,NULL,'SALT2','MDS uhdfk-27',0.47452,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97541,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002dc',NULL,97541,42.34,0.34,2000,40875,65,NULL,'SALT','MDS uhdfk-27',0.47452,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97542,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002dc',NULL,97542,42.36,0.27,2010,40875,65,NULL,'MLCS31','MDS uhdfk-27',0.47452,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97543,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002dc',NULL,97543,42.37,0.35,2020,40875,65,NULL,'BAT','MDS uhdfk-27',0.47452,'2003ApJ...589..693B',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97544,'Tully est','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97544,31.13,0.8,16.8,40876,75,NULL,'B','MESSIER 090',NULL,'1988NBGC.C....0000T',1988,1,9.5,'UZC has V = 644 +- 29 km/sec.','G',0.000013,NULL,'10.26',4.4,'SAB(rs)ab;LINER;Sy','Parent (of companion) galaxy',NULL,NULL,'Sy',1,189.2074583,13.16294,0.087,NULL,58151340978,908614702,14197104,10.26),(97545,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97545,29.56,0.42,8.17,40876,65,NULL,NULL,'MESSIER 090',NULL,'1980ApJ...238..458M',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97546,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97546,29.84,0.92,9.3,40876,NULL,NULL,'CO','MESSIER 090',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97547,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97547,29.93,0.7,9.7,40876,NULL,NULL,'HI','MESSIER 090',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97548,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97548,29.97,0.05,9.86,40876,NULL,NULL,'stellar kinematics','MESSIER 090',NULL,'2008ApJ...683...78C',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97549,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97549,30.13,NULL,10.6,40876,84,NULL,'RSA Hubble type','MESSIER 090',NULL,'1986AJ.....91.1286S',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97550,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97550,30.37,NULL,11.9,40876,NULL,NULL,NULL,'MESSIER 090',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97551,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97551,30.5,NULL,12.6,40876,84,NULL,'RSA Hubble type','MESSIER 090',NULL,'1986AJ.....91.1286S',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97552,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97552,30.5,NULL,12.6,40876,84,NULL,'RC2 Hubble type','MESSIER 090',NULL,'1986AJ.....91.1286S',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97553,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97553,31.03,0.3,16.1,40876,55,NULL,'B','MESSIER 090',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97554,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97554,31.1,NULL,16.6,40876,84,NULL,'RC2 Hubble type','MESSIER 090',NULL,'1986AJ.....91.1286S',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97555,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97555,38.64,0.46,535,40877,70,NULL,NULL,'2MASX J12365006+2407329',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,189.208666667,24.12583,0,NULL,58612329156,915817643,14309650,18.3),(97556,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97556,36.53,0.27,203,40878,70,NULL,NULL,'2MASX J12365106+4745336',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000168,NULL,'16.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,189.212917,47.75947,0,NULL,59110734917,923605233,14431331,16.4),(97557,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97557,37.96,0.46,392,40879,70,NULL,NULL,'2MASX J12365284+4131393',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000127,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,189.22025,41.52775,0,NULL,59115346883,923677295,14432457,18.6),(97558,'GCLF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97558,30.99,0.12,15.8,40880,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4570',NULL,'2010ApJ...717..603V',2010,1,3.8,NULL,'G',0.000017,NULL,'11.84',1.1,'S0(7)/E7','in a radial-velocity based grouping',NULL,NULL,NULL,1,189.2225,7.24664,0,NULL,58239294488,909988976,14218577,11.84),(97559,'GCLF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97559,31.07,0.15,16.4,40880,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4570',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97560,'GCLF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97560,31.23,0.15,17.6,40880,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4570',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97561,'GCLF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97561,31.28,0.14,18,40880,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4570',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97562,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97562,31.15,0.12,17,40880,74.4,NULL,NULL,'NGC 4570',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97563,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97563,31.16,0.06,17.1,40880,NULL,NULL,NULL,'NGC 4570',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97564,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97564,31.17,0.07,17.1,40880,NULL,NULL,'HST ACS VCS','NGC 4570',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97565,'GC radius','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97565,30.7,0.11,13.8,40880,NULL,NULL,NULL,'NGC 4570',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97566,'Faber-Jackson','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97566,31.34,0.65,18.5,40880,95,NULL,'Weighted Mean','NGC 4570',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97567,'Faber-Jackson','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97567,32.64,0.81,33.7,40880,55,NULL,'Visvanathan & Sandage 1979','NGC 4570',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97568,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97568,30.7,NULL,13.8,40880,NULL,NULL,NULL,'NGC 4570',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97569,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97569,31.15,0.12,17,40880,74.4,NULL,NULL,'NGC 4570',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97570,'Tertiary','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97570,30.49,0.25,12.5,40880,95,NULL,NULL,'NGC 4570',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97571,'Tully est','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97571,31.13,0.8,16.8,40880,75,NULL,'B','NGC 4570',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97572,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97572,30.48,0.45,12.5,40880,NULL,NULL,'K','NGC 4570',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97573,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97573,31.85,0.4,23.5,40880,NULL,NULL,'mean','NGC 4570',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97574,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Sas',NULL,97574,44.9,0.19,4000,40881,65,NULL,NULL,'GOODS J123654.15+620821.8',0.44643,'2007ApJ...659...98R',2007,1,0.023,'Reiss et al. (2007ApJ...659...98R) give z = 1.39.','G',0.00033,NULL,'22.9R',0.021,NULL,NULL,NULL,NULL,NULL,1,189.225625,62.13939,0,NULL,57375260129,896488439,14007631,22.9),(97575,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Sas','R',97575,44.02,NULL,4390,40881,65,NULL,'SALT','GOODS J123654.15+620821.8',0.44643,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97576,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Sas',NULL,97576,44.11,0.24,4590,40881,74.2,NULL,'SALT 2','GOODS J123654.15+620821.8',0.44643,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97577,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Sas',NULL,97577,44.8,0.18,6300,40881,65,NULL,'SN Sasquatch, SALT2','GOODS J123654.15+620821.8',0.44643,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97578,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Sas',NULL,97578,44.81,0.19,6340,40881,65,NULL,'SN Sasquatch, MLCS2k2','GOODS J123654.15+620821.8',0.44643,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97579,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Sas',NULL,97579,44.83,0.59,6390,40881,70,NULL,'SALT','GOODS J123654.15+620821.8',0.44643,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97580,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Sas',NULL,97580,44.89,0.91,6570,40881,65,NULL,'SALT','GOODS J123654.15+620821.8',0.44643,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97581,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Sas',NULL,97581,44.93,0.22,6700,40881,65,NULL,'SN Sasquatch, SALT2','GOODS J123654.15+620821.8',0.44643,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97582,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Sas',NULL,97582,44.93,0.28,6700,40881,65,NULL,'SN Sasquatch, SALT2','GOODS J123654.15+620821.8',0.44643,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97583,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Sas',NULL,97583,45,0.23,6900,40881,65,NULL,'SN Sasquatch, SALT2','GOODS J123654.15+620821.8',0.44643,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97584,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Sas',NULL,97584,45.25,0.15,7760,40881,70,NULL,'SN Sasquatch, SALT2','GOODS J123654.15+620821.8',0.44643,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97585,'GCLF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97585,31.61,0.46,21,40882,NULL,NULL,'TOM(g) = -7.2 mag','IC 3586',NULL,'2007ApJS..171..101J',2007,1,0.96,NULL,'G',0.000097,NULL,'14.8g',0.83,'dS0:','Group member',NULL,NULL,NULL,1,189.2285417,12.52008,0.128,NULL,58153206028,908643844,14197560,14.8),(97586,'GCLF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97586,31.62,0.4,21.1,40882,NULL,NULL,'TOM(g) = -7.2 mag','IC 3586',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97587,'GCLF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97587,31.86,0.56,23.6,40882,NULL,NULL,'TOM(u) = -8.4 mag','IC 3586',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97588,'GCLF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97588,32.01,0.52,25.2,40882,NULL,NULL,'TOM(z) = -8.53 mag','IC 3586',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97589,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97589,31.07,0.14,16.4,40882,74.4,NULL,NULL,'IC 3586',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97590,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97590,31.09,0.08,16.5,40882,NULL,NULL,'HST ACS VCS','IC 3586',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97591,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97591,31.09,0.08,16.5,40882,NULL,NULL,NULL,'IC 3586',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97592,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97592,32.19,NULL,27.4,40883,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1475',NULL,'2010Ap&SS.325..163P',2010,1,0.89,NULL,'G',0.000033,NULL,'16.5g',0.22,'Irr(f)',NULL,NULL,NULL,NULL,1,189.2289583,1.61506,0.016,NULL,58000585550,906259149,14160299,16.5),(97593,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97593,32.23,NULL,28,40883,NULL,NULL,'Dipole + Quadrupole','FGC 1475',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97594,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97594,32.26,NULL,28.3,40883,NULL,NULL,'Dipole','FGC 1475',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97595,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97595,32.34,NULL,29.4,40883,NULL,NULL,NULL,'FGC 1475',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97596,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Tha',NULL,97596,43.19,0.22,2230,40884,74.2,NULL,'SALT 2','GOODS J123655.15+621304.0',0.95,'2010ApJ...716..712A',2010,1,0.007,NULL,'G',0.004,NULL,'23.65',0.0055,'E3',NULL,NULL,NULL,NULL,1,189.229833,62.21767,0,NULL,57375222033,896487844,14007622,23.65),(97597,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Tha',NULL,97597,43.85,0.27,3010,40884,65,NULL,NULL,'GOODS J123655.15+621304.0',0.95,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97598,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Tha',NULL,97598,43.98,0.34,3200,40884,65,NULL,'MLCS17','GOODS J123655.15+621304.0',0.95,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97599,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Tha',NULL,97599,44.04,0.18,3300,40884,70,NULL,'SALT','GOODS J123655.15+621304.0',0.95,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97600,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Tha',NULL,97600,44.04,0.32,3300,40884,65,NULL,'SALT2','GOODS J123655.15+621304.0',0.95,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97601,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Tha',NULL,97601,44.06,0.31,3320,40884,65,NULL,'MLCS2k2','GOODS J123655.15+621304.0',0.95,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97602,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Tha',NULL,97602,44.11,0.39,3410,40884,65,NULL,'MLCS31','GOODS J123655.15+621304.0',0.95,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97603,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Tha',NULL,97603,44.15,0.43,3470,40884,65,NULL,'SALT2','GOODS J123655.15+621304.0',0.95,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97604,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002dd','R',97604,42.99,NULL,2030,40885,65,NULL,'SALT','[TBF2002] J123655.35+621246.1',0.95,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,189.230625,62.21281,0,NULL,57375222058,896487844,14007622,NULL),(97605,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002dd',NULL,97605,43.11,0.22,2150,40885,74.2,NULL,'SALT 2','[TBF2002] J123655.35+621246.1',0.95,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97606,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002dd',NULL,97606,43.77,0.21,2910,40885,70,NULL,'SALT','[TBF2002] J123655.35+621246.1',0.95,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97607,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002dd',NULL,97607,43.9,0.18,3090,40885,65,NULL,'SALT','[TBF2002] J123655.35+621246.1',0.95,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97608,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002dd',NULL,97608,43.92,0.2,3120,40885,65,NULL,'SALT2','[TBF2002] J123655.35+621246.1',0.95,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97609,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002dd',NULL,97609,43.97,0.26,3190,40885,65,NULL,'MLCS17','[TBF2002] J123655.35+621246.1',0.95,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97610,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002dd',NULL,97610,43.98,0.34,3210,40885,65,NULL,NULL,'[TBF2002] J123655.35+621246.1',0.95,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97611,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002dd',NULL,97611,44.06,0.26,3330,40885,65,NULL,NULL,'[TBF2002] J123655.35+621246.1',0.95,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97612,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002dd',NULL,97612,44.08,0.29,3350,40885,65,NULL,'MLCS31','[TBF2002] J123655.35+621246.1',0.95,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97613,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002dd',NULL,97613,44.15,0.2,3470,40885,65,NULL,'MLCS','[TBF2002] J123655.35+621246.1',0.95,'2003ApJ...589..693B',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97614,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002dd',NULL,97614,44.17,0.2,3500,40885,65,NULL,'MLCS, no U-band','[TBF2002] J123655.35+621246.1',0.95,'2003ApJ...589..693B',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97615,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002dd',NULL,97615,44.17,0.27,3500,40885,65,NULL,'BAT, no U-band','[TBF2002] J123655.35+621246.1',0.95,'2003ApJ...589..693B',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97616,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002dd',NULL,97616,44.27,0.27,3660,40885,65,NULL,'BAT','[TBF2002] J123655.35+621246.1',0.95,'2003ApJ...589..693B',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97617,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003es',NULL,97617,43.36,0.24,2400,40886,74.2,NULL,'SALT 2','GOODS J123655.45+621311.6',0.954,'2010ApJ...716..712A',2010,1,0.0133,'Lanzetta, et al. (1996Natur.381..759L) give z = 0.37.','G',0.00033,NULL,'22.19',0.0119,'E/Sa:;HiLum    HII',NULL,NULL,NULL,NULL,1,189.2309583,62.21986,0,NULL,57375223072,896487860,14007622,22.19),(97618,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003es',NULL,97618,44.06,0.27,3310,40886,65,NULL,'SN Ramone, MLCS2k2','GOODS J123655.45+621311.6',0.954,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97619,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003es',NULL,97619,44.06,0.15,3320,40886,70,NULL,'SALT','GOODS J123655.45+621311.6',0.954,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97620,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003es',NULL,97620,44.13,0.28,3430,40886,65,NULL,'SN Ramone, MLCS17','GOODS J123655.45+621311.6',0.954,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97621,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003es',NULL,97621,44.19,0.3,3520,40886,65,NULL,'SN Ramone, MLCS31','GOODS J123655.45+621311.6',0.954,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97622,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003es',NULL,97622,44.28,0.31,3670,40886,65,NULL,NULL,'GOODS J123655.45+621311.6',0.954,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97623,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003es',NULL,97623,44.28,0.34,3670,40886,65,NULL,'SN Ramone, SALT2','GOODS J123655.45+621311.6',0.954,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97624,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003es',NULL,97624,44.3,0.27,3710,40886,65,NULL,NULL,'GOODS J123655.45+621311.6',0.954,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97625,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003es',NULL,97625,44.31,0.23,3730,40886,65,NULL,'SN Ramone, SALT2','GOODS J123655.45+621311.6',0.954,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97626,'Brightest Stars','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97626,30.9,0.2,15.1,40887,NULL,NULL,NULL,'NGC 4571',NULL,'1992ApJ...393..523P',1992,1,3.6,NULL,'G',0.00001,NULL,'11.82',3.2,'SA(r)d         HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,189.234917,14.21736,0.054,NULL,58873390339,919896724,14373386,11.82),(97627,'Brightest Stars','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97627,30.97,NULL,15.6,40887,NULL,NULL,'Blue','NGC 4571',NULL,'1997AstL...23..644G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97628,'Brightest Stars','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97628,31.04,NULL,16.1,40887,NULL,NULL,'Red','NGC 4571',NULL,'1997AstL...23..644G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97629,'Brightest Stars','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97629,31.06,NULL,16.3,40887,NULL,NULL,'Red + Blue','NGC 4571',NULL,'1997AstL...23..644G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97630,'Cepheids','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97630,30.84,0.09,14.7,40887,74.4,NULL,NULL,'NGC 4571',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97631,'Cepheids','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97631,30.9,NULL,15.1,40887,NULL,NULL,'3, R','NGC 4571',NULL,'1994Natur.371..385P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97632,'Cepheids','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97632,30.9,NULL,15.1,40887,NULL,NULL,'HST KP Calibrated, max. D','NGC 4571',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97633,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97633,30.79,0.61,14.4,40887,NULL,NULL,NULL,'NGC 4571',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97634,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97634,30.84,0.09,14.7,40887,74.4,NULL,NULL,'NGC 4571',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97635,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97635,31.05,0.55,16.2,40887,NULL,NULL,'Malmquist cor.','NGC 4571',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97636,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97636,31.13,0.4,16.8,40887,75,NULL,'B','NGC 4571',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97637,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97637,31.41,NULL,19.1,40887,NULL,NULL,NULL,'NGC 4571',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97638,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97638,31.68,0.92,21.7,40887,NULL,NULL,'CO','NGC 4571',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97639,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97639,31.73,0.7,22.2,40887,NULL,NULL,'HI','NGC 4571',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97640,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97640,37.34,0.19,294,40888,70,NULL,NULL,'2MASX J12365647+1520154',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,189.235375,15.33747,0.015,NULL,58885659245,920088425,14376381,17.4),(97641,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Lan',NULL,97641,44.21,0.22,3110,40889,74.2,NULL,'SALT 2','GOODS J123656.59+621253.1',1.23407,'2010ApJ...716..712A',2010,1,0.006,NULL,'G',0.00033,NULL,'24.03',0.0041,'E1 tides',NULL,NULL,NULL,NULL,1,189.236333,62.21458,0,NULL,57375222079,896487844,14007622,24.03),(97642,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Lan','R',97642,44.44,NULL,3460,40889,65,NULL,'SALT','GOODS J123656.59+621253.1',1.23407,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97643,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Lan',NULL,97643,44.83,0.19,4140,40889,70,NULL,'SALT 2','GOODS J123656.59+621253.1',1.23407,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97644,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Lan',NULL,97644,44.83,0.15,4140,40889,65,NULL,'SALT2','GOODS J123656.59+621253.1',1.23407,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97645,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Lan',NULL,97645,44.85,0.24,4180,40889,70,NULL,'SALT','GOODS J123656.59+621253.1',1.23407,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97646,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Lan',NULL,97646,44.97,0.2,4420,40889,65,NULL,NULL,'GOODS J123656.59+621253.1',1.23407,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97647,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Lan',NULL,97647,44.97,0.21,4420,40889,65,NULL,'SALT','GOODS J123656.59+621253.1',1.23407,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97648,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Lan',NULL,97648,45.03,0.15,4540,40889,65,NULL,'MLCS2k2','GOODS J123656.59+621253.1',1.23407,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97649,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Lan',NULL,97649,45.08,0.19,4650,40889,65,NULL,'MLCS17','GOODS J123656.59+621253.1',1.23407,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97650,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Lan',NULL,97650,45.11,0.25,4710,40889,65,NULL,'MLCS31','GOODS J123656.59+621253.1',1.23407,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97651,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Lan',NULL,97651,45.11,0.21,4720,40889,65,NULL,'SALT2','GOODS J123656.59+621253.1',1.23407,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97652,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Lan',NULL,97652,45.54,0.08,5730,40889,70,NULL,'SALT 2','GOODS J123656.59+621253.1',1.23407,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97653,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97653,36.64,0.65,213,40890,70,NULL,NULL,'2MASX J12365674-4105428',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,189.236375,-41.09525,0.425,NULL,46762942793,730670981,11416734,15.6),(97654,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97654,35.2,0.46,110,40891,70,NULL,NULL,'2MASX J12365712+1025489',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000169,NULL,'16.1g',0.33,'S0/a',NULL,NULL,NULL,NULL,1,189.238125,10.43033,0,NULL,58199070215,909360472,14208757,16.1),(97655,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97655,37.43,0.46,306,40892,70,NULL,NULL,'2MASX J12365770+0719579',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000209,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,189.2404583,7.33281,0,NULL,58239800950,909996889,14218701,16.2),(97656,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97656,37.28,0.46,285,40893,70,NULL,NULL,'SDSS J123658.69+072328.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000136,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,189.244583,7.39128,0,NULL,58239811575,909997055,14218703,18.2),(97657,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97657,37.34,0.19,294,40894,70,NULL,NULL,'VPC 1090',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000182,NULL,'16.6g',0.32,'AGN',NULL,NULL,NULL,NULL,1,189.245875,15.13886,0.042,NULL,58885504637,920086009,14376343,16.6),(97658,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97658,37.9,0.19,380,40895,70,NULL,NULL,'2MASX J12365905+1252244',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,189.246166667,12.87347,0.087,NULL,58151239950,908613124,14197080,17.7),(97659,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97659,36.91,0.46,241,40896,70,NULL,NULL,'2MASX J12365931+2946564',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00016,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,189.247417,29.78236,0.088,NULL,58776837168,918388080,14349813,16.9),(97660,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97660,37.62,0.46,333,40897,70,NULL,NULL,'2MASX J12365937+3644174',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,189.247417,36.73817,0,NULL,58565590030,915087344,14298239,17.9),(97661,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97661,38.52,0.21,505,40898,70,NULL,NULL,'2MASX J12365952+5550580',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000174,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,189.2482083,55.84933,0,NULL,57403223133,896925361,14014458,17.7),(97662,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97662,37.22,0.19,278,40899,70,NULL,NULL,'2MASX J12370034+1629589',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,189.2514583,16.49964,0.015,NULL,58884236869,920066201,14376034,NULL),(97663,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97663,37.94,0.46,388,40900,70,NULL,NULL,'2MASX J12370081+6556445',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,189.253291667,65.94564,0.021,NULL,57321193929,895643655,13994432,17.4),(97664,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97664,37.69,0.46,346,40901,70,NULL,NULL,'2MASX J12370157+0055012',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000079,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,189.2565417,0.91714,0.023,NULL,58002943088,906295985,14160874,17.2),(97665,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Red',NULL,97665,43.56,0.24,2350,40902,74.2,NULL,'SALT 2','GOODS J123701.71+621223.9',1.191,'2010ApJ...716..712A',2010,1,0.005,NULL,'G',NULL,NULL,'24.78',0.0044,NULL,NULL,NULL,NULL,NULL,1,189.257125,62.20653,0,NULL,57375256290,896488379,14007630,24.78),(97666,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Red',NULL,97666,43.64,0.39,2440,40902,65,NULL,NULL,'GOODS J123701.71+621223.9',1.191,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97667,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Red',NULL,97667,44.12,0.25,3040,40902,70,NULL,'SALT','GOODS J123701.71+621223.9',1.191,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97668,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Red','R',97668,44.18,NULL,3130,40902,65,NULL,'SALT','GOODS J123701.71+621223.9',1.191,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97669,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Red',NULL,97669,44.21,0.23,3160,40902,65,NULL,'SALT','GOODS J123701.71+621223.9',1.191,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97670,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97670,37.33,0.46,292,40903,70,NULL,NULL,'2MASX J12370191+0556482',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000163,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,189.2580417,5.94678,0,NULL,58240952819,910014887,14218982,16.9),(97671,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97671,36.01,0.46,160,40904,70,NULL,NULL,'CGCG 014-078',NULL,'2015arXiv151105856S',2015,1,0.72,'UZC has V = 13538 +- 44 km/sec.','G',0.0001,NULL,'15.1g',0.57,'SA0-:',NULL,NULL,NULL,NULL,1,189.260291667,1.81908,0,NULL,58000496119,906257751,14160277,15.1),(97672,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97672,38.89,0.46,600,40905,70,NULL,NULL,'SDSS J123702.50+212025.7',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'19.26',0.19,NULL,NULL,NULL,NULL,NULL,1,189.2604583,21.3405,0.212,NULL,58894235583,920222430,14378475,19.26),(97673,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97673,37.4,0.33,302,40906,70,NULL,NULL,'2MASX J12370261+2215489',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,189.260875,22.26369,0.064,NULL,58895618016,920244031,14378812,16.8),(97674,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97674,29.96,NULL,9.82,40907,NULL,NULL,NULL,'IC 3591',NULL,'2013AJ....145..101K',2013,1,0.9,'HOLM 428B = IC 3589 is a star.','G',0.000013,NULL,'14.40',0.6,'SBmIII         HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,189.262667,6.92664,0,NULL,58241233178,910019268,14219051,14.4),(97675,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97675,31.28,0.36,18,40907,NULL,NULL,NULL,'IC 3591',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97676,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97676,37.46,0.13,310,40908,70,NULL,NULL,'SDSS J123704.15+163535.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,189.267291667,16.59328,0.015,NULL,58884765294,920074457,14376163,18),(97677,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 1997cj',NULL,97677,42.48,0.19,1390,40909,65,NULL,'H96','H-ZSNS J123704.27+622624.9',0.5,'1998ApJ...493L..53G',1998,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,189.2677917,62.44025,0,NULL,57377249091,896519517,14008117,NULL),(97678,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 1997cj','R',97678,41.65,NULL,1420,40909,65,NULL,'SALT','H-ZSNS J123704.27+622624.9',0.5,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97679,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 1997cj',NULL,97679,41.65,0.32,1430,40909,74.2,NULL,'SALT 2','H-ZSNS J123704.27+622624.9',0.5,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97680,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 1997cj',NULL,97680,42.59,0.25,1460,40909,65,NULL,'RPK','H-ZSNS J123704.27+622624.9',0.5,'1998ApJ...493L..53G',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97681,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 1997cj',NULL,97681,42.4,0.17,2010,40909,65,NULL,'MLCS','H-ZSNS J123704.27+622624.9',0.5,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97682,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 1997cj',NULL,97682,42.43,0.29,2040,40909,70,NULL,'SALT','H-ZSNS J123704.27+622624.9',0.5,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97683,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 1997cj',NULL,97683,42.6,0.28,2200,40909,65,NULL,'SALT','H-ZSNS J123704.27+622624.9',0.5,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97684,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 1997cj',NULL,97684,42.7,0.16,2310,40909,65,NULL,'Template','H-ZSNS J123704.27+622624.9',0.5,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97685,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 1997cj',NULL,97685,42.74,0.2,2360,40909,65,NULL,NULL,'H-ZSNS J123704.27+622624.9',0.5,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97686,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97686,35.98,0.46,157,40910,70,NULL,NULL,'2MASX J12370427+3602084',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000182,NULL,'16.1g',0.32,NULL,NULL,NULL,NULL,NULL,1,189.267917,36.03583,0,NULL,58564244203,915066315,14297911,16.1),(97687,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97687,37.64,0.46,338,40911,70,NULL,NULL,'SDSS J123704.47+315039.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,189.268667,31.84419,0.021,NULL,58784509673,918507963,14351686,18.1),(97688,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97688,37.34,0.19,294,40912,70,NULL,NULL,'VPC 1096',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000176,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,189.270333,15.25878,0.017,NULL,58885614348,920087724,14376370,16.3),(97689,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97689,37.14,0.46,268,40913,70,NULL,NULL,'2MASX J12370527+2603214',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,189.271916667,26.05606,0.039,NULL,58618430090,915912970,14311140,17.7),(97690,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97690,36.46,0.46,196,40914,70,NULL,NULL,'2MASX J12370546+0535442',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,189.2727917,5.59556,0,NULL,58222325571,909723837,14214434,17.5),(97691,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97691,38.18,0.14,433,40915,70,NULL,NULL,'2MASXi J1237056+643106',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,189.273666667,64.51858,0.017,NULL,57367195035,896362422,14005662,18),(97692,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Spo','R',97692,42.5,NULL,1720,40916,65,NULL,'MLCS17','GOODS J123706.60+621512.4',0.84,'2010arXiv1006.2112L',2010,1,0.014,NULL,'G',NULL,NULL,'22.94',0.013,'E0/Star',NULL,NULL,NULL,NULL,1,189.277083,62.25333,0,NULL,57375220016,896487812,14007622,22.94),(97693,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Spo',NULL,97693,42.68,0.21,1870,40916,74.2,NULL,'SALT 2','GOODS J123706.60+621512.4',0.84,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97694,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Spo',NULL,97694,43.29,0.3,2470,40916,65,NULL,'MLCS2k2','GOODS J123706.60+621512.4',0.84,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97695,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Spo',NULL,97695,43.37,0.29,2560,40916,65,NULL,'SALT2','GOODS J123706.60+621512.4',0.84,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97696,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Spo',NULL,97696,43.37,0.39,2560,40916,65,NULL,'MLCS17','GOODS J123706.60+621512.4',0.84,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97697,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Spo',NULL,97697,43.43,0.4,2640,40916,65,NULL,'MLCS31','GOODS J123706.60+621512.4',0.84,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97698,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Spo',NULL,97698,43.45,0.2,2660,40916,65,NULL,NULL,'GOODS J123706.60+621512.4',0.84,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97699,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Spo',NULL,97699,43.6,0.21,2850,40916,70,NULL,'SALT','GOODS J123706.60+621512.4',0.84,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97700,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Spo',NULL,97700,43.61,0.31,2860,40916,65,NULL,'SALT2','GOODS J123706.60+621512.4',0.84,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97701,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST05Spo',NULL,97701,43.77,0.19,3080,40916,65,NULL,'SALT','GOODS J123706.60+621512.4',0.84,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97702,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97702,37.44,0.46,307,40917,70,NULL,NULL,'2MASX J12370692+3556374',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000148,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,189.2787083,35.94389,0,NULL,58564173090,915065204,14297893,17.1),(97703,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97703,37.54,0.46,322,40918,70,NULL,NULL,'2MASX J12370862+1003534',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,189.286,10.06486,0,NULL,58198404394,909350068,14208594,17.3),(97704,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97704,37.57,0.46,327,40919,70,NULL,NULL,'2MASX J12370873+6354445',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000157,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,189.286541667,63.91244,0.025,NULL,57366980848,896359075,14005610,16.6),(97705,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97705,37.11,0.46,264,40920,70,NULL,NULL,'SDSS J123708.93+063918.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,189.2872083,6.65503,0,NULL,58241181193,910018456,14219038,17.8),(97706,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003dy','R',97706,44.01,NULL,2710,40921,65,NULL,'SN Borg, MLCS31','GOODS J123709.12+621129.4',1.34,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,189.288,62.1915,0,NULL,57375256511,896488382,14007630,NULL),(97707,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003dy',NULL,97707,44.28,0.27,3070,40921,74.2,NULL,'SALT 2','GOODS J123709.12+621129.4',1.34,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97708,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003dy',NULL,97708,44.88,0.31,4030,40921,65,NULL,'SN Borg, MLCS31','GOODS J123709.12+621129.4',1.34,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97709,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003dy',NULL,97709,44.89,0.19,4070,40921,65,NULL,'SN Borg, MLCS2k2','GOODS J123709.12+621129.4',1.34,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97710,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003dy',NULL,97710,44.92,0.24,4120,40921,65,NULL,'SN Borg, MLCS17','GOODS J123709.12+621129.4',1.34,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97711,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003dy',NULL,97711,44.92,0.31,4120,40921,65,NULL,NULL,'GOODS J123709.12+621129.4',1.34,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97712,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003dy',NULL,97712,44.94,0.21,4150,40921,65,NULL,'SN Borg, SALT2','GOODS J123709.12+621129.4',1.34,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97713,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003dy',NULL,97713,44.95,0.25,4180,40921,70,NULL,'SALT','GOODS J123709.12+621129.4',1.34,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97714,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003dy',NULL,97714,44.98,0.27,4240,40921,70,NULL,'SN Borg, SALT 2','GOODS J123709.12+621129.4',1.34,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97715,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003dy',NULL,97715,45.05,0.21,4360,40921,65,NULL,'SN Borg, SALT2','GOODS J123709.12+621129.4',1.34,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97716,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003dy',NULL,97716,45.05,0.25,4370,40921,65,NULL,NULL,'GOODS J123709.12+621129.4',1.34,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97717,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003dy',NULL,97717,45.05,0.26,4380,40921,65,NULL,'SALT','GOODS J123709.12+621129.4',1.34,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97718,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003dy',NULL,97718,45.1,0.11,4470,40921,70,NULL,'SN Borg, MLCS31','GOODS J123709.12+621129.4',1.34,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97719,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97719,36.44,0.46,194,40922,70,NULL,NULL,'2MASX J12370914+6505235',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00016,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,189.2882083,65.08992,0.017,NULL,57321845485,895653835,13994591,16.3),(97720,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97720,37.66,0.46,340,40923,70,NULL,NULL,'VPCX 51',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00016,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,189.288667,14.71806,0.052,NULL,58885046933,920078858,14376232,17.2),(97721,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN SCP-0401',NULL,97721,45.57,0.24,4790,40924,70,NULL,'SALT2-2','CXO J123709.4+622214',1.713,'2013ApJ...763...35R',2013,1,NULL,NULL,'G',NULL,'PHOT','26.2B',NULL,NULL,NULL,NULL,NULL,NULL,1,189.2895417,62.37094,0,NULL,57377072776,896516762,14008074,26.2),(97722,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97722,36.26,0.46,179,40925,70,NULL,NULL,'2MASX J12370984+0831094',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000158,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,189.291,8.51944,0,NULL,58194062221,909282222,14207534,16.4),(97723,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97723,38.54,0.46,512,40926,70,NULL,NULL,'2MASX J12371271+1723449',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,189.303125,17.39575,0.039,NULL,58876495998,919945249,14374144,18.2),(97724,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97724,37.58,0.46,329,40927,70,NULL,NULL,'SDSS J123713.07+071503.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,189.3045,7.25103,0,NULL,58239761443,909996272,14218691,17.7),(97725,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97725,37.34,0.19,294,40928,70,NULL,NULL,'2MASX J12371320+1523329',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.1g',0.12,'AGN',NULL,NULL,NULL,NULL,1,189.305083,15.39244,0.017,NULL,58885624928,920087889,14376373,18.1),(97726,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97726,29.43,NULL,7.69,40929,NULL,NULL,NULL,'[RC3] 1234.6-1014',NULL,'2013AJ....145..101K',2013,1,1.1,NULL,'G',0.000007,NULL,'16.54',0.6,'IB(s)m',NULL,NULL,NULL,NULL,1,189.30625,-10.49611,0.081,NULL,43165641050,674463141,10538486,16.54),(97727,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97727,29.45,0.4,7.7,40929,NULL,NULL,NULL,'[RC3] 1234.6-1014',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97728,'IRAS','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97728,31.23,0.8,17.6,40930,75,NULL,'MAT, I','ESO 442- G 013',NULL,'1997ApJS..109..333W',1997,1,3,'Extended HIPASS source','G',0.000007,NULL,'13.47',1,'SB(rs)cd',NULL,NULL,NULL,NULL,1,189.30625,-28.49289,0.309,NULL,43427636160,678556815,10602450,13.47),(97729,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97729,31.6,0.32,20.9,40930,85,NULL,'I, inv','ESO 442- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97730,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97730,31.61,0.32,21,40930,85,NULL,'I, raw','ESO 442- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97731,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97731,31.78,0.4,22.7,40930,NULL,NULL,NULL,'ESO 442- G 013',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97732,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97732,31.86,0.2,23.6,40930,74.4,NULL,NULL,'ESO 442- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97733,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97733,32.03,0.43,25.5,40930,75,NULL,'3.6 micron, color corrected','ESO 442- G 013',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97734,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97734,32.08,0.43,26.1,40930,75,NULL,'MAT, I, raw','ESO 442- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97735,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97735,32.11,0.43,26.4,40930,75,NULL,'MAT, I, inv','ESO 442- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97736,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97736,32.18,0.43,27.3,40930,75,NULL,'3.6 micron, color + selection bias corrected','ESO 442- G 013',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97737,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97737,32.39,0.43,30,40930,75,NULL,'MAT, I, cor','ESO 442- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97738,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97738,38.37,0.46,473,40931,70,NULL,NULL,'2MASX J12371354+2416404',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,189.3064583,24.27803,0,NULL,58616586291,915884160,14310690,18.3),(97739,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97739,32.74,0.49,35.3,40932,75,NULL,'IR','2MFGC 09938',NULL,'2011yCatp016004901K',2011,1,NULL,'This is a part of the galaxy ESO 442- G 013.','PofG',0.00015,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,189.3075,-28.49761,0.309,NULL,43427636151,678556814,10602450,NULL),(97740,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97740,37.77,0.46,358,40933,70,NULL,NULL,'2MASX J12371503+0817174',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,189.31275,8.28806,0,NULL,58194068906,909282326,14207536,17.2),(97741,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003eb',NULL,97741,42.34,0.2,1550,40934,74.2,NULL,'SALT 2','GOODS J123715.09+621334.6',0.899,'2010ApJ...716..712A',2010,1,0.025,NULL,'G',0.00033,NULL,'22.5',0.022,NULL,NULL,NULL,NULL,NULL,1,189.312875,62.22617,0,NULL,57375253434,896488334,14007630,22.5),(97742,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003eb',NULL,97742,43.06,0.31,2160,40934,65,NULL,'SN McEnroe, MLCS2k2','GOODS J123715.09+621334.6',0.899,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97743,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003eb',NULL,97743,43.14,0.13,2240,40934,65,NULL,'SN McEnroe, SALT2','GOODS J123715.09+621334.6',0.899,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97744,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003eb',NULL,97744,43.17,0.18,2270,40934,65,NULL,'SN McEnroe, SALT2','GOODS J123715.09+621334.6',0.899,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97745,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003eb',NULL,97745,43.18,0.2,2280,40934,70,NULL,'SALT','GOODS J123715.09+621334.6',0.899,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97746,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003eb',NULL,97746,43.41,0.37,2530,40934,65,NULL,'SN McEnroe, MLCS31','GOODS J123715.09+621334.6',0.899,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97747,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003eb',NULL,97747,43.43,0.31,2550,40934,65,NULL,'SN McEnroe, MLCS17','GOODS J123715.09+621334.6',0.899,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97748,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003eb',NULL,97748,43.64,0.25,2820,40934,65,NULL,NULL,'GOODS J123715.09+621334.6',0.899,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97749,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003eb',NULL,97749,43.64,0.25,2820,40934,65,NULL,NULL,'GOODS J123715.09+621334.6',0.899,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97750,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97750,35.94,0.46,154,40935,70,NULL,NULL,'2MASX J12371560+5102120',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000169,NULL,'16.0g',0.38,'E0',NULL,NULL,NULL,NULL,1,189.315333,51.03672,0,NULL,57237437461,894334960,13973983,16),(97751,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97751,37.12,0.46,265,40936,70,NULL,NULL,'2MASX J12371576+5654471',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,189.315917,56.913,0.017,NULL,57408084600,897001321,14015645,16.9),(97752,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN GND13Sto',NULL,97752,42.3,0.35,2880,40937,NULL,NULL,'z = 1.8','[KPA2012] GN_IRS18',NULL,'2015AJ....150..156R',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,189.319125,62.27861,0,NULL,57377070906,896516732,14008073,NULL),(97753,'L(H{beta})-{sigma}','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97753,46.16,NULL,1595,40938,74.3,NULL,NULL,'GOODS J123718.61+620956.2',2.2713,'2015MNRAS.451.3001T',2015,1,0.018,NULL,'G',NULL,NULL,'23.9R',0.017,NULL,NULL,NULL,NULL,NULL,1,189.3274583,62.16542,0,NULL,57375254768,896488355,14007630,23.9),(97754,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97754,38.18,0.14,433,40939,70,NULL,NULL,'2MASX J12371900+6431505',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,189.329125,64.53069,0.017,NULL,57367194641,896362416,14005662,18.1),(97755,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97755,37.97,0.46,393,40940,70,NULL,NULL,'2MASX J12371902+2357434',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,189.329417,23.96217,0.022,NULL,58612363099,915818173,14309658,16.8),(97756,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97756,37.44,0.46,308,40941,70,NULL,NULL,'2MASX J12371941+0341464',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000187,NULL,'16.0g',0.47,'E0',NULL,NULL,NULL,NULL,1,189.330833,3.69622,0.029,NULL,58233583998,909899749,14217183,16),(97757,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97757,37.49,0.46,314,40942,70,NULL,NULL,'2MASX J12371955+0245264',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000147,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,189.331416667,2.75728,0.016,NULL,58219639336,909681864,14213779,17.8),(97758,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003az','R',97758,43.98,NULL,2760,40943,65,NULL,'SALT','GOODS J123719.68+621837.6',1.27,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,189.332,62.31044,0,NULL,57377068454,896516694,14008073,NULL),(97759,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003az',NULL,97759,44.13,0.22,2950,40943,74.2,NULL,'SALT 2','GOODS J123719.68+621837.6',1.27,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97760,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003az',NULL,97760,44.63,0.23,3720,40943,70,NULL,'SALT','GOODS J123719.68+621837.6',1.27,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97761,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003az',NULL,97761,44.64,0.25,3740,40943,65,NULL,NULL,'GOODS J123719.68+621837.6',1.27,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97762,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003az',NULL,97762,44.74,0.21,3920,40943,65,NULL,'SALT','GOODS J123719.68+621837.6',1.27,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97763,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003az',NULL,97763,44.79,0.14,3990,40943,65,NULL,'SN Torngasek, SALT2','GOODS J123719.68+621837.6',1.27,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97764,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003az',NULL,97764,44.8,0.2,4010,40943,70,NULL,'SN Torngasek, SALT 2','GOODS J123719.68+621837.6',1.27,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97765,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003az',NULL,97765,44.81,0.21,4040,40943,65,NULL,'SN Torngasek, MLCS2k2','GOODS J123719.68+621837.6',1.27,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97766,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003az',NULL,97766,44.83,0.32,4080,40943,65,NULL,'SN Torngasek, MLCS31','GOODS J123719.68+621837.6',1.27,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97767,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003az',NULL,97767,44.84,0.25,4100,40943,65,NULL,'SN Torngasek, MLCS17','GOODS J123719.68+621837.6',1.27,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97768,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003az',NULL,97768,44.87,0.21,4150,40943,65,NULL,'SN Torngasek, SALT2','GOODS J123719.68+621837.6',1.27,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97769,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003az',NULL,97769,45,0.08,4400,40943,70,NULL,'SN Torngasek, SALT2','GOODS J123719.68+621837.6',1.27,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97770,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003az',NULL,97770,45.2,0.2,4840,40943,65,NULL,NULL,'GOODS J123719.68+621837.6',1.27,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97771,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97771,38.13,0.46,422,40944,70,NULL,NULL,'2MASX J12371985+5326370',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,189.332583,53.44381,0,NULL,57227798728,894184355,13971630,17.7),(97772,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Eag','R',97772,43.33,NULL,2300,40945,65,NULL,'SALT','GOODS J123720.85+621340.7',1.01891,'2010arXiv1006.2112L',2010,1,0.018,NULL,'G',0.00033,NULL,'22.15',0.017,NULL,NULL,NULL,NULL,NULL,1,189.3369583,62.22781,0,NULL,57375252675,896488323,14007630,22.15),(97773,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Eag',NULL,97773,43.57,0.21,2560,40945,74.2,NULL,'SALT 2','GOODS J123720.85+621340.7',1.01891,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97774,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Eag',NULL,97774,43.96,0.07,3070,40945,70,NULL,'SALT','GOODS J123720.85+621340.7',1.01891,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97775,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Eag',NULL,97775,44.2,0.22,3430,40945,70,NULL,'SALT','GOODS J123720.85+621340.7',1.01891,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97776,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Eag',NULL,97776,44.23,0.17,3480,40945,65,NULL,'SALT2','GOODS J123720.85+621340.7',1.01891,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97777,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Eag',NULL,97777,44.34,0.19,3660,40945,65,NULL,'SALT','GOODS J123720.85+621340.7',1.01891,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97778,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Eag',NULL,97778,44.35,0.21,3660,40945,65,NULL,'SALT2','GOODS J123720.85+621340.7',1.01891,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97779,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Eag',NULL,97779,44.35,0.18,3670,40945,65,NULL,'MLCS2k2','GOODS J123720.85+621340.7',1.01891,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97780,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Eag',NULL,97780,44.38,0.2,3720,40945,70,NULL,'SALT 2','GOODS J123720.85+621340.7',1.01891,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97781,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Eag',NULL,97781,44.39,0.21,3730,40945,65,NULL,'MLCS17','GOODS J123720.85+621340.7',1.01891,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97782,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Eag',NULL,97782,44.42,0.22,3790,40945,65,NULL,'MLCS31','GOODS J123720.85+621340.7',1.01891,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97783,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Eag',NULL,97783,44.52,0.19,3970,40945,65,NULL,NULL,'GOODS J123720.85+621340.7',1.01891,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97784,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97784,35.17,0.2,108,40946,74.4,NULL,NULL,'IC 3598',NULL,'2013AJ....146...86T',2013,1,1.55,NULL,'G',0.00001,NULL,'14.6g',0.45,'SA(r)ab:       RET','Group member, peripheral',NULL,NULL,NULL,1,189.337833,28.20817,0.07,NULL,58732788845,917699825,14339059,14.6),(97785,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97785,35.31,0.4,115,40946,NULL,NULL,'mean','IC 3598',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97786,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97786,35.33,0.47,116,40946,NULL,NULL,'H','IC 3598',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97787,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97787,35.46,0.45,123,40946,NULL,NULL,'K','IC 3598',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97788,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97788,35.46,0.07,124,40946,NULL,NULL,NULL,'IC 3598',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97789,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97789,35.48,0.46,125,40946,NULL,NULL,'J','IC 3598',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97790,'Brightest Stars','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97790,27.2,NULL,2.8,40947,NULL,NULL,NULL,'UGCA 290',NULL,'1998A&AS..128..459M',1998,1,NULL,'VV misprints R.A. as 12h34.3m, dec as +39d05m; corrected in MCG errata.','GPair',0.000002,NULL,NULL,NULL,'Im pec',NULL,NULL,NULL,NULL,1,189.340833,38.74389,0,1,58560249901,915003904,14296936,NULL),(97791,'Brightest Stars','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97791,27.58,0.4,3.28,40947,NULL,NULL,'3B + 3R mean','UGCA 290',NULL,'1997AstL...23..656G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97792,'Brightest Stars','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97792,27.91,NULL,3.82,40947,NULL,NULL,'LF','UGCA 290',NULL,'1997AstL...23..656G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97793,'TRGB','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97793,28.99,0.08,6.29,40947,74.4,NULL,NULL,'UGCA 290',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97794,'TRGB','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97794,29.1,0.12,6.7,40947,NULL,NULL,NULL,'UGCA 290',NULL,'2002ApJ...567..258C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97795,'TRGB','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97795,29.1,0.12,6.7,40947,NULL,NULL,'I','UGCA 290',NULL,'2000ApJ...545L..31C',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97796,'TRGB','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97796,29.13,0.13,6.7,40947,NULL,NULL,NULL,'UGCA 290',NULL,'2014A&A...566A..71L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97797,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97797,36.95,0.27,246,40948,70,NULL,NULL,'2MASX J12372201+4156000',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000212,NULL,'16.0g',0.42,'E0',NULL,NULL,NULL,NULL,1,189.3420417,41.93336,0,NULL,59118453236,923725831,14433216,16),(97798,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97798,36.95,0.27,246,40949,70,NULL,NULL,'2MASX J12372282+4153350',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00016,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,189.345125,41.89303,0,NULL,59118322477,923723788,14433184,16.8),(97799,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97799,37.79,0.33,361,40950,70,NULL,NULL,'2MASX J12372305+0803474',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000188,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,189.346125,8.06308,0,NULL,58193994385,909281162,14207518,16.6),(97800,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97800,38.2,0.46,436,40951,70,NULL,NULL,'2MASX J12372310+2719164',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000193,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,189.3462917,27.32136,0.084,NULL,58730311399,917661115,14338454,17.7),(97801,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97801,37.09,0.46,261,40952,70,NULL,NULL,'2MASX J12372326+3356176',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,189.347083,33.93831,0,NULL,58745079943,917891874,14342060,17.3),(97802,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97802,37.74,0.46,354,40953,70,NULL,NULL,'SDSS J123723.88-015917.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000085,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,189.3495,-1.98819,0.049,NULL,43169472057,674523000,10539421,17.9),(97803,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97803,36.95,0.27,246,40954,70,NULL,NULL,'SDSS J123724.04+415447.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,189.3502083,41.91322,0,NULL,59118322422,923723787,14433184,18.1),(97804,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97804,38.54,0.46,512,40955,70,NULL,NULL,'2MASX J12372476+4632000',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,189.353333,46.53325,0,NULL,59111946775,923624168,14431627,17.8),(97805,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97805,31.55,0.22,20.4,40956,NULL,NULL,'I','NGC 4589',NULL,'2003ApJ...583..712J',2003,1,3.2,'The 2MASS position is 7 arcsec north of the nucleus.','G',0.000047,NULL,'11.69',2.6,'E2             LINER','X-ray-bright group member',NULL,NULL,NULL,1,189.354125,74.19192,0.033,NULL,57033117444,891142460,13924100,11.69),(97806,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97806,31.71,0.22,22,40956,NULL,NULL,'I','NGC 4589',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97807,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97807,31.75,0.14,22.4,40956,74.4,NULL,NULL,'NGC 4589',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97808,'D-Sigma','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97808,32.79,0.4,36.1,40956,75,NULL,'Edat, raw','NGC 4589',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97809,'D-Sigma','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97809,32.93,0.4,38.6,40956,75,NULL,'Edat, cor','NGC 4589',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97810,'Faber-Jackson','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97810,31.6,0.39,20.9,40956,95,NULL,'Weighted Mean','NGC 4589',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97811,'Faber-Jackson','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97811,31.64,0.49,21.3,40956,95,NULL,'de Vaucouleurs','NGC 4589',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97812,'Faber-Jackson','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97812,32.88,0.81,37.7,40956,55,NULL,'Visvanathan & Sandage 1979','NGC 4589',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97813,'Tertiary','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97813,31.72,0.71,22.1,40956,95,NULL,NULL,'NGC 4589',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97814,'Tully est','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97814,32.39,0.8,30,40956,75,NULL,'B','NGC 4589',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97815,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97815,32.55,0.4,32.3,40956,NULL,NULL,'mean','NGC 4589',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97816,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97816,32.6,0.45,33.2,40956,NULL,NULL,'K','NGC 4589',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97817,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003bd',NULL,97817,42.43,0.19,1830,40957,74.2,NULL,'SALT 2','GOODS J123725.06+621317.5',0.67,'2010ApJ...716..712A',2010,1,0.01,NULL,'G',0.01,NULL,'25.4R',0.009,NULL,NULL,NULL,NULL,NULL,1,189.354417,62.22153,0,NULL,57375253057,896488329,14007630,25.4),(97818,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003bd',NULL,97818,43.02,0.22,2410,40957,65,NULL,'SN Anguta, MLCS2k2','GOODS J123725.06+621317.5',0.67,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97819,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003bd',NULL,97819,43.07,0.56,2460,40957,65,NULL,'SN Anguta, SALT2','GOODS J123725.06+621317.5',0.67,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97820,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003bd',NULL,97820,43.09,0.32,2480,40957,65,NULL,'SN Anguta, MLCS31','GOODS J123725.06+621317.5',0.67,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97821,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003bd',NULL,97821,43.12,0.25,2520,40957,65,NULL,'SN Anguta, MLCS17','GOODS J123725.06+621317.5',0.67,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97822,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003bd',NULL,97822,43.13,0.07,2530,40957,70,NULL,'SALT','GOODS J123725.06+621317.5',0.67,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97823,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003bd',NULL,97823,43.19,0.24,2600,40957,65,NULL,NULL,'GOODS J123725.06+621317.5',0.67,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97824,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003bd',NULL,97824,43.19,0.28,2600,40957,65,NULL,NULL,'GOODS J123725.06+621317.5',0.67,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97825,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003bd',NULL,97825,43.33,0.18,2780,40957,65,NULL,'SN Anguta, SALT2','GOODS J123725.06+621317.5',0.67,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97826,'IRAS','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97826,32.45,0.8,31,40958,75,NULL,'MAT, I','ESO 322- G 033',NULL,'1997ApJS..109..333W',1997,1,1.79,NULL,'G',0.000033,NULL,'16.95',0.17,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,189.355417,-40.17778,0.465,NULL,46746556692,730414948,11412733,16.95),(97827,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97827,31.86,0.32,23.6,40958,85,NULL,'I, inv','ESO 322- G 033',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97828,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97828,31.95,0.32,24.5,40958,85,NULL,'I, raw','ESO 322- G 033',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97829,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97829,31.96,NULL,24.7,40958,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 322- G 033',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97830,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97830,31.97,NULL,24.8,40958,NULL,NULL,'Dipole + Quadrupole','ESO 322- G 033',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97831,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97831,31.99,NULL,25,40958,NULL,NULL,'Dipole','ESO 322- G 033',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97832,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97832,32.1,NULL,26.3,40958,NULL,NULL,NULL,'ESO 322- G 033',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97833,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97833,32.31,0.43,29,40958,75,NULL,'MAT, I, inv','ESO 322- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97834,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97834,32.53,0.43,32.1,40958,75,NULL,'MAT, I, raw','ESO 322- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97835,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97835,32.91,0.43,38.3,40958,75,NULL,'MAT, I, cor','ESO 322- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97836,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97836,37.83,0.46,368,40959,70,NULL,NULL,'SDSS J123727.12+375331.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000173,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,189.363,37.89208,0,NULL,58558016297,914969004,14296390,18.2),(97837,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97837,35.24,0.51,112,40960,70,NULL,NULL,'2MASX J12372752-5215578',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00014,NULL,'15.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,189.36475,-52.26614,0.281,NULL,44612649893,697072654,10891760,15.2),(97838,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97838,35.32,0.63,116,40961,70,NULL,NULL,'2MASX J12372790-4425430',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,189.366333,-44.42858,0.477,NULL,46770839004,730794359,11418661,16.6),(97839,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002ki',NULL,97839,43.47,0.36,2310,40962,74.2,NULL,'SALT 2','GOODS J123728.36+622040.0',1.141,'2010ApJ...716..712A',2010,1,0.018,NULL,'G',0.001,NULL,'24.4z',0.014,'Cand. z~6 galaxy',NULL,NULL,NULL,NULL,1,189.368167,62.34444,0,NULL,57377073325,896516770,14008074,24.4),(97840,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002ki','R',97840,43.7,NULL,2570,40962,65,NULL,'SALT','GOODS J123728.36+622040.0',1.141,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97841,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002ki',NULL,97841,43.99,0.96,2930,40962,65,NULL,'SN Nanna, SALT2','GOODS J123728.36+622040.0',1.141,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97842,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002ki',NULL,97842,44.03,0.77,2990,40962,70,NULL,'SALT','GOODS J123728.36+622040.0',1.141,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97843,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002ki',NULL,97843,44.12,0.73,3110,40962,65,NULL,'SALT','GOODS J123728.36+622040.0',1.141,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97844,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002ki',NULL,97844,44.46,0.39,3640,40962,65,NULL,'SN Nanna, MLCS17','GOODS J123728.36+622040.0',1.141,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97845,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002ki',NULL,97845,44.57,0.46,3830,40962,65,NULL,'SN Nanna, MLCS31','GOODS J123728.36+622040.0',1.141,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97846,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002ki',NULL,97846,44.64,0.31,3950,40962,65,NULL,'SN Nanna, MLCS2k2','GOODS J123728.36+622040.0',1.141,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97847,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002ki',NULL,97847,44.71,0.29,4090,40962,65,NULL,NULL,'GOODS J123728.36+622040.0',1.141,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97848,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002ki',NULL,97848,44.72,0.23,4110,40962,65,NULL,'SN Nanna, SALT2','GOODS J123728.36+622040.0',1.141,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97849,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2002ki',NULL,97849,44.84,0.3,4340,40962,65,NULL,NULL,'GOODS J123728.36+622040.0',1.141,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97850,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003lv',NULL,97850,42.82,0.22,1890,40963,74.2,NULL,'SALT 2','GOODS J123728.95+621127.8',0.935,'2010ApJ...716..712A',2010,1,0.015,NULL,'G',0.00033,NULL,'23.5R',0.015,'E;Opt.var.',NULL,NULL,NULL,NULL,1,189.370708333,62.19106,0,NULL,57375200965,896487515,14007617,23.5),(97851,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003lv',NULL,97851,43.51,0.36,2600,40963,65,NULL,'exSN 2003XX, SN Vilas, MLCS2k2','GOODS J123728.95+621127.8',0.935,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97852,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003lv',NULL,97852,43.54,0.07,2640,40963,70,NULL,'exSN 2003XX, SN Vilas, MLCS2k2','GOODS J123728.95+621127.8',0.935,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97853,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003lv',NULL,97853,43.59,0.18,2700,40963,65,NULL,'exSN 2003XX, SN Vilas, SALT 2','GOODS J123728.95+621127.8',0.935,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97854,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003lv',NULL,97854,43.64,0.21,2760,40963,65,NULL,'exSN 2003XX, SN Vilas, SALT2','GOODS J123728.95+621127.8',0.935,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97855,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003lv',NULL,97855,43.69,0.14,2830,40963,70,NULL,'exSN 2003XX, SALT','GOODS J123728.95+621127.8',0.935,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97856,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003lv',NULL,97856,43.71,0.37,2850,40963,65,NULL,'exSN 2003XX, SN Vilas, MLCS17','GOODS J123728.95+621127.8',0.935,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97857,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003lv',NULL,97857,43.79,0.38,2960,40963,65,NULL,'exSN 2003XX, SN Vilas, MLCS31','GOODS J123728.95+621127.8',0.935,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97858,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003lv',NULL,97858,43.87,0.2,3070,40963,65,NULL,'ex SN 2003XX','GOODS J123728.95+621127.8',0.935,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97859,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003lv',NULL,97859,43.97,0.29,3220,40963,65,NULL,'ex SN 2003XX','GOODS J123728.95+621127.8',0.935,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97860,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97860,29.29,NULL,7.21,40964,NULL,NULL,NULL,'VCC 1713',NULL,'2013AJ....145..101K',2013,1,0.54,NULL,'G',0.000043,NULL,'15.08',0.32,'dE','Group member',NULL,NULL,NULL,1,189.37125,4.75142,0,NULL,58230175417,909846490,14216351,15.08),(97861,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97861,35.72,0.63,139,40965,70,NULL,NULL,'2MASX J12372925-4414140',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,189.37175,-44.23717,0.481,NULL,46770840568,730794383,11418662,17.1),(97862,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97862,38.52,0.21,505,40966,70,NULL,NULL,'2MASX J12372965+5550321',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000142,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,189.373375,55.84214,0,NULL,57403013333,896922083,14014407,18.4),(97863,'Cepheids','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97863,31.31,0.32,18.3,40967,NULL,NULL,'HST KP Calibrated, K\'','NGC 4578',NULL,'2000ApJ...529..745F',2000,1,3.3,NULL,'G',0.000017,NULL,'12.38',2.5,'SA(r)0^0^:','in a radial-velocity based grouping',NULL,NULL,NULL,1,189.377333,9.55508,0,NULL,58199468987,909366702,14208854,12.38),(97864,'GCLF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97864,30.87,0.13,14.9,40967,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4578',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97865,'GCLF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97865,30.87,0.16,14.9,40967,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4578',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97866,'GCLF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97866,31.02,0.16,16,40967,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4578',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97867,'GCLF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97867,31.14,0.14,16.9,40967,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4578',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97868,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97868,30.84,0.06,14.7,40967,NULL,NULL,'I','NGC 4578',NULL,'1990AJ....100.1416T',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97869,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97869,30.95,0.2,15.5,40967,NULL,NULL,'I','NGC 4578',NULL,'1993A&A...275..433B',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97870,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97870,31.03,0.1,16.1,40967,NULL,NULL,'K','NGC 4578',NULL,'1996ApJ...468..519J',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97871,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97871,31.06,0.06,16.3,40967,NULL,NULL,NULL,'NGC 4578',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97872,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97872,31.07,0.07,16.4,40967,NULL,NULL,'HST ACS VCS','NGC 4578',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97873,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97873,31.15,0.3,17,40967,NULL,NULL,'K','NGC 4578',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97874,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97874,31.25,0.12,17.8,40967,74.4,NULL,NULL,'NGC 4578',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97875,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97875,31.25,0.08,17.8,40967,NULL,NULL,'I','NGC 4578',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97876,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97876,31.34,0.13,18.5,40967,NULL,NULL,'I','NGC 4578',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97877,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97877,31.4,0.15,19.1,40967,NULL,NULL,'HST KP Calibrated, I','NGC 4578',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97878,'Faber-Jackson','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97878,30.38,0.47,11.9,40967,95,NULL,'Weighted Mean','NGC 4578',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97879,'Faber-Jackson','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97879,30.51,0.67,12.6,40967,95,NULL,'de Vaucouleurs','NGC 4578',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97880,'Faber-Jackson','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97880,31.31,0.81,18.3,40967,55,NULL,'Visvanathan & Sandage 1979','NGC 4578',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97881,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97881,31.25,0.12,17.8,40967,74.4,NULL,NULL,'NGC 4578',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97882,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97882,31.32,NULL,18.4,40967,NULL,NULL,NULL,'NGC 4578',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97883,'Tertiary','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97883,30.49,0.25,12.5,40967,95,NULL,NULL,'NGC 4578',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97884,'Tully est','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97884,31.13,0.8,16.8,40967,75,NULL,'B','NGC 4578',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97885,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97885,31.51,0.45,20.1,40967,NULL,NULL,'K','NGC 4578',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97886,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97886,32.45,0.4,30.9,40967,NULL,NULL,'mean','NGC 4578',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97887,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97887,37.36,0.46,296,40968,70,NULL,NULL,'2MASX J12373088-0143477',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000085,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,189.3787083,-1.72992,0.029,NULL,42985808389,671653256,10494582,16.9),(97888,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97888,38.9,0.46,604,40969,70,NULL,NULL,'SDSS J123732.45+014220.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000175,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,189.38525,1.70583,0.016,NULL,58000660863,906260325,14160317,18.2),(97889,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97889,38.52,0.46,505,40970,70,NULL,NULL,'SDSS J123732.92+242452.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'19.85',0.13,NULL,NULL,NULL,NULL,NULL,1,189.3872083,24.4145,0.023,NULL,58617439767,915897496,14310898,19.85),(97890,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97890,38.32,0.33,462,40971,70,NULL,NULL,'SDSS J123733.01+533806.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000154,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,189.387583333,53.63519,0,NULL,57227899129,894185923,13971655,18.6),(97891,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97891,34.21,0.42,69.3,40972,NULL,NULL,'Malmquist cor.','NGC 4576',NULL,'2009ApJS..182..474S',2009,1,1.36,NULL,'G',0.000033,NULL,'14.1g',0.8,'SAB(rs)bc:','Group member',NULL,NULL,NULL,1,189.389833333,4.36769,0.021,NULL,58230240773,909847512,14216367,14.1),(97892,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97892,34.22,0.41,69.7,40972,NULL,NULL,NULL,'NGC 4576',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97893,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97893,34.26,0.2,71.1,40972,74.4,NULL,NULL,'NGC 4576',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97894,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97894,34.65,0.4,84.9,40972,NULL,NULL,'mean','NGC 4576',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97895,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97895,34.88,0.47,94.4,40972,NULL,NULL,'H','NGC 4576',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97896,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97896,34.91,0.45,95.8,40972,NULL,NULL,'K','NGC 4576',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97897,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97897,37.8,0.46,363,40973,70,NULL,NULL,'2MASX J12373492+2454222',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,189.395583333,24.90619,0.048,NULL,58616829373,915887958,14310749,16.9),(97898,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97898,37.86,0.46,372,40974,70,NULL,NULL,'2MASX J12373516+0833256',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000183,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,189.396541667,8.55706,0,NULL,58194002643,909281291,14207520,16.7),(97899,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97899,29.79,0.4,9.1,40975,NULL,NULL,NULL,'[KKS2000] 30',NULL,'2013MNRAS.429.2677K',2013,1,1,NULL,'G',0.000003,NULL,'17.3',0.5,'Ir',NULL,NULL,NULL,NULL,1,189.3995,-8.86714,0.057,NULL,43164481740,674445027,10538203,17.3),(97900,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97900,29.8,NULL,9.12,40975,NULL,NULL,NULL,'[KKS2000] 30',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97901,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97901,37.49,0.46,315,40976,70,NULL,NULL,'2MASX J12373654+3438442',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,189.40225,34.64556,NULL,NULL,58744656925,917885264,14341957,17.5),(97902,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97902,37.76,0.46,357,40977,70,NULL,NULL,'2MASX J12373685+0751106',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000204,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,189.403625,7.85308,0,NULL,58194264142,909285377,14207584,17.2),(97903,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97903,37.8,0.46,364,40978,70,NULL,NULL,'2MASX J12373719+6340364',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,189.404583,63.67683,0.025,NULL,57374425500,896475398,14007428,17.7),(97904,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97904,37.95,0.46,389,40979,70,NULL,NULL,'2MASX J12373800+0613336',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000143,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,189.408375,6.22597,0,NULL,58240395852,910006185,14218846,17.2),(97905,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97905,37.79,0.33,361,40980,70,NULL,NULL,'SDSS J123738.08+080331.2',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,189.4087083,8.05869,0,NULL,58194826172,909294158,14207721,18.3),(97906,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97906,37.67,0.46,341,40981,70,NULL,NULL,'2MASX J12373887+0618016',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000164,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,189.4120417,6.30036,0,NULL,58240349703,910005464,14218835,17.2),(97907,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97907,36.77,0.6,226,40982,70,NULL,NULL,'2MASX J12374104-4408373',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,189.4210417,-44.14367,0.477,NULL,46763421500,730678460,11416850,16.8),(97908,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97908,29.65,NULL,8.51,40983,NULL,NULL,NULL,'VCC 1725',NULL,'2013AJ....145..101K',2013,1,1.1,NULL,'G',0.000013,NULL,'14.89',0.5,'SmIII/BCD      HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,189.423,8.55864,0,NULL,58194723825,909292559,14207696,14.89),(97909,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97909,30.77,0.2,14.3,40983,74.4,NULL,NULL,'VCC 1725',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97910,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97910,31.03,0.36,16.1,40983,NULL,NULL,NULL,'VCC 1725',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97911,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97911,38.61,0.46,528,40984,70,NULL,NULL,'SDSS J123742.02+532249.7',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00019,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,189.425083333,53.3805,0,NULL,57227767727,894183870,13971622,17.3),(97912,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97912,37.76,0.33,356,40985,70,NULL,NULL,'2MASX J12374226+1928465',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.61',0.16,NULL,NULL,NULL,NULL,NULL,1,189.426125,19.47967,NULL,NULL,58920114512,920626789,14384793,17.61),(97913,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97913,35.15,0.56,107,40986,70,NULL,NULL,'2MASX J12374278-4455473',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,189.428333,-44.92969,0.421,NULL,46770789103,730793579,11418649,15.6),(97914,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97914,37.12,0.46,265,40987,70,NULL,NULL,'2MASX J12374285+1001126',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000147,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,189.428583,10.02028,0,NULL,58199507376,909367302,14208864,17.2),(97915,'IRAS','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97915,32.85,0.8,37.2,40988,75,NULL,'MAT, I','NGC 4574',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000017,NULL,'13.6',1.1,'SAB(s)c        HII','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,189.4312917,-35.51764,0.201,NULL,43241519090,675648735,10557011,13.6),(97916,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97916,31.78,0.69,22.7,40988,100,NULL,'mid-IR','NGC 4574',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97917,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97917,32.76,NULL,35.6,40988,NULL,NULL,'I','NGC 4574',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97918,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97918,32.78,0.43,35.9,40988,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4574',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97919,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97919,32.78,0.32,36,40988,85,NULL,'I, raw','NGC 4574',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97920,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97920,32.81,0.32,36.5,40988,85,NULL,'I, inv','NGC 4574',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97921,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97921,32.82,0.43,36.6,40988,75,NULL,'3.6 micron, color corrected','NGC 4574',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97922,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97922,32.87,0.2,37.5,40988,74.4,NULL,NULL,'NGC 4574',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97923,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97923,32.91,NULL,38.2,40988,NULL,NULL,'B','NGC 4574',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97924,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97924,32.97,0.43,39.2,40988,75,NULL,'MAT, I, raw','NGC 4574',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97925,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97925,33.09,0.4,41.5,40988,NULL,NULL,NULL,'NGC 4574',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97926,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97926,33.12,0.43,42.1,40988,75,NULL,'MAT, I, inv','NGC 4574',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97927,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97927,33.14,0.4,42.4,40988,NULL,NULL,'mean','NGC 4574',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97928,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97928,33.2,0.43,43.7,40988,75,NULL,'MAT, I, cor','NGC 4574',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97929,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97929,33.35,0.08,46.9,40988,NULL,NULL,NULL,'NGC 4574',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97930,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97930,33.43,0.46,48.6,40988,NULL,NULL,'J','NGC 4574',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97931,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97931,33.5,0.47,50,40988,NULL,NULL,'H','NGC 4574',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97932,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97932,33.53,0.45,50.8,40988,NULL,NULL,'K','NGC 4574',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97933,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 1989M',NULL,97933,31.61,0.2,21,40989,68,NULL,NULL,'MESSIER 058',NULL,'1996ApJ...465L..83R',1996,1,5.9,NULL,'G',0.000002,NULL,'10.48',4.7,'SAB(rs)b;LINER Sy1.9','in a radial-velocity based grouping',NULL,NULL,'unobscured Seyfert 2',1,189.431333333,11.81819,0.136,NULL,58152929316,908639520,14197492,10.48),(97934,'SNII optical','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 1988A',NULL,97934,31.51,0.3,20,40989,NULL,NULL,NULL,'MESSIER 058',NULL,'1994ApJ...432...42S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97935,'SNII optical','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 1988A',NULL,97935,31.81,0.35,23,40989,NULL,NULL,'EPM','MESSIER 058',NULL,'1992ApJ...395..366S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97936,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97936,30.99,NULL,15.8,40989,84,NULL,'RSA Hubble type','MESSIER 058',NULL,'1986AJ.....91.1286S',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97937,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97937,31.07,0.45,16.4,40989,NULL,NULL,NULL,'MESSIER 058',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97938,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97938,31.1,0.3,16.6,40989,NULL,18.45,'SN 1989M host','MESSIER 058',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97939,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97939,31.1,0.3,16.6,40989,NULL,18.45,'SN 1988A host','MESSIER 058',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97940,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97940,31.1,0.45,16.6,40989,NULL,NULL,'Malmquist cor.','MESSIER 058',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97941,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97941,31.11,0.2,16.7,40989,74.4,NULL,NULL,'MESSIER 058',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97942,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97942,31.13,0.4,16.8,40989,75,NULL,'B','MESSIER 058',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97943,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97943,31.37,0.35,18.8,40989,NULL,NULL,NULL,'MESSIER 058',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97944,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97944,31.59,NULL,20.8,40989,84,NULL,'RC2 Hubble type','MESSIER 058',NULL,'1986AJ.....91.1286S',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97945,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97945,31.61,NULL,21,40989,NULL,NULL,NULL,'MESSIER 058',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97946,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97946,31.62,0.7,21.1,40989,NULL,NULL,'HI','MESSIER 058',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97947,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97947,31.69,NULL,21.8,40989,NULL,NULL,'B','MESSIER 058',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97948,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97948,31.77,NULL,22.6,40989,NULL,NULL,'LEDA [April 2006]','MESSIER 058',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97949,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97949,31.86,0.3,23.5,40989,55,NULL,'B','MESSIER 058',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97950,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97950,31.88,0.92,23.8,40989,NULL,NULL,'CO','MESSIER 058',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97951,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97951,35.15,0.59,107,40990,70,NULL,NULL,'2MFGC 09941',NULL,'2014MNRAS.445.2677S',2014,1,1.16,NULL,'G',0.00015,NULL,'13.99',0.25,NULL,NULL,NULL,NULL,NULL,1,189.4337917,-7.46528,0.061,NULL,43212278095,675191845,10549872,13.99),(97952,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97952,35.36,0.5,118,40991,70,NULL,NULL,'2MASX J12374564-1438231',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.74',0.7,NULL,NULL,NULL,NULL,NULL,1,189.440333,-14.63989,0.053,NULL,43938314227,686536159,10727127,15.74),(97953,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97953,38.01,0.33,400,40992,70,NULL,NULL,'2MASX J12374676+5421440',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,189.444917,54.36225,0,NULL,57218878681,894044979,13969452,17.9),(97954,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97954,38,0.46,398,40993,70,NULL,NULL,'LCRS B123513.9-025233',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000084,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,189.451167,-3.15058,0.033,NULL,43183204700,674737573,10542774,17.4),(97955,'Ring Diameter','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97955,33,0.98,40,40994,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4580',NULL,'1981ApJS...45..541P',1981,1,2.28,'Nearest galaxy of comparable redshift to [HB89] 1226+023 ABS07.','G',0.000023,NULL,'12.7g',1.45,'SAB(rs)a pec   LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,189.451625,5.36853,0,NULL,58223054964,909735233,14214613,12.7),(97956,'Ring Diameter','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97956,33.3,0.76,46,40994,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4580',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97957,'Tully est','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97957,32.04,0.8,25.6,40994,75,NULL,'B','NGC 4580',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97958,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97958,28.94,0.69,6.12,40994,100,NULL,'mid-IR','NGC 4580',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97959,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97959,30.89,0.45,15,40994,NULL,NULL,'K','NGC 4580',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97960,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97960,30.94,0.47,15.4,40994,NULL,NULL,'H','NGC 4580',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97961,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97961,31.02,0.46,16,40994,NULL,NULL,'J','NGC 4580',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97962,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97962,31.13,0.48,16.9,40994,NULL,NULL,NULL,'NGC 4580',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97963,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97963,31.17,0.2,17.1,40994,74.4,NULL,NULL,'NGC 4580',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97964,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97964,31.23,0.46,17.6,40994,NULL,NULL,'Malmquist cor.','NGC 4580',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97965,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97965,31.51,0.4,20,40994,NULL,NULL,'mean','NGC 4580',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97966,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97966,31.72,0.05,22.1,40994,NULL,NULL,'stellar kinematics','NGC 4580',NULL,'2008ApJ...683...78C',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97967,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003eq','R',97967,42.72,NULL,1900,40995,65,NULL,'SN Elvis, SALT2','GOODS J123748.40+621335.2',0.839,'2010arXiv1006.2112L',2010,1,0.02,NULL,'G',0.00033,NULL,'22.7R',0.02,NULL,NULL,NULL,NULL,NULL,1,189.451625,62.22636,0.005,NULL,57375202564,896487540,14007617,22.7),(97968,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003eq',NULL,97968,42.78,0.19,1960,40995,74.2,NULL,'SALT 2','GOODS J123748.40+621335.2',0.839,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97969,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003eq',NULL,97969,43.47,0.12,2690,40995,65,NULL,'SN Elvis, SALT2','GOODS J123748.40+621335.2',0.839,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97970,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003eq',NULL,97970,43.5,0.18,2730,40995,65,NULL,'SN Elvis, MLCS2k2','GOODS J123748.40+621335.2',0.839,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97971,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003eq',NULL,97971,43.51,0.16,2730,40995,70,NULL,'SN Elvis, SALT 2','GOODS J123748.40+621335.2',0.839,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97972,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003eq',NULL,97972,43.56,0.18,2800,40995,65,NULL,'SN Elvis, SALT2','GOODS J123748.40+621335.2',0.839,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97973,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003eq',NULL,97973,43.56,0.2,2800,40995,70,NULL,'SALT','GOODS J123748.40+621335.2',0.839,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97974,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003eq',NULL,97974,43.59,0.21,2840,40995,65,NULL,'SN Elvis, MLCS17','GOODS J123748.40+621335.2',0.839,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97975,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003eq',NULL,97975,43.63,0.23,2890,40995,65,NULL,'SN Elvis, MLCS31','GOODS J123748.40+621335.2',0.839,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97976,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003eq',NULL,97976,43.63,0.05,2890,40995,70,NULL,'SN Elvis, SALT2','GOODS J123748.40+621335.2',0.839,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97977,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003eq',NULL,97977,43.67,0.21,2950,40995,65,NULL,NULL,'GOODS J123748.40+621335.2',0.839,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97978,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003eq',NULL,97978,43.73,0.18,3020,40995,65,NULL,'SALT','GOODS J123748.40+621335.2',0.839,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97979,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003eq',NULL,97979,43.86,0.22,3220,40995,65,NULL,NULL,'GOODS J123748.40+621335.2',0.839,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97980,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97980,38.54,0.46,511,40996,70,NULL,NULL,'SDSS J123748.96+602834.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000139,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,189.4540417,60.47614,0,NULL,57332447172,895819487,13997179,18.4),(97981,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97981,37.82,0.46,366,40997,70,NULL,NULL,'2MASX J12374964+6402054',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000176,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,189.457083,64.03489,0.025,NULL,57366970806,896358918,14005608,16.8),(97982,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97982,36.21,0.46,175,40998,70,NULL,NULL,'2MASX J12374987+0240463',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,189.4577083,2.67947,0.016,NULL,58219689063,909682641,14213791,16.7),(97983,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97983,37.57,0.46,326,40999,70,NULL,NULL,'2MASX J12375073+3722300',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,189.46125,37.37528,0,NULL,58565813933,915090842,14298294,17.7),(97984,'IRAS','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97984,32.82,0.8,36.6,41000,75,NULL,'MAT, I','NGC 4575',NULL,'1997ApJS..109..333W',1997,1,2,'RC3 gives v = 5250 +/- 67 km/sec.','G',0.000022,NULL,'13.12',1.3,'SAB(rs)bc      HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,189.463,-40.53736,0.469,NULL,46746465557,730413524,11412711,13.12),(97985,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97985,32.12,0.32,26.5,41000,85,NULL,'I, raw','NGC 4575',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97986,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97986,32.15,0.32,26.9,41000,85,NULL,'I, inv','NGC 4575',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97987,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97987,32.25,0.43,28.2,41000,75,NULL,'MAT, I, raw','NGC 4575',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97988,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97988,32.32,0.38,29.1,41000,NULL,NULL,NULL,'NGC 4575',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97989,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97989,32.4,0.43,30.3,41000,75,NULL,'MAT, I, inv','NGC 4575',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97990,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97990,32.66,0.43,34,41000,75,NULL,'MAT, I, cor','NGC 4575',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97991,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97991,33.39,0.09,47.7,41000,NULL,NULL,NULL,'NGC 4575',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97992,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97992,38.67,0.46,541,41001,70,NULL,NULL,'SDSS J123751.13+213458.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'19.45',0.17,NULL,NULL,NULL,NULL,NULL,1,189.463083,21.58286,0.132,NULL,58893714651,920214291,14378348,19.45),(97993,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97993,37.9,0.46,380,41002,70,NULL,NULL,'2MASX J12375161+3124503',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000153,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,189.465125,31.41378,0.022,NULL,58786495874,918538998,14352171,17.8),(97994,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,97994,36.26,0.78,179,41003,70,NULL,NULL,'2MASX J12375170-5038446',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,189.4655,-50.64581,0.777,NULL,44617390545,697146727,10892917,17.6),(97995,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97995,37.77,0.46,358,41004,70,NULL,NULL,'2MASX J12375200+0118583',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000186,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,189.466667,1.31603,0,NULL,58002615313,906290864,14160794,16.7),(97996,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97996,35.06,0.46,103,41005,70,NULL,NULL,'VCC 1737',NULL,'2015arXiv151105856S',2015,1,0.76,'SDSS DR5 has z = 0.026275 +- 0.000169; incorrectly called IC 3609 in CGCG.','G',0.000113,NULL,'14.6g',0.68,'E2','Group member',NULL,NULL,NULL,1,189.471667,14.28131,0.027,NULL,58873506248,919898535,14373414,14.6),(97997,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97997,37.69,0.46,345,41006,70,NULL,NULL,'2MASX J12375348+0354413',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,189.473,3.91169,0.035,NULL,58233674225,909901159,14217205,17.1),(97998,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97998,37.34,0.19,294,41007,70,NULL,NULL,'IC 3601',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00021,NULL,'15.6',0.2,'S?',NULL,NULL,NULL,NULL,1,189.4735,15.22467,0.017,NULL,58885588163,920087315,14376364,15.6),(97999,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',97999,37.34,0.19,294,41008,70,NULL,NULL,'VPC 1125',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000178,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,189.476625,15.21639,0.017,NULL,58885588208,920087315,14376364,17.6),(98000,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98000,37.08,0.46,260,41009,70,NULL,NULL,'2MASX J12375781+4649375',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000155,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,189.4910417,46.82711,0,NULL,59114040599,923656884,14432138,17),(98001,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98001,36.2,0.46,174,41010,70,NULL,NULL,'2MASX J12375802+5531044',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000198,NULL,'15.6g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,189.492083,55.51803,0,NULL,57399840385,896872506,14013632,15.6),(98002,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98002,38.18,0.46,432,41011,70,NULL,NULL,'2MASX J12375868+0823016',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000182,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,189.494541667,8.38378,0,NULL,58194784650,909293510,14207711,17.4),(98003,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98003,36.6,0.46,209,41012,70,NULL,NULL,'2MASX J12375870+6753028',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000089,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,189.494667,67.88408,0.025,NULL,57863360186,904115002,14126796,17.1),(98004,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98004,35.01,0.56,100,41013,70,NULL,NULL,'MCG -03-32-017',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.000103,NULL,'15.35',0.15,'poss. LINER',NULL,NULL,NULL,NULL,1,189.502125,-20.13094,0.097,NULL,43953389578,686771712,10730808,15.35),(98005,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98005,37.66,0.46,341,41014,70,NULL,NULL,'SDSS J123800.55+355015.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000142,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,189.502333,35.83769,0,NULL,58562294320,915035848,14297435,18.4),(98006,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98006,36.64,0.46,213,41015,70,NULL,NULL,'LCRS B123527.3-022330',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000068,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,189.5062083,-2.66639,0.033,NULL,43169267980,674519812,10539372,16.6),(98007,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98007,37.44,0.46,308,41016,70,NULL,NULL,'SDSS J123802.02+673156.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000074,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,189.5085,67.53244,0.009,NULL,57863500667,904117197,14126831,18.1),(98008,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98008,38.05,0.46,406,41017,70,NULL,NULL,'2MASX J12380469+3144023',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,189.5194583,31.73381,0.011,NULL,58784711741,918511120,14351736,18.4),(98009,'GRB','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98009,42.21,0.16,1790,41018,NULL,NULL,NULL,'GRB 090424',0.544,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,189.521333,16.83767,0.021,NULL,58884035029,920063047,14375985,NULL),(98010,'D-Sigma','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98010,32.39,0.4,30.1,41019,75,NULL,'Edat, raw','NGC 4581',NULL,'1997ApJS..109..333W',1997,1,1.63,NULL,'G',0.00008,NULL,'13.1g',0.94,'E+','in a radial-velocity based grouping',NULL,NULL,NULL,1,189.5215417,1.47775,0,NULL,58000444329,906256942,14160264,13.1),(98011,'D-Sigma','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98011,32.73,0.4,35.1,41019,75,NULL,'Edat, cor','NGC 4581',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98012,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98012,31.86,0.4,23.5,41019,NULL,NULL,'mean','NGC 4581',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98013,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98013,33.1,0.45,41.7,41019,NULL,NULL,'K','NGC 4581',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98014,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98014,33.76,0.4,56.4,41020,NULL,NULL,'mean','UGC 07800',NULL,'2007A&A...465...71T',2007,1,1.27,NULL,'G',0.000017,NULL,'14.7g',0.41,'SA(r)b?        NLAGN',NULL,NULL,NULL,NULL,1,189.52225,-0.02703,0.013,NULL,42984820693,671637823,10494340,14.7),(98015,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98015,34.11,0.47,66.5,41020,NULL,NULL,'H','UGC 07800',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98016,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98016,37.81,0.46,365,41021,70,NULL,NULL,'2MASX J12380570+0943522',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000163,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,189.5239583,9.73131,0,NULL,58200060588,909375946,14208999,16.6),(98017,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98017,37.2,0.46,275,41022,70,NULL,NULL,'2MASX J12380625+0933492',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,189.526167,9.56369,0,NULL,58199946410,909374162,14208971,17),(98018,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98018,38.01,0.33,400,41023,70,NULL,NULL,'2MASX J12380665+5423464',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000186,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,189.5274583,54.39639,0,NULL,57218875970,894044937,13969452,17.3),(98019,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98019,31.21,0.14,17.5,41024,74.4,NULL,NULL,'VCC 1743',NULL,'2013AJ....146...86T',2013,1,0.94,'This is probably not IC 3602.','G',0.000033,NULL,'15.6g',0.47,'dE6','Group member',NULL,NULL,NULL,1,189.5282917,10.08236,0,NULL,58198736211,909355253,14208675,15.6),(98020,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98020,31.23,0.09,17.6,41024,NULL,NULL,'HST ACS VCS','VCC 1743',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98021,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98021,31.23,0.09,17.6,41024,NULL,NULL,NULL,'VCC 1743',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98022,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98022,31.15,NULL,17,41025,NULL,NULL,NULL,'VCC 1744',NULL,'2014A&A...562A..49M',2014,1,0.46,NULL,'G',0.000007,NULL,'16.6g',0.27,'BCD?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,189.5287083,10.16556,0,NULL,58198777722,909355901,14208685,16.6),(98023,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98023,37.5,0.33,316,41026,70,NULL,NULL,'2MASX J12380752+0138584',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000173,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,189.5314583,1.64956,0,NULL,58000432110,906256751,14160261,16.5),(98024,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98024,36.7,0.46,219,41027,70,NULL,NULL,'2MASX J12380849-0123454',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000074,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,189.535375,-1.39603,0.053,NULL,42986668924,671666701,10494792,17.2),(98025,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98025,37.76,0.33,356,41028,70,NULL,NULL,'2MASX J12380856+1925424',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,189.535625,19.42864,NULL,NULL,58906269571,920410462,14381413,17.2),(98026,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98026,37.11,0.33,264,41029,70,NULL,NULL,'2MASX J12380862+4222274',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000175,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,189.53575,42.37422,0,NULL,59118680451,923729382,14433271,17),(98027,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Pat','R',98027,43.48,NULL,2520,41030,65,NULL,'MLCS31','[RSC2007] J123809.00+621847.24',0.97,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,189.5375,62.31311,0.005,NULL,57377092174,896517065,14008079,NULL),(98028,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Pat',NULL,98028,43.75,0.28,2850,41030,74.2,NULL,'SALT 2','[RSC2007] J123809.00+621847.24',0.97,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98029,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Pat',NULL,98029,43.88,0.06,3030,41030,70,NULL,'MLCS31','[RSC2007] J123809.00+621847.24',0.97,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98030,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Pat',NULL,98030,44.39,0.32,3820,41030,65,NULL,'MLCS31','[RSC2007] J123809.00+621847.24',0.97,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98031,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Pat',NULL,98031,44.43,0.27,3910,41030,65,NULL,'MLCS17','[RSC2007] J123809.00+621847.24',0.97,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98032,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Pat',NULL,98032,44.45,0.23,3940,41030,65,NULL,'MLCS2k2','[RSC2007] J123809.00+621847.24',0.97,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98033,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Pat',NULL,98033,44.57,0.29,4150,41030,65,NULL,'SALT2','[RSC2007] J123809.00+621847.24',0.97,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98034,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Pat',NULL,98034,44.58,0.24,4180,41030,70,NULL,'SALT','[RSC2007] J123809.00+621847.24',0.97,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98035,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Pat',NULL,98035,44.64,0.26,4300,41030,65,NULL,'SALT2','[RSC2007] J123809.00+621847.24',0.97,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98036,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Pat',NULL,98036,44.67,0.36,4360,41030,65,NULL,NULL,'[RSC2007] J123809.00+621847.24',0.97,'2007ApJ...659...98R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98037,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Pat',NULL,98037,44.73,0.33,4470,41030,70,NULL,'SALT 2','[RSC2007] J123809.00+621847.24',0.97,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98038,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN HST04Pat',NULL,98038,44.78,0.21,4590,41030,65,NULL,'SALT','[RSC2007] J123809.00+621847.24',0.97,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98039,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98039,35.93,0.33,153,41031,70,NULL,NULL,'2MASX J12380984+0929502',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000195,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,189.541166667,9.49733,0,NULL,58199943360,909374115,14208970,16.3),(98040,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98040,36.28,0.46,181,41032,70,NULL,NULL,'2MASX J12381020+4732475',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000173,NULL,'15.4g',0.53,'E0',NULL,NULL,NULL,NULL,1,189.542625,47.5465,0,NULL,59110754500,923605539,14431336,15.4),(98041,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98041,38.32,0.33,462,41033,70,NULL,NULL,'2MASX J12381084+5331504',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,189.545291667,53.53078,0,NULL,57227784586,894184134,13971627,17.2),(98042,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98042,37.99,0.46,396,41034,70,NULL,NULL,'2MASX J12381174+5601574',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000178,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,189.549167,56.03256,0,NULL,57403087215,896923237,14014425,17.7),(98043,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98043,37.74,0.46,353,41035,70,NULL,NULL,'2MASX J12381302+0212467',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,189.554167,2.21297,0,NULL,58219870022,909685469,14213835,17.6),(98044,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98044,34.98,0.2,99.1,41036,74.4,NULL,NULL,'NGC 4585',NULL,'2013AJ....146...86T',2013,1,0.89,NULL,'G',0.000011,NULL,'14.6g',0.5,'Sab','Group member, peripheral',NULL,NULL,NULL,1,189.555333,28.93703,0.07,NULL,58731678121,917682470,14338788,14.6),(98045,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98045,35.2,0.08,110,41036,NULL,NULL,NULL,'NGC 4585',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98046,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98046,38.33,0.46,463,41037,70,NULL,NULL,'2MASX J12381427+1259040',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000151,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,189.559583,12.98444,0.09,NULL,58151672664,908619885,14197185,17.8),(98047,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98047,37.46,0.46,310,41038,70,NULL,NULL,'2MASX J12381487+1031212',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000162,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,189.561958333,10.52258,0,NULL,58198714889,909354920,14208670,17.1),(98048,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98048,36.61,0.51,210,41039,70,NULL,NULL,'2MASX J12381524-1037155',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.85',0.5,NULL,NULL,NULL,NULL,NULL,1,189.563625,-10.62097,0.081,NULL,43165039063,674453735,10538339,15.85),(98049,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98049,38.63,0.27,533,41040,70,NULL,NULL,'2MASX J12381530+2108554',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,189.56375,21.14889,0.205,NULL,58893347073,920208548,14378258,17.4),(98050,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98050,36.8,0.46,229,41041,70,NULL,NULL,'2MASXi J1238157+413930',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000141,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,189.5652917,41.65839,0,NULL,59114888364,923670130,14432345,17.5),(98051,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98051,36.66,0.46,215,41042,70,NULL,NULL,'IC 3603',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000183,NULL,'15.8g',0.41,'S0',NULL,NULL,NULL,NULL,1,189.567291667,15.56981,0.01,NULL,58887756108,920121189,14376893,15.8),(98052,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98052,38.63,0.27,533,41043,70,NULL,NULL,'2MASX J12381617+2116104',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,189.567417,21.26961,0.205,NULL,58893338412,920208412,14378256,18.2),(98053,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98053,35.9,0.69,151,41044,70,NULL,NULL,'2MASX J12381621-4441119',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,189.567583333,-44.68667,0.477,NULL,46770890313,730795161,11418674,17.6),(98054,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98054,37.5,0.33,316,41045,70,NULL,NULL,'2MASX J12381657+0137127',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000183,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,189.5690417,1.62025,0,NULL,58000430485,906256726,14160261,17),(98055,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98055,32.48,0.34,31.3,41046,NULL,NULL,'I','ESO 322- G 038',NULL,'2001ApJ...546..681T',2001,1,1.6,NULL,'G',0.000087,NULL,'13.66',0.8,'SAB0-','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,189.5767083,-41.50333,0.465,NULL,46763042324,730672536,11416758,13.66),(98056,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98056,32.48,0.34,31.3,41046,NULL,NULL,NULL,'ESO 322- G 038',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98057,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98057,32.76,0.12,35.7,41046,74.4,NULL,NULL,'ESO 322- G 038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98058,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98058,32.77,0.34,35.9,41046,NULL,NULL,'Malmquist cor.','ESO 322- G 038',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98059,'D-Sigma','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98059,32.93,0.4,38.6,41046,75,NULL,'Edat, raw','ESO 322- G 038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98060,'D-Sigma','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98060,32.95,0.4,38.9,41046,75,NULL,'Edat, cor','ESO 322- G 038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98061,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98061,32.76,0.12,35.7,41046,74.4,NULL,NULL,'ESO 322- G 038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98062,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98062,32.95,0.47,39,41046,70,NULL,NULL,'ESO 322- G 038',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98063,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98063,34.05,0.41,64.6,41046,NULL,NULL,NULL,'ESO 322- G 038',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98064,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98064,34.14,0.41,67.2,41046,NULL,NULL,'Malmquist cor.','ESO 322- G 038',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98065,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98065,33.27,0.4,45,41046,NULL,NULL,'mean','ESO 322- G 038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98066,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98066,33.48,0.45,49.7,41046,NULL,NULL,'K','ESO 322- G 038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98067,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98067,38.63,0.27,533,41047,70,NULL,NULL,'2MASX J12382005+2117356',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,189.583458333,21.29319,0.205,NULL,58894189062,920221704,14378464,17.8),(98068,'Tully est','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98068,32.99,0.8,39.7,41048,75,NULL,'B','ESO 380- G 050',NULL,'1988NBGC.C....0000T',1988,1,1.2,'6dF DR2 has z = 0.029641.','G',0.000043,NULL,'15.20',0.7,'SB(r)ab','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,189.585291667,-35.61592,0.201,NULL,43241971092,675655798,10557121,15.2),(98069,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98069,37.63,0.15,336,41049,70,NULL,NULL,'2MASX J12382073+1532220',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000162,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,189.586291667,15.53956,0.01,NULL,58887754443,920121163,14376893,18.1),(98070,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98070,31.5,0.43,20,41050,75,NULL,'3.6 micron, color + selection bias corrected','UGC 07802',NULL,'2014MNRAS.444..527S',2014,1,1.18,NULL,'G',0.000003,NULL,'14.9g',0.33,'Sdm            HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,189.58675,7.89131,0,NULL,58194813748,909293964,14207718,14.9),(98071,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98071,31.6,0.43,20.9,41050,75,NULL,'3.6 micron, color corrected','UGC 07802',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98072,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98072,31.62,0.2,21.1,41050,74.4,NULL,NULL,'UGC 07802',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98073,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98073,31.81,0.56,23.1,41050,NULL,NULL,'Malmquist cor.','UGC 07802',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98074,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98074,31.83,0.56,23.2,41050,NULL,NULL,NULL,'UGC 07802',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98075,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98075,31.99,NULL,25,41050,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07802',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98076,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98076,32.01,NULL,25.2,41050,NULL,NULL,'Dipole + Quadrupole','UGC 07802',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98077,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98077,32.01,NULL,25.3,41050,NULL,NULL,'Dipole','UGC 07802',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98078,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98078,32.09,NULL,26.2,41050,NULL,NULL,NULL,'UGC 07802',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98079,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98079,32.22,0.49,27.7,41050,75,NULL,'IR','UGC 07802',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98080,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98080,35.93,0.33,153,41051,70,NULL,NULL,'VCC 1759',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000113,NULL,'15.5g',0.46,'RS0_1_(0)','Group member',NULL,NULL,NULL,1,189.5932917,9.52833,0,NULL,58200117911,909376842,14209013,15.5),(98081,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98081,37.56,0.46,325,41052,70,NULL,NULL,'2MASX J12382277+3111431',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,189.594875,31.19542,0.017,NULL,58787209428,918550147,14352346,17.7),(98082,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98082,37.16,0.46,270,41053,70,NULL,NULL,'2MASX J12382496+0226357',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,189.604041667,2.44342,0,NULL,58219728463,909683257,14213800,17),(98083,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98083,37.39,0.46,301,41054,70,NULL,NULL,'2MASX J12382542+4245326',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,189.605917,42.75917,0,NULL,59118639095,923728735,14433261,17.9),(98084,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98084,37.19,0.46,274,41055,70,NULL,NULL,'2MASX J12382687+0852462',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000154,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,189.612167,8.87958,0,NULL,58196482018,909320031,14208125,17.2),(98085,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98085,33.37,0.43,47.3,41056,75,NULL,'3.6 micron, color + selection bias corrected','ESO 322- G 040',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.00014,NULL,'14.23',0.6,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,189.617417,-40.36781,0.465,NULL,46746351187,730411737,11412683,14.23),(98086,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98086,38.25,0.46,446,41057,70,NULL,NULL,'SDSS J123828.29+110121.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,189.617875,11.02258,0,NULL,58185432352,909147380,14205427,18.1),(98087,'Tully est','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98087,31.22,0.8,17.5,41058,75,NULL,'B','NGC 4586',NULL,'1988NBGC.C....0000T',1988,1,2.9,NULL,'G',0.000017,NULL,'12.7g',0.99,'SA(s)a: sp     Sy','in a radial-velocity based grouping',NULL,NULL,NULL,1,189.618333,4.31908,0.009,NULL,58230082873,909845044,14216328,12.7),(98088,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98088,30.4,NULL,12,41058,NULL,NULL,NULL,'NGC 4586',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98089,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98089,30.77,0.36,14.3,41058,NULL,NULL,NULL,'NGC 4586',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98090,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98090,31.06,0.45,16.3,41058,NULL,NULL,'K','NGC 4586',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98091,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98091,31.08,0.47,16.4,41058,NULL,NULL,'H','NGC 4586',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98092,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98092,31.13,0.46,16.8,41058,NULL,NULL,'J','NGC 4586',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98093,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98093,31.59,0.4,20.8,41058,NULL,NULL,'mean','NGC 4586',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98094,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98094,34.81,0.47,91.7,41059,70,NULL,NULL,'AM 1235-284 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00011,NULL,'16',0.2,'S0',NULL,NULL,NULL,NULL,1,189.618833,-28.93828,0.337,NULL,43425578156,678524658,10601947,16),(98095,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98095,38.14,0.46,425,41060,70,NULL,NULL,'2MASX J12382858+4954495',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,189.6190417,49.91381,0,NULL,57202553362,893789896,13965467,17.6),(98096,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98096,37.6,0.46,330,41061,70,NULL,NULL,'2MASX J12382917+5012595',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000168,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,189.621708333,50.21661,0,NULL,57202447253,893788238,13965441,17),(98097,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98097,38.2,0.46,437,41062,70,NULL,NULL,'SDSS J123830.31+313600.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000164,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,189.6262917,31.60017,0.011,NULL,58784583944,918509124,14351705,18.1),(98098,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98098,38.25,0.46,447,41063,70,NULL,NULL,'MCG +09-21-026',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000176,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,189.62725,53.45508,0,NULL,57227760489,894183757,13971621,16.5),(98099,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98099,37.16,0.46,270,41064,70,NULL,NULL,'2MASX J12383119+3638290',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,189.629875,36.64139,0,NULL,58568953011,915139890,14299060,17.7),(98100,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98100,37.75,0.27,356,41065,70,NULL,NULL,'SDSS J123832.10+413601.1',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,189.63375,41.60033,0,NULL,59114896389,923670256,14432347,17.5),(98101,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98101,36.73,0.59,221,41066,70,NULL,NULL,'2MASX J12383253-1031580',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,189.635625,-10.53272,0.081,NULL,43165085358,674454458,10538350,15.5),(98102,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98102,37.68,0.27,343,41067,70,NULL,NULL,'2MASX J12383309+0653352',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,189.63775,6.89319,0,NULL,58241677212,910026206,14219159,17.3),(98103,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98103,37.89,0.46,379,41068,70,NULL,NULL,'2MASX J12383456+6529069',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000134,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,189.6439583,65.48525,0.049,NULL,57323442823,895678794,13994981,18.2),(98104,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98104,36.93,0.46,243,41069,70,NULL,NULL,'2MASX J12383520+0854392',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,189.646667,8.91081,0,NULL,58196467236,909319800,14208121,17.1),(98105,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98105,36.98,0.46,249,41070,70,NULL,NULL,'2MASX J12383536+1716482',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,189.6472917,17.28011,0.033,NULL,58876714196,919948659,14374197,NULL),(98106,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98106,31.17,0.45,17.2,41071,NULL,NULL,'K','NGC 4587',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000097,NULL,'14.49',0.5,'SA(r)0^0^:','in a radial-velocity based grouping',NULL,NULL,NULL,1,189.647583333,2.65733,0.031,NULL,58219807762,909684496,14213820,14.49),(98107,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98107,31.44,0.4,19.4,41071,NULL,NULL,'mean','NGC 4587',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98108,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98108,37.11,0.33,264,41072,70,NULL,NULL,'2MASX J12383558+4224046',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,189.6484583,42.40139,0,NULL,59118700759,923729699,14433276,17.3),(98109,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98109,34.03,0.49,64,41073,75,NULL,'IR','UGC 07806',NULL,'2011yCatp016004901K',2011,1,1.83,'The UZC position is 11 arcsec southeast of the galaxy\'s center.','G',0.000015,NULL,'15.3g',0.3,'SBcd: sp','Group member',NULL,NULL,NULL,1,189.649666667,1.40228,0,NULL,58002534101,906289595,14160774,15.3),(98110,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98110,34.08,NULL,65.6,41073,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07806',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98111,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98111,34.09,NULL,65.9,41073,NULL,NULL,'Dipole + Quadrupole','UGC 07806',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98112,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98112,34.09,NULL,65.9,41073,NULL,NULL,'Dipole','UGC 07806',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98113,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98113,34.16,NULL,67.8,41073,NULL,NULL,NULL,'UGC 07806',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98114,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98114,34.25,0.2,70.8,41073,74.4,NULL,NULL,'UGC 07806',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98115,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98115,34.36,0.4,74.5,41073,NULL,NULL,'Malmquist cor.','UGC 07806',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98116,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98116,34.38,0.4,75,41073,NULL,NULL,NULL,'UGC 07806',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98117,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98117,37.87,0.46,376,41074,70,NULL,NULL,'2MASX J12383718+0310597',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,189.6547917,3.18339,0.06,NULL,58232703823,909885997,14216968,17.8),(98118,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98118,34.11,NULL,66.5,41075,NULL,NULL,'Dipole','IC 3608',NULL,'2010Ap&SS.325..163P',2010,1,1.32,NULL,'G',0.000005,NULL,'15.3g',0.4,'Sc','Group member',NULL,NULL,NULL,1,189.655541667,10.47589,0,NULL,58198692867,909354576,14208665,15.3),(98119,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98119,34.13,NULL,67.1,41075,NULL,NULL,'Dipole + Quadrupole','IC 3608',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98120,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98120,34.15,NULL,67.6,41075,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 3608',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98121,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98121,34.36,NULL,74.3,41075,NULL,NULL,NULL,'IC 3608',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98122,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98122,35.28,0.4,114,41075,NULL,NULL,'mean','IC 3608',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98123,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98123,35.45,0.47,123,41075,NULL,NULL,'H','IC 3608',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98124,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98124,35.51,0.45,126,41075,NULL,NULL,'K','IC 3608',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98125,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98125,35.83,0.38,146,41075,NULL,NULL,'Malmquist cor.','IC 3608',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98126,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98126,35.85,0.2,148,41075,74.4,NULL,NULL,'IC 3608',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98127,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98127,36.08,0.34,165,41075,NULL,NULL,NULL,'IC 3608',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98128,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98128,38.13,0.33,423,41076,70,NULL,NULL,'2MASX J12383831+0752302',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000155,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,189.659708333,7.87497,0,NULL,58194806788,909293856,14207716,17.4),(98129,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98129,37.88,0.46,376,41077,70,NULL,NULL,'2MASX J12383830+6333524',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000169,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,189.659875,63.56456,0,NULL,57374473966,896476155,14007439,17.8),(98130,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98130,38.05,0.46,407,41078,70,NULL,NULL,'2MASX J12383854+2318147',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,189.66075,23.30419,0.076,NULL,58894544965,920227265,14378551,17),(98131,'Brightest Stars','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98131,27.44,NULL,3.1,41079,NULL,NULL,NULL,'UGCA 292',NULL,'1998A&AS..128..459M',1998,1,1,NULL,'G',0.000002,NULL,'16.00',0.7,'ImIV-V','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,189.666916667,32.76681,0.02,NULL,58773632353,918338005,14349031,16),(98132,'CMD','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98132,27.54,NULL,3.22,41079,NULL,NULL,NULL,'UGCA 292',NULL,'2012ApJ...748...47M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98133,'TRGB','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98133,27.79,0.04,3.61,41079,NULL,NULL,'I','UGCA 292',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98134,'TRGB','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98134,27.79,0.05,3.62,41079,NULL,NULL,'I','UGCA 292',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98135,'TRGB','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98135,27.88,0.08,3.77,41079,74.4,NULL,NULL,'UGCA 292',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98136,'Tully est','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98136,27.77,0.8,3.6,41079,75,NULL,NULL,'UGCA 292',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98137,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98137,37.65,0.46,340,41080,70,NULL,NULL,'2MASX J12384020+0410104',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000192,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,189.6675417,4.16969,0.009,NULL,58233175178,909893362,14217083,16.9),(98138,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98138,37.5,0.46,317,41081,70,NULL,NULL,'2MASX J12384019+6544400',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,189.667833,65.74464,0.049,NULL,57323406967,895678233,13994972,17.3),(98139,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98139,36.1,0.46,166,41082,70,NULL,NULL,'SDSS J123840.78+134402.2',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000186,NULL,'15.7g',0.38,NULL,NULL,NULL,NULL,NULL,1,189.669917,13.73397,0.064,NULL,58874322441,919911288,14373613,15.7),(98140,'IRAS','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98140,33.67,0.8,54.3,41083,75,NULL,'MAT, I','ESO 322- G 042',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000033,NULL,'14.48',0.6,'SB(r)bc:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,189.6705,-42.21422,0.549,NULL,46766272074,730723001,11417546,14.48),(98141,'IRAS','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98141,33.69,0.8,54.8,41083,75,NULL,'HMCL, I','ESO 322- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98142,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98142,32.37,0.2,29.8,41083,74.4,NULL,NULL,'ESO 322- G 042',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98143,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98143,32.39,0.32,30,41083,85,NULL,'I, raw','ESO 322- G 042',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98144,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98144,32.39,0.32,30,41083,85,NULL,'I, inv','ESO 322- G 042',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98145,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98145,32.6,0.4,33,41083,75,NULL,'HMCL, I, raw','ESO 322- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98146,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98146,32.65,0.43,33.9,41083,75,NULL,'MAT, I, raw','ESO 322- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98147,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98147,32.67,0.4,34.3,41083,75,NULL,'HMCL, I, inv','ESO 322- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98148,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98148,32.71,0.38,34.8,41083,NULL,NULL,NULL,'ESO 322- G 042',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98149,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98149,32.73,0.43,35.2,41083,75,NULL,'MAT, I, inv','ESO 322- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98150,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98150,32.94,0.4,38.7,41083,75,NULL,'HMCL, I, cor','ESO 322- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98151,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98151,33.02,0.43,40.1,41083,75,NULL,'MAT, I, cor','ESO 322- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98152,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98152,33.09,0.49,41.4,41083,75,NULL,'IR','ESO 322- G 042',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98153,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98153,33.39,0.11,47.7,41083,NULL,NULL,NULL,'ESO 322- G 042',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98154,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98154,37.03,0.46,255,41084,70,NULL,NULL,'SDSS J123842.87-001953.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000069,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,189.678625,-0.33139,0.03,NULL,42986947416,671671053,10494860,17.9),(98155,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98155,37.44,0.46,308,41085,70,NULL,NULL,'2MASX J12384305+0235004',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000142,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,189.679333,2.58333,0,NULL,58219822648,909684728,14213823,17.5),(98156,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98156,37.3,0.46,288,41086,70,NULL,NULL,'2MASX J12384315+6231144',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,189.679875,62.52044,0,NULL,57377262623,896519728,14008120,18.2),(98157,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98157,37.34,0.46,294,41087,70,NULL,NULL,'2MASX J12384393+6308520',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,189.683333,63.14786,0,NULL,57377514479,896523663,14008182,17.3),(98158,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98158,38.13,0.33,423,41088,70,NULL,NULL,'SDSS J123844.09+075158.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,189.68375,7.86617,0,NULL,58194298725,909285917,14207592,18),(98159,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98159,37.7,0.27,346,41089,70,NULL,NULL,'2MASX J12384410+0615042',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,189.683875,6.25111,0,NULL,58241540110,910024064,14219126,17.1),(98160,'IRAS','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98160,34.43,0.8,77,41090,75,NULL,'CF, r','NGC 4588',NULL,'1997ApJS..109..333W',1997,1,1.15,NULL,'G',0.00001,NULL,'15.0g',0.48,'Sc(s)I-II','Group member',NULL,NULL,NULL,1,189.6892917,6.76817,0,NULL,58242073277,910032394,14219256,15),(98161,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98161,34.04,0.38,64.3,41090,75,NULL,'CF, r, raw','NGC 4588',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98162,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98162,34.08,0.38,65.5,41090,75,NULL,'CF, r, inv','NGC 4588',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98163,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98163,34.19,0.49,68.7,41090,75,NULL,'IR','NGC 4588',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98164,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98164,34.32,0.38,73,41090,75,NULL,'CF, r, cor','NGC 4588',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98165,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98165,34.42,0.2,76.6,41090,74.4,NULL,NULL,'NGC 4588',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98166,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98166,34.43,0.53,76.8,41090,NULL,NULL,'Malmquist cor.','NGC 4588',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98167,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98167,34.48,0.52,78.6,41090,NULL,NULL,NULL,'NGC 4588',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98168,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98168,37.54,0.23,322,41091,70,NULL,NULL,'2MASX J12384681+1715152',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.15',0.17,NULL,NULL,NULL,NULL,NULL,1,189.695041667,17.25431,0.033,NULL,58876719155,919948736,14374199,17.15),(98169,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98169,36.5,0.46,200,41092,70,NULL,NULL,'2MASX J12384715+4041457',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000185,NULL,'16.0g',0.39,NULL,NULL,NULL,NULL,NULL,1,189.696375,40.69614,0,NULL,59081698008,923151531,14424242,16),(98170,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98170,37.43,0.46,306,41093,70,NULL,NULL,'2MASX J12384721+1327092',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,189.696791667,13.45269,0.079,NULL,58151478548,908616852,14197138,17.4),(98171,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98171,37.65,0.46,338,41094,70,NULL,NULL,'2MASX J12384761+3512579',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,189.698583,35.21611,0,NULL,58562647063,915041360,14297521,18.1),(98172,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98172,38.64,0.46,535,41095,70,NULL,NULL,'SDSS J123847.82+500523.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,189.699291667,50.08997,0,NULL,57202473041,893788641,13965447,18.4),(98173,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98173,36.66,0.54,215,41096,70,NULL,NULL,'2MASX J12384792-1045120',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.07',NULL,NULL,NULL,NULL,NULL,NULL,1,189.69975,-10.75331,0.081,NULL,43153986083,674281032,10535641,16.07),(98174,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98174,37,0.33,251,41097,70,NULL,NULL,'2MASX J12384865+1745312',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,189.7029583,17.75872,0.035,NULL,58906987928,920421686,14381588,16.7),(98175,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98175,37.21,0.46,276,41098,70,NULL,NULL,'2MASX J12384885+1037112',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000162,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,189.70375,10.61967,0,NULL,58184888606,909138884,14205295,16.8),(98176,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98176,37.42,0.16,305,41099,70,NULL,NULL,'2MASX J12385128+1353302',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,189.7137083,13.89158,0.064,NULL,58874300502,919910945,14373608,17.4),(98177,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98177,37.38,0.46,300,41100,70,NULL,NULL,'2MASX J12385177+2505151',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,189.715708333,25.08756,0.036,NULL,58618599503,915915617,14311181,16.7),(98178,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98178,36.81,0.46,230,41101,70,NULL,NULL,'2MASX J12385444+4325119',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000174,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,189.72675,43.42006,0,NULL,59117345114,923708517,14432945,16.6),(98179,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98179,38.44,0.46,487,41102,70,NULL,NULL,'2MASX J12385590+0834582',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,189.733,8.58292,0,NULL,58194497070,909289016,14207640,17.5),(98180,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98180,38.34,0.46,466,41103,70,NULL,NULL,'VII Zw 476',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000191,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,189.73575,60.76456,0,NULL,57361883806,896279434,14004366,17.5),(98181,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98181,37.25,0.15,282,41104,70,NULL,NULL,'2MASX J12385738+1653312',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.94',0.17,NULL,NULL,NULL,NULL,NULL,1,189.739167,16.89206,0.021,NULL,58876597118,919946829,14374169,17.94),(98182,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98182,37.25,0.15,282,41105,70,NULL,NULL,'2MASX J12385765+1646282',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.36',0.17,NULL,NULL,NULL,NULL,NULL,1,189.740333,16.77469,0.021,NULL,58884024359,920062880,14375982,17.36),(98183,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2008bz','R',98183,37.06,0.08,258,41106,NULL,NULL,'MLCS2k2, R(V) = 1.8','2MASX J12385810+1107502',NULL,'2015Sci...347.1459K',2015,1,0.59,NULL,'G',0.000165,NULL,'16.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,189.7422083,11.13056,0.009,NULL,58185332341,909145817,14205403,16.6),(98184,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2008bz','R',98184,37.1,0.08,263,41106,NULL,NULL,'MLCS2k2, R(V) = 3.1','2MASX J12385810+1107502',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98185,'SNIa','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2008bz',NULL,98185,37.39,0.2,284,41106,73.8,NULL,'SALT 2 (SNANA)','2MASX J12385810+1107502',0.0614,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98186,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98186,37.63,0.27,336,41107,70,NULL,NULL,'2MASX J12385863+1053452',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000163,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,189.7442083,10.89589,0,NULL,58185444024,909147562,14205430,17.1),(98187,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98187,37.74,0.46,353,41108,70,NULL,NULL,'2MASX J12385876+0739022',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,189.7447917,7.65064,0,NULL,58194357799,909286840,14207606,17.3),(98188,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98188,37.54,0.23,322,41109,70,NULL,NULL,'2MASX J12385932+1710316',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,189.747125,17.17531,0.031,NULL,58876752648,919949260,14374207,18),(98189,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98189,37.63,0.15,336,41110,70,NULL,NULL,'2MASX J12390013+1516116',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000208,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,189.750541667,15.26992,0.022,NULL,58887576317,920118379,14376849,16.6),(98190,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98190,37.73,0.27,352,41111,70,NULL,NULL,'2MASX J12390106+0323314',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,189.754417,3.39203,0.043,NULL,58232754233,909886784,14216981,17.8),(98191,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98191,37.7,0.27,346,41112,70,NULL,NULL,'SDSS J123901.07+060841.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000153,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,189.7544583,6.14472,0,NULL,58241544991,910024140,14219127,18.4),(98192,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98192,35.12,0.46,106,41113,70,NULL,NULL,'UGC 07813',NULL,'2015arXiv151105856S',2015,1,0.98,NULL,'G',0.000067,NULL,'14.1g',0.97,'E:','Group member',NULL,NULL,NULL,1,189.754667,0.36556,0,NULL,58002486512,906288851,14160763,14.1),(98193,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98193,37.63,0.15,336,41114,70,NULL,NULL,'SDSS J123901.91+152040.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,189.758,15.3445,0.019,NULL,58887627740,920119183,14376862,18.5),(98194,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98194,37.75,0.27,356,41115,70,NULL,NULL,'2MASX J12390228+4132327',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000148,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,189.7597083,41.54239,0,NULL,59115012709,923672073,14432376,17.5),(98195,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98195,38.29,0.46,454,41116,70,NULL,NULL,'2MASX J12390332+2145523',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,189.763916667,21.76444,0.116,NULL,58901164711,920330698,14380167,17),(98196,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98196,37.63,0.27,336,41117,70,NULL,NULL,'2MASX J12390372+1057327',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000152,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,189.765417,10.95903,0,NULL,58185468444,909147944,14205436,17.3),(98197,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98197,36.17,0.6,171,41118,70,NULL,NULL,'LCRS B123629.1-054541',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'14.88',0.36,NULL,NULL,NULL,NULL,NULL,1,189.766583,-6.03611,0.029,NULL,43213421083,675209704,10550151,14.88),(98198,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98198,36.53,0.46,202,41119,70,NULL,NULL,'2MASX J12390421+0058164',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000091,NULL,'16.3g',0.37,'AGN',NULL,NULL,NULL,NULL,1,189.767583,0.97117,0,NULL,58002699266,906292176,14160815,16.3),(98199,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98199,30.82,0.14,14.6,41120,74.4,NULL,NULL,'IC 3612',NULL,'2013AJ....146...86T',2013,1,1.07,NULL,'G',0.000085,NULL,'15.2g',0.47,'dS0   :','Group member',NULL,NULL,NULL,1,189.769583,14.73114,0.034,NULL,58885341832,920083466,14376304,15.2),(98200,'SBF','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98200,30.84,0.14,14.7,41120,NULL,NULL,'HST ACS VCS','IC 3612',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98201,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98201,35.77,0.33,143,41121,70,NULL,NULL,'2MASX J12390478+5924292',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000177,NULL,'15.7g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,189.770041667,59.40814,0,NULL,57403748240,896933566,14014586,15.7),(98202,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98202,35.52,0.5,127,41122,70,NULL,NULL,'2MASX J12390519-2011174',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'15.70',NULL,NULL,NULL,NULL,NULL,NULL,1,189.77175,-20.18825,0.089,NULL,43941649108,686588267,10727941,15.7),(98203,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98203,37.29,0.46,287,41123,70,NULL,NULL,'SDSS J123905.93+550318.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00016,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,189.774708333,55.05508,0.021,NULL,57399934439,896873975,14013655,18.5),(98204,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98204,37.73,0.27,352,41124,70,NULL,NULL,'2MASX J12390600+0326154',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.29',0.12,NULL,NULL,NULL,NULL,NULL,1,189.774917,3.43769,0.043,NULL,58232785701,909887276,14216988,18.29),(98205,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98205,37.75,0.27,356,41125,70,NULL,NULL,'2MASX J12390672+4126137',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000168,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,189.7782917,41.43717,0,NULL,59114813510,923668961,14432327,17.9),(98206,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98206,37.63,0.15,336,41126,70,NULL,NULL,'2MASX J12390683+1521306',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000193,NULL,'16.0g',0.37,NULL,NULL,NULL,NULL,NULL,1,189.778583,15.35844,0.019,NULL,58887595002,920118671,14376854,16),(98207,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98207,38.82,0.46,581,41127,70,NULL,NULL,'2MASX J12390734+1719006',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,189.7805417,17.31686,0.033,NULL,58876649316,919947645,14374181,18.2),(98208,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98208,38.6,0.46,524,41128,70,NULL,NULL,'2MASX J12390861+0131404',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000184,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,189.785875,1.52781,0,NULL,58219312835,909676763,14213699,18.1),(98209,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98209,37.42,0.16,305,41129,70,NULL,NULL,'2MASX J12390961+1346146',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,189.790166667,13.77075,0.086,NULL,58874318468,919911226,14373612,18),(98210,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98210,37.58,0.46,328,41130,70,NULL,NULL,'SDSS J123909.72+382115.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000153,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,189.790541667,38.35442,0,NULL,58559432637,914991134,14296736,18),(98211,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98211,37.11,0.46,265,41131,70,NULL,NULL,'2MASX J12390997+2434464',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'18.69',NULL,NULL,NULL,NULL,NULL,NULL,1,189.791667,24.57956,0.023,NULL,58616904276,915889129,14310767,18.69),(98212,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98212,37.7,0.27,346,41132,70,NULL,NULL,'2MASX J12391032+0615457',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000186,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,189.792917,6.26286,0,NULL,58241526719,910023854,14219122,17.3),(98213,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98213,37.25,0.15,282,41133,70,NULL,NULL,'2MASX J12391083+1618236',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.09',0.16,NULL,NULL,NULL,NULL,NULL,1,189.79525,16.30658,0.009,NULL,58884863086,920075985,14376187,18.09),(98214,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98214,37.25,0.15,282,41134,70,NULL,NULL,'2MASX J12391097+1617426',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,189.795875,16.29522,0.009,NULL,58884851723,920075808,14376184,NULL),(98215,'SNII optical','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003ej',NULL,98215,34.42,0.12,76.6,41135,NULL,NULL,'I, photospheric magnitude method','UGC 07820',NULL,'2014AJ....148..107R',2014,1,1.28,'The APM position refers to a knot just north of the bar.','G',0.000017,NULL,'14.5g',0.94,'SAB(s)cd:',NULL,NULL,NULL,NULL,1,189.797416667,0.71747,0.005,NULL,58002770403,906293287,14160832,14.5),(98216,'SNII optical','2016-12-15 15:15:03','2016-12-16 11:20:14','1','SN 2003ej',NULL,98216,34.45,0.19,77.6,41135,NULL,NULL,'V, photospheric magnitude method','UGC 07820',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98217,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98217,37,0.33,251,41136,70,NULL,NULL,'2MASX J12391174+1743306',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,189.799,17.72522,0.033,NULL,58907859488,920435304,14381801,17.4),(98218,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98218,37.73,0.27,352,41137,70,NULL,NULL,'2MASX J12391178+0327019',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000178,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,189.799125,3.45056,0.043,NULL,58232796539,909887445,14216991,17.1),(98219,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98219,37.7,0.33,347,41138,70,NULL,NULL,'2MASX J12391225+0919347',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000179,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,189.80125,9.32633,0,NULL,58199998600,909374978,14208984,17.4),(98220,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98220,37.89,0.46,379,41139,70,NULL,NULL,'2MASX J12391231+0942347',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000176,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,189.801333,9.70967,0,NULL,58199196141,909362439,14208788,17.6),(98221,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98221,32.78,0.4,36.1,41140,NULL,NULL,'mean','NGC 4577',NULL,'2007A&A...465...71T',2007,1,1.6,'Identification as NGC 4577 is uncertain.','G',0.000023,NULL,'13.8g',0.8,'Sb             HII','Group member',NULL,NULL,NULL,1,189.801833,6.01231,0,NULL,58241367869,910021372,14219083,13.8),(98222,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98222,33.19,0.36,43.5,41140,NULL,NULL,NULL,'NGC 4577',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98223,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98223,33.5,0.47,50.1,41140,NULL,NULL,'H','NGC 4577',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98224,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98224,33.52,0.46,50.6,41140,NULL,NULL,'J','NGC 4577',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98225,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98225,33.53,0.45,50.7,41140,NULL,NULL,'K','NGC 4577',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98226,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98226,33.8,0.3,57.4,41140,55,NULL,'B','NGC 4577',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98227,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98227,37.7,0.33,347,41141,70,NULL,NULL,'2MASX J12391266+0919117',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,'PRED','17.39',0.14,'BrClG',NULL,NULL,NULL,NULL,1,189.80275,9.31983,0,NULL,58199998712,909374979,14208984,17.39),(98228,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98228,37.06,0.46,258,41142,70,NULL,NULL,'2MASX J12391261+3604256',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,189.80275,36.07383,0,NULL,58562230465,915034851,14297419,17.1),(98229,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98229,38.2,0.46,437,41143,70,NULL,NULL,'2MASX J12391302+2114332',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,189.8042917,21.24244,0.161,NULL,58901474122,920335533,14380242,18.2),(98230,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98230,37.68,0.27,343,41144,70,NULL,NULL,'2MASX J12391440+0641047',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00019,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,189.809958333,6.68461,0,NULL,58241868937,910029202,14219206,16.7),(98231,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98231,36.5,0.46,199,41145,70,NULL,NULL,'2MASX J12391491+5931412',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,189.811916667,59.52819,0,NULL,57403734518,896933351,14014583,17),(98232,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98232,37.87,0.46,375,41146,70,NULL,NULL,'SDSS J123915.31+001746.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000117,NULL,'18.1g',0.18,'NLAGN',NULL,NULL,NULL,'Sy 2',1,189.8137917,0.29636,0,NULL,58002273757,906285527,14160711,18.1),(98233,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98233,36.6,0.46,209,41147,70,NULL,NULL,'2MASX J12391582+0157149',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000193,NULL,'16.1g',0.39,'S0',NULL,NULL,NULL,NULL,1,189.81575,1.95406,0,NULL,58219420045,909678438,14213725,16.1),(98234,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98234,35.04,0.33,102,41148,70,NULL,NULL,'IC 3618',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000031,NULL,'15.1g',0.52,'E',NULL,NULL,NULL,NULL,1,189.821375,26.67778,0.081,NULL,58609136801,915767762,14308871,15.1),(98235,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98235,35.23,0.25,111,41148,74.4,NULL,NULL,'IC 3618',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98236,'FP','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,'R',98236,37.68,0.27,343,41149,70,NULL,NULL,'SDSS J123917.79+063944.9',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000154,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,189.824167,6.6625,0,NULL,58241869344,910029208,14219206,18.7),(98237,'IRAS','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98237,31,0.8,15.8,41150,75,NULL,'A82, H','NGC 4592',NULL,'1997ApJS..109..333W',1997,1,4.04,'Extended HIPASS source','G',0.000007,NULL,'12.5g',0.87,'SA(s)dm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,189.828083333,-0.532,0.078,NULL,42987086720,671673230,10494894,12.5),(98238,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98238,29.8,0.4,9.1,41150,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 4592',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98239,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98239,29.8,0.47,9.11,41150,75,NULL,'A82, H, inv','NGC 4592',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98240,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98240,29.9,0.4,9.6,41150,75,NULL,'B','NGC 4592',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98241,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98241,29.92,0.47,9.63,41150,75,NULL,'A82, H, raw','NGC 4592',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98242,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98242,30.17,0.4,11.6,41150,NULL,NULL,NULL,'NGC 4592',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98243,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98243,30.33,0.43,11.6,41150,75,NULL,'3.6 micron, color corrected','NGC 4592',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98244,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:14','1',NULL,NULL,98244,30.33,0.43,11.6,41150,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4592',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98245,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98245,30.34,0.2,11.7,41150,74.4,NULL,NULL,'NGC 4592',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98246,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98246,30.34,0.47,11.7,41150,75,NULL,'A82, H, cor','NGC 4592',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98247,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98247,30.62,0.48,13.3,41150,NULL,NULL,NULL,'NGC 4592',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98248,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98248,30.85,0.43,14.8,41150,NULL,NULL,'Malmquist cor.','NGC 4592',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98249,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98249,38.51,0.33,504,41151,70,NULL,NULL,'SDSS J123918.85+334737.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,189.828583,33.79381,0,NULL,58745265178,917894768,14342105,18.5),(98250,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98250,35.65,0.25,135,41152,74.4,NULL,NULL,'CGCG 159-043',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000036,NULL,'15.05',0.6,'E2','Group member',NULL,NULL,NULL,1,189.82875,27.7735,0.095,NULL,58730055813,917657122,14338392,15.05),(98251,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98251,37.25,0.15,282,41153,70,NULL,NULL,'2MASX J12392037+1638076',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.71',0.21,NULL,NULL,NULL,NULL,NULL,1,189.8349583,16.63553,0.014,NULL,58884700469,920073444,14376147,16.71),(98252,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98252,37.35,0.46,295,41154,70,NULL,NULL,'SDSS J123920.54+662214.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00007,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,189.835625,66.37056,0.021,NULL,57321018220,895640909,13994389,18.3),(98253,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98253,37.72,0.46,350,41155,70,NULL,NULL,'2MASX J12392148+2743064',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000181,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,189.8395,27.71836,0.095,NULL,58730063423,917657240,14338394,17.3),(98254,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98254,37.54,0.23,322,41156,70,NULL,NULL,'2MASX J12392186+1711576',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.00',0.21,NULL,NULL,NULL,NULL,NULL,1,189.841083,17.19931,0.031,NULL,58876697890,919948404,14374193,17),(98255,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98255,36.9,0.33,240,41157,70,NULL,NULL,'2MASX J12392194+1722276',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.4g',0.13,'AGN',NULL,NULL,NULL,NULL,1,189.841541667,17.37436,0.033,NULL,58876685452,919948210,14374190,17.4),(98256,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98256,37.94,0.46,387,41158,70,NULL,NULL,'2MASXi J1239229+484924',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000142,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,189.845791667,48.82347,0,NULL,59093572152,923337064,14427141,17.6),(98257,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98257,29.76,1.33,8.96,41159,NULL,NULL,NULL,'IC 3617',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000005,NULL,'14.37',0.7,'SBmIII/BCD     HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,189.854167,7.96583,0,NULL,58194720871,909292513,14207695,14.37),(98258,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98258,30.73,0.85,14,41159,NULL,NULL,'Malmquist cor.','IC 3617',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98259,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98259,30.83,0.43,14.7,41159,75,NULL,'3.6 micron, color + selection bias corrected','IC 3617',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98260,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98260,30.89,0.2,15.1,41159,74.4,NULL,NULL,'IC 3617',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98261,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98261,30.92,0.43,15.2,41159,75,NULL,'3.6 micron, color corrected','IC 3617',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98262,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98262,31.13,0.4,16.8,41159,75,NULL,'B','IC 3617',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98263,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98263,31.49,0.36,19.9,41159,NULL,NULL,NULL,'IC 3617',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98264,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98264,38,0.46,399,41160,70,NULL,NULL,'2MASX J12392630+1245416',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,189.859541667,12.76175,0.08,NULL,58153617277,908650269,14197660,17.5),(98265,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98265,37.76,0.46,357,41161,70,NULL,NULL,'SDSS J123927.15+105513.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000136,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,189.863125,10.92044,0,NULL,58185269291,909144832,14205388,18.3),(98266,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98266,37.54,0.23,322,41162,70,NULL,NULL,'SDSS J123927.38+171108.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,189.864125,17.18561,0.031,NULL,58876697487,919948398,14374193,18),(98267,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98267,34.51,0.25,79.8,41163,74.4,NULL,NULL,'IC 3623',NULL,'2013AJ....146...86T',2013,1,0.87,NULL,'G',0.000025,NULL,'14.6g',0.67,'E0',NULL,NULL,NULL,NULL,1,189.865083,27.10233,0.081,NULL,58729778415,917652787,14338324,14.6),(98268,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98268,35.04,0.33,102,41163,70,NULL,NULL,'IC 3623',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98269,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98269,37.25,0.15,282,41164,70,NULL,NULL,'2MASX J12392787+1625460',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'16.61',0.17,NULL,NULL,NULL,NULL,NULL,1,189.866125,16.42939,0.014,NULL,58884733396,920073959,14376155,16.61),(98270,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98270,30.44,0.4,12.2,41165,NULL,NULL,NULL,'HIPASS J1239-07',NULL,'2013MNRAS.429.2677K',2013,1,NULL,NULL,'G',0.000041,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,189.86875,-7.13694,0.033,NULL,43213167962,675205749,10550089,NULL),(98271,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98271,37.42,0.16,305,41166,70,NULL,NULL,'2MASX J12392820+1348210',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000162,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,189.867541667,13.80586,0.045,NULL,58874392127,919912376,14373630,17.3),(98272,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98272,37.47,0.46,312,41167,70,NULL,NULL,'2MASX J12392841+1432566',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,189.868333,14.54906,0.031,NULL,58885328540,920083258,14376300,17.6),(98273,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98273,37.25,0.15,282,41168,70,NULL,NULL,'2MASX J12392877+1629300',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,189.869875,16.49164,0.014,NULL,58884739591,920074056,14376157,NULL),(98274,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98274,37.83,0.46,369,41169,70,NULL,NULL,'2MASX J12392880+0446169',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,189.87,4.77136,0,NULL,58222552727,909727386,14214490,NULL),(98275,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98275,37.63,0.15,336,41170,70,NULL,NULL,'2MASX J12392929+1527500',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,189.872,15.46397,0.019,NULL,58887997031,920124953,14376952,17.6),(98276,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98276,37.63,0.15,336,41171,70,NULL,NULL,'2MASX J12392956+1532120',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000161,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,189.873167,15.53675,0.019,NULL,58887784139,920121627,14376900,18.2),(98277,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98277,37.52,0.46,319,41172,70,NULL,NULL,'SDSS J123930.01+103523.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000144,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,189.875083,10.58992,0,NULL,58184900579,909139071,14205297,17.7),(98278,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98278,35.77,0.33,143,41173,70,NULL,NULL,'VII Zw 478',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000172,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,189.875375,59.44969,0,NULL,57403755552,896933680,14014588,16.5),(98279,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98279,37.59,0.33,329,41174,70,NULL,NULL,'2MASX J12393191-0023096',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000095,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,189.882875,-0.38608,0.078,NULL,42983590992,671618609,10494040,17),(98280,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98280,38.06,0.46,410,41175,70,NULL,NULL,'SDSS J123931.99+264244.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000142,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,189.883333,26.71225,0.081,NULL,58729741796,917652215,14338315,18.4),(98281,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98281,37.89,0.46,378,41176,70,NULL,NULL,'2MASX J12393214+3201334',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,189.884125,32.02606,0.021,NULL,58784621686,918509713,14351714,17.4),(98282,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98282,37.59,0.33,329,41177,70,NULL,NULL,'2MASX J12393251-0023376',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000091,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,189.885541667,-0.39375,0.078,NULL,42983591127,671618611,10494040,17),(98283,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98283,38.32,0.46,462,41178,70,NULL,NULL,'2MASX J12393317+3734592',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,189.888333333,37.58317,0,NULL,58567430353,915116099,14298689,17.9),(98284,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98284,37.63,0.15,336,41179,70,NULL,NULL,'IC 3621',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000127,NULL,'16.41',0.25,'BrClG',NULL,NULL,NULL,NULL,1,189.889917,15.50261,0.019,NULL,58887998140,920124970,14376952,16.41),(98285,'IRAS','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98285,34.93,0.8,97,41180,75,NULL,'CF, r','UGC 07823',NULL,'1997ApJS..109..333W',1997,1,1.21,NULL,'G',0.000107,NULL,'14.4g',0.49,'Scd:',NULL,NULL,NULL,NULL,1,189.89,47.62328,0,NULL,59111155107,923611798,14431434,14.4),(98286,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98286,34.57,0.38,82.1,41180,75,NULL,'CF, r, raw','UGC 07823',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98287,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98287,34.7,0.38,87.1,41180,75,NULL,'CF, r, inv','UGC 07823',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98288,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98288,34.96,0.38,98.3,41180,75,NULL,'CF, r, cor','UGC 07823',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98289,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98289,35.24,0.4,112,41180,NULL,NULL,'mean','UGC 07823',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98290,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98290,35.38,0.47,119,41180,NULL,NULL,'H','UGC 07823',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98291,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98291,38.31,0.33,459,41181,70,NULL,NULL,'2MASX J12393466+2235566',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,189.894583,22.59911,0.035,NULL,58903166534,920361977,14380655,18.2),(98292,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98292,37.64,0.46,337,41182,70,NULL,NULL,'SDSS J123934.71+442301.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,189.894667,44.38367,0,NULL,59119683294,923745051,14433516,18.1),(98293,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98293,37.75,0.46,355,41183,70,NULL,NULL,'SDSS J123935.68+024617.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000128,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,189.898708333,2.77156,0.014,NULL,58219574383,909680849,14213763,18.2),(98294,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98294,34.31,0.53,72.9,41184,NULL,NULL,'Malmquist cor.','ESO 268- G 029',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'15.51',0.4,'SB(s)d? sp',NULL,NULL,NULL,NULL,1,189.9025,-42.89444,0.477,NULL,46765622803,730712856,11417388,15.51),(98295,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98295,34.5,0.49,79.5,41184,NULL,NULL,NULL,'ESO 268- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98296,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98296,34.54,0.2,80.9,41184,74.4,NULL,NULL,'ESO 268- G 029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98297,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98297,34.55,0.49,81.5,41184,75,NULL,'IR','ESO 268- G 029',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98298,'IRAS','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98298,33.49,0.8,49.8,41185,75,NULL,'MAT, I','NGC 4603A',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000022,NULL,'14.21',0.6,'SA(s)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,189.903833333,-40.74003,0.501,NULL,46746014923,730406483,11412601,14.21),(98299,'IRAS','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98299,33.57,0.8,51.7,41185,75,NULL,'HMCL, I','NGC 4603A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98300,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98300,32.29,0.32,28.7,41185,85,NULL,'I, raw','NGC 4603A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98301,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98301,32.3,0.32,28.9,41185,85,NULL,'I, inv','NGC 4603A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98302,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98302,32.41,0.38,30.3,41185,NULL,NULL,NULL,'NGC 4603A',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98303,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98303,32.43,0.43,30.6,41185,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4603A',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98304,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98304,32.52,0.43,31.9,41185,75,NULL,'MAT, I, raw','NGC 4603A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98305,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98305,32.54,0.4,32.2,41185,75,NULL,'HMCL, I, raw','NGC 4603A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98306,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98306,32.58,0.43,32.8,41185,75,NULL,'3.6 micron, color corrected','NGC 4603A',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98307,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98307,32.64,0.43,33.7,41185,75,NULL,'MAT, I, inv','NGC 4603A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98308,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98308,32.64,0.4,33.7,41185,75,NULL,'HMCL, I, inv','NGC 4603A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98309,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98309,32.7,0.2,34.7,41185,74.4,NULL,NULL,'NGC 4603A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98310,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98310,32.89,0.4,37.9,41185,75,NULL,'HMCL, I, cor','NGC 4603A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98311,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98311,32.91,0.43,38.1,41185,75,NULL,'MAT, I, cor','NGC 4603A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98312,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98312,32.96,0.47,39.1,41185,NULL,NULL,'H','NGC 4603A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98313,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98313,33.08,0.45,41.4,41185,NULL,NULL,'K','NGC 4603A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98314,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98314,33.14,0.46,42.5,41185,NULL,NULL,'J','NGC 4603A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98315,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98315,33.39,0.11,47.7,41185,NULL,NULL,NULL,'NGC 4603A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98316,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98316,33.58,0.4,52,41185,NULL,NULL,'mean','NGC 4603A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98317,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98317,37.42,0.16,305,41186,70,NULL,NULL,'2MASX J12393692+1346061',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000177,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,189.9037917,13.76844,0.086,NULL,58874358422,919911850,14373622,17.7),(98318,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98318,37.63,0.15,336,41187,70,NULL,NULL,'2MASX J12393703+1537491',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000175,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,189.9042083,15.63028,0.023,NULL,58887792799,920121762,14376902,17),(98319,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98319,37.38,0.33,299,41188,70,NULL,NULL,'2MASX J12393775+6245190',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000188,NULL,'16.5g',0.33,'AGN',NULL,NULL,NULL,NULL,1,189.907375,62.75536,0,NULL,57377107684,896517307,14008082,16.5),(98320,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98320,38.2,0.46,436,41189,70,NULL,NULL,'2MASX J12393922+2133395',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,189.913333,21.56111,0.116,NULL,58901393923,920334280,14380223,18),(98321,'AGN time lag','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98321,33.96,0.09,61.9,41190,NULL,NULL,NULL,'NGC 4593',NULL,'2014ApJ...784L..11Y',2014,1,3.9,NULL,'G',0.000127,NULL,'11.67',2.9,'(R)SB(rs)b     Sy1','Group non-member, background',NULL,NULL,'Sy',1,189.9142917,-5.34425,0.041,NULL,43178632284,674666129,10541658,11.67),(98322,'Ring Diameter','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98322,30.4,0.84,12,41190,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4593',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98323,'Sosies','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98323,33.43,0.5,48.5,41190,NULL,NULL,NULL,'NGC 4593',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98324,'Tully est','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98324,32.98,0.8,39.5,41190,75,NULL,'B','NGC 4593',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98325,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98325,32.04,0.45,25.6,41190,NULL,NULL,'K','NGC 4593',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98326,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98326,32.09,0.47,26.2,41190,NULL,NULL,'H','NGC 4593',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98327,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98327,32.12,0.46,26.6,41190,NULL,NULL,'J','NGC 4593',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98328,'Tully-Fisher','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98328,32.85,0.4,37.2,41190,NULL,NULL,'mean','NGC 4593',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98329,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98329,37.9,0.46,381,41191,70,NULL,NULL,'2MASX J12393981+5439379',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000175,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,189.915667,54.66053,0,NULL,57218927885,894045748,13969464,17.3),(98330,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98330,37.9,0.46,380,41192,70,NULL,NULL,'SDSS J123939.92+012009.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000161,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,189.916375,1.33583,0,NULL,57999100499,906235945,14159936,18.4),(98331,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,NULL,98331,36.37,0.53,188,41193,70,NULL,NULL,'2MASX J12394002-1543385',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.93',0.4,NULL,NULL,NULL,NULL,NULL,1,189.916833,-15.72756,0.033,NULL,43939277025,686551203,10727362,15.93),(98332,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98332,37.82,0.33,367,41194,70,NULL,NULL,'2MASX J12394056+0236540',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,189.919,2.61489,0.014,NULL,58220113635,909689275,14213894,17.6),(98333,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98333,36.79,0.46,228,41195,70,NULL,NULL,'2MASX J12394098+5756540',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000171,NULL,'16.1g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,189.92075,57.94814,0,NULL,57405960514,896968133,14015127,16.1),(98334,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98334,38.31,0.33,459,41196,70,NULL,NULL,'SDSS J123941.85+223430.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'19.41',0.12,NULL,NULL,NULL,NULL,NULL,1,189.924375,22.57522,0.097,NULL,58903165464,920361960,14380655,19.41),(98335,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98335,38.05,0.46,408,41197,70,NULL,NULL,'2MASX J12394262+3340153',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,189.927667,33.67111,0,NULL,58744969528,917890148,14342033,17.9),(98336,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98336,37.82,0.33,367,41198,70,NULL,NULL,'2MASX J12394304+0236021',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,189.92925,2.60053,0.014,NULL,58220111618,909689244,14213894,17.2),(98337,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98337,37.12,0.46,266,41199,70,NULL,NULL,'2MASX J12394317+1328391',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,189.929958333,13.47739,0.037,NULL,58873784599,919902884,14373482,16.7),(98338,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98338,37.63,0.15,336,41200,70,NULL,NULL,'2MASX J12394443+1531551',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,189.9349583,15.53197,0.023,NULL,58888005441,920125085,14376954,18.1),(98339,'FP','2016-12-15 15:15:03','2016-12-16 11:20:15','1',NULL,'R',98339,37.86,0.46,374,41201,70,NULL,NULL,'SDSS J123944.78+095552.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,189.936625,9.93111,0,NULL,58199137142,909361517,14208773,18.5),(98340,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98340,37.55,0.46,323,41202,70,NULL,NULL,'2MASX J12394576+0853137',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,189.94075,8.887,0,NULL,58199681869,909370029,14208906,17.6),(98341,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98341,38.51,0.33,504,41203,70,NULL,NULL,'2MASX J12394623+3347203',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000181,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,189.942667,33.78894,0,NULL,58745290626,917895166,14342111,17.6),(98342,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98342,37.85,0.46,372,41204,70,NULL,NULL,'2MASX J12394631+3425573',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,189.942917,34.43267,0,NULL,58744823904,917887873,14341998,17.8),(98343,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98343,37.01,0.46,252,41205,70,NULL,NULL,'2MASX J12394690+0438461',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00017,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,189.945417,4.64628,0,NULL,58222674452,909729288,14214520,17.2),(98344,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98344,36.98,0.67,249,41206,70,NULL,NULL,'2MASX J12394783-1018233',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,189.949417,-10.30647,0.081,NULL,43153651407,674275803,10535559,15.4),(98345,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98345,33.12,0.4,42,41207,NULL,NULL,'mean','IC 3631',NULL,'2007A&A...465...71T',2007,1,1.05,NULL,'G',0.000017,NULL,'14.0g',0.68,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,189.9500417,12.97397,0.08,NULL,58151445752,908616339,14197130,14),(98346,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98346,33.2,0.47,43.6,41207,NULL,NULL,'H','IC 3631',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98347,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98347,36.43,0.46,193,41208,70,NULL,NULL,'LCRS B123714.1-023118',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000092,NULL,'15.9g',0.44,'E0',NULL,NULL,NULL,NULL,1,189.951583,-2.79608,0.029,NULL,43170926332,674545723,10539776,15.9),(98348,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98348,37.63,0.15,336,41209,70,NULL,NULL,'2MASX J12394838+1525591',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,189.9517083,15.43303,0.019,NULL,58888002618,920125040,14376953,18),(98349,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98349,37.51,0.46,317,41210,70,NULL,NULL,'2MASX J12394936+2911012',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000187,NULL,'16.7g',0.31,'E',NULL,NULL,NULL,NULL,1,189.9557083,29.18375,0.07,NULL,58730852617,917669572,14338587,16.7),(98350,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98350,35.79,0.5,144,41211,70,NULL,NULL,'2MASX J12394941-4423240',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.6I',0.4,NULL,NULL,NULL,NULL,NULL,1,189.955833,-44.38994,0.469,NULL,46771585949,730806030,11418844,13.6),(98351,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98351,37.47,0.46,312,41212,70,NULL,NULL,'2MASX J12394976+6544153',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000141,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,189.957375,65.73756,0.049,NULL,57323521102,895680017,13995000,17.7),(98352,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98352,37.77,0.21,358,41213,70,NULL,NULL,'2MASX J12395089+0321161',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,189.9620417,3.35439,0.065,NULL,58232300119,909879689,14216870,18.1),(98353,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98353,37.85,0.46,372,41214,70,NULL,NULL,'2MASX J12395123+5436050',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,189.9635,54.60147,0,NULL,57218718454,894042475,13969413,18),(98354,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98354,36.9,0.33,240,41215,70,NULL,NULL,'2MASX J12395132+1727361',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,189.963791667,17.46022,0.033,NULL,58876626436,919947288,14374176,17.3),(98355,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98355,37.25,0.15,282,41216,70,NULL,NULL,'2MASX J12395137+1624571',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.13',0.15,NULL,NULL,NULL,NULL,NULL,1,189.9640417,16.41589,0.018,NULL,58884450987,920069546,14376086,18.13),(98356,'Tully est','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98356,31.13,0.8,16.8,41217,75,NULL,'B','NGC 4595',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000013,NULL,'12.91',1.1,'SAB(rs)b?      HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,189.9662917,15.29781,0.025,NULL,58887884187,920123190,14376924,12.91),(98357,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98357,27.75,0.69,3.54,41217,100,NULL,'mid-IR','NGC 4595',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98358,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98358,30.29,0.43,11.4,41217,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4595',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98359,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98359,30.45,0.43,12.3,41217,75,NULL,'3.6 micron, color corrected','NGC 4595',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98360,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98360,30.53,0.2,12.8,41217,74.4,NULL,NULL,'NGC 4595',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98361,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98361,30.54,NULL,12.8,41217,NULL,NULL,'B','NGC 4595',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98362,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98362,30.71,0.47,13.9,41217,NULL,NULL,NULL,'NGC 4595',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98363,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98363,30.91,0.43,15.2,41217,NULL,NULL,'Malmquist cor.','NGC 4595',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98364,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98364,30.94,NULL,15.4,41217,NULL,NULL,NULL,'NGC 4595',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98365,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98365,31.03,0.36,16.1,41217,NULL,NULL,NULL,'NGC 4595',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98366,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98366,31.12,0.4,16.8,41217,NULL,NULL,'mean','NGC 4595',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98367,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98367,31.26,0.46,17.9,41217,NULL,NULL,'J','NGC 4595',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98368,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98368,31.31,0.45,18.3,41217,NULL,NULL,'K','NGC 4595',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98369,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98369,31.37,0.47,18.8,41217,NULL,NULL,'H','NGC 4595',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98370,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98370,37.63,0.27,336,41218,70,NULL,NULL,'2MASX J12395202+1059567',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000189,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,189.966916667,10.99903,0,NULL,58185128061,909142625,14205353,16.9),(98371,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98371,37.4,0.46,302,41219,70,NULL,NULL,'2MASX J12395205+1823480',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.1',0.19,NULL,'Group member',NULL,NULL,NULL,1,189.967083,18.39658,0.03,NULL,58908025316,920437895,14381842,17.1),(98372,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98372,35.61,0.58,132,41220,70,NULL,NULL,'2MASX J12395216-4239160',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.4,NULL,NULL,NULL,NULL,NULL,1,189.967333,-42.65442,0.477,NULL,46765523195,730711299,11417364,14.3),(98373,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98373,37.25,0.15,282,41221,70,NULL,NULL,'2MASX J12395228+1637551',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'17.82',0.15,NULL,NULL,NULL,NULL,NULL,1,189.967958333,16.63203,0.019,NULL,58884427200,920069175,14376080,17.82),(98374,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98374,38.4,0.46,480,41222,70,NULL,NULL,'2MASX J12395228-0310013',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000096,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,189.968,-3.16714,0.029,NULL,43181687093,674713860,10542404,18.3),(98375,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98375,36.8,0.46,230,41223,70,NULL,NULL,'2MASX J12395307+1146017',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000178,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,189.9712083,11.76692,0.099,NULL,58153272599,908644884,14197576,16.7),(98376,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98376,37.42,0.46,305,41224,70,NULL,NULL,'2MASX J12395420+4643470',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,189.976,46.72969,0,NULL,59114195678,923659307,14432176,17.4),(98377,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98377,38.05,0.46,407,41225,70,NULL,NULL,'SDSS J123955.25+474529.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,189.98025,47.75831,0,NULL,59111362264,923615035,14431484,18.5),(98378,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98378,37.42,0.16,305,41226,70,NULL,NULL,'2MASX J12395539+1357301',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,189.9807083,13.95831,0.045,NULL,58874365236,919911956,14373624,17.5),(98379,'Faber-Jackson','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98379,29.39,1.25,7.55,41227,95,NULL,'de Vaucouleurs','NGC 4596',NULL,'1984ApJS...56...91D',1984,1,4,NULL,'G',0.000017,NULL,'11.35',3,'SB(r)0+       LINER:','in a radial-velocity based grouping',NULL,NULL,NULL,1,189.983125,10.17614,0,NULL,58198650846,909353919,14208654,11.35),(98380,'Faber-Jackson','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98380,29.84,0.9,9.29,41227,95,NULL,'Weighted Mean','NGC 4596',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98381,'Faber-Jackson','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98381,31.4,1.61,19.1,41227,55,NULL,'Visvanathan & Sandage 1979','NGC 4596',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98382,'Tertiary','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98382,30.49,0.25,12.5,41227,95,NULL,NULL,'NGC 4596',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98383,'Tully est','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98383,31.13,0.8,16.8,41227,75,NULL,'B','NGC 4596',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98384,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98384,37.3,0.46,288,41228,70,NULL,NULL,'SDSS J123957.30+323831.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,189.98875,32.64219,0.034,NULL,58772775113,918324611,14348822,18.2),(98385,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98385,36.8,0.53,229,41229,70,NULL,NULL,'2MASX J12395781-1056315',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.27',NULL,NULL,NULL,NULL,NULL,NULL,1,189.991,-10.94228,0.089,NULL,43153920328,674280005,10535625,16.27),(98386,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98386,29.57,NULL,8.2,41230,NULL,NULL,NULL,'VCC 1816',NULL,'2013AJ....145..101K',2013,1,1,'Multiple SDSS entries describe this source.','G',0.00002,NULL,'16.2',0.5,'ImIV-V','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,189.993666667,13.78142,0.045,NULL,58874355021,919911797,14373621,16.2),(98387,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98387,37.29,0.46,287,41231,70,NULL,NULL,'2MASX J12395885+0230491',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,189.995167,2.51367,0.014,NULL,58220108608,909689197,14213893,17.2),(98388,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98388,28.97,0.19,6.22,41232,NULL,NULL,'blue GCs, TOM(V) = -7.17 mag','MESSIER 104',NULL,'2001AJ....121.2974L',2001,1,8.7,NULL,'G',0.000017,NULL,'8.98',3.5,'SA(s)a;LINER   Sy1.9','Group member, radial-velocity confirmed',NULL,NULL,'unobscured Seyfert 2',1,189.997625,-11.62306,0.117,NULL,43035188055,672424813,10506637,8.98),(98389,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98389,29.52,0.06,8,41232,NULL,NULL,NULL,'MESSIER 104',NULL,'2006AJ....132.1593S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98390,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98390,29.72,0.1,8.79,41232,NULL,NULL,'all GCs, TOM(V) = -7.63 mag','MESSIER 104',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98391,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98391,29.77,0.12,8.99,41232,NULL,NULL,'red GCs, TOM(V) = -7.55 mag','MESSIER 104',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98392,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98392,30,0.2,10,41232,NULL,NULL,'Virgo m-M = 30.8','MESSIER 104',NULL,'1992AJ....103..800B',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98393,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98393,30,0.2,10,41232,NULL,NULL,'GCLF M87','MESSIER 104',NULL,'1996ApJ...458..455F',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98394,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98394,31,0.35,15.8,41232,NULL,NULL,'Virgo m-M = 31.8','MESSIER 104',NULL,'1992AJ....103..800B',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98395,'PNLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98395,29.46,0.08,7.8,41232,NULL,NULL,NULL,'MESSIER 104',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98396,'PNLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98396,29.74,0.06,8.87,41232,NULL,NULL,'93','MESSIER 104',NULL,'1996ApJ...458..455F',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98397,'PNLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98397,29.75,0.11,8.91,41232,NULL,NULL,'HST KP Calibrated','MESSIER 104',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98398,'PNLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98398,29.79,0.07,9.08,41232,NULL,NULL,'I','MESSIER 104',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98399,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98399,29.66,0.08,8.55,41232,NULL,NULL,'I','MESSIER 104',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98400,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98400,29.79,0.18,9.08,41232,NULL,NULL,'I','MESSIER 104',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98401,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98401,29.86,0.09,9.38,41232,NULL,NULL,'I','MESSIER 104',NULL,'1997AJ....114..626A',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98402,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98402,29.95,0.18,9.77,41232,NULL,NULL,'I','MESSIER 104',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98403,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98403,29.99,0.17,9.95,41232,NULL,NULL,'HST KP Calibrated, F814W','MESSIER 104',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98404,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98404,30.01,0.2,10,41232,NULL,NULL,'HST KP Calibrated, I','MESSIER 104',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98405,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98405,30.26,0.12,11.3,41232,74.4,NULL,NULL,'MESSIER 104',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98406,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98406,30.26,0.12,11.3,41232,74.4,NULL,NULL,'MESSIER 104',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98407,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98407,30.5,0.4,12.6,41232,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 3 galaxy group','MESSIER 104',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98408,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98408,30.55,NULL,12.9,41232,75,NULL,'CO','MESSIER 104',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98409,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98409,30.69,0.36,13.7,41232,NULL,NULL,NULL,'MESSIER 104',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98410,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98410,30.73,NULL,14,41232,75,NULL,'HI','MESSIER 104',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98411,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98411,31.2,0.43,17.4,41232,75,NULL,'3.6 micron, color corrected','MESSIER 104',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98412,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98412,31.5,0.4,20,41232,75,NULL,'B','MESSIER 104',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98413,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98413,31.66,NULL,21.5,41232,NULL,NULL,'LEDA [April 2006]','MESSIER 104',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98414,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98414,31.68,0.43,21.7,41232,75,NULL,'3.6 micron, color + selection bias corrected','MESSIER 104',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98415,'Brightest Stars','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98415,28.58,NULL,5.2,41233,NULL,NULL,NULL,'NGC 4605',NULL,'1994BSAO...38....5K',1994,1,5.8,NULL,'G',0.00001,NULL,'10.89',2.2,'SB(s)c pec     HII','Possible group member',NULL,NULL,NULL,1,189.997417,61.60919,0,NULL,57364537570,896320899,14005014,10.89),(98416,'TRGB','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98416,28.69,NULL,5.47,41233,NULL,NULL,NULL,'NGC 4605',NULL,'2006AJ....131.1361K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98417,'TRGB','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98417,28.71,0.04,5.52,41233,NULL,NULL,'I','NGC 4605',NULL,'2007ApJ...661..815R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98418,'TRGB','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98418,28.72,0.1,5.55,41233,74.4,NULL,NULL,'NGC 4605',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98419,'TRGB','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98419,28.78,0.03,5.7,41233,NULL,NULL,'I','NGC 4605',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98420,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98420,27.97,0.36,3.93,41233,NULL,NULL,NULL,'NGC 4605',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98421,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98421,28.02,0.4,4,41233,75,NULL,'B','NGC 4605',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98422,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98422,28.71,NULL,5.52,41233,NULL,NULL,'LEDA [April 2006]','NGC 4605',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98423,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98423,37.83,0.33,369,41234,70,NULL,NULL,'SDSS J124000.77+270340.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000138,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,190.00325,27.06131,0.081,NULL,58729821336,917653458,14338335,18.5),(98424,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98424,37.42,0.16,305,41235,70,NULL,NULL,'2MASX J12400092+1403039',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000168,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,190.004,14.05106,0.045,NULL,58873957661,919905588,14373524,16.9),(98425,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98425,36.11,0.46,167,41236,70,NULL,NULL,'2MASX J12400097+4747050',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000198,NULL,'15.5g',0.48,'E',NULL,NULL,NULL,NULL,1,190.0042083,47.78475,0,NULL,59111360114,923615001,14431484,15.5),(98426,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98426,37.42,0.46,305,41237,70,NULL,NULL,'2MASX J12400110+2408302',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.14',0.21,NULL,NULL,NULL,NULL,NULL,1,190.0047083,24.14169,0.028,NULL,58605103756,915704746,14307886,17.14),(98427,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98427,36.2,0.85,174,41238,70,NULL,NULL,'2MASX J12400128-1121095',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.38',NULL,NULL,NULL,NULL,NULL,NULL,1,190.00525,-11.35281,0.117,NULL,43153403014,674271922,10535498,16.38),(98428,'IRAS','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98428,32.82,0.8,36.7,41239,75,NULL,'MAT, I','ESO 322- G 045',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.37',0.6,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,190.006917,-42.04275,0.557,NULL,46765876307,730716817,11417450,14.37),(98429,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98429,32.2,0.32,27.5,41239,85,NULL,'I, raw','ESO 322- G 045',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98430,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98430,32.21,0.32,27.7,41239,85,NULL,'I, inv','ESO 322- G 045',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98431,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98431,32.42,0.43,30.4,41239,75,NULL,'MAT, I, raw','ESO 322- G 045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98432,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98432,32.52,0.43,32,41239,75,NULL,'MAT, I, inv','ESO 322- G 045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98433,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98433,32.63,0.47,33.6,41239,NULL,NULL,'H','ESO 322- G 045',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98434,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98434,32.72,0.45,34.9,41239,NULL,NULL,'K','ESO 322- G 045',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98435,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98435,32.74,0.46,35.4,41239,NULL,NULL,'J','ESO 322- G 045',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98436,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98436,32.82,0.43,36.7,41239,75,NULL,'MAT, I, cor','ESO 322- G 045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98437,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98437,33.03,0.2,40.4,41239,74.4,NULL,NULL,'ESO 322- G 045',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98438,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98438,33.22,0.4,44.1,41239,NULL,NULL,'mean','ESO 322- G 045',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98439,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98439,33.36,0.11,47.1,41239,NULL,NULL,NULL,'ESO 322- G 045',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98440,'TRGB','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98440,28.75,0.06,5.62,41240,NULL,NULL,'I','SDSS J124001.86+261916.2',NULL,'2014ApJ...785....3M',2014,1,0.21,NULL,'G',0.00003,NULL,'19.50',0.11,NULL,NULL,NULL,NULL,NULL,1,190.0077917,26.32119,0.078,NULL,58617557535,915899336,14310927,19.5),(98441,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98441,37.77,0.21,358,41241,70,NULL,NULL,'2MASX J12400198+0309551',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,190.0082083,3.16536,0.065,NULL,58232359970,909880624,14216884,17.3),(98442,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98442,29.65,NULL,8.51,41242,NULL,NULL,NULL,'BTS 146',NULL,'2013AJ....145..101K',2013,1,0.4,NULL,'G',NULL,NULL,'17.0',NULL,'dE4?;cand. dwarf','Dwarf, within FOV of cluster',NULL,NULL,NULL,1,190.008833,38.00064,0,NULL,58559559450,914993116,14296767,17),(98443,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98443,37.53,0.33,321,41243,70,NULL,NULL,'2MASX J12400295+1750429',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,190.0122083,17.84531,0.04,NULL,58907840056,920435000,14381796,18.4),(98444,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98444,37.56,0.09,324,41244,70,NULL,NULL,'2MASX J12400400+1836590',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'15.8',0.3,NULL,'Group member',NULL,NULL,NULL,1,190.016916667,18.61647,0.03,NULL,58908039631,920438119,14381845,15.8),(98445,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98445,37.43,0.33,306,41245,70,NULL,NULL,'2MASX J12400406+0601173',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000197,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,190.017,6.02142,0,NULL,58241338349,910020911,14219076,16.3),(98446,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98446,37.77,0.21,358,41246,70,NULL,NULL,'SDSS J124004.79+031555.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,190.02,3.26536,0.065,NULL,58232304354,909879755,14216871,18.4),(98447,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98447,37.77,0.21,358,41247,70,NULL,NULL,'SDSS J124005.44+031840.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,190.022666667,3.31125,0.065,NULL,58232333537,909880211,14216878,17.8),(98448,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98448,35.27,0.46,113,41248,70,NULL,NULL,'2MASX J12400595+2837042',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000093,NULL,'17.24',0.28,NULL,NULL,NULL,NULL,NULL,1,190.024917,28.61781,0.09,NULL,58731641924,917681905,14338779,17.24),(98449,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98449,37.13,0.46,267,41249,70,NULL,NULL,'2MASX J12400628+1502419',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,190.0260417,15.04508,0.025,NULL,58887174524,920112101,14376751,17.6),(98450,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98450,38.59,0.46,523,41250,70,NULL,NULL,'SDSS J124006.40+331138.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000168,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,190.0267083,33.194,0,NULL,58742882410,917857537,14341524,18.5),(98451,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98451,37.61,0.46,333,41251,70,NULL,NULL,'SDSS J124007.70+523435.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000138,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,190.032125,52.57656,0.012,NULL,57229580830,894212200,13972065,18.3),(98452,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98452,37.89,0.46,378,41252,70,NULL,NULL,'2MASX J12401001+1547549',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000171,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,190.0417083,15.79875,0.023,NULL,58887367090,920115110,14376798,18.3),(98453,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98453,29.54,NULL,8.09,41253,NULL,NULL,NULL,'VCC 1822',NULL,'2013AJ....145..101K',2013,1,0.67,NULL,'G',0.000033,NULL,'16.7g',0.34,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,190.043375,6.84686,0,NULL,58241617230,910025269,14219144,16.7),(98454,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98454,37.83,0.33,369,41254,70,NULL,NULL,'2MASX J12401049+2711087',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,190.043875,27.18586,0.085,NULL,58730622121,917665970,14338530,17.6),(98455,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98455,37.42,0.46,305,41255,70,NULL,NULL,'2MASX J12401056+1016304',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000176,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,190.044167,10.27514,0,NULL,58184760217,909136878,14205263,17.3),(98456,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98456,31.04,0.14,16.1,41256,74.4,NULL,NULL,'IC 3633',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000127,NULL,'15.5g',0.46,'dE2,N','Group member',NULL,NULL,NULL,1,190.046875,9.89614,0,NULL,58199178255,909362160,14208783,15.5),(98457,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98457,31.05,0.08,16.2,41256,NULL,NULL,NULL,'IC 3633',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98458,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98458,31.06,0.09,16.3,41256,NULL,NULL,'HST ACS VCS','IC 3633',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98459,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98459,37.46,0.46,311,41257,70,NULL,NULL,'2MASX J12401175+3405254',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,190.049,34.09044,0,NULL,58745346152,917896033,14342125,17.7),(98460,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98460,32.17,NULL,27.2,41258,NULL,NULL,NULL,'NGC 4598',NULL,'1999MNRAS.304..595G',1999,1,1.47,NULL,'G',0.000077,NULL,'13.6g',1.06,'SB0','in a radial-velocity based grouping',NULL,NULL,NULL,1,190.0497083,8.38375,0,NULL,58194441209,909288143,14207627,13.6),(98461,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98461,36.68,0.46,217,41259,70,NULL,NULL,'2MASX J12401220+0041446',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000101,NULL,'16.0g',0.42,'E0',NULL,NULL,NULL,NULL,1,190.050833,0.69567,0.006,NULL,57999659936,906244686,14160073,16),(98462,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98462,37.49,0.46,315,41260,70,NULL,NULL,'2MASX J12401260+1008214',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000127,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,190.052417,10.13933,0,NULL,58198596675,909353073,14208641,18),(98463,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98463,37.42,0.16,305,41261,70,NULL,NULL,'SDSS J124012.79+132902.4',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.5g',0.3,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,190.053333,13.48403,0.037,NULL,58873823029,919903484,14373491,16.5),(98464,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98464,30.02,NULL,10.1,41262,NULL,NULL,NULL,'NGC 4597',NULL,'2013AJ....145..101K',2013,1,4.1,'Extended HIPASS source','G',0.000007,NULL,'12.58',1.9,'SB(rs)m','X-ray-faint group member',NULL,NULL,NULL,1,190.053875,-5.79928,0.029,NULL,43209997233,675156206,10549315,12.58),(98465,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98465,30.01,0.4,10.1,41262,NULL,NULL,NULL,'NGC 4597',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98466,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98466,31.15,0.4,17,41262,75,NULL,'B','NGC 4597',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98467,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98467,31.01,0.25,15.9,41263,NULL,NULL,'TOM(g) = -7.2 mag','IC 3635',NULL,'2007ApJS..171..101J',2007,1,0.9,NULL,'G',0.000085,NULL,'15.8g',0.7,'dE,N','Group member',NULL,NULL,NULL,1,190.05575,12.87478,0.08,NULL,58153526851,908648857,14197638,15.8),(98468,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98468,31.01,0.21,15.9,41263,NULL,NULL,'TOM(g) = -7.2 mag','IC 3635',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98469,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98469,31.16,0.28,17,41263,NULL,NULL,'TOM(u) = -8.4 mag','IC 3635',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98470,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98470,31.29,0.2,18.1,41263,NULL,NULL,'TOM(z) = -8.53 mag','IC 3635',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98471,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98471,31.12,0.14,16.8,41263,74.4,NULL,NULL,'IC 3635',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98472,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98472,31.13,0.08,16.8,41263,NULL,NULL,NULL,'IC 3635',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98473,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98473,31.15,0.09,16.9,41263,NULL,NULL,'HST ACS VCS','IC 3635',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98474,'GC radius','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98474,29.71,0.17,8.73,41263,NULL,NULL,NULL,'IC 3635',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98475,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98475,36.94,0.46,244,41264,70,NULL,NULL,'2MASX J12401402+2228300',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,190.058583,22.47494,0.097,NULL,58903173279,920362082,14380657,17.5),(98476,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98476,37.56,0.09,324,41265,70,NULL,NULL,'2MASX J12401441+1837450',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.47',0.17,NULL,'Group member',NULL,NULL,NULL,1,190.060083,18.62925,0.03,NULL,58908034256,920438035,14381844,17.47);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (98477,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98477,37.68,0.46,344,41266,70,NULL,NULL,'2MASX J12401493-0013314',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000086,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,190.0622917,-0.22536,0.034,NULL,42983750151,671621096,10494079,17.4),(98478,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98478,37.77,0.21,358,41267,70,NULL,NULL,'2MASX J12401551+0325246',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000161,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,190.0647083,3.42339,0.03,NULL,58232286926,909879483,14216866,17.1),(98479,'SNII optical','2016-12-15 15:15:04','2016-12-16 11:20:15','1','SN 2010aj',NULL,98479,34.91,0.22,95.9,41268,NULL,NULL,'SCM','MCG -01-32-035',NULL,'2015ApJ...799..215P',2015,1,1.1,NULL,'G',0.000013,NULL,'13.91',0.7,'SAB(rs)bc:',NULL,NULL,NULL,NULL,1,190.066708333,-9.29908,0.037,NULL,43167130722,674486417,10538850,13.91),(98480,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98480,34.47,0.52,78.3,41268,NULL,NULL,'Malmquist cor.','MCG -01-32-035',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98481,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98481,34.75,0.47,89.1,41268,NULL,NULL,'H','MCG -01-32-035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98482,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98482,34.88,0.46,94.5,41268,NULL,NULL,'J','MCG -01-32-035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98483,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98483,34.89,0.45,95,41268,NULL,NULL,'K','MCG -01-32-035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98484,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98484,34.9,0.4,95.7,41268,NULL,NULL,'mean','MCG -01-32-035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98485,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98485,34.95,0.42,97.8,41268,NULL,NULL,NULL,'MCG -01-32-035',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98486,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98486,34.99,0.2,99.5,41268,74.4,NULL,NULL,'MCG -01-32-035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98487,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98487,37.53,0.33,321,41269,70,NULL,NULL,'2MASX J12401688+1749049',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.71',0.16,NULL,NULL,NULL,NULL,NULL,1,190.0704583,17.81797,0.04,NULL,58907328962,920427015,14381672,17.71),(98488,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98488,37.26,0.46,283,41270,70,NULL,NULL,'SDSS J124017.33+102910.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000143,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,190.0722083,10.48625,0,NULL,58184932091,909139563,14205305,18),(98489,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98489,33.86,0.48,59.2,41271,70,NULL,NULL,'MCG -07-26-024',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'14.5',0.9,'SA0^0^: pec',NULL,NULL,NULL,NULL,1,190.072583,-43.21936,0.397,NULL,46763623268,730681613,11416900,14.5),(98490,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98490,37.52,0.33,319,41272,70,NULL,NULL,'2MASX J12401769+1710289',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,190.0737083,17.17481,0.028,NULL,58877374551,919958977,14374359,17.2),(98491,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98491,31.29,0.22,18.1,41273,NULL,NULL,'TOM(g) = -7.2 mag','VCC 1833',NULL,'2010ApJ...717..603V',2010,1,0.83,NULL,'G',0.000106,NULL,'14.5g',0.69,'S0_1_(6)','Group member',NULL,NULL,NULL,1,190.082,15.93528,0.025,NULL,58884514233,920070534,14376102,14.5),(98492,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98492,31.32,0.27,18.3,41273,NULL,NULL,'TOM(g) = -7.2 mag','VCC 1833',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98493,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98493,31.35,0.16,18.6,41273,NULL,NULL,'TOM(u) = -8.4 mag','VCC 1833',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98494,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98494,31.48,0.15,19.8,41273,NULL,NULL,'TOM(z) = -8.53 mag','VCC 1833',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98495,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98495,31.04,0.14,16.1,41273,74.4,NULL,NULL,'VCC 1833',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98496,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98496,31.05,0.07,16.2,41273,NULL,NULL,NULL,'VCC 1833',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98497,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98497,31.06,0.07,16.3,41273,NULL,NULL,'HST ACS VCS','VCC 1833',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98498,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98498,37.37,0.46,297,41274,70,NULL,NULL,'2MASX J12402025+0322556',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,'FoF','18.24',0.13,NULL,NULL,NULL,NULL,NULL,1,190.0845,3.38208,0.065,NULL,58232328680,909880135,14216877,18.24),(98499,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98499,35.64,0.63,134,41275,70,NULL,NULL,'2MASX J12402080-1424317',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.16',0.3,NULL,NULL,NULL,NULL,NULL,1,190.086583333,-14.40886,0.089,NULL,43937972350,686530817,10727044,16.16),(98500,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98500,38.1,0.46,417,41276,70,NULL,NULL,'2MASX J12402153+4751433',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,190.089667,47.86217,0.01,NULL,59111349285,923614832,14431481,17.4),(98501,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98501,37.5,0.46,316,41277,70,NULL,NULL,'2MASX J12402178+1336189',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000175,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,190.09075,13.60528,0.037,NULL,58873694345,919901474,14373460,16.9),(98502,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98502,36.85,0.46,235,41278,70,NULL,NULL,'2MASX J12402200+0102436',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000077,NULL,'16.8g',0.24,'AGN',NULL,NULL,NULL,NULL,1,190.091583,1.04558,0,NULL,57999318427,906239350,14159989,16.8),(98503,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98503,37.99,0.46,396,41279,70,NULL,NULL,'2MASX J12402211+1321079',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,190.0922083,13.35233,0.037,NULL,58873869661,919904213,14373503,17.5),(98504,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98504,37.13,0.46,266,41280,70,NULL,NULL,'2MASX J12402223+4123481',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00019,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,190.09275,41.39681,0,NULL,59118200506,923721882,14433154,16.3),(98505,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98505,29.33,0.22,7.35,41281,NULL,NULL,'I','NGC 4600',NULL,'2001ApJ...546..681T',2001,1,1.2,NULL,'G',0.000113,NULL,'13.73',0.8,'S0(6),N','in a radial-velocity based grouping',NULL,NULL,NULL,1,190.095666667,3.11775,0.051,NULL,58232362082,909880657,14216885,13.73),(98506,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98506,29.56,0.08,8.15,41281,74.4,NULL,NULL,'NGC 4600',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98507,'TRGB','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98507,29.56,0.08,8.15,41281,74.4,NULL,NULL,'NGC 4600',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98508,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98508,29.56,0.08,8.15,41281,74.4,NULL,NULL,'NGC 4600',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98509,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98509,31.44,0.4,19.4,41281,NULL,NULL,'mean','NGC 4600',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98510,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98510,31.63,0.45,21.2,41281,NULL,NULL,'K','NGC 4600',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98511,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98511,35.1,0.46,105,41282,70,NULL,NULL,'2MASX J12402293+2533057',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00018,NULL,'16.26',0.2,NULL,NULL,NULL,NULL,NULL,1,190.0955417,25.55147,0.058,NULL,58604314950,915692421,14307694,16.26),(98512,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98512,37.13,0.46,267,41283,70,NULL,NULL,'2MASX J12402323+4324043',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,190.097041667,43.40114,0,NULL,59117186739,923706042,14432906,17.2),(98513,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98513,37.42,0.16,305,41284,70,NULL,NULL,'2MASX J12402335+1323239',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000162,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,190.0975,13.38992,0.037,NULL,58873868981,919904202,14373503,16.8),(98514,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98514,35.99,0.69,158,41285,70,NULL,NULL,'WKK 1250',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'17.1',0.32,'br.blg',NULL,NULL,NULL,NULL,1,190.0987083,-52.59675,0.281,NULL,44604725537,696948836,10889825,17.1),(98515,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98515,37.17,0.46,272,41286,70,NULL,NULL,'2MASX J12402373+0813294',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000159,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,190.098916667,8.22475,0,NULL,58194543507,909289742,14207652,16.8),(98516,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98516,37.27,0.46,284,41287,70,NULL,NULL,'2MASX J12402462+2518497',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,190.1025,25.31378,0.061,NULL,58604161859,915690029,14307656,17.5),(98517,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98517,38.7,0.46,550,41288,70,NULL,NULL,'SDSS J124024.79+000933.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000062,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,190.103333,0.15919,0.018,NULL,57999600507,906243757,14160058,18.6),(98518,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98518,36.81,0.33,230,41289,70,NULL,NULL,'2MASX J12402536+2808117',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00015,NULL,'16.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,190.10575,28.13669,0.089,NULL,58731311110,917676736,14338699,16.6),(98519,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98519,35.46,0.46,123,41290,70,NULL,NULL,'VIII Zw 205',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.00015,NULL,'16.05',0.54,NULL,NULL,NULL,NULL,NULL,1,190.105917,24.904,0.029,NULL,58605447897,915710123,14307970,16.05),(98520,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98520,37.17,0.46,271,41291,70,NULL,NULL,'2MASX J12402558+2521207',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,190.1067083,25.35567,0.058,NULL,58604340864,915692826,14307700,18),(98521,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98521,37.56,0.09,324,41292,70,NULL,NULL,'2MASX J12402618+1837455',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'15.8',0.26,NULL,'Group member',NULL,NULL,NULL,1,190.1090417,18.62922,0.024,NULL,58908033320,920438020,14381844,15.8),(98522,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98522,37.52,0.33,319,41293,70,NULL,NULL,'2MASX J12402740+1715169',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,190.114083,17.25461,0.033,NULL,58877408085,919959501,14374367,16.9),(98523,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98523,36.71,0.46,219,41294,70,NULL,NULL,'2MASX J12402820+0405236',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000167,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,190.1175,4.08989,0.006,NULL,58231935348,909873989,14216781,16.4),(98524,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98524,37.19,0.46,274,41295,70,NULL,NULL,'2MASX J12402903+4439154',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,190.120833,44.65433,0,NULL,59119736802,923745887,14433529,17.1),(98525,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98525,37.98,0.46,395,41296,70,NULL,NULL,'2MASX J12402930+2813357',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,190.1222917,28.22664,0.089,NULL,58731503627,917679744,14338746,17.4),(98526,'IRAS','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98526,33.87,0.8,59.4,41297,75,NULL,'MAT, I','NGC 4603B',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'15.16',0.3,'Sb pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,190.123916667,-41.06983,0.513,NULL,46745786128,730402908,11412545,15.16),(98527,'IRAS','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98527,33.89,0.8,60,41297,75,NULL,'HMCL, I','NGC 4603B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98528,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98528,32.62,0.32,33.4,41297,85,NULL,'I, raw','NGC 4603B',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98529,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98529,32.62,0.32,33.4,41297,85,NULL,'I, inv','NGC 4603B',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98530,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98530,32.89,0.43,37.8,41297,75,NULL,'MAT, I, raw','NGC 4603B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98531,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98531,32.94,0.43,38.7,41297,75,NULL,'MAT, I, inv','NGC 4603B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98532,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98532,33.19,0.43,43.4,41297,75,NULL,'MAT, I, cor','NGC 4603B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98533,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98533,33.2,0.56,43.6,41297,NULL,NULL,NULL,'NGC 4603B',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98534,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98534,33.21,0.56,43.9,41297,NULL,NULL,'Malmquist cor.','NGC 4603B',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98535,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98535,33.22,0.49,44.1,41297,75,NULL,'IR','NGC 4603B',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98536,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98536,33.24,0.2,44.5,41297,74.4,NULL,NULL,'NGC 4603B',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98537,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98537,33.44,0.4,48.7,41297,75,NULL,'HMCL, I, raw','NGC 4603B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98538,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98538,33.52,0.4,50.5,41297,75,NULL,'HMCL, I, inv','NGC 4603B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98539,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98539,33.57,0.4,51.7,41297,75,NULL,'HMCL, I, cor','NGC 4603B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98540,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98540,37.56,0.09,324,41298,70,NULL,NULL,'SDSS J124030.20+183704.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.2g',0.15,NULL,'Group member',NULL,NULL,NULL,1,190.125875,18.61792,0.024,NULL,58908033832,920438028,14381844,18.2),(98541,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98541,36.93,0.46,243,41299,70,NULL,NULL,'2MASX J12403055+4805457',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000161,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,190.12725,48.09608,0.01,NULL,59111241501,923613148,14431455,16.5),(98542,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98542,37.19,0.46,275,41300,70,NULL,NULL,'2MASX J12403072+1715216',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.93',0.23,'AGN',NULL,NULL,NULL,NULL,1,190.128083333,17.25597,0.032,NULL,58877400508,919959382,14374365,17.93),(98543,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98543,37.14,0.46,268,41301,70,NULL,NULL,'SDSS J124031.17-010042.6',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000077,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,190.129917,-1.01186,0.041,NULL,42983996979,671624952,10494139,17.2),(98544,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98544,37.08,0.46,260,41302,70,NULL,NULL,'2MASX J12403208+1656446',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,190.133541667,16.94572,0.028,NULL,58877481607,919960650,14374385,17.1),(98545,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98545,38,0.46,397,41303,70,NULL,NULL,'SDSS J124032.06+423714.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000136,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,190.133625,42.62075,0,NULL,59117845783,923716340,14433067,18.7),(98546,'IRAS','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98546,34.48,0.8,78.8,41304,75,NULL,'MAT, I','ESO 381- G 005',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000025,NULL,'14.90',0.7,'S?',NULL,NULL,NULL,NULL,1,190.13625,-36.96803,0.197,NULL,43251645081,675806954,10559483,14.9),(98547,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98547,33.23,0.32,44.3,41304,85,NULL,'I, raw','ESO 381- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98548,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98548,33.24,0.32,44.5,41304,85,NULL,'I, inv','ESO 381- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98549,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98549,33.66,0.43,53.9,41304,75,NULL,'MAT, I, raw','ESO 381- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98550,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98550,33.75,0.43,56.1,41304,75,NULL,'MAT, I, inv','ESO 381- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98551,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98551,33.8,0.43,57.5,41304,75,NULL,'MAT, I, cor','ESO 381- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98552,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98552,33.99,0.2,62.8,41304,74.4,NULL,NULL,'ESO 381- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98553,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98553,34.19,0.53,68.8,41304,NULL,NULL,'Malmquist cor.','ESO 381- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98554,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98554,34.43,0.47,77,41304,NULL,NULL,NULL,'ESO 381- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98555,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98555,38.29,0.46,455,41305,70,NULL,NULL,'SDSS J124032.90-022100.2',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000077,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,190.137125,-2.35008,0.029,NULL,43171181020,674549703,10539839,18.3),(98556,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98556,37.04,0.33,256,41306,70,NULL,NULL,'2MASX J12403530+1200576',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,190.1470417,12.01586,0.097,NULL,58153354637,908646166,14197596,18),(98557,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98557,37.47,0.46,312,41307,70,NULL,NULL,'2MASX J12403673+1831225',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'15.9',0.27,NULL,'Group member',NULL,NULL,NULL,1,190.153083,18.52286,0.03,NULL,58908907707,920451682,14382057,15.9),(98558,'IRAS','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98558,32.9,0.8,38,41308,75,NULL,'MAT, I','NGC 4602',NULL,'1997ApJS..109..333W',1997,1,3.4,'One APM position refers to the east side of the galaxy.','G',0.000013,NULL,'12.31',1.2,'SAB(rs)bc      Sy1.9','in a pair',NULL,NULL,NULL,1,190.1535417,-5.133,0.025,NULL,43179754982,674683671,10541932,12.31),(98559,'Sosies','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98559,32.69,0.22,34.5,41308,NULL,NULL,NULL,'NGC 4602',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98560,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98560,32.37,0.43,29.7,41308,75,NULL,'MAT, I, raw','NGC 4602',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98561,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98561,32.42,0.32,30.5,41308,85,NULL,'I, raw','NGC 4602',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98562,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98562,32.47,0.3,31.2,41308,55,NULL,'B','NGC 4602',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98563,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98563,32.48,0.32,31.3,41308,85,NULL,'I, inv','NGC 4602',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98564,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98564,32.57,0.4,32.7,41308,NULL,NULL,NULL,'NGC 4602',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98565,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98565,32.58,0.43,32.9,41308,75,NULL,'MAT, I, cor','NGC 4602',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98566,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98566,32.61,0.43,33.3,41308,75,NULL,'MAT, I, inv','NGC 4602',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98567,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98567,32.65,0.46,33.9,41308,NULL,NULL,'J','NGC 4602',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98568,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98568,32.65,0.47,33.9,41308,NULL,NULL,'H','NGC 4602',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98569,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98569,32.67,0.45,34.1,41308,NULL,NULL,'K','NGC 4602',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98570,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98570,32.76,0.43,35.7,41308,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4602',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98571,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98571,32.8,0.42,36.2,41308,NULL,NULL,'Malmquist cor.','NGC 4602',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98572,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98572,32.81,0.43,36.4,41308,75,NULL,'3.6 micron, color corrected','NGC 4602',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98573,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98573,32.89,0.2,37.8,41308,74.4,NULL,NULL,'NGC 4602',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98574,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98574,32.89,0.4,37.9,41308,75,NULL,'B','NGC 4602',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98575,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98575,32.94,0.39,38.7,41308,NULL,NULL,NULL,'NGC 4602',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98576,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98576,32.94,0.4,38.7,41308,NULL,NULL,'mean','NGC 4602',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98577,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98577,38.07,0.23,412,41309,70,NULL,NULL,'2MASX J12403833+6506401',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00018,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,190.159333,65.11128,0.021,NULL,57322814104,895668970,13994827,18),(98578,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98578,37.03,0.46,255,41310,70,NULL,NULL,'2MASX J12403922+0623291',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,190.16325,6.39122,0,NULL,58238712971,909979890,14218435,17.6),(98579,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98579,38.16,0.46,429,41311,70,NULL,NULL,'2MASX J12403964+5905214',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000141,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,190.165083,59.08944,0,NULL,57407059172,896985299,14015395,17.7),(98580,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98580,35.16,0.54,108,41312,70,NULL,NULL,'2MASX J12404073-0852008',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000093,NULL,'13.4I',0.6,NULL,NULL,NULL,NULL,NULL,1,190.169708333,-8.86686,0.061,NULL,43165960828,674468137,10538564,13.4),(98581,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98581,37.04,0.33,256,41313,70,NULL,NULL,'2MASX J12404117+1158441',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000142,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,190.171541667,11.97906,0.097,NULL,58153349217,908646081,14197595,17.6),(98582,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98582,37.97,0.46,393,41314,70,NULL,NULL,'2MASX J12404142+1350477',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,190.1724583,13.84653,0.046,NULL,58874159886,919908748,14373574,17.9),(98583,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98583,38.45,0.46,489,41315,70,NULL,NULL,'SDSS J124041.99+065324.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000134,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,190.175,6.89008,0.018,NULL,58238224531,909972258,14218316,18.3),(98584,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98584,37.43,0.33,306,41316,70,NULL,NULL,'SDSS J124042.64+055741.9',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000152,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,190.1777083,5.96167,0,NULL,58238656441,909979006,14218421,17.5),(98585,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98585,31.9,0.45,24,41317,NULL,NULL,'K','NGC 4603C',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000063,NULL,'14.13',0.4,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,190.179625,-40.76336,0.513,NULL,46749221743,730456589,11413384,14.13),(98586,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98586,33.26,0.4,44.9,41317,NULL,NULL,'mean','NGC 4603C',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98587,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98587,36.81,0.33,230,41318,70,NULL,NULL,'2MASX J12404536+2807365',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000147,NULL,'15.7g',0.43,NULL,NULL,NULL,NULL,NULL,1,190.1890417,28.12697,0.085,NULL,58731328860,917677013,14338703,15.7),(98588,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98588,37.19,0.46,275,41319,70,NULL,NULL,'2MASX J12404548+4959374',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00016,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,190.1897917,49.99358,0,NULL,57202620023,893790937,13965483,16.7),(98589,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98589,37.42,0.21,304,41320,70,NULL,NULL,'2MASX J12404568+1615467',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,190.19025,16.26297,0.018,NULL,58884600425,920071881,14376123,17),(98590,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98590,37.81,0.33,364,41321,70,NULL,NULL,'2MASX J12404629+0344344',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,190.192875,3.74278,0,NULL,58232089080,909876391,14216818,17.7),(98591,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98591,38.32,0.46,460,41322,70,NULL,NULL,'2MASX J12404754+0808060',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000188,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,190.19825,8.13497,0,NULL,58195031233,909297363,14207771,17),(98592,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98592,37.11,0.46,264,41323,70,NULL,NULL,'SDSS J124048.09-020646.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000065,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,190.200417,-2.11281,0.029,NULL,43171793547,674559274,10539988,18.2),(98593,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98593,37.16,0.46,271,41324,70,NULL,NULL,'2MASX J12404821+0533394',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,190.200875,5.56103,0,NULL,58221453443,909710210,14214222,17.6),(98594,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98594,37.81,0.33,364,41325,70,NULL,NULL,'2MASX J12404749+0342544',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,190.201167,3.71839,0,NULL,58232089725,909876401,14216818,17.5),(98595,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98595,37.94,0.46,388,41326,70,NULL,NULL,'2MASX J12404850+1258417',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,190.2019583,12.97833,0.068,NULL,58151409777,908615777,14197121,17.6),(98596,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98596,37.47,0.46,312,41327,70,NULL,NULL,'2MASX J12404876+6559325',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000172,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,190.2029583,65.99233,0.049,NULL,57323135940,895673999,13994906,16.7),(98597,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98597,37.56,0.09,324,41328,70,NULL,NULL,'2MASX J12404960+1831405',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'16.8',0.17,NULL,'Group member',NULL,NULL,NULL,1,190.2065,18.52781,0.03,NULL,58908915018,920451797,14382059,16.8),(98598,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98598,37.63,0.46,335,41329,70,NULL,NULL,'2MASX J12404959-0302551',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000073,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,190.206667,-3.04858,0.025,NULL,43181926360,674717599,10542462,18),(98599,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98599,37.11,0.46,264,41330,70,NULL,NULL,'2MASX J12404964+4344352',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,190.206833,43.74317,0,NULL,59119013363,923734583,14433352,17.1),(98600,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98600,37.95,0.46,389,41331,70,NULL,NULL,'2MASX J12404972+0709440',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,190.207125,7.16225,0.018,NULL,58195188002,909299812,14207809,17.5),(98601,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98601,31.9,0.43,24,41332,75,NULL,'3.6 micron, color + selection bias corrected','UGC 07844',NULL,'2014MNRAS.444..527S',2014,1,1.27,NULL,'G',0.00009,NULL,'16.5',0.16,'Sd','X-ray-bright group member',NULL,NULL,NULL,1,190.207875,73.71892,0.045,NULL,57031412332,891115817,13923684,16.5),(98602,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98602,33.35,NULL,46.9,41332,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07844',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98603,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98603,33.37,NULL,47.2,41332,NULL,NULL,'Dipole + Quadrupole','UGC 07844',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98604,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98604,33.38,NULL,47.5,41332,NULL,NULL,'Dipole','UGC 07844',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98605,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98605,33.53,NULL,50.8,41332,NULL,NULL,NULL,'UGC 07844',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98606,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98606,37.56,0.09,324,41333,70,NULL,NULL,'2MASX J12405031+1836485',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'15.7',0.31,NULL,'Group member',NULL,NULL,NULL,1,190.2095,18.61339,0.024,NULL,58908938197,920452159,14382064,15.7),(98607,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98607,38.77,0.46,568,41334,70,NULL,NULL,'2MASX J12405208+0045114',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000075,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,190.217125,0.75331,0.006,NULL,57999264098,906238501,14159976,17.9),(98608,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98608,38.07,0.23,412,41335,70,NULL,NULL,'2MASX J12405254+6511572',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,190.2190417,65.19919,0.021,NULL,57322987398,895671678,13994869,17.1),(98609,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98609,37.32,0.46,291,41336,70,NULL,NULL,'2MASX J12405267+2237172',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'18.72',NULL,NULL,NULL,NULL,NULL,NULL,1,190.219583,22.62142,0.083,NULL,58903718994,920370609,14380790,18.72),(98610,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98610,33.99,0.46,62.8,41337,70,NULL,NULL,'IC 3651',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.00009,NULL,'14.20',1,'S0 pec','Group member',NULL,NULL,NULL,1,190.2204583,26.72814,0.081,NULL,58733922875,917717544,14339336,14.2),(98611,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98611,34.43,0.4,76.9,41337,NULL,NULL,'mean','IC 3651',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98612,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98612,35.14,0.45,107,41337,NULL,NULL,'K','IC 3651',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98613,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98613,37.33,0.46,292,41338,70,NULL,NULL,'2MASX J12405294+1810032',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'17.4',0.14,NULL,'Group member',NULL,NULL,NULL,1,190.220833,18.16761,0.031,NULL,58908359076,920443110,14381923,17.4),(98614,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98614,37.57,0.46,326,41339,70,NULL,NULL,'2MASX J12405349+6756065',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000092,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,190.222333,67.93525,0.021,NULL,57862870182,904107346,14126677,17.6),(98615,'D-Sigma','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98615,32.93,0.4,38.6,41340,75,NULL,'Edat, raw','ESO 322- G 051',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00007,NULL,'12.69',0.5,'SB0-? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,190.2250417,-41.60664,0.513,NULL,46765741706,730714714,11417417,12.69),(98616,'D-Sigma','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98616,32.95,0.4,38.9,41340,75,NULL,'Edat, cor','ESO 322- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98617,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98617,32.6,0.5,33.1,41340,70,NULL,NULL,'ESO 322- G 051',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98618,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98618,33.23,0.25,44.3,41340,74.4,NULL,NULL,'ESO 322- G 051',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98619,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98619,32.75,0.45,35.5,41340,NULL,NULL,'K','ESO 322- G 051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98620,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98620,33.42,0.4,48.2,41340,NULL,NULL,'mean','ESO 322- G 051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98621,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98621,37.8,0.46,363,41341,70,NULL,NULL,'SDSS J124054.51+080453.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000147,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,190.227125,8.08161,0,NULL,58195029058,909297329,14207770,18.4),(98622,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98622,37.25,0.46,282,41342,70,NULL,NULL,'2MASX J12405499+4553563',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,190.2292083,45.89894,0,NULL,59111752708,923621136,14431580,17.1),(98623,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98623,32.31,0.41,29,41343,NULL,18.45,'LMC ZP','NGC 4603',NULL,'2009AcA....59..403M',2009,1,3.4,'Confused HIPASS source','G',0.00002,NULL,'12.29',2.5,'SA(rs)bc','in a pair',NULL,NULL,NULL,1,190.2300417,-40.97639,0.513,NULL,46749225371,730456646,11413385,12.29),(98624,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98624,32.58,0.09,32.8,41343,74.4,NULL,NULL,'NGC 4603',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98625,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98625,32.61,0.1,33.3,41343,NULL,NULL,'43, VI','NGC 4603',NULL,'1999ApJ...523..506N',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98626,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98626,32.86,0.15,37.3,41343,NULL,NULL,'MW HIPP','NGC 4603',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98627,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98627,33.48,0.86,49.7,41343,NULL,NULL,'MW P02','NGC 4603',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98628,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98628,33.7,0.09,55,41343,NULL,NULL,'79, VI','NGC 4603',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98629,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98629,33.7,0.09,55,41343,NULL,NULL,'MW GFG','NGC 4603',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98630,'Type II Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98630,32.46,0.44,31,41343,NULL,18.45,'LMC ZP','NGC 4603',NULL,'2009AcA....59..403M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98631,'IRAS','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98631,32.38,0.8,29.9,41343,75,NULL,'MAT, I','NGC 4603',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98632,'IRAS','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98632,32.39,0.8,30.1,41343,75,NULL,'HMCL, I','NGC 4603',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98633,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98633,32.27,0.32,28.5,41343,85,NULL,'I, raw','NGC 4603',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98634,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98634,32.28,0.35,28.6,41343,NULL,NULL,NULL,'NGC 4603',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98635,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98635,32.29,0.43,28.7,41343,75,NULL,'MAT, I, raw','NGC 4603',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98636,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98636,32.34,0.32,29.4,41343,85,NULL,'I, inv','NGC 4603',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98637,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98637,32.47,0.4,31.2,41343,75,NULL,'HMCL, I, raw','NGC 4603',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98638,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98638,32.5,0.46,31.7,41343,NULL,NULL,'J','NGC 4603',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98639,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98639,32.52,0.45,32,41343,NULL,NULL,'K','NGC 4603',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98640,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98640,32.53,0.47,32.1,41343,NULL,NULL,'H','NGC 4603',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98641,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98641,32.55,NULL,32.4,41343,NULL,NULL,'I','NGC 4603',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98642,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98642,32.55,0.43,32.4,41343,75,NULL,'3.6 micron, color corrected','NGC 4603',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98643,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98643,32.56,0.43,32.4,41343,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4603',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98644,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98644,32.56,0.43,32.6,41343,75,NULL,'MAT, I, inv','NGC 4603',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98645,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98645,32.57,NULL,32.7,41343,NULL,NULL,'B','NGC 4603',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98646,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98646,32.58,0.09,32.8,41343,74.4,NULL,NULL,'NGC 4603',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98647,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98647,32.62,0.01,33.4,41343,NULL,NULL,'B','NGC 4603',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98648,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98648,32.7,0.43,34.7,41343,75,NULL,'MAT, I, cor','NGC 4603',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98649,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98649,32.7,0.4,34.7,41343,75,NULL,'HMCL, I, inv','NGC 4603',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98650,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98650,32.76,0.15,35.6,41343,NULL,NULL,'I','NGC 4603',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98651,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98651,32.83,0.4,36.8,41343,75,NULL,'HMCL, I, cor','NGC 4603',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98652,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98652,33.03,0.4,40.4,41343,NULL,NULL,'mean','NGC 4603',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98653,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98653,33.33,0.4,46.4,41343,75,NULL,'B','NGC 4603',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98654,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98654,33.39,0.1,47.7,41343,NULL,NULL,NULL,'NGC 4603',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98655,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98655,37.12,0.46,265,41344,70,NULL,NULL,'2MASX J12405545+1536590',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,190.231083,15.6165,0.03,NULL,58887440731,920116261,14376816,17.2),(98656,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98656,35.06,0.46,103,41345,70,NULL,NULL,'2MASX J12405540+5527153',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000166,NULL,'15.2g',0.5,'S0/a',NULL,NULL,NULL,NULL,1,190.231083,55.45422,0.005,NULL,57399478776,896866855,14013544,15.2),(98657,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98657,37.78,0.46,359,41346,70,NULL,NULL,'2MASX J12405565+3402434',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000186,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,190.232,34.0455,0,NULL,58744497936,917882780,14341918,17.4),(98658,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98658,35.22,0.37,111,41347,NULL,NULL,'Malmquist cor.','UGC 07836',NULL,'2009ApJS..182..474S',2009,1,1.43,NULL,'G',0.000007,NULL,'14.7g',0.41,'Scd:',NULL,NULL,NULL,NULL,1,190.234291667,29.46558,0.076,NULL,58775888373,918373255,14349582,14.7),(98659,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98659,35.6,0.2,132,41347,74.4,NULL,NULL,'UGC 07836',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98660,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98660,35.64,0.31,134,41347,NULL,NULL,NULL,'UGC 07836',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98661,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98661,38.1,0.46,416,41348,70,NULL,NULL,'2MASX J12405686+0321024',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000181,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,190.236833,3.35067,0.056,NULL,58232435419,909881803,14216903,17.5),(98662,'Sosies','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98662,33.77,0.17,56.8,41349,NULL,NULL,NULL,'UGC 07848',NULL,'2002A&A...393...57T',2002,1,1.99,NULL,'G',0.000047,NULL,'14.3g',0.73,'SABcd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,190.2387083,63.51958,0,NULL,57376245708,896503839,14007872,14.3),(98663,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98663,33.25,0.4,44.7,41349,NULL,NULL,NULL,'UGC 07848',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98664,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98664,33.44,0.2,48.8,41349,74.4,NULL,NULL,'UGC 07848',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98665,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98665,33.54,0.43,51,41349,75,NULL,'3.6 micron, color corrected','UGC 07848',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98666,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98666,33.59,0.56,52.4,41349,NULL,NULL,NULL,'UGC 07848',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98667,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98667,33.62,0.56,52.9,41349,NULL,NULL,'Malmquist cor.','UGC 07848',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98668,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98668,33.69,0.43,54.6,41349,75,NULL,'3.6 micron, color + selection bias corrected','UGC 07848',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98669,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98669,37.56,0.09,324,41350,70,NULL,NULL,'2MASX J12405750+1831512',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.2',0.18,NULL,'Group member',NULL,NULL,NULL,1,190.2395,18.53106,0.027,NULL,58908910705,920451729,14382058,17.2),(98670,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98670,30.69,0.47,13.8,41351,NULL,NULL,'H','NGC 4606',NULL,'2007A&A...465...71T',2007,1,3.2,NULL,'G',0.000003,NULL,'12.67',1.6,'SB(s)a:;Sy     LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,190.23975,11.91222,0.097,NULL,58153351337,908646114,14197595,12.67),(98671,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98671,30.74,0.46,14.1,41351,NULL,NULL,'J','NGC 4606',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98672,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98672,30.75,0.45,14.1,41351,NULL,NULL,'K','NGC 4606',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98673,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98673,31.5,0.1,20,41351,NULL,NULL,'stellar kinematics','NGC 4606',NULL,'2008ApJ...683...78C',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98674,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98674,31.84,0.4,23.4,41351,NULL,NULL,'mean','NGC 4606',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98675,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98675,37.56,0.09,324,41352,70,NULL,NULL,'2MASX J12405800+1832442',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'15.6',0.15,NULL,'Group member',NULL,NULL,NULL,1,190.241667,18.54556,0.027,NULL,58908910601,920451728,14382058,15.6),(98676,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98676,30.81,0.22,14.5,41353,NULL,NULL,'TOM(g) = -7.2 mag','IC 3652',NULL,'2010ApJ...717..603V',2010,1,1.03,NULL,'G',0.000067,NULL,'14.4g',1,'dE0,N','Group member',NULL,NULL,NULL,1,190.244,11.1845,0.007,NULL,58187085047,909173203,14205831,14.4),(98677,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98677,30.89,0.29,15.1,41353,NULL,NULL,'TOM(g) = -7.2 mag','IC 3652',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98678,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98678,31,0.23,15.9,41353,NULL,NULL,'TOM(u) = -8.4 mag','IC 3652',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98679,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98679,31.1,0.21,16.6,41353,NULL,NULL,'TOM(z) = -8.53 mag','IC 3652',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98680,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98680,31.01,0.14,15.9,41353,74.4,NULL,NULL,'IC 3652',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98681,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98681,31.03,0.08,16.1,41353,NULL,NULL,'HST ACS VCS','IC 3652',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98682,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98682,31.04,0.06,16.1,41353,NULL,NULL,NULL,'IC 3652',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98683,'GC radius','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98683,30.32,0.09,11.6,41353,NULL,NULL,NULL,'IC 3652',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98684,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98684,37.38,0.33,299,41354,70,NULL,NULL,'2MASX J12405880+6253523',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,190.2447917,62.89783,0,NULL,57376783474,896512241,14008003,17.5),(98685,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98685,37.56,0.09,324,41355,70,NULL,NULL,'4C +18.35',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.0002,NULL,'15.5',0.3,'E','Group member',NULL,'radio jet',NULL,1,190.251375,18.55389,0.027,NULL,58908948585,920452321,14382067,15.5),(98686,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98686,34.95,0.49,97.9,41356,70,NULL,NULL,'LCRS B123826.1-062321',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000073,NULL,'14.41',0.7,'SB(r)0+ pec:',NULL,NULL,NULL,NULL,1,190.254667,-6.66339,0.041,NULL,43210501654,675164088,10549438,14.41),(98687,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98687,38.34,0.46,466,41357,70,NULL,NULL,'SDSS J124101.21+013034.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,190.2550417,1.50969,0,NULL,58220455320,909694614,14213978,17.7),(98688,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98688,37.5,0.23,316,41358,70,NULL,NULL,'2MASX J12410177+1220280',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000184,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,190.257375,12.34122,0.095,NULL,58153636276,908650566,14197665,16.6),(98689,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98689,37.61,0.46,332,41359,70,NULL,NULL,'2MASX J12410206+3800027',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,190.258583333,38.00064,0,NULL,58559396117,914990564,14296727,17.1),(98690,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98690,38.11,0.33,419,41360,70,NULL,NULL,'2MASX J12410220-0214031',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000082,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,190.2592083,-2.23431,0.025,NULL,43171010794,674547043,10539797,17.2),(98691,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98691,37.53,0.46,320,41361,70,NULL,NULL,'LCRS B123828.2-021914',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000074,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,190.260375,-2.59475,0.025,NULL,43170440214,674538128,10539658,18),(98692,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98692,35.84,0.46,148,41362,70,NULL,NULL,'2MASX J12410261+0541454',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000164,NULL,'16.1g',0.38,'S0',NULL,NULL,NULL,NULL,1,190.260833,5.69583,0,NULL,58221436706,909709948,14214217,16.1),(98693,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98693,34.68,0.51,86.3,41363,70,NULL,NULL,'2MASX J12410305-1018062',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.77',0.4,NULL,NULL,NULL,NULL,NULL,1,190.262667,-10.30175,0.093,NULL,43154163599,674283806,10535684,15.77),(98694,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98694,36.23,0.58,176,41364,70,NULL,NULL,'2MASX J12410368-0513211',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'15.08',0.4,NULL,NULL,NULL,NULL,NULL,1,190.2654583,-5.22253,0.033,NULL,43179831984,674684874,10541951,15.08),(98695,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98695,36.29,0.46,181,41365,70,NULL,NULL,'2MASX J12410389+1156488',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000168,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,190.2662083,11.94683,0.097,NULL,58150514188,908601784,14196902,16.8),(98696,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98696,35.85,0.53,148,41366,70,NULL,NULL,'2MASX J12410468-0933502',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.35',0.4,NULL,NULL,NULL,NULL,NULL,1,190.269583,-9.56389,0.049,NULL,43166357706,674474339,10538661,16.35),(98697,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98697,33.88,0.49,59.7,41367,75,NULL,'IR','NGC 4617',NULL,'2011yCatp016004901K',2011,1,2.61,NULL,'G',0.000027,NULL,'13.9g',0.62,'Sb','Isolated galaxy',NULL,NULL,NULL,1,190.2744583,50.39342,0,NULL,57205564080,893836938,13966202,13.9),(98698,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98698,33.91,0.47,60.4,41367,NULL,NULL,'H','NGC 4617',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98699,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98699,33.93,0.46,61.2,41367,NULL,NULL,'J','NGC 4617',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98700,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98700,33.99,0.45,62.7,41367,NULL,NULL,'K','NGC 4617',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98701,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98701,34.11,0.4,66.3,41367,NULL,NULL,'mean','NGC 4617',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98702,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98702,38.11,0.33,419,41368,70,NULL,NULL,'2MASX J12410602-0212310',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000097,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,190.275125,-2.20861,0.025,NULL,43171018888,674547170,10539799,17.2),(98703,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98703,38.07,0.23,412,41369,70,NULL,NULL,'SDSS J124106.30+651544.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000142,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,190.276291667,65.26233,0.021,NULL,57323014904,895672107,13994876,18.6),(98704,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98704,37.56,0.09,324,41370,70,NULL,NULL,'2MASX J12410643+1830172',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.2',0.28,NULL,'Group member',NULL,NULL,NULL,1,190.277041667,18.50472,0.029,NULL,58908911112,920451736,14382058,16.2),(98705,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98705,37.56,0.09,324,41371,70,NULL,NULL,'2MASX J12410649+1814542',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.5',0.22,NULL,'Group member',NULL,NULL,NULL,1,190.277125,18.24861,0.029,NULL,58908352863,920443013,14381922,16.5),(98706,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98706,39.01,0.46,633,41372,70,NULL,NULL,'2MASX J12410773+6247593',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000183,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,190.282333333,62.79986,0,NULL,57376645636,896510088,14007970,17.5),(98707,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98707,37.56,0.09,324,41373,70,NULL,NULL,'2MASX J12410849+1900092',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.64',0.18,NULL,NULL,NULL,NULL,NULL,1,190.2855,19.00256,0.015,NULL,58908543713,920445995,14381968,17.64),(98708,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98708,37.56,0.09,324,41374,70,NULL,NULL,'2MASX J12410959+1830142',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000093,NULL,'14.7',0.2,NULL,'Group member',NULL,NULL,NULL,1,190.2899583,18.50397,0.027,NULL,58908938804,920452168,14382065,14.7),(98709,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98709,37.89,0.46,378,41375,70,NULL,NULL,'2MASX J12410981+5858552',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,190.291125,58.98194,0,NULL,57407185676,896987276,14015426,17.7),(98710,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98710,35.45,0.64,123,41376,70,NULL,NULL,'2MASX J12411229-1656404',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.13',NULL,NULL,NULL,NULL,NULL,NULL,1,190.301167,-16.94458,0.061,NULL,43934273317,686473020,10726140,16.13),(98711,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98711,37.99,0.33,396,41377,70,NULL,NULL,'LCRS B123837.9-030033',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000079,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,190.301541667,-3.28339,0.029,NULL,43182408902,674725139,10542580,17.3),(98712,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98712,29.61,0.43,8.4,41378,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4607',NULL,'2014MNRAS.444..527S',2014,1,2.9,NULL,'G',0.000008,NULL,'13.75',0.7,'SBb? sp        LINER','in a pair',NULL,NULL,NULL,1,190.301667,11.88664,0.079,NULL,58150516367,908601818,14196903,13.75),(98713,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98713,30.08,0.43,10.4,41378,75,NULL,'3.6 micron, color corrected','NGC 4607',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98714,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98714,30.48,0.2,12.5,41378,74.4,NULL,NULL,'NGC 4607',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98715,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98715,31.45,0.47,19.5,41378,NULL,NULL,'H','NGC 4607',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98716,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98716,31.47,0.45,19.7,41378,NULL,NULL,'K','NGC 4607',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98717,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98717,31.5,0.36,20,41378,NULL,NULL,NULL,'NGC 4607',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98718,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98718,31.62,0.46,21.1,41378,NULL,NULL,'J','NGC 4607',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98719,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98719,31.64,0.49,21.3,41378,75,NULL,'IR','NGC 4607',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98720,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98720,32.43,0.4,30.6,41378,NULL,NULL,'mean','NGC 4607',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98721,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98721,37.53,0.33,320,41379,70,NULL,NULL,'2MASX J12411246+1642029',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,190.302083,16.70072,0.022,NULL,58876923532,919951930,14374248,17.1),(98722,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98722,38.01,0.46,401,41380,70,NULL,NULL,'2MASX J12411258+0049589',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000076,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,190.3025,0.83311,0,NULL,57999293471,906238960,14159983,17.8),(98723,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98723,37.56,0.09,324,41381,70,NULL,NULL,'2MASX J12411280+1812501',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.2',0.2,NULL,'Group member',NULL,NULL,NULL,1,190.303375,18.21408,0.029,NULL,58908401153,920443768,14381933,16.2),(98724,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98724,37.78,0.46,359,41382,70,NULL,NULL,'SDSS J124113.17+543549.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000168,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,190.304917,54.59706,0,NULL,57218703265,894042238,13969409,18.4),(98725,'Ring Diameter','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98725,31,0.84,16,41383,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4608',NULL,'1981ApJS...45..541P',1981,1,3.2,NULL,'G',0.000017,NULL,'11.97',2.7,'SB(r)0^0^','in a radial-velocity based grouping',NULL,NULL,NULL,1,190.305375,10.15567,0,NULL,58186596249,909165566,14205711,11.97),(98726,'Faber-Jackson','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98726,30.6,0.83,13.2,41383,95,NULL,'Weighted Mean','NGC 4608',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98727,'Faber-Jackson','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98727,30.6,0.83,13.2,41383,95,NULL,'de Vaucouleurs','NGC 4608',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98728,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98728,31.53,NULL,20.2,41383,NULL,NULL,NULL,'NGC 4608',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98729,'Tertiary','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98729,30.49,0.25,12.5,41383,95,NULL,NULL,'NGC 4608',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98730,'Tully est','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98730,31.13,0.8,16.8,41383,75,NULL,'B','NGC 4608',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98731,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98731,31.53,0.45,20.3,41383,NULL,NULL,'K','NGC 4608',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98732,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98732,32.08,0.4,26.1,41383,NULL,NULL,'mean','NGC 4608',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98733,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98733,36.72,0.56,221,41384,70,NULL,NULL,'2MASX J12411328-1057092',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,190.305417,-10.95258,0.089,NULL,43154568008,674290125,10535783,16.3),(98734,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98734,37.56,0.09,324,41385,70,NULL,NULL,'SDSS J124113.51+183321.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,190.306333333,18.55611,0.027,NULL,58908947044,920452297,14382067,18.3),(98735,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98735,37.56,0.09,324,41386,70,NULL,NULL,'2MASX J12411367+1831121',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.62',0.16,NULL,'Group member',NULL,NULL,NULL,1,190.307167,18.52011,0.027,NULL,58908942307,920452223,14382065,17.62),(98736,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98736,36.96,0.58,247,41387,70,NULL,NULL,'2MASX J12411417-1104232',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,190.309083,-11.07308,0.089,NULL,43154621938,674290967,10535796,16.5),(98737,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98737,37.5,0.46,317,41388,70,NULL,NULL,'2MASX J12411423+4641044',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00015,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,190.309291667,46.68453,0,NULL,59114503438,923664116,14432251,17.4),(98738,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98738,34.87,0.52,94.2,41389,70,NULL,NULL,'2MASX J12411450-1030432',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.68',NULL,NULL,NULL,NULL,NULL,NULL,1,190.3102917,-10.51217,0.089,NULL,43154275803,674285559,10535711,15.68),(98739,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98739,37.27,0.46,284,41390,70,NULL,NULL,'2MASX J12411498+1209269',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,190.312333,12.15753,0.095,NULL,58150617779,908603402,14196928,17.3),(98740,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98740,38.45,0.46,489,41391,70,NULL,NULL,'2MASX J12411502+3936366',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,190.3124583,39.61025,0,NULL,59084897069,923201516,14425023,17.7),(98741,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98741,37.78,0.46,359,41392,70,NULL,NULL,'SDSS J124115.02-015717.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000078,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,190.312583333,-1.95478,0.021,NULL,43171960655,674561885,10540029,18.1),(98742,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98742,37.64,0.46,337,41393,70,NULL,NULL,'2MASX J12411539+4555124',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000164,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,190.314375,45.92017,0,NULL,59111750969,923621108,14431579,16.9),(98743,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98743,38.55,0.33,513,41394,70,NULL,NULL,'SDSS J124115.66+251839.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,190.3152917,25.31111,0.045,NULL,58604385077,915693516,14307711,18.6),(98744,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98744,30.72,0.61,13.9,41395,NULL,NULL,'TOM(g) = -7.2 mag','IC 3653',NULL,'2010ApJ...717..603V',2010,1,0.76,NULL,'G',0.000013,NULL,'14.2g',0.72,'E3','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,190.315541667,11.38725,0.038,NULL,58183648477,909119507,14204992,14.2),(98745,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98745,30.8,0.74,14.4,41395,NULL,NULL,'TOM(g) = -7.2 mag','IC 3653',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98746,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98746,31.02,0.69,16,41395,NULL,NULL,'TOM(u) = -8.4 mag','IC 3653',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98747,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98747,31.04,0.6,16.1,41395,NULL,NULL,'TOM(z) = -8.53 mag','IC 3653',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98748,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98748,30.84,0.45,14.7,41395,NULL,NULL,'I','IC 3653',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98749,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98749,30.93,0.14,15.4,41395,74.4,NULL,NULL,'IC 3653',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98750,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98750,30.95,0.06,15.5,41395,NULL,NULL,NULL,'IC 3653',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98751,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98751,30.95,0.08,15.5,41395,NULL,NULL,'HST ACS VCS','IC 3653',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98752,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98752,34.49,0.2,79.1,41396,74.4,NULL,NULL,'UGC 07845',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.00003,NULL,'15.45',0.3,'S0','Group member, peripheral',NULL,NULL,NULL,1,190.318166667,27.85317,0.088,NULL,58734412781,917725199,14339456,15.45),(98753,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98753,35.31,0.14,116,41396,NULL,NULL,NULL,'UGC 07845',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98754,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98754,38.07,0.23,412,41397,70,NULL,NULL,'2MASX J12411711+6502463',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,190.321083333,65.04628,0.021,NULL,57322803206,895668800,13994825,18),(98755,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98755,38.12,0.46,420,41398,70,NULL,NULL,'2MASX J12411722+3503505',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,190.32175,35.06403,0,NULL,58562066057,915032282,14297379,17.7),(98756,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98756,37.56,0.09,324,41399,70,NULL,NULL,'MCG +03-32-083',NULL,'2015arXiv151105856S',2015,1,1.01,NULL,'G',0.000187,NULL,'15.0g',0.54,'BrClG','Group member',NULL,NULL,NULL,1,190.322833,18.57458,0.027,NULL,58908944536,920452258,14382066,15),(98757,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98757,38.55,0.33,513,41400,70,NULL,NULL,'2MASX J12411797+2517144',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,190.325,25.28753,0.045,NULL,58604387631,915693556,14307711,17.1),(98758,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98758,37.73,0.46,351,41401,70,NULL,NULL,'2MASX J12411804+0227519',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,190.325083,2.46425,0,NULL,58218352586,909661759,14213464,17.9),(98759,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98759,35.46,0.75,124,41402,70,NULL,NULL,'2MASX J12411817-0837112',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.18',NULL,NULL,NULL,NULL,NULL,NULL,1,190.325667,-8.61992,0.077,NULL,43165979086,674468423,10538569,16.18),(98760,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98760,37.5,0.23,316,41403,70,NULL,NULL,'2MASX J12411839+1213519',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000173,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,190.326625,12.23108,0.095,NULL,58150174532,908596477,14196819,17.2),(98761,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98761,37.08,0.27,260,41404,70,NULL,NULL,'2MASX J12411844+4129507',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00017,NULL,'16.7g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,190.326833,41.49747,0,NULL,59116102185,923689096,14432642,16.7),(98762,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98762,37.4,0.46,301,41405,70,NULL,NULL,'2MASX J12411877+2951403',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,190.328083333,29.86108,0.068,NULL,58783285842,918488841,14351388,17),(98763,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98763,39.29,0.46,720,41406,70,NULL,NULL,'SDSS J124120.18+211711.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'19.58',NULL,NULL,NULL,NULL,NULL,NULL,1,190.334125,21.28636,0.138,NULL,58901403526,920334430,14380225,19.58),(98764,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98764,37.59,0.46,330,41407,70,NULL,NULL,'2MASX J12412074+6822259',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000072,NULL,'17.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,190.33625,68.374,0.021,NULL,57864549089,904133579,14127087,17.9),(98765,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98765,38.15,0.46,426,41408,70,NULL,NULL,'SDSS J124120.85+413050.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,190.336917,41.51392,0,NULL,59116147187,923689799,14432653,18.5),(98766,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98766,37.75,0.56,355,41409,70,NULL,NULL,'2MASX J12412164-1057292',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,190.3402083,-10.95819,0.089,NULL,43154563064,674290047,10535781,15.4),(98767,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98767,30.89,0.4,15,41410,NULL,NULL,NULL,'CGCG 014-104',NULL,'2013MNRAS.429.2677K',2013,1,1.27,'The APM position refers to the southeastern part of the spindle.','G',0.000005,NULL,'14.7g',0.54,'SA0+',NULL,NULL,NULL,NULL,1,190.3455,-3.05792,0.025,NULL,43181845113,674716329,10542442,14.7),(98768,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98768,37.53,0.6,320,41411,70,NULL,NULL,'2MASX J12412314-1109192',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.55',NULL,NULL,NULL,NULL,NULL,NULL,1,190.3465417,-11.15561,0.125,NULL,43154450932,674288295,10535754,16.55),(98769,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98769,37.5,0.23,316,41412,70,NULL,NULL,'SDSS J124123.17+120952.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000168,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,190.3465417,12.16467,0.095,NULL,58150619256,908603425,14196928,18.5),(98770,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98770,37.99,0.46,397,41413,70,NULL,NULL,'2MASX J12412342+2548364',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,190.347833,25.81006,0.063,NULL,58603960029,915686875,14307607,17.4),(98771,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98771,37.42,0.21,304,41414,70,NULL,NULL,'2MASX J12412352+1628568',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,190.348125,16.48236,0.022,NULL,58876980717,919952823,14374262,17),(98772,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98772,33.73,0.46,55.8,41415,70,NULL,NULL,'VCC 1875',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000159,NULL,'14.8g',0.34,'S0_1_(6)','Group member',NULL,NULL,NULL,1,190.3482083,6.67808,0,NULL,58238428962,909975452,14218366,14.8),(98773,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98773,36.63,0.46,212,41416,70,NULL,NULL,'2MASX J12412371+2124068',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,190.3487083,21.40192,0.129,NULL,58901280015,920332500,14380195,16.8),(98774,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98774,37.99,0.33,396,41417,70,NULL,NULL,'LCRS B123849.2-030002',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000086,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,190.34875,-3.2745,0.025,NULL,43182423985,674725374,10542583,17.5),(98775,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98775,38.33,0.46,463,41418,70,NULL,NULL,'2MASX J12412398+5842135',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000178,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,190.349917,58.70375,0,NULL,57406831632,896981744,14015339,17.4),(98776,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98776,32.99,0.69,39.6,41419,100,NULL,'mid-IR','MCG -02-32-023',NULL,'2013ApJ...771...88L',2013,1,1.5,NULL,'G',0.000013,NULL,'14.15',0.6,'SAB(rs)bc:',NULL,NULL,NULL,NULL,1,190.350125,-12.61428,0.093,NULL,43034121681,672408151,10506377,14.15),(98777,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98777,33.81,0.2,57.8,41419,74.4,NULL,NULL,'MCG -02-32-023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98778,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98778,33.93,0.34,61.2,41419,NULL,NULL,'Malmquist cor.','MCG -02-32-023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98779,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98779,34.01,0.4,63.4,41419,NULL,NULL,'mean','MCG -02-32-023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98780,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98780,34.02,0.33,63.6,41419,NULL,NULL,NULL,'MCG -02-32-023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98781,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98781,34.12,0.47,66.6,41419,NULL,NULL,'H','MCG -02-32-023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98782,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98782,34.19,0.46,68.9,41419,NULL,NULL,'J','MCG -02-32-023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98783,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98783,34.24,0.45,70.6,41419,NULL,NULL,'K','MCG -02-32-023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98784,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98784,37.5,0.23,316,41420,70,NULL,NULL,'2MASX J12412460+1210328',NULL,'2015arXiv151105856S',2015,1,0.52,'2002AJ....123.2976R has V_sun = 1159 +- 65 km/s.','G',0.000117,NULL,'16.86',0.4,'S0',NULL,NULL,NULL,NULL,1,190.352375,12.17581,0.095,NULL,58150159600,908596243,14196816,16.86),(98785,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98785,37.56,0.09,324,41421,70,NULL,NULL,'2MASX J12412469+1838298',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.7',0.24,NULL,'Group member',NULL,NULL,NULL,1,190.3530417,18.64167,0.027,NULL,58908987628,920452931,14382077,16.7),(98786,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98786,34.78,0.46,90.4,41422,70,NULL,NULL,'2MASX J12412493+3128565',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000073,NULL,'15.7g',0.42,NULL,NULL,NULL,NULL,NULL,1,190.353917,31.48233,0,NULL,58785105207,918517268,14351832,15.7),(98787,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98787,38.18,0.46,432,41423,70,NULL,NULL,'2MASX J12412511+1313468',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000197,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,190.3545417,13.22961,0.061,NULL,58874692013,919917062,14373704,17.5),(98788,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98788,37.35,0.46,295,41424,70,NULL,NULL,'SDSS J124125.27+471332.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000129,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,190.3552917,47.22558,0,NULL,59113814894,923653357,14432083,18),(98789,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98789,36.72,0.74,220,41425,70,NULL,NULL,'2MASX J12412538-1239454',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,190.355833,-12.66261,0.093,NULL,43034140076,672408438,10506381,16.6),(98790,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98790,34.6,0.49,83.1,41426,75,NULL,'IR','NGC 4611',NULL,'2011yCatp016004901K',2011,1,1.38,NULL,'G',0.000023,NULL,'14.7g',0.36,'SABc','Group member',NULL,NULL,NULL,1,190.3560417,13.72953,0.046,NULL,58874006759,919906355,14373536,14.7),(98791,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98791,34.91,0.2,95.9,41426,74.4,NULL,NULL,'NGC 4611',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98792,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98792,35.01,0.28,101,41426,NULL,NULL,NULL,'NGC 4611',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98793,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98793,35.08,0.27,104,41426,NULL,NULL,'Malmquist cor.','NGC 4611',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98794,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98794,37.56,0.09,324,41427,70,NULL,NULL,'2MASX J12412645+1838588',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'15.8',0.25,NULL,'Group member',NULL,NULL,NULL,1,190.360167,18.64986,0.027,NULL,58908971031,920452672,14382073,15.8),(98795,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98795,36.11,0.75,167,41428,70,NULL,NULL,'2MASX J12412674-1515284',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.18',NULL,NULL,NULL,NULL,NULL,NULL,1,190.361625,-15.258,0.069,NULL,43939391937,686552999,10727390,16.18),(98796,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98796,37.42,0.21,304,41429,70,NULL,NULL,'2MASX J12412713+1626438',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,190.363167,16.44556,0.025,NULL,58876979966,919952811,14374262,17.3),(98797,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98797,36.2,0.46,174,41430,70,NULL,NULL,'2MASX J12412721+1039562',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',NULL,NULL,'16.51',0.17,NULL,NULL,NULL,NULL,NULL,1,190.3632917,10.66553,0,NULL,58187395953,909178061,14205907,16.51),(98798,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98798,37.78,0.33,360,41431,70,NULL,NULL,'SDSS J124127.66+021904.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,190.36525,2.31778,0,NULL,58220243019,909691297,14213926,18.1),(98799,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98799,37.56,0.09,324,41432,70,NULL,NULL,'2MASX J12412767+1810188',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.0',0.25,NULL,'Group member',NULL,NULL,NULL,1,190.36525,18.17186,0.03,NULL,58908408251,920443878,14381935,16),(98800,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98800,36.37,0.56,188,41433,70,NULL,NULL,'2MASX J12412794-1629215',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.07',NULL,NULL,NULL,NULL,NULL,NULL,1,190.3665,-16.48961,0.073,NULL,43934014764,686468980,10726077,16.07),(98801,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98801,37.12,0.33,265,41434,70,NULL,NULL,'2MASX J12412956+6318072',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000184,NULL,'16.0g',0.36,'E0',NULL,NULL,NULL,NULL,1,190.3732083,63.30192,0,NULL,57376266337,896504161,14007877,16),(98802,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98802,37.53,0.33,320,41435,70,NULL,NULL,'2MASX J12412972+1637478',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,190.373875,16.62997,0.022,NULL,58876967426,919952616,14374259,16.9),(98803,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98803,35.62,0.6,133,41436,70,NULL,NULL,'2MASX J12413038-1122102',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.26',NULL,NULL,NULL,NULL,NULL,NULL,1,190.376667,-11.3695,0.125,NULL,43151534600,674242728,10535042,16.26),(98804,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98804,37.56,0.09,324,41437,70,NULL,NULL,'2MASX J12413053+1841018',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'16.0',0.23,NULL,'Group member',NULL,NULL,NULL,1,190.377375,18.68383,0.027,NULL,58908847424,920450741,14382042,16),(98805,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98805,37.15,0.46,269,41438,70,NULL,NULL,'2MASX J12413062+1642098',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,190.377583,16.70275,0.029,NULL,58876838267,919950597,14374228,17.2),(98806,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98806,38.31,0.46,460,41439,70,NULL,NULL,'2MASX J12413106+6827389',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000081,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,190.379375,68.46072,0.021,NULL,57864530815,904133293,14127082,17.6),(98807,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98807,37.78,0.33,360,41440,70,NULL,NULL,'2MASX J12413186+0218329',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,190.382833,2.30903,0,NULL,58220275402,909691803,14213934,17.2),(98808,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98808,37.17,0.46,272,41441,70,NULL,NULL,'2MASX J12413206+3053213',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,190.383583333,30.88939,0.023,NULL,58786899278,918545301,14352270,18),(98809,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98809,31.33,0.19,18.5,41442,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4612',NULL,'2010ApJ...717..603V',2010,1,2.17,NULL,'G',0.000017,NULL,'12.3g',1.38,'(R)SAB0^0^','in a radial-velocity based grouping',NULL,NULL,NULL,1,190.3864583,7.31489,0.009,NULL,58195416453,909303382,14207865,12.3),(98810,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98810,31.34,0.22,18.5,41442,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4612',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98811,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98811,31.47,0.18,19.6,41442,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4612',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98812,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98812,31.53,0.17,20.2,41442,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4612',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98813,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98813,31.07,0.14,16.4,41442,74.4,NULL,NULL,'NGC 4612',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98814,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98814,31.09,0.07,16.5,41442,NULL,NULL,'HST ACS VCS','NGC 4612',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98815,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98815,31.1,0.05,16.6,41442,NULL,NULL,NULL,'NGC 4612',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98816,'GC radius','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98816,30.64,0.1,13.4,41442,NULL,NULL,NULL,'NGC 4612',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98817,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98817,30.74,NULL,14.1,41442,NULL,NULL,NULL,'NGC 4612',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98818,'Tully est','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98818,31.13,0.8,16.8,41442,75,NULL,'B','NGC 4612',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98819,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98819,30.67,0.45,13.6,41442,NULL,NULL,'K','NGC 4612',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98820,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98820,32.09,0.4,26.1,41442,NULL,NULL,'mean','NGC 4612',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98821,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98821,29.31,0.4,7.3,41443,75,NULL,'B','NGC 4618',NULL,'1988NBGC.C....0000T',1988,1,4.2,NULL,'G',0.000003,NULL,'11.22',3.4,'SB(rs)m        HII','Probable group member',NULL,NULL,NULL,1,190.386875,41.15078,0,NULL,59084383912,923193498,14424898,11.22),(98822,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98822,29.49,NULL,7.91,41443,NULL,NULL,NULL,'NGC 4618',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98823,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98823,36.67,0.46,215,41444,70,NULL,NULL,'2MASX J12413324+1724028',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.45',0.2,NULL,NULL,NULL,NULL,NULL,1,190.388333333,17.40078,0.029,NULL,58877125709,919955089,14374298,17.45),(98824,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98824,37.56,0.09,324,41445,70,NULL,NULL,'SDSS J124133.21+181337.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,190.388416667,18.22722,0.03,NULL,58908384478,920443507,14381929,18.4),(98825,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98825,37.08,0.27,260,41446,70,NULL,NULL,'2MASX J12413375+4133297',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00017,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,190.3905,41.55811,0,NULL,59116149545,923689836,14432653,17.1),(98826,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98826,35.08,1.03,104,41447,NULL,NULL,'Malmquist cor.','ESO 268- G 032',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'15.55',1.1,'SAB(s)bc',NULL,NULL,NULL,NULL,1,190.39475,-42.91578,0.453,NULL,46765673087,730713641,11417400,15.55),(98827,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98827,35.57,0.82,130,41447,NULL,NULL,NULL,'ESO 268- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98828,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98828,35.61,0.2,132,41447,74.4,NULL,NULL,'ESO 268- G 032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98829,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98829,37.85,0.46,371,41448,70,NULL,NULL,'LCRS B123900.6-024237',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000075,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,190.395833,-2.98436,0.025,NULL,43181866888,674716670,10542447,17.5),(98830,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98830,37.42,0.21,304,41449,70,NULL,NULL,'2MASX J12413592+1620338',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'15.9g',0.39,NULL,NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,190.3997917,16.34269,0.025,NULL,58876798012,919949968,14374218,15.9),(98831,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98831,37.47,0.46,311,41450,70,NULL,NULL,'2MASX J12413628+6540588',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000167,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,190.400917,65.683,0.049,NULL,57323349074,895677329,13994958,16.8),(98832,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98832,38.03,0.46,404,41451,70,NULL,NULL,'2MASX J12413633+5602595',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000175,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,190.401333,56.05003,0,NULL,57402752652,896918010,14014343,17.3),(98833,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98833,35.89,0.49,150,41452,70,NULL,NULL,'2MASX J12413643-1123302',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.13',0.4,NULL,NULL,NULL,NULL,NULL,1,190.4017083,-11.39183,0.125,NULL,43151529079,674242641,10535041,16.13),(98834,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98834,38.27,0.46,450,41453,70,NULL,NULL,'2MASX J12413672+3735137',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,190.4029583,37.58725,0,NULL,58567627714,915119183,14298737,18),(98835,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98835,34.08,0.49,65.4,41454,75,NULL,'IR','NGC 4615',NULL,'2011yCatp016004901K',2011,1,1.6,'The position in 1998AJ....116.1573B is 5 arcsec south of the nucleus.','G',0.00003,NULL,'13.84',0.7,'Scd:           HII','Possible field galaxy',NULL,NULL,NULL,1,190.4055,26.07283,0.066,NULL,58604082473,915688788,14307637,13.84),(98836,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98836,37.56,0.09,324,41455,70,NULL,NULL,'2MASX J12413784+1900378',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,190.407833,19.0105,0.015,NULL,58908594984,920446796,14381981,17.6),(98837,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98837,37.42,0.21,304,41456,70,NULL,NULL,'2MASX J12413912+1619358',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,190.412833333,16.32661,0.025,NULL,58876798029,919949969,14374218,17.5),(98838,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98838,37.23,0.46,280,41457,70,NULL,NULL,'2MASX J12413934+5247184',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000162,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,190.414083,52.78831,0,NULL,57199533390,893742709,13964729,18.1),(98839,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98839,29.97,0.52,9.84,41458,NULL,NULL,'TOM(u) = -8.4 mag','IC 3663',NULL,'2007ApJS..171..101J',2007,1,0.95,NULL,'G',0.000155,NULL,'15.5g',0.56,'dE5,N','Group member',NULL,NULL,NULL,1,190.4142083,12.24739,0.095,NULL,58150218976,908597171,14196830,15.5),(98840,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98840,30.1,0.3,10.5,41458,NULL,NULL,'TOM(z) = -8.53 mag','IC 3663',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98841,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98841,30.23,0.98,11.1,41458,NULL,NULL,'TOM(g) = -7.2 mag','IC 3663',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98842,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98842,30.23,0.72,11.1,41458,NULL,NULL,'TOM(g) = -7.2 mag','IC 3663',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98843,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98843,30.96,0.14,15.6,41458,74.4,NULL,NULL,'IC 3663',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98844,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98844,30.99,0.18,15.7,41458,NULL,NULL,'HST ACS VCS','IC 3663',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98845,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98845,37.56,0.09,324,41459,70,NULL,NULL,'2MASX J12413960+1809588',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'15.5',0.15,NULL,'Group member',NULL,NULL,NULL,1,190.4150417,18.16625,0.03,NULL,58908387531,920443555,14381930,15.5),(98846,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98846,36.9,0.62,240,41460,70,NULL,NULL,'2MASX J12414015-1238065',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,190.417375,-12.63517,0.093,NULL,43034148774,672408574,10506383,15.1),(98847,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98847,37.64,0.46,338,41461,70,NULL,NULL,'SDSS J124140.86+091636.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.92',0.11,NULL,NULL,NULL,NULL,NULL,1,190.4202917,9.27669,0,NULL,58197843170,909341299,14208457,18.92),(98848,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98848,37.61,0.46,333,41462,70,NULL,NULL,'2MASX J12414093+1429398',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,190.420625,14.4945,0.03,NULL,58886982063,920109094,14376704,17.6),(98849,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98849,36.93,0.46,244,41463,70,NULL,NULL,'2MASXi J1241416-005455',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000078,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,190.42375,-0.91525,0.041,NULL,43168230525,674503601,10539118,17.6),(98850,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98850,37.01,0.46,252,41464,70,NULL,NULL,'2MASX J12414171+2935333',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000131,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,190.423833,29.59269,0.078,NULL,58783199570,918487493,14351367,18),(98851,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98851,37.08,0.27,260,41465,70,NULL,NULL,'2MASX J12414276+4129354',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00017,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,190.428208333,41.49328,0,NULL,59116155882,923689935,14432655,17.2),(98852,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98852,37.64,0.33,337,41466,70,NULL,NULL,'2MASX J12414291+0345518',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,190.428833333,3.76444,0,NULL,58232039765,909875621,14216806,17.6),(98853,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98853,37.33,0.27,293,41467,70,NULL,NULL,'2MASX J12414363+1521298',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000181,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,190.431667,15.35814,0.031,NULL,58887381320,920115333,14376802,17.5),(98854,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98854,37.93,0.46,385,41468,70,NULL,NULL,'2MASX J12414432+3154063',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000176,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,190.434667,31.90178,0.02,NULL,58784426160,918506658,14351666,17.2),(98855,'D-Sigma','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98855,32.79,0.4,36.1,41469,75,NULL,'Edat, raw','NGC 4648',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.00006,NULL,'12.96',1.6,'E3','X-ray-bright group member',NULL,NULL,NULL,1,190.4349583,74.42094,0.053,NULL,57032603671,891134432,13923975,12.96),(98856,'D-Sigma','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98856,32.93,0.4,38.6,41469,75,NULL,'Edat, cor','NGC 4648',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98857,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98857,32.34,0.4,29.4,41469,NULL,NULL,'mean','NGC 4648',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98858,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98858,33.25,0.45,44.7,41469,NULL,NULL,'K','NGC 4648',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98859,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98859,37.56,0.09,324,41470,70,NULL,NULL,'2MASX J12414446+1836318',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,190.435375,18.60883,0.027,NULL,58908972529,920452695,14382073,16.2),(98860,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:15','1','SN 2006ac',NULL,98860,34.3,0.17,70.8,41471,74.2,NULL,'SALT 2','NGC 4619',0.023106,'2010ApJ...716..712A',2010,1,1.25,NULL,'G',0.000037,NULL,'13.5g',1.06,'SB(r)b pec?    Sy1','Field galaxy',NULL,NULL,'Sy 1.0',1,190.435625,35.06278,0,NULL,58562111988,915032999,14297390,13.5),(98861,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:15','1','SN 2006ac',NULL,98861,34.89,0.09,92.9,41471,72,NULL,NULL,'NGC 4619',0.023106,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98862,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:15','1','SN 2006ac',NULL,98862,34.88,0.09,94.6,41471,74.4,NULL,NULL,'NGC 4619',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98863,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:15','1','SN 2006ac',NULL,98863,34.95,0.03,95.5,41471,72,NULL,NULL,'NGC 4619',0.023106,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98864,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:15','1','SN 2006ac',NULL,98864,34.98,0.14,96.8,41471,72,NULL,NULL,'NGC 4619',0.023106,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98865,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:15','1','SN 2006ac',NULL,98865,34.99,0.16,97.2,41471,73.8,NULL,'SALT 2 (SNANA)','NGC 4619',0.0235,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98866,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:15','1','SN 2006ac',NULL,98866,35,0.16,97.8,41471,70,NULL,'SALT 2','NGC 4619',0.023106,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98867,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:15','1','SN 2006ac','R',98867,35.03,0.1,101,41471,NULL,NULL,'MLCS2k2, R(V) = 1.8','NGC 4619',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98868,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:15','1','SN 2006ac',NULL,98868,35.04,0.07,102,41471,72,NULL,'M(H) = -18.317 mag','NGC 4619',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98869,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:15','1','SN 2006ac','R',98869,35.07,0.11,103,41471,NULL,NULL,'MLCS2k2, R(V) = 3.1','NGC 4619',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98870,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:15','1','SN 2006ac',NULL,98870,35.19,0.2,107,41471,65,NULL,'SALT2','NGC 4619',0.023106,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98871,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:15','1','SN 2006ac',NULL,98871,35.21,0.18,108,41471,65,NULL,'SALT','NGC 4619',0.023106,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98872,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:15','1','SN 2006ac',NULL,98872,35.26,0.17,110,41471,65,NULL,'MLCS17','NGC 4619',0.023106,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98873,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:15','1','SN 2006ac',NULL,98873,35.29,0.17,112,41471,65,NULL,'MLCS31','NGC 4619',0.023106,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98874,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:15','1','SN 2006ac',NULL,98874,35.8,0.02,141,41471,70,NULL,'SALT 2','NGC 4619',0.023106,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98875,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98875,38.11,0.46,418,41472,70,NULL,NULL,'2MASX J12414460+2623324',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,190.435875,26.39233,0.074,NULL,58722408500,917537632,14336525,18.2),(98876,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98876,38.18,0.46,433,41473,70,NULL,NULL,'2MASX J12414723+2751294',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,190.446917,27.85833,0.095,NULL,58736522802,917758168,14339971,17.9),(98877,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98877,36.73,0.46,222,41474,70,NULL,NULL,'2MASX J12414762+4454524',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00018,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,190.448417,44.91464,0,NULL,59119450442,923741413,14433459,16.6),(98878,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98878,38.12,0.46,421,41475,70,NULL,NULL,'2MASX J12414768+3417013',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000175,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,190.448875,34.28383,0,NULL,58744017568,917875274,14341801,18.1),(98879,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98879,38.11,0.46,419,41476,70,NULL,NULL,'SDSS J124149.21+082648.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000141,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,190.455083,8.44667,0,NULL,58193134042,909267719,14207308,18.3),(98880,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98880,37.61,0.46,333,41477,70,NULL,NULL,'2MASX J12415107+5334233',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000133,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,190.462917,53.57306,0,NULL,57198134482,893720851,13964388,17.5),(98881,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98881,37.96,0.46,391,41478,70,NULL,NULL,'2MASX J12415132+3615465',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000191,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,190.463833,36.26303,0,NULL,58566909323,915107958,14298561,16.7),(98882,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98882,37.7,0.46,346,41479,70,NULL,NULL,'VCC 1893',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000188,NULL,'16.6g',0.24,'dE2,N','Group member',NULL,NULL,NULL,1,190.464417,2.73886,0.028,NULL,58218433448,909663022,14213484,16.6),(98883,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98883,30.98,0.14,15.7,41480,74.4,NULL,NULL,'UGC 07854',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000002,NULL,'15.3',0.6,'d:E6','Group member',NULL,NULL,NULL,1,190.466583333,9.40289,0,NULL,58197489049,909335766,14208371,15.3),(98884,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98884,31,0.06,15.8,41480,NULL,NULL,NULL,'UGC 07854',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98885,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98885,31.01,0.07,15.9,41480,NULL,NULL,'HST ACS VCS','UGC 07854',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98886,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98886,36.85,0.46,234,41481,70,NULL,NULL,'SDSS J124152.15+080212.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00018,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,190.4672917,8.03678,0,NULL,58195121006,909298765,14207793,17.4),(98887,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98887,37.96,0.33,391,41482,70,NULL,NULL,'SDSS J124152.23+015138.8',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,190.467625,1.86081,0,NULL,58221116703,909704948,14214139,17.9),(98888,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98888,29.57,0.4,8.2,41483,75,NULL,'B','NGC 4625',NULL,'1988NBGC.C....0000T',1988,1,1.27,NULL,'G',0.000003,NULL,'13.2g',1.2,'SAB(rs)m pec','Probable group member',NULL,NULL,NULL,1,190.469667,41.27397,0,NULL,59083336567,923177133,14424642,13.2),(98889,'Tully est','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98889,32.44,0.8,30.7,41484,75,NULL,NULL,'UGC 07872',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.00003,NULL,'16.0',0.7,'Im','X-ray-bright group member',NULL,NULL,NULL,1,190.472083,75.30694,0.037,NULL,57032081166,891126268,13923847,16),(98890,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98890,37.56,0.09,324,41485,70,NULL,NULL,'2MASX J12415380+1838374',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'16.9',0.16,NULL,'Group member',NULL,NULL,NULL,1,190.474333,18.64367,0.027,NULL,58908968835,920452638,14382072,16.9),(98891,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98891,37.96,0.14,391,41486,70,NULL,NULL,'2MASX J12415413-0211365',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000068,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,190.475625,-2.19342,0.021,NULL,43171000876,674546888,10539795,17.4),(98892,'Brightest Stars','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98892,29,NULL,6.3,41487,NULL,NULL,NULL,'UGC 07857',NULL,'2000Ap.....43..367T',2000,1,1.3,NULL,'G',0.0002,NULL,'14.70',0.8,'Sd','Group member',NULL,NULL,NULL,1,190.4762083,13.77289,0.049,NULL,58874473391,919913646,14373650,14.7),(98893,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98893,37.75,0.17,355,41488,70,NULL,NULL,'2MASX J12415462+0925019',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,190.477583,9.41725,0,NULL,58197490919,909335795,14208371,17.7),(98894,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98894,37.96,0.33,391,41489,70,NULL,NULL,'2MASX J12415658+0154288',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000172,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,190.4857083,1.90783,0,NULL,58220979910,909702811,14214106,16.8),(98895,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98895,37.96,0.14,391,41490,70,NULL,NULL,'SDSS J124156.72-020818.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000075,NULL,'18.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,190.486333,-2.13853,0.021,NULL,43171849747,674560152,10540002,18.5),(98896,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98896,36.26,0.33,178,41491,70,NULL,NULL,'2MASX J12415676+2719515',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000097,NULL,'16.99',0.25,NULL,NULL,NULL,NULL,NULL,1,190.486667,27.33094,0.111,NULL,58734498546,917726539,14339477,16.99),(98897,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98897,38.4,0.46,478,41492,70,NULL,NULL,'2MASX J12415725+3625005',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000193,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,190.488667,36.41681,0,NULL,58568343879,915130373,14298912,17),(98898,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98898,37.56,0.46,325,41493,70,NULL,NULL,'SDSS J124157.40+112256.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,190.4892083,11.38231,0.04,NULL,58183702726,909120355,14205005,18.2),(98899,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98899,37.96,0.14,391,41494,70,NULL,NULL,'SDSS J124157.57-020507.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00007,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,190.489916667,-2.08553,0.021,NULL,43171850747,674560167,10540002,18.4),(98900,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98900,36.99,0.46,250,41495,70,NULL,NULL,'2MASX J12415873+1753525',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,190.49475,17.89797,0.029,NULL,58908426685,920444166,14381940,17.6),(98901,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98901,31.64,0.3,21.3,41496,NULL,NULL,'I','NGC 4620',NULL,'2001ApJ...546..681T',2001,1,1.59,NULL,'G',0.000078,NULL,'13.5g',1.23,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,190.497333,12.94278,0.038,NULL,58874719776,919917496,14373710,13.5),(98902,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98902,31.65,0.14,21.4,41496,74.4,NULL,NULL,'NGC 4620',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98903,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98903,36.72,0.46,221,41497,70,NULL,NULL,'2MASX J12415952+2445475',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,190.498125,24.76311,0.013,NULL,58606197265,915721832,14308153,16.6),(98904,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98904,29.84,0.14,9.29,41498,74.4,NULL,NULL,'NGC 4627',NULL,'2013AJ....146...86T',2013,1,2.6,NULL,'G',0.000053,NULL,'13.06',1.8,'E4 pec','Probable group member',NULL,NULL,NULL,1,190.498667,32.57356,0.027,NULL,58742504552,917851633,14341431,13.06),(98905,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98905,29.86,0.15,9.38,41498,NULL,NULL,'I','NGC 4627',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98906,'TRGB','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98906,29.13,NULL,6.7,41498,NULL,NULL,NULL,'NGC 4627',NULL,'2006astro.ph..3457T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98907,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98907,37.86,0.46,373,41499,70,NULL,NULL,'2MASX J12415975+0717189',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000144,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,190.498917,7.28881,0.009,NULL,58195290422,909301412,14207834,17.7),(98908,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98908,37.64,0.33,337,41500,70,NULL,NULL,'2MASX J12420056+0338258',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.00019,NULL,'15.8g',0.45,'E0',NULL,NULL,NULL,NULL,1,190.5022917,3.64042,0,NULL,58232023890,909875373,14216802,15.8),(98909,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98909,34.7,0.55,87.1,41501,70,NULL,NULL,'2MASX J12420158-2024363',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000113,NULL,'15.29',0.4,NULL,NULL,NULL,NULL,NULL,1,190.506667,-20.41014,0.125,NULL,43912139225,686127175,10720737,15.29),(98910,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98910,36.75,0.46,224,41502,70,NULL,NULL,'2MASX J12420165+3616255',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,190.5067917,36.27386,0,NULL,58566917609,915108087,14298563,16.6),(98911,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98911,30.61,0.08,13.2,41503,NULL,NULL,'TOM(g) = -7.2 mag','MESSIER 059',NULL,'2010ApJ...717..603V',2010,1,5.4,'z=0.001368 (2000MNRAS.313..469S)','G',0.000017,NULL,'10.57',3.7,'E5             AGN','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,190.509333,11.64703,0.06,NULL,58150601960,908603155,14196924,10.57),(98912,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98912,30.65,0.09,13.5,41503,NULL,NULL,'TOM(g) = -7.2 mag','MESSIER 059',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98913,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98913,30.66,0.09,13.5,41503,NULL,NULL,'TOM(u) = -8.4 mag','MESSIER 059',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98914,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98914,30.7,0.2,13.8,41503,NULL,NULL,'TOM(V) = -7.3 mag','MESSIER 059',NULL,'2009ApJ...690..512H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98915,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98915,30.74,0.08,14.1,41503,NULL,NULL,'TOM(z) = -8.53 mag','MESSIER 059',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98916,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98916,30.82,0.06,14.6,41503,NULL,NULL,NULL,'MESSIER 059',NULL,'2001AJ....121.2950K',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98917,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:15','1','SN 1939B',NULL,98917,30.7,0.36,13.8,41503,NULL,NULL,NULL,'MESSIER 059',NULL,'1992ApJ...390L..45P',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98918,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:15','1','SN 1939B',NULL,98918,31,0.5,15.8,41503,NULL,NULL,NULL,'MESSIER 059',NULL,'2011A&A...532A.154C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98919,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:15','1','SN 1939B',NULL,98919,31.1,0.4,16,41503,NULL,NULL,'Photographic','MESSIER 059',NULL,'1982ApJ...254....1A',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98920,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:15','1','SN 1939B','R',98920,31.82,NULL,23.1,41503,NULL,NULL,'Photographic','MESSIER 059',NULL,'1988SSRv...48....1R',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98921,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98921,30.73,0.2,14,41503,NULL,NULL,'I','MESSIER 059',NULL,'1990AJ....100.1416T',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98922,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98922,30.76,0.21,14.2,41503,NULL,NULL,'V Theoretical - SSP','MESSIER 059',NULL,'2011A&A...532A.154C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98923,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98923,30.82,0.1,14.6,41503,NULL,NULL,'I','MESSIER 059',NULL,'2000ApJ...536..255N',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98924,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98924,30.85,0.13,14.8,41503,NULL,NULL,'HST KP Calibrated, F814W','MESSIER 059',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98925,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98925,30.86,0.07,14.9,41503,NULL,NULL,'HST ACS VCS','MESSIER 059',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98926,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98926,30.87,0.06,14.9,41503,NULL,NULL,NULL,'MESSIER 059',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98927,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98927,30.91,0.21,15.2,41503,NULL,NULL,'V Empirical','MESSIER 059',NULL,'2011A&A...532A.154C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98928,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98928,30.93,0.21,15.3,41503,NULL,NULL,'R Theoretical - SSP','MESSIER 059',NULL,'2011A&A...532A.154C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98929,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98929,30.93,0.12,15.4,41503,74.4,NULL,NULL,'MESSIER 059',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98930,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98930,30.96,0.11,15.6,41503,NULL,NULL,'Median','MESSIER 059',NULL,'2011A&A...532A.154C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98931,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98931,30.99,0.21,15.8,41503,NULL,NULL,'V Theoretical - CSP','MESSIER 059',NULL,'2011A&A...532A.154C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98932,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98932,31,0.13,15.8,41503,NULL,NULL,'K','MESSIER 059',NULL,'1994ApJ...433..567P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98933,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98933,31.04,0.21,16.1,41503,NULL,NULL,'R Theoretical - CSP','MESSIER 059',NULL,'2011A&A...532A.154C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98934,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98934,31.05,0.21,16.2,41503,NULL,NULL,'R Empirical','MESSIER 059',NULL,'2011A&A...532A.154C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98935,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98935,31.06,0.16,16.3,41503,NULL,NULL,'I','MESSIER 059',NULL,'1997AJ....114..626A',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98936,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98936,31.31,0.2,18.3,41503,NULL,NULL,'I','MESSIER 059',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98937,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98937,31.31,0.2,18.3,41503,NULL,NULL,NULL,'MESSIER 059',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98938,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98938,31.35,0.2,18.7,41503,NULL,NULL,'Malmquist cor.','MESSIER 059',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98939,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98939,31.37,0.22,18.8,41503,NULL,NULL,'HST KP Calibrated, I','MESSIER 059',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98940,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98940,31.41,0.19,19.1,41503,NULL,NULL,'HST KP Calibrated, Ks','MESSIER 059',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98941,'GC radius','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98941,31.01,0.06,15.9,41503,NULL,NULL,NULL,'MESSIER 059',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98942,'D-Sigma','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98942,31.13,0.4,16.8,41503,75,NULL,'Edat, raw','MESSIER 059',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98943,'D-Sigma','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98943,31.15,0.4,17,41503,75,NULL,'Edat, cor','MESSIER 059',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98944,'Faber-Jackson','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98944,30.58,0.29,13.1,41503,95,NULL,'Weighted Mean','MESSIER 059',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98945,'Faber-Jackson','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98945,30.61,0.47,13.2,41503,95,NULL,'de Vaucouleurs','MESSIER 059',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98946,'Faber-Jackson','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98946,30.79,0.63,14.4,41503,95,NULL,'Michard 1979b, c','MESSIER 059',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98947,'Faber-Jackson','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98947,31.01,0.46,15.9,41503,95,NULL,'Michard 1979a','MESSIER 059',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98948,'Faber-Jackson','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98948,31.11,NULL,16.7,41503,NULL,NULL,'LEDA [April 2006]','MESSIER 059',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98949,'Faber-Jackson','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98949,31.19,0.81,17.3,41503,55,NULL,'Visvanathan & Sandage 1979','MESSIER 059',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98950,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98950,30.82,NULL,14.6,41503,NULL,NULL,NULL,'MESSIER 059',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98951,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98951,30.93,0.12,15.4,41503,74.4,NULL,NULL,'MESSIER 059',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98952,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98952,30.95,NULL,15.5,41503,NULL,NULL,NULL,'MESSIER 059',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98953,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98953,30.97,0.41,15.6,41503,NULL,NULL,NULL,'MESSIER 059',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98954,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98954,31.19,0.41,17.3,41503,NULL,NULL,'Malmquist cor.','MESSIER 059',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98955,'Tertiary','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98955,30.49,0.25,12.5,41503,95,NULL,NULL,'MESSIER 059',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98956,'Tully est','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98956,31.13,0.8,16.8,41503,75,NULL,'B','MESSIER 059',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98957,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98957,36.46,0.46,196,41504,70,NULL,NULL,'2MASX J12420283+1227426',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000182,NULL,'16.1g',0.37,NULL,NULL,NULL,NULL,NULL,1,190.511917,12.46194,0.073,NULL,58150342027,908599094,14196860,16.1),(98958,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98958,36.26,0.33,178,41505,70,NULL,NULL,'2MASX J12420434+2723465',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000163,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,190.51825,27.39639,0.111,NULL,58734663002,917729109,14339517,16.4),(98959,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98959,38.38,0.46,475,41506,70,NULL,NULL,'SDSS J124206.21+022742.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000089,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,190.525875,2.46169,0.011,NULL,58218338854,909661544,14213461,18.3),(98960,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98960,37.36,0.46,296,41507,70,NULL,NULL,'2MASX J12420723+0301312',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000165,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,190.5300417,3.02531,0.06,NULL,58232482242,909882535,14216914,16.7),(98961,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98961,37.33,0.27,293,41508,70,NULL,NULL,'2MASX J12420737+1529196',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000175,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,190.530667,15.48889,0.031,NULL,58887400043,920115625,14376806,16.9),(98962,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98962,37.75,0.17,355,41509,70,NULL,NULL,'SDSS J124207.40+092611.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,190.530833,9.4365,0,NULL,58197452305,909335192,14208362,18.3),(98963,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98963,38.18,0.33,433,41510,70,NULL,NULL,'2MASX J12420763+0315252',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,'FoF','17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,190.53175,3.25703,0.12,NULL,58232616658,909884635,14216947,17.2),(98964,'TRGB','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98964,29.26,0.04,7.11,41511,NULL,NULL,NULL,'NGC 4631',NULL,'2006astro.ph..3457T',2006,1,15.5,NULL,'G',0.00001,NULL,'9.75',2.7,'SB(s)d         HII','Pair member (points to parent)',NULL,NULL,NULL,1,190.533375,32.5415,0.027,NULL,58742503533,917851617,14341431,9.75),(98965,'TRGB','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98965,29.33,0.1,7.35,41511,74.4,NULL,NULL,'NGC 4631',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98966,'TRGB','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98966,29.34,0.06,7.4,41511,NULL,NULL,'I','NGC 4631',NULL,'2011ApJS..195...18R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98967,'TRGB','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98967,29.38,0.06,7.52,41511,NULL,NULL,NULL,'NGC 4631',NULL,'2016MNRAS.457.1419M',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98968,'TRGB','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98968,29.41,0.04,7.62,41511,NULL,NULL,'disk','NGC 4631',NULL,'2005AJ....129.1331S',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98969,'CO ring diameter','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98969,28.01,NULL,4,41511,NULL,NULL,NULL,'NGC 4631',NULL,'1991PASJ...43..671S',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98970,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98970,27.53,NULL,3.2,41511,75,NULL,'CO','NGC 4631',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98971,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98971,27.84,NULL,3.7,41511,75,NULL,'HI','NGC 4631',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98972,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98972,27.85,NULL,3.72,41511,NULL,NULL,'LEDA [Oct 2006]','NGC 4631',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98973,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98973,28.06,NULL,4.1,41511,65.2,NULL,'CO','NGC 4631',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98974,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98974,28.54,NULL,5.1,41511,54,NULL,'HI','NGC 4631',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98975,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98975,28.77,0.36,5.68,41511,NULL,NULL,NULL,'NGC 4631',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98976,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98976,29.19,0.4,6.9,41511,75,NULL,'B','NGC 4631',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98977,'IRAS','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98977,32.53,0.8,32.1,41512,75,NULL,'MAT, I','NGC 4603D',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.08',1.1,'SA(r)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,190.53375,-40.82086,0.501,NULL,46749428444,730459819,11413434,14.08),(98978,'Tully est','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98978,33.33,0.8,46.4,41512,75,NULL,NULL,'NGC 4603D',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98979,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98979,32.59,0.43,33,41512,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4603D',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98980,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98980,32.67,0.43,34.1,41512,75,NULL,'3.6 micron, color corrected','NGC 4603D',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98981,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98981,32.72,0.2,35,41512,74.4,NULL,NULL,'NGC 4603D',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98982,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98982,33.08,0.4,41.4,41512,NULL,NULL,'mean','NGC 4603D',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98983,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98983,33.34,0.32,46.6,41512,85,NULL,'I, raw','NGC 4603D',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98984,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98984,33.38,0.1,47.5,41512,NULL,NULL,NULL,'NGC 4603D',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98985,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98985,33.39,0.43,47.6,41512,75,NULL,'MAT, I, raw','NGC 4603D',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98986,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98986,33.39,0.32,47.7,41512,85,NULL,'I, inv','NGC 4603D',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98987,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98987,33.51,0.46,50.3,41512,NULL,NULL,'J','NGC 4603D',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98988,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98988,33.54,0.47,51.1,41512,NULL,NULL,'H','NGC 4603D',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98989,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98989,33.55,0.43,51.3,41512,75,NULL,'MAT, I, cor','NGC 4603D',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98990,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98990,33.58,0.45,52,41512,NULL,NULL,'K','NGC 4603D',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98991,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98991,33.6,0.43,52.6,41512,75,NULL,'MAT, I, inv','NGC 4603D',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98992,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98992,37.83,0.46,369,41513,70,NULL,NULL,'2MASX J12420807+6446199',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000183,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,190.533916667,64.77225,0,NULL,57367107102,896361048,14005641,16.8),(98993,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98993,34.6,0.59,83,41514,70,NULL,NULL,'IC 0806',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'15.10',0.9,'(R)SB(rs)a',NULL,NULL,NULL,NULL,1,190.535125,-17.34936,0.089,NULL,43933720567,686464383,10726005,15.1),(98994,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98994,37.65,0.33,339,41515,70,NULL,NULL,'SDSS J124208.45+213714.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,190.53525,21.62061,0.124,NULL,58904591868,920384247,14381003,18.5),(98995,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98995,37.95,0.46,389,41516,70,NULL,NULL,'2MASX J12420846+2422265',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,190.535375,24.37394,0.036,NULL,58605724097,915714439,14308038,17.8),(98996,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',98996,38.56,0.46,516,41517,70,NULL,NULL,'2MASX J12420871+1704406',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,190.536167,17.07806,0.037,NULL,58877192848,919956138,14374314,NULL),(98997,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98997,30.96,0.21,15.6,41518,NULL,NULL,'TOM(g) = -7.2 mag','IC 0809',NULL,'2010ApJ...717..603V',2010,1,0.9,NULL,'G',0.000087,NULL,'14.50',0.9,'dE1,N','Group member',NULL,NULL,NULL,1,190.536083,11.75428,0.079,NULL,58150564559,908602571,14196915,14.5),(98998,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98998,30.99,0.24,15.8,41518,NULL,NULL,'TOM(g) = -7.2 mag','IC 0809',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98999,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,98999,31.06,0.22,16.3,41518,NULL,NULL,'TOM(u) = -8.4 mag','IC 0809',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99000,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99000,31.16,0.21,17.1,41518,NULL,NULL,'TOM(z) = -8.53 mag','IC 0809',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99001,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99001,31.01,0.14,15.9,41518,74.4,NULL,NULL,'IC 0809',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99002,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99002,31.03,0.07,16,41518,NULL,NULL,'HST ACS VCS','IC 0809',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99003,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99003,31.03,0.06,16.1,41518,NULL,NULL,NULL,'IC 0809',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99004,'GC radius','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99004,30.64,0.15,13.4,41518,NULL,NULL,NULL,'IC 0809',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99005,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99005,35.43,0.63,122,41519,70,NULL,NULL,'2MASX J12420882-1549169',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.24',NULL,NULL,NULL,NULL,NULL,NULL,1,190.536583,-15.82153,0.029,NULL,43939063103,686547860,10727310,16.24),(99006,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99006,37.96,0.14,391,41520,70,NULL,NULL,'SDSS J124208.91-020844.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000073,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,190.537167,-2.14564,0.021,NULL,43170989236,674546706,10539792,18.5),(99007,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99007,37.65,0.33,339,41521,70,NULL,NULL,'2MASX J12420901+2140145',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,190.537625,21.67069,0.124,NULL,58904578778,920384043,14381000,17),(99008,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99008,38.19,0.46,435,41522,70,NULL,NULL,'SDSS J124209.08+544938.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000168,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,190.537875,54.82744,0,NULL,57399082724,896860667,14013447,18.3),(99009,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99009,37.75,0.17,355,41523,70,NULL,NULL,'2MASX J12420928+0928459',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.17',0.14,'AGN',NULL,NULL,NULL,NULL,1,190.538625,9.47939,0,NULL,58197450965,909335171,14208362,18.17),(99010,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99010,37.56,0.46,326,41524,70,NULL,NULL,'2MASX J12420931+2511045',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,190.5387917,25.18467,0.038,NULL,58604255381,915691490,14307679,17.5),(99011,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99011,38.18,0.33,433,41525,70,NULL,NULL,'SDSS J124209.38+032107.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000155,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,190.539125,3.35203,0.056,NULL,58232581749,909884089,14216938,18.4),(99012,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99012,38.28,0.46,454,41526,70,NULL,NULL,'2MASX J12421026+4202211',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000202,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,190.542791667,42.03922,0,NULL,59116289210,923692018,14432687,16.9),(99013,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99013,37.96,0.14,391,41527,70,NULL,NULL,'SDSS J124210.43-020654.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000082,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,190.5435,-2.11506,0.037,NULL,43171853698,674560214,10540003,18.3),(99014,'Black Hole','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99014,35.94,0.8,155,41528,NULL,NULL,NULL,'WAS 61',NULL,'2014ApJ...793..108W',2014,1,0.33,NULL,'G',0.001291,NULL,'15.7g',0.23,'S0?            Sy1',NULL,NULL,NULL,'NL Sy 1',1,190.544167,33.28406,0,NULL,58742737551,917855274,14341488,15.7),(99015,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99015,30.89,0.11,15.1,41529,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4623',NULL,'2010ApJ...717..603V',2010,1,2.2,NULL,'G',0.000017,NULL,'13.24',0.7,'SB0+: sp','in a radial-velocity based grouping',NULL,NULL,NULL,1,190.5445417,7.67694,0,NULL,58195962450,909311913,14207998,13.24),(99016,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99016,30.96,0.14,15.6,41529,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4623',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99017,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99017,31.15,0.14,17,41529,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4623',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99018,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99018,31.21,0.12,17.5,41529,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4623',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99019,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99019,31.17,0.14,17.1,41529,74.4,NULL,NULL,'NGC 4623',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99020,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99020,31.19,0.07,17.3,41529,NULL,NULL,'HST ACS VCS','NGC 4623',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99021,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99021,31.2,0.06,17.4,41529,NULL,NULL,NULL,'NGC 4623',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99022,'GC radius','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99022,30.43,0.09,12.2,41529,NULL,NULL,NULL,'NGC 4623',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99023,'Faber-Jackson','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99023,30.82,0.65,14.6,41529,95,NULL,'Weighted Mean','NGC 4623',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99024,'Faber-Jackson','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99024,31.99,0.81,25,41529,55,NULL,'Visvanathan & Sandage 1979','NGC 4623',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99025,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99025,30.63,NULL,13.4,41529,NULL,NULL,NULL,'NGC 4623',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99026,'Tertiary','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99026,30.49,0.25,12.5,41529,95,NULL,NULL,'NGC 4623',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99027,'Tully est','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99027,31.13,0.8,16.8,41529,75,NULL,'B','NGC 4623',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99028,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99028,30.86,0.45,14.8,41529,NULL,NULL,'K','NGC 4623',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99029,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99029,32.09,0.4,26.1,41529,NULL,NULL,'mean','NGC 4623',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99030,'IRAS','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99030,35.02,0.8,101,41530,75,NULL,'MAT, I','ESO 507- G 002',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'16.08',0.5,'SB...',NULL,NULL,NULL,NULL,1,190.5472917,-25.42864,0.369,NULL,43388781819,677949715,10592964,16.08),(99031,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99031,34.67,0.32,85.8,41530,85,NULL,'I, raw','ESO 507- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99032,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99032,34.69,0.32,86.8,41530,85,NULL,'I, inv','ESO 507- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99033,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99033,34.84,0.43,92.9,41530,75,NULL,'MAT, I, raw','ESO 507- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99034,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99034,34.97,0.43,98.8,41530,75,NULL,'MAT, I, inv','ESO 507- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99035,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99035,35.02,0.2,101,41530,74.4,NULL,NULL,'ESO 507- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99036,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99036,35.05,0.43,102,41530,75,NULL,'MAT, I, cor','ESO 507- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99037,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99037,35.15,0.45,107,41530,NULL,NULL,'Malmquist cor.','ESO 507- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99038,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99038,35.16,0.45,108,41530,NULL,NULL,NULL,'ESO 507- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99039,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:15','1','SN 2007cp',NULL,99039,35.06,0.29,99.1,41531,74.2,NULL,'SALT 2','IC 0807',0.0377,'2010ApJ...716..712A',2010,1,0.3,NULL,'G',0.00014,NULL,'14.25',0.2,NULL,NULL,NULL,NULL,NULL,1,190.5520417,-17.40356,0.089,NULL,43933541716,686461589,10725962,14.25),(99040,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:15','1','SN 2007cp',NULL,99040,35.64,0.1,134,41531,74.4,NULL,NULL,'IC 0807',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99041,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:15','1','SN 2007cp',NULL,99041,35.94,0.28,148,41531,73.8,NULL,'SALT 2 (SNANA)','IC 0807',0.0377,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99042,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:15','1','SN 2007cp','R',99042,35.95,0.17,155,41531,NULL,NULL,'MLCS2k2, R(V) = 1.8','IC 0807',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99043,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:15','1','SN 2007cp','R',99043,35.99,0.18,158,41531,NULL,NULL,'MLCS2k2, R(V) = 3.1','IC 0807',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99044,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99044,34.34,0.49,73.8,41531,70,NULL,NULL,'IC 0807',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99045,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99045,37.75,0.17,355,41532,70,NULL,NULL,'2MASX J12421259+0929269',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.43',0.14,'BrClG',NULL,NULL,NULL,NULL,1,190.552417,9.49078,0,NULL,58197459085,909335298,14208364,18.43),(99046,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99046,38.04,0.46,405,41533,70,NULL,NULL,'2MASX J12421382+3926165',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000129,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,190.5575417,39.43786,0,NULL,59084740751,923199074,14424985,18.2),(99047,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99047,35.72,0.58,139,41534,70,NULL,NULL,'2MASX J12421495-4648293',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.2,NULL,NULL,NULL,NULL,NULL,1,190.562416667,-46.80822,0.537,NULL,46770663884,730791623,11418619,14.2),(99048,'Brightest Stars','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99048,27.37,NULL,3,41535,NULL,NULL,NULL,'IC 3687',NULL,'1998A&AS..128..459M',1998,1,3.4,NULL,'G',0.000003,NULL,'13.71',3,'IAB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,190.562917,38.50333,0,1,58559177058,914987141,14296674,13.71),(99049,'TRGB','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99049,28.08,0.08,4.12,41535,NULL,NULL,NULL,'IC 3687',NULL,'2013AstBu..68..125M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99050,'TRGB','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99050,28.09,0.12,4.15,41535,NULL,NULL,NULL,'IC 3687',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99051,'TRGB','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99051,28.3,0.24,4.57,41535,NULL,NULL,NULL,'IC 3687',NULL,'2003A&A...398..467K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99052,'TRGB','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99052,28.3,0.08,4.57,41535,NULL,NULL,'I','IC 3687',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99053,'TRGB','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99053,28.3,0.1,4.57,41535,74.4,NULL,NULL,'IC 3687',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99054,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99054,28.28,0.4,4.5,41535,75,NULL,'B','IC 3687',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99055,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99055,35.31,NULL,115,41536,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1488',NULL,'2010Ap&SS.325..163P',2010,1,1.04,NULL,'G',0.000108,NULL,'16.8g',0.12,'Scd',NULL,NULL,NULL,NULL,1,190.565667,39.56464,0,NULL,59084752075,923199251,14424988,16.8),(99056,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99056,35.32,NULL,116,41536,NULL,NULL,'Dipole + Quadrupole','FGC 1488',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99057,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99057,35.34,NULL,117,41536,NULL,NULL,'Dipole','FGC 1488',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99058,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99058,35.36,NULL,118,41536,NULL,NULL,NULL,'FGC 1488',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99059,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99059,38.2,0.46,437,41537,70,NULL,NULL,'2MASX J12421598+5126033',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000174,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,190.5664583,51.43419,0,NULL,57204190130,893815470,13965866,16.9),(99060,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99060,38.14,0.46,424,41538,70,NULL,NULL,'2MASX J12421603+2017055',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,190.566667,20.28469,0.125,NULL,58899411378,920303302,14379739,18.2),(99061,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99061,32.98,0.24,39.4,41539,NULL,NULL,'I','NGC 4616',NULL,'2001ApJ...546..681T',2001,1,0.9,NULL,'G',0.000087,NULL,'14.43',0.8,'E+:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,190.5685417,-40.64206,0.501,NULL,46749395402,730459303,11413426,14.43),(99062,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99062,32.98,0.24,39.4,41539,NULL,NULL,NULL,'NGC 4616',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99063,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99063,33.13,0.24,42.2,41539,NULL,NULL,'Malmquist cor.','NGC 4616',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99064,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99064,33.17,0.12,43.1,41539,74.4,NULL,NULL,'NGC 4616',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99065,'D-Sigma','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99065,32.78,0.4,35.9,41539,75,NULL,'Edat, raw','NGC 4616',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99066,'D-Sigma','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99066,32.87,0.22,37.5,41539,70,NULL,'CEN 45, 100 galaxies','NGC 4616',NULL,'1988MNRAS.235.1177L',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99067,'D-Sigma','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99067,32.88,0.4,37.6,41539,75,NULL,'Edat, cor','NGC 4616',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99068,'D-Sigma','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99068,32.91,0.33,38.2,41539,70,NULL,'CEN 45, 100 galaxies','NGC 4616',NULL,'1988MNRAS.235.1177L',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99069,'D-Sigma','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99069,33.11,0.16,41.8,41539,72,NULL,'Cen 45 Cluster, 8 galaxies','NGC 4616',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99070,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99070,33.17,0.12,43.1,41539,74.4,NULL,NULL,'NGC 4616',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99071,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99071,33.85,0.41,58.9,41539,NULL,NULL,NULL,'NGC 4616',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99072,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99072,33.92,0.41,60.9,41539,NULL,NULL,'Malmquist cor.','NGC 4616',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99073,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99073,34.04,0.4,64.2,41539,NULL,NULL,'mean','NGC 4616',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99074,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99074,34.07,0.18,65.2,41539,70,NULL,'Cen 45 Cluster','NGC 4616',NULL,'1992ApJ...396..453H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99075,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99075,34.17,NULL,68.2,41539,71,NULL,'CEN 45, 100 galaxies','NGC 4616',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99076,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99076,34.24,0.3,70.5,41539,NULL,NULL,'CEN 45, 8 galaxies','NGC 4616',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99077,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99077,34.39,0.45,75.6,41539,NULL,NULL,'K','NGC 4616',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99078,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99078,38.39,0.46,476,41540,70,NULL,NULL,'SDSS J124217.09-022026.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000065,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,190.5712083,-2.34072,0.037,NULL,43170586253,674540410,10539693,18.4),(99079,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99079,37.33,0.27,293,41541,70,NULL,NULL,'2MASX J12421734+1527366',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,190.572375,15.46036,0.031,NULL,58887401064,920115641,14376806,18.1),(99080,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99080,36.05,0.66,162,41542,70,NULL,NULL,'2MASX J12421790-1128116',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.71',0.3,NULL,NULL,NULL,NULL,NULL,1,190.574583,-11.47008,0.129,NULL,43033854872,672403982,10506312,16.71),(99081,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99081,38.09,0.33,415,41543,70,NULL,NULL,'2MASX J12421796+1032079',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,190.574875,10.53556,0,NULL,58187522480,909180038,14205938,18),(99082,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99082,35.56,0.65,130,41544,70,NULL,NULL,'LCRS B123943.4-053040',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'14.82',0.19,NULL,NULL,NULL,NULL,NULL,1,190.576166667,-5.78503,0.029,NULL,43210118744,675158105,10549345,14.82),(99083,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99083,37.18,0.46,273,41545,70,NULL,NULL,'VII Zw 479',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000173,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,190.579917,63.23386,0,NULL,57376496397,896507756,14007933,16.8),(99084,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99084,35.67,0.46,136,41546,70,NULL,NULL,'2MASX J12421982+4526162',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'16.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,190.582416667,45.43786,0,NULL,59111676511,923619945,14431561,16.5),(99085,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99085,37.65,0.46,339,41547,70,NULL,NULL,'2MASX J12422151+0010382',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000085,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,190.589583,0.17711,0,NULL,57999003913,906234436,14159913,17.2),(99086,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99086,37.24,0.46,281,41548,70,NULL,NULL,'2MASX J12422166+3214190',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,190.590375,32.23861,0.022,NULL,58772739716,918324058,14348813,17),(99087,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99087,37.56,0.09,324,41549,70,NULL,NULL,'2MASX J12422208+1834415',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.3',0.22,NULL,'Group member',NULL,NULL,NULL,1,190.592083,18.57833,0.027,NULL,58908769283,920449520,14382023,16.3),(99088,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99088,37.37,0.46,298,41550,70,NULL,NULL,'2MASX J12422371+6008048',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000162,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,190.5989583,60.13458,0,NULL,57332813039,895825203,13997268,16.9),(99089,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99089,37.96,0.14,391,41551,70,NULL,NULL,'2MASX J12422388-0221521',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000077,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,190.599375,-2.36442,0.037,NULL,43170566785,674540106,10539689,18.1),(99090,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99090,37.57,0.46,327,41552,70,NULL,NULL,'2MASX J12422397+0025422',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000077,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,190.600125,0.42819,0,NULL,57998933734,906233339,14159895,17.9),(99091,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99091,37.83,0.46,369,41553,70,NULL,NULL,'SDSS J124224.12+464940.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000138,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,190.600583,46.82781,0,NULL,59114487749,923663871,14432247,18.6),(99092,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99092,37.96,0.14,391,41554,70,NULL,NULL,'2MASX J12422427-0202551',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000073,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,190.60125,-2.04861,0.021,NULL,43171846188,674560096,10540001,17.1),(99093,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99093,38.09,0.33,415,41555,70,NULL,NULL,'2MASX J12422441+1032098',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.63',0.14,NULL,NULL,NULL,NULL,NULL,1,190.601625,10.53597,0,NULL,58187522657,909180041,14205938,18.63),(99094,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99094,37.96,0.14,391,41556,70,NULL,NULL,'2MASX J12422468-0219551',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000079,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,190.602667,-2.33189,0.037,NULL,43170582679,674540354,10539693,18.2),(99095,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99095,33.16,0.4,42.8,41557,NULL,NULL,'mean','NGC 4628',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.00003,NULL,'12.84',0.5,'SA(s)b: sp     Sy2',NULL,NULL,NULL,'Sy 2',1,190.60525,-6.971,0.045,NULL,43155706819,674307919,10536061,12.84),(99096,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99096,33.17,0.4,43,41557,75,NULL,NULL,'NGC 4628',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99097,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99097,33.26,0.45,44.8,41557,NULL,NULL,'K','NGC 4628',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99098,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99098,33.31,0.47,46,41557,NULL,NULL,'H','NGC 4628',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99099,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99099,33.32,0.46,46.1,41557,NULL,NULL,'J','NGC 4628',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99100,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99100,33.74,0.49,56,41557,75,NULL,'IR','NGC 4628',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99101,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99101,36.11,0.33,167,41558,70,NULL,NULL,'2MASX J12422548+6429188',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000169,NULL,'16.6g',0.29,'Candidate      BLLAC',NULL,NULL,NULL,'BL Lac',1,190.6057917,64.48861,0,NULL,57369269055,896394828,14006169,16.6),(99102,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99102,38.11,0.46,420,41559,70,NULL,NULL,'SDSS J124226.64+290656.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'19.48',0.15,NULL,NULL,NULL,NULL,NULL,1,190.611,29.11572,0.073,NULL,58732893471,917701460,14339085,19.48),(99103,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99103,36.86,0.46,235,41560,70,NULL,NULL,'2MASX J12422796+5735556',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000153,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,190.616375,57.59881,0,NULL,57405492592,896960821,14015012,16.9),(99104,'GRB','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99104,43.07,NULL,4110,41561,70,NULL,'Pseudo z = 5.88','GRB 020305',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'G',NULL,NULL,'25.1R',NULL,'HETE',NULL,NULL,NULL,NULL,1,190.6165,-14.30319,0.085,NULL,43925384916,686334139,10723970,25.1),(99105,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99105,36.49,0.54,199,41562,70,NULL,NULL,'2MASX J12422835-1053554',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00011,NULL,'15.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,190.618167,-10.89883,0.093,NULL,43154522827,674289419,10535772,15.7),(99106,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99106,37.75,0.17,355,41563,70,NULL,NULL,'2MASX J12422839+0929518',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.34',0.14,NULL,NULL,NULL,NULL,NULL,1,190.618333,9.49772,0,NULL,58197438475,909334976,14208359,18.34),(99107,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99107,37.97,0.46,393,41564,70,NULL,NULL,'SDSS J124228.76+312127.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000133,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,190.619875,31.35758,0.006,NULL,58784863353,918513489,14351773,18.4),(99108,'IRAS','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99108,34.39,0.8,75.6,41565,75,NULL,'MAT, I','ESO 268- G 033',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000027,NULL,'14.70',0.4,'SB(r)bc:',NULL,NULL,NULL,NULL,1,190.623875,-47.55814,0.601,NULL,46766859617,730732181,11417690,14.7),(99109,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99109,34.19,0.43,68.8,41565,75,NULL,'MAT, I, raw','ESO 268- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99110,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99110,34.38,0.32,75,41565,85,NULL,'I, raw','ESO 268- G 033',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99111,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99111,34.38,0.49,75.1,41565,75,NULL,'IR','ESO 268- G 033',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99112,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99112,34.38,0.43,75.3,41565,75,NULL,'MAT, I, cor','ESO 268- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99113,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99113,34.4,0.4,75.9,41565,NULL,NULL,'Malmquist cor.','ESO 268- G 033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99114,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99114,34.44,0.47,77.2,41565,NULL,NULL,'H','ESO 268- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99115,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99115,34.44,0.32,77.3,41565,85,NULL,'I, inv','ESO 268- G 033',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99116,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99116,34.47,0.43,78.2,41565,75,NULL,'MAT, I, inv','ESO 268- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99117,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99117,34.51,0.4,79.9,41565,NULL,NULL,'mean','ESO 268- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99118,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99118,34.52,0.46,80.3,41565,NULL,NULL,'J','ESO 268- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99119,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99119,34.53,0.45,80.5,41565,NULL,NULL,'K','ESO 268- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99120,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99120,34.6,0.37,83.1,41565,NULL,NULL,NULL,'ESO 268- G 033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99121,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99121,34.64,0.2,84.7,41565,74.4,NULL,NULL,'ESO 268- G 033',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99122,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99122,37.96,0.14,391,41566,70,NULL,NULL,'2MASX J12423001-0211251',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00008,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,190.625,-2.19022,0.037,NULL,43170662036,674541594,10539712,17.8),(99123,'Tully est','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99123,31.26,0.8,17.9,41567,75,NULL,'B','NGC 4630',NULL,'1988NBGC.C....0000T',1988,1,1.8,NULL,'G',0.000013,NULL,'13.15',1.3,'IB(s)m?        HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,190.6297083,3.96025,0.008,NULL,58223955771,909749308,14214832,13.15),(99124,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99124,30.91,NULL,15.2,41567,NULL,NULL,NULL,'NGC 4630',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99125,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99125,31.08,0.36,16.4,41567,NULL,NULL,NULL,'NGC 4630',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99126,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99126,37.89,0.46,378,41568,70,NULL,NULL,'SDSS J124231.58+174251.1',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.1r',NULL,NULL,NULL,NULL,NULL,NULL,1,190.631667,17.71425,0.015,NULL,58907189283,920424832,14381638,17.1),(99127,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99127,37.96,0.14,391,41569,70,NULL,NULL,'2MASX J12423188-0215221',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000076,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,190.633,-2.25622,0.037,NULL,43170666826,674541669,10539713,17.4),(99128,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99128,37.73,0.27,352,41570,70,NULL,NULL,'SDSS J124232.45+421130.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,190.63525,42.19186,0,NULL,59116232817,923691137,14432674,17.9),(99129,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99129,31.56,0.4,20.6,41571,NULL,NULL,NULL,'NGC 4629',NULL,'2013MNRAS.429.2677K',2013,1,1.32,NULL,'G',0.000013,NULL,'14.3g',0.87,'SAB(s)m pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,190.636125,-1.35067,0.037,NULL,43168565033,674508828,10539200,14.3),(99130,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99130,32.59,0.43,32.9,41571,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4629',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99131,'IRAS','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99131,32.19,0.8,27.4,41572,75,NULL,'CF, r','NGC 4632',NULL,'1997ApJS..109..333W',1997,1,3.1,'Position is for 2MASX J12423203-0004571, the nucleus.','G',0.00001,NULL,'12.36',1.2,'SAc            HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,190.633458333,-0.08261,0.014,NULL,42983305242,671614144,10493971,12.36),(99132,'Tully est','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99132,30.76,0.8,14.2,41572,75,NULL,'B','NGC 4632',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99133,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99133,30.46,0.43,12.4,41572,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4632',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99134,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99134,30.62,0.43,13.3,41572,75,NULL,'3.6 micron, color corrected','NGC 4632',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99135,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99135,30.79,0.2,14.4,41572,74.4,NULL,NULL,'NGC 4632',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99136,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99136,30.99,0.38,15.8,41572,75,NULL,'CF, r, raw','NGC 4632',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99137,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99137,31,0.42,15.8,41572,NULL,NULL,NULL,'NGC 4632',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99138,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99138,31,0.38,15.9,41572,75,NULL,'CF, r, inv','NGC 4632',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99139,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99139,31.06,0.4,16.2,41572,NULL,NULL,NULL,'NGC 4632',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99140,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99140,31.12,0.4,16.7,41572,NULL,NULL,'Malmquist cor.','NGC 4632',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99141,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99141,31.2,0.38,17.4,41572,75,NULL,'CF, r, cor','NGC 4632',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99142,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99142,31.28,0.46,18,41572,NULL,NULL,'J','NGC 4632',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99143,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99143,31.39,0.47,19,41572,NULL,NULL,'H','NGC 4632',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99144,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99144,31.39,0.45,19,41572,NULL,NULL,'K','NGC 4632',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99145,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99145,31.94,0.4,24.5,41572,NULL,NULL,'mean','NGC 4632',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99146,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99146,38.43,0.46,485,41573,70,NULL,NULL,'2MASX J12423380+3414390',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,190.640625,34.24417,0,NULL,58744047195,917875737,14341808,17.8),(99147,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99147,37,0.27,251,41574,70,NULL,NULL,'LCRS B123959.6-023621',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000071,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,190.641791667,-2.87997,0.029,NULL,43181474689,674710542,10542352,17.4),(99148,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99148,37.77,0.46,358,41575,70,NULL,NULL,'2MASX J12423454+2621126',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,190.643917,26.35361,0.064,NULL,58722578881,917540295,14336567,17.8),(99149,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99149,37.8,0.33,362,41576,70,NULL,NULL,'III Zw 067 NOTES03',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.8',0.18,NULL,NULL,NULL,NULL,NULL,1,190.645,9.88681,0,NULL,58186230305,909159848,14205622,18.8),(99150,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99150,36.11,0.33,167,41577,70,NULL,NULL,'CGCG 315-053',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000153,NULL,'15.2g',0.39,'S0',NULL,NULL,NULL,NULL,1,190.646875,64.59761,0.013,NULL,57369267903,896394810,14006168,15.2),(99151,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99151,38.16,0.46,429,41578,70,NULL,NULL,'2MASX J12423598+3316538',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000164,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,190.65,33.28178,0.011,NULL,58742742220,917855347,14341489,18.1),(99152,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99152,37.21,0.46,277,41579,70,NULL,NULL,'2MASX J12423600-0113537',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000076,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,190.650125,-1.23178,0.037,NULL,43168618494,674509663,10539213,17.2),(99153,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99153,37.2,0.46,275,41580,70,NULL,NULL,'IC 3689',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'16.0g',0.37,NULL,NULL,NULL,NULL,NULL,1,190.654,20.8505,0.124,NULL,58901132833,920330200,14380159,16),(99154,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99154,36.94,0.46,245,41581,70,NULL,NULL,'2MASX J12423702+4020227',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,190.65425,40.33975,0,NULL,59085114040,923204906,14425076,17.2),(99155,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99155,38.3,0.46,456,41582,70,NULL,NULL,'SDSS J124237.03+184321.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.1g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,190.654333,18.72269,0.025,NULL,58908686639,920448228,14382003,18.1),(99156,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99156,31.48,NULL,19.8,41583,NULL,NULL,NULL,'NGC 4633',NULL,'1999MNRAS.304..595G',1999,1,2.29,NULL,'G',0.000013,NULL,'13.8g',0.83,'SAB(s)dm:      HII','Pair member (points to parent)',NULL,NULL,NULL,1,190.65575,14.35719,0.031,NULL,58872573977,919883968,14373187,13.8),(99157,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99157,31.77,0.36,22.6,41583,NULL,NULL,NULL,'NGC 4633',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99158,'Ring Diameter','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99158,32.4,0.84,30,41584,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4622',NULL,'1981ApJS...45..541P',1981,1,1.7,'Star superposed northeast of nucleus.','G',0.00013,NULL,'13.26',1.6,'SA(r)ab','in a chain',NULL,NULL,NULL,1,190.65675,-40.74422,0.501,NULL,46749422130,730459720,11413433,13.26),(99159,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99159,34.27,0.48,71.4,41584,70,NULL,NULL,'NGC 4622',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99160,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99160,38.76,0.46,565,41585,70,NULL,NULL,'SDSS J124237.67+514022.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,190.656958333,51.67281,0,NULL,57206213503,893847085,13966360,18.4),(99161,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99161,37.45,0.33,308,41586,70,NULL,NULL,'2MASX J12423803+0246365',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000173,NULL,'17.0g',NULL,NULL,NULL,NULL,NULL,NULL,1,190.6584583,2.77664,0.05,NULL,58218907054,909670422,14213600,17),(99162,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99162,37.96,0.46,391,41587,70,NULL,NULL,'SDSS J124238.22+020105.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00014,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,190.65925,2.01814,0,NULL,58220690886,909698295,14214035,18.4),(99163,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99163,37.06,0.46,259,41588,70,NULL,NULL,'2MASX J12423849+2629516',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000153,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,190.660417,26.49781,0.068,NULL,58722502675,917539104,14336548,17.6),(99164,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99164,35.7,0.46,138,41589,70,NULL,NULL,'MCG +08-23-079',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00008,NULL,'15.2g',0.54,'S0^-',NULL,NULL,NULL,NULL,1,190.6622917,48.53597,0,NULL,59094526674,923351979,14427374,15.2),(99165,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99165,37.06,0.55,258,41590,70,NULL,NULL,'2MASX J12423910-1128224',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.74',NULL,NULL,NULL,NULL,NULL,NULL,1,190.662833333,-11.47286,0.097,NULL,43033971105,672405798,10506340,16.74),(99166,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99166,29,0.69,6.31,41591,100,NULL,'mid-IR','NGC 4635',NULL,'2013ApJ...771...88L',2013,1,2,NULL,'G',0.000003,NULL,'13.20',1.4,'SAB(s)d        AGN?','Isolated galaxy',NULL,NULL,NULL,1,190.6635,19.94531,0.126,NULL,58899528566,920305133,14379767,13.2),(99167,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99167,31.86,0.4,23.5,41591,75,NULL,'B','NGC 4635',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99168,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99168,36.62,0.56,210,41592,70,NULL,NULL,'LCRS B124005.0-023615',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00011,NULL,'16.0g',0.45,'E0',NULL,NULL,NULL,NULL,1,190.664125,-2.87831,0.029,NULL,43181474433,674710538,10542352,16),(99169,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99169,37,0.27,251,41592,70,NULL,NULL,'LCRS B124005.0-023615',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99170,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99170,37.96,0.14,391,41593,70,NULL,NULL,'2MASX J12423946-0214177',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000102,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,190.664375,-2.23831,0.037,NULL,43170665961,674541655,10539713,17),(99171,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99171,37.8,0.33,362,41594,70,NULL,NULL,'III Zw 067 NOTES04',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'18.3',0.24,NULL,NULL,NULL,NULL,NULL,1,190.666,9.87258,0,NULL,58186231207,909159862,14205622,18.3),(99172,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99172,37.52,0.46,319,41595,70,NULL,NULL,'2MASX J12424042+6753423',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000089,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,190.6687917,67.89514,0.021,NULL,57863017497,904109648,14126713,16.8),(99173,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99173,33.98,0.2,62.5,41596,74.4,NULL,NULL,'UGC 07873',NULL,'2013AJ....146...86T',2013,1,1.36,'The APM position is 8\\\" northwest of the nucleus.','G',0.000149,NULL,'14.6g',0.78,'SA(rs)c:',NULL,NULL,NULL,NULL,1,190.669667,1.34578,0,NULL,58217268243,909644816,14213200,14.6),(99174,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99174,34.24,0.38,70.4,41596,NULL,NULL,NULL,'UGC 07873',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99175,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99175,34.25,0.37,70.6,41596,NULL,NULL,'Malmquist cor.','UGC 07873',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99176,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99176,37.75,0.17,355,41597,70,NULL,NULL,'2MASX J12424082+0925498',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,190.670125,9.43061,0,NULL,58197471600,909335493,14208367,17.1),(99177,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99177,35.37,0.51,119,41598,70,NULL,NULL,'2MASX J12424140-4231302',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000113,NULL,'13.5I',0.4,NULL,NULL,NULL,NULL,NULL,1,190.6724583,-42.52506,0.401,NULL,46765105098,730704767,11417261,13.5),(99178,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99178,36.43,0.57,193,41599,70,NULL,NULL,'2MASX J12424155-1128484',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,190.673125,-11.48017,0.097,NULL,43033970852,672405794,10506340,15.6),(99179,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99179,37.46,0.46,310,41600,70,NULL,NULL,'2MASXi J1242421+244312',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,190.675667,24.72031,0.011,NULL,58606050370,915719537,14308117,17.9),(99180,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99180,37.45,0.33,308,41601,70,NULL,NULL,'2MASX J12424244+0247035',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000204,NULL,'16.2g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,190.676875,2.78431,0.05,NULL,58218908776,909670449,14213600,16.2),(99181,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99181,34.46,0.4,78,41602,NULL,NULL,'mean','NGC 4644',NULL,'2007A&A...465...71T',2007,1,1.74,NULL,'G',0.00013,NULL,'14.4g',0.42,'Sb','Pair member (points to parent)',NULL,NULL,NULL,1,190.67775,55.1455,0.017,NULL,57399127685,896861370,14013458,14.4),(99182,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99182,34.68,0.47,86.1,41602,NULL,NULL,'H','NGC 4644',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99183,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99183,34.74,0.46,88.7,41602,NULL,NULL,'J','NGC 4644',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99184,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,NULL,99184,34.74,0.45,88.7,41602,NULL,NULL,'K','NGC 4644',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99185,'FP','2016-12-15 15:15:04','2016-12-16 11:20:15','1',NULL,'R',99185,36.94,0.46,245,41603,70,NULL,NULL,'2MASX J12424334+0427535',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000172,NULL,'16.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,190.680667,4.46478,0,NULL,58225202106,909768782,14215137,16.4),(99186,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99186,36.95,0.46,246,41604,70,NULL,NULL,'2MASX J12424494+1247331',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.03',0.16,NULL,NULL,NULL,NULL,NULL,1,190.68725,12.79253,0.065,NULL,58871994435,919874913,14373045,18.03),(99187,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99187,37.2,0.33,275,41605,70,NULL,NULL,'2MASX J12424508+0900068',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.07',0.21,NULL,NULL,NULL,NULL,NULL,1,190.6879583,9.00192,0,NULL,58198056501,909344632,14208509,17.07),(99188,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99188,37.92,0.33,384,41606,70,NULL,NULL,'2MASX J12424620+0032235',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000091,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,190.692458333,0.53986,0,NULL,57998910203,906232971,14159890,17),(99189,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99189,38.45,0.46,489,41607,70,NULL,NULL,'2MASX J12424614+3755206',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000171,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,190.692458333,37.92247,0,NULL,58558916246,914983066,14296610,17.8),(99190,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99190,37.01,0.46,253,41608,70,NULL,NULL,'2MASX J12424637+0938568',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,190.6932917,9.64897,0,NULL,58186116878,909158076,14205594,17),(99191,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99191,37.73,0.27,352,41609,70,NULL,NULL,'2MASX J12424656+4215512',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,190.6939583,42.26431,0,NULL,59116415358,923693989,14432718,17.2),(99192,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99192,36.5,0.46,199,41610,70,NULL,NULL,'2MASX J12424665+4231262',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000168,NULL,'16.1g',0.37,'S0',NULL,NULL,NULL,NULL,1,190.6942917,42.52408,0,NULL,59115958004,923686843,14432606,16.1),(99193,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99193,34.75,0.11,89.3,41611,NULL,NULL,NULL,'UGC 07877',NULL,'2009ApJS..182..474S',2009,1,1.02,NULL,'G',0.00001,NULL,'16.0g',0.26,'Sb','Group member, peripheral',NULL,NULL,NULL,1,190.696667,27.27194,0.111,NULL,58734589363,917727958,14339499,16),(99194,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99194,35.03,0.43,101,41611,75,NULL,'3.6 micron, color corrected','UGC 07877',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99195,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99195,35.06,0.2,103,41611,74.4,NULL,NULL,'UGC 07877',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99196,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99196,35.08,0.43,104,41611,75,NULL,'3.6 micron, color + selection bias corrected','UGC 07877',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99197,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99197,36.93,0.46,244,41612,70,NULL,NULL,'2MASX J12424728+1059048',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.37',0.14,NULL,NULL,NULL,NULL,NULL,1,190.696958333,10.98478,0,NULL,58187212782,909175199,14205862,18.37),(99198,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99198,30.97,0.13,15.6,41613,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4638',NULL,'2010ApJ...717..603V',2010,1,2.17,'Identification as NGC 4667 is not certain.','G',0.000017,NULL,'12.1g',1.27,'S0-','in a radial-velocity based grouping',NULL,NULL,NULL,1,190.697583333,11.4425,0.04,NULL,58183808071,909122001,14205031,12.1),(99199,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99199,31,0.15,15.8,41613,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4638',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99200,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99200,31.23,0.14,17.6,41613,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4638',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99201,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99201,31.32,0.13,18.4,41613,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4638',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99202,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99202,31.17,0.14,17.1,41613,74.4,NULL,NULL,'NGC 4638',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99203,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99203,31.19,0.07,17.3,41613,NULL,NULL,'HST ACS VCS','NGC 4638',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99204,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99204,31.21,0.05,17.5,41613,NULL,NULL,NULL,'NGC 4638',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99205,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99205,31.68,0.26,21.7,41613,NULL,NULL,'I','NGC 4638',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99206,'GC radius','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99206,30.54,0.1,12.8,41613,NULL,NULL,NULL,'NGC 4638',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99207,'Faber-Jackson','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99207,29.88,0.85,9.46,41613,95,NULL,'de Vaucouleurs','NGC 4638',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99208,'Faber-Jackson','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99208,29.93,0.52,9.68,41613,95,NULL,'Weighted Mean','NGC 4638',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99209,'Faber-Jackson','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99209,30.94,0.81,15.4,41613,55,NULL,'Visvanathan & Sandage 1979','NGC 4638',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99210,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99210,29.74,NULL,8.87,41613,NULL,NULL,NULL,'NGC 4638',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99211,'Tertiary','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99211,30.49,0.25,12.5,41613,95,NULL,NULL,'NGC 4638',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99212,'Tully est','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99212,31.13,0.8,16.8,41613,75,NULL,'B','NGC 4638',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99213,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99213,31.1,0.45,16.6,41613,NULL,NULL,'K','NGC 4638',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99214,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99214,31.66,0.4,21.5,41613,NULL,NULL,'mean','NGC 4638',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99215,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99215,37.2,0.33,275,41614,70,NULL,NULL,'2MASX J12424858+0900338',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.39',0.11,NULL,NULL,NULL,NULL,NULL,1,190.7027083,9.00942,0,NULL,58198010309,909343911,14208498,18.39),(99216,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1992P',NULL,99216,34.5,0.08,79.4,41615,65,NULL,'Snapshot','IC 3690',NULL,'1996ApJ...473...88R',1996,1,1.1,NULL,'G',0.000023,NULL,'15.18',0.3,'Sb:','Group member',NULL,NULL,NULL,1,190.704958333,10.35747,0,NULL,58187492529,909179570,14205930,15.18),(99217,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1992P',NULL,99217,34.75,0.19,86.9,41615,74.2,NULL,'SALT 2','IC 3690',0.0254,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99218,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1992P',NULL,99218,35,0.03,97.4,41615,70,NULL,'Snapshot','IC 3690',0.0254,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99219,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1992P',NULL,99219,35.25,0.08,112,41615,74.4,NULL,NULL,'IC 3690',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99220,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1992P',NULL,99220,35.27,0.17,113,41615,70.8,NULL,NULL,'IC 3690',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99221,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1992P',NULL,99221,35.35,0.02,115,41615,72,NULL,NULL,'IC 3690',0.0254,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99222,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1992P',NULL,99222,35.4,0.19,117,41615,70,NULL,'SALT 2','IC 3690',0.0254,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99223,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1992P',NULL,99223,35.43,0.1,119,41615,65,NULL,'SALT2','IC 3690',0.0254,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99224,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1992P',NULL,99224,35.44,0.19,119,41615,73.8,NULL,'SALT 2 (SNANA)','IC 3690',0.0265,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99225,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1992P',NULL,99225,35.39,0.05,120,41615,65,NULL,'LCS','IC 3690',NULL,'1995ApJ...445L..91R',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99226,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1992P',NULL,99226,35.46,0.19,121,41615,72,NULL,NULL,'IC 3690',0.0254,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99227,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1992P',NULL,99227,35.45,0.07,123,41615,60,NULL,'M(B) = -19.48 mag','IC 3690',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99228,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1992P',NULL,99228,35.52,0.18,124,41615,70,NULL,'SALT','IC 3690',0.0254,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99229,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1992P',NULL,99229,35.52,0.2,124,41615,65,NULL,'SALT2','IC 3690',0.0254,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99230,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1992P',NULL,99230,35.53,0.18,124,41615,65,NULL,'MLCS17','IC 3690',0.0254,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99231,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1992P',NULL,99231,35.48,0.06,125,41615,60,NULL,'M(V) = -19.47 mag','IC 3690',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99232,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1992P',NULL,99232,35.59,0.12,125,41615,65,NULL,'MLCS2k2','IC 3690',0.0254,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99233,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1992P',NULL,99233,35.49,0.06,125,41615,60,NULL,'M(I) = -19.19 mag','IC 3690',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99234,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1992P',NULL,99234,35.57,0.1,127,41615,65,NULL,'MLCS2k2','IC 3690',0.0254,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99235,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1992P',NULL,99235,35.57,0.14,127,41615,70,NULL,NULL,'IC 3690',0.0254,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99236,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1992P',NULL,99236,35.58,0.19,128,41615,65,NULL,'MLCS31','IC 3690',0.0254,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99237,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1992P',NULL,99237,35.59,0.16,128,41615,65,NULL,'Template','IC 3690',0.0254,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99238,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1992P',NULL,99238,35.6,0.12,128,41615,65,NULL,'MLCS2k2','IC 3690',0.0254,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99239,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1992P',NULL,99239,35.61,0.04,129,41615,65,NULL,'MLCS','IC 3690',0.0254,'1996ApJ...473..588R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99240,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1992P',NULL,99240,35.64,0.2,131,41615,65,NULL,NULL,'IC 3690',0.0254,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99241,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1992P',NULL,99241,35.69,0.19,134,41615,65,NULL,'SALT','IC 3690',0.0254,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99242,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1992P',NULL,99242,35.67,0.14,136,41615,60,NULL,NULL,'IC 3690',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99243,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1992P',NULL,99243,35.76,0.13,138,41615,65,NULL,'MLCS','IC 3690',0.0254,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99244,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1992P',NULL,99244,35.82,0.1,142,41615,65,NULL,'SALT','IC 3690',0.0254,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99245,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99245,31.35,0.18,18.6,41616,NULL,NULL,'HST KP Calibrated, K\'','NGC 4636',NULL,'2000ApJ...529..745F',2000,1,6,NULL,'G',0.000014,NULL,'10.43',4.7,'E/S0_1;LINER   Sy3','in a radial-velocity based grouping',NULL,NULL,'LINER b',1,190.707625,2.68778,0.05,NULL,58218910966,909670483,14213601,10.43),(99246,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99246,31.2,0.3,17.4,41616,NULL,NULL,NULL,'NGC 4636',NULL,'1994A&A...287..463K',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99247,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99247,31.24,0.17,17.7,41616,NULL,NULL,NULL,'NGC 4636',NULL,'2005A&A...433...43D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99248,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99248,31.73,0.16,22.2,41616,NULL,NULL,'TOM(V) = -7.62 mag, t5 function','NGC 4636',NULL,'1995ApJ...446....1S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99249,'GCLF','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99249,31.84,0.13,23.3,41616,NULL,NULL,'TOM(V) = -7.62 mag, Gaussian','NGC 4636',NULL,'1995ApJ...446....1S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99250,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1939A',NULL,99250,30.7,0.36,13.8,41616,NULL,NULL,NULL,'NGC 4636',NULL,'1992ApJ...390L..45P',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99251,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99251,30.3,0.2,11.5,41616,NULL,NULL,'I','NGC 4636',NULL,'1993A&A...275..433B',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99252,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99252,30.67,0.13,13.6,41616,NULL,NULL,'I','NGC 4636',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99253,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99253,30.77,0.09,14.3,41616,NULL,NULL,'K','NGC 4636',NULL,'1996ApJ...468..519J',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99254,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99254,30.77,0.1,14.3,41616,NULL,NULL,'K','NGC 4636',NULL,'1994ApJ...433..567P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99255,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99255,30.79,0.16,14.4,41616,NULL,NULL,'HST KP Calibrated, Ks','NGC 4636',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99256,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99256,30.83,0.13,14.7,41616,NULL,NULL,NULL,'NGC 4636',NULL,'2001ApJ...550..503J',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99257,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99257,30.83,0.08,14.7,41616,NULL,NULL,'I','NGC 4636',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99258,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99258,30.83,0.13,14.7,41616,NULL,NULL,'I','NGC 4636',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99259,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99259,30.83,0.13,14.7,41616,NULL,NULL,NULL,'NGC 4636',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99260,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99260,30.86,0.13,14.9,41616,NULL,NULL,'Malmquist cor.','NGC 4636',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99261,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99261,30.88,0.16,15,41616,NULL,NULL,'HST KP Calibrated, I','NGC 4636',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99262,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99262,30.89,0.12,15.1,41616,74.4,NULL,NULL,'NGC 4636',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99263,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99263,30.96,0.06,15.6,41616,NULL,NULL,'I','NGC 4636',NULL,'1990AJ....100.1416T',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99264,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99264,31.2,0.15,17.4,41616,NULL,NULL,'K','NGC 4636',NULL,'1998ApJ...505..111J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99265,'D-Sigma','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99265,31.13,0.4,16.8,41616,75,NULL,'Edat, raw','NGC 4636',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99266,'D-Sigma','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99266,31.15,0.4,17,41616,75,NULL,'Edat, cor','NGC 4636',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99267,'Faber-Jackson','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99267,30.15,0.32,10.7,41616,95,NULL,'de Vaucouleurs','NGC 4636',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99268,'Faber-Jackson','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99268,30.42,NULL,12.1,41616,NULL,NULL,'LEDA [April 2006]','NGC 4636',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99269,'Faber-Jackson','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99269,30.46,0.25,12.4,41616,95,NULL,'Weighted Mean','NGC 4636',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99270,'Faber-Jackson','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99270,31.26,0.46,17.9,41616,95,NULL,'Michard 1979a','NGC 4636',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99271,'Faber-Jackson','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99271,31.31,0.63,18.3,41616,95,NULL,'Michard 1979b, c','NGC 4636',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99272,'Faber-Jackson','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99272,31.51,1.61,20,41616,55,NULL,'Visvanathan & Sandage 1979','NGC 4636',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99273,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99273,30.89,0.12,15.1,41616,74.4,NULL,NULL,'NGC 4636',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99274,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99274,30.95,0.41,15.5,41616,NULL,NULL,NULL,'NGC 4636',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99275,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99275,30.95,NULL,15.5,41616,NULL,NULL,NULL,'NGC 4636',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99276,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99276,31.18,0.41,17.2,41616,NULL,NULL,'Malmquist cor.','NGC 4636',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99277,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99277,31.29,NULL,18.1,41616,NULL,NULL,NULL,'NGC 4636',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99278,'Tertiary','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99278,30.59,0.2,13.1,41616,95,NULL,NULL,'NGC 4636',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99279,'Tully est','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99279,31.15,0.8,17,41616,75,NULL,'B','NGC 4636',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99280,'GRB','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99280,46.55,1.5,4470,41617,NULL,NULL,NULL,'GRB 090323',3.57,'2010JCAP...08..020W',2010,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,190.709458333,17.0535,0.037,NULL,58877178137,919955908,14374311,NULL),(99281,'GRB','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99281,48.05,0.3,40700,41617,NULL,NULL,NULL,'GRB 090323',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99282,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99282,37.43,0.46,306,41618,70,NULL,NULL,'2MASX J12425073-0148507',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000102,NULL,'16.2g',0.31,'E0',NULL,NULL,NULL,NULL,1,190.711375,-1.81417,0.025,NULL,43171359910,674552498,10539882,16.2),(99283,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99283,33.46,0.49,49.2,41619,70,NULL,NULL,'ESO 442- G 015',NULL,'2014MNRAS.445.2677S',2014,1,1.1,'Kaldare et al. (2003MNRAS.339..652K) give v = 9033 +/-108 km/sec.','G',0.00015,NULL,'13.99',0.8,'(R_1R\'_2)SB(r)a',NULL,NULL,NULL,NULL,1,190.711583,-30.40967,0.329,NULL,43475306548,679301664,10614088,13.99),(99284,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99284,37.75,0.17,355,41620,70,NULL,NULL,'2MASX J12425103+0930588',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.31',0.15,NULL,NULL,NULL,NULL,NULL,1,190.7125,9.51625,0,NULL,58186109824,909157966,14205593,18.31),(99285,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99285,37.95,0.46,389,41621,70,NULL,NULL,'2MASX J12425160+5529074',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000132,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,190.715291667,55.48539,0.005,NULL,57399502337,896867224,14013550,17.8),(99286,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99286,37.86,0.46,374,41622,70,NULL,NULL,'2MASX J12425182+2618426',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000103,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,190.716083,26.31178,0.064,NULL,58722610905,917540795,14336574,17.9),(99287,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99287,34.44,0.46,77.1,41623,70,NULL,NULL,'NGC 4646',NULL,'2015arXiv151105856S',2015,1,1.01,NULL,'G',0.00015,NULL,'13.8g',0.63,'S0?','in a radial-velocity based grouping',NULL,NULL,NULL,1,190.717167,54.856,0,NULL,57428458133,897319658,14020619,13.8),(99288,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99288,31.47,0.1,19.7,41624,NULL,NULL,NULL,'NGC 4639',NULL,'2009ApJ...699..539R',2009,1,2.8,NULL,'G',0.000018,NULL,'12.24',1.9,'SAB(rs)bc      Sy1.8','in a radial-velocity based grouping',NULL,NULL,'Sy 1.0',1,190.7182917,13.25739,0.053,NULL,58874858920,919919670,14373744,12.24),(99289,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99289,31.52,0.08,20.2,41624,NULL,NULL,'17, VI','NGC 4639',NULL,'2001ApJ...547L.103G',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99290,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99290,31.58,0.11,20.7,41624,NULL,NULL,'LMC W01','NGC 4639',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99291,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99291,31.6,0.08,20.9,41624,NULL,NULL,'V, I, NIR (W), 25, Syst. +/- 0.40 mag','NGC 4639',NULL,'2013MNRAS.434.2866F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99292,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99292,31.61,0.08,21,41624,NULL,NULL,'14, VI, KEY PROJECT','NGC 4639',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99293,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99293,31.62,0.08,21,41624,NULL,NULL,'STR 04 LMC non-linear','NGC 4639',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99294,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99294,31.62,0.08,21.1,41624,NULL,NULL,'17, VI +Z','NGC 4639',NULL,'2001ApJ...547L.103G',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99295,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99295,31.62,0.09,21.1,41624,NULL,NULL,'14','NGC 4639',NULL,'2005ApJ...627..579R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99296,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99296,31.64,0.07,21.3,41624,NULL,NULL,'MW HIPP','NGC 4639',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99297,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99297,31.65,0.08,21.4,41624,NULL,NULL,'STR04 LMC linear','NGC 4639',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99298,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99298,31.66,0.08,21.4,41624,NULL,NULL,'KN04 LMC non-linear','NGC 4639',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99299,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99299,31.66,0.11,21.5,41624,NULL,NULL,'cte LMC K03','NGC 4639',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99300,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99300,31.66,0.08,21.5,41624,NULL,NULL,'KN04 LMC linear','NGC 4639',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99301,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99301,31.66,0.11,21.5,41624,NULL,NULL,'cte U99','NGC 4639',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99302,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99302,31.67,0.08,21.5,41624,NULL,NULL,'TR02 LMC linear','NGC 4639',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99303,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99303,31.67,0.08,21.6,41624,NULL,NULL,'SNIa calibrated','NGC 4639',NULL,'2011ApJ...730..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99304,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99304,31.67,0.08,21.6,41624,NULL,NULL,'KN06 LMC linear','NGC 4639',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99305,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99305,31.69,0.11,21.8,41624,NULL,NULL,'cte LMC STS02','NGC 4639',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99306,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99306,31.7,0.08,21.9,41624,NULL,NULL,'KN06 LMC non-linear','NGC 4639',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99307,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99307,31.7,0.08,21.9,41624,NULL,NULL,'TR02 LMC non-linear','NGC 4639',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99308,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99308,31.71,0.08,22,41624,NULL,NULL,'14, VI, +Z, KEY PROJECT','NGC 4639',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99309,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99309,31.71,0.21,22,41624,NULL,NULL,'MW P02','NGC 4639',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99310,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99310,31.72,0.07,22.1,41624,74.4,NULL,NULL,'NGC 4639',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99311,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99311,31.74,0.11,22.3,41624,NULL,NULL,'14, VI','NGC 4639',NULL,'1997ApJ...491...13K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99312,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99312,31.76,0.11,22.5,41624,NULL,NULL,'cte MW FSG03','NGC 4639',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99313,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99313,31.78,0.13,22.7,41624,NULL,NULL,'14, VI +Z','NGC 4639',NULL,'1997ApJ...491...13K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99314,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99314,31.79,0.11,22.8,41624,NULL,NULL,'cte MF91','NGC 4639',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99315,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99315,31.8,0.09,22.9,41624,NULL,NULL,'ALLFRAME','NGC 4639',NULL,'2000ApJ...529..723G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99316,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99316,31.8,0.08,22.9,41624,NULL,NULL,'MW GFG','NGC 4639',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99317,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99317,31.8,0.08,22.9,41624,NULL,NULL,'77, VI','NGC 4639',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99318,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99318,31.8,0.09,22.9,41624,NULL,NULL,'HST KP Calibrated','NGC 4639',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99319,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99319,31.81,0.11,23,41624,NULL,NULL,'cte MW GFG98','NGC 4639',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99320,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99320,31.84,0.08,23.3,41624,NULL,NULL,'NK04 GAL','NGC 4639',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99321,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99321,31.88,0.08,23.7,41624,NULL,NULL,'STR04 GAL','NGC 4639',NULL,'2006ApJ...642L..29N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99322,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99322,31.89,0.11,23.9,41624,NULL,NULL,'cte MW STS03','NGC 4639',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99323,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99323,31.92,0.11,24.2,41624,NULL,NULL,'ALLFRAME, Key Project','NGC 4639',NULL,'2000ApJ...529..723G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99324,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99324,31.92,0.09,24.2,41624,NULL,NULL,'Z, Key Project','NGC 4639',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99325,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99325,32,0.23,25.1,41624,NULL,NULL,'20, VI','NGC 4639',NULL,'1996ApJ...460L..15S',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99326,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99326,32.03,0.22,25.5,41624,NULL,NULL,'18, VI','NGC 4639',NULL,'1997ApJ...486....1S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99327,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99327,32.2,0.09,27.5,41624,NULL,18.54,'LMC ZP','NGC 4639',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99328,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99328,32.2,NULL,27.5,41624,NULL,18.54,NULL,'NGC 4639',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99329,'Cepheids','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99329,32.31,NULL,29,41624,NULL,NULL,'25, VI','NGC 4639',NULL,'2006A&A...452..423P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99330,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1990N',NULL,99330,31.04,0.14,16.1,41624,65,NULL,'Snapshot','NGC 4639',NULL,'1996ApJ...473...88R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99331,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1990N',NULL,99331,31.41,0.22,19.1,41624,65,NULL,'avg. of 6 SNIa and hosts','NGC 4639',NULL,'1996AJ....112.2398H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99332,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1990N',NULL,99332,31.5,0.48,20,41624,67,NULL,NULL,'NGC 4639',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99333,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1990N',NULL,99333,31.6,0.07,20.9,41624,66,NULL,NULL,'NGC 4639',NULL,'1994A&A...281...51M',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99334,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1990N',NULL,99334,31.67,0.08,21.6,41624,NULL,NULL,'MLCS2k2, Cepheids calibrated','NGC 4639',NULL,'2011ApJ...730..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99335,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1990N',NULL,99335,31.72,0.07,22.1,41624,74.4,NULL,NULL,'NGC 4639',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99336,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1990N',NULL,99336,31.81,0.2,23,41624,68,NULL,NULL,'NGC 4639',NULL,'1996ApJ...465L..83R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99337,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1990N',NULL,99337,31.99,0.02,25,41624,60,NULL,'M(I) = -19.19 mag','NGC 4639',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99338,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1990N',NULL,99338,32,0.02,25.1,41624,60,NULL,'M(V) = -19.47 mag','NGC 4639',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99339,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1990N',NULL,99339,32.03,0.03,25.5,41624,60,NULL,'M(B) = -19.48 mag','NGC 4639',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99340,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1990N','R',99340,32.05,NULL,25.7,41624,62.3,NULL,NULL,'NGC 4639',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99341,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1990N',NULL,99341,32.1,NULL,26.3,41624,56,NULL,'M(B) = -19.8 mag','NGC 4639',NULL,'1992ARA&A..30..359B',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99342,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1990N',NULL,99342,32.15,0.09,26.8,41624,65,NULL,'MLCS2k2','NGC 4639',0.003395,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99343,'SNIa','2016-12-15 15:15:04','2016-12-16 11:20:16','1','SN 1990N',NULL,99343,32.14,0.14,26.8,41624,60,NULL,NULL,'NGC 4639',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99344,'Sosies','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99344,31.7,0.18,21.9,41624,NULL,NULL,NULL,'NGC 4639',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99345,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99345,31.02,0.4,16,41624,75,NULL,'HOSTS SN 1990N','NGC 4639',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99346,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99346,31.13,0.4,16.8,41624,75,NULL,'B','NGC 4639',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99347,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99347,31.4,0.3,19.1,41624,NULL,18.45,'SN 1990N host','NGC 4639',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99348,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99348,31.58,0.35,20.7,41624,NULL,NULL,NULL,'NGC 4639',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99349,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99349,31.67,NULL,21.6,41624,NULL,NULL,'I','NGC 4639',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99350,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99350,31.68,0.03,21.7,41624,NULL,NULL,'B','NGC 4639',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99351,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99351,31.71,0.08,22,41624,75,NULL,NULL,'NGC 4639',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99352,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99352,31.73,0.02,22.2,41624,NULL,NULL,'I','NGC 4639',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99353,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99353,31.74,NULL,22.3,41624,NULL,NULL,'B','NGC 4639',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99354,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99354,31.8,0.4,22.9,41624,75,NULL,'HOSTS SN 1990N','NGC 4639',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99355,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99355,31.82,0.42,23.1,41624,NULL,18.48,'3.6 micron','NGC 4639',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99356,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99356,32,NULL,25.1,41624,NULL,NULL,NULL,'NGC 4639',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99357,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99357,32.53,0.3,32.1,41624,55,NULL,'B','NGC 4639',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99358,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99358,35.08,0.4,104,41625,NULL,NULL,'mean','IC 3692',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.00002,NULL,'14.69',0.7,'SBa:           LINER','Isolated galaxy',NULL,NULL,NULL,1,190.725,20.98975,0.124,NULL,58901103854,920329747,14380152,14.69),(99359,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99359,35.33,0.47,116,41625,NULL,NULL,'H','IC 3692',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99360,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99360,35.4,0.45,120,41625,NULL,NULL,'K','IC 3692',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99361,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99361,35.46,0.46,123,41625,NULL,NULL,'J','IC 3692',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99362,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99362,38.64,0.33,535,41626,70,NULL,NULL,'2MASX J12425402+5658155',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,190.7252083,56.97089,0,NULL,57400301324,896879708,14013745,17.7),(99363,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99363,37.92,0.33,384,41627,70,NULL,NULL,'2MASX J12425614+0032545',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00008,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,190.733875,0.54853,0,NULL,58217128075,909642626,14213166,17.2),(99364,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99364,32.98,0.2,39.5,41628,74.4,NULL,NULL,'UGC 07883',NULL,'2013AJ....146...86T',2013,1,2.77,'Da Costa, et al. (1998,AJ,116,1) give v = 4759 +/- 74 km/sec.','G',0.000013,NULL,'13.9g',0.61,'SA(s)cd: sp',NULL,NULL,NULL,NULL,1,190.738583,-1.22942,0.037,NULL,43168621363,674509708,10539214,13.9),(99365,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99365,33.06,0.51,41,41628,NULL,NULL,'Malmquist cor.','UGC 07883',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99366,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99366,33.17,0.49,43.1,41628,75,NULL,'IR','UGC 07883',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99367,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99367,33.2,0.48,43.6,41628,NULL,NULL,NULL,'UGC 07883',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99368,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99368,37.81,0.46,365,41629,70,NULL,NULL,'SDSS J124257.95+650401.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000129,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,190.7414583,65.06717,0.029,NULL,57322780917,895668451,13994819,18.5),(99369,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99369,31.12,0.14,16.8,41630,74.4,NULL,NULL,'IC 3693',NULL,'2013AJ....146...86T',2013,1,0.89,NULL,'G',0.000327,NULL,'15.1B',0.63,'dE3','Group member',NULL,NULL,NULL,1,190.74175,10.68181,0,NULL,58187344735,909177261,14205894,15.1),(99370,'SBF','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99370,31.14,0.16,16.9,41630,NULL,NULL,'HST ACS VCS','IC 3693',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99371,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99371,36.7,0.6,219,41631,70,NULL,NULL,'LCRS B124022.0-111907',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00011,NULL,'16.72',0.4,NULL,NULL,NULL,NULL,NULL,1,190.742583,-11.59242,0.097,NULL,43034017075,672406516,10506351,16.72),(99372,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99372,37.85,0.46,371,41632,70,NULL,NULL,'2MASX J12425826-0006117',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000079,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,190.742917,-0.10333,0.014,NULL,42983336726,671614636,10493978,17.6),(99373,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99373,37.23,0.33,279,41633,70,NULL,NULL,'2MASX J12425848+3713553',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000178,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,190.743875,37.23208,0,NULL,58568015009,915125234,14298831,16.5),(99374,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99374,37.12,0.33,265,41634,70,NULL,NULL,'VII Zw 480 NOTES03',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000161,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,190.75275,63.28022,0,NULL,57376503357,896507864,14007935,17),(99375,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99375,38.63,0.33,531,41635,70,NULL,NULL,'2MASX J12430246+0600489',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000136,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,190.760375,6.01367,0,NULL,58238781512,909980961,14218452,17.6),(99376,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99376,35.31,0.49,115,41636,NULL,NULL,'Malmquist cor.','CGCG 015-003',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000017,NULL,'15.2g',0.62,'NLAGN',NULL,NULL,NULL,'Sy 2',1,190.7625417,-1.28275,0.045,NULL,43168485681,674507588,10539181,15.2),(99377,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99377,35.55,0.44,129,41636,NULL,NULL,NULL,'CGCG 015-003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99378,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99378,35.59,0.2,131,41636,74.4,NULL,NULL,'CGCG 015-003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99379,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99379,37.81,0.46,365,41637,70,NULL,NULL,'SDSS J124303.16+172728.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.6g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,190.7632083,17.45783,0.037,NULL,58877032064,919953626,14374275,17.6),(99380,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99380,37.73,0.27,352,41638,70,NULL,NULL,'2MASX J12430342+4203314',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,190.764208333,42.05858,0,NULL,59116272234,923691753,14432683,17.5),(99381,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99381,38.25,0.46,446,41639,70,NULL,NULL,'2MASX J12430388+2721486',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,190.766166667,27.36367,0.111,NULL,58734594779,917728043,14339500,17.7),(99382,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99382,36.81,0.46,230,41640,70,NULL,NULL,'2MASX J12430434+1934006',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,190.768125,19.56681,0.126,NULL,58899035250,920297425,14379647,17.3),(99383,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99383,37.71,0.46,348,41641,70,NULL,NULL,'2MASX J12430459+0407012',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000169,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,190.7692083,4.11686,0,NULL,58224022577,909750352,14214849,16.6),(99384,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99384,37.18,0.46,273,41642,70,NULL,NULL,'2MASX J12430492+0207042',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00016,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,190.770583333,2.11769,0,NULL,58218655053,909666485,14213538,16.7),(99385,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99385,38.23,0.46,443,41643,70,NULL,NULL,'2MASX J12430539-0213312',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000084,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,190.7722917,-2.22536,0.053,NULL,43170716249,674542441,10539725,17.8),(99386,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99386,35,0.43,100,41644,75,NULL,'3.6 micron, color + selection bias corrected','UGC 07890',NULL,'2014MNRAS.444..527S',2014,1,0.71,NULL,'G',0.000027,NULL,'14.7g',0.51,'Sab','Group member',NULL,NULL,NULL,1,190.7722917,27.71408,0.086,NULL,58736758489,917761851,14340028,14.7),(99387,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99387,35.01,0.43,100,41644,75,NULL,'3.6 micron, color corrected','UGC 07890',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99388,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99388,35.07,0.12,103,41644,NULL,NULL,NULL,'UGC 07890',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99389,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99389,35.09,0.2,104,41644,74.4,NULL,NULL,'UGC 07890',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99390,'D-Sigma','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99390,34.21,0.4,69.5,41645,75,NULL,'Edat, raw','NGC 4645A',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000067,NULL,'12.2',0.8,'SA?(r)0^0','in a pair',NULL,NULL,NULL,1,190.773208333,-41.35892,0.501,NULL,46747108365,730423568,11412868,12.2),(99391,'D-Sigma','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99391,34.55,0.4,81.2,41645,75,NULL,'Edat, cor','NGC 4645A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99392,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99392,32.82,0.49,36.6,41645,70,NULL,NULL,'NGC 4645A',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99393,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99393,32.6,0.45,33.2,41645,NULL,NULL,'K','NGC 4645A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99394,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99394,33.29,0.4,45.4,41645,NULL,NULL,'mean','NGC 4645A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99395,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99395,36.34,0.33,185,41646,70,NULL,NULL,'CGCG 015-004',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000102,NULL,'15.2g',0.56,'S0/a',NULL,NULL,NULL,NULL,1,190.777083,-0.43792,0.044,NULL,42983388680,671615448,10493991,15.2),(99396,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99396,35.36,NULL,118,41647,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1492',NULL,'2010Ap&SS.325..163P',2010,1,1.18,NULL,'G',0.000202,NULL,'16.8g',0.14,'Sd',NULL,NULL,NULL,NULL,1,190.7825,45.85539,0,NULL,59113517061,923648704,14432011,16.8),(99397,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99397,35.38,NULL,119,41647,NULL,NULL,'Dipole + Quadrupole','FGC 1492',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99398,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99398,35.4,NULL,120,41647,NULL,NULL,'Dipole','FGC 1492',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99399,'Tully-Fisher','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99399,35.41,NULL,121,41647,NULL,NULL,NULL,'FGC 1492',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99400,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99400,37,0.27,251,41648,70,NULL,NULL,'LCRS B124034.5-022918',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000076,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,190.786958333,-2.76233,0.029,NULL,43170015989,674531499,10539554,17),(99401,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99401,38.26,0.46,449,41649,70,NULL,NULL,'2MASX J12430892-0143292',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000085,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,190.787167,-1.72478,0.025,NULL,43171441001,674553765,10539902,17.6),(99402,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99402,37.65,0.46,339,41650,70,NULL,NULL,'2MASX J12430954+6549284',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000166,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,190.790041667,65.82456,0.049,NULL,57323224441,895675381,13994927,16.9),(99403,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99403,38.63,0.33,531,41651,70,NULL,NULL,'SDSS J124309.79+055943.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,190.790833,5.99556,0,NULL,58238089830,909970153,14218283,18.2),(99404,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99404,36.42,0.46,193,41652,70,NULL,NULL,'CGCG 015-006',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000127,NULL,'15.0g',0.65,'NLAGN',NULL,NULL,NULL,NULL,1,190.79125,-1.44122,0.045,NULL,43171287743,674551370,10539865,15),(99405,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,NULL,99405,36.7,0.55,218,41653,70,NULL,NULL,'2MASX J12431100-1714359',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.17',0.3,NULL,NULL,NULL,NULL,NULL,1,190.7960417,-17.24336,0.101,NULL,43934595129,686478048,10726219,16.17),(99406,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99406,38.2,0.46,437,41654,70,NULL,NULL,'2MASX J12431107+0810029',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000165,NULL,'18.1g',0.16,'S',NULL,NULL,NULL,NULL,1,190.796167,8.16753,0,NULL,58193182325,909268473,14207319,18.1),(99407,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99407,38.07,0.46,411,41655,70,NULL,NULL,'2MASX J12431165+2938536',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.0001,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,190.798625,29.64811,0.058,NULL,58781329702,918458276,14350910,17.4),(99408,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99408,37.74,0.46,353,41656,70,NULL,NULL,'2MASX J12431221+1531512',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,190.800833,15.53081,0.033,NULL,58886440113,920100626,14376572,17.8),(99409,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99409,36.42,0.46,193,41657,70,NULL,NULL,'2MASX J12431221+1658522',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.36',0.14,NULL,NULL,NULL,NULL,NULL,1,190.801083,16.98131,0.039,NULL,58879221339,919987833,14374809,18.36),(99410,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99410,38.1,0.46,417,41658,70,NULL,NULL,'SDSS J124313.85+055712.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000141,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,190.80775,5.95333,0,NULL,58238090554,909970164,14218283,18),(99411,'FP','2016-12-15 15:15:04','2016-12-16 11:20:16','1',NULL,'R',99411,37.17,0.46,272,41659,70,NULL,NULL,'2MASX J12431401+1557522',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.26',0.17,NULL,NULL,NULL,NULL,NULL,1,190.8085417,15.96442,0.037,NULL,58878078924,919969983,14374530,18.26),(99412,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99412,36.01,0.46,160,41660,70,NULL,NULL,'VCC 1959',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000177,NULL,'15.7g',0.42,'S0','Group member',NULL,NULL,NULL,1,190.812375,4.08389,0,NULL,58224072154,909751127,14214861,15.7),(99413,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99413,37.87,0.33,375,41661,70,NULL,NULL,'SDSS J124315.10+100815.4',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,190.812958333,10.13764,0,NULL,58187457721,909179026,14205922,17.6),(99414,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99414,37.36,0.33,297,41662,70,NULL,NULL,'2MASX J12431695+1706442',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,190.82075,17.11242,0.039,NULL,58879344922,919989764,14374840,16.6),(99415,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99415,32.77,0.3,35.8,41663,55,NULL,'B','NGC 4642',NULL,'2000A&A...355..835E',2000,1,1.9,'The APM position refers to the northeastern end of the galaxy.','G',0.00002,NULL,'13.7B',0.6,'SAB(rs)bc pec sp',NULL,NULL,NULL,NULL,1,190.824083333,-0.64425,0.044,NULL,43167871360,674497990,10539031,13.7),(99416,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99416,32.8,0.4,36.4,41663,75,NULL,NULL,'NGC 4642',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99417,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99417,32.99,0.48,39.6,41663,NULL,NULL,'Malmquist cor.','NGC 4642',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99418,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99418,33.04,0.2,40.6,41663,74.4,NULL,NULL,'NGC 4642',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99419,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99419,33.08,0.43,41.4,41663,75,NULL,'3.6 micron, color corrected','NGC 4642',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99420,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99420,33.14,0.45,42.4,41663,NULL,NULL,NULL,'NGC 4642',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99421,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99421,33.14,0.43,42.4,41663,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4642',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99422,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99422,33.16,0.4,42.8,41663,NULL,NULL,'mean','NGC 4642',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99423,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99423,33.2,0.49,43.6,41663,75,NULL,'IR','NGC 4642',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99424,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99424,33.27,0.47,45,41663,NULL,NULL,'H','NGC 4642',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99425,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99425,33.3,0.46,45.6,41663,NULL,NULL,'J','NGC 4642',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99426,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99426,33.3,0.45,45.7,41663,NULL,NULL,'K','NGC 4642',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99427,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99427,37.6,0.46,331,41664,70,NULL,NULL,'2MASX J12431786+0732529',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000172,NULL,'18.36',0.13,NULL,NULL,NULL,NULL,NULL,1,190.824583,7.548,0,NULL,58195526269,909305097,14207892,18.36),(99428,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99428,36.41,0.33,191,41665,70,NULL,NULL,'2MASX J12431870+0330202',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000174,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,190.827958333,3.5055,0.036,NULL,58223372475,909740194,14214690,16.5),(99429,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99429,36.53,0.46,203,41666,70,NULL,NULL,'2MASX J12431869+2255086',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,190.827958333,22.91894,0.081,NULL,58889523311,920148801,14377325,16.5),(99430,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99430,36.41,0.33,191,41667,70,NULL,NULL,'VCC 1962',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000097,NULL,'15.3g',0.56,'S0','Group member',NULL,NULL,NULL,1,190.8280417,3.55017,0.036,NULL,58223373643,909740213,14214690,15.3),(99431,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99431,35.75,0.52,141,41668,70,NULL,NULL,'MCG -02-32-027',NULL,'2014MNRAS.445.2677S',2014,1,0.22,NULL,'G',0.00015,NULL,'15.12',0.2,NULL,NULL,NULL,NULL,NULL,1,190.8294583,-10.89739,0.097,NULL,43151663049,674244735,10535073,15.12),(99432,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99432,36.12,0.68,167,41669,70,NULL,NULL,'LCRS B124044.1-062238',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.45',NULL,NULL,NULL,NULL,NULL,NULL,1,190.8302917,-6.651,0.013,NULL,43156139074,674314673,10536166,15.45),(99433,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99433,37.14,0.46,268,41670,70,NULL,NULL,'2MASX J12431993+0151402',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,190.833,1.86128,0,NULL,58220723699,909698807,14214043,17.1),(99434,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99434,37.24,0.46,280,41671,70,NULL,NULL,'2MASX J12431992+1424572',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000167,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,190.833166667,14.41594,0.028,NULL,58872597630,919884337,14373192,16.9),(99435,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99435,37.23,0.33,279,41672,70,NULL,NULL,'2MASX J12432008+3712133',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000157,NULL,'16.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,190.833583,37.20372,0,NULL,58567979159,915124674,14298823,16.1),(99436,'Tully est','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99436,32.05,0.8,25.7,41673,75,NULL,'B','NGC 4643',NULL,'1988NBGC.C....0000T',1988,1,3.1,NULL,'G',0.000017,NULL,'11.72',2.3,'SB(rs)0/a      LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,190.833917,1.97828,0,NULL,58218702514,909667226,14213550,11.72),(99437,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99437,38.72,0.46,555,41674,70,NULL,NULL,'SDSS J124320.95+012620.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000134,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,190.837333333,1.43917,0.009,NULL,58220766320,909699473,14214054,18.7),(99438,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99438,37.78,0.46,360,41675,70,NULL,NULL,'2MASX J12432190+0421442',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000153,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,190.841125,4.36225,0,NULL,58224733265,909761457,14215022,17.1),(99439,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99439,37.55,0.46,324,41676,70,NULL,NULL,'SDSS J124322.51-000002.7',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00007,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,190.843791667,-0.00078,0.014,NULL,42983327248,671614488,10493976,17.4),(99440,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99440,37.19,0.33,274,41677,70,NULL,NULL,'2MASX J12432314+5632266',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,190.846417,56.54064,0,NULL,57400753705,896886776,14013855,18),(99441,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99441,34.91,0.46,95.9,41678,70,NULL,NULL,'CGCG 043-008',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'15.6',0.19,NULL,NULL,NULL,NULL,NULL,1,190.8497083,6.66589,0,NULL,58192671411,909260490,14207195,15.6),(99442,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99442,38.03,0.46,404,41679,70,NULL,NULL,'2MASX J12432673+0218512',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000084,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,190.861291667,2.31419,0,NULL,58219014604,909672103,14213626,17.6),(99443,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99443,37.19,0.33,274,41680,70,NULL,NULL,'VII Zw 481',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00014,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,190.863125,56.63664,0,NULL,57400695042,896885860,14013841,17.5),(99444,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99444,37.71,0.46,348,41681,70,NULL,NULL,'2MASX J12432759+3412388',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000173,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,190.865083,34.21075,0.008,NULL,58743966088,917874470,14341788,17.6),(99445,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99445,35.57,0.44,130,41682,NULL,NULL,'Malmquist cor.','UGC 07897',NULL,'2009ApJS..182..474S',2009,1,1.05,NULL,'G',0.000014,NULL,'15.3g',0.34,'Sc',NULL,NULL,NULL,NULL,1,190.8695417,29.46681,0.067,NULL,58781319064,918458110,14350907,15.3),(99446,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99446,36.01,0.36,159,41682,NULL,NULL,NULL,'UGC 07897',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99447,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99447,36.22,0.2,175,41682,74.4,NULL,NULL,'UGC 07897',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99448,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99448,37.52,0.46,319,41683,70,NULL,NULL,'2MASX J12433116+1252202',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,190.879833,12.87233,0.048,NULL,58871933429,919873959,14373030,17.8),(99449,'D-Sigma','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99449,32.93,0.4,38.6,41684,75,NULL,'Edat, raw','NGC 4645B',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000024,NULL,'12.1',0.7,'SAB:','in a pair',NULL,NULL,NULL,1,190.879917,-41.36253,0.501,NULL,46747334983,730427109,11412923,12.1),(99450,'D-Sigma','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99450,32.95,0.4,38.9,41684,75,NULL,'Edat, cor','NGC 4645B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99451,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99451,32.22,0.25,27.8,41684,74.4,NULL,NULL,'NGC 4645B',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99452,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99452,37.87,0.33,375,41685,70,NULL,NULL,'SDSS J124332.06+100746.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,190.883625,10.12964,0,NULL,58187463373,909179115,14205923,18.5),(99453,'Tully est','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99453,31.13,0.8,16.8,41686,75,NULL,'B','NGC 4647',NULL,'1988NBGC.C....0000T',1988,1,2.9,NULL,'G',0.000003,NULL,'11.94',2.3,'SAB(rs)c       HII','Pair member (points to parent)',NULL,NULL,NULL,1,190.884625,11.58186,0.04,NULL,58150696550,908604633,14196947,11.94),(99454,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99454,31.01,0.54,16,41686,NULL,NULL,NULL,'NGC 4647',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99455,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99455,31.01,0.54,16,41686,NULL,NULL,NULL,'NGC 4647',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99456,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99456,31.06,0.2,16.3,41686,74.4,NULL,NULL,'NGC 4647',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99457,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99457,31.13,0.51,16.8,41686,NULL,NULL,'Malmquist cor.','NGC 4647',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99458,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99458,31.13,0.51,16.8,41686,NULL,NULL,'Malmquist cor.','NGC 4647',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99459,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99459,31.19,NULL,17.3,41686,NULL,NULL,NULL,'NGC 4647',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99460,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99460,31.22,0.92,17.5,41686,NULL,NULL,'CO','NGC 4647',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99461,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99461,31.71,0.7,22,41686,NULL,NULL,'HI','NGC 4647',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99462,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99462,31.95,0.3,24.5,41686,55,NULL,'B','NGC 4647',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99463,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99463,37.36,0.33,297,41687,70,NULL,NULL,'2MASX J12433349+1701362',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,190.889583,17.02667,0.039,NULL,58879223377,919987865,14374810,17.2),(99464,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99464,36.2,0.9,174,41688,70,NULL,NULL,'2MASX J12433369-1015482',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.45',0.4,NULL,NULL,NULL,NULL,NULL,1,190.890458333,-10.26356,0.093,NULL,43155037858,674297466,10535897,16.45),(99465,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99465,34.96,0.47,98.3,41689,NULL,NULL,'H','ESO 574- G 024',NULL,'2007A&A...465...71T',2007,1,2.55,NULL,'G',0.000027,NULL,'14.39',0.31,'(R\'_1R\'_2)SB(l)abHII','in a pair',NULL,NULL,NULL,1,190.891166667,-20.84297,0.125,NULL,43919126709,686236354,10722443,14.39),(99466,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99466,35.02,0.45,101,41689,NULL,NULL,'K','ESO 574- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99467,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99467,35.06,0.46,103,41689,NULL,NULL,'J','ESO 574- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99468,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99468,35.06,0.4,103,41689,NULL,NULL,'mean','ESO 574- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99469,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99469,36.91,0.46,241,41690,70,NULL,NULL,'2MASX J12433427+4835011',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,190.892958333,48.58372,0,NULL,59094498018,923351531,14427367,17.3),(99470,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99470,36.31,0.46,183,41691,70,NULL,NULL,'2MASX J12433431+5836495',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000174,NULL,'16.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,190.893167,58.61372,0,NULL,57405702458,896964100,14015064,16.2),(99471,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99471,34.78,0.46,90.4,41692,70,NULL,NULL,'NGC 4655',NULL,'2015arXiv151105856S',2015,1,0.93,NULL,'G',0.000143,NULL,'14.2g',0.89,NULL,NULL,NULL,NULL,NULL,1,190.9020417,41.01853,0,NULL,59083433682,923178651,14424666,14.2),(99472,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99472,37.67,0.46,342,41693,70,NULL,NULL,'2MASX J12433671+1004234',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.40',0.15,NULL,NULL,NULL,NULL,NULL,1,190.902833,10.07311,0,NULL,58187448684,909178885,14205920,18.4),(99473,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99473,37.66,0.33,340,41694,70,NULL,NULL,'2MASX J12433698+3148108',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,190.904167,31.80297,0.035,NULL,58780267833,918441684,14350651,17.9),(99474,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99474,37.62,0.33,335,41695,70,NULL,NULL,'2MASX J12433722+2653211',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,190.90525,26.88933,0.06,NULL,58734897066,917732766,14339574,17.5),(99475,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99475,37.39,0.46,301,41696,70,NULL,NULL,'2MASX J12433773+6433358',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000196,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,190.907125,64.56006,0.013,NULL,57369275768,896394933,14006170,16.7),(99476,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99476,31.14,0.43,16.9,41697,75,NULL,'3.6 micron, color + selection bias corrected','UGC 07908',NULL,'2014MNRAS.444..527S',2014,1,1.5,NULL,'G',NULL,NULL,'15.25',0.3,'Scd:','X-ray-bright group member',NULL,NULL,NULL,1,190.9075,73.6125,0.033,NULL,57038955121,891233673,13925526,15.25),(99477,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99477,37.62,0.33,335,41698,70,NULL,NULL,'SDSS J124338.84+265059.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,190.911833,26.85,0.06,NULL,58734828215,917731690,14339557,18),(99478,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99478,38.64,0.33,535,41699,70,NULL,NULL,'2MASX J12433902+5657374',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000158,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,190.912375,56.9605,0.017,NULL,57400251271,896878926,14013733,18),(99479,'Cepheids','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99479,31.31,0.32,18.3,41700,NULL,NULL,'HST KP Calibrated, K\'','MESSIER 060',NULL,'2000ApJ...529..745F',2000,1,7.4,NULL,'G',0.000017,NULL,'9.81',6,'E2','Pair member (points to parent)',NULL,NULL,NULL,1,190.916583333,11.55269,0.04,NULL,58150685280,908604457,14196944,9.81),(99480,'Cepheids','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99480,31.8,0.09,22.9,41700,NULL,NULL,'HST KP Calibrated','MESSIER 060',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99481,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99481,30.05,0.1,10.2,41700,NULL,NULL,'Photographic, TOM(B) = -6.40 mag','MESSIER 060',NULL,'1987AJ.....94..906H',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99482,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99482,30.4,0.1,12,41700,NULL,NULL,'Photographic, TOM(B) = -6.40 mag','MESSIER 060',NULL,'1987AJ.....94..906H',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99483,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99483,30.63,0.13,13.4,41700,NULL,NULL,'blue GCs, TOM(V) = -7.17 mag','MESSIER 060',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99484,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99484,30.9,0.2,15.1,41700,NULL,NULL,'TOM(V) = -7.3 mag','MESSIER 060',NULL,'2009ApJ...690..512H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99485,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99485,30.95,0.25,15.5,41700,NULL,NULL,NULL,'MESSIER 060',NULL,'1993AJ....105.1358S',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99486,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99486,31.06,0.05,16.3,41700,NULL,NULL,NULL,'MESSIER 060',NULL,'2001AJ....121.2950K',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99487,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99487,31.09,0.06,16.5,41700,NULL,NULL,'TOM(g) = -7.2 mag','MESSIER 060',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99488,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99488,31.15,0.07,17,41700,NULL,NULL,'TOM(u) = -8.4 mag','MESSIER 060',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99489,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99489,31.17,0.06,17.1,41700,NULL,NULL,'TOM(z) = -8.53 mag','MESSIER 060',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99490,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99490,31.21,0.08,17.5,41700,NULL,NULL,'all GCs, TOM(V) = -7.63 mag','MESSIER 060',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99491,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99491,31.21,0.11,17.5,41700,NULL,NULL,'red GCs, TOM(V) = -7.55 mag','MESSIER 060',NULL,'2001AJ....121.2974L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99492,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99492,31.26,0.15,17.9,41700,NULL,NULL,'TOM(V) = -7.62 mag, t5 function','MESSIER 060',NULL,'1995ApJ...446....1S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99493,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99493,31.26,0.08,17.9,41700,NULL,NULL,'TOM(g) = -7.2 mag','MESSIER 060',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99494,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99494,31.38,0.53,18.9,41700,NULL,NULL,'HST KP Calibrated, B','MESSIER 060',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99495,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99495,31.38,0.53,18.9,41700,NULL,NULL,'HST KP Calibrated, B','MESSIER 060',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99496,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99496,31.39,0.11,19,41700,NULL,NULL,'B','MESSIER 060',NULL,'1991ApJS...76..115H',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99497,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99497,31.46,NULL,19.6,41700,NULL,NULL,'TOM(B) = -7.0 mag','MESSIER 060',NULL,'1988ASPC....4..231H',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99498,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99498,31.58,0.16,20.7,41700,NULL,NULL,'TOM(V) = -7.62 mag, Gaussian','MESSIER 060',NULL,'1995ApJ...446....1S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99499,'PNLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99499,30.73,0.13,14,41700,NULL,NULL,NULL,'MESSIER 060',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99500,'PNLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99500,30.7,0.2,14,41700,NULL,NULL,'218','MESSIER 060',NULL,'2011ApJ...736...65T',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99501,'PNLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99501,30.76,0.08,14.2,41700,NULL,NULL,'16 PNe','MESSIER 060',NULL,'1990ApJ...356..332J',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99502,'PNLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99502,30.82,0.15,14.6,41700,NULL,NULL,'HST KP Calibrated','MESSIER 060',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99503,'PNLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99503,30.82,0.15,14.6,41700,NULL,NULL,'HST KP Calibrated','MESSIER 060',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99504,'PNLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99504,30.87,0.11,14.9,41700,NULL,NULL,'I','MESSIER 060',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99505,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99505,30.81,0.08,14.5,41700,NULL,NULL,'I','MESSIER 060',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99506,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99506,30.95,0.11,15.5,41700,NULL,NULL,'I','MESSIER 060',NULL,'1997AJ....114..626A',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99507,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99507,30.98,0.08,15.7,41700,NULL,NULL,'HST KP Calibrated, F814W','MESSIER 060',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99508,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99508,31.06,0.11,16.3,41700,NULL,NULL,'I','MESSIER 060',NULL,'2000ApJ...536..255N',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99509,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99509,31.08,0.08,16.5,41700,NULL,NULL,'HST ACS VCS','MESSIER 060',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99510,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99510,31.13,0.15,16.8,41700,NULL,NULL,'I','MESSIER 060',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99511,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99511,31.13,0.15,16.8,41700,NULL,NULL,NULL,'MESSIER 060',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99512,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99512,31.16,0.15,17.1,41700,NULL,NULL,'Malmquist cor.','MESSIER 060',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99513,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99513,31.18,0.17,17.2,41700,NULL,NULL,'HST KP Calibrated, I','MESSIER 060',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99514,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99514,31.19,0.07,17.3,41700,NULL,NULL,NULL,'MESSIER 060',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99515,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99515,31.2,0.12,17.4,41700,74.4,NULL,NULL,'MESSIER 060',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99516,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99516,31.22,0.07,17.5,41700,NULL,NULL,'HST KP Calibrated, I','MESSIER 060',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99517,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99517,31.23,0.13,17.6,41700,NULL,NULL,'HST KP Calibrated, F814W','MESSIER 060',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99518,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99518,31.41,0.19,19.1,41700,NULL,NULL,'HST KP Calibrated, Ks','MESSIER 060',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99519,'GC radius','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99519,31.25,0.03,17.8,41700,NULL,NULL,NULL,'MESSIER 060',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99520,'D-Sigma','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99520,31.13,0.4,16.8,41700,75,NULL,'Edat, raw','MESSIER 060',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99521,'D-Sigma','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99521,31.15,0.4,17,41700,75,NULL,'Edat, cor','MESSIER 060',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99522,'Faber-Jackson','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99522,30.55,0.46,12.9,41700,95,NULL,'Michard 1979a','MESSIER 060',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99523,'Faber-Jackson','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99523,30.83,0.63,14.7,41700,95,NULL,'Michard 1979b, c','MESSIER 060',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99524,'Faber-Jackson','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99524,30.85,0.3,14.8,41700,95,NULL,'Weighted Mean','MESSIER 060',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99525,'Faber-Jackson','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99525,31.24,NULL,17.7,41700,NULL,NULL,'LEDA [April 2006]','MESSIER 060',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99526,'Faber-Jackson','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99526,31.24,0.44,17.7,41700,95,NULL,'de Vaucouleurs','MESSIER 060',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99527,'Faber-Jackson','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99527,31.65,1.61,21.4,41700,55,NULL,'Visvanathan & Sandage 1979','MESSIER 060',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99528,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99528,31.09,0.41,16.5,41700,NULL,NULL,NULL,'MESSIER 060',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99529,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99529,31.1,NULL,16.6,41700,NULL,NULL,NULL,'MESSIER 060',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99530,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99530,31.2,0.12,17.4,41700,74.4,NULL,NULL,'MESSIER 060',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99531,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99531,31.28,0.41,18,41700,NULL,NULL,'Malmquist cor.','MESSIER 060',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99532,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99532,31.37,NULL,18.8,41700,NULL,NULL,NULL,'MESSIER 060',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99533,'Tertiary','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99533,30.49,0.25,12.5,41700,95,NULL,NULL,'MESSIER 060',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99534,'Tully est','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99534,31.13,0.8,16.8,41700,75,NULL,'B','MESSIER 060',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99535,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99535,37.57,0.46,326,41701,70,NULL,NULL,'SDSS J124340.23+404838.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,190.917625,40.81081,0,NULL,59083428063,923178563,14424665,18.4),(99536,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99536,38.36,0.46,470,41702,70,NULL,NULL,'2MASX J12434031+2316359',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,190.918,23.27664,0.06,NULL,58890115331,920158052,14377469,17.4),(99537,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99537,38.09,0.46,416,41703,70,NULL,NULL,'2MASX J12434081+5622550',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00014,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,190.9202917,56.382,0,NULL,57400854136,896888345,14013880,18.3),(99538,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99538,37.56,0.46,325,41704,70,NULL,NULL,'2MASX J12434227+0033421',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000079,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,190.926,0.56183,0,NULL,58217140891,909642826,14213169,17.4),(99539,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99539,37.94,0.33,387,41705,70,NULL,NULL,'2MASX J12434252+6248029',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,190.9267083,62.80075,0,NULL,57376999142,896515611,14008056,18.1),(99540,'CMD','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99540,31.02,0.48,16,41706,NULL,NULL,NULL,'NGC 4651',NULL,'2014MNRAS.442.3544F',2014,1,4,NULL,'G',0.000007,NULL,'11.39',2.6,'SA(rs)c        LINER','Isolated galaxy',NULL,NULL,NULL,1,190.927625,16.39339,0.028,NULL,58878763472,919980679,14374698,11.39),(99541,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99541,31.99,0.4,25,41706,NULL,NULL,NULL,'NGC 4651',NULL,'2014MNRAS.442.3544F',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99542,'PNLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99542,31.36,0.07,18.7,41706,NULL,NULL,'31 candidate Pne','NGC 4651',NULL,'2014MNRAS.442.3544F',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99543,'PNLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99543,31.37,0.13,18.8,41706,NULL,NULL,'confirmed Pne','NGC 4651',NULL,'2014MNRAS.442.3544F',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99544,'GC radius','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99544,30.95,0.2,15.5,41706,NULL,NULL,NULL,'NGC 4651',NULL,'2014MNRAS.442.3544F',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99545,'SNII optical','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 2006my',NULL,99545,30.44,0.24,12.2,41706,NULL,NULL,'SCM','NGC 4651',NULL,'2015ApJ...799..215P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99546,'IRAS','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99546,30.86,0.8,14.9,41706,75,NULL,'A82, H','NGC 4651',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99547,'Sosies','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99547,31.86,0.17,23.6,41706,NULL,NULL,NULL,'NGC 4651',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99548,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99548,28.4,0.69,4.8,41706,100,NULL,'mid-IR','NGC 4651',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99549,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99549,31.13,0.4,16.8,41706,75,NULL,'B','NGC 4651',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99550,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99550,31.45,0.42,19.5,41706,65,NULL,NULL,'NGC 4651',NULL,'1980ApJ...238..458M',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99551,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99551,31.96,NULL,24.7,41706,NULL,NULL,'LEDA [April 2006]','NGC 4651',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99552,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99552,32.02,0.35,25.4,41706,NULL,NULL,NULL,'NGC 4651',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99553,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99553,32.09,0.7,26.2,41706,NULL,NULL,'HI','NGC 4651',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99554,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99554,32.15,0.04,26.9,41706,NULL,NULL,'stellar kinematics','NGC 4651',NULL,'2008ApJ...683...78C',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99555,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99555,32.22,0.45,27.8,41706,NULL,NULL,'Malmquist cor.','NGC 4651',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99556,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99556,32.28,0.43,28.5,41706,75,NULL,'3.6 micron, color corrected','NGC 4651',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99557,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99557,32.3,0.92,28.8,41706,NULL,NULL,'CO','NGC 4651',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99558,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99558,32.32,0.2,29.1,41706,74.4,NULL,NULL,'NGC 4651',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99559,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99559,32.34,0.47,29.3,41706,75,NULL,'A82, H, raw','NGC 4651',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99560,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99560,32.33,0.43,29.3,41706,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4651',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99561,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99561,32.41,0.47,30.4,41706,75,NULL,'A82, H, cor','NGC 4651',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99562,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99562,32.52,0.39,31.9,41706,NULL,NULL,NULL,'NGC 4651',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99563,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99563,32.56,0.47,32.5,41706,75,NULL,'A82, H, inv','NGC 4651',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99564,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99564,32.57,0.3,32.7,41706,55,NULL,'B','NGC 4651',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99565,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99565,38.31,0.46,459,41707,70,NULL,NULL,'2MASX J12434353+5449020',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000199,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,190.9312917,54.81719,0,NULL,57428463052,897319735,14020620,17.2),(99566,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99566,37.72,0.46,350,41708,70,NULL,NULL,'2MASX J12434370+2029359',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,190.932125,20.49336,0.117,NULL,58899062408,920297850,14379653,16.7),(99567,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99567,36.68,0.46,217,41709,70,NULL,NULL,'2MASX J12434373-0157006',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000066,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,190.93225,-1.95028,0.025,NULL,43170245995,674535093,10539610,17.6),(99568,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99568,38.21,0.46,438,41710,70,NULL,NULL,'2MASX J12434456+3014279',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,190.9355,30.24097,0.024,NULL,58781799638,918465619,14351025,17.2),(99569,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99569,37.35,0.46,295,41711,70,NULL,NULL,'2MASX J12434504+3548329',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000141,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,190.937667,35.80917,0,NULL,58567078870,915110607,14298603,17.6),(99570,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99570,36.34,0.33,185,41712,70,NULL,NULL,'2MASX J12434505-0021266',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000109,NULL,'15.6g',0.47,'E0',NULL,NULL,NULL,NULL,1,190.9377917,-0.35736,0.019,NULL,43168006678,674500104,10539064,15.6),(99571,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99571,36.59,0.56,208,41712,70,NULL,NULL,'2MASX J12434505-0021266',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99572,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99572,38.29,0.46,455,41713,70,NULL,NULL,'2MASX J12434527+1728342',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,190.938791667,17.47617,0.039,NULL,58875723650,919933182,14373955,17.7),(99573,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99573,35.44,0.44,122,41714,NULL,NULL,'Malmquist cor.','IC 3704',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000023,NULL,'14.83',0.3,'Sbc','Group member',NULL,NULL,NULL,1,190.9400417,10.77008,0,NULL,58183712838,909120513,14205008,14.83),(99574,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99574,35.54,0.42,128,41714,NULL,NULL,NULL,'IC 3704',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99575,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99575,35.58,0.2,131,41714,74.4,NULL,NULL,'IC 3704',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99576,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99576,36.65,0.46,214,41715,70,NULL,NULL,'2MASX J12434650+2713321',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,190.9439583,27.2255,0.068,NULL,58734680468,917729382,14339521,17.3),(99577,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99577,37.82,0.46,367,41716,70,NULL,NULL,'2MASX J12434695+3558460',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000169,NULL,'17.0g',0.31,NULL,NULL,NULL,NULL,NULL,1,190.945667,35.97942,0.006,NULL,58567064746,915110386,14298599,17),(99578,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99578,34.76,0.5,89.4,41717,NULL,NULL,'Malmquist cor.','ESO 574- G 025',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'15.10',0.6,'Sb',NULL,NULL,NULL,NULL,1,190.946166667,-20.15553,0.145,NULL,43911596613,686118697,10720604,15.1),(99579,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99579,34.86,0.48,93.6,41717,NULL,NULL,NULL,'ESO 574- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99580,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99580,34.9,0.2,95.5,41717,74.4,NULL,NULL,'ESO 574- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99581,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99581,38.13,0.46,422,41718,70,NULL,NULL,'SDSS J124347.13+631244.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000137,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,190.946417,63.21225,0,NULL,57376446561,896506977,14007921,17.9),(99582,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99582,37.63,0.46,336,41719,70,NULL,NULL,'2MASX J12434809+3614120',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000173,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,190.950417,36.23667,0.005,NULL,58566627747,915103558,14298493,16.8),(99583,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99583,34.63,0.48,84.4,41720,70,NULL,NULL,'NGC 4622A',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.46',0.5,'SAB0- pec:','in a pair',NULL,NULL,NULL,1,190.954625,-40.71461,0.497,NULL,46749265828,730457278,11413394,14.46),(99584,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99584,34.38,0.49,75,41721,75,NULL,'IR','UGC 07905 NED02',NULL,'2011yCatp016004901K',2011,1,2.17,NULL,'G',0.000073,NULL,'15.5g',0.21,'Sc','Pair member (points to parent)',NULL,NULL,NULL,1,190.955916667,54.90494,0,NULL,57428631236,897322363,14020661,15.5),(99585,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99585,37.93,0.46,385,41722,70,NULL,NULL,'LCRS B124115.5-032400',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000103,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,190.958833,-3.67358,0.013,NULL,43178212216,674659565,10541555,17.4),(99586,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99586,32.96,0.4,39.1,41723,75,NULL,'B','NGC 4653',NULL,'1988NBGC.C....0000T',1988,1,1.77,'The APM position is northeast of the nucleus.','G',0.000017,NULL,'13.4g',1.38,'SAB(rs)cd','Group member',NULL,NULL,NULL,1,190.962125,-0.56122,0.03,NULL,43167984324,674499755,10539058,13.4),(99587,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99587,33.08,NULL,41.3,41723,NULL,NULL,'B','NGC 4653',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99588,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99588,36.96,0.46,246,41724,70,NULL,NULL,'2MASX J12435266+3701180',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,190.969375,37.02153,0,NULL,58567863366,915122865,14298794,17.2),(99589,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99589,34.86,0.25,93.8,41725,74.4,NULL,NULL,'CGCG 159-063',NULL,'2013AJ....146...86T',2013,1,0.65,NULL,'G',0.000077,NULL,'15.7',0.62,'E3',NULL,NULL,NULL,NULL,1,190.970916667,26.86333,0.06,NULL,58734823411,917731615,14339556,15.7),(99590,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99590,37.66,0.33,340,41726,70,NULL,NULL,'2MASX J12435338+3149409',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000161,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,190.972417,31.82817,0.035,NULL,58780266256,918441660,14350650,17),(99591,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99591,37.17,0.46,272,41727,70,NULL,NULL,'2MASX J12435509+4314572',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,190.979625,43.24911,0,NULL,59120314940,923754920,14433670,17.9),(99592,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99592,37.47,0.46,312,41728,70,NULL,NULL,'2MASX J12435516+2937489',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000146,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,190.979833,29.63039,0.054,NULL,58781157255,918455582,14350868,17.1),(99593,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99593,38.36,0.46,469,41729,70,NULL,NULL,'2MASX J12435639-0110256',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000081,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,190.985083333,-1.17383,0.049,NULL,43168503154,674507861,10539185,18.1),(99594,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99594,38.15,0.46,426,41730,70,NULL,NULL,'2MASX J12435655-0228456',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000087,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,190.98575,-2.47939,0.029,NULL,43170824770,674544137,10539752,17.3),(99595,'Grav. Stability Gas. Disk','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99595,30.94,NULL,15.4,41731,NULL,NULL,NULL,'NGC 4654',NULL,'1996AstL...22...71Z',1996,1,5.17,NULL,'G',0.000017,NULL,'12.0g',1.41,'SAB(rs)cd      HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,190.98575,13.12667,0.06,NULL,58875193789,919924902,14373826,12),(99596,'IRAS','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99596,31.42,0.8,19.3,41731,75,NULL,'A82, H','NGC 4654',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99597,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99597,29.09,0.69,6.57,41731,100,NULL,'mid-IR','NGC 4654',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99598,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99598,30.43,0.92,12.2,41731,NULL,NULL,'CO','NGC 4654',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99599,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99599,30.58,0.43,13.1,41731,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4654',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99600,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99600,30.67,0.43,13.6,41731,75,NULL,'3.6 micron, color corrected','NGC 4654',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99601,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99601,30.74,0.35,14.1,41731,NULL,NULL,NULL,'NGC 4654',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99602,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99602,30.75,NULL,14.1,41731,NULL,NULL,NULL,'NGC 4654',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99603,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99603,30.76,0.7,14.2,41731,NULL,NULL,'HI','NGC 4654',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99604,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99604,30.79,0.42,14.4,41731,65,NULL,NULL,'NGC 4654',NULL,'1980ApJ...238..458M',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99605,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99605,30.81,0.2,14.5,41731,74.4,NULL,NULL,'NGC 4654',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99606,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99606,30.99,NULL,15.8,41731,84,NULL,'RSA Hubble type','NGC 4654',NULL,'1986AJ.....91.1286S',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99607,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99607,31.01,0.47,15.9,41731,NULL,NULL,'H','NGC 4654',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99608,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99608,31.02,0.46,16,41731,NULL,NULL,'J','NGC 4654',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99609,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99609,31.03,0.45,16.1,41731,NULL,NULL,'K','NGC 4654',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99610,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99610,31.03,0.42,16.1,41731,NULL,NULL,'Malmquist cor.','NGC 4654',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99611,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99611,31.03,0.42,16.1,41731,NULL,NULL,NULL,'NGC 4654',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99612,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99612,31.07,0.47,16.3,41731,75,NULL,'A82, H, raw','NGC 4654',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99613,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99613,31.13,0.4,16.8,41731,75,NULL,'B','NGC 4654',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99614,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99614,31.16,0.47,17.1,41731,75,NULL,'A82, H, inv','NGC 4654',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99615,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99615,31.33,0.47,18.5,41731,75,NULL,'A82, H, cor','NGC 4654',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99616,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99616,31.35,0.4,18.6,41731,NULL,NULL,'mean','NGC 4654',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99617,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99617,31.41,0.3,19.1,41731,55,NULL,'B','NGC 4654',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99618,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99618,32,NULL,25.1,41731,84,NULL,'RSA Hubble type','NGC 4654',NULL,'1986AJ.....91.1286S',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99619,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99619,37.52,0.46,320,41732,70,NULL,NULL,'2MASX J12435757+6636020',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000101,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,190.990291667,66.60053,0.041,NULL,57854444329,903975692,14124620,16.3),(99620,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99620,28.42,0.2,4.83,41733,74.4,NULL,NULL,'NGC 4656',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'GPair',0.000003,NULL,NULL,NULL,'SB(s)m pec     HII','Pair member (points to parent)',NULL,NULL,NULL,1,190.990541667,32.16814,0.03,NULL,58747532850,917930200,14342659,NULL),(99621,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99621,28.5,0.43,5,41733,75,NULL,'3.6 micron, color corrected','NGC 4656',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99622,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99622,28.53,0.43,5.1,41733,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4656',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99623,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99623,28.66,NULL,5.4,41733,NULL,NULL,NULL,'NGC 4656',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99624,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99624,28.69,0.36,5.47,41733,NULL,NULL,NULL,'NGC 4656',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99625,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99625,29.3,0.4,7.2,41733,75,NULL,'B','NGC 4656',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99626,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99626,36.61,0.33,210,41734,70,NULL,NULL,'2MASX J12435771+0143381',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00011,NULL,'15.5g',0.45,'S0^-',NULL,NULL,NULL,NULL,1,190.990417,1.72717,0,NULL,58220629911,909697342,14214020,15.5),(99627,'TRGB','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99627,28.18,0.1,4.33,41735,74.4,NULL,NULL,'SDSS J124357.79+433940.3',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000002,NULL,'17.',0.6,'dwarf Irr',NULL,NULL,NULL,NULL,1,190.9907917,43.66122,0,NULL,59122414236,923787722,14434183,17),(99628,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99628,34.61,0.56,83.4,41736,NULL,NULL,'Malmquist cor.','ESO 268- G 035',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.91',0.8,'Sc?',NULL,NULL,NULL,NULL,1,190.9932917,-45.59478,0.469,NULL,46769636314,730775567,11418368,14.91),(99629,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99629,34.86,0.5,93.7,41736,NULL,NULL,NULL,'ESO 268- G 035',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99630,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99630,34.9,0.2,95.5,41736,74.4,NULL,NULL,'ESO 268- G 035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99631,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99631,37.94,0.33,387,41737,70,NULL,NULL,'2MASX J12440220+6245269',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,191.008875,62.75747,0,NULL,57376881510,896513773,14008027,17.5),(99632,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99632,37.32,0.46,291,41738,70,NULL,NULL,'SDSS J124402.54+030558.9',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,191.010583,3.09972,0.071,NULL,58231642525,909869414,14216709,17.5),(99633,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99633,36.9,0.55,240,41739,70,NULL,NULL,'2MASX J12440301-2140581',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.05',NULL,NULL,NULL,NULL,NULL,NULL,1,191.012583,-21.68286,0.113,NULL,43921794218,686278034,10723094,16.05),(99634,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99634,37.02,0.46,253,41740,70,NULL,NULL,'2MASX J12440317+2600259',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000083,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,191.013333,26.00717,0.09,NULL,58723309394,917551709,14336745,16.6),(99635,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99635,32.02,0.4,25.4,41741,75,NULL,'B','DDO 142',NULL,'1988NBGC.C....0000T',1988,1,3.2,NULL,'G',0.000003,NULL,'12.81',2.6,'SAB(rs)dm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.0147917,-5.67606,0.049,NULL,43176323606,674630056,10541094,12.81),(99636,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99636,38.02,0.46,401,41742,70,NULL,NULL,'2MASX J12440395+3759209',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000151,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,191.016417,37.98908,0,NULL,58558998898,914984357,14296630,17.3),(99637,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99637,37.82,0.46,367,41743,70,NULL,NULL,'LCRS B124129.9-025948',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00007,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,191.018375,-3.27017,0.025,NULL,43177444923,674647576,10541368,18.3),(99638,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99638,34.5,0.15,79.4,41744,NULL,NULL,'HST, Cantiello et al. 05','ESO 381- G 012',NULL,'2008ApJ...678..168B',2008,1,1,NULL,'G',0.000047,NULL,'12.6',0.8,'S?',NULL,NULL,NULL,NULL,1,191.021916667,-34.20208,0.297,NULL,43462880557,679107508,10611054,12.6),(99639,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99639,34.6,0.25,83.2,41744,NULL,NULL,'HST, Jensen et al. 03','ESO 381- G 012',NULL,'2008ApJ...678..168B',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99640,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99640,34.7,0.25,87.1,41744,NULL,NULL,'ACS','ESO 381- G 012',NULL,'2008ApJ...678..168B',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99641,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99641,37.83,0.46,369,41745,70,NULL,NULL,'2MASX J12440610+0002052',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000083,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,191.02525,0.03497,0,NULL,57998876378,906232443,14159881,17.3),(99642,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99642,37.94,0.46,387,41746,70,NULL,NULL,'2MASX J12440605+5237199',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,191.025375,52.62214,0,NULL,57199796474,893746819,13964794,17.5),(99643,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99643,37.8,0.27,363,41747,70,NULL,NULL,'2MASX J12440718+0119382',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000087,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,191.0300417,1.32719,0.009,NULL,58217444498,909647570,14213243,17.7),(99644,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99644,37.84,0.46,370,41748,70,NULL,NULL,'2MASX J12440756+3930147',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,191.031583,39.50417,0,NULL,59082804117,923168814,14424512,17.9),(99645,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99645,37.55,0.46,324,41749,70,NULL,NULL,'2MASX J12440833+0213332',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000163,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,191.034583333,2.22597,0,NULL,58218885612,909670087,14213595,17.3),(99646,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99646,38.4,0.46,480,41750,70,NULL,NULL,'2MASX J12440874+2932029',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,191.0364583,29.53417,0.054,NULL,58781190229,918456097,14350876,17.4),(99647,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99647,36.61,0.33,210,41751,70,NULL,NULL,'2MASX J12440925+0137102',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000071,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,191.038417,1.6195,0,NULL,58220638231,909697472,14214023,16.8),(99648,'IRAS','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99648,33.21,0.8,43.9,41752,75,NULL,'MAT, I','ESO 381- G 014',NULL,'1997ApJS..109..333W',1997,1,1.34,NULL,'G',0.000027,NULL,'15.15',0.18,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.039875,-36.511,0.253,NULL,43250643740,675791308,10559239,15.15),(99649,'IRAS','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99649,33.24,0.8,44.4,41752,75,NULL,'HMCL, I','ESO 381- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99650,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99650,33.13,0.38,42.3,41752,NULL,NULL,NULL,'ESO 381- G 014',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99651,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99651,33.14,0.4,42.4,41752,75,NULL,'HMCL, I, raw','ESO 381- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99652,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99652,33.14,NULL,42.5,41752,NULL,NULL,NULL,'ESO 381- G 014',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99653,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99653,33.16,0.32,42.9,41752,85,NULL,'I, inv','ESO 381- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99654,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99654,33.16,0.4,42.9,41752,75,NULL,'HMCL, I, inv','ESO 381- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99655,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99655,33.17,0.32,43,41752,85,NULL,'I, raw','ESO 381- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99656,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99656,33.21,0.2,43.9,41752,74.4,NULL,NULL,'ESO 381- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99657,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99657,33.22,NULL,44,41752,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 381- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99658,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99658,33.22,0.43,44.1,41752,75,NULL,'3.6 micron, color + selection bias corrected','ESO 381- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99659,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99659,33.23,0.43,44.2,41752,75,NULL,'3.6 micron, color corrected','ESO 381- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99660,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99660,33.25,NULL,44.6,41752,NULL,NULL,'Dipole + Quadrupole','ESO 381- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99661,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99661,33.25,NULL,44.7,41752,NULL,NULL,'Dipole','ESO 381- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99662,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99662,33.32,0.4,46,41752,75,NULL,'HMCL, I, cor','ESO 381- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99663,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99663,33.37,0.43,47.2,41752,75,NULL,'MAT, I, raw','ESO 381- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99664,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99664,33.38,0.12,47.5,41752,NULL,NULL,NULL,'ESO 381- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99665,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99665,33.38,0.49,47.5,41752,75,NULL,'IR','ESO 381- G 014',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99666,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99666,33.41,0.43,48.2,41752,75,NULL,'MAT, I, inv','ESO 381- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99667,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99667,33.52,0.43,50.7,41752,75,NULL,'MAT, I, cor','ESO 381- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99668,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99668,32.29,0.12,28.7,41753,74.4,NULL,NULL,'NGC 4645',NULL,'2013AJ....146...86T',2013,1,2.2,NULL,'G',0.000011,NULL,'12.88',1.4,'E+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.041625,-41.74994,0.501,NULL,46764850529,730700789,11417199,12.88),(99669,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99669,32.38,0.18,29.9,41753,NULL,NULL,'I','NGC 4645',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99670,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99670,32.38,0.18,29.9,41753,NULL,NULL,NULL,'NGC 4645',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99671,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99671,32.45,0.18,31,41753,NULL,NULL,'Malmquist cor.','NGC 4645',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99672,'D-Sigma','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99672,32.93,0.4,38.6,41753,75,NULL,'Edat, raw','NGC 4645',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99673,'D-Sigma','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99673,32.95,0.4,38.9,41753,75,NULL,'Edat, cor','NGC 4645',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99674,'Faber-Jackson','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99674,32.99,0.65,39.6,41753,95,NULL,'Weighted Mean','NGC 4645',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99675,'Faber-Jackson','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99675,34.67,0.81,85.9,41753,55,NULL,'Visvanathan & Sandage 1979','NGC 4645',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99676,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99676,32.18,0.5,27.3,41753,70,NULL,NULL,'NGC 4645',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99677,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99677,32.29,0.12,28.7,41753,74.4,NULL,NULL,'NGC 4645',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99678,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99678,32.35,0.41,29.5,41753,NULL,NULL,NULL,'NGC 4645',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99679,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99679,32.77,0.41,35.8,41753,NULL,NULL,'Malmquist cor.','NGC 4645',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99680,'Tertiary','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99680,32.42,0.71,30.5,41753,95,NULL,NULL,'NGC 4645',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99681,'Tully est','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99681,33.33,0.8,46.4,41753,75,NULL,'B','NGC 4645',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99682,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99682,32.61,0.45,33.2,41753,NULL,NULL,'K','NGC 4645',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99683,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99683,33.02,0.4,40.1,41753,NULL,NULL,'mean','NGC 4645',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99684,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99684,31.08,0.14,16.4,41754,74.4,NULL,NULL,'VCC 1993',NULL,'2013AJ....146...86T',2013,1,0.66,NULL,'G',0.000068,NULL,'15.6g',0.59,'E0','Group member',NULL,NULL,NULL,1,191.050125,12.94183,0.007,NULL,58871906615,919873540,14373024,15.6),(99685,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99685,31.09,0.05,16.5,41754,NULL,NULL,NULL,'VCC 1993',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99686,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99686,31.1,0.07,16.6,41754,NULL,NULL,'HST ACS VCS','VCC 1993',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99687,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99687,37.81,0.46,365,41755,70,NULL,NULL,'2MASX J12441371+0042052',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000081,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,191.0569583,0.70156,0,NULL,58217033451,909641147,14213142,17.6),(99688,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99688,35.02,0.74,101,41756,70,NULL,NULL,'2MFGC 10032',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00013,NULL,'10.8K',NULL,NULL,NULL,NULL,NULL,NULL,1,191.061167,-16.30939,0.089,NULL,43934496869,686476513,10726195,10.8),(99689,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99689,37.8,0.27,363,41757,70,NULL,NULL,'2MASX J12441571+0114202',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000079,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,191.065417,1.23886,0,NULL,58217449129,909647642,14213244,17.9),(99690,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99690,38.64,0.46,535,41758,70,NULL,NULL,'SDSS J124415.77-015055.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000095,NULL,'18.2g',0.17,'NLAGN',NULL,NULL,NULL,NULL,1,191.06575,-1.84881,0.021,NULL,43170376700,674537135,10539642,18.2),(99691,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99691,38.05,0.46,408,41759,70,NULL,NULL,'SDSS J124417.14+572616.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000145,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,191.0714583,57.43792,0,NULL,57407444279,896991316,14015489,18.6),(99692,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99692,37.47,0.46,312,41760,70,NULL,NULL,'2MASX J12441821+1035422',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.32',0.15,NULL,NULL,NULL,NULL,NULL,1,191.076,10.59492,0,NULL,58186867068,909169797,14205778,18.32),(99693,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99693,38.27,0.46,452,41761,70,NULL,NULL,'2MASX J12441904+6241428',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000178,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,191.0795417,62.69517,0,NULL,57376596745,896509324,14007958,17.9),(99694,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99694,33.2,NULL,43.6,41762,NULL,NULL,NULL,'FGC 1496',NULL,'2000BSAO...50....5K',2000,1,2.02,NULL,'G',0.00001,NULL,'15.22',0.12,'Sdm',NULL,NULL,NULL,NULL,1,191.079583,-5.53681,0.049,NULL,43176338095,674630282,10541098,15.22),(99695,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99695,33.23,NULL,44.2,41762,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1496',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99696,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99696,33.23,NULL,44.2,41762,NULL,NULL,'Dipole + Quadrupole','FGC 1496',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99697,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99697,33.23,NULL,44.3,41762,NULL,NULL,'Dipole','FGC 1496',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99698,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99698,36.54,0.52,203,41763,70,NULL,NULL,'2MASX J12441932-0711598',NULL,'2014MNRAS.445.2677S',2014,1,1.01,NULL,'G',0.00015,NULL,'15.36',0.47,NULL,NULL,NULL,NULL,NULL,1,191.0805417,-7.19997,0.037,NULL,43158701356,674354708,10536792,15.36),(99699,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99699,37.04,0.46,256,41764,70,NULL,NULL,'2MASX J12441951+0655162',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,191.081416667,6.92122,0,NULL,58192131761,909252058,14207063,16.9),(99700,'Tully est','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99700,33.33,0.8,46.4,41765,75,NULL,NULL,'NGC 4650',NULL,'1988NBGC.C....0000T',1988,1,3.2,NULL,'G',0.000123,NULL,'12.6',2.8,'SB(rs)a','in a chain',NULL,NULL,NULL,1,191.081625,-40.73181,0.497,NULL,46747236930,730425577,11412899,12.6),(99701,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99701,37.8,0.27,363,41766,70,NULL,NULL,'2MASX J12442031+0105452',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000081,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,191.0845,1.09597,0,NULL,58217402763,909646918,14213233,16.4),(99702,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99702,37.51,0.46,318,41767,70,NULL,NULL,'2MASX J12442020+5913111',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000176,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,191.0845,59.21978,0,NULL,57403944903,896936639,14014634,17.1),(99703,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99703,37.67,0.46,342,41768,70,NULL,NULL,'2MASX J12442087+6237367',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000151,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,191.0870417,62.62672,0,NULL,57376631408,896509865,14007966,17.6),(99704,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99704,35.87,0.2,149,41769,74.4,NULL,NULL,'IC 3714',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000015,NULL,'15.1',0.55,'SBb(s)I','Group member',NULL,NULL,NULL,1,191.096167,10.18883,0,NULL,58186974052,909171469,14205804,15.1),(99705,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99705,38.07,0.46,411,41770,70,NULL,NULL,'2MASX J12442309+6204267',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000154,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,191.096333,62.07419,0.017,NULL,57362739806,896292809,14004575,17.2),(99706,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99706,35.17,0.46,108,41771,70,NULL,NULL,'2MASX J12442358+6020577',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000156,NULL,'15.6g',0.43,'E',NULL,NULL,NULL,NULL,1,191.09825,60.34922,0,NULL,57332059903,895813435,13997084,15.6),(99707,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99707,38.13,0.27,423,41772,70,NULL,NULL,'2MASX J12442452+0145562',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,191.1022917,1.76569,0,NULL,58218557281,909664957,14213514,17.6),(99708,'Tully est','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99708,29.28,0.8,7.2,41773,75,NULL,NULL,'UGC 07916',NULL,'1988NBGC.C....0000T',1988,1,2.5,NULL,'G',0.00002,NULL,'17.',1.7,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.10475,34.38653,0.01,NULL,58743456029,917866500,14341664,17),(99709,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99709,29.8,NULL,9.12,41773,NULL,NULL,NULL,'UGC 07916',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99710,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99710,36.87,0.46,236,41774,70,NULL,NULL,'2MASX J12442598+0111472',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00008,NULL,'16.6g',0.27,'Cand.grav.lens',NULL,NULL,NULL,NULL,1,191.108375,1.19636,0,NULL,58217449927,909647655,14213244,16.6),(99711,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99711,34.19,0.67,68.9,41775,NULL,NULL,NULL,'NGC 4662',NULL,'2009ApJS..182..474S',2009,1,1.74,NULL,'G',0.00002,NULL,'13.7g',1.36,'SB(rs)bc','Isolated galaxy',NULL,NULL,NULL,1,191.109167,37.12122,0,NULL,58567773527,915121461,14298772,13.7),(99712,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99712,34.23,0.2,70.2,41775,74.4,NULL,NULL,'NGC 4662',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99713,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99713,34.33,0.63,73.5,41775,NULL,NULL,'Malmquist cor.','NGC 4662',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99714,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99714,37.26,0.46,283,41776,70,NULL,NULL,'SDSS J124428.54+331546.2',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,191.1189583,33.26283,0.019,NULL,58750379954,917974686,14343354,17.1),(99715,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99715,31.03,0.4,16.1,41777,NULL,NULL,NULL,'UGC 07911',NULL,'2013MNRAS.429.2677K',2013,1,2.01,NULL,'G',0.000018,NULL,'14.7g',0.64,'(R\')SB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.119875,0.46806,0,NULL,58217176225,909643378,14213177,14.7),(99716,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99716,31.86,0.4,23.5,41777,75,NULL,'B','UGC 07911',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99717,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99717,39.07,0.46,652,41778,70,NULL,NULL,'SDSS J124430.09+024852.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000083,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,191.125375,2.81458,0.048,NULL,58218020585,909656571,14213383,18.4),(99718,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99718,37.52,0.46,319,41779,70,NULL,NULL,'2MASX J12443098+6529324',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,191.129208333,65.49225,0.049,NULL,57320072865,895626138,13994158,17),(99719,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99719,38.06,0.27,409,41780,70,NULL,NULL,'SDSS J124431.73+161217.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,191.13225,16.20497,0.031,NULL,58878708077,919979813,14374684,18.4),(99720,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99720,30.68,0.12,13.7,41781,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4660',NULL,'2007ApJS..171..101J',2007,1,2.2,NULL,'G',0.000014,NULL,'12.16',1.6,'E5','in a radial-velocity based grouping',NULL,NULL,NULL,1,191.13325,11.19053,0,NULL,58184353002,909130515,14205164,12.16),(99721,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99721,30.71,0.11,13.9,41781,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4660',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99722,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99722,30.8,0.18,14.5,41781,NULL,NULL,NULL,'NGC 4660',NULL,'2001AJ....121.2950K',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99723,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99723,30.87,0.11,14.9,41781,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4660',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99724,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99724,31,0.1,15.8,41781,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4660',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99725,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99725,30.37,0.18,11.9,41781,NULL,NULL,'I','NGC 4660',NULL,'1997AJ....114..626A',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99726,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99726,30.54,0.19,12.8,41781,NULL,NULL,'I','NGC 4660',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99727,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99727,30.61,0.21,13.2,41781,NULL,NULL,'HST KP Calibrated, I','NGC 4660',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99728,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99728,30.76,0.18,14.2,41781,NULL,NULL,'HST KP Calibrated, F814W','NGC 4660',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99729,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99729,30.88,0.05,15,41781,NULL,NULL,NULL,'NGC 4660',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99730,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99730,30.88,0.07,15,41781,NULL,NULL,'HST ACS VCS','NGC 4660',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99731,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99731,31.11,0.12,16.7,41781,74.4,NULL,NULL,'NGC 4660',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99732,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99732,31.3,0.16,18.2,41781,NULL,NULL,'I','NGC 4660',NULL,'2000ApJ...536..255N',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99733,'GC radius','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99733,30.76,0.05,14.2,41781,NULL,NULL,NULL,'NGC 4660',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99734,'D-Sigma','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99734,31.13,0.4,16.8,41781,75,NULL,'Edat, raw','NGC 4660',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99735,'D-Sigma','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99735,31.15,0.4,17,41781,75,NULL,'Edat, cor','NGC 4660',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99736,'Faber-Jackson','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99736,31.21,0.3,17.5,41781,95,NULL,'Weighted Mean','NGC 4660',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99737,'Faber-Jackson','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99737,31.26,0.52,17.9,41781,95,NULL,'de Vaucouleurs','NGC 4660',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99738,'Faber-Jackson','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99738,31.4,0.63,19.1,41781,95,NULL,'Michard 1979b, c','NGC 4660',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99739,'Faber-Jackson','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99739,31.8,0.46,22.9,41781,95,NULL,'Michard 1979a','NGC 4660',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99740,'Faber-Jackson','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99740,31.9,0.81,24,41781,55,NULL,'Visvanathan & Sandage 1979','NGC 4660',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99741,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99741,30.83,NULL,14.7,41781,NULL,NULL,NULL,'NGC 4660',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99742,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99742,31.01,NULL,15.9,41781,NULL,NULL,NULL,'NGC 4660',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99743,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99743,31.11,0.12,16.7,41781,74.4,NULL,NULL,'NGC 4660',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99744,'Tertiary','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99744,30.49,0.25,12.5,41781,95,NULL,NULL,'NGC 4660',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99745,'Tully est','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99745,31.13,0.8,16.8,41781,75,NULL,'B','NGC 4660',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99746,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99746,31.65,0.45,21.4,41781,NULL,NULL,'K','NGC 4660',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99747,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99747,31.66,0.4,21.5,41781,NULL,NULL,'mean','NGC 4660',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99748,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99748,37.88,0.46,377,41782,70,NULL,NULL,'2MASX J12443236+3145044',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,191.135125,31.75125,0.02,NULL,58780280669,918441885,14350654,17.8),(99749,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99749,34.15,0.49,67.7,41783,75,NULL,'IR','UGC 07922',NULL,'2011yCatp016004901K',2011,1,1.77,NULL,'G',0.000027,NULL,'14.6g',0.37,'SBbc?','Group member',NULL,NULL,NULL,1,191.135375,56.15017,0,NULL,57430780141,897355939,14021186,14.6),(99750,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99750,34.31,0.2,72.8,41783,74.4,NULL,NULL,'UGC 07922',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99751,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99751,34.38,0.38,75,41783,NULL,NULL,'Malmquist cor.','UGC 07922',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99752,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99752,34.48,0.4,78.9,41783,NULL,NULL,'mean','UGC 07922',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99753,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99753,34.5,0.36,79.4,41783,NULL,NULL,NULL,'UGC 07922',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99754,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99754,34.7,0.47,87,41783,NULL,NULL,'H','UGC 07922',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99755,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99755,36.36,0.67,187,41784,70,NULL,NULL,'2MASX J12443281-0712282',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'16.14',0.29,NULL,NULL,NULL,NULL,NULL,1,191.136666667,-7.20789,0.037,NULL,43158831456,674356741,10536824,16.14),(99756,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99756,37.99,0.46,396,41785,70,NULL,NULL,'2MASX J12443284+0800329',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000203,NULL,'17.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,191.136708333,8.00919,0,NULL,58193854263,909278972,14207483,17.3),(99757,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99757,31.51,0.4,20,41786,NULL,NULL,NULL,'UGC 07913',NULL,'2013MNRAS.429.2677K',2013,1,1.4,NULL,'G',0.00001,NULL,'14.7B',0.7,'SAB(s)m',NULL,NULL,NULL,NULL,1,191.1382083,-2.31903,0.017,NULL,43170845543,674544461,10539757,14.7),(99758,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99758,37.64,0.46,337,41787,70,NULL,NULL,'2MASX J12443359+1001199',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.65',0.16,NULL,NULL,NULL,NULL,NULL,1,191.1400417,10.02231,0,NULL,58185847330,909153864,14205529,18.65),(99759,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99759,38.06,0.46,409,41788,70,NULL,NULL,'SDSS J124433.83-004912.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000075,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,191.141,-0.82017,0.021,NULL,43168640216,674510003,10539218,18.1),(99760,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99760,37.66,0.46,340,41789,70,NULL,NULL,'2MASX J12443495+1706502',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,191.14575,17.11411,0.048,NULL,58879331172,919989549,14374836,17.6),(99761,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99761,36.48,0.46,198,41790,70,NULL,NULL,'2MASX J12443668+2845589',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000179,NULL,'16.0g',0.39,'S0',NULL,NULL,NULL,NULL,1,191.152917,28.76625,0.06,NULL,58732976241,917702753,14339105,16),(99762,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99762,38.8,0.46,576,41791,70,NULL,NULL,'2MASX J12443734+4844390',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000194,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,191.155458333,48.74422,0,NULL,59094379147,923349674,14427338,17.7),(99763,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99763,36.87,0.21,236,41792,70,NULL,NULL,'2MASX J12443745+0148241',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000095,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,191.156125,1.80678,0,NULL,58218750740,909667980,14213562,16.3),(99764,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99764,36.3,0.46,182,41793,70,NULL,NULL,'CGCG 043-013',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000098,NULL,'15.8g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,191.157083,2.85906,0.048,NULL,58218013064,909656454,14213382,15.8),(99765,'Tully est','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99765,32.76,0.8,35.7,41794,75,NULL,'B','NGC 4658',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.000021,NULL,'13.01',0.9,'SB(s)bc','in a pair',NULL,NULL,NULL,1,191.1574583,-10.08311,0.097,NULL,43154783663,674293494,10535835,13.01),(99766,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99766,31.66,0.4,21.5,41794,NULL,NULL,NULL,'NGC 4658',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99767,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99767,32.08,0.43,26.1,41794,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4658',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99768,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99768,32.19,0.43,27.5,41794,75,NULL,'3.6 micron, color corrected','NGC 4658',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99769,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99769,32.33,0.2,29.2,41794,74.4,NULL,NULL,'NGC 4658',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99770,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99770,32.52,0.47,32,41794,NULL,NULL,'H','NGC 4658',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99771,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99771,32.56,0.45,32.6,41794,NULL,NULL,'K','NGC 4658',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99772,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99772,32.85,0.4,37.1,41794,NULL,NULL,'mean','NGC 4658',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99773,'Tully est','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99773,29.93,0.8,9.7,41795,75,NULL,'B','UGCA 294',NULL,'1988NBGC.C....0000T',1988,1,0.7,NULL,'G',0.000023,NULL,'15.10',0.4,'S0 pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.1589583,28.4725,0.069,NULL,58733728895,917714513,14339289,15.1),(99774,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99774,29.98,NULL,9.91,41795,NULL,NULL,NULL,'UGCA 294',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99775,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99775,37.48,0.33,313,41796,70,NULL,NULL,'2MASX J12443844+0440131',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000152,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,191.16,4.67031,0,NULL,58221885543,909716961,14214327,16.9),(99776,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99776,38.08,0.46,413,41797,70,NULL,NULL,'2MASX J12443899+2753209',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,191.1625,27.88925,0.07,NULL,58736642139,917760033,14340000,17.9),(99777,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99777,37.4,0.46,303,41798,70,NULL,NULL,'2MASX J12443938+4654019',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,191.164167,46.90067,0,NULL,59113925743,923655089,14432110,17.7),(99778,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99778,36.85,0.46,235,41799,70,NULL,NULL,'2MASX J12444055+4933070',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,191.1690417,49.55194,0,NULL,59094174909,923346482,14427288,17),(99779,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99779,37.78,0.46,359,41800,70,NULL,NULL,'SDSS J124441.21+020850.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000146,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,191.17175,2.14736,0,NULL,58218582150,909665346,14213521,18.2),(99780,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99780,37.48,0.33,313,41801,70,NULL,NULL,'2MASX J12444185+0434531',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000183,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,191.1744583,4.5815,0,NULL,58221706196,909714159,14214283,16.7),(99781,'TRGB','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99781,28.47,NULL,4.94,41802,NULL,NULL,'I','ESO 381- G 018',NULL,'2006ARep...50..517T',2006,1,1.2,NULL,'G',0.000022,NULL,'15.79',0.7,'Irr',NULL,NULL,NULL,NULL,1,191.176625,-35.96672,0.253,NULL,43250217239,675784644,10559135,15.79),(99782,'TRGB','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99782,28.55,0.1,5.13,41802,NULL,NULL,NULL,'ESO 381- G 018',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99783,'TRGB','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99783,28.56,NULL,5.15,41802,NULL,NULL,NULL,'ESO 381- G 018',NULL,'2011A&A...530A..59C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99784,'TRGB','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99784,28.63,NULL,5.33,41802,NULL,NULL,NULL,'ESO 381- G 018',NULL,'2007AJ....133..504K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99785,'TRGB','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99785,28.65,0.06,5.37,41802,NULL,NULL,'I','ESO 381- G 018',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99786,'TRGB','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99786,28.68,0.1,5.45,41802,74.4,NULL,NULL,'ESO 381- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99787,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99787,36.08,0.36,164,41803,NULL,NULL,'Malmquist cor.','IC 3726',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000118,NULL,'14.9g',0.33,'Scd:','Group member',NULL,NULL,NULL,1,191.1774583,40.679,0,NULL,59083850321,923185161,14424768,14.9),(99788,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99788,36.42,0.31,192,41803,NULL,NULL,NULL,'IC 3726',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99789,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99789,37.97,0.46,392,41804,70,NULL,NULL,'2MASX J12444264+1200242',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,191.177833,12.00658,0.012,NULL,58871386134,919865408,14372897,17.7),(99790,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99790,35.87,0.48,149,41805,70,NULL,NULL,'ESO 381- G 019',NULL,'2014MNRAS.445.2677S',2014,1,1.1,'The FLASH velocity (see 2003MNRAS.339..652K) is given as 6625 +/- 108km/sec.','G',0.000047,NULL,'15.42',0.4,'S0',NULL,NULL,NULL,NULL,1,191.1835417,-35.87244,0.253,NULL,43250162654,675783791,10559121,15.42),(99791,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99791,38.01,0.46,400,41806,70,NULL,NULL,'2MASX J12444477+1643542',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,191.186625,16.73186,0.039,NULL,58879609285,919993895,14374904,17.5),(99792,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99792,37.96,0.46,390,41807,70,NULL,NULL,'2MASX J12444495+5107029',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,191.187333,51.11753,0,NULL,57204742218,893824097,13966001,17.9),(99793,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99793,37.11,0.33,264,41808,70,NULL,NULL,'2MASX J12444571+4207510',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000178,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,191.190625,42.13078,0,NULL,59116441649,923694400,14432725,16.5),(99794,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99794,29.16,NULL,6.79,41809,NULL,NULL,NULL,'IC 3718',NULL,'2013AJ....145..101K',2013,1,2.3,'The SDSS position is 12 arcsec northwest of the nucleus.','G',0.000017,NULL,'14.0g',0.68,'S','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.191583333,12.35144,0.038,NULL,58872155967,919877436,14373084,14),(99795,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99795,34.56,0.49,81.7,41810,75,NULL,'IR','NGC 4669',NULL,'2011yCatp016004901K',2011,1,1.4,'Multiple SDSS entries describe this object.','G',0.000184,NULL,'14.1',0.4,'S','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.193917,54.87589,0,NULL,57428655970,897322749,14020667,14.1),(99796,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99796,37.11,0.33,264,41811,70,NULL,NULL,'2MASX J12444706+4206091',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000211,NULL,'16.1g',0.37,'E0',NULL,NULL,NULL,NULL,1,191.196125,42.10258,0,NULL,59116471125,923694861,14432732,16.1),(99797,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99797,37.82,0.46,366,41812,70,NULL,NULL,'2MASX J12444762+1020438',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.38',0.15,NULL,NULL,NULL,NULL,NULL,1,191.198667,10.34556,0,NULL,58187029507,909172336,14205817,18.38),(99798,'IRAS','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99798,33.48,0.8,49.7,41813,75,NULL,'MAT, I','ESO 574- G 028',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'15.22',0.2,'SA(s)c: sp',NULL,NULL,NULL,NULL,1,191.20325,-20.78506,0.117,NULL,43920923104,686264423,10722881,15.22),(99799,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99799,32.9,0.32,38.1,41813,85,NULL,'I, inv','ESO 574- G 028',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99800,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99800,32.92,0.32,38.3,41813,85,NULL,'I, raw','ESO 574- G 028',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99801,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99801,33.14,0.43,42.4,41813,75,NULL,'MAT, I, raw','ESO 574- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99802,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99802,33.16,0.43,42.8,41813,75,NULL,'MAT, I, inv','ESO 574- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99803,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99803,33.33,0.43,46.3,41813,75,NULL,'MAT, I, cor','ESO 574- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99804,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99804,33.36,0.56,47,41813,NULL,NULL,NULL,'ESO 574- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99805,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99805,33.39,0.2,47.6,41813,74.4,NULL,NULL,'ESO 574- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99806,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99806,33.48,0.53,49.6,41813,NULL,NULL,'Malmquist cor.','ESO 574- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99807,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99807,33.65,0.49,53.7,41813,75,NULL,'IR','ESO 574- G 028',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99808,'Tully est','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99808,33.33,0.8,46.4,41814,75,NULL,'B','NGC 4650A',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.00001,NULL,'13.9',0.8,'(PR)','in a chain',NULL,NULL,NULL,1,191.204416667,-40.71431,0.501,NULL,46747356994,730427453,11412928,13.9),(99809,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99809,37.06,0.44,258,41815,NULL,NULL,'Malmquist cor.','2MASX J12445225-0025496',NULL,'2009ApJS..182..474S',2009,1,0.76,NULL,'G',0.000027,NULL,'16.2g',0.25,'BLAGN',NULL,NULL,NULL,'Sy 1',1,191.21775,-0.43047,0.053,NULL,43167925626,674498837,10539044,16.2),(99810,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99810,37.33,0.39,292,41815,NULL,NULL,NULL,'2MASX J12445225-0025496',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99811,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99811,37.37,0.2,298,41815,74.4,NULL,NULL,'2MASX J12445225-0025496',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99812,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99812,36.51,0.46,201,41816,70,NULL,NULL,'2MASX J12445250+3935530',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000186,NULL,'15.6g',0.47,NULL,NULL,NULL,NULL,NULL,1,191.2187917,39.59797,0,NULL,59082397201,923162456,14424413,15.6),(99813,'Tully est','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99813,31.92,0.8,24.2,41817,75,NULL,NULL,'UGCA 295',NULL,'1988NBGC.C....0000T',1988,1,2.5,NULL,'G',0.000007,NULL,'15.1',1.2,'SAB(s)m:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.2255417,-9.12514,0.077,NULL,43152155496,674252429,10535194,15.1),(99814,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99814,37.08,0.46,260,41818,70,NULL,NULL,'2MASX J12445530+4554171',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,191.23025,45.90481,0,NULL,59112990897,923640482,14431882,16.9),(99815,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99815,38.13,0.27,423,41819,70,NULL,NULL,'2MASX J12445546+0153541',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000086,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,191.2312917,1.89847,0,NULL,58218620021,909665937,14213530,16.9),(99816,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99816,36.27,0.46,179,41820,70,NULL,NULL,'2MASX J12445679+6605206',NULL,'2015arXiv151105856S',2015,1,0.58,'HOLM 456B is a star.','G',0.000173,NULL,'15.6g',0.45,'S0a',NULL,NULL,NULL,NULL,1,191.2365,66.08897,0.041,NULL,57319639999,895619374,13994052,15.6),(99817,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99817,36.01,0.53,159,41821,70,NULL,NULL,'CGCG 015-014',NULL,'2014MNRAS.445.2677S',2014,1,0.98,NULL,'G',0.000129,NULL,'14.6g',0.71,'SA(r)0-?;BrClG',NULL,NULL,NULL,NULL,1,191.239083,-0.04314,0,NULL,43167777425,674496522,10539008,14.6),(99818,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99818,36.32,0.46,184,41821,70,NULL,NULL,'CGCG 015-014',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99819,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99819,37.39,0.27,301,41822,70,NULL,NULL,'2MASX J12445745+0509031',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,191.2392917,5.15086,0,NULL,58222046326,909719473,14214366,17.7),(99820,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99820,37.39,0.27,301,41823,70,NULL,NULL,'2MASX J12445834+0509544',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000179,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,191.243125,5.16519,0,NULL,58222047027,909719484,14214366,17.4),(99821,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99821,36.14,0.46,169,41824,70,NULL,NULL,'2MASX J12445932+1628216',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.63',0.2,NULL,NULL,NULL,NULL,NULL,1,191.24725,16.47261,0.029,NULL,58879634743,919994292,14374910,16.63),(99822,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99822,36.38,0.46,189,41825,70,NULL,NULL,'2MASX J12445974+0713451',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000176,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,191.249041667,7.22903,0,NULL,58195489453,909304522,14207883,16.7),(99823,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 1999bm',NULL,99823,38.1,0.16,362,41826,74.2,NULL,'SALT 2','APMUKS(BJ) B124225.40-061107.2',0.15,'2010ApJ...716..712A',2010,1,0.12,NULL,'G',NULL,NULL,'19.38',0.11,NULL,NULL,NULL,NULL,NULL,1,191.252375,-6.45869,0.045,NULL,43156072291,674313629,10536150,19.38),(99824,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 1999bm',NULL,99824,39.05,0.06,561,41826,70,NULL,'SALT','APMUKS(BJ) B124225.40-061107.2',0.15,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99825,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 1999bm',NULL,99825,39.19,0.07,598,41826,65,NULL,'SALT','APMUKS(BJ) B124225.40-061107.2',0.15,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99826,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99826,37.39,0.27,301,41827,70,NULL,NULL,'SDSS J124501.03+050907.8',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'16.8g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,191.254291667,5.15219,0,NULL,58222046614,909719478,14214366,16.8),(99827,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99827,37.75,0.27,355,41828,70,NULL,NULL,'2MASX J12450247+0053424',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000068,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,191.26025,0.89506,0,NULL,58217337217,909645894,14213217,17.1),(99828,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99828,37.97,0.46,393,41829,70,NULL,NULL,'2MASX J12450450+4116039',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000151,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,191.268625,41.26772,0,NULL,59083491144,923179549,14424680,17.8),(99829,'IRAS','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99829,34.14,0.8,67.3,41830,75,NULL,'MAT, I','ESO 268- G 037',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000024,NULL,'14.27',1.1,'SAB(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.2717083,-44.00544,0.389,NULL,46774265014,730847890,11419498,14.27),(99830,'IRAS','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99830,34.17,0.8,68.1,41830,75,NULL,'HMCL, I','ESO 268- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99831,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99831,33.81,0.4,57.7,41830,75,NULL,'HMCL, I, raw','ESO 268- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99832,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99832,33.93,0.4,61,41830,75,NULL,'HMCL, I, cor','ESO 268- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99833,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99833,33.96,0.4,61.8,41830,75,NULL,'HMCL, I, inv','ESO 268- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99834,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99834,34,0.43,63.2,41830,75,NULL,'MAT, I, raw','ESO 268- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99835,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99835,34.01,0.32,63.3,41830,85,NULL,'I, raw','ESO 268- G 037',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99836,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99836,34.05,0.32,64.7,41830,85,NULL,'I, inv','ESO 268- G 037',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99837,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99837,34.15,0.43,67.5,41830,75,NULL,'MAT, I, cor','ESO 268- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99838,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99838,34.19,NULL,68.9,41830,NULL,NULL,'B','ESO 268- G 037',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99839,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99839,34.22,0.43,69.7,41830,75,NULL,'MAT, I, inv','ESO 268- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99840,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99840,34.26,0.46,71.1,41830,NULL,NULL,'Malmquist cor.','ESO 268- G 037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99841,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99841,34.35,NULL,74.1,41830,NULL,NULL,'I','ESO 268- G 037',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99842,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99842,34.5,0.41,79.5,41830,NULL,NULL,NULL,'ESO 268- G 037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99843,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99843,34.54,0.2,80.9,41830,74.4,NULL,NULL,'ESO 268- G 037',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99844,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99844,35.78,0.56,143,41831,70,NULL,NULL,'2MASX J12450534-4305226',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.3,NULL,NULL,NULL,NULL,NULL,1,191.272333,-43.08958,0.357,NULL,46773206441,730831350,11419239,13.9),(99845,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99845,37.07,0.98,259,41832,70,NULL,NULL,'2MFGC 10048',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'12.3K',NULL,NULL,NULL,NULL,NULL,NULL,1,191.273208333,-48.89703,0.681,NULL,46733759648,730214994,11409609,12.3),(99846,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99846,37.75,0.27,355,41833,70,NULL,NULL,'2MASX J12450567+0049554',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000094,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,191.2735,0.83217,0,NULL,58217339825,909645934,14213217,16.4),(99847,'Tully est','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99847,31.26,0.8,17.9,41834,75,NULL,'B','NGC 4665',NULL,'1988NBGC.C....0000T',1988,1,3.8,'z=0.002618 (1999PASP..111..438F)','G',0.000017,NULL,'10.5',3.2,'SB(s)0/a','in a radial-velocity based grouping',NULL,NULL,NULL,1,191.274958333,3.05578,0.059,NULL,58223292649,909738947,14214671,10.5),(99848,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99848,38.57,0.46,517,41835,70,NULL,NULL,'2MASX J12450717-0212467',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000097,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,191.279916667,-2.21314,0.005,NULL,43169941197,674530331,10539536,18),(99849,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99849,38.06,0.27,409,41836,70,NULL,NULL,'2MASX J12450733+1619337',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,'PHOT','18.58',0.13,NULL,NULL,NULL,NULL,NULL,1,191.280625,16.32603,0.029,NULL,58879571970,919993312,14374895,18.58),(99850,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99850,38.06,0.27,409,41837,70,NULL,NULL,'2MASX J12450830+1618087',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.41',0.15,NULL,NULL,NULL,NULL,NULL,1,191.2845417,16.30258,0.029,NULL,58879563865,919993185,14374893,18.41),(99851,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99851,37.31,0.46,290,41838,70,NULL,NULL,'2MASX J12450832+1717077',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,191.28475,17.28553,0.054,NULL,58875949061,919936704,14374011,17.9),(99852,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN ASASSN-14lp','R',99852,30.83,NULL,14.7,41839,NULL,NULL,NULL,'NGC 4666',NULL,'2015arXiv150704257S',2015,1,4.6,NULL,'G',0.000017,NULL,'11.49',1.3,'SABc:;HII      LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.2857917,-0.46189,0.053,NULL,43100773353,673449583,10522649,11.49),(99853,'IRAS','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99853,31.84,0.8,23.4,41839,75,NULL,'MAT, I','NGC 4666',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99854,'Tully est','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99854,30.75,0.8,14.1,41839,75,NULL,'B','NGC 4666',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99855,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99855,30.54,0.43,12.8,41839,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4666',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99856,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99856,30.78,0.43,14.3,41839,75,NULL,'3.6 micron, color corrected','NGC 4666',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99857,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99857,30.98,0.36,15.7,41839,NULL,NULL,NULL,'NGC 4666',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99858,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99858,31.13,0.32,16.8,41839,85,NULL,'I, raw','NGC 4666',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99859,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99859,31.13,0.2,16.8,41839,74.4,NULL,NULL,'NGC 4666',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99860,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99860,31.13,0.43,16.9,41839,75,NULL,'MAT, I, raw','NGC 4666',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99861,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99861,31.18,0.32,17.2,41839,85,NULL,'I, inv','NGC 4666',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99862,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99862,31.28,0.4,18.2,41839,NULL,NULL,NULL,'NGC 4666',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99863,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99863,31.38,0.42,18.8,41839,NULL,NULL,'Malmquist cor.','NGC 4666',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99864,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99864,31.37,0.43,18.8,41839,75,NULL,'MAT, I, inv','NGC 4666',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99865,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99865,31.37,0.43,18.8,41839,75,NULL,'MAT, I, cor','NGC 4666',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99866,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99866,31.42,0.49,19.3,41839,75,NULL,'IR','NGC 4666',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99867,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99867,31.42,0.41,19.3,41839,NULL,NULL,NULL,'NGC 4666',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99868,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 1991aa',NULL,99868,33.12,0.16,42,41840,68,NULL,NULL,'LCRS B124233.9-060233',NULL,'1996ApJ...465L..83R',1996,1,NULL,NULL,'G',0.0001,NULL,'14.30',NULL,'SB',NULL,NULL,NULL,NULL,1,191.2877917,-6.31581,0.033,NULL,43155369605,674302650,10535978,14.3),(99869,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99869,37.96,0.33,391,41841,70,NULL,NULL,'SDSS J124511.43+132820.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00015,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,191.297667,13.47231,0.043,NULL,58875050317,919922661,14373791,18.6),(99870,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99870,34.96,0.47,98.2,41842,NULL,NULL,'H','IC 0813',NULL,'2007A&A...465...71T',2007,1,1,'UGC incorrectly says IC 0813 = IC 3734.','G',0.000023,NULL,'14.4',0.8,'Sab            LINER',NULL,NULL,NULL,NULL,1,191.299333,23.03614,0.057,NULL,58889879192,920154362,14377411,14.4),(99871,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99871,35,0.45,100,41842,NULL,NULL,'K','IC 0813',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99872,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99872,35.05,0.46,102,41842,NULL,NULL,'J','IC 0813',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99873,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99873,35.15,0.4,107,41842,NULL,NULL,'mean','IC 0813',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99874,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99874,31.15,NULL,17,41843,NULL,NULL,NULL,'IC 3732',NULL,'2014A&A...562A..49M',2014,1,0.36,NULL,'G',0.000384,NULL,'16.2g',0.28,'BCD?','Group member',NULL,NULL,NULL,1,191.299833,10.32444,0,NULL,58186810961,909168921,14205764,16.2),(99875,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99875,38.27,0.46,450,41844,70,NULL,NULL,'2MASX J12451227+1836350',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.54',0.15,NULL,NULL,NULL,NULL,NULL,1,191.301167,18.60981,0.064,NULL,58905292699,920395198,14381174,18.54),(99876,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99876,37.75,0.27,355,41845,70,NULL,NULL,'SDSS J124512.37+004750.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000083,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,191.301583333,0.79728,0,NULL,58083325091,907551954,14180499,18.2),(99877,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99877,36.87,0.21,236,41846,70,NULL,NULL,'2MASX J12451288+0148174',NULL,'2015arXiv151105856S',2015,1,1.06,NULL,'G',0.00013,NULL,'14.8g',0.7,'BrClG',NULL,NULL,NULL,NULL,1,191.303625,1.80481,0,NULL,58218741868,909667841,14213560,14.8),(99878,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99878,38.13,0.27,423,41847,70,NULL,NULL,'2MASX J12451328+0152544',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000186,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,191.3054583,1.88169,0,NULL,58218625208,909666018,14213531,16.8),(99879,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99879,36.24,0.5,177,41848,70,NULL,NULL,'2MASX J12451360-1246335',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00013,NULL,'16.12',NULL,NULL,NULL,NULL,NULL,NULL,1,191.306708333,-12.77608,0.093,NULL,43923460636,686304072,10723501,16.12),(99880,'D-Sigma','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99880,32.93,0.4,38.6,41849,75,NULL,'Edat, raw','NGC 4650B',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.00015,NULL,'14.54',0.4,'E+: sp','in a chain',NULL,NULL,NULL,1,191.3122917,-40.82425,0.501,NULL,46747358266,730427472,11412929,14.54),(99881,'D-Sigma','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99881,32.95,0.4,38.9,41849,75,NULL,'Edat, cor','NGC 4650B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99882,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99882,33.99,0.23,62.8,41849,74.4,NULL,NULL,'NGC 4650B',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99883,'Tully est','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99883,33.33,0.8,46.4,41849,75,NULL,NULL,'NGC 4650B',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99884,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99884,37.99,0.46,396,41850,70,NULL,NULL,'2MASX J12451488+0126504',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000091,NULL,'17.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,191.312125,1.44733,0,NULL,58085081253,907579394,14180928,17.4),(99885,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99885,30.21,0.4,11,41851,75,NULL,'B','NGC 4670',NULL,'1988NBGC.C....0000T',1988,1,1.4,'Multiple SDSS entries describe this galaxy.','G',0.000013,NULL,'13.09',1.1,'SB(s)0/a pec:  BCDG','in a radial-velocity based grouping',NULL,NULL,NULL,1,191.321125,27.12542,0.043,NULL,58736177033,917752766,14339886,13.09),(99886,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99886,37.45,0.46,309,41852,70,NULL,NULL,'2MASX J12451753+2536367',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,191.322958333,25.61019,0.028,NULL,58722838234,917544347,14336630,17.6),(99887,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99887,37.52,0.46,320,41853,70,NULL,NULL,'2MASX J12451822+4640241',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,191.3257917,46.67322,0,NULL,59112752840,923636763,14431824,17.5),(99888,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99888,38.11,0.46,418,41854,70,NULL,NULL,'2MASX J12451887+6033444',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,191.328667,60.56225,0,NULL,57361497709,896273401,14004271,17.9),(99889,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99889,37.68,0.21,343,41855,70,NULL,NULL,'2MASX J12451929+3606511',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,191.3305417,36.11431,0.012,NULL,58566591046,915102985,14298484,17.5),(99890,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99890,36.67,0.46,216,41856,70,NULL,NULL,'2MASX J12451973+0028144',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000081,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,191.3322917,0.47064,0,NULL,58082879874,907544998,14180390,16.6),(99891,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99891,36.87,0.21,236,41857,70,NULL,NULL,'2MASX J12452015+0148394',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000176,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,191.334,1.81089,0,NULL,58085229549,907581711,14180964,17.4),(99892,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99892,30.74,0.26,14.1,41858,NULL,NULL,'TOM(g) = -7.2 mag','IC 3735',NULL,'2007ApJS..171..101J',2007,1,0.9,NULL,'G',0.000147,NULL,'14.84',0.5,'E?','Group member',NULL,NULL,NULL,1,191.335083,13.69267,0.008,NULL,58872966249,919890097,14373282,14.84),(99893,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99893,30.75,0.22,14.1,41858,NULL,NULL,'TOM(g) = -7.2 mag','IC 3735',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99894,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99894,31.01,0.24,15.9,41858,NULL,NULL,'TOM(u) = -8.4 mag','IC 3735',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99895,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99895,31.15,0.23,17,41858,NULL,NULL,'TOM(z) = -8.53 mag','IC 3735',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99896,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99896,31.15,0.14,17,41858,74.4,NULL,NULL,'IC 3735',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99897,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99897,31.16,0.07,17.1,41858,NULL,NULL,NULL,'IC 3735',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99898,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99898,31.17,0.08,17.2,41858,NULL,NULL,'HST ACS VCS','IC 3735',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99899,'GC radius','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99899,30.23,0.17,11.1,41858,NULL,NULL,NULL,'IC 3735',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99900,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99900,36.35,0.46,186,41859,70,NULL,NULL,'2MASX J12452078+1004174',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.07',0.18,NULL,NULL,NULL,NULL,NULL,1,191.3367917,10.07147,0,NULL,58186840616,909169384,14205771,18.07),(99901,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99901,36.06,0.74,163,41860,70,NULL,NULL,'LCRS B124245.3-114929',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00006,NULL,'14.74',NULL,NULL,NULL,NULL,NULL,NULL,1,191.340666667,-12.09789,0.089,NULL,43922840636,686294384,10723349,14.74),(99902,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99902,36.87,0.21,236,41861,70,NULL,NULL,'2MASX J12452175+0149504',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000097,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,191.3407083,1.83061,0,NULL,58085232054,907581750,14180964,16.8),(99903,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99903,37.96,0.33,391,41862,70,NULL,NULL,'2MASX J12452208+1328097',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000199,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,191.342,13.46936,0.063,NULL,58875041919,919922529,14373789,16.6),(99904,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99904,36.88,0.46,238,41863,70,NULL,NULL,'2MASX J12452290+2155239',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'18.67',NULL,NULL,NULL,NULL,NULL,NULL,1,191.345417,21.92325,0.115,NULL,58901948349,920342942,14380358,18.67),(99905,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99905,37.21,0.46,277,41864,70,NULL,NULL,'2MASX J12452378+1212457',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000177,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,191.349167,12.21272,0.047,NULL,58872122643,919876916,14373076,16.8),(99906,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99906,37.19,0.46,274,41865,70,NULL,NULL,'2MASX J12452631+1118324',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,191.3597083,11.30911,0.025,NULL,58183622429,909119100,14204985,17.6),(99907,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99907,36.99,0.33,249,41866,70,NULL,NULL,'2MASX J12452770+3926462',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000186,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,191.365458333,39.44619,0,NULL,59082364412,923161943,14424405,17.1),(99908,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99908,36.76,0.33,225,41867,70,NULL,NULL,'2MASX J12452890+5936511',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000196,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,191.370167,59.61428,0,NULL,57404127513,896939492,14014679,16.7),(99909,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99909,37.97,0.46,393,41868,70,NULL,NULL,'SDSS J124529.71+124032.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000146,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,191.373791667,12.67575,0.039,NULL,58871597254,919868707,14372948,18.7),(99910,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99910,36.6,0.46,209,41869,70,NULL,NULL,'2MASX J12453051+4050462',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00017,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,191.377167,40.84619,0,NULL,59083911470,923186116,14424783,16.5),(99911,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99911,36.99,0.33,249,41870,70,NULL,NULL,'2MASX J12453054+3927042',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000177,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,191.377333,39.45108,0,NULL,59082364260,923161941,14424405,16.5),(99912,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99912,38.14,0.46,424,41871,70,NULL,NULL,'2MASX J12453135+5640461',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,191.3807917,56.67936,0,NULL,57431431628,897366119,14021345,17.8),(99913,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 1997Y',NULL,99913,33.61,0.25,51.9,41872,74.2,NULL,'SALT 2','NGC 4675',0.01587,'2010ApJ...716..712A',2010,1,1.56,NULL,'G',0.000124,NULL,'14.5g',0.49,'SBb:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.382875,54.73761,0,NULL,57420248361,897191380,14018615,14.5),(99914,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 1997Y',NULL,99914,34.15,0.19,66.6,41872,72,NULL,NULL,'NGC 4675',0.01587,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99915,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 1997Y',NULL,99915,34.19,0.08,68.9,41872,74.4,NULL,NULL,'NGC 4675',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99916,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 1997Y',NULL,99916,34.27,0.2,70.3,41872,70,NULL,'SALT 2','NGC 4675',0.01587,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99917,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 1997Y',NULL,99917,34.25,0.17,70.8,41872,70.8,NULL,NULL,'NGC 4675',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99918,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 1997Y',NULL,99918,34.3,0.19,71.3,41872,73.8,NULL,'SALT 2 (SNANA)','NGC 4675',0.0169,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99919,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 1997Y',NULL,99919,34.3,0.05,71.4,41872,72,NULL,NULL,'NGC 4675',0.01587,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99920,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 1997Y',NULL,99920,34.38,0.29,74,41872,70,NULL,'SALT','NGC 4675',0.01587,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99921,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 1997Y',NULL,99921,34.45,0.14,76.4,41872,70,NULL,NULL,'NGC 4675',0.01587,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99922,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 1997Y',NULL,99922,34.5,0.21,78.3,41872,65,NULL,'MLCS31','NGC 4675',0.01587,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99923,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 1997Y',NULL,99923,34.51,0.24,78.6,41872,65,NULL,'SALT2','NGC 4675',0.01587,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99924,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 1997Y',NULL,99924,34.52,0.32,79,41872,65,NULL,'SALT','NGC 4675',0.01587,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99925,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 1997Y',NULL,99925,34.56,0.1,79.2,41872,65,NULL,'MLCS2k2','NGC 4675',0.01587,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99926,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 1997Y',NULL,99926,34.53,0.11,79.3,41872,65,NULL,'MLCS2k2','NGC 4675',0.01587,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99927,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 1997Y',NULL,99927,34.54,0.23,79.7,41872,65,NULL,NULL,'NGC 4675',0.01587,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99928,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 1997Y',NULL,99928,34.55,0.21,80,41872,65,NULL,'MLCS17','NGC 4675',0.01587,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99929,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 1997Y',NULL,99929,34.6,0.14,83.2,41872,60,NULL,NULL,'NGC 4675',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99930,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 1997Y',NULL,99930,34.64,0.03,83.2,41872,65,NULL,'SALT','NGC 4675',0.01587,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99931,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99931,34.44,0.4,77.3,41872,NULL,NULL,'mean','NGC 4675',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99932,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99932,34.48,0.47,78.8,41872,NULL,NULL,'H','NGC 4675',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99933,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99933,34.54,0.45,81,41872,NULL,NULL,'K','NGC 4675',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99934,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99934,34.59,0.49,82.7,41872,75,NULL,'IR','NGC 4675',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99935,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99935,34.64,0.46,84.5,41872,NULL,NULL,'J','NGC 4675',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99936,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99936,30.78,0.4,14.3,41873,NULL,NULL,NULL,'NGC 4668',NULL,'2009AJ....138..323T',2009,1,1.52,'The 2MASX position is 6.2 arcsec north of the nucleus.','G',0.000023,NULL,'13.5g',0.77,'SB(s)d:        NLAGN','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.383291667,-0.53572,0.047,NULL,43100793218,673449894,10522654,13.5),(99937,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99937,31.03,0.43,16.1,41873,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4668',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99938,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99938,31.07,0.4,16.4,41873,NULL,NULL,NULL,'NGC 4668',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99939,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99939,31.13,0.2,16.8,41873,74.4,NULL,NULL,'NGC 4668',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99940,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99940,31.14,0.43,16.9,41873,75,NULL,'3.6 micron, color corrected','NGC 4668',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99941,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99941,31.18,0.44,17.2,41873,NULL,NULL,NULL,'NGC 4668',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99942,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99942,31.26,0.43,17.8,41873,NULL,NULL,'Malmquist cor.','NGC 4668',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99943,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99943,31.64,0.2,21.3,41874,74.4,NULL,NULL,'IC 3742',NULL,'2013AJ....146...86T',2013,1,1.96,'The 2MASX position applies to a knot north of the center.','G',0.000013,NULL,'14.2g',0.66,'SBc(s)         HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.383416667,13.33258,0.063,NULL,58875158281,919924348,14373817,14.2),(99944,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99944,31.68,0.43,21.6,41874,75,NULL,'3.6 micron, color + selection bias corrected','IC 3742',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99945,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99945,31.68,0.43,21.7,41874,75,NULL,'3.6 micron, color corrected','IC 3742',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99946,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99946,31.86,0.36,23.6,41874,NULL,NULL,NULL,'IC 3742',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99947,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99947,32.25,NULL,28.2,41874,NULL,NULL,NULL,'IC 3742',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99948,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99948,37.65,0.27,339,41875,70,NULL,NULL,'2MASXi J1245324+321539',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000139,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,191.385375,32.26094,0,NULL,58749729612,917964525,14343195,17.7),(99949,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99949,38.4,0.46,479,41876,70,NULL,NULL,'SDSS J124532.91+061124.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000138,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,191.387125,6.19017,0,NULL,58192009454,909250147,14207033,18.4),(99950,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99950,37.52,0.33,320,41877,70,NULL,NULL,'2MASX J12453387+3153587',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,191.3909583,31.89975,0.045,NULL,58747755272,917933676,14342713,17.3),(99951,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99951,35.63,0.54,134,41878,70,NULL,NULL,'IC 0814',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000097,NULL,'15.84',NULL,NULL,NULL,NULL,NULL,NULL,1,191.39225,-8.09219,0.049,NULL,43157414385,674334599,10536478,15.84),(99952,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99952,37.25,0.46,281,41879,70,NULL,NULL,'2MASX J12453463+4105582',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000178,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,191.394333,41.09958,0,NULL,59084077158,923188705,14424823,17.1),(99953,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99953,34.07,0.25,65.2,41880,74.4,NULL,NULL,'NGC 4673',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000019,NULL,'13.87',0.9,'E1-2           RET','in a pair',NULL,NULL,NULL,1,191.394458333,27.06083,0.022,NULL,58736144831,917752262,14339879,13.87),(99954,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99954,37.04,0.46,256,41881,70,NULL,NULL,'2MASX J12453475+0444358',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00016,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,191.394833,4.74322,0,NULL,58221757701,909714964,14214296,16.8),(99955,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99955,37.74,0.27,353,41882,70,NULL,NULL,'2MASX J12453497+2823396',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,191.395625,28.3945,0.077,NULL,58733480263,917710629,14339228,16.5),(99956,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99956,37.95,0.46,389,41883,70,NULL,NULL,'2MASX J12453631+2447066',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,191.40125,24.78503,0.016,NULL,58606657898,915729029,14308266,17.3),(99957,'Tully est','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99957,31.52,0.8,20.1,41884,75,NULL,'B','UGCA 296',NULL,'1988NBGC.C....0000T',1988,1,0.3,NULL,'G',0.000367,NULL,'15.7',0.3,'Compact',NULL,NULL,NULL,NULL,1,191.401667,71.31869,0.029,NULL,56983692796,890370199,13912034,15.7),(99958,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99958,37.52,0.33,320,41885,70,NULL,NULL,'2MASX J12453661+3156067',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000179,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,191.4025,31.93522,0.045,NULL,58747754181,917933659,14342713,16.9),(99959,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99959,37.36,0.33,297,41886,70,NULL,NULL,'2MASX J12453732+0043288',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000069,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,191.4055,0.72453,0,NULL,58083319102,907551860,14180497,17.4),(99960,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99960,37.86,0.46,373,41887,70,NULL,NULL,'2MASX J12453801+1831269',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,191.408333,18.52414,0.048,NULL,58905250886,920394545,14381164,17.2),(99961,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 2006S',NULL,99961,35.2,0.16,106,41888,74.2,NULL,'SALT 2','UGC 07934',0.032102,'2010ApJ...716..712A',2010,1,0.55,NULL,'G',0.000093,NULL,'15.5g',0.46,'S',NULL,NULL,NULL,NULL,1,191.4110417,35.08375,NULL,NULL,58554585939,914915405,14295553,15.5),(99962,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 2006S',NULL,99962,35.76,0.09,142,41888,74.4,NULL,NULL,'UGC 07934',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99963,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 2006S',NULL,99963,35.92,0.15,147,41888,73.8,NULL,'SALT 2 (SNANA)','UGC 07934',0.0333,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99964,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 2006S',NULL,99964,35.94,0.04,149,41888,72,NULL,'SALT','UGC 07934',0.032102,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99965,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 2006S',NULL,99965,35.94,0.15,149,41888,70,NULL,'SALT 2','UGC 07934',0.032102,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99966,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 2006S','R',99966,35.87,0.07,149,41888,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 07934',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99967,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 2006S','R',99967,35.9,0.05,151,41888,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 07934',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99968,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 2006S',NULL,99968,36.04,0.17,156,41888,65,NULL,'SALT','UGC 07934',0.032102,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99969,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 2006S',NULL,99969,36.05,0.14,157,41888,65,NULL,'MLCS17','UGC 07934',0.032102,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99970,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 2006S',NULL,99970,36.06,0.18,158,41888,65,NULL,'SALT2','UGC 07934',0.032102,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99971,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 2006S',NULL,99971,36.13,0.15,163,41888,65,NULL,'MLCS31','UGC 07934',0.032102,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99972,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 2006S',NULL,99972,36.18,0.02,167,41888,70,NULL,'SALT 2','UGC 07934',0.032102,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99973,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99973,37.38,0.46,300,41889,70,NULL,NULL,'2MASX J12453935+4338016',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,191.4140417,43.63375,0,NULL,59120446048,923756969,14433702,17.7),(99974,'Tully est','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99974,32.06,0.8,25.8,41890,75,NULL,NULL,'DDO 146',NULL,'1988NBGC.C....0000T',1988,1,3.4,'APMUKS(BJ) B124304.79-054810.1 is a chain of knots in the galaxy.','G',0.000003,NULL,'12.9B',2.5,'SAB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.422375,-6.06883,0.033,NULL,43155229515,674300461,10535944,12.9),(99975,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99975,30.92,0.4,15.3,41890,NULL,NULL,NULL,'DDO 146',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99976,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99976,31.13,0.43,16.8,41890,75,NULL,'3.6 micron, color + selection bias corrected','DDO 146',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99977,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99977,38.51,0.46,502,41891,70,NULL,NULL,'2MASX J12454141+5657262',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,191.422666667,56.95739,0,NULL,57430623448,897353491,14021148,18),(99978,'IRAS','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99978,34.3,0.8,72.4,41892,75,NULL,'MAT, I','ESO 507- G 007',NULL,'1997ApJS..109..333W',1997,1,3.58,NULL,'G',0.000024,NULL,'14.36',0.45,'Sbc: sp',NULL,NULL,NULL,NULL,1,191.426,-26.24375,0.321,NULL,43420946290,678452285,10600816,14.36),(99979,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99979,34.04,0.46,64.3,41892,NULL,NULL,'J','ESO 507- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99980,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99980,34.06,0.43,64.9,41892,75,NULL,'MAT, I, raw','ESO 507- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99981,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99981,34.09,0.49,65.9,41892,75,NULL,'IR','ESO 507- G 007',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99982,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99982,34.14,0.47,67.3,41892,NULL,NULL,'H','ESO 507- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99983,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99983,34.24,0.45,70.6,41892,NULL,NULL,'K','ESO 507- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99984,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99984,34.25,NULL,71,41892,NULL,NULL,NULL,'ESO 507- G 007',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99985,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99985,34.35,0.46,74.1,41892,NULL,NULL,'Malmquist cor.','ESO 507- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99986,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99986,34.38,0.4,75.3,41892,NULL,NULL,'mean','ESO 507- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99987,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99987,34.38,0.43,75.3,41892,75,NULL,'MAT, I, cor','ESO 507- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99988,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99988,34.41,0.43,76.1,41892,75,NULL,'MAT, I, inv','ESO 507- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99989,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99989,34.41,0.32,76.2,41892,85,NULL,'I, raw','ESO 507- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99990,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99990,34.44,NULL,77.2,41892,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 507- G 007',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99991,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99991,34.46,NULL,78.1,41892,NULL,NULL,'Dipole + Quadrupole','ESO 507- G 007',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99992,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99992,34.47,NULL,78.3,41892,NULL,NULL,'Dipole','ESO 507- G 007',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99993,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99993,34.5,0.32,79.3,41892,85,NULL,'I, inv','ESO 507- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99994,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99994,34.5,0.2,79.4,41892,74.4,NULL,NULL,'ESO 507- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99995,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,99995,34.56,0.42,81.6,41892,NULL,NULL,NULL,'ESO 507- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99996,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99996,37.71,0.46,349,41893,70,NULL,NULL,'2MASX J12454238+3944252',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,191.426667,39.74044,0,NULL,59082376923,923162139,14424408,18.2),(99997,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99997,37.74,0.27,353,41894,70,NULL,NULL,'SDSS J124543.03+282608.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'19.57',0.13,NULL,NULL,NULL,NULL,NULL,1,191.429333,28.43575,0.077,NULL,58733493161,917710830,14339231,19.57),(99998,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99998,37.61,0.46,333,41895,70,NULL,NULL,'2MASX J12454383+3004547',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,191.432667,30.08194,0.009,NULL,58781860495,918466570,14351040,17.7),(99999,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',99999,37.44,0.15,307,41896,70,NULL,NULL,'2MASX J12454514+1727391',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.01',0.17,NULL,NULL,NULL,NULL,NULL,1,191.438167,17.46089,0.056,NULL,58875890295,919935785,14373996,17.01),(100000,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100000,38.34,0.46,466,41897,70,NULL,NULL,'2MASX J12454593+4735547',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000189,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,191.441375,47.59861,0,NULL,59112687485,923635741,14431808,16.8),(100001,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100001,38.14,0.21,425,41898,70,NULL,NULL,'2MASX J12454622+2625405',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,191.44275,26.42797,0.036,NULL,58723114381,917548662,14336697,17.5),(100002,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100002,37.39,0.46,301,41899,70,NULL,NULL,'2MASX J12454695+4025092',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,191.445667,40.41919,0,NULL,59084216823,923190887,14424857,17.4),(100003,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100003,38.34,0.46,466,41900,70,NULL,NULL,'2MASX J12454877+2949135',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,191.4532917,29.82047,0.049,NULL,58781431685,918459870,14350935,18.4),(100004,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100004,36.6,0.46,209,41901,70,NULL,NULL,'2MASX J12454881+2718315',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000127,NULL,'17.66',0.17,NULL,NULL,NULL,NULL,NULL,1,191.4535,27.30872,0.043,NULL,58736856959,917763389,14340052,17.66),(100005,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100005,38.12,0.46,421,41902,70,NULL,NULL,'2MASX J12454901+5400362',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000141,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,191.45425,54.01,0.047,NULL,57198744133,893730377,13964537,17.8),(100006,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100006,37.65,0.27,339,41903,70,NULL,NULL,'2MASX J12454902+3215018',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000097,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,191.454375,32.2505,0,NULL,58749721889,917964404,14343193,16.8),(100007,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100007,37.48,0.46,313,41904,70,NULL,NULL,'KUG 1243+413',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000189,NULL,'16.8g',0.28,'Spiral',NULL,NULL,NULL,NULL,1,191.456,41.04822,0,NULL,59084067534,923188555,14424821,16.8),(100008,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100008,37.44,0.15,307,41905,70,NULL,NULL,'2MASX J12455029+1711171',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,191.459667,17.18814,0.054,NULL,58875796478,919934319,14373973,17.2),(100009,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100009,37.65,0.27,339,41906,70,NULL,NULL,'SDSS J124551.19+321159.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000128,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,191.463333,32.19983,0,NULL,58747677754,917932464,14342694,18.7),(100010,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100010,37.44,0.15,307,41907,70,NULL,NULL,'2MASX J12455148+1715131',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.41',0.27,NULL,NULL,NULL,NULL,NULL,1,191.4645417,17.25361,0.054,NULL,58875917640,919936213,14374003,17.41),(100011,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100011,38.09,0.46,415,41908,70,NULL,NULL,'LCRS B124317.1-023545',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000105,NULL,'16.8g',0.35,NULL,NULL,NULL,NULL,NULL,1,191.4647917,-2.86914,0.021,NULL,43106968764,673546386,10524162,16.8),(100012,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100012,38.66,0.46,539,41909,70,NULL,NULL,'SDSS J124552.29+615227.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00016,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,191.467875,61.87422,0.021,NULL,57365051125,896328923,14005139,18.6),(100013,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100013,36.1,0.46,166,41910,70,NULL,NULL,'CGCG 015-017',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000077,NULL,'15.1g',0.54,'SA0-',NULL,NULL,NULL,NULL,1,191.468041667,-1.68025,0.021,NULL,43102481472,673476273,10523066,15.1),(100014,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100014,36.25,0.5,178,41910,70,NULL,NULL,'CGCG 015-017',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100015,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100015,37.95,0.46,388,41911,70,NULL,NULL,'2MASX J12455304+6730556',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000067,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,191.471166667,67.51547,0.013,NULL,57854884945,903982577,14124727,18.1),(100016,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100016,37.16,0.46,270,41912,70,NULL,NULL,'2MASX J12455386+4204476',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000215,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,191.474417,42.08,0,NULL,59115747771,923683558,14432555,17.5),(100017,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100017,36.43,0.85,194,41913,70,NULL,NULL,'ESO 442- G 019',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'16.31',0.2,'S0-a',NULL,NULL,NULL,NULL,1,191.478083,-32.768,0.317,NULL,43466617892,679165904,10611967,16.31),(100018,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100018,34.72,0.58,87.8,41914,70,NULL,NULL,'ESO 574- G 030',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000097,NULL,'15.23',0.6,'(R)SB(s)0+',NULL,NULL,NULL,NULL,1,191.478333,-21.19572,0.113,NULL,43921010347,686265786,10722902,15.23),(100019,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100019,37.42,0.33,304,41915,70,NULL,NULL,'2MASX J12455550+4233426',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000188,NULL,'16.1g',0.4,'E0',NULL,NULL,NULL,NULL,1,191.4812083,42.56197,0,NULL,59116498296,923695285,14432738,16.1),(100020,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100020,36.87,0.21,236,41916,70,NULL,NULL,'2MASX J12455673+0147599',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000105,NULL,'15.8g',0.44,'S0^-',NULL,NULL,NULL,NULL,1,191.4864583,1.79997,0,NULL,58085232658,907581760,14180965,15.8),(100021,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100021,37.27,0.46,285,41917,70,NULL,NULL,'2MASXi J1245571-015816',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00008,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,191.48825,-1.9715,0.021,NULL,43102310510,673473601,10523025,17.1),(100022,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100022,37.42,0.33,304,41918,70,NULL,NULL,'2MASX J12455813+4234506',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000179,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,191.492,42.58064,0,NULL,59116498790,923695293,14432738,17.2),(100023,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100023,34.85,0.52,93.5,41919,70,NULL,NULL,'2MASX J12455900-0727096',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00011,NULL,'15.02',0.8,NULL,NULL,NULL,NULL,NULL,1,191.495833,-7.45286,0.025,NULL,43157600585,674337509,10536523,15.02),(100024,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100024,37.44,0.15,307,41920,70,NULL,NULL,'2MASX J12460005+1721099',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,191.500167,17.35281,0.054,NULL,58875887112,919935736,14373995,NULL),(100025,'TRGB','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100025,28.61,0.1,5.27,41921,NULL,NULL,NULL,'ESO 381- G 020',NULL,'2012A&A...540A..49M',2012,1,3,NULL,'G',0.000007,NULL,'14.21',1.2,'IB(s)m',NULL,NULL,NULL,NULL,1,191.5027917,-33.83694,0.257,NULL,43467366412,679177600,10612150,14.21),(100026,'TRGB','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100026,28.66,0.05,5.4,41921,NULL,NULL,'I','ESO 381- G 020',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100027,'TRGB','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100027,28.68,NULL,5.45,41921,NULL,NULL,NULL,'ESO 381- G 020',NULL,'2007AJ....133..504K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100028,'TRGB','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100028,28.69,0.1,5.47,41921,74.4,NULL,NULL,'ESO 381- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100029,'Tully est','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100029,28.53,0.8,5.1,41921,75,NULL,NULL,'ESO 381- G 020',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100030,'IRAS','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100030,32.8,0.8,36.3,41922,75,NULL,'A82, H','UGC 07941',NULL,'1997ApJS..109..333W',1997,1,2.27,NULL,'G',0.000013,NULL,'14.7g',0.5,'Sd:','Isolated galaxy',NULL,NULL,NULL,1,191.503583,64.56933,0.009,NULL,57369332633,896395822,14006184,14.7),(100031,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100031,32.79,0.4,36.1,41922,NULL,NULL,'Virgo cluster at 15.6 Mpc','UGC 07941',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100032,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100032,32.79,0.4,36.2,41922,75,NULL,'B','UGC 07941',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100033,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100033,33.13,0.2,42.3,41922,74.4,NULL,NULL,'UGC 07941',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100034,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100034,33.13,0.38,42.3,41922,NULL,NULL,NULL,'UGC 07941',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100035,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100035,33.47,0.43,49.5,41922,75,NULL,'3.6 micron, color corrected','UGC 07941',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100036,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100036,33.5,0.47,50.2,41922,75,NULL,'A82, H, inv','UGC 07941',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100037,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100037,33.52,0.47,50.5,41922,75,NULL,'A82, H, cor','UGC 07941',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100038,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100038,33.54,0.47,51.1,41922,75,NULL,'A82, H, raw','UGC 07941',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100039,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100039,33.87,0.43,59.4,41922,75,NULL,'3.6 micron, color + selection bias corrected','UGC 07941',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100040,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100040,36.59,0.46,208,41923,70,NULL,NULL,'2MASX J12460139-0104239',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000065,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,191.50575,-1.07319,0.029,NULL,43101167909,673455748,10522746,16.9),(100041,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100041,37.63,0.46,335,41924,70,NULL,NULL,'2MASX J12460146+1021471',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.32',0.17,NULL,NULL,NULL,NULL,NULL,1,191.50625,10.36297,0,NULL,58183930291,909123910,14205061,18.32),(100042,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100042,37.89,0.46,379,41925,70,NULL,NULL,'SDSS J124602.85+064102.0',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000181,NULL,'17.8g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,191.511917,6.68392,0,NULL,58070768019,907355750,14177433,17.8),(100043,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100043,37.68,0.21,343,41926,70,NULL,NULL,'2MASX J12460396+3602119',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000179,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,191.516375,36.03664,0.017,NULL,58555341328,914927208,14295737,17.3),(100044,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100044,29.96,NULL,9.82,41927,NULL,NULL,NULL,'VCC 2033',NULL,'2013AJ....145..101K',2013,1,0.4,NULL,'G',0.00001,NULL,'15.60',0.4,'BCD            HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.518583,8.47636,0,NULL,58192877168,909263705,14207245,15.6),(100045,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100045,37.75,0.46,355,41928,70,NULL,NULL,'SDSS J124605.09+065742.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000138,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,191.52125,6.96175,0,NULL,58192073282,909251145,14207049,18.4),(100046,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100046,36.76,0.33,225,41929,70,NULL,NULL,'MCG +10-18-082',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00018,NULL,'15.7g',0.46,'E0',NULL,NULL,NULL,NULL,1,191.529167,59.6145,0,NULL,57404123642,896939431,14014678,15.7),(100047,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100047,38.28,0.46,453,41930,70,NULL,NULL,'2MASX J12460768+6045075',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,191.5322083,60.75222,0,NULL,57362173852,896283966,14004436,18),(100048,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100048,37.55,0.46,324,41931,70,NULL,NULL,'2MASX J12460871+2226075',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,191.536333,22.43547,0.105,NULL,58891215168,920175237,14377738,17.4),(100049,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100049,37.68,0.21,343,41932,70,NULL,NULL,'2MASX J12460874+3604309',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000198,NULL,'15.9g',0.5,'BrClG',NULL,NULL,NULL,NULL,1,191.536417,36.07522,0.017,NULL,58555347224,914927300,14295739,15.9),(100050,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100050,33.47,0.45,49.4,41933,NULL,NULL,'I','2MASX J12460896-4103394',NULL,'2003A&A...410..445M',2003,1,0.4,NULL,'G',0.000183,NULL,'16.30',0.4,'S',NULL,NULL,NULL,NULL,1,191.537125,-41.06103,0.489,NULL,46747602724,730431292,11412988,16.3),(100051,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100051,37.36,0.33,297,41934,70,NULL,NULL,'2MASX J12460941+0042219',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000072,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,191.539167,0.70617,0,NULL,58083612883,907556451,14180569,17),(100052,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100052,38.07,0.46,411,41935,70,NULL,NULL,'SDSS J124609.93+132551.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,191.541375,13.43106,0.063,NULL,58873039252,919891238,14373300,18.2),(100053,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100053,37.08,0.27,261,41936,70,NULL,NULL,'2MASX J12461025+5206501',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000191,NULL,'15.8g',0.49,'E0',NULL,NULL,NULL,NULL,1,191.542833,52.11397,0,NULL,57207018348,893859661,13966557,15.8),(100054,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100054,37.62,0.46,335,41937,70,NULL,NULL,'2MASX J12461096+2314135',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,191.5457083,23.23717,0.09,NULL,58891812647,920184572,14377883,16.9),(100055,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100055,37.73,0.46,352,41938,70,NULL,NULL,'2MASX J12461226+5040231',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,191.551333,50.67319,0,NULL,57205228492,893831695,13966120,18.3),(100056,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100056,37.44,0.15,307,41939,70,NULL,NULL,'2MASX J12461352+1710129',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000153,NULL,'15.7g',0.55,NULL,NULL,NULL,NULL,NULL,1,191.556583,17.17025,0.054,NULL,58875792859,919934263,14373972,15.7),(100057,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100057,29.35,NULL,7.41,41940,NULL,NULL,NULL,'VCC 2037',NULL,'2013AJ....145..101K',2013,1,1.3,NULL,'G',0.000005,NULL,'15.8',0.6,'Im/BCD','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.56375,10.20556,0,NULL,58183921672,909123776,14205059,15.8),(100058,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100058,34.75,0.25,89.2,41941,NULL,NULL,NULL,'IC 3754',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.00001,NULL,'14.60',0.6,'Sab','Group member',NULL,NULL,NULL,1,191.56475,8.34844,0,NULL,58192861353,909263458,14207241,14.6),(100059,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100059,34.88,0.24,94.5,41941,NULL,NULL,'Malmquist cor.','IC 3754',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100060,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100060,35.01,0.2,100,41941,74.4,NULL,NULL,'IC 3754',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100061,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100061,35.02,0.47,101,41941,NULL,NULL,'H','IC 3754',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100062,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100062,35.08,0.4,104,41941,NULL,NULL,'mean','IC 3754',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100063,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100063,35.14,0.46,107,41941,NULL,NULL,'J','IC 3754',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100064,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100064,35.16,0.45,108,41941,NULL,NULL,'K','IC 3754',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100065,'IRAS','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100065,33.15,0.8,42.7,41942,75,NULL,'HMCL, I','NGC 4672',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.00002,NULL,'14.09',0.6,'SA(s)a pec sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.565625,-41.70597,0.485,NULL,46746710578,730417352,11412771,14.09),(100066,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100066,33.31,0.4,46,41942,NULL,NULL,'mean','NGC 4672',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100067,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100067,33.37,0.45,47.2,41942,NULL,NULL,'K','NGC 4672',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100068,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100068,33.39,0.47,47.7,41942,NULL,NULL,'H','NGC 4672',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100069,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100069,33.5,0.46,50.1,41942,NULL,NULL,'J','NGC 4672',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100070,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100070,33.62,0.43,53,41942,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4672',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100071,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100071,33.75,0.43,56.2,41942,75,NULL,'3.6 micron, color corrected','NGC 4672',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100072,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100072,33.78,0.38,57,41942,NULL,NULL,NULL,'NGC 4672',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100073,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100073,33.81,0.4,57.8,41942,75,NULL,'HMCL, I, raw','NGC 4672',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100074,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100074,33.91,0.2,60.5,41942,74.4,NULL,NULL,'NGC 4672',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100075,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100075,33.91,0.4,60.6,41942,75,NULL,'HMCL, I, cor','NGC 4672',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100076,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100076,34.02,0.4,63.6,41942,75,NULL,'HMCL, I, inv','NGC 4672',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100077,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100077,37.54,0.33,322,41943,70,NULL,NULL,'2MASX J12461579+0502329',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.85',0.14,NULL,NULL,NULL,NULL,NULL,1,191.565875,5.04233,0,NULL,58091184095,907674751,14182417,18.85),(100078,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100078,38.62,0.46,530,41944,70,NULL,NULL,'2MASX J12461700+2954403',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,191.570833,29.91133,0.037,NULL,58781463415,918460365,14350943,18.1),(100079,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100079,37.91,0.46,382,41945,70,NULL,NULL,'SDSS J124617.08-014221.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000074,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,191.571167,-1.70592,0.021,NULL,43102491698,673476432,10523069,18.2),(100080,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100080,38.33,0.46,463,41946,70,NULL,NULL,'2MASX J12461714+3739109',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,191.57125,37.653,0,NULL,58567204747,915112574,14298633,18.5),(100081,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100081,37.54,0.33,322,41947,70,NULL,NULL,'2MASX J12461760+0502229',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,191.573333,5.03978,0,NULL,58091183883,907674748,14182417,17.8),(100082,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100082,37.7,0.46,347,41948,70,NULL,NULL,'2MASX J12461812+1536569',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,191.575417,15.61581,0.011,NULL,58878569429,919977647,14374650,17.4),(100083,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100083,37.74,0.27,353,41949,70,NULL,NULL,'2MASX J12462003+2825103',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.91',0.17,NULL,NULL,NULL,NULL,NULL,1,191.583375,28.41961,0.049,NULL,58733462675,917710354,14339224,18.91),(100084,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100084,37.08,0.27,261,41950,70,NULL,NULL,'SDSS J124620.06+520303.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000167,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,191.583625,52.05103,0,NULL,57207010223,893859534,13966555,18.1),(100085,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100085,38.14,0.21,425,41951,70,NULL,NULL,'SDSS J124621.11+262358.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'19.94',0.13,NULL,NULL,NULL,NULL,NULL,1,191.5879583,26.39944,0.036,NULL,58723115618,917548681,14336698,19.94),(100086,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100086,37.6,0.46,332,41952,70,NULL,NULL,'2MASX J12462137+3924109',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000148,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,191.5890417,39.40308,0,NULL,59082479584,923163743,14424433,17.4),(100087,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100087,36.14,0.27,169,41953,70,NULL,NULL,'IC 0815',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000193,NULL,'14.8g',0.69,'E1',NULL,NULL,NULL,NULL,1,191.5944583,11.87661,0.054,NULL,58871491781,919867059,14372922,14.8),(100088,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100088,37.97,0.33,392,41954,70,NULL,NULL,'2MASX J12462294-0030549',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000082,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,191.595625,-0.51542,0.047,NULL,43101629766,673462965,10522858,17.5),(100089,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100089,37.23,0.46,280,41955,70,NULL,NULL,'2MASX J12462295+1526079',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00018,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,191.595625,15.43558,0.033,NULL,58878418694,919975292,14374613,16.9),(100090,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100090,38.14,0.21,425,41956,70,NULL,NULL,'2MASX J12462311+2626023',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,191.5962917,26.43383,0.036,NULL,58722898678,917545291,14336645,17.1),(100091,'Tully est','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100091,31.72,0.8,22.1,41957,75,NULL,NULL,'UGCA 297',NULL,'1988NBGC.C....0000T',1988,1,0.83,NULL,'G',0.000012,NULL,'15.5g',0.39,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.59725,48.23519,0,NULL,59097432921,923397389,14428084,15.5),(100092,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100092,37.52,0.46,319,41958,70,NULL,NULL,'2MASX J12462337+0709537',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000172,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,191.597417,7.16506,0.01,NULL,58073548864,907399201,14178112,16.8),(100093,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100093,37.8,0.46,362,41959,70,NULL,NULL,'2MASX J12462363+0822247',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00018,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,191.598417,8.37344,0,NULL,58072264323,907379130,14177798,16.8),(100094,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100094,36.41,0.51,191,41960,70,NULL,NULL,'2MASX J12462385-1228398',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'14.7R',0.35,NULL,NULL,NULL,NULL,NULL,1,191.599417,-12.47778,0.081,NULL,43923369390,686302646,10723478,14.7),(100095,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100095,37.75,0.46,355,41961,70,NULL,NULL,'2MASX J12462422+3629029',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000163,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,191.601,36.48414,0.015,NULL,58553799206,914903112,14295361,17.2),(100096,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100096,37.74,0.46,353,41962,70,NULL,NULL,'SDSS J124624.67+272934.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'19.84',0.15,NULL,NULL,NULL,NULL,NULL,1,191.602833,27.49281,0.05,NULL,58736925872,917764466,14340069,19.84),(100097,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 2004gu',NULL,100097,36.28,0.23,164,41963,72,NULL,NULL,'FGC 175A',0.04693,'2013ApJ...773...53F',2013,1,0.68,NULL,'G',0.000195,NULL,'17.5g',0.1,'S',NULL,NULL,NULL,NULL,1,191.603417,11.94956,0.054,NULL,58871487731,919866995,14372921,17.5),(100098,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 2004gu',NULL,100098,36.31,0.07,183,41963,72,NULL,'M(H) = -18.317 mag','FGC 175A',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100099,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 2004gu',NULL,100099,36.41,0.1,183,41963,72,NULL,NULL,'FGC 175A',0.045859,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100100,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 2004gu','R',100100,36.32,0.06,184,41963,NULL,NULL,'MLCS2k2, R(V) = 3.1','FGC 175A',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100101,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 2004gu',NULL,100101,36.32,0.01,184,41963,72,NULL,NULL,'FGC 175A',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100102,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 2004gu',NULL,100102,36.35,0.1,186,41963,74.4,NULL,NULL,'FGC 175A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100103,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 2004gu',NULL,100103,36.48,0.13,189,41963,72,NULL,NULL,'FGC 175A',0.045859,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100104,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 2004gu',NULL,100104,36.48,0.15,189,41963,70,NULL,'SALT 2','FGC 175A',0.045859,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100105,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 2004gu','R',100105,36.4,0.05,191,41963,NULL,NULL,'MLCS2k2, R(V) = 1.8','FGC 175A',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100106,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 2004gu',NULL,100106,36.51,0.13,192,41963,73.8,NULL,'SALT 2 (SNANA)','FGC 175A',0.0467,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100107,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:16','1','SN 2004gu',NULL,100107,36.77,0.02,216,41963,70,NULL,NULL,'FGC 175A',0.045859,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100108,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100108,37.68,0.21,343,41964,70,NULL,NULL,'2MASX J12462481+3600349',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000194,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,191.603333,36.00978,0.017,NULL,58555357986,914927468,14295741,17.3),(100109,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100109,35.91,0.77,152,41965,70,NULL,NULL,'2MASX J12462511-2146282',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000183,NULL,'16.14',0.2,NULL,NULL,NULL,NULL,NULL,1,191.604583,-21.77461,0.117,NULL,43921418842,686272169,10723002,16.14),(100110,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100110,37.01,0.46,252,41966,70,NULL,NULL,'2MASX J12462540+2046333',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,191.605875,20.77581,0.124,NULL,58902295595,920348368,14380443,17.7),(100111,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100111,37.92,0.13,383,41967,70,NULL,NULL,'SDSS J124625.87+003130.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00008,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,191.607833,0.52503,0,NULL,58083595207,907556175,14180565,18.6),(100112,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100112,38.03,0.46,404,41968,70,NULL,NULL,'2MASX J12462597+0040267',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00009,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,191.60825,0.67406,0,NULL,58083609996,907556406,14180568,17.2),(100113,'D-Sigma','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100113,32.78,0.4,35.9,41969,75,NULL,'Edat, raw','ESO 322- G 075',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000123,NULL,'13.82',0.9,'(R)SA0^0^:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.608458333,-40.75253,0.489,NULL,46746924397,730420693,11412823,13.82),(100114,'D-Sigma','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100114,32.88,0.4,37.6,41969,75,NULL,'Edat, cor','ESO 322- G 075',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100115,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100115,32.61,0.23,33.3,41969,74.4,NULL,NULL,'ESO 322- G 075',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100116,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100116,33.15,0.51,42.6,41969,70,NULL,NULL,'ESO 322- G 075',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100117,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100117,33.59,0.45,52.3,41969,NULL,NULL,'K','ESO 322- G 075',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100118,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100118,34.04,0.4,64.2,41969,NULL,NULL,'mean','ESO 322- G 075',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100119,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100119,37.91,0.23,382,41970,70,NULL,NULL,'2MASX J12462673+2520132',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00014,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,191.611375,25.33717,0,NULL,58722620627,917540947,14336577,17.2),(100120,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100120,36.14,0.27,169,41971,70,NULL,NULL,'2MASX J12462682+1154447',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.14',0.19,NULL,NULL,NULL,NULL,NULL,1,191.611625,11.91231,0.054,NULL,58871496456,919867132,14372923,18.14),(100121,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100121,37.92,0.13,383,41972,70,NULL,NULL,'2MASX J12462717+0028437',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000096,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,191.613083,0.47872,0,NULL,58083596718,907556198,14180565,16.5),(100122,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100122,39,0.46,631,41973,70,NULL,NULL,'SDSS J124627.34-023103.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000087,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,191.613917,-2.51772,0.013,NULL,43101734114,673464595,10522884,18.2),(100123,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100123,37.08,0.27,261,41974,70,NULL,NULL,'2MASX J12462795+5202218',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000196,NULL,'15.6g',0.53,'AGN',NULL,NULL,NULL,NULL,1,191.6165,52.03944,0,NULL,57207009560,893859524,13966555,15.6),(100124,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100124,37.53,0.46,321,41975,70,NULL,NULL,'2MASX J12463146+1730546',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,191.631125,17.51511,0.056,NULL,58876364708,919943198,14374112,17.3),(100125,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100125,37.29,0.46,287,41976,70,NULL,NULL,'2MASX J12463156+2059154',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,191.6315417,20.98756,0.15,NULL,58902267731,920347933,14380436,17.9),(100126,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100126,37.97,0.33,392,41977,70,NULL,NULL,'2MASX J12463174-0037108',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000067,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,191.632333333,-0.61961,0.016,NULL,43101676571,673463696,10522870,17.8),(100127,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100127,37.54,0.46,323,41978,70,NULL,NULL,'2MASX J12463246+1704106',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,191.635291667,17.06947,0.054,NULL,58876277412,919941834,14374091,17.8),(100128,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100128,38.14,0.21,425,41979,70,NULL,NULL,'2MASX J12463274+2627187',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,191.636333333,26.45525,0.036,NULL,58722928928,917545764,14336652,17.6),(100129,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100129,37.73,0.46,352,41980,70,NULL,NULL,'2MASX J12463301+1440516',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,191.6374583,14.68114,0.033,NULL,58886151408,920096115,14376501,18.1),(100130,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100130,37.63,0.46,336,41981,70,NULL,NULL,'2MASX J12463375+5710210',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,191.640416667,57.17253,0,NULL,57430753385,897355521,14021180,17.2),(100131,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100131,36.14,0.27,169,41982,70,NULL,NULL,'VCC 2041',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.000143,NULL,'15.1g',0.48,'E6(cD)','Group member',NULL,NULL,NULL,1,191.640667,11.89664,0.054,NULL,58871495892,919867123,14372923,15.1),(100132,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100132,38.1,0.46,418,41983,70,NULL,NULL,'2MASX J12463416+0055328',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000083,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,191.642166667,0.92564,0,NULL,58083398375,907553099,14180517,18.1),(100133,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100133,37.04,0.46,256,41984,70,NULL,NULL,'2MASX J12463451+0007438',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000075,NULL,'17.2g',0.26,'AGN',NULL,NULL,NULL,NULL,1,191.6437083,0.12886,0,NULL,58082831848,907544247,14180378,17.2),(100134,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100134,37.46,0.46,311,41985,70,NULL,NULL,'SDSS J124635.20+153252.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000103,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,191.6467083,15.54786,0.033,NULL,58878590303,919977973,14374655,18.3),(100135,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100135,37.68,0.21,343,41986,70,NULL,NULL,'2MASX J12463622+3604520',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000178,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,191.650917,36.08114,0.017,NULL,58555354590,914927415,14295740,16.8),(100136,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100136,37.91,0.23,382,41987,70,NULL,NULL,'2MASX J12463647+2512067',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',NULL,NULL,NULL,0.12,NULL,NULL,NULL,NULL,NULL,1,191.652083,25.20189,0,NULL,58722616058,917540875,14336576,NULL),(100137,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100137,37.76,0.46,356,41988,70,NULL,NULL,'2MASX J12463661-0116248',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000105,NULL,'16.6g',0.32,'AGN',NULL,NULL,NULL,NULL,1,191.6525,-1.27369,0.029,NULL,43104575555,673508993,10523578,16.6),(100138,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100138,37.43,0.46,306,41989,70,NULL,NULL,'2MASX J12463662+1842104',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,191.6525417,18.70289,0.056,NULL,58897028499,920266070,14379157,17.3),(100139,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100139,30.71,0.4,13.9,41990,NULL,NULL,NULL,'KDG 198',NULL,'2013MNRAS.429.2677K',2013,1,0.6,NULL,'G',0.000007,NULL,'16.80',0.5,'Dwarf',NULL,NULL,NULL,NULL,1,191.656333333,-4.07586,0.049,NULL,43108310088,673567345,10524489,16.8),(100140,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100140,37.67,0.46,342,41991,70,NULL,NULL,'SDSS J124639.19+152944.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,191.663333,15.49572,0.033,NULL,58878579746,919977808,14374653,17.8),(100141,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100141,36.99,0.33,250,41992,70,NULL,NULL,'2MASX J12463922+0136068',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000086,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,191.663458333,1.60192,0.033,NULL,58085314592,907583040,14180985,17.3),(100142,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100142,36.78,0.46,227,41993,70,NULL,NULL,'2MASX J12463925+3138009',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000155,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,191.663458333,31.63367,0.021,NULL,58747585548,917931024,14342672,17.2),(100143,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100143,37.13,0.46,266,41994,70,NULL,NULL,'2MASX J12464025+5842350',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,191.66775,58.70983,0,NULL,57405615594,896962743,14015042,17.3),(100144,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100144,36.77,0.46,226,41995,70,NULL,NULL,'2MASX J12464035+5027208',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000133,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,191.6682917,50.45589,0,NULL,57205971444,893843303,13966301,17.2),(100145,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100145,34.04,0.4,64.3,41996,NULL,NULL,'mean','ESO 322- G 076',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000025,NULL,'14.26',0.8,'SB(r)ab:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.674916667,-40.02472,0.469,NULL,46748715550,730448680,11413260,14.26),(100146,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100146,34.15,0.47,67.6,41996,NULL,NULL,'H','ESO 322- G 076',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100147,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100147,34.18,0.45,68.4,41996,NULL,NULL,'K','ESO 322- G 076',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100148,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100148,34.22,0.46,69.7,41996,NULL,NULL,'J','ESO 322- G 076',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100149,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100149,37.91,0.23,382,41997,70,NULL,NULL,'2MASX J12464207+2513577',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,191.675417,25.23256,0,NULL,58722616995,917540890,14336576,17.8),(100150,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100150,37.85,0.46,371,41998,70,NULL,NULL,'2MASX J12464230+0837287',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'17.43',0.16,NULL,NULL,NULL,NULL,NULL,1,191.6762083,8.62469,0,NULL,58067007886,907296998,14176515,17.43),(100151,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100151,36.76,0.46,225,41999,70,NULL,NULL,'2MASX J12464339+0344598',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000153,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,191.680833,3.74989,0.006,NULL,58092885086,907701329,14182833,17.2),(100152,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100152,38.36,0.33,469,42000,70,NULL,NULL,'2MASX J12464362+5933070',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,191.681875,59.55214,0,NULL,57404108921,896939201,14014675,17.7),(100153,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100153,37.44,0.15,307,42001,70,NULL,NULL,'SDSS J124643.92+172218.3',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.2g',0.35,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,191.683,17.37178,0.053,NULL,58876423209,919944112,14374126,16.2),(100154,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100154,36.66,0.46,215,42002,70,NULL,NULL,'2MASX J12464401+1040196',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000083,NULL,'16.43',0.3,NULL,NULL,NULL,NULL,NULL,1,191.68325,10.67214,0,NULL,58066339781,907286559,14176352,16.43),(100155,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100155,37.92,0.13,383,42003,70,NULL,NULL,'SDSS J124644.11+001223.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000066,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,191.6837917,0.20661,0,NULL,58082816972,907544015,14180375,18.3),(100156,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100156,36.91,0.58,241,42004,70,NULL,NULL,'2MASX J12464456-0145518',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.000075,NULL,'16.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,191.68575,-1.76444,0.013,NULL,43102405572,673475087,10523048,16.2),(100157,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100157,37.44,0.15,307,42005,70,NULL,NULL,'2MASX J12464397+1722186',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.03',0.18,NULL,NULL,NULL,NULL,NULL,1,191.685875,17.36642,0.053,NULL,58876421407,919944084,14374126,18.03),(100158,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100158,36.99,0.33,250,42006,70,NULL,NULL,'SDSS J124644.75+012751.4',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000081,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,191.6865,1.46428,0.033,NULL,58085183481,907580991,14180952,17.2),(100159,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100159,37.42,0.46,305,42007,70,NULL,NULL,'2MASX J12464534+4031580',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000142,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,191.688917,40.53278,0,NULL,59083812171,923184565,14424758,18.1),(100160,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100160,37.92,0.13,383,42008,70,NULL,NULL,'2MASX J12464564+0018588',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000078,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,191.690125,0.31625,0,NULL,58083675345,907557427,14180584,18),(100161,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100161,31.19,0.4,17.3,42009,75,NULL,'B','UGC 07943',NULL,'1988NBGC.C....0000T',1988,1,2.2,NULL,'G',0.000021,NULL,'13.84',1.8,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.690417,5.955,0,NULL,58070387818,907349809,14177340,13.84),(100162,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100162,31.78,0.36,22.7,42009,NULL,NULL,NULL,'UGC 07943',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100163,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100163,35.21,0.47,110,42010,NULL,NULL,'H','IC 0816',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000007,NULL,'14.86',0.6,'SB(r)...','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,191.693083,9.85056,0.011,NULL,58067577299,907305895,14176654,14.86),(100164,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100164,35.23,0.4,111,42010,NULL,NULL,'mean','IC 0816',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100165,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100165,34.33,0.46,73.4,42011,70,NULL,NULL,'ESO 574- G 031',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000043,NULL,'14.36',0.9,'(R\')SA(r)a',NULL,NULL,NULL,NULL,1,191.692958333,-21.39294,0.117,NULL,43921674116,686276158,10723064,14.36),(100166,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100166,37.65,0.27,339,42012,70,NULL,NULL,'2MASX J12464710-0217368',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000088,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,191.69625,-2.29367,0.013,NULL,43101803237,673465675,10522901,16.6),(100167,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100167,37.44,0.15,307,42013,70,NULL,NULL,'2MASX J12464732+1721076',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,191.6970417,17.35208,0.053,NULL,58876425835,919944153,14374127,17.3),(100168,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100168,36.97,0.46,247,42014,70,NULL,NULL,'2MASX J12464736+2756548',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.0002,NULL,'16.8',0.27,NULL,NULL,NULL,NULL,NULL,1,191.6974583,27.94867,0.04,NULL,58736264984,917754140,14339908,16.8),(100169,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100169,37.92,0.13,383,42015,70,NULL,NULL,'2MASX J12464744+0007028',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000083,NULL,'15.9g',0.4,'S0',NULL,NULL,NULL,NULL,1,191.6977083,0.11744,0,NULL,58082851441,907544553,14180383,15.9),(100170,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100170,37.82,0.12,367,42016,70,NULL,NULL,'2MASX J12464754+5453150',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000202,NULL,'16.1g',0.41,'BrClG',NULL,NULL,NULL,NULL,1,191.6980417,54.88756,0,NULL,57420211054,897190797,14018606,16.1),(100171,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100171,37.92,0.13,383,42017,70,NULL,NULL,'2MASX J12464898+0003378',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000076,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,191.704083333,0.06042,0,NULL,58082826232,907544159,14180377,17.6),(100172,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100172,37.79,0.46,362,42018,70,NULL,NULL,'2MASX J12464927+5149448',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,191.705125,51.829,0,NULL,57207117101,893861204,13966581,17.8),(100173,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100173,37.92,0.13,383,42019,70,NULL,NULL,'SDSS J124649.46+001856.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000069,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,191.706083,0.31575,0,NULL,58083685691,907557588,14180587,18.1),(100174,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,NULL,100174,36.56,0.66,205,42020,70,NULL,NULL,'2MASX J12464963-1754307',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.7b',0.18,NULL,NULL,NULL,NULL,NULL,1,191.7067083,-17.90858,0.101,NULL,43939613733,686556464,10727444,16.7),(100175,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100175,39.17,0.46,683,42021,70,NULL,NULL,'SDSS J124650.21+024016.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000127,NULL,'18.6g',0.14,'BLAGN',NULL,NULL,NULL,'Sy 1',1,191.7092083,2.67122,0.018,NULL,58096590954,907759233,14183738,18.6),(100176,'FP','2016-12-15 15:15:05','2016-12-16 11:20:16','1',NULL,'R',100176,36.84,0.27,233,42022,70,NULL,NULL,'2MASX J12465019+3011149',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,191.70925,30.18747,0.016,NULL,58783067128,918485423,14351334,17.3),(100177,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100177,37.65,0.27,339,42023,70,NULL,NULL,'2MASX J12465024-0217568',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000089,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,191.709458333,-2.29908,0.013,NULL,43101803481,673465679,10522901,16.4),(100178,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100178,37.57,0.19,327,42024,70,NULL,NULL,'SDSS J124650.69+072646.0',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'18.13',0.17,NULL,NULL,NULL,NULL,NULL,1,191.711208333,7.44614,0.009,NULL,58072721449,907386272,14177910,18.13),(100179,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100179,37.92,0.13,383,42025,70,NULL,NULL,'2MASX J12465124+0017498',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.000114,NULL,'15.6g',0.42,'BrClG',NULL,NULL,NULL,NULL,1,191.713375,0.29703,0,NULL,58083687061,907557610,14180587,15.6),(100180,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100180,37.92,0.13,383,42026,70,NULL,NULL,'SDSS J124652.68+001352.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00007,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,191.719541667,0.23119,0,NULL,58082813723,907543964,14180374,17.7),(100181,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100181,37.44,0.15,307,42027,70,NULL,NULL,'SDSS J124653.01+172312.0',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,191.720916667,17.38669,0.053,NULL,58876425070,919944141,14374127,NULL),(100182,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100182,37.57,0.19,327,42028,70,NULL,NULL,'SDSS J124654.31+071801.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000138,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,191.726333,7.3005,0.01,NULL,58072522387,907383162,14177861,17.9),(100183,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:17','1','SN 1997bp',NULL,100183,31.89,0.31,23.7,42029,74.2,NULL,'SALT 2','NGC 4680',0.00831,'2010ApJ...716..712A',2010,1,1.4,NULL,'G',0.00003,NULL,'13.23',1.2,'Pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.7279583,-11.63706,0.093,NULL,43956310188,686817346,10731521,13.23),(100184,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:17','1','SN 1997bp',NULL,100184,32.39,0.08,30.1,42029,74.4,NULL,NULL,'NGC 4680',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100185,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:17','1','SN 1997bp',NULL,100185,32.46,0.19,30.8,42029,72,NULL,NULL,'NGC 4680',0.00831,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100186,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:17','1','SN 1997bp',NULL,100186,32.69,0.35,34.2,42029,70,NULL,'SALT','NGC 4680',0.00831,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100187,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:17','1','SN 1997bp',NULL,100187,32.76,0.05,35.3,42029,72,NULL,NULL,'NGC 4680',0.00831,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100188,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:17','1','SN 1997bp',NULL,100188,32.81,0.1,36.5,42029,65,NULL,'Snapshot','NGC 4680',NULL,'1998ApJ...504..935R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100189,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:17','1','SN 1997bp',NULL,100189,32.9,0.09,37.3,42029,65,NULL,'MLCS2k2','NGC 4680',0.00831,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100190,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:17','1','SN 1997bp',NULL,100190,32.97,0.14,39.3,42029,60,NULL,NULL,'NGC 4680',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100191,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:17','1','SN 1997bp',NULL,100191,33.01,0.17,40,42029,70.8,NULL,NULL,'NGC 4680',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100192,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100192,31.21,0.43,17.5,42029,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4680',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100193,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100193,31.43,0.42,19.3,42029,NULL,18.48,'3.6 micron','NGC 4680',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100194,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100194,31.43,0.43,19.3,42029,75,NULL,'3.6 micron, color corrected','NGC 4680',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100195,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100195,31.58,0.4,20.7,42029,75,NULL,'HOSTS SN 1997bp','NGC 4680',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100196,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100196,32.15,0.4,26.9,42029,75,NULL,'HOSTS SN 1997bp','NGC 4680',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100197,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100197,32.39,0.08,30.1,42029,74.4,NULL,NULL,'NGC 4680',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100198,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100198,32.96,0.4,39,42029,NULL,NULL,'mean','NGC 4680',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100199,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100199,33.04,0.45,40.6,42029,NULL,NULL,'K','NGC 4680',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100200,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100200,33.07,0.47,41.1,42029,NULL,NULL,'H','NGC 4680',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100201,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100201,33.1,0.46,41.7,42029,NULL,NULL,'J','NGC 4680',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100202,'Tully est','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100202,29.74,0.8,8.9,42030,75,NULL,'B','UGCA 298',NULL,'1988NBGC.C....0000T',1988,1,0.5,NULL,'G',0.00005,NULL,'15.50',0.3,'E+:            HII','Group member',NULL,NULL,NULL,1,191.730875,26.56428,0.041,NULL,58722884352,917545068,14336641,15.5),(100203,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100203,30.21,NULL,11,42030,NULL,NULL,NULL,'UGCA 298',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100204,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100204,35.79,0.72,144,42031,70,NULL,NULL,'2MASX J12465544-1857537',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,191.731,-18.96489,0.113,NULL,43910557185,686102456,10720350,15.6),(100205,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100205,37.65,0.27,339,42032,70,NULL,NULL,'2MASX J12465626-0212001',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000088,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,191.734375,-2.20022,0.021,NULL,43101813781,673465840,10522903,16.8),(100206,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100206,29.76,0.4,8.9,42033,75,NULL,'B','UGC 07950',NULL,'1988NBGC.C....0000T',1988,1,1.22,NULL,'G',0.000013,NULL,'14.1g',0.92,'Im             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.7352083,51.61294,0,NULL,57206547594,893852306,13966442,14.1),(100207,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100207,29.75,NULL,8.91,42033,NULL,NULL,NULL,'UGC 07950',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100208,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100208,37.63,0.46,336,42034,70,NULL,NULL,'2MASX J12465681+3405019',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00013,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,191.736583,34.08386,0.018,NULL,58752749367,918011708,14343932,18.1),(100209,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100209,37.92,0.13,383,42035,70,NULL,NULL,'SDSS J124656.87+001515.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000085,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,191.737,0.25436,0,NULL,58083678885,907557482,14180585,18.3),(100210,'Tully est','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100210,33.33,0.8,46.4,42036,75,NULL,'B','NGC 4677',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.0001,NULL,'13.91',0.7,'SB(s)0+:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.7380417,-41.58253,0.485,NULL,46746742804,730417856,11412779,13.91),(100211,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100211,36.74,0.46,223,42037,70,NULL,NULL,'2MASX J12465711+0344201',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000162,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,191.738083,3.73892,0.006,NULL,58092884672,907701323,14182833,16.6),(100212,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100212,38.38,0.46,473,42038,70,NULL,NULL,'2MASX J12465732+5351377',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000182,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,191.739,53.86058,0.007,NULL,57198427010,893725422,13964459,17),(100213,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100213,34.69,0.46,86.7,42039,70,NULL,NULL,'2MASX J12465779+4032270',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.00016,NULL,'15.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,191.7410417,40.54089,0,NULL,59083843274,923185051,14424766,15.7),(100214,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100214,37.09,0.33,262,42040,70,NULL,NULL,'2MASX J12465848+3625000',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000206,NULL,'15.7g',0.5,NULL,NULL,NULL,NULL,NULL,1,191.743625,36.41656,0.023,NULL,58555684939,914932577,14295821,15.7),(100215,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100215,37.75,0.46,355,42041,70,NULL,NULL,'2MASX J12465913+6302061',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000134,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,191.746541667,63.03492,0,NULL,57376065814,896501028,14007828,17.7),(100216,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100216,37.09,0.33,262,42042,70,NULL,NULL,'2MASX J12465947+3626570',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000169,NULL,'16.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,191.7477917,36.44903,0.023,NULL,58555669674,914932338,14295817,16.4),(100217,'Brightest Stars','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100217,30.09,NULL,10.4,42043,NULL,NULL,NULL,'UGC 07949',NULL,'1998A&AS..128..459M',1998,1,1.9,NULL,'G',0.000002,NULL,'17.',1.5,'Im:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.749167,36.47639,0.034,NULL,58555669392,914932334,14295817,17),(100218,'TRGB','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100218,27.39,0.1,3.01,42043,74.4,NULL,NULL,'UGC 07949',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100219,'Tully est','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100219,28.11,0.8,4.2,42043,75,NULL,NULL,'UGC 07949',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100220,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100220,28.66,NULL,5.4,42043,NULL,NULL,NULL,'UGC 07949',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100221,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100221,37.91,0.23,382,42044,70,NULL,NULL,'2MASXi J1246599+252142',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,191.7495417,25.362,0,NULL,58723704542,917557883,14336841,17.6),(100222,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100222,39.02,0.46,638,42045,70,NULL,NULL,'SDSS J124700.28+005602.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00009,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,191.7512083,0.93397,0,NULL,58083405692,907553213,14180518,18.3),(100223,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100223,31.34,NULL,18.6,42046,NULL,NULL,NULL,'FGC 1497',NULL,'2000BSAO...50....5K',2000,1,1.05,NULL,'G',0.000017,NULL,'16.8g',0.17,'Sdm',NULL,NULL,NULL,NULL,1,191.7527083,32.65161,0.023,NULL,58750615858,917978372,14343412,16.8),(100224,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100224,31.35,NULL,18.6,42046,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1497',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100225,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100225,31.38,NULL,18.8,42046,NULL,NULL,'Dipole + Quadrupole','FGC 1497',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100226,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100226,31.4,NULL,19.1,42046,NULL,NULL,'Dipole','FGC 1497',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100227,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100227,31.85,NULL,23.4,42046,NULL,NULL,NULL,'FGC 1497',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100228,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100228,36.06,0.46,163,42047,70,NULL,NULL,'2MASX J12470339+0022571',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000081,NULL,'16.1g',0.41,NULL,NULL,NULL,NULL,NULL,1,191.764041667,0.38253,0,NULL,58083709367,907557958,14180593,16.1),(100229,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100229,36.69,0.46,218,42048,70,NULL,NULL,'VII Zw 484',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000173,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,191.768417,57.77389,0,NULL,57438067843,897469810,14022965,16.2),(100230,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100230,37.82,0.12,367,42049,70,NULL,NULL,'2MASX J12470505+5505467',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000181,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,191.770625,55.09622,0,NULL,57429336645,897333385,14020834,17.8),(100231,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100231,36.85,0.46,234,42050,70,NULL,NULL,'2MASX J12470537+5247156',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000145,NULL,'17.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,191.77225,52.78767,0.009,NULL,57199140422,893736569,13964633,17.6),(100232,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100232,37.55,0.46,324,42051,70,NULL,NULL,'2MASX J12470558+2838384',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000142,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,191.773125,28.64394,0.046,NULL,58725960492,917593132,14337392,17.7),(100233,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100233,37.92,0.46,383,42052,70,NULL,NULL,'2MASX J12470554+4907206',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000183,NULL,'16.7g',0.35,NULL,NULL,NULL,NULL,NULL,1,191.77325,49.12253,0,NULL,59097062188,923391596,14427993,16.7),(100234,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:17','1','SN PTF11qri',NULL,100234,37.01,0.15,252,42053,72,NULL,'M(H) = -18.317 mag','LCRS B124431.1-060321',NULL,'2014ApJ...784..105W',2013,1,0.27,NULL,'G',NULL,NULL,'17.18',0.17,NULL,NULL,NULL,NULL,NULL,1,191.776125,-6.32861,0.033,NULL,43126803426,673856303,10529004,17.18),(100235,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100235,37.82,0.12,367,42054,70,NULL,NULL,'2MASX J12470775+5459187',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000182,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,191.7822917,54.98839,0,NULL,57428492025,897320187,14020627,16.5),(100236,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100236,38.42,0.46,484,42055,70,NULL,NULL,'SDSS J124708.99-000317.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000074,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,191.7874583,-0.05494,0,NULL,43100804809,673450075,10522657,18.7),(100237,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100237,31.73,0.4,22.2,42056,75,NULL,NULL,'NGC 4693',NULL,'2008Ap.....51..336K',2008,1,2.5,'HOLM 460B is a star.','G',0.000013,NULL,'13.99',0.5,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.7882083,71.17614,0.021,NULL,56983162999,890361921,13911905,13.99),(100238,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100238,32.15,0.49,26.9,42056,75,NULL,'IR','NGC 4693',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100239,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100239,32.31,0.49,29,42056,NULL,NULL,'Malmquist cor.','NGC 4693',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100240,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100240,32.36,0.48,29.6,42056,NULL,NULL,NULL,'NGC 4693',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100241,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100241,32.38,0.2,29.9,42056,74.4,NULL,NULL,'NGC 4693',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100242,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100242,32.42,0.4,30.5,42056,NULL,NULL,NULL,'NGC 4693',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100243,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100243,32.43,0.4,30.6,42056,NULL,NULL,'mean','NGC 4693',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100244,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100244,32.86,0.47,37.3,42056,NULL,NULL,'H','NGC 4693',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100245,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100245,32.95,0.45,38.9,42056,NULL,NULL,'K','NGC 4693',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100246,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100246,33.01,0.46,40,42056,NULL,NULL,'J','NGC 4693',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100247,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100247,36.35,NULL,186,42057,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07948',NULL,'2010Ap&SS.325..163P',2010,1,1.12,NULL,'G',0.000012,NULL,'16.0',0.16,'Sb',NULL,NULL,NULL,NULL,1,191.788833,9.01628,0,NULL,58067167663,907299494,14176554,16),(100248,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100248,36.35,NULL,186,42057,NULL,NULL,'Dipole + Quadrupole','UGC 07948',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100249,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100249,36.36,NULL,187,42057,NULL,NULL,'Dipole','UGC 07948',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100250,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100250,36.56,NULL,205,42057,NULL,NULL,NULL,'UGC 07948',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100251,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100251,36.72,0.49,220,42057,75,NULL,'IR','UGC 07948',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100252,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100252,36.84,0.27,233,42058,70,NULL,NULL,'2MASX J12470947+3008485',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000107,NULL,'16.0g',0.36,NULL,NULL,NULL,NULL,NULL,1,191.7894583,30.14681,0.016,NULL,58783069437,918485459,14351335,16),(100253,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100253,37.07,0.46,260,42059,70,NULL,NULL,'2MASX J12470967+0407551',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000178,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,191.790375,4.13183,0,NULL,58094997960,907734343,14183349,17),(100254,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100254,37.44,0.46,308,42060,70,NULL,NULL,'SDSS J124709.76+062658.6',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.1g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,191.790708333,6.44964,0,NULL,58071025475,907359773,14177496,17.1),(100255,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100255,37.56,0.46,324,42061,70,NULL,NULL,'2MASX J12471035+0759124',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000138,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,191.793083,7.98672,0,NULL,58072324782,907380074,14177813,17.8),(100256,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100256,37.57,0.19,327,42062,70,NULL,NULL,'2MASX J12471034+0729194',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,191.793291667,7.48889,0.01,NULL,58072702202,907385971,14177905,17.2),(100257,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100257,34.43,0.49,76.8,42063,75,NULL,'IR','UGC 07955',NULL,'2011yCatp016004901K',2011,1,1.48,NULL,'G',0.000018,NULL,'16.0',0.19,'Sc             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.79875,26.71347,0.041,NULL,58736000715,917750011,14339843,16),(100258,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100258,34.79,0.43,90.8,42063,75,NULL,'3.6 micron, color corrected','UGC 07955',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100259,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100259,34.82,0.43,92,42063,75,NULL,'3.6 micron, color + selection bias corrected','UGC 07955',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100260,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100260,34.82,0.2,92,42063,74.4,NULL,NULL,'UGC 07955',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100261,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100261,34.95,NULL,97.6,42063,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07955',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100262,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100262,34.96,NULL,98,42063,NULL,NULL,'Dipole + Quadrupole','UGC 07955',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100263,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100263,34.97,NULL,98.5,42063,NULL,NULL,'Dipole','UGC 07955',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100264,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100264,35.07,0.12,103,42063,NULL,NULL,NULL,'UGC 07955',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100265,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100265,35.07,NULL,103,42063,NULL,NULL,NULL,'UGC 07955',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100266,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100266,37.57,0.19,327,42064,70,NULL,NULL,'SDSS J124713.10+074619.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00015,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,191.804625,7.77197,0,NULL,58073217700,907394026,14178031,18.6),(100267,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100267,37.92,0.13,383,42065,70,NULL,NULL,'2MASX J12471385+0020261',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00007,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,191.80775,0.34064,0,NULL,58083688580,907557634,14180588,17.6),(100268,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100268,30.65,0.32,13.5,42066,NULL,NULL,'TOM(g) = -7.2 mag','IC 3773',NULL,'2010ApJ...717..603V',2010,1,1.83,'The IC number includes a nearby star.','G',0.00004,NULL,'13.9g',0.66,'d:S0(9)','in a radial-velocity based grouping',NULL,NULL,NULL,1,191.81375,10.20358,0,NULL,58066256812,907285262,14176332,13.9),(100269,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100269,30.68,0.51,13.7,42066,NULL,NULL,'TOM(g) = -7.2 mag','IC 3773',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100270,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100270,30.84,0.34,14.8,42066,NULL,NULL,'TOM(u) = -8.4 mag','IC 3773',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100271,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100271,30.95,0.28,15.5,42066,NULL,NULL,'TOM(z) = -8.53 mag','IC 3773',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100272,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100272,31.66,0.4,21.5,42066,NULL,NULL,'mean','IC 3773',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100273,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100273,32.03,0.45,25.5,42066,NULL,NULL,'K','IC 3773',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100274,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100274,37.88,0.46,376,42067,70,NULL,NULL,'SDSS J124715.40+003013.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000073,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,191.8142083,0.50369,0,NULL,58083726100,907558220,14180597,18.2),(100275,'Sosies','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100275,31.8,0.11,22.9,42068,NULL,NULL,NULL,'NGC 4682',NULL,'2002A&A...393...57T',2002,1,2.6,NULL,'G',0.00003,NULL,'13.18',1.3,'SAB(s)cd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.8145417,-10.06344,0.097,NULL,43118023535,673719117,10526861,13.18),(100276,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100276,32.44,0.4,30.8,42068,NULL,NULL,NULL,'NGC 4682',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100277,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100277,32.53,0.47,32.1,42068,NULL,NULL,'H','NGC 4682',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100278,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100278,32.62,0.45,33.5,42068,NULL,NULL,'K','NGC 4682',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100279,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100279,32.63,0.46,33.5,42068,NULL,NULL,'J','NGC 4682',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100280,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100280,32.79,0.4,36.1,42068,NULL,NULL,'mean','NGC 4682',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100281,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100281,33.13,0.3,42.3,42068,55,NULL,'B','NGC 4682',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100282,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100282,37.57,0.19,327,42069,70,NULL,NULL,'2MASX J12471572+0730334',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,191.815417,7.50925,0.01,NULL,58072709232,907386081,14177907,17.8),(100283,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100283,38.83,0.46,583,42070,70,NULL,NULL,'SDSS J124715.73+082015.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,191.815583,8.33758,0,NULL,58072275544,907379305,14177801,18.4),(100284,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100284,38.36,0.33,469,42071,70,NULL,NULL,'2MASX J12471714+5928547',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,191.82125,59.48186,0,NULL,57403848991,896935140,14014611,17.4),(100285,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100285,38.49,0.46,499,42072,70,NULL,NULL,'2MASX J12471728+1300155',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,191.822083,13.00436,0.053,NULL,58871514864,919867419,14372928,17.8),(100286,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100286,35.69,0.49,137,42073,70,NULL,NULL,'2MASX J12471735-4502334',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000093,NULL,'13.3I',0.4,NULL,NULL,NULL,NULL,NULL,1,191.822375,-45.04256,0.357,NULL,46772395317,730818676,11419041,13.3),(100287,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100287,37.84,0.46,370,42074,70,NULL,NULL,'2MASX J12471741+3103116',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,191.8225417,31.05319,0.013,NULL,58780803829,918450059,14350782,17.3),(100288,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100288,30.65,0.19,13.5,42075,NULL,NULL,'I','NGC 4684',NULL,'2001ApJ...546..681T',2001,1,2.9,'Da Costa, et al. (1998,AJ,116,1) give v = 37624 +/- 54 km/sec.','G',0.000017,NULL,'12.38',1,'SB(r)0+        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.823,-2.72742,0.021,NULL,43115585412,673681022,10526265,12.38),(100289,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100289,30.72,0.14,13.9,42075,74.4,NULL,NULL,'NGC 4684',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100290,'Tully est','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100290,32.19,0.8,27.4,42075,75,NULL,'B','NGC 4684',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100291,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100291,30.52,0.45,12.7,42075,NULL,NULL,'K','NGC 4684',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100292,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100292,31.87,0.4,23.6,42075,NULL,NULL,'mean','NGC 4684',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100293,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100293,36.79,0.53,228,42076,70,NULL,NULL,'2MASX J12471782-0739534',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'15.52',0.25,NULL,NULL,NULL,NULL,NULL,1,191.824375,-7.66497,0.073,NULL,43127780055,673871563,10529243,15.52),(100294,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100294,37.84,0.23,369,42077,70,NULL,NULL,'2MASX J12471961+5005417',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00015,NULL,'16.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,191.831875,50.09489,0,NULL,57205619182,893837799,13966215,16.4),(100295,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100295,37.75,0.33,356,42078,70,NULL,NULL,'SDSS J124720.51+274647.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'19.50',0.14,NULL,NULL,NULL,NULL,NULL,1,191.835458333,27.78,0.04,NULL,58736467629,917757306,14339957,19.5),(100296,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100296,31.1,0.44,16.6,42079,NULL,NULL,'TOM(g) = -7.2 mag','IC 3779',NULL,'2007ApJS..171..101J',2007,1,0.91,NULL,'G',0.000058,NULL,'15.3g',0.56,'dE5:,N','Group member',NULL,NULL,NULL,1,191.836,12.16642,0.067,NULL,58988825351,921700396,14401568,15.3),(100297,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100297,31.1,0.12,16.6,42079,NULL,NULL,'TOM(g) = -7.2 mag','IC 3779',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100298,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100298,31.36,0.39,18.7,42079,NULL,NULL,'TOM(u) = -8.4 mag','IC 3779',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100299,'GCLF','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100299,31.49,0.14,19.9,42079,NULL,NULL,'TOM(z) = -8.53 mag','IC 3779',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100300,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100300,30.98,0.14,15.7,42079,74.4,NULL,NULL,'IC 3779',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100301,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100301,30.99,0.08,15.8,42079,NULL,NULL,NULL,'IC 3779',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100302,'SBF','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100302,31,0.08,15.8,42079,NULL,NULL,'HST ACS VCS','IC 3779',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100303,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100303,36.82,0.46,231,42080,70,NULL,NULL,'2MASX J12472095+0806223',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,191.8372917,8.10631,0,NULL,58072493070,907382704,14177854,17.3),(100304,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100304,37.84,0.46,371,42081,70,NULL,NULL,'2MASX J12472094+1623535',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,191.837333333,16.39822,0.027,NULL,58879096159,919985877,14374779,17.6),(100305,'D-Sigma','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100305,32.93,0.4,38.6,42082,75,NULL,'Edat, raw','NGC 4696B',NULL,'1997ApJS..109..333W',1997,1,1.3,'Marginal HIPASS detection.','G',0.000022,NULL,'12.68',0.7,'SA0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.84075,-41.2375,0.469,NULL,46747531027,730430172,11412971,12.68),(100306,'D-Sigma','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100306,32.95,0.4,38.9,42082,75,NULL,'Edat, cor','NGC 4696B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100307,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100307,33.64,0.23,53.5,42082,74.4,NULL,NULL,'NGC 4696B',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100308,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100308,33.42,0.4,48.2,42082,NULL,NULL,'mean','NGC 4696B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100309,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100309,33.76,0.45,56.5,42082,NULL,NULL,'K','NGC 4696B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100310,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100310,36.41,0.46,192,42083,70,NULL,NULL,'2MASX J12472277+0505311',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000169,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,191.8447917,5.09194,0,NULL,58091288217,907676378,14182443,16.5),(100311,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100311,37.75,0.33,356,42084,70,NULL,NULL,'2MASX J12472293+2748195',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,191.8454583,27.80539,0.04,NULL,58736464501,917757257,14339957,17.4),(100312,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100312,35.89,0.7,151,42085,70,NULL,NULL,'2MASX J12472297-1617439',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'16.2b',0.38,'SBab',NULL,NULL,NULL,NULL,1,191.845708333,-16.29547,0.057,NULL,43935056005,686485250,10726332,16.2),(100313,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100313,37.4,0.46,302,42086,70,NULL,NULL,'2MASX J12472333+1119593',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000172,NULL,'18.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,191.847417,11.33314,0.05,NULL,58955144550,921174133,14393345,18),(100314,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100314,37.52,0.46,319,42087,70,NULL,NULL,'2MASX J12472348+2516355',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00009,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,191.847833,25.27642,0.022,NULL,58723728935,917558264,14336847,16.9),(100315,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100315,33.86,0.46,59.2,42088,70,NULL,NULL,'NGC 4687',NULL,'2015arXiv151105856S',2015,1,0.9,'RC3 has V = 675 +- 45 km/sec.','G',0.000077,NULL,'14.18',0.8,'E1','in a radial-velocity based grouping',NULL,NULL,NULL,1,191.8490417,35.35206,0.023,NULL,58554672339,914916755,14295574,14.18),(100316,'Tully est','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100316,29.61,0.8,8.4,42088,75,NULL,'B','NGC 4687',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100317,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100317,38.14,0.21,425,42089,70,NULL,NULL,'SDSS J124723.80+263410.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,191.849167,26.56969,0.041,NULL,58722878142,917544970,14336640,18.2),(100318,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100318,37.57,0.19,327,42090,70,NULL,NULL,'2MASX J12472400+0741253',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000143,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,191.849958333,7.69031,0,NULL,58073176043,907393375,14178021,16.9),(100319,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100319,37.82,0.12,367,42091,70,NULL,NULL,'2MASX J12472426+5459137',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000204,NULL,'16.1g',0.41,'BrClG',NULL,NULL,NULL,NULL,1,191.8509583,54.98703,0,NULL,57428489657,897320150,14020627,16.1),(100320,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100320,35.08,0.65,104,42092,NULL,NULL,NULL,'ESO 507- G 009',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'16.15',0.8,'Sb',NULL,NULL,NULL,NULL,1,191.853291667,-24.63669,0.441,NULL,43386577013,677915265,10592426,16.15),(100321,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100321,35.08,0.65,104,42092,NULL,NULL,'Malmquist cor.','ESO 507- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100322,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100322,35.12,0.2,106,42092,74.4,NULL,NULL,'ESO 507- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100323,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100323,37.92,0.13,383,42093,70,NULL,NULL,'2MASX J12472516+0019498',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000085,NULL,'16.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,191.855,0.33044,0,NULL,58083663796,907557246,14180581,16.9),(100324,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100324,37.82,0.46,366,42094,70,NULL,NULL,'SDSS J124725.50+662742.0',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000071,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,191.85625,66.46169,0.049,NULL,57852612909,903947076,14124173,18.6),(100325,'TRGB','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100325,27.5,NULL,3.16,42095,NULL,NULL,NULL,'HIPASS J1247-77',NULL,'2006AJ....131.1361K',2006,1,0.8,NULL,'G',0.00001,NULL,'17. B',0.3,'Im',NULL,NULL,NULL,NULL,1,191.858333,-77.57139,0.589,NULL,44190052334,690469567,10788586,17),(100326,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100326,37.92,0.13,383,42096,70,NULL,NULL,'SDSS J124726.31+001538.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000069,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,191.859667,0.26067,0,NULL,58083702693,907557854,14180591,18.3),(100327,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100327,37.85,0.17,372,42097,70,NULL,NULL,'2MASXi J1247268-013203',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000102,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,191.861875,-1.53436,0.029,NULL,43102382765,673474730,10523042,18),(100328,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100328,32.8,0.43,36.3,42098,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 159-075',NULL,'2014MNRAS.444..527S',2014,1,0.5,NULL,'G',0.000013,NULL,'15.1',0.25,'S0/a',NULL,NULL,NULL,NULL,1,191.8682083,27.45778,0.046,NULL,58736388699,917756073,14339938,15.1),(100329,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100329,33.18,0.43,43.2,42098,75,NULL,'3.6 micron, color corrected','CGCG 159-075',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100330,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100330,33.81,0.69,57.9,42098,100,NULL,'mid-IR','CGCG 159-075',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100331,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100331,35.08,0.12,104,42098,NULL,NULL,NULL,'CGCG 159-075',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100332,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100332,37.64,0.46,338,42099,70,NULL,NULL,'2MASX J12472877+1339197',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,191.869916667,13.65558,0.048,NULL,58872944634,919889759,14373277,18.1),(100333,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100333,31.89,0.4,23.8,42100,NULL,NULL,NULL,'2MASX J12472958-0823274',NULL,'2013MNRAS.429.2677K',2013,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,191.873333,-8.39106,0.097,NULL,43131122098,673923782,10530059,NULL),(100334,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100334,38.11,0.46,418,42101,70,NULL,NULL,'SDSS J124730.15+060945.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000144,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,191.875667,6.16264,0,NULL,58071136159,907361502,14177523,18.5),(100335,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:17','1','SN 2001cz',NULL,100335,33.31,0.14,45.2,42102,74.2,NULL,'SALT 2','NGC 4679',0.01538,'2010ApJ...716..712A',2010,1,2.4,NULL,'G',0.000026,NULL,'13.15',1,'SA(s)bc        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.8760417,-39.57086,0.409,NULL,46748170841,730440169,11413127,13.15),(100336,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:17','1','SN 2001cz',NULL,100336,33.85,0.1,58,42102,72,NULL,NULL,'NGC 4679',0.01538,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100337,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:17','1','SN 2001cz',NULL,100337,33.86,0.03,58.3,42102,72,NULL,NULL,'NGC 4679',0.01538,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100338,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:17','1','SN 2001cz',NULL,100338,33.84,0.08,58.6,42102,74.4,NULL,NULL,'NGC 4679',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100339,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:17','1','SN 2001cz',NULL,100339,33.88,0.12,58.8,42102,72,NULL,NULL,'NGC 4679',0.01538,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100340,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:17','1','SN 2001cz',NULL,100340,33.92,0.05,60.8,42102,72,NULL,'M(H) = -18.317 mag','NGC 4679',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100341,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:17','1','SN 2001cz',NULL,100341,33.98,0.19,61.4,42102,70,NULL,'SALT 2','NGC 4679',0.01538,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100342,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:17','1','SN 2001cz',NULL,100342,34.02,0.19,62.7,42102,73.8,NULL,'SALT 2 (SNANA)','NGC 4679',0.0155,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100343,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:17','1','SN 2001cz',NULL,100343,34.03,0.03,63.8,42102,72,NULL,NULL,'NGC 4679',0.01538,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100344,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:17','1','SN 2001cz',NULL,100344,34.09,0.14,64.8,42102,70,NULL,'SALT','NGC 4679',0.01538,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100345,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:17','1','SN 2001cz',NULL,100345,34.14,0.19,66.3,42102,72,NULL,NULL,'NGC 4679',0.01538,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100346,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:17','1','SN 2001cz',NULL,100346,34.15,0.24,66.7,42102,65,NULL,'SALT2','NGC 4679',0.01538,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100347,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:17','1','SN 2001cz',NULL,100347,34.16,0.13,67,42102,70,NULL,NULL,'NGC 4679',0.01538,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100348,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:17','1','SN 2001cz',NULL,100348,34.22,0.2,68.8,42102,65,NULL,'SALT','NGC 4679',0.01538,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100349,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:17','1','SN 2001cz',NULL,100349,34.25,0.22,69.8,42102,65,NULL,'MLCS31','NGC 4679',0.01538,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100350,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:17','1','SN 2001cz',NULL,100350,34.26,0.21,70,42102,65,NULL,'MLCS17','NGC 4679',0.01538,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100351,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:17','1','SN 2001cz',NULL,100351,34.29,0.11,70,42102,65,NULL,'MLCS2k2','NGC 4679',0.01538,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100352,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:17','1','SN 2001cz',NULL,100352,34.23,0.17,70.1,42102,70.8,NULL,NULL,'NGC 4679',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100353,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:17','1','SN 2001cz',NULL,100353,34.28,0.12,70.5,42102,65,NULL,'MLCS2k2','NGC 4679',0.01538,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100354,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:17','1','SN 2001cz',NULL,100354,34.44,0.02,76.1,42102,65,NULL,'SALT','NGC 4679',0.01538,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100355,'SNIa','2016-12-15 15:15:05','2016-12-16 11:20:17','1','SN 2001cz',NULL,100355,34.51,0.03,78.5,42102,70,NULL,'SALT 2','NGC 4679',0.01538,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100356,'IRAS','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100356,34.05,0.8,64.5,42102,75,NULL,'MAT, I','NGC 4679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100357,'IRAS','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100357,34.08,0.8,65.5,42102,75,NULL,'HMCL, I','NGC 4679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100358,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100358,32.46,NULL,31,42102,NULL,NULL,'B','NGC 4679',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100359,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100359,32.91,0.4,38.2,42102,75,NULL,'HOSTS SN 2001cz','NGC 4679',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100360,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100360,33.31,0.43,45.9,42102,75,NULL,'MAT, I, raw','NGC 4679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100361,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100361,33.36,0.4,47,42102,75,NULL,'HMCL, I, raw','NGC 4679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100362,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100362,33.37,0.47,47.2,42102,NULL,NULL,'H','NGC 4679',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100363,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100363,33.37,0.46,47.2,42102,NULL,NULL,'J','NGC 4679',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100364,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100364,33.39,0.32,47.6,42102,85,NULL,'I, raw','NGC 4679',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100365,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100365,33.43,0.4,48.5,42102,75,NULL,'HOSTS SN 2001cz','NGC 4679',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100366,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100366,33.43,0.43,48.5,42102,75,NULL,'3.6 micron, color corrected','NGC 4679',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100367,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100367,33.43,0.45,48.6,42102,NULL,NULL,'K','NGC 4679',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100368,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100368,33.46,0.32,49.1,42102,85,NULL,'I, inv','NGC 4679',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100369,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100369,33.47,0.42,49.4,42102,NULL,18.48,'3.6 micron','NGC 4679',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100370,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100370,33.47,0.43,49.5,42102,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4679',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100371,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100371,33.48,0.43,49.8,42102,75,NULL,'MAT, I, cor','NGC 4679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100372,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100372,33.5,0.4,50.1,42102,75,NULL,'HMCL, I, cor','NGC 4679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100373,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100373,33.57,0.4,51.7,42102,75,NULL,'HMCL, I, inv','NGC 4679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100374,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100374,33.57,0.43,51.9,42102,NULL,NULL,'Malmquist cor.','NGC 4679',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100375,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100375,33.58,0.43,51.9,42102,75,NULL,'MAT, I, inv','NGC 4679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100376,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100376,33.76,0.39,56.4,42102,NULL,NULL,NULL,'NGC 4679',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100377,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100377,33.84,0.08,58.6,42102,74.4,NULL,NULL,'NGC 4679',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100378,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100378,34.08,0.4,65.5,42102,NULL,NULL,'mean','NGC 4679',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100379,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100379,38.43,0.33,485,42103,70,NULL,NULL,'2MASX J12473042+5347068',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00006,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,191.8767917,53.78533,0.007,NULL,57198443897,893725685,13964463,17.7),(100380,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100380,37.22,0.46,278,42104,70,NULL,NULL,'2MASX J12473054+0442098',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000164,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,191.877417,4.70267,0,NULL,58092117005,907689328,14182645,16.9),(100381,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100381,38.59,0.46,522,42105,70,NULL,NULL,'2MASX J12473119+6341192',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000187,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,191.880041667,63.68881,0.029,NULL,57368317489,896379960,14005936,17.3),(100382,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100382,37.96,0.46,391,42106,70,NULL,NULL,'2MASX J12473141+2455404',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,191.8807917,24.92797,0.03,NULL,58603116449,915673694,14307401,18),(100383,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100383,37.78,0.46,360,42107,70,NULL,NULL,'2MASX J12473176+2222120',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,191.882458333,22.37014,0.112,NULL,58891290042,920176406,14377756,17),(100384,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100384,38.42,0.46,484,42108,70,NULL,NULL,'SDSS J124732.13+104228.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,191.883875,10.70783,0,NULL,58066916049,907295563,14176493,18),(100385,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100385,37.41,0.46,304,42109,70,NULL,NULL,'2MASX J12473229+6751332',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000081,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,191.884375,67.85919,0.013,NULL,57854659060,903979047,14124672,17.1),(100386,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100386,37.84,0.23,369,42110,70,NULL,NULL,'2MASX J12473229+5001168',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000142,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,191.88475,50.02142,0,NULL,57205645606,893838212,13966222,18.3),(100387,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100387,36.6,0.63,209,42111,70,NULL,NULL,'2MASX J12473258-5047129',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.8I',0.3,NULL,NULL,NULL,NULL,NULL,1,191.885833,-50.78686,1.013,NULL,44601287048,696895110,10888986,14.8),(100388,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100388,36.53,0.46,203,42112,70,NULL,NULL,'2MASX J12473307+4102481',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000143,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,191.88775,41.04675,0,NULL,59083978800,923187168,14424799,17.5),(100389,'Tully est','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100389,31.97,0.8,24.7,42113,75,NULL,NULL,'ESO 172- G 009',NULL,'1988NBGC.C....0000T',1988,1,1.6,'Confused HIPASS source','G',0.000025,NULL,'16.1',1.1,'IB(s)m pec',NULL,NULL,NULL,NULL,1,191.888833,-53.94808,NULL,NULL,44602701210,696917206,10889331,16.1),(100390,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100390,38.09,0.46,414,42114,70,NULL,NULL,'VII Zw 485',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000102,NULL,'17.2g',0.23,'WLRG          LINER?',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,191.888875,67.38792,0.025,NULL,57855284863,903988825,14124825,17.2),(100391,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100391,37.85,0.17,372,42115,70,NULL,NULL,'2MASX J12473357-0129198',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000085,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,191.889791667,-1.48889,0.025,NULL,43102387648,673474807,10523043,17.6),(100392,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100392,37.8,0.46,363,42116,70,NULL,NULL,'2MASX J12473355+3738301',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,191.889833333,37.64164,0,NULL,58553572530,914899570,14295305,17.4),(100393,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100393,37.68,0.46,344,42117,70,NULL,NULL,'2MASX J12473389+2440469',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,191.891083,24.67967,0.03,NULL,58603328832,915677013,14307453,17.5),(100394,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100394,37.58,0.46,327,42118,70,NULL,NULL,'2MASX J12473515+0509518',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000161,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,191.896375,5.16428,0,NULL,58091304341,907676630,14182447,17.1),(100395,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100395,37.74,0.46,354,42119,70,NULL,NULL,'SDSS J124736.05+014658.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000082,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,191.90025,1.78283,0,NULL,58085628178,907587940,14181061,18),(100396,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100396,37.84,0.23,369,42120,70,NULL,NULL,'SDSS J124736.49+500143.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000134,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,191.902083,50.02872,0,NULL,57205613304,893837707,13966214,18.1),(100397,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100397,38.16,0.19,428,42121,70,NULL,NULL,'2MASX J12473797+0003271',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000095,NULL,'17.9g',0.14,'BLAGN',NULL,NULL,NULL,'Sy 1',1,191.9082083,0.0575,0,NULL,58083641839,907556903,14180576,17.9),(100398,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100398,38.43,0.33,485,42122,70,NULL,NULL,'2MASX J12473955+5345417',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000171,NULL,'17.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,191.914875,53.76158,0,NULL,57198438947,893725608,13964462,17.6),(100399,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100399,38.16,0.19,428,42123,70,NULL,NULL,'SDSS J124739.61-000743.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000076,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,191.915083,-0.12889,0,NULL,43101533704,673461464,10522835,18.2),(100400,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100400,36.86,0.46,235,42124,70,NULL,NULL,'2MASX J12473969+0953083',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.03',0.2,NULL,NULL,NULL,NULL,NULL,1,191.915541667,9.88572,0.031,NULL,58069666522,907338539,14177164,18.03),(100401,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100401,37.69,0.46,345,42125,70,NULL,NULL,'SDSS J124740.21+362035.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000132,NULL,'19.04',0.15,NULL,NULL,NULL,NULL,NULL,1,191.917583,36.34314,0.023,NULL,58555850412,914935162,14295861,19.04),(100402,'IRAS','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100402,35.07,0.8,103,42126,75,NULL,'MAT, I','ESO 507- G 011',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'14.81',0.5,'SB(rs)bc pec   HII',NULL,NULL,NULL,NULL,1,191.918041667,-26.19992,0.281,NULL,43422796342,678481192,10601268,14.81),(100403,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100403,35.13,0.32,106,42126,85,NULL,'I, raw','ESO 507- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100404,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100404,35.17,0.43,108,42126,75,NULL,'MAT, I, raw','ESO 507- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100405,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100405,35.2,0.32,110,42126,85,NULL,'I, inv','ESO 507- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100406,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100406,35.28,0.48,114,42126,NULL,NULL,'Malmquist cor.','ESO 507- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100407,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100407,35.33,0.4,116,42126,NULL,NULL,'mean','ESO 507- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100408,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100408,35.35,0.47,117,42126,NULL,NULL,'H','ESO 507- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100409,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100409,35.39,0.43,119,42126,75,NULL,'MAT, I, cor','ESO 507- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100410,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100410,35.43,0.45,122,42126,NULL,NULL,NULL,'ESO 507- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100411,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100411,35.47,0.43,124,42126,75,NULL,'MAT, I, inv','ESO 507- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100412,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100412,35.47,0.2,124,42126,74.4,NULL,NULL,'ESO 507- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100413,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100413,35.48,0.45,125,42126,NULL,NULL,'K','ESO 507- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100414,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100414,35.48,0.46,125,42126,NULL,NULL,'J','ESO 507- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100415,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100415,37.7,0.46,346,42127,70,NULL,NULL,'SDSS J124741.16+660143.4',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000133,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,191.921625,66.02878,0.061,NULL,57319876814,895623075,13994110,17.9),(100416,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100416,37.82,0.12,367,42128,70,NULL,NULL,'2MASX J12474168+5458256',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,191.9234583,54.97364,0,NULL,57420154621,897189915,14018592,17.7),(100417,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100417,38.01,0.33,399,42129,70,NULL,NULL,'SDSS J124741.90+273051.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'19.41',0.12,NULL,NULL,NULL,NULL,NULL,1,191.924625,27.51442,0.042,NULL,58736439275,917756863,14339950,19.41),(100418,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100418,33.09,0.25,41.5,42130,74.4,NULL,NULL,'NGC 4683',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000057,NULL,'13.8',0.8,'SB(s)0-','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,191.9265417,-41.52828,0.469,NULL,46746779117,730418423,11412787,13.8),(100419,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100419,32.7,0.45,34.7,42130,NULL,NULL,'K','NGC 4683',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100420,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100420,33.41,0.4,48.2,42130,NULL,NULL,'mean','NGC 4683',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100421,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100421,36.62,0.69,210,42131,70,NULL,NULL,'2MASX J12474297-2117116',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.25',NULL,NULL,NULL,NULL,NULL,NULL,1,191.929167,-21.28683,0.117,NULL,43921557901,686274342,10723036,16.25),(100422,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100422,37.17,0.46,272,42132,70,NULL,NULL,'2MASX J12474401+3108447',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,191.9335417,31.14569,0.02,NULL,58780784525,918449758,14350777,17.5),(100423,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100423,38.16,0.19,428,42133,70,NULL,NULL,'2MASX J12474444-0010528',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000082,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,191.9352083,-0.18131,0,NULL,43101573517,673462086,10522845,17.8),(100424,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100424,38.12,0.33,421,42134,70,NULL,NULL,'SDSS J124745.31-000922.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000077,NULL,'18.4g',0.09,NULL,NULL,NULL,NULL,NULL,1,191.938833,-0.15617,0,NULL,43101528387,673461381,10522834,18.4),(100425,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100425,37.2,0.46,276,42135,70,NULL,NULL,'2MASX J12474540+5342577',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000168,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,191.938917,53.71597,0,NULL,57198384014,893724750,13964449,16.9),(100426,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100426,36.84,0.27,233,42136,70,NULL,NULL,'IC 0822',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.000103,NULL,'15.0g',0.64,NULL,NULL,NULL,NULL,NULL,1,191.939875,30.07719,0.016,NULL,58782584658,918477885,14351216,15),(100427,'Tully est','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100427,31.13,0.8,16.8,42137,75,NULL,'B','NGC 4689',NULL,'1988NBGC.C....0000T',1988,1,4.3,NULL,'G',0.000017,NULL,'11.6B',3.5,'SA(rs)bc;Sy    LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,191.939833333,13.76281,0.048,NULL,58872893187,919888956,14373264,11.6),(100428,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100428,30.84,0.35,14.7,42137,NULL,NULL,NULL,'NGC 4689',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100429,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100429,30.93,0.47,15.4,42137,NULL,NULL,'H','NGC 4689',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100430,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100430,30.98,0.62,15.7,42137,NULL,NULL,NULL,'NGC 4689',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100431,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100431,30.99,0.46,15.7,42137,NULL,NULL,'J','NGC 4689',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100432,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100432,31,0.45,15.8,42137,NULL,NULL,'K','NGC 4689',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100433,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100433,31.02,0.2,16,42137,74.4,NULL,NULL,'NGC 4689',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100434,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100434,31.12,0.58,16.7,42137,NULL,NULL,'Malmquist cor.','NGC 4689',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100435,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100435,31.44,0.7,19.4,42137,NULL,NULL,'HI','NGC 4689',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100436,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100436,31.48,0.92,19.8,42137,NULL,NULL,'CO','NGC 4689',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100437,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100437,31.74,0.3,22.3,42137,55,NULL,'B','NGC 4689',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100438,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100438,31.95,0.4,24.5,42137,NULL,NULL,'mean','NGC 4689',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100439,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100439,31.16,0.4,17.1,42138,75,NULL,'B','NGC 4688',NULL,'1988NBGC.C....0000T',1988,1,3.2,NULL,'G',0.000003,NULL,'12.62',2.8,'SB(s)cd;LINER  HII','Parent (of companion) galaxy',NULL,NULL,NULL,1,191.943833333,4.33606,0.013,NULL,58091491804,907679559,14182493,12.62),(100440,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100440,37.61,0.46,333,42139,70,NULL,NULL,'2MASX J12474705+1302296',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,191.945916667,13.04147,0.053,NULL,58991052689,921735198,14402112,17.1),(100441,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100441,36.86,0.62,236,42140,70,NULL,NULL,'2MASX J12474857-1519568',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.47',NULL,NULL,NULL,NULL,NULL,NULL,1,191.952416667,-15.3325,0.101,NULL,43933044763,686453824,10725841,16.47),(100442,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100442,38.4,0.46,479,42141,70,NULL,NULL,'SDSS J124748.98+382317.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000186,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,191.954125,38.38806,0,NULL,59086435260,923225550,14425399,17.9),(100443,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100443,37.12,0.46,265,42142,70,NULL,NULL,'2MASX J12475002+3945024',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,191.958583333,39.75075,0,NULL,59082330566,923161415,14424397,17.4),(100444,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100444,35.64,0.49,134,42143,70,NULL,NULL,'2MASX J12475244-1510348',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.79',NULL,NULL,NULL,NULL,NULL,NULL,1,191.9684583,-15.17642,0.101,NULL,43932372139,686443314,10725676,15.79),(100445,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100445,37.83,0.33,369,42144,70,NULL,NULL,'2MASX J12475285-0013305',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000076,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,191.97025,-0.22506,0,NULL,43101283873,673457560,10522774,17.1),(100446,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100446,34.43,0.49,77,42145,75,NULL,'IR','UGC 07963',NULL,'2011yCatp016004901K',2011,1,1.48,NULL,'G',0.000017,NULL,'15.8g',0.23,'Sd(f)',NULL,NULL,NULL,NULL,1,191.9707917,-1.18586,0.025,NULL,43104434023,673506781,10523543,15.8),(100447,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100447,34.7,NULL,87.1,42145,NULL,NULL,NULL,'UGC 07963',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100448,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100448,34.75,NULL,89.2,42145,NULL,NULL,'Dipole + Quadrupole','UGC 07963',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100449,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100449,34.75,NULL,89.2,42145,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07963',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100450,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100450,34.76,NULL,89.6,42145,NULL,NULL,'Dipole','UGC 07963',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100451,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100451,34.88,0.56,94.6,42145,NULL,NULL,'Malmquist cor.','UGC 07963',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100452,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100452,35.06,0.51,103,42145,NULL,NULL,NULL,'UGC 07963',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100453,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100453,35.1,0.2,105,42145,74.4,NULL,NULL,'UGC 07963',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100454,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100454,38.02,0.33,401,42146,70,NULL,NULL,'2MASX J12475325+2051291',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,191.971917,20.85811,0.124,NULL,58902518891,920351857,14380497,17.2),(100455,'IRAS','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100455,33.34,0.8,46.6,42147,75,NULL,'MAT, I','ESO 574- G 032',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000033,NULL,'15',0.6,'Sb',NULL,NULL,NULL,NULL,1,191.978083,-21.92847,0.137,NULL,43907494653,686054603,10719603,15),(100456,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100456,33.18,0.2,43.3,42147,74.4,NULL,NULL,'ESO 574- G 032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100457,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100457,33.31,0.49,45.8,42147,75,NULL,'IR','ESO 574- G 032',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100458,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100458,33.52,0.11,50.7,42147,NULL,NULL,NULL,'ESO 574- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100459,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100459,33.77,0.32,56.7,42147,85,NULL,'I, raw','ESO 574- G 032',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100460,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100460,33.79,0.32,57.3,42147,85,NULL,'I, inv','ESO 574- G 032',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100461,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100461,33.87,0.43,59.3,42147,75,NULL,'MAT, I, raw','ESO 574- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100462,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100462,34,0.43,63,42147,75,NULL,'MAT, I, inv','ESO 574- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100463,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100463,34.22,0.43,69.9,42147,75,NULL,'MAT, I, cor','ESO 574- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100464,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100464,38.06,0.14,409,42148,70,NULL,NULL,'2MASX J12475493+6236083',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,191.9792917,62.60239,0,NULL,57362473696,896288651,14004510,18.1),(100465,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100465,38.02,0.33,401,42149,70,NULL,NULL,'SDSS J124755.07+205006.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'19.21',0.16,NULL,NULL,NULL,NULL,NULL,1,191.9794583,20.83506,0.124,NULL,58902518342,920351849,14380497,19.21),(100466,'D-Sigma','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100466,34.86,0.4,93.8,42150,75,NULL,'Edat, raw','NGC 4692',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000031,NULL,'13.64',1.3,'E+:','Group member',NULL,NULL,NULL,1,191.9805,27.22236,0.038,NULL,58735605890,917743842,14339747,13.64),(100467,'D-Sigma','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100467,34.89,0.4,95,42150,75,NULL,'Edat, cor','NGC 4692',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100468,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100468,34.47,0.46,78.5,42150,70,NULL,NULL,'NGC 4692',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100469,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100469,34.91,0.25,95.9,42150,74.4,NULL,NULL,'NGC 4692',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100470,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100470,35.25,0.45,112,42150,NULL,NULL,'K','NGC 4692',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100471,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100471,35.36,0.4,118,42150,NULL,NULL,'mean','NGC 4692',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100472,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100472,38.16,0.19,428,42151,70,NULL,NULL,'2MASX J12475545-0018545',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000082,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,191.981,-0.315,0,NULL,43101274811,673457418,10522772,17.8),(100473,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100473,38.01,0.33,399,42152,70,NULL,NULL,'SDSS J124755.91+272922.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'19.84',0.13,NULL,NULL,NULL,NULL,NULL,1,191.983,27.48964,0.042,NULL,58736435208,917756800,14339950,19.84),(100474,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100474,38.27,0.46,451,42153,70,NULL,NULL,'2MASX J12475599+6505323',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,191.9835417,65.09214,0.033,NULL,57366013066,896343954,14005374,17.6),(100475,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100475,38.66,0.46,541,42154,70,NULL,NULL,'SDSS J124756.41+582850.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,191.985083333,58.48069,0,NULL,57438609237,897478269,14023097,18.3),(100476,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100476,38.02,0.46,401,42155,70,NULL,NULL,'2MASX J12475677+5643140',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,191.986667,56.72067,0,NULL,57431517344,897367458,14021366,18.3),(100477,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100477,38.23,0.46,443,42156,70,NULL,NULL,'2MASX J12475708+3536578',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000186,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,191.9879583,35.61592,0.023,NULL,58555614072,914931469,14295804,17.1),(100478,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100478,38.02,0.46,403,42157,70,NULL,NULL,'2MASX J12475723+3841254',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000149,NULL,'17.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,191.988583,38.69053,0,NULL,59086396453,923224944,14425389,17.2),(100479,'FP','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,'R',100479,37.17,0.46,271,42158,70,NULL,NULL,'2MASX J12475787+4120034',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,191.991,41.33425,0,NULL,59083241759,923175652,14424619,17.4),(100480,'IRAS','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100480,33.44,0.8,48.7,42159,75,NULL,'MAT, I','ESO 574- G 033',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000017,NULL,'13.71',1.3,'SB(rs)bc',NULL,NULL,NULL,NULL,1,191.9932083,-22.26844,0.217,NULL,43909256176,686082127,10720033,13.71),(100481,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100481,33.32,0.32,46.2,42159,85,NULL,'I, raw','ESO 574- G 033',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100482,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100482,33.37,0.45,47.3,42159,NULL,NULL,'K','ESO 574- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100483,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100483,33.38,0.46,47.3,42159,NULL,NULL,'J','ESO 574- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100484,'Tully-Fisher','2016-12-15 15:15:05','2016-12-16 11:20:17','1',NULL,NULL,100484,33.37,0.32,47.3,42159,85,NULL,'I, inv','ESO 574- G 033',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100485,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100485,33.47,0.43,49.4,42159,75,NULL,'MAT, I, raw','ESO 574- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100486,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100486,33.48,0.47,49.7,42159,NULL,NULL,'H','ESO 574- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100487,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100487,33.56,0.4,51.5,42159,NULL,NULL,'mean','ESO 574- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100488,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100488,33.7,0.43,55,42159,75,NULL,'MAT, I, inv','ESO 574- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100489,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100489,33.7,0.43,55.1,42159,75,NULL,'MAT, I, cor','ESO 574- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100490,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100490,33.78,0.06,57.1,42159,NULL,NULL,NULL,'ESO 574- G 033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100491,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100491,38.12,0.33,421,42160,70,NULL,NULL,'2MASXi J1247595-001132',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000073,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,191.9982083,-0.19239,0,NULL,43101285875,673457591,10522774,18.2),(100492,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100492,33.17,0.45,43.1,42161,NULL,NULL,'K','2MASX J12475956-4113108',NULL,'2007A&A...465...71T',2007,1,0.62,NULL,'G',0.000033,NULL,'15.82',0.38,'S0','Group member',NULL,NULL,NULL,1,191.999,-41.21972,0.469,NULL,46747522003,730430031,11412969,15.82),(100493,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100493,33.42,0.4,48.2,42161,NULL,NULL,'mean','2MASX J12475956-4113108',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100494,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100494,37.71,0.46,348,42162,70,NULL,NULL,'2MASX J12480010+4545343',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000182,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,192.000583,45.75939,0,NULL,59121267012,923769797,14433903,16.7),(100495,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100495,37.85,0.17,372,42163,70,NULL,NULL,'2MASX J12480065-0141575',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000074,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,192.002833333,-1.69944,0.005,NULL,43102541964,673477218,10523081,18.2),(100496,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100496,38.04,0.23,405,42164,70,NULL,NULL,'2MASX J12480123+0646419',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000186,NULL,'16.5g',0.38,NULL,NULL,NULL,NULL,NULL,1,192.005,6.77828,0.009,NULL,58073656465,907400882,14178138,16.5),(100497,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100497,38.16,0.46,429,42165,70,NULL,NULL,'SDSS J124801.48+065352.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000138,NULL,'18.5g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,192.0062083,6.89778,0.009,NULL,58073799178,907403112,14178173,18.5),(100498,'IRAS','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100498,33.71,0.8,55.2,42166,75,NULL,'MAT, I','ESO 322- G 085',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'15.18',0.4,'Sc? pec sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.008708333,-40.59464,0.457,NULL,46747051396,730422678,11412854,15.18),(100499,'IRAS','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100499,33.73,0.8,55.8,42166,75,NULL,'HMCL, I','ESO 322- G 085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100500,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100500,32.77,0.4,35.8,42166,75,NULL,'HMCL, I, inv','ESO 322- G 085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100501,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100501,32.77,0.32,35.8,42166,85,NULL,'I, inv','ESO 322- G 085',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100502,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100502,32.77,0.4,35.8,42166,75,NULL,'HMCL, I, raw','ESO 322- G 085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100503,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100503,32.78,0.32,35.9,42166,85,NULL,'I, raw','ESO 322- G 085',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100504,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100504,33.05,0.43,40.8,42166,75,NULL,'MAT, I, raw','ESO 322- G 085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100505,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100505,33.08,0.43,41.3,42166,75,NULL,'MAT, I, inv','ESO 322- G 085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100506,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100506,33.08,0.4,41.3,42166,75,NULL,'HMCL, I, cor','ESO 322- G 085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100507,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100507,33.3,0.43,45.8,42166,75,NULL,'MAT, I, cor','ESO 322- G 085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100508,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100508,33.39,0.12,47.7,42166,NULL,NULL,NULL,'ESO 322- G 085',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100509,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100509,37.85,0.17,372,42167,70,NULL,NULL,'2MASX J12480232-0139435',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000067,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,192.00975,-1.66219,0.005,NULL,43102543153,673477236,10523081,18),(100510,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100510,37.85,0.17,372,42168,70,NULL,NULL,'2MASX J12480265-0139105',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000106,NULL,'16.4g',0.39,'BrClG',NULL,NULL,NULL,NULL,1,192.011167,-1.65283,0.005,NULL,43102540500,673477195,10523081,16.4),(100511,'IRAS','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100511,33.44,0.8,48.7,42169,75,NULL,'MAT, I','NGC 4696C',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'14.64',0.3,'Sb: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.011083333,-40.81856,0.457,NULL,46747024371,730422255,11412847,14.64),(100512,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100512,32.72,0.43,35,42169,75,NULL,'MAT, I, raw','NGC 4696C',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100513,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100513,32.73,0.32,35.2,42169,85,NULL,'I, raw','NGC 4696C',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100514,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100514,32.76,0.32,35.7,42169,85,NULL,'I, inv','NGC 4696C',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100515,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100515,32.87,0.43,37.5,42169,75,NULL,'MAT, I, inv','NGC 4696C',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100516,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100516,33.07,0.49,41,42169,75,NULL,'IR','NGC 4696C',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100517,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100517,33.07,0.43,41.1,42169,75,NULL,'MAT, I, cor','NGC 4696C',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100518,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100518,33.42,0.14,48.4,42169,NULL,NULL,NULL,'NGC 4696C',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100519,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100519,37.58,0.33,328,42170,70,NULL,NULL,'2MASX J12480288+0028268',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000063,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,192.0120417,0.47408,0,NULL,58083077513,907548086,14180438,17.8),(100520,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100520,38.06,0.14,409,42171,70,NULL,NULL,'2MASX J12480305+6236332',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000179,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,192.012833,62.60931,0,NULL,57362476397,896288693,14004510,16.8),(100521,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100521,38.14,0.46,425,42172,70,NULL,NULL,'2MASX J12480394+1243581',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000183,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,192.0164583,12.73286,0.056,NULL,58989266314,921707286,14401676,16.7),(100522,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100522,37.91,0.46,381,42173,70,NULL,NULL,'SDSS J124804.43+450057.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000154,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,192.0185,45.01608,0.03,NULL,59121140864,923767826,14433872,18.7),(100523,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100523,33.06,0.47,41,42174,NULL,NULL,'H','ESO 507- G 013',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000017,NULL,'14.86',0.4,'SB(r?)b?       HII',NULL,NULL,NULL,NULL,1,192.0225417,-27.57767,0.341,NULL,43433751665,678652369,10603943,14.86),(100524,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100524,33.06,0.45,41,42174,NULL,NULL,'K','ESO 507- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100525,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100525,33.17,0.46,43.1,42174,NULL,NULL,'J','ESO 507- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100526,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100526,33.4,0.4,47.9,42174,NULL,NULL,'mean','ESO 507- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100527,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100527,33.45,0.2,49,42174,74.4,NULL,NULL,'ESO 507- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100528,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100528,33.64,0.49,53.6,42174,75,NULL,'IR','ESO 507- G 013',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100529,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100529,36.61,0.46,210,42175,70,NULL,NULL,'MRK 0443',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.00012,NULL,'16.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,192.026917,33.3555,0.028,NULL,58753702063,918026594,14344165,16.1),(100530,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100530,38.04,0.23,405,42176,70,NULL,NULL,'SDSS J124807.77+063937.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,192.032417,6.66036,0,NULL,58073650096,907400782,14178137,17.7),(100531,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100531,38.32,0.46,462,42177,70,NULL,NULL,'SDSS J124808.22+362109.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000155,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,192.03425,36.35258,0.034,NULL,58555854244,914935222,14295862,18.2),(100532,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100532,37.85,0.17,372,42178,70,NULL,NULL,'2MASXi J1248089-013851',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000068,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,192.0372083,-1.64775,0.005,NULL,43102072514,673469883,10522966,18.1),(100533,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100533,37.82,0.12,367,42179,70,NULL,NULL,'2MASX J12480936+5502421',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000177,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,192.038833,55.045,0,NULL,57429328273,897333254,14020832,17.7),(100534,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100534,37.85,0.17,372,42180,70,NULL,NULL,'2MASX J12481025-0144495',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00008,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,192.0427083,-1.747,0.005,NULL,43102061184,673469706,10522964,17.6),(100535,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100535,38.16,0.19,428,42181,70,NULL,NULL,'2MASX J12481131-0017525',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000077,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,192.04725,-0.29778,0,NULL,43101391480,673459241,10522800,17.8),(100536,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100536,37.82,0.12,367,42182,70,NULL,NULL,'2MASX J12481134+5456491',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,192.0472917,54.94708,0,NULL,57420875737,897201183,14018768,17.8),(100537,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100537,38.44,0.46,488,42183,70,NULL,NULL,'2MASX J12481137+0153128',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000087,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,192.0475,1.88706,0,NULL,58085435323,907584926,14181014,18),(100538,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100538,37.29,0.33,288,42184,70,NULL,NULL,'2MASX J12481225-0121365',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000069,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,192.050917,-1.36033,0.037,NULL,43104666996,673510421,10523600,17.2),(100539,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100539,37.12,0.53,265,42185,70,NULL,NULL,'2MASX J12481255-2142531',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,192.0522917,-21.71481,0.137,NULL,43907472843,686054263,10719597,15.4),(100540,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100540,37.73,0.33,351,42186,70,NULL,NULL,'2MASX J12481276+0214488',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000095,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,192.053,2.24694,0,NULL,58097280086,907770001,14183906,16.9),(100541,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100541,38.39,0.46,477,42187,70,NULL,NULL,'2MASX J12481324+6302461',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000133,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,192.055291667,63.04625,0,NULL,57376190025,896502969,14007858,17.6),(100542,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100542,37.83,0.33,369,42188,70,NULL,NULL,'SDSS J124813.53-001347.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000066,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,192.056417,-0.22989,0,NULL,43101281008,673457515,10522773,18.2),(100543,'Tully est','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100543,31.76,0.8,22.5,42189,75,NULL,'B','NGC 4691',NULL,'1988NBGC.C....0000T',1988,1,2.52,NULL,'G',0.000023,NULL,'12.0g',1.46,'(R)SB(s)0/a pecHII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.056791667,-3.33272,0.021,NULL,43107776360,673559005,10524359,12),(100544,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100544,37.41,0.46,303,42190,70,NULL,NULL,'2MASX J12481382+0020218',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000083,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,192.0575417,0.33956,0,NULL,58083193983,907549905,14180467,17.5),(100545,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100545,38.01,0.46,400,42191,70,NULL,NULL,'LCRS B124540.6-022803',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000091,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,192.0624583,-2.74028,0.017,NULL,43116275229,673691800,10526434,17.6),(100546,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100546,29.96,0.45,9.81,42192,NULL,NULL,'K','NGC 4694',NULL,'2007A&A...465...71T',2007,1,3.2,NULL,'G',0.000008,NULL,'12.06',1.5,'SB0 pec        HII','in a radial-velocity based grouping',NULL,NULL,'H II',1,192.062833,10.98361,0,NULL,58066098970,907282796,14176293,12.06),(100547,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100547,30.6,0.2,13.2,42192,NULL,NULL,'stellar kinematics','NGC 4694',NULL,'2008ApJ...683...78C',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100548,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100548,31.13,0.4,16.8,42192,75,NULL,'B','NGC 4694',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100549,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100549,31.66,0.4,21.4,42192,NULL,NULL,'mean','NGC 4694',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100550,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100550,38.04,0.23,405,42193,70,NULL,NULL,'2MASX J12481573+0649040',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.22',0.19,NULL,NULL,NULL,NULL,NULL,1,192.0655,6.81769,0,NULL,58073751640,907402369,14178162,18.22),(100551,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100551,37.58,0.33,328,42194,70,NULL,NULL,'2MASX J12481668+0029398',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000089,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,192.069375,0.4945,0,NULL,58083111185,907548612,14180447,16.7),(100552,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100552,37.42,0.27,305,42195,70,NULL,NULL,'2MASX J12481691-0051295',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000087,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,192.0704583,-0.85811,0.013,NULL,43104658751,673510292,10523598,17.3),(100553,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100553,37.33,0.46,292,42196,70,NULL,NULL,'2MASX J12481691+6623269',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000071,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,192.070625,66.39086,0.049,NULL,57852610740,903947042,14124172,17),(100554,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100554,38.16,0.19,428,42197,70,NULL,NULL,'2MASX J12481705-0015395',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000103,NULL,'16.2g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,192.071083333,-0.26106,0,NULL,43101398111,673459345,10522802,16.2),(100555,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100555,38.13,0.33,422,42198,70,NULL,NULL,'2MASX J12481816+6402221',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000165,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,192.075625,64.03958,0.033,NULL,57369559660,896399369,14006240,17.3),(100556,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100556,37.42,0.27,305,42199,70,NULL,NULL,'2MASX J12481858-0041495',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000074,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,192.0775417,-0.69714,0.014,NULL,43104155854,673502435,10523475,17.4),(100557,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100557,37.84,0.23,369,42200,70,NULL,NULL,'2MASX J12481888+5007022',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000195,NULL,'16.0g',0.38,'E0',NULL,NULL,NULL,NULL,1,192.078833,50.11744,0,NULL,57203537277,893805269,13965707,16),(100558,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100558,32.47,0.25,31.2,42201,74.4,NULL,NULL,'ESO 507- G 014',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.000057,NULL,'13.85',0.8,'(R\')SB(r)0^0^:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.085,-26.46456,0.281,NULL,43422110055,678470469,10601101,13.85),(100559,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100559,32.8,0.45,36.2,42201,NULL,NULL,'K','ESO 507- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100560,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100560,33.44,0.4,48.6,42201,NULL,NULL,'mean','ESO 507- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100561,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100561,34.61,0.5,83.6,42202,NULL,NULL,'Malmquist cor.','ESO 574- G 034',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'15.38',0.3,'SA(s)bc: sp    HII',NULL,NULL,NULL,NULL,1,192.086,-20.29256,0.073,NULL,43913288251,686145128,10721017,15.38),(100562,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100562,34.73,0.2,88.3,42202,74.4,NULL,NULL,'ESO 574- G 034',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100563,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100563,34.79,0.49,90.7,42202,75,NULL,'IR','ESO 574- G 034',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100564,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100564,34.79,0.46,90.8,42202,NULL,NULL,NULL,'ESO 574- G 034',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100565,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100565,34.9,0.4,95.7,42202,NULL,NULL,'mean','ESO 574- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100566,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100566,34.93,0.47,97,42202,NULL,NULL,'H','ESO 574- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100567,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100567,35.05,0.45,102,42202,NULL,NULL,'K','ESO 574- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100568,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100568,35.12,0.46,106,42202,NULL,NULL,'J','ESO 574- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100569,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100569,38.53,0.46,508,42203,70,NULL,NULL,'2MASX J12482116+2649011',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.24,'E',NULL,NULL,NULL,NULL,1,192.088125,26.81697,0.026,NULL,58735678020,917744969,14339765,17.4),(100570,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100570,32.78,0.67,36,42204,NULL,NULL,'I','NGC 4696D',NULL,'2001ApJ...546..681T',2001,1,1.7,NULL,'G',0.000073,NULL,'13.99',0.3,'SB(r)0^0^ pec sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.09025,-41.71403,0.469,NULL,46746815784,730418996,11412796,13.99),(100571,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100571,32.78,0.67,36,42204,NULL,NULL,NULL,'NGC 4696D',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100572,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100572,32.82,0.14,36.6,42204,74.4,NULL,NULL,'NGC 4696D',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100573,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100573,33.4,0.67,47.8,42204,NULL,NULL,'Malmquist cor.','NGC 4696D',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100574,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100574,32.93,0.4,38.6,42204,75,NULL,'Edat, raw','NGC 4696D',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100575,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100575,32.95,0.4,38.9,42204,75,NULL,'Edat, cor','NGC 4696D',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100576,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100576,32.3,0.49,28.8,42204,70,NULL,NULL,'NGC 4696D',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100577,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100577,32.51,0.41,31.8,42204,NULL,NULL,NULL,'NGC 4696D',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100578,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100578,32.92,0.41,38.4,42204,NULL,NULL,'Malmquist cor.','NGC 4696D',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100579,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100579,33.02,0.4,40.1,42204,NULL,NULL,'mean','NGC 4696D',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100580,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100580,33.1,0.45,41.7,42204,NULL,NULL,'K','NGC 4696D',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100581,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100581,37.38,0.46,299,42205,70,NULL,NULL,'2MASX J12482178+4926232',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000168,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,192.090791667,49.43983,0,NULL,59097007099,923390735,14427980,16.5),(100582,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100582,37.24,0.46,281,42206,70,NULL,NULL,'2MASX J12482186+0816040',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000185,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,192.091125,8.26792,0,NULL,58080875332,907513677,14179901,17.1),(100583,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100583,35.69,0.58,138,42207,70,NULL,NULL,'2MASX J12482214-1701171',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000147,NULL,'15.43',NULL,NULL,NULL,NULL,NULL,NULL,1,192.092333,-17.02144,0.057,NULL,43932121406,686439396,10725615,15.43),(100584,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100584,32.93,0.4,38.6,42208,75,NULL,'Edat, raw','ESO 322- G 089',NULL,'1997ApJS..109..333W',1997,1,0.6,NULL,'G',0.000043,NULL,'14.92',0.6,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.095125,-41.12353,0.457,NULL,46747493689,730429588,11412962,14.92),(100585,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100585,32.95,0.4,38.9,42208,75,NULL,'Edat, cor','ESO 322- G 089',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100586,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100586,33.51,0.23,50.4,42208,74.4,NULL,NULL,'ESO 322- G 089',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100587,'IRAS','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100587,31.09,0.8,16.5,42209,75,NULL,'A82, H','NGC 4698',NULL,'1997ApJS..109..333W',1997,1,4,NULL,'G',0.000002,NULL,'11.46',2.5,'SA(s)ab;Sy2    LINER','in a radial-velocity based grouping',NULL,NULL,'unobscured Seyfert 2',1,192.0954583,8.48739,0,NULL,58080780104,907512189,14179877,11.46),(100588,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100588,28.9,0.69,6.04,42209,100,NULL,'mid-IR','NGC 4698',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100589,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100589,30.57,0.92,13,42209,NULL,NULL,'CO','NGC 4698',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100590,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100590,30.88,0.7,15,42209,NULL,NULL,'HI','NGC 4698',NULL,'1997A&A...323...14S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100591,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100591,30.99,NULL,15.8,42209,84,NULL,'RSA Hubble type','NGC 4698',NULL,'1986AJ.....91.1286S',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100592,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100592,31.13,0.4,16.8,42209,75,NULL,'B','NGC 4698',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100593,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100593,31.28,0.42,18,42209,65,NULL,NULL,'NGC 4698',NULL,'1980ApJ...238..458M',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100594,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100594,31.41,NULL,19.1,42209,84,NULL,'RC2 Hubble type','NGC 4698',NULL,'1986AJ.....91.1286S',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100595,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100595,31.53,NULL,20.2,42209,NULL,NULL,NULL,'NGC 4698',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100596,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100596,31.87,0.35,23.7,42209,NULL,NULL,NULL,'NGC 4698',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100597,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100597,31.88,0.52,23.8,42209,NULL,NULL,'Malmquist cor.','NGC 4698',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100598,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100598,31.99,NULL,25,42209,NULL,NULL,'B','NGC 4698',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100599,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100599,32.18,0.2,27.3,42209,74.4,NULL,NULL,'NGC 4698',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100600,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100600,32.27,0.44,28.4,42209,NULL,NULL,NULL,'NGC 4698',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100601,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100601,32.27,0.43,28.4,42209,75,NULL,'3.6 micron, color corrected','NGC 4698',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100602,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100602,32.33,0.47,29.3,42209,75,NULL,'A82, H, raw','NGC 4698',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100603,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100603,32.35,0.3,29.5,42209,55,NULL,'B','NGC 4698',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100604,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100604,32.4,0.47,30.2,42209,75,NULL,'A82, H, cor','NGC 4698',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100605,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100605,32.42,0.43,30.5,42209,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4698',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100606,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100606,32.57,0.47,32.6,42209,75,NULL,'A82, H, inv','NGC 4698',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100607,'TRGB','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100607,29.07,0.1,6.53,42210,74.4,NULL,NULL,'NGC 4707',NULL,'2013AJ....146...86T',2013,1,2.2,'The 2MASS position refers to a superposed star.','G',0.000003,NULL,'13.4',2.1,'Sm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.0952917,51.16469,0.019,NULL,57205078246,893829347,13966083,13.4),(100608,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100608,28.82,NULL,5.81,42210,NULL,NULL,NULL,'NGC 4707',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100609,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100609,29.52,0.4,8,42210,75,NULL,'B','NGC 4707',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100610,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100610,37.3,0.33,288,42211,70,NULL,NULL,'2MASX J12482318+0555190',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000165,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,192.0965417,5.92206,0,NULL,58071110660,907361104,14177517,17),(100611,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100611,37.73,0.33,351,42212,70,NULL,NULL,'SDSS J124823.68+021645.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000065,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,192.098667,2.27922,0,NULL,58097325780,907770715,14183917,18.7),(100612,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100612,37.29,0.33,288,42213,70,NULL,NULL,'2MASX J12482379-0122393',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00008,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,192.099167,-1.37764,0.037,NULL,43103958312,673499348,10523427,17.1),(100613,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100613,36.19,0.46,173,42214,70,NULL,NULL,'2MASX J12482473+4509493',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000151,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,192.1032083,45.16378,0.03,NULL,59121652174,923775815,14433997,16.9),(100614,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100614,37.3,0.33,288,42215,70,NULL,NULL,'2MASX J12482506+0551020',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000174,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,192.1044583,5.85044,0,NULL,58071070328,907360473,14177507,16.6),(100615,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100615,34.21,NULL,69.5,42216,NULL,NULL,NULL,'NGC 4696E',NULL,'1993MNRAS.263..211R',1993,1,1.8,NULL,'G',0.00015,NULL,'14.52',0.7,'SB(s)0^0^','Group member',NULL,NULL,NULL,1,192.108833,-40.9365,0.457,NULL,46746970663,730421416,11412834,14.52),(100616,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100616,37.81,0.46,365,42217,70,NULL,NULL,'2MASX J12482692+5813070',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,192.1125,58.21878,0,NULL,57438755071,897480547,14023133,17.8),(100617,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100617,37.13,0.46,266,42218,70,NULL,NULL,'2MASX J12482708+0444140',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000178,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,192.113,4.73708,0,NULL,58091996520,907687445,14182616,17),(100618,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100618,38.06,0.14,409,42219,70,NULL,NULL,'2MASX J12482773+6238391',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,192.115375,62.64414,0.013,NULL,57362478630,896288728,14004511,17.8),(100619,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100619,37.52,0.58,319,42220,70,NULL,NULL,'2MASX J12482769-2141111',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,192.115417,-21.68636,0.137,NULL,43907964971,686061952,10719718,15.1),(100620,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100620,30.71,0.4,13.9,42221,NULL,NULL,NULL,'HIPASS J1248-08',NULL,'2013MNRAS.429.2677K',2013,1,NULL,NULL,'G',0.000007,NULL,NULL,NULL,'Sc',NULL,NULL,NULL,NULL,1,192.116667,-8.03028,0.129,NULL,43126956851,673858700,10529042,NULL),(100621,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100621,38.13,0.46,424,42222,70,NULL,NULL,'2MASX J12482825+2210316',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,192.1177917,22.17567,0.15,NULL,58890794643,920168666,14377635,18.1),(100622,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100622,35.03,0.49,101,42223,75,NULL,'IR','CGCG 043-032',NULL,'2011yCatp016004901K',2011,1,0.79,NULL,'G',0.000017,NULL,'16.4g',0.18,'Sd(f)',NULL,NULL,NULL,NULL,1,192.117875,3.44042,0.036,NULL,58092494767,907695230,14182737,16.4),(100623,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100623,36.59,0.46,208,42224,70,NULL,NULL,'2MASX J12482869+4217513',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000093,NULL,'15.6g',0.45,'E',NULL,NULL,NULL,NULL,1,192.1197917,42.29769,0,NULL,59115601442,923681272,14432519,15.6),(100624,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100624,37.11,0.46,264,42225,70,NULL,NULL,'2MASX J12482908+0542060',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000132,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,192.121167,5.70169,0,NULL,58099645173,907806955,14184483,17.7),(100625,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100625,37.59,0.27,330,42226,70,NULL,NULL,'SDSS J124829.25+301343.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000162,NULL,'19.65',0.17,NULL,NULL,NULL,NULL,NULL,1,192.121916667,30.22869,0.025,NULL,58782963505,918483804,14351309,19.65),(100626,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100626,38.04,0.23,405,42227,70,NULL,NULL,'SDSS J124829.52+064432.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000153,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,192.123041667,6.74242,0,NULL,58073633961,907400530,14178133,18.5),(100627,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100627,38.06,0.14,409,42228,70,NULL,NULL,'2MASX J12483059+6242461',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,192.127583,62.71264,0.013,NULL,57362471270,896288613,14004509,17.8),(100628,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100628,38.28,0.33,453,42229,70,NULL,NULL,'2MASX J12483082+6415061',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,192.1284583,64.25158,0.017,NULL,57369586706,896399792,14006246,17.6),(100629,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100629,33.52,0.23,50.6,42230,74.4,NULL,NULL,'2MASX J12483106-4118226',NULL,'2013AJ....146...86T',2013,1,1.03,NULL,'G',0.000033,NULL,'15.90',0.68,'dE','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.129333333,-41.30669,0.469,NULL,46746692104,730417064,11412766,15.9),(100630,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100630,38.21,0.46,438,42231,70,NULL,NULL,'SDSS J124832.41+462923.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000138,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,192.135125,46.48981,0,NULL,59113416190,923647127,14431986,18.1),(100631,'Tully est','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100631,33.12,0.8,42,42232,75,NULL,NULL,'ESO 268- G 043',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000025,NULL,'15.63',1.2,'Dwarf',NULL,NULL,NULL,NULL,1,192.137083,-45.62817,0.493,NULL,46772348502,730817945,11419030,15.63),(100632,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100632,37.42,0.27,305,42233,70,NULL,NULL,'2MASX J12483273-0102153',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000092,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,192.136417,-1.03764,0.037,NULL,43104836806,673513075,10523641,16.6),(100633,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 1996ck','R',100633,42.21,NULL,1670,42234,65,NULL,'SALT','H-ZSNS J124835.19-004603.0',0.656,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,'E/S0',NULL,NULL,NULL,NULL,1,192.146625,-0.7675,0.014,NULL,43104656880,673510263,10523597,NULL),(100634,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 1996ck',NULL,100634,42.44,0.64,1860,42234,74.2,NULL,'SALT 2','H-ZSNS J124835.19-004603.0',0.656,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100635,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 1996ck',NULL,100635,43.18,0.53,2610,42234,70,NULL,'SALT','H-ZSNS J124835.19-004603.0',0.656,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100636,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 1996ck',NULL,100636,43.39,0.5,2870,42234,65,NULL,'SALT','H-ZSNS J124835.19-004603.0',0.656,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100637,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100637,37.12,0.2,265,42235,74.4,NULL,NULL,'VCC 2077',NULL,'2013AJ....146...86T',2013,1,0.59,NULL,'G',0.000037,NULL,'15.6g',0.41,'Sab:','Group member',NULL,NULL,NULL,1,192.148417,10.87508,0,NULL,58066140241,907283441,14176303,15.6),(100638,'PNLF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100638,29.89,0.07,9.51,42236,NULL,NULL,NULL,'NGC 4697',NULL,'2002ApJ...577...31C',2002,1,7.2,NULL,'G',0.000008,NULL,'10.14',4.7,'E6             LLAGN','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.1495,-5.80075,0.037,NULL,43126689662,673854525,10528976,10.14),(100639,'PNLF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100639,30.1,0.1,10.5,42236,NULL,NULL,'531 PNe','NGC 4697',NULL,'2001ApJ...563..135M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100640,'PNLF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100640,30.22,NULL,11.1,42236,NULL,NULL,'320 PNe','NGC 4697',NULL,'2006AJ....131..837S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100641,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100641,30.35,0.14,11.7,42236,NULL,NULL,'I','NGC 4697',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100642,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100642,30.35,0.14,11.7,42236,NULL,NULL,NULL,'NGC 4697',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100643,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100643,30.39,0.14,12,42236,NULL,NULL,'Malmquist cor.','NGC 4697',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100644,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100644,30.47,0.14,12.4,42236,74.4,NULL,NULL,'NGC 4697',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100645,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100645,30.49,0.07,12.5,42236,NULL,NULL,'HST ACS VCS','NGC 4697',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100646,'GC radius','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100646,30.06,0.04,10.3,42236,NULL,NULL,NULL,'NGC 4697',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100647,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100647,29.69,0.4,8.67,42236,75,NULL,'Edat, raw','NGC 4697',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100648,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100648,30.03,0.4,10.1,42236,75,NULL,'Edat, cor','NGC 4697',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100649,'Faber-Jackson','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100649,29.46,0.35,7.8,42236,95,NULL,'de Vaucouleurs','NGC 4697',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100650,'Faber-Jackson','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100650,29.62,0.25,8.39,42236,95,NULL,'Weighted Mean','NGC 4697',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100651,'Faber-Jackson','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100651,29.77,0.63,8.99,42236,95,NULL,'Michard 1979b, c','NGC 4697',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100652,'Faber-Jackson','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100652,30.07,NULL,10.3,42236,NULL,NULL,'LEDA [April 2006]','NGC 4697',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100653,'Faber-Jackson','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100653,30.21,0.81,11,42236,55,NULL,'Visvanathan & Sandage 1979','NGC 4697',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100654,'Faber-Jackson','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100654,30.32,0.46,11.6,42236,95,NULL,'Michard 1979a','NGC 4697',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100655,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100655,29.84,0.41,9.28,42236,NULL,NULL,NULL,'NGC 4697',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100656,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100656,30.18,0.41,10.8,42236,NULL,NULL,'Malmquist cor.','NGC 4697',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100657,'Tertiary','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100657,30.81,0.21,14.5,42236,95,NULL,NULL,'NGC 4697',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100658,'Tully est','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100658,31.84,0.8,23.3,42236,75,NULL,'B','NGC 4697',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100659,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100659,30.45,0.45,12.3,42236,NULL,NULL,'K','NGC 4697',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100660,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100660,31.61,0.4,20.9,42236,NULL,NULL,'mean','NGC 4697',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100661,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100661,33.73,0.44,55.7,42237,NULL,NULL,'I','CCC 058',NULL,'2003A&A...410..445M',2003,1,NULL,NULL,'G',0.000193,NULL,'17.94',NULL,'dE','Group member',NULL,NULL,NULL,1,192.15025,-41.43983,0.469,NULL,46746684990,730416952,11412764,17.94),(100662,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100662,37.75,0.46,354,42238,70,NULL,NULL,'SDSS J124838.20+105329.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.82',0.14,NULL,NULL,NULL,NULL,NULL,1,192.1592083,10.89158,0,NULL,58066138847,907283419,14176303,18.82),(100663,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100663,36.29,0.61,181,42239,70,NULL,NULL,'2MASX J12483891-2025043',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000183,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,192.162083,-20.41781,0.073,NULL,43913139348,686142802,10720981,15),(100664,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100664,37.59,0.27,330,42240,70,NULL,NULL,'2MASX J12483937+3009055',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,192.164125,30.1515,0.032,NULL,58782454619,918475853,14351185,17.1),(100665,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100665,38.17,0.23,431,42241,70,NULL,NULL,'SDSS J124839.55+015902.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000073,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,192.1647917,1.98392,0,NULL,58085417631,907584650,14181010,18.5),(100666,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100666,33.23,0.32,44.2,42242,NULL,NULL,'I','CCC 061',NULL,'2003A&A...410..445M',2003,1,0.73,NULL,'G',0.000063,NULL,'16.91',0.33,'dE','Group member',NULL,NULL,NULL,1,192.165375,-41.26822,0.469,NULL,46746691695,730417057,11412766,16.91),(100667,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100667,38.06,0.14,409,42243,70,NULL,NULL,'2MASX J12483992+6237031',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000167,NULL,'16.3g',0.4,'BrClG',NULL,NULL,NULL,NULL,1,192.1665417,62.6175,0.013,NULL,57362474016,896288656,14004510,16.3),(100668,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100668,37.87,0.46,375,42244,70,NULL,NULL,'2MASX J12484008+5437266',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00015,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,192.166875,54.62403,0,NULL,57421012358,897203318,14018801,17.4),(100669,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100669,37.4,0.33,302,42245,70,NULL,NULL,'2MASX J12484072+1527398',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000151,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,192.169708333,15.46117,0.03,NULL,58998728567,921855133,14403986,17.3),(100670,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100670,34.1,0.43,66.1,42246,75,NULL,'3.6 micron, color + selection bias corrected','KUG 1246+266',NULL,'2014MNRAS.444..527S',2014,1,0.8,NULL,'G',0.000045,NULL,'15.7',0.2,'Sc(sp)',NULL,NULL,NULL,NULL,1,192.17525,26.41722,0.021,NULL,58721596293,917524942,14336327,15.7),(100671,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100671,34.32,0.43,73,42246,75,NULL,'3.6 micron, color corrected','KUG 1246+266',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100672,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100672,34.53,0.49,80.4,42246,75,NULL,'IR','KUG 1246+266',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100673,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100673,34.58,0.2,82.4,42246,74.4,NULL,NULL,'KUG 1246+266',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100674,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100674,35.08,0.14,104,42246,NULL,NULL,NULL,'KUG 1246+266',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100675,'IRAS','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100675,33.29,0.8,45.6,42247,75,NULL,'MAT, I','ESO 268- G 044',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000027,NULL,'14.40',0.6,'Sb:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.17575,-45.00814,0.357,NULL,46772528467,730820757,11419074,14.4),(100676,'IRAS','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100676,33.32,0.8,46.1,42247,75,NULL,'HMCL, I','ESO 268- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100677,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100677,32.88,0.38,37.7,42247,NULL,NULL,NULL,'ESO 268- G 044',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100678,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100678,33.04,0.32,40.6,42247,85,NULL,'I, raw','ESO 268- G 044',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100679,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100679,33.06,0.32,40.9,42247,85,NULL,'I, inv','ESO 268- G 044',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100680,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100680,33.35,0.4,46.7,42247,75,NULL,'HMCL, I, raw','ESO 268- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100681,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100681,33.37,0.43,47.2,42247,75,NULL,'MAT, I, raw','ESO 268- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100682,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100682,33.39,0.1,47.7,42247,NULL,NULL,NULL,'ESO 268- G 044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100683,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100683,33.46,0.4,49.2,42247,75,NULL,'HMCL, I, inv','ESO 268- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100684,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100684,33.47,0.4,49.4,42247,NULL,NULL,'mean','ESO 268- G 044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100685,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100685,33.5,0.4,50.1,42247,75,NULL,'HMCL, I, cor','ESO 268- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100686,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100686,33.5,0.47,50.1,42247,NULL,NULL,'H','ESO 268- G 044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100687,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100687,33.5,0.43,50.1,42247,75,NULL,'MAT, I, inv','ESO 268- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100688,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100688,33.54,0.43,51.1,42247,75,NULL,'MAT, I, cor','ESO 268- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100689,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100689,33.58,0.45,52.1,42247,NULL,NULL,'K','ESO 268- G 044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100690,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100690,33.6,0.46,52.4,42247,NULL,NULL,'J','ESO 268- G 044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100691,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100691,36.73,0.46,222,42248,70,NULL,NULL,'2MASX J12484221+1316299',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000205,NULL,'15.9g',0.42,NULL,NULL,NULL,NULL,NULL,1,192.176083,13.27483,0.029,NULL,58991311492,921739242,14402175,15.9),(100692,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100692,34.99,0.46,99.5,42249,70,NULL,NULL,'2MASX J12484263+4746305',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000169,NULL,'15.6g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,192.177625,47.77508,0,NULL,59095348958,923364827,14427575,15.6),(100693,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100693,37.82,0.12,367,42250,70,NULL,NULL,'SDSS J124842.88+550352.4',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,192.178667,55.06458,0,NULL,57428804803,897325075,14020704,17.5),(100694,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100694,36.85,0.46,235,42251,70,NULL,NULL,'2MASX J12484308+0532490',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.52',0.19,NULL,NULL,NULL,NULL,NULL,1,192.1795417,5.54697,0,NULL,58100375572,907818368,14184662,17.52),(100695,'Tully est','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100695,31.94,0.8,24.5,42252,75,NULL,NULL,'DDO 148',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000023,NULL,'15',1.9,'IB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.179583,-5.25389,0.057,NULL,43135100712,673985948,10531030,15),(100696,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100696,29.77,NULL,8.99,42252,NULL,NULL,NULL,'DDO 148',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100697,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100697,29.77,0.4,9,42252,NULL,NULL,NULL,'DDO 148',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100698,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100698,32.54,0.45,32.2,42253,NULL,NULL,'K','2MASX J12484344-4138376',NULL,'2007A&A...465...71T',2007,1,0.91,NULL,'G',0.000063,NULL,'15.37',0.58,'S0','Group member',NULL,NULL,NULL,1,192.180375,-41.64364,0.469,NULL,46746807023,730418859,11412794,15.37),(100699,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100699,32.8,0.4,36.3,42253,NULL,NULL,'mean','2MASX J12484344-4138376',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100700,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100700,37.36,0.46,296,42254,70,NULL,NULL,'2MASXi J1248447+461408',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000169,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,192.1865,46.2355,0,NULL,59113335149,923645861,14431966,18),(100701,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100701,37.57,0.11,326,42255,70,NULL,NULL,'2MASX J12484527-0144583',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000065,NULL,'17.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,192.1885417,-1.74961,0,NULL,43102182940,673471608,10522993,17.7),(100702,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100702,33.83,0.47,58.4,42256,NULL,NULL,'H','NGC 4711',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00003,NULL,'14.22',0.9,'Sb:','in a radial-velocity based grouping',NULL,NULL,NULL,1,192.191125,35.33269,0.034,NULL,58555011635,914922056,14295657,14.22),(100703,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100703,33.96,0.45,62.1,42256,NULL,NULL,'K','NGC 4711',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100704,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100704,33.97,0.4,62.2,42256,NULL,NULL,'mean','NGC 4711',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100705,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100705,33.97,0.46,62.3,42256,NULL,NULL,'J','NGC 4711',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100706,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100706,36.82,0.46,231,42257,70,NULL,NULL,'2MASX J12484620+0907049',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.82',0.22,NULL,NULL,NULL,NULL,NULL,1,192.1925417,9.11806,0,NULL,58067824399,907309756,14176714,16.82),(100707,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 1998ab',NULL,100707,34.35,0.22,72.2,42258,74.2,NULL,'SALT 2','NGC 4704',0.02713,'2010ApJ...716..712A',2010,1,1,NULL,'G',0.00006,NULL,'14.52',0.9,'Sbc pec;HII    Sy2',NULL,NULL,NULL,'Sy 2',1,192.1934583,41.92125,0,NULL,59083122241,923173785,14424590,14.52),(100708,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 1998ab',NULL,100708,34.85,0.04,90.9,42258,72,NULL,NULL,'NGC 4704',0.02713,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100709,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 1998ab',NULL,100709,34.86,0.08,93.8,42258,74.4,NULL,NULL,'NGC 4704',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100710,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 1998ab',NULL,100710,34.96,0.16,95.4,42258,73.8,NULL,'SALT 2 (SNANA)','NGC 4704',0.0277,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100711,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 1998ab',NULL,100711,35.03,0.27,98.7,42258,70,NULL,'SALT','NGC 4704',0.02713,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100712,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 1998ab',NULL,100712,35.08,0.07,101,42258,65,NULL,'SALT2','NGC 4704',0.02713,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100713,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 1998ab',NULL,100713,35.1,0.2,102,42258,72,NULL,NULL,'NGC 4704',0.02713,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100714,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 1998ab',NULL,100714,35.15,0.08,104,42258,70,NULL,NULL,'NGC 4704',0.02713,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100715,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 1998ab',NULL,100715,35.21,0.1,105,42258,65,NULL,'MLCS2k2','NGC 4704',0.02713,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100716,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 1998ab',NULL,100716,35.17,0.16,105,42258,65,NULL,'MLCS31','NGC 4704',0.02713,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100717,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 1998ab',NULL,100717,35.17,0.28,105,42258,65,NULL,'SALT','NGC 4704',0.02713,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100718,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 1998ab',NULL,100718,35.18,0.1,106,42258,65,NULL,'MLCS2k2','NGC 4704',0.02713,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100719,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 1998ab',NULL,100719,35.2,0.07,107,42258,65,NULL,'MLCS2k2','NGC 4704',0.02713,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100720,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 1998ab',NULL,100720,35.27,0.16,110,42258,65,NULL,'MLCS17','NGC 4704',0.02713,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100721,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 1998ab',NULL,100721,35.28,0.19,111,42258,65,NULL,'SALT2','NGC 4704',0.02713,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100722,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 1998ab',NULL,100722,35.36,0.02,115,42258,65,NULL,'SALT','NGC 4704',0.02713,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100723,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 1998ab',NULL,100723,35.33,0.3,116,42258,60,NULL,NULL,'NGC 4704',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100724,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 1998ab',NULL,100724,35.4,0.17,120,42258,70.8,NULL,NULL,'NGC 4704',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100725,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 1998ab',NULL,100725,35.53,0.03,124,42258,70,NULL,'SALT 2','NGC 4704',0.02713,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100726,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100726,36.38,0.46,189,42259,70,NULL,NULL,'2MASX J12484657+4139162',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000087,NULL,'15.4g',0.44,'E0',NULL,NULL,NULL,NULL,1,192.194,41.6545,0,NULL,59083283510,923176304,14424629,15.4),(100727,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100727,38.18,0.46,432,42260,70,NULL,NULL,'2MASX J12484783+6613031',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000081,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,192.199333,66.21767,0.049,NULL,57319834483,895622413,13994100,17.9),(100728,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100728,38.28,0.33,453,42261,70,NULL,NULL,'2MASX J12484801+6412551',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,192.20025,64.21536,0.033,NULL,57369583697,896399745,14006246,18),(100729,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100729,37.31,0.46,290,42262,70,NULL,NULL,'2MASX J12484894+5134338',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000176,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,192.2039583,51.57603,0,NULL,57206605119,893853204,13966456,17.4),(100730,'GCLF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100730,32.95,0.34,38.9,42263,NULL,NULL,NULL,'NGC 4696',NULL,'2005A&A...438..103M',2005,1,4.5,'Incorrectly identified as NGC 4296 in PKSCAT90 (version 1.01).','G',0.00005,NULL,'11.39',3.2,'E+1 pec;BrClG  LINER','Group member, radial-velocity confirmed',NULL,NULL,'LINER',1,192.2052083,-41.31083,0.461,NULL,46746687387,730416990,11412765,11.39),(100731,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100731,32.75,0.12,35.5,42263,74.4,NULL,NULL,'NGC 4696',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100732,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100732,32.75,0.17,35.5,42263,NULL,NULL,'I','NGC 4696',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100733,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100733,32.75,0.17,35.5,42263,NULL,NULL,NULL,'NGC 4696',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100734,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100734,32.83,0.17,36.8,42263,NULL,NULL,'Malmquist cor.','NGC 4696',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100735,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100735,33,0.1,39.8,42263,NULL,NULL,NULL,'NGC 4696',NULL,'2005ApJ...634..239C',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100736,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100736,33.14,0.17,42.5,42263,NULL,NULL,'I','NGC 4696',NULL,'2003A&A...410..445M',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100737,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100737,32.93,0.4,38.6,42263,75,NULL,'Edat, raw','NGC 4696',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100738,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100738,32.95,0.4,38.9,42263,75,NULL,'Edat, cor','NGC 4696',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100739,'Dwarf Galaxy Diameter','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100739,33.18,0.72,43.3,42263,NULL,NULL,'Centaurus cluster, bias corr.','NGC 4696',NULL,'2011MNRAS.414.3699M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100740,'Dwarf Galaxy Diameter','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100740,33.43,0.58,48.5,42263,NULL,NULL,'Centaurus cluster','NGC 4696',NULL,'2011MNRAS.414.3699M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100741,'Faber-Jackson','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100741,31.9,NULL,24,42263,NULL,NULL,'LEDA [Nov 2006]','NGC 4696',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100742,'Faber-Jackson','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100742,32,0.37,25.1,42263,95,NULL,'Weighted Mean','NGC 4696',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100743,'Faber-Jackson','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100743,32.45,0.46,30.9,42263,95,NULL,'Michard 1979a','NGC 4696',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100744,'Faber-Jackson','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100744,32.73,0.63,35.2,42263,95,NULL,'Michard 1979b, c','NGC 4696',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100745,'Faber-Jackson','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100745,33.41,0.81,48.1,42263,55,NULL,'Visvanathan & Sandage 1979','NGC 4696',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100746,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100746,32.19,0.41,27.4,42263,NULL,NULL,NULL,'NGC 4696',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100747,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100747,32.6,0.41,33.1,42263,NULL,NULL,'Malmquist cor.','NGC 4696',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100748,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100748,32.75,0.12,35.5,42263,74.4,NULL,NULL,'NGC 4696',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100749,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100749,32.87,0.16,37.5,42263,NULL,NULL,'log(m)-log(r), early FP','NGC 4696',NULL,'1989AJ.....98.1542B',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100750,'Tertiary','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100750,32.42,0.71,30.5,42263,95,NULL,NULL,'NGC 4696',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100751,'Tully est','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100751,33.33,0.8,46.4,42263,75,NULL,'B','NGC 4696',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100752,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100752,32.62,0.45,33.4,42263,NULL,NULL,'K','NGC 4696',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100753,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100753,33.42,0.4,48.2,42263,NULL,NULL,'mean','NGC 4696',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100754,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100754,38.17,0.23,431,42264,70,NULL,NULL,'2MASX J12484965+0200540',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000114,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,192.206833,2.01497,0,NULL,58096750851,907761732,14183777,16.3),(100755,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100755,36.55,0.2,204,42265,74.4,NULL,NULL,'CGCG 071-049',NULL,'2013AJ....146...86T',2013,1,0.53,NULL,'G',0.00002,NULL,'16.85',0.3,NULL,NULL,NULL,NULL,NULL,1,192.2075,10.35892,0,NULL,58066780510,907293445,14176460,16.85),(100756,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100756,37.7,0.33,347,42266,70,NULL,NULL,'2MASX J12484991+5428007',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,192.2080417,54.467,0,NULL,57420966365,897202599,14018790,17.5),(100757,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100757,36.99,0.46,251,42267,70,NULL,NULL,'SDSS J124850.04+000659.2',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000071,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,192.2085,0.11644,0,NULL,58083207116,907550111,14180470,17.3),(100758,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100758,37.99,0.46,395,42268,70,NULL,NULL,'2MASX J12485031+0029490',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000098,NULL,'17.3g',0.24,'AGN',NULL,NULL,NULL,NULL,1,192.2097917,0.49683,0,NULL,58086551111,907602361,14181286,17.3),(100759,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100759,37.53,0.46,320,42269,70,NULL,NULL,'2MASX J12485114+2015501',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,192.213125,20.264,0.071,NULL,58898508708,920289198,14379518,16.6),(100760,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100760,37.94,0.46,387,42270,70,NULL,NULL,'2MASX J12485168+2950150',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,192.2155,29.83744,0.036,NULL,58782616281,918478379,14351224,17.4),(100761,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100761,33.28,0.09,45.3,42271,NULL,NULL,'I','CCC 068',NULL,'2003A&A...410..445M',2003,1,NULL,NULL,'G',NULL,NULL,'20.59',NULL,'dE','Group member',NULL,NULL,NULL,1,192.2187917,-41.54014,0.461,NULL,46746802423,730418787,11412793,20.59),(100762,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100762,37.38,0.46,299,42272,70,NULL,NULL,'SDSS J124853.24-013618.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000078,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,192.221833,-1.60517,0,NULL,43102212518,673472070,10523001,18.3),(100763,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100763,35.21,0.53,110,42273,70,NULL,NULL,'2MASX J12485326-1812284',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.36',NULL,NULL,NULL,NULL,NULL,NULL,1,192.222083,-18.20797,0.081,NULL,43910425462,686100397,10720318,16.36),(100764,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100764,36.98,0.6,248,42274,70,NULL,NULL,'LCRS B124616.7-115404',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.89',NULL,NULL,NULL,NULL,NULL,NULL,1,192.2224583,-12.17342,0.085,NULL,43957307910,686832936,10731764,14.89),(100765,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100765,38.17,0.23,431,42275,70,NULL,NULL,'SDSS J124853.51+020214.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00007,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,192.223,2.03731,0,NULL,58096806749,907762605,14183790,18.4),(100766,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100766,37.81,0.33,365,42276,70,NULL,NULL,'SDSS J124853.77+520137.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,192.224041667,52.02717,0,NULL,57206821138,893856580,13966509,18),(100767,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100767,32.58,0.33,32.8,42277,NULL,NULL,'I','CCC 070',NULL,'2003A&A...410..445M',2003,1,NULL,NULL,'G',0.000067,NULL,'15.64',NULL,'E','Group member',NULL,NULL,NULL,1,192.224583,-41.31917,0.461,NULL,46746686798,730416981,11412765,15.64),(100768,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100768,31.46,0.4,19.6,42278,NULL,NULL,NULL,'LCRS B124617.5-112413',NULL,'2013MNRAS.429.2677K',2013,1,0.8,NULL,'G',0.000017,NULL,'15.0b',0.4,NULL,NULL,NULL,NULL,NULL,1,192.2255417,-11.67842,0.081,NULL,43956500723,686820323,10731567,15),(100769,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100769,37.57,0.11,326,42279,70,NULL,NULL,'2MASX J12485424-0140493',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000098,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,192.225917,-1.68031,0,NULL,43102237539,673472461,10523007,17),(100770,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100770,37.21,0.33,277,42280,70,NULL,NULL,'2MASX J12485421+2958091',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000167,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,192.225917,29.96917,0.032,NULL,58782494835,918476481,14351195,18),(100771,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100771,37.59,0.46,329,42281,70,NULL,NULL,'2MASX J12485504+0114373',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000075,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,192.229375,1.24381,0.01,NULL,58085961005,907593140,14181142,17.4),(100772,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100772,37.52,0.33,319,42282,70,NULL,NULL,'2MASX J12485519+0713410',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.44',0.18,NULL,NULL,NULL,NULL,NULL,1,192.2300417,7.228,0.045,NULL,58073026157,907391033,14177984,18.44),(100773,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100773,37.21,0.33,277,42283,70,NULL,NULL,'2MASX J12485536+3000282',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000137,NULL,'16.2g',0.32,NULL,NULL,NULL,NULL,NULL,1,192.2307083,30.00797,0.032,NULL,58782505801,918476653,14351197,16.2),(100774,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100774,38.17,0.23,431,42284,70,NULL,NULL,'2MASX J12485603+0157024',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000088,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,192.233583333,1.95067,0,NULL,58096771996,907762062,14183782,17.5),(100775,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100775,36.7,0.66,218,42285,70,NULL,NULL,'2MASX J12485609-2154404',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,192.2337083,-21.91131,0.137,NULL,43907855943,686060249,10719691,15.6),(100776,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100776,37.4,0.33,302,42286,70,NULL,NULL,'2MASX J12485728+1528593',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,192.2385417,15.48328,0.03,NULL,58998773423,921855834,14403997,16.9),(100777,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100777,37.57,0.11,326,42287,70,NULL,NULL,'2MASX J12485770-0159243',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000075,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,192.2405,-1.99028,0,NULL,43115994573,673687415,10526365,16.9),(100778,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100778,37.52,0.33,319,42288,70,NULL,NULL,'CGCG 043-033',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00018,NULL,'15.7',0.22,NULL,NULL,NULL,NULL,NULL,1,192.241833,7.25411,0.045,NULL,58073023529,907390992,14177984,15.7),(100779,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100779,37.4,0.46,302,42289,70,NULL,NULL,'2MASX J12485927+3505442',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000176,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,192.247125,35.09569,0.02,NULL,58738674787,917791793,14340496,17),(100780,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100780,37.98,0.46,395,42290,70,NULL,NULL,'2MASX J12485950+1056270',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.63',0.15,NULL,NULL,NULL,NULL,NULL,1,192.247875,10.94069,0,NULL,58955256229,921175878,14393373,18.63),(100781,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100781,33.65,0.49,53.7,42291,75,NULL,'IR','IC 3799',NULL,'2011yCatp016004901K',2011,1,2.4,'Confused HIPASS source','G',0.00003,NULL,'14',0.24,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.2485,-14.39922,0.069,NULL,43971039315,687047489,10735117,14),(100782,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100782,34.1,NULL,66.1,42291,NULL,NULL,'Dipole','IC 3799',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100783,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100783,34.1,NULL,66.1,42291,NULL,NULL,'Dipole + Quadrupole','IC 3799',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100784,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100784,34.11,NULL,66.2,42291,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 3799',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100785,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100785,34.37,NULL,75,42291,NULL,NULL,NULL,'IC 3799',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100786,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100786,37.38,0.46,299,42292,70,NULL,NULL,'SDSS J124859.69+025712.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000063,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,192.248708333,2.95336,0.046,NULL,58092578825,907696544,14182758,18),(100787,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100787,37.57,0.11,326,42293,70,NULL,NULL,'2MASX J12485997-0155373',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000088,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,192.2499583,-1.92703,0,NULL,43115977986,673687156,10526361,16.8),(100788,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100788,37.57,0.11,326,42294,70,NULL,NULL,'2MASX J12490051-0142104',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000077,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,192.252083,-1.703,0,NULL,43102234002,673472406,10523006,17.5),(100789,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 2007N',NULL,100789,34.1,0.23,64.3,42295,72,NULL,NULL,'MCG -01-33-012',0.01401,'2013ApJ...773...53F',2013,1,1.5,NULL,'G',0.00004,NULL,'14.51',0.7,'SA(s)a:',NULL,NULL,NULL,NULL,1,192.256333,-9.45703,0.069,NULL,43120996897,673765576,10527587,14.51),(100790,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 2007N',NULL,100790,34.07,0.27,64.3,42295,65,NULL,'MLCS31','MCG -01-33-012',0.012879,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100791,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 2007N',NULL,100791,34.1,0.1,66.1,42295,74.4,NULL,NULL,'MCG -01-33-012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100792,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 2007N',NULL,100792,34.42,0.24,75.6,42295,65,NULL,'MLCS17','MCG -01-33-012',0.012879,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100793,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100793,33.76,0.4,56.5,42295,NULL,NULL,'mean','MCG -01-33-012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100794,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100794,34.06,0.47,64.9,42295,NULL,NULL,'H','MCG -01-33-012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100795,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100795,34.17,0.46,68.1,42295,NULL,NULL,'J','MCG -01-33-012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100796,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100796,38.06,0.14,409,42296,70,NULL,NULL,'2MASX J12490182+6237341',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000125,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,192.257541667,62.62614,0.013,NULL,57362438095,896288095,14004501,18.2),(100797,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100797,33.6,0.45,52.5,42297,NULL,NULL,'I','CCC 075',NULL,'2003A&A...410..445M',2003,1,NULL,NULL,'G',0.000233,NULL,'18.06',NULL,'dE,N','Group member',NULL,NULL,NULL,1,192.258333,-41.25925,0.461,NULL,46746643546,730416305,11412754,18.06),(100798,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100798,37.09,0.46,261,42298,70,NULL,NULL,'2MASX J12490213+5157127',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000171,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,192.259083,51.95361,0,NULL,57206905670,893857901,13966529,16.6),(100799,'Tully est','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100799,32.05,0.8,25.7,42299,75,NULL,'B','NGC 4699',NULL,'1988NBGC.C....0000T',1988,1,3.8,NULL,'G',0.000013,NULL,'10.41',2.6,'SAB(rs)b;HII   Sy','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.2592917,-8.66486,0.085,NULL,43120395929,673756186,10527440,10.41),(100800,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100800,29.78,0.69,9.02,42299,100,NULL,'mid-IR','NGC 4699',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100801,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100801,31.55,0.4,20.4,42299,NULL,NULL,NULL,'NGC 4699',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100802,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100802,31.87,0.4,23.7,42299,NULL,NULL,NULL,'NGC 4699',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100803,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100803,38.42,0.46,483,42300,70,NULL,NULL,'2MASX J12490308+3044482',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00014,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,192.262917,30.74678,0.027,NULL,58782698031,918479656,14351244,18.1),(100804,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100804,38.06,0.14,409,42301,70,NULL,NULL,'2MASX J12490337+6250421',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000142,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,192.263916667,62.84497,0.013,NULL,57376143907,896502248,14007847,18.4),(100805,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100805,38.06,0.14,409,42302,70,NULL,NULL,'2MASX J12490349+6247401',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000138,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,192.264375,62.79467,0.013,NULL,57362454530,896288352,14004505,18.1),(100806,'IRAS','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100806,33.31,0.8,46,42303,75,NULL,'MAT, I','ESO 322- G 093',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'16.04',0.2,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.267166667,-41.33878,0.461,NULL,46746686086,730416970,11412765,16.04),(100807,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100807,32.14,0.32,26.8,42303,85,NULL,'I, inv','ESO 322- G 093',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100808,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100808,32.17,0.32,27.2,42303,85,NULL,'I, raw','ESO 322- G 093',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100809,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100809,32.56,0.43,32.5,42303,75,NULL,'MAT, I, inv','ESO 322- G 093',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100810,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100810,32.6,0.43,33.2,42303,75,NULL,'MAT, I, raw','ESO 322- G 093',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100811,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100811,32.98,0.43,39.5,42303,75,NULL,'MAT, I, cor','ESO 322- G 093',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100812,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100812,33.39,0.1,47.7,42303,NULL,NULL,NULL,'ESO 322- G 093',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100813,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100813,37.57,0.11,326,42304,70,NULL,NULL,'2MASX J12490452-0120474',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000066,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,192.268917,-1.3465,0.053,NULL,43103971330,673499552,10523430,17.1),(100814,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100814,38.06,0.14,409,42305,70,NULL,NULL,'2MASX J12490470+6235551',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000183,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,192.26925,62.59853,0.013,NULL,57362447849,896288247,14004503,17),(100815,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100815,37.19,0.46,274,42306,70,NULL,NULL,'2MASX J12490480+4349596',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000196,NULL,'15.7g',0.5,'E0',NULL,NULL,NULL,NULL,1,192.269917,43.83319,0,NULL,59120132752,923752074,14433626,15.7),(100816,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100816,37.55,0.46,324,42307,70,NULL,NULL,'2MASX J12490488+6810380',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000078,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,192.2702917,68.17714,0.021,NULL,57860985898,904077904,14126217,17.5),(100817,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100817,38.06,0.14,409,42308,70,NULL,NULL,'SDSS J124905.31+624243.4',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,192.272125,62.71208,0.013,NULL,57362458828,896288419,14004506,17.9),(100818,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100818,38.13,0.33,422,42309,70,NULL,NULL,'2MASX J12490563+6358251',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00017,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,192.273833,63.97364,0.033,NULL,57368393150,896381142,14005955,17.9),(100819,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100819,34.95,0.46,97.8,42310,70,NULL,NULL,'CGCG 100-009',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000187,NULL,'15.5',0.3,NULL,NULL,NULL,NULL,NULL,1,192.275417,17.02581,0.055,NULL,58875592455,919931132,14373923,15.5),(100820,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100820,34.22,0.49,69.9,42311,70,NULL,NULL,'ESO 322- G 094',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000077,NULL,'14.71',0.5,'SA0-','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.2765417,-41.83272,0.469,NULL,46746630076,730416094,11412751,14.71),(100821,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100821,38.17,0.33,430,42312,70,NULL,NULL,'2MASX J12490664-0222564',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000075,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,192.277625,-2.38225,0.009,NULL,43116395974,673693687,10526463,17.6),(100822,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100822,38.06,0.14,409,42313,70,NULL,NULL,'2MASX J12490681+6243521',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000135,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,192.2782917,62.73111,0.013,NULL,57362461688,896288463,14004507,18.4),(100823,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100823,36.27,0.64,179,42314,70,NULL,NULL,'2MFGC 10099',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'11.5K',NULL,NULL,NULL,NULL,NULL,NULL,1,192.278916667,-15.46597,0.017,NULL,43963053023,686922703,10733167,11.5),(100824,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100824,28.6,0.43,5.3,42315,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4700',NULL,'2014MNRAS.444..527S',2014,1,3,'Extended HIPASS source','G',0.000013,NULL,'12.63',0.6,'SB(s)c? sp;HII Sy2','Group member, radial-velocity confirmed',NULL,NULL,'H II',1,192.2839583,-11.40986,0.081,NULL,43838986240,684984160,10702877,12.63),(100825,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100825,28.82,0.43,5.8,42315,75,NULL,'3.6 micron, color corrected','NGC 4700',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100826,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100826,28.94,0.2,6.14,42315,74.4,NULL,NULL,'NGC 4700',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100827,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100827,29.3,0.4,7.24,42315,NULL,NULL,NULL,'NGC 4700',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100828,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100828,29.06,0.4,7.3,42315,NULL,NULL,NULL,'NGC 4700',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100829,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100829,29.32,NULL,7.31,42315,NULL,NULL,NULL,'NGC 4700',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100830,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100830,31.9,0.4,24,42315,75,NULL,'B','NGC 4700',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100831,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100831,37.37,0.46,299,42316,70,NULL,NULL,'2MASX J12490904+3234022',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000175,NULL,'17.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,192.2877917,32.56739,0.006,NULL,58749896154,917967127,14343236,17),(100832,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100832,37.57,0.46,326,42317,70,NULL,NULL,'2MASX J12490976+0240104',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000075,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,192.290625,2.66953,0.041,NULL,58096971179,907765174,14183830,17.6),(100833,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100833,37.89,0.46,379,42318,70,NULL,NULL,'2MASX J12490983+5636287',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000175,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,192.290833,56.60808,0,NULL,57431359316,897364989,14021327,16.9),(100834,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100834,37.99,0.46,396,42319,70,NULL,NULL,'2MASX J12490994+1321083',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,192.291583333,13.35219,0.029,NULL,58991260749,921738449,14402163,17.1),(100835,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100835,37.81,0.33,365,42320,70,NULL,NULL,'2MASX J12491020+5206187',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,192.292625,52.10528,0,NULL,57206830408,893856725,13966511,16.7),(100836,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100836,38.17,0.33,430,42321,70,NULL,NULL,'2MASXi J1249105-022059',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000083,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,192.294167,-2.34983,0.009,NULL,43116394619,673693665,10526463,18.1),(100837,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100837,37.7,0.33,347,42322,70,NULL,NULL,'2MASX J12491066+5425217',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,192.294417,54.42261,0,NULL,57420455826,897194622,14018665,17.9),(100838,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100838,35.93,0.61,153,42323,70,NULL,NULL,'2MASX J12491088-1511362',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.38',NULL,NULL,NULL,NULL,NULL,NULL,1,192.2955417,-15.19344,0.077,NULL,43962667619,686916681,10733073,16.38),(100839,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100839,37.59,0.46,329,42324,70,NULL,NULL,'2MASX J12491137+2536507',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'18.69',NULL,NULL,NULL,NULL,NULL,NULL,1,192.297416667,25.61419,0.026,NULL,58724406606,917568853,14337013,18.69),(100840,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100840,31.16,0.36,17.1,42325,NULL,NULL,NULL,'NGC 4701',NULL,'2009AJ....138..323T',2009,1,2.8,NULL,'G',0.000017,NULL,'12.80',2.1,'SA(s)cd        HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,192.2982917,3.38872,0.014,NULL,58094412565,907725196,14183206,12.8),(100841,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100841,31.25,0.4,17.8,42325,NULL,NULL,'mean','NGC 4701',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100842,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100842,31.55,0.4,20.5,42325,75,NULL,'B','NGC 4701',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100843,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100843,32,0.45,25.1,42325,NULL,NULL,'K','NGC 4701',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100844,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100844,32.02,0.47,25.4,42325,NULL,NULL,'H','NGC 4701',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100845,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100845,32.09,0.46,26.2,42325,NULL,NULL,'J','NGC 4701',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100846,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100846,32.71,0.3,34.8,42325,55,NULL,'B','NGC 4701',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100847,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100847,36.48,0.46,198,42326,70,NULL,NULL,'ARK 389',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'15.7',0.2,NULL,NULL,NULL,NULL,NULL,1,192.300083333,17.69375,0.057,NULL,58904819401,920387803,14381059,15.7),(100848,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100848,38.8,0.46,575,42327,70,NULL,NULL,'SDSS J124912.46+545125.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,192.3019583,54.85719,0,NULL,57420937232,897202144,14018783,18.4),(100849,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100849,35.98,0.75,157,42328,70,NULL,NULL,'2MASX J12491275-2157285',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00009,NULL,'16.25',NULL,NULL,NULL,NULL,NULL,NULL,1,192.303167,-21.95789,0.137,NULL,43907862363,686060349,10719692,16.25),(100850,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100850,35.35,0.5,117,42329,70,NULL,NULL,'ESO 575- G 001',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00015,NULL,'14.76',0.3,'S0',NULL,NULL,NULL,NULL,1,192.303917,-21.58856,0.137,NULL,43907978282,686062160,10719721,14.76),(100851,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100851,37.36,0.46,296,42330,70,NULL,NULL,'2MASX J12491316+4144415',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000167,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,192.304875,41.74481,0,NULL,59083112083,923173626,14424587,17.7),(100852,'TRGB','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100852,28.1,0.31,4.17,42331,NULL,NULL,NULL,'LEDA 166146',NULL,'2013AstBu..68..125M',2013,1,1.7,NULL,'G',NULL,NULL,'17.6B',1,'dwarf Sph',NULL,NULL,NULL,NULL,1,192.305417,35.61194,0.025,NULL,58554969705,914921401,14295646,17.6),(100853,'TRGB','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100853,28.26,NULL,4.48,42331,NULL,NULL,NULL,'LEDA 166146',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100854,'TRGB','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100854,28.38,NULL,4.74,42331,NULL,NULL,NULL,'LEDA 166146',NULL,'2003A&A...398..467K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100855,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100855,37.42,0.46,305,42332,70,NULL,NULL,'SDSS J124913.67+072827.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,192.307,7.47439,0.019,NULL,58072926678,907389479,14177960,18.2),(100856,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100856,37.57,0.11,326,42333,70,NULL,NULL,'2MASX J12491405-0141144',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000095,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,192.308667,-1.68742,0,NULL,43102197705,673471839,10522997,16.5),(100857,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100857,37.57,0.11,326,42334,70,NULL,NULL,'2MASX J12491445-0121324',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000082,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,192.3102083,-1.35908,0.053,NULL,43103976854,673499638,10523431,17.2),(100858,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100858,37.04,0.46,256,42335,70,NULL,NULL,'2MASX J12491464+4803369',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000202,NULL,'16.0g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,192.3107917,48.06017,0,NULL,59097323039,923395672,14428057,16),(100859,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100859,35.99,0.61,157,42336,70,NULL,NULL,'2MASX J12491806-2135235',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,192.3252917,-21.58992,0.137,NULL,43907986339,686062286,10719723,14.9),(100860,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100860,31.49,0.43,19.9,42337,75,NULL,'3.6 micron, color + selection bias corrected','DDO 149',NULL,'2014MNRAS.444..527S',2014,1,1.6,'Confused HIPASS source','G',0.000013,NULL,'14.70',0.7,'IB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.3262917,-4.01631,0.081,NULL,43108823844,673575372,10524615,14.7),(100861,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100861,31.7,0.4,21.9,42337,NULL,NULL,NULL,'DDO 149',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100862,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100862,33.5,0.31,50.1,42338,NULL,NULL,'I','2MASX J12491862-4120073',NULL,'2003A&A...410..445M',2003,1,0.65,NULL,'G',0.000037,NULL,'15.77',0.25,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.32725,-41.33572,0.461,NULL,46746669110,730416704,11412761,15.77),(100863,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100863,33.37,0.23,47.2,42338,74.4,NULL,NULL,'2MASX J12491862-4120073',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100864,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100864,33.29,0.46,45.5,42339,NULL,NULL,'J','NGC 4703',NULL,'2007A&A...465...71T',2007,1,3.49,NULL,'G',0.000037,NULL,'14.5',0.47,'Sb',NULL,NULL,NULL,NULL,1,192.329041667,-9.10842,0.085,NULL,43120235252,673753675,10527401,14.5),(100865,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100865,33.36,0.47,46.9,42339,NULL,NULL,'H','NGC 4703',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100866,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100866,33.4,0.45,47.9,42339,NULL,NULL,'K','NGC 4703',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100867,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100867,33.45,0.49,48.9,42339,75,NULL,'IR','NGC 4703',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100868,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100868,34.03,0.4,63.9,42339,NULL,NULL,'mean','NGC 4703',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100869,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100869,34.09,NULL,65.7,42339,NULL,NULL,'Dipole','NGC 4703',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100870,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100870,34.09,NULL,65.9,42339,NULL,NULL,'Dipole + Quadrupole','NGC 4703',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100871,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100871,34.11,NULL,66.2,42339,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 4703',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100872,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100872,37.45,0.62,310,42340,70,NULL,NULL,'LCRS B124642.6-114646',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.53',NULL,NULL,NULL,NULL,NULL,NULL,1,192.3304583,-12.05169,0.081,NULL,43957342187,686833471,10731772,15.53),(100873,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100873,36.99,0.46,250,42341,70,NULL,NULL,'2MASX J12491957+2345397',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,192.3315417,23.76092,0.122,NULL,58888424121,920131626,14377056,17.6),(100874,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100874,33.61,0.53,52.7,42342,70,NULL,NULL,'MRK 1336',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'14.92',0.6,'E',NULL,NULL,NULL,NULL,1,192.332583,-9.29225,0.085,NULL,43120198262,673753097,10527392,14.92),(100875,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100875,37.95,0.46,388,42343,70,NULL,NULL,'2MASX J12492152+1706313',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,192.339917,17.10869,0.055,NULL,58875601752,919931277,14373926,17.3),(100876,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100876,36.58,0.2,207,42344,74.4,NULL,NULL,'CGCG 071-050',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000022,NULL,'15.7',0.23,'SAa','Isolated galaxy',NULL,NULL,NULL,1,192.343167,9.81767,0,NULL,58069785900,907340404,14177193,15.7),(100877,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100877,37.64,0.46,338,42345,70,NULL,NULL,'SDSS J124923.46+280423.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'19.72',0.14,NULL,NULL,NULL,NULL,NULL,1,192.34775,28.07322,0.053,NULL,58727622003,917619093,14337798,19.72),(100878,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100878,35.09,0.85,104,42346,NULL,NULL,'Malmquist cor.','ESO 322- G 098',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'16.26',0.5,'S',NULL,NULL,NULL,NULL,1,192.347917,-42.64736,0.437,NULL,46772999800,730828121,11419189,16.26),(100879,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100879,35.15,0.83,107,42346,NULL,NULL,NULL,'ESO 322- G 098',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100880,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100880,35.19,0.2,109,42346,74.4,NULL,NULL,'ESO 322- G 098',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100881,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100881,29.39,0.43,7.5,42347,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-33-015',NULL,'2014MNRAS.444..527S',2014,1,4.1,NULL,'G',0.00001,NULL,'13.24',3.2,'SB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.348791667,-10.11842,0.101,NULL,43118234455,673722413,10526912,13.24),(100882,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100882,31.1,0.4,16.6,42347,NULL,NULL,NULL,'MCG -02-33-015',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100883,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100883,31.83,0.4,23.3,42347,75,NULL,'B','MCG -02-33-015',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100884,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100884,37.68,0.46,344,42348,70,NULL,NULL,'2MASX J12492474+5637156',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,192.353166667,56.62097,0,NULL,57431352722,897364886,14021326,17),(100885,'IRAS','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100885,33.88,0.8,59.6,42349,75,NULL,'MAT, I','NGC 4705',NULL,'1997ApJS..109..333W',1997,1,3,'The APM position refers to the southeastern part of the galaxy.','G',0.00001,NULL,'12.52',1,'SAB(s)bc: sp',NULL,NULL,NULL,NULL,1,192.354041667,-5.19586,0.045,NULL,43135242353,673988161,10531065,12.52),(100886,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100886,32.94,0.43,38.8,42349,75,NULL,'MAT, I, raw','NGC 4705',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100887,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100887,33.07,0.32,41.1,42349,85,NULL,'I, raw','NGC 4705',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100888,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100888,33.12,0.32,42.1,42349,85,NULL,'I, inv','NGC 4705',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100889,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100889,33.14,0.43,42.5,42349,75,NULL,'MAT, I, cor','NGC 4705',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100890,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100890,33.17,0.47,43,42349,NULL,NULL,'H','NGC 4705',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100891,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100891,33.18,0.43,43.3,42349,75,NULL,'MAT, I, inv','NGC 4705',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100892,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100892,33.22,0.45,44.1,42349,NULL,NULL,'K','NGC 4705',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100893,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100893,33.23,0.46,44.3,42349,NULL,NULL,'J','NGC 4705',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100894,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100894,33.46,0.2,49.2,42349,74.4,NULL,NULL,'NGC 4705',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100895,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100895,33.73,0.35,55.6,42349,NULL,NULL,NULL,'NGC 4705',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100896,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100896,33.75,0.35,56.3,42349,NULL,NULL,'Malmquist cor.','NGC 4705',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100897,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100897,33.9,0.4,60.3,42349,NULL,NULL,'mean','NGC 4705',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100898,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100898,37.81,0.33,365,42350,70,NULL,NULL,'2MASX J12492528+2649507',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.6g',0.18,'SAB0',NULL,NULL,NULL,NULL,1,192.355583,26.83089,0.026,NULL,58735547143,917742924,14339733,17.6),(100899,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100899,32.78,0.4,35.9,42351,75,NULL,'Edat, raw','ESO 322- G 099',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000037,NULL,'14.43',0.6,'(L?)SB0^-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.359125,-41.48986,0.461,NULL,46746666125,730416658,11412760,14.43),(100900,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100900,32.88,0.4,37.6,42351,75,NULL,'Edat, cor','ESO 322- G 099',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100901,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100901,32.49,0.23,31.5,42351,74.4,NULL,NULL,'ESO 322- G 099',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100902,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100902,33.85,0.4,59,42351,NULL,NULL,'mean','ESO 322- G 099',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100903,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100903,33.88,0.45,59.6,42351,NULL,NULL,'K','ESO 322- G 099',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100904,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100904,37.57,0.11,326,42352,70,NULL,NULL,'2MASX J12492622-0139501',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000096,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,192.3592917,-1.66392,0.005,NULL,43102199080,673471860,10522997,17),(100905,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100905,38.65,0.46,536,42353,70,NULL,NULL,'LCRS B124651.8-030154',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00008,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,192.359667,-3.30386,0.021,NULL,43107633248,673556769,10524324,18),(100906,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100906,32.78,0.4,35.9,42354,75,NULL,'Edat, raw','ESO 322- G 100',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'14.8',0.4,'S0p','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.3612083,-41.46328,0.461,NULL,46754056202,730532128,11414564,14.8),(100907,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100907,32.88,0.4,37.6,42354,75,NULL,'Edat, cor','ESO 322- G 100',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100908,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100908,32.68,0.23,34.4,42354,74.4,NULL,NULL,'ESO 322- G 100',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100909,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100909,35.68,0.46,137,42355,70,NULL,NULL,'2MASX J12492702+5134549',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000087,NULL,'16.1g',0.31,'S0^-',NULL,NULL,NULL,NULL,1,192.36275,51.58189,0,NULL,57209929784,893905152,13967268,16.1),(100910,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100910,36.22,0.46,176,42356,70,NULL,NULL,'IC 3816',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000107,NULL,'15.3g',0.57,NULL,NULL,NULL,NULL,NULL,1,192.368625,37.23028,0.023,NULL,58553676832,914901200,14295331,15.3),(100911,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100911,38.02,0.46,403,42357,70,NULL,NULL,'2MASX J12492940+4129083',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,192.372375,41.4855,0,NULL,59085259942,923207186,14425112,18),(100912,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100912,38.19,0.46,434,42358,70,NULL,NULL,'2MASX J12493212+1746005',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,192.384,17.76697,0.057,NULL,58896432188,920256752,14379011,17.9),(100913,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100913,33.35,0.49,46.7,42359,75,NULL,'IR','MCG -01-33-017',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000033,NULL,'14.46',0.4,'Sb?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.3879583,-9.74083,0.085,NULL,43121425145,673772267,10527691,14.46),(100914,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100914,33.43,0.47,48.5,42359,NULL,NULL,NULL,'MCG -01-33-017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100915,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100915,33.47,0.2,49.4,42359,74.4,NULL,NULL,'MCG -01-33-017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100916,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100916,33.61,0.43,52.8,42359,NULL,NULL,'Malmquist cor.','MCG -01-33-017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100917,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100917,34.14,0.4,67.2,42359,NULL,NULL,'mean','MCG -01-33-017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100918,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100918,34.33,0.47,73.3,42359,NULL,NULL,'H','MCG -01-33-017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100919,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100919,37.57,0.11,326,42360,70,NULL,NULL,'2MASX J12493322-0128401',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000076,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,192.3885417,-1.47778,0.041,NULL,43101998214,673468722,10522948,18.1),(100920,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100920,35.76,0.5,142,42361,70,NULL,NULL,'2MASX J12493348-4403575',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000137,NULL,'14.0R',1.1,'(R\')S0^0^?;E/D',NULL,NULL,NULL,NULL,1,192.38975,-44.06592,0.365,NULL,46773846165,730841346,11419396,14),(100921,'Sosies','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100921,34.81,0.21,91.6,42362,NULL,NULL,NULL,'NGC 4712',NULL,'2002A&A...393...57T',2002,1,2.5,NULL,'G',0.000017,NULL,'13.3',1.1,'SA(s)bc        HII','in a pair',NULL,NULL,NULL,1,192.392583,25.46994,0.031,NULL,58724252593,917566446,14336975,13.3),(100922,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100922,33.89,0.2,60,42362,74.4,NULL,NULL,'NGC 4712',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100923,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100923,34.03,0.36,64,42362,NULL,NULL,NULL,'NGC 4712',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100924,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100924,34.11,0.34,66.5,42362,NULL,NULL,'Malmquist cor.','NGC 4712',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100925,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100925,34.3,0.4,72.4,42362,NULL,NULL,'mean','NGC 4712',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100926,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100926,34.34,0.47,73.8,42362,NULL,NULL,'H','NGC 4712',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100927,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100927,34.37,0.46,74.9,42362,NULL,NULL,'J','NGC 4712',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100928,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100928,34.44,0.45,77.3,42362,NULL,NULL,'K','NGC 4712',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100929,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100929,37.57,0.11,326,42363,70,NULL,NULL,'SDSS J124934.24-014135.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000072,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,192.3927083,-1.69314,0.005,NULL,43102024786,673469137,10522955,18.5),(100930,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100930,32.18,0.44,27.3,42364,NULL,NULL,'I','ESO 322- G 101',NULL,'2001ApJ...546..681T',2001,1,0.9,NULL,'G',0.000067,NULL,'14.29',0.5,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.393917,-41.05486,0.449,NULL,46754759993,730543124,11414736,14.29),(100931,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100931,32.49,0.12,31.5,42364,74.4,NULL,NULL,'ESO 322- G 101',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100932,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100932,32.93,0.4,38.6,42364,75,NULL,'Edat, raw','ESO 322- G 101',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100933,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100933,32.95,0.4,38.9,42364,75,NULL,'Edat, cor','ESO 322- G 101',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100934,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100934,32.25,0.49,28.2,42364,70,NULL,NULL,'ESO 322- G 101',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100935,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100935,32.49,0.12,31.5,42364,74.4,NULL,NULL,'ESO 322- G 101',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100936,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100936,38.16,0.46,429,42365,70,NULL,NULL,'SDSS J124934.68+165419.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.7g',0.09,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,192.394541667,16.90553,0.055,NULL,58997147340,921830427,14403600,18.7),(100937,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100937,36.26,0.46,179,42366,70,NULL,NULL,'2MASX J12493506+5716150',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000165,NULL,'16.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,192.395875,57.27094,0,NULL,57442164004,897533812,14023965,16.1),(100938,'IRAS','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100938,35.29,0.8,115,42367,75,NULL,'CF, r','UGC 07978',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000007,NULL,'14.51',0.7,'Scd:',NULL,NULL,NULL,NULL,1,192.403625,30.84553,0.037,NULL,58782649359,918478896,14351232,14.51),(100939,'IRAS','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100939,35.3,0.8,115,42367,75,NULL,'HMCL, I','UGC 07978',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100940,'IRAS','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100940,35.3,0.8,115,42367,75,NULL,'W91CL, r','UGC 07978',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100941,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100941,34.9,0.38,95.6,42367,75,NULL,'CF, r, raw','UGC 07978',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100942,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100942,34.9,0.38,95.6,42367,75,NULL,'W91CL, r, raw','UGC 07978',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100943,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100943,34.95,0.34,97.5,42367,NULL,NULL,'Malmquist cor.','UGC 07978',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100944,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100944,34.96,0.33,98.4,42367,NULL,NULL,NULL,'UGC 07978',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100945,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100945,34.98,0.38,99.2,42367,75,NULL,'W91CL, r, cor','UGC 07978',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100946,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100946,34.99,0.4,99.7,42367,75,NULL,'HMCL, I, raw','UGC 07978',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100947,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100947,35,0.38,100,42367,75,NULL,'CF, r, cor','UGC 07978',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100948,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100948,35.04,0.38,102,42367,75,NULL,'CF, r, inv','UGC 07978',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100949,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100949,35.04,0.38,102,42367,75,NULL,'W91CL, r, inv','UGC 07978',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100950,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100950,35.07,0.2,103,42367,74.4,NULL,NULL,'UGC 07978',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100951,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100951,35.07,0.43,104,42367,75,NULL,'3.6 micron, color corrected','UGC 07978',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100952,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100952,35.09,0.4,104,42367,75,NULL,'HMCL, I, cor','UGC 07978',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100953,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100953,35.13,0.43,106,42367,75,NULL,'3.6 micron, color + selection bias corrected','UGC 07978',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100954,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100954,35.18,0.4,109,42367,75,NULL,'HMCL, I, inv','UGC 07978',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100955,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100955,38.13,0.33,424,42368,70,NULL,NULL,'2MASX J12493696+0131585',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000092,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,192.404,1.53292,0,NULL,58085387312,907584176,14181002,17.8),(100956,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100956,38.62,0.46,529,42369,70,NULL,NULL,'SDSS J124936.98+074707.9',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.7g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,192.404125,7.78553,0.012,NULL,58081025254,907516019,14179937,17.7),(100957,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100957,32.93,0.4,38.6,42370,75,NULL,'Edat, raw','ESO 322- G 102',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.00004,NULL,'14.6',0.3,'SB(s)0^0^: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.407667,-41.38817,0.461,NULL,46754065025,730532266,11414566,14.6),(100958,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100958,32.95,0.4,38.9,42370,75,NULL,'Edat, cor','ESO 322- G 102',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100959,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100959,32.42,0.25,30.5,42370,74.4,NULL,NULL,'ESO 322- G 102',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100960,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100960,32.86,0.45,37.4,42370,NULL,NULL,'K','ESO 322- G 102',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100961,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100961,33.42,0.4,48.2,42370,NULL,NULL,'mean','ESO 322- G 102',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100962,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100962,37.56,0.46,326,42371,70,NULL,NULL,'2MASX J12493796+1148198',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000179,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,192.408333,11.80544,0.089,NULL,58989660342,921713442,14401772,17.4),(100963,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100963,37.57,0.11,326,42372,70,NULL,NULL,'2MASX J12493810-0146031',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000088,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,192.4087083,-1.76764,0.005,NULL,43115889345,673685771,10526340,17),(100964,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100964,36.4,0.46,191,42373,70,NULL,NULL,'CGCG 043-037',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000094,NULL,'16.0g',0.38,'SB0',NULL,NULL,NULL,NULL,1,192.409167,2.75561,0.041,NULL,58096985668,907765401,14183834,16),(100965,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100965,37.23,0.46,279,42374,70,NULL,NULL,'2MASX J12493858+1454265',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000115,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,192.410666667,14.90733,0.035,NULL,58998338216,921849034,14403891,17.8),(100966,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100966,37.69,0.46,344,42375,70,NULL,NULL,'2MASX J12493884+2919426',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00016,NULL,'16.6g',0.32,'S0',NULL,NULL,NULL,NULL,1,192.411833,29.32856,0.04,NULL,58728128779,917627012,14337922,16.6),(100967,'Tully est','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100967,31.13,0.8,16.8,42376,75,NULL,'B','NGC 4710',NULL,'1988NBGC.C....0000T',1988,1,4.9,NULL,'G',0.000017,NULL,'11.91',1.2,'SA(r)0+? sp    HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,192.411791667,15.16544,0.022,NULL,58999007335,921859489,14404054,11.91),(100968,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100968,35.42,0.46,121,42377,70,NULL,NULL,'CGCG 244-043',NULL,'2015arXiv151105856S',2015,1,0.88,NULL,'G',0.000193,NULL,'14.6g',0.63,'Sa',NULL,NULL,NULL,NULL,1,192.415708333,49.44711,0,NULL,59097170438,923393288,14428020,14.6),(100969,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100969,32.88,0.3,37.7,42378,NULL,NULL,'I','CCC 111',NULL,'2003A&A...410..445M',2003,1,0.92,NULL,'G',0.000133,NULL,'16.59',0.71,'dE,N','Group member',NULL,NULL,NULL,1,192.41725,-41.36619,0.461,NULL,46754064856,730532263,11414566,16.59),(100970,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100970,36.84,0.46,233,42379,70,NULL,NULL,'LCRS B124706.1-023822',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000066,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,192.4187083,-2.91186,0.021,NULL,43107713538,673558024,10524344,16.8),(100971,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 2005bo',NULL,100971,33.84,0.16,56.9,42380,72,NULL,NULL,'NGC 4708',0.01502,'2013ApJ...773...53F',2013,1,1.3,'HOLM 463B superposed on arm northwest side.','G',0.000027,NULL,'13.4B',0.9,'SA(r)ab pec?',NULL,NULL,NULL,NULL,1,192.422833333,-11.09303,0.085,NULL,43839033068,684984891,10702888,13.4),(100972,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 2005bo',NULL,100972,33.79,0.1,57.3,42380,74.4,NULL,NULL,'NGC 4708',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100973,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 2005bo',NULL,100973,33.85,0.06,58.1,42380,72,NULL,NULL,'NGC 4708',0.013896,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100974,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 2005bo',NULL,100974,33.87,0.2,58.7,42380,70,NULL,'SALT 2','NGC 4708',0.013896,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100975,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 2005bo',NULL,100975,33.87,0.01,59.4,42380,72,NULL,NULL,'NGC 4708',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100976,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 2005bo',NULL,100976,33.96,0.18,61,42380,73.8,NULL,'SALT 2 (SNANA)','NGC 4708',0.0144,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100977,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 2005bo',NULL,100977,35.79,0.03,142,42380,70,NULL,NULL,'NGC 4708',0.013896,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100978,'SNII optical','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 2003ef',NULL,100978,32.94,0.34,38.7,42380,NULL,NULL,'EPM E96','NGC 4708',NULL,'2009ApJ...696.1176J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100979,'SNII optical','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 2003ef',NULL,100979,33.87,0.22,59.4,42380,NULL,NULL,'V, photospheric magnitude method','NGC 4708',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100980,'SNII optical','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 2003ef',NULL,100980,33.96,0.1,61.9,42380,NULL,NULL,'I, photospheric magnitude method','NGC 4708',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100981,'SNII optical','2016-12-15 15:15:06','2016-12-16 11:20:17','1','SN 2003ef',NULL,100981,34.36,0.81,74.4,42380,NULL,NULL,'EPM D05','NGC 4708',NULL,'2009ApJ...696.1176J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100982,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100982,32.85,0.69,37.2,42380,100,NULL,'mid-IR','NGC 4708',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100983,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100983,34.31,0.2,72.8,42381,74.4,NULL,NULL,'UGC 07981',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000008,NULL,'16.4g',0.23,'Scd:',NULL,NULL,NULL,NULL,1,192.422875,30.75239,0.027,NULL,58782654789,918478981,14351234,16.4),(100984,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100984,34.43,0.49,76.9,42381,NULL,NULL,NULL,'UGC 07981',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100985,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100985,34.65,0.44,85.1,42381,NULL,NULL,'Malmquist cor.','UGC 07981',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100986,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100986,30.46,0.4,12.3,42382,NULL,NULL,NULL,'NGC 4678',NULL,'2013MNRAS.429.2677K',2013,1,1.1,'Diameter includes companions or long extensions.','G',0.000003,NULL,'14.49',0.5,'Sbc',NULL,NULL,NULL,NULL,1,192.424375,-4.57972,0.041,NULL,43105350349,673521099,10523767,14.49),(100987,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100987,34.81,0.25,91.6,42383,74.4,NULL,NULL,'CGCG 159-083',NULL,'2013AJ....146...86T',2013,1,1.05,'RC3 has V = 7401 +- 58 km/sec.','G',0.000036,NULL,'14.3g',0.75,'E1:','Group member',NULL,NULL,NULL,1,192.4262083,26.89203,0.028,NULL,58735556510,917743070,14339735,14.3),(100988,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100988,35.31,0.05,115,42383,70,NULL,NULL,'CGCG 159-083',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100989,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100989,38.18,0.46,433,42384,70,NULL,NULL,'SDSS J124942.31+353928.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00015,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,192.426333,35.65794,0.031,NULL,58554962213,914921284,14295645,18.6),(100990,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100990,37.75,0.46,355,42385,70,NULL,NULL,'SDSS J124942.48+001349.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00007,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,192.427,0.2305,0,NULL,58083010219,907547034,14180422,18.3),(100991,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100991,37.77,0.33,358,42386,70,NULL,NULL,'LCRS B124708.3-025101',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000103,NULL,'16.6g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,192.428,-3.12267,0.021,NULL,43107702886,673557857,10524341,16.6),(100992,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100992,37.57,0.11,326,42387,70,NULL,NULL,'2MASX J12494329-0130021',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000073,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,192.430333,-1.5005,0.041,NULL,43102007616,673468869,10522951,17.4),(100993,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100993,37.47,0.46,312,42388,70,NULL,NULL,'2MASX J12494342+2323475',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000193,NULL,'17.34',0.2,NULL,NULL,NULL,NULL,NULL,1,192.4307917,23.39647,0.119,NULL,58889041358,920141271,14377207,17.34),(100994,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100994,36.99,0.46,250,42389,70,NULL,NULL,'LCRS B124711.0-025623',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000079,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,192.4397083,-3.21206,0.017,NULL,43107516670,673554947,10524296,16.5),(100995,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100995,36.53,0.46,203,42390,70,NULL,NULL,'SDSS J124945.72+034746.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00014,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,192.440541667,3.79617,0,NULL,58095264752,907738511,14183414,17.9),(100996,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',100996,37.19,0.46,274,42391,70,NULL,NULL,'2MASX J12494589+1805215',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.31',0.17,NULL,NULL,NULL,NULL,NULL,1,192.441167,18.08925,0.056,NULL,58896515809,920258059,14379032,18.31),(100997,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100997,35.09,0.67,104,42392,NULL,NULL,'Malmquist cor.','ESO 507- G 017',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.57',0.7,'Sb             HII',NULL,NULL,NULL,NULL,1,192.441416667,-23.86053,0.349,NULL,43385959905,677905623,10592275,14.57),(100998,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100998,35.38,0.59,119,42392,NULL,NULL,NULL,'ESO 507- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(100999,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,100999,35.42,0.2,121,42392,74.4,NULL,NULL,'ESO 507- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101000,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101000,37.57,0.11,326,42393,70,NULL,NULL,'SDSS J124946.35-014505.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000067,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,192.443125,-1.75142,0.005,NULL,43115891837,673685809,10526340,18.6),(101001,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101001,33.33,0.57,46.3,42394,NULL,NULL,'I','CCC 115',NULL,'2003A&A...410..445M',2003,1,NULL,NULL,'G',NULL,NULL,'18.97',NULL,'dE','Group member',NULL,NULL,NULL,1,192.4439583,-41.36889,0.461,NULL,46754064484,730532257,11414566,18.97),(101002,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101002,37.69,0.46,346,42395,70,NULL,NULL,'2MASX J12494682+5447510',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000185,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,192.4452083,54.79758,0,NULL,57421044686,897203823,14018809,16.6),(101003,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101003,29.87,NULL,9.42,42396,NULL,NULL,NULL,'UGC 07983',NULL,'2013AJ....145..101K',2013,1,0.73,NULL,'G',0.00002,NULL,'16.2g',0.4,'Im:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.4459583,3.84231,0,NULL,58095265696,907738526,14183414,16.2),(101004,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101004,37.58,0.33,329,42397,70,NULL,NULL,'2MASX J12494910+2450372',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000113,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,192.454667,24.84375,0.037,NULL,58720866303,917513535,14336148,16.5),(101005,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101005,38.06,0.46,410,42398,70,NULL,NULL,'2MASX J12494988+5536170',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000149,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,192.4577083,55.60461,0,NULL,57428793146,897324892,14020701,17.8),(101006,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101006,31.34,0.43,18.5,42399,75,NULL,'3.6 micron, color + selection bias corrected','UGC 07982',NULL,'2014MNRAS.444..527S',2014,1,3.18,NULL,'G',0.000017,NULL,'13.8g',0.56,'Sd(f)','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.4592083,2.85128,0.041,NULL,58096894602,907763978,14183812,13.8),(101007,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101007,31.42,0.43,19.2,42399,75,NULL,'3.6 micron, color corrected','UGC 07982',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101008,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101008,31.46,0.36,19.6,42399,NULL,NULL,NULL,'UGC 07982',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101009,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101009,31.48,0.2,19.8,42399,74.4,NULL,NULL,'UGC 07982',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101010,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101010,31.59,0.4,20.8,42399,75,NULL,NULL,'UGC 07982',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101011,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101011,31.77,0.49,22.6,42399,75,NULL,'IR','UGC 07982',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101012,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101012,31.79,0.4,22.8,42399,NULL,NULL,NULL,'UGC 07982',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101013,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101013,37.14,0.46,268,42400,70,NULL,NULL,'LCRS B124716.5-022700',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000076,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,192.46175,-2.72214,0,NULL,43115834068,673684907,10526326,17.2),(101014,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101014,37.34,0.46,294,42401,70,NULL,NULL,'2MASX J12495106+1419535',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,192.462625,14.33164,0.056,NULL,59002564446,921915069,14404922,17.1),(101015,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101015,37.58,0.33,329,42402,70,NULL,NULL,'2MASX J12495123+2453553',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,192.463333,24.89853,0.037,NULL,58720977333,917515270,14336176,17),(101016,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101016,32.93,0.4,38.6,42403,75,NULL,'Edat, raw','2MASX J12495160-4113346',NULL,'1997ApJS..109..333W',1997,1,1.02,NULL,'G',0.00004,NULL,'14.64',0.82,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.464916667,-41.22617,0.461,NULL,46754048079,730532001,11414562,14.64),(101017,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101017,32.95,0.4,38.9,42403,75,NULL,'Edat, cor','2MASX J12495160-4113346',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101018,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101018,33.23,0.23,44.3,42403,74.4,NULL,NULL,'2MASX J12495160-4113346',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101019,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101019,38.3,0.46,457,42404,70,NULL,NULL,'2MASX J12495214+4958348',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000197,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,192.467167,49.97636,0,NULL,59095944329,923374130,14427720,16.5),(101020,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101020,37.15,0.46,270,42405,70,NULL,NULL,'2MASX J12495330+1722112',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,192.471958333,17.36972,0.057,NULL,58997109700,921829839,14403591,17.5),(101021,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101021,33.49,0.4,49.9,42406,NULL,NULL,'mean','IC 3812',NULL,'2007A&A...465...71T',2007,1,0.8,NULL,'G',0.000037,NULL,'13.19',0.2,'Sc',NULL,NULL,NULL,NULL,1,192.474167,-6.71744,0.037,NULL,43130024794,673906637,10529791,13.19),(101022,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101022,33.73,0.45,55.6,42406,NULL,NULL,'K','IC 3812',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101023,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101023,33.76,0.47,56.6,42406,NULL,NULL,'H','IC 3812',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101024,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101024,33.84,0.46,58.7,42406,NULL,NULL,'J','IC 3812',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101025,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101025,32.93,0.4,38.6,42407,75,NULL,'Edat, raw','NGC 4706',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000011,NULL,'13.93',0.6,'SAB(s)0^0^','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.475625,-41.27956,0.461,NULL,46754099991,730532812,11414575,13.93),(101026,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101026,32.95,0.4,38.9,42407,75,NULL,'Edat, cor','NGC 4706',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101027,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101027,33.41,0.23,48.1,42407,74.4,NULL,NULL,'NGC 4706',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101028,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101028,33.42,0.48,48.2,42407,70,NULL,NULL,'NGC 4706',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101029,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101029,33.6,0.4,52.4,42407,NULL,NULL,'mean','NGC 4706',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101030,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101030,33.65,0.45,53.7,42407,NULL,NULL,'K','NGC 4706',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101031,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101031,33.54,0.47,51.1,42408,NULL,NULL,'I','CCC 121',NULL,'2003A&A...410..445M',2003,1,NULL,NULL,'G',0.000207,NULL,'18.36',NULL,'dE','Group member',NULL,NULL,NULL,1,192.475375,-41.33933,0.461,NULL,46754101103,730532829,11414575,18.36),(101032,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101032,36.33,0.73,184,42409,70,NULL,NULL,'2MASX J12495422-1432265',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.47',0.4,NULL,NULL,NULL,NULL,NULL,1,192.475917,-14.54092,0.097,NULL,43971218813,687050293,10735160,16.47),(101033,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101033,37.81,0.33,365,42410,70,NULL,NULL,'2MASX J12495482+2652293',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'15.95',0.14,'SB0',NULL,NULL,NULL,NULL,1,192.4785,26.87481,0.023,NULL,58735552087,917743001,14339734,15.95),(101034,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101034,38.43,0.27,484,42411,70,NULL,NULL,'2MASX J12495498-0121245',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000093,NULL,'16.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,192.479083333,-1.35681,0.033,NULL,43103862497,673497851,10523403,16.4),(101035,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101035,32.86,0.45,37.3,42412,NULL,NULL,'I','CCC 123',NULL,'2003A&A...410..445M',2003,1,NULL,NULL,'G',0.000153,NULL,'18.45',NULL,'dS0','Group member',NULL,NULL,NULL,1,192.483333,-41.40122,0.461,NULL,46754059349,730532177,11414565,18.45),(101036,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101036,33.49,0.45,50,42413,NULL,NULL,'I','CCC 124',NULL,'2003A&A...410..445M',2003,1,NULL,NULL,'G',NULL,NULL,'20.02',NULL,'dE:','Group member',NULL,NULL,NULL,1,192.483917,-41.38972,0.461,NULL,46754059479,730532179,11414565,20.02),(101037,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101037,37.54,0.46,323,42414,70,NULL,NULL,'2MASX J12495631+1708433',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,192.484667,17.14528,0.055,NULL,58997187918,921831061,14403610,16.6),(101038,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101038,33.24,0.4,44.5,42415,NULL,NULL,'I','CCC 125',NULL,'2003A&A...410..445M',2003,1,0.66,NULL,'G',0.000117,NULL,'17.07',0.54,'dE','Group member',NULL,NULL,NULL,1,192.484625,-41.26031,0.461,NULL,46754092423,730532694,11414573,17.07),(101039,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101039,38.43,0.27,484,42416,70,NULL,NULL,'SDSS J124956.50-012449.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.0001,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,192.4854583,-1.41369,0.033,NULL,43103853370,673497708,10523401,18.5),(101040,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101040,38.89,0.46,600,42417,70,NULL,NULL,'SDSS J124956.59+243810.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'19.82',0.11,NULL,NULL,NULL,NULL,NULL,1,192.485833,24.63631,0.058,NULL,58721119823,917517497,14336210,19.82),(101041,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101041,37.57,0.11,326,42418,70,NULL,NULL,'SDSS J124957.22-013114.4',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000077,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,192.488458333,-1.52067,0.033,NULL,43102037293,673469332,10522958,18.4),(101042,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101042,37.94,0.33,387,42419,70,NULL,NULL,'2MASX J12495741+1256223',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.80',0.19,'BrClG',NULL,NULL,NULL,NULL,1,192.4892917,12.93956,0.065,NULL,58992293769,921754590,14402415,17.8),(101043,'IRAS','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101043,31.36,0.8,18.7,42420,75,NULL,'A82, H','NGC 4713',NULL,'1997ApJS..109..333W',1997,1,2.28,NULL,'G',0.000002,NULL,'12.4g',1.56,'SAB(rs)d;HII   LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,192.491125,5.31142,0,NULL,58100529050,907820766,14184699,12.4),(101044,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101044,27.66,0.69,3.4,42420,100,NULL,'mid-IR','NGC 4713',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101045,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101045,30.19,0.4,10.9,42420,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 4713',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101046,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101046,30.68,0.43,13.7,42420,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4713',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101047,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101047,30.86,0.43,14.8,42420,75,NULL,'3.6 micron, color corrected','NGC 4713',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101048,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101048,30.87,0.35,14.9,42420,NULL,NULL,NULL,'NGC 4713',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101049,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101049,30.97,0.2,15.6,42420,74.4,NULL,NULL,'NGC 4713',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101050,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101050,31.02,0.47,16,42420,75,NULL,'A82, H, inv','NGC 4713',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101051,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101051,31.08,0.47,16.4,42420,75,NULL,'A82, H, raw','NGC 4713',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101052,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101052,31.11,0.45,16.7,42420,NULL,NULL,NULL,'NGC 4713',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101053,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101053,31.17,0.44,17.1,42420,NULL,NULL,'Malmquist cor.','NGC 4713',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101054,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101054,31.26,0.4,17.9,42420,75,NULL,'B','NGC 4713',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101055,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101055,31.35,0.47,18.7,42420,75,NULL,'A82, H, cor','NGC 4713',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101056,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101056,35.1,0.4,105,42421,NULL,NULL,'mean','NGC 4715',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000133,NULL,'14.1',1.7,'SA0+',NULL,NULL,NULL,NULL,1,192.491167,27.82242,0.042,NULL,58727313004,917614265,14337722,14.1),(101057,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101057,35.61,0.45,132,42421,NULL,NULL,'K','NGC 4715',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101058,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101058,38,0.46,398,42422,70,NULL,NULL,'2MASX J12495795+0616378',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000178,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,192.4914583,6.27725,0,NULL,58073961614,907405650,14178213,16.6),(101059,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101059,35.24,0.2,112,42423,74.4,NULL,NULL,'VCC 2082',NULL,'2013AJ....146...86T',2013,1,0.72,NULL,'G',0.000082,NULL,'16.3g',0.2,'S','Group member',NULL,NULL,NULL,1,192.4927083,11.26389,0.026,NULL,58956017652,921187775,14393558,16.3),(101060,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101060,37.11,0.46,264,42424,70,NULL,NULL,'2MASX J12495856+0609438',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,192.493875,6.16208,0,NULL,58073958791,907405606,14178212,17.7),(101061,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101061,39,0.46,632,42425,70,NULL,NULL,'SDSS J124958.99+570554.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,192.495833,57.09844,0,NULL,57430647815,897353872,14021154,18.4),(101062,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101062,38.43,0.27,484,42426,70,NULL,NULL,'2MASX J12495912-0123005',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000104,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,192.4962083,-1.38342,0.033,NULL,43103851784,673497684,10523401,17.3),(101063,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101063,39.06,0.46,648,42427,70,NULL,NULL,'2MASX J12495963-0215195',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000094,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,192.498417,-2.25564,0,NULL,43116197873,673690591,10526415,17.5),(101064,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101064,37.57,0.11,326,42428,70,NULL,NULL,'SDSS J125000.38-013717.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000075,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,192.501625,-1.62161,0,NULL,43102015763,673468996,10522953,18.2),(101065,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101065,36.41,0.58,191,42429,70,NULL,NULL,'6dF J1250017-151255',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'16.4b',0.3,'S0','Group member',NULL,NULL,NULL,1,192.507375,-15.21514,0.065,NULL,43963535706,686930245,10733285,16.4),(101066,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101066,36.48,0.46,198,42430,70,NULL,NULL,'2MASX J12500214+6235451',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.00018,NULL,'15.9g',0.41,'E0',NULL,NULL,NULL,NULL,1,192.50925,62.59603,0.033,NULL,57362562890,896290045,14004531,15.9),(101067,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101067,33.08,0.25,41.3,42431,74.4,NULL,NULL,'IC 3813',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.00011,NULL,'14.02',1,'SAB(r)0^+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.509667,-25.92069,0.333,NULL,43423508244,678492316,10601442,14.02),(101068,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101068,33.42,0.4,48.2,42431,NULL,NULL,'mean','IC 3813',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101069,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101069,33.98,0.45,62.5,42431,NULL,NULL,'K','IC 3813',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101070,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101070,37.4,0.46,302,42432,70,NULL,NULL,'2MASX J12500369+5032342',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,192.515375,50.54294,0,NULL,57203815792,893809621,13965775,17),(101071,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101071,36.73,0.46,221,42433,70,NULL,NULL,'2MASX J12500383+4142435',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,192.516,41.71217,0,NULL,59085192645,923206135,14425095,17.1),(101072,'GCLF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101072,32.32,0.33,29.1,42434,NULL,NULL,NULL,'NGC 4709',NULL,'2005A&A...438..103M',2005,1,2.4,NULL,'G',0.000014,NULL,'12.0',2,'E1','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.516166667,-41.38197,0.461,NULL,46754089875,730532654,11414572,12),(101073,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101073,32.5,0.15,31.6,42434,NULL,NULL,'I','NGC 4709',NULL,'2003A&A...410..445M',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101074,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101074,32.74,0.23,35.3,42434,NULL,NULL,'I','NGC 4709',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101075,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101075,32.74,0.23,35.3,42434,NULL,NULL,NULL,'NGC 4709',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101076,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101076,32.85,0.12,37.2,42434,74.4,NULL,NULL,'NGC 4709',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101077,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101077,32.88,0.17,37.7,42434,NULL,NULL,'I','NGC 4709',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101078,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101078,32.89,0.23,37.8,42434,NULL,NULL,'Malmquist cor.','NGC 4709',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101079,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101079,33.04,0.17,40.6,42434,NULL,NULL,NULL,'NGC 4709',NULL,'2001ApJ...550..503J',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101080,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101080,32.78,0.4,35.9,42434,75,NULL,'Edat, raw','NGC 4709',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101081,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101081,32.78,0.4,35.9,42434,75,NULL,'Edat, raw','NGC 4709',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101082,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101082,32.88,0.4,37.6,42434,75,NULL,'Edat, cor','NGC 4709',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101083,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101083,32.88,0.4,37.6,42434,75,NULL,'Edat, cor','NGC 4709',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101084,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101084,32.85,0.12,37.2,42434,74.4,NULL,NULL,'NGC 4709',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101085,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101085,33.14,0.41,42.5,42434,NULL,NULL,NULL,'NGC 4709',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101086,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101086,33.2,0.47,43.7,42434,70,NULL,NULL,'NGC 4709',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101087,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101087,33.38,0.41,47.4,42434,NULL,NULL,'Malmquist cor.','NGC 4709',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101088,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101088,33.27,0.45,45.1,42434,NULL,NULL,'K','NGC 4709',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101089,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101089,34.04,0.4,64.3,42434,NULL,NULL,'mean','NGC 4709',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101090,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101090,36.57,0.57,206,42435,70,NULL,NULL,'2MASX J12500482-2304225',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.4,NULL,NULL,NULL,NULL,NULL,1,192.520083333,-23.07283,0.193,NULL,43906801003,686043765,10719433,14.2),(101091,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101091,38.13,0.33,424,42436,70,NULL,NULL,'2MASX J12500517+0134091',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000074,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,192.5215,1.56917,0,NULL,58085404035,907584438,14181006,17.2),(101092,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101092,37.23,0.33,279,42437,70,NULL,NULL,'2MASX J12500672+4035495',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000183,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,192.528125,40.59725,0,NULL,59085625022,923212890,14425201,16.5),(101093,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101093,37.47,0.46,312,42438,70,NULL,NULL,'2MASX J12500710+5015222',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000144,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,192.529583,50.25614,0,NULL,57203698315,893807786,13965746,17.3),(101094,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101094,35.41,0.46,121,42439,70,NULL,NULL,'NGC 4732',NULL,'2015arXiv151105856S',2015,1,1.04,'The position in 1999A&AS..140...89P is 7.5\\\" east of the nucleus.','G',0.000087,NULL,'14.4g',0.7,'E',NULL,NULL,NULL,NULL,1,192.529583,52.85011,0,NULL,57200891072,893763923,13965061,14.4),(101095,'Tully est','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101095,32.09,0.8,26.1,42439,75,NULL,'B','NGC 4750',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101096,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101096,32.82,0.25,36.6,42440,74.4,NULL,NULL,'AM 1247-410',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.00006,NULL,'15.04',0.3,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.53225,-41.398,0.461,NULL,46754089270,730532644,11414572,15.04),(101097,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101097,38.56,0.46,515,42441,70,NULL,NULL,'2MASX J12500858+0054581',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000087,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,192.5357917,0.91619,0,NULL,58086052620,907594572,14181165,18),(101098,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101098,38.16,0.46,428,42442,70,NULL,NULL,'2MASX J12501075+5430540',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,192.544583,54.51511,0,NULL,57420447758,897194496,14018664,18.1),(101099,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101099,32.93,0.4,38.6,42443,75,NULL,'Edat, raw','2MASX J12501152-4113155',NULL,'1997ApJS..109..333W',1997,1,0.92,NULL,'G',0.000008,NULL,'15.35',0.79,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.547833333,-41.22142,0.461,NULL,46754091679,730532682,11414573,15.35),(101100,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101100,32.95,0.4,38.9,42443,75,NULL,'Edat, cor','2MASX J12501152-4113155',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101101,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101101,33.2,0.23,43.7,42443,74.4,NULL,NULL,'2MASX J12501152-4113155',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101102,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101102,33.51,0.23,50.4,42444,74.4,NULL,NULL,'2MASX J12501186-4117565',NULL,'2013AJ....146...86T',2013,1,0.67,NULL,'G',0.000037,NULL,'16',0.62,'dE','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.549167,-41.2995,0.461,NULL,46754102179,730532846,11414575,16),(101103,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101103,37.23,0.27,279,42445,70,NULL,NULL,'2MASXi J1250119-001935',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00007,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,192.5500417,-0.32656,0.01,NULL,43104120799,673501887,10523466,17.7),(101104,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101104,35.95,0.57,155,42446,70,NULL,NULL,'2MASX J12501214-1949475',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.3,NULL,NULL,NULL,NULL,NULL,1,192.550583333,-19.82983,0.089,NULL,43912721705,686136276,10720879,14),(101105,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101105,37.77,0.46,358,42447,70,NULL,NULL,'SDSS J125012.27+031518.2',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000086,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,192.551125,3.25506,0.029,NULL,58094477307,907726207,14183221,16.9),(101106,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101106,32.93,0.4,38.6,42448,75,NULL,'Edat, raw','ESO 323- G 005',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.00008,NULL,'14.1',0.5,'S0: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.551167,-41.51489,0.461,NULL,46754129233,730533269,11414582,14.1),(101107,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101107,32.95,0.4,38.9,42448,75,NULL,'Edat, cor','ESO 323- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101108,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101108,33.17,0.25,43.1,42448,74.4,NULL,NULL,'ESO 323- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101109,'Tully est','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101109,33.33,0.8,46.4,42448,75,NULL,NULL,'ESO 323- G 005',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101110,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101110,35.31,0.05,115,42449,70,NULL,NULL,'2MASX J12501346+2646335',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.00008,NULL,'14.35',0.64,NULL,NULL,NULL,NULL,NULL,1,192.556083,26.77608,0.023,NULL,58735533782,917742715,14339729,14.35),(101111,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101111,38.07,0.46,411,42450,70,NULL,NULL,'2MASX J12501349+1126333',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000181,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,192.5562083,11.44278,0.071,NULL,58955991981,921187374,14393552,17.6),(101112,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101112,37.84,0.46,369,42451,70,NULL,NULL,'2MASXi J1250146+345344',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,192.561333,34.89569,0.013,NULL,58738702457,917792225,14340503,17.3),(101113,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101113,38.47,0.33,495,42452,70,NULL,NULL,'SDSS J125016.55+312350.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000154,NULL,'18.8g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,192.5689583,31.3975,0.046,NULL,58748985943,917952905,14343014,18.8),(101114,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101114,37.92,0.46,384,42453,70,NULL,NULL,'2MASX J12501727+6650460',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000097,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,192.5722083,66.84619,0.057,NULL,57855529251,903992644,14124885,16.8),(101115,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101115,38.18,0.46,433,42454,70,NULL,NULL,'2MASX J12501829+3133280',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00014,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,192.57625,31.55783,0.031,NULL,58748964572,917952571,14343008,18.1),(101116,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101116,37.59,0.27,330,42455,70,NULL,NULL,'2MASX J12501839+3034460',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00016,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,192.576625,30.57953,0.035,NULL,58779262661,918425979,14350405,16.8),(101117,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101117,38.47,0.33,495,42456,70,NULL,NULL,'2MASX J12501844+3123340',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,192.57675,31.39261,0.046,NULL,58748986088,917952907,14343014,17.4),(101118,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101118,37.95,0.46,389,42457,70,NULL,NULL,'SDSS J125018.91+235631.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'19.45',0.15,NULL,NULL,NULL,NULL,NULL,1,192.5787917,23.94208,0.098,NULL,58602998707,915671854,14307372,19.45),(101119,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101119,37.23,0.27,279,42458,70,NULL,NULL,'2MASX J12501913-0024058',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000065,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,192.5797083,-0.40161,0.039,NULL,43104303671,673504744,10523511,17.5),(101120,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101120,37.77,0.33,358,42459,70,NULL,NULL,'LCRS B124744.7-025409',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000085,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,192.580166667,-3.17458,0.017,NULL,43108029899,673562967,10524421,16.8),(101121,'IRAS','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101121,32.02,0.8,25.4,42460,75,NULL,'HMCL, I','ESO 268- G 046',NULL,'1997ApJS..109..333W',1997,1,2.3,'Position in 1982MNRAS.200..325L is in error.','G',0.000017,NULL,'14.41',0.7,'IB(s)m',NULL,NULL,NULL,NULL,1,192.5829583,-44.42586,0.373,NULL,46773875219,730841800,11419403,14.41),(101122,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101122,31.68,0.2,21.7,42460,74.4,NULL,NULL,'ESO 268- G 046',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101123,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101123,31.85,0.4,23.4,42460,NULL,NULL,NULL,'ESO 268- G 046',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101124,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101124,31.92,0.4,24.2,42460,75,NULL,'HMCL, I, inv','ESO 268- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101125,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101125,31.93,0.4,24.3,42460,75,NULL,'HMCL, I, raw','ESO 268- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101126,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101126,32.02,0.61,25.3,42460,NULL,NULL,NULL,'ESO 268- G 046',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101127,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101127,32.26,0.4,28.4,42460,75,NULL,'HMCL, I, cor','ESO 268- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101128,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101128,32.42,0.51,30.4,42460,NULL,NULL,'Malmquist cor.','ESO 268- G 046',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101129,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101129,38.44,0.46,487,42461,70,NULL,NULL,'2MASX J12502032+6458044',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,192.5850417,64.96789,0.033,NULL,57366321347,896348771,14005449,18),(101130,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101130,37.23,0.33,279,42462,70,NULL,NULL,'2MASX J12502147+4032356',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,192.589416667,40.54319,0,NULL,59085630380,923212974,14425202,16.8),(101131,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101131,37.58,0.46,328,42463,70,NULL,NULL,'2MASX J12502194+1822340',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.43',0.14,NULL,NULL,NULL,NULL,NULL,1,192.5915,18.37628,0.057,NULL,59027294022,922301469,14410960,18.43),(101132,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,NULL,101132,35.91,0.57,152,42464,70,NULL,NULL,'2MASX J12502295-1825275',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000113,NULL,'16.25',0.3,NULL,NULL,NULL,NULL,NULL,1,192.595791667,-18.42433,0.081,NULL,43982391042,687224860,10737888,16.25),(101133,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101133,37.9,0.33,381,42465,70,NULL,NULL,'2MASX J12502359+2524076',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,192.5985417,25.40211,0.031,NULL,58724111304,917564239,14336941,17.2),(101134,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101134,36.95,0.46,245,42466,70,NULL,NULL,'2MASX J12502467+0807503',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,192.6027083,8.13053,0,NULL,58081652637,907525822,14180090,16.6),(101135,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101135,37.33,0.46,293,42467,70,NULL,NULL,'2MASX J12502513+5409243',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,192.604917,54.15672,0.017,NULL,57420331622,897192681,14018635,17.8),(101136,'FP','2016-12-15 15:15:06','2016-12-16 11:20:17','1',NULL,'R',101136,35.33,0.46,116,42468,70,NULL,NULL,'CGCG 244-044',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000184,NULL,'14.9g',0.6,'E0',NULL,NULL,NULL,NULL,1,192.6057083,48.08169,0,NULL,59095254753,923363355,14427552,14.9),(101137,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101137,37.94,0.33,387,42469,70,NULL,NULL,'SDSS J125025.67+130155.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000149,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,192.607,13.03222,0.065,NULL,58992231833,921753622,14402400,18.7),(101138,'Cepheids','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101138,30.37,0.1,11.9,42470,NULL,NULL,'LMC W01','NGC 4725',NULL,'2001ApJ...548..564W',2001,1,10.7,NULL,'G',0.00001,NULL,'10.11',7.6,'SAB(r)ab pec   Sy2','in a radial-velocity based grouping',NULL,NULL,'Sy 2',1,192.61075,25.50081,0.031,NULL,58724104783,917564137,14336939,10.11),(101139,'Cepheids','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101139,30.38,0.06,11.9,42470,NULL,NULL,'15, VI, KEY PROJECT','NGC 4725',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101140,'Cepheids','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101140,30.39,0.07,12,42470,NULL,NULL,'cte LMC K03','NGC 4725',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101141,'Cepheids','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101141,30.4,0.07,12,42470,NULL,NULL,'cte U99','NGC 4725',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101142,'Cepheids','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101142,30.43,0.07,12.2,42470,NULL,NULL,'cte LMC STS02','NGC 4725',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101143,'Cepheids','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101143,30.44,0.06,12.2,42470,NULL,NULL,'MW HIPP','NGC 4725',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101144,'Cepheids','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101144,30.46,0.06,12.4,42470,NULL,NULL,'15, VI, +Z, KEY PROJECT','NGC 4725',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101145,'Cepheids','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101145,30.46,0.18,12.4,42470,NULL,NULL,'MW P02','NGC 4725',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101146,'Cepheids','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101146,30.49,0.07,12.5,42470,NULL,NULL,'cte MW FSG03','NGC 4725',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101147,'Cepheids','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101147,30.5,0.08,12.6,42470,74.4,NULL,NULL,'NGC 4725',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101148,'Cepheids','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101148,30.52,0.07,12.7,42470,NULL,NULL,'cte MF91','NGC 4725',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101149,'Cepheids','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101149,30.53,0.11,12.8,42470,NULL,NULL,'53, VI','NGC 4725',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101150,'Cepheids','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101150,30.53,0.11,12.8,42470,NULL,NULL,'MW GFG','NGC 4725',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101151,'Cepheids','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101151,30.54,0.07,12.8,42470,NULL,NULL,'cte MW GFG98','NGC 4725',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101152,'Cepheids','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101152,30.57,0.08,13,42470,NULL,NULL,'13, VI','NGC 4725',NULL,'1999ApJ...512...48G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101153,'Cepheids','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101153,30.57,0.08,13,42470,NULL,NULL,'HST KP Calibrated','NGC 4725',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101154,'Cepheids','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101154,30.62,0.07,13.3,42470,NULL,NULL,'cte MW STS03','NGC 4725',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101155,'Cepheids','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101155,30.65,NULL,13.5,42470,NULL,18.54,NULL,'NGC 4725',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101156,'Cepheids','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101156,30.65,0.06,13.5,42470,NULL,18.54,'LMC ZP','NGC 4725',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101157,'Cepheids','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101157,31.38,NULL,18.9,42470,NULL,NULL,'20, VI','NGC 4725',NULL,'2006A&A...452..423P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101158,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101158,30.45,0.34,12.3,42470,NULL,NULL,'I','NGC 4725',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101159,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101159,30.5,0.08,12.6,42470,74.4,NULL,NULL,'NGC 4725',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101160,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101160,30.61,0.34,13.2,42470,NULL,NULL,'I','NGC 4725',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101161,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101161,30.61,0.34,13.2,42470,NULL,NULL,NULL,'NGC 4725',NULL,'2001ApJ...550..503J',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101162,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101162,30.67,0.35,13.6,42470,NULL,NULL,'HST KP Calibrated, I','NGC 4725',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101163,'IRAS','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101163,31.68,0.8,21.6,42470,75,NULL,'A82, H','NGC 4725',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101164,'Sosies','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101164,30.81,0.15,14.5,42470,NULL,NULL,NULL,'NGC 4725',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101165,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101165,29.9,0.69,9.55,42470,100,NULL,'mid-IR','NGC 4725',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101166,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101166,30.14,0.32,10.7,42470,NULL,NULL,'I','NGC 4725',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101167,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101167,30.22,NULL,11.1,42470,NULL,NULL,'I','NGC 4725',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101168,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101168,30.23,0.23,11.1,42470,NULL,NULL,'B','NGC 4725',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101169,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101169,30.26,NULL,11.3,42470,NULL,NULL,'B','NGC 4725',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101170,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101170,30.37,0.47,11.9,42470,NULL,NULL,NULL,'NGC 4725',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101171,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101171,30.45,0.45,12.3,42470,NULL,NULL,'Malmquist cor.','NGC 4725',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101172,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101172,30.46,0.06,12.4,42470,75,NULL,NULL,'NGC 4725',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101173,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101173,30.47,0.4,12.4,42470,75,NULL,'B','NGC 4725',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101174,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101174,30.5,0.08,12.6,42470,74.4,NULL,NULL,'NGC 4725',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101175,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101175,30.5,0.35,12.6,42470,NULL,NULL,NULL,'NGC 4725',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101176,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101176,30.7,0.43,13.8,42470,75,NULL,'3.6 micron, color corrected','NGC 4725',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101177,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101177,30.78,0.3,14.3,42470,55,NULL,'B','NGC 4725',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101178,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101178,30.77,0.43,14.3,42470,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4725',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101179,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101179,31.03,0.4,16.1,42470,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 4725',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101180,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101180,31.3,0.47,18.2,42470,75,NULL,'A82, H, raw','NGC 4725',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101181,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101181,31.4,NULL,19.1,42470,NULL,NULL,'LEDA [April 2006]','NGC 4725',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101182,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101182,31.47,0.47,19.7,42470,75,NULL,'A82, H, cor','NGC 4725',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101183,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101183,31.57,0.47,20.6,42470,75,NULL,'A82, H, inv','NGC 4725',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101184,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101184,31.55,NULL,20.4,42471,NULL,NULL,NULL,'UGC 07990',NULL,'2013AJ....145..101K',2013,1,1,NULL,'G',0.000013,NULL,'17.',0.6,'Im',NULL,NULL,NULL,NULL,1,192.6135,28.35281,0.014,NULL,58727680336,917620005,14337812,17),(101185,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101185,37.9,0.33,381,42472,70,NULL,NULL,'2MASX J12502781+2519506',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,192.6159583,25.33086,0.085,NULL,58724067891,917563560,14336930,17.6),(101186,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101186,38.52,0.46,506,42473,70,NULL,NULL,'2MASX J12502865+2427516',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,192.619333,24.46425,0.058,NULL,58720400261,917506254,14336035,17.5),(101187,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101187,37.48,0.46,313,42474,70,NULL,NULL,'2MASX J12502864+6209125',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000145,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,192.619375,62.15367,0,NULL,57362962240,896296285,14004629,18.4),(101188,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101188,33.35,0.25,46.8,42475,74.4,NULL,NULL,'ESO 507- G 021',NULL,'2013AJ....146...86T',2013,1,1.8,NULL,'G',0.00006,NULL,'13.74',0.7,'SA0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.6194583,-26.84267,0.301,NULL,43434044374,678656943,10604014,13.74),(101189,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101189,33.1,0.45,41.8,42475,NULL,NULL,'K','ESO 507- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101190,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101190,33.41,0.4,48,42475,NULL,NULL,'mean','ESO 507- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101191,'Tully est','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101191,32.76,0.8,35.7,42476,75,NULL,NULL,'DDO 151',NULL,'1988NBGC.C....0000T',1988,1,3.2,NULL,'G',0.000017,NULL,'14.17',1.5,'SB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.6225417,-10.85442,0.085,NULL,43839762638,684996291,10703067,14.17),(101192,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101192,32.15,0.4,26.9,42476,NULL,NULL,NULL,'DDO 151',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101193,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101193,32.44,0.2,30.8,42476,74.4,NULL,NULL,'DDO 151',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101194,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101194,32.53,0.43,32,42476,75,NULL,'3.6 micron, color corrected','DDO 151',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101195,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101195,32.65,0.43,33.8,42476,75,NULL,'3.6 micron, color + selection bias corrected','DDO 151',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101196,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101196,37.82,0.12,367,42477,70,NULL,NULL,'2MASX J12502968+5501264',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000174,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,192.623583,55.02392,0,NULL,57420664077,897197876,14018716,17.6),(101197,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101197,38.85,0.46,588,42478,70,NULL,NULL,'2MASX J12503054-0121308',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000095,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,192.627167,-1.35858,0.029,NULL,43103826041,673497281,10523395,18.2),(101198,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101198,37.26,0.46,283,42479,70,NULL,NULL,'2MASX J12503104+1138433',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000175,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,192.629417,11.64531,0.089,NULL,58989146887,921705420,14401647,16.8),(101199,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101199,33.85,NULL,58.9,42480,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07993',NULL,'2010Ap&SS.325..163P',2010,1,2.52,NULL,'G',0.000013,NULL,'14.8g',0.31,'Sc',NULL,NULL,NULL,NULL,1,192.631583,52.12292,0,NULL,57209641752,893900652,13967197,14.8),(101200,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101200,33.86,NULL,59,42480,NULL,NULL,'Dipole + Quadrupole','UGC 07993',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101201,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101201,33.86,NULL,59.1,42480,NULL,NULL,'Dipole','UGC 07993',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101202,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101202,34.04,0.49,64.4,42480,75,NULL,'IR','UGC 07993',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101203,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101203,34.38,0.2,75.2,42480,74.4,NULL,NULL,'UGC 07993',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101204,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101204,34.47,0.45,78.2,42480,NULL,NULL,'Malmquist cor.','UGC 07993',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101205,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101205,34.56,0.43,81.7,42480,NULL,NULL,NULL,'UGC 07993',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101206,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101206,38.5,0.46,502,42481,70,NULL,NULL,'2MASX J12503247+3542246',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000196,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,192.635291667,35.70686,0.029,NULL,58556075890,914938685,14295916,17.1),(101207,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101207,33.84,0.37,58.7,42482,NULL,NULL,NULL,'NGC 4718',NULL,'2009ApJS..182..474S',2009,1,1.8,'Confused HIPASS source','G',0.000013,NULL,'12.00',0.6,'SB(rs)b? sp',NULL,NULL,NULL,NULL,1,192.636,-5.28192,0.037,NULL,43134576540,673977758,10530902,12),(101208,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101208,33.88,0.37,59.7,42482,NULL,NULL,'Malmquist cor.','NGC 4718',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101209,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101209,33.88,0.2,59.7,42482,74.4,NULL,NULL,'NGC 4718',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101210,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101210,34,0.47,63.2,42482,NULL,NULL,'H','NGC 4718',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101211,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101211,34.1,0.46,66,42482,NULL,NULL,'J','NGC 4718',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101212,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101212,34.14,0.4,67.4,42482,NULL,NULL,'mean','NGC 4718',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101213,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101213,34.18,0.45,68.7,42482,NULL,NULL,'K','NGC 4718',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101214,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101214,32.78,0.4,35.9,42483,75,NULL,'Edat, raw','ESO 323- G 008',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000019,NULL,'14.60',0.3,'S0','Group member',NULL,NULL,NULL,1,192.6432083,-41.47086,0.465,NULL,46754161447,730533772,11414590,14.6),(101215,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101215,32.88,0.4,37.6,42483,75,NULL,'Edat, cor','ESO 323- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101216,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101216,33.12,0.23,42.1,42483,74.4,NULL,NULL,'ESO 323- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101217,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101217,34.12,0.51,66.6,42483,70,NULL,NULL,'ESO 323- G 008',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101218,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101218,34.15,0.45,67.6,42483,NULL,NULL,'K','ESO 323- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101219,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101219,34.36,0.4,74.4,42483,NULL,NULL,'mean','ESO 323- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101220,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101220,37.33,0.46,292,42484,70,NULL,NULL,'2MASX J12503488+0554370',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000183,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,192.645333,5.91039,0,NULL,58070459408,907350928,14177358,16.8),(101221,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101221,37.82,0.46,366,42485,70,NULL,NULL,'2MASX J12503541+5023072',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000175,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,192.647833333,50.38525,0,NULL,57203572751,893805824,13965716,17.9),(101222,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101222,35.99,0.49,158,42486,75,NULL,'IR','2MFGC 10124',NULL,'2011yCatp016004901K',2011,1,0.6,NULL,'G',0.000033,NULL,'15.7R',0.16,'Sb','Group member',NULL,NULL,NULL,1,192.6520417,-15.19836,0.065,NULL,43963602922,686931295,10733301,15.7),(101223,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101223,37.67,0.46,343,42487,70,NULL,NULL,'2MASX J12503809+0445070',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,192.658917,4.75206,0,NULL,58100021395,907812834,14184575,17.3),(101224,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101224,31.48,0.43,19.8,42488,75,NULL,'3.6 micron, color + selection bias corrected','UGC 07991',NULL,'2014MNRAS.444..527S',2014,1,2.55,'HOLM 467B is a star.','G',0.000014,NULL,'14.6g',0.38,'Sd(f)',NULL,NULL,NULL,NULL,1,192.662333,1.46453,0,NULL,58085346990,907583546,14180992,14.6),(101225,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101225,31.59,0.43,20.8,42488,75,NULL,'3.6 micron, color corrected','UGC 07991',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101226,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101226,31.62,0.2,21.1,42488,74.4,NULL,NULL,'UGC 07991',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101227,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101227,31.8,0.58,22.9,42488,NULL,NULL,'Malmquist cor.','UGC 07991',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101228,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101228,31.86,0.57,23.5,42488,NULL,NULL,NULL,'UGC 07991',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101229,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101229,32.03,0.49,25.5,42488,75,NULL,'IR','UGC 07991',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101230,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101230,32.13,0.4,26.7,42488,75,NULL,NULL,'UGC 07991',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101231,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101231,32.58,NULL,32.8,42488,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 07991',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101232,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101232,32.59,NULL,33,42488,NULL,NULL,'Dipole + Quadrupole','UGC 07991',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101233,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101233,32.6,NULL,33.1,42488,NULL,NULL,'Dipole','UGC 07991',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101234,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101234,32.67,NULL,34.2,42488,NULL,NULL,NULL,'UGC 07991',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101235,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101235,37.36,0.46,296,42489,70,NULL,NULL,'2MASX J12504032+2151515',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.70',0.19,NULL,NULL,NULL,NULL,NULL,1,192.668167,21.86439,0.146,NULL,58890565255,920165082,14377579,17.7),(101236,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101236,37.83,0.46,368,42490,70,NULL,NULL,'2MASX J12504041+1348568',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000153,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,192.6682917,13.81586,0.064,NULL,58991654989,921744609,14402259,17.4),(101237,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101237,37.88,0.46,377,42491,70,NULL,NULL,'2MASX J12504054-0121408',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000095,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,192.6690417,-1.36139,0.029,NULL,43103828293,673497317,10523395,17),(101238,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101238,34.72,0.54,87.9,42492,NULL,NULL,'Malmquist cor.','ESO 575- G 004',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000024,NULL,'14.80',0.8,'S              HII',NULL,NULL,NULL,NULL,1,192.670333,-20.33503,0.117,NULL,43912378173,686130908,10720795,14.8),(101239,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101239,34.94,0.49,97.5,42492,NULL,NULL,NULL,'ESO 575- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101240,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101240,34.98,0.2,99.1,42492,74.4,NULL,NULL,'ESO 575- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101241,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101241,37.72,0.46,351,42493,70,NULL,NULL,'2MASX J12504224+3524466',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,192.675917,35.41283,NULL,NULL,58554873867,914919904,14295623,17.5),(101242,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101242,37.52,0.46,319,42494,70,NULL,NULL,'2MASX J12504265+0512360',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,192.677625,5.21008,0,NULL,58100310270,907817347,14184646,17.4),(101243,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101243,31.53,0.4,20.2,42495,NULL,NULL,NULL,'NGC 4720',NULL,'2013MNRAS.429.2677K',2013,1,0.65,'Confused HIPASS source','G',0.00002,NULL,'13.4',0.35,'S0-?',NULL,NULL,NULL,NULL,1,192.67825,-4.15583,0.045,NULL,43108585410,673571647,10524556,13.4),(101244,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101244,32.93,0.4,38.6,42496,75,NULL,'Edat, raw','ESO 323- G 009',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000067,NULL,'14.39',0.5,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.679416667,-41.43022,0.465,NULL,46754111162,730532986,11414577,14.39),(101245,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101245,32.95,0.4,38.9,42496,75,NULL,'Edat, cor','ESO 323- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101246,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101246,32.99,0.23,39.6,42496,74.4,NULL,NULL,'ESO 323- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101247,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101247,32.87,0.4,37.5,42496,NULL,NULL,'mean','ESO 323- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101248,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101248,33.41,0.45,48.1,42496,NULL,NULL,'K','ESO 323- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101249,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101249,37.99,0.46,397,42497,70,NULL,NULL,'SDSS J125044.36+011346.4',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000086,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,192.684875,1.22958,0.024,NULL,58085907778,907592309,14181129,17.4),(101250,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101250,37.32,0.46,291,42498,70,NULL,NULL,'SDSS J125045.17+513731.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000182,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,192.68825,51.62542,0,NULL,57210038004,893906843,13967294,17.4),(101251,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101251,38.33,0.46,464,42499,70,NULL,NULL,'2MASX J12504640+0525490',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,192.6932083,5.43039,0,NULL,58100280874,907816888,14184638,17.4),(101252,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101252,33.71,0.51,55.3,42500,70,NULL,NULL,'ESO 323- G 011',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.66',0.4,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.69425,-41.89453,0.473,NULL,46753967851,730530747,11414542,14.66),(101253,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101253,37.62,0.33,335,42501,70,NULL,NULL,'SDSS J125046.70+090411.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,192.694583,9.06992,0,NULL,58069313530,907333023,14177078,17.9),(101254,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101254,37.62,0.33,335,42502,70,NULL,NULL,'2MASX J12504699+0905465',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.45',0.28,NULL,NULL,NULL,NULL,NULL,1,192.695667,9.09614,0,NULL,58069315321,907333051,14177078,17.45),(101255,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101255,37.23,0.27,279,42503,70,NULL,NULL,'2MASX J12504792-0014242',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000077,NULL,'17.2g',0.23,'NLAGN',NULL,NULL,NULL,NULL,1,192.699625,-0.24025,0.01,NULL,43103057652,673485275,10523207,17.2),(101256,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101256,38.32,0.46,462,42504,70,NULL,NULL,'SDSS J125049.03+585621.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000139,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,192.704333,58.93942,0,NULL,57440687947,897510749,14023605,18.4),(101257,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101257,38.21,0.46,439,42505,70,NULL,NULL,'2MASX J12505014+1820546',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,192.709,18.34839,0.059,NULL,59027297490,922301523,14410961,17.8),(101258,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101258,37.53,0.46,320,42506,70,NULL,NULL,'2MASX J12505053-0135312',NULL,'2015arXiv151105856S',2015,1,0.34,'This galaxy lenses a z = 0.353 object.','G',0.000102,NULL,'16.8g',0.26,'S0/SA',NULL,NULL,NULL,NULL,1,192.7105,-1.59211,0.005,NULL,43115881375,673685646,10526338,16.8),(101259,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101259,37.58,0.46,328,42507,70,NULL,NULL,'2MASX J12505084+4654271',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000142,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,192.711667,46.90747,0,NULL,59094733029,923355203,14427425,17),(101260,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101260,36.18,0.46,172,42508,70,NULL,NULL,'2MASX J12505144+0500380',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'16.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,192.714333333,5.01056,0,NULL,58099831650,907809869,14184529,16.6),(101261,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101261,37.82,0.12,367,42509,70,NULL,NULL,'2MASX J12505290+5454584',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000214,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,192.720417,54.91628,0,NULL,57420746528,897199164,14018736,17.2),(101262,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101262,35.26,0.46,113,42510,70,NULL,NULL,'NGC 4737',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000093,NULL,'15.3',0.4,NULL,NULL,NULL,NULL,NULL,1,192.720583333,34.15686,0.016,NULL,58738584511,917790382,14340474,15.3),(101263,'PNLF','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101263,28.21,0.06,4.39,42511,NULL,NULL,NULL,'MESSIER 094',NULL,'2008ApJ...683..630H',2008,1,11.2,'IRAS F12485+4123 (in FSC version 1) was removed from version 2.','G',0.000005,NULL,'8.99',9.1,'(R)SA(r)ab;Sy2 LINER','Possible field galaxy',NULL,NULL,'Sy',1,192.721083333,41.12044,0,NULL,59086123363,923220677,14425323,8.99),(101264,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101264,28.31,0.08,4.59,42511,74.4,NULL,NULL,'MESSIER 094',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101265,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101265,28.58,0.18,5.2,42511,NULL,NULL,'I','MESSIER 094',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101266,'TRGB','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101266,28.14,0.13,4.2,42511,NULL,NULL,'I','MESSIER 094',NULL,'2011ApJS..195...18R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101267,'TRGB','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101267,28.14,0.08,4.25,42511,NULL,NULL,NULL,'MESSIER 094',NULL,'2013AstBu..68..125M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101268,'TRGB','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101268,28.31,0.08,4.59,42511,74.4,NULL,NULL,'MESSIER 094',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101269,'TRGB','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101269,28.34,0.02,4.66,42511,NULL,NULL,'I','MESSIER 094',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101270,'TRGB','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101270,28.34,0.29,4.66,42511,NULL,NULL,NULL,'MESSIER 094',NULL,'2003A&A...398..467K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101271,'TRGB','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101271,28.42,NULL,4.82,42511,NULL,NULL,NULL,'MESSIER 094',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101272,'CO ring diameter','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101272,29.03,NULL,6.4,42511,NULL,NULL,NULL,'MESSIER 094',NULL,'1991PASJ...43..671S',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101273,'Sosies','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101273,29.01,0.57,6.34,42511,NULL,NULL,NULL,'MESSIER 094',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101274,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101274,28.17,0.4,4.3,42511,75,NULL,'B','MESSIER 094',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101275,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101275,28.52,0.36,5.06,42511,NULL,NULL,NULL,'MESSIER 094',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101276,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101276,28.74,NULL,5.6,42511,75,NULL,'HI','MESSIER 094',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101277,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101277,28.96,NULL,6.2,42511,75,NULL,'CO','MESSIER 094',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101278,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101278,29,0.42,6.31,42511,53.9,NULL,'Canes Venatici I Group','MESSIER 094',NULL,'1984A&A...132..253R',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101279,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101279,29.76,NULL,8.95,42511,NULL,NULL,'LEDA [April 2006]','MESSIER 094',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101280,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101280,36.23,0.51,176,42512,70,NULL,NULL,'2MASX J12505337-1829160',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000113,NULL,'14.3I',0.2,NULL,NULL,NULL,NULL,NULL,1,192.722333,-18.48786,0.089,NULL,43981918808,687217481,10737773,14.3),(101281,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101281,36.86,0.46,236,42513,70,NULL,NULL,'2MASX J12505353+0735505',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.13',0.19,NULL,NULL,NULL,NULL,NULL,1,192.723,7.59731,0.016,NULL,58081105789,907517277,14179957,18.13),(101282,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:18','1','SN 1961D',NULL,101282,34.6,0.36,81,42514,NULL,NULL,NULL,'CGCG 159-089',NULL,'1992ApJ...390L..45P',1992,1,0.3,NULL,'G',0.000022,NULL,'15.8',0.2,'E0','Group member',NULL,NULL,NULL,1,192.72525,27.84183,0.043,NULL,58727276308,917613692,14337713,15.8),(101283,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:18','1','SN 1961D',NULL,101283,35,0.3,100,42514,NULL,NULL,'Photographic','CGCG 159-089',NULL,'1982ApJ...254....1A',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101284,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:18','1','SN 1961D',NULL,101284,35.05,0.2,102,42514,NULL,NULL,NULL,'CGCG 159-089',NULL,'1990ApJ...350..110C',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101285,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:18','1','SN 1961D','R',101285,36.12,NULL,167,42514,NULL,NULL,'Photographic','CGCG 159-089',NULL,'1988SSRv...48....1R',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101286,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101286,34.65,0.25,85.1,42514,74.4,NULL,NULL,'CGCG 159-089',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101287,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101287,34.74,0.46,88.8,42514,70,NULL,NULL,'CGCG 159-089',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101288,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101288,37.24,0.46,281,42515,70,NULL,NULL,'2MASX J12505462+0045040',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000103,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,192.7274583,0.75114,0,NULL,58084101330,907564083,14180688,16.4),(101289,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101289,36,0.46,159,42516,70,NULL,NULL,'2MASX J12505475+4745521',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000087,NULL,'15.4g',0.45,'S0',NULL,NULL,NULL,NULL,1,192.728125,47.76447,0,NULL,59095411580,923365805,14427590,15.4),(101290,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101290,37.4,0.46,302,42517,70,NULL,NULL,'2MASX J12505502+2343585',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,192.729416667,23.733,0.114,NULL,58888135961,920127124,14376986,17.1),(101291,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101291,36.82,0.46,231,42518,70,NULL,NULL,'2MASX J12505513+2840071',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00009,NULL,'15.8g',0.42,NULL,NULL,NULL,NULL,NULL,1,192.729667,28.66875,0.037,NULL,58728405379,917631334,14337989,15.8),(101292,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101292,37.82,0.12,367,42519,70,NULL,NULL,'SDSS J125055.48+544823.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,192.731166667,54.80653,0,NULL,57420839949,897200624,14018759,18.2),(101293,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101293,36.14,0.46,169,42520,70,NULL,NULL,'CGCG 043-043',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000106,NULL,'15.2g',0.53,'E',NULL,NULL,NULL,NULL,1,192.7324583,3.19706,0.035,NULL,58094274045,907723031,14183172,15.2),(101294,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101294,38.08,0.46,413,42521,70,NULL,NULL,'SDSS J125056.21+361537.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000159,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,192.73425,36.26042,0.027,NULL,58556238268,914941222,14295956,18.5),(101295,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101295,32.61,0.25,33.3,42522,74.4,NULL,NULL,'2MASX J12505749-4123477',NULL,'2013AJ....146...86T',2013,1,0.93,NULL,'G',0.00005,NULL,'15.24',0.73,'S0','Group member',NULL,NULL,NULL,1,192.7395,-41.39667,0.465,NULL,46754118105,730533095,11414579,15.24),(101296,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101296,37.45,0.46,309,42523,70,NULL,NULL,'2MASX J12505774+4517531',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000188,NULL,'16.5g',0.38,NULL,NULL,NULL,NULL,NULL,1,192.740667,45.29814,0,NULL,59121707843,923776685,14434010,16.5),(101297,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101297,37.67,0.46,342,42524,70,NULL,NULL,'2MASX J12505846+1320121',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.75',0.16,NULL,NULL,NULL,NULL,NULL,1,192.7437083,13.33664,0.073,NULL,58991491502,921742054,14402219,18.75),(101298,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101298,37.98,0.33,394,42525,70,NULL,NULL,'2MASX J12505901+6311565',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,192.745875,63.19908,0.005,NULL,57367626052,896369157,14005768,17.4),(101299,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101299,36.31,0.46,183,42526,70,NULL,NULL,'2MASX J12505930+2647501',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000097,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,192.747208333,26.79728,0.023,NULL,58735795671,917746807,14339793,16.3),(101300,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101300,35.11,0.2,105,42527,74.4,NULL,NULL,'NGC 4741',NULL,'2013AJ....146...86T',2013,1,1.16,NULL,'G',0.000153,NULL,'13.9g',0.73,'Scd:',NULL,NULL,NULL,NULL,1,192.748,47.67156,0,NULL,59095415171,923365862,14427591,13.9),(101301,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101301,35.13,0.47,106,42527,NULL,NULL,'H','NGC 4741',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101302,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101302,35.21,0.46,110,42527,NULL,NULL,'J','NGC 4741',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101303,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101303,35.26,0.45,113,42527,NULL,NULL,'K','NGC 4741',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101304,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101304,35.39,0.4,120,42527,NULL,NULL,'mean','NGC 4741',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101305,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101305,36.02,0.46,160,42528,70,NULL,NULL,'2MASX J12505954+3503580',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000077,NULL,'15.8g',0.35,NULL,NULL,NULL,NULL,NULL,1,192.748125,35.06617,NULL,NULL,58738628818,917791075,14340485,15.8),(101306,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101306,30.27,0.4,11.3,42529,73,NULL,'IR','NGC 4731',NULL,'2011A&A...532A.104N',2011,1,6.6,'Confused and extended HIPASS source','G',0.00001,NULL,'11.90',3.2,'SB(s)cd','Parent (of companion) galaxy',NULL,NULL,NULL,1,192.7545417,-6.39306,0.037,NULL,43129428304,673897317,10529645,11.9),(101307,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101307,30.27,0.4,11.4,42529,75,NULL,NULL,'NGC 4731',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101308,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101308,30.47,0.43,12.4,42529,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4731',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101309,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101309,30.52,0.43,12.7,42529,75,NULL,'3.6 micron, color corrected','NGC 4731',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101310,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101310,30.55,0.2,12.9,42529,74.4,NULL,NULL,'NGC 4731',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101311,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101311,30.66,0.36,13.6,42529,NULL,NULL,NULL,'NGC 4731',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101312,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101312,30.66,0.4,13.6,42529,NULL,NULL,NULL,'NGC 4731',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101313,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101313,31.81,0.49,23,42529,75,NULL,'IR','NGC 4731',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101314,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101314,32.07,0.4,25.9,42529,75,NULL,'B','NGC 4731',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101315,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101315,32.93,0.4,38.6,42530,75,NULL,'Edat, raw','2MASX J12510087-4143207',NULL,'1997ApJS..109..333W',1997,1,1.34,NULL,'G',0.000077,NULL,'14.65',1.17,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.753583,-41.72253,0.465,NULL,46754145813,730533528,11414586,14.65),(101316,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101316,32.95,0.4,38.9,42530,75,NULL,'Edat, cor','2MASX J12510087-4143207',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101317,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101317,33.99,0.25,62.8,42530,74.4,NULL,NULL,'2MASX J12510087-4143207',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101318,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101318,34.03,0.52,64.1,42530,70,NULL,NULL,'2MASX J12510087-4143207',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101319,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101319,37.5,0.6,317,42530,70,NULL,NULL,'2MASX J12510128-1420038',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101320,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101320,33.04,0.4,40.5,42530,NULL,NULL,'mean','2MASX J12510087-4143207',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101321,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101321,35.06,0.45,103,42530,NULL,NULL,'K','2MASX J12510087-4143207',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101322,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101322,37.14,0.21,268,42531,70,NULL,NULL,'SDSS J125102.54+043640.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000162,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,192.760583,4.61139,0,NULL,58099793208,907809268,14184519,18.5),(101323,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101323,38.08,0.46,413,42532,70,NULL,NULL,'SDSS J125102.75+083255.9',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.9g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,192.7615,8.54889,0,NULL,58081180315,907518442,14179975,17.9),(101324,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101324,30.93,0.4,15.3,42533,NULL,NULL,NULL,'NGC 4723',NULL,'2013MNRAS.429.2677K',2013,1,1.1,'Holmberg 471b is a star (perhaps with a plate defect involved).','G',0.00001,NULL,'15.38',0.6,'SB(s)m pec?',NULL,NULL,NULL,NULL,1,192.762125,-13.23661,0.065,NULL,43957743594,686839743,10731870,15.38),(101325,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101325,31.71,0.62,22,42534,NULL,NULL,'Malmquist cor.','KUG 1248+276',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000004,NULL,'15.14',0.6,'Sc',NULL,NULL,NULL,NULL,1,192.764958333,27.37,0.041,NULL,58735331718,917739558,14339680,15.14),(101326,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101326,31.88,0.58,23.7,42534,NULL,NULL,NULL,'KUG 1248+276',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101327,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101327,36.81,0.7,230,42535,70,NULL,NULL,'2MASX J12510408-1959432',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.6I',0.2,NULL,NULL,NULL,NULL,NULL,1,192.767,-19.99533,0.109,NULL,43983373831,687240216,10738128,14.6),(101328,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101328,37.52,0.33,319,42536,70,NULL,NULL,'2MASX J12510437+1807030',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.43',0.17,NULL,NULL,NULL,NULL,NULL,1,192.768167,18.11769,0.059,NULL,59026617691,922290901,14410795,18.43),(101329,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101329,37.73,0.33,351,42537,70,NULL,NULL,'2MASX J12510446+1704462',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,192.7685417,17.07958,0.052,NULL,58997252526,921832070,14403626,17.1),(101330,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101330,37.48,0.46,313,42538,70,NULL,NULL,'2MASX J12510454+1647312',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,192.769083,16.79203,0.049,NULL,58998077925,921844967,14403827,17.7),(101331,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101331,37.01,0.57,253,42539,70,NULL,NULL,'2MASX J12510521-1831532',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,192.7717917,-18.53156,0.089,NULL,43981910611,687217353,10737771,14.2),(101332,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101332,30.65,0.12,13.5,42540,74.4,NULL,NULL,'NGC 4733',NULL,'2013AJ....146...86T',2013,1,1.67,'HOLM 473B is a star.','G',0.000017,NULL,'12.7g',1.6,'SB(rs)0^0^','in a radial-velocity based grouping',NULL,NULL,NULL,1,192.77825,10.91208,0,NULL,58956143309,921189739,14393589,12.7),(101333,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101333,30.87,0.2,14.9,42540,NULL,NULL,'I','NGC 4733',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101334,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101334,30.65,0.12,13.5,42540,74.4,NULL,NULL,'NGC 4733',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101335,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101335,30.67,NULL,13.6,42540,NULL,NULL,NULL,'NGC 4733',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101336,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101336,31.27,0.45,17.9,42540,NULL,NULL,'K','NGC 4733',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101337,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101337,31.27,0.4,18,42540,NULL,NULL,'mean','NGC 4733',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101338,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101338,36.74,0.57,223,42541,70,NULL,NULL,'2MASX J12510847-0127002',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.000095,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,192.785375,-1.44994,0.025,NULL,43116409956,673693905,10526467,16.6),(101339,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101339,34.08,0.49,65.6,42542,75,NULL,'IR','NGC 4738',NULL,'2011yCatp016004901K',2011,1,2.35,NULL,'G',0.000007,NULL,'14.24',0.26,'Sc',NULL,NULL,NULL,NULL,1,192.787083,28.78806,0.016,NULL,58728288875,917629513,14337961,14.24),(101340,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101340,34.33,0.2,73.5,42542,74.4,NULL,NULL,'NGC 4738',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101341,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101341,34.38,NULL,75.1,42542,NULL,NULL,NULL,'NGC 4738',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101342,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101342,34.4,NULL,76,42542,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 4738',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101343,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101343,34.42,NULL,76.7,42542,NULL,NULL,'Dipole + Quadrupole','NGC 4738',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101344,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101344,34.44,NULL,77.1,42542,NULL,NULL,'Dipole','NGC 4738',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101345,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101345,37.14,0.21,268,42543,70,NULL,NULL,'CGCG 043-044',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000083,NULL,'15.6g',0.54,'E0',NULL,NULL,NULL,NULL,1,192.787125,4.58092,0,NULL,58099790097,907809220,14184519,15.6),(101346,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101346,37.87,0.46,376,42544,70,NULL,NULL,'SDSS J125108.95+494258.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,192.787333,49.71628,0,NULL,59096115323,923376801,14427762,18.4),(101347,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101347,37.37,0.46,297,42545,70,NULL,NULL,'2MASX J12510932+0358530',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000137,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,192.7889583,3.98139,0.008,NULL,58094551748,907727371,14183240,17.3),(101348,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101348,37.73,0.33,351,42546,70,NULL,NULL,'2MASX J12511087+1705012',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,'PHOT','17.4g',NULL,NULL,NULL,NULL,NULL,NULL,1,192.7955,17.08369,0.052,NULL,58997260700,921832198,14403628,17.4),(101349,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101349,37.86,0.33,373,42547,70,NULL,NULL,'2MASX J12511190+6349573',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000185,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,192.799625,63.83264,0.029,NULL,57368593861,896384279,14006004,16.5),(101350,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101350,32.2,0.45,27.5,42548,NULL,NULL,'K','NGC 4749',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.00004,NULL,'14.28',0.4,'Sb? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.799875,71.63672,0.029,NULL,56983601535,890368773,13912012,14.28),(101351,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101351,32.28,0.47,28.6,42548,NULL,NULL,'H','NGC 4749',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101352,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101352,32.34,0.4,29.4,42548,75,NULL,NULL,'NGC 4749',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101353,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101353,32.36,0.43,29.7,42548,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4749',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101354,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101354,32.43,0.46,30.7,42548,NULL,NULL,'J','NGC 4749',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101355,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101355,32.49,0.4,31.5,42548,NULL,NULL,'mean','NGC 4749',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101356,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101356,32.7,0.43,34.6,42548,75,NULL,'3.6 micron, color corrected','NGC 4749',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101357,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101357,32.76,0.49,35.7,42548,75,NULL,'IR','NGC 4749',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101358,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101358,33.07,0.2,41.1,42548,74.4,NULL,NULL,'NGC 4749',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101359,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101359,37.48,0.46,314,42549,70,NULL,NULL,'2MASX J12511199+2647571',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,192.8000417,26.79917,0.023,NULL,58735076050,917735563,14339618,18.3),(101360,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101360,37.52,0.33,319,42550,70,NULL,NULL,'SDSS J125112.26+451607.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000131,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,192.801125,45.26861,0,NULL,59121702686,923776604,14434009,18.4),(101361,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101361,37.07,0.46,260,42551,70,NULL,NULL,'VCC 2089',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'16.0g',0.39,'BCD?','Group member',NULL,NULL,NULL,1,192.801333,10.57006,0,NULL,58955653927,921182092,14393470,16),(101362,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101362,38.16,0.46,428,42552,70,NULL,NULL,'2MASX J12511276+2842321',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,192.80325,28.709,0.037,NULL,58728409299,917631395,14337990,17.9),(101363,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101363,37.31,0.61,290,42553,70,NULL,NULL,'2MASX J12511381-1246068',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.70',0.4,NULL,NULL,NULL,NULL,NULL,1,192.807583,-12.76881,0.053,NULL,43960355966,686880561,10732508,16.7),(101364,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101364,36.98,0.46,249,42554,70,NULL,NULL,'2MASX J12511434+4251539',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000172,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,192.809667,42.86506,0,NULL,59108423598,923569118,14430767,16.7),(101365,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101365,36.9,0.46,240,42555,70,NULL,NULL,'2MASX J12511449+4358319',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000179,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,192.8105417,43.97539,0,NULL,59120081378,923751271,14433613,16.7),(101366,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101366,37.9,0.46,380,42556,70,NULL,NULL,'SDSS J125114.83+005515.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000064,NULL,'18.7g',0.12,'AGN',NULL,NULL,NULL,NULL,1,192.811833,0.92103,0,NULL,58084143058,907564735,14180698,18.7),(101367,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101367,36.33,0.52,184,42557,70,NULL,NULL,'2MASX J12511547-1502328',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14',NULL,'Sa','Group member',NULL,NULL,NULL,1,192.814375,-15.04242,0.045,NULL,43963614500,686931476,10733304,14),(101368,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101368,32.72,0.69,34.9,42558,100,NULL,'mid-IR','MCG -01-33-028',NULL,'2013ApJ...771...88L',2013,1,1.3,NULL,'G',0.00003,NULL,'14.43',0.6,'(R\')SAB(r)0+?',NULL,NULL,NULL,NULL,1,192.8160417,-7.77028,0.109,NULL,43131783145,673934111,10530220,14.43),(101369,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101369,37.79,0.21,361,42559,70,NULL,NULL,'2MASX J12511745-0157118',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000086,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,192.822833,-1.95333,0.005,NULL,43116523655,673695682,10526495,17.1),(101370,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101370,35.43,0.46,122,42560,70,NULL,NULL,'2MASX J12511791+1109471',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.22',0.25,NULL,NULL,NULL,NULL,NULL,1,192.824583,11.16322,0,NULL,58956021919,921187842,14393560,17.22),(101371,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101371,38.35,0.46,468,42561,70,NULL,NULL,'2MASX J12511907+6250456',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00017,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,192.829583,62.84594,0.025,NULL,57362371876,896287060,14004485,17),(101372,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101372,37.98,0.46,394,42562,70,NULL,NULL,'2MASX J12512000+3801435',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,192.833291667,38.02881,0,NULL,59075588753,923056074,14422751,18.2),(101373,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101373,37.84,0.46,371,42563,70,NULL,NULL,'2MASX J12512021+5004285',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000149,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,192.834541667,50.07461,0,NULL,59096067499,923376054,14427750,17.2),(101374,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101374,36.76,0.46,225,42564,70,NULL,NULL,'2MASX J12512059-0054218',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000082,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,192.835917,-0.90597,0.005,NULL,43103441312,673491270,10523301,16.5),(101375,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101375,37.68,0.46,343,42565,70,NULL,NULL,'2MASX J12512126+3556101',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000139,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,192.838416667,35.93619,0.028,NULL,58556461567,914944711,14296011,17.3),(101376,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101376,37.75,0.46,354,42566,70,NULL,NULL,'2MASX J12512166+0858251',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.66',0.12,NULL,NULL,NULL,NULL,NULL,1,192.8402083,8.97356,0,NULL,58069307610,907332931,14177077,18.66),(101377,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101377,38.09,0.46,414,42567,70,NULL,NULL,'2MASX J12512284+4124235',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,192.8452917,41.40644,0,NULL,59085371639,923208931,14425139,17.4),(101378,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101378,36.65,0.46,214,42568,70,NULL,NULL,'2MASX J12512331+4550299',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,192.847167,45.84158,0.006,NULL,59121019664,923765932,14433842,16.9),(101379,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101379,35.03,0.2,101,42569,74.4,NULL,NULL,'CGCG 071-057',NULL,'2013AJ....146...86T',2013,1,0.99,NULL,'G',0.000089,NULL,'15.8g',0.25,'Sc',NULL,NULL,NULL,NULL,1,192.8472083,14.08139,0.071,NULL,59003280430,921926256,14405097,15.8),(101380,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101380,37.79,0.21,361,42570,70,NULL,NULL,'2MASX J12512592-0149408',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000087,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,192.857875,-1.82806,0.005,NULL,43116506605,673695415,10526490,17.2),(101381,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101381,37.22,0.46,277,42571,70,NULL,NULL,'2MASX J12512596+4023576',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,192.85825,40.39922,0,NULL,59085544697,923211635,14425181,17.3),(101382,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101382,37.52,0.33,319,42572,70,NULL,NULL,'SDSS J125126.16+180415.1',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,192.8590417,18.07089,0.059,NULL,59026637713,922291214,14410800,17),(101383,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101383,36.7,0.46,218,42573,70,NULL,NULL,'2MASX J12512634+5934435',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000177,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,192.85975,59.57872,0.009,NULL,57437810047,897465781,14022902,16.5),(101384,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101384,33.12,0.45,42,42574,NULL,NULL,'K','ESO 507- G 024',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.00004,NULL,'14.03',1,'(R)SB(l)0^0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.861375,-26.80828,0.297,NULL,43433192486,678643632,10603806,14.03),(101385,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101385,33.5,0.4,50.2,42574,NULL,NULL,'mean','ESO 507- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101386,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101386,38.26,0.46,449,42575,70,NULL,NULL,'2MASX J12512719-0102598',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000084,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,192.8632083,-1.05011,0.025,NULL,43103506882,673492295,10523317,17.4),(101387,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101387,37.99,0.46,397,42576,70,NULL,NULL,'2MASX J12512719+4506590',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,192.8634583,45.11647,0.009,NULL,59121428681,923772323,14433942,17.5),(101388,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101388,37.98,0.33,394,42577,70,NULL,NULL,'2MASX J12512813+6323407',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,192.867333,63.39469,0,NULL,57367849235,896372644,14005822,18),(101389,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101389,35.9,0.46,151,42578,70,NULL,NULL,'CGCG 071-056',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000117,NULL,'15.6',0.39,NULL,NULL,NULL,NULL,NULL,1,192.8692917,9.92272,0,NULL,58069377007,907334015,14177093,15.6),(101390,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101390,36.82,0.46,231,42579,70,NULL,NULL,'2MASX J12512875+0549148',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000173,NULL,'16.5g',0.3,'AGN',NULL,NULL,NULL,NULL,1,192.869916667,5.82083,0,NULL,58073810288,907403285,14178176,16.5),(101391,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101391,37.52,0.33,319,42580,70,NULL,NULL,'2MASX J12512945+4517489',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00018,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,192.872625,45.29703,0,NULL,59121721329,923776895,14434013,16.6),(101392,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101392,37.79,0.21,361,42581,70,NULL,NULL,'2MASX J12512972-0150188',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000107,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,192.873875,-1.83853,0.005,NULL,43116514973,673695546,10526492,16.7),(101393,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101393,37.91,0.46,382,42582,70,NULL,NULL,'2MASX J12513024+5029390',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,192.875916667,50.49408,0,NULL,57203990104,893812345,13965817,17.8),(101394,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101394,36.01,0.6,159,42583,70,NULL,NULL,'2MASX J12513045-1420182',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'16.24',0.5,NULL,NULL,NULL,NULL,NULL,1,192.8767083,-14.3385,0.029,NULL,43971943477,687061616,10735337,16.24),(101395,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101395,37.07,0.53,259,42584,70,NULL,NULL,'2MASX J12513165-1831122',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.13',0.6,NULL,NULL,NULL,NULL,NULL,1,192.8819583,-18.52014,0.089,NULL,43981900041,687217188,10737768,16.13),(101396,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101396,32.62,0.4,33.4,42585,75,NULL,'Edat, raw','ESO 507- G 025',NULL,'1997ApJS..109..333W',1997,1,2.3,'Extended HIPASS source','G',0.000017,NULL,'13.02',1.8,'SA0-;D/cD poss.LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.882667,-26.45208,0.293,NULL,43422444587,678475696,10601182,13.02),(101397,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101397,32.95,0.4,39,42585,75,NULL,'Edat, cor','ESO 507- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101398,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101398,33.11,0.17,41.9,42585,72,NULL,'ESO 507- G 025 GROUP; ABELL S0714 GROUP, 7 galaxies','ESO 507- G 025',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101399,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101399,32.71,0.48,34.9,42585,70,NULL,NULL,'ESO 507- G 025',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101400,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101400,33.02,0.25,40.2,42585,74.4,NULL,NULL,'ESO 507- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101401,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101401,33.31,0.45,45.9,42585,NULL,NULL,'K','ESO 507- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101402,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101402,33.43,0.4,48.6,42585,NULL,NULL,'mean','ESO 507- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101403,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101403,32.98,0.53,39.4,42586,70,NULL,NULL,'NGC 4722',NULL,'2014MNRAS.445.2677S',2014,1,1.8,'RC3 has V = 1312 +- 9 km/s; the NGC identification is not certain.','G',0.00015,NULL,'13.75',0.7,'SB(r)0/a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.8849583,-13.33003,0.065,NULL,43957824863,686841013,10731890,13.75),(101404,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101404,30.92,0.4,15.3,42586,NULL,NULL,NULL,'NGC 4722',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101405,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101405,33.96,0.47,61.9,42587,NULL,NULL,'H','IC 3834',NULL,'2007A&A...465...71T',2007,1,0.7,'Incorrectly called NGC 4726 by VCV.','G',0.000087,NULL,'14.23',0.3,'Sa             Sy1',NULL,NULL,NULL,'Sy 1',1,192.885,-14.22139,0.029,NULL,43971970738,687062042,10735344,14.23),(101406,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101406,33.98,0.45,62.4,42587,NULL,NULL,'K','IC 3834',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101407,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101407,34.03,0.46,64.1,42587,NULL,NULL,'J','IC 3834',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101408,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101408,34.04,0.4,64.3,42587,NULL,NULL,'mean','IC 3834',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101409,'IRAS','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101409,33.48,0.8,49.5,42588,75,NULL,'MAT, I','ESO 442- G 024',NULL,'1997ApJS..109..333W',1997,1,1.9,'This may possibly be IC 3829, but that is more likely ESO 442- G 026.','G',0.000033,NULL,'14.05',1.1,'SA(r)c',NULL,NULL,NULL,NULL,1,192.8855,-27.783,0.273,NULL,43429219797,678581559,10602836,14.05),(101410,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101410,32.07,0.32,26,42588,85,NULL,'I, raw','ESO 442- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101411,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101411,32.07,0.32,26,42588,85,NULL,'I, inv','ESO 442- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101412,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101412,32.45,0.43,31,42588,75,NULL,'MAT, I, raw','ESO 442- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101413,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101413,32.53,0.43,32.1,42588,75,NULL,'MAT, I, inv','ESO 442- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101414,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101414,32.76,0.43,35.7,42588,75,NULL,'MAT, I, cor','ESO 442- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101415,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101415,35.37,0.63,118,42589,70,NULL,NULL,'ESO 442- G 025',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'14.85',0.9,'SB(r)bc',NULL,NULL,NULL,NULL,1,192.890625,-28.24467,0.297,NULL,43431832405,678622381,10603474,14.85),(101416,'BL Lac Luminosity','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101416,41.57,NULL,1500,42590,NULL,NULL,NULL,'SHBL J125134.9-295843',0.487,'2005ApJ...635..173S',2005,1,NULL,'Massaro et al. (2009A&A...495..691M) give z = 0.382','QSO',NULL,':','17.7R',NULL,'BLLAC',NULL,NULL,NULL,'BL Lac',1,192.895083,-29.97856,0.285,NULL,43475006771,679296980,10614015,17.7),(101417,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101417,37.52,0.46,318,42591,70,NULL,NULL,'2MASX J12513541+0255158',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00009,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,192.8975,2.92097,0.046,NULL,58093737497,907714648,14183041,16.3),(101418,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101418,36.91,0.46,241,42592,70,NULL,NULL,'IC 3842',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000185,NULL,'15.8g',0.47,NULL,NULL,NULL,NULL,NULL,1,192.8995,40.37136,0,NULL,59085541637,923211588,14425181,15.8),(101419,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101419,37.86,0.33,373,42593,70,NULL,NULL,'2MASX J12513606+6351197',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,192.900375,63.85542,0.029,NULL,57368593028,896384266,14006004,17.2),(101420,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101420,33.16,0.49,42.9,42594,70,NULL,NULL,'NGC 4739',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000073,NULL,'13.53',1.4,'E+ pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.9045,-8.41022,0.101,NULL,43131361070,673927516,10530117,13.53),(101421,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101421,33.6,0.45,52.4,42594,NULL,NULL,'K','NGC 4739',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101422,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101422,33.69,0.4,54.6,42594,NULL,NULL,'mean','NGC 4739',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101423,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101423,33.26,0.25,44.9,42595,74.4,NULL,NULL,'2MASX J12513734-4118121',NULL,'2013AJ....146...86T',2013,1,1.25,NULL,'G',0.000047,NULL,'15.32',0.56,'S0','Group member',NULL,NULL,NULL,1,192.9052083,-41.30367,0.465,NULL,46753991999,730531124,11414548,15.32),(101424,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101424,33.18,0.25,43.3,42596,74.4,NULL,NULL,'ESO 507- G 027',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.00006,NULL,'13.99',0.4,'S0','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,192.906875,-26.11742,0.341,NULL,43422360462,678474382,10601162,13.99),(101425,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101425,32.91,0.45,38.2,42596,NULL,NULL,'K','ESO 507- G 027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101426,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101426,33.43,0.4,48.6,42596,NULL,NULL,'mean','ESO 507- G 027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101427,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101427,34.57,0.2,82,42597,74.4,NULL,NULL,'UGC 08004',NULL,'2013AJ....146...86T',2013,1,1.49,NULL,'G',0.000008,NULL,'14.9g',0.55,'Sd','Group member, peripheral',NULL,NULL,NULL,1,192.9082083,31.35278,0.046,NULL,58749504082,917961001,14343140,14.9),(101428,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101428,34.62,0.43,83.9,42597,75,NULL,'3.6 micron, color corrected','UGC 08004',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101429,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101429,34.74,0.43,88.9,42597,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08004',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101430,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101430,34.85,0.1,93.5,42597,NULL,NULL,NULL,'UGC 08004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101431,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101431,36.65,0.46,214,42598,70,NULL,NULL,'2MASX J12513946+0809248',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.38',0.15,NULL,NULL,NULL,NULL,NULL,1,192.9142917,8.15678,0,NULL,58081306648,907520416,14180006,18.38),(101432,'SNIa','2016-12-15 15:15:06','2016-12-16 11:20:18','1','PTF10duz','N',101432,37.26,0.03,266,42599,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10duz',0.064,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101433,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101433,37.55,0.46,324,42600,70,NULL,NULL,'2MASX J12514095+5514365',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000175,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,192.920667,55.24328,0,NULL,57420565130,897196330,14018692,17),(101434,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101434,37.58,0.68,328,42601,70,NULL,NULL,'2MASX J12514139-2240297',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000113,NULL,'14.6I',0.2,NULL,NULL,NULL,NULL,NULL,1,192.9224583,-22.67494,0.209,NULL,43906279178,686035612,10719306,14.6),(101435,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101435,36.84,0.52,233,42602,70,NULL,NULL,'2MASX J12514148-1833127',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000113,NULL,'13.8I',0.4,NULL,NULL,NULL,NULL,NULL,1,192.92275,-18.55353,0.069,NULL,43981933559,687217711,10737776,13.8),(101436,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101436,37.82,0.46,366,42603,70,NULL,NULL,'2MASX J12514237+4223439',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,192.926417,42.39561,0,NULL,59108259911,923566561,14430727,17.6),(101437,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101437,36.98,0.46,249,42604,70,NULL,NULL,'2MASXi J1251437+181336',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,192.9322917,18.22667,0.059,NULL,59027434820,922303669,14410994,17.2),(101438,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101438,32.93,0.4,38.6,42605,75,NULL,'Edat, raw','ESO 323- G 015',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000087,NULL,'13.87',1,'SA(l)0^-','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.932333,-38.82919,0.321,NULL,46756726536,730573852,11415216,13.87),(101439,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101439,32.95,0.4,38.9,42605,75,NULL,'Edat, cor','ESO 323- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101440,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101440,33.27,0.25,45.1,42605,74.4,NULL,NULL,'ESO 323- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101441,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101441,33.4,0.4,47.8,42605,NULL,NULL,'mean','ESO 323- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101442,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101442,33.62,0.45,52.9,42605,NULL,NULL,'K','ESO 323- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101443,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101443,29.82,NULL,9.2,42606,NULL,NULL,NULL,'KUG 1249+263',NULL,'2013AJ....145..101K',2013,1,0.6,'Position in 1985AnTok..202.237T is incorrect.','G',0.000062,NULL,'16.72',0.4,'Irr',NULL,NULL,NULL,NULL,1,192.9352083,26.1105,0.023,NULL,58722332368,917536443,14336506,16.72),(101444,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101444,37.79,0.21,361,42607,70,NULL,NULL,'2MASX J12514480-0151318',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000105,NULL,'16.5g',0.34,'BrClG          AGN',NULL,NULL,NULL,NULL,1,192.9365,-1.85878,0.005,NULL,43116491357,673695177,10526487,16.5),(101445,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101445,36.6,0.62,209,42608,70,NULL,NULL,'2MASX J12514508-1336062',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'13.9I',0.5,NULL,NULL,NULL,NULL,NULL,1,192.937833333,-13.60181,0.061,NULL,43957806690,686840729,10731886,13.9),(101446,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101446,37.35,0.46,295,42609,70,NULL,NULL,'2MASX J12514588+2707443',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,192.9412083,27.12903,0.03,NULL,58735065041,917735391,14339615,16.9),(101447,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101447,30.46,0.4,12.3,42610,75,NULL,'B','NGC 4747',NULL,'1988NBGC.C....0000T',1988,1,3.5,NULL,'G',0.000003,NULL,'12.96',1.2,'SBcd? pec sp','in a radial-velocity based grouping',NULL,NULL,NULL,1,192.9414583,25.77708,0.04,NULL,58721988718,917531073,14336423,12.96),(101448,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101448,30.64,0.49,13.4,42610,75,NULL,'IR','NGC 4747',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101449,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101449,28.7,NULL,5.5,42611,NULL,NULL,NULL,'IC 3840',NULL,'2013AJ....145..101K',2013,1,1,NULL,'G',NULL,NULL,'16.90',0.24,'Sm/Irr:',NULL,NULL,NULL,NULL,1,192.942083,21.73519,0.138,NULL,59023937746,922249027,14410141,16.9),(101450,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101450,32.39,0.31,30.1,42612,NULL,NULL,NULL,'NGC 4729',NULL,'2001MNRAS.327.1004B',2001,1,1.5,NULL,'G',0.000008,NULL,'13.42',1.4,'E+:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.942833,-41.13228,0.421,NULL,46754896412,730545256,11414769,13.42),(101451,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101451,32.63,0.31,33.6,42612,NULL,NULL,'Malmquist cor.','NGC 4729',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101452,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101452,32.93,0.4,38.6,42612,75,NULL,'Edat, raw','NGC 4729',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101453,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101453,32.95,0.4,38.9,42612,75,NULL,'Edat, cor','NGC 4729',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101454,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101454,32.35,0.23,29.5,42612,74.4,NULL,NULL,'NGC 4729',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101455,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101455,32.64,0.41,33.7,42612,NULL,NULL,NULL,'NGC 4729',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101456,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101456,33.03,0.41,40.4,42612,NULL,NULL,'Malmquist cor.','NGC 4729',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101457,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101457,32.94,0.45,38.6,42612,NULL,NULL,'K','NGC 4729',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101458,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101458,33.27,0.4,45,42612,NULL,NULL,'mean','NGC 4729',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101459,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101459,33.16,0.25,42.9,42613,74.4,NULL,NULL,'2MASX J12514793-4059371',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000097,NULL,'15.95',0.68,'dE','Group member',NULL,NULL,NULL,1,192.9497917,-40.99375,0.421,NULL,46754955035,730546172,11414783,15.95),(101460,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101460,30.95,0.16,15.5,42614,NULL,NULL,'I','NGC 4742',NULL,'2001ApJ...546..681T',2001,1,2.6,NULL,'G',0.00005,NULL,'12.83',1.5,'E4:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.950167,-10.45472,0.089,NULL,43839610412,684993912,10703029,12.83),(101461,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101461,30.95,0.16,15.5,42614,NULL,NULL,NULL,'NGC 4742',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101462,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101462,30.97,0.14,15.6,42614,74.4,NULL,NULL,'NGC 4742',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101463,'SBF','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101463,30.99,0.16,15.8,42614,NULL,NULL,'Malmquist cor.','NGC 4742',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101464,'Faber-Jackson','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101464,29.12,0.65,6.67,42614,95,NULL,'Weighted Mean','NGC 4742',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101465,'Faber-Jackson','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101465,29.9,0.81,9.55,42614,55,NULL,'Visvanathan & Sandage 1979','NGC 4742',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101466,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101466,29.85,0.41,9.35,42614,NULL,NULL,NULL,'NGC 4742',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101467,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101467,30.18,0.41,10.9,42614,NULL,NULL,'Malmquist cor.','NGC 4742',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101468,'Tully est','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101468,31.83,0.8,23.2,42614,75,NULL,'B','NGC 4742',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101469,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101469,36.74,0.46,223,42615,70,NULL,NULL,'2MASX J12515046+4906160',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000198,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,192.9602917,49.10458,0,NULL,59096764009,923386937,14427920,16.2),(101470,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101470,32.9,0.25,38,42616,74.4,NULL,NULL,'2MASX J12515082-4111107',NULL,'2013AJ....146...86T',2013,1,0.79,NULL,'G',0.00006,NULL,'16.01',0.67,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.9614583,-41.18642,0.457,NULL,46754866239,730544784,11414762,16.01),(101471,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101471,36.93,0.46,244,42617,70,NULL,NULL,'2MASX J12515149+1623182',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,192.9645417,16.38847,0.017,NULL,58997928920,921842639,14403791,17),(101472,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101472,37.79,0.46,362,42618,70,NULL,NULL,'SDSS J125151.63+380812.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000031,NULL,'18.6g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,192.965167,38.13692,0,NULL,59075289230,923051394,14422678,18.6),(101473,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101473,37.36,0.46,297,42619,70,NULL,NULL,'2MASX J12515289+0958158',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.94',0.19,NULL,NULL,NULL,NULL,NULL,1,192.970333,9.97114,0,NULL,58069411956,907334561,14177102,17.94),(101474,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101474,38.71,0.46,553,42620,70,NULL,NULL,'SDSS J125153.12+561742.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000182,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,192.971417,56.29503,0,NULL,57432507879,897382935,14021608,18.3),(101475,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101475,37.14,0.21,268,42621,70,NULL,NULL,'CGCG 043-047 NED01',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.00008,NULL,'15.4g',0.5,'cD;BrClG',NULL,NULL,NULL,NULL,1,192.9727083,4.57981,0,NULL,58103397691,907865588,14185399,15.4),(101476,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101476,38.49,0.46,498,42622,70,NULL,NULL,'SDSS J125153.68+044125.9',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000139,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,192.973667,4.69056,0,NULL,58103324475,907864444,14185381,17.8),(101477,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101477,37.82,0.12,367,42623,70,NULL,NULL,'2MASX J12515433+5457394',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000182,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,192.9764583,54.96111,0.007,NULL,57420747383,897199177,14018737,16.7),(101478,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101478,36.91,0.46,241,42624,70,NULL,NULL,'2MASX J12515486+4122080',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000157,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,192.978833333,41.369,0,NULL,59085339130,923208423,14425131,17),(101479,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101479,35.07,0.4,103,42625,NULL,NULL,'mean','IC 0827',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.00004,NULL,'14.94',0.4,'S?',NULL,NULL,NULL,NULL,1,192.979416667,16.28286,0.017,NULL,58997880813,921841887,14403779,14.94),(101480,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101480,35.11,0.47,105,42625,NULL,NULL,'H','IC 0827',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101481,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101481,32.08,NULL,26.1,42626,NULL,NULL,'B','NGC 4746',NULL,'2002ApJ...565..681R',2002,1,3.8,'The SDSS position is 3.8 arcsec northwest of the nucleus.','G',0.000017,NULL,'13.36',1.1,'Sb: sp;LINER   HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,192.980667,12.08297,0.069,NULL,58992583431,921759116,14402486,13.36),(101482,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101482,32.15,0.4,26.9,42626,NULL,NULL,'mean','NGC 4746',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101483,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101483,32.23,0.43,27.9,42626,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4746',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101484,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101484,32.41,0.43,30.4,42626,75,NULL,'3.6 micron, color corrected','NGC 4746',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101485,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101485,32.54,0.36,32.2,42626,NULL,NULL,NULL,'NGC 4746',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101486,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101486,32.62,0.47,33.5,42626,NULL,NULL,'H','NGC 4746',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101487,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101487,32.62,0.45,33.5,42626,NULL,NULL,'K','NGC 4746',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101488,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101488,32.64,0.2,33.7,42626,74.4,NULL,NULL,'NGC 4746',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101489,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101489,32.68,0.46,34.4,42626,NULL,NULL,'J','NGC 4746',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101490,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101490,32.91,0.49,38.3,42626,75,NULL,'IR','NGC 4746',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101491,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101491,33.15,0.3,42.6,42626,55,NULL,'B','NGC 4746',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101492,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101492,33.59,0.25,52.2,42627,74.4,NULL,NULL,'2MASX J12515649-4132208',NULL,'2013AJ....146...86T',2013,1,1.11,NULL,'G',0.00004,NULL,'15.16',0.71,'SB0','Group member',NULL,NULL,NULL,1,192.985,-41.53917,0.457,NULL,46754025081,730531641,11414556,15.16),(101493,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101493,34.12,0.57,66.8,42627,70,NULL,NULL,'2MASX J12515649-4132208',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101494,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101494,36.07,0.46,164,42628,70,NULL,NULL,'2MASX J12515663+5521154',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000191,NULL,'15.5g',0.39,'Sa',NULL,NULL,NULL,NULL,1,192.986208333,55.35439,0,NULL,57428717778,897323715,14020683,15.5),(101495,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101495,37.35,0.46,295,42629,70,NULL,NULL,'2MASX J12515692+3248356',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000173,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,192.9872083,32.80978,0.03,NULL,58751358613,917989978,14343593,16.9),(101496,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101496,37.19,0.46,274,42630,70,NULL,NULL,'2MASXi J1251571+134612',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,192.988208333,13.77,0.073,NULL,59002770857,921918294,14404973,17.6),(101497,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101497,39.6,0.46,831,42631,70,NULL,NULL,'SDSS J125157.73+070558.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.3g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,192.990583,7.09958,0.018,NULL,58071452904,907366451,14177600,18.3),(101498,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101498,38.19,0.46,434,42632,70,NULL,NULL,'2MASX J12515772+3102276',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,192.990625,31.04117,0.053,NULL,58748939672,917952182,14343002,17.9),(101499,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101499,35.48,0.2,125,42633,74.4,NULL,NULL,'CGCG 071-061',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00001,NULL,'15.6',0.2,NULL,NULL,NULL,NULL,NULL,1,192.9914583,9.51975,0,NULL,58069543251,907336613,14177134,15.6),(101500,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101500,37.26,0.46,283,42634,70,NULL,NULL,'2MASX J12515815+1817227',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.43',0.14,NULL,NULL,NULL,NULL,NULL,1,192.992458333,18.28956,0.061,NULL,59027461268,922304082,14411001,18.43),(101501,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101501,38.64,0.46,535,42635,70,NULL,NULL,'2MASX J12515851+0434053',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000175,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,192.9937917,4.56814,0,NULL,58103387574,907865430,14185397,17.5),(101502,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101502,33.5,0.23,50.1,42636,74.4,NULL,NULL,'NGC 4730',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000014,NULL,'13.87',1,'SA(r)0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,193.0019583,-41.14731,0.421,NULL,46754896143,730545252,11414769,13.87),(101503,'Tully est','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101503,33.33,0.8,46.4,42636,75,NULL,NULL,'NGC 4730',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101504,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101504,32.8,0.4,36.3,42636,NULL,NULL,'mean','NGC 4730',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101505,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101505,33.57,0.45,51.8,42636,NULL,NULL,'K','NGC 4730',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101506,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101506,37.03,0.46,255,42637,70,NULL,NULL,'SDSS J125200.95+482949.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000166,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,193.004,48.49708,0,NULL,59096870712,923388604,14427946,17.9),(101507,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101507,37.99,0.46,396,42638,70,NULL,NULL,'2MASX J12520097+0016393',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000078,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,193.004167,0.27753,0,NULL,58084504822,907570387,14180787,17.5),(101508,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101508,38.01,0.33,400,42639,70,NULL,NULL,'SDSS J125201.35+664335.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000073,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,193.005666667,66.72656,0.025,NULL,57852751343,903949239,14124206,18.2),(101509,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101509,37.6,0.46,330,42640,70,NULL,NULL,'2MASX J12520216+0004063',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000069,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,193.008875,0.06847,0,NULL,58084525891,907570717,14180792,17.7),(101510,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101510,32.93,0.4,38.6,42641,75,NULL,'Edat, raw','ESO 323- G 019',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000011,NULL,'12.8',0.7,'E+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,193.013083,-41.45992,0.457,NULL,46754034747,730531792,11414559,12.8),(101511,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101511,32.95,0.4,38.9,42641,75,NULL,'Edat, cor','ESO 323- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101512,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101512,33.2,0.45,43.6,42641,NULL,NULL,'K','ESO 323- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101513,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101513,33.41,0.4,48.1,42641,NULL,NULL,'mean','ESO 323- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101514,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101514,37.09,0.46,261,42642,70,NULL,NULL,'SDSS J125203.21+402113.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,193.013416667,40.35386,0,NULL,59088967904,923265123,14426017,17.7),(101515,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101515,39.06,0.46,648,42643,70,NULL,NULL,'SDSS J125204.22+501315.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000172,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,193.017625,50.221,0,NULL,57203570446,893805788,13965715,18.7),(101516,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101516,37.01,0.46,253,42644,70,NULL,NULL,'2MASX J12520544+6341557',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000163,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,193.022958333,63.69878,0.029,NULL,57368561267,896383769,14005996,17),(101517,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101517,37.14,0.21,268,42645,70,NULL,NULL,'2MASX J12520808+0433374',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,193.033667,4.56042,0,NULL,58103428204,907866065,14185407,17.4),(101518,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101518,34.69,0.4,86.8,42646,75,NULL,'Edat, raw','ESO 575- G 013',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.00009,NULL,'14.24',0.9,'E?',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,193.0350417,-21.86511,0.157,NULL,43975658432,687119663,10736244,14.24),(101519,'D-Sigma','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101519,35.03,0.4,101,42646,75,NULL,'Edat, cor','ESO 575- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101520,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101520,34.7,0.46,87.1,42646,70,NULL,NULL,'ESO 575- G 013',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101521,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101521,35.09,0.4,104,42646,NULL,NULL,'mean','ESO 575- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101522,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101522,35.32,0.45,116,42646,NULL,NULL,'K','ESO 575- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101523,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101523,37.79,0.21,361,42647,70,NULL,NULL,'SDSS J125208.49-014954.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000076,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,193.035375,-1.83178,0.005,NULL,43116481818,673695028,10526484,18.2),(101524,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101524,37.25,0.46,282,42648,70,NULL,NULL,'2MASX J12520971-0138336',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000091,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,193.040583,-1.64269,0.005,NULL,43116651113,673697673,10526526,17.1),(101525,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101525,37.14,0.21,268,42649,70,NULL,NULL,'2MASX J12520988+0439084',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000103,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,193.041166667,4.65225,0,NULL,58103369814,907865153,14185393,16.9),(101526,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101526,37.3,0.46,288,42650,70,NULL,NULL,'2MASX J12521029+3255074',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000138,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,193.0430417,32.91883,0.03,NULL,58751512832,917992388,14343631,17.5),(101527,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101527,37.63,0.46,335,42651,70,NULL,NULL,'SDSS J125212.00+440741.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000125,NULL,'18.5g',0.09,NULL,NULL,NULL,NULL,NULL,1,193.0500417,44.12806,0,NULL,59108767449,923574491,14430851,18.5),(101528,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101528,37.97,0.46,392,42652,70,NULL,NULL,'2MASX J12521313+1940474',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,193.054875,19.67983,0.057,NULL,59029471873,922335498,14411492,17.3),(101529,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101529,33.1,0.2,41.7,42653,74.4,NULL,NULL,'IC 3829',NULL,'2013AJ....146...86T',2013,1,2.7,'The IC identification is not certain.','G',0.000103,NULL,'12.55',0.8,'SB0?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,193.055417,-29.84067,0.293,NULL,43474923367,679295677,10613994,12.55),(101530,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101530,33.13,0.54,42.2,42653,NULL,NULL,NULL,'IC 3829',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101531,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101531,33.22,0.51,44.1,42653,NULL,NULL,'Malmquist cor.','IC 3829',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101532,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,'R',101532,37.83,0.46,369,42654,70,NULL,NULL,'2MASX J12521386+5819476',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,193.057667,58.32981,0,NULL,57438673569,897479274,14023113,17.7),(101533,'FP','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101533,33.64,0.25,53.5,42655,74.4,NULL,NULL,'ESO 507- G 032',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.000067,NULL,'13.82',1,'(R\')SAB0-:    LINER?',NULL,NULL,NULL,NULL,1,193.061833,-26.30394,0.365,NULL,43422517930,678476842,10601200,13.82),(101534,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101534,33.35,0.4,46.9,42655,NULL,NULL,'mean','ESO 507- G 032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101535,'Tully-Fisher','2016-12-15 15:15:06','2016-12-16 11:20:18','1',NULL,NULL,101535,33.77,0.45,56.7,42655,NULL,NULL,'K','ESO 507- G 032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101536,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101536,37.52,0.46,319,42656,70,NULL,NULL,'2MASX J12521554+4247304',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,193.064875,42.79178,0,NULL,59108440202,923569378,14430771,17.3),(101537,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101537,33.33,0.49,46.4,42657,70,NULL,NULL,'IC 0828',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000077,NULL,'15.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,193.065125,-8.13286,0.117,NULL,43133337007,673958390,10530599,15),(101538,'D-Sigma','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101538,32.93,0.4,38.6,42658,75,NULL,'Edat, raw','NGC 4743',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000057,NULL,'13.97',0.5,'SA0+:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,193.066583333,-41.39067,0.457,NULL,46753997463,730531210,11414550,13.97),(101539,'D-Sigma','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101539,32.95,0.4,38.9,42658,75,NULL,'Edat, cor','NGC 4743',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101540,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101540,32.17,0.23,27.2,42658,74.4,NULL,NULL,'NGC 4743',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101541,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101541,32.26,0.53,28.3,42658,70,NULL,NULL,'NGC 4743',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101542,'Tully est','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101542,33.33,0.8,46.4,42658,75,NULL,NULL,'NGC 4743',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101543,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101543,32.51,0.45,31.8,42658,NULL,NULL,'K','NGC 4743',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101544,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101544,33.41,0.4,48.1,42658,NULL,NULL,'mean','NGC 4743',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101545,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101545,37.91,0.46,382,42659,70,NULL,NULL,'2MASX J12521597+3603110',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,193.0664583,36.05303,0.028,NULL,58556341805,914942840,14295981,17.5),(101546,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101546,37.47,0.33,312,42660,70,NULL,NULL,'2MASX J12521758+3709510',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,193.0732917,37.16428,0.027,NULL,59075194791,923049918,14422654,16.5),(101547,'GCLF','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101547,31.21,0.2,17.5,42661,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4754',NULL,'2007ApJS..171..101J',2007,1,4.6,NULL,'G',0.000017,NULL,'11.52',2.5,'SB(r)0-:','Pair member (points to parent)',NULL,NULL,NULL,1,193.072917,11.31389,0.04,NULL,58955882204,921185659,14393525,11.52),(101548,'GCLF','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101548,31.23,0.17,17.6,42661,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4754',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101549,'GCLF','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101549,31.28,0.19,18,42661,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4754',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101550,'GCLF','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101550,31.45,0.18,19.5,42661,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4754',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101551,'SBF','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101551,31.01,0.14,15.9,42661,74.4,NULL,NULL,'NGC 4754',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101552,'SBF','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101552,31.03,0.07,16.1,42661,NULL,NULL,'HST ACS VCS','NGC 4754',NULL,'2009ApJ...694..556B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101553,'SBF','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101553,31.04,0.06,16.1,42661,NULL,NULL,NULL,'NGC 4754',NULL,'2007ApJ...655..144M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101554,'SBF','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101554,31.13,0.14,16.8,42661,NULL,NULL,'I','NGC 4754',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101555,'GC radius','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101555,30.76,0.11,14.2,42661,NULL,NULL,NULL,'NGC 4754',NULL,'2005ApJ...634.1002J',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101556,'Faber-Jackson','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101556,30.19,0.63,10.9,42661,95,NULL,'Michard 1979b, c','NGC 4754',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101557,'Faber-Jackson','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101557,30.49,0.27,12.5,42661,95,NULL,'Weighted Mean','NGC 4754',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101558,'Faber-Jackson','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101558,30.69,0.46,13.7,42661,95,NULL,'Michard 1979a','NGC 4754',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101559,'Faber-Jackson','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101559,30.77,0.41,14.3,42661,95,NULL,'de Vaucouleurs','NGC 4754',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101560,'Faber-Jackson','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101560,31.36,NULL,18.7,42661,NULL,NULL,'LEDA [April 2006]','NGC 4754',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101561,'Faber-Jackson','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101561,31.61,0.81,21,42661,55,NULL,'Visvanathan & Sandage 1979','NGC 4754',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101562,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101562,31.29,NULL,18.1,42661,NULL,NULL,NULL,'NGC 4754',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101563,'Tertiary','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101563,30.49,0.25,12.5,42661,95,NULL,NULL,'NGC 4754',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101564,'Tully est','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101564,31.13,0.8,16.8,42661,75,NULL,'B','NGC 4754',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101565,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101565,31.25,0.45,17.8,42661,NULL,NULL,'K','NGC 4754',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101566,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101566,31.45,0.4,19.5,42661,NULL,NULL,'mean','NGC 4754',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101567,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101567,37.59,0.27,330,42662,70,NULL,NULL,'SDSS J125217.86+071048.3',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,193.074417,7.18011,0.032,NULL,58081941905,907530342,14180161,NULL),(101568,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101568,36.54,0.46,204,42663,70,NULL,NULL,'2MASX J12521797+2824292',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000117,NULL,'16.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,193.074917,28.40797,0.038,NULL,58728057997,917625906,14337904,16.2),(101569,'SNIa','2016-12-15 15:15:07','2016-12-16 11:20:18','1','PTF10hjw','N',101569,36.47,0.06,189,42664,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10hjw',0.0417,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101570,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101570,37.43,0.46,306,42665,70,NULL,NULL,'SDSS J125218.67+152953.6',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.3g',0.37,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,193.077833,15.49822,0.015,NULL,59001137188,921892768,14404574,16.3),(101571,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101571,38.54,0.46,510,42666,70,NULL,NULL,'2MASX J12521931+4946173',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000178,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,193.080583,49.77139,0,NULL,59096072467,923376132,14427752,18.1),(101572,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101572,36.9,0.46,240,42667,70,NULL,NULL,'2MASX J12521939+1540366',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,193.080833,15.67678,0.013,NULL,59001124689,921892573,14404571,17.7),(101573,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101573,37.94,0.46,387,42668,70,NULL,NULL,'2MASX J12521953+1321296',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000207,NULL,'16.1g',0.37,'S0',NULL,NULL,NULL,NULL,1,193.081416667,13.35814,0.069,NULL,58991554382,921743037,14402234,16.1),(101574,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101574,38.09,0.46,415,42669,70,NULL,NULL,'2MASX J12522051+4114420',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000166,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,193.085541667,41.24511,0,NULL,59086039076,923219360,14425302,17.3),(101575,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101575,38.22,0.46,441,42670,70,NULL,NULL,'2MASX J12522060+6411309',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,193.0859583,64.19189,0.029,NULL,57367956744,896374324,14005848,17.3),(101576,'Tully est','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101576,31.66,0.8,21.4,42671,75,NULL,NULL,'UGC 08011',NULL,'1988NBGC.C....0000T',1988,1,1.4,NULL,'G',0.00002,NULL,'15.3B',1.1,'Im',NULL,NULL,NULL,NULL,1,193.087625,21.62944,0.153,NULL,59023944869,922249138,14410142,15.3),(101577,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101577,37.03,0.84,255,42672,70,NULL,NULL,'2MASX J12522182-4509452',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,193.090917,-45.16261,0.365,NULL,46772131132,730814548,11418977,17.1),(101578,'GCLF','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101578,31.95,0.14,24.5,42673,NULL,NULL,'TOM(V) = -7.4 mag','NGC 4753',NULL,'2015MNRAS.453.4421C',2015,1,6,NULL,'G',0.000017,NULL,'10.85',2.8,'I0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,193.092125,-1.19969,0.025,NULL,43114782411,673668475,10526069,10.85),(101579,'SNIa','2016-12-15 15:15:07','2016-12-16 11:20:18','1','SN 1983G',NULL,101579,29.8,0.4,9.12,42673,NULL,NULL,'SN 1981B(NGC 4536) + -0.3 mag','NGC 4753',NULL,'1985PASP...97..229B',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101580,'SNIa','2016-12-15 15:15:07','2016-12-16 11:20:18','1','SN 1983G',NULL,101580,31.4,0.51,15,42673,67,NULL,NULL,'NGC 4753',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101581,'SNIa','2016-12-15 15:15:07','2016-12-16 11:20:18','1','SN 1965I',NULL,101581,31.1,0.4,16,42673,NULL,NULL,'Photographic','NGC 4753',NULL,'1982ApJ...254....1A',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101582,'SNIa','2016-12-15 15:15:07','2016-12-16 11:20:18','1','SN 1983G',NULL,101582,31.1,0.2,16.6,42673,NULL,NULL,'m-M(B) = 12.6 - -18.5 mag','NGC 4753',NULL,'1985PASP...97..229B',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101583,'SNIa','2016-12-15 15:15:07','2016-12-16 11:20:18','1','SN 1983G',NULL,101583,31.3,0.06,18.2,42673,66,NULL,NULL,'NGC 4753',NULL,'1994A&A...281...51M',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101584,'SNIa','2016-12-15 15:15:07','2016-12-16 11:20:18','1','SN 1983G','R',101584,31.41,NULL,19.1,42673,62.3,NULL,NULL,'NGC 4753',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101585,'SNIa','2016-12-15 15:15:07','2016-12-16 11:20:18','1','SN 1983G',NULL,101585,31.5,0.14,20,42673,60,NULL,NULL,'NGC 4753',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101586,'SNIa','2016-12-15 15:15:07','2016-12-16 11:20:18','1','SN 1965I',NULL,101586,31.64,0.3,21.3,42673,60,NULL,'M(B) = -19.48 mag','NGC 4753',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101587,'SNIa','2016-12-15 15:15:07','2016-12-16 11:20:18','1','SN 1965I',NULL,101587,31.83,0.3,23.2,42673,60,NULL,'M(V) = -19.47 mag','NGC 4753',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101588,'SNIa','2016-12-15 15:15:07','2016-12-16 11:20:18','1','SN 1965I','R',101588,32,NULL,25.1,42673,NULL,NULL,'Photographic','NGC 4753',NULL,'1988SSRv...48....1R',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101589,'SNIa','2016-12-15 15:15:07','2016-12-16 11:20:18','1','SN 1983G','R',101589,32.18,NULL,27.3,42673,NULL,NULL,'Photographic','NGC 4753',NULL,'1988SSRv...48....1R',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101590,'SBF','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101590,31.86,0.19,23.6,42673,NULL,NULL,'I','NGC 4753',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101591,'SBF','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101591,31.91,0.14,24.1,42673,74.4,NULL,NULL,'NGC 4753',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101592,'Tully est','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101592,30.89,0.8,15.1,42673,75,NULL,'B','NGC 4753',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101593,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101593,30.3,0.45,11.5,42673,NULL,NULL,'K','NGC 4753',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101594,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101594,30.63,NULL,13.4,42673,NULL,NULL,'LEDA [April 2006]','NGC 4753',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101595,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101595,31.68,0.4,21.7,42673,NULL,NULL,'mean','NGC 4753',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101596,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101596,37.22,0.46,278,42674,70,NULL,NULL,'2MASX J12522214+4557004',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,193.092333,45.95019,0,NULL,59121032812,923766137,14433845,17.1),(101597,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101597,34.11,0.25,66.4,42675,74.4,NULL,NULL,'2MASX J12522255-4116548',NULL,'2013AJ....146...86T',2013,1,1.52,NULL,'G',0.000057,NULL,'14',1.3,'SB0','Group member',NULL,NULL,NULL,1,193.094,-41.28181,0.457,NULL,46754862677,730544729,11414761,14),(101598,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101598,37.39,0.46,300,42676,70,NULL,NULL,'PKS 1249+035',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000099,NULL,'16.6g',0.28,'Elliptical',NULL,NULL,NULL,NULL,1,193.0942083,3.26503,0.035,NULL,58093899308,907717176,14183080,16.6),(101599,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101599,38.25,0.46,446,42677,70,NULL,NULL,'2MASX J12522272+5022053',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000202,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,193.094875,50.36822,0,NULL,57203879939,893810624,13965791,17.7),(101600,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101600,37.59,0.27,330,42678,70,NULL,NULL,'CGCG 043-049',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00014,NULL,'15.7',0.26,NULL,NULL,NULL,NULL,NULL,1,193.096333,7.09833,0.018,NULL,58079064659,907485385,14179459,15.7),(101601,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101601,37.8,0.46,363,42679,70,NULL,NULL,'SDSS J125224.13+605851.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000141,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,193.1005417,60.98108,0,NULL,57353828208,896153565,14002399,18.2),(101602,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101602,37.59,0.27,330,42680,70,NULL,NULL,'2MASX J12522453+0710538',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'16.8',0.12,NULL,NULL,NULL,NULL,NULL,1,193.102083,7.1815,0.032,NULL,58081940081,907530313,14180161,16.8),(101603,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101603,37.83,0.46,369,42681,70,NULL,NULL,'2MASX J12522476+4435494',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00018,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,193.10325,44.59714,0.008,NULL,59107482779,923554418,14430537,17.5),(101604,'D-Sigma','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101604,32.78,0.4,35.9,42682,75,NULL,'Edat, raw','ESO 323- G 023',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.00007,NULL,'14.16',0.9,'SB0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,193.108333,-40.70739,0.421,NULL,46754748945,730542952,11414733,14.16),(101605,'D-Sigma','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101605,32.88,0.4,37.6,42682,75,NULL,'Edat, cor','ESO 323- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101606,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101606,33.18,0.25,43.3,42682,74.4,NULL,NULL,'ESO 323- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101607,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101607,33.81,0.45,57.8,42682,NULL,NULL,'K','ESO 323- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101608,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101608,33.93,0.4,61.2,42682,NULL,NULL,'mean','ESO 323- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101609,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101609,36.42,0.46,192,42683,70,NULL,NULL,'2MASX J12522625-0055311',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000084,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,193.1092917,-0.92525,0.005,NULL,43103400356,673490630,10523291,16.5),(101610,'Tully est','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101610,32.66,0.8,34,42684,75,NULL,NULL,'UGCA 304',NULL,'1988NBGC.C....0000T',1988,1,2.55,NULL,'G',0.000023,NULL,'14.5',0.22,'Sdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,193.1119583,-9.75397,0.077,NULL,43119065728,673735402,10527115,14.5),(101611,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101611,32.06,0.4,25.9,42684,75,NULL,NULL,'UGCA 304',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101612,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101612,32.42,0.49,30.4,42684,75,NULL,'IR','UGCA 304',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101613,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101613,32.93,NULL,38.5,42684,NULL,NULL,'Dipole + Quadrupole + Octopole','UGCA 304',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101614,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101614,32.93,NULL,38.6,42684,NULL,NULL,'Dipole + Quadrupole','UGCA 304',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101615,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101615,32.94,NULL,38.7,42684,NULL,NULL,'Dipole','UGCA 304',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101616,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101616,33.01,NULL,39.9,42684,NULL,NULL,NULL,'UGCA 304',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101617,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101617,37.47,0.33,312,42685,70,NULL,NULL,'2MASX J12522848+3709420',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,193.11875,37.16156,0.027,NULL,59075195360,923049927,14422655,17.2),(101618,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101618,38.21,0.46,439,42686,70,NULL,NULL,'2MASX J12522935+5902526',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000136,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,193.122167,59.04783,0,NULL,57440651133,897510173,14023596,17.8),(101619,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101619,37.73,0.16,351,42687,70,NULL,NULL,'SDSS J125230.38+445759.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000152,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,193.126625,44.96667,0.023,NULL,59107599995,923556249,14430566,18.6),(101620,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101620,37.36,0.46,297,42688,70,NULL,NULL,'2MASX J12523196+6727023',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000088,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,193.133375,67.45067,0.025,NULL,57856059946,904000936,14125014,16.4),(101621,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101621,36.8,0.46,229,42689,70,NULL,NULL,'2MASX J12523210+6212309',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000176,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,193.133625,62.20867,0,NULL,57355461224,896179081,14002798,16.9),(101622,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101622,36.32,0.46,184,42690,70,NULL,NULL,'2MASX J12523244+0314316',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.22',0.18,NULL,NULL,NULL,NULL,NULL,1,193.135083,3.24214,0.035,NULL,58094010598,907718915,14183108,18.22),(101623,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101623,36.54,0.46,204,42691,70,NULL,NULL,'2MASX J12523272+0451186',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,193.136291667,4.85519,0,NULL,58103483304,907866926,14185420,17),(101624,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101624,38.12,0.46,422,42692,70,NULL,NULL,'2MASX J12523272+0716188',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,193.136291667,7.27194,0.032,NULL,58081986566,907531040,14180172,17.7),(101625,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101625,37.07,0.46,259,42693,70,NULL,NULL,'2MASX J12523425+2503085',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000127,NULL,'17.62',0.18,NULL,NULL,NULL,NULL,NULL,1,193.14275,25.05239,0.104,NULL,58720766319,917511973,14336124,17.62),(101626,'SNIa','2016-12-15 15:15:07','2016-12-16 11:20:18','1','SN 2006D',NULL,101626,32.23,0.27,27.7,42694,74.2,NULL,'SALT 2','MRK 1337',0.008526,'2010ApJ...716..712A',2010,1,1.2,NULL,'G',0.000017,NULL,'15.0',0.8,'SAB(s)ab pec?  HII',NULL,NULL,NULL,NULL,1,193.144625,-9.77669,0.077,NULL,43119063197,673735362,10527115,15),(101627,'SNIa','2016-12-15 15:15:07','2016-12-16 11:20:18','1','SN 2006D',NULL,101627,32.68,0.13,34.1,42694,72,NULL,NULL,'MRK 1337',0.008526,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101628,'SNIa','2016-12-15 15:15:07','2016-12-16 11:20:18','1','SN 2006D',NULL,101628,32.72,0.06,34.7,42694,72,NULL,NULL,'MRK 1337',0.008526,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101629,'SNIa','2016-12-15 15:15:07','2016-12-16 11:20:18','1','SN 2006D',NULL,101629,32.71,0.01,34.8,42694,72,NULL,NULL,'MRK 1337',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101630,'SNIa','2016-12-15 15:15:07','2016-12-16 11:20:18','1','SN 2006D',NULL,101630,32.81,0.04,36.2,42694,72,NULL,NULL,'MRK 1337',0.008526,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101631,'SNIa','2016-12-15 15:15:07','2016-12-16 11:20:18','1','SN 2006D',NULL,101631,32.81,0.1,36.5,42694,74.4,NULL,NULL,'MRK 1337',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101632,'SNIa','2016-12-15 15:15:07','2016-12-16 11:20:18','1','SN 2006D',NULL,101632,32.9,0.03,38.1,42694,72,NULL,'M(H) = -18.317 mag','MRK 1337',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101633,'SNIa','2016-12-15 15:15:07','2016-12-16 11:20:18','1','SN 2006D',NULL,101633,33.01,0.23,39.5,42694,73.8,NULL,'SALT 2 (SNANA)','MRK 1337',0.01,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101634,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101634,30.82,1.02,14.6,42695,NULL,NULL,NULL,'ESO 442- G 028',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.00046,NULL,'15.18',1,'SB(s)m',NULL,NULL,NULL,NULL,1,193.146667,-31.88722,0.265,NULL,43460442887,679069420,10610459,15.18),(101635,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101635,31.43,0.77,19.4,42695,NULL,NULL,'Malmquist cor.','ESO 442- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101636,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101636,38.04,0.46,406,42696,70,NULL,NULL,'2MASX J12523574+0655124',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,193.148917,6.92017,0.018,NULL,58071487944,907366999,14177609,18.1),(101637,'Tully est','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101637,32.1,0.8,26.3,42697,75,NULL,NULL,'DDO 152',NULL,'1988NBGC.C....0000T',1988,1,2.1,'The APM position refers to a star cloud northeast of the nucleus.','G',0.000017,NULL,'16.17',2.1,'IAB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,193.151125,-6.28975,0.045,NULL,43128773035,673887078,10529485,16.17),(101638,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101638,31.23,0.4,17.6,42697,NULL,NULL,NULL,'DDO 152',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101639,'IRAS','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101639,35.25,0.8,112,42698,75,NULL,'W91CL, r','UGC 08013',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000006,NULL,'15.20',0.4,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,193.1512083,26.74989,0.023,NULL,58735153099,917736767,14339636,15.2),(101640,'IRAS','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101640,35.26,0.8,113,42698,75,NULL,'HMCL, I','UGC 08013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101641,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101641,35.01,0.38,100,42698,75,NULL,'W91CL, r, raw','UGC 08013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101642,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101642,35.05,0.38,103,42698,75,NULL,'W91CL, r, cor','UGC 08013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101643,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101643,35.06,0.4,103,42698,75,NULL,'HMCL, I, raw','UGC 08013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101644,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101644,35.11,0.4,105,42698,75,NULL,'HMCL, I, cor','UGC 08013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101645,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101645,35.12,0.09,106,42698,NULL,NULL,NULL,'UGC 08013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101646,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101646,35.13,0.38,106,42698,75,NULL,'W91CL, r, inv','UGC 08013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101647,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101647,35.22,0.4,111,42698,75,NULL,'HMCL, I, inv','UGC 08013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101648,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101648,35.28,0.2,114,42698,74.4,NULL,NULL,'UGC 08013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101649,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101649,35.44,0.43,122,42698,75,NULL,'3.6 micron, color corrected','UGC 08013',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101650,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101650,35.74,0.43,140,42698,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08013',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101651,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101651,37.46,0.27,310,42699,70,NULL,NULL,'2MASX J12523687+0812224',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.98',0.12,NULL,NULL,NULL,NULL,NULL,1,193.153833333,8.20639,0,NULL,58081913482,907529898,14180154,18.98),(101652,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101652,37.33,0.46,292,42700,70,NULL,NULL,'2MASX J12523780-0136411',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000083,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,193.157541667,-1.61131,0.005,NULL,43116577804,673696528,10526508,17.1),(101653,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101653,36.24,0.57,177,42701,70,NULL,NULL,'2MASX J12523803-2144240',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,193.158583333,-21.73997,0.185,NULL,43975643307,687119426,10736241,15.3),(101654,'IRAS','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101654,33.86,0.8,59.2,42702,75,NULL,'MAT, I','ESO 323- G 025',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000023,NULL,'13.39',1.1,'(R)SA(rs)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,193.1625417,-39.02828,0.325,NULL,46756681146,730573142,11415205,13.39),(101655,'IRAS','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101655,33.89,0.8,59.9,42702,75,NULL,'HMCL, I','ESO 323- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101656,'Sosies','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101656,33.56,0.21,51.5,42702,NULL,NULL,NULL,'ESO 323- G 025',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101657,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101657,33.49,0.32,50,42702,85,NULL,'I, raw','ESO 323- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101658,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101658,33.51,0.43,50.3,42702,75,NULL,'MAT, I, raw','ESO 323- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101659,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101659,33.52,NULL,50.6,42702,NULL,NULL,'B','ESO 323- G 025',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101660,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101660,33.55,0.32,51.4,42702,85,NULL,'I, inv','ESO 323- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101661,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101661,33.64,0.43,53.6,42702,75,NULL,'MAT, I, cor','ESO 323- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101662,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101662,33.68,0.47,54.5,42702,NULL,NULL,'H','ESO 323- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101663,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101663,33.71,0.43,55.2,42702,NULL,NULL,'Malmquist cor.','ESO 323- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101664,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101664,33.71,0.46,55.2,42702,NULL,NULL,'J','ESO 323- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101665,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101665,33.72,0.45,55.5,42702,NULL,NULL,'K','ESO 323- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101666,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101666,33.76,0.43,56.4,42702,75,NULL,'MAT, I, inv','ESO 323- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101667,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101667,33.76,NULL,56.5,42702,NULL,NULL,'I','ESO 323- G 025',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101668,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101668,33.81,0.4,57.7,42702,75,NULL,'HMCL, I, raw','ESO 323- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101669,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101669,33.87,0.4,59.4,42702,NULL,NULL,'mean','ESO 323- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101670,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101670,33.9,0.4,60.3,42702,75,NULL,'HMCL, I, cor','ESO 323- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101671,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101671,34.02,0.4,63.7,42702,75,NULL,'HMCL, I, inv','ESO 323- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101672,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101672,34.03,0.37,63.9,42702,NULL,NULL,NULL,'ESO 323- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101673,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101673,34.07,0.2,65.2,42702,74.4,NULL,NULL,'ESO 323- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101674,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101674,37.73,0.16,351,42703,70,NULL,NULL,'2MASX J12523910+4447094',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,193.163,44.78614,0.012,NULL,59107659568,923557180,14430580,17.7),(101675,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101675,37.46,0.27,310,42704,70,NULL,NULL,'2MASX J12524077+0822054',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.19',0.19,NULL,NULL,NULL,NULL,NULL,1,193.169917,8.36822,0,NULL,58081729372,907527021,14180109,18.19),(101676,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101676,33.84,0.25,58.6,42705,74.4,NULL,NULL,'2MASX J12524096-4113468',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.000077,NULL,'15.46',0.34,'S0','Group member',NULL,NULL,NULL,1,193.1704583,-41.22978,0.457,NULL,46754889648,730545150,11414767,15.46),(101677,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101677,35.32,0.33,116,42706,70,NULL,NULL,'2MASX J12524109+2621565',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00008,NULL,'15.5g',0.41,NULL,NULL,NULL,NULL,NULL,1,193.1712083,26.36583,0.033,NULL,58721505227,917523519,14336304,15.5),(101678,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101678,37.35,0.46,295,42707,70,NULL,NULL,'2MASX J12524112+0639344',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.84',0.13,NULL,NULL,NULL,NULL,NULL,1,193.171417,6.65972,0.015,NULL,58071701426,907370334,14177661,18.84),(101679,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101679,38.01,0.33,400,42708,70,NULL,NULL,'SDSS J125241.59+664619.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000072,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,193.1732917,66.77211,0.025,NULL,57852705035,903948516,14124195,18.5),(101680,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101680,36.53,0.35,203,42709,NULL,NULL,NULL,'2MASX J12524169-1559110',NULL,'2009ApJS..182..474S',2009,1,0.64,NULL,'G',0.000033,NULL,'15',0.26,'Sab','Group member',NULL,NULL,NULL,1,193.17375,-15.98633,0.049,NULL,43964438072,686944344,10733505,15),(101681,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101681,36.55,0.35,204,42709,NULL,NULL,'Malmquist cor.','2MASX J12524169-1559110',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101682,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101682,36.57,0.2,206,42709,74.4,NULL,NULL,'2MASX J12524169-1559110',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101683,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101683,35.32,0.33,116,42710,70,NULL,NULL,'IC 0831',NULL,'2015arXiv151105856S',2015,1,0.91,NULL,'G',0.000107,NULL,'14.7g',0.48,'E',NULL,NULL,NULL,NULL,1,193.183625,26.47042,0.029,NULL,58721510045,917523594,14336306,14.7),(101684,'IRAS','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101684,31.42,0.8,19.3,42711,75,NULL,'A82, H','NGC 4758',NULL,'1997ApJS..109..333W',1997,1,3.1,NULL,'G',0.00002,NULL,'13.55',0.7,'Im:            HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,193.1835417,15.84853,0.015,NULL,59001065268,921891644,14404556,13.55),(101685,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101685,30.37,0.43,11.9,42711,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4758',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101686,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101686,30.49,0.43,12.6,42711,75,NULL,'3.6 micron, color corrected','NGC 4758',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101687,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101687,30.57,0.2,13,42711,74.4,NULL,NULL,'NGC 4758',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101688,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101688,30.59,0.47,13.1,42711,75,NULL,'A82, H, inv','NGC 4758',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101689,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101689,30.62,0.42,13.3,42711,65,NULL,NULL,'NGC 4758',NULL,'1980ApJ...238..458M',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101690,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101690,30.72,0.47,13.9,42711,75,NULL,'A82, H, raw','NGC 4758',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101691,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101691,30.87,0.35,14.9,42711,NULL,NULL,NULL,'NGC 4758',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101692,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101692,31.05,0.4,16.2,42711,75,NULL,'B','NGC 4758',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101693,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101693,31.05,0.47,16.2,42711,75,NULL,'A82, H, cor','NGC 4758',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101694,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101694,37.25,0.46,282,42712,70,NULL,NULL,'2MASX J12524463+4500395',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000128,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,193.1860417,45.01097,0.023,NULL,59107601901,923556279,14430566,17.6),(101695,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101695,38.39,0.46,477,42713,70,NULL,NULL,'2MASX J12524526+2243154',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'19.11',NULL,NULL,NULL,NULL,NULL,NULL,1,193.188667,22.72103,0.118,NULL,59022662058,922229094,14409829,19.11),(101696,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101696,37.42,0.46,305,42714,70,NULL,NULL,'2MASX J12524764+5244352',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,193.1985,52.74306,0,NULL,57208520583,893883134,13966923,17.3),(101697,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101697,36.51,0.46,200,42715,70,NULL,NULL,'2MASXi J1252487+274728',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000097,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,193.202875,27.79131,0.037,NULL,58727380616,917615322,14337739,16.5),(101698,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101698,36.2,0.46,174,42716,70,NULL,NULL,'2MASX J12524868+4544335',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000173,NULL,'15.7g',0.49,'S0^-',NULL,NULL,NULL,NULL,1,193.203,45.74267,0,NULL,59120975835,923765247,14433831,15.7),(101699,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101699,37.8,0.46,362,42717,70,NULL,NULL,'2MASX J12524883+5515042',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000099,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,193.2037083,55.25122,0,NULL,57420609203,897197018,14018703,17.5),(101700,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101700,38.37,0.46,471,42718,70,NULL,NULL,'2MASX J12524933+0812464',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,193.205541667,8.21294,0,NULL,58081919677,907529994,14180156,17.3),(101701,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101701,37.46,0.27,310,42719,70,NULL,NULL,'2MASX J12524987+0819044',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.54',0.13,NULL,NULL,NULL,NULL,NULL,1,193.20775,8.31783,0,NULL,58081716812,907526825,14180106,18.54),(101702,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101702,36.49,0.46,199,42720,70,NULL,NULL,'CGCG 043-051',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000193,NULL,'15.6',0.2,NULL,NULL,NULL,NULL,NULL,1,193.207833,7.13217,0.032,NULL,58079090029,907485781,14179465,15.6),(101703,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101703,38.51,0.46,503,42721,70,NULL,NULL,'SDSS J125250.20+313755.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,193.2092083,31.63219,0.056,NULL,58749444450,917960069,14343126,18.5),(101704,'IRAS','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101704,33.61,0.8,52.7,42722,75,NULL,'MAT, I','ESO 323- G 027',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'13.68',1,'SAB(r)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,193.210375,-40.45167,0.473,NULL,46754235140,730534924,11414608,13.68),(101705,'IRAS','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101705,33.65,0.8,53.8,42722,75,NULL,'HMCL, I','ESO 323- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101706,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101706,33.16,0.4,42.9,42722,75,NULL,'HMCL, I, raw','ESO 323- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101707,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101707,33.19,0.43,43.5,42722,75,NULL,'3.6 micron, color + selection bias corrected','ESO 323- G 027',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101708,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101708,33.2,0.43,43.7,42722,75,NULL,'3.6 micron, color corrected','ESO 323- G 027',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101709,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101709,33.25,0.2,44.7,42722,74.4,NULL,NULL,'ESO 323- G 027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101710,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101710,33.33,0.38,46.3,42722,NULL,NULL,NULL,'ESO 323- G 027',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101711,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101711,33.34,0.4,46.6,42722,75,NULL,'HMCL, I, inv','ESO 323- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101712,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101712,33.36,0.4,46.9,42722,75,NULL,'HMCL, I, cor','ESO 323- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101713,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101713,33.39,0.08,47.7,42722,NULL,NULL,NULL,'ESO 323- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101714,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101714,33.45,0.32,49,42722,85,NULL,'I, raw','ESO 323- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101715,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101715,33.46,0.47,49.2,42722,NULL,NULL,'H','ESO 323- G 027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101716,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101716,33.48,0.46,49.7,42722,NULL,NULL,'J','ESO 323- G 027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101717,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101717,33.48,0.43,49.7,42722,75,NULL,'MAT, I, raw','ESO 323- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101718,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101718,33.49,0.45,50,42722,NULL,NULL,'K','ESO 323- G 027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101719,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101719,33.51,0.32,50.3,42722,85,NULL,'I, inv','ESO 323- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101720,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101720,33.61,NULL,52.8,42722,NULL,NULL,'B','ESO 323- G 027',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101721,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101721,33.62,0.43,53.1,42722,75,NULL,'MAT, I, cor','ESO 323- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101722,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101722,33.65,0.4,53.7,42722,NULL,NULL,'mean','ESO 323- G 027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101723,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101723,33.68,NULL,54.5,42722,NULL,NULL,'I','ESO 323- G 027',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101724,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101724,33.74,0.43,56,42722,75,NULL,'MAT, I, inv','ESO 323- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101725,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101725,37.74,0.46,352,42723,70,NULL,NULL,'2MASX J12525070+3437017',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000169,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,193.211333,34.61722,0.008,NULL,58740821939,917825342,14341020,17.8),(101726,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101726,32.72,0.4,35,42724,NULL,NULL,'mean','NGC 4751',NULL,'2007A&A...465...71T',2007,1,3,NULL,'G',0.00015,NULL,'11.80',1.1,'SA0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,193.211625,-42.65992,0.381,NULL,46759324302,730614442,11415850,11.8),(101727,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101727,33.34,0.45,46.6,42724,NULL,NULL,'K','NGC 4751',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101728,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101728,37.85,0.46,371,42725,70,NULL,NULL,'2MASX J12525088+6303159',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,193.211875,63.05453,0,NULL,57375996452,896499944,14007811,18),(101729,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101729,37.78,0.33,359,42726,70,NULL,NULL,'2MASX J12525181-0212152',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000099,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,193.215875,-2.20431,0.005,NULL,43116751317,673699239,10526550,17.2),(101730,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101730,33.75,0.45,56.1,42727,NULL,NULL,'K','NGC 4756',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000063,NULL,'12.1V',1.3,'SAB(s)0^0^?;cD','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,193.2192917,-15.41328,0.009,NULL,43964602670,686946916,10733545,12.1),(101731,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101731,33.95,0.4,61.7,42727,NULL,NULL,'mean','NGC 4756',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101732,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101732,38.8,0.46,574,42728,70,NULL,NULL,'2MASX J12525302+3406297',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,193.2210417,34.10825,0.009,NULL,58740380337,917818442,14340913,18),(101733,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101733,37.78,0.33,359,42729,70,NULL,NULL,'2MASX J12525315-0210342',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000079,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,193.221541667,-2.17625,0.005,NULL,43116752698,673699260,10526550,16.5),(101734,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101734,36.26,0.61,178,42730,70,NULL,NULL,'2MASX J12525334-4514218',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,193.2222917,-45.23944,0.365,NULL,46760791117,730637361,11416208,16.3),(101735,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101735,35.08,0.4,104,42731,NULL,NULL,'mean','UGC 08015',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000018,NULL,'14.2',1.1,'Sab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,193.223333,9.98925,0,NULL,58956722558,921198789,14393731,14.2),(101736,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101736,35.72,0.47,139,42731,NULL,NULL,'H','UGC 08015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101737,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101737,35.72,0.46,139,42731,NULL,NULL,'J','UGC 08015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101738,'IRAS','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101738,34.94,0.8,97.1,42732,75,NULL,'W91CL, r','UGC 08017',NULL,'1997ApJS..109..333W',1997,1,1.01,NULL,'G',0.000017,NULL,'14.3g',0.45,'Sab','in a radial-velocity based grouping',NULL,NULL,NULL,1,193.2232917,28.37128,0.043,NULL,58728109158,917626705,14337917,14.3),(101739,'IRAS','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101739,34.95,0.8,97.6,42732,75,NULL,'HMCL, I','UGC 08017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101740,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101740,35.06,0.47,103,42732,NULL,NULL,'H','UGC 08017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101741,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101741,35.08,0.45,104,42732,NULL,NULL,'K','UGC 08017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101742,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101742,35.14,0.4,107,42732,NULL,NULL,'mean','UGC 08017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101743,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101743,35.17,0.4,108,42732,75,NULL,'HMCL, I, raw','UGC 08017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101744,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101744,35.22,0.4,111,42732,75,NULL,'HMCL, I, cor','UGC 08017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101745,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101745,35.22,0.46,111,42732,NULL,NULL,'J','UGC 08017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101746,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101746,35.39,0.38,120,42732,75,NULL,'W91CL, r, raw','UGC 08017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101747,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101747,35.43,0.4,122,42732,75,NULL,'HMCL, I, inv','UGC 08017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101748,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101748,35.44,0.43,122,42732,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08017',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101749,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101749,35.46,0.43,123,42732,75,NULL,'3.6 micron, color corrected','UGC 08017',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101750,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101750,35.49,0.38,125,42732,75,NULL,'W91CL, r, cor','UGC 08017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101751,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101751,35.63,0.38,133,42732,75,NULL,'W91CL, r, inv','UGC 08017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101752,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101752,35.63,0.2,134,42732,74.4,NULL,NULL,'UGC 08017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101753,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101753,39.03,0.46,639,42733,70,NULL,NULL,'SDSS J125254.35+305739.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,193.2265,30.96086,0.06,NULL,58748904841,917951638,14342994,18.2),(101754,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101754,37.82,0.12,367,42734,70,NULL,NULL,'2MASX J12525434+5512173',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,193.226583,55.20497,0.017,NULL,57420597208,897196831,14018700,17.9),(101755,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101755,36.26,0.46,179,42735,70,NULL,NULL,'2MASX J12525471+5043404',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000087,NULL,'15.5g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,193.228125,50.72797,0,NULL,57203939407,893811553,13965805,15.5),(101756,'GCLF','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101756,31.63,0.3,21.2,42736,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4762',NULL,'2007ApJS..171..101J',2007,1,8.7,NULL,'G',0.000017,NULL,'11.12',1.7,'SB(r)0^0^ sp   LINER','Pair member (points to parent)',NULL,NULL,NULL,1,193.2335417,11.23081,0.006,NULL,58955694575,921182727,14393480,11.12),(101757,'GCLF','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101757,31.82,0.32,23.1,42736,NULL,NULL,'TOM(g) = -7.2 mag','NGC 4762',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101758,'GCLF','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101758,31.9,0.33,24,42736,NULL,NULL,'TOM(u) = -8.4 mag','NGC 4762',NULL,'2007ApJS..171..101J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101759,'GCLF','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101759,32.17,0.36,27.2,42736,NULL,NULL,'TOM(z) = -8.53 mag','NGC 4762',NULL,'2010ApJ...717..603V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101760,'Faber-Jackson','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101760,29.83,0.46,9.25,42736,95,NULL,'de Vaucouleurs','NGC 4762',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101761,'Faber-Jackson','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101761,30.08,0.29,10.4,42736,95,NULL,'Weighted Mean','NGC 4762',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101762,'Faber-Jackson','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101762,30.44,0.81,12.2,42736,55,NULL,'Visvanathan & Sandage 1979','NGC 4762',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101763,'Faber-Jackson','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101763,30.57,0.63,13,42736,95,NULL,'Michard 1979b, c','NGC 4762',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101764,'Faber-Jackson','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101764,30.83,0.46,14.7,42736,95,NULL,'Michard 1979a','NGC 4762',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101765,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101765,30.17,NULL,10.8,42736,NULL,NULL,NULL,'NGC 4762',NULL,'1999MNRAS.304..595G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101766,'Tertiary','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101766,30.49,0.25,12.5,42736,95,NULL,NULL,'NGC 4762',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101767,'Tully est','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101767,31.13,0.8,16.8,42736,75,NULL,'B','NGC 4762',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101768,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101768,37.77,0.46,358,42737,70,NULL,NULL,'SDSS J125257.11+234928.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'19.59',0.14,NULL,NULL,NULL,NULL,NULL,1,193.238,23.82461,0.096,NULL,59022246442,922222600,14409728,19.59),(101769,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101769,36.15,0.57,170,42738,70,NULL,NULL,'2MASX J12525787-1520498',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.000097,NULL,'15.1V',0.28,'E','Group member',NULL,NULL,NULL,1,193.2410417,-15.347,0.037,NULL,43963738992,686933421,10733334,15.1),(101770,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101770,38.05,0.46,407,42739,70,NULL,NULL,'2MASX J12525879+0108316',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000083,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,193.245083,1.14222,0.017,NULL,58098133848,907783341,14184114,17.3),(101771,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101771,37.73,0.16,351,42740,70,NULL,NULL,'2MASX J12525990+4501304',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000172,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,193.249916667,45.02517,0.006,NULL,59107632942,923556764,14430574,17.8),(101772,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101772,33.28,0.43,45.3,42741,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4767A',NULL,'2014MNRAS.444..527S',2014,1,0.9,NULL,'G',NULL,NULL,'16.31',0.3,'Scd pec sp',NULL,NULL,NULL,NULL,1,193.256167,-39.83525,0.369,NULL,46758064541,730594758,11415543,16.31),(101773,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101773,37.73,0.16,351,42742,70,NULL,NULL,'SDSS J125303.03+445914.7',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,193.262625,44.98744,0.006,NULL,59107632132,923556752,14430574,17.5),(101774,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101774,37.73,0.16,351,42743,70,NULL,NULL,'2MASX J12530320+4500444',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000203,NULL,'15.8g',0.53,'BrClG',NULL,NULL,NULL,NULL,1,193.26325,45.01247,0.006,NULL,59107633033,923556766,14430574,15.8),(101775,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101775,33.93,0.2,61.1,42744,74.4,NULL,NULL,'IC 3852',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.00005,NULL,'16.0',0.6,'SBd',NULL,NULL,NULL,NULL,1,193.26375,35.77344,0.027,NULL,58553154626,914893041,14295203,16),(101776,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101776,36,0.46,158,42745,70,NULL,NULL,'2MASX J12530355+4952464',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000186,NULL,'15.4g',0.45,'E0',NULL,NULL,NULL,NULL,1,193.264583,49.87969,0,NULL,59096592604,923384259,14427879,15.4),(101777,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101777,36.43,0.52,193,42746,70,NULL,NULL,'2MASX J12530377-1936380',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,193.265625,-19.61064,0.121,NULL,43983331027,687239547,10738117,15),(101778,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101778,37.07,0.57,260,42747,70,NULL,NULL,'2MASX J12530375-1527018',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.000077,NULL,'15.4V',0.3,'E','Group member',NULL,NULL,NULL,1,193.265833,-15.45039,0.009,NULL,43964597712,686946839,10733544,15.4),(101779,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101779,36.46,0.9,196,42748,70,NULL,NULL,'2MASX J12530417-1525568',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000067,NULL,'15.9V',0.2,'Sb','Group member',NULL,NULL,NULL,1,193.2675417,-15.43247,0.009,NULL,43964597370,686946833,10733544,15.9),(101780,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101780,34.5,0.59,79.4,42749,70,NULL,NULL,'2MASX J12530421-1021571',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00008,NULL,'15.67',NULL,NULL,NULL,NULL,NULL,NULL,1,193.267625,-10.36597,0.105,NULL,43842518799,685039356,10703739,15.67),(101781,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101781,37.25,0.46,281,42750,70,NULL,NULL,'I Zw 044 NOTES03',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000182,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,193.267958333,46.79933,0,NULL,59094646857,923353857,14427404,16.5),(101782,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101782,37.73,0.16,351,42751,70,NULL,NULL,'SDSS J125304.31+450237.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000185,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,193.268,45.04381,0.006,NULL,59107634184,923556784,14430574,18),(101783,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101783,37.04,0.46,256,42752,70,NULL,NULL,'2MASX J12530472+1404356',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000148,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,193.2694583,14.07667,0.085,NULL,59003131738,921923933,14405061,17.1),(101784,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101784,33.75,0.45,56.3,42753,NULL,NULL,'K','NGC 4759 NED02',NULL,'2007A&A...465...71T',2007,1,0.7,NULL,'G',0.000033,NULL,'13.47',0.5,'S0+;BrClG','Compact group member',NULL,NULL,NULL,1,193.274208333,-9.20383,0.097,NULL,43119345150,673739767,10527183,13.47),(101785,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101785,33.98,0.4,62.6,42753,NULL,NULL,'mean','NGC 4759 NED02',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101786,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101786,36.99,0.46,250,42754,70,NULL,NULL,'2MASX J12530570+3122257',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000123,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,193.2737917,31.37392,0.056,NULL,58749599020,917962484,14343163,16.4),(101787,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101787,36.27,0.55,180,42755,70,NULL,NULL,'2MASX J12530680-1551228',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15',0.4,'S0','Group member',NULL,NULL,NULL,1,193.27825,-15.85639,0.009,NULL,43964464553,686944758,10733511,15),(101788,'D-Sigma','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101788,33.51,0.4,50.4,42756,75,NULL,'Edat, raw','NGC 4760',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000057,NULL,'12.88',1.9,'E0?','in a pair',NULL,'radio jet','Flat-Spectrum Radio Source',1,193.280125,-10.49419,0.093,NULL,43842389521,685037336,10703708,12.88),(101789,'D-Sigma','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101789,33.85,0.4,58.9,42756,75,NULL,'Edat, cor','NGC 4760',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101790,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101790,33.97,0.47,62.3,42756,70,NULL,NULL,'NGC 4760',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101791,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101791,33.91,0.45,60.5,42756,NULL,NULL,'K','NGC 4760',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101792,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101792,34.17,0.4,68.1,42756,NULL,NULL,'mean','NGC 4760',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101793,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101793,36.76,0.46,225,42757,70,NULL,NULL,'2MASX J12530731+5138215',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00018,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,193.280833,51.63928,0,NULL,57209908062,893904813,13967262,16.3),(101794,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101794,37.62,0.46,334,42758,70,NULL,NULL,'2MASX J12530796+4342254',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000164,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,193.283083333,43.70689,0,NULL,59109009094,923578267,14430910,18.3),(101795,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101795,37.83,0.33,368,42759,70,NULL,NULL,'SDSS J125309.43+485634.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,193.2892917,48.94286,0,NULL,59096800222,923387503,14427929,17.8),(101796,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101796,37.73,0.16,351,42760,70,NULL,NULL,'2MASX J12530951+4459583',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,193.2897917,44.9995,0.006,NULL,59107637158,923556830,14430575,17.8),(101797,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101797,37.73,0.16,351,42761,70,NULL,NULL,'SDSS J125309.94+450105.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00016,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,193.2914583,45.01811,0.006,NULL,59107637009,923556828,14430575,18.2),(101798,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101798,37.82,0.12,367,42762,70,NULL,NULL,'2MASX J12530999+5510083',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000176,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,193.291833,55.16897,0.017,NULL,57420591458,897196741,14018699,16.7),(101799,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101799,33.12,0.47,42.1,42763,NULL,NULL,'H','ESO 507- G 037',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.00012,NULL,'14.28',0.3,'S?             HII',NULL,NULL,NULL,NULL,1,193.294833,-27.46686,0.313,NULL,43429742158,678589721,10602964,14.28),(101800,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101800,33.21,0.45,43.9,42763,NULL,NULL,'K','ESO 507- G 037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101801,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101801,33.4,0.46,47.8,42763,NULL,NULL,'J','ESO 507- G 037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101802,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101802,33.62,0.4,52.9,42763,NULL,NULL,'mean','ESO 507- G 037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101803,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101803,38.36,0.46,470,42764,70,NULL,NULL,'SDSS J125310.81+023217.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000069,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,193.2950417,2.53808,0.018,NULL,58095772357,907746443,14183538,18.7),(101804,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101804,38.23,0.5,442,42765,NULL,NULL,'Malmquist cor.','2MASX J12531100-2911079',NULL,'2009ApJS..182..474S',2009,1,0.25,NULL,'G',0.00003,NULL,'16.85',NULL,'Sc:',NULL,NULL,NULL,NULL,1,193.295875,-29.18561,0.309,NULL,43428717404,678573709,10602714,16.85),(101805,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101805,38.24,0.49,444,42765,NULL,NULL,NULL,'2MASX J12531100-2911079',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101806,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101806,38.28,0.2,453,42765,74.4,NULL,NULL,'2MASX J12531100-2911079',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101807,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101807,37.36,0.46,296,42766,70,NULL,NULL,'2MASX J12531123+3118097',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,193.296958333,31.30272,0.065,NULL,58749592811,917962387,14343162,17.2),(101808,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101808,38.15,0.33,426,42767,70,NULL,NULL,'SDSS J125311.62-005112.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000082,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,193.298458333,-0.85347,0.013,NULL,43114699835,673667184,10526049,18.6),(101809,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101809,35.97,0.53,157,42768,70,NULL,NULL,'2MASX J12531188-4503281',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000107,NULL,'15.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,193.299458333,-45.05783,0.365,NULL,46760850069,730638282,11416223,15.3),(101810,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101810,38.58,0.33,521,42769,70,NULL,NULL,'2MASX J12531214+3059177',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,193.300625,30.98833,0.06,NULL,58748896924,917951514,14342992,18.4),(101811,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101811,38.15,0.33,426,42770,70,NULL,NULL,'SDSS J125312.26-005257.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000072,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,193.301125,-0.88258,0.009,NULL,43114697842,673667153,10526049,18.3),(101812,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101812,37.15,0.46,269,42771,70,NULL,NULL,'2MASX J12531335+5539423',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00018,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,193.305833,55.66181,0,NULL,57432130333,897377036,14021516,16.7),(101813,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101813,37.88,0.33,377,42772,70,NULL,NULL,'SDSS J125313.74+062803.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,193.3072917,6.46756,0.025,NULL,58071613872,907368966,14177640,18.6),(101814,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101814,35.18,0.46,109,42773,70,NULL,NULL,'2MASX J12531396+6238198',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000165,NULL,'15.5g',0.43,'E0',NULL,NULL,NULL,NULL,1,193.307875,62.63875,0.021,NULL,57355123533,896173805,14002715,15.5),(101815,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101815,38.32,0.46,462,42774,70,NULL,NULL,'SDSS J125313.97+003130.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000073,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,193.30825,0.52525,0,NULL,58084725867,907573841,14180841,17.8),(101816,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101816,36.43,0.46,193,42775,70,NULL,NULL,'2MASX J12531436+1153527',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000164,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,193.309916667,11.89786,0.071,NULL,58992380734,921755948,14402436,16.8),(101817,'Tully est','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101817,31.63,0.8,21.2,42776,75,NULL,'B','NGC 4765',NULL,'1988NBGC.C....0000T',1988,1,1.1,'Multiple SDSS entries describe this object.','G',0.000005,NULL,'13.4B',0.8,'S0/a?          HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,193.3100417,4.46311,0.006,NULL,58103293853,907863966,14185374,13.4),(101818,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101818,29.93,NULL,9.68,42776,NULL,NULL,NULL,'NGC 4765',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101819,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101819,37.24,0.46,281,42777,70,NULL,NULL,'2MASX J12531588+5740553',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,193.316583333,57.68203,0,NULL,57442937365,897545896,14024154,17.7),(101820,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101820,35.31,0.05,115,42778,70,NULL,NULL,'CGCG 159-104',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000117,NULL,'14.83',0.7,'S0',NULL,NULL,NULL,NULL,1,193.317125,27.09444,0.026,NULL,58726775437,917605866,14337591,14.83),(101821,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101821,37.46,0.33,310,42779,70,NULL,NULL,'2MASX J12531858+0703017',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,'PHOT','18.03',0.2,'BrClG',NULL,NULL,NULL,NULL,1,193.3275417,7.05036,0.025,NULL,58079271684,907488620,14179509,18.03),(101822,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101822,38.7,0.33,549,42780,70,NULL,NULL,'SDSS J125319.05+003600.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000073,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,193.329375,0.60006,0,NULL,58084698567,907573415,14180834,18.2),(101823,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101823,37.74,0.46,354,42781,70,NULL,NULL,'SDSS J125319.89+173646.9',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,193.332875,17.61306,0.052,NULL,59044082819,922563794,14415059,NULL),(101824,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101824,38.7,0.33,549,42782,70,NULL,NULL,'SDSS J125320.75+003919.7',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000093,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,193.3365,0.65547,0,NULL,58084703412,907573490,14180835,17.8),(101825,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101825,38.58,0.33,521,42783,70,NULL,NULL,'2MASX J12532107+3057342',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000177,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,193.337875,30.95956,0.06,NULL,58748896196,917951503,14342992,17.2),(101826,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101826,31.27,0.36,17.9,42784,NULL,NULL,NULL,'NGC 4771',NULL,'2009AJ....138..323T',2009,1,4.57,NULL,'G',0.000024,NULL,'12.7g',0.77,'SAd? sp;Sy     LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,193.338416667,1.26908,0,NULL,58098113533,907783023,14184109,12.7),(101827,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101827,31.31,0.46,18.2,42784,NULL,NULL,'J','NGC 4771',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101828,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101828,31.31,0.4,18.3,42784,75,NULL,NULL,'NGC 4771',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101829,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101829,31.38,0.47,18.8,42784,NULL,NULL,'H','NGC 4771',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101830,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101830,31.45,0.46,19.5,42784,NULL,NULL,'Malmquist cor.','NGC 4771',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101831,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101831,31.45,0.45,19.5,42784,NULL,NULL,'K','NGC 4771',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101832,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101832,31.45,0.4,19.5,42784,NULL,NULL,NULL,'NGC 4771',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101833,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101833,31.49,0.45,19.9,42784,NULL,NULL,NULL,'NGC 4771',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101834,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101834,31.5,0.49,20,42784,75,NULL,'IR','NGC 4771',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101835,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101835,31.53,0.2,20.2,42784,74.4,NULL,NULL,'NGC 4771',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101836,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101836,31.53,0.4,20.3,42784,NULL,NULL,'mean','NGC 4771',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101837,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101837,31.9,0.3,24,42784,55,NULL,'B','NGC 4771',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101838,'Tully est','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101838,32.01,0.8,25.3,42785,75,NULL,NULL,'UGCA 305',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.00002,NULL,'16.79',1,'IB(s)m:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,193.339083,-4.97817,0.033,NULL,43138268457,674035444,10531803,16.79),(101839,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101839,31.21,0.4,17.5,42785,NULL,NULL,NULL,'UGCA 305',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101840,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101840,37.17,0.46,272,42786,70,NULL,NULL,'2MASX J12532205+0956227',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.26',0.19,NULL,NULL,NULL,NULL,NULL,1,193.341791667,9.93972,0,NULL,58956774021,921199594,14393743,18.26),(101841,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101841,37.83,0.33,368,42787,70,NULL,NULL,'2MASX J12532254+4856405',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000149,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,193.344083,48.94456,0,NULL,59096331302,923380176,14427815,17.5),(101842,'IRAS','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101842,32.1,0.8,26.3,42788,75,NULL,'MAT, I','ESO 323- G 033',NULL,'1997ApJS..109..333W',1997,1,1.79,NULL,'G',0.000033,NULL,'15.06',0.25,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,193.344167,-42.141,0.485,NULL,46751896294,730498379,11414037,15.06),(101843,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101843,32.9,0.32,38.1,42788,85,NULL,'I, inv','ESO 323- G 033',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101844,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101844,32.91,0.32,38.2,42788,85,NULL,'I, raw','ESO 323- G 033',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101845,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101845,32.99,0.49,39.7,42788,75,NULL,'IR','ESO 323- G 033',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101846,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101846,33.06,0.43,41,42788,75,NULL,'MAT, I, raw','ESO 323- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101847,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101847,33.1,0.43,41.8,42788,75,NULL,'MAT, I, inv','ESO 323- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101848,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101848,33.31,0.43,46,42788,75,NULL,'MAT, I, cor','ESO 323- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101849,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101849,33.68,NULL,54.5,42788,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 323- G 033',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101850,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101850,33.69,NULL,54.8,42788,NULL,NULL,'Dipole + Quadrupole','ESO 323- G 033',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101851,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101851,33.7,NULL,54.9,42788,NULL,NULL,'Dipole','ESO 323- G 033',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101852,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101852,33.76,NULL,56.6,42788,NULL,NULL,NULL,'ESO 323- G 033',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101853,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101853,37.09,0.46,262,42789,70,NULL,NULL,'LCRS B125048.7-025152',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000081,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,193.3465,-3.13561,0.013,NULL,43106891042,673545172,10524143,16.6),(101854,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101854,38.05,0.46,408,42790,70,NULL,NULL,'2MASX J12532347+4544316',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00018,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,193.347583,45.74211,0,NULL,59107293822,923551465,14430491,17.4),(101855,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101855,36.34,0.46,185,42791,70,NULL,NULL,'2MASX J12532576+3347362',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000158,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,193.357375,33.79347,0,NULL,58740278084,917816845,14340888,16.2),(101856,'SBF','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101856,32.69,0.22,34.5,42792,NULL,NULL,'I','ESO 323- G 034',NULL,'2001ApJ...546..681T',2001,1,2,NULL,'G',0.000011,NULL,'13.01',1.1,'E5:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,193.358083,-41.20283,0.453,NULL,46754353189,730536768,11414637,13.01),(101857,'SBF','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101857,32.69,0.22,34.5,42792,NULL,NULL,NULL,'ESO 323- G 034',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101858,'SBF','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101858,32.79,0.12,36.1,42792,74.4,NULL,NULL,'ESO 323- G 034',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101859,'SBF','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101859,32.82,0.22,36.7,42792,NULL,NULL,'Malmquist cor.','ESO 323- G 034',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101860,'D-Sigma','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101860,32.78,0.4,35.9,42792,75,NULL,'Edat, raw','ESO 323- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101861,'D-Sigma','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101861,32.88,0.4,37.6,42792,75,NULL,'Edat, cor','ESO 323- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101862,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101862,32.77,0.41,35.8,42792,NULL,NULL,NULL,'ESO 323- G 034',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101863,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101863,32.79,0.12,36.1,42792,74.4,NULL,NULL,'ESO 323- G 034',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101864,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101864,33.13,0.41,42.3,42792,NULL,NULL,'Malmquist cor.','ESO 323- G 034',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101865,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101865,38.03,0.46,404,42793,70,NULL,NULL,'SDSS J125326.04+241216.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'19.52',0.16,NULL,NULL,NULL,NULL,NULL,1,193.3585417,24.20447,0.077,NULL,58686928773,916983262,14327863,19.52),(101866,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101866,36.66,0.46,215,42794,70,NULL,NULL,'2MASX J12532661+1328215',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000153,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,193.360917,13.47275,0.077,NULL,59002605906,921915717,14404933,17),(101867,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101867,36.41,0.46,191,42795,70,NULL,NULL,'2MASX J12532668+1748455',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'16.75',0.24,NULL,NULL,NULL,NULL,NULL,1,193.361125,17.81253,0.069,NULL,59026838629,922294353,14410849,16.75),(101868,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101868,33.61,0.47,52.6,42796,NULL,NULL,'H','NGC 4763',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00003,NULL,'13.31',1.1,'SB(r)a:',NULL,NULL,NULL,NULL,1,193.363416667,-17.00553,0.045,NULL,44015918602,687748728,10746073,13.31),(101869,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101869,33.61,0.45,52.6,42796,NULL,NULL,'K','NGC 4763',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101870,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101870,33.63,0.46,53.1,42796,NULL,NULL,'J','NGC 4763',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101871,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101871,33.93,0.4,61,42796,NULL,NULL,'mean','NGC 4763',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101872,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101872,37.95,0.46,389,42797,70,NULL,NULL,'2MASX J12532723+3817550',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.29',0.14,NULL,NULL,NULL,NULL,NULL,1,193.363375,38.29853,0,NULL,59075438686,923053729,14422714,18.29),(101873,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101873,33.44,0.46,48.7,42798,NULL,NULL,'J','NGC 4785',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000042,NULL,'13.21',1,'(R\')SAB(r)ab   Sy2',NULL,NULL,NULL,'Sy 2',1,193.363875,-48.74919,0.893,NULL,46736309298,730254832,11410231,13.21),(101874,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101874,33.44,0.47,48.7,42798,NULL,NULL,'H','NGC 4785',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101875,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101875,33.47,0.45,49.5,42798,NULL,NULL,'K','NGC 4785',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101876,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101876,33.56,0.4,51.6,42798,NULL,NULL,'mean','NGC 4785',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101877,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101877,37.88,0.63,376,42799,70,NULL,NULL,'2MASX J12532848-1530297',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000067,NULL,'15.7V',0.3,'S/S0','Group member',NULL,NULL,NULL,1,193.368667,-15.50828,0.009,NULL,43964631277,686947363,10733552,15.7),(101878,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101878,36.78,0.33,227,42800,70,NULL,NULL,'2MASX J12532860+4629417',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00017,NULL,'16.1g',0.34,NULL,NULL,NULL,NULL,NULL,1,193.3692917,46.49486,0,NULL,59094611849,923353310,14427395,16.1),(101879,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101879,36.71,0.58,220,42801,70,NULL,NULL,'2MASX J12532896-1531597',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000073,NULL,'15.4V',0.2,'S0','Group member',NULL,NULL,NULL,1,193.37075,-15.53336,0.009,NULL,43964638427,686947475,10733554,15.4),(101880,'Sosies','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101880,32.26,0.25,28.3,42802,NULL,NULL,NULL,'NGC 4772',NULL,'2002A&A...393...57T',2002,1,3.4,NULL,'G',0.000017,NULL,'11.96',1.7,'SA(s)a;LINER   Sy3','in a radial-velocity based grouping',NULL,NULL,'LINER b',1,193.3715,2.16839,0,NULL,58099108852,907798575,14184352,11.96),(101881,'Tully est','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101881,31.07,0.8,16.3,42802,75,NULL,'B','NGC 4772',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101882,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101882,31.97,0.4,24.8,42802,NULL,NULL,NULL,'NGC 4772',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101883,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101883,32.81,0.3,36.4,42802,55,NULL,'B','NGC 4772',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101884,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101884,33.06,0.36,40.9,42802,NULL,NULL,NULL,'NGC 4772',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101885,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101885,38.41,0.46,480,42803,70,NULL,NULL,'2MASX J12532917+3808509',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000187,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,193.37175,38.14758,0,NULL,59075455676,923053994,14422718,17.8),(101886,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101886,33.71,0.49,55.1,42804,70,NULL,NULL,'2MASX J12532933-0525468',NULL,'2014MNRAS.445.2677S',2014,1,1.15,NULL,'G',0.00013,NULL,'14.90',0.5,NULL,NULL,NULL,NULL,NULL,1,193.3722917,-5.42989,0.041,NULL,43136049413,674000772,10531262,14.9),(101887,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101887,30.09,0.4,10.4,42805,NULL,NULL,NULL,'LCRS B125056.4-053926',NULL,'2013MNRAS.429.2677K',2013,1,0.87,NULL,'G',0.000013,NULL,'16.77',0.4,'Ir',NULL,NULL,NULL,NULL,1,193.381667,-5.92783,0.041,NULL,43128362522,673880664,10529385,16.77),(101888,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101888,30.09,NULL,10.4,42805,NULL,NULL,NULL,'LCRS B125056.4-053926',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101889,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101889,33.01,0.48,40,42806,70,NULL,NULL,'NGC 4770',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000117,NULL,'13.78',0.7,'S0/a:',NULL,NULL,NULL,NULL,1,193.3839583,-9.5415,0.097,NULL,43119268450,673738569,10527165,13.78),(101890,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101890,34.79,0.52,90.7,42807,70,NULL,NULL,'2MASX J12533295-3219450',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.6b',0.2,'Sp',NULL,NULL,NULL,NULL,1,193.387375,-32.32914,0.277,NULL,43459924395,679061318,10610333,16.6),(101891,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101891,38.39,0.46,477,42808,70,NULL,NULL,'2MASX J12533369+0832457',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,193.390416667,8.54614,0,NULL,58080052999,907500828,14179700,17.3),(101892,'IRAS','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101892,33.2,0.8,43.7,42809,75,NULL,'HMCL, I','ESO 507- G 041',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',NULL,NULL,'14.78',0.8,'SB.../Irr',NULL,NULL,NULL,NULL,1,193.3935417,-25.384,0.361,NULL,43421807687,678465745,10601027,14.78),(101893,'IRAS','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101893,33.2,0.8,43.7,42809,75,NULL,'A82, H','ESO 507- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101894,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101894,31.85,0.47,23.5,42809,75,NULL,'A82, H, inv','ESO 507- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101895,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101895,32.01,0.47,25.3,42809,75,NULL,'A82, H, raw','ESO 507- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101896,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101896,32.37,0.47,29.8,42809,75,NULL,'A82, H, cor','ESO 507- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101897,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101897,32.4,0.68,30.2,42809,NULL,NULL,NULL,'ESO 507- G 041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101898,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101898,32.44,0.2,30.8,42809,74.4,NULL,NULL,'ESO 507- G 041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101899,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101899,32.58,0.38,32.8,42809,NULL,NULL,NULL,'ESO 507- G 041',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101900,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101900,32.64,0.61,33.7,42809,NULL,NULL,'Malmquist cor.','ESO 507- G 041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101901,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101901,32.67,0.4,34.2,42809,75,NULL,'HMCL, I, raw','ESO 507- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101902,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101902,32.69,0.4,34.4,42809,75,NULL,'HMCL, I, inv','ESO 507- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101903,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101903,32.91,0.4,38.2,42809,75,NULL,'HMCL, I, cor','ESO 507- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101904,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101904,37.8,0.46,363,42810,70,NULL,NULL,'2MASX J12533477+3809519',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000171,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,193.394833,38.16444,0,NULL,59075454224,923053972,14422718,17.8),(101905,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101905,37.9,0.46,381,42811,70,NULL,NULL,'2MASX J12533526+0532090',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000169,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,193.396917,5.53597,0.016,NULL,58102115674,907845557,14185086,16.7),(101906,'IRAS','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101906,33.23,0.8,44.2,42812,75,NULL,'HMCL, I','ESO 507- G 042',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.00013,NULL,'14.36',0.6,'Sb             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,193.40025,-26.29422,0.385,NULL,43421648618,678463259,10600988,14.36),(101907,'IRAS','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101907,33.23,0.8,44.2,42812,75,NULL,'A82, H','ESO 507- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101908,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101908,33.04,0.47,40.5,42812,75,NULL,'A82, H, raw','ESO 507- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101909,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101909,33.08,0.47,41.3,42812,75,NULL,'A82, H, inv','ESO 507- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101910,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101910,33.17,0.38,43.1,42812,NULL,NULL,NULL,'ESO 507- G 042',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101911,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101911,33.23,0.13,44.4,42812,NULL,NULL,NULL,'ESO 507- G 042',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101912,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101912,33.28,0.47,45.3,42812,75,NULL,'A82, H, cor','ESO 507- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101913,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101913,33.3,0.4,45.8,42812,75,NULL,'HMCL, I, raw','ESO 507- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101914,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101914,33.41,0.4,48,42812,75,NULL,'HMCL, I, inv','ESO 507- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101915,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101915,33.41,0.4,48.2,42812,NULL,NULL,'mean','ESO 507- G 042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101916,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101916,33.44,0.4,48.8,42812,75,NULL,'HMCL, I, cor','ESO 507- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101917,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101917,33.64,0.47,53.4,42812,NULL,NULL,'H','ESO 507- G 042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101918,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101918,33.73,0.46,55.6,42812,NULL,NULL,'J','ESO 507- G 042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101919,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101919,33.75,0.45,56.3,42812,NULL,NULL,'K','ESO 507- G 042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101920,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101920,34.8,0.54,91.1,42813,70,NULL,NULL,'2MASX J12533607-1017557',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.72',NULL,NULL,NULL,NULL,NULL,NULL,1,193.4005417,-10.29886,0.093,NULL,43842532898,685039576,10703743,15.72),(101921,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101921,37.52,0.46,319,42814,70,NULL,NULL,'2MASX J12533635+2957432',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000189,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,193.4015,29.96192,0.065,NULL,58779094226,918423347,14350364,16.5),(101922,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101922,37.11,0.46,265,42815,70,NULL,NULL,'2MASX J12533699+1523176',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,193.404167,15.38814,0.014,NULL,59000308201,921879815,14404372,17.6),(101923,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101923,36.71,0.33,220,42816,70,NULL,NULL,'2MASX J12533848+5906261',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000178,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,193.4105,59.10719,0,NULL,57440788500,897512320,14023630,16.5),(101924,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101924,37.46,0.33,310,42817,70,NULL,NULL,'2MASX J12534056+0703116',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.74',0.15,NULL,NULL,NULL,NULL,NULL,1,193.4189583,7.05311,0.025,NULL,58079274671,907488666,14179510,18.74),(101925,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101925,37.09,0.46,261,42818,70,NULL,NULL,'2MASX J12534173+0341059',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.00012,NULL,'15.8g',0.44,'AGN',NULL,NULL,NULL,NULL,1,193.423875,3.68492,0,NULL,58101150929,907830483,14184851,15.8),(101926,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101926,34.93,0.49,96.9,42819,70,NULL,NULL,'2MASX J12534178-0453052',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.14',0.52,NULL,NULL,NULL,NULL,NULL,1,193.424041667,-4.885,0.033,NULL,43138272509,674035507,10531804,15.14),(101927,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101927,37.34,0.46,294,42820,70,NULL,NULL,'2MASX J12534422-0045122',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000098,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,193.4342083,-0.75356,0.013,NULL,43115219494,673675304,10526176,16.5),(101928,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101928,38.2,0.46,437,42821,70,NULL,NULL,'2MASX J12534429-0125032',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000081,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,193.434458333,-1.41772,0.037,NULL,43114954938,673671170,10526112,17.7),(101929,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101929,36.8,0.46,229,42822,70,NULL,NULL,'2MASX J12534471+5250593',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,193.436417,52.84989,0,NULL,57208622391,893884724,13966948,17.2),(101930,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101930,32.12,0.4,26.6,42823,75,NULL,'B','NGC 4775',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.00001,NULL,'12.24',2,'SA(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,193.440417,-6.62217,0.033,NULL,43128574593,673883978,10529437,12.24),(101931,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101931,35.57,0.55,130,42824,70,NULL,NULL,'2MASX J12534707-1514457',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000063,NULL,'14.3V',0.6,'SBb','Group member',NULL,NULL,NULL,1,193.4462083,-15.24608,0.037,NULL,43963847908,686935123,10733361,14.3),(101932,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101932,36.71,0.33,220,42825,70,NULL,NULL,'2MASX J12534720+5903131',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,193.446667,59.05375,0,NULL,57440759037,897511859,14023622,16.8),(101933,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101933,36.8,0.58,229,42826,70,NULL,NULL,'6dF J1253494-155851',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'17.1b',0.28,'S0','Group member',NULL,NULL,NULL,1,193.455916667,-15.98075,0.037,NULL,43964424320,686944130,10733502,17.1),(101934,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101934,32.95,0.36,38.9,42827,NULL,NULL,NULL,'NGC 4779',NULL,'2009AJ....138..323T',2009,1,2.1,NULL,'G',0.000002,NULL,'13.19',1.8,'SB(rs)bc;HII   Sbrst','Group member',NULL,NULL,'Starburst',1,193.461833,9.71006,0.026,NULL,58956943024,921202234,14393784,13.19),(101935,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101935,33.02,0.47,40.2,42827,NULL,NULL,'H','NGC 4779',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101936,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101936,33.05,0.45,40.7,42827,NULL,NULL,'K','NGC 4779',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101937,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101937,33.09,0.46,41.6,42827,NULL,NULL,'J','NGC 4779',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101938,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101938,33.16,0.4,42.8,42827,NULL,NULL,'mean','NGC 4779',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101939,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101939,35.04,0.43,102,42828,75,NULL,'3.6 micron, color + selection bias corrected','KUG 1251+292',NULL,'2014MNRAS.444..527S',2014,1,0.73,NULL,'G',0.000053,NULL,'15.5g',0.31,'Sc             Sbrst',NULL,NULL,NULL,NULL,1,193.464583,28.97939,0.033,NULL,58725473421,917585522,14337273,15.5),(101940,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101940,35.09,0.43,104,42828,75,NULL,'3.6 micron, color corrected','KUG 1251+292',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101941,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101941,35.21,0.2,110,42828,74.4,NULL,NULL,'KUG 1251+292',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101942,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101942,36.31,0.46,183,42829,70,NULL,NULL,'2MASX J12535163+0122069',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000081,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,193.4650417,1.36858,0,NULL,58098190682,907784229,14184128,16.5),(101943,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101943,37,0.63,251,42830,NULL,NULL,'Malmquist cor.','2MASX J12535225-2901344',NULL,'2009ApJS..182..474S',2009,1,0.44,NULL,'G',0.000043,NULL,'16.8V',NULL,'Sbc',NULL,NULL,NULL,NULL,1,193.468,-29.02619,0.309,NULL,43428867712,678576058,10602750,16.8),(101944,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101944,37.47,0.51,311,42830,NULL,NULL,NULL,'2MASX J12535225-2901344',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101945,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101945,37.51,0.2,318,42830,74.4,NULL,NULL,'2MASX J12535225-2901344',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101946,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101946,37.88,0.33,377,42831,70,NULL,NULL,'2MASX J12535233+0629117',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.46',0.17,NULL,NULL,NULL,NULL,NULL,1,193.467958333,6.4865,0.025,NULL,58071589459,907368585,14177634,18.46),(101947,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101947,37.19,0.46,275,42832,70,NULL,NULL,'2MASX J12535243+3151259',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,193.4684583,31.85717,0.048,NULL,58746856336,917919630,14342494,16.9),(101948,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101948,35.34,0.33,117,42833,70,NULL,NULL,'2MASX J12535252+3214299',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.00008,NULL,'14.5g',0.64,NULL,NULL,NULL,NULL,NULL,1,193.4687917,32.24167,0.04,NULL,58746918349,917920599,14342509,14.5),(101949,'SBF','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101949,32.55,0.12,32.4,42834,74.4,NULL,NULL,'NGC 4767',NULL,'2013AJ....146...86T',2013,1,2.6,NULL,'G',0.000019,NULL,'12.51',1.2,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,193.470625,-39.71431,0.405,NULL,46758049321,730594520,11415539,12.51),(101950,'SBF','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101950,32.58,0.25,32.8,42834,NULL,NULL,'I','NGC 4767',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101951,'SBF','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101951,32.58,0.25,32.8,42834,NULL,NULL,NULL,'NGC 4767',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101952,'SBF','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101952,32.74,0.25,35.3,42834,NULL,NULL,'Malmquist cor.','NGC 4767',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101953,'D-Sigma','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101953,32.93,0.4,38.6,42834,75,NULL,'Edat, raw','NGC 4767',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101954,'D-Sigma','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101954,32.95,0.4,38.9,42834,75,NULL,'Edat, cor','NGC 4767',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101955,'Faber-Jackson','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101955,32.39,0.65,30.1,42834,95,NULL,'Weighted Mean','NGC 4767',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101956,'Faber-Jackson','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101956,33.94,0.81,61.4,42834,55,NULL,'Visvanathan & Sandage 1979','NGC 4767',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101957,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101957,32.35,0.41,29.4,42834,NULL,NULL,NULL,'NGC 4767',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101958,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101958,32.55,0.12,32.4,42834,74.4,NULL,NULL,'NGC 4767',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101959,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101959,32.76,0.41,35.6,42834,NULL,NULL,'Malmquist cor.','NGC 4767',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101960,'Tertiary','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101960,32.42,0.71,30.5,42834,95,NULL,NULL,'NGC 4767',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101961,'Tully est','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101961,33.33,0.8,46.4,42834,75,NULL,'B','NGC 4767',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101962,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101962,32.44,0.45,30.8,42834,NULL,NULL,'K','NGC 4767',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101963,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101963,33.4,0.4,48,42834,NULL,NULL,'mean','NGC 4767',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101964,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101964,38.44,0.46,488,42835,70,NULL,NULL,'SDSS J125353.00+193328.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.7g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,193.470875,19.55783,0.055,NULL,59029349629,922333587,14411462,18.7),(101965,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101965,36.17,0.55,171,42836,70,NULL,NULL,'2MASX J12535329-1506294',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00012,NULL,'14',0.4,'S0','Group member',NULL,NULL,NULL,1,193.472167,-15.10836,0.037,NULL,43963893403,686935834,10733372,14),(101966,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101966,37.76,0.46,357,42837,70,NULL,NULL,'2MASX J12535456+6144369',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000159,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,193.477333333,61.74344,0,NULL,57356363791,896193184,14003018,17.1),(101967,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101967,36.78,0.33,227,42838,70,NULL,NULL,'2MASX J12535536+4632096',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,193.480583,46.53614,0,NULL,59094603812,923353184,14427393,17),(101968,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101968,36.15,0.46,170,42839,70,NULL,NULL,'CGCG 043-057',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000182,NULL,'15.6g',0.41,'E0',NULL,NULL,NULL,NULL,1,193.4860417,5.03211,0,NULL,58103040049,907860000,14185312,15.6),(101969,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101969,37.41,0.46,303,42840,70,NULL,NULL,'2MASX J12535681+2127168',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,193.486791667,21.45458,0.171,NULL,59024105446,922251647,14410181,17.5),(101970,'Tully est','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101970,31.19,0.8,17.3,42841,75,NULL,NULL,'UGCA 307',NULL,'1988NBGC.C....0000T',1988,1,2,'Position is for the eccentric nucleus.','G',0.000003,NULL,'15',1,'IB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,193.4887083,-12.10583,0.073,NULL,43958795954,686856186,10732127,15),(101971,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101971,29.5,0.4,8,42841,NULL,NULL,NULL,'UGCA 307',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101972,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101972,29.52,NULL,8.02,42841,NULL,NULL,NULL,'UGCA 307',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101973,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101973,33.1,0.48,41.7,42842,70,NULL,NULL,'NGC 4777',NULL,'2014MNRAS.445.2677S',2014,1,1.9,NULL,'G',0.000037,NULL,'14.02',0.9,'(R)SAB(s)a:',NULL,NULL,NULL,NULL,1,193.493917,-8.77572,0.097,NULL,43118942345,673733474,10527085,14.02),(101974,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101974,32.74,0.47,35.3,42842,NULL,NULL,'H','NGC 4777',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101975,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101975,32.85,0.46,37.1,42842,NULL,NULL,'J','NGC 4777',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101976,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101976,32.87,0.45,37.6,42842,NULL,NULL,'K','NGC 4777',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101977,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101977,33.54,0.4,51.1,42842,NULL,NULL,'mean','NGC 4777',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101978,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101978,37.3,0.46,289,42843,70,NULL,NULL,'2MASX J12535909+0107449',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000075,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,193.4962917,1.12908,0,NULL,58098210270,907784535,14184133,17.6),(101979,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101979,35.27,0.25,113,42844,74.4,NULL,NULL,'IC 0832',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000042,NULL,'14.9',0.3,'E?',NULL,NULL,NULL,NULL,1,193.4962917,26.44406,0.031,NULL,58721339969,917520937,14336264,14.9),(101980,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101980,35.31,0.05,115,42844,70,NULL,NULL,'IC 0832',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101981,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101981,36.39,0.51,190,42845,70,NULL,NULL,'2MASX J12540036-1647444',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'16.27',0.5,NULL,NULL,NULL,NULL,NULL,1,193.5014583,-16.79578,0.045,NULL,44015666024,687744781,10746012,16.27),(101982,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101982,37.06,0.46,258,42846,70,NULL,NULL,'2MASX J12540059+3609182',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00019,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,193.502375,36.15506,0.023,NULL,58552987701,914890432,14295163,16.5),(101983,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101983,38.12,0.46,421,42847,70,NULL,NULL,'2MASX J12540234+3019490',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,193.509667,30.33028,0.056,NULL,58746302521,917910976,14342359,17.6),(101984,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101984,36.81,0.46,230,42848,70,NULL,NULL,'MCG +08-24-001',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000241,NULL,'16.0g',0.4,'E0',NULL,NULL,NULL,NULL,1,193.510291667,48.78506,0,NULL,59096715155,923386174,14427908,16),(101985,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101985,34.4,NULL,75.9,42849,NULL,NULL,NULL,'UGC 08025',NULL,'1993MNRAS.263..211R',1993,1,2.03,NULL,'G',0.000009,NULL,'14.4g',0.36,'Sb','Pair member (points to parent)',NULL,NULL,NULL,1,193.510333,29.60361,0.032,NULL,58779124825,918423825,14350372,14.4),(101986,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101986,34.59,0.49,82.8,42849,75,NULL,'IR','UGC 08025',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101987,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101987,34.65,0.47,85.1,42849,NULL,NULL,'H','UGC 08025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101988,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101988,34.74,0.45,88.7,42849,NULL,NULL,'K','UGC 08025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101989,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101989,34.75,0.46,89.1,42849,NULL,NULL,'J','UGC 08025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101990,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101990,34.79,NULL,90.9,42849,NULL,NULL,NULL,'UGC 08025',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101991,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101991,34.89,0.4,95,42849,NULL,NULL,'mean','UGC 08025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101992,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101992,34.9,0.2,95.5,42849,74.4,NULL,NULL,'UGC 08025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101993,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101993,34.93,NULL,97,42849,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101994,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101994,34.94,NULL,97.3,42849,NULL,NULL,'Dipole + Quadrupole','UGC 08025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101995,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101995,34.94,NULL,97.4,42849,NULL,NULL,'Dipole','UGC 08025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101996,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101996,34.97,0.43,98.5,42849,75,NULL,'3.6 micron, color corrected','UGC 08025',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101997,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101997,35.17,0.43,108,42849,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08025',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101998,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,101998,35.25,0.15,112,42849,NULL,NULL,NULL,'UGC 08025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101999,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',101999,37.02,0.46,253,42850,70,NULL,NULL,'2MASX J12540375+4914533',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000184,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,193.51575,49.248,0,NULL,59096348514,923380445,14427819,16.7),(102000,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102000,35.03,0.51,102,42851,70,NULL,NULL,'2MASX J12540435-1335064',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.82',NULL,NULL,NULL,NULL,NULL,NULL,1,193.517958333,-13.58517,0.045,NULL,43971660786,687057199,10735268,15.82),(102001,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102001,37.88,0.46,377,42852,70,NULL,NULL,'2MASX J12540455+6500358',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000147,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,193.518667,65.01014,0.037,NULL,57366382813,896349731,14005464,17),(102002,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102002,33.03,0.47,40.4,42853,NULL,NULL,'H','NGC 4780',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000017,NULL,'13.81',1.3,'SAB(rs)c','in a pair',NULL,NULL,NULL,1,193.5217917,-8.62111,0.129,NULL,43118911920,673732998,10527078,13.81),(102003,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102003,33.09,0.46,41.6,42853,NULL,NULL,'J','NGC 4780',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102004,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102004,33.25,0.45,44.7,42853,NULL,NULL,'K','NGC 4780',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102005,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102005,33.53,0.4,50.8,42853,NULL,NULL,'mean','NGC 4780',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102006,'Brightest Stars','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102006,27.4,NULL,3.02,42854,NULL,NULL,NULL,'NGC 4789A',NULL,'1998AJ....116.2886S',1998,1,3,NULL,'G',0.000007,NULL,'13.94',2.2,'IB(s)m IV-V','in a pair',NULL,NULL,NULL,1,193.521875,27.14964,0.019,NULL,58726791428,917606116,14337595,13.94),(102007,'Brightest Stars','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102007,28.18,NULL,4.3,42854,NULL,NULL,NULL,'NGC 4789A',NULL,'1998A&AS..128..459M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102008,'TRGB','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102008,28.03,0.04,4.04,42854,NULL,NULL,'I','NGC 4789A',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102009,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102009,28.01,0.4,4,42854,75,NULL,'B','NGC 4789A',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102010,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102010,35.33,0.59,117,42855,70,NULL,NULL,'FGC 177A',NULL,'2014MNRAS.445.2677S',2014,1,1.51,NULL,'G',0.000033,NULL,'14',0.27,'Scd? sp','Group member',NULL,NULL,NULL,1,193.523833,-16.08367,0.037,NULL,43964398399,686943724,10733495,14),(102011,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102011,36.63,0.35,212,42855,NULL,NULL,'Malmquist cor.','FGC 177A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102012,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102012,36.66,0.35,215,42855,NULL,NULL,NULL,'FGC 177A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102013,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102013,36.7,0.2,219,42855,74.4,NULL,NULL,'FGC 177A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102014,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102014,38.01,0.46,401,42856,70,NULL,NULL,'SDSS J125406.11+181925.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,193.5255,18.32372,0.079,NULL,59030245377,922347584,14411681,18),(102015,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102015,37.26,0.17,283,42857,70,NULL,NULL,'2MASX J12540655+1853498',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,193.527375,18.89725,0.065,NULL,59030595145,922353049,14411766,17.7),(102016,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102016,37.81,0.33,365,42858,70,NULL,NULL,'2MASX J12540668+3411100',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,193.527917,34.18619,0,NULL,58741174798,917830856,14341107,18.2),(102017,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102017,36.84,0.46,234,42859,70,NULL,NULL,'2MASX J12540693+5513511',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000181,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,193.529083,55.23081,0,NULL,57423457553,897241524,14019398,16.2),(102018,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102018,36.17,0.46,171,42860,70,NULL,NULL,'2MASX J12540742+3229230',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000117,NULL,'17.11',0.21,NULL,NULL,NULL,NULL,NULL,1,193.530875,32.48969,0.064,NULL,58751533012,917992703,14343635,17.11),(102019,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102019,36.32,0.46,183,42861,70,NULL,NULL,'2MASX J12540908+0522529',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000103,NULL,'17.88',0.22,NULL,NULL,NULL,NULL,NULL,1,193.537833,5.38139,0,NULL,58101941972,907842843,14185044,17.88),(102020,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102020,36.13,0.52,168,42862,70,NULL,NULL,'2MASX J12540910-0115272',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.000112,NULL,'15.7g',0.52,'AGN',NULL,NULL,NULL,NULL,1,193.538,-1.25753,0.041,NULL,43115091471,673673304,10526145,15.7),(102021,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102021,36.4,0.46,191,42862,70,NULL,NULL,'2MASX J12540910-0115272',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102022,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102022,37.18,0.46,273,42863,70,NULL,NULL,'SDSS J125409.48+024647.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000068,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,193.5395,2.77997,0.048,NULL,58096224387,907753506,14183648,18.6),(102023,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102023,37.35,0.46,295,42864,70,NULL,NULL,'2MASX J12541017+1426306',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000151,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,193.542333,14.44172,0.071,NULL,59002892679,921920198,14405003,17.5),(102024,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102024,38.25,0.46,446,42865,70,NULL,NULL,'2MASX J12541041+6712461',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000089,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,193.543375,67.21267,0.029,NULL,57855987679,903999807,14124996,17.8),(102025,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102025,37.69,0.33,345,42866,70,NULL,NULL,'2MASXi J1254111+172114',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,193.5467083,17.35403,0.065,NULL,59044234986,922566171,14415096,17.9),(102026,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102026,37.6,0.46,331,42867,70,NULL,NULL,'Coma A',NULL,'2015arXiv151105856S',2015,1,0.42,'The position from the Texas survey is ~5 arcsec off the nucleus.','G',0.00006,NULL,'16.5g',0.36,'Radio galaxy   HEG','Group member',NULL,'FR II',NULL,1,193.5500417,27.62608,0.035,NULL,58726994585,917609290,14337645,16.5),(102027,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102027,37.69,0.33,345,42868,70,NULL,NULL,'2MASX J12541211+1718526',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,193.5505,17.31456,0.065,NULL,59044236301,922566192,14415096,17.3),(102028,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102028,37.26,0.17,283,42869,70,NULL,NULL,'IC 3865',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.87',0.17,NULL,NULL,NULL,NULL,NULL,1,193.5589583,18.86894,0.065,NULL,59030597620,922353087,14411766,17.87);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (102029,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102029,36.76,0.41,225,42870,NULL,NULL,'Malmquist cor.','AGC 520483',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.00003,NULL,'17.4V',NULL,NULL,NULL,NULL,NULL,NULL,1,193.5604583,-29.05089,0.313,NULL,43428785291,678574770,10602730,17.4),(102030,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102030,37,0.37,251,42870,NULL,NULL,NULL,'AGC 520483',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102031,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102031,37.04,0.2,256,42870,74.4,NULL,NULL,'AGC 520483',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102032,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102032,36.72,0.84,220,42871,70,NULL,NULL,'2MASX J12541542-1550084',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'16',0.3,'S0/E','Group member',NULL,NULL,NULL,1,193.564375,-15.83572,0.009,NULL,43964375396,686943365,10733490,16),(102033,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102033,39.07,0.46,650,42872,70,NULL,NULL,'SDSS J125415.81+040835.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000125,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,193.565875,4.14308,0.023,NULL,58101341947,907833467,14184897,18.3),(102034,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102034,37.67,0.46,342,42873,70,NULL,NULL,'2MASX J12541721+5300460',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000138,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,193.571667,53.01283,0,NULL,57200475172,893757424,13964959,18),(102035,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102035,36.12,0.46,167,42874,70,NULL,NULL,'2MASX J12541734+5757241',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000157,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,193.57225,57.95669,0,NULL,57442677085,897541829,14024091,16.4),(102036,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102036,36.62,0.24,211,42875,70,NULL,NULL,'ABELL 3528',NULL,'1999AJ....118.1489D',1999,1,NULL,'Katgert (1996,A&A,310,8) identifies multiple redshift systems in this cluster.','GClstr',NULL,NULL,NULL,NULL,'II     [BM];R  [A]',NULL,NULL,NULL,NULL,1,193.575833,-29.02103,0.313,NULL,43428785453,678574772,10602730,NULL),(102037,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102037,32.6,0.47,33.2,42876,NULL,NULL,'H','ESO 323- G 038',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000123,NULL,'14.33',0.5,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,193.576375,-41.82061,0.485,NULL,46752690611,730510790,11414231,14.33),(102038,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102038,32.65,0.45,33.9,42876,NULL,NULL,'K','ESO 323- G 038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102039,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102039,32.73,0.46,35.2,42876,NULL,NULL,'J','ESO 323- G 038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102040,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102040,33.35,0.4,46.7,42876,NULL,NULL,'mean','ESO 323- G 038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102041,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102041,36.73,0.46,222,42877,70,NULL,NULL,'2MASX J12541875+0926021',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.45',0.15,NULL,NULL,NULL,NULL,NULL,1,193.578166667,9.43392,0,NULL,58068496483,907320257,14176879,18.45),(102042,'D-Sigma','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102042,34.86,0.4,93.8,42878,75,NULL,'Edat, raw','NGC 4789',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'13.12',1.5,'SA0:           PAS','in a radial-velocity based grouping',NULL,'radio jet',NULL,1,193.57925,27.06803,0.019,NULL,58726565048,917602578,14337540,13.12),(102043,'D-Sigma','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102043,34.89,0.4,95,42878,75,NULL,'Edat, cor','NGC 4789',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102044,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102044,34.64,0.45,84.7,42878,NULL,NULL,'K','NGC 4789',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102045,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102045,35.43,0.4,122,42878,NULL,NULL,'mean','NGC 4789',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102046,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102046,38.03,0.46,403,42879,70,NULL,NULL,'2MASXi J1254193-014059',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000077,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,193.580625,-1.68317,0.017,NULL,43117128323,673705130,10526642,18),(102047,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102047,37.04,0.33,256,42880,70,NULL,NULL,'2MASX J12541981+1740055',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,193.582583,17.66819,0.066,NULL,59043856022,922560250,14415003,17.5),(102048,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102048,34.16,0.48,67.9,42881,70,NULL,NULL,'IC 3859',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.00015,NULL,'14.84',0.5,'SB?a? sp',NULL,NULL,NULL,NULL,1,193.58275,-9.11772,0.097,NULL,43119485686,673741963,10527218,14.84),(102049,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102049,37.39,0.46,300,42882,70,NULL,NULL,'2MASX J12542016+6620092',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000066,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,193.584208333,66.33594,0.017,NULL,57852949810,903952340,14124255,17.8),(102050,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102050,33.23,NULL,44.2,42883,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 443- G 003',NULL,'2010Ap&SS.325..163P',2010,1,1.21,NULL,'G',0.000023,NULL,'16.92',0.11,'Sc',NULL,NULL,NULL,NULL,1,193.585417,-31.78194,0.313,NULL,43460127644,679064494,10610382,16.92),(102051,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102051,33.24,NULL,44.5,42883,NULL,NULL,'Dipole + Quadrupole','ESO 443- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102052,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102052,33.25,NULL,44.7,42883,NULL,NULL,'Dipole','ESO 443- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102053,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102053,37.04,0.33,256,42884,70,NULL,NULL,'2MASX J12542190+1746296',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.82',0.24,NULL,NULL,NULL,NULL,NULL,1,193.591417,17.77486,0.066,NULL,59026853787,922294590,14410852,16.82),(102054,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102054,36.62,0.24,211,42885,70,NULL,'ABELL 3528, BGC','ESO 443- G 004',NULL,'1999AJ....118.1489D',1999,1,1.1,NULL,'G',0.000167,NULL,'13.5V',0.7,'cD;S0;BrClG','Brightest group member',NULL,NULL,NULL,1,193.592666667,-29.013,0.313,NULL,43428784530,678574758,10602730,13.5),(102055,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102055,35.31,0.05,115,42886,70,NULL,NULL,'2MASX J12542229+2705031',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000107,NULL,'16.1g',0.34,NULL,'Group member',NULL,NULL,NULL,1,193.592833333,27.08419,0.019,NULL,58726779261,917605925,14337592,16.1),(102056,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102056,37.44,0.33,307,42887,70,NULL,NULL,'2MASX J12542229+0850481',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.15',0.18,NULL,NULL,NULL,NULL,NULL,1,193.592917,8.84692,0,NULL,58068949755,907327339,14176989,18.15),(102057,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102057,37.58,0.46,328,42888,70,NULL,NULL,'2MASX J12542256-0131338',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000079,NULL,'17.7g',0.2,'NLAGN',NULL,NULL,NULL,NULL,1,193.594,-1.52608,0.041,NULL,43117049869,673703904,10526623,17.7),(102058,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102058,36.26,0.46,178,42889,70,NULL,NULL,'2MASX J12542270+0822392',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.87',0.17,NULL,NULL,NULL,NULL,NULL,1,193.59475,8.37761,0,NULL,58080041470,907500647,14179697,17.87),(102059,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102059,37.44,0.33,307,42890,70,NULL,NULL,'2MASX J12542282+0855522',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,193.594958333,8.93128,0,NULL,58068943546,907327242,14176988,17.1),(102060,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102060,37.17,0.6,271,42891,NULL,NULL,'Malmquist cor.','AGC 520535',NULL,'2009ApJS..182..474S',2009,1,0.31,NULL,'G',0.00003,NULL,'17.7V',NULL,'Sc',NULL,NULL,NULL,NULL,1,193.595833,-28.70375,0.313,NULL,43428289057,678567016,10602609,17.7),(102061,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102061,37.43,0.53,307,42891,NULL,NULL,NULL,'AGC 520535',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102062,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102062,37.48,0.2,313,42891,74.4,NULL,NULL,'AGC 520535',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102063,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102063,37.94,0.46,387,42892,70,NULL,NULL,'2MASX J12542344+6237536',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000142,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,193.597875,62.63158,0.017,NULL,57355117176,896173705,14002714,18.2),(102064,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102064,30.32,0.43,11.6,42893,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4781',NULL,'2014MNRAS.444..527S',2014,1,3.5,NULL,'G',0.000007,NULL,'11.72',1.5,'SB(rs)d        HII','in a pair',NULL,NULL,NULL,1,193.5989583,-10.53719,0.085,NULL,43843026409,685047287,10703863,11.72),(102065,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102065,30.47,0.43,12.4,42893,75,NULL,'3.6 micron, color corrected','NGC 4781',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102066,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102066,30.53,0.4,12.8,42893,NULL,NULL,NULL,'NGC 4781',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102067,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102067,30.58,0.46,13,42893,NULL,NULL,'J','NGC 4781',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102068,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102068,30.65,0.2,13.5,42893,74.4,NULL,NULL,'NGC 4781',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102069,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102069,30.66,0.47,13.6,42893,NULL,NULL,'H','NGC 4781',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102070,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102070,30.71,0.45,13.8,42893,NULL,NULL,'K','NGC 4781',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102071,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102071,30.95,0.43,15.5,42893,NULL,NULL,NULL,'NGC 4781',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102072,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102072,30.95,0.4,15.5,42893,NULL,NULL,NULL,'NGC 4781',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102073,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102073,31.07,0.41,16.4,42893,NULL,NULL,'Malmquist cor.','NGC 4781',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102074,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102074,31.65,0.4,21.4,42893,NULL,NULL,'mean','NGC 4781',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102075,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102075,31.76,0.4,22.5,42893,75,NULL,'B','NGC 4781',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102076,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102076,37.95,0.46,389,42894,70,NULL,NULL,'2MASX J12542414+6416397',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000147,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,193.6002917,64.27761,0.029,NULL,57367914359,896373661,14005838,17),(102077,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102077,33.99,NULL,62.9,42895,NULL,NULL,NULL,'FGC 1519',NULL,'2000BSAO...50....5K',2000,1,1.12,NULL,'G',0.000007,NULL,'16.4',0.11,'Sdm',NULL,NULL,NULL,NULL,1,193.601667,-10.21389,0.085,NULL,43842468916,685038576,10703727,16.4),(102078,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102078,34.03,NULL,63.9,42895,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1519',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102079,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102079,34.03,NULL,64,42895,NULL,NULL,'Dipole + Quadrupole','FGC 1519',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102080,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102080,34.05,NULL,64.5,42895,NULL,NULL,'Dipole','FGC 1519',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102081,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102081,36.79,0.79,228,42896,70,NULL,NULL,'2MASX J12542481-3053373',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00014,NULL,'16.4',0.4,'Sp',NULL,NULL,NULL,NULL,1,193.6035,-30.89369,0.325,NULL,43457898845,679029669,10609838,16.4),(102082,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102082,38.12,0.46,420,42897,70,NULL,NULL,'SDSS J125424.99+070442.1',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,193.604167,7.07839,0.025,NULL,58079194102,907487407,14179490,17.5),(102083,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102083,37.26,0.17,283,42898,70,NULL,NULL,'IC 3871',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'15.19',0.2,NULL,NULL,NULL,NULL,NULL,1,193.6069583,18.92914,0.065,NULL,59030544965,922352265,14411754,15.19),(102084,'IRAS','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102084,34.23,0.8,70.2,42899,75,NULL,'HMCL, I','ESO 323- G 039',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000007,NULL,'15.32',0.5,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,193.6102083,-40.37233,0.469,NULL,46757760365,730590005,11415468,15.32),(102085,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102085,34.29,0.85,72.1,42899,NULL,NULL,'Malmquist cor.','ESO 323- G 039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102086,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102086,34.55,0.75,81.3,42899,NULL,NULL,NULL,'ESO 323- G 039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102087,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102087,34.59,0.2,82.8,42899,74.4,NULL,NULL,'ESO 323- G 039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102088,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102088,34.64,0.4,84.7,42899,75,NULL,'HMCL, I, raw','ESO 323- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102089,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102089,34.75,0.4,89.3,42899,75,NULL,'HMCL, I, inv','ESO 323- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102090,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102090,34.81,0.4,91.7,42899,75,NULL,'HMCL, I, cor','ESO 323- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102091,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102091,37.36,0.46,297,42900,70,NULL,NULL,'2MASX J12542651+2930260',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000117,NULL,'17.0g',0.23,'Sbrst',NULL,NULL,NULL,NULL,1,193.610667,29.50719,0.033,NULL,58724680017,917573125,14337080,17),(102092,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102092,38.59,0.46,523,42901,70,NULL,NULL,'SDSS J125428.09+061209.0',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,193.617083,6.20253,0.023,NULL,58072152088,907377376,14177771,NULL),(102093,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102093,30.92,NULL,15.3,42902,NULL,NULL,NULL,'UGC 08030',NULL,'2013AJ....145..101K',2013,1,0.9,NULL,'G',0.000013,NULL,'18.',0.5,'Im:',NULL,NULL,NULL,NULL,1,193.6225,26.305,0.031,NULL,58688899477,917014054,14328344,18),(102094,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102094,37.26,0.17,283,42903,70,NULL,NULL,'IC 3872',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.05',0.2,'Compact',NULL,NULL,NULL,NULL,1,193.627333,18.96317,0.065,NULL,59030547248,922352300,14411754,18.05),(102095,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102095,36.65,0.46,214,42904,70,NULL,NULL,'LCRS B125156.2-030305',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000092,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,193.6280417,-3.3225,0.009,NULL,43106104632,673532884,10523951,16.5),(102096,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102096,37.81,0.33,365,42905,70,NULL,NULL,'2MASX J12543121+3408251',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000172,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,193.630125,34.14031,0,NULL,58741137429,917830272,14341098,16.8),(102097,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102097,37.34,0.46,294,42906,70,NULL,NULL,'2MASX J12543142+2620405',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00012,NULL,'16.1g',0.38,NULL,NULL,NULL,NULL,NULL,1,193.631,26.34464,0.031,NULL,58689031588,917016118,14328376,16.1),(102098,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102098,37.27,0.46,285,42907,70,NULL,NULL,'SDSS J125431.69+051353.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000135,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,193.6320417,5.23156,0,NULL,58102420825,907850325,14185161,18.5),(102099,'D-Sigma','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102099,33.81,0.4,57.8,42908,75,NULL,'Edat, raw','NGC 4786',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000093,NULL,'12.4B',1.3,'E+ pec',NULL,NULL,NULL,NULL,1,193.635083,-6.85942,0.041,NULL,43130372915,673912076,10529876,12.4),(102100,'D-Sigma','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102100,34.14,0.4,67.4,42908,75,NULL,'Edat, cor','NGC 4786',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102101,'Faber-Jackson','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102101,31.68,0.65,21.7,42908,95,NULL,'Weighted Mean','NGC 4786',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102102,'Faber-Jackson','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102102,33.06,0.81,40.9,42908,55,NULL,'Visvanathan & Sandage 1979','NGC 4786',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102103,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102103,33.73,0.46,55.7,42908,70,NULL,NULL,'NGC 4786',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102104,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102104,34.04,0.45,64.2,42908,NULL,NULL,'K','NGC 4786',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102105,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102105,34.09,0.4,65.7,42908,NULL,NULL,'mean','NGC 4786',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102106,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102106,35.13,0.59,106,42909,70,NULL,NULL,'2MASX J12543317-1935375',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.33',NULL,'SB(r)0/a:',NULL,NULL,NULL,NULL,1,193.63825,-19.59389,0.129,NULL,43982991716,687234245,10738035,15.33),(102107,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102107,39.1,0.46,662,42910,70,NULL,NULL,'SDSS J125433.66+123920.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,193.6402917,12.65561,0.046,NULL,58990249916,921722654,14401916,18.4),(102108,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102108,37.06,0.33,259,42911,70,NULL,NULL,'2MASX J12543425+3658345',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00018,NULL,'17.33',0.16,'AGN',NULL,NULL,NULL,NULL,1,193.6427083,36.97644,0.025,NULL,59076203123,923065673,14422901,17.33),(102109,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102109,36.49,0.57,198,42912,70,NULL,NULL,'2MASX J12543438-1447189',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.0R',0.3,'S0','Group member',NULL,NULL,NULL,1,193.643333,-14.78867,0.033,NULL,43963660057,686932188,10733315,15),(102110,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102110,37.26,0.17,283,42913,70,NULL,NULL,'IC 3874',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00037,NULL,'17.37',0.4,NULL,NULL,NULL,NULL,NULL,1,193.643416667,18.957,NULL,NULL,59030547165,922352299,14411754,17.37),(102111,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102111,36.87,0.27,237,42914,70,NULL,NULL,'2MASX J12543471+5306461',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,193.644667,53.11264,0,NULL,57200438886,893756857,13964950,17.5),(102112,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102112,37.06,0.33,259,42915,70,NULL,NULL,'2MASX J12543509+3657175',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000192,NULL,'17.1g',0.18,'AGN',NULL,NULL,NULL,NULL,1,193.646125,36.95492,0.025,NULL,59076026458,923062913,14422858,17.1),(102113,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102113,36.97,0.46,248,42916,70,NULL,NULL,'2MASX J12543547+4140475',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,193.647666667,41.67997,0,NULL,59078797825,923106216,14423534,17.8),(102114,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102114,35.85,0.62,148,42917,70,NULL,NULL,'2MASX J12543551-4547323',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,193.648083,-45.79225,0.525,NULL,46760453416,730632084,11416126,15.2),(102115,'D-Sigma','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102115,33.51,0.4,50.4,42918,75,NULL,'Edat, raw','NGC 4782',NULL,'1997ApJS..109..333W',1997,1,1.8,'Sometimes confused with NGC 4783.','G',0.000063,NULL,'12.69',1.7,'E0 pec','Pair member (points to parent)',NULL,NULL,NULL,1,193.648833,-12.56864,0.061,NULL,43959184894,686862263,10732222,12.69),(102116,'D-Sigma','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102116,33.85,0.4,58.9,42918,75,NULL,'Edat, cor','NGC 4782',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102117,'Faber-Jackson','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102117,33.07,0.46,41.1,42918,95,NULL,'Michard 1979a','NGC 4782',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102118,'Faber-Jackson','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102118,33.09,0.63,41.5,42918,95,NULL,'Michard 1979b, c','NGC 4782',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102119,'Faber-Jackson','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102119,33.26,0.32,44.9,42918,95,NULL,'Weighted Mean','NGC 4782',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102120,'Faber-Jackson','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102120,33.95,0.48,61.7,42918,95,NULL,'de Vaucouleurs','NGC 4782',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102121,'Tertiary','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102121,33.11,0.5,41.9,42918,95,NULL,NULL,'NGC 4782',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102122,'FP','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,'R',102122,35.9,0.33,151,42919,70,NULL,NULL,'CGCG 316-005',NULL,'2015arXiv151105856S',2015,1,0.91,NULL,'G',0.0002,NULL,'14.6g',0.68,'E0',NULL,NULL,NULL,NULL,1,193.650917,62.229,0.009,NULL,57355451068,896178922,14002795,14.6),(102123,'D-Sigma','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102123,33.51,0.4,50.4,42920,75,NULL,'Edat, raw','NGC 4783',NULL,'1997ApJS..109..333W',1997,1,1.8,'Sometimes confused with NGC 4782.','G',0.000063,NULL,'12.54',1.7,'E0 pec','Pair member (points to parent)',NULL,NULL,NULL,1,193.6524583,-12.55783,0.061,NULL,43959184647,686862260,10732222,12.54),(102124,'D-Sigma','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102124,33.85,0.4,58.9,42920,75,NULL,'Edat, cor','NGC 4783',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102125,'Faber-Jackson','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102125,33.04,0.32,40.6,42920,95,NULL,'Weighted Mean','NGC 4783',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102126,'Faber-Jackson','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102126,33.07,0.48,41.1,42920,95,NULL,'de Vaucouleurs','NGC 4783',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102127,'Faber-Jackson','2016-12-15 15:15:07','2016-12-16 11:20:18','1',NULL,NULL,102127,33.41,0.46,48.1,42920,95,NULL,'Michard 1979a','NGC 4783',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102128,'Faber-Jackson','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102128,33.51,0.63,50.4,42920,95,NULL,'Michard 1979b, c','NGC 4783',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102129,'Tertiary','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102129,33.11,0.5,41.9,42920,95,NULL,NULL,'NGC 4783',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102130,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102130,33.43,0.47,48.6,42921,70,NULL,NULL,'NGC 4784',NULL,'2014MNRAS.445.2677S',2014,1,1.9,'The redshift from 1998AJ....116....1D (V = 1260 +- 2 km/s) is for NGC 4781.','G',0.00015,NULL,'14.49',0.4,'S0','in a pair',NULL,NULL,NULL,1,193.65425,-10.61306,0.093,NULL,43843058280,685047785,10703871,14.49),(102131,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102131,38.59,0.46,523,42922,70,NULL,NULL,'2MASX J12543703+6451237',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000096,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,193.6545417,64.85661,0.037,NULL,57366226234,896347284,14005426,18),(102132,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102132,36.08,0.57,165,42923,70,NULL,NULL,'ESO 575- G 023',NULL,'2014MNRAS.445.2677S',2014,1,1.3,'RC3 has V = 1513 +- 9 km/s.','G',0.00015,NULL,'14.76',1.2,'(R\')SB(rs)ab',NULL,NULL,NULL,NULL,1,193.654667,-18.30828,0.081,NULL,43984989004,687265453,10738522,14.76),(102133,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102133,34.9,0.4,95.3,42924,NULL,NULL,'mean','MCG -02-33-052',NULL,'2007A&A...465...71T',2007,1,1.83,NULL,'G',0.00002,NULL,'16',0.2,'Sc',NULL,NULL,NULL,NULL,1,193.6557083,-11.60697,0.089,NULL,43958699005,686854671,10732104,16),(102134,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102134,35.01,0.49,100,42924,75,NULL,'IR','MCG -02-33-052',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102135,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102135,35.09,NULL,104,42924,NULL,NULL,'Dipole + Quadrupole','MCG -02-33-052',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102136,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102136,35.09,NULL,104,42924,NULL,NULL,'Dipole','MCG -02-33-052',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102137,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102137,35.1,NULL,105,42924,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -02-33-052',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102138,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102138,35.1,0.47,105,42924,NULL,NULL,'H','MCG -02-33-052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102139,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102139,35.21,0.45,110,42924,NULL,NULL,'K','MCG -02-33-052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102140,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102140,36.87,0.27,237,42925,70,NULL,NULL,'NGC 4801',NULL,'2015arXiv151105856S',2015,1,0.95,NULL,'G',0.000127,NULL,'14.9g',0.61,'E0',NULL,NULL,NULL,NULL,1,193.657375,53.09,0,NULL,57200438758,893756855,13964950,14.9),(102141,'Sosies','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102141,32.37,0.38,29.8,42926,NULL,NULL,NULL,'NGC 4800',NULL,'2002A&A...393...57T',2002,1,1.6,NULL,'G',0.000057,NULL,'12.3',1.2,'SA(rs)b        HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,193.6575,46.53117,0,NULL,59101943588,923467868,14429185,12.3),(102142,'Tully est','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102142,30.91,0.8,15.2,42926,75,NULL,'B','NGC 4800',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102143,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102143,32.31,0.43,29,42926,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4800',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102144,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102144,37.56,0.46,325,42927,70,NULL,NULL,'2MASX J12543782-0011048',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000093,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,193.657667,-0.18456,0.013,NULL,43103012464,673484569,10523196,16.3),(102145,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102145,37.37,0.46,298,42928,70,NULL,NULL,'2MASX J12543837+2909375',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000113,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,193.6599583,29.16039,0.035,NULL,58724627860,917572310,14337067,17),(102146,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102146,36.11,0.46,167,42929,70,NULL,NULL,'2MASXi J1254385+454852',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000157,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,193.66025,45.81453,0,NULL,59107440981,923553765,14430527,16.8),(102147,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102147,36.86,0.53,235,42930,70,NULL,NULL,'2MASX J12543922-1814240',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.17',NULL,NULL,NULL,NULL,NULL,NULL,1,193.663583,-18.24022,0.081,NULL,43984993284,687265520,10738523,16.17),(102148,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102148,38.67,0.46,542,42931,70,NULL,NULL,'2MASX J12543997+2620025',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,193.6664583,26.33411,0.031,NULL,58689041874,917016279,14328379,17.7),(102149,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102149,36.35,0.57,186,42932,70,NULL,NULL,'2MASX J12544025-1731339',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14',0.2,'E','Group member',NULL,NULL,NULL,1,193.667667,-17.52628,0.073,NULL,44015543011,687742859,10745982,14),(102150,'Tully est','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102150,32.95,0.8,38.9,42933,75,NULL,'B','NGC 4793',NULL,'1988NBGC.C....0000T',1988,1,2.8,NULL,'G',0.000009,NULL,'12.3',1.5,'SAB(rs)c       Sbrst','Group member',NULL,NULL,NULL,1,193.66925,28.93867,0.043,NULL,58725367088,917583860,14337247,12.3),(102151,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102151,31.89,0.69,23.9,42933,100,NULL,'mid-IR','NGC 4793',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102152,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102152,32.03,0.43,25.5,42933,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4793',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102153,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102153,32.22,0.43,27.8,42933,75,NULL,'3.6 micron, color corrected','NGC 4793',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102154,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102154,32.28,0.46,28.5,42933,NULL,NULL,'Malmquist cor.','NGC 4793',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102155,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102155,32.34,0.45,29.4,42933,NULL,NULL,'K','NGC 4793',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102156,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102156,32.36,0.46,29.7,42933,NULL,NULL,'J','NGC 4793',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102157,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102157,32.39,0.47,30,42933,NULL,NULL,'H','NGC 4793',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102158,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102158,32.47,0.2,31.2,42933,74.4,NULL,NULL,'NGC 4793',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102159,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102159,32.61,0.4,33.3,42933,NULL,NULL,NULL,'NGC 4793',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102160,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102160,32.69,0.3,34.6,42933,55,NULL,'B','NGC 4793',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102161,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102161,32.94,0.4,38.7,42933,NULL,NULL,'mean','NGC 4793',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102162,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102162,38.41,0.46,480,42934,70,NULL,NULL,'2MASX J12544204+1552496',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.48',0.15,NULL,NULL,NULL,NULL,NULL,1,193.67525,15.88042,0,NULL,59000716840,921886200,14404471,18.48),(102163,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102163,37.72,0.46,349,42935,70,NULL,NULL,'2MASX J12544237+3258312',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00018,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,193.6764583,32.97525,0.017,NULL,58751592308,917993629,14343650,17),(102164,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102164,36.56,0.55,205,42936,70,NULL,NULL,'2MASX J12544252-1654119',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.4b',0.4,'Sa','Group member',NULL,NULL,NULL,1,193.6772083,-16.90325,0.049,NULL,44015728309,687745754,10746027,16.4),(102165,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102165,37.17,0.46,271,42937,70,NULL,NULL,'2MASX J12544304-0208505',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000073,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,193.6794583,-2.14733,0.013,NULL,43113604844,673650075,10525782,17),(102166,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102166,37.22,0.46,278,42938,70,NULL,NULL,'2MASX J12544319+3953035',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000182,NULL,'16.0g',0.4,NULL,NULL,NULL,NULL,NULL,1,193.680167,39.88419,0,NULL,59089252562,923269571,14426087,16),(102167,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102167,32.33,0.49,29.3,42939,75,NULL,'IR','UGC 08040',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000067,NULL,'14.70',0.2,'S?','in a radial-velocity based grouping',NULL,NULL,NULL,1,193.6814583,58.77639,0,NULL,57440825479,897512898,14023639,14.7),(102168,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102168,33.99,0.46,62.8,42940,70,NULL,NULL,'MCG -02-33-054',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'15',0.2,'E',NULL,NULL,NULL,NULL,1,193.6814583,-12.76078,0.061,NULL,43958951312,686858614,10732165,15),(102169,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102169,37.89,0.46,379,42941,70,NULL,NULL,'2MASX J12544429-0100045',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000085,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,193.6845,-1.00128,0.037,NULL,43115328281,673677004,10526203,17.2),(102170,'IRAS','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102170,33.35,0.8,46.7,42942,75,NULL,'MAT, I','NGC 4767B',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'13.82',1,'SB(s)cd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,193.687625,-39.85228,0.437,NULL,46757954659,730593041,11415516,13.82),(102171,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102171,32.77,0.32,35.8,42942,85,NULL,'I, raw','NGC 4767B',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102172,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102172,32.81,0.32,36.4,42942,85,NULL,'I, inv','NGC 4767B',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102173,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102173,32.88,0.43,37.7,42942,75,NULL,'MAT, I, raw','NGC 4767B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102174,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102174,32.99,0.47,39.6,42942,NULL,NULL,'H','NGC 4767B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102175,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102175,33.05,0.43,40.7,42942,75,NULL,'MAT, I, inv','NGC 4767B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102176,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102176,33.06,0.45,40.9,42942,NULL,NULL,'K','NGC 4767B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102177,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102177,33.13,0.46,42.3,42942,NULL,NULL,'J','NGC 4767B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102178,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102178,33.19,0.43,43.4,42942,75,NULL,'MAT, I, cor','NGC 4767B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102179,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102179,33.39,0.08,47.7,42942,NULL,NULL,NULL,'NGC 4767B',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102180,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102180,33.42,0.4,48.3,42942,NULL,NULL,'mean','NGC 4767B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102181,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102181,36.83,0.46,232,42943,70,NULL,NULL,'2MASX J12544584+0950183',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.82',0.19,NULL,NULL,NULL,NULL,NULL,1,193.691,9.83844,0,NULL,58956912927,921201764,14393777,17.82),(102182,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102182,35.8,0.54,144,42944,70,NULL,NULL,'ESO 575- G 025',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'15.70',0.7,'S0:',NULL,NULL,NULL,NULL,1,193.692667,-21.87211,0.181,NULL,43976660115,687135314,10736489,15.7),(102183,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102183,38.27,0.27,451,42945,70,NULL,NULL,'2MASX J12544643+0843443',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,193.693375,8.72892,0,NULL,58068909440,907326710,14176979,17.7),(102184,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102184,37.14,0.46,267,42946,70,NULL,NULL,'2MASX J12544772+2720245',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',NULL,NULL,'16.58',0.55,NULL,'Group member',NULL,NULL,NULL,1,193.698833,27.34022,0.018,NULL,58726622237,917603472,14337554,16.58),(102185,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102185,36.69,0.46,217,42947,70,NULL,NULL,'LCRS B125213.7-025415',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000083,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,193.701,-3.17536,0.009,NULL,43106168572,673533883,10523966,16.4),(102186,'IRAS','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102186,31.43,0.8,19.3,42948,75,NULL,'A82, H','IC 3877',NULL,'1997ApJS..109..333W',1997,1,3.7,'Often incorrectly called IC 3881.','G',0.000018,NULL,'13.70',0.9,'SBcd:','in a radial-velocity based grouping',NULL,NULL,NULL,1,193.702833,19.17828,NULL,NULL,59029716402,922339318,14411551,13.7),(102187,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102187,31.13,0.4,16.8,42948,NULL,NULL,'Virgo cluster at 15.6 Mpc','IC 3877',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102188,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102188,31.67,0.47,21.6,42948,75,NULL,'A82, H, inv','IC 3877',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102189,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102189,31.78,0.47,22.7,42948,75,NULL,'A82, H, raw','IC 3877',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102190,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102190,31.81,0.4,23,42948,75,NULL,'B','IC 3877',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102191,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102191,31.86,0.47,23.5,42948,75,NULL,'A82, H, cor','IC 3877',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102192,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102192,32.05,0.38,25.7,42948,NULL,NULL,NULL,'IC 3877',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102193,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102193,32.34,0.2,29.4,42948,74.4,NULL,NULL,'IC 3877',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102194,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102194,32.36,0.43,29.6,42948,75,NULL,'3.6 micron, color corrected','IC 3877',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102195,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102195,32.39,0.43,30.1,42948,75,NULL,'3.6 micron, color + selection bias corrected','IC 3877',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102196,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102196,32.4,0.6,30.2,42948,NULL,NULL,'Malmquist cor.','IC 3877',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102197,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102197,32.59,0.55,32.9,42948,NULL,NULL,NULL,'IC 3877',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102198,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102198,37.22,0.9,278,42949,70,NULL,NULL,'2MASX J12544960-2323090',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,193.706667,-23.38592,0.217,NULL,43973187984,687081062,10735641,15.8),(102199,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102199,37.58,0.46,329,42950,70,NULL,NULL,'SDSS J125449.77+230015.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,193.707417,23.00425,0.054,NULL,59023120018,922236250,14409941,17.7),(102200,'SNIa','2016-12-15 15:15:07','2016-12-16 11:20:19','1','PTF10icb',NULL,102200,33.48,0.03,49.1,42951,70,NULL,'SiFTO+SALT2, SN PTF10icb','PTF10icb HOST',0.008606,'2012MNRAS.426.2359M',2012,1,0.89,NULL,'G',0.00007,NULL,'14.9g',0.65,NULL,'Group member',NULL,NULL,NULL,1,193.7074583,58.88233,0,NULL,57440981987,897515343,14023677,14.9),(102201,'SNIa','2016-12-15 15:15:07','2016-12-16 11:20:19','1','PTF10icb',NULL,102201,33.48,0.03,49.2,42951,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10icb HOST',0.008606,'2014MNRAS.438.1391P',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102202,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102202,37.47,0.46,313,42952,70,NULL,NULL,'2MASX J12545032+2104320',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'18.94',NULL,NULL,NULL,NULL,NULL,NULL,1,193.709583,21.07564,0.203,NULL,59023727252,922245738,14410089,18.94),(102203,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102203,37.85,0.33,372,42953,70,NULL,NULL,'2MASX J12545046+0316432',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000104,NULL,'17.0g',0.27,'AGN',NULL,NULL,NULL,NULL,1,193.710375,3.27875,0.041,NULL,58093318460,907708100,14182939,17),(102204,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102204,37.78,0.46,359,42954,70,NULL,NULL,'2MASX J12545053+3938205',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,193.710417,39.63906,0,NULL,59089261119,923269704,14426089,17.9),(102205,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102205,33.72,0.47,55.5,42955,70,NULL,NULL,'MCG -02-33-057',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'14.87',0.2,NULL,NULL,NULL,NULL,NULL,1,193.7105417,-14.12422,0.045,NULL,43972449742,687069527,10735461,14.87),(102206,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102206,37.67,0.46,342,42956,70,NULL,NULL,'2MASX J12545083+5109561',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,193.711791667,51.16564,0,NULL,57208065154,893876018,13966812,17.7),(102207,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102207,32.39,0.43,30,42957,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-33-058',NULL,'2014MNRAS.444..527S',2014,1,1.5,NULL,'G',0.000028,NULL,'15.39',0.2,'Sdm? sp',NULL,NULL,NULL,NULL,1,193.712833333,-11.89206,0.073,NULL,43958876205,686857440,10732147,15.39),(102208,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102208,31.73,0.4,22.2,42958,75,NULL,'B','NGC 4809',NULL,'1988NBGC.C....0000T',1988,1,1.7,'NGC gives only one pos. for N4809 & N4810. NED follows CGCG and RC2.','G',0.00002,NULL,'14.3B',0.7,'Im pec         HII','Pair member (points to parent)',NULL,NULL,NULL,1,193.71275,2.65408,0.029,NULL,58095398094,907740595,14183446,14.3),(102209,'Tully est','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102209,31.67,0.8,21.6,42959,75,NULL,'B','NGC 4810',NULL,'1988NBGC.C....0000T',1988,1,1.9,'NGC gives only one pos. for N4809 & N4810. NED follows CGCG and RC2.','G',0.00007,NULL,'14.20',0.8,'Im pec','Pair member (points to parent)',NULL,NULL,NULL,1,193.713333,2.64028,0.029,NULL,58095396616,907740572,14183446,14.2),(102210,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102210,37.26,0.17,283,42960,70,NULL,NULL,'2MASX J12545151+1906420',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.91',0.29,NULL,NULL,NULL,NULL,NULL,1,193.714583,19.11178,NULL,NULL,59029710060,922339219,14411550,16.91),(102211,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102211,36.74,0.33,223,42961,70,NULL,NULL,'CGCG 043-063',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.00008,NULL,'14.9g',0.63,'E0',NULL,NULL,NULL,NULL,1,193.7160417,3.88486,0.021,NULL,58101583436,907837241,14184956,14.9),(102212,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102212,31.14,0.4,16.9,42962,NULL,NULL,NULL,'NGC 4790',NULL,'2013MNRAS.429.2677K',2013,1,1.7,'Confused HIPASS source','G',0.000018,NULL,'12.76',1.1,'SB(rs)c:?','in a pair',NULL,NULL,NULL,1,193.716416667,-10.24783,0.113,NULL,43842413494,685037710,10703714,12.76),(102213,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102213,31.78,0.4,22.7,42962,NULL,NULL,'mean','NGC 4790',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102214,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102214,31.85,0.46,23.5,42962,NULL,NULL,'J','NGC 4790',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102215,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102215,31.87,0.4,23.6,42962,75,NULL,'B','NGC 4790',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102216,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102216,31.87,0.47,23.7,42962,NULL,NULL,'H','NGC 4790',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102217,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102217,31.91,0.45,24.1,42962,NULL,NULL,'K','NGC 4790',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102218,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102218,37.85,0.33,372,42963,70,NULL,NULL,'2MASX J12545206+0317292',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,193.717,3.29142,0.041,NULL,58093321865,907708154,14182939,17.7),(102219,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102219,36.52,0.62,202,42964,70,NULL,NULL,'2MASX J12545240-2916171',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00012,NULL,'14.7V',0.46,'S0;BrClG',NULL,NULL,NULL,NULL,1,193.718416667,-29.27142,0.309,NULL,43428074844,678563669,10602557,14.7),(102220,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102220,32.32,0.43,29,42965,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08052',NULL,'2014MNRAS.444..527S',2014,1,1.8,NULL,'G',0.00003,NULL,'14.39',0.4,'S?','in a radial-velocity based grouping',NULL,NULL,NULL,1,193.72075,73.17844,0.025,NULL,57037127760,891205121,13925080,14.39),(102221,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102221,36.87,0.27,237,42966,70,NULL,NULL,'2MASX J12545347+5305261',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,193.7230417,53.09056,0,NULL,57200468052,893757313,13964958,17.3),(102222,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102222,38.27,0.27,451,42967,70,NULL,NULL,'SDSS J125453.54+083708.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.5g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,193.723125,8.61903,0,NULL,58068631597,907322368,14176912,18.5),(102223,'TRGB','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102223,28.81,NULL,5.78,42968,NULL,NULL,NULL,'ESO 443- G 009',NULL,'2007AJ....133..504K',2007,1,1.2,NULL,'G',0.000002,NULL,'17.01',1.1,'dwarf Im',NULL,NULL,NULL,NULL,1,193.72525,-28.34086,0.305,NULL,43428148153,678564814,10602575,17.01),(102224,'TRGB','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102224,28.85,0.11,5.89,42968,NULL,NULL,'I','ESO 443- G 009',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102225,'TRGB','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102225,28.88,0.1,5.97,42968,74.4,NULL,NULL,'ESO 443- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102226,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102226,35.31,0.05,115,42969,70,NULL,NULL,'NGC 4797',NULL,'2015arXiv151105856S',2015,1,1.2,NULL,'G',0.000036,NULL,'13.8g',0.9,'S0-:           AGN','Group member',NULL,NULL,NULL,1,193.729875,27.41269,0.018,NULL,58696270029,917129219,14330144,13.8),(102227,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102227,34.68,0.45,86.1,42969,NULL,NULL,'K','NGC 4797',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102228,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102228,35.11,0.4,105,42969,NULL,NULL,'mean','NGC 4797',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102229,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102229,33.67,0.5,54.1,42970,70,NULL,NULL,'MCG -02-33-059',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'14.89',0.2,NULL,NULL,NULL,NULL,NULL,1,193.73225,-10.06825,0.113,NULL,43841302216,685020347,10703442,14.89),(102230,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102230,37.07,0.46,259,42971,70,NULL,NULL,'2MASX J12545609+1803260',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.78',0.12,NULL,NULL,NULL,NULL,NULL,1,193.7337083,18.05731,0.075,NULL,59026720226,922292503,14410820,18.78),(102231,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102231,36.63,0.37,212,42972,NULL,NULL,'Malmquist cor.','AGC 520517',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000033,NULL,'17.8V',NULL,'Sc',NULL,NULL,NULL,NULL,1,193.733917,-28.98386,0.313,NULL,43428794687,678574916,10602733,17.8),(102232,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102232,36.69,0.36,217,42972,NULL,NULL,NULL,'AGC 520517',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102233,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102233,36.73,0.2,222,42972,74.4,NULL,NULL,'AGC 520517',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102234,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102234,34.52,0.62,80.1,42973,70,NULL,NULL,'PKS 1252-441',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5',NULL,'Elliptical     BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,193.739625,-44.41572,0.381,NULL,46761360921,730646264,11416347,15.5),(102235,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102235,38,0.46,398,42974,70,NULL,NULL,'2MASX J12545807+0523332',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,193.742,5.39261,0.014,NULL,58102534982,907852109,14185189,17.7),(102236,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102236,38.04,0.46,405,42975,70,NULL,NULL,'2MASX J12545938+3624113',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,193.7474583,36.40311,0.023,NULL,59073132884,923017701,14422151,17.6),(102237,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102237,36.51,0.49,200,42976,75,NULL,'IR','2MFGC 10208',NULL,'2011yCatp016004901K',2011,1,0.58,NULL,'G',0.000033,NULL,'15',0.2,'Sb','Group member',NULL,NULL,NULL,1,193.747417,-17.92475,0.081,NULL,43982049129,687219517,10737804,15),(102238,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102238,36.52,0.44,202,42976,NULL,NULL,'Malmquist cor.','2MFGC 10208',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102239,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102239,36.79,0.39,228,42976,NULL,NULL,NULL,'2MFGC 10208',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102240,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102240,36.83,0.2,232,42976,74.4,NULL,NULL,'2MFGC 10208',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102241,'IRAS','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102241,33.85,0.8,58.8,42977,75,NULL,'MAT, I','ESO 323- G 042',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000033,NULL,'14.07',0.8,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,193.7535417,-40.97225,0.425,NULL,46754389201,730537331,11414645,14.07),(102242,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102242,32.41,0.32,30.3,42977,85,NULL,'I, raw','ESO 323- G 042',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102243,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102243,32.43,0.32,30.6,42977,85,NULL,'I, inv','ESO 323- G 042',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102244,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102244,32.53,0.43,32.1,42977,75,NULL,'MAT, I, raw','ESO 323- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102245,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102245,32.59,0.43,32.9,42977,75,NULL,'3.6 micron, color + selection bias corrected','ESO 323- G 042',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102246,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102246,32.64,0.43,33.8,42977,75,NULL,'3.6 micron, color corrected','ESO 323- G 042',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102247,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102247,32.65,0.43,34,42977,75,NULL,'MAT, I, inv','ESO 323- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102248,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102248,32.74,0.2,35.3,42977,74.4,NULL,NULL,'ESO 323- G 042',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102249,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102249,32.93,0.43,38.5,42977,75,NULL,'MAT, I, cor','ESO 323- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102250,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102250,32.94,0.41,38.8,42977,NULL,NULL,NULL,'ESO 323- G 042',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102251,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102251,33.05,0.39,40.7,42977,NULL,NULL,'Malmquist cor.','ESO 323- G 042',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102252,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102252,33.32,0.47,46.2,42977,NULL,NULL,'H','ESO 323- G 042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102253,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102253,33.44,0.46,48.6,42977,NULL,NULL,'J','ESO 323- G 042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102254,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102254,33.51,0.45,50.2,42977,NULL,NULL,'K','ESO 323- G 042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102255,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102255,33.82,0.4,58.1,42977,NULL,NULL,'mean','ESO 323- G 042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102256,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102256,36.71,0.27,220,42978,70,NULL,NULL,'2MASX J12550199+0015342',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000071,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,193.758167,0.25964,0,NULL,58083801850,907559403,14180615,16.8),(102257,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102257,37.85,0.46,372,42979,70,NULL,NULL,'SDSS J125503.44+332158.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000126,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,193.764375,33.36633,0.015,NULL,58740017102,917812767,14340824,18.4),(102258,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102258,33.58,0.48,51.9,42980,70,NULL,NULL,'NGC 4792',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.02',0.4,'S0','in a pair',NULL,NULL,NULL,1,193.765333,-12.49717,0.061,NULL,43959133596,686861462,10732210,15.02),(102259,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102259,30.59,0.4,13.1,42981,NULL,NULL,NULL,'LCRS B125228.1-060555',NULL,'2013MNRAS.429.2677K',2013,1,NULL,NULL,'G',0.00015,NULL,'15.39',NULL,NULL,NULL,NULL,NULL,NULL,1,193.765417,-6.36956,0.049,NULL,43130104884,673907888,10529810,15.39),(102260,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102260,36.74,0.33,223,42982,70,NULL,NULL,'2MASX J12550424+0356092',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000176,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,193.767667,3.93597,0.021,NULL,58101554130,907836783,14184949,17.3),(102261,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102261,36.9,0.46,240,42983,70,NULL,NULL,'2MASX J12550542+2518119',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,193.772666667,25.30325,0.061,NULL,58690143776,917033496,14328648,17.4),(102262,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102262,35.52,0.33,127,42984,70,NULL,NULL,'UGC 08047 NOTES02',NULL,'2015arXiv151105856S',2015,1,0.83,'UGC incorrectly used this CGCG position for UGC 08047.','G',0.000123,NULL,'14.8g',0.64,'Sb-c',NULL,NULL,NULL,NULL,1,193.776625,55.14969,0.029,NULL,57423675859,897244935,14019452,14.8),(102263,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102263,34.7,1.49,87.1,42985,NULL,NULL,NULL,'ESO 381- G 028',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.67',0.5,'Sc             HII',NULL,NULL,NULL,NULL,1,193.776833333,-34.85667,0.161,NULL,43453685876,678963841,10608810,15.67),(102264,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102264,34.74,0.2,88.7,42985,74.4,NULL,NULL,'ESO 381- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102265,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102265,34.94,1.33,97.1,42985,NULL,NULL,'Malmquist cor.','ESO 381- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102266,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102266,36.71,0.27,220,42986,70,NULL,NULL,'2MASX J12550733+0017362',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000076,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,193.780458333,0.29336,0,NULL,58083789221,907559206,14180612,17.4),(102267,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102267,35.58,0.46,130,42987,70,NULL,NULL,'2MASX J12550739+3030457',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00007,NULL,'15.5g',0.42,NULL,NULL,NULL,NULL,NULL,1,193.7807917,30.51269,0.058,NULL,58746370977,917912046,14342375,15.5),(102268,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102268,38.12,0.46,421,42988,70,NULL,NULL,'2MASX J12550788+0804075',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,193.7827917,8.06869,0,NULL,58080418729,907506542,14179789,NULL),(102269,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102269,38.27,0.27,451,42989,70,NULL,NULL,'2MASX J12550989+0836505',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.70',0.13,NULL,NULL,NULL,NULL,NULL,1,193.7912917,8.61406,0,NULL,58079644125,907494439,14179600,18.7),(102270,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102270,33.5,0.48,50.2,42990,70,NULL,NULL,'NGC 4794',NULL,'2014MNRAS.445.2677S',2014,1,1.9,NULL,'G',0.0001,NULL,'13.65',0.8,'SB(rs)a','in a pair',NULL,NULL,NULL,1,193.79375,-12.60847,0.061,NULL,43959161528,686861898,10732217,13.65),(102271,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102271,30.95,0.4,15.5,42991,NULL,NULL,NULL,'2dFGRS N189Z061',NULL,'2013MNRAS.429.2677K',2013,1,0.35,NULL,'G',0.000013,NULL,'18.52',0.15,'Im',NULL,NULL,NULL,NULL,1,193.795125,-3.39744,0,NULL,43136428448,674006694,10531354,18.52),(102272,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102272,35.08,0.46,104,42992,70,NULL,NULL,'2MASX J12551088+2934419',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000103,NULL,'15.4g',0.37,'Sa',NULL,NULL,NULL,NULL,1,193.79525,29.57828,0.033,NULL,58779013514,918422086,14350345,15.4),(102273,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102273,38.55,0.46,514,42993,70,NULL,NULL,'2MASX J12551119+1714276',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,193.79675,17.24108,0.065,NULL,59043928354,922561380,14415021,17.9),(102274,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102274,38.07,0.33,412,42994,70,NULL,NULL,'SDSS J125511.63+031329.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000084,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,193.798458333,3.22486,0.041,NULL,58093438477,907709976,14182968,18.1),(102275,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102275,38.08,0.46,413,42995,70,NULL,NULL,'2MASX J12551174+5512081',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00014,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,193.799083,55.20244,0.041,NULL,57423470729,897241730,14019402,18.4),(102276,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102276,38.04,0.46,405,42996,70,NULL,NULL,'SDSS J125512.50+092130.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,193.802125,9.3585,0,NULL,58957041319,921203770,14393808,18.2),(102277,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102277,30.76,0.4,14.2,42997,75,NULL,'B','UGC 08041',NULL,'1988NBGC.C....0000T',1988,1,1.58,'Host galaxy of UM 525.','G',0.000018,NULL,'13.9g',0.97,'SB(s)d         HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,193.8027083,0.11664,0.024,NULL,58083820935,907559702,14180620,13.9),(102278,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102278,30.8,0.2,14.5,42997,74.4,NULL,NULL,'UGC 08041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102279,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102279,30.82,0.43,14.6,42997,75,NULL,'3.6 micron, color corrected','UGC 08041',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102280,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102280,30.91,0.43,15.2,42997,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08041',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102281,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102281,31.17,0.42,17.2,42997,NULL,NULL,NULL,'UGC 08041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102282,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102282,31.17,0.4,17.2,42997,NULL,NULL,NULL,'UGC 08041',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102283,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102283,31.21,0.41,17.5,42997,NULL,NULL,'Malmquist cor.','UGC 08041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102284,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102284,38.62,0.46,529,42998,70,NULL,NULL,'2MASX J12551272+0818415',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,193.803125,8.31153,0,NULL,58080522806,907508168,14179815,17.9),(102285,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102285,38.29,0.46,456,42999,70,NULL,NULL,'2MASX J12551419+0617505',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.79',0.14,NULL,NULL,NULL,NULL,NULL,1,193.809,6.29731,0.023,NULL,58078716121,907479939,14179374,18.79),(102286,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102286,37.56,0.46,326,43000,70,NULL,NULL,'2MASX J12551442+4231100',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,193.810167,42.51944,0,NULL,59078425767,923100402,14423443,17.5),(102287,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102287,37.7,0.27,346,43001,70,NULL,NULL,'2MASX J12551500-0133410',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000082,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,193.812583333,-1.56131,0.033,NULL,43116945137,673702267,10526597,16.9),(102288,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102288,38.6,0.19,524,43002,70,NULL,NULL,'2MASX J12551563+6209045',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,193.814875,62.15131,0.009,NULL,57355470985,896179234,14002800,17.5),(102289,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102289,36.71,0.27,220,43003,70,NULL,NULL,'CGCG 015-038',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000117,NULL,'15.3g',0.52,'E','Isolated galaxy',NULL,NULL,NULL,1,193.819083,0.24689,0,NULL,58083796048,907559313,14180614,15.3),(102290,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102290,38.81,0.46,577,43004,70,NULL,NULL,'2MASX J12551770+5400442',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,193.8239583,54.01231,0.02,NULL,57421835225,897216175,14019002,17.7),(102291,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102291,38.07,0.33,412,43005,70,NULL,NULL,'SDSS J125518.15+031753.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000083,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,193.825625,3.29825,0.041,NULL,58100696843,907823388,14184740,17.4),(102292,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102292,36.47,0.46,197,43006,70,NULL,NULL,'2MASX J12551820+2550449',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,193.82575,25.84569,0.04,NULL,58689737858,917027154,14328549,16.7),(102293,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102293,37.91,0.46,383,43007,70,NULL,NULL,'2MASX J12552123+2022399',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,193.838666667,20.37778,0.135,NULL,59037965427,922468209,14413565,17.3),(102294,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102294,36.73,0.78,221,43008,70,NULL,NULL,'2MASX J12552130-2053270',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,193.838708333,-20.89081,0.177,NULL,43975826815,687122293,10736285,15.9),(102295,'Tully est','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102295,32.97,0.8,39.3,43009,75,NULL,'B','NGC 4814',NULL,'1988NBGC.C....0000T',1988,1,3.1,NULL,'G',0.00001,NULL,'12.7g',2.3,'SA(s)b','in a radial-velocity based grouping',NULL,NULL,NULL,1,193.841417,58.34411,0,NULL,57438341332,897474083,14023032,12.7),(102296,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102296,33.05,0.4,40.7,43009,NULL,NULL,'mean','NGC 4814',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102297,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102297,33.11,0.45,41.8,43009,NULL,NULL,'K','NGC 4814',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102298,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102298,33.12,0.43,42,43009,75,NULL,'3.6 micron, color corrected','NGC 4814',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102299,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102299,33.12,0.47,42.1,43009,NULL,NULL,'H','NGC 4814',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102300,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102300,33.16,0.2,42.9,43009,74.4,NULL,NULL,'NGC 4814',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102301,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102301,33.18,0.43,43.3,43009,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4814',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102302,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102302,33.19,0.46,43.4,43009,NULL,NULL,'J','NGC 4814',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102303,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102303,38.68,0.46,544,43010,70,NULL,NULL,'SDSS J125523.89+022909.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000073,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,193.849583,2.48603,0,NULL,58095468895,907741701,14183464,18.5),(102304,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102304,38.06,0.46,410,43011,70,NULL,NULL,'2MASX J12552596+3732033',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000178,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,193.858083,37.53422,0,NULL,59076702031,923073469,14423022,17.4),(102305,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102305,38.61,0.46,526,43012,70,NULL,NULL,'2MASX J12552689+0602287',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,193.862,6.04136,0.019,NULL,58071422787,907365981,14177593,17.2),(102306,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102306,38.81,0.46,578,43013,70,NULL,NULL,'SDSS J125527.00+514856.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,193.862541667,51.81575,0,NULL,57209453918,893897717,13967151,18.3),(102307,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102307,37.7,0.27,346,43014,70,NULL,NULL,'SDSS J125527.60-013001.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000063,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,193.8650417,-1.5005,0.033,NULL,43116948295,673702317,10526598,18.3),(102308,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102308,37.93,0.46,385,43015,70,NULL,NULL,'2MASX J12552782+0252167',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,193.865875,2.87144,0.043,NULL,58093240631,907706884,14182920,17.9),(102309,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102309,37.32,0.33,291,43016,70,NULL,NULL,'SDSS J125528.06+182517.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,193.8669583,18.4215,0.079,NULL,59030198347,922346849,14411669,18),(102310,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102310,36.11,0.55,167,43017,70,NULL,NULL,'2MASX J12552898-0956010',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.08',NULL,NULL,NULL,NULL,NULL,NULL,1,193.870666667,-9.93358,0.093,NULL,43841760902,685027514,10703554,16.08),(102311,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102311,37.9,0.46,381,43018,70,NULL,NULL,'2MASX J12552898+5524343',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,193.870708333,55.40958,0.005,NULL,57422440758,897225636,14019150,17.5),(102312,'D-Sigma','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102312,34.86,0.4,93.8,43019,75,NULL,'Edat, raw','NGC 4807',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000019,NULL,'14.1g',0.8,'SAB0- pec:','in a radial-velocity based grouping',NULL,NULL,NULL,1,193.87125,27.52142,0.029,NULL,58696788859,917137325,14330270,14.1),(102313,'D-Sigma','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102313,34.89,0.4,95,43019,75,NULL,'Edat, cor','NGC 4807',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102314,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102314,34.69,0.25,86.7,43019,74.4,NULL,NULL,'NGC 4807',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102315,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102315,35.31,0.05,115,43019,70,NULL,NULL,'NGC 4807',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102316,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102316,38.07,0.46,410,43020,70,NULL,NULL,'SDSS J125529.46+483304.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000179,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,193.872791667,48.55133,0,NULL,59096696589,923385884,14427904,18.4),(102317,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102317,36.52,0.46,201,43021,70,NULL,NULL,'2MASX J12552958+1458213',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000187,NULL,'16.1g',0.34,NULL,NULL,NULL,NULL,NULL,1,193.873375,14.97275,0.023,NULL,58999927398,921873865,14404279,16.1),(102318,'Tully est','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102318,32.38,0.8,30,43022,75,NULL,NULL,'ESO 269- G 009',NULL,'1988NBGC.C....0000T',1988,1,1.4,NULL,'G',0.000017,NULL,'14.83',1.1,'IB(s)m pec:',NULL,NULL,NULL,NULL,1,193.873583,-45.23553,0.401,NULL,46761237225,730644331,11416317,14.83),(102319,'Tully est','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102319,32.26,0.8,28.4,43023,75,NULL,NULL,'IC 3896A',NULL,'1988NBGC.C....0000T',1988,1,2.2,NULL,'G',0.000025,NULL,'12.9',1.7,'SB(rl)c',NULL,NULL,NULL,NULL,1,193.877625,-50.07142,1.033,NULL,46734193391,730221771,11409715,12.9),(102320,'Tully est','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102320,31.83,0.8,23.2,43024,75,NULL,NULL,'UGCA 308',NULL,'1988NBGC.C....0000T',1988,1,1.4,'Position is for the center of the eccentric patchy bar.','G',0.00002,NULL,NULL,1,'IB(s)m:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,193.880833,-10.39372,0.113,NULL,43842976765,685046511,10703851,NULL),(102321,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102321,31.1,0.4,16.6,43024,NULL,NULL,NULL,'UGCA 308',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102322,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102322,37.97,0.46,392,43025,70,NULL,NULL,'2MASX J12553216+3650340',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000136,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,193.88425,36.84278,0.021,NULL,59076215058,923065860,14422904,18.5),(102323,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102323,33.65,0.51,53.6,43026,NULL,NULL,NULL,'ESO 443- G 010',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000023,NULL,'13.34',0.2,'Sa',NULL,NULL,NULL,NULL,1,193.885666667,-28.45906,0.317,NULL,43306730026,676667656,10572932,13.34),(102324,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102324,33.67,0.5,54.1,43026,NULL,NULL,'Malmquist cor.','ESO 443- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102325,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102325,33.69,0.2,54.7,43026,74.4,NULL,NULL,'ESO 443- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102326,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102326,35.89,0.53,151,43027,70,NULL,NULL,'2MASX J12553322-1519033',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000113,NULL,'14.0R',0.5,'S0','Group member',NULL,NULL,NULL,1,193.888375,-15.31761,0.029,NULL,43961882921,686904420,10732881,14),(102327,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102327,35.34,0.33,117,43028,70,NULL,NULL,'2MASX J12553453+3212213',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.00008,NULL,'15.6g',0.46,NULL,NULL,NULL,NULL,NULL,1,193.8937917,32.20597,0.035,NULL,58746562789,917915043,14342422,15.6),(102328,'D-Sigma','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102328,33.69,0.4,54.7,43029,75,NULL,'Edat, raw','ESO 507- G 045',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000043,NULL,'13.52',1.4,'(R\')SA(s)0^0^: pec','Pair member (points to parent)',NULL,NULL,NULL,1,193.898708333,-26.82506,0.333,NULL,43308328204,676692628,10573322,13.52),(102329,'D-Sigma','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102329,33.98,0.4,62.5,43029,75,NULL,'Edat, cor','ESO 507- G 045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102330,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102330,34.24,0.4,70.5,43029,NULL,NULL,'mean','ESO 507- G 045',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102331,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102331,34.35,0.45,74.3,43029,NULL,NULL,'K','ESO 507- G 045',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102332,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102332,38.6,0.19,524,43030,70,NULL,NULL,'2MASX J12553575+6210206',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,193.89925,62.17244,0.017,NULL,57355355820,896177434,14002772,17.9),(102333,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102333,37.7,0.27,346,43031,70,NULL,NULL,'2MASX J12553654-0130440',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000082,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,193.902166667,-1.51228,0.025,NULL,43116979565,673702805,10526606,16.9),(102334,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102334,34.59,0.48,82.9,43032,70,NULL,NULL,'2MASX J12553714-1323463',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00013,NULL,'15.47',NULL,NULL,NULL,NULL,NULL,NULL,1,193.9047917,-13.39636,0.057,NULL,43972237617,687066212,10735409,15.47),(102335,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102335,37.81,0.46,365,43033,70,NULL,NULL,'2MASX J12553808+1842149',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,193.908625,18.70406,0.09,NULL,59030500929,922351577,14411743,17.9),(102336,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102336,36.16,0.46,171,43034,70,NULL,NULL,'2MASX J12553812-0035264',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000088,NULL,'16.2g',0.37,'S0',NULL,NULL,NULL,NULL,1,193.9089583,-0.59067,0.009,NULL,43114473765,673663652,10525994,16.2),(102337,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102337,36.22,0.54,175,43034,70,NULL,NULL,'2MASX J12553812-0035264',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102338,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102338,35.21,0.49,110,43035,75,NULL,'IR','ESO 575- G 026',NULL,'2011yCatp016004901K',2011,1,1.43,NULL,'G',0.00004,NULL,'16.39',0.2,'Sd',NULL,NULL,NULL,NULL,1,193.9114583,-22.51814,0.257,NULL,43973418709,687084667,10735697,16.39),(102339,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102339,35.78,NULL,143,43035,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 575- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102340,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102340,35.8,NULL,144,43035,NULL,NULL,'Dipole + Quadrupole','ESO 575- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102341,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102341,35.81,NULL,145,43035,NULL,NULL,'Dipole','ESO 575- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102342,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102342,35.81,NULL,145,43035,NULL,NULL,NULL,'ESO 575- G 026',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102343,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102343,38.2,0.46,436,43036,70,NULL,NULL,'SDSS J125538.71+622747.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,193.9112917,62.46322,0.013,NULL,57355969800,896187028,14002922,18.2),(102344,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102344,37.39,0.46,301,43037,70,NULL,NULL,'2MASX J12553910+3007004',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,193.913125,30.11681,0.044,NULL,58745508230,917898566,14342165,16.9),(102345,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102345,30.35,NULL,11.8,43038,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08048',NULL,'2010Ap&SS.325..163P',2010,1,1.3,'Multiple SDSS entries describe this object.','G',0.000023,NULL,'16.2g',0.28,'Irr(f)','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,193.914,-0.26356,0.025,NULL,43114361968,673661905,10525967,16.2),(102346,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102346,30.38,NULL,11.9,43038,NULL,NULL,'Dipole + Quadrupole','UGC 08048',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102347,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102347,30.43,NULL,12.2,43038,NULL,NULL,'Dipole','UGC 08048',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102348,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102348,30.67,NULL,13.6,43038,NULL,NULL,NULL,'UGC 08048',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102349,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102349,31.35,0.4,18.7,43038,NULL,NULL,NULL,'UGC 08048',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102350,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102350,36.66,0.38,215,43039,NULL,NULL,'Malmquist cor.','2MASX J12554023-2834345',NULL,'2009ApJS..182..474S',2009,1,0.48,NULL,'G',0.00003,NULL,'15.22',0.2,'Sb:',NULL,NULL,NULL,NULL,1,193.9177083,-28.57631,0.325,NULL,43306825919,676669154,10572955,15.22),(102351,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102351,36.95,0.33,245,43039,NULL,NULL,NULL,'2MASX J12554023-2834345',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102352,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102352,36.99,0.2,250,43039,74.4,NULL,NULL,'2MASX J12554023-2834345',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102353,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102353,37.1,0.61,263,43040,NULL,NULL,'Malmquist cor.','2MASX J12554028-2849435',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.00003,NULL,'17.45',NULL,NULL,NULL,NULL,NULL,NULL,1,193.917791667,-28.82875,0.325,NULL,43428217203,678565893,10602592,17.45),(102354,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102354,37.5,0.5,316,43040,NULL,NULL,NULL,'2MASX J12554028-2849435',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102355,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102355,37.54,0.2,322,43040,74.4,NULL,NULL,'2MASX J12554028-2849435',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102356,'Brightest Stars','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102356,31.4,NULL,19.1,43041,NULL,NULL,NULL,'LSBC D575-05',NULL,'1998A&AS..128..459M',1998,1,1.2,NULL,'G',0.00002,NULL,'16.52',0.6,'dI',NULL,NULL,NULL,NULL,1,193.921,19.20908,0.104,NULL,59029829005,922341078,14411579,16.52),(102357,'TRGB','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102357,28.42,0.1,4.83,43041,74.4,NULL,NULL,'LSBC D575-05',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102358,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102358,28.7,NULL,5.5,43041,NULL,NULL,NULL,'LSBC D575-05',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102359,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102359,36.75,0.46,224,43042,70,NULL,NULL,'2MASX J12554084+5102193',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,193.920125,51.03869,0,NULL,57207337682,893864651,13966635,17.1),(102360,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102360,35.31,0.05,115,43043,70,NULL,NULL,'IC 3900',NULL,'2015arXiv151105856S',2015,1,0.91,NULL,'G',0.000083,NULL,'14.6g',0.53,'SB0:','Group member',NULL,NULL,NULL,1,193.922083,27.25075,0.018,NULL,58696306844,917129794,14330153,14.6),(102361,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102361,35.7,0.25,138,43043,74.4,NULL,NULL,'IC 3900',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102362,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102362,37.99,0.46,397,43044,70,NULL,NULL,'2MASX J12554133+1957072',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,193.9222917,19.95222,0.127,NULL,59037361799,922458778,14413418,16.9),(102363,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102363,36.55,0.46,204,43045,70,NULL,NULL,'2MASX J12554155+0242487',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000094,NULL,'16.1g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,193.9230417,2.71347,0.043,NULL,58095545006,907742890,14183482,16.1),(102364,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102364,37.97,0.46,392,43046,70,NULL,NULL,'2MASX J12554280+4619300',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,193.92825,46.325,0,NULL,59099893238,923435831,14428684,17.6),(102365,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102365,37.72,0.46,350,43047,70,NULL,NULL,'2MASX J12554288+0308207',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00008,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,193.9287083,3.13917,0.026,NULL,58100594691,907821792,14184715,17.7),(102366,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102366,37.3,0.46,289,43048,70,NULL,NULL,'2MASX J12554297+6320476',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,193.9292917,63.34661,0.005,NULL,57349808541,896090758,14001418,17),(102367,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102367,36.31,0.68,183,43049,70,NULL,NULL,'2MASX J12554352-1521052',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000073,NULL,'15.0R',NULL,'SBa','Group member',NULL,NULL,NULL,1,193.9312917,-15.3515,0.029,NULL,43962346342,686911661,10732994,15),(102368,'D-Sigma','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102368,33.69,0.4,54.7,43050,75,NULL,'Edat, raw','ESO 507- G 046',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.00005,NULL,'14.33',0.9,'E2:','Pair member (points to parent)',NULL,NULL,NULL,1,193.933875,-26.8095,0.333,NULL,43308332971,676692702,10573323,14.33),(102369,'D-Sigma','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102369,33.98,0.4,62.5,43050,75,NULL,'Edat, cor','ESO 507- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102370,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102370,34.15,0.4,67.6,43050,NULL,NULL,'mean','ESO 507- G 046',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102371,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102371,34.44,0.45,77.3,43050,NULL,NULL,'K','ESO 507- G 046',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102372,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102372,37.26,0.17,283,43051,70,NULL,NULL,'SDSS J125544.21+185738.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,193.93425,18.96069,0.116,NULL,59029789924,922340467,14411569,18.1),(102373,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102373,38.6,0.19,524,43052,70,NULL,NULL,'2MASX J12554303+6209146',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,193.9345,62.15025,0.017,NULL,57355369154,896177643,14002775,18.2),(102374,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102374,36.87,0.46,237,43053,70,NULL,NULL,'2MASX J12554559+5538413',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00019,NULL,'16.0g',0.38,'E0',NULL,NULL,NULL,NULL,1,193.9400417,55.64494,0.005,NULL,57430035338,897344302,14021004,16),(102375,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102375,37.32,0.33,291,43054,70,NULL,NULL,'2MASX J12554629+1829171',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.53',0.15,NULL,NULL,NULL,NULL,NULL,1,193.943041667,18.48825,0.097,NULL,59030202728,922346917,14411670,18.53),(102376,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102376,35.16,0.54,108,43055,70,NULL,NULL,'MCG -02-33-062',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15',0.8,NULL,NULL,NULL,NULL,NULL,1,193.943333,-11.54278,0.089,NULL,43840558719,685008729,10703261,15),(102377,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102377,37.95,0.46,389,43056,70,NULL,NULL,'2MASX J12554664+1906241',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,193.944333,19.10658,NULL,NULL,59029846050,922341344,14411583,17.3),(102378,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102378,37.55,0.46,324,43057,70,NULL,NULL,'2MASX J12554706+6425576',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000073,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,193.946083333,64.43283,0.041,NULL,57368907685,896389182,14006080,17.6),(102379,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102379,36.29,NULL,181,43058,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1524',NULL,'2010Ap&SS.325..163P',2010,1,1.2,NULL,'G',0.000169,NULL,'16.5g',0.15,'Sbc',NULL,NULL,NULL,NULL,1,193.946417,59.36444,0,NULL,57440326182,897505096,14023517,16.5),(102380,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102380,36.3,NULL,182,43058,NULL,NULL,NULL,'FGC 1524',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102381,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102381,36.31,NULL,183,43058,NULL,NULL,'Dipole + Quadrupole','FGC 1524',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102382,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102382,36.34,NULL,185,43058,NULL,NULL,'Dipole','FGC 1524',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102383,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102383,36.92,0.52,242,43059,70,NULL,NULL,'2MASX J12554772-1824143',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.24',NULL,NULL,NULL,NULL,NULL,NULL,1,193.949,-18.40411,0.101,NULL,43985061397,687266584,10738540,16.24),(102384,'IRAS','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102384,31.33,0.8,18.5,43060,75,NULL,'A82, H','NGC 4808',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.000017,NULL,'12.35',1.1,'SA(s)cd:;HII   LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,193.9539583,4.30411,0,NULL,58100828592,907825446,14184772,12.35),(102385,'IRAS','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102385,31.33,0.8,18.5,43060,75,NULL,'CF, r','NGC 4808',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102386,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102386,30.85,0.4,14.8,43060,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 4808',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102387,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102387,30.97,0.43,15.6,43060,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4808',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102388,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102388,31.15,0.43,17,43060,75,NULL,'3.6 micron, color corrected','NGC 4808',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102389,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102389,31.29,0.46,18.1,43060,NULL,NULL,'J','NGC 4808',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102390,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102390,31.31,0.4,18.3,43060,NULL,NULL,'mean','NGC 4808',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102391,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102391,31.33,0.45,18.4,43060,NULL,NULL,'K','NGC 4808',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102392,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102392,31.33,0.2,18.5,43060,74.4,NULL,NULL,'NGC 4808',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102393,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102393,31.34,0.35,18.5,43060,NULL,NULL,NULL,'NGC 4808',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102394,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102394,31.34,0.47,18.6,43060,NULL,NULL,'H','NGC 4808',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102395,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102395,31.38,0.47,18.9,43060,75,NULL,'A82, H, raw','NGC 4808',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102396,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102396,31.4,0.47,19.1,43060,75,NULL,'A82, H, inv','NGC 4808',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102397,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102397,31.59,0.47,20.8,43060,75,NULL,'A82, H, cor','NGC 4808',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102398,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102398,31.6,0.4,20.9,43060,75,NULL,'B','NGC 4808',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102399,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102399,31.62,0.38,21,43060,75,NULL,'CF, r, raw','NGC 4808',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102400,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102400,31.67,0.38,21.6,43060,75,NULL,'CF, r, inv','NGC 4808',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102401,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102401,31.73,0.38,22.2,43060,75,NULL,'CF, r, cor','NGC 4808',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102402,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102402,35.31,0.05,115,43061,70,NULL,NULL,'2MASX J12554898+2754205',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000103,NULL,'15.9g',0.38,NULL,'Group member',NULL,NULL,NULL,1,193.954167,27.90586,0.039,NULL,58696727169,917136362,14330255,15.9),(102403,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102403,37.24,0.33,280,43062,70,NULL,NULL,'2MASX J12554906+3045154',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000127,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,193.954416667,30.75433,0.059,NULL,58745945100,917905392,14342271,16.6),(102404,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102404,31.53,0.4,20.2,43063,75,NULL,'B','UGC 08053',NULL,'1988NBGC.C....0000T',1988,1,1.3,'The position is for the eccentric nucleus.','G',0.000017,NULL,'14.2B',0.45,'SABdm','in a pair',NULL,NULL,NULL,1,193.954625,4.01394,0.021,NULL,58101019308,907828426,14184819,14.2),(102405,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102405,36.72,0.52,221,43064,70,NULL,NULL,'2MASX J12554936-1657322',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.0001,NULL,'14',0.3,'S0/E','Group member',NULL,NULL,NULL,1,193.955625,-16.95892,0.053,NULL,44015681851,687745028,10746016,14),(102406,'SBF','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102406,30.31,0.16,11.5,43065,NULL,NULL,'I','NGC 4802',NULL,'2001ApJ...546..681T',2001,1,2.4,NULL,'G',0.00015,NULL,'12.39',1.6,'SA(r)0?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,193.956833,-12.05531,0.069,NULL,43959392233,686865503,10732273,12.39),(102407,'SBF','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102407,30.32,0.14,11.6,43065,74.4,NULL,NULL,'NGC 4802',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102408,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102408,37.03,0.68,255,43066,70,NULL,NULL,'2MASX J12555014-2052303',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.38',NULL,NULL,NULL,NULL,NULL,NULL,1,193.9587917,-20.87519,0.193,NULL,43975817806,687122153,10736283,16.38),(102409,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102409,37.8,0.46,362,43067,70,NULL,NULL,'2MASX J12555031+0844109',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.44',0.15,NULL,NULL,NULL,NULL,NULL,1,193.959875,8.73653,0,NULL,58068196794,907315574,14176805,18.44),(102410,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102410,37.9,0.46,380,43068,70,NULL,NULL,'SDSS J125551.89+221530.1',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.84',0.19,NULL,NULL,NULL,NULL,NULL,1,193.9662083,22.25839,0.128,NULL,59026187845,922284185,14410690,18.84),(102411,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102411,37.24,0.33,280,43069,70,NULL,NULL,'2MASX J12555224+3042544',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000117,NULL,'15.9g',0.45,NULL,NULL,NULL,NULL,NULL,1,193.967583,30.71508,0.059,NULL,58745943663,917905369,14342271,15.9),(102412,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102412,35.77,0.46,142,43070,70,NULL,NULL,'2MASX J12555237+1030549',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.68',0.21,NULL,NULL,NULL,NULL,NULL,1,193.9682083,10.51536,0,NULL,58958367938,921224499,14394132,17.68),(102413,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102413,37.39,0.46,301,43071,70,NULL,NULL,'2MASX J12555473+2520285',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,193.978167,25.34125,0.056,NULL,58689166844,917018231,14328409,17.3),(102414,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102414,37.64,0.46,337,43072,70,NULL,NULL,'2MASX J12555733+6156226',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,193.989083,61.93975,0.017,NULL,57355376867,896177763,14002777,18),(102415,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102415,38.6,0.19,524,43073,70,NULL,NULL,'2MASX J12555872+6208485',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000187,NULL,'16.3g',0.34,'BrClG          AGN',NULL,NULL,NULL,NULL,1,193.9949583,62.14678,0.017,NULL,57355370487,896177663,14002775,16.3),(102416,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102416,36.87,0.46,236,43074,70,NULL,NULL,'2MASX J12555906+1631248',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.72',0.16,NULL,NULL,NULL,NULL,NULL,1,193.9962083,16.52375,0.014,NULL,59046922302,922608160,14415752,18.72),(102417,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102417,37.34,0.46,294,43075,70,NULL,NULL,'2MASX J12555943+5437012',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000177,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,193.9977917,54.61711,0,NULL,57424186964,897252921,14019576,16.3),(102418,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102418,35.34,0.33,117,43076,70,NULL,NULL,'MCG +08-24-010',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000083,NULL,'15.1g',0.57,'S0^-',NULL,NULL,NULL,NULL,1,193.998,48.44547,0,NULL,59102465889,923476029,14429312,15.1),(102419,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102419,37.88,0.46,377,43077,70,NULL,NULL,'2MASX J12560053+3530263',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000198,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,194.002166667,35.50739,0.028,NULL,58553365169,914896330,14295255,16.7),(102420,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102420,37.48,0.27,314,43078,70,NULL,NULL,'2MASX J12560066+3623470',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00022,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,194.0027917,36.39642,0.034,NULL,59073352340,923021130,14422205,17.4),(102421,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102421,35.31,0.05,115,43079,70,NULL,NULL,'2MASX J12560174+2645235',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00011,NULL,'16.0g',0.33,NULL,'Group member',NULL,NULL,NULL,1,194.007333,26.75661,0.016,NULL,58696156146,917127439,14330116,16),(102422,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102422,37.13,0.46,267,43080,70,NULL,NULL,'2MASX J12560216+4117340',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000208,NULL,'15.8g',0.45,'E0',NULL,NULL,NULL,NULL,1,194.0089583,41.29264,0,NULL,59078308711,923098573,14423415,15.8),(102423,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102423,36.28,0.46,181,43081,70,NULL,NULL,'2MASX J12560300+4217452',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000144,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,194.01275,42.29578,0,NULL,59078440038,923100625,14423447,17),(102424,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102424,36.13,0.56,168,43082,70,NULL,NULL,'2MASX J12560463-1707326',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.0001,NULL,'14',0.3,'E','Group member',NULL,NULL,NULL,1,194.0192917,-17.12569,0.053,NULL,44018834512,687794289,10746785,14),(102425,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102425,37.71,0.46,348,43083,70,NULL,NULL,'SDSS J125606.84+090143.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.81',0.13,NULL,NULL,NULL,NULL,NULL,1,194.0285417,9.02875,0,NULL,58068141567,907314711,14176792,18.81),(102426,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102426,36.4,0.53,190,43084,70,NULL,NULL,'2MASX J12560707-1656496',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000097,NULL,'14',0.5,'S0p','Group member',NULL,NULL,NULL,1,194.0295417,-16.94719,0.053,NULL,44018960837,687796263,10746816,14),(102427,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102427,37.84,0.46,370,43085,70,NULL,NULL,'SDSS J125607.26+300003.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000158,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,194.0302917,30.00108,0.027,NULL,58745522382,917898787,14342168,18.5),(102428,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102428,38.6,0.19,524,43086,70,NULL,NULL,'2MASX J12560814+6210265',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,194.033916667,62.17406,0.017,NULL,57355368374,896177630,14002775,17.9),(102429,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102429,37.48,0.27,314,43087,70,NULL,NULL,'2MASX J12560829+3616193',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000133,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,194.0347083,36.27211,0.023,NULL,59073218203,923019034,14422172,17.7),(102430,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102430,37.55,0.46,324,43088,70,NULL,NULL,'IC 3911 NED01',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000067,NULL,'16.2g',0.41,NULL,NULL,NULL,NULL,NULL,1,194.038417,35.63672,0.019,NULL,58553437056,914897454,14295272,16.2),(102431,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102431,36.9,0.46,240,43089,70,NULL,NULL,'2MASX J12560925+6520566',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000149,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,194.038667,65.34911,0.037,NULL,57365668115,896338564,14005290,16.6),(102432,'SBF','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102432,28.16,NULL,4.28,43090,NULL,NULL,NULL,'ESO 219- G 010',NULL,'2000AJ....119..166J',2000,1,1.4,NULL,'G',NULL,NULL,'16.96',1.1,'dE,N',NULL,NULL,NULL,NULL,1,194.04,-50.14392,1.033,NULL,46734244189,730222565,11409727,16.96),(102433,'SBF','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102433,28.4,0.18,4.79,43090,NULL,NULL,'R','ESO 219- G 010',NULL,'2000AJ....119..166J',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102434,'TRGB','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102434,28.41,NULL,4.8,43090,NULL,NULL,NULL,'ESO 219- G 010',NULL,'2015ApJ...802L..25T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102435,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102435,37.98,0.46,394,43091,70,NULL,NULL,'2MASX J12560999+6231135',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,194.0415417,62.52061,0.013,NULL,57355994856,896187419,14002928,17.8),(102436,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102436,37.47,0.46,312,43092,70,NULL,NULL,'2MASX J12561075+1950334',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.14,'AGN',NULL,NULL,NULL,NULL,1,194.04475,19.84247,0.127,NULL,59037449939,922460155,14413439,17.9),(102437,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102437,37.94,0.46,388,43093,70,NULL,NULL,'2MASX J12561101+1439418',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,194.046,14.66147,0.053,NULL,59001572698,921899573,14404680,17.2),(102438,'Jet Proper Motion','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102438,41.28,0.53,1800,43094,NULL,NULL,NULL,'3C 279',NULL,'2000ApJ...535..575H',2000,1,NULL,NULL,'QSO',0.0004,NULL,'15.2R',NULL,'blazar;HPQ;FSRQBLLAC',NULL,NULL,'radio jet','Flat-Spectrum Radio Source',1,194.0465417,-5.78931,0.057,NULL,43127961109,673874392,10529287,15.2),(102439,'GeV TeV ratio','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102439,41.05,NULL,1620,43094,72,NULL,NULL,'3C 279',NULL,'2010MNRAS.405L..76P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102440,'D-Sigma','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102440,34.86,0.4,93.8,43095,75,NULL,'Edat, raw','NGC 4816',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000031,NULL,'13.7g',1.1,'S0-:           PAS','in a radial-velocity based grouping',NULL,NULL,NULL,1,194.050625,27.74547,0.044,NULL,58696911251,917139238,14330300,13.7),(102441,'D-Sigma','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102441,34.89,0.4,95,43095,75,NULL,'Edat, cor','NGC 4816',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102442,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102442,35.03,0.23,101,43095,74.4,NULL,NULL,'NGC 4816',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102443,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102443,35.11,0.4,105,43095,NULL,NULL,'mean','NGC 4816',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102444,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102444,35.41,0.45,121,43095,NULL,NULL,'K','NGC 4816',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102445,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102445,38.6,0.19,524,43096,70,NULL,NULL,'SDSS J125612.47+620611.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000153,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,194.052,62.10317,0.017,NULL,57355396100,896178064,14002782,18.6),(102446,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102446,37.98,0.46,394,43097,70,NULL,NULL,'SDSS J125613.03+020843.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000067,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,194.0542917,2.1455,0,NULL,58095900918,907748451,14183569,18.7),(102447,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102447,38.12,0.46,420,43098,70,NULL,NULL,'2MASX J12561391-0058021',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000074,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,194.058083,-0.96725,0.025,NULL,43114927433,673670741,10526105,18.1),(102448,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102448,37.84,0.33,370,43099,70,NULL,NULL,'2MASX J12561567+3346075',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000174,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,194.06525,33.76878,0,NULL,58739511626,917804869,14340701,17.7),(102449,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102449,36.18,0.54,172,43100,70,NULL,NULL,'ESO 575- G 030',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'16.15',0.2,'S...',NULL,NULL,NULL,NULL,1,194.068375,-18.39086,0.101,NULL,43985071274,687266738,10738542,16.15),(102450,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102450,35.31,0.05,115,43101,70,NULL,NULL,'2MASX J12561667+2726450',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000103,NULL,'15.8g',0.35,'SB0/a','Group member',NULL,NULL,NULL,1,194.069583,27.44597,0.029,NULL,58697024648,917141010,14330328,15.8),(102451,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102451,35.52,0.33,127,43102,70,NULL,NULL,'2MASX J12561755+5511260',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000174,NULL,'16.0g',0.33,'S0^-',NULL,NULL,NULL,NULL,1,194.07325,55.19069,0.037,NULL,57423656935,897244639,14019447,16),(102452,'Tully est','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102452,30.97,0.8,15.6,43103,75,NULL,NULL,'UGCA 309',NULL,'1988NBGC.C....0000T',1988,1,0.9,NULL,'G',0.000017,NULL,'15.50',0.8,'Im','Dwarf, within FOV of cluster',NULL,NULL,NULL,1,194.074167,34.65472,0,NULL,58737883402,917779428,14340303,15.5),(102453,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102453,35.31,0.05,115,43104,70,NULL,NULL,'IC 0834',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000031,NULL,'14.6g',0.54,'E',NULL,NULL,NULL,NULL,1,194.0775,26.35892,0.028,NULL,58700434129,917194283,14331160,14.6),(102454,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102454,35.7,0.25,138,43104,74.4,NULL,NULL,'IC 0834',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102455,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102455,37.84,0.33,370,43105,70,NULL,NULL,'2MASX J12561928+3347355',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000158,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,194.080417,33.79317,0,NULL,58739495871,917804622,14340697,16.9),(102456,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102456,35.11,0.25,105,43106,74.4,NULL,NULL,'CGCG 160-023',NULL,'2013AJ....146...86T',2013,1,0.65,NULL,'G',0.000028,NULL,'15.2g',0.59,'E','Group member',NULL,NULL,NULL,1,194.082458333,27.75103,0.044,NULL,58696881659,917138775,14330293,15.2),(102457,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102457,35.31,0.05,115,43106,70,NULL,NULL,'CGCG 160-023',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102458,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102458,36.96,0.46,247,43107,70,NULL,NULL,'2MASX J12562129+0256442',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000087,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,194.0887917,2.94556,0.026,NULL,58093222063,907706594,14182915,16.9),(102459,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102459,37.11,0.46,264,43108,70,NULL,NULL,'LCRS B125347.5-023104',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000098,NULL,'16.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,194.091583,-2.78842,0.009,NULL,43113263121,673644736,10525699,16.4),(102460,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102460,36.8,0.46,229,43109,70,NULL,NULL,'2MASX J12562265+0918374',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000187,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,194.0944583,9.31044,0,NULL,58956364331,921193192,14393643,16.5),(102461,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102461,37.47,0.46,312,43110,70,NULL,NULL,'IC 3914',NULL,'2015arXiv151105856S',2015,1,0.31,'The IC number includes a neighboring star.','G',0.000174,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,194.094916667,36.36092,0.034,NULL,59073188496,923018570,14422165,17),(102462,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102462,37.69,0.46,345,43111,70,NULL,NULL,'2MASX J12562326+0856294',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.24',0.18,NULL,NULL,NULL,NULL,NULL,1,194.096833333,8.94161,0,NULL,58068271649,907316744,14176824,18.24),(102463,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102463,35.62,0.46,133,43112,70,NULL,NULL,'CGCG 043-074 NED01',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000093,NULL,'16.74',0.26,NULL,NULL,NULL,NULL,NULL,1,194.101916667,7.44717,0.035,NULL,58082227621,907534806,14180231,16.74),(102464,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102464,35.31,0.05,115,43113,70,NULL,NULL,'2MASX J12562629+2743380',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00004,NULL,'16.82',0.36,NULL,'Group member',NULL,NULL,NULL,1,194.109583,27.72725,0.044,NULL,58696889237,917138894,14330295,16.82),(102465,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102465,34.93,0.23,96.8,43114,74.4,NULL,NULL,'CGCG 160-027',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000019,NULL,'15.1g',0.6,'E','Group member',NULL,NULL,NULL,1,194.1109583,27.83064,0.044,NULL,58696698463,917135913,14330248,15.1),(102466,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102466,35.31,0.05,115,43114,70,NULL,NULL,'CGCG 160-027',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102467,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102467,38.35,0.46,467,43115,70,NULL,NULL,'2MASX J12562685+1013394',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,194.111875,10.22767,0,NULL,58958438208,921225597,14394149,NULL),(102468,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102468,35.91,0.46,152,43116,70,NULL,NULL,'2MASX J12562691+0936044',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000179,NULL,'17.30',0.22,NULL,NULL,NULL,NULL,NULL,1,194.11225,9.60125,0,NULL,58957227810,921206684,14393854,17.3),(102469,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102469,37.22,0.46,278,43117,70,NULL,NULL,'2MASX J12562735+0236052',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000077,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,194.1140417,2.60131,0.022,NULL,58095351248,907739863,14183435,18.2),(102470,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102470,36.76,0.46,225,43118,70,NULL,NULL,'2MASX J12562824+0337292',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000062,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,194.117625,3.62492,0.022,NULL,58101478863,907835607,14184931,17.2),(102471,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102471,36.13,0.46,168,43119,70,NULL,NULL,'2MASX J12562826+3522135',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000167,NULL,'16.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,194.1177083,35.37044,0.028,NULL,58552623713,914884745,14295074,16.3),(102472,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102472,38.23,0.46,443,43120,70,NULL,NULL,'2MASX J12562831+4852544',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,194.118125,48.88197,0,NULL,59104336584,923505259,14429769,18.5),(102473,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102473,34.1,0.43,65.9,43121,75,NULL,'3.6 micron, color + selection bias corrected','IC 3913',NULL,'2014MNRAS.444..527S',2014,1,0.75,NULL,'G',0.00002,NULL,'15.3g',0.56,'Sc','Group member',NULL,NULL,NULL,1,194.1190417,27.29128,0.025,NULL,58697031926,917141123,14330330,15.3),(102474,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102474,34.19,0.43,68.9,43121,75,NULL,'3.6 micron, color corrected','IC 3913',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102475,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102475,34.31,0.2,72.8,43121,74.4,NULL,NULL,'IC 3913',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102476,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102476,35.07,0.09,103,43121,NULL,NULL,NULL,'IC 3913',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102477,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102477,38.13,0.46,422,43122,70,NULL,NULL,'2MASX J12562903+5013135',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000199,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,194.120791667,50.22028,0,NULL,59095892506,923373320,14427708,17.3),(102478,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102478,35.31,0.05,115,43123,70,NULL,NULL,'NGC 4821',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000025,NULL,'14.7g',0.49,'E4:','in a pair',NULL,NULL,NULL,1,194.121375,26.957,0,NULL,58696228056,917128563,14330133,14.7),(102479,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102479,35.31,0.05,115,43124,70,NULL,NULL,'NGC 4817',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000031,NULL,'15.3g',0.62,'E','Group member',NULL,NULL,NULL,1,194.12425,27.94,0.044,NULL,58698789127,917168580,14330759,15.3),(102480,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102480,35.57,0.25,130,43124,74.4,NULL,NULL,'NGC 4817',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102481,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102481,37.35,0.46,295,43125,70,NULL,NULL,'2MASX J12562989+0222142',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000076,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,194.1245,2.3705,0,NULL,58095460885,907741576,14183462,17.3),(102482,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102482,37.48,0.27,314,43126,70,NULL,NULL,'2MASX J12563285+3615522',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000146,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,194.136833,36.26464,0.023,NULL,59073225735,923019152,14422174,17.6),(102483,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102483,35.19,NULL,109,43127,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 269- G 011',NULL,'2010Ap&SS.325..163P',2010,1,1.57,NULL,'G',0.000033,NULL,'15.77',0.22,'Sbc',NULL,NULL,NULL,NULL,1,194.139041667,-44.24739,0.397,NULL,46762212544,730659571,11416555,15.77),(102484,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102484,35.2,NULL,110,43127,NULL,NULL,'Dipole + Quadrupole','ESO 269- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102485,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102485,35.22,NULL,110,43127,NULL,NULL,'Dipole','ESO 269- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102486,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102486,35.24,NULL,112,43127,NULL,NULL,NULL,'ESO 269- G 011',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102487,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102487,35.27,0.49,113,43127,75,NULL,'IR','ESO 269- G 011',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102488,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102488,35.47,0.46,124,43127,NULL,NULL,'Malmquist cor.','ESO 269- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102489,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102489,35.59,0.44,132,43127,NULL,NULL,NULL,'ESO 269- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102490,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102490,35.64,0.2,134,43127,74.4,NULL,NULL,'ESO 269- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102491,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102491,35.31,0.05,115,43128,70,NULL,NULL,'2MASX J12563418+2732200',NULL,'2015arXiv151105856S',2015,1,0.52,'Often incorrectly refered to as NGC 4824, which is a star.','G',0.00003,NULL,'15.4g',0.46,'SA0','Group member',NULL,NULL,NULL,1,194.142458333,27.53894,0.029,NULL,58696860743,917138449,14330288,15.4),(102492,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102492,37.92,0.46,385,43129,70,NULL,NULL,'2MASX J12563447+1125145',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,194.143666667,11.42072,0.038,NULL,58958211920,921222061,14394094,17.2),(102493,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102493,34.64,0.49,84.6,43130,75,NULL,'IR','MCG -02-33-066',NULL,'2011yCatp016004901K',2011,1,1.4,'Confused HIPASS source','G',0.000027,NULL,'15',0.3,'SB(s)m? sp',NULL,NULL,NULL,NULL,1,194.144375,-13.39375,0.049,NULL,43972947115,687077298,10735582,15),(102494,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102494,35.16,0.23,108,43131,74.4,NULL,NULL,'NGC 4824',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'*',NULL,NULL,'15.8g',NULL,NULL,NULL,NULL,NULL,NULL,1,194.1515417,27.43264,0.025,NULL,58697155469,917143054,14330360,15.8),(102495,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102495,37.14,0.46,268,43132,70,NULL,NULL,'2MASX J12563659+0411029',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000139,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,194.152416667,4.18417,0.006,NULL,58100871698,907826120,14184783,17.4),(102496,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102496,38.63,0.46,533,43133,70,NULL,NULL,'2MASX J12563788+1817165',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,194.157833,18.28803,0.097,NULL,59028170506,922315164,14411174,17.9),(102497,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102497,36.11,0.46,167,43134,70,NULL,NULL,'2MASX J12563823+5236415',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000186,NULL,'15.9g',0.34,'E0',NULL,NULL,NULL,NULL,1,194.159291667,52.61161,0,NULL,57209037281,893891207,13967050,15.9),(102498,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102498,36.06,0.46,163,43135,70,NULL,NULL,'2MASX J12563874+5039545',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'16.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,194.161375,50.66525,0,NULL,57203025240,893797269,13965582,16.3),(102499,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102499,37.85,0.46,372,43136,70,NULL,NULL,'2MASX J12563948+2218375',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,194.164625,22.31047,0.117,NULL,59025764549,922277571,14410587,17.1),(102500,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102500,35.36,0.59,118,43137,70,NULL,NULL,'2MASX J12564009-2026375',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,194.1670417,-20.44372,0.213,NULL,43987065969,687297905,10739029,15.5),(102501,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102501,31.41,0.4,19.1,43138,75,NULL,NULL,'IC 3908',NULL,'2008Ap.....51..336K',2008,1,1.8,'The APM position refers to the northern arm.','G',0.000013,NULL,'13.5b',0.7,'SB(s)d?        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,194.16925,-7.56278,0.113,NULL,43132628651,673947322,10530426,13.5),(102502,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102502,31.52,0.45,20.2,43138,NULL,NULL,'K','IC 3908',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102503,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102503,31.56,0.47,20.5,43138,NULL,NULL,'H','IC 3908',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102504,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102504,31.66,0.46,21.4,43138,NULL,NULL,'J','IC 3908',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102505,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102505,31.7,0.4,21.8,43138,NULL,NULL,'mean','IC 3908',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102506,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102506,31.9,0.4,23.9,43138,NULL,NULL,NULL,'IC 3908',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102507,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102507,32.09,0.49,26.2,43138,75,NULL,'IR','IC 3908',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102508,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102508,35.91,0.46,152,43139,70,NULL,NULL,'2MASX J12564083+3512594',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000172,NULL,'16.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,194.17025,35.21658,0.028,NULL,58737112302,917767379,14340115,16.3),(102509,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102509,37.97,0.46,392,43140,70,NULL,NULL,'2MASX J12564141+0053589',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000101,NULL,'16.4g',0.39,'E/S0',NULL,NULL,NULL,NULL,1,194.172625,0.89975,0,NULL,58089641110,907650642,14182041,16.4),(102510,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102510,37.18,0.46,273,43141,70,NULL,NULL,'2MASX J12564205+6305157',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000147,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,194.174916667,63.08756,0,NULL,57357160215,896205628,14003212,16.7),(102511,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102511,35.7,0.51,138,43142,70,NULL,NULL,'2MASX J12564201-1701351',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00008,NULL,'14',0.4,'S0','Group member',NULL,NULL,NULL,1,194.175083333,-17.02647,0.053,NULL,44018864353,687794755,10746793,14),(102512,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102512,35.31,0.05,115,43143,70,NULL,NULL,'NGC 4828',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000077,NULL,'14.8g',0.73,'S0','Group member',NULL,NULL,NULL,1,194.178583,28.02044,0.073,NULL,58698813176,917168955,14330764,14.8),(102513,'D-Sigma','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102513,32.06,0.4,25.8,43144,75,NULL,'Edat, raw','IC 3896',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000067,NULL,'12.1',1.9,'E',NULL,NULL,NULL,NULL,1,194.180125,-50.34686,1.005,NULL,46734036705,730219323,11409676,12.1),(102514,'D-Sigma','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102514,32.39,0.4,30.1,43144,75,NULL,'Edat, cor','IC 3896',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102515,'Faber-Jackson','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102515,31.97,0.65,24.8,43144,95,NULL,'Weighted Mean','IC 3896',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102516,'Faber-Jackson','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102516,33.91,0.81,60.5,43144,55,NULL,'Visvanathan & Sandage 1979','IC 3896',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102517,'Tully est','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102517,32.4,0.8,30.2,43144,75,NULL,'B','IC 3896',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102518,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102518,37.58,0.46,327,43145,70,NULL,NULL,'LCRS B125408.8-032014',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000074,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,194.1812083,-3.60789,0.009,NULL,43137172244,674018316,10531536,17.7),(102519,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102519,35.27,0.25,113,43146,74.4,NULL,NULL,'NGC 4827',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000031,NULL,'13.8g',1.3,'S0-','in a radial-velocity based grouping',NULL,NULL,NULL,1,194.181375,27.17864,0,NULL,58697134442,917142725,14330355,13.8),(102520,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102520,35.31,0.05,115,43146,70,NULL,NULL,'NGC 4827',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102521,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102521,35.11,0.4,105,43146,NULL,NULL,'mean','NGC 4827',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102522,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102522,35.54,0.45,128,43146,NULL,NULL,'K','NGC 4827',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102523,'SBF','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102523,28.6,0.08,5.24,43147,74.4,NULL,NULL,'MESSIER 064',NULL,'2013AJ....146...86T',2013,1,10,'UZC has V = 5640 +- 45 km/sec.','G',0.000013,NULL,'9.36',5.4,'(R)SA(rs)ab;HIISy2','Possible field galaxy',NULL,NULL,'Sy',1,194.181833,21.68297,0.147,NULL,59026344212,922286628,14410728,9.36),(102524,'SBF','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102524,29.37,0.2,7.48,43147,NULL,NULL,'I','MESSIER 064',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102525,'TRGB','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102525,28.34,0.01,4.66,43147,NULL,NULL,'I','MESSIER 064',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102526,'TRGB','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102526,28.6,0.08,5.24,43147,74.4,NULL,NULL,'MESSIER 064',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102527,'TRGB','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102527,28.61,NULL,5.27,43147,NULL,NULL,'I','MESSIER 064',NULL,'2008ApJ...686L..75M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102528,'IRAS','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102528,28.91,0.8,6.04,43147,75,NULL,'A82, H','MESSIER 064',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102529,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102529,26.92,0.69,2.42,43147,100,NULL,'mid-IR','MESSIER 064',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102530,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102530,28.06,0.4,4.1,43147,75,NULL,'B','MESSIER 064',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102531,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102531,28.33,0.47,4.63,43147,75,NULL,'A82, H, raw','MESSIER 064',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102532,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102532,28.41,0.47,4.81,43147,75,NULL,'A82, H, inv','MESSIER 064',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102533,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102533,28.54,0.35,5.11,43147,NULL,NULL,NULL,'MESSIER 064',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102534,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102534,28.6,0.08,5.24,43147,74.4,NULL,NULL,'MESSIER 064',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102535,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102535,28.7,0.43,5.5,43147,75,NULL,'3.6 micron, color + selection bias corrected','MESSIER 064',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102536,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102536,28.72,0.46,5.54,43147,NULL,NULL,NULL,'MESSIER 064',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102537,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102537,28.72,0.46,5.54,43147,NULL,NULL,'Malmquist cor.','MESSIER 064',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102538,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102538,28.73,0.47,5.57,43147,75,NULL,'A82, H, cor','MESSIER 064',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102539,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102539,28.72,0.43,5.6,43147,75,NULL,'3.6 micron, color corrected','MESSIER 064',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102540,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102540,29.24,NULL,7.05,43147,NULL,NULL,'LEDA [April 2006]','MESSIER 064',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102541,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102541,34.61,0.46,83.7,43148,70,NULL,NULL,'CGCG 160-030',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000063,NULL,'15.0g',0.5,'S0','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,194.183375,30.71925,0.051,NULL,58745718072,917901844,14342216,15),(102542,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102542,37.05,0.57,257,43149,70,NULL,NULL,'2MASX J12564442-1827376',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,194.185083333,-18.46042,0.101,NULL,43983910275,687248598,10738259,16.9),(102543,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102543,37.95,0.46,389,43150,70,NULL,NULL,'2MASX J12564544+1654282',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,194.189375,16.90783,0.07,NULL,59047211880,922612685,14415823,17.5),(102544,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102544,37.16,0.46,270,43151,70,NULL,NULL,'2MASX J12564548+0142029',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000074,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,194.189625,1.70072,0,NULL,58088273373,907629271,14181707,17.3),(102545,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102545,37.87,0.46,374,43152,70,NULL,NULL,'2MASX J12564557+1227502',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000184,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,194.189833333,12.46408,0.063,NULL,59004225923,921941030,14405328,17.1),(102546,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102546,35.44,0.2,122,43153,74.4,NULL,NULL,'UGC 08064',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000035,NULL,'15.7',0.12,'Sb',NULL,NULL,NULL,NULL,1,194.194,11.09147,0.024,NULL,58958238687,921222479,14394101,15.7),(102547,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102547,35.47,0.49,124,43153,NULL,NULL,'Malmquist cor.','UGC 08064',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102548,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102548,35.48,0.48,125,43153,NULL,NULL,NULL,'UGC 08064',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102549,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102549,37.08,0.46,261,43154,70,NULL,NULL,'2MASX J12564718+2230264',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,194.19675,22.50739,0.117,NULL,59022997443,922234335,14409911,17.1),(102550,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102550,38.1,0.46,418,43155,70,NULL,NULL,'SDSS J125647.93+061228.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,194.19975,6.20794,0.018,NULL,58078764060,907480688,14179385,17.7),(102551,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102551,38.2,0.46,437,43156,70,NULL,NULL,'2MASX J12564790+5340005',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000146,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,194.19975,53.66686,0.012,NULL,57200741501,893761585,13965024,18.5),(102552,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102552,36.54,0.47,203,43157,NULL,NULL,'Malmquist cor.','CGCG 071-077',NULL,'2009ApJS..182..474S',2009,1,0.74,NULL,'G',0.000083,NULL,'15.6g',0.39,'S0',NULL,NULL,NULL,NULL,1,194.1999583,11.16567,0.024,NULL,58958245992,921222593,14394103,15.6),(102553,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102553,36.77,0.42,226,43157,NULL,NULL,NULL,'CGCG 071-077',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102554,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102554,36.81,0.2,230,43157,74.4,NULL,NULL,'CGCG 071-077',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102555,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102555,37,0.46,251,43158,70,NULL,NULL,'2MASX J12564845+1001425',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,194.20175,10.02847,0.011,NULL,58956561983,921196280,14393691,17.6),(102556,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102556,35.9,0.46,151,43159,70,NULL,NULL,'IC 3919',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000179,NULL,'15.9g',0.34,NULL,NULL,NULL,NULL,NULL,1,194.2029583,38.58875,0,NULL,59073910628,923029853,14422341,15.9),(102557,'Tully est','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102557,31.66,0.8,21.5,43160,75,NULL,'B','NGC 4818',NULL,'1988NBGC.C....0000T',1988,1,4.3,NULL,'G',0.000103,NULL,'12.10',1.5,'SAB(rs)ab pec: Sbrst','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,194.20375,-8.52531,0.081,NULL,43132167560,673940118,10530314,12.1),(102558,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102558,30.1,0.43,10.4,43160,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4818',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102559,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102559,30.23,0.43,11.1,43160,75,NULL,'3.6 micron, color corrected','NGC 4818',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102560,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102560,30.38,0.2,11.9,43160,74.4,NULL,NULL,'NGC 4818',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102561,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102561,30.43,0.4,12.2,43160,NULL,NULL,NULL,'NGC 4818',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102562,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102562,31.34,0.3,18.6,43160,55,NULL,'B','NGC 4818',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102563,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102563,35.11,0.07,105,43161,NULL,NULL,NULL,'CGCG 160-031',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.00011,NULL,'15.4g',0.2,'Sa             AGN','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,194.206917,27.09392,0,NULL,58697102568,917142227,14330347,15.4),(102564,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102564,37.49,0.46,315,43162,70,NULL,NULL,'2MASX J12565042+3016434',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000179,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,194.210083333,30.27881,0.027,NULL,58674971184,916796424,14324944,16.5),(102565,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102565,37.24,0.46,281,43163,70,NULL,NULL,'2MASX J12565041+3025114',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000157,NULL,'16.4g',0.35,'AGN',NULL,NULL,NULL,NULL,1,194.210125,30.41983,0.046,NULL,58674717455,916792460,14324882,16.4),(102566,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102566,35.08,0.09,104,43164,NULL,NULL,NULL,'KUG 1254+291',NULL,'2009ApJS..182..474S',2009,1,0.97,NULL,'G',0.000073,NULL,'15.1g',0.34,'S0/a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,194.210917,28.92983,0.044,NULL,58695184893,917112263,14329879,15.1),(102567,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102567,37.31,0.75,290,43165,70,NULL,NULL,'2MASX J12565104-1716444',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.000097,NULL,'15.7V',0.1,'SB0','Group member',NULL,NULL,NULL,1,194.2127917,-17.27894,0.089,NULL,44018952053,687796125,10746814,15.7),(102568,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102568,37.98,0.27,394,43166,70,NULL,NULL,'2MASX J12565216+0305169',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000087,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,194.217375,3.08806,0.026,NULL,58114219959,908034686,14188041,17.4),(102569,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102569,33.26,0.5,44.8,43167,70,NULL,NULL,'NGC 4811',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'14.02',0.9,'SAB(rl)0^+','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,194.218167,-41.79719,0.497,NULL,46752621303,730509707,11414214,14.02),(102570,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102570,35.31,0.05,115,43168,70,NULL,NULL,'2MASX J12565310+2755458',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'16.0g',0.14,'E/SA0','Group member',NULL,NULL,NULL,1,194.221417,27.9295,0.044,NULL,58698783165,917168486,14330757,16),(102571,'SNIa','2016-12-15 15:15:07','2016-12-16 11:20:19','1','SN 2007bz',NULL,102571,34.95,0.18,95.6,43169,74.2,NULL,'SALT 2','IC 3918',0.021778,'2010ApJ...716..712A',2010,1,0.6,'Often mistakenly called IC 3917 (that is a nearby star).','G',0.0002,NULL,'15.6',0.3,'Sc','Isolated galaxy',NULL,NULL,NULL,1,194.223083,22.37361,0.117,NULL,59025756021,922277437,14410584,15.6),(102572,'SNIa','2016-12-15 15:15:07','2016-12-16 11:20:19','1','SN 2007bz',NULL,102572,35.25,NULL,110,43169,72,NULL,'MLCS17','IC 3918',0.021778,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102573,'SNIa','2016-12-15 15:15:07','2016-12-16 11:20:19','1','SN 2007bz','R',102573,35.43,0.1,122,43169,NULL,NULL,'MLCS2k2, R(V) = 3.1','IC 3918',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102574,'SNIa','2016-12-15 15:15:07','2016-12-16 11:20:19','1','SN 2007bz','R',102574,35.49,0.07,125,43169,NULL,NULL,'MLCS2k2, R(V) = 1.8','IC 3918',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102575,'SNIa','2016-12-15 15:15:07','2016-12-16 11:20:19','1','SN 2007bz',NULL,102575,35.5,0.09,126,43169,74.4,NULL,NULL,'IC 3918',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102576,'SNIa','2016-12-15 15:15:07','2016-12-16 11:20:19','1','SN 2007bz',NULL,102576,35.62,0.17,130,43169,70,NULL,'SALT 2','IC 3918',0.021778,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102577,'SNIa','2016-12-15 15:15:07','2016-12-16 11:20:19','1','SN 2007bz',NULL,102577,35.76,0.19,139,43169,65,NULL,'MLCS17','IC 3918',0.021778,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102578,'SNIa','2016-12-15 15:15:07','2016-12-16 11:20:19','1','SN 2007bz',NULL,102578,35.78,0.21,140,43169,65,NULL,'SALT2','IC 3918',0.021778,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102579,'SNIa','2016-12-15 15:15:07','2016-12-16 11:20:19','1','SN 2007bz',NULL,102579,35.83,0.21,143,43169,65,NULL,'MLCS31','IC 3918',0.021778,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102580,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102580,35.76,0.59,142,43170,70,NULL,NULL,'2MASX J12565395-1742054',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00011,NULL,'14',0.2,'S0','Group member',NULL,NULL,NULL,1,194.2247917,-17.7015,0.089,NULL,44016611755,687759558,10746243,14),(102581,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102581,36.56,0.61,205,43171,70,NULL,NULL,'2MASX J12565408-3300125',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000057,NULL,'14.7',0.3,'E',NULL,NULL,NULL,NULL,1,194.2252917,-33.00347,0.333,NULL,43454250105,678972657,10608947,14.7),(102582,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102582,38.08,0.46,412,43172,70,NULL,NULL,'SDSS J125654.15+060446.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,194.225667,6.07969,0.018,NULL,58078551142,907477361,14179333,18.1),(102583,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102583,37.02,0.46,253,43173,70,NULL,NULL,'2MASX J12565448+4635180',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000194,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,194.226875,46.5885,0,NULL,59100001768,923437527,14428711,17),(102584,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102584,38.49,0.46,498,43174,70,NULL,NULL,'SDSS J125655.53+220210.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,194.231375,22.03639,0.129,NULL,59025851263,922278925,14410608,18.5),(102585,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102585,37.08,0.33,260,43175,70,NULL,NULL,'2MASX J12565547+2857218',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000117,NULL,'16.7g',0.28,'E','Group member',NULL,NULL,NULL,1,194.231375,28.95625,0.044,NULL,58695186744,917112292,14329879,16.7),(102586,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102586,37.48,0.46,313,43176,70,NULL,NULL,'2MASX J12565586+6147456',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000147,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,194.23275,61.79617,0,NULL,57356494547,896195227,14003050,17.2),(102587,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102587,37.17,0.7,272,43177,70,NULL,NULL,'2MASX J12565754-1716444',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.000097,NULL,'16.0V',0.2,'S0','Group member',NULL,NULL,NULL,1,194.239916667,-17.27903,0.097,NULL,44018955877,687796185,10746815,16),(102588,'Tully-Fisher','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102588,34.33,NULL,73.5,43178,NULL,NULL,NULL,'CGCG 160-036',NULL,'1993MNRAS.263..211R',1993,1,0.77,NULL,'G',0.0001,NULL,'14.5g',0.66,'E?','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,194.241125,30.71606,0.051,NULL,58674661417,916791584,14324868,14.5),(102589,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,NULL,102589,35.98,0.55,157,43179,70,NULL,NULL,'2MASX J12565801-1549244',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,194.241667,-15.82353,0.033,NULL,43962171808,686908934,10732952,16.5),(102590,'FP','2016-12-15 15:15:07','2016-12-16 11:20:19','1',NULL,'R',102590,37.98,0.27,394,43180,70,NULL,NULL,'SDSS J125658.38+031529.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000061,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,194.2432917,3.25828,0.031,NULL,58114327908,908036373,14188068,18.6),(102591,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102591,37.37,0.46,298,43181,70,NULL,NULL,'2MASX J12565938+0618585',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.87',0.21,'BrClG',NULL,NULL,NULL,NULL,1,194.247333,6.31622,0.018,NULL,58078656907,907479014,14179359,17.87),(102592,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102592,37.08,0.33,260,43182,70,NULL,NULL,'2MASX J12570019+2854138',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00018,NULL,'16.7g',0.29,'E','Group member',NULL,NULL,NULL,1,194.250708333,28.90378,0.044,NULL,58695186417,917112287,14329879,16.7),(102593,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102593,34,0.51,63.1,43183,70,NULL,NULL,'NGC 4820',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00011,NULL,'15.70',0.2,'S0','Group member',NULL,NULL,NULL,1,194.252333,-13.71933,0.037,NULL,43972850510,687075789,10735559,15.7),(102594,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102594,35.31,0.05,115,43184,70,NULL,NULL,'CGCG 160-035',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.00006,NULL,'15.2g',0.36,'Sa','Group member',NULL,NULL,NULL,1,194.25675,29.06261,0.042,NULL,58695342063,917114719,14329917,15.2),(102595,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102595,38.87,0.46,594,43185,70,NULL,NULL,'2MASX J12570258+5113575',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000174,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,194.260875,51.23267,0.038,NULL,57208126724,893876980,13966827,18.3),(102596,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102596,33.58,0.53,52,43186,70,NULL,NULL,'NGC 4822',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000127,NULL,'14.36',0.7,'S0-',NULL,NULL,NULL,NULL,1,194.265583,-10.76183,0.085,NULL,43840293040,685004578,10703196,14.36),(102597,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102597,37.85,0.46,371,43187,70,NULL,NULL,'2MASX J12570385+6153445',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,194.266,61.89561,0.013,NULL,57356516519,896195570,14003055,17.5),(102598,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102598,38.61,0.46,528,43188,70,NULL,NULL,'2MASX J12570468+4848305',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,194.269375,48.80839,0,NULL,59104347626,923505431,14429772,18.1),(102599,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102599,34.56,0.56,81.6,43189,70,NULL,NULL,'MCG -02-33-068',NULL,'2014MNRAS.445.2677S',2014,1,1.9,NULL,'G',0.000023,NULL,'14.91',0.4,'SB(rs)cd?',NULL,NULL,NULL,NULL,1,194.274625,-12.27211,0.069,NULL,43958541162,686852205,10732065,14.91),(102600,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102600,34.56,0.44,81.7,43189,NULL,NULL,'Malmquist cor.','MCG -02-33-068',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102601,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102601,34.66,0.2,85.5,43189,74.4,NULL,NULL,'MCG -02-33-068',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102602,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102602,34.73,0.47,88.5,43189,NULL,NULL,'H','MCG -02-33-068',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102603,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102603,34.82,0.46,92.2,43189,NULL,NULL,'J','MCG -02-33-068',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102604,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102604,34.88,0.38,94.6,43189,NULL,NULL,NULL,'MCG -02-33-068',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102605,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102605,34.91,0.45,95.8,43189,NULL,NULL,'K','MCG -02-33-068',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102606,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102606,34.92,0.4,96.5,43189,NULL,NULL,'mean','MCG -02-33-068',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102607,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102607,37.31,0.46,290,43190,70,NULL,NULL,'2MASX J12570615+1358323',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.93',0.22,NULL,NULL,NULL,NULL,NULL,1,194.275583,13.97558,0.035,NULL,59005089243,921954519,14405539,17.93),(102608,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102608,37.98,0.46,394,43191,70,NULL,NULL,'SDSS J125707.95+351405.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,194.283125,35.23483,0.034,NULL,58737106958,917767296,14340114,18.2),(102609,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102609,33.75,0.49,56.2,43192,70,NULL,NULL,'ESO 443- G 015 NED02',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'12.7R',NULL,'S0',NULL,NULL,NULL,NULL,1,194.284333333,-32.51261,0.333,NULL,43467723979,679183187,10612237,12.7),(102610,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102610,37.59,0.33,329,43193,70,NULL,NULL,'2MASX J12570867+1756483',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.39',0.16,NULL,NULL,NULL,NULL,NULL,1,194.2862917,17.94669,0.095,NULL,59028065560,922313524,14411148,18.39),(102611,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102611,35.26,0.23,113,43194,74.4,NULL,NULL,'CGCG 160-037',NULL,'2013AJ....146...86T',2013,1,0.57,NULL,'G',0.000025,NULL,'15.0g',0.5,'SB0','Group member',NULL,NULL,NULL,1,194.28925,27.46642,0.025,NULL,58696833461,917138022,14330281,15),(102612,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102612,35.31,0.05,115,43194,70,NULL,NULL,'CGCG 160-037',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102613,'BCG','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102613,36.96,0.35,236,43195,60,NULL,NULL,'ABELL 1644',0.0456,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II     [BM]',NULL,NULL,NULL,NULL,1,194.290417,-17.40028,0.097,NULL,44018935548,687795867,10746810,NULL),(102614,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102614,35.9,0.33,151,43196,70,NULL,NULL,'2MASX J12570989+6219304',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000214,NULL,'15.4g',0.51,'E0',NULL,NULL,NULL,NULL,1,194.290917,62.32508,0.013,NULL,57356014540,896187727,14002933,15.4),(102615,'CMD','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102615,20.8,0.2,0.145,43197,NULL,NULL,NULL,'CVn II dSph',NULL,'2008AJ....135.1361D',2008,1,NULL,NULL,'G',NULL,NULL,'15.1V',NULL,NULL,NULL,NULL,NULL,NULL,1,194.291667,34.32083,0,1,58737710482,917776726,14340261,15.1),(102616,'CMD','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102616,20.9,0.2,0.15,43197,NULL,NULL,NULL,'CVn II dSph',NULL,'2008AJ....135.1361D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102617,'CMD','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102617,20.9,0.2,0.15,43197,NULL,NULL,NULL,'CVn II dSph',NULL,'2007ApJ...654..897B',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102618,'CMD','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102618,20.9,NULL,0.151,43197,NULL,NULL,NULL,'CVn II dSph',NULL,'2008A&A...477..139L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102619,'CMD','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102619,20.95,NULL,0.155,43197,NULL,NULL,NULL,'CVn II dSph',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102620,'Horizontal Branch','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102620,20.7,0.1,0.15,43197,NULL,NULL,'helio','CVn II dSph',NULL,'2006ApJ...653L..29S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102621,'Horizontal Branch','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102621,21.01,0.11,0.159,43197,NULL,NULL,NULL,'CVn II dSph',NULL,'2012ApJ...744...96O',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102622,'RR Lyrae','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102622,21.02,0.06,0.16,43197,NULL,NULL,'2','CVn II dSph',NULL,'2008ApJ...675L..73G',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102623,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102623,37.63,0.46,336,43198,70,NULL,NULL,'2MASX J12571079+0837017',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,194.294875,8.61703,0,NULL,58079580742,907493449,14179585,17.9),(102624,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102624,37.95,0.46,390,43199,70,NULL,NULL,'2MASX J12571084+0144032',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000086,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,194.295083,1.73425,0,NULL,58088451071,907632047,14181750,17.7),(102625,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102625,35.18,0.07,109,43200,NULL,NULL,NULL,'UGC 08069',NULL,'2009ApJS..182..474S',2009,1,0.91,NULL,'G',0.000077,NULL,'14.6g',0.49,'S0/a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,194.2975,29.04506,0.042,NULL,58695299135,917114048,14329907,14.6),(102626,'BCG','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102626,36.96,0.35,236,43201,60,NULL,'ABELL 1644, BCG','2MASX J12571157-1724344',0.0456,'1980ApJ...241..486H',1980,1,1.9,NULL,'G',0.00011,NULL,'13.1V',0.7,'cD;E+4','Group member',NULL,NULL,'Flat-Spectrum Radio Source',1,194.2982917,-17.4095,0.097,NULL,44018935360,687795865,10746810,13.1),(102627,'IRAS','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102627,33.2,0.8,43.6,43202,75,NULL,'MAT, I','NGC 4835A',NULL,'1997ApJS..109..333W',1997,1,3.19,NULL,'G',0.000009,NULL,'14.04',0.45,'Scd',NULL,NULL,NULL,NULL,1,194.304708333,-46.37469,0.433,NULL,46730039585,730156868,11408701,14.04),(102628,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102628,33.15,0.43,42.7,43202,75,NULL,'MAT, I, raw','NGC 4835A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102629,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102629,33.21,0.32,43.8,43202,85,NULL,'I, raw','NGC 4835A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102630,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102630,33.25,0.49,44.6,43202,75,NULL,'IR','NGC 4835A',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102631,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102631,33.25,0.32,44.7,43202,85,NULL,'I, inv','NGC 4835A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102632,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102632,33.36,0.43,47,43202,75,NULL,'MAT, I, inv','NGC 4835A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102633,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102633,33.37,0.43,47.3,43202,75,NULL,'MAT, I, cor','NGC 4835A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102634,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102634,33.39,0.16,47.7,43202,NULL,NULL,NULL,'NGC 4835A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102635,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102635,33.41,NULL,48,43202,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 4835A',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102636,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102636,33.41,NULL,48.1,43202,NULL,NULL,'Dipole','NGC 4835A',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102637,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102637,33.41,NULL,48.1,43202,NULL,NULL,'Dipole + Quadrupole','NGC 4835A',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102638,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102638,33.47,NULL,49.5,43202,NULL,NULL,NULL,'NGC 4835A',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102639,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102639,37.28,0.27,285,43203,70,NULL,NULL,'2MASX J12571206+3112201',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000212,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,194.300375,31.20556,0.051,NULL,58747019719,917922183,14342534,16.4),(102640,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102640,32.55,0.4,32.4,43204,75,NULL,NULL,'UGC 08067',NULL,'2008Ap.....51..336K',2008,1,2.46,NULL,'G',0.000017,NULL,'13.6B',0.34,'Sb pec sp',NULL,NULL,NULL,NULL,1,194.300458333,-1.70711,0,NULL,43111919666,673623744,10525371,13.6),(102641,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102641,33.05,0.49,40.7,43204,75,NULL,'IR','UGC 08067',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102642,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102642,33.08,0.43,41.2,43204,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08067',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102643,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102643,33.13,0.43,42.3,43204,75,NULL,'3.6 micron, color corrected','UGC 08067',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102644,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102644,33.18,0.2,43.3,43204,74.4,NULL,NULL,'UGC 08067',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102645,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102645,33.2,0.4,43.7,43204,NULL,NULL,'mean','UGC 08067',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102646,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102646,33.23,0.51,44.2,43204,NULL,NULL,NULL,'UGC 08067',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102647,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102647,33.25,0.47,44.6,43204,NULL,NULL,'H','UGC 08067',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102648,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102648,33.29,0.3,45.6,43204,55,NULL,'B','UGC 08067',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102649,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102649,33.35,0.48,46.7,43204,NULL,NULL,'Malmquist cor.','UGC 08067',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102650,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102650,33.44,0.46,48.7,43204,NULL,NULL,'J','UGC 08067',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102651,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102651,33.45,NULL,49,43204,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08067',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102652,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102652,33.45,NULL,49.1,43204,NULL,NULL,'Dipole','UGC 08067',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102653,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102653,33.46,NULL,49.1,43204,NULL,NULL,'Dipole + Quadrupole','UGC 08067',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102654,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102654,33.46,NULL,49.3,43204,NULL,NULL,NULL,'UGC 08067',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102655,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102655,33.49,0.45,49.9,43204,NULL,NULL,'K','UGC 08067',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102656,'Tully est','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102656,32.13,0.8,26.7,43205,75,NULL,NULL,'UGCA 310',NULL,'1988NBGC.C....0000T',1988,1,1.5,'2dF final data release has z = 0.10940: +- 0.00041.','G',0.000013,NULL,'16.13',1,'IB(s)m:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,194.3005,-4.15883,0.021,NULL,43148126836,674189481,10534210,16.13),(102657,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102657,32.41,0.4,30.4,43205,NULL,NULL,NULL,'UGCA 310',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102658,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102658,37.35,0.56,295,43206,70,NULL,NULL,'2MASX J12571212-1709174',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000147,NULL,'15.5V',NULL,'S0','Group member',NULL,NULL,NULL,1,194.300667,-17.15472,0.053,NULL,44018907629,687795431,10746803,15.5),(102659,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102659,32.65,1.31,33.9,43207,95,NULL,'Weighted Mean','NGC 4825',NULL,'1984ApJS...56...91D',1984,1,1.9,NULL,'G',0.00006,NULL,'12.63',1.2,'SA0-','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,194.301,-13.66483,0.037,NULL,43972851026,687075797,10735559,12.63),(102660,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102660,34.25,1.61,70.8,43207,55,NULL,'Visvanathan & Sandage 1979','NGC 4825',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102661,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102661,33.81,0.47,57.9,43207,70,NULL,NULL,'NGC 4825',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102662,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102662,34.21,0.52,69.5,43208,70,NULL,NULL,'ESO 443- G 015 NED01',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'13.64',1.2,'S0/a: pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,194.3012917,-32.51681,0.333,NULL,43467680642,679182510,10612226,13.64),(102663,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102663,37.28,0.27,285,43209,70,NULL,NULL,'2MASX J12571285+3106271',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000175,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,194.3035,31.10758,0.078,NULL,58676487772,916820121,14325314,17.1),(102664,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102664,37.89,0.46,379,43210,70,NULL,NULL,'2MASX J12571316+0738187',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.41',0.18,NULL,NULL,NULL,NULL,NULL,1,194.3047917,7.63858,0.027,NULL,58080335933,907505248,14179769,18.41),(102665,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102665,32.59,0.69,32.9,43211,100,NULL,'mid-IR','MCG -02-33-071',NULL,'2013ApJ...771...88L',2013,1,1.2,NULL,'G',0.000097,NULL,'14.64',0.7,'SB(rs)bc:',NULL,NULL,NULL,NULL,1,194.305125,-15.03656,0.049,NULL,43962488527,686913883,10733029,14.64),(102666,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102666,33.84,0.4,58.7,43211,NULL,NULL,'mean','MCG -02-33-071',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102667,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102667,33.89,0.2,60,43211,74.4,NULL,NULL,'MCG -02-33-071',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102668,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102668,34.02,0.41,63.8,43211,NULL,NULL,'Malmquist cor.','MCG -02-33-071',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102669,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102669,34.07,0.47,65.2,43211,NULL,NULL,'H','MCG -02-33-071',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102670,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102670,34.08,0.4,65.4,43211,NULL,NULL,NULL,'MCG -02-33-071',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102671,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102671,34.16,0.46,68.1,43211,NULL,NULL,'J','MCG -02-33-071',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102672,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102672,34.29,0.45,72.2,43211,NULL,NULL,'K','MCG -02-33-071',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102673,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102673,36.93,0.57,243,43212,70,NULL,NULL,'2MASX J12571506-1720504',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.000087,NULL,'15.5V',0.29,'E','Group member',NULL,NULL,NULL,1,194.3127917,-17.34725,0.097,NULL,44018936446,687795881,10746810,15.5),(102674,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102674,37.75,0.46,355,43213,70,NULL,NULL,'2MASX J12571533+1337152',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000158,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,194.3137917,13.62083,0.051,NULL,59005243002,921956921,14405576,17.5),(102675,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102675,31.64,0.4,21.3,43214,NULL,NULL,NULL,'MCG -01-33-059',NULL,'2013MNRAS.429.2677K',2013,1,1.5,NULL,'G',0.00001,NULL,'16.18',1.2,'SA(s)dm pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,194.3159583,-5.34625,0.061,NULL,43149053250,674203957,10534436,16.18),(102676,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102676,31.85,0.43,23.4,43214,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-33-059',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102677,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102677,38.12,0.46,420,43215,70,NULL,NULL,'2MASX J12571668+6538315',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000202,NULL,'16.8g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,194.319541667,65.64219,0.073,NULL,57365558417,896336850,14005263,16.8),(102678,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102678,35.31,0.05,115,43216,70,NULL,NULL,'2MASX J12571682+2737068',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00004,NULL,'16.2g',0.22,'E','Group member',NULL,NULL,NULL,1,194.3199583,27.61847,0.061,NULL,58696852910,917138326,14330286,16.2),(102679,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102679,37.59,0.33,329,43217,70,NULL,NULL,'2MASX J12571729+1803160',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,194.3219583,18.05458,0.095,NULL,59028261848,922316591,14411196,17.1),(102680,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102680,34.94,0.46,97.4,43218,70,NULL,NULL,'LCRS B125442.1-061619',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000077,NULL,'14.91',0.53,NULL,NULL,NULL,NULL,NULL,1,194.3235417,-6.5425,0.065,NULL,43130620600,673915946,10529936,14.91),(102681,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102681,38.02,0.46,402,43219,70,NULL,NULL,'2MASX J12571769-0108255',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000095,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,194.323583,-1.14058,0.025,NULL,43110396588,673599946,10524999,17.4),(102682,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102682,38.03,0.46,404,43220,70,NULL,NULL,'2MASXi J1257177+563911',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,194.3237083,56.65339,0.021,NULL,57429764567,897340071,14020938,17.6),(102683,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102683,37.39,0.46,301,43221,70,NULL,NULL,'2MASX J12571833+4816094',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000173,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,194.3262917,48.26939,0,NULL,59102501033,923476578,14429321,17.4),(102684,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102684,37.27,0.46,284,43222,70,NULL,NULL,'2MASX J12571932+1251272',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000183,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,194.3304583,12.85739,0.043,NULL,59004187231,921940425,14405319,16.6),(102685,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102685,37.58,0.46,328,43223,70,NULL,NULL,'2MASX J12571938+1105367',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.21',0.2,NULL,NULL,NULL,NULL,NULL,1,194.3307083,11.09361,0.024,NULL,58958273606,921223025,14394109,18.21),(102686,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102686,36.8,0.33,229,43224,70,NULL,NULL,'2MASX J12571959+3342251',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,194.331875,33.70689,0.008,NULL,58739638170,917806846,14340731,17.1),(102687,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102687,35.23,0.58,111,43225,70,NULL,NULL,'2MASX J12572000-2039246',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.99',NULL,NULL,NULL,NULL,NULL,NULL,1,194.33325,-20.657,0.213,NULL,43986999075,687296860,10739013,15.99),(102688,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102688,37.97,0.46,392,43226,70,NULL,NULL,'2MASX J12572021+2528318',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,194.3342917,25.47556,0.047,NULL,58689508898,917023576,14328493,17.8),(102689,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102689,37.13,0.46,266,43227,70,NULL,NULL,'2MASX J12572039+1436070',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000142,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,194.334917,14.60206,0.036,NULL,59001729363,921902021,14404719,17.6),(102690,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102690,37.02,0.46,253,43228,70,NULL,NULL,'2MASX J12572114+6128085',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000193,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,194.338167,61.46903,0,NULL,57356387562,896193555,14003024,16.2),(102691,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102691,37.02,0.57,254,43229,70,NULL,NULL,'2MASX J12572166-1547411',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.50',NULL,NULL,NULL,NULL,NULL,NULL,1,194.340333,-15.79478,0.033,NULL,44017549133,687774205,10746471,16.5),(102692,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102692,36.63,0.57,211,43230,70,NULL,NULL,'2MASX J12572253-0441095',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.000143,NULL,'15.64',0.48,NULL,NULL,NULL,NULL,NULL,1,194.3439583,-4.686,0.045,NULL,43149538533,674211539,10534555,15.64),(102693,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102693,34.63,0.62,84.3,43231,70,NULL,NULL,'2MFGC 10251',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'10.6K',NULL,NULL,NULL,NULL,NULL,NULL,1,194.3454583,-15.64867,0.033,NULL,43962195840,686909310,10732957,10.6),(102694,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102694,34.86,0.4,93.8,43232,75,NULL,'Edat, raw','NGC 4839',NULL,'1997ApJS..109..333W',1997,1,4,'The position in 1996ApJS..106....1W is 6 arcsec south of the nucleus.','G',0.000039,NULL,'13.4g',1.9,'cD;SA0','in a radial-velocity based grouping',NULL,'radio jet',NULL,1,194.3515,27.49781,0.025,NULL,58696848368,917138255,14330285,13.4),(102695,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102695,34.89,0.4,95,43232,75,NULL,'Edat, cor','NGC 4839',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102696,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102696,32.21,0.66,27.7,43232,95,NULL,'Weighted Mean','NGC 4839',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102697,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102697,32.21,0.66,27.7,43232,95,NULL,'de Vaucouleurs','NGC 4839',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102698,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102698,35.07,0.09,103,43232,70,NULL,NULL,'NGC 4839',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102699,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102699,35.09,0.22,104,43232,74.4,NULL,NULL,'NGC 4839',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102700,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102700,35.31,0.05,115,43232,70,NULL,NULL,'NGC 4839',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102701,'Tertiary','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102701,34.15,0.35,67.6,43232,95,NULL,NULL,'NGC 4839',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102702,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102702,34.85,0.45,93.2,43232,NULL,NULL,'K','NGC 4839',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102703,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102703,35.11,0.4,105,43232,NULL,NULL,'mean','NGC 4839',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102704,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102704,34.54,0.6,81.1,43233,70,NULL,NULL,'NGC 4829',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.16',0.4,'E3? or SB0-?','Group member',NULL,NULL,NULL,1,194.352,-13.7375,0.033,NULL,43972726992,687073859,10735529,16.16),(102705,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102705,37.87,0.46,375,43234,70,NULL,NULL,'SDSS J125725.16+140704.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,194.354833,14.11786,0.035,NULL,59001609832,921900153,14404689,18),(102706,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102706,36.68,0.68,216,43235,70,NULL,NULL,'2MASX J12572548-1739231',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00009,NULL,'15.4V',0.3,'S0','Group member',NULL,NULL,NULL,1,194.356291667,-17.65644,0.097,NULL,44016661760,687760340,10746255,15.4),(102707,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102707,37.28,0.27,285,43236,70,NULL,NULL,'2MASX J12572579+3120030',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000164,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,194.357375,31.33428,0.051,NULL,58676691066,916823297,14325364,17.2),(102708,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102708,35.31,0.05,115,43237,70,NULL,NULL,'CGCG 160-040',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000043,NULL,'15.5g',0.3,'SA0','Group member',NULL,NULL,NULL,1,194.357667,27.54614,0.061,NULL,58696849329,917138270,14330285,15.5),(102709,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102709,37.98,0.27,394,43238,70,NULL,NULL,'SDSS J125726.06+030332.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000092,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,194.358625,3.059,0.033,NULL,58114396206,908037440,14188085,18.3),(102710,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102710,32.92,0.5,38.4,43239,70,NULL,NULL,'ARK 396',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.00009,NULL,'14.89',0.2,'SBa',NULL,NULL,NULL,NULL,1,194.360333,-3.49089,0,NULL,43148782284,674199723,10534370,14.89),(102711,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102711,35.28,0.49,114,43240,75,NULL,'IR','UGC 08075',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000177,NULL,'16.2g',0.16,'Scd',NULL,NULL,NULL,NULL,1,194.3617083,41.47336,0,NULL,59078196365,923096818,14423387,16.2),(102712,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102712,35.38,NULL,119,43240,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08075',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102713,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102713,35.4,NULL,120,43240,NULL,NULL,'Dipole + Quadrupole','UGC 08075',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102714,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102714,35.41,NULL,121,43240,NULL,NULL,'Dipole','UGC 08075',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102715,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102715,35.43,NULL,122,43240,NULL,NULL,NULL,'UGC 08075',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102716,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102716,32.51,0.4,31.8,43241,75,NULL,'Edat, raw','NGC 4830',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.00004,NULL,'13.31',1.2,'SAB0-',NULL,NULL,NULL,NULL,1,194.3662917,-19.69128,0.165,NULL,43989566128,687336970,10739640,13.31),(102717,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102717,32.85,0.4,37.1,43241,75,NULL,'Edat, cor','NGC 4830',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102718,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102718,33.11,0.48,42,43241,70,NULL,NULL,'NGC 4830',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102719,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102719,35.31,0.05,115,43242,70,NULL,NULL,'2MASX J12572841+2810348',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000083,NULL,'15.6g',0.37,'SAB0','Group member',NULL,NULL,NULL,1,194.3684583,28.17642,0.073,NULL,58695464973,917116640,14329947,15.6),(102720,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102720,34.07,0.43,65.2,43243,NULL,NULL,'Malmquist cor.','ESO 443- G 016',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000027,NULL,'14.31',0.5,'SB(rs:)c:',NULL,NULL,NULL,NULL,1,194.369875,-28.20497,0.349,NULL,43306874483,676669913,10572967,14.31),(102721,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102721,34.23,0.2,70.2,43243,74.4,NULL,NULL,'ESO 443- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102722,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102722,34.29,0.39,72.1,43243,NULL,NULL,NULL,'ESO 443- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102723,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102723,36.05,0.54,162,43244,70,NULL,NULL,'2MASX J12572906-1756196',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000077,NULL,'14',0.3,'S0','Group member',NULL,NULL,NULL,1,194.371125,-17.93878,0.125,NULL,43984050996,687250796,10738293,14),(102724,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102724,35.95,0.53,155,43245,70,NULL,NULL,'2MASX J12572928-1824486',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.00',NULL,NULL,NULL,NULL,NULL,NULL,1,194.372083,-18.41356,0.113,NULL,43984412377,687256443,10738381,16),(102725,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102725,34.79,0.77,90.8,43246,NULL,NULL,NULL,'ESO 507- G 053',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.12',0.3,'Sb',NULL,NULL,NULL,NULL,1,194.375625,-26.01408,0.377,NULL,43303437066,676616204,10572128,16.12),(102726,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102726,34.8,0.77,91.3,43246,NULL,NULL,'Malmquist cor.','ESO 507- G 053',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102727,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102727,34.83,0.2,92.5,43246,74.4,NULL,NULL,'ESO 507- G 053',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102728,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102728,35.09,0.08,104,43247,NULL,NULL,NULL,'IC 0837',NULL,'2009ApJS..182..474S',2009,1,1.05,NULL,'G',0.000025,NULL,'15.2g',0.34,'S0/a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,194.380041667,26.51217,0.019,NULL,58700511925,917195498,14331179,15.2),(102729,'BL Lac Luminosity','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102729,39.09,NULL,576,43248,NULL,NULL,NULL,'2MASX J12573192+2412398',0.141,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',NULL,NULL,'15.4',NULL,'BLLAC',NULL,NULL,NULL,'BL Lac',1,194.383083,24.21117,0.07,NULL,58687198443,916987475,14327929,15.4),(102730,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102730,34.77,0.23,90,43249,74.4,NULL,NULL,'NGC 4841A',NULL,'2013AJ....146...86T',2013,1,1.29,'Component \'a)\' in UGC notes.','G',0.000028,NULL,'13.6g',1.11,'E+ pec','Pair member (points to parent)',NULL,NULL,NULL,1,194.383125,28.47694,0.044,NULL,58695911163,917123611,14330056,13.6),(102731,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102731,35.07,0.09,103,43249,70,NULL,NULL,'NGC 4841A',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102732,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102732,34.03,0.45,63.8,43249,NULL,NULL,'K','NGC 4841A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102733,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102733,35.1,0.4,105,43249,NULL,NULL,'mean','NGC 4841A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102734,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102734,35.15,0.23,107,43250,74.4,NULL,NULL,'NGC 4840',NULL,'2013AJ....146...86T',2013,1,0.76,NULL,'G',0.000031,NULL,'14.5g',0.69,'SAB0','Group member',NULL,NULL,NULL,1,194.386833,27.61033,0.061,NULL,58696851987,917138312,14330286,14.5),(102735,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102735,35.31,0.05,115,43250,70,NULL,NULL,'NGC 4840',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102736,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102736,34.86,0.4,93.8,43251,75,NULL,'Edat, raw','NGC 4841B',NULL,'1997ApJS..109..333W',1997,1,1.8,'Component \'b)\' in UGC notes.','G',0.000019,NULL,'14.3g',1.8,'E pec          AGN','Pair member (points to parent)',NULL,NULL,NULL,1,194.3912083,28.48225,0.044,NULL,58695911043,917123610,14330056,14.3),(102737,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102737,34.89,0.4,95,43251,75,NULL,'Edat, cor','NGC 4841B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102738,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102738,34.63,0.23,84.3,43251,74.4,NULL,NULL,'NGC 4841B',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102739,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102739,35.07,0.09,103,43251,70,NULL,NULL,'NGC 4841B',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102740,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102740,38.28,0.46,453,43252,70,NULL,NULL,'2MASX J12573389+5425428',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000142,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,194.391416667,54.42856,0.011,NULL,57423760539,897246258,14019472,17.7),(102741,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102741,36.39,0.46,189,43253,70,NULL,NULL,'MCG +08-24-013',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.0002,NULL,'15.5g',0.4,'E0',NULL,NULL,NULL,NULL,1,194.394083333,49.14881,0,NULL,59104449508,923507023,14429797,15.5),(102742,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102742,37.16,0.46,271,43254,70,NULL,NULL,'2MASX J12573485+1737571',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.39',0.15,NULL,NULL,NULL,NULL,NULL,1,194.395167,17.63264,0.116,NULL,59045629266,922587957,14415436,18.39),(102743,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102743,35.31,0.05,115,43255,70,NULL,NULL,'NGC 4842A',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000057,NULL,'13.42',0.4,'E/SA0','in a pair',NULL,NULL,NULL,1,194.399333,27.49325,0.061,NULL,58696806156,917137596,14330274,13.42),(102744,'IRAS','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102744,33.92,0.8,60.7,43256,75,NULL,'MAT, I','ESO 219- G 014',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'13.4',0.7,'SAB(r)a',NULL,NULL,NULL,NULL,1,194.4005417,-49.75119,1.053,NULL,46738314675,730286166,11410721,13.4),(102745,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102745,34.06,0.45,64.7,43256,NULL,NULL,'K','ESO 219- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102746,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102746,34.06,0.4,64.8,43256,NULL,NULL,'mean','ESO 219- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102747,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102747,34.07,0.47,65.2,43256,NULL,NULL,'H','ESO 219- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102748,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102748,34.11,0.43,66.3,43256,75,NULL,'MAT, I, raw','ESO 219- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102749,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102749,34.12,0.46,66.6,43256,NULL,NULL,'J','ESO 219- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102750,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102750,34.27,0.43,71.5,43256,75,NULL,'MAT, I, cor','ESO 219- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102751,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102751,34.49,0.32,79.2,43256,85,NULL,'I, raw','ESO 219- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102752,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102752,34.51,0.43,79.9,43256,75,NULL,'MAT, I, inv','ESO 219- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102753,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102753,34.6,0.32,83.2,43256,85,NULL,'I, inv','ESO 219- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102754,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102754,35.31,0.05,115,43257,70,NULL,NULL,'SDSS J125736.13+272905.3',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00017,NULL,'15.9g',0.26,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,194.400583,27.48481,0.061,NULL,58696802679,917137541,14330274,15.9),(102755,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102755,35.31,0.05,115,43258,70,NULL,NULL,'2MASX J12573656+2701528',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000087,NULL,'15.6g',0.42,NULL,'Group member',NULL,NULL,NULL,1,194.40225,27.03136,0.009,NULL,58697077775,917141840,14330341,15.6),(102756,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102756,32.52,0.4,32,43259,75,NULL,'Edat, raw','NGC 4831',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00009,NULL,'13.67',0.9,'SAB0-','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,194.402875,-27.29214,0.361,NULL,43309094418,676704600,10573509,13.67),(102757,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102757,32.86,0.4,37.3,43259,75,NULL,'Edat, cor','NGC 4831',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102758,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102758,32.77,0.25,35.8,43259,74.4,NULL,NULL,'NGC 4831',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102759,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102759,33.45,0.49,48.9,43259,70,NULL,NULL,'NGC 4831',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102760,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102760,33.07,0.45,41.2,43259,NULL,NULL,'K','NGC 4831',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102761,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102761,33.43,0.4,48.6,43259,NULL,NULL,'mean','NGC 4831',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102762,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102762,37.99,0.46,396,43260,70,NULL,NULL,'SDSS J125737.18+543930.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,194.404917,54.6585,0.007,NULL,57424041839,897250653,14019541,18.3),(102763,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102763,37.19,0.46,274,43261,70,NULL,NULL,'2MASX J12573988+3948349',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000146,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,194.416125,39.80972,0,NULL,59088082787,923251293,14425801,17.4),(102764,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102764,37.83,0.11,368,43262,70,NULL,NULL,'2MASX J12574049-0129321',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000066,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,194.418875,-1.49217,0.025,NULL,43111713171,673620518,10525320,17.6),(102765,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102765,35.38,0.46,119,43263,70,NULL,NULL,'CGCG 071-080',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.00006,NULL,'15.3',1,NULL,NULL,NULL,NULL,NULL,1,194.4217083,8.66531,0,NULL,58956186269,921190410,14393600,15.3),(102766,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102766,35.6,0.46,132,43264,70,NULL,NULL,'2MASX J12574139+3116309',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000087,NULL,'15.3g',0.47,NULL,NULL,NULL,NULL,NULL,1,194.422417,31.27528,0.051,NULL,58676692001,916823312,14325364,15.3),(102767,'IRAS','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102767,35.61,0.8,132,43265,75,NULL,'MAT, I','ESO 507- G 056',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.94',0.9,'Sc             HII',NULL,NULL,NULL,NULL,1,194.423833,-24.18858,0.397,NULL,43302737873,676605279,10571957,14.94),(102768,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102768,34.86,0.32,93.6,43265,85,NULL,'I, raw','ESO 507- G 056',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102769,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102769,34.91,0.32,95.9,43265,85,NULL,'I, inv','ESO 507- G 056',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102770,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102770,34.93,0.43,96.9,43265,75,NULL,'MAT, I, raw','ESO 507- G 056',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102771,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102771,35.11,0.43,105,43265,75,NULL,'MAT, I, cor','ESO 507- G 056',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102772,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102772,35.16,0.43,108,43265,75,NULL,'MAT, I, inv','ESO 507- G 056',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102773,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102773,35.38,0.51,119,43265,NULL,NULL,'Malmquist cor.','ESO 507- G 056',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102774,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102774,35.46,0.49,123,43265,NULL,NULL,NULL,'ESO 507- G 056',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102775,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102775,35.5,0.2,126,43265,74.4,NULL,NULL,'ESO 507- G 056',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102776,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102776,36.88,0.46,237,43266,70,NULL,NULL,'2MASX J12574394+1351251',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000146,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,194.433125,13.85697,0.035,NULL,59004750459,921949225,14405456,16.8),(102777,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102777,31.69,0.4,21.7,43267,75,NULL,'B','UGC 08074',NULL,'1988NBGC.C....0000T',1988,1,1.2,NULL,'G',0.000031,NULL,'14.6B',1.1,'Sm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,194.4357083,2.69175,0.024,NULL,58105848835,907903888,14185998,14.6),(102778,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102778,36.17,0.49,171,43268,75,NULL,'IR','2MFGC 10259',NULL,'2011yCatp016004901K',2011,1,0.58,NULL,'G',0.000033,NULL,'15.9V',0.24,'Sc','Group member',NULL,NULL,NULL,1,194.44425,-17.50342,0.097,NULL,44016813268,687762707,10746292,15.9),(102779,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102779,36.34,0.58,185,43268,NULL,NULL,'Malmquist cor.','2MFGC 10259',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102780,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102780,36.73,0.48,222,43268,NULL,NULL,NULL,'2MFGC 10259',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102781,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102781,36.77,0.2,226,43268,74.4,NULL,NULL,'2MFGC 10259',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102782,'Tully est','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102782,32.01,0.8,25.3,43269,75,NULL,NULL,'UGCA 311',NULL,'1988NBGC.C....0000T',1988,1,3.76,NULL,'G',0.000021,NULL,'14.24',0.32,'Sdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,194.445125,-9.63375,0.013,NULL,43841617728,685025277,10703519,14.24),(102783,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102783,31.34,0.4,18.5,43269,75,NULL,NULL,'UGCA 311',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102784,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102784,31.49,0.4,19.8,43269,NULL,NULL,NULL,'UGCA 311',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102785,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102785,31.69,0.43,21.8,43269,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 311',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102786,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102786,31.82,0.49,23.2,43269,75,NULL,'IR','UGCA 311',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102787,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102787,32.03,0.4,25.4,43269,NULL,NULL,'mean','UGCA 311',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102788,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102788,32.07,0.46,26,43269,NULL,NULL,'J','UGCA 311',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102789,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102789,32.15,0.47,27,43269,NULL,NULL,'H','UGCA 311',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102790,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102790,32.3,NULL,28.8,43269,NULL,NULL,'Dipole + Quadrupole + Octopole','UGCA 311',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102791,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102791,32.3,NULL,28.9,43269,NULL,NULL,'Dipole','UGCA 311',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102792,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102792,32.3,NULL,28.9,43269,NULL,NULL,'Dipole + Quadrupole','UGCA 311',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102793,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102793,32.32,0.45,29.2,43269,NULL,NULL,'K','UGCA 311',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102794,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102794,32.38,NULL,29.9,43269,NULL,NULL,NULL,'UGCA 311',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102795,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102795,35.31,0.05,115,43270,70,NULL,NULL,'2MASX J12574705+2908584',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000067,NULL,'15.7g',0.46,'S0','Group member',NULL,NULL,NULL,1,194.446,29.1495,0.042,NULL,58695239043,917113110,14329892,15.7),(102796,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102796,36.98,0.33,249,43271,70,NULL,NULL,'2MASX J12574724+0320554',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000091,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,194.446958333,3.34867,0.049,NULL,58115057524,908047773,14188246,16.6),(102797,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102797,37.96,0.33,391,43272,70,NULL,NULL,'2MASX J12574731+0221074',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000086,NULL,'17.7g',0.16,'NLAGN',NULL,NULL,NULL,'Sy 2',1,194.44725,2.35192,0,NULL,58088220994,907628453,14181694,17.7),(102798,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102798,32.84,0.45,37,43273,NULL,NULL,'K','NGC 4832',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.00015,NULL,'12.2',1.2,'S0^0^','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,194.4480417,-39.76169,0.409,NULL,46755793133,730559267,11414988,12.2),(102799,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102799,33.41,0.4,48.1,43273,NULL,NULL,'mean','NGC 4832',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102800,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102800,37.03,0.46,255,43274,70,NULL,NULL,'2MASX J12574752+0946476',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,194.4479583,9.77994,0.045,NULL,58956672791,921198012,14393718,17),(102801,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102801,34.24,0.4,70.5,43275,NULL,NULL,'mean','NGC 4846',NULL,'2007A&A...465...71T',2007,1,1.43,NULL,'G',0.000033,NULL,'14.2g',0.54,'Sb','Isolated galaxy',NULL,NULL,NULL,1,194.448708333,36.37072,0.014,NULL,59073600482,923025007,14422265,14.2),(102802,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102802,34.36,0.47,74.5,43275,NULL,NULL,'H','NGC 4846',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102803,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102803,34.48,0.46,78.7,43275,NULL,NULL,'J','NGC 4846',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102804,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102804,34.51,0.45,79.9,43275,NULL,NULL,'K','NGC 4846',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102805,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102805,35.57,0.46,130,43276,70,NULL,NULL,'2MASX J12574771+0825456',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.77',0.22,NULL,NULL,NULL,NULL,NULL,1,194.4487917,8.42925,0,NULL,58075406545,907428227,14178566,16.77),(102806,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102806,35.31,0.05,115,43277,70,NULL,NULL,'SDSS J125748.06+275258.9',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000173,NULL,'15.1g',0.48,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,194.4502917,27.88306,0.051,NULL,58698968062,917171375,14330802,15.1),(102807,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102807,36.82,0.63,231,43278,70,NULL,NULL,'2MASX J12574856-1756045',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00009,NULL,'16',NULL,'S0','Group member',NULL,NULL,NULL,1,194.452333333,-17.9345,0.125,NULL,43984058105,687250907,10738295,16),(102808,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102808,34.95,0.23,97.7,43279,74.4,NULL,NULL,'CGCG 160-049',NULL,'2013AJ....146...86T',2013,1,0.59,NULL,'G',0.000022,NULL,'15.48',0.47,'SB0','Group member',NULL,NULL,NULL,1,194.452791667,28.18044,0.054,NULL,58695454861,917116482,14329945,15.48),(102809,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102809,35.31,0.05,115,43279,70,NULL,NULL,'CGCG 160-049',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102810,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102810,36.19,0.52,173,43280,70,NULL,NULL,'2MASX J12574919-1732431',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000087,NULL,'14.4V',0.4,'E','Group member, 2nd ranked galaxy',NULL,NULL,NULL,1,194.455,-17.54517,0.097,NULL,44016818636,687762791,10746293,14.4),(102811,'SNIa','2016-12-15 15:15:08','2016-12-16 11:20:19','1','SN 1963C',NULL,102811,34.6,0.36,81,43281,NULL,NULL,NULL,'CGCG 160-048',NULL,'1992ApJ...390L..45P',1992,1,NULL,NULL,'GPair',0.0005,NULL,NULL,NULL,'E3?','Group member',NULL,NULL,NULL,1,194.455417,27.88111,0.051,NULL,58698968035,917171375,14330802,NULL),(102812,'SNIa','2016-12-15 15:15:08','2016-12-16 11:20:19','1','SN 1963C',NULL,102812,35,0.3,100,43281,NULL,NULL,'Photographic','CGCG 160-048',NULL,'1982ApJ...254....1A',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102813,'SNIa','2016-12-15 15:15:08','2016-12-16 11:20:19','1','SN 1963C',NULL,102813,35.05,0.2,102,43281,NULL,NULL,NULL,'CGCG 160-048',NULL,'1990ApJ...350..110C',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102814,'SNIa','2016-12-15 15:15:08','2016-12-16 11:20:19','1','SN 1963C','R',102814,35.62,NULL,133,43281,NULL,NULL,'Photographic','CGCG 160-048',NULL,'1988SSRv...48....1R',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102815,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102815,37.47,0.6,312,43282,70,NULL,NULL,'2MASX J12574931-1720330',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000107,NULL,'15.9V',0.2,'S0','Group member',NULL,NULL,NULL,1,194.455458333,-17.34261,0.101,NULL,44018797652,687793713,10746776,15.9),(102816,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102816,35.07,0.08,103,43283,NULL,NULL,NULL,'UGC 08076',NULL,'2009ApJS..182..474S',2009,1,0.94,NULL,'G',0.000008,NULL,'15.1g',0.62,'SABd:',NULL,NULL,NULL,NULL,1,194.458083333,29.65419,0.013,NULL,58674352040,916786750,14324792,15.1),(102817,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102817,36.98,0.33,249,43284,70,NULL,NULL,'2MASX J12574998+0319544',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00009,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,194.45825,3.33178,0.049,NULL,58115056675,908047760,14188246,17.1),(102818,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102818,35.31,0.05,115,43285,70,NULL,NULL,'CGCG 160-048 NED02',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00004,NULL,'16.0g',0.38,'SA0/a','Group member',NULL,NULL,NULL,1,194.4609583,27.8795,0.051,NULL,58698967746,917171371,14330802,16),(102819,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102819,38.78,0.46,570,43286,70,NULL,NULL,'SDSS J125750.82+153736.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,194.461791667,15.62694,0.011,NULL,59044865712,922576026,14415250,18.1),(102820,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102820,35.47,0.66,124,43287,70,NULL,NULL,'2MASX J12575162-1704030',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.000107,NULL,'15',0.3,'Ep','Group member',NULL,NULL,NULL,1,194.465083,-17.06758,0.061,NULL,44018792433,687793631,10746775,15),(102821,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102821,37.96,0.33,391,43288,70,NULL,NULL,'CGCG 043-081',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000108,NULL,'16.2g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,194.467667,2.35161,0,NULL,58088219265,907628426,14181694,16.2),(102822,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102822,37.29,0.46,287,43289,70,NULL,NULL,'SDSS J125753.47+020257.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000069,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,194.4727917,2.04942,0,NULL,58088924531,907639445,14181866,18),(102823,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102823,34.57,0.25,82,43290,74.4,NULL,NULL,'2MASX J12575392+2829594',NULL,'2013AJ....146...86T',2013,1,0.42,NULL,'G',0.000022,NULL,'16.0g',0.29,'E','Group member',NULL,NULL,NULL,1,194.47475,28.49981,0.044,NULL,58695918944,917123733,14330058,16),(102824,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102824,37.19,0.33,274,43291,70,NULL,NULL,'2MASX J12575469+2736574',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000083,NULL,'15.8g',0.47,'E','Group member',NULL,NULL,NULL,1,194.478083,27.61594,0.061,NULL,58698837222,917169331,14330770,15.8),(102825,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102825,38.54,0.46,510,43292,70,NULL,NULL,'SDSS J125755.24+433547.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,194.4802083,43.59647,0,NULL,59109744601,923589759,14431089,18.3),(102826,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102826,37.7,0.46,347,43293,70,NULL,NULL,'2MASX J12575556-0144161',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00004,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,194.481583333,-1.73789,0.005,NULL,43111876327,673623067,10525360,17.2),(102827,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102827,37.45,0.46,309,43294,70,NULL,NULL,'2MASX J12575597-0153201',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000074,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,194.48325,-1.88886,0.005,NULL,43112051754,673625808,10525403,17.6),(102828,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102828,34.03,0.54,64,43295,70,NULL,NULL,'NGC 4838',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000022,NULL,'14.00',1.4,'(R\')SB(r)b:',NULL,NULL,NULL,NULL,1,194.484,-13.06008,0.049,NULL,43970647947,687041374,10735021,14),(102829,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102829,33.47,0.47,49.4,43295,NULL,NULL,'H','NGC 4838',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102830,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102830,33.56,0.46,51.5,43295,NULL,NULL,'J','NGC 4838',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102831,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102831,33.57,0.45,51.7,43295,NULL,NULL,'K','NGC 4838',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102832,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102832,34.29,0.4,72,43295,NULL,NULL,'mean','NGC 4838',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102833,'SNIa','2016-12-15 15:15:08','2016-12-16 11:20:19','1','SN 1963M',NULL,102833,34.6,0.36,81,43296,NULL,NULL,NULL,'KUG 1255+283',NULL,'1992ApJ...390L..45P',1992,1,0.6,NULL,'G',0.000043,NULL,'15.7g',0.46,'Sb       Sbrst;HII','Group member',NULL,NULL,NULL,1,194.4905,28.06178,0.073,NULL,58698943101,917170985,14330796,15.7),(102834,'SNIa','2016-12-15 15:15:08','2016-12-16 11:20:19','1','SN 1963M',NULL,102834,35,0.3,100,43296,NULL,NULL,'Photographic','KUG 1255+283',NULL,'1982ApJ...254....1A',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102835,'SNIa','2016-12-15 15:15:08','2016-12-16 11:20:19','1','SN 1963M',NULL,102835,35.05,0.2,102,43296,NULL,NULL,NULL,'KUG 1255+283',NULL,'1990ApJ...350..110C',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102836,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102836,37.43,0.46,306,43297,70,NULL,NULL,'2MASX J12575811+0802499',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,194.49225,8.04708,0,NULL,58075503823,907429747,14178589,17.3),(102837,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102837,37.39,0.33,301,43298,70,NULL,NULL,'2MASX J12575836+1225419',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,194.493083,12.4285,0.057,NULL,59004242780,921941293,14405332,16.7),(102838,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102838,37.92,0.33,384,43299,70,NULL,NULL,'2MASX J12575847+0720539',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.86',0.12,NULL,NULL,NULL,NULL,NULL,1,194.493666667,7.34817,0.034,NULL,58075707579,907432930,14178639,18.86),(102839,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102839,36.4,0.46,190,43300,70,NULL,NULL,'2MASX J12575911+5215401',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000164,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,194.4962917,52.26125,0,NULL,57208960431,893890006,13967031,17.1),(102840,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102840,36.22,0.42,176,43301,NULL,NULL,NULL,'2MASX J12575986-1735230',NULL,'2009ApJS..182..474S',2009,1,0.44,NULL,'G',0.000033,NULL,'16.5V',0.2,'Sd','Group member',NULL,NULL,NULL,1,194.499583,-17.58975,0.101,NULL,44016845455,687763210,10746300,16.5),(102841,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102841,36.26,0.2,179,43301,74.4,NULL,NULL,'2MASX J12575986-1735230',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102842,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102842,36.33,0.4,185,43301,NULL,NULL,'Malmquist cor.','2MASX J12575986-1735230',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102843,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102843,33.98,0.47,62.4,43302,70,NULL,NULL,'NGC 4843',NULL,'2014MNRAS.445.2677S',2014,1,2.1,NULL,'G',0.000027,NULL,'13.96',0.5,'SA(r)0/a?',NULL,NULL,NULL,NULL,1,194.503416667,-3.62114,0,NULL,43148283046,674191922,10534248,13.96),(102844,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102844,34.31,0.49,72.8,43302,75,NULL,'IR','NGC 4843',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102845,'Tully est','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102845,30.96,0.8,15.6,43303,75,NULL,'B','NGC 4845',NULL,'1988NBGC.C....0000T',1988,1,2.39,'Identification as NGC 4910 is uncertain.','G',0.000057,NULL,'12.2g',1,'SA(s)ab sp;HII LINER','in a radial-velocity based grouping',NULL,NULL,'Sy 2',1,194.504958333,1.57583,0,NULL,58088333995,907630218,14181722,12.2),(102846,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102846,31.28,0.2,18,43303,74.4,NULL,NULL,'NGC 4845',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102847,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102847,31.3,0.43,18.2,43303,75,NULL,'3.6 micron, color corrected','NGC 4845',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102848,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102848,31.39,0.43,19,43303,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4845',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102849,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102849,31.46,0.49,19.6,43303,75,NULL,'IR','NGC 4845',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102850,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102850,31.72,0.4,22,43303,75,NULL,NULL,'NGC 4845',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102851,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102851,31.81,0.3,23.1,43303,55,NULL,'B','NGC 4845',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102852,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102852,31.81,0.4,23.1,43303,NULL,NULL,NULL,'NGC 4845',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102853,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102853,37.29,0.46,288,43304,70,NULL,NULL,'2MASX J12580179+0843329',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,194.507583,8.72586,0,NULL,58969828414,921403568,14396930,17.1),(102854,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102854,37.92,0.33,384,43305,70,NULL,NULL,'2MASX J12580237+0721479',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,194.5097917,7.36328,0.034,NULL,58075694700,907432729,14178636,17.9),(102855,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102855,35.31,0.05,115,43306,70,NULL,NULL,'CGCG 160-052',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000083,NULL,'15.4g',0.38,'S0','Group member',NULL,NULL,NULL,1,194.5132083,26.91597,0,NULL,58696541156,917133455,14330210,15.4),(102856,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102856,37.19,0.33,274,43307,70,NULL,NULL,'2MASX J12580342+2737595',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00007,NULL,'16.5g',0.26,'E','Group member',NULL,NULL,NULL,1,194.514375,27.63333,0.061,NULL,58698838195,917169346,14330771,16.5),(102857,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102857,37.7,0.46,346,43308,70,NULL,NULL,'SDSS J125804.00+225228.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'19.25',0.11,NULL,NULL,NULL,NULL,NULL,1,194.5167083,22.8745,0.094,NULL,58804651789,918822684,14356604,19.25),(102858,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102858,35.96,0.57,155,43309,70,NULL,NULL,'2MASX J12580489-1727160',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000093,NULL,'15.3V',0.3,'S0','Group member',NULL,NULL,NULL,1,194.5204583,-17.45436,0.101,NULL,44016826356,687762911,10746295,15.3),(102859,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102859,36.19,0.46,173,43310,70,NULL,NULL,'2MASX J12580526+4517195',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000167,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,194.521875,45.28886,0,NULL,59107791392,923559240,14430613,16.5),(102860,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102860,37.63,0.46,335,43311,70,NULL,NULL,'2MASX J12580554+0948339',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,194.5230417,9.8095,0.034,NULL,58956662067,921197844,14393716,17.2),(102861,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102861,34.95,0.47,97.9,43312,NULL,NULL,'H','NGC 4848',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000033,NULL,'14.3g',0.5,'SBab: sp   HII;AGN','in a radial-velocity based grouping',NULL,NULL,NULL,1,194.5235,28.24275,0.054,NULL,58695430587,917116102,14329939,14.3),(102862,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102862,35.08,0.45,104,43312,NULL,NULL,'K','NGC 4848',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102863,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102863,35.14,0.46,107,43312,NULL,NULL,'J','NGC 4848',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102864,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102864,35.16,0.4,108,43312,NULL,NULL,'mean','NGC 4848',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102865,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102865,36.81,0.46,230,43313,70,NULL,NULL,'2MASX J12580596+5105071',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000188,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,194.524917,51.08544,0,NULL,57207270011,893863593,13966618,16.7),(102866,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102866,38.91,0.46,605,43314,70,NULL,NULL,'SDSS J125806.07+032753.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000074,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,194.525333,3.46486,0.026,NULL,58115075578,908048055,14188250,18.4),(102867,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102867,38.75,0.46,561,43315,70,NULL,NULL,'SDSS J125807.09+013304.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000064,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,194.529583,1.55122,0,NULL,58088335819,907630247,14181722,18.4),(102868,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102868,37.72,0.46,350,43316,70,NULL,NULL,'2MASX J12580737+3934565',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000191,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,194.530583,39.58231,0,NULL,59088282796,923254418,14425850,17),(102869,'IRAS','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102869,31.86,0.8,23.6,43317,75,NULL,'MAT, I','NGC 4835',NULL,'1997ApJS..109..333W',1997,1,4,NULL,'G',0.000017,NULL,'12.45',0.9,'SAB:(s)b','Parent (of companion) galaxy',NULL,NULL,NULL,1,194.532667,-46.26422,0.433,NULL,46729986252,730156035,11408688,12.45),(102870,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102870,31.18,0.4,17.2,43317,75,NULL,NULL,'NGC 4835',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102871,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102871,31.18,0.39,17.2,43317,73,NULL,'IR','NGC 4835',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102872,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102872,31.52,0.36,20.1,43317,NULL,NULL,NULL,'NGC 4835',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102873,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102873,31.6,0.46,20.9,43317,NULL,NULL,'J','NGC 4835',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102874,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102874,31.61,0.47,21,43317,NULL,NULL,'H','NGC 4835',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102875,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102875,31.68,0.45,21.6,43317,NULL,NULL,'K','NGC 4835',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102876,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102876,31.72,NULL,22.1,43317,NULL,NULL,'I','NGC 4835',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102877,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102877,31.74,0.32,22.3,43317,85,NULL,'I, raw','NGC 4835',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102878,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102878,31.8,0.32,22.9,43317,85,NULL,'I, inv','NGC 4835',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102879,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102879,31.82,0.49,23.1,43317,75,NULL,'IR','NGC 4835',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102880,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102880,31.83,0.43,23.2,43317,75,NULL,'MAT, I, raw','NGC 4835',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102881,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102881,32.06,0.43,25.9,43317,75,NULL,'MAT, I, inv','NGC 4835',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102882,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102882,32.09,0.49,26.2,43317,NULL,NULL,NULL,'NGC 4835',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102883,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102883,32.13,0.2,26.7,43317,74.4,NULL,NULL,'NGC 4835',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102884,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102884,32.13,NULL,26.7,43317,NULL,NULL,'B','NGC 4835',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102885,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102885,32.21,0.43,27.7,43317,75,NULL,'MAT, I, cor','NGC 4835',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102886,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102886,32.22,0.46,27.9,43317,NULL,NULL,'Malmquist cor.','NGC 4835',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102887,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102887,32.35,0.4,29.5,43317,75,NULL,'B','NGC 4835',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102888,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102888,32.5,0.4,31.6,43317,NULL,NULL,'mean','NGC 4835',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102889,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102889,36.87,0.67,236,43318,70,NULL,NULL,'2MASX J12580879-4924243',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,194.536667,-49.40686,0.769,NULL,46739067098,730297923,11410905,17.2),(102890,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102890,37.7,0.33,346,43319,70,NULL,NULL,'2MASX J12580895-0156217',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000097,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,194.537416667,-1.9395,0,NULL,43112190672,673627979,10525437,17.8),(102891,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102891,37.83,0.11,368,43320,70,NULL,NULL,'SDSS J125809.01-013643.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000063,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,194.5375417,-1.61197,0,NULL,43111859937,673622811,10525356,17.6),(102892,'IRAS','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102892,35.19,0.8,109,43321,75,NULL,'HMCL, I','CGCG 160-058',NULL,'1997ApJS..109..333W',1997,1,1.23,NULL,'G',0.000011,NULL,'15.3g',0.33,'Sc             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,194.538458333,28.70858,0.048,NULL,58696127373,917126990,14330109,15.3),(102893,'IRAS','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102893,35.19,0.8,109,43321,75,NULL,'W91CL, r','CGCG 160-058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102894,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102894,33.73,0.43,55.6,43321,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 160-058',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102895,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102895,33.86,0.43,59.1,43321,75,NULL,'3.6 micron, color corrected','CGCG 160-058',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102896,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102896,34.02,0.2,63.7,43321,74.4,NULL,NULL,'CGCG 160-058',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102897,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102897,34.69,0.4,86.9,43321,75,NULL,'HMCL, I, raw','CGCG 160-058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102898,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102898,34.81,0.38,91.8,43321,75,NULL,'W91CL, r, raw','CGCG 160-058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102899,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102899,34.84,0.4,93.1,43321,75,NULL,'HMCL, I, inv','CGCG 160-058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102900,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102900,34.89,0.4,95.1,43321,75,NULL,'HMCL, I, cor','CGCG 160-058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102901,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102901,34.93,0.38,96.7,43321,75,NULL,'W91CL, r, inv','CGCG 160-058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102902,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102902,34.93,0.38,97,43321,75,NULL,'W91CL, r, cor','CGCG 160-058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102903,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102903,35.08,0.1,104,43321,NULL,NULL,NULL,'CGCG 160-058',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102904,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102904,36.03,0.2,161,43322,74.4,NULL,NULL,'CGCG 160-060',NULL,'2013AJ....146...86T',2013,1,0.76,NULL,'G',0.000042,NULL,'15.0g',0.33,'S?',NULL,NULL,NULL,NULL,1,194.541917,32.01653,0.037,NULL,58676446708,916819479,14325304,15),(102905,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102905,35.36,0.54,118,43323,70,NULL,NULL,'2MASX J12581048-1009280',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.79',NULL,NULL,NULL,NULL,NULL,NULL,1,194.543583,-10.158,0.097,NULL,43842017408,685031522,10703617,15.79),(102906,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102906,37.7,0.33,346,43324,70,NULL,NULL,'2MASX J12581082-0158517',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00005,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,194.545083,-1.98097,0,NULL,43112147434,673627303,10525426,17.2),(102907,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102907,37.95,0.46,389,43325,70,NULL,NULL,'2MASX J12581110+0545152',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,194.5462083,5.75431,0.023,NULL,58076456675,907444635,14178822,17.6),(102908,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102908,37.39,0.33,301,43326,70,NULL,NULL,'SDSS J125812.11+122534.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,194.550458333,12.42617,0.057,NULL,59004240752,921941261,14405332,18.3),(102909,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102909,36.8,0.33,229,43327,70,NULL,NULL,'2MASX J12581267+3335318',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000087,NULL,'15.7g',0.49,NULL,NULL,NULL,NULL,NULL,1,194.55275,33.59222,0.008,NULL,58739612069,917806438,14340725,15.7),(102910,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102910,35.31,0.05,115,43328,70,NULL,NULL,'NGC 4849',NULL,'2015arXiv151105856S',2015,1,1.7,'CGCG misprints name as \'IC 0838\'; corrected in vol III (errata).','G',0.000087,NULL,'13.85',1.3,'S0^0^:','in a pair',NULL,NULL,NULL,1,194.552833,26.39689,0.017,NULL,58701326238,917208222,14331378,13.85),(102911,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102911,34.83,0.4,92.3,43328,NULL,NULL,'mean','NGC 4849',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102912,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102912,35.1,0.45,105,43328,NULL,NULL,'K','NGC 4849',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102913,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102913,37.98,0.46,394,43329,70,NULL,NULL,'2MASX J12581422+3945475',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000175,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,194.559083,39.76342,0,NULL,59088086538,923251352,14425802,17.9),(102914,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102914,38.03,0.46,404,43330,70,NULL,NULL,'2MASX J12581501+0046332',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000079,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,194.562625,0.77586,0,NULL,58089707116,907651673,14182057,18.3),(102915,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102915,37.55,0.46,324,43331,70,NULL,NULL,'2MASX J12581519+0143222',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000079,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,194.563375,1.72292,0,NULL,58088785102,907637267,14181832,17.1),(102916,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102916,37.84,0.46,371,43332,70,NULL,NULL,'2MASX J12581520+6028133',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000111,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,194.5635,60.47042,0,NULL,57383303813,896614122,14009595,17.8),(102917,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102917,37.39,0.46,301,43333,70,NULL,NULL,'SDSS J125816.80+152029.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000153,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,194.570041667,15.34161,0.014,NULL,58999250410,921863287,14404113,18.4),(102918,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102918,31.94,0.4,24.4,43334,75,NULL,NULL,'UGC 08085',NULL,'2008Ap.....51..336K',2008,1,2.81,NULL,'G',0.00002,NULL,'14.3g',0.49,'SBcd?',NULL,NULL,NULL,NULL,1,194.572041667,14.55706,0.036,NULL,59002202907,921909420,14404834,14.3),(102919,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102919,32.21,0.6,27.7,43334,NULL,NULL,'Malmquist cor.','UGC 08085',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102920,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102920,32.3,0.2,28.8,43334,74.4,NULL,NULL,'UGC 08085',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102921,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102921,32.35,0.4,29.5,43334,NULL,NULL,NULL,'UGC 08085',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102922,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102922,32.37,0.43,29.8,43334,75,NULL,'3.6 micron, color corrected','UGC 08085',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102923,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102923,32.41,0.43,30.3,43334,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08085',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102924,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102924,32.43,0.55,30.6,43334,NULL,NULL,NULL,'UGC 08085',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102925,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102925,32.69,0.49,34.5,43334,75,NULL,'IR','UGC 08085',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102926,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102926,37.78,0.46,359,43335,70,NULL,NULL,'2MASX J12581742+2450337',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,194.572667,24.84278,0.05,NULL,58690838683,917044354,14328818,17.2),(102927,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102927,36.32,0.46,184,43336,70,NULL,NULL,'2MASX J12581769+2708117',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00009,NULL,'15.6g',0.53,'Irr','Group member',NULL,NULL,NULL,1,194.573667,27.13647,0.02,NULL,58696486632,917132603,14330196,15.6),(102928,'SNIa','2016-12-15 15:15:08','2016-12-16 11:20:19','1','SN 1968H','R',102928,36.52,NULL,201,43337,NULL,NULL,'Photographic','2MASX J12581769+2708117',NULL,'1988SSRv...48....1R',1988,1,0.7,NULL,'G',0.00009,NULL,'15.6g',0.53,'Irr','Group member',NULL,NULL,NULL,1,194.573667,27.13647,0.02,NULL,58696486632,917132603,14330196,15.6),(102929,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102929,37.46,0.46,311,43338,70,NULL,NULL,'2MASX J12581784+2501577',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,194.5745417,25.03256,0.047,NULL,58690798071,917043719,14328808,17),(102930,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102930,37.83,0.11,368,43339,70,NULL,NULL,'SDSS J125818.72-012844.6',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000086,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,194.5780417,-1.47906,0.021,NULL,43111836774,673622449,10525350,18),(102931,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102931,36.41,0.53,192,43340,70,NULL,NULL,'2MASX J12581913-1718370',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000097,NULL,'15',0.3,'S0','Group member',NULL,NULL,NULL,1,194.5794583,-17.31031,0.101,NULL,44016757846,687761841,10746278,15),(102932,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102932,38.53,0.33,509,43341,70,NULL,NULL,'2MASX J12581928+3518555',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000142,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,194.5802083,35.31536,0.034,NULL,58552530898,914883295,14295051,17.9),(102933,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102933,37.83,0.46,369,43342,70,NULL,NULL,'LCRS B125545.6-031649',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000043,NULL,'17.0g',0.28,'NLAGN',NULL,NULL,NULL,NULL,1,194.5847917,-3.55036,0.009,NULL,43148853897,674200842,10534388,17),(102934,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102934,38.05,0.27,407,43343,70,NULL,NULL,'2MASX J12582044+1234495',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000171,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,194.585291667,12.58028,0.057,NULL,59004359357,921943114,14405361,17.7),(102935,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102935,37.87,0.46,374,43344,70,NULL,NULL,'2MASX J12582059+2240046',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,194.585833,22.66794,0.108,NULL,58804469082,918819829,14356559,17.8),(102936,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102936,38.21,0.46,438,43345,70,NULL,NULL,'2MASX J12582060+6513253',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,194.586083,65.22367,0.033,NULL,57348798298,896074973,14001171,18),(102937,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102937,34.73,0.23,88.3,43346,74.4,NULL,NULL,'NGC 4850',NULL,'2013AJ....146...86T',2013,1,0.64,NULL,'G',0.00003,NULL,'15.0g',0.61,'SAB0           AGN','Group member',NULL,NULL,NULL,1,194.591,27.96772,0.051,NULL,58698937054,917170891,14330795,15),(102938,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102938,35.31,0.05,115,43346,70,NULL,NULL,'NGC 4850',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102939,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102939,33.07,0.4,41.1,43347,75,NULL,'B','UGC 08084',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.000003,NULL,'14.42',1.3,'SB(s)dm',NULL,NULL,NULL,NULL,1,194.591917,2.79231,0.024,NULL,58106006376,907906349,14186036,14.42),(102940,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102940,33.12,0.49,42.1,43347,75,NULL,'IR','UGC 08084',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102941,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102941,36.82,0.46,231,43348,70,NULL,NULL,'LCRS B125547.7-024953',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000094,NULL,'15.9g',0.45,'E;BrClG',NULL,NULL,NULL,NULL,1,194.59275,-3.10156,0.009,NULL,43148033593,674188024,10534187,15.9),(102942,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102942,34.4,0.2,75.9,43349,74.4,NULL,NULL,'UGC 08088',NULL,'2013AJ....146...86T',2013,1,1.12,NULL,'G',0.000008,NULL,'15.1g',0.4,'S',NULL,NULL,NULL,NULL,1,194.595,13.87272,0.034,NULL,59001984450,921906007,14404781,15.1),(102943,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102943,34.48,0.48,78.7,43349,NULL,NULL,NULL,'UGC 08088',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102944,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102944,34.84,0.4,93,43349,NULL,NULL,'Malmquist cor.','UGC 08088',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102945,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102945,36.03,0.64,161,43350,70,NULL,NULL,'2MASX J12582306-1615384',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,194.5960417,-16.26058,0.049,NULL,44017453301,687772707,10746448,16.4),(102946,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102946,38.05,0.27,407,43351,70,NULL,NULL,'2MASX J12582379+1234275',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,194.599125,12.57439,0.057,NULL,59004359392,921943115,14405361,17.7),(102947,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102947,38.53,0.33,509,43352,70,NULL,NULL,'SDSS J125824.17+352400.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000162,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,194.60075,35.40008,0.013,NULL,58552533331,914883333,14295052,18.7),(102948,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102948,37.44,0.46,307,43353,70,NULL,NULL,'IC 3937',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.09',0.17,NULL,NULL,NULL,NULL,NULL,1,194.603083333,18.81867,0.098,NULL,59027972583,922312071,14411126,18.09),(102949,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102949,33.64,0.49,53.5,43354,75,NULL,'IR','FGC 1529',NULL,'2011yCatp016004901K',2011,1,1.4,'The 2MASX position applies to the western end of the galaxy.','G',0.000027,NULL,'16.35',0.11,'Sd',NULL,NULL,NULL,NULL,1,194.61025,-9.03789,0.089,NULL,43852604820,685196950,10706202,16.35),(102950,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102950,34.1,NULL,66,43354,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1529',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102951,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102951,34.1,NULL,66.1,43354,NULL,NULL,'Dipole + Quadrupole','FGC 1529',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102952,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102952,34.11,NULL,66.3,43354,NULL,NULL,'Dipole','FGC 1529',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102953,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102953,34.12,NULL,66.8,43354,NULL,NULL,NULL,'FGC 1529',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102954,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102954,36.93,0.46,243,43355,70,NULL,NULL,'2MASX J12582687+0830209',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.38',0.16,NULL,NULL,NULL,NULL,NULL,1,194.6119583,8.50586,0,NULL,58961434266,921272410,14394881,18.38),(102955,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102955,37.25,0.46,282,43356,70,NULL,NULL,'2MASX J12582722-0119577',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000081,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,194.613375,-1.33275,0.013,NULL,43112311440,673629866,10525466,16.6),(102956,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102956,36.97,0.46,248,43357,70,NULL,NULL,'2MASX J12582716+5715224',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,194.613375,57.25625,0,NULL,57444396229,897568691,14024510,17.7),(102957,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102957,38.29,0.27,455,43358,70,NULL,NULL,'2MASX J12582725+5016501',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,194.613708333,50.28061,0,NULL,59104056367,923500880,14429701,17.2),(102958,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102958,37.62,0.46,335,43359,70,NULL,NULL,'2MASX J12582780+6001063',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,194.615875,60.01844,0,NULL,57382792838,896606138,14009470,17.8),(102959,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102959,29.7,0.4,8.7,43360,NULL,NULL,NULL,'MCG -02-33-075',NULL,'2013MNRAS.429.2677K',2013,1,1.1,NULL,'G',0.000031,NULL,'14.26',0.5,'S0- pec sp',NULL,NULL,NULL,NULL,1,194.6177917,-10.57692,0.093,NULL,43840402921,685006295,10703223,14.26),(102960,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102960,29.7,NULL,8.71,43360,NULL,NULL,NULL,'MCG -02-33-075',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102961,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102961,37.6,0.46,331,43361,70,NULL,NULL,'2MASX J12582839+2021476',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,194.6184583,20.36333,0.156,NULL,59038209539,922472024,14413625,17.7),(102962,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102962,36.62,0.46,211,43362,70,NULL,NULL,'2MASX J12582865+2831367',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00011,NULL,'16.4g',0.27,'S0','Group member',NULL,NULL,NULL,1,194.61925,28.52683,0.054,NULL,58695900127,917123439,14330053,16.4),(102963,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102963,37.42,0.46,305,43363,70,NULL,NULL,'2MASX J12582885+1914506',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.62',0.13,NULL,NULL,NULL,NULL,NULL,1,194.62025,19.24739,NULL,NULL,59035396643,922428072,14412938,18.62),(102964,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102964,37.53,0.46,321,43364,70,NULL,NULL,'2MASX J12582936+5741036',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000195,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,194.622125,57.68431,0,NULL,57444789510,897574836,14024606,16.4),(102965,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102965,37.81,0.46,365,43365,70,NULL,NULL,'2MASX J12582935+0612372',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.98',0.14,NULL,NULL,NULL,NULL,NULL,1,194.622417,6.21039,0.03,NULL,58077312927,907458014,14179031,18.98),(102966,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102966,34.93,0.23,96.8,43366,74.4,NULL,NULL,'CGCG 160-065',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000031,NULL,'14.7g',1,'E','Group member',NULL,NULL,NULL,1,194.625833,28.01475,0.051,NULL,58698945252,917171019,14330797,14.7),(102967,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102967,35.31,0.05,115,43366,70,NULL,NULL,'CGCG 160-065',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102968,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102968,37.38,0.33,300,43367,70,NULL,NULL,'2MASX J12583098+4737382',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,194.629041667,47.62739,0,NULL,59102750724,923480480,14429382,17),(102969,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102969,38.29,0.27,455,43368,70,NULL,NULL,'2MASX J12583121+5016111',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,194.63,50.26983,0,NULL,59104056463,923500882,14429701,18.1),(102970,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102970,35.31,0.05,115,43369,70,NULL,NULL,'2MASX J12583157+2740247',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00004,NULL,'16.5g',0.32,'E','Group member',NULL,NULL,NULL,1,194.631667,27.6735,0.061,NULL,58699125744,917173839,14330841,16.5),(102971,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102971,35.31,0.05,115,43370,70,NULL,NULL,'2MASX J12583190+2802587',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00003,NULL,'16.4g',0.29,'SAB0','Group member',NULL,NULL,NULL,1,194.6329583,28.04961,0.051,NULL,58698900183,917170315,14330786,16.4),(102972,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102972,38.09,0.33,415,43371,70,NULL,NULL,'2MASXi J1258321-014120',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00008,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,194.6339583,-1.68908,0,NULL,43111967423,673624490,10525382,17.2),(102973,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102973,37.83,0.11,368,43372,70,NULL,NULL,'2MASXi J1258322-013518',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00003,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,194.634291667,-1.58833,0,NULL,43111865993,673622906,10525357,17.9),(102974,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102974,38.05,0.27,407,43373,70,NULL,NULL,'2MASX J12583225+1237246',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,194.6345,12.62361,0.049,NULL,59004309965,921942343,14405349,17.5),(102975,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102975,37.16,0.46,270,43374,70,NULL,NULL,'2MASX J12583463+2013036',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,194.644375,20.21775,0.156,NULL,59038069275,922469832,14413591,17.1),(102976,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102976,35.96,0.81,155,43375,70,NULL,NULL,'2MASX J12583486-1820040',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,194.6452083,-18.33436,0.133,NULL,43984603848,687259435,10738428,16.8),(102977,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102977,37.83,0.11,368,43376,70,NULL,NULL,'2MASXi J1258351-013342',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000075,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,194.646583,-1.56169,0,NULL,43111864060,673622875,10525357,18.1),(102978,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102978,33.01,0.44,40,43377,95,NULL,'Weighted Mean','NGC 4853',NULL,'1984ApJS...56...91D',1984,1,0.82,NULL,'G',0.00004,NULL,'14.1g',0.61,'(R\')SA0-?      AGN','in a radial-velocity based grouping',NULL,NULL,'Sy ?',1,194.646625,27.59633,0.032,NULL,58699100036,917173438,14330834,14.1),(102979,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102979,33.11,0.63,41.9,43377,95,NULL,'Michard 1979b, c','NGC 4853',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102980,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102980,33.67,0.46,54.2,43377,95,NULL,'Michard 1979a','NGC 4853',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102981,'Tertiary','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102981,34.15,0.35,67.6,43377,95,NULL,NULL,'NGC 4853',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102982,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102982,26.04,NULL,1.61,43378,NULL,NULL,NULL,'CGCG 015-050',NULL,'2000BSAO...50....5K',2000,1,1.13,'The SDSS position is about 4 arcsec north of the center of the galaxy.','G',0.00004,NULL,'16.1g',0.21,'Sd(f)',NULL,NULL,NULL,NULL,1,194.650333333,1.70561,0,1,58088796194,907637440,14181835,16.1),(102983,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102983,32.22,NULL,27.8,43378,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 015-050',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102984,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102984,32.25,NULL,28.2,43378,NULL,NULL,'Dipole + Quadrupole','CGCG 015-050',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102985,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102985,32.29,NULL,28.7,43378,NULL,NULL,'Dipole','CGCG 015-050',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102986,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102986,36.96,0.46,247,43379,70,NULL,NULL,'I Zw 048',NULL,'2015arXiv151105856S',2015,1,0.37,'Not IC 3942.  Star superposed?  Sargent (ApJ 160,405,1970) says yes.','G',0.000156,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,194.650958333,36.13194,0.009,NULL,59073449731,923022652,14422228,16.6),(102987,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102987,38.29,0.46,455,43380,70,NULL,NULL,'2MASX J12583628+2438387',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,194.651417,24.64397,0.075,NULL,58690455747,917038371,14328724,16.9),(102988,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102988,37.83,0.11,368,43381,70,NULL,NULL,'2MASX J12583689-0147350',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000037,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,194.6537083,-1.793,0,NULL,43111960784,673624387,10525381,16.9),(102989,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102989,38.29,0.27,455,43382,70,NULL,NULL,'2MASX J12583755+5016145',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000144,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,194.656417,50.27081,0,NULL,59104086470,923501351,14429708,18.1),(102990,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102990,37.83,0.11,368,43383,70,NULL,NULL,'2MASX J12583829-0134290',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000084,NULL,'16.3g',0.39,'AGN',NULL,NULL,NULL,NULL,1,194.659417,-1.57486,0,NULL,43111817776,673622152,10525346,16.3),(102991,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102991,34.12,0.48,66.8,43384,70,NULL,NULL,'2MASX J12583870-4536384',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000077,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,194.6612917,-45.61067,0.477,NULL,46730388173,730162315,11408786,15.9),(102992,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102992,37.45,0.46,309,43385,70,NULL,NULL,'2MASX J12583927+4211063',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000176,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,194.663875,42.18492,0,NULL,59080548099,923133564,14423961,16.4),(102993,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102993,37.15,0.46,269,43386,70,NULL,NULL,'2MASXi J1258395+611219',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000152,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,194.664833333,61.20544,0,NULL,57353283933,896145061,14002266,17.5),(102994,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',102994,37.5,0.46,316,43387,70,NULL,NULL,'SDSS J125840.37+174339.4',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.5g',0.31,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,194.66825,17.72761,0.105,NULL,59045734409,922589600,14415462,16.5),(102995,'Brightest Stars','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102995,24.9,NULL,0.955,43388,NULL,NULL,'3B 2','UGC 08091',NULL,'1988A&AS...74..375A',1988,1,1.1,'VIII Zw -15\' Dec error.','G',0.00001,NULL,'14.68',1,'ImV','Possible field galaxy',NULL,NULL,NULL,1,194.6685,14.2175,0.038,1,59002322085,921911282,14404863,14.68),(102996,'Brightest Stars','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102996,25,NULL,1,43388,NULL,NULL,'red, M(V) = -4.5 mag','UGC 08091',NULL,'1993RMxAA..27..213W',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102997,'Brightest Stars','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102997,25,NULL,1,43388,NULL,NULL,'Photographic','UGC 08091',NULL,'1986PASP...98.1282M',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102998,'Brightest Stars','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102998,25.2,NULL,1.1,43388,NULL,NULL,'3B 1','UGC 08091',NULL,'1988A&AS...74..375A',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102999,'Brightest Stars','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,102999,25.25,0.36,1.12,43388,NULL,NULL,'Photographic, plus tertiary methods','UGC 08091',NULL,'1983ApJ...271..123D',1983,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103000,'Brightest Stars','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103000,25.9,NULL,1.51,43388,NULL,NULL,NULL,'UGC 08091',NULL,'1998AJ....116.2886S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103001,'Carbon Stars','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103001,26.1,NULL,1.66,43388,NULL,NULL,NULL,'UGC 08091',NULL,'1983ApJ...271...65H',1983,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103002,'Cepheids','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103002,26.45,0.07,1.95,43388,NULL,NULL,'1, R','UGC 08091',NULL,'2006MmSAI..77..299G',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103003,'Cepheids','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103003,26.69,0.06,2.18,43388,74.4,NULL,NULL,'UGC 08091',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103004,'Cepheids','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103004,26.75,0.35,2.24,43388,NULL,NULL,'1','UGC 08091',NULL,'1995AJ....109..579T',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103005,'Cepheids','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103005,26.8,NULL,2.29,43388,NULL,NULL,'HST KP Calibrated, max. D','UGC 08091',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103006,'CMD','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103006,24.95,NULL,0.977,43388,NULL,NULL,NULL,'UGC 08091',NULL,'1988A&AS...74..375A',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103007,'TRGB','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103007,26.43,0.1,1.93,43388,NULL,NULL,NULL,'UGC 08091',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103008,'TRGB','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103008,26.59,0.02,2.08,43388,NULL,NULL,'I','UGC 08091',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103009,'TRGB','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103009,26.64,0.05,2.13,43388,NULL,NULL,NULL,'UGC 08091',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103010,'TRGB','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103010,26.69,0.12,2.18,43388,NULL,NULL,'I','UGC 08091',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103011,'TRGB','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103011,26.69,0.06,2.18,43388,74.4,NULL,NULL,'UGC 08091',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103012,'TRGB','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103012,26.7,0.15,2.19,43388,NULL,NULL,NULL,'UGC 08091',NULL,'1998AJ....116.1227D',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103013,'HII region diameter','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103013,25.1,NULL,1.05,43388,NULL,NULL,'Photographic','UGC 08091',NULL,'1986PASP...98.1282M',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103014,'Magnitude','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103014,25.2,NULL,1.1,43388,NULL,NULL,'Photographic','UGC 08091',NULL,'1986PASP...98.1282M',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103015,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103015,26.17,0.4,1.7,43388,75,NULL,'B','UGC 08091',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103016,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103016,36.81,0.77,231,43389,70,NULL,NULL,'2MASX J12584078-1636234',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,194.67,-16.60644,0.065,NULL,44019137586,687799024,10746859,16.8),(103017,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103017,34.16,0.25,67.9,43390,74.4,NULL,NULL,'AM 1255-315',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000014,NULL,'15.0b',NULL,'E',NULL,NULL,NULL,NULL,1,194.674666667,-32.12172,0.373,NULL,43328261439,677004084,10578188,15),(103018,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103018,34.29,0.48,72,43390,70,NULL,NULL,'AM 1255-315',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103019,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103019,37.83,0.11,368,43391,70,NULL,NULL,'SDSS J125842.06-013935.6',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000033,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,194.6752917,-1.65989,0,NULL,43111999108,673624986,10525390,17.4),(103020,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103020,37.83,0.11,368,43392,70,NULL,NULL,'2MASX J12584256-0150530',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00006,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,194.677375,-1.84803,0,NULL,43112158913,673627483,10525429,17),(103021,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103021,35.38,0.46,119,43393,70,NULL,NULL,'2MASX J12584343+5355178',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000169,NULL,'15.4g',0.51,'E0',NULL,NULL,NULL,NULL,1,194.6809583,53.92161,0.025,NULL,57421944018,897217875,14019029,15.4),(103022,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103022,36.37,0.59,188,43394,70,NULL,NULL,'PRC B-15',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000097,NULL,'15',0.5,'SB0','Group member',NULL,NULL,NULL,1,194.6812917,-17.44697,0.117,NULL,44016803286,687762551,10746289,15),(103023,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103023,37.83,0.11,368,43395,70,NULL,NULL,'2MASX J12584396-0131180',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000074,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,194.6832917,-1.52178,0.013,NULL,43111821724,673622214,10525347,17.4),(103024,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103024,38.09,0.33,415,43396,70,NULL,NULL,'SDSS J125844.21-014139.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000076,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,194.68425,-1.69428,0,NULL,43112003503,673625054,10525391,18.3),(103025,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103025,37.98,0.46,395,43397,70,NULL,NULL,'SDSS J125844.53+094419.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,194.6855417,9.73864,0.038,NULL,58970573444,921415210,14397112,18.3),(103026,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103026,36.06,0.77,163,43398,NULL,NULL,NULL,'2MASX J12584437-1709104',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000033,NULL,'15',0.36,'Sbc','Group member',NULL,NULL,NULL,1,194.686833,-17.15278,0.117,NULL,44018770990,687793296,10746770,15),(103027,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103027,36.1,0.2,166,43398,74.4,NULL,NULL,'2MASX J12584437-1709104',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103028,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103028,36.1,0.76,166,43398,NULL,NULL,'Malmquist cor.','2MASX J12584437-1709104',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103029,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103029,36.03,0.58,161,43399,70,NULL,NULL,'2MASX J12584487-2809548',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'16.1b',0.3,'S0',NULL,NULL,NULL,NULL,1,194.687,-28.16533,0.365,NULL,43309662602,676713478,10573648,16.1),(103030,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103030,37.14,0.46,268,43400,70,NULL,NULL,'2MASX J12584644+0416533',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000183,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,194.6934583,4.28147,0.024,NULL,58115388850,908052950,14188327,16.6),(103031,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103031,36.63,0.46,211,43401,70,NULL,NULL,'2MASX J12584673+3211316',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000117,NULL,'15.6g',0.44,NULL,NULL,NULL,NULL,NULL,1,194.6947917,32.19214,0.044,NULL,58676271515,916816742,14325261,15.6),(103032,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103032,34.86,0.4,93.8,43402,75,NULL,'Edat, raw','NGC 4854',NULL,'1997ApJS..109..333W',1997,1,0.99,NULL,'G',0.000037,NULL,'14.6g',0.69,'SAB0','Group member',NULL,NULL,NULL,1,194.6975,27.67475,0.039,NULL,58699125886,917173841,14330841,14.6),(103033,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103033,34.89,0.4,95,43402,75,NULL,'Edat, cor','NGC 4854',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103034,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103034,35.31,0.05,115,43402,70,NULL,NULL,'NGC 4854',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103035,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103035,35.56,0.23,129,43402,74.4,NULL,NULL,'NGC 4854',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103036,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103036,35.38,0.4,119,43402,NULL,NULL,'mean','NGC 4854',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103037,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103037,35.84,0.45,147,43402,NULL,NULL,'K','NGC 4854',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103038,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103038,37.27,0.46,285,43403,70,NULL,NULL,'2MASX J12584729+4036309',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.61',0.18,NULL,NULL,NULL,NULL,NULL,1,194.697208333,40.60869,0,NULL,59079425257,923116019,14423687,17.61),(103039,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103039,36.9,0.46,240,43404,70,NULL,NULL,'2MASX J12584802+2850358',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000164,NULL,'17.0g',0.25,'E','Group member',NULL,NULL,NULL,1,194.700083333,28.84344,0.047,NULL,58695954986,917124296,14330067,17),(103040,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103040,31.34,0.43,18.5,43405,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-33-061',NULL,'2014MNRAS.444..527S',2014,1,1.9,NULL,'G',0.00001,NULL,'14.5',0.21,'Sm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,194.703667,-6.11289,0.057,NULL,43123671175,673807362,10528240,14.5),(103041,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103041,31.59,0.4,20.8,43405,NULL,NULL,NULL,'MCG -01-33-061',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103042,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103042,32.16,NULL,27.1,43405,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -01-33-061',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103043,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103043,32.18,NULL,27.3,43405,NULL,NULL,'Dipole + Quadrupole','MCG -01-33-061',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103044,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103044,32.2,NULL,27.5,43405,NULL,NULL,'Dipole','MCG -01-33-061',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103045,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103045,35.91,0.63,152,43406,70,NULL,NULL,'2MASX J12584926-4654334',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,194.7052083,-46.90933,0.689,NULL,46737983676,730280994,11410640,16.7),(103046,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103046,29.06,NULL,6.49,43407,NULL,NULL,NULL,'6dF J1258495-045319',NULL,'2013AJ....145..101K',2013,1,0.85,NULL,'G',0.000021,NULL,'15.26',0.36,NULL,NULL,NULL,NULL,NULL,1,194.7067917,-4.8885,0.029,NULL,43149898402,674217162,10534643,15.26),(103047,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103047,29.07,0.4,6.5,43407,NULL,NULL,NULL,'6dF J1258495-045319',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103048,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103048,35.91,0.52,152,43408,70,NULL,NULL,'2MASX J12584977-1750589',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000107,NULL,'14.2H',0.4,'E','Group member',NULL,NULL,NULL,1,194.7074583,-17.84972,0.145,NULL,43983966588,687249477,10738273,14.2),(103049,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103049,37.83,0.11,368,43409,70,NULL,NULL,'2MASX J12585063-0151110',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000069,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,194.711125,-1.85306,0,NULL,43112168806,673627637,10525431,18.2),(103050,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103050,37.83,0.11,368,43410,70,NULL,NULL,'2MASXi J1258507-013712',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000037,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,194.711541667,-1.62014,0,NULL,43111999992,673624999,10525390,17.7),(103051,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103051,35.2,0.2,110,43411,74.4,NULL,NULL,'UGC 08093',NULL,'2013AJ....146...86T',2013,1,1.02,NULL,'G',0.000003,NULL,'14.7g',0.56,'S',NULL,NULL,NULL,NULL,1,194.7119583,9.65397,0.038,NULL,58970449031,921413266,14397082,14.7),(103052,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103052,35.39,0.49,120,43412,70,NULL,NULL,'ESO 269-IG 022 NED01',NULL,'2014MNRAS.445.2677S',2014,1,1.46,NULL,'G',0.00005,NULL,'14.75',1.46,'S0',NULL,NULL,NULL,NULL,1,194.712166667,-43.87508,0.385,NULL,46762061315,730657208,11416518,14.75),(103053,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103053,37.49,0.46,315,43413,70,NULL,NULL,'2MASX J12585188+4225343',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000157,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,194.716125,42.42622,0,NULL,59080459186,923132174,14423940,17),(103054,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103054,34.65,0.23,85.1,43414,74.4,NULL,NULL,'IC 3947',NULL,'2013AJ....146...86T',2013,1,0.58,NULL,'G',0.000019,NULL,'15.4g',0.5,'SA0','Group member',NULL,NULL,NULL,1,194.717083,27.78506,0.051,NULL,58699253546,917175836,14330872,15.4),(103055,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103055,35.31,0.05,115,43414,70,NULL,NULL,'IC 3947',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103056,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103056,37.83,0.11,368,43415,70,NULL,NULL,'SDSS J125852.25-014411.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000047,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,194.7177083,-1.7365,0,NULL,43111990880,673624857,10525388,18.5),(103057,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103057,37.32,0.95,290,43416,70,NULL,NULL,'2MASX J12585237-4648204',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,194.7182917,-46.80575,0.689,NULL,46737719493,730276867,11410576,17.7),(103058,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103058,37.55,0.33,323,43417,70,NULL,NULL,'2MASX J12585238+6015202',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000147,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,194.718583,60.25572,0,NULL,57383093534,896610836,14009544,17.4),(103059,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103059,38.17,0.46,431,43418,70,NULL,NULL,'2MASX J12585268+2417299',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,194.719708333,24.29175,0.066,NULL,58690420979,917037827,14328716,17.4),(103060,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103060,37.63,0.46,336,43419,70,NULL,NULL,'2MASX J12585297+0948582',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000179,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,194.720667,9.81619,0.038,NULL,58970363140,921411924,14397061,16.8),(103061,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103061,37.83,0.11,368,43420,70,NULL,NULL,'SDSS J125853.28-013529.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000033,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,194.722,-1.59167,0,NULL,43111945536,673624149,10525377,18.2),(103062,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103062,35.31,0.05,115,43421,70,NULL,NULL,'2MASX J12585341+2807339',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000033,NULL,'15.9g',0.33,'SA0/a','Group member',NULL,NULL,NULL,1,194.722666667,28.12608,0.054,NULL,58699026259,917172285,14330816,15.9),(103063,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103063,36.36,0.33,187,43422,70,NULL,NULL,'2MASX J12585346+3724398',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000165,NULL,'16.5g',0.27,'AGN',NULL,NULL,NULL,NULL,1,194.7229583,37.411,0,NULL,59076452310,923069567,14422961,16.5),(103064,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103064,37.33,0.46,292,43423,70,NULL,NULL,'SDSS J125853.79+263307.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000164,NULL,'19.44',0.15,NULL,NULL,NULL,NULL,NULL,1,194.724125,26.55219,0.017,NULL,58700949157,917202330,14331286,19.44),(103065,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103065,37.58,0.23,328,43424,70,NULL,NULL,'LCRS B125619.4-023439',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000071,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,194.724666667,-2.84742,0.013,NULL,43143779234,674121550,10533149,17.5),(103066,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103066,35.41,0.64,121,43425,70,NULL,NULL,'2MASX J12585462-0058220',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.000083,NULL,'16.1g',0.34,'NLAGN',NULL,NULL,NULL,NULL,1,194.72775,-0.97275,0.013,NULL,43112388846,673631075,10525485,16.1),(103067,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103067,35.91,0.46,152,43425,70,NULL,NULL,'2MASX J12585462-0058220',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103068,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103068,34.86,0.4,93.8,43426,75,NULL,'Edat, raw','GIN 768',NULL,'1997ApJS..109..333W',1997,1,0.32,NULL,'G',0.000019,NULL,'16.2g',0.27,'E/SA0','Group member',NULL,NULL,NULL,1,194.7302083,27.96469,0.051,NULL,58699081465,917173147,14330830,16.2),(103069,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103069,34.89,0.4,95,43426,75,NULL,'Edat, cor','GIN 768',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103070,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103070,35.38,0.25,119,43426,74.4,NULL,NULL,'GIN 768',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103071,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103071,37.33,0.46,292,43427,70,NULL,NULL,'2MASX J12585557+1539495',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000196,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,194.731583333,15.66375,0.02,NULL,59045182060,922580969,14415327,16.2),(103072,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103072,35.16,0.12,108,43428,NULL,NULL,NULL,'IC 3949',NULL,'2009ApJS..182..474S',2009,1,1,'Position in Gallouet et al (1973A&AS...12...89G) is incorrect.','G',0.000047,NULL,'14.7g',0.2,'SA0 pec sp     AGN','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,194.733375,27.83336,0.051,NULL,58699254006,917175843,14330872,14.7),(103073,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103073,35.07,0.09,103,43429,70,NULL,NULL,'SDSS J125856.14+275801.0',NULL,'2001MNRAS.321..277C',2001,1,0.07,NULL,'G',NULL,NULL,'20.8r',0.02,NULL,NULL,NULL,NULL,NULL,1,194.7339583,27.96697,0.051,NULL,58699081395,917173146,14330830,20.8),(103074,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103074,36.36,0.33,187,43430,70,NULL,NULL,'IC 3956',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000187,NULL,'15.5g',0.51,'AGN',NULL,NULL,NULL,NULL,1,194.734917,37.39817,0,NULL,59076448577,923069509,14422961,15.5),(103075,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103075,37.38,0.33,300,43431,70,NULL,NULL,'2MASX J12585709+4739233',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,194.738,47.65642,0,NULL,59102784074,923481001,14429390,17.7),(103076,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103076,37.56,0.46,325,43432,70,NULL,NULL,'2MASX J12585727+6159391',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,194.7387083,61.99422,0.005,NULL,57356992291,896203004,14003171,17.3),(103077,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103077,36.49,0.23,198,43433,70,NULL,NULL,'CGCG 160-072',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.00009,NULL,'15.3g',0.38,'E?',NULL,NULL,NULL,NULL,1,194.7404583,31.25708,0.023,NULL,58676686408,916823225,14325362,15.3),(103078,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103078,37.57,0.23,327,43434,70,NULL,NULL,'IC 3948',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,194.7422917,24.06136,0.066,NULL,58686970835,916983919,14327873,17.3),(103079,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103079,37.83,0.11,368,43435,70,NULL,NULL,'2MASX J12585930-0155540',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00003,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,194.747167,-1.93164,0,NULL,43112094742,673626480,10525413,17.2),(103080,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103080,37.57,0.23,327,43436,70,NULL,NULL,'2MASX J12585993+2403489',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,194.7499583,24.06358,0.066,NULL,58686970249,916983910,14327873,17.2),(103081,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103081,35.52,0.55,127,43437,70,NULL,NULL,'LCRS B125625.6-022131',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.00015,NULL,'16.61',0.21,NULL,NULL,NULL,NULL,NULL,1,194.7502083,-2.62856,0.005,NULL,43143866035,674122906,10533170,16.61),(103082,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103082,34.94,0.22,97.3,43438,74.4,NULL,NULL,'GIN 767',NULL,'2013AJ....146...86T',2013,1,0.35,NULL,'G',0.000025,NULL,'16.5g',0.28,'E','Group member',NULL,NULL,NULL,1,194.7502917,27.96747,0.051,NULL,58699081075,917173141,14330830,16.5),(103083,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,NULL,103083,35.07,0.09,103,43438,70,NULL,NULL,'GIN 767',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103084,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103084,37.44,0.46,308,43439,70,NULL,NULL,'2MASX J12590105+1525386',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000177,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,194.7545,15.42747,0.02,NULL,59044407444,922568866,14415138,17),(103085,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103085,38.11,0.46,418,43440,70,NULL,NULL,'2MASX J12590133+6215206',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,194.755333,62.25572,0.005,NULL,57355718705,896183104,14002861,17.4),(103086,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103086,35.31,0.05,115,43441,70,NULL,NULL,'CGCG 160-214',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.000043,NULL,'15.0g',0.39,'S0             AGN','Group member',NULL,NULL,NULL,1,194.757583,28.22522,0.054,NULL,58695747053,917121047,14330016,15),(103087,'FP','2016-12-15 15:15:08','2016-12-16 11:20:19','1',NULL,'R',103087,37.05,0.27,257,43442,70,NULL,NULL,'2MASX J12590206+1844468',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,194.758583333,18.74644,0.098,NULL,59027940637,922311572,14411118,NULL),(103088,'TRGB','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103088,29.99,0.1,9.95,43443,74.4,NULL,NULL,'NGC 4861',NULL,'2013AJ....146...86T',2013,1,4,NULL,'G',0.000003,NULL,'12.9',1.5,'SB(s)m:;HII    Sbrst','Possible field galaxy',NULL,NULL,NULL,1,194.75975,34.85944,NULL,NULL,58737188378,917768568,14340133,12.9),(103089,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103089,29.32,NULL,7.31,43443,NULL,NULL,NULL,'NGC 4861',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103090,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103090,29.4,0.4,7.59,43443,NULL,NULL,NULL,'NGC 4861',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103091,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103091,31.25,0.4,17.8,43443,75,NULL,'B','NGC 4861',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103092,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103092,37.83,0.11,368,43444,70,NULL,NULL,'SDSS J125902.35-014209.1',NULL,'2015arXiv151105856S',2015,1,0.17,'The SDSS image may be affected by the star to the northeast.','G',0.000057,NULL,'16.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,194.759833,-1.70253,0,NULL,43111978208,673624659,10525385,16.6),(103093,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103093,36.84,0.46,234,43445,70,NULL,NULL,'2MASX J12590247+5237286',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000203,NULL,'15.7g',0.38,'E0',NULL,NULL,NULL,NULL,1,194.7605,52.62447,0.006,NULL,57209102173,893892221,13967065,15.7),(103094,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103094,35.56,0.46,130,43446,70,NULL,NULL,'2MASX J12590264+4634472',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000163,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,194.760916667,46.57986,0,NULL,59100697844,923448403,14428881,16.4),(103095,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103095,36.05,0.65,162,43447,70,NULL,NULL,'LCRS B125628.1-052741',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.00015,NULL,'14.87',0.23,NULL,NULL,NULL,NULL,NULL,1,194.764375,-5.73111,0.053,NULL,43140627289,674072301,10532379,14.87),(103096,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103096,34.86,0.4,93.8,43448,75,NULL,'Edat, raw','NGC 4860',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000007,NULL,'14.2g',1.2,'E2','Group member',NULL,NULL,NULL,1,194.76625,28.12369,0.054,NULL,58699024463,917172257,14330816,14.2),(103097,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103097,34.89,0.4,95,43448,75,NULL,'Edat, cor','NGC 4860',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103098,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103098,34.23,0.44,70.1,43448,95,NULL,'Weighted Mean','NGC 4860',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103099,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103099,34.75,0.63,89.1,43448,95,NULL,'Michard 1979b, c','NGC 4860',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103100,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103100,34.84,0.46,92.9,43448,95,NULL,'Michard 1979a','NGC 4860',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103101,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103101,35.07,0.09,103,43448,70,NULL,NULL,'NGC 4860',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103102,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103102,35.15,0.22,107,43448,74.4,NULL,NULL,'NGC 4860',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103103,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103103,35.31,0.05,115,43448,70,NULL,NULL,'NGC 4860',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103104,'Tertiary','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103104,34.15,0.35,67.6,43448,95,NULL,NULL,'NGC 4860',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103105,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103105,34.86,0.25,93.8,43449,74.4,NULL,NULL,'GIN 766',NULL,'2013AJ....146...86T',2013,1,0.16,NULL,'G',0.00002,NULL,'17.3b',0.13,'E/SA0','Group member',NULL,NULL,NULL,1,194.7660417,27.95906,0.051,NULL,58699085422,917173209,14330831,17.3),(103106,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103106,35.07,0.09,103,43449,70,NULL,NULL,'GIN 766',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103107,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103107,37.72,0.19,350,43450,70,NULL,NULL,'SDSS J125904.00+300251.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,194.766667,30.04764,0.01,NULL,58675160170,916799377,14324990,18.1),(103108,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103108,37.27,0.46,284,43451,70,NULL,NULL,'2MASX J12590431+4520172',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00019,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,194.767958333,45.33803,0.026,NULL,59107935337,923561489,14430648,17.1),(103109,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103109,37.1,0.57,264,43452,70,NULL,NULL,'2MASX J12590474-4848414',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,194.769667,-48.81147,0.861,NULL,46738863877,730294748,11410855,14.4),(103110,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103110,35.17,0.25,108,43453,74.4,NULL,NULL,'2MASX J12590475+2803019',NULL,'2013AJ....146...86T',2013,1,0.37,'SDSS DR6 has z = 0.026951 +- 0.000150.','G',0.000133,NULL,'17.3g',0.19,'SAa:','Group member',NULL,NULL,NULL,1,194.769917,28.05039,0.054,NULL,58699035049,917172422,14330819,17.3),(103111,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103111,37.51,0.71,317,43454,70,NULL,NULL,'CGCG 015-051',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.000071,NULL,'15.7g',0.39,'Sb',NULL,NULL,NULL,NULL,1,194.7709583,-3.14578,0.013,NULL,43148756229,674199316,10534364,15.7),(103112,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103112,37.58,0.23,328,43455,70,NULL,NULL,'LCRS B125630.6-022757',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000077,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,194.77125,-2.73561,0.013,NULL,43143787843,674121685,10533151,18.5),(103113,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103113,35.68,0.5,137,43456,70,NULL,NULL,'2MASX J12590595-1737559',NULL,'2014MNRAS.445.2677S',2014,1,0.92,NULL,'G',0.000033,NULL,'15.36',0.58,'Sab','Group member',NULL,NULL,NULL,1,194.774917,-17.63222,0.117,NULL,44016691424,687760803,10746262,15.36),(103114,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103114,35.9,0.43,152,43456,NULL,NULL,'Malmquist cor.','2MASX J12590595-1737559',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103115,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103115,36.13,0.39,168,43456,NULL,NULL,NULL,'2MASX J12590595-1737559',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103116,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103116,36.17,0.2,171,43456,74.4,NULL,NULL,'2MASX J12590595-1737559',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103117,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103117,35.07,0.09,103,43457,70,NULL,NULL,'IC 3955',NULL,'2001MNRAS.321..277C',2001,1,0.56,NULL,'G',0.000019,NULL,'15.1g',0.34,'SB0/a','Group member',NULL,NULL,NULL,1,194.775125,27.99669,0.054,NULL,58699083847,917173185,14330831,15.1),(103118,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103118,35.08,0.22,104,43457,74.4,NULL,NULL,'IC 3955',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103119,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103119,37.05,0.27,257,43458,70,NULL,NULL,'IC 3950',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'16.85',0.18,'Spiral',NULL,NULL,NULL,NULL,1,194.7755,18.73561,0.098,NULL,59027942044,922311594,14411118,16.85),(103120,'Tully est','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103120,31.77,0.8,22.6,43459,75,NULL,NULL,'UGCA 312',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000003,NULL,'16.6',0.9,'IAB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,194.778333,-12.22778,0.065,NULL,43970089049,687032641,10734885,16.6),(103121,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103121,30.39,0.4,12,43459,NULL,NULL,NULL,'UGCA 312',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103122,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103122,36.49,0.59,198,43460,70,NULL,NULL,'ESO 507- G 061',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000103,NULL,'16.43',0.2,'S...',NULL,NULL,NULL,NULL,1,194.7787083,-25.01297,0.437,NULL,43305226759,676644168,10572565,16.43),(103123,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103123,34.86,0.4,93.8,43461,75,NULL,'Edat, raw','IC 3957',NULL,'1997ApJS..109..333W',1997,1,0.4,NULL,'G',0.000023,NULL,'15.80',0.4,'E','Group member',NULL,NULL,NULL,1,194.781208333,27.76778,0.039,NULL,58699267557,917176055,14330875,15.8),(103124,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103124,34.89,0.4,95,43461,75,NULL,'Edat, cor','IC 3957',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103125,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103125,34.94,0.22,97.3,43461,74.4,NULL,NULL,'IC 3957',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103126,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103126,35.07,0.09,103,43461,70,NULL,NULL,'IC 3957',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103127,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103127,35.31,0.05,115,43461,70,NULL,NULL,'IC 3957',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103128,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103128,35.01,0.25,100,43462,74.4,NULL,NULL,'IC 3960',NULL,'2013AJ....146...86T',2013,1,0.49,NULL,'G',0.000033,NULL,'15.4g',0.44,'SB0            AGN','Group member',NULL,NULL,NULL,1,194.783167,27.855,0.051,NULL,58699045231,917172581,14330821,15.4),(103129,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103129,35.31,0.05,115,43462,70,NULL,NULL,'IC 3960',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103130,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103130,34.86,0.4,93.8,43463,75,NULL,'Edat, raw','IC 3959',NULL,'1997ApJS..109..333W',1997,1,0.61,NULL,'G',0.000022,NULL,'14.8g',0.61,'E','Group member',NULL,NULL,NULL,1,194.784166667,27.78414,0.039,NULL,58699267761,917176058,14330875,14.8),(103131,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103131,34.89,0.4,95,43463,75,NULL,'Edat, cor','IC 3959',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103132,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103132,35.03,0.22,101,43463,74.4,NULL,NULL,'IC 3959',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103133,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103133,35.07,0.09,103,43463,70,NULL,NULL,'IC 3959',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103134,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103134,35.31,0.05,115,43463,70,NULL,NULL,'IC 3959',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103135,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103135,37.58,0.23,328,43464,70,NULL,NULL,'LCRS B125633.6-022034',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00005,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,194.783375,-2.61247,0.005,NULL,43143747632,674121056,10533141,17.5),(103136,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103136,35.04,0.5,102,43465,70,NULL,NULL,'2MASX J12590802-1054508',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000137,NULL,'15.10',0.7,NULL,NULL,NULL,NULL,NULL,1,194.783375,-10.91408,0.093,NULL,43853676751,685213699,10706464,15.1),(103137,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103137,37.83,0.11,368,43466,70,NULL,NULL,'SDSS J125908.27-014716.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000081,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,194.7845,-1.78806,0,NULL,43111975344,673624614,10525384,17.9),(103138,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103138,36.79,0.46,228,43467,70,NULL,NULL,'2MASX J12590899+0858452',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.24',0.13,NULL,NULL,NULL,NULL,NULL,1,194.787375,8.97922,0,NULL,58970020414,921406568,14396977,18.24),(103139,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103139,37.69,0.46,345,43468,70,NULL,NULL,'LCRS B125634.6-032344',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00007,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,194.789083333,-3.66542,0.017,NULL,43148194116,674190533,10534227,18.1),(103140,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103140,37.05,0.27,257,43469,70,NULL,NULL,'IC 3951',NULL,'2015arXiv151105856S',2015,1,0.29,'The IC number includes a defect on the original Heidelberg plate.','G',NULL,NULL,'16.98',0.2,'Spiral',NULL,NULL,NULL,NULL,1,194.7925,18.76428,0.098,NULL,59027940152,922311564,14411118,16.98),(103141,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103141,35.31,0.05,115,43470,70,NULL,NULL,'2MASX J12591030+2737119',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00004,NULL,'16.0g',0.34,'E','Group member',NULL,NULL,NULL,1,194.7929583,27.61989,0.039,NULL,58699139395,917174053,14330844,16),(103142,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103142,36.15,0.46,170,43471,70,NULL,NULL,'2MASX J12591108+1030062',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'17.16',0.19,NULL,NULL,NULL,NULL,NULL,1,194.7962083,10.50167,0.032,NULL,58969246390,921394474,14396788,17.16),(103143,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103143,37.57,0.23,327,43472,70,NULL,NULL,'IC 3958',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000117,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,194.7975417,24.02228,0.068,NULL,58686964866,916983826,14327872,16.5),(103144,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103144,35.78,0.89,144,43473,70,NULL,NULL,'2MASX J12591146-1822410',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.29',0.3,'(R\'_1)SB(s)a',NULL,NULL,NULL,NULL,1,194.797667,-18.37817,0.145,NULL,43984441939,687256905,10738389,16.29),(103145,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103145,36.83,0.46,232,43474,70,NULL,NULL,'2MASX J12591183+1509556',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000192,NULL,'15.9g',0.43,NULL,NULL,NULL,NULL,NULL,1,194.7995,15.16544,0.022,NULL,58999289562,921863899,14404123,15.9),(103146,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103146,35.59,0.46,131,43475,70,NULL,NULL,'CGCG 189-006',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000073,NULL,'14.9g',0.68,NULL,NULL,NULL,NULL,NULL,1,194.801125,35.90975,0.012,NULL,59072828630,923012947,14422077,14.9),(103147,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103147,35.83,0.53,146,43476,70,NULL,NULL,'2MASX J12591227-1925428',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.97',0.4,NULL,NULL,NULL,NULL,NULL,1,194.80125,-19.42856,0.173,NULL,43989494375,687335849,10739622,15.97),(103148,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103148,34.86,0.4,93.8,43477,75,NULL,'Edat, raw','NGC 4864',NULL,'1997ApJS..109..333W',1997,1,0.6,'Shortened CGCG name may be confused with CGCG 125650+2814.5.','G',0.000007,NULL,'14.5g',0.3,'E2             PAS','Group member',NULL,NULL,NULL,1,194.804625,27.977,0.054,NULL,58699084433,917173194,14330831,14.5),(103149,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103149,34.89,0.4,95,43477,75,NULL,'Edat, cor','NGC 4864',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103150,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103150,34.97,0.23,98.6,43477,74.4,NULL,NULL,'NGC 4864',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103151,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103151,35.07,0.09,103,43477,70,NULL,NULL,'NGC 4864',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103152,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103152,37.17,0.7,272,43478,70,NULL,NULL,'2MASX J12591300-2809273',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,194.8042083,-28.15756,0.365,NULL,43310004976,676718827,10573731,15.7),(103153,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103153,36.49,0.23,198,43479,70,NULL,NULL,'2MASX J12591336+3121280',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000093,NULL,'16.0g',0.36,NULL,NULL,NULL,NULL,NULL,1,194.805625,31.35783,0.023,NULL,58677035079,916828673,14325448,16),(103154,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103154,37.2,0.46,275,43480,70,NULL,NULL,'2MASX J12591337+0707522',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.05',0.2,NULL,NULL,NULL,NULL,NULL,1,194.805666667,7.13114,0.026,NULL,58077628395,907462943,14179108,18.05),(103155,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103155,37.43,0.46,306,43481,70,NULL,NULL,'2MASX J12591350+3246260',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000146,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,194.806166667,32.77386,0.027,NULL,58671227103,916737923,14324030,17.8),(103156,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103156,34.7,0.25,87.1,43482,74.4,NULL,NULL,'IC 3963',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00003,NULL,'15.3g',0.3,'SA0','Group member',NULL,NULL,NULL,1,194.80625,27.77461,0.039,NULL,58699264927,917176014,14330875,15.3),(103157,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103157,37.62,0.46,333,43483,70,NULL,NULL,'2MASX J12591351+0855562',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000191,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,194.8062917,8.93233,0,NULL,58970026943,921406670,14396979,16.8),(103158,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103158,35.31,0.05,115,43484,70,NULL,NULL,'CGCG 160-074',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000083,NULL,'15.2g',0.47,'SA0','Group member',NULL,NULL,NULL,1,194.807125,27.40258,0.032,NULL,58698422147,917162846,14330669,15.2),(103159,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103159,35.31,0.05,115,43485,70,NULL,NULL,'CGCG 160-223',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.00003,NULL,'15.1g',0.67,'E/SA0','Group member',NULL,NULL,NULL,1,194.808,28.07625,0.054,NULL,58699032545,917172383,14330818,15.1),(103160,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103160,36.49,0.23,198,43486,70,NULL,NULL,'2MASX J12591397+3105210',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.0001,NULL,'15.5g',0.52,NULL,NULL,NULL,NULL,NULL,1,194.808167,31.08914,0.043,NULL,58676592409,916821756,14325339,15.5),(103161,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103161,37.46,0.46,310,43487,70,NULL,NULL,'2MASX J12591454+6559082',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000072,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,194.810916667,65.98564,0.041,NULL,57852095755,903938996,14124046,16.8),(103162,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103162,36.19,0.46,173,43488,70,NULL,NULL,'2MASX J12591476-0221400',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000083,NULL,'16.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,194.8115,-2.36103,0.005,NULL,43143847722,674122620,10533165,16.4),(103163,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103163,34.86,0.4,93.8,43489,75,NULL,'Edat, raw','NGC 4867',NULL,'1997ApJS..109..333W',1997,1,0.54,'Shortened CGCG name may be confused with CGCG 125648+2814.9.','G',0.00001,NULL,'15.1g',0.43,'E3','Group member',NULL,NULL,NULL,1,194.8135417,27.97072,0.054,NULL,58699087152,917173236,14330831,15.1),(103164,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103164,34.89,0.4,95,43489,75,NULL,'Edat, cor','NGC 4867',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103165,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103165,34.83,0.25,92.5,43489,74.4,NULL,NULL,'NGC 4867',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103166,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103166,35.07,0.09,103,43489,70,NULL,NULL,'NGC 4867',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103167,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103167,35.31,0.05,115,43489,70,NULL,NULL,'NGC 4867',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103168,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103168,37.94,0.46,388,43490,70,NULL,NULL,'2MASX J12591514+4935145',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000183,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,194.81325,49.58728,0,NULL,59104997325,923515583,14429930,17.3),(103169,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103169,37.36,0.46,297,43491,70,NULL,NULL,'2MASX J12591665+1406166',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000149,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,194.819333333,14.10461,0.024,NULL,59002171042,921908922,14404826,17.4),(103170,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103170,36.03,0.62,160,43492,70,NULL,NULL,'2MASX J12591688-1655329',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'16.55',0.37,NULL,'Group member',NULL,NULL,NULL,1,194.820208333,-16.92597,0.065,NULL,44018318958,687786233,10746659,16.55),(103171,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103171,37.57,0.23,327,43493,70,NULL,NULL,'2MASX J12591702+2358440',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,194.820708333,23.97892,0.076,NULL,58686964033,916983813,14327872,17.1),(103172,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103172,38.59,0.46,523,43494,70,NULL,NULL,'SDSS J125917.23+600119.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,194.821833333,60.02214,0,NULL,57382795966,896606186,14009471,18.6),(103173,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103173,37.58,0.23,328,43495,70,NULL,NULL,'LCRS B125643.2-023117',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000084,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,194.8239583,-2.79133,0.013,NULL,43143738053,674120907,10533139,17.3),(103174,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103174,33.37,0.46,47.2,43496,70,NULL,NULL,'NGC 4855',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.000063,NULL,'13.95',1.3,'(R\')SB(s)0- pec:',NULL,NULL,NULL,NULL,1,194.826875,-13.23103,0.041,NULL,43972587300,687071676,10735494,13.95),(103175,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103175,35.61,0.46,132,43497,70,NULL,NULL,'2MASX J12591897+4531304',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000156,NULL,'16.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,194.828917,45.52525,0,NULL,59100265600,923441650,14428775,16.2),(103176,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103176,34,0.44,63.1,43498,95,NULL,'Weighted Mean','NGC 4865',NULL,'1984ApJS...56...91D',1984,1,0.9,NULL,'G',0.000053,NULL,'14.3g',0.5,'E6','Group member',NULL,NULL,NULL,1,194.8327917,28.08431,0.054,NULL,58698570105,917165157,14330705,14.3),(103177,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103177,34.54,0.63,80.9,43498,95,NULL,'Michard 1979b, c','NGC 4865',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103178,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103178,34.55,0.46,81.3,43498,95,NULL,'Michard 1979a','NGC 4865',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103179,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103179,35.31,0.05,115,43498,70,NULL,NULL,'NGC 4865',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103180,'Tertiary','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103180,34.15,0.35,67.6,43498,95,NULL,NULL,'NGC 4865',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103181,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103181,34.29,0.23,72.1,43499,74.4,NULL,NULL,'GIN 763',NULL,'2013AJ....146...86T',2013,1,0.45,NULL,'G',0.00003,NULL,'16.0g',0.33,'E/SA0','Group member',NULL,NULL,NULL,1,194.8340417,27.886,0.051,NULL,58699072257,917173004,14330828,16),(103182,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103182,37.42,0.46,305,43500,70,NULL,NULL,'2MASX J12592083-0038220',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000099,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,194.83675,-0.63944,0.005,NULL,43110761824,673605653,10525088,16.3),(103183,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103183,36.37,0.48,188,43501,NULL,NULL,NULL,'2MASX J12592124-1738485',NULL,'2009ApJS..182..474S',2009,1,0.46,NULL,'G',0.000033,NULL,'16',0.22,'S','Group member',NULL,NULL,NULL,1,194.8384583,-17.64681,0.117,NULL,44016722863,687761294,10746270,16),(103184,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103184,36.38,0.48,189,43501,NULL,NULL,'Malmquist cor.','2MASX J12592124-1738485',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103185,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103185,36.41,0.2,191,43501,74.4,NULL,NULL,'2MASX J12592124-1738485',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103186,'Tully est','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103186,31.63,0.8,21.1,43502,75,NULL,'B','NGC 4856',NULL,'1988NBGC.C....0000T',1988,1,4.3,NULL,'G',0.000023,NULL,'11.49',1.2,'SB(s)0/a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,194.838625,-15.04217,0.037,NULL,43961775078,686902735,10732855,11.49),(103187,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103187,31.89,0.4,24,43502,NULL,NULL,NULL,'NGC 4856',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103188,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103188,35.07,0.09,103,43503,70,NULL,NULL,'[APS2006] J194.839920+27.88764',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'VisS',NULL,NULL,'24.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,194.839917,27.88764,0.039,NULL,58699071816,917172997,14330828,24.2),(103189,'IRAS','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103189,33.32,0.8,46,43504,75,NULL,'MAT, I','ESO 507- G 062',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'13.74',0.5,'SB(s)b?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,194.846417,-27.42722,0.389,NULL,43309459109,676710298,10573598,13.74),(103190,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103190,32.96,0.2,39.1,43504,74.4,NULL,NULL,'ESO 507- G 062',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103191,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103191,33.07,0.47,41.1,43504,NULL,NULL,'H','ESO 507- G 062',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103192,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103192,33.12,0.32,42,43504,85,NULL,'I, raw','ESO 507- G 062',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103193,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103193,33.13,0.43,42.3,43504,75,NULL,'MAT, I, raw','ESO 507- G 062',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103194,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103194,33.14,0.45,42.4,43504,NULL,NULL,'K','ESO 507- G 062',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103195,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103195,33.15,0.46,42.7,43504,NULL,NULL,'J','ESO 507- G 062',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103196,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103196,33.16,0.32,42.9,43504,85,NULL,'I, inv','ESO 507- G 062',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103197,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103197,33.18,0.44,43.3,43504,NULL,NULL,NULL,'ESO 507- G 062',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103198,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103198,33.21,0.44,43.8,43504,NULL,NULL,'Malmquist cor.','ESO 507- G 062',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103199,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103199,33.33,0.43,46.3,43504,75,NULL,'MAT, I, inv','ESO 507- G 062',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103200,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103200,33.34,0.43,46.5,43504,75,NULL,'MAT, I, cor','ESO 507- G 062',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103201,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103201,33.46,0.4,49.2,43504,NULL,NULL,'mean','ESO 507- G 062',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103202,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103202,34.55,0.49,81.5,43504,75,NULL,'IR','ESO 507- G 062',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103203,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103203,36.61,0.46,210,43505,70,NULL,NULL,'2MASX J12592189+1626247',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.66',0.16,'AGN',NULL,NULL,NULL,NULL,1,194.84125,16.44039,0.017,NULL,59046558432,922602475,14415663,17.66),(103204,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103204,35.34,0.33,117,43506,70,NULL,NULL,'CGCG 245-008',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.000077,NULL,'14.9g',0.51,'E0',NULL,NULL,NULL,NULL,1,194.84325,48.34544,0,NULL,59105553907,923524279,14430066,14.9),(103205,'BCG','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103205,37.97,0.35,362,43507,60,NULL,'ABELL 1651, BCG','2MASX J12592251-0411460',0.0842,'1980ApJ...241..486H',1980,1,0.57,NULL,'G',0.00009,NULL,'15.74',0.46,'BrClG','Brightest group member',NULL,NULL,NULL,1,194.8435417,-4.19619,0.005,NULL,43150081669,674220026,10534687,15.74),(103206,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103206,35.07,0.09,103,43508,70,NULL,NULL,'GIN 762',NULL,'2001MNRAS.321..277C',2001,1,0.36,NULL,'G',0.000027,NULL,'16.0g',0.27,'SB0','Group member',NULL,NULL,NULL,1,194.84425,27.89689,0.051,NULL,58699075326,917173051,14330828,16),(103207,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103207,35.26,0.23,113,43508,74.4,NULL,NULL,'GIN 762',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103208,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103208,35.31,0.05,115,43508,70,NULL,NULL,'GIN 762',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103209,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103209,36.44,0.46,194,43509,70,NULL,NULL,'IC 3965',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.34',0.14,'Compact',NULL,NULL,NULL,NULL,1,194.8445,18.84294,0.098,NULL,59035474697,922429292,14412957,18.34),(103210,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103210,35.97,0.16,156,43510,70,NULL,NULL,'2MASX J12592280+3849280',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000175,NULL,'17.00',0.22,'AGN',NULL,NULL,NULL,NULL,1,194.844875,38.82436,0,NULL,59074056252,923032128,14422377,17),(103211,'SZ effect','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103211,39.15,NULL,675,43511,NULL,NULL,NULL,'ABELL 1651',NULL,'2001ApJ...555L..11M',2001,1,NULL,NULL,'GClstr',0.00019,NULL,NULL,NULL,'I-II   [BM]',NULL,NULL,NULL,NULL,1,194.839583,-4.19472,0.005,NULL,43150081819,674220028,10534687,NULL),(103212,'SZ effect','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103212,39.37,NULL,749,43511,NULL,NULL,NULL,'ABELL 1651',NULL,'2005ApJ...625..108D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103213,'BCG','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103213,37.97,0.35,362,43511,60,NULL,NULL,'ABELL 1651',0.0842,'1980ApJ...241..486H',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103214,'Tully est','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103214,32.03,0.8,25.5,43512,75,NULL,NULL,'ESO 219- G 016',NULL,'1988NBGC.C....0000T',1988,1,2.1,'A-M +30\' Dec error.','G',0.000021,NULL,'16.52',1.2,'IB(s)m',NULL,NULL,NULL,NULL,1,194.845833,-49.62222,1.069,NULL,46739053435,730297709,11410901,16.52),(103215,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103215,35.07,0.09,103,43513,70,NULL,NULL,'[ANM98] +4.15+1.35',NULL,'2001MNRAS.321..277C',2001,1,NULL,'NED calculated pos. uncertain. See Adami (1998,A&A,334,765).','G',0.0014,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,194.845833,27.91278,0.051,NULL,58699073308,917173020,14330828,NULL),(103216,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103216,37.72,0.19,350,43514,70,NULL,NULL,'2MASX J12592326+2958558',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000169,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,194.8469583,29.98231,0,NULL,58675128260,916798879,14324982,18),(103217,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103217,34.86,0.4,93.8,43515,75,NULL,'Edat, raw','NGC 4869',NULL,'1997ApJS..109..333W',1997,1,0.7,'One of two 6cm sources associated with [WB92] 1256+2811','G',0.00003,NULL,'14.5g',0.7,'E3             PAS','Group member',NULL,'radio jet',NULL,1,194.847333,27.91158,0.051,NULL,58699073309,917173020,14330828,14.5),(103218,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103218,34.89,0.4,95,43515,75,NULL,'Edat, cor','NGC 4869',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103219,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103219,35.09,0.44,104,43515,95,NULL,'Weighted Mean','NGC 4869',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103220,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103220,35.6,0.46,132,43515,95,NULL,'Michard 1979a','NGC 4869',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103221,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103221,36.03,0.63,161,43515,95,NULL,'Michard 1979b, c','NGC 4869',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103222,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103222,34.88,0.22,94.6,43515,74.4,NULL,NULL,'NGC 4869',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103223,'Tertiary','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103223,34.15,0.35,67.6,43515,95,NULL,NULL,'NGC 4869',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103224,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103224,37.99,0.46,395,43516,70,NULL,NULL,'2MASX J12592374+0759382',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.55',0.16,NULL,NULL,NULL,NULL,NULL,1,194.848833333,7.994,0.011,NULL,58075558004,907430593,14178603,18.55),(103225,'SNIa','2016-12-15 15:15:08','2016-12-16 11:20:20','1','SN 2006cj',NULL,103225,37,0.16,235,43517,74.2,NULL,'SALT 2','2MASX J12592407+2820498',0.067517,'2010ApJ...716..712A',2010,1,0.29,NULL,'G',0.000087,NULL,'17.2g',0.21,'SAc','Group member',NULL,NULL,NULL,1,194.8505417,28.34717,0.056,NULL,58695809905,917122029,14330031,17.2),(103226,'SNIa','2016-12-15 15:15:08','2016-12-16 11:20:20','1','SN 2006cj','R',103226,37.38,0.07,299,43517,NULL,NULL,'MLCS2k2, R(V) = 1.8','2MASX J12592407+2820498',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103227,'SNIa','2016-12-15 15:15:08','2016-12-16 11:20:20','1','SN 2006cj','R',103227,37.42,0.07,305,43517,NULL,NULL,'MLCS2k2, R(V) = 3.1','2MASX J12592407+2820498',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103228,'SNIa','2016-12-15 15:15:08','2016-12-16 11:20:20','1','SN 2006cj',NULL,103228,37.78,0.13,336,43517,65,NULL,'MLCS17','2MASX J12592407+2820498',0.067517,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103229,'SNIa','2016-12-15 15:15:08','2016-12-16 11:20:20','1','SN 2006cj',NULL,103229,37.78,0.16,338,43517,65,NULL,'SALT','2MASX J12592407+2820498',0.067517,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103230,'SNIa','2016-12-15 15:15:08','2016-12-16 11:20:20','1','SN 2006cj',NULL,103230,37.82,0.13,344,43517,65,NULL,'MLCS31','2MASX J12592407+2820498',0.067517,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103231,'SNIa','2016-12-15 15:15:08','2016-12-16 11:20:20','1','SN 2006cj',NULL,103231,37.87,0.18,351,43517,65,NULL,'SALT2','2MASX J12592407+2820498',0.067517,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103232,'SNIa','2016-12-15 15:15:08','2016-12-16 11:20:20','1','SN 2006cj',NULL,103232,37.9,0.18,357,43517,73.8,NULL,'SALT 2 (SNANA)','2MASX J12592407+2820498',0.0684,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103233,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103233,35.23,0.25,111,43518,74.4,NULL,NULL,'2MASX J12592491+2744198',NULL,'2013AJ....146...86T',2013,1,0.48,NULL,'G',0.000033,NULL,'15.9g',0.25,'SA0','Group member',NULL,NULL,NULL,1,194.853875,27.73886,0.039,NULL,58699274429,917176162,14330877,15.9),(103234,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103234,35.31,0.05,115,43518,70,NULL,NULL,'2MASX J12592491+2744198',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103235,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103235,35.97,0.16,156,43519,70,NULL,NULL,'IC 3987',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000187,NULL,'15.6g',0.47,NULL,NULL,NULL,NULL,NULL,1,194.854333333,38.73344,0,NULL,59074570026,923040156,14422502,15.6),(103236,'SNIa','2016-12-15 15:15:08','2016-12-16 11:20:20','1','SN 2010ai',NULL,103236,35.15,0.21,105,43520,73.8,NULL,'SALT 2 (SNANA)','SDSS J125925.04+275948.2',0.0195,'2014ApJ...795...44R',2014,1,0.24,NULL,'G',0.000123,NULL,'17.8g',0.21,'E','Group member',NULL,NULL,NULL,1,194.854375,27.99675,0.054,NULL,58699078978,917173109,14330829,17.8),(103237,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103237,36.64,0.46,213,43521,70,NULL,NULL,'2MASX J12592507+1546577',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,194.854583,15.78286,0.033,NULL,59045313320,922583020,14415359,17.6),(103238,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103238,35.46,0.25,124,43522,74.4,NULL,NULL,'2MASX J12592529+2758048',NULL,'2013AJ....146...86T',2013,1,0.25,NULL,'G',0.00004,NULL,'16.6b',0.2,'SA0','Group member',NULL,NULL,NULL,1,194.8555417,27.96794,0.054,NULL,58699078447,917173100,14330829,16.6),(103239,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103239,35.04,0.25,102,43523,74.4,NULL,NULL,'IC 3968',NULL,'2013AJ....146...86T',2013,1,0.41,NULL,'G',0.000007,NULL,'16.2g',0.25,'SA0','Group member',NULL,NULL,NULL,1,194.856208333,27.97319,0.054,NULL,58699078013,917173093,14330829,16.2),(103240,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103240,37.66,0.46,340,43524,70,NULL,NULL,'2MASX J12592567+2607208',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,194.857125,26.12256,0.026,NULL,58701167248,917205738,14331339,17.7),(103241,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103241,36.19,0.46,173,43525,70,NULL,NULL,'2MASX J12592623+1420297',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000183,NULL,'15.6g',0.51,NULL,NULL,NULL,NULL,NULL,1,194.8592917,14.34169,0.037,NULL,59001439228,921897487,14404648,15.6),(103242,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103242,37.51,0.46,317,43526,70,NULL,NULL,'2MASX J12592649+2050311',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,194.860333,20.84192,0.129,NULL,59036174956,922440233,14413128,16.6),(103243,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103243,35.1,0.23,105,43527,74.4,NULL,NULL,'2MASX J12592657+2759548',NULL,'2013AJ....146...86T',2013,1,0.34,NULL,'G',0.000019,NULL,'16.4g',0.28,'SB0','Group member',NULL,NULL,NULL,1,194.8607917,27.99847,0.054,NULL,58699076263,917173066,14330829,16.4),(103244,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103244,37.54,0.46,322,43528,70,NULL,NULL,'2MASX J12592664-0137240',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000078,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,194.861167,-1.62344,0,NULL,43111506682,673617291,10525270,17.5),(103245,'Tully est','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103245,31.02,0.8,16,43529,75,NULL,'B','NGC 4866',NULL,'1988NBGC.C....0000T',1988,1,6.3,NULL,'G',0.000017,NULL,'12.14',1.3,'SB(rs)bc;HII   Sbrst','Group member',NULL,NULL,NULL,1,194.863083,14.17106,0.024,NULL,59002148586,921908571,14404821,12.14),(103246,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103246,32.07,0.34,25.9,43529,NULL,NULL,'Malmquist cor.','NGC 4866',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103247,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103247,32.35,0.29,29.5,43529,NULL,NULL,NULL,'NGC 4866',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103248,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103248,32.36,0.4,29.7,43529,75,NULL,NULL,'NGC 4866',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103249,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103249,32.46,0.2,31.1,43529,74.4,NULL,NULL,'NGC 4866',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103250,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103250,32.47,0.49,31.1,43529,75,NULL,'IR','NGC 4866',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103251,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103251,37.5,0.46,316,43530,70,NULL,NULL,'2MASX J12592716+6820592',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000078,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,194.863083,68.34989,0.029,NULL,57853177710,903955901,14124310,17.6),(103252,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103252,36.9,0.46,240,43531,70,NULL,NULL,'2MASX J12592724-0125510',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000066,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,194.8635,-1.43067,0.017,NULL,43112595752,673634308,10525536,17.9),(103253,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103253,37.03,0.69,254,43532,70,NULL,NULL,'2MASX J12592740-1920278',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.2I',0.4,NULL,NULL,NULL,NULL,NULL,1,194.86425,-19.34103,0.173,NULL,43986034444,687281788,10738777,14.2),(103254,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103254,36.43,0.53,193,43533,70,NULL,NULL,'2MASX J12592776-1919378',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.06',NULL,NULL,NULL,NULL,NULL,NULL,1,194.865666667,-19.32742,0.173,NULL,43986034267,687281785,10738777,16.06),(103255,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103255,35.97,0.16,156,43534,70,NULL,NULL,'2MASX J12592802+3851010',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000158,NULL,'16.7g',0.21,'AGN',NULL,NULL,NULL,NULL,1,194.866625,38.85019,0,NULL,59074547911,923039811,14422497,16.7),(103256,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103256,35.75,0.63,141,43535,70,NULL,NULL,'2MASX J12592963-0523440',NULL,'2014MNRAS.445.2677S',2014,1,0.69,NULL,'G',0.00015,NULL,'16.09',0.28,NULL,NULL,NULL,NULL,NULL,1,194.8735,-5.39564,0.033,NULL,43140717827,674073716,10532401,16.09),(103257,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103257,37.72,0.19,350,43536,70,NULL,NULL,'2MASX J12593012+2959125',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000177,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,194.8755,29.98681,0,NULL,58675131506,916798929,14324983,17.3),(103258,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103258,34.32,0.23,73.1,43537,74.4,NULL,NULL,'GIN 760',NULL,'2013AJ....146...86T',2013,1,0.31,'Smith, et al. (2000MNRAS.313..469S) give v = 6478 +/- 6 km/sec.','G',0.00002,NULL,'16.5g',0.29,'E','Group member',NULL,NULL,NULL,1,194.8777083,27.79142,0.039,NULL,58699271984,917176124,14330876,16.5),(103259,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103259,35.07,0.09,103,43537,70,NULL,NULL,'GIN 760',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103260,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103260,34.26,0.59,71.2,43538,NULL,NULL,NULL,'NGC 4862',NULL,'2009ApJS..182..474S',2009,1,1,'IC identification is not certain.','G',0.000133,NULL,'15.31',0.8,'SB(s)c',NULL,NULL,NULL,NULL,1,194.878417,-14.13233,0.045,NULL,43969858730,687029042,10734828,15.31),(103261,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103261,34.27,0.59,71.3,43538,NULL,NULL,'Malmquist cor.','NGC 4862',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103262,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103262,34.3,0.2,72.4,43538,74.4,NULL,NULL,'NGC 4862',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103263,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103263,34.83,0.25,92.5,43539,74.4,NULL,NULL,'IC 3973',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000022,NULL,'14.9g',0.5,'S0/a','Group member',NULL,NULL,NULL,1,194.878417,27.88422,0.039,NULL,58699066875,917172919,14330826,14.9),(103264,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103264,35.07,0.09,103,43539,70,NULL,NULL,'IC 3973',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103265,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103265,36.55,0.46,204,43540,70,NULL,NULL,'VII Zw 494',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000152,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,194.879,61.16419,0,NULL,57353419899,896147185,14002299,16.9),(103266,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103266,35.14,NULL,106,43541,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08104',NULL,'2010Ap&SS.325..163P',2010,1,1.07,NULL,'G',0.000185,NULL,'16.9g',0.16,'Scd',NULL,NULL,NULL,NULL,1,194.885375,42.75894,0,NULL,59080454946,923132108,14423939,16.9),(103267,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103267,35.15,NULL,107,43541,NULL,NULL,'Dipole + Quadrupole','UGC 08104',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103268,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103268,35.16,NULL,108,43541,NULL,NULL,'Dipole','UGC 08104',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103269,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103269,35.19,NULL,109,43541,NULL,NULL,NULL,'UGC 08104',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103270,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103270,38.09,0.46,415,43542,70,NULL,NULL,'SDSS J125932.68+364249.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,194.886208333,36.71367,0,NULL,59073040346,923016255,14422128,18.5),(103271,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103271,34.89,0.44,95.1,43543,95,NULL,'Weighted Mean','NGC 4873',NULL,'1984ApJS...56...91D',1984,1,0.67,NULL,'G',0.000007,NULL,'15.1g',0.45,'SA0','Group member',NULL,NULL,NULL,1,194.886625,27.98361,0.054,NULL,58699059692,917172807,14330825,15.1),(103272,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103272,35.43,0.46,122,43543,95,NULL,'Michard 1979a','NGC 4873',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103273,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103273,35.72,0.63,139,43543,95,NULL,'Michard 1979b, c','NGC 4873',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103274,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103274,34.73,0.25,88.3,43543,74.4,NULL,NULL,'NGC 4873',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103275,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103275,35.31,0.05,115,43543,70,NULL,NULL,'NGC 4873',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103276,'Tertiary','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103276,34.15,0.35,67.6,43543,95,NULL,NULL,'NGC 4873',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103277,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103277,37.71,0.46,348,43544,70,NULL,NULL,'2MASX J12593367+1704298',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,194.890458333,17.07494,0.065,NULL,59046107293,922595426,14415553,17.9),(103278,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103278,34.86,0.4,93.8,43545,75,NULL,'Edat, raw','NGC 4872',NULL,'1997ApJS..109..333W',1997,1,0.6,NULL,'G',0.000007,NULL,'15.2g',0.37,'SB0            AGN','Group member',NULL,NULL,NULL,1,194.891833333,27.94694,0.05,NULL,58699061209,917172831,14330825,15.2),(103279,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103279,34.89,0.4,95,43545,75,NULL,'Edat, cor','NGC 4872',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103280,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103280,34.93,0.23,96.8,43545,74.4,NULL,NULL,'NGC 4872',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103281,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103281,35.27,0.51,113,43546,70,NULL,NULL,'ESO 575- G 042',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000083,NULL,'14.63',0.5,'SAB?(r)a',NULL,NULL,NULL,NULL,1,194.892208333,-21.09664,0.233,NULL,43974615650,687103369,10735990,14.63),(103282,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103282,38.41,0.33,482,43547,70,NULL,NULL,'SDSS J125934.34+175430.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,194.893125,17.90856,0.099,NULL,59028342646,922317853,14411216,18.4),(103283,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103283,37.46,0.46,311,43548,70,NULL,NULL,'2MASX J12593463+2128081',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,194.8942083,21.46894,0.131,NULL,59025151087,922267985,14410437,18.2),(103284,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103284,37.94,0.46,387,43549,70,NULL,NULL,'2MASX J12593523+2250121',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,194.896833,22.83664,0.108,NULL,58807964312,918874442,14357413,17.5),(103285,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103285,35.22,0.73,111,43550,70,NULL,NULL,'2MASX J12593528-1832348',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.23',0.2,NULL,NULL,NULL,NULL,NULL,1,194.897083,-18.54331,0.145,NULL,43984436771,687256824,10738387,16.23),(103286,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103286,35.31,0.05,115,43551,70,NULL,NULL,'KUG 1257+288A',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.00011,NULL,'15.8g',0.3,'S0','Group member',NULL,NULL,NULL,1,194.898625,28.55136,0.054,NULL,58695820911,917122201,14330034,15.8),(103287,'GCLF','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103287,34.8,0.1,91,43552,NULL,NULL,'I','NGC 4874',NULL,'2016ApJ...819...77L',2016,1,1.9,'One of two 6cm sources associated with [WB92] 1256+2811','G',0.00001,NULL,'12.7b',1.9,'cD;Di','in a radial-velocity based grouping',NULL,'radio jet',NULL,1,194.8987917,27.95928,0.05,NULL,58699063106,917172861,14330825,12.7),(103288,'GCLF','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103288,34.8,0.09,91,43552,NULL,NULL,'Mean of GCs in N4874, N4889, N4921, and N4923','NGC 4874',NULL,'2016ApJ...819...77L',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103289,'GCLF','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103289,35.01,0.15,100,43552,NULL,NULL,NULL,'NGC 4874',NULL,'2009AJ....137.3314H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103290,'GCLF','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103290,35.15,0.12,107,43552,NULL,NULL,NULL,'NGC 4874',NULL,'2002ApJ...567..294O',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103291,'PNLF','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103291,34.9,NULL,97.7,43552,NULL,NULL,'Coma Cluster','NGC 4874',NULL,'2013IAUS..289..287A',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103292,'SBF','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103292,34.91,0.11,96,43552,NULL,NULL,'H','NGC 4874',NULL,'2015AAS...22525305J',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103293,'SBF','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103293,34.99,0.21,99.5,43552,NULL,NULL,'K','NGC 4874',NULL,'2001ApJ...557L..31L',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103294,'BCG','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103294,34.89,0.35,92.9,43552,60,NULL,'Coma Cluster, ABELL 1656, BCG','NGC 4874',0.023,'1980ApJ...241..486H',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103295,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103295,34.66,0.48,85.4,43552,NULL,NULL,'assume Virgo m-M = 31.00 mag','NGC 4874',NULL,'1987ApJ...313...42D',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103296,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103296,34.73,0.48,88.4,43552,NULL,NULL,'assume Virgo m-M = 31.00 mag + Fornx m-M = 31.21 mg','NGC 4874',NULL,'1987ApJ...313...42D',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103297,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103297,34.76,NULL,89.5,43552,NULL,NULL,'Coma vs. Virgo m-M = 31.31 mag','NGC 4874',NULL,'1997MNRAS.289..847D',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103298,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103298,34.86,NULL,93.8,43552,NULL,NULL,'Coma vs. Virgo m-M = 31.31 mag, Aperture cor.','NGC 4874',NULL,'1997MNRAS.289..847D',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103299,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103299,34.86,0.4,93.8,43552,75,NULL,'Edat, raw','NGC 4874',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103300,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103300,34.89,0.4,95,43552,75,NULL,'Edat, cor','NGC 4874',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103301,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103301,34.89,0.15,95,43552,NULL,NULL,'Coma Cluster, 81 galaxies','NGC 4874',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103302,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103302,34.9,0.13,95.5,43552,NULL,NULL,'Coma cluster','NGC 4874',NULL,'1997NewA....1..363G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103303,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103303,35.05,0.05,102,43552,72,NULL,'Coma Cluster, 80 galaxies','NGC 4874',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103304,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103304,33.66,0.47,54,43552,95,NULL,'de Vaucouleurs','NGC 4874',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103305,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103305,33.95,0.32,61.7,43552,95,NULL,'Weighted Mean','NGC 4874',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103306,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103306,34.51,0.46,79.8,43552,95,NULL,'Michard 1979a','NGC 4874',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103307,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103307,34.76,0.12,89.5,43552,NULL,NULL,'Coma vs. Virgo m-M = 31.00 mag','NGC 4874',NULL,'1986MNRAS.222..417L',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103308,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103308,35.19,0.21,109,43552,NULL,NULL,'for m-M(Coma-Leo) = 4.73 mag','NGC 4874',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103309,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103309,35.21,0.21,110,43552,NULL,NULL,'for D(Coma)/D(Leo) = 8.84','NGC 4874',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103310,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103310,35.22,0.63,111,43552,95,NULL,'Michard 1979b, c','NGC 4874',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103311,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103311,35.35,0.34,117,43552,NULL,NULL,'for m-M(Coma-Leo) = 4.89 mag','NGC 4874',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103312,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103312,34.67,0.14,85.8,43552,NULL,NULL,'Coma Cluster, 81 galaxies','NGC 4874',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103313,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103313,34.76,NULL,89.5,43552,NULL,NULL,'Coma vs. Virgo m-M = 31.31 mag','NGC 4874',NULL,'1997MNRAS.289..847D',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103314,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103314,34.77,0.14,90,43552,NULL,NULL,'Coma Cluster, 81 galaxies','NGC 4874',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103315,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103315,34.82,0.22,92,43552,74.4,NULL,NULL,'NGC 4874',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103316,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103316,34.86,NULL,93.8,43552,NULL,NULL,'Coma vs. Virgo m-M = 31.31 mag, Aperture cor.','NGC 4874',NULL,'1997MNRAS.289..847D',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103317,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103317,34.91,0.05,96,43552,75,NULL,'Coma Cluster, 71 galaxies','NGC 4874',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103318,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103318,34.91,0.05,96,43552,75,NULL,'Coma cluster, 71 galaxies','NGC 4874',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103319,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103319,34.92,0.65,96.4,43552,NULL,NULL,'assume Virgo m-M = 31.00 mag + Fornx m-M = 31.21 mg','NGC 4874',NULL,'1987ApJ...313...42D',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103320,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103320,35,0.65,99.9,43552,NULL,NULL,'assume Virgo m-M = 31.00 mag','NGC 4874',NULL,'1987ApJ...313...42D',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103321,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103321,35.07,0.09,103,43552,70,NULL,NULL,'NGC 4874',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103322,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103322,35.17,0.23,108,43552,NULL,NULL,'Coma cluster','NGC 4874',NULL,'1997ApJ...482...68H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103323,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103323,35.31,0.05,115,43552,70,NULL,NULL,'NGC 4874',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103324,'Magnitude','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103324,34.34,NULL,73.8,43552,NULL,NULL,'assume Virgo m-M = 31.00 mag','NGC 4874',NULL,'1989ApJ...342..617G',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103325,'Magnitude','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103325,35.34,NULL,117,43552,NULL,NULL,'Coma cluster','NGC 4874',NULL,'1995A&A...302...21G',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103326,'Tertiary','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103326,34.15,0.35,67.6,43552,95,NULL,NULL,'NGC 4874',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103327,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103327,34.66,NULL,85.6,43552,71,NULL,'Coma Cluster, 68 galaxies','NGC 4874',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103328,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103328,34.68,0.34,86.3,43552,77,NULL,'Coma Cluster, 28 galaxies','NGC 4874',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103329,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103329,34.68,NULL,86.3,43552,77,NULL,'BRIK, Coma Cluster, 28 galaxies','NGC 4874',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103330,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103330,34.7,0.2,87.1,43552,NULL,NULL,'Coma Cluster, 7 galaxies, H(T)(T<=4)','NGC 4874',NULL,'2001ApJ...555..215W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103331,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103331,34.74,0.3,88.6,43552,NULL,NULL,'Coma Cluster, 28 galaxies','NGC 4874',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103332,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103332,34.77,0.1,89.9,43552,74.4,NULL,'Coma CLUSTER, 24 galaxies, WISE I-band','NGC 4874',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103333,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103333,34.77,0.1,90,43552,75,NULL,'Coma CLUSTER','NGC 4874',NULL,'2012ApJ...749...78T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103334,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103334,34.78,0.11,90.4,43552,75,NULL,'Coma cluster, avg. of 16 spiral galaxies','NGC 4874',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103335,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103335,34.8,0.17,91.2,43552,75,NULL,'Coma Cluster, 9 galaxies [for Virgo m-M = 31.10 mag, D = 16.6 Mpc]','NGC 4874',NULL,'1986A&A...164...17G',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103336,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103336,34.83,0.03,92.6,43552,75,NULL,'Coma CLUSTER','NGC 4874',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103337,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103337,34.86,0.11,93.9,43552,74.4,NULL,'Coma CLUSTER, 24 galaxies, WISE W1 (3.4 micro-meter), color corrected','NGC 4874',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103338,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103338,34.87,0.11,94.1,43552,74.4,NULL,'Coma CLUSTER, 24 galaxies, WISE W2 (4.6 micro-meter), color corrected','NGC 4874',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103339,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103339,34.88,0.45,94.4,43552,NULL,NULL,'K','NGC 4874',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103340,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103340,34.9,0.13,95.4,43552,75,NULL,'Coma cluster, avg. of 16 spiral galaxies','NGC 4874',NULL,'2013ApJ...765...94S',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103341,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103341,34.91,0.06,95.8,43552,74.4,NULL,'Coma CLUSTER, 24 galaxies, WISE W1 (3.4 micro-meter), curved','NGC 4874',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103342,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103342,34.94,0.13,97.3,43552,NULL,NULL,'Coma Cluster, 20 galaxies, H(T)','NGC 4874',NULL,'2001ApJ...555..215W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103343,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103343,34.94,0.06,97.4,43552,74.4,NULL,'Coma CLUSTER, 24 galaxies, WISE W2 (4.6 micro-meter), curved','NGC 4874',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103344,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103344,35.02,0.06,101,43552,75,NULL,'Coma Cluster, 68 galaxies','NGC 4874',NULL,'1990ApJ...351L...5W',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103345,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103345,35.05,0.14,102,43552,NULL,NULL,'Coma Cluster, 11 galaxies, H(-0.5)','NGC 4874',NULL,'2001ApJ...555..215W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103346,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103346,35.08,0.14,104,43552,NULL,NULL,'Coma Cluster, 11 galaxies, H(T)(H(-0.5) available)','NGC 4874',NULL,'2001ApJ...555..215W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103347,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103347,35.08,0.16,104,43552,NULL,NULL,'Coma Cluster, 4 galaxies, H(T)(T<=5)','NGC 4874',NULL,'2001ApJ...555..215W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103348,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103348,35.11,0.4,105,43552,NULL,NULL,'mean','NGC 4874',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103349,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103349,35.14,0.23,107,43553,74.4,NULL,NULL,'NGC 4875',NULL,'2013AJ....146...86T',2013,1,0.29,NULL,'G',0.000025,NULL,'15.4g',0.2,'SAB0','Group member',NULL,NULL,NULL,1,194.9079583,27.90733,0.05,NULL,58699067900,917172935,14330827,15.4),(103350,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103350,35.31,0.05,115,43553,70,NULL,NULL,'NGC 4875',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103351,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103351,35.97,0.16,156,43554,70,NULL,NULL,'IC 4001',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000168,NULL,'15.5g',0.41,NULL,NULL,NULL,NULL,NULL,1,194.9080417,38.87025,0,NULL,59074551517,923039867,14422497,15.5),(103352,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103352,36.68,0.74,217,43555,70,NULL,NULL,'LCRS B125703.7-054157',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'15.47',0.2,NULL,NULL,NULL,NULL,NULL,1,194.912917,-5.96889,0.049,NULL,43123601873,673806279,10528223,15.47),(103353,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103353,37.55,0.33,323,43556,70,NULL,NULL,'2MASX J12593932+6016308',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,194.9135417,60.27514,0,NULL,57383099705,896610932,14009545,17),(103354,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103354,35.97,0.16,156,43557,70,NULL,NULL,'IC 4003',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00013,NULL,'15.0g',0.54,NULL,NULL,NULL,NULL,NULL,1,194.913875,38.81558,0,NULL,59074604730,923040698,14422510,15),(103355,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103355,37.85,0.46,371,43558,70,NULL,NULL,'2MASX J12594078+2659307',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000164,NULL,'17.6g',0.2,NULL,'Group member',NULL,NULL,NULL,1,194.919917,26.99206,0.007,NULL,58696639417,917134990,14330234,17.6),(103356,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103356,38.33,0.46,464,43559,70,NULL,NULL,'2MASX J12594101-0035067',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000077,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,194.9209583,-0.58533,0.005,NULL,43112801794,673637528,10525586,17.8),(103357,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103357,38.14,0.33,425,43560,70,NULL,NULL,'2MASX J12594120+2100091',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'18.41',NULL,NULL,NULL,NULL,NULL,NULL,1,194.9217083,21.0025,0.19,NULL,59024978954,922265296,14410395,18.41),(103358,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103358,37.72,0.19,350,43561,70,NULL,NULL,'SDSS J125941.20+300035.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,194.9217083,30.00994,0,NULL,58675121785,916798777,14324980,18.4),(103359,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103359,34.86,0.4,93.8,43562,75,NULL,'Edat, raw','CGCG 160-233',NULL,'1997ApJS..109..333W',1997,1,0.31,NULL,'G',0.00001,NULL,'16.1g',0.27,'Ed','Group member',NULL,NULL,NULL,1,194.92625,27.92472,0.05,NULL,58699070952,917172983,14330827,16.1),(103360,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103360,34.89,0.4,95,43562,75,NULL,'Edat, cor','CGCG 160-233',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103361,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103361,35.22,0.22,111,43562,74.4,NULL,NULL,'CGCG 160-233',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103362,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103362,35.31,0.05,115,43562,70,NULL,NULL,'CGCG 160-233',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103363,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103363,35.97,0.16,156,43563,70,NULL,NULL,'IC 4004',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000127,NULL,'15.4g',0.49,NULL,NULL,NULL,NULL,NULL,1,194.928208333,38.81131,0,NULL,59074604897,923040701,14422510,15.4),(103364,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103364,34.86,0.4,93.8,43564,75,NULL,'Edat, raw','GIN 786',NULL,'1997ApJS..109..333W',1997,1,0.38,NULL,'G',0.000022,NULL,'15.9g',0.37,'E','Group member',NULL,NULL,NULL,1,194.932208333,27.99469,0.05,NULL,58698591901,917165498,14330710,15.9),(103365,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103365,34.89,0.4,95,43564,75,NULL,'Edat, cor','GIN 786',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103366,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103366,34.92,0.22,96.4,43564,74.4,NULL,NULL,'GIN 786',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103367,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103367,35.31,0.05,115,43564,70,NULL,NULL,'GIN 786',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103368,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103368,37.1,0.46,263,43565,70,NULL,NULL,'2MASX J12594415+4737525',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,194.934,47.63133,0,NULL,59102270206,923472971,14429265,17),(103369,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103369,38.41,0.33,482,43566,70,NULL,NULL,'2MASX J12594429+1756368',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,194.9345417,17.94353,0.099,NULL,59027629506,922306711,14411042,17.8),(103370,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103370,34.86,0.4,93.8,43567,75,NULL,'Edat, raw','NGC 4876',NULL,'1997ApJS..109..333W',1997,1,0.58,NULL,'G',0.000013,NULL,'15.1g',0.4,'E5','Group member',NULL,NULL,NULL,1,194.9350417,27.91247,0.05,NULL,58699071390,917172990,14330827,15.1),(103371,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103371,34.89,0.4,95,43567,75,NULL,'Edat, cor','NGC 4876',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103372,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103372,34.99,0.22,99.5,43567,74.4,NULL,NULL,'NGC 4876',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103373,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103373,35.31,0.05,115,43567,70,NULL,NULL,'NGC 4876',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103374,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103374,37.6,0.33,332,43568,70,NULL,NULL,'2MASX J12594455+1654378',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.48',0.16,NULL,NULL,NULL,NULL,NULL,1,194.9355,16.91064,0.065,NULL,59045974783,922593355,14415521,18.48),(103375,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103375,37.44,0.33,308,43569,70,NULL,NULL,'2MASX J12594482+1604328',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.38',0.15,NULL,NULL,NULL,NULL,NULL,1,194.936667,16.07575,0.01,NULL,59044621113,922572204,14415190,18.38),(103376,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103376,37.7,0.33,347,43570,70,NULL,NULL,'2MASX J12594488+0921371',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000176,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,194.936917,9.36025,0.017,NULL,58970705215,921417268,14397144,17.1),(103377,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103377,34.24,0.4,70.6,43571,75,NULL,'Edat, raw','ESO 575- G 043',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000107,NULL,'14.01',1.1,'SAB(s)0-',NULL,NULL,NULL,NULL,1,194.939,-22.17547,0.281,NULL,43974682602,687104415,10736006,14.01),(103378,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103378,34.58,0.4,82.4,43571,75,NULL,'Edat, cor','ESO 575- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103379,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103379,34.56,0.45,81.7,43571,NULL,NULL,'K','ESO 575- G 043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103380,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103380,35.08,0.4,104,43571,NULL,NULL,'mean','ESO 575- G 043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103381,'IRAS','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103381,32.78,0.8,35.9,43572,75,NULL,'MAT, I','ESO 443- G 021',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000028,NULL,'14.41',0.3,'Scd: sp        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,194.94125,-29.60022,0.361,NULL,43336466518,677132289,10580192,14.41),(103382,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103382,32.83,0.4,36.9,43572,75,NULL,NULL,'ESO 443- G 021',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103383,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103383,33.14,0.43,42.5,43572,75,NULL,'3.6 micron, color + selection bias corrected','ESO 443- G 021',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103384,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103384,33.2,0.4,43.6,43572,NULL,NULL,'mean','ESO 443- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103385,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103385,33.35,0.47,46.8,43572,NULL,NULL,'H','ESO 443- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103386,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103386,33.35,0.49,46.8,43572,75,NULL,'IR','ESO 443- G 021',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103387,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103387,33.38,0.4,47.4,43572,NULL,NULL,NULL,'ESO 443- G 021',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103388,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103388,33.39,0.45,47.6,43572,NULL,NULL,'K','ESO 443- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103389,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103389,33.41,0.15,48.2,43572,NULL,NULL,NULL,'ESO 443- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103390,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103390,33.42,0.46,48.2,43572,NULL,NULL,'J','ESO 443- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103391,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103391,33.42,0.43,48.4,43572,75,NULL,'3.6 micron, color corrected','ESO 443- G 021',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103392,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103392,33.48,0.43,49.6,43572,75,NULL,'MAT, I, raw','ESO 443- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103393,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103393,33.55,0.32,51.2,43572,85,NULL,'I, raw','ESO 443- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103394,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103394,33.58,0.32,52.1,43572,85,NULL,'I, inv','ESO 443- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103395,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103395,33.62,0.43,53.1,43572,75,NULL,'MAT, I, cor','ESO 443- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103396,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103396,33.67,0.43,54.1,43572,75,NULL,'MAT, I, inv','ESO 443- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103397,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103397,33.71,0.2,55.2,43572,74.4,NULL,NULL,'ESO 443- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103398,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103398,34.47,0.44,78.3,43573,95,NULL,'Weighted Mean','IC 3998',NULL,'1984ApJS...56...91D',1984,1,0.45,NULL,'G',0.00003,NULL,'15.4g',0.34,'SB0','Group member',NULL,NULL,NULL,1,194.944917,27.97386,0.05,NULL,58698589950,917165467,14330710,15.4),(103399,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103399,34.8,0.63,91.2,43573,95,NULL,'Michard 1979b, c','IC 3998',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103400,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103400,35.25,0.46,112,43573,95,NULL,'Michard 1979a','IC 3998',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103401,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103401,35.31,0.05,115,43573,70,NULL,NULL,'IC 3998',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103402,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103402,35.39,0.25,120,43573,74.4,NULL,NULL,'IC 3998',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103403,'GRB','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103403,46.75,1.48,5550,43574,NULL,NULL,NULL,'GRB 080607',3.036,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,194.9467083,15.91928,0.033,NULL,59045088083,922579501,14415304,NULL),(103404,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103404,38.17,0.33,431,43575,70,NULL,NULL,'2MASX J12594702+5036336',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000144,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,194.945875,50.60944,0,NULL,59090468244,923288566,14426383,17.4),(103405,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103405,36.58,0.63,207,43576,70,NULL,NULL,'2MASX J12594701-3342447',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,194.945916667,-33.71244,0.257,NULL,43322188538,676909195,10576706,15.5),(103406,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103406,36.53,0.6,202,43577,70,NULL,NULL,'2MASX J12594722-1932173',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,194.946791667,-19.53806,0.209,NULL,43989475727,687335558,10739618,17),(103407,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103407,34.34,0.69,73.9,43578,100,NULL,'mid-IR','IC 0841',NULL,'2013ApJ...771...88L',2013,1,0.8,NULL,'G',0.000057,NULL,'15.4',0.3,'Sb             AGN',NULL,NULL,NULL,NULL,1,194.94725,21.81322,0.119,NULL,59024817862,922262779,14410355,15.4),(103408,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103408,36.16,0.53,170,43579,70,NULL,NULL,'2MASX J12594756-4854246',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,194.9482083,-48.90694,0.861,NULL,46738893617,730295212,11410862,14.3),(103409,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103409,36.32,0.46,184,43580,70,NULL,NULL,'MCG +09-21-078',NULL,'2015arXiv151105856S',2015,1,0.65,'MCG declination is +10 arcmin in error.','G',0.000191,NULL,'15.3g',0.59,'E0',NULL,NULL,NULL,NULL,1,194.948833,50.79528,0,NULL,57195653819,893682090,13963782,15.3),(103410,'SZ effect','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103410,35.06,NULL,103,43581,NULL,NULL,NULL,'Coma Cluster',NULL,'2005ApJ...625..108D',2005,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II     [BM]',NULL,NULL,NULL,NULL,1,194.953041667,27.98069,0.05,NULL,58698589839,917165466,14330710,NULL),(103411,'SZ effect','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103411,35.22,NULL,111,43581,NULL,NULL,NULL,'Coma Cluster',NULL,'2001ApJ...555L..11M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103412,'SBF','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103412,35.1,0.55,105,43581,NULL,NULL,'HST KP Calibrated, F814W','Coma Cluster',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103413,'BCG','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103413,34.89,0.35,92.9,43581,60,NULL,NULL,'Coma Cluster',0.023,'1980ApJ...241..486H',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103414,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103414,38.14,0.33,425,43582,70,NULL,NULL,'2MASX J12594805+2106560',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,194.950375,21.1155,0.153,NULL,59024954360,922264911,14410389,18.1),(103415,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103415,38.1,0.46,416,43583,70,NULL,NULL,'2MASX J12594833+3837588',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,194.9515,38.63308,0,NULL,59074566264,923040097,14422501,18),(103416,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103416,38.47,0.46,494,43584,70,NULL,NULL,'SDSS J125948.65+612919.9',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000178,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,194.9527083,61.48886,0,NULL,57356752365,896199255,14003113,17.6),(103417,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103417,35.32,0.52,116,43585,70,NULL,NULL,'2MASX J12594899-1932143',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,194.954125,-19.53739,0.209,NULL,43989602943,687337545,10739649,14.9),(103418,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103418,36.53,0.33,202,43586,70,NULL,NULL,'2MASX J12594932+5515262',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000167,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,194.955417,55.25725,0.009,NULL,57422916216,897233065,14019266,16.6),(103419,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103419,37.29,0.46,287,43587,70,NULL,NULL,'2MASX J12595079+4526056',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,194.961417,45.43492,0,NULL,59100319390,923442490,14428788,16.9),(103420,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103420,37.72,0.19,350,43588,70,NULL,NULL,'SDSS J125951.85+295354.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,194.966083,29.89839,0,NULL,58675054805,916797731,14324964,18.1),(103421,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103421,36.49,0.23,198,43589,70,NULL,NULL,'2MASX J12595198+3121065',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.00009,NULL,'15.4g',0.48,NULL,NULL,NULL,NULL,'USS',1,194.966625,31.35175,0.023,NULL,58677047256,916828863,14325450,15.4),(103422,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103422,36.26,0.58,178,43590,70,NULL,NULL,'2MASX J12595214-1641460',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'16.9b',0.2,'S0','Group member',NULL,NULL,NULL,1,194.9672083,-16.69608,0.065,NULL,44018324151,687786314,10746661,16.9),(103423,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103423,38.04,0.46,406,43591,70,NULL,NULL,'2MASX J12595238+5110056',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000174,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,194.9682917,51.16817,0,NULL,57195822036,893684719,13963823,17.3),(103424,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103424,37.62,0.46,335,43592,70,NULL,NULL,'2MASX J12595355+0045021',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000074,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,194.973166667,0.7505,0,NULL,58091004640,907671947,14182374,18.2),(103425,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103425,34.86,0.4,93.8,43593,75,NULL,'Edat, raw','2MASX J12595511+2807422',NULL,'1997ApJS..109..333W',1997,1,0.54,NULL,'G',0.000022,NULL,'16.4b',0.49,'SB0','Group member',NULL,NULL,NULL,1,194.9795417,28.12836,0.054,NULL,58698619808,917165934,14330717,16.4),(103426,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103426,34.89,0.4,95,43593,75,NULL,'Edat, cor','2MASX J12595511+2807422',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103427,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103427,34.81,0.23,91.6,43593,74.4,NULL,NULL,'2MASX J12595511+2807422',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103428,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103428,35.31,0.05,115,43593,70,NULL,NULL,'2MASX J12595511+2807422',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103429,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103429,34.35,0.44,74.1,43594,95,NULL,'Weighted Mean','NGC 4883',NULL,'1984ApJS...56...91D',1984,1,0.62,NULL,'G',0.00003,NULL,'15.0g',0.46,'SAB0','Group member',NULL,NULL,NULL,1,194.983375,28.03472,0.05,NULL,58698626084,917166032,14330719,15),(103430,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103430,34.74,0.63,88.7,43594,95,NULL,'Michard 1979b, c','NGC 4883',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103431,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103431,35.07,0.46,103,43594,95,NULL,'Michard 1979a','NGC 4883',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103432,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103432,34.93,0.25,96.8,43594,74.4,NULL,NULL,'NGC 4883',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103433,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103433,35.31,0.05,115,43594,70,NULL,NULL,'NGC 4883',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103434,'Tertiary','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103434,34.15,0.35,67.6,43594,95,NULL,NULL,'NGC 4883',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103435,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103435,31.95,0.4,24.5,43595,NULL,NULL,NULL,'UGC 08120',NULL,'2009AJ....138..323T',2009,1,1.8,NULL,'G',0.000017,NULL,'14.40',0.9,'Sd','Isolated galaxy',NULL,NULL,NULL,1,194.984167,73.69247,0.025,NULL,57038614486,891228351,13925442,14.4),(103436,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103436,32.24,0.2,28.1,43595,74.4,NULL,NULL,'UGC 08120',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103437,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103437,32.28,0.48,28.5,43595,NULL,NULL,'Malmquist cor.','UGC 08120',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103438,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103438,32.42,0.45,30.5,43595,NULL,NULL,NULL,'UGC 08120',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103439,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103439,29.19,NULL,6.89,43596,NULL,NULL,NULL,'SGC 1257.3-1909',NULL,'2013AJ....145..101K',2013,1,1.6,NULL,'G',0.000002,NULL,'17.5',0.9,'IAm:',NULL,NULL,NULL,NULL,1,194.984583,-19.41306,0.173,NULL,43989482291,687335660,10739619,17.5),(103440,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103440,29.19,0.4,6.9,43596,NULL,NULL,NULL,'SGC 1257.3-1909',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103441,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103441,35,0.46,100,43597,70,NULL,NULL,'NGC 4901',NULL,'2015arXiv151105856S',2015,1,0.96,NULL,'G',0.000153,NULL,'14.4g',0.88,'E0',NULL,NULL,NULL,NULL,1,194.9850417,47.20556,0,NULL,59102373750,923474589,14429290,14.4),(103442,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103442,37.6,0.33,332,43598,70,NULL,NULL,'2MASX J12595676+1651310',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.42',0.14,NULL,NULL,NULL,NULL,NULL,1,194.986541667,16.85867,0.065,NULL,59045994589,922593665,14415526,18.42),(103443,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103443,36.59,0.46,208,43599,70,NULL,NULL,'CGCG 043-092',NULL,'2015arXiv151105856S',2015,1,1.2,NULL,'G',0.000163,NULL,'15.6',0.7,NULL,NULL,NULL,NULL,NULL,1,194.986583,7.06856,0.026,NULL,58077672094,907463626,14179119,15.6),(103444,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103444,37.7,0.33,347,43600,70,NULL,NULL,'2MASX J12595737+0920480',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,194.9889583,9.34656,0.017,NULL,58970836382,921419318,14397176,17.7),(103445,'GCLF','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103445,34.9,NULL,95.5,43601,NULL,NULL,NULL,'NGC 4881',NULL,'2002ApJ...567..294O',2002,1,1,NULL,'G',0.000019,NULL,'14.7b',1,'E','Group member',NULL,NULL,NULL,1,194.99,28.24739,0.056,NULL,58695775903,917121498,14330023,14.7),(103446,'GCLF','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103446,35.16,0.23,108,43601,NULL,NULL,NULL,'NGC 4881',NULL,'1995AJ....110.2537B',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103447,'SBF','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103447,35.04,0.31,102,43601,NULL,NULL,'I','NGC 4881',NULL,'1997ApJ...483L..37T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103448,'SBF','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103448,35.1,0.55,105,43601,NULL,NULL,'HST KP Calibrated, F814W','NGC 4881',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103449,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103449,34.86,0.4,93.8,43601,75,NULL,'Edat, raw','NGC 4881',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103450,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103450,34.89,0.4,95,43601,75,NULL,'Edat, cor','NGC 4881',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103451,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103451,34.35,0.44,74.1,43601,95,NULL,'Weighted Mean','NGC 4881',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103452,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103452,34.89,0.46,95.1,43601,95,NULL,'Michard 1979a','NGC 4881',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103453,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103453,35.02,0.63,101,43601,95,NULL,'Michard 1979b, c','NGC 4881',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103454,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103454,34.88,0.22,94.6,43601,74.4,NULL,NULL,'NGC 4881',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103455,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103455,35.07,0.09,103,43601,70,NULL,NULL,'NGC 4881',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103456,'Tertiary','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103456,34.15,0.35,67.6,43601,95,NULL,NULL,'NGC 4881',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103457,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103457,35.1,0.4,105,43601,NULL,NULL,'mean','NGC 4881',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103458,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103458,35.52,0.45,127,43601,NULL,NULL,'K','NGC 4881',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103459,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103459,35.31,0.05,115,43602,70,NULL,NULL,'SDSS J125957.74+281447.9',NULL,'2015arXiv151105856S',2015,1,0.91,NULL,'G',0.000194,NULL,'14.3g',0.88,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,194.990625,28.24667,0.056,NULL,58695775903,917121498,14330023,14.3),(103460,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103460,36.47,0.46,197,43603,70,NULL,NULL,'2MASX J12595843+2711583',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.0001,NULL,'15.5g',0.47,'E','Group member',NULL,NULL,NULL,1,194.993416667,27.19961,0.019,NULL,58698451661,917163307,14330676,15.5),(103461,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103461,37.53,0.46,321,43604,70,NULL,NULL,'2MASX J12595909+0959100',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.12',0.19,NULL,NULL,NULL,NULL,NULL,1,194.996125,9.98603,0.026,NULL,58970915488,921420554,14397196,18.12),(103462,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103462,34.2,0.68,69.1,43605,70,NULL,NULL,'ESO 269- G 027',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000083,NULL,'15.24',0.3,'S0^0^: sp',NULL,NULL,NULL,NULL,1,194.997333,-45.60158,0.413,NULL,46730550964,730164858,11408825,15.24),(103463,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103463,37.44,0.33,308,43606,70,NULL,NULL,'2MASX J12595938+1610271',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,194.9975417,16.17403,0.01,NULL,59044637569,922572462,14415194,16.8),(103464,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103464,35.97,0.16,156,43607,70,NULL,NULL,'2MASX J12595950+3844439',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000176,NULL,'17.71',0.18,NULL,NULL,NULL,NULL,NULL,1,194.997917,38.74564,0,NULL,59074595830,923040559,14422508,17.71),(103465,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103465,37.87,0.16,375,43608,70,NULL,NULL,'2MASX J12595955-0201223',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00007,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,194.9980417,-2.02289,0.005,NULL,43144261300,674129082,10533266,18),(103466,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103466,35.45,0.72,123,43609,70,NULL,NULL,'2MASX J12595984-2224023',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.1I',0.3,NULL,NULL,NULL,NULL,NULL,1,194.999417,-22.40061,0.281,NULL,43790918926,684233108,10691142,14.1),(103467,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103467,37.68,0.46,344,43610,70,NULL,NULL,'2MASX J12595999+5501521',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000176,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,194.999916667,55.03131,0.01,NULL,57423244555,897238196,14019346,17.3),(103468,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103468,37.46,0.46,310,43611,70,NULL,NULL,'2MASX J13000084+1821371',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.66',0.14,NULL,NULL,NULL,NULL,NULL,1,195.003625,18.36036,0.097,NULL,59027582453,922305975,14411030,18.66),(103469,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103469,37.9,0.46,379,43612,70,NULL,NULL,'2MASX J13000161+6302560',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000183,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,195.006417,63.04892,0.005,NULL,57357203991,896206312,14003223,18),(103470,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103470,38.17,0.33,431,43613,70,NULL,NULL,'SDSS J130002.17+672555.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000072,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,195.009125,67.43206,0.037,NULL,57855732920,903995826,14124934,18.7),(103471,'IRAS','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103471,33.09,0.8,41.5,43614,75,NULL,'MAT, I','ESO 269- G 028',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.00003,NULL,'15.26',0.4,'SB(s)bc:',NULL,NULL,NULL,NULL,1,195.009,-43.29953,0.341,NULL,46758392128,730599877,11415623,15.26),(103472,'IRAS','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103472,33.11,0.8,41.8,43614,75,NULL,'HMCL, I','ESO 269- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103473,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103473,33.39,0.1,47.7,43614,NULL,NULL,NULL,'ESO 269- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103474,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103474,33.51,0.4,50.2,43614,75,NULL,'HMCL, I, raw','ESO 269- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103475,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103475,33.55,0.4,51.4,43614,75,NULL,'HMCL, I, inv','ESO 269- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103476,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103476,33.62,0.4,53.1,43614,75,NULL,'HMCL, I, cor','ESO 269- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103477,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103477,33.64,0.38,53.5,43614,NULL,NULL,NULL,'ESO 269- G 028',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103478,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103478,33.75,0.32,56.3,43614,85,NULL,'I, raw','ESO 269- G 028',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103479,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103479,33.76,0.32,56.6,43614,85,NULL,'I, inv','ESO 269- G 028',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103480,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103480,33.86,0.43,59.1,43614,75,NULL,'MAT, I, raw','ESO 269- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103481,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103481,33.94,0.43,61.3,43614,75,NULL,'MAT, I, inv','ESO 269- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103482,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103482,33.97,0.43,62.1,43614,75,NULL,'MAT, I, cor','ESO 269- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103483,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103483,37.72,0.19,350,43615,70,NULL,NULL,'2MASX J13000220+3000449',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000159,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,195.0092083,30.01239,0,NULL,58674466281,916788535,14324820,17),(103484,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103484,37.38,0.46,299,43616,70,NULL,NULL,'SDSS J130003.18+292233.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,195.01325,29.37592,0,NULL,58704394223,917256159,14332127,18.4),(103485,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103485,35.21,0.09,110,43617,NULL,NULL,NULL,'NGC 4892',NULL,'2009ApJS..182..474S',2009,1,1.57,NULL,'G',0.00005,NULL,'14.2g',0.38,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,195.014708333,26.89811,0,NULL,58696451179,917132049,14330188,14.2),(103486,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103486,37.11,0.46,264,43618,70,NULL,NULL,'2MASX J13000347+1615311',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.48',0.14,NULL,NULL,NULL,NULL,NULL,1,195.014583,16.25861,0.01,NULL,59044641508,922572523,14415195,18.48),(103487,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103487,34.86,0.4,93.8,43619,75,NULL,'Edat, raw','NGC 4886',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000014,NULL,'14.9g',1.1,'E0','Group member',NULL,NULL,NULL,1,195.0185,27.98758,0.05,NULL,58698592924,917165514,14330711,14.9),(103488,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103488,34.89,0.4,95,43619,75,NULL,'Edat, cor','NGC 4886',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103489,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103489,34.34,0.44,73.8,43619,95,NULL,'Weighted Mean','NGC 4886',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103490,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103490,34.65,0.63,85.1,43619,95,NULL,'Michard 1979b, c','NGC 4886',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103491,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103491,35.1,0.46,105,43619,95,NULL,'Michard 1979a','NGC 4886',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103492,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103492,34.88,0.23,94.6,43619,74.4,NULL,NULL,'NGC 4886',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103493,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103493,35.31,0.05,115,43619,70,NULL,NULL,'NGC 4886',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103494,'Tertiary','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103494,34.15,0.35,67.6,43619,95,NULL,NULL,'NGC 4886',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103495,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103495,38.5,0.46,500,43620,70,NULL,NULL,'SDSS J130004.73+242322.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'19.24',0.16,NULL,NULL,NULL,NULL,NULL,1,195.01975,24.38953,0.063,NULL,58688434965,917006796,14328231,19.24),(103496,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103496,31.19,0.4,17.3,43621,NULL,NULL,NULL,'MCG -02-33-082',NULL,'2013MNRAS.429.2677K',2013,1,1.2,NULL,'G',0.000033,NULL,'14.41',0.3,'IB(s)m? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,195.021167,-15.36514,0.029,NULL,44017330925,687770795,10746418,14.41),(103497,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103497,38.17,0.33,431,43622,70,NULL,NULL,'2MASX J13000508+6724250',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000129,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,195.021333,67.407,0.037,NULL,57855732095,903995813,14124934,16.4),(103498,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103498,38.5,0.46,501,43623,70,NULL,NULL,'SDSS J130005.27+094620.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,195.0219583,9.77239,0.038,NULL,58970964081,921421313,14397208,18.4),(103499,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103499,37.24,0.46,280,43624,70,NULL,NULL,'SDSS J130005.44+252536.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.80',0.17,NULL,NULL,NULL,NULL,NULL,1,195.0227083,25.42672,NULL,NULL,58689324682,917020698,14328448,18.8),(103500,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103500,35.99,0.51,158,43625,70,NULL,NULL,'2MASX J13000579-1029205',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00009,NULL,'15.80',NULL,NULL,NULL,NULL,NULL,NULL,1,195.024167,-10.48919,0.109,NULL,43854282471,685223163,10706611,15.8),(103501,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103501,35.29,0.46,114,43626,70,NULL,NULL,'2MASX J13000592+3359389',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'16.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,195.024625,33.99411,0.008,NULL,58670207322,916721989,14323781,16.4),(103502,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103502,34.86,0.4,93.8,43627,75,NULL,'Edat, raw','IC 4011',NULL,'1997ApJS..109..333W',1997,1,0.33,NULL,'G',0.000017,NULL,'15.7g',0.31,'E','Group member',NULL,NULL,NULL,1,195.026625,28.00414,0.05,NULL,58698585542,917165399,14330709,15.7),(103503,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103503,34.89,0.4,95,43627,75,NULL,'Edat, cor','IC 4011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103504,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103504,34.56,0.22,81.7,43627,74.4,NULL,NULL,'IC 4011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103505,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103505,35.31,0.05,115,43628,70,NULL,NULL,'2MASX J13000626+2741072',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00004,NULL,'16.1g',0.36,'E','Group member',NULL,NULL,NULL,1,195.0260417,27.68531,0.039,NULL,58699276527,917176195,14330878,16.1),(103506,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103506,35.31,0.05,115,43629,70,NULL,NULL,'2MASX J13000626+2746332',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000027,NULL,'15.32',0.24,'SA0','Group member',NULL,NULL,NULL,1,195.0262083,27.77581,0.039,NULL,58699249502,917175773,14330871,15.32),(103507,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103507,38,0.33,399,43630,70,NULL,NULL,'IC 4007 NED02',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.01',0.2,NULL,NULL,NULL,NULL,NULL,1,195.029125,19.96467,0.157,NULL,59038879250,922482488,14413788,18.01),(103508,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103508,38.17,0.33,431,43631,70,NULL,NULL,'SDSS J130007.40+503443.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,195.030833,50.57881,0,NULL,59090455635,923288369,14426380,18.3),(103509,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103509,34.86,0.4,93.8,43632,75,NULL,'Edat, raw','IC 4012',NULL,'1997ApJS..109..333W',1997,1,0.41,NULL,'G',0.000025,NULL,'15.4g',0.33,'E','Group member',NULL,NULL,NULL,1,195.033291667,28.07856,0.05,NULL,58698614423,917165850,14330716,15.4),(103510,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103510,34.89,0.4,95,43632,75,NULL,'Edat, cor','IC 4012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103511,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103511,34.35,0.44,74.1,43632,95,NULL,'Weighted Mean','IC 4012',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103512,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103512,34.45,0.63,77.6,43632,95,NULL,'Michard 1979b, c','IC 4012',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103513,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103513,35.24,0.46,112,43632,95,NULL,'Michard 1979a','IC 4012',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103514,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103514,34.95,0.22,97.7,43632,74.4,NULL,NULL,'IC 4012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103515,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103515,35.31,0.05,115,43632,70,NULL,NULL,'IC 4012',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103516,'Tertiary','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103516,34.15,0.35,67.6,43632,95,NULL,NULL,'IC 4012',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103517,'CMD','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103517,34.5,NULL,79.4,43633,NULL,NULL,'Photographic, Coma Cluster, 22 galaxy avg., Virgo m-M = 31.0 mag','NGC 4889',NULL,'1981ApJ...245...18A',1981,1,2.9,NULL,'G',0.000043,NULL,'12.9g',1.9,'cD;E4;Dd       PAS','in a radial-velocity based grouping',NULL,NULL,NULL,1,195.033875,27.977,0.05,NULL,58698595619,917165556,14330711,12.9),(103518,'CMD','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103518,34.69,0.08,86.7,43633,NULL,NULL,'Coma Cluster, vs. Virgo m-M = 31.00 mag','NGC 4889',NULL,'1992MNRAS.254..601B',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103519,'GCLF','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103519,34.8,0.09,91,43633,NULL,NULL,'Mean of GCs in N4874, N4889, N4921, and N4923','NGC 4889',NULL,'2016ApJ...819...77L',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103520,'GCLF','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103520,34.81,0.09,92,43633,NULL,NULL,'I','NGC 4889',NULL,'2016ApJ...819...77L',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103521,'PNLF','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103521,34.9,NULL,97.7,43633,NULL,NULL,'Coma Cluster','NGC 4889',NULL,'2013IAUS..289..287A',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103522,'SZ effect','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103522,34.91,0.77,96,43633,NULL,NULL,'Coma Cluster','NGC 4889',NULL,'1995ApJ...449L...5H',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103523,'SBF','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103523,34.64,0.25,84.7,43633,NULL,NULL,'K','NGC 4889',NULL,'1999ApJ...510...71J',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103524,'BCG','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103524,34.89,0.35,92.9,43633,60,NULL,'ABELL 1656, BCG','NGC 4889',0.023,'1980ApJ...241..486H',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103525,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103525,34.66,0.48,85.4,43633,NULL,NULL,'assume Virgo m-M = 31.00 mag','NGC 4889',NULL,'1987ApJ...313...42D',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103526,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103526,34.73,0.48,88.4,43633,NULL,NULL,'assume Virgo m-M = 31.00 mag + Fornx m-M = 31.21 mg','NGC 4889',NULL,'1987ApJ...313...42D',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103527,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103527,34.76,NULL,89.5,43633,NULL,NULL,'Coma vs. Virgo m-M = 31.31 mag','NGC 4889',NULL,'1997MNRAS.289..847D',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103528,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103528,34.86,NULL,93.8,43633,NULL,NULL,'Coma vs. Virgo m-M = 31.31 mag, Aperture cor.','NGC 4889',NULL,'1997MNRAS.289..847D',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103529,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103529,34.86,0.4,93.8,43633,75,NULL,'Edat, raw','NGC 4889',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103530,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103530,34.89,0.4,95,43633,75,NULL,'Edat, cor','NGC 4889',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103531,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103531,34.89,0.15,95,43633,NULL,NULL,'Coma Cluster, 81 galaxies','NGC 4889',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103532,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103532,34.9,0.13,95.5,43633,NULL,NULL,'Coma cluster','NGC 4889',NULL,'1997NewA....1..363G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103533,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103533,35.05,0.05,102,43633,72,NULL,'Coma Cluster, 80 galaxies','NGC 4889',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103534,'D-Sigma','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103534,36.56,NULL,205,43633,NULL,NULL,'Coma Cluster, K, avg. 13 ellipticals','NGC 4889',NULL,'1995AJ....110.1052G',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103535,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103535,33.7,0.46,55,43633,95,NULL,'Michard 1979a','NGC 4889',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103536,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103536,33.74,0.28,56,43633,95,NULL,'Weighted Mean','NGC 4889',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103537,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103537,34.21,0.63,69.5,43633,95,NULL,'Michard 1979b, c','NGC 4889',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103538,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103538,34.38,0.45,75.2,43633,95,NULL,'de Vaucouleurs','NGC 4889',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103539,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103539,34.85,0.81,93.3,43633,55,NULL,'Visvanathan & Sandage 1979','NGC 4889',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103540,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103540,35.19,0.21,109,43633,NULL,NULL,'for m-M(Coma-Leo) = 4.73 mag','NGC 4889',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103541,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103541,35.21,0.21,110,43633,NULL,NULL,'for D(Coma)/D(Leo) = 8.84','NGC 4889',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103542,'Faber-Jackson','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103542,35.35,0.34,117,43633,NULL,NULL,'for m-M(Coma-Leo) = 4.89 mag','NGC 4889',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103543,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103543,34.67,0.14,85.8,43633,NULL,NULL,'Coma Cluster, 81 galaxies','NGC 4889',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103544,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103544,34.76,NULL,89.5,43633,NULL,NULL,'Coma vs. Virgo m-M = 31.31 mag','NGC 4889',NULL,'1997MNRAS.289..847D',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103545,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103545,34.77,0.14,90,43633,NULL,NULL,'Coma Cluster, 81 galaxies','NGC 4889',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103546,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103546,34.86,NULL,93.8,43633,NULL,NULL,'Coma vs. Virgo m-M = 31.31 mag, Aperture cor.','NGC 4889',NULL,'1997MNRAS.289..847D',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103547,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103547,34.91,0.05,96,43633,75,NULL,'Coma Cluster, 71 galaxies','NGC 4889',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103548,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103548,34.91,0.05,96,43633,75,NULL,'Coma cluster, 71 galaxies','NGC 4889',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103549,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103549,34.92,0.65,96.4,43633,NULL,NULL,'assume Virgo m-M = 31.00 mag + Fornx m-M = 31.21 mg','NGC 4889',NULL,'1987ApJ...313...42D',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103550,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103550,35,0.65,99.9,43633,NULL,NULL,'assume Virgo m-M = 31.00 mag','NGC 4889',NULL,'1987ApJ...313...42D',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103551,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103551,35.07,0.09,103,43633,70,NULL,NULL,'NGC 4889',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103552,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103552,35.1,0.22,105,43633,74.4,NULL,NULL,'NGC 4889',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103553,'FP','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103553,35.17,0.23,108,43633,NULL,NULL,'Coma cluster','NGC 4889',NULL,'1997ApJ...482...68H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103554,'Magnitude','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103554,34.34,NULL,73.8,43633,NULL,NULL,'assume Virgo m-M = 31.00 mag','NGC 4889',NULL,'1989ApJ...342..617G',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103555,'Magnitude','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103555,35.34,NULL,117,43633,NULL,NULL,'Coma cluster','NGC 4889',NULL,'1995A&A...302...21G',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103556,'Tertiary','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103556,34.15,0.35,67.6,43633,95,NULL,NULL,'NGC 4889',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103557,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103557,34.48,0.2,78.7,43633,NULL,NULL,'Coma Cluster, 30 spirals avg.','NGC 4889',NULL,'1991ApJ...376....8F',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103558,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103558,34.66,NULL,85.6,43633,71,NULL,'Coma Cluster, 68 galaxies','NGC 4889',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103559,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103559,34.68,0.34,86.3,43633,77,NULL,'Coma Cluster, 28 galaxies','NGC 4889',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103560,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103560,34.68,NULL,86.3,43633,77,NULL,'BRIK, Coma Cluster, 28 galaxies','NGC 4889',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103561,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103561,34.7,0.2,87.1,43633,NULL,NULL,'Coma Cluster, 7 galaxies, H(T)(T<=4)','NGC 4889',NULL,'2001ApJ...555..215W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103562,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103562,34.74,0.3,88.6,43633,NULL,NULL,'Coma Cluster, 28 galaxies','NGC 4889',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103563,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103563,34.77,0.1,89.9,43633,74.4,NULL,'Coma CLUSTER, 24 galaxies, WISE I-band','NGC 4889',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103564,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103564,34.78,0.11,90.4,43633,75,NULL,'Coma cluster, avg. of 16 spiral galaxies','NGC 4889',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103565,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103565,34.8,0.17,91.2,43633,75,NULL,'Coma Cluster, 9 galaxies [for Virgo m-M = 31.10 mag, D = 16.6 Mpc]','NGC 4889',NULL,'1986A&A...164...17G',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103566,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,'R',103566,34.83,0.03,92.6,43633,75,NULL,'Coma CLUSTER','NGC 4889',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103567,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103567,34.86,0.11,93.9,43633,74.4,NULL,'Coma CLUSTER, 24 galaxies, WISE W1 (3.4 micro-meter), color corrected','NGC 4889',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103568,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103568,34.87,0.11,94.1,43633,74.4,NULL,'Coma CLUSTER, 24 galaxies, WISE W2 (4.6 micro-meter), color corrected','NGC 4889',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103569,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103569,34.9,0.13,95.4,43633,75,NULL,'Coma cluster, avg. of 16 spiral galaxies','NGC 4889',NULL,'2013ApJ...765...94S',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103570,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103570,34.91,0.06,95.8,43633,74.4,NULL,'Coma CLUSTER, 24 galaxies, WISE W1 (3.4 micro-meter), curved','NGC 4889',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103571,'Tully-Fisher','2016-12-15 15:15:08','2016-12-16 11:20:20','1',NULL,NULL,103571,34.94,0.13,97.3,43633,NULL,NULL,'Coma Cluster, 20 galaxies, H(T)','NGC 4889',NULL,'2001ApJ...555..215W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103572,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103572,34.94,0.06,97.4,43633,74.4,NULL,'Coma CLUSTER, 24 galaxies, WISE W2 (4.6 micro-meter), curved','NGC 4889',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103573,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103573,35.02,0.06,101,43633,75,NULL,'Coma Cluster, 30 spirals avg.','NGC 4889',NULL,'1990ApJ...351L...5W',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103574,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103574,35.05,0.14,102,43633,NULL,NULL,'Coma Cluster, 11 galaxies, H(-0.5)','NGC 4889',NULL,'2001ApJ...555..215W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103575,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103575,35.08,0.14,104,43633,NULL,NULL,'Coma Cluster, 11 galaxies, H(T)(H(-0.5) available)','NGC 4889',NULL,'2001ApJ...555..215W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103576,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103576,35.08,0.16,104,43633,NULL,NULL,'Coma Cluster, 4 galaxies, H(T)(T<=5)','NGC 4889',NULL,'2001ApJ...555..215W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103577,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103577,35.39,0.35,120,43633,NULL,NULL,'Coma Cluster, avg. spirals','NGC 4889',NULL,'1984Natur.307..326S',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103578,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103578,38.27,0.46,452,43634,70,NULL,NULL,'2MASX J13000878+1903211',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,195.0365,19.05603,0.09,NULL,59035520597,922430009,14412968,17.8),(103579,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103579,36.51,0.68,201,43635,70,NULL,NULL,'2MASX J13000904-0815115',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.4,NULL,NULL,NULL,NULL,NULL,1,195.037667,-8.25314,0.093,NULL,43848478468,685132476,10705194,14.5),(103580,'D-Sigma','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103580,34.86,0.4,93.8,43636,75,NULL,'Edat, raw','NGC 4895A',NULL,'1997ApJS..109..333W',1997,1,0.55,NULL,'G',0.000019,NULL,'15.7g',0.34,'SAB0','Group member',NULL,NULL,NULL,1,195.038,28.17039,0.054,NULL,58698611482,917165804,14330715,15.7),(103581,'D-Sigma','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103581,34.89,0.4,95,43636,75,NULL,'Edat, cor','NGC 4895A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103582,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103582,35.16,0.23,108,43636,74.4,NULL,NULL,'NGC 4895A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103583,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103583,35.31,0.05,115,43636,70,NULL,NULL,'NGC 4895A',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103584,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103584,37.87,0.46,374,43637,70,NULL,NULL,'2MASX J13000912+5010315',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000165,NULL,'16.9g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,195.038041667,50.1755,0,NULL,59104183301,923502864,14429732,16.9),(103585,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103585,36,0.46,159,43638,70,NULL,NULL,'2MASX J13000921+6218531',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000177,NULL,'15.8g',0.38,'SBab',NULL,NULL,NULL,NULL,1,195.038333,62.31469,0.009,NULL,57355716219,896183065,14002860,15.8),(103586,'Tully est','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103586,30.98,0.8,15.7,43639,75,NULL,'B','NGC 4880',NULL,'1988NBGC.C....0000T',1988,1,2.21,'HOLM 497B is a star.','G',0.000068,NULL,'13.1g',1.35,'SA(r)0+:','in a radial-velocity based grouping',NULL,NULL,NULL,1,195.0440417,12.48331,0.051,NULL,58995587609,921806056,14403219,13.1),(103587,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103587,37.77,0.46,359,43640,70,NULL,NULL,'SDSS J130011.79+632606.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000068,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,195.049167,63.43506,0.005,NULL,57349846738,896091355,14001427,18.5),(103588,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103588,35.97,0.16,156,43641,70,NULL,NULL,'2MASX J13001240+3838009',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000163,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,195.0515,38.63347,0,NULL,59074634574,923041165,14422518,16.7),(103589,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103589,38.27,0.46,450,43642,70,NULL,NULL,'2MASX J13001243+1815251',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,195.051833,18.25711,0.097,NULL,59027577460,922305897,14411029,17.3),(103590,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103590,35.01,0.25,100,43643,74.4,NULL,NULL,'2MASX J13001286+2804322',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000033,NULL,'15.9g',0.33,'SA0/a','Group member',NULL,NULL,NULL,1,195.053583333,28.0755,0.05,NULL,58698607873,917165748,14330714,15.9),(103591,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103591,37.51,0.33,317,43644,70,NULL,NULL,'2MASX J13001330+2937132',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000172,NULL,'16.7g',0.31,'E',NULL,NULL,NULL,NULL,1,195.0555,29.62031,0,NULL,58704078044,917251219,14332050,16.7),(103592,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103592,35.31,0.05,115,43645,70,NULL,NULL,'CGCG 160-083',NULL,'2015arXiv151105856S',2015,1,0.98,NULL,'G',0.00008,NULL,'15.0g',0.48,'SA0','Group member',NULL,NULL,NULL,1,195.058375,28.82817,0.052,NULL,58703926565,917248852,14332013,15),(103593,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103593,35.95,0.58,155,43646,NULL,NULL,'Malmquist cor.','KUG 1257+275',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000021,NULL,'16.0g',0.24,'Spiral         HII','Group member',NULL,NULL,NULL,1,195.0602083,27.28072,0.019,NULL,58698491211,917163925,14330686,16),(103594,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103594,36.17,0.52,171,43646,NULL,NULL,NULL,'KUG 1257+275',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103595,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103595,36.18,0.2,172,43646,74.4,NULL,NULL,'KUG 1257+275',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103596,'D-Sigma','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103596,34.86,0.4,93.8,43647,75,NULL,'Edat, raw','IC 4021',NULL,'1997ApJS..109..333W',1997,1,0.4,NULL,'G',0.000022,NULL,'15.5g',0.4,'SA0','Group member',NULL,NULL,NULL,1,195.061417,28.04131,0.05,NULL,58698613603,917165837,14330716,15.5),(103597,'D-Sigma','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103597,34.89,0.4,95,43647,75,NULL,'Edat, cor','IC 4021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103598,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103598,34.39,0.44,75.5,43647,95,NULL,'Weighted Mean','IC 4021',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103599,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103599,34.44,0.63,77.3,43647,95,NULL,'Michard 1979b, c','IC 4021',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103600,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103600,35.32,0.46,116,43647,95,NULL,'Michard 1979a','IC 4021',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103601,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103601,34.93,0.22,96.8,43647,74.4,NULL,NULL,'IC 4021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103602,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103602,35.07,0.09,103,43647,70,NULL,NULL,'IC 4021',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103603,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103603,35.31,0.05,115,43647,70,NULL,NULL,'IC 4021',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103604,'Tertiary','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103604,34.15,0.35,67.6,43647,95,NULL,NULL,'IC 4021',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103605,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103605,33.63,0.47,53.2,43648,70,NULL,NULL,'MCG -02-33-084',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00011,NULL,'14.91',0.3,'SB(r)0^0^:',NULL,NULL,NULL,NULL,1,195.064041667,-13.00706,0.037,NULL,43966042342,686969411,10733897,14.91),(103606,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103606,33.92,0.25,60.8,43649,74.4,NULL,NULL,'NGC 4894',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000033,NULL,'15.7g',0.27,'SA0','Group member',NULL,NULL,NULL,1,195.068833333,27.96753,0.05,NULL,58698586972,917165421,14330709,15.7),(103607,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103607,38,0.33,399,43650,70,NULL,NULL,'2MASX J13001683+1954393',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,195.070083,19.91106,0.157,NULL,59038870543,922482352,14413786,NULL),(103608,'Tully est','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103608,32.07,0.8,26,43651,75,NULL,NULL,'UGCA 314',NULL,'1988NBGC.C....0000T',1988,1,1.8,NULL,'G',0.00002,NULL,'14.64',1,'IB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,195.071667,-12.34656,0.057,NULL,43966669836,686979216,10734050,14.64),(103609,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103609,31.97,0.4,24.8,43651,NULL,NULL,NULL,'UGCA 314',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103610,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103610,35.31,0.05,115,43652,70,NULL,NULL,'2MASX J13001702+2803502',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000023,NULL,'16.1g',0.16,'SB0','Group member',NULL,NULL,NULL,1,195.070958333,28.06392,0.05,NULL,58698605168,917165705,14330714,16.1),(103611,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103611,36.09,0.21,165,43653,70,NULL,NULL,'2MASX J13001717+3942232',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'16.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,195.071417,39.70639,0,NULL,59087342073,923239719,14425620,16.6),(103612,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103612,37.09,0.54,262,43654,70,NULL,NULL,'2MASX J13001776-3338115',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,195.074083333,-33.63653,0.257,NULL,43322228066,676909813,10576715,15.3),(103613,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103613,34.56,0.44,81.7,43655,95,NULL,'Weighted Mean','NGC 4895',NULL,'1984ApJS...56...91D',1984,1,1.8,NULL,'G',0.000028,NULL,'14.0g',0.6,'SA0 pec sp','in a radial-velocity based grouping',NULL,NULL,NULL,1,195.0747083,28.20231,0.056,NULL,58698599995,917165624,14330712,14),(103614,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103614,34.82,0.46,92,43655,95,NULL,'Michard 1979a','NGC 4895',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103615,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103615,35.73,0.63,140,43655,95,NULL,'Michard 1979b, c','NGC 4895',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103616,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103616,34.57,0.25,82,43655,74.4,NULL,NULL,'NGC 4895',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103617,'Tertiary','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103617,34.15,0.35,67.6,43655,95,NULL,NULL,'NGC 4895',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103618,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103618,35.21,0.45,110,43655,NULL,NULL,'K','NGC 4895',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103619,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103619,35.45,0.4,123,43655,NULL,NULL,'mean','NGC 4895',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103620,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103620,37.61,0.46,333,43656,70,NULL,NULL,'2MASX J13001902+4029392',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000182,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,195.079333333,40.49422,0,NULL,59079510733,923117355,14423708,16.8),(103621,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103621,35.31,0.05,115,43657,70,NULL,NULL,'2MASX J13001914+2733135',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000033,NULL,'16.1b',0.44,'Elliptical','Group member',NULL,NULL,NULL,1,195.079583,27.55372,0.029,NULL,58699201748,917175027,14330859,16.1),(103622,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103622,35.29,0.48,114,43658,70,NULL,NULL,'ESO 575- G 044 NED02',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.06',NULL,'cE0: pec','Pair member (points to parent)',NULL,NULL,NULL,1,195.083375,-22.692,0.273,NULL,43792143882,684252248,10691441,15.06),(103623,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103623,33.68,0.49,54.5,43659,70,NULL,NULL,'NGC 4878',NULL,'2014MNRAS.445.2677S',2014,1,1.2,'NGC identification is not certain.','G',0.000117,NULL,'12.22',1,'SB(r)0+',NULL,NULL,NULL,NULL,1,195.0840417,-6.10383,0.053,NULL,43123409169,673803268,10528176,12.22),(103624,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103624,36.89,0.46,239,43660,70,NULL,NULL,'2MASX J13002073+0831470',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000179,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,195.086291667,8.52964,0,NULL,58961625039,921275391,14394927,16.3),(103625,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103625,37.14,0.46,268,43661,70,NULL,NULL,'2MASX J13002105+3059570',NULL,'2015arXiv151105856S',2015,1,0.38,'2003AJ....126.2152R has V = 10204 +- 68 km/s.','G',0.000179,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,195.087666667,30.99917,0.029,NULL,58677672664,916838635,14325603,16.7),(103626,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103626,37.51,0.33,317,43662,70,NULL,NULL,'2MASX J13002111+1909243',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,195.087875,19.15669,NULL,NULL,59035640794,922431887,14412998,17.4),(103627,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103627,37.51,0.33,317,43663,70,NULL,NULL,'2MASX J13002130+2934495',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000103,NULL,'17.6g',0.19,'LINER',NULL,NULL,NULL,NULL,1,195.088917,29.58036,0,NULL,58704081154,917251268,14332051,17.6),(103628,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103628,38,0.46,398,43664,70,NULL,NULL,'2MASX J13002145+5436097',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,195.0892917,54.60264,0,NULL,57423328689,897239510,14019367,18.2),(103629,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103629,37.07,0.46,259,43665,70,NULL,NULL,'2MASX J13002175+2108533',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,195.0905,21.14822,0.149,NULL,59024961233,922265019,14410390,17.8),(103630,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103630,34.46,0.44,78,43666,95,NULL,'Weighted Mean','IC 4026',NULL,'1984ApJS...56...91D',1984,1,0.34,NULL,'G',0.00003,NULL,'15.3g',0.26,'SB0','Group member',NULL,NULL,NULL,1,195.09225,28.047,0.05,NULL,58698604798,917165699,14330714,15.3),(103631,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103631,34.79,0.63,90.8,43666,95,NULL,'Michard 1979b, c','IC 4026',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103632,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103632,35.23,0.46,111,43666,95,NULL,'Michard 1979a','IC 4026',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103633,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103633,34.83,0.25,92.5,43666,74.4,NULL,NULL,'IC 4026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103634,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103634,35.31,0.05,115,43666,70,NULL,NULL,'IC 4026',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103635,'Tertiary','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103635,34.15,0.35,67.6,43666,95,NULL,NULL,'IC 4026',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103636,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103636,37.51,0.33,317,43667,70,NULL,NULL,'2MASX J13002280+1907533',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.98',0.17,NULL,NULL,NULL,NULL,NULL,1,195.0952083,19.13139,NULL,NULL,59035643667,922431932,14412998,17.98),(103637,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103637,38.9,0.46,602,43668,70,NULL,NULL,'SDSS J130023.10+070623.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,195.0962917,7.10656,0.012,NULL,58078332146,907473939,14179280,18.2),(103638,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103638,37.87,0.16,375,43669,70,NULL,NULL,'2MASX J13002370-0215353',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000073,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,195.0987083,-2.25992,0.021,NULL,43144554324,674133661,10533338,17.6),(103639,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103639,38.67,0.46,541,43670,70,NULL,NULL,'SDSS J130024.10+050918.6',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,195.100417,5.15519,0,NULL,58109918566,907967477,14186991,18.1),(103640,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103640,37.52,0.46,319,43671,70,NULL,NULL,'SDSS J130025.31+484859.5',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,195.1055,48.81656,0,NULL,59105491385,923523302,14430051,17.5),(103641,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103641,37.87,0.16,375,43672,70,NULL,NULL,'2MASX J13002550-0212013',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00006,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,195.106208333,-2.2005,0.037,NULL,43144559734,674133745,10533339,17.3),(103642,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103642,35.31,0.05,115,43673,70,NULL,NULL,'IC 4032',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000093,NULL,'15.0g',0.56,'E','Group member',NULL,NULL,NULL,1,195.106875,28.86781,0.052,NULL,58703910709,917248604,14332009,15),(103643,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103643,34.03,0.47,64.1,43674,NULL,NULL,'H','NGC 4877',NULL,'2007A&A...465...71T',2007,1,2.2,NULL,'G',0.000026,NULL,'13.08',1,'SA(s)ab:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,195.10975,-15.28344,0.029,NULL,44017378621,687771540,10746430,13.08),(103644,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103644,34.05,0.45,64.5,43674,NULL,NULL,'K','NGC 4877',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103645,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103645,34.07,0.46,65.1,43674,NULL,NULL,'J','NGC 4877',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103646,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103646,34.24,0.4,70.5,43674,NULL,NULL,'mean','NGC 4877',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103647,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103647,36.73,0.33,222,43675,70,NULL,NULL,'2MASX J13002634+2701416',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.62',0.3,NULL,'Group member',NULL,NULL,NULL,1,195.109875,27.02822,0,NULL,58698276641,917160572,14330633,17.62),(103648,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103648,34.52,0.23,80.2,43676,74.4,NULL,NULL,'2MASX J13002689+2730556',NULL,'2013AJ....146...86T',2013,1,0.51,NULL,'G',0.000019,NULL,'16.4b',0.46,'E','Group member',NULL,NULL,NULL,1,195.111917,27.51561,0.029,NULL,58699200724,917175011,14330859,16.4),(103649,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103649,35.31,0.05,115,43676,70,NULL,NULL,'2MASX J13002689+2730556',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103650,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103650,37.16,0.33,271,43677,70,NULL,NULL,'2MASX J13002745+0733453',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.24',0.19,NULL,NULL,NULL,NULL,NULL,1,195.114333,7.56264,0.019,NULL,58075988153,907437314,14178708,18.24),(103651,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103651,35.47,0.25,124,43678,74.4,NULL,NULL,'IC 4030',NULL,'2013AJ....146...86T',2013,1,0.39,NULL,'G',0.00004,NULL,'16.42',0.27,'SB0','Group member',NULL,NULL,NULL,1,195.116541667,27.95597,0.05,NULL,58698704333,917167255,14330738,16.42),(103652,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103652,35.25,0.46,112,43679,70,NULL,NULL,'2MASX J13002798+3422469',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000087,NULL,'15.9g',0.37,NULL,NULL,NULL,NULL,NULL,1,195.116791667,34.37969,0.022,NULL,58670867027,916732297,14323942,15.9),(103653,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103653,36.53,0.33,202,43680,70,NULL,NULL,'2MASX J13002864+5511387',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,195.119583,55.19419,0.013,NULL,57422783118,897230986,14019234,16.4),(103654,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103654,37.34,0.46,294,43681,70,NULL,NULL,'2MASX J13002926+3546119',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000179,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,195.121875,35.76992,0.009,NULL,59290714218,926417409,14475272,17),(103655,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103655,36.98,0.46,249,43682,70,NULL,NULL,'2MASX J13002988+1256445',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,195.1245,12.94581,0.032,NULL,58995533942,921805217,14403206,17.6),(103656,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103656,38.2,0.46,436,43683,70,NULL,NULL,'2MASX J13003050+6459351',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,195.1275,64.99308,0.025,NULL,57349145976,896080405,14001256,17.8),(103657,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103657,34,0.44,63.1,43684,95,NULL,'Weighted Mean','NGC 4896',NULL,'1984ApJS...56...91D',1984,1,1,NULL,'G',0.000037,NULL,'14.5g',0.6,'S0- pec:','Group member',NULL,NULL,NULL,1,195.12825,28.34622,0.056,NULL,58695835067,917122422,14330037,14.5),(103658,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103658,34.53,0.63,80.5,43684,95,NULL,'Michard 1979b, c','NGC 4896',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103659,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103659,34.57,0.46,82,43684,95,NULL,'Michard 1979a','NGC 4896',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103660,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103660,35.31,0.05,115,43684,70,NULL,NULL,'NGC 4896',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103661,'Tertiary','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103661,34.15,0.35,67.6,43684,95,NULL,NULL,'NGC 4896',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103662,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103662,34.78,0.4,90.4,43684,NULL,NULL,'mean','NGC 4896',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103663,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103663,34.95,0.45,97.6,43684,NULL,NULL,'K','NGC 4896',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103664,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103664,37.16,0.33,271,43685,70,NULL,NULL,'2MASX J13003183+0732333',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.99',0.14,NULL,NULL,NULL,NULL,NULL,1,195.1327083,7.54269,0.019,NULL,58076102792,907439106,14178736,18.99),(103665,'IRAS','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103665,32.43,0.8,30.6,43686,75,NULL,'MAT, I','ESO 381- G 041',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'14.94',0.5,'IB(s)m:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,195.1327917,-34.37386,0.233,NULL,43319664282,676869754,10576089,14.94),(103666,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103666,30.48,0.32,12.5,43686,85,NULL,'I, inv','ESO 381- G 041',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103667,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103667,30.55,0.32,12.9,43686,85,NULL,'I, raw','ESO 381- G 041',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103668,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103668,31.11,0.43,16.7,43686,75,NULL,'MAT, I, inv','ESO 381- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103669,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103669,31.3,0.43,18.2,43686,75,NULL,'MAT, I, raw','ESO 381- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103670,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103670,31.62,0.43,21.1,43686,75,NULL,'MAT, I, cor','ESO 381- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103671,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103671,31.91,0.4,24.1,43686,NULL,NULL,NULL,'ESO 381- G 041',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103672,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103672,34.23,0.48,70.1,43687,70,NULL,NULL,'ESO 269- G 031',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000083,NULL,'14.36',0.9,'SA0-: pec',NULL,NULL,NULL,NULL,1,195.13325,-45.41467,0.413,NULL,46730337431,730161522,11408773,14.36),(103673,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103673,36.73,0.33,222,43688,70,NULL,NULL,'2MASX J13003211+2658236',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00014,NULL,'16.0g',0.38,NULL,'Group member',NULL,NULL,NULL,1,195.133667,26.97311,0,NULL,58696458298,917132160,14330190,16),(103674,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103674,38.41,0.23,482,43689,70,NULL,NULL,'2MASX J13003250+2155203',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00012,NULL,'17.57',0.32,NULL,NULL,NULL,NULL,NULL,1,195.135666667,21.92222,0.119,NULL,59024765271,922261957,14410343,17.57),(103675,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103675,37.87,0.16,375,43690,70,NULL,NULL,'2MASX J13003280-0201469',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000067,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,195.136583333,-2.02961,0,NULL,43144301344,674129708,10533276,18.4),(103676,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103676,38.41,0.23,482,43691,70,NULL,NULL,'SDSS J130033.17+221306.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'19.38',0.11,NULL,NULL,NULL,NULL,NULL,1,195.13825,22.21836,0.084,NULL,58805964351,918843192,14356924,19.38),(103677,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103677,35.69,0.46,138,43692,70,NULL,NULL,'CGCG 294-009',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000162,NULL,'15.4g',0.39,'S0',NULL,NULL,NULL,NULL,1,195.141541667,58.98253,0,NULL,57439698248,897495285,14023363,15.4),(103678,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103678,37.56,0.15,325,43693,70,NULL,NULL,'2MASX J13003411+0111552',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000084,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,195.142,1.19856,0,NULL,58090674775,907666793,14182293,17.3),(103679,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103679,37.87,0.16,375,43694,70,NULL,NULL,'2MASX J13003426-0208029',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000099,NULL,'16.2g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,195.14275,-2.13408,0.037,NULL,43144268614,674129197,10533268,16.2),(103680,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103680,34.98,0.61,99,43695,70,NULL,NULL,'2MASX J13003457-7653376',NULL,'2014MNRAS.445.2677S',2014,1,0.12,NULL,'G',0.00015,NULL,'17.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,195.1437917,-76.89381,0.701,NULL,44181904919,690342264,10786597,17.6),(103681,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103681,37.04,0.46,256,43696,70,NULL,NULL,'2MASX J13003472+0724483',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.77',0.14,NULL,NULL,NULL,NULL,NULL,1,195.1447917,7.41339,0.019,NULL,58076076552,907438696,14178729,18.77),(103682,'Tully est','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103682,32.54,0.8,32.2,43697,75,NULL,NULL,'UGCA 317',NULL,'1988NBGC.C....0000T',1988,1,0.82,NULL,'G',0.00001,NULL,'15.4g',0.37,'S0/a?',NULL,NULL,NULL,NULL,1,195.1455,64.44714,0.025,NULL,57352635922,896134936,14002108,15.4),(103683,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103683,37.87,0.16,375,43698,70,NULL,NULL,'2MASX J13003540-0209069',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000092,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,195.147375,-2.15194,0.037,NULL,43144268165,674129190,10533268,17.1),(103684,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103684,35.08,0.1,104,43699,NULL,NULL,NULL,'KUG 1258+278',NULL,'2009ApJS..182..474S',2009,1,0.82,NULL,'G',0.000037,NULL,'15.7g',0.24,'Sbc            HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,195.148667,27.57408,0.029,NULL,58699191479,917174866,14330857,15.7),(103685,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103685,37.56,0.15,325,43700,70,NULL,NULL,'2MASX J13003577+0107372',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000076,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,195.149083,1.12692,0,NULL,58090671865,907666747,14182292,17.4),(103686,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103686,37.4,0.46,301,43701,70,NULL,NULL,'2MASX J13003630+0850443',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000191,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,195.151333,8.84561,0,NULL,58970744947,921417889,14397154,16.7),(103687,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103687,37.87,0.16,375,43702,70,NULL,NULL,'2MASX J13003733-0209359',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000087,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,195.1555,-2.16006,0.037,NULL,43144545835,674133528,10533336,18),(103688,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103688,35.39,0.61,120,43703,70,NULL,NULL,'2MASX J13003749-0748410',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00014,NULL,'15.45',NULL,NULL,NULL,NULL,NULL,NULL,1,195.15625,-7.81139,0.117,NULL,43124143536,673814742,10528355,15.45),(103689,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103689,38.37,0.46,472,43704,70,NULL,NULL,'SDSS J130037.76+081704.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,195.157375,8.28469,0,NULL,58961510784,921273606,14394900,18.1),(103690,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103690,35.07,0.1,103,43705,NULL,NULL,NULL,'IC 4040',NULL,'2009ApJS..182..474S',2009,1,0.7,'Multiple SDSS entries describe this object.','G',0.000017,NULL,'15.36',0.3,'Sdm:           HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,195.1580417,28.05736,0.05,NULL,58698733315,917167708,14330745,15.36),(103691,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103691,37.9,0.46,380,43706,70,NULL,NULL,'2MASX J13003774+2955092',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000147,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,195.1575,29.91931,0,NULL,58674590114,916790470,14324851,18.4),(103692,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103692,36.73,0.33,222,43707,70,NULL,NULL,'2MASX J13003836+0704533',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.72',0.22,NULL,NULL,NULL,NULL,NULL,1,195.15975,7.08144,0.012,NULL,58078345010,907474140,14179283,17.72),(103693,'SNII optical','2016-12-15 15:15:09','2016-12-16 11:20:20','1','SN 1999br',NULL,103693,31.6,0.43,20.8,43708,NULL,NULL,'SEAM','NGC 4900',0.003201,'2009ApJ...694.1067P',2009,1,1.93,'Multiple SDSS entries describe this object.','G',0.000009,NULL,'12.2g',1.67,'SB(rs)c;WR     HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,195.1635417,2.50072,0,NULL,58106808268,907918879,14186232,12.2),(103694,'SNII optical','2016-12-15 15:15:09','2016-12-16 11:20:20','1','SN 1999br',NULL,103694,31.67,0.48,21.6,43708,NULL,NULL,'SCM, B','NGC 4900',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103695,'SNII optical','2016-12-15 15:15:09','2016-12-16 11:20:20','1','SN 1999br',NULL,103695,31.86,0.31,23.6,43708,NULL,NULL,'SCM, BVI','NGC 4900',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103696,'SNII optical','2016-12-15 15:15:09','2016-12-16 11:20:20','1','SN 1999br',NULL,103696,31.89,0.59,23.9,43708,NULL,NULL,'SCM, V','NGC 4900',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103697,'SNII optical','2016-12-15 15:15:09','2016-12-16 11:20:20','1','SN 1999br',NULL,103697,32.1,0.57,26.3,43708,NULL,NULL,'SCM, I','NGC 4900',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103698,'SNII optical','2016-12-15 15:15:09','2016-12-16 11:20:20','1','SN 1999br',NULL,103698,32.11,0.15,26.4,43708,NULL,NULL,'V, photospheric magnitude method','NGC 4900',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103699,'SNII optical','2016-12-15 15:15:09','2016-12-16 11:20:20','1','SN 1999br',NULL,103699,32.11,0.07,26.4,43708,NULL,NULL,'I, photospheric magnitude method','NGC 4900',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103700,'SNII optical','2016-12-15 15:15:09','2016-12-16 11:20:20','1','SN 1999br',NULL,103700,32.98,0.68,39.5,43708,NULL,NULL,'EPM D05','NGC 4900',NULL,'2009ApJ...696.1176J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103701,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103701,31.19,0.4,17.3,43708,75,NULL,'B','NGC 4900',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103702,'D-Sigma','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103702,34.86,0.4,93.8,43709,75,NULL,'Edat, raw','NGC 4906',NULL,'1997ApJS..109..333W',1997,1,0.48,NULL,'G',0.000025,NULL,'14.9g',0.43,'E3','Group member',NULL,NULL,NULL,1,195.165708333,27.92389,0.05,NULL,58698707596,917167306,14330739,14.9),(103703,'D-Sigma','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103703,34.89,0.4,95,43709,75,NULL,'Edat, cor','NGC 4906',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103704,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103704,34.44,0.44,77.3,43709,95,NULL,'Weighted Mean','NGC 4906',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103705,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103705,34.8,0.63,91.2,43709,95,NULL,'Michard 1979b, c','NGC 4906',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103706,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103706,35.18,0.46,109,43709,95,NULL,'Michard 1979a','NGC 4906',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103707,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103707,34.84,0.22,92.9,43709,74.4,NULL,NULL,'NGC 4906',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103708,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103708,35.07,0.09,103,43709,70,NULL,NULL,'NGC 4906',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103709,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103709,35.31,0.05,115,43709,70,NULL,NULL,'NGC 4906',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103710,'Tertiary','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103710,34.15,0.35,67.6,43709,95,NULL,NULL,'NGC 4906',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103711,'IRAS','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103711,35.06,0.8,103,43710,75,NULL,'HMCL, I','IC 0842',NULL,'1997ApJS..109..333W',1997,1,1.19,NULL,'G',0.000013,NULL,'14.5g',0.62,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,195.1647917,29.01942,0.046,NULL,58704491717,917257683,14332151,14.5),(103712,'IRAS','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103712,35.07,0.8,103,43710,75,NULL,'W91CL, r','IC 0842',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103713,'IRAS','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103713,35.09,0.8,104,43710,75,NULL,'CF, r','IC 0842',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103714,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103714,34.39,NULL,75.5,43710,NULL,NULL,NULL,'IC 0842',NULL,'1993MNRAS.263..211R',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103715,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103715,34.68,0.38,86.3,43710,75,NULL,'W91CL, r, raw','IC 0842',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103716,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103716,34.75,0.4,89.1,43710,75,NULL,'HMCL, I, raw','IC 0842',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103717,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103717,34.83,0.38,92.6,43710,75,NULL,'W91CL, r, inv','IC 0842',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103718,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103718,34.87,0.38,94.4,43710,75,NULL,'W91CL, r, cor','IC 0842',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103719,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103719,34.91,0.38,95.8,43710,75,NULL,'CF, r, raw','IC 0842',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103720,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103720,34.92,0.4,96.4,43710,75,NULL,'HMCL, I, cor','IC 0842',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103721,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103721,34.94,0.4,97.4,43710,75,NULL,'HMCL, I, inv','IC 0842',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103722,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103722,34.95,0.43,97.8,43710,75,NULL,'3.6 micron, color corrected','IC 0842',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103723,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103723,34.97,0.2,98.6,43710,74.4,NULL,NULL,'IC 0842',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103724,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103724,34.99,0.38,99.6,43710,75,NULL,'CF, r, cor','IC 0842',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103725,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103725,35.06,0.43,103,43710,75,NULL,'3.6 micron, color + selection bias corrected','IC 0842',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103726,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103726,35.07,0.38,103,43710,75,NULL,'CF, r, inv','IC 0842',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103727,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103727,35.16,0.06,108,43710,NULL,NULL,NULL,'IC 0842',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103728,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103728,35.2,0.4,109,43710,NULL,NULL,'mean','IC 0842',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103729,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103729,35.46,0.47,124,43710,NULL,NULL,'H','IC 0842',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103730,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103730,37.23,0.46,280,43711,70,NULL,NULL,'SDSS J130040.28+073614.9',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,195.167833,7.60417,0.023,NULL,58076003490,907437554,14178711,17.5),(103731,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103731,34.91,0.23,95.9,43712,74.4,NULL,NULL,'IC 4041',NULL,'2013AJ....146...86T',2013,1,0.62,NULL,'G',0.000028,NULL,'15.4g',0.45,'SA0','Group member',NULL,NULL,NULL,1,195.1702083,27.99661,0.05,NULL,58698751823,917167997,14330749,15.4),(103732,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103732,35.31,0.05,115,43712,70,NULL,NULL,'IC 4041',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103733,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103733,38.41,0.23,482,43713,70,NULL,NULL,'2MASX J13004087+2212243',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,195.170417,22.20675,0.084,NULL,58805962065,918843157,14356924,18.1),(103734,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103734,37.8,0.14,363,43714,70,NULL,NULL,'LCRS B125806.4-031146',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000072,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,195.171541667,-3.46558,0.017,NULL,43150605524,674228211,10534815,17.8),(103735,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103735,37.87,0.16,375,43715,70,NULL,NULL,'2MASX J13004207-0206579',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000082,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,195.1752917,-2.11625,0.037,NULL,43144268973,674129202,10533268,17.9),(103736,'SNIa','2016-12-15 15:15:09','2016-12-16 11:20:20','1','SN 2006bz',NULL,103736,35.06,0.1,103,43716,74.4,NULL,NULL,'IC 4042A',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.00003,NULL,'15.7g',0.4,'SB0','Group member',NULL,NULL,NULL,1,195.1785,27.96311,0.05,NULL,58698749087,917167954,14330749,15.7),(103737,'SNIa','2016-12-15 15:15:09','2016-12-16 11:20:20','1','SN 2006bz',NULL,103737,35.31,0.19,112,43716,65,NULL,'MLCS31','IC 4042A',0.027906,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103738,'SNIa','2016-12-15 15:15:09','2016-12-16 11:20:20','1','SN 2006bz',NULL,103738,35.38,0.16,116,43716,65,NULL,'MLCS17','IC 4042A',0.027906,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103739,'SNIa','2016-12-15 15:15:09','2016-12-16 11:20:20','1','SN 2006bz',NULL,103739,35.64,0.17,131,43716,65,NULL,'SALT','IC 4042A',0.027906,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103740,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103740,34.31,0.44,72.8,43717,95,NULL,'Weighted Mean','IC 4042',NULL,'1984ApJS...56...91D',1984,1,0.56,NULL,'G',0.000027,NULL,'14.9g',0.48,'SA0/a          AGN','Group member',NULL,NULL,NULL,1,195.178208333,27.97139,0.05,NULL,58698749789,917167965,14330749,14.9),(103741,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103741,34.75,0.63,89.1,43717,95,NULL,'Michard 1979b, c','IC 4042',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103742,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103742,34.98,0.46,99.1,43717,95,NULL,'Michard 1979a','IC 4042',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103743,'Tertiary','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103743,34.15,0.35,67.6,43717,95,NULL,NULL,'IC 4042',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103744,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103744,32.21,0.67,27.7,43718,95,NULL,'Weighted Mean','NGC 4914',NULL,'1984ApJS...56...91D',1984,1,3.5,NULL,'G',0.000083,NULL,'12.49',1.9,'E+','in a radial-velocity based grouping',NULL,NULL,NULL,1,195.1789583,37.31528,0,NULL,59076284685,923066948,14422921,12.49),(103745,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103745,32.21,0.67,27.7,43718,95,NULL,'de Vaucouleurs','NGC 4914',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103746,'Tertiary','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103746,33.38,0.5,47.4,43718,95,NULL,NULL,'NGC 4914',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103747,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103747,38.32,0.46,461,43719,70,NULL,NULL,'SDSS J130042.90+080040.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,195.1787917,8.01131,0.01,NULL,58962355691,921286807,14395106,18.3),(103748,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103748,37.24,0.46,281,43720,70,NULL,NULL,'2MASX J13004294+1749345',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.42',0.15,NULL,NULL,NULL,NULL,NULL,1,195.178875,17.82636,0.09,NULL,59045419687,922584682,14415385,18.42),(103749,'Tully est','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103749,31.8,0.8,22.9,43721,75,NULL,NULL,'DDO 159',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000026,NULL,'16',1.5,'IB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,195.181375,-15.71544,0.029,NULL,44018029263,687781707,10746589,16),(103750,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103750,35.31,0.05,115,43722,70,NULL,NULL,'CGCG 160-089',NULL,'2015arXiv151105856S',2015,1,0.87,NULL,'G',0.00004,NULL,'15.3g',0.43,'SAB0','Group member',NULL,NULL,NULL,1,195.184291667,28.33728,0.057,NULL,58695659311,917119676,14329994,15.3),(103751,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103751,37.45,0.46,309,43723,70,NULL,NULL,'2MASX J13004448+1137203',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,195.1855417,11.62239,0.044,NULL,58964622701,921322229,14395659,18),(103752,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103752,34.42,0.25,76.6,43724,74.4,NULL,NULL,'2MASX J13004459+2806026',NULL,'2013AJ....146...86T',2013,1,0.44,NULL,'G',0.000023,NULL,'16.69',0.18,'S0','Group member',NULL,NULL,NULL,1,195.186,28.10064,0.057,NULL,58698743676,917167869,14330747,16.69),(103753,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103753,37.81,0.46,365,43725,70,NULL,NULL,'2MASX J13004599+2513076',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,195.19175,25.21883,NULL,NULL,58688023487,917000366,14328130,18.2),(103754,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103754,38.26,0.46,448,43726,70,NULL,NULL,'2MASX J13004607-0228079',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00009,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,195.191875,-2.46881,0.037,NULL,43144662160,674135346,10533364,17.5),(103755,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103755,38.2,0.46,437,43727,70,NULL,NULL,'2MASX J13004687+3148432',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000133,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,195.195375,31.81211,0.046,NULL,58676348814,916817950,14325280,17.6),(103756,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103756,35.11,0.25,105,43728,74.4,NULL,NULL,'IC 4044',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.00003,NULL,'16.1g',0.29,'S0i','Group member',NULL,NULL,NULL,1,195.1975417,27.92217,0.05,NULL,58698700693,917167198,14330737,16.1),(103757,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103757,36.94,0.46,244,43729,70,NULL,NULL,'2MASX J13004813+0329592',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000085,NULL,'17.0g',0.27,'NLAGN',NULL,NULL,NULL,NULL,1,195.200583,3.49983,0.071,NULL,58115664023,908057250,14188394,17),(103758,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103758,38.01,0.46,400,43730,70,NULL,NULL,'2MASX J13004851+1915160',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,195.202083,19.2545,NULL,NULL,59035624785,922431637,14412994,17.1),(103759,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103759,37.56,0.15,325,43731,70,NULL,NULL,'2MASX J13004865+0101062',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000297,NULL,'17.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,195.202625,1.01842,0,NULL,58090868114,907669814,14182340,17.4),(103760,'D-Sigma','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103760,34.86,0.4,93.8,43732,75,NULL,'Edat, raw','IC 4045',NULL,'1997ApJS..109..333W',1997,1,0.8,NULL,'G',0.000022,NULL,'14.8g',0.5,'E/SA0          AGN','Group member',NULL,NULL,NULL,1,195.202667,28.09078,0.057,NULL,58698743313,917167864,14330747,14.8),(103761,'D-Sigma','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103761,34.89,0.4,95,43732,75,NULL,'Edat, cor','IC 4045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103762,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103762,34.86,0.23,93.8,43732,74.4,NULL,NULL,'IC 4045',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103763,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103763,35.31,0.05,115,43732,70,NULL,NULL,'IC 4045',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103764,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103764,34.29,0.51,72.1,43733,70,NULL,NULL,'2MASX J13004876-1200252',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000077,NULL,'15.51',NULL,NULL,NULL,NULL,NULL,NULL,1,195.203083,-12.00711,0.069,NULL,43965950952,686967983,10733874,15.51),(103765,'Ring Diameter','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103765,33.9,0.84,60,43734,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4907',NULL,'1981ApJS...45..541P',1981,1,1.1,NULL,'G',0.000033,NULL,'14.1g',1,'SB(r)b         LINER','Group member',NULL,NULL,NULL,1,195.203333,28.15833,0.057,NULL,58698516463,917164319,14330692,14.1),(103766,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103766,37.28,0.75,285,43735,70,NULL,NULL,'2MASX J13005003-4841084',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,195.208666667,-48.68569,0.849,NULL,46740869758,730326089,11411345,17.6),(103767,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103767,35.3,0.22,115,43736,74.4,NULL,NULL,'IC 4051',NULL,'2013AJ....146...86T',2013,1,1,'The identifications of IC 4051 and NGC 4908 are often confused.','G',0.000031,NULL,'14.6g',0.9,'E5             PAS','Group member',NULL,NULL,NULL,1,195.214833333,28.04281,0.05,NULL,58698737687,917167776,14330746,14.6),(103768,'GCLF','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103768,35,0.2,100,43737,NULL,NULL,NULL,'NGC 4908',NULL,'2000AJ....119.2699W',2000,1,1,'The identifications of IC 4051 and NGC 4908 are often confused.','G',0.00004,NULL,'14.1g',0.9,'E2','Group member',NULL,NULL,NULL,1,195.226917,28.00764,0.05,NULL,58698759008,917168109,14330751,14.1),(103769,'GCLF','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103769,35.07,0.17,103,43737,NULL,NULL,'M87 GCLF','NGC 4908',NULL,'1997AJ....113.1483B',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103770,'GCLF','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103770,35.08,0.2,104,43737,NULL,NULL,NULL,'NGC 4908',NULL,'2002ApJ...567..294O',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103771,'GCLF','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103771,35.11,0.12,105,43737,NULL,NULL,'mean','NGC 4908',NULL,'1997AJ....113.1483B',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103772,'GCLF','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103772,35.15,0.16,107,43737,NULL,NULL,'MW+M31GC','NGC 4908',NULL,'1997AJ....113.1483B',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103773,'D-Sigma','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103773,34.86,0.4,93.8,43737,75,NULL,'Edat, raw','NGC 4908',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103774,'D-Sigma','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103774,34.89,0.4,95,43737,75,NULL,'Edat, cor','NGC 4908',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103775,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103775,34.88,0.44,94.6,43737,95,NULL,'Weighted Mean','NGC 4908',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103776,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103776,35.39,0.46,120,43737,95,NULL,'Michard 1979a','NGC 4908',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103777,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103777,35.74,0.63,141,43737,95,NULL,'Michard 1979b, c','NGC 4908',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103778,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103778,34.7,0.25,87.1,43737,74.4,NULL,NULL,'NGC 4908',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103779,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103779,35.31,0.05,115,43737,70,NULL,NULL,'NGC 4908',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103780,'Tertiary','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103780,34.15,0.35,67.6,43737,95,NULL,NULL,'NGC 4908',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103781,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103781,34.46,0.4,78.1,43737,NULL,NULL,'mean','NGC 4908',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103782,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103782,35.69,0.45,138,43737,NULL,NULL,'K','NGC 4908',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103783,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103783,34.94,0.25,97.3,43738,74.4,NULL,NULL,'CGCG 160-091',NULL,'2013AJ....146...86T',2013,1,0.85,NULL,'G',0.000077,NULL,'14.5g',0.5,'SB0','Group member',NULL,NULL,NULL,1,195.2170417,28.36592,0.057,NULL,58695667505,917119804,14329996,14.5),(103784,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103784,35.31,0.05,115,43738,70,NULL,NULL,'CGCG 160-091',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103785,'Ring Diameter','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103785,33.5,0.84,51,43739,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4897',NULL,'1981ApJS...45..541P',1981,1,2.6,'Misidentified as NGC 4891 in many catalogs.','G',0.000013,NULL,'12.60',2.3,'SAB(r)bc:      Sy','Group member, radial-velocity confirmed',NULL,NULL,'Sy 2',1,195.220625,-13.44981,0.041,NULL,43967337966,686989655,10734213,12.6),(103786,'Sosies','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103786,33.45,0.59,49,43739,NULL,NULL,NULL,'NGC 4897',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103787,'Tully est','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103787,32.85,0.8,37.1,43739,75,NULL,NULL,'NGC 4897',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103788,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103788,33.04,0.4,40.5,43739,NULL,NULL,'mean','NGC 4897',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103789,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103789,33.35,0.47,46.9,43739,NULL,NULL,'H','NGC 4897',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103790,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103790,33.41,0.45,48,43739,NULL,NULL,'K','NGC 4897',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103791,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103791,33.42,0.46,48.3,43739,NULL,NULL,'J','NGC 4897',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103792,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103792,36.93,0.46,244,43740,70,NULL,NULL,'2MASX J13005339+4551137',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000173,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,195.2224583,45.85383,0,NULL,59100191252,923440488,14428757,17.2),(103793,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103793,35.04,0.49,102,43741,75,NULL,'IR','ESO 381- G 045',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.48',0.2,'Sb:',NULL,NULL,NULL,NULL,1,195.226917,-36.12069,0.197,NULL,46925950550,733217977,11456530,15.48),(103794,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103794,35.3,0.2,115,43741,74.4,NULL,NULL,'ESO 381- G 045',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103795,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103795,35.39,0.35,120,43741,NULL,NULL,NULL,'ESO 381- G 045',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103796,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103796,35.48,0.33,125,43741,NULL,NULL,'Malmquist cor.','ESO 381- G 045',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103797,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103797,37.8,0.14,363,43742,70,NULL,NULL,'LCRS B125820.0-031945',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000079,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,195.2282917,-3.59844,0.013,NULL,43150837259,674231832,10534872,18),(103798,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103798,38.11,0.46,419,43743,70,NULL,NULL,'2MASX J13005541-0014079',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00008,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,195.230875,-0.23544,0,NULL,43110669288,673604207,10525065,17.6),(103799,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103799,37.56,0.15,325,43744,70,NULL,NULL,'2MASX J13005578+0102312',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000089,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,195.2325,1.042,0,NULL,58090753268,907668019,14182312,16.9),(103800,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103800,35.07,0.05,103,43745,NULL,NULL,NULL,'NGC 4911',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000017,NULL,'13.55',1.3,'SAB(r)bc       AGN','in a radial-velocity based grouping',NULL,NULL,NULL,1,195.233666667,27.79083,0.052,NULL,58698675184,917166799,14330731,13.55),(103801,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103801,32.46,0.47,31,43746,NULL,NULL,'H','NGC 4899',NULL,'2007A&A...465...71T',2007,1,2.6,NULL,'G',0.000023,NULL,'12.39',1.4,'SAB(rs)c:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,195.2359583,-13.94422,0.065,NULL,43967645971,686994468,10734288,12.39),(103802,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103802,32.49,0.45,31.4,43746,NULL,NULL,'K','NGC 4899',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103803,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103803,32.5,0.46,31.6,43746,NULL,NULL,'J','NGC 4899',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103804,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103804,32.92,0.4,38.4,43746,75,NULL,'B','NGC 4899',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103805,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103805,33.06,0.4,40.9,43746,NULL,NULL,'mean','NGC 4899',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103806,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103806,38.41,0.23,482,43747,70,NULL,NULL,'2MASX J13005691+2156260',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,195.237333,21.94058,0.114,NULL,58805821176,918840955,14356889,17),(103807,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103807,36.9,0.46,240,43748,70,NULL,NULL,'2MASX J13005711+5700286',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000167,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,195.237875,57.00803,0,NULL,57443798746,897559355,14024364,16.4),(103808,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103808,38.12,0.46,421,43749,70,NULL,NULL,'2MASX J13005760+0857399',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,195.2400417,8.96103,0.005,NULL,58970765006,921418203,14397159,17.3),(103809,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103809,37.93,0.46,386,43750,70,NULL,NULL,'2MASX J13005789+4036509',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,195.2412083,40.61422,0,NULL,59079479233,923116863,14423700,17.6),(103810,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103810,30.81,0.4,14.6,43751,NULL,NULL,NULL,'HIPASS J1300-13B',NULL,'2013MNRAS.429.2677K',2013,1,NULL,NULL,'G',0.000017,NULL,NULL,NULL,'SBm(pec)',NULL,NULL,NULL,NULL,1,195.241667,-13.52417,0.065,NULL,43967559533,686993117,10734267,NULL),(103811,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103811,36.73,0.33,222,43752,70,NULL,NULL,'2MASX J13005834+0655439',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'18.06',0.19,NULL,NULL,NULL,NULL,NULL,1,195.243125,6.92889,0.012,NULL,58078394620,907474915,14179295,18.06),(103812,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103812,37.56,0.15,325,43753,70,NULL,NULL,'2MASX J13005853+0050163',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000076,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,195.243833333,0.83797,0,NULL,58090912486,907670507,14182351,16.9),(103813,'SNIa','2016-12-15 15:15:09','2016-12-16 11:20:20','1','SN 2003ai',NULL,103813,35.38,0.2,115,43754,74.2,NULL,'SALT 2','IC 4062',0.0369,'2010ApJ...716..712A',2010,1,0.46,'UGC says CGCG 1258.8+4007 is incorrectly identified as IC 4062.','G',0.000091,NULL,'16.2g',0.41,NULL,'Group member, radial-velocity confirmed',NULL,NULL,NULL,1,195.244333,39.85894,0,NULL,59087386256,923240410,14425631,16.2),(103814,'SNIa','2016-12-15 15:15:09','2016-12-16 11:20:20','1','SN 2003ai',NULL,103814,35.96,0.1,156,43754,74.4,NULL,NULL,'IC 4062',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103815,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103815,37.56,0.15,325,43755,70,NULL,NULL,'SDSS J130058.64+011503.7',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000078,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,195.244333,1.25106,0,NULL,58090838131,907669345,14182333,17.7),(103816,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103816,30.88,0.43,15,43756,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4904',NULL,'2014MNRAS.444..527S',2014,1,2.2,'Multiple SDSS entries describe this object.','G',0.000003,NULL,'12.6B',1.4,'SB(s)cd;HII;WR Sbrst','Group member, radial-velocity confirmed',NULL,NULL,'Starburst',1,195.244417,-0.02761,0,NULL,43110657844,673604028,10525062,12.6),(103817,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103817,31.02,0.43,16,43756,75,NULL,'3.6 micron, color corrected','NGC 4904',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103818,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103818,31.25,0.2,17.8,43756,74.4,NULL,NULL,'NGC 4904',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103819,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103819,31.27,0.4,17.9,43756,NULL,NULL,NULL,'NGC 4904',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103820,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103820,31.5,0.4,20,43756,NULL,NULL,NULL,'NGC 4904',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103821,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103821,31.56,0.52,20.5,43756,NULL,NULL,'Malmquist cor.','NGC 4904',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103822,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103822,31.58,0.4,20.7,43756,NULL,NULL,'mean','NGC 4904',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103823,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103823,31.68,0.49,21.6,43756,NULL,NULL,NULL,'NGC 4904',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103824,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103824,31.79,NULL,22.8,43756,72,NULL,NULL,'NGC 4904',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103825,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103825,32.1,0.46,26.4,43756,NULL,NULL,'J','NGC 4904',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103826,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103826,32.11,0.47,26.4,43756,NULL,NULL,'H','NGC 4904',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103827,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103827,32.11,0.45,26.4,43756,NULL,NULL,'K','NGC 4904',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103828,'Ring Diameter','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103828,32.5,0.84,31,43757,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4902',NULL,'1981ApJS...45..541P',1981,1,3,NULL,'G',0.000017,NULL,'11.61',2.7,'SB(r)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,195.248875,-14.51364,0.069,NULL,43968914962,687014296,10734598,11.61),(103829,'Tully est','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103829,32.97,0.8,39.2,43757,75,NULL,'B','NGC 4902',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103830,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103830,36.16,0.46,171,43758,70,NULL,NULL,'SDSS J130059.84+113928.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,195.249375,11.65792,0.044,NULL,58964610374,921322037,14395656,17.3),(103831,'D-Sigma','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103831,33.65,0.4,53.7,43759,75,NULL,'Edat, raw','ESO 443- G 024',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000022,NULL,'12.9',1.5,'SA(s)0-;cD    blazar','Group member, radial-velocity confirmed',NULL,'radio jet',NULL,1,195.253291667,-32.44131,0.301,NULL,43332480763,677070011,10579218,12.9),(103832,'D-Sigma','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103832,34.1,0.4,65.9,43759,75,NULL,'Edat, cor','ESO 443- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103833,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103833,33.84,0.25,58.6,43759,74.4,NULL,NULL,'ESO 443- G 024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103834,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103834,34,0.45,63,43759,NULL,NULL,'K','ESO 443- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103835,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103835,34.35,0.4,74.2,43759,NULL,NULL,'mean','ESO 443- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103836,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103836,33.7,0.42,55,43760,NULL,NULL,'Malmquist cor.','ESO 381- G 046',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000023,NULL,'15',0.6,'Sc             HII',NULL,NULL,NULL,NULL,1,195.2580417,-35.93161,0.197,NULL,46925984566,733218508,11456539,15),(103837,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103837,33.74,0.2,56,43760,74.4,NULL,NULL,'ESO 381- G 046',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103838,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103838,33.85,0.39,58.8,43760,NULL,NULL,NULL,'ESO 381- G 046',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103839,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103839,34.15,0.4,67.5,43760,NULL,NULL,'mean','ESO 381- G 046',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103840,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103840,34.34,0.47,73.7,43760,NULL,NULL,'H','ESO 381- G 046',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103841,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103841,36.12,0.46,167,43761,70,NULL,NULL,'2MASX J13010210+5211210',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000158,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,195.258917,52.18925,0,NULL,57194901873,893670341,13963599,16.5),(103842,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103842,37.93,0.09,386,43762,70,NULL,NULL,'LCRS B125828.5-023315',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000092,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,195.2627083,-2.82342,0.021,NULL,43144138104,674127157,10533236,17.5),(103843,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103843,36.25,0.79,178,43763,70,NULL,NULL,'2MASX J13010353-2212203',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.41',NULL,NULL,NULL,NULL,NULL,NULL,1,195.2647917,-22.20564,0.297,NULL,43791144925,684236639,10691197,16.41),(103844,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103844,31.94,0.4,24.4,43764,NULL,NULL,NULL,'UGC 08127',NULL,'2013MNRAS.429.2677K',2013,1,1.51,NULL,'G',0.000017,NULL,'15.5g',0.38,'IB(s)m:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,195.2652917,-1.95339,0,NULL,43144435331,674131802,10533309,15.5),(103845,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103845,32.31,NULL,29,43764,72,NULL,NULL,'UGC 08127',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103846,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103846,36.62,0.46,211,43765,70,NULL,NULL,'SDSS J130104.50+101538.7',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.2g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,195.26875,10.26078,0.022,NULL,58969150672,921392979,14396765,17.2),(103847,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103847,37.56,0.15,325,43766,70,NULL,NULL,'2MASX J13010493+0104283',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000075,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,195.2705,1.07444,0,NULL,58090759309,907668114,14182314,17.4),(103848,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103848,37.04,0.46,256,43767,70,NULL,NULL,'2MASX J13010527+3421357',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000156,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,195.271833333,34.35986,0.022,NULL,58670866328,916732286,14323941,17.1),(103849,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103849,38.15,0.46,426,43768,70,NULL,NULL,'2MASX J13010526+6152112',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000138,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,195.2722083,61.86986,0.009,NULL,57357044794,896203824,14003184,18.3),(103850,'D-Sigma','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103850,34.15,0.4,67.7,43769,75,NULL,'Edat, raw','ESO 381- G 047',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000022,NULL,'13.99',1.1,'(R)SA(r)0+',NULL,NULL,NULL,NULL,1,195.2725,-35.61656,0.133,NULL,46925893985,733217093,11456517,13.99),(103851,'D-Sigma','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103851,34.49,0.4,79,43769,75,NULL,'Edat, cor','ESO 381- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103852,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103852,37.16,0.46,271,43770,70,NULL,NULL,'2MASX J13010561+1015339',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,195.2732917,10.25953,0.022,NULL,58969106669,921392291,14396754,17.2),(103853,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103853,37.56,0.15,325,43771,70,NULL,NULL,'2MASX J13010566+0045303',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000097,NULL,'15.9g',0.46,'E0',NULL,NULL,NULL,NULL,1,195.273666667,0.75839,0,NULL,58090888726,907670136,14182345,15.9),(103854,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103854,37.65,0.46,338,43772,70,NULL,NULL,'2MASX J13010654+1134289',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,195.277125,11.57458,0.044,NULL,58964793522,921324898,14395701,17.4),(103855,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103855,36.09,0.21,165,43773,70,NULL,NULL,'IC 4064',NULL,'2015arXiv151105856S',2015,1,1.28,'Often mistakenly called IC 4062.  UZC has V = 40312 +- 73 km/s.','G',0.000093,NULL,'13.9g',0.97,'S0',NULL,NULL,NULL,NULL,1,195.2780417,39.84147,0,NULL,59087387691,923240432,14425631,13.9),(103856,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103856,36.63,0.46,212,43774,70,NULL,NULL,'2MASX J13010676+4953320',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00018,NULL,'15.9g',0.46,'E0',NULL,NULL,NULL,NULL,1,195.27825,49.89233,0,NULL,59104175040,923502735,14429730,15.9),(103857,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103857,37.56,0.15,325,43775,70,NULL,NULL,'2MASX J13010700+0042113',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000077,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,195.2790417,0.70311,0,NULL,58090417774,907662777,14182230,16.9),(103858,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103858,37.8,0.14,363,43776,70,NULL,NULL,'LCRS B125832.8-031043',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000099,NULL,'15.9g',0.46,'BrClG',NULL,NULL,NULL,NULL,1,195.281417,-3.44794,0.013,NULL,43150680544,674229383,10534834,15.9),(103859,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103859,37.8,0.14,363,43777,70,NULL,NULL,'LCRS B125832.9-031006',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000078,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,195.281625,-3.43764,0.013,NULL,43150680400,674229381,10534834,17.4),(103860,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103860,37.77,0.46,359,43778,70,NULL,NULL,'2MASX J13010872+2113540',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,195.286333,21.23164,0.14,NULL,59025224483,922269132,14410455,18.1),(103861,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103861,37.51,0.46,318,43779,70,NULL,NULL,'LCRS B125834.5-022322',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000073,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,195.2874583,-2.65886,0.021,NULL,43144179139,674127799,10533246,17.4),(103862,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103862,35.31,0.05,115,43780,70,NULL,NULL,'CGCG 160-092',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000019,NULL,'16.1b',0.2,'E','Group member',NULL,NULL,NULL,1,195.288458333,27.81833,0.052,NULL,58698681898,917166904,14330732,16.1),(103863,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103863,35.51,0.23,126,43780,74.4,NULL,NULL,'CGCG 160-092',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103864,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103864,37.34,0.46,294,43781,70,NULL,NULL,'2MASX J13010967+4021240',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000175,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,195.290333,40.35658,0,NULL,59079731554,923120805,14423762,16.8),(103865,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103865,35.63,0.46,133,43782,70,NULL,NULL,'VIII Zw 223',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,195.2950417,23.79875,0.063,NULL,58806718924,918854983,14357109,16.6),(103866,'SNIa','2016-12-15 15:15:09','2016-12-16 11:20:20','1','PTF10bjs',NULL,103866,35.61,0.03,128,43783,70,NULL,'SiFTO+SALT2, SN PTF10bjs','PTF10bjs',0.0303,'2012MNRAS.426.2359M',2012,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,195.29675,53.81597,0.021,NULL,57421320823,897208137,14018877,NULL),(103867,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103867,38.49,0.23,499,43784,70,NULL,NULL,'2MASX J13011236+1813259',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,195.301541667,18.22375,0.096,NULL,59027719812,922308122,14411064,17.3),(103868,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103868,36.64,0.46,213,43785,70,NULL,NULL,'2MASX J13011261+5050090',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000176,NULL,'17.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,195.3027917,50.83581,0,NULL,59090554211,923289909,14426404,17.4),(103869,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103869,37.65,0.46,339,43786,70,NULL,NULL,'2MASX J13011280+3035508',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000127,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,195.30325,30.59744,0,NULL,58678269134,916847955,14325749,16.5),(103870,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103870,37.57,0.46,326,43787,70,NULL,NULL,'2MASX J13011339+1846099',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,195.305833,18.76928,0.09,NULL,59035821385,922434709,14413042,17.7),(103871,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103871,36.24,0.81,177,43788,70,NULL,NULL,'2MASX J13011352-0936376',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.71',NULL,NULL,NULL,NULL,NULL,NULL,1,195.3065,-9.61058,0.081,NULL,43854735804,685230246,10706722,15.71),(103872,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103872,38.79,0.46,574,43789,70,NULL,NULL,'SDSS J130113.87+110357.6',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.8g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,195.307791667,11.06603,0.019,NULL,58968964303,921390067,14396719,17.8),(103873,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103873,37.93,0.09,386,43790,70,NULL,NULL,'LCRS B125839.6-023517',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00007,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,195.308875,-2.85742,0.017,NULL,43143956132,674124314,10533192,17.6),(103874,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103874,37.29,0.46,287,43791,70,NULL,NULL,'2MASX J13011533+1825299',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,195.3137917,18.42489,0.094,NULL,59034982254,922421597,14412837,17.1),(103875,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103875,37.36,0.46,297,43792,70,NULL,NULL,'2MASX J13011553+1204159',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000173,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,195.3147917,12.07128,0.056,NULL,58995179625,921799681,14403120,16.3),(103876,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103876,38.16,0.46,429,43793,70,NULL,NULL,'2MASX J13011694+1907388',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,195.3205417,19.12747,0.093,NULL,59035655293,922432113,14413001,17.7),(103877,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103877,38.8,0.46,576,43794,70,NULL,NULL,'SDSS J130117.23+292217.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,195.321833333,29.37142,0.005,NULL,58704086018,917251344,14332052,18.5),(103878,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103878,37.56,0.15,325,43795,70,NULL,NULL,'SDSS J130117.27+004742.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000065,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,195.322,0.795,0,NULL,58090902676,907670354,14182349,18.3),(103879,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103879,34.58,0.25,82.4,43796,74.4,NULL,NULL,'NGC 4919',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000028,NULL,'14.6g',0.7,'(R\')SA(r)0^0^:','Group member',NULL,NULL,NULL,1,195.3232917,27.80908,0.052,NULL,58698681790,917166902,14330732,14.6),(103880,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103880,37.72,0.46,349,43797,70,NULL,NULL,'SDSS J130119.18+461052.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,195.3299583,46.18128,0,NULL,59100688680,923448260,14428879,17.9),(103881,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103881,36.09,0.21,165,43798,70,NULL,NULL,'IC 4067',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000182,NULL,'16.2g',0.3,'S0?',NULL,NULL,NULL,NULL,1,195.33375,39.94036,0,NULL,59087380150,923240314,14425629,16.2),(103882,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103882,36.09,0.21,165,43799,70,NULL,NULL,'SDSS J130120.66+395500.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,195.336125,39.91669,0,NULL,59087380411,923240318,14425629,17.5),(103883,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103883,37.8,0.14,363,43800,70,NULL,NULL,'LCRS B125846.3-031751',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000091,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,195.3377083,-3.56667,0.013,NULL,43150643056,674228797,10534824,17.2),(103884,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103884,37.09,0.46,262,43801,70,NULL,NULL,'2MASX J13012147+1340269',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,195.339541667,13.67411,0.026,NULL,58994371024,921787047,14402922,18.1),(103885,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103885,37.41,0.46,303,43802,70,NULL,NULL,'2MASX J13012155+0831389',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,195.339875,8.52742,0,NULL,58962292550,921285821,14395090,17.4),(103886,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103886,36.27,0.46,180,43803,70,NULL,NULL,'CGCG 043-095',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00019,NULL,'15.5',0.31,NULL,NULL,NULL,NULL,NULL,1,195.343125,7.31856,0.025,NULL,58076128933,907439514,14178742,15.5),(103887,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103887,37.26,0.46,283,43804,70,NULL,NULL,'2MASX J13012239+0927199',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000202,NULL,'15.9g',0.45,NULL,NULL,NULL,NULL,NULL,1,195.34325,9.45567,0.017,NULL,58970932155,921420814,14397200,15.9),(103888,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103888,38.15,0.46,427,43805,70,NULL,NULL,'2MASX J13012247+5105360',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,195.3435417,51.09319,0,NULL,57195722914,893683170,13963799,17.6),(103889,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103889,35.31,0.05,115,43806,70,NULL,NULL,'2MASX J13012280+2811456',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000025,NULL,'15.9b',0.57,'Epec','Group member',NULL,NULL,NULL,1,195.344916667,28.19606,0.057,NULL,58698556295,917164942,14330702,15.9),(103890,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103890,35.49,0.25,125,43806,74.4,NULL,NULL,'2MASX J13012280+2811456',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103891,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103891,33.88,0.47,59.7,43807,NULL,NULL,'H','NGC 4903',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000033,NULL,'13.72',1.3,'SB(rs)c;Sy2    HII','Group member, radial-velocity confirmed',NULL,NULL,'Sy 2',1,195.344875,-30.93497,0.389,NULL,43330448804,677038262,10578722,13.72),(103892,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103892,33.92,0.45,60.8,43807,NULL,NULL,'K','NGC 4903',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103893,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103893,33.97,0.46,62.3,43807,NULL,NULL,'J','NGC 4903',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103894,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103894,34.27,0.4,71.5,43807,NULL,NULL,'mean','NGC 4903',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103895,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103895,37.41,0.46,303,43808,70,NULL,NULL,'2MASX J13012300+0106423',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000078,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,195.345791667,1.11183,0,NULL,58090807852,907668872,14182326,16.9),(103896,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103896,38.14,0.46,424,43809,70,NULL,NULL,'2MASX J13012310+2900356',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000183,NULL,'17.6g',0.2,NULL,'Group member',NULL,NULL,NULL,1,195.3464583,29.00994,0.035,NULL,58704311189,917254862,14332107,17.6),(103897,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103897,38.23,0.33,442,43810,70,NULL,NULL,'2MASX J13012419+0803031',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.36',0.16,NULL,NULL,NULL,NULL,NULL,1,195.35075,8.05089,0.021,NULL,58962368042,921287000,14395109,18.36),(103898,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103898,36.63,0.46,212,43811,70,NULL,NULL,'2MASX J13012433+3240509',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00014,NULL,'16.1g',0.34,NULL,NULL,NULL,NULL,NULL,1,195.3512917,32.68072,0.024,NULL,58671950903,916749232,14324206,16.1),(103899,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103899,37.81,0.46,365,43812,70,NULL,NULL,'LCRS B125850.1-024604',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000087,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,195.352833,-3.03706,0.017,NULL,43148441713,674194401,10534287,17.6),(103900,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103900,34.39,0.45,75.6,43813,NULL,NULL,'K','NGC 4922',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'GPair',0.00003,NULL,NULL,NULL,'I0/p;LINER:    Sy2','Group member',NULL,NULL,NULL,1,195.35375,29.31111,0.005,NULL,58704203750,917253183,14332080,NULL),(103901,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103901,35.09,0.4,104,43813,NULL,NULL,'mean','NGC 4922',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103902,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103902,37.2,0.46,276,43814,70,NULL,NULL,'2MASX J13012516+1113511',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,195.35475,11.23078,0.019,NULL,58964688176,921323252,14395675,17.5),(103903,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103903,38.01,0.46,399,43815,70,NULL,NULL,'2MASX J13012585+3633099',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,195.357667,36.55258,0,NULL,59291324712,926426948,14475421,17.7),(103904,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103904,37.43,0.46,306,43816,70,NULL,NULL,'2MASX J13012587-0223178',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000073,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,195.35775,-2.38811,0.021,NULL,43144015596,674125243,10533206,17.4),(103905,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103905,35.85,0.63,148,43817,70,NULL,NULL,'2MASX J13012615-1316346',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.74',NULL,NULL,NULL,NULL,NULL,NULL,1,195.3590417,-13.27631,0.053,NULL,43967363397,686990053,10734219,16.74),(103906,'GCLF','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103906,34.73,0.14,88.3,43818,NULL,NULL,'V','NGC 4921',NULL,'2016ApJ...819...77L',2016,1,2.5,NULL,'G',0.000013,NULL,'13.1g',2.2,'SB(rs)ab;RET   AGN','in a radial-velocity based grouping',NULL,NULL,NULL,1,195.3589583,27.88594,0.052,NULL,58698721242,917167519,14330742,13.1),(103907,'GCLF','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103907,34.73,0.14,88.3,43818,NULL,NULL,'I','NGC 4921',NULL,'2016ApJ...819...77L',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103908,'GCLF','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103908,34.93,0.11,97,43818,NULL,NULL,NULL,'NGC 4921',NULL,'2011AstL...37..766T',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103909,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103909,37.57,0.46,326,43819,70,NULL,NULL,'2MASX J13012687+0834251',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'17.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,195.362,8.57367,0,NULL,58962025194,921281643,14395025,17.7),(103910,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103910,37.25,0.46,281,43820,70,NULL,NULL,'SDSS J130127.74+420252.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,195.365583333,42.04786,0,NULL,59080732790,923136449,14424007,18.5),(103911,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103911,37.2,0.46,275,43821,70,NULL,NULL,'2MASX J13012807+4011156',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000172,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,195.366833333,40.18778,0,NULL,59079009656,923109525,14423586,16.8),(103912,'D-Sigma','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103912,32.63,0.4,33.5,43822,75,NULL,'Edat, raw','NGC 4915',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000067,NULL,'13.50',1.3,'E0','Parent (of companion) galaxy',NULL,NULL,NULL,1,195.367583333,-4.54653,0.033,NULL,43149213208,674206456,10534475,13.5),(103913,'D-Sigma','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103913,32.96,0.4,39.1,43822,75,NULL,'Edat, cor','NGC 4915',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103914,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103914,31.2,0.65,17.4,43822,95,NULL,'Weighted Mean','NGC 4915',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103915,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103915,32.46,0.81,31,43822,55,NULL,'Visvanathan & Sandage 1979','NGC 4915',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103916,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103916,32.34,0.48,29.4,43822,70,NULL,NULL,'NGC 4915',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103917,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103917,36.62,0.46,211,43823,70,NULL,NULL,'2MASX J13012925+0750301',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.4',0.27,NULL,NULL,NULL,NULL,NULL,1,195.371833333,7.84161,0.021,NULL,58961877785,921279340,14394989,16.4),(103918,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103918,38.37,0.46,471,43824,70,NULL,NULL,'2MASX J13013024+2101549',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,195.375916667,21.03197,0.17,NULL,59024483616,922257556,14410274,17.4),(103919,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103919,37.8,0.14,363,43825,70,NULL,NULL,'LCRS B125855.5-030423',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000073,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,195.376,-3.34203,0.013,NULL,43150736132,674230252,10534847,17.5),(103920,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103920,38.49,0.23,499,43826,70,NULL,NULL,'2MASX J13013035+1816079',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,195.3765417,18.26883,0.091,NULL,59035042591,922422540,14412852,17.6),(103921,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103921,38.49,0.23,499,43827,70,NULL,NULL,'2MASX J13013049+1815259',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,195.377083,18.25722,0.091,NULL,59035042736,922422542,14412852,17.1),(103922,'GCLF','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103922,34.84,0.18,93,43828,NULL,NULL,'V','NGC 4923',NULL,'2016ApJ...819...77L',2016,1,0.8,NULL,'G',0.000028,NULL,'14.4g',0.8,'(R\')SA(r)0-?','Group member',NULL,NULL,NULL,1,195.3825,27.84753,0.052,NULL,58698652280,917166441,14330725,14.4),(103923,'GCLF','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103923,34.93,0.26,96.8,43828,NULL,NULL,'I','NGC 4923',NULL,'2016ApJ...819...77L',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103924,'GCLF','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103924,34.93,0.11,97,43828,NULL,NULL,NULL,'NGC 4923',NULL,'2011AstL...37..766T',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103925,'D-Sigma','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103925,34.86,0.4,93.8,43828,75,NULL,'Edat, raw','NGC 4923',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103926,'D-Sigma','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103926,34.89,0.4,95,43828,75,NULL,'Edat, cor','NGC 4923',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103927,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103927,33.7,0.44,55,43828,95,NULL,'Weighted Mean','NGC 4923',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103928,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103928,34.02,0.63,63.7,43828,95,NULL,'Michard 1979b, c','NGC 4923',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103929,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103929,34.34,0.46,73.8,43828,95,NULL,'Michard 1979a','NGC 4923',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103930,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103930,34.88,0.23,94.6,43828,74.4,NULL,NULL,'NGC 4923',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103931,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103931,35.31,0.05,115,43828,70,NULL,NULL,'NGC 4923',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103932,'Tertiary','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103932,34.15,0.35,67.6,43828,95,NULL,NULL,'NGC 4923',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103933,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103933,38.49,0.23,499,43829,70,NULL,NULL,'2MASX J13013196+1818389',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,195.383291667,18.31069,0.091,NULL,59035044862,922422575,14412852,17.9),(103934,'D-Sigma','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103934,33.65,0.4,53.7,43830,75,NULL,'Edat, raw','IC 3986',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000017,NULL,'13.33',1.2,'SAB0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,195.383917,-32.29106,0.353,NULL,43332472846,677069888,10579217,13.33),(103935,'D-Sigma','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103935,34.1,0.4,65.9,43830,75,NULL,'Edat, cor','IC 3986',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103936,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103936,33.75,0.47,56.2,43830,70,NULL,NULL,'IC 3986',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103937,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103937,33.83,0.25,58.3,43830,74.4,NULL,NULL,'IC 3986',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103938,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103938,34.12,0.45,66.6,43830,NULL,NULL,'K','IC 3986',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103939,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103939,34.17,0.4,68.3,43830,NULL,NULL,'mean','IC 3986',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103940,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103940,37.56,0.46,325,43831,70,NULL,NULL,'2MASX J13013281+6258033',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,195.386541667,62.96753,0.021,NULL,57358088912,896220139,14003439,17.9),(103941,'Tully est','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103941,33.17,0.8,43.1,43832,75,NULL,NULL,'DDO 160',NULL,'1988NBGC.C....0000T',1988,1,1.4,NULL,'G',0.000027,NULL,'14.20',0.5,'SB(s)dm pec','is a companion galaxy',NULL,NULL,NULL,1,195.388708333,-4.77503,0.033,NULL,43141273025,674082391,10532537,14.2),(103942,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103942,37.6,0.46,332,43833,70,NULL,NULL,'2MASX J13013342+1648580',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,195.38925,16.81617,0.07,NULL,59046073690,922594901,14415545,17.5),(103943,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103943,36.64,0.46,213,43834,70,NULL,NULL,'SDSS J130133.49+530756.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000154,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,195.3895417,53.13242,0.008,NULL,57194597311,893665582,13963524,17.8),(103944,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103944,35.31,0.05,115,43835,70,NULL,NULL,'IC 0843',NULL,'2015arXiv151105856S',2015,1,1.23,NULL,'G',0.000083,NULL,'14.4g',0.54,'S0','Group member',NULL,NULL,NULL,1,195.39,29.13061,0.014,NULL,58704293954,917254593,14332103,14.4),(103945,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103945,35.32,0.25,116,43835,74.4,NULL,NULL,'IC 0843',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103946,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103946,38.23,0.33,442,43836,70,NULL,NULL,'SDSS J130133.91+080504.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,195.391333,8.08464,0.021,NULL,58962436442,921288069,14395126,18.4),(103947,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103947,38.19,0.33,434,43837,70,NULL,NULL,'2MASX J13013410+0343115',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,195.392083,3.71969,0.033,NULL,58116078786,908063731,14188495,17.8),(103948,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103948,37.8,0.14,363,43838,70,NULL,NULL,'SDSS J130134.31-033523.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000069,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,195.392958333,-3.58978,0.013,NULL,43150646148,674228846,10534825,18.4),(103949,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103949,37.8,0.14,363,43839,70,NULL,NULL,'LCRS B125859.6-031731',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00008,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,195.393125,-3.56108,0.013,NULL,43150653844,674228966,10534827,18.1),(103950,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103950,37.71,0.46,348,43840,70,NULL,NULL,'2MASX J13013475+3858467',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000191,NULL,'17.85',0.19,NULL,NULL,NULL,NULL,NULL,1,195.394667,38.97953,0,NULL,59073831315,923028614,14422322,17.85),(103951,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103951,37.25,0.46,281,43841,70,NULL,NULL,'2MASX J13013544+0648181',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.64',0.15,NULL,NULL,NULL,NULL,NULL,1,195.3977917,6.80508,0,NULL,58078498790,907476543,14179320,18.64),(103952,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103952,38,0.46,398,43842,70,NULL,NULL,'2MASX J13013690+0405575',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,195.40375,4.09936,0.022,NULL,58116012370,908062693,14188479,17.6),(103953,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103953,38.43,0.46,485,43843,70,NULL,NULL,'SDSS J130136.97+190027.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,195.404083333,19.00778,0.093,NULL,59035830013,922434843,14413044,18.2),(103954,'IRAS','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103954,35.46,0.8,124,43844,75,NULL,'CF, r','UGC 08143',NULL,'1997ApJS..109..333W',1997,1,1.06,NULL,'G',0.000169,NULL,'14.8g',0.53,'Sbc',NULL,NULL,NULL,NULL,1,195.407583,54.39044,0.021,NULL,57421534967,897211483,14018929,14.8),(103955,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103955,35.77,0.38,143,43844,75,NULL,'CF, r, raw','UGC 08143',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103956,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103956,35.96,0.38,155,43844,75,NULL,'CF, r, cor','UGC 08143',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103957,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103957,35.98,0.38,157,43844,75,NULL,'CF, r, inv','UGC 08143',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103958,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103958,36.09,0.21,165,43845,70,NULL,NULL,'IC 4085',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000191,NULL,'15.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,195.409125,39.70269,0,NULL,59087495037,923242109,14425657,15.9),(103959,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103959,38.02,0.46,401,43846,70,NULL,NULL,'2MASX J13013929+0458535',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,195.413625,4.98156,0,NULL,58109282098,907957532,14186836,17.6),(103960,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103960,36.86,0.46,235,43847,70,NULL,NULL,'2MASX J13013947+6420023',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000081,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,195.4142917,64.33403,0.013,NULL,57352504921,896132889,14002076,16.8),(103961,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103961,35.54,0.2,128,43848,74.4,NULL,NULL,'CGCG 071-099',NULL,'2013AJ....146...86T',2013,1,0.73,NULL,'G',0.000022,NULL,'15.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,195.423166667,10.01669,0.015,NULL,58971005131,921421955,14397218,15.9),(103962,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103962,34.62,0.47,84,43849,70,NULL,NULL,'ESO 443- G 034',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000077,NULL,'13.58',1.1,'(R\')SAB(rs)0/a: pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,195.423708333,-30.91236,0.285,NULL,43330493456,677038960,10578733,13.58),(103963,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103963,36.09,0.46,165,43850,70,NULL,NULL,'CGCG 043-098',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000157,NULL,'15.7g',0.42,'E0','Group member',NULL,NULL,NULL,1,195.426417,5.03117,0,NULL,58109282538,907957539,14186836,15.7),(103964,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103964,37.96,0.46,390,43851,70,NULL,NULL,'SDSS J130142.97+091440.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,195.429083333,9.24469,0.013,NULL,58970155024,921408672,14397010,18),(103965,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103965,37.72,0.21,350,43852,70,NULL,NULL,'2MASX J13014319-0054090',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000083,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,195.429833,-0.9025,0.017,NULL,43112584360,673634130,10525533,17.4),(103966,'IRAS','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103966,34.89,0.8,94.9,43853,75,NULL,'HMCL, I','IC 4088',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000008,NULL,'14.5g',0.43,'Sab            Sbrst','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,195.4307083,29.04467,0.014,NULL,58704327296,917255114,14332111,14.5),(103967,'IRAS','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103967,34.97,0.8,98.6,43853,75,NULL,'W91CL, r','IC 4088',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103968,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103968,34.48,NULL,78.7,43853,NULL,NULL,NULL,'IC 4088',NULL,'1993MNRAS.263..211R',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103969,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103969,34.98,0.38,99,43853,75,NULL,'W91CL, r, raw','IC 4088',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103970,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103970,34.98,0.4,99.2,43853,75,NULL,'HMCL, I, raw','IC 4088',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103971,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103971,35.03,0.38,101,43853,75,NULL,'W91CL, r, cor','IC 4088',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103972,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103972,35.06,0.49,103,43853,75,NULL,'IR','IC 4088',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103973,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103973,35.14,0.4,107,43853,NULL,NULL,'mean','IC 4088',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103974,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103974,35.16,0.38,108,43853,75,NULL,'W91CL, r, inv','IC 4088',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103975,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103975,35.21,0.4,110,43853,75,NULL,'HMCL, I, inv','IC 4088',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103976,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103976,35.23,0.08,111,43853,NULL,NULL,NULL,'IC 4088',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103977,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103977,35.23,0.4,111,43853,75,NULL,'HMCL, I, cor','IC 4088',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103978,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103978,35.28,0.2,114,43853,74.4,NULL,NULL,'IC 4088',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103979,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103979,35.3,0.47,115,43853,NULL,NULL,'H','IC 4088',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103980,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103980,35.34,0.43,117,43853,75,NULL,'3.6 micron, color corrected','IC 4088',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103981,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103981,35.38,0.45,119,43853,NULL,NULL,'K','IC 4088',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103982,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103982,35.43,0.46,122,43853,NULL,NULL,'J','IC 4088',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103983,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103983,35.56,0.43,129,43853,75,NULL,'3.6 micron, color + selection bias corrected','IC 4088',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103984,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103984,37.93,0.09,386,43854,70,NULL,NULL,'SDSS J130145.39-023042.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000071,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,195.439167,-2.51172,0.009,NULL,43144028625,674125447,10533210,18.1),(103985,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103985,38.62,0.46,530,43855,70,NULL,NULL,'2MASX J13014588+6506282',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,195.441583333,65.10781,0.029,NULL,57349730124,896089533,14001398,17.9),(103986,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103986,37.8,0.14,363,43856,70,NULL,NULL,'SDSS J130146.24-033224.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000077,NULL,'18.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,195.442667,-3.54025,0.013,NULL,43150644942,674228827,10534825,18.1),(103987,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103987,37.93,0.09,386,43857,70,NULL,NULL,'LCRS B125912.6-021905',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000092,NULL,'16.7g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,195.446333,-2.587,0.009,NULL,43144163652,674127557,10533243,16.7),(103988,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103988,36.63,0.72,212,43858,70,NULL,NULL,'2MASX J13014731-2400592',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000057,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,195.447333,-24.0165,0.445,NULL,43304510109,676632970,10572390,15.4),(103989,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103989,36.46,0.46,196,43859,70,NULL,NULL,'2MASX J13014776+3802178',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,195.449041667,38.03825,0,NULL,59074384509,923037257,14422457,17),(103990,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103990,34.4,0.25,75.9,43860,74.4,NULL,NULL,'2MASX J13014841+2736147',NULL,'2013AJ....146...86T',2013,1,0.66,NULL,'G',0.000037,NULL,'16.0g',0.2,'S0','Group member',NULL,NULL,NULL,1,195.451583,27.60397,0.041,NULL,58698630206,917166096,14330720,16),(103991,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103991,37.8,0.14,363,43861,70,NULL,NULL,'LCRS B125913.6-032415',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000094,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,195.4517917,-3.67311,0.013,NULL,43150796886,674231201,10534862,17.3),(103992,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103992,36.47,0.46,197,43862,70,NULL,NULL,'IC 4075',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.05',0.15,NULL,NULL,NULL,NULL,NULL,1,195.452333333,19.965,0.15,NULL,59036560883,922446263,14413222,18.05),(103993,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',103993,37.41,0.46,304,43863,70,NULL,NULL,'2MASX J13014873+4345478',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000205,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,195.452917,43.76325,0,NULL,59106948288,923546067,14430407,16.4),(103994,'IRAS','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103994,33.05,0.8,40.7,43864,75,NULL,'MAT, I','ESO 507- G 067',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000025,NULL,'14.60',1.4,'SB(rs)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,195.453125,-27.12508,0.389,NULL,43307732865,676683326,10573176,14.6),(103995,'IRAS','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103995,33.07,0.8,41,43864,75,NULL,'HMCL, I','ESO 507- G 067',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103996,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103996,32.33,0.4,29.3,43864,75,NULL,'HMCL, I, raw','ESO 507- G 067',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103997,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103997,32.39,0.4,30.1,43864,75,NULL,'HMCL, I, inv','ESO 507- G 067',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103998,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103998,32.61,0.4,33.3,43864,75,NULL,'HMCL, I, cor','ESO 507- G 067',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103999,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,103999,32.66,0.38,34,43864,NULL,NULL,NULL,'ESO 507- G 067',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104000,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,104000,32.81,0.43,36.4,43864,75,NULL,'MAT, I, raw','ESO 507- G 067',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104001,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,104001,32.83,0.32,36.8,43864,85,NULL,'I, raw','ESO 507- G 067',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104002,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,104002,32.85,0.32,37.1,43864,85,NULL,'I, inv','ESO 507- G 067',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104003,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,104003,32.92,0.43,38.3,43864,75,NULL,'MAT, I, inv','ESO 507- G 067',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104004,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,104004,33.08,0.43,41.2,43864,75,NULL,'MAT, I, cor','ESO 507- G 067',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104005,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,104005,33.25,0.58,44.8,43864,NULL,NULL,NULL,'ESO 507- G 067',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104006,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,104006,33.29,0.2,45.5,43864,74.4,NULL,NULL,'ESO 507- G 067',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104007,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,104007,33.37,0.55,47.3,43864,NULL,NULL,'Malmquist cor.','ESO 507- G 067',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104008,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',104008,38.13,0.46,422,43865,70,NULL,NULL,'2MASXi J1301491+663701',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000092,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,195.454875,66.61694,0.037,NULL,57907415857,904803372,14137552,17.1),(104009,'FP','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',104009,37.93,0.09,386,43866,70,NULL,NULL,'LCRS B125914.7-021938',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000109,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,195.455083,-2.59619,0.009,NULL,43144166974,674127608,10533243,17.7),(104010,'IRAS','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,104010,33.64,0.8,53.4,43867,75,NULL,'MAT, I','MCG -01-33-071',NULL,'1997ApJS..109..333W',1997,1,3.14,NULL,'G',0.00003,NULL,'14.30',0.36,'Sbc','in a pair',NULL,NULL,NULL,1,195.4565,-8.33625,0.093,NULL,43849251245,685144550,10705383,14.3),(104011,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,'R',104011,33.22,0.49,44,43867,75,NULL,'IR','MCG -01-33-071',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104012,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,104012,33.38,0.46,47.5,43867,NULL,NULL,'J','MCG -01-33-071',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104013,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,104013,33.39,0.47,47.7,43867,NULL,NULL,'H','MCG -01-33-071',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104014,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,104014,33.53,0.45,50.8,43867,NULL,NULL,'K','MCG -01-33-071',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104015,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,104015,33.61,0.2,52.7,43867,74.4,NULL,NULL,'MCG -01-33-071',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104016,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,104016,33.63,0.43,53.3,43867,75,NULL,'MAT, I, raw','MCG -01-33-071',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104017,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:20','1',NULL,NULL,104017,33.76,0.4,56.4,43867,NULL,NULL,'mean','MCG -01-33-071',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104018,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104018,33.8,0.35,57.4,43867,NULL,NULL,'Malmquist cor.','MCG -01-33-071',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104019,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104019,33.83,0.32,58.3,43867,85,NULL,'I, raw','MCG -01-33-071',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104020,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104020,33.83,0.43,58.3,43867,75,NULL,'MAT, I, cor','MCG -01-33-071',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104021,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104021,33.85,NULL,58.8,43867,NULL,NULL,'Dipole','MCG -01-33-071',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104022,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104022,33.85,NULL,58.9,43867,NULL,NULL,'Dipole + Quadrupole','MCG -01-33-071',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104023,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104023,33.86,NULL,59.2,43867,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -01-33-071',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104024,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104024,33.87,NULL,59.4,43867,NULL,NULL,NULL,'MCG -01-33-071',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104025,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104025,33.87,0.34,59.5,43867,NULL,NULL,NULL,'MCG -01-33-071',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104026,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104026,33.89,0.32,60,43867,85,NULL,'I, inv','MCG -01-33-071',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104027,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104027,33.9,0.43,60.1,43867,75,NULL,'MAT, I, inv','MCG -01-33-071',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104028,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104028,38.23,0.46,442,43868,70,NULL,NULL,'2MASX J13015000+0330195',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000088,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,195.4582917,3.50533,0.033,NULL,58115613721,908056464,14188382,17.4),(104029,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104029,35.31,0.05,115,43869,70,NULL,NULL,'CGCG 160-100',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000043,NULL,'15.4g',0.67,'E/SAB0','Group member',NULL,NULL,NULL,1,195.45925,27.89356,0.052,NULL,58698711862,917167372,14330740,15.4),(104030,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104030,35.44,0.23,122,43869,74.4,NULL,NULL,'CGCG 160-100',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104031,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104031,36.77,0.46,226,43870,70,NULL,NULL,'2MASX J13015031+5819356',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000169,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,195.459917,58.32672,0,NULL,57441474154,897523033,14023797,16.3),(104032,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104032,37.7,0.46,347,43871,70,NULL,NULL,'2MASX J13015045+0949171',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.0002,NULL,'18.12',0.19,NULL,NULL,NULL,NULL,NULL,1,195.46025,9.82128,0.015,NULL,58971735749,921433371,14397396,18.12),(104033,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104033,34.46,0.49,78.1,43872,70,NULL,NULL,'2MASX J13015101-4342479',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.4I',0.4,NULL,NULL,NULL,NULL,NULL,1,195.462625,-43.71328,0.393,NULL,46758447546,730600742,11415636,13.4),(104034,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104034,38.32,0.19,461,43873,70,NULL,NULL,'SDSS J130151.94+671734.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000067,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,195.4664583,67.29297,0.033,NULL,57852298661,903942166,14124096,18.5),(104035,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104035,37.41,0.46,304,43874,70,NULL,NULL,'2MASX J13015212+6244431',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,195.4670417,62.74536,0.005,NULL,57357561777,896211902,14003310,17.5),(104036,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104036,38.11,0.46,419,43875,70,NULL,NULL,'SDSS J130152.24+544820.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000167,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,195.4677083,54.80564,0.009,NULL,57423220652,897237822,14019340,18),(104037,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104037,36.75,0.46,224,43876,70,NULL,NULL,'2MASX J13015296+3359050',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,195.4707917,33.98486,0.01,NULL,58670258044,916722781,14323793,17),(104038,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104038,38.36,0.27,470,43877,70,NULL,NULL,'SDSS J130153.47+315829.6',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000145,NULL,'18.7g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,195.4727917,31.97492,0.032,NULL,58685566810,916961981,14327530,18.7),(104039,'GCLF','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104039,35.23,0.2,111,43878,NULL,NULL,NULL,'NGC 4926',NULL,'2002ApJ...567..294O',2002,1,1.2,NULL,'G',0.000025,NULL,'13.8g',1.1,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,195.473875,27.62444,0.041,NULL,58697525237,917148831,14330450,13.8),(104040,'D-Sigma','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104040,34.86,0.4,93.8,43878,75,NULL,'Edat, raw','NGC 4926',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104041,'D-Sigma','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104041,34.89,0.4,95,43878,75,NULL,'Edat, cor','NGC 4926',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104042,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104042,35.01,0.22,100,43878,74.4,NULL,NULL,'NGC 4926',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104043,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104043,35.07,0.09,103,43878,70,NULL,NULL,'NGC 4926',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104044,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104044,35.31,0.05,115,43878,70,NULL,NULL,'NGC 4926',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104045,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104045,35.35,0.4,117,43878,NULL,NULL,'mean','NGC 4926',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104046,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104046,35.75,0.45,141,43878,NULL,NULL,'K','NGC 4926',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104047,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104047,34.89,0.46,95.1,43879,70,NULL,NULL,'2MASXi J1301541+361343',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000169,NULL,'15.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,195.475625,36.22872,0.006,NULL,59291539177,926430299,14475473,15.3),(104048,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104048,38.19,0.33,434,43880,70,NULL,NULL,'SDSS J130155.37+034443.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000135,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,195.48075,3.74536,0.016,NULL,58116019049,908062797,14188481,18.5),(104049,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104049,33.1,0.49,41.6,43881,75,NULL,'IR','MCG -01-33-072',NULL,'2011yCatp016004901K',2011,1,1.68,'The APM position refers to the eastern end of the spindle.','G',0.00002,NULL,'15.27',0.19,'Sd',NULL,NULL,NULL,NULL,1,195.48075,-6.92611,0.077,NULL,43125251080,673832048,10528625,15.27),(104050,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104050,33.2,0.2,43.7,43881,74.4,NULL,NULL,'MCG -01-33-072',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104051,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104051,33.56,0.4,51.6,43881,NULL,NULL,'mean','MCG -01-33-072',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104052,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104052,33.57,0.41,51.8,43881,NULL,NULL,NULL,'MCG -01-33-072',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104053,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104053,33.72,0.38,55.4,43881,NULL,NULL,'Malmquist cor.','MCG -01-33-072',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104054,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104054,33.83,0.47,58.4,43881,NULL,NULL,'H','MCG -01-33-072',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104055,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104055,33.94,NULL,61.4,43881,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -01-33-072',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104056,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104056,33.95,NULL,61.6,43881,NULL,NULL,'Dipole + Quadrupole','MCG -01-33-072',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104057,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104057,33.96,NULL,61.8,43881,NULL,NULL,'Dipole','MCG -01-33-072',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104058,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104058,37.65,0.46,338,43882,70,NULL,NULL,'2MASX J13015548+6626053',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000092,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,195.481083,66.43494,0.025,NULL,57906754252,904793035,14137391,17),(104059,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104059,36.53,0.46,202,43883,70,NULL,NULL,'2MASX J13015555+3132030',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,195.4814583,31.53428,0.035,NULL,58676844093,916825688,14325401,16.8),(104060,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104060,34.18,0.56,68.4,43884,70,NULL,NULL,'2MASX J13015584-1658505',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000143,NULL,'15.42',0.5,NULL,NULL,NULL,NULL,NULL,1,195.4827083,-16.98089,0.069,NULL,44016529477,687758273,10746223,15.42),(104061,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104061,35.31,0.05,115,43885,70,NULL,NULL,'NGC 4927',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000042,NULL,'14.4g',0.62,'SA0-:','Group member',NULL,NULL,NULL,1,195.49,28.00589,0.065,NULL,58698537659,917164650,14330697,14.4),(104062,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104062,35.91,0.23,152,43885,74.4,NULL,NULL,'NGC 4927',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104063,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104063,37.42,0.27,305,43886,70,NULL,NULL,'2MASX J13015793+2356516',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,195.4912917,23.94781,0.057,NULL,58806690092,918854532,14357102,17.3),(104064,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104064,36.92,0.46,242,43887,70,NULL,NULL,'2MASX J13015822+3001380',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000153,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,195.492625,30.02714,0,NULL,58678003063,916843797,14325684,16.7),(104065,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104065,37.17,0.46,272,43888,70,NULL,NULL,'2MASX J13015899+1942076',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,195.495916667,19.70219,0.15,NULL,59038740971,922480327,14413755,17.3),(104066,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104066,37.66,0.46,341,43889,70,NULL,NULL,'2MASX J13015944+2720259',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'18.15',0.31,NULL,'Group member',NULL,NULL,NULL,1,195.497583333,27.34069,0.014,NULL,58697902148,917154721,14330542,18.15),(104067,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104067,35.93,0.46,153,43890,70,NULL,NULL,'CGCG 043-104',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000117,NULL,'15.5',0.6,NULL,NULL,NULL,NULL,NULL,1,195.49925,6.28303,0.062,NULL,58077999152,907468736,14179199,15.5),(104068,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104068,36.92,0.46,242,43891,70,NULL,NULL,'2MASX J13020101+1226229',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000172,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,195.504333333,12.43981,0.051,NULL,58995799624,921809369,14403271,16.4),(104069,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104069,34.87,0.25,94.2,43892,74.4,NULL,NULL,'NGC 4926B',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00004,NULL,'15.86',0.54,'SB0','Group member',NULL,NULL,NULL,1,195.504333333,27.65297,0.041,NULL,58697526755,917148855,14330450,15.86),(104070,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104070,37.48,0.46,314,43893,70,NULL,NULL,'LCRS B125926.5-025116',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00009,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,195.504667,-3.12358,0.013,NULL,43150539559,674227180,10534799,16.6),(104071,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104071,36.33,0.6,185,43894,70,NULL,NULL,'2MASX J13020114-1628495',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,195.5047917,-16.48053,0.057,NULL,44016348883,687755451,10746178,17),(104072,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104072,35.79,0.46,144,43895,70,NULL,NULL,'2MASX J13020152+0816153',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.10',0.21,NULL,NULL,NULL,NULL,NULL,1,195.506167,8.27081,0.015,NULL,58962459245,921288425,14395131,17.1),(104073,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104073,33.44,0.52,48.8,43896,70,NULL,NULL,'NGC 4909',NULL,'2014MNRAS.445.2677S',2014,1,1.9,NULL,'G',0.000029,NULL,'13.61',1.7,'(R_1R\'_2)SAB(l)a',NULL,NULL,NULL,NULL,1,195.5077083,-42.77142,0.377,NULL,46750492429,730476444,11413694,13.61),(104074,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104074,37.93,0.09,386,43897,70,NULL,NULL,'LCRS B125928.0-022000',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000085,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,195.5105,-2.60222,0.009,NULL,43143939181,674124049,10533188,17.9),(104075,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104075,31.88,0.4,23.7,43898,NULL,NULL,NULL,'MCG -02-33-093',NULL,'2013MNRAS.429.2677K',2013,1,0.8,NULL,'G',0.00001,NULL,'14.02',0.4,NULL,NULL,NULL,NULL,NULL,1,195.513875,-14.88289,0.037,NULL,44019263658,687800994,10746890,14.02),(104076,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104076,32.04,0.4,25.6,43898,NULL,NULL,'mean','MCG -02-33-093',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104077,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104077,32.65,0.47,33.8,43898,NULL,NULL,'H','MCG -02-33-093',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104078,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104078,37.76,0.46,357,43899,70,NULL,NULL,'LCRS B125928.9-031618',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000073,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,195.51525,-3.54058,0.009,NULL,43150617039,674228391,10534818,17.6),(104079,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104079,31.3,0.4,18.2,43900,NULL,NULL,NULL,'NGC 4920',NULL,'2013MNRAS.429.2677K',2013,1,1,NULL,'G',0.000003,NULL,'14.15',0.7,'IB(s)m',NULL,NULL,NULL,NULL,1,195.517291667,-11.37842,0.085,NULL,43845368873,685083888,10704435,14.15),(104080,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104080,35.24,0.08,112,43901,NULL,NULL,NULL,'CGCG 160-107',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.00007,NULL,'14.5g',0.28,'S0a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,195.5175,29.25344,0.014,NULL,58704175629,917252744,14332074,14.5),(104081,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104081,37.4,0.46,302,43902,70,NULL,NULL,'2MASX J13020429+3956081',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000174,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,195.5180417,39.93553,0,NULL,59079030634,923109853,14423591,16.8),(104082,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104082,35.29,0.46,114,43903,70,NULL,NULL,'2MASX J13020438+2853399',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000019,NULL,'15.7g',0.36,NULL,'Group member',NULL,NULL,NULL,1,195.518458333,28.89458,0.035,NULL,58703814148,917247096,14331985,15.7),(104083,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104083,37.72,0.21,350,43904,70,NULL,NULL,'2MASX J13020624-0050260',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00008,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,195.526083333,-0.84042,0,NULL,43109719952,673589374,10524833,17.2),(104084,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104084,37.61,0.33,332,43905,70,NULL,NULL,'2MASX J13020642+2252317',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,195.526791667,22.87539,0.073,NULL,58808271197,918879237,14357488,17),(104085,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104085,33.2,0.56,43.6,43906,70,NULL,NULL,'NGC 4925',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.0001,NULL,'14.03',0.5,'SA:(s)0o: pec',NULL,NULL,NULL,NULL,1,195.5307917,-7.71078,0.069,NULL,43849077500,685141835,10705341,14.03),(104086,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104086,38.32,0.19,461,43907,70,NULL,NULL,'2MASX J13020754+6723352',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000092,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,195.531,67.39319,0.033,NULL,57853610784,903962668,14124416,17.4),(104087,'IRAS','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104087,34.21,0.8,69.7,43908,75,NULL,'MAT, I','ESO 381- G 051',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'15',0.3,'Sb',NULL,NULL,NULL,NULL,1,195.531125,-33.12067,0.265,NULL,43321656941,676900889,10576576,15),(104088,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104088,33.86,0.43,59.3,43908,75,NULL,'3.6 micron, color + selection bias corrected','ESO 381- G 051',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104089,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104089,33.99,0.43,62.9,43908,75,NULL,'3.6 micron, color corrected','ESO 381- G 051',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104090,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104090,34.02,0.45,63.7,43908,NULL,NULL,'K','ESO 381- G 051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104091,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104091,34.06,0.47,64.7,43908,NULL,NULL,'H','ESO 381- G 051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104092,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104092,34.15,0.46,67.5,43908,NULL,NULL,'J','ESO 381- G 051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104093,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104093,34.2,0.49,69,43908,75,NULL,'IR','ESO 381- G 051',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104094,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104094,34.2,0.2,69.2,43908,74.4,NULL,NULL,'ESO 381- G 051',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104095,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104095,34.28,0.4,71.7,43908,NULL,NULL,'mean','ESO 381- G 051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104096,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104096,34.3,0.43,72.3,43908,75,NULL,'MAT, I, raw','ESO 381- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104097,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104097,34.39,0.32,75.5,43908,85,NULL,'I, raw','ESO 381- G 051',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104098,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104098,34.46,0.32,78,43908,85,NULL,'I, inv','ESO 381- G 051',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104099,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104099,34.51,0.43,79.8,43908,75,NULL,'MAT, I, cor','ESO 381- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104100,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104100,34.59,0.43,82.8,43908,75,NULL,'MAT, I, inv','ESO 381- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104101,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104101,37.72,0.21,350,43909,70,NULL,NULL,'2MASX J13020784-0051070',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000073,NULL,'18.1g',0.15,'NLAGN',NULL,NULL,NULL,NULL,1,195.532583333,-0.85189,0,NULL,43109719704,673589370,10524833,18.1),(104102,'IRAS','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104102,30.7,0.8,13.8,43910,75,NULL,'A82, H','UGC 08146',NULL,'1997ApJS..109..333W',1997,1,3.92,NULL,'G',0.000003,NULL,'14.42',0.32,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,195.53375,58.70131,0,NULL,57439508812,897492325,14023317,14.42),(104103,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104103,30.75,0.4,14.1,43910,NULL,NULL,'Virgo cluster at 15.6 Mpc','UGC 08146',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104104,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104104,30.76,0.4,14.2,43910,75,NULL,'B','UGC 08146',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104105,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104105,31.19,0.47,17.3,43910,75,NULL,'A82, H, inv','UGC 08146',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104106,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104106,31.23,NULL,17.6,43910,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08146',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104107,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104107,31.24,NULL,17.7,43910,NULL,NULL,'Dipole','UGC 08146',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104108,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104108,31.24,NULL,17.7,43910,NULL,NULL,'Dipole + Quadrupole','UGC 08146',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104109,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104109,31.33,NULL,18.5,43910,NULL,NULL,NULL,'UGC 08146',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104110,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104110,31.35,0.38,18.6,43910,NULL,NULL,NULL,'UGC 08146',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104111,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104111,31.38,0.47,18.9,43910,75,NULL,'A82, H, raw','UGC 08146',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104112,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104112,31.54,0.2,20.3,43910,74.4,NULL,NULL,'UGC 08146',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104113,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104113,31.63,0.43,21.2,43910,75,NULL,'3.6 micron, color corrected','UGC 08146',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104114,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104114,31.67,0.47,21.6,43910,75,NULL,'A82, H, cor','UGC 08146',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104115,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104115,31.69,0.43,21.8,43910,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08146',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104116,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104116,31.77,0.59,22.5,43910,NULL,NULL,'Malmquist cor.','UGC 08146',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104117,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104117,31.81,0.57,23,43910,NULL,NULL,NULL,'UGC 08146',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104118,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104118,37.06,0.46,258,43911,70,NULL,NULL,'2MASX J13020875+0524379',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000201,NULL,'16.2g',0.34,'E0',NULL,NULL,NULL,NULL,1,195.5365,5.41078,0,NULL,58109714663,907964291,14186942,16.2),(104119,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104119,38.36,0.27,470,43912,70,NULL,NULL,'2MASX J13020928+3153540',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,195.5385,31.89822,0.035,NULL,58685574402,916962100,14327532,18.3),(104120,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104120,37.19,0.46,274,43913,70,NULL,NULL,'2MASX J13020926+0922303',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000152,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,195.538667,9.37508,0.013,NULL,58971313769,921426777,14397293,17.3),(104121,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104121,37.03,0.46,255,43914,70,NULL,NULL,'2MASX J13021152+4954370',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00023,NULL,'15.9g',0.33,'E0',NULL,NULL,NULL,NULL,1,195.54825,49.91036,0,NULL,59104887443,923513866,14429904,15.9),(104122,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104122,33.74,0.2,56,43915,74.4,NULL,NULL,'AGC 221465',NULL,'2013AJ....146...86T',2013,1,0.55,NULL,'G',0.000038,NULL,'15.81',0.39,'Irr','Group member',NULL,NULL,NULL,1,195.5497917,28.1725,0.065,NULL,58698500505,917164070,14330688,15.81),(104123,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104123,35.08,0.07,104,43915,NULL,NULL,NULL,'AGC 221465',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104124,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104124,34.46,0.49,77.9,43916,75,NULL,'IR','ESO 507- G 068',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'16.26',0.2,'S...',NULL,NULL,NULL,NULL,1,195.551541667,-25.37861,0.421,NULL,43315987151,676812299,10575192,16.26),(104125,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104125,34.58,0.5,82.5,43916,NULL,NULL,'Malmquist cor.','ESO 507- G 068',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104126,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104126,34.67,0.48,85.9,43916,NULL,NULL,NULL,'ESO 507- G 068',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104127,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104127,34.71,0.2,87.5,43916,74.4,NULL,NULL,'ESO 507- G 068',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104128,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104128,37.03,0.46,254,43917,70,NULL,NULL,'2MASX J13021260+2441079',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,195.552666667,24.68558,0.05,NULL,58688693907,917010842,14328294,17.1),(104129,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104129,36.71,0.79,220,43918,70,NULL,NULL,'2MASX J13021415-1246275',NULL,'2014MNRAS.445.2677S',2014,1,NULL,'There is a star superposed 5 arcsec southwest of the nucleus.','G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,195.5589583,-12.77433,0.081,NULL,43968003817,687000059,10734375,16),(104130,'Tully est','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104130,29.25,0.8,7.1,43919,75,NULL,NULL,'UGCA 319',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.000013,NULL,'15.33',1.1,'IB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,195.559958333,-17.23753,0.121,NULL,44016156329,687752442,10746131,15.33),(104131,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104131,31.47,0.43,19.7,43919,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 319',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104132,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104132,37.8,0.14,363,43920,70,NULL,NULL,'LCRS B125940.1-031339',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000085,NULL,'16.7g',0.35,NULL,NULL,NULL,NULL,NULL,1,195.562,-3.49642,0.009,NULL,43150612398,674228318,10534817,16.7),(104133,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104133,37.21,0.33,277,43921,70,NULL,NULL,'2MASX J13021606+1745224',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,195.566875,17.75617,0.093,NULL,59045376333,922584005,14415375,18),(104134,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104134,37.42,0.27,305,43922,70,NULL,NULL,'IC 4096',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00012,NULL,'17.40',0.18,NULL,NULL,NULL,NULL,NULL,1,195.570667,24.01083,0.031,NULL,58688350140,917005470,14328210,17.4),(104135,'IRAS','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104135,35.63,0.8,134,43923,75,NULL,'MAT, I','ESO 443- G 038',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'15.43',0.6,'S?',NULL,NULL,NULL,NULL,1,195.5725,-32.37769,0.353,NULL,43332807717,677075120,10579298,15.43),(104136,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104136,35.21,0.43,110,43923,75,NULL,'MAT, I, raw','ESO 443- G 038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104137,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104137,35.28,0.32,114,43923,85,NULL,'I, raw','ESO 443- G 038',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104138,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104138,35.34,0.32,117,43923,85,NULL,'I, inv','ESO 443- G 038',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104139,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104139,35.49,0.43,125,43923,75,NULL,'MAT, I, inv','ESO 443- G 038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104140,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104140,35.49,0.43,125,43923,75,NULL,'MAT, I, cor','ESO 443- G 038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104141,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104141,35.62,0.31,133,43923,NULL,NULL,'Malmquist cor.','ESO 443- G 038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104142,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104142,35.67,0.31,136,43923,NULL,NULL,NULL,'ESO 443- G 038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104143,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104143,35.71,0.2,139,43923,74.4,NULL,NULL,'ESO 443- G 038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104144,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104144,37.93,0.09,386,43924,70,NULL,NULL,'2MASX J13021752-0232320',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00007,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,195.573083333,-2.54225,0.009,NULL,43143938929,674124045,10533188,17.5),(104145,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104145,37.72,0.21,350,43925,70,NULL,NULL,'2MASX J13021784-0050510',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000075,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,195.5742917,-0.84758,0,NULL,43109772036,673590188,10524846,18.1),(104146,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104146,37.61,0.33,332,43926,70,NULL,NULL,'2MASX J13021790+2251432',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,195.5745,22.86208,0.073,NULL,58807369977,918865155,14357268,16.7),(104147,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104147,37.72,0.21,350,43927,70,NULL,NULL,'2MASX J13021798-0055190',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000074,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,195.574958333,-0.922,0.005,NULL,43109741452,673589710,10524839,17.9),(104148,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104148,36.27,0.46,180,43928,70,NULL,NULL,'IC 4104',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000176,NULL,'15.8g',0.4,NULL,NULL,NULL,NULL,NULL,1,195.5755,38.59242,0,NULL,59073765583,923027587,14422306,15.8),(104149,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104149,35.21,0.49,110,43929,75,NULL,'IR','UGC 08145',NULL,'2011yCatp016004901K',2011,1,1.51,NULL,'G',0.000023,NULL,'14.5g',0.38,'Sab',NULL,NULL,NULL,NULL,1,195.576208333,32.89061,0.017,NULL,58671333135,916739580,14324055,14.5),(104150,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104150,35.23,0.47,111,43929,NULL,NULL,'H','UGC 08145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104151,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104151,35.28,0.4,114,43929,NULL,NULL,'mean','UGC 08145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104152,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104152,35.3,0.45,115,43929,NULL,NULL,'K','UGC 08145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104153,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104153,35.32,0.46,116,43929,NULL,NULL,'J','UGC 08145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104154,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104154,35.43,0.2,122,43929,74.4,NULL,NULL,'UGC 08145',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104155,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104155,36.46,0.46,196,43930,70,NULL,NULL,'IC 4105',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000177,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,195.579167,38.27128,0,NULL,59074221225,923034706,14422417,16.3),(104156,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104156,37.38,0.46,300,43931,70,NULL,NULL,'2MASX J13021928+2928169',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,195.5802917,29.47125,0,NULL,58704044221,917250690,14332042,17.7),(104157,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104157,36.34,0.46,185,43932,70,NULL,NULL,'2MASX J13021939+2857099',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000093,NULL,'16.5g',0.23,NULL,'Group member',NULL,NULL,NULL,1,195.580875,28.95267,0.014,NULL,58704267485,917254179,14332096,16.5),(104158,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104158,37.36,0.33,297,43933,70,NULL,NULL,'2MASX J13021985-0202280',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000085,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,195.5827083,-2.04114,0.005,NULL,43146360397,674161881,10533779,17),(104159,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104159,38.11,0.46,419,43934,70,NULL,NULL,'2MASX J13021993+5136549',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,195.582833,51.61536,0,NULL,57196330861,893692669,13963947,17.7),(104160,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104160,33.61,0.49,52.8,43935,75,NULL,'IR','MCG -02-33-098',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.00011,NULL,'14.5',0.5,'Sc pec sp HII:;LIRG','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,195.584917,-15.76658,0.033,NULL,44019635156,687806799,10746981,14.5),(104161,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104161,37.75,0.46,354,43936,70,NULL,NULL,'2MASX J13022092+3617193',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000167,NULL,'16.3g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,195.58725,36.28861,0.011,NULL,59291597178,926431205,14475487,16.3),(104162,'IRAS','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104162,30.74,0.8,14.1,43937,75,NULL,'A82, H','ESO 219- G 021',NULL,'1997ApJS..109..333W',1997,1,5,'A-M +30\' Dec error.','G',0.000007,NULL,'13.28',1.1,'SB(s)cd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,195.588167,-50.33406,0.989,NULL,46726820464,730106569,11407915,13.28),(104163,'IRAS','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104163,30.75,0.8,14.1,43937,75,NULL,'MAT, I','ESO 219- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104164,'Tully est','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104164,31.33,0.8,18.4,43937,75,NULL,NULL,'ESO 219- G 021',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104165,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104165,30.05,0.47,10.3,43937,75,NULL,'A82, H, inv','ESO 219- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104166,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104166,30.1,0.47,10.5,43937,75,NULL,'A82, H, raw','ESO 219- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104167,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104167,30.47,0.47,12.4,43937,75,NULL,'A82, H, cor','ESO 219- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104168,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104168,30.76,0.32,14.2,43937,85,NULL,'I, raw','ESO 219- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104169,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104169,30.76,0.32,14.2,43937,85,NULL,'I, inv','ESO 219- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104170,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104170,30.8,0.35,14.5,43937,NULL,NULL,NULL,'ESO 219- G 021',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104171,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104171,30.81,0.4,14.5,43937,73,NULL,'opt','ESO 219- G 021',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104172,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104172,30.88,0.43,15,43937,75,NULL,'MAT, I, raw','ESO 219- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104173,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104173,30.88,0.2,15,43937,74.4,NULL,NULL,'ESO 219- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104174,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104174,30.95,0.43,15.5,43937,75,NULL,'MAT, I, inv','ESO 219- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104175,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104175,30.95,0.43,15.5,43937,75,NULL,'3.6 micron, color corrected','ESO 219- G 021',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104176,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104176,30.95,0.43,15.5,43937,75,NULL,'3.6 micron, color + selection bias corrected','ESO 219- G 021',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104177,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104177,31.2,0.43,17.4,43937,75,NULL,'MAT, I, cor','ESO 219- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104178,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104178,37.93,0.09,386,43938,70,NULL,NULL,'2MASX J13022146-0230060',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000083,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,195.589541667,-2.50169,0.005,NULL,43145904367,674154755,10533668,16.4),(104179,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104179,38.85,0.46,588,43939,70,NULL,NULL,'2MASX J13022272+5621268',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,195.5945417,56.35753,0.017,NULL,57429574739,897337105,14020892,18.2),(104180,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104180,38.36,0.27,470,43940,70,NULL,NULL,'SDSS J130223.09+315355.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,195.59625,31.89872,0.035,NULL,58685545741,916961652,14327525,18.2),(104181,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104181,37.42,0.27,305,43941,70,NULL,NULL,'IC 4099',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00013,NULL,'17.12',0.23,NULL,NULL,NULL,NULL,NULL,1,195.5967917,24.02917,0.031,NULL,58688353756,917005527,14328211,17.12),(104182,'IRAS','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104182,31.51,0.8,20.1,43942,75,NULL,'MAT, I','ESO 219- G 022',NULL,'1997ApJS..109..333W',1997,1,2,'RC3 gives v = 1093 +/- 42 km/sec.','G',0.000033,NULL,'14.56',0.7,'SAB(s)dm:','Pair member (points to parent)',NULL,NULL,NULL,1,195.5975,-49.47289,0.793,NULL,46738651198,730291424,11410803,14.56),(104183,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104183,31.47,0.32,19.7,43942,85,NULL,'I, raw','ESO 219- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104184,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104184,31.48,0.32,19.8,43942,85,NULL,'I, inv','ESO 219- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104185,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104185,31.81,0.43,23,43942,75,NULL,'MAT, I, raw','ESO 219- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104186,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104186,31.88,0.43,23.8,43942,75,NULL,'MAT, I, inv','ESO 219- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104187,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104187,32.18,0.43,27.3,43942,75,NULL,'MAT, I, cor','ESO 219- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104188,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104188,35.86,0.46,148,43943,70,NULL,NULL,'2MASX J13022362+5314570',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000178,NULL,'16.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,195.59825,53.24914,0.008,NULL,57194642976,893666296,13963535,16.2),(104189,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104189,37.26,0.46,283,43944,70,NULL,NULL,'2MASX J13022401+6250531',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00014,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,195.600333,62.84792,0.005,NULL,57357539047,896211547,14003305,18.1),(104190,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104190,37.93,0.09,386,43945,70,NULL,NULL,'LCRS B125950.0-022347',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000076,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,195.602,-2.66511,0.013,NULL,43145794559,674153039,10533641,18),(104191,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104191,36.69,0.27,218,43946,70,NULL,NULL,'2MASX J13022457+0028366',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000067,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,195.6024583,0.47675,0,NULL,58087636843,907619325,14181551,17.2),(104192,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104192,39.07,0.46,653,43947,70,NULL,NULL,'SDSS J130225.22+360012.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000177,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,195.605083333,36.00339,0.011,NULL,59290849015,926419515,14475304,18.1),(104193,'IRAS','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104193,34.04,0.8,64.3,43948,75,NULL,'MAT, I','MCG -03-33-028',NULL,'1997ApJS..109..333W',1997,1,2.91,NULL,'G',0.00003,NULL,'14.26',0.39,'Sbc',NULL,NULL,NULL,NULL,1,195.607833,-17.67983,0.121,NULL,44016101446,687751585,10746118,14.26),(104194,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104194,32.72,NULL,34.9,43948,NULL,NULL,NULL,'MCG -03-33-028',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104195,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104195,33.43,0.49,48.5,43948,75,NULL,'IR','MCG -03-33-028',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104196,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104196,33.8,0.43,57.7,43948,75,NULL,'MAT, I, raw','MCG -03-33-028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104197,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104197,33.97,0.32,62.3,43948,85,NULL,'I, raw','MCG -03-33-028',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104198,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104198,33.98,NULL,62.6,43948,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -03-33-028',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104199,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104199,33.98,NULL,62.6,43948,NULL,NULL,'Dipole','MCG -03-33-028',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104200,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104200,33.99,NULL,62.7,43948,NULL,NULL,'Dipole + Quadrupole','MCG -03-33-028',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104201,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104201,34.01,0.2,63.4,43948,74.4,NULL,NULL,'MCG -03-33-028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104202,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104202,34.01,0.4,63.5,43948,NULL,NULL,'Malmquist cor.','MCG -03-33-028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104203,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104203,34.04,0.32,64.2,43948,85,NULL,'I, inv','MCG -03-33-028',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104204,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104204,34.08,0.43,65.5,43948,75,NULL,'MAT, I, inv','MCG -03-33-028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104205,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104205,34.11,0.43,66.4,43948,75,NULL,'MAT, I, cor','MCG -03-33-028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104206,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104206,34.21,0.37,69.5,43948,NULL,NULL,NULL,'MCG -03-33-028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104207,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104207,35.8,0.46,144,43949,70,NULL,NULL,'2MASX J13022848+0311496',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000076,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,195.618708333,3.19728,0.059,NULL,58112639444,908009991,14187656,16.6),(104208,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104208,34.34,0.43,73.7,43950,75,NULL,'3.6 micron, color + selection bias corrected','AM 1259-361',NULL,'2014MNRAS.444..527S',2014,1,0.8,NULL,'G',0.00015,NULL,'17.1',0.09,'Sc',NULL,NULL,NULL,NULL,1,195.620708333,-36.45347,0.153,NULL,46926306203,733223534,11456617,17.1),(104209,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104209,38.16,0.46,428,43951,70,NULL,NULL,'SDSS J130231.23+131116.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000159,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,195.630125,13.18803,0.022,NULL,58996191532,921815492,14403367,18.4),(104210,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104210,35.72,0.46,139,43952,70,NULL,NULL,'IC 4108',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000093,NULL,'15.3g',0.43,NULL,NULL,NULL,NULL,NULL,1,195.631375,38.4785,0,NULL,59074493414,923038959,14422483,15.3),(104211,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104211,37.37,0.46,298,43953,70,NULL,NULL,'2MASX J13023226+2442393',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,195.634417,24.711,0.05,NULL,58688152466,917002382,14328162,17.4),(104212,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104212,36.69,0.27,218,43954,70,NULL,NULL,'2MASX J13023244+0020426',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000213,NULL,'16.82',0.29,NULL,NULL,NULL,NULL,NULL,1,195.63525,0.34517,0.029,NULL,58087661919,907619717,14181558,16.82),(104213,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104213,35.91,0.46,152,43955,70,NULL,NULL,'2MASX J13023328+3130098',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000094,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,195.63875,31.50264,0.038,NULL,58685017094,916953392,14327396,16.9),(104214,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104214,35.99,0.46,158,43956,70,NULL,NULL,'2MASX J13023385+4958100',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000156,NULL,'16.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,195.641,49.9695,0,NULL,59090797151,923293705,14426464,16.2),(104215,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104215,36.69,0.27,218,43957,70,NULL,NULL,'CGCG 015-057',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000105,NULL,'15.2g',0.51,'E0',NULL,NULL,NULL,NULL,1,195.644375,0.34858,0.029,NULL,58087662509,907619726,14181558,15.2),(104216,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104216,36.98,0.33,249,43958,70,NULL,NULL,'2MASX J13023481+1841432',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.64',0.14,NULL,NULL,NULL,NULL,NULL,1,195.645041667,18.69528,0.085,NULL,59035756875,922433701,14413026,18.64),(104217,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104217,37.21,0.33,277,43959,70,NULL,NULL,'2MASX J13023496+1745194',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,195.645833,17.75561,0.093,NULL,59045326211,922583222,14415362,16.7),(104218,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104218,38.03,0.46,404,43960,70,NULL,NULL,'2MASX J13023588-0035590',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000094,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,195.6494583,-0.59972,0,NULL,43109854645,673591478,10524866,17),(104219,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104219,37.07,0.46,260,43961,70,NULL,NULL,'2MASX J13023638+3908193',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000146,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,195.65175,39.13864,0,NULL,59073864586,923029134,14422330,17.6),(104220,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104220,35.79,0.46,144,43962,70,NULL,NULL,'III Zw 069',NULL,'2015arXiv151105856S',2015,1,0.42,'CGPG +1m RA error.','G',0.00011,NULL,'16.33',0.38,NULL,'Group member',NULL,NULL,NULL,1,195.655625,27.17614,0,NULL,58697914632,917154916,14330545,16.33),(104221,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104221,37.17,0.11,272,43963,70,NULL,NULL,'2MASX J13023750+1918172',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000073,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,195.656375,19.30481,0.077,NULL,59035114133,922423658,14412869,17.8),(104222,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104222,37.93,0.09,386,43964,70,NULL,NULL,'LCRS B130004.2-022722',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000107,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,195.661417,-2.72472,0.013,NULL,43145769947,674152655,10533635,17),(104223,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104223,37.3,0.46,288,43965,70,NULL,NULL,'2MASX J13023876+1844552',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.91',0.11,NULL,NULL,NULL,NULL,NULL,1,195.661541667,18.74875,0.085,NULL,59035751870,922433622,14413025,18.91),(104224,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104224,37.39,0.27,301,43966,70,NULL,NULL,'2MASX J13023903+6229390',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.0002,NULL,'15.7g',0.52,'FR II          AGN',NULL,NULL,NULL,NULL,1,195.6627083,62.49425,0.005,NULL,57355775715,896183995,14002874,15.7),(104225,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104225,36.68,0.46,217,43967,70,NULL,NULL,'2MASX J13023912+6349290',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00007,NULL,'16.8g',0.29,'NLAGN',NULL,NULL,NULL,NULL,1,195.663291667,63.82489,0.029,NULL,57350226445,896097288,14001520,16.8),(104226,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104226,36.61,0.33,210,43968,70,NULL,NULL,'2MASX J13023950+0548326',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000186,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,195.6645,5.80903,0.015,NULL,58076694309,907448348,14178880,17.7),(104227,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104227,38.32,0.19,461,43969,70,NULL,NULL,'2MASX J13024033+6728405',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.0001,NULL,'16.5g',0.35,'BrClG          XBONG',NULL,NULL,NULL,NULL,1,195.668041667,67.478,0.033,NULL,57853614757,903962730,14124417,16.5),(104228,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104228,36.51,0.72,201,43970,70,NULL,NULL,'LCRS B130002.0-122940',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'17.01',0.3,NULL,NULL,NULL,NULL,NULL,1,195.671583,-12.76492,0.069,NULL,43968035340,687000552,10734383,17.01),(104229,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104229,37.93,0.09,386,43971,70,NULL,NULL,'2MASX J13024126-0226420',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000079,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,195.671917,-2.445,0.005,NULL,43145983930,674155998,10533687,17.2),(104230,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104230,37.02,0.46,254,43972,70,NULL,NULL,'2MASX J13024147+1942222',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,195.6727917,19.70631,0.17,NULL,59036448794,922444512,14413195,17),(104231,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104231,37.93,0.09,386,43973,70,NULL,NULL,'LCRS B130007.0-023401',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000091,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,195.673083,-2.83583,0.013,NULL,43145235696,674144307,10533504,16.9),(104232,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104232,38.57,0.46,518,43974,70,NULL,NULL,'SDSS J130241.93+084223.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,195.6747083,8.70661,0.019,NULL,58970115837,921408059,14397000,18.3),(104233,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104233,37.93,0.09,386,43975,70,NULL,NULL,'LCRS B130008.3-022624',NULL,'2015arXiv151105856S',2015,1,0.3,'The APM image includes a superposed star.','G',0.000077,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,195.6785417,-2.70867,0.013,NULL,43145761889,674152529,10533633,17.6),(104234,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104234,38.12,0.27,422,43976,70,NULL,NULL,'2MASX J13024294+0820490',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,195.678875,8.34683,0.013,NULL,58962164122,921283814,14395059,NULL),(104235,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104235,37.6,0.46,331,43977,70,NULL,NULL,'SDSS J130243.24+045132.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,195.680167,4.85911,0,NULL,58109317329,907958083,14186845,18.2),(104236,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104236,37.41,0.17,304,43978,70,NULL,NULL,'2MASX J13024357+0316366',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000106,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,195.681583333,3.27686,0.051,NULL,58112768650,908012010,14187687,17.7),(104237,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104237,35.83,0.46,146,43979,70,NULL,NULL,'2MASX J13024433+0530246',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000171,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,195.684583,5.50683,0,NULL,58109508405,907961068,14186891,16.3),(104238,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104238,37.36,0.33,297,43980,70,NULL,NULL,'2MASXi J1302443-015747',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000074,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,195.684875,-1.96325,0.005,NULL,43146406253,674162597,10533790,17.8),(104239,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104239,35.31,0.05,115,43981,70,NULL,NULL,'NGC 4929',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000083,NULL,'14.6g',1,'E1:','Group member',NULL,NULL,NULL,1,195.685,28.04536,0.065,NULL,58697504446,917148506,14330445,14.6),(104240,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104240,35.32,0.25,116,43981,74.4,NULL,NULL,'NGC 4929',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104241,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104241,35.1,0.4,105,43981,NULL,NULL,'mean','NGC 4929',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104242,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104242,35.6,0.45,132,43981,NULL,NULL,'K','NGC 4929',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104243,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104243,35.87,0.46,149,43982,70,NULL,NULL,'2MASX J13024465+3205057',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000113,NULL,'16.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,195.686,32.08503,0.035,NULL,58685626886,916962920,14327545,16.2),(104244,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104244,34.69,0.46,86.9,43983,NULL,NULL,'Malmquist cor.','ESO 575- G 050',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.61',0.6,'Sb',NULL,NULL,NULL,NULL,1,195.686375,-22.07217,0.289,NULL,43791663941,684244749,10691324,14.61),(104245,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104245,34.82,0.44,92.1,43983,NULL,NULL,NULL,'ESO 575- G 050',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104246,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104246,34.86,0.2,93.8,43983,74.4,NULL,NULL,'ESO 575- G 050',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104247,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104247,37.54,0.46,322,43984,70,NULL,NULL,'2MASX J13024598+0941310',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,195.6917083,9.69181,0.015,NULL,58971899217,921435925,14397436,17.8),(104248,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104248,37.93,0.09,386,43985,70,NULL,NULL,'LCRS B130011.8-022242',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000078,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,195.693125,-2.64703,0.005,NULL,43145821566,674153461,10533647,17.2),(104249,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104249,35.88,0.46,150,43986,70,NULL,NULL,'2MASX J13024653+3858190',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000164,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,195.6939583,38.97192,0,NULL,59073851854,923028935,14422327,16.6),(104250,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104250,37.41,0.17,304,43987,70,NULL,NULL,'2MASX J13024705+0315406',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000068,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,195.695875,3.26142,0.051,NULL,58112768938,908012014,14187687,18),(104251,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104251,37.93,0.09,386,43988,70,NULL,NULL,'2MASX J13024706-0223040',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000081,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,195.6960417,-2.38444,0.005,NULL,43145910550,674154852,10533669,17.7),(104252,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104252,36.3,0.46,182,43989,70,NULL,NULL,'2MASX J13024790+4109100',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,195.699417,41.15275,0,NULL,59079256314,923113379,14423646,17),(104253,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104253,34.75,NULL,89.1,43990,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08149',NULL,'2010Ap&SS.325..163P',2010,1,1.29,NULL,'G',0.000008,NULL,'16.20',0.11,'Sc',NULL,NULL,NULL,NULL,1,195.699375,6.78561,0.036,NULL,58078166273,907471348,14179239,16.2),(104254,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104254,34.76,NULL,89.6,43990,NULL,NULL,'Dipole + Quadrupole','UGC 08149',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104255,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104255,34.77,NULL,90,43990,NULL,NULL,'Dipole','UGC 08149',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104256,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104256,35.04,0.49,102,43990,75,NULL,'IR','UGC 08149',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104257,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104257,35.22,0.49,110,43990,NULL,NULL,'Malmquist cor.','UGC 08149',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104258,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104258,35.23,0.48,111,43990,NULL,NULL,NULL,'UGC 08149',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104259,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104259,35.26,0.2,113,43990,74.4,NULL,NULL,'UGC 08149',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104260,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104260,38.32,0.19,461,43991,70,NULL,NULL,'SDSS J130248.44+672714.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000107,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,195.701875,67.45397,0.033,NULL,57853622331,903962848,14124419,18.6),(104261,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104261,37.93,0.09,386,43992,70,NULL,NULL,'LCRS B130014.8-021932',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000073,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,195.7057083,-2.59414,0.005,NULL,43145807760,674153246,10533644,18),(104262,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104262,35.81,0.46,145,43993,70,NULL,NULL,'MCG +07-27-022',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.00008,NULL,'15.4g',0.55,'E',NULL,NULL,NULL,NULL,1,195.70575,43.21478,0,NULL,59077222452,923081600,14423150,15.4),(104263,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104263,38.48,0.46,497,43994,70,NULL,NULL,'2MASX J13024954+6811175',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000098,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,195.7065417,68.18814,0.029,NULL,57853940301,903967817,14124497,16.6),(104264,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104264,37.93,0.09,386,43995,70,NULL,NULL,'2MASX J13025000-0226380',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000103,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,195.708375,-2.44392,0.005,NULL,43145985669,674156026,10533687,16.6),(104265,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104265,37.89,0.46,379,43996,70,NULL,NULL,'SDSS J130250.46+474443.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000129,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,195.71025,47.74556,0,NULL,59105869417,923529209,14430143,18.5),(104266,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104266,37.66,0.46,341,43997,70,NULL,NULL,'2MASX J13025064+1947478',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,195.710917,19.79667,0.17,NULL,59036444228,922444441,14413194,17.4),(104267,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104267,37.41,0.17,304,43998,70,NULL,NULL,'SDSS J130251.02+031834.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000061,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,195.712625,3.30964,0.051,NULL,58112759012,908011859,14187685,18.3),(104268,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104268,38.32,0.19,461,43999,70,NULL,NULL,'2MASX J13025166+6725216',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000088,NULL,'17.7g',0.22,'XBONG          AGN?',NULL,NULL,NULL,NULL,1,195.715333,67.4225,0.033,NULL,57908922803,904826918,14137920,17.7),(104269,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104269,37.93,0.09,386,44000,70,NULL,NULL,'2MASX J13025213-0221570',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000093,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,195.7172083,-2.36581,0,NULL,43145908966,674154827,10533669,17.1),(104270,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104270,35.07,0.46,103,44001,70,NULL,NULL,'CGCG 071-100',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00017,NULL,'15.2',0.35,NULL,NULL,NULL,NULL,NULL,1,195.7185417,10.09442,0,NULL,58971519964,921429999,14397343,15.2),(104271,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104271,37.41,0.17,304,44002,70,NULL,NULL,'SDSS J130254.27+031902.7',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.2g',0.37,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,195.726167,3.31742,0.051,NULL,58112788678,908012323,14187692,16.2),(104272,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104272,37.93,0.09,386,44003,70,NULL,NULL,'2MASX J13025507-0224415',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00009,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,195.729583,-2.41164,0,NULL,43145980590,674155946,10533686,18),(104273,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104273,37.5,0.46,316,44004,70,NULL,NULL,'2MASX J13025511+0817288',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,195.729625,8.29136,0.013,NULL,58962128758,921283261,14395050,17),(104274,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104274,37.63,0.46,336,44005,70,NULL,NULL,'2MASX J13025533+5709529',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000142,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,195.730541667,57.16481,0,NULL,57443892830,897560825,14024387,18),(104275,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104275,32.47,NULL,31.2,44006,NULL,NULL,NULL,'MCG +09-21-092',NULL,'2000BSAO...50....5K',2000,1,0.88,'MCG implies the R.A. is 12h00.9m; corrected in MCG errata.','G',0.000013,NULL,'16.8g',0.21,'Sm',NULL,NULL,NULL,NULL,1,195.732208333,55.6945,0.013,NULL,57422316460,897223694,14019120,16.8),(104276,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104276,32.59,NULL,33,44006,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG +09-21-092',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104277,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104277,32.62,NULL,33.4,44006,NULL,NULL,'Dipole + Quadrupole','MCG +09-21-092',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104278,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104278,32.65,NULL,33.9,44006,NULL,NULL,'Dipole','MCG +09-21-092',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104279,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104279,36.97,0.61,248,44007,70,NULL,NULL,'AM 1259-493 NED02',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,195.733416667,-50.21269,1.017,NULL,46727553671,730118026,11408094,16.8),(104280,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104280,37.93,0.09,386,44008,70,NULL,NULL,'SDSS J130256.08-022017.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000081,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,195.733666667,-2.33822,0,NULL,43145908332,674154817,10533669,18.5),(104281,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104281,37.47,0.33,312,44009,70,NULL,NULL,'2MASX J13025648+3634461',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000136,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,195.735417,36.57964,0.007,NULL,59291405307,926428207,14475440,18.1),(104282,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104282,38.55,0.46,512,44010,70,NULL,NULL,'SDSS J130257.06+544753.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,195.7377917,54.79811,0.006,NULL,57423180220,897237190,14019331,18.1),(104283,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104283,36.89,0.46,239,44011,70,NULL,NULL,'2MASX J13025737+0717158',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.72',0.2,NULL,NULL,NULL,NULL,NULL,1,195.739,7.28761,0.034,NULL,58961704027,921276625,14394947,17.72),(104284,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104284,37.39,0.27,301,44012,70,NULL,NULL,'2MASX J13025755+6228517',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000192,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,195.7397917,62.48094,0.005,NULL,57355555139,896180549,14002821,16.4),(104285,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104285,37.51,0.46,317,44013,70,NULL,NULL,'2MASX J13025764+2433043',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'18.67',NULL,NULL,NULL,NULL,NULL,NULL,1,195.740083,24.55114,0.05,NULL,58688721536,917011274,14328301,18.67),(104286,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104286,37.17,0.11,272,44014,70,NULL,NULL,'IC 4110',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000093,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,195.742875,19.22697,0.077,NULL,59035132445,922423944,14412874,17),(104287,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104287,37.76,0.46,357,44015,70,NULL,NULL,'2MASX J13025861+0531351',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,195.744417,5.52647,0,NULL,58111585975,907993530,14187398,17.5),(104288,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104288,37.41,0.17,304,44016,70,NULL,NULL,'2MASX J13025871+0306041',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,'FoF','18.50',0.16,NULL,NULL,NULL,NULL,NULL,1,195.744625,3.10114,0.054,NULL,58112826630,908012916,14187701,18.5),(104289,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104289,37.65,0.46,338,44017,70,NULL,NULL,'2MASX J13025896+0424581',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000178,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,195.745667,4.41614,0.018,NULL,58111043813,907985059,14187266,17.5),(104290,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104290,37.76,0.46,357,44018,70,NULL,NULL,'2MASX J13025907+6140067',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000137,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,195.7462917,61.66869,0.005,NULL,57356706541,896198539,14003102,17.7),(104291,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104291,37.41,0.17,304,44019,70,NULL,NULL,'2MASX J13025917+0306341',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000071,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,195.7465,3.10958,0.054,NULL,58112826844,908012919,14187701,17.5),(104292,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104292,37.41,0.17,304,44020,70,NULL,NULL,'2MASX J13025944+0319251',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000085,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,195.7475,3.32372,0.051,NULL,58112789051,908012328,14187692,17.1),(104293,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104293,37.69,0.46,345,44021,70,NULL,NULL,'2MASX J13030032-0028525',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000096,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,195.75125,-0.48139,0,NULL,43109882467,673591913,10524873,17.2),(104294,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104294,37.47,0.33,312,44022,70,NULL,NULL,'2MASX J13030055+3632181',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000141,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,195.752333,36.53853,0.007,NULL,59291287861,926426372,14475412,17.8),(104295,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104295,31.32,0.4,18.4,44023,NULL,NULL,NULL,'NGC 4928',NULL,'2013MNRAS.429.2677K',2013,1,1.3,NULL,'G',0.000021,NULL,'13.24',1,'SA(s)bc pec','in a pair',NULL,NULL,NULL,1,195.752375,-8.08497,0.089,NULL,43849097938,685142155,10705346,13.24),(104296,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104296,32.28,0.47,28.6,44023,NULL,NULL,'H','NGC 4928',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104297,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104297,32.3,0.46,28.8,44023,NULL,NULL,'J','NGC 4928',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104298,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104298,32.31,0.4,28.9,44023,NULL,NULL,'mean','NGC 4928',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104299,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104299,32.38,0.45,30,44023,NULL,NULL,'K','NGC 4928',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104300,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104300,37.39,0.27,301,44024,70,NULL,NULL,'2MASX J13030075+6227208',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000193,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,195.7534583,62.45581,0.005,NULL,57355584163,896181002,14002828,16.7),(104301,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104301,37.68,0.33,343,44025,70,NULL,NULL,'2MASX J13030099+2301208',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,195.75425,23.02256,0.073,NULL,58807410662,918865791,14357277,17.3),(104302,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104302,34.03,0.25,64,44026,74.4,NULL,NULL,'ESO 382- G 002',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000014,NULL,'14.36',0.7,'S0',NULL,NULL,NULL,NULL,1,195.755125,-32.84081,0.237,NULL,43321545258,676899144,10576549,14.36),(104303,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104303,34.25,0.48,70.9,44026,70,NULL,NULL,'ESO 382- G 002',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104304,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104304,34.17,0.4,68.3,44026,NULL,NULL,'mean','ESO 382- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104305,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104305,34.6,0.45,83,44026,NULL,NULL,'K','ESO 382- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104306,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104306,37.56,0.46,325,44027,70,NULL,NULL,'2MASX J13030149-0138205',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000078,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,195.756167,-1.63906,0.005,NULL,43146530694,674164542,10533820,17.4),(104307,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104307,37.24,0.46,281,44028,70,NULL,NULL,'2MASX J13030171+2127249',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,195.757375,21.45681,0.126,NULL,58805353594,918833649,14356775,17.7),(104308,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104308,38.72,0.46,555,44029,70,NULL,NULL,'2MASX J13030176-0144165',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000091,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,195.7574583,-1.73814,0.005,NULL,43146534494,674164601,10533821,17.7),(104309,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104309,36.59,0.46,208,44030,70,NULL,NULL,'2MASX J13030178+1521406',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000037,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,195.7574583,15.36119,0.019,NULL,59052478626,922694978,14417109,17),(104310,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104310,36.97,0.46,248,44031,70,NULL,NULL,'2MASX J13030485-0031245',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000083,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,195.770125,-0.52347,0,NULL,43109886106,673591970,10524874,17.3),(104311,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104311,33.13,0.4,42.3,44032,75,NULL,'B','UGC 08153',NULL,'1988NBGC.C....0000T',1988,1,1.2,NULL,'G',0.000003,NULL,'15.2g',0.81,'Sd',NULL,NULL,NULL,NULL,1,195.774667,3.99189,0.023,NULL,58112368335,908005755,14187589,15.2),(104312,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104312,36.83,0.46,233,44033,70,NULL,NULL,'2MASX J13030593+1344396',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000164,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,195.774833,13.74439,0.026,NULL,58994955726,921796183,14403065,17.1),(104313,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104313,34.64,0.5,84.9,44034,70,NULL,NULL,'LCRS B130030.7-054235',NULL,'2014MNRAS.445.2677S',2014,1,0.81,NULL,'G',0.00009,NULL,'14.18',0.63,NULL,NULL,NULL,NULL,NULL,1,195.7764583,-5.978,0.057,NULL,43121929372,673780146,10527814,14.18),(104314,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104314,37.68,0.33,343,44035,70,NULL,NULL,'2MASX J13030657+2259209',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,195.7772917,22.98908,0.073,NULL,58807409567,918865774,14357277,18.4),(104315,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104315,37.09,0.46,262,44036,70,NULL,NULL,'LCRS B130033.9-023513',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00008,NULL,'16.3g',0.4,NULL,NULL,NULL,NULL,NULL,1,195.785541667,-2.85547,0.013,NULL,43145289822,674145153,10533518,16.3),(104316,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104316,37.93,0.09,386,44037,70,NULL,NULL,'2MASX J13030882-0221475',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000083,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,195.786625,-2.36311,0,NULL,43146014654,674156478,10533694,17.9),(104317,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104317,35.69,0.46,138,44038,70,NULL,NULL,'2MASX J13030921+5436599',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000168,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,195.788167,54.61656,0.008,NULL,57421388619,897209197,14018893,16.2),(104318,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104318,37.93,0.09,386,44039,70,NULL,NULL,'2MASX J13030928-0224415',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000083,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,195.7887083,-2.41158,0,NULL,43146016089,674156501,10533695,17.3),(104319,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104319,38.18,0.46,432,44040,70,NULL,NULL,'2MASX J13030993+1517446',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,195.791375,15.29589,0.019,NULL,59052600475,922696882,14417138,18),(104320,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104320,35.55,0.33,129,44041,70,NULL,NULL,'2MASX J13031027+4722517',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,195.79275,47.38114,0,NULL,59105664741,923526011,14430093,17),(104321,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104321,37.2,0.59,275,44042,70,NULL,NULL,'2MASX J13031036-1957099',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.05',NULL,NULL,NULL,NULL,NULL,NULL,1,195.793125,-19.95269,0.225,NULL,43988282910,687316920,10739326,16.05),(104322,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104322,35.55,0.33,129,44043,70,NULL,NULL,'CGCG 245-013',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000173,NULL,'14.7g',0.77,'E0',NULL,NULL,NULL,NULL,1,195.7934583,47.39386,0,NULL,59105664868,923526013,14430093,14.7),(104323,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104323,36.61,0.33,210,44044,70,NULL,NULL,'2MASX J13031067+0554421',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000158,NULL,'16.2g',0.31,'E0',NULL,NULL,NULL,NULL,1,195.794625,5.91189,0.015,NULL,58074914597,907420540,14178445,16.2),(104324,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104324,36.69,0.46,218,44045,70,NULL,NULL,'2MASX J13031069+1750315',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.89',0.12,NULL,NULL,NULL,NULL,NULL,1,195.794667,17.84222,0.09,NULL,59040074973,922501171,14414080,18.89),(104325,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104325,37.93,0.09,386,44046,70,NULL,NULL,'2MASX J13031135-0223015',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00008,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,195.797333333,-2.38383,0,NULL,43146018309,674156536,10533695,18),(104326,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104326,38.43,0.46,486,44047,70,NULL,NULL,'2MASX J13031406+0248551',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000082,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,195.808625,2.81539,0.04,NULL,58105061273,907891582,14185805,17.7),(104327,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104327,37.1,0.46,263,44048,70,NULL,NULL,'LCRS B130040.4-031518',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000077,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,195.813333,-3.52347,0,NULL,43147652022,674182062,10534094,17.1),(104328,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104328,37.93,0.09,386,44049,70,NULL,NULL,'2MASX J13031609-0225115',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000085,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,195.817,-2.41978,0,NULL,43146017372,674156521,10533695,17.5),(104329,'SNIa','2016-12-15 15:15:09','2016-12-16 11:20:21','1','SN 2007F',NULL,104329,34.47,0.17,76.5,44050,74.2,NULL,'SALT 2','UGC 08162',0.023591,'2010ApJ...716..712A',2010,1,0.83,NULL,'G',0.000107,NULL,'14.8g',0.7,'Scd:',NULL,NULL,NULL,NULL,1,195.817125,50.62075,0,NULL,59091285154,923301330,14426583,14.8),(104330,'SNIa','2016-12-15 15:15:09','2016-12-16 11:20:21','1','SN 2007F',NULL,104330,34.98,0.04,96.7,44050,70,NULL,'SALT 2','UGC 08162',0.023591,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104331,'SNIa','2016-12-15 15:15:09','2016-12-16 11:20:21','1','SN 2007F',NULL,104331,35.04,0.09,102,44050,74.4,NULL,NULL,'UGC 08162',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104332,'SNIa','2016-12-15 15:15:09','2016-12-16 11:20:21','1','SN 2007F',NULL,104332,35.11,0.02,103,44050,72,NULL,'SALT2','UGC 08162',0.023591,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104333,'SNIa','2016-12-15 15:15:09','2016-12-16 11:20:21','1','SN 2007F','R',104333,35.12,0.05,106,44050,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 08162',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104334,'SNIa','2016-12-15 15:15:09','2016-12-16 11:20:21','1','SN 2007F','R',104334,35.15,0.06,107,44050,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 08162',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104335,'SNIa','2016-12-15 15:15:09','2016-12-16 11:20:21','1','SN 2007F',NULL,104335,35.22,0.16,108,44050,70,NULL,'SALT 2','UGC 08162',0.023591,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104336,'SNIa','2016-12-15 15:15:09','2016-12-16 11:20:21','1','SN 2007F',NULL,104336,35.22,0.15,108,44050,73.8,NULL,'SALT 2 (SNANA)','UGC 08162',0.0245,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104337,'SNIa','2016-12-15 15:15:09','2016-12-16 11:20:21','1','SN 2007F',NULL,104337,35.35,0.2,115,44050,65,NULL,'SALT2','UGC 08162',0.023591,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104338,'SNIa','2016-12-15 15:15:09','2016-12-16 11:20:21','1','SN 2007F',NULL,104338,35.36,0.16,115,44050,65,NULL,'MLCS17','UGC 08162',0.023591,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104339,'SNIa','2016-12-15 15:15:09','2016-12-16 11:20:21','1','SN 2007F',NULL,104339,35.37,0.18,116,44050,65,NULL,'SALT','UGC 08162',0.023591,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104340,'SNIa','2016-12-15 15:15:09','2016-12-16 11:20:21','1','SN 2007F',NULL,104340,35.44,0.16,120,44050,65,NULL,'MLCS31','UGC 08162',0.023591,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104341,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104341,37.61,0.46,332,44051,70,NULL,NULL,'SDSS J130316.13+084748.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00014,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,195.81725,8.79681,0.019,NULL,58970141519,921408461,14397007,18),(104342,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104342,28.39,NULL,4.76,44052,NULL,NULL,NULL,'UGCA 320',NULL,'2000BSAO...50....5K',2000,1,8.01,'Confused HIPASS source','G',0.000007,NULL,'13.78',1.06,'IB(s)m sp',NULL,NULL,NULL,NULL,1,195.81975,-17.42303,0.117,NULL,44020495350,687820239,10747191,13.78),(104343,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104343,28.53,NULL,5.09,44052,NULL,NULL,'Dipole + Quadrupole','UGCA 320',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104344,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104344,28.53,NULL,5.09,44052,NULL,NULL,'Dipole + Quadrupole + Octopole','UGCA 320',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104345,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104345,28.54,NULL,5.1,44052,NULL,NULL,'Dipole','UGCA 320',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104346,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104346,28.67,0.2,5.42,44052,74.4,NULL,NULL,'UGCA 320',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104347,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104347,29.19,0.4,6.9,44052,73,NULL,'opt','UGCA 320',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104348,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104348,29.2,0.36,6.92,44052,NULL,NULL,NULL,'UGCA 320',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104349,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104349,29.26,0.4,7.1,44052,75,NULL,'B','UGCA 320',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104350,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104350,29.32,0.4,7.3,44052,NULL,NULL,NULL,'UGCA 320',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104351,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104351,29.32,NULL,7.31,44052,NULL,NULL,NULL,'UGCA 320',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104352,'D-Sigma','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104352,32.39,0.4,30.1,44053,75,NULL,'Edat, raw','IC 0844',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.00003,NULL,'13.67',0.4,'S0','in a pair',NULL,NULL,NULL,1,195.825916667,-30.52108,0.309,NULL,43330378883,677037170,10578705,13.67),(104353,'D-Sigma','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104353,32.53,0.4,32,44053,75,NULL,'Edat, cor','IC 0844',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104354,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104354,32.35,0.45,29.5,44053,NULL,NULL,'K','IC 0844',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104355,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104355,33.19,0.4,43.5,44053,NULL,NULL,'mean','IC 0844',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104356,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104356,37.54,0.46,323,44054,70,NULL,NULL,'2MASX J13031840+2517234',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,195.826667,25.28986,0.037,NULL,58702091610,917220181,14331565,16.9),(104357,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104357,38.32,0.33,462,44055,70,NULL,NULL,'2MASX J13031913+6821055',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000085,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,195.829333333,68.35153,0.029,NULL,57853267859,903957310,14124332,17.3),(104358,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104358,37.56,0.46,326,44056,70,NULL,NULL,'SDSS J130319.30+032210.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000071,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,195.830417,3.36953,0.085,NULL,58112777583,908012149,14187689,18.3),(104359,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104359,37.32,0.46,291,44057,70,NULL,NULL,'2MASX J13031953+3308453',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000174,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,195.8314583,33.14578,0,NULL,58673239588,916769368,14324521,16.5),(104360,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104360,36.81,0.46,230,44058,70,NULL,NULL,'2MASX J13032015+2228050',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,195.8339583,22.468,0.107,NULL,58805565545,918836961,14356827,16.9),(104361,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104361,38.13,0.46,423,44059,70,NULL,NULL,'2MASX J13032083+0447011',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,195.8367083,4.78364,0,NULL,58111228921,907987951,14187311,17.9),(104362,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104362,37.41,0.46,303,44060,70,NULL,NULL,'2MASX J13032109+1117540',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,195.837917,11.2985,0.012,NULL,58965611270,921337676,14395901,17.1),(104363,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104363,37.85,0.46,371,44061,70,NULL,NULL,'2MASX J13032228+4012437',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000202,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,195.84275,40.21214,0,NULL,59079075322,923110551,14423602,17),(104364,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104364,38.32,0.33,462,44062,70,NULL,NULL,'SDSS J130322.67+681747.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000073,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,195.8445,68.29647,0.029,NULL,57853279653,903957494,14124335,18.1),(104365,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104365,36.99,0.52,250,44063,70,NULL,NULL,'2MASX J13032357-1151091',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.07',NULL,NULL,NULL,NULL,NULL,NULL,1,195.8482083,-11.85286,0.069,NULL,43966396979,686974952,10733983,16.07),(104366,'IRAS','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104366,34.16,0.8,67.8,44064,75,NULL,'MAT, I','ESO 443- G 041',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'13.95',0.5,'(R\')SAB?(r)ab  HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,195.848791667,-32.23719,0.297,NULL,43332869096,677076079,10579313,13.95),(104367,'Sosies','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104367,34.39,0.04,75.5,44064,NULL,NULL,NULL,'ESO 443- G 041',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104368,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104368,34.06,0.32,64.9,44064,NULL,NULL,'Malmquist cor.','ESO 443- G 041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104369,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104369,34.18,0.43,68.5,44064,75,NULL,'MAT, I, raw','ESO 443- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104370,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104370,34.3,0.32,72.6,44064,85,NULL,'I, raw','ESO 443- G 041',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104371,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104371,34.35,0.43,74.3,44064,75,NULL,'MAT, I, cor','ESO 443- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104372,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104372,34.39,0.32,75.4,44064,85,NULL,'I, inv','ESO 443- G 041',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104373,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104373,34.48,0.27,78.8,44064,NULL,NULL,NULL,'ESO 443- G 041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104374,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104374,34.51,0.43,79.8,44064,75,NULL,'MAT, I, inv','ESO 443- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104375,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104375,34.52,0.2,80.2,44064,74.4,NULL,NULL,'ESO 443- G 041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104376,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104376,37.32,0.46,291,44065,70,NULL,NULL,'2MASX J13032382-0227544',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000078,NULL,'17.0g',0.31,NULL,NULL,NULL,NULL,NULL,1,195.8492917,-2.46522,0,NULL,43145998648,674156228,10533691,17),(104377,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104377,37.09,0.33,262,44066,70,NULL,NULL,'2MASX J13032402+6012249',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000157,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,195.850333,60.20686,0.005,NULL,57386117648,896658088,14010282,16.5),(104378,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104378,36.87,0.46,236,44067,70,NULL,NULL,'IC 4122',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000073,NULL,'15.3',0.3,'E?',NULL,NULL,NULL,NULL,1,195.8517917,20.19692,0.139,NULL,59036737761,922449027,14413266,15.3),(104379,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104379,37.93,0.09,386,44068,70,NULL,NULL,'SDSS J130324.94-023458.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000071,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,195.8539583,-2.58278,0,NULL,43145775943,674152749,10533636,18.3),(104380,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104380,36.09,0.54,165,44069,70,NULL,NULL,'2MASX J13032508-4412086',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,195.854625,-44.20231,0.461,NULL,46759001048,730609391,11415771,15.5),(104381,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104381,37.39,0.46,301,44070,70,NULL,NULL,'SDSS J130325.84+081515.9',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,195.8577083,8.25444,0.029,NULL,58962106251,921282910,14395045,18.6),(104382,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104382,38.1,0.46,417,44071,70,NULL,NULL,'SDSS J130325.87+523522.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000141,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,195.8577917,52.58953,0,NULL,57195578162,893680908,13963764,18.2),(104383,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104383,38.07,0.46,412,44072,70,NULL,NULL,'2MASX J13032611+1257031',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,195.858833,12.95083,0.023,NULL,58996902020,921826594,14403540,18.3),(104384,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104384,36.79,0.46,228,44073,70,NULL,NULL,'2MASX J13032709+5134396',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000136,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,195.8627917,51.57778,0,NULL,57196473731,893694902,13963982,17.1),(104385,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104385,37.23,0.46,280,44074,70,NULL,NULL,'2MASXi J1303271+324735',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000148,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,195.862833,32.79333,0.027,NULL,58671479836,916741872,14324091,17.1),(104386,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104386,37.77,0.46,357,44075,70,NULL,NULL,'2MASX J13032822+5847426',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000147,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,195.8672917,58.79519,0,NULL,57439788864,897496701,14023385,17.5),(104387,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104387,37.75,0.46,354,44076,70,NULL,NULL,'2MASX J13032851+3251564',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000184,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,195.868875,32.86567,0.027,NULL,58671337438,916739647,14324056,17.6),(104388,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104388,37.25,0.46,282,44077,70,NULL,NULL,'2MASX J13032864+1246571',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,195.869375,12.78253,0.039,NULL,58996984373,921827880,14403560,17.3),(104389,'IRAS','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104389,34.79,0.8,90.6,44078,75,NULL,'W91CL, r','UGC 08161',NULL,'1997ApJS..109..333W',1997,1,1.13,NULL,'G',0.000007,NULL,'14.9g',0.45,'Sb             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,195.871167,26.5505,0,NULL,58699799752,917184371,14331005,14.9),(104390,'IRAS','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104390,34.79,0.8,90.6,44078,75,NULL,'HMCL, I','UGC 08161',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104391,'IRAS','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104391,34.8,0.8,91.4,44078,75,NULL,'CF, r','UGC 08161',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104392,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104392,34.41,0.38,76.2,44078,75,NULL,'CF, r, raw','UGC 08161',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104393,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104393,34.5,0.38,79.5,44078,75,NULL,'CF, r, inv','UGC 08161',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104394,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104394,34.76,0.38,89.5,44078,75,NULL,'W91CL, r, raw','UGC 08161',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104395,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104395,34.76,0.38,89.5,44078,75,NULL,'CF, r, cor','UGC 08161',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104396,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104396,34.86,0.43,93.7,44078,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08161',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104397,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104397,34.89,0.38,95,44078,75,NULL,'W91CL, r, inv','UGC 08161',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104398,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104398,34.89,0.43,95.2,44078,75,NULL,'3.6 micron, color corrected','UGC 08161',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104399,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104399,34.91,0.38,95.9,44078,75,NULL,'W91CL, r, cor','UGC 08161',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104400,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104400,35.02,0.2,101,44078,74.4,NULL,NULL,'UGC 08161',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104401,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104401,35.02,0.4,101,44078,75,NULL,'HMCL, I, raw','UGC 08161',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104402,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104402,35.1,0.4,105,44078,75,NULL,'HMCL, I, cor','UGC 08161',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104403,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104403,35.16,0.06,108,44078,NULL,NULL,NULL,'UGC 08161',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104404,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104404,35.2,0.4,110,44078,75,NULL,'HMCL, I, inv','UGC 08161',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104405,'IRAS','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104405,32.9,0.8,38.1,44079,75,NULL,'MAT, I','ESO 443- G 042',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.000027,NULL,'13.98',0.4,'Sb: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,195.873875,-29.82878,0.381,NULL,43329577978,677024655,10578510,13.98),(104406,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104406,32.53,0.43,32,44079,75,NULL,'MAT, I, raw','ESO 443- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104407,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104407,32.63,0.32,33.5,44079,85,NULL,'I, raw','ESO 443- G 042',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104408,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104408,32.63,0.4,33.6,44079,75,NULL,NULL,'ESO 443- G 042',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104409,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104409,32.66,0.32,34.1,44079,85,NULL,'I, inv','ESO 443- G 042',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104410,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104410,32.71,0.43,34.9,44079,75,NULL,'MAT, I, inv','ESO 443- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104411,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104411,32.74,0.49,35.3,44079,75,NULL,'IR','ESO 443- G 042',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104412,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104412,32.84,0.46,37.1,44079,NULL,NULL,'J','ESO 443- G 042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104413,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104413,32.85,0.43,37.2,44079,75,NULL,'MAT, I, cor','ESO 443- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104414,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104414,32.86,0.47,37.3,44079,NULL,NULL,'H','ESO 443- G 042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104415,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104415,32.86,0.2,37.3,44079,74.4,NULL,NULL,'ESO 443- G 042',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104416,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104416,32.87,0.45,37.6,44079,NULL,NULL,'K','ESO 443- G 042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104417,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104417,32.94,0.43,38.7,44079,75,NULL,'3.6 micron, color corrected','ESO 443- G 042',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104418,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104418,33.02,0.43,40.2,44079,75,NULL,'3.6 micron, color + selection bias corrected','ESO 443- G 042',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104419,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104419,33.21,0.4,43.8,44079,NULL,NULL,'mean','ESO 443- G 042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104420,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104420,33.45,0.13,49.1,44079,NULL,NULL,NULL,'ESO 443- G 042',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104421,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104421,38.12,0.27,422,44080,70,NULL,NULL,'SDSS J130330.59+081603.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,195.8775,8.26761,0.029,NULL,58962116067,921283063,14395047,18.3),(104422,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104422,36.59,0.33,208,44081,70,NULL,NULL,'2MASXi J1303308+200258',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,195.8785,20.04944,0.165,NULL,59036531255,922445800,14413215,17.4),(104423,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104423,37.66,0.46,341,44082,70,NULL,NULL,'2MASX J13033153+1716241',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,195.8815,17.27344,0.087,NULL,59053908255,922717316,14417458,17.3),(104424,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104424,37.07,0.46,260,44083,70,NULL,NULL,'IC 4124',NULL,'2015arXiv151105856S',2015,1,0.41,'The IC number includes a neighboring star.','G',NULL,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,195.8815417,22.84681,0.043,NULL,58807531607,918867681,14357307,16.5),(104425,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104425,34.09,0.47,65.6,44084,NULL,NULL,'H','ESO 382- G 003',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000033,NULL,'14.62',0.8,'S?',NULL,NULL,NULL,NULL,1,195.884667,-32.86775,0.237,NULL,43321544008,676899125,10576548,14.62),(104426,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104426,34.21,0.4,69.4,44084,NULL,NULL,'mean','ESO 382- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104427,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104427,34.22,0.45,69.8,44084,NULL,NULL,'K','ESO 382- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104428,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104428,34.24,0.46,70.3,44084,NULL,NULL,'J','ESO 382- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104429,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104429,36.26,0.33,178,44085,70,NULL,NULL,'2MASX J13033286+0724420',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,195.8870417,7.41161,0.034,NULL,58962777417,921293397,14395209,17.3),(104430,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104430,35.6,0.46,132,44086,70,NULL,NULL,'2MASX J13033310+1450201',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000173,NULL,'15.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,195.887875,14.83906,0.035,NULL,59051725253,922683207,14416925,15.9),(104431,'TRGB','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104431,27.49,0.1,3.15,44087,74.4,NULL,NULL,'ESO 269- G 037',NULL,'2013AJ....146...86T',2013,1,2.2,NULL,'G',0.000007,NULL,'16.29',1.4,'IABm:',NULL,NULL,NULL,NULL,1,195.889917,-46.58497,0.637,NULL,46732102075,730189094,11409204,16.29),(104432,'TRGB','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104432,27.49,0.11,3.15,44087,NULL,NULL,NULL,'ESO 269- G 037',NULL,'2015ApJ...802L..25T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104433,'TRGB','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104433,27.56,0.14,3.25,44087,NULL,NULL,'I','ESO 269- G 037',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104434,'TRGB','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104434,27.71,NULL,3.48,44087,NULL,NULL,NULL,'ESO 269- G 037',NULL,'2002A&A...385...21K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104435,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104435,35.65,0.68,135,44088,70,NULL,NULL,'2MASX J13033461-7902103',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,195.89425,-79.03619,0.489,NULL,44256082184,691501284,10804707,17.4),(104436,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104436,38.52,0.46,505,44089,70,NULL,NULL,'2MASX J13033466+6338478',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000085,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,195.894458333,63.64664,0.029,NULL,57350181896,896096592,14001509,18.1),(104437,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104437,37.46,0.33,310,44090,70,NULL,NULL,'2MASX J13033466+0246192',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000096,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,195.894625,2.772,0.04,NULL,58105047726,907891370,14185802,17.1),(104438,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104438,36.98,0.33,249,44091,70,NULL,NULL,'IC 4125',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000107,NULL,'16.26',0.26,NULL,NULL,NULL,NULL,NULL,1,195.8957083,18.80339,0.078,NULL,59033332995,922395828,14412434,16.26),(104439,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104439,36.97,0.55,248,44092,70,NULL,NULL,'2MASX J13033554-1931212',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.3,NULL,NULL,NULL,NULL,NULL,1,195.898,-19.5225,0.225,NULL,43988028418,687312944,10739264,13.9),(104440,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104440,37.17,0.11,272,44093,70,NULL,NULL,'2MASX J13033606+1932350',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,195.900375,19.543,0.078,NULL,59036417096,922444017,14413187,17.1),(104441,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104441,36.63,0.46,211,44094,70,NULL,NULL,'2MASX J13033706+1007170',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000035,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,195.9045417,10.12144,0,NULL,58971621989,921431593,14397368,16.5),(104442,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104442,35.26,0.58,113,44095,70,NULL,NULL,'2MASX J13033714-2355072',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000083,NULL,'13.9I',0.3,NULL,NULL,NULL,NULL,NULL,1,195.9047917,-23.91853,0.289,NULL,43789772820,684215200,10690862,13.9),(104443,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104443,38.12,0.27,422,44096,70,NULL,NULL,'SDSS J130337.14+081859.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,195.9047917,8.31644,0.029,NULL,58962102125,921282845,14395044,17.7),(104444,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104444,37.88,0.27,376,44097,70,NULL,NULL,'2MASX J13033724+2917588',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00017,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,195.905375,29.29981,0.015,NULL,58707125909,917298842,14332794,18.2),(104445,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104445,36.77,0.46,225,44098,70,NULL,NULL,'2MASX J13033759+6456498',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000079,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,195.906417,64.94706,0.025,NULL,57349559876,896086873,14001357,16.9),(104446,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104446,37.92,0.21,384,44099,70,NULL,NULL,'LCRS B130102.8-030813',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00007,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,195.9064583,-3.40533,0,NULL,43147634884,674181795,10534090,18.3),(104447,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104447,37.45,0.46,309,44100,70,NULL,NULL,'2MASX J13033759-0100194',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000073,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,195.906667,-1.00542,0.021,NULL,43109680457,673588757,10524824,17.3),(104448,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104448,38.25,0.46,446,44101,70,NULL,NULL,'SDSS J130337.90+272154.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'19.29',0.14,NULL,'Group member',NULL,NULL,NULL,1,195.9079583,27.36511,0.035,NULL,58698192611,917159259,14330613,19.29),(104449,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104449,37.39,0.46,301,44102,70,NULL,NULL,'2MASX J13033802+0613150',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.60',0.16,NULL,NULL,NULL,NULL,NULL,1,195.9082917,6.22078,0.037,NULL,58075052996,907422703,14178479,18.6),(104450,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104450,37.58,0.33,329,44103,70,NULL,NULL,'2MASX J13033943+0607560',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,195.914167,6.13219,0.037,NULL,58075009140,907422017,14178469,17.2),(104451,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104451,38.32,0.19,461,44104,70,NULL,NULL,'SDSS J130339.54+672445.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000077,NULL,'18.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,195.9147917,67.41269,0.029,NULL,57908921584,904826899,14137920,18.1),(104452,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104452,38.78,0.46,571,44105,70,NULL,NULL,'SDSS J130339.95+023405.5',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000071,NULL,'17.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,195.9164583,2.56822,0.016,NULL,58105024174,907891002,14185796,17.7),(104453,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104453,37.07,0.46,259,44106,70,NULL,NULL,'2MASX J13034027+0807240',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.09',0.16,NULL,NULL,NULL,NULL,NULL,1,195.9177083,8.12347,0.029,NULL,58962088742,921282636,14395041,18.09),(104454,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104454,35.68,0.62,137,44107,70,NULL,NULL,'2MASX J13034029-1959062',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,195.917958333,-19.98506,0.225,NULL,43988185278,687315394,10739303,16.2),(104455,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104455,38.61,0.46,526,44108,70,NULL,NULL,'2MASX J13034036+4041117',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,195.91825,40.68658,0,NULL,59079815807,923122121,14423783,18.4),(104456,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104456,37.88,0.27,376,44109,70,NULL,NULL,'SDSS J130340.58+291624.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,195.919125,29.27353,0.026,NULL,58707127400,917298865,14332794,18.2),(104457,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104457,35.64,0.19,134,44110,70,NULL,NULL,'SBS 1301+539',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000126,NULL,'15.8g',0.41,'E0',NULL,NULL,NULL,NULL,1,195.920041667,53.72325,0.029,NULL,57425482044,897273156,14019893,15.8),(104458,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104458,37.99,0.46,396,44111,70,NULL,NULL,'2MASX J13034126+1200011',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,195.921791667,12.00019,0.04,NULL,58995501091,921804704,14403198,18.3),(104459,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104459,37.2,0.46,275,44112,70,NULL,NULL,'2MASXi J1303413-003310',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000076,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,195.922,-0.55281,0,NULL,43110084837,673595075,10524923,17.4),(104460,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104460,36.97,0.46,248,44113,70,NULL,NULL,'2MASX J13034129+0219033',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00007,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,195.922125,2.31756,0,NULL,58107039881,907922498,14186289,17.5),(104461,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104461,36.26,0.33,178,44114,70,NULL,NULL,'CGCG 043-123',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.000183,NULL,'15.4',1,NULL,NULL,NULL,NULL,NULL,1,195.9224583,7.51569,0.044,NULL,58962953929,921296155,14395252,15.4),(104462,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104462,37.17,0.11,272,44115,70,NULL,NULL,'2MASX J13034157+1920060',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00008,NULL,'17.2V',NULL,NULL,NULL,NULL,NULL,NULL,1,195.923125,19.33503,0.078,NULL,59033256963,922394640,14412416,17.2),(104463,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104463,36.95,0.27,245,44116,70,NULL,NULL,'2MASX J13034271+0859540',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,195.9279583,8.99844,0.02,NULL,58971179771,921424683,14397260,17.4),(104464,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104464,38.41,0.46,480,44117,70,NULL,NULL,'2MASX J13034287-0140204',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000081,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,195.9287083,-1.67247,0.005,NULL,43146458643,674163416,10533803,18.1),(104465,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104465,36.01,0.61,159,44118,70,NULL,NULL,'2MASX J13034340-2814288',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'16.4b',0.3,'S0',NULL,NULL,NULL,NULL,1,195.9307917,-28.24139,0.345,NULL,43337927167,677155111,10580548,16.4),(104466,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104466,38.3,0.46,457,44119,70,NULL,NULL,'SDSS J130343.54+512817.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,195.931417,51.4715,0,NULL,57196458997,893694671,13963979,18.5),(104467,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104467,37.21,0.55,277,44120,70,NULL,NULL,'2MASX J13034381-1648122',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,195.9325,-16.80333,0.069,NULL,44021157835,687830591,10747352,16.5),(104468,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104468,37.58,0.33,329,44121,70,NULL,NULL,'2MASX J13034435+0606503',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00018,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,195.934917,6.11383,0.037,NULL,58075058186,907422784,14178481,17.7),(104469,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104469,35.31,0.05,115,44122,70,NULL,NULL,'NGC 4943',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.00008,NULL,'15.1g',0.5,'SAB0           AGN','Group member',NULL,NULL,NULL,1,195.93725,28.08422,0.038,NULL,58705101728,917267214,14332300,15.1),(104470,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104470,37.7,0.46,346,44123,70,NULL,NULL,'2MASX J13034600+0032143',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000078,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,195.941625,0.53725,0,NULL,58087957536,907624336,14181630,17.9),(104471,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104471,37.17,0.11,272,44124,70,NULL,NULL,'2MASX J13034609+1920450',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000087,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,195.942167,19.34572,0.078,NULL,59033257899,922394654,14412416,17.5),(104472,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104472,37.17,0.11,272,44125,70,NULL,NULL,'SDSS J130346.31+191446.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,195.943,19.24636,0.077,NULL,59033260539,922394695,14412417,18.1),(104473,'IRAS','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104473,33.75,0.8,56.1,44126,75,NULL,'MAT, I','MCG -01-33-076',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000023,NULL,'14.16',0.5,'Sc?',NULL,NULL,NULL,NULL,1,195.943625,-5.13347,0.041,NULL,43141998488,674093726,10532714,14.16),(104474,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104474,33.64,0.2,53.5,44126,74.4,NULL,NULL,'MCG -01-33-076',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104475,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104475,33.78,0.4,57.1,44126,NULL,NULL,'mean','MCG -01-33-076',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104476,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104476,33.79,0.49,57.3,44126,75,NULL,'IR','MCG -01-33-076',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104477,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104477,33.8,0.32,57.5,44126,85,NULL,'I, raw','MCG -01-33-076',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104478,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104478,33.8,0.46,57.6,44126,NULL,NULL,'J','MCG -01-33-076',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104479,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104479,33.81,0.43,57.7,44126,75,NULL,'MAT, I, raw','MCG -01-33-076',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104480,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104480,33.82,0.47,58,44126,NULL,NULL,'H','MCG -01-33-076',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104481,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104481,33.85,0.32,58.8,44126,85,NULL,'I, inv','MCG -01-33-076',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104482,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104482,33.95,0.45,61.7,44126,NULL,NULL,'K','MCG -01-33-076',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104483,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104483,33.96,0.41,62,44126,NULL,NULL,'Malmquist cor.','MCG -01-33-076',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104484,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104484,34.02,0.43,63.7,44126,75,NULL,'MAT, I, cor','MCG -01-33-076',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104485,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104485,34.04,0.39,64.1,44126,NULL,NULL,NULL,'MCG -01-33-076',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104486,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104486,34.03,0.43,64.1,44126,75,NULL,'MAT, I, inv','MCG -01-33-076',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104487,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104487,37.17,0.11,272,44127,70,NULL,NULL,'IC 4130',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000083,NULL,'14.3V',0.34,'cD',NULL,NULL,NULL,NULL,1,195.944125,19.27153,0.077,NULL,59033264087,922394751,14412417,14.3),(104488,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104488,36.51,0.71,201,44128,70,NULL,NULL,'2MASX J13034670-1918332',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.19',0.4,NULL,NULL,NULL,NULL,NULL,1,195.944625,-19.30931,0.217,NULL,43978597763,687165590,10736962,16.19),(104489,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104489,37.22,0.46,278,44129,70,NULL,NULL,'2MASX J13034673+2647119',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.4g',0.17,NULL,'Group member',NULL,NULL,NULL,1,195.944708333,26.78656,0,NULL,58699704805,917182887,14330982,17.4),(104490,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104490,36.18,0.46,172,44130,70,NULL,NULL,'2MASX J13034679+4158110',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00017,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,195.945083,41.96986,0,NULL,59080290907,923129545,14423899,16.5),(104491,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104491,36.41,0.55,192,44131,70,NULL,NULL,'2MASX J13034682-1647477',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.54',NULL,NULL,NULL,NULL,NULL,NULL,1,195.9452083,-16.79675,0.069,NULL,44021157282,687830582,10747352,16.54),(104492,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104492,37.92,0.21,384,44132,70,NULL,NULL,'LCRS B130112.4-031650',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000078,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,195.946791667,-3.549,0,NULL,43147609402,674181396,10534084,17.8),(104493,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104493,37.91,0.46,381,44133,70,NULL,NULL,'2MASX J13034771+4351430',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,195.9487917,43.86203,0,NULL,59107131096,923548923,14430451,17.3),(104494,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104494,37.27,0.46,284,44134,70,NULL,NULL,'LCRS B130113.0-031440',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00008,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,195.94925,-3.51283,0,NULL,43147622852,674181607,10534087,16.7),(104495,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104495,36.26,0.63,179,44135,70,NULL,NULL,'2MASX J13034877-1946163',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.5,NULL,NULL,NULL,NULL,NULL,1,195.9532917,-19.77119,0.233,NULL,43988061322,687313458,10739272,13.9),(104496,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104496,37.17,0.11,272,44136,70,NULL,NULL,'2MASX J13034962+1914233',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000073,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,195.95675,19.23964,0.077,NULL,59033313806,922395528,14412430,17.4),(104497,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104497,36.53,0.46,202,44137,70,NULL,NULL,'2MASX J13034961+5328190',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000188,NULL,'16.5g',0.28,'AGN',NULL,NULL,NULL,NULL,1,195.956875,53.47208,0.02,NULL,57413785685,897090401,14017037,16.5),(104498,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104498,38.38,0.46,473,44138,70,NULL,NULL,'SDSS J130349.73-015613.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00008,NULL,'18.3g',0.17,'NLAGN',NULL,NULL,NULL,'Sy 2',1,195.95725,-1.93697,0.005,NULL,43146796528,674168695,10533885,18.3),(104499,'SNIa','2016-12-15 15:15:09','2016-12-16 11:20:21','1','SN 1973F',NULL,104499,34.6,0.36,81,44139,NULL,NULL,NULL,'NGC 4944',NULL,'1992ApJ...390L..45P',1992,1,1.7,NULL,'G',0.000025,NULL,'13.5g',0.6,'SA0','in a radial-velocity based grouping',NULL,NULL,NULL,1,195.958125,28.18572,0.038,NULL,58705087309,917266989,14332296,13.5),(104500,'SNIa','2016-12-15 15:15:09','2016-12-16 11:20:21','1','SN 1973F',NULL,104500,35,0.3,100,44139,NULL,NULL,'Photographic','NGC 4944',NULL,'1982ApJ...254....1A',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104501,'SNIa','2016-12-15 15:15:09','2016-12-16 11:20:21','1','SN 1973F',NULL,104501,35.05,0.2,102,44139,NULL,NULL,NULL,'NGC 4944',NULL,'1990ApJ...350..110C',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104502,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104502,35.31,0.05,115,44139,70,NULL,NULL,'NGC 4944',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104503,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104503,34.81,0.23,91.6,44140,74.4,NULL,NULL,'IC 4133',NULL,'2013AJ....146...86T',2013,1,0.38,NULL,'G',0.000025,NULL,'15.37',0.36,'E','Group member',NULL,NULL,NULL,1,195.961667,27.98839,0.054,NULL,58705290471,917270163,14332346,15.37),(104504,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104504,35.31,0.05,115,44140,70,NULL,NULL,'IC 4133',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104505,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104505,37.92,0.21,384,44141,70,NULL,NULL,'LCRS B130116.2-031052',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000073,NULL,'18.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,195.962667,-3.44969,0,NULL,43147613140,674181455,10534085,18.4),(104506,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104506,36.13,0.7,168,44142,70,NULL,NULL,'2MASX J13035160-1542068',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.82',0.2,NULL,NULL,NULL,NULL,NULL,1,195.9647917,-15.70211,0.013,NULL,44019613005,687806453,10746975,16.82),(104507,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104507,38.06,0.33,410,44143,70,NULL,NULL,'SDSS J130351.93+025534.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000065,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,195.966416667,2.92617,0.04,NULL,58112706928,908011045,14187672,18.3),(104508,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104508,38.52,0.46,506,44144,70,NULL,NULL,'SDSS J130352.09+291118.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,195.967083,29.18844,0.026,NULL,58707139381,917299052,14332797,17.6),(104509,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104509,33.42,NULL,48.4,44145,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08166',NULL,'2010Ap&SS.325..163P',2010,1,1.12,NULL,'G',0.000005,NULL,'16.5g',0.17,'Scd','Isolated galaxy',NULL,NULL,NULL,1,195.968666667,10.97217,0,NULL,58965393464,921334272,14395848,16.5),(104510,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104510,33.43,NULL,48.5,44145,NULL,NULL,'Dipole + Quadrupole','UGC 08166',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104511,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104511,33.43,NULL,48.6,44145,NULL,NULL,'Dipole','UGC 08166',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104512,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104512,33.51,0.47,50.3,44145,NULL,NULL,'Malmquist cor.','UGC 08166',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104513,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104513,33.59,NULL,52.3,44145,NULL,NULL,NULL,'UGC 08166',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104514,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104514,33.6,0.2,52.5,44145,74.4,NULL,NULL,'UGC 08166',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104515,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104515,33.7,0.43,54.8,44145,75,NULL,'3.6 micron, color corrected','UGC 08166',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104516,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104516,33.75,0.43,56.3,44145,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08166',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104517,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104517,33.76,0.42,56.5,44145,NULL,NULL,NULL,'UGC 08166',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104518,'IRAS','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104518,33.14,0.8,42.4,44146,75,NULL,'HMCL, I','ESO 323- G 072',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'16.04',0.3,'S',NULL,NULL,NULL,NULL,1,195.970625,-41.83861,0.481,NULL,46753605386,730525084,11414454,16.04),(104519,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104519,32.36,0.4,29.6,44146,75,NULL,'HMCL, I, inv','ESO 323- G 072',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104520,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104520,32.37,0.49,29.8,44146,75,NULL,'IR','ESO 323- G 072',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104521,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104521,32.4,0.4,30.1,44146,75,NULL,'HMCL, I, raw','ESO 323- G 072',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104522,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104522,32.75,0.4,35.5,44146,75,NULL,'HMCL, I, cor','ESO 323- G 072',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104523,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104523,33.39,0.13,47.7,44146,NULL,NULL,NULL,'ESO 323- G 072',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104524,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104524,37.61,0.46,332,44147,70,NULL,NULL,'SDSS J130353.18+390333.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000178,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,195.971625,39.05922,0,NULL,59292808669,926450135,14475783,18),(104525,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104525,37.36,0.46,297,44148,70,NULL,NULL,'2MASX J13035321+1744581',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,195.971833,17.74939,0.09,NULL,59040134842,922502106,14414095,17.2),(104526,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104526,37.65,0.46,339,44149,70,NULL,NULL,'2MASX J13035593+2203383',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,195.983083333,22.06075,0.117,NULL,58805617932,918837780,14356840,17.4),(104527,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104527,37.77,0.46,358,44150,70,NULL,NULL,'2MASX J13035616+5430537',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000141,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,195.98375,54.51492,0,NULL,57425808565,897278258,14019972,17.6),(104528,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104528,36.18,0.55,172,44151,70,NULL,NULL,'2MASX J13035618-1919343',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.05',0.4,NULL,NULL,NULL,NULL,NULL,1,195.9842083,-19.32625,0.217,NULL,43978603536,687165680,10736963,16.05),(104529,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104529,36.44,0.46,194,44152,70,NULL,NULL,'2MASX J13035641+0742556',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.22',0.17,NULL,NULL,NULL,NULL,NULL,1,195.9849583,7.71542,0.037,NULL,58962935303,921295864,14395247,18.22),(104530,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104530,36.74,0.46,223,44153,70,NULL,NULL,'2MASX J13035716+1050356',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,195.988083,10.84317,0,NULL,58965047784,921328871,14395763,17.1),(104531,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104531,38.66,0.46,539,44154,70,NULL,NULL,'SDSS J130357.43-025714.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000073,NULL,'18.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,195.989333333,-2.954,0.013,NULL,43147229984,674175468,10533991,18.4),(104532,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104532,38.31,0.46,458,44155,70,NULL,NULL,'SDSS J130357.92+033052.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000088,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,195.991333333,3.51447,0.066,NULL,58113082613,908016915,14187764,18),(104533,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104533,36.93,0.46,244,44156,70,NULL,NULL,'IC 4152',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000203,NULL,'15.6g',0.5,NULL,NULL,NULL,NULL,NULL,1,195.993583,38.19861,0,NULL,59293212295,926456442,14475881,15.6),(104534,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104534,37.65,0.46,339,44157,70,NULL,NULL,'2MASX J13035853+1619572',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.36',0.16,NULL,NULL,NULL,NULL,NULL,1,195.993917,16.33264,0.013,NULL,59055164266,922736941,14417764,18.36),(104535,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104535,38.69,0.46,548,44158,70,NULL,NULL,'SDSS J130358.73-004502.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000094,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,195.994708333,-0.75069,0,NULL,43109671520,673588617,10524822,18),(104536,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104536,37.09,0.46,261,44159,70,NULL,NULL,'2MASX J13040005+5536457',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000184,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,196.0002083,55.61267,0.013,NULL,57422286942,897223233,14019113,16.6),(104537,'D-Sigma','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104537,32.39,0.4,30.1,44160,75,NULL,'Edat, raw','ESO 443- G 043',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000027,NULL,'13.99',1.1,'S0?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,196.002583,-30.36903,0.337,NULL,43330045485,677031960,10578624,13.99),(104538,'D-Sigma','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104538,32.53,0.4,32,44160,75,NULL,'Edat, cor','ESO 443- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104539,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104539,33.69,0.4,54.6,44160,NULL,NULL,'mean','ESO 443- G 043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104540,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104540,33.83,0.45,58.3,44160,NULL,NULL,'K','ESO 443- G 043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104541,'IRAS','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104541,34.19,0.8,69,44161,75,NULL,'MAT, I','ESO 323- G 073',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.21',0.7,'SA(s)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,196.006958333,-38.19917,0.333,NULL,46927539893,733242810,11456918,14.21),(104542,'IRAS','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104542,34.22,0.8,69.9,44161,75,NULL,'HMCL, I','ESO 323- G 073',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104543,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104543,34.17,0.43,68.1,44161,75,NULL,'MAT, I, raw','ESO 323- G 073',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104544,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104544,34.17,0.4,68.3,44161,75,NULL,'HMCL, I, raw','ESO 323- G 073',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104545,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104545,34.19,0.32,68.9,44161,85,NULL,'I, raw','ESO 323- G 073',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104546,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104546,34.24,0.32,70.5,44161,85,NULL,'I, inv','ESO 323- G 073',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104547,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104547,34.26,0.4,71.1,44161,75,NULL,'HMCL, I, cor','ESO 323- G 073',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104548,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104548,34.26,0.4,71.1,44161,NULL,NULL,'mean','ESO 323- G 073',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104549,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104549,34.28,0.43,71.7,44161,75,NULL,'MAT, I, cor','ESO 323- G 073',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104550,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104550,34.33,0.4,73.4,44161,75,NULL,'HMCL, I, inv','ESO 323- G 073',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104551,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104551,34.38,0.43,75.2,44161,75,NULL,'MAT, I, inv','ESO 323- G 073',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104552,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104552,34.52,0.47,80.2,44161,NULL,NULL,'H','ESO 323- G 073',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104553,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104553,37.92,0.21,384,44162,70,NULL,NULL,'LCRS B130127.6-030417',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000099,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,196.0097917,-3.33958,0,NULL,43147812079,674184563,10534133,16.5),(104554,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104554,38.06,0.33,410,44163,70,NULL,NULL,'2MASX J13040340+0258218',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.23',0.16,NULL,NULL,NULL,NULL,NULL,1,196.014083333,2.97256,0.04,NULL,58112715349,908011177,14187674,18.23),(104555,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104555,37.42,0.46,305,44164,70,NULL,NULL,'2MASX J13040353+6213202',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,196.014375,62.22217,0.013,NULL,57356108688,896189198,14002956,17.8),(104556,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104556,37.17,0.11,272,44165,70,NULL,NULL,'IC 4139',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000093,NULL,'16.82',0.2,NULL,NULL,NULL,NULL,NULL,1,196.017291667,19.29497,0.073,NULL,59033269775,922394840,14412419,16.82),(104557,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104557,36.36,0.46,187,44166,70,NULL,NULL,'2MASX J13040435+4902061',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000174,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,196.018083,49.03489,0,NULL,59105315256,923520550,14430008,16.4),(104558,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104558,36.08,0.33,165,44167,70,NULL,NULL,'CGCG 043-127',NULL,'2015arXiv151105856S',2015,1,0.6,'The position in 1996AJ....112..388L is incorrect.','G',0.00018,NULL,'15.2',0.4,'E','Group member',NULL,NULL,NULL,1,196.020833,7.90789,0.037,NULL,58963410131,921303283,14395363,15.2),(104559,'Tully est','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104559,32.72,0.8,35,44168,75,NULL,NULL,'NGC 4930',NULL,'1988NBGC.C....0000T',1988,1,4.5,NULL,'G',0.00001,NULL,'12.0',3.7,'SB(rs)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,196.0219583,-41.41158,0.409,NULL,46753398807,730521856,11414404,12),(104560,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104560,30.58,0.36,13.1,44168,NULL,NULL,NULL,'NGC 4930',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104561,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104561,38.11,0.33,418,44169,70,NULL,NULL,'SDSS J130405.81+073315.9',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,196.02425,7.55444,0.044,NULL,58962964283,921296316,14395254,18.5),(104562,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104562,36.59,0.33,208,44170,70,NULL,NULL,'IC 4140',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,196.025167,20.09636,0.135,NULL,59036476612,922444947,14413202,17.3),(104563,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104563,37.46,0.33,310,44171,70,NULL,NULL,'2MASX J13040607+0245238',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000076,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,196.025375,2.75678,0.04,NULL,58105231099,907894235,14185847,17.1),(104564,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104564,37.17,0.11,272,44172,70,NULL,NULL,'2MASX J13040727+1917254',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000097,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,196.030375,19.2905,0.073,NULL,59033267235,922394800,14412418,17.3),(104565,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104565,37.09,0.33,262,44173,70,NULL,NULL,'2MASX J13040791+6009022',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000181,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,196.033167,60.15056,0.005,NULL,57386155257,896658675,14010291,17.5),(104566,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104566,36.49,0.46,198,44174,70,NULL,NULL,'SDSS J130408.23+440823.7',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000101,NULL,'16.8g',0.2,'Sbrst',NULL,NULL,NULL,NULL,1,196.034333333,44.13994,0,NULL,59107114856,923548669,14430447,16.8),(104567,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104567,37.88,0.46,376,44175,70,NULL,NULL,'2MASX J13040856+1044566',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,196.035667,10.74886,0,NULL,58965094905,921329607,14395775,17.6),(104568,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104568,38.31,0.46,459,44176,70,NULL,NULL,'SDSS J130408.93+141511.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,196.03725,14.25314,0.051,NULL,59050464015,922663500,14416617,18.3),(104569,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104569,37.33,0.46,292,44177,70,NULL,NULL,'2MASX J13040986+5522286',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,196.0407917,55.37453,0.013,NULL,57422769018,897230765,14019230,16.9),(104570,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104570,38.14,0.46,424,44178,70,NULL,NULL,'2MASX J13040981+5118181',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00015,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,196.041083333,51.30489,0,NULL,57196054311,893688348,13963880,17.1),(104571,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104571,35.31,0.05,115,44179,70,NULL,NULL,'CGCG 160-125',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.00007,NULL,'15.1g',0.6,'S0','Group member',NULL,NULL,NULL,1,196.0422917,28.24794,0.038,NULL,58705199828,917268747,14332324,15.1),(104572,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104572,38.61,0.46,527,44180,70,NULL,NULL,'2MASX J13041067+4953011',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000184,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,196.044375,49.88361,0,NULL,59090848421,923294506,14426476,17.2),(104573,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104573,37.17,0.11,272,44181,70,NULL,NULL,'IC 4148',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000083,NULL,'17.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,196.0445417,19.25917,0.073,NULL,59033266546,922394789,14412418,17.1),(104574,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104574,37.39,0.46,301,44182,70,NULL,NULL,'2MASX J13041085+5528396',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000208,NULL,'15.9g',0.44,'BrClG',NULL,NULL,NULL,NULL,1,196.045,55.47753,0.013,NULL,57422980448,897234069,14019282,15.9),(104575,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104575,37.43,0.46,306,44183,70,NULL,NULL,'2MASX J13041108+3321133',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000158,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,196.046291667,33.35381,0,NULL,58674029504,916781711,14324714,17.1),(104576,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104576,37.92,0.21,384,44184,70,NULL,NULL,'LCRS B130137.4-031102',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000078,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,196.0507083,-3.45219,0,NULL,43147834163,674184908,10534139,17),(104577,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104577,37.05,0.46,257,44185,70,NULL,NULL,'2MASX J13041274+0548188',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000173,NULL,'17.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,196.053167,5.80522,0.017,NULL,58075090226,907423284,14178488,17.6),(104578,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104578,38,0.46,399,44186,70,NULL,NULL,'SDSS J130413.07+114817.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000141,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,196.0545,11.805,0.031,NULL,58995461262,921804082,14403188,18.2),(104579,'Sosies','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104579,31.63,0.37,21.2,44187,NULL,NULL,NULL,'NGC 4941',NULL,'2002A&A...393...57T',2002,1,3.6,NULL,'G',0.000017,NULL,'12.43',1.9,'(R)SAB(r)ab:   Sy2','Group member, radial-velocity confirmed',NULL,NULL,'Sy 2',1,196.05475,-5.55161,0.013,NULL,43138985788,674046652,10531978,12.43),(104580,'Tully est','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104580,29.03,0.8,6.4,44187,75,NULL,'B','NGC 4941',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104581,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104581,29.05,0.69,6.45,44187,100,NULL,'mid-IR','NGC 4941',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104582,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104582,31.47,0.4,19.7,44187,NULL,NULL,'mean','NGC 4941',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104583,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104583,31.63,0.4,21.2,44187,NULL,NULL,NULL,'NGC 4941',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104584,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104584,31.69,0.45,21.8,44187,NULL,NULL,'K','NGC 4941',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104585,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104585,31.71,0.46,22,44187,NULL,NULL,'J','NGC 4941',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104586,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104586,38.11,0.33,418,44188,70,NULL,NULL,'2MASX J13041316+0734536',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.85',0.2,NULL,NULL,NULL,NULL,NULL,1,196.054917,7.58169,0.044,NULL,58962890754,921295168,14395237,17.85),(104587,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104587,36.97,0.46,248,44189,70,NULL,NULL,'2MASX J13041333+2809112',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'18.15',0.19,NULL,'Group member',NULL,NULL,NULL,1,196.055583,28.15319,0.038,NULL,58705278303,917269973,14332343,18.15),(104588,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104588,37.1,0.46,263,44190,70,NULL,NULL,'2MASX J13041336+0114078',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000117,NULL,'15.6g',0.47,NULL,NULL,NULL,NULL,NULL,1,196.055791667,1.23567,0.005,NULL,58104418395,907881537,14185649,15.6),(104589,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104589,37.65,0.46,340,44191,70,NULL,NULL,'SDSS J130413.42+325510.5',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000177,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,196.0559583,32.91961,0.027,NULL,58673296248,916770253,14324535,17),(104590,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104590,36.95,0.27,245,44192,70,NULL,NULL,'2MASX J13041424+0858436',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000202,NULL,'15.9g',0.39,NULL,NULL,NULL,NULL,NULL,1,196.059291667,8.97881,0.037,NULL,58971153572,921424274,14397254,15.9),(104591,'IRAS','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104591,33.25,0.8,44.8,44193,75,NULL,'A82, H','NGC 4939',NULL,'1997ApJS..109..333W',1997,1,5.5,NULL,'G',0.000013,NULL,'11.9',2.8,'SA(s)bc        Sy2','Group member',NULL,NULL,'Sy 2',1,196.059958333,-10.33961,0.113,NULL,43853862054,685216594,10706509,11.9),(104592,'Sosies','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104592,32.89,0.13,37.8,44193,NULL,NULL,NULL,'NGC 4939',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104593,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104593,32.02,0.4,25.3,44193,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 4939',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104594,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104594,32.18,0.69,27.3,44193,100,NULL,'mid-IR','NGC 4939',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104595,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104595,32.7,0.35,34.7,44193,NULL,NULL,NULL,'NGC 4939',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104596,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104596,32.78,0.46,36,44193,NULL,NULL,'J','NGC 4939',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104597,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104597,32.82,0.47,36.7,44193,NULL,NULL,'H','NGC 4939',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104598,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104598,32.83,0.47,36.8,44193,75,NULL,'A82, H, raw','NGC 4939',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104599,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104599,32.87,0.3,37.4,44193,55,NULL,'B','NGC 4939',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104600,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104600,32.87,0.45,37.5,44193,NULL,NULL,'K','NGC 4939',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104601,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104601,33.05,0.47,40.8,44193,75,NULL,'A82, H, inv','NGC 4939',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104602,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104602,33.1,0.47,41.6,44193,75,NULL,'A82, H, cor','NGC 4939',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104603,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104603,33.1,0.43,41.6,44193,75,NULL,'3.6 micron, color corrected','NGC 4939',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104604,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104604,33.1,0.2,41.7,44193,74.4,NULL,NULL,'NGC 4939',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104605,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104605,33.17,0.51,43,44193,NULL,NULL,'Malmquist cor.','NGC 4939',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104606,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104606,33.21,0.5,43.8,44193,NULL,NULL,NULL,'NGC 4939',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104607,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104607,33.21,0.43,43.8,44193,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4939',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104608,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104608,33.23,0.4,44.3,44193,75,NULL,'B','NGC 4939',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104609,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104609,33.24,0.4,44.4,44193,NULL,NULL,'mean','NGC 4939',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104610,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104610,36.08,0.33,165,44194,70,NULL,NULL,'CGCG 043-128',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000173,NULL,'15.5',0.21,'E','Group member',NULL,NULL,NULL,1,196.060167,7.90383,0.037,NULL,58963407167,921303236,14395363,15.5),(104611,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104611,36.04,0.46,162,44195,70,NULL,NULL,'CGCG 189-016',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000087,NULL,'15.2g',0.61,NULL,NULL,NULL,NULL,NULL,1,196.063375,35.4155,0.011,NULL,59157320335,924333130,14442705,15.2),(104612,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104612,37.81,0.46,364,44196,70,NULL,NULL,'2MASX J13041630+1329202',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000164,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,196.067833333,13.48897,0.023,NULL,58994631004,921791109,14402986,17.8),(104613,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104613,36.18,0.46,172,44197,70,NULL,NULL,'2MASX J13041680+6638587',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000078,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,196.0697917,66.64958,0.033,NULL,57907464036,904804125,14137564,16.7),(104614,'D-Sigma','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104614,32.39,0.4,30.1,44198,75,NULL,'Edat, raw','NGC 4936',NULL,'1997ApJS..109..333W',1997,1,2.7,NULL,'G',0.000027,NULL,'11.77',2.3,'E0       poss. LINER','in a pair',NULL,NULL,NULL,1,196.070375,-30.52625,0.337,NULL,43329971614,677030806,10578606,11.77),(104615,'D-Sigma','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104615,32.53,0.4,32,44198,75,NULL,'Edat, cor','NGC 4936',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104616,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104616,31.52,0.63,20.1,44198,95,NULL,'Michard 1979b, c','NGC 4936',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104617,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104617,31.79,0.37,22.8,44198,95,NULL,'Weighted Mean','NGC 4936',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104618,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104618,32.05,0.46,25.7,44198,95,NULL,'Michard 1979a','NGC 4936',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104619,'Faber-Jackson','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104619,33.81,0.81,57.8,44198,55,NULL,'Visvanathan & Sandage 1979','NGC 4936',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104620,'Tertiary','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104620,32.46,0.5,31,44198,95,NULL,NULL,'NGC 4936',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104621,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104621,36.73,0.46,222,44199,70,NULL,NULL,'2MASX J13041714+1252367',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000162,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,196.0715,12.87694,0.029,NULL,58997052117,921828939,14403577,16.6),(104622,'FP','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,'R',104622,38.57,0.33,518,44200,70,NULL,NULL,'SDSS J130417.39+401838.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000167,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,196.0724583,40.31083,0,NULL,59078999717,923109370,14423583,18.6),(104623,'Tully est','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104623,32.27,0.8,28.5,44201,75,NULL,NULL,'NGC 4942',NULL,'1988NBGC.C....0000T',1988,1,1.9,'The IC identification is not certain.','G',0.000007,NULL,'13.79',1.3,'SAB(s)d:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,196.079625,-7.64944,0.117,NULL,43851011927,685172061,10705813,13.79),(104624,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104624,31.3,0.4,18.2,44201,NULL,NULL,NULL,'NGC 4942',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104625,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104625,32.34,0.4,29.4,44201,NULL,NULL,'mean','NGC 4942',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104626,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104626,32.68,0.47,34.4,44201,NULL,NULL,'H','NGC 4942',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104627,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104627,32.73,0.45,35.1,44201,NULL,NULL,'K','NGC 4942',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104628,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104628,32.74,0.46,35.4,44201,NULL,NULL,'J','NGC 4942',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104629,'IRAS','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104629,32.42,0.8,30.5,44202,75,NULL,'MAT, I','NGC 4947A',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000017,NULL,'15.01',0.7,'SB(s)m:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,196.0867917,-35.22778,0.133,NULL,46859730681,732183291,11440363,15.01),(104630,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104630,32.01,0.32,25.2,44202,85,NULL,'I, inv','NGC 4947A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104631,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104631,32.03,0.32,25.5,44202,85,NULL,'I, raw','NGC 4947A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104632,'Tully-Fisher','2016-12-15 15:15:09','2016-12-16 11:20:21','1',NULL,NULL,104632,32.52,0.43,31.9,44202,75,NULL,'MAT, I, inv','NGC 4947A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104633,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104633,32.55,0.43,32.4,44202,75,NULL,'MAT, I, raw','NGC 4947A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104634,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104634,32.58,0.4,32.8,44202,NULL,NULL,NULL,'NGC 4947A',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104635,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104635,32.86,0.14,37.4,44202,NULL,NULL,NULL,'NGC 4947A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104636,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104636,32.91,0.43,38.3,44202,75,NULL,'MAT, I, cor','NGC 4947A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104637,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104637,37.05,0.46,257,44203,70,NULL,NULL,'2MASX J13042086+0944521',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000188,NULL,'16.1g',0.38,NULL,NULL,NULL,NULL,NULL,1,196.0870417,9.74772,0,NULL,58971547706,921430432,14397350,16.1),(104638,'BL Lac Luminosity','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104638,39.34,NULL,738,44204,NULL,NULL,'Min. z = 0.19','SUMSS J130420-435308',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'QSO',NULL,NULL,'15.7V',NULL,'blazar',NULL,NULL,NULL,NULL,1,196.0872083,-43.88575,0.389,NULL,46759084559,730610696,11415792,15.7),(104639,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104639,38.02,0.46,403,44205,70,NULL,NULL,'SDSS J130420.89+083232.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'18.1g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,196.087083,8.54231,0.035,NULL,58962489495,921288898,14395139,18.1),(104640,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104640,36.48,0.46,198,44206,70,NULL,NULL,'2MASX J13042096+0109038',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000069,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,196.087417,1.151,0,NULL,58104427196,907881674,14185651,16.9),(104641,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104641,37.81,0.46,366,44207,70,NULL,NULL,'2MASX J13042111+4039068',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000176,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,196.088,40.65206,0,NULL,59079791089,923121735,14423777,17),(104642,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104642,37.63,0.33,335,44208,70,NULL,NULL,'SDSS J130421.62+222645.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.88',0.19,NULL,NULL,NULL,NULL,NULL,1,196.090083,22.44594,0.099,NULL,58805479991,918835624,14356806,18.88),(104643,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104643,35.61,0.32,132,44209,NULL,NULL,NULL,'ESO 443- G 049',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.13',0.4,'S?',NULL,NULL,NULL,NULL,1,196.0914583,-32.35464,0.333,NULL,43332718299,677073723,10579276,15.13),(104644,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104644,35.61,0.32,133,44209,NULL,NULL,'Malmquist cor.','ESO 443- G 049',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104645,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104645,35.65,0.2,135,44209,74.4,NULL,NULL,'ESO 443- G 049',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104646,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104646,35.8,0.4,145,44209,NULL,NULL,'mean','ESO 443- G 049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104647,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104647,35.86,0.47,149,44209,NULL,NULL,'H','ESO 443- G 049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104648,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104648,37.19,0.46,275,44210,70,NULL,NULL,'2MASX J13042278+6015483',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000169,NULL,'16.7g',0.36,NULL,NULL,NULL,NULL,NULL,1,196.0947083,60.2635,0.005,NULL,57386223983,896659749,14010308,16.7),(104649,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104649,35.14,0.72,107,44211,70,NULL,NULL,'2MASX J13042293-5139222',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,196.095708333,-51.65614,1.129,NULL,44595676815,696807450,10887616,17.1),(104650,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104650,37.88,0.27,376,44212,70,NULL,NULL,'SDSS J130423.35+292300.3',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,196.097333,29.38342,0.028,NULL,58706921405,917295646,14332744,17.1),(104651,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104651,38.57,0.33,518,44213,70,NULL,NULL,'2MASX J13042399+4019088',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,196.1,40.31925,0,NULL,59078996753,923109324,14423583,17.8),(104652,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104652,35.61,0.46,132,44214,70,NULL,NULL,'CGCG 270-045',NULL,'2015arXiv151105856S',2015,1,0.9,'MCG implies the R.A. is 12h02.3m; corrected in MCG errata.','G',0.000087,NULL,'14.6g',0.69,'E0',NULL,NULL,NULL,NULL,1,196.100041667,55.36817,0.013,NULL,57422763211,897230675,14019229,14.6),(104653,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104653,36.84,0.46,233,44215,70,NULL,NULL,'2MASX J13042431+2052216',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,196.101208333,20.87267,0.115,NULL,59035888676,922435760,14413058,17.6),(104654,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104654,37.95,0.33,389,44216,70,NULL,NULL,'2MASX J13042519+5108040',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,196.10525,51.13467,0,NULL,57196024954,893687889,13963873,18.1),(104655,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104655,33.63,0.43,53.2,44217,75,NULL,'3.6 micron, color + selection bias corrected','KUG 1302+275',NULL,'2014MNRAS.444..527S',2014,1,0.9,NULL,'G',0.000013,NULL,'15.14',0.6,'Sc             HII','Group member',NULL,NULL,NULL,1,196.110625,27.30431,0.022,NULL,58698177314,917159020,14330609,15.14),(104656,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104656,33.73,0.43,55.8,44217,75,NULL,'3.6 micron, color corrected','KUG 1302+275',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104657,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104657,33.81,0.2,57.8,44217,74.4,NULL,NULL,'KUG 1302+275',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104658,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104658,35.08,0.09,104,44217,NULL,NULL,NULL,'KUG 1302+275',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104659,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104659,37.75,0.33,355,44218,70,NULL,NULL,'2MASX J13042660+1007361',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000181,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,196.110875,10.12678,0,NULL,58971452294,921428942,14397327,17.4),(104660,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104660,36.84,0.46,233,44219,70,NULL,NULL,'2MASX J13042663+1331578',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.19',0.2,NULL,NULL,NULL,NULL,NULL,1,196.111125,13.53275,0.025,NULL,58994660989,921791577,14402993,17.19),(104661,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104661,36.15,0.16,170,44220,70,NULL,NULL,'2MASX J13042724+4337240',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000181,NULL,'15.9g',0.38,'S0/a',NULL,NULL,NULL,NULL,1,196.113333,43.62347,0,NULL,59106300685,923535948,14430249,15.9),(104662,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104662,37.23,0.46,279,44221,70,NULL,NULL,'2MASX J13042741+4847369',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00017,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,196.114167,48.79353,0,NULL,59105342663,923520979,14430015,17.4),(104663,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104663,38.58,0.46,520,44222,70,NULL,NULL,'2MASX J13042791+1137351',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000186,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,196.11625,11.62658,0.031,NULL,58965343446,921333491,14395835,17.8),(104664,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104664,37.8,0.33,362,44223,70,NULL,NULL,'LCRS B130154.0-025116',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000074,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,196.1195,-3.12244,0.013,NULL,43147750787,674183606,10534118,17.7),(104665,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104665,38.26,0.46,450,44224,70,NULL,NULL,'2MASX J13042935+1907186',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,196.1222083,19.12175,0.074,NULL,59033299815,922395309,14412426,17.6),(104666,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104666,35.59,0.49,131,44225,70,NULL,NULL,'ESO 269- G 039',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00011,NULL,'15.21',0.4,'S0',NULL,NULL,NULL,NULL,1,196.1252917,-44.98767,0.349,NULL,46729254202,730144596,11408509,15.21),(104667,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104667,35.08,0.49,104,44226,70,NULL,NULL,'ESO 443- G 052',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000133,NULL,'15.07',0.4,'S0?',NULL,NULL,NULL,NULL,1,196.12575,-32.25142,0.333,NULL,43332904938,677076639,10579322,15.07),(104668,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104668,32.37,NULL,29.8,44227,72,NULL,NULL,'HIPASS J1304-02',NULL,'2014Ap.....57..457K',2014,1,NULL,NULL,'G',0.000023,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,196.129167,-2.89444,0.013,NULL,43147255940,674175874,10533998,NULL),(104669,'Tully est','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104669,31.99,0.8,25,44228,75,NULL,NULL,'UGCA 322',NULL,'1988NBGC.C....0000T',1988,1,3.5,NULL,'G',0.000005,NULL,'12.9B',2.6,'SAB(s)dm','Isolated galaxy',NULL,NULL,NULL,1,196.13,-3.57242,0.009,NULL,43147698130,674182783,10534105,12.9),(104670,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104670,30.65,0.4,13.5,44228,NULL,NULL,NULL,'UGCA 322',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104671,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104671,33.89,0.48,59.9,44229,70,NULL,NULL,'ESO 443- G 053',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000077,NULL,'13.83',0.9,'E?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,196.131208333,-30.17064,0.381,NULL,43329610444,677025163,10578518,13.83),(104672,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104672,38.06,0.33,408,44230,70,NULL,NULL,'2MASX J13043161+1848256',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,196.13175,18.80706,0.074,NULL,59033462549,922397852,14412466,17.7),(104673,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104673,32.3,NULL,28.8,44231,72,NULL,NULL,'LCRS B130157.2-024313',NULL,'2014Ap.....57..457K',2014,1,0.65,NULL,'G',0.000114,NULL,'16.2g',0.42,NULL,NULL,NULL,NULL,NULL,1,196.132667,-2.988,0.013,NULL,43147252877,674175826,10533997,16.2),(104674,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104674,36.02,0.46,160,44232,70,NULL,NULL,'CGCG 071-105',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000103,NULL,'15.6',0.24,NULL,NULL,NULL,NULL,NULL,1,196.1327083,8.535,0.035,NULL,58962487794,921288871,14395138,15.6),(104675,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104675,37.8,0.33,362,44233,70,NULL,NULL,'LCRS B130157.4-024504',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000111,NULL,'16.2g',0.42,NULL,NULL,NULL,NULL,NULL,1,196.1335,-3.01911,0.013,NULL,43147252022,674175812,10533997,16.2),(104676,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104676,36.95,0.46,246,44234,70,NULL,NULL,'2MASX J13043234+3855406',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000172,NULL,'17.74',0.21,NULL,NULL,NULL,NULL,NULL,1,196.134667,38.92811,0,NULL,59293018257,926453410,14475834,17.74),(104677,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104677,38.06,0.33,408,44235,70,NULL,NULL,'2MASX J13043246+1845436',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,196.135166667,18.76211,0.074,NULL,59033352395,922396131,14412439,17.9),(104678,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104678,37.34,0.67,294,44236,70,NULL,NULL,'2MASX J13043295-1957338',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.16',NULL,NULL,NULL,NULL,NULL,NULL,1,196.137375,-19.95958,0.233,NULL,43980029391,687187959,10737311,16.16),(104679,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104679,37.63,0.33,335,44237,70,NULL,NULL,'2MASX J13043308+2228066',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.83',0.16,NULL,NULL,NULL,NULL,NULL,1,196.13775,22.46853,0.075,NULL,58805510532,918836102,14356814,17.83),(104680,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104680,37.28,0.46,286,44238,70,NULL,NULL,'2MASX J13043395+3951586',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000172,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,196.141541667,39.86625,0,NULL,59300157485,926564960,14477577,17),(104681,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104681,37.62,0.46,333,44239,70,NULL,NULL,'2MASX J13043424+1135211',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000183,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,196.142625,11.58933,0.031,NULL,58965340649,921333447,14395835,16.7),(104682,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104682,37.17,0.11,272,44240,70,NULL,NULL,'2MASX J13043451+1933176',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,196.1437917,19.55489,NULL,NULL,59031996571,922374946,14412108,NULL),(104683,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104683,37.24,0.46,281,44241,70,NULL,NULL,'2MASX J13043465+1108001',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,196.144375,11.13331,0,NULL,58965421249,921334707,14395854,17.4),(104684,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104684,37.89,0.46,379,44242,70,NULL,NULL,'2MASX J13043474+0853151',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.54',0.16,NULL,NULL,NULL,NULL,NULL,1,196.1447917,8.88758,0.037,NULL,58968300356,921379693,14396557,18.54),(104685,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104685,37.73,0.46,352,44243,70,NULL,NULL,'SDSS J130435.17+665831.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000064,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,196.146583,66.97542,0.033,NULL,57907344364,904802255,14137535,17.8),(104686,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104686,37.17,0.11,272,44244,70,NULL,NULL,'2MASX J13043563+1928096',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00008,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,196.148625,19.46933,0.073,NULL,59031970381,922374537,14412102,17.2),(104687,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104687,37.91,0.46,382,44245,70,NULL,NULL,'2MASX J13043648+6144272',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000159,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,196.152,61.74106,0.009,NULL,57354620637,896165947,14002592,17.3),(104688,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104688,38.46,0.46,492,44246,70,NULL,NULL,'2MASX J13043662+5549488',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,196.1525,55.83028,0.009,NULL,57422342798,897224106,14019126,17.5),(104689,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104689,36.97,0.33,247,44247,70,NULL,NULL,'2MASX J13043702+1519539',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,196.154416667,15.33156,0.016,NULL,59052432278,922694254,14417097,17.1),(104690,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104690,36.64,0.46,213,44248,70,NULL,NULL,'2MASX J13043804+0617211',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.67',0.18,NULL,NULL,NULL,NULL,NULL,1,196.158625,6.28936,0.054,NULL,58075365925,907427592,14178556,17.67),(104691,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104691,35.06,0.54,103,44249,70,NULL,NULL,'2MASX J13043856-1718204',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.12',NULL,NULL,NULL,NULL,NULL,NULL,1,196.160625,-17.30561,0.129,NULL,44020398203,687818721,10747167,16.12),(104692,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104692,36.97,0.33,247,44250,70,NULL,NULL,'2MASX J13043909+1521169',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000154,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,196.162875,15.35478,0.016,NULL,59052429860,922694216,14417097,16.9),(104693,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104693,37.25,0.46,282,44251,70,NULL,NULL,'2MASX J13043920+0604140',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000177,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,196.163291667,6.0705,0.029,NULL,58075219602,907425306,14178520,16.6),(104694,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104694,37.42,0.46,305,44252,70,NULL,NULL,'2MASX J13043927+1809196',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.59',0.14,NULL,NULL,NULL,NULL,NULL,1,196.1637083,18.15561,0.078,NULL,59032820015,922387812,14412309,18.59),(104695,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104695,36.53,0.6,202,44253,70,NULL,NULL,'2MASX J13043962-2211428',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.48',0.2,NULL,NULL,NULL,NULL,NULL,1,196.1650417,-22.19544,0.269,NULL,43791400645,684240635,10691259,16.48),(104696,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104696,36.37,0.33,188,44254,70,NULL,NULL,'2MASX J13043970+0341380',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000016,NULL,'16.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,196.1655,3.69383,0.04,NULL,58112534588,908008352,14187630,16.8),(104697,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104697,38.45,0.46,489,44255,70,NULL,NULL,'2MASX J13044036-0126514',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000086,NULL,'17.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,196.16825,-1.44769,0.005,NULL,43146413933,674162717,10533792,17.3),(104698,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104698,37.15,0.46,269,44256,70,NULL,NULL,'2MASX J13044101+5849189',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000179,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,196.171333,58.82178,0,NULL,57439808897,897497014,14023390,16.6),(104699,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104699,37.93,0.27,386,44257,70,NULL,NULL,'2MASX J13044118+1120211',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,196.171667,11.33911,0,NULL,58965274199,921332409,14395818,17.3),(104700,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104700,36.28,0.53,180,44258,70,NULL,NULL,'2MASX J13044172-1629304',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.57',0.5,NULL,NULL,NULL,NULL,NULL,1,196.1739583,-16.49189,0.077,NULL,44020936317,687827129,10747298,16.57),(104701,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104701,36.95,0.27,245,44259,70,NULL,NULL,'2MASX J13044364+0900001',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00017,NULL,'16.0g',0.34,NULL,NULL,NULL,NULL,NULL,1,196.181833,8.99994,0.037,NULL,58968463505,921382242,14396597,16),(104702,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104702,37.18,0.46,273,44260,70,NULL,NULL,'2MASX J13044364+1424479',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000104,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,196.181917,14.41325,0.051,NULL,59050501892,922664092,14416626,17.5),(104703,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104703,37.4,0.46,303,44261,70,NULL,NULL,'2MASX J13044366+0952161',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,196.181958333,9.87108,0,NULL,58971422890,921428482,14397320,17),(104704,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104704,36.15,0.16,170,44262,70,NULL,NULL,'B3 1302+432',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000174,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,196.189583,42.93844,0,NULL,59077733758,923089589,14423274,16.3),(104705,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104705,38.15,0.33,426,44263,70,NULL,NULL,'2MASX J13044555+3140210',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000135,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,196.189916667,31.67247,0.067,NULL,58686053167,916969580,14327649,18.2),(104706,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104706,37.99,0.46,396,44264,70,NULL,NULL,'2MASX J13044636+0905394',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,196.193167,9.09436,0.024,NULL,58968466641,921382291,14396598,17.7),(104707,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104707,37.46,0.46,310,44265,70,NULL,NULL,'2MASX J13044646+1043591',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000176,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,196.1935417,10.73297,0,NULL,58964944510,921327257,14395738,16.7),(104708,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104708,37.51,0.46,318,44266,70,NULL,NULL,'2MASX J13044718+2117235',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,196.1965,21.28986,0.065,NULL,58805209986,918831406,14356740,18),(104709,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104709,37.55,0.46,324,44267,70,NULL,NULL,'2MASX J13044754+0143130',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000081,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,196.1979583,1.72019,0.018,NULL,58107657941,907932155,14186439,17.3),(104710,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104710,36.62,0.46,211,44268,70,NULL,NULL,'2MASX J13044854+4006016',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00018,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,196.202416667,40.10061,0,NULL,59300268454,926566694,14477604,16.2),(104711,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104711,37.04,0.46,256,44269,70,NULL,NULL,'2MASX J13044909+0729474',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.21',0.16,NULL,NULL,NULL,NULL,NULL,1,196.2045417,7.49647,0.04,NULL,58962949728,921296089,14395251,18.21),(104712,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104712,36.15,0.16,170,44270,70,NULL,NULL,'2MASX J13044915+4333220',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,196.204667,43.55614,0,NULL,59106325047,923536328,14430255,17),(104713,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104713,38.01,0.46,401,44271,70,NULL,NULL,'2MASX J13044917+1816205',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,196.204875,18.27228,0.078,NULL,59033682829,922401294,14412520,17.7),(104714,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104714,38.15,0.33,426,44272,70,NULL,NULL,'2MASX J13044970+3139480',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000154,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,196.207041667,31.6635,0.067,NULL,58686053479,916969585,14327649,17.3),(104715,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104715,35,0.77,100,44273,70,NULL,NULL,'MC 1302-170',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'16.39',0.6,NULL,NULL,NULL,NULL,NULL,1,196.2077083,-17.29897,0.129,NULL,44020391931,687818623,10747165,16.39),(104716,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104716,36.37,0.33,188,44274,70,NULL,NULL,'CGCG 043-137N',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000179,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,196.2154583,3.83911,0.04,NULL,58110638440,907978725,14187167,16.4),(104717,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104717,38.02,0.46,402,44275,70,NULL,NULL,'2MASX J13045295+5135070',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00018,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,196.2205417,51.58533,0,NULL,57195959378,893686865,13963857,17),(104718,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104718,37.51,0.46,318,44276,70,NULL,NULL,'2MASX J13045297+1031014',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00018,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,196.2207917,10.51717,0,NULL,58964865468,921326022,14395719,16.9),(104719,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104719,36.63,0.2,212,44277,74.4,NULL,NULL,'CGCG 071-106',NULL,'2013AJ....146...86T',2013,1,0.81,NULL,'G',0.000015,NULL,'15.4g',0.44,'Sc',NULL,NULL,NULL,NULL,1,196.221,13.23689,0.027,NULL,58996655413,921822740,14403480,15.4),(104720,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104720,37.83,0.27,367,44278,70,NULL,NULL,'2MASX J13045318+1206186',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,196.22175,12.10522,0.034,NULL,58996328580,921817634,14403400,18),(104721,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104721,36.15,0.16,170,44279,70,NULL,NULL,'2MASX J13045325+4321490',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000185,NULL,'16.1g',0.33,'S0^-',NULL,NULL,NULL,NULL,1,196.2220417,43.36381,0,NULL,59076849239,923075769,14423058,16.1),(104722,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104722,37.21,0.46,277,44280,70,NULL,NULL,'SDSS J130453.66+080321.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,196.223583,8.05589,0.035,NULL,58962573348,921290208,14395159,18.2),(104723,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104723,36.39,0.5,189,44281,70,NULL,NULL,'2MASX J13045370-3417073',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000103,NULL,'16.6b',0.5,'E',NULL,NULL,NULL,NULL,1,196.223875,-34.28531,0.185,NULL,46859518144,732179971,11440312,16.6),(104724,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104724,37.44,0.46,308,44282,70,NULL,NULL,'SDSS J130454.02+114820.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,196.225125,11.80569,0.031,NULL,58995300692,921801573,14403149,18.2),(104725,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104725,37.69,0.46,345,44283,70,NULL,NULL,'2MASX J13045450-0219009',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000122,NULL,'16.4g',0.36,'NLAGN',NULL,NULL,NULL,'Sy 2',1,196.227125,-2.31703,0.013,NULL,43145374521,674146476,10533538,16.4),(104726,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104726,38.11,0.46,418,44284,70,NULL,NULL,'SDSS J130454.51+362210.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00014,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,196.227166667,36.36964,0.044,NULL,59291508314,926429817,14475465,18.6),(104727,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104727,38.68,0.46,546,44285,70,NULL,NULL,'2MASX J13045473+4002306',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,196.228083,40.04181,0,NULL,59300269603,926566712,14477604,17.9),(104728,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104728,37.17,0.11,272,44286,70,NULL,NULL,'2MASX J13045500+1919276',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00007,NULL,'18.39',0.14,NULL,NULL,NULL,NULL,NULL,1,196.229125,19.32439,0.073,NULL,59033844290,922403817,14412559,18.39),(104729,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104729,35.38,0.48,119,44287,70,NULL,NULL,'2MASX J13045590-3206113',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000123,NULL,'15.4b',0.6,'SB',NULL,NULL,NULL,NULL,1,196.2329583,-32.10317,0.333,NULL,43332765373,677074458,10579288,15.4),(104730,'SNIa','2016-12-15 15:15:10','2016-12-16 11:20:21','1','SN 1994U',NULL,104730,31.72,0.1,22,44288,65,NULL,'Snapshot','NGC 4948',0.003746,'1998ApJ...504..935R',1998,1,2,'The IC identification is not certain; HOLM 505B is a double star.','G',0.000021,NULL,'13.97',0.7,'SB(s)dm: sp','in a pair',NULL,NULL,NULL,1,196.233167,-7.94769,0.113,NULL,43851270274,685176098,10705876,13.97),(104731,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104731,29.88,0.43,9.5,44288,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4948',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104732,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104732,30.1,0.43,10.5,44288,75,NULL,'3.6 micron, color corrected','NGC 4948',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104733,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104733,30.88,0.4,15,44288,NULL,NULL,NULL,'NGC 4948',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104734,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104734,36.9,0.46,240,44289,70,NULL,NULL,'2MASX J13045614+1155326',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000146,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,196.2337917,11.92586,0.031,NULL,58995304023,921801625,14403150,16.7),(104735,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104735,37.95,0.33,389,44290,70,NULL,NULL,'2MASXi J1304564+510805',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000141,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,196.2352917,51.13511,0,NULL,57196077974,893688718,13963886,18.1),(104736,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104736,37.32,0.46,291,44291,70,NULL,NULL,'2MASX J13045649+2101556',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,196.2354583,21.03219,0.101,NULL,58818837605,919044337,14360067,16.5),(104737,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104737,35.48,0.46,125,44292,70,NULL,NULL,'CGCG 100-029',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00017,NULL,'15.3',0.5,NULL,NULL,NULL,NULL,NULL,1,196.237125,17.56897,0.084,NULL,59040322055,922505032,14414141,15.3),(104738,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104738,36.15,0.16,170,44293,70,NULL,NULL,'2MASX J13045722+4330422',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000171,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,196.238375,43.51167,0,NULL,59106323169,923536299,14430254,16.5),(104739,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104739,35.56,0.46,129,44294,70,NULL,NULL,'IC 0845',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000157,NULL,'14.9g',0.57,'E0',NULL,NULL,NULL,NULL,1,196.23925,12.07906,0.031,NULL,58996340047,921817813,14403403,14.9),(104740,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104740,37.93,0.27,386,44295,70,NULL,NULL,'2MASX J13045802+1132194',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000191,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,196.24175,11.53886,0.013,NULL,58965344403,921333506,14395836,16.5),(104741,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104741,38.02,0.33,402,44296,70,NULL,NULL,'LCRS B130223.5-030312',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00008,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,196.242875,-3.32122,0.009,NULL,43147790394,674184224,10534128,17.2),(104742,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104742,34.86,0.25,93.8,44297,74.4,NULL,NULL,'NGC 4952',NULL,'2013AJ....146...86T',2013,1,1.34,NULL,'G',0.000039,NULL,'13.6g',0.87,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,196.24325,29.12225,0.032,NULL,58707069589,917297962,14332780,13.6),(104743,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104743,34.98,0.46,99,44297,70,NULL,NULL,'NGC 4952',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104744,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104744,34.78,0.4,90.3,44297,NULL,NULL,'mean','NGC 4952',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104745,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104745,35.23,0.45,111,44297,NULL,NULL,'K','NGC 4952',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104746,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104746,37.72,0.33,350,44298,70,NULL,NULL,'2MASX J13045891+5749309',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00019,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,196.2455,57.82525,0,NULL,57444505141,897570392,14024537,17.2),(104747,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104747,37.93,0.27,386,44299,70,NULL,NULL,'2MASX J13050040+1125364',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000176,NULL,'17.3g',0.23,'BrClG',NULL,NULL,NULL,NULL,1,196.251708333,11.42681,0,NULL,58965322331,921333161,14395830,17.3),(104748,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104748,37.43,0.46,306,44300,70,NULL,NULL,'2MASX J13050083+0125068',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000078,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,196.2535417,1.41844,0.018,NULL,58104479879,907882498,14185664,16.8),(104749,'TRGB','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104749,28.77,0.1,5.68,44301,NULL,NULL,NULL,'HIPASS J1305-40',NULL,'2012A&A...540A..49M',2012,1,1,NULL,'G',0.000013,NULL,'16.33',0.55,'dwarf Irr',NULL,NULL,NULL,NULL,1,196.25875,-40.08278,0.369,NULL,46932265686,733316651,11458072,16.33),(104750,'TRGB','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104750,28.81,NULL,5.78,44301,NULL,NULL,NULL,'HIPASS J1305-40',NULL,'2007AJ....133..504K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104751,'TRGB','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104751,28.87,0.1,5.94,44301,74.4,NULL,NULL,'HIPASS J1305-40',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104752,'TRGB','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104752,29.02,0.14,6.37,44301,NULL,NULL,'I','HIPASS J1305-40',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104753,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104753,37.65,0.46,339,44302,70,NULL,NULL,'2MASX J13050220+2813544',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'18.33',0.3,NULL,'Group member',NULL,NULL,NULL,1,196.2592083,28.23175,0.035,NULL,58705187299,917268551,14332321,18.33),(104754,'SNIa','2016-12-15 15:15:10','2016-12-16 11:20:21','1','SN 2006cg',NULL,104754,34.17,0.19,66.4,44303,74.2,NULL,'SALT 2','2MASX J13050256+2844204',0.028063,'2010ApJ...716..712A',2010,1,0.52,NULL,'G',0.000097,NULL,'16.1g',0.27,'S0','Group member',NULL,NULL,NULL,1,196.260583,28.739,0.031,NULL,58707667553,917307305,14332926,16.1),(104755,'SNIa','2016-12-15 15:15:10','2016-12-16 11:20:21','1','SN 2006cg',NULL,104755,34.8,0.09,91.2,44303,74.4,NULL,NULL,'2MASX J13050256+2844204',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104756,'SNIa','2016-12-15 15:15:10','2016-12-16 11:20:21','1','SN 2006cg',NULL,104756,35.11,0.19,102,44303,65,NULL,'MLCS17','2MASX J13050256+2844204',0.028063,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104757,'SNIa','2016-12-15 15:15:10','2016-12-16 11:20:21','1','SN 2006cg',NULL,104757,35.17,0.26,105,44303,65,NULL,'SALT2','2MASX J13050256+2844204',0.028063,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104758,'SNIa','2016-12-15 15:15:10','2016-12-16 11:20:21','1','SN 2006cg',NULL,104758,35.18,0.21,106,44303,65,NULL,'MLCS31','2MASX J13050256+2844204',0.028063,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104759,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104759,35.26,0.25,113,44304,74.4,NULL,NULL,'CGCG 270-047',NULL,'2013AJ....146...86T',2013,1,0.7,'MCG implies the R.A. is 12h02.8m; corrected in MCG errata.','G',0.00007,NULL,'14.8g',0.66,'SB','Group member',NULL,NULL,NULL,1,196.26175,53.65386,0.033,NULL,57425366461,897271350,14019864,14.8),(104760,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104760,35.47,0.19,124,44304,70,NULL,NULL,'CGCG 270-047',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104761,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104761,36.14,0.53,169,44305,70,NULL,NULL,'2MASX J13050305-1112487',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,196.262833,-11.21356,0.109,NULL,43845546490,685086663,10704479,16.1),(104762,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104762,36.15,0.16,170,44306,70,NULL,NULL,'MCG +07-27-027',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000171,NULL,'16.0g',0.32,'E0',NULL,NULL,NULL,NULL,1,196.266583,43.57919,0,NULL,59106327615,923536368,14430255,16),(104763,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104763,33.67,0.55,54.2,44307,70,NULL,NULL,'ESO 269- G 043',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000133,NULL,'14.88',0.7,'S0',NULL,NULL,NULL,NULL,1,196.269167,-46.79022,0.637,NULL,46731917341,730186208,11409159,14.88),(104764,'IRAS','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104764,32.66,0.8,34,44308,75,NULL,'MAT, I','ESO 575- G 053',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000017,NULL,'14.57',0.4,'Sb? sp',NULL,NULL,NULL,NULL,1,196.270541667,-22.38394,0.269,NULL,43791160993,684236890,10691201,14.57),(104765,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104765,32.41,0.43,30.3,44308,75,NULL,'3.6 micron, color + selection bias corrected','ESO 575- G 053',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104766,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104766,32.42,0.4,30.5,44308,NULL,NULL,NULL,'ESO 575- G 053',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104767,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104767,32.51,0.32,31.7,44308,85,NULL,'I, inv','ESO 575- G 053',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104768,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104768,32.51,0.32,31.8,44308,85,NULL,'I, raw','ESO 575- G 053',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104769,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104769,32.55,0.43,32.3,44308,75,NULL,'3.6 micron, color corrected','ESO 575- G 053',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104770,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104770,32.63,0.2,33.6,44308,74.4,NULL,NULL,'ESO 575- G 053',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104771,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104771,32.82,0.43,36.7,44308,75,NULL,'MAT, I, raw','ESO 575- G 053',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104772,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104772,32.88,0.43,37.6,44308,75,NULL,'MAT, I, inv','ESO 575- G 053',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104773,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104773,33.05,0.43,40.8,44308,75,NULL,'MAT, I, cor','ESO 575- G 053',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104774,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104774,33.17,0.4,43,44308,NULL,NULL,'mean','ESO 575- G 053',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104775,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104775,33.31,0.1,46,44308,NULL,NULL,NULL,'ESO 575- G 053',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104776,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104776,33.43,0.47,48.5,44308,NULL,NULL,'H','ESO 575- G 053',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104777,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104777,38.39,0.46,477,44309,70,NULL,NULL,'SDSS J130505.38+672512.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000074,NULL,'18.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,196.2724583,67.42025,0.029,NULL,57910026102,904844157,14138189,18.3),(104778,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104778,30.97,0.4,15.6,44310,NULL,NULL,NULL,'NGC 4948A',NULL,'2013MNRAS.429.2677K',2013,1,1.5,'HOLM 506B is a star.','G',0.000024,NULL,'14.47',1.2,'SB(s)dm','in a pair',NULL,NULL,NULL,1,196.274125,-8.16133,0.085,NULL,43850651234,685166425,10705725,14.47),(104779,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104779,32.09,0.4,26.2,44310,75,NULL,'B','NGC 4948A',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104780,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104780,37.72,0.33,350,44311,70,NULL,NULL,'2MASX J13050579+5747578',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,196.274417,57.79931,0,NULL,57444504973,897570390,14024537,16.9),(104781,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104781,37.09,0.46,262,44312,70,NULL,NULL,'2MASX J13050602+1917416',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,196.274958333,19.29494,0.073,NULL,59033832994,922403640,14412556,16.9),(104782,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104782,37.52,0.33,318,44313,70,NULL,NULL,'2MASX J13050728+2748433',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.95',0.23,NULL,'Group member',NULL,NULL,NULL,1,196.280417,27.81206,0.041,NULL,58705144514,917267883,14332310,17.95),(104783,'IRAS','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104783,31.03,0.8,16.1,44314,75,NULL,'A82, H','NGC 4951',NULL,'1997ApJS..109..333W',1997,1,3.3,'The APM position is west of the nucleus.','G',0.000013,NULL,'12.57',1.2,'SAB(rs)cd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,196.282083,-6.49383,0.057,NULL,43122254662,673785229,10527894,12.57),(104784,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104784,29.93,0.4,9.7,44314,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 4951',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104785,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104785,30.61,0.47,13.3,44314,75,NULL,'A82, H, inv','NGC 4951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104786,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104786,30.63,0.47,13.4,44314,75,NULL,'A82, H, raw','NGC 4951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104787,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104787,30.82,0.4,15.1,44314,NULL,NULL,NULL,'NGC 4951',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104788,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104788,30.98,0.47,15.7,44314,75,NULL,'A82, H, cor','NGC 4951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104789,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104789,31.28,0.46,18.1,44314,NULL,NULL,'J','NGC 4951',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104790,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104790,31.3,0.47,18.2,44314,NULL,NULL,'H','NGC 4951',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104791,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104791,31.35,0.45,18.6,44314,NULL,NULL,'K','NGC 4951',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104792,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104792,31.58,0.4,20.7,44314,NULL,NULL,'mean','NGC 4951',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104793,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104793,31.73,0.4,22.2,44314,75,NULL,'B','NGC 4951',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104794,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104794,37.87,0.33,376,44315,70,NULL,NULL,'2MASX J13050791-0223419',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000083,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,196.283083333,-2.39486,0.013,NULL,43145520739,674148761,10533574,17.4),(104795,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104795,37.25,0.46,282,44316,70,NULL,NULL,'2MASX J13050855+3625325',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,196.285458333,36.42572,0.044,NULL,59291521049,926430016,14475469,17.4),(104796,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104796,36.41,0.46,191,44317,70,NULL,NULL,'2MASX J13050975+1539286',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,196.2904583,15.65786,0.013,NULL,59055553873,922743029,14417859,17),(104797,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104797,37.17,0.11,272,44318,70,NULL,NULL,'2MASX J13050998+1917426',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.23',0.15,NULL,NULL,NULL,NULL,NULL,1,196.2917917,19.29517,0.073,NULL,59033821921,922403467,14412554,18.23),(104798,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104798,35.71,0.46,139,44319,70,NULL,NULL,'IC 4168',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000162,NULL,'15.2g',0.54,NULL,NULL,NULL,NULL,NULL,1,196.294625,40.04969,0,NULL,59300267216,926566675,14477604,15.2),(104799,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104799,37.87,0.33,376,44320,70,NULL,NULL,'2MASX J13051085-0221419',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000097,NULL,'16.9g',0.28,'NLAGN',NULL,NULL,NULL,NULL,1,196.295125,-2.36156,0.013,NULL,43145519452,674148741,10533574,16.9),(104800,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104800,36.77,0.46,226,44321,70,NULL,NULL,'2MASX J13051155+6102350',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00017,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,196.29825,61.04297,0.009,NULL,57384659357,896635302,14009926,16.8),(104801,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104801,37.59,0.33,330,44322,70,NULL,NULL,'IC 4169 NED01',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000156,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,196.3000417,38.77069,0,NULL,59292990963,926452983,14475827,18.7),(104802,'D-Sigma','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104802,34.86,0.4,93.8,44323,75,NULL,'Edat, raw','NGC 4957',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.00005,NULL,'14.01',1,'E3             HII','in a pair',NULL,NULL,NULL,1,196.301625,27.56975,0.032,NULL,58705117282,917267457,14332304,14.01),(104803,'D-Sigma','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104803,34.89,0.4,95,44323,75,NULL,'Edat, cor','NGC 4957',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104804,'Faber-Jackson','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104804,34.39,0.55,75.5,44323,95,NULL,'Weighted Mean','NGC 4957',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104805,'Faber-Jackson','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104805,34.39,0.55,75.5,44323,95,NULL,'de Vaucouleurs','NGC 4957',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104806,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104806,34.89,0.25,95.1,44323,74.4,NULL,NULL,'NGC 4957',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104807,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104807,35.48,0.27,125,44323,70,NULL,NULL,'NGC 4957',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104808,'Tertiary','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104808,34.15,0.35,67.6,44323,95,NULL,NULL,'NGC 4957',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104809,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104809,35.1,0.4,105,44323,NULL,NULL,'mean','NGC 4957',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104810,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104810,35.3,0.45,115,44323,NULL,NULL,'K','NGC 4957',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104811,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104811,37.59,0.33,330,44324,70,NULL,NULL,'IC 4169 NED02',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000191,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,196.302166667,38.77356,0,NULL,59292990952,926452983,14475827,16.2),(104812,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104812,36.55,0.76,204,44325,70,NULL,NULL,'2MASX J13051305-1121307',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.42',0.2,NULL,NULL,NULL,NULL,NULL,1,196.3045,-11.35875,0.109,NULL,43845526778,685086355,10704474,16.42),(104813,'Tully est','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104813,31.61,0.8,21,44326,75,NULL,NULL,'DDO 163',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000037,NULL,'16',0.9,'IB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,196.309667,-7.88928,0.113,NULL,43851385024,685177891,10705904,16),(104814,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104814,31.87,0.4,23.7,44326,NULL,NULL,NULL,'DDO 163',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104815,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104815,36.29,0.46,181,44327,70,NULL,NULL,'2MASX J13051521+0512568',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00016,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,196.313458333,5.21572,0,NULL,58108225610,907941025,14186578,16.4),(104816,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104816,36.66,0.71,215,44328,70,NULL,NULL,'2MASX J13051611-1726463',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.00015,NULL,'15.9b',0.5,'Scd? sp',NULL,NULL,NULL,NULL,1,196.317167,-17.44628,0.129,NULL,44008916323,687639317,10744364,15.9),(104817,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104817,37.14,0.46,267,44329,70,NULL,NULL,'2MASX J13051641+6440430',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000078,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,196.31825,64.67864,0.033,NULL,57352712518,896136133,14002127,16.6),(104818,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104818,38.2,0.46,436,44330,70,NULL,NULL,'2MASX J13051647+2132546',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,196.3185417,21.54839,0.133,NULL,58819012695,919047073,14360110,18.2),(104819,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104819,35.17,0.33,108,44331,70,NULL,NULL,'MCG +10-19-018',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000158,NULL,'15.6g',0.38,'S0',NULL,NULL,NULL,NULL,1,196.3194583,58.90431,0,NULL,57439774669,897496479,14023382,15.6),(104820,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104820,37.25,0.46,282,44332,70,NULL,NULL,'2MASX J13051668+3312474',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,196.3195,33.21314,0.008,NULL,58673996931,916781202,14324706,17.2),(104821,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104821,37.93,0.23,385,44333,70,NULL,NULL,'2MASX J13051875+5410356',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000223,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,196.328083333,54.17642,0.019,NULL,57426160492,897283757,14020058,17.3),(104822,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104822,38.17,0.46,430,44334,70,NULL,NULL,'2MASX J13051880+1830075',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,196.328291667,18.50203,0.072,NULL,59033757779,922402465,14412538,17.5),(104823,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104823,38.43,0.46,486,44335,70,NULL,NULL,'2MASX J13051876+0402128',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,196.328375,4.03692,0.013,NULL,58110676000,907979312,14187176,17.4),(104824,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104824,37.19,0.83,274,44336,70,NULL,NULL,'2MASX J13051962-3740295',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00007,NULL,'18.8R',NULL,'E/S0',NULL,NULL,NULL,NULL,1,196.331667,-37.67489,0.209,NULL,46927635370,733244302,11456942,18.8),(104825,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104825,37.17,0.11,272,44337,70,NULL,NULL,'2MASX J13052000+1911365',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000093,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,196.333375,19.19347,0.066,NULL,59034019460,922406554,14412602,16.7),(104826,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104826,37.75,0.46,354,44338,70,NULL,NULL,'2MASX J13052002+3951385',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,196.333417,39.86061,0,NULL,59300159842,926564997,14477578,17.9),(104827,'Ring Diameter','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104827,33.1,0.76,41,44339,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4947',NULL,'1981ApJS...45..541P',1981,1,2.4,NULL,'G',0.000024,NULL,'12.62',1.3,'SA(r)bc        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,196.334167,-35.33742,0.133,NULL,46859714290,732183035,11440359,12.62),(104828,'Ring Diameter','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104828,33.2,0.6,43,44339,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4947',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104829,'IRAS','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104829,32.24,0.8,28,44339,75,NULL,'MAT, I','NGC 4947',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104830,'Sosies','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104830,31.79,0.39,22.8,44339,NULL,NULL,NULL,'NGC 4947',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104831,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104831,32.22,0.4,27.8,44339,NULL,NULL,NULL,'NGC 4947',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104832,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104832,32.26,0.32,28.3,44339,85,NULL,'I, raw','NGC 4947',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104833,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104833,32.31,0.32,29,44339,85,NULL,'I, inv','NGC 4947',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104834,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104834,32.41,0.43,30.3,44339,75,NULL,'MAT, I, raw','NGC 4947',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104835,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104835,32.61,0.4,33.3,44339,75,NULL,'B','NGC 4947',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104836,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104836,32.63,0.43,33.6,44339,75,NULL,'MAT, I, inv','NGC 4947',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104837,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104837,32.78,0.43,36,44339,75,NULL,'MAT, I, cor','NGC 4947',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104838,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104838,32.93,0.07,38.6,44339,NULL,NULL,NULL,'NGC 4947',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104839,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104839,35.5,0.46,126,44340,70,NULL,NULL,'IC 0846',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000334,NULL,'15.48',0.4,'S0',NULL,NULL,NULL,NULL,1,196.3379583,23.09556,0.051,NULL,58806885183,918857580,14357149,15.48),(104840,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104840,37.52,0.33,318,44341,70,NULL,NULL,'2MASX J13052129+2747063',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.86',0.18,NULL,'Group member',NULL,NULL,NULL,1,196.338666667,27.78503,0.041,NULL,58705143306,917267864,14332310,18.86),(104841,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104841,37.38,0.46,299,44342,70,NULL,NULL,'2MASX J13052160+3656205',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000176,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,196.3399583,36.93908,0,NULL,59294215576,926472118,14476126,16.6),(104842,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104842,37.7,0.21,346,44343,70,NULL,NULL,'2MASX J13052289+2200038',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,196.3452917,22.00103,0.145,NULL,58819461018,919054078,14360219,17.3),(104843,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104843,37.82,0.46,366,44344,70,NULL,NULL,'2MASX J13052439+0850393',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'16.4r',NULL,NULL,NULL,NULL,NULL,NULL,1,196.351667,8.84436,0.055,NULL,58968487778,921382621,14396603,16.4),(104844,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104844,36.15,0.16,170,44345,70,NULL,NULL,'2MASX J13052516+4327033',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000184,NULL,'15.7g',0.35,'E0',NULL,NULL,NULL,NULL,1,196.354875,43.45108,0,NULL,59106291350,923535802,14430246,15.7),(104845,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104845,35.31,0.05,115,44346,70,NULL,NULL,'CGCG 160-132',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.00008,NULL,'15.0g',0.35,'S0/a',NULL,NULL,NULL,NULL,1,196.35525,29.29647,0.046,NULL,58705947852,917280435,14332506,15),(104846,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104846,35.47,0.19,124,44347,70,NULL,NULL,'MRK 0239',NULL,'2001MNRAS.321..277C',2001,1,0.39,NULL,'G',0.000067,NULL,'15.1g',0.37,'S?','Group member',NULL,NULL,'Post Starburst (E+A) or (a+k) Galaxy',1,196.357583,53.59175,0.033,NULL,57413879211,897091862,14017060,15.1),(104847,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104847,37.75,0.33,355,44348,70,NULL,NULL,'2MASX J13052631+1009373',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000207,NULL,'16.1g',0.39,NULL,NULL,NULL,NULL,NULL,1,196.359583,10.1605,0,NULL,58966162213,921346284,14396035,16.1),(104848,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104848,37.83,0.27,367,44349,70,NULL,NULL,'2MASX J13052650+1209565',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,196.360458333,12.16586,0.03,NULL,58996535288,921820863,14403450,17.8),(104849,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104849,37.7,0.21,346,44350,70,NULL,NULL,'SDSS J130526.92+215700.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.98',0.12,NULL,NULL,NULL,NULL,NULL,1,196.362167,21.95017,0.145,NULL,58819449968,919053905,14360217,18.98),(104850,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104850,38.02,0.33,402,44351,70,NULL,NULL,'SDSS J130527.14-032222.2',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000083,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,196.363125,-3.37286,0.017,NULL,43146973536,674171461,10533929,17.8),(104851,'TRGB','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104851,27.63,0.06,3.36,44352,NULL,NULL,NULL,'NGC 4945',NULL,'2005ApJ...633..810M',2005,1,20,'A-M +30\' Dec error.','G',0.00001,NULL,'9.3',3.8,'SB(s)cd: sp    Sy2','Group member, radial-velocity confirmed',NULL,NULL,'Flat-Spectrum Radio Source',1,196.3645,-49.46822,0.793,NULL,46727225548,730112899,11408014,9.3),(104852,'TRGB','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104852,27.77,0.05,3.58,44352,NULL,NULL,NULL,'NGC 4945',NULL,'2016MNRAS.457.1419M',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104853,'TRGB','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104853,27.85,0.08,3.72,44352,74.4,NULL,NULL,'NGC 4945',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104854,'TRGB','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104854,27.85,0.11,3.72,44352,NULL,NULL,NULL,'NGC 4945',NULL,'2015ApJ...802L..25T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104855,'TRGB','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104855,27.9,NULL,3.8,44352,NULL,NULL,'I','NGC 4945',NULL,'2008ApJ...686L..75M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104856,'Tully est','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104856,28.6,0.8,5.2,44352,75,NULL,'B','NGC 4945',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104857,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104857,27.46,NULL,3.1,44352,NULL,NULL,'LEDA [April 2006]','NGC 4945',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104858,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104858,27.75,0.36,3.55,44352,NULL,NULL,NULL,'NGC 4945',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104859,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104859,27.85,0.08,3.72,44352,74.4,NULL,NULL,'NGC 4945',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104860,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104860,28.25,0.4,4.46,44352,75,NULL,NULL,'NGC 4945',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104861,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104861,28.27,0.4,4.5,44352,73,NULL,'IR','NGC 4945',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104862,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104862,29.24,0.49,7.04,44352,75,NULL,'IR','NGC 4945',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104863,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104863,37.55,0.46,324,44353,70,NULL,NULL,'2MASX J13052783+1538245',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000156,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,196.366,15.64008,0.013,NULL,59055542589,922742852,14417857,17.3),(104864,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104864,36.68,0.46,217,44354,70,NULL,NULL,'2MASX J13052854+4534543',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,196.368916667,45.58186,0,NULL,59101221066,923456579,14429009,16.8),(104865,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104865,37.93,0.23,385,44355,70,NULL,NULL,'2MASX J13052925+5400516',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,196.3717917,54.01447,0.043,NULL,57426134647,897283353,14020052,17.6),(104866,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104866,37.13,0.46,266,44356,70,NULL,NULL,'2MASX J13052926+3815325',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000174,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,196.371833333,38.25889,0,NULL,59293788162,926465440,14476022,16.8),(104867,'SBF','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104867,33.36,0.12,47,44357,74.4,NULL,NULL,'NGC 4946',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000067,NULL,'13.46',1.2,'E+?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,196.372417,-43.59114,0.409,NULL,46758209869,730597029,11415578,13.46),(104868,'SBF','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104868,33.39,0.17,47.6,44357,NULL,NULL,'I','NGC 4946',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104869,'SBF','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104869,33.39,0.17,47.6,44357,NULL,NULL,NULL,'NGC 4946',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104870,'SBF','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104870,33.43,0.17,48.4,44357,NULL,NULL,'Malmquist cor.','NGC 4946',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104871,'D-Sigma','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104871,32.84,0.4,36.9,44357,75,NULL,'Edat, raw','NGC 4946',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104872,'D-Sigma','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104872,33.02,0.4,40.2,44357,75,NULL,'Edat, cor','NGC 4946',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104873,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104873,33.36,0.12,47,44357,74.4,NULL,NULL,'NGC 4946',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104874,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104874,33.36,0.41,47,44357,NULL,NULL,NULL,'NGC 4946',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104875,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104875,33.52,0.41,50.6,44357,NULL,NULL,'Malmquist cor.','NGC 4946',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104876,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104876,33.34,0.45,46.6,44357,NULL,NULL,'K','NGC 4946',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104877,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104877,33.37,0.4,47.1,44357,NULL,NULL,'mean','NGC 4946',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104878,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104878,37.57,0.46,327,44358,70,NULL,NULL,'LCRS B130254.7-031048',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000074,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,196.373167,-3.44789,0.017,NULL,43146947705,674171057,10533922,17.3),(104879,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104879,37.72,0.46,350,44359,70,NULL,NULL,'2MASX J13052989+0722333',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.41',0.15,NULL,NULL,NULL,NULL,NULL,1,196.374625,7.37603,0.043,NULL,58962865300,921294770,14395230,18.41),(104880,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104880,37.55,0.27,324,44360,70,NULL,NULL,'2MASX J13053045+5511536',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000168,NULL,'16.1g',0.4,'E0',NULL,NULL,NULL,NULL,1,196.377,55.19814,0.013,NULL,57424704593,897261009,14019703,16.1),(104881,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104881,37.7,0.21,346,44361,70,NULL,NULL,'IC 4167',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.52',0.18,NULL,NULL,NULL,NULL,NULL,1,196.378125,21.91003,0.102,NULL,58819475854,919054310,14360223,17.52),(104882,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104882,36.15,0.16,170,44362,70,NULL,NULL,'2MASX J13053112+4325233',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000176,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,196.379583,43.42328,0,NULL,59076877777,923076215,14423065,16.3),(104883,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104883,37.93,0.23,385,44363,70,NULL,NULL,'2MASX J13053125+5354319',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.00019,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,196.380125,53.909,0.043,NULL,57425350509,897271101,14019860,16.3),(104884,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104884,35.26,0.25,113,44364,74.4,NULL,NULL,'NGC 4973',NULL,'2013AJ....146...86T',2013,1,0.79,NULL,'G',0.000063,NULL,'14.5g',0.73,'E/S0','Group member',NULL,NULL,NULL,1,196.3839583,53.68514,0.033,NULL,57425377642,897271525,14019867,14.5),(104885,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104885,35.47,0.19,124,44364,70,NULL,NULL,'NGC 4973',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104886,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104886,35.64,0.19,134,44364,70,NULL,NULL,'NGC 4973',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104887,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104887,37,0.15,251,44365,70,NULL,NULL,'2MASX J13053261+0930183',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000208,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,196.385916667,9.505,0.009,NULL,58968075850,921376185,14396502,16.4),(104888,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104888,37.71,0.46,348,44366,70,NULL,NULL,'2MASX J13053280+2730373',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,196.386833,27.51053,0.032,NULL,58704659816,917260309,14332192,17),(104889,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104889,36.69,0.46,218,44367,70,NULL,NULL,'2MASX J13053450+6710089',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00009,NULL,'16.6g',0.24,'NLAGN',NULL,NULL,NULL,'Sy 2',1,196.39375,67.169,0.029,NULL,57907120604,904798759,14137480,16.6),(104890,'IRAS','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104890,33.33,0.8,46.4,44368,75,NULL,'MAT, I','ESO 443- G 059',NULL,'1997ApJS..109..333W',1997,1,1.7,'ESO-LV gives v = 2294 +/- 10 km/sec.','G',0.000033,NULL,'14.48',0.4,'SA(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,196.3957083,-28.45917,0.317,NULL,43339669088,677182329,10580973,14.48),(104891,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104891,32.22,0.32,27.8,44368,85,NULL,'I, inv','ESO 443- G 059',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104892,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104892,32.23,0.32,27.9,44368,85,NULL,'I, raw','ESO 443- G 059',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104893,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104893,32.52,0.43,32,44368,75,NULL,'MAT, I, raw','ESO 443- G 059',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104894,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104894,32.55,0.43,32.4,44368,75,NULL,'MAT, I, inv','ESO 443- G 059',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104895,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104895,32.84,0.43,37,44368,75,NULL,'MAT, I, cor','ESO 443- G 059',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104896,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104896,33.54,0.13,51.2,44368,NULL,NULL,NULL,'ESO 443- G 059',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104897,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104897,37.64,0.33,337,44369,70,NULL,NULL,'2MASX J13053527+0637013',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,196.396958333,6.61697,0.046,NULL,58959932473,921248944,14394514,17.3),(104898,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104898,37.64,0.33,337,44370,70,NULL,NULL,'2MASX J13053634+0635233',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.43',0.16,NULL,NULL,NULL,NULL,NULL,1,196.4014583,6.58994,0.046,NULL,58959935042,921248985,14394515,18.43),(104899,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104899,35.26,0.25,113,44371,74.4,NULL,NULL,'NGC 4967',NULL,'2013AJ....146...86T',2013,1,0.92,NULL,'G',0.00003,NULL,'14.7g',0.7,'E','Group member',NULL,NULL,NULL,1,196.4017917,53.56428,0.033,NULL,57413884864,897091951,14017061,14.7),(104900,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104900,35.47,0.19,124,44371,70,NULL,NULL,'NGC 4967',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104901,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104901,35.64,0.19,134,44371,70,NULL,NULL,'NGC 4967',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104902,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104902,37.62,0.46,333,44372,70,NULL,NULL,'2MASX J13053688+1122193',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,196.403583,11.37194,0,NULL,58965311520,921332992,14395828,17.1),(104903,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104903,37.55,0.27,324,44373,70,NULL,NULL,'SDSS J130537.72+551213.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000161,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,196.407208333,55.20375,0.013,NULL,57424700803,897260950,14019702,18.3),(104904,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104904,36.78,0.46,227,44374,70,NULL,NULL,'2MASX J13053788+0849133',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000182,NULL,'16.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,196.4077917,8.82044,0.055,NULL,58968475063,921382422,14396600,16.4),(104905,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104905,37.78,0.33,359,44375,70,NULL,NULL,'2MASX J13053803+4948089',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000184,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,196.408333,49.80247,0,NULL,59090914447,923295538,14426492,16.9),(104906,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104906,37,0.15,251,44376,70,NULL,NULL,'SDSS J130538.19+091730.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,196.409167,9.29169,0.009,NULL,58968535093,921383360,14396615,17.9),(104907,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104907,36.91,0.33,240,44377,70,NULL,NULL,'2MASX J13053877+1003293',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,196.411583,10.05814,0,NULL,58967990329,921374848,14396482,16.6),(104908,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104908,37,0.15,251,44378,70,NULL,NULL,'2MASX J13054011+0927163',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,196.4170417,9.45442,0.009,NULL,58968545942,921383530,14396617,17.2),(104909,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104909,36.67,0.46,216,44379,70,NULL,NULL,'2MASX J13054045-0211335',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000061,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,196.418666667,-2.19264,0.021,NULL,43145548242,674149191,10533581,17.9),(104910,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104910,37,0.15,251,44380,70,NULL,NULL,'2MASX J13054093+0935323',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,196.4205417,9.59231,0,NULL,58968070999,921376109,14396501,16.9),(104911,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104911,35.56,0.53,129,44381,70,NULL,NULL,'2MFGC 10414',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,196.4212083,-42.36161,0.389,NULL,46750147631,730471056,11413610,13.6),(104912,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104912,37,0.15,251,44382,70,NULL,NULL,'2MASX J13054119+0912043',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00011,NULL,'16.49',0.23,NULL,NULL,NULL,NULL,NULL,1,196.4217083,9.20103,0.024,NULL,58968525388,921383209,14396612,16.49),(104913,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104913,35.64,0.46,135,44383,70,NULL,NULL,'2MASX J13054137+0111232',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000072,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,196.4224583,1.18989,0,NULL,58104518401,907883100,14185673,16.4),(104914,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104914,37.07,0.96,260,44384,70,NULL,NULL,'2MASX J13054208-2049414',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,196.425375,-20.82817,0.249,NULL,43798035386,684344302,10692879,15.4),(104915,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104915,36.91,0.33,240,44385,70,NULL,NULL,'SDSS J130542.12+100818.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000178,NULL,'17.8g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,196.4255417,10.13836,0,NULL,58966152441,921346131,14396033,17.8),(104916,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104916,37.19,0.46,274,44386,70,NULL,NULL,'2MASX J13054288+5610396',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000182,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,196.428875,56.17783,0.009,NULL,57429472281,897335504,14020867,16.4),(104917,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104917,37.98,0.46,394,44387,70,NULL,NULL,'LCRS B130308.3-022021',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000076,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,196.428916667,-2.60686,0.017,NULL,43145611790,674150184,10533596,17.7),(104918,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104918,37.17,0.11,272,44388,70,NULL,NULL,'2MASX J13054388+1921148',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,196.4329583,19.35403,0.068,NULL,59034006770,922406355,14412599,17.1),(104919,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104919,37.94,0.46,387,44389,70,NULL,NULL,'LCRS B130310.6-023402',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00009,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,196.438625,-2.83497,0.017,NULL,43144846351,674138224,10533409,17),(104920,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104920,37.7,0.21,346,44390,70,NULL,NULL,'SDSS J130545.97+215645.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'19.30',0.11,NULL,NULL,NULL,NULL,NULL,1,196.4415417,21.94592,0.087,NULL,58819453674,919053963,14360218,19.3),(104921,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104921,36.88,0.66,238,44391,70,NULL,NULL,'2MASX J13054596-1938214',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.34',NULL,NULL,NULL,NULL,NULL,NULL,1,196.441583333,-19.63947,0.233,NULL,43980082707,687188792,10737324,16.34),(104922,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104922,36.85,0.46,234,44392,70,NULL,NULL,'SBS 1303+601',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000171,NULL,'16.2g',0.32,NULL,NULL,NULL,NULL,NULL,1,196.4459583,59.84333,0,NULL,57384030098,896625470,14009772,16.2),(104923,'FP','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,'R',104923,37.94,0.33,387,44393,70,NULL,NULL,'2MASX J13054712+0041182',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000076,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,196.446375,0.68844,0,NULL,58103864441,907872881,14185513,17),(104924,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104924,31.93,0.69,24.3,44394,100,NULL,'mid-IR','NGC 4961',NULL,'2013ApJ...771...88L',2013,1,1.6,'Identification as NGC 4960 is not certain.','G',0.00003,NULL,'13.7B',1.1,'SB(s)cd','in a pair',NULL,NULL,NULL,1,196.4482083,27.73414,0.036,NULL,58705429528,917272336,14332380,13.7),(104925,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:21','1',NULL,NULL,104925,32.65,0.4,33.9,44394,NULL,NULL,NULL,'NGC 4961',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104926,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104926,32.96,0.43,39,44394,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4961',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104927,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104927,32.98,0.4,39.4,44394,75,NULL,'B','NGC 4961',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104928,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104928,33,0.4,39.7,44394,NULL,NULL,'mean','NGC 4961',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104929,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104929,33,0.43,39.8,44394,75,NULL,'3.6 micron, color corrected','NGC 4961',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104930,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104930,33.04,0.2,40.6,44394,74.4,NULL,NULL,'NGC 4961',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104931,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104931,33.08,0.7,41.2,44394,NULL,NULL,'Malmquist cor.','NGC 4961',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104932,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104932,33.13,0.68,42.3,44394,NULL,NULL,NULL,'NGC 4961',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104933,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104933,33.85,0.3,58.9,44394,55,NULL,'B','NGC 4961',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104934,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104934,33.92,0.47,60.9,44394,NULL,NULL,'H','NGC 4961',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104935,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',104935,36.24,0.46,177,44395,70,NULL,NULL,'2MASX J13054816+4428210',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000158,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,196.450583,44.47261,0,NULL,59098610137,923415783,14428371,17),(104936,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',104936,35.48,0.27,125,44396,70,NULL,NULL,'I Zw 051',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'16.55',0.25,NULL,NULL,NULL,NULL,NULL,1,196.453583,28.10653,0.04,NULL,58705321568,917270649,14332353,16.55),(104937,'Faber-Jackson','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104937,30.49,0.65,12.5,44397,95,NULL,'Weighted Mean','NGC 4958',NULL,'1984ApJS...56...91D',1984,1,4.1,NULL,'G',0.00003,NULL,'12.11',1.3,'SB(r)0? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,196.453667,-8.02028,0.081,NULL,43850493435,685163959,10705686,12.11),(104938,'Faber-Jackson','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104938,31.59,0.81,20.8,44397,55,NULL,'Visvanathan & Sandage 1979','NGC 4958',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104939,'Tully est','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104939,31.6,0.8,20.9,44397,75,NULL,'B','NGC 4958',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104940,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104940,30.59,0.45,13.1,44397,NULL,NULL,'K','NGC 4958',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104941,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104941,31.65,0.4,21.4,44397,NULL,NULL,'mean','NGC 4958',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104942,'Brightest Stars','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104942,26.77,0.61,2.26,44398,NULL,NULL,'K, 3, red stars','IC 4182',NULL,'1994MNRAS.271..530R',1994,1,6,NULL,'G',0.000003,NULL,'13.0',5.5,'SA(s)m','Probable group member',NULL,NULL,NULL,1,196.456417,37.60489,0,0,59294225862,926472279,14476129,13),(104943,'Brightest Stars','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104943,26.97,0.62,2.48,44398,NULL,NULL,'3, B, red stars','IC 4182',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104944,'Brightest Stars','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104944,27,0.2,2.5,44398,NULL,NULL,NULL,'IC 4182',NULL,'1992ApJ...390L..45P',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104945,'Brightest Stars','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104945,27.64,0.58,3.37,44398,NULL,NULL,'V, 3, red stars','IC 4182',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104946,'Brightest Stars','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104946,27.76,0.9,3.56,44398,NULL,NULL,'3, B, blue stars','IC 4182',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104947,'Brightest Stars','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104947,27.83,0.55,3.68,44398,NULL,NULL,'3, B, red stars','IC 4182',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104948,'Brightest Stars','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104948,28.18,0.35,4.33,44398,NULL,NULL,'3, B, red stars revised','IC 4182',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104949,'Brightest Stars','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104949,28.21,0.03,4.39,44398,NULL,NULL,'Photographic','IC 4182',NULL,'1982ApJ...256..339S',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104950,'Brightest Stars','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104950,28.24,0.88,4.45,44398,NULL,NULL,'3, B, blue stars','IC 4182',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104951,'Brightest Stars','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104951,28.29,0.36,4.55,44398,NULL,NULL,'V, 3, red stars revised','IC 4182',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104952,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',104952,27.4,NULL,3.02,44398,NULL,NULL,'UBVRI','IC 4182',NULL,'1992AAS...181.8202J',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104953,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104953,28.05,0.07,4.07,44398,NULL,NULL,'2, H','IC 4182',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104954,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',104954,28.05,0.07,4.07,44398,NULL,NULL,'2, H','IC 4182',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104955,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',104955,28.05,0.1,4.07,44398,73,NULL,'Cepheids periods Gaussian ','IC 4182',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104956,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104956,28.06,NULL,4.09,44398,NULL,NULL,'52, VI','IC 4182',NULL,'2006A&A...452..423P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104957,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104957,28.07,0.14,4.11,44398,NULL,NULL,'19, VI +Z','IC 4182',NULL,'1997ApJ...491...13K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104958,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',104958,28.14,0.01,4.25,44398,NULL,NULL,'2, I','IC 4182',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104959,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104959,28.14,0.01,4.25,44398,NULL,NULL,'2, I','IC 4182',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104960,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104960,28.19,0.08,4.34,44398,NULL,NULL,'28, VI +Z','IC 4182',NULL,'2001ApJ...547L.103G',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104961,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',104961,28.2,0.07,4.37,44398,NULL,NULL,'2, V','IC 4182',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104962,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104962,28.2,0.07,4.37,44398,NULL,NULL,'2, V','IC 4182',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104963,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104963,28.21,0.08,4.38,44398,NULL,NULL,'28, VI','IC 4182',NULL,'2001ApJ...547L.103G',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104964,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104964,28.21,0.09,4.39,44398,NULL,18.54,'LMC ZP','IC 4182',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104965,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104965,28.22,0.06,4.41,44398,74.4,NULL,NULL,'IC 4182',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104966,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',104966,28.23,0.07,4.43,44398,NULL,NULL,NULL,'IC 4182',NULL,'1996CRASB.323..619P',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104967,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',104967,28.26,0.07,4.49,44398,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian ','IC 4182',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104968,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104968,28.26,0.06,4.49,44398,NULL,NULL,'16, VI, +Z, KEY PROJECT','IC 4182',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104969,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104969,28.27,0.08,4.5,44398,NULL,NULL,'LMC W01','IC 4182',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104970,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104970,28.28,0.06,4.53,44398,NULL,NULL,'16, VI, KEY PROJECT','IC 4182',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104971,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104971,28.29,0.13,4.54,44398,NULL,NULL,'cte MW GFG98','IC 4182',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104972,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104972,28.31,0.11,4.59,44398,NULL,NULL,'19, VI','IC 4182',NULL,'1997ApJ...491...13K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104973,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104973,28.31,0.08,4.59,44398,NULL,NULL,'ALLFRAME, Key Project','IC 4182',NULL,'2000ApJ...529..723G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104974,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104974,28.32,0.13,4.61,44398,NULL,NULL,'cte LMC K03','IC 4182',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104975,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104975,28.33,0.13,4.63,44398,NULL,NULL,'cte MW FSG03','IC 4182',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104976,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104976,28.33,0.13,4.64,44398,NULL,NULL,'cte U99','IC 4182',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104977,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104977,28.34,0.13,4.65,44398,NULL,NULL,'cte LMC STS02','IC 4182',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104978,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104978,28.35,0.13,4.67,44398,NULL,NULL,'cte MW STS03','IC 4182',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104979,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104979,28.35,0.06,4.68,44398,NULL,NULL,'LMC VIHJK','IC 4182',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104980,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104980,28.36,0.08,4.7,44398,NULL,NULL,'HST KP Calibrated','IC 4182',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104981,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104981,28.36,0.09,4.7,44398,NULL,NULL,'28, VI','IC 4182',NULL,'1994ApJ...425...14S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104982,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104982,28.36,0.08,4.7,44398,NULL,NULL,'ALLFRAME','IC 4182',NULL,'2000ApJ...529..723G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104983,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104983,28.36,0.06,4.7,44398,NULL,NULL,'MW HIPP','IC 4182',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104984,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104984,28.36,NULL,4.7,44398,NULL,NULL,NULL,'IC 4182',NULL,'2004AJ....127.2031K',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104985,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104985,28.37,0.13,4.71,44398,NULL,NULL,'cte MF91','IC 4182',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104986,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104986,28.37,0.15,4.72,44398,NULL,NULL,'MW P02','IC 4182',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104987,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104987,28.39,0.07,4.76,44398,NULL,NULL,'MW GFG','IC 4182',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104988,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104988,28.39,0.07,4.76,44398,NULL,NULL,'169, VI','IC 4182',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104989,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',104989,28.43,0.08,4.85,44398,NULL,NULL,NULL,'IC 4182',NULL,'1996ASPC...94..357H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104990,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,104990,28.47,0.08,4.94,44398,NULL,NULL,'27, V apparent','IC 4182',NULL,'1992ApJ...401L...7S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104991,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',104991,28.48,0.08,4.97,44398,73,NULL,'Cepheids magnitudes Gaussian ','IC 4182',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104992,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',104992,28.5,0.03,5.01,44398,NULL,NULL,'BVRI+','IC 4182',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104993,'Cepheids','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',104993,28.5,0.03,5.01,44398,NULL,NULL,'BVRI','IC 4182',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104994,'SNIa','2016-12-15 15:15:10','2016-12-16 11:20:22','1','SN 1937C',NULL,104994,27.2,0.3,2.75,44398,NULL,NULL,'Photographic','IC 4182',NULL,'1993ApJ...415...10d',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104995,'SNIa','2016-12-15 15:15:10','2016-12-16 11:20:22','1','SN 1937C','R',104995,28.13,NULL,4.23,44398,NULL,NULL,'Photographic','IC 4182',NULL,'1988SSRv...48....1R',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104996,'SNIa','2016-12-15 15:15:10','2016-12-16 11:20:22','1','SN 1937C',NULL,104996,28.17,0.09,4.31,44398,60,NULL,'M(B) = -19.48 mag','IC 4182',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104997,'SNIa','2016-12-15 15:15:10','2016-12-16 11:20:22','1','SN 1937C',NULL,104997,28.19,0.11,4.35,44398,60,NULL,'M(V) = -19.47 mag','IC 4182',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104998,'SNIa','2016-12-15 15:15:10','2016-12-16 11:20:22','1','SN 1937C',NULL,104998,28.3,0.44,4.5,44398,67,NULL,NULL,'IC 4182',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104999,'SNIa','2016-12-15 15:15:10','2016-12-16 11:20:22','1','SN 1937C',NULL,104999,28.54,0.14,5.11,44398,60,NULL,NULL,'IC 4182',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105000,'TRGB','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105000,28.15,0.07,4.26,44398,NULL,NULL,NULL,'IC 4182',NULL,'2013AstBu..68..125M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105001,'TRGB','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105001,28.17,0.14,4.31,44398,NULL,NULL,NULL,'IC 4182',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105002,'TRGB','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105002,28.2,0.07,4.37,44398,NULL,NULL,'I','IC 4182',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105003,'TRGB','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105003,28.22,0.06,4.41,44398,74.4,NULL,NULL,'IC 4182',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105004,'TRGB','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105004,28.23,0.05,4.43,44398,NULL,NULL,'I','IC 4182',NULL,'2007ApJ...661..815R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105005,'TRGB','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105005,28.23,0.02,4.43,44398,NULL,NULL,NULL,'IC 4182',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105006,'TRGB','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105006,28.25,0.06,4.47,44398,NULL,NULL,NULL,'IC 4182',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105007,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105007,26.9,0.4,2.4,44398,NULL,18.45,'SN 1937C host','IC 4182',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105008,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105008,28.22,0.4,4.4,44398,75,NULL,'B','IC 4182',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105009,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105009,38,0.46,399,44399,70,NULL,NULL,'2MASX J13055167+1147169',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000215,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,196.4652083,11.78814,0.023,NULL,58996294083,921817095,14403392,16.8),(105010,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105010,37.78,0.33,359,44400,70,NULL,NULL,'2MASX J13055177+4948488',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000141,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,196.465583,49.81369,0,NULL,59090905994,923295406,14426490,17.8),(105011,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105011,35.57,0.46,130,44401,70,NULL,NULL,'IC 4184',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000162,NULL,'15.5g',0.41,'SABa',NULL,NULL,NULL,NULL,1,196.465708333,38.83739,0,NULL,59292962366,926452536,14475820,15.5),(105012,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105012,37.94,0.33,387,44402,70,NULL,NULL,'2MASX J13055180+0043589',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00008,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,196.465958333,0.73297,0,NULL,58104575085,907883985,14185687,17.3),(105013,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105013,37.25,0.46,282,44403,70,NULL,NULL,'2MASX J13055214-0043253',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000099,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,196.467333,-0.72375,0,NULL,43143575560,674118368,10533099,16.4),(105014,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105014,37.69,0.46,344,44404,70,NULL,NULL,'2MASX J13055237+4932108',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,196.468416667,49.53647,0,NULL,59090727667,923292619,14426447,17.2),(105015,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105015,37,0.15,251,44405,70,NULL,NULL,'2MASX J13055287+0932509',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000165,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,196.4702917,9.54761,0.009,NULL,58968065730,921376027,14396500,16.3),(105016,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105016,37.55,0.27,324,44406,70,NULL,NULL,'2MASX J13055362+5518016',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,196.4734583,55.30064,0.013,NULL,57424661285,897260332,14019692,18),(105017,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105017,37.02,0.7,254,44407,70,NULL,NULL,'2MASX J13055437-2904536',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000103,NULL,'15.8b',0.4,'*+E',NULL,NULL,NULL,NULL,1,196.476583,-29.08161,0.461,NULL,43337267444,677144803,10580387,15.8),(105018,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105018,35.26,0.25,113,44408,74.4,NULL,NULL,'NGC 4974',NULL,'2013AJ....146...86T',2013,1,1.08,NULL,'G',0.000037,NULL,'14.2g',0.77,'E/S0','Group member',NULL,NULL,NULL,1,196.482875,53.65928,0.033,NULL,57413889639,897092025,14017062,14.2),(105019,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105019,35.47,0.19,124,44408,70,NULL,NULL,'NGC 4974',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105020,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105020,35.64,0.19,134,44408,70,NULL,NULL,'NGC 4974',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105021,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105021,38.19,0.46,435,44409,70,NULL,NULL,'2MASX J13055711+2144305',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,196.4880417,21.74169,0.102,NULL,58819711829,919057997,14360281,17.9),(105022,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105022,38.02,0.46,402,44410,70,NULL,NULL,'SDSS J130557.50+581855.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00013,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,196.489583,58.31542,0,NULL,57442039035,897531859,14023935,18.2),(105023,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105023,38.34,0.46,465,44411,70,NULL,NULL,'2MASX J13055768+6118387',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,196.490125,61.31078,0,NULL,57354516695,896164323,14002567,18),(105024,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105024,37.83,0.27,367,44412,70,NULL,NULL,'2MASX J13055794+1205488',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000178,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,196.4915417,12.09706,0.03,NULL,58996314043,921817406,14403396,16.9),(105025,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105025,36.95,0.46,245,44413,70,NULL,NULL,'2MASX J13055840-0022263',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000067,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,196.493333,-0.37389,0.012,NULL,43109207711,673581370,10524708,17.4),(105026,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105026,34.59,0.49,82.6,44414,75,NULL,'IR','UGC 08186',NULL,'2011yCatp016004901K',2011,1,2.08,NULL,'G',0.000027,NULL,'14.9g',0.34,'Scd(f)',NULL,NULL,NULL,NULL,1,196.494333,3.95644,0.013,NULL,58111009039,907984516,14187258,14.9),(105027,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105027,34.9,0.2,95.5,44414,74.4,NULL,NULL,'UGC 08186',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105028,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105028,34.92,0.33,96.6,44414,NULL,NULL,'Malmquist cor.','UGC 08186',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105029,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105029,35,0.47,99.8,44414,NULL,NULL,'H','UGC 08186',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105030,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105030,35.06,0.31,103,44414,NULL,NULL,NULL,'UGC 08186',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105031,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105031,35.11,0.45,105,44414,NULL,NULL,'K','UGC 08186',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105032,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105032,35.14,0.4,107,44414,NULL,NULL,'mean','UGC 08186',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105033,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105033,35.16,0.46,108,44414,NULL,NULL,'J','UGC 08186',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105034,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105034,37,0.15,251,44415,70,NULL,NULL,'2MASX J13055862+0924489',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000152,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,196.4942083,9.41361,0.009,NULL,58968553388,921383646,14396619,17.2),(105035,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105035,37.57,0.46,327,44416,70,NULL,NULL,'SDSS J130558.83+175743.7',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.2B',0.24,NULL,NULL,NULL,NULL,NULL,1,196.495167,17.96217,0.074,NULL,59032797463,922387460,14412304,16.2),(105036,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105036,37.82,0.46,366,44417,70,NULL,NULL,'2MASX J13055885-0246563',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000082,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,196.4952083,-2.78236,0.017,NULL,43144900712,674139073,10533423,17.5),(105037,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105037,35.89,0.46,150,44418,70,NULL,NULL,'IC 4187',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000187,NULL,'15.4g',0.49,NULL,NULL,NULL,NULL,NULL,1,196.498417,36.29847,0,NULL,59291058549,926422789,14475356,15.4),(105038,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105038,35.31,0.05,115,44419,70,NULL,NULL,'CGCG 160-136',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00008,NULL,'14.95',0.7,'S0?',NULL,NULL,NULL,NULL,1,196.4984583,29.27881,0.046,NULL,58705925559,917280086,14332501,14.95),(105039,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105039,35.58,0.66,131,44420,70,NULL,NULL,'2MASX J13060097-3736577',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00006,NULL,'15.3R',NULL,'S0',NULL,NULL,NULL,NULL,1,196.504125,-37.61633,0.281,NULL,46929624850,733275388,11457427,15.3),(105040,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105040,36.84,0.46,233,44421,70,NULL,NULL,'2MASX J13060100+4722340',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,196.504375,47.37597,0,NULL,59103530862,923492669,14429572,17.4),(105041,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105041,38.65,0.46,538,44422,70,NULL,NULL,'SDSS J130601.35+363217.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,196.505666667,36.53828,0.021,NULL,59291021046,926422203,14475346,18.4),(105042,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105042,36.11,0.68,167,44423,70,NULL,NULL,'2MASX J13060192-1351087',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.76',NULL,NULL,NULL,NULL,NULL,NULL,1,196.507917,-13.85264,0.077,NULL,44012661066,687697829,10745278,16.76),(105043,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105043,34.31,0.2,72.8,44424,74.4,NULL,NULL,'IC 4189',NULL,'2013AJ....146...86T',2013,1,1.23,NULL,'G',0.000103,NULL,'14.1g',0.84,'Scd:','in a radial-velocity based grouping',NULL,NULL,NULL,1,196.5147917,35.98033,0.013,NULL,59291168201,926424503,14475382,14.1),(105044,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105044,34.44,0.5,77.2,44424,NULL,NULL,NULL,'IC 4189',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105045,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105045,34.56,0.48,81.7,44424,NULL,NULL,'Malmquist cor.','IC 4189',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105046,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105046,36.39,0.46,190,44425,70,NULL,NULL,'2MASX J13060398+5014592',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000191,NULL,'15.3g',0.57,'E',NULL,NULL,NULL,NULL,1,196.5165,50.24972,0,NULL,59091230019,923300469,14426569,15.3),(105047,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105047,37.49,0.58,315,44426,70,NULL,NULL,'2MASX J13060456-1133439',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,196.519083,-11.56217,0.109,NULL,43846522703,685101917,10704717,16.9),(105048,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105048,38.26,0.46,449,44427,70,NULL,NULL,'2MASX J13060465+6634055',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,196.519417,66.56806,0.025,NULL,57907549897,904805467,14137585,18),(105049,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105049,38.63,0.46,531,44428,70,NULL,NULL,'SDSS J130604.72+672421.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000092,NULL,'18.6g',0.14,'NLAGN',NULL,NULL,NULL,NULL,1,196.5197083,67.40608,0.033,NULL,57910019754,904844058,14138188,18.6),(105050,'D-Sigma','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105050,32.39,0.4,30.1,44429,75,NULL,'Edat, raw','NGC 4955',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'13.2',1.3,'E2','Group member, radial-velocity confirmed',NULL,NULL,'Flat-Spectrum Radio Source',1,196.520083333,-29.75428,0.353,NULL,43329663589,677025993,10578531,13.2),(105051,'D-Sigma','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105051,32.53,0.4,32,44429,75,NULL,'Edat, cor','NGC 4955',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105052,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105052,33.27,0.49,45.1,44429,70,NULL,NULL,'NGC 4955',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105053,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105053,33.45,0.4,48.9,44429,NULL,NULL,'mean','NGC 4955',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105054,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105054,33.57,0.45,51.7,44429,NULL,NULL,'K','NGC 4955',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105055,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105055,35.31,0.05,115,44430,70,NULL,NULL,'CGCG 160-135',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000077,NULL,'15.2g',0.48,'S0',NULL,NULL,NULL,NULL,1,196.522958333,28.59294,0.032,NULL,58706789114,917293579,14332712,15.2),(105056,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105056,37.73,0.46,352,44431,70,NULL,NULL,'2MASX J13060565+5112102',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000183,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,196.523417,51.20294,0,NULL,57196036917,893688076,13963876,17.6),(105057,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105057,37.93,0.23,385,44432,70,NULL,NULL,'2MASX J13060612+5402579',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000155,NULL,'17.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,196.525291667,54.04961,0.043,NULL,57426263422,897285365,14020083,17.7),(105058,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105058,38.24,0.46,444,44433,70,NULL,NULL,'2MASX J13060728+4538110',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,196.530166667,45.6365,0,NULL,59101688016,923463875,14429123,18),(105059,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105059,38.08,0.46,413,44434,70,NULL,NULL,'SDSS J130607.65+401457.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000148,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,196.531875,40.24933,0,NULL,59300288389,926567006,14477609,18.3),(105060,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105060,37.15,0.54,269,44435,70,NULL,NULL,'2MASX J13060826-0522403',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00009,NULL,'15.69',0.42,NULL,NULL,NULL,NULL,NULL,1,196.5345417,-5.37783,0.061,NULL,43139446861,674053857,10532091,15.69),(105061,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105061,34.47,0.2,78.3,44436,74.4,NULL,NULL,'UGC 08193',NULL,'2013AJ....146...86T',2013,1,1.06,NULL,'G',0.000014,NULL,'16.1g',0.22,'Sc',NULL,NULL,NULL,NULL,1,196.5347917,30.20928,0.046,NULL,58676207997,916815749,14325246,16.1),(105062,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105062,35.03,0.49,101,44436,75,NULL,'IR','UGC 08193',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105063,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105063,37.05,0.57,257,44437,70,NULL,NULL,'2MASX J13060964-2054582',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.13',NULL,NULL,NULL,NULL,NULL,NULL,1,196.540041667,-20.91625,0.245,NULL,43798001852,684343778,10692871,16.13),(105064,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105064,36.35,0.49,186,44438,70,NULL,NULL,'AM 1303-340',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00011,NULL,'15.5',0.4,NULL,NULL,NULL,NULL,NULL,1,196.540333,-34.31672,0.185,NULL,46859332896,732177076,11440266,15.5),(105065,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105065,35.99,0.54,158,44439,70,NULL,NULL,'2MASX J13060975-1350427',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,196.540708333,-13.84514,0.077,NULL,44012659068,687697797,10745278,16.1),(105066,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105066,36.06,0.6,163,44440,70,NULL,NULL,'2MASX J13061030-4748428',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.4,NULL,NULL,NULL,NULL,NULL,1,196.542875,-47.81186,0.793,NULL,46739695188,730307737,11411058,13.9),(105067,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105067,34.41,0.5,76.2,44441,70,NULL,NULL,'NGC 4953',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'14.09',0.9,'S0+: pec','Pair member (points to parent)',NULL,NULL,NULL,1,196.543625,-37.58575,0.281,NULL,46929615376,733275240,11457425,14.09),(105068,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105068,37.33,0.46,292,44442,70,NULL,NULL,'2MASX J13061113+2610280',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00016,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,196.546416667,26.17461,0.008,NULL,58700171044,917190172,14331096,17),(105069,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105069,37.91,0.33,382,44443,70,NULL,NULL,'2MASX J13061127+3620100',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000127,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,196.546917,36.33622,0,NULL,59291053021,926422703,14475354,18.3),(105070,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105070,37,0.15,251,44444,70,NULL,NULL,'2MASX J13061173+0911509',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000194,NULL,'18.14',0.17,NULL,NULL,NULL,NULL,NULL,1,196.548833,9.19744,0.01,NULL,58968751839,921386747,14396667,18.14),(105071,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105071,37.7,0.21,346,44445,70,NULL,NULL,'2MASX J13061333+2141245',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,196.555417,21.68997,0.102,NULL,58819719783,919058121,14360283,16.6),(105072,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105072,37,0.15,251,44446,70,NULL,NULL,'2MASX J13061427+0914366',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000181,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,196.559667,9.24372,0.01,NULL,58968746397,921386662,14396666,16.7),(105073,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105073,36.54,NULL,204,44447,NULL,NULL,NULL,'FGC 1559',NULL,'2000BSAO...50....5K',2000,1,0.78,NULL,'G',0.000174,NULL,'16.7g',0.15,'Sd',NULL,NULL,NULL,NULL,1,196.5642083,53.51789,0.033,NULL,57413902753,897092230,14017066,16.7),(105074,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105074,38.44,0.46,488,44448,70,NULL,NULL,'2MASX J13061571+1840445',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,196.5654583,18.67897,0.07,NULL,59033519220,922398737,14412480,18.3),(105075,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105075,36.83,0.46,232,44449,70,NULL,NULL,'2MASX J13061579+6041468',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000165,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,196.565541667,60.69642,0.005,NULL,57385857962,896654030,14010219,16.8),(105076,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105076,38.04,0.46,405,44450,70,NULL,NULL,'2MASX J13061597+4009390',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000178,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,196.566667,40.16092,0,NULL,59300292509,926567070,14477610,17.5),(105077,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105077,34.7,0.47,87.1,44451,NULL,NULL,'H','CGCG 160-137',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'GPair',0.000027,NULL,NULL,NULL,'S','in a radial-velocity based grouping',NULL,NULL,NULL,1,196.567083333,29.06361,0.032,NULL,58705904808,917279762,14332496,NULL),(105078,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105078,34.84,0.46,92.8,44451,NULL,NULL,'J','CGCG 160-137',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105079,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105079,34.85,0.45,93.5,44451,NULL,NULL,'K','CGCG 160-137',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105080,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105080,35.12,0.4,106,44451,NULL,NULL,'mean','CGCG 160-137',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105081,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105081,37.07,0.46,259,44452,70,NULL,NULL,'2MASX J13061726+0715476',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.06',0.17,NULL,NULL,NULL,NULL,NULL,1,196.572041667,7.26319,0.043,NULL,58963264088,921301001,14395328,18.06),(105082,'IRAS','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105082,34.92,0.8,96.5,44453,75,NULL,'HMCL, I','NGC 4966',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000083,NULL,'13.9g',0.6,'Sa             LINER','in a radial-velocity based grouping',NULL,NULL,'LINER',1,196.572125,29.06286,0.032,NULL,58705904799,917279762,14332496,13.9),(105083,'IRAS','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105083,34.94,0.8,97.3,44453,75,NULL,'W91CL, r','NGC 4966',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105084,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105084,34.02,0.69,63.6,44453,100,NULL,'mid-IR','NGC 4966',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105085,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105085,34.64,0.4,84.5,44453,75,NULL,'HMCL, I, raw','NGC 4966',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105086,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105086,34.82,0.38,91.9,44453,75,NULL,'W91CL, r, raw','NGC 4966',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105087,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105087,34.87,0.4,94.1,44453,75,NULL,'HMCL, I, inv','NGC 4966',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105088,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105088,34.88,0.4,94.5,44453,75,NULL,'HMCL, I, cor','NGC 4966',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105089,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105089,34.94,0.38,97.1,44453,75,NULL,'W91CL, r, cor','NGC 4966',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105090,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105090,35.02,0.38,101,44453,75,NULL,'W91CL, r, inv','NGC 4966',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105091,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105091,35.23,0.11,111,44453,NULL,NULL,NULL,'NGC 4966',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105092,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105092,35.48,0.61,125,44454,70,NULL,NULL,'2MASX J13061740-0745423',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.32',0.31,NULL,NULL,NULL,NULL,NULL,1,196.5727083,-7.76183,0.145,NULL,43851346448,685177288,10705895,16.32),(105093,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105093,37.21,0.46,277,44455,70,NULL,NULL,'2MASX J13061753-0010553',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000065,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,196.573041667,-0.18208,0.007,NULL,43109100801,673579700,10524682,17.6),(105094,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105094,35.57,0.59,130,44456,70,NULL,NULL,'2MASX J13061753-2909023',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.2b',0.4,'E',NULL,NULL,NULL,NULL,1,196.573167,-29.15061,0.461,NULL,43337262028,677144719,10580386,16.2),(105095,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105095,34.73,0.62,88.5,44457,70,NULL,NULL,'2MASX J13061808-0736433',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.000083,NULL,'15.53',0.47,NULL,NULL,NULL,NULL,NULL,1,196.575375,-7.61214,0.145,NULL,43851400769,685178137,10705908,15.53),(105096,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105096,35.38,0.46,119,44458,70,NULL,NULL,'2MASX J13061822+2715181',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000167,NULL,'15.99',0.3,NULL,NULL,NULL,NULL,NULL,1,196.575875,27.25506,0.01,NULL,58697288764,917145136,14330392,15.99),(105097,'Tully est','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105097,31.87,0.8,23.6,44459,75,NULL,NULL,'DDO 164',NULL,'1988NBGC.C....0000T',1988,1,2,NULL,'G',0.000003,NULL,'18',1.7,'IAm pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,196.5767083,-17.51478,0.133,NULL,44009719231,687651862,10744560,18),(105098,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105098,31.3,0.4,18.2,44459,NULL,NULL,NULL,'DDO 164',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105099,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105099,37.73,0.33,352,44460,70,NULL,NULL,'2MASX J13061925+1113396',NULL,'2015arXiv151105856S',2015,1,0.63,'TXS codes: lobes(W)','G',0.000199,NULL,'16.0g',0.37,'E0',NULL,NULL,NULL,NULL,1,196.5802083,11.22772,0,NULL,58967429568,921366087,14396345,16),(105100,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105100,38.06,0.46,410,44461,70,NULL,NULL,'SDSS J130619.27+380657.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000138,NULL,'18.6g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,196.5802917,38.11592,0,NULL,59293587405,926462303,14475973,18.6),(105101,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105101,34.76,0.5,89.6,44462,70,NULL,NULL,'2MASX J13061970-1302510',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,196.582125,-13.04753,0.053,NULL,43968134830,687002106,10734407,16.3),(105102,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105102,38.13,0.27,422,44463,70,NULL,NULL,'2MASX J13061987+4542474',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000166,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,196.582625,45.71317,0,NULL,59101736809,923464637,14429134,18.4),(105103,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105103,35.75,0.46,142,44464,70,NULL,NULL,'2MASX J13062093+5318232',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000213,NULL,'15.9g',0.3,'Candidate      BLAGN',NULL,NULL,NULL,'AGN',1,196.587375,53.30644,0.061,NULL,57413854210,897091472,14017054,15.9),(105104,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105104,35.84,0.64,147,44465,70,NULL,NULL,'2MASX J13062135-1231250',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.37',NULL,NULL,NULL,NULL,NULL,NULL,1,196.5890417,-12.52392,0.053,NULL,43965481197,686960643,10733760,16.37),(105105,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105105,37.73,0.46,351,44466,70,NULL,NULL,'2MASX J13062136+1442409',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000142,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,196.589125,14.71131,0.016,NULL,59050272165,922660502,14416570,18.4),(105106,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105106,37.3,0.46,288,44467,70,NULL,NULL,'2MASX J13062155+3518112',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000167,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,196.589917,35.303,0,NULL,59157154174,924330533,14442664,17),(105107,'IRAS','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105107,34.92,0.8,96.5,44468,75,NULL,'HMCL, I','UGC 08195',NULL,'1997ApJS..109..333W',1997,1,1.32,NULL,'G',0.000011,NULL,'16.0',0.13,'Sd             Sbrst',NULL,NULL,NULL,NULL,1,196.592333,29.65747,0.044,NULL,58705983869,917280997,14332515,16),(105108,'IRAS','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105108,34.95,0.8,97.5,44468,75,NULL,'W91CL, r','UGC 08195',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105109,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105109,34.16,0.38,67.9,44468,75,NULL,'W91CL, r, inv','UGC 08195',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105110,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105110,34.17,0.38,68.2,44468,75,NULL,'W91CL, r, raw','UGC 08195',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105111,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105111,34.2,0.4,69.1,44468,75,NULL,'HMCL, I, raw','UGC 08195',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105112,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105112,34.24,0.4,70.5,44468,75,NULL,'HMCL, I, inv','UGC 08195',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105113,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105113,34.25,0.49,70.8,44468,75,NULL,'IR','UGC 08195',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105114,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105114,34.35,0.2,74.1,44468,74.4,NULL,NULL,'UGC 08195',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105115,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105115,34.39,NULL,75.5,44468,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08195',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105116,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105116,34.4,NULL,75.9,44468,NULL,NULL,'Dipole + Quadrupole','UGC 08195',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105117,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105117,34.41,NULL,76.2,44468,NULL,NULL,'Dipole','UGC 08195',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105118,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105118,34.47,NULL,78.2,44468,NULL,NULL,NULL,'UGC 08195',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105119,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105119,34.61,0.38,83.6,44468,75,NULL,'W91CL, r, cor','UGC 08195',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105120,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105120,34.65,0.4,85.1,44468,75,NULL,'HMCL, I, cor','UGC 08195',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105121,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105121,35.08,0.16,104,44468,NULL,NULL,NULL,'UGC 08195',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105122,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105122,37.11,0.46,264,44469,70,NULL,NULL,'2MASX J13062275+5454179',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,196.594666667,54.90506,0.01,NULL,57427931868,897311435,14020491,16.9),(105123,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105123,37.42,0.46,305,44470,70,NULL,NULL,'2MASX J13062414+0008009',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000085,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,196.600667,0.13367,0.006,NULL,58086966644,907608853,14181388,17.3),(105124,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105124,36.83,0.46,232,44471,70,NULL,NULL,'2MASX J13062441+2328480',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,196.6017917,23.48003,0.044,NULL,58817882483,919029413,14359834,17.6),(105125,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105125,35.47,0.19,124,44472,70,NULL,NULL,'SDSS J130624.81+532903.9',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'*',NULL,NULL,'15.1g',NULL,'Point Src [SDSS]',NULL,NULL,NULL,NULL,1,196.603417,53.48442,0.061,NULL,57413934040,897092719,14017073,15.1),(105126,'Brightest Stars','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105126,28.43,NULL,4.85,44473,NULL,NULL,'3R','UGC 08201',NULL,'1991A&AS...91..503K',1991,1,3.5,'The UZC position is southwest of the center of the galaxy.','G',0.000001,NULL,'12.8',1.9,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,196.6035417,67.70694,0.033,NULL,57909160165,904830627,14137978,12.8),(105127,'Brightest Stars','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105127,28.47,NULL,4.94,44473,NULL,NULL,'3B','UGC 08201',NULL,'1991A&AS...91..503K',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105128,'SBF','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105128,28.4,0.4,4.79,44473,NULL,NULL,NULL,'UGC 08201',NULL,'2003AJ....125.1247H',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105129,'TRGB','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105129,28.3,0.19,4.57,44473,NULL,NULL,'I','UGC 08201',NULL,'2002A&A...383..125K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105130,'TRGB','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105130,28.31,NULL,4.59,44473,NULL,NULL,NULL,'UGC 08201',NULL,'2006Ap.....49....3K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105131,'TRGB','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105131,28.41,0.02,4.81,44473,NULL,NULL,'I','UGC 08201',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105132,'TRGB','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105132,28.42,0.1,4.83,44473,74.4,NULL,NULL,'UGC 08201',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105133,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105133,27.22,0.4,2.8,44473,75,NULL,'B','UGC 08201',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105134,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105134,36.96,0.46,246,44474,70,NULL,NULL,'2MASX J13062531+0808236',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.25',0.15,NULL,NULL,NULL,NULL,NULL,1,196.605417,8.13989,0.032,NULL,58960719041,921261235,14394706,18.25),(105135,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105135,36.79,0.55,228,44475,70,NULL,NULL,'2MASX J13062643-3746321',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000073,NULL,'16.0b',0.5,'S0',NULL,NULL,NULL,NULL,1,196.610083,-37.77581,0.281,NULL,46927708961,733245452,11456960,16),(105136,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105136,36.14,0.33,169,44476,70,NULL,NULL,'MCG +08-24-041',NULL,'2015arXiv151105856S',2015,1,0.94,NULL,'G',0.000185,NULL,'14.9g',0.64,'E0',NULL,NULL,NULL,NULL,1,196.611083,45.289,0,NULL,59098544950,923414764,14428355,14.9),(105137,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105137,37.74,0.46,353,44477,70,NULL,NULL,'2MASX J13062705+1144146',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000183,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,196.612875,11.73753,0.023,NULL,58963797775,921309340,14395458,17.3),(105138,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105138,36.55,0.46,205,44478,70,NULL,NULL,'MCG +10-19-028',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000167,NULL,'15.9g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,196.621375,56.63419,0.005,NULL,57443198349,897549974,14024218,15.9),(105139,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105139,36.18,0.54,172,44479,70,NULL,NULL,'2MASX J13062913-3010081',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.6b',NULL,'E',NULL,NULL,NULL,NULL,1,196.621417,-30.16897,0.353,NULL,43330250493,677035163,10578674,15.6),(105140,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105140,37.79,0.46,362,44480,70,NULL,NULL,'2MASX J13062913+0315269',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00007,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,196.6214583,3.2575,0.043,NULL,58112183722,908002870,14187544,18),(105141,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105141,36.76,0.46,225,44481,70,NULL,NULL,'2MASX J13062917+2637071',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,196.621583,26.61853,0,NULL,58699492107,917179564,14330930,17.3),(105142,'IRAS','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105142,33.04,0.8,40.5,44482,75,NULL,'MAT, I','ESO 269- G 048',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'15.59',0.5,'SB(s)dm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,196.624417,-44.16731,0.505,NULL,46728845985,730138218,11408409,15.59),(105143,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105143,32.44,0.32,30.8,44482,85,NULL,'I, inv','ESO 269- G 048',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105144,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105144,32.47,0.32,31.2,44482,85,NULL,'I, raw','ESO 269- G 048',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105145,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105145,32.79,0.43,36.1,44482,75,NULL,'MAT, I, inv','ESO 269- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105146,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105146,32.82,0.43,36.6,44482,75,NULL,'MAT, I, raw','ESO 269- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105147,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105147,33.13,0.43,42.3,44482,75,NULL,'MAT, I, cor','ESO 269- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105148,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105148,33.39,0.11,47.7,44482,NULL,NULL,NULL,'ESO 269- G 048',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105149,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105149,36.95,0.46,245,44483,70,NULL,NULL,'2MASX J13063008+0848476',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,196.625417,8.81336,0.024,NULL,58968364614,921380697,14396573,17.1),(105150,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105150,37.35,0.46,295,44484,70,NULL,NULL,'2MASX J13063046+5631019',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000143,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,196.62675,56.51733,0.005,NULL,57443108799,897548574,14024196,17.5),(105151,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105151,37.73,0.33,352,44485,70,NULL,NULL,'SDSS J130630.82+112000.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,196.628417,11.33344,0.006,NULL,58967445178,921366330,14396348,17.9),(105152,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105152,37.91,0.33,382,44486,70,NULL,NULL,'SDSS J130633.55+361555.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000145,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,196.639833333,36.26542,0,NULL,59291179160,926424674,14475385,18.6),(105153,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105153,36.37,0.46,188,44487,70,NULL,NULL,'2MASX J13063419+0408369',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000178,NULL,'16.1g',0.32,'S0',NULL,NULL,NULL,NULL,1,196.642375,4.14361,0.023,NULL,58110363877,907974435,14187100,16.1),(105154,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105154,37.56,0.46,326,44488,70,NULL,NULL,'2MASX J13063421+1800030',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,196.642667,18.00069,0.07,NULL,59033137751,922392777,14412387,17.8),(105155,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105155,38.17,0.46,430,44489,70,NULL,NULL,'2MASX J13063596+6526577',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000085,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,196.6497917,65.44944,0.045,NULL,57349323821,896083184,14001299,17.7),(105156,'SNIa','2016-12-15 15:15:10','2016-12-16 11:20:22','1','SN 1962A',NULL,105156,34.6,0.36,81,44490,NULL,NULL,NULL,'KUG 1304+281',NULL,'1992ApJ...390L..45P',1992,1,0.76,NULL,'G',0.00005,NULL,'16.38',0.37,'E/S0           Sbrst',NULL,NULL,NULL,NULL,1,196.651625,27.87294,0.036,NULL,58705532578,917273946,14332405,16.38),(105157,'SNIa','2016-12-15 15:15:10','2016-12-16 11:20:22','1','SN 1962A',NULL,105157,35,0.3,100,44490,NULL,NULL,'Photographic','KUG 1304+281',NULL,'1982ApJ...254....1A',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105158,'SNIa','2016-12-15 15:15:10','2016-12-16 11:20:22','1','SN 1962A',NULL,105158,35,0.4,100,44490,60,NULL,'M(B) = -19.48 mag','KUG 1304+281',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105159,'SNIa','2016-12-15 15:15:10','2016-12-16 11:20:22','1','SN 1962A',NULL,105159,35.05,0.2,102,44490,NULL,NULL,NULL,'KUG 1304+281',NULL,'1990ApJ...350..110C',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105160,'SNIa','2016-12-15 15:15:10','2016-12-16 11:20:22','1','SN 1962A',NULL,105160,35.11,0.4,105,44490,60,NULL,'M(V) = -19.47 mag','KUG 1304+281',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105161,'SNIa','2016-12-15 15:15:10','2016-12-16 11:20:22','1','SN 1962A','R',105161,35.54,NULL,128,44490,NULL,NULL,'Photographic','KUG 1304+281',NULL,'1988SSRv...48....1R',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105162,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105162,37.64,0.33,337,44491,70,NULL,NULL,'2MASX J13063647+1453198',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000142,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,196.652,14.88892,0.019,NULL,59051908665,922686072,14416969,17.9),(105163,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105163,35.17,0.33,108,44492,70,NULL,NULL,'CGCG 294-015',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.00011,NULL,'15.0g',0.44,'E0',NULL,NULL,NULL,NULL,1,196.6539583,58.76422,0.005,NULL,57439084781,897485699,14023214,15),(105164,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105164,37.68,0.46,343,44493,70,NULL,NULL,'2MASX J13063714+6422327',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000075,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,196.655125,64.37594,0.029,NULL,57352851328,896138302,14002160,17.1),(105165,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105165,38.51,0.46,504,44494,70,NULL,NULL,'SDSS J130637.29+583217.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000147,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,196.655417,58.53833,0,NULL,57441950031,897530469,14023913,18.6),(105166,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105166,32.92,0.83,38.4,44495,NULL,NULL,'Malmquist cor.','VV 841',NULL,'2009ApJS..182..474S',2009,1,0.75,'Eccentric nucleus; similar to NGC 2537.','G',0.00001,NULL,'15.5g',0.43,'Irr            Sbrst','Group non-member, foreground',NULL,NULL,NULL,1,196.659,28.84847,0.028,NULL,58706701551,917292211,14332690,15.5),(105167,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105167,32.94,0.82,38.7,44495,NULL,NULL,NULL,'VV 841',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105168,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105168,33.12,0.2,42.1,44495,74.4,NULL,NULL,'VV 841',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105169,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105169,38.13,0.27,422,44496,70,NULL,NULL,'2MASX J13063829+4546275',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00016,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,196.659583,45.77425,0,NULL,59101704008,923464125,14429126,17.1),(105170,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105170,38.11,0.46,419,44497,70,NULL,NULL,'SDSS J130638.63+001028.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000067,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,196.6609583,0.17469,0.006,NULL,58086975031,907608984,14181390,18.6),(105171,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105171,37.86,0.46,373,44498,70,NULL,NULL,'2MASX J13064140+6737186',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000085,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,196.672375,67.62186,0.033,NULL,57909152721,904830511,14137976,17.1),(105172,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105172,37.54,0.33,322,44499,70,NULL,NULL,'2MASX J13064231-0058255',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000094,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,196.6762083,-0.97364,0.009,NULL,43143226550,674112914,10533014,16.5),(105173,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105173,37.85,0.46,372,44500,70,NULL,NULL,'SDSS J130643.84+135550.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000163,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,196.6827083,13.93072,0.018,NULL,59049891299,922654551,14416477,18.4),(105174,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105174,36.8,0.46,229,44501,70,NULL,NULL,'SDSS J130643.85+004144.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000067,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,196.68275,0.69564,0,NULL,58103784824,907871637,14185494,17.6),(105175,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105175,37.36,0.46,297,44502,70,NULL,NULL,'2MASX J13064503-0150145',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000072,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,196.6877917,-1.83742,0,NULL,43145213636,674143963,10533499,17),(105176,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105176,38.54,0.33,509,44503,70,NULL,NULL,'2MASX J13064568+6105436',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,196.690333,61.09558,0.005,NULL,57384878573,896638727,14009980,17.7),(105177,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105177,37.48,0.46,314,44504,70,NULL,NULL,'2MASX J13064610+3929450',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000175,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,196.692083,39.49583,0,NULL,59304538610,926633415,14478647,17.9),(105178,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105178,36.77,0.46,226,44505,70,NULL,NULL,'2MASX J13064727+1631592',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.16',0.14,NULL,NULL,NULL,NULL,NULL,1,196.697083,16.53322,0.022,NULL,59054447118,922725736,14417589,18.16),(105179,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105179,37.54,0.46,322,44506,70,NULL,NULL,'2MASX J13064748+3928430',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,196.6977083,39.47881,0,NULL,59304536643,926633385,14478646,17),(105180,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105180,37.64,0.33,337,44507,70,NULL,NULL,'2MASX J13064793+1452482',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000191,NULL,'16.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,196.6995,14.88011,0.016,NULL,59051921836,922686278,14416973,16.4),(105181,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105181,35.72,0.46,139,44508,70,NULL,NULL,'2MASX J13064910+5003267',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000174,NULL,'15.7g',0.43,'E0',NULL,NULL,NULL,NULL,1,196.704375,50.05753,0,NULL,59090787181,923293549,14426461,15.7),(105182,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105182,37.27,0.46,284,44509,70,NULL,NULL,'2MASX J13064908+1423242',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.88',0.2,NULL,NULL,NULL,NULL,NULL,1,196.7045,14.39008,0.015,NULL,59050215863,922659622,14416556,17.88),(105183,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105183,38.06,0.33,409,44510,70,NULL,NULL,'2MASX J13064916+0551498',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,196.70475,5.86392,0.012,NULL,58074555540,907414930,14178358,18.1),(105184,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105184,36.07,0.46,164,44511,70,NULL,NULL,'CGCG 044-002',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00007,NULL,'15.5',0.27,NULL,NULL,NULL,NULL,NULL,1,196.70775,7.44406,0.068,NULL,58963177630,921299650,14395307,15.5),(105185,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105185,36.61,0.46,210,44512,70,NULL,NULL,'2MASX J13065017+1955080',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'17.23',0.16,NULL,NULL,NULL,NULL,NULL,1,196.7089583,19.91869,NULL,NULL,59032714354,922386161,14412283,17.23),(105186,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105186,35.47,0.19,124,44513,70,NULL,NULL,'GIN 308',NULL,'2001MNRAS.321..277C',2001,1,0.44,NULL,'G',0.00011,NULL,'16.0g',0.31,'E/S0',NULL,NULL,NULL,NULL,1,196.711875,53.54694,0.061,NULL,57413907443,897092303,14017067,16),(105187,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105187,36.91,0.46,241,44514,70,NULL,NULL,'2MASX J13065135+3201161',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,196.713833,32.02128,0.006,NULL,58685808436,916965756,14327589,17.1),(105188,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105188,37.95,0.46,389,44515,70,NULL,NULL,'LCRS B130416.8-030628',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000068,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,196.7149583,-3.37494,0,NULL,43139699053,674057797,10532153,17.7),(105189,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105189,38.29,0.46,456,44516,70,NULL,NULL,'2MASX J13065239+3336371',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000174,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,196.71825,33.61019,0,NULL,58672304637,916754759,14324293,16.9),(105190,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105190,35.91,0.27,152,44517,70,NULL,NULL,'MCG +10-19-032',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000162,NULL,'16.1g',0.42,'E0',NULL,NULL,NULL,NULL,1,196.718917,60.18775,0,NULL,57386325148,896661330,14010333,16.1),(105191,'Tully est','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105191,32.5,0.8,31.7,44518,75,NULL,NULL,'UGCA 324',NULL,'1988NBGC.C....0000T',1988,1,1.9,'Confused HIPASS source','G',0.000013,NULL,'13.12',1.5,'SB(rs)d        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,196.720916667,-28.55786,0.349,NULL,43338951537,677171117,10580798,13.12),(105192,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105192,32.77,0.4,35.9,44518,NULL,NULL,'mean','UGCA 324',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105193,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105193,32.83,0.47,36.8,44518,NULL,NULL,'H','UGCA 324',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105194,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105194,37.58,0.46,327,44519,70,NULL,NULL,'SDSS J130653.16-010158.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000065,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,196.7215,-1.03294,0.009,NULL,43143222600,674112853,10533013,18.2),(105195,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105195,38.48,0.46,496,44520,70,NULL,NULL,'SDSS J130654.65+084802.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.2g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,196.7277083,8.80083,0.024,NULL,58968311094,921379860,14396560,18.2),(105196,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105196,34.8,0.25,91.2,44521,74.4,NULL,NULL,'NGC 4971',NULL,'2013AJ....146...86T',2013,1,0.77,NULL,'G',0.00008,NULL,'14.6g',0.76,'S0?',NULL,NULL,NULL,NULL,1,196.729,28.54803,0.036,NULL,58706883148,917295049,14332735,14.6),(105197,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105197,36.66,0.46,215,44522,70,NULL,NULL,'2MASX J13065673+1853536',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00014,NULL,'16.27',0.23,NULL,NULL,NULL,NULL,NULL,1,196.7364583,18.89828,0.07,NULL,59034736134,922417752,14412777,16.27),(105198,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105198,34.76,0.57,89.7,44523,70,NULL,NULL,'ESO 575-IG 056 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.95,NULL,'G',0.000143,NULL,'15.63',0.46,NULL,NULL,NULL,NULL,NULL,1,196.737125,-20.24822,0.265,NULL,43979446770,687178855,10737169,15.63),(105199,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105199,37.76,0.46,357,44524,70,NULL,NULL,'2MASX J13065720+6739105',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000075,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,196.7385417,67.653,0.033,NULL,57909150987,904830484,14137976,18),(105200,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105200,37.54,0.33,322,44525,70,NULL,NULL,'2MASX J13065751-0101011',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000072,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,196.7395,-1.01683,0.013,NULL,43143223158,674112861,10533013,17.4),(105201,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105201,38.49,0.46,498,44526,70,NULL,NULL,'2MASX J13065772+3822122',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,196.740417,38.37011,0,NULL,59293664522,926463508,14475992,17.6),(105202,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105202,37.09,0.9,262,44527,70,NULL,NULL,'2MASX J13065783-1550126',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,196.7410417,-15.83683,0.081,NULL,44023328907,687864514,10747883,16.4),(105203,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105203,38.13,0.27,422,44528,70,NULL,NULL,'2MASX J13065814+4534255',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000178,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,196.742167,45.57364,0,NULL,59101557080,923461829,14429091,16.9),(105204,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105204,38.06,0.33,409,44529,70,NULL,NULL,'2MASX J13065915+0550118',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000166,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,196.7464583,5.83658,0,NULL,58074549090,907414829,14178356,16.8),(105205,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105205,36.04,0.49,161,44530,70,NULL,NULL,'2MASX J13065992-3728546',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000057,NULL,'15.4b',NULL,'E',NULL,NULL,NULL,NULL,1,196.749916667,-37.48236,0.261,NULL,46929930783,733280168,11457502,15.4),(105206,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105206,38.42,0.46,484,44531,70,NULL,NULL,'2MASX J13070067+5536435',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00018,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,196.752958333,55.61219,0.013,NULL,57425171280,897268301,14019817,17.8),(105207,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105207,35.45,0.46,123,44532,70,NULL,NULL,'2MASX J13070119+4618336',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000175,NULL,'16.3g',0.24,'AGN',NULL,NULL,NULL,NULL,1,196.7550417,46.30942,0,NULL,59101752191,923464877,14429138,16.3),(105208,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105208,37.64,0.33,337,44533,70,NULL,NULL,'2MASX J13070128+1916107',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'18.17',0.13,NULL,NULL,NULL,NULL,NULL,1,196.755458333,19.26956,0.062,NULL,59034689640,922417025,14412766,18.17),(105209,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105209,36.73,0.33,222,44534,70,NULL,NULL,'VIII Zw 239 NED01',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'15.8g',0.42,NULL,NULL,NULL,NULL,NULL,1,196.756417,9.61792,0,NULL,58968119165,921376861,14396513,15.8),(105210,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105210,36.83,0.46,232,44535,70,NULL,NULL,'2MASX J13070165+2126147',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,196.756833333,21.43744,0.042,NULL,58819810987,919059546,14360305,16.3),(105211,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105211,36.73,0.33,222,44536,70,NULL,NULL,'VIII Zw 239 NED02',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,'PRED','17.78',0.19,NULL,NULL,NULL,NULL,NULL,1,196.763666667,9.61469,0,NULL,58968119292,921376863,14396513,17.78),(105212,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105212,38.54,0.33,509,44537,70,NULL,NULL,'2MASX J13070350+6108196',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,196.764583,61.13897,0.005,NULL,57384880513,896638758,14009980,18),(105213,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105213,38.2,0.46,437,44538,70,NULL,NULL,'2MASX J13070352+5434305',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,196.764667,54.57528,0,NULL,57425950253,897280472,14020007,17.7),(105214,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105214,35.91,0.27,152,44539,70,NULL,NULL,'2MASX J13070488+6025576',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000173,NULL,'16.0g',0.33,'S0^-',NULL,NULL,NULL,NULL,1,196.770417,60.43272,0,NULL,57386407171,896662612,14010353,16),(105215,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105215,37.59,0.46,330,44540,70,NULL,NULL,'2MASX J13070625-0220421',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000068,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,196.775917,-2.34517,0.009,NULL,43145662969,674150983,10533609,18),(105216,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105216,37.9,0.46,380,44541,70,NULL,NULL,'2MASX J13070656+5549515',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000172,NULL,'17.0g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,196.777667,55.83083,0.013,NULL,57424453356,897257083,14019641,17),(105217,'IRAS','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105217,33.04,0.8,40.5,44542,75,NULL,'HMCL, I','UGCA 325',NULL,'1997ApJS..109..333W',1997,1,1.5,'MCG notes this as possibly interacting.','G',NULL,NULL,'15.13',1,'SB(s)d:',NULL,NULL,NULL,NULL,1,196.779583,-24.11194,0.289,NULL,43311476870,676741826,10574091,15.13),(105218,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105218,32.16,0.38,27,44542,NULL,NULL,NULL,'UGCA 325',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105219,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105219,32.41,0.4,30.3,44542,75,NULL,'HMCL, I, inv','UGCA 325',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105220,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105220,32.45,0.4,30.8,44542,75,NULL,'HMCL, I, raw','UGCA 325',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105221,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105221,32.7,0.4,34.7,44542,75,NULL,'HMCL, I, cor','UGCA 325',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105222,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105222,38.43,0.46,484,44543,70,NULL,NULL,'SDSS J130708.76+185917.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,196.786541667,18.98811,0.07,NULL,59034744010,922417875,14412779,18.3),(105223,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105223,37.39,0.33,301,44544,70,NULL,NULL,'2MASX J13070889+1741183',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,196.787041667,17.6885,0.058,NULL,59040687895,922510748,14414230,17.6),(105224,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105224,37.2,0.69,275,44545,70,NULL,NULL,'2MASX J13070890-3140473',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.5b',NULL,'S0',NULL,NULL,NULL,NULL,1,196.787083,-31.67983,0.329,NULL,43335490834,677117044,10579953,16.5),(105225,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105225,37.97,0.46,393,44546,70,NULL,NULL,'VIII Zw 238 NED03',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,196.788417,-0.02972,0.012,NULL,43109057945,673579030,10524672,17),(105226,'Tully est','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105226,32.54,0.8,32.2,44547,75,NULL,NULL,'NGC 4965',NULL,'1988NBGC.C....0000T',1988,1,2.6,'Confused HIPASS source','G',0.000017,NULL,'12.75',2,'SAB(s)d        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,196.789083333,-28.22819,0.297,NULL,43338334113,677161470,10580647,12.75),(105227,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105227,32.87,0.4,37.5,44547,NULL,NULL,'mean','NGC 4965',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105228,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105228,33.35,0.46,46.7,44547,NULL,NULL,'J','NGC 4965',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105229,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105229,33.4,0.45,47.8,44547,NULL,NULL,'K','NGC 4965',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105230,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105230,33.41,0.47,48.2,44547,NULL,NULL,'H','NGC 4965',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105231,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105231,38.06,0.27,409,44548,70,NULL,NULL,'2MASX J13071193+1153163',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000201,NULL,'16.5g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,196.799667,11.88792,0.025,NULL,58993653728,921775839,14402747,16.5),(105232,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105232,37.54,0.46,322,44549,70,NULL,NULL,'SDSS J130712.99+610950.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000139,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,196.804125,61.16408,0.005,NULL,57384857770,896638402,14009975,18.4),(105233,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105233,37.39,0.33,301,44550,70,NULL,NULL,'SDSS J130713.42+174225.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.5g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,196.8059583,17.70703,0.058,NULL,59040688692,922510760,14414230,18.5),(105234,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105234,38.06,0.27,409,44551,70,NULL,NULL,'2MASX J13071356+1154023',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.58',0.16,NULL,NULL,NULL,NULL,NULL,1,196.806375,11.90069,0.025,NULL,58993655400,921775865,14402747,18.58),(105235,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105235,38.06,0.27,409,44552,70,NULL,NULL,'2MASX J13071363+1157193',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,196.80675,11.95544,0.025,NULL,58993644564,921775696,14402745,18.3),(105236,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105236,35.64,0.19,134,44553,70,NULL,NULL,'2MASX J13071386+5331246',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,196.808083,53.52336,0.061,NULL,57413908629,897092322,14017067,17),(105237,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105237,36.45,0.46,195,44554,70,NULL,NULL,'2MASX J13071411+2135307',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,196.808833333,21.59178,0.042,NULL,58819846935,919060108,14360314,16.3),(105238,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105238,37.91,0.33,382,44555,70,NULL,NULL,'SDSS J130714.31+091410.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,196.809625,9.23611,0.01,NULL,58968684439,921385694,14396651,18.2),(105239,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105239,35.79,0.5,144,44556,70,NULL,NULL,'2MASX J13071600-1543396',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.42',NULL,NULL,NULL,NULL,NULL,NULL,1,196.816667,-15.72783,0.045,NULL,44023345392,687864771,10747887,15.42),(105240,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105240,38.04,0.46,406,44557,70,NULL,NULL,'SDSS J130716.41+235617.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.0g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,196.818417,23.93822,0.047,NULL,58813643693,918963182,14358799,18),(105241,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105241,35.64,0.46,134,44558,70,NULL,NULL,'2MASX J13071646+4715296',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000169,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,196.81875,47.25814,0,NULL,59099209575,923425149,14428517,16.3),(105242,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105242,35.67,0.57,136,44559,70,NULL,NULL,'2MASX J13071654-1901397',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.09',NULL,NULL,NULL,NULL,NULL,NULL,1,196.8189583,-19.02789,0.213,NULL,43981419882,687209685,10737651,16.09),(105243,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105243,36.08,0.46,165,44560,70,NULL,NULL,'2MASX J13071694+1321527',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000113,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,196.8205417,13.36478,0.032,NULL,59050825412,922669147,14416705,16.8),(105244,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105244,38.35,0.46,467,44561,70,NULL,NULL,'2MASX J13071741+5427135',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00014,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,196.82275,54.45375,0,NULL,57425976360,897280880,14020013,18.2),(105245,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105245,35.61,0.55,132,44562,70,NULL,NULL,'2MASX J13071766-2058487',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,196.823667,-20.98019,0.241,NULL,43798048067,684344501,10692882,16.5),(105246,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105246,36.6,0.63,208,44563,70,NULL,NULL,'2MASX J13071821-2021157',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.39',NULL,NULL,NULL,NULL,NULL,NULL,1,196.825833,-20.3545,0.265,NULL,43798117035,684345578,10692899,16.39),(105247,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105247,37.38,0.46,299,44564,70,NULL,NULL,'LCRS B130444.0-022918',NULL,'2015arXiv151105856S',2015,1,0.51,'The APM image includes a star southeast of the galaxy.','G',0.000086,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,196.827833,-2.75528,0.017,NULL,43144751574,674136743,10533386,16.3),(105248,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105248,37.15,0.33,269,44565,70,NULL,NULL,'2MASX J13071894+0656311',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.73',0.19,NULL,NULL,NULL,NULL,NULL,1,196.829,6.94189,0.03,NULL,58960165648,921252588,14394571,17.73),(105249,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105249,37.91,0.33,382,44566,70,NULL,NULL,'2MASX J13071931+0914291',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,196.830583,9.24144,0.01,NULL,58968685821,921385715,14396651,17.6),(105250,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105250,37.36,0.46,297,44567,70,NULL,NULL,'2MASX J13071965-0213057',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000078,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,196.831917,-2.21825,0.009,NULL,43145631165,674150486,10533601,17.7),(105251,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105251,35.26,0.25,113,44568,74.4,NULL,NULL,'CGCG 271-010',NULL,'2013AJ....146...86T',2013,1,0.76,NULL,'G',0.000043,NULL,'14.9g',0.64,'E/S0','Group member',NULL,NULL,NULL,1,196.8409583,53.58683,0.044,NULL,57413898913,897092170,14017065,14.9),(105252,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105252,35.47,0.19,124,44568,70,NULL,NULL,'CGCG 271-010',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105253,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105253,35.64,0.19,134,44568,70,NULL,NULL,'CGCG 271-010',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105254,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105254,38.4,0.46,479,44569,70,NULL,NULL,'2MASX J13072217+0848221',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000195,NULL,'16.9g',0.32,NULL,NULL,NULL,NULL,NULL,1,196.842333,8.80617,0.024,NULL,58967853383,921372709,14396448,16.9),(105255,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105255,38.26,0.19,449,44570,70,NULL,NULL,'SDSS J130722.24+085737.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000145,NULL,'18.6g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,196.8427083,8.96039,0,NULL,58968596587,921384321,14396630,18.6),(105256,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105256,35.12,0.65,106,44571,70,NULL,NULL,'2MASX J13072268-1903327',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.16',NULL,NULL,NULL,NULL,NULL,NULL,1,196.844625,-19.05906,0.213,NULL,43981421010,687209703,10737651,16.16),(105257,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105257,37.46,0.46,311,44572,70,NULL,NULL,'2MASX J13072289+0044305',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000088,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,196.845333,0.74175,0.006,NULL,58104614272,907884598,14185696,16.6),(105258,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105258,37.52,0.46,320,44573,70,NULL,NULL,'SDSS J130723.86+300300.5',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.9g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,196.849417,30.05014,0.018,NULL,58675366819,916802606,14325040,16.9),(105259,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105259,34.02,0.49,63.6,44574,75,NULL,'IR','UGC 08203',NULL,'2011yCatp016004901K',2011,1,2.14,NULL,'G',0.000018,NULL,'15.7g',0.21,'Sd',NULL,NULL,NULL,NULL,1,196.85175,32.86272,0.008,NULL,58672627837,916759809,14324372,15.7),(105260,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105260,34.26,NULL,71,44574,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08203',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105261,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105261,34.26,NULL,71.2,44574,NULL,NULL,'Dipole + Quadrupole','UGC 08203',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105262,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105262,34.27,NULL,71.6,44574,NULL,NULL,'Dipole','UGC 08203',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105263,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105263,34.37,NULL,74.8,44574,NULL,NULL,NULL,'UGC 08203',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105264,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105264,34.42,0.48,76.5,44574,NULL,NULL,NULL,'UGC 08203',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105265,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105265,34.44,0.2,77.3,44574,74.4,NULL,NULL,'UGC 08203',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105266,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105266,34.6,0.44,83.3,44574,NULL,NULL,'Malmquist cor.','UGC 08203',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105267,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105267,38.77,0.33,568,44575,70,NULL,NULL,'SDSS J130725.51+651804.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000082,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,196.856375,65.30122,0.029,NULL,57349357929,896083717,14001308,18.7),(105268,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105268,37.99,0.46,397,44576,70,NULL,NULL,'2MASX J13072596+3433542',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000183,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,196.85825,34.56506,NULL,NULL,59160297042,924379641,14443431,16.8),(105269,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105269,37.04,0.46,256,44577,70,NULL,NULL,'2MASX J13072761+1846380',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.70',0.22,NULL,NULL,NULL,NULL,NULL,1,196.865167,18.77711,0.068,NULL,59034756716,922418073,14412782,17.7),(105270,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105270,36.14,0.33,169,44578,70,NULL,NULL,'2MASX J13072847+4520586',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,196.8684583,45.34961,0,NULL,59098131347,923408302,14428254,17.2),(105271,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105271,36.9,0.46,240,44579,70,NULL,NULL,'SDSS J130728.45+295506.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,196.868583333,29.91839,0,NULL,58675342496,916802226,14325034,17.7),(105272,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105272,36.57,0.46,206,44580,70,NULL,NULL,'2MASX J13072975+1243548',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000195,NULL,'17.2g',0.18,'AGN',NULL,NULL,NULL,NULL,1,196.873875,12.73203,0.014,NULL,58993355148,921771174,14402674,17.2),(105273,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105273,36.83,0.61,232,44581,70,NULL,NULL,'2MASX J13073000-3037185',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.6b',0.3,'E',NULL,NULL,NULL,NULL,1,196.875041667,-30.62183,0.293,NULL,43332297197,677067143,10579174,16.6),(105274,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105274,38.26,0.19,449,44582,70,NULL,NULL,'2MASX J13073114+0857351',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,196.879667,8.95975,0,NULL,58967888238,921373253,14396457,17.4),(105275,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105275,38.69,0.46,546,44583,70,NULL,NULL,'2MASX J13073125+3728043',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000154,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,196.880125,37.46775,0,NULL,59294784746,926481011,14476265,17),(105276,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105276,38.26,0.19,449,44584,70,NULL,NULL,'2MASX J13073134+0859381',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000204,NULL,'16.0g',0.46,NULL,NULL,NULL,NULL,NULL,1,196.880583,8.99386,0,NULL,58967890567,921373290,14396457,16),(105277,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105277,37.8,0.46,363,44585,70,NULL,NULL,'2MASX J13073136+0008335',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000068,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,196.8807917,0.14267,0.012,NULL,58103697947,907870280,14185473,18.2),(105278,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105278,37.15,0.33,269,44586,70,NULL,NULL,'2MASX J13073176+0655521',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,196.8822917,6.93131,0.03,NULL,58959677739,921244964,14394452,17.7),(105279,'IRAS','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105279,33,0.8,39.7,44587,75,NULL,'MAT, I','ESO 269- G 049',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'13.7b',0.8,'SB(r)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,196.8854583,-45.01389,0.369,NULL,46729765956,730152593,11408634,13.7),(105280,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105280,32.99,0.32,39.6,44587,85,NULL,'I, raw','ESO 269- G 049',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105281,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105281,33.01,0.32,40,44587,85,NULL,'I, inv','ESO 269- G 049',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105282,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105282,33.23,0.43,44.3,44587,75,NULL,'MAT, I, raw','ESO 269- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105283,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105283,33.38,0.4,47.4,44587,NULL,NULL,'mean','ESO 269- G 049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105284,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105284,33.38,0.43,47.5,44587,75,NULL,'MAT, I, inv','ESO 269- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105285,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105285,33.39,0.1,47.7,44587,NULL,NULL,NULL,'ESO 269- G 049',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105286,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105286,33.43,0.43,48.6,44587,75,NULL,'MAT, I, cor','ESO 269- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105287,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105287,33.91,0.46,60.6,44587,NULL,NULL,'J','ESO 269- G 049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105288,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105288,33.93,0.45,61.1,44587,NULL,NULL,'K','ESO 269- G 049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105289,'D-Sigma','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105289,33.06,0.4,41,44588,75,NULL,'Edat, raw','NGC 4970',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000117,NULL,'13.82',1,'S0^0^:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,196.890583,-24.00856,0.289,NULL,43794844211,684294440,10692100,13.82),(105290,'D-Sigma','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105290,33.3,0.4,45.7,44588,75,NULL,'Edat, cor','NGC 4970',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105291,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105291,33.15,0.49,42.7,44588,70,NULL,NULL,'NGC 4970',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105292,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105292,37.91,0.46,382,44589,70,NULL,NULL,'2MASX J13073376+0348205',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,196.890708333,3.80572,0.044,NULL,58110431946,907975499,14187117,17.5),(105293,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105293,38.1,0.46,416,44590,70,NULL,NULL,'SDSS J130733.88+614505.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000149,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,196.8912083,61.75147,0.013,NULL,57354772433,896168319,14002629,18.3),(105294,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105294,37.35,0.46,295,44591,70,NULL,NULL,'2MASX J13073401+1852330',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.19',0.17,NULL,NULL,NULL,NULL,NULL,1,196.891625,18.87581,0.068,NULL,59034719161,922417486,14412773,18.19),(105295,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105295,36.06,0.46,163,44592,70,NULL,NULL,'CGCG 101-003',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00018,NULL,'15.4',0.6,NULL,NULL,NULL,NULL,NULL,1,196.891833333,16.35619,0.015,NULL,59054779470,922730929,14417670,15.4),(105296,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105296,37.22,0.7,278,44593,70,NULL,NULL,'2MASX J13073402-5131271',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,196.891875,-51.52411,1.113,NULL,44597540700,696836573,10888071,17.9),(105297,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105297,37.64,0.33,337,44594,70,NULL,NULL,'2MASX J13073415+1916590',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.49',0.14,NULL,NULL,NULL,NULL,NULL,1,196.892458333,19.28306,0.073,NULL,59034687012,922416984,14412765,18.49),(105298,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105298,37.74,0.33,352,44595,70,NULL,NULL,'2MASX J13073425+4635562',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,196.8927083,46.59883,0,NULL,59099134561,923423977,14428499,17.1),(105299,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105299,37.07,0.46,259,44596,70,NULL,NULL,'VIII Zw 241',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00008,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,196.896875,1.76347,0.08,NULL,58105297601,907895275,14185863,17.1),(105300,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105300,38.03,0.46,403,44597,70,NULL,NULL,'2MASX J13073523+4436222',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000174,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,196.897,44.60617,0,NULL,59098726849,923417607,14428400,17.7),(105301,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105301,38.26,0.19,449,44598,70,NULL,NULL,'2MASX J13073532+0857301',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,196.897125,8.95836,0,NULL,58967889553,921373274,14396457,17.8),(105302,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105302,35.56,0.46,130,44599,70,NULL,NULL,'2MASX J13073616+5748453',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000162,NULL,'15.9g',0.33,'S0^-',NULL,NULL,NULL,NULL,1,196.90075,57.81256,0,NULL,57441561107,897524392,14023818,15.9),(105303,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105303,36.77,0.46,226,44600,70,NULL,NULL,'SDSS J130736.60+061720.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.16',0.14,NULL,NULL,NULL,NULL,NULL,1,196.9025417,6.28894,0.028,NULL,58959588813,921243575,14394430,18.16),(105304,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105304,35.91,0.27,152,44601,70,NULL,NULL,'IC 0852',NULL,'2015arXiv151105856S',2015,1,0.95,NULL,'G',0.00009,NULL,'14.5g',0.73,'S0-:',NULL,NULL,NULL,NULL,1,196.903167,60.15719,0,NULL,57386285164,896660705,14010323,14.5),(105305,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105305,36.33,0.46,184,44602,70,NULL,NULL,'2MASX J13073773+4521443',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000161,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,196.907125,45.36242,0,NULL,59098132894,923408326,14428255,16.8),(105306,'BL Lac Luminosity','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105306,38.05,NULL,407,44603,NULL,NULL,'Min. z = 0.1','1FGL J1307.6-4259',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,196.91,-43,0.369,NULL,46749816277,730465879,11413529,NULL),(105307,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105307,37.07,0.46,260,44604,70,NULL,NULL,'LCRS B130503.4-032330',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00008,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,196.910083333,-3.65839,0.005,NULL,43140330213,674067659,10532307,17.5),(105308,'SNII optical','2016-12-15 15:15:10','2016-12-16 11:20:22','1','SN 2003cn',NULL,105308,34.31,0.13,72.8,44605,NULL,NULL,'I, photospheric magnitude method','IC 0849',NULL,'2014AJ....148..107R',2014,1,0.98,NULL,'G',0.00003,NULL,'14.2g',0.89,'SAB(rs)cd pec?',NULL,NULL,NULL,NULL,1,196.911208333,-0.94247,0.017,NULL,43143238353,674113099,10533017,14.2),(105309,'SNII optical','2016-12-15 15:15:10','2016-12-16 11:20:22','1','SN 2003cn',NULL,105309,34.34,0.16,73.8,44605,NULL,NULL,'V, photospheric magnitude method','IC 0849',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105310,'SNII optical','2016-12-15 15:15:10','2016-12-16 11:20:22','1','SN 2003cn',NULL,105310,34.77,0.42,89.9,44605,NULL,NULL,'SCM, B','IC 0849',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105311,'SNII optical','2016-12-15 15:15:10','2016-12-16 11:20:22','1','SN 2003cn',NULL,105311,34.81,0.28,91.6,44605,NULL,NULL,'SCM, BVI','IC 0849',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105312,'SNII optical','2016-12-15 15:15:10','2016-12-16 11:20:22','1','SN 2003cn',NULL,105312,34.85,0.54,93.3,44605,NULL,NULL,'SCM, I','IC 0849',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105313,'SNII optical','2016-12-15 15:15:10','2016-12-16 11:20:22','1','SN 2003cn',NULL,105313,34.86,0.55,93.8,44605,NULL,NULL,'SCM, V','IC 0849',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105314,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105314,36.38,0.46,188,44606,70,NULL,NULL,'2MASX J13073891+1747368',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,196.912166667,17.79344,0.058,NULL,59040702815,922510981,14414234,17.1),(105315,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105315,36.93,0.33,243,44607,70,NULL,NULL,'2MASX J13073937+1401548',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000179,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,196.914083,14.03181,0.014,NULL,59051491141,922679549,14416867,16.7),(105316,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105316,37.21,0.46,277,44608,70,NULL,NULL,'2MASX J13073949+4402443',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000141,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,196.914583,44.0455,0,NULL,59097790446,923402975,14428171,17.4),(105317,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105317,36.91,0.46,241,44609,70,NULL,NULL,'2MASX J13074014-0221297',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000086,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,196.9172083,-2.35833,0.005,NULL,43144828714,674137948,10533405,16.4),(105318,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105318,38.1,0.46,417,44610,70,NULL,NULL,'SDSS J130740.55+162203.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'19.05',0.13,NULL,NULL,NULL,NULL,NULL,1,196.919,16.36769,0.015,NULL,59054777069,922730891,14417670,19.05),(105319,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105319,37.78,0.46,359,44611,70,NULL,NULL,'SDSS J130741.12+001853.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000072,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,196.921333,0.31489,0,NULL,58057589394,907149834,14174216,18.5),(105320,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105320,37.57,0.46,327,44612,70,NULL,NULL,'2MASX J13074120+2614159',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.55',0.16,NULL,NULL,NULL,NULL,NULL,1,196.9217083,26.23781,0.012,NULL,58692012151,917062689,14329104,18.55),(105321,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105321,37.6,0.46,331,44613,70,NULL,NULL,'2MASX J13074160+6356575',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000073,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,196.923125,63.94936,0.037,NULL,57351901538,896123461,14001929,17.5),(105322,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105322,36.92,0.46,242,44614,70,NULL,NULL,'2MASX J13074232+0313155',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000009,NULL,'16.5g',0.27,'HII',NULL,NULL,NULL,NULL,1,196.9264583,3.22097,0.045,NULL,58110008084,907968876,14187013,16.5),(105323,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105323,38.46,0.46,491,44615,70,NULL,NULL,'SDSS J130742.63+143623.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,196.927667,14.60639,0.023,NULL,59050584365,922665380,14416646,18.2),(105324,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105324,32.68,0.4,34.4,44616,NULL,NULL,'mean','ESO 382- G 011',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000028,NULL,'16.10',0.2,'S0',NULL,NULL,NULL,NULL,1,196.927791667,-33.55928,0.257,NULL,43320577127,676884017,10576312,16.1),(105325,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105325,34.37,0.45,74.9,44616,NULL,NULL,'K','ESO 382- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105326,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105326,37.74,0.33,352,44617,70,NULL,NULL,'2MASX J13074279+4633513',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,196.928167,46.56419,0,NULL,59099121385,923423771,14428496,17.7),(105327,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105327,33.42,0.43,48.3,44618,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4979',NULL,'2014MNRAS.444..527S',2014,1,1,NULL,'G',0.00002,NULL,'14.83',0.7,'Sbc',NULL,NULL,NULL,NULL,1,196.928417,24.81058,0.04,NULL,58693612003,917087687,14329495,14.83),(105328,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105328,33.56,0.43,51.6,44618,75,NULL,'3.6 micron, color corrected','NGC 4979',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105329,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105329,33.74,0.2,56,44618,74.4,NULL,NULL,'NGC 4979',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105330,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105330,35.08,0.08,104,44618,NULL,NULL,NULL,'NGC 4979',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105331,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105331,34.76,0.46,89.4,44619,70,NULL,NULL,'MCG -02-34-001',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00012,NULL,'14.75',0.4,NULL,NULL,NULL,NULL,NULL,1,196.932041667,-12.55914,0.073,NULL,43965383027,686959109,10733736,14.75),(105332,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105332,36.96,0.46,247,44620,70,NULL,NULL,'2MASX J13074447+4521073',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00017,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,196.935125,45.35208,0,NULL,59098136089,923408376,14428255,16.7),(105333,'IRAS','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105333,32.71,0.8,34.8,44621,75,NULL,'HMCL, I','UGCA 327',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000019,NULL,'14.39',0.5,'SB(s)d: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,196.9369583,-22.85786,0.269,NULL,43804032394,684438006,10694343,14.39),(105334,'IRAS','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105334,32.71,0.8,34.9,44621,75,NULL,'MAT, I','UGCA 327',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105335,'Tully est','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105335,32.85,0.8,37.1,44621,75,NULL,NULL,'UGCA 327',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105336,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105336,32.04,0.2,25.6,44621,74.4,NULL,NULL,'UGCA 327',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105337,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105337,32.14,0.38,26.8,44621,NULL,NULL,NULL,'UGCA 327',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105338,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105338,32.21,0.43,27.6,44621,75,NULL,'3.6 micron, color corrected','UGCA 327',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105339,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105339,32.21,0.4,27.7,44621,75,NULL,'HMCL, I, raw','UGCA 327',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105340,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105340,32.25,0.32,28.2,44621,85,NULL,'I, raw','UGCA 327',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105341,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105341,32.26,0.32,28.3,44621,85,NULL,'I, inv','UGCA 327',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105342,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105342,32.26,0.4,28.3,44621,75,NULL,'HMCL, I, inv','UGCA 327',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105343,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105343,32.28,0.43,28.5,44621,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 327',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105344,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105344,32.41,0.43,30.4,44621,75,NULL,'MAT, I, raw','UGCA 327',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105345,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105345,32.47,0.4,31.2,44621,75,NULL,'HMCL, I, cor','UGCA 327',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105346,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105346,32.49,0.43,31.5,44621,75,NULL,'MAT, I, inv','UGCA 327',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105347,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105347,32.69,0.43,34.6,44621,75,NULL,'MAT, I, cor','UGCA 327',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105348,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105348,33.3,0.15,45.8,44621,NULL,NULL,NULL,'UGCA 327',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105349,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105349,37.55,0.46,323,44622,70,NULL,NULL,'2MASX J13074511+4455343',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,196.938083,44.92608,0,NULL,59098754055,923418032,14428406,17.1),(105350,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105350,36.91,0.46,241,44623,70,NULL,NULL,'2MASX J13074540+0712073',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.00',0.15,NULL,NULL,NULL,NULL,NULL,1,196.9392083,7.20192,0.007,NULL,58959694385,921245224,14394456,18),(105351,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105351,37.2,0.46,276,44624,70,NULL,NULL,'2MASX J13074551+6205275',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000143,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,196.9397083,62.09097,0.013,NULL,57354425357,896162896,14002545,18),(105352,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105352,38.48,0.46,496,44625,70,NULL,NULL,'SDSS J130745.68+204827.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'19.01',0.15,NULL,NULL,NULL,NULL,NULL,1,196.940375,20.80756,0.074,NULL,58810602435,918915663,14358057,19.01),(105353,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105353,37.37,0.33,297,44626,70,NULL,NULL,'2MASX J13074645+1258592',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000152,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,196.943583,12.98317,0.015,NULL,58993182187,921768471,14402632,17.3),(105354,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105354,37.21,0.46,276,44627,70,NULL,NULL,'SDSS J130746.62+494509.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000166,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,196.944333,49.75269,0,NULL,59092728170,923323877,14426935,18.1),(105355,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105355,37.8,0.46,363,44628,70,NULL,NULL,'2MASX J13074679+2606464',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,196.945125,26.11289,0.012,NULL,58692341211,917067831,14329184,17),(105356,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105356,38.01,0.46,400,44629,70,NULL,NULL,'SDSS J130747.38-010354.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000078,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,196.9474583,-1.06511,0.017,NULL,43088560295,673258754,10519668,18),(105357,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105357,36.25,0.46,178,44630,70,NULL,NULL,'2MASX J13074737+3459160',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,196.9474583,34.98781,0,NULL,59159937386,924374021,14443344,17.2),(105358,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105358,35,0.46,99.9,44631,70,NULL,NULL,'CGCG 316-010',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000159,NULL,'15.3g',0.5,'Sa','Group member',NULL,NULL,NULL,1,196.953041667,62.34722,0,NULL,57354264479,896160382,14002505,15.3),(105359,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105359,37.73,0.23,351,44632,70,NULL,NULL,'2MASX J13074985-0116077',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000213,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,196.957625,-1.26867,0.017,NULL,43088356206,673255565,10519618,17.1),(105360,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105360,34.53,0.49,80.4,44633,75,NULL,'IR','IC 0850',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.000017,NULL,'15.2',0.2,'Sd pec sp',NULL,NULL,NULL,NULL,1,196.959291667,-0.86844,0.017,NULL,43088536209,673258378,10519662,15.2),(105361,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105361,33.9,0.47,60.3,44634,70,NULL,NULL,'NGC 4975',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.02',0.6,'SAB(rs)0^0^ pec?',NULL,NULL,NULL,NULL,1,196.959167,-5.01747,0.033,NULL,43138863180,674044737,10531949,15.02),(105362,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105362,38.03,0.46,403,44635,70,NULL,NULL,'2MASX J13075016+3314400',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000176,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,196.9592083,33.24453,0,NULL,58672447999,916756999,14324328,18.1),(105363,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105363,38.16,0.46,428,44636,70,NULL,NULL,'2MASX J13075048+4611463',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,196.96025,46.19625,0,NULL,59101537541,923461524,14429086,17.4),(105364,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105364,34.73,0.46,88.4,44637,70,NULL,NULL,'NGC 4978',NULL,'2015arXiv151105856S',2015,1,1.5,NULL,'G',0.000147,NULL,'14.12',0.8,'S0/a',NULL,NULL,NULL,NULL,1,196.9605417,18.4155,0.047,NULL,59034192554,922409258,14412644,14.12),(105365,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105365,37.28,0.46,285,44638,70,NULL,NULL,'2MASX J13075051+5501394',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00018,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,196.960917,55.02772,0.021,NULL,57428036476,897313069,14020516,16.7),(105366,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105366,37.31,0.46,290,44639,70,NULL,NULL,'2MASX J13075170+1434543',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000191,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,196.965583,14.58175,0.023,NULL,59050615827,922665872,14416654,16.9),(105367,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105367,37.91,0.46,382,44640,70,NULL,NULL,'2MASX J13075244+1836100',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,196.968583,18.60278,0.065,NULL,59034216517,922409633,14412650,NULL),(105368,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105368,36.03,0.46,161,44641,70,NULL,NULL,'2MASX J13075319+4539203',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000163,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,196.971625,45.65575,0,NULL,59101573299,923462082,14429095,16.4),(105369,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105369,36.24,0.52,177,44642,70,NULL,NULL,'PKS 1305-315',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'16.0',0.6,'Elliptical',NULL,NULL,NULL,NULL,1,196.977917,-31.77819,0.289,NULL,43335430458,677116100,10579939,16),(105370,'SNIa','2016-12-15 15:15:10','2016-12-16 11:20:22','1','SN 2002G',NULL,105370,35.23,0.21,108,44643,74.2,NULL,'SALT 2','CGCG 189-024',0.033737,'2010ApJ...716..712A',2010,1,0.68,NULL,'G',0.00009,NULL,'14.8g',0.52,'E','Group member',NULL,NULL,NULL,1,196.978375,34.08711,NULL,NULL,59160163916,924377561,14443399,14.8),(105371,'SNIa','2016-12-15 15:15:10','2016-12-16 11:20:22','1','SN 2002G',NULL,105371,35.66,0.41,131,44643,65,NULL,'MLCS31','CGCG 189-024',0.033737,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105372,'SNIa','2016-12-15 15:15:10','2016-12-16 11:20:22','1','SN 2002G',NULL,105372,35.67,0.16,132,44643,70,NULL,'SALT 2','CGCG 189-024',0.033737,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105373,'SNIa','2016-12-15 15:15:10','2016-12-16 11:20:22','1','SN 2002G',NULL,105373,35.68,0.35,132,44643,65,NULL,'MLCS17','CGCG 189-024',0.033737,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105374,'SNIa','2016-12-15 15:15:10','2016-12-16 11:20:22','1','SN 2002G',NULL,105374,35.82,0.18,141,44643,73.8,NULL,'SALT 2 (SNANA)','CGCG 189-024',0.035,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105375,'SNIa','2016-12-15 15:15:10','2016-12-16 11:20:22','1','SN 2002G',NULL,105375,35.81,0.09,145,44643,74.4,NULL,NULL,'CGCG 189-024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105376,'SNIa','2016-12-15 15:15:10','2016-12-16 11:20:22','1','SN 2002G',NULL,105376,36.08,0.18,159,44643,65,NULL,'SALT','CGCG 189-024',0.033737,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105377,'SNIa','2016-12-15 15:15:10','2016-12-16 11:20:22','1','SN 2002G',NULL,105377,36.13,0.24,162,44643,65,NULL,'SALT2','CGCG 189-024',0.033737,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105378,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105378,36.93,0.33,243,44644,70,NULL,NULL,'2MASX J13075560+1403313',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000176,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,196.9817083,14.05856,0.014,NULL,59051483900,922679435,14416866,16.4),(105379,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105379,37.72,0.46,349,44645,70,NULL,NULL,'SDSS J130755.75+111803.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,196.9822917,11.30106,0,NULL,58963891285,921310801,14395481,17.9),(105380,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105380,29.49,0.4,7.9,44646,NULL,NULL,NULL,'MCG -03-34-002',NULL,'2013MNRAS.429.2677K',2013,1,0.4,NULL,'G',0.000013,NULL,'14.90',0.25,'Sbc',NULL,NULL,NULL,NULL,1,196.9860417,-16.68914,0.093,NULL,44009321726,687645651,10744463,14.9),(105381,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105381,29.49,NULL,7.91,44646,NULL,NULL,NULL,'MCG -03-34-002',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105382,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105382,37.91,0.13,382,44647,70,NULL,NULL,'SDSS J130757.01-014332.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000065,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,196.9875417,-1.72558,0.021,NULL,43089677415,673276209,10519940,18.3),(105383,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105383,37.84,0.46,370,44648,70,NULL,NULL,'2MASX J13075745-0158027',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00007,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,196.98925,-1.96736,0.005,NULL,43089776809,673277762,10519965,17.7),(105384,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105384,35.31,0.05,115,44649,70,NULL,NULL,'CGCG 160-145',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000077,NULL,'15.3g',0.49,'E',NULL,NULL,NULL,NULL,1,196.9912083,28.71064,0.02,NULL,58706326896,917286357,14332599,15.3),(105385,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105385,37.48,0.27,314,44650,70,NULL,NULL,'SDSS J130758.23+153532.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000132,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,196.992625,15.59233,0.017,NULL,59055345064,922739766,14417808,18.4),(105386,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105386,37.11,0.46,265,44651,70,NULL,NULL,'2MASX J13075831+0822154',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.27',0.19,NULL,NULL,NULL,NULL,NULL,1,196.992917,8.37097,0.025,NULL,58961367838,921271372,14394865,17.27),(105387,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105387,38.07,0.46,410,44652,70,NULL,NULL,'2MASX J13075838+6737309',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000082,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,196.993416667,67.62539,0.025,NULL,57909020246,904828441,14137944,17.6),(105388,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105388,37.37,0.46,298,44653,70,NULL,NULL,'2MASX J13075843+5607534',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,196.993917,56.13164,0.013,NULL,57416901524,897139086,14017798,18.1),(105389,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105389,36.27,0.46,179,44654,70,NULL,NULL,'2MASX J13075899+1558303',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.92',0.17,NULL,NULL,NULL,NULL,NULL,1,196.9959583,15.97511,0.014,NULL,59054914234,922733034,14417703,16.92),(105390,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105390,34.4,0.33,76,44655,70,NULL,NULL,'NGC 4987',NULL,'2015arXiv151105856S',2015,1,1.14,NULL,'G',0.00008,NULL,'14.1g',0.71,'E',NULL,NULL,NULL,NULL,1,196.996083333,51.92931,0,NULL,57197021289,893703457,13964116,14.1),(105391,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105391,37.85,0.46,372,44656,70,NULL,NULL,'2MASX J13075910+3328041',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000134,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,196.996417,33.46778,0,NULL,58672437953,916756843,14324325,17.9),(105392,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105392,38.77,0.33,568,44657,70,NULL,NULL,'SDSS J130800.40+652226.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000074,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,197.001667,65.37406,0.021,NULL,57349346758,896083543,14001305,18.1),(105393,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105393,36.74,0.7,222,44658,70,NULL,NULL,'2MASX J13080049-3722244',NULL,'2014MNRAS.445.2677S',2014,1,NULL,'6dF DR2 has z = 0.047625.','G',0.00015,NULL,'15.48',NULL,NULL,NULL,NULL,NULL,NULL,1,197.002,-37.37353,0.137,NULL,46929887700,733279495,11457492,15.48),(105394,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105394,36.5,0.46,200,44659,70,NULL,NULL,'CGCG 044-006',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.00014,NULL,'15.2g',0.51,'E0',NULL,NULL,NULL,NULL,1,197.006375,3.59906,0.044,NULL,58110902787,907982856,14187232,15.2),(105395,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105395,38.05,0.33,408,44660,70,NULL,NULL,'SDSS J130801.73+511954.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00013,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,197.0072083,51.33186,0,NULL,57195900576,893685946,13963842,18.2),(105396,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105396,36.33,0.46,185,44661,70,NULL,NULL,'2MASX J13080194+1516353',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.18',0.18,NULL,NULL,NULL,NULL,NULL,1,197.0082083,15.27647,0.014,NULL,59053330303,922708285,14417316,18.18),(105397,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105397,38.05,0.33,408,44662,70,NULL,NULL,'2MASX J13080217+5121149',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00018,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,197.009125,51.35414,0,NULL,57195899548,893685930,13963842,18),(105398,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105398,38.26,0.19,449,44663,70,NULL,NULL,'2MASX J13080241+0900044',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.00',0.19,NULL,NULL,NULL,NULL,NULL,1,197.010041667,9.00111,0,NULL,58967923985,921373812,14396465,18),(105399,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105399,36.83,0.46,232,44664,70,NULL,NULL,'2MASX J13080254+2518224',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.0001,NULL,'16.93',0.16,NULL,NULL,NULL,NULL,NULL,1,197.0107083,25.30636,0.029,NULL,58694102620,917095353,14329614,16.93),(105400,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105400,38.44,0.46,487,44665,70,NULL,NULL,'2MASX J13080269+0151364',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000092,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,197.011125,1.86014,0.08,NULL,58060078267,907188722,14174823,17.9),(105401,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105401,37.11,0.46,264,44666,70,NULL,NULL,'2MASX J13080280+1740083',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.60',0.16,NULL,NULL,NULL,NULL,NULL,1,197.011833333,17.66897,0.058,NULL,59040854055,922513344,14414271,18.6),(105402,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105402,38.2,0.46,437,44667,70,NULL,NULL,'2MASX J13080354+3359302',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,197.014667,33.99178,NULL,NULL,59158085024,924345078,14442891,17.8),(105403,'Brightest Stars','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105403,28.74,0.4,5.6,44668,NULL,NULL,'3B + 3R mean','UGC 08215',NULL,'1997AstL...23..656G',1997,1,1,'Multiple SDSS entries describe this source.','G',0.000001,NULL,'17.',0.7,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,197.015,46.82803,0,NULL,59099617568,923431524,14428617,17),(105404,'Brightest Stars','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105404,28.9,NULL,6.03,44668,NULL,NULL,'LF','UGC 08215',NULL,'1997AstL...23..656G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105405,'TRGB','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105405,27.87,0.12,3.75,44668,NULL,NULL,NULL,'UGC 08215',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105406,'TRGB','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105406,28.2,0.12,4.36,44668,NULL,NULL,NULL,'UGC 08215',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105407,'TRGB','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105407,28.24,0.08,4.44,44668,NULL,NULL,NULL,'UGC 08215',NULL,'2013AstBu..68..125M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105408,'TRGB','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105408,28.29,NULL,4.55,44668,NULL,NULL,NULL,'UGC 08215',NULL,'2006AJ....131.1361K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105409,'TRGB','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105409,28.3,0.06,4.57,44668,NULL,NULL,'I','UGC 08215',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105410,'TRGB','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105410,28.3,0.1,4.57,44668,74.4,NULL,NULL,'UGC 08215',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105411,'Tully est','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105411,27.96,0.8,3.9,44668,75,NULL,NULL,'UGC 08215',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105412,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105412,36.34,0.33,185,44669,70,NULL,NULL,'CGCG 189-026',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000093,NULL,'15.1g',0.52,'E','Group member',NULL,NULL,NULL,1,197.017375,34.00758,NULL,NULL,59158083907,924345061,14442891,15.1),(105413,'D-Sigma','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105413,33.06,0.4,41,44670,75,NULL,'Edat, raw','IC 4197',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00002,NULL,'13.92',0.9,'SAB0-    poss. LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,197.0180417,-23.79686,0.289,NULL,43795073624,684298025,10692156,13.92),(105414,'D-Sigma','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105414,33.3,0.4,45.7,44670,75,NULL,'Edat, cor','IC 4197',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105415,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105415,33.31,0.45,46,44670,NULL,NULL,'K','IC 4197',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105416,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105416,33.32,0.4,46,44670,NULL,NULL,'mean','IC 4197',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105417,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105417,38.72,0.46,554,44671,70,NULL,NULL,'2MASX J13080432+5832414',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000183,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,197.01825,58.54486,0,NULL,57441193132,897518642,14023728,17.7),(105418,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105418,38.14,0.33,425,44672,70,NULL,NULL,'2MASX J13080455+0014264',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000089,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,197.019083,0.24064,0.009,NULL,58057776536,907152758,14174261,17.4),(105419,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105419,37.78,0.81,360,44673,70,NULL,NULL,'2MASX J13080546-5128173',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,197.022666667,-51.47156,1.113,NULL,44597514336,696836161,10888065,16.5),(105420,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105420,37.61,0.46,332,44674,70,NULL,NULL,'2MASX J13080559+0839234',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'18.45',0.15,NULL,NULL,NULL,NULL,NULL,1,197.023417,8.65653,0.02,NULL,58960507811,921257934,14394655,18.45),(105421,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105421,38.6,0.33,524,44675,70,NULL,NULL,'2MASX J13080680+1917415',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.29',0.17,NULL,NULL,NULL,NULL,NULL,1,197.0282083,19.29472,0.073,NULL,59034396751,922412449,14412694,18.29),(105422,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105422,37.91,0.19,382,44676,70,NULL,NULL,'SDSS J130806.84+101959.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,197.0285417,10.33308,0,NULL,58967592534,921368633,14396384,17.8),(105423,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105423,38.6,0.33,524,44677,70,NULL,NULL,'SDSS J130808.07+191741.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,197.033667,19.29486,0.073,NULL,59034396783,922412449,14412694,18.4),(105424,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105424,35.9,0.46,151,44678,70,NULL,NULL,'2MASX J13080865+0432214',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00017,NULL,'16.0g',0.37,'S0',NULL,NULL,NULL,NULL,1,197.0362083,4.53917,0.013,NULL,58108472959,907944889,14186638,16),(105425,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105425,37.32,0.46,291,44679,70,NULL,NULL,'2MASX J13080897+5004541',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000153,NULL,'17.7g',0.19,'AGN',NULL,NULL,NULL,NULL,1,197.037333,50.08158,0,NULL,59092693868,923323341,14426927,17.7),(105426,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105426,37.46,0.46,310,44680,70,NULL,NULL,'2MASX J13080926+1527113',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,197.038583,15.45314,0.017,NULL,59053317682,922708088,14417313,17.5),(105427,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105427,38.1,0.46,418,44681,70,NULL,NULL,'SDSS J130809.70+053625.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000159,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,197.0404583,5.60706,0,NULL,58107951979,907936749,14186511,18.5),(105428,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105428,36.54,0.65,203,44682,70,NULL,NULL,'II SZ 004',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000113,NULL,'15.63',0.3,'E0',NULL,NULL,NULL,NULL,1,197.045291667,-12.98006,0.057,NULL,44011310613,687676728,10744948,15.63),(105429,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105429,37.73,0.23,351,44683,70,NULL,NULL,'2MASX J13081252-0116567',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000086,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,197.05225,-1.28231,0.017,NULL,43088355188,673255549,10519617,16.7),(105430,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105430,34.28,0.54,71.8,44684,70,NULL,NULL,'2MASX J13081256-1736077',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000113,NULL,'15.45',0.7,NULL,NULL,NULL,NULL,NULL,1,197.0524583,-17.60233,0.169,NULL,44009202323,687643786,10744434,15.45),(105431,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105431,36.34,0.33,185,44685,70,NULL,NULL,'2MASX J13081335+3357232',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000173,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,197.055666667,33.95636,NULL,NULL,59158078870,924344982,14442890,16.6),(105432,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105432,38.84,0.46,586,44686,70,NULL,NULL,'SDSS J130813.47-003757.0',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000083,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,197.056125,-0.63253,0,NULL,43089015181,673265862,10519779,18),(105433,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105433,33.66,NULL,54,44687,NULL,NULL,NULL,'FGC 1563',NULL,'2000BSAO...50....5K',2000,1,0.95,NULL,'G',0.000063,'?','16.7',0.12,'Sdm',NULL,NULL,NULL,NULL,1,197.057917,-16.23917,0.105,NULL,44022423873,687850373,10747662,16.7),(105434,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105434,33.84,NULL,58.5,44687,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1563',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105435,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105435,33.84,NULL,58.5,44687,NULL,NULL,'Dipole + Quadrupole','FGC 1563',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105436,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105436,33.84,NULL,58.7,44687,NULL,NULL,'Dipole','FGC 1563',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105437,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105437,38.17,0.46,431,44688,70,NULL,NULL,'2MASXi J1308139+333847',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,197.058125,33.64644,NULL,NULL,59158269820,924347965,14442936,17.9),(105438,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105438,35.8,0.49,144,44689,75,NULL,'IR','FGC 1565',NULL,'2011yCatp016004901K',2011,1,1.17,NULL,'G',0.000153,NULL,'16.2g',0.17,'Sbc',NULL,NULL,NULL,NULL,1,197.060083,43.92458,0,NULL,59097798010,923403093,14428173,16.2),(105439,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105439,35.96,NULL,156,44689,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1565',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105440,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105440,35.98,NULL,157,44689,NULL,NULL,'Dipole + Quadrupole','FGC 1565',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105441,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105441,36,NULL,159,44689,NULL,NULL,NULL,'FGC 1565',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105442,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105442,36.01,NULL,159,44689,NULL,NULL,'Dipole','FGC 1565',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105443,'IRAS','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105443,31.56,0.8,20.5,44690,75,NULL,'MAT, I','ESO 575- G 061',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00001,NULL,'16.04',0.11,'SBd: sp',NULL,NULL,NULL,NULL,1,197.065,-21.00222,0.229,NULL,43798366146,684349471,10692960,16.04),(105444,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105444,31.71,0.43,21.9,44690,75,NULL,'3.6 micron, color + selection bias corrected','ESO 575- G 061',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105445,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105445,31.79,NULL,22.8,44690,NULL,NULL,NULL,'ESO 575- G 061',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105446,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105446,32.07,0.32,26,44690,85,NULL,'I, inv','ESO 575- G 061',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105447,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105447,32.11,NULL,26.4,44690,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 575- G 061',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105448,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105448,32.11,NULL,26.4,44690,NULL,NULL,'Dipole + Quadrupole','ESO 575- G 061',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105449,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105449,32.12,0.32,26.6,44690,85,NULL,'I, raw','ESO 575- G 061',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105450,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105450,32.13,NULL,26.7,44690,NULL,NULL,'Dipole','ESO 575- G 061',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105451,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105451,32.29,0.43,28.7,44690,75,NULL,'3.6 micron, color corrected','ESO 575- G 061',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105452,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105452,32.43,0.63,30.6,44690,NULL,NULL,NULL,'ESO 575- G 061',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105453,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105453,32.5,0.43,31.6,44690,75,NULL,'MAT, I, inv','ESO 575- G 061',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105454,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105454,32.53,0.2,32.1,44690,74.4,NULL,NULL,'ESO 575- G 061',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105455,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105455,32.57,0.59,32.7,44690,NULL,NULL,'Malmquist cor.','ESO 575- G 061',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105456,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105456,32.61,0.43,33.3,44690,75,NULL,'MAT, I, raw','ESO 575- G 061',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105457,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105457,32.7,0.4,34.7,44690,NULL,NULL,NULL,'ESO 575- G 061',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105458,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105458,32.85,0.43,37.2,44690,75,NULL,'MAT, I, cor','ESO 575- G 061',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105459,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105459,35.86,0.59,149,44691,70,NULL,NULL,'2MASX J13081616-3801459',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,197.067291667,-38.02942,0.261,NULL,46927419831,733240934,11456889,15.2),(105460,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105460,37.35,0.46,295,44692,70,NULL,NULL,'2MASX J13081619+1003444',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,197.0675417,10.06222,0,NULL,58966470438,921351100,14396110,17.3),(105461,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105461,37.32,0.46,291,44693,70,NULL,NULL,'2MASX J13081677+0854524',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000192,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,197.069833333,8.91467,0.015,NULL,58967872242,921373003,14396453,16.4),(105462,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105462,37.46,0.46,311,44694,70,NULL,NULL,'SDSS J130816.79+180042.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,197.07,18.01183,0.066,NULL,59033032186,922391127,14412361,18.2),(105463,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105463,36.56,0.46,205,44695,70,NULL,NULL,'2MASX J13081701+2222545',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,197.070875,22.38194,0.05,NULL,58820058314,919063411,14360365,17.5),(105464,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105464,38.8,0.46,577,44696,70,NULL,NULL,'2MASX J13081735+1636429',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.94',0.13,NULL,NULL,NULL,NULL,NULL,1,197.072333,16.61208,0,NULL,59040393417,922506147,14414158,18.94),(105465,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105465,38.44,0.27,487,44697,70,NULL,NULL,'2MASX J13081783+1057274',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00018,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,197.07425,10.95769,0.006,NULL,58967473803,921366778,14396355,17.5),(105466,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105466,37.56,0.33,325,44698,70,NULL,NULL,'2MASX J13081841+6107392',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,197.076833,61.12761,0.009,NULL,57384834494,896638038,14009969,17.5),(105467,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105467,38.92,0.46,608,44699,70,NULL,NULL,'2MASX J13081976+3618279',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000159,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,197.082375,36.30783,0,NULL,59294402003,926475031,14476172,17.7),(105468,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105468,37.37,0.33,297,44700,70,NULL,NULL,'2MASX J13082001+1303439',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000183,NULL,'16.2g',0.42,'E0',NULL,NULL,NULL,NULL,1,197.083417,13.06217,0.015,NULL,59048177606,922627775,14416058,16.2),(105469,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105469,33.22,NULL,44,44701,NULL,NULL,NULL,'IC 4204',NULL,'2000BSAO...50....5K',2000,1,0.97,NULL,'G',0.00018,NULL,'15.6g',0.27,'SBcd?',NULL,NULL,NULL,NULL,1,197.089917,39.46117,0,NULL,59304483042,926632547,14478633,15.6),(105470,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105470,33.57,NULL,51.7,44701,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 4204',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105471,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105471,33.58,NULL,52.1,44701,NULL,NULL,'Dipole','IC 4204',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105472,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105472,33.58,NULL,52.1,44701,NULL,NULL,'Dipole + Quadrupole','IC 4204',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105473,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105473,33.62,0.49,53.1,44701,75,NULL,'IR','IC 4204',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105474,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105474,33.81,0.2,57.8,44701,74.4,NULL,NULL,'IC 4204',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105475,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105475,37.48,0.27,314,44702,70,NULL,NULL,'2MASX J13082206+1542209',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.89',0.28,NULL,NULL,NULL,NULL,NULL,1,197.091875,15.70575,0.011,NULL,59052998484,922703101,14417235,16.89),(105476,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105476,38.14,0.46,424,44703,70,NULL,NULL,'2MASX J13082207-0132258',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000297,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,197.091917,-1.54053,0.021,NULL,43089721792,673276903,10519951,17),(105477,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105477,38.65,0.46,538,44704,70,NULL,NULL,'SDSS J130822.61+295608.7',NULL,'2015arXiv151105856S',2015,1,0.11,NULL,'G',0.000178,NULL,'18.7g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,197.09425,29.93578,0.025,NULL,58675416643,916803385,14325052,18.7),(105478,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105478,38.1,0.46,416,44705,70,NULL,NULL,'2MASX J13082339+1406059',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,197.097333,14.10181,0.014,NULL,59050652696,922666448,14416663,17.8),(105479,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105479,38.01,0.46,400,44706,70,NULL,NULL,'2MASX J13082416+1226579',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,197.100833,12.44939,0.033,NULL,58993826549,921778539,14402789,17.6),(105480,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105480,33.23,0.69,44.3,44707,100,NULL,'mid-IR','NGC 4986',NULL,'2013ApJ...771...88L',2013,1,1.7,NULL,'G',0.000017,NULL,'14.02',0.9,'SB(r)b','in a radial-velocity based grouping',NULL,NULL,NULL,1,197.101916667,35.20644,0,NULL,59160000990,924375015,14443359,14.02),(105481,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105481,34.34,0.4,73.7,44707,NULL,NULL,'mean','NGC 4986',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105482,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105482,34.46,0.47,77.9,44707,NULL,NULL,'H','NGC 4986',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105483,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105483,34.56,0.46,81.6,44707,NULL,NULL,'J','NGC 4986',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105484,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105484,37.48,0.27,314,44708,70,NULL,NULL,'2MASX J13082448+1542589',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,197.102083,15.71642,0.011,NULL,59052994889,922703045,14417235,17.3),(105485,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105485,37.56,0.33,325,44709,70,NULL,NULL,'2MASX J13082478+6111302',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00018,NULL,'16.4g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,197.103083333,61.19192,0.009,NULL,57384805256,896637582,14009962,16.4),(105486,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105486,36.74,0.46,222,44710,70,NULL,NULL,'2MASX J13082496+5217562',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00017,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,197.104,52.299,0,NULL,57197410915,893709545,13964211,16.3),(105487,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105487,37.89,0.46,379,44711,70,NULL,NULL,'2MASX J13082604+3550339',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00017,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,197.1085,35.84267,0,NULL,59157001776,924328152,14442627,17.6),(105488,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105488,37.73,0.23,351,44712,70,NULL,NULL,'2MASX J13082620-0122528',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000071,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,197.1092917,-1.38147,0.025,NULL,43091760722,673308761,10520449,17.9),(105489,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105489,38.26,0.19,449,44713,70,NULL,NULL,'SDSS J130826.40+085419.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000142,NULL,'18.8g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,197.1100417,8.9055,0.015,NULL,58967942924,921374108,14396470,18.8),(105490,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105490,38.03,0.46,404,44714,70,NULL,NULL,'SDSS J130827.61+094426.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.8g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,197.115083,9.74072,0,NULL,58966516080,921351813,14396122,17.8),(105491,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105491,36.66,0.57,215,44715,70,NULL,NULL,'2MASX J13082768-3425288',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.19',NULL,NULL,NULL,NULL,NULL,NULL,1,197.115333,-34.42469,0.161,NULL,46862428319,732225442,11441022,15.19),(105492,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105492,37.84,0.46,370,44716,70,NULL,NULL,'SDSS J130827.86+321318.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,197.116125,32.22186,0.019,NULL,58684018222,916937784,14327152,18.1),(105493,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105493,36.52,0.46,201,44717,70,NULL,NULL,'2MASX J13082844+3920389',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000164,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,197.118708333,39.34414,0,NULL,59305184805,926643512,14478804,16.9),(105494,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105494,36.55,0.54,204,44718,70,NULL,NULL,'LCRS B130552.8-060610',NULL,'2014MNRAS.445.2677S',2014,1,0.71,NULL,'G',0.000147,NULL,'15.40',0.5,NULL,NULL,NULL,NULL,NULL,1,197.1192917,-6.36978,0.089,NULL,43847449743,685116402,10704943,15.4),(105495,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105495,35.8,0.72,144,44719,70,NULL,NULL,'LCRS B130551.7-121033',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000127,NULL,'15.40',0.2,NULL,NULL,NULL,NULL,NULL,1,197.123625,-12.44247,0.073,NULL,43965590639,686962353,10733786,15.4),(105496,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105496,38.17,0.46,430,44720,70,NULL,NULL,'SDSS J130830.17+184037.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.6g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,197.12575,18.67722,0.069,NULL,59034125970,922408218,14412628,18.6),(105497,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105497,36.89,0.46,239,44721,70,NULL,NULL,'2MASX J13083019+0315515',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,197.125833,3.26425,0.045,NULL,58054564477,907102569,14173477,17.3),(105498,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105498,38.76,0.46,564,44722,70,NULL,NULL,'SDSS J130830.84+142915.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,197.1285417,14.48772,0.023,NULL,59050599560,922665618,14416650,18.5),(105499,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105499,37.95,0.33,389,44723,70,NULL,NULL,'2MASX J13083133+3951229',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00013,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,197.130625,39.85636,0,NULL,59300187786,926565434,14477584,18.3),(105500,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105500,34.86,0.49,93.9,44724,75,NULL,'IR','IC 4202',NULL,'2011yCatp016004901K',2011,1,2.02,NULL,'G',0.000008,NULL,'15.26',0.22,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,197.131583,24.70078,0.033,NULL,58694011384,917093927,14329592,15.26),(105501,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105501,35.02,0.47,101,44724,NULL,NULL,'H','IC 4202',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105502,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105502,35.07,0.13,103,44724,NULL,NULL,NULL,'IC 4202',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105503,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105503,35.13,0.45,106,44724,NULL,NULL,'K','IC 4202',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105504,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105504,35.14,0.4,107,44724,NULL,NULL,'mean','IC 4202',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105505,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105505,35.15,0.46,107,44724,NULL,NULL,'J','IC 4202',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105506,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105506,35.18,NULL,109,44724,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 4202',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105507,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105507,35.19,NULL,109,44724,NULL,NULL,'Dipole + Quadrupole','IC 4202',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105508,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105508,35.2,NULL,110,44724,NULL,NULL,'Dipole','IC 4202',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105509,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105509,35.22,0.2,111,44724,74.4,NULL,NULL,'IC 4202',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105510,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105510,35.29,NULL,114,44724,NULL,NULL,NULL,'IC 4202',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105511,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105511,35.35,0.43,117,44724,75,NULL,'3.6 micron, color corrected','IC 4202',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105512,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105512,35.58,0.43,131,44724,75,NULL,'3.6 micron, color + selection bias corrected','IC 4202',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105513,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105513,37.35,0.46,295,44725,70,NULL,NULL,'2MASX J13083169+0951524',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000158,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,197.132166667,9.86461,0,NULL,58966650073,921353907,14396154,16.8),(105514,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105514,38.58,0.46,519,44726,70,NULL,NULL,'SDSS J130832.69+270819.6',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'19.51',NULL,NULL,NULL,NULL,NULL,NULL,1,197.136125,27.13886,0,NULL,58718207005,917471984,14335499,19.51),(105515,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105515,36.18,0.23,172,44727,70,NULL,NULL,'2MASX J13083432+4342152',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'16.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,197.143041667,43.70428,0,NULL,59106132771,923533324,14430208,16.4),(105516,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105516,33.22,0.43,44,44728,75,NULL,'3.6 micron, color + selection bias corrected','IC 0851',NULL,'2014MNRAS.444..527S',2014,1,1,NULL,'G',0.00002,NULL,'14.98',0.4,'Sbc',NULL,NULL,NULL,NULL,1,197.143083,21.04978,0.065,NULL,58819219941,919050311,14360161,14.98),(105517,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105517,33.22,0.43,44.1,44728,75,NULL,'3.6 micron, color corrected','IC 0851',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105518,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105518,33.25,0.2,44.7,44728,74.4,NULL,NULL,'IC 0851',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105519,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105519,37.91,0.13,382,44729,70,NULL,NULL,'2MASX J13083495-0144558',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000091,NULL,'16.8g',0.32,'AGN',NULL,NULL,NULL,NULL,1,197.145583333,-1.74892,0.025,NULL,43089911088,673279860,10519997,16.8),(105520,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105520,34.67,0.53,85.7,44730,70,NULL,NULL,'ESO 443- G 072',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.05',0.5,'Sa',NULL,NULL,NULL,NULL,1,197.14725,-32.14803,0.273,NULL,43334143537,677095992,10579624,15.05),(105521,'TRGB','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105521,28.37,0.1,4.72,44731,74.4,NULL,NULL,'UGC 08245',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.000197,NULL,'14.51',0.7,'Im',NULL,NULL,NULL,NULL,1,197.150917,78.93719,0.081,NULL,57158863989,893107249,13954800,14.51),(105522,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105522,38.3,0.46,456,44732,70,NULL,NULL,'SDSS J130836.39+665908.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000077,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,197.151625,66.98575,0.053,NULL,57907225846,904800403,14137506,18),(105523,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105523,37.73,0.23,351,44733,70,NULL,NULL,'SDSS J130836.78-011836.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000071,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,197.1532917,-1.31011,0.025,NULL,43091816964,673309640,10520463,18.6),(105524,'D-Sigma','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105524,29.71,0.4,8.75,44734,75,NULL,'Edat, raw','NGC 4976',NULL,'1997ApJS..109..333W',1997,1,5.6,NULL,'G',0.00008,NULL,'11.04',3,'E4 pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,197.156375,-49.50642,0.897,NULL,46727727906,730120748,11408136,11.04),(105525,'D-Sigma','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105525,30.05,0.4,10.2,44734,75,NULL,'Edat, cor','NGC 4976',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105526,'Faber-Jackson','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105526,28.48,0.63,4.97,44734,95,NULL,'Michard 1979b, c','NGC 4976',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105527,'Faber-Jackson','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105527,29.4,0.37,7.59,44734,95,NULL,'Weighted Mean','NGC 4976',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105528,'Faber-Jackson','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105528,29.91,0.46,9.59,44734,95,NULL,'Michard 1979a','NGC 4976',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105529,'Faber-Jackson','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105529,30.43,0.81,12.2,44734,55,NULL,'Visvanathan & Sandage 1979','NGC 4976',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105530,'Tully est','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105530,31.34,0.8,18.6,44734,75,NULL,'B','NGC 4976',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105531,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105531,38.14,0.33,425,44735,70,NULL,NULL,'SDSS J130837.79+001322.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000076,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,197.1574583,0.22281,0.009,NULL,58057808933,907153264,14174269,18.3),(105532,'IRAS','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105532,32.88,0.8,37.6,44736,75,NULL,'MAT, I','ESO 323- G 085',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000013,NULL,'14.32',1,'SB(rs)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,197.160666667,-41.46164,0.369,NULL,46933692692,733338948,11458421,14.32),(105533,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105533,30.27,0.43,11.3,44736,75,NULL,'3.6 micron, color + selection bias corrected','ESO 323- G 085',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (105534,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105534,30.54,0.43,12.8,44736,75,NULL,'3.6 micron, color corrected','ESO 323- G 085',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105535,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105535,31.05,0.32,16.2,44736,85,NULL,'I, inv','ESO 323- G 085',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105536,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105536,31.09,0.32,16.5,44736,85,NULL,'I, raw','ESO 323- G 085',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105537,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105537,31.52,0.43,20.1,44736,75,NULL,'MAT, I, inv','ESO 323- G 085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105538,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105538,31.59,0.43,20.8,44736,75,NULL,'MAT, I, raw','ESO 323- G 085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105539,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105539,31.62,0.4,21.1,44736,NULL,NULL,NULL,'ESO 323- G 085',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105540,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105540,31.95,0.43,24.6,44736,75,NULL,'MAT, I, cor','ESO 323- G 085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105541,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105541,33.39,0.09,47.7,44736,NULL,NULL,NULL,'ESO 323- G 085',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105542,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105542,37.62,0.46,334,44737,70,NULL,NULL,'2MASX J13083884+5043171',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,197.161833,50.72139,0,NULL,59093139293,923330301,14427035,18),(105543,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105543,38.69,0.46,547,44738,70,NULL,NULL,'2MASX J13083942+6504421',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000091,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,197.164375,65.07831,0.025,NULL,57349457684,896085276,14001332,17.5),(105544,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105544,36.44,0.54,194,44739,70,NULL,NULL,'2MASX J13083952-4301155',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.5,NULL,NULL,NULL,NULL,NULL,1,197.164583,-43.02097,0.369,NULL,46930222152,733284721,11457573,14),(105545,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105545,37.24,0.33,280,44740,70,NULL,NULL,'2MASX J13084048+1347429',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,197.168583,13.79517,0.006,NULL,59051570273,922680785,14416887,17.4),(105546,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105546,37.16,0.46,270,44741,70,NULL,NULL,'2MASX J13084095+0101345',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000072,NULL,'17.4g',0.22,'NLAGN',NULL,NULL,NULL,NULL,1,197.170667,1.02647,0,NULL,58058299198,907160924,14174389,17.4),(105547,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105547,36.47,0.46,197,44742,70,NULL,NULL,'2MASX J13084131+4259541',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,197.172167,42.99836,0,NULL,59299180479,926549694,14477338,17.3),(105548,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105548,38.19,0.46,434,44743,70,NULL,NULL,'2MASXi J1308419+153056',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,197.1744583,15.51586,0.013,NULL,59053449066,922710141,14417345,18.1),(105549,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105549,36.17,0.54,172,44744,70,NULL,NULL,'2MASX J13084206-2056529',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.5I',0.6,NULL,NULL,NULL,NULL,NULL,1,197.1752917,-20.94808,0.229,NULL,43798369856,684349529,10692961,13.5),(105550,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105550,34.4,0.33,76,44745,70,NULL,NULL,'CGCG 271-017',NULL,'2015arXiv151105856S',2015,1,0.98,NULL,'G',0.00013,NULL,'14.1g',0.75,'S0',NULL,NULL,NULL,NULL,1,197.175625,52.01686,0,NULL,57197518470,893711226,13964237,14.1),(105551,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105551,37.95,0.33,389,44746,70,NULL,NULL,'2MASX J13084243+3952132',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,197.1767083,39.87036,0,NULL,59301036918,926578701,14477792,17.5),(105552,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105552,36.94,0.69,245,44747,70,NULL,NULL,'2MASX J13084277-5104103',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.8I',0.5,NULL,NULL,NULL,NULL,NULL,1,197.178208333,-51.0695,1.105,NULL,46727991825,730124872,11408201,13.8),(105553,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105553,36.72,0.46,221,44748,70,NULL,NULL,'2MASX J13084275+2515330',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'18.52',NULL,NULL,NULL,NULL,NULL,NULL,1,197.17825,25.25925,0.029,NULL,58694279619,917098119,14329658,18.52),(105554,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105554,37.11,0.46,265,44749,70,NULL,NULL,'2MASX J13084347+2200130',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,197.1812083,22.00356,0.026,NULL,58820833872,919075529,14360555,17.2),(105555,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105555,38.44,0.27,487,44750,70,NULL,NULL,'SDSS J130843.98+105706.5',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,197.1832917,10.95183,0.006,NULL,58967002153,921359408,14396240,18.1),(105556,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105556,37.91,0.19,382,44751,70,NULL,NULL,'2MASX J13084474+1027317',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00027,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,197.186375,10.45883,0,NULL,58967114955,921361171,14396268,17.5),(105557,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105557,37.91,0.13,382,44752,70,NULL,NULL,'2MASXi J1308467-014045',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000073,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,197.194541667,-1.67931,0.025,NULL,43089919977,673279999,10519999,18.3),(105558,'IRAS','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105558,32.93,0.8,38.6,44753,75,NULL,'MAT, I','ESO 269- G 052',NULL,'1997ApJS..109..333W',1997,1,1.97,NULL,'G',0.000033,NULL,'16.11',0.21,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,197.196667,-43.67611,0.429,NULL,46930067668,733282307,11457536,16.11),(105559,'IRAS','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105559,32.97,0.8,39.2,44753,75,NULL,'A82, H','ESO 269- G 052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105560,'IRAS','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105560,32.97,0.8,39.2,44753,75,NULL,'HMCL, I','ESO 269- G 052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105561,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105561,32.87,NULL,37.5,44753,NULL,NULL,NULL,'ESO 269- G 052',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105562,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105562,32.93,0.32,38.6,44753,85,NULL,'I, inv','ESO 269- G 052',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105563,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105563,32.96,0.32,39.1,44753,85,NULL,'I, raw','ESO 269- G 052',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105564,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105564,33.2,NULL,43.6,44753,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 269- G 052',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105565,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105565,33.21,NULL,43.8,44753,NULL,NULL,'Dipole + Quadrupole','ESO 269- G 052',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105566,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105566,33.22,0.43,44,44753,75,NULL,'MAT, I, inv','ESO 269- G 052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105567,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105567,33.22,NULL,44.1,44753,NULL,NULL,'Dipole','ESO 269- G 052',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105568,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105568,33.26,0.43,44.9,44753,75,NULL,'MAT, I, raw','ESO 269- G 052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105569,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105569,33.39,0.13,47.7,44753,NULL,NULL,NULL,'ESO 269- G 052',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105570,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105570,33.45,0.43,49,44753,75,NULL,'MAT, I, cor','ESO 269- G 052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105571,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105571,33.74,0.47,56,44753,75,NULL,'A82, H, inv','ESO 269- G 052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105572,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105572,33.75,0.4,56.1,44753,75,NULL,'HMCL, I, raw','ESO 269- G 052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105573,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105573,33.77,0.4,56.8,44753,75,NULL,'HMCL, I, inv','ESO 269- G 052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105574,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105574,33.8,0.38,57.5,44753,NULL,NULL,NULL,'ESO 269- G 052',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105575,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105575,33.82,0.47,58.1,44753,75,NULL,'A82, H, raw','ESO 269- G 052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105576,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105576,33.84,0.4,58.5,44753,75,NULL,'HMCL, I, cor','ESO 269- G 052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105577,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105577,33.95,0.47,61.7,44753,75,NULL,'A82, H, cor','ESO 269- G 052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105578,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105578,36.24,0.53,177,44754,70,NULL,NULL,'2MASX J13084724-2220509',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.59',NULL,NULL,NULL,NULL,NULL,NULL,1,197.196917,-22.34758,0.285,NULL,43805233419,684456772,10694637,16.59),(105579,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105579,37.06,0.46,259,44755,70,NULL,NULL,'2MASX J13084749+0843027',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,197.1979583,8.71753,0.015,NULL,58960480726,921257511,14394648,17.5),(105580,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105580,38.22,0.46,441,44756,70,NULL,NULL,'2MASX J13084764+0338378',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,197.1982917,3.64386,0.048,NULL,58055060838,907110325,14173598,18.2),(105581,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105581,37.68,0.46,344,44757,70,NULL,NULL,'2MASX J13084863+2057231',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,197.202625,20.95658,0.065,NULL,58811080558,918923133,14358173,16.9),(105582,'Ring Diameter','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105582,31,0.98,16,44758,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4981',NULL,'1981ApJS...45..541P',1981,1,2.8,NULL,'G',0.000013,NULL,'12.10',2,'SAB(r)bc       LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,197.203083,-6.77753,0.081,NULL,43847907396,685123553,10705055,12.1),(105583,'Ring Diameter','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105583,31.9,0.76,24,44758,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4981',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105584,'Sosies','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105584,31.74,0.24,22.3,44758,NULL,NULL,NULL,'NGC 4981',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105585,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105585,31.61,0.4,21,44758,NULL,NULL,NULL,'NGC 4981',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105586,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105586,31.64,0.43,21.3,44758,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4981',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105587,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105587,31.69,0.43,21.8,44758,75,NULL,'3.6 micron, color corrected','NGC 4981',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105588,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105588,31.75,0.2,22.4,44758,74.4,NULL,NULL,'NGC 4981',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105589,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105589,31.9,0.4,24.1,44758,NULL,NULL,NULL,'NGC 4981',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105590,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105590,31.94,0.45,24.5,44758,NULL,NULL,'K','NGC 4981',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105591,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105591,31.94,0.55,24.5,44758,NULL,NULL,'Malmquist cor.','NGC 4981',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105592,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105592,31.96,0.47,24.7,44758,NULL,NULL,'H','NGC 4981',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105593,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105593,31.97,0.54,24.8,44758,NULL,NULL,NULL,'NGC 4981',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105594,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105594,31.98,0.46,24.8,44758,NULL,NULL,'J','NGC 4981',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105595,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105595,32.22,0.4,27.8,44758,75,NULL,'B','NGC 4981',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105596,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105596,32.24,0.4,28.1,44758,NULL,NULL,'mean','NGC 4981',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105597,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105597,38.35,0.46,467,44759,70,NULL,NULL,'2MASX J13084966+5301431',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000174,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,197.207083,53.02861,0.028,NULL,57414154523,897096164,14017127,17.6),(105598,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105598,37.11,0.46,264,44760,70,NULL,NULL,'2MASX J13084973+4228551',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,197.2072917,42.48217,0,NULL,59300014364,926562724,14477542,17.7),(105599,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105599,37.37,0.46,298,44761,70,NULL,NULL,'2MASX J13084993+3514520',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,197.2082083,35.24781,0,NULL,59159989629,924374837,14443356,17.5),(105600,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105600,34.26,0.33,71.1,44762,70,NULL,NULL,'ARK 402',NULL,'2015arXiv151105856S',2015,1,1.23,NULL,'G',0.000091,NULL,'14.1g',0.87,'NLAGN','Group member',NULL,NULL,'Sy 2',1,197.2087917,-0.81733,0.013,NULL,43088558834,673258731,10519667,14.1),(105601,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105601,37.81,0.46,364,44763,70,NULL,NULL,'2MASX J13085059+0851407',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.70',0.14,NULL,NULL,NULL,NULL,NULL,1,197.210875,8.86125,0.015,NULL,58967934039,921373969,14396468,18.7),(105602,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105602,37.24,0.33,280,44764,70,NULL,NULL,'2MASX J13085071+1349581',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.84',0.19,NULL,NULL,NULL,NULL,NULL,1,197.2112917,13.83281,0.006,NULL,59051567757,922680746,14416886,17.84),(105603,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105603,38.04,0.46,405,44765,70,NULL,NULL,'SDSS J130851.25+183821.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,197.213583,18.63922,0.069,NULL,59034137108,922408392,14412631,18),(105604,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105604,37.47,0.33,312,44766,70,NULL,NULL,'2MASX J13085157+3014310',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,197.214875,30.24206,0.035,NULL,58682658905,916916545,14326821,17.3),(105605,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105605,38.1,0.46,416,44767,70,NULL,NULL,'2MASX J13085195+0903417',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000188,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,197.2165417,9.0615,0.034,NULL,58967963366,921374427,14396475,16.9),(105606,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105606,36.98,0.46,249,44768,70,NULL,NULL,'2MASX J13085210+2156090',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,197.217167,21.93597,0.047,NULL,58820852723,919075823,14360559,16.9),(105607,'IRAS','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105607,34.46,0.8,78,44769,75,NULL,'A82, H','UGC 08229',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000005,NULL,'14.3',1,'SB(r)b','in a radial-velocity based grouping',NULL,NULL,NULL,1,197.225791667,28.18392,0.04,NULL,58704801180,917262518,14332226,14.3),(105608,'IRAS','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105608,34.46,0.8,78,44769,75,NULL,'HMCL, I','UGC 08229',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105609,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105609,33.66,0.69,53.9,44769,100,NULL,'mid-IR','UGC 08229',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105610,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105610,34.18,NULL,68.5,44769,NULL,NULL,NULL,'UGC 08229',NULL,'1993MNRAS.263..211R',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105611,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105611,34.34,0.4,73.7,44769,75,NULL,'HMCL, I, raw','UGC 08229',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105612,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105612,34.52,0.4,80,44769,75,NULL,'HMCL, I, inv','UGC 08229',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105613,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105613,34.54,0.43,81,44769,75,NULL,'3.6 micron, color corrected','UGC 08229',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105614,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105614,34.54,0.43,81,44769,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08229',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105615,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105615,34.65,0.2,85.1,44769,74.4,NULL,NULL,'UGC 08229',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105616,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105616,34.74,0.4,88.6,44769,75,NULL,'HMCL, I, cor','UGC 08229',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105617,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105617,34.8,0.4,91,44769,NULL,NULL,'mean','UGC 08229',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105618,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105618,34.94,0.47,97.4,44769,NULL,NULL,'H','UGC 08229',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105619,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105619,35.07,0.45,103,44769,NULL,NULL,'K','UGC 08229',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105620,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105620,35.08,0.46,104,44769,NULL,NULL,'J','UGC 08229',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105621,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105621,35.16,0.06,108,44769,NULL,NULL,NULL,'UGC 08229',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105622,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105622,35.34,0.47,117,44769,75,NULL,'A82, H, raw','UGC 08229',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105623,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105623,35.58,0.47,130,44769,75,NULL,'A82, H, inv','UGC 08229',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105624,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105624,35.6,0.47,132,44769,75,NULL,'A82, H, cor','UGC 08229',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105625,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105625,35.3,0.52,115,44770,70,NULL,NULL,'2MASX J13085443-2203458',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.31',0.4,NULL,NULL,NULL,NULL,NULL,1,197.22675,-22.06281,0.285,NULL,43805254686,684457104,10694642,16.31),(105626,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105626,37.91,0.19,382,44771,70,NULL,NULL,'2MASX J13085478+1031147',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.0001,NULL,'18.11',0.18,'gE',NULL,NULL,NULL,NULL,1,197.2282917,10.52067,0,NULL,58967137548,921361524,14396273,18.11),(105627,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105627,37.41,0.46,303,44772,70,NULL,NULL,'2MASX J13085490+6652511',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000089,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,197.228916667,66.88078,0.041,NULL,57907358207,904802471,14137538,17.4),(105628,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105628,38.16,0.46,430,44773,70,NULL,NULL,'2MASX J13085506+0905557',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000176,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,197.229333,9.09875,0.034,NULL,58967952040,921374250,14396472,17.2),(105629,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105629,36.59,0.7,208,44774,70,NULL,NULL,'2MASX J13085543-1755136',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,197.230916667,-17.92047,0.149,NULL,44009008215,687640753,10744386,15.3),(105630,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105630,36.38,0.46,189,44775,70,NULL,NULL,'2MASX J13085586+0727417',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.79',0.15,NULL,NULL,NULL,NULL,NULL,1,197.232625,7.46169,0.024,NULL,58960958346,921264974,14394765,17.79),(105631,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105631,36.53,0.46,202,44776,70,NULL,NULL,'2MASX J13085587+5209122',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000182,NULL,'16.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,197.23275,52.15331,0,NULL,57197486276,893710723,13964230,16.2),(105632,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105632,36.95,0.46,246,44777,70,NULL,NULL,'2MASX J13085648+5309592',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000171,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,197.235125,53.16656,0.038,NULL,57414169077,897096391,14017131,17.6),(105633,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105633,37.47,0.33,312,44778,70,NULL,NULL,'SDSS J130856.44+301318.3',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00017,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,197.2352083,30.22178,0.035,NULL,58682728887,916917638,14326838,17.4),(105634,'Tully est','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105634,31.64,0.8,21.3,44779,75,NULL,'B','NGC 4984',NULL,'1988NBGC.C....0000T',1988,1,2.8,NULL,'G',0.00002,NULL,'12.25',2.2,'(R)SAB(rs)0+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,197.238458333,-15.51631,0.061,NULL,44022158738,687846230,10747597,12.25),(105635,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105635,34.79,0.2,90.8,44780,74.4,NULL,NULL,'MCG +05-31-141',NULL,'2013AJ....146...86T',2013,1,0.69,NULL,'G',0.000013,NULL,'15.9g',0.47,NULL,NULL,NULL,NULL,NULL,1,197.23825,28.2805,0.04,NULL,58704790862,917262357,14332224,15.9),(105636,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105636,35.08,0.09,104,44780,NULL,NULL,NULL,'MCG +05-31-141',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105637,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105637,37.91,0.46,382,44781,70,NULL,NULL,'2MASX J13085800+0054268',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000082,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,197.241583333,0.90756,0,NULL,58058335078,907161485,14174398,17.6),(105638,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105638,38.23,0.46,443,44782,70,NULL,NULL,'2MASX J13085892+3810032',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000155,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,197.2454583,38.16764,0,NULL,59293548731,926461698,14475964,18.4),(105639,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105639,37.91,0.19,382,44783,70,NULL,NULL,'2MASX J13085898+1029317',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,197.245875,10.49197,0,NULL,58967105606,921361025,14396266,17.2),(105640,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105640,37.91,0.13,382,44784,70,NULL,NULL,'2MASX J13090177-0127298',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000084,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,197.257333,-1.45839,0.021,NULL,43089691401,673276428,10519944,17.4),(105641,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105641,36.73,0.46,221,44785,70,NULL,NULL,'2MASX J13090207+3954032',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000146,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,197.258875,39.90103,0,NULL,59300515832,926570559,14477664,16.5),(105642,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105642,37.16,0.46,270,44786,70,NULL,NULL,'2MASX J13090253+4244216',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000215,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,197.260541667,42.73928,0,NULL,59300024872,926562888,14477545,17.3),(105643,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105643,33.88,NULL,59.6,44787,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 443- G 074',NULL,'2010Ap&SS.325..163P',2010,1,1.34,NULL,'G',0.000033,NULL,'16.48',0.17,'Sc',NULL,NULL,NULL,NULL,1,197.261375,-29.22556,0.341,NULL,43336720683,677136260,10580254,16.48),(105644,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105644,33.89,NULL,60,44787,NULL,NULL,'Dipole + Quadrupole','ESO 443- G 074',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105645,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105645,33.91,NULL,60.4,44787,NULL,NULL,'Dipole','ESO 443- G 074',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105646,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105646,37.66,0.46,340,44788,70,NULL,NULL,'2MASX J13090419+5639319',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000166,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,197.267667,56.65894,0,NULL,57434906255,897420410,14022193,16.7),(105647,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105647,37.93,0.46,385,44789,70,NULL,NULL,'SDSS J130904.33+503011.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000123,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,197.268083,50.50325,0,NULL,59093151348,923330489,14427038,18.1),(105648,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105648,37.91,0.19,382,44790,70,NULL,NULL,'4C +10.35',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000127,NULL,'16.2g',0.4,'BrClG',NULL,NULL,'WAT?',NULL,1,197.268625,10.49314,0,NULL,58967134282,921361473,14396273,16.2),(105649,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105649,36.66,0.46,215,44791,70,NULL,NULL,'MCG +08-24-052',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000176,NULL,'15.8g',0.49,'S0^-',NULL,NULL,NULL,NULL,1,197.268875,49.76633,0,NULL,59092751921,923324248,14426941,15.8),(105650,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105650,36.84,0.46,233,44792,70,NULL,NULL,'2MASX J13090508+4857372',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,197.271083333,48.96044,0,NULL,59092087997,923313874,14426779,17.5),(105651,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105651,38.6,0.46,526,44793,70,NULL,NULL,'SDSS J130905.18+055650.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,197.271583333,5.9475,0,NULL,58976164077,921502563,14398477,18),(105652,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105652,37.48,0.46,313,44794,70,NULL,NULL,'SDSS J130905.58+092837.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.56',0.15,NULL,NULL,NULL,NULL,NULL,1,197.2732917,9.47717,0.006,NULL,58965800228,921340628,14395947,18.56),(105653,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105653,37.97,0.46,392,44795,70,NULL,NULL,'2MASX J13090580+3116497',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,197.274208333,31.28044,0.039,NULL,58686402230,916975034,14327734,17.4),(105654,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105654,38.05,0.46,408,44796,70,NULL,NULL,'2MASX J13090640+0609466',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,197.276667,6.16314,0.016,NULL,58976258000,921504031,14398500,17.5),(105655,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105655,35.8,0.46,144,44797,70,NULL,NULL,'2MASX J13090692+4718136',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000167,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,197.27875,47.30389,0,NULL,59099768911,923433889,14428654,16.3),(105656,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105656,38.44,0.27,487,44798,70,NULL,NULL,'SDSS J130907.18+105416.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000149,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,197.279958333,10.90469,0.011,NULL,58964187450,921315428,14395553,18.7),(105657,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105657,37.61,0.46,332,44799,70,NULL,NULL,'2MASX J13090777+3821122',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000173,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,197.282375,38.35347,0,NULL,59293534905,926461482,14475960,17.1),(105658,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105658,37.74,0.46,354,44800,70,NULL,NULL,'2MASX J13090798+3446267',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,197.283167,34.77406,0,NULL,59160426774,924381668,14443463,17.5),(105659,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105659,38.48,0.46,497,44801,70,NULL,NULL,'SDSS J130908.61-024057.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000074,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,197.285916667,-2.68258,0.021,NULL,43096516792,673383074,10521610,18.5),(105660,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105660,31.12,0.2,16.8,44802,74.4,NULL,NULL,'NGC 4980',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.000007,NULL,'13.51',0.7,'SAB(rs)a pec?  HII',NULL,NULL,NULL,NULL,1,197.292,-28.64178,0.313,NULL,43336895462,677138991,10580296,13.51),(105661,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105661,31.15,0.43,17,44802,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4980',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105662,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105662,31.16,0.43,17.1,44802,75,NULL,'3.6 micron, color corrected','NGC 4980',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105663,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105663,36.93,0.46,243,44803,70,NULL,NULL,'2MASX J13091043+1643271',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.30',0.27,NULL,NULL,NULL,NULL,NULL,1,197.293417,16.72414,0,NULL,59042397123,922537455,14414647,17.3),(105664,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105664,37.91,0.13,382,44804,70,NULL,NULL,'2MASX J13091051-0132168',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000088,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,197.293666667,-1.53814,0.021,NULL,43089880093,673279376,10519990,17.4),(105665,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105665,37.32,0.33,291,44805,70,NULL,NULL,'2MASX J13091057+3905402',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000171,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,197.294083,39.0945,0,NULL,59305251494,926644554,14478821,17.7),(105666,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105666,36.95,0.46,246,44806,70,NULL,NULL,'2MASX J13091084+0740228',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,197.2952083,7.67286,0.024,NULL,58961143110,921267861,14394810,17),(105667,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105667,36.05,0.46,162,44807,70,NULL,NULL,'2MASX J13091108+5201153',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,197.296125,52.02092,0,NULL,57197471421,893710490,13964226,16.5),(105668,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105668,36.53,0.76,202,44808,70,NULL,NULL,'2MASX J13091156-7522357',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,197.29825,-75.37656,0.909,NULL,44210624575,690791008,10793609,17.6),(105669,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105669,37.91,0.13,382,44809,70,NULL,NULL,'2MASX J13091171-0143328',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00009,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,197.298917,-1.72564,0.021,NULL,43089855592,673278993,10519984,17.3),(105670,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105670,35.77,0.49,143,44810,75,NULL,'IR','ESO 269- G 054',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'16.15',0.2,'S',NULL,NULL,NULL,NULL,1,197.299667,-44.63125,0.513,NULL,46728884134,730138814,11408418,16.15),(105671,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105671,35.84,0.44,147,44810,NULL,NULL,'Malmquist cor.','ESO 269- G 054',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105672,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105672,36.1,0.39,166,44810,NULL,NULL,NULL,'ESO 269- G 054',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105673,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105673,36.15,0.2,170,44810,74.4,NULL,NULL,'ESO 269- G 054',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105674,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105674,37.96,0.46,391,44811,70,NULL,NULL,'2MASX J13091261+3330007',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000155,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,197.302583333,33.50017,NULL,NULL,59158164449,924346319,14442911,17.4),(105675,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105675,36.18,0.23,172,44812,70,NULL,NULL,'CGCG 217-014',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00021,NULL,'15.0g',0.57,'E0',NULL,NULL,NULL,NULL,1,197.3084583,43.34117,0,NULL,59299122283,926548785,14477324,15),(105676,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105676,37.13,0.46,266,44813,70,NULL,NULL,'2MASX J13091562+5322033',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000193,NULL,'16.0g',0.3,'S0',NULL,NULL,NULL,NULL,1,197.315125,53.36753,0.045,NULL,57414745916,897105404,14017271,16),(105677,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105677,32.74,0.48,35.4,44814,70,NULL,NULL,'NGC 4989',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000057,NULL,'13.92',0.9,'S0^0^:',NULL,NULL,NULL,NULL,1,197.316875,-5.39642,0.045,NULL,43092516866,673320576,10520634,13.92),(105678,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105678,37.91,0.13,382,44815,70,NULL,NULL,'2MASX J13091761-0136539',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000213,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,197.323417,-1.61503,0.021,NULL,43089838205,673278721,10519980,17.5),(105679,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105679,36.18,0.23,172,44816,70,NULL,NULL,'2MASX J13091867+4339166',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000191,NULL,'15.6g',0.51,'E0',NULL,NULL,NULL,NULL,1,197.32775,43.65461,0,NULL,59307473425,926679272,14479363,15.6),(105680,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105680,37.91,0.13,382,44817,70,NULL,NULL,'2MASX J13091907-0137209',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000113,NULL,'15.8g',0.5,'BrClG',NULL,NULL,NULL,NULL,1,197.329583,-1.62253,0.021,NULL,43089830469,673278601,10519978,15.8),(105681,'Tully est','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105681,33.02,0.8,40.1,44818,75,NULL,NULL,'UGCA 328',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000027,NULL,'15.12',0.9,'IB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,197.329833,-24.38656,0.457,NULL,43312330363,676755161,10574299,15.12),(105682,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105682,37.91,0.13,382,44819,70,NULL,NULL,'2MASX J13092034-0136169',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000103,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,197.3347083,-1.60472,0.021,NULL,43089839101,673278735,10519980,17.7),(105683,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105683,37.91,0.13,382,44820,70,NULL,NULL,'SDSS J130921.10-013757.1',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000068,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,197.3379583,-1.63253,0.021,NULL,43089833315,673278645,10519978,18),(105684,'FP','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,'R',105684,36.9,0.46,240,44821,70,NULL,NULL,'2MASX J13092159+0830158',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.20',0.17,NULL,NULL,NULL,NULL,NULL,1,197.3397917,8.50442,0.02,NULL,58960639866,921259997,14394687,18.2),(105685,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105685,33.13,0.46,42.3,44822,NULL,NULL,'J','UGC 08233',NULL,'2007A&A...465...71T',2007,1,1.7,'The UZC position includes a bright superposed star.','G',0.000043,NULL,'14.40',0.7,'Scd:',NULL,NULL,NULL,NULL,1,197.346583,6.99633,0.026,NULL,58976658667,921510291,14398598,14.4),(105686,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105686,33.54,0.47,51.1,44822,NULL,NULL,'H','UGC 08233',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105687,'Tully-Fisher','2016-12-15 15:15:10','2016-12-16 11:20:22','1',NULL,NULL,105687,33.62,0.4,52.9,44822,NULL,NULL,'mean','UGC 08233',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105688,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105688,33.77,0.45,56.8,44822,NULL,NULL,'K','UGC 08233',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105689,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105689,35.48,0.27,125,44823,70,NULL,NULL,'2MASX J13092346+2816530',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000168,NULL,'16.1g',0.31,NULL,NULL,NULL,NULL,NULL,1,197.347625,28.28147,0.035,NULL,58719207754,917487621,14335744,16.1),(105690,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105690,37.88,0.46,376,44824,70,NULL,NULL,'2MASX J13092398+3748313',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,197.34975,37.80867,0,NULL,59293850526,926466414,14476037,17),(105691,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105691,38.04,0.46,406,44825,70,NULL,NULL,'2MASX J13092457+4238596',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,197.352417,42.64983,0,NULL,59300031054,926562985,14477546,17.8),(105692,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105692,37.42,0.46,304,44826,70,NULL,NULL,'2MASX J13092507+1515553',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000144,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,197.3545,15.26544,0.013,NULL,59053375587,922708993,14417328,17.4),(105693,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105693,36.58,0.46,207,44827,70,NULL,NULL,'2MASX J13092565+0429453',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000192,NULL,'16.2g',0.26,'AGN',NULL,NULL,NULL,NULL,1,197.356833,4.49603,0.024,NULL,58053863439,907091616,14173306,16.2),(105694,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105694,35.98,0.52,157,44828,70,NULL,NULL,'ESO 575- G 065',NULL,'2014MNRAS.445.2677S',2014,1,1,'ESO/U lists the identification with NGC 4994 as doubtful. See ESO 508- G 18.','G',0.00015,NULL,'16.18',0.2,'S0?',NULL,NULL,NULL,NULL,1,197.357416667,-22.47972,0.277,NULL,43804661751,684447839,10694497,16.18),(105695,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105695,37.12,0.46,266,44829,70,NULL,NULL,'2MASX J13092718+0857368',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000181,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,197.363167,8.96031,0.034,NULL,58967779167,921371549,14396430,16.4),(105696,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105696,37.91,0.13,382,44830,70,NULL,NULL,'SDSS J130927.41-013251.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000092,NULL,'18.3g',0.1,NULL,NULL,NULL,NULL,NULL,1,197.36425,-1.54758,0.021,NULL,43089811325,673278301,10519973,18.3),(105697,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105697,38.27,0.27,450,44831,70,NULL,NULL,'2MASX J13092897+5403254',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,197.370833,54.05706,0.032,NULL,57425699063,897276547,14019946,17.3),(105698,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105698,38.07,0.46,410,44832,70,NULL,NULL,'2MASX J13093031-0038399',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000081,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,197.376375,-0.64458,0.017,NULL,43088920174,673264377,10519755,17.4),(105699,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105699,37.37,0.46,298,44833,70,NULL,NULL,'2MASX J13093036-0214339',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000082,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,197.3764583,-2.24286,0.017,NULL,43089230101,673269220,10519831,17),(105700,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105700,37.91,0.19,382,44834,70,NULL,NULL,'2MASX J13093165+1035598',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000237,NULL,'18.70',0.15,NULL,NULL,NULL,NULL,NULL,1,197.381917,10.60011,0,NULL,58967168397,921362006,14396281,18.7),(105701,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105701,36.6,0.98,209,44835,70,NULL,NULL,'2MASX J13093207-2553307',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,197.383625,-25.89186,0.409,NULL,43313508743,676773574,10574587,15.6),(105702,'Ring Diameter','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105702,32.2,0.84,27,44836,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 4999',NULL,'1981ApJS...45..541P',1981,1,2.16,NULL,'G',0.000027,NULL,'13.1g',1.51,'SB(r)b','in a radial-velocity based grouping',NULL,NULL,NULL,1,197.388041667,1.67306,0.043,NULL,58060011054,907187672,14174807,13.1),(105703,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105703,33.6,0.69,52.6,44836,100,NULL,'mid-IR','NGC 4999',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105704,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105704,37.2,0.46,275,44837,70,NULL,NULL,'2MASX J13093465+2010385',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,197.394375,20.17739,NULL,NULL,58810792040,918918625,14358103,17.1),(105705,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105705,35.46,0.51,124,44838,70,NULL,NULL,'ESO 323- G 087',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'15.76',0.3,'S0-a     poss. LINER',NULL,NULL,NULL,NULL,1,197.3945,-38.07064,0.253,NULL,46927210605,733237665,11456838,15.76),(105706,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105706,33.12,0.45,42.1,44839,NULL,NULL,'K','IC 4200',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000035,NULL,'13.86',1,'(R\')SA(r)0^0^: Sy1',NULL,NULL,NULL,'AGN',1,197.394833,-51.96858,1.153,NULL,44597654206,696838346,10888099,13.86),(105707,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105707,33.73,0.4,55.7,44839,NULL,NULL,'mean','IC 4200',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105708,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105708,36.89,0.46,239,44840,70,NULL,NULL,'SDSS J130934.96+053247.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,197.3957083,5.54661,0,NULL,58929998934,920781233,14387206,17.8),(105709,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105709,36.18,0.23,172,44841,70,NULL,NULL,'2MASX J13093529+4316057',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000204,NULL,'15.9g',0.37,'S0',NULL,NULL,NULL,NULL,1,197.397,43.26833,0,NULL,59299111320,926548614,14477322,15.9),(105710,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105710,37.75,0.46,354,44842,70,NULL,NULL,'2MASX J13093565-0035299',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000067,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,197.3985417,-0.59175,0,NULL,43088916139,673264314,10519754,17.7),(105711,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105711,35.68,0.43,137,44843,NULL,NULL,'Malmquist cor.','ESO 575- G 066',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.79',0.6,'SA(s)b         HII',NULL,NULL,NULL,NULL,1,197.399833,-18.97236,0.225,NULL,43980813048,687200203,10737503,14.79),(105712,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105712,35.86,0.4,149,44843,NULL,NULL,NULL,'ESO 575- G 066',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105713,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105713,35.9,0.2,151,44843,74.4,NULL,NULL,'ESO 575- G 066',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105714,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105714,29.46,NULL,7.8,44844,NULL,NULL,NULL,'AM 1306-265',NULL,'2013AJ....145..101K',2013,1,0.6,NULL,'G',0.00002,NULL,'15.11',0.4,NULL,NULL,NULL,NULL,NULL,1,197.4025,-27.14075,0.333,NULL,43349438580,677334977,10583359,15.11),(105715,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105715,36,0.52,158,44845,70,NULL,NULL,'ESO 508- G 017',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000147,NULL,'15.34',0.6,'Sa',NULL,NULL,NULL,NULL,1,197.4039583,-24.84764,0.441,NULL,43311772770,676746449,10574163,15.34),(105716,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105716,37.91,0.46,382,44846,70,NULL,NULL,'SDSS J130937.32+510745.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000125,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,197.405541667,51.12936,0,NULL,59093086951,923329483,14427023,18.5),(105717,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105717,38.49,0.46,500,44847,70,NULL,NULL,'SDSS J130938.41+073904.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,197.410083333,7.65139,0.024,NULL,58960920973,921264390,14394756,18.4),(105718,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105718,37.57,0.46,327,44848,70,NULL,NULL,'2MASX J13093957+3927303',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000197,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,197.4147083,39.45833,0,NULL,59305209714,926643901,14478810,16.9),(105719,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105719,36.6,0.46,209,44849,70,NULL,NULL,'2MASX J13093973+5604414',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000158,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,197.4157917,56.07817,0.013,NULL,57416977350,897140271,14017816,16.7),(105720,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105720,38.27,0.27,450,44850,70,NULL,NULL,'2MASX J13093988+5402094',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000195,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,197.416125,54.03594,0.032,NULL,57425679354,897276239,14019941,17.8),(105721,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105721,35.81,0.58,145,44851,70,NULL,NULL,'MCG -02-34-005',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.5',0.6,NULL,NULL,NULL,NULL,NULL,1,197.4165,-12.33872,0.077,NULL,43964882849,686951294,10733613,15.5),(105722,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105722,37.52,0.46,319,44852,70,NULL,NULL,'2MASX J13094018+1755515',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.64',0.16,NULL,NULL,NULL,NULL,NULL,1,197.417375,17.93103,0.057,NULL,59039289077,922488891,14413888,18.64),(105723,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105723,38.65,0.46,538,44853,70,NULL,NULL,'2MASX J13094043+1942445',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,197.418583,19.71233,0.088,NULL,58810732781,918917699,14358089,17.8),(105724,'Sosies','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105724,32.4,0.2,30.2,44854,NULL,NULL,NULL,'NGC 4995',NULL,'2002A&A...393...57T',2002,1,2.5,NULL,'G',0.000023,NULL,'11.93',1.6,'SAB(rs)b       Sy','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,197.419375,-7.83342,0.109,NULL,43849772338,685152692,10705510,11.93),(105725,'Tully est','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105725,32.23,0.8,28,44854,75,NULL,'B','NGC 4995',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105726,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105726,30.56,0.69,12.9,44854,100,NULL,'mid-IR','NGC 4995',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105727,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105727,32,0.47,25.2,44854,NULL,NULL,'Malmquist cor.','NGC 4995',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105728,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105728,32.03,0.46,25.5,44854,NULL,NULL,NULL,'NGC 4995',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105729,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105729,32.03,0.4,25.5,44854,NULL,NULL,NULL,'NGC 4995',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105730,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105730,32.03,0.43,25.5,44854,75,NULL,'3.6 micron, color + selection bias corrected','NGC 4995',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105731,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105731,32.07,0.2,25.9,44854,74.4,NULL,NULL,'NGC 4995',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105732,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105732,32.08,0.43,26,44854,75,NULL,'3.6 micron, color corrected','NGC 4995',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105733,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105733,32.23,0.47,27.9,44854,NULL,NULL,'H','NGC 4995',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105734,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105734,32.27,0.45,28.4,44854,NULL,NULL,'K','NGC 4995',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105735,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105735,32.29,0.46,28.7,44854,NULL,NULL,'J','NGC 4995',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105736,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105736,32.35,0.4,29.5,44854,NULL,NULL,'mean','NGC 4995',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105737,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105737,32.83,0.3,36.8,44854,55,NULL,'B','NGC 4995',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105738,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105738,35.09,0.45,104,44855,NULL,NULL,'Malmquist cor.','UGC 08238',NULL,'2009ApJS..182..474S',2009,1,0.92,NULL,'G',0.000017,NULL,'14.8g',0.67,'Sd             NLAGN',NULL,NULL,NULL,NULL,1,197.421166667,-1.04828,0.017,NULL,43091910606,673311103,10520485,14.8),(105739,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105739,35.39,0.39,120,44855,NULL,NULL,NULL,'UGC 08238',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105740,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105740,35.43,0.2,122,44855,74.4,NULL,NULL,'UGC 08238',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105741,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105741,37.63,0.46,337,44856,70,NULL,NULL,'2MASX J13094208+1340063',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,197.42525,13.66828,0,NULL,59051365839,922677591,14416837,18),(105742,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105742,34.89,0.48,95.1,44857,NULL,NULL,'Malmquist cor.','2MASX J13094219-0753072',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000013,NULL,'14.0I',NULL,NULL,NULL,NULL,NULL,NULL,1,197.425791667,-7.88533,0.109,NULL,43849802244,685153160,10705518,14),(105743,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105743,35.16,0.42,107,44857,NULL,NULL,NULL,'2MASX J13094219-0753072',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105744,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105744,35.2,0.2,110,44857,74.4,NULL,NULL,'2MASX J13094219-0753072',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105745,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105745,37.5,0.27,316,44858,70,NULL,NULL,'2MASX J13094344-0013288',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000087,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,197.4310417,-0.22481,0.023,NULL,43088997960,673265593,10519774,16.4),(105746,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105746,37.19,0.46,274,44859,70,NULL,NULL,'2MASX J13094400+2534400',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,197.4334583,25.57783,0.026,NULL,58692331616,917067681,14329182,17.2),(105747,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105747,32.22,0.4,27.8,44860,75,NULL,NULL,'MCG -03-34-004',NULL,'2008Ap.....51..336K',2008,1,1.9,NULL,'G',0.000013,NULL,'14.50',0.5,'S0+:','X-ray-bright group member',NULL,NULL,NULL,1,197.433625,-16.60211,0.101,NULL,44010004043,687656313,10744629,14.5),(105748,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105748,33.16,0.49,42.8,44860,75,NULL,'IR','MCG -03-34-004',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105749,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105749,36.69,0.46,217,44861,70,NULL,NULL,'2MASX J13094417+5954154',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00017,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,197.434125,59.90428,0,NULL,57384142186,896627221,14009800,16.4),(105750,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105750,37.32,0.33,291,44862,70,NULL,NULL,'2MASX J13094478+3908283',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000127,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,197.4365,39.14125,0,NULL,59305325342,926645708,14478839,16.5),(105751,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105751,35.14,0.53,107,44863,70,NULL,NULL,'2MASX J13094590-7321378',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,197.440958333,-73.36058,0.973,NULL,44216283785,690879434,10794991,16.8),(105752,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105752,37.91,0.13,382,44864,70,NULL,NULL,'2MASX J13094623-0131248',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000074,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,197.442583,-1.52361,0.013,NULL,43089848872,673278888,10519982,18),(105753,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105753,35.46,0.46,124,44865,70,NULL,NULL,'UGC 08247',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.000186,NULL,'14.9g',0.47,'S0',NULL,NULL,NULL,NULL,1,197.444,55.48581,0.009,NULL,57425241738,897269402,14019834,14.9),(105754,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105754,37.63,0.33,336,44866,70,NULL,NULL,'2MASX J13094659+4443507',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000188,NULL,'16.0g',0.38,'BrClG',NULL,NULL,NULL,NULL,1,197.444125,44.73069,0.02,NULL,59098661616,923416587,14428384,16),(105755,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105755,37.37,0.46,298,44867,70,NULL,NULL,'2MASX J13094686+0749223',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.05',0.13,NULL,NULL,NULL,NULL,NULL,1,197.445375,7.82303,0.029,NULL,58961007390,921265740,14394777,18.05),(105756,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105756,35.4,0.58,120,44868,70,NULL,NULL,'2MASX J13094695-4238564',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,197.445667,-42.64906,0.421,NULL,46930942347,733295974,11457749,15),(105757,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105757,36.44,0.46,194,44869,70,NULL,NULL,'2MASX J13094705+4853582',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000187,NULL,'15.9g',0.38,'E0',NULL,NULL,NULL,NULL,1,197.4457917,48.89958,0,NULL,59092105941,923314155,14426783,15.9),(105758,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105758,36.89,0.33,239,44870,70,NULL,NULL,'2MASX J13094731+0847463',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000202,NULL,'16.1g',0.31,NULL,NULL,NULL,NULL,NULL,1,197.447208333,8.79611,0.017,NULL,58967728403,921370756,14396418,16.1),(105759,'Tully est','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105759,31.68,0.8,21.7,44871,75,NULL,NULL,'UGCA 330',NULL,'1988NBGC.C....0000T',1988,1,3,'HR 4961 = 50 Vir (V=6.0) superposed 47\\\" southwest of center.','G',0.00002,NULL,'14.50',2.5,'SAB(s)d:       Sy2','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,197.447917,-10.32,0.097,NULL,43846746540,685105414,10704772,14.5),(105760,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105760,31.73,0.4,22.2,44871,NULL,NULL,NULL,'UGCA 330',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105761,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105761,34.2,0.47,69.2,44872,NULL,NULL,'H','NGC 5000',NULL,'2007A&A...465...71T',2007,1,1.52,NULL,'G',0.000013,NULL,'13.9g',1.06,'SB(rs)bc       Sbrst','in a radial-velocity based grouping',NULL,NULL,NULL,1,197.447875,28.90694,0.032,NULL,58717518220,917461222,14335331,13.9),(105762,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105762,34.44,0.46,77.2,44872,NULL,NULL,'J','NGC 5000',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105763,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105763,34.48,0.45,78.8,44872,NULL,NULL,'K','NGC 5000',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105764,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105764,34.64,0.4,84.8,44872,NULL,NULL,'mean','NGC 5000',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105765,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105765,32.78,0.17,36,44873,70,NULL,'NGC 4993 GROUP; ESO 508- G 018 GROUP','NGC 4993',NULL,'1992ApJ...396..453H',1990,1,1.3,NULL,'G',0.00005,NULL,'13.32',1.1,'(R\')SAB(rs)0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,197.44875,-23.38389,0.281,NULL,43795733749,684308339,10692317,13.32),(105766,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105766,32.98,NULL,39.5,44873,71,NULL,'ESO 508- G 018 group, 100 galaxies','NGC 4993',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105767,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105767,33.07,0.3,41.1,44873,NULL,NULL,'ESO 508- G 018 group, 9 galaxies','NGC 4993',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105768,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105768,34.67,0.2,85.9,44874,74.4,NULL,NULL,'CGCG 072-008',NULL,'2013AJ....146...86T',2013,1,0.82,NULL,'G',0.000006,NULL,'15.3g',0.48,'Sc',NULL,NULL,NULL,NULL,1,197.452416667,11.65133,0.011,NULL,58963649062,921307016,14395422,15.3),(105769,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105769,37.5,0.27,316,44875,70,NULL,NULL,'SDSS J130949.15-001136.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000068,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,197.454833,-0.19342,0.023,NULL,43088997779,673265590,10519774,18.2),(105770,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105770,36.94,0.74,244,44876,70,NULL,NULL,'2MASX J13095017-2451157',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,197.459,-24.8545,0.441,NULL,43313661211,676775956,10574624,15.5),(105771,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105771,34.1,0.52,66.2,44877,70,NULL,NULL,'ESO 443- G 077',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000133,NULL,'14.69',0.3,'S0?',NULL,NULL,NULL,NULL,1,197.4614583,-30.51506,0.325,NULL,43332266534,677066664,10579166,14.69),(105772,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105772,33.05,0.49,40.7,44878,75,NULL,'IR','2MFGC 10484',NULL,'2011yCatp016004901K',2011,1,NULL,'This is a knot in the galaxy ESO 508- G 019.','G',0.00015,NULL,'14.0R',NULL,'HII',NULL,NULL,NULL,NULL,1,197.461667,-24.24186,0.457,NULL,43312080440,676751256,10574238,14),(105773,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105773,38.06,0.27,409,44879,70,NULL,NULL,'2MASX J13095173+6449517',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000078,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,197.46525,64.83097,0.025,NULL,57352382457,896130975,14002046,18.3),(105774,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105774,37.56,0.46,325,44880,70,NULL,NULL,'SDSS J130951.78+304154.6',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,197.46575,30.69853,0.007,NULL,58682939979,916920937,14326889,17.2),(105775,'IRAS','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105775,32.99,0.8,39.6,44881,75,NULL,'MAT, I','ESO 508- G 019',NULL,'1997ApJS..109..333W',1997,1,1.7,'The position is for the brightest (J-band) knot along the bar.','G',0.000019,NULL,'14.32',0.6,'SB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,197.46625,-24.23911,0.457,NULL,43312080407,676751256,10574238,14.32),(105776,'IRAS','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105776,33.01,0.8,40,44881,75,NULL,'HMCL, I','ESO 508- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105777,'Tully est','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105777,33.08,0.8,41.3,44881,75,NULL,NULL,'ESO 508- G 019',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105778,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105778,32.36,0.32,29.7,44881,85,NULL,'I, raw','ESO 508- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105779,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105779,32.36,0.32,29.7,44881,85,NULL,'I, inv','ESO 508- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105780,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105780,32.74,0.43,35.2,44881,75,NULL,'MAT, I, raw','ESO 508- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105781,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105781,32.79,0.2,36.1,44881,74.4,NULL,NULL,'ESO 508- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105782,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105782,32.8,0.43,36.3,44881,75,NULL,'MAT, I, inv','ESO 508- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105783,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105783,32.84,0.4,37.1,44881,75,NULL,'HMCL, I, raw','ESO 508- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105784,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105784,32.92,0.4,38.3,44881,75,NULL,'HMCL, I, inv','ESO 508- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105785,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105785,32.93,0.38,38.5,44881,NULL,NULL,NULL,'ESO 508- G 019',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105786,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105786,32.97,0.43,39.3,44881,75,NULL,'3.6 micron, color corrected','ESO 508- G 019',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105787,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105787,33,0.43,39.8,44881,75,NULL,'MAT, I, cor','ESO 508- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105788,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105788,33.06,0.4,41,44881,75,NULL,'HMCL, I, cor','ESO 508- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105789,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105789,33.14,0.43,42.4,44881,75,NULL,'3.6 micron, color + selection bias corrected','ESO 508- G 019',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105790,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105790,33.31,0.11,46,44881,NULL,NULL,NULL,'ESO 508- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105791,'IRAS','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105791,34.95,0.8,97.9,44882,75,NULL,'HMCL, I','UGC 08244',NULL,'1997ApJS..109..333W',1997,1,1.21,NULL,'G',0.000168,NULL,'15.7g',0.45,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,197.467125,28.38244,0.035,NULL,58717432637,917459884,14335310,15.7),(105792,'IRAS','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105792,34.98,0.8,98.9,44882,75,NULL,'W91CL, r','UGC 08244',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105793,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105793,34.49,0.2,79.1,44882,74.4,NULL,NULL,'UGC 08244',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105794,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105794,34.57,0.43,81.9,44882,75,NULL,'3.6 micron, color corrected','UGC 08244',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105795,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105795,34.7,0.43,86.9,44882,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08244',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105796,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105796,34.77,0.4,89.9,44882,75,NULL,'HMCL, I, raw','UGC 08244',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105797,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105797,34.87,0.4,94.3,44882,75,NULL,'HMCL, I, inv','UGC 08244',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105798,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105798,34.89,0.38,95.1,44882,75,NULL,'W91CL, r, raw','UGC 08244',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105799,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105799,34.95,0.38,97.6,44882,75,NULL,'W91CL, r, inv','UGC 08244',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105800,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105800,34.95,0.4,97.8,44882,75,NULL,'HMCL, I, cor','UGC 08244',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105801,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105801,34.98,0.38,98.9,44882,75,NULL,'W91CL, r, cor','UGC 08244',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105802,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105802,35.07,0.09,103,44882,NULL,NULL,NULL,'UGC 08244',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105803,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105803,37.22,0.46,278,44883,70,NULL,NULL,'2MASX J13095319+5634254',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000165,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,197.471667,56.57381,0.013,NULL,57434951894,897421123,14022205,16.6),(105804,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105804,37.63,0.33,336,44884,70,NULL,NULL,'2MASX J13095456+4440257',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000198,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,197.4774583,44.67389,0.02,NULL,59097812276,923403316,14428176,17.1),(105805,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105805,37.89,0.46,379,44885,70,NULL,NULL,'2MASX J13095465+5017142',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000171,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,197.477875,50.28725,0,NULL,59093394152,923334283,14427098,17.6),(105806,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105806,37.74,0.46,353,44886,70,NULL,NULL,'SDSS J130956.45+671408.1',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000076,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,197.48525,67.23558,0.017,NULL,57910092144,904845189,14138206,17.7),(105807,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105807,39.39,0.46,755,44887,70,NULL,NULL,'SDSS J130956.75+140644.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000146,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,197.4865,14.11231,0,NULL,59051415658,922678369,14416849,18.7),(105808,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105808,36.89,0.33,239,44888,70,NULL,NULL,'2MASX J13095777+0845183',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00018,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,197.49075,8.75506,0.017,NULL,58960386781,921256043,14394625,16.2),(105809,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105809,36.13,0.46,168,44889,70,NULL,NULL,'2MASX J13095810+5024432',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000181,NULL,'16.1g',0.28,'S0^-',NULL,NULL,NULL,NULL,1,197.492125,50.41214,0,NULL,59093400624,923334384,14427099,16.1),(105810,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105810,37.41,0.46,303,44890,70,NULL,NULL,'2MASX J13095831+2022216',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.65',0.18,NULL,NULL,NULL,NULL,NULL,1,197.493083,20.37267,NULL,NULL,58811281651,918926275,14358223,17.65),(105811,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105811,37.98,0.46,395,44891,70,NULL,NULL,'2MASX J13095920+1412135',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000179,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,197.496625,14.20378,0,NULL,59050703783,922667246,14416675,17.5),(105812,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105812,37.32,0.46,291,44892,70,NULL,NULL,'2MASX J13095957+2142497',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,197.498417,21.71386,0.042,NULL,58820331325,919067676,14360432,16.6),(105813,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105813,33.73,0.49,55.8,44893,75,NULL,'IR','ESO 269-IG 056',NULL,'2011yCatp016004901K',2011,1,2.8,'Confused HIPASS source','G',0.000017,NULL,'14.01',0.7,'SB(s)m pec:',NULL,NULL,NULL,NULL,1,197.50675,-43.21208,0.385,NULL,46930309449,733286085,11457595,14.01),(105814,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105814,38.27,0.27,450,44894,70,NULL,NULL,'2MASX J13100199+5400053',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000186,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,197.508583333,54.00144,0.032,NULL,57425688646,897276385,14019943,16.7),(105815,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105815,35.94,0.67,154,44895,70,NULL,NULL,'LCRS B130726.3-055144',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.01',NULL,NULL,NULL,NULL,NULL,NULL,1,197.5089583,-6.12814,0.085,NULL,43881018504,685640914,10713139,15.01),(105816,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105816,38.06,0.27,409,44896,70,NULL,NULL,'2MASX J13100269+6451007',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000093,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,197.510958333,64.85031,0.025,NULL,57352381446,896130960,14002046,16.9),(105817,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105817,37.72,0.33,350,44897,70,NULL,NULL,'2MASX J13100290+0904543',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000183,NULL,'16.0g',0.43,NULL,NULL,NULL,NULL,NULL,1,197.512167,9.08172,0.019,NULL,58965674703,921338667,14395916,16),(105818,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105818,36.76,0.46,225,44898,70,NULL,NULL,'2MASX J13100390+3054573',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,197.516375,30.91603,0.021,NULL,58683030728,916922355,14326911,16.8),(105819,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105819,36.63,0.46,212,44899,70,NULL,NULL,'CGCG 294-025',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000178,NULL,'15.3g',0.56,'AGN',NULL,NULL,NULL,NULL,1,197.518167,60.22408,0,NULL,57385580317,896649692,14010151,15.3),(105820,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:22','1','SN 1992K',NULL,105820,32.85,0.1,37.2,44900,74.4,NULL,NULL,'ESO 269- G 057',NULL,'2013AJ....146...86T',2013,1,3.2,NULL,'G',0.000017,NULL,'12.49',2.3,'(R\'_2)SAB(r)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,197.518458333,-46.43733,0.449,NULL,46731308390,730176693,11409010,12.49),(105821,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:22','1','SN 1992K',NULL,105821,33.15,0.38,42.7,44900,65,NULL,'LCS','ESO 269- G 057',NULL,'1995ApJ...445L..91R',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105822,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:22','1','SN 1992K',NULL,105822,33.21,0.15,42.9,44900,65,NULL,'MLCS2k2','ESO 269- G 057',0.01036,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105823,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:22','1','SN 1992K',NULL,105823,33.2,0.65,43,44900,67,NULL,NULL,'ESO 269- G 057',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105824,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:22','1','SN 1992K',NULL,105824,33.37,0.17,47.2,44900,70.8,NULL,NULL,'ESO 269- G 057',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105825,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:22','1','SN 1992K',NULL,105825,33.48,0.21,49.2,44900,70,NULL,'SALT','ESO 269- G 057',0.01036,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105826,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:22','1','SN 1992K',NULL,105826,33.55,0.16,50.7,44900,65,NULL,'MLCS','ESO 269- G 057',0.01036,'1996ApJ...473..588R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105827,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:22','1','SN 1992K',NULL,105827,33.53,0.15,50.8,44900,65,NULL,'Snapshot','ESO 269- G 057',NULL,'1996ApJ...473...88R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105828,'Tully est','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105828,33.05,0.8,40.7,44900,75,NULL,NULL,'ESO 269- G 057',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105829,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105829,32.24,0.43,28,44900,75,NULL,'3.6 micron, color + selection bias corrected','ESO 269- G 057',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105830,'IRAS','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105830,30.98,0.8,15.7,44901,75,NULL,'A82, H','UGC 08246',NULL,'1997ApJS..109..333W',1997,1,3.5,NULL,'G',0.000037,NULL,'14.6',0.6,'SB(s)cd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,197.5185,34.18117,NULL,NULL,59158174416,924346475,14442913,14.6),(105831,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105831,30.84,0.43,14.7,44901,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08246',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105832,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105832,30.87,0.2,14.9,44901,74.4,NULL,NULL,'UGC 08246',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105833,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105833,30.9,0.43,15.1,44901,75,NULL,'3.6 micron, color corrected','UGC 08246',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105834,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105834,31.1,0.4,16.6,44901,NULL,NULL,'Virgo cluster at 15.6 Mpc','UGC 08246',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105835,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105835,31.11,0.46,16.7,44901,NULL,NULL,NULL,'UGC 08246',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105836,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105836,31.18,0.44,17.2,44901,NULL,NULL,'Malmquist cor.','UGC 08246',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105837,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105837,31.19,0.4,17.3,44901,75,NULL,'B','UGC 08246',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105838,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105838,31.46,0.47,19.6,44901,75,NULL,'A82, H, inv','UGC 08246',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105839,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105839,31.62,0.36,21.1,44901,NULL,NULL,NULL,'UGC 08246',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105840,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105840,31.67,0.47,21.6,44901,75,NULL,'A82, H, raw','UGC 08246',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105841,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105841,31.69,0.4,21.8,44901,75,NULL,NULL,'UGC 08246',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105842,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,NULL,105842,31.8,0.47,22.9,44901,75,NULL,'A82, H, cor','UGC 08246',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105843,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105843,32.14,0.49,26.8,44901,75,NULL,'IR','UGC 08246',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105844,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105844,37.92,0.27,383,44902,70,NULL,NULL,'2MASX J13100476+1359205',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000177,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,197.519833333,13.98894,0,NULL,59051420054,922678438,14416850,18),(105845,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105845,37.92,0.27,383,44903,70,NULL,NULL,'2MASX J13100607+1356345',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000171,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,197.5254583,13.943,0,NULL,59051466100,922679157,14416861,17.8),(105846,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105846,37.93,0.33,386,44904,70,NULL,NULL,'2MASX J13100680+5629582',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,197.52825,56.49939,0.013,NULL,57434814196,897418971,14022171,18.1),(105847,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105847,37.79,0.46,361,44905,70,NULL,NULL,'2MASX J13100714+1859297',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,197.529916667,18.9915,0.077,NULL,59031001588,922359399,14411865,17.3),(105848,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105848,36.78,0.46,227,44906,70,NULL,NULL,'2MASX J13100786+0236235',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000081,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,197.532875,2.60658,0.033,NULL,58061959174,907218112,14175283,17),(105849,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105849,37.66,0.46,340,44907,70,NULL,NULL,'2MASX J13100836+1136215',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,197.534833333,11.60608,0.011,NULL,58963617824,921306528,14395414,17.3),(105850,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105850,37.42,0.1,304,44908,70,NULL,NULL,'SDSS J131009.00+391617.8',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000145,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,197.5375417,39.27164,0,NULL,59305337534,926645898,14478842,17.7),(105851,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105851,37.42,0.1,304,44909,70,NULL,NULL,'2MASX J13100997+3909235',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000067,NULL,'15.5g',0.53,'cD m',NULL,NULL,NULL,NULL,1,197.5414583,39.15653,0,NULL,59305318670,926645604,14478837,15.5),(105852,'FP','2016-12-15 15:15:11','2016-12-16 11:20:22','1',NULL,'R',105852,37.92,0.27,383,44910,70,NULL,NULL,'2MASX J13101026+1400345',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000173,NULL,'17.0g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,197.5427083,14.00967,0,NULL,59051420884,922678451,14416850,17),(105853,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105853,37.65,0.46,339,44911,70,NULL,NULL,'2MASX J13101137+2806040',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,197.5475,28.10111,0.038,NULL,58719235677,917488057,14335750,17.7),(105854,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105854,37.88,0.23,376,44912,70,NULL,NULL,'SDSS J131011.61+105811.9',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000158,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,197.548416667,10.97,0.011,NULL,58964247714,921316370,14395568,17.2),(105855,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105855,38.06,0.27,409,44913,70,NULL,NULL,'2MASXi J1310120+645147',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000077,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,197.550333,64.86317,0.025,NULL,57352344821,896130387,14002037,18.1),(105856,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105856,37.06,0.46,258,44914,70,NULL,NULL,'2MASX J13101219+4517487',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000206,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,197.551,45.29681,0,NULL,59098220011,923409687,14428276,16.7),(105857,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105857,37.72,0.33,350,44915,70,NULL,NULL,'2MASX J13101249+0912305',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000169,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,197.552083,9.2085,0,NULL,58965866276,921341660,14395963,17.2),(105858,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105858,36.87,0.46,237,44916,70,NULL,NULL,'2MASX J13101436+4506547',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,197.5597083,45.11531,0,NULL,59098166791,923408856,14428263,17.4),(105859,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105859,37.42,0.1,304,44917,70,NULL,NULL,'2MASX J13101435+3905375',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000083,NULL,'17.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,197.55975,39.09378,0,NULL,59305145510,926642898,14478795,17.3),(105860,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105860,37.78,0.46,359,44918,70,NULL,NULL,'2MASX J13101516+5440045',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000219,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,197.563333,54.66789,0.019,NULL,57428279241,897316863,14020575,16.5),(105861,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105861,37.88,0.23,376,44919,70,NULL,NULL,'2MASX J13101553+1056175',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000169,NULL,'16.7g',0.34,'E',NULL,NULL,NULL,NULL,1,197.56475,10.93811,0.011,NULL,58964261786,921316590,14395571,16.7),(105862,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105862,35.58,0.68,131,44920,70,NULL,NULL,'2MASX J13101611-3252424',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.51',NULL,'*+Sp',NULL,NULL,NULL,NULL,1,197.567167,-32.87842,0.177,NULL,43320042085,676875657,10576182,14.51),(105863,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105863,37.33,0.46,292,44921,70,NULL,NULL,'SDSS J131016.46+150516.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000142,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,197.568625,15.08794,0.012,NULL,59053560710,922711886,14417373,18.6),(105864,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105864,36.95,0.46,245,44922,70,NULL,NULL,'2MASX J13101688+4005355',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000173,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,197.5705,40.09325,0,NULL,59300534070,926570844,14477669,16.4),(105865,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105865,38.69,0.46,547,44923,70,NULL,NULL,'SDSS J131017.32+104009.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000178,NULL,'18.7g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,197.5722083,10.66931,0,NULL,58964085686,921313838,14395528,18.7),(105866,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105866,37.42,0.1,304,44924,70,NULL,NULL,'2MASX J13101753+3858405',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000067,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,197.572958333,38.97789,0,NULL,59304659227,926635300,14478676,17.1),(105867,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105867,37.5,0.27,316,44925,70,NULL,NULL,'SDSS J131017.59-000726.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000065,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,197.573333,-0.12389,0.056,NULL,43088946880,673264795,10519762,18.1),(105868,'D-Sigma','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105868,33.57,0.4,51.8,44926,75,NULL,'Edat, raw','ESO 040- G 002',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000324,NULL,'13.87',1,'SA0-:',NULL,NULL,NULL,NULL,1,197.573875,-75.49656,0.909,NULL,44211208853,690800138,10793752,13.87),(105869,'D-Sigma','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105869,33.91,0.4,60.5,44926,75,NULL,'Edat, cor','ESO 040- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105870,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105870,33.22,0.4,44.1,44926,NULL,NULL,'mean','ESO 040- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105871,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105871,33.29,0.45,45.5,44926,NULL,NULL,'K','ESO 040- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105872,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105872,38,0.46,399,44927,70,NULL,NULL,'2MASX J13101880+6050438',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00018,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,197.578667,60.84564,0,NULL,57385164138,896643189,14010049,17.2),(105873,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105873,38.44,0.46,488,44928,70,NULL,NULL,'2MASX J13101990+1317481',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000164,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,197.582917,13.29675,0,NULL,59047754255,922621160,14415955,17.7),(105874,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105874,36.41,0.68,192,44929,70,NULL,NULL,'2MFGC 10493',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'12.1K',NULL,NULL,NULL,NULL,NULL,NULL,1,197.5830417,-21.88489,0.257,NULL,43805077637,684454338,10694599,12.1),(105875,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105875,37.48,0.46,313,44930,70,NULL,NULL,'2MASX J13101995+0418011',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000191,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,197.58325,4.30022,0.044,NULL,58057191102,907143610,14174118,16.5),(105876,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105876,34,0.44,63.2,44931,NULL,NULL,NULL,'UGC 08250',NULL,'2009ApJS..182..474S',2009,1,1.56,NULL,'G',0.00006,NULL,'15.2g',0.3,'Scd:',NULL,NULL,NULL,NULL,1,197.583917,32.48319,0.015,NULL,58683667248,916932300,14327067,15.2),(105877,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105877,34.05,0.49,64.7,44931,75,NULL,'IR','UGC 08250',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105878,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105878,34.13,0.2,67,44931,74.4,NULL,NULL,'UGC 08250',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105879,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105879,34.18,0.41,68.4,44931,NULL,NULL,'Malmquist cor.','UGC 08250',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105880,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105880,37.1,0.46,263,44932,70,NULL,NULL,'2MASX J13102018+0950365',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.84',0.21,NULL,NULL,NULL,NULL,NULL,1,197.584083,9.84344,0,NULL,58966067193,921344799,14396012,17.84),(105881,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105881,38.3,0.46,458,44933,70,NULL,NULL,'SDSS J131020.50+141210.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00017,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,197.585417,14.20281,0,NULL,59048789333,922637333,14416208,18.3),(105882,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105882,37.44,0.33,308,44934,70,NULL,NULL,'2MASX J13102081-0047363',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000075,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,197.586667,-0.79356,0.025,NULL,43091889253,673310769,10520480,17.2),(105883,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105883,38.21,0.46,438,44935,70,NULL,NULL,'SDSS J131021.13+111640.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,197.588083,11.27783,0.019,NULL,58964398829,921318731,14395605,18.1),(105884,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105884,38.86,0.46,592,44936,70,NULL,NULL,'LCRS B130746.5-030744',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000082,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,197.5889583,-3.39475,0.017,NULL,43095401356,673365646,10521338,18.3),(105885,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105885,37.81,0.46,364,44937,70,NULL,NULL,'2MASX J13102209+3119494',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,197.5922917,31.33025,0.017,NULL,58686204407,916971943,14327686,17.9),(105886,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105886,35.01,0.47,101,44938,NULL,NULL,'H','IC 4209',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000033,NULL,'14.48',0.5,'SB(rs)bc?',NULL,NULL,NULL,NULL,1,197.593708333,-7.17069,0.081,NULL,43884540781,685695949,10713999,14.48),(105887,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105887,35.06,0.4,103,44938,NULL,NULL,'mean','IC 4209',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105888,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105888,35.2,0.46,110,44938,NULL,NULL,'J','IC 4209',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105889,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105889,35.23,0.45,111,44938,NULL,NULL,'K','IC 4209',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105890,'IRAS','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105890,32.07,0.8,26,44939,75,NULL,'A82, H','ESO 443- G 079',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000017,NULL,'15.24',0.4,'IB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,197.5947083,-27.97703,0.273,NULL,43349460667,677335322,10583364,15.24),(105891,'IRAS','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105891,32.07,0.8,26,44939,75,NULL,'HMCL, I','ESO 443- G 079',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105892,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105892,31.46,0.47,19.6,44939,75,NULL,'A82, H, inv','ESO 443- G 079',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105893,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105893,31.73,0.47,22.2,44939,75,NULL,'A82, H, raw','ESO 443- G 079',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105894,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105894,31.87,0.4,23.7,44939,75,NULL,'HMCL, I, inv','ESO 443- G 079',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105895,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105895,31.97,0.4,24.8,44939,75,NULL,'HMCL, I, raw','ESO 443- G 079',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105896,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105896,32.06,0.79,25.8,44939,NULL,NULL,NULL,'ESO 443- G 079',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105897,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105897,32.1,0.2,26.3,44939,74.4,NULL,NULL,'ESO 443- G 079',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105898,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105898,32.11,0.47,26.4,44939,75,NULL,'A82, H, cor','ESO 443- G 079',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105899,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105899,32.12,0.38,26.5,44939,NULL,NULL,NULL,'ESO 443- G 079',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105900,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105900,32.25,0.4,28.2,44939,75,NULL,'HMCL, I, cor','ESO 443- G 079',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105901,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105901,32.39,0.67,30.1,44939,NULL,NULL,'Malmquist cor.','ESO 443- G 079',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105902,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105902,35.85,0.46,148,44940,70,NULL,NULL,'SDSS J131023.14+300533.9',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00017,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,197.5964583,30.09278,0.054,NULL,58682737392,916917771,14326840,16.5),(105903,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105903,34.26,0.33,71.1,44941,70,NULL,NULL,'ARK 404',NULL,'2015arXiv151105856S',2015,1,1.01,NULL,'G',0.00008,NULL,'14.4g',0.58,'S0',NULL,NULL,NULL,NULL,1,197.5990417,-1.01053,0.025,NULL,43091934053,673311469,10520491,14.4),(105904,'Sosies','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105904,34.56,0.12,81.7,44942,NULL,NULL,NULL,'ESO 576- G 001',NULL,'2002A&A...393...57T',2002,1,1.2,'1998AJ....116....1D has V = 2965 +- 4 km/s.','G',0.000033,NULL,'14.81',0.7,'(R\'_2:)SB(r)bc',NULL,NULL,NULL,NULL,1,197.599,-21.68414,0.245,NULL,43804959919,684452498,10694570,14.81),(105905,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105905,33.27,0.4,45.1,44942,NULL,NULL,'mean','ESO 576- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105906,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105906,34.45,0.45,77.7,44942,NULL,NULL,'K','ESO 576- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105907,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105907,34.51,0.46,79.8,44942,NULL,NULL,'J','ESO 576- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105908,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105908,34.54,0.47,80.9,44942,NULL,NULL,'H','ESO 576- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105909,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105909,35.27,0.47,113,44942,NULL,NULL,'Malmquist cor.','ESO 576- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105910,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105910,35.42,0.44,121,44942,NULL,NULL,NULL,'ESO 576- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105911,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105911,35.46,0.2,124,44942,74.4,NULL,NULL,'ESO 576- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105912,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105912,37.46,0.46,310,44943,70,NULL,NULL,'2MASX J13102403+4436268',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,197.600125,44.6075,0,NULL,59278243583,926222555,14472227,18),(105913,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105913,38,0.46,398,44944,70,NULL,NULL,'SDSS J131025.77+310912.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000161,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,197.607375,31.15342,0.017,NULL,58686214306,916972098,14327689,18.1),(105914,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105914,36.7,0.46,219,44945,70,NULL,NULL,'2MASX J13102608+2042346',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,197.608667,20.70969,NULL,NULL,58811186930,918924795,14358199,16.7),(105915,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105915,37.65,0.46,339,44946,70,NULL,NULL,'2MASX J13102617+0040451',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00009,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,197.6090417,0.67933,0.065,NULL,58058342924,907161608,14174400,16.6),(105916,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105916,37.02,0.46,253,44947,70,NULL,NULL,'2MASX J13102656+1654061',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.27',0.23,NULL,NULL,NULL,NULL,NULL,1,197.6107083,16.90167,0,NULL,59043154036,922549281,14414832,17.27),(105917,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105917,33.37,0.2,47.2,44948,74.4,NULL,NULL,'UGC 08248',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'15.03',0.4,'Sb',NULL,NULL,NULL,NULL,1,197.6145,18.43811,0.083,NULL,59031340814,922364700,14411948,15.03),(105918,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105918,33.53,0.47,50.7,44948,NULL,NULL,'H','UGC 08248',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105919,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105919,33.62,0.45,53,44948,NULL,NULL,'K','UGC 08248',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105920,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105920,33.76,0.46,56.6,44948,NULL,NULL,'J','UGC 08248',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105921,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105921,33.82,0.4,58.1,44948,NULL,NULL,'mean','UGC 08248',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105922,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105922,37.34,0.23,293,44949,70,NULL,NULL,'2MASX J13102750+5426456',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000189,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,197.614917,54.44608,0.019,NULL,57427554094,897305532,14020398,17),(105923,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105923,36.6,0.46,209,44950,70,NULL,NULL,'2MASX J13102800+3834571',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000189,NULL,'15.7g',0.41,NULL,NULL,NULL,NULL,NULL,1,197.616625,38.58253,0,NULL,59304824582,926637884,14478716,15.7),(105924,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105924,34.71,0.4,87.7,44951,NULL,NULL,'Malmquist cor.','MCG -01-34-010',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.00001,NULL,'14.64',0.4,'S pec',NULL,NULL,NULL,NULL,1,197.618083,-7.65042,0.109,NULL,43882615758,685665871,10713529,14.64),(105925,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105925,34.86,0.38,93.7,44951,NULL,NULL,NULL,'MCG -01-34-010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105926,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105926,34.9,0.2,95.5,44951,74.4,NULL,NULL,'MCG -01-34-010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105927,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105927,37.91,0.46,382,44952,70,NULL,NULL,'2MASX J13102826+4811341',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,197.6179583,48.19272,0,NULL,59103074082,923485532,14429461,17.8),(105928,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105928,37.87,0.46,375,44953,70,NULL,NULL,'2MASX J13102865+1748111',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.57',0.16,NULL,NULL,NULL,NULL,NULL,1,197.6195,17.80306,0.03,NULL,59039343711,922489745,14413902,18.57),(105929,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105929,38.07,0.46,410,44954,70,NULL,NULL,'2MASX J13102871+0512421',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000176,NULL,'17.5g',0.21,'AGN',NULL,NULL,NULL,NULL,1,197.6197083,5.21175,0,NULL,58053553718,907086776,14173230,17.5),(105930,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105930,36.24,0.53,177,44955,70,NULL,NULL,'2MASX J13102895-2159015',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.29',0.5,NULL,NULL,NULL,NULL,NULL,1,197.620583,-21.984,0.257,NULL,43805086728,684454480,10694601,16.29),(105931,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105931,38.4,0.23,479,44956,70,NULL,NULL,'2MASX J13102904+0820355',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,197.621167,8.34325,0.02,NULL,58978436286,921538066,14399032,17.5),(105932,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105932,38.04,0.46,405,44957,70,NULL,NULL,'2MASX J13102926+3507094',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,197.622041667,35.11939,0.01,NULL,59160559338,924383739,14443495,18.1),(105933,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105933,36.8,0.46,229,44958,70,NULL,NULL,'2MASX J13102978+3946041',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000176,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,197.623916667,39.76781,0,NULL,59304955850,926639935,14478748,16.9),(105934,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105934,35.62,0.43,133,44959,NULL,NULL,'Malmquist cor.','ESO 323- G 088',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.41',0.6,'Sb',NULL,NULL,NULL,NULL,1,197.632583,-42.71797,0.405,NULL,46931027152,733297299,11457770,15.41),(105935,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105935,35.63,0.42,134,44959,NULL,NULL,NULL,'ESO 323- G 088',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105936,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105936,35.67,0.2,136,44959,74.4,NULL,NULL,'ESO 323- G 088',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105937,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105937,38.4,0.23,479,44960,70,NULL,NULL,'2MASX J13103194+0820285',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,197.633125,8.34108,0.02,NULL,58978436202,921538065,14399032,17.2),(105938,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105938,36.87,0.46,236,44961,70,NULL,NULL,'2MASX J13103204+3636121',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000178,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,197.633541667,36.60347,0,NULL,59292426302,926444160,14475690,16.7),(105939,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105939,38.4,0.23,479,44962,70,NULL,NULL,'2MASX J13103241+0822335',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,197.635125,8.37606,0.02,NULL,58978438202,921538096,14399032,17.1),(105940,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105940,37.17,0.46,272,44963,70,NULL,NULL,'2MASX J13103285+1109285',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.68',0.23,NULL,NULL,NULL,NULL,NULL,1,197.636833,11.15792,0.019,NULL,58964421500,921319085,14395610,17.68),(105941,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105941,27.8,0.1,3.63,44964,NULL,NULL,NULL,'ESO 269- G 058',NULL,'2012A&A...540A..49M',2012,1,3,'ESO-LV gives v = 1853 km/sec.','G',NULL,NULL,'13.29',1.8,'I0 pec',NULL,NULL,NULL,NULL,1,197.6372083,-46.99092,0.597,NULL,46731828485,730184820,11409137,13.29),(105942,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105942,27.87,0.1,3.75,44964,74.4,NULL,NULL,'ESO 269- G 058',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105943,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105943,27.87,0.11,3.75,44964,NULL,NULL,NULL,'ESO 269- G 058',NULL,'2015ApJ...802L..25T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105944,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105944,27.9,NULL,3.8,44964,NULL,NULL,NULL,'ESO 269- G 058',NULL,'2007AJ....133..504K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105945,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105945,27.91,0.02,3.82,44964,NULL,NULL,'I','ESO 269- G 058',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105946,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105946,27.93,0.18,3.85,44964,NULL,NULL,NULL,'ESO 269- G 058',NULL,'2007AJ....134.1799D',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105947,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105947,37.46,0.46,311,44965,70,NULL,NULL,'2MASXi J1310330-011251',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000074,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,197.6375,-1.21425,0.021,NULL,43092121856,673314404,10520537,17.8),(105948,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105948,37.54,0.46,322,44966,70,NULL,NULL,'2MASX J13103351+2704379',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000161,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,197.6395417,27.07714,0.027,NULL,58718251416,917472678,14335510,17),(105949,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105949,38.04,0.46,405,44967,70,NULL,NULL,'2MASX J13103378+0304181',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,197.64075,3.07169,0.045,NULL,58055389280,907115457,14173679,17.6),(105950,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105950,38.4,0.23,479,44968,70,NULL,NULL,'SDSS J131033.97+082051.2',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,197.641541667,8.34756,0.02,NULL,58978450249,921538285,14399035,17.2),(105951,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105951,36.03,0.23,161,44969,70,NULL,NULL,'UGC 08251',NULL,'2015arXiv151105856S',2015,1,1.09,NULL,'G',0.00008,NULL,'15.1g',0.45,'S0',NULL,NULL,NULL,NULL,1,197.642375,34.63625,0.005,NULL,59160512590,924383009,14443484,15.1),(105952,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105952,36.84,0.46,234,44970,70,NULL,NULL,'2MASX J13103517+3937091',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,197.646667,39.61922,0,NULL,59304933546,926639586,14478743,17.7),(105953,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105953,38.7,0.46,551,44971,70,NULL,NULL,'2MASX J13103559+0408501',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000182,NULL,'17.3g',0.24,'BrClG',NULL,NULL,NULL,NULL,1,197.6482917,4.14714,0.044,NULL,58057215514,907143992,14174124,17.3),(105954,'D-Sigma','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105954,33.38,0.4,47.4,44972,75,NULL,'Edat, raw','ESO 323- G 089',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.00007,NULL,'13.60',1,'(RL)SA(l)0^0',NULL,NULL,NULL,NULL,1,197.6484583,-39.60442,0.337,NULL,46940981430,733452834,11460200,13.6),(105955,'D-Sigma','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105955,33.71,0.4,55.3,44972,75,NULL,'Edat, cor','ESO 323- G 089',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105956,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105956,33.2,0.4,43.6,44972,NULL,NULL,'mean','ESO 323- G 089',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105957,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105957,33.8,0.45,57.5,44972,NULL,NULL,'K','ESO 323- G 089',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105958,'IRAS','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105958,33.06,0.8,40.9,44973,75,NULL,'MAT, I','ESO 576- G 003',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000017,NULL,'14.00',0.7,'SB(s)c pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,197.6487917,-21.74825,0.245,NULL,43804957843,684452466,10694569,14),(105959,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105959,31.91,0.32,24.1,44973,85,NULL,'I, inv','ESO 576- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105960,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105960,31.93,0.32,24.3,44973,85,NULL,'I, raw','ESO 576- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105961,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105961,32.27,0.4,28.4,44973,NULL,NULL,NULL,'ESO 576- G 003',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105962,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105962,32.32,0.43,29.1,44973,75,NULL,'MAT, I, raw','ESO 576- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105963,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105963,32.35,0.43,29.5,44973,75,NULL,'MAT, I, inv','ESO 576- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105964,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105964,32.38,0.2,29.9,44973,74.4,NULL,NULL,'ESO 576- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105965,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105965,32.46,0.43,31.1,44973,75,NULL,'3.6 micron, color corrected','ESO 576- G 003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105966,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105966,32.51,0.43,31.7,44973,75,NULL,'3.6 micron, color + selection bias corrected','ESO 576- G 003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105967,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105967,32.6,0.43,33.1,44973,75,NULL,'MAT, I, cor','ESO 576- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105968,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105968,33.31,0.1,46,44973,NULL,NULL,NULL,'ESO 576- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105969,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105969,36.72,0.33,221,44974,70,NULL,NULL,'SDSS J131035.73+491942.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000174,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,197.648875,49.32839,0,NULL,59092157661,923314963,14426796,17.6),(105970,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105970,36.8,0.46,229,44975,70,NULL,NULL,'2MASX J13103602+4251109',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000174,NULL,'16.1g',0.3,'S0^-',NULL,NULL,NULL,NULL,1,197.650167,42.85306,0,NULL,59299940405,926561568,14477524,16.1),(105971,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105971,38.36,0.33,469,44976,70,NULL,NULL,'2MASX J13103643+1346121',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,197.651833333,13.77011,0,NULL,59051170406,922674537,14416789,17),(105972,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105972,37.53,0.46,320,44977,70,NULL,NULL,'2MASX J13103663+2739319',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,197.6525417,27.65892,0.033,NULL,58718849562,917482024,14335656,17),(105973,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105973,35.72,0.53,139,44978,70,NULL,NULL,'ESO 382- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000117,NULL,'15.74',0.4,'(R\')SB(s)b    LINER?',NULL,NULL,NULL,NULL,1,197.654083333,-37.29997,0.133,NULL,46928684687,733260698,11457198,15.74),(105974,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105974,37.28,0.46,286,44979,70,NULL,NULL,'2MASX J13103697+1507081',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000153,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,197.65425,15.11881,0.012,NULL,59053566568,922711977,14417374,17),(105975,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105975,37.12,0.23,266,44980,70,NULL,NULL,'SDSS J131037.23+022115.9',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000184,NULL,'15.8g',0.45,'E0',NULL,NULL,NULL,NULL,1,197.655167,2.35442,0.025,NULL,58061873829,907216778,14175262,15.8),(105976,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105976,37.34,0.23,293,44981,70,NULL,NULL,'2MASX J13103725+5429405',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000181,NULL,'16.3g',0.39,'BrClG',NULL,NULL,NULL,NULL,1,197.6552083,54.49467,0.019,NULL,57427555305,897305551,14020399,16.3),(105977,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105977,30.42,0.43,12.2,44982,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5002',NULL,'2014MNRAS.444..527S',2014,1,1.44,'Multiple SDSS entries describe this galaxy.','G',0.00002,NULL,'14.5g',0.71,'SBm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,197.658375,36.63392,0,NULL,59292427033,926444172,14475690,14.5),(105978,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105978,37.44,0.33,308,44983,70,NULL,NULL,'2MASX J13103821-0039242',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00009,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,197.659125,-0.65683,0.025,NULL,43088742067,673261594,10519712,16.5),(105979,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105979,37.12,0.23,266,44984,70,NULL,NULL,'2MASX J13103725+0221161',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,'FoF','17.25',0.19,NULL,NULL,NULL,NULL,NULL,1,197.659667,2.35997,0.025,NULL,58061873965,907216780,14175262,17.25),(105980,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105980,37.76,0.46,356,44985,70,NULL,NULL,'2MASX J13103881-0033412',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000088,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,197.66175,-0.5615,0.009,NULL,43088751459,673261741,10519714,17.3),(105981,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105981,37.93,0.33,386,44986,70,NULL,NULL,'2MASX J13103906+5629215',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000167,NULL,'16.8g',0.33,NULL,NULL,NULL,NULL,NULL,1,197.662833333,56.48922,0,NULL,57434807551,897418867,14022169,16.8),(105982,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105982,37.88,0.23,376,44987,70,NULL,NULL,'2MASX J13103936+1100137',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,197.6640417,11.00394,0.019,NULL,58964147372,921314802,14395543,17.3),(105983,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105983,37.12,0.23,266,44988,70,NULL,NULL,'2MASX J13103978+0223338',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000173,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,197.665667,2.39275,0.025,NULL,58061844262,907216316,14175254,17.3),(105984,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105984,37.34,0.23,293,44989,70,NULL,NULL,'SDSS J131041.25+542322.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000152,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,197.671917,54.3895,0,NULL,57427519156,897304986,14020390,18.4),(105985,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105985,34.16,0.49,67.9,44990,75,NULL,'IR','IC 0856',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000027,NULL,'15.1',0.3,'Sab',NULL,NULL,NULL,NULL,1,197.673375,20.53678,NULL,NULL,58811115867,918923685,14358182,15.1),(105986,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105986,38.36,0.33,469,44991,70,NULL,NULL,'2MASX J13104233+1346230',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,197.676417,13.77308,0,NULL,59051170898,922674545,14416789,17.8),(105987,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105987,34.98,NULL,99,44992,NULL,NULL,'Dipole + Quadrupole + Octopole','LSBC F576-03',NULL,'2010Ap&SS.325..163P',2010,1,0.84,NULL,'G',NULL,NULL,'17.17',0.09,'Scd',NULL,NULL,NULL,NULL,1,197.677833,21.36708,0.042,NULL,58820185362,919065396,14360396,17.17),(105988,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105988,35,NULL,100,44992,NULL,NULL,'Dipole + Quadrupole','LSBC F576-03',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105989,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105989,35.01,NULL,101,44992,NULL,NULL,'Dipole','LSBC F576-03',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105990,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105990,38.15,0.46,426,44993,70,NULL,NULL,'2MASX J13104282-0155006',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.0001,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,197.6782917,-1.91681,0.025,NULL,43089566148,673274471,10519913,17),(105991,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105991,38.36,0.46,471,44994,70,NULL,NULL,'2MASX J13104299+0053318',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000108,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,197.6790417,0.89211,0.034,NULL,58061543921,907211623,14175181,17.1),(105992,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105992,37.33,0.63,293,44995,70,NULL,NULL,'2MASX J13104334-2050246',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.24',NULL,NULL,NULL,NULL,NULL,NULL,1,197.680541667,-20.84022,0.233,NULL,43798259754,684347808,10692934,16.24),(105993,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105993,37.42,0.1,304,44996,70,NULL,NULL,'2MASX J13104341+3914132',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000067,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,197.681,39.23686,0,NULL,59305151461,926642991,14478796,16.7),(105994,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105994,36.61,0.46,210,44997,70,NULL,NULL,'2MASX J13104374+5532285',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000171,NULL,'16.1g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,197.682167,55.54125,0.013,NULL,57425231943,897269249,14019832,16.1),(105995,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105995,37.42,0.1,304,44998,70,NULL,NULL,'2MASX J13104436+3905342',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000067,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,197.6847917,39.09292,0,NULL,59305137962,926642780,14478793,16.2),(105996,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',105996,35.59,0.46,131,44999,70,NULL,NULL,'2MASX J13104520+6410419',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000072,NULL,'16.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,197.688375,64.17836,0.025,NULL,57351557082,896118079,14001844,16.4),(105997,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105997,35.98,0.56,157,45000,70,NULL,NULL,'2MASX J13104530-1746165',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.47',0.5,NULL,NULL,NULL,NULL,NULL,1,197.688833,-17.77139,0.153,NULL,44007205193,687612581,10743946,16.47),(105998,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105998,36.09,0.66,165,45001,70,NULL,NULL,'LCRS B130807.3-121858',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.96',0.3,NULL,NULL,NULL,NULL,NULL,1,197.6895,-12.58186,0.073,NULL,44010916064,687670563,10744852,16.96),(105999,'Tully est','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,105999,33.01,0.8,40,45002,75,NULL,NULL,'UGCA 331',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000022,NULL,'14.28',1.8,'SB(rs)c:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,197.691416667,-23.86575,0.273,NULL,43795262437,684300975,10692202,14.28),(106000,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106000,34.46,0.43,77.9,45003,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5004B',NULL,'2014MNRAS.444..527S',2014,1,0.8,NULL,'G',0.000009,NULL,'15.20',0.52,'Sc             Sbrst','Group member',NULL,NULL,NULL,1,197.6985417,29.70989,0.031,NULL,58712930292,917389535,14334211,15.2),(106001,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106001,34.5,0.43,79.6,45003,75,NULL,'3.6 micron, color corrected','NGC 5004B',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106002,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106002,34.6,0.2,83.2,45003,74.4,NULL,NULL,'NGC 5004B',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106003,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106003,35.08,0.08,104,45003,NULL,NULL,NULL,'NGC 5004B',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106004,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106004,36.92,0.46,243,45004,70,NULL,NULL,'2MASX J13104806+1657594',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.50',0.22,NULL,NULL,NULL,NULL,NULL,1,197.700167,16.96656,0,NULL,59043206922,922550108,14414845,17.5),(106005,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106005,38.33,0.21,463,45005,70,NULL,NULL,'2MASX J13104893+0007318',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000076,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,197.7039583,0.12544,0.044,NULL,58058013779,907156465,14174319,18.2),(106006,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106006,37.77,0.46,358,45006,70,NULL,NULL,'2MASX J13104905+1244504',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,197.7042917,12.74733,0.015,NULL,59048407435,922631366,14416115,17.8),(106007,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106007,37.66,0.46,340,45007,70,NULL,NULL,'2MASX J13104907+0614167',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,197.704375,6.23792,0,NULL,58977104727,921517261,14398707,17.4),(106008,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106008,37.42,0.1,304,45008,70,NULL,NULL,'2MASX J13105049+3930032',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000087,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,197.710333333,39.50094,0,NULL,59305004344,926640692,14478760,16.7),(106009,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106009,34.96,0.49,98.1,45009,75,NULL,'IR','UGC 08257',NULL,'2011yCatp016004901K',2011,1,1.68,NULL,'G',0.000107,NULL,'15.5g',0.23,'Scd',NULL,NULL,NULL,NULL,1,197.7104583,49.89272,0,NULL,59093473680,923335526,14427117,15.5),(106010,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106010,35.47,NULL,124,45009,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08257',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106011,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106011,35.5,NULL,126,45009,NULL,NULL,'Dipole + Quadrupole','UGC 08257',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106012,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106012,35.51,NULL,126,45009,NULL,NULL,NULL,'UGC 08257',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106013,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106013,35.53,NULL,127,45009,NULL,NULL,'Dipole','UGC 08257',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106014,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106014,37.94,0.46,387,45010,70,NULL,NULL,'2MASX J13105152+0244108',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,197.7147083,2.73625,0.028,NULL,58062606876,907228232,14175441,17.2),(106015,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106015,37.42,0.1,304,45011,70,NULL,NULL,'2MASX J13105299+3929292',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00008,NULL,'17.84',0.16,NULL,NULL,NULL,NULL,NULL,1,197.720916667,39.49158,0,NULL,59305004504,926640695,14478760,17.84),(106016,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106016,37.42,0.1,304,45012,70,NULL,NULL,'2MASX J13105374+3914481',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,197.724,39.24661,0,NULL,59305161905,926643154,14478799,17.9),(106017,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106017,37.68,0.46,343,45013,70,NULL,NULL,'2MASX J13105418+0736367',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,197.725917,7.61028,0.014,NULL,58978677474,921541835,14399091,17.1),(106018,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106018,38.29,0.46,454,45014,70,NULL,NULL,'SDSS J131054.36+050307.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000133,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,197.7265,5.05211,0.014,NULL,58053502049,907085969,14173218,18.7),(106019,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106019,38.33,0.21,463,45015,70,NULL,NULL,'2MASX J13105453+0003498',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00009,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,197.727333333,0.06397,0.044,NULL,58058010569,907156415,14174318,17.2),(106020,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106020,38.33,0.21,463,45016,70,NULL,NULL,'2MASX J13105479+0010468',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000103,NULL,'16.8g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,197.728208333,0.17969,0.044,NULL,58057998625,907156228,14174316,16.8),(106021,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106021,37.01,0.46,252,45017,70,NULL,NULL,'2MASX J13105552+0730147',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'17.99',0.14,NULL,NULL,NULL,NULL,NULL,1,197.73125,7.50425,0.025,NULL,58978720515,921542508,14399101,17.99),(106022,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106022,35.78,0.2,143,45018,74.4,NULL,NULL,'CGCG 072-011 NED01',NULL,'2013AJ....146...86T',2013,1,0.64,NULL,'G',0.000075,NULL,'15.8g',0.21,'Im',NULL,NULL,NULL,NULL,1,197.732583,11.87478,0.01,NULL,58992934086,921764595,14402571,15.8),(106023,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106023,37.42,0.1,304,45019,70,NULL,NULL,'SDSS J131055.93+392904.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,197.733083333,39.48453,0,NULL,59305004934,926640702,14478760,17.5),(106024,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:23','1','SN 1996ai',NULL,106024,30.68,0.3,13.7,45020,60,NULL,NULL,'NGC 5005',NULL,'2005ApJ...624..532R',2005,1,5.8,NULL,'G',0.000017,NULL,'10.61',2.8,'SAB(rs)bc;Sy2  LINER','in a radial-velocity based grouping',NULL,NULL,'LINER b',1,197.734291667,37.05919,0,NULL,59292528106,926445751,14475714,10.61),(106025,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:23','1','SN 1996ai',NULL,106025,30.76,0.25,14.1,45020,72,NULL,NULL,'NGC 5005',0.00316,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106026,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:23','1','SN 1996ai',NULL,106026,30.96,0.74,15.5,45020,74.2,NULL,'SALT 2','NGC 5005',0.00316,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106027,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:23','1','SN 1996ai',NULL,106027,31.09,0.17,16.5,45020,70.8,NULL,NULL,'NGC 5005',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106028,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:23','1','SN 1996ai',NULL,106028,31.15,0.19,16.9,45020,65,NULL,'MLCS2k2','NGC 5005',0.00316,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106029,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:23','1','SN 1996ai',NULL,106029,31.27,0.08,18,45020,74.4,NULL,NULL,'NGC 5005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106030,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:23','1','SN 1996ai',NULL,106030,32.7,0.74,34.6,45020,70,NULL,'SALT','NGC 5005',0.00316,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106031,'Tully est','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106031,31.64,0.8,21.3,45020,75,NULL,'B','NGC 5005',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106032,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106032,31.27,0.08,18,45020,74.4,NULL,NULL,'NGC 5005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106033,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106033,31.35,0.4,18.6,45020,75,NULL,'HOSTS SN 1996ai','NGC 5005',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106034,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106034,31.65,0.36,21.4,45020,NULL,NULL,NULL,'NGC 5005',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106035,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106035,31.76,0.43,22.5,45020,75,NULL,'3.6 micron, color corrected','NGC 5005',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106036,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106036,31.79,NULL,22.8,45020,NULL,NULL,'LEDA [April 2006]','NGC 5005',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106037,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106037,31.92,0.4,24.2,45020,75,NULL,'HOSTS SN 1996ai','NGC 5005',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106038,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106038,31.92,0.43,24.2,45020,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5005',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106039,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106039,31.97,0.3,24.8,45020,55,NULL,'B','NGC 5005',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106040,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106040,32,0.42,25.1,45020,NULL,18.48,'3.6 micron','NGC 5005',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106041,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106041,37.42,0.1,304,45021,70,NULL,NULL,'2MASX J13105632+3912421',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.0001,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,197.734583,39.21158,0,NULL,59305164357,926643193,14478799,17.6),(106042,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:23','1','SN 2009nr','R',106042,32.93,0.04,38.5,45022,NULL,NULL,NULL,'UGC 08255',NULL,'2011AstL...37..775T',2011,1,1.27,NULL,'G',0.000002,NULL,'14.3g',0.97,'Scd:','Pair member, wide',NULL,NULL,NULL,1,197.7355,11.47736,0.009,NULL,58963729581,921308274,14395441,14.3),(106043,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:23','1','SN 2009nr',NULL,106043,33.27,0.15,45.1,45022,NULL,NULL,NULL,'UGC 08255',NULL,'2011ApJ...726..106K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106044,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106044,33.33,0.6,46.4,45022,NULL,NULL,'Malmquist cor.','UGC 08255',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106045,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106045,33.56,0.54,51.6,45022,NULL,NULL,NULL,'UGC 08255',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106046,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106046,33.6,0.2,52.5,45022,74.4,NULL,NULL,'UGC 08255',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106047,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106047,37.34,0.23,293,45023,70,NULL,NULL,'2MASX J13105677+5426576',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00017,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,197.7365,54.44947,0,NULL,57427551245,897305488,14020398,16.8),(106048,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106048,37.31,0.27,290,45024,70,NULL,NULL,'2MASX J13105819+4626064',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000189,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,197.742417,46.43519,0,NULL,59099566626,923430728,14428605,16.4),(106049,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106049,37.88,0.23,376,45025,70,NULL,NULL,'2MASX J13105859+1107157',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000174,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,197.74425,11.12111,0.019,NULL,58964434530,921319289,14395613,17),(106050,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106050,37.54,0.46,322,45026,70,NULL,NULL,'2MASX J13105878+0812597',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.38',0.16,NULL,NULL,NULL,NULL,NULL,1,197.744875,8.21656,0.021,NULL,58978411455,921537678,14399026,18.38),(106051,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106051,37.7,0.46,347,45027,70,NULL,NULL,'2MASX J13105874+5300280',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,197.744917,53.00789,0.028,NULL,57414014322,897093973,14017093,17.7),(106052,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106052,37.77,0.27,358,45028,70,NULL,NULL,'2MASX J13105928+1917398',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.46',0.14,NULL,NULL,NULL,NULL,NULL,1,197.7470417,19.29428,0.08,NULL,59030953411,922358647,14411853,18.46),(106053,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106053,38.33,0.21,463,45029,70,NULL,NULL,'2MASX J13105948+0007373',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000095,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,197.7479583,0.12694,0.044,NULL,58058000734,907156261,14174316,18.5),(106054,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106054,38.16,0.46,429,45030,70,NULL,NULL,'SDSS J131059.96+644412.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000065,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,197.749875,64.73678,0.025,NULL,57352284795,896129449,14002022,18.4),(106055,'SZ effect','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106055,40.7,0.68,1380,45031,NULL,NULL,'Hydrost. Eq.','MACS J1311.0-0311',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,197.757917,-3.17667,0.025,NULL,43094986682,673359166,10521236,NULL),(106056,'SZ effect','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106056,40.88,1.01,1500,45031,NULL,NULL,'Isotherm., r < 100 kpc','MACS J1311.0-0311',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106057,'SZ effect','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106057,41.47,0.76,1970,45031,NULL,NULL,'Isotherm.','MACS J1311.0-0311',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106058,'SZ effect','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106058,41.63,NULL,2120,45031,NULL,NULL,'3.1 (red) calibration','MACS J1311.0-0311',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106059,'SZ effect','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106059,42,NULL,2510,45031,NULL,NULL,'4.2 (black) calibration','MACS J1311.0-0311',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106060,'SZ effect','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106060,42.12,NULL,2660,45031,NULL,NULL,'4.1 (blue) calibration','MACS J1311.0-0311',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106061,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106061,37.9,0.46,380,45032,70,NULL,NULL,'2MASX J13110001+0507168',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,197.750125,5.12128,0,NULL,58053493798,907085840,14173216,17.3),(106062,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106062,37.58,0.46,328,45033,70,NULL,NULL,'2MASX J13110107+0621497',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,197.754583,6.36372,0.013,NULL,58977135577,921517743,14398714,17.5),(106063,'Tully est','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106063,31.29,0.8,18.1,45034,75,NULL,NULL,'UGC 08261',NULL,'1988NBGC.C....0000T',1988,1,0.64,'Eccentric nucleus.','G',0.000013,NULL,'16.2g',0.49,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,197.75375,35.5025,0.026,NULL,59160027422,924375428,14443366,16.2),(106064,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106064,33.23,0.4,44.3,45034,NULL,NULL,NULL,'UGC 08261',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106065,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106065,34.66,0.25,85.5,45035,74.4,NULL,NULL,'NGC 5004',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000036,NULL,'13.89',1.1,'S0','in a pair',NULL,NULL,NULL,1,197.7564583,29.63669,0.031,NULL,58712922108,917389407,14334209,13.89),(106066,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106066,34.66,0.46,85.6,45035,70,NULL,NULL,'NGC 5004',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106067,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106067,34.96,0.45,98.3,45035,NULL,NULL,'K','NGC 5004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106068,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106068,35.12,0.4,105,45035,NULL,NULL,'mean','NGC 5004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106069,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106069,34.17,0.43,68.4,45036,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5004C',NULL,'2014MNRAS.444..527S',2014,1,1.38,NULL,'G',0.000016,NULL,'14.6g',0.56,'SBab           Sbrst','Group member',NULL,NULL,NULL,1,197.757083,29.57828,0.031,NULL,58712920168,917389377,14334209,14.6),(106070,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106070,34.23,0.43,70.2,45036,75,NULL,'3.6 micron, color corrected','NGC 5004C',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106071,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106071,34.37,0.2,74.8,45036,74.4,NULL,NULL,'NGC 5004C',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106072,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106072,35.19,0.4,109,45036,NULL,NULL,'mean','NGC 5004C',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106073,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106073,35.28,0.47,114,45036,NULL,NULL,'H','NGC 5004C',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106074,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106074,35.37,0.45,119,45036,NULL,NULL,'K','NGC 5004C',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106075,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106075,33.3,0.55,45.6,45037,70,NULL,NULL,'ESO 269- G 061',NULL,'2014MNRAS.445.2677S',2014,1,2.5,NULL,'G',0.000033,NULL,'13.94',0.7,'Sb: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,197.757541667,-44.59253,0.509,NULL,46952009845,733625153,11462893,13.94),(106076,'IRAS','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106076,34.19,0.8,68.7,45037,75,NULL,'MAT, I','ESO 269- G 061',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106077,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106077,33.92,0.45,60.7,45037,NULL,NULL,'K','ESO 269- G 061',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106078,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106078,33.92,0.46,60.8,45037,NULL,NULL,'J','ESO 269- G 061',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106079,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106079,33.92,0.47,60.9,45037,NULL,NULL,'H','ESO 269- G 061',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106080,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106080,34.07,0.43,65.1,45037,75,NULL,'MAT, I, raw','ESO 269- G 061',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106081,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106081,34.12,0.41,66.5,45037,NULL,NULL,'Malmquist cor.','ESO 269- G 061',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106082,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106082,34.12,0.49,66.7,45037,75,NULL,'IR','ESO 269- G 061',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106083,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106083,34.18,0.43,68.4,45037,75,NULL,'MAT, I, cor','ESO 269- G 061',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106084,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106084,34.2,0.4,69.3,45037,NULL,NULL,'mean','ESO 269- G 061',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106085,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106085,34.27,0.32,71.6,45037,85,NULL,'I, raw','ESO 269- G 061',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106086,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106086,34.36,0.32,74.5,45037,85,NULL,'I, inv','ESO 269- G 061',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106087,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106087,34.41,0.43,76.3,45037,75,NULL,'MAT, I, inv','ESO 269- G 061',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106088,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106088,34.53,0.34,80.7,45037,NULL,NULL,NULL,'ESO 269- G 061',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106089,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106089,34.58,0.2,82.4,45037,74.4,NULL,NULL,'ESO 269- G 061',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106090,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106090,38.13,0.46,422,45038,70,NULL,NULL,'SDSS J131102.21+024552.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,197.7592083,2.76453,0.028,NULL,58062617998,907228406,14175443,18.2),(106091,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106091,37.7,0.46,346,45039,70,NULL,NULL,'2MASX J13110236+5242478',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000141,NULL,'17.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,197.759916667,52.71319,0,NULL,57197203349,893706302,13964160,17.9),(106092,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106092,38.33,0.21,463,45040,70,NULL,NULL,'2MASXi J1311030+000307',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000078,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,197.762875,0.05217,0.044,NULL,58057976306,907155879,14174310,18),(106093,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106093,37.77,0.27,358,45041,70,NULL,NULL,'2MASX J13110353+1901128',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.94',0.29,NULL,NULL,NULL,NULL,NULL,1,197.764667,19.02019,0.103,NULL,59031157651,922361838,14411903,17.94),(106094,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106094,37.27,0.33,284,45042,70,NULL,NULL,'2MASX J13110351+1633044',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.54',0.17,NULL,NULL,NULL,NULL,NULL,1,197.76475,16.55119,0,NULL,59042239697,922534995,14414609,18.54),(106095,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106095,35.2,0.46,109,45043,70,NULL,NULL,'CGCG 072-013',NULL,'2015arXiv151105856S',2015,1,0.97,NULL,'G',0.000187,NULL,'15.1',0.58,NULL,NULL,NULL,NULL,NULL,1,197.770583333,8.80786,0.009,NULL,58972967538,921452617,14397697,15.1),(106096,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106096,35.74,0.47,141,45044,70,NULL,NULL,'2MASX J13110495-2141138',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000143,NULL,'15.13',0.8,'(R?)SAB(s:)0o',NULL,NULL,NULL,NULL,1,197.77075,-21.68719,0.245,NULL,43804980143,684452814,10694575,15.13),(106097,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106097,38.58,0.46,521,45045,70,NULL,NULL,'SDSS J131105.06+131122.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000143,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,197.771125,13.18972,0,NULL,59047791172,922621737,14415964,18.6),(106098,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106098,37.42,0.1,304,45046,70,NULL,NULL,'2MASX J13110504+3914145',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000103,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,197.771125,39.23733,0,NULL,59305159725,926643120,14478798,17.2),(106099,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106099,37.12,0.23,266,45047,70,NULL,NULL,'2MASX J13110607+0224218',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000159,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,197.775375,2.40594,0.025,NULL,58062714451,907229913,14175467,17.1),(106100,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106100,37.31,0.27,290,45048,70,NULL,NULL,'2MASX J13110641+4625364',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00019,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,197.776875,46.42686,0,NULL,59099553438,923430522,14428601,16.7),(106101,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106101,37.44,0.46,307,45049,70,NULL,NULL,'2MASX J13110653+0203148',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000187,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,197.7772917,2.05406,0.045,NULL,58060252379,907191443,14174866,16.3),(106102,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106102,37.94,0.46,388,45050,70,NULL,NULL,'2MASX J13110656+3718375',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,197.7775,37.31058,0,NULL,59292109914,926439217,14475612,17.5),(106103,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106103,37.16,0.46,270,45051,70,NULL,NULL,'VIII Zw 255',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000157,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,197.7787917,3.63956,0.055,NULL,58057362868,907146294,14174160,17),(106104,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106104,37.64,0.46,337,45052,70,NULL,NULL,'2MASX J13110717+0638108',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,197.779875,6.63631,0.027,NULL,58976827448,921512928,14398639,18.1),(106105,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106105,37.16,0.46,270,45053,70,NULL,NULL,'2MASX J13110762+1042408',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000193,NULL,'16.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,197.7817083,10.71153,0,NULL,58964293456,921317085,14395579,16.4),(106106,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106106,36.94,0.46,245,45054,70,NULL,NULL,'2MASX J13110862+0920568',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.67',0.23,NULL,NULL,NULL,NULL,NULL,1,197.785833,9.34919,0,NULL,58973153415,921455522,14397742,17.67),(106107,'BCG','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106107,37.56,0.35,303,45055,60,NULL,'ABELL 1691, BCG','MCG +07-27-039',0.0722,'1980ApJ...241..486H',1980,1,0.79,NULL,'G',0.000067,NULL,'15.0g',0.75,'cD;BrClG','Brightest group member',NULL,NULL,NULL,1,197.785916667,39.22686,0,NULL,59305159318,926643114,14478798,15),(106108,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106108,37.42,0.1,304,45055,70,NULL,NULL,'MCG +07-27-039',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106109,'IRAS','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106109,32.03,0.8,25.5,45056,75,NULL,'MAT, I','ESO 443- G 080',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000007,NULL,'14.11',0.9,'SB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,197.7899583,-28.01033,0.273,NULL,43351501829,677367216,10583862,14.11),(106110,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106110,32.25,0.43,28.2,45056,75,NULL,'MAT, I, inv','ESO 443- G 080',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106111,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106111,32.26,0.32,28.3,45056,85,NULL,'I, inv','ESO 443- G 080',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106112,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106112,32.27,0.32,28.5,45056,85,NULL,'I, raw','ESO 443- G 080',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106113,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106113,32.3,0.43,28.9,45056,75,NULL,'MAT, I, raw','ESO 443- G 080',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106114,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106114,32.63,0.43,33.5,45056,75,NULL,'MAT, I, cor','ESO 443- G 080',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106115,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106115,33.23,0.4,44.3,45056,NULL,NULL,NULL,'ESO 443- G 080',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106116,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106116,33.29,0.85,45.5,45056,NULL,NULL,NULL,'ESO 443- G 080',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106117,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106117,33.33,0.2,46.3,45056,74.4,NULL,NULL,'ESO 443- G 080',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106118,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106118,33.57,0.75,51.8,45056,NULL,NULL,'Malmquist cor.','ESO 443- G 080',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106119,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106119,36.71,0.46,220,45057,70,NULL,NULL,'2MASX J13111009+0127316',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000161,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,197.791917,1.45878,0.04,NULL,58060313385,907192396,14174881,16.3),(106120,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106120,38.04,0.46,405,45058,70,NULL,NULL,'2MASX J13111009+1523204',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,197.792,15.38886,0.012,NULL,59052745739,922699152,14417174,17.7),(106121,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106121,37.74,0.46,354,45059,70,NULL,NULL,'2MASX J13111018+3029032',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000172,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,197.7925417,30.48411,0.041,NULL,58681015027,916890859,14326419,17),(106122,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106122,37.42,0.1,304,45060,70,NULL,NULL,'2MASX J13111047+3912185',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.0001,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,197.793625,39.20519,0,NULL,59305159501,926643117,14478798,17.7),(106123,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106123,37.77,0.27,358,45061,70,NULL,NULL,'2MASXi J1311109+185945',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,197.7955,18.99619,0.103,NULL,59031155384,922361802,14411903,17.9),(106124,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106124,37.42,0.1,304,45062,70,NULL,NULL,'2MASX J13111114+3916385',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000137,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,197.796416667,39.27733,0,NULL,59305160336,926643130,14478798,17.9),(106125,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106125,37.85,0.33,371,45063,70,NULL,NULL,'2MASX J13111211+1204352',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,197.800583333,12.0765,0.011,NULL,58992916068,921764313,14402567,18.2),(106126,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106126,36.73,0.46,222,45064,70,NULL,NULL,'SDSS J131113.32+184704.9',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.8g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,197.8055417,18.78469,0.073,NULL,59030981315,922359083,14411860,16.8),(106127,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106127,27.33,0.11,2.93,45065,NULL,NULL,NULL,'[CFC97] CEN 07',NULL,'2015ApJ...802L..25T',2015,1,0.8,NULL,'G',NULL,NULL,'17.3',0.7,'Sph',NULL,NULL,NULL,NULL,1,197.80775,-38.89897,0.309,0,46941273162,733457393,11460271,17.3),(106128,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106128,38.75,0.46,561,45066,70,NULL,NULL,'SDSS J131114.57+634250.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000072,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,197.8107083,63.71411,0.037,NULL,57360554311,896258661,14004041,18.7),(106129,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106129,37.56,0.46,324,45067,70,NULL,NULL,'2MASX J13111467+1304452',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000125,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,197.811125,13.07928,0,NULL,59047770827,922621419,14415959,17.4),(106130,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106130,38.15,0.27,427,45068,70,NULL,NULL,'2MASX J13111475+1929508',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,197.8115,19.49753,0.08,NULL,58808914883,918889295,14357645,17.2),(106131,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106131,36.93,0.46,243,45069,70,NULL,NULL,'2MASX J13111623+2825300',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000175,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,197.817583333,28.42514,0.037,NULL,58717481642,917460650,14335322,16.9),(106132,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106132,37.31,0.27,290,45070,70,NULL,NULL,'2MASX J13111705+4625033',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000187,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,197.821167,46.41756,0,NULL,59099553158,923430518,14428601,16.2),(106133,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106133,34.12,0.43,66.8,45071,75,NULL,'3.6 micron, color + selection bias corrected','ESO 576- G 005',NULL,'2014MNRAS.444..527S',2014,1,1.3,'The 2MASX position is for a superposed star (or knot?).','G',0.000073,NULL,'15.51',0.4,'SBdm? sp',NULL,NULL,NULL,NULL,1,197.824958333,-19.82847,0.197,NULL,43800827005,684387921,10693561,15.51),(106134,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106134,34.48,0.49,78.9,45071,75,NULL,'IR','ESO 576- G 005',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106135,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106135,36.03,0.23,161,45072,70,NULL,NULL,'2MASX J13111890+3502003',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000117,NULL,'15.8g',0.33,NULL,NULL,NULL,NULL,NULL,1,197.828875,35.03356,0.006,NULL,59160582487,924384101,14443501,15.8),(106136,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106136,37.72,0.46,351,45073,70,NULL,NULL,'2MASX J13112042+2056158',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,197.8350417,20.93775,0.039,NULL,58811496998,918929640,14358275,17.5),(106137,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106137,37.59,0.46,330,45074,70,NULL,NULL,'2MASX J13112082+0506206',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000181,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,197.836875,5.10586,0,NULL,58930038344,920781849,14387216,17.1),(106138,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106138,38.14,0.46,425,45075,70,NULL,NULL,'2MASX J13112107+3515413',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000183,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,197.8377083,35.2615,0.006,NULL,59160011945,924375186,14443362,17),(106139,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106139,36.03,0.23,161,45076,70,NULL,NULL,'UGC 08266',NULL,'2015arXiv151105856S',2015,1,1.19,NULL,'G',0.000103,NULL,'14.5g',0.75,'S0-:',NULL,NULL,NULL,NULL,1,197.844333,34.41806,0.009,NULL,59159753596,924371149,14443299,14.5),(106140,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106140,37.42,0.1,304,45077,70,NULL,NULL,'2MASX J13112268+3919466',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000083,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,197.8447083,39.32978,0,NULL,59305005272,926640707,14478761,16.6),(106141,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106141,37.31,0.46,289,45078,70,NULL,NULL,'2MASX J13112307+5117158',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000208,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,197.846125,51.28761,0,NULL,59089666177,923276034,14426188,16.4),(106142,'BCG','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106142,37.56,0.35,303,45079,60,NULL,NULL,'ABELL 1691',0.0722,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',0.00032,NULL,NULL,NULL,'II     [BM]',NULL,NULL,NULL,NULL,1,197.846833333,39.20131,0,NULL,59305105327,926642270,14478785,NULL),(106143,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:23','1','SN 1959C',NULL,106143,32.99,0.2,39.6,45080,60,NULL,'M(B) = -19.48 mag','UGC 08263',NULL,'2000ApJ...540..634P',2000,1,0.75,NULL,'G',0.000027,NULL,'15.8g',0.25,'SBc pec:',NULL,NULL,NULL,NULL,1,197.846916667,3.41144,0.053,NULL,58054792428,907106131,14173533,15.8),(106144,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:23','1','SN 1959C',NULL,106144,33.1,0.2,41.7,45080,60,NULL,'M(V) = -19.47 mag','UGC 08263',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106145,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:23','1','SN 1959C','R',106145,33.65,NULL,53.7,45080,NULL,NULL,'Photographic','UGC 08263',NULL,'1988SSRv...48....1R',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106146,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106146,33.24,0.4,44.4,45080,75,NULL,'B','UGC 08263',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106147,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106147,36.1,0.53,166,45081,70,NULL,NULL,'PKS 1308-441',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'14.5',0.9,NULL,NULL,NULL,'radio jet','Flat-Spectrum Radio Source',1,197.849,-44.37811,0.509,NULL,46951122859,733611294,11462676,14.5),(106148,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106148,38.06,0.46,409,45082,70,NULL,NULL,'2MASX J13112390+0417366',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,197.8495,4.29339,0.048,NULL,58056839063,907138110,14174032,17.6),(106149,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106149,37.93,0.33,385,45083,70,NULL,NULL,'2MASX J13112400+3558346',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000181,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,197.850125,35.97644,0,NULL,59159047021,924360109,14443126,17.1),(106150,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106150,36.68,0.46,216,45084,70,NULL,NULL,'LCRS B130849.2-025648',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000068,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,197.8502917,-3.21225,0.025,NULL,43095112068,673361126,10521267,17),(106151,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106151,38.76,0.46,564,45085,70,NULL,NULL,'SDSS J131124.31+354301.4',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000159,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,197.8512917,35.71708,0.009,NULL,59158929473,924358273,14443098,18.6),(106152,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106152,37.85,0.33,371,45086,70,NULL,NULL,'2MASX J13112554+1205422',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,197.856583,12.09508,0.011,NULL,59047451873,922616435,14415881,17.4),(106153,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106153,37.03,0.27,254,45087,70,NULL,NULL,'SDSS J131125.65+050745.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,197.856917,5.12942,0,NULL,58930902235,920795347,14387427,17.9),(106154,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106154,38.54,0.33,511,45088,70,NULL,NULL,'2MASX J13112611+5129438',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000194,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,197.858875,51.49558,0,NULL,59089651150,923275799,14426184,16.9),(106155,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106155,38.15,0.27,427,45089,70,NULL,NULL,'2MASX J13112706+1931377',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.98',0.12,NULL,NULL,NULL,NULL,NULL,1,197.862625,19.52711,0.074,NULL,58811770594,918933915,14358342,18.98),(106156,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106156,35.99,0.46,158,45090,70,NULL,NULL,'2MASX J13112720+4312092',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000194,NULL,'15.5g',0.44,'E0',NULL,NULL,NULL,NULL,1,197.8635417,43.20256,0,NULL,59307561552,926680649,14479385,15.5),(106157,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106157,35,0.2,100,45091,74.4,NULL,NULL,'UGC 08272',NULL,'2013AJ....146...86T',2013,1,0.84,NULL,'G',0.000082,NULL,'15.1g',0.61,'(R\')SB(rs)c',NULL,NULL,NULL,NULL,1,197.864416667,47.54956,0.028,NULL,59099028056,923422313,14428473,15.1),(106158,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106158,37.17,0.46,272,45092,70,NULL,NULL,'2MASX J13112794+2512140',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000147,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,197.8665,25.20386,0.044,NULL,58694941315,917108458,14329819,16.8),(106159,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106159,38.1,0.46,416,45093,70,NULL,NULL,'2MASX J13112811+0627478',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,197.867083,6.46333,0.021,NULL,58976954329,921514911,14398670,17.8),(106160,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106160,34.63,0.59,84.5,45094,70,NULL,NULL,'LCRS B130849.9-122118',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.32',NULL,NULL,NULL,NULL,NULL,NULL,1,197.867167,-12.62072,0.069,NULL,44011714508,687683039,10745047,16.32),(106161,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106161,37.01,0.33,252,45095,70,NULL,NULL,'2MASX J13112826+0549106',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000183,NULL,'16.2g',0.43,NULL,NULL,NULL,NULL,NULL,1,197.8679583,5.8195,0,NULL,58976176775,921502762,14398480,16.2),(106162,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106162,37.27,0.33,284,45096,70,NULL,NULL,'2MASX J13112858+1630082',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,197.8692917,16.50219,0,NULL,59042235755,922534933,14414608,17.2),(106163,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106163,37.06,0.46,258,45097,70,NULL,NULL,'SDSS J131128.71+571252.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000139,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,197.869625,57.21469,0,NULL,57435399449,897428116,14022314,18.1),(106164,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106164,37.8,0.46,363,45098,70,NULL,NULL,'2MASX J13112884+1555132',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.90',0.13,NULL,NULL,NULL,NULL,NULL,1,197.87025,15.92039,0.009,NULL,59042011392,922531428,14414553,18.9),(106165,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106165,35.28,0.46,114,45099,70,NULL,NULL,'VIII Zw 259',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00017,NULL,'16.2g',0.28,'S0^-',NULL,NULL,NULL,NULL,1,197.871083,3.68747,0.055,NULL,58057419587,907147181,14174174,16.2),(106166,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106166,37.88,0.46,376,45100,70,NULL,NULL,'SDSS J131129.45+152313.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000161,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,197.87275,15.387,0.012,NULL,59052748919,922699201,14417175,18.1),(106167,'SZ effect','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106167,38.74,NULL,559,45101,NULL,NULL,'3.1 (red) calibration','ABELL 1689',NULL,'2010ApJ...721..653R',2010,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III:[BM]',NULL,NULL,NULL,NULL,1,197.872917,-1.33806,0.021,NULL,43091427043,673303547,10520367,NULL),(106168,'SZ effect','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106168,38.91,NULL,604,45101,NULL,NULL,NULL,'ABELL 1689',NULL,'2005ApJ...625..108D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106169,'SZ effect','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106169,38.95,NULL,616,45101,NULL,NULL,'4.2 (black) calibration','ABELL 1689',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106170,'SZ effect','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106170,39,NULL,630,45101,NULL,NULL,NULL,'ABELL 1689',NULL,'2011A&A...532A..14C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106171,'SZ effect','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106171,39.06,0.28,650,45101,NULL,NULL,'Hydrost. Eq.','ABELL 1689',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106172,'SZ effect','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106172,39.12,NULL,668,45101,NULL,NULL,NULL,'ABELL 1689',NULL,'2002ApJ...581...53R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106173,'SZ effect','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106173,39.23,0.37,700,45101,NULL,NULL,'Isotherm.','ABELL 1689',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106174,'SZ effect','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106174,39.27,0.03,716,45101,70,NULL,NULL,'ABELL 1689',NULL,'1997ApJ...481...35H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106175,'SZ effect','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106175,39.33,NULL,736,45101,NULL,NULL,'4.1 (blue) calibration','ABELL 1689',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106176,'SZ effect','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106176,39.77,0.42,900,45101,NULL,NULL,'Isotherm., r < 100 kpc','ABELL 1689',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106177,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106177,36.69,0.46,218,45102,70,NULL,NULL,'2MASX J13112995+0008576',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000096,NULL,'16.1g',0.42,'E0',NULL,NULL,NULL,NULL,1,197.874875,0.14936,0.044,NULL,58058044031,907156937,14174327,16.1),(106178,'Tully est','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106178,31.79,0.8,22.8,45103,75,NULL,'B','NGC 5014',NULL,'1988NBGC.C....0000T',1988,1,1.76,NULL,'G',0.000017,NULL,'13.3g',0.57,'Sa? sp','in a radial-velocity based grouping',NULL,NULL,'Starburst',1,197.880083333,36.28214,0,NULL,59292368544,926443258,14475675,13.3),(106179,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106179,28.78,0.43,5.7,45103,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106180,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106180,29.21,0.43,7,45103,75,NULL,'3.6 micron, color corrected','NGC 5014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106181,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106181,29.54,0.2,8.09,45103,74.4,NULL,NULL,'NGC 5014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106182,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106182,30.77,0.4,14.2,45103,75,NULL,NULL,'NGC 5014',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106183,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106183,31.2,0.47,17.4,45103,NULL,NULL,'H','NGC 5014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106184,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106184,31.28,0.45,18.1,45103,NULL,NULL,'K','NGC 5014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106185,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106185,31.29,0.46,18.1,45103,NULL,NULL,'J','NGC 5014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106186,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106186,31.49,0.49,19.9,45103,75,NULL,'IR','NGC 5014',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106187,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106187,31.5,0.4,19.9,45103,NULL,NULL,'mean','NGC 5014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106188,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106188,37.03,0.27,254,45104,70,NULL,NULL,'2MASX J13113200+0507236',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000182,NULL,'16.1g',0.42,NULL,NULL,NULL,NULL,NULL,1,197.8835,5.12336,0,NULL,58930902676,920795354,14387427,16.1),(106189,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106189,38.3,0.46,456,45105,70,NULL,NULL,'2MASX J13113234+3522413',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000184,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,197.884833,35.37811,0.026,NULL,59160017126,924375267,14443363,17.3),(106190,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106190,36.77,0.46,226,45106,70,NULL,NULL,'2MASX J13113272-0148140',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000095,NULL,'16.9g',0.28,'NLAGN',NULL,NULL,NULL,'Sy 2',1,197.886333333,-1.80397,0.037,NULL,43089549572,673274212,10519909,16.9),(106191,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106191,35.24,0.55,112,45107,70,NULL,NULL,'LCRS B130855.7-062632',NULL,'2014MNRAS.445.2677S',2014,1,0.79,NULL,'G',0.00008,NULL,'15.49',0.3,NULL,NULL,NULL,NULL,NULL,1,197.887125,-6.708,0.093,NULL,43881145161,685642893,10713170,15.49),(106192,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106192,36.24,0.51,177,45108,70,NULL,NULL,'2MASX J13113304-0036260',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.000093,NULL,'15.62',0.42,'E',NULL,NULL,NULL,NULL,1,197.887833,-0.60719,0.029,NULL,43091610532,673306414,10520412,15.62),(106193,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106193,36.84,0.46,234,45109,70,NULL,NULL,'2MASX J13113508+0842478',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000183,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,197.8962083,8.71317,0.009,NULL,58986637348,921666208,14401034,16.7),(106194,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106194,37.01,0.33,252,45110,70,NULL,NULL,'2MASX J13113563+0547366',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,197.8984583,5.79356,0,NULL,58976174596,921502728,14398480,17.2),(106195,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106195,37.42,0.1,304,45111,70,NULL,NULL,'2MASX J13113607+3928275',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000073,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,197.900125,39.47447,0,NULL,59305011265,926640801,14478762,17.4),(106196,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106196,37.42,0.1,304,45112,70,NULL,NULL,'2MASX J13113628+3913285',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000067,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,197.9012083,39.22467,0,NULL,59305106105,926642282,14478785,16.9),(106197,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106197,37.87,0.46,374,45113,70,NULL,NULL,'2MASX J13113649+4258428',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000164,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,197.9020417,42.97858,0,NULL,59299212326,926550192,14477346,18),(106198,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106198,35.37,0.46,119,45114,70,NULL,NULL,'CGCG 072-016',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000173,NULL,'14.9g',0.63,NULL,NULL,NULL,NULL,NULL,1,197.9025417,10.12911,0,NULL,58973492225,921460816,14397825,14.9),(106199,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106199,37.73,0.46,351,45115,70,NULL,NULL,'2MASX J13113684-0028590',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000117,NULL,'16.4g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,197.903333,-0.48311,0.017,NULL,43091607124,673306361,10520411,16.4),(106200,'Sosies','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106200,32.96,0.16,39.1,45116,NULL,NULL,NULL,'NGC 5012',NULL,'2002A&A...393...57T',2002,1,2.9,'Position in 1987AnTok..212.251T is for a superposed star.','G',0.000017,NULL,'12.8g',1.02,'SAB(rs)c       LINER','Possible field galaxy',NULL,NULL,NULL,1,197.904333,22.9155,0.027,NULL,58813865773,918966652,14358853,12.8),(106201,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106201,31.98,0.69,24.9,45116,100,NULL,'mid-IR','NGC 5012',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106202,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106202,32.76,0.4,35.6,45116,NULL,NULL,NULL,'NGC 5012',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106203,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106203,32.92,0.47,38.3,45116,NULL,NULL,'H','NGC 5012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106204,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106204,32.92,0.49,38.5,45116,NULL,NULL,'Malmquist cor.','NGC 5012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106205,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106205,32.93,0.46,38.6,45116,NULL,NULL,'J','NGC 5012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106206,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106206,32.93,0.45,38.6,45116,NULL,NULL,'K','NGC 5012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106207,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106207,33.03,0.4,40.4,45116,75,NULL,'B','NGC 5012',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106208,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106208,33.06,0.4,41,45116,NULL,NULL,'mean','NGC 5012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106209,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106209,33.13,0.43,42.2,45116,75,NULL,'3.6 micron, color corrected','NGC 5012',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106210,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106210,33.14,0.2,42.5,45116,74.4,NULL,NULL,'NGC 5012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106211,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106211,33.18,0.43,43.2,45116,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5012',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106212,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106212,33.19,0.43,43.4,45116,NULL,NULL,NULL,'NGC 5012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106213,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106213,37.93,0.33,385,45117,70,NULL,NULL,'2MASX J13113743+3600495',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000156,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,197.906,36.01394,0,NULL,59159047902,924360123,14443126,18.1),(106214,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106214,37.03,0.27,254,45118,70,NULL,NULL,'2MASX J13113767+0506355',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00017,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,197.907,5.10989,0,NULL,58930904895,920795388,14387427,16.5),(106215,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106215,36.7,0.46,219,45119,70,NULL,NULL,'2MASX J13113815+2916141',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00011,NULL,'17.4g',0.18,'LINER',NULL,NULL,NULL,'LINER',1,197.9089583,29.27078,0.028,NULL,58717333213,917458331,14335286,17.4),(106216,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106216,37.45,0.46,310,45120,70,NULL,NULL,'2MASX J13113836+4008265',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,197.90975,40.14069,0,NULL,59300429475,926569210,14477643,17.6),(106217,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106217,38.37,0.46,471,45121,70,NULL,NULL,'SDSS J131138.47+324424.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000177,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,197.910333333,32.74028,0,NULL,58672079139,916751236,14324238,18.1),(106218,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106218,36.35,0.46,186,45122,70,NULL,NULL,'2MASX J13113955+4655058',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000174,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,197.9149583,46.91811,0,NULL,59099649615,923432025,14428625,16.3),(106219,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106219,37.06,0.46,258,45123,70,NULL,NULL,'2MASX J13114005+3149163',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.000133,NULL,'15.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,197.916833,31.82122,0.018,NULL,58684160730,916940011,14327187,15.8),(106220,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106220,37.53,0.46,321,45124,70,NULL,NULL,'2MASX J13114041+6529197',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000075,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,197.918,65.48872,0.017,NULL,57873515447,904273678,14129276,17.2),(106221,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106221,38.3,0.33,457,45125,70,NULL,NULL,'2MASX J13114105+6641156',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000096,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,197.9205417,66.68778,0.033,NULL,57907084685,904798198,14137471,17.3),(106222,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106222,36.72,0.33,221,45126,70,NULL,NULL,'2MASX J13114103+4923386',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000172,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,197.921166667,49.394,0,NULL,59092296192,923317128,14426830,16.3),(106223,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106223,37.34,0.46,293,45127,70,NULL,NULL,'SDSS J131142.77+104956.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.4g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,197.92825,10.83228,0,NULL,58972335774,921442746,14397542,17.4),(106224,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106224,35.36,0.23,118,45128,70,NULL,NULL,'2MASX J13114331+4719568',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00018,NULL,'15.7g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,197.9305,47.3325,0,NULL,59098994546,923421789,14428465,15.7),(106225,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106225,36.55,0.73,204,45129,70,NULL,NULL,'2MASX J13114442-4321071',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,197.935,-43.35203,0.389,NULL,46959580887,733743451,11464741,15.5),(106226,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106226,37.61,0.33,333,45130,70,NULL,NULL,'2MASX J13114505+5643461',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000175,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,197.9377083,56.72958,0,NULL,57435675527,897432430,14022381,16.8),(106227,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106227,35.88,0.46,150,45131,70,NULL,NULL,'2MASX J13114552+4054276',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,197.9395417,40.90775,0,NULL,59302392767,926599886,14478123,16.4),(106228,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106228,38.45,0.46,490,45132,70,NULL,NULL,'SDSS J131145.66+301651.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00014,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,197.940291667,30.28089,0.041,NULL,58681319923,916895623,14326494,18.6),(106229,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106229,32.65,0.51,33.8,45133,70,NULL,NULL,'NGC 5006',NULL,'2014MNRAS.445.2677S',2014,1,2,NULL,'G',0.00015,NULL,'13.72',1.7,'(R\')SB(r)a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,197.940708333,-19.26175,0.237,NULL,43797231481,684331741,10692683,13.72),(106230,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106230,37.05,0.33,257,45134,70,NULL,NULL,'2MASX J13114584+4040276',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000171,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,197.9410417,40.67428,0,NULL,59302378445,926599663,14478119,16.6),(106231,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106231,37.16,0.46,271,45135,70,NULL,NULL,'2MASX J13114622+6156458',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,197.9425,61.94611,0.021,NULL,57354052235,896157066,14002454,17.8),(106232,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106232,35.05,0.46,102,45136,70,NULL,NULL,'CGCG 101-007',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000163,NULL,'16.0g',0.36,'S0/a',NULL,NULL,NULL,NULL,1,197.942583,14.57042,0,NULL,59049424526,922647258,14416363,16),(106233,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106233,38.54,0.33,511,45137,70,NULL,NULL,'2MASX J13114623+5131550',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,197.94275,51.53181,0,NULL,59089650682,923275791,14426184,17.9),(106234,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106234,37.26,0.46,283,45138,70,NULL,NULL,'2MASX J13114634+4023536',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000196,NULL,'16.1g',0.34,NULL,NULL,NULL,NULL,NULL,1,197.94325,40.39819,0,NULL,59300412411,926568943,14477639,16.1),(106235,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106235,38.58,0.46,519,45139,70,NULL,NULL,'2MASX J13114668+1134519',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000178,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,197.944583,11.58106,0,NULL,58963574524,921305851,14395403,17.8),(106236,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106236,37.61,0.33,333,45140,70,NULL,NULL,'2MASXi J1311468+564618',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,197.9452917,56.77183,0,NULL,57435662413,897432225,14022378,17.8),(106237,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106237,37.46,0.46,311,45141,70,NULL,NULL,'2MASX J13114701-0136389',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000089,NULL,'16.9g',0.32,'NLAGN',NULL,NULL,NULL,NULL,1,197.9457917,-1.61089,0.021,NULL,43089636273,673275566,10519930,16.9),(106238,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106238,36.84,0.46,233,45142,70,NULL,NULL,'2MASX J13114880+1000240',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000185,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,197.953375,10.00653,0,NULL,58973540296,921461567,14397836,16.5),(106239,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106239,37.41,0.74,303,45143,70,NULL,NULL,'2MASX J13114994-4701211',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,197.958167,-47.02253,0.597,NULL,46730961110,730171267,11408926,17.7),(106240,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106240,37.42,0.1,304,45144,70,NULL,NULL,'2MASX J13115003+3912426',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000113,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,197.9585,39.21178,0,NULL,59305113647,926642400,14478787,17.6),(106241,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106241,38.24,0.46,444,45145,70,NULL,NULL,'SDSS J131150.88+273705.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,197.9620417,27.61811,0.025,NULL,58718946913,917483545,14335680,18.2),(106242,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106242,36.53,0.68,203,45146,70,NULL,NULL,'2MASX J13115096-2151511',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,197.962333,-21.86422,0.281,NULL,43801787497,684402929,10693795,17.1),(106243,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106243,33.99,NULL,62.7,45147,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08277',NULL,'2010Ap&SS.325..163P',2010,1,0.67,NULL,'G',0.000126,NULL,'16.8g',0.2,'Sc',NULL,NULL,NULL,NULL,1,197.962875,40.89503,0,NULL,59302390517,926599851,14478122,16.8),(106244,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106244,34.01,NULL,63.3,45147,NULL,NULL,'Dipole + Quadrupole','UGC 08277',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106245,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106245,34.01,NULL,63.5,45147,NULL,NULL,'Dipole','UGC 08277',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106246,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106246,34.07,NULL,65,45147,NULL,NULL,NULL,'UGC 08277',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106247,'IRAS','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106247,32.6,0.8,33.2,45148,75,NULL,'CF, r','UGC 08282',NULL,'1997ApJS..109..333W',1997,1,1.27,NULL,'G',0.000011,NULL,'15.1g',0.41,'Scd:',NULL,NULL,NULL,NULL,1,197.9637083,60.24731,0,NULL,57383603256,896618800,14009668,15.1),(106248,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106248,33.26,0.38,45,45148,75,NULL,'CF, r, inv','UGC 08282',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106249,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106249,33.3,0.38,45.7,45148,75,NULL,'CF, r, raw','UGC 08282',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106250,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106250,33.32,0.38,46.1,45148,75,NULL,'CF, r, cor','UGC 08282',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106251,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106251,33.34,0.4,46.6,45148,NULL,NULL,NULL,'UGC 08282',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106252,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106252,33.5,0.2,50.1,45148,74.4,NULL,NULL,'UGC 08282',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106253,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106253,33.52,0.43,50.6,45148,75,NULL,'3.6 micron, color corrected','UGC 08282',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106254,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106254,33.53,0.43,50.9,45148,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08282',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106255,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106255,33.67,0.54,54.2,45148,NULL,NULL,NULL,'UGC 08282',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106256,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106256,33.69,0.53,54.7,45148,NULL,NULL,'Malmquist cor.','UGC 08282',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106257,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106257,36.5,0.53,199,45149,70,NULL,NULL,'2MASX J13115130-3635369',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,197.963791667,-36.59364,0.169,NULL,46928398112,733256220,11457128,14.3),(106258,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106258,36.24,0.46,177,45150,70,NULL,NULL,'2MASX J13115277+4504308',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000178,NULL,'15.9g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,197.969833,45.07533,0,NULL,59278827897,926231685,14472370,15.9),(106259,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106259,38.3,0.33,457,45151,70,NULL,NULL,'SDSS J131153.35+664307.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000094,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,197.972333,66.71869,0.033,NULL,57907075218,904798050,14137469,18.5),(106260,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106260,36.81,0.46,230,45152,70,NULL,NULL,'2MASX J13115341+3852127',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00011,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,197.9725,38.87019,0,NULL,59304693911,926635842,14478685,17.1),(106261,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106261,36.67,0.46,216,45153,70,NULL,NULL,'2MASX J13115341+2259587',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,197.972583333,22.99964,0.025,NULL,58814072614,918969884,14358904,16.7),(106262,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106262,37.07,0.33,259,45154,70,NULL,NULL,'2MASX J13115430+2501521',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.0001,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,197.976333,25.03119,0.069,NULL,58694851408,917107053,14329797,16.6),(106263,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106263,37.47,0.64,311,45155,70,NULL,NULL,'LCRS B130916.4-122525',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.32',NULL,NULL,NULL,NULL,NULL,NULL,1,197.977667,-12.68894,0.081,NULL,44011743408,687683490,10745054,15.32),(106264,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106264,36.99,0.33,250,45156,70,NULL,NULL,'2MASX J13115470+3952477',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000199,NULL,'15.7g',0.44,NULL,NULL,NULL,NULL,NULL,1,197.977917,39.88008,0,NULL,59304858308,926638411,14478725,15.7),(106265,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106265,38.31,0.46,459,45157,70,NULL,NULL,'2MASX J13115478+1118309',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,197.978208333,11.30875,0,NULL,58963684872,921307576,14395430,17.4),(106266,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106266,37.81,0.46,365,45158,70,NULL,NULL,'LCRS B130920.2-025253',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000088,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,197.9792083,-3.14669,0.025,NULL,43095159947,673361874,10521279,17),(106267,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106267,35.92,0.46,153,45159,70,NULL,NULL,'2MASX J13115566+1120419',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000167,NULL,'16.2g',0.41,NULL,NULL,NULL,NULL,NULL,1,197.982,11.34508,0,NULL,58963682500,921307539,14395430,16.2),(106268,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106268,37.42,0.1,304,45160,70,NULL,NULL,'2MASX J13115569+3924407',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000067,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,197.982083,39.41139,0,NULL,59305033474,926641148,14478767,16.3),(106269,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106269,35.36,0.23,118,45161,70,NULL,NULL,'2MASX J13115594+4654258',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.00008,NULL,'15.3g',0.44,'S0^-',NULL,NULL,NULL,NULL,1,197.983083333,46.90719,0,NULL,59099650573,923432040,14428625,15.3),(106270,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106270,36.71,0.2,220,45162,74.4,NULL,NULL,'CGCG 072-019',NULL,'2013AJ....146...86T',2013,1,0.49,NULL,'G',0.000101,NULL,'15.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,197.9839583,12.35314,0.011,NULL,59047648535,922619508,14415929,15.6),(106271,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106271,37.44,0.46,308,45163,70,NULL,NULL,'2MASX J13115659+5235421',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000172,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,197.985666667,52.59511,0,NULL,57193856429,893654006,13963343,16.8),(106272,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106272,35.06,0.46,103,45164,70,NULL,NULL,'CGCG 189-038',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000103,NULL,'14.4g',0.9,'S?',NULL,NULL,NULL,NULL,1,197.9895,34.36525,0.009,NULL,59157876903,924341826,14442841,14.4),(106273,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106273,37.05,0.46,257,45165,70,NULL,NULL,'2MASX J13115755+5647542',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000133,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,197.9895417,56.79828,0.013,NULL,57435672313,897432379,14022380,17.4),(106274,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106274,36.93,0.27,244,45166,70,NULL,NULL,'2MASX J13115824+5410122',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000176,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,197.992833,54.17006,0.018,NULL,57425590241,897274847,14019919,16.7),(106275,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106275,37.44,0.46,308,45167,70,NULL,NULL,'2MASX J13115884+4817011',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000172,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,197.994875,48.28375,0,NULL,59091601666,923306276,14426660,16.7),(106276,'Tully est','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106276,32.53,0.8,32,45168,75,NULL,NULL,'UGCA 332',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000026,NULL,'13.78',1.1,'SB(s)d',NULL,NULL,NULL,NULL,1,197.992333,-12.06439,0.057,NULL,44010893866,687670216,10744847,13.78),(106277,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106277,32.38,0.4,30,45168,NULL,NULL,NULL,'UGCA 332',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106278,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106278,38.15,0.27,427,45169,70,NULL,NULL,'2MASX J13115936+1929526',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,197.9972917,19.498,0.074,NULL,58808894060,918888969,14357640,18.2),(106279,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106279,37.07,0.46,259,45170,70,NULL,NULL,'2MASX J13120148+2549521',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000127,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,198.0062083,25.83117,0.043,NULL,58692712520,917073633,14329275,16.4),(106280,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106280,36.06,0.59,163,45171,70,NULL,NULL,'2MASX J13120188-2253317',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.4,NULL,NULL,NULL,NULL,NULL,1,198.007833,-22.89225,0.285,NULL,43795383786,684302871,10692232,14.4),(106281,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106281,38.28,0.46,452,45172,70,NULL,NULL,'2MASX J13120223+5632533',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000138,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,198.0092083,56.54817,0.013,NULL,57434780756,897418449,14022163,18.1),(106282,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106282,37.42,0.1,304,45173,70,NULL,NULL,'2MASX J13120259+3920167',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000146,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,198.01075,39.33806,0,NULL,59304980698,926640323,14478755,17.7),(106283,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106283,36.99,0.33,250,45174,70,NULL,NULL,'2MASX J13120278+3955147',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,198.011667,39.92061,0,NULL,59304859285,926638426,14478725,17.2),(106284,'Tully est','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106284,32.04,0.8,25.6,45175,75,NULL,NULL,'IC 4212',NULL,'1988NBGC.C....0000T',1988,1,3.1,'The IC identification is not certain.','G',0.000003,NULL,'14.5',2.4,'SB(s)cd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,198.0124583,-6.97583,0.093,NULL,43884689966,685698280,10714035,14.5),(106285,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106285,31.7,0.4,21.9,45175,NULL,NULL,NULL,'IC 4212',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106286,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106286,37.26,0.61,283,45176,70,NULL,NULL,'2MASX J13120567-3637509',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,198.023583,-36.63081,0.165,NULL,46928917894,733264342,11457255,15.5),(106287,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106287,31.94,NULL,24.4,45177,72,NULL,NULL,'UGC 08276',NULL,'2014Ap.....57..457K',2014,1,0.55,'SDSS DR2 has z = 0.625986 +- 0.000269.','G',0.000013,NULL,'17.1g',0.29,'Im:',NULL,NULL,NULL,NULL,1,198.0272917,5.47569,0,NULL,58930845399,920794459,14387413,17.1),(106288,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106288,33.03,0.4,40.3,45178,75,NULL,'B','NGC 5016',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000017,NULL,'13.49',1.3,'SAB(rs)c       SBNG','Pair member, wide',NULL,NULL,NULL,1,198.027833333,24.095,0.025,NULL,58693263697,917082245,14329410,13.49),(106289,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106289,33.07,0.4,41.1,45178,NULL,NULL,'mean','NGC 5016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106290,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106290,33.11,0.45,41.9,45178,NULL,NULL,'K','NGC 5016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106291,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106291,33.13,0.47,42.3,45178,NULL,NULL,'H','NGC 5016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106292,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106292,33.17,0.46,43,45178,NULL,NULL,'J','NGC 5016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106293,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106293,33.33,0.4,46.3,45178,NULL,NULL,NULL,'NGC 5016',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106294,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106294,36.93,0.27,244,45179,70,NULL,NULL,'2MASX J13120668+5402453',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,198.028,54.04597,0.041,NULL,57414280071,897098126,14017158,17.3),(106295,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106295,35.58,0.25,131,45180,74.4,NULL,NULL,'ARK 407',NULL,'2013AJ....146...86T',2013,1,0.25,NULL,'G',0.00005,NULL,'15.0',0.25,'E0',NULL,NULL,NULL,NULL,1,198.033041667,27.33053,0.05,NULL,58718519118,917476861,14335575,15),(106296,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106296,35.64,0.46,134,45180,70,NULL,NULL,'ARK 407',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106297,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106297,37.61,0.13,333,45181,70,NULL,NULL,'2MASX J13120799-0100301',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000213,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,198.033333,-1.00847,0.025,NULL,43092182807,673315356,10520552,17.4),(106298,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106298,37.07,0.33,259,45182,70,NULL,NULL,'2MASX J13120841+2449451',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,198.034916667,24.82903,0.023,NULL,58694867466,917107304,14329801,16.7),(106299,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106299,36.14,0.46,169,45183,70,NULL,NULL,'CGCG 245-029',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000189,NULL,'15.4g',0.52,'E0',NULL,NULL,NULL,NULL,1,198.035667,45.42683,0,NULL,59278666083,926229157,14472330,15.4),(106300,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106300,37.8,0.33,362,45184,70,NULL,NULL,'2MASX J13120921+4117087',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,198.038375,41.28589,0,NULL,59303203873,926612560,14478321,16.6),(106301,'IRAS','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106301,32.94,0.8,38.7,45185,75,NULL,'MAT, I','NGC 5011A',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'14.32',0.8,'SAB(s)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,198.0405,-43.30786,0.401,NULL,46959622937,733744108,11464751,14.32),(106302,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106302,32.42,0.43,30.5,45185,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5011A',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106303,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106303,32.57,0.43,32.7,45185,75,NULL,'3.6 micron, color corrected','NGC 5011A',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106304,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106304,32.69,0.2,34.5,45185,74.4,NULL,NULL,'NGC 5011A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106305,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106305,32.94,0.32,38.7,45185,85,NULL,'I, raw','NGC 5011A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106306,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106306,32.97,0.32,39.2,45185,85,NULL,'I, inv','NGC 5011A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106307,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106307,33.2,0.43,43.6,45185,75,NULL,'MAT, I, raw','NGC 5011A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106308,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106308,33.31,0.47,45.9,45185,NULL,NULL,'H','NGC 5011A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106309,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106309,33.31,0.4,45.9,45185,NULL,NULL,'mean','NGC 5011A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106310,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106310,33.34,0.46,46.6,45185,NULL,NULL,'J','NGC 5011A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106311,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106311,33.36,0.43,46.9,45185,75,NULL,'MAT, I, inv','NGC 5011A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106312,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106312,33.37,0.45,47.3,45185,NULL,NULL,'K','NGC 5011A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106313,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106313,33.4,0.43,47.9,45185,75,NULL,'MAT, I, cor','NGC 5011A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106314,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106314,33.41,0.09,48.2,45185,NULL,NULL,NULL,'NGC 5011A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106315,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106315,36.65,0.46,214,45186,70,NULL,NULL,'2MASX J13120988+4852472',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000142,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,198.041375,48.87992,0,NULL,59092327895,923317623,14426837,17.3),(106316,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106316,38.01,0.33,400,45187,70,NULL,NULL,'2MASX J13121041+0415544',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,198.0434583,4.26517,0.048,NULL,58056873409,907138647,14174041,16.9),(106317,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106317,31.2,0.4,17.4,45188,75,NULL,'B','IC 4213',NULL,'1988NBGC.C....0000T',1988,1,2.5,NULL,'G',0.000017,NULL,'14.01',0.5,'Scd:           HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,198.04675,35.66969,0.009,NULL,59158917380,924358084,14443095,14.01),(106318,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106318,31.42,0.2,19.2,45188,74.4,NULL,NULL,'IC 4213',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106319,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106319,31.48,0.4,19.8,45188,NULL,NULL,NULL,'IC 4213',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106320,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106320,31.51,0.52,20,45188,NULL,NULL,'Malmquist cor.','IC 4213',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106321,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106321,31.54,0.43,20.3,45188,75,NULL,'3.6 micron, color corrected','IC 4213',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106322,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106322,31.58,0.43,20.7,45188,75,NULL,'3.6 micron, color + selection bias corrected','IC 4213',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106323,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106323,31.61,0.5,21,45188,NULL,NULL,NULL,'IC 4213',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106324,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106324,34.91,0.46,96.1,45189,70,NULL,NULL,'2MASX J13121134+0446414',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000095,NULL,'15.7g',0.35,'Sa',NULL,NULL,NULL,NULL,1,198.0472083,4.77814,0.019,NULL,58053991007,907093609,14173337,15.7),(106325,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106325,35.34,0.72,117,45190,70,NULL,NULL,'2MASX J13121175-4333303',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,198.049,-43.55853,0.429,NULL,46959637421,733744334,11464755,15.3),(106326,'Brightest Stars','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106326,28.66,NULL,5.4,45191,NULL,NULL,NULL,'NGC 5023',NULL,'1999AstL...25..322S',1999,1,7.28,NULL,'G',0.000003,NULL,'12.85',0.78,'Scd','in a radial-velocity based grouping',NULL,NULL,NULL,1,198.0525,44.04122,0,NULL,59278219424,926222178,14472221,12.85),(106327,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106327,28.19,0.06,4.35,45191,NULL,NULL,'I','NGC 5023',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106328,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106328,28.92,0.13,6.07,45191,NULL,NULL,NULL,'NGC 5023',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106329,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106329,28.94,0.05,6.14,45191,NULL,NULL,NULL,'NGC 5023',NULL,'2006astro.ph..3457T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106330,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106330,29.06,0.07,6.5,45191,NULL,NULL,'I','NGC 5023',NULL,'2011ApJS..195...18R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106331,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106331,29.06,0.07,6.5,45191,NULL,NULL,NULL,'NGC 5023',NULL,'2016MNRAS.457.1419M',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106332,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106332,29.1,0.03,6.61,45191,NULL,NULL,NULL,'NGC 5023',NULL,'2005AJ....129.1331S',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106333,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106333,29.13,0.09,6.69,45191,74.4,NULL,NULL,'NGC 5023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106334,'IRAS','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106334,29.82,0.8,9.2,45191,75,NULL,'A82, H','NGC 5023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106335,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106335,28.89,0.4,6,45191,75,NULL,'B','NGC 5023',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106336,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106336,29.13,0.09,6.69,45191,74.4,NULL,NULL,'NGC 5023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106337,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106337,29.54,0.4,8.1,45191,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5023',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106338,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106338,29.66,0.4,8.54,45191,NULL,NULL,'mean','NGC 5023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106339,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106339,29.82,NULL,9.21,45191,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 5023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106340,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106340,29.85,NULL,9.33,45191,NULL,NULL,'Dipole + Quadrupole','NGC 5023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106341,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106341,29.85,NULL,9.34,45191,NULL,NULL,'Dipole','NGC 5023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106342,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106342,29.93,NULL,9.7,45191,NULL,NULL,NULL,'NGC 5023',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106343,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106343,29.97,0.35,9.86,45191,NULL,NULL,NULL,'NGC 5023',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106344,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106344,30.1,0.47,10.5,45191,75,NULL,'A82, H, inv','NGC 5023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106345,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106345,30.13,0.43,10.6,45191,75,NULL,'3.6 micron, color corrected','NGC 5023',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106346,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106346,30.12,0.43,10.6,45191,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5023',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106347,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106347,30.21,0.56,11,45191,NULL,NULL,NULL,'NGC 5023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106348,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106348,30.26,0.47,11.3,45191,75,NULL,'A82, H, raw','NGC 5023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106349,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106349,30.44,0.5,12.3,45191,NULL,NULL,'Malmquist cor.','NGC 5023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106350,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106350,30.59,0.47,13.1,45191,75,NULL,'A82, H, cor','NGC 5023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106351,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106351,30.9,0.46,15.2,45191,NULL,NULL,'J','NGC 5023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106352,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106352,31.08,0.47,16.4,45191,NULL,NULL,'H','NGC 5023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106353,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106353,31.2,0.45,17.4,45191,NULL,NULL,'K','NGC 5023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106354,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106354,37.6,0.46,331,45192,70,NULL,NULL,'VIII Zw 261',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.77',0.3,NULL,NULL,NULL,NULL,NULL,1,198.05325,23.62367,0.021,NULL,58814264258,918972879,14358951,16.77),(106355,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106355,37.61,0.13,333,45193,70,NULL,NULL,'2MASX J13121359-0058281',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.88',0.2,'BrClG',NULL,NULL,NULL,NULL,1,198.056625,-0.9745,0.025,NULL,43092196271,673315566,10520555,17.88),(106356,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106356,35.82,0.46,146,45194,70,NULL,NULL,'2MASX J13121416+0402304',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000177,NULL,'16.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,198.058916667,4.04183,0.05,NULL,58056853708,907138339,14174036,16.2),(106357,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106357,37.24,0.46,281,45195,70,NULL,NULL,'2MASX J13121425+6658436',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000086,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,198.059667,66.97867,0.033,NULL,57910390072,904849844,14138278,16.6),(106358,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106358,36.4,0.65,191,45196,70,NULL,NULL,'ESO 269- G 064',NULL,'2014MNRAS.445.2677S',2014,1,0.9,'RC3 has V = 12223 +- 87 km/s.','G',0.00015,NULL,'15.39',0.5,'S?',NULL,NULL,NULL,NULL,1,198.059916667,-47.66922,0.737,NULL,46730886776,730170105,11408907,15.39),(106359,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106359,37.02,0.46,253,45197,70,NULL,NULL,'2MASX J13121464+1956496',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,198.061125,19.94725,0.071,NULL,58812482078,918945032,14358516,17),(106360,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106360,37.61,0.13,333,45198,70,NULL,NULL,'2MASX J13121552-0055501',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000103,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,198.064666667,-0.93056,0.025,NULL,43092186527,673315414,10520553,16.8),(106361,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106361,35.24,0.46,112,45199,70,NULL,NULL,'2MASX J13121603+0337064',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,198.066875,3.61864,0.055,NULL,58057376396,907146506,14174164,16.3),(106362,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106362,36.29,0.46,181,45200,70,NULL,NULL,'2MASX J13121712+3832247',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000176,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,198.071333,38.54017,0,NULL,59306637750,926666214,14479159,16.2),(106363,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106363,37.36,0.46,297,45201,70,NULL,NULL,'2MASX J13121708+6132418',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000146,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,198.0714583,61.54508,0.017,NULL,57384489022,896632640,14009885,17.6),(106364,'Tully est','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106364,31.29,0.8,18.1,45202,75,NULL,'B','KUG 1309+269',NULL,'1988NBGC.C....0000T',1988,1,0.9,NULL,'G',0.000053,NULL,'14.81',0.5,'E              HII',NULL,NULL,NULL,NULL,1,198.0735417,26.68614,0.022,NULL,58710662682,917354104,14333657,14.81),(106365,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106365,37.61,0.13,333,45203,70,NULL,NULL,'2MASXi J1312177-005823',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000075,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,198.074,-0.97342,0.025,NULL,43092187381,673315427,10520553,18.1),(106366,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106366,38.63,0.46,532,45204,70,NULL,NULL,'2MASX J13121918+3851137',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000073,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,198.079833,38.85386,0,NULL,59306602469,926665663,14479150,17.5),(106367,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106367,38.77,0.46,568,45205,70,NULL,NULL,'SDSS J131219.57+062315.8',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,198.0815417,6.38775,0.021,NULL,58976441987,921506906,14398545,18.6),(106368,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106368,36.88,0.23,237,45206,70,NULL,NULL,'2MASX J13122031+0508154',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000175,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,198.0845,5.13758,0.022,NULL,58930917934,920795592,14387431,16.9),(106369,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106369,37.76,0.46,357,45207,70,NULL,NULL,'2MASX J13122038+0140094',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,198.084875,1.66911,0.038,NULL,58060209883,907190779,14174855,17.6),(106370,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106370,37.91,0.46,382,45208,70,NULL,NULL,'2MASX J13122066+1123143',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000184,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,198.0859583,11.38744,0,NULL,58972145578,921439774,14397496,17.3),(106371,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106371,36.09,0.57,165,45209,70,NULL,NULL,'2MASX J13122089-1316466',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.7I',0.2,NULL,NULL,NULL,NULL,NULL,1,198.0869583,-13.27964,0.109,NULL,44011411500,687678304,10744973,14.7),(106372,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106372,37.54,0.46,322,45210,70,NULL,NULL,'2MASX J13122104+0317484',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,198.087583,3.29692,0.043,NULL,58056656616,907135259,14173988,17.7),(106373,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106373,38.01,0.33,400,45211,70,NULL,NULL,'SDSS J131221.02+041619.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000154,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,198.087583,4.27203,0.048,NULL,58056883438,907138803,14174043,18),(106374,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106374,37.61,0.13,333,45212,70,NULL,NULL,'2MASX J13122125-0048091',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000067,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,198.088666667,-0.80267,0.025,NULL,43092207017,673315734,10520558,17.7),(106375,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106375,31.71,0.47,21.9,45213,NULL,NULL,'H','NGC 5015',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000007,NULL,'13.24',1.5,'(R)SB(r)a:',NULL,NULL,NULL,NULL,1,198.095375,-4.33647,0.069,NULL,43092643544,673322555,10520664,13.24),(106376,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106376,31.86,0.46,23.5,45213,NULL,NULL,'J','NGC 5015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106377,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106377,31.95,0.45,24.5,45213,NULL,NULL,'K','NGC 5015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106378,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106378,33.13,0.4,42.3,45213,NULL,NULL,'mean','NGC 5015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106379,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106379,38.62,0.46,529,45214,70,NULL,NULL,'SDSS J131223.61-011519.4',NULL,'2015arXiv151105856S',2015,1,0.24,'Teague et al (1990ApJS...72..715T) have V = 50671 +- 75 km/s.','G',0.000078,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,198.098375,-1.25539,0.017,NULL,43091478649,673304353,10520380,17.9),(106380,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106380,36.03,0.23,161,45215,70,NULL,NULL,'2MASX J13122431+3423155',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000077,NULL,'15.4g',0.47,NULL,NULL,NULL,NULL,NULL,1,198.101125,34.38758,0.009,NULL,59157887228,924341987,14442843,15.4),(106381,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106381,39.02,0.46,637,45216,70,NULL,NULL,'SDSS J131225.42+045944.3',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000152,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,198.105917,4.99567,0.022,NULL,58930402811,920787543,14387305,17.8),(106382,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106382,38.04,0.46,405,45217,70,NULL,NULL,'2MASX J13122563+1606470',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,198.106917,16.11317,0.008,NULL,59041948211,922530440,14414538,18.1),(106383,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106383,37.57,0.21,326,45218,70,NULL,NULL,'2MASX J13122625+0059034',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00011,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,198.1092917,0.98439,0.056,NULL,58060872244,907201128,14175017,17.6),(106384,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106384,37.61,0.13,333,45219,70,NULL,NULL,'SDSS J131226.26-010259.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000053,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,198.109416667,-1.04975,0.025,NULL,43091319446,673301866,10520341,18.2),(106385,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106385,36.78,0.46,227,45220,70,NULL,NULL,'2MASX J13122710+4347180',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000107,NULL,'15.5g',0.45,'E0',NULL,NULL,NULL,NULL,1,198.113083,43.78831,0,NULL,59307641838,926681903,14479404,15.5),(106386,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106386,37.83,0.46,368,45221,70,NULL,NULL,'2MASX J13122822-0139541',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000015,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,198.117583333,-1.66492,0.021,NULL,43089435270,673272426,10519881,17),(106387,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106387,37.61,0.13,333,45222,70,NULL,NULL,'2MASX J13122852-0053391',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000071,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,198.118875,-0.89422,0.025,NULL,43092202218,673315659,10520557,17.5),(106388,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106388,37.48,0.33,313,45223,70,NULL,NULL,'2MASX J13122932+5307240',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000167,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,198.122041667,53.12347,0.026,NULL,57415256857,897113388,14017396,16.6),(106389,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106389,36.84,0.27,233,45224,70,NULL,NULL,'2MASX J13122932+0945103',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000179,NULL,'17.48',0.25,NULL,NULL,NULL,NULL,NULL,1,198.122083,9.75283,0,NULL,58973688730,921463886,14397873,17.48),(106390,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106390,37.84,0.46,369,45225,70,NULL,NULL,'2MASX J13123169+5523572',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000185,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,198.132,55.39933,0.013,NULL,57424894799,897263981,14019749,17.1),(106391,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106391,38.06,0.46,410,45226,70,NULL,NULL,'2MASX J13123243+1606120',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,198.135166667,16.10319,0.008,NULL,59041951714,922530495,14414538,17.5),(106392,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106392,35.26,0.46,113,45227,70,NULL,NULL,'CGCG 072-023',NULL,'2015arXiv151105856S',2015,1,0.93,NULL,'G',0.000147,NULL,'14.5g',0.73,'E0',NULL,NULL,NULL,NULL,1,198.136708333,11.72897,0,NULL,58971927745,921436371,14397443,14.5),(106393,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106393,36.77,0.46,226,45228,70,NULL,NULL,'SDSS J131233.23+442619.7',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,198.1385,44.43883,0.024,NULL,59279082499,926235664,14472432,17.6),(106394,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106394,31.21,0.4,17.5,45229,75,NULL,'B','UGC 08285',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000022,NULL,'14.69',0.4,'Sdm:',NULL,NULL,NULL,NULL,1,198.138625,7.18428,0.029,NULL,58979657426,921557147,14399330,14.69),(106395,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106395,31.52,NULL,20.1,45229,72,NULL,NULL,'UGC 08285',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106396,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106396,37.61,0.13,333,45230,70,NULL,NULL,'2MASX J13123373-0105311',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000076,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,198.140583,-1.09189,0.025,NULL,43091435691,673303682,10520370,17.6),(106397,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106397,36.84,0.27,233,45231,70,NULL,NULL,'2MASX J13123378+0955343',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000195,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,198.140708333,9.92617,0,NULL,58973703992,921464124,14397876,16.2),(106398,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106398,36.84,0.27,233,45232,70,NULL,NULL,'2MASX J13123513+0958530',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000181,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,198.1465,9.98139,0,NULL,58973520283,921461254,14397832,16.4),(106399,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106399,37.64,0.46,338,45233,70,NULL,NULL,'2MASX J13123520+4224120',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000152,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,198.1465,42.40344,0,NULL,59299806474,926559476,14477491,17.3),(106400,'IRAS','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106400,32.93,0.8,38.6,45234,75,NULL,'MAT, I','MCG -03-34-014',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000013,NULL,'13.02',0.8,'SAB(s)c','X-ray-bright group member',NULL,NULL,NULL,1,198.147625,-17.54242,0.145,NULL,44007443575,687616305,10744004,13.02),(106401,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106401,32.27,0.43,28.4,45234,75,NULL,'3.6 micron, color + selection bias corrected','MCG -03-34-014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106402,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106402,32.33,0.4,29.2,45234,NULL,NULL,NULL,'MCG -03-34-014',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106403,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106403,32.36,0.43,29.6,45234,75,NULL,'3.6 micron, color corrected','MCG -03-34-014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106404,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106404,32.36,0.4,29.7,45234,75,NULL,NULL,'MCG -03-34-014',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106405,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106405,32.45,0.32,30.9,45234,85,NULL,'I, raw','MCG -03-34-014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106406,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106406,32.49,0.2,31.5,45234,74.4,NULL,NULL,'MCG -03-34-014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106407,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106407,32.5,0.32,31.6,45234,85,NULL,'I, inv','MCG -03-34-014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106408,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106408,32.53,0.49,32.1,45234,75,NULL,'IR','MCG -03-34-014',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106409,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106409,32.54,0.43,32.2,45234,75,NULL,'MAT, I, raw','MCG -03-34-014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106410,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106410,32.76,0.43,35.7,45234,75,NULL,'MAT, I, inv','MCG -03-34-014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106411,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106411,32.78,0.43,35.9,45234,75,NULL,'MAT, I, cor','MCG -03-34-014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106412,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106412,33.05,0.09,40.8,45234,NULL,NULL,NULL,'MCG -03-34-014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106413,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106413,37.75,0.46,356,45235,70,NULL,NULL,'2MASX J13123567-0107181',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000087,NULL,'17.2g',0.22,'BrClG',NULL,NULL,NULL,NULL,1,198.1487917,-1.12175,0.025,NULL,43091481238,673304394,10520381,17.2),(106414,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106414,37.05,0.33,257,45236,70,NULL,NULL,'2MASX J13123608+4049588',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000152,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,198.150417,40.83303,0,NULL,59302471919,926601123,14478142,17),(106415,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106415,35.36,0.23,118,45237,70,NULL,NULL,'NGC 5029',NULL,'2015arXiv151105856S',2015,1,1.6,NULL,'G',0.000103,NULL,'13.7g',0.93,'E',NULL,NULL,NULL,NULL,1,198.156625,47.06328,0,NULL,59098928725,923420761,14428449,13.7),(106416,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106416,36.88,0.23,237,45238,70,NULL,NULL,'2MASX J13123761+0512225',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.90',0.14,NULL,NULL,NULL,NULL,NULL,1,198.15675,5.20614,0,NULL,58930983363,920796615,14387447,17.9),(106417,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106417,37.28,0.46,286,45239,70,NULL,NULL,'2MASX J13123850+1018030',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000213,NULL,'17.46',0.19,NULL,NULL,NULL,NULL,NULL,1,198.1604583,10.30072,0,NULL,58975618490,921494038,14398344,17.46),(106418,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106418,37.95,0.27,390,45240,70,NULL,NULL,'SDSS J131241.12+153558.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,198.171375,15.59969,0.016,NULL,59041296646,922520260,14414379,18.1),(106419,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106419,37.95,0.27,390,45241,70,NULL,NULL,'SDSS J131241.63+153722.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,198.1734583,15.62286,0.016,NULL,59041300293,922520317,14414379,18),(106420,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106420,33.02,0.4,40.1,45242,75,NULL,'B','NGC 5012A',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.000017,NULL,'14.20',1,'Sm:','in a pair',NULL,NULL,NULL,1,198.174125,22.82981,0.025,NULL,58815895975,918998374,14359349,14.2),(106421,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106421,36.88,0.23,237,45243,70,NULL,NULL,'2MASX J13124190+0502375',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000196,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,198.174583,5.04381,0.022,NULL,58930401000,920787515,14387304,16.7),(106422,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106422,37.9,0.46,380,45244,70,NULL,NULL,'2MASXi J1312422-003113',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000071,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,198.176,-0.52047,0.025,NULL,43091648134,673307002,10520421,18.1),(106423,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106423,36.81,0.46,230,45245,70,NULL,NULL,'2MASX J13124266-0034267',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000067,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,198.177667,-0.57411,0.025,NULL,43091675680,673307432,10520428,17.7),(106424,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106424,37.61,0.46,333,45246,70,NULL,NULL,'SDSS J131242.65+041826.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000157,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,198.17775,4.30733,0.048,NULL,58056786707,907137292,14174020,18.5),(106425,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106425,37.48,0.33,313,45247,70,NULL,NULL,'SDSS J131243.04+530751.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000166,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,198.179375,53.13092,0.026,NULL,57415268348,897113567,14017399,18.5),(106426,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106426,37.8,0.33,362,45248,70,NULL,NULL,'2MASXi J1312430+411127',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,198.179625,41.19097,0,NULL,59303180262,926612191,14478315,17.8),(106427,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106427,37.23,0.46,279,45249,70,NULL,NULL,'LCRS B131008.7-025909',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000067,NULL,'17.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,198.181583333,-3.251,0.025,NULL,43095663854,673369747,10521402,17.7),(106428,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106428,34.44,0.2,77.3,45250,74.4,NULL,NULL,'NGC 5025',NULL,'2013AJ....146...86T',2013,1,1.12,'Position in 1995ApJS...97...77D is for northeast end of galaxy.','G',0.000008,NULL,'14.2g',0.57,'Sb',NULL,NULL,NULL,NULL,1,198.1864583,31.80939,0,NULL,58680290158,916879533,14326242,14.2),(106429,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106429,34.5,0.49,79.5,45250,75,NULL,'IR','NGC 5025',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106430,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106430,34.84,0.47,92.8,45250,NULL,NULL,'H','NGC 5025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106431,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106431,34.86,0.4,93.9,45250,NULL,NULL,'mean','NGC 5025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106432,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106432,34.93,0.46,96.7,45250,NULL,NULL,'J','NGC 5025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106433,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106433,35.01,0.45,100,45250,NULL,NULL,'K','NGC 5025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106434,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106434,28.09,0.09,4.15,45251,NULL,NULL,'I','Centaurus A-dE1',NULL,'2009AJ....138..332J',2009,1,1,NULL,'G',NULL,NULL,'19.3',0.6,'dwarf Sph?',NULL,NULL,NULL,NULL,1,198.188333,-41.8325,0.473,NULL,46933918795,733342481,11458476,19.3),(106435,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106435,28.12,NULL,4.21,45251,NULL,NULL,NULL,'Centaurus A-dE1',NULL,'2007AJ....133..504K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106436,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106436,28.13,0.1,4.23,45251,74.4,NULL,NULL,'Centaurus A-dE1',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106437,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106437,28.13,0.11,4.23,45251,NULL,NULL,NULL,'Centaurus A-dE1',NULL,'2015ApJ...802L..25T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106438,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106438,28.18,0.12,4.33,45251,NULL,NULL,'I, M(ITRGB) = -4.05','Centaurus A-dE1',NULL,'2011A&A...530A..58C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106439,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106439,36.92,0.46,242,45252,70,NULL,NULL,'2MASX J13124616+0120175',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000179,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,198.192458333,1.33825,0.025,NULL,58060764240,907199441,14174991,16.5),(106440,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106440,36.93,0.27,244,45253,70,NULL,NULL,'2MASX J13124707+5358411',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,198.196375,53.97806,0.041,NULL,57414316552,897098696,14017167,17.9),(106441,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106441,37.79,0.46,362,45254,70,NULL,NULL,'SDSS J131247.26+211024.4',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'19.01',NULL,NULL,NULL,NULL,NULL,NULL,1,198.196958333,21.17333,NULL,NULL,58817485377,919023209,14359737,19.01),(106442,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106442,37.95,0.27,390,45255,70,NULL,NULL,'2MASX J13124844+1537049',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,198.201833333,15.61819,0.016,NULL,59041298316,922520286,14414379,16.9),(106443,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106443,37.39,0.46,300,45256,70,NULL,NULL,'2MASXi J1312497+480506',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000175,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,198.207208333,48.08511,0,NULL,59103014480,923484601,14429446,17.6),(106444,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106444,37.48,0.46,313,45257,70,NULL,NULL,'LCRS B131014.9-031222',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000087,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,198.207625,-3.47092,0.025,NULL,43095628551,673369196,10521393,16.7),(106445,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106445,35.36,0.23,118,45258,70,NULL,NULL,'2MASX J13125070+4703170',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000167,NULL,'16.1g',0.29,'S0^-',NULL,NULL,NULL,NULL,1,198.2112917,47.05481,0,NULL,59098930947,923420796,14428449,16.1),(106446,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106446,36.14,0.8,169,45259,70,NULL,NULL,'2MASX J13125080-2140523',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.23',NULL,NULL,NULL,NULL,NULL,NULL,1,198.211708333,-21.68128,0.277,NULL,43801955113,684405548,10693836,16.23),(106447,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106447,37.69,0.33,345,45260,70,NULL,NULL,'2MASX J13125079+1943469',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.67',0.21,NULL,NULL,NULL,NULL,NULL,1,198.211875,19.72975,0.071,NULL,58811834558,918934914,14358358,17.67),(106448,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106448,37.69,0.33,345,45261,70,NULL,NULL,'2MASX J13125100+1932049',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.62',0.14,NULL,NULL,NULL,NULL,NULL,1,198.2125417,19.53469,0.073,NULL,58808995848,918890560,14357665,18.62),(106449,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106449,37.57,0.21,326,45262,70,NULL,NULL,'2MASX J13125110+0100065',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000084,NULL,'16.0g',0.47,'BrClG',NULL,NULL,NULL,NULL,1,198.2130417,1.00181,0.043,NULL,58060884967,907201327,14175020,16),(106450,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106450,36.67,0.46,215,45263,70,NULL,NULL,'VII Zw 503',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,198.2157917,56.95264,0,NULL,57435702338,897432849,14022388,16.7),(106451,'SBF','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106451,33.11,0.22,41.9,45264,NULL,NULL,'I','NGC 5011',NULL,'2001ApJ...546..681T',2001,1,2.4,NULL,'G',0.000067,NULL,'12.41',2,'E1-2           LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,198.216083,-43.09622,0.401,NULL,46960294619,733754603,11464915,12.41),(106452,'SBF','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106452,33.11,0.22,41.9,45264,NULL,NULL,NULL,'NGC 5011',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106453,'SBF','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106453,33.16,0.14,42.9,45264,74.4,NULL,NULL,'NGC 5011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106454,'SBF','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106454,33.22,0.22,44,45264,NULL,NULL,'Malmquist cor.','NGC 5011',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106455,'D-Sigma','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106455,32.84,0.4,36.9,45264,75,NULL,'Edat, raw','NGC 5011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106456,'D-Sigma','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106456,33.02,0.4,40.2,45264,75,NULL,'Edat, cor','NGC 5011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106457,'Faber-Jackson','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106457,32.04,0.65,25.6,45264,95,NULL,'Weighted Mean','NGC 5011',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106458,'Faber-Jackson','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106458,33.5,0.81,50.1,45264,55,NULL,'Visvanathan & Sandage 1979','NGC 5011',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106459,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106459,32.81,0.41,36.5,45264,NULL,NULL,NULL,'NGC 5011',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106460,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106460,32.93,0.48,38.5,45264,70,NULL,NULL,'NGC 5011',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106461,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106461,33.15,0.41,42.7,45264,NULL,NULL,'Malmquist cor.','NGC 5011',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106462,'Tully est','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106462,33.06,0.8,40.9,45264,75,NULL,'B','NGC 5011',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106463,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106463,33.16,0.45,42.8,45264,NULL,NULL,'K','NGC 5011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106464,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106464,33.37,0.4,47.1,45264,NULL,NULL,'mean','NGC 5011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106465,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106465,37.57,0.21,326,45265,70,NULL,NULL,'2MASX J13125250+0101115',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00008,NULL,'17.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,198.218875,1.01981,0.043,NULL,58060854905,907200857,14175013,17.5),(106466,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106466,37.27,0.46,284,45266,70,NULL,NULL,'2MASX J13125388+5639478',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,198.224333,56.66339,0,NULL,57435633880,897431779,14022371,17.7),(106467,'D-Sigma','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106467,32.75,0.4,35.4,45267,75,NULL,'Edat, raw','NGC 5017',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.00006,NULL,'13.6',1.3,'E+?','X-ray-bright group member',NULL,NULL,NULL,1,198.227083,-16.76583,0.097,NULL,44010564179,687665065,10744766,13.6),(106468,'D-Sigma','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106468,32.9,0.4,38,45267,75,NULL,'Edat, cor','NGC 5017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106469,'Faber-Jackson','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106469,31.13,0.65,16.8,45267,95,NULL,'Weighted Mean','NGC 5017',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106470,'Faber-Jackson','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106470,32.38,0.81,29.9,45267,55,NULL,'Visvanathan & Sandage 1979','NGC 5017',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106471,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106471,32.48,0.51,31.4,45267,70,NULL,NULL,'NGC 5017',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106472,'Tully est','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106472,32.83,0.8,36.8,45267,75,NULL,'B','NGC 5017',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106473,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106473,33.08,0.4,41.4,45267,NULL,NULL,'mean','NGC 5017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106474,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106474,33.6,0.45,52.6,45267,NULL,NULL,'K','NGC 5017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106475,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106475,37.57,0.21,326,45268,70,NULL,NULL,'2MASX J13125470+0102095',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000102,NULL,'16.0g',0.46,'E0',NULL,NULL,NULL,NULL,1,198.228083,1.03597,0.043,NULL,58060856475,907200882,14175013,16),(106476,'IRAS','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106476,32.26,0.8,28.3,45269,75,NULL,'MAT, I','UGCA 334',NULL,'1997ApJS..109..333W',1997,1,3.4,NULL,'G',0.000019,NULL,'13.29',0.9,'SB(s)d: sp',NULL,NULL,NULL,NULL,1,198.2327917,-32.68833,0.193,NULL,46872410939,732381420,11443459,13.29),(106477,'Tully est','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106477,32.61,0.8,33.3,45269,75,NULL,NULL,'UGCA 334',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106478,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106478,31.48,0.4,19.8,45269,NULL,NULL,NULL,'UGCA 334',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106479,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106479,31.49,0.2,19.9,45269,74.4,NULL,NULL,'UGCA 334',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106480,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106480,31.54,0.32,20.3,45269,85,NULL,'I, raw','UGCA 334',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106481,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106481,31.55,0.43,20.4,45269,75,NULL,'3.6 micron, color corrected','UGCA 334',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106482,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106482,31.55,0.32,20.4,45269,85,NULL,'I, inv','UGCA 334',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106483,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106483,31.59,0.43,20.8,45269,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 334',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106484,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106484,31.7,0.43,21.9,45269,75,NULL,'MAT, I, raw','UGCA 334',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106485,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106485,31.7,0.5,21.9,45269,NULL,NULL,NULL,'UGCA 334',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106486,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106486,31.76,0.48,22.5,45269,NULL,NULL,'Malmquist cor.','UGCA 334',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106487,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106487,31.78,0.43,22.7,45269,75,NULL,'MAT, I, inv','UGCA 334',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106488,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106488,31.79,0.4,22.9,45269,75,NULL,NULL,'UGCA 334',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106489,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106489,32.03,0.43,25.5,45269,75,NULL,'MAT, I, cor','UGCA 334',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106490,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106490,32.32,0.49,29.2,45270,75,NULL,'IR','2MFGC 10534',NULL,'2011yCatp016004901K',2011,1,NULL,'This is a part of UGCA 334.','PofG',0.00015,NULL,NULL,NULL,'HII',NULL,NULL,NULL,NULL,1,198.233666667,-32.69392,0.193,NULL,46872410917,732381420,11443459,NULL),(106491,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106491,38.08,0.17,414,45271,70,NULL,NULL,'2MASX J13125676+0814200',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,198.2364583,8.23878,0.015,NULL,58986665865,921666654,14401041,18.1),(106492,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106492,37.46,0.12,310,45272,70,NULL,NULL,'2MASX J13125708+3903002',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00008,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,198.2379583,39.05011,0,NULL,59307268858,926676075,14479313,16.5),(106493,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106493,37.66,0.46,340,45273,70,NULL,NULL,'2MASX J13125738+0907100',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000173,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,198.2392917,9.11947,0,NULL,58973923368,921467552,14397930,17),(106494,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106494,37.48,0.46,313,45274,70,NULL,NULL,'2MASX J13125775+6012317',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000163,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,198.2407917,60.20872,0,NULL,57383636136,896619314,14009676,16.8),(106495,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106495,34.44,0.2,77.3,45275,74.4,NULL,NULL,'UGC 08294',NULL,'2013AJ....146...86T',2013,1,0.81,NULL,'G',0.000008,NULL,'15.7g',0.61,'Scd:',NULL,NULL,NULL,NULL,1,198.242833,31.25861,0,NULL,58679866794,916872918,14326139,15.7),(106496,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106496,34.46,0.43,77.9,45275,75,NULL,'3.6 micron, color corrected','UGC 08294',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106497,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106497,34.52,0.43,80.2,45275,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08294',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106498,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106498,34.8,0.09,91.4,45275,NULL,NULL,NULL,'UGC 08294',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106499,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106499,36.11,0.5,166,45276,70,NULL,NULL,'2MASX J13125945-3300102',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.6b',NULL,'E',NULL,NULL,NULL,NULL,1,198.24775,-33.00281,0.193,NULL,46860896011,732201500,11440648,16.6),(106500,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106500,38.49,0.46,499,45277,70,NULL,NULL,'SDSS J131259.46+672941.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000083,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,198.2477917,67.49483,0.025,NULL,57910715087,904854923,14138358,18.6),(106501,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106501,37.3,0.46,289,45278,70,NULL,NULL,'2MASX J13125980+1106010',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00017,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,198.249167,11.10042,0,NULL,58972009571,921437649,14397463,16.6),(106502,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106502,36.56,0.46,205,45279,70,NULL,NULL,'2MASX J13130007+4128422',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000154,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,198.250417,41.47839,0,NULL,59303151516,926611742,14478308,17),(106503,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106503,37.61,0.13,333,45280,70,NULL,NULL,'2MASX J13130024-0101307',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000067,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,198.250917,-1.02514,0.025,NULL,43091341599,673302212,10520347,17.3),(106504,'GCLF','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106504,32.4,0.6,30.2,45281,NULL,NULL,'TOM(V) = -7.3 mag','NGC 5018',NULL,'2009ApJ...690..512H',2009,1,3.3,NULL,'G',0.000003,NULL,'11.2B',2.5,'E3:','in a pair',NULL,NULL,NULL,1,198.254291667,-19.51819,0.217,NULL,43797258571,684332165,10692690,11.2),(106505,'GCLF','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106505,33.4,0.6,47.9,45281,NULL,NULL,NULL,'NGC 5018',NULL,'1996A&A...314..357H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106506,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:23','1','SN 2002dj',NULL,106506,32.08,0.26,25.8,45281,74.2,NULL,'SALT 2','NGC 5018',0.009393,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106507,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:23','1','SN 2002dj',NULL,106507,32.65,0.09,33.9,45281,74.4,NULL,NULL,'NGC 5018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106508,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:23','1','SN 2002dj',NULL,106508,32.85,0.22,36.8,45281,73.8,NULL,'SALT 2 (SNANA)','NGC 5018',0.0104,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106509,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:23','1','SN 2002dj',NULL,106509,32.87,0.12,37.1,45281,72,NULL,NULL,'NGC 5018',0.009393,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106510,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:23','1','SN 2002dj',NULL,106510,32.89,0.25,37.5,45281,70,NULL,'SALT 2','NGC 5018',0.009393,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106511,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:23','1','SN 2002dj',NULL,106511,32.9,0.03,37.7,45281,72,NULL,NULL,'NGC 5018',0.009393,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106512,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:23','1','SN 2002dj',NULL,106512,32.94,0.05,38.4,45281,72,NULL,NULL,'NGC 5018',0.009393,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106513,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:23','1','SN 2002dj',NULL,106513,32.96,0.31,38.7,45281,65,NULL,'SALT2','NGC 5018',0.009393,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106514,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:23','1','SN 2002dj',NULL,106514,32.99,0.02,39.6,45281,72,NULL,'M(H) = -18.317 mag','NGC 5018',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106515,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:23','1','SN 2002dj',NULL,106515,33.1,0.29,41.4,45281,65,NULL,'MLCS17','NGC 5018',0.009393,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106516,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:23','1','SN 2002dj',NULL,106516,33.13,0.3,41.8,45281,65,NULL,'MLCS31','NGC 5018',0.009393,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106517,'D-Sigma','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106517,32.75,0.4,35.4,45281,75,NULL,'Edat, raw','NGC 5018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106518,'D-Sigma','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106518,32.9,0.4,38,45281,75,NULL,'Edat, cor','NGC 5018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106519,'Faber-Jackson','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106519,30.8,0.65,14.5,45281,95,NULL,'Weighted Mean','NGC 5018',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106520,'Faber-Jackson','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106520,31.97,0.81,24.8,45281,55,NULL,'Visvanathan & Sandage 1979','NGC 5018',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106521,'Tully est','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106521,33.06,0.8,40.9,45281,75,NULL,'B','NGC 5018',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106522,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106522,32.34,0.45,29.4,45281,NULL,NULL,'K','NGC 5018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106523,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106523,32.57,0.4,32.7,45281,75,NULL,'HOSTS SN 2002dj','NGC 5018',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106524,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106524,33.24,0.4,44.5,45281,NULL,NULL,'mean','NGC 5018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106525,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106525,36.18,0.61,172,45282,70,NULL,NULL,'2MASX J13130120-4401432',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,198.254917,-44.02872,0.481,NULL,46951176804,733612137,11462689,15),(106526,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106526,37.22,0.71,277,45283,70,NULL,NULL,'LCRS B131023.5-122052',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000127,NULL,'15.12',0.5,NULL,NULL,NULL,NULL,NULL,1,198.2574583,-12.61286,0.065,NULL,43994449994,687413281,10740832,15.12),(106527,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106527,36.65,0.46,214,45284,70,NULL,NULL,'2MASX J13130187+3844233',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000142,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,198.257667,38.73972,0,NULL,59306585408,926665397,14479146,17.3),(106528,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106528,37.46,0.12,310,45285,70,NULL,NULL,'2MASX J13130180+3904243',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,198.257667,39.07356,0,NULL,59307274762,926676168,14479315,17.8),(106529,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106529,38.38,0.33,475,45286,70,NULL,NULL,'2MASX J13130261+6201577',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,198.261,62.03289,0.021,NULL,57354083901,896157560,14002461,18.2),(106530,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106530,38.08,0.17,414,45287,70,NULL,NULL,'SDSS J131302.70+080850.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,198.2612917,8.14736,0.015,NULL,58986663090,921666610,14401040,18.4),(106531,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106531,38.07,0.46,411,45288,70,NULL,NULL,'2MASX J13130307+3940353',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000178,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,198.262667,39.67653,0,NULL,59306951559,926671118,14479236,16.9),(106532,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106532,38.34,0.46,467,45289,70,NULL,NULL,'2MASX J13130410+1049435',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.67',0.15,NULL,NULL,NULL,NULL,NULL,1,198.267208333,10.82869,0,NULL,58972862813,921450981,14397671,18.67),(106533,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106533,31.89,NULL,23.9,45290,72,NULL,NULL,'AGC 238737',NULL,'2014Ap.....57..457K',2014,1,NULL,NULL,'RadioS',0.000068,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,198.26875,6.2775,0.032,NULL,58976483633,921507556,14398555,NULL),(106534,'IRAS','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106534,32.89,0.8,37.9,45291,75,NULL,'MAT, I','ESO 576- G 011',NULL,'1997ApJS..109..333W',1997,1,3.53,NULL,'G',0.000013,NULL,'14.11',0.5,'SB(s)cd? sp    HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,198.2712917,-19.97692,0.201,NULL,43801073264,684391769,10693621,14.11),(106535,'IRAS','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106535,32.91,0.8,38.2,45291,75,NULL,'HMCL, I','ESO 576- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106536,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106536,32.22,0.4,27.8,45291,75,NULL,NULL,'ESO 576- G 011',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106537,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106537,32.46,0.38,31,45291,NULL,NULL,NULL,'ESO 576- G 011',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106538,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106538,32.52,0.32,31.9,45291,85,NULL,'I, raw','ESO 576- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106539,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106539,32.54,0.32,32.2,45291,85,NULL,'I, inv','ESO 576- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106540,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106540,32.58,0.43,32.7,45291,75,NULL,'MAT, I, raw','ESO 576- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106541,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106541,32.6,0.4,33.1,45291,75,NULL,'HMCL, I, raw','ESO 576- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106542,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106542,32.6,0.2,33.1,45291,74.4,NULL,NULL,'ESO 576- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106543,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106543,32.62,0.43,33.5,45291,75,NULL,'3.6 micron, color corrected','ESO 576- G 011',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106544,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106544,32.66,0.43,34,45291,75,NULL,'3.6 micron, color + selection bias corrected','ESO 576- G 011',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106545,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106545,32.67,NULL,34.2,45291,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 576- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106546,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106546,32.67,NULL,34.2,45291,NULL,NULL,'Dipole + Quadrupole','ESO 576- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106547,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106547,32.67,0.49,34.2,45291,75,NULL,'IR','ESO 576- G 011',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106548,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106548,32.67,NULL,34.3,45291,NULL,NULL,'Dipole','ESO 576- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106549,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106549,32.71,0.4,34.8,45291,75,NULL,'HMCL, I, inv','ESO 576- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106550,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106550,32.71,0.43,34.9,45291,75,NULL,'MAT, I, inv','ESO 576- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106551,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106551,32.74,NULL,35.4,45291,NULL,NULL,NULL,'ESO 576- G 011',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106552,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106552,32.81,0.4,36.4,45291,75,NULL,'HMCL, I, cor','ESO 576- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106553,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106553,32.81,0.43,36.5,45291,75,NULL,'MAT, I, cor','ESO 576- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106554,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106554,32.92,0.47,38.4,45291,NULL,NULL,'H','ESO 576- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106555,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106555,33.03,0.46,40.4,45291,NULL,NULL,'J','ESO 576- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106556,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106556,33.13,0.45,42.2,45291,NULL,NULL,'K','ESO 576- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106557,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106557,33.22,0.4,44,45291,NULL,NULL,'mean','ESO 576- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106558,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106558,33.3,0.14,45.8,45291,NULL,NULL,NULL,'ESO 576- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106559,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106559,37.82,0.46,366,45292,70,NULL,NULL,'2MASX J13130594+3020328',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000179,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,198.274625,30.34236,0.049,NULL,58681435738,916897433,14326522,16.9),(106560,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106560,37.51,0.46,317,45293,70,NULL,NULL,'2MASX J13130615+2939576',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000153,NULL,'16.1g',0.37,'S0',NULL,NULL,NULL,NULL,1,198.275625,29.66592,0.033,NULL,58713108738,917392324,14334255,16.1),(106561,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106561,36.93,0.46,243,45294,70,NULL,NULL,'2MASX J13130650+4603411',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000147,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,198.276875,46.06144,0,NULL,59280482241,926257535,14472773,17.7),(106562,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106562,36.4,0.46,190,45295,70,NULL,NULL,'2MASX J13130712+0448481',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000172,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,198.279625,4.81336,0.05,NULL,58930488723,920788886,14387326,16.5),(106563,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106563,37.61,0.13,333,45296,70,NULL,NULL,'2MASX J13130786-0055500',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000079,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,198.282917,-0.93064,0.025,NULL,43091352934,673302389,10520349,18.2),(106564,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106564,37.9,0.46,380,45297,70,NULL,NULL,'2MASX J13130871+4519221',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000174,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,198.286167,45.32278,0,NULL,59278771412,926230803,14472356,17.3),(106565,'SBF','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106565,27.74,NULL,3.54,45298,NULL,NULL,NULL,'ESO 269- G 066',NULL,'2000AJ....119..166J',2000,1,1.4,NULL,'G',0.000103,NULL,'14.11',1.2,'dE,N:',NULL,NULL,NULL,NULL,1,198.288167,-44.88994,0.397,NULL,46951871754,733622996,11462859,14.11),(106566,'SBF','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106566,28.04,0.37,4.05,45298,NULL,NULL,'R','ESO 269- G 066',NULL,'2000AJ....119..166J',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106567,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106567,27.82,0.02,3.66,45298,NULL,NULL,'I','ESO 269- G 066',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106568,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106568,27.87,NULL,3.75,45298,NULL,NULL,NULL,'ESO 269- G 066',NULL,'2007AJ....133..504K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106569,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106569,27.87,0.1,3.75,45298,74.4,NULL,NULL,'ESO 269- G 066',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106570,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106570,27.87,0.11,3.75,45298,NULL,NULL,NULL,'ESO 269- G 066',NULL,'2015ApJ...802L..25T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106571,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106571,27.88,0.12,3.77,45298,NULL,NULL,'I, M(ITRGB) = -4.05','ESO 269- G 066',NULL,'2011A&A...530A..58C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106572,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106572,37.34,0.33,294,45299,70,NULL,NULL,'2MASX J13130963+3954193',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000153,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,198.2902917,39.90547,0,NULL,59304874203,926638659,14478729,17.2),(106573,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106573,36.88,0.23,237,45300,70,NULL,NULL,'2MASX J13130999+0519111',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.64',0.16,NULL,NULL,NULL,NULL,NULL,1,198.291583333,5.31969,0,NULL,58930789272,920793582,14387399,17.64),(106574,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106574,35.73,0.46,140,45301,70,NULL,NULL,'2MASX J13131055+1055545',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000152,NULL,'15.9g',0.37,NULL,NULL,NULL,NULL,NULL,1,198.2940417,10.93183,0,NULL,58972873342,921451145,14397674,15.9),(106575,'SBF','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106575,29.06,0.92,6.49,45302,NULL,NULL,'Sersic','NGC 5011C',NULL,'2007AJ....133.1756S',2007,1,1.2,'RC3 gives a discordant velocity of v = 3236 km/sec.','G',0.00032,NULL,'14.21',0.8,'S0: pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,198.2995,-43.26547,0.401,NULL,46960338649,733755291,11464926,14.21),(106576,'SBF','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106576,29.85,1.5,9.33,45302,NULL,NULL,'SB-m relation','NGC 5011C',NULL,'2007AJ....133.1756S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106577,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106577,27.86,0.1,3.73,45302,74.4,NULL,NULL,'NGC 5011C',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106578,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106578,27.86,0.11,3.73,45302,NULL,NULL,NULL,'NGC 5011C',NULL,'2015ApJ...802L..25T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106579,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106579,38.09,0.46,414,45303,70,NULL,NULL,'2MASX J13131207+2132160',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,198.300458333,21.53789,0.031,NULL,58817750447,919027350,14359802,16.8),(106580,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106580,32.71,0.5,34.9,45304,70,NULL,NULL,'NGC 5011B',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000017,NULL,'14.42',0.4,'S0: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,198.300541667,-43.24647,0.401,NULL,46960340853,733755325,11464926,14.42),(106581,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106581,33.72,0.47,55.5,45305,70,NULL,NULL,'ESO 382- G 016',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000047,NULL,'13.68',0.8,'SA0^0^ pec:','Pair member (points to parent)',NULL,NULL,NULL,1,198.3017083,-36.72281,0.165,NULL,46928931435,733264553,11457258,13.68),(106582,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106582,36.61,0.46,210,45306,70,NULL,NULL,'2MASX J13131373+1113295',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00018,NULL,'16.0g',0.42,'E0',NULL,NULL,NULL,NULL,1,198.3070417,11.22489,0,NULL,58972126692,921439479,14397491,16),(106583,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106583,37.86,0.16,373,45307,70,NULL,NULL,'2MASX J13131449+0649265',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.54',0.11,NULL,NULL,NULL,NULL,NULL,1,198.310417,6.82381,0.053,NULL,58980289370,921567021,14399484,18.54),(106584,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106584,37.47,0.46,311,45308,70,NULL,NULL,'SDSS J131315.61-015535.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000066,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,198.315083333,-1.92639,0.021,NULL,43097161522,673393148,10521767,18),(106585,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106585,38.93,0.46,610,45309,70,NULL,NULL,'SDSS J131315.79+043742.2',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,198.315833,4.62839,0.036,NULL,58930276962,920785577,14387274,18.1),(106586,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106586,37.46,0.12,310,45310,70,NULL,NULL,'2MASX J13131631+3900503',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000123,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,198.3180417,39.01383,0,NULL,59307319841,926676872,14479326,17.2),(106587,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106587,37.52,0.46,319,45311,70,NULL,NULL,'2MASX J13131651+0629075',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.04',0.16,NULL,NULL,NULL,NULL,NULL,1,198.318791667,6.48558,0.029,NULL,58979965015,921561953,14399405,18.04),(106588,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106588,37.34,0.33,294,45312,70,NULL,NULL,'2MASX J13131676+3955573',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,198.319833333,39.9325,0,NULL,59306938606,926670915,14479233,17.1),(106589,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106589,39.02,0.46,638,45313,70,NULL,NULL,'2MASX J13131683+3015499',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000181,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,198.32,30.26375,0.049,NULL,58681443099,916897548,14326524,17.9),(106590,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106590,31.54,0.4,20.3,45314,75,NULL,'B','Holmberg VIII',NULL,'1988NBGC.C....0000T',1988,1,2.2,NULL,'G',0.000017,NULL,'13.48',1.9,'IAB(s)m','is a companion galaxy',NULL,NULL,NULL,1,198.323333,36.2175,0,NULL,59159479716,924366870,14443232,13.48),(106591,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106591,37.44,0.46,307,45315,70,NULL,NULL,'2MASX J13131758+5151350',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000177,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,198.323375,51.85961,0,NULL,57194421041,893662828,13963481,17.5),(106592,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106592,38.08,0.17,414,45316,70,NULL,NULL,'2MASX J13131824+0812075',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.69',0.17,NULL,NULL,NULL,NULL,NULL,1,198.326166667,8.20203,0.026,NULL,58987523676,921680057,14401250,17.69),(106593,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106593,37.2,0.46,275,45317,70,NULL,NULL,'2MASX J13131955+2628546',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00012,NULL,'16.87',0.28,NULL,NULL,NULL,NULL,NULL,1,198.3315417,26.48172,0.032,NULL,58710575145,917352736,14333636,16.87),(106594,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106594,30.36,0.2,11.8,45318,74.4,NULL,NULL,'UGC 08298',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000002,NULL,'14.60',0.9,'Im',NULL,NULL,NULL,NULL,1,198.331583,10.19392,0,NULL,58975808645,921497010,14398390,14.6),(106595,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106595,37.69,0.46,346,45319,70,NULL,NULL,'SDSS J131320.21+034827.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00018,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,198.33425,3.80764,0.053,NULL,58056957764,907139965,14174061,18.3),(106596,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106596,36.55,0.46,204,45320,70,NULL,NULL,'SDSS J131320.70+221251.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,198.336291667,22.21431,0.025,NULL,58817020855,919015950,14359624,17.3),(106597,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106597,37.43,0.56,306,45321,70,NULL,NULL,'2MASX J13132146-4431272',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,198.339416667,-44.52428,0.481,NULL,46952059259,733625925,11462905,17),(106598,'IRAS','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106598,34.61,0.8,83.7,45322,75,NULL,'MAT, I','ESO 576- G 012',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'15.70',0.9,'SA(rs)c:',NULL,NULL,NULL,NULL,1,198.34025,-18.93103,0.221,NULL,43797844649,684341322,10692833,15.7),(106599,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106599,33.4,0.32,47.9,45322,85,NULL,'I, raw','ESO 576- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106600,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106600,33.4,0.32,47.9,45322,85,NULL,'I, inv','ESO 576- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106601,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106601,33.85,0.43,58.8,45322,75,NULL,'MAT, I, raw','ESO 576- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106602,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106602,33.91,0.43,60.5,45322,75,NULL,'MAT, I, inv','ESO 576- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106603,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106603,34.17,0.43,68.3,45322,75,NULL,'MAT, I, cor','ESO 576- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106604,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106604,34.85,0.2,93.3,45322,74.4,NULL,NULL,'ESO 576- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106605,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106605,35.04,0.51,102,45322,NULL,NULL,'Malmquist cor.','ESO 576- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106606,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106606,35.09,0.5,104,45322,NULL,NULL,NULL,'ESO 576- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106607,'Brightest Stars','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106607,27.85,NULL,3.72,45323,NULL,NULL,NULL,'UGC 08308',NULL,'1998A&AS..128..325T',1998,1,1.1,'Multiple SDSS entries describe this source.','G',0.000001,NULL,'17.',0.6,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,198.345125,46.32267,0,NULL,59280715592,926261181,14472830,17),(106608,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106608,28.02,0.1,4.02,45323,NULL,NULL,NULL,'UGC 08308',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106609,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106609,28.08,0.25,4.14,45323,NULL,NULL,NULL,'UGC 08308',NULL,'2013AstBu..68..125M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106610,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106610,28.1,0.26,4.17,45323,NULL,NULL,NULL,'UGC 08308',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106611,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106611,28.11,0.26,4.19,45323,NULL,NULL,NULL,'UGC 08308',NULL,'2003A&A...398..467K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106612,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106612,28.13,0.17,4.23,45323,NULL,NULL,'I','UGC 08308',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106613,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106613,28.14,0.1,4.25,45323,74.4,NULL,NULL,'UGC 08308',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106614,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106614,28.2,0.12,4.37,45323,NULL,NULL,NULL,'UGC 08308',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106615,'Tully est','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106615,27.53,0.8,3.2,45323,75,NULL,NULL,'UGC 08308',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106616,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106616,38.36,0.46,470,45324,70,NULL,NULL,'SDSS J131322.89+591049.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,198.345417,59.18036,0,NULL,57390720425,896730006,14011406,18.3),(106617,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106617,35.83,0.58,146,45325,70,NULL,NULL,'2MASX J13132299-2302558',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,198.345875,-23.04889,0.273,NULL,43795969609,684312025,10692375,15.8),(106618,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106618,37.57,0.21,326,45326,70,NULL,NULL,'2MASX J13132371+0057301',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000087,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,198.348625,0.9585,0.043,NULL,58058972002,907171437,14174553,16.7),(106619,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106619,37,0.59,251,45327,70,NULL,NULL,'2MASX J13132485-3352293',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.6b',NULL,'Sp',NULL,NULL,NULL,NULL,1,198.3535417,-33.87489,0.181,NULL,46861514409,732211162,11440799,15.6),(106620,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106620,35.88,0.46,150,45328,70,NULL,NULL,'2MASX J13132492+0430281',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'16.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,198.3539583,4.50797,0.047,NULL,58930287544,920785742,14387277,16.9),(106621,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106621,33.74,NULL,56.1,45329,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08302',NULL,'2010Ap&SS.325..163P',2010,1,1.3,NULL,'G',0.000017,NULL,'16.0g',0.2,'Sdm:',NULL,NULL,NULL,NULL,1,198.3557917,33.29025,NULL,NULL,59157615317,924337739,14442777,16),(106622,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106622,33.76,NULL,56.6,45329,NULL,NULL,'Dipole + Quadrupole','UGC 08302',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106623,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106623,33.77,NULL,56.8,45329,NULL,NULL,'Dipole','UGC 08302',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106624,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106624,36.68,0.54,217,45330,70,NULL,NULL,'2MASX J13132554-4730365',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,198.3565417,-47.51008,0.597,NULL,46730868599,730169821,11408903,15.9),(106625,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106625,37.61,0.13,333,45331,70,NULL,NULL,'2MASX J13132573-0107340',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000063,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,198.3572917,-1.12625,0.013,NULL,43090740995,673292828,10520200,17.3),(106626,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106626,36.05,0.2,162,45332,74.4,NULL,NULL,'CGCG 072-028',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',NULL,NULL,'15.7',0.2,NULL,NULL,NULL,NULL,NULL,1,198.358291667,8.98236,0,NULL,58973893359,921467083,14397923,15.7),(106627,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106627,37.46,0.12,310,45333,70,NULL,NULL,'2MASX J13132628+3906153',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000067,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,198.359541667,39.10406,0,NULL,59307317131,926676830,14479325,17),(106628,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106628,37.55,0.46,324,45334,70,NULL,NULL,'SDSS J131326.70-004533.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000075,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,198.36125,-0.75931,0.029,NULL,43090840632,673294384,10520224,18.1),(106629,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106629,33.8,0.69,57.5,45335,100,NULL,'mid-IR','NGC 5032',NULL,'2013ApJ...771...88L',2013,1,2.1,NULL,'G',0.000027,NULL,'13.7',1.1,'SB(r)b         LINER','Possible field galaxy',NULL,NULL,NULL,1,198.3622917,27.80239,0.041,NULL,58720217511,917503398,14335990,13.7),(106630,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106630,34.57,NULL,82,45335,NULL,NULL,NULL,'NGC 5032',NULL,'1993MNRAS.263..211R',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106631,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106631,34.93,0.45,97,45335,NULL,NULL,'K','NGC 5032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106632,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106632,34.94,0.47,97.1,45335,NULL,NULL,'H','NGC 5032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106633,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106633,34.94,0.4,97.1,45335,NULL,NULL,'mean','NGC 5032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106634,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106634,34.96,0.46,98,45335,NULL,NULL,'J','NGC 5032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106635,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106635,35.33,0.11,117,45335,NULL,NULL,NULL,'NGC 5032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106636,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106636,35.46,0.2,124,45335,74.4,NULL,NULL,'NGC 5032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106637,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106637,35.52,0.43,127,45335,75,NULL,'3.6 micron, color corrected','NGC 5032',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106638,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106638,35.79,0.43,144,45335,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5032',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106639,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106639,37.66,0.46,341,45336,70,NULL,NULL,'SDSS J131327.04+240622.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'19.11',0.13,NULL,NULL,NULL,NULL,NULL,1,198.3627083,24.10611,0.066,NULL,58691427682,917053557,14328961,19.11),(106640,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106640,37.93,0.46,386,45337,70,NULL,NULL,'2MASX J13132711+2312550',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,198.363,23.21519,0,NULL,58816593817,919009278,14359519,16.9),(106641,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106641,37.99,0.46,397,45338,70,NULL,NULL,'2MASX J13132734+1448424',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,198.3639583,14.81178,0.005,NULL,59048525436,922633209,14416143,17.2),(106642,'SNII radio','2016-12-15 15:15:11','2016-12-16 11:20:23','1','SN 1985L',NULL,106642,33.14,0.46,42.5,45339,NULL,NULL,NULL,'NGC 5033',NULL,'1998ApJ...500...51W',1998,1,10.7,NULL,'G',0.000003,NULL,'10.75',5,'SA(s)c;HII     Sy1','Parent (of companion) galaxy',NULL,NULL,'Sy 1.9',1,198.364458333,36.59394,0,NULL,59292640194,926447503,14475742,10.75),(106643,'IRAS','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106643,31.12,0.8,16.7,45339,75,NULL,'A82, H','NGC 5033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106644,'Sosies','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106644,30.92,0.09,15.3,45339,NULL,NULL,NULL,'NGC 5033',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106645,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106645,29.28,0.69,7.18,45339,100,NULL,'mid-IR','NGC 5033',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106646,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106646,30.91,0.4,15.2,45339,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 5033',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106647,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106647,31.01,0.47,15.9,45339,75,NULL,'A82, H, raw','NGC 5033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106648,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106648,31.22,0.47,17.5,45339,75,NULL,'A82, H, inv','NGC 5033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106649,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106649,31.22,0.47,17.5,45339,75,NULL,'A82, H, cor','NGC 5033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106650,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106650,31.23,NULL,17.6,45339,NULL,NULL,'LEDA [April 2006]','NGC 5033',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106651,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106651,31.36,0.4,18.7,45339,75,NULL,'B','NGC 5033',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106652,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106652,31.35,0.45,18.7,45339,NULL,NULL,'Malmquist cor.','NGC 5033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106653,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106653,31.37,0.35,18.8,45339,NULL,NULL,NULL,'NGC 5033',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106654,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106654,31.4,0.43,19,45339,75,NULL,'3.6 micron, color corrected','NGC 5033',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106655,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106655,31.4,0.2,19.1,45339,74.4,NULL,NULL,'NGC 5033',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106656,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106656,31.43,0.3,19.3,45339,55,NULL,'B','NGC 5033',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106657,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106657,31.43,0.43,19.3,45339,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5033',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106658,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106658,31.46,0.43,19.6,45339,NULL,NULL,NULL,'NGC 5033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106659,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106659,38,0.46,398,45340,70,NULL,NULL,'2MASX J13132802+2618036',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,198.366833333,26.30103,0.032,NULL,58710611213,917353300,14333645,17.6),(106660,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106660,37.46,0.12,310,45341,70,NULL,NULL,'2MASX J13132839+3910588',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,198.3682083,39.18297,0,NULL,59307316117,926676814,14479325,17.4),(106661,'IRAS','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106661,33.1,0.8,41.7,45342,75,NULL,'MAT, I','NGC 5022',NULL,'1997ApJS..109..333W',1997,1,2.51,NULL,'G',0.000027,NULL,'13.98',0.34,'SBb pec sp     HII','in a pair',NULL,NULL,NULL,1,198.378291667,-19.54664,0.217,NULL,43800723876,684386310,10693536,13.98),(106662,'IRAS','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106662,33.11,0.8,41.9,45342,75,NULL,'HMCL, I','NGC 5022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106663,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106663,32.53,0.4,32.1,45342,NULL,NULL,NULL,'NGC 5022',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106664,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106664,32.57,0.32,32.6,45342,85,NULL,'I, raw','NGC 5022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106665,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106665,32.61,0.32,33.2,45342,85,NULL,'I, inv','NGC 5022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106666,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106666,32.65,0.43,33.8,45342,75,NULL,'MAT, I, raw','NGC 5022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106667,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106667,32.69,0.4,34.5,45342,75,NULL,'HMCL, I, raw','NGC 5022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106668,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106668,32.73,0.46,35.2,45342,NULL,NULL,'J','NGC 5022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106669,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106669,32.76,0.47,35.7,45342,NULL,NULL,'H','NGC 5022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106670,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106670,32.82,0.45,36.7,45342,NULL,NULL,'K','NGC 5022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106671,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106671,32.84,0.43,37,45342,75,NULL,'MAT, I, inv','NGC 5022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106672,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106672,32.84,0.4,37.1,45342,75,NULL,'HMCL, I, inv','NGC 5022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106673,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106673,32.87,0.43,37.5,45342,75,NULL,'MAT, I, cor','NGC 5022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106674,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106674,32.87,0.2,37.5,45342,74.4,NULL,NULL,'NGC 5022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106675,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106675,32.88,0.4,37.7,45342,75,NULL,'HMCL, I, cor','NGC 5022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106676,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106676,32.92,0.43,38.3,45342,75,NULL,'3.6 micron, color corrected','NGC 5022',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106677,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106677,32.95,0.49,38.9,45342,75,NULL,'IR','NGC 5022',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106678,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106678,33.01,0.43,40,45342,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5022',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106679,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106679,33.3,0.12,45.8,45342,NULL,NULL,NULL,'NGC 5022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106680,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106680,33.32,0.4,46.2,45342,NULL,NULL,'mean','NGC 5022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106681,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106681,33.66,NULL,54.1,45342,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 5022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106682,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106682,33.67,NULL,54.2,45342,NULL,NULL,'Dipole + Quadrupole','NGC 5022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106683,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106683,33.67,NULL,54.2,45342,NULL,NULL,'Dipole','NGC 5022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106684,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106684,33.73,NULL,55.8,45342,NULL,NULL,NULL,'NGC 5022',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106685,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106685,37.5,0.23,316,45343,70,NULL,NULL,'2MASX J13133101+5710415',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,198.3795,57.17817,0,NULL,57435504263,897429754,14022339,16.8),(106686,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106686,35.1,0.46,105,45344,70,NULL,NULL,'NGC 5040',NULL,'2015arXiv151105856S',2015,1,1.19,NULL,'G',0.00011,NULL,'14.3g',0.61,NULL,NULL,NULL,NULL,NULL,1,198.386,51.25836,0,NULL,59089815392,923278365,14426224,14.3),(106687,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106687,35.67,0.72,136,45345,70,NULL,NULL,'2MASX J13133275-1045443',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.13',0.4,NULL,NULL,NULL,NULL,NULL,1,198.3864583,-10.76247,0.077,NULL,43873449507,685522648,10711291,16.13),(106688,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106688,37.5,0.23,316,45346,70,NULL,NULL,'2MASX J13133337+5707165',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,198.389125,57.12136,0,NULL,57435541767,897430340,14022349,17.9),(106689,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106689,37.63,0.46,335,45347,70,NULL,NULL,'2MASX J13133375+2508175',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,198.390625,25.13806,0.056,NULL,58694714204,917104909,14329764,17),(106690,'D-Sigma','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106690,32.84,0.4,36.9,45348,75,NULL,'Edat, raw','ESO 269- G 072',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000667,NULL,'13.96',0.6,'E4:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,198.390708333,-43.52603,0.429,NULL,46960412342,733756442,11464944,13.96),(106691,'D-Sigma','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106691,33.02,0.4,40.2,45348,75,NULL,'Edat, cor','ESO 269- G 072',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106692,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106692,33.36,0.4,47.1,45348,NULL,NULL,'mean','ESO 269- G 072',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106693,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106693,33.67,0.45,54.1,45348,NULL,NULL,'K','ESO 269- G 072',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106694,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106694,37.82,0.46,366,45349,70,NULL,NULL,'SDSS J131333.98+594220.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000159,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,198.391625,59.70561,0,NULL,57391517244,896742456,14011600,18.3),(106695,'Tully est','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106695,32.81,0.8,36.4,45350,75,NULL,NULL,'UGCA 338',NULL,'1988NBGC.C....0000T',1988,1,2,NULL,'G',0.000017,NULL,'14.02',1.9,'SAB(s)dm','X-ray-bright group member',NULL,NULL,NULL,1,198.393083,-15.432,0.061,NULL,44007941324,687624083,10744126,14.02),(106696,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106696,37.98,0.46,394,45351,70,NULL,NULL,'SDSS J131334.32+095413.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,198.393,9.90381,0,NULL,58975703021,921495359,14398364,18.5),(106697,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106697,34.78,0.47,90.4,45352,NULL,NULL,'H','UGC 08306',NULL,'2007A&A...465...71T',2007,1,1.6,'HOLM 512B is a star.','G',0.000033,NULL,'14.96',0.3,'Sb','Isolated galaxy',NULL,NULL,NULL,1,198.393416667,15.99206,0.019,NULL,59041560632,922524384,14414443,14.96),(106698,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106698,34.89,0.45,94.9,45352,NULL,NULL,'K','UGC 08306',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106699,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106699,34.92,0.29,96.5,45352,NULL,NULL,'Malmquist cor.','UGC 08306',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106700,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106700,34.94,0.29,97.4,45352,NULL,NULL,NULL,'UGC 08306',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106701,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106701,34.97,0.46,98.6,45352,NULL,NULL,'J','UGC 08306',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106702,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106702,35.01,0.2,100,45352,74.4,NULL,NULL,'UGC 08306',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106703,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106703,35.06,0.4,103,45352,NULL,NULL,'mean','UGC 08306',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106704,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106704,37.87,0.46,374,45353,70,NULL,NULL,'2MASX J13133526+6209346',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,198.3967083,62.15958,0.021,NULL,57358297976,896223405,14003490,17.8),(106705,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106705,37.36,0.74,297,45354,70,NULL,NULL,'2MASX J13133570-4356305',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,198.398833,-43.94183,0.429,NULL,46959495104,733742111,11464720,15.7),(106706,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106706,35.88,0.67,150,45355,70,NULL,NULL,'2MASX J13133606-2648440',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,198.400375,-26.81225,0.277,NULL,43345476006,677273062,10582391,15.1),(106707,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106707,37.82,0.46,367,45356,70,NULL,NULL,'SDSS J131336.73+441026.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000163,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,198.403041667,44.17392,0,NULL,59279031492,926234867,14472419,18.8),(106708,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106708,37.86,0.16,373,45357,70,NULL,NULL,'SDSS J131337.18+065048.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,198.404958333,6.84681,0.067,NULL,58980247575,921566368,14399474,17.9),(106709,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106709,36.54,0.65,203,45358,70,NULL,NULL,'2MFGC 10544',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'12.1K',NULL,NULL,NULL,NULL,NULL,NULL,1,198.405667,-45.93039,0.441,NULL,46954728751,733667636,11463556,12.1),(106710,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106710,37.46,0.12,310,45359,70,NULL,NULL,'2MASX J13133747+3852148',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000182,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,198.40625,38.87092,0,NULL,59307280420,926676256,14479316,18.1),(106711,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106711,37.46,0.12,310,45360,70,NULL,NULL,'SDSS J131339.27+385509.0',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000154,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,198.413667,38.91917,0,NULL,59307292177,926676440,14479319,18.6),(106712,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106712,38.34,0.46,466,45361,70,NULL,NULL,'SDSS J131339.69+332305.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000121,NULL,'19.75',0.12,NULL,NULL,NULL,NULL,NULL,1,198.415375,33.38486,NULL,NULL,59171279549,924551242,14446113,19.75),(106713,'TRGB','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106713,29.6,0.1,8.3,45362,74.4,NULL,NULL,'LEDA 166159',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',NULL,NULL,'18.2',0.7,'dwarf Sph?',NULL,NULL,NULL,NULL,1,198.4155,42.04411,0,NULL,59302711035,926604859,14478200,18.2),(106714,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106714,37.57,0.53,327,45363,70,NULL,NULL,'2MASX J13133973-3250374',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.6b',NULL,'E',NULL,NULL,NULL,NULL,1,198.415625,-32.84369,0.193,NULL,46872448225,732382003,11443468,16.6),(106715,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106715,35.76,0.27,142,45364,70,NULL,NULL,'CGCG 072-030',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00009,NULL,'15.5g',0.36,'S0',NULL,NULL,NULL,NULL,1,198.417583,12.68925,0.01,NULL,59014476173,922101190,14407831,15.5),(106716,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106716,37.14,0.46,268,45365,70,NULL,NULL,'2MASX J13134095+1321084',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000107,NULL,'15.6g',0.41,'E0',NULL,NULL,NULL,NULL,1,198.420667,13.35247,0,NULL,59017279176,922144987,14408515,15.6),(106717,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106717,38.35,0.46,467,45366,70,NULL,NULL,'2MASX J13134113+6134150',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00016,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,198.4212083,61.57092,0.009,NULL,57384471286,896632363,14009880,17.4),(106718,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106718,37.48,0.46,313,45367,70,NULL,NULL,'LCRS B131106.5-023549',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,198.421833,-2.86183,0.029,NULL,43096735823,673386497,10521664,16.9),(106719,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106719,33.93,0.49,61,45368,75,NULL,'IR','LSBC F576-01',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.000067,NULL,'15.95',0.17,'Sc:',NULL,NULL,NULL,NULL,1,198.422,22.62569,0.025,NULL,58815777027,918996516,14359320,15.95),(106720,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106720,37.46,0.12,310,45369,70,NULL,NULL,'2MASX J13134157+3856299',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000182,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,198.42325,38.94158,0,NULL,59307290943,926676420,14479319,17.4),(106721,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106721,37.5,0.23,316,45370,70,NULL,NULL,'2MASX J13134170+5716095',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,198.423708333,57.26939,0,NULL,57435361158,897427518,14022304,17.2),(106722,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106722,36.72,0.46,220,45371,70,NULL,NULL,'2MASX J13134252+0650511',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00014,NULL,'17.75',0.16,NULL,NULL,NULL,NULL,NULL,1,198.42725,6.84739,0.067,NULL,58980248155,921566377,14399474,17.75),(106723,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106723,38.08,0.17,414,45372,70,NULL,NULL,'2MASX J13134260+0817430',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.92',0.18,NULL,NULL,NULL,NULL,NULL,1,198.427583,8.29542,0,NULL,58987555534,921680555,14401258,17.92),(106724,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106724,37.86,0.16,373,45373,70,NULL,NULL,'SDSS J131343.02+064859.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,198.4292917,6.81644,0.067,NULL,58980247854,921566372,14399474,18),(106725,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106725,37.46,0.12,310,45374,70,NULL,NULL,'2MASX J13134517+3848239',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000185,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,198.438167,38.80678,0,NULL,59306577627,926665275,14479144,16.7),(106726,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106726,34.61,0.54,83.7,45375,70,NULL,NULL,'2MASX J13134531-0504480',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.000077,NULL,'15.74',0.41,NULL,NULL,NULL,NULL,NULL,1,198.438667,-5.08022,0.077,NULL,43827074023,684798031,10699969,15.74),(106727,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106727,34.44,0.46,77.4,45376,70,NULL,NULL,'NGC 5028',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.000067,NULL,'13.15',0.9,'E6',NULL,NULL,NULL,NULL,1,198.441083,-13.04247,0.057,NULL,43994366481,687411976,10740812,13.15),(106728,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106728,36.17,0.52,171,45377,70,NULL,NULL,'2MASX J13134620-3154544',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'16.2',NULL,'*+E',NULL,NULL,NULL,NULL,1,198.442583,-31.91511,0.265,NULL,43325260466,676957194,10577456,16.2),(106729,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106729,36.72,0.71,221,45378,70,NULL,NULL,'2MASX J13134634-2334504',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.0I',0.2,NULL,NULL,NULL,NULL,NULL,1,198.443083,-23.58072,0.237,NULL,43796396347,684318692,10692479,15),(106730,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106730,35.45,0.66,123,45379,70,NULL,NULL,'2MASX J13134642-0839024',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00008,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,198.443416667,-8.65069,0.077,NULL,43886979983,685734062,10714594,15.8),(106731,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106731,37.46,0.12,310,45380,70,NULL,NULL,'2MASX J13134646+3854419',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,198.44375,38.91156,0,NULL,59307293824,926676466,14479319,17.7),(106732,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106732,37.5,0.23,316,45381,70,NULL,NULL,'2MASX J13134651+5704515',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,198.443833333,57.08094,0,NULL,57435526014,897430093,14022345,18),(106733,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106733,36.86,0.46,236,45382,70,NULL,NULL,'2MASX J13134726+2247084',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000083,NULL,'16.78',0.24,NULL,NULL,NULL,NULL,NULL,1,198.447,22.78569,0.021,NULL,58815762571,918996290,14359317,16.78),(106734,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106734,36.65,0.46,214,45383,70,NULL,NULL,'SDSS J131347.40+483004.0',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,198.4475417,48.50117,0,NULL,59091687011,923307609,14426681,17),(106735,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106735,38.3,0.46,458,45384,70,NULL,NULL,'2MASX J13134775+5243488',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,198.448667,52.73033,0.014,NULL,57412178683,897065291,14016645,17.4),(106736,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106736,37.61,0.13,333,45385,70,NULL,NULL,'2MASX J13134914-0106170',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000066,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,198.4547917,-1.10475,0.013,NULL,43090751457,673292991,10520202,18.2),(106737,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106737,35.78,0.46,144,45386,70,NULL,NULL,'CGCG 044-034 NED01',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,198.454875,2.53733,0.029,NULL,58065176245,907268378,14176068,16.5),(106738,'SNIa','2016-12-15 15:15:11','2016-12-16 11:20:23','1','SN 2002cx',NULL,106738,36.15,0.26,166,45387,72,NULL,NULL,'CGCG 044-035',0.02396,'2006ApJ...645..488W',2006,1,0.57,NULL,'G',0.000087,NULL,'15.4',0.19,NULL,'Group member',NULL,NULL,NULL,1,198.4552083,6.96261,0.067,NULL,58980208107,921565751,14399464,15.4),(106739,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106739,37.46,0.12,310,45388,70,NULL,NULL,'MCG +07-27-047',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000206,NULL,'15.6g',0.6,NULL,NULL,NULL,NULL,NULL,1,198.456917,38.89433,0,NULL,59307291925,926676436,14479319,15.6),(106740,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106740,37.86,0.16,373,45389,70,NULL,NULL,'SDSS J131351.29+065616.9',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,198.46375,6.93808,0.067,NULL,58980241108,921566267,14399472,17.3),(106741,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106741,36.77,0.46,226,45390,70,NULL,NULL,'2MASX J13135182+0417509',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000191,NULL,'16.1g',0.39,'E0',NULL,NULL,NULL,NULL,1,198.4660417,4.29731,0.047,NULL,58056773405,907137084,14174016,16.1),(106742,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106742,36.04,0.61,161,45391,70,NULL,NULL,'2MASX J13135196-1309264',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,198.4664583,-13.15744,0.057,NULL,43994342128,687411595,10740806,16.8),(106743,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106743,38.38,0.33,475,45392,70,NULL,NULL,'2MASX J13135256+6201072',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000188,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,198.469,62.01867,0.021,NULL,57354066748,896157292,14002457,17.2),(106744,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106744,35.99,0.27,158,45393,70,NULL,NULL,'2MASX J13135300+3407295',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000083,NULL,'15.4g',0.52,NULL,NULL,NULL,NULL,NULL,1,198.4709583,34.12481,0.012,NULL,59158003524,924343805,14442871,15.4),(106745,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106745,38.08,0.46,414,45394,70,NULL,NULL,'SDSS J131353.27+602542.7',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,198.472,60.42853,0,NULL,57385433619,896647400,14010115,17.7),(106746,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106746,37.86,0.16,373,45395,70,NULL,NULL,'SDSS J131353.42+070311.9',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,198.472583333,7.05331,0.067,NULL,58979351579,921552368,14399255,NULL),(106747,'Tully-Fisher','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,NULL,106747,29.83,0.4,9.2,45396,75,NULL,'B','UGC 08313',NULL,'1988NBGC.C....0000T',1988,1,1.91,NULL,'G',0.000012,NULL,'14.4g',0.55,'SB(s)c? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,198.4744583,42.20861,0,NULL,59299629932,926556717,14477448,14.4),(106748,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106748,35.7,0.46,138,45397,70,NULL,NULL,'2MASX J13135427+5219422',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000175,NULL,'16.0g',0.4,NULL,NULL,NULL,NULL,NULL,1,198.476375,52.32833,0,NULL,57193962721,893655667,13963369,16),(106749,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106749,36.4,0.46,190,45398,70,NULL,NULL,'SDSS J131354.44+474804.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000155,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,198.476833333,47.80128,0,NULL,59098794790,923418668,14428416,17.9),(106750,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106750,36.93,0.46,243,45399,70,NULL,NULL,'2MASX J13135483+0356289',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000202,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,198.4785417,3.9415,0.048,NULL,58055819337,907122177,14173784,17.6),(106751,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106751,37.46,0.12,310,45400,70,NULL,NULL,'SDSS J131354.91+385244.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000159,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,198.478833333,38.87908,0,NULL,59307281443,926676272,14479316,18.5),(106752,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106752,38.41,0.46,481,45401,70,NULL,NULL,'2MASX J13135520+5512265',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,198.4800417,55.20725,0.013,NULL,57427884680,897310698,14020479,18),(106753,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106753,38.81,0.46,579,45402,70,NULL,NULL,'SDSS J131355.82+104934.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,198.482625,10.82625,0,NULL,58972960960,921452515,14397695,17.9),(106754,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106754,36.85,0.46,235,45403,70,NULL,NULL,'2MASX J13135631+0550369',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,'FoF','17.73',0.17,NULL,NULL,NULL,NULL,NULL,1,198.484583,5.84347,0,NULL,58976410950,921506421,14398537,17.73),(106755,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106755,38.16,0.27,429,45404,70,NULL,NULL,'2MASX J13135655+0909471',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,198.485583,9.16311,0,NULL,58973392235,921459253,14397800,17.6),(106756,'FP','2016-12-15 15:15:11','2016-12-16 11:20:23','1',NULL,'R',106756,35.76,0.27,142,45405,70,NULL,NULL,'CGCG 072-031',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000168,NULL,'15.7g',0.44,'E0',NULL,NULL,NULL,NULL,1,198.488625,12.59258,0.008,NULL,59014757324,922105583,14407899,15.7),(106757,'FP','2016-12-15 15:15:12','2016-12-16 11:20:23','1',NULL,NULL,106757,35.84,0.51,147,45406,70,NULL,NULL,'2MASX J13135746-3355063',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000014,NULL,'14.21',NULL,'*+E',NULL,NULL,NULL,NULL,1,198.489333333,-33.91836,0.181,NULL,46861489837,732210778,11440793,14.21),(106758,'FP','2016-12-15 15:15:12','2016-12-16 11:20:23','1',NULL,'R',106758,37.86,0.16,373,45407,70,NULL,NULL,'2MASX J13135770+0659391',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,198.490375,6.99422,0.067,NULL,58979336967,921552140,14399252,17.2),(106759,'FP','2016-12-15 15:15:12','2016-12-16 11:20:23','1',NULL,'R',106759,37.2,0.33,275,45408,70,NULL,NULL,'2MASX J13135775+4318588',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000181,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,198.490541667,43.31622,0,NULL,59308425379,926694146,14479596,16.4),(106760,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:23','1',NULL,NULL,106760,33.98,0.43,62.5,45409,NULL,NULL,'Malmquist cor.','ESO 323- G 097',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'14.80',0.4,'S',NULL,NULL,NULL,NULL,1,198.4910417,-39.25964,0.281,NULL,46942034145,733469283,11460457,14.8),(106761,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106761,34.26,0.37,71.3,45409,NULL,NULL,NULL,'ESO 323- G 097',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106762,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106762,34.31,0.2,72.8,45409,74.4,NULL,NULL,'ESO 323- G 097',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106763,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106763,32.74,0.47,35.2,45410,NULL,NULL,'H','ESO 219- G 041',NULL,'2007A&A...465...71T',2007,1,2.8,'A-M +30\' Dec error.','G',0.00002,NULL,'12.9',0.9,'(R\'_1)SB(s)ab',NULL,NULL,NULL,NULL,1,198.4917917,-49.47819,0.909,NULL,46726323465,730098804,11407793,12.9),(106764,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106764,32.75,0.45,35.4,45410,NULL,NULL,'K','ESO 219- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106765,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106765,32.77,0.46,35.8,45410,NULL,NULL,'J','ESO 219- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106766,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106766,32.96,0.49,39.1,45410,75,NULL,'IR','ESO 219- G 041',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106767,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106767,33.4,0.4,47.9,45410,NULL,NULL,'mean','ESO 219- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106768,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106768,37.19,0.33,274,45411,70,NULL,NULL,'2MASX J13135837+5328092',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000202,NULL,'15.7g',0.46,'E0',NULL,NULL,NULL,NULL,1,198.493125,53.46928,0.031,NULL,57415750857,897121107,14017517,15.7),(106769,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106769,37.2,0.46,275,45412,70,NULL,NULL,'2MASX J13140017+6042473',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,198.5004583,60.713,0,NULL,57385135784,896642746,14010042,17.8),(106770,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106770,37.46,0.12,310,45413,70,NULL,NULL,'2MASX J13140041+3849098',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000184,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,198.5014583,38.81931,0,NULL,59307279261,926676238,14479316,16.7),(106771,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106771,37.62,0.46,334,45414,70,NULL,NULL,'2MASX J13140114+4522108',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000148,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,198.504667,45.36958,0,NULL,59281611292,926275176,14473049,17.7),(106772,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106772,38.08,0.17,414,45415,70,NULL,NULL,'2MASX J13140120+0822261',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.10',0.19,NULL,NULL,NULL,NULL,NULL,1,198.5052083,8.37389,0,NULL,58987589801,921681090,14401267,18.1),(106773,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106773,35.99,0.27,158,45416,70,NULL,NULL,'2MASX J13140135+3356128',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.0001,NULL,'15.3g',0.45,NULL,NULL,NULL,NULL,NULL,1,198.5055,33.93681,0.013,NULL,59157932697,924342698,14442854,15.3),(106774,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106774,38.16,0.27,429,45417,70,NULL,NULL,'2MASX J13140231+0909550',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,198.509667,9.16522,0,NULL,58973423148,921459736,14397808,17.4),(106775,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106775,36.2,0.68,174,45418,70,NULL,NULL,'2MASX J13140318-3353248',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,198.51325,-33.89017,0.181,NULL,46861488636,732210759,11440793,14.6),(106776,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106776,35.57,0.51,130,45419,70,NULL,NULL,'AM 1311-373',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,'(R_1)SAB(r)0^+',NULL,NULL,NULL,NULL,1,198.515,-37.79692,0.213,NULL,46939939654,733436557,11459946,14.4),(106777,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106777,37.19,0.33,274,45420,70,NULL,NULL,'2MASX J13140364+5326452',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000173,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,198.5152917,53.44581,0.031,NULL,57415758268,897121222,14017519,17.3),(106778,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106778,38.31,0.46,459,45421,70,NULL,NULL,'2MASX J13140397+1334005',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000183,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,198.516667,13.56669,0,NULL,59016266567,922129165,14408268,17.2),(106779,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106779,37.86,0.16,373,45422,70,NULL,NULL,'2MASX J13140400+0652530',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.76',0.18,NULL,NULL,NULL,NULL,NULL,1,198.516833,6.88144,0.039,NULL,58980124420,921564444,14399444,17.76),(106780,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106780,37.11,0.46,265,45423,70,NULL,NULL,'2MASX J13140560+1743095',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.44',0.21,NULL,NULL,NULL,NULL,NULL,1,198.5234583,17.71933,0.006,NULL,59039106387,922486037,14413844,17.44),(106781,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106781,37.22,0.46,278,45424,70,NULL,NULL,'2MASX J13140591+1217245',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,198.524708333,12.29003,0.011,NULL,59014727179,922105112,14407892,17.1),(106782,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106782,37.9,0.46,380,45425,70,NULL,NULL,'2MASX J13140608+3040378',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00014,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,198.5255,30.67717,0.028,NULL,58681586118,916899783,14326559,17.5),(106783,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106783,37.55,0.46,324,45426,70,NULL,NULL,'2MASX J13140675+0033574',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00007,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,198.528125,0.56594,0.006,NULL,58059451526,907178930,14174670,17.8),(106784,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106784,36.31,0.53,182,45427,70,NULL,NULL,'2MASX J13140679-3353078',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000019,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,198.528333,-33.8855,0.181,NULL,46861489114,732210767,11440793,14.9),(106785,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106785,37.77,0.46,358,45428,70,NULL,NULL,'2MASX J13140715+1409275',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,198.53,14.15761,0,NULL,59016881402,922138771,14408418,18.1),(106786,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106786,37.34,0.46,294,45429,70,NULL,NULL,'2MASX J13140763+4242099',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000151,NULL,'17.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,198.5319583,42.70269,0,NULL,59307871679,926685494,14479460,17.2),(106787,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106787,37.86,0.16,373,45430,70,NULL,NULL,'2MASX J13140830+0654220',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.83',0.16,NULL,NULL,NULL,NULL,NULL,1,198.534583333,6.90603,0.039,NULL,58980126062,921564469,14399444,17.83),(106788,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106788,34.17,0.49,68.3,45431,75,NULL,'IR','MCG -01-34-013',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000033,NULL,'14.86',0.3,'Sc: sp',NULL,NULL,NULL,NULL,1,198.540541667,-5.59853,0.073,NULL,43826565660,684790088,10699845,14.86),(106789,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106789,34.21,0.2,69.5,45431,74.4,NULL,NULL,'MCG -01-34-013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106790,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106790,34.25,0.47,70.8,45431,NULL,NULL,NULL,'MCG -01-34-013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106791,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106791,34.3,0.46,72.4,45431,NULL,NULL,'Malmquist cor.','MCG -01-34-013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106792,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106792,38.68,0.46,544,45432,70,NULL,NULL,'SDSS J131410.11+040020.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000166,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,198.542125,4.00561,0.048,NULL,58055752376,907121130,14173767,18.5),(106793,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106793,36.87,0.77,236,45433,70,NULL,NULL,'2MASX J13141030-4424424',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,198.542875,-44.41178,0.469,NULL,46951930868,733623919,11462873,15.3),(106794,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106794,37.83,0.46,367,45434,70,NULL,NULL,'2MASX J13141151+3202388',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'17.3g',0.19,'E2',NULL,NULL,NULL,NULL,1,198.5479583,32.04406,0,NULL,58679545108,916867892,14326060,17.3),(106795,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106795,32.72,0.48,35,45435,70,NULL,NULL,'NGC 5026',NULL,'2014MNRAS.445.2677S',2014,1,3.2,NULL,'G',0.00011,NULL,'12.48',2,'(RL)SB(r)0^+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,198.556833333,-42.96128,0.441,NULL,46960068690,733751073,11464860,12.48),(106796,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106796,35.96,0.69,155,45436,70,NULL,NULL,'2MASX J13141463-1841558',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.05',NULL,NULL,NULL,NULL,NULL,NULL,1,198.560833,-18.69883,0.233,NULL,43797046704,684328854,10692638,16.05),(106797,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106797,35.72,0.58,139,45437,70,NULL,NULL,'ESO 508- G 028',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000143,NULL,'15.62',0.2,'(R\')S0/a? pec sp',NULL,NULL,NULL,NULL,1,198.562041667,-23.39047,0.269,NULL,43796219374,684315927,10692436,15.62),(106798,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106798,35.06,0.46,103,45438,70,NULL,NULL,'2MASX J13141599+1203490',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000159,NULL,'15.6g',0.31,'S0',NULL,NULL,NULL,NULL,1,198.566667,12.06347,0,NULL,59013945255,922092894,14407701,15.6),(106799,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106799,37.43,0.46,307,45439,70,NULL,NULL,'2MASX J13141696+0018525',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000213,NULL,'17.13',0.28,NULL,NULL,NULL,NULL,NULL,1,198.570667,0.31461,0.037,NULL,58059341088,907177204,14174643,17.13),(106800,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106800,38.39,0.33,477,45440,70,NULL,NULL,'2MASX J13141779+1540064',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000139,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,198.574167,15.66817,0.023,NULL,59041200889,922518763,14414355,17.9),(106801,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106801,37.36,0.46,297,45441,70,NULL,NULL,'2MASX J13141827+2842019',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000175,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,198.576083333,28.70058,0.036,NULL,58717864968,917466640,14335416,16.8),(106802,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106802,36.39,0.46,190,45442,70,NULL,NULL,'2MASX J13141850+6652137',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00009,NULL,'16.0g',0.38,'E0',NULL,NULL,NULL,NULL,1,198.5772917,66.87061,0.033,NULL,57910265315,904847895,14138248,16),(106803,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106803,37.43,0.46,307,45443,70,NULL,NULL,'2MASX J13141873+6451283',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00007,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,198.5777917,64.85781,0.029,NULL,57351339962,896114686,14001791,17.7),(106804,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106804,35.77,0.46,142,45444,70,NULL,NULL,'MCG +10-19-054',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000167,NULL,'15.7g',0.44,'S0^-',NULL,NULL,NULL,NULL,1,198.581833,57.17375,0,NULL,57435044143,897422564,14022227,15.7),(106805,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106805,37.69,0.46,345,45445,70,NULL,NULL,'2MASX J13141965+3324268',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,198.582083,33.40756,NULL,NULL,59171286283,924551348,14446114,17.7),(106806,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106806,35.61,0.2,132,45446,74.4,NULL,NULL,'CGCG 072-032',NULL,'2013AJ....146...86T',2013,1,0.51,NULL,'G',0.000385,NULL,'15.7',0.23,NULL,NULL,NULL,NULL,NULL,1,198.582375,13.50728,0,NULL,59016240076,922128751,14408261,15.7),(106807,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106807,35.49,0.42,125,45447,NULL,NULL,NULL,'ESO 382- G 021',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.77',0.3,'Sb:',NULL,NULL,NULL,NULL,1,198.584,-37.19608,0.201,NULL,46928111311,733251739,11457058,15.77),(106808,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106808,35.53,0.2,128,45447,74.4,NULL,NULL,'ESO 382- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106809,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106809,35.57,0.4,130,45447,NULL,NULL,'Malmquist cor.','ESO 382- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106810,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106810,35.76,0.27,142,45448,70,NULL,NULL,'2MASX J13142059+1233094',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000178,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,198.585541667,12.55264,0.008,NULL,59014874904,922107420,14407928,16.1),(106811,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106811,38.02,0.33,402,45449,70,NULL,NULL,'2MASX J13142253+5655326',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000172,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,198.593875,56.92578,0.009,NULL,57435176165,897424627,14022259,17),(106812,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106812,37.56,0.46,326,45450,70,NULL,NULL,'SDSS J131423.01+100520.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000142,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,198.595917,10.08906,0,NULL,58975872843,921498013,14398406,18.4),(106813,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106813,37.46,0.12,310,45451,70,NULL,NULL,'2MASX J13142311+3845027',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000184,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,198.5964583,38.75078,0,NULL,59307363467,926677554,14479336,17.6),(106814,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106814,37.2,0.46,275,45452,70,NULL,NULL,'2MASX J13142326+1610434',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,198.5969583,16.17883,0.015,NULL,59041610719,922525167,14414455,NULL),(106815,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106815,37.7,0.46,347,45453,70,NULL,NULL,'2MASX J13142343+4410410',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000134,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,198.5975417,44.17811,0,NULL,59278504269,926226629,14472291,17.9),(106816,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106816,34.37,0.43,74.7,45454,75,NULL,'3.6 micron, color corrected','UGC 08317',NULL,'2014MNRAS.444..527S',2014,1,1.24,NULL,'G',0.000009,NULL,'14.7g',0.46,'Sb',NULL,NULL,NULL,NULL,1,198.598375,30.48397,0.026,NULL,58681524470,916898819,14326544,14.7),(106817,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106817,34.37,0.2,74.8,45454,74.4,NULL,NULL,'UGC 08317',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106818,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106818,34.43,0.43,76.8,45454,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08317',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106819,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106819,34.76,0.13,89.7,45454,NULL,NULL,NULL,'UGC 08317',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106820,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106820,36.86,0.46,235,45455,70,NULL,NULL,'2MASX J13142378+0221045',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000155,NULL,'17.0g',0.31,NULL,NULL,NULL,NULL,NULL,1,198.5992083,2.35133,0.029,NULL,58065408461,907272007,14176125,17),(106821,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106821,38.02,0.33,402,45456,70,NULL,NULL,'2MASXi J1314250+565625',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000172,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,198.6047917,56.94039,0.009,NULL,57435174267,897424597,14022259,17.7),(106822,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106822,38.29,0.46,455,45457,70,NULL,NULL,'2MASX J13142541+3644457',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00014,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,198.605833,36.74597,0,NULL,59291933576,926436462,14475569,18.3),(106823,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106823,38.08,0.17,414,45458,70,NULL,NULL,'SDSS J131425.74+083147.8',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.7g',0.28,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,198.60725,8.52994,0,NULL,58987495192,921679612,14401243,16.7),(106824,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106824,37.53,0.46,321,45459,70,NULL,NULL,'2MASX J13142648+0054325',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000091,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,198.610417,0.90892,0.032,NULL,58059123613,907173806,14174590,16.9),(106825,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106825,37.46,0.12,310,45460,70,NULL,NULL,'2MASX J13142740+3856187',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000179,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,198.6142083,38.93856,0,NULL,59307404293,926678192,14479346,16.7),(106826,'Brightest Stars','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106826,27,NULL,2.51,45461,NULL,NULL,NULL,'UGC 08320',NULL,'1998AJ....116.2886S',1998,1,3.6,'The UZC position is for the approximate center of the outer isophotes.','G',0.000003,NULL,'12.7',1.4,'IBm','in a radial-velocity based grouping',NULL,NULL,NULL,1,198.6164583,45.91914,0,1,59281655231,926275862,14473060,12.7),(106827,'Brightest Stars','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106827,28.01,NULL,4,45461,NULL,NULL,NULL,'UGC 08320',NULL,'1998A&AS..128..325T',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106828,'Brightest Stars','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106828,28.34,NULL,4.66,45461,NULL,NULL,'Blue','UGC 08320',NULL,'1997AstL...23..644G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106829,'Brightest Stars','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106829,28.63,0.4,5.32,45461,NULL,NULL,'3B + 3R mean','UGC 08320',NULL,'1997AstL...23..656G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106830,'Brightest Stars','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106830,28.63,NULL,5.32,45461,NULL,NULL,'LF','UGC 08320',NULL,'1997AstL...23..656G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106831,'Brightest Stars','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106831,28.63,NULL,5.32,45461,NULL,NULL,'Red + Blue','UGC 08320',NULL,'1997AstL...23..644G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106832,'Brightest Stars','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106832,28.72,NULL,5.55,45461,NULL,NULL,'Red','UGC 08320',NULL,'1997AstL...23..644G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106833,'TRGB','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106833,28.11,0.1,4.19,45461,NULL,NULL,NULL,'UGC 08320',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106834,'TRGB','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106834,28.12,0.09,4.2,45461,NULL,NULL,NULL,'UGC 08320',NULL,'2013AstBu..68..125M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106835,'TRGB','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106835,28.13,0.12,4.22,45461,NULL,NULL,NULL,'UGC 08320',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106836,'TRGB','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106836,28.14,0.1,4.25,45461,74.4,NULL,NULL,'UGC 08320',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106837,'TRGB','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106837,28.18,0.26,4.33,45461,NULL,NULL,NULL,'UGC 08320',NULL,'2003A&A...398..467K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106838,'TRGB','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106838,28.32,0.07,4.61,45461,NULL,NULL,'I','UGC 08320',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106839,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106839,27.78,0.4,3.6,45461,75,NULL,'B','UGC 08320',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106840,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106840,38.22,0.46,441,45462,70,NULL,NULL,'SDSS J131428.33+072934.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00032,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,198.6180417,7.49297,0,NULL,58978771573,921543305,14399114,17.9),(106841,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106841,37.27,0.46,284,45463,70,NULL,NULL,'2MASX J13142854+1701004',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.20',0.22,NULL,NULL,NULL,NULL,NULL,1,198.618833,17.01667,0,NULL,59039801230,922496894,14414013,17.2),(106842,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106842,37.35,0.46,295,45464,70,NULL,NULL,'2MASX J13143021+1725044',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,198.626,17.41803,0,NULL,59039938416,922499037,14414047,17.3),(106843,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106843,32.61,0.2,33.3,45465,74.4,NULL,NULL,'UGC 08318',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000137,NULL,'15.0',0.9,'SB(s)cd?',NULL,NULL,NULL,NULL,1,198.6274583,35.38683,0,NULL,59159283884,924363810,14443184,15),(106844,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106844,32.96,0.4,39.1,45465,NULL,NULL,NULL,'UGC 08318',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106845,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106845,33.09,0.64,41.5,45465,NULL,NULL,NULL,'UGC 08318',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106846,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106846,33.32,0.58,46.1,45465,NULL,NULL,'Malmquist cor.','UGC 08318',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106847,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106847,38.16,0.27,429,45466,70,NULL,NULL,'SDSS J131431.62+090852.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,198.63175,9.14786,0,NULL,58973431970,921459874,14397810,18.5),(106848,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106848,36.92,0.46,242,45467,70,NULL,NULL,'2MASX J13143195+1959355',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,198.633208333,19.99322,0.064,NULL,58812125107,918939454,14358428,16.9),(106849,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106849,37.61,0.46,332,45468,70,NULL,NULL,'2MASX J13143416+3046205',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000141,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,198.642083,30.77253,0.02,NULL,58681543484,916899116,14326548,17.5),(106850,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106850,36.9,0.46,240,45469,70,NULL,NULL,'2MASX J13143452+4215270',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000163,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,198.643625,42.25758,0,NULL,59299649977,926557030,14477453,16.7),(106851,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106851,35.81,0.46,145,45470,70,NULL,NULL,'2MASX J13143500+5021062',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000158,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,198.645833,50.35178,0,NULL,59092863489,923325992,14426968,16.7),(106852,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106852,37,0.46,251,45471,70,NULL,NULL,'2MASX J13143653+1502274',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000172,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,198.6522917,15.04081,0,NULL,59010773018,922043328,14406927,16.6),(106853,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106853,36.93,0.46,243,45472,70,NULL,NULL,'2MASX J13143691+0837478',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00019,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,198.653667,8.63003,0,NULL,58987211458,921675179,14401174,16.4),(106854,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106854,37.72,0.46,349,45473,70,NULL,NULL,'SDSS J131437.26+011659.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,198.655291667,1.28308,0.028,NULL,58063372614,907240197,14175628,18.3),(106855,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106855,38.06,0.46,410,45474,70,NULL,NULL,'2MASX J13143748+3644056',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,198.6562083,36.73494,0,NULL,59291934503,926436476,14475569,17.8),(106856,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106856,37.52,0.46,320,45475,70,NULL,NULL,'2MASX J13143745+6754308',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000098,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,198.656417,67.90864,0.029,NULL,57909810160,904840783,14138137,17.2),(106857,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106857,36.8,0.46,229,45476,70,NULL,NULL,'2MASX J13143915+3155135',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000174,NULL,'17.2',0.28,'E0',NULL,NULL,NULL,NULL,1,198.663208333,31.92039,0,NULL,58679546180,916867909,14326061,17.2),(106858,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106858,38.39,0.33,477,45477,70,NULL,NULL,'SDSS J131439.17+154309.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000164,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,198.66325,15.71939,0.022,NULL,59011301488,922051585,14407056,18.7),(106859,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106859,37.38,0.46,300,45478,70,NULL,NULL,'SDSS J131439.29+194341.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'17.2E',NULL,NULL,NULL,NULL,NULL,NULL,1,198.6637083,19.72808,0.064,NULL,58812228447,918941069,14358454,17.2),(106860,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106860,37.37,0.46,298,45479,70,NULL,NULL,'2MASX J13144159-0157434',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000086,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,198.6732917,-1.96203,0.029,NULL,43100449775,673444527,10522570,16.5),(106861,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106861,37.38,0.46,300,45480,70,NULL,NULL,'2MASX J13144168+2032246',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,198.67375,20.54011,0.062,NULL,58810216271,918909629,14357962,17.7),(106862,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106862,36.93,0.84,244,45481,70,NULL,NULL,'2MASX J13144257-3642182',NULL,'2014MNRAS.445.2677S',2014,1,0.6,'6dF DR1 has z = 0.051156.','G',0.00015,NULL,'16.4b',NULL,'Sp',NULL,NULL,NULL,NULL,1,198.677375,-36.70503,0.177,NULL,46928175964,733252749,11457074,16.4),(106863,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106863,36.37,0.46,188,45482,70,NULL,NULL,'MRK 0658',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000073,NULL,'16.0',0.2,'Compact',NULL,NULL,NULL,NULL,1,198.6817917,24.00036,0.019,NULL,58813019560,918953430,14358647,16),(106864,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106864,36.57,0.64,206,45483,70,NULL,NULL,'2MASX J13144409-0821126',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,198.68375,-8.3535,0.077,NULL,43887058001,685735281,10714613,16.8),(106865,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106865,38.15,0.46,426,45484,70,NULL,NULL,'2MASX J13144579+6611188',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000076,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,198.690375,66.18844,0.013,NULL,57873688712,904276386,14129318,17.7),(106866,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106866,35.18,0.46,109,45485,70,NULL,NULL,'2MASX J13144569+3508545',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000093,NULL,'15.3g',0.44,NULL,NULL,NULL,NULL,NULL,1,198.690583,35.14847,0,NULL,59159332690,924364573,14443196,15.3),(106867,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106867,34.16,0.46,68,45486,70,NULL,NULL,'CGCG 271-026',NULL,'2015arXiv151105856S',2015,1,1.04,NULL,'G',0.00011,NULL,'14.3g',0.39,'S0',NULL,NULL,NULL,NULL,1,198.691833,53.82036,0.048,NULL,57415026070,897109782,14017340,14.3),(106868,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106868,37.77,0.46,359,45487,70,NULL,NULL,'2MASX J13144658+6724229',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000085,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,198.694583,67.40636,0.029,NULL,57910727416,904855115,14138361,16.9),(106869,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106869,37.79,0.46,362,45488,70,NULL,NULL,'2MASX J13144737+3825217',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,198.697208333,38.42261,0,NULL,59306486532,926663852,14479122,17.7),(106870,'Tully est','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106870,31.26,0.8,17.9,45489,75,NULL,'B','UGC 08323',NULL,'1988NBGC.C....0000T',1988,1,1,NULL,'G',0.000027,NULL,'14.3',0.8,'Im?            HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,198.70125,34.88092,0,NULL,59159149926,924361717,14443151,14.3),(106871,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106871,37.02,0.46,254,45490,70,NULL,NULL,'2MASX J13144903+4127316',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,198.70425,41.45869,0,NULL,59302616599,926603384,14478177,17.1),(106872,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106872,38.52,0.46,505,45491,70,NULL,NULL,'SDSS J131450.34+212033.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'19.45',0.13,NULL,NULL,NULL,NULL,NULL,1,198.7097917,21.34258,NULL,NULL,58816904253,919014128,14359595,19.45),(106873,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106873,38.42,0.46,483,45492,70,NULL,NULL,'SDSS J131450.39+201032.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,198.7099583,20.17567,0.065,NULL,58810100162,918907815,14357934,18.4),(106874,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106874,36.13,0.46,168,45493,70,NULL,NULL,'2MASX J13145076+4142467',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000185,NULL,'15.4g',0.56,'E0',NULL,NULL,NULL,NULL,1,198.711667,41.71311,0,NULL,59302626306,926603536,14478180,15.4),(106875,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106875,35.09,0.4,104,45494,NULL,NULL,'mean','IC 0858',NULL,'2007A&A...465...71T',2007,1,2,NULL,'G',0.000017,NULL,'13.70',1.5,'S0?','Pair member (points to parent)',NULL,NULL,NULL,1,198.716416667,17.22678,0,NULL,59039617430,922494022,14413969,13.7),(106876,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106876,35.47,0.45,124,45494,NULL,NULL,'K','IC 0858',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106877,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106877,37.34,0.46,294,45495,70,NULL,NULL,'2MASX J13145245+4319239',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000136,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,198.718625,43.32328,0,NULL,59308473809,926694903,14479607,17.6),(106878,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106878,36.23,0.33,176,45496,70,NULL,NULL,'2MASX J13145351+0714198',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00023,NULL,'17.84',0.16,NULL,NULL,NULL,NULL,NULL,1,198.7230417,7.23872,0.027,NULL,58979276696,921551198,14399237,17.84),(106879,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106879,35.99,0.27,158,45497,70,NULL,NULL,'2MASX J13145354+3400445',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000173,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,198.7230417,34.01239,0.013,NULL,59171775542,924558992,14446234,16.9),(106880,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106880,38.05,0.46,407,45498,70,NULL,NULL,'2MASX J13145406+3842567',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000143,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,198.725167,38.71564,0,NULL,59307366324,926677598,14479337,17.7),(106881,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106881,36.1,0.46,166,45499,70,NULL,NULL,'MCG +06-29-066',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.0001,NULL,'15.0g',0.64,NULL,NULL,NULL,NULL,NULL,1,198.727833,34.70242,0,NULL,59159087977,924360749,14443136,15),(106882,'Tully est','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106882,31.85,0.8,23.5,45500,75,NULL,NULL,'UGCA 339',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000017,NULL,'15.58',0.6,'IB(s)m',NULL,NULL,NULL,NULL,1,198.728,-23.14589,0.265,NULL,43796681662,684323150,10692549,15.58),(106883,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106883,37.47,0.46,312,45501,70,NULL,NULL,'SDSS J131454.74+432101.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000135,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,198.728125,43.35036,0,NULL,59308463391,926694740,14479605,18.2),(106884,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106884,37.11,0.46,264,45502,70,NULL,NULL,'2MASX J13145536+6753438',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000104,NULL,'15.9g',0.44,'E0',NULL,NULL,NULL,NULL,1,198.730625,67.89547,0.029,NULL,57909810840,904840794,14138137,15.9),(106885,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106885,37.48,0.46,314,45503,70,NULL,NULL,'2MASX J13145542+3655247',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000178,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,198.731125,36.92358,0,NULL,59291934838,926436481,14475570,17.1),(106886,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106886,38.13,0.33,422,45504,70,NULL,NULL,'2MASX J13145559+0640499',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000217,NULL,'17.75',0.18,NULL,NULL,NULL,NULL,NULL,1,198.7317083,6.68061,0.033,NULL,58980112971,921564265,14399441,17.75),(106887,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106887,37.03,0.65,254,45505,70,NULL,NULL,'II SZ 015',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'15.2',0.37,'E2',NULL,NULL,NULL,NULL,1,198.734041667,-13.52828,0.113,NULL,43995781450,687434085,10741157,15.2),(106888,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106888,38.38,0.46,474,45506,70,NULL,NULL,'SDSS J131456.19+150823.8',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'18.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,198.734167,15.13997,0.01,NULL,59010753091,922043017,14406922,18.3),(106889,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106889,35.39,0.46,119,45507,70,NULL,NULL,'2MASX J13145670+0444285',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000151,NULL,'16.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,198.736125,4.74142,0.031,NULL,58933822445,920840975,14388140,16.4),(106890,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106890,34.93,0.46,96.9,45508,70,NULL,NULL,'IC 0859',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000073,NULL,'15.2',0.3,'E','Pair member (points to parent)',NULL,NULL,NULL,1,198.738667,17.22517,0,NULL,59039620769,922494074,14413969,15.2),(106891,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106891,37.68,0.27,344,45509,70,NULL,NULL,'2MASX J13145734+1048138',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000176,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,198.738791667,10.80383,0,NULL,58972534560,921445852,14397591,17.2),(106892,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106892,38.37,0.46,471,45510,70,NULL,NULL,'2MASX J13145900+4252329',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,198.7457917,42.87594,0,NULL,59307978601,926687165,14479486,17.8),(106893,'Tully est','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106893,32.31,0.8,29,45511,75,NULL,'B','NGC 5037',NULL,'1988NBGC.C....0000T',1988,1,2.2,NULL,'G',0.000003,'?','12.22',0.7,'SA(s)a:','Group member',NULL,NULL,NULL,1,198.747375,-16.59031,0.101,NULL,44006913459,687608022,10743875,12.22),(106894,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106894,37.27,0.46,284,45512,70,NULL,NULL,'2MASX J13145965+1050468',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000184,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,198.74875,10.84639,0,NULL,58972531915,921445811,14397590,16.6),(106895,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106895,38.41,0.46,481,45513,70,NULL,NULL,'SDSS J131459.87+193211.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,198.7495,19.53667,0.069,NULL,58808698641,918885916,14357592,18.1),(106896,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106896,36.52,0.5,201,45514,70,NULL,NULL,'2MASX J13150078-1316161',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'16.51',NULL,NULL,NULL,NULL,NULL,NULL,1,198.753167,-13.27131,0.113,NULL,43997969857,687468279,10741691,16.51),(106897,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106897,34.87,0.47,94.3,45515,NULL,NULL,'H','UGC 08322',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000113,NULL,'14.1g',0.46,'Sa?',NULL,NULL,NULL,NULL,1,198.753833,12.72525,0.008,NULL,59014567211,922102612,14407853,14.1),(106898,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106898,34.96,0.46,98.4,45515,NULL,NULL,'J','UGC 08322',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106899,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106899,34.96,0.45,98.4,45515,NULL,NULL,'K','UGC 08322',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106900,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106900,35.14,0.4,107,45515,NULL,NULL,'mean','UGC 08322',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106901,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106901,37.2,0.33,275,45516,70,NULL,NULL,'2MASX J13150087+4327439',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,198.7537917,43.46225,0,NULL,59308494366,926695224,14479612,17),(106902,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106902,37.22,0.46,278,45517,70,NULL,NULL,'2MASX J13150199+2636064',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000173,NULL,'15.8g',0.41,'E',NULL,NULL,NULL,NULL,1,198.759083,26.59558,0.034,NULL,58710837208,917356831,14333700,15.8),(106903,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106903,36.31,0.46,182,45518,70,NULL,NULL,'2MASX J13150218+3805087',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000198,NULL,'15.6g',0.47,NULL,NULL,NULL,NULL,NULL,1,198.7592083,38.08578,0,NULL,59306054933,926657108,14479017,15.6),(106904,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106904,35.45,0.46,123,45519,70,NULL,NULL,'CGCG 044-039',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.0001,NULL,'15.1g',0.52,'S0/a','Group member',NULL,NULL,NULL,1,198.75925,3.01683,0.018,NULL,58056219714,907128433,14173881,15.1),(106905,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106905,38.62,0.46,529,45520,70,NULL,NULL,'2MASX J13150256+6053439',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,198.760916667,60.89544,0.005,NULL,57384998122,896640595,14010009,17.8),(106906,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106906,34.17,0.4,68.1,45521,NULL,NULL,'mean','IC 0860',NULL,'2007A&A...465...71T',2007,1,0.5,'UZC has V = 3911 +- 57 km/sec.','G',0.000064,NULL,'15.40',0.3,'Sa         HII;LIRG',NULL,NULL,NULL,NULL,1,198.764708333,24.61886,0.038,NULL,58691928857,917061388,14329084,15.4),(106907,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106907,34.9,0.47,95.3,45521,NULL,NULL,'H','IC 0860',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106908,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106908,34.93,0.45,97,45521,NULL,NULL,'K','IC 0860',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106909,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106909,35,0.46,99.9,45521,NULL,NULL,'J','IC 0860',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106910,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106910,36.76,0.46,225,45522,70,NULL,NULL,'2MASX J13150431+3303315',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00011,NULL,'15.5g',0.49,'E4',NULL,NULL,NULL,NULL,1,198.767917,33.05875,NULL,NULL,59171352286,924552379,14446130,15.5),(106911,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106911,38.19,0.46,434,45523,70,NULL,NULL,'SDSS J131504.43+063356.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,198.7685,6.56561,0.033,NULL,58979846018,921560094,14399376,18),(106912,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106912,37.22,0.46,278,45524,70,NULL,NULL,'2MASX J13150530+3013393',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000161,NULL,'16.9g',0.37,'E0',NULL,NULL,NULL,NULL,1,198.772125,30.22753,0.035,NULL,58680793163,916887393,14326365,16.9),(106913,'IRAS','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106913,33.37,0.8,47.2,45525,75,NULL,'MAT, I','ESO 269- G 075',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.87',0.6,'SAB(s)dm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,198.7724583,-47.13256,0.617,NULL,46952299175,733629674,11462963,14.87),(106914,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106914,32.66,0.32,34.1,45525,85,NULL,'I, raw','ESO 269- G 075',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106915,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106915,32.68,0.32,34.3,45525,85,NULL,'I, inv','ESO 269- G 075',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106916,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106916,32.96,0.43,39.1,45525,75,NULL,'MAT, I, raw','ESO 269- G 075',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106917,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106917,33.05,0.43,40.8,45525,75,NULL,'MAT, I, inv','ESO 269- G 075',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106918,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106918,33.23,0.43,44.2,45525,75,NULL,'MAT, I, cor','ESO 269- G 075',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106919,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106919,33.72,0.1,55.6,45525,NULL,NULL,NULL,'ESO 269- G 075',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106920,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106920,36.82,0.46,232,45526,70,NULL,NULL,'2MASX J13150552+3422003',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000151,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,198.772958333,34.36675,0.006,NULL,59171728874,924558263,14446222,17),(106921,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106921,34.38,0.49,75.1,45527,75,NULL,'IR','UGC 08324',NULL,'2011yCatp016004901K',2011,1,1.46,NULL,'G',0.000007,NULL,'15.7g',0.26,'Sd(f)','Group member',NULL,NULL,NULL,1,198.775,3.04517,0.018,NULL,58056217428,907128397,14173881,15.7),(106922,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106922,34.68,NULL,86.5,45527,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08324',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106923,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106923,34.7,NULL,87,45527,NULL,NULL,'Dipole + Quadrupole','UGC 08324',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106924,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106924,34.7,NULL,87,45527,NULL,NULL,'Dipole','UGC 08324',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106925,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106925,34.75,NULL,89.2,45527,NULL,NULL,NULL,'UGC 08324',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106926,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106926,34.9,0.31,95.4,45527,NULL,NULL,'Malmquist cor.','UGC 08324',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106927,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106927,34.92,0.2,96.4,45527,74.4,NULL,NULL,'UGC 08324',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106928,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106928,34.99,0.29,99.7,45527,NULL,NULL,NULL,'UGC 08324',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106929,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106929,38.13,0.33,422,45528,70,NULL,NULL,'SDSS J131506.28+063840.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,198.7762083,6.64458,0.033,NULL,58980108053,921564188,14399440,18.2),(106930,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106930,36.84,0.46,233,45529,70,NULL,NULL,'2MASX J13150639+2936593',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000203,NULL,'17.0',0.23,'E2',NULL,NULL,NULL,NULL,1,198.77675,29.61656,0.029,NULL,58713557637,917399338,14334364,17),(106931,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106931,37.64,0.33,337,45530,70,NULL,NULL,'2MASX J13150674-0115029',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00007,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,198.777917,-1.25103,0.021,NULL,43099079916,673423123,10522236,17.3),(106932,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106932,37.09,0.46,262,45531,70,NULL,NULL,'2MASX J13150682+2116383',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,198.778375,21.27742,NULL,NULL,58816900484,919014070,14359594,17),(106933,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106933,34.58,0.48,82.5,45532,70,NULL,NULL,'ESO 382- G 023',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00005,NULL,'14.23',0.9,'SAB(r)ab       HII',NULL,NULL,NULL,NULL,1,198.7784583,-37.14281,0.201,NULL,46928162581,733252540,11457070,14.23),(106934,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106934,38.37,0.33,473,45533,70,NULL,NULL,'2MASX J13150716+1531394',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000199,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,198.779875,15.52772,0.043,NULL,59010851357,922044552,14406946,18.2),(106935,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106935,37.01,0.33,253,45534,70,NULL,NULL,'2MASX J13150824+0655223',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000474,NULL,'17.69',0.17,NULL,NULL,NULL,NULL,NULL,1,198.7844583,6.92289,0.068,NULL,58979409111,921553267,14399269,17.69),(106936,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106936,37.56,0.33,326,45535,70,NULL,NULL,'2MASX J13150834+5616464',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000161,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,198.7847083,56.27956,0,NULL,57417685259,897151332,14017989,17.2),(106937,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106937,38.37,0.33,473,45536,70,NULL,NULL,'2MASX J13150869+1537274',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,198.786375,15.62417,0.023,NULL,59011576323,922055880,14407123,18.1),(106938,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106938,37.18,0.46,273,45537,70,NULL,NULL,'2MASX J13150953+4341349',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000156,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,198.7899583,43.69314,0,NULL,59308346032,926692906,14479576,16.7),(106939,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106939,32.77,0.47,35.8,45538,NULL,NULL,'H','WKK 2029',NULL,'2007A&A...465...71T',2007,1,0.78,NULL,'G',0.000017,NULL,'15.8',0.52,'S',NULL,NULL,NULL,NULL,1,198.791166667,-58.93656,NULL,NULL,44767084516,699485695,10929463,15.8),(106940,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106940,32.8,0.4,36.3,45538,NULL,NULL,'mean','WKK 2029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106941,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106941,32.88,0.45,37.7,45538,NULL,NULL,'K','WKK 2029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106942,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106942,36.85,0.46,234,45539,70,NULL,NULL,'VII Zw 505',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000173,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,198.791833,61.4565,0.017,NULL,57384629428,896634834,14009919,16.4),(106943,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106943,37.02,0.46,254,45540,70,NULL,NULL,'2MASX J13151144+0405534',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,198.797625,4.09833,0.057,NULL,58931576090,920805876,14387591,17.8),(106944,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106944,36.24,0.69,177,45541,70,NULL,NULL,'2MASX J13151163-3338210',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'14.20',0.5,'SB',NULL,NULL,NULL,NULL,1,198.7985417,-33.63914,0.229,NULL,46873340384,732395943,11443686,14.2),(106945,'IRAS','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106945,32.29,0.8,28.7,45542,75,NULL,'HMCL, I','ESO 443- G 085',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000027,NULL,'14.64',0.8,'SB(rs)d',NULL,NULL,NULL,NULL,1,198.8090417,-32.25389,0.201,NULL,46868385548,732318524,11442476,14.64),(106946,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106946,31.42,0.4,19.2,45542,NULL,NULL,NULL,'ESO 443- G 085',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106947,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106947,31.63,0.4,21.2,45542,75,NULL,'HMCL, I, inv','ESO 443- G 085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106948,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106948,31.68,0.4,21.7,45542,75,NULL,'HMCL, I, raw','ESO 443- G 085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106949,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106949,31.97,0.4,24.7,45542,75,NULL,'HMCL, I, cor','ESO 443- G 085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106950,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106950,37.99,0.46,396,45543,70,NULL,NULL,'2MASX J13151496+2035344',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,198.812416667,20.59303,0.062,NULL,58810429749,918912964,14358015,18),(106951,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106951,38.27,0.46,452,45544,70,NULL,NULL,'SDSS J131516.14+661317.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000073,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,198.817333,66.22153,0.013,NULL,57873692280,904276441,14129319,18.6),(106952,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106952,37.01,0.33,253,45545,70,NULL,NULL,'2MASX J13151643+0650143',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00024,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,198.8185,6.8375,0.039,NULL,58979444322,921553817,14399278,17.3),(106953,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106953,37.68,0.27,344,45546,70,NULL,NULL,'SDSS J131517.34+105156.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,198.82225,10.86572,0,NULL,58972567184,921446362,14397599,18),(106954,'TRGB','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106954,28.18,0.1,4.32,45547,74.4,NULL,NULL,'DDO 169NW',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'LSB',NULL,NULL,NULL,NULL,1,198.82675,47.53336,0,NULL,59280242345,926253786,14472715,NULL),(106955,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106955,37.56,0.33,326,45548,70,NULL,NULL,'2MASX J13151856+5614325',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,198.827417,56.24247,0,NULL,57417712242,897151753,14017996,17.3),(106956,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106956,36.19,0.46,173,45549,70,NULL,NULL,'2MASX J13151900+2828228',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000169,NULL,'16.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,198.829083,28.47317,0.041,NULL,58717694954,917463983,14335374,16.5),(106957,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106957,37.95,0.27,390,45550,70,NULL,NULL,'SDSS J131519.18+574151.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000164,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,198.83,57.69767,0,NULL,57436621418,897447209,14022612,18.6),(106958,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106958,37.15,0.62,269,45551,70,NULL,NULL,'II SZ 022',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.6',0.4,'E1',NULL,NULL,NULL,NULL,1,198.8325417,-10.58744,0.069,NULL,43872887293,685513863,10711154,15.6),(106959,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106959,36.23,0.33,176,45552,70,NULL,NULL,'2MASX J13151987+0719053',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000464,NULL,'18.08',0.15,NULL,NULL,NULL,NULL,NULL,1,198.8329583,7.31822,0.025,NULL,58979261505,921550961,14399233,18.08),(106960,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106960,37.64,0.33,337,45553,70,NULL,NULL,'2MASX J13152015-0117459',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000082,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,198.834,-1.29611,0.029,NULL,43099066930,673422920,10522233,17.4),(106961,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106961,37.82,0.46,366,45554,70,NULL,NULL,'2MASX J13152015+1312592',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000146,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,198.834,13.21658,0.02,NULL,59017486949,922148233,14408566,17.7),(106962,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106962,38.08,0.17,414,45555,70,NULL,NULL,'2MASX J13152086+0847583',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000155,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,198.837125,8.79939,0,NULL,58987351335,921677364,14401208,17.1),(106963,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106963,38.35,0.46,468,45556,70,NULL,NULL,'2MASX J13152111+0505304',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,198.838125,5.09181,0.021,NULL,58933469623,920835462,14388054,17.8),(106964,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106964,37.72,0.33,350,45557,70,NULL,NULL,'2MASX J13152170+3942221',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000171,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,198.8402917,39.70625,0,NULL,59307096617,926673384,14479271,16.8),(106965,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106965,34.83,0.46,92.5,45558,70,NULL,NULL,'ESO 382- G 024',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000014,NULL,'14.5',0.9,'S0',NULL,NULL,NULL,NULL,1,198.8405,-34.93422,0.121,NULL,46860115617,732189306,11440457,14.5),(106966,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106966,35.24,0.4,112,45558,NULL,NULL,'mean','ESO 382- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106967,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106967,35.24,0.45,112,45558,NULL,NULL,'K','ESO 382- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106968,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106968,37.4,0.46,302,45559,70,NULL,NULL,'SDSS J131521.85+431412.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,198.841083,43.23683,0,NULL,59308279068,926691860,14479560,18.3),(106969,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106969,37.21,0.46,276,45560,70,NULL,NULL,'2MASX J13152191+3408194',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,198.841333,34.13864,0.008,NULL,59171909427,924561084,14446266,17.4),(106970,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106970,37.95,0.27,390,45561,70,NULL,NULL,'2MASX J13152224+5740265',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000184,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,198.842666667,57.67397,0,NULL,57436621963,897447218,14022612,16.5),(106971,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106971,38,0.46,399,45562,70,NULL,NULL,'2MASX J13152351+3032144',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00014,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,198.848125,30.53736,0.026,NULL,58682403775,916912558,14326758,18.1),(106972,'SBF','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106972,32.47,0.28,31.2,45563,NULL,NULL,'I','NGC 5044',NULL,'2001ApJ...546..681T',2001,1,3,NULL,'G',0.000077,NULL,'11.83',3,'E0             LINER','X-ray-bright group member',NULL,NULL,NULL,1,198.849875,-16.38553,0.109,NULL,44000622817,687509731,10742339,11.83),(106973,'SBF','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106973,32.47,0.28,31.2,45563,NULL,NULL,NULL,'NGC 5044',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106974,'SBF','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106974,32.54,0.14,32.2,45563,74.4,NULL,NULL,'NGC 5044',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106975,'SBF','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106975,32.6,0.28,33.1,45563,NULL,NULL,'Malmquist cor.','NGC 5044',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106976,'D-Sigma','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106976,32.75,0.4,35.4,45563,75,NULL,'Edat, raw','NGC 5044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106977,'D-Sigma','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106977,32.9,0.4,38,45563,75,NULL,'Edat, cor','NGC 5044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106978,'Faber-Jackson','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106978,32.34,0.37,29.4,45563,95,NULL,'Weighted Mean','NGC 5044',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106979,'Faber-Jackson','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106979,32.83,0.46,36.8,45563,95,NULL,'Michard 1979a','NGC 5044',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106980,'Faber-Jackson','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106980,33.01,0.63,40,45563,95,NULL,'Michard 1979b, c','NGC 5044',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106981,'Faber-Jackson','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106981,33.4,0.81,47.9,45563,55,NULL,'Visvanathan & Sandage 1979','NGC 5044',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106982,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106982,32.37,0.41,29.7,45563,NULL,NULL,NULL,'NGC 5044',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106983,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106983,32.6,0.41,33.1,45563,NULL,NULL,'Malmquist cor.','NGC 5044',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106984,'Tully est','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106984,32.95,0.8,38.9,45563,75,NULL,'B','NGC 5044',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106985,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106985,32.89,0.45,37.8,45563,NULL,NULL,'K','NGC 5044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106986,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106986,33.09,0.4,41.6,45563,NULL,NULL,'mean','NGC 5044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106987,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106987,37.83,0.46,367,45564,70,NULL,NULL,'2MASX J13152406+0750493',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.75',0.17,NULL,NULL,NULL,NULL,NULL,1,198.8502083,7.84694,0,NULL,58987091707,921673307,14401145,17.75),(106988,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106988,37.72,0.33,350,45565,70,NULL,NULL,'2MASX J13152422+3941331',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000194,NULL,'16.4g',0.41,'BrClG',NULL,NULL,NULL,NULL,1,198.850916667,39.69269,0,NULL,59307097173,926673393,14479271,16.4),(106989,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106989,36.71,0.23,219,45566,70,NULL,NULL,'2MASX J13152441+0950413',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.89',0.18,NULL,NULL,NULL,NULL,NULL,1,198.8517917,9.84472,0,NULL,58976101635,921501588,14398462,16.89),(106990,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106990,36.56,0.46,205,45567,70,NULL,NULL,'2MASX J13152455+3236214',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000172,NULL,'17.2',0.18,'E0',NULL,NULL,NULL,NULL,1,198.8524583,32.60594,NULL,NULL,59162907330,924420427,14444069,17.2),(106991,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106991,37.42,0.46,305,45568,70,NULL,NULL,'2MASX J13152478+2201154',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,198.85325,22.02111,NULL,NULL,58815522831,918992544,14359258,16.5),(106992,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106992,35.06,0.2,103,45569,74.4,NULL,NULL,'UGC 08328',NULL,'2013AJ....146...86T',2013,1,1.03,NULL,'G',0.000008,NULL,'16.1g',0.27,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,198.856625,27.30325,0.043,NULL,58716733789,917448965,14335140,16.1),(106993,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106993,35.08,0.11,104,45569,NULL,NULL,NULL,'UGC 08328',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106994,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106994,35.19,0.43,109,45569,75,NULL,'3.6 micron, color corrected','UGC 08328',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106995,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,106995,35.38,0.43,119,45569,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08328',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106996,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106996,37.74,0.46,353,45570,70,NULL,NULL,'2MASX J13152609+1717312',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.81',0.14,NULL,NULL,NULL,NULL,NULL,1,198.858625,17.29203,0,NULL,59039875519,922498054,14414032,18.81),(106997,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106997,37.68,0.27,344,45571,70,NULL,NULL,'VIII Zw 268 NED02',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000198,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,198.86075,10.85164,0,NULL,58972568203,921446378,14397599,17.1),(106998,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106998,35.63,0.46,134,45572,70,NULL,NULL,'2MASX J13152722+2904268',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000185,NULL,'15.5g',0.47,'E',NULL,NULL,NULL,NULL,1,198.8635417,29.07417,0.037,NULL,58713749600,917402337,14334411,15.5),(106999,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',106999,37.8,0.46,362,45573,70,NULL,NULL,'2MASX J13152776-0053199',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000088,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,198.865583333,-0.88881,0.045,NULL,43098968274,673421379,10522209,17.2),(107000,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107000,37.68,0.46,344,45574,70,NULL,NULL,'2MASX J13152853+0826163',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.78',0.12,NULL,NULL,NULL,NULL,NULL,1,198.869,8.43783,0,NULL,58987296279,921676504,14401195,18.78),(107001,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107001,36.71,0.23,219,45575,70,NULL,NULL,'2MASX J13152982+0951006',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000201,NULL,'15.5g',0.49,NULL,NULL,NULL,NULL,NULL,1,198.8742917,9.85017,0,NULL,58976102149,921501596,14398462,15.5),(107002,'Brightest Stars','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107002,29.58,NULL,8.23,45576,NULL,NULL,NULL,'UGC 08331',NULL,'1998A&AS..131....1K',1998,1,2.7,NULL,'G',0.000017,NULL,'14.6',0.9,'IAm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,198.8762917,47.49894,0,NULL,59280230627,926253603,14472712,14.6),(107003,'TRGB','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107003,28.05,0.14,4.08,45576,NULL,NULL,NULL,'UGC 08331',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107004,'TRGB','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107004,28.21,NULL,4.39,45576,NULL,NULL,NULL,'UGC 08331',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107005,'TRGB','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107005,28.22,0.06,4.4,45576,NULL,NULL,NULL,'UGC 08331',NULL,'2013AstBu..68..125M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107006,'TRGB','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107006,28.22,0.05,4.41,45576,NULL,NULL,'I','UGC 08331',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107007,'TRGB','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107007,28.22,0.1,4.41,45576,74.4,NULL,NULL,'UGC 08331',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107008,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107008,28.29,0.4,4.6,45576,75,NULL,'B','UGC 08331',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107009,'IRAS','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107009,31.04,0.8,16.1,45577,75,NULL,'A82, H','NGC 5042',NULL,'1997ApJS..109..333W',1997,1,4.2,NULL,'G',0.000007,NULL,'12.75',2.2,'SAB(rs)c',NULL,NULL,NULL,NULL,1,198.87925,-23.98406,0.233,NULL,43793383319,684271614,10691743,12.75),(107010,'Tully est','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107010,31.69,0.8,21.7,45577,75,NULL,NULL,'NGC 5042',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107011,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107011,30.15,0.4,10.7,45577,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5042',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107012,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107012,30.51,0.38,12.6,45577,NULL,NULL,NULL,'NGC 5042',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107013,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107013,30.5,0.39,12.6,45577,73,NULL,'opt','NGC 5042',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107014,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107014,30.67,0.2,13.6,45577,74.4,NULL,NULL,'NGC 5042',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107015,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107015,30.76,0.43,14.2,45577,75,NULL,'3.6 micron, color corrected','NGC 5042',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107016,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107016,30.84,0.47,14.7,45577,75,NULL,'A82, H, inv','NGC 5042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107017,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107017,30.84,0.43,14.7,45577,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5042',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107018,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107018,30.87,0.47,14.9,45577,75,NULL,'A82, H, raw','NGC 5042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107019,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107019,30.95,0.41,15.5,45577,NULL,NULL,NULL,'NGC 5042',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107020,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107020,31.15,0.38,17,45577,NULL,NULL,'Malmquist cor.','NGC 5042',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107021,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107021,31.22,0.47,17.5,45577,75,NULL,'A82, H, cor','NGC 5042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107022,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107022,37.91,0.46,383,45578,70,NULL,NULL,'2MASX J13153150+0500557',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000185,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,198.88125,5.01556,0.021,NULL,58933941430,920842834,14388169,17.2),(107023,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107023,37.68,0.46,343,45579,70,NULL,NULL,'SDSS J131531.96+570631.1',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000161,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,198.883208333,57.10864,0.009,NULL,57435074696,897423042,14022235,17.4),(107024,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107024,37.3,0.46,289,45580,70,NULL,NULL,'2MASX J13153227+2213404',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,198.884541667,22.22806,0.022,NULL,58815436936,918991202,14359237,16.6),(107025,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107025,36.71,0.23,219,45581,70,NULL,NULL,'SDSS J131534.93+095224.0',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000176,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,198.895583333,9.87336,0,NULL,58976070461,921501100,14398454,17.3),(107026,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107026,37.67,0.46,341,45582,70,NULL,NULL,'2MASX J13153516+2040004',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.37',0.15,NULL,NULL,NULL,NULL,NULL,1,198.8965,20.66675,0.06,NULL,58810369423,918912022,14358000,17.37),(107027,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107027,37.6,0.46,331,45583,70,NULL,NULL,'2MASX J13153546+6723340',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000091,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,198.8975,67.393,0.033,NULL,57910602619,904853165,14138330,17.2),(107028,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107028,37.02,0.62,253,45584,70,NULL,NULL,'2MASX J13153634-3145260',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.8',0.3,'Sp',NULL,NULL,NULL,NULL,1,198.901333,-31.75717,0.229,NULL,43325466381,676960412,10577506,16.8),(107029,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107029,35.43,0.59,122,45585,70,NULL,NULL,'2MASX J13153688-0508040',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'16.83',0.32,NULL,NULL,NULL,NULL,NULL,1,198.9037083,-5.13456,0.053,NULL,43830131410,684845803,10700715,16.83),(107030,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107030,35.6,0.59,132,45586,70,NULL,NULL,'AM 1311-730 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.08,NULL,'G',0.00015,NULL,'14.7b',NULL,'S?',NULL,NULL,NULL,NULL,1,198.90425,-73.37053,0.849,NULL,44215715778,690870559,10794852,14.7),(107031,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107031,36.68,0.46,217,45587,70,NULL,NULL,'2MASX J13153773+0932446',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000164,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,198.907083,9.54564,0,NULL,58975258218,921488409,14398256,16.6),(107032,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107032,37.11,0.46,264,45588,70,NULL,NULL,'2MASX J13153926+4820149',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000142,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,198.913417,48.33758,0,NULL,59275172411,926174568,14471477,17.7),(107033,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107033,37.55,0.33,323,45589,70,NULL,NULL,'2MASX J13153942+1338332',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000183,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,198.914375,13.64267,0,NULL,59016778540,922137164,14408393,16.4),(107034,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107034,38.87,0.46,594,45590,70,NULL,NULL,'2MASX J13154051+1253444',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,198.91875,12.89556,0.008,NULL,59017389471,922146710,14408542,18.5),(107035,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107035,37.51,0.33,318,45591,70,NULL,NULL,'2MASX J13154108+2919467',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000161,NULL,'16.8g',0.29,'E',NULL,NULL,NULL,NULL,1,198.921333,29.32978,0.054,NULL,58713618439,917400288,14334379,16.8),(107036,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107036,34.86,0.55,93.6,45592,70,NULL,NULL,'ESO 576- G 018',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000113,NULL,'15.15',0.9,'S0',NULL,NULL,NULL,NULL,1,198.922083,-22.73844,0.241,NULL,43796524988,684320702,10692510,15.15),(107037,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107037,37.8,0.46,363,45593,70,NULL,NULL,'2MASX J13154148+3213499',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000178,NULL,'17.7',0.16,'E2',NULL,NULL,NULL,NULL,1,198.9227083,32.2305,0,NULL,59162848122,924419501,14444054,17.7),(107038,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107038,35.84,0.46,147,45594,70,NULL,NULL,'2MASX J13154159+3345419',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000077,NULL,'15.6g',0.46,'E3',NULL,NULL,NULL,NULL,1,198.923417,33.76175,0.013,NULL,59171753404,924558646,14446228,15.6),(107039,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107039,37.55,0.33,323,45595,70,NULL,NULL,'2MASX J13154192+1340014',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000174,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,198.924583,13.66717,0,NULL,59016779485,922137179,14408393,17.1),(107040,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107040,36.17,0.46,171,45596,70,NULL,NULL,'2MASX J13154272+6236388',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000178,NULL,'16.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,198.9277083,62.61078,0.037,NULL,57358984201,896234128,14003658,16.9),(107041,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107041,36.23,0.71,176,45597,70,NULL,NULL,'2MASX J13154278-3240396',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,198.9282917,-32.67758,0.197,NULL,46868317310,732317457,11442460,14.6),(107042,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107042,37.32,0.46,291,45598,70,NULL,NULL,'2MASX J13154322-0046330',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000096,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,198.929875,-0.776,0.041,NULL,43090785576,673293524,10520211,17.7),(107043,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107043,37.27,0.46,284,45599,70,NULL,NULL,'2MASX J13154398+5210559',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000185,NULL,'16.9g',0.26,'AGN',NULL,NULL,NULL,NULL,1,198.9332917,52.18214,0,NULL,57193620758,893650324,13963286,16.9),(107044,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107044,37.71,0.19,348,45600,70,NULL,NULL,'2MASX J13154586+4328256',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000154,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,198.9410417,43.47361,0,NULL,59308267466,926691679,14479557,17.8),(107045,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107045,37.3,0.33,288,45601,70,NULL,NULL,'2MASX J13154599+2503333',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,198.941583333,25.05936,0.03,NULL,58708302778,917317230,14333081,17.6),(107046,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107046,37.95,0.27,390,45602,70,NULL,NULL,'2MASXi J1315463+574010',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,198.942958333,57.66967,0,NULL,57436746755,897449168,14022643,17.6),(107047,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107047,37.33,0.46,292,45603,70,NULL,NULL,'2MASX J13154760+0109368',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000069,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,198.948417,1.16031,0.033,NULL,58063534328,907242723,14175667,18.3),(107048,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107048,36.71,0.23,219,45604,70,NULL,NULL,'CGCG 072-038 NED01',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000113,NULL,'15.4g',0.49,NULL,NULL,NULL,NULL,NULL,1,198.9502917,10.00331,0,NULL,58975879261,921498113,14398408,15.4),(107049,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107049,38.27,0.46,451,45605,70,NULL,NULL,'2MASX J13154858+1516444',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000176,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,198.952416667,15.27911,0.048,NULL,59010910833,922045481,14406960,17.6),(107050,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107050,36.47,0.46,197,45606,70,NULL,NULL,'2MASX J13154919+1249364',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000198,NULL,'16.6g',0.28,'Candidate      BLAGN',NULL,NULL,NULL,NULL,1,198.954875,12.82675,0.005,NULL,59017336366,922145880,14408529,16.6),(107051,'SNIa','2016-12-15 15:15:12','2016-12-16 11:20:24','1','SN 1971I','R',107051,30.91,NULL,15.2,45607,NULL,NULL,'Photographic','MESSIER 063',NULL,'1988SSRv...48....1R',1988,1,12.6,NULL,'G',0.000003,NULL,'9.31',7.2,'SA(rs)bc   HII/LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,198.955541667,42.02928,0,NULL,59301433587,926584899,14477889,9.31),(107052,'TRGB','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107052,29.78,0.09,9.04,45607,74.4,NULL,NULL,'MESSIER 063',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107053,'TRGB','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107053,29.85,0.13,9.32,45607,NULL,NULL,NULL,'MESSIER 063',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107054,'Grav. Stability Gas. Disk','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107054,29.13,NULL,6.7,45607,NULL,NULL,NULL,'MESSIER 063',NULL,'1996AstL...22...71Z',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107055,'IRAS','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107055,30.2,0.8,10.9,45607,75,NULL,'A82, H','MESSIER 063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107056,'Sosies','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107056,30.07,0.07,10.3,45607,NULL,NULL,NULL,'MESSIER 063',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107057,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107057,28.13,0.69,4.22,45607,100,NULL,'mid-IR','MESSIER 063',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107058,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107058,28.49,0.4,5,45607,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 2 galaxy group','MESSIER 063',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107059,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107059,29.27,0.4,7.2,45607,75,NULL,'B','MESSIER 063',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107060,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107060,29.3,0.3,7.24,45607,NULL,18.45,'SN 1971I host','MESSIER 063',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107061,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107061,29.49,0.4,7.9,45607,73,NULL,'opt','MESSIER 063',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107062,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107062,29.5,0.35,7.94,45607,NULL,NULL,NULL,'MESSIER 063',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107063,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107063,29.58,0.43,8.2,45607,75,NULL,'3.6 micron, color + selection bias corrected','MESSIER 063',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107064,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107064,29.65,0.43,8.5,45607,75,NULL,'3.6 micron, color corrected','MESSIER 063',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107065,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107065,29.66,0.47,8.53,45607,75,NULL,'A82, H, raw','MESSIER 063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107066,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107066,29.78,0.09,9.04,45607,74.4,NULL,NULL,'MESSIER 063',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107067,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107067,29.85,0.47,9.32,45607,75,NULL,'A82, H, inv','MESSIER 063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107068,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107068,29.99,NULL,9.95,45607,NULL,NULL,'LEDA [April 2006]','MESSIER 063',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107069,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107069,30.03,0.47,10.2,45607,75,NULL,'A82, H, cor','MESSIER 063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107070,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107070,37.82,0.33,367,45608,70,NULL,NULL,'2MASX J13154983+0745146',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,198.957625,7.75392,0,NULL,58987089881,921673279,14401144,17.4),(107071,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107071,38.15,0.46,426,45609,70,NULL,NULL,'2MASX J13155015+4111141',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000138,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,198.9587917,41.18717,0,NULL,59301963777,926593184,14478018,18),(107072,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107072,38.3,0.46,456,45610,70,NULL,NULL,'2MASX J13155063+2347564',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,198.960833,23.79894,0,NULL,58812960595,918952509,14358632,16.9),(107073,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107073,39.64,0.46,848,45611,70,NULL,NULL,'SDSS J131551.91+365617.0',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000165,NULL,'19.0g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,198.9662917,36.93808,0,NULL,59291962592,926436915,14475576,19),(107074,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107074,37.71,0.19,348,45612,70,NULL,NULL,'SDSS J131552.39+433229.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000163,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,198.968333,43.54147,0,NULL,59308277729,926691839,14479559,18.5),(107075,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107075,36.15,0.46,170,45613,70,NULL,NULL,'2MASX J13155354+0641046',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000257,NULL,'17.90',0.16,NULL,NULL,NULL,NULL,NULL,1,198.9732083,6.68475,0.033,NULL,58977544441,921524131,14398814,17.9),(107076,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107076,37.71,0.19,348,45614,70,NULL,NULL,'SDSS J131553.58+432733.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000139,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,198.9732917,43.45931,0,NULL,59308296243,926692128,14479564,18.2),(107077,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107077,37.3,0.33,288,45615,70,NULL,NULL,'2MASX J13155380+2502503',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.52',0.28,NULL,NULL,NULL,NULL,NULL,1,198.974208333,25.04747,0.03,NULL,58708303824,917317247,14333081,17.52),(107078,'Tully est','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107078,31.39,0.8,19,45616,75,NULL,NULL,'UGC 08333',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000013,NULL,'17.',0.4,'Im:',NULL,NULL,NULL,NULL,1,198.974625,25.43547,0.036,NULL,58708412463,917318944,14333108,17),(107079,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107079,31.6,0.43,20.9,45616,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08333',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107080,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107080,31.7,0.2,21.9,45616,74.4,NULL,NULL,'UGC 08333',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107081,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107081,31.7,0.43,21.9,45616,75,NULL,'3.6 micron, color corrected','UGC 08333',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107082,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107082,32.43,0.4,30.6,45616,NULL,NULL,NULL,'UGC 08333',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107083,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107083,36.63,0.33,212,45617,70,NULL,NULL,'2MASX J13155567+0848195',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.13',0.21,NULL,NULL,NULL,NULL,NULL,1,198.981958333,8.80536,0,NULL,58987145687,921674151,14401158,18.13),(107084,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107084,36.89,0.17,238,45618,70,NULL,NULL,'2MASX J13155645+0705466',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000267,NULL,'17.52',0.18,NULL,NULL,NULL,NULL,NULL,1,198.985125,7.09628,0.025,NULL,58977446321,921522598,14398790,17.52),(107085,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107085,37.42,0.46,305,45619,70,NULL,NULL,'SDSS J131556.49+643545.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00007,NULL,'18.3g',0.11,'NLAGN',NULL,NULL,NULL,NULL,1,198.985375,64.59597,0.029,NULL,57351826076,896122282,14001910,18.3),(107086,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107086,38.23,0.46,443,45620,70,NULL,NULL,'SDSS J131557.25+093823.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000124,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,198.988583,9.63983,0,NULL,58976011662,921500182,14398440,18.6),(107087,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107087,34.98,0.69,98.9,45621,70,NULL,NULL,'CGCG 016-036',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000097,NULL,'15.36',0.3,NULL,NULL,NULL,NULL,NULL,1,198.989583,-3.65411,0.049,NULL,43093977406,673343396,10520990,15.36),(107088,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107088,35.57,0.49,130,45622,75,NULL,'IR','CGCG 101-016',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.00004,NULL,'15.6',0.2,'Scd',NULL,NULL,NULL,NULL,1,198.989916667,17.16497,0,NULL,59010586878,922040419,14406881,15.6),(107089,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107089,37.96,0.46,390,45623,70,NULL,NULL,'2MASX J13155766+1235444',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000157,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,198.99025,12.59564,0.005,NULL,59014185291,922096645,14407760,17.4),(107090,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107090,38.02,0.46,402,45624,70,NULL,NULL,'2MASX J13155859+2124484',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,198.994083333,21.41344,NULL,NULL,58816969531,919015148,14359611,17.3),(107091,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107091,37.51,0.33,318,45625,70,NULL,NULL,'2MASX J13155855+2916483',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000174,NULL,'16.9g',0.28,'E',NULL,NULL,NULL,NULL,1,198.994083333,29.28017,0.054,NULL,58713609015,917400140,14334377,16.9),(107092,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107092,36.93,0.46,243,45626,70,NULL,NULL,'2MASX J13155868+0421308',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,'Post Starburst (E+A) or (a+k) Galaxy',1,198.994583,4.35869,0.056,NULL,58933745853,920839778,14388121,17.1),(107093,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107093,37.96,0.21,390,45627,70,NULL,NULL,'2MASX J13155877+0942465',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,198.994917,9.71289,0,NULL,58976021119,921500329,14398442,17.6),(107094,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107094,38.31,0.46,460,45628,70,NULL,NULL,'SDSS J131559.02+085434.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.4g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,198.9959583,8.90961,0,NULL,58973281847,921457528,14397773,18.4),(107095,'Tully est','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107095,32.97,0.8,39.3,45629,75,NULL,'B','NGC 5049',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000063,NULL,'13.7',0.6,'S0','X-ray-bright group member',NULL,NULL,NULL,1,198.997083,-16.39717,0.117,NULL,44001718770,687526855,10742607,13.7),(107096,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107096,37.96,0.21,390,45630,70,NULL,NULL,'2MASX J13160059+0928254',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.56',0.14,NULL,NULL,NULL,NULL,NULL,1,199.002417,9.47361,0,NULL,58975266064,921488532,14398258,18.56),(107097,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107097,36.83,0.46,232,45631,70,NULL,NULL,'2MASX J13160058+3806384',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000192,NULL,'15.7g',0.45,NULL,NULL,NULL,NULL,NULL,1,199.0025417,38.11058,0,NULL,59306210638,926659541,14479055,15.7),(107098,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107098,37.49,0.46,315,45632,70,NULL,NULL,'2MASX J13160099+2533543',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,199.004291667,25.56497,0.036,NULL,58711193884,917362404,14333787,17.2),(107099,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107099,37.71,0.19,348,45633,70,NULL,NULL,'2MASX J13160111+4327366',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,199.0044583,43.46008,0,NULL,59308303591,926692243,14479566,17.1),(107100,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107100,36.89,0.17,238,45634,70,NULL,NULL,'2MASX J13160122+0701154',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000414,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,199.005167,7.02097,0.03,NULL,58977450247,921522660,14398791,NULL),(107101,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107101,36.63,0.33,212,45635,70,NULL,NULL,'2MASX J13160143+0835134',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000184,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,199.005916667,8.58711,0,NULL,58987338454,921677163,14401205,16.2),(107102,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107102,37.13,0.46,267,45636,70,NULL,NULL,'2MASX J13160182+1559433',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.56',0.16,NULL,NULL,NULL,NULL,NULL,1,199.007417,15.9955,0.016,NULL,59011490979,922054546,14407102,18.56),(107103,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107103,36.33,0.46,185,45637,70,NULL,NULL,'2MASX J13160222-0133230',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000073,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,199.009417,-1.5565,0.029,NULL,43100553074,673446141,10522595,16.3),(107104,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107104,35.24,0.59,112,45638,70,NULL,NULL,'2MASX J13160340-1453270',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.59',NULL,NULL,NULL,NULL,NULL,NULL,1,199.01425,-14.89111,0.101,NULL,44002544499,687539757,10742808,16.59),(107105,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107105,35.4,0.2,120,45639,74.4,NULL,NULL,'CGCG 072-040',NULL,'2013AJ....146...86T',2013,1,0.77,NULL,'G',0.000182,NULL,'16.0g',0.27,'Sc','Group member',NULL,NULL,NULL,1,199.014958333,13.40317,0,NULL,59017397335,922146833,14408544,16),(107106,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107106,34.86,0.2,93.8,45640,74.4,NULL,NULL,'UGC 08338',NULL,'2013AJ....146...86T',2013,1,0.96,NULL,'G',0.000007,NULL,'14.3g',0.52,'Sbc',NULL,NULL,NULL,NULL,1,199.0150417,35.04353,0,NULL,59170392238,924537378,14445896,14.3),(107107,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107107,35.89,0.47,151,45641,NULL,NULL,'H','ESO 382- G 027',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000033,NULL,'14.6b',0.9,'Sb-c           HII',NULL,NULL,NULL,NULL,1,199.015375,-37.34725,0.213,NULL,46939621572,733431587,11459868,14.6),(107108,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107108,35.96,0.4,156,45641,NULL,NULL,'mean','ESO 382- G 027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107109,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107109,36.03,0.46,161,45641,NULL,NULL,'J','ESO 382- G 027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107110,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107110,37.62,0.27,334,45642,70,NULL,NULL,'2MASX J13160430+6219349',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.0g',0.18,'AGN',NULL,NULL,NULL,NULL,1,199.018167,62.32633,0.037,NULL,57358238272,896222473,14003476,18),(107111,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107111,37.97,0.46,393,45643,70,NULL,NULL,'2MASX J13160456+0545045',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,199.019083,5.75111,0,NULL,58932373542,920818336,14387786,17.5),(107112,'CMD','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'N',107112,21.02,NULL,0.16,45644,NULL,NULL,NULL,'CVn W',NULL,'2009AJ....137..450W',2009,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107113,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107113,35.56,0.47,130,45645,70,NULL,NULL,'AM 1313-370 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.000093,NULL,'15.20',0.3,'E',NULL,NULL,NULL,NULL,1,199.023,-37.33292,0.213,NULL,46939622396,733431599,11459868,15.2),(107114,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107114,37.5,0.46,316,45646,70,NULL,NULL,'2MASX J13160577+2736073',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000182,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,199.02425,27.60217,0.046,NULL,58716864321,917451005,14335171,16.8),(107115,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107115,37.82,0.33,367,45647,70,NULL,NULL,'2MASX J13160644+0746415',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,199.026875,7.77822,0,NULL,58988054787,921688356,14401380,NULL),(107116,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107116,38.1,0.46,416,45648,70,NULL,NULL,'SDSS J131606.70+080335.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,199.0279583,8.05997,0,NULL,58986924583,921670696,14401104,18.2),(107117,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107117,36.92,0.46,242,45649,70,NULL,NULL,'2MASX J13160669+3742584',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000183,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,199.028125,37.71631,0,NULL,59306353639,926661775,14479090,16.7),(107118,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107118,37.71,0.19,348,45650,70,NULL,NULL,'2MASX J13160690+4327101',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000222,NULL,'16.7g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,199.028583,43.45283,0,NULL,59308304273,926692254,14479566,16.7),(107119,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107119,37.62,0.27,334,45651,70,NULL,NULL,'2MASX J13160717+6218339',NULL,'2015arXiv151105856S',2015,1,0.37,'May contribute to the IR source IRAS F13142+6233.','G',0.000187,NULL,'16.7g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,199.030125,62.30956,0.037,NULL,57358238112,896222470,14003476,16.7),(107120,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107120,37.96,0.21,390,45652,70,NULL,NULL,'2MASX J13160727+0945595',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.98',0.21,NULL,NULL,NULL,NULL,NULL,1,199.0305,9.76642,0,NULL,58976029233,921500456,14398444,17.98),(107121,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107121,36.98,0.33,249,45653,70,NULL,NULL,'2MASX J13160753+1704543',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.31',0.17,NULL,NULL,NULL,NULL,NULL,1,199.031375,17.08167,0.005,NULL,59010064970,922032265,14406754,18.31),(107122,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107122,37.82,0.46,367,45654,70,NULL,NULL,'2MASX J13160816+1928361',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.46',0.16,NULL,NULL,NULL,NULL,NULL,1,199.034,19.47675,0.056,NULL,58808657246,918885269,14357582,18.46),(107123,'D-Sigma','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107123,32.39,0.4,30.1,45655,75,NULL,'Edat, raw','NGC 5048',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00005,NULL,'13.72',0.8,'SA0-:',NULL,NULL,NULL,NULL,1,199.034916667,-28.41053,0.249,NULL,43342368250,677224503,10581632,13.72),(107124,'D-Sigma','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107124,32.53,0.4,32,45655,75,NULL,'Edat, cor','NGC 5048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107125,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107125,33.88,0.45,59.6,45655,NULL,NULL,'K','NGC 5048',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107126,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107126,34.01,0.4,63.5,45655,NULL,NULL,'mean','NGC 5048',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107127,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107127,38.14,0.46,425,45656,70,NULL,NULL,'2MASX J13160853+5230257',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,199.035541667,52.50733,0,NULL,57412498464,897070288,14016723,17.9),(107128,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107128,37.71,0.19,348,45657,70,NULL,NULL,'2MASX J13160884+4326071',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,199.03675,43.43533,0,NULL,59308303667,926692244,14479566,17.4),(107129,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107129,36.97,0.46,248,45658,70,NULL,NULL,'2MASX J13160885+6207439',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00014,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,199.036958333,62.12894,0.025,NULL,57358411191,896225174,14003518,17.8),(107130,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107130,36.89,0.17,238,45659,70,NULL,NULL,'SDSS J131610.08+070237.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000207,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,199.0420417,7.04367,0.03,NULL,58977470853,921522982,14398796,18.1),(107131,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107131,37.61,0.46,333,45660,70,NULL,NULL,'SDSS J131612.23+594648.0',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,199.051,59.78,0.005,NULL,57391555946,896743061,14011610,17.6),(107132,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107132,37.67,0.46,341,45661,70,NULL,NULL,'SDSS J131612.38-003654.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000053,NULL,'18.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,199.051583333,-0.61528,0.037,NULL,43090326873,673286357,10520099,18.5),(107133,'IRAS','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107133,34.35,0.8,74.2,45662,75,NULL,'CF, r','NGC 5056',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000006,NULL,'13.7',1,'Scd:           AGN','Possible field galaxy',NULL,NULL,NULL,1,199.051333,30.95033,0.022,NULL,58682078870,916907482,14326679,13.7),(107134,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107134,33.54,0.69,51,45662,100,NULL,'mid-IR','NGC 5056',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107135,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107135,33.65,0.38,53.8,45662,75,NULL,'CF, r, raw','NGC 5056',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107136,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107136,33.78,0.38,56.9,45662,75,NULL,'CF, r, inv','NGC 5056',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107137,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107137,33.92,0.47,60.7,45662,NULL,NULL,'H','NGC 5056',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107138,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107138,33.98,0.38,62.4,45662,75,NULL,'CF, r, cor','NGC 5056',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107139,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107139,34.13,0.2,67,45662,74.4,NULL,NULL,'NGC 5056',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107140,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107140,34.31,0.43,72.8,45662,NULL,NULL,NULL,'NGC 5056',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107141,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107141,34.34,0.45,73.9,45662,NULL,NULL,'K','NGC 5056',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107142,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107142,34.37,0.42,74.9,45662,NULL,NULL,'Malmquist cor.','NGC 5056',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107143,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107143,34.41,0.46,76.3,45662,NULL,NULL,'J','NGC 5056',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107144,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107144,34.59,0.4,82.9,45662,NULL,NULL,'mean','NGC 5056',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107145,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107145,37.96,0.21,390,45663,70,NULL,NULL,'2MASX J13161356+0932365',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000199,NULL,'16.5g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,199.0564583,9.54353,0,NULL,58975154949,921486796,14398231,16.5),(107146,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107146,36.64,0.46,213,45664,70,NULL,NULL,'2MASX J13161467+6204078',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,199.061333,62.06889,0.025,NULL,57358376774,896224637,14003509,17.1),(107147,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107147,37.62,0.27,334,45665,70,NULL,NULL,'2MASX J13161480+6223598',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000186,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,199.061916667,62.4,0.037,NULL,57359119552,896236243,14003691,17.2),(107148,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107148,35.52,0.46,127,45666,70,NULL,NULL,'IC 0862',NULL,'2015arXiv151105856S',2015,1,0.5,'MCG declination is -1 degree in error.','G',0.00006,NULL,'15.2',0.4,'E','Isolated galaxy',NULL,NULL,NULL,1,199.064083333,20.04767,0.066,NULL,58810169458,918908897,14357951,15.2),(107149,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107149,36.54,0.46,203,45667,70,NULL,NULL,'SDSS J131615.87+122527.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,199.066166667,12.42425,0.011,NULL,59014247286,922097613,14407775,18),(107150,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107150,36.54,0.46,203,45668,70,NULL,NULL,'2MASX J13161623+1227387',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,199.06775,12.46067,0.011,NULL,59014196132,922096814,14407762,16.9),(107151,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107151,38.11,0.46,419,45669,70,NULL,NULL,'SDSS J131616.43+081412.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,199.0685,8.23689,0,NULL,58987256405,921675881,14401185,17.9),(107152,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107152,38.03,0.33,404,45670,70,NULL,NULL,'2MASX J13161661+4352572',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,199.069083,43.88236,0,NULL,59308190113,926690470,14479538,17.1),(107153,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107153,33.87,0.49,59.4,45671,75,NULL,'IR','IC 4215',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000063,NULL,'15.08',0.2,'Sab',NULL,NULL,NULL,NULL,1,199.070125,25.40522,0.045,NULL,58708350610,917317978,14333093,15.08),(107154,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107154,36.98,0.33,249,45672,70,NULL,NULL,'2MASX J13161694+1707167',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.26',0.19,NULL,NULL,NULL,NULL,NULL,1,199.0705,17.12131,0.005,NULL,59010638362,922041224,14406894,18.26),(107155,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107155,36.89,0.17,238,45673,70,NULL,NULL,'CGCG 044-046',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000113,NULL,'14.2',0.5,'E+ pec',NULL,NULL,'WAT',NULL,1,199.070916667,7.04631,0.021,NULL,58977472428,921523006,14398796,14.2),(107156,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107156,37.02,0.76,253,45674,70,NULL,NULL,'2MASX J13161802-1025445',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.23',NULL,NULL,NULL,NULL,NULL,NULL,1,199.074917,-10.42911,0.065,NULL,43872699869,685510935,10711108,16.23),(107157,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107157,34.98,0.52,98.9,45675,70,NULL,NULL,'2MASX J13161797-2033561',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,199.074958333,-20.56567,0.269,NULL,43799976724,684374636,10693353,16.7),(107158,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107158,37.75,0.46,355,45676,70,NULL,NULL,'2MASX J13161857+0235186',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00017,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,199.0772917,2.58853,0.012,NULL,58064277412,907254334,14175848,17.7),(107159,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107159,36.69,0.66,218,45677,70,NULL,NULL,'2MASX J13161970-3256361',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.8I',0.2,NULL,NULL,NULL,NULL,NULL,1,199.082166667,-32.94333,0.197,NULL,46872543099,732383485,11443491,14.8),(107160,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107160,37.37,0.46,298,45678,70,NULL,NULL,'2MASX J13161978+0913065',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000157,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,199.0825,9.21864,0,NULL,58975081371,921485646,14398213,16.6),(107161,'IRAS','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107161,33.97,0.8,62.1,45679,75,NULL,'MAT, I','NGC 5051',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'13.99',0.6,'SA(rs)b        HII',NULL,NULL,NULL,NULL,1,199.08375,-28.28569,0.249,NULL,43348657508,677322773,10583168,13.99),(107162,'Sosies','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107162,34.59,0.07,82.8,45679,NULL,NULL,NULL,'NGC 5051',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107163,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107163,33.8,0.43,57.6,45679,75,NULL,'MAT, I, raw','NGC 5051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107164,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107164,33.85,0.32,58.9,45679,85,NULL,'I, raw','NGC 5051',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107165,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107165,33.92,0.32,60.7,45679,85,NULL,'I, inv','NGC 5051',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107166,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107166,33.93,0.43,61,45679,75,NULL,'MAT, I, cor','NGC 5051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107167,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107167,33.96,0.47,61.9,45679,NULL,NULL,'H','NGC 5051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107168,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107168,33.96,0.45,62,45679,NULL,NULL,'K','NGC 5051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107169,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107169,33.97,0.46,62.4,45679,NULL,NULL,'J','NGC 5051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107170,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107170,34.03,0.4,64,45679,NULL,NULL,'mean','NGC 5051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107171,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107171,34.08,0.43,65.5,45679,75,NULL,'MAT, I, inv','NGC 5051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107172,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107172,34.28,0.07,71.9,45679,NULL,NULL,NULL,'NGC 5051',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107173,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107173,37.65,0.17,339,45680,70,NULL,NULL,'VIII Zw 272 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00009,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,199.083917,0.86328,0.033,NULL,58063707741,907245433,14175709,17.1),(107174,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107174,37.16,0.46,270,45681,70,NULL,NULL,'2MASX J13162098-0035460',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000075,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,199.0875,-0.596,0.037,NULL,43090329049,673286391,10520099,17.3),(107175,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107175,38.03,0.33,404,45682,70,NULL,NULL,'2MASX J13162105+4355532',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000149,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,199.087875,43.93133,0,NULL,59308236649,926691197,14479549,17.6),(107176,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107176,36.89,0.17,238,45683,70,NULL,NULL,'CGCG 044-047',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000133,NULL,'15.6',0.27,NULL,NULL,NULL,NULL,NULL,1,199.088167,6.99406,0.03,NULL,58977468575,921522946,14398796,15.6),(107177,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107177,35.31,0.46,115,45684,70,NULL,NULL,'CGCG 072-041',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.000163,NULL,'14.7g',0.65,'E0','Group member',NULL,NULL,NULL,1,199.089333,13.50183,0,NULL,59016742875,922136607,14408384,14.7),(107178,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107178,37.72,0.33,350,45685,70,NULL,NULL,'2MASX J13162189+4412532',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000171,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,199.0912917,44.21489,0,NULL,59307999247,926687488,14479492,17),(107179,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107179,36.79,0.46,228,45686,70,NULL,NULL,'2MASX J13162345+3458351',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000168,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,199.0977083,34.9765,0,NULL,59170398665,924537479,14445898,16.6),(107180,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107180,37.65,0.17,339,45687,70,NULL,NULL,'VIII Zw 272 NOTES02',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000095,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,199.100583,0.85967,0.033,NULL,58063707355,907245427,14175709,17),(107181,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107181,38.61,0.46,527,45688,70,NULL,NULL,'2MASX J13162416+1748387',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.94',0.12,NULL,NULL,NULL,NULL,NULL,1,199.100916667,17.81078,0.012,NULL,59009725064,922026954,14406671,18.94),(107182,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107182,37.65,0.17,339,45689,70,NULL,NULL,'SDSS J131624.51+004904.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000094,NULL,'18.3g',0.09,NULL,NULL,NULL,NULL,NULL,1,199.102167,0.81783,0,NULL,58063661078,907244704,14175698,18.3),(107183,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107183,34.33,0.46,73.6,45690,70,NULL,NULL,'NGC 5057',NULL,'2015arXiv151105856S',2015,1,1.2,NULL,'G',0.000063,NULL,'14.1g',0.98,'S0',NULL,NULL,NULL,NULL,1,199.1157083,31.0315,0.022,NULL,58682098443,916907788,14326684,14.1),(107184,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107184,36.82,0.46,232,45691,70,NULL,NULL,'2MASX J13162776+3940425',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000197,NULL,'16.0g',0.34,NULL,NULL,NULL,NULL,NULL,1,199.115791667,39.67853,0,NULL,59303646770,926619480,14478429,16),(107185,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107185,37.91,0.46,382,45692,70,NULL,NULL,'2MASX J13162886+1300397',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,199.1204583,13.01111,0,NULL,59018005264,922156332,14408692,18.3),(107186,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107186,35.49,0.46,125,45693,70,NULL,NULL,'UGC 08347',NULL,'2015arXiv151105856S',2015,1,0.93,NULL,'G',0.000202,NULL,'14.7g',0.66,'S0:            AGN',NULL,NULL,NULL,NULL,1,199.1242083,52.93369,0.033,NULL,57412345608,897067900,14016685,14.7),(107187,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107187,36.73,0.33,222,45694,70,NULL,NULL,'2MASX J13163014+4400001',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000176,NULL,'16.1g',0.34,'E0',NULL,NULL,NULL,NULL,1,199.1255417,44.00011,0,NULL,59308217539,926690899,14479545,16.1),(107188,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107188,35.73,0.46,140,45695,70,NULL,NULL,'2MASX J13163071+2544531',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000032,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,199.128125,25.748,0.048,NULL,58711645952,917369468,14333897,16.2),(107189,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107189,37.04,0.46,256,45696,70,NULL,NULL,'2MASX J13163227+2747231',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,199.134583333,27.78981,0.046,NULL,58716441883,917444404,14335068,17.6),(107190,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107190,37.65,0.17,339,45697,70,NULL,NULL,'VIII Zw 272 NOTES03',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000093,NULL,'16.4g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,199.135666667,0.87025,0.053,NULL,58063715183,907245549,14175711,16.4),(107191,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107191,38.16,0.46,429,45698,70,NULL,NULL,'2MASX J13163262+6046227',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000145,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,199.135875,60.77311,0.005,NULL,57393249913,896769529,14012023,18.6),(107192,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107192,33.7,0.54,54.8,45699,NULL,NULL,NULL,'SDSS J131634.04-021722.1',NULL,'2009ApJS..182..474S',2009,1,0.61,NULL,'G',0.000013,NULL,'16.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,199.141833333,-2.2895,0.033,NULL,43098316316,673411192,10522049,16.1),(107193,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107193,33.74,0.2,56,45699,74.4,NULL,NULL,'SDSS J131634.04-021722.1',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107194,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107194,33.82,0.51,58,45699,NULL,NULL,'Malmquist cor.','SDSS J131634.04-021722.1',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107195,'GRB','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107195,42.87,NULL,3750,45700,70,NULL,'Pseudo z = 2.9','GRB 020331',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,199.141667,-17.86667,0.169,NULL,43998253556,687472711,10741761,NULL),(107196,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107196,37.65,0.17,339,45701,70,NULL,NULL,'2MASX J13163459+0057160',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000082,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,199.144167,0.95453,0.033,NULL,58063693505,907245211,14175706,17.7),(107197,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107197,34.75,0.48,88.9,45702,NULL,NULL,'Malmquist cor.','UGC 08340',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000013,NULL,'14.57',1,'Scd?',NULL,NULL,NULL,NULL,1,199.147917,-2.09136,0.021,NULL,43099752301,673433629,10522400,14.57),(107198,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107198,34.95,0.44,97.9,45702,NULL,NULL,NULL,'UGC 08340',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107199,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107199,34.99,0.2,99.5,45702,74.4,NULL,NULL,'UGC 08340',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107200,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107200,33.21,NULL,43.9,45703,NULL,NULL,'Dipole + Quadrupole','ESO 219- G 044',NULL,'2010Ap&SS.325..163P',2010,1,1.57,NULL,'G',0.000023,NULL,'16.02',0.13,'Sdm',NULL,NULL,NULL,NULL,1,199.1482083,-52.38481,1.009,NULL,44778468534,699663570,10932243,16.02),(107201,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107201,33.21,NULL,43.9,45703,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 219- G 044',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107202,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107202,33.23,NULL,44.3,45703,NULL,NULL,'Dipole','ESO 219- G 044',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107203,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107203,37.65,0.17,339,45704,70,NULL,NULL,'VIII Zw 272 NOTES04',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000097,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,199.149125,0.86978,0.053,NULL,58063701465,907245335,14175708,16.5),(107204,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107204,36.89,0.17,238,45705,70,NULL,NULL,'2MASX J13163685+0700551',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00021,NULL,'17.11',0.19,NULL,NULL,NULL,NULL,NULL,1,199.153583,7.01519,0.021,NULL,58977463453,921522866,14398794,17.11),(107205,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107205,37.01,0.46,253,45706,70,NULL,NULL,'2MASX J13163761+2855261',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'16.9g',0.31,'E3',NULL,NULL,NULL,NULL,1,199.156667,28.92386,0.048,NULL,58713252246,917394566,14334290,16.9),(107206,'IRAS','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107206,32.79,0.8,36.1,45707,75,NULL,'MAT, I','ESO 269- G 078',NULL,'1997ApJS..109..333W',1997,1,1.3,'Confused HIPASS source','G',0.000033,NULL,'15.07',0.7,'SB(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,199.160083333,-45.89492,0.385,NULL,46955091697,733673307,11463645,15.07),(107207,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107207,32.19,0.32,27.4,45707,85,NULL,'I, inv','ESO 269- G 078',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107208,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107208,32.22,0.32,27.8,45707,85,NULL,'I, raw','ESO 269- G 078',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107209,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107209,32.56,0.43,32.5,45707,75,NULL,'MAT, I, inv','ESO 269- G 078',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107210,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107210,32.6,0.43,33.1,45707,75,NULL,'MAT, I, raw','ESO 269- G 078',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107211,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107211,32.94,0.43,38.7,45707,75,NULL,'MAT, I, cor','ESO 269- G 078',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107212,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107212,33.39,0.11,47.7,45707,NULL,NULL,NULL,'ESO 269- G 078',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107213,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107213,37.64,0.46,337,45708,70,NULL,NULL,'SDSS J131638.56+324244.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000143,NULL,'18.4g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,199.1607083,32.71236,NULL,NULL,59162894606,924420228,14444066,18.4),(107214,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107214,38.7,0.46,549,45709,70,NULL,NULL,'2MASX J13163889+2951511',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,199.16225,29.864,0.026,NULL,58680684687,916885698,14326339,17.9),(107215,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107215,38.41,0.33,481,45710,70,NULL,NULL,'SDSS J131639.06+101630.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'17.9g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,199.16275,10.27506,0,NULL,58975345189,921489768,14398277,17.9),(107216,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107216,35.41,0.46,121,45711,70,NULL,NULL,'CGCG 316-014',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000083,NULL,'15.2g',0.56,'E0',NULL,NULL,NULL,NULL,1,199.1640417,62.63275,0.037,NULL,57359155776,896236809,14003700,15.2),(107217,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107217,37.03,0.23,255,45712,70,NULL,NULL,'VIII Zw 277',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,199.1647083,7.83994,0,NULL,58988099068,921689047,14401391,16.9),(107218,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107218,32.66,NULL,34,45713,NULL,NULL,NULL,'FGC 1587',NULL,'2000BSAO...50....5K',2000,1,0.96,NULL,'G',0.000077,NULL,'17.83',0.09,'Sd',NULL,NULL,NULL,NULL,1,199.17525,26.13183,0.039,NULL,58711694015,917370218,14333909,17.83),(107219,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107219,34.06,NULL,64.8,45713,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1587',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107220,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107220,34.07,NULL,65.3,45713,NULL,NULL,'Dipole + Quadrupole','FGC 1587',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107221,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107221,34.08,NULL,65.3,45713,NULL,NULL,'Dipole','FGC 1587',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107222,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107222,37.02,0.46,253,45714,70,NULL,NULL,'2MASX J13164291+0152570',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000185,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,199.17875,1.88261,0.03,NULL,58065012969,907265827,14176028,16.6),(107223,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107223,38.25,0.46,447,45715,70,NULL,NULL,'2MASX J13164339+6056419',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000182,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,199.181125,60.945,0.005,NULL,57393213716,896768964,14012015,17.3),(107224,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107224,37.59,0.46,330,45716,70,NULL,NULL,'2MASX J13164428+1717189',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,199.184583,17.2885,0.006,NULL,59009754129,922027408,14406678,17.2),(107225,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107225,35.24,0.33,112,45717,70,NULL,NULL,'2MASX J13164519+0633411',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.93',0.2,NULL,NULL,NULL,NULL,NULL,1,199.18825,6.56144,0.061,NULL,58977979451,921530928,14398920,16.93),(107226,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107226,36.5,0.46,200,45718,70,NULL,NULL,'2MASX J13164548+3520341',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000173,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,199.189666667,35.34275,0,NULL,59170552995,924539890,14445935,16.6),(107227,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107227,37.36,0.46,297,45719,70,NULL,NULL,'2MASX J13164666+1242269',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,199.194541667,12.70747,0.005,NULL,59017816574,922153383,14408646,17.3),(107228,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107228,38.09,0.27,415,45720,70,NULL,NULL,'2MASX J13164716+3722255',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00017,NULL,'16.8g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,199.196583,37.37375,0,NULL,59305564701,926649448,14478897,16.8),(107229,'SNIa','2016-12-15 15:15:12','2016-12-16 11:20:24','1','PTF11bas','N',107229,37.88,0.02,347,45721,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF11bas',0.0863,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107230,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107230,37.04,0.46,256,45722,70,NULL,NULL,'2MASX J13164808+6728232',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.0001,NULL,'16.0g',0.36,'E0',NULL,NULL,NULL,NULL,1,199.2000417,67.47322,0.033,NULL,57910618826,904853419,14138334,16),(107231,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107231,36.41,0.46,192,45723,70,NULL,NULL,'2MASX J13164819+0111480',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000078,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,199.200875,1.19658,0.047,NULL,58063641468,907244397,14175693,16.5),(107232,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107232,35.81,0.27,145,45724,70,NULL,NULL,'ARK 411',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.00008,NULL,'14.8g',0.69,NULL,NULL,NULL,NULL,NULL,1,199.200958333,33.97889,0.011,NULL,59171863264,924560363,14446255,14.8),(107233,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107233,37.72,0.33,350,45725,70,NULL,NULL,'2MASX J13164913+4414333',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,199.204875,44.24258,0,NULL,59308002182,926687534,14479492,17.9),(107234,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107234,37.16,0.46,271,45726,70,NULL,NULL,'SDSS J131649.22+100102.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,199.205083,10.01736,0,NULL,58975543652,921492869,14398326,17.6),(107235,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107235,38.09,0.27,415,45727,70,NULL,NULL,'2MASX J13164942+3720425',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000158,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,199.205875,37.34517,0,NULL,59305563497,926649429,14478897,17.1),(107236,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107236,36.58,0.53,207,45728,70,NULL,NULL,'2MASX J13164946-1747407',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.32',NULL,NULL,NULL,NULL,NULL,NULL,1,199.206083,-17.79469,0.173,NULL,43998277596,687473087,10741766,16.32),(107237,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107237,35.96,0.46,156,45729,70,NULL,NULL,'2MASX J13164948+4724073',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000168,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,199.2062083,47.40203,0,NULL,59280352771,926255512,14472742,16.3),(107238,'SNIa','2016-12-15 15:15:12','2016-12-16 11:20:24','1','SN 2004E',NULL,107238,35.74,0.16,137,45730,70,NULL,'SALT 2','KUG 1314+318B',0.029834,'2013MNRAS.433.2240G',2013,1,0.7,NULL,'G',0.000067,NULL,'15.4',0.3,'E7/S01         HII',NULL,NULL,NULL,NULL,1,199.213167,31.58122,0,NULL,58679987819,916874809,14326168,15.4),(107239,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107239,37.63,0.46,335,45731,70,NULL,NULL,'SDSS J131651.45+175647.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,199.214417,17.94642,0.013,NULL,58829369560,919208899,14362639,18.4),(107240,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107240,37.03,0.23,255,45732,70,NULL,NULL,'2MASX J13165157+0743151',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00009,NULL,'16.92',0.26,NULL,NULL,NULL,NULL,NULL,1,199.214833333,7.72078,0,NULL,58988159092,921689985,14401406,16.92),(107241,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107241,37.52,0.46,319,45733,70,NULL,NULL,'SDSS J131652.20-005944.7',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00009,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,199.2175417,-0.99575,0.017,NULL,43099605205,673431331,10522364,18.1),(107242,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107242,38.09,0.27,415,45734,70,NULL,NULL,'2MASX J13165270+3722565',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,199.219541667,37.38233,0,NULL,59305573851,926649591,14478899,17.6),(107243,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107243,36.83,0.56,233,45735,70,NULL,NULL,'2MASX J13165414-0442037',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'17.15',0.21,NULL,NULL,NULL,NULL,NULL,1,199.225375,-4.70128,0.049,NULL,43830388083,684849813,10700778,17.15),(107244,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107244,37.81,0.46,365,45736,70,NULL,NULL,'SDSS J131655.47+081859.8',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.9g',0.29,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,199.231166667,8.31664,0,NULL,58987752339,921683630,14401306,16.9),(107245,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107245,38.04,0.46,406,45737,70,NULL,NULL,'2MASX J13165569+3312116',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.2g',0.24,'E0',NULL,NULL,NULL,NULL,1,199.232125,33.20339,NULL,NULL,59172120246,924564378,14446318,17.2),(107246,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107246,37.05,0.46,257,45738,70,NULL,NULL,'2MASX J13165592+0257510',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000187,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,199.232917,2.96417,0,NULL,58055649513,907119523,14173742,16.7),(107247,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107247,38.38,0.46,473,45739,70,NULL,NULL,'2MASX J13165620+2147135',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,199.234125,21.78711,NULL,NULL,58814725125,918980080,14359063,17.9),(107248,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107248,37.57,0.46,326,45740,70,NULL,NULL,'2MASX J13165661+4248163',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000171,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,199.2357917,42.80467,0,NULL,59311342450,926739725,14480308,17.7),(107249,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107249,37.23,0.46,279,45741,70,NULL,NULL,'2MASX J13165671+1731589',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,199.2362917,17.53308,0.024,NULL,59009918416,922029975,14406718,17.4),(107250,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107250,31.9,0.43,24,45742,75,NULL,'3.6 micron, color + selection bias corrected','ESO 508- G 034',NULL,'2014MNRAS.444..527S',2014,1,1.2,NULL,'G',0.00001,NULL,'14.73',0.6,'SAB(s)m:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,199.238875,-25.33722,0.321,NULL,43344293375,677254583,10582102,14.73),(107251,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107251,31.99,0.43,25,45742,75,NULL,'3.6 micron, color corrected','ESO 508- G 034',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107252,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107252,32.04,0.2,25.6,45742,74.4,NULL,NULL,'ESO 508- G 034',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107253,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107253,32.31,0.6,29,45742,NULL,NULL,NULL,'ESO 508- G 034',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107254,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107254,32.54,0.54,32.2,45742,NULL,NULL,'Malmquist cor.','ESO 508- G 034',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107255,'Sosies','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107255,30.84,0.23,14.7,45743,NULL,NULL,NULL,'NGC 5054',NULL,'2002A&A...393...57T',2002,1,5.1,NULL,'G',0.000007,NULL,'10.8B',3,'SA(s)bc;BrClG','Group member',NULL,NULL,NULL,1,199.2437083,-16.63486,0.121,NULL,43998928463,687483257,10741925,10.8),(107256,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107256,30.46,0.69,12.4,45743,100,NULL,'mid-IR','NGC 5054',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107257,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107257,30.68,NULL,13.7,45743,65.2,NULL,'CO','NGC 5054',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107258,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107258,31.18,0.4,17.2,45743,NULL,NULL,NULL,'NGC 5054',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107259,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107259,31.18,0.4,17.2,45743,NULL,NULL,NULL,'NGC 5054',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107260,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107260,31.22,NULL,17.5,45743,NULL,NULL,'B','NGC 5054',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107261,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107261,31.23,0.43,17.6,45743,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5054',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107262,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107262,31.25,0.43,17.8,45743,75,NULL,'3.6 micron, color corrected','NGC 5054',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107263,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107263,31.3,0.2,18.2,45743,74.4,NULL,NULL,'NGC 5054',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107264,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107264,31.34,0.47,18.6,45743,NULL,NULL,'H','NGC 5054',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107265,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107265,31.36,0.45,18.7,45743,NULL,NULL,'K','NGC 5054',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107266,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107266,31.37,0.46,18.8,45743,NULL,NULL,'J','NGC 5054',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107267,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107267,31.59,NULL,20.8,45743,54,NULL,'HI','NGC 5054',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107268,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107268,32.06,NULL,25.8,45743,NULL,NULL,'LEDA [April 2006]','NGC 5054',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107269,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107269,32.07,0.4,26,45743,NULL,NULL,'mean','NGC 5054',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107270,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107270,32.18,0.4,27.3,45743,75,NULL,'B','NGC 5054',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107271,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107271,37.61,0.33,333,45744,70,NULL,NULL,'2MASX J13165985+4029274',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000194,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,199.2494583,40.49097,0,NULL,59301813580,926590837,14477981,17.6),(107272,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107272,37.12,0.46,266,45745,70,NULL,NULL,'SDSS J131659.93+644341.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000069,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,199.24975,64.72828,0.037,NULL,57351761197,896121268,14001894,17.8),(107273,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107273,37.65,0.17,339,45746,70,NULL,NULL,'2MASX J13170040+0055319',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000089,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,199.251583,0.92544,0.053,NULL,58063836493,907247445,14175741,16.7),(107274,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107274,35.61,0.61,132,45747,70,NULL,NULL,'2MASX J13170043-3328087',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.9b',NULL,'SB',NULL,NULL,NULL,NULL,1,199.2517917,-33.46911,0.213,NULL,46873425588,732397274,11443707,15.9),(107275,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107275,38.93,0.46,612,45748,70,NULL,NULL,'SDSS J131700.78+661159.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000087,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,199.253291667,66.19978,0.025,NULL,57876532851,904320825,14130012,18.1),(107276,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107276,38.41,0.33,481,45749,70,NULL,NULL,'SDSS J131701.10+101623.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,199.254583,10.27317,0,NULL,58975385257,921490394,14398287,18.1),(107277,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107277,32.75,0.43,35.5,45750,75,NULL,'3.6 micron, color + selection bias corrected','IC 4216',NULL,'2014MNRAS.444..527S',2014,1,1.9,'Marginal HIPASS detection.','G',0.000017,NULL,'13.69',0.8,'SAB(rs)cd',NULL,NULL,NULL,NULL,1,199.2577917,-10.77,0.061,NULL,43864794107,685387407,10709178,13.69),(107278,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107278,36.76,0.46,225,45751,70,NULL,NULL,'UGC 08345 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000191,NULL,'16.0g',0.41,'E0','Pair member (points to parent)',NULL,NULL,NULL,1,199.2582083,12.54686,0.008,NULL,59017722066,922151907,14408623,16),(107279,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107279,38.23,0.46,442,45752,70,NULL,NULL,'2MASX J13170285+5940318',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,199.261875,59.67569,0,NULL,57391704073,896745376,14011646,17.8),(107280,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107280,34.56,0.5,81.8,45753,NULL,NULL,'Malmquist cor.','IC 4218',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000017,NULL,'14.90',0.3,'Sa             Sy1',NULL,NULL,NULL,'Sy 1.2',1,199.264208333,-2.26128,0.029,NULL,43098372128,673412064,10522063,14.9),(107281,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107281,34.63,0.49,84.3,45753,NULL,NULL,NULL,'IC 4218',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107282,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107282,34.67,0.2,85.9,45753,74.4,NULL,NULL,'IC 4218',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107283,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107283,34.69,0.4,86.7,45753,NULL,NULL,'mean','IC 4218',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107284,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107284,34.8,0.47,91,45753,NULL,NULL,'H','IC 4218',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107285,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107285,34.81,0.45,91.5,45753,NULL,NULL,'K','IC 4218',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107286,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107286,34.92,0.46,96.4,45753,NULL,NULL,'J','IC 4218',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107287,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107287,39.5,0.46,795,45754,70,NULL,NULL,'2MASX J13170396+2805229',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,199.266541667,28.08958,0.079,NULL,58716372261,917443316,14335051,17.7),(107288,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107288,36.73,0.33,222,45755,70,NULL,NULL,'2MASX J13170596+4357133',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000182,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,199.27475,43.95367,0,NULL,59308231109,926691111,14479548,16.5),(107289,'IRAS','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107289,32.84,0.8,36.9,45756,75,NULL,'MAT, I','MCG -03-34-041',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.000007,NULL,'15',0.3,'Sc: sp','X-ray-bright group member',NULL,NULL,NULL,1,199.2755417,-16.25219,0.121,NULL,44001918771,687529980,10742655,15),(107290,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107290,32.83,0.2,36.8,45756,74.4,NULL,NULL,'MCG -03-34-041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107291,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107291,32.83,0.49,36.9,45756,75,NULL,'IR','MCG -03-34-041',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107292,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107292,32.93,0.43,38.6,45756,75,NULL,'3.6 micron, color corrected','MCG -03-34-041',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107293,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107293,32.98,0.43,39.4,45756,75,NULL,'3.6 micron, color + selection bias corrected','MCG -03-34-041',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107294,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107294,33.05,0.15,40.8,45756,NULL,NULL,NULL,'MCG -03-34-041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107295,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107295,33.29,0.32,45.6,45756,85,NULL,'I, raw','MCG -03-34-041',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107296,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107296,33.31,0.4,45.9,45756,NULL,NULL,NULL,'MCG -03-34-041',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107297,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107297,33.33,NULL,46.3,45756,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -03-34-041',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107298,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107298,33.33,0.32,46.3,45756,85,NULL,'I, inv','MCG -03-34-041',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107299,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107299,33.33,NULL,46.4,45756,NULL,NULL,'Dipole + Quadrupole','MCG -03-34-041',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107300,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107300,33.34,NULL,46.5,45756,NULL,NULL,'Dipole','MCG -03-34-041',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107301,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107301,33.34,0.43,46.6,45756,75,NULL,'MAT, I, raw','MCG -03-34-041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107302,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107302,33.5,0.43,50.2,45756,75,NULL,'MAT, I, inv','MCG -03-34-041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107303,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107303,33.62,0.43,53.1,45756,75,NULL,'MAT, I, cor','MCG -03-34-041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107304,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107304,33.67,NULL,54.1,45756,NULL,NULL,NULL,'MCG -03-34-041',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107305,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107305,37.62,0.27,334,45757,70,NULL,NULL,'2MASX J13170753-0134111',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000086,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,199.281375,-1.56964,0.025,NULL,43099729434,673433272,10522394,17.2),(107306,'Tully est','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107306,33.09,0.8,41.5,45758,75,NULL,'B','IC 0875',NULL,'1988NBGC.C....0000T',1988,1,1.2,NULL,'G',0.00016,NULL,'13.8g',1.1,'S0','in a pair',NULL,NULL,NULL,1,199.281541667,57.53944,0,NULL,57436765895,897449467,14022647,13.8),(107307,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107307,37.96,0.21,390,45759,70,NULL,NULL,'2MASX J13170825+0936237',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,199.2842917,9.60658,0,NULL,58975126285,921486348,14398224,17.5),(107308,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107308,38.19,0.46,435,45760,70,NULL,NULL,'2MASX J13170899+0515259',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,199.2875,5.25719,0.03,NULL,58932408015,920818875,14387794,17.7),(107309,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107309,38.92,0.46,609,45761,70,NULL,NULL,'SDSS J131709.23-010945.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000096,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,199.288458333,-1.16261,0.017,NULL,43099387775,673427933,10522311,18.4),(107310,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107310,36.89,0.17,238,45762,70,NULL,NULL,'SDSS J131709.76+070945.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,199.290708333,7.16256,0.021,NULL,58985042286,921641285,14400645,17.9),(107311,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107311,35.74,0.46,141,45763,70,NULL,NULL,'2MASX J13171047+6152090',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000161,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,199.2935,61.86925,0.025,NULL,57358165890,896221342,14003458,16.3),(107312,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107312,37.92,0.46,384,45764,70,NULL,NULL,'2MASX J13171062+6317160',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000079,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,199.2944583,63.28778,0.005,NULL,57360361240,896255644,14003994,17.4),(107313,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107313,37.84,0.46,369,45765,70,NULL,NULL,'2MASX J13171134+5914168',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,199.297625,59.23808,0,NULL,57388756873,896699326,14010926,17.6),(107314,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107314,31.57,0.69,20.6,45766,100,NULL,'mid-IR','IC 0863',NULL,'2013ApJ...771...88L',2013,1,1.8,NULL,'G',0.00001,NULL,'14.24',1.2,'SAB(r)a        HII','X-ray-bright group member',NULL,NULL,NULL,1,199.301667,-17.25447,0.157,NULL,43999232894,687488013,10742000,14.24),(107315,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107315,37.98,0.46,395,45767,70,NULL,NULL,'SDSS J131712.77+510551.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00005,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,199.30325,51.0975,0,NULL,59090271989,923285499,14426335,18.4),(107316,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107316,36.92,0.27,242,45768,70,NULL,NULL,'2MASX J13171365+4114373',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000165,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,199.3069583,41.24369,0,NULL,59302181319,926596583,14478071,16.8),(107317,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107317,35.24,0.33,112,45769,70,NULL,NULL,'CGCG 044-054',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.0001,NULL,'15.5',0.29,NULL,NULL,NULL,NULL,NULL,1,199.3145417,6.40169,0.02,NULL,58978202719,921534417,14398975,15.5),(107318,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107318,34.51,0.69,79.8,45770,NULL,NULL,NULL,'NGC 5060',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.05',0.8,'SB(s)b',NULL,NULL,NULL,NULL,1,199.317583333,6.03744,0,NULL,58977804789,921528199,14398878,14.05),(107319,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107319,34.55,0.2,81.3,45770,74.4,NULL,NULL,'NGC 5060',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107320,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107320,34.63,0.66,84.3,45770,NULL,NULL,'Malmquist cor.','NGC 5060',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107321,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107321,38.22,0.46,440,45771,70,NULL,NULL,'2MASX J13171632+4158563',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000165,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,199.318125,41.98231,0,NULL,59301477329,926585583,14477899,18.4),(107322,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107322,38.77,0.46,569,45772,70,NULL,NULL,'SDSS J131716.65+030300.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'18.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,199.319375,3.05014,0,NULL,58055610600,907118915,14173733,18.1),(107323,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107323,37.81,0.46,365,45773,70,NULL,NULL,'2MASX J13171697+2820079',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,199.320625,28.33556,0.049,NULL,58714529564,917414524,14334601,17.9),(107324,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107324,36.33,0.68,185,45774,70,NULL,NULL,'2MASX J13171712-1746152',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,199.321417,-17.77089,0.173,NULL,43775998987,683999984,10687499,15.4),(107325,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107325,38.07,0.46,411,45775,70,NULL,NULL,'SDSS J131717.80+112837.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000178,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,199.324167,11.47706,0,NULL,58943256156,920988377,14390443,18.4),(107326,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107326,37.61,0.33,333,45776,70,NULL,NULL,'2MASX J13171946+4027453',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,199.331333,40.46258,0,NULL,59301765609,926590087,14477970,17.9),(107327,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107327,37.78,0.46,359,45777,70,NULL,NULL,'2MASX J13171985+2616430',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000173,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,199.332625,26.27861,0.034,NULL,58710963931,917358811,14333731,17.5),(107328,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107328,38.03,0.33,404,45778,70,NULL,NULL,'2MASX J13172163+3805393',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000138,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,199.340083,38.09439,0,NULL,59305706334,926651661,14478932,18.4),(107329,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107329,36.71,0.33,220,45779,70,NULL,NULL,'2MASX J13172206+2853460',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000216,NULL,'15.8g',0.42,'E',NULL,NULL,NULL,NULL,1,199.3420417,28.89608,0.034,NULL,58715152962,917424265,14334754,15.8),(107330,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107330,36.5,0.46,199,45780,70,NULL,NULL,'2MASX J13172217+0650318',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000187,NULL,'17.57',0.16,NULL,NULL,NULL,NULL,NULL,1,199.3422917,6.84214,0.037,NULL,58977579768,921524683,14398823,17.57),(107331,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107331,36.31,0.46,183,45781,70,NULL,NULL,'2MASX J13172240+2707280',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000183,NULL,'17.08',0.39,NULL,NULL,NULL,NULL,NULL,1,199.3435417,27.12442,0.039,NULL,58716678240,917448097,14335126,17.08),(107332,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107332,36.46,0.46,196,45782,70,NULL,NULL,'2MASX J13172250+5013593',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,199.344,50.233,0,NULL,59089936522,923280258,14426254,17.3),(107333,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107333,37.86,0.46,373,45783,70,NULL,NULL,'SDSS J131723.04+670241.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00009,NULL,'18.6g',0.11,'NLAGN',NULL,NULL,NULL,NULL,1,199.3460417,67.045,0.029,NULL,57910248994,904847640,14138244,18.6),(107334,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107334,36.85,0.46,234,45784,70,NULL,NULL,'2MASX J13172357+6704233',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000091,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,199.348625,67.07325,0.029,NULL,57910463837,904850997,14138296,16.7),(107335,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107335,37.2,0.46,276,45785,70,NULL,NULL,'2MASX J13172433+6231229',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000154,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,199.3512917,62.52308,0.041,NULL,57359131762,896236433,14003694,17.2),(107336,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107336,37.03,0.46,254,45786,70,NULL,NULL,'2MASX J13172479+0551509',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,199.35325,5.86433,0,NULL,58977755543,921527430,14398866,17.5),(107337,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107337,38.35,0.46,468,45787,70,NULL,NULL,'2MASX J13172542+3451146',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000181,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,199.355875,34.85417,0,NULL,59170588220,924540440,14445944,17.7),(107338,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107338,37.88,0.46,377,45788,70,NULL,NULL,'2MASX J13172545+1042147',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.59',0.16,NULL,NULL,NULL,NULL,NULL,1,199.356125,10.70425,0,NULL,58942838556,920981852,14390341,18.59),(107339,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107339,37.62,0.27,334,45789,70,NULL,NULL,'2MASX J13172795-0130340',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000213,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,199.3665,-1.50944,0.021,NULL,43099850499,673435164,10522424,17.1),(107340,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107340,37.56,0.21,326,45790,70,NULL,NULL,'2MASX J13172888+4232561',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,199.370375,42.54906,0,NULL,59311180156,926737189,14480268,17.4),(107341,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107341,37.03,0.23,255,45791,70,NULL,NULL,'2MASX J13172898+0743269',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.89',0.15,NULL,NULL,NULL,NULL,NULL,1,199.370833,7.724,0,NULL,58988105309,921689145,14401392,17.89),(107342,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107342,35.74,0.33,141,45792,70,NULL,NULL,'ARK 412',NULL,'2015arXiv151105856S',2015,1,0.99,NULL,'G',0.00007,NULL,'14.9g',0.6,'E0',NULL,NULL,NULL,NULL,1,199.3754583,47.78314,0,NULL,59288840817,926388137,14474814,14.9),(107343,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107343,36.32,0.46,183,45793,70,NULL,NULL,'2MASX J13173050+0012321',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000081,NULL,'16.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,199.377041667,0.20886,0.056,NULL,58058629110,907166079,14174469,16.5),(107344,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107344,37.56,0.21,326,45794,70,NULL,NULL,'2MASX J13173061+4227311',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000155,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,199.3774583,42.45872,0,NULL,59311156157,926736814,14480262,17),(107345,'IRAS','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107345,34.33,0.8,73.3,45795,75,NULL,'HMCL, I','NGC 5065',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000004,NULL,'14.20',0.8,'Sd             HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,199.3775417,31.09269,0.011,NULL,58682005465,916906335,14326661,14.2),(107346,'IRAS','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107346,34.34,0.8,73.6,45795,75,NULL,'A82, H','NGC 5065',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107347,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107347,34.14,0.2,67.3,45795,74.4,NULL,NULL,'NGC 5065',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107348,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107348,34.27,0.4,71.4,45795,75,NULL,'HMCL, I, raw','NGC 5065',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107349,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107349,34.31,0.51,72.8,45795,NULL,NULL,NULL,'NGC 5065',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107350,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107350,34.41,0.47,76.1,45795,75,NULL,'A82, H, raw','NGC 5065',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107351,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107351,34.43,0.4,77,45795,75,NULL,'HMCL, I, inv','NGC 5065',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107352,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107352,34.46,0.48,78.1,45795,NULL,NULL,'Malmquist cor.','NGC 5065',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107353,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107353,34.51,0.47,79.8,45795,75,NULL,'A82, H, inv','NGC 5065',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107354,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107354,34.67,0.4,85.9,45795,75,NULL,'HMCL, I, cor','NGC 5065',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107355,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107355,34.85,0.47,93.2,45795,75,NULL,'A82, H, cor','NGC 5065',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107356,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107356,37.58,0.46,328,45796,70,NULL,NULL,'2MASXi J1317307+675617',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000075,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,199.378083333,67.93814,0.033,NULL,57909945790,904842902,14138170,18),(107357,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107357,35.74,0.33,141,45797,70,NULL,NULL,'MCG +08-24-100',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000165,NULL,'15.7g',0.45,'S0/a',NULL,NULL,NULL,NULL,1,199.38175,47.67664,0,NULL,59288834359,926388036,14474813,15.7),(107358,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107358,37.11,0.46,265,45798,70,NULL,NULL,'IC 0869 NED02',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,199.381833,20.67758,0.058,NULL,58839892869,919373326,14365208,16.3),(107359,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107359,37.18,0.46,273,45799,70,NULL,NULL,'2MASX J13173255+5948038',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000165,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,199.385541667,59.80094,0,NULL,57391689620,896745150,14011642,16.6),(107360,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107360,36.71,0.33,220,45800,70,NULL,NULL,'2MASX J13173256+2859121',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000123,NULL,'16.5g',0.26,'E1',NULL,NULL,NULL,NULL,1,199.385583333,28.98681,0.034,NULL,58715877386,917435584,14334931,16.5),(107361,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107361,37.37,0.46,298,45801,70,NULL,NULL,'2MASX J13173353+3629193',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000196,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,199.389583,36.48875,0,NULL,59158570600,924352665,14443010,16.4),(107362,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107362,35.81,0.27,145,45802,70,NULL,NULL,'2MASX J13173503+3349527',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000083,NULL,'16.24',0.29,NULL,NULL,NULL,NULL,NULL,1,199.3960417,33.83128,0.013,NULL,59171936829,924561512,14446273,16.24),(107363,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107363,36.7,0.46,219,45803,70,NULL,NULL,'2MASX J13173555+0945049',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000184,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,199.398083,9.75128,0,NULL,58974349748,921474214,14398034,16.8),(107364,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107364,37.44,0.46,308,45804,70,NULL,NULL,'SDSS J131735.60+110159.2',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.29,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,199.398375,11.03314,0,NULL,58942943689,920983495,14390367,16.8),(107365,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107365,37.3,0.46,288,45805,70,NULL,NULL,'2MASX J13173672+5328067',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000145,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,199.40325,53.4685,0.026,NULL,57415795158,897121799,14017528,17.6),(107366,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107366,37.03,0.23,255,45806,70,NULL,NULL,'2MASX J13173706+0738449',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.43',0.19,NULL,NULL,NULL,NULL,NULL,1,199.404375,7.64586,0.053,NULL,58987993142,921687392,14401365,17.43),(107367,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107367,37.62,0.27,334,45807,70,NULL,NULL,'2MASX J13173729-0134550',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00015,NULL,'17.18',0.3,NULL,NULL,NULL,NULL,NULL,1,199.405375,-1.58197,0.021,NULL,43099860520,673435320,10522426,17.18),(107368,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107368,34.55,0.46,81.3,45808,70,NULL,NULL,'MRK 0250',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000084,NULL,'15.1g',0.54,'Sbrst',NULL,NULL,NULL,NULL,1,199.408333,43.81064,0,NULL,59308131574,926689555,14479524,15.1),(107369,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107369,38.02,0.46,401,45809,70,NULL,NULL,'2MASX J13173834+5125107',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,199.409875,51.41967,0,NULL,59089528703,923273885,14426154,17.5),(107370,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107370,37.71,0.46,348,45810,70,NULL,NULL,'LCRS B131504.0-023219',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000084,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,199.411417,-2.80189,0.029,NULL,43097682787,673401293,10521895,17.9),(107371,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107371,36.92,0.27,242,45811,70,NULL,NULL,'B3 1315+415',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000199,NULL,'15.7g',0.4,'PEG',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,199.413291667,41.26267,0,NULL,59302176195,926596503,14478070,15.7),(107372,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107372,35.83,0.59,146,45812,70,NULL,NULL,'2MASX J13173923-1416502',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.09',NULL,NULL,NULL,NULL,NULL,NULL,1,199.413417,-14.28064,0.129,NULL,44003351510,687552367,10743005,16.09),(107373,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107373,37.21,0.46,277,45813,70,NULL,NULL,'2MASX J13174004+6801182',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000097,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,199.416875,68.02161,0.033,NULL,57909725757,904839464,14138116,17.3),(107374,'IRAS','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107374,31.58,0.8,20.7,45814,75,NULL,'MAT, I','ESO 382- G 031',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.00002,NULL,'14.50',0.4,'SB(s)d: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,199.417375,-37.28133,0.181,NULL,46939729855,733433278,11459894,14.5),(107375,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107375,31.16,0.32,17.1,45814,85,NULL,'I, inv','ESO 382- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107376,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107376,31.2,0.32,17.4,45814,85,NULL,'I, raw','ESO 382- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107377,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107377,31.38,0.4,18.9,45814,NULL,NULL,NULL,'ESO 382- G 031',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107378,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107378,31.38,0.4,18.9,45814,73,NULL,'opt','ESO 382- G 031',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107379,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107379,31.51,0.43,20,45814,75,NULL,'MAT, I, inv','ESO 382- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107380,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107380,31.54,0.2,20.3,45814,74.4,NULL,NULL,'ESO 382- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107381,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107381,31.57,0.43,20.6,45814,75,NULL,'MAT, I, raw','ESO 382- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107382,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107382,31.92,0.43,24.2,45814,75,NULL,'MAT, I, cor','ESO 382- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107383,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107383,36.74,0.56,222,45815,70,NULL,NULL,'2MASX J13174070-1415146',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,199.419583,-14.25417,0.129,NULL,44003351813,687552372,10743005,17.1),(107384,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107384,37.62,0.33,334,45816,70,NULL,NULL,'SDSS J131741.25+485327.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000154,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,199.421917,48.891,0,NULL,59275855391,926185240,14471644,18.5),(107385,'IRAS','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107385,35.28,0.8,114,45817,75,NULL,'MAT, I','ESO 382- G 032',NULL,'1997ApJS..109..333W',1997,1,2.15,NULL,'G',0.000033,NULL,'15.5',0.28,'Sc',NULL,NULL,NULL,NULL,1,199.4252917,-34.35369,0.133,NULL,46874714342,732417411,11444022,15.5),(107386,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107386,35.06,0.43,103,45817,75,NULL,'MAT, I, raw','ESO 382- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107387,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107387,35.06,NULL,103,45817,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 382- G 032',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107388,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107388,35.07,NULL,103,45817,NULL,NULL,'Dipole + Quadrupole','ESO 382- G 032',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107389,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107389,35.08,0.49,104,45817,75,NULL,'IR','ESO 382- G 032',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107390,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107390,35.08,NULL,104,45817,NULL,NULL,'Dipole','ESO 382- G 032',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107391,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107391,35.09,0.77,104,45817,NULL,NULL,'Malmquist cor.','ESO 382- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107392,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107392,35.12,NULL,106,45817,NULL,NULL,NULL,'ESO 382- G 032',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107393,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107393,35.29,0.32,114,45817,85,NULL,'I, raw','ESO 382- G 032',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107394,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107394,35.36,0.32,118,45817,85,NULL,'I, inv','ESO 382- G 032',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107395,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107395,35.36,0.43,118,45817,75,NULL,'MAT, I, inv','ESO 382- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107396,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107396,35.36,0.43,118,45817,75,NULL,'MAT, I, cor','ESO 382- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107397,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107397,35.43,0.66,122,45817,NULL,NULL,NULL,'ESO 382- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107398,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107398,35.47,0.2,124,45817,74.4,NULL,NULL,'ESO 382- G 032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107399,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107399,37.65,0.46,339,45818,70,NULL,NULL,'2MASX J13174257+3342007',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000182,NULL,'16.9g',0.28,'E2',NULL,NULL,NULL,NULL,1,199.427583,33.70014,0.013,NULL,59171983856,924562247,14446285,16.9),(107400,'Sosies','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107400,32.18,0.42,27.3,45819,NULL,NULL,NULL,'IC 4214',NULL,'2002A&A...393...57T',2002,1,2.2,NULL,'G',0.000007,NULL,'12.16',1.3,'(R\'_1)SAB(r)a',NULL,NULL,NULL,NULL,1,199.427875,-32.10169,0.241,NULL,46869218062,732331532,11442680,12.16),(107401,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107401,31.12,0.69,16.7,45819,100,NULL,'mid-IR','IC 4214',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107402,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107402,32.63,0.43,33.6,45819,75,NULL,'3.6 micron, color corrected','IC 4214',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107403,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107403,32.65,0.2,33.9,45819,74.4,NULL,NULL,'IC 4214',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107404,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107404,32.71,0.43,34.8,45819,75,NULL,'3.6 micron, color + selection bias corrected','IC 4214',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107405,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107405,31.98,NULL,24.9,45820,72,NULL,NULL,'UM 559',NULL,'2014Ap.....57..457K',2014,1,0.87,'Multiple SDSS entries describe this object.','G',0.000033,NULL,'16.27',0.26,NULL,NULL,NULL,NULL,NULL,1,199.428333,-1.00028,0.021,NULL,43099458607,673429040,10522328,16.27),(107406,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107406,37.57,0.46,326,45821,70,NULL,NULL,'2MASX J13174470+0841359',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.40',0.18,NULL,NULL,NULL,NULL,NULL,1,199.436208333,8.69342,0,NULL,58985866819,921654169,14400846,18.4),(107407,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107407,38.46,0.46,492,45822,70,NULL,NULL,'2MASX J13174501+2805090',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,199.437583333,28.08578,0.038,NULL,58714720413,917417506,14334648,18),(107408,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107408,35.1,0.4,105,45823,NULL,NULL,'mean','UGC 08359',NULL,'2007A&A...465...71T',2007,1,1.21,NULL,'G',0.000037,NULL,'14.6g',0.56,'Sab            AGN',NULL,NULL,NULL,NULL,1,199.438291667,27.56986,0.036,NULL,58717010022,917453281,14335207,14.6),(107409,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107409,35.26,0.47,113,45823,NULL,NULL,'H','UGC 08359',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107410,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107410,35.39,0.51,120,45824,70,NULL,NULL,'MCG -04-31-046',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.000137,NULL,'15',0.15,NULL,NULL,NULL,NULL,NULL,1,199.4385417,-24.31964,0.377,NULL,43310632764,676728636,10573884,15),(107411,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107411,35.09,0.54,104,45825,70,NULL,NULL,'MCG -02-34-016',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.000057,NULL,'15',0.2,'Sc',NULL,NULL,NULL,NULL,1,199.44225,-15.50864,0.125,NULL,44001038982,687516234,10742441,15),(107412,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107412,35.81,0.27,145,45826,70,NULL,NULL,'2MASX J13174618+3350157',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000167,NULL,'15.9g',0.32,NULL,NULL,NULL,NULL,NULL,1,199.442458333,33.83756,0.013,NULL,59171945116,924561642,14446275,15.9),(107413,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107413,35.2,0.5,110,45827,70,NULL,NULL,'ESO 382- G 033',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.00015,NULL,'14.59',0.8,'(R\')SA(s)0/a',NULL,NULL,NULL,NULL,1,199.448125,-37.66078,0.201,NULL,46940414425,733443975,11460062,14.59),(107414,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107414,38.18,0.46,433,45828,70,NULL,NULL,'2MASX J13174766+4818187',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000185,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,199.448417,48.30525,0,NULL,59275070006,926172968,14471452,17.2),(107415,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107415,37.52,0.46,319,45829,70,NULL,NULL,'2MASX J13174913+3955445',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000166,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,199.4545417,39.929,0,NULL,59304086941,926626358,14478536,16.9),(107416,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107416,37.98,0.46,394,45830,70,NULL,NULL,'2MASX J13174920+0250451',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000199,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,199.454917,2.84586,0,NULL,58063949717,907249214,14175768,16.8),(107417,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107417,37.56,0.21,326,45831,70,NULL,NULL,'2MASX J13175094+4226131',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000175,NULL,'16.8g',0.33,NULL,NULL,NULL,NULL,NULL,1,199.462333,42.43694,0,NULL,59311158872,926736857,14480263,16.8),(107418,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107418,38.03,0.33,404,45832,70,NULL,NULL,'2MASX J13175104+3757535',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000024,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,199.4625,37.96478,0,NULL,59306304554,926661008,14479078,17.2),(107419,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107419,37.35,0.23,295,45833,70,NULL,NULL,'2MASX J13175114+1446301',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000167,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,199.4630417,14.77514,0,NULL,59018960433,922171256,14408925,16.7),(107420,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107420,37.56,0.21,326,45834,70,NULL,NULL,'2MASX J13175166+4225491',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000178,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,199.465541667,42.43036,0,NULL,59311159118,926736861,14480263,17.5),(107421,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107421,35.93,0.54,154,45835,70,NULL,NULL,'2MASX J13175191-1421406',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,199.4662917,-14.36125,0.097,NULL,44003336993,687552140,10743002,16.1),(107422,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107422,36.91,0.46,241,45836,70,NULL,NULL,'VIII Zw 282 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000187,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,199.473583,2.21806,0.071,NULL,58064734806,907261481,14175960,16.5),(107423,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107423,37.77,0.46,358,45837,70,NULL,NULL,'2MASX J13175728+1705511',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.61',0.14,NULL,NULL,NULL,NULL,NULL,1,199.4887083,17.09753,0,NULL,59010556058,922039938,14406874,18.61),(107424,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107424,38.31,0.33,459,45838,70,NULL,NULL,'2MASX J13175729+1748581',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.94',0.12,NULL,NULL,NULL,NULL,NULL,1,199.488875,17.81611,0.007,NULL,58829567257,919211988,14362687,18.94),(107425,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107425,38.31,0.33,459,45839,70,NULL,NULL,'2MASX J13175869+1748181',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,199.494708333,17.80506,0.007,NULL,58829569255,919212019,14362687,17.8),(107426,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107426,37.42,0.27,305,45840,70,NULL,NULL,'SDSS J131758.90+662704.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000056,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,199.495417,66.45133,0.033,NULL,57876464613,904319759,14129996,18.2),(107427,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107427,37.76,0.46,356,45841,70,NULL,NULL,'2MASX J13175897+1936563',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,199.495916667,19.61575,0.065,NULL,58840086163,919376346,14365255,17.8),(107428,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107428,37.35,0.23,295,45842,70,NULL,NULL,'2MASX J13175969+1441531',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000155,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,199.498625,14.69808,0,NULL,59018941481,922170960,14408921,17.2),(107429,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107429,37.35,0.46,296,45843,70,NULL,NULL,'2MASX J13175978+2247253',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,199.499291667,22.79044,NULL,NULL,58813063298,918954114,14358658,16.7),(107430,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107430,37.35,0.23,295,45844,70,NULL,NULL,'2MASX J13180127+1444101',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000179,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,199.505458333,14.73619,0,NULL,59018944015,922171000,14408921,16.5),(107431,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107431,37.35,0.23,295,45845,70,NULL,NULL,'2MASX J13180189+1447101',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,199.508125,14.78611,0,NULL,59018956803,922171200,14408925,17.8),(107432,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107432,37.88,0.46,377,45846,70,NULL,NULL,'2MASX J13180214+3817485',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,199.508875,38.29675,0,NULL,59305877084,926654329,14478973,17),(107433,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107433,39.09,0.46,659,45847,70,NULL,NULL,'2MASX J13180216+1413501',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,199.5090417,14.23056,0,NULL,59018998946,922171858,14408935,17.7),(107434,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107434,37.37,0.46,298,45848,70,NULL,NULL,'2MASX J13180415+6611401',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000068,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,199.517625,66.19444,0.033,NULL,57876503525,904320367,14130005,17.9),(107435,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107435,37.48,0.46,313,45849,70,NULL,NULL,'SDSS J131804.52+005622.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000064,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,199.518875,0.93953,0.037,NULL,58063741237,907245956,14175718,17.9),(107436,'SNIa','2016-12-15 15:15:12','2016-12-16 11:20:24','1','SN 1996X',NULL,107436,31.36,0.35,18.6,45850,74.2,NULL,'SALT 2','NGC 5061',0.00689,'2010ApJ...716..712A',2010,1,3.5,'1994A&A...286..389H has z = 0.008876 +- 0.000030.','G',0.000063,NULL,'11.44',3,'E0','X-ray-faint group member',NULL,NULL,NULL,1,199.521125,-26.83722,0.253,NULL,43346630236,677291097,10582673,11.44),(107437,'SNIa','2016-12-15 15:15:12','2016-12-16 11:20:24','1','SN 1996X',NULL,107437,31.97,0.17,24.6,45850,72,NULL,NULL,'NGC 5061',0.00689,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107438,'SNIa','2016-12-15 15:15:12','2016-12-16 11:20:24','1','SN 1996X',NULL,107438,32.01,0.09,25.2,45850,74.4,NULL,NULL,'NGC 5061',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107439,'SNIa','2016-12-15 15:15:12','2016-12-16 11:20:24','1','SN 1996X',NULL,107439,32.11,0.35,26.2,45850,70,NULL,'SALT','NGC 5061',0.00689,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107440,'SNIa','2016-12-15 15:15:12','2016-12-16 11:20:24','1','SN 1996X',NULL,107440,32.21,0.07,27.7,45850,60,NULL,'M(I) = -19.19 mag','NGC 5061',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107441,'SNIa','2016-12-15 15:15:12','2016-12-16 11:20:24','1','SN 1996X',NULL,107441,32.22,0.07,27.8,45850,60,NULL,'M(B) = -19.48 mag','NGC 5061',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107442,'SNIa','2016-12-15 15:15:12','2016-12-16 11:20:24','1','SN 1996X',NULL,107442,32.24,0.07,28.1,45850,60,NULL,'M(V) = -19.47 mag','NGC 5061',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107443,'SNIa','2016-12-15 15:15:12','2016-12-16 11:20:24','1','SN 1996X',NULL,107443,32.43,0.07,30.2,45850,65,NULL,'MLCS2k2','NGC 5061',0.00689,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107444,'SNIa','2016-12-15 15:15:12','2016-12-16 11:20:24','1','SN 1996X',NULL,107444,32.46,0.14,31,45850,60,NULL,NULL,'NGC 5061',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107445,'SNIa','2016-12-15 15:15:12','2016-12-16 11:20:24','1','SN 1996X',NULL,107445,32.6,0.12,33.1,45850,70.8,NULL,NULL,'NGC 5061',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107446,'SBF','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107446,31.85,0.26,23.4,45850,NULL,NULL,NULL,'NGC 5061',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107447,'SBF','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107447,31.96,0.26,24.7,45850,NULL,NULL,'Malmquist cor.','NGC 5061',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107448,'SBF','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107448,32.32,0.19,29.1,45850,NULL,NULL,'I','NGC 5061',NULL,'2001ApJ...559..584A',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107449,'D-Sigma','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107449,31.96,0.4,24.7,45850,75,NULL,'Edat, raw','NGC 5061',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107450,'D-Sigma','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107450,32.09,0.4,26.2,45850,75,NULL,'Edat, cor','NGC 5061',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107451,'Faber-Jackson','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107451,30.42,0.65,12.1,45850,95,NULL,'Weighted Mean','NGC 5061',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107452,'Faber-Jackson','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107452,30.93,NULL,15.3,45850,NULL,NULL,'LEDA [April 2006]','NGC 5061',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107453,'Faber-Jackson','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107453,31.5,0.81,20,45850,55,NULL,'Visvanathan & Sandage 1979','NGC 5061',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107454,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107454,30.9,0.52,15.2,45850,70,NULL,NULL,'NGC 5061',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107455,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107455,31.15,0.41,17,45850,NULL,NULL,NULL,'NGC 5061',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107456,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107456,31.42,0.41,19.2,45850,NULL,NULL,'Malmquist cor.','NGC 5061',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107457,'Tully est','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107457,32.29,0.8,28.7,45850,75,NULL,'B','NGC 5061',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107458,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107458,31.55,0.45,20.4,45850,NULL,NULL,'K','NGC 5061',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107459,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107459,31.94,0.4,24.4,45850,75,NULL,'HOSTS SN 1996X','NGC 5061',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107460,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107460,32.53,0.4,32.1,45850,NULL,NULL,'mean','NGC 5061',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107461,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107461,37.56,0.21,326,45851,70,NULL,NULL,'2MASX J13180813+4229470',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000166,NULL,'16.9g',0.34,NULL,NULL,NULL,NULL,NULL,1,199.53375,42.49636,0,NULL,59311146911,926736670,14480260,16.9),(107462,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107462,37.67,0.46,342,45852,70,NULL,NULL,'2MASX J13180849+1759407',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,199.535458333,17.99481,0.007,NULL,58829471572,919210493,14362663,18.1),(107463,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107463,37.38,0.46,300,45853,70,NULL,NULL,'2MASX J13180926+2927033',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000178,NULL,'16.4g',0.28,'E5',NULL,NULL,NULL,NULL,1,199.5385417,29.45078,0.025,NULL,58715582075,917430969,14334858,16.4),(107464,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107464,37.37,0.46,298,45854,70,NULL,NULL,'2MASX J13180925+3734535',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000173,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,199.5385417,37.58142,0,NULL,59305434638,926647416,14478865,17.8),(107465,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107465,37.42,0.27,305,45855,70,NULL,NULL,'2MASX J13181061+6625402',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000116,NULL,'15.4g',0.51,'BrClG',NULL,NULL,NULL,NULL,1,199.544167,66.42792,0.033,NULL,57876631609,904322368,14130037,15.4),(107466,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107466,37.27,0.46,285,45856,70,NULL,NULL,'2MASX J13181093+3828044',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,199.5455417,38.46792,0,NULL,59305868349,926654192,14478971,17.3),(107467,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107467,38.64,0.46,534,45857,70,NULL,NULL,'2MASX J13181124+5646357',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,199.54675,56.77672,0,NULL,57417462693,897147854,14017935,18.4),(107468,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107468,37,0.46,251,45858,70,NULL,NULL,'2MASX J13181140+6146358',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,199.547458333,61.77664,0.029,NULL,57392762149,896761908,14011904,16.8),(107469,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107469,37.65,0.46,339,45859,70,NULL,NULL,'2MASX J13181188+1959047',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,199.5495,19.98458,0.048,NULL,58840233581,919378649,14365291,17.4),(107470,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107470,35.08,0.58,104,45860,70,NULL,NULL,'MCG -02-34-018',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.06',0.4,'SbII-III','Group member',NULL,NULL,NULL,1,199.551625,-15.6905,0.129,NULL,44001473939,687523030,10742547,15.06),(107471,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107471,37.17,0.46,271,45861,70,NULL,NULL,'2MASX J13181497+1415562',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000156,NULL,'17.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,199.5625,14.26567,0,NULL,59018987251,922171675,14408932,17.4),(107472,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107472,37.59,0.46,330,45862,70,NULL,NULL,'SDSS J131815.31+433900.4',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00018,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,199.5637917,43.65014,0,NULL,59310970669,926733916,14480217,17.3),(107473,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107473,34.49,0.46,79.2,45863,70,NULL,NULL,'IC 0873',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.0001,NULL,'14.8g',0.69,'E','in a triple',NULL,NULL,NULL,1,199.567833333,4.46431,0.054,NULL,58933271360,920832365,14388005,14.8),(107474,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107474,35.41,0.33,121,45864,70,NULL,NULL,'CGCG 271-030',NULL,'2015arXiv151105856S',2015,1,1.05,NULL,'G',0.000199,NULL,'14.5g',0.66,'E0',NULL,NULL,NULL,NULL,1,199.568333333,53.96519,0.016,NULL,57413069457,897079210,14016862,14.5),(107475,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107475,36.84,0.46,234,45865,70,NULL,NULL,'2MASX J13181689+6026038',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000193,NULL,'15.8g',0.42,'E0',NULL,NULL,NULL,NULL,1,199.5705,60.43439,0,NULL,57394286906,896785732,14012277,15.8),(107476,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107476,38.02,0.46,401,45866,70,NULL,NULL,'SDSS J131817.24+040313.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000137,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,199.571833333,4.05369,0.056,NULL,58931366376,920802599,14387540,18.7),(107477,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107477,37.77,0.12,358,45867,70,NULL,NULL,'SDSS J131818.84-004504.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000071,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,199.5785417,-0.75117,0.029,NULL,43099430911,673428607,10522321,18.3),(107478,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107478,35.85,0.55,148,45868,70,NULL,NULL,'2MASX J13181976-3257172',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000147,NULL,'16.6',NULL,'S0',NULL,NULL,NULL,NULL,1,199.582333333,-32.95475,0.201,NULL,46868621967,732322218,11442534,16.6),(107479,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107479,36.78,0.46,227,45869,70,NULL,NULL,'2MASX J13182011+4450470',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000194,NULL,'15.7g',0.49,'E0',NULL,NULL,NULL,NULL,1,199.58375,44.8465,0,NULL,59282014323,926281473,14473148,15.7),(107480,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107480,37.59,0.46,329,45870,70,NULL,NULL,'2MASX J13182032+0732509',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,199.584583,7.54744,0.053,NULL,58987974783,921687105,14401361,NULL),(107481,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107481,34.87,0.67,94.2,45871,70,NULL,NULL,'2MASX J13182052-1655189',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,199.585291667,-16.92194,0.157,NULL,43999251985,687488312,10742004,14.6),(107482,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107482,37.48,0.46,313,45872,70,NULL,NULL,'2MASX J13182084+1103229',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00018,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,199.5869583,11.05628,0.02,NULL,58946357995,921036843,14391200,17.1),(107483,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107483,38.3,0.27,457,45873,70,NULL,NULL,'SDSS J131823.03+104747.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000143,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,199.596,10.79656,0,NULL,58946378332,921037161,14391205,18.4),(107484,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107484,36.88,0.46,238,45874,70,NULL,NULL,'2MASX J13182304+2429333',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,199.596167,24.49269,0,NULL,58707887921,917310748,14332980,16.9),(107485,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107485,33.48,0.48,49.7,45875,70,NULL,NULL,'NGC 5062',NULL,'2014MNRAS.445.2677S',2014,1,2.2,NULL,'G',0.00009,NULL,'12.2',0.7,'S0^0^ pec sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,199.598417,-35.45867,0.145,NULL,46874467400,732413553,11443961,12.2),(107486,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107486,36.9,0.46,239,45876,70,NULL,NULL,'2MASX J13182415+0056580',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000065,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,199.600833,0.9495,0.037,NULL,58063255817,907238372,14175599,17.5),(107487,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107487,37.61,0.46,332,45877,70,NULL,NULL,'2MASX J13182508+0022030',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000098,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,199.6047083,0.36764,0.025,NULL,58063037681,907234963,14175546,16.9),(107488,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107488,36.72,0.23,221,45878,70,NULL,NULL,'MCG +08-24-103',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000193,NULL,'16.0g',0.37,'E0',NULL,NULL,NULL,NULL,1,199.606291667,47.24839,0,NULL,59289504916,926398514,14474976,16),(107489,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107489,36.94,0.46,244,45879,70,NULL,NULL,'2MASX J13182565+6111507',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000153,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,199.6067083,61.19739,0.021,NULL,57393713947,896776780,14012137,17.4),(107490,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107490,33.16,0.49,42.8,45880,70,NULL,NULL,'NGC 5063',NULL,'2014MNRAS.445.2677S',2014,1,2.3,NULL,'G',0.00015,NULL,'13.25',1.8,'(R\':)SA(r)a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,199.607125,-35.35247,0.117,NULL,46874462813,732413481,11443960,13.25),(107491,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107491,36.72,0.23,221,45881,70,NULL,NULL,'MCG +08-24-102',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000197,NULL,'15.6g',0.55,'BrClG',NULL,NULL,NULL,NULL,1,199.60875,47.22317,0,NULL,59289503388,926398490,14474976,15.6),(107492,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107492,36.92,0.27,242,45882,70,NULL,NULL,'2MASX J13182775+4114049',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000194,NULL,'15.7g',0.43,'E0',NULL,NULL,NULL,NULL,1,199.615917,41.23481,0,NULL,59302128106,926595751,14478058,15.7),(107493,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107493,37.62,0.33,334,45883,70,NULL,NULL,'SDSS J131829.82+484837.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000138,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,199.6242917,48.81047,0,NULL,59275990371,926187349,14471677,18),(107494,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107494,37.66,0.46,340,45884,70,NULL,NULL,'2MASX J13182982+1349022',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000178,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,199.624333,13.81725,0,NULL,59018349047,922161703,14408776,16.7),(107495,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107495,35.41,0.33,121,45885,70,NULL,NULL,'CGCG 271-031',NULL,'2015arXiv151105856S',2015,1,0.88,'GSC 3843-0323 (mag. 12) superposed 33 arcsec south of nucleus.','G',0.000187,NULL,'14.7g',0.7,'E0',NULL,NULL,NULL,NULL,1,199.624875,54.06642,0.022,NULL,57413041561,897078774,14016855,14.7),(107496,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107496,32.67,0.47,34.2,45886,NULL,NULL,'H','IC 4221',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00001,NULL,'13.58',0.8,'SA(r)c pec?',NULL,NULL,NULL,NULL,1,199.6264583,-14.60889,0.097,NULL,44003380787,687552824,10743012,13.58),(107497,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107497,32.81,0.46,36.4,45886,NULL,NULL,'J','IC 4221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107498,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107498,32.86,0.45,37.2,45886,NULL,NULL,'K','IC 4221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107499,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107499,33.13,0.4,42.2,45886,NULL,NULL,'mean','IC 4221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107500,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107500,37.77,0.12,358,45887,70,NULL,NULL,'2MASX J13183087-0047144',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000085,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,199.628625,-0.78747,0.029,NULL,43099436480,673428695,10522323,17.7),(107501,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107501,36.61,0.46,210,45888,70,NULL,NULL,'2MASX J13183131+2902444',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'16.8g',0.25,'E3',NULL,NULL,NULL,NULL,1,199.6305,29.04569,0.009,NULL,58716029355,917437958,14334968,16.8),(107502,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107502,36.72,0.23,221,45889,70,NULL,NULL,'MCG +08-24-105',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000172,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,199.630875,47.14981,0,NULL,59288978791,926390293,14474848,16.2),(107503,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107503,36.34,0.23,186,45890,70,NULL,NULL,'CGCG 160-185',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000093,NULL,'15.0g',0.63,'E5',NULL,NULL,NULL,NULL,1,199.632,31.33797,0,NULL,59163032961,924422390,14444099,15),(107504,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107504,38.3,0.27,457,45891,70,NULL,NULL,'2MASX J13183261+1050279',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000168,NULL,'16.9g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,199.635833,10.84125,0,NULL,58946406738,921037605,14391212,16.9),(107505,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107505,38.27,0.46,451,45892,70,NULL,NULL,'SDSS J131833.62+110750.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000163,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,199.640083333,11.13072,0.02,NULL,58946499684,921039057,14391235,18),(107506,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107506,37.4,0.46,301,45893,70,NULL,NULL,'2MASX J13183443+3336162',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000097,NULL,'16.8g',0.28,'E1',NULL,NULL,NULL,NULL,1,199.6434583,33.60439,0.011,NULL,59171521845,924555028,14446172,16.8),(107507,'IRAS','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107507,32,0.8,25.1,45894,75,NULL,'MAT, I','ESO 576- G 026',NULL,'1997ApJS..109..333W',1997,1,1.88,NULL,'G',0.000033,NULL,'15.67',0.17,'SBd? sp',NULL,NULL,NULL,NULL,1,199.644667,-21.29972,0.313,NULL,43811623758,684556621,10696197,15.67),(107508,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107508,31.55,0.43,20.4,45894,75,NULL,'3.6 micron, color + selection bias corrected','ESO 576- G 026',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107509,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107509,31.68,0.43,21.7,45894,75,NULL,'3.6 micron, color corrected','ESO 576- G 026',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107510,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107510,31.77,0.2,22.6,45894,74.4,NULL,NULL,'ESO 576- G 026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107511,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107511,31.78,0.32,22.7,45894,85,NULL,'I, inv','ESO 576- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107512,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107512,31.82,0.32,23.1,45894,85,NULL,'I, raw','ESO 576- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107513,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107513,32.13,0.74,26.6,45894,NULL,NULL,NULL,'ESO 576- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107514,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107514,32.24,0.43,28,45894,75,NULL,'MAT, I, inv','ESO 576- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107515,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107515,32.29,0.43,28.7,45894,75,NULL,'MAT, I, raw','ESO 576- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107516,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107516,32.32,0.49,29.1,45894,75,NULL,'IR','ESO 576- G 026',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107517,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107517,32.39,0.65,30.1,45894,NULL,NULL,'Malmquist cor.','ESO 576- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107518,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107518,32.47,0.4,31.1,45894,75,NULL,NULL,'ESO 576- G 026',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107519,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107519,32.55,NULL,32.4,45894,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 576- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107520,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107520,32.55,NULL,32.4,45894,NULL,NULL,'Dipole + Quadrupole','ESO 576- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107521,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107521,32.56,0.43,32.6,45894,75,NULL,'MAT, I, cor','ESO 576- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107522,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107522,32.57,NULL,32.6,45894,NULL,NULL,'Dipole','ESO 576- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107523,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107523,32.67,NULL,34.1,45894,NULL,NULL,NULL,'ESO 576- G 026',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107524,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107524,38.88,0.46,597,45895,70,NULL,NULL,'SDSS J131834.89+025357.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000153,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,199.645375,2.89942,0,NULL,58055512242,907117378,14173709,18.6),(107525,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107525,35.87,0.52,149,45896,70,NULL,NULL,'2MASX J13183516-3918217',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,199.646541667,-39.30608,0.241,NULL,46938827377,733419177,11459674,15),(107526,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107526,38.08,0.46,413,45897,70,NULL,NULL,'2MASX J13183592+3025052',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,199.649583,30.41814,0.017,NULL,58679112374,916861130,14325955,17.7),(107527,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107527,36.88,0.46,238,45898,70,NULL,NULL,'2MASX J13183642+4649129',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,199.651875,46.82019,0,NULL,59280838235,926263097,14472860,17.6),(107528,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107528,37.33,0.46,292,45899,70,NULL,NULL,'SDSS J131836.82+360330.4',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000159,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,199.653458333,36.05847,0,NULL,59170351788,924536746,14445886,17.9),(107529,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107529,37.11,0.46,265,45900,70,NULL,NULL,'2MASX J13183683+5704562',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000146,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,199.653625,57.08225,0,NULL,57436077356,897438708,14022479,18.1),(107530,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107530,35.7,0.33,138,45901,70,NULL,NULL,'CGCG 160-186',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.000073,NULL,'15.1g',0.44,'E6','Group member',NULL,NULL,NULL,1,199.6544583,30.86536,0.023,NULL,58678593422,916853022,14325828,15.1),(107531,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107531,36.35,0.46,186,45902,70,NULL,NULL,'NGC 5071',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.0001,NULL,'15.5',0.7,NULL,NULL,NULL,NULL,NULL,1,199.654958333,7.93553,0.026,NULL,58988535906,921695873,14401498,15.5),(107532,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107532,36.72,0.23,221,45903,70,NULL,NULL,'2MASX J13183818+4703431',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000185,NULL,'16.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,199.659167,47.06192,0,NULL,59280795510,926262429,14472850,16.2),(107533,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107533,38.31,0.46,459,45904,70,NULL,NULL,'2MASX J13183880+3838160',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000153,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,199.661875,38.63797,0,NULL,59306711076,926667360,14479177,17.4),(107534,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107534,37.62,0.33,334,45905,70,NULL,NULL,'2MASX J13183942+2111002',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.5g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,199.664167,21.18347,0.059,NULL,58847162414,919486912,14366983,16.5),(107535,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107535,35.89,0.73,150,45906,70,NULL,NULL,'2MASX J13183947-4113397',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,199.664417,-41.22767,0.393,NULL,46931997504,733312461,11458007,15.3),(107536,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107536,38.26,0.46,449,45907,70,NULL,NULL,'2MASX J13183978+5917582',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,199.665667,59.29956,0,NULL,57389418491,896709663,14011088,17.8),(107537,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107537,38.12,0.46,421,45908,70,NULL,NULL,'2MASX J13184057+0944329',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,199.669083333,9.74242,0,NULL,58974483717,921476308,14398067,18),(107538,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107538,37.44,0.46,308,45909,70,NULL,NULL,'VIII Zw 285',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00011,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,199.669541667,-0.37475,0.029,NULL,43098784089,673418501,10522164,16.5),(107539,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107539,38.01,0.46,400,45910,70,NULL,NULL,'2MASX J13184095+1557468',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.76',0.15,NULL,NULL,NULL,NULL,NULL,1,199.670625,15.96289,0.009,NULL,59013701712,922089089,14407642,18.76),(107540,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107540,31.84,0.4,23.3,45911,75,NULL,'B','DDO 171',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.00002,NULL,'15.00',1.2,'IB(s)m',NULL,NULL,NULL,NULL,1,199.671667,-8.44639,0.073,NULL,43887784590,685746634,10714791,15),(107541,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107541,36.34,0.23,186,45912,70,NULL,NULL,'2MASX J13184170+3122122',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000171,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,199.673708333,31.37003,0,NULL,59163024132,924422252,14444097,17.3),(107542,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107542,36.59,0.46,208,45913,70,NULL,NULL,'VIII Zw 286',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.0001,NULL,'15.6g',0.52,'E0',NULL,NULL,NULL,NULL,1,199.6790417,-0.17894,0.013,NULL,43098579079,673415298,10522114,15.6),(107543,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107543,36.47,0.6,197,45914,70,NULL,NULL,'2MASX J13184348-4154146',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,199.681166667,-41.904,0.425,NULL,46961947179,733780424,11465319,15.1),(107544,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107544,37.57,0.46,326,45915,70,NULL,NULL,'2MASX J13184445+4312072',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000188,NULL,'16.7g',0.36,NULL,NULL,NULL,NULL,NULL,1,199.685417,43.20211,0,NULL,59311449743,926741402,14480334,16.7),(107545,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107545,36.72,0.46,221,45916,70,NULL,NULL,'2MASX J13184472+1640528',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.37',0.18,NULL,NULL,NULL,NULL,NULL,1,199.686417,16.68125,0,NULL,59010374826,922037106,14406829,18.37),(107546,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107546,38.19,0.27,434,45917,70,NULL,NULL,'SDSS J131844.83+113730.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00013,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,199.686833,11.62519,0.017,NULL,58945989445,921031085,14391110,18.4),(107547,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107547,31.06,0.43,16.3,45918,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08365',NULL,'2014MNRAS.444..527S',2014,1,1.81,NULL,'G',0.000037,NULL,'15.2g',0.5,'SB(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,199.688,41.94964,0,NULL,59309139267,926705301,14479770,15.2),(107548,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107548,31.2,0.43,17.4,45918,75,NULL,'3.6 micron, color corrected','UGC 08365',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107549,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107549,31.32,0.2,18.4,45918,74.4,NULL,NULL,'UGC 08365',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107550,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107550,31.55,0.58,20.4,45918,NULL,NULL,'Malmquist cor.','UGC 08365',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107551,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107551,31.65,0.55,21.4,45918,NULL,NULL,NULL,'UGC 08365',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107552,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107552,31.88,0.4,23.7,45918,75,NULL,'B','UGC 08365',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107553,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107553,31.89,0.4,23.9,45918,75,NULL,NULL,'UGC 08365',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107554,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107554,32.8,0.49,36.3,45918,75,NULL,'IR','UGC 08365',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107555,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107555,36.64,0.46,213,45919,70,NULL,NULL,'2MASX J13184572+4314072',NULL,'2015arXiv151105856S',2015,1,0.51,'2004AJ....127.1943G has z = 0.0567 +- 0.0028.','G',0.000019,NULL,'15.8g',0.46,'LINER',NULL,NULL,NULL,NULL,1,199.690708333,43.23536,0,NULL,59311451151,926741424,14480334,15.8),(107556,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107556,35.68,0.46,137,45920,70,NULL,NULL,'2MASX J13184622+2044512',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.18',0.24,NULL,NULL,NULL,NULL,NULL,1,199.692625,20.74767,0.059,NULL,58839840035,919372500,14365195,16.18),(107557,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107557,36.82,0.46,231,45921,70,NULL,NULL,'2MASX J13184638+3434252',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000175,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,199.693083,34.57378,0.011,NULL,59172372398,924568318,14446379,16.7),(107558,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107558,38.1,0.27,417,45922,70,NULL,NULL,'2MASX J13184641+0618179',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,199.693375,6.30506,0.018,NULL,58977244662,921519447,14398741,17.6),(107559,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107559,38.11,0.46,420,45923,70,NULL,NULL,'2MASX J13184698+4225512',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000201,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,199.6957917,42.43092,0,NULL,59309179686,926705932,14479780,16.9),(107560,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107560,37.77,0.12,358,45924,70,NULL,NULL,'2MASX J13184854-0053334',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000083,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,199.7024583,-0.89269,0.021,NULL,43099169522,673424523,10522258,17.4),(107561,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107561,36.03,0.2,161,45925,74.4,NULL,NULL,'CGCG 072-045',NULL,'2013AJ....146...86T',2013,1,0.74,NULL,'G',0.000201,NULL,'16.1g',0.26,'Sb',NULL,NULL,NULL,NULL,1,199.703333,12.39719,0.011,NULL,59017640907,922150639,14408603,16.1),(107562,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107562,37.95,0.33,390,45926,70,NULL,NULL,'2MASX J13185066+5801101',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,199.711208333,58.01958,0.005,NULL,57436511696,897445495,14022585,17.9),(107563,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107563,38.37,0.46,473,45927,70,NULL,NULL,'2MASX J13185083+3809019',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,199.711708333,38.1505,0,NULL,59305778659,926652791,14478949,18.2),(107564,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107564,37.77,0.12,358,45928,70,NULL,NULL,'2MASX J13185088-0116354',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000076,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,199.712166667,-1.27639,0.021,NULL,43099152764,673424261,10522254,17.6),(107565,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107565,38.3,0.27,457,45929,70,NULL,NULL,'2MASX J13185094+1054169',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,199.712166667,10.90483,0,NULL,58946393641,921037400,14391209,17.9),(107566,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107566,37.69,0.46,345,45930,70,NULL,NULL,'2MASX J13185141+3538002',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000148,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,199.71425,35.63331,0,NULL,59171091224,924548300,14446067,17.7),(107567,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107567,36.47,0.46,197,45931,70,NULL,NULL,'2MASX J13185196+3144472',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000179,NULL,'16.8g',0.2,'E3',NULL,NULL,NULL,NULL,1,199.716333333,31.74644,0,NULL,59163248079,924425751,14444152,16.8),(107568,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107568,38.31,0.46,458,45932,70,NULL,NULL,'2MASX J13185205+4216022',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,199.716916667,42.26711,0,NULL,59309257142,926707142,14479799,18),(107569,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107569,36.94,0.46,245,45933,70,NULL,NULL,'CGCG 044-064 NED03',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.52',0.15,NULL,NULL,NULL,NULL,NULL,1,199.7202917,7.78442,0.026,NULL,58988661579,921697837,14401528,17.52),(107570,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107570,38.1,0.27,417,45934,70,NULL,NULL,'2MASX J13185285+0616559',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,199.720375,6.28231,0.018,NULL,58977247033,921519484,14398741,17.1),(107571,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107571,37.29,0.57,287,45935,70,NULL,NULL,'2MASX J13185329-3716218',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,199.721958333,-37.27286,0.193,NULL,46935422307,733365973,11458843,15.7),(107572,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107572,34.1,NULL,66.2,45936,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1592',NULL,'2010Ap&SS.325..163P',2010,1,1.27,NULL,'G',0.000032,NULL,'15.81',0.11,'Sd',NULL,NULL,NULL,NULL,1,199.726,-5.79103,0.097,NULL,43827522406,684805037,10700078,15.81),(107573,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107573,34.12,NULL,66.6,45936,NULL,NULL,'Dipole + Quadrupole','FGC 1592',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107574,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107574,34.13,NULL,67,45936,NULL,NULL,'Dipole','FGC 1592',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107575,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107575,34.18,NULL,68.6,45936,NULL,NULL,NULL,'FGC 1592',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107576,'PNLF','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107576,28.68,0.08,5.45,45937,NULL,NULL,NULL,'NGC 5068',NULL,'2008ApJ...683..630H',2008,1,7.2,NULL,'G',0.000003,NULL,'10.52',6.3,'SB(s)d','Line-of-sight pair member',NULL,NULL,NULL,1,199.728375,-21.03911,0.309,NULL,43820018219,684687784,10698246,10.52),(107577,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107577,29.13,0.4,6.7,45937,75,NULL,'B','NGC 5068',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107578,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107578,34.86,0.58,93.9,45938,NULL,NULL,'Malmquist cor.','ESO 508- G 041',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.95',0.7,'Sb             HII',NULL,NULL,NULL,NULL,1,199.7294583,-24.69678,0.325,NULL,43344141583,677252212,10582065,14.95),(107579,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107579,34.94,0.56,97.3,45938,NULL,NULL,NULL,'ESO 508- G 041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107580,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107580,34.98,0.2,99.1,45938,74.4,NULL,NULL,'ESO 508- G 041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107581,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107581,37.86,0.46,373,45939,70,NULL,NULL,'2MASX J13185609+1245028',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,199.733833,12.75075,0.007,NULL,59017136903,922142764,14408480,17.6),(107582,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107582,35.26,0.58,113,45940,70,NULL,NULL,'2MASX J13185643-1454127',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00004,NULL,'15.49',NULL,NULL,NULL,NULL,NULL,NULL,1,199.7349583,-14.90361,0.105,NULL,44002920695,687545635,10742900,15.49),(107583,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107583,36.48,0.52,198,45940,NULL,NULL,'Malmquist cor.','2MASX J13185643-1454127',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107584,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107584,36.54,0.51,204,45940,NULL,NULL,NULL,'2MASX J13185643-1454127',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107585,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107585,36.58,0.2,207,45940,74.4,NULL,NULL,'2MASX J13185643-1454127',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107586,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107586,37.44,0.46,307,45941,70,NULL,NULL,'2MASX J13185680+2115442',NULL,'2015arXiv151105856S',2015,1,0.35,'Both NGP9 F379-1072445 and 1072452 may contribute to the IRAS flux.','G',NULL,NULL,'16.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,199.736583,21.26225,0.065,NULL,58847373640,919490213,14367034,16.7),(107587,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107587,37.36,0.46,297,45942,70,NULL,NULL,'2MASX J13185708+3157322',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000182,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,199.737875,31.95886,NULL,NULL,59163146958,924424171,14444127,16.9),(107588,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107588,37.97,0.27,392,45943,70,NULL,NULL,'2MASX J13185716+0536449',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000187,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,199.73825,5.61258,0,NULL,58933025778,920828527,14387945,16.9),(107589,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107589,37.95,0.33,390,45944,70,NULL,NULL,'2MASX J13185798+5803171',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000147,NULL,'16.5g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,199.741333333,58.05489,0.005,NULL,57436518504,897445601,14022587,16.5),(107590,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107590,38.1,0.27,417,45945,70,NULL,NULL,'2MASX J13185794+0610283',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,199.7414583,6.17456,0,NULL,58977366129,921521345,14398771,17.2),(107591,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107591,38.21,0.27,438,45946,70,NULL,NULL,'2MASX J13185857+1618578',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.08',0.21,NULL,NULL,NULL,NULL,NULL,1,199.744,16.31617,0,NULL,59013649268,922088269,14407629,18.08),(107592,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107592,37.77,0.12,358,45947,70,NULL,NULL,'2MASX J13185863-0037429',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000085,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,199.744167,-0.62856,0.029,NULL,43085018498,673203414,10518803,16.8),(107593,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107593,37.21,0.46,276,45948,70,NULL,NULL,'2MASX J13185890+4212392',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000172,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,199.745417,42.21089,0,NULL,59309287350,926707614,14479806,17.2),(107594,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107594,37.97,0.27,392,45949,70,NULL,NULL,'2MASX J13185970+0531119',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,'FoF','17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,199.748625,5.51992,0.011,NULL,58933032181,920828627,14387947,17.5),(107595,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107595,35.7,0.33,138,45950,70,NULL,NULL,'CGCG 160-190',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.00007,NULL,'15.1g',0.44,'E','Group member',NULL,NULL,NULL,1,199.748917,30.781,0.022,NULL,58678817152,916856518,14325883,15.1),(107596,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107596,32.05,0.48,25.7,45951,70,NULL,NULL,'NGC 5064',NULL,'2014MNRAS.445.2677S',2014,1,2.5,'Confused HIPASS source','G',0.000017,NULL,'12.90',1.1,'(R\':)SA(s)ab   LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,199.7497083,-47.90867,0.681,NULL,46956375720,733693370,11463958,12.9),(107597,'IRAS','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107597,32.72,0.8,34.9,45951,75,NULL,'MAT, I','NGC 5064',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107598,'Tully est','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107598,32.98,0.8,39.5,45951,75,NULL,'B','NGC 5064',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107599,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107599,32.98,0.43,39.5,45951,75,NULL,'MAT, I, raw','NGC 5064',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107600,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107600,33.06,0.4,40.9,45951,NULL,NULL,NULL,'NGC 5064',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107601,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107601,33.14,0.32,42.4,45951,85,NULL,'I, raw','NGC 5064',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107602,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107602,33.23,0.32,44.2,45951,85,NULL,'I, inv','NGC 5064',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107603,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107603,33.24,0.43,44.5,45951,75,NULL,'MAT, I, cor','NGC 5064',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107604,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107604,33.27,0.43,45.1,45951,75,NULL,'3.6 micron, color corrected','NGC 5064',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107605,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107605,33.29,0.43,45.6,45951,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5064',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107606,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107606,33.34,0.2,46.6,45951,74.4,NULL,NULL,'NGC 5064',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107607,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107607,33.35,0.43,46.7,45951,75,NULL,'MAT, I, inv','NGC 5064',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107608,'D-Sigma','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107608,31.96,0.4,24.7,45952,75,NULL,'Edat, raw','IC 0874',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'13.44',1,'SB(rs)0^0','X-ray-faint group member',NULL,NULL,NULL,1,199.752166667,-27.62856,0.209,NULL,43348984113,677327876,10583248,13.44),(107609,'D-Sigma','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107609,32.09,0.4,26.2,45952,75,NULL,'Edat, cor','IC 0874',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107610,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107610,32.8,0.45,36.3,45952,NULL,NULL,'K','IC 0874',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107611,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107611,32.8,0.4,36.4,45952,NULL,NULL,'mean','IC 0874',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107612,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107612,38.19,0.27,434,45953,70,NULL,NULL,'2MASX J13190059+1140573',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,199.7525,11.68253,0.013,NULL,58946024051,921031625,14391119,17.8),(107613,'D-Sigma','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107613,33.04,0.4,40.5,45954,75,NULL,'Edat, raw','ESO 269- G 080',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000133,NULL,'12.7',1.2,'SA0^0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,199.753875,-47.25778,0.613,NULL,46957145825,733705403,11464146,12.7),(107614,'D-Sigma','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107614,33.37,0.4,47.3,45954,75,NULL,'Edat, cor','ESO 269- G 080',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107615,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107615,33.15,0.49,42.7,45954,70,NULL,NULL,'ESO 269- G 080',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107616,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107616,33.23,0.4,44.2,45954,NULL,NULL,'mean','ESO 269- G 080',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107617,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107617,33.28,0.45,45.3,45954,NULL,NULL,'K','ESO 269- G 080',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107618,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107618,38.19,0.27,434,45955,70,NULL,NULL,'2MASX J13190100+1137223',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000173,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,199.75425,11.62272,0.017,NULL,58946024742,921031636,14391119,16.5),(107619,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107619,37.43,0.46,306,45956,70,NULL,NULL,'2MASX J13190168+3102503',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000189,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,199.756917,31.04719,0.018,NULL,58678587276,916852926,14325826,16.7),(107620,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107620,37.77,0.12,358,45957,70,NULL,NULL,'2MASX J13190171-0108389',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000082,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,199.7572083,-1.14417,0.021,NULL,43085236169,673206815,10518856,17.1),(107621,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107621,37.68,0.46,343,45958,70,NULL,NULL,'2MASX J13190186+4341272',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,199.7577083,43.691,0,NULL,59311100048,926735938,14480249,17.6),(107622,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107622,37.77,0.12,358,45959,70,NULL,NULL,'2MASX J13190190-0039439',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000078,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,199.758083333,-0.66222,0.029,NULL,43085008479,673203257,10518800,17.6),(107623,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107623,37.42,0.27,305,45960,70,NULL,NULL,'2MASX J13190220+6629010',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000087,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,199.7589583,66.48372,0.033,NULL,57876456573,904319633,14129994,17.5),(107624,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107624,38.5,0.46,502,45961,70,NULL,NULL,'2MASX J13190213+3706338',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000144,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,199.759125,37.10931,0,NULL,59297200569,926518758,14476855,18.1),(107625,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107625,37.97,0.27,392,45962,70,NULL,NULL,'2MASX J13190265+0537559',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,199.7610417,5.63236,0,NULL,58932160291,920815004,14387734,18),(107626,'IRAS','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107626,32.83,0.8,36.9,45963,75,NULL,'MAT, I','ESO 269- G 082',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'15.01',0.6,'SB(s)c:',NULL,NULL,NULL,NULL,1,199.761333333,-47.326,0.613,NULL,46957144460,733705382,11464146,15.01),(107627,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107627,33.42,0.32,48.4,45963,85,NULL,'I, raw','ESO 269- G 082',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107628,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107628,33.43,0.32,48.6,45963,85,NULL,'I, inv','ESO 269- G 082',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107629,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107629,34.43,0.43,77.1,45963,75,NULL,'MAT, I, raw','ESO 269- G 082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107630,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107630,34.6,0.43,83.2,45963,75,NULL,'MAT, I, inv','ESO 269- G 082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107631,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107631,34.65,0.43,85.2,45963,75,NULL,'MAT, I, cor','ESO 269- G 082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107632,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107632,37.77,0.46,358,45964,70,NULL,NULL,'2MASX J13190370+2618203',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,199.765583,26.30575,0,NULL,58709540862,917336575,14333383,17.3),(107633,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107633,37.29,0.46,287,45965,70,NULL,NULL,'4C +29.47',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000184,NULL,'16.0g',0.41,'E0',NULL,NULL,'radio jet',NULL,1,199.767333333,29.64303,0.022,NULL,58712350062,917380469,14334069,16),(107634,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107634,37.77,0.12,358,45966,70,NULL,NULL,'2MASX J13190470-0053279',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000101,NULL,'16.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,199.769625,-0.89111,0.021,NULL,43085390325,673209223,10518894,16.4),(107635,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107635,37.66,0.46,340,45967,70,NULL,NULL,'SDSS J131904.80+023127.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000143,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,199.770041667,2.52436,0.018,NULL,58064063746,907250996,14175796,17.9),(107636,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107636,37.63,0.27,336,45968,70,NULL,NULL,'2MASX J13190566+0511109',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00014,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,199.77375,5.18639,0,NULL,58933088020,920829500,14387960,17.8),(107637,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107637,38.49,0.46,499,45969,70,NULL,NULL,'2MASX J13190579+3916588',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,199.774083,39.28292,0,NULL,59304012979,926625202,14478518,18.1),(107638,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107638,38,0.46,398,45970,70,NULL,NULL,'2MASX J13190590+2807464',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00016,NULL,'17.6g',0.19,'E0',NULL,NULL,NULL,NULL,1,199.774667,28.12944,0.024,NULL,58714666676,917416666,14334635,17.6),(107639,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107639,37.74,0.46,352,45971,70,NULL,NULL,'2MASX J13190609+4420242',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,199.7755,44.34006,0,NULL,59310866959,926732296,14480192,17.1),(107640,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107640,34.37,0.46,74.7,45972,70,NULL,NULL,'NGC 5075',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.0001,NULL,'15.1',0.6,NULL,NULL,NULL,NULL,NULL,1,199.7760417,7.83103,0.026,NULL,58988531081,921695798,14401496,15.1),(107641,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107641,37.63,0.27,336,45973,70,NULL,NULL,'2MASX J13190747+0510149',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000172,NULL,'16.8g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,199.7810417,5.17069,0,NULL,58933084936,920829452,14387960,16.8),(107642,'IRAS','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107642,34.74,0.8,88.7,45974,75,NULL,'HMCL, I','NGC 5081',NULL,'1997ApJS..109..333W',1997,1,2.33,NULL,'G',0.000004,NULL,'14.0g',0.69,'SBb','Isolated galaxy',NULL,NULL,NULL,1,199.784333333,28.50692,0.018,NULL,58715942407,917436600,14334946,14),(107643,'IRAS','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107643,34.79,0.8,91,45974,75,NULL,'W91CL, r','NGC 5081',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107644,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107644,34.61,0.4,83.5,45974,75,NULL,'HMCL, I, raw','NGC 5081',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107645,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107645,34.87,0.4,94.3,45974,75,NULL,'HMCL, I, inv','NGC 5081',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107646,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107646,34.89,0.4,95.2,45974,75,NULL,'HMCL, I, cor','NGC 5081',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107647,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107647,34.9,0.38,95.4,45974,75,NULL,'W91CL, r, raw','NGC 5081',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107648,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107648,34.98,0.38,99.1,45974,75,NULL,'W91CL, r, cor','NGC 5081',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107649,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107649,34.99,0.4,99.8,45974,NULL,NULL,'mean','NGC 5081',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107650,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107650,35.03,0.47,101,45974,NULL,NULL,'H','NGC 5081',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107651,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107651,35.09,0.46,104,45974,NULL,NULL,'J','NGC 5081',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107652,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107652,35.13,0.45,106,45974,NULL,NULL,'K','NGC 5081',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107653,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107653,35.13,0.38,106,45974,75,NULL,'W91CL, r, inv','NGC 5081',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107654,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107654,35.19,0.2,109,45974,74.4,NULL,NULL,'NGC 5081',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107655,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107655,35.2,0.12,110,45974,NULL,NULL,NULL,'NGC 5081',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107656,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107656,35.33,0.43,117,45974,75,NULL,'3.6 micron, color corrected','NGC 5081',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107657,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107657,35.67,0.43,136,45974,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5081',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107658,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107658,37.77,0.12,358,45975,70,NULL,NULL,'2MASX J13190904-0054509',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00007,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,199.787625,-0.91422,0.017,NULL,43085359907,673208748,10518886,17.3),(107659,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107659,37.5,0.46,316,45976,70,NULL,NULL,'2MASX J13191009+3922359',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000147,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,199.792166667,39.37661,0,NULL,59304043333,926625677,14478526,17),(107660,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107660,37.45,0.46,309,45977,70,NULL,NULL,'SDSS J131910.11+532953.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000165,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,199.792166667,53.49814,0.073,NULL,57415511526,897117367,14017458,18.2),(107661,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107661,38.21,0.46,439,45978,70,NULL,NULL,'2MASX J13191062+0004169',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000081,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,199.794208333,0.07142,0.027,NULL,58051269820,907051090,14172673,18.3),(107662,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107662,37.81,0.46,365,45979,70,NULL,NULL,'SDSS J131910.90+425623.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,199.7954583,42.93975,0,NULL,59311326053,926739469,14480304,18.4),(107663,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107663,36.03,0.46,161,45980,70,NULL,NULL,'2MASX J13191248+2623244',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.0001,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,199.802,26.39006,0.049,NULL,58709748972,917339827,14333434,16.4),(107664,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107664,34.37,0.5,75,45981,70,NULL,NULL,'NGC 5070',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000127,NULL,'14.5',0.7,'SA0-:',NULL,NULL,NULL,NULL,1,199.802333,-12.53989,0.077,NULL,43996493372,687445208,10741331,14.5),(107665,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107665,37.9,0.46,381,45982,70,NULL,NULL,'2MASX J13191284-0117259',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000086,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,199.803583333,-1.29053,0.021,NULL,43085212409,673206443,10518850,17.2),(107666,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107666,37.77,0.12,358,45983,70,NULL,NULL,'SDSS J131913.72-005246.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000074,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,199.807208333,-0.87964,0.017,NULL,43085391650,673209244,10518894,18.2),(107667,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107667,37.14,0.56,268,45984,70,NULL,NULL,'2MASX J13191498-3710469',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000107,NULL,'16.0b',NULL,'BrClG','Group member, 4th ranked galaxy',NULL,NULL,NULL,1,199.8124583,-37.17964,0.165,NULL,46935545092,733367892,11458873,16),(107668,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107668,36.26,0.46,179,45985,70,NULL,NULL,'2MASX J13191507+0712123',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,199.812917,7.20336,0.046,NULL,58985288766,921645136,14400705,17.1),(107669,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107669,37.99,0.46,396,45986,70,NULL,NULL,'SDSS J131915.65+062734.2',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',NULL,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,199.8152083,6.45953,0.018,NULL,58984686418,921635725,14400558,18.3),(107670,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107670,37.77,0.12,358,45987,70,NULL,NULL,'2MASX J13191671-0059439',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000213,NULL,'15.4g',0.52,'BrClG',NULL,NULL,NULL,NULL,1,199.819708333,-0.99544,0.017,NULL,43085349943,673208592,10518884,15.4),(107671,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107671,37.16,0.46,270,45988,70,NULL,NULL,'2MASX J13191669+2532164',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,199.81975,25.53792,0,NULL,58707954076,917311782,14332996,17.8),(107672,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107672,37.82,0.46,366,45989,70,NULL,NULL,'SDSS J131917.76+151842.6',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,199.8240417,15.31186,0,NULL,59010994032,922046781,14406980,17.6),(107673,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107673,37.98,0.46,394,45990,70,NULL,NULL,'SDSS J131918.03+081955.2',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.8g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,199.825166667,8.33203,0,NULL,58985879360,921654365,14400849,17.8),(107674,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107674,37.9,0.46,381,45991,70,NULL,NULL,'2MASX J13191818+4326217',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000177,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,199.825667,43.43953,0,NULL,59311429880,926741091,14480329,16.9),(107675,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107675,37.13,0.46,266,45992,70,NULL,NULL,'2MASX J13191824+3450044',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,199.826166667,34.83456,0.011,NULL,59172336709,924567761,14446371,17.2),(107676,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107676,34.74,0.46,88.6,45993,70,NULL,NULL,'NGC 5080',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000157,NULL,'14.6',0.3,NULL,NULL,NULL,NULL,NULL,1,199.830083333,8.42914,0,NULL,58985902191,921654721,14400855,14.6),(107677,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107677,37.77,0.12,358,45994,70,NULL,NULL,'SDSS J131919.64-005247.9',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000076,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,199.831875,-0.88,0.017,NULL,43085395025,673209297,10518895,17.8),(107678,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107678,36.25,0.61,178,45995,70,NULL,NULL,'2MASX J13191968-3328075',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00004,NULL,'14.5',NULL,'(R\')Sa?',NULL,NULL,NULL,NULL,1,199.8319583,-33.46881,0.201,NULL,46873148487,732392945,11443639,14.5),(107679,'FP','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107679,38.21,0.27,438,45996,70,NULL,NULL,'SDSS J131919.85+161512.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,199.83275,16.25361,0,NULL,59013634076,922088032,14407625,18.3),(107680,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107680,32,0.4,25.2,45997,75,NULL,NULL,'NGC 5073',NULL,'2008Ap.....51..336K',2008,1,4.14,NULL,'G',0.00002,NULL,'13.50',0.58,'SB(s)c? sp     HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,199.8360417,-14.84453,0.105,NULL,44002925799,687545715,10742901,13.5),(107681,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107681,32.36,0.4,29.6,45997,NULL,NULL,NULL,'NGC 5073',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107682,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,'R',107682,32.39,0.49,30,45997,75,NULL,'IR','NGC 5073',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107683,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107683,32.4,0.2,30.2,45997,74.4,NULL,NULL,'NGC 5073',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107684,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107684,32.45,0.43,30.9,45997,75,NULL,'3.6 micron, color corrected','NGC 5073',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107685,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107685,32.49,0.42,31.4,45997,NULL,NULL,NULL,'NGC 5073',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107686,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107686,32.48,0.43,31.4,45997,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5073',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107687,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107687,32.5,0.42,31.6,45997,NULL,NULL,'Malmquist cor.','NGC 5073',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107688,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107688,32.98,NULL,39.5,45997,NULL,NULL,'Dipole','NGC 5073',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107689,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107689,32.98,NULL,39.5,45997,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 5073',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107690,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107690,32.99,NULL,39.6,45997,NULL,NULL,'Dipole + Quadrupole','NGC 5073',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107691,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107691,33.05,NULL,40.8,45997,NULL,NULL,NULL,'NGC 5073',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107692,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:24','1',NULL,NULL,107692,33.36,0.3,47.1,45997,55,NULL,'B','NGC 5073',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107693,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107693,37.63,0.27,336,45998,70,NULL,NULL,'SDSS J131920.91+051238.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,199.837167,5.21058,0,NULL,58932967365,920827615,14387931,18),(107694,'D-Sigma','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107694,33.3,0.4,45.6,45999,75,NULL,'Edat, raw','NGC 5090A',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000107,NULL,'13.96',0.6,'S0^0^','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,199.8379583,-43.64939,0.477,NULL,46963301859,733801591,11465649,13.96),(107695,'D-Sigma','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107695,33.45,0.4,49,45999,75,NULL,'Edat, cor','NGC 5090A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107696,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107696,32.99,0.52,39.6,45999,70,NULL,NULL,'NGC 5090A',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107697,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107697,33.38,0.45,47.3,45999,NULL,NULL,'K','NGC 5090A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107698,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107698,33.51,0.4,50.3,45999,NULL,NULL,'mean','NGC 5090A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107699,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107699,37.87,0.33,375,46000,70,NULL,NULL,'SDSS J131921.32-005522.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000078,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,199.838833,-0.923,0.017,NULL,43085354788,673208668,10518885,18.1),(107700,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107700,37.87,0.33,375,46001,70,NULL,NULL,'2MASX J13192151-0057519',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00009,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,199.839667,-0.96442,0.017,NULL,43085355947,673208686,10518885,17.5),(107701,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107701,37.73,0.46,351,46002,70,NULL,NULL,'2MASX J13192254+5934132',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000133,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,199.844,59.57039,0,NULL,57391095436,896735866,14011497,17.9),(107702,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107702,37.62,0.33,334,46003,70,NULL,NULL,'2MASX J13192309+2116454',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,199.846083,21.27933,0.063,NULL,58847367563,919490118,14367033,17.8),(107703,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107703,35.94,0.72,154,46004,70,NULL,NULL,'2MASX J13192322-1851259',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.97',NULL,NULL,NULL,NULL,NULL,NULL,1,199.8467917,-18.85736,0.249,NULL,43805641975,684463155,10694736,15.97),(107704,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107704,38.21,0.27,438,46005,70,NULL,NULL,'2MASX J13192335+1614126',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.55',0.23,NULL,NULL,NULL,NULL,NULL,1,199.847333,16.23678,0,NULL,59013628972,922087952,14407624,18.55),(107705,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107705,35.56,0.49,129,46006,75,NULL,'IR','FGC 1597',NULL,'2011yCatp016004901K',2011,1,0.86,NULL,'G',0.000205,NULL,'17.1g',0.11,'Scd',NULL,NULL,NULL,NULL,1,199.85225,43.82533,0,NULL,59311114123,926736158,14480252,17.1),(107706,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107706,35.99,NULL,158,46006,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1597',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107707,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107707,36.01,NULL,159,46006,NULL,NULL,'Dipole + Quadrupole','FGC 1597',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107708,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107708,36.03,NULL,161,46006,NULL,NULL,NULL,'FGC 1597',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107709,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107709,36.04,NULL,161,46006,NULL,NULL,'Dipole','FGC 1597',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107710,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107710,38.09,0.46,415,46007,70,NULL,NULL,'2MASX J13192455+3721129',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,199.852417,37.35347,0,NULL,59297155762,926518058,14476844,17.5),(107711,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107711,37.65,0.46,338,46008,70,NULL,NULL,'SDSS J131924.79+484226.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000148,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,199.853333,48.70731,0,NULL,59275962033,926186906,14471670,18.4),(107712,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107712,34.77,0.65,90,46009,NULL,NULL,'Malmquist cor.','ESO 324- G 005',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.80',0.4,'Sb',NULL,NULL,NULL,NULL,1,199.8567083,-39.15353,0.237,NULL,46938741687,733417838,11459653,14.8),(107713,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107713,34.92,0.6,96.5,46009,NULL,NULL,NULL,'ESO 324- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107714,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107714,34.96,0.2,98.2,46009,74.4,NULL,NULL,'ESO 324- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107715,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107715,35.23,0.53,111,46010,70,NULL,NULL,'2MASX J13192575-3249325',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000097,NULL,'16.9',NULL,'S0',NULL,NULL,NULL,NULL,1,199.857416667,-32.82575,0.197,NULL,46868712163,732323627,11442556,16.9),(107716,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107716,38.77,0.46,568,46011,70,NULL,NULL,'2MASX J13192589+6654462',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000101,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,199.857583,66.91278,0.033,NULL,57908185290,904815395,14137740,17.9),(107717,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107717,37.77,0.12,358,46012,70,NULL,NULL,'2MASX J13192604-0043507',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000068,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,199.858458333,-0.73072,0.029,NULL,43085341155,673208455,10518882,17.7),(107718,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107718,37.82,0.46,366,46013,70,NULL,NULL,'2MASX J13192637+2311184',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,199.860083,23.18858,NULL,NULL,58846489519,919476398,14366818,17.6),(107719,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107719,38.5,0.46,501,46014,70,NULL,NULL,'2MASX J13192648+5244103',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000143,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,199.860625,52.73611,0,NULL,57412600064,897071876,14016748,18.7),(107720,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107720,38.09,0.46,416,46015,70,NULL,NULL,'2MASX J13192748+1536376',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,199.864541667,15.61058,0,NULL,59013012896,922078326,14407473,17.5),(107721,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107721,37.75,0.46,354,46016,70,NULL,NULL,'2MASX J13192777+5547012',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000148,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,199.866083,55.78358,0.005,NULL,57419217567,897175274,14018363,18.3),(107722,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107722,36.46,0.46,196,46017,70,NULL,NULL,'2MASX J13192848+5814442',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000173,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,199.8685417,58.24558,0.005,NULL,57434219908,897409686,14022026,16.6),(107723,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107723,35.06,0.2,103,46018,74.4,NULL,NULL,'CGCG 101-022',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.0003,NULL,'15.6',0.5,NULL,NULL,NULL,NULL,NULL,1,199.868791667,14.57761,0,NULL,59018748668,922167947,14408874,15.6),(107724,'IRAS','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107724,31.42,0.8,19.2,46019,75,NULL,'MAT, I','ESO 382- G 041',NULL,'1997ApJS..109..333W',1997,1,2.44,NULL,'G',0.000027,NULL,'15.34',0.22,'Sd',NULL,NULL,NULL,NULL,1,199.8700417,-35.10158,0.121,NULL,46874246901,732410107,11443907,15.34),(107725,'IRAS','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107725,31.44,0.8,19.5,46019,75,NULL,'HMCL, I','ESO 382- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107726,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107726,31.81,0.32,23,46019,85,NULL,'I, inv','ESO 382- G 041',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107727,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107727,31.83,NULL,23.3,46019,NULL,NULL,NULL,'ESO 382- G 041',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107728,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107728,31.86,0.32,23.5,46019,85,NULL,'I, raw','ESO 382- G 041',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107729,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107729,32.04,0.43,25.6,46019,75,NULL,'3.6 micron, color + selection bias corrected','ESO 382- G 041',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107730,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107730,32.14,0.43,26.8,46019,75,NULL,'3.6 micron, color corrected','ESO 382- G 041',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107731,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107731,32.17,0.43,27.2,46019,75,NULL,'MAT, I, inv','ESO 382- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107732,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107732,32.18,0.2,27.3,46019,74.4,NULL,NULL,'ESO 382- G 041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107733,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107733,32.27,0.43,28.4,46019,75,NULL,'MAT, I, raw','ESO 382- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107734,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107734,32.33,NULL,29.3,46019,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 382- G 041',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107735,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107735,32.35,NULL,29.5,46019,NULL,NULL,'Dipole + Quadrupole','ESO 382- G 041',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107736,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107736,32.36,NULL,29.7,46019,NULL,NULL,'Dipole','ESO 382- G 041',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107737,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107737,32.5,0.67,31.6,46019,NULL,NULL,NULL,'ESO 382- G 041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107738,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107738,32.5,0.4,31.6,46019,75,NULL,'HMCL, I, inv','ESO 382- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107739,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107739,32.53,0.4,32.1,46019,NULL,NULL,NULL,'ESO 382- G 041',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107740,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107740,32.54,0.4,32.2,46019,75,NULL,'HMCL, I, raw','ESO 382- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107741,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107741,32.62,0.43,33.5,46019,75,NULL,'MAT, I, cor','ESO 382- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107742,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107742,32.82,0.49,36.7,46019,75,NULL,'IR','ESO 382- G 041',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107743,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107743,32.86,0.4,37.3,46019,75,NULL,'HMCL, I, cor','ESO 382- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107744,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107744,32.86,0.57,37.4,46019,NULL,NULL,'Malmquist cor.','ESO 382- G 041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107745,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107745,32.88,0.4,37.6,46019,75,NULL,NULL,'ESO 382- G 041',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107746,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107746,37.96,0.46,391,46020,70,NULL,NULL,'2MASX J13192889+3756009',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000177,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,199.87025,37.93347,0,NULL,59297571692,926524557,14476946,16.3),(107747,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107747,36.75,0.53,224,46021,70,NULL,NULL,'2MASX J13192912-3331055',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.33',NULL,'*+E',NULL,NULL,NULL,NULL,1,199.871667,-33.51858,0.201,NULL,46873137090,732392767,11443636,14.33),(107748,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107748,37.11,0.46,264,46022,70,NULL,NULL,'2MASX J13192995+3015414',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000173,NULL,'16.9g',0.23,'E2',NULL,NULL,NULL,NULL,1,199.874667,30.26142,0.02,NULL,58679122841,916861294,14325957,16.9),(107749,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107749,35.32,0.46,116,46023,70,NULL,NULL,'2MASX J13193157+5517502',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000162,NULL,'15.4g',0.52,'AGN+SF',NULL,NULL,NULL,NULL,1,199.881375,55.29736,0.013,NULL,57426732154,897292689,14020198,15.4),(107750,'D-Sigma','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107750,32.75,0.4,35.4,46024,75,NULL,'Edat, raw','NGC 5077',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.00007,NULL,'12.38',1.5,'E3-4;LINER     Sy1.9','in a pair',NULL,NULL,'Flat-Spectrum Radio Source',1,199.8819583,-12.65697,0.073,NULL,43996952742,687452386,10741443,12.38),(107751,'D-Sigma','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107751,32.9,0.4,38,46024,75,NULL,'Edat, cor','NGC 5077',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107752,'Faber-Jackson','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107752,32.19,0.63,27.4,46024,95,NULL,'Michard 1979b, c','NGC 5077',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107753,'Faber-Jackson','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107753,32.26,0.37,28.3,46024,95,NULL,'Weighted Mean','NGC 5077',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107754,'Faber-Jackson','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107754,32.51,0.46,31.8,46024,95,NULL,'Michard 1979a','NGC 5077',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107755,'Faber-Jackson','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107755,34.35,0.81,74.1,46024,55,NULL,'Visvanathan & Sandage 1979','NGC 5077',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107756,'Tully est','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107756,33.04,0.8,40.6,46024,75,NULL,'B','NGC 5077',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107757,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107757,33,0.4,39.8,46024,NULL,NULL,'mean','NGC 5077',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107758,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107758,33.13,0.45,42.2,46024,NULL,NULL,'K','NGC 5077',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107759,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107759,35.78,0.49,143,46025,70,NULL,NULL,'ESO 508-IG 045 NED01',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00008,NULL,'15.71',0.5,'E              HII',NULL,NULL,NULL,NULL,1,199.88325,-24.48422,0.397,NULL,43344152303,677252379,10582068,15.71),(107760,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107760,36.62,0.46,211,46026,70,NULL,NULL,'2MASX J13193217+4023369',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,199.88425,40.39361,0,NULL,59303388504,926615445,14478366,17.7),(107761,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107761,37.66,0.46,340,46027,70,NULL,NULL,'2MASX J13193313+4515009',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,199.888,45.25039,0,NULL,59281888264,926279504,14473117,17.9),(107762,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107762,35.65,0.54,135,46028,70,NULL,NULL,'II SZ 033',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.5',0.2,'E0',NULL,NULL,NULL,NULL,1,199.892166667,-14.77289,0.097,NULL,44002951525,687546117,10742908,15.5),(107763,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107763,36.46,0.46,196,46029,70,NULL,NULL,'2MASX J13193498+1052399',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000179,NULL,'15.8g',0.46,NULL,NULL,NULL,NULL,NULL,1,199.8957917,10.87772,0.011,NULL,58946516995,921039328,14391239,15.8),(107764,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107764,35.97,0.46,156,46030,70,NULL,NULL,'MRK 1345',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'15.5',0.19,NULL,NULL,NULL,NULL,NULL,1,199.896875,20.13842,0.05,NULL,58840830044,919387969,14365437,15.5),(107765,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107765,36.34,0.23,186,46031,70,NULL,NULL,'2MASX J13193531+3139277',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000073,NULL,'15.8g',0.5,'E1',NULL,NULL,NULL,NULL,1,199.896958333,31.65781,0,NULL,59164280789,924441887,14444404,15.8),(107766,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107766,37.13,0.46,266,46032,70,NULL,NULL,'2MASX J13193567+1802344',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.35',0.16,NULL,NULL,NULL,NULL,NULL,1,199.898708333,18.04289,0,NULL,58829900798,919217199,14362768,18.35),(107767,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107767,38.09,0.46,415,46033,70,NULL,NULL,'2MASX J13193576-0002567',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000077,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,199.899083,-0.04914,0.013,NULL,43084977431,673202772,10518793,17.5),(107768,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107768,37.62,0.46,335,46034,70,NULL,NULL,'2MASXi J1319364+544855',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,199.901875,54.81547,0.013,NULL,57427310143,897301720,14020339,17.3),(107769,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107769,34.66,0.46,85.4,46035,70,NULL,NULL,'ARK 413',NULL,'2015arXiv151105856S',2015,1,0.87,NULL,'G',0.000085,NULL,'14.7g',0.66,'E0',NULL,NULL,NULL,NULL,1,199.902791667,-2.91206,0.045,NULL,43836770930,684949545,10702336,14.7),(107770,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107770,32.43,0.51,30.7,46036,NULL,NULL,NULL,'NGC 5079',NULL,'2009ApJS..182..474S',2009,1,1.6,NULL,'G',0.000027,NULL,'13.12',1,'SB(rs)bc pec:','in a pair',NULL,NULL,NULL,1,199.9085417,-12.69903,0.073,NULL,43996817082,687450266,10741410,13.12),(107771,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107771,32.47,0.2,31.2,46036,74.4,NULL,NULL,'NGC 5079',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107772,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107772,32.56,0.48,32.5,46036,NULL,NULL,'Malmquist cor.','NGC 5079',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107773,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107773,37.77,0.12,358,46037,70,NULL,NULL,'2MASX J13193865-0058407',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000066,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,199.910833,-0.97792,0.017,NULL,43085424751,673209761,10518902,17.8),(107774,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107774,34.98,0.65,99.2,46038,70,NULL,NULL,'VIII Zw 291',NULL,'2014MNRAS.445.2677S',2014,1,0.5,'6dF DR1 has z = 0.014160.','G',0.00015,NULL,'16.7',0.4,'E',NULL,NULL,NULL,NULL,1,199.911541667,-28.74006,0.233,NULL,43343906656,677248541,10582008,16.7),(107775,'Tully est','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107775,32.72,0.8,35.1,46039,75,NULL,'B','NGC 5089',NULL,'1988NBGC.C....0000T',1988,1,1.31,NULL,'G',0.000004,NULL,'14.0g',0.69,'Sb',NULL,NULL,NULL,'Emission-Line Galaxy',1,199.914,30.25656,0.02,NULL,58679340876,916864701,14326010,14),(107776,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107776,33.94,0.2,61.4,46039,74.4,NULL,NULL,'NGC 5089',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107777,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107777,37.67,0.46,342,46040,70,NULL,NULL,'2MASX J13194073+4102100',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000196,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,199.919833,41.03631,0,NULL,59301377732,926584027,14477875,16.4),(107778,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107778,37.77,0.12,358,46041,70,NULL,NULL,'2MASX J13194131-0101017',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000073,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,199.922125,-1.01722,0.017,NULL,43085449641,673210150,10518908,17.5),(107779,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107779,36.96,0.46,246,46042,70,NULL,NULL,'2MASX J13194141+2124140',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',NULL,NULL,'16.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,199.922375,21.40394,0.065,NULL,58847219576,919487805,14366996,16.1),(107780,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107780,37.79,0.46,362,46043,70,NULL,NULL,'2MASX J13194199+1216419',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000147,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,199.925,12.27842,0.011,NULL,59015684292,922120067,14408126,17.6),(107781,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107781,37.47,0.33,312,46044,70,NULL,NULL,'2MASX J13194253-0129387',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000075,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,199.927166667,-1.49417,0.017,NULL,43086568919,673227639,10519181,16.9),(107782,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107782,36.77,0.46,226,46045,70,NULL,NULL,'2MASX J13194270+5212197',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,199.928167,52.20569,0,NULL,57411689507,897057648,14016525,18.1),(107783,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107783,37.43,0.46,307,46046,70,NULL,NULL,'2MASX J13194414+6336072',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000075,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,199.9337083,63.602,0.041,NULL,57359940108,896249064,14003891,17.4),(107784,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107784,36.14,0.46,169,46047,70,NULL,NULL,'2MASX J13194463+1021459',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000103,NULL,'15.4g',0.45,NULL,NULL,NULL,NULL,NULL,1,199.936,10.36278,0,NULL,58944288116,921004501,14390695,15.4),(107785,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107785,36.34,0.23,186,46048,70,NULL,NULL,'2MASX J13194502+3134277',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000093,NULL,'15.9g',0.45,'E0',NULL,NULL,NULL,NULL,1,199.9375,31.57431,0,NULL,59164108335,924439192,14444362,15.9),(107786,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107786,37.61,0.33,332,46049,70,NULL,NULL,'2MASX J13194516+6041202',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000172,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,199.938417,60.68903,0,NULL,57393123587,896767556,14011993,17.6),(107787,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107787,37.76,0.46,356,46050,70,NULL,NULL,'2MASX J13194524+3600221',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,199.9385,36.00622,0,NULL,59170288350,924535755,14445871,17.8),(107788,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107788,37.61,0.33,332,46051,70,NULL,NULL,'2MASX J13194523+6030432',NULL,'2015arXiv151105856S',2015,1,0.37,'One of two 6cm sources associated with [WB92] 1317+6046','G',0.000177,NULL,'16.8g',0.26,'AGN',NULL,NULL,NULL,NULL,1,199.938833,60.51197,0,NULL,57394249914,896785154,14012268,16.8),(107789,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107789,37.62,0.46,334,46052,70,NULL,NULL,'2MASX J13194568+1239590',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,199.940417,12.66633,0,NULL,59015704217,922120378,14408130,17.8),(107790,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107790,36.97,0.46,248,46053,70,NULL,NULL,'2MASX J13194619-0122207',NULL,'2015arXiv151105856S',2015,1,0.22,'CUYS (2005MNRAS.359..930B) give z = 0.2213.','G',0.000066,NULL,'17.8g',0.17,'ELG',NULL,NULL,NULL,NULL,1,199.942583,-1.37253,0.017,NULL,43087096722,673235886,10519310,17.8),(107791,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107791,37.73,0.46,352,46054,70,NULL,NULL,'2MASX J13194743+0018126',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00007,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,199.9475417,0.30361,0.088,NULL,58051467245,907054175,14172721,17.4),(107792,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107792,37.31,0.46,290,46055,70,NULL,NULL,'2MASX J13194813+6137532',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000154,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,199.9505417,61.63144,0.029,NULL,57392807025,896762609,14011915,16.8),(107793,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107793,37.91,0.46,381,46056,70,NULL,NULL,'SDSS J131948.13+655729.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00007,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,199.950625,65.95817,0.029,NULL,57877199542,904331242,14130175,18.4),(107794,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107794,36.47,0.27,197,46057,70,NULL,NULL,'2MASX J13194833+0725069',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.45',0.21,NULL,NULL,NULL,NULL,NULL,1,199.951417,7.41853,0.09,NULL,58988356482,921693070,14401454,17.45),(107795,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107795,37.88,0.15,376,46058,70,NULL,NULL,'SDSS J131949.86+172601.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,199.9577917,17.43383,0,NULL,58830249971,919222655,14362853,18.5),(107796,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107796,37.06,0.46,258,46059,70,NULL,NULL,'2MASX J13195017+6122312',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,199.9592083,61.37547,0.017,NULL,57392970234,896765159,14011955,16.9),(107797,'SNIa','2016-12-15 15:15:12','2016-12-16 11:20:25','1','PTF10hml','N',107797,37.11,0.03,251,46060,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10hml',0.0534,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107798,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107798,34.3,0.46,72.3,46061,70,NULL,NULL,'NGC 5092',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.00005,NULL,'14.31',1,'E',NULL,NULL,NULL,NULL,1,199.9647083,22.99989,NULL,NULL,58846522929,919476920,14366826,14.31),(107799,'IRAS','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107799,31.49,0.8,19.9,46062,75,NULL,'MAT, I','UGCA 348',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000017,NULL,'13.23',1.4,'SB(rs)c        HII',NULL,NULL,NULL,NULL,1,199.966667,-22.27883,0.273,NULL,43811884291,684560692,10696260,13.23),(107800,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107800,30.27,0.43,11.3,46062,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 348',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107801,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107801,30.48,0.43,12.5,46062,75,NULL,'3.6 micron, color corrected','UGCA 348',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107802,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107802,30.61,0.2,13.2,46062,74.4,NULL,NULL,'UGCA 348',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107803,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107803,30.85,0.32,14.8,46062,85,NULL,'I, raw','UGCA 348',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107804,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107804,30.85,0.32,14.8,46062,85,NULL,'I, inv','UGCA 348',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107805,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107805,31.29,0.43,18.1,46062,75,NULL,'MAT, I, raw','UGCA 348',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107806,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107806,31.32,0.43,18.4,46062,75,NULL,'MAT, I, inv','UGCA 348',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107807,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107807,31.57,0.43,20.7,46062,75,NULL,'MAT, I, cor','UGCA 348',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107808,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107808,32.42,0.47,30.5,46062,NULL,NULL,'H','UGCA 348',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107809,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107809,32.45,0.46,30.9,46062,NULL,NULL,'J','UGCA 348',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107810,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107810,32.49,0.45,31.5,46062,NULL,NULL,'K','UGCA 348',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107811,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107811,33.31,0.4,45.9,46062,NULL,NULL,'mean','UGCA 348',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107812,'Tully-Fisher','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,NULL,107812,33.31,0.08,46,46062,NULL,NULL,NULL,'UGCA 348',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107813,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107813,37.29,0.46,287,46063,70,NULL,NULL,'2MASX J13195220+1332049',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000173,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,199.967458333,13.53481,0,NULL,59021737700,922214651,14409603,16.7),(107814,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107814,37.51,0.46,318,46064,70,NULL,NULL,'2MASXi J1319523+542116',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,199.968125,54.35453,0.012,NULL,57413607198,897087612,14016993,18),(107815,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107815,37,0.46,252,46065,70,NULL,NULL,'2MASX J13195241+3221297',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000107,NULL,'16.6',0.19,'E3',NULL,NULL,NULL,NULL,1,199.9682083,32.35822,NULL,NULL,59163425146,924428517,14444195,16.6),(107816,'TRGB','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'RN',107816,27.67,0.38,3.42,46066,NULL,NULL,NULL,'CenA-MM-Dw5',NULL,'2015arXiv151205366C',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107817,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107817,36.95,0.46,245,46067,70,NULL,NULL,'2MASX J13195339+3442447',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,199.9724583,34.71256,0.011,NULL,59173099395,924579678,14446557,17.8),(107818,'FP','2016-12-15 15:15:12','2016-12-16 11:20:25','1',NULL,'R',107818,36.33,0.46,184,46068,70,NULL,NULL,'2MASX J13195453+3329467',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000103,NULL,'15.7g',0.38,'E1',NULL,NULL,NULL,NULL,1,199.977416667,33.49631,0.009,NULL,59171424950,924553514,14446148,15.7),(107819,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107819,37.29,0.46,287,46069,70,NULL,NULL,'2MASX J13195456+1239179',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000135,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,199.9774583,12.65508,0,NULL,59015745928,922121030,14408141,17.8),(107820,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107820,38.2,0.46,436,46070,70,NULL,NULL,'2MASX J13195479+2100200',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,199.97825,21.00556,0.058,NULL,58851490109,919554532,14368039,17.3),(107821,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107821,37.81,0.46,366,46071,70,NULL,NULL,'SDSS J131955.19+004228.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000068,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,199.979958333,0.70786,0.037,NULL,58052155565,907064930,14172889,18.5),(107822,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107822,35.4,0.46,120,46072,70,NULL,NULL,'SDSS J131956.29+292653.3',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.3g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,199.9845417,29.44817,0.019,NULL,58712336081,917380251,14334066,16.3),(107823,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107823,35.27,0.46,113,46073,70,NULL,NULL,'UGC 08377',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.000083,NULL,'14.8g',0.67,'E?',NULL,NULL,NULL,NULL,1,199.9847917,30.119,0.02,NULL,58679211890,916862685,14325979,14.8),(107824,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107824,38.06,0.46,410,46074,70,NULL,NULL,'2MASX J13195638+0752088',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,199.9850417,7.86922,0.006,NULL,58988296723,921692136,14401439,17.3),(107825,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107825,37.88,0.15,376,46075,70,NULL,NULL,'SDSS J131956.45+172307.3',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.1g',0.35,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,199.9852083,17.38539,0,NULL,58830256486,919222757,14362855,16.1),(107826,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107826,38.34,0.46,465,46076,70,NULL,NULL,'2MASX J13195741+1442389',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,199.989375,14.71072,0,NULL,59018795046,922168672,14408885,18.1),(107827,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107827,37.34,0.46,294,46077,70,NULL,NULL,'SDSS J131957.50+074553.4',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.5g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,199.989583,7.76483,0.031,NULL,58988372908,921693326,14401458,17.5),(107828,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107828,37.8,0.27,363,46078,70,NULL,NULL,'2MASX J13195781+3743012',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00007,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,199.990875,37.71708,0,NULL,59297836124,926528689,14477010,17.4),(107829,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107829,38.42,0.46,484,46079,70,NULL,NULL,'2MASX J13195830+3510357',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,199.992875,35.17656,0,NULL,59170759512,924543117,14445986,18),(107830,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107830,37.81,0.46,364,46080,70,NULL,NULL,'2MASX J13195858+1136278',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,199.9942083,11.60781,0.014,NULL,58944931489,921014554,14390852,17.6),(107831,'IRAS','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107831,32.58,0.8,32.8,46081,75,NULL,'MAT, I','ESO 269- G 085',NULL,'1997ApJS..109..333W',1997,1,2.4,NULL,'G',0.000021,NULL,'12.75',1.5,'SAB(rs)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,199.9955417,-47.28183,0.605,NULL,46956898222,733701534,11464086,12.75),(107832,'Sosies','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107832,31.56,0.16,20.5,46081,NULL,NULL,NULL,'ESO 269- G 085',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107833,'Tully est','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107833,32.89,0.8,37.9,46081,75,NULL,NULL,'ESO 269- G 085',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107834,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107834,31.94,0.32,24.4,46081,85,NULL,'I, raw','ESO 269- G 085',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107835,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107835,31.98,0.32,24.9,46081,85,NULL,'I, inv','ESO 269- G 085',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107836,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107836,32.2,0.43,27.5,46081,75,NULL,'MAT, I, raw','ESO 269- G 085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107837,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107837,32.2,0.43,27.5,46081,75,NULL,'3.6 micron, color + selection bias corrected','ESO 269- G 085',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107838,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107838,32.23,0.43,27.9,46081,75,NULL,'3.6 micron, color corrected','ESO 269- G 085',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107839,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107839,32.24,0.47,28.1,46081,NULL,NULL,'H','ESO 269- G 085',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107840,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107840,32.26,0.4,28.3,46081,NULL,NULL,NULL,'ESO 269- G 085',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107841,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107841,32.27,0.2,28.4,46081,74.4,NULL,NULL,'ESO 269- G 085',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107842,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107842,32.34,0.45,29.3,46081,NULL,NULL,'K','ESO 269- G 085',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107843,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107843,32.35,0.46,29.5,46081,NULL,NULL,'J','ESO 269- G 085',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107844,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107844,32.41,0.43,30.3,46081,75,NULL,'MAT, I, inv','ESO 269- G 085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107845,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107845,32.58,0.43,32.8,46081,75,NULL,'MAT, I, cor','ESO 269- G 085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107846,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107846,33.04,0.4,40.6,46081,NULL,NULL,'mean','ESO 269- G 085',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107847,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107847,33.25,0.09,44.8,46081,NULL,NULL,NULL,'ESO 269- G 085',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107848,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107848,37.88,0.15,376,46082,70,NULL,NULL,'SDSS J131959.83+173527.7',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.6g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,199.999291667,17.59106,0,NULL,58830346754,919224168,14362877,17.6),(107849,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107849,38.29,0.27,456,46083,70,NULL,NULL,'2MASX J13200269+4116207',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,200.0112917,41.27253,0,NULL,59301297582,926582774,14477855,17.9),(107850,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107850,38.01,0.46,400,46084,70,NULL,NULL,'SDSS J132002.79+240405.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.74',0.12,NULL,NULL,NULL,NULL,NULL,1,200.011625,24.06811,0,NULL,58791575523,918618367,14353411,18.74),(107851,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107851,37.4,0.46,302,46085,70,NULL,NULL,'2MASX J13200317+1056528',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000183,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,200.0132917,10.94806,0.011,NULL,58946746298,921042910,14391295,16.9),(107852,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107852,34.6,0.48,83.2,46086,70,NULL,NULL,'VV 802 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15',0.4,'SA:0o pec',NULL,NULL,NULL,NULL,1,200.019417,-17.12169,0.177,NULL,43776591383,684009240,10687644,15),(107853,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107853,38.29,0.27,456,46087,70,NULL,NULL,'2MASX J13200511+4124307',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000167,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,200.0215,41.4085,0,NULL,59301244054,926581938,14477842,16.7),(107854,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107854,37.29,0.46,287,46088,70,NULL,NULL,'2MASX J13200557+1414569',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00009,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,200.0232917,14.24917,0.011,NULL,59018707018,922167297,14408864,16.5),(107855,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107855,37.49,0.46,315,46089,70,NULL,NULL,'SDSS J132006.86+142318.0',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,200.028625,14.38833,0,NULL,59018714474,922167413,14408865,17),(107856,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107856,37.9,0.46,380,46090,70,NULL,NULL,'2MASX J13200692+5405368',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,200.0287083,54.09361,0.009,NULL,57413687669,897088869,14017013,17.6),(107857,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107857,35.52,0.46,127,46091,70,NULL,NULL,'IC 0882',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.00014,NULL,'14.69',0.9,'S?','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,200.028916667,15.89814,0,NULL,59013791549,922090492,14407663,14.69),(107858,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107858,37.69,0.15,345,46092,70,NULL,NULL,'2MASX J13200727+5858199',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000145,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,200.0305,58.97228,0,NULL,57389598723,896712480,14011132,17.9),(107859,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107859,35.95,0.16,155,46093,70,NULL,NULL,'2MASX J13200767+3251216',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000103,NULL,'15.7g',0.44,NULL,NULL,NULL,NULL,NULL,1,200.031833,32.85614,0.005,NULL,59163322039,924426906,14444170,15.7),(107860,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107860,38.39,0.46,476,46094,70,NULL,NULL,'SDSS J132007.67+025615.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000147,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,200.032,2.93775,0,NULL,58935275060,920863672,14388494,18.6),(107861,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107861,37.88,0.15,376,46095,70,NULL,NULL,'2MASX J13200804+1719329',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.59',0.18,NULL,NULL,NULL,NULL,NULL,1,200.033417,17.32581,0.011,NULL,58830244663,919222572,14362852,18.59),(107862,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107862,35.8,0.7,144,46096,70,NULL,NULL,'ESO 269- G 086',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.56',1,'SA(s)a',NULL,NULL,NULL,NULL,1,200.0337083,-45.07397,0.401,NULL,46953503967,733648499,11463257,15.56),(107863,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107863,37.76,0.46,356,46097,70,NULL,NULL,'2MASX J13200944-0302186',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00008,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,200.0392917,-3.03858,0.041,NULL,43836821235,684950331,10702348,17.7),(107864,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107864,36.92,0.66,242,46098,70,NULL,NULL,'2MASX J13200954-3324027',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,200.0397917,-33.40075,0.201,NULL,46872958616,732389978,11443593,15.6),(107865,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107865,35.95,0.16,155,46099,70,NULL,NULL,'2MASX J13200994+3323409',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00009,NULL,'15.9g',0.44,'E0',NULL,NULL,NULL,NULL,1,200.0412917,33.39464,0.009,NULL,59171432929,924553639,14446150,15.9),(107866,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107866,38.29,0.27,456,46100,70,NULL,NULL,'2MASX J13201034+4112338',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,200.04325,41.20947,0,NULL,59301283465,926582554,14477852,17.9),(107867,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107867,36.47,0.27,197,46101,70,NULL,NULL,'2MASX J13201112+0736049',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.83',0.16,NULL,NULL,NULL,NULL,NULL,1,200.046375,7.60133,0.031,NULL,58988423148,921694111,14401470,17.83),(107868,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107868,37.99,0.46,397,46102,70,NULL,NULL,'SDSS J132011.75+211942.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'19.00',0.15,NULL,NULL,NULL,NULL,NULL,1,200.049,21.32847,0.063,NULL,58848088791,919501387,14367209,19),(107869,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107869,36.81,0.46,230,46103,70,NULL,NULL,'2MASX J13201259+0813239',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,200.052417,8.22342,0,NULL,58986393422,921662397,14400974,17),(107870,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107870,37.88,0.15,376,46104,70,NULL,NULL,'2MASX J13201275+1712234',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'18.21',0.25,'BrClG',NULL,NULL,NULL,NULL,1,200.053125,17.20642,0,NULL,58829743381,919214740,14362730,18.21),(107871,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107871,36.95,0.46,246,46105,70,NULL,NULL,'SDSS J132013.35+284529.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000127,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,200.055666667,28.75831,0.008,NULL,58715358590,917427477,14334804,18.1),(107872,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107872,37.8,0.27,363,46106,70,NULL,NULL,'2MASX J13201388+3747378',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00009,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,200.057791667,37.79375,0,NULL,59297619973,926525312,14476958,17.8),(107873,'IRAS','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107873,30.98,0.8,15.7,46107,75,NULL,'MAT, I','ESO 382- G 045',NULL,'1997ApJS..109..333W',1997,1,3.5,NULL,'G',0.00001,NULL,'13.99',1.6,'SB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,200.060083,-36.04347,0.173,NULL,46873521168,732398768,11443730,13.99),(107874,'Tully est','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107874,31.63,0.8,21.2,46107,75,NULL,NULL,'ESO 382- G 045',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107875,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107875,30.41,0.32,12.1,46107,85,NULL,'I, inv','ESO 382- G 045',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107876,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107876,30.45,0.32,12.3,46107,85,NULL,'I, raw','ESO 382- G 045',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107877,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107877,30.58,0.2,13.1,46107,74.4,NULL,NULL,'ESO 382- G 045',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107878,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107878,30.69,0.4,13.7,46107,NULL,NULL,NULL,'ESO 382- G 045',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107879,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107879,30.74,0.55,14,46107,NULL,NULL,NULL,'ESO 382- G 045',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107880,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107880,30.91,0.39,15.2,46107,73,NULL,'opt','ESO 382- G 045',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107881,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107881,30.99,0.43,15.7,46107,75,NULL,'MAT, I, inv','ESO 382- G 045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107882,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107882,31,0.49,15.8,46107,NULL,NULL,'Malmquist cor.','ESO 382- G 045',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107883,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107883,31.08,0.43,16.5,46107,75,NULL,'MAT, I, raw','ESO 382- G 045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107884,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107884,31.41,0.43,19.2,46107,75,NULL,'MAT, I, cor','ESO 382- G 045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107885,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107885,35.95,0.16,155,46108,70,NULL,NULL,'NGC 5098 NED02',NULL,'2015arXiv151105856S',2015,1,0.89,'Incorrectly called \'NGC 5096\' in MCG.','G',0.000113,NULL,'14.8g',0.71,'S?;BrClG',NULL,NULL,NULL,NULL,1,200.061375,33.14342,0.007,NULL,59163283700,924426307,14444161,14.8),(107886,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107886,34.44,0.33,77.2,46109,70,NULL,NULL,'CGCG 160-201',NULL,'2015arXiv151105856S',2015,1,0.93,NULL,'G',0.000073,NULL,'14.7g',0.57,'E5','Group member',NULL,NULL,NULL,1,200.0615,30.98781,0.032,NULL,59161420838,924397200,14443706,14.7),(107887,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107887,37.88,0.15,376,46110,70,NULL,NULL,'2MASX J13201527+1712224',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,200.0635,17.20633,0,NULL,58829743531,919214742,14362730,17.6),(107888,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107888,35.95,0.16,155,46111,70,NULL,NULL,'2MASX J13201561+3317509',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00013,NULL,'16.5',0.26,'E2',NULL,NULL,NULL,NULL,1,200.064917,33.29753,0.009,NULL,59171465349,924554146,14446158,16.5),(107889,'Faber-Jackson','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107889,33.51,1.31,50.4,46112,95,NULL,'Weighted Mean','NGC 5084',NULL,'1984ApJS...56...91D',1984,1,9.3,'Confused and extended HIPASS source','G',0.00001,NULL,'11.41',1.7,'S0       poss. LINER','Line-of-sight pair member',NULL,NULL,NULL,1,200.0705,-21.82758,0.325,NULL,43812436937,684569327,10696395,11.41),(107890,'Faber-Jackson','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107890,35.32,1.61,116,46112,55,NULL,'Visvanathan & Sandage 1979','NGC 5084',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107891,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107891,31.12,0.54,16.7,46112,70,NULL,NULL,'NGC 5084',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107892,'Tully est','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107892,32.11,0.8,26.4,46112,75,NULL,'B','NGC 5084',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107893,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107893,30.74,0.45,14,46112,NULL,NULL,'K','NGC 5084',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107894,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107894,31.96,0.4,24.7,46112,NULL,NULL,'mean','NGC 5084',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107895,'Ring Diameter','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107895,32.3,0.98,29,46113,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5085',NULL,'1981ApJS...45..541P',1981,1,3.4,'Extended HIPASS source','G',0.00001,NULL,'12.97',3,'SA(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,200.0739583,-24.44014,0.261,NULL,43289655619,676400869,10568763,12.97),(107896,'Ring Diameter','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107896,33.5,0.76,51,46113,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5085',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107897,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107897,32.31,0.4,28.9,46113,75,NULL,'B','NGC 5085',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107898,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107898,37.93,0.16,386,46114,70,NULL,NULL,'SDSS J132017.95+210718.3',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'19.15',NULL,NULL,NULL,NULL,NULL,NULL,1,200.074958333,21.12181,0.063,NULL,58847208116,919487626,14366994,19.15),(107899,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107899,37.88,0.15,376,46115,70,NULL,NULL,'SDSS J132018.02+170626.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,200.075125,17.10747,0,NULL,58829721821,919214403,14362725,18.3),(107900,'SNII optical','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1999cr',NULL,107900,34.07,0.14,65.2,46116,NULL,NULL,'V, photospheric magnitude method','ESO 576- G 034',NULL,'2014AJ....148..107R',2014,1,1.2,NULL,'G',0.00015,NULL,'16.02',0.2,'S.../Irr',NULL,NULL,NULL,NULL,1,200.0760417,-20.14847,0.305,NULL,43807302173,684489096,10695142,16.02),(107901,'SNII optical','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1999cr',NULL,107901,34.12,0.06,66.7,46116,NULL,NULL,'I, photospheric magnitude method','ESO 576- G 034',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107902,'SNII optical','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1999cr',NULL,107902,34.56,0.18,78.5,46116,NULL,NULL,'SEAM','ESO 576- G 034',0.020197,'2009ApJ...694.1067P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107903,'SNII optical','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1999cr',NULL,107903,34.5,0.42,79.4,46116,NULL,NULL,'SCM, B','ESO 576- G 034',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107904,'SNII optical','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1999cr',NULL,107904,34.56,0.28,81.7,46116,NULL,NULL,'SCM, BVI','ESO 576- G 034',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107905,'SNII optical','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1999cr',NULL,107905,34.59,0.54,82.8,46116,NULL,NULL,'SCM, I','ESO 576- G 034',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107906,'SNII optical','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1999cr',NULL,107906,34.63,0.55,84.3,46116,NULL,NULL,'SCM, V','ESO 576- G 034',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107907,'SNII optical','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1999cr',NULL,107907,34.67,NULL,86,46116,NULL,NULL,NULL,'ESO 576- G 034',NULL,'2003MNRAS.346...97N',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107908,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107908,37.4,0.46,303,46117,70,NULL,NULL,'2MASX J13201863+2304505',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,200.0775,23.08083,NULL,NULL,58847021814,919484715,14366948,16.8),(107909,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107909,37.56,0.46,325,46118,70,NULL,NULL,'2MASX J13201888+4101539',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,200.078667,41.0315,0,NULL,59301420140,926584689,14477885,17.4),(107910,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107910,37.83,0.46,368,46119,70,NULL,NULL,'SDSS J132019.51+630205.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000073,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,200.081291667,63.03481,0.005,NULL,57358423052,896225360,14003521,18.1),(107911,'Tully est','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107911,31.94,0.8,24.5,46120,75,NULL,'B','NGC 5088',NULL,'1988NBGC.C....0000T',1988,1,2.6,'HOLM 515B is a star.','G',0.00001,NULL,'12.82',0.8,'SAB(s)bc:','Group member',NULL,NULL,NULL,1,200.084375,-12.57178,0.073,NULL,43996960583,687452509,10741445,12.82),(107912,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107912,31.41,0.2,19.1,46120,74.4,NULL,NULL,'NGC 5088',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107913,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107913,31.43,0.43,19.3,46120,75,NULL,'3.6 micron, color corrected','NGC 5088',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107914,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107914,31.47,0.43,19.7,46120,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5088',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107915,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107915,31.66,0.53,21.4,46120,NULL,NULL,NULL,'NGC 5088',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107916,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107916,31.71,0.51,22,46120,NULL,NULL,'Malmquist cor.','NGC 5088',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107917,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107917,31.71,0.4,22,46120,NULL,NULL,NULL,'NGC 5088',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107918,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107918,32.07,0.46,26,46120,NULL,NULL,'J','NGC 5088',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107919,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107919,32.08,0.4,26.1,46120,NULL,NULL,'mean','NGC 5088',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107920,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107920,32.13,0.47,26.6,46120,NULL,NULL,'H','NGC 5088',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107921,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107921,32.24,0.45,28.1,46120,NULL,NULL,'K','NGC 5088',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107922,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107922,36.43,0.2,193,46121,74.4,NULL,NULL,'UGC 08379',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.00015,NULL,'15.16',0.3,'Sbc',NULL,NULL,NULL,NULL,1,200.0850417,6.33622,0.01,NULL,58984716167,921636190,14400565,15.16),(107923,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107923,35.95,0.16,155,46122,70,NULL,NULL,'2MASX J13202356+3308079',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000143,NULL,'16.3',0.2,'E1',NULL,NULL,NULL,NULL,1,200.098125,33.1355,0.007,NULL,59163287182,924426362,14444161,16.3),(107924,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107924,36.56,0.46,205,46123,70,NULL,NULL,'2MASX J13202357+4616414',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,200.0982083,46.27825,0,NULL,59281270886,926269857,14472966,16.6),(107925,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107925,37.06,0.33,258,46124,70,NULL,NULL,'2MASX J13202364+6616373',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000084,NULL,'16.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,200.0982083,66.27706,0.029,NULL,57876591508,904321742,14130027,16.9),(107926,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107926,38.06,0.46,409,46125,70,NULL,NULL,'SDSS J132023.82+105550.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,200.09925,10.93067,0.011,NULL,58946742534,921042852,14391294,18.4),(107927,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107927,35.99,0.46,158,46126,70,NULL,NULL,'2MASX J13202410+2118245',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.00',0.21,NULL,NULL,NULL,NULL,NULL,1,200.1005417,21.30672,0.063,NULL,58848105449,919501647,14367213,17),(107928,'D-Sigma','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107928,31.96,0.4,24.7,46127,75,NULL,'Edat, raw','NGC 5087',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.000037,NULL,'13.11',1.7,'E+      poss. LINER?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,200.104,-20.611,0.293,NULL,43820160171,684690002,10698281,13.11),(107929,'D-Sigma','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107929,32.09,0.4,26.2,46127,75,NULL,'Edat, cor','NGC 5087',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107930,'Faber-Jackson','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107930,31.06,0.65,16.3,46127,95,NULL,'Weighted Mean','NGC 5087',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107931,'Faber-Jackson','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107931,32.79,0.81,36.1,46127,55,NULL,'Visvanathan & Sandage 1979','NGC 5087',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107932,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107932,31.97,0.53,24.8,46127,70,NULL,NULL,'NGC 5087',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107933,'Tully est','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107933,32.22,0.8,27.8,46127,75,NULL,'B','NGC 5087',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107934,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107934,31.93,0.4,24.3,46127,NULL,NULL,'mean','NGC 5087',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107935,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107935,32.35,0.45,29.5,46127,NULL,NULL,'K','NGC 5087',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107936,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107936,37.91,0.46,383,46128,70,NULL,NULL,'2MASX J13202509+4210454',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000145,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,200.10475,42.17939,0,NULL,59309196881,926706201,14479784,17.5),(107937,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107937,37.32,0.46,291,46129,70,NULL,NULL,'SDSS J132026.02+144556.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000123,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,200.108458333,14.76572,0,NULL,59021484301,922210692,14409542,18.3),(107938,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107938,37.88,0.15,376,46130,70,NULL,NULL,'2MASX J13202677+1701124',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'18.03',0.21,NULL,NULL,NULL,NULL,NULL,1,200.111667,17.02,0,NULL,58829796926,919215576,14362743,18.03),(107939,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107939,37.88,0.15,376,46131,70,NULL,NULL,'2MASXi J1320269+173027',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,200.1122083,17.50775,0.011,NULL,58830340944,919224077,14362876,17.8),(107940,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107940,37.93,0.16,386,46132,70,NULL,NULL,'2MASX J13202724+2117175',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,200.113708333,21.28825,0.063,NULL,58848104859,919501638,14367213,17.6),(107941,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107941,34.47,0.68,78.2,46133,NULL,NULL,NULL,'ESO 576- G 036',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000007,NULL,'15.97',0.7,'Sb:',NULL,NULL,NULL,NULL,1,200.113583333,-21.50961,0.325,NULL,43812622749,684572230,10696441,15.97),(107942,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107942,34.51,0.2,79.8,46133,74.4,NULL,NULL,'ESO 576- G 036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107943,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107943,34.56,0.65,81.6,46133,NULL,NULL,'Malmquist cor.','ESO 576- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107944,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107944,37.7,0.46,347,46134,70,NULL,NULL,'2MASX J13202753+6244211',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000175,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,200.114917,62.73933,0,NULL,57347245087,896050704,14000792,17.4),(107945,'IRAS','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107945,35.39,0.8,120,46135,75,NULL,'MAT, I','ESO 444- G 010',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000017,NULL,'15.37',0.3,'S?','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,200.1150417,-30.90858,0.177,NULL,46867630950,732306733,11442292,15.37),(107946,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107946,34.6,0.43,83,46135,75,NULL,'MAT, I, raw','ESO 444- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107947,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107947,34.69,0.32,86.5,46135,85,NULL,'I, raw','ESO 444- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107948,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107948,34.72,0.32,88.1,46135,85,NULL,'I, inv','ESO 444- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107949,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107949,34.79,0.43,90.7,46135,75,NULL,'MAT, I, inv','ESO 444- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107950,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107950,34.91,0.43,95.9,46135,75,NULL,'MAT, I, cor','ESO 444- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107951,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107951,35,0.62,100,46135,NULL,NULL,'Malmquist cor.','ESO 444- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107952,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107952,35.04,0.61,102,46135,NULL,NULL,NULL,'ESO 444- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107953,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107953,35.56,0.2,129,46135,74.4,NULL,NULL,'ESO 444- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107954,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107954,35.77,0.49,142,46135,75,NULL,'IR','ESO 444- G 010',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107955,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107955,37.5,0.33,317,46136,70,NULL,NULL,'2MASX J13202777+6018201',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,200.115875,60.30556,0,NULL,57394165283,896783832,14012247,17.2),(107956,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107956,38.4,0.46,479,46137,70,NULL,NULL,'SDSS J132029.25+290239.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000159,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,200.121916667,29.04428,0.008,NULL,58712526364,917383224,14334112,18.5),(107957,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107957,35.03,0.56,102,46138,70,NULL,NULL,'AM 1317-303 NED02',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000033,NULL,'14.33',0.7,'(R\')SB(s)a','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,200.122875,-30.89633,0.177,NULL,46867630275,732306723,11442292,14.33),(107958,'IRAS','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107958,32.11,0.8,26.5,46139,75,NULL,'MAT, I','ESO 508- G 051',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000017,NULL,'14.80',0.9,'SAB(s)dm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,200.123625,-26.08478,0.281,NULL,43346480446,677288756,10582636,14.8),(107959,'IRAS','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107959,32.17,0.8,27.2,46139,75,NULL,'A82, H','ESO 508- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107960,'IRAS','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107960,32.17,0.8,27.2,46139,75,NULL,'HMCL, I','ESO 508- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107961,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107961,31.39,0.4,19,46139,75,NULL,'HMCL, I, inv','ESO 508- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107962,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107962,31.48,0.4,19.8,46139,75,NULL,'HMCL, I, raw','ESO 508- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107963,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107963,31.61,0.47,21,46139,75,NULL,'A82, H, inv','ESO 508- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107964,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107964,31.75,0.4,22.3,46139,75,NULL,'HMCL, I, cor','ESO 508- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107965,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107965,31.82,0.47,23.1,46139,75,NULL,'A82, H, raw','ESO 508- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107966,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107966,32.18,0.47,27.3,46139,75,NULL,'A82, H, cor','ESO 508- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107967,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107967,32.2,0.32,27.5,46139,85,NULL,'I, inv','ESO 508- G 051',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107968,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107968,32.22,0.32,27.8,46139,85,NULL,'I, raw','ESO 508- G 051',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107969,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107969,32.5,0.43,31.6,46139,75,NULL,'MAT, I, inv','ESO 508- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107970,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107970,32.54,0.43,32.2,46139,75,NULL,'MAT, I, raw','ESO 508- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107971,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107971,32.6,0.54,33.1,46139,NULL,NULL,NULL,'ESO 508- G 051',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107972,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107972,32.64,0.2,33.7,46139,74.4,NULL,NULL,'ESO 508- G 051',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107973,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107973,32.66,0.38,34,46139,NULL,NULL,NULL,'ESO 508- G 051',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107974,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107974,32.78,0.5,35.9,46139,NULL,NULL,'Malmquist cor.','ESO 508- G 051',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107975,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107975,32.84,0.43,36.9,46139,75,NULL,'MAT, I, cor','ESO 508- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107976,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107976,34.4,0.27,75.8,46140,70,NULL,NULL,'IC 4226',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.00007,NULL,'14.9g',0.43,NULL,NULL,NULL,NULL,NULL,1,200.1267083,32.00392,NULL,NULL,59164250939,924441420,14444397,14.9),(107977,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107977,37.47,0.33,312,46141,70,NULL,NULL,'2MASX J13203145-0127187',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000097,NULL,'16.8g',0.27,'AGN',NULL,NULL,NULL,NULL,1,200.131125,-1.45514,0.037,NULL,43086660588,673229071,10519204,16.8),(107978,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107978,36.47,0.27,197,46142,70,NULL,NULL,'CGCG 044-073',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000183,NULL,'15.6',0.5,NULL,NULL,NULL,NULL,NULL,1,200.131667,7.54064,0.057,NULL,58988386857,921693544,14401461,15.6),(107979,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107979,30.5,NULL,12.6,46143,72,NULL,NULL,'UGC 08382',NULL,'2014Ap.....57..457K',2014,1,1,'Multiple SDSS entries describe this source.','G',0.000013,NULL,'14.82',0.6,'IBm',NULL,NULL,NULL,NULL,1,200.1347083,5.40686,0.024,NULL,58932257918,920816529,14387758,14.82),(107980,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107980,37.93,0.16,386,46144,70,NULL,NULL,'2MASX J13203340+2115055',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'18.98',NULL,NULL,NULL,NULL,NULL,NULL,1,200.139125,21.25153,0.063,NULL,58848063056,919500985,14367202,18.98),(107981,'Cepheids','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107981,27.61,0.11,3.33,46145,NULL,NULL,'HST KP Calibrated','NGC 5128 GROUP',NULL,'2000ApJ...529..745F',2000,1,NULL,NULL,'GGroup',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,200.141458333,-44.98092,0.401,NULL,46953508587,733648571,11463258,NULL),(107982,'PNLF','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107982,27.7,0.11,3.47,46145,NULL,NULL,'HST KP Calibrated','NGC 5128 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107983,'SBF','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107983,28.12,0.13,4.21,46145,NULL,NULL,'HST KP Calibrated, I','NGC 5128 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107984,'TRGB','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107984,27.93,0.13,3.85,46145,NULL,NULL,'HST KP Calibrated','NGC 5128 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107985,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107985,36.29,0.46,181,46146,70,NULL,NULL,'2MASX J13203411+3356408',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,200.142208333,33.94461,0,NULL,59172667370,924572927,14446451,16.8),(107986,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107986,35.38,0.57,119,46147,NULL,NULL,'Malmquist cor.','ESO 576- G 038',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.80',0.5,'Sb-c',NULL,NULL,NULL,NULL,1,200.145583333,-18.59578,0.253,NULL,43808824592,684512884,10695513,15.8),(107987,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107987,35.46,0.55,123,46147,NULL,NULL,NULL,'ESO 576- G 038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107988,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107988,35.5,0.2,126,46147,74.4,NULL,NULL,'ESO 576- G 038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107989,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 2000cu',NULL,107989,34.58,0.18,80.6,46148,70,NULL,'SALT 2','IC 0883',0.023299,'2013MNRAS.433.2240G',2013,1,0.56,NULL,'G',0.00001,NULL,'14.7g',0.49,'Sb sp          LIRG',NULL,NULL,NULL,NULL,1,200.14725,34.1395,0,NULL,59173014911,924578357,14446536,14.7),(107990,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107990,37.29,0.46,288,46149,70,NULL,NULL,'2MASX J13203578+3016018',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000187,NULL,'16.8g',0.24,'E4',NULL,NULL,NULL,NULL,1,200.149,30.26725,0.019,NULL,58679304083,916864126,14326001,16.8),(107991,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107991,36.52,0.95,202,46150,70,NULL,NULL,'2MASX J13203629-4109051',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.4,NULL,NULL,NULL,NULL,NULL,1,200.15125,-41.15147,0.413,NULL,46931270031,733301094,11457829,14.4),(107992,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107992,37.06,0.33,258,46151,70,NULL,NULL,'2MASX J13203623+6616224',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00008,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,200.151333,66.27294,0.029,NULL,57876583817,904321622,14130025,16.7),(107993,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107993,37.47,0.21,311,46152,70,NULL,NULL,'2MASX J13203762+1130580',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000163,NULL,'16.1g',0.42,'E0',NULL,NULL,NULL,NULL,1,200.15675,11.51594,0.014,NULL,58945023973,921015999,14390874,16.1),(107994,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107994,31.22,NULL,17.5,46153,72,NULL,NULL,'UGC 08385',NULL,'2014Ap.....57..457K',2014,1,1.91,'The SDSS position is for an HII region 7-8 arcsec southeast of the nucleus.','G',0.000002,NULL,'14.4g',0.82,'SABm',NULL,NULL,NULL,NULL,1,200.159583,9.78722,0,NULL,58944466889,921007295,14390738,14.4),(107995,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107995,31.75,0.4,22.4,46153,75,NULL,'B','UGC 08385',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107996,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107996,37.93,0.16,386,46154,70,NULL,NULL,'2MASX J13203913+2123064',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,200.163,21.38514,0.067,NULL,58848103013,919501609,14367212,17.3),(107997,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',107997,39.1,0.46,661,46155,70,NULL,NULL,'SDSS J132039.88+063335.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00019,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,200.166167,6.56,0.01,NULL,58984591925,921634248,14400535,18.6),(107998,'D-Sigma','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107998,33.3,0.4,45.6,46156,75,NULL,'Edat, raw','NGC 5082',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00014,NULL,'13.75',1,'SB(r)0^+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,200.1667917,-43.69994,0.481,NULL,46963214744,733800230,11465628,13.75),(107999,'D-Sigma','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,107999,33.45,0.4,49,46156,75,NULL,'Edat, cor','NGC 5082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108000,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108000,33.32,0.45,46.1,46156,NULL,NULL,'K','NGC 5082',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108001,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108001,33.68,0.4,54.5,46156,NULL,NULL,'mean','NGC 5082',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108002,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108002,38.32,0.46,462,46157,70,NULL,NULL,'2MASX J13204059+2808493',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000188,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,200.169167,28.14717,0.013,NULL,58714318615,917411228,14334550,18),(108003,'IRAS','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108003,34.23,0.8,70.3,46158,75,NULL,'MAT, I','ESO 576- G 039',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00003,NULL,'15.57',0.6,'SB(s)m',NULL,NULL,NULL,NULL,1,200.175375,-18.03522,0.217,NULL,43776364465,684005694,10687588,15.57),(108004,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108004,33.91,0.32,60.6,46158,85,NULL,'I, raw','ESO 576- G 039',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108005,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108005,33.91,0.32,60.6,46158,85,NULL,'I, inv','ESO 576- G 039',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108006,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108006,34.22,0.43,69.8,46158,75,NULL,'MAT, I, raw','ESO 576- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108007,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108007,34.28,0.43,71.7,46158,75,NULL,'MAT, I, inv','ESO 576- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108008,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108008,34.31,0.49,72.9,46158,NULL,NULL,NULL,'ESO 576- G 039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108009,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108009,34.35,0.2,74.1,46158,74.4,NULL,NULL,'ESO 576- G 039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108010,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108010,34.49,0.43,78.9,46158,75,NULL,'MAT, I, cor','ESO 576- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108011,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108011,34.52,0.44,80.3,46158,NULL,NULL,'Malmquist cor.','ESO 576- G 039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108012,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108012,36.79,0.46,228,46159,70,NULL,NULL,'2MASXi J1320425+265932',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,200.177375,26.99244,0.065,NULL,58716101734,917439089,14334985,17.4),(108013,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108013,37.93,0.16,386,46160,70,NULL,NULL,'2MASX J13204261+2109091',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,200.1775,21.15275,0.057,NULL,58847200597,919487509,14366992,16.5),(108014,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108014,37.48,0.46,314,46161,70,NULL,NULL,'SDSS J132042.59+150335.6',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000147,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,200.1775417,15.05989,0,NULL,59012287247,922066988,14407296,17.3),(108015,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108015,37.69,0.46,345,46162,70,NULL,NULL,'2MASX J13204286+0157122',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,200.1785417,1.95336,0.026,NULL,58051256680,907050885,14172670,17.5),(108016,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108016,35.98,0.46,157,46163,70,NULL,NULL,'2MASX J13204336+3206422',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000156,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,200.180667,32.11161,0,NULL,59164726837,924448856,14444513,16.5),(108017,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1997br',NULL,108017,31.59,0.2,20.7,46164,72,NULL,NULL,'ESO 576- G 040',0.00694,'2006ApJ...645..488W',2006,1,2.1,'Confused HIPASS source','G',0.000013,NULL,'14.92',0.4,'SBd? pec sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,200.1822917,-22.05111,0.325,NULL,43811967026,684561984,10696281,14.92),(108018,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1997br',NULL,108018,31.81,0.09,23,46164,74.4,NULL,NULL,'ESO 576- G 040',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108019,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1997br',NULL,108019,32.25,0.1,27.8,46164,65,NULL,'MLCS2k2','ESO 576- G 040',0.00694,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108020,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1997br',NULL,108020,32.66,0.17,34,46164,70.8,NULL,NULL,'ESO 576- G 040',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108021,'IRAS','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108021,32.15,0.8,26.9,46164,75,NULL,'MAT, I','ESO 576- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108022,'IRAS','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108022,32.16,0.8,27.1,46164,75,NULL,'HMCL, I','ESO 576- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108023,'IRAS','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108023,32.16,0.8,27.1,46164,75,NULL,'A82, H','ESO 576- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108024,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108024,30.91,0.32,15.2,46164,85,NULL,'I, inv','ESO 576- G 040',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108025,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108025,30.94,0.32,15.4,46164,85,NULL,'I, raw','ESO 576- G 040',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108026,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108026,31.02,0.47,16,46164,75,NULL,'A82, H, inv','ESO 576- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108027,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108027,31.21,0.47,17.4,46164,75,NULL,'A82, H, raw','ESO 576- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108028,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108028,31.27,0.43,18,46164,75,NULL,'MAT, I, inv','ESO 576- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108029,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108029,31.33,0.43,18.5,46164,75,NULL,'MAT, I, raw','ESO 576- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108030,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108030,31.45,0.4,19.5,46164,75,NULL,'HOSTS SN 1997br','ESO 576- G 040',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108031,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108031,31.5,0.43,20,46164,75,NULL,'3.6 micron, color + selection bias corrected','ESO 576- G 040',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108032,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108032,31.53,0.43,20.2,46164,75,NULL,'3.6 micron, color corrected','ESO 576- G 040',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108033,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108033,31.55,0.47,20.4,46164,75,NULL,'A82, H, cor','ESO 576- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108034,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108034,31.57,0.42,20.6,46164,NULL,18.48,'3.6 micron','ESO 576- G 040',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108035,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108035,31.59,0.38,20.8,46164,NULL,NULL,NULL,'ESO 576- G 040',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108036,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108036,31.62,0.43,21,46164,75,NULL,'MAT, I, cor','ESO 576- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108037,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108037,31.62,0.4,21.1,46164,75,NULL,'HMCL, I, inv','ESO 576- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108038,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108038,31.67,0.4,21.6,46164,75,NULL,'HMCL, I, raw','ESO 576- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108039,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108039,31.7,0.58,21.9,46164,NULL,NULL,NULL,'ESO 576- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108040,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108040,31.8,0.55,22.9,46164,NULL,NULL,'Malmquist cor.','ESO 576- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108041,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108041,31.81,0.09,23,46164,74.4,NULL,NULL,'ESO 576- G 040',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108042,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108042,31.92,0.4,24.2,46164,75,NULL,'HMCL, I, cor','ESO 576- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108043,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108043,31.94,0.4,24.4,46164,75,NULL,'HOSTS SN 1997br','ESO 576- G 040',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108044,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108044,37.63,0.46,336,46165,70,NULL,NULL,'2MASX J13204398-0053517',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000085,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,200.183167,-0.89778,0.013,NULL,43085322262,673208160,10518877,17.2),(108045,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108045,34.76,0.47,89.6,46166,70,NULL,NULL,'MCG -02-34-036',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00011,NULL,'14.89',0.3,NULL,NULL,NULL,NULL,NULL,1,200.1835417,-14.09989,0.121,NULL,44006387196,687599799,10743746,14.89),(108046,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108046,38.86,0.46,591,46167,70,NULL,NULL,'2MASX J13204414+4508226',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,200.184083,45.13953,0,NULL,59279867860,926247935,14472623,18),(108047,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108047,37.33,0.46,292,46168,70,NULL,NULL,'2MASX J13204489+1133151',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000124,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,200.187166667,11.55422,0.014,NULL,58945146909,921017920,14390905,16.4),(108048,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108048,38.05,0.33,407,46169,70,NULL,NULL,'2MASX J13204489+1142401',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000183,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,200.187166667,11.71111,0.017,NULL,58945171118,921018298,14390910,17),(108049,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108049,37.93,0.16,386,46170,70,NULL,NULL,'SDSS J132045.35+211627.0',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',NULL,NULL,'15.7g',0.42,'BrClG',NULL,NULL,NULL,NULL,1,200.189,21.27419,0.067,NULL,58848063741,919500995,14367203,15.7),(108050,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108050,37.47,0.21,311,46171,70,NULL,NULL,'2MASX J13204571+1131351',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000168,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,200.190583,11.52642,0.014,NULL,58945020045,921015938,14390874,16.8),(108051,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108051,37.53,0.46,321,46172,70,NULL,NULL,'SDSS J132045.82+081410.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,200.190958333,8.23636,0.015,NULL,58986349764,921661715,14400964,18.1),(108052,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108052,35.95,0.16,155,46173,70,NULL,NULL,'2MASX J13204632+3326372',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000083,NULL,'16.0g',0.39,'E1',NULL,NULL,NULL,NULL,1,200.193041667,33.44372,0.009,NULL,59172511461,924570491,14446413,16),(108053,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108053,34.45,0.46,77.5,46174,70,NULL,NULL,'NGC 5094',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'14.24',0.6,'E2/SA0-',NULL,NULL,NULL,NULL,1,200.1952083,-14.08067,0.121,NULL,44006384353,687599755,10743746,14.24),(108054,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108054,36.61,0.46,210,46175,70,NULL,NULL,'2MASX J13204711+2935593',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000123,NULL,'16.5g',0.32,'E0',NULL,NULL,NULL,NULL,1,200.1965,29.59989,0.022,NULL,58712809649,917387650,14334182,16.5),(108055,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108055,37.93,0.46,386,46176,70,NULL,NULL,'SDSS J132047.70+281557.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000161,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,200.1987917,28.26603,0.013,NULL,58714356406,917411818,14334559,18.6),(108056,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108056,36.65,0.46,214,46177,70,NULL,NULL,'2MASX J13204769+0802541',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,200.1989583,8.0485,0.015,NULL,58986244792,921660074,14400938,16.8),(108057,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108057,37.01,0.46,252,46178,70,NULL,NULL,'2MASX J13204864+3045272',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000133,NULL,'15.6g',0.48,'E2',NULL,NULL,NULL,NULL,1,200.2025417,30.75769,0.016,NULL,59161286276,924395098,14443673,15.6),(108058,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108058,35.95,0.16,155,46179,70,NULL,NULL,'2MASX J13204902+3306012',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000083,NULL,'15.4g',0.38,'E4',NULL,NULL,NULL,NULL,1,200.20425,33.10039,0.007,NULL,59163295469,924426491,14444163,15.4),(108059,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108059,37.65,0.46,339,46180,70,NULL,NULL,'2MASX J13204931+2253482',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,200.205333,22.89672,NULL,NULL,58846442735,919475667,14366807,16.6),(108060,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108060,32.37,0.5,29.8,46181,70,NULL,NULL,'ESO 269- G 090',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000107,NULL,'13.77',0.8,'SAB0-','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,200.211083,-47.21831,0.597,NULL,46957016427,733703381,11464115,13.77),(108061,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108061,37.52,0.46,319,46182,70,NULL,NULL,'2MASX J13205092+0059504',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000073,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,200.212,0.99742,0.029,NULL,58052426007,907069156,14172955,17.3),(108062,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108062,37.74,0.46,354,46183,70,NULL,NULL,'2MASX J13205143+5954542',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000176,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,200.214333333,59.91519,0,NULL,57391050937,896735170,14011487,17.4),(108063,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108063,37.83,0.46,369,46184,70,NULL,NULL,'2MASX J13205166+5937050',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,200.215167,59.61808,0,NULL,57391144966,896736640,14011510,17.6),(108064,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108064,37.8,0.27,363,46185,70,NULL,NULL,'2MASX J13205203+3755484',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000057,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,200.2167083,37.93019,0,NULL,59297594315,926524911,14476951,16.7),(108065,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108065,37.5,0.33,317,46186,70,NULL,NULL,'2MASX J13205199+6017172',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,200.2167083,60.28825,0,NULL,57394633130,896791142,14012361,18),(108066,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108066,37.93,0.16,386,46187,70,NULL,NULL,'2MASX J13205225+2119452',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,200.217667,21.32939,0.067,NULL,58848112505,919501757,14367214,17.7),(108067,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108067,31.8,0.4,22.9,46188,75,NULL,NULL,'NGC 5109',NULL,'2008Ap.....51..336K',2008,1,1.7,NULL,'G',0.00003,NULL,'13.80',0.5,'Sbc','in a pair',NULL,NULL,NULL,1,200.218125,57.64475,0,NULL,57436406184,897443846,14022560,13.8),(108068,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108068,32.46,0.49,31,46188,75,NULL,'IR','NGC 5109',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108069,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108069,38.36,0.46,470,46189,70,NULL,NULL,'SDSS J132052.43+200134.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,200.2185,20.02636,0.059,NULL,58840406005,919381343,14365333,18.4),(108070,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108070,38.51,0.46,503,46190,70,NULL,NULL,'SDSS J132053.56+324430.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,200.2232083,32.74194,0.005,NULL,59164035377,924438052,14444344,18),(108071,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108071,36.65,0.27,213,46191,70,NULL,NULL,'2MASX J13205409+5834180',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000171,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,200.225625,58.57164,0,NULL,57389046909,896703857,14010997,16.4),(108072,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108072,38.05,0.33,407,46192,70,NULL,NULL,'SDSS J132054.52+114443.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00016,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,200.2272083,11.74553,0.017,NULL,58945093664,921017088,14390892,18.3),(108073,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108073,37.47,0.21,311,46193,70,NULL,NULL,'2MASX J13205612+1135041',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000197,NULL,'16.2g',0.4,'BrClG',NULL,NULL,NULL,NULL,1,200.233833,11.58461,0.014,NULL,58945122218,921017534,14390898,16.2),(108074,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108074,38.1,0.27,417,46194,70,NULL,NULL,'2MASX J13205653+1313257',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,200.235583,13.22375,0.007,NULL,59019647616,922181994,14409093,16.9),(108075,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108075,37.94,0.46,388,46195,70,NULL,NULL,'2MASX J13205675+5804190',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,200.236625,58.07186,0,NULL,57436318510,897442476,14022538,17.2),(108076,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108076,37.47,0.21,311,46196,70,NULL,NULL,'2MASX J13205735+1130511',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000175,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,200.238875,11.51433,0.014,NULL,58944999905,921015623,14390869,17.4),(108077,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108077,37.77,0.46,358,46197,70,NULL,NULL,'SDSS J132057.80+153829.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,200.240833,15.64164,0,NULL,59012886075,922076344,14407442,17.7),(108078,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108078,37.64,0.46,337,46198,70,NULL,NULL,'2MASXi J1320588+242043',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,200.245125,24.34531,0,NULL,58661788697,916590448,14321725,17.4),(108079,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108079,37.1,0.46,263,46199,70,NULL,NULL,'SDSS J132058.94+163231.1',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.4g',0.31,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,200.245625,16.542,0,NULL,59013078300,922079348,14407489,16.4),(108080,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108080,37.32,0.46,291,46200,70,NULL,NULL,'2MASX J13210160+2612480',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000186,NULL,'16.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,200.256667,26.2135,0.036,NULL,58709326351,917333224,14333331,16.7),(108081,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108081,37.11,0.46,264,46201,70,NULL,NULL,'2MASX J13210219+6052092',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000177,NULL,'16.3g',0.37,'AGN',NULL,NULL,NULL,NULL,1,200.259125,60.86919,0.009,NULL,57393600040,896775000,14012109,16.3),(108082,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108082,38.27,0.33,451,46202,70,NULL,NULL,'2MASX J13210236+5842161',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000202,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,200.25975,58.70444,0,NULL,57389082626,896704416,14011006,16.4),(108083,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108083,38.1,0.27,417,46203,70,NULL,NULL,'2MASX J13210256+1313597',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,200.2607083,13.23306,0.007,NULL,59019645499,922181960,14409093,17.9),(108084,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108084,35.95,0.16,155,46204,70,NULL,NULL,'ARK 415',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000097,NULL,'15.0g',0.53,'E6',NULL,NULL,NULL,NULL,1,200.260875,33.3395,0.006,NULL,59172468140,924569814,14446403,15),(108085,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 2007ar',NULL,108085,36,0.19,151,46205,74.2,NULL,'SALT 2','CGCG 294-033',0.052933,'2010ApJ...716..712A',2010,1,1.01,NULL,'G',0.000117,NULL,'15.0g',0.53,'E0',NULL,NULL,NULL,NULL,1,200.262625,58.54889,0,NULL,57388869173,896701080,14010954,15),(108086,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 2007ar',NULL,108086,36.48,0.18,187,46205,65,NULL,'MLCS17','CGCG 294-033',0.052933,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108087,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 2007ar',NULL,108087,36.37,0.09,188,46205,74.4,NULL,NULL,'CGCG 294-033',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108088,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108088,36.65,0.27,213,46205,70,NULL,NULL,'CGCG 294-033',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108089,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108089,37.76,0.46,357,46206,70,NULL,NULL,'2MASX J13210321+4143144',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,200.263333,41.72078,0,NULL,59309386090,926709157,14479830,17.5),(108090,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108090,37.44,0.46,308,46207,70,NULL,NULL,'2MASX J13210386+3727355',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000161,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,200.266166667,37.45997,0,NULL,59297970131,926530783,14477043,16.7),(108091,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108091,35.94,0.78,154,46208,70,NULL,NULL,'2MASX J13210412-3303009',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.2',0.4,NULL,NULL,NULL,NULL,NULL,1,200.267166667,-33.05017,0.185,NULL,46870308573,732348571,11442946,15.2),(108092,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108092,36.63,0.46,212,46209,70,NULL,NULL,'2MASX J13210435+4055095',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000162,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,200.268167,40.91936,0,NULL,59301208263,926581379,14477834,16.7),(108093,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108093,38.27,0.33,451,46210,70,NULL,NULL,'2MASX J13210532+5839591',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000187,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,200.272375,58.66653,0,NULL,57389088407,896704506,14011007,17),(108094,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108094,37.52,0.46,319,46211,70,NULL,NULL,'2MASX J13210562+3948354',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,200.2734583,39.80981,0,NULL,59304129866,926627029,14478547,17.8),(108095,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108095,37.02,0.46,254,46212,70,NULL,NULL,'2MASX J13210578+2921541',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00016,NULL,'16.4g',0.36,'E3',NULL,NULL,NULL,NULL,1,200.274208333,29.36511,0.019,NULL,58712881638,917388775,14334199,16.4),(108096,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108096,36.56,0.56,205,46213,70,NULL,NULL,'2MASX J13210596-7351597',NULL,'2014MNRAS.445.2677S',2014,1,0.24,NULL,'G',0.00015,NULL,'13.67',0.08,NULL,NULL,NULL,NULL,NULL,1,200.275083,-73.86658,0.845,NULL,44215232219,690863003,10794734,13.67),(108097,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108097,37.54,0.23,322,46214,70,NULL,NULL,'2MASX J13210688+2647291',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000165,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,200.278583,26.7915,0.062,NULL,58708772360,917324568,14333196,16.8),(108098,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108098,37.24,0.46,281,46215,70,NULL,NULL,'SDSS J132107.50+375535.8',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00007,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,200.281291667,37.92664,0,NULL,59297696145,926526502,14476976,16.5),(108099,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108099,37.43,0.46,307,46216,70,NULL,NULL,'2MASX J13210756+1808022',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.24',0.17,NULL,NULL,NULL,NULL,NULL,1,200.2814583,18.13397,0.048,NULL,58838006926,919343858,14364747,18.24),(108100,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108100,36.78,0.46,227,46217,70,NULL,NULL,'2MASX J13210758+4841520',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,200.2817083,48.69778,0,NULL,59275427206,926178550,14471539,17.1),(108101,'TRGB','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108101,28.59,0.12,5.2,46218,NULL,NULL,NULL,'HIPASS J1321-31',NULL,'2003ApJ...596L..47P',2003,1,1.3,NULL,'G',0.00001,NULL,'17.1',0.6,'dwarf Irr',NULL,NULL,NULL,NULL,1,200.284166667,-31.52917,0.233,NULL,46870977741,732359027,11443109,17.1),(108102,'TRGB','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108102,28.59,0.13,5.2,46218,NULL,NULL,NULL,'HIPASS J1321-31',NULL,'2007MNRAS.374..107G',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108103,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108103,35.6,0.72,132,46219,70,NULL,NULL,'II SZ 039',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6',NULL,'E3',NULL,NULL,NULL,NULL,1,200.284375,-13.65206,0.085,NULL,44006075709,687594932,10743670,15.6),(108104,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108104,37.62,0.46,335,46220,70,NULL,NULL,'2MASX J13210983+1204581',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,200.291083333,12.08283,0.013,NULL,59015500688,922117198,14408081,17.1),(108105,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108105,37.27,0.46,284,46221,70,NULL,NULL,'2MASX J13211052+0327404',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000152,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,200.293875,3.46111,0.011,NULL,58936087433,920876366,14388693,17.1),(108106,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108106,38.04,0.27,406,46222,70,NULL,NULL,'2MASX J13211113-0043086',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000073,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,200.296375,-0.719,0.013,NULL,43085737475,673214648,10518978,18),(108107,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108107,37.93,0.16,386,46223,70,NULL,NULL,'2MASX J13211157+2124192',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,200.29825,21.40544,0.067,NULL,58848069757,919501089,14367204,18.1),(108108,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108108,36.52,1.03,201,46224,70,NULL,NULL,'2MASX J13211237-0848515',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,200.301541667,-8.81439,0.053,NULL,43887253397,685738334,10714661,15.7),(108109,'SBF','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108109,32.88,0.36,37.7,46225,NULL,NULL,NULL,'NGC 5090',NULL,'2001MNRAS.327.1004B',2001,1,2.9,NULL,'G',0.00007,NULL,'12.57',2.4,'E2             LINER','Pair member, radial velocity confirmed',NULL,'radio jet',NULL,1,200.303417,-43.70456,0.481,NULL,46963225080,733800391,11465631,12.57),(108110,'SBF','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108110,33.14,0.36,42.4,46225,NULL,NULL,'Malmquist cor.','NGC 5090',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108111,'D-Sigma','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108111,33.3,0.4,45.6,46225,75,NULL,'Edat, raw','NGC 5090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108112,'D-Sigma','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108112,33.45,0.4,49,46225,75,NULL,'Edat, cor','NGC 5090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108113,'Faber-Jackson','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108113,32.88,0.65,37.7,46225,95,NULL,'Weighted Mean','NGC 5090',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108114,'Faber-Jackson','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108114,34.54,0.81,80.9,46225,55,NULL,'Visvanathan & Sandage 1979','NGC 5090',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108115,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108115,33.19,0.41,43.5,46225,NULL,NULL,NULL,'NGC 5090',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108116,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108116,33.41,0.41,48,46225,NULL,NULL,'Malmquist cor.','NGC 5090',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108117,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108117,38.11,0.46,419,46226,70,NULL,NULL,'2MASX J13211289+4512426',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,200.3037917,45.21169,0,NULL,59279856197,926247753,14472621,18),(108118,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108118,33.64,0.2,53.5,46227,74.4,NULL,NULL,'UGC 08392',NULL,'2013AJ....146...86T',2013,1,1.34,NULL,'G',0.000023,NULL,'14.9g',0.67,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,200.304375,31.22183,NULL,NULL,59161407202,924396987,14443702,14.9),(108119,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108119,33.88,0.54,59.7,46227,NULL,NULL,NULL,'UGC 08392',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108120,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108120,34.08,0.49,65.4,46227,NULL,NULL,'Malmquist cor.','UGC 08392',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108121,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108121,37.93,0.33,385,46228,70,NULL,NULL,'2MASX J13211313-0038436',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000087,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,200.304833,-0.64542,0.017,NULL,43085780978,673215327,10518989,17.7),(108122,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108122,35.55,0.42,129,46229,NULL,NULL,NULL,'ESO 382- G 048',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.94',0.2,'S...',NULL,NULL,NULL,NULL,1,200.306833333,-35.52211,0.169,NULL,46873907782,732404809,11443825,15.94),(108123,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108123,35.59,0.2,131,46229,74.4,NULL,NULL,'ESO 382- G 048',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108124,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108124,35.6,0.41,132,46229,NULL,NULL,'Malmquist cor.','ESO 382- G 048',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108125,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108125,37.87,0.46,374,46230,70,NULL,NULL,'2MASXi J1321155+244218',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,200.314417,24.70517,0,NULL,58662439433,916600616,14321884,17.9),(108126,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108126,36.86,0.46,236,46231,70,NULL,NULL,'2MASX J13211558+1202401',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000172,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,200.314833,12.04456,0.013,NULL,59015502943,922117233,14408081,16.6),(108127,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108127,34.69,0.47,86.7,46232,70,NULL,NULL,'MCG -03-34-055',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00014,NULL,'14.72',0.4,NULL,NULL,NULL,NULL,NULL,1,200.3170417,-15.90272,0.133,NULL,43999959683,687499370,10742177,14.72),(108128,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108128,38.48,0.46,497,46233,70,NULL,NULL,'SDSS J132116.25+042622.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,200.31775,4.43967,0.05,NULL,58934455519,920850867,14388294,18.7),(108129,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108129,37.48,0.46,314,46234,70,NULL,NULL,'2MASX J13211727+3747449',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000206,NULL,'16.53',0.39,NULL,NULL,NULL,NULL,NULL,1,200.321833333,37.79575,0,NULL,59297859850,926529060,14477016,16.53),(108130,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108130,37.15,0.46,269,46235,70,NULL,NULL,'2MASX J13211792+4632163',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,200.324875,46.53786,0,NULL,59280735136,926261486,14472835,16.9),(108131,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108131,37.66,0.46,340,46236,70,NULL,NULL,'2MASX J13211829+3130311',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000155,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,200.326083333,31.50867,NULL,NULL,59164177333,924440270,14444379,18.1),(108132,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108132,38.02,0.33,403,46237,70,NULL,NULL,'2MASX J13211855+2509401',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,200.327333,25.16125,0.006,NULL,58662306579,916598540,14321852,17.9),(108133,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108133,36.98,0.46,249,46238,70,NULL,NULL,'CGCG 072-053',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.00019,NULL,'15.3g',0.44,'E0','Group member',NULL,NULL,NULL,1,200.327917,12.21297,0.013,NULL,59015821902,922122217,14408159,15.3),(108134,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108134,34.44,0.33,77.2,46239,70,NULL,NULL,'CGCG 160-208',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.000063,NULL,'14.5g',0.5,'S0','Group member',NULL,NULL,NULL,1,200.3282083,31.38806,NULL,NULL,59161338976,924395921,14443686,14.5),(108135,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108135,38,0.46,397,46240,70,NULL,NULL,'SDSS J132120.02+402343.8',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000173,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,200.333458333,40.3955,0,NULL,59303512914,926617389,14478396,17.9),(108136,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108136,38.1,0.27,417,46241,70,NULL,NULL,'2MASXi J1321205+131126',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,200.335458333,13.19078,0.007,NULL,59019864266,922185379,14409146,17.8),(108137,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108137,37.54,0.23,322,46242,70,NULL,NULL,'2MASX J13212047+2633271',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000191,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,200.335458333,26.55742,0.058,NULL,58708882706,917326292,14333223,17.6),(108138,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108138,37.47,0.21,311,46243,70,NULL,NULL,'2MASX J13212052+1133493',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000178,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,200.335541667,11.56372,0.015,NULL,58945113552,921017399,14390896,16.9),(108139,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108139,37.32,0.46,291,46244,70,NULL,NULL,'2MASX J13212096+1227191',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,200.337417,12.45522,0.008,NULL,59015948546,922124196,14408190,17.6),(108140,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108140,37.69,0.15,345,46245,70,NULL,NULL,'2MASX J13212198+5908221',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000178,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,200.341917,59.13944,0.005,NULL,57389370928,896708920,14011076,16.9),(108141,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108141,36.1,0.57,166,46246,70,NULL,NULL,'2MASX J13212239-3548040',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,200.34325,-35.80119,0.169,NULL,46873845625,732403837,11443809,15),(108142,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108142,33.95,0.47,61.7,46247,NULL,NULL,'Malmquist cor.','NGC 5104',NULL,'2009ApJS..182..474S',2009,1,1.38,NULL,'G',0.00003,NULL,'14.0g',0.58,'Sa:;LIRG       LINER',NULL,NULL,NULL,NULL,1,200.3462083,0.34239,0.066,NULL,58052200369,907065630,14172900,14),(108143,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108143,33.99,0.46,62.7,46247,NULL,NULL,NULL,'NGC 5104',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108144,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108144,34.04,0.45,64.2,46247,NULL,NULL,'K','NGC 5104',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108145,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108145,34.13,0.47,66.9,46247,NULL,NULL,'H','NGC 5104',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108146,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108146,34.23,0.43,70.2,46247,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5104',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108147,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108147,34.24,0.46,70.5,46247,NULL,NULL,'J','NGC 5104',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108148,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108148,34.36,0.43,74.6,46247,75,NULL,'3.6 micron, color corrected','NGC 5104',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108149,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108149,34.38,0.2,75.2,46247,74.4,NULL,NULL,'NGC 5104',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108150,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108150,34.55,0.4,81.4,46247,NULL,NULL,'mean','NGC 5104',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108151,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108151,37.93,0.33,385,46248,70,NULL,NULL,'2MASX J13212388-0032314',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000088,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,200.3494583,-0.54222,0.013,NULL,43085784205,673215378,10518990,17.2),(108152,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108152,37.71,0.46,349,46249,70,NULL,NULL,'SDSS J132124.65+174252.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.6g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,200.35275,17.71469,0.024,NULL,58830087007,919220109,14362814,18.6),(108153,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108153,36.75,0.46,224,46250,70,NULL,NULL,'2MASX J13212515+3418331',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000127,NULL,'16.52',0.25,NULL,NULL,NULL,NULL,NULL,1,200.354917,34.30919,0.01,NULL,59173044030,924578812,14446543,16.52),(108154,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108154,37.89,0.13,378,46251,70,NULL,NULL,'SDSS J132125.26+111024.8',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00019,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,200.3552917,11.17358,0.011,NULL,58945306780,921020418,14390944,18),(108155,'IRAS','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108155,31.27,0.8,18,46252,75,NULL,'A82, H','NGC 5107',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000013,NULL,'13.81',0.5,'SB(s)d? sp','in a radial-velocity based grouping',NULL,NULL,'H II',1,200.352833,38.53761,0,NULL,59298046256,926531972,14477062,13.81),(108156,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108156,30.7,0.4,13.8,46252,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5107',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108157,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108157,30.76,0.4,14.2,46252,75,NULL,NULL,'NGC 5107',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108158,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108158,31.42,0.38,19.2,46252,NULL,NULL,NULL,'NGC 5107',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108159,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108159,31.48,0.47,19.8,46252,75,NULL,'A82, H, inv','NGC 5107',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108160,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108160,31.49,0.4,19.9,46252,75,NULL,'B','NGC 5107',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108161,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108161,31.64,0.49,21.3,46252,75,NULL,'IR','NGC 5107',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108162,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108162,31.64,0.47,21.3,46252,75,NULL,'A82, H, raw','NGC 5107',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108163,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108163,31.85,0.47,23.4,46252,75,NULL,'A82, H, cor','NGC 5107',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108164,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108164,38.04,0.27,406,46253,70,NULL,NULL,'2MASX J13212542-0041364',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000093,NULL,'16.6g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,200.356,-0.69342,0.009,NULL,43085739954,673214686,10518979,16.6),(108165,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108165,37.99,0.46,396,46254,70,NULL,NULL,'2MASX J13212596-0141254',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000086,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,200.358083,-1.69044,0.041,NULL,43086838879,673231857,10519247,17.5),(108166,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108166,35.48,0.87,124,46255,70,NULL,NULL,'2MASX J13212609-1617416',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,200.3587083,-16.29492,0.133,NULL,43999861183,687497830,10742153,15.2),(108167,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108167,38.04,0.27,406,46256,70,NULL,NULL,'2MASX J13212629-0041154',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000111,NULL,'17.2g',0.19,'BrClG',NULL,NULL,NULL,NULL,1,200.3595,-0.68756,0.009,NULL,43085739920,673214686,10518979,17.2),(108168,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108168,36.6,0.58,209,46257,70,NULL,NULL,'2MASX J13212649-0811282',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000107,NULL,'15.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,200.360333,-8.19119,0.081,NULL,43888047961,685750749,10714855,15.7),(108169,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108169,37.54,0.23,322,46258,70,NULL,NULL,'SDSS J132127.43+263501.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,200.364333,26.58361,0.058,NULL,58708872997,917326140,14333220,18),(108170,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108170,38.28,0.46,453,46259,70,NULL,NULL,'2MASX J13212799+5818291',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00017,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,200.366708333,58.30803,0,NULL,57434193752,897409277,14022019,17.8),(108171,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108171,36.57,0.2,206,46260,74.4,NULL,NULL,'CGCG 072-054',NULL,'2013AJ....146...86T',2013,1,0.91,NULL,'G',0.000171,NULL,'15.6g',0.31,'Sbc','Group member',NULL,NULL,NULL,1,200.36925,12.33808,0.008,NULL,59015898432,922123413,14408178,15.6),(108172,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108172,38.15,0.46,427,46261,70,NULL,NULL,'2MASX J13212864+4150019',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,200.3695,41.83397,0,NULL,59309382048,926709094,14479829,18),(108173,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108173,37.29,0.59,287,46262,70,NULL,NULL,'2MASX J13212973-2901243',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'<16.5',NULL,NULL,NULL,NULL,NULL,NULL,1,200.3739583,-29.02336,0.229,NULL,43340097700,677189026,10581078,0),(108174,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108174,37.82,0.46,367,46263,70,NULL,NULL,'2MASX J13213024+4225164',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000137,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,200.376166667,42.42142,0,NULL,59309304622,926707884,14479810,17.9),(108175,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1994T',NULL,108175,35.25,0.17,108,46264,74.2,NULL,'SALT 2','CGCG 016-058',0.03466,'2010ApJ...716..712A',2010,1,0.69,NULL,'G',0.000073,NULL,'15.7g',0.29,'Sa',NULL,NULL,NULL,NULL,1,200.377125,-2.14556,0.037,NULL,43086917365,673233083,10519266,15.7),(108176,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1994T',NULL,108176,35.77,0.28,138,46264,72,NULL,NULL,'CGCG 016-058',0.03466,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108177,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1994T',NULL,108177,35.81,0.13,140,46264,65,NULL,'SALT2','CGCG 016-058',0.03466,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108178,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1994T',NULL,108178,35.76,0.08,142,46264,74.4,NULL,NULL,'CGCG 016-058',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108179,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1994T',NULL,108179,35.86,0.16,144,46264,65,NULL,'MLCS17','CGCG 016-058',0.03466,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108180,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1994T',NULL,108180,35.88,0.04,145,46264,72,NULL,NULL,'CGCG 016-058',0.03466,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108181,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1994T',NULL,108181,36.01,0.11,149,46264,65,NULL,'MLCS2k2','CGCG 016-058',0.03466,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108182,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1994T',NULL,108182,35.95,0.08,150,46264,65,NULL,'MLCS2k2','CGCG 016-058',0.03466,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108183,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1994T',NULL,108183,36,0.17,153,46264,65,NULL,'MLCS31','CGCG 016-058',0.03466,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108184,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1994T',NULL,108184,36.01,0.2,154,46264,65,NULL,NULL,'CGCG 016-058',0.03466,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108185,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1994T',NULL,108185,36.02,0.12,155,46264,65,NULL,'MLCS2k2','CGCG 016-058',0.03466,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108186,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1994T',NULL,108186,36.11,0.19,161,46264,70,NULL,'SALT','CGCG 016-058',0.03466,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108187,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1994T',NULL,108187,36.13,0.19,162,46264,65,NULL,'SALT2','CGCG 016-058',0.03466,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108188,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1994T',NULL,108188,36.17,0.11,165,46264,65,NULL,'MLCS','CGCG 016-058',0.03466,'1996ApJ...473..588R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108189,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1994T',NULL,108189,36.19,0.21,167,46264,65,NULL,'MLCS','CGCG 016-058',0.03466,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108190,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1994T',NULL,108190,36.16,0.1,171,46264,65,NULL,'Snapshot','CGCG 016-058',NULL,'1996ApJ...473...88R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108191,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1994T',NULL,108191,36.26,0.18,173,46264,65,NULL,'SALT','CGCG 016-058',0.03466,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108192,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1994T',NULL,108192,36.3,0.02,176,46264,65,NULL,'SALT','CGCG 016-058',0.03466,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108193,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1994T',NULL,108193,36.37,0.14,188,46264,60,NULL,NULL,'CGCG 016-058',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108194,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1994T',NULL,108194,36.41,0.07,191,46264,60,NULL,'M(I) = -19.19 mag','CGCG 016-058',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108195,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1994T',NULL,108195,36.5,0.2,193,46264,65,NULL,'Template','CGCG 016-058',0.03466,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108196,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1994T',NULL,108196,36.52,0.08,201,46264,60,NULL,'M(V) = -19.47 mag','CGCG 016-058',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108197,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1994T',NULL,108197,36.62,0.09,211,46264,60,NULL,'M(B) = -19.48 mag','CGCG 016-058',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108198,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108198,36.44,0.54,194,46264,70,NULL,NULL,'CGCG 016-058',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108199,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108199,36.21,0.55,174,46265,70,NULL,NULL,'2MASX J13213069-3547390',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.8R',NULL,'E',NULL,NULL,NULL,NULL,1,200.377917,-35.79422,0.169,NULL,46873842041,732403781,11443809,13.8),(108200,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108200,38.4,0.27,480,46266,70,NULL,NULL,'SDSS J132131.19-011345.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00008,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,200.38,-1.22919,0.013,NULL,43087131626,673236431,10519319,18.5),(108201,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108201,36.66,0.2,215,46267,74.4,NULL,NULL,'UGC 08395',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'15.2g',0.6,'Sab','Group member',NULL,NULL,NULL,1,200.384125,12.18775,0.013,NULL,59015821051,922122203,14408159,15.2),(108202,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108202,36.7,0.46,219,46268,70,NULL,NULL,'2MASX J13213220+3223431',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000107,NULL,'16.2g',0.35,'E2',NULL,NULL,NULL,NULL,1,200.384166667,32.39528,0,NULL,59163901073,924435954,14444311,16.2),(108203,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108203,37.89,0.13,378,46269,70,NULL,NULL,'2MASX J13213243+1112033',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000174,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,200.385125,11.20108,0.015,NULL,58945441608,921022525,14390976,17.3),(108204,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108204,38.02,0.33,403,46270,70,NULL,NULL,'2MASX J13213419+2506375',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,200.3925417,25.11042,0.006,NULL,58662307854,916598560,14321852,16.9),(108205,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108205,36.45,0.46,195,46271,70,NULL,NULL,'2MASX J13213550+4814343',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,200.398,48.24292,0,NULL,59289220046,926394063,14474907,17.5),(108206,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108206,35.68,0.73,137,46272,70,NULL,NULL,'2MASX J13213588-4223004',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,200.399625,-42.3835,0.481,NULL,46962371974,733787062,11465422,14.1),(108207,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108207,37.54,0.23,322,46273,70,NULL,NULL,'2MASX J13213604+2638585',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000113,NULL,'16.0g',0.39,NULL,NULL,NULL,NULL,NULL,1,200.4002917,26.64956,0.058,NULL,58708754931,917324295,14333192,16),(108208,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108208,36.69,0.46,218,46274,70,NULL,NULL,'2MASX J13213611+3101311',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,200.4005,31.02522,0.041,NULL,59161394755,924396793,14443699,17.5),(108209,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108209,35.81,0.46,145,46275,70,NULL,NULL,'2MASX J13213610+1005383',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000179,NULL,'15.7g',0.46,NULL,NULL,NULL,NULL,NULL,1,200.4005417,10.09392,0,NULL,58944433274,921006769,14390730,15.7),(108210,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108210,37.68,0.46,343,46276,70,NULL,NULL,'2MASX J13213643+4156289',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000138,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,200.4020417,41.94133,0,NULL,59309545205,926711643,14479869,18.1),(108211,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108211,38.24,0.46,445,46277,70,NULL,NULL,'2MASX J13213663+3015021',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.7g',0.18,'E1',NULL,NULL,NULL,NULL,1,200.402625,30.25061,0.019,NULL,58678406089,916850095,14325782,17.7),(108212,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108212,38.48,0.33,497,46278,70,NULL,NULL,'2MASX J13213669-0055204',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000088,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,200.402791667,-0.92247,0.009,NULL,43087221522,673237836,10519341,18.2),(108213,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108213,36.26,0.46,179,46279,70,NULL,NULL,'2MASX J13213669+3159531',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00012,NULL,'16.2g',0.29,'S02',NULL,NULL,NULL,NULL,1,200.402875,31.998,0.014,NULL,59164812313,924450192,14444534,16.2),(108214,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108214,35.97,0.54,156,46280,70,NULL,NULL,'VV 184b',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'16',0.15,NULL,NULL,NULL,NULL,NULL,1,200.4029583,-16.28597,0.133,NULL,43999861912,687497842,10742153,16),(108215,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108215,36.77,0.46,226,46281,70,NULL,NULL,'SDSS J132136.71+125300.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,200.4029583,12.88358,0,NULL,59015356625,922114947,14408046,17.9),(108216,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108216,37.98,0.46,395,46282,70,NULL,NULL,'2MASX J13213756-0121404',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000078,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,200.4065417,-1.36136,0.041,NULL,43087117584,673236212,10519315,17.5),(108217,'Tully est','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108217,32.6,0.8,33.1,46283,75,NULL,NULL,'ESO 040- G 007',NULL,'1988NBGC.C....0000T',1988,1,3.58,'Stars superposed.','G',0.000025,NULL,'14.4',0.45,'SB(s)c: sp',NULL,NULL,NULL,NULL,1,200.415167,-77.53342,0.653,NULL,44179162765,690299418,10785928,14.4),(108218,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108218,32.02,0.4,25.4,46283,NULL,NULL,NULL,'ESO 040- G 007',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108219,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108219,32.07,0.4,25.9,46283,73,NULL,'opt','ESO 040- G 007',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108220,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108220,32.12,0.4,26.6,46283,75,NULL,NULL,'ESO 040- G 007',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108221,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108221,32.12,0.39,26.6,46283,73,NULL,'IR','ESO 040- G 007',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108222,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108222,32.42,0.49,30.5,46283,75,NULL,'IR','ESO 040- G 007',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108223,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108223,32.54,NULL,32.2,46283,NULL,NULL,NULL,'ESO 040- G 007',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108224,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108224,32.71,NULL,34.8,46283,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 040- G 007',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108225,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108225,32.73,NULL,35.1,46283,NULL,NULL,'Dipole','ESO 040- G 007',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108226,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108226,32.73,NULL,35.2,46283,NULL,NULL,'Dipole + Quadrupole','ESO 040- G 007',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108227,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108227,32.92,0.4,38.3,46283,NULL,NULL,'mean','ESO 040- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108228,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108228,33.01,0.47,40,46283,NULL,NULL,'H','ESO 040- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108229,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108229,33.12,0.45,42,46283,NULL,NULL,'K','ESO 040- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108230,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108230,33.14,0.46,42.5,46283,NULL,NULL,'J','ESO 040- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108231,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108231,34.49,0.2,79.1,46284,74.4,NULL,NULL,'UGC 08397',NULL,'2013AJ....146...86T',2013,1,1.29,NULL,'G',0.000127,NULL,'14.5g',0.66,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,200.418875,31.351,NULL,NULL,59161340292,924395942,14443686,14.5),(108232,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108232,34.51,0.48,79.8,46284,NULL,NULL,NULL,'UGC 08397',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108233,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108233,34.64,0.45,84.7,46284,NULL,NULL,'Malmquist cor.','UGC 08397',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108234,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108234,37.92,0.46,384,46285,70,NULL,NULL,'2MASX J13214092+4129439',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000172,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,200.420833,41.49558,0,NULL,59308680020,926698125,14479658,17.8),(108235,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108235,37.79,0.46,361,46286,70,NULL,NULL,'2MASX J13214213+1034133',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00024,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,200.4255,10.57044,0,NULL,58945883548,921029430,14391084,17.1),(108236,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108236,37.69,0.15,345,46287,70,NULL,NULL,'2MASX J13214224+5856243',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.0002,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,200.42625,58.94014,0,NULL,57389389788,896709215,14011081,17),(108237,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108237,37.88,0.46,377,46288,70,NULL,NULL,'2MASX J13214241+1730381',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'18.66',0.25,NULL,NULL,NULL,NULL,NULL,1,200.4267917,17.5105,0.024,NULL,58830017566,919219024,14362797,18.66),(108238,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108238,37.84,0.27,369,46289,70,NULL,NULL,'2MASX J13214424+1323181',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000193,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,200.4345,13.38833,0.011,NULL,59019787550,922184180,14409127,16.9),(108239,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108239,36.65,0.27,213,46290,70,NULL,NULL,'2MASX J13214472+5838144',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000185,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,200.436083,58.63722,0,NULL,57389067156,896704174,14011002,16.9),(108240,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108240,38.48,0.33,497,46291,70,NULL,NULL,'2MASX J13214469-0055384',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000088,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,200.4362917,-0.92742,0.009,NULL,43087204943,673237577,10519337,17.8),(108241,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108241,36.63,0.6,211,46292,70,NULL,NULL,'2MASX J13214503-3103010',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.4',0.4,'E',NULL,NULL,NULL,NULL,1,200.437583333,-31.05017,0.165,NULL,46867625438,732306647,11442291,16.4),(108242,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108242,38.4,0.27,480,46293,70,NULL,NULL,'2MASX J13214523-0109284',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000077,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,200.438417,-1.15778,0.009,NULL,43087121345,673236271,10519316,18.1),(108243,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108243,38.2,0.46,436,46294,70,NULL,NULL,'2MASX J13214542-0004534',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000089,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,200.4392917,-0.08156,0.045,NULL,43085544750,673211636,10518931,17.9),(108244,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 2001cj','R',108244,35.19,0.04,109,46295,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 08399',NULL,'2015Sci...347.1459K',2015,1,0.95,NULL,'G',0.000027,NULL,'14.7g',0.53,'SB(r)b','Group member',NULL,NULL,NULL,1,200.439375,31.23725,NULL,NULL,59161366339,924396349,14443692,14.7),(108245,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 2001cj','R',108245,35.23,0.04,111,46295,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 08399',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108246,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 2001cj',NULL,108246,35.29,0.16,112,46295,70,NULL,'SALT 2','UGC 08399',0.024233,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108247,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108247,36.75,0.46,224,46296,70,NULL,NULL,'2MASX J13214576+4648264',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,200.4407917,46.80744,0,NULL,59288908843,926389200,14474831,17),(108248,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108248,37.49,0.46,315,46297,70,NULL,NULL,'SDSS J132145.81+084051.4',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.6g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,200.440917,8.68097,0,NULL,58985797079,921653079,14400829,17.6),(108249,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108249,30.74,0.53,14,46298,70,NULL,NULL,'NGC 5101',NULL,'2014MNRAS.445.2677S',2014,1,5.4,'Confused HIPASS source','G',0.00001,NULL,'11.6',4.6,'(R\'_1R\'_2)SB(rl)0/a','X-ray-faint group member',NULL,NULL,NULL,1,200.442667,-27.43053,0.321,NULL,43341014144,677203346,10581302,11.6),(108250,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108250,32.19,0.4,27.4,46298,75,NULL,'B','NGC 5101',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108251,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108251,38.4,0.27,480,46299,70,NULL,NULL,'2MASX J13214643-0109374',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000213,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,200.443375,-1.1605,0.009,NULL,43087120584,673236259,10519316,17.8),(108252,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108252,36.06,0.53,163,46300,70,NULL,NULL,'2MASX J13214675-4144067',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,200.4447917,-41.73528,0.457,NULL,46962478877,733788732,11465448,14.3),(108253,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108253,37.63,0.46,336,46301,70,NULL,NULL,'2MASX J13214677-0145554',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000099,NULL,'16.1g',0.46,'E0',NULL,NULL,NULL,NULL,1,200.444875,-1.7655,0.041,NULL,43086810314,673231411,10519240,16.1),(108254,'TRGB','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108254,27.95,0.07,3.89,46302,NULL,NULL,'I','AM 1318-444',NULL,'2009AJ....138..332J',2009,1,1.3,NULL,'G',NULL,NULL,'16.14',1,'IBm',NULL,NULL,NULL,NULL,1,200.4475,-45.06167,0.333,NULL,46953481917,733648154,11463252,16.14),(108255,'TRGB','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108255,27.99,0.1,3.96,46302,74.4,NULL,NULL,'AM 1318-444',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108256,'TRGB','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108256,27.99,0.11,3.96,46302,NULL,NULL,NULL,'AM 1318-444',NULL,'2015ApJ...802L..25T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108257,'TRGB','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108257,28,NULL,3.98,46302,NULL,NULL,NULL,'AM 1318-444',NULL,'2007AJ....133..504K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108258,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108258,35.27,0.48,113,46303,70,NULL,NULL,'MCG -02-34-038',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.99',0.4,NULL,NULL,NULL,NULL,NULL,1,200.4480417,-14.10047,0.085,NULL,44006616073,687603376,10743802,14.99),(108259,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108259,37.2,0.46,276,46304,70,NULL,NULL,'2MASX J13214818+2512245',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,200.450667,25.20672,0.006,NULL,58662095348,916595239,14321800,16.8),(108260,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108260,39.04,0.46,642,46305,70,NULL,NULL,'SDSS J132149.08+101100.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,200.4545,10.18336,0,NULL,58943956674,920999323,14390614,18.4),(108261,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108261,32.5,0.43,31.6,46306,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5105',NULL,'2014MNRAS.444..527S',2014,1,2,NULL,'G',0.000007,NULL,'13.19',1.5,'SB(rs)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,200.4545417,-13.20678,0.117,NULL,44005053580,687578962,10743421,13.19),(108262,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108262,32.51,0.43,31.7,46306,75,NULL,'3.6 micron, color corrected','NGC 5105',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108263,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108263,32.52,0.2,31.9,46306,74.4,NULL,NULL,'NGC 5105',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108264,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108264,32.67,0.51,34.2,46306,NULL,NULL,NULL,'NGC 5105',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108265,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108265,32.71,0.5,34.9,46306,NULL,NULL,'Malmquist cor.','NGC 5105',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108266,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108266,32.86,0.4,37.3,46306,NULL,NULL,NULL,'NGC 5105',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108267,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108267,38.06,0.46,409,46307,70,NULL,NULL,'2MASX J13215087+3856411',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,200.4620417,38.94472,0,NULL,59296215989,926503374,14476615,17.3),(108268,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108268,36.26,0.56,179,46308,70,NULL,NULL,'2MASX J13215170-1740144',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.27',NULL,NULL,NULL,NULL,NULL,NULL,1,200.4654583,-17.67081,0.189,NULL,43776324741,684005074,10687579,16.27),(108269,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108269,38.01,0.46,401,46309,70,NULL,NULL,'2MASX J13215240-0131459',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000095,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,200.46825,-1.52933,0.041,NULL,43086776321,673230880,10519232,16.9),(108270,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108270,37.69,0.15,345,46310,70,NULL,NULL,'2MASX J13215349+5855514',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000173,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,200.473166667,58.931,0,NULL,57389391613,896709243,14011081,17.2),(108271,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108271,37.41,0.33,303,46311,70,NULL,NULL,'2MASX J13215519-0018489',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000095,NULL,'16.1g',0.42,NULL,NULL,NULL,NULL,NULL,1,200.479917,-0.31367,0.045,NULL,43085662874,673213482,10518960,16.1),(108272,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108272,37.11,0.46,265,46312,70,NULL,NULL,'2MASX J13215523+3126148',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000173,NULL,'17.2',0.17,'E2',NULL,NULL,NULL,NULL,1,200.480125,31.43747,NULL,NULL,59161318233,924395597,14443681,17.2),(108273,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108273,35.25,0.2,112,46313,74.4,NULL,NULL,'CGCG 101-031',NULL,'2013AJ....146...86T',2013,1,0.89,NULL,'G',0.000133,NULL,'15.3g',0.44,'Sc',NULL,NULL,NULL,NULL,1,200.4807083,14.33272,0.006,NULL,59021637319,922213083,14409579,15.3),(108274,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108274,38.18,0.46,433,46314,70,NULL,NULL,'2MASX J13215579-0038189',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000099,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,200.4824583,-0.63869,0.005,NULL,43085596571,673212446,10518944,17.2),(108275,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108275,29.64,0.69,8.48,46315,100,NULL,'mid-IR','NGC 5112',NULL,'2013ApJ...771...88L',2013,1,4,NULL,'G',0.000007,NULL,'13.4g',2.8,'SB(rs)cd','in a radial-velocity based grouping',NULL,NULL,NULL,1,200.485,38.73469,0,NULL,59298084922,926532576,14477071,13.4),(108276,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108276,30.98,0.43,15.7,46315,75,NULL,'3.6 micron, color corrected','NGC 5112',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108277,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108277,30.99,0.43,15.8,46315,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5112',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108278,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108278,31.03,0.2,16.1,46315,74.4,NULL,NULL,'NGC 5112',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108279,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108279,31.31,0.51,18.2,46315,NULL,NULL,'Malmquist cor.','NGC 5112',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108280,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108280,31.35,0.5,18.6,46315,NULL,NULL,NULL,'NGC 5112',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108281,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108281,31.39,0.37,19,46315,NULL,NULL,NULL,'NGC 5112',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108282,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108282,31.56,0.4,20.5,46315,75,NULL,'B','NGC 5112',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108283,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108283,32.15,0.4,26.9,46315,NULL,NULL,'mean','NGC 5112',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108284,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108284,32.45,0.3,30.9,46315,55,NULL,'B','NGC 5112',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108285,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108285,32.69,0.46,34.4,46315,NULL,NULL,'J','NGC 5112',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108286,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108286,32.7,0.47,34.7,46315,NULL,NULL,'H','NGC 5112',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108287,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108287,32.72,0.45,34.9,46315,NULL,NULL,'K','NGC 5112',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108288,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108288,37.72,0.46,350,46316,70,NULL,NULL,'2MASX J13215670+0635455',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,200.4862917,6.59606,0,NULL,58983253581,921613337,14400208,17.2),(108289,'PNLF','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108289,27.42,0.26,3.05,46317,NULL,NULL,NULL,'NGC 5102',NULL,'2002ApJ...577...31C',2002,1,8.7,'Extended HIPASS source','G',0.000007,NULL,'10.35',2.8,'SA0-           HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,200.4900417,-36.63025,0.201,NULL,46866013171,732281455,11441897,10.35),(108290,'PNLF','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108290,27.47,0.27,3.1,46317,NULL,NULL,NULL,'NGC 5102',NULL,'1994AJ....108.1610M',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108291,'PNLF','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108291,27.54,0.22,3.22,46317,NULL,NULL,'HST KP Calibrated','NGC 5102',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108292,'SBF','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108292,27.86,0.08,3.74,46317,74.4,NULL,NULL,'NGC 5102',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108293,'SBF','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108293,28.01,0.13,4,46317,NULL,NULL,'I','NGC 5102',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108294,'SBF','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108294,28.07,0.17,4.11,46317,NULL,NULL,'HST KP Calibrated, I','NGC 5102',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108295,'TRGB','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108295,27.51,0.16,3.18,46317,NULL,NULL,NULL,'NGC 5102',NULL,'2008AJ....135.1636D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108296,'TRGB','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108296,27.66,NULL,3.4,46317,NULL,NULL,NULL,'NGC 5102',NULL,'2002A&A...385...21K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108297,'TRGB','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108297,27.72,0.03,3.5,46317,NULL,NULL,'I','NGC 5102',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108298,'TRGB','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108298,27.86,0.08,3.74,46317,74.4,NULL,NULL,'NGC 5102',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108299,'TRGB','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108299,27.86,0.11,3.74,46317,NULL,NULL,NULL,'NGC 5102',NULL,'2015ApJ...802L..25T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108300,'Faber-Jackson','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108300,26.8,0.81,2.29,46317,55,NULL,'Visvanathan & Sandage 1979','NGC 5102',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108301,'Faber-Jackson','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108301,27.19,NULL,2.74,46317,NULL,NULL,'LEDA [April 2006]','NGC 5102',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108302,'Faber-Jackson','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108302,27.41,0.63,3.03,46317,95,NULL,'Michard 1979b, c','NGC 5102',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108303,'Faber-Jackson','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108303,27.77,0.37,3.58,46317,95,NULL,'Weighted Mean','NGC 5102',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108304,'Faber-Jackson','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108304,28.72,0.46,5.55,46317,95,NULL,'Michard 1979a','NGC 5102',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108305,'Tertiary','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108305,27.98,0.26,3.94,46317,95,NULL,NULL,'NGC 5102',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108306,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108306,27.75,0.4,3.5,46317,75,NULL,'B','NGC 5102',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108307,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108307,33.25,0.47,44.6,46317,NULL,NULL,'H','NGC 5102',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108308,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108308,33.3,0.45,45.7,46317,NULL,NULL,'K','NGC 5102',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108309,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108309,33.31,0.46,45.9,46317,NULL,NULL,'J','NGC 5102',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108310,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108310,33.35,0.4,46.7,46317,NULL,NULL,'mean','NGC 5102',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108311,'IRAS','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108311,32.95,0.8,39,46318,75,NULL,'MAT, I','ESO 270- G 006',NULL,'1997ApJS..109..333W',1997,1,1.9,'Mathewson et al. (1992, ApJS, 81, 413) give v=3233 km/sec.','G',0.000022,NULL,'13.96',0.6,'Sb: sp','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,200.490375,-45.93758,0.341,NULL,46953889068,733654516,11463351,13.96),(108312,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108312,32.59,0.32,32.9,46318,85,NULL,'I, raw','ESO 270- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108313,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108313,32.61,0.32,33.2,46318,85,NULL,'I, inv','ESO 270- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108314,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108314,32.78,0.43,36,46318,75,NULL,'MAT, I, raw','ESO 270- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108315,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108315,32.92,0.49,38.3,46318,75,NULL,'IR','ESO 270- G 006',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108316,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108316,32.92,0.43,38.3,46318,75,NULL,'MAT, I, inv','ESO 270- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108317,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108317,33.02,0.4,40.2,46318,NULL,NULL,NULL,'ESO 270- G 006',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108318,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108318,33.08,0.43,41.4,46318,75,NULL,'MAT, I, cor','ESO 270- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108319,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108319,33.49,0.12,50,46318,NULL,NULL,NULL,'ESO 270- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108320,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108320,37.57,0.46,326,46319,70,NULL,NULL,'2MASX J13215786+4151302',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000171,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,200.491083,41.8585,0,NULL,59309505736,926711027,14479859,17.6),(108321,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108321,37.56,0.46,325,46320,70,NULL,NULL,'2MASX J13215794+1511132',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000194,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,200.4914583,15.18703,0.01,NULL,59012526931,922070733,14407355,16.8),(108322,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108322,35.42,0.51,121,46321,70,NULL,NULL,'2MASX J13215868-4141529',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000097,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,200.494417,-41.69803,0.465,NULL,46961607621,733775119,11465236,14.3),(108323,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108323,34.65,0.47,85,46322,NULL,NULL,'H','IC 4230',NULL,'2007A&A...465...71T',2007,1,1.15,'RC3 gives v = 10815 +/- 9 km/sec.','G',0.000103,NULL,'14.7g',0.34,'Sa?',NULL,NULL,NULL,NULL,1,200.496667,26.73386,0.062,NULL,58663691885,916620185,14322190,14.7),(108324,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108324,34.88,0.46,94.4,46322,NULL,NULL,'J','IC 4230',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108325,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108325,35.17,0.4,108,46322,NULL,NULL,'mean','IC 4230',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108326,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108326,36.81,0.46,230,46323,70,NULL,NULL,'2MASX J13220040+1856029',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.06',0.2,NULL,NULL,NULL,NULL,NULL,1,200.50175,18.93419,0.027,NULL,58841756377,919402443,14365663,18.06),(108327,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108327,37.89,0.46,379,46324,70,NULL,NULL,'LCRS B131925.4-031708',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000082,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,200.5020417,-3.54714,0.045,NULL,43837598522,684962476,10702538,17.3),(108328,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108328,38.02,0.46,402,46325,70,NULL,NULL,'2MASX J13220175+4747387',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,200.507375,47.79417,0,NULL,59289273366,926394896,14474920,17.6),(108329,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108329,37.09,0.46,262,46326,70,NULL,NULL,'SDSS J132201.77+220009.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.94',0.13,NULL,NULL,NULL,NULL,NULL,1,200.507417,22.00278,0.065,NULL,58850147629,919533556,14367711,17.94),(108330,'TRGB','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108330,27.88,0.03,3.77,46327,NULL,NULL,'I','SGC 1319.1-4216',NULL,'2009AJ....138..332J',2009,1,1.9,NULL,'G',NULL,NULL,'16.6:',0.7,'Im',NULL,NULL,NULL,NULL,1,200.508541667,-42.53539,0.481,NULL,46962191276,733784238,11465378,16.6),(108331,'TRGB','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108331,27.92,0.11,3.84,46327,NULL,NULL,NULL,'SGC 1319.1-4216',NULL,'2015ApJ...802L..25T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108332,'TRGB','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108332,27.94,NULL,3.87,46327,NULL,NULL,NULL,'SGC 1319.1-4216',NULL,'2007AJ....133..504K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108333,'TRGB','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108333,28.01,0.13,4,46327,NULL,NULL,'I, M(ITRGB) = -4.05','SGC 1319.1-4216',NULL,'2011A&A...530A..58C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108334,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108334,37.8,0.33,364,46328,70,NULL,NULL,'SDSS J132202.90+163919.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,200.512125,16.65553,0,NULL,58833039362,919266240,14363535,18.1),(108335,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108335,34.65,0.46,85.3,46329,70,NULL,NULL,'CGCG 189-058',NULL,'2015arXiv151105856S',2015,1,0.93,NULL,'G',0.000083,NULL,'14.6g',0.47,NULL,NULL,NULL,NULL,NULL,1,200.5124583,35.51389,0,NULL,59170864323,924544755,14446011,14.6),(108336,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108336,37.47,0.46,311,46330,70,NULL,NULL,'SDSS J132203.48+232229.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,200.5145417,23.37489,NULL,NULL,58846938331,919483411,14366928,17.9),(108337,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108337,35.34,0.46,117,46331,70,NULL,NULL,'CGCG 044-075',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.00016,NULL,'15.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,200.52175,6.11481,0,NULL,58982617246,921603394,14400053,15.3),(108338,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108338,37.41,0.33,303,46332,70,NULL,NULL,'2MASX J13220552-0015259',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000076,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,200.523125,-0.25714,0.041,NULL,43085670367,673213599,10518962,17.8),(108339,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108339,36.47,0.83,196,46333,70,NULL,NULL,'2MASX J13220680-1722374',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,200.5282917,-17.37708,0.189,NULL,43779753830,684058653,10688416,16.9),(108340,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108340,37.52,0.46,319,46334,70,NULL,NULL,'2MASX J13220711+2214569',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.09',0.14,NULL,NULL,NULL,NULL,NULL,1,200.52975,22.24919,0.056,NULL,58850048060,919532000,14367687,18.09),(108341,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108341,37.49,0.46,315,46335,70,NULL,NULL,'2MASX J13220784+2714277',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,200.5327083,27.24103,0.064,NULL,58713983002,917405984,14334468,17.1),(108342,'IRAS','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108342,33.79,0.8,57.3,46336,75,NULL,'MAT, I','ESO 444- G 014',NULL,'1997ApJS..109..333W',1997,1,1.4,'RC3 gives v = 5674 +/- 34 km/sec.','G',0.000033,NULL,'15.30',0.3,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,200.534583333,-30.70994,0.165,NULL,46868130249,732314535,11442414,15.3),(108343,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108343,33.64,0.32,53.4,46336,85,NULL,'I, raw','ESO 444- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108344,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108344,33.65,0.32,53.7,46336,85,NULL,'I, inv','ESO 444- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108345,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108345,33.85,0.43,58.8,46336,75,NULL,'MAT, I, raw','ESO 444- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108346,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108346,33.94,0.43,61.3,46336,75,NULL,'MAT, I, cor','ESO 444- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108347,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108347,33.95,0.43,61.7,46336,75,NULL,'MAT, I, inv','ESO 444- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108348,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108348,33.99,0.11,62.9,46336,NULL,NULL,NULL,'ESO 444- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108349,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108349,34.88,0.49,94.8,46336,75,NULL,'IR','ESO 444- G 014',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108350,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108350,37.57,0.46,327,46337,70,NULL,NULL,'2MASX J13220930+0106158',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000092,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,200.538875,1.10447,0.034,NULL,58053188167,907081065,14173141,17.1),(108351,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108351,37.18,0.46,273,46338,70,NULL,NULL,'2MASX J13220975+3629313',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,200.540583,36.492,0,NULL,59166886065,924482594,14445040,17.8),(108352,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108352,38.22,0.46,441,46339,70,NULL,NULL,'SDSS J132211.09+175824.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,200.54625,17.97342,0.035,NULL,58829843169,919216299,14362754,18.4),(108353,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108353,34.52,0.51,80,46340,70,NULL,NULL,'2MASX J13221122-1606050',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'15.49',NULL,NULL,NULL,NULL,NULL,NULL,1,200.546667,-16.10133,0.125,NULL,44000070460,687501100,10742204,15.49),(108354,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108354,37.82,0.46,366,46341,70,NULL,NULL,'SDSS J132211.41+505752.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.5g',0.09,NULL,NULL,NULL,NULL,NULL,1,200.547583,50.96444,0,NULL,59274942317,926170973,14471421,18.5),(108355,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108355,37.43,0.46,307,46342,70,NULL,NULL,'LCRS B131937.2-030331',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000085,NULL,'17.4g',0.23,'BLAGN',NULL,NULL,NULL,'Sy 1',1,200.550833,-3.31983,0.065,NULL,43837790831,684965481,10702585,17.4),(108356,'TRGB','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108356,27.87,0.04,3.75,46343,NULL,NULL,'I','[KK2000] 55',NULL,'2009AJ....138..332J',2009,1,0.8,NULL,'G',NULL,NULL,'18.5',0.7,'Sph',NULL,NULL,NULL,NULL,1,200.553208333,-42.72803,0.485,NULL,46962692526,733792070,11465501,18.5),(108357,'TRGB','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108357,27.93,0.11,3.85,46343,NULL,NULL,NULL,'[KK2000] 55',NULL,'2015ApJ...802L..25T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108358,'TRGB','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108358,27.98,NULL,3.94,46343,NULL,NULL,NULL,'[KK2000] 55',NULL,'2007AJ....133..504K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108359,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108359,38.16,0.33,429,46344,70,NULL,NULL,'2MASX J13221313+3711153',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,200.554833,37.18756,0,NULL,59297895493,926529617,14477025,17.3),(108360,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108360,35.84,0.46,147,46345,70,NULL,NULL,'CGCG 016-061',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000099,NULL,'15.2g',0.39,'S0',NULL,NULL,NULL,NULL,1,200.561167,-3.08819,0.065,NULL,43837632736,684963011,10702547,15.2),(108361,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108361,37.17,0.46,272,46346,70,NULL,NULL,'2MASX J13221520+2704248',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000153,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,200.56325,27.07342,0.064,NULL,58658401074,916537516,14320898,17.7),(108362,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108362,37.2,0.33,275,46347,70,NULL,NULL,'LCRS B131940.6-023741',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000088,NULL,'17.5g',0.24,'NLAGN',NULL,NULL,NULL,NULL,1,200.5645,-2.88936,0.033,NULL,43823205005,684737578,10699024,17.5),(108363,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108363,37.92,0.46,384,46348,70,NULL,NULL,'2MASX J13221579+5848004',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000172,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,200.566125,58.80031,0,NULL,57388944459,896702257,14010972,18.4),(108364,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108364,37.2,0.33,275,46349,70,NULL,NULL,'VIII Zw 298',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00009,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,200.56725,-2.9205,0.033,NULL,43836902971,684951608,10702368,16.5),(108365,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108365,38.7,0.46,549,46350,70,NULL,NULL,'2MASX J13221673-0106079',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000095,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,200.569833333,-1.10225,0.009,NULL,43087998627,673249978,10519530,18.3),(108366,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108366,37.45,0.46,309,46351,70,NULL,NULL,'2MASX J13221749+1634213',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.83',0.15,NULL,NULL,NULL,NULL,NULL,1,200.572833,16.57256,0,NULL,58832982976,919265359,14363521,18.83),(108367,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108367,38.78,0.46,571,46352,70,NULL,NULL,'SDSS J132217.64+024607.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000134,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,200.5735417,2.76867,0.006,NULL,58923819783,920684684,14385698,18.3),(108368,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108368,37.89,0.13,378,46353,70,NULL,NULL,'2MASX J13221773+1114345',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.61',0.12,NULL,NULL,NULL,NULL,NULL,1,200.5740417,11.24306,0.011,NULL,58945465033,921022891,14390982,18.61),(108369,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108369,38.64,0.33,535,46354,70,NULL,NULL,'SDSS J132218.16-015054.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000077,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,200.5757083,-1.84847,0.037,NULL,43086424588,673225384,10519146,18.6),(108370,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108370,38.73,0.46,557,46355,70,NULL,NULL,'2MASX J13221839+4309427',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000138,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,200.5767917,43.16189,0,NULL,59310803034,926731297,14480176,18.3),(108371,'Sosies','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108371,34.61,0.22,83.6,46356,NULL,NULL,NULL,'MCG -03-34-063',NULL,'2002A&A...393...57T',2002,1,1.7,'Often confused with the Seyfert MCG -03-34-064 in the literature.','G',0.00011,NULL,'14.96',0.5,'Sy2',NULL,NULL,NULL,NULL,1,200.579375,-16.70836,0.177,NULL,43779411193,684053299,10688332,14.96),(108372,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108372,36.9,0.46,240,46357,70,NULL,NULL,'2MASX J13221917+1146115',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,200.579917,11.76981,0.017,NULL,58945577729,921024652,14391010,17.6),(108373,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108373,37.84,0.27,369,46358,70,NULL,NULL,'2MASX J13221989+1327373',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000195,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,200.58275,13.46056,0.009,NULL,59019762668,922183791,14409121,16.9),(108374,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108374,37.89,0.13,378,46359,70,NULL,NULL,'2MASX J13222098+1108005',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000175,NULL,'18.1g',0.15,'AGN',NULL,NULL,NULL,NULL,1,200.587333333,11.13347,0.011,NULL,58945345085,921021016,14390953,18.1),(108375,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108375,37.8,0.33,364,46360,70,NULL,NULL,'2MASX J13222146+1640103',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.24',0.21,NULL,NULL,NULL,NULL,NULL,1,200.589625,16.66969,0,NULL,58833040473,919266257,14363535,18.24),(108376,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108376,37.48,0.33,313,46361,70,NULL,NULL,'SDSS J132221.97-023045.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000065,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,200.591583,-2.51261,0.033,NULL,43824120405,684751881,10699248,18.1),(108377,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108377,38.09,0.46,415,46362,70,NULL,NULL,'SDSS J132222.11+600720.8',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000134,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,200.592167,60.1225,0,NULL,57394500052,896789063,14012329,17.8),(108378,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108378,38.37,0.46,472,46363,70,NULL,NULL,'SDSS J132222.23+221904.2',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,200.592666667,22.31786,0.056,NULL,58850069133,919532330,14367692,17.6),(108379,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108379,37.89,0.13,378,46364,70,NULL,NULL,'2MASX J13222260+1112536',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000175,NULL,'16.5g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,200.5942083,11.21489,0.011,NULL,58945463658,921022869,14390982,16.5),(108380,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108380,37.21,0.46,276,46365,70,NULL,NULL,'2MASX J13222269+3952473',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000212,NULL,'15.9g',0.41,NULL,NULL,NULL,NULL,NULL,1,200.594583,39.87986,0,NULL,59296004498,926500070,14476563,15.9),(108381,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108381,38.64,0.33,535,46366,70,NULL,NULL,'VIII Zw 299 NOTES02',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000079,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,200.597417,-1.84119,0.037,NULL,43086425994,673225406,10519146,17.7),(108382,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108382,37.75,0.46,355,46367,70,NULL,NULL,'2MASX J13222345+2621428',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,200.597875,26.36197,0.05,NULL,58663722131,916620658,14322197,17.2),(108383,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108383,37.8,0.46,362,46368,70,NULL,NULL,'2MASX J13222362+6639241',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000104,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,200.59875,66.65678,0.053,NULL,57875616412,904306506,14129789,16.8),(108384,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108384,36.96,0.33,246,46369,70,NULL,NULL,'2MASX J13222395+0739196',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,200.599917,7.65542,0.014,NULL,58981653949,921588342,14399817,17.5),(108385,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108385,36.67,0.46,215,46370,70,NULL,NULL,'2MASX J13222437+2242089',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.32',0.18,NULL,NULL,NULL,NULL,NULL,1,200.6017917,22.70247,0.047,NULL,58846752921,919480514,14366883,17.32),(108386,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108386,33.29,0.43,45.5,46371,75,NULL,'3.6 micron, color + selection bias corrected','MCG -03-34-064',NULL,'2014MNRAS.444..527S',2014,1,1,'Often incorrectly called MCG -03-34-063 in the literature.','G',0.00004,NULL,'14.64',0.8,'SB?            Sy1.8',NULL,NULL,NULL,'Sy 1 h',1,200.601916667,-16.72847,0.177,NULL,43779408693,684053260,10688332,14.64),(108387,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108387,34.41,0.4,76.2,46371,NULL,NULL,'mean','MCG -03-34-064',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108388,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108388,35.65,0.47,135,46371,NULL,NULL,'H','MCG -03-34-064',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108389,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108389,37.48,0.33,313,46372,70,NULL,NULL,'LCRS B131950.8-021726',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00008,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,200.606416667,-2.55164,0.033,NULL,43824090408,684751412,10699240,17.6),(108390,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108390,37.69,0.46,344,46373,70,NULL,NULL,'2MASX J13222579+5202235',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000167,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,200.607416667,52.03994,0,NULL,59206845649,925106963,14454796,17.2),(108391,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108391,37.8,0.46,364,46374,70,NULL,NULL,'2MASX J13222783+1601173',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.26',0.23,NULL,NULL,NULL,NULL,NULL,1,200.615875,16.0215,0,NULL,59012279022,922066859,14407294,17.26),(108392,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108392,38.02,0.46,402,46375,70,NULL,NULL,'2MASX J13222844+3238502',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000121,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,200.618417,32.64733,0,NULL,59163955399,924436803,14444325,18.4),(108393,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108393,37.89,0.13,378,46376,70,NULL,NULL,'2MASX J13222981+1112416',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000181,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,200.6240417,11.21153,0.011,NULL,58945468253,921022941,14390983,17.4),(108394,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108394,36.25,0.46,178,46377,70,NULL,NULL,'2MASX J13222987+2306469',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.6g',0.29,'AGN',NULL,NULL,NULL,NULL,1,200.6244583,23.11311,NULL,NULL,58846702357,919479724,14366870,16.6),(108395,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108395,37.75,0.46,355,46378,70,NULL,NULL,'2MASX J13223041+3359552',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,200.626875,33.99856,0.007,NULL,59169759962,924527499,14445742,17.7),(108396,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108396,36.89,0.46,238,46379,70,NULL,NULL,'2MASX J13223059+2205579',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000097,NULL,'17.10',0.24,NULL,NULL,NULL,NULL,NULL,1,200.627375,22.09956,0.057,NULL,58850270673,919535479,14367741,17.1),(108397,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108397,35.11,0.46,105,46380,70,NULL,NULL,'IC 0885',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000053,NULL,'14.9',0.8,'E','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,200.628833,21.31642,0.068,NULL,58847645062,919494454,14367100,14.9),(108398,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108398,38.11,0.46,418,46381,70,NULL,NULL,'2MASX J13223095+4907305',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000161,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,200.628875,49.12508,0,NULL,59277242099,926206907,14471982,17.2),(108399,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108399,38.16,0.33,429,46382,70,NULL,NULL,'2MASX J13223145+3707456',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,200.631,37.12944,0,NULL,59297896682,926529635,14477025,17.2),(108400,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108400,37.58,0.19,328,46383,70,NULL,NULL,'2MASX J13223206-0142502',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000082,NULL,'17.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,200.6335,-1.71406,0.045,NULL,43086458958,673225921,10519155,17.3),(108401,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108401,37.84,0.27,369,46384,70,NULL,NULL,'2MASX J13223215+1315503',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,200.633833333,13.26389,0.009,NULL,59019796248,922184316,14409129,17.3),(108402,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108402,37.17,0.46,272,46385,70,NULL,NULL,'2MASX J13223231+3940576',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,200.63475,39.68269,0,NULL,59296849570,926513274,14476769,17.7),(108403,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108403,37.71,0.33,349,46386,70,NULL,NULL,'2MASX J13223312+1705503',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'19.10',0.23,NULL,NULL,NULL,NULL,NULL,1,200.6379583,17.09742,0,NULL,58833166165,919268221,14363565,19.1),(108404,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108404,35.34,0.57,117,46387,70,NULL,NULL,'2MASX J13223363-1046314',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.55',NULL,NULL,NULL,NULL,NULL,NULL,1,200.64025,-10.7755,0.045,NULL,43867393876,685428029,10709812,15.55),(108405,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108405,37.55,0.46,324,46388,70,NULL,NULL,'2MASX J13223540+3238212',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.0001,NULL,'16.8g',0.27,'E0',NULL,NULL,NULL,NULL,1,200.647583333,32.63931,0,NULL,59163984485,924437257,14444332,16.8),(108406,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108406,38.27,0.46,451,46389,70,NULL,NULL,'2MASX J13223640+1029196',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000175,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,200.6517917,10.48878,0,NULL,58945735428,921027116,14391048,16.9),(108407,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108407,34.89,0.52,95,46390,70,NULL,NULL,'2MASX J13223703-1303560',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.94',NULL,NULL,NULL,NULL,NULL,NULL,1,200.6542917,-13.06581,0.097,NULL,44005475220,687585550,10743524,15.94),(108408,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108408,37.58,0.19,328,46391,70,NULL,NULL,'2MASX J13223920-0138182',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000085,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,200.663291667,-1.63839,0.045,NULL,43086500826,673226575,10519165,17.4),(108409,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108409,37.67,0.46,342,46392,70,NULL,NULL,'2MASX J13224122+1106526',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000206,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,200.6717083,11.11444,0.011,NULL,58945355338,921021177,14390955,17.9),(108410,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108410,38.44,0.46,488,46393,70,NULL,NULL,'2MASX J13224198+0753226',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00018,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,200.675,7.88961,0.011,NULL,58981773593,921590212,14399847,17.2),(108411,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108411,37.84,0.46,371,46394,70,NULL,NULL,'2MASX J13224225+0001326',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000077,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,200.676,0.02572,0.033,NULL,58051677263,907057457,14172772,18),(108412,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108412,37.92,0.23,383,46395,70,NULL,NULL,'SDSS J132242.43+001020.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00007,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,200.6767917,0.17244,0.019,NULL,58051745009,907058515,14172789,18.5),(108413,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108413,37.92,0.23,383,46396,70,NULL,NULL,'2MASX J13224271+0009336',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000095,NULL,'16.7g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,200.677875,0.15931,0.019,NULL,58051752119,907058626,14172791,16.7),(108414,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108414,37.41,0.46,303,46397,70,NULL,NULL,'2MASX J13224413+2924355',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000063,NULL,'17.2g',0.22,'E3',NULL,NULL,NULL,NULL,1,200.683833,29.40975,0.009,NULL,58712033851,917375528,14333992,17.2),(108415,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108415,36.94,0.46,244,46398,70,NULL,NULL,'2MASX J13224465+4014177',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000185,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,200.686167,40.23833,0,NULL,59296024702,926500385,14476568,17),(108416,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108416,38.11,0.46,419,46399,70,NULL,NULL,'2MASX J13224588-0218271',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000076,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,200.6912083,-2.3075,0.037,NULL,43824039285,684750613,10699228,18.2),(108417,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108417,38.37,0.33,473,46400,70,NULL,NULL,'2MASX J13224650+0351194',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000173,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,200.693875,3.85544,0.036,NULL,58937906304,920904786,14389137,17.7),(108418,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108418,38.09,0.46,415,46401,70,NULL,NULL,'SDSS J132246.98+010117.0',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000073,NULL,'18.6g',0.09,NULL,NULL,NULL,NULL,NULL,1,200.6957917,1.02139,0.028,NULL,58053334934,907083358,14173177,18.6),(108419,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108419,35.89,0.7,151,46402,70,NULL,NULL,'AM 1320-330 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.8,'6dF DR2 has z = 0.046620.','G',0.000133,NULL,'16.4b',NULL,'(R\')SABa',NULL,NULL,NULL,NULL,1,200.696917,-33.38592,0.185,NULL,46871656852,732369638,11443275,16.4),(108420,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108420,36.16,0.46,171,46403,70,NULL,NULL,'2MASX J13224787+3330322',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000161,NULL,'16.8g',0.28,'E2',NULL,NULL,NULL,NULL,1,200.699291667,33.50889,0.007,NULL,59169594736,924524917,14445701,16.8),(108421,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108421,36.11,0.46,167,46404,70,NULL,NULL,'2MASX J13224800+5216581',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000172,NULL,'15.9g',0.38,NULL,NULL,NULL,NULL,NULL,1,200.6999583,52.28294,0,NULL,57277658303,894963410,13983803,15.9),(108422,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108422,37.11,0.46,264,46405,70,NULL,NULL,'SDSS J132248.11+022650.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,200.7004583,2.44731,0.028,NULL,58924668223,920697940,14385905,17.7),(108423,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108423,37.37,0.46,298,46406,70,NULL,NULL,'2MASX J13224919+1741151',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.79',0.31,NULL,NULL,NULL,NULL,NULL,1,200.705083,17.6875,0.019,NULL,58832955080,919264923,14363514,17.79),(108424,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108424,37.92,0.23,383,46407,70,NULL,NULL,'2MASX J13224926+0018414',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000073,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,200.705333,0.31147,0.019,NULL,58051771631,907058931,14172795,17.8),(108425,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108425,36.96,0.33,246,46408,70,NULL,NULL,'VIII Zw 303',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,200.708167,7.71011,0.011,NULL,58981832838,921591138,14399861,17.1),(108426,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108426,37.71,0.33,349,46409,70,NULL,NULL,'2MASX J13224999+1705261',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,NULL,0.35,'2MASS Extended Ver.2',NULL,NULL,NULL,NULL,1,200.708375,17.09064,0,NULL,58833146613,919267915,14363561,NULL),(108427,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108427,38.19,0.46,434,46410,70,NULL,NULL,'LCRS B132015.3-024016',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000079,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,200.709167,-2.93203,0.033,NULL,43837371619,684958931,10702483,18.3),(108428,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108428,39.01,0.46,633,46411,70,NULL,NULL,'2MASX J13225041+3546102',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,200.71025,35.76928,0,NULL,59166386128,924474783,14444918,17.9),(108429,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108429,37.58,0.19,328,46412,70,NULL,NULL,'2MASX J13225255-0130535',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00007,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,200.718917,-1.51492,0.021,NULL,43086362617,673224415,10519131,17.9),(108430,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108430,36.74,0.65,222,46413,70,NULL,NULL,'2MASX J13225342-2737280',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.7b',NULL,'E',NULL,NULL,NULL,NULL,1,200.722666667,-27.62442,0.233,NULL,43296623343,676509739,10570464,16.7),(108431,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108431,37.48,0.46,313,46414,70,NULL,NULL,'2MASX J13225345+3717017',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,200.722875,37.28372,0,NULL,59297406593,926521978,14476905,16.8),(108432,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108432,37.92,0.23,383,46415,70,NULL,NULL,'SDSS J132253.58+001147.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000059,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,200.72325,0.19644,0.019,NULL,58051773433,907058959,14172796,18.3),(108433,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108433,37.8,0.21,363,46416,70,NULL,NULL,'SDSS J132254.46+135245.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.7g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,200.7269583,13.87931,0.017,NULL,59022181067,922221579,14409712,18.7),(108434,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108434,35.6,0.63,132,46417,70,NULL,NULL,'2MASX J13225478-3502554',NULL,'2014MNRAS.445.2677S',2014,1,0.6,'6dF DR2 has z = 0.027290.','G',0.00015,NULL,'14.97',NULL,'E',NULL,NULL,NULL,NULL,1,200.728208333,-35.04872,0.149,NULL,46874819561,732419055,11444047,14.97),(108435,'IRAS','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108435,33.16,0.8,42.9,46418,75,NULL,'CF, r','NGC 5116',NULL,'1997ApJS..109..333W',1997,1,1.98,NULL,'G',0.000017,NULL,'13.5g',0.68,'SB(s)c:','Field galaxy',NULL,NULL,NULL,1,200.7317083,26.98072,0.064,NULL,58658415075,916537735,14320902,13.5),(108436,'Tully est','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108436,33.17,0.8,43,46418,75,NULL,'B','NGC 5116',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108437,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108437,33.14,0.43,42.4,46418,75,NULL,'3.6 micron, color corrected','NGC 5116',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108438,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108438,33.15,0.47,42.6,46418,NULL,NULL,'H','NGC 5116',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108439,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108439,33.17,0.43,43.1,46418,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5116',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108440,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108440,33.18,0.46,43.2,46418,NULL,NULL,'J','NGC 5116',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108441,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108441,33.19,0.38,43.4,46418,75,NULL,'CF, r, raw','NGC 5116',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108442,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108442,33.22,0.2,44.1,46418,74.4,NULL,NULL,'NGC 5116',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108443,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108443,33.25,0.45,44.6,46418,NULL,NULL,'K','NGC 5116',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108444,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108444,33.29,0.4,45.5,46418,NULL,NULL,'mean','NGC 5116',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108445,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108445,33.3,0.38,45.7,46418,75,NULL,'CF, r, inv','NGC 5116',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108446,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108446,33.43,0.38,48.6,46418,75,NULL,'CF, r, cor','NGC 5116',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108447,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108447,33.46,0.56,49.1,46418,NULL,NULL,NULL,'NGC 5116',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108448,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108448,33.53,0.54,50.9,46418,NULL,NULL,'Malmquist cor.','NGC 5116',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108449,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108449,36.07,0.53,164,46419,70,NULL,NULL,'ESO 444- G 017',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00007,NULL,'14.3V',0.8,'(R\'_2:)SB(r)a',NULL,NULL,NULL,NULL,1,200.7317083,-31.73819,0.133,NULL,46871096611,732360884,11443138,14.3),(108450,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108450,37.35,0.33,295,46420,70,NULL,NULL,'2MASX J13225617+5511470',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000157,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,200.733917,55.19642,0.005,NULL,57418110765,897157980,14018093,16.8),(108451,'Tully est','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108451,32.91,0.8,38.3,46421,75,NULL,'B','NGC 5117',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.00001,NULL,'14.3g',0.81,'SBcd?',NULL,NULL,NULL,NULL,1,200.735333333,28.31644,0,NULL,58714240918,917410014,14334531,14.3),(108452,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108452,32.51,0.43,31.8,46421,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5117',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108453,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108453,32.64,0.4,33.7,46421,NULL,NULL,NULL,'NGC 5117',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108454,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108454,32.72,0.43,34.9,46421,75,NULL,'3.6 micron, color corrected','NGC 5117',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108455,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108455,32.95,0.2,38.9,46421,74.4,NULL,NULL,'NGC 5117',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108456,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108456,33.16,0.63,42.8,46421,NULL,NULL,'Malmquist cor.','NGC 5117',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108457,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108457,33.19,0.63,43.4,46421,NULL,NULL,NULL,'NGC 5117',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108458,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108458,34.35,0.47,74.3,46422,70,NULL,NULL,'NGC 5110',NULL,'2014MNRAS.445.2677S',2014,1,0.4,'Star superposed.','G',0.000067,NULL,'13.13',0.4,'E2/S0-',NULL,NULL,NULL,NULL,1,200.7355,-12.96481,0.093,NULL,44005481237,687585644,10743525,13.13),(108459,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108459,38.18,0.46,433,46423,70,NULL,NULL,'SDSS J132256.95+574715.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000136,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,200.737333,57.78764,0,NULL,57432961916,897390029,14021719,18.7),(108460,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108460,38.21,0.46,438,46424,70,NULL,NULL,'2MASX J13225802-0229105',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000094,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,200.741667,-2.48617,0.037,NULL,43824125554,684751961,10699249,17.5),(108461,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108461,35.45,0.53,123,46425,70,NULL,NULL,'2MASX J13225872-3242464',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'17.23',NULL,'E',NULL,NULL,NULL,NULL,1,200.744625,-32.71286,0.185,NULL,46870409812,732350153,11442971,17.23),(108462,'IRAS','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108462,35.04,0.8,102,46426,75,NULL,'HMCL, I','NGC 5115',NULL,'1997ApJS..109..333W',1997,1,1.18,NULL,'G',0.000033,NULL,'14.6g',0.6,'SBcd:',NULL,NULL,NULL,NULL,1,200.751583,13.95067,0.028,NULL,59022148984,922221077,14409704,14.6),(108463,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108463,34.26,0.4,71,46426,75,NULL,'HMCL, I, raw','NGC 5115',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108464,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108464,34.38,0.4,75.2,46426,75,NULL,'HMCL, I, inv','NGC 5115',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108465,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108465,34.61,0.4,83.5,46426,NULL,NULL,NULL,'NGC 5115',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108466,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108466,34.63,0.2,84.3,46426,74.4,NULL,NULL,'NGC 5115',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108467,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108467,34.64,0.4,84.8,46426,75,NULL,'HMCL, I, cor','NGC 5115',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108468,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108468,34.76,0.38,89.5,46426,NULL,NULL,'Malmquist cor.','NGC 5115',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108469,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108469,33.14,0.2,42.5,46427,74.4,NULL,NULL,'UGC 08409',NULL,'2013AJ....146...86T',2013,1,3.1,NULL,'G',0.00002,NULL,'14.8',1.5,'SAdm',NULL,NULL,NULL,NULL,1,200.753583,23.30636,NULL,NULL,58791965496,918624460,14353507,14.8),(108470,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108470,33.15,0.4,42.7,46427,75,NULL,'B','UGC 08409',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108471,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108471,38.37,0.33,473,46428,70,NULL,NULL,'2MASX J13230174+0353584',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000182,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,200.757333,3.8995,0.036,NULL,58937925976,920905093,14389142,17.1),(108472,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108472,37.58,0.19,328,46429,70,NULL,NULL,'2MASX J13230209-0142405',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00008,NULL,'16.3g',0.44,'BrClG',NULL,NULL,NULL,NULL,1,200.75875,-1.71139,0.021,NULL,43086468212,673226065,10519157,16.3),(108473,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108473,37.88,0.33,377,46430,70,NULL,NULL,'2MASX J13230211+1101324',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.85',0.23,NULL,NULL,NULL,NULL,NULL,1,200.75875,11.02558,0.01,NULL,58945379906,921021561,14390961,17.85),(108474,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108474,38.13,0.46,423,46431,70,NULL,NULL,'2MASX J13230229+5418220',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,200.7597083,54.30594,0,NULL,57412860971,897075952,14016811,18.1),(108475,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108475,37.63,0.46,336,46432,70,NULL,NULL,'VII Zw 510',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,200.759916667,61.00608,0.013,NULL,57393463220,896772862,14012075,17.3),(108476,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108476,35.33,0.47,116,46433,70,NULL,NULL,'2MASX J13230241-3452464',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.3b',NULL,'E        poss. LINER',NULL,NULL,NULL,NULL,1,200.760083,-34.87964,0.153,NULL,46874786713,732418542,11444039,15.3),(108477,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108477,36.46,0.46,196,46434,70,NULL,NULL,'2MASX J13230250+0824564',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.39',0.24,NULL,NULL,NULL,NULL,NULL,1,200.7604583,8.41564,0,NULL,58981462571,921585352,14399771,17.39),(108478,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108478,38.2,0.46,437,46435,70,NULL,NULL,'2MASX J13230253+4849191',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'18.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,200.76075,48.822,0,NULL,59275232871,926175513,14471492,18.1),(108479,'TRGB','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'RN',108479,27.96,0.25,3.91,46436,NULL,NULL,NULL,'CenA-MM-Dw4',NULL,'2015arXiv151205366C',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108480,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108480,36.74,0.46,223,46437,70,NULL,NULL,'2MASX J13230272+1105254',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.96',0.23,NULL,NULL,NULL,NULL,NULL,1,200.761417,11.09039,0.01,NULL,58945387261,921021675,14390963,16.96),(108481,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108481,35.57,0.48,130,46438,70,NULL,NULL,'2MASX J13230295-4133592',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00011,NULL,'13.2I',0.7,NULL,NULL,NULL,NULL,NULL,1,200.762375,-41.56639,0.465,NULL,46961705053,733776641,11465260,13.2),(108482,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108482,37.5,0.46,316,46439,70,NULL,NULL,'2MASX J13230721+4641348',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,200.779958333,46.693,0,NULL,59289960270,926405629,14475087,17.9),(108483,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108483,37.79,0.46,362,46440,70,NULL,NULL,'LCRS B132032.8-025135',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000073,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,200.782375,-3.12056,0.065,NULL,43837380315,684959067,10702485,17.9),(108484,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108484,37.85,0.46,372,46441,70,NULL,NULL,'2MASX J13230923+2935023',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000167,NULL,'16.5g',0.28,'E3',NULL,NULL,NULL,NULL,1,200.788458333,29.58392,0.023,NULL,58712116252,917376816,14334012,16.5),(108485,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108485,37.89,0.13,378,46442,70,NULL,NULL,'2MASX J13230951+1112534',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,200.789666667,11.21489,0.01,NULL,58945537664,921024026,14391000,17.8),(108486,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108486,36.72,0.46,221,46443,70,NULL,NULL,'2MASX J13230985+5513500',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000198,NULL,'15.8g',0.4,'E0',NULL,NULL,NULL,NULL,1,200.7907917,55.23064,0.005,NULL,57418112306,897158004,14018093,15.8),(108487,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108487,37.63,0.46,337,46444,70,NULL,NULL,'2MASX J13231046+5104231',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000146,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,200.793625,51.07319,0,NULL,59274806757,926168855,14471388,17.6),(108488,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108488,36.62,0.46,211,46445,70,NULL,NULL,'2MASX J13231098+3622476',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000139,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,200.7957917,36.37992,0,NULL,59166935808,924483372,14445052,17.5),(108489,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108489,37.89,0.13,378,46446,70,NULL,NULL,'2MASX J13231107+1116574',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,200.796083,11.28261,0.037,NULL,58945549877,921024216,14391003,17.1),(108490,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108490,37.59,0.46,330,46447,70,NULL,NULL,'2MASX J13231148+5409069',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00017,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,200.797875,54.15178,0,NULL,57413594085,897087407,14016990,17.4),(108491,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108491,37.14,0.46,268,46448,70,NULL,NULL,'2MASX J13231201+3357045',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000163,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,200.800125,33.95111,0.007,NULL,59169757193,924527456,14445741,17),(108492,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108492,37.89,0.13,378,46449,70,NULL,NULL,'SDSS J132312.29+111919.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000175,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,200.80125,11.32197,0.037,NULL,58945547670,921024182,14391002,18.1),(108493,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108493,37.94,0.46,388,46450,70,NULL,NULL,'SDSS J132312.43+161943.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,200.8017917,16.32878,0,NULL,58831118894,919236232,14363066,18.6),(108494,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108494,38.55,0.46,512,46451,70,NULL,NULL,'2MASX J13231263+0238344',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000189,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,200.802583333,2.64292,0.026,NULL,58924569988,920696406,14385881,17.6),(108495,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108495,37.04,0.46,256,46452,70,NULL,NULL,'2MASX J13231275+2658323',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,200.803083,26.97578,0.076,NULL,58658408510,916537632,14320900,17.6),(108496,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108496,37.55,0.46,323,46453,70,NULL,NULL,'SDSS J132312.79+054447.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,200.803333,5.74664,0.019,NULL,58927049188,920735143,14386486,18.2),(108497,'IRAS','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108497,32.26,0.8,28.3,46454,75,NULL,'MAT, I','IC 4231',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'14.52',0.4,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,200.80575,-26.30039,0.237,NULL,43290545174,676414768,10568980,14.52),(108498,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108498,31.91,0.32,24.1,46454,85,NULL,'I, raw','IC 4231',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108499,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108499,31.91,0.32,24.1,46454,85,NULL,'I, inv','IC 4231',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108500,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108500,32.15,0.43,26.9,46454,75,NULL,'MAT, I, raw','IC 4231',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108501,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108501,32.21,0.43,27.7,46454,75,NULL,'MAT, I, inv','IC 4231',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108502,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108502,32.23,0.43,27.9,46454,75,NULL,'3.6 micron, color corrected','IC 4231',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108503,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108503,32.22,0.43,27.9,46454,75,NULL,'3.6 micron, color + selection bias corrected','IC 4231',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108504,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108504,32.24,0.49,28.1,46454,75,NULL,'IR','IC 4231',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108505,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108505,32.24,0.4,28.1,46454,NULL,NULL,NULL,'IC 4231',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108506,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108506,32.27,0.2,28.4,46454,74.4,NULL,NULL,'IC 4231',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108507,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108507,32.27,0.4,28.5,46454,75,NULL,NULL,'IC 4231',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108508,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108508,32.46,0.43,31,46454,75,NULL,'MAT, I, cor','IC 4231',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108509,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108509,32.54,0.48,32.2,46454,NULL,NULL,NULL,'IC 4231',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108510,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108510,32.73,0.44,35.1,46454,NULL,NULL,'Malmquist cor.','IC 4231',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108511,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108511,36.16,0.46,170,46455,70,NULL,NULL,'2MASX J13231431+3210045',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.0001,NULL,'15.7g',0.44,'E0',NULL,NULL,NULL,NULL,1,200.809625,32.168,0.008,NULL,59164697918,924448404,14444506,15.7),(108512,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108512,35.53,0.49,128,46456,75,NULL,'IR','FGC 1607',NULL,'2011yCatp016004901K',2011,1,0.21,NULL,'G',0.000083,NULL,'17.7g',0.12,'Sd',NULL,NULL,NULL,NULL,1,200.8105417,44.43281,0,NULL,59310004732,926718823,14479981,17.7),(108513,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108513,35.77,NULL,143,46456,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1607',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108514,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108514,35.79,NULL,144,46456,NULL,NULL,'Dipole + Quadrupole','FGC 1607',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108515,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108515,35.82,NULL,146,46456,NULL,NULL,NULL,'FGC 1607',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108516,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108516,35.82,NULL,146,46456,NULL,NULL,'Dipole','FGC 1607',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108517,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108517,37.68,0.46,343,46457,70,NULL,NULL,'SDSS J132315.61+110630.6',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000168,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,200.815083333,11.10853,0.01,NULL,58945258533,921019664,14390932,17.2),(108518,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108518,37.75,0.33,354,46458,70,NULL,NULL,'SDSS J132315.90+482913.0',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,200.8162917,48.48697,0,NULL,59275254868,926175857,14471497,18),(108519,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108519,37.69,0.46,346,46459,70,NULL,NULL,'2MASX J13231591-0123053',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,200.816417,-1.38494,0.017,NULL,43087514070,673242407,10519412,16.9),(108520,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108520,37.47,0.46,313,46460,70,NULL,NULL,'2MASX J13231736-0054523',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000065,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,200.822125,-0.91469,0.009,NULL,43087867361,673247927,10519498,17.8),(108521,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108521,35.46,0.46,124,46461,70,NULL,NULL,'CGCG 016-063',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000089,NULL,'15.5g',0.51,'E              AGN?','Isolated galaxy',NULL,NULL,NULL,1,200.822958333,-2.15108,0.037,NULL,43823745656,684746025,10699156,15.5),(108522,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108522,37.8,0.21,363,46462,70,NULL,NULL,'2MASX J13231809+1323168',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,200.8252917,13.38808,0.009,NULL,59019434735,922178667,14409041,17.6),(108523,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108523,34.99,0.49,99.4,46463,70,NULL,NULL,'ESO 576- G 044',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000117,NULL,'14.97',0.8,'SA0^0^: pec',NULL,NULL,NULL,NULL,1,200.826417,-19.62011,0.273,NULL,43820515722,684695558,10698368,14.97),(108524,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108524,37.58,0.19,328,46464,70,NULL,NULL,'2MASX J13231873-0200263',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000083,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,200.8280417,-2.00725,0.033,NULL,43823776563,684746508,10699164,17.4),(108525,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108525,37.75,0.33,354,46465,70,NULL,NULL,'2MASX J13232153+4828227',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000146,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,200.839625,48.47297,0,NULL,59275255238,926175863,14471497,17.6),(108526,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108526,34.66,0.5,85.4,46466,70,NULL,NULL,'2MASX J13232213-4415530',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.4I',0.4,NULL,NULL,NULL,NULL,NULL,1,200.842333,-44.26472,0.453,NULL,46961084715,733766948,11465108,13.4),(108527,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108527,37.58,0.19,328,46467,70,NULL,NULL,'2MASX J13232245-0135253',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000064,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,200.8435,-1.59053,0.021,NULL,43086271390,673222990,10519109,17.2),(108528,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108528,37.68,0.46,344,46468,70,NULL,NULL,'2MASX J13232245+0041558',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000067,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,200.8435,0.69881,0.021,NULL,58052659520,907072805,14173012,18),(108529,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1991U',NULL,108529,34.62,0.17,81.4,46469,74.2,NULL,'SALT 2','IC 4232',0.031442,'2010ApJ...716..712A',2010,1,1.1,NULL,'G',0.000143,NULL,'14.53',0.3,'Sbc: pec       HII',NULL,NULL,NULL,NULL,1,200.8435417,-26.1095,0.209,NULL,43291448646,676428885,10569201,14.53),(108530,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1991U',NULL,108530,35.26,0.08,113,46469,74.4,NULL,NULL,'IC 4232',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108531,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1991U',NULL,108531,35.39,0.16,116,46469,70,NULL,'SALT 2','IC 4232',0.031442,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108532,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1991U',NULL,108532,35.43,0.05,118,46469,72,NULL,NULL,'IC 4232',0.03144,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108533,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1991U',NULL,108533,35.54,0.2,124,46469,65,NULL,NULL,'IC 4232',0.03144,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108534,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1991U',NULL,108534,35.61,0.17,125,46469,65,NULL,'MLCS2k2','IC 4232',0.03144,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108535,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1991U',NULL,108535,35.58,0.08,127,46469,70,NULL,'SALT','IC 4232',0.03144,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108536,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1991U',NULL,108536,35.52,0.15,127,46469,60,NULL,'M(I) = -19.19 mag','IC 4232',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108537,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1991U',NULL,108537,35.61,0.2,128,46469,65,NULL,'SALT2','IC 4232',0.031442,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108538,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1991U',NULL,108538,35.62,0.21,129,46469,65,NULL,'MLCS31','IC 4232',0.031442,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108539,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1991U',NULL,108539,35.61,0.16,132,46469,60,NULL,'M(V) = -19.47 mag','IC 4232',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108540,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1991U',NULL,108540,35.65,0.17,135,46469,70.8,NULL,NULL,'IC 4232',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108541,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1991U',NULL,108541,35.68,0.21,137,46469,60,NULL,'M(B) = -19.48 mag','IC 4232',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108542,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1991U',NULL,108542,35.7,0.17,138,46469,65,NULL,'Snapshot','IC 4232',NULL,'1996ApJ...473...88R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108543,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1991U',NULL,108543,35.79,0.14,144,46469,60,NULL,NULL,'IC 4232',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108544,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1991U',NULL,108544,36.02,0.13,160,46469,65,NULL,'LCS','IC 4232',NULL,'1995ApJ...445L..91R',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108545,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:25','1','SN 1991U',NULL,108545,36.42,0.18,187,46469,65,NULL,'MLCS','IC 4232',0.03144,'1996ApJ...473..588R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108546,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108546,38.18,0.33,433,46470,70,NULL,NULL,'2MASX J13232251+0104528',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000071,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,200.84375,1.08144,0.01,NULL,58053035521,907078680,14173104,17.8),(108547,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108547,36.29,0.46,181,46471,70,NULL,NULL,'2MASX J13232367+2715154',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00008,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,200.848791667,27.25425,0.061,NULL,58658591941,916540499,14320945,16.5),(108548,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108548,37.74,0.46,353,46472,70,NULL,NULL,'2MASX J13232403+5628360',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000132,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,200.85,56.47653,0,NULL,57419766310,897183848,14018497,17.5),(108549,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108549,37.8,0.21,363,46473,70,NULL,NULL,'2MASX J13232548+1334258',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000175,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,200.856333,13.57397,0.014,NULL,59021388450,922209194,14409518,16.9),(108550,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108550,38.06,0.46,410,46474,70,NULL,NULL,'2MASX J13232557+2316533',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,200.856375,23.28161,NULL,NULL,58792016157,918625252,14353519,17.2),(108551,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108551,34.4,0.27,75.8,46475,70,NULL,NULL,'2MASX J13232557+3206115',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00008,NULL,'15.7g',0.43,'E3',NULL,NULL,NULL,NULL,1,200.856583,32.10317,0.009,NULL,59164691526,924448305,14444504,15.7),(108552,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108552,36.82,0.46,232,46476,70,NULL,NULL,'2MASX J13232604+2137323',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,200.858583,21.62575,0.073,NULL,58849492536,919523320,14367551,16.9),(108553,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108553,37.78,0.46,360,46477,70,NULL,NULL,'2MASX J13232737+4308394',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000146,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,200.8640417,43.14428,0,NULL,59310839003,926731859,14480185,17.3),(108554,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108554,35.29,0.46,114,46478,70,NULL,NULL,'2MASX J13232795+1255098',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000163,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,200.8665,12.91931,0,NULL,59020138226,922189659,14409213,16.4),(108555,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108555,35.71,0.47,139,46479,70,NULL,NULL,'ESO 508- G 062',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'14.99',0.6,'S0-a',NULL,NULL,NULL,NULL,1,200.86675,-24.05814,0.285,NULL,43763773790,683808965,10684515,14.99),(108556,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108556,37.8,0.21,363,46480,70,NULL,NULL,'2MASX J13232857+1338038',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,200.869083,13.63444,0.014,NULL,59021392920,922209264,14409519,17.6),(108557,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108557,35.82,0.33,146,46481,70,NULL,NULL,'2MASX J13232870+3345037',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000103,NULL,'15.8g',0.46,'E0',NULL,NULL,NULL,NULL,1,200.8695417,33.75094,0.016,NULL,59169779908,924527811,14445747,15.8),(108558,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108558,37.8,0.21,363,46482,70,NULL,NULL,'2MASX J13232871+1331238',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000143,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,200.869666667,13.52333,0.014,NULL,59021332957,922208327,14409505,18.1),(108559,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108559,37.89,0.46,379,46483,70,NULL,NULL,'2MASX J13232887+0004368',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000078,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,200.870333,0.07697,0.033,NULL,58051582639,907055978,14172749,17.5),(108560,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108560,37.92,0.46,384,46484,70,NULL,NULL,'2MASX J13232906+5022497',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,200.8710417,50.38047,0,NULL,59274574693,926165229,14471331,17.6),(108561,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108561,36.27,0.55,179,46485,70,NULL,NULL,'2MASX J13232900-3150392',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000047,NULL,'13.3V',NULL,'E/S0;BrClG',NULL,NULL,NULL,NULL,1,200.8712917,-31.8445,0.229,NULL,46870654103,732353970,11443030,13.3),(108562,'IRAS','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108562,33.88,0.8,59.7,46486,75,NULL,'MAT, I','ESO 444- G 021',NULL,'1997ApJS..109..333W',1997,1,2.26,NULL,'G',0.000013,NULL,'15.54',0.2,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,200.877667,-30.11431,0.229,NULL,46867184780,732299762,11442183,15.54),(108563,'IRAS','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108563,33.88,0.8,59.8,46486,75,NULL,'HMCL, I','ESO 444- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108564,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108564,33.41,0.4,48,46486,75,NULL,'HMCL, I, raw','ESO 444- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108565,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108565,33.45,0.4,49,46486,75,NULL,'HMCL, I, inv','ESO 444- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108566,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108566,33.52,NULL,50.7,46486,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 444- G 021',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108567,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108567,33.53,NULL,50.9,46486,NULL,NULL,'Dipole + Quadrupole','ESO 444- G 021',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108568,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108568,33.54,NULL,51,46486,NULL,NULL,'Dipole','ESO 444- G 021',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108569,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108569,33.55,0.32,51.3,46486,85,NULL,'I, raw','ESO 444- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108570,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108570,33.55,0.32,51.3,46486,85,NULL,'I, inv','ESO 444- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108571,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108571,33.59,0.4,52.3,46486,75,NULL,'HMCL, I, cor','ESO 444- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108572,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108572,33.61,NULL,52.6,46486,NULL,NULL,NULL,'ESO 444- G 021',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108573,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108573,33.68,0.43,54.5,46486,75,NULL,'MAT, I, raw','ESO 444- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108574,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108574,33.73,0.43,55.8,46486,75,NULL,'MAT, I, inv','ESO 444- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108575,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108575,33.81,0.43,57.8,46486,75,NULL,'MAT, I, cor','ESO 444- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108576,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108576,33.92,0.2,60.8,46486,74.4,NULL,NULL,'ESO 444- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108577,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108577,34.02,0.15,63.8,46486,NULL,NULL,NULL,'ESO 444- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108578,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108578,34.03,0.49,63.8,46486,75,NULL,'IR','ESO 444- G 021',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108579,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108579,34.92,0.29,96.6,46487,NULL,NULL,'Malmquist cor.','CGCG 072-058',NULL,'2009ApJS..182..474S',2009,1,0.47,NULL,'G',0.000103,NULL,'15.5',0.36,NULL,NULL,NULL,NULL,NULL,1,200.878291667,13.77286,0.014,NULL,59021400951,922209389,14409521,15.5),(108580,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108580,34.93,0.29,97,46487,NULL,NULL,NULL,'CGCG 072-058',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108581,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108581,34.97,0.2,98.6,46487,74.4,NULL,NULL,'CGCG 072-058',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108582,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108582,37.61,0.33,332,46488,70,NULL,NULL,'SDSS J132330.80+104920.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000144,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,200.878333,10.82231,0,NULL,58945413135,921022080,14390970,17.9),(108583,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108583,35.82,0.33,146,46489,70,NULL,NULL,'2MASX J13233117+3347368',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00013,NULL,'16.1g',0.39,NULL,NULL,NULL,NULL,NULL,1,200.88,33.79367,0.016,NULL,59169783054,924527860,14445747,16.1),(108584,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108584,36.8,0.46,229,46490,70,NULL,NULL,'2MASX J13233142+6624222',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000103,NULL,'15.8g',0.5,'E0',NULL,NULL,NULL,NULL,1,200.880625,66.40628,0.053,NULL,57875434703,904303667,14129744,15.8),(108585,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108585,37.94,0.46,386,46491,70,NULL,NULL,'SDSS J132331.35+525202.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000144,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,200.880667,52.86742,0,NULL,57278033687,894969276,13983894,18.1),(108586,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108586,37.89,0.13,378,46492,70,NULL,NULL,'2MASX J13233170+1118088',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000182,NULL,'16.0g',0.42,'BrClG',NULL,NULL,NULL,NULL,1,200.8819583,11.30225,0.01,NULL,58945567088,921024485,14391007,16),(108587,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108587,36.76,0.46,225,46493,70,NULL,NULL,'NGP9 F380-1086610',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'18.54',NULL,NULL,NULL,NULL,NULL,NULL,1,200.8827083,21.8825,0.073,NULL,58850195698,919534307,14367723,18.54),(108588,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108588,38.13,0.46,423,46494,70,NULL,NULL,'2MASX J13233193+6008497',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000173,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,200.883125,60.14714,0,NULL,57394498429,896789037,14012328,18.2),(108589,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108589,36.43,0.46,193,46495,70,NULL,NULL,'2MASX J13233222+6226477',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000179,NULL,'16.2g',0.39,'E0',NULL,NULL,NULL,NULL,1,200.883875,62.44653,0.041,NULL,57347659490,896057179,14000893,16.2),(108590,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108590,37.26,0.46,283,46496,70,NULL,NULL,'SDSS J132332.75+135713.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,200.8865,13.95375,0.028,NULL,59021284555,922207571,14409493,18.4),(108591,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108591,36.62,0.46,211,46497,70,NULL,NULL,'2MASX J13233438+0328468',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,200.8932083,3.47967,0,NULL,58935595215,920868675,14388573,17.2),(108592,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108592,37.88,0.33,377,46498,70,NULL,NULL,'SDSS J132334.70+110018.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000137,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,200.894625,11.00517,0.01,NULL,58945425645,921022275,14390973,18.6),(108593,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108593,37.72,0.46,350,46499,70,NULL,NULL,'SDSS J132335.36+135333.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,200.897375,13.89278,0.016,NULL,59021285759,922207589,14409493,18),(108594,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108594,37.83,0.46,368,46500,70,NULL,NULL,'2MASX J13233560+6547167',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00007,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,200.898333,65.78811,0.069,NULL,57876346721,904317917,14129967,17.6),(108595,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108595,36.63,0.46,212,46501,70,NULL,NULL,'2MASX J13233590+0122138',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'16.9g',0.27,'AGN',NULL,NULL,NULL,NULL,1,200.8995,1.37061,0.033,NULL,58052854857,907075857,14173060,16.9),(108596,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108596,35.12,NULL,106,46502,NULL,NULL,NULL,'ESO 508- G 064',NULL,'2000BSAO...50....5K',2000,1,1.32,NULL,'G',0.000033,NULL,'16',0.1,'Sc','Group member',NULL,NULL,NULL,1,200.90175,-26.86642,0.273,NULL,43298038856,676531857,10570810,16),(108597,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108597,36,0.56,158,46502,NULL,NULL,NULL,'ESO 508- G 064',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108598,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108598,36.01,0.56,159,46502,NULL,NULL,'Malmquist cor.','ESO 508- G 064',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108599,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108599,36.04,0.2,161,46502,74.4,NULL,NULL,'ESO 508- G 064',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108600,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108600,32.02,1.06,25.4,46503,NULL,NULL,'Malmquist cor.','CGCG 072-060',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000053,NULL,'15.3',0.7,NULL,'Group member',NULL,NULL,NULL,1,200.903916667,13.97356,0.028,NULL,59021314177,922208034,14409500,15.3),(108601,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108601,32.18,0.99,27.3,46503,NULL,NULL,NULL,'CGCG 072-060',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108602,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108602,37.69,0.46,346,46504,70,NULL,NULL,'2MASX J13233732+1340001',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000267,NULL,'18.53',0.2,NULL,NULL,NULL,NULL,NULL,1,200.905458333,13.66667,0.014,NULL,59021377912,922209029,14409516,18.53),(108603,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108603,38.18,0.46,432,46505,70,NULL,NULL,'2MASX J13233757-0112583',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000089,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,200.906583333,-1.21614,0.009,NULL,43087558297,673243098,10519423,17),(108604,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108604,37.61,0.33,332,46506,70,NULL,NULL,'2MASX J13233767+1045568',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,200.906875,10.76569,0,NULL,58945228236,921019191,14390924,17.6),(108605,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108605,36.25,0.51,178,46507,70,NULL,NULL,'2MASX J13233781-2636451',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,'E/S0','Group member',NULL,NULL,NULL,1,200.9075,-26.61258,0.237,NULL,43297949557,676530461,10570788,14.6),(108606,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108606,37.05,0.46,257,46508,70,NULL,NULL,'2MASX J13233884+6601562',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00009,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,200.911583,66.03225,0.069,NULL,57876248620,904316384,14129943,16.7),(108607,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108607,35.5,0.48,126,46509,70,NULL,NULL,'2MASX J13233877-2600381',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000143,NULL,'15.21',NULL,NULL,NULL,NULL,NULL,NULL,1,200.911625,-26.01067,0.209,NULL,43291469928,676429217,10569206,15.21),(108608,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108608,37.89,0.13,378,46510,70,NULL,NULL,'SDSS J132338.95+111708.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,200.9122917,11.28575,0.01,NULL,58945557973,921024343,14391005,18.4),(108609,'FP','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108609,37.36,0.46,296,46511,70,NULL,NULL,'2MASX J13233901+5922211',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000159,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,200.912375,59.37264,0.005,NULL,57389307242,896707925,14011061,17),(108610,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,'R',108610,34.25,0.49,70.8,46512,75,NULL,'IR','ESO 576- G 045',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000033,NULL,'15.33',0.4,'SB(r)a:',NULL,NULL,NULL,NULL,1,200.914583,-19.03858,0.241,NULL,43808087702,684501370,10695333,15.33),(108611,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:25','1',NULL,NULL,108611,34.62,0.41,83.9,46512,NULL,NULL,'Malmquist cor.','ESO 576- G 045',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108612,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108612,34.65,0.4,85.1,46512,NULL,NULL,NULL,'ESO 576- G 045',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108613,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108613,34.69,0.2,86.7,46512,74.4,NULL,NULL,'ESO 576- G 045',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108614,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108614,37.35,0.33,295,46513,70,NULL,NULL,'2MASX J13234038+5517151',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000214,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,200.918041667,55.28753,0,NULL,57418094739,897157730,14018089,16.4),(108615,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108615,37.39,0.27,301,46514,70,NULL,NULL,'2MASX J13234204+0111048',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000089,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,200.9252083,1.18486,0.01,NULL,58053099229,907079675,14173119,17.2),(108616,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108616,35.26,0.49,113,46515,75,NULL,'IR','UGC 08418',NULL,'2011yCatp016004901K',2011,1,1.38,NULL,'G',0.000033,NULL,'16.4g',0.15,'Sd',NULL,NULL,NULL,NULL,1,200.930667,30.56369,NULL,NULL,59160857646,924388400,14443568,16.4),(108617,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108617,35.4,NULL,120,46515,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08418',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108618,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108618,35.42,NULL,121,46515,NULL,NULL,'Dipole + Quadrupole','UGC 08418',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108619,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108619,35.43,NULL,122,46515,NULL,NULL,'Dipole','UGC 08418',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108620,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108620,35.45,NULL,123,46515,NULL,NULL,NULL,'UGC 08418',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108621,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108621,37.68,0.46,344,46516,70,NULL,NULL,'2MASX J13234452+5557521',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,200.935583,55.9645,0,NULL,57419379301,897177801,14018403,17.2),(108622,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108622,33.94,NULL,61.4,46517,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 508- G 065',NULL,'2010Ap&SS.325..163P',2010,1,1.51,NULL,'G',0.000033,NULL,'16.73',0.2,'Sdm',NULL,NULL,NULL,NULL,1,200.936625,-23.17992,0.257,NULL,43764002205,683812534,10684570,16.73),(108623,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108623,33.96,NULL,61.9,46517,NULL,NULL,'Dipole + Quadrupole','ESO 508- G 065',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108624,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108624,33.96,NULL,62,46517,NULL,NULL,'Dipole','ESO 508- G 065',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108625,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108625,34.03,NULL,64,46517,NULL,NULL,NULL,'ESO 508- G 065',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108626,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108626,37.89,0.13,378,46518,70,NULL,NULL,'2MASX J13234496+1118478',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.54',0.15,NULL,NULL,NULL,NULL,NULL,1,200.93725,11.31331,0.01,NULL,58945562799,921024418,14391006,18.54),(108627,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108627,34.4,0.27,75.8,46519,70,NULL,NULL,'NGC 5127',NULL,'2015arXiv151105856S',2015,1,1.54,NULL,'G',0.000073,NULL,'13.3g',1.08,'E pec','Possible field galaxy',NULL,'radio jet',NULL,1,200.937583333,31.56575,0.023,NULL,59160994161,924390533,14443602,13.3),(108628,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108628,33.93,0.45,61.2,46519,NULL,NULL,'K','NGC 5127',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108629,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108629,34.26,0.4,71.2,46519,NULL,NULL,'mean','NGC 5127',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108630,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108630,37.04,0.46,256,46520,70,NULL,NULL,'2MASX J13234876+1152002',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,200.953,11.86672,0.012,NULL,58944682915,921010670,14390791,16.8),(108631,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108631,38.18,0.33,433,46521,70,NULL,NULL,'2MASX J13234887+0102323',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000071,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,200.9535417,1.04228,0.01,NULL,58053012907,907078326,14173098,17.6),(108632,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108632,35.6,0.68,132,46522,NULL,NULL,'Malmquist cor.','2MASX J13234898-2644059',NULL,'2009ApJS..182..474S',2009,1,0.46,NULL,'G',0.000033,NULL,'15.49',0.38,'Sc','Group member',NULL,NULL,NULL,1,200.954167,-26.73497,0.237,NULL,43298048583,676532009,10570812,15.49),(108633,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108633,35.63,0.67,134,46522,NULL,NULL,NULL,'2MASX J13234898-2644059',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108634,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108634,35.67,0.2,136,46522,74.4,NULL,NULL,'2MASX J13234898-2644059',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108635,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108635,35.61,0.46,132,46523,70,NULL,NULL,'VII Zw 512',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,200.957041667,57.48972,0,NULL,57433623262,897400363,14021880,16.5),(108636,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108636,37.89,0.13,378,46524,70,NULL,NULL,'SDSS J132350.41+111637.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000153,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,200.960083333,11.27708,0.01,NULL,58945513631,921023650,14390994,18.4),(108637,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108637,36.82,0.64,231,46525,70,NULL,NULL,'LCRS B132111.9-122259',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000127,NULL,'15.26',NULL,NULL,NULL,NULL,NULL,NULL,1,200.96225,-12.64386,0.061,NULL,44004623547,687572242,10743316,15.26),(108638,'IRAS','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108638,34.68,0.8,86.4,46526,75,NULL,'HMCL, I','UGC 08417',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000027,NULL,'15.62',0.2,'Sbc',NULL,NULL,NULL,NULL,1,200.9682083,13.73428,0.016,NULL,59021454400,922210225,14409534,15.62),(108639,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108639,34.69,0.49,86.6,46526,75,NULL,'IR','UGC 08417',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108640,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108640,34.72,0.4,87.9,46526,75,NULL,'HMCL, I, raw','UGC 08417',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108641,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108641,34.81,0.2,91.6,46526,74.4,NULL,NULL,'UGC 08417',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108642,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108642,34.89,0.4,95,46526,75,NULL,'HMCL, I, inv','UGC 08417',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108643,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108643,35,0.4,99.8,46526,75,NULL,'HMCL, I, cor','UGC 08417',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108644,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108644,37.33,0.46,293,46527,70,NULL,NULL,'2MASX J13235273+1455442',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.30',0.16,NULL,NULL,NULL,NULL,NULL,1,200.969708333,14.92886,0,NULL,59021081449,922204397,14409443,18.3),(108645,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108645,37.25,0.46,281,46528,70,NULL,NULL,'2MASX J13235360+5825041',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000172,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,200.973625,58.41794,0,NULL,57389936105,896717751,14011214,16.7),(108646,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108646,34.52,0.51,80.1,46529,70,NULL,NULL,'2MASX J13235606-1906388',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00012,NULL,'15.44',NULL,NULL,NULL,NULL,NULL,NULL,1,200.983666667,-19.11083,0.241,NULL,43808187455,684502928,10695358,15.44),(108647,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108647,38.13,0.33,423,46530,70,NULL,NULL,'SDSS J132356.85-033429.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000074,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,200.986917,-3.57481,0.065,NULL,43837945520,684967898,10702623,18.5),(108648,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108648,34.77,0.49,89.8,46531,75,NULL,'IR','NGC 5131',NULL,'2011yCatp016004901K',2011,1,2.54,NULL,'G',0.00003,NULL,'14.0g',0.43,'Sa             AGN','Group member',NULL,NULL,NULL,1,200.98725,30.98806,NULL,NULL,59161669606,924401087,14443766,14),(108649,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108649,34.91,0.47,95.9,46531,NULL,NULL,'H','NGC 5131',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108650,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108650,34.93,0.45,96.8,46531,NULL,NULL,'K','NGC 5131',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108651,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108651,34.93,0.46,97,46531,NULL,NULL,'J','NGC 5131',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108652,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108652,35.04,0.4,102,46531,NULL,NULL,'mean','NGC 5131',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108653,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108653,37.82,0.46,366,46532,70,NULL,NULL,'2MASX J13235719+5921060',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000144,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,200.988417,59.35178,0.005,NULL,57389317196,896708081,14011063,17.8),(108654,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108654,36.45,0.5,195,46533,70,NULL,NULL,'2MASX J13235763-3138453',NULL,'2014MNRAS.445.2677S',2014,1,0.86,NULL,'G',0.000047,NULL,'14.3V',0.86,'E','Group member',NULL,NULL,NULL,1,200.9900417,-31.64628,0.189,NULL,46870680314,732354379,11443037,14.3),(108655,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108655,37.51,0.46,317,46534,70,NULL,NULL,'2MASX J13235851+1051272',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,200.993833333,10.85758,0,NULL,58945407634,921021994,14390968,17.4),(108656,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108656,38.24,0.46,444,46535,70,NULL,NULL,'2MASX J13235930+0604563',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000181,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,200.9970417,6.08225,0,NULL,58983328930,921614514,14400226,17.1),(108657,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108657,37.39,0.46,301,46536,70,NULL,NULL,'2MASX J13235934+3818332',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'17.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,200.99725,38.30922,0,NULL,59298111653,926532994,14477078,17.9),(108658,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108658,36.98,0.46,249,46537,70,NULL,NULL,'2MASX J13235981+4349308',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000195,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,200.999125,43.82508,0,NULL,59310369105,926724517,14480070,16.5),(108659,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108659,36.42,0.76,192,46538,70,NULL,NULL,'2MASX J13235995-3128213',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.000067,NULL,'15.4V',0.56,'E','Group member',NULL,NULL,NULL,1,200.999208333,-31.47264,0.189,NULL,46867870057,732310469,11442351,15.4),(108660,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108660,37.67,0.46,341,46539,70,NULL,NULL,'2MASX J13240012+0246503',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000174,NULL,'17.0g',0.25,'AGN',NULL,NULL,NULL,NULL,1,201.0004583,2.78061,0.007,NULL,58924438048,920694344,14385849,17),(108661,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108661,34.78,0.37,90.2,46540,NULL,NULL,'Malmquist cor.','NGC 5125',NULL,'2009ApJS..182..474S',2009,1,1.7,NULL,'G',0.000007,NULL,'13.24',1.3,'Sb','Possible field galaxy',NULL,NULL,NULL,1,201.002958333,9.71019,0,NULL,58951538838,921117794,14392465,13.24),(108662,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108662,34.9,0.35,95.3,46540,NULL,NULL,NULL,'NGC 5125',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108663,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108663,34.94,0.2,97.3,46540,74.4,NULL,NULL,'NGC 5125',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108664,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108664,35.08,0.4,104,46540,NULL,NULL,'mean','NGC 5125',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108665,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108665,35.51,0.47,127,46540,NULL,NULL,'H','NGC 5125',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108666,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108666,35.52,0.45,127,46540,NULL,NULL,'K','NGC 5125',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108667,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108667,35.55,0.46,129,46540,NULL,NULL,'J','NGC 5125',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108668,'D-Sigma','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108668,33,0.4,39.9,46541,75,NULL,'Edat, raw','NGC 5114',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000067,NULL,'13.45',1,'SAB0-','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,201.0072083,-32.34394,0.181,NULL,46870703644,732354744,11443042,13.45),(108669,'D-Sigma','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108669,33.23,0.4,44.3,46541,75,NULL,'Edat, cor','NGC 5114',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108670,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108670,33.48,0.45,49.8,46541,NULL,NULL,'K','NGC 5114',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108671,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108671,33.64,0.4,53.4,46541,NULL,NULL,'mean','NGC 5114',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108672,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108672,38.27,0.46,452,46542,70,NULL,NULL,'2MASX J13240251+4849276',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000144,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,201.010541667,48.82439,0,NULL,59277090035,926204531,14471945,17.3),(108673,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108673,38.13,0.33,423,46543,70,NULL,NULL,'LCRS B132127.7-031612',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000128,NULL,'16.2g',0.39,'BrClG',NULL,NULL,NULL,NULL,1,201.011917,-3.53069,0.065,NULL,43837932834,684967700,10702620,16.2),(108674,'Tully est','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108674,32.4,0.8,30.2,46544,75,NULL,NULL,'UGCA 352',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.000023,NULL,'15.07',1.1,'IB(s)m',NULL,NULL,NULL,NULL,1,201.014708333,-24.66386,0.281,NULL,43290125170,676408205,10568878,15.07),(108675,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108675,37.94,0.46,387,46545,70,NULL,NULL,'SDSS J132404.67+000144.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000071,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,201.0194583,0.02892,0.033,NULL,58051529367,907055146,14172736,18.2),(108676,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108676,38.13,0.46,422,46546,70,NULL,NULL,'2MASX J13240570+2303078',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,201.023625,23.05211,0.032,NULL,58792049166,918625768,14353527,17.8),(108677,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108677,36.97,0.71,247,46547,70,NULL,NULL,'2MASX J13240597-3051298',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'17.21',0.41,NULL,'Group member',NULL,NULL,NULL,1,201.024833,-30.85825,0.185,NULL,46868029176,732312955,11442389,17.21),(108678,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108678,37.77,0.33,359,46548,70,NULL,NULL,'2MASX J13240639+1054402',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000188,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,201.0267083,10.91111,0,NULL,58945276619,921019947,14390936,16.4),(108679,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108679,37.69,0.15,345,46549,70,NULL,NULL,'2MASX J13240638+5904000',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000198,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,201.0267083,59.06653,0,NULL,57389221795,896706590,14011040,17.1),(108680,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108680,37.08,0.46,261,46550,70,NULL,NULL,'2MASX J13240696+1625021',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.72',0.23,NULL,NULL,NULL,NULL,NULL,1,201.028833,16.41728,0,NULL,58831062335,919235348,14363052,18.72),(108681,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108681,37.7,0.46,347,46551,70,NULL,NULL,'SDSS J132408.55+664442.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000075,NULL,'18.5g',0.14,'NLAGN',NULL,NULL,NULL,NULL,1,201.035667,66.74522,0.053,NULL,57875564537,904305695,14129776,18.5),(108682,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108682,37.55,0.23,324,46552,70,NULL,NULL,'SDSS J132409.06+394605.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000166,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,201.03775,39.76831,0,NULL,59296912703,926514260,14476785,18.2),(108683,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108683,37.55,0.23,324,46553,70,NULL,NULL,'2MASX J13240970+3943132',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000189,NULL,'15.7g',0.49,NULL,NULL,NULL,NULL,NULL,1,201.040333,39.72028,0,NULL,59296913012,926514265,14476785,15.7),(108684,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108684,36.91,0.46,241,46554,70,NULL,NULL,'LCRS B132134.7-031508',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000067,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,201.0409583,-3.51283,0.053,NULL,43837935212,684967737,10702620,17.6),(108685,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108685,36.73,0.33,222,46555,70,NULL,NULL,'2MASX J13240992+3057046',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000107,NULL,'16.3g',0.27,'E4',NULL,NULL,NULL,NULL,1,201.041333,30.95131,NULL,NULL,59161596231,924399941,14443749,16.3),(108686,'IRAS','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108686,35.03,0.8,101,46556,75,NULL,'HMCL, I','CGCG 072-064',NULL,'1997ApJS..109..333W',1997,1,0.82,'ALFALFA source is a blend with the galaxy UGC 08421.','G',0.000015,NULL,'15.6g',0.4,'Sbc','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,201.04175,9.66172,0,NULL,58951805985,921121968,14392530,15.6),(108687,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108687,34.54,0.4,80.9,46556,75,NULL,'HMCL, I, raw','CGCG 072-064',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108688,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108688,34.59,0.2,82.8,46556,74.4,NULL,NULL,'CGCG 072-064',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108689,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108689,34.61,0.4,83.5,46556,75,NULL,'HMCL, I, inv','CGCG 072-064',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108690,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108690,34.86,0.4,93.7,46556,75,NULL,'HMCL, I, cor','CGCG 072-064',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108691,'D-Sigma','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108691,34.34,0.4,73.7,46557,75,NULL,'Edat, raw','NGC 5129',NULL,'1997ApJS..109..333W',1997,1,1.86,NULL,'G',0.000067,NULL,'13.2g',1.01,'E','Possible field galaxy',NULL,NULL,NULL,1,201.0417083,13.97653,0.016,NULL,59021310252,922207972,14409499,13.2),(108692,'D-Sigma','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108692,34.67,0.4,86,46557,75,NULL,'Edat, cor','NGC 5129',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108693,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108693,34.54,0.33,80.8,46557,70,NULL,NULL,'NGC 5129',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108694,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108694,34.64,0.45,84.7,46557,NULL,NULL,'K','NGC 5129',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108695,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108695,35.06,0.4,103,46557,NULL,NULL,'mean','NGC 5129',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108696,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 1992ag',NULL,108696,34.35,0.18,72.3,46558,74.2,NULL,'SALT 2','ESO 508- G 067',0.026,'2010ApJ...716..712A',2010,1,1,NULL,'G',0.00015,NULL,'15.21',0.2,'S?             HII',NULL,NULL,NULL,NULL,1,201.043833333,-23.87736,0.289,NULL,43763807559,683809493,10684523,15.21),(108697,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 1992ag',NULL,108697,34.9,0.08,95.5,46558,74.4,NULL,NULL,'ESO 508- G 067',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108698,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 1992ag',NULL,108698,34.97,0.1,96.2,46558,65,NULL,'SALT2','ESO 508- G 067',0.026,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108699,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 1992ag',NULL,108699,35.06,0.24,100,46558,65,NULL,NULL,'ESO 508- G 067',0.026,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108700,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 1992ag',NULL,108700,35.08,0.27,101,46558,72,NULL,NULL,'ESO 508- G 067',0.026,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108701,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 1992ag',NULL,108701,35.09,0.1,102,46558,72,NULL,NULL,'ESO 508- G 067',0.026,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108702,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 1992ag',NULL,108702,35.11,0.11,102,46558,65,NULL,'MLCS2k2','ESO 508- G 067',0.026,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108703,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 1992ag',NULL,108703,35.12,0.2,103,46558,65,NULL,'SALT2','ESO 508- G 067',0.026,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108704,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 1992ag',NULL,108704,35.14,0.16,104,46558,65,NULL,'MLCS2k2','ESO 508- G 067',0.026,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108705,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 1992ag',NULL,108705,35.17,0.2,105,46558,65,NULL,'MLCS31','ESO 508- G 067',0.026,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108706,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 1992ag',NULL,108706,35.25,0.15,106,46558,65,NULL,'MLCS2k2','ESO 508- G 067',0.026,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108707,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 1992ag',NULL,108707,35.21,0.18,107,46558,65,NULL,'MLCS17','ESO 508- G 067',0.026,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108708,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 1992ag',NULL,108708,35.23,0.17,108,46558,70,NULL,'SALT','ESO 508- G 067',0.026,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108709,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 1992ag',NULL,108709,35.19,0.14,109,46558,60,NULL,NULL,'ESO 508- G 067',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108710,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 1992ag',NULL,108710,35.21,0.06,110,46558,60,NULL,'M(I) = -19.19 mag','ESO 508- G 067',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108711,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 1992ag',NULL,108711,35.3,0.07,115,46558,60,NULL,'M(V) = -19.47 mag','ESO 508- G 067',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108712,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 1992ag',NULL,108712,35.35,0.18,115,46558,65,NULL,'SALT','ESO 508- G 067',0.026,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108713,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 1992ag',NULL,108713,35.35,0.09,115,46558,70,NULL,NULL,'ESO 508- G 067',0.026,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108714,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 1992ag',NULL,108714,35.37,0.23,116,46558,65,NULL,'MLCS','ESO 508- G 067',0.026,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108715,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 1992ag',NULL,108715,35.39,0.08,120,46558,60,NULL,'M(B) = -19.48 mag','ESO 508- G 067',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108716,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 1992ag',NULL,108716,35.53,0.2,124,46558,65,NULL,'Template','ESO 508- G 067',0.026,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108717,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 1992ag',NULL,108717,35.61,0.04,129,46558,65,NULL,'SALT','ESO 508- G 067',0.026,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108718,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 1992ag',NULL,108718,36.2,0.04,170,46558,70,NULL,'SALT 2','ESO 508- G 067',0.026,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108719,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108719,36.39,0.46,190,46559,70,NULL,NULL,'2MASX J13241134+0159473',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,201.047167,1.99656,0.016,NULL,58924191843,920690497,14385789,17.2),(108720,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108720,37.13,0.46,267,46560,70,NULL,NULL,'2MASX J13241134+3323236',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000165,NULL,'16.9g',0.27,'E0',NULL,NULL,NULL,NULL,1,201.047416667,33.38989,0,NULL,59162127373,924408240,14443878,16.9),(108721,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108721,38.18,0.46,433,46561,70,NULL,NULL,'SDSS J132412.68+003504.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000059,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,201.052833,0.58458,0.028,NULL,58052697272,907073394,14173021,18.4),(108722,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108722,35.23,0.49,111,46562,75,NULL,'IR','UGC 08425',NULL,'2011yCatp016004901K',2011,1,1.46,NULL,'G',0.000101,NULL,'15.5g',0.25,'Sbc','Pair member (points to parent)',NULL,NULL,NULL,1,201.0535,15.59403,0,NULL,59011851172,922060174,14407190,15.5),(108723,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108723,37.85,0.46,371,46563,70,NULL,NULL,'2MASX J13241277+1640112',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,201.053333,16.66986,0,NULL,58833048850,919266388,14363537,17.9),(108724,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108724,37.79,0.46,361,46564,70,NULL,NULL,'2MASX J13241336+1619452',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.48',0.21,NULL,NULL,NULL,NULL,NULL,1,201.055791667,16.32939,0,NULL,58831054136,919235220,14363050,18.48),(108725,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108725,34.52,NULL,80.1,46565,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08434',NULL,'2010Ap&SS.325..163P',2010,1,1.19,NULL,'G',NULL,NULL,'16.5',0.12,'Scd',NULL,NULL,NULL,NULL,1,201.058,70.53133,0,NULL,57906524645,904789447,14137335,16.5),(108726,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108726,34.54,NULL,80.8,46565,NULL,NULL,'Dipole + Quadrupole','UGC 08434',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108727,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108727,34.54,NULL,81,46565,NULL,NULL,'Dipole','UGC 08434',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108728,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108728,34.58,NULL,82.6,46565,NULL,NULL,NULL,'UGC 08434',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108729,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108729,37.56,0.46,325,46566,70,NULL,NULL,'2MASX J13241561+0848303',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,201.065041667,8.8085,0,NULL,58948897831,921076528,14391820,17.3),(108730,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108730,33.63,0.49,53.2,46567,75,NULL,'IR','UGC 08426',NULL,'2011yCatp016004901K',2011,1,1.47,NULL,'G',0.00003,NULL,'15.3g',0.32,'SBcd?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,201.065917,31.34514,0.04,NULL,59161015019,924390859,14443607,15.3),(108731,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108731,34.15,0.2,67.6,46567,74.4,NULL,NULL,'UGC 08426',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108732,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108732,34.3,0.52,72.4,46567,NULL,NULL,NULL,'UGC 08426',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108733,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108733,34.46,0.49,78,46567,NULL,NULL,'Malmquist cor.','UGC 08426',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108734,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108734,38.58,0.33,520,46568,70,NULL,NULL,'2MASX J13241623+0048298',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000123,NULL,'16.4g',0.31,'BrClG          AGN',NULL,NULL,NULL,NULL,1,201.0677083,0.80836,0.021,NULL,58052970639,907077666,14173088,16.4),(108735,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108735,37.28,0.55,285,46569,70,NULL,NULL,'2MASX J13241714-4638384',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.7I',0.3,NULL,NULL,NULL,NULL,NULL,1,201.0715,-46.64408,0.433,NULL,46958936707,733733386,11464584,14.7),(108736,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108736,37.9,0.33,381,46570,70,NULL,NULL,'2MASX J13241761+4723309',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000174,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,201.073417,47.39192,0,NULL,59290557901,926414967,14475233,17.7),(108737,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108737,37.9,0.33,381,46571,70,NULL,NULL,'2MASX J13241771+4723029',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000174,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,201.073875,47.38422,0,NULL,59290557805,926414965,14475233,16.8),(108738,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108738,36.39,0.46,190,46572,70,NULL,NULL,'2MASX J13241793+5833560',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,201.074833333,58.5655,0,NULL,57389917087,896717454,14011210,17.2),(108739,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108739,37.08,0.46,260,46573,70,NULL,NULL,'2MASX J13241814+2624378',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000167,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,201.0755417,26.41053,0.054,NULL,58665806929,916653233,14322706,16.6),(108740,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108740,37.3,0.33,289,46574,70,NULL,NULL,'2MASX J13241838+3155286',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000093,NULL,'16.6g',0.31,'E3',NULL,NULL,NULL,NULL,1,201.0765,31.92456,0.009,NULL,59164532329,924445817,14444465,16.6),(108741,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108741,34.83,0.5,92.5,46575,70,NULL,NULL,'2MASX J13241921-1707417',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'15.75',NULL,NULL,NULL,NULL,NULL,NULL,1,201.079917,-17.1285,0.201,NULL,43780132925,684064576,10688509,15.75),(108742,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108742,36.98,0.46,249,46576,70,NULL,NULL,'2MASX J13241983+3721287',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,201.082458333,37.358,0,NULL,59297490078,926523282,14476926,16.8),(108743,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108743,37.38,0.46,299,46577,70,NULL,NULL,'2MASX J13242000+1309492',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,201.083291667,13.16381,0,NULL,59019561693,922180651,14409072,16.9),(108744,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108744,37.98,0.46,394,46578,70,NULL,NULL,'2MASX J13242009+2503408',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,201.08375,25.06131,0,NULL,58665685729,916651339,14322677,16.8),(108745,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108745,35.84,0.59,148,46579,NULL,NULL,NULL,'2MASX J13242034-2702397',NULL,'2009ApJS..182..474S',2009,1,0.52,NULL,'G',0.000033,NULL,'16',0.32,'Sc','Group member',NULL,NULL,NULL,1,201.08475,-27.04439,0.273,NULL,43295894716,676498354,10570286,16),(108746,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108746,35.89,0.2,151,46579,74.4,NULL,NULL,'2MASX J13242034-2702397',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108747,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108747,35.93,0.57,153,46579,NULL,NULL,'Malmquist cor.','2MASX J13242034-2702397',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108748,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108748,36.95,0.46,246,46580,70,NULL,NULL,'2MASX J13242040+0854293',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.16',0.16,NULL,NULL,NULL,NULL,NULL,1,201.084875,8.90822,0,NULL,58948893156,921076455,14391819,18.16),(108749,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108749,37.69,0.15,345,46581,70,NULL,NULL,'2MASX J13242065+5902321',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000172,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,201.0857917,59.04219,0,NULL,57389682087,896713782,14011152,17.7),(108750,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108750,37.21,0.46,276,46582,70,NULL,NULL,'2MASX J13242137+2346139',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,201.089167,23.77056,0.016,NULL,58792280148,918629377,14353584,17.5),(108751,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108751,36.17,0.49,171,46583,70,NULL,NULL,'2MASX J13242275-3142239',NULL,'2014MNRAS.445.2677S',2014,1,0.94,NULL,'G',0.000077,NULL,'14.1V',0.66,'S0:','Group member',NULL,NULL,NULL,1,201.094958333,-31.70675,0.229,NULL,46870675244,732354300,11443035,14.1),(108752,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108752,37.77,0.33,359,46584,70,NULL,NULL,'2MASX J13242292+1053553',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,201.0955,10.89861,0,NULL,58953452449,921147694,14392932,17.5),(108753,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108753,37.69,0.15,345,46585,70,NULL,NULL,'2MASX J13242352+5853291',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00017,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,201.098167,58.89147,0,NULL,57390019387,896719052,14011235,17.8),(108754,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108754,35.01,NULL,100,46586,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08429',NULL,'2010Ap&SS.325..163P',2010,1,1.21,NULL,'G',0.000011,NULL,'16.2',0.11,'Sd',NULL,NULL,NULL,NULL,1,201.104417,17.09311,0,NULL,58833441445,919272522,14363633,16.2),(108755,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108755,35.02,NULL,101,46586,NULL,NULL,'Dipole + Quadrupole','UGC 08429',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108756,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108756,35.03,NULL,101,46586,NULL,NULL,'Dipole','UGC 08429',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108757,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108757,35.17,NULL,108,46586,NULL,NULL,NULL,'UGC 08429',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108758,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108758,35.21,0.49,110,46586,75,NULL,'IR','UGC 08429',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108759,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108759,35.49,0.2,125,46586,74.4,NULL,NULL,'UGC 08429',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108760,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108760,35.95,0.46,155,46587,70,NULL,NULL,'2MASX J13242516+5257363',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,201.104625,52.96022,0,NULL,57278139086,894970923,13983920,16.6),(108761,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108761,37.39,0.27,301,46588,70,NULL,NULL,'2MASX J13242529+0118448',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,201.1054583,1.31253,0.033,NULL,58052892400,907076443,14173069,17.5),(108762,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 2006cq',NULL,108762,35.99,0.17,150,46589,74.2,NULL,'SALT 2','IC 4239',0.048337,'2010ApJ...716..712A',2010,1,0.87,'RC3 gives v = 6991 +/- 25 km/sec.','G',0.000093,NULL,'15.0g',0.58,'S?',NULL,NULL,NULL,NULL,1,201.1059583,30.95928,NULL,NULL,59161597121,924399955,14443749,15),(108763,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 2006cq',NULL,108763,36.57,0.09,206,46589,74.4,NULL,NULL,'IC 4239',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108764,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 2006cq',NULL,108764,36.69,0.16,208,46589,73.8,NULL,'SALT 2 (SNANA)','IC 4239',0.0488,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108765,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 2006cq',NULL,108765,36.89,0.18,228,46589,65,NULL,'SALT2','IC 4239',0.048337,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108766,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 2006cq','R',108766,36.79,0.11,228,46589,NULL,NULL,'MLCS2k2, R(V) = 3.1','IC 4239',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108767,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 2006cq','R',108767,36.79,0.09,228,46589,NULL,NULL,'MLCS2k2, R(V) = 1.8','IC 4239',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108768,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 2006cq',NULL,108768,36.91,0.16,230,46589,65,NULL,'SALT','IC 4239',0.048337,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108769,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 2006cq',NULL,108769,37.01,0.16,241,46589,65,NULL,'MLCS17','IC 4239',0.048337,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108770,'SNIa','2016-12-15 15:15:13','2016-12-16 11:20:26','1','SN 2006cq',NULL,108770,37.07,0.18,247,46589,65,NULL,'MLCS31','IC 4239',0.048337,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108771,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108771,37.13,0.61,266,46590,70,NULL,NULL,'2MASX J13242596-3141178',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00007,NULL,'15.6V',0.26,'(R)SB0^+?','Group member',NULL,NULL,NULL,1,201.108125,-31.68833,0.229,NULL,46870674179,732354284,11443035,15.6),(108772,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108772,37.65,0.46,339,46591,70,NULL,NULL,'2MASX J13242614-0003519',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000068,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,201.109083,-0.06433,0.033,NULL,43084154829,673189919,10518592,17.3),(108773,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108773,36.37,NULL,188,46592,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1612',NULL,'2010Ap&SS.325..163P',2010,1,1.24,NULL,'G',0.0001,NULL,'16.4g',0.16,'Scd',NULL,NULL,NULL,NULL,1,201.110917,43.95619,0,NULL,59310581308,926727832,14480122,16.4),(108774,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108774,36.37,NULL,188,46592,NULL,NULL,NULL,'FGC 1612',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108775,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108775,36.39,NULL,190,46592,NULL,NULL,'Dipole + Quadrupole','FGC 1612',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108776,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108776,36.42,NULL,193,46592,NULL,NULL,'Dipole','FGC 1612',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108777,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108777,36.62,0.49,211,46592,75,NULL,'IR','FGC 1612',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108778,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108778,36.49,0.46,199,46593,70,NULL,NULL,'2MASX J13242664+2527378',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000157,NULL,'16.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,201.1110417,25.46058,0,NULL,58665608234,916650128,14322658,16.5),(108779,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108779,37.48,0.46,313,46594,70,NULL,NULL,'2MASX J13242678+2317579',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,201.1117917,23.29947,0.031,NULL,58791917609,918623712,14353495,17.2),(108780,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108780,33.83,0.46,58.3,46595,70,NULL,NULL,'NGC 5130',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'14.25',0.4,'E3: or S0-',NULL,NULL,NULL,NULL,1,201.113167,-10.21022,0.053,NULL,43868552877,685446138,10710095,14.25),(108781,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108781,37.56,0.46,325,46596,70,NULL,NULL,'SDSS J132427.94+014507.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000149,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,201.1164583,1.75203,0,NULL,58923963837,920686934,14385733,18.4),(108782,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108782,37.36,0.33,297,46597,70,NULL,NULL,'2MASX J13242807+3256236',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.1g',0.23,'E0',NULL,NULL,NULL,NULL,1,201.117125,32.93989,0.009,NULL,59162066854,924407294,14443863,17.1),(108783,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108783,38.83,0.46,583,46598,70,NULL,NULL,'SDSS J132428.94+512404.4',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000178,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,201.120625,51.40125,0,NULL,59206864245,925107253,14454800,18.2),(108784,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108784,36.74,0.46,223,46599,70,NULL,NULL,'2MASX J13243114+2532348',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000145,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,201.13,25.543,0,NULL,58664760565,916636883,14322451,16.9),(108785,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108785,37.45,0.46,309,46600,70,NULL,NULL,'2MASX J13243190+0501438',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000174,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,201.1327917,5.02881,0.044,NULL,58927223754,920737871,14386529,17.7),(108786,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108786,37.73,0.46,352,46601,70,NULL,NULL,'2MASX J13243187+4157358',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,201.1327917,41.96011,0,NULL,59308904289,926701629,14479712,17.3),(108787,'IRAS','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108787,32.79,0.8,36.2,46602,75,NULL,'HMCL, I','IC 4237',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000003,NULL,'13.23',1.3,'SB(r)c','in a pair',NULL,NULL,NULL,1,201.1365,-21.13683,0.281,NULL,43810819456,684544054,10696000,13.23),(108788,'IRAS','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108788,32.8,0.8,36.3,46602,75,NULL,'MAT, I','IC 4237',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108789,'Sosies','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108789,32.22,0.26,27.8,46602,NULL,NULL,NULL,'IC 4237',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108790,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108790,31.66,0.69,21.5,46602,100,NULL,'mid-IR','IC 4237',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108791,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108791,32.95,0.4,38.9,46602,75,NULL,'HMCL, I, raw','IC 4237',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108792,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108792,32.97,0.47,39.3,46602,NULL,NULL,'H','IC 4237',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108793,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108793,33,0.46,39.8,46602,NULL,NULL,'J','IC 4237',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108794,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108794,33.02,0.45,40.1,46602,NULL,NULL,'K','IC 4237',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108795,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108795,33.02,0.32,40.2,46602,85,NULL,'I, raw','IC 4237',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108796,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108796,33.02,0.38,40.2,46602,NULL,NULL,NULL,'IC 4237',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108797,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108797,33.05,0.4,40.7,46602,NULL,NULL,'mean','IC 4237',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108798,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108798,33.05,0.43,40.7,46602,75,NULL,'MAT, I, raw','IC 4237',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108799,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108799,33.07,0.32,41.2,46602,85,NULL,'I, inv','IC 4237',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108800,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108800,33.12,0.4,42.1,46602,75,NULL,'HMCL, I, inv','IC 4237',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108801,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108801,33.13,0.4,42.2,46602,75,NULL,'HMCL, I, cor','IC 4237',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108802,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108802,33.28,0.43,45.2,46602,75,NULL,'MAT, I, cor','IC 4237',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108803,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108803,33.3,0.43,45.6,46602,75,NULL,'MAT, I, inv','IC 4237',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108804,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108804,33.31,0.07,46,46602,NULL,NULL,NULL,'IC 4237',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108805,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108805,33.37,0.43,47.2,46602,75,NULL,'3.6 micron, color corrected','IC 4237',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108806,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108806,33.39,0.2,47.6,46602,74.4,NULL,NULL,'IC 4237',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108807,'Tully-Fisher','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,NULL,108807,33.42,0.43,48.3,46602,75,NULL,'3.6 micron, color + selection bias corrected','IC 4237',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108808,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108808,35.77,0.46,142,46603,70,NULL,NULL,'CGCG 218-008',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000083,NULL,'15.2g',0.58,'E0',NULL,NULL,NULL,NULL,1,201.136875,42.76425,0,NULL,59308796577,926699946,14479686,15.2),(108809,'FP','2016-12-15 15:15:13','2016-12-16 11:20:26','1',NULL,'R',108809,37.3,0.33,289,46604,70,NULL,NULL,'2MASX J13243313+3147496',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00011,NULL,'16.7g',0.36,'E1',NULL,NULL,NULL,NULL,1,201.138083,31.79719,0.016,NULL,59164550771,924446105,14444470,16.7),(108810,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108810,37.39,0.27,301,46605,70,NULL,NULL,'2MASX J13243329+0115558',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,201.138791667,1.26564,0.033,NULL,58052890807,907076418,14173069,17.2),(108811,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108811,38.25,0.46,447,46606,70,NULL,NULL,'2MASX J13243354+0145008',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,201.13975,1.75017,0.019,NULL,58923973962,920687093,14385735,17.8),(108812,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108812,35.85,0.46,148,46607,70,NULL,NULL,'2MASX J13243433+4345076',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000165,NULL,'15.8g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,201.142917,43.75208,0,NULL,59310258804,926722793,14480043,15.8),(108813,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108813,36.26,0.44,179,46608,NULL,NULL,'Malmquist cor.','2MASX J13243442-2709107',NULL,'2009ApJS..182..474S',2009,1,0.44,NULL,'G',0.000033,NULL,'16',0.2,'S','Group member',NULL,NULL,NULL,1,201.143416667,-27.15306,0.273,NULL,43295871072,676497985,10570281,16),(108814,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108814,36.34,0.42,186,46608,NULL,NULL,NULL,'2MASX J13243442-2709107',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108815,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108815,36.38,0.2,189,46608,74.4,NULL,NULL,'2MASX J13243442-2709107',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108816,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108816,35.4,0.59,120,46609,NULL,NULL,NULL,'2MASX J13243500-1947554',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.00015,NULL,'16.18',0.3,NULL,NULL,NULL,NULL,NULL,1,201.145916667,-19.79886,0.261,NULL,43821288225,684707628,10698556,16.18),(108817,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108817,35.39,0.59,120,46609,NULL,NULL,'Malmquist cor.','2MASX J13243500-1947554',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108818,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108818,35.44,0.2,122,46609,74.4,NULL,NULL,'2MASX J13243500-1947554',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108819,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108819,37.74,0.46,353,46610,70,NULL,NULL,'2MASX J13243568+1212092',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,201.1487917,12.20256,0,NULL,59019165161,922174455,14408975,17.3),(108820,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108820,28.14,0.1,4.25,46611,NULL,NULL,NULL,'AM 1321-304',NULL,'2012A&A...540A..49M',2012,1,0.85,NULL,'G',0.000002,NULL,'16.67',0.85,'dwarf Im','Group member',NULL,NULL,NULL,1,201.150958333,-30.97181,0.185,NULL,46868042958,732313171,11442393,16.67),(108821,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108821,28.31,NULL,4.6,46611,NULL,NULL,NULL,'AM 1321-304',NULL,'2002A&A...385...21K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108822,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108822,28.36,0.06,4.7,46611,NULL,NULL,'I','AM 1321-304',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108823,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108823,28.39,0.1,4.76,46611,74.4,NULL,NULL,'AM 1321-304',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108824,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108824,37.26,0.21,283,46612,70,NULL,NULL,'2MASX J13243847+0824543',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.0002,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,201.160417,8.41503,0,NULL,58981504439,921586006,14399781,17.1),(108825,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108825,38.17,0.33,431,46613,70,NULL,NULL,'2MASX J13243979+0022158',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000104,NULL,'17.2g',0.25,'AGN',NULL,NULL,NULL,NULL,1,201.1657917,0.37114,0.017,NULL,58049840833,907028763,14172324,17.2),(108826,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108826,37.99,0.46,396,46614,70,NULL,NULL,'SDSS J132440.19+521800.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000148,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,201.167458333,52.30011,0,NULL,57277517845,894961216,13983769,18.3),(108827,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108827,36.57,0.46,206,46615,70,NULL,NULL,'2MASX J13244068+5754100',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,201.169417,57.90272,0,NULL,57433042513,897391289,14021738,16.7),(108828,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108828,37.69,0.46,345,46616,70,NULL,NULL,'2MASX J13244068-0014049',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000078,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,201.169583,-0.23475,0.033,NULL,43084185391,673190396,10518599,16.8),(108829,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108829,37.32,0.23,291,46617,70,NULL,NULL,'2MASX J13244093+4027438',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,201.1705,40.46214,0,NULL,59296137294,926502145,14476596,17.5),(108830,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108830,34.69,0.74,86.7,46618,70,NULL,NULL,'2MASX J13244150-2012164',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00008,NULL,'13.3I',0.6,NULL,NULL,NULL,NULL,NULL,1,201.172875,-20.20456,0.277,NULL,43822014311,684718973,10698733,13.3),(108831,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108831,35.11,0.58,105,46619,NULL,NULL,NULL,'ESO 508- G 069',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.10',0.2,'S              HII','Group member',NULL,NULL,NULL,1,201.174875,-27.51631,0.245,NULL,43296710163,676511096,10570485,16.1),(108832,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108832,35.13,0.57,106,46619,NULL,NULL,'Malmquist cor.','ESO 508- G 069',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108833,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108833,35.15,0.2,107,46619,74.4,NULL,NULL,'ESO 508- G 069',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108834,'IRAS','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108834,32.06,0.8,25.8,46620,75,NULL,'MAT, I','UGCA 353',NULL,'1997ApJS..109..333W',1997,1,2.9,NULL,'G',0.000013,NULL,'13.51',1.8,'SB(rs)cd+comp?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,201.174167,-19.69594,0.261,NULL,43821266994,684707296,10698551,13.51),(108835,'Tully est','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108835,32.37,0.8,29.8,46620,75,NULL,NULL,'UGCA 353',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108836,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108836,30.77,0.43,14.3,46620,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 353',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108837,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108837,30.78,0.2,14.3,46620,74.4,NULL,NULL,'UGCA 353',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108838,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108838,30.81,0.43,14.5,46620,75,NULL,'3.6 micron, color corrected','UGCA 353',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108839,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108839,30.91,0.32,15.2,46620,85,NULL,'I, inv','UGCA 353',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108840,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108840,30.92,0.32,15.3,46620,85,NULL,'I, raw','UGCA 353',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108841,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108841,31.28,0.4,18,46620,NULL,NULL,NULL,'UGCA 353',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108842,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108842,31.28,0.4,18,46620,NULL,NULL,NULL,'UGCA 353',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108843,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108843,31.44,0.43,19.5,46620,75,NULL,'MAT, I, raw','UGCA 353',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108844,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108844,31.47,0.43,19.7,46620,75,NULL,'MAT, I, inv','UGCA 353',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108845,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108845,31.72,0.43,22.1,46620,75,NULL,'MAT, I, cor','UGCA 353',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108846,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108846,32.17,0.4,27.2,46620,NULL,NULL,'mean','UGCA 353',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108847,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108847,32.74,0.47,35.4,46620,NULL,NULL,'H','UGCA 353',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108848,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108848,36.87,0.46,236,46621,70,NULL,NULL,'2MASX J13244216+2309119',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'17.09',0.3,NULL,NULL,NULL,NULL,NULL,1,201.175667,23.15325,0.032,NULL,58792074707,918626167,14353533,17.09),(108849,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108849,37.51,0.27,318,46622,70,NULL,NULL,'2MASX J13244304+2423097',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,201.1794583,24.38608,NULL,NULL,58662037062,916594329,14321786,17),(108850,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108850,37.4,0.27,301,46623,70,NULL,NULL,'2MASX J13244439-0100020',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000088,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,201.1847917,-1.00058,0.021,NULL,43084565555,673196336,10518692,16.8),(108851,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108851,37.26,0.33,283,46624,70,NULL,NULL,'SDSS J132444.92+242901.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.1g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,201.1872083,24.48381,NULL,NULL,58662028283,916594191,14321784,18.1),(108852,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108852,38.17,0.33,431,46625,70,NULL,NULL,'SDSS J132445.38+002804.3',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000073,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,201.189083,0.46786,0.028,NULL,58049881220,907029394,14172334,18),(108853,'Tully est','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108853,31.72,0.8,22.1,46626,75,NULL,'B','NGC 5121',NULL,'1988NBGC.C....0000T',1988,1,1.9,'Confused HIPASS source','G',0.000023,NULL,'11.51',1.5,'SA(rs)a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,201.1900417,-37.68219,0.221,NULL,46935997539,733374961,11458983,11.51),(108854,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108854,32.01,0.4,25.3,46626,NULL,NULL,'mean','NGC 5121',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108855,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108855,32.06,0.45,25.9,46626,NULL,NULL,'K','NGC 5121',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108856,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108856,32.07,0.47,26,46626,NULL,NULL,'H','NGC 5121',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108857,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108857,32.13,0.46,26.6,46626,NULL,NULL,'J','NGC 5121',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108858,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108858,38.71,0.46,551,46627,70,NULL,NULL,'SDSS J132445.70-010805.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00008,NULL,'18.8g',0.09,NULL,NULL,NULL,NULL,NULL,1,201.1904583,-1.13497,0.061,NULL,43084462613,673194728,10518667,18.8),(108859,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108859,38.08,0.23,413,46628,70,NULL,NULL,'2MASX J13244606-0125410',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000075,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,201.1920417,-1.42797,0.037,NULL,43822351185,684724237,10698816,17.7),(108860,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108860,35.59,0.46,131,46629,70,NULL,NULL,'IC 4241',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.0001,NULL,'15.1g',0.58,'E?',NULL,NULL,NULL,NULL,1,201.1939583,26.73842,0.068,NULL,58665909879,916654841,14322731,15.1),(108861,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108861,36.52,0.4,202,46630,NULL,NULL,'Malmquist cor.','ESO 508- G 070',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.00',0.2,'Sbc','Group member',NULL,NULL,NULL,1,201.19625,-26.39214,0.229,NULL,43297941226,676530331,10570786,15),(108862,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108862,36.91,0.34,241,46630,NULL,NULL,NULL,'ESO 508- G 070',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108863,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108863,36.95,0.2,245,46630,74.4,NULL,NULL,'ESO 508- G 070',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108864,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108864,36.73,0.33,222,46631,70,NULL,NULL,'2MASX J13244970+3101261',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00018,NULL,'16.9',0.19,'E0',NULL,NULL,NULL,NULL,1,201.207083,31.02392,0.029,NULL,59161603826,924400059,14443750,16.9),(108865,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108865,37.26,0.33,283,46632,70,NULL,NULL,'2MASX J13244982+2425207',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,201.20775,24.42233,NULL,NULL,58661816268,916590879,14321732,17.4),(108866,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108866,37.47,0.46,312,46633,70,NULL,NULL,'2MASX J13245018+6622096',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000077,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,201.209125,66.36947,0.045,NULL,57875772842,904308950,14129827,17.5),(108867,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108867,37.44,0.46,308,46634,70,NULL,NULL,'2MASX J13245036+0104559',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000074,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,201.2099583,1.08222,0.029,NULL,58049447496,907022617,14172228,17.4),(108868,'D-Sigma','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108868,33.06,0.4,40.9,46635,75,NULL,'Edat, raw','NGC 5124',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.00005,NULL,'13.06',0.7,'E6:      poss. LINER','Pair member (points to parent)',NULL,NULL,NULL,1,201.210125,-30.30753,0.201,NULL,46867369694,732302651,11442228,13.06),(108869,'D-Sigma','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108869,33.4,0.4,48,46635,75,NULL,'Edat, cor','NGC 5124',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108870,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108870,33.59,0.47,52.2,46635,70,NULL,NULL,'NGC 5124',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108871,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108871,33.61,0.45,52.8,46635,NULL,NULL,'K','NGC 5124',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108872,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108872,33.95,0.4,61.7,46635,NULL,NULL,'mean','NGC 5124',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108873,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108873,37.11,0.46,264,46636,70,NULL,NULL,'2MASX J13245054+4953388',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00018,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,201.21075,49.89414,0,NULL,59277984235,926218503,14472164,17.2),(108874,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108874,34.54,0.33,80.8,46637,70,NULL,NULL,'NGC 5136',NULL,'2015arXiv151105856S',2015,1,1.05,NULL,'G',0.0001,NULL,'14.3g',0.78,NULL,NULL,NULL,NULL,NULL,1,201.2142083,13.73786,0.018,NULL,59021226686,922206666,14409479,14.3),(108875,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108875,34.34,0.33,74,46638,70,NULL,NULL,'NGC 5141',NULL,'2015arXiv151105856S',2015,1,1.3,NULL,'G',0.000067,NULL,'13.8',1,'S0','Pair member (points to parent)',NULL,'radio jet',NULL,1,201.214333333,36.37853,0,NULL,59166694019,924479594,14444993,13.8),(108876,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108876,37.26,0.21,283,46639,70,NULL,NULL,'SDSS J132451.68+081814.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.8g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,201.215375,8.30392,0,NULL,58981546266,921586660,14399791,17.8),(108877,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108877,34.73,0.7,88.5,46640,NULL,NULL,NULL,'2MASX J13245119-2624516',NULL,'2009ApJS..182..474S',2009,1,0.52,NULL,'G',0.000033,NULL,'16',0.32,'SBbc','Group member',NULL,NULL,NULL,1,201.215917,-26.416,0.229,NULL,43298657124,676541517,10570961,16),(108878,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108878,34.77,0.69,90.1,46640,NULL,NULL,'Malmquist cor.','2MASX J13245119-2624516',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108879,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108879,34.78,0.2,90.4,46640,74.4,NULL,NULL,'2MASX J13245119-2624516',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108880,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108880,38.04,0.46,405,46641,70,NULL,NULL,'2MASX J13245315+1321502',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000186,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,201.221541667,13.36403,0.008,NULL,59019601458,922181272,14409082,16.7),(108881,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108881,37.61,0.46,333,46642,70,NULL,NULL,'2MASXi J1324562+540208',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000158,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,201.234333,54.03578,0,NULL,57279922016,894998781,13984355,17),(108882,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108882,37.51,0.46,318,46643,70,NULL,NULL,'2MASX J13245539+1203120',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000156,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,201.2345,12.05661,0.005,NULL,59019115108,922173673,14408963,18.6),(108883,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108883,35.82,0.49,146,46644,NULL,NULL,'Malmquist cor.','2MASX J13245678-2639316',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000027,NULL,'14.33',0.36,'Scd','Group member',NULL,NULL,NULL,1,201.236583,-26.65881,0.229,NULL,43297882919,676529420,10570772,14.33),(108884,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108884,36.01,0.45,159,46644,NULL,NULL,NULL,'2MASX J13245678-2639316',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108885,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108885,36.05,0.2,162,46644,74.4,NULL,NULL,'2MASX J13245678-2639316',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108886,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108886,37.36,0.33,297,46645,70,NULL,NULL,'2MASX J13245720+3254401',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000176,NULL,'17.1g',0.22,'E3',NULL,NULL,NULL,NULL,1,201.23825,32.91108,0,NULL,59162540705,924414698,14443979,17.1),(108887,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108887,35.85,0.45,148,46646,NULL,NULL,'Malmquist cor.','2MASX J13245768-2732346',NULL,'2009ApJS..182..474S',2009,1,0.7,'6dF DR2 has z = 0.036368.','G',0.000033,NULL,'16',0.34,'Sc','Group member',NULL,NULL,NULL,1,201.240375,-27.54294,0.245,NULL,43296531178,676508299,10570442,16),(108888,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108888,35.95,0.43,155,46646,NULL,NULL,NULL,'2MASX J13245768-2732346',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108889,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108889,35.99,0.2,158,46646,74.4,NULL,NULL,'2MASX J13245768-2732346',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108890,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108890,38.58,0.33,520,46647,70,NULL,NULL,'SDSS J132459.63+004838.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000104,NULL,'18.6g',0.12,'NLAGN',NULL,NULL,NULL,NULL,1,201.2484583,0.81067,0.061,NULL,58049555017,907024297,14172254,18.6),(108891,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108891,37.52,0.46,319,46648,70,NULL,NULL,'2MASX J13250007+3533071',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000176,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,201.2505,35.55194,0,NULL,59168048159,924500752,14445324,18.3),(108892,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108892,38.31,0.46,459,46649,70,NULL,NULL,'2MASX J13250032-0106030',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000093,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,201.2515,-1.10086,0.061,NULL,43084457937,673194655,10518666,17.7),(108893,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108893,37.61,0.46,333,46650,70,NULL,NULL,'2MASX J13250039-0123530',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000206,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,201.2515417,-1.39797,0.037,NULL,43822352932,684724264,10698816,16.2),(108894,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108894,36.81,0.66,231,46651,70,NULL,NULL,'2MASX J13250038-2714086',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16',NULL,'S0','Group member',NULL,NULL,NULL,1,201.2515417,-27.23572,0.221,NULL,43296619092,676509673,10570463,16),(108895,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108895,34.57,0.49,81.9,46652,75,NULL,'IR','ESO 508- G 071',NULL,'2011yCatp016004901K',2011,1,1.5,'1991MNRAS.248..528A gives V = 11100 +- 300 km/sec.','G',0.000033,NULL,'16.41',0.2,'Sc:',NULL,NULL,NULL,NULL,1,201.2542083,-24.00969,0.273,NULL,43763849686,683810151,10684533,16.41),(108896,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108896,34.83,0.2,92.5,46652,74.4,NULL,NULL,'ESO 508- G 071',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108897,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108897,35.01,0.5,100,46652,NULL,NULL,'Malmquist cor.','ESO 508- G 071',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108898,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108898,35.04,0.49,102,46652,NULL,NULL,NULL,'ESO 508- G 071',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108899,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108899,34.34,0.33,74,46653,70,NULL,NULL,'NGC 5142',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.00008,NULL,'14.2',0.7,'S0','Pair member (points to parent)',NULL,NULL,NULL,1,201.254625,36.3995,0,NULL,59166566245,924477597,14444962,14.2),(108900,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108900,38.08,0.46,413,46654,70,NULL,NULL,'2MASX J13250165+0837470',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,201.257041667,8.62975,0,NULL,58949080730,921079386,14391865,17.6),(108901,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108901,37.4,0.27,301,46655,70,NULL,NULL,'2MASX J13250172-0101240',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00015,NULL,'17.26',0.34,'BrClG',NULL,NULL,NULL,NULL,1,201.257333,-1.02331,0.021,NULL,43084644176,673197565,10518711,17.26),(108902,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108902,38.5,0.46,501,46656,70,NULL,NULL,'SDSS J132501.75+623122.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000143,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,201.257333,62.52297,0.069,NULL,57347625379,896056646,14000885,18.6),(108903,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108903,36.41,0.46,192,46657,70,NULL,NULL,'2MASX J13250174+5853246',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000159,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,201.2574583,58.89011,0,NULL,57390015210,896718987,14011234,16.6),(108904,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108904,37.78,0.33,359,46658,70,NULL,NULL,'2MASX J13250342+3117380',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00012,NULL,'15.8g',0.4,'E3',NULL,NULL,NULL,NULL,1,201.264458333,31.29403,0.04,NULL,59161122782,924392543,14443633,15.8),(108905,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108905,37.4,0.27,301,46659,70,NULL,NULL,'2MASX J13250479-0101440',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000064,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,201.269917,-1.02889,0.021,NULL,43084643834,673197559,10518711,17.4),(108906,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108906,36.61,0.46,209,46660,70,NULL,NULL,'2MASX J13250495+3242350',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,201.270833,32.70989,0,NULL,59162554435,924414913,14443983,17.2),(108907,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108907,35.75,0.5,142,46661,70,NULL,NULL,'2MASX J13250587-1533346',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.83',0.5,NULL,NULL,NULL,NULL,NULL,1,201.274417,-15.55975,0.097,NULL,43999457220,687491519,10742054,15.83),(108908,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108908,37.34,0.46,294,46662,70,NULL,NULL,'2MASX J13250595+0618440',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000182,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,201.274875,6.31217,0,NULL,58982868134,921607314,14400114,16.4),(108909,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108909,36.46,0.46,196,46663,70,NULL,NULL,'2MASX J13250742+2257220',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,201.280958333,22.95611,0.031,NULL,58791853561,918622711,14353479,17.4),(108910,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108910,35.41,0.49,121,46664,75,NULL,'IR','2MFGC 10759',NULL,'2011yCatp016004901K',2011,1,0.74,NULL,'G',0.000033,NULL,'16',0.2,'Sc','Group member',NULL,NULL,NULL,1,201.28375,-27.81939,0.245,NULL,43296087628,676501369,10570333,16),(108911,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108911,35.82,0.43,146,46664,NULL,NULL,'Malmquist cor.','2MFGC 10759',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108912,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108912,35.95,0.41,155,46664,NULL,NULL,NULL,'2MFGC 10759',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108913,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108913,36,0.2,158,46664,74.4,NULL,NULL,'2MFGC 10759',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108914,'IRAS','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108914,34.26,0.8,71.1,46665,75,NULL,'MAT, I','ESO 576- G 051',NULL,'1997ApJS..109..333W',1997,1,1.3,'Diameter includes companions or long extensions.','G',0.000033,NULL,'13.65',0.9,'SB(s)bc pec    HII',NULL,NULL,NULL,NULL,1,201.2874583,-19.76814,0.261,NULL,43821191346,684706114,10698533,13.65),(108915,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108915,33.09,0.32,41.5,46665,85,NULL,'I, raw','ESO 576- G 051',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108916,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108916,33.13,0.32,42.3,46665,85,NULL,'I, inv','ESO 576- G 051',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108917,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108917,33.24,0.43,44.4,46665,75,NULL,'MAT, I, raw','ESO 576- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108918,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108918,33.38,0.2,47.4,46665,74.4,NULL,NULL,'ESO 576- G 051',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108919,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108919,33.43,0.43,48.4,46665,75,NULL,'MAT, I, inv','ESO 576- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108920,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108920,33.43,NULL,48.5,46665,NULL,NULL,'I','ESO 576- G 051',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108921,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108921,33.47,0.69,49.5,46665,100,NULL,'mid-IR','ESO 576- G 051',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108922,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108922,33.5,NULL,50.1,46665,NULL,NULL,'B','ESO 576- G 051',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108923,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108923,33.5,0.43,50.2,46665,75,NULL,'MAT, I, cor','ESO 576- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108924,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108924,33.58,0.54,52,46665,NULL,NULL,NULL,'ESO 576- G 051',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108925,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108925,33.72,0.51,55.5,46665,NULL,NULL,'Malmquist cor.','ESO 576- G 051',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108926,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108926,33.97,0.47,62.3,46665,NULL,NULL,'H','ESO 576- G 051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108927,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108927,34.02,0.46,63.7,46665,NULL,NULL,'J','ESO 576- G 051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108928,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108928,34.06,0.45,64.8,46665,NULL,NULL,'K','ESO 576- G 051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108929,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108929,34.53,0.4,80.7,46665,NULL,NULL,'mean','ESO 576- G 051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108930,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108930,36.59,0.46,208,46666,70,NULL,NULL,'2MASX J13250899+1100070',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,201.287667,11.00206,0,NULL,58953487213,921148237,14392941,17.3),(108931,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108931,37.12,0.46,265,46667,70,NULL,NULL,'2MASX J13251081+1021360',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,201.295083,10.35986,0,NULL,58954414117,921162720,14393167,17.7),(108932,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108932,37.26,0.21,283,46668,70,NULL,NULL,'2MASX J13251183+0821500',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.00011,NULL,'15.2g',0.58,NULL,NULL,NULL,NULL,NULL,1,201.2992917,8.36381,0,NULL,58981487615,921585743,14399777,15.2),(108933,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108933,37.2,0.46,276,46669,70,NULL,NULL,'2MASX J13251226+1337022',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,201.301167,13.61739,0.018,NULL,59021258877,922207169,14409487,17.2),(108934,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108934,34.15,0.51,67.6,46670,70,NULL,NULL,'ESO 382- G 058',NULL,'2014MNRAS.445.2677S',2014,1,2.3,NULL,'G',0.00002,NULL,'14.35',0.4,'SB(r)b',NULL,NULL,NULL,NULL,1,201.3022083,-33.65553,0.185,NULL,46872270975,732379233,11443425,14.35),(108935,'IRAS','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108935,35.06,0.8,103,46670,75,NULL,'MAT, I','ESO 382- G 058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108936,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108936,34.45,0.43,77.5,46670,75,NULL,'MAT, I, raw','ESO 382- G 058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108937,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108937,34.63,0.47,84.2,46670,NULL,NULL,'H','ESO 382- G 058',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108938,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108938,34.63,0.49,84.4,46670,75,NULL,'IR','ESO 382- G 058',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108939,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108939,34.69,0.46,86.7,46670,NULL,NULL,'J','ESO 382- G 058',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108940,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108940,34.72,0.43,87.7,46670,75,NULL,'MAT, I, cor','ESO 382- G 058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108941,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108941,34.77,0.45,89.8,46670,NULL,NULL,'K','ESO 382- G 058',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108942,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108942,34.77,0.32,90,46670,85,NULL,'I, raw','ESO 382- G 058',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108943,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108943,34.79,0.57,90.9,46670,NULL,NULL,'Malmquist cor.','ESO 382- G 058',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108944,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108944,34.8,0.43,91.3,46670,75,NULL,'MAT, I, inv','ESO 382- G 058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108945,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108945,34.86,0.32,93.8,46670,85,NULL,'I, inv','ESO 382- G 058',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108946,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108946,35.04,0.51,102,46670,NULL,NULL,NULL,'ESO 382- G 058',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108947,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108947,35.08,0.2,104,46670,74.4,NULL,NULL,'ESO 382- G 058',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108948,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108948,35.18,0.4,109,46670,NULL,NULL,'mean','ESO 382- G 058',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108949,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108949,37.55,0.23,324,46671,70,NULL,NULL,'2MASX J13251331+3955536',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000228,NULL,'16.0g',0.46,NULL,NULL,NULL,NULL,NULL,1,201.305833,39.93139,0,NULL,59296835443,926513053,14476766,16),(108950,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108950,37.55,0.23,324,46672,70,NULL,NULL,'SDSS J132513.82+395204.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,201.307625,39.86783,0,NULL,59296828025,926512937,14476764,18),(108951,'Sosies','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108951,33.7,1.01,55,46673,NULL,NULL,NULL,'NGC 5145',NULL,'2002A&A...393...57T',2002,1,2,NULL,'G',0.000037,NULL,'13.34',1.8,'S?;HII         Sbrst','Group member',NULL,NULL,NULL,1,201.308,43.26728,0.012,NULL,59310125476,926720710,14480011,13.34),(108952,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108952,31.88,0.4,23.7,46673,75,NULL,'B','NGC 5145',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108953,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108953,37.81,0.46,365,46674,70,NULL,NULL,'2MASX J13251394+4109086',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,201.308167,41.15239,0,NULL,59322383887,926912248,14483003,17.9),(108954,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108954,36.46,0.46,196,46675,70,NULL,NULL,'2MASX J13251418+1334022',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000113,NULL,'16.0g',0.42,NULL,NULL,NULL,NULL,NULL,1,201.309125,13.56731,0.018,NULL,59021252331,922207067,14409485,16),(108955,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108955,37.51,0.27,318,46676,70,NULL,NULL,'2MASX J13251500+2422527',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000173,NULL,'16.0g',0.37,NULL,NULL,NULL,NULL,NULL,1,201.3124583,24.38142,NULL,NULL,58661824359,916591005,14321734,16),(108956,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108956,37.79,0.46,362,46677,70,NULL,NULL,'2MASX J13251532+5706167',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,201.3137083,57.10475,0.013,NULL,57416231265,897128613,14017634,18.1),(108957,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108957,37.32,0.23,291,46678,70,NULL,NULL,'2MASX J13251599+4031136',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000175,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,201.316583333,40.52039,0,NULL,59313981391,926780959,14480952,16.8),(108958,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108958,37.69,0.15,345,46679,70,NULL,NULL,'2MASX J13251656+5904467',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000186,NULL,'16.1g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,201.31875,59.07956,0.009,NULL,57389686632,896713853,14011153,16.1),(108959,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108959,37.38,0.46,299,46680,70,NULL,NULL,'2MASX J13251797+0000415',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000078,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,201.324833333,0.0115,0.033,NULL,58049718032,907026844,14172294,17.3),(108960,'IRAS','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108960,31.73,0.8,22.2,46681,75,NULL,'MAT, I','NGC 5134',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.000007,NULL,'12.83',1.7,'(R)SAB(r)a     HII','in a pair',NULL,NULL,NULL,1,201.3272917,-21.13417,0.281,NULL,43810856304,684544629,10696009,12.83),(108961,'Tully est','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108961,32.09,0.8,26.1,46681,75,NULL,'B','NGC 5134',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108962,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108962,28.66,0.32,5.39,46681,85,NULL,'I, inv','NGC 5134',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108963,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108963,28.7,0.32,5.47,46681,85,NULL,'I, raw','NGC 5134',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108964,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108964,28.8,0.4,5.75,46681,NULL,NULL,NULL,'NGC 5134',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108965,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108965,28.99,1.17,6.27,46681,NULL,NULL,'Malmquist cor.','NGC 5134',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108966,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108966,29.02,1.16,6.36,46681,NULL,NULL,NULL,'NGC 5134',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108967,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108967,29.06,0.2,6.49,46681,74.4,NULL,NULL,'NGC 5134',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108968,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108968,29.14,0.43,6.73,46681,75,NULL,'MAT, I, inv','NGC 5134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108969,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108969,29.2,0.47,6.91,46681,NULL,NULL,'H','NGC 5134',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108970,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108970,29.2,0.43,6.92,46681,75,NULL,'MAT, I, raw','NGC 5134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108971,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108971,29.29,0.45,7.2,46681,NULL,NULL,'K','NGC 5134',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108972,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108972,29.3,0.46,7.23,46681,NULL,NULL,'J','NGC 5134',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108973,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108973,29.52,0.43,8,46681,75,NULL,'MAT, I, cor','NGC 5134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108974,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108974,29.89,0.4,9.5,46681,73,NULL,'opt','NGC 5134',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108975,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108975,31.61,0.4,21,46681,NULL,NULL,'mean','NGC 5134',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108976,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108976,37.78,0.33,359,46682,70,NULL,NULL,'SDSS J132519.43+311614.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,201.331,31.27061,0.04,NULL,59161174849,924393357,14443646,18.1),(108977,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108977,38.27,0.46,451,46683,70,NULL,NULL,'SDSS J132519.58+134128.7',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,201.331625,13.69131,0.018,NULL,59021254701,922207104,14409486,17.6),(108978,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108978,36.24,0.51,177,46684,70,NULL,NULL,'2MASX J13251994-0924401',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.7I',0.4,NULL,NULL,NULL,NULL,NULL,1,201.333083,-9.41119,0.061,NULL,43869221883,685456591,10710259,13.7),(108979,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108979,38.52,0.46,506,46685,70,NULL,NULL,'SDSS J132520.01+022012.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000163,NULL,'18.6g',0.09,NULL,NULL,NULL,NULL,NULL,1,201.333375,2.33669,0.011,NULL,58924805760,920700090,14385938,18.6),(108980,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108980,38.08,0.23,413,46686,70,NULL,NULL,'2MASX J13252052-0108243',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000077,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,201.335417,-1.14019,0.061,NULL,43084437081,673194329,10518661,17.1),(108981,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108981,35.85,0.4,148,46687,NULL,NULL,'Malmquist cor.','ESO 508- G 073',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'15.38',0.7,'Sb',NULL,NULL,NULL,NULL,1,201.339583,-24.97236,0.253,NULL,43293499283,676460926,10569701,15.38),(108982,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108982,35.99,0.38,158,46687,NULL,NULL,NULL,'ESO 508- G 073',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108983,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108983,36.03,0.2,161,46687,74.4,NULL,NULL,'ESO 508- G 073',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108984,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108984,37.5,0.46,317,46688,70,NULL,NULL,'2MASX J13252191+2406186',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,201.3412083,24.10528,0.024,NULL,58792141298,918627207,14353550,17.4),(108985,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108985,36.27,0.53,179,46689,70,NULL,NULL,'2MASX J13252250-2522555',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,201.34375,-25.38206,0.269,NULL,43292731700,676448932,10569514,14.5),(108986,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108986,36.88,0.46,238,46690,70,NULL,NULL,'2MASX J13252249+3913496',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,201.343833,39.23033,0,NULL,59296589807,926509215,14476706,17.3),(108987,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108987,37.73,0.46,352,46691,70,NULL,NULL,'2MASX J13252371+2738356',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000153,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,201.348875,27.64306,0.103,NULL,58659183746,916549746,14321089,17.3),(108988,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108988,37.51,0.27,318,46692,70,NULL,NULL,'2MASX J13252482+2421086',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,201.353583,24.35242,NULL,NULL,58665243249,916644425,14322569,18),(108989,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108989,37.63,0.46,336,46693,70,NULL,NULL,'2MASX J13252618+3921252',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000183,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,201.359,39.35717,0,NULL,59296735352,926511489,14476742,17),(108990,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108990,38.09,0.46,415,46694,70,NULL,NULL,'SDSS J132526.37+184417.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,201.3599583,18.73833,0.035,NULL,58839725636,919370713,14365167,18.4),(108991,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108991,37.04,0.46,256,46695,70,NULL,NULL,'2MASX J13252727+0806148',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,201.3635417,8.10422,0,NULL,58982213792,921597090,14399954,17.6),(108992,'Brightest Stars','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108992,27.37,0.04,2.98,46696,NULL,NULL,'Photographic, brightest globular cluster','NGC 5128',NULL,'1980ApJ...240L..93D',1980,1,25.7,NULL,'G',0.000017,NULL,'7.84',20,'S0 pec;Sy2     BLLAC','Pair member (points to parent)',NULL,'radio jet',NULL,1,201.365083,-43.01911,0.485,0,46962583428,733790366,11465474,7.84),(108993,'Cepheids','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108993,27.43,0.05,3.06,46696,NULL,18.45,NULL,'NGC 5128',NULL,'2010AcA....60..121M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108994,'Cepheids','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108994,27.46,0.32,3.1,46696,NULL,18.39,'VI, LMC ZP','NGC 5128',NULL,'2008MNRAS.390.1539M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108995,'Cepheids','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108995,27.67,0.12,3.42,46696,NULL,NULL,'42, VI','NGC 5128',NULL,'2007ApJ...654..186F',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108996,'Cepheids','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108996,27.72,NULL,3.5,46696,NULL,18.45,'Color Cut','NGC 5128',NULL,'2010AcA....60..121M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108997,'Cepheids','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108997,27.82,0.06,3.66,46696,74.4,NULL,NULL,'NGC 5128',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108998,'GCLF','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,108998,27.7,NULL,3,46696,NULL,NULL,'Photographic','NGC 5128',NULL,'1984ApJ...276..491H',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108999,'GCLF','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',108999,27.53,0.5,3.2,46696,NULL,NULL,NULL,'NGC 5128',NULL,'1988IAUS..126..205H',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109000,'GCLF','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109000,27.59,0.3,3.3,46696,NULL,NULL,NULL,'NGC 5128',NULL,'1984ApJ...287..175H',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109001,'Miras','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109001,27.92,0.19,3.84,46696,NULL,NULL,'K, LPV, M(K) = -8.65 mag','NGC 5128',NULL,'2003A&A...411..351R',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109002,'Miras','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109002,27.96,0.11,3.91,46696,NULL,NULL,'K','NGC 5128',NULL,'2004A&A...413..903R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109003,'Miras','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109003,28.11,0.32,4.2,46696,NULL,NULL,'K, LPV','NGC 5128',NULL,'2003Msngr.112...43R',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109004,'PNLF','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109004,27.64,0.09,3.37,46696,NULL,NULL,NULL,'NGC 5128',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109005,'PNLF','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109005,27.73,0.05,3.5,46696,NULL,NULL,'224 PNe','NGC 5128',NULL,'1993ApJ...414..463H',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109006,'PNLF','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109006,27.73,0.06,3.52,46696,NULL,NULL,'I','NGC 5128',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109007,'PNLF','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109007,27.76,0.12,3.56,46696,NULL,NULL,'HST KP Calibrated','NGC 5128',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109008,'PNLF','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109008,27.9,0.11,3.8,46696,NULL,NULL,NULL,'NGC 5128',NULL,'1988ASPC....4...42J',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109009,'PNLF','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109009,27.92,0.1,3.84,46696,NULL,NULL,NULL,'NGC 5128',NULL,'2010PASA...27..457H',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109010,'SNIa','2016-12-15 15:15:14','2016-12-16 11:20:26','1','SN 1986G',NULL,109010,27.4,NULL,3,46696,70,NULL,NULL,'NGC 5128',NULL,'1987ApJ...315L.129F',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109011,'SNIa','2016-12-15 15:15:14','2016-12-16 11:20:26','1','SN 1986G',NULL,109011,27.46,0.2,3.09,46696,65,NULL,'MLCS2k2','NGC 5128',0.00183,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109012,'SNIa','2016-12-15 15:15:14','2016-12-16 11:20:26','1','SN 1986G',NULL,109012,27.59,0.18,3.3,46696,70,NULL,NULL,'NGC 5128',NULL,'1992ApJ...400..127R',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109013,'SNIa','2016-12-15 15:15:14','2016-12-16 11:20:26','1','SN 1986G',NULL,109013,27.59,0.6,3.3,46696,82,NULL,NULL,'NGC 5128',NULL,'1987PASP...99..592P',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109014,'SNIa','2016-12-15 15:15:14','2016-12-16 11:20:26','1','SN 1986G',NULL,109014,27.66,0.35,3.4,46696,NULL,NULL,NULL,'NGC 5128',NULL,'1993ApJ...417..547R',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109015,'SNIa','2016-12-15 15:15:14','2016-12-16 11:20:26','1','SN 1986G',NULL,109015,27.87,0.4,3.75,46696,NULL,NULL,NULL,'NGC 5128',NULL,'1993ApJ...417..547R',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109016,'SNIa','2016-12-15 15:15:14','2016-12-16 11:20:26','1','SN 1986G',NULL,109016,28.1,0.55,4.2,46696,67,NULL,NULL,'NGC 5128',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109017,'SNIa','2016-12-15 15:15:14','2016-12-16 11:20:26','1','SN 1986G',NULL,109017,28.2,0.19,4.36,46696,72,NULL,NULL,'NGC 5128',0.00183,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109018,'SNIa','2016-12-15 15:15:14','2016-12-16 11:20:26','1','SN 1986G',NULL,109018,28.3,0.05,4.57,46696,66,NULL,NULL,'NGC 5128',NULL,'1994A&A...281...51M',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109019,'SBF','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109019,27.48,0.06,3.1,46696,NULL,NULL,'I','NGC 5128',NULL,'1990AJ....100.1794T',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109020,'SBF','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109020,27.72,0.06,3.5,46696,NULL,NULL,'Photographic, I','NGC 5128',NULL,'1993AJ....106.1344S',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109021,'SBF','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109021,27.74,0.14,3.53,46696,NULL,NULL,'I, new zero point and color','NGC 5128',NULL,'2007ApJ...654..186F',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109022,'SBF','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109022,27.81,0.08,3.65,46696,NULL,NULL,'I','NGC 5128',NULL,'1993ApJ...419..479C',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109023,'SBF','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109023,27.82,0.06,3.66,46696,74.4,NULL,NULL,'NGC 5128',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109024,'SBF','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109024,27.92,0.59,3.84,46696,NULL,NULL,'Photographic, R','NGC 5128',NULL,'1993AJ....106.1344S',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109025,'SBF','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109025,28.03,0.1,4,46696,NULL,NULL,'I','NGC 5128',NULL,'1997ApJ...475..399T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109026,'SBF','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109026,28.06,0.14,4.09,46696,NULL,NULL,'I, new zero point','NGC 5128',NULL,'2007ApJ...654..186F',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109027,'SBF','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109027,28.12,0.14,4.21,46696,NULL,NULL,'I','NGC 5128',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109028,'SBF','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109028,28.12,0.14,4.21,46696,NULL,NULL,'I','NGC 5128',NULL,'2001ApJ...559..584A',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109029,'SBF','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109029,28.19,0.19,4.35,46696,NULL,NULL,'HST KP Calibrated, I','NGC 5128',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109030,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109030,27.72,0.01,3.5,46696,NULL,NULL,'I','NGC 5128',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109031,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109031,27.72,0.04,3.5,46696,NULL,NULL,'I','NGC 5128',NULL,'2007ApJ...661..815R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109032,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109032,27.76,0.2,3.56,46696,NULL,NULL,'K','NGC 5128',NULL,'2004A&A...413..903R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109033,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109033,27.8,0.2,3.6,46696,NULL,NULL,NULL,'NGC 5128',NULL,'1996ApJ...465...79S',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109034,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109034,27.82,0.06,3.66,46696,74.4,NULL,NULL,'NGC 5128',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109035,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109035,27.82,0.11,3.66,46696,NULL,NULL,NULL,'NGC 5128',NULL,'2015ApJ...802L..25T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109036,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109036,27.86,0.35,3.73,46696,NULL,NULL,NULL,'NGC 5128',NULL,'2013MNRAS.432..832C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109037,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109037,27.87,0.17,3.75,46696,NULL,NULL,'K, Z','NGC 5128',NULL,'2004A&A...413..903R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109038,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109038,27.89,0.2,3.78,46696,NULL,NULL,'J','NGC 5128',NULL,'2004A&A...413..903R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109039,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109039,27.9,0.2,3.8,46696,NULL,NULL,'H','NGC 5128',NULL,'2004A&A...413..903R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109040,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109040,27.91,0.08,3.82,46696,NULL,NULL,'IJHK','NGC 5128',NULL,'2010PASA...27..457H',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109041,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109041,27.93,0.13,3.85,46696,NULL,NULL,'HST KP Calibrated','NGC 5128',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (109042,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109042,27.98,0.15,3.9,46696,NULL,NULL,'I','NGC 5128',NULL,'1999AJ....117..855H',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109043,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109043,28.03,0.19,4.04,46696,NULL,NULL,'Second stream ','NGC 5128',NULL,'2015arXiv151205366C',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109044,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109044,28.03,0.15,4.04,46696,NULL,NULL,NULL,'NGC 5128',NULL,'2015arXiv151205366C',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109045,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109045,28.06,NULL,4.1,46696,NULL,NULL,NULL,'NGC 5128',NULL,'2006AstL...32..236K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109046,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109046,28.2,0.2,4.36,46696,NULL,NULL,'Shell 2','NGC 5128',NULL,'2015arXiv151205366C',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109047,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109047,28.43,0.2,4.75,46696,NULL,NULL,'Shell 1','NGC 5128',NULL,'2015arXiv151205366C',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109048,'Type II Cepheids','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109048,27.9,0.22,3.8,46696,NULL,18.45,NULL,'NGC 5128',NULL,'2010AcA....60..121M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109049,'Statistical','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109049,27.91,0.05,3.82,46696,NULL,NULL,NULL,'NGC 5128',NULL,'2010PASA...27..457H',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109050,'GC radius','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109050,27.77,0.17,3.58,46696,NULL,NULL,NULL,'NGC 5128',NULL,'2009ApJ...705.1533C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109051,'Faber-Jackson','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109051,26.01,NULL,1.59,46696,NULL,NULL,'LEDA [April 2006]','NGC 5128',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109052,'Tully est','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109052,28.45,0.8,4.9,46696,75,NULL,'B','NGC 5128',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109053,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109053,29.76,0.34,8.95,46696,53.9,NULL,'Centaurus A Group','NGC 5128',NULL,'1984A&A...132..253R',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109054,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109054,37.97,0.46,392,46697,70,NULL,NULL,'2MASX J13252763+1223272',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000182,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,201.3652083,12.39103,0.018,NULL,59007716567,921995571,14406180,18),(109055,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109055,36.18,0.46,172,46698,70,NULL,NULL,'LCRS B132252.6-031133',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000151,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,201.365666667,-3.45244,0.049,NULL,43837971245,684968300,10702629,17.1),(109056,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109056,37.94,0.33,387,46699,70,NULL,NULL,'SDSS J132528.93+112007.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000164,NULL,'18.2g',0.16,'Sy',NULL,NULL,NULL,NULL,1,201.370583,11.3355,0,NULL,58953127559,921142618,14392853,18.2),(109057,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109057,32.14,0.4,26.8,46700,75,NULL,'B','UGC 08441',NULL,'1988NBGC.C....0000T',1988,1,2.6,NULL,'G',0.000037,NULL,'14.8',1.7,'Im','Dwarf, possible member',NULL,NULL,NULL,1,201.37125,57.82222,0,NULL,57433550575,897399227,14021862,14.8),(109058,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109058,37.61,0.33,332,46701,70,NULL,NULL,'2MASX J13252927-0155173',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,201.371916667,-1.92161,0.041,NULL,43825887850,684779497,10699679,17.2),(109059,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109059,37.32,0.23,291,46702,70,NULL,NULL,'SDSS J132529.34+402940.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000163,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,201.3722917,40.49469,0,NULL,59313861819,926779090,14480923,18),(109060,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109060,37.55,0.46,323,46703,70,NULL,NULL,'2MASX J13252934+2319144',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,201.372375,23.32078,0.031,NULL,58791900491,918623445,14353491,17.4),(109061,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109061,37.26,0.21,283,46704,70,NULL,NULL,'2MASX J13253003+0821558',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000172,NULL,'16.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,201.37525,8.3655,0,NULL,58948922085,921076907,14391826,16.6),(109062,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109062,36.51,0.2,200,46705,74.4,NULL,NULL,'CGCG 072-072',NULL,'2013AJ....146...86T',2013,1,0.81,NULL,'G',0.000005,NULL,'15.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,201.380417,11.82525,0,NULL,58939415822,920928372,14389505,15.7),(109063,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109063,36.8,0.46,229,46706,70,NULL,NULL,'2MASX J13253187+1600362',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,201.382833,16.00994,0,NULL,58831394634,919240541,14363133,17.7),(109064,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109064,37.94,0.33,387,46707,70,NULL,NULL,'2MASX J13253262+1117178',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000184,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,201.3860417,11.28828,0,NULL,58953134908,921142732,14392855,17.2),(109065,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109065,36.71,0.72,220,46708,70,NULL,NULL,'2MASX J13253269-2525205',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,201.386167,-25.42239,0.269,NULL,43292709684,676448588,10569509,15.7),(109066,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109066,31.22,0.4,17.5,46709,NULL,NULL,NULL,'NGC 5121A',NULL,'2009AJ....138..323T',2009,1,1.7,'Confused HIPASS source','G',0.000023,NULL,'15.63',0.5,'SAB(s)dm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,201.386666667,-37.37881,0.197,NULL,46935898659,733373416,11458959,15.63),(109067,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109067,31.22,0.4,17.5,46709,73,NULL,'opt','NGC 5121A',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109068,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109068,31.23,0.87,17.6,46709,NULL,NULL,NULL,'NGC 5121A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109069,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109069,31.27,0.2,18,46709,74.4,NULL,NULL,'NGC 5121A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109070,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109070,31.55,0.75,20.4,46709,NULL,NULL,'Malmquist cor.','NGC 5121A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109071,'SNIa','2016-12-15 15:15:14','2016-12-16 11:20:26','1','SN 2007cg',NULL,109071,35.14,0.17,103,46710,74.2,NULL,'SALT 2','ESO 508- G 075',0.033196,'2010ApJ...716..712A',2010,1,1.1,NULL,'G',0.000033,NULL,'15.96',0.3,'S              HII',NULL,NULL,NULL,NULL,1,201.389041667,-24.65239,0.269,NULL,43293076131,676454314,10569598,15.96),(109072,'SNIa','2016-12-15 15:15:14','2016-12-16 11:20:26','1','SN 2007cg',NULL,109072,35.44,0.05,119,46710,72,NULL,'MLCS17','ESO 508- G 075',0.033196,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109073,'SNIa','2016-12-15 15:15:14','2016-12-16 11:20:26','1','SN 2007cg',NULL,109073,35.64,0.08,134,46710,74.4,NULL,NULL,'ESO 508- G 075',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109074,'SNIa','2016-12-15 15:15:14','2016-12-16 11:20:26','1','SN 2007cg',NULL,109074,35.72,0.2,135,46710,65,NULL,'MLCS17','ESO 508- G 075',0.033196,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109075,'SNIa','2016-12-15 15:15:14','2016-12-16 11:20:26','1','SN 2007cg',NULL,109075,35.85,0.21,143,46710,65,NULL,'SALT2','ESO 508- G 075',0.033196,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109076,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109076,35.61,0.49,132,46710,NULL,NULL,'Malmquist cor.','ESO 508- G 075',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109077,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109077,35.64,0.08,134,46710,74.4,NULL,NULL,'ESO 508- G 075',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109078,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109078,35.67,0.48,136,46710,NULL,NULL,NULL,'ESO 508- G 075',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109079,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109079,37.98,0.33,395,46711,70,NULL,NULL,'2MASX J13253379+1205228',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000158,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,201.390708333,12.08964,0,NULL,59007627910,921994186,14406159,17.3),(109080,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109080,38.86,0.46,593,46712,70,NULL,NULL,'SDSS J132533.79+251001.8',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,201.390791667,25.16717,NULL,NULL,58665550554,916649227,14322644,NULL),(109081,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109081,37.76,0.46,357,46713,70,NULL,NULL,'2MASX J13253392+1304122',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000147,NULL,'16.1g',0.37,'E0',NULL,NULL,NULL,NULL,1,201.3912917,13.07006,0.008,NULL,59019512381,922179880,14409060,16.1),(109082,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109082,36.2,0.52,174,46714,70,NULL,NULL,'ESO 508- G 074',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15',0.2,'SB0','Group member',NULL,NULL,NULL,1,201.391416667,-27.58292,0.185,NULL,43296495454,676507741,10570433,15),(109083,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109083,34.64,0.6,84.9,46715,70,NULL,NULL,'II SZ 045',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3',NULL,'E1',NULL,NULL,NULL,NULL,1,201.3974583,-13.13853,0.089,NULL,44005294462,687582725,10743480,15.3),(109084,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109084,37.32,0.23,291,46716,70,NULL,NULL,'2MASX J13253557+4029214',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000187,NULL,'16.1g',0.42,'E0',NULL,NULL,NULL,NULL,1,201.3982917,40.48919,0,NULL,59313857990,926779031,14480922,16.1),(109085,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109085,38.1,0.33,416,46717,70,NULL,NULL,'LCRS B132300.7-031349',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,201.399125,-3.49017,0.049,NULL,43837976759,684968386,10702631,17.8),(109086,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109086,38.5,0.46,502,46718,70,NULL,NULL,'SDSS J132536.37+004812.6',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00007,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,201.401583,0.80353,0.061,NULL,58049512505,907023632,14172244,17.9),(109087,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109087,35.96,0.38,156,46719,NULL,NULL,'Malmquist cor.','ESO 508- G 076',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.38',0.2,'Sbc','Group member',NULL,NULL,NULL,1,201.404875,-27.32994,0.221,NULL,43296587813,676509184,10570456,15.38),(109088,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109088,36.19,0.34,173,46719,NULL,NULL,NULL,'ESO 508- G 076',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109089,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109089,36.23,0.2,176,46719,74.4,NULL,NULL,'ESO 508- G 076',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109090,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109090,36.82,0.6,232,46720,70,NULL,NULL,'2MASX J13253790-2647535',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15',NULL,'S0','Group member',NULL,NULL,NULL,1,201.407917,-26.79828,0.245,NULL,43298777147,676543392,10570990,15),(109091,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109091,38.16,0.46,428,46721,70,NULL,NULL,'SDSS J132537.91+052046.2',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000149,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,201.408,5.34619,0.036,NULL,58927653212,920744581,14386634,17.8),(109092,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109092,38.26,0.27,448,46722,70,NULL,NULL,'2MASX J13253923+6200022',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000188,NULL,'17.0g',0.26,'BrClG',NULL,NULL,NULL,NULL,1,201.413583,62.00072,0.057,NULL,57379984844,896562263,14008785,17),(109093,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109093,36.08,NULL,165,46723,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 508- G 077',NULL,'2010Ap&SS.325..163P',2010,1,1.1,NULL,'G',0.000027,NULL,'14.84',0.11,'Sc','Group member',NULL,NULL,NULL,1,201.414,-27.34539,0.221,NULL,43296506001,676507906,10570436,14.84),(109094,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109094,36.1,NULL,166,46723,NULL,NULL,'Dipole + Quadrupole','ESO 508- G 077',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109095,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109095,36.13,NULL,168,46723,NULL,NULL,'Dipole','ESO 508- G 077',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109096,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109096,36.31,0.43,183,46723,NULL,NULL,'Malmquist cor.','ESO 508- G 077',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109097,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109097,36.58,0.38,207,46723,NULL,NULL,NULL,'ESO 508- G 077',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109098,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109098,36.62,0.2,211,46723,74.4,NULL,NULL,'ESO 508- G 077',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109099,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109099,36.14,0.46,169,46724,70,NULL,NULL,'2MASX J13254005+4158284',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000168,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,201.417,41.97467,0,NULL,59322733485,926917710,14483089,16.3),(109100,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109100,38.15,0.46,426,46725,70,NULL,NULL,'2MASXi J1325413+124703',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000172,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,201.422333,12.78428,0.008,NULL,59008158818,922002481,14406288,17.4),(109101,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109101,38.08,0.23,413,46726,70,NULL,NULL,'2MASX J13254144-0121518',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00015,NULL,'17.42',0.27,'BrClG',NULL,NULL,NULL,NULL,1,201.422666667,-1.3645,0.045,NULL,43822409652,684725150,10698830,17.42),(109102,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109102,37.26,0.21,283,46727,70,NULL,NULL,'2MASX J13254223+0821008',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.45',0.14,NULL,NULL,NULL,NULL,NULL,1,201.425958333,8.35031,0,NULL,58948926735,921076980,14391827,18.45),(109103,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109103,35.73,0.38,140,46728,NULL,NULL,'Malmquist cor.','ESO 444- G 031',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15',0.8,'Sc',NULL,NULL,NULL,NULL,1,201.427875,-29.54481,0.141,NULL,46846215668,731972119,11437064,15),(109104,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109104,35.8,0.36,144,46728,NULL,NULL,NULL,'ESO 444- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109105,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109105,35.84,0.2,147,46728,74.4,NULL,NULL,'ESO 444- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109106,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109106,36.72,0.46,221,46729,70,NULL,NULL,'2MASX J13254321+5213486',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000193,NULL,'16.0g',0.43,'E',NULL,NULL,NULL,NULL,1,201.430083,52.23014,0,NULL,59206936018,925108375,14454818,16),(109107,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109107,37.69,0.15,345,46730,70,NULL,NULL,'2MASX J13254381+5905146',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,201.4325,59.08725,0.009,NULL,57389736098,896714626,14011166,17.7),(109108,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109108,37.28,0.46,285,46731,70,NULL,NULL,'LCRS B132309.5-022255',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00018,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,201.434667,-2.64186,0.045,NULL,43825282694,684770042,10699531,16.7),(109109,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109109,35.43,0.49,122,46732,70,NULL,NULL,'2MASX J13254456-2132389',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.62',NULL,NULL,NULL,NULL,NULL,NULL,1,201.435875,-21.54444,0.269,NULL,43810913355,684545521,10696023,15.62),(109110,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109110,37.92,0.33,383,46733,70,NULL,NULL,'2MASX J13254481+2954025',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,201.436791667,29.90061,0.031,NULL,59177459971,924647812,14447622,17),(109111,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109111,36.44,0.56,194,46734,70,NULL,NULL,'2MASX J13254495-2830355',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.7b',0.3,'E',NULL,NULL,NULL,NULL,1,201.4372917,-28.50983,0.181,NULL,43294315940,676473686,10569901,16.7),(109112,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109112,37.61,0.33,332,46735,70,NULL,NULL,'2MASX J13254544-0200368',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,201.439333333,-2.01022,0.045,NULL,43825881239,684779394,10699678,16.8),(109113,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109113,36.96,0.46,246,46736,70,NULL,NULL,'2MASX J13254555+6644193',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000065,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,201.439833333,66.73861,0.045,NULL,57876105988,904314156,14129908,18.1),(109114,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109114,38.08,0.23,413,46737,70,NULL,NULL,'2MASX J13254584-0122348',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,201.4410417,-1.37628,0.045,NULL,43822377205,684724643,10698822,17.6),(109115,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109115,37.17,0.46,272,46738,70,NULL,NULL,'2MASX J13254641+1433199',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000175,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,201.443416667,14.55542,0.022,NULL,59020319897,922192498,14409257,16.6),(109116,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109116,38.2,0.46,437,46739,70,NULL,NULL,'2MASX J13254782-0014538',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00009,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,201.44925,-0.24836,0.033,NULL,43084356498,673193070,10518641,17),(109117,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109117,36.48,0.46,198,46740,70,NULL,NULL,'2MASX J13254826+0133133',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00017,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,201.451125,1.55367,0.038,NULL,58925013882,920703341,14385989,16.7),(109118,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109118,35.68,0.49,137,46741,70,NULL,NULL,'2MASX J13255027-3208540',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.000137,NULL,'15.4b',0.82,'E','Group member',NULL,NULL,NULL,1,201.459667,-32.14839,0.229,NULL,46870594002,732353031,11443016,15.4),(109119,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109119,36.3,0.46,182,46742,70,NULL,NULL,'2MASX J13255037+1140545',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000127,NULL,'16.1g',0.42,'E0',NULL,NULL,NULL,NULL,1,201.4599583,11.68194,0,NULL,58953087236,921141988,14392843,16.1),(109120,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109120,34.87,0.25,94.2,46743,74.4,NULL,NULL,'2MASX J13255082-2645045',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000014,NULL,'15',NULL,'E','Group member',NULL,NULL,NULL,1,201.46175,-26.75128,0.245,NULL,43298776548,676543383,10570990,15),(109121,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109121,38.88,0.46,597,46744,70,NULL,NULL,'SDSS J132550.92+493713.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,201.4622083,49.62047,0,NULL,59277980573,926218446,14472163,18.3),(109122,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109122,37.36,0.33,297,46745,70,NULL,NULL,'2MASX J13255112+0108243',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000085,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,201.463167,1.14014,0.029,NULL,58922126749,920658230,14385284,17.2),(109123,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109123,37.13,0.46,267,46746,70,NULL,NULL,'2MASX J13255130+4207186',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00017,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,201.463833,42.12181,0,NULL,59322791355,926918614,14483103,16.7),(109124,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109124,38.1,0.33,416,46747,70,NULL,NULL,'LCRS B132316.5-031224',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,201.465125,-3.46656,0.049,NULL,43837974147,684968346,10702630,17.6),(109125,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109125,36.71,0.46,220,46748,70,NULL,NULL,'2MASX J13255176-0040447',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000099,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,201.4657917,-0.67903,0.029,NULL,43084697193,673198393,10518724,16.4),(109126,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109126,35.09,0.54,104,46749,70,NULL,NULL,'II SZ 044',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,'E2',NULL,NULL,NULL,NULL,1,201.4687917,-14.31656,0.089,NULL,44004417516,687569023,10743265,16.1),(109127,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109127,38.05,0.46,407,46750,70,NULL,NULL,'2MASX J13255363+2451411',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'18.73',NULL,NULL,NULL,NULL,NULL,NULL,1,201.4735,24.86153,0.023,NULL,58665570477,916649538,14322649,18.73),(109128,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109128,37.98,0.33,395,46751,70,NULL,NULL,'2MASX J13255437+1208169',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00016,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,201.4767083,12.13808,0.013,NULL,59007615808,921993997,14406156,17.3),(109129,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109129,37.93,0.46,386,46752,70,NULL,NULL,'2MASX J13255462-0024427',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000077,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,201.477583,-0.412,0.021,NULL,43084891816,673201434,10518772,16.8),(109130,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109130,37.77,0.23,358,46753,70,NULL,NULL,'2MASX J13255612+0611545',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000169,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,201.4837083,6.1985,0,NULL,58982903256,921607863,14400122,16.7),(109131,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109131,37.14,0.46,268,46754,70,NULL,NULL,'2MASX J13255641+5345456',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000139,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,201.485333333,53.76267,0,NULL,57280027872,895000435,13984381,17.4),(109132,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'RN',109132,27.78,0.22,3.61,46755,NULL,NULL,NULL,'CenA-MM-Dw6',NULL,'2015arXiv151205366C',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109133,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109133,37.19,0.46,274,46756,70,NULL,NULL,'2MASX J13255817+4112114',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000165,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,201.49225,41.20314,0,NULL,59322245441,926910085,14482970,17),(109134,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109134,36.43,0.46,194,46757,70,NULL,NULL,'2MASX J13255866+1308309',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,201.494333,13.142,0.008,NULL,59008108185,922001690,14406276,17),(109135,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109135,36.59,0.46,208,46758,70,NULL,NULL,'2MASX J13255864+1841167',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.37',0.19,NULL,NULL,NULL,NULL,NULL,1,201.494375,18.68786,0.025,NULL,58839671502,919369867,14365154,17.37),(109136,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109136,37.77,0.23,358,46759,70,NULL,NULL,'2MASX J13260000+0603435',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000173,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,201.4999583,6.06208,0,NULL,58982881509,921607523,14400117,17.9),(109137,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109137,37.82,0.46,367,46760,70,NULL,NULL,'2MASX J13260016+0715005',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000178,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,201.500833,7.25022,0,NULL,58984337487,921630273,14400473,16.9),(109138,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109138,35.2,0.46,110,46761,70,NULL,NULL,'2MASX J13260088+0613225',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000164,NULL,'15.7g',0.39,NULL,NULL,NULL,NULL,NULL,1,201.503625,6.22314,0,NULL,58982901193,921607831,14400122,15.7),(109139,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109139,33.89,0.51,60,46762,70,NULL,NULL,'2MASX J13260133-2255351',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000127,NULL,'15.35',NULL,NULL,NULL,NULL,NULL,NULL,1,201.5052917,-22.92656,0.257,NULL,43767019217,683859675,10685307,15.35),(109140,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109140,36.83,0.46,232,46763,70,NULL,NULL,'SDSS J132602.39+364759.2',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',NULL,NULL,'15.6g',0.4,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,201.51,36.79981,0,NULL,59166639070,924478735,14444980,15.6),(109141,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109141,37.36,0.33,297,46764,70,NULL,NULL,'2MASX J13260252+0111163',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00008,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,201.510625,1.18775,0.029,NULL,58922129620,920658275,14385285,17),(109142,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109142,36.86,0.33,236,46765,70,NULL,NULL,'2MASX J13260257+3118044',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000161,NULL,'16.6g',0.3,'E1',NULL,NULL,NULL,NULL,1,201.510958333,31.30117,0.026,NULL,59161135195,924392737,14443636,16.6),(109143,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109143,37.05,0.33,257,46766,70,NULL,NULL,'2MASX J13260322+2434591',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.02',0.2,NULL,NULL,NULL,NULL,NULL,1,201.5135,24.58294,0.026,NULL,58665449908,916647654,14322619,17.02),(109144,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109144,38.53,0.46,508,46767,70,NULL,NULL,'SDSS J132603.44-015347.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000138,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,201.514375,-1.89639,0.045,NULL,43825853813,684778965,10699671,18.6),(109145,'IRAS','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109145,32.32,0.8,29.1,46768,75,NULL,'HMCL, I','ESO 444- G 033',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000027,NULL,'14.89',0.4,'SBm? sp','Group member',NULL,NULL,NULL,1,201.5177917,-32.12947,0.161,NULL,46869531504,732336429,11442756,14.89),(109146,'IRAS','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109146,32.33,0.8,29.2,46768,75,NULL,'MAT, I','ESO 444- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109147,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109147,31.68,0.32,21.7,46768,85,NULL,'I, inv','ESO 444- G 033',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109148,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109148,31.72,0.32,22.1,46768,85,NULL,'I, raw','ESO 444- G 033',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109149,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109149,32.13,0.43,26.7,46768,75,NULL,'MAT, I, inv','ESO 444- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109150,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109150,32.21,0.43,27.7,46768,75,NULL,'MAT, I, raw','ESO 444- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109151,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109151,32.39,0.4,30,46768,75,NULL,'HMCL, I, inv','ESO 444- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109152,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109152,32.42,0.4,30.4,46768,75,NULL,'HMCL, I, raw','ESO 444- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109153,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109153,32.55,0.43,32.3,46768,75,NULL,'MAT, I, cor','ESO 444- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109154,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109154,32.72,0.6,34.9,46768,NULL,NULL,NULL,'ESO 444- G 033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109155,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109155,32.71,0.4,34.9,46768,75,NULL,'HMCL, I, cor','ESO 444- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109156,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109156,32.76,0.2,35.7,46768,74.4,NULL,NULL,'ESO 444- G 033',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109157,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109157,32.97,0.54,39.3,46768,NULL,NULL,'Malmquist cor.','ESO 444- G 033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109158,'IRAS','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109158,32.73,0.8,35.1,46769,75,NULL,'MAT, I','ESO 220- G 008',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'14.05',0.5,'SA(s)b: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,201.5235,-48.23592,0.557,NULL,46958408667,733725135,11464455,14.05),(109159,'Tully est','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109159,32.72,0.8,35,46769,75,NULL,NULL,'ESO 220- G 008',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109160,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109160,32.51,0.32,31.7,46769,85,NULL,'I, raw','ESO 220- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109161,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109161,32.51,0.43,31.8,46769,75,NULL,'MAT, I, raw','ESO 220- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109162,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109162,32.55,0.32,32.3,46769,85,NULL,'I, inv','ESO 220- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109163,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109163,32.69,0.43,34.4,46769,75,NULL,'MAT, I, inv','ESO 220- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109164,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109164,32.69,0.49,34.5,46769,75,NULL,'IR','ESO 220- G 008',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109165,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109165,32.85,0.43,37.1,46769,75,NULL,'MAT, I, cor','ESO 220- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109166,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109166,33.35,0.12,46.9,46769,NULL,NULL,NULL,'ESO 220- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109167,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109167,37.69,0.15,345,46770,70,NULL,NULL,'2MASX J13260600+5859549',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,201.525291667,58.99872,0.009,NULL,57390595473,896728054,14011375,17.2),(109168,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109168,36.02,0.46,160,46771,70,NULL,NULL,'2MASX J13260644+0808475',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,201.52675,8.1465,0,NULL,58949240669,921081885,14391904,16.5),(109169,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109169,35.15,0.49,107,46772,75,NULL,'IR','UGC 08442',NULL,'2011yCatp016004901K',2011,1,0.94,NULL,'G',0.000053,NULL,'16.1g',0.2,'Sd',NULL,NULL,NULL,NULL,1,201.5284583,21.93939,0.031,NULL,58848528281,919508254,14367316,16.1),(109170,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109170,35.38,NULL,119,46772,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08442',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109171,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109171,35.39,NULL,120,46772,NULL,NULL,'Dipole + Quadrupole','UGC 08442',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109172,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109172,35.41,NULL,121,46772,NULL,NULL,'Dipole','UGC 08442',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109173,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109173,35.43,NULL,122,46772,NULL,NULL,NULL,'UGC 08442',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109174,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109174,37.97,0.21,393,46773,70,NULL,NULL,'SDSS J132607.32+000941.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,201.5305417,0.16147,0.037,NULL,58049809257,907028269,14172316,18),(109175,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109175,37.97,0.21,393,46774,70,NULL,NULL,'2MASX J13260756+0010493',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000078,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,201.531583,0.18025,0.037,NULL,58049778720,907027792,14172309,17.4),(109176,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109176,35.21,0.47,110,46775,70,NULL,NULL,'ESO 576- G 054',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.14',0.7,'(R\')SAB(s)0-?',NULL,NULL,NULL,NULL,1,201.532625,-19.77672,0.265,NULL,43821896020,684717125,10698705,15.14),(109177,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109177,37.63,0.46,336,46776,70,NULL,NULL,'SDSS J132607.91+091826.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,201.533,9.30733,0,NULL,58951891376,921123302,14392551,18.1),(109178,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109178,36.86,0.33,236,46777,70,NULL,NULL,'2MASX J13260796+3116364',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.0001,NULL,'16.0g',0.36,'E4',NULL,NULL,NULL,NULL,1,201.533291667,31.27681,0.026,NULL,59161069370,924391708,14443620,16),(109179,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109179,34.31,0.51,72.9,46778,70,NULL,NULL,'ESO 576- G 055',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000143,NULL,'14.92',0.4,'Sa-b',NULL,NULL,NULL,NULL,1,201.5345,-21.03447,0.273,NULL,43818649057,684666391,10697912,14.92),(109180,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109180,38.12,0.46,420,46779,70,NULL,NULL,'2MASX J13260887+5418450',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000159,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,201.536916667,54.31247,0,NULL,57279630047,894994219,13984284,17.8),(109181,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109181,34.57,0.4,82,46780,NULL,NULL,'mean','NGC 5149',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000023,NULL,'13.75',0.9,'SBbc','Pair member (points to parent)',NULL,NULL,NULL,1,201.538125,35.93442,0,NULL,59168172715,924502698,14445354,13.75),(109182,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109182,34.68,0.45,86.3,46780,NULL,NULL,'K','NGC 5149',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109183,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109183,34.69,0.47,86.6,46780,NULL,NULL,'H','NGC 5149',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109184,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109184,34.73,0.46,88.1,46780,NULL,NULL,'J','NGC 5149',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109185,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109185,36.92,0.46,242,46781,70,NULL,NULL,'2MASX J13260930-0052487',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000066,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,201.53875,-0.88006,0.029,NULL,43084533429,673195834,10518684,17.6),(109186,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109186,37.97,0.21,393,46782,70,NULL,NULL,'2MASX J13261034+0005077',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000082,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,201.543125,0.08556,0.037,NULL,58049812536,907028320,14172317,17.2),(109187,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109187,35.98,0.5,157,46783,70,NULL,NULL,'ESO 509- G 003',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00007,NULL,'14.0V',0.5,'E/S0','Group member',NULL,NULL,NULL,1,201.5437083,-27.42769,0.157,NULL,43296421914,676506592,10570415,14),(109188,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109188,36.31,0.46,183,46784,70,NULL,NULL,'2MASX J13261054+3329154',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000151,NULL,'17.2g',0.2,'E3',NULL,NULL,NULL,NULL,1,201.544083,33.48772,0,NULL,59161786706,924402917,14443795,17.2),(109189,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109189,35.33,0.25,116,46785,74.4,NULL,NULL,'2MASX J13261061-2649366',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000014,NULL,'15.00',NULL,'E        poss. LINER','Group member',NULL,NULL,NULL,1,201.54425,-26.82681,0.245,NULL,43298250556,676535164,10570861,15),(109190,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109190,35.33,0.48,117,46785,70,NULL,NULL,'2MASX J13261061-2649366',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109191,'Tully est','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109191,31.83,0.8,23.3,46786,75,NULL,NULL,'UGCA 357',NULL,'1988NBGC.C....0000T',1988,1,0.8,NULL,'G',0.000037,NULL,'19.10',0.6,'Im',NULL,NULL,NULL,NULL,1,201.551167,37.76633,0,NULL,59298504397,926539131,14477173,19.1),(109192,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109192,36.23,0.42,176,46787,NULL,NULL,NULL,'2MASX J13261291-2729075',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000027,NULL,'15.68',NULL,'Sc',NULL,NULL,NULL,NULL,1,201.55375,-27.48544,0.157,NULL,43296413070,676506454,10570413,15.68),(109193,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109193,36.27,0.2,179,46787,74.4,NULL,NULL,'2MASX J13261291-2729075',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109194,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109194,36.31,0.41,183,46787,NULL,NULL,'Malmquist cor.','2MASX J13261291-2729075',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109195,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109195,38.61,0.46,527,46788,70,NULL,NULL,'2MASX J13261308-0010489',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000102,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,201.5545417,-0.18039,0.037,NULL,43084321936,673192530,10518633,18.2),(109196,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109196,37.51,0.33,318,46789,70,NULL,NULL,'SDSS J132613.64+365057.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'19.59',0.15,NULL,NULL,NULL,NULL,NULL,1,201.556833333,36.84936,0,NULL,59166461663,924475963,14444936,19.59),(109197,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109197,37.83,0.33,367,46790,70,NULL,NULL,'SDSS J132613.71+261331.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'19.33',0.17,NULL,NULL,NULL,NULL,NULL,1,201.557167,26.22539,NULL,NULL,58666158744,916658730,14322792,19.33),(109198,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109198,37.9,0.46,380,46791,70,NULL,NULL,'2MASX J13261603+5923259',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,201.566667,59.39058,0.009,NULL,57389854253,896716472,14011194,17.6),(109199,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109199,37.05,0.33,257,46792,70,NULL,NULL,'2MASX J13261606+2435080',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,201.5670417,24.58544,0.026,NULL,58665306249,916645410,14322584,16.9),(109200,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109200,37.83,0.33,367,46793,70,NULL,NULL,'2MASX J13261612+2613370',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000166,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,201.56725,26.22694,NULL,NULL,58666159502,916658742,14322792,16.8),(109201,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109201,34.99,0.52,99.7,46794,70,NULL,NULL,'MCG -02-34-048',NULL,'2014MNRAS.445.2677S',2014,1,2,NULL,'G',0.00015,NULL,'15.11',2,'S0?',NULL,NULL,NULL,NULL,1,201.5675417,-12.61631,0.057,NULL,43991881576,687373149,10740205,15.11),(109202,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109202,30.62,NULL,13.3,46795,72,NULL,NULL,'SDSS J132615.73+022729.5',NULL,'2014Ap.....57..457K',2014,1,0.8,'Multiple SDSS entries describe this source.','G',0.00001,NULL,'16.8',0.4,'dI',NULL,NULL,NULL,NULL,1,201.565583,2.45822,0.019,NULL,58924988916,920702951,14385983,16.8),(109203,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109203,38.26,0.27,448,46796,70,NULL,NULL,'2MASX J13261642+6201585',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000203,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,201.5682083,62.03303,0.057,NULL,57379990734,896562355,14008786,17.9),(109204,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109204,35.05,0.46,102,46797,70,NULL,NULL,'ESO 576- G 056',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.00015,NULL,'14.49',0.7,'SA(rs:)a',NULL,NULL,NULL,NULL,1,201.570833,-19.63522,0.265,NULL,43821172002,684705812,10698528,14.49),(109205,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109205,36.8,0.33,229,46798,70,NULL,NULL,'2MASX J13261731+0755465',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000118,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,201.572167,7.92944,0,NULL,58981991893,921593623,14399900,16.8),(109206,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109206,37.76,0.46,357,46799,70,NULL,NULL,'2MASX J13261745+0927355',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.74',0.14,NULL,NULL,NULL,NULL,NULL,1,201.572667,9.45981,0,NULL,58951776006,921121500,14392523,18.74),(109207,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109207,37.62,0.46,334,46800,70,NULL,NULL,'2MASX J13261750+1852282',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.48',0.22,NULL,NULL,NULL,NULL,NULL,1,201.572875,18.87439,0.018,NULL,58853231957,919581749,14368464,17.48),(109208,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109208,37.77,0.23,358,46801,70,NULL,NULL,'2MASX J13261753+0607087',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.64',0.21,NULL,NULL,NULL,NULL,NULL,1,201.572958333,6.11925,0,NULL,58982715174,921604924,14400076,17.64),(109209,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109209,37.92,0.33,383,46802,70,NULL,NULL,'2MASX J13261794+3010373',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,201.5747083,30.177,0.018,NULL,59177682163,924651283,14447676,17.9),(109210,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109210,38.03,0.46,403,46803,70,NULL,NULL,'2MASX J13261852+1133505',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000167,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,201.577041667,11.56414,0.011,NULL,58953253618,921144587,14392884,16.8),(109211,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109211,37.55,0.27,324,46804,70,NULL,NULL,'2MASX J13261878+2306192',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,201.578291667,23.10553,0.03,NULL,58795410548,918678289,14354348,17.2),(109212,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109212,37.51,0.33,318,46805,70,NULL,NULL,'2MASX J13261927+3652533',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,201.580375,36.88153,0,NULL,59166459723,924475933,14444936,17.3),(109213,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109213,36.88,0.46,237,46806,70,NULL,NULL,'2MASX J13261933+5825229',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,201.580667,58.42314,0,NULL,57387207560,896675118,14010548,17.1),(109214,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109214,31.67,0.4,21.6,46807,75,NULL,'B','NGC 5147',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000013,NULL,'12.29',1.5,'SB(s)dm        HII','Field galaxy',NULL,NULL,NULL,1,201.5822083,2.10086,0,NULL,58925688938,920713889,14386154,12.29),(109215,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109215,37.77,0.23,358,46808,70,NULL,NULL,'2MASX J13262005+0607115',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00017,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,201.583625,6.11992,0,NULL,58982715268,921604926,14400076,17.7),(109216,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109216,38.19,0.46,435,46809,70,NULL,NULL,'SDSS J132620.36+001608.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000067,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,201.584833,0.26917,0.037,NULL,58050058779,907032168,14172377,18.5),(109217,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109217,37.28,0.46,285,46810,70,NULL,NULL,'2MASX J13262040-0141110',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,201.5850417,-1.68631,0.041,NULL,43825959620,684780619,10699697,17.5),(109218,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109218,33.67,0.51,54.2,46811,70,NULL,NULL,'ESO 576- G 057',NULL,'2014MNRAS.445.2677S',2014,1,1.2,'Fairall et al. (1992AJ....103...11F) give v = 8883 +/- 53 km/sec.','G',0.000033,NULL,'14.82',1,'(R)SA(r)ab',NULL,NULL,NULL,NULL,1,201.585333,-22.63147,0.257,NULL,43765753401,683839896,10684998,14.82),(109219,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109219,36.72,0.56,221,46812,70,NULL,NULL,'2MASX J13262055-0910255',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.20',0.3,NULL,NULL,NULL,NULL,NULL,1,201.585667,-9.17378,0.077,NULL,43869130884,685455170,10710237,16.2),(109220,'D-Sigma','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109220,33,0.4,39.9,46813,75,NULL,'Edat, raw','NGC 5140',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.00007,NULL,'12.77',1.7,'SAB(s)0-:     LINER?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,201.5905417,-33.86847,0.173,NULL,46871440087,732366251,11443222,12.77),(109221,'D-Sigma','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109221,33.23,0.4,44.3,46813,75,NULL,'Edat, cor','NGC 5140',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109222,'Faber-Jackson','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109222,32.53,0.44,32.1,46813,95,NULL,'Weighted Mean','NGC 5140',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109223,'Faber-Jackson','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109223,32.87,0.46,37.5,46813,95,NULL,'Michard 1979a','NGC 5140',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109224,'Faber-Jackson','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109224,33,0.63,39.8,46813,95,NULL,'Michard 1979b, c','NGC 5140',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109225,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109225,32.83,0.48,36.9,46813,70,NULL,NULL,'NGC 5140',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109226,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109226,37.49,0.33,315,46814,70,NULL,NULL,'2MASX J13262177+4717116',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,201.590417,47.28661,0,NULL,59290638198,926416221,14475253,17.8),(109227,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109227,35.51,0.6,126,46815,70,NULL,NULL,'2MASX J13262213-3034547',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00014,NULL,'15.1b',0.61,'E',NULL,NULL,NULL,NULL,1,201.5922083,-30.58186,0.141,NULL,46900834032,732825531,11450398,15.1),(109228,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109228,35.23,0.46,111,46816,70,NULL,NULL,'2MASX J13262223+1236325',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000164,NULL,'15.8g',0.43,'S0',NULL,NULL,NULL,NULL,1,201.592583333,12.60906,0.012,NULL,59008477713,922007464,14406366,15.8),(109229,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109229,35.66,0.57,136,46817,70,NULL,NULL,'2MASX J13262252-2501058',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00014,NULL,'15.37',NULL,NULL,NULL,NULL,NULL,NULL,1,201.593916667,-25.01833,0.253,NULL,43292630762,676447355,10569489,15.37),(109230,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109230,37.64,0.46,337,46818,70,NULL,NULL,'2MASX J13262261+5512549',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00017,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,201.594417,55.21542,0,NULL,57418036389,897156818,14018075,17.2),(109231,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109231,37.97,0.21,393,46819,70,NULL,NULL,'SDSS J132623.73+001055.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000075,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,201.598875,0.18214,0.037,NULL,58049782381,907027849,14172310,18.1),(109232,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109232,34.56,0.46,81.7,46820,70,NULL,NULL,'CGCG 044-084',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.00011,NULL,'15.1g',0.48,'S0','Pair member (points to parent)',NULL,NULL,NULL,1,201.600166667,4.46553,0.041,NULL,58934690345,920854536,14388352,15.1),(109233,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109233,37.98,0.46,395,46821,70,NULL,NULL,'2MASX J13262604+2233442',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,201.60875,22.56231,0.029,NULL,58793170009,918643281,14353801,17.4),(109234,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109234,38.18,0.46,433,46822,70,NULL,NULL,'SDSS J132626.81+251326.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,201.61175,25.22397,0.037,NULL,58664903012,916639109,14322486,18.4),(109235,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109235,36.95,0.53,245,46823,70,NULL,NULL,'2MASX J13262768-4629042',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'14.1I',0.37,NULL,NULL,NULL,NULL,NULL,1,201.615417,-46.4845,0.417,NULL,46955587958,733681061,11463766,14.1),(109236,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109236,37.5,0.46,316,46824,70,NULL,NULL,'2MASX J13262841-0017250',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000067,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,201.6182917,-0.29036,0.037,NULL,43084829772,673200465,10518757,17.3),(109237,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109237,37.97,0.21,393,46825,70,NULL,NULL,'SDSS J132628.64+001426.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000085,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,201.619375,0.24067,0.037,NULL,58050057881,907032154,14172377,18.3),(109238,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'RN',109238,27.65,0.19,3.38,46826,NULL,NULL,NULL,'CenA-MM-Dw7',NULL,'2015arXiv151205366C',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109239,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109239,35.52,0.48,127,46827,70,NULL,NULL,'MCG -03-34-078',NULL,'2014MNRAS.445.2677S',2014,1,3.5,NULL,'G',0.00015,NULL,'15.10',2.2,'SA0-',NULL,NULL,NULL,NULL,1,201.62,-19.66944,0.269,NULL,43821893301,684717082,10698704,15.1),(109240,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109240,38.1,0.46,417,46828,70,NULL,NULL,'2MASX J13262920+0030387',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000089,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,201.621708333,0.51092,0.024,NULL,58050211625,907034556,14172414,16.9),(109241,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109241,37.07,0.53,259,46829,70,NULL,NULL,'2MASX J13263064-2751118',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16',NULL,'S0       poss. LINER','Group member',NULL,NULL,NULL,1,201.62775,-27.85336,0.157,NULL,43297727682,676526995,10570734,16),(109242,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109242,36.93,0.63,243,46830,70,NULL,NULL,'2MASX J13263071-4613331',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.5b',0.26,NULL,NULL,NULL,NULL,NULL,1,201.627875,-46.22583,0.417,NULL,46956167969,733690124,11463908,16.5),(109243,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109243,36.88,0.46,237,46831,70,NULL,NULL,'2MASX J13263097+4619010',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00015,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,201.62925,46.31703,0,NULL,59287290384,926363912,14474436,16.8),(109244,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109244,37.66,0.21,340,46832,70,NULL,NULL,'2MASX J13263127+1732015',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,201.630417,17.53369,0,NULL,58832451738,919257058,14363391,18),(109245,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109245,36.43,0.57,193,46833,70,NULL,NULL,'2MASX J13263148-4614001',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'16.5b',0.39,NULL,NULL,NULL,NULL,NULL,1,201.63125,-46.23333,0.417,NULL,46956168093,733690126,11463908,16.5),(109246,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109246,34.39,0.49,75.4,46834,70,NULL,NULL,'AM 1323-295',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.1R',NULL,'E?',NULL,NULL,NULL,NULL,1,201.632667,-30.22278,0.225,NULL,46900964543,732827570,11450430,14.1),(109247,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109247,38.29,0.46,456,46835,70,NULL,NULL,'2MASX J13263296+2550124',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,201.63725,25.83667,NULL,NULL,58666039715,916656870,14322763,18),(109248,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109248,37.13,0.46,267,46836,70,NULL,NULL,'2MASX J13263390+5045059',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,201.64125,50.75169,0,NULL,59274452492,926163320,14471301,17.6),(109249,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109249,37.54,0.33,322,46837,70,NULL,NULL,'2MASX J13263396+1118065',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.91',0.19,NULL,NULL,NULL,NULL,NULL,1,201.641541667,11.30181,0,NULL,58953216155,921144002,14392875,17.91),(109250,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109250,37.93,0.46,385,46838,70,NULL,NULL,'SDSS J132634.17+022616.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,201.642375,2.43783,0.01,NULL,58924985508,920702898,14385982,18.2),(109251,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109251,37.28,0.46,286,46839,70,NULL,NULL,'2MASX J13263438+2756504',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000172,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,201.643333,27.94728,NULL,NULL,58661385341,916584145,14321627,17.8),(109252,'Tully est','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109252,31.78,0.8,22.7,46840,75,NULL,NULL,'UGCA 356',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.000013,NULL,'15.22',0.9,'IB(s)m','Dwarf, possible member',NULL,NULL,NULL,1,201.646667,-22.2375,0.241,NULL,43811308347,684551692,10696120,15.22),(109253,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109253,35.75,0.5,142,46841,70,NULL,NULL,'ESO 509- G 005',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00011,NULL,'15.08',0.8,'SAB(rs)b','Group member',NULL,NULL,NULL,1,201.646833,-26.74181,0.245,NULL,43298242404,676535037,10570859,15.08),(109254,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109254,38.26,0.27,448,46842,70,NULL,NULL,'2MASX J13263532+6208526',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,201.6472917,62.14803,0.057,NULL,57379731270,896558301,14008723,17.9),(109255,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109255,38.65,0.46,537,46843,70,NULL,NULL,'SDSS J132636.56+613435.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000157,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,201.652375,61.57661,0.021,NULL,57380063867,896563497,14008804,18.6),(109256,'Tully est','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109256,31.89,0.8,23.9,46844,75,NULL,NULL,'UGC 08449',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.000017,NULL,'15.5g',0.37,'Sdm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,201.652416667,42.76428,0,NULL,59322675186,926916799,14483074,15.5),(109257,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109257,37.66,0.21,340,46845,70,NULL,NULL,'2MASX J13263694+1734405',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.64',0.15,NULL,NULL,NULL,NULL,NULL,1,201.653833333,17.57781,0,NULL,58832450145,919257033,14363391,18.64),(109258,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109258,37.96,0.46,392,46846,70,NULL,NULL,'2MASX J13263714+3702372',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,201.65475,37.04364,0,NULL,59168526360,924508224,14445441,16.8),(109259,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109259,34.72,0.46,87.9,46847,70,NULL,NULL,'NGC 5146',NULL,'2014MNRAS.445.2677S',2014,1,0.6,'HOLM 516B is a star.','G',0.000107,NULL,'13.59',0.4,'S0o pec',NULL,NULL,NULL,NULL,1,201.6562083,-12.32397,0.065,NULL,43991108128,687361064,10740016,13.59),(109260,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109260,35.04,0.67,102,46848,NULL,NULL,NULL,'2MASXi J1326385-315207',NULL,'2009ApJS..182..474S',2009,1,0.36,NULL,'G',0.000033,NULL,'17.53',0.11,NULL,'Group member',NULL,NULL,NULL,1,201.6605,-31.86869,0.161,NULL,46870576319,732352754,11443011,17.53),(109261,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109261,35.08,0.2,104,46848,74.4,NULL,NULL,'2MASXi J1326385-315207',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109262,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109262,35.23,0.61,111,46848,NULL,NULL,'Malmquist cor.','2MASXi J1326385-315207',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109263,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109263,38.18,0.46,432,46849,70,NULL,NULL,'2MASX J13263973+0824055',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000182,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,201.665667,8.40164,0,NULL,58949812314,921090817,14392044,17.9),(109264,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109264,35.37,0.57,118,46850,70,NULL,NULL,'2MASX J13264050-1224370',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,201.6687083,-12.41022,0.065,NULL,43990993155,687359268,10739988,14.1),(109265,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109265,36.77,0.46,226,46851,70,NULL,NULL,'2MASX J13264054+4216291',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00018,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,201.668917,42.27483,0,NULL,59322914735,926920542,14483133,17),(109266,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109266,35.06,0.46,103,46852,70,NULL,NULL,'NGC 5151',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00018,NULL,'14.9',0.7,NULL,NULL,NULL,NULL,NULL,1,201.670167,16.87381,0,NULL,58832471416,919257365,14363396,14.9),(109267,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109267,37.49,0.33,315,46853,70,NULL,NULL,'2MASX J13264116+4712431',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000152,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,201.671583,47.21203,0,NULL,59290460378,926413443,14475210,17),(109268,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109268,35.82,0.56,146,46854,70,NULL,NULL,'2MASX J13264141-2439258',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,201.6725,-24.65714,0.249,NULL,43291873442,676435522,10569305,14),(109269,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109269,35.61,0.49,133,46855,75,NULL,'IR','ESO 509- G 007',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.00003,NULL,'15.00',0.2,'Sb:','Group member',NULL,NULL,NULL,1,201.6730417,-27.63369,0.157,NULL,43296823082,676512860,10570513,15),(109270,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109270,35.85,0.44,148,46855,NULL,NULL,'Malmquist cor.','ESO 509- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109271,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109271,36,0.41,159,46855,NULL,NULL,NULL,'ESO 509- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109272,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109272,36.04,0.2,161,46855,74.4,NULL,NULL,'ESO 509- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109273,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109273,35.05,0.55,102,46856,70,NULL,NULL,'2MASX J13264218-3128578',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.000073,NULL,'15.9b',0.34,'S0','Group member',NULL,NULL,NULL,1,201.67575,-31.48275,0.201,NULL,46901009283,732828270,11450441,15.9),(109274,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109274,37.72,0.33,350,46857,70,NULL,NULL,'2MASXi J1326422+385637',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,201.675791667,38.94358,0,NULL,59298662874,926541607,14477212,17.9),(109275,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109275,37.51,0.14,317,46858,70,NULL,NULL,'2MASX J13264348+0108159',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000089,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,201.681083,1.13772,0.029,NULL,58922360450,920661882,14385341,16.8),(109276,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109276,37.54,0.33,322,46859,70,NULL,NULL,'2MASX J13264357+1117037',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000197,NULL,'16.3g',0.39,'BrClG',NULL,NULL,NULL,NULL,1,201.681625,11.2845,0,NULL,58953226711,921144167,14392877,16.3),(109277,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109277,37.24,0.46,280,46860,70,NULL,NULL,'2MASX J13264354+4609291',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000165,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,201.681625,46.15806,0.015,NULL,59287386043,926365406,14474459,16.6),(109278,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109278,37.31,0.46,289,46861,70,NULL,NULL,'2MASX J13264362+1519538',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000162,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,201.681667,15.33167,0,NULL,58830419758,919225308,14362895,16.8),(109279,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109279,35.35,0.25,117,46862,74.4,NULL,NULL,'ESO 509- G 008',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000017,NULL,'13.0V',0.7,'cD;E;BrClG','Group member',NULL,NULL,NULL,1,201.68375,-27.43939,0.157,NULL,43296385671,676506026,10570406,13),(109280,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109280,35.54,0.47,128,46862,70,NULL,NULL,'ESO 509- G 008',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109281,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109281,35.77,0.45,142,46862,NULL,NULL,'K','ESO 509- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109282,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109282,35.85,0.4,148,46862,NULL,NULL,'mean','ESO 509- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109283,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109283,28.33,NULL,4.63,46863,NULL,NULL,NULL,'IC 4247',NULL,'2011A&A...530A..59C',2011,1,1.3,NULL,'G',0.000217,NULL,'14.37',0.5,'S?','Brightest group member',NULL,NULL,NULL,1,201.685125,-30.36242,0.141,NULL,46900919899,732826873,11450419,14.37),(109284,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109284,28.41,0.1,4.81,46863,NULL,NULL,NULL,'IC 4247',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109285,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109285,28.48,NULL,4.97,46863,NULL,NULL,NULL,'IC 4247',NULL,'2007AJ....133..504K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109286,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109286,28.54,0.04,5.11,46863,NULL,NULL,'I','IC 4247',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109287,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109287,28.57,0.1,5.18,46863,74.4,NULL,NULL,'IC 4247',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109288,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109288,34.39,0.49,75.3,46864,75,NULL,'IR','MCG -02-34-051',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.000033,NULL,'14.24',0.3,'Sd? sp',NULL,NULL,NULL,NULL,1,201.686375,-11.21297,0.049,NULL,43870232041,685472375,10710505,14.24),(109289,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109289,34.51,0.41,79.8,46864,NULL,NULL,'Malmquist cor.','MCG -02-34-051',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109290,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109290,34.62,0.39,84.1,46864,NULL,NULL,NULL,'MCG -02-34-051',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109291,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109291,34.66,0.2,85.5,46864,74.4,NULL,NULL,'MCG -02-34-051',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109292,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109292,34.85,0.4,93.1,46864,NULL,NULL,'mean','MCG -02-34-051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109293,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109293,34.96,0.47,98.3,46864,NULL,NULL,'H','MCG -02-34-051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109294,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109294,35.81,0.66,145,46865,70,NULL,NULL,'2MASX J13264523-2730258',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000067,NULL,'16',NULL,'SBa','Group member',NULL,NULL,NULL,1,201.688333,-27.50731,0.157,NULL,43296854142,676513345,10570521,16),(109295,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109295,37.2,0.46,276,46866,70,NULL,NULL,'2MASX J13264568-0105093',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000086,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,201.6904583,-1.08594,0.033,NULL,43822501930,684726592,10698853,16.7),(109296,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109296,37.59,0.46,330,46867,70,NULL,NULL,'2MASX J13264578+4439331',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000192,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,201.6907917,44.65908,0,NULL,59309791156,926715486,14479929,16.6),(109297,'Cepheids','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109297,13.49,0.01,0.005,46868,NULL,NULL,'true ','omega Cen',NULL,'2011JAVSO..39..122M',2011,1,NULL,NULL,'*Cl',NULL,NULL,NULL,NULL,'Globular',NULL,NULL,NULL,NULL,1,201.6912083,-47.47686,0.557,0,46959367715,733740120,11464689,NULL),(109298,'CMD','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109298,13.43,0.09,0.0049,46868,NULL,NULL,'true, E(B-V) = 0.08, syst. 200 kpc','omega Cen',NULL,'2009MNRAS.394..831M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109299,'CMD','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109299,13.57,NULL,0.0052,46868,NULL,NULL,'true, E(B-V) = 0.15','omega Cen',NULL,'1998ApJ...495..284W',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109300,'CMD','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109300,14.3,0.1,0.0061,46868,NULL,NULL,'apparent m-M, D assumes A(V) = 0.37 = 0.12 E(B-V) x 3.1 R(V)','omega Cen',NULL,'1983PASP...95..979R',1983,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109301,'CMD','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109301,13.96,0.18,0.0062,46868,NULL,NULL,'true, E(B-V) = 0.11','omega Cen',NULL,'1991MNRAS.250..314N',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109302,'CMD','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109302,13.97,NULL,0.0062,46868,NULL,NULL,'true, E(B-V) = 0.11','omega Cen',NULL,'1998ApJ...495..284W',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109303,'Delta Scuti','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109303,14.02,NULL,0.0054,46868,NULL,NULL,'apparent D = 6370 pc, true D assumes A(V) = 0.37 = 0.12 E(B-V) x 3.1 R(V)','omega Cen',NULL,'2000PASP..112.1096M',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109304,'Horizontal Branch','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109304,13.83,NULL,0.0049,46868,NULL,NULL,'apparent m-M, D assumes A(V) = 0.37 = 0.12 E(B-V) x 3.1 R(V)','omega Cen',NULL,'1996AJ....111.1913S',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109305,'Horizontal Branch','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109305,13.62,NULL,0.0053,46868,NULL,NULL,NULL,'omega Cen',NULL,'2006MNRAS.370.1979M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109306,'Horizontal Branch','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109306,14,NULL,0.0053,46868,NULL,NULL,'apparent m-M, D assumes A(V) = 0.37 = 0.12 E(B-V) x 3.1 R(V)','omega Cen',NULL,'1986MmSAI..57..361T',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109307,'RR Lyrae','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109307,13.56,0.09,0.0052,46868,NULL,NULL,'true, 10','omega Cen',NULL,'2015A&A...574A..15F',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109308,'RR Lyrae','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109308,13.58,0.14,0.0052,46868,NULL,NULL,'true ','omega Cen',NULL,'2010JAVSO..38..100M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109309,'RR Lyrae','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109309,13.62,0.05,0.0053,46868,NULL,NULL,'true, 0.16 E(B-V) x 3.1 R(V)','omega Cen',NULL,'2011AJ....142..110M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109310,'RR Lyrae','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109310,14.01,0.11,0.0053,46868,NULL,NULL,'apparent m-M, D assumes A(V) = 0.37 = 0.12 E(B-V) x 3.1 R(V), V, RRb','omega Cen',NULL,'2002ASPC..265..185C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109311,'RR Lyrae','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109311,13.68,0.1,0.0054,46868,NULL,NULL,'true 1','omega Cen',NULL,'2007A&A...476..779B',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109312,'RR Lyrae','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109312,13.68,0.27,0.0054,46868,NULL,NULL,'true ','omega Cen',NULL,'2007AJ....133.1447W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109313,'RR Lyrae','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109313,13.7,0.06,0.0055,46868,NULL,NULL,'true, 114, JK, syst. 0.06 mag','omega Cen',NULL,'2006ApJ...652..362D',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109314,'RR Lyrae','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109314,13.7,0.1,0.0055,46868,NULL,NULL,'true, 128, E(B-V)=0.11','omega Cen',NULL,'2006MmSAI..77..245C',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109315,'RR Lyrae','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109315,13.71,0.05,0.0055,46868,NULL,NULL,'true, 181, JK','omega Cen',NULL,'2006MmSAI..77..330D',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109316,'RR Lyrae','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109316,14.08,0.11,0.0055,46868,NULL,NULL,'apparent m-M, D assumes A(V) = 0.37 = 0.12 E(B-V) x 3.1 R(V), V, RRc','omega Cen',NULL,'2002ASPC..265..185C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109317,'RR Lyrae','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109317,13.73,0.07,0.0056,46868,NULL,NULL,'true, E(B-V) = 0.12','omega Cen',NULL,'2000AcA....50..249M',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109318,'RR Lyrae','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109318,13.75,0.11,0.0056,46868,NULL,NULL,'true, Sollima et al. 2008','omega Cen',NULL,'2008ApJ...686L..87B',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109319,'RR Lyrae','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109319,13.76,0.34,0.0057,46868,NULL,NULL,'true ','omega Cen',NULL,'2013MmSAI..84..265F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109320,'RR Lyrae','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109320,13.77,NULL,0.0057,46868,NULL,NULL,'true, E(B-V) = 0.11','omega Cen',NULL,'1984Ap&SS.103..207S',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109321,'RR Lyrae','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109321,14.15,0.04,0.0057,46868,NULL,NULL,'apparent m-M, D assumes A(V) = 0.37 = 0.12 E(B-V) x 3.1 R(V), V. mean of 2','omega Cen',NULL,'2002MNRAS.336..276D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109322,'RR Lyrae','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109322,13.78,0.04,0.0057,46868,NULL,NULL,'true, K','omega Cen',NULL,'2014RMxAC..44..161N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109323,'RR Lyrae','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109323,13.8,0.1,0.0058,46868,NULL,NULL,'true 2','omega Cen',NULL,'2007A&A...476..779B',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109324,'RR Lyrae','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109324,13.88,NULL,0.006,46868,NULL,NULL,'true ','omega Cen',NULL,'2002ASPC..265..163K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109325,'SX Phe Stars','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109325,13.7,0.3,0.0055,46868,NULL,NULL,'true, B-V','omega Cen',NULL,'2002IAUS..207..138F',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109326,'SX Phe Stars','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109326,13.75,0.18,0.0056,46868,NULL,NULL,'true, V-I','omega Cen',NULL,'2002IAUS..207..138F',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109327,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109327,13.65,0.09,0.0054,46868,NULL,NULL,'true, I, Lee et al. 1993','omega Cen',NULL,'2008ApJ...686L..87B',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109328,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109328,13.7,0.11,0.0055,46868,NULL,NULL,'true, MTRGB = _4.05 mag','omega Cen',NULL,'2004A&A...424..199B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109329,'Type II Cepheids','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109329,13.67,0.07,0.0054,46868,NULL,NULL,'true ','omega Cen',NULL,'2014RMxAC..44..161N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109330,'Statistical','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109330,13.58,NULL,0.0052,46868,NULL,NULL,'true (2010 edition)','omega Cen',NULL,'1996AJ....112.1487H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109331,'Eclipsing Binary','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109331,13.8,0.1,0.0049,46868,NULL,NULL,'apparent m-M, D assumes A(V) = 0.37 = 0.12 E(B-V) x 3.1 R(V), NJL 5','omega Cen',NULL,'1993A&A...270..297H',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109332,'Eclipsing Binary','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109332,13.5,0.13,0.005,46868,NULL,NULL,'true, E(B-V) = 0.131, mean of 2 EB, \'apparent distance moduli\'','omega Cen',NULL,'2007AJ....133.2457K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109333,'Eclipsing Binary','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109333,13.6,NULL,0.0052,46868,NULL,NULL,'true, E(B-V)=0.11, R(V) = 3.0','omega Cen',NULL,'2011BASI...39..247K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109334,'Eclipsing Binary','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109334,14.05,0.11,0.0054,46868,NULL,NULL,'true, D = 5360 pc = m-M = 13.65, OGLEGC 17','omega Cen',NULL,'2001AJ....121.3089T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109335,'Eclipsing Binary','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109335,14.05,NULL,0.0054,46868,NULL,NULL,'apparent m-M, D assumes A(V) = 0.37 = 0.12 E(B-V) x 3.1 R(V), NJL 5','omega Cen',NULL,'2012ApJ...755...83L',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109336,'Eclipsing Binary','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109336,13.69,NULL,0.0055,46868,NULL,NULL,'true, E(B-V) = 0.09','omega Cen',NULL,'2002ASPC..265..163K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109337,'Eclipsing Binary','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109337,14.09,0.04,0.0055,46868,NULL,NULL,'apparent m-M, D assumes A(V) = 0.37 = 0.12 E(B-V) x 3.1 R(V)','omega Cen',NULL,'2002ASPC..265..155K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109338,'Proper Motion','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109338,13.27,NULL,0.0045,46868,NULL,NULL,'true ','omega Cen',NULL,'2000A&A...360..472V',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109339,'Proper Motion','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109339,13.31,0.04,0.0046,46868,NULL,NULL,'true ','omega Cen',NULL,'2013MNRAS.436.2598W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109340,'Black Hole','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109340,13.37,0.03,0.0047,46868,NULL,NULL,'true ','omega Cen',NULL,'2010ApJ...710.1063V',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109341,'Mass Model','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109341,13.07,0.04,0.0041,46868,NULL,NULL,'true ','omega Cen',NULL,'2013ApJ...772...67B',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109342,'Mass Model','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109342,13.75,0.13,0.0048,46868,NULL,NULL,'true, D = 4800 kpc = m-M = 13.41 mag','omega Cen',NULL,'2006A&A...445..513V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109343,'Mass Model','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109343,13.41,0.13,0.0048,46868,NULL,NULL,'true ','omega Cen',NULL,'2008ApJ...686L..87B',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109344,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109344,37.72,0.33,350,46869,70,NULL,NULL,'2MASX J13264625+3854253',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,201.692667,38.90706,0,NULL,59298635589,926541181,14477205,17.6),(109345,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109345,36.19,0.57,173,46870,70,NULL,NULL,'2MASX J13264647-2707078',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00009,NULL,'15.0V',NULL,'E','Group member',NULL,NULL,NULL,1,201.6937083,-27.11903,0.245,NULL,43296469747,676507339,10570427,15),(109346,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109346,37.29,0.33,287,46871,70,NULL,NULL,'2MASX J13264669+4124303',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000148,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,201.694667,41.40858,0,NULL,59322229909,926909842,14482966,17.1),(109347,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109347,34.75,0.47,89.2,46872,70,NULL,NULL,'ESO 576- G 060',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000137,NULL,'15.09',0.4,'S0-a',NULL,NULL,NULL,NULL,1,201.6952083,-21.04308,0.269,NULL,43818539958,684664686,10697885,15.09),(109348,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109348,38.58,0.46,520,46873,70,NULL,NULL,'2MASX J13264694+2641133',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000144,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,201.6957083,26.687,NULL,NULL,58666453380,916663334,14322864,18.4),(109349,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109349,37.99,0.46,397,46874,70,NULL,NULL,'2MASXi J1326475+281602',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000154,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,201.697875,28.26739,NULL,NULL,58661289337,916582645,14321603,18.1),(109350,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109350,35.8,0.18,145,46875,70,NULL,'ABELL 1736, BGC','ESO 509- G 009',NULL,'1999AJ....118.1489D',1999,1,0.9,NULL,'G',0.00015,NULL,'13.4V',0.8,'cD;S0?','Group member, 2nd ranked galaxy',NULL,NULL,NULL,1,201.702875,-27.14375,0.245,NULL,43296469231,676507331,10570427,13.4),(109351,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109351,37.44,0.46,308,46876,70,NULL,NULL,'2MASX J13264927+1649478',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.30',0.27,NULL,NULL,NULL,NULL,NULL,1,201.705458333,16.83,0,NULL,58832486236,919257597,14363399,17.3),(109352,'IRAS','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109352,32.29,0.8,28.8,46877,75,NULL,'HMCL, I','ESO 382- G 067',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000053,NULL,'15',0.8,'Sa             HII?',NULL,NULL,NULL,NULL,1,201.7057917,-36.75672,0.213,NULL,46866595777,732290559,11442039,15),(109353,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109353,32.93,0.4,38.5,46877,NULL,NULL,NULL,'ESO 382- G 067',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109354,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109354,33.11,0.4,41.8,46877,75,NULL,'HMCL, I, raw','ESO 382- G 067',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109355,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109355,33.19,0.4,43.4,46877,75,NULL,'HMCL, I, inv','ESO 382- G 067',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109356,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109356,33.35,0.4,46.8,46877,75,NULL,'HMCL, I, cor','ESO 382- G 067',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109357,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109357,35.69,0.39,137,46878,NULL,NULL,'Malmquist cor.','2MFGC 10795',NULL,'2009ApJS..182..474S',2009,1,0.62,NULL,'G',0.000037,NULL,'14.1R',0.12,'Sbc            Sbrst','Group member',NULL,NULL,NULL,1,201.7074583,-31.39569,0.181,NULL,46901004844,732828200,11450440,14.1),(109358,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109358,35.78,0.38,144,46878,NULL,NULL,NULL,'2MFGC 10795',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109359,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109359,35.82,0.2,146,46878,74.4,NULL,NULL,'2MFGC 10795',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109360,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109360,36.15,0.46,170,46879,70,NULL,NULL,'SDSS J132649.92+214322.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.1g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,201.7080417,21.72289,0.041,NULL,58849193058,919518641,14367478,17.1),(109361,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109361,38.01,0.33,400,46880,70,NULL,NULL,'2MASX J13265147+4725281',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,201.714417,47.4245,0,NULL,59290673065,926416766,14475261,17.1),(109362,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109362,37.29,0.33,287,46881,70,NULL,NULL,'2MASX J13265202+4125383',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,201.716667,41.42742,0,NULL,59323095896,926923373,14483177,18),(109363,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109363,36.46,0.17,196,46882,70,NULL,NULL,'ABELL 1736b',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,201.717333,-27.10931,0.245,NULL,43296472714,676507386,10570427,NULL),(109364,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109364,37.16,0.46,270,46883,70,NULL,NULL,'SDSS J132652.67+444638.6',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000145,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,201.719458333,44.77739,0,NULL,59309788128,926715439,14479928,18.3),(109365,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109365,37.99,0.46,395,46884,70,NULL,NULL,'SDSS J132653.45+021335.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000143,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,201.7227083,2.22653,0.01,NULL,58924895959,920701499,14385960,18.3),(109366,'IRAS','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109366,34.25,0.8,70.8,46885,75,NULL,'A82, H','UGC 08451',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000027,NULL,'14.44',0.9,'SAc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,201.7247083,32.19319,0,NULL,59162283922,924410686,14443916,14.44),(109367,'IRAS','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109367,34.28,0.8,71.8,46885,75,NULL,'CF, r','UGC 08451',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109368,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109368,34.31,0.33,72.7,46885,91,NULL,'H','UGC 08451',NULL,'1984ApJ...278..475B',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109369,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109369,34.42,0.4,76.7,46885,NULL,NULL,'mean','UGC 08451',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109370,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109370,34.52,0.38,80.2,46885,75,NULL,'CF, r, raw','UGC 08451',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109371,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109371,34.67,0.38,86,46885,75,NULL,'CF, r, inv','UGC 08451',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109372,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109372,34.71,0.2,87.5,46885,74.4,NULL,NULL,'UGC 08451',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109373,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109373,34.73,0.47,88.1,46885,75,NULL,'A82, H, raw','UGC 08451',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109374,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109374,34.81,0.39,91.6,46885,NULL,NULL,NULL,'UGC 08451',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109375,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109375,34.82,0.38,92,46885,75,NULL,'CF, r, cor','UGC 08451',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109376,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109376,34.84,0.47,92.7,46885,NULL,NULL,'H','UGC 08451',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109377,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109377,34.85,0.38,93.1,46885,NULL,NULL,'Malmquist cor.','UGC 08451',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109378,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109378,34.88,0.47,94.7,46885,75,NULL,'A82, H, inv','UGC 08451',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109379,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109379,35.12,0.47,106,46885,75,NULL,'A82, H, cor','UGC 08451',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109380,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109380,38.43,0.33,485,46886,70,NULL,NULL,'SDSS J132653.95+524928.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,201.724833,52.8245,0.006,NULL,57278241513,894972523,13983945,18.6),(109381,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109381,36.43,0.4,193,46887,NULL,NULL,'Malmquist cor.','2MASX J13265397-3118388',NULL,'2009ApJS..182..474S',2009,1,0.31,NULL,'G',0.000033,NULL,'17.3V',0.06,'Sc','Group member',NULL,NULL,NULL,1,201.7250417,-31.31097,0.181,NULL,46901183761,732830996,11450484,17.3),(109382,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109382,36.45,0.4,195,46887,NULL,NULL,NULL,'2MASX J13265397-3118388',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109383,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109383,36.49,0.2,199,46887,74.4,NULL,NULL,'2MASX J13265397-3118388',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109384,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109384,35.8,0.18,145,46888,70,NULL,NULL,'ABELL 1736',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,201.725,-27.18333,0.245,NULL,43296476300,676507442,10570428,NULL),(109385,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109385,37.92,0.46,384,46889,70,NULL,NULL,'2MASX J13265410+1404028',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000127,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,201.7254583,14.06736,0.02,NULL,59006972540,921983945,14405999,18.1),(109386,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109386,37.66,0.21,340,46890,70,NULL,NULL,'2MASX J13265433+1737188',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,201.726333,17.62197,0,NULL,58832402275,919256285,14363379,17.7),(109387,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109387,36.65,0.66,214,46891,70,NULL,NULL,'2MASX J13265450-3158138',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.93',0.42,NULL,'Group member',NULL,NULL,NULL,1,201.727,-31.97044,0.161,NULL,46869526835,732336356,11442755,16.93),(109388,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109388,37.13,0.33,267,46892,70,NULL,NULL,'SDSS J132655.09+131015.9',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.5g',0.28,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,201.729583,13.17111,0.008,NULL,59008137000,922002140,14406283,16.5),(109389,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109389,36.16,0.67,171,46893,70,NULL,NULL,'2MASX J13265560-2442448',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,201.7317083,-24.71247,0.249,NULL,43291847210,676435112,10569298,15.6),(109390,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109390,36.83,0.25,232,46894,74.4,NULL,NULL,'2MASX J13265599-3124468',NULL,'2013AJ....146...86T',2013,1,0.44,NULL,'G',0.00011,NULL,'15.8V',0.26,'E/S0','Group member',NULL,NULL,NULL,1,201.733125,-31.41311,0.181,NULL,46901015908,732828373,11450443,15.8),(109391,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109391,35.41,0.25,121,46895,74.4,NULL,NULL,'2MASX J13265599-3125269',NULL,'2013AJ....146...86T',2013,1,0.45,NULL,'G',0.000067,NULL,'16.0V',0.36,'S0','Group member',NULL,NULL,NULL,1,201.733416667,-31.42431,0.181,NULL,46901017774,732828402,11450443,16),(109392,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109392,37.55,0.27,324,46896,70,NULL,NULL,'2MASX J13265655+2308480',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,201.7355417,23.14678,0.029,NULL,58795523897,918680060,14354375,17.9),(109393,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109393,35.37,0.46,119,46897,70,NULL,NULL,'CGCG 246-001',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.00006,NULL,'15.1g',0.61,'E',NULL,NULL,NULL,NULL,1,201.736708333,44.82108,0,NULL,59309573846,926712091,14479876,15.1),(109394,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109394,37.51,0.14,317,46898,70,NULL,NULL,'2MASX J13265701+0111549',NULL,'2015arXiv151105856S',2015,1,0.29,'Hewitt et al (2001AJ....122..518H) have z = 0.067.','G',0.000101,NULL,'17.1g',0.28,'NLAGN',NULL,NULL,NULL,NULL,1,201.7374583,1.19847,0.025,NULL,58922309410,920661084,14385329,17.1),(109395,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109395,38.01,0.33,400,46899,70,NULL,NULL,'2MASX J13265757+4725211',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,201.7400417,47.42239,0,NULL,59290672603,926416759,14475261,18.4),(109396,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109396,37.77,0.46,358,46900,70,NULL,NULL,'2MASX J13265883+5445445',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,201.7454583,54.76231,0,NULL,57291053850,895172716,13987073,17.3),(109397,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109397,37.66,0.21,340,46901,70,NULL,NULL,'SDSS J132700.64+173144.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,201.7527083,17.52897,0,NULL,58832277720,919254339,14363349,18.2),(109398,'IRAS','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109398,31.73,0.8,22.2,46902,75,NULL,'HMCL, I','UGCA 358',NULL,'1997ApJS..109..333W',1997,1,1.7,'Eccentric nucleus.','G',0.000017,NULL,'14.82',1.1,'SB(s)dm:',NULL,NULL,NULL,NULL,1,201.7537083,-30.07639,0.249,NULL,46900870560,732826102,11450407,14.82),(109399,'Tully est','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109399,32.2,0.8,27.5,46902,75,NULL,NULL,'UGCA 358',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109400,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109400,32.52,0.2,31.9,46902,74.4,NULL,NULL,'UGCA 358',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109401,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109401,32.58,0.4,32.8,46902,NULL,NULL,NULL,'UGCA 358',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109402,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109402,32.62,0.43,33.4,46902,75,NULL,'3.6 micron, color corrected','UGCA 358',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109403,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109403,32.65,0.43,34,46902,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 358',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109404,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109404,33.01,0.4,40.1,46902,75,NULL,'HMCL, I, inv','UGCA 358',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109405,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109405,33.03,0.4,40.3,46902,75,NULL,'HMCL, I, raw','UGCA 358',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109406,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109406,33.31,0.4,45.9,46902,75,NULL,'HMCL, I, cor','UGCA 358',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109407,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109407,37.79,0.46,361,46903,70,NULL,NULL,'2MASX J13270159+1906440',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,201.756625,19.11222,0.012,NULL,58853397857,919584341,14368505,NULL),(109408,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109408,37.43,0.46,306,46904,70,NULL,NULL,'VII Zw 515',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,201.7582917,61.12983,0,NULL,57393311819,896770497,14012039,17.5),(109409,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109409,35.24,0.25,112,46905,74.4,NULL,NULL,'2MASX J13270274-2726069',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000014,NULL,'15.4V',0.4,'S0','Group member',NULL,NULL,NULL,1,201.76125,-27.4355,0.157,NULL,43296864364,676513505,10570523,15.4),(109410,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109410,35.68,0.53,137,46905,70,NULL,NULL,'2MASX J13270274-2726069',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109411,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109411,37.95,0.46,389,46906,70,NULL,NULL,'SDSS J132703.60+071835.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00013,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,201.7650417,7.30997,0,NULL,58984207822,921628247,14400441,18.4),(109412,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109412,37.51,0.14,317,46907,70,NULL,NULL,'2MASX J13270375+0120089',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000213,NULL,'16.38',0.31,'BrClG',NULL,NULL,NULL,NULL,1,201.765625,1.33572,0.025,NULL,58922289868,920660779,14385324,16.38),(109413,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109413,38.01,0.46,400,46908,70,NULL,NULL,'2MASX J13270420+3829283',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000168,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,201.767667,38.49125,0,NULL,59298834556,926544289,14477254,16.8),(109414,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109414,36.58,0.25,207,46909,74.4,NULL,NULL,'2MASX J13270435-3120079',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000087,NULL,'16.0V',0.28,NULL,'Group member',NULL,NULL,NULL,1,201.7680417,-31.33561,0.181,NULL,46901197733,732831214,11450487,16),(109415,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109415,37.66,0.21,340,46910,70,NULL,NULL,'2MASX J13270454+1729298',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.66',0.21,NULL,NULL,NULL,NULL,NULL,1,201.768917,17.49164,0,NULL,58832306561,919254790,14363356,18.66),(109416,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109416,37.17,0.46,272,46911,70,NULL,NULL,'2MASX J13270461-0029403',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000086,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,201.76925,-0.49456,0.025,NULL,43084774947,673199608,10518743,16.8),(109417,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109417,36.54,0.46,203,46912,70,NULL,NULL,'2MASX J13270468+2445264',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00011,NULL,'16.17',0.27,NULL,NULL,NULL,NULL,NULL,1,201.769417,24.75742,0.023,NULL,58663253937,916613342,14322083,16.17),(109418,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109418,36.46,0.17,196,46913,70,NULL,'ABELL 1736b, BGC','ESO 509- G 012',NULL,'1999AJ....118.1489D',1999,1,0.9,NULL,'G',0.00008,NULL,'13.9V',0.8,'S0','Group member',NULL,NULL,NULL,1,201.770125,-26.99344,0.197,NULL,43296243827,676503809,10570372,13.9),(109419,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109419,37.73,0.46,352,46914,70,NULL,NULL,'LCRS B132429.7-031921',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000131,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,201.770375,-3.58158,0.057,NULL,43836571583,684946430,10702287,17.3),(109420,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109420,37.67,0.46,342,46915,70,NULL,NULL,'2MASX J13270559+4107163',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000173,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,201.77325,41.12144,0,NULL,59322216059,926909625,14482962,16.5),(109421,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109421,36.58,0.46,207,46916,70,NULL,NULL,'2MASX J13270567+3151295',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000157,NULL,'16.7g',0.29,'E1',NULL,NULL,NULL,NULL,1,201.7737917,31.85814,0.024,NULL,59162231625,924409869,14443904,16.7),(109422,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109422,35.42,0.48,121,46917,70,NULL,NULL,'II SZ 049',NULL,'2014MNRAS.445.2677S',2014,1,0.6,'1978ApJ...225..768R has V = 4300 +- 200 km/s.','G',0.00015,NULL,'15.2',0.5,'E2',NULL,NULL,NULL,NULL,1,201.7769583,-11.57961,0.049,NULL,43857891750,685279558,10707493,15.2),(109423,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109423,36.3,0.46,182,46918,70,NULL,NULL,'2MASX J13270655+4902579',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000174,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,201.777417,49.04928,0,NULL,59276749683,926199213,14471862,16.4),(109424,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109424,36.41,0.6,192,46919,70,NULL,NULL,'2MASX J13270660-3151399',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'16.5b',0.5,'E','Group member',NULL,NULL,NULL,1,201.777583,-31.86108,0.169,NULL,46869513145,732336142,11442752,16.5),(109425,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109425,37.12,0.46,266,46920,70,NULL,NULL,'2MASX J13270659+5832006',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00021,NULL,'16.1g',0.32,NULL,NULL,NULL,NULL,NULL,1,201.777625,58.53342,0,NULL,57389981130,896718455,14011225,16.1),(109426,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109426,36.02,0.46,160,46921,70,NULL,NULL,'2MASX J13270765+5327489',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000072,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,201.7817917,53.46356,0,NULL,57281077981,895016843,13984638,16.5),(109427,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109427,37.66,0.46,340,46922,70,NULL,NULL,'2MASX J13270872+1359232',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,201.7862917,13.98986,0.015,NULL,59006953570,921983649,14405994,17.7),(109428,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109428,36.05,0.25,162,46923,74.4,NULL,NULL,'2MASX J13270950-3138199',NULL,'2013AJ....146...86T',2013,1,0.77,NULL,'G',0.000093,NULL,'14.5V',0.61,'S0','Group member',NULL,NULL,NULL,1,201.789666667,-31.63903,0.169,NULL,46900980377,732827818,11450434,14.5),(109429,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109429,36.21,0.63,175,46923,70,NULL,NULL,'2MASX J13270950-3138199',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109430,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109430,37.51,0.14,317,46924,70,NULL,NULL,'SDSS J132709.60+011745.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000171,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,201.790041667,1.29594,0.025,NULL,58922288926,920660764,14385324,17.9),(109431,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109431,35.03,0.65,101,46925,NULL,NULL,NULL,'ESO 444- G 040',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.14',0.3,'Sb:',NULL,NULL,NULL,NULL,1,201.801667,-28.73861,0.233,NULL,43294068240,676469816,10569840,16.14),(109432,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109432,35.07,0.2,103,46925,74.4,NULL,NULL,'ESO 444- G 040',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109433,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109433,35.11,0.63,105,46925,NULL,NULL,'Malmquist cor.','ESO 444- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109434,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109434,36.8,0.33,229,46926,70,NULL,NULL,'2MASX J13271359+0759577',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.11',0.18,NULL,NULL,NULL,NULL,NULL,1,201.806708333,7.99933,0,NULL,58949259813,921082184,14391909,17.11),(109435,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109435,37.28,0.46,286,46927,70,NULL,NULL,'2MASX J13271427-0229507',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000166,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,201.809375,-2.49747,0.049,NULL,43825346707,684771042,10699547,17.7),(109436,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109436,36.16,0.46,171,46928,70,NULL,NULL,'2MASX J13271440+3347105',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000077,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,201.810083,33.78611,0,NULL,59169200858,924518763,14445605,16.2),(109437,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109437,37.71,0.21,348,46929,70,NULL,NULL,'LCRS B132440.0-022303',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,201.811833,-2.64342,0.049,NULL,43824938161,684764658,10699447,17.1),(109438,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109438,37.84,0.46,369,46930,70,NULL,NULL,'2MASX J13271552+2553504',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,201.814625,25.89744,0.038,NULL,58666015545,916656492,14322757,17.4),(109439,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109439,35.16,0.4,108,46931,NULL,NULL,'mean','NGC 5157',NULL,'2007A&A...465...71T',2007,1,1.45,NULL,'G',0.000087,NULL,'13.8g',1.07,'SAB(r)a','Group member',NULL,NULL,NULL,1,201.820208333,32.03072,0.024,NULL,59162238966,924409983,14443905,13.8),(109440,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109440,35.95,0.47,155,46931,NULL,NULL,'H','NGC 5157',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109441,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109441,35.96,0.45,155,46931,NULL,NULL,'K','NGC 5157',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109442,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109442,36,0.46,159,46931,NULL,NULL,'J','NGC 5157',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109443,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109443,37.88,0.33,377,46932,70,NULL,NULL,'2MASX J13271763+1226312',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000164,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,201.8235417,12.44222,0,NULL,59008561295,922008770,14406387,16.8),(109444,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109444,37.51,0.14,317,46933,70,NULL,NULL,'2MASX J13271898+0118294',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,201.829041667,1.30822,0.025,NULL,58922301825,920660966,14385327,17.6),(109445,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109445,37.14,0.46,268,46934,70,NULL,NULL,'2MASX J13271893+4658368',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000192,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,201.829041667,46.97703,0,NULL,59290426618,926412915,14475201,16.7),(109446,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109446,37.87,0.46,375,46935,70,NULL,NULL,'2MASXi J1327190+361201',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,201.829208333,36.20047,0,NULL,59168891066,924513922,14445530,17.7),(109447,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109447,37.51,0.46,318,46936,70,NULL,NULL,'2MASX J13272099+5227179',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,201.83775,52.45497,0.012,NULL,57277813513,894965836,13983841,17.2),(109448,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109448,37.84,0.46,371,46937,70,NULL,NULL,'SDSS J132721.22+314104.5',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,201.838416667,31.68461,0.029,NULL,59177975491,924655867,14447747,17.8),(109449,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109449,38.93,0.46,612,46938,70,NULL,NULL,'2MASX J13272134+4423208',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000179,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,201.8387917,44.38911,0,NULL,59309707568,926714180,14479909,17.7),(109450,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109450,37.13,0.33,267,46939,70,NULL,NULL,'SDSS J132721.77+130759.6',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',NULL,NULL,'15.7g',0.39,'E0',NULL,NULL,NULL,NULL,1,201.84075,13.13325,0,NULL,59008237572,922003712,14406308,15.7),(109451,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109451,36.58,0.46,207,46940,70,NULL,NULL,'2MASX J13272199-0100307',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000104,NULL,'15.7g',0.33,'S0',NULL,NULL,NULL,NULL,1,201.841541667,-1.00867,0.033,NULL,43822529019,684727015,10698859,15.7),(109452,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109452,37.71,0.21,348,46941,70,NULL,NULL,'LCRS B132447.2-023241',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00015,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,201.8420417,-2.80386,0.069,NULL,43824949831,684764841,10699450,16.8),(109453,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109453,35.98,0.59,157,46942,70,NULL,NULL,'2MASX J13272247-2523458',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000107,NULL,'13.0I',0.8,NULL,NULL,NULL,NULL,NULL,1,201.843583333,-25.39606,0.265,NULL,43292042067,676438157,10569346,13),(109454,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109454,35.29,0.89,115,46943,NULL,NULL,NULL,'2MASX J13272267-2703298',NULL,'2009ApJS..182..474S',2009,1,0.48,NULL,'G',0.000033,NULL,'16.3V',0.24,'S','Group member',NULL,NULL,NULL,1,201.844417,-27.05839,0.197,NULL,43296259345,676504052,10570375,16.3),(109455,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109455,35.33,0.2,116,46943,74.4,NULL,NULL,'2MASX J13272267-2703298',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109456,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109456,35.53,0.8,128,46943,NULL,NULL,'Malmquist cor.','2MASX J13272267-2703298',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109457,'IRAS','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109457,34.69,0.8,86.9,46944,75,NULL,'HMCL, I','CGCG 072-077',NULL,'1997ApJS..109..333W',1997,1,1.07,NULL,'G',0.000027,NULL,'15.4g',0.27,'Sbc',NULL,NULL,NULL,NULL,1,201.844375,12.35467,0.014,NULL,59008526185,922008221,14406378,15.4),(109458,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109458,34.68,0.4,86.2,46944,75,NULL,'HMCL, I, raw','CGCG 072-077',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109459,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109459,34.82,0.4,92.2,46944,75,NULL,'HMCL, I, inv','CGCG 072-077',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109460,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109460,34.83,0.49,92.6,46944,75,NULL,'IR','CGCG 072-077',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109461,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109461,34.95,0.4,97.9,46944,75,NULL,'HMCL, I, cor','CGCG 072-077',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109462,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109462,37.51,0.14,317,46945,70,NULL,NULL,'2MASX J13272298+0115594',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000153,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,201.845875,1.26656,0.025,NULL,58922275960,920660561,14385321,16.6),(109463,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109463,35.07,0.5,103,46946,70,NULL,NULL,'2MASX J13272322-2745028',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15',0.4,'S0','Group member',NULL,NULL,NULL,1,201.8467917,-27.75075,0.157,NULL,43297704911,676526639,10570728,15),(109464,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109464,37.16,0.17,271,46947,70,NULL,NULL,'2MASX J13272417+3730026',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,201.8504583,37.50069,0,NULL,59295411556,926490805,14476418,17.2),(109465,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109465,37.71,0.21,348,46948,70,NULL,NULL,'LCRS B132449.4-022452',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00015,NULL,'16.7g',0.26,'BrClG          AGN',NULL,NULL,NULL,NULL,1,201.851125,-2.67336,0.049,NULL,43824933011,684764578,10699446,16.7),(109466,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109466,37.66,0.46,341,46949,70,NULL,NULL,'2MASX J13272454+0507404',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,201.852375,5.12792,0.054,NULL,58929788977,920777952,14387155,17.6),(109467,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109467,35.8,0.25,145,46950,74.4,NULL,NULL,'2MASX J13272470-3140428',NULL,'2013AJ....146...86T',2013,1,0.39,NULL,'G',0.000057,NULL,'16.2V',0.35,'S0','Group member',NULL,NULL,NULL,1,201.8527917,-31.67861,0.169,NULL,46900985114,732827892,11450435,16.2),(109468,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109468,34,0.48,63.1,46951,70,NULL,NULL,'MCG -02-34-053',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000133,NULL,'15',0.3,NULL,NULL,NULL,NULL,NULL,1,201.85325,-11.80928,0.049,NULL,43857855131,685278986,10707484,15),(109469,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109469,38.28,0.46,454,46952,70,NULL,NULL,'SDSS J132726.49+532121.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000155,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,201.860417,53.356,0,NULL,57281029702,895016089,13984626,18.4),(109470,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109470,37.71,0.21,348,46953,70,NULL,NULL,'SDSS J132726.52-023724.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000138,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,201.860541667,-2.62353,0.049,NULL,43824934040,684764594,10699446,18.2),(109471,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109471,37.79,0.46,361,46954,70,NULL,NULL,'2MASX J13272698+0810187',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,201.862375,8.17206,0,NULL,58949308073,921082938,14391920,16.9),(109472,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109472,37.14,0.25,268,46955,74.4,NULL,NULL,'2MASX J13272698-3141066',NULL,'2013AJ....146...86T',2013,1,0.44,NULL,'G',0.00008,NULL,'16.0V',0.44,'E','Group member',NULL,NULL,NULL,1,201.862583,-31.68533,0.169,NULL,46900984069,732827876,11450435,16),(109473,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109473,37.38,0.46,300,46956,70,NULL,NULL,'2MASX J13272720+5154039',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,201.863167,51.90122,0,NULL,59207823933,925122248,14455035,17.8),(109474,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109474,37.57,0.27,326,46957,70,NULL,NULL,'2MASX J13272731+5903546',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000169,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,201.86375,59.06511,0.013,NULL,57390610655,896728291,14011379,17.3),(109475,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109475,35.67,0.46,136,46958,70,NULL,NULL,'2MASX J13272739+0842467',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00008,NULL,'15.53',0.25,NULL,NULL,NULL,NULL,NULL,1,201.8642917,8.71292,0,NULL,58949467284,921085426,14391959,15.53),(109476,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109476,27.89,0.11,3.78,46959,NULL,NULL,NULL,'AM 1324-450',NULL,'2015ApJ...802L..25T',2015,1,0.5,NULL,'G',NULL,NULL,'18.',0.5,'dwarf Irr/Sph',NULL,NULL,NULL,NULL,1,201.865833,-45.35278,0.321,NULL,46953169751,733643277,11463176,18),(109477,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109477,37.74,0.46,353,46960,70,NULL,NULL,'2MASX J13272923+1158122',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000136,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,201.871916667,11.97006,0.035,NULL,58939544512,920930383,14389537,18),(109478,'IRAS','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109478,30.93,0.8,15.4,46961,75,NULL,'MAT, I','ESO 324- G 023',NULL,'1997ApJS..109..333W',1997,1,3.8,NULL,'G',0.00001,NULL,'13.07',0.7,'SB(s)d: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,201.873041667,-38.17764,0.237,NULL,46938117287,733408082,11459501,13.07),(109479,'Tully est','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109479,31.58,0.8,20.7,46961,75,NULL,NULL,'ESO 324- G 023',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109480,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109480,30.11,0.32,10.5,46961,85,NULL,'I, inv','ESO 324- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109481,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109481,30.13,0.32,10.6,46961,85,NULL,'I, raw','ESO 324- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109482,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109482,30.42,0.43,12.1,46961,75,NULL,'MAT, I, inv','ESO 324- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109483,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109483,30.44,0.43,12.2,46961,75,NULL,'MAT, I, raw','ESO 324- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109484,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109484,30.56,0.2,12.9,46961,74.4,NULL,NULL,'ESO 324- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109485,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109485,30.6,0.58,13.2,46961,NULL,NULL,NULL,'ESO 324- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109486,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109486,30.75,0.43,14.1,46961,75,NULL,'MAT, I, cor','ESO 324- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109487,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109487,30.76,0.54,14.2,46961,NULL,NULL,'Malmquist cor.','ESO 324- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109488,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109488,30.77,0.4,14.3,46961,NULL,NULL,NULL,'ESO 324- G 023',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109489,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109489,31.28,0.4,18,46961,73,NULL,'IR','ESO 324- G 023',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109490,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109490,31.28,0.4,18,46961,75,NULL,NULL,'ESO 324- G 023',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109491,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109491,32.69,0.49,34.5,46961,75,NULL,'IR','ESO 324- G 023',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109492,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109492,36.06,0.5,163,46962,70,NULL,NULL,'2MASX J13272961-3123237',NULL,'2014MNRAS.445.2677S',2014,1,1.14,NULL,'G',0.00007,NULL,'13.7V',1.14,'E','Group member',NULL,NULL,NULL,1,201.873417,-31.39025,0.181,NULL,46901186778,732831043,11450485,13.7),(109493,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109493,36.74,0.25,223,46962,74.4,NULL,NULL,'2MASX J13272961-3123237',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109494,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109494,37.55,0.27,324,46963,70,NULL,NULL,'2MASX J13273004+2304043',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,201.875375,23.06775,0.029,NULL,58795736984,918683390,14354427,16.6),(109495,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109495,37.56,0.46,325,46964,70,NULL,NULL,'2MASX J13273045+2610182',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000218,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,201.876916667,26.17169,0.04,NULL,58666120152,916658127,14322783,16.7),(109496,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109496,37.89,0.46,379,46965,70,NULL,NULL,'2MASX J13273048+4000557',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,201.876958333,40.01544,0,NULL,59314203547,926784430,14481006,17.9),(109497,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109497,37.68,0.46,343,46966,70,NULL,NULL,'2MASX J13273053+5357078',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000138,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,201.8772917,53.95242,0,NULL,57280334837,895005231,13984456,17.4),(109498,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109498,34.51,0.49,79.9,46967,75,NULL,'IR','UGC 08457',NULL,'2011yCatp016004901K',2011,1,1.34,NULL,'G',0.000016,NULL,'15.69',0.18,'Sc',NULL,NULL,NULL,NULL,1,201.878125,20.88097,0.03,NULL,58851225133,919550392,14367974,15.69),(109499,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109499,34.74,0.2,88.7,46967,74.4,NULL,NULL,'UGC 08457',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109500,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109500,34.8,0.37,91.4,46967,NULL,NULL,NULL,'UGC 08457',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109501,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109501,34.92,0.35,96.4,46967,NULL,NULL,'Malmquist cor.','UGC 08457',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109502,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109502,34.96,NULL,98,46967,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08457',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109503,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109503,34.98,NULL,99.2,46967,NULL,NULL,'Dipole + Quadrupole','UGC 08457',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109504,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109504,35,NULL,100,46967,NULL,NULL,'Dipole','UGC 08457',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109505,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109505,35,NULL,100,46967,NULL,NULL,NULL,'UGC 08457',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109506,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109506,37.84,0.33,370,46968,70,NULL,NULL,'2MASX J13273109+1250392',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000195,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,201.8795417,12.84433,0,NULL,59008266344,922004161,14406315,16.8),(109507,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109507,34.57,0.47,82,46969,70,NULL,NULL,'II SZ 050',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.0',0.6,'E0',NULL,NULL,NULL,NULL,1,201.88375,-12.49769,0.073,NULL,43991956590,687374321,10740223,15),(109508,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109508,37.24,0.46,280,46970,70,NULL,NULL,'2MASX J13273243+3118272',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000169,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,201.885208333,31.30747,0.026,NULL,59178207030,924659484,14447804,17.7),(109509,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109509,37.51,0.14,317,46971,70,NULL,NULL,'SDSS J132732.83+012741.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000168,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,201.8867917,1.46161,0.027,NULL,58922239855,920659997,14385312,18.4),(109510,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109510,37.78,0.46,359,46972,70,NULL,NULL,'2MASX J13273291+0124204',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,201.887167,1.40564,0.027,NULL,58922254202,920660221,14385315,17.5),(109511,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109511,37.71,0.21,348,46973,70,NULL,NULL,'LCRS B132458.4-021953',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00013,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,201.8885417,-2.59036,0.049,NULL,43824864524,684763508,10699429,17.3),(109512,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109512,37.84,0.33,370,46974,70,NULL,NULL,'2MASX J13273348+1249092',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,201.889416667,12.81931,0,NULL,59008259512,922004054,14406313,18),(109513,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109513,35.93,0.25,153,46975,74.4,NULL,NULL,'2MASX J13273351-3125267',NULL,'2013AJ....146...86T',2013,1,0.38,NULL,'G',0.00017,NULL,'16.6V',0.31,'E','Group member',NULL,NULL,NULL,1,201.889708333,-31.42408,0.181,NULL,46901018795,732828418,11450444,16.6),(109514,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109514,37.72,0.46,350,46976,70,NULL,NULL,'SDSS J132733.59+494013.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,201.8899583,49.67044,0,NULL,59276344099,926192876,14471763,18),(109515,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109515,38.33,0.46,463,46977,70,NULL,NULL,'2MASX J13273390+1453132',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,201.891375,14.88683,0.014,NULL,59006526148,921976971,14405890,17.7),(109516,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109516,37.88,0.33,377,46978,70,NULL,NULL,'2MASX J13273483+1229011',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,201.895083,12.48381,0,NULL,59008612311,922009567,14406399,18.4),(109517,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109517,37.94,0.46,388,46979,70,NULL,NULL,'2MASX J13273483+4114417',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000153,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,201.8952917,41.24475,0,NULL,59323065344,926922896,14483170,18.3),(109518,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109518,36.2,0.25,174,46980,74.4,NULL,NULL,'2MASX J13273498-3132587',NULL,'2013AJ....146...86T',2013,1,0.53,NULL,'G',0.000103,NULL,'15.0V',0.47,'E/S0','Group member',NULL,NULL,NULL,1,201.895667,-31.54978,0.169,NULL,46901032649,732828635,11450447,15),(109519,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109519,35.36,0.49,118,46981,75,NULL,'IR','UGC 08456',NULL,'2011yCatp016004901K',2011,1,1.27,NULL,'G',0.000012,NULL,'16.2g',0.16,'Sc',NULL,NULL,NULL,NULL,1,201.8955,15.18931,0,NULL,58834612884,919290826,14363919,16.2),(109520,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109520,35.37,NULL,119,46981,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08456',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109521,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109521,35.38,NULL,119,46981,NULL,NULL,NULL,'UGC 08456',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109522,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109522,35.38,NULL,119,46981,NULL,NULL,'Dipole + Quadrupole','UGC 08456',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109523,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109523,35.39,NULL,120,46981,NULL,NULL,'Dipole','UGC 08456',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109524,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109524,35.46,0.6,124,46981,NULL,NULL,'Malmquist cor.','UGC 08456',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109525,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109525,35.77,0.52,143,46981,NULL,NULL,NULL,'UGC 08456',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109526,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109526,35.79,0.2,144,46981,74.4,NULL,NULL,'UGC 08456',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109527,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109527,35.73,0.48,140,46982,70,NULL,NULL,'ESO 509- G 016',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000017,NULL,'14.5V',0.4,'S0/E','Group member',NULL,NULL,NULL,1,201.8985417,-27.04292,0.197,NULL,43296254924,676503983,10570374,14.5),(109528,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109528,33.81,0.4,57.8,46983,NULL,NULL,'mean','NGC 5150',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000037,NULL,'12.6',1,'SBbc:          HII?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,201.90225,-29.56225,0.173,NULL,46846348252,731974191,11437096,12.6),(109529,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109529,33.93,0.45,61,46983,NULL,NULL,'K','NGC 5150',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109530,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109530,33.94,0.47,61.4,46983,NULL,NULL,'H','NGC 5150',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109531,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109531,33.98,0.46,62.5,46983,NULL,NULL,'J','NGC 5150',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109532,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109532,27.79,0.1,3.61,46984,NULL,NULL,NULL,'ESO 324- G 024',NULL,'2012A&A...540A..49M',2012,1,3.2,NULL,'G',0.00001,NULL,'12.90',2.3,'IABm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,201.905667,-41.48067,0.393,NULL,46973973813,733968340,11468255,12.9),(109533,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109533,27.84,0.05,3.7,46984,NULL,NULL,'I','ESO 324- G 024',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109534,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109534,27.84,NULL,3.7,46984,NULL,NULL,NULL,'ESO 324- G 024',NULL,'2002A&A...385...21K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109535,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109535,27.89,0.1,3.78,46984,74.4,NULL,NULL,'ESO 324- G 024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109536,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109536,27.89,0.11,3.78,46984,NULL,NULL,NULL,'ESO 324- G 024',NULL,'2015ApJ...802L..25T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109537,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109537,27.91,0.19,3.82,46984,NULL,NULL,NULL,'ESO 324- G 024',NULL,'2015arXiv151205366C',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109538,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109538,28.19,0.2,4.35,46984,NULL,NULL,'S field','ESO 324- G 024',NULL,'2015arXiv151205366C',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109539,'Tully est','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109539,28.3,0.8,4.6,46984,75,NULL,NULL,'ESO 324- G 024',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109540,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109540,35.89,0.25,151,46985,74.4,NULL,NULL,'2MASX J13273913-3132227',NULL,'2013AJ....146...86T',2013,1,0.61,NULL,'G',0.000073,NULL,'14.7V',0.61,'E','Group member',NULL,NULL,NULL,1,201.912833333,-31.53981,0.181,NULL,46901032127,732828626,11450447,14.7),(109541,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109541,37.64,0.27,337,46986,70,NULL,NULL,'2MASX J13274035+1550572',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,201.918333,15.84925,0,NULL,58835144682,919299135,14364048,17.8),(109542,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109542,37.64,0.27,337,46987,70,NULL,NULL,'2MASX J13274049+1548192',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.38',0.15,NULL,NULL,NULL,NULL,NULL,1,201.91875,15.80536,0.025,NULL,58835403545,919303180,14364112,18.38),(109543,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109543,36.96,0.46,246,46988,70,NULL,NULL,'2MASX J13274199+1235592',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000194,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,201.925083333,12.59972,0,NULL,59008373408,922005834,14406341,17),(109544,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109544,37.43,0.46,307,46989,70,NULL,NULL,'2MASX J13274413+4031326',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,201.933875,40.52567,0,NULL,59314739311,926792801,14481137,17.7),(109545,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,NULL,109545,36.39,0.25,190,46990,74.4,NULL,NULL,'2MASX J13274460-3128427',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.00007,NULL,'15.9V',0.32,'E','Group member',NULL,NULL,NULL,1,201.9357083,-31.47858,0.181,NULL,46900991660,732827994,11450437,15.9),(109546,'FP','2016-12-15 15:15:14','2016-12-16 11:20:26','1',NULL,'R',109546,36.02,0.46,160,46991,70,NULL,NULL,'2MASX J13274514+2510452',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000127,NULL,'16.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,201.938083,25.17925,0.027,NULL,58663087261,916610738,14322042,16),(109547,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109547,36.06,0.25,163,46992,74.4,NULL,NULL,'2MASX J13274547-3147507',NULL,'2013AJ....146...86T',2013,1,0.95,NULL,'G',0.0001,NULL,'15.2b',0.57,'*+S0','Group member',NULL,NULL,NULL,1,201.939583,-31.7975,0.169,NULL,46904393666,732881151,11451267,15.2),(109548,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109548,37.87,0.33,374,46993,70,NULL,NULL,'2MASX J13274613+0058046',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000091,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,201.94225,0.96783,0.024,NULL,58922483517,920663804,14385371,17),(109549,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109549,36.61,0.25,210,46994,74.4,NULL,NULL,'2MASX J13274663-3127147',NULL,'2013AJ....146...86T',2013,1,0.51,NULL,'G',0.000067,NULL,'15.3V',0.35,'S0','Group member',NULL,NULL,NULL,1,201.9442917,-31.45436,0.181,NULL,46900994025,732828031,11450437,15.3),(109550,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109550,35.88,0.51,150,46995,NULL,NULL,NULL,'2MASX J13274771-2725488',NULL,'2009ApJS..182..474S',2009,1,0.33,NULL,'G',0.000023,NULL,'15.75',NULL,'S0',NULL,NULL,NULL,NULL,1,201.948667,-27.43036,0.173,NULL,43296986207,676515409,10570553,15.75),(109551,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109551,35.92,0.2,153,46995,74.4,NULL,NULL,'2MASX J13274771-2725488',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109552,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109552,36.09,0.46,165,46995,NULL,NULL,'Malmquist cor.','2MASX J13274771-2725488',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109553,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109553,36.23,0.46,177,46996,NULL,NULL,'Malmquist cor.','2MFGC 10814',NULL,'2009ApJS..182..474S',2009,1,0.46,NULL,'G',0.000027,NULL,'15.4V',0.14,'Sa','Group member',NULL,NULL,NULL,1,201.9495,-31.23333,0.145,NULL,46901228271,732831691,11450495,15.4),(109554,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109554,36.6,0.49,209,46996,75,NULL,'IR','2MFGC 10814',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109555,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109555,36.65,0.38,213,46996,NULL,NULL,NULL,'2MFGC 10814',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109556,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109556,36.69,0.2,218,46996,74.4,NULL,NULL,'2MFGC 10814',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109557,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109557,38.34,0.46,466,46997,70,NULL,NULL,'2MASX J13274845+2433301',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,201.951875,24.55844,0.025,NULL,58663287521,916613867,14322091,17.8),(109558,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109558,36.58,0.25,207,46998,74.4,NULL,NULL,'2MASX J13274851-3128457',NULL,'2013AJ....146...86T',2013,1,0.54,NULL,'G',0.00008,NULL,'15.4V',0.38,'S0','Group member',NULL,NULL,NULL,1,201.952125,-31.47942,0.181,NULL,46900991354,732827989,11450437,15.4),(109559,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109559,37.87,0.33,374,46999,70,NULL,NULL,'SDSS J132749.57+005757.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000136,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,201.956583333,0.96603,0.024,NULL,58922483443,920663803,14385371,18.2),(109560,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109560,37.15,0.46,269,47000,70,NULL,NULL,'2MASX J13275020+4206175',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000145,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,201.959291667,42.10481,0,NULL,59322833814,926919278,14483113,17.1),(109561,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109561,36.76,0.25,225,47001,74.4,NULL,NULL,'2MASX J13275071-3134067',NULL,'2013AJ....146...86T',2013,1,0.42,NULL,'G',0.000057,NULL,'15.4V',0.34,'E/S0','Group member',NULL,NULL,NULL,1,201.961167,-31.56856,0.169,NULL,46900996556,732828071,11450438,15.4),(109562,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109562,37.19,0.46,274,47002,70,NULL,NULL,'2MASX J13275080+0041046',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000076,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,201.96175,0.68456,0.02,NULL,58921727700,920651995,14385187,17.2),(109563,'Sosies','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109563,34.69,0.62,86.7,47003,NULL,NULL,NULL,'NGC 5152',NULL,'2002A&A...393...57T',2002,1,2,NULL,'G',0.000037,NULL,'13.30',0.6,'SB(s)b','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,201.963,-29.61861,0.209,NULL,46846378864,731974669,11437104,13.3),(109564,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109564,38.4,0.46,478,47004,70,NULL,NULL,'SDSS J132751.89+564629.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,201.96625,56.775,0,NULL,57416715183,897136174,14017752,18.4),(109565,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109565,36.07,0.59,164,47005,70,NULL,NULL,'2MASX J13275218-2705488',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000057,NULL,'15.6V',0.3,'SBa/0','Group member',NULL,NULL,NULL,1,201.9675,-27.09703,0.197,NULL,43296289398,676504521,10570383,15.6),(109566,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109566,37.44,0.46,308,47006,70,NULL,NULL,'2MASX J13275252+2517471',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,201.9687083,25.29644,0.02,NULL,58662896906,916607764,14321996,17.2),(109567,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109567,36.55,0.54,204,47007,70,NULL,NULL,'2MASX J13275326-2724128',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00005,NULL,'15.4V',0.3,'E','Group member',NULL,NULL,NULL,1,201.971583,-27.40372,0.173,NULL,43296991415,676515490,10570554,15.4),(109568,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109568,35.87,0.46,149,47008,70,NULL,NULL,'IC 4258',NULL,'2015arXiv151105856S',2015,1,0.86,NULL,'G',0.00009,NULL,'14.6g',0.72,'S?',NULL,NULL,NULL,NULL,1,201.971917,28.50819,0.007,NULL,58658019748,916531558,14320805,14.6),(109569,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109569,37.51,0.14,317,47009,70,NULL,NULL,'2MASX J13275393+0114516',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000076,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,201.974833,1.24781,0.024,NULL,58922430206,920662971,14385358,17.2),(109570,'D-Sigma','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109570,33.06,0.4,40.9,47010,75,NULL,'Edat, raw','NGC 5153',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000097,NULL,'12.83',1.4,'E1 pec','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,201.976375,-29.61803,0.209,NULL,46846378162,731974658,11437104,12.83),(109571,'D-Sigma','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109571,33.4,0.4,48,47010,75,NULL,'Edat, cor','NGC 5153',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109572,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109572,33.37,0.47,47.3,47010,70,NULL,NULL,'NGC 5153',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109573,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109573,33.61,0.45,52.6,47010,NULL,NULL,'K','NGC 5153',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109574,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109574,33.97,0.4,62.2,47010,NULL,NULL,'mean','NGC 5153',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109575,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109575,36.67,0.25,216,47011,74.4,NULL,NULL,'2MASX J13275493-3132187',NULL,'2013AJ....146...86T',2013,1,0.92,NULL,'G',0.000067,NULL,'15.2b',0.92,'E','Group member',NULL,NULL,NULL,1,201.9789583,-31.53858,0.169,NULL,46900998555,732828102,11450439,15.2),(109576,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109576,35.42,0.5,121,47012,70,NULL,NULL,'ESO 509- G 018',NULL,'2014MNRAS.445.2677S',2014,1,1.1,'6dF DR2 has z = 0.045918.','G',0.000113,NULL,'14.95',0.8,'S0',NULL,NULL,NULL,NULL,1,201.979833,-24.49906,0.257,NULL,43291969950,676437030,10569328,14.95),(109577,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109577,34.26,0.4,71,47013,NULL,NULL,'mean','MCG -02-34-054',NULL,'2007A&A...465...71T',2007,1,1.8,'RC3 has V = 3990 +- 9 km/s; 2005ApJS..160..149S have V = 6769 km/s.','G',0.00015,NULL,'12.8B',1.3,'SB(rs)bc',NULL,NULL,NULL,NULL,1,201.98175,-13.42308,0.085,NULL,43993250038,687394531,10740539,12.8),(109578,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109578,35.28,0.47,114,47013,NULL,NULL,'H','MCG -02-34-054',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109579,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109579,35.33,0.45,116,47013,NULL,NULL,'K','MCG -02-34-054',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109580,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109580,35.34,0.46,117,47013,NULL,NULL,'J','MCG -02-34-054',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109581,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109581,37.82,0.46,367,47014,70,NULL,NULL,'SDSS J132755.62+103910.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,201.9817917,10.65297,0,NULL,58953746059,921152282,14393004,17.9),(109582,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109582,35.26,0.5,113,47015,70,NULL,NULL,'ESO 509- G 019',NULL,'2014MNRAS.445.2677S',2014,1,2.67,NULL,'G',0.000017,NULL,'15.23',0.28,'Sbc            HII',NULL,NULL,NULL,NULL,1,201.9849583,-25.85622,0.193,NULL,43301226116,676581658,10571588,15.23),(109583,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109583,35.54,NULL,128,47015,NULL,NULL,NULL,'ESO 509- G 019',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109584,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109584,35.87,NULL,149,47015,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 509- G 019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109585,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109585,35.88,NULL,150,47015,NULL,NULL,'Dipole + Quadrupole','ESO 509- G 019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109586,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109586,35.89,NULL,151,47015,NULL,NULL,'Dipole','ESO 509- G 019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109587,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109587,36.06,0.47,163,47015,NULL,NULL,'Malmquist cor.','ESO 509- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109588,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109588,36.19,0.44,173,47015,NULL,NULL,NULL,'ESO 509- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109589,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109589,36.26,0.2,179,47015,74.4,NULL,NULL,'ESO 509- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109590,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109590,38.43,0.33,485,47016,70,NULL,NULL,'2MASX J13275659+5255573',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000174,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,201.985666667,52.93261,0.011,NULL,57277755536,894964930,13983827,16.6),(109591,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109591,35.84,0.25,147,47017,74.4,NULL,NULL,'ESO 444- G 046',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.00007,NULL,'12.6V',1.2,'cD;E+4;BrClG','Group member',NULL,NULL,NULL,1,201.986917,-31.49553,0.181,NULL,46901001489,732828148,11450439,12.6),(109592,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109592,36.63,0.14,211,47017,70,NULL,'ABELL 3558, BGC','ESO 444- G 046',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109593,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109593,36.38,0.54,189,47018,70,NULL,NULL,'2MASX J13275689-3100527',NULL,'2014MNRAS.445.2677S',2014,1,0.92,NULL,'G',0.00015,NULL,'13.8R',0.55,'E','Group member',NULL,NULL,NULL,1,201.987166667,-31.01461,0.145,NULL,46901166787,732830731,11450480,13.8),(109594,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109594,36.63,0.14,211,47019,70,NULL,NULL,'ABELL 3558',NULL,'1999AJ....118.1489D',1999,1,NULL,'Katgert (1996,A&A,310,8) identifies multiple redshift systems in this cluster.','GClstr',NULL,NULL,NULL,NULL,'I      [BM];R  [A]',NULL,NULL,NULL,NULL,1,201.989583,-31.5025,0.181,NULL,46901001580,732828149,11450439,NULL),(109595,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109595,38.72,0.46,554,47020,70,NULL,NULL,'SDSS J132757.52+541907.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000139,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,201.9897083,54.31889,0.009,NULL,57279680475,894995007,13984296,18.6),(109596,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109596,37.51,0.14,317,47021,70,NULL,NULL,'2MASX J13275913+0126556',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000201,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,201.996375,1.44883,0.018,NULL,58921910602,920654853,14385232,16.5),(109597,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109597,34.47,0.5,78.4,47022,70,NULL,NULL,'MCG -03-34-079',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.00015,NULL,'15.05',0.2,NULL,NULL,NULL,NULL,NULL,1,202.000333,-16.35619,0.177,NULL,43786752619,684168009,10690125,15.05),(109598,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109598,35.28,0.46,114,47023,70,NULL,NULL,'CGCG 271-043',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.00007,NULL,'15.0g',0.5,'S?','Pair member (points to parent)',NULL,NULL,NULL,1,202.000583,56.03489,0,NULL,57418248647,897160135,14018127,15),(109599,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109599,37.15,0.46,269,47024,70,NULL,NULL,'2MASX J13280139+2222049',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.11',0.13,NULL,NULL,NULL,NULL,NULL,1,202.005875,22.36817,0.029,NULL,58793309366,918645458,14353835,18.11),(109600,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109600,37.28,0.46,285,47025,70,NULL,NULL,'2MASX J13280212+2547033',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,202.0087917,25.78419,0.022,NULL,58669445600,916710087,14323595,17.6),(109601,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109601,35.75,0.25,141,47026,74.4,NULL,NULL,'2MASX J13280218-3131447',NULL,'2013AJ....146...86T',2013,1,0.48,NULL,'G',0.000067,NULL,'15.7V',0.43,'E','Group member',NULL,NULL,NULL,1,202.0092917,-31.52903,0.145,NULL,46901001957,732828155,11450439,15.7),(109602,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109602,37.83,0.46,368,47027,70,NULL,NULL,'2MASX J13280228+1924429',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.52',0.16,NULL,NULL,NULL,NULL,NULL,1,202.009375,19.41206,0.018,NULL,58852725147,919573830,14368341,18.52),(109603,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109603,36.51,0.25,200,47028,74.4,NULL,NULL,'2MASX J13280225-3134437',NULL,'2013AJ....146...86T',2013,1,0.46,NULL,'G',0.00007,NULL,'15.8V',0.46,'E','Group member',NULL,NULL,NULL,1,202.0095417,-31.57903,0.169,NULL,46900997965,732828093,11450438,15.8),(109604,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109604,36.22,0.25,175,47029,74.4,NULL,NULL,'2MASX J13280261-3145207',NULL,'2013AJ....146...86T',2013,1,0.71,NULL,'G',0.00006,NULL,'14.6V',0.64,'E','Group member',NULL,NULL,NULL,1,202.010916667,-31.75583,0.169,NULL,46904387701,732881057,11451266,14.6),(109605,'CMD','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109605,21.5,0.2,0.2,47030,NULL,NULL,NULL,'CVn I dSph',NULL,'2008AJ....135.1361D',2008,1,NULL,NULL,'G',NULL,NULL,'13.9V',NULL,NULL,NULL,NULL,NULL,NULL,1,202.014583,33.55583,0,1,59161951978,924405499,14443835,13.9),(109606,'CMD','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109606,21.7,NULL,0.219,47030,NULL,NULL,NULL,'CVn I dSph',NULL,'2008A&A...477..139L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109607,'CMD','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109607,21.75,0.2,0.22,47030,NULL,NULL,NULL,'CVn I dSph',NULL,'2008AJ....135.1361D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109608,'CMD','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109608,21.75,NULL,0.224,47030,NULL,NULL,NULL,'CVn I dSph',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109609,'Horizontal Branch','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109609,21.68,0.08,0.216,47030,NULL,NULL,NULL,'CVn I dSph',NULL,'2012ApJ...744...96O',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109610,'Horizontal Branch','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109610,21.69,0.1,0.218,47030,NULL,NULL,NULL,'CVn I dSph',NULL,'2008ApJ...672L..13M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109611,'RR Lyrae','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109611,21.62,0.06,0.21,47030,NULL,NULL,'23, E(B-V) = 0.03','CVn I dSph',NULL,'2008ApJ...674L..81K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109612,'RR Lyrae','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109612,21.67,0.06,0.216,47030,NULL,NULL,'23, E(B-V) = 0.014','CVn I dSph',NULL,'2008ApJ...674L..81K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109613,'TRGB','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109613,21.75,0.2,0.22,47030,NULL,NULL,NULL,'CVn I dSph',NULL,'2006ApJ...643L.103Z',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109614,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109614,36.25,0.46,178,47031,70,NULL,NULL,'UGC 08461',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000073,NULL,'15.1g',0.65,'PECULR',NULL,NULL,NULL,NULL,1,202.0165,34.33272,0,NULL,59167106797,924486043,14445094,15.1),(109615,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109615,36.95,0.46,246,47032,70,NULL,NULL,'2MASX J13280409+4113030',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000161,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,202.017083333,41.21758,0,NULL,59323059722,926922808,14483168,16.8),(109616,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109616,37.75,0.46,355,47033,70,NULL,NULL,'SDSS J132804.37-022818.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000112,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,202.01825,-2.47189,0.037,NULL,43824896619,684764009,10699437,18),(109617,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109617,37.9,0.46,381,47034,70,NULL,NULL,'2MASX J13280460+1000430',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,202.019083,10.01189,0,NULL,58955133035,921173953,14393343,17.9),(109618,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109618,36.83,0.46,232,47035,70,NULL,NULL,'2MASX J13280519+3635020',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.49',0.21,NULL,NULL,NULL,NULL,NULL,1,202.021667,36.58381,0,NULL,59168696214,924510878,14445482,17.49),(109619,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109619,34.86,0.51,93.6,47036,70,NULL,NULL,'2MASX J13280546-2108099',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000113,NULL,'15.60',0.5,NULL,NULL,NULL,NULL,NULL,1,202.0227083,-21.13608,0.281,NULL,43810629538,684541086,10695954,15.6),(109620,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109620,34.85,0.5,93.3,47037,70,NULL,NULL,'2MASX J13280572-2925304',NULL,'2014MNRAS.445.2677S',2014,1,0.6,'Quintana, et al. (1995AJ....110..463Q) give v = 16704 +/- 66 km/sec.','G',0.00004,NULL,'16.0',NULL,'S0',NULL,NULL,NULL,NULL,1,202.023916667,-29.42508,0.209,NULL,46847062943,731985358,11437271,16),(109621,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109621,37.69,0.46,344,47038,70,NULL,NULL,'2MASX J13280658+0004094',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000079,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,202.027375,0.06933,0.029,NULL,58049330527,907020789,14172199,17.1),(109622,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109622,38.11,0.46,419,47039,70,NULL,NULL,'2MASX J13280695+1103440',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,202.0289583,11.06222,0,NULL,58953640277,921150629,14392978,18.3),(109623,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109623,35.36,0.6,118,47040,NULL,NULL,NULL,'2MASX J13280741-2701144',NULL,'2009ApJS..182..474S',2009,1,0.44,NULL,'G',0.000023,NULL,'15.5V',0.26,'Sc','Group member',NULL,NULL,NULL,1,202.030667,-27.02056,0.193,NULL,43296234708,676503667,10570369,15.5),(109624,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109624,35.4,0.2,120,47040,74.4,NULL,NULL,'2MASX J13280741-2701144',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109625,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109625,35.41,0.59,121,47040,NULL,NULL,'Malmquist cor.','2MASX J13280741-2701144',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109626,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109626,37.69,0.33,345,47041,70,NULL,NULL,'2MASX J13280790-0127483',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000147,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,202.032875,-1.46339,0.037,NULL,43822745589,684730399,10698912,17.5),(109627,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109627,38.29,0.46,456,47042,70,NULL,NULL,'SDSS J132809.51+561634.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,202.039666667,56.27617,0,NULL,57416360144,897130627,14017666,18.2),(109628,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109628,36.35,0.73,187,47043,NULL,NULL,'Malmquist cor.','2MASX J13280995-2719544',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.00003,NULL,'15.2V',0.5,'Sc             HII?','Group member',NULL,NULL,NULL,1,202.041375,-27.33194,0.173,NULL,43296772245,676512066,10570501,15.2),(109629,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109629,37.2,0.49,275,47043,NULL,NULL,NULL,'2MASX J13280995-2719544',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109630,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109630,32.95,0.4,39,47044,75,NULL,'B','NGC 5169',NULL,'1988NBGC.C....0000T',1988,1,2.18,NULL,'G',0.000023,NULL,'14.0g',0.66,'SB(rs)b:','in a pair',NULL,NULL,NULL,1,202.041875,46.67214,0,NULL,59286822573,926356602,14474321,14),(109631,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109631,33.41,0.4,48.1,47044,NULL,NULL,NULL,'NGC 5169',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109632,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109632,35.69,0.71,138,47045,70,NULL,NULL,'2MASX J13281027-4303521',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'15.0R',0.2,NULL,NULL,NULL,NULL,NULL,1,202.04275,-43.06447,0.481,NULL,46974666366,733979161,11468424,15),(109633,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109633,36.12,0.55,167,47046,70,NULL,NULL,'2MASX J13281048-3123098',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.000073,NULL,'15.3V',0.43,'E','Group member',NULL,NULL,NULL,1,202.0435,-31.38617,0.145,NULL,46901212489,732831445,11450491,15.3),(109634,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109634,36.4,0.25,191,47046,74.4,NULL,NULL,'2MASX J13281048-3123098',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109635,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109635,37.01,0.46,252,47047,70,NULL,NULL,'2MASX J13281095+1053388',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000186,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,202.04575,10.89403,0,NULL,58953679452,921151241,14392988,16.3),(109636,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109636,38.27,0.46,450,47048,70,NULL,NULL,'2MASX J13281126+1537479',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.84',0.14,NULL,NULL,NULL,NULL,NULL,1,202.047,15.62997,0.025,NULL,58834735116,919292736,14363949,18.84),(109637,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109637,36.56,0.46,205,47049,70,NULL,NULL,'2MASX J13281164+0003124',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000075,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,202.048458333,0.05328,0.029,NULL,58049330430,907020787,14172199,16.6),(109638,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109638,37.11,0.46,264,47050,70,NULL,NULL,'2MASX J13281160+4546187',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,202.0485417,45.77192,0,NULL,59286698153,926354658,14474291,17.4),(109639,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109639,37.51,0.46,318,47051,70,NULL,NULL,'SDSS J132812.06+263710.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,202.0502917,26.61964,0,NULL,58666403373,916662552,14322852,18.1),(109640,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109640,31.05,NULL,16.2,47052,72,NULL,NULL,'SDSS J132811.81+021643.7',NULL,'2014Ap.....57..457K',2014,1,0.8,NULL,'G',0.000007,NULL,'16.3',0.45,'dIn',NULL,NULL,NULL,NULL,1,202.0505,2.27944,0,NULL,58922962244,920671285,14385488,16.3),(109641,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109641,36.7,0.46,219,47053,70,NULL,NULL,'2MASX J13281281+5354423',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000165,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,202.053375,53.91172,0,NULL,57280354409,895005537,13984461,16.7),(109642,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109642,35.53,0.62,127,47054,70,NULL,NULL,'2MASX J13281289-2059049',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.73',0.3,NULL,NULL,NULL,NULL,NULL,1,202.053583333,-20.98483,0.281,NULL,43818036926,684656826,10697762,15.73),(109643,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109643,36.77,0.58,226,47055,70,NULL,NULL,'2MASX J13281309-3014328',NULL,'2014MNRAS.445.2677S',2014,1,0.4,'6dF DR2 has z = 0.047439.','G',0.00015,NULL,'16.8',NULL,'S0',NULL,NULL,NULL,NULL,1,202.054583,-30.24242,0.249,NULL,46901565933,732836967,11450577,16.8),(109644,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109644,36.75,0.46,224,47056,70,NULL,NULL,'2MASX J13281371+3153025',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000141,NULL,'17.4g',0.21,'E0',NULL,NULL,NULL,NULL,1,202.057083,31.88392,0.028,NULL,59180851352,924700802,14448450,17.4),(109645,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109645,36.57,0.55,206,47057,70,NULL,NULL,'2MASX J13281425-2757344',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.3b',NULL,'Sp',NULL,NULL,NULL,NULL,1,202.059333,-27.95961,0.201,NULL,43297637814,676525590,10570712,15.3),(109646,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109646,37.95,0.46,389,47058,70,NULL,NULL,'2MASX J13281430+5328403',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,202.059625,53.47789,0,NULL,57281002019,895015656,13984619,17.2),(109647,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109647,38.45,0.46,489,47059,70,NULL,NULL,'SDSS J132814.59+551358.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,202.0607917,55.23292,0,NULL,57287005077,895109454,13986085,18.4),(109648,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109648,35.47,0.68,124,47060,70,NULL,NULL,'2MASX J13281474-2437004',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000113,NULL,'17.16',0.3,NULL,NULL,NULL,NULL,NULL,1,202.061417,-24.61683,0.257,NULL,43292338034,676442781,10569418,17.16),(109649,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109649,35.6,0.47,132,47061,70,NULL,NULL,'MCG -05-32-027',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.5',0.2,'E',NULL,NULL,NULL,NULL,1,202.062167,-27.97672,0.201,NULL,43297638241,676525597,10570712,15.5),(109650,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109650,33.91,0.47,60.6,47062,NULL,NULL,'H','NGC 5166',NULL,'2007A&A...465...71T',2007,1,2.3,NULL,'G',0.000083,NULL,'14.29',0.4,'Sb','in a radial-velocity based grouping',NULL,NULL,NULL,1,202.062667,32.03239,0.045,NULL,59179857601,924685275,14448207,14.29),(109651,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109651,33.93,0.46,61.2,47062,NULL,NULL,'J','NGC 5166',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109652,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109652,33.95,0.45,61.6,47062,NULL,NULL,'K','NGC 5166',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109653,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109653,33.98,0.49,62.6,47062,75,NULL,'IR','NGC 5166',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109654,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109654,34.13,0.4,67,47062,NULL,NULL,'mean','NGC 5166',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109655,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109655,38.4,0.46,478,47063,70,NULL,NULL,'2MASX J13281503+1552480',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,202.0627083,15.87997,0.025,NULL,58835201811,919300028,14364062,17.7),(109656,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109656,37.88,0.46,377,47064,70,NULL,NULL,'2MASX J13281541+3103205',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000135,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,202.064125,31.05583,0.025,NULL,59178125874,924658216,14447784,18.6),(109657,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109657,34.53,0.2,80.5,47065,74.4,NULL,NULL,'NGC 5159',NULL,'2013AJ....146...86T',2013,1,1.54,NULL,'G',0.000073,NULL,'14.9g',0.44,'Sd','Field galaxy',NULL,NULL,NULL,1,202.067375,2.98267,0.042,NULL,58936862586,920888477,14388882,14.9),(109658,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109658,34.7,0.34,87.1,47065,NULL,NULL,NULL,'NGC 5159',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109659,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109659,34.77,0.33,90.1,47065,NULL,NULL,'Malmquist cor.','NGC 5159',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109660,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109660,36.62,0.46,211,47066,70,NULL,NULL,'SDSS J132817.21+094348.8',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'17.6g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,202.07175,9.73025,0,NULL,58954776690,921168385,14393256,17.6),(109661,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109661,36.93,0.46,244,47067,70,NULL,NULL,'2MASX J13281781+1043258',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,202.07425,10.72389,0,NULL,58953820805,921153450,14393022,17.5),(109662,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109662,36.92,0.46,242,47068,70,NULL,NULL,'2MASX J13281825+2656143',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000158,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,202.075916667,26.93742,0,NULL,58666268929,916660452,14322819,17.1),(109663,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109663,37.28,0.33,286,47069,70,NULL,NULL,'2MASX J13281838+3857060',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,202.0765,38.95183,0,NULL,59298766660,926543229,14477237,17.5),(109664,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109664,37.52,0.46,318,47070,70,NULL,NULL,'2MASX J13281855+0612388',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000164,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,202.077417,6.21083,0.038,NULL,58981047577,921578868,14399669,17.3),(109665,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109665,36.23,0.49,177,47071,NULL,NULL,'Malmquist cor.','2MASX J13281864-2712274',NULL,'2009ApJS..182..474S',2009,1,0.55,NULL,'G',0.000023,NULL,'15.2V',0.4,'Sb','Group member',NULL,NULL,NULL,1,202.07775,-27.20772,0.193,NULL,43296814597,676512728,10570511,15.2),(109666,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109666,36.76,0.38,225,47071,NULL,NULL,NULL,'2MASX J13281864-2712274',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109667,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109667,36.8,0.2,229,47071,74.4,NULL,NULL,'2MASX J13281864-2712274',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109668,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109668,35.62,0.68,133,47072,70,NULL,NULL,'2MASX J13281883-2054228',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.2I',0.2,NULL,NULL,NULL,NULL,NULL,1,202.0784583,-20.90642,0.281,NULL,43818771009,684668297,10697942,14.2),(109669,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109669,37.84,0.46,371,47073,70,NULL,NULL,'2MASX J13281898+3144285',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,202.079333333,31.74125,0.028,NULL,59180908060,924701688,14448463,18),(109670,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109670,33.62,NULL,53,47074,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08464',NULL,'2010Ap&SS.325..163P',2010,1,0.57,NULL,'G',0.000033,NULL,'16.3g',0.2,'Scd',NULL,NULL,NULL,NULL,1,202.0795417,30.01936,0.03,NULL,59131444279,923928816,14436387,16.3),(109671,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109671,33.65,NULL,53.8,47074,NULL,NULL,'Dipole + Quadrupole','UGC 08464',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109672,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109672,33.67,NULL,54.2,47074,NULL,NULL,'Dipole','UGC 08464',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109673,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109673,37.64,0.27,337,47075,70,NULL,NULL,'2MASX J13281942+1543390',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,202.0810417,15.72753,0.025,NULL,58835457126,919304017,14364125,17.8),(109674,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109674,37.4,0.46,302,47076,70,NULL,NULL,'2MASX J13282021+2215336',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,202.084333333,22.25925,0.029,NULL,58793328643,918645760,14353840,16.9),(109675,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109675,34.52,NULL,80.1,47077,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -02-34-055',NULL,'2010Ap&SS.325..163P',2010,1,1.85,'RC3 has V = 3935 +- 9 km/s; 6df has z = 0.019890 +- 0.000150.','G',0.000033,NULL,'15',0.24,'Sbc',NULL,NULL,NULL,NULL,1,202.0844583,-11.78439,0.049,NULL,43858712251,685292378,10707693,15),(109676,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109676,34.53,NULL,80.4,47077,NULL,NULL,'Dipole','MCG -02-34-055',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109677,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109677,34.53,NULL,80.5,47077,NULL,NULL,'Dipole + Quadrupole','MCG -02-34-055',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109678,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109678,34.63,0.2,84.3,47077,74.4,NULL,NULL,'MCG -02-34-055',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109679,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109679,34.65,0.49,85.2,47077,75,NULL,'IR','MCG -02-34-055',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109680,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109680,34.66,0.38,85.4,47077,NULL,NULL,'Malmquist cor.','MCG -02-34-055',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109681,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109681,34.78,0.36,90.5,47077,NULL,NULL,NULL,'MCG -02-34-055',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109682,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109682,35.84,NULL,147,47077,NULL,NULL,NULL,'MCG -02-34-055',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109683,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109683,36.56,0.41,205,47078,NULL,NULL,'Malmquist cor.','2MASX J13282037-3056088',NULL,'2009ApJS..182..474S',2009,1,0.41,NULL,'G',0.000033,NULL,'16.8b',0.21,NULL,'Group member',NULL,NULL,NULL,1,202.084917,-30.93578,0.145,NULL,46901529302,732836395,11450568,16.8),(109684,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109684,36.91,0.35,241,47078,NULL,NULL,NULL,'2MASX J13282037-3056088',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109685,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109685,36.95,0.2,245,47078,74.4,NULL,NULL,'2MASX J13282037-3056088',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109686,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109686,36.82,0.46,231,47079,70,NULL,NULL,'2MASX J13282064+2701333',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,202.0860417,27.02606,0,NULL,58658667556,916541680,14320963,16.7),(109687,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109687,35.79,0.67,144,47080,70,NULL,NULL,'2MASX J13282156-2528354',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000103,NULL,'17.27',0.3,NULL,NULL,NULL,NULL,NULL,1,202.0897917,-25.4765,0.217,NULL,43300219492,676565929,10571342,17.27),(109688,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109688,38.13,0.46,423,47081,70,NULL,NULL,'2MASX J13282215+0728088',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,202.0924583,7.46911,0,NULL,58983973238,921624581,14400384,17.3),(109689,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109689,38.07,0.46,412,47082,70,NULL,NULL,'2MASX J13282259+1435140',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000252,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,202.094167,14.58725,0.01,NULL,59006679090,921979360,14405927,17.5),(109690,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109690,37.17,0.46,272,47083,70,NULL,NULL,'2MASX J13282306+3845220',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000166,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,202.096,38.75614,0,NULL,59298699784,926542184,14477221,16.7),(109691,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109691,37.88,0.46,377,47084,70,NULL,NULL,'2MASX J13282333+3736180',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00014,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,202.097333,37.60522,0,NULL,59295449255,926491394,14476428,18.1),(109692,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109692,37.47,0.46,312,47085,70,NULL,NULL,'2MASX J13282384+6217547',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,202.0992083,62.29864,0.045,NULL,57347046357,896047599,14000743,17.8),(109693,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109693,37.33,0.33,292,47086,70,NULL,NULL,'2MASX J13282418-0156502',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,202.100833,-1.94722,0.037,NULL,43825672771,684776137,10699627,17.9),(109694,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109694,37.33,0.33,292,47087,70,NULL,NULL,'2MASX J13282451-0156302',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000159,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,202.102167,-1.94183,0.037,NULL,43825673076,684776141,10699627,16.9),(109695,'Tully est','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109695,32.16,0.8,27.1,47088,75,NULL,NULL,'ESO 509- G 026',NULL,'1988NBGC.C....0000T',1988,1,1.3,'Da Costa, et al. (1987, AJ, 93, 1338) give v = 12,949 +/- 31 km/sec.','G',0.00001,NULL,'15.17',1,'SAB(s)m',NULL,NULL,NULL,NULL,1,202.102583,-27.57028,0.173,NULL,43296926186,676514471,10570538,15.17),(109696,'IRAS','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109696,33.95,0.8,61.7,47089,75,NULL,'MAT, I','ESO 444- G 047',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00001,NULL,'14.77',0.4,'SB(r)cd? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,202.10425,-31.85786,0.177,NULL,46904438324,732881848,11451278,14.77),(109697,'IRAS','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109697,33.96,0.8,61.8,47089,75,NULL,'HMCL, I','ESO 444- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109698,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109698,33.12,0.32,42,47089,85,NULL,'I, raw','ESO 444- G 047',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109699,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109699,33.12,0.32,42.1,47089,85,NULL,'I, inv','ESO 444- G 047',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109700,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109700,33.34,0.43,46.5,47089,75,NULL,'MAT, I, raw','ESO 444- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109701,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109701,33.41,0.43,48.1,47089,75,NULL,'MAT, I, inv','ESO 444- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109702,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109702,33.57,0.43,51.8,47089,75,NULL,'MAT, I, cor','ESO 444- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109703,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109703,33.88,0.4,59.7,47089,75,NULL,'HMCL, I, raw','ESO 444- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109704,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109704,33.92,0.2,60.8,47089,74.4,NULL,NULL,'ESO 444- G 047',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109705,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109705,33.95,0.4,61.5,47089,75,NULL,'HMCL, I, cor','ESO 444- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109706,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109706,33.99,0.4,62.7,47089,75,NULL,'HMCL, I, inv','ESO 444- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109707,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109707,34.12,0.1,66.8,47089,NULL,NULL,NULL,'ESO 444- G 047',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109708,'Tully est','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109708,32.9,0.8,38,47090,75,NULL,'B','NGC 5173',NULL,'1988NBGC.C....0000T',1988,1,0.98,NULL,'G',0.000017,NULL,'13.5g',0.91,'E0:','in a radial-velocity based grouping',NULL,NULL,NULL,1,202.1052917,46.59164,0,NULL,59286840113,926356876,14474326,13.5),(109709,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109709,36.43,0.62,193,47091,70,NULL,NULL,'2MASX J13282548-2455534',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.26',0.6,'Sy1',NULL,NULL,NULL,NULL,1,202.10625,-24.93147,0.261,NULL,43292232801,676441137,10569392,15.26),(109710,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109710,33.95,0.46,61.6,47092,70,NULL,NULL,'IC 0890',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000117,NULL,'15.15',0.5,NULL,NULL,NULL,NULL,NULL,1,202.106625,-16.09233,0.129,NULL,43786922953,684170671,10690166,15.15),(109711,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109711,37.96,0.46,391,47093,70,NULL,NULL,'LCRS B132550.5-031629',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000174,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,202.107083,-3.53344,0.057,NULL,43836592223,684946753,10702293,17.6),(109712,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109712,34.97,0.2,98.6,47094,74.4,NULL,NULL,'UGC 08466',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000057,NULL,'15.0g',0.56,'Sbc',NULL,NULL,NULL,NULL,1,202.107166667,30.81572,0.021,NULL,59178462890,924663482,14447866,15),(109713,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109713,37.31,0.46,290,47095,70,NULL,NULL,'2MASX J13282580+6025597',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000153,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,202.10775,60.43328,0,NULL,57392052650,896750822,14011731,16.9),(109714,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109714,37.79,0.46,362,47096,70,NULL,NULL,'2MASX J13282592+5501247',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000135,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,202.107917,55.02364,0,NULL,57286875549,895107430,13986053,17.4),(109715,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109715,37.51,0.14,317,47097,70,NULL,NULL,'2MASX J13282604+0127034',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,202.1085417,1.45078,0.018,NULL,58921922504,920655039,14385234,17.2),(109716,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109716,36.41,0.46,192,47098,70,NULL,NULL,'2MASX J13282613+1718180',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.88',0.17,NULL,NULL,NULL,NULL,NULL,1,202.1090417,17.305,0,NULL,58831995514,919249929,14363280,17.88),(109717,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109717,35.88,0.51,150,47099,NULL,NULL,NULL,'AGC 530504',NULL,'2009ApJS..182..474S',2009,1,0.56,NULL,'G',0.000033,NULL,'16',0.16,'S','Group member',NULL,NULL,NULL,1,202.111667,-26.80333,0.193,NULL,43298087523,676532617,10570822,16),(109718,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109718,35.92,0.2,153,47099,74.4,NULL,NULL,'AGC 530504',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109719,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109719,36.06,0.47,163,47099,NULL,NULL,'Malmquist cor.','AGC 530504',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109720,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109720,38.21,0.46,439,47100,70,NULL,NULL,'2MASX J13282711+2406113',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,202.112917,24.10322,0.025,NULL,58794079758,918657496,14354023,17.6),(109721,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109721,37.16,0.17,271,47101,70,NULL,NULL,'2MASX J13282718+3741116',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000137,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,202.1130417,37.68667,0,NULL,59295617383,926494021,14476469,17.2),(109722,'D-Sigma','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109722,33.3,0.4,45.6,47102,75,NULL,'Edat, raw','ESO 270- G 014',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000123,NULL,'13.88',0.9,'S0- pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,202.113666667,-44.172,0.449,NULL,46974298304,733973411,11468334,13.88),(109723,'D-Sigma','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109723,33.45,0.4,49,47102,75,NULL,'Edat, cor','ESO 270- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109724,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109724,33.75,0.5,56.3,47102,70,NULL,NULL,'ESO 270- G 014',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109725,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109725,33.7,0.4,54.9,47102,NULL,NULL,'mean','ESO 270- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109726,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109726,33.98,0.45,62.4,47102,NULL,NULL,'K','ESO 270- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109727,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109727,37.76,0.46,357,47103,70,NULL,NULL,'2MASX J13282808-0006182',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000088,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,202.1169583,-0.10519,0.029,NULL,43084133721,673189589,10518587,17.7),(109728,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109728,35.89,0.51,151,47104,70,NULL,NULL,'2MASX J13282950-2454361',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00013,NULL,'15.31',0.5,NULL,NULL,NULL,NULL,NULL,1,202.122958333,-24.91008,0.261,NULL,43292233183,676441143,10569392,15.31),(109729,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109729,37.69,0.33,345,47105,70,NULL,NULL,'2MASX J13283084-0116562',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,202.128625,-1.28242,0.033,NULL,43822899426,684732803,10698950,17.4),(109730,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109730,37.95,0.46,388,47106,70,NULL,NULL,'2MASX J13283099+0411484',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,202.129041667,4.19669,0.023,NULL,58928650976,920760171,14386877,17.3),(109731,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109731,37.51,0.14,317,47107,70,NULL,NULL,'VIII Zw 313',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000086,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,202.129833,1.13422,0.024,NULL,58922414062,920662719,14385354,16.8),(109732,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109732,37.77,0.27,358,47108,70,NULL,NULL,'2MASX J13283146+1113228',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,202.131125,11.22289,0,NULL,58939855076,920935235,14389613,17.4),(109733,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109733,35.63,0.57,134,47109,70,NULL,NULL,'2MASX J13283290-2836221',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.4',NULL,'E',NULL,NULL,NULL,NULL,1,202.137083,-28.60617,0.169,NULL,43294085730,676470089,10569845,16.4),(109734,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109734,32.86,0.4,37.3,47110,75,NULL,NULL,'IC 4263',NULL,'2008Ap.....51..336K',2008,1,1.9,'RC3 has V = 454 +- 8 km/s; UZC has V = 2681 +- 42 km/s.','G',0.000176,NULL,'14.8g',0.41,'SB(s)d: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,202.138291667,46.92719,0,NULL,59290349371,926411708,14475182,14.8),(109735,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109735,32.87,0.2,37.5,47110,74.4,NULL,NULL,'IC 4263',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109736,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109736,33.04,0.43,40.5,47110,75,NULL,'3.6 micron, color corrected','IC 4263',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109737,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109737,33.12,0.49,42,47110,75,NULL,'IR','IC 4263',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109738,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109738,33.22,0.43,44,47110,75,NULL,'3.6 micron, color + selection bias corrected','IC 4263',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109739,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109739,37.99,0.46,396,47111,70,NULL,NULL,'2MASX J13283330+3929116',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000173,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,202.13875,39.48653,0,NULL,59296507347,926507927,14476686,17.6),(109740,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109740,37.93,0.46,386,47112,70,NULL,NULL,'2MASX J13283337+5117245',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000144,NULL,'18.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,202.139041667,51.29022,0,NULL,59207291771,925113933,14454905,18.3),(109741,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109741,37.23,0.46,279,47113,70,NULL,NULL,'2MASX J13283352+1929266',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,202.139791667,19.49072,0.018,NULL,58852882411,919576287,14368379,17.4),(109742,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109742,38.22,0.46,441,47114,70,NULL,NULL,'2MASX J13283476+3102236',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000187,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,202.144708333,31.03981,0.021,NULL,59178130287,924658285,14447785,17.4),(109743,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109743,35.82,0.44,146,47115,NULL,NULL,'Malmquist cor.','2MASX J13283562-2749271',NULL,'2009ApJS..182..474S',2009,1,0.64,NULL,'G',0.000033,NULL,'15',0.42,'Sb','Group member',NULL,NULL,NULL,1,202.148417,-27.82425,0.173,NULL,43297660490,676525945,10570717,15),(109744,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109744,35.94,0.41,154,47115,NULL,NULL,NULL,'2MASX J13283562-2749271',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109745,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109745,35.98,0.2,157,47115,74.4,NULL,NULL,'2MASX J13283562-2749271',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109746,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109746,37.92,0.07,384,47116,70,NULL,NULL,'2MASX J13283632-0215261',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000208,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,202.151333,-2.25722,0.033,NULL,43824985998,684765406,10699459,17.3),(109747,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109747,37.97,0.46,392,47117,70,NULL,NULL,'SDSS J132836.63+000557.4',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,202.152667,0.09928,0.029,NULL,58049386525,907021664,14172213,17.3),(109748,'IRAS','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109748,34.6,0.8,83.2,47118,75,NULL,'MAT, I','ESO 383- G 002',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000023,NULL,'14.36',0.7,'SAB(rs)c',NULL,NULL,NULL,NULL,1,202.157667,-37.57328,0.209,NULL,46934568476,733352632,11458634,14.36),(109749,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109749,33.96,0.44,61.9,47118,NULL,NULL,'Malmquist cor.','ESO 383- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109750,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109750,34.03,NULL,64.1,47118,NULL,NULL,'B','ESO 383- G 002',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109751,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109751,34.06,0.43,64.8,47118,75,NULL,'MAT, I, raw','ESO 383- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109752,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109752,34.11,0.32,66.5,47118,85,NULL,'I, raw','ESO 383- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109753,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109753,34.17,0.32,68.1,47118,85,NULL,'I, inv','ESO 383- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109754,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109754,34.18,0.43,68.6,47118,75,NULL,'MAT, I, cor','ESO 383- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109755,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109755,34.25,0.2,70.8,47118,74.4,NULL,NULL,'ESO 383- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109756,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109756,34.25,NULL,70.8,47118,NULL,NULL,'I','ESO 383- G 002',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109757,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109757,34.25,0.38,70.8,47118,NULL,NULL,NULL,'ESO 383- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109758,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109758,34.28,0.43,71.7,47118,75,NULL,'MAT, I, inv','ESO 383- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109759,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109759,34.9,0.4,95.7,47118,NULL,NULL,'mean','ESO 383- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109760,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109760,34.94,0.47,97.3,47118,NULL,NULL,'H','ESO 383- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109761,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109761,35.12,0.46,106,47118,NULL,NULL,'J','ESO 383- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109762,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109762,35.12,0.45,106,47118,NULL,NULL,'K','ESO 383- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109763,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109763,37.65,0.46,339,47119,70,NULL,NULL,'2MASX J13283782+1027068',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.63',0.14,NULL,NULL,NULL,NULL,NULL,1,202.157541667,10.45192,0,NULL,58954190042,921159219,14393112,18.63),(109764,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109764,37.64,0.46,337,47120,70,NULL,NULL,'2MASX J13283819+0439397',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000179,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,202.159083,4.661,0.085,NULL,58929039600,920766243,14386972,16.4),(109765,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109765,36.5,0.56,200,47121,70,NULL,NULL,'2MASX J13283871-3120487',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.000103,NULL,'14.8V',0.5,'E','Group member',NULL,NULL,NULL,1,202.161333,-31.34703,0.145,NULL,46901082000,732829406,11450459,14.8),(109766,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109766,36.82,0.25,231,47121,74.4,NULL,NULL,'2MASX J13283871-3120487',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109767,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109767,38.02,0.27,402,47122,70,NULL,NULL,'VIII Zw 314',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000083,NULL,'17.2g',0.28,'AGN',NULL,NULL,NULL,NULL,1,202.16225,0.54825,0.013,NULL,58921763425,920652553,14385196,17.2),(109768,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109768,37.16,0.17,271,47123,70,NULL,NULL,'2MASX J13283947+3744276',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'18.37',0.22,NULL,NULL,NULL,NULL,NULL,1,202.164583,37.74103,0,NULL,59295647999,926494499,14476476,18.37),(109769,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109769,37.92,0.46,384,47124,70,NULL,NULL,'SDSS J132839.54+573841.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000142,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,202.1647917,57.64489,0,NULL,57432838553,897388102,14021689,18.5),(109770,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109770,37.36,0.46,297,47125,70,NULL,NULL,'2MASX J13284165+1120231',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000182,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,202.1734583,11.33983,0,NULL,58940347827,920942934,14389733,17),(109771,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109771,37.92,0.07,384,47126,70,NULL,NULL,'2MASX J13284259-0210591',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,202.177667,-2.18314,0.033,NULL,43824528609,684758259,10699347,18.3),(109772,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109772,36.46,0.69,196,47127,70,NULL,NULL,'2MASX J13284313-3138398',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.000067,NULL,'15.6V',0.3,'S0','Group member',NULL,NULL,NULL,1,202.1795,-31.64461,0.177,NULL,46904419813,732881559,11451274,15.6),(109773,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109773,37.57,0.46,326,47128,70,NULL,NULL,'2MASX J13284311+2034175',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,202.1797917,20.57158,0,NULL,58851316362,919551818,14367997,17.2),(109774,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109774,37.57,0.46,326,47129,70,NULL,NULL,'2MASX J13284396+1920555',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',NULL,NULL,'15.8g',0.44,'BrClG',NULL,NULL,NULL,NULL,1,202.1832917,19.34878,0.018,NULL,58852899973,919576562,14368383,15.8),(109775,'Ring Diameter','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109775,33.9,0.84,60,47130,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5156',NULL,'1981ApJS...45..541P',1981,1,2.3,'Confused HIPASS source','G',0.000013,NULL,'12.49',2,'SB(r)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,202.1837083,-48.91681,0.621,NULL,46944143816,733502247,11460972,12.49),(109776,'Tully est','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109776,32.98,0.8,39.5,47130,75,NULL,'B','NGC 5156',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109777,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109777,36.07,0.63,164,47131,70,NULL,NULL,'2MASX J13284441-3113238',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00009,NULL,'15.3V',0.22,'E/S0','Group member',NULL,NULL,NULL,1,202.184917,-31.22344,0.145,NULL,46901085614,732829462,11450460,15.3),(109778,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109778,37.57,0.46,327,47132,70,NULL,NULL,'SDSS J132844.57+641222.7',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000079,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,202.18575,64.20631,0.041,NULL,57345727020,896026984,14000421,17.8),(109779,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109779,35.58,0.49,131,47133,70,NULL,NULL,'2MASX J13284482-2801491',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.5b',NULL,'SB0',NULL,NULL,NULL,NULL,1,202.18675,-28.03031,0.201,NULL,43297362610,676521290,10570645,15.5),(109780,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109780,38.54,0.46,511,47134,70,NULL,NULL,'2MASX J13284489+4102036',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000192,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,202.186875,41.03439,0,NULL,59314347808,926786684,14481041,17.8),(109781,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109781,36.98,0.46,249,47135,70,NULL,NULL,'2MASX J13284530+2505180',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000083,NULL,'16.37',0.24,NULL,NULL,NULL,NULL,NULL,1,202.188791667,25.08853,0.026,NULL,58663000518,916609383,14322021,16.37),(109782,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109782,37.51,0.46,318,47136,70,NULL,NULL,'2MASX J13284547+0657041',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,202.1895417,6.95131,0,NULL,58980671862,921572997,14399578,17.8),(109783,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109783,37.83,0.23,368,47137,70,NULL,NULL,'2MASX J13284593+0933471',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,202.19125,9.56317,0,NULL,58954820070,921169063,14393266,17.9),(109784,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109784,35.93,0.25,153,47138,74.4,NULL,NULL,'2MASX J13284721-3141348',NULL,'2013AJ....146...86T',2013,1,0.48,NULL,'G',0.000077,NULL,'15.8V',0.39,'E/S0','Group member',NULL,NULL,NULL,1,202.196791667,-31.69308,0.177,NULL,46904421735,732881589,11451274,15.8),(109785,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109785,37.77,0.27,358,47139,70,NULL,NULL,'2MASX J13284757+1118131',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00014,NULL,'17.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,202.198166667,11.30383,0,NULL,58940358431,920943100,14389735,17.4),(109786,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109786,38.16,0.46,429,47140,70,NULL,NULL,'2MASX J13284845+2752280',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000048,NULL,'17.6g',0.2,'AGN',NULL,NULL,NULL,NULL,1,202.201917,27.87439,0.02,NULL,58660934566,916577102,14321517,17.6),(109787,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109787,36.37,0.25,188,47141,74.4,NULL,NULL,'2MASX J13284932-3134328',NULL,'2013AJ....146...86T',2013,1,0.89,NULL,'G',0.00007,NULL,'14.4V',0.8,'E/S0','Group member',NULL,NULL,NULL,1,202.205375,-31.57594,0.177,NULL,46904591532,732884242,11451316,14.4),(109788,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109788,37.17,0.46,272,47142,70,NULL,NULL,'2MASX J13285134+5511216',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000183,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,202.214,55.18922,0,NULL,57287109510,895111086,13986110,16.8),(109789,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109789,37.09,0.33,262,47143,70,NULL,NULL,'2MASX J13285154+0954202',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.26',0.18,NULL,NULL,NULL,NULL,NULL,1,202.214625,9.90567,0,NULL,58955002945,921171921,14393311,18.26),(109790,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109790,37.58,0.46,329,47144,70,NULL,NULL,'2MASX J13285213+4928566',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000189,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,202.2172083,49.4825,0,NULL,59276840388,926200631,14471884,16.4),(109791,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109791,36.26,0.46,179,47145,70,NULL,NULL,'2MASX J13285234+1433377',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,202.2182917,14.56036,0.01,NULL,58823121184,919111268,14361113,16.6),(109792,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109792,38.25,0.46,447,47146,70,NULL,NULL,'2MASX J13285253+2313504',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,202.2187083,23.23056,0.023,NULL,58795631485,918681741,14354402,17.7),(109793,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109793,37.28,0.33,286,47147,70,NULL,NULL,'2MASX J13285268+3856556',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,202.219458333,38.94867,0,NULL,59298581078,926540329,14477192,17.3),(109794,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109794,38.14,0.46,425,47148,70,NULL,NULL,'2MASX J13285310+0330507',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00018,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,202.221333,3.51425,0,NULL,58937218550,920894039,14388969,17.4),(109795,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109795,37.6,0.46,332,47149,70,NULL,NULL,'2MASX J13285332-0126031',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000184,NULL,'16.6g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,202.222208333,-1.43408,0.037,NULL,43822770871,684730794,10698918,16.6),(109796,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109796,35.75,0.46,141,47150,70,NULL,NULL,'2MASX J13285390+5437296',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00016,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,202.224833,54.62472,0,NULL,57291148734,895174198,13987096,16.5),(109797,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109797,37.04,0.25,256,47151,74.4,NULL,NULL,'2MASX J13285425-3129178',NULL,'2013AJ....146...86T',2013,1,0.73,NULL,'G',0.000053,NULL,'14.9V',0.66,'E/S0','Group member',NULL,NULL,NULL,1,202.225875,-31.48822,0.145,NULL,46904525063,732883204,11451300,14.9),(109798,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109798,37.6,0.53,331,47151,70,NULL,NULL,'2MASX J13285425-3129178',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109799,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109799,37,0.75,251,47152,NULL,NULL,'Malmquist cor.','2MFGC 10840',NULL,'2009ApJS..182..474S',2009,1,0.29,NULL,'G',0.000033,NULL,'16.7V',0.12,NULL,'Group member',NULL,NULL,NULL,1,202.22625,-31.21525,0.145,NULL,46901098842,732829669,11450463,16.7),(109800,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109800,37.6,0.57,330,47152,NULL,NULL,NULL,'2MFGC 10840',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109801,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109801,37.64,0.2,337,47152,74.4,NULL,NULL,'2MFGC 10840',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109802,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109802,36.36,0.55,187,47153,70,NULL,NULL,'2MASX J13285497-1743275',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.74',0.3,NULL,NULL,NULL,NULL,NULL,1,202.2290417,-17.72456,0.201,NULL,43784375709,684130870,10689544,16.74),(109803,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109803,34.52,0.46,80.3,47154,70,NULL,NULL,'CGCG 218-014 NED02',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000083,NULL,'15.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,202.233666667,38.57439,0,NULL,59295256953,926488389,14476381,15.8),(109804,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109804,36.56,0.37,205,47155,NULL,NULL,'Malmquist cor.','FGCE 1067',NULL,'2009ApJS..182..474S',2009,1,0.68,NULL,'G',0.000037,NULL,'17.6V',0.09,'Sc','Group member',NULL,NULL,NULL,1,202.2337917,-31.52219,0.177,NULL,46904593803,732884278,11451316,17.6),(109805,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109805,36.63,0.36,212,47155,NULL,NULL,NULL,'FGCE 1067',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109806,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109806,36.67,0.2,216,47155,74.4,NULL,NULL,'FGCE 1067',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109807,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109807,38.42,0.33,483,47156,70,NULL,NULL,'2MASX J13285627+5431346',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,202.2345,54.52631,0,NULL,57279671301,894994864,13984294,18.2),(109808,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109808,35.71,0.69,139,47157,70,NULL,NULL,'2MASX J13285675-2803451',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.2b',NULL,'E',NULL,NULL,NULL,NULL,1,202.236541667,-28.06247,0.177,NULL,43297510335,676523598,10570681,16.2),(109809,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109809,35.85,0.66,148,47158,70,NULL,NULL,'2MFGC 10841',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00011,NULL,'14.3R',0.18,'Sp','Group member',NULL,NULL,NULL,1,202.238417,-31.81933,0.177,NULL,46904401002,732881265,11451269,14.3),(109810,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109810,39.22,0.46,699,47159,70,NULL,NULL,'2MASX J13285746+5229056',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,202.239625,52.48494,0.013,NULL,59207418574,925115915,14454936,18.1),(109811,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109811,36.94,0.46,245,47160,70,NULL,NULL,'SDSS J132858.06+390400.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,202.2419583,39.06672,0,NULL,59298583633,926540369,14477193,18.1),(109812,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109812,38.2,0.27,437,47161,70,NULL,NULL,'2MASX J13285813+6519285',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000082,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,202.242083,65.3245,0.045,NULL,57878854004,904357093,14130579,16.9),(109813,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109813,36.57,0.46,206,47162,70,NULL,NULL,'2MASX J13285885+1210527',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000162,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,202.245333,12.18142,0,NULL,59008008667,922000135,14406252,16.7),(109814,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109814,36.46,0.46,196,47163,70,NULL,NULL,'2MASX J13285917+0154568',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000166,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,202.246541667,1.91572,0,NULL,58925361833,920708778,14386074,16.8),(109815,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109815,37.16,0.17,271,47164,70,NULL,NULL,'2MASX J13285961+3742086',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.0002,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,202.248333,37.70233,0,NULL,59295661047,926494703,14476479,17),(109816,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109816,37.24,0.46,280,47165,70,NULL,NULL,'2MASX J13290036+2214095',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,202.251583,22.23586,0.031,NULL,58793635491,918650554,14353914,17.4),(109817,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109817,37.77,0.27,358,47166,70,NULL,NULL,'2MASX J13290096+1121362',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.4g',0.22,'BrClG',NULL,NULL,NULL,NULL,1,202.254083,11.35989,0,NULL,58940421991,920944093,14389751,17.4),(109818,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109818,38.45,0.46,491,47167,70,NULL,NULL,'SDSS J132901.72+102802.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000188,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,202.2572083,10.46742,0,NULL,58954108687,921157948,14393092,18.3),(109819,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109819,36.58,0.73,207,47168,70,NULL,NULL,'6dF J1329018-314955',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,202.25775,-31.83197,0.177,NULL,46904400739,732881261,11451269,15.5),(109820,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109820,37.17,0.46,271,47169,70,NULL,NULL,'2MASX J13290190+1042212',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.55',0.24,NULL,NULL,NULL,NULL,NULL,1,202.2580417,10.70597,0,NULL,58953585334,921149770,14392965,17.55),(109821,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109821,37.92,0.07,384,47170,70,NULL,NULL,'SDSS J132903.45-022117.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000156,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,202.264417,-2.35489,0.033,NULL,43825022849,684765982,10699468,18.5),(109822,'IRAS','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109822,35.03,0.8,101,47171,75,NULL,'HMCL, I','CGCG 072-083',NULL,'1997ApJS..109..333W',1997,1,0.82,NULL,'G',0.000027,NULL,'15.9g',0.24,'Sbc',NULL,NULL,NULL,NULL,1,202.2677083,12.23775,0,NULL,59008032443,922000506,14406257,15.9),(109823,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109823,35.4,0.4,120,47171,75,NULL,'HMCL, I, raw','CGCG 072-083',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109824,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109824,35.58,0.4,130,47171,75,NULL,'HMCL, I, inv','CGCG 072-083',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109825,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109825,35.58,0.4,131,47171,75,NULL,'HMCL, I, cor','CGCG 072-083',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109826,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109826,35.78,0.42,143,47172,NULL,NULL,'Malmquist cor.','2MASX J13290580-2710468',NULL,'2009ApJS..182..474S',2009,1,0.68,NULL,'G',0.00003,NULL,'14.59',0.28,'Sc','Group member',NULL,NULL,NULL,1,202.27425,-27.17969,0.193,NULL,43294944607,676483509,10570054,14.59),(109827,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109827,35.83,0.41,147,47172,NULL,NULL,NULL,'2MASX J13290580-2710468',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109828,'Tully-Fisher','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109828,35.87,0.2,149,47172,74.4,NULL,NULL,'2MASX J13290580-2710468',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109829,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109829,37.6,0.46,332,47173,70,NULL,NULL,'2MASX J13290729+6150131',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,202.280417,61.83708,0.013,NULL,57379941623,896561587,14008774,17.8),(109830,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109830,38.06,0.46,409,47174,70,NULL,NULL,'2MASX J13290748+0012084',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00008,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,202.281208333,0.20228,0.029,NULL,58049195347,907018677,14172166,17.3),(109831,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109831,36.98,0.46,249,47175,70,NULL,NULL,'2MASX J13290890+2429177',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,202.287083,24.48822,0.026,NULL,58663457788,916616527,14322133,17.5),(109832,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109832,35.64,0.25,134,47176,74.4,NULL,NULL,'2MASX J13291003-3132487',NULL,'2013AJ....146...86T',2013,1,0.43,NULL,'G',0.00016,NULL,'15.8V',0.39,'S0','Group member',NULL,NULL,NULL,1,202.291625,-31.54697,0.177,NULL,46904604661,732884447,11451319,15.8),(109833,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109833,37.2,0.46,276,47177,70,NULL,NULL,'2MASX J13291100+2927417',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000044,NULL,'16.3g',0.35,'E0             Sbrst',NULL,NULL,NULL,NULL,1,202.296,29.46156,0.033,NULL,59132307482,923942304,14436598,16.3),(109834,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109834,38.23,0.33,442,47178,70,NULL,NULL,'2MASX J13291172+5516068',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,202.298625,55.26872,0,NULL,57287029797,895109840,13986091,17.3),(109835,'CMD','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,NULL,109835,19.4,0.22,0.0759,47179,NULL,NULL,NULL,'SDSS J132911.76+284128.8',NULL,'2008A&A...477..139L',2008,1,0.04,NULL,'G',NULL,NULL,'23.0g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,202.299041667,28.69133,0.017,1,59131607854,923931372,14436427,23),(109836,'FP','2016-12-15 15:15:14','2016-12-16 11:20:27','1',NULL,'R',109836,37.2,0.46,276,47180,70,NULL,NULL,'2MASX J13291199+1017415',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,202.299916667,10.29478,0,NULL,58954336080,921161501,14393148,17.6),(109837,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109837,38.23,0.33,442,47181,70,NULL,NULL,'2MASX J13291207+5517258',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,202.300333,55.29064,0,NULL,57287030736,895109855,13986091,18.1),(109838,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109838,37.58,0.46,327,47182,70,NULL,NULL,'2MASX J13291224+0906495',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000177,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,202.301167,9.11394,0,NULL,58954626745,921166042,14393219,17.4),(109839,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109839,37.16,0.17,271,47183,70,NULL,NULL,'IC 4268',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000097,NULL,'16.59',0.24,'AGN',NULL,NULL,NULL,NULL,1,202.301375,37.6605,0,NULL,59295635446,926494303,14476473,16.59),(109840,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SNF20080514-002','R',109840,34.92,0.06,96.4,47184,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 08472',NULL,'2015Sci...347.1459K',2015,1,1.32,NULL,'G',0.00009,NULL,'14.7g',0.44,'S0',NULL,NULL,NULL,NULL,1,202.306833333,11.27583,0,NULL,58940408676,920943885,14389748,14.7),(109841,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SNF20080514-002','R',109841,34.97,0.06,98.6,47184,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 08472',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109842,'IRAS','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109842,32.26,0.8,28.4,47185,75,NULL,'MAT, I','NGC 5161',NULL,'1997ApJS..109..333W',1997,1,5.6,NULL,'G',0.00001,NULL,'12.0',2.2,'SA(s)c:        HII','Possible group member',NULL,NULL,NULL,1,202.3079583,-33.17383,0.173,NULL,46901912940,732842389,11450662,12),(109843,'IRAS','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109843,32.27,0.8,28.4,47185,75,NULL,'HMCL, I','NGC 5161',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109844,'IRAS','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109844,32.27,0.8,28.4,47185,75,NULL,'A82, H','NGC 5161',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109845,'Sosies','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109845,31.72,0.1,22.1,47185,NULL,NULL,NULL,'NGC 5161',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109846,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109846,31.2,0.69,17.4,47185,100,NULL,'mid-IR','NGC 5161',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109847,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109847,31.34,0.35,18.5,47185,NULL,NULL,NULL,'NGC 5161',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109848,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109848,31.34,0.4,18.5,47185,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5161',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109849,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109849,31.48,0.4,19.8,47185,75,NULL,'HMCL, I, raw','NGC 5161',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109850,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109850,31.51,0.47,20,47185,75,NULL,'A82, H, raw','NGC 5161',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109851,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109851,31.58,NULL,20.7,47185,NULL,NULL,'B','NGC 5161',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109852,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109852,31.61,0.2,21,47185,74.4,NULL,NULL,'NGC 5161',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109853,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109853,31.61,0.47,21,47185,75,NULL,'A82, H, inv','NGC 5161',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109854,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109854,31.63,0.32,21.2,47185,85,NULL,'I, raw','NGC 5161',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109855,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109855,31.63,0.4,21.2,47185,75,NULL,'HMCL, I, inv','NGC 5161',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109856,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109856,31.67,0.32,21.6,47185,85,NULL,'I, inv','NGC 5161',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109857,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109857,31.69,0.43,21.7,47185,75,NULL,'MAT, I, raw','NGC 5161',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109858,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109858,31.69,NULL,21.8,47185,NULL,NULL,'B','NGC 5161',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109859,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109859,31.69,0.43,21.8,47185,75,NULL,'3.6 micron, color corrected','NGC 5161',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109860,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109860,31.76,0.4,22.5,47185,75,NULL,'HMCL, I, cor','NGC 5161',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109861,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109861,31.81,NULL,23,47185,NULL,NULL,'I','NGC 5161',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109862,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109862,31.83,0.43,23.2,47185,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5161',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109863,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109863,31.88,0.43,23.7,47185,75,NULL,'MAT, I, inv','NGC 5161',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109864,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109864,31.9,0.47,24,47185,75,NULL,'A82, H, cor','NGC 5161',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109865,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109865,32,0.46,25.1,47185,NULL,NULL,'J','NGC 5161',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109866,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109866,32.01,0.43,25.3,47185,75,NULL,'MAT, I, cor','NGC 5161',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109867,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109867,32.05,0.47,25.7,47185,NULL,NULL,'H','NGC 5161',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109868,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109868,32.12,0.45,26.6,47185,NULL,NULL,'K','NGC 5161',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109869,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109869,32.62,0.4,33.4,47185,NULL,NULL,'mean','NGC 5161',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109870,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109870,32.62,0.4,33.5,47185,75,NULL,'B','NGC 5161',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109871,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109871,37.92,0.07,384,47186,70,NULL,NULL,'2MASX J13291475-0211426',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,202.311541667,-2.19528,0.041,NULL,43824538121,684758408,10699350,17.7),(109872,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109872,38.2,0.27,437,47187,70,NULL,NULL,'2MASX J13291496+6518442',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000086,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,202.312375,65.31236,0.045,NULL,57878846442,904356975,14130577,18),(109873,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109873,36.09,0.41,166,47188,NULL,NULL,'Malmquist cor.','2MASX J13291497-3116448',NULL,'2009ApJS..182..474S',2009,1,0.52,'Quintana, et al. (1995AJ....110..463Q) give v = 16167 +/- 75 km/sec.','G',0.00003,NULL,'14.8R',0.21,'Sc','Group member',NULL,NULL,NULL,1,202.312416667,-31.27914,0.173,NULL,46901089151,732829517,11450461,14.8),(109874,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109874,36.36,0.37,187,47188,NULL,NULL,NULL,'2MASX J13291497-3116448',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109875,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109875,36.4,0.2,191,47188,74.4,NULL,NULL,'2MASX J13291497-3116448',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109876,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109876,36.7,0.57,219,47189,70,NULL,NULL,'2MASX J13291521-3107448',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.6b',0.38,'E','Group member',NULL,NULL,NULL,1,202.313333,-31.12906,0.173,NULL,46901040943,732828764,11450449,16.6),(109877,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109877,37.83,0.23,368,47190,70,NULL,NULL,'2MASX J13291540+0932545',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.31',0.23,NULL,NULL,NULL,NULL,NULL,1,202.314167,9.54847,0,NULL,58954721564,921167524,14393242,17.31),(109878,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109878,35.37,0.19,119,47191,70,NULL,NULL,'CGCG 072-086',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.00008,NULL,'15.2g',0.59,'S0',NULL,NULL,NULL,NULL,1,202.314333,11.20317,0,NULL,58939837700,920934964,14389608,15.2),(109879,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109879,34.7,0.69,87.3,47192,100,NULL,'mid-IR','NGC 5201',NULL,'2013ApJ...771...88L',2013,1,1.2,NULL,'G',0.00003,NULL,'14.1g',0.78,'S?',NULL,NULL,NULL,NULL,1,202.3175417,53.08197,0.031,NULL,57281273037,895019891,13984685,14.1),(109880,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109880,35.33,0.47,116,47192,NULL,NULL,'H','NGC 5201',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109881,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109881,35.34,0.46,117,47192,NULL,NULL,'J','NGC 5201',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109882,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109882,35.34,0.45,117,47192,NULL,NULL,'K','NGC 5201',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109883,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109883,35.43,0.4,122,47192,NULL,NULL,'mean','NGC 5201',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109884,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109884,36.14,0.6,169,47193,70,NULL,NULL,'2MASX J13291697-3202338',NULL,'2014MNRAS.445.2677S',2014,1,0.71,NULL,'G',0.00015,NULL,'16.1b',0.57,'E','Group member',NULL,NULL,NULL,1,202.320833,-32.04275,0.177,NULL,46902497049,732851516,11450804,16.1),(109885,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109885,37.77,0.33,358,47194,70,NULL,NULL,'SDSS J132918.03+080709.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,202.325125,8.11925,0,NULL,58950297019,921098390,14392162,18.1),(109886,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109886,37.83,0.23,368,47195,70,NULL,NULL,'SDSS J132918.16+093225.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000166,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,202.3257083,9.54047,0,NULL,58954721626,921167525,14393242,18.4),(109887,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109887,38.2,0.27,437,47196,70,NULL,NULL,'SDSS J132918.51+651842.1',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00008,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,202.327125,65.31172,0.045,NULL,57878846242,904356972,14130577,17.2),(109888,'IRAS','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109888,33.74,0.8,56,47197,75,NULL,'CF, r','NGC 5172',NULL,'1997ApJS..109..333W',1997,1,3.3,NULL,'G',0.000003,NULL,'12.63',1.7,'SAB(rs)bc:','in a radial-velocity based grouping',NULL,NULL,NULL,1,202.3304583,17.05192,0,NULL,58833934905,919280232,14363753,12.63),(109889,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109889,33.6,NULL,52.5,47197,NULL,NULL,'B','NGC 5172',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109890,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109890,33.66,0.47,53.9,47197,NULL,NULL,'H','NGC 5172',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109891,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109891,33.67,0.46,54.2,47197,NULL,NULL,'J','NGC 5172',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109892,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109892,33.69,0.45,54.6,47197,NULL,NULL,'K','NGC 5172',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109893,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109893,33.69,0.38,54.7,47197,75,NULL,'CF, r, raw','NGC 5172',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109894,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109894,33.7,0.4,55.1,47197,NULL,NULL,'Malmquist cor.','NGC 5172',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109895,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109895,33.86,NULL,59.2,47197,NULL,NULL,'I','NGC 5172',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109896,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109896,33.88,0.37,59.6,47197,NULL,NULL,NULL,'NGC 5172',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109897,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109897,33.9,0.38,60.4,47197,75,NULL,'CF, r, inv','NGC 5172',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109898,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109898,33.92,0.2,60.8,47197,74.4,NULL,NULL,'NGC 5172',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109899,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109899,33.95,0.38,61.6,47197,75,NULL,'CF, r, cor','NGC 5172',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109900,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109900,33.99,0.4,62.7,47197,NULL,NULL,'mean','NGC 5172',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109901,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109901,37.54,0.46,322,47198,70,NULL,NULL,'2MASX J13292004+6024502',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000183,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,202.3339583,60.414,0,NULL,57392550306,896758598,14011853,17),(109902,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109902,36.51,0.62,200,47199,70,NULL,NULL,'2MASX J13292015-2930158',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.95',NULL,'S0',NULL,NULL,NULL,NULL,1,202.334,-29.50442,0.201,NULL,46847215040,731987735,11437308,14.95),(109903,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109903,37.92,0.07,384,47200,70,NULL,NULL,'2MASX J13292022-0213056',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000185,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,202.3342917,-2.21831,0.041,NULL,43824541260,684758457,10699350,17.2),(109904,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109904,37.77,0.27,359,47201,70,NULL,NULL,'2MASX J13292028+0042224',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000089,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,202.334583,0.70608,0.014,NULL,58921678626,920651228,14385175,17.8),(109905,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109905,36.47,0.63,197,47202,70,NULL,NULL,'2MASX J13292059-1336331',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,202.335875,-13.60928,0.085,NULL,43992287145,687379486,10740304,17.1),(109906,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109906,35.96,0.25,156,47203,74.4,NULL,NULL,'2MASX J13292074-3132248',NULL,'2013AJ....146...86T',2013,1,0.68,NULL,'G',0.000103,NULL,'14.9R',0.55,'E/S0','Group member',NULL,NULL,NULL,1,202.3364583,-31.54025,0.181,NULL,46904600339,732884380,11451318,14.9),(109907,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109907,36.97,0.52,248,47203,70,NULL,NULL,'2MASX J13292074-3132248',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109908,'BCG','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109908,37.09,0.35,248,47204,60,NULL,'ABELL 1749, BCG','IC 4269',0.0562,'1980ApJ...241..486H',1980,1,0.87,NULL,'G',0.000073,NULL,'14.7g',0.64,'cD','Brightest group member',NULL,NULL,NULL,1,202.337666667,37.62308,0,NULL,59295636159,926494314,14476473,14.7),(109909,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109909,37.77,0.27,359,47205,70,NULL,NULL,'2MASX J13292109+0044584',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000087,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,202.337875,0.74969,0.014,NULL,58922539209,920664675,14385385,17),(109910,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109910,38.32,0.46,461,47206,70,NULL,NULL,'2MASX J13292256-0152416',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,202.344125,-1.87836,0.037,NULL,43825645202,684775706,10699620,17.8),(109911,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109911,37.66,0.46,340,47207,70,NULL,NULL,'2MASX J13292263+2511186',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.76',0.17,NULL,NULL,NULL,NULL,NULL,1,202.3442083,25.18836,0.023,NULL,58667410849,916678294,14323098,17.76),(109912,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109912,34.94,0.33,97.4,47208,70,NULL,NULL,'2MASX J13292274+3205114',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000067,NULL,'16.3g',0.26,'E6',NULL,NULL,NULL,NULL,1,202.344875,32.08639,0.01,NULL,59180025262,924687894,14448248,16.3),(109913,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109913,35.9,0.46,151,47209,NULL,NULL,'Malmquist cor.','2MASX J13292280-2659218',NULL,'2009ApJS..182..474S',2009,1,0.56,NULL,'G',0.000033,NULL,'15.1R',0.32,'SBbc','Group member',NULL,NULL,NULL,1,202.3450417,-26.98933,0.189,NULL,43294928411,676483256,10570050,15.1),(109914,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109914,36.05,0.43,162,47209,NULL,NULL,NULL,'2MASX J13292280-2659218',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109915,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109915,36.09,0.2,165,47209,74.4,NULL,NULL,'2MASX J13292280-2659218',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109916,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109916,33.36,0.45,47,47210,NULL,NULL,'K','ESO 383- G 005',NULL,'2007A&A...465...71T',2007,1,3.5,NULL,'G',0.000017,NULL,'14.21',0.5,'Sbc            HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,202.3482083,-34.27128,0.153,NULL,46864248378,732253880,11441466,14.21),(109917,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109917,33.39,0.47,47.6,47210,NULL,NULL,'H','ESO 383- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109918,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109918,33.4,0.43,47.9,47210,75,NULL,'3.6 micron, color + selection bias corrected','ESO 383- G 005',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109919,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109919,33.55,0.46,51.3,47210,NULL,NULL,'J','ESO 383- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109920,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109920,33.62,0.4,52.9,47210,NULL,NULL,'mean','ESO 383- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109921,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109921,33.64,0.49,53.3,47210,75,NULL,'IR','ESO 383- G 005',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109922,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109922,33.64,0.43,53.5,47210,75,NULL,'3.6 micron, color corrected','ESO 383- G 005',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109923,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109923,33.95,0.2,61.7,47210,74.4,NULL,NULL,'ESO 383- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109924,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109924,37.56,0.46,325,47211,70,NULL,NULL,'2MASX J13292367+2325213',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,202.3484583,23.42267,0.023,NULL,58794457956,918663405,14354115,17),(109925,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109925,38.19,0.46,434,47212,70,NULL,NULL,'SDSS J132923.68+105930.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,202.3487083,10.99181,0,NULL,58939894185,920935846,14389622,18.5),(109926,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2010cr',NULL,109926,35.05,0.05,100,47213,70,NULL,'SiFTO+SALT2, SN PTF10fps, SN 2010cr','NGC 5177',0.02157,'2012MNRAS.426.2359M',2012,1,0.81,NULL,'G',0.000097,NULL,'15.1g',0.46,'S0','Group member',NULL,NULL,NULL,1,202.351083333,11.79703,0,NULL,58940020707,920937823,14389653,15.1),(109927,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2010cr',NULL,109927,35.08,0.05,102,47213,70,NULL,'SN 2010cr, SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','NGC 5177',0.02157,'2014MNRAS.438.1391P',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109928,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109928,37.13,0.46,267,47214,70,NULL,NULL,'2MASX J13292448+4520458',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000186,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,202.351833,45.34622,0,NULL,59286514116,926351783,14474246,16.2),(109929,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109929,37.09,0.33,262,47215,70,NULL,NULL,'2MASX J13292453+1000265',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00016,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,202.352083,10.00725,0,NULL,58954283078,921160673,14393135,16.6),(109930,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109930,37.23,0.46,279,47216,70,NULL,NULL,'2MASX J13292454+3254364',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000188,NULL,'16.6g',0.24,'E2',NULL,NULL,NULL,NULL,1,202.3522917,32.91011,0,NULL,59179605291,924681332,14448145,16.6),(109931,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109931,38.3,0.46,456,47217,70,NULL,NULL,'2MASX J13292467+1115105',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000164,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,202.35275,11.25303,0,NULL,58940228004,920941062,14389704,17.4),(109932,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109932,35.37,0.19,119,47218,70,NULL,NULL,'NGC 5176',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.00009,NULL,'14.9g',0.61,'S0','Group member',NULL,NULL,NULL,1,202.354,11.78147,0,NULL,58940020171,920937815,14389653,14.9),(109933,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109933,35.37,0.19,119,47219,70,NULL,NULL,'2MASX J13292536+1202395',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000187,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,202.355583,12.04431,0,NULL,59007977984,921999656,14406244,16.4),(109934,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109934,35.13,0.57,106,47220,70,NULL,NULL,'2MASX J13292560-2043462',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.28',NULL,NULL,NULL,NULL,NULL,NULL,1,202.3567083,-20.72972,0.237,NULL,43817990290,684656098,10697751,15.28),(109935,'IRAS','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109935,34.86,0.8,94,47221,75,NULL,'HMCL, I','NGC 5162',NULL,'1997ApJS..109..333W',1997,1,1.8,'Called \'double nebula\' in CGCG; UGC calls it galaxy with star superposed.','G',0.000003,NULL,'15.5g',1.01,'Scd:','Field galaxy',NULL,NULL,NULL,1,202.3580417,11.00789,0,NULL,58939926195,920936346,14389630,15.5),(109936,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109936,34.01,0.69,63.4,47221,100,NULL,'mid-IR','NGC 5162',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109937,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109937,34.46,0.4,77.9,47221,75,NULL,'HMCL, I, raw','NGC 5162',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109938,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109938,34.76,0.4,89.6,47221,75,NULL,'HMCL, I, inv','NGC 5162',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109939,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109939,34.79,0.4,90.8,47221,75,NULL,'HMCL, I, cor','NGC 5162',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109940,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109940,34.92,0.23,96.6,47221,NULL,NULL,'Malmquist cor.','NGC 5162',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109941,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109941,35.02,0.46,101,47221,NULL,NULL,'J','NGC 5162',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109942,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109942,35.03,0.22,101,47221,NULL,NULL,NULL,'NGC 5162',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109943,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109943,35.04,0.4,102,47221,NULL,NULL,'mean','NGC 5162',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109944,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109944,35.05,0.47,102,47221,NULL,NULL,'H','NGC 5162',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109945,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109945,35.05,0.2,102,47221,74.4,NULL,NULL,'NGC 5162',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109946,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109946,35.13,0.45,106,47221,NULL,NULL,'K','NGC 5162',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109947,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109947,35.02,0.4,101,47222,NULL,NULL,'mean','NGC 5180',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000103,NULL,'13.96',1,'S0?','in a pair',NULL,NULL,NULL,1,202.362333333,16.82583,0,NULL,58834016224,919281503,14363773,13.96),(109948,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109948,35.19,0.45,109,47222,NULL,NULL,'K','NGC 5180',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109949,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109949,36.19,0.25,173,47223,74.4,NULL,NULL,'2MASX J13292810-3133048',NULL,'2013AJ....146...86T',2013,1,0.71,NULL,'G',0.0001,NULL,'15.4b',0.57,'E','Group member',NULL,NULL,NULL,1,202.367125,-31.55128,0.181,NULL,46904602262,732884410,11451318,15.4),(109950,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109950,36.44,0.48,194,47223,70,NULL,NULL,'2MASX J13292810-3133048',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109951,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109951,35.31,0.57,116,47224,70,NULL,NULL,'IC 4259',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000097,NULL,'17.1b',0.5,'S?',NULL,NULL,NULL,NULL,1,202.3672917,-30.13494,0.221,NULL,46846582157,731977846,11437153,17.1),(109952,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109952,36.72,0.27,221,47225,70,NULL,NULL,'2MASX J13292877+2949496',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000097,NULL,'16.3g',0.31,'E1',NULL,NULL,NULL,NULL,1,202.3697917,29.8305,0.031,NULL,59132189704,923940464,14436569,16.3),(109953,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109953,34.89,0.4,95.2,47226,NULL,NULL,'mean','ARK 419',NULL,'2007A&A...465...71T',2007,1,0.4,NULL,'G',0.000057,NULL,'15.3',0.3,'Sc',NULL,NULL,NULL,NULL,1,202.3705,-3.68044,0.049,NULL,43831593392,684868646,10701072,15.3),(109954,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109954,34.96,0.47,98.3,47226,NULL,NULL,'H','ARK 419',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109955,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109955,35.04,0.45,102,47226,NULL,NULL,'K','ARK 419',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109956,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109956,35.05,0.46,103,47226,NULL,NULL,'J','ARK 419',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109957,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109957,37.5,0.46,316,47227,70,NULL,NULL,'2MASX J13292935+0659525',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.99',0.14,NULL,NULL,NULL,NULL,NULL,1,202.3722083,6.99789,0,NULL,58980788618,921574822,14399606,17.99),(109958,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109958,35.37,0.19,119,47228,70,NULL,NULL,'NGC 5179',NULL,'2015arXiv151105856S',2015,1,0.99,NULL,'G',0.000073,NULL,'14.4g',0.73,'S0','Group member',NULL,NULL,NULL,1,202.378667,11.74583,0,NULL,58940021317,920937833,14389653,14.4),(109959,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109959,38.03,0.46,404,47229,70,NULL,NULL,'2MASX J13293122+5148124',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000155,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,202.380166667,51.8035,0,NULL,59207459324,925116551,14454946,17.3),(109960,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109960,38.02,0.27,402,47230,70,NULL,NULL,'SDSS J132931.31+002750.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000067,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,202.3804583,0.46394,0.033,NULL,58921817102,920653392,14385209,18.7),(109961,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109961,38.14,0.46,426,47231,70,NULL,NULL,'2MASX J13293141+5137054',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000139,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,202.3810417,51.61819,0,NULL,59207591149,925118611,14454978,18.4),(109962,'BCG','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109962,37.09,0.35,248,47232,60,NULL,NULL,'ABELL 1749',0.0562,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',0.000527,NULL,NULL,NULL,'II:    [BM]',NULL,NULL,NULL,NULL,1,202.384583333,37.62544,0,NULL,59295508200,926492315,14476442,NULL),(109963,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109963,37.69,0.46,346,47233,70,NULL,NULL,'2MASX J13293286+5322184',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000133,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,202.386875,53.37175,0,NULL,57281566661,895024479,13984757,17.6),(109964,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109964,37.57,0.27,326,47234,70,NULL,NULL,'2MASX J13293336+5905519',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,202.388917,59.09786,0,NULL,57390516103,896726814,14011356,17.4),(109965,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109965,36.72,0.27,221,47235,70,NULL,NULL,'2MASX J13293432+2942535',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000168,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,202.393125,29.71472,0.031,NULL,59132319757,923942496,14436601,17.8),(109966,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109966,37.83,0.23,368,47236,70,NULL,NULL,'2MASX J13293541+0936565',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000191,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,202.397666667,9.61581,0,NULL,58954733287,921167707,14393245,18),(109967,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109967,35.99,0.48,158,47237,NULL,NULL,'Malmquist cor.','2MASX J13293644-2749597',NULL,'2009ApJS..182..474S',2009,1,0.38,NULL,'G',0.000033,NULL,'16',0.26,'Sb             HII','Group member',NULL,NULL,NULL,1,202.4017917,-27.83331,0.177,NULL,43295314627,676489291,10570145,16),(109968,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109968,36.23,0.43,176,47237,NULL,NULL,NULL,'2MASX J13293644-2749597',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109969,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109969,36.27,0.2,179,47237,74.4,NULL,NULL,'2MASX J13293644-2749597',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109970,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109970,38.02,0.27,402,47238,70,NULL,NULL,'2MASX J13293644+0027244',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000085,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,202.402,0.45689,0.033,NULL,58921825112,920653517,14385211,17),(109971,'Brightest Stars','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109971,28.06,NULL,4.1,47239,NULL,NULL,NULL,'NGC 5204',NULL,'2000A&AS..142..425D',2000,1,5,NULL,'G',0.000003,NULL,'11.73',3,'SA(s)m         HII','Possible field galaxy',NULL,NULL,NULL,1,202.402125,58.41872,0.005,NULL,57387316853,896676825,14010575,11.73),(109972,'CMD','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109972,28.4,0.05,4.79,47239,NULL,NULL,NULL,'NGC 5204',NULL,'2015MNRAS.450.3886M',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109973,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109973,27.61,NULL,3.32,47239,NULL,NULL,NULL,'NGC 5204',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109974,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109974,28.3,0.19,4.57,47239,NULL,NULL,NULL,'NGC 5204',NULL,'2013AstBu..68..125M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109975,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109975,28.34,0.27,4.65,47239,NULL,NULL,NULL,'NGC 5204',NULL,'2003A&A...398..467K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109976,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109976,28.39,0.09,4.76,47239,74.4,NULL,NULL,'NGC 5204',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109977,'HII region diameter','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109977,29.05,0.16,6.46,47239,NULL,NULL,'Method 2','NGC 5204',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109978,'HII region diameter','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109978,29.52,0.09,8.02,47239,NULL,NULL,'Method 1','NGC 5204',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109979,'IRAS','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109979,29.29,0.8,7.21,47239,75,NULL,'A82, H','NGC 5204',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109980,'Magnitude','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109980,28.73,0.16,5.57,47239,NULL,NULL,NULL,'NGC 5204',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109981,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109981,28.17,0.4,4.3,47239,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5204',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109982,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109982,28.35,0.47,4.68,47239,75,NULL,'A82, H, inv','NGC 5204',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109983,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109983,28.39,0.09,4.76,47239,74.4,NULL,NULL,'NGC 5204',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109984,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109984,28.4,0.4,4.8,47239,75,NULL,'B','NGC 5204',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109985,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109985,28.43,NULL,4.85,47239,NULL,NULL,'IR','NGC 5204',NULL,'1980ApJ...237..655A',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109986,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109986,28.6,0.47,5.25,47239,75,NULL,'A82, H, raw','NGC 5204',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109987,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109987,28.69,NULL,5.47,47239,NULL,NULL,'LEDA [April 2006]','NGC 5204',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109988,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109988,28.7,0.43,5.5,47239,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5204',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109989,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109989,28.73,0.43,5.6,47239,75,NULL,'3.6 micron, color corrected','NGC 5204',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109990,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109990,28.98,0.47,6.24,47239,75,NULL,'A82, H, cor','NGC 5204',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(109991,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109991,37.16,0.17,271,47240,70,NULL,NULL,'2MASX J13293664+3737441',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000127,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,202.4027083,37.62894,0,NULL,59295510123,926492345,14476442,17.4),(109992,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109992,37.92,0.07,384,47241,70,NULL,NULL,'SDSS J132937.38-020636.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000149,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,202.40575,-2.11017,0.033,NULL,43824537285,684758395,10699349,18.4),(109993,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109993,38.16,0.46,429,47242,70,NULL,NULL,'SDSS J132937.86+091311.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,202.4077917,9.21975,0,NULL,58952553005,921133640,14392713,18.1),(109994,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109994,38.42,0.33,483,47243,70,NULL,NULL,'2MASX J13293846+5427239',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,202.4102917,54.45653,0,NULL,57279649269,894994519,13984289,17.6),(109995,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109995,38.05,0.23,407,47244,70,NULL,NULL,'2MASX J13293863+1127382',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.99',0.21,NULL,NULL,NULL,NULL,NULL,1,202.411083,11.46053,0,NULL,58940216643,920940885,14389701,17.99),(109996,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109996,38.11,0.46,418,47245,70,NULL,NULL,'SDSS J132938.90+055552.7',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,202.412083,5.93133,0.036,NULL,58926202591,920721915,14386279,17.8),(109997,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,109997,31.96,0.4,24.6,47246,75,NULL,'B','UGC 08489',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.00003,NULL,'14.62',0.6,'SABdm','Dwarf, possible member',NULL,NULL,NULL,1,202.4130417,45.38719,0,NULL,59286513147,926351767,14474246,14.62),(109998,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109998,36.72,0.27,221,47247,70,NULL,NULL,'UGC 08483',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.00009,NULL,'15.0g',0.63,'S?',NULL,NULL,NULL,NULL,1,202.413625,29.77011,0.031,NULL,59132196134,923940564,14436571,15),(109999,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',109999,38.15,0.46,427,47248,70,NULL,NULL,'SDSS J132939.57+062139.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,202.414916667,6.36092,0.024,NULL,58981190539,921581102,14399704,18),(110000,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110000,37.97,0.46,392,47249,70,NULL,NULL,'2MASX J13293975-0128421',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,202.4154583,-1.47839,0.037,NULL,43822646949,684728858,10698888,17.5),(110001,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110001,37.26,0.46,284,47250,70,NULL,NULL,'2MASX J13293990+4158517',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,202.4164583,41.98125,0,NULL,59322471507,926913617,14483025,17.7),(110002,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110002,37.77,0.27,359,47251,70,NULL,NULL,'2MASX J13294025+0044314',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000075,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,202.41775,0.74197,0.014,NULL,58921672765,920651136,14385174,17.4),(110003,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110003,37.82,0.33,366,47252,70,NULL,NULL,'SDSS J132941.22+192758.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,202.42175,19.46622,0.018,NULL,58852650348,919572661,14368322,18.4),(110004,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110004,35.64,0.46,135,47253,70,NULL,NULL,'2MASX J13294157+1218504',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.50',0.22,NULL,NULL,NULL,NULL,NULL,1,202.423333,12.31406,0,NULL,59008073024,922001141,14406267,17.5),(110005,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110005,34.91,0.52,95.7,47254,70,NULL,NULL,'2MASX J13294171-2236562',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.73',NULL,NULL,NULL,NULL,NULL,NULL,1,202.423833,-22.61569,0.233,NULL,43766146689,683846042,10685094,15.73),(110006,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110006,35.29,0.46,114,47255,70,NULL,NULL,'NGC 5181',NULL,'2015arXiv151105856S',2015,1,1.06,NULL,'G',0.00011,NULL,'14.1g',0.91,NULL,NULL,NULL,NULL,NULL,1,202.425,13.30411,0,NULL,59009522716,922023792,14406621,14.1),(110007,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110007,38.05,0.23,407,47256,70,NULL,NULL,'SDSS J132942.22+112333.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000149,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,202.425917,11.39258,0,NULL,58940247180,920941362,14389708,18.7),(110008,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110008,37.92,0.07,384,47257,70,NULL,NULL,'2MASX J13294317-0211171',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,202.4297917,-2.18814,0.033,NULL,43824530782,684758293,10699348,17.7),(110009,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110009,37.92,0.07,384,47258,70,NULL,NULL,'2MASX J13294343-0207301',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000169,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,202.4309583,-2.12494,0.033,NULL,43824535899,684758373,10699349,18),(110010,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110010,38.19,0.46,435,47259,70,NULL,NULL,'SDSS J132943.68+022051.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000229,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,202.432,2.34772,0.016,NULL,58923662355,920682224,14385659,17.7),(110011,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110011,37.3,0.46,289,47260,70,NULL,NULL,'2MASX J13294423+0948552',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,202.4342083,9.81519,0,NULL,58954222019,921159719,14393120,17.8),(110012,'IRAS','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110012,34.68,0.8,86.3,47261,75,NULL,'HMCL, I','CGCG 072-097',NULL,'1997ApJS..109..333W',1997,1,0.98,NULL,'G',0.000023,NULL,'15.8g',0.35,NULL,NULL,NULL,NULL,NULL,1,202.435166667,9.93314,0,NULL,58954224826,921159762,14393121,15.8),(110013,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110013,34.44,0.4,77.4,47261,75,NULL,'HMCL, I, raw','CGCG 072-097',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110014,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110014,34.5,0.4,79.3,47261,75,NULL,'HMCL, I, inv','CGCG 072-097',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110015,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110015,34.78,0.4,90.5,47261,75,NULL,'HMCL, I, cor','CGCG 072-097',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110016,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110016,34.91,0.2,95.9,47261,74.4,NULL,NULL,'CGCG 072-097',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110017,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110017,34.71,0.58,87.4,47262,70,NULL,NULL,'2MASX J13294469-2023462',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.62',0.4,NULL,NULL,NULL,NULL,NULL,1,202.43625,-20.39628,0.261,NULL,43818819562,684669055,10697953,15.62),(110018,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110018,37.06,0.46,258,47263,70,NULL,NULL,'2MASX J13294528+3236395',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'16.8g',0.3,'E0',NULL,NULL,NULL,NULL,1,202.438875,32.61103,0.012,NULL,59180475790,924694934,14448358,16.8),(110019,'GRB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110019,46.3,0.67,3800,47264,NULL,NULL,NULL,'GRB 050502',3.79,'2008AIPC.1065..367L',2008,1,NULL,NULL,'VisS',NULL,NULL,'19.8V',NULL,'INTEGRAL',NULL,NULL,NULL,NULL,1,202.442958333,42.67422,0,NULL,59323270167,926926096,14483220,19.8),(110020,'GRB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110020,47.24,0.64,5860,47264,69.7,NULL,'Calibrated','GRB 050502',3.79,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110021,'GRB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110021,47.51,0.63,6630,47264,69.7,NULL,'Fiducial','GRB 050502',3.79,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110022,'GRB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110022,47.87,0.67,7830,47264,72,NULL,NULL,'GRB 050502',3.79,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110023,'GRB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110023,48.06,0.67,8540,47264,70,NULL,NULL,'GRB 050502',3.79,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110024,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110024,37.2,0.33,276,47265,70,NULL,NULL,'2MASX J13294660+3840236',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,202.4442083,38.67322,0,NULL,59295244451,926488194,14476378,17.8),(110025,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110025,35.73,0.46,140,47266,70,NULL,NULL,'2MASX J13294692+0627542',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.34',0.2,NULL,NULL,NULL,NULL,NULL,1,202.445583333,6.46519,0,NULL,58981328954,921583264,14399738,17.34),(110026,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110026,35.64,0.47,134,47267,70,NULL,NULL,'IC 4261',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.5',0.7,'S0',NULL,NULL,NULL,NULL,1,202.448583,-28.00636,0.177,NULL,43295326887,676489482,10570148,15.5),(110027,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110027,35.65,0.68,135,47268,70,NULL,NULL,'6dF J1329477-313625',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,202.4489583,-31.60694,0.181,NULL,46904631868,732884872,11451326,14.1),(110028,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110028,37.72,0.33,350,47269,70,NULL,NULL,'2MASX J13294794+1142332',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000171,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,202.449583,11.70914,0,NULL,58940145170,920939768,14389683,16.5),(110029,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110029,35.13,0.47,106,47270,NULL,NULL,'H','NGC 5187',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.00003,NULL,'14.2g',0.72,'Sb',NULL,NULL,NULL,NULL,1,202.450791667,31.13014,0.023,NULL,59178094546,924657727,14447776,14.2),(110030,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110030,35.13,0.4,106,47270,NULL,NULL,'mean','NGC 5187',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110031,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110031,35.25,0.45,112,47270,NULL,NULL,'K','NGC 5187',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110032,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110032,35.26,0.46,113,47270,NULL,NULL,'J','NGC 5187',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110033,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110033,37.04,0.62,256,47271,70,NULL,NULL,'2MASX J13294834-3115580',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'16.5B',0.61,'E','Group member',NULL,NULL,NULL,1,202.451333,-31.26622,0.173,NULL,46904515125,732883048,11451297,16.5),(110034,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110034,37.77,0.33,358,47272,70,NULL,NULL,'2MASX J13294840+0814172',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000167,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,202.451667,8.23822,0,NULL,58950848542,921107008,14392297,16.4),(110035,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110035,37.91,0.46,382,47273,70,NULL,NULL,'2MASX J13294856+3423065',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,202.4524583,34.38508,0,NULL,59167196341,924487442,14445116,17.7),(110036,'GCLF','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110036,31.5,0.34,20,47274,NULL,NULL,'HST KP Calibrated, V','NGC 5170',NULL,'2000ApJ...529..745F',2000,1,9.91,NULL,'G',0.000001,NULL,'12.35',1.23,'SA(s)c: sp',NULL,NULL,NULL,NULL,1,202.4532917,-17.96642,0.209,NULL,43782304383,684098505,10689039,12.35),(110037,'GCLF','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110037,31.76,0.23,22.5,47274,NULL,NULL,NULL,'NGC 5170',NULL,'2000ApJS..128..431F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110038,'GCLF','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110038,32.3,0.3,28.8,47274,NULL,NULL,NULL,'NGC 5170',NULL,'1990PASP..102....5F',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110039,'GC radius','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110039,31.45,0.15,19.5,47274,NULL,NULL,NULL,'NGC 5170',NULL,'2010MNRAS.403..429F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110040,'IRAS','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110040,31.38,0.8,18.9,47274,75,NULL,'A82, H','NGC 5170',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110041,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110041,31.67,0.4,21.6,47274,75,NULL,NULL,'NGC 5170',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110042,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110042,31.78,NULL,22.7,47274,NULL,NULL,'Dipole','NGC 5170',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110043,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110043,31.79,NULL,22.8,47274,NULL,NULL,'Dipole + Quadrupole','NGC 5170',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110044,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110044,31.79,NULL,22.8,47274,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 5170',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110045,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110045,31.84,0.41,23.4,47274,NULL,NULL,'Malmquist cor.','NGC 5170',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110046,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110046,31.84,0.4,23.4,47274,NULL,NULL,NULL,'NGC 5170',NULL,'2013MNRAS.429.2677K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110047,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110047,31.89,0.4,23.9,47274,NULL,NULL,NULL,'NGC 5170',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110048,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110048,31.9,0.4,24,47274,75,NULL,'B','NGC 5170',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110049,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110049,31.91,0.2,24.1,47274,74.4,NULL,NULL,'NGC 5170',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110050,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110050,31.93,NULL,24.3,47274,NULL,NULL,NULL,'NGC 5170',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110051,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110051,32.24,0.43,28,47274,75,NULL,'3.6 micron, color corrected','NGC 5170',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110052,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110052,32.47,0.43,31.2,47274,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5170',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110053,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110053,32.64,0.4,33.7,47274,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5170',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110054,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110054,32.86,0.47,37.4,47274,75,NULL,'A82, H, raw','NGC 5170',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110055,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110055,33.01,0.49,40,47274,75,NULL,'IR','NGC 5170',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110056,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110056,33.1,0.47,41.7,47274,75,NULL,'A82, H, cor','NGC 5170',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110057,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110057,33.16,0.47,42.9,47274,75,NULL,'A82, H, inv','NGC 5170',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110058,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110058,38.85,0.46,589,47275,70,NULL,NULL,'2MASX J13294983+0014224',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000072,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,202.45775,0.23944,0.033,NULL,58921641764,920650652,14385166,18),(110059,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110059,37.92,0.07,384,47276,70,NULL,NULL,'2MASX J13295057-0211141',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000146,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,202.460583,-2.18719,0.033,NULL,43824646443,684760100,10699376,17.6),(110060,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110060,35.79,0.5,144,47277,70,NULL,NULL,'ESO 444- G 055',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00001,NULL,'14.35',0.8,'E3','Compact group member',NULL,NULL,NULL,1,202.4622083,-29.51464,0.201,NULL,46847008957,731984514,11437258,14.35),(110061,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110061,37.17,0.46,271,47278,70,NULL,NULL,'2MASX J13295195+4027586',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000189,NULL,'16.2g',0.32,NULL,NULL,NULL,NULL,NULL,1,202.466416667,40.46619,0,NULL,59314600735,926790636,14481103,16.2),(110062,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110062,37.42,0.23,305,47279,70,NULL,NULL,'2MASX J13295264+0851482',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000191,NULL,'16.0g',0.38,NULL,NULL,NULL,NULL,NULL,1,202.4692083,8.86333,0,NULL,58949904042,921092250,14392066,16),(110063,'CMD','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110063,29.2,NULL,6.92,47280,NULL,NULL,NULL,'MESSIER 051a',NULL,'1990PAZh...16..979G',1990,1,11.2,NULL,'G',0.00001,NULL,'8.96',6.9,'SA(s)bc pec;HIISy2.5','Pair member (points to parent)',NULL,NULL,'Sy 2',1,202.469625,47.19517,0,NULL,59290405649,926412588,14475196,8.96),(110064,'PNLF','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110064,29.41,0.12,7.62,47280,NULL,NULL,'NGC 5194, v gsr = 551','MESSIER 051a',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110065,'PNLF','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110065,29.52,0.12,8.02,47280,NULL,NULL,'HST KP Calibrated','MESSIER 051a',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110066,'PNLF','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110066,29.62,0.15,8.4,47280,NULL,NULL,'64, NGC 5194, v gsr = 551','MESSIER 051a',NULL,'1997ApJ...479..231F',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110067,'SBF','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110067,29.32,0.14,7.31,47280,74.4,NULL,'NGC 5195','MESSIER 051a',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110068,'SBF','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110068,29.42,0.27,7.66,47280,NULL,NULL,'I, NGC 5194, v gsr = 551','MESSIER 051a',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110069,'SBF','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110069,29.47,0.28,7.83,47280,NULL,NULL,'HST KP Calibrated, I','MESSIER 051a',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110070,'SBF','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110070,29.59,0.15,8.28,47280,NULL,NULL,'NGC 5195','MESSIER 051a',NULL,'1996AJ....111..327R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110071,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110071,29.74,0.14,8.88,47280,NULL,NULL,'Field 2','MESSIER 051a',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110072,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110072,29.78,0.13,9.05,47280,NULL,NULL,'Field 1','MESSIER 051a',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110073,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110073,29.79,0.14,9.09,47280,NULL,NULL,'Field 3','MESSIER 051a',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110074,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110074,29.98,0.15,9.9,47280,NULL,NULL,'NGC 5194, v gsr = 551','MESSIER 051a',NULL,'2009AstL...35..599T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110075,'CO ring diameter','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110075,29.65,NULL,8.5,47280,NULL,NULL,NULL,'MESSIER 051a',NULL,'1991PASJ...43..671S',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110076,'GC radius','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110076,29.67,NULL,8.6,47280,NULL,NULL,'NGC 5194, v gsr = 551','MESSIER 051a',NULL,'2009gcgg.book..103S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110077,'Grav. Stability Gas. Disk','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110077,29.35,NULL,7.4,47280,NULL,NULL,NULL,'MESSIER 051a',NULL,'1996AstL...22...71Z',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110078,'HII region diameter','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110078,29.57,0.15,8.2,47280,NULL,NULL,'NGC 5194, v gsr = 551','MESSIER 051a',NULL,'2005JKAS...38....7I',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110079,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110079,28.91,0.05,6.06,47280,NULL,NULL,'EPM, H01, fixed explosion epoch','MESSIER 051a',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110080,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110080,28.96,0.17,6.2,47280,NULL,NULL,'EPM, H01','MESSIER 051a',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110081,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110081,29.02,NULL,6.36,47280,NULL,NULL,'SCM, NGC 5194, v gsr = 551','MESSIER 051a',NULL,'2006MNRAS.372.1735T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110082,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 1994I',NULL,110082,29.2,0.3,6.92,47280,NULL,NULL,'Type Ic, NGC 5194','MESSIER 051a',NULL,'1994ApJ...437L.115I',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110083,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110083,29.37,0.04,7.49,47280,NULL,NULL,'EPM, D05, fixed explosion epoch','MESSIER 051a',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110084,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110084,29.38,0.06,7.5,47280,NULL,NULL,'EPM, expansion velocity modeled','MESSIER 051a',NULL,'2012MNRAS.419.2783T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110085,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110085,29.4,NULL,7.59,47280,NULL,NULL,'EPM, NGC 5194, v gsr = 551','MESSIER 051a',NULL,'2006MNRAS.372.1735T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110086,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110086,29.46,0.11,7.8,47280,NULL,NULL,'SCM','MESSIER 051a',NULL,'2015ApJ...799..215P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110087,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110087,29.5,0.18,7.9,47280,NULL,NULL,'SEAM, NGC 5194, v gsr = 551','MESSIER 051a',NULL,'2007ApJ...662.1148B',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110088,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110088,29.51,0.14,7.97,47280,NULL,NULL,'EPM, D05','MESSIER 051a',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110089,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 1994I',NULL,110089,29.6,0.5,8.3,47280,NULL,NULL,'SEAM, Type Ic SN, NGC 5194, v gsr = 551','MESSIER 051a',NULL,'1996MNRAS.279..799B',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110090,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 1994I',NULL,110090,29.6,0.3,8.32,47280,NULL,NULL,'Type Ic, NGC 5194','MESSIER 051a',NULL,'1996AJ....111..327R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110091,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110091,29.61,0.21,8.32,47280,NULL,NULL,'SEAM','MESSIER 051a',0.002,'2009ApJ...694.1067P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110092,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2011dh',NULL,110092,29.62,0.05,8.4,47280,NULL,NULL,'EPM, +/- 0.13 syst.','MESSIER 051a',NULL,'2012A&A...540A..93V',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110093,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110093,29.63,0.05,8.43,47280,NULL,NULL,'I, photospheric magnitude method, NGC 5194','MESSIER 051a',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110094,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110094,29.67,0.05,8.6,47280,NULL,NULL,'EPM','MESSIER 051a',NULL,'2012MNRAS.419.2783T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110095,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110095,29.75,0.12,8.9,47280,NULL,NULL,'SCM, NGC 5194, v gsr = 551','MESSIER 051a',NULL,'2008ApJ...675..644D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110096,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110096,29.75,0.16,8.9,47280,NULL,NULL,'SEAM, NGC 5194, v gsr = 551','MESSIER 051a',NULL,'2008ApJ...675..644D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110097,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110097,29.77,0.08,8.99,47280,NULL,NULL,'V, photospheric magnitude method, NGC 5194','MESSIER 051a',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110098,'Tully est','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110098,29.85,0.8,9.3,47280,75,NULL,'B, NGC 5195, v gsr = 573','MESSIER 051a',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110099,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110099,28.45,NULL,4.9,47280,65.2,NULL,'CO','MESSIER 051a',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110100,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110100,28.74,NULL,5.6,47280,75,NULL,'HI','MESSIER 051a',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110101,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110101,28.84,NULL,5.86,47280,NULL,NULL,'LEDA [Nov 2006]','MESSIER 051a',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110102,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110102,28.88,0.39,5.97,47280,NULL,NULL,'TF and disk scale length','MESSIER 051a',NULL,'1995ApJ...442...82C',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110103,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110103,29.43,0.4,7.7,47280,75,NULL,'B, NGC 5194, v gsr = 551','MESSIER 051a',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110104,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110104,29.6,NULL,8.3,47280,75,NULL,'CO','MESSIER 051a',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110105,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110105,30.43,NULL,12.2,47280,54,NULL,'HI','MESSIER 051a',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110106,'CMD','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110106,29.2,NULL,6.92,47281,NULL,NULL,NULL,'MESSIER 051b',NULL,'1990PAZh...16..979G',1990,1,5.8,NULL,'G',0.000033,NULL,'10.45',4.6,'SB0_1 pec      LINER','Pair member (points to parent)',NULL,NULL,NULL,1,202.4982917,47.26614,0,NULL,59290404015,926412562,14475196,10.45),(110107,'PNLF','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110107,29.41,0.12,7.62,47281,NULL,NULL,'NGC 5194, v gsr = 551','MESSIER 051b',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110108,'PNLF','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110108,29.52,0.12,8.02,47281,NULL,NULL,'HST KP Calibrated','MESSIER 051b',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110109,'PNLF','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110109,29.62,0.15,8.4,47281,NULL,NULL,'64, NGC 5194, v gsr = 551','MESSIER 051b',NULL,'1997ApJ...479..231F',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110110,'SBF','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110110,29.32,0.14,7.31,47281,74.4,NULL,NULL,'MESSIER 051b',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110111,'SBF','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110111,29.42,0.27,7.66,47281,NULL,NULL,'I, NGC 5194, v gsr = 551','MESSIER 051b',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110112,'SBF','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110112,29.47,0.28,7.83,47281,NULL,NULL,'HST KP Calibrated, I','MESSIER 051b',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110113,'SBF','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110113,29.59,0.15,8.28,47281,NULL,NULL,'NGC 5195','MESSIER 051b',NULL,'1996AJ....111..327R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110114,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110114,29.74,0.14,8.88,47281,NULL,NULL,'Field 2','MESSIER 051b',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110115,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110115,29.78,0.13,9.05,47281,NULL,NULL,'Field 1','MESSIER 051b',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110116,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110116,29.79,0.14,9.09,47281,NULL,NULL,'Field 3','MESSIER 051b',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110117,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110117,29.98,0.15,9.9,47281,NULL,NULL,'NGC 5194, v gsr = 551','MESSIER 051b',NULL,'2009AstL...35..599T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110118,'CO ring diameter','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110118,29.65,NULL,8.5,47281,NULL,NULL,NULL,'MESSIER 051b',NULL,'1991PASJ...43..671S',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110119,'GC radius','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110119,29.67,NULL,8.6,47281,NULL,NULL,'NGC 5194, v gsr = 551','MESSIER 051b',NULL,'2009gcgg.book..103S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110120,'Grav. Stability Gas. Disk','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110120,29.35,NULL,7.4,47281,NULL,NULL,NULL,'MESSIER 051b',NULL,'1996AstL...22...71Z',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110121,'HII region diameter','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110121,29.57,0.15,8.2,47281,NULL,NULL,'NGC 5194, v gsr = 551','MESSIER 051b',NULL,'2005JKAS...38....7I',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110122,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110122,28.91,0.05,6.06,47281,NULL,NULL,'EPM, H01, fixed explosion epoch','MESSIER 051b',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110123,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110123,28.96,0.17,6.2,47281,NULL,NULL,'EPM, H01','MESSIER 051b',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110124,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110124,29.02,NULL,6.36,47281,NULL,NULL,'SCM, NGC 5194, v gsr = 551','MESSIER 051b',NULL,'2006MNRAS.372.1735T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110125,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 1994I',NULL,110125,29.2,0.3,6.92,47281,NULL,NULL,'Type Ic, NGC 5194','MESSIER 051b',NULL,'1994ApJ...437L.115I',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110126,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110126,29.37,0.04,7.49,47281,NULL,NULL,'EPM, D05, fixed explosion epoch','MESSIER 051b',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110127,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110127,29.38,0.06,7.5,47281,NULL,NULL,'EPM, expansion velocity modeled','MESSIER 051b',NULL,'2012MNRAS.419.2783T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110128,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110128,29.4,NULL,7.59,47281,NULL,NULL,'EPM, NGC 5194, v gsr = 551','MESSIER 051b',NULL,'2006MNRAS.372.1735T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110129,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110129,29.46,0.11,7.8,47281,NULL,NULL,'SCM','MESSIER 051b',NULL,'2015ApJ...799..215P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110130,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110130,29.5,0.18,7.9,47281,NULL,NULL,'SEAM, NGC 5194, v gsr = 551','MESSIER 051b',NULL,'2007ApJ...662.1148B',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110131,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110131,29.51,0.14,7.97,47281,NULL,NULL,'EPM, D05','MESSIER 051b',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110132,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 1994I',NULL,110132,29.6,0.5,8.3,47281,NULL,NULL,'SEAM, Type Ic SN, NGC 5194, v gsr = 551','MESSIER 051b',NULL,'1996MNRAS.279..799B',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110133,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 1994I',NULL,110133,29.6,0.3,8.32,47281,NULL,NULL,'Type Ic, NGC 5194','MESSIER 051b',NULL,'1996AJ....111..327R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110134,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110134,29.61,0.21,8.32,47281,NULL,NULL,'SEAM','MESSIER 051b',0.002,'2009ApJ...694.1067P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110135,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2011dh',NULL,110135,29.62,0.05,8.4,47281,NULL,NULL,'EPM, +/- 0.13 syst.','MESSIER 051b',NULL,'2012A&A...540A..93V',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110136,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110136,29.63,0.05,8.43,47281,NULL,NULL,'I, photospheric magnitude method, NGC 5194','MESSIER 051b',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110137,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110137,29.67,0.05,8.6,47281,NULL,NULL,'EPM','MESSIER 051b',NULL,'2012MNRAS.419.2783T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110138,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110138,29.75,0.12,8.9,47281,NULL,NULL,'SCM, NGC 5194, v gsr = 551','MESSIER 051b',NULL,'2008ApJ...675..644D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110139,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110139,29.75,0.16,8.9,47281,NULL,NULL,'SEAM, NGC 5194, v gsr = 551','MESSIER 051b',NULL,'2008ApJ...675..644D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110140,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110140,29.77,0.08,8.99,47281,NULL,NULL,'V, photospheric magnitude method, NGC 5194','MESSIER 051b',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110141,'Tully est','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110141,29.85,0.8,9.3,47281,75,NULL,'B, NGC 5195, v gsr = 573','MESSIER 051b',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110142,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110142,28.45,NULL,4.9,47281,65.2,NULL,'CO','MESSIER 051b',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110143,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110143,28.74,NULL,5.6,47281,75,NULL,'HI','MESSIER 051b',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110144,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110144,28.84,NULL,5.86,47281,NULL,NULL,'LEDA [Nov 2006]','MESSIER 051b',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110145,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110145,28.88,0.39,5.97,47281,NULL,NULL,'TF and disk scale length','MESSIER 051b',NULL,'1995ApJ...442...82C',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110146,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110146,29.43,0.4,7.7,47281,75,NULL,'B, NGC 5194, v gsr = 551','MESSIER 051b',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110147,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110147,29.6,NULL,8.3,47281,75,NULL,'CO','MESSIER 051b',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110148,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110148,30.43,NULL,12.2,47281,54,NULL,'HI','MESSIER 051b',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110149,'CMD','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110149,29.2,NULL,6.92,47282,NULL,NULL,NULL,'MESSIER 051',NULL,'1990PAZh...16..979G',1990,1,NULL,NULL,'GPair',NULL,NULL,NULL,NULL,'SAbc           LINER',NULL,NULL,NULL,NULL,1,202.484167,47.23056,0,NULL,59290404193,926412565,14475196,NULL),(110150,'PNLF','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110150,29.41,0.12,7.62,47282,NULL,NULL,'NGC 5194, v gsr = 551','MESSIER 051',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110151,'PNLF','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110151,29.52,0.12,8.02,47282,NULL,NULL,'HST KP Calibrated','MESSIER 051',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110152,'PNLF','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110152,29.62,0.15,8.4,47282,NULL,NULL,'64, NGC 5194, v gsr = 551','MESSIER 051',NULL,'1997ApJ...479..231F',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110153,'SBF','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110153,29.32,0.14,7.31,47282,74.4,NULL,'NGC 5195','MESSIER 051',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110154,'SBF','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110154,29.42,0.27,7.66,47282,NULL,NULL,'I, NGC 5194, v gsr = 551','MESSIER 051',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110155,'SBF','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110155,29.47,0.28,7.83,47282,NULL,NULL,'HST KP Calibrated, I','MESSIER 051',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110156,'SBF','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110156,29.59,0.15,8.28,47282,NULL,NULL,'NGC 5195','MESSIER 051',NULL,'1996AJ....111..327R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110157,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110157,29.74,0.14,8.88,47282,NULL,NULL,'Field 2','MESSIER 051',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110158,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110158,29.78,0.13,9.05,47282,NULL,NULL,'Field 1','MESSIER 051',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110159,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110159,29.79,0.14,9.09,47282,NULL,NULL,'Field 3','MESSIER 051',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110160,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110160,29.98,0.15,9.9,47282,NULL,NULL,'NGC 5194, v gsr = 551','MESSIER 051',NULL,'2009AstL...35..599T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110161,'CO ring diameter','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110161,29.65,NULL,8.5,47282,NULL,NULL,NULL,'MESSIER 051',NULL,'1991PASJ...43..671S',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110162,'GC radius','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110162,29.67,NULL,8.6,47282,NULL,NULL,'NGC 5194, v gsr = 551','MESSIER 051',NULL,'2009gcgg.book..103S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110163,'Grav. Stability Gas. Disk','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110163,29.35,NULL,7.4,47282,NULL,NULL,NULL,'MESSIER 051',NULL,'1996AstL...22...71Z',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110164,'HII region diameter','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110164,29.57,0.15,8.2,47282,NULL,NULL,'NGC 5194, v gsr = 551','MESSIER 051',NULL,'2005JKAS...38....7I',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110165,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110165,28.91,0.05,6.06,47282,NULL,NULL,'EPM, H01, fixed explosion epoch','MESSIER 051',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110166,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110166,28.96,0.17,6.2,47282,NULL,NULL,'EPM, H01','MESSIER 051',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110167,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110167,29.02,NULL,6.36,47282,NULL,NULL,'SCM, NGC 5194, v gsr = 551','MESSIER 051',NULL,'2006MNRAS.372.1735T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110168,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 1994I',NULL,110168,29.2,0.3,6.92,47282,NULL,NULL,'Type Ic, NGC 5194','MESSIER 051',NULL,'1994ApJ...437L.115I',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110169,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110169,29.37,0.04,7.49,47282,NULL,NULL,'EPM, D05, fixed explosion epoch','MESSIER 051',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110170,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110170,29.38,0.06,7.5,47282,NULL,NULL,'EPM, expansion velocity modeled','MESSIER 051',NULL,'2012MNRAS.419.2783T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110171,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110171,29.4,NULL,7.59,47282,NULL,NULL,'EPM, NGC 5194, v gsr = 551','MESSIER 051',NULL,'2006MNRAS.372.1735T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110172,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110172,29.46,0.11,7.8,47282,NULL,NULL,'SCM','MESSIER 051',NULL,'2015ApJ...799..215P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110173,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110173,29.5,0.18,7.9,47282,NULL,NULL,'SEAM, NGC 5194, v gsr = 551','MESSIER 051',NULL,'2007ApJ...662.1148B',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110174,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110174,29.51,0.14,7.97,47282,NULL,NULL,'EPM, D05','MESSIER 051',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110175,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 1994I',NULL,110175,29.6,0.5,8.3,47282,NULL,NULL,'SEAM, Type Ic SN, NGC 5194, v gsr = 551','MESSIER 051',NULL,'1996MNRAS.279..799B',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110176,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 1994I',NULL,110176,29.6,0.3,8.32,47282,NULL,NULL,'Type Ic, NGC 5194','MESSIER 051',NULL,'1996AJ....111..327R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110177,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110177,29.61,0.21,8.32,47282,NULL,NULL,'SEAM','MESSIER 051',0.002,'2009ApJ...694.1067P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110178,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2011dh',NULL,110178,29.62,0.05,8.4,47282,NULL,NULL,'EPM, +/- 0.13 syst.','MESSIER 051',NULL,'2012A&A...540A..93V',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110179,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110179,29.63,0.05,8.43,47282,NULL,NULL,'I, photospheric magnitude method, NGC 5194','MESSIER 051',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110180,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110180,29.67,0.05,8.6,47282,NULL,NULL,'EPM','MESSIER 051',NULL,'2012MNRAS.419.2783T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110181,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110181,29.75,0.12,8.9,47282,NULL,NULL,'SCM, NGC 5194, v gsr = 551','MESSIER 051',NULL,'2008ApJ...675..644D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110182,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110182,29.75,0.16,8.9,47282,NULL,NULL,'SEAM, NGC 5194, v gsr = 551','MESSIER 051',NULL,'2008ApJ...675..644D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110183,'SNII optical','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2005cs',NULL,110183,29.77,0.08,8.99,47282,NULL,NULL,'V, photospheric magnitude method, NGC 5194','MESSIER 051',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110184,'Tully est','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110184,29.85,0.8,9.3,47282,75,NULL,'B, NGC 5195, v gsr = 573','MESSIER 051',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110185,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110185,28.45,NULL,4.9,47282,65.2,NULL,'CO','MESSIER 051',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110186,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110186,28.84,NULL,5.86,47282,NULL,NULL,'LEDA [Nov 2006]','MESSIER 051',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110187,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110187,28.88,0.39,5.97,47282,NULL,NULL,'TF and disk scale length','MESSIER 051',NULL,'1995ApJ...442...82C',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110188,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110188,29.43,0.4,7.7,47282,75,NULL,'B, NGC 5194, v gsr = 551','MESSIER 051',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110189,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110189,29.6,NULL,8.3,47282,75,NULL,'CO','MESSIER 051',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110190,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110190,29.8,NULL,9.1,47282,75,NULL,'HI','MESSIER 051',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110191,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110191,30.43,NULL,12.2,47282,54,NULL,'HI','MESSIER 051',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110192,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110192,37.87,0.46,375,47283,70,NULL,NULL,'2MASX J13295297+3741506',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000117,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,202.470833,37.69753,0,NULL,59295518026,926492469,14476444,18),(110193,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110193,37.62,0.46,335,47284,70,NULL,NULL,'2MASX J13295491+5400330',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000132,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,202.4787083,54.00903,0,NULL,57280202627,895003166,13984424,17.9),(110194,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110194,35.91,0.54,152,47285,70,NULL,NULL,'GALEXASC J132955.10-311958.7',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,202.479667,-31.33228,0.173,NULL,46904520707,732883136,11451299,14.2),(110195,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110195,37.93,0.46,385,47286,70,NULL,NULL,'SDSS J132955.20+062135.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,202.4800417,6.35994,0.024,NULL,58981197526,921581211,14399706,18.5),(110196,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110196,37.42,0.23,305,47287,70,NULL,NULL,'2MASX J13295560+0849072',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000183,NULL,'17.86',0.2,NULL,NULL,NULL,NULL,NULL,1,202.481667,8.81853,0,NULL,58949905690,921092276,14392066,17.86),(110197,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110197,37.76,0.23,357,47288,70,NULL,NULL,'2MASX J13295587+0118464',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,202.4827917,1.31283,0.013,NULL,58922082885,920657545,14385274,17.3),(110198,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110198,37.71,0.46,349,47289,70,NULL,NULL,'2MASX J13295584+2356544',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.43',0.3,NULL,NULL,NULL,NULL,NULL,1,202.482833,23.9485,0.016,NULL,58794628288,918666067,14354157,17.43),(110199,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110199,38.06,0.46,408,47290,70,NULL,NULL,'2MASX J13295633+1056182',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000155,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,202.484833,10.93842,0,NULL,58939911065,920936110,14389626,18.1),(110200,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110200,37.51,0.46,317,47291,70,NULL,NULL,'2MASX J13295638+0047264',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000073,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,202.484917,0.79081,0.014,NULL,58922513925,920664280,14385379,17.2),(110201,'IRAS','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110201,34.82,0.8,91.9,47292,75,NULL,'HMCL, I','UGC 08486',NULL,'1997ApJS..109..333W',1997,1,1.09,NULL,'G',0.000023,NULL,'15.5g',0.43,'Sd',NULL,NULL,NULL,NULL,1,202.486333,11.07211,0,NULL,58939875346,920935552,14389618,15.5),(110202,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110202,34.7,0.69,87.2,47292,NULL,NULL,NULL,'UGC 08486',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110203,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110203,34.77,0.67,90.1,47292,NULL,NULL,'Malmquist cor.','UGC 08486',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110204,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110204,34.79,0.2,90.8,47292,74.4,NULL,NULL,'UGC 08486',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110205,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110205,35.19,0.4,109,47292,75,NULL,'HMCL, I, raw','UGC 08486',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110206,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110206,35.32,0.4,116,47292,75,NULL,'HMCL, I, inv','UGC 08486',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110207,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110207,35.39,0.4,120,47292,75,NULL,'HMCL, I, cor','UGC 08486',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110208,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110208,37.42,0.23,305,47293,70,NULL,NULL,'2MASX J13295682+0842522',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,202.486708333,8.71453,0,NULL,58949944763,921092886,14392076,17.3),(110209,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'N',110209,27.78,0.24,3.6,47294,NULL,NULL,'r-band (SDSS), M(TRGB) = -3.01 mag','CenA-MM-Dw2',NULL,'2014ApJ...795L...6J',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110210,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'N',110210,27.78,0.11,3.6,47294,NULL,NULL,NULL,'CenA-MM-Dw2',NULL,'2015ApJ...802L..25T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110211,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110211,36.7,0.46,219,47295,70,NULL,NULL,'2MASX J13295782+1219384',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000137,NULL,'17.38',0.26,NULL,NULL,NULL,NULL,NULL,1,202.490833,12.32736,0,NULL,59008059841,922000935,14406264,17.38),(110212,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110212,37.79,0.46,361,47296,70,NULL,NULL,'2MASX J13295873+4324449',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000181,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,202.494708333,43.41261,0,NULL,59321442852,926897544,14482774,17),(110213,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110213,36.89,0.46,239,47297,70,NULL,NULL,'2MASX J13295972+3731377',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000103,NULL,'16.71',0.25,NULL,NULL,NULL,NULL,NULL,1,202.498917,37.52714,0,NULL,59295505084,926492266,14476441,16.71),(110214,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110214,34.79,0.46,90.6,47298,70,NULL,NULL,'IC 0891',NULL,'2015arXiv151105856S',2015,1,0.89,'One APM position is east of the nucleus.','G',0.000089,NULL,'14.3g',0.85,'E0',NULL,NULL,NULL,NULL,1,202.499666667,0.30511,0.033,NULL,58921612608,920650197,14385159,14.3),(110215,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110215,37.42,0.23,305,47299,70,NULL,NULL,'2MASX J13300013+0848492',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,202.500667,8.81364,0,NULL,58949902965,921092233,14392066,17.7),(110216,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110216,37.92,0.07,384,47300,70,NULL,NULL,'SDSS J133000.39-020437.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,202.501667,-2.07706,0.033,NULL,43824655338,684760239,10699378,18.6),(110217,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110217,37.16,0.17,271,47301,70,NULL,NULL,'2MASX J13300048+3717277',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.50',0.22,NULL,NULL,NULL,NULL,NULL,1,202.502083,37.29108,0,NULL,59165266113,924457283,14444645,17.5),(110218,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110218,36.64,0.76,213,47302,70,NULL,NULL,'2MASX J13300119-2758297',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.12',NULL,'*+E',NULL,NULL,NULL,NULL,1,202.505,-27.97492,0.153,NULL,43295327362,676489490,10570148,15.12),(110219,'D-Sigma','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110219,33.69,0.4,54.7,47303,75,NULL,'Edat, raw','ESO 576- G 067',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00015,NULL,'14.17',0.5,'SAB0-',NULL,NULL,NULL,NULL,1,202.5095417,-20.55175,0.205,NULL,43817965390,684655709,10697745,14.17),(110220,'D-Sigma','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110220,34.03,0.4,63.9,47303,75,NULL,'Edat, cor','ESO 576- G 067',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110221,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2006br',NULL,110221,34.95,0.19,95.4,47304,74.2,NULL,'SALT 2','NGC 5185',0.02459,'2010ApJ...716..712A',2010,1,0.88,NULL,'G',0.000012,NULL,'14.3g',0.68,'Sb','Field galaxy',NULL,NULL,NULL,1,202.509375,13.41606,0,NULL,59009264495,922019757,14406558,14.3),(110222,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2006br',NULL,110222,35.26,0.05,110,47304,72,NULL,'Malmquist cor.','NGC 5185',0.02459,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110223,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2006br',NULL,110223,35.43,0.08,122,47304,72,NULL,'M(H) = -18.317 mag','NGC 5185',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110224,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2006br',NULL,110224,35.49,0.09,125,47304,74.4,NULL,NULL,'NGC 5185',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110225,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2006br',NULL,110225,35.64,0.16,128,47304,72,NULL,NULL,'NGC 5185',0.02554,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110226,'IRAS','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110226,35.07,0.8,103,47304,75,NULL,'HMCL, I','NGC 5185',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110227,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110227,34.96,0.23,98.4,47304,NULL,NULL,'Malmquist cor.','NGC 5185',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110228,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110228,35.11,0.4,105,47304,NULL,NULL,'mean','NGC 5185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110229,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110229,35.13,0.47,106,47304,NULL,NULL,'H','NGC 5185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110230,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110230,35.14,0.21,107,47304,NULL,NULL,NULL,'NGC 5185',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110231,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110231,35.15,0.46,107,47304,NULL,NULL,'J','NGC 5185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110232,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110232,35.19,0.45,109,47304,NULL,NULL,'K','NGC 5185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110233,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110233,35.22,0.49,111,47304,75,NULL,'IR','NGC 5185',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110234,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110234,35.42,0.4,121,47304,75,NULL,'HMCL, I, raw','NGC 5185',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110235,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110235,35.46,0.4,124,47304,75,NULL,'HOSTS SN 2006br','NGC 5185',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110236,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110236,35.49,0.09,125,47304,74.4,NULL,NULL,'NGC 5185',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110237,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110237,35.59,0.4,131,47304,75,NULL,'HMCL, I, cor','NGC 5185',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110238,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110238,35.7,0.4,138,47304,75,NULL,'HMCL, I, inv','NGC 5185',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110239,'IRAS','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110239,32.33,0.8,29.2,47305,75,NULL,'A82, H','NGC 5205',NULL,'1997ApJS..109..333W',1997,1,1.79,NULL,'G',0.000007,NULL,'13.4g',0.95,'Sbc','in a radial-velocity based grouping',NULL,NULL,NULL,1,202.514917,62.51158,0.029,NULL,57347122386,896048787,14000762,13.4),(110240,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110240,31.85,0.47,23.4,47305,75,NULL,'A82, H, raw','NGC 5205',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110241,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110241,31.87,0.47,23.6,47305,75,NULL,'A82, H, inv','NGC 5205',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110242,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110242,32.19,0.47,27.4,47305,75,NULL,'A82, H, cor','NGC 5205',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110243,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110243,32.25,0.4,28.2,47305,NULL,NULL,'mean','NGC 5205',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110244,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110244,32.36,0.38,29.6,47305,NULL,NULL,NULL,'NGC 5205',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110245,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110245,32.38,0.4,29.9,47305,75,NULL,'B','NGC 5205',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110246,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110246,32.42,0.47,30.5,47305,NULL,NULL,'H','NGC 5205',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110247,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110247,32.59,0.45,33,47305,NULL,NULL,'K','NGC 5205',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110248,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110248,32.63,0.46,33.6,47305,NULL,NULL,'J','NGC 5205',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110249,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110249,32.73,0.5,35.2,47305,NULL,NULL,'Malmquist cor.','NGC 5205',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110250,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110250,32.78,0.2,36,47305,74.4,NULL,NULL,'NGC 5205',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110251,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110251,32.8,0.48,36.2,47305,NULL,NULL,NULL,'NGC 5205',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110252,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110252,32.84,0.43,37,47305,75,NULL,'3.6 micron, color corrected','NGC 5205',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110253,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110253,32.87,0.43,37.5,47305,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5205',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110254,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110254,37.5,0.46,316,47306,70,NULL,NULL,'2MASX J13300397+2304521',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,202.516583,23.08131,0.03,NULL,58794818255,918669035,14354203,17.3),(110255,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110255,37.88,0.46,376,47307,70,NULL,NULL,'2MASX J13300441-0213304',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,202.518458333,-2.22503,0.033,NULL,43824615077,684759610,10699368,17.7),(110256,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110256,35.62,0.42,133,47308,NULL,NULL,NULL,'2MFGC 10858',NULL,'2009ApJS..182..474S',2009,1,0.61,NULL,'G',0.000033,NULL,'14.4R',0.61,'Sc            Sbrst?','Group member',NULL,NULL,NULL,1,202.521417,-31.41022,0.173,NULL,46904564472,732883819,11451309,14.4),(110257,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110257,35.64,0.41,134,47308,NULL,NULL,'Malmquist cor.','2MFGC 10858',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110258,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110258,35.67,0.2,136,47308,74.4,NULL,NULL,'2MFGC 10858',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110259,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110259,36.44,0.37,194,47309,NULL,NULL,'Malmquist cor.','2MASX J13300526-3113531',NULL,'2009ApJS..182..474S',2009,1,0.36,NULL,'G',0.000033,NULL,'16.1R',0.14,'S','Group member',NULL,NULL,NULL,1,202.521667,-31.2315,0.173,NULL,46904511072,732882985,11451296,16.1),(110260,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110260,36.49,0.37,198,47309,NULL,NULL,NULL,'2MASX J13300526-3113531',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110261,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110261,36.53,0.2,202,47309,74.4,NULL,NULL,'2MASX J13300526-3113531',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110262,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110262,34.61,0.4,83.4,47310,NULL,NULL,'mean','ESO 576- G 069',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000033,NULL,'14.97',0.8,'(PR?)      Sy2/LINER',NULL,NULL,NULL,'Sy ?',1,202.522083,-20.93297,0.237,NULL,43817914757,684654918,10697733,14.97),(110263,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110263,35.02,0.47,101,47310,NULL,NULL,'H','ESO 576- G 069',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110264,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110264,35.05,0.45,102,47310,NULL,NULL,'K','ESO 576- G 069',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110265,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110265,35.12,0.46,106,47310,NULL,NULL,'J','ESO 576- G 069',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110266,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110266,37.09,0.46,262,47311,70,NULL,NULL,'2MASX J13300533+4408349',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,202.5224583,44.14292,0,NULL,59321172900,926893326,14482708,16.9),(110267,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110267,33.48,0.47,49.7,47312,NULL,NULL,'H','NGC 5183',NULL,'2007A&A...465...71T',2007,1,0.92,NULL,'G',0.000033,NULL,'13.6g',0.68,'Sb pec','Pair member (points to parent)',NULL,NULL,NULL,1,202.525625,-1.72058,0.037,NULL,43825536361,684774005,10699593,13.6),(110268,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110268,33.55,0.46,51.2,47312,NULL,NULL,'J','NGC 5183',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110269,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110269,33.58,0.45,51.9,47312,NULL,NULL,'K','NGC 5183',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110270,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110270,33.91,0.4,60.6,47312,NULL,NULL,'mean','NGC 5183',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110271,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110271,34.94,0.33,97.4,47313,70,NULL,NULL,'UGC 08492',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.00011,NULL,'14.6g',0.68,'S0','Group member',NULL,NULL,NULL,1,202.5272083,31.38811,0.025,NULL,59180969055,924702641,14448478,14.6),(110272,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110272,37.85,0.46,372,47314,70,NULL,NULL,'CGCG 016-082 NED01',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000097,NULL,'16.1g',0.4,'E0',NULL,NULL,NULL,NULL,1,202.529,0.50961,0.021,NULL,58921696556,920651508,14385179,16.1),(110273,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110273,37.97,0.46,393,47315,70,NULL,NULL,'2MASX J13300756+1418297',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,202.5315,14.30822,0.007,NULL,58823411924,919115811,14361184,17),(110274,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110274,35.52,0.46,127,47316,70,NULL,NULL,'LCRS B132733.1-025017',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00015,NULL,'16.1g',0.29,'S0',NULL,NULL,NULL,NULL,1,202.5340417,-3.09569,0.053,NULL,43835964148,684936939,10702139,16.1),(110275,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110275,38.02,0.46,402,47317,70,NULL,NULL,'SDSS J133009.23+255845.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,202.5385,25.97922,0.024,NULL,58669914472,916717413,14323709,18.3),(110276,'D-Sigma','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110276,33.05,0.4,40.7,47318,75,NULL,'Edat, raw','NGC 5198',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000017,NULL,'12.69',1.8,'E1-2:','in a radial-velocity based grouping',NULL,NULL,NULL,1,202.5475,46.67078,0,NULL,59287009735,926359527,14474367,12.69),(110277,'D-Sigma','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110277,33.38,0.4,47.5,47318,75,NULL,'Edat, cor','NGC 5198',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110278,'Tully est','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110278,32.96,0.8,39,47318,75,NULL,'B','NGC 5198',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110279,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110279,33,0.4,39.9,47318,NULL,NULL,'mean','NGC 5198',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110280,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110280,33.49,0.45,50,47318,NULL,NULL,'K','NGC 5198',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110281,'Sosies','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110281,33.89,0.12,60,47319,NULL,NULL,NULL,'NGC 5184',NULL,'2002A&A...393...57T',2002,1,1.87,NULL,'G',0.000027,NULL,'13.2g',1.06,'SAB(r)c','Pair member (points to parent)',NULL,NULL,NULL,1,202.547875,-1.66314,0.037,NULL,43825550089,684774220,10699597,13.2),(110282,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110282,33.65,0.46,53.7,47319,NULL,NULL,'J','NGC 5184',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110283,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110283,33.67,0.47,54.1,47319,NULL,NULL,'H','NGC 5184',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110284,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110284,33.71,0.45,55.3,47319,NULL,NULL,'K','NGC 5184',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110285,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110285,33.8,0.4,57.5,47319,NULL,NULL,'mean','NGC 5184',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110286,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110286,33.9,0.39,60.2,47319,NULL,NULL,'Malmquist cor.','NGC 5184',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110287,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110287,34.04,0.36,64.4,47319,NULL,NULL,NULL,'NGC 5184',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110288,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110288,34.08,0.2,65.5,47319,74.4,NULL,NULL,'NGC 5184',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110289,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110289,33.66,0.54,53.9,47320,70,NULL,NULL,'ESO 576- G 070',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00013,NULL,'15.13',0.2,'S0',NULL,NULL,NULL,NULL,1,202.548416667,-21.01158,0.237,NULL,43817958196,684655596,10697743,15.13),(110290,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110290,37.92,0.07,384,47321,70,NULL,NULL,'2MASX J13301188-0207094',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000123,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,202.549583,-2.11933,0.033,NULL,43824650836,684760169,10699377,17.6),(110291,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110291,37.72,0.33,350,47322,70,NULL,NULL,'2MASX J13301217+1145407',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,202.550625,11.76136,0,NULL,58940194034,920940531,14389695,18),(110292,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110292,36.09,0.51,165,47323,70,NULL,NULL,'2MASX J13301235-2930061',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.0001,NULL,'15.06',NULL,'E',NULL,NULL,NULL,NULL,1,202.551417,-29.50169,0.189,NULL,46847018417,731984662,11437260,15.06),(110293,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110293,38.03,0.61,404,47324,70,NULL,NULL,'2MASX J13301289-2923361',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.34',NULL,'E',NULL,NULL,NULL,NULL,1,202.55375,-29.39344,0.189,NULL,46847026766,731984793,11437262,15.34),(110294,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110294,37.94,0.46,388,47325,70,NULL,NULL,'2MASX J13301393-0038524',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000114,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,202.558083,-0.64794,0.009,NULL,43822226481,684722288,10698785,17.9),(110295,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110295,37.23,0.46,279,47326,70,NULL,NULL,'2MASX J13301409+1110517',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,202.558583,11.18117,0,NULL,58939796603,920934321,14389598,17.4),(110296,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'N',110296,27.8,0.24,3.63,47327,NULL,NULL,'r-band (SDSS), M(TRGB) = -3.01 mag','CenA-MM-Dw1',NULL,'2014ApJ...795L...6J',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110297,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'N',110297,27.8,0.11,3.63,47327,NULL,NULL,NULL,'CenA-MM-Dw1',NULL,'2015ApJ...802L..25T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110298,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110298,38.09,0.46,414,47328,70,NULL,NULL,'2MASX J13301431+4003486',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,202.559833333,40.06353,0,NULL,59314121431,926783147,14480986,17.8),(110299,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110299,37.92,0.07,384,47329,70,NULL,NULL,'SDSS J133014.36-020554.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000165,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,202.559875,-2.09856,0.025,NULL,43824651468,684760179,10699377,18.5),(110300,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110300,33.61,0.51,52.7,47330,70,NULL,NULL,'ESO 576- G 071',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000133,NULL,'15.11',0.3,'Sa',NULL,NULL,NULL,NULL,1,202.560916667,-21.21981,0.285,NULL,43810564238,684540066,10695938,15.11),(110301,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110301,37.64,0.46,337,47331,70,NULL,NULL,'2MASX J13301527-0131074',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000093,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,202.563667,-1.51881,0.037,NULL,43825500968,684773452,10699585,17.8),(110302,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110302,37.05,0.81,257,47332,70,NULL,NULL,'2MASX J13301595-3036168',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000097,NULL,'17.03',NULL,NULL,NULL,NULL,NULL,NULL,1,202.5665417,-30.60475,0.121,NULL,46901434133,732834908,11450545,17.03),(110303,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110303,33.36,0.2,47,47333,74.4,NULL,NULL,'MCG -02-34-060',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.00001,NULL,'13.66',0.7,'SB(rs)c',NULL,NULL,NULL,NULL,1,202.569,-10.05375,0.029,NULL,43870997590,685484337,10710692,13.66),(110304,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110304,33.59,0.48,52.3,47333,NULL,NULL,NULL,'MCG -02-34-060',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110305,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110305,33.71,0.46,55.3,47333,NULL,NULL,'Malmquist cor.','MCG -02-34-060',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110306,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110306,33.6,0.73,52.6,47334,NULL,NULL,NULL,'ESO 576- G 072',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.00002,NULL,'15.5',0.8,'Sb',NULL,NULL,NULL,NULL,1,202.571417,-21.74686,0.249,NULL,43765638694,683838104,10684970,15.5),(110307,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110307,34.04,0.6,64.1,47334,NULL,NULL,'Malmquist cor.','ESO 576- G 072',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110308,'IRAS','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110308,33.37,0.8,47.3,47335,75,NULL,'MAT, I','IC 4264',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000025,NULL,'14.93',0.4,'SA(s)d: sp',NULL,NULL,NULL,NULL,1,202.573833333,-27.92844,0.153,NULL,43295401656,676490650,10570166,14.93),(110309,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110309,33,0.32,39.9,47335,85,NULL,'I, raw','IC 4264',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110310,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110310,33,0.32,39.9,47335,85,NULL,'I, inv','IC 4264',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110311,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110311,33.18,0.2,43.3,47335,74.4,NULL,NULL,'IC 4264',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110312,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110312,33.25,0.43,44.6,47335,75,NULL,'MAT, I, raw','IC 4264',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110313,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110313,33.29,0.43,45.5,47335,75,NULL,'MAT, I, inv','IC 4264',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110314,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110314,33.51,0.43,50.4,47335,75,NULL,'MAT, I, cor','IC 4264',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110315,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110315,33.66,0.12,54.1,47335,NULL,NULL,NULL,'IC 4264',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110316,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110316,37.01,0.46,253,47336,70,NULL,NULL,'2MASX J13301874-0132424',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000073,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,202.578083333,-1.54528,0.037,NULL,43825503375,684773490,10699585,17.8),(110317,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110317,37.37,0.64,298,47337,70,NULL,NULL,'2MASX J13301901-3201549',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.00015,NULL,'17.1b',0.2,NULL,'Group member',NULL,NULL,NULL,1,202.579208333,-32.03186,0.181,NULL,46904480617,732882509,11451289,17.1),(110318,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110318,35.21,0.46,110,47338,70,NULL,NULL,'CGCG 072-105',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000067,NULL,'14.8g',0.42,'E0','Group member',NULL,NULL,NULL,1,202.579833,11.51181,0,NULL,58940119200,920939362,14389677,14.8),(110319,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110319,37.57,0.27,326,47339,70,NULL,NULL,'2MASX J13302014+5903341',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,202.5839583,59.05964,0.013,NULL,57390504949,896726639,14011353,17.6),(110320,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'RN',110320,27.82,0.19,3.66,47340,NULL,NULL,'NW field','CenA-MM-Dw3',NULL,'2015arXiv151205366C',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110321,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'RN',110321,28.09,0.19,4.15,47340,NULL,NULL,'SE field','CenA-MM-Dw3',NULL,'2015arXiv151205366C',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110322,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'RN',110322,28.12,0.19,4.2,47340,NULL,NULL,'N field','CenA-MM-Dw3',NULL,'2015arXiv151205366C',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110323,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'RN',110323,28.18,0.21,4.33,47340,NULL,NULL,'S field','CenA-MM-Dw3',NULL,'2015arXiv151205366C',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110324,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'RN',110324,28.32,0.19,4.61,47340,NULL,NULL,NULL,'CenA-MM-Dw3',NULL,'2015arXiv151205366C',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110325,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110325,37.17,0.46,271,47341,70,NULL,NULL,'2MASX J13302393+1252457',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,202.599625,12.87939,0,NULL,59009442856,922022544,14406602,17),(110326,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110326,37.03,0.27,254,47342,70,NULL,NULL,'2MASX J13302415+4200525',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,202.600667,42.01453,0,NULL,59323584527,926931008,14483297,17.8),(110327,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110327,36.73,0.46,222,47343,70,NULL,NULL,'2MASX J13302489+1112527',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000172,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,202.603667,11.21456,0,NULL,58939743475,920933491,14389585,16.8),(110328,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110328,35.18,0.46,109,47344,NULL,NULL,'J','UGC 08498',NULL,'2007A&A...465...71T',2007,1,1.57,NULL,'G',0.00003,NULL,'14.0g',0.64,'Sb             LINER','Group member',NULL,NULL,NULL,1,202.60825,31.62081,0.028,NULL,59181042495,924703788,14448496,14),(110329,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110329,35.19,0.47,109,47344,NULL,NULL,'H','UGC 08498',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110330,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110330,35.19,0.4,109,47344,NULL,NULL,'mean','UGC 08498',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110331,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110331,35.25,0.45,112,47344,NULL,NULL,'K','UGC 08498',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110332,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110332,37.76,0.23,357,47345,70,NULL,NULL,'2MASX J13302778+0121082',NULL,'2015arXiv151105856S',2015,1,0.08,NULL,'G',0.000182,NULL,'18.7g',0.07,NULL,NULL,NULL,NULL,NULL,1,202.615791667,1.35222,0.013,NULL,58921908515,920654820,14385231,18.7),(110333,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110333,37.82,0.33,366,47346,70,NULL,NULL,'SDSS J133028.36+192034.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,202.618167,19.343,0.018,NULL,58844575810,919446497,14366351,17.8),(110334,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110334,38,0.46,399,47347,70,NULL,NULL,'2MASX J13303073+1737417',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.58',0.15,NULL,NULL,NULL,NULL,NULL,1,202.628125,17.62828,0,NULL,58833652417,919275819,14363684,18.58),(110335,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110335,37.32,0.46,291,47348,70,NULL,NULL,'2MASX J13303154+2825233',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000185,NULL,'16.7g',0.25,'E4',NULL,NULL,NULL,NULL,1,202.631375,28.42303,0.017,NULL,59132872831,923951137,14436736,16.7),(110336,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110336,37.92,0.07,384,47349,70,NULL,NULL,'2MASX J13303233-0147353',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000093,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,202.6349583,-1.79325,0.037,NULL,43824499754,684757808,10699340,17),(110337,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110337,37.69,0.46,344,47350,70,NULL,NULL,'2MASX J13303366+4613066',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000134,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,202.640167,46.21864,0,NULL,59286891545,926357680,14474338,17.5),(110338,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110338,37.22,0.33,278,47351,70,NULL,NULL,'2MASX J13303364+5512210',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000172,NULL,'16.3g',0.39,'BrClG',NULL,NULL,NULL,NULL,1,202.640375,55.20589,0,NULL,57286945809,895108528,13986070,16.3),(110339,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110339,38.02,0.7,401,47352,70,NULL,NULL,'2MASX J13303418-3131419',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.000077,NULL,'17.1b',0.21,'S0','Group member',NULL,NULL,NULL,1,202.64225,-31.52839,0.149,NULL,46904543128,732883486,11451304,17.1),(110340,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110340,37.03,0.27,254,47353,70,NULL,NULL,'2MASX J13303464+4200406',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000186,NULL,'16.1g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,202.644458333,42.01139,0,NULL,59323605877,926931341,14483302,16.1),(110341,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110341,33.84,0.51,58.6,47354,70,NULL,NULL,'2MASX J13303467-3215509',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00006,NULL,'15.74',0.57,'E','Group member',NULL,NULL,NULL,1,202.644541667,-32.26417,0.169,NULL,46902467933,732851061,11450797,15.74),(110342,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110342,36.02,0.72,160,47355,70,NULL,NULL,'2MASX J13303514-2118129',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.16',NULL,NULL,NULL,NULL,NULL,NULL,1,202.646417,-21.30364,0.285,NULL,43765470410,683835475,10684929,16.16),(110343,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110343,37.92,0.07,384,47356,70,NULL,NULL,'2MASX J13303600-0141363',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,202.650083333,-1.69333,0.037,NULL,43824506997,684757921,10699342,17.5),(110344,'IRAS','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110344,33.96,0.8,62,47357,75,NULL,'MAT, I','IC 4267',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.82',0.5,'S0?',NULL,NULL,NULL,NULL,1,202.650417,-26.25606,0.209,NULL,43301835699,676591182,10571737,14.82),(110345,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110345,33.21,0.32,43.9,47357,85,NULL,'I, inv','IC 4267',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110346,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110346,33.22,0.32,44,47357,85,NULL,'I, raw','IC 4267',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110347,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110347,33.49,0.43,49.9,47357,75,NULL,'MAT, I, raw','IC 4267',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110348,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110348,33.53,0.43,50.9,47357,75,NULL,'MAT, I, inv','IC 4267',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110349,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110349,33.71,0.43,55.3,47357,75,NULL,'MAT, I, cor','IC 4267',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110350,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110350,34.16,0.1,68.1,47357,NULL,NULL,NULL,'IC 4267',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110351,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110351,34.41,0.2,76.2,47357,74.4,NULL,NULL,'IC 4267',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110352,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110352,36.33,0.55,185,47358,70,NULL,NULL,'2MASX J13303649-3218359',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'14.8R',0.18,NULL,'Group member',NULL,NULL,NULL,1,202.6520417,-32.31003,0.169,NULL,46902448469,732850757,11450793,14.8),(110353,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110353,37.92,0.07,384,47359,70,NULL,NULL,'2MASX J13303693-0153033',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000077,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,202.6537917,-1.88422,0.033,NULL,43824666907,684760420,10699381,17.5),(110354,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110354,37.06,0.46,258,47360,70,NULL,NULL,'2MASX J13303712+1438570',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.59',0.2,NULL,NULL,NULL,NULL,NULL,1,202.65475,14.64919,0.005,NULL,58824010858,919125169,14361330,17.59),(110355,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110355,38.23,0.46,442,47361,70,NULL,NULL,'2MASX J13303750+3008044',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000175,NULL,'17.4g',0.23,'E0',NULL,NULL,NULL,NULL,1,202.656417,30.13461,0.031,NULL,59131933755,923936464,14436507,17.4),(110356,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110356,38.05,0.23,407,47362,70,NULL,NULL,'2MASX J13303843+1124433',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000163,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,202.660083333,11.412,0,NULL,58940076957,920938702,14389667,17.1),(110357,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110357,34.09,0.4,65.8,47363,NULL,NULL,'mean','NGC 5190',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000017,NULL,'14.00',0.8,'SBb:','in a radial-velocity based grouping',NULL,NULL,NULL,1,202.660625,18.13461,0,NULL,58844089635,919438900,14366232,14),(110358,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110358,34.38,0.45,75.1,47363,NULL,NULL,'K','NGC 5190',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110359,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110359,34.43,0.47,76.8,47363,NULL,NULL,'H','NGC 5190',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110360,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110360,34.47,0.46,78.4,47363,NULL,NULL,'J','NGC 5190',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110361,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110361,34.91,0.49,96,47364,75,NULL,'IR','UGC 08506',NULL,'2011yCatp016004901K',2011,1,1.06,NULL,'G',0.000008,NULL,'16.3g',0.19,'Scd',NULL,NULL,NULL,NULL,1,202.661417,49.13658,0,NULL,59276913688,926201776,14471902,16.3),(110362,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110362,34.98,NULL,99.1,47364,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08506',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110363,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110363,35,NULL,100,47364,NULL,NULL,'Dipole + Quadrupole','UGC 08506',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110364,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110364,35.01,NULL,100,47364,NULL,NULL,'Dipole','UGC 08506',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110365,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110365,35.04,NULL,102,47364,NULL,NULL,NULL,'UGC 08506',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110366,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110366,38.05,0.23,407,47365,70,NULL,NULL,'2MASX J13303877+1124113',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,202.6615,11.40311,0,NULL,58940076372,920938693,14389667,17.1),(110367,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110367,38.25,0.21,446,47366,70,NULL,NULL,'SDSS J133040.26+530642.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000149,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,202.66775,53.11183,0,NULL,57281296843,895020263,13984691,18.7),(110368,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110368,36.64,0.46,213,47367,70,NULL,NULL,'2MASX J13304031+0408329',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000157,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,202.668083,4.14261,0.017,NULL,58928706663,920761041,14386891,17),(110369,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110369,38.44,0.46,487,47368,70,NULL,NULL,'2MASX J13304102+2501182',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,202.6712083,25.02178,0.024,NULL,58667686904,916682607,14323165,17.3),(110370,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110370,32.87,0.47,37.6,47369,NULL,NULL,'H','NGC 5182',NULL,'2007A&A...465...71T',2007,1,1.9,'The position in 1995AJ....110..463Q is 13 arcsec north of the nucleus.','G',0.000017,NULL,'13.21',1.3,'(R\'_2)SB(r)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,202.6712917,-28.15031,0.153,NULL,43295237324,676488083,10570126,13.21),(110371,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110371,32.96,0.45,39.1,47369,NULL,NULL,'K','NGC 5182',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110372,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110372,32.98,0.46,39.4,47369,NULL,NULL,'J','NGC 5182',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110373,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110373,33.12,0.69,42,47369,100,NULL,'mid-IR','NGC 5182',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110374,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110374,34,0.4,63.1,47369,NULL,NULL,'mean','NGC 5182',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110375,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110375,37.19,0.46,274,47370,70,NULL,NULL,'2MASX J13304128+4303416',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000159,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,202.671875,43.06147,0,NULL,59323330393,926927037,14483234,17),(110376,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110376,36.33,0.17,185,47371,70,NULL,NULL,'2MASX J13304250+3232493',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.00009,NULL,'15.2g',0.53,NULL,NULL,NULL,NULL,NULL,1,202.677166667,32.54694,0.006,NULL,59180538713,924695917,14448373,15.2),(110377,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110377,35.61,0.17,132,47372,70,NULL,NULL,'NGC 5199',NULL,'2015arXiv151105856S',2015,1,0.93,NULL,'G',0.00009,NULL,'14.3g',0.79,'COMPACT',NULL,NULL,NULL,NULL,1,202.678167,34.83067,0,NULL,59167878770,924498105,14445282,14.3),(110378,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110378,35.41,0.48,121,47373,70,NULL,NULL,'ESO 576- G 077',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00012,NULL,'14.95',1,'S0       poss. LINER',NULL,NULL,NULL,NULL,1,202.679583,-20.95183,0.205,NULL,43817951419,684655490,10697742,14.95),(110379,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110379,37.2,0.33,276,47374,70,NULL,NULL,'2MASX J13304308+3834410',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000127,NULL,'16.40',0.25,NULL,NULL,NULL,NULL,NULL,1,202.679625,38.57814,0,NULL,59295336245,926489628,14476400,16.4),(110380,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110380,37.76,0.23,357,47375,70,NULL,NULL,'2MASX J13304328+0115089',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000102,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,202.680333,1.25242,0.028,NULL,58921884500,920654445,14385225,17.2),(110381,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110381,37.22,0.27,278,47376,70,NULL,NULL,'2MASX J13304402+1115413',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000149,NULL,'17.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,202.6834583,11.26147,0,NULL,58940195563,920940555,14389696,17.2),(110382,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110382,37.92,0.07,384,47377,70,NULL,NULL,'SDSS J133044.15-015525.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000133,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,202.6839583,-1.92386,0.033,NULL,43824675587,684760556,10699383,18.6),(110383,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110383,37.92,0.07,384,47378,70,NULL,NULL,'2MASX J13304434-0153183',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000077,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,202.684917,-1.88833,0.033,NULL,43824666875,684760419,10699381,17.5),(110384,'CMD','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110384,27.04,NULL,2.56,47379,NULL,NULL,NULL,'UGC 08508',NULL,'2012ApJ...748...47M',2012,1,1.7,NULL,'G',0.000017,NULL,'14.40',1,'IAm','Probable group member',NULL,NULL,NULL,1,202.685,54.91,0,1,57291230403,895175475,13987116,14.4),(110385,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110385,26.98,0.1,2.49,47379,NULL,NULL,NULL,'UGC 08508',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110386,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110386,27.04,0.13,2.56,47379,NULL,NULL,NULL,'UGC 08508',NULL,'2002A&A...389..812K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110387,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110387,27.06,0.02,2.58,47379,NULL,NULL,'I','UGC 08508',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110388,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110388,27.06,0.14,2.58,47379,NULL,NULL,NULL,'UGC 08508',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110389,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110389,27.11,0.08,2.64,47379,74.4,NULL,NULL,'UGC 08508',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110390,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110390,27.12,0.08,2.65,47379,NULL,NULL,'I','UGC 08508',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110391,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110391,27.13,0.08,2.67,47379,NULL,NULL,NULL,'UGC 08508',NULL,'2013AstBu..68..125M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110392,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110392,27.14,0.11,2.68,47379,NULL,NULL,NULL,'UGC 08508',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110393,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110393,27.15,0.04,2.69,47379,NULL,NULL,NULL,'UGC 08508',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110394,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110394,27.13,0.4,2.7,47379,75,NULL,'B','UGC 08508',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110395,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110395,37.92,0.07,384,47380,70,NULL,NULL,'SDSS J133045.05-013733.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000151,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,202.68775,-1.62608,0.037,NULL,43824463804,684757246,10699331,18.7),(110396,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110396,38.12,0.46,422,47381,70,NULL,NULL,'2MASX J13304508+0050029',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000085,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,202.6877917,0.83406,0.007,NULL,58385317523,912270586,14254227,17.7),(110397,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110397,37.92,0.07,384,47382,70,NULL,NULL,'2MASX J13304547-0209083',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,202.6894583,-2.15222,0.025,NULL,43824642538,684760039,10699375,17.7),(110398,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110398,36.18,0.46,172,47383,70,NULL,NULL,'2MASX J13304552+2718342',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,202.6897083,27.30961,0.009,NULL,58660160084,916565001,14321328,16.6),(110399,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110399,38.25,0.21,446,47384,70,NULL,NULL,'2MASX J13304564+5306545',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000169,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,202.6904583,53.11522,0,NULL,57281297845,895020278,13984691,18),(110400,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110400,37.99,0.46,397,47385,70,NULL,NULL,'2MASX J13304594-0028573',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000075,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,202.6915,-0.48281,0.009,NULL,43553782440,680527850,10633247,17.5),(110401,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110401,35.8,0.44,144,47386,NULL,NULL,NULL,'LCSB S1920P',NULL,'2009ApJS..182..474S',2009,1,0.62,NULL,'G',0.00003,NULL,'14.7R',0.62,'Sbc','Group member',NULL,NULL,NULL,1,202.693125,-31.69028,0.149,NULL,46904463147,732882236,11451284,14.7),(110402,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110402,35.79,0.44,144,47386,NULL,NULL,'Malmquist cor.','LCSB S1920P',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110403,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110403,35.84,0.2,147,47386,74.4,NULL,NULL,'LCSB S1920P',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110404,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110404,36.44,0.46,194,47387,70,NULL,NULL,'2MASX J13304680+2705332',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000087,NULL,'17.47',0.24,NULL,NULL,NULL,NULL,NULL,1,202.695083,27.0925,0.009,NULL,58660072518,916563633,14321306,17.47),(110405,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110405,35.37,0.19,119,47388,70,NULL,NULL,'NGC 5191',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.000073,NULL,'14.3g',0.61,'E0',NULL,NULL,NULL,NULL,1,202.697333,11.20075,0,NULL,58939738922,920933420,14389584,14.3),(110406,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110406,37.65,0.59,339,47389,70,NULL,NULL,'2MASX J13304755-3202356',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'17.1b',0.38,NULL,'Group member',NULL,NULL,NULL,1,202.6982083,-32.04325,0.169,NULL,46904455033,732882109,11451282,17.1),(110407,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110407,38.03,0.46,403,47390,70,NULL,NULL,'SDSS J133047.63+521024.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000043,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,202.6984583,52.17339,0,NULL,59207536421,925117756,14454964,18.1),(110408,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110408,36.41,0.57,191,47391,70,NULL,NULL,'2MASX J13304820-2939309',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000147,NULL,'14.80',NULL,'Sp',NULL,NULL,NULL,NULL,1,202.700833,-29.65864,0.169,NULL,46846537610,731977150,11437142,14.8),(110409,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110409,37.92,0.07,384,47392,70,NULL,NULL,'2MASXi J1330490-015356',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,202.704375,-1.89886,0.033,NULL,43824661579,684760337,10699380,17.9),(110410,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110410,37.31,0.33,290,47393,70,NULL,NULL,'2MASX J13304914+0432189',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,202.704833,4.53867,0.039,NULL,58929346241,920771035,14387047,17.5),(110411,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110411,36.26,0.53,178,47394,70,NULL,NULL,'2MASX J13304956-2802279',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,202.7065417,-28.04108,0.153,NULL,43295416581,676490884,10570170,15.4),(110412,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110412,35.9,0.7,152,47395,70,NULL,NULL,'2MASX J13305017-2526059',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00014,NULL,'17.61',NULL,NULL,NULL,NULL,NULL,NULL,1,202.709125,-25.43492,0.165,NULL,43300693326,676573333,10571458,17.61),(110413,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110413,37.92,0.07,384,47396,70,NULL,NULL,'SDSS J133050.59-015143.0',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000097,NULL,'16.2g',0.39,'BrClG',NULL,NULL,NULL,NULL,1,202.7107917,-1.86197,0.037,NULL,43824493680,684757713,10699339,16.2),(110414,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110414,37.86,0.46,374,47397,70,NULL,NULL,'2MASX J13305088+0047059',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000074,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,202.712166667,0.78494,0.007,NULL,58385316249,912270566,14254227,18),(110415,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110415,36.03,0.46,160,47398,70,NULL,NULL,'2MASX J13305188+4208156',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00016,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,202.716167,42.13778,0,NULL,59323642546,926931914,14483311,16.6),(110416,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110416,37.92,0.07,384,47399,70,NULL,NULL,'SDSS J133053.11-013730.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.0001,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,202.721333,-1.62514,0.037,NULL,43824461393,684757209,10699331,18.4),(110417,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110417,36.41,0.55,192,47400,70,NULL,NULL,'2MASX J13305347-2212391',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,202.722833333,-22.21092,0.249,NULL,43766107456,683845429,10685084,15.3),(110418,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110418,37.66,0.46,340,47401,70,NULL,NULL,'2MASX J13305357+5356555',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000149,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,202.7232917,53.94864,0,NULL,57280220434,895003444,13984428,17.7),(110419,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110419,36.89,0.33,239,47402,70,NULL,NULL,'2MASX J13305363+5852230',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000168,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,202.723833,58.87317,0.013,NULL,57390310779,896723605,14011306,16.7),(110420,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110420,37.7,0.46,347,47403,70,NULL,NULL,'SDSS J133053.86+541606.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000158,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,202.7244583,54.2685,0.021,NULL,57280162772,895002543,13984414,18.6),(110421,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110421,37.92,0.07,384,47404,70,NULL,NULL,'2MASX J13305434-0152313',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000103,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,202.726375,-1.8755,0.033,NULL,43824483210,684757550,10699336,17.4),(110422,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110422,36.61,0.46,210,47405,70,NULL,NULL,'2MASX J13305457+3606498',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,202.727375,36.11394,0,NULL,59168502512,924507851,14445435,16.6),(110423,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110423,37.03,0.27,254,47406,70,NULL,NULL,'2MASX J13305564+4200176',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000197,NULL,'15.7g',0.46,'E0',NULL,NULL,NULL,NULL,1,202.732041667,42.00489,0,NULL,59323607752,926931371,14483302,15.7),(110424,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110424,36.05,0.5,162,47407,NULL,NULL,NULL,'AGC 530478',NULL,'2009ApJS..182..474S',2009,1,0.36,NULL,'G',0.00004,NULL,'16.4R',0.36,'Sc','Group member',NULL,NULL,NULL,1,202.734,-31.56192,0.149,NULL,46904659659,732885307,11451332,16.4),(110425,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110425,36.09,0.2,165,47407,74.4,NULL,NULL,'AGC 530478',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110426,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110426,36.24,0.46,177,47407,NULL,NULL,'Malmquist cor.','AGC 530478',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110427,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110427,37.92,0.07,384,47408,70,NULL,NULL,'2MASX J13305661-0143233',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000077,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,202.735875,-1.72306,0.037,NULL,43824501448,684757835,10699341,17.6),(110428,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110428,37.75,0.46,355,47409,70,NULL,NULL,'2MASX J13305698+3850218',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,202.7375417,38.8395,0,NULL,59295362067,926490032,14476406,18),(110429,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110429,38.1,0.46,417,47410,70,NULL,NULL,'2MASX J13305712+4139558',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000192,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,202.737833333,41.66544,0,NULL,59322640212,926916253,14483066,16.4),(110430,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110430,36.14,0.78,169,47411,70,NULL,NULL,'2MASX J13305771-3149206',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.000067,NULL,'15.1R',0.25,'S0','Group member',NULL,NULL,NULL,1,202.740375,-31.8225,0.149,NULL,46904471529,732882367,11451286,15.1),(110431,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110431,36.89,0.33,239,47412,70,NULL,NULL,'2MASX J13305813+5856461',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000166,NULL,'16.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,202.7425417,58.94608,0.013,NULL,57390349313,896724208,14011315,16.2),(110432,'IRAS','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110432,35,0.8,100,47413,75,NULL,'MAT, I','ESO 577- G 001',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'15.15',0.5,'SAB(r)bc',NULL,NULL,NULL,NULL,1,202.7434583,-21.84753,0.249,NULL,43765610095,683837657,10684963,15.15),(110433,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110433,34.53,0.32,80.5,47413,85,NULL,'I, raw','ESO 577- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110434,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110434,34.56,0.43,81.7,47413,75,NULL,'MAT, I, raw','ESO 577- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110435,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110435,34.57,0.32,82.1,47413,85,NULL,'I, inv','ESO 577- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110436,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110436,34.76,0.43,89.6,47413,75,NULL,'MAT, I, inv','ESO 577- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110437,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110437,34.81,0.43,91.5,47413,75,NULL,'MAT, I, cor','ESO 577- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110438,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110438,35.12,0.53,106,47413,NULL,NULL,'Malmquist cor.','ESO 577- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110439,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110439,35.2,0.51,109,47413,NULL,NULL,NULL,'ESO 577- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110440,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110440,35.24,0.2,112,47413,74.4,NULL,NULL,'ESO 577- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110441,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110441,31.79,0.4,22.8,47414,75,NULL,'B','UGC 08507',NULL,'1988NBGC.C....0000T',1988,1,1.4,'2MASS position is for a southern hot-spot.','G',0.000007,NULL,'13.94',0.8,'Sm','Isolated galaxy',NULL,NULL,NULL,1,202.744458333,19.43806,0.018,NULL,58845099181,919454674,14366479,13.94),(110442,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110442,37.76,0.23,357,47415,70,NULL,NULL,'2MASX J13310022+0110041',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000075,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,202.7509583,1.16772,0.028,NULL,58385267361,912269802,14254215,17.7),(110443,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110443,34.03,0.57,63.9,47416,NULL,NULL,NULL,'2MFGC 10870',NULL,'2009ApJS..182..474S',2009,1,0.82,NULL,'G',0.000037,NULL,'15.05',NULL,'Sc',NULL,NULL,NULL,NULL,1,202.751625,-27.04231,0.197,NULL,43295075178,676485549,10570086,15.05),(110444,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110444,34.07,0.2,65.2,47416,74.4,NULL,NULL,'2MFGC 10870',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110445,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110445,34.19,0.49,68.8,47416,75,NULL,'IR','2MFGC 10870',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110446,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110446,34.22,0.52,69.8,47416,NULL,NULL,'Malmquist cor.','2MFGC 10870',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110447,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110447,38.09,0.46,414,47417,70,NULL,NULL,'2MASX J13310064+1404470',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000165,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,202.752833333,14.07967,0,NULL,58823432715,919116136,14361189,18),(110448,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110448,37.9,0.46,379,47418,70,NULL,NULL,'2MASX J13310082+0847193',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,202.7534583,8.78858,0.011,NULL,58948297333,921067145,14391674,17.4),(110449,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110449,38.25,0.21,446,47419,70,NULL,NULL,'2MASX J13310120+5306245',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,202.755125,53.10694,0.013,NULL,57281294806,895020231,13984691,17.4),(110450,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110450,37.31,0.33,290,47420,70,NULL,NULL,'2MASX J13310171+0426031',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000173,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,202.757167,4.43411,0.039,NULL,58928250724,920753917,14386779,16.8),(110451,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110451,36.02,0.61,160,47421,70,NULL,NULL,'2MASX J13310195-3143466',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.000117,NULL,'14.7R',0.42,'E/S0','Group member',NULL,NULL,NULL,1,202.757833,-31.72986,0.149,NULL,46904739019,732886547,11451352,14.7),(110452,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110452,37.27,0.46,285,47422,70,NULL,NULL,'2MASX J13310214+5455571',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000186,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,202.7587917,54.93258,0,NULL,57291242115,895175658,13987119,16.6),(110453,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110453,35.37,0.19,119,47423,70,NULL,NULL,'CGCG 073-006',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00007,NULL,'15.3g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,202.760875,11.36683,0,NULL,58942105562,920970399,14390162,15.3),(110454,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110454,33.95,0.5,61.6,47424,70,NULL,NULL,'MCG -03-34-087',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000037,NULL,'15.40',0.3,'Sa',NULL,NULL,NULL,NULL,1,202.763375,-16.13011,0.201,NULL,43788422237,684194097,10690532,15.4),(110455,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110455,36.41,0.61,191,47425,70,NULL,NULL,'2MASX J13310367-3145586',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00009,NULL,'16.7b',0.39,NULL,'Group member',NULL,NULL,NULL,1,202.765333,-31.76622,0.149,NULL,46904744183,732886627,11451353,16.7),(110456,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2007ca',NULL,110456,33.78,0.21,56.2,47426,74.2,NULL,'SALT 2','MCG -02-34-061',0.014066,'2010ApJ...716..712A',2010,1,1.5,NULL,'G',0.00001,NULL,'15',0.3,'Sc pec sp',NULL,NULL,NULL,NULL,1,202.766,-15.10119,0.137,NULL,43787063702,684172870,10690201,15),(110457,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2007ca',NULL,110457,33.98,0.03,62.6,47426,72,NULL,'M(H) = -18.317 mag','MCG -02-34-061',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110458,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2007ca',NULL,110458,34.15,0.04,66.7,47426,72,NULL,'MLCS31','MCG -02-34-061',0.014066,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110459,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2007ca',NULL,110459,34.24,0.08,70.5,47426,74.4,NULL,NULL,'MCG -02-34-061',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110460,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2007ca',NULL,110460,34.39,0.16,73.3,47426,72,NULL,NULL,'MCG -02-34-061',0.01508,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110461,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2007ca',NULL,110461,34.39,0.24,74.6,47426,65,NULL,'MLCS31','MCG -02-34-061',0.014066,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110462,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2007ca',NULL,110462,34.42,0.24,75.5,47426,73.8,NULL,'SALT 2 (SNANA)','MCG -02-34-061',0.0153,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110463,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2007ca',NULL,110463,34.43,0.26,75.7,47426,73.8,NULL,'SALT 2 (SNANA)','MCG -02-34-061',0.0154,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110464,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2007ca',NULL,110464,34.45,0.2,76.4,47426,70,NULL,'SALT 2','MCG -02-34-061',0.014066,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110465,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2007ca',NULL,110465,34.62,0.22,82.8,47426,65,NULL,'MLCS17','MCG -02-34-061',0.014066,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110466,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2007ca',NULL,110466,34.64,0.24,83.4,47426,65,NULL,'SALT2','MCG -02-34-061',0.014066,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110467,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2007ca',NULL,110467,34.69,0.23,85.4,47426,65,NULL,'SALT','MCG -02-34-061',0.014066,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110468,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:27','1','SN 2007ca',NULL,110468,35.2,0.2,108,47426,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','MCG -02-34-061',0.014066,'2011A&A...526A..81B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110469,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110469,33.58,0.59,52,47426,NULL,NULL,NULL,'MCG -02-34-061',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110470,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110470,33.64,0.4,53.5,47426,75,NULL,'HOSTS SN 2007ca','MCG -02-34-061',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110471,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110471,33.84,0.43,58.7,47426,75,NULL,'3.6 micron, color corrected','MCG -02-34-061',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110472,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110472,33.87,0.42,59.4,47426,NULL,18.48,'3.6 micron','MCG -02-34-061',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110473,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110473,33.93,0.5,61.1,47426,NULL,NULL,'Malmquist cor.','MCG -02-34-061',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110474,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110474,33.95,0.39,61.6,47426,NULL,NULL,NULL,'MCG -02-34-061',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110475,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110475,34.02,0.43,63.6,47426,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-34-061',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110476,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110476,34.07,0.49,65.3,47426,75,NULL,'IR','MCG -02-34-061',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110477,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110477,34.21,0.35,69.6,47426,NULL,NULL,'Malmquist cor.','MCG -02-34-061',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110478,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110478,34.24,0.08,70.5,47426,74.4,NULL,NULL,'MCG -02-34-061',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110479,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110479,37.45,0.46,309,47427,70,NULL,NULL,'2MASX J13310418+1501139',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000149,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,202.7675,15.02056,0,NULL,58823663260,919119738,14361245,18.3),(110480,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110480,36.33,0.17,185,47428,70,NULL,NULL,'2MASX J13310587+3237262',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000183,NULL,'16.4g',0.36,'E6',NULL,NULL,NULL,NULL,1,202.7745417,32.62406,0,NULL,59180568355,924696380,14448380,16.4),(110481,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110481,36.26,0.53,179,47429,70,NULL,NULL,'2MASX J13310631-7612562',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,202.776417,-76.21567,0.681,NULL,44208342324,690755348,10793052,16.2),(110482,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110482,37.34,0.46,293,47430,70,NULL,NULL,'2MASX J13310648+3549582',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.87',0.19,NULL,NULL,NULL,NULL,NULL,1,202.777,35.83297,0,NULL,59168307132,924504798,14445387,16.87),(110483,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110483,37.32,0.46,291,47431,70,NULL,NULL,'2MASX J13310671+1827024',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.89',0.16,NULL,NULL,NULL,NULL,NULL,1,202.7779583,18.45061,0,NULL,58844941110,919452204,14366440,17.89),(110484,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,NULL,110484,36.69,0.65,218,47432,70,NULL,NULL,'2MASX J13310754-1832271',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,202.781417,-18.54092,0.317,NULL,43815746907,684621045,10697203,15.4),(110485,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110485,37.49,0.46,315,47433,70,NULL,NULL,'SDSS J133107.85-021133.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00017,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,202.7827083,-2.19269,0.033,NULL,43824594903,684759295,10699363,17.8),(110486,'FP','2016-12-15 15:15:15','2016-12-16 11:20:27','1',NULL,'R',110486,37.22,0.33,278,47434,70,NULL,NULL,'2MASXi J1331080+551217',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,202.783625,55.20494,0,NULL,57286942725,895108480,13986070,17.5),(110487,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110487,37.74,0.46,353,47435,70,NULL,NULL,'2MASX J13310859+0400301',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,202.7857917,4.00847,0,NULL,58928822731,920762855,14386919,17.1),(110488,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:28','1','SN 1993O',NULL,110488,36.09,0.16,157,47436,74.2,NULL,'SALT 2','2MASX J13310895-3312576',0.052,'2010ApJ...716..712A',2010,1,0.22,NULL,'G',0.00023,NULL,'17.4V',0.09,'E5/S01',NULL,NULL,NULL,NULL,1,202.788125,-33.21581,0.145,NULL,46901842058,732841282,11450645,17.4),(110489,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:28','1','SN 1993O',NULL,110489,36.64,0.19,202,47436,72,NULL,NULL,'2MASX J13310895-3312576',0.052,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110490,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:28','1','SN 1993O',NULL,110490,36.77,0.03,215,47436,70,NULL,'SALT 2','2MASX J13310895-3312576',0.052,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110491,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:28','1','SN 1993O',NULL,110491,36.8,0.04,218,47436,72,NULL,NULL,'2MASX J13310895-3312576',0.052,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110492,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:28','1','SN 1993O',NULL,110492,36.7,0.08,219,47436,74.4,NULL,NULL,'2MASX J13310895-3312576',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110493,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:28','1','SN 1993O',NULL,110493,36.82,0.15,220,47436,70,NULL,'SALT','2MASX J13310895-3312576',0.052,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110494,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:28','1','SN 1993O',NULL,110494,36.84,0.09,222,47436,65,NULL,'SALT2','2MASX J13310895-3312576',0.052,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110495,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:28','1','SN 1993O',NULL,110495,36.86,0.17,224,47436,70,NULL,'SALT 2','2MASX J13310895-3312576',0.052,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110496,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:28','1','SN 1993O',NULL,110496,36.76,0.12,225,47436,70.8,NULL,NULL,'2MASX J13310895-3312576',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110497,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:28','1','SN 1993O',NULL,110497,36.91,0.18,229,47436,73.8,NULL,'SALT 2 (SNANA)','2MASX J13310895-3312576',0.0518,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110498,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:28','1','SN 1993O',NULL,110498,36.79,0.05,236,47436,70,NULL,NULL,'2MASX J13310895-3312576',0.052,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110499,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:28','1','SN 1993O',NULL,110499,36.98,0.13,236,47436,65,NULL,'SALT','2MASX J13310895-3312576',0.052,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110500,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:28','1','SN 1993O',NULL,110500,36.87,0.07,237,47436,60,NULL,'M(B) = -19.48 mag','2MASX J13310895-3312576',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110501,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:28','1','SN 1993O',NULL,110501,36.99,0.17,238,47436,65,NULL,'SALT2','2MASX J13310895-3312576',0.052,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110502,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:28','1','SN 1993O',NULL,110502,37.03,0.12,242,47436,65,NULL,'MLCS','2MASX J13310895-3312576',0.052,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110503,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:28','1','SN 1993O',NULL,110503,37.14,0.1,242,47436,65,NULL,'MLCS2k2','2MASX J13310895-3312576',0.052,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110504,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:28','1','SN 1993O',NULL,110504,37.05,0.02,244,47436,65,NULL,'SALT','2MASX J13310895-3312576',0.052,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110505,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:28','1','SN 1993O',NULL,110505,36.97,0.06,248,47436,60,NULL,'M(I) = -19.19 mag','2MASX J13310895-3312576',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110506,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:28','1','SN 1993O',NULL,110506,37.08,0.14,248,47436,65,NULL,'MLCS17','2MASX J13310895-3312576',0.052,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110507,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:28','1','SN 1993O',NULL,110507,36.98,0.06,249,47436,60,NULL,'M(V) = -19.47 mag','2MASX J13310895-3312576',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110508,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:28','1','SN 1993O',NULL,110508,37.1,0.07,250,47436,65,NULL,'MLCS2k2','2MASX J13310895-3312576',0.052,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110509,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:28','1','SN 1993O',NULL,110509,37.12,0.1,253,47436,65,NULL,'MLCS2k2','2MASX J13310895-3312576',0.052,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110510,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:28','1','SN 1993O',NULL,110510,37.16,0.14,256,47436,65,NULL,'MLCS31','2MASX J13310895-3312576',0.052,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110511,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:28','1','SN 1993O',NULL,110511,37.16,0.18,257,47436,65,NULL,NULL,'2MASX J13310895-3312576',0.052,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110512,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:28','1','SN 1993O',NULL,110512,37.31,0.14,275,47436,65,NULL,'Template','2MASX J13310895-3312576',0.052,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110513,'SNIa','2016-12-15 15:15:15','2016-12-16 11:20:28','1','SN 1993O',NULL,110513,37.21,0.14,277,47436,60,NULL,NULL,'2MASX J13310895-3312576',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110514,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110514,35.15,0.23,107,47437,70,NULL,NULL,'CGCG 045-002',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000197,NULL,'15.6',0.27,NULL,NULL,NULL,NULL,NULL,1,202.7882083,7.60222,0,NULL,58950228507,921097320,14392145,15.6),(110515,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110515,37.38,0.46,300,47438,70,NULL,NULL,'2MASX J13310938+1433009',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000188,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,202.789125,14.55014,0.005,NULL,58824051870,919125810,14361340,16.3),(110516,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110516,37.92,0.07,384,47439,70,NULL,NULL,'2MASX J13310962-0144447',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,202.7902083,-1.74575,0.041,NULL,43555251861,680550810,10633606,17.4),(110517,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110517,37.92,0.07,384,47440,70,NULL,NULL,'2MASX J13310989-0141077',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000067,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,202.791125,-1.68558,0.041,NULL,43555283887,680551310,10633614,16.6),(110518,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110518,37.22,0.27,278,47441,70,NULL,NULL,'2MASX J13310991+1105196',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,202.791125,11.08875,0,NULL,58941649124,920963267,14390051,17.3),(110519,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110519,37.92,0.07,384,47442,70,NULL,NULL,'2MASX J13311042-0138017',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000123,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,202.7935,-1.63389,0.041,NULL,43555233633,680550525,10633601,17.8),(110520,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110520,36.13,0.51,168,47443,70,NULL,NULL,'II SZ 066',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4',NULL,'E2',NULL,NULL,NULL,NULL,1,202.7965417,-13.30917,0.057,NULL,43993529481,687398898,10740607,15.4),(110521,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110521,37.51,0.21,318,47444,70,NULL,NULL,'2MASX J13311126+0448501',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000141,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,202.7970417,4.814,0.065,NULL,58929429835,920772341,14387067,18),(110522,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110522,37.92,0.07,384,47445,70,NULL,NULL,'2MASX J13311396-0148577',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000127,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,202.80825,-1.816,0.041,NULL,43555245441,680550710,10633604,17.3),(110523,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110523,37.92,0.07,384,47446,70,NULL,NULL,'2MASX J13311469-0130167',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000123,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,202.8112083,-1.50456,0.041,NULL,43557323963,680583186,10634112,17.5),(110524,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110524,36.33,0.17,185,47447,70,NULL,NULL,'2MASX J13311466+3241212',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000178,NULL,'16.9g',0.26,'E0',NULL,NULL,NULL,NULL,1,202.81125,32.68931,0,NULL,59180578977,924696546,14448383,16.9),(110525,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110525,38.25,0.21,446,47448,70,NULL,NULL,'2MASX J13311495+5304085',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,202.812416667,53.06922,0.013,NULL,57281337096,895020892,13984701,17.8),(110526,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110526,36.95,0.46,246,47449,70,NULL,NULL,'2MASX J13311507+3100292',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000196,NULL,'16.7g',0.27,'E3',NULL,NULL,NULL,NULL,1,202.812917,31.00811,0,NULL,59181299310,924707801,14448559,16.7),(110527,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110527,37.82,0.27,366,47450,70,NULL,NULL,'2MASX J13311514+1823114',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.04',0.18,NULL,NULL,NULL,NULL,NULL,1,202.813041667,18.38639,0,NULL,58844953555,919452399,14366443,18.04),(110528,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110528,37.07,0.67,259,47451,70,NULL,NULL,'2MASX J13311518-3137236',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00016,NULL,'14.7R',0.41,'*+E','Group member',NULL,NULL,NULL,1,202.81325,-31.62319,0.149,NULL,46904870336,732888599,11451384,14.7),(110529,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110529,37.96,0.46,391,47452,70,NULL,NULL,'2MASX J13311516+2258174',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,202.81325,22.97158,0.026,NULL,58794224954,918659764,14354058,18),(110530,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110530,37.05,0.46,257,47453,70,NULL,NULL,'2MASX J13311541+2558582',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.50',0.18,NULL,NULL,NULL,NULL,NULL,1,202.814125,25.98292,0.024,NULL,58668960646,916702510,14323476,17.5),(110531,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110531,37.76,0.46,356,47454,70,NULL,NULL,'SDSS J133115.66+063058.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,202.81525,6.51636,0.016,NULL,58980427284,921569176,14399518,18.4),(110532,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110532,37.51,0.21,318,47455,70,NULL,NULL,'2MASX J13311608+0449251',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000192,NULL,'16.2g',0.42,NULL,NULL,NULL,NULL,NULL,1,202.8170417,4.82356,0.065,NULL,58929429711,920772339,14387067,16.2),(110533,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110533,37.92,0.07,384,47456,70,NULL,NULL,'2MASX J13311616-0159337',NULL,'2015arXiv151105856S',2015,1,0.26,'2001ApJ...562..254D: z = 0.092344 +- 0.000143; 2dF: z = 0.08640 +- 0.00021.','G',0.000151,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,202.817458333,-1.99267,0.033,NULL,43555330159,680552033,10633625,17.5),(110534,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110534,37.82,0.27,366,47457,70,NULL,NULL,'2MASX J13311669+1825594',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.68',0.21,NULL,NULL,NULL,NULL,NULL,1,202.819625,18.43303,0,NULL,58844952553,919452383,14366443,17.68),(110535,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110535,35.62,0.74,133,47458,70,NULL,NULL,'2MASX J13311717-1318577',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,202.8215,-13.31608,0.057,NULL,43993517066,687398704,10740604,17.1),(110536,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110536,38.75,0.46,563,47459,70,NULL,NULL,'SDSS J133119.10+461655.2',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,202.829625,46.282,0,NULL,59286885184,926357581,14474337,17.9),(110537,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110537,37.92,0.07,384,47460,70,NULL,NULL,'2MASX J13311956-0145377',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00009,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,202.831375,-1.76047,0.041,NULL,43555258225,680550909,10633607,17.4),(110538,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110538,35.16,0.46,108,47461,70,NULL,NULL,'NGC 5196',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000107,NULL,'14.8g',0.66,'S0-',NULL,NULL,NULL,NULL,1,202.831917,-1.61506,0.041,NULL,43555285091,680551329,10633614,14.8),(110539,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110539,35.72,0.4,139,47462,NULL,NULL,'Malmquist cor.','ESO 383- G 008',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.63',0.5,'S?',NULL,NULL,NULL,NULL,1,202.8330417,-35.08836,0.185,NULL,46864658463,732260288,11441567,14.63),(110540,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110540,35.89,0.37,150,47462,NULL,NULL,NULL,'ESO 383- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110541,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110541,35.93,0.2,153,47462,74.4,NULL,NULL,'ESO 383- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110542,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110542,37.51,0.21,318,47463,70,NULL,NULL,'2MASX J13312009+0447441',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000176,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,202.833625,4.79567,0.065,NULL,58929428169,920772315,14387067,17),(110543,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110543,36.25,0.46,178,47464,70,NULL,NULL,'2MASX J13312033+0802396',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',NULL,NULL,'16.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,202.834625,8.04431,0,NULL,58950787519,921106054,14392282,16),(110544,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110544,37.55,0.46,324,47465,70,NULL,NULL,'2MASX J13312040+1909234',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,202.835,19.1565,0.008,NULL,58844661385,919447834,14366372,17.7),(110545,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110545,38.59,0.33,522,47466,70,NULL,NULL,'SDSS J133120.92+260703.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'19.21',0.14,NULL,NULL,NULL,NULL,NULL,1,202.8372083,26.11767,0.024,NULL,58669801543,916715649,14323682,19.21),(110546,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110546,37.86,0.19,373,47467,70,NULL,NULL,'2MASX J13312151+1332200',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000169,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,202.83975,13.53886,0,NULL,59009165311,922018207,14406534,16.9),(110547,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110547,35.43,0.2,122,47468,74.4,NULL,NULL,'CGCG 073-011',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000008,NULL,'15.9g',0.32,'Scd',NULL,NULL,NULL,NULL,1,202.841333,10.72592,0,NULL,58941751935,920964873,14390076,15.9),(110548,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110548,37.66,0.46,340,47469,70,NULL,NULL,'2MASX J13312227+1600280',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,202.842833333,16.00781,0,NULL,58837550677,919336729,14364636,16.9),(110549,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110549,36.9,0.46,240,47470,70,NULL,NULL,'2MASX J13312241-0010307',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000093,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,202.843333,-0.17531,0.013,NULL,43553877483,680529335,10633270,16.7),(110550,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110550,38.59,0.33,522,47471,70,NULL,NULL,'2MASX J13312269+2603261',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,202.844666667,26.05725,0.024,NULL,58668966269,916702597,14323478,17.4),(110551,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110551,36.04,0.46,162,47472,70,NULL,NULL,'2MASX J13312310-0201357',NULL,'2015arXiv151105856S',2015,1,0.37,'2001ApJ...562..254D: z = 0.089165 +- 0.000150; 2dF: z = 0.03500 +- 0.00030.','G',0.000165,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,202.846333,-2.0265,0.033,NULL,43555328331,680552005,10633625,16.5),(110552,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110552,34.91,0.33,95.8,47473,70,NULL,NULL,'CGCG 073-009',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.0001,NULL,'14.9g',0.53,NULL,NULL,NULL,NULL,NULL,1,202.8482917,9.82436,0,NULL,58952454040,921132094,14392688,14.9),(110553,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110553,37.92,0.07,384,47474,70,NULL,NULL,'2MASXi J1331238-015334',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000123,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,202.849375,-1.89289,0.045,NULL,43555326444,680551975,10633624,17.5),(110554,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110554,38.2,0.33,437,47475,70,NULL,NULL,'2MASX J13312386+3820239',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,202.8494583,38.33994,0,NULL,59295814399,926497099,14476517,16.8),(110555,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110555,37.35,0.46,295,47476,70,NULL,NULL,'2MASX J13312446+1353530',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.03',0.17,NULL,NULL,NULL,NULL,NULL,1,202.852,13.89797,0,NULL,58823314652,919114291,14361160,18.03),(110556,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110556,37.42,0.46,305,47477,70,NULL,NULL,'2MASX J13312451+0740336',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.94',0.09,NULL,NULL,NULL,NULL,NULL,1,202.852083,7.67594,0,NULL,58950693058,921104579,14392259,18.94),(110557,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110557,38,0.46,398,47478,70,NULL,NULL,'2MASX J13312453+5440090',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00018,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,202.852375,54.66919,0,NULL,57292003514,895187554,13987305,16.6),(110558,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110558,34.91,0.33,95.8,47479,70,NULL,NULL,'CGCG 073-010',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000097,NULL,'14.7g',0.74,NULL,NULL,NULL,NULL,NULL,1,202.853166667,9.95844,0,NULL,58952510766,921132980,14392702,14.7),(110559,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110559,36.26,0.54,178,47480,70,NULL,NULL,'2MASX J13312570-3025450',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.8',NULL,'*+E',NULL,NULL,NULL,NULL,1,202.8570417,-30.42922,0.141,NULL,46901254089,732832095,11450501,15.8),(110560,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110560,37.86,0.19,373,47481,70,NULL,NULL,'SDSS J133126.65+133438.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000152,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,202.861083,13.57728,0,NULL,59007081807,921985653,14406025,18.6),(110561,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110561,36.05,0.64,162,47482,70,NULL,NULL,'2MASX J13312683-1319037',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.70',NULL,NULL,NULL,NULL,NULL,NULL,1,202.861875,-13.31778,0.057,NULL,43993517626,687398712,10740604,16.7),(110562,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110562,37.07,0.46,259,47483,70,NULL,NULL,'2MASX J13312723+3031536',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000157,NULL,'16.5g',0.3,'E4',NULL,NULL,NULL,NULL,1,202.863416667,30.53164,0,NULL,59177721353,924651896,14447685,16.5),(110563,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110563,36.76,0.46,225,47484,70,NULL,NULL,'2MASX J13312732+2525061',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.54',0.17,NULL,NULL,NULL,NULL,NULL,1,202.864,25.41831,0.037,NULL,58667111265,916673613,14323025,17.54),(110564,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110564,36.02,0.5,160,47485,70,NULL,NULL,'2MASX J13312752-3149140',NULL,'2014MNRAS.445.2677S',2014,1,0.96,NULL,'G',0.00015,NULL,'13.5R',0.77,'E2 pec','Group member',NULL,NULL,NULL,1,202.864167,-31.82069,0.149,NULL,46904760746,732886886,11451357,13.5),(110565,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110565,38.08,0.46,413,47486,70,NULL,NULL,'SDSS J133127.43+272821.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'19.47',0.12,NULL,NULL,NULL,NULL,NULL,1,202.864333,27.47256,0.01,NULL,58660484423,916570069,14321407,19.47),(110566,'Tully est','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110566,32.59,0.8,32.9,47487,75,NULL,'B','NGC 5188',NULL,'1988NBGC.C....0000T',1988,1,3,NULL,'G',0.00002,NULL,'12.96',1.1,'(R\':)SAB(rs)b  HII','Possible group member',NULL,NULL,NULL,1,202.867833333,-34.79442,0.157,NULL,46894484744,732726324,11448848,12.96),(110567,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110567,31.23,0.69,17.6,47487,100,NULL,'mid-IR','NGC 5188',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110568,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110568,31.67,0.43,21.5,47487,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5188',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110569,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110569,31.75,0.45,22.4,47487,NULL,NULL,'K','NGC 5188',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110570,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110570,31.78,0.47,22.7,47487,NULL,NULL,'H','NGC 5188',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110571,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110571,31.84,0.46,23.3,47487,NULL,NULL,'J','NGC 5188',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110572,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110572,31.89,0.43,23.9,47487,75,NULL,'3.6 micron, color corrected','NGC 5188',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110573,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110573,32.15,0.2,26.9,47487,74.4,NULL,NULL,'NGC 5188',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110574,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110574,32.57,0.4,32.7,47487,NULL,NULL,'mean','NGC 5188',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110575,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110575,36.75,0.46,224,47488,70,NULL,NULL,'2MASX J13312854+1218240',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,202.868916667,12.30681,0,NULL,59008907078,922014173,14406471,17.3),(110576,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110576,36.96,0.46,247,47489,70,NULL,NULL,'2MASX J13312939+1020286',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000162,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,202.872625,10.34131,0,NULL,58941043813,920953809,14389903,16.9),(110577,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110577,37.22,0.27,278,47490,70,NULL,NULL,'2MASX J13312961+1107566',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.88',0.18,'Sy2            LINER',NULL,NULL,NULL,'Sy 2',1,202.8735417,11.13247,0,NULL,58942365463,920974460,14390225,17.88),(110578,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110578,37.02,0.46,254,47491,70,NULL,NULL,'2MASX J13312983+6220261',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,202.8745,62.34069,0.041,NULL,57379656609,896557134,14008705,17.1),(110579,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110579,37.92,0.07,384,47492,70,NULL,NULL,'2MASX J13312996-0139234',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00008,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,202.874875,-1.65644,0.041,NULL,43555288414,680551381,10633615,16.5),(110580,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110580,37.88,0.46,376,47493,70,NULL,NULL,'2MASX J13313018+0537216',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000152,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,202.87575,5.62256,0.052,NULL,58926766543,920730727,14386417,17),(110581,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110581,36.77,0.46,225,47494,70,NULL,NULL,'2MASX J13313071+1142136',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000149,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,202.8780417,11.70383,0,NULL,58942059197,920969674,14390151,17.2),(110582,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110582,36.91,0.46,241,47495,70,NULL,NULL,'2MASX J13313134+4006064',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000151,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,202.880375,40.10169,0,NULL,59315254954,926800858,14481263,16.7),(110583,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110583,37.88,0.27,376,47496,70,NULL,NULL,'LCRS B132856.8-023606',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000148,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,202.882083,-2.85881,0.029,NULL,43824246690,684753854,10699278,17.6),(110584,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110584,37.57,0.46,326,47497,70,NULL,NULL,'2MASX J13313182+2928580',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00013,NULL,'16.9g',0.25,'E2',NULL,NULL,NULL,NULL,1,202.882583,29.483,0.029,NULL,59131956803,923936825,14436512,16.9),(110585,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110585,37.82,0.27,366,47498,70,NULL,NULL,'SDSS J133133.15+182127.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,202.888167,18.35772,0,NULL,58844960879,919452513,14366445,18),(110586,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110586,36.24,0.48,177,47499,NULL,NULL,'Malmquist cor.','2MASX J13313340-3156351',NULL,'2009ApJS..182..474S',2009,1,0.37,NULL,'G',0.000033,NULL,'17.46',0.11,'S','Group member',NULL,NULL,NULL,1,202.889,-31.94319,0.149,NULL,46904715988,732886187,11451346,17.46),(110587,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110587,36.36,0.46,187,47499,NULL,NULL,NULL,'2MASX J13313340-3156351',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110588,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110588,36.4,0.2,191,47499,74.4,NULL,NULL,'2MASX J13313340-3156351',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110589,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110589,36.8,0.62,229,47500,70,NULL,NULL,'2MASX J13313349-3148461',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.000107,NULL,'14.9R',0.44,'E2','Group member',NULL,NULL,NULL,1,202.889416667,-31.81289,0.149,NULL,46904760502,732886882,11451357,14.9),(110590,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110590,35.6,0.4,132,47501,NULL,NULL,'mean','UGC 08525',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000103,NULL,'14.30',0.8,'S0-?',NULL,NULL,NULL,NULL,1,202.89325,71.48022,0.021,NULL,57885872221,904466753,14132293,14.3),(110591,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110591,35.69,0.45,137,47501,NULL,NULL,'K','UGC 08525',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110592,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110592,38.2,0.33,437,47502,70,NULL,NULL,'2MASXi J1331352+382054',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.6g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,202.897,38.34864,0,NULL,59295842835,926497544,14476524,17.6),(110593,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110593,36.07,0.51,164,47503,70,NULL,NULL,'2MASX J13313569-3010121',NULL,'2014MNRAS.445.2677S',2014,1,0.5,'6dF DR2 has z = 0.049270.','G',0.00015,NULL,'16.3',NULL,'*+E',NULL,NULL,NULL,NULL,1,202.898667,-30.17008,0.169,NULL,46846487340,731976364,11437130,16.3),(110594,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110594,36.16,0.46,170,47504,70,NULL,NULL,'2MASX J13313610+2318501',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000103,NULL,'16.48',0.31,NULL,NULL,NULL,NULL,NULL,1,202.9005,23.31408,0.033,NULL,58794305319,918661020,14354078,16.48),(110595,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110595,37.86,0.19,373,47505,70,NULL,NULL,'2MASX J13313618+1335035',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,'PHOT','17.56',0.2,'BrClG',NULL,NULL,NULL,NULL,1,202.900708333,13.58439,0,NULL,59007095758,921985871,14406029,17.56),(110596,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110596,36.26,0.46,178,47506,70,NULL,NULL,'2MASX J13313693+6137421',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000169,NULL,'16.0g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,202.9037083,61.62831,0,NULL,57381368636,896583884,14009123,16),(110597,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110597,37.92,0.07,384,47507,70,NULL,NULL,'2MASX J13313770-0152234',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00013,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,202.906917,-1.87333,0.045,NULL,43555461200,680554081,10633657,16.7),(110598,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110598,36.09,0.46,165,47508,70,NULL,NULL,'2MASX J13313807+1359305',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,202.9087083,13.99186,0,NULL,58823497399,919117146,14361205,16.6),(110599,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110599,36.93,0.46,243,47509,70,NULL,NULL,'2MASX J13313830+1015046',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000177,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,202.909708333,10.25136,0,NULL,58941012614,920953322,14389895,16.5),(110600,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110600,37.32,0.46,291,47510,70,NULL,NULL,'2MASX J13313840+4034375',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000162,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,202.909917,40.57706,0,NULL,59314874184,926794909,14481170,16.7),(110601,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110601,37.02,0.46,254,47511,70,NULL,NULL,'2MASX J13313954+4737264',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000191,NULL,'16.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,202.915,47.62397,0,NULL,59288283354,926379427,14474678,16.4),(110602,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110602,37.51,0.21,318,47512,70,NULL,NULL,'2MASX J13313970+0455116',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,202.915291667,4.92003,0.065,NULL,58926518160,920726846,14386356,17.3),(110603,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110603,37.07,0.46,260,47513,70,NULL,NULL,'2MASX J13314017+2549066',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,202.9172917,25.81844,0.019,NULL,58669079520,916704367,14323505,17.5),(110604,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110604,36.92,0.46,242,47514,70,NULL,NULL,'2MASX J13314024+5705343',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,202.917667,57.093,0,NULL,57285909352,895092333,13985817,17.2),(110605,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110605,37.92,0.07,384,47515,70,NULL,NULL,'SDSS J133141.43-014319.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000177,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,202.922666667,-1.72211,0.041,NULL,43555246666,680550729,10633605,18.5),(110606,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110606,35.6,0.66,132,47516,70,NULL,NULL,'2MASX J13314273-2124422',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.96',0.5,NULL,NULL,NULL,NULL,NULL,1,202.927917,-21.41175,0.269,NULL,43767807497,683871992,10685499,15.96),(110607,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110607,36.18,0.33,172,47517,70,NULL,NULL,'2MASX J13314293+0931176',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000148,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,202.929083333,9.52136,0,NULL,58953025012,921141015,14392828,17.1),(110608,'GRB','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110608,46.37,0.6,3720,47518,69.7,NULL,'Calibrated','GRB 060206',4.04795,'2009MNRAS.400..775C',2009,1,NULL,NULL,'G',0.0002,NULL,'17  V',NULL,'Swift',NULL,NULL,NULL,NULL,1,202.930916667,35.051,0,NULL,59167350195,924489846,14445153,17),(110609,'GRB','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110609,46.53,0.65,4010,47518,72,NULL,NULL,'GRB 060206',4.04795,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110610,'GRB','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110610,46.55,0.51,4040,47518,69.7,NULL,'Fiducial','GRB 060206',4.04795,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110611,'GRB','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110611,46.63,0.64,4200,47518,70,NULL,NULL,'GRB 060206',4.04795,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110612,'GRB','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110612,46.78,0.75,4500,47518,NULL,NULL,NULL,'GRB 060206',4.04795,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110613,'GRB','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110613,48.54,1.54,10100,47518,100,NULL,NULL,'GRB 060206',4.04795,'2009EPJC...63..139W',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110614,'GRB','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110614,48.68,1.48,10800,47518,69.7,NULL,'Calibrated','GRB 060206',4.04795,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110615,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110615,35.98,0.48,157,47519,70,NULL,NULL,'2MASX J13314406-2948236',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.6',NULL,'*+E',NULL,NULL,NULL,NULL,1,202.933625,-29.80661,0.153,NULL,46846557813,731977465,11437147,15.6),(110616,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110616,35.88,0.58,150,47520,70,NULL,NULL,'2MASX J13314435-4138584',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.3,NULL,NULL,NULL,NULL,NULL,1,202.9347917,-41.64961,0.353,NULL,46973624170,733962877,11468169,14.1),(110617,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110617,34.84,0.47,92.8,47521,70,NULL,NULL,'IC 0892',NULL,'2014MNRAS.445.2677S',2014,1,1.13,NULL,'G',0.000083,NULL,'14.0g',0.71,'S0 pec',NULL,NULL,NULL,NULL,1,202.941167,-2.71306,0.053,NULL,43554735304,680542739,10633480,14),(110618,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110618,34.99,0.46,99.4,47521,70,NULL,NULL,'IC 0892',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110619,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110619,37.2,0.46,276,47522,70,NULL,NULL,'2MASX J13314630-0158584',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000136,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,202.942791667,-1.98292,0.045,NULL,43555355655,680552432,10633631,17.5),(110620,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110620,36.49,0.5,199,47523,70,NULL,NULL,'2MASX J13314673-3253401',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'14.10',NULL,'S0+*;BrClG',NULL,NULL,NULL,NULL,1,202.944833,-32.89442,0.153,NULL,46902724406,732855068,11450860,14.1),(110621,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110621,37.29,0.46,287,47524,70,NULL,NULL,'2MASX J13314725+2534595',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,202.946791667,25.58333,0.037,NULL,58669032215,916703628,14323494,16.9),(110622,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110622,37.15,0.65,269,47525,70,NULL,NULL,'2MASX J13314773-3125381',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.000183,NULL,'15.2R',0.3,NULL,'Group member',NULL,NULL,NULL,1,202.949,-31.42731,0.157,NULL,46904860424,732888444,11451381,15.2),(110623,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110623,36.86,0.59,236,47526,70,NULL,NULL,'2MASX J13314871-4125174',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'13.28',0.29,NULL,NULL,NULL,NULL,NULL,1,202.953,-41.42147,0.353,NULL,46973587960,733962311,11468161,13.28),(110624,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110624,37.79,0.46,361,47527,70,NULL,NULL,'2MASX J13314878+5501454',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,202.953417,55.02928,0,NULL,57291191669,895174869,13987107,17.9),(110625,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110625,33.81,0.58,57.8,47528,70,NULL,NULL,'NGC 5193A',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00007,NULL,'13.97',0.4,'S0^0^: sp','Pair member (points to parent)',NULL,NULL,NULL,1,202.9545,-33.23947,0.125,NULL,46901885385,732841959,11450655,13.97),(110626,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110626,36.16,0.46,171,47529,70,NULL,NULL,'2MASX J13315010+1411296',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000169,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,202.958875,14.19156,0,NULL,58823367140,919115111,14361173,16.4),(110627,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110627,38.12,0.46,421,47530,70,NULL,NULL,'SDSS J133150.46+503338.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00014,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,202.960333333,50.56064,0,NULL,59208591601,925134243,14455222,18.4),(110628,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110628,35.15,0.46,107,47531,70,NULL,NULL,'CGCG 218-019',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.00017,NULL,'15.0g',0.62,'E0',NULL,NULL,NULL,NULL,1,202.961333,44.15222,0,NULL,59321947852,926905435,14482897,15),(110629,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110629,37.92,0.07,384,47532,70,NULL,NULL,'2MASX J13315090-0141134',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000117,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,202.962125,-1.68708,0.041,NULL,43555442889,680553795,10633653,17.5),(110630,'IRAS','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110630,33.91,0.8,60.4,47533,75,NULL,'HMCL, I','IC 4275',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000043,NULL,'14.20',0.5,'SB?            HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,202.96375,-29.73239,0.153,NULL,46846549924,731977342,11437145,14.2),(110631,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110631,33.3,0.4,45.8,47533,75,NULL,'HMCL, I, raw','IC 4275',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110632,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110632,33.39,0.4,47.7,47533,75,NULL,'HMCL, I, inv','IC 4275',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110633,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110633,33.54,0.4,51.1,47533,75,NULL,'HMCL, I, cor','IC 4275',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110634,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110634,33.96,0.4,62,47533,NULL,NULL,'mean','IC 4275',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110635,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110635,33.98,0.47,62.4,47533,NULL,NULL,'H','IC 4275',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110636,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110636,34.07,0.46,65.1,47533,NULL,NULL,'J','IC 4275',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110637,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110637,34.45,0.51,77.6,47534,70,NULL,NULL,'ESO 577- G 004',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00013,NULL,'15.06',0.6,'S0',NULL,NULL,NULL,NULL,1,202.9639583,-20.17361,0.253,NULL,43816689855,684635778,10697434,15.06),(110638,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110638,37.88,0.27,376,47535,70,NULL,NULL,'LCRS B132916.9-023655',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000185,NULL,'16.2g',0.35,'FR II          AGN',NULL,NULL,NULL,NULL,1,202.966125,-2.87208,0.053,NULL,43554713104,680542392,10633474,16.2),(110639,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110639,37.92,0.07,384,47536,70,NULL,NULL,'2MASX J13315217-0156064',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000093,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,202.9672917,-1.93522,0.045,NULL,43555343723,680552245,10633628,17.4),(110640,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110640,31.7,0.4,21.9,47537,NULL,NULL,'mean','UGC 08516',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000007,NULL,'14.03',0.8,'Scd:','Isolated galaxy',NULL,NULL,NULL,1,202.969125,20.00117,0.006,NULL,58843939781,919436559,14366196,14.03),(110641,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110641,31.95,0.47,24.6,47537,NULL,NULL,'H','UGC 08516',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110642,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110642,36.94,0.46,244,47538,70,NULL,NULL,'2MASX J13315326+6342280',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000075,NULL,'17.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,202.972,63.70789,0.041,NULL,57346269607,896035462,14000554,17.6),(110643,'GCLF','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110643,33.41,0.25,48.1,47539,NULL,NULL,NULL,'NGC 5193',NULL,'1998ApJ...499..577L',1998,1,1.9,NULL,'G',0.000011,NULL,'11.7V',1.7,'E pec:','Possible group member',NULL,NULL,NULL,1,202.9730417,-33.23422,0.125,NULL,46901885190,732841956,11450655,11.7),(110644,'GCLF','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110644,34.24,0.18,70.5,47539,NULL,NULL,NULL,'NGC 5193',NULL,'2002ApJ...567..294O',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110645,'SBF','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110645,32.66,0.29,34,47539,NULL,NULL,'I','NGC 5193',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110646,'SBF','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110646,32.66,0.29,34,47539,NULL,NULL,NULL,'NGC 5193',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110647,'SBF','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110647,32.74,0.14,35.3,47539,74.4,NULL,NULL,'NGC 5193',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110648,'SBF','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110648,32.82,0.29,36.7,47539,NULL,NULL,'Malmquist cor.','NGC 5193',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110649,'SBF','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110649,33.35,0.14,46.8,47539,NULL,NULL,'I','NGC 5193',NULL,'1998ApJ...499..577L',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110650,'SBF','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110650,33.35,0.15,46.8,47539,NULL,NULL,'I','NGC 5193',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110651,'SBF','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110651,33.51,0.15,50.4,47539,NULL,NULL,NULL,'NGC 5193',NULL,'2001ApJ...550..503J',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110652,'SBF','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110652,33.6,0.18,52.5,47539,NULL,NULL,'HST KP Calibrated, F814W','NGC 5193',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110653,'D-Sigma','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110653,33,0.4,39.9,47539,75,NULL,'Edat, raw','NGC 5193',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110654,'D-Sigma','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110654,33.23,0.4,44.3,47539,75,NULL,'Edat, cor','NGC 5193',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110655,'Faber-Jackson','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110655,30.6,0.65,13.2,47539,95,NULL,'Weighted Mean','NGC 5193',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110656,'Faber-Jackson','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110656,31.72,0.81,22.1,47539,55,NULL,'Visvanathan & Sandage 1979','NGC 5193',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110657,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110657,32.98,0.47,39.4,47539,70,NULL,NULL,'NGC 5193',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110658,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110658,33.16,0.41,42.9,47539,NULL,NULL,NULL,'NGC 5193',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110659,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110659,33.46,0.41,49.2,47539,NULL,NULL,'Malmquist cor.','NGC 5193',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110660,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110660,33.5,0.45,50.1,47539,NULL,NULL,'K','NGC 5193',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110661,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110661,33.72,0.4,55.5,47539,NULL,NULL,'mean','NGC 5193',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110662,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110662,37.86,0.19,373,47540,70,NULL,NULL,'SDSS J133153.80+132535.7',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,202.974167,13.42658,0,NULL,59009203680,922018807,14406543,17.7),(110663,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110663,38.28,0.46,452,47541,70,NULL,NULL,'2MASX J13315398+3824125',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,202.9747917,38.40361,0,NULL,59295855984,926497749,14476527,18),(110664,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110664,37.92,0.07,384,47542,70,NULL,NULL,'2MASX J13315417-0204404',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,202.975625,-2.07783,0.045,NULL,43555295670,680551494,10633617,18),(110665,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110665,38.59,0.46,522,47543,70,NULL,NULL,'LCRS B132919.0-025540',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000147,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,202.975625,-3.18453,0.037,NULL,43831534267,684867722,10701058,17.8),(110666,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110666,37.92,0.07,384,47544,70,NULL,NULL,'2MASX J13315444-0143424',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00007,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,202.976875,-1.72847,0.041,NULL,43555475436,680554303,10633660,17.5),(110667,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110667,36.83,0.46,232,47545,70,NULL,NULL,'2MASX J13315457-0126474',NULL,'2015arXiv151105856S',2015,1,0.52,'SDSS DR2 gives z=0.0753.','G',0.000183,NULL,'16.0g',0.38,'E/S0',NULL,NULL,NULL,NULL,1,202.97725,-1.44661,0.041,NULL,43557350387,680583599,10634118,16),(110668,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110668,37.86,0.19,373,47546,70,NULL,NULL,'2MASX J13315483+1328105',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000226,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,202.9785417,13.46947,0,NULL,59009198322,922018723,14406542,16.2),(110669,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110669,37.88,0.27,376,47547,70,NULL,NULL,'LCRS B132920.2-023620',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,202.979667,-2.86253,0.053,NULL,43554713451,680542397,10633474,17.5),(110670,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110670,37.86,0.19,373,47548,70,NULL,NULL,'2MASX J13315525+1331316',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,202.98025,13.52536,0,NULL,59009145951,922017905,14406529,17.3),(110671,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110671,37.99,0.46,397,47549,70,NULL,NULL,'2MASX J13315608+6327380',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000102,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,202.9839583,63.46053,0.057,NULL,57348323680,896067557,14001055,17.4),(110672,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110672,37.74,0.46,354,47550,70,NULL,NULL,'2MASX J13315685+0711426',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.98',0.18,NULL,NULL,NULL,NULL,NULL,1,202.9869583,7.19511,0,NULL,58947557027,921055578,14391493,17.98),(110673,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110673,37.87,0.46,374,47551,70,NULL,NULL,'2MASX J13315707+1520336',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,202.9879583,15.34256,0,NULL,58835051712,919297683,14364026,17.8),(110674,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110674,37.9,0.46,381,47552,70,NULL,NULL,'2MASX J13315740+1003136',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000176,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,202.989167,10.05389,0,NULL,58952403543,921131305,14392676,17.8),(110675,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110675,37.35,0.46,295,47553,70,NULL,NULL,'2MASX J13315926+1857031',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,202.996958333,18.95094,0,NULL,58844648534,919447633,14366369,17.2),(110676,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110676,37.51,0.21,318,47554,70,NULL,NULL,'SDSS J133159.68+045506.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000147,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,202.998708333,4.91839,0.055,NULL,58926521050,920726891,14386357,18.3),(110677,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110677,36.18,0.33,172,47555,70,NULL,NULL,'2MASX J13320085+0932176',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000164,NULL,'15.9g',0.38,NULL,NULL,NULL,NULL,NULL,1,203.00375,9.53814,0,NULL,58953034955,921141171,14392830,15.9),(110678,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110678,38.03,0.33,404,47556,70,NULL,NULL,'2MASX J13320110+1141096',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000113,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,203.004667,11.686,0,NULL,58942074323,920969911,14390154,16.5),(110679,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110679,38.2,0.46,438,47557,70,NULL,NULL,'2MASX J13320289+3815275',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,203.012125,38.25775,0,NULL,59295839955,926497499,14476523,17.6),(110680,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110680,37.92,0.07,384,47558,70,NULL,NULL,'SDSS J133204.09-020023.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,203.017083333,-2.00667,0.045,NULL,43555319736,680551870,10633622,18.6),(110681,'GRB','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110681,38.21,NULL,438,47559,65,NULL,'L = 10e57 photons/s','3B 920720',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,203.016667,36.86972,0,NULL,59165882098,924466907,14444795,NULL),(110682,'GRB','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110682,41,NULL,1580,47559,65,NULL,'L = 2 x 10e58 photons/s','3B 920720',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110683,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110683,37.9,0.46,380,47560,70,NULL,NULL,'2MASX J13320610+1128168',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000177,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,203.025291667,11.4715,0,NULL,58942281668,920973151,14390205,17.1),(110684,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110684,35.54,0.47,128,47561,NULL,NULL,'H','IC 4276',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000033,NULL,'15.30',0.2,'S?             HII',NULL,NULL,NULL,NULL,1,203.026083333,-28.15683,0.137,NULL,46848766249,732011972,11437687,15.3),(110685,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110685,35.65,0.4,135,47561,NULL,NULL,'mean','IC 4276',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110686,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110686,35.69,0.45,137,47561,NULL,NULL,'K','IC 4276',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110687,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110687,35.82,0.46,146,47561,NULL,NULL,'J','IC 4276',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110688,'D-Sigma','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110688,33.42,0.4,48.3,47562,75,NULL,'Edat, raw','NGC 5216',NULL,'1997ApJS..109..333W',1997,1,1.31,NULL,'G',0.000087,NULL,'13.6g',1.08,'E0 pec         BLAGN','Pair member (points to parent)',NULL,NULL,'Sy 1',1,203.0287083,62.70069,0.029,NULL,57348178647,896065291,14001020,13.6),(110689,'D-Sigma','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110689,33.76,0.4,56.4,47562,75,NULL,'Edat, cor','NGC 5216',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110690,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110690,33.35,0.4,46.7,47562,NULL,NULL,'mean','NGC 5216',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110691,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110691,33.78,0.45,57,47562,NULL,NULL,'K','NGC 5216',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110692,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110692,35.07,0.56,103,47563,70,NULL,NULL,'2MASX J13320766-0851064',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.11',0.3,NULL,NULL,NULL,NULL,NULL,1,203.032167,-8.85186,0.097,NULL,43862582669,685352854,10708638,16.11),(110693,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110693,38.03,0.33,404,47564,70,NULL,NULL,'SDSS J133207.94+114259.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,203.033083333,11.71664,0,NULL,58942075689,920969932,14390155,17.9),(110694,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110694,37.88,0.46,377,47565,70,NULL,NULL,'SDSS J133207.94+242121.2',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.54',0.17,NULL,NULL,NULL,NULL,NULL,1,203.033083333,24.35592,0.025,NULL,58666816095,916669001,14322953,18.54),(110695,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110695,37.15,0.46,269,47566,70,NULL,NULL,'2MASX J13320834+3548260',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000173,NULL,'17.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,203.0347083,35.80739,0,NULL,59167216237,924487753,14445121,17.3),(110696,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110696,35.9,0.46,151,47567,70,NULL,NULL,'MCG +07-28-027',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',NULL,NULL,'15.4g',0.51,NULL,NULL,NULL,NULL,NULL,1,203.03525,40.49992,0,NULL,59314871399,926794865,14481169,15.4),(110697,'IRAS','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110697,34.21,0.8,69.4,47568,75,NULL,'MAT, I','ESO 509- G 045',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000033,NULL,'14.25',1.1,'Sc',NULL,NULL,NULL,NULL,1,203.035417,-22.95217,0.245,NULL,43769154030,683893031,10685828,14.25),(110698,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110698,32.96,0.32,39,47568,85,NULL,'I, raw','ESO 509- G 045',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110699,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110699,32.97,0.32,39.2,47568,85,NULL,'I, inv','ESO 509- G 045',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110700,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110700,33.23,0.43,44.3,47568,75,NULL,'MAT, I, raw','ESO 509- G 045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110701,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110701,33.31,0.43,45.9,47568,75,NULL,'MAT, I, inv','ESO 509- G 045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110702,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110702,33.48,0.2,49.7,47568,74.4,NULL,NULL,'ESO 509- G 045',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110703,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110703,33.49,0.43,50,47568,75,NULL,'MAT, I, cor','ESO 509- G 045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110704,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110704,34.43,0.11,77.1,47568,NULL,NULL,NULL,'ESO 509- G 045',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110705,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110705,37.48,0.27,313,47569,70,NULL,NULL,'2MASX J13320874+3759353',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,203.036667,37.99314,0,NULL,59295040551,926485008,14476328,17.2),(110706,'IRAS','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110706,35.12,0.8,106,47570,75,NULL,'MAT, I','ESO 509- G 044',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000023,NULL,'15',0.3,'Sb:            HII',NULL,NULL,NULL,NULL,1,203.037167,-24.86017,0.277,NULL,43300768178,676574502,10571476,15),(110707,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110707,34.66,0.32,85.4,47570,85,NULL,'I, raw','ESO 509- G 044',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110708,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110708,34.67,0.43,85.9,47570,75,NULL,'MAT, I, raw','ESO 509- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110709,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110709,34.71,0.32,87.7,47570,85,NULL,'I, inv','ESO 509- G 044',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110710,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110710,34.8,0.49,91.2,47570,75,NULL,'IR','ESO 509- G 044',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110711,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110711,34.92,0.43,96.5,47570,75,NULL,'MAT, I, inv','ESO 509- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110712,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110712,34.93,0.5,97,47570,NULL,NULL,'Malmquist cor.','ESO 509- G 044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110713,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110713,34.96,0.43,98,47570,75,NULL,'MAT, I, cor','ESO 509- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110714,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110714,35.05,0.48,103,47570,NULL,NULL,NULL,'ESO 509- G 044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110715,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110715,35.09,0.2,104,47570,74.4,NULL,NULL,'ESO 509- G 044',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110716,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110716,35.37,0.4,119,47570,NULL,NULL,'mean','ESO 509- G 044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110717,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110717,35.42,0.47,121,47570,NULL,NULL,'H','ESO 509- G 044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110718,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110718,35.54,0.45,128,47570,NULL,NULL,'K','ESO 509- G 044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110719,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110719,36.1,0.79,166,47571,70,NULL,NULL,'2MASX J13320917-3103271',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'17.02',0.13,NULL,'Group member',NULL,NULL,NULL,1,203.0382083,-31.0575,0.173,NULL,46904323411,732880053,11451250,17.02),(110720,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110720,38.43,0.46,485,47572,70,NULL,NULL,'SDSS J133209.67+105015.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,203.040333,10.83761,0,NULL,58941704649,920964135,14390064,18.2),(110721,'Sosies','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110721,33.53,0.33,50.8,47573,NULL,NULL,NULL,'NGC 5218',NULL,'2002A&A...393...57T',2002,1,1.85,NULL,'G',0.000072,NULL,'13.2g',0.99,'SB(s)b? pec;HIILINER','Pair member (points to parent)',NULL,NULL,NULL,1,203.04325,62.76775,0.029,NULL,57348193724,896065526,14001023,13.2),(110722,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110722,33.26,0.4,44.9,47573,NULL,NULL,'mean','NGC 5218',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110723,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110723,33.63,0.47,53.3,47573,NULL,NULL,'H','NGC 5218',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110724,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110724,33.63,0.45,53.3,47573,NULL,NULL,'K','NGC 5218',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110725,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110725,33.69,0.46,54.8,47573,NULL,NULL,'J','NGC 5218',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110726,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110726,37.81,0.19,364,47574,70,NULL,NULL,'2MASX J13321155+6012460',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,203.048083,60.21289,0,NULL,57392611982,896759562,14011868,17.4),(110727,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110727,37.25,0.33,281,47575,70,NULL,NULL,'2MASX J13321165+3130270',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00018,NULL,'17.1g',0.25,'E0',NULL,NULL,NULL,NULL,1,203.048625,31.50742,0.022,NULL,59181620169,924712815,14448637,17.1),(110728,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110728,37.14,0.46,268,47576,70,NULL,NULL,'2MASX J13321171+2614540',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000113,NULL,'17.39',0.24,NULL,NULL,NULL,NULL,NULL,1,203.048833,26.24844,0.026,NULL,58668494818,916695231,14323362,17.39),(110729,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110729,37.48,0.27,313,47577,70,NULL,NULL,'2MASX J13321214+3752363',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000158,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,203.0507083,37.87681,0,NULL,59295043897,926485060,14476329,18.5),(110730,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110730,36.66,0.92,214,47578,70,NULL,NULL,'2MASX J13321272-2322416',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,203.053125,-23.37817,0.229,NULL,43764813295,683825207,10684768,15.9),(110731,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110731,37.33,0.46,293,47579,70,NULL,NULL,'2MASX J13321286+4906071',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000197,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,203.0534583,49.10214,0,NULL,59276184085,926190376,14471724,16.5),(110732,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110732,34.27,0.46,71.5,47580,70,NULL,NULL,'NGC 5203',NULL,'2014MNRAS.445.2677S',2014,1,1.9,NULL,'G',0.00007,NULL,'13.45',1.1,'S0-',NULL,NULL,NULL,NULL,1,203.055833,-8.78622,0.097,NULL,43862553064,685352391,10708631,13.45),(110733,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110733,36.74,0.33,223,47581,70,NULL,NULL,'2MASX J13321339+1234513',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,203.055875,12.58106,0,NULL,59006185631,921971650,14405807,17),(110734,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110734,36.74,0.33,223,47582,70,NULL,NULL,'2MASX J13321339+1235173',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,'PRED','17.50',0.18,NULL,NULL,NULL,NULL,NULL,1,203.055917,12.58819,0,NULL,59006178537,921971539,14405805,17.5),(110735,'IRAS','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110735,35.15,0.8,107,47583,75,NULL,'HMCL, I','NGC 5207',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00002,NULL,'14.00',1,'SAB(r)b',NULL,NULL,NULL,NULL,1,203.0582917,13.89239,0,NULL,58823300408,919114068,14361157,14),(110736,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110736,34.49,0.69,79.1,47583,100,NULL,'mid-IR','NGC 5207',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110737,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110737,34.75,0.47,89.3,47583,NULL,NULL,'H','NGC 5207',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110738,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110738,34.83,0.46,92.3,47583,NULL,NULL,'J','NGC 5207',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110739,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110739,34.83,0.45,92.4,47583,NULL,NULL,'K','NGC 5207',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110740,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110740,34.96,0.29,98.1,47583,NULL,NULL,'Malmquist cor.','NGC 5207',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110741,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110741,35.01,0.4,101,47583,75,NULL,'HMCL, I, raw','NGC 5207',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110742,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110742,35.12,0.4,106,47583,NULL,NULL,'mean','NGC 5207',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110743,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110743,35.2,0.4,109,47583,75,NULL,'HMCL, I, cor','NGC 5207',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110744,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110744,35.28,0.25,114,47583,NULL,NULL,NULL,'NGC 5207',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110745,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110745,35.31,0.4,115,47583,75,NULL,'HMCL, I, inv','NGC 5207',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110746,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110746,35.38,0.2,119,47583,74.4,NULL,NULL,'NGC 5207',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110747,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110747,37.81,0.33,365,47584,70,NULL,NULL,'2MASX J13321461+0413238',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000149,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,203.0610417,4.22333,0.015,NULL,58928363712,920755683,14386807,17.2),(110748,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110748,36.33,0.17,185,47585,70,NULL,NULL,'2MASX J13321513+3242530',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00018,NULL,'15.6g',0.44,'E1',NULL,NULL,NULL,NULL,1,203.063125,32.71483,0,NULL,59180420984,924694077,14448344,15.6),(110749,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110749,37.92,0.07,384,47586,70,NULL,NULL,'2MASX J13321558-0143115',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000073,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,203.064833,-1.72003,0.041,NULL,43555483495,680554429,10633662,17.5),(110750,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110750,37.96,0.21,392,47587,70,NULL,NULL,'2MASX J13321576+5413202',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,203.065625,54.22222,0,NULL,57280148894,895002326,13984411,18.1),(110751,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110751,38.03,0.27,404,47588,70,NULL,NULL,'2MASX J13321681+0113238',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000081,NULL,'16.7g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,203.070083,1.22322,0.041,NULL,58388362819,912318169,14254971,16.7),(110752,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110752,37.48,0.27,313,47589,70,NULL,NULL,'2MASX J13321704+3752444',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.10',0.22,NULL,NULL,NULL,NULL,NULL,1,203.070958333,37.87886,0,NULL,59295045141,926485080,14476329,16.1),(110753,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110753,37.96,0.21,392,47590,70,NULL,NULL,'2MASX J13321716+5416112',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000142,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,203.0714583,54.26967,0,NULL,57280149612,895002337,13984411,18.4),(110754,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110754,37.63,0.71,336,47591,70,NULL,NULL,'2MASX J13321920-3255130',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000097,NULL,'15.20',0.3,'S0',NULL,NULL,NULL,NULL,1,203.079875,-32.92039,0.153,NULL,46902733441,732855210,11450862,15.2),(110755,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110755,37.81,0.19,364,47592,70,NULL,NULL,'2MASX J13321963+6007120',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,203.082,60.11994,0,NULL,57392616513,896759633,14011869,17.3),(110756,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110756,37.18,0.66,273,47593,70,NULL,NULL,'2MASX J13322089-4728458',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,203.087,-47.47947,0.501,NULL,46957642094,733713157,11464268,17.1),(110757,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110757,35.47,0.46,124,47594,70,NULL,NULL,'2MASX J13322098+2904340',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000117,NULL,'15.3g',0.47,'E5',NULL,NULL,NULL,NULL,1,203.0872083,29.07625,0.023,NULL,59135147976,923986687,14437291,15.3),(110758,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110758,38.1,0.33,417,47595,70,NULL,NULL,'2MASX J13322135+6735231',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000086,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,203.0890417,67.58964,0.021,NULL,57907629277,904806707,14137604,17.1),(110759,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110759,36.33,0.17,185,47596,70,NULL,NULL,'2MASX J13322223+3227110',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000191,NULL,'16.1g',0.37,'E0',NULL,NULL,NULL,NULL,1,203.092666667,32.45303,0,NULL,59180233303,924691145,14448299,16.1),(110760,'GCLF','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110760,33.41,0.25,48.1,47597,NULL,NULL,'NGC 5193','Abell 3560',NULL,'1998ApJ...499..577L',1998,1,NULL,'Vettolani et al. (1990AJ.....99.1709V) say v=3600km/sec is a foreground system.','GClstr',NULL,NULL,NULL,NULL,'I      [BM];R  [A]',NULL,NULL,NULL,NULL,1,203.094167,-33.13944,0.153,NULL,46901836229,732841191,11450643,NULL),(110761,'SBF','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110761,33.35,0.14,46.8,47597,NULL,NULL,'NGC 5193','Abell 3560',NULL,'1998ApJ...499..577L',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110762,'SBF','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110762,33.6,0.18,52.5,47597,NULL,NULL,'HST KP Calibrated, F814W','ABELL 3560',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110763,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110763,37.38,0.46,300,47598,70,NULL,NULL,'2MASX J13322276+5926507',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,203.094916667,59.44736,0.005,NULL,57388364507,896693195,14010831,17.2),(110764,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110764,37.66,0.46,341,47599,70,NULL,NULL,'2MASX J13322346+3812404',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,203.0977083,38.21136,0,NULL,59295827816,926497309,14476520,17.8),(110765,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110765,37.81,0.33,365,47600,70,NULL,NULL,'2MASX J13322424+0414208',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000154,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,203.100916667,4.23911,0.015,NULL,58928182665,920752854,14386763,17.1),(110766,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110766,34.94,0.51,97.1,47601,70,NULL,NULL,'2MASX J13322430-1310547',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'16.00',0.6,NULL,NULL,NULL,NULL,NULL,1,203.101333,-13.18197,0.113,NULL,43990419752,687350308,10739848,16),(110767,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110767,38.1,0.46,418,47602,70,NULL,NULL,'2MASX J13322512-0209385',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000176,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,203.1047083,-2.16078,0.045,NULL,43555615801,680556496,10633695,17.4),(110768,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110768,37.92,0.07,384,47603,70,NULL,NULL,'SDSS J133225.63-014654.0',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000142,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,203.1067917,-1.78169,0.049,NULL,43555429109,680553579,10633649,18.6),(110769,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110769,35.25,0.46,112,47604,70,NULL,NULL,'CGCG 190-018',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000127,NULL,'15.3g',0.46,NULL,NULL,NULL,NULL,NULL,1,203.108458333,33.51239,0,NULL,59188031453,924812991,14450202,15.3),(110770,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110770,36.74,0.46,223,47605,70,NULL,NULL,'2MASX J13322615+3314340',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000175,NULL,'17.2g',0.25,'E1',NULL,NULL,NULL,NULL,1,203.109083,33.24286,0,NULL,59179669837,924682341,14448161,17.2),(110771,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110771,38.25,0.21,446,47606,70,NULL,NULL,'2MASX J13322621+5306312',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000194,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,203.10925,53.10872,0.013,NULL,57281196514,895018695,13984667,17.4),(110772,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110772,38.04,0.46,405,47607,70,NULL,NULL,'2MASX J13322623+2012013',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,203.109333333,20.20036,0,NULL,58843933447,919436460,14366194,17.7),(110773,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110773,37.26,0.55,283,47608,70,NULL,NULL,'2MASX J13322716-3730489',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000097,NULL,'14.96',NULL,'poss. LINER',NULL,NULL,NULL,NULL,1,203.1132083,-37.51356,0.225,NULL,46863100862,732235950,11441186,14.96),(110774,'IRAS','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110774,32.19,0.8,27.4,47609,75,NULL,'MAT, I','ESO 021- G 003',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000027,NULL,'12.52',1.4,'(R\'_2)SB(rs)cd',NULL,NULL,NULL,NULL,1,203.113708333,-80.43236,0.473,NULL,44256714257,691511160,10804861,12.52),(110775,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110775,31.95,0.32,24.6,47609,85,NULL,'I, inv','ESO 021- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110776,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110776,31.96,0.32,24.7,47609,85,NULL,'I, raw','ESO 021- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110777,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110777,32.41,0.43,30.3,47609,75,NULL,'MAT, I, raw','ESO 021- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110778,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110778,32.41,0.4,30.4,47609,73,NULL,'opt','ESO 021- G 003',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110779,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110779,32.46,0.43,31.1,47609,75,NULL,'MAT, I, inv','ESO 021- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110780,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110780,32.6,0.68,33.1,47609,NULL,NULL,'Malmquist cor.','ESO 021- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110781,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110781,32.61,0.43,33.3,47609,75,NULL,'MAT, I, cor','ESO 021- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110782,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110782,32.62,0.68,33.4,47609,NULL,NULL,NULL,'ESO 021- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110783,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110783,32.66,0.2,34,47609,74.4,NULL,NULL,'ESO 021- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110784,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110784,38.24,0.46,445,47610,70,NULL,NULL,'SDSS J133229.13-004506.4',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000076,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,203.121417,-0.75178,0.013,NULL,43554476618,680538697,10633417,18),(110785,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110785,38.03,0.27,404,47611,70,NULL,NULL,'2MASX J13322964+0108564',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000134,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,203.123667,1.14903,0.013,NULL,58388355212,912318050,14254969,17.2),(110786,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110786,38.35,0.46,467,47612,70,NULL,NULL,'2MASX J13322983+1101009',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,203.1245417,11.01697,0,NULL,58942500792,920976574,14390258,17.5),(110787,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110787,38.27,0.46,451,47613,70,NULL,NULL,'SDSS J133229.90-012401.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000139,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,203.124625,-1.40036,0.045,NULL,43557567723,680586995,10634171,18.5),(110788,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110788,38.09,0.46,416,47614,70,NULL,NULL,'2MASX J13323004+3253144',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000188,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,203.125125,32.88725,0,NULL,59180438385,924694349,14448349,17.7),(110789,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110789,38.25,0.46,447,47615,70,NULL,NULL,'SDSS J133230.32+103151.4',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000172,NULL,'17.8g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,203.126375,10.53097,0,NULL,58941610896,920962670,14390041,17.8),(110790,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110790,35.99,0.46,157,47616,70,NULL,NULL,'2MASX J13323031+1053269',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000158,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,203.126375,10.89075,0,NULL,58942458329,920975911,14390248,16.4),(110791,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110791,36.44,0.6,194,47617,70,NULL,NULL,'2MASX J13323049-2252244',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.9I',0.2,NULL,NULL,NULL,NULL,NULL,1,203.127083,-22.87339,0.245,NULL,43769158355,683893099,10685829,14.9),(110792,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110792,37.84,0.46,371,47618,70,NULL,NULL,'SDSS J133230.64+055714.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.3g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,203.1277083,5.95403,0.041,NULL,58925794907,920715545,14386180,18.3),(110793,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110793,38.03,0.27,404,47619,70,NULL,NULL,'SDSS J133230.66+010905.4',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,'FoF','17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,203.12775,1.1515,0.013,NULL,58388355957,912318061,14254969,17.4),(110794,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110794,36.94,0.46,244,47620,70,NULL,NULL,'2MASX J13323075+2206033',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,203.127958333,22.10094,0,NULL,58800725962,918761343,14355645,17.5),(110795,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110795,32.8,0.47,36.4,47621,NULL,NULL,'H','UGC 08521',NULL,'2007A&A...465...71T',2007,1,1.09,NULL,'G',0.000003,NULL,'13.9g',0.92,'(R)SB(r)ab pec',NULL,NULL,NULL,NULL,1,203.128166667,1.84769,0.013,NULL,58387271112,912301111,14254704,13.9),(110796,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110796,32.98,0.46,39.4,47621,NULL,NULL,'J','UGC 08521',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110797,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110797,33.03,0.45,40.4,47621,NULL,NULL,'K','UGC 08521',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110798,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110798,33.31,0.4,45.9,47621,NULL,NULL,'mean','UGC 08521',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110799,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110799,35.48,0.58,125,47622,70,NULL,NULL,'IC 4279',NULL,'2014MNRAS.445.2677S',2014,1,2.9,NULL,'G',0.00014,NULL,'15.5',1.9,'S pec',NULL,NULL,NULL,NULL,1,203.129041667,-27.12747,0.201,NULL,43294778098,676480907,10570014,15.5),(110800,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110800,37.59,0.46,329,47623,70,NULL,NULL,'SDSS J133231.08+014940.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000081,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,203.1295,1.82797,0.013,NULL,58387269969,912301093,14254704,18),(110801,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110801,38.1,0.33,417,47624,70,NULL,NULL,'2MASX J13323233+6738032',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000091,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,203.1349583,67.63422,0.025,NULL,57911836969,904872452,14138632,17.2),(110802,'IRAS','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110802,34.89,0.8,95.2,47625,75,NULL,'HMCL, I','CGCG 073-021',NULL,'1997ApJS..109..333W',1997,1,0.42,NULL,'G',0.000027,NULL,'15.6',0.18,NULL,NULL,NULL,NULL,NULL,1,203.134833,13.93328,0,NULL,58823295475,919113991,14361156,15.6),(110803,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110803,34.82,0.4,91.9,47625,75,NULL,'HMCL, I, raw','CGCG 073-021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110804,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110804,34.9,0.4,95.7,47625,75,NULL,'HMCL, I, inv','CGCG 073-021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110805,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110805,35.04,0.4,102,47625,75,NULL,'HMCL, I, cor','CGCG 073-021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110806,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110806,37.64,0.46,337,47626,70,NULL,NULL,'2MASX J13323244+0103594',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000079,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,203.135291667,1.06642,0.013,NULL,58388234152,912316158,14254939,17.2),(110807,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110807,35.78,0.61,143,47627,70,NULL,NULL,'2MASX J13323361-3309165',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000087,NULL,'15.1V',NULL,'E',NULL,NULL,NULL,NULL,1,203.1400417,-33.15447,0.153,NULL,46901822774,732840980,11450640,15.1),(110808,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110808,35,0.59,99.9,47628,70,NULL,NULL,'ESO 509- G 048',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000133,NULL,'15.06',0.7,'(R?)SB(r)ab:',NULL,NULL,NULL,NULL,1,203.141667,-27.44881,0.201,NULL,43295532971,676492702,10570198,15.06),(110809,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110809,37.24,0.6,281,47629,70,NULL,NULL,'2MASX J13323472-3150545',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'15.6V',0.27,'S0','Group member',NULL,NULL,NULL,1,203.144583,-31.84842,0.157,NULL,46904734969,732886483,11451351,15.6),(110810,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110810,37.86,0.46,373,47630,70,NULL,NULL,'SDSS J133235.20+180504.1',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.4g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,203.146667,18.0845,0,NULL,58826765317,919168208,14362003,17.4),(110811,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110811,37.47,0.33,312,47631,70,NULL,NULL,'SDSS J133235.50+380115.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.92',0.13,NULL,NULL,NULL,NULL,NULL,1,203.1479583,38.021,0,NULL,59295041703,926485026,14476328,18.92),(110812,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110812,35.13,0.48,106,47632,70,NULL,NULL,'2MASX J13323653-1309493',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000077,NULL,'16.05',NULL,NULL,NULL,NULL,NULL,NULL,1,203.152125,-13.16381,0.113,NULL,43990612206,687353315,10739895,16.05),(110813,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110813,37.78,0.46,360,47633,70,NULL,NULL,'2MASX J13323725+0050114',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000096,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,203.155291667,0.83644,0.013,NULL,58385421528,912272211,14254253,16.9),(110814,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110814,37.79,0.46,361,47634,70,NULL,NULL,'2MASX J13323808+6217060',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000184,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,203.1587917,62.28503,0.033,NULL,57379663640,896557244,14008706,16.6),(110815,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110815,38.15,0.46,426,47635,70,NULL,NULL,'SDSS J133238.81+260241.9',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'19.00',NULL,NULL,NULL,NULL,NULL,NULL,1,203.161708333,26.04503,0.038,NULL,58668515065,916695547,14323367,19),(110816,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110816,37.96,0.46,390,47636,70,NULL,NULL,'2MASX J13323919+1142092',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,'PRED','17.45',0.15,NULL,NULL,NULL,NULL,NULL,1,203.163375,11.70258,0,NULL,58938642197,920916284,14389316,17.45),(110817,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110817,36.06,0.6,163,47637,70,NULL,NULL,'2MASX J13323927-3149525',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'15.6V',0.27,'S0','Group member',NULL,NULL,NULL,1,203.1635417,-31.83128,0.157,NULL,46904724306,732886317,11451348,15.6),(110818,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110818,36.7,0.46,218,47638,70,NULL,NULL,'2MASX J13324067+5446558',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000155,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,203.169625,54.78211,0,NULL,57292041315,895188145,13987314,17.1),(110819,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110819,37.5,0.33,317,47639,70,NULL,NULL,'SDSS J133241.04-021511.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,203.1710417,-2.25317,0.045,NULL,43555573018,680555828,10633684,18.1),(110820,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110820,37.28,0.46,286,47640,70,NULL,NULL,'2MASX J13324241+1235540',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,203.176833333,12.59831,0,NULL,59006280310,921973129,14405830,17.5),(110821,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110821,35.15,0.23,107,47641,70,NULL,NULL,'NGC 5209',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000117,NULL,'15.36',0.64,'E              AGN','Group member',NULL,NULL,'Flat-Spectrum Radio Source',1,203.17725,7.32725,0,NULL,58947102728,921048480,14391382,15.36),(110822,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110822,37.27,0.46,284,47642,70,NULL,NULL,'SDSS J133242.91+100005.0',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.5g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,203.178833333,10.00139,0,NULL,58941108958,920954827,14389919,17.5),(110823,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110823,35.75,0.46,141,47643,70,NULL,NULL,'CGCG 102-010',NULL,'2015arXiv151105856S',2015,1,1.2,NULL,'G',NULL,NULL,'15.6',1.2,'AGN','Group member',NULL,NULL,NULL,1,203.1807083,18.17631,0.01,NULL,58844440774,919444387,14366318,15.6),(110824,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110824,36.43,0.46,193,47644,70,NULL,NULL,'LCRS B133008.6-023754',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,203.181375,-2.88825,0.049,NULL,43568397694,680756213,10636815,17.6),(110825,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110825,35.67,0.54,136,47645,70,NULL,NULL,'2MASX J13324580-2329283',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,203.190958333,-23.49114,0.269,NULL,43768747076,683886673,10685729,15.2),(110826,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110826,36.02,0.39,160,47646,NULL,NULL,'Malmquist cor.','ESO 509- G 052',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000033,NULL,'15.73',0.5,'Sb:',NULL,NULL,NULL,NULL,1,203.192833,-26.99308,0.161,NULL,43294729878,676480154,10570002,15.73),(110827,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110827,36.34,0.34,185,47646,NULL,NULL,NULL,'ESO 509- G 052',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110828,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110828,36.38,0.2,189,47646,74.4,NULL,NULL,'ESO 509- G 052',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110829,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110829,38.35,0.46,467,47647,70,NULL,NULL,'2MASX J13324714+2808202',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000181,NULL,'17.4g',0.19,'E3',NULL,NULL,NULL,NULL,1,203.196417,28.13897,0.019,NULL,59133075716,923954308,14436786,17.4),(110830,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110830,38.07,0.46,411,47648,70,NULL,NULL,'SDSS J133247.19+042556.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00013,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,203.196625,4.43225,0.028,NULL,58928149563,920752336,14386755,18.3),(110831,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110831,35.54,0.52,128,47649,70,NULL,NULL,'2MASX J13324741-2331193',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000097,NULL,'13.5I',0.4,NULL,NULL,NULL,NULL,NULL,1,203.197625,-23.52203,0.269,NULL,43768802083,683887532,10685742,13.5),(110832,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110832,37.2,0.23,276,47650,70,NULL,NULL,'2MASX J13324813+3339275',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000191,NULL,'16.8g',0.26,'E1',NULL,NULL,NULL,NULL,1,203.2005417,33.65775,0,NULL,59188128133,924814502,14450226,16.8),(110833,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110833,37.92,0.07,384,47651,70,NULL,NULL,'SDSS J133248.52-014559.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,203.202166667,-1.76658,0.049,NULL,43555404552,680553196,10633643,18),(110834,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110834,36.7,0.46,219,47652,70,NULL,NULL,'2MASX J13324863+3953494',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,203.202667,39.89717,0,NULL,59315148823,926799200,14481237,17.3),(110835,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110835,34.75,0.49,89.2,47653,70,NULL,NULL,'ESO 509- G 053',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'14.82',0.8,'S0',NULL,NULL,NULL,NULL,1,203.206625,-23.64489,0.269,NULL,43768774645,683887103,10685735,14.82),(110836,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110836,33.98,0.49,62.4,47654,75,NULL,'IR','CGCG 017-017',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.000031,NULL,'15.0g',0.33,'Sbc',NULL,NULL,NULL,NULL,1,203.209,-3.08281,0.065,NULL,43559989902,680624842,10634763,15),(110837,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110837,34.12,NULL,66.6,47654,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 017-017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110838,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110838,34.13,NULL,66.9,47654,NULL,NULL,'Dipole + Quadrupole','CGCG 017-017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110839,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110839,34.13,NULL,67,47654,NULL,NULL,'Dipole','CGCG 017-017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110840,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110840,34.15,0.2,67.6,47654,74.4,NULL,NULL,'CGCG 017-017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110841,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110841,34.4,0.52,75.8,47654,NULL,NULL,NULL,'CGCG 017-017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110842,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110842,34.45,0.51,77.6,47654,NULL,NULL,'Malmquist cor.','CGCG 017-017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110843,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110843,36.54,0.46,203,47655,70,NULL,NULL,'2MASX J13325028+4721077',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000159,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,203.209417,47.35206,0,NULL,59288120695,926376885,14474638,16.9),(110844,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110844,37.02,0.33,254,47656,70,NULL,NULL,'2MASX J13325182+2531372',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,203.2160417,25.52697,0,NULL,58667060478,916672819,14323012,16.9),(110845,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110845,37.5,0.19,316,47657,70,NULL,NULL,'2MASX J13325256+2541582',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00011,NULL,'16.2g',0.33,NULL,'Field galaxy',NULL,NULL,NULL,1,203.219,25.69944,0,NULL,58668925186,916701956,14323468,16.2),(110846,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110846,37.5,0.33,317,47658,70,NULL,NULL,'2MASX J13325262-0216548',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000143,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,203.219333,-2.28194,0.045,NULL,43554784133,680543502,10633492,17.5),(110847,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110847,35.15,0.23,107,47659,70,NULL,NULL,'CGCG 045-012',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000097,NULL,'15.4',0.24,NULL,'Group member',NULL,NULL,NULL,1,203.221,7.39344,0,NULL,58947126895,921048857,14391388,15.4),(110848,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110848,36.48,0.46,198,47660,70,NULL,NULL,'2MASX J13325351+3846364',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,203.223083,38.77697,0,NULL,59312258921,926754045,14480531,17.3),(110849,'IRAS','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110849,34.93,0.8,96.7,47661,75,NULL,'HMCL, I','UGC 08527',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000023,NULL,'15.07',0.3,'Sdm:',NULL,NULL,NULL,NULL,1,203.226,9.52036,0,NULL,58952948636,921139822,14392809,15.07),(110850,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110850,34.82,0.4,91.9,47661,75,NULL,'HMCL, I, raw','UGC 08527',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110851,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110851,35.01,0.4,100,47661,75,NULL,'HMCL, I, inv','UGC 08527',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110852,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110852,35,0.49,100,47661,75,NULL,'IR','UGC 08527',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110853,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110853,35.03,0.4,102,47661,75,NULL,'HMCL, I, cor','UGC 08527',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110854,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110854,37.5,0.19,316,47662,70,NULL,NULL,'SDSS J133255.18+255005.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.42',0.13,NULL,NULL,NULL,NULL,NULL,1,203.229917,25.83494,0,NULL,58668893622,916701462,14323460,18.42),(110855,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110855,37.81,0.19,364,47663,70,NULL,NULL,'2MASX J13325562+6006228',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00019,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,203.231667,60.10644,0.009,NULL,57392570189,896758909,14011857,17),(110856,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110856,35.09,0.48,104,47664,70,NULL,NULL,'2MASX J13325569-1112054',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.70',0.7,NULL,NULL,NULL,NULL,NULL,1,203.231833,-11.20147,0.089,NULL,43859621645,685306588,10707915,14.7),(110857,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110857,38.62,0.46,531,47665,70,NULL,NULL,'SDSS J133256.82-020249.9',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,203.236791667,-2.04719,0.049,NULL,43555741541,680558461,10633725,18.6),(110858,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110858,37.81,0.19,364,47666,70,NULL,NULL,'2MASX J13325723+6015478',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,203.238208333,60.26333,0,NULL,57392593020,896759265,14011863,17.6),(110859,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110859,37.67,0.46,342,47667,70,NULL,NULL,'2MASX J13325724+6240388',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000104,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,203.238583,62.67742,0.029,NULL,57347956634,896061822,14000965,16.3),(110860,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110860,36.33,0.17,185,47668,70,NULL,NULL,'CGCG 190-020',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000087,NULL,'14.8g',0.72,'E1',NULL,NULL,NULL,NULL,1,203.2397917,32.60519,0,NULL,59180269232,924691706,14448307,14.8),(110861,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110861,36.19,0.46,173,47669,70,NULL,NULL,'2MASX J13325770+2743041',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000133,NULL,'15.8g',0.24,NULL,'Field galaxy',NULL,NULL,NULL,1,203.2404583,27.71783,0.021,NULL,59133199217,923956237,14436816,15.8),(110862,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110862,37.96,0.21,392,47670,70,NULL,NULL,'2MASX J13325893+5428327',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000146,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,203.2457917,54.47589,0,NULL,57291485871,895179466,13987179,18.1),(110863,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110863,35.73,0.64,140,47671,70,NULL,NULL,'ESO 577- G 008',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.78',0.2,'S0-a',NULL,NULL,NULL,NULL,1,203.251416667,-21.63242,0.237,NULL,43768553259,683883644,10685681,15.78),(110864,'TRGB','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'RN',110864,27.9,0.2,3.81,47672,NULL,NULL,NULL,'CenA-MM-Dw9',NULL,'2015arXiv151205366C',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110865,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110865,35.62,0.54,133,47673,70,NULL,NULL,'2MASX J13330150-3306018',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'14.9V',NULL,NULL,NULL,NULL,NULL,NULL,1,203.2565,-33.10031,0.153,NULL,46902149995,732846093,11450720,14.9),(110866,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110866,35.15,0.23,107,47674,70,NULL,NULL,'MRK 1353',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'17.0',0.2,NULL,NULL,NULL,NULL,NULL,1,203.2572083,7.12006,0,NULL,58947683277,921057551,14391524,17),(110867,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110867,37.4,0.46,302,47675,70,NULL,NULL,'2MASX J13330257+3553494',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00021,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,203.260625,35.89697,0,NULL,59165376672,924459010,14444672,16.2),(110868,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110868,36.68,0.59,217,47676,70,NULL,NULL,'2MASX J13330370-3312548',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00009,NULL,'15.2V',NULL,NULL,NULL,NULL,NULL,NULL,1,203.265375,-33.21522,0.145,NULL,46906083686,732907557,11451680,15.2),(110869,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110869,37.2,0.23,276,47677,70,NULL,NULL,'2MASX J13330404+3352260',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000153,NULL,'15.8g',0.41,NULL,NULL,NULL,NULL,NULL,1,203.266625,33.87381,0,NULL,59188072940,924813639,14450213,15.8),(110870,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110870,37.81,0.19,364,47678,70,NULL,NULL,'2MASX J13330506+6010249',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,203.270833,60.1735,0.009,NULL,57392589062,896759204,14011862,17.9),(110871,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110871,32.67,0.69,34.2,47679,100,NULL,'mid-IR','NGC 5211',NULL,'2013ApJ...771...88L',2013,1,1.85,NULL,'G',0.000023,NULL,'13.5g',1.04,'(R\')SAB(rs)ab pec',NULL,NULL,NULL,NULL,1,203.27225,-1.03581,0.013,NULL,43557517350,680586208,10634159,13.5),(110872,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110872,33.53,0.45,50.8,47679,NULL,NULL,'K','NGC 5211',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110873,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110873,33.55,0.47,51.3,47679,NULL,NULL,'H','NGC 5211',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110874,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110874,33.62,0.46,53,47679,NULL,NULL,'J','NGC 5211',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110875,'Tully-Fisher','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110875,33.66,0.4,54.1,47679,NULL,NULL,'mean','NGC 5211',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110876,'Tully est','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110876,31.92,0.8,24.2,47680,75,NULL,NULL,'UGCA 362',NULL,'1988NBGC.C....0000T',1988,1,0.2,NULL,'G',NULL,NULL,'16.5',0.1,'Compact',NULL,NULL,NULL,NULL,1,203.274667,68.86047,0.041,NULL,57914081233,904907519,14139179,16.5),(110877,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110877,37.47,0.33,312,47681,70,NULL,NULL,'2MASX J13330602+3758004',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000174,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,203.275041667,37.96675,0,NULL,59295077341,926485583,14476337,16.5),(110878,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110878,36.67,0.46,216,47682,70,NULL,NULL,'2MASX J13330605+3924464',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,203.275083,39.41303,0,NULL,59312330274,926755160,14480549,17.2),(110879,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110879,36.02,0.55,160,47683,70,NULL,NULL,'2MASX J13330603-7512167',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,203.275291667,-75.20461,0.833,NULL,44201741457,690652210,10791440,16.8),(110880,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110880,36.74,0.56,223,47684,70,NULL,NULL,'2MASX J13330616-3708504',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,203.275625,-37.14728,0.245,NULL,46863911694,732248620,11441384,14.4),(110881,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110881,36,0.5,159,47685,70,NULL,NULL,'ESO 577- G 009',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'14.67',0.7,'E?',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,203.2785417,-22.59964,0.257,NULL,43771262560,683925977,10686343,14.67),(110882,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110882,38.55,0.46,512,47686,70,NULL,NULL,'2MASX J13330706+4722594',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000234,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,203.279458333,47.38314,0,NULL,59288085501,926376335,14474630,18.2),(110883,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,NULL,110883,35.83,0.53,147,47687,70,NULL,NULL,'2MASX J13330711-2746028',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.4b',0.4,'E',NULL,NULL,NULL,NULL,1,203.2797083,-27.76744,0.197,NULL,46849197435,732018709,11437792,16.4),(110884,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110884,36.33,0.17,185,47688,70,NULL,NULL,'2MASX J13330747+3230510',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.00007,NULL,'15.3g',0.44,NULL,NULL,NULL,NULL,NULL,1,203.281083,32.51417,0,NULL,59180313862,924692404,14448318,15.3),(110885,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110885,37.65,0.46,338,47689,70,NULL,NULL,'2MASX J13330826+1202249',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000183,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,203.284375,12.04036,0,NULL,59006095065,921970235,14405784,17.3),(110886,'FP','2016-12-15 15:15:15','2016-12-16 11:20:28','1',NULL,'R',110886,37.5,0.19,316,47690,70,NULL,NULL,'2MASX J13330824+2542131',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,203.2844583,25.70372,0,NULL,58668938751,916702167,14323471,17.4),(110887,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110887,37.9,0.46,380,47691,70,NULL,NULL,'2MASX J13330929-0118595',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000178,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,203.288583,-1.3165,0.045,NULL,43557410332,680584536,10634133,17.2),(110888,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110888,37.31,0.33,289,47692,70,NULL,NULL,'2MASX J13330971+3705034',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'15.9g',0.45,NULL,NULL,NULL,NULL,NULL,1,203.290667,37.08417,0,NULL,59165736340,924464630,14444759,15.9),(110889,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110889,37.25,0.33,281,47693,70,NULL,NULL,'2MASX J13331029+3128040',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.7g',0.18,'E0',NULL,NULL,NULL,NULL,1,203.293083,31.46772,0.022,NULL,59181497089,924710892,14448607,17.7),(110890,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110890,37.74,0.46,353,47694,70,NULL,NULL,'2MASX J13331125+1427515',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,203.296917,14.46422,0.008,NULL,58824139321,919127176,14361362,17.8),(110891,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110891,37.8,0.46,362,47695,70,NULL,NULL,'2MASX J13331152+2022055',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,203.298125,20.36811,0,NULL,58843079822,919423122,14365986,16.9),(110892,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110892,33.32,1.09,46.2,47696,NULL,NULL,NULL,'MCG -03-35-003',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000013,NULL,'15.33',0.5,'HII',NULL,NULL,NULL,NULL,1,203.301625,-16.13936,0.221,NULL,43788096949,684189014,10690453,15.33),(110893,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110893,33.82,0.86,58.1,47696,NULL,NULL,'Malmquist cor.','MCG -03-35-003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110894,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110894,37.63,0.46,336,47697,70,NULL,NULL,'2MASX J13331281+6139370',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000157,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,203.30325,61.66042,0,NULL,57382135508,896595867,14009310,17.6),(110895,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110895,34.66,0.47,85.6,47698,70,NULL,NULL,'MCG -03-35-004',NULL,'2014MNRAS.445.2677S',2014,1,2.5,'Springob et al. (2005ApJS..160..149S) give v= 2169 km/sec.','G',0.00004,NULL,'13.97',1.5,'SAB(s)ab pec:',NULL,NULL,NULL,NULL,1,203.307917,-16.1215,0.221,NULL,43788103828,684189122,10690455,13.97),(110896,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110896,37.59,0.33,330,47699,70,NULL,NULL,'SDSS J133314.36+532103.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,203.309875,53.35086,0,NULL,57281416517,895022133,13984720,18.3),(110897,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110897,32.3,NULL,28.8,47700,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08538',NULL,'2010Ap&SS.325..163P',2010,1,1.13,NULL,'G',0.000189,NULL,'16.3g',0.18,'Sdm',NULL,NULL,NULL,NULL,1,203.3114583,45.83719,0,NULL,59285382461,926334100,14473970,16.3),(110898,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110898,32.33,NULL,29.3,47700,NULL,NULL,'Dipole + Quadrupole','UGC 08538',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110899,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110899,32.35,NULL,29.5,47700,NULL,NULL,'Dipole','UGC 08538',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110900,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110900,32.43,NULL,30.7,47700,NULL,NULL,NULL,'UGC 08538',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110901,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110901,37.1,0.58,263,47701,70,NULL,NULL,'2MASX J13331723-3129329',NULL,'2014MNRAS.445.2677S',2014,1,0.51,'Quintana, et al. (1995AJ....110..463Q) give v = 10894 +/- 116 km/sec.','G',0.000123,NULL,'15.3V',0.3,'S0','Group member',NULL,NULL,NULL,1,203.322,-31.49258,0.169,NULL,46904835535,732888055,11451375,15.3),(110902,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110902,37.26,0.46,283,47702,70,NULL,NULL,'2MASX J13331794+5843285',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,203.32475,58.72461,0,NULL,57386747748,896667933,14010436,17.4),(110903,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110903,38.11,0.46,419,47703,70,NULL,NULL,'2MASX J13331840+0120309',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000086,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,203.326583,1.34172,0.041,NULL,58388314177,912317409,14254959,17.1),(110904,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110904,37.64,0.46,338,47704,70,NULL,NULL,'2MASX J13331884+0426169',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000167,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,203.328625,4.43797,0.028,NULL,58396785955,912449780,14257027,17),(110905,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110905,37.56,0.46,325,47705,70,NULL,NULL,'2MASX J13331891+1749585',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.72',0.18,NULL,NULL,NULL,NULL,NULL,1,203.328917,17.83308,0,NULL,58826784323,919168505,14362007,17.72),(110906,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110906,36.61,0.46,210,47706,70,NULL,NULL,'2MASX J13331909+1415035',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00017,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,203.3297083,14.25094,0.008,NULL,58824997583,919140587,14361571,16.3),(110907,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110907,27.78,NULL,3.6,47707,NULL,NULL,NULL,'ESO 174- G 001',NULL,'2013AJ....145..101K',2013,1,1.8,NULL,'G',NULL,NULL,'14.1',1.1,'SAB(s)0^0^ pec:',NULL,NULL,NULL,NULL,1,203.332,-53.35469,NULL,NULL,44715344697,698677260,10916832,14.1),(110908,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110908,37.46,0.46,310,47708,70,NULL,NULL,'2MASX J13332122+1146350',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.93',0.15,NULL,NULL,NULL,NULL,NULL,1,203.3384583,11.77642,0,NULL,58938884074,920920063,14389375,17.93),(110909,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110909,35.14,0.46,107,47709,70,NULL,NULL,'CGCG 045-018',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000087,NULL,'15.2',0.44,NULL,NULL,NULL,NULL,NULL,1,203.338583333,6.31869,0.038,NULL,58946798935,921043733,14391308,15.2),(110910,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110910,37.36,0.46,296,47710,70,NULL,NULL,'2MASX J13332200+5850325',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,203.341875,58.84239,0,NULL,57390184101,896721626,14011275,16.9),(110911,'IRAS','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110911,34.99,0.8,99.4,47711,75,NULL,'HMCL, I','MRK 1355',NULL,'1997ApJS..109..333W',1997,1,0.7,'This galaxy mistakenly called MRK 1354 in 1982AJ.....87.1364K.','G',0.000007,NULL,'15.5',0.2,'S',NULL,NULL,NULL,NULL,1,203.3427083,9.52733,0,NULL,58952120051,921126875,14392607,15.5),(110912,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110912,35.08,0.2,104,47711,74.4,NULL,NULL,'MRK 1355',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110913,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110913,35.17,0.4,108,47711,75,NULL,'HMCL, I, raw','MRK 1355',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110914,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110914,35.28,0.4,114,47711,75,NULL,'HMCL, I, inv','MRK 1355',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110915,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110915,35.35,0.4,118,47711,75,NULL,'HMCL, I, cor','MRK 1355',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110916,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110916,35.59,0.49,131,47711,75,NULL,'IR','MRK 1355',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110917,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110917,37.75,0.46,354,47712,70,NULL,NULL,'2MASX J13332301+0200009',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000195,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,203.345875,2.00017,0.005,NULL,58387829891,912309842,14254841,16.9),(110918,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110918,38.33,0.46,464,47713,70,NULL,NULL,'2MASX J13332305+1203455',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000195,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,203.346,12.06256,0,NULL,59006106006,921970406,14405787,17.3),(110919,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110919,36.41,0.46,191,47714,70,NULL,NULL,'2MASX J13332307+1235045',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000167,NULL,'16.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,203.346125,12.58453,0,NULL,59006492786,921976449,14405882,16.4),(110920,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110920,38.17,0.46,430,47715,70,NULL,NULL,'SDSS J133323.51+025551.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00007,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,203.347958333,2.93103,0.014,NULL,58398557678,912477463,14257460,18.1),(110921,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110921,36.92,0.33,242,47716,70,NULL,NULL,'2MASX J13332426+1430255',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000176,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,203.351166667,14.50717,0.008,NULL,58824168494,919127632,14361369,16.3),(110922,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110922,37.5,0.19,316,47717,70,NULL,NULL,'2MASX J13332470+2528270',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,203.3527917,25.47414,0.011,NULL,58667104064,916673501,14323023,17.5),(110923,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110923,37.34,0.46,293,47718,70,NULL,NULL,'2MASX J13332477+4914573',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000179,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,203.353125,49.24925,0,NULL,59276249278,926191394,14471740,17),(110924,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110924,37.09,0.71,262,47719,70,NULL,NULL,'2MASX J13332604-1541306',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,203.358458333,-15.69186,0.165,NULL,43787676188,684182440,10690350,14.6),(110925,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110925,38.28,0.57,452,47720,70,NULL,NULL,'2MASX J13332781-4249401',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.9I',0.2,NULL,NULL,NULL,NULL,NULL,1,203.365875,-42.82786,0.429,NULL,46975515683,733992432,11468631,14.9),(110926,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110926,37.02,0.33,254,47721,70,NULL,NULL,'2MASX J13332816+2532420',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000107,NULL,'17.19',0.23,NULL,'Field galaxy',NULL,NULL,NULL,1,203.367417,25.54492,0.011,NULL,58667044943,916672577,14323009,17.19),(110927,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110927,38.16,0.46,429,47722,70,NULL,NULL,'2MASX J13332883+1456105',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000141,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,203.370083,14.93631,0,NULL,58824071700,919126120,14361345,18),(110928,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110928,34.75,0.47,89.2,47723,NULL,NULL,'H','UGC 08539',NULL,'2007A&A...465...71T',2007,1,1.41,NULL,'G',0.000037,NULL,'14.1g',0.66,'S?','Group member',NULL,NULL,NULL,1,203.370917,33.04239,0,NULL,59188320460,924817507,14450273,14.1),(110929,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110929,34.9,0.45,95.7,47723,NULL,NULL,'K','UGC 08539',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110930,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110930,34.92,0.46,96.6,47723,NULL,NULL,'J','UGC 08539',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110931,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110931,35.19,0.4,109,47723,NULL,NULL,'mean','UGC 08539',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110932,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110932,36.25,0.46,178,47724,70,NULL,NULL,'2MASX J13332957+1339385',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,203.3732083,13.66064,0.006,NULL,58824350221,919130472,14361413,17.4),(110933,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110933,37.76,0.46,356,47725,70,NULL,NULL,'2MASX J13332960+3823261',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000147,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,203.3734583,38.39067,0,NULL,59294995783,926484309,14476317,17.7),(110934,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110934,37.2,0.23,276,47726,70,NULL,NULL,'2MASX J13332964+3344271',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.55',0.2,NULL,NULL,NULL,NULL,NULL,1,203.373583,33.74072,0,NULL,59188098156,924814033,14450219,17.55),(110935,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110935,37.2,0.23,276,47727,70,NULL,NULL,'2MASX J13333013+3349031',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000187,NULL,'15.8g',0.4,NULL,NULL,NULL,NULL,NULL,1,203.375625,33.81758,0,NULL,59188095572,924813993,14450218,15.8),(110936,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110936,37.49,0.33,315,47728,70,NULL,NULL,'2MASX J13333043+1550055',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.20',0.16,NULL,NULL,NULL,NULL,NULL,1,203.3767917,15.83469,0,NULL,58837578778,919337168,14364643,18.2),(110937,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110937,34.23,0.49,70,47729,75,NULL,'IR','ESO 509- G 057',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.73',0.2,'S...',NULL,NULL,NULL,NULL,1,203.379,-24.80972,0.285,NULL,43286333696,676348964,10567952,15.73),(110938,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110938,34.36,0.11,74.6,47729,NULL,NULL,NULL,'ESO 509- G 057',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110939,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110939,37.12,0.46,265,47730,70,NULL,NULL,'SDSS J133331.22+233342.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.29',0.16,NULL,NULL,NULL,NULL,NULL,1,203.380125,23.56186,0,NULL,58802250423,918785162,14356018,18.29),(110940,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110940,37.59,0.33,330,47731,70,NULL,NULL,'2MASX J13333122+5313245',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,203.3802917,53.22347,0,NULL,57279127495,894986367,13984161,17.3),(110941,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110941,37.49,0.33,315,47732,70,NULL,NULL,'2MASX J13333272+1551234',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,203.386333333,15.85656,0,NULL,58837568106,919337001,14364640,18),(110942,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110942,36.75,0.81,224,47733,70,NULL,NULL,'2MASX J13333277-1650500',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,203.386583333,-16.84725,0.261,NULL,43782792997,684106140,10689158,14.1),(110943,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110943,33.16,0.49,42.8,47734,75,NULL,'IR','UGC 08534',NULL,'2011yCatp016004901K',2011,1,0.88,'The SDSS position is west of the nucleus.','G',0.000017,NULL,'15.6g',0.4,'SBcd:',NULL,NULL,NULL,NULL,1,203.388125,1.30611,0.01,NULL,58388287827,912316997,14254953,15.6),(110944,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110944,33.51,0.2,50.4,47734,74.4,NULL,NULL,'UGC 08534',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110945,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110945,33.63,0.55,53.2,47734,NULL,NULL,NULL,'UGC 08534',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110946,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110946,33.66,0.54,54,47734,NULL,NULL,'Malmquist cor.','UGC 08534',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110947,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110947,37.03,0.46,255,47735,70,NULL,NULL,'2MASX J13333351+4738094',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,203.389625,47.63606,0,NULL,59288159179,926377487,14474648,16.9),(110948,'TRGB','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'RN',110948,27.7,0.2,3.47,47736,NULL,NULL,NULL,'CenA-MM-Dw8',NULL,'2015arXiv151205366C',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110949,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110949,36.83,0.58,233,47737,70,NULL,NULL,'ESO 444- G 072',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00005,NULL,'13.5V',0.9,'SAB(rs)0^0^;cD','Group member',NULL,NULL,NULL,1,203.394833,-31.67236,0.169,NULL,46903944516,732874133,11451158,13.5),(110950,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110950,37.01,0.46,253,47738,70,NULL,NULL,'2MASX J13333518+5048326',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000187,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,203.396625,50.80914,0,NULL,59208515029,925133047,14455203,18),(110951,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110951,37.96,0.21,392,47739,70,NULL,NULL,'2MASX J13333526+5427435',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000173,NULL,'16.4g',0.38,'BrClG',NULL,NULL,NULL,NULL,1,203.396791667,54.46211,0,NULL,57291512758,895179886,13987185,16.4),(110952,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110952,36.86,0.46,235,47740,70,NULL,NULL,'2MASX J13333691+6404380',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000075,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,203.403833333,64.07717,0.033,NULL,57867169220,904174519,14127726,16.8),(110953,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110953,36.45,0.66,195,47741,70,NULL,NULL,'2MASX J13333709-3138281',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00008,NULL,'16.0V',0.26,'S0','Group member',NULL,NULL,NULL,1,203.404625,-31.64111,0.169,NULL,46903946960,732874171,11451158,16),(110954,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110954,36.27,0.33,180,47742,70,NULL,NULL,'CGCG 073-026',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.00012,NULL,'15.3g',0.55,NULL,'Group member',NULL,NULL,NULL,1,203.4092083,13.236,0,NULL,58821463322,919085364,14360708,15.3),(110955,'Tully est','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110955,32.64,0.8,33.7,47743,75,NULL,NULL,'UGCA 363',NULL,'1988NBGC.C....0000T',1988,1,0.73,'The SDSS position applies to a bright knot (or superposed star?).','G',0.00002,NULL,'16.4g',0.41,'Im?',NULL,NULL,NULL,NULL,1,203.412333,60.38794,0.009,NULL,57392675903,896760560,14011883,16.4),(110956,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110956,37.5,0.19,316,47744,70,NULL,NULL,'2MASX J13334035+2549320',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.2g',0.4,NULL,'Field galaxy',NULL,NULL,NULL,1,203.418167,25.82575,0.018,NULL,58668415036,916693984,14323343,16.2),(110957,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110957,37.01,0.27,253,47745,70,NULL,NULL,'2MASX J13334045+5359145',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000188,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,203.418666667,53.98742,0.018,NULL,57280090560,895001415,13984397,17.2),(110958,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110958,37.14,0.33,268,47746,70,NULL,NULL,'2MASX J13334097+0951519',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,203.42075,9.86442,0,NULL,58941369188,920958893,14389982,17.2),(110959,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110959,37.24,0.46,281,47747,70,NULL,NULL,'SDSS J133341.49+574938.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,203.422875,57.82728,0,NULL,57264869200,894763581,13980680,18),(110960,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110960,37.5,0.19,316,47748,70,NULL,NULL,'2MASX J13334213+2544550',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.65',0.2,NULL,NULL,NULL,NULL,NULL,1,203.425625,25.74878,0,NULL,58668405237,916693831,14323341,17.65),(110961,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110961,35.11,0.63,105,47749,70,NULL,NULL,'2MASX J13334256-3028102',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000067,NULL,'17.14',NULL,NULL,NULL,NULL,NULL,NULL,1,203.427416667,-30.46942,0.085,NULL,46903076542,732860570,11450946,17.14),(110962,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110962,37.96,0.21,392,47750,70,NULL,NULL,'2MASX J13334271+5426195',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000144,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,203.428167,54.43889,0,NULL,57291513845,895179903,13987185,17.8),(110963,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110963,37.89,0.33,378,47751,70,NULL,NULL,'2MASX J13334314-0227110',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'16.6g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,203.4297083,-2.45314,0.061,NULL,43568521365,680758146,10636846,16.6),(110964,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110964,38.78,0.46,571,47752,70,NULL,NULL,'2MASX J13334314+5239306',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,203.4300417,52.65869,0,NULL,59209210506,925143914,14455373,18),(110965,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110965,37.02,0.85,253,47753,70,NULL,NULL,'2MASX J13334335-2939199',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,203.430541667,-29.6555,0.153,NULL,46850050938,732032045,11438000,15.7),(110966,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110966,37.77,0.46,358,47754,70,NULL,NULL,'2MASX J13334378+5526475',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,203.4322917,55.44656,0,NULL,57287314535,895114289,13986160,17),(110967,'TRGB','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110967,27.06,0.03,2.58,47755,NULL,NULL,'I','NGC 5206',NULL,'2009AJ....138..332J',2009,1,3.7,NULL,'G',0.000033,NULL,'11.6B',3.2,'SB?(r?)0^-?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,203.43325,-48.15117,0.537,0,46958264285,733722879,11464419,11.6),(110968,'TRGB','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110968,27.53,0.1,3.21,47755,74.4,NULL,NULL,'NGC 5206',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110969,'TRGB','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110969,27.53,0.11,3.21,47755,NULL,NULL,NULL,'NGC 5206',NULL,'2015ApJ...802L..25T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110970,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110970,36.53,0.55,202,47756,70,NULL,NULL,'2MASX J13334537-1829140',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.00',0.4,NULL,NULL,NULL,NULL,NULL,1,203.4390417,-18.48736,0.289,NULL,43815421576,684615962,10697124,16),(110971,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110971,36.36,0.46,187,47757,70,NULL,NULL,'2MASX J13334541+2351374',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.21',0.22,NULL,NULL,NULL,NULL,NULL,1,203.439167,23.86042,0.028,NULL,58802092302,918782692,14355979,17.21),(110972,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110972,36.51,0.83,200,47758,70,NULL,NULL,'2MASX J13334580-3310072',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00008,NULL,'15.10',0.2,NULL,NULL,NULL,NULL,NULL,1,203.4407917,-33.16872,0.141,NULL,46906546978,732914796,11451793,15.1),(110973,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110973,36.73,0.46,221,47759,70,NULL,NULL,'2MASX J13334582+4226092',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000153,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,203.441083,42.43606,0,NULL,59323521450,926930022,14483281,17),(110974,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110974,37.12,0.46,266,47760,70,NULL,NULL,'2MASX J13334638+4741472',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000166,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,203.443041667,47.69653,0,NULL,59283753345,926308646,14473572,16.9),(110975,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110975,37.17,0.46,272,47761,70,NULL,NULL,'2MASX J13334703+3907051',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000122,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,203.4459583,39.11806,0,NULL,59312259905,926754061,14480532,18),(110976,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110976,37.71,0.46,349,47762,70,NULL,NULL,'2MASX J13334790+1139119',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000179,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,203.4495,11.65342,0,NULL,58938710427,920917350,14389333,16.9),(110977,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110977,35.32,0.4,116,47763,NULL,NULL,'mean','ESO 383- G 019',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.00003,NULL,'13.91',1.3,'SA(r)b',NULL,NULL,NULL,NULL,1,203.449666667,-37.73178,0.237,NULL,46863106232,732236034,11441188,13.91),(110978,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110978,35.49,0.47,125,47763,NULL,NULL,'H','ESO 383- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110979,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110979,35.54,0.45,128,47763,NULL,NULL,'K','ESO 383- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110980,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110980,35.6,0.46,132,47763,NULL,NULL,'J','ESO 383- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110981,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110981,37.25,0.65,281,47764,70,NULL,NULL,'2MASX J13334790-3133212',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.000083,NULL,'15.6V',0.37,'S0','Group member',NULL,NULL,NULL,1,203.449583,-31.556,0.169,NULL,46904779677,732887182,11451362,15.6),(110982,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110982,38.47,0.46,493,47765,70,NULL,NULL,'2MASX J13334831+5910365',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000117,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,203.451291667,59.17675,0,NULL,57388202142,896690658,14010791,17.5),(110983,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110983,37.89,0.33,378,47766,70,NULL,NULL,'SDSS J133348.50-022837.3',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000173,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,203.452125,-2.47706,0.061,NULL,43568525279,680758207,10636846,18.8),(110984,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110984,37.25,0.33,281,47767,70,NULL,NULL,'2MASX J13334909+5454414',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000199,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,203.4547083,54.91142,0,NULL,57291947166,895186674,13987291,17.3),(110985,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110985,37.89,0.46,379,47768,70,NULL,NULL,'2MASX J13334948+2607435',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.64',0.15,NULL,NULL,NULL,NULL,NULL,1,203.456375,26.12875,0.028,NULL,58668438179,916694346,14323349,17.64),(110986,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110986,35.97,0.46,156,47769,70,NULL,NULL,'2MASX J13335111-0113580',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00015,NULL,'15.7g',0.47,'E0',NULL,NULL,NULL,NULL,1,203.463083,-1.23275,0.049,NULL,43557689253,680588894,10634201,15.7),(110987,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110987,36.12,0.53,168,47769,70,NULL,NULL,'2MASX J13335111-0113580',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(110988,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110988,36.21,0.51,175,47770,70,NULL,NULL,'2MASX J13335228-1648440',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.39',0.6,NULL,NULL,NULL,NULL,NULL,1,203.467833,-16.81225,0.261,NULL,43782827852,684106685,10689166,15.39),(110989,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,110989,35.25,0.57,112,47771,70,NULL,NULL,'2MASX J13335266-3300512',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000093,NULL,'14.39',0.6,NULL,NULL,NULL,NULL,NULL,1,203.469375,-33.01425,0.149,NULL,46906593560,732915524,11451805,14.39),(110990,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110990,37.31,0.33,289,47772,70,NULL,NULL,'2MASX J13335267+3700029',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,203.469541667,37.00089,0,NULL,59165708644,924464197,14444753,17.2),(110991,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110991,37.78,0.46,360,47773,70,NULL,NULL,'2MASX J13335432+4125539',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000183,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,203.476417,41.43158,0,NULL,59312974689,926765229,14480706,16.9),(110992,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110992,38.06,0.46,409,47774,70,NULL,NULL,'2MASX J13335607+3945309',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,203.4834583,39.75867,0,NULL,59315133677,926798963,14481233,17.4),(110993,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110993,36.92,0.33,242,47775,70,NULL,NULL,'2MASX J13335613+1430197',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,203.4837917,14.50539,0.009,NULL,58824269953,919129218,14361394,17.4),(110994,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110994,38,0.46,398,47776,70,NULL,NULL,'2MASX J13335715+0313561',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000029,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,203.4880417,3.23231,0.025,NULL,58394242867,912410044,14256406,16.6),(110995,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110995,38.7,0.46,548,47777,70,NULL,NULL,'2MASX J13335871-0157158',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000178,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,203.494667,-1.95442,0.073,NULL,43555637582,680556837,10633700,18),(110996,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110996,37.81,0.19,364,47778,70,NULL,NULL,'2MASX J13335907+6009180',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,203.496125,60.155,0.009,NULL,57391896943,896748389,14011693,17.8),(110997,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110997,37.02,0.46,253,47779,70,NULL,NULL,'2MASX J13335916+2225375',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,203.4964583,22.42706,0,NULL,58803611413,918806428,14356350,17.3),(110998,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110998,36.15,0.46,169,47780,70,NULL,NULL,'2MASX J13335949+0916148',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000136,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,203.497833333,9.27092,0,NULL,58952238579,921128727,14392636,16.8),(110999,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',110999,37.43,0.46,306,47781,70,NULL,NULL,'2MASX J13340000+1122120',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000151,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,203.499916667,11.37,0.007,NULL,58938688991,920917015,14389328,17.4),(111000,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111000,37.88,0.46,376,47782,70,NULL,NULL,'SDSS J133400.20+112058.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,203.500875,11.34953,0.007,NULL,58938691448,920917053,14389328,17.9),(111001,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111001,38.64,0.46,534,47783,70,NULL,NULL,'2MASX J13340030+6254550',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000089,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,203.50125,62.91553,0.029,NULL,57348061453,896063460,14000991,17.8),(111002,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111002,35.28,0.58,114,47784,70,NULL,NULL,'ESO 324-IG 037 NED02',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.34',NULL,NULL,NULL,NULL,NULL,NULL,1,203.504375,-38.33867,0.217,NULL,46934418732,733350292,11458598,15.34),(111003,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111003,37.49,0.46,315,47785,70,NULL,NULL,'2MASX J13340183+1503237',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00013,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,203.5074583,15.05656,0,NULL,58822242033,919097531,14360898,17.4),(111004,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111004,38.62,0.46,529,47786,70,NULL,NULL,'2MASX J13340217+0507322',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000173,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,203.508875,5.12569,0.047,NULL,58394078663,912407479,14256366,17.7),(111005,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111005,34.22,NULL,69.8,47787,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1635',NULL,'2010Ap&SS.325..163P',2010,1,0.99,NULL,'G',0.00015,NULL,'16.7',0.07,'Sd',NULL,NULL,NULL,NULL,1,203.509875,-11.10928,0.093,NULL,43859452913,685303951,10707874,16.7),(111006,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111006,34.24,NULL,70.5,47787,NULL,NULL,'Dipole + Quadrupole','FGC 1635',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111007,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111007,34.26,NULL,71.1,47787,NULL,NULL,'Dipole','FGC 1635',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111008,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111008,34.31,NULL,72.6,47787,NULL,NULL,NULL,'FGC 1635',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111009,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111009,37.64,0.46,337,47788,70,NULL,NULL,'2MASX J13340256+0738510',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.05',0.15,NULL,NULL,NULL,NULL,NULL,1,203.510541667,7.64739,0,NULL,58950478784,921101231,14392206,18.05),(111010,'Brightest Stars','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111010,28.55,NULL,5.13,47789,NULL,NULL,NULL,'NGC 5229',NULL,'1999AstL...25..322S',1999,1,3.58,NULL,'G',0.000027,NULL,'14.30',0.45,'SB(s)d? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,203.5117917,47.91544,0,NULL,59288134005,926377093,14474642,14.3),(111011,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111011,29.02,0.4,6.4,47789,75,NULL,'B','NGC 5229',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111012,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111012,30.14,0.43,10.7,47789,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5229',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111013,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111013,30.2,NULL,11,47789,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 5229',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111014,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111014,30.22,NULL,11.1,47789,NULL,NULL,'Dipole + Quadrupole','NGC 5229',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111015,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111015,30.25,NULL,11.2,47789,NULL,NULL,'Dipole','NGC 5229',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111016,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111016,30.34,NULL,11.7,47789,NULL,NULL,NULL,'NGC 5229',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111017,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111017,34.28,NULL,71.7,47790,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08543',NULL,'2010Ap&SS.325..163P',2010,1,2.26,NULL,'G',0.000007,NULL,'14.7g',0.31,'Sb(f)',NULL,NULL,NULL,NULL,1,203.5152917,4.75372,0.04,NULL,58393622834,912400356,14256255,14.7),(111018,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111018,34.28,NULL,71.9,47790,NULL,NULL,'Dipole + Quadrupole','UGC 08543',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111019,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111019,34.29,NULL,72,47790,NULL,NULL,'Dipole','UGC 08543',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111020,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111020,34.69,0.49,86.9,47790,75,NULL,'IR','UGC 08543',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111021,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111021,35.05,0.4,102,47790,NULL,NULL,'mean','UGC 08543',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111022,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111022,35.22,0.47,111,47790,NULL,NULL,'H','UGC 08543',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111023,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111023,38.28,0.46,453,47791,70,NULL,NULL,'LCRS B133129.0-030655',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000187,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,203.5175,-3.37125,0.065,NULL,43560819009,680637797,10634965,17.7),(111024,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111024,35.37,NULL,118,47792,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08551',NULL,'2010Ap&SS.325..163P',2010,1,1.7,NULL,'G',0.000107,NULL,'16.0',0.21,'Sbc',NULL,NULL,NULL,NULL,1,203.518917,52.70228,0.043,NULL,59209192916,925143639,14455369,16),(111025,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111025,35.38,NULL,119,47792,NULL,NULL,'Dipole + Quadrupole','UGC 08551',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111026,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111026,35.39,NULL,119,47792,NULL,NULL,'Dipole','UGC 08551',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111027,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111027,35.4,NULL,121,47792,NULL,NULL,NULL,'UGC 08551',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111028,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111028,36.07,0.5,164,47793,70,NULL,NULL,'2MASX J13340456-1737432',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'16.64',0.4,NULL,NULL,NULL,NULL,NULL,1,203.519125,-17.62883,0.213,NULL,43782602283,684103160,10689111,16.64),(111029,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111029,34.85,0.49,93.2,47794,75,NULL,'IR','2MFGC 10923',NULL,'2011yCatp016004901K',2011,1,0.05,NULL,'G',0.000167,NULL,'20.9g',0.05,NULL,NULL,NULL,NULL,NULL,1,203.51925,52.702,0.043,NULL,59209192916,925143639,14455369,20.9),(111030,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111030,37.58,0.46,328,47795,70,NULL,NULL,'2MASX J13340538+0245152',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000096,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,203.522375,2.75417,0,NULL,58398546833,912477294,14257457,16.5),(111031,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111031,34.76,0.46,89.3,47796,70,NULL,NULL,'NGC 5217',NULL,'2015arXiv151105856S',2015,1,1.5,NULL,'G',0.000147,NULL,'13.56',1.4,'E','Possible field galaxy',NULL,NULL,NULL,1,203.524708333,17.85686,0.011,NULL,58826946921,919171045,14362047,13.56),(111032,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111032,36.32,0.33,184,47797,70,NULL,NULL,'2MASX J13340613+3941180',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000189,NULL,'16.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,203.5257083,39.68836,0,NULL,59315139902,926799060,14481235,16.9),(111033,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111033,34.8,0.46,91,47798,70,NULL,NULL,'CGCG 045-026',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000093,NULL,'15.4g',0.35,'SABa',NULL,NULL,NULL,NULL,1,203.528416667,5.10233,0.047,NULL,58394078950,912407483,14256366,15.4),(111034,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111034,37.76,0.46,357,47799,70,NULL,NULL,'SDSS J133407.32+083911.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,203.5305417,8.65333,0,NULL,58947961375,921061896,14391592,18.2),(111035,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111035,37.58,0.27,328,47800,70,NULL,NULL,'2MASX J13340819+0217392',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000071,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,203.534166667,2.29414,0.041,NULL,58386940370,912295943,14254624,18),(111036,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111036,38.06,0.46,409,47801,70,NULL,NULL,'2MASX J13340818+6118031',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000169,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,203.534166667,61.30083,0,NULL,57381335235,896583363,14009115,17.5),(111037,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111037,37.58,0.27,328,47802,70,NULL,NULL,'2MASX J13340845+0219522',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000102,NULL,'16.0g',0.42,'AGN',NULL,NULL,NULL,NULL,1,203.535291667,2.33108,0.009,NULL,58398412724,912475198,14257424,16),(111038,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111038,36.32,NULL,184,47803,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1637',NULL,'2010Ap&SS.325..163P',2010,1,0.4,NULL,'G',0.000187,NULL,'18.0g',0.11,'Scd',NULL,NULL,NULL,NULL,1,203.537,39.85031,0,NULL,59315596748,926806199,14481346,18),(111039,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111039,36.34,NULL,186,47803,NULL,NULL,'Dipole + Quadrupole','FGC 1637',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111040,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111040,36.35,NULL,186,47803,NULL,NULL,NULL,'FGC 1637',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111041,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111041,36.38,NULL,189,47803,NULL,NULL,'Dipole','FGC 1637',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111042,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111042,36.27,0.33,180,47804,70,NULL,NULL,'IC 0898',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.0001,NULL,'15.2g',0.45,'AGN+SF','Group member',NULL,NULL,NULL,1,203.5392083,13.28083,0,NULL,58821685320,919088833,14360763,15.2),(111043,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111043,37.44,0.46,308,47805,70,NULL,NULL,'2MASX J13340942+0103412',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000081,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,203.5392917,1.0615,0,NULL,58388868012,912326062,14255094,17.3),(111044,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111044,37.42,0.46,305,47806,70,NULL,NULL,'2MASX J13340999+0211342',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000084,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,203.5415,2.19286,0.041,NULL,58387663789,912307246,14254800,17),(111045,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111045,37.77,0.46,358,47807,70,NULL,NULL,'SDSS J133410.78-010606.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00007,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,203.544917,-1.10189,0.049,NULL,43557818826,680590919,10634233,18.1),(111046,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111046,36.25,0.44,178,47808,NULL,NULL,'Malmquist cor.','2MASX J13341140-3504023',NULL,'2009ApJS..182..474S',2009,1,0.46,NULL,'G',0.00015,NULL,'15.28',0.2,'Sc',NULL,NULL,NULL,NULL,1,203.5475,-35.06733,0.109,NULL,46894762672,732730666,11448916,15.28),(111047,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111047,36.34,0.42,186,47808,NULL,NULL,NULL,'2MASX J13341140-3504023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111048,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111048,36.38,0.2,189,47808,74.4,NULL,NULL,'2MASX J13341140-3504023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111049,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111049,37.14,0.33,268,47809,70,NULL,NULL,'2MASX J13341147+0953220',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.30',0.15,NULL,NULL,NULL,NULL,NULL,1,203.5477083,9.88942,0,NULL,58941332138,920958314,14389973,18.3),(111050,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111050,35.58,0.55,131,47810,70,NULL,NULL,'ESO 383- G 022',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000117,NULL,'16.0b',0.1,'Sa:',NULL,NULL,NULL,NULL,1,203.552083,-32.97736,0.149,NULL,46906578086,732915282,11451801,16),(111051,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111051,37.85,0.46,372,47811,70,NULL,NULL,'SDSS J133413.87+022031.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000072,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,203.557833333,2.34203,0.009,NULL,58398410715,912475167,14257424,18.1),(111052,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111052,37.69,0.6,345,47812,70,NULL,NULL,'6dF J1334140-291429',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,203.5584583,-29.24147,0.145,NULL,46850322455,732036288,11438067,15.2),(111053,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111053,36.37,0.54,188,47813,70,NULL,NULL,'2MASX J13341443-1805006',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.5,NULL,NULL,NULL,NULL,NULL,1,203.5602083,-18.08353,0.309,NULL,43782543400,684102240,10689097,13.9),(111054,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111054,34.9,0.43,95.6,47814,NULL,NULL,NULL,'UGC 08554',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',NULL,NULL,'16.5',0.3,'Sbc',NULL,NULL,NULL,NULL,1,203.561333,37.20789,0,NULL,59165033920,924453655,14444588,16.5),(111055,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111055,34.91,0.43,96.1,47814,NULL,NULL,'Malmquist cor.','UGC 08554',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111056,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111056,34.93,0.2,96.8,47814,74.4,NULL,NULL,'UGC 08554',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111057,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111057,38.58,0.46,519,47815,70,NULL,NULL,'SDSS J133414.96+585712.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000162,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,203.562375,58.95336,0,NULL,57390195820,896721809,14011278,18.5),(111058,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111058,36.67,0.46,216,47816,70,NULL,NULL,'2MASX J13341513+5615055',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000188,NULL,'16.0g',0.4,'E0',NULL,NULL,NULL,NULL,1,203.563041667,56.25144,0,NULL,57289655878,895150873,13986732,16),(111059,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111059,35.13,0.46,106,47817,70,NULL,NULL,'CGCG 294-047',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000169,NULL,'15.5g',0.42,'S0',NULL,NULL,NULL,NULL,1,203.5635417,61.69714,0.005,NULL,57382126165,896595721,14009308,15.5),(111060,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111060,36.32,0.33,184,47818,70,NULL,NULL,'2MASX J13341610+3954420',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000157,NULL,'16.2g',0.41,NULL,NULL,NULL,NULL,NULL,1,203.567083333,39.91164,0,NULL,59315639713,926806870,14481357,16.2),(111061,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111061,36.86,0.46,235,47819,70,NULL,NULL,'2MASX J13341617+5835545',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,203.567458333,58.59853,0,NULL,57386949873,896671091,14010485,17.1),(111062,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111062,37.09,0.46,261,47820,70,NULL,NULL,'2MASX J13341636+3146455',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.3g',0.22,'E2',NULL,NULL,NULL,NULL,1,203.56825,31.77936,0,NULL,59180763630,924699431,14448428,17.3),(111063,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111063,35.87,0.46,149,47821,70,NULL,NULL,'2MASX J13341688+0945140',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000169,NULL,'16.0g',0.37,NULL,NULL,NULL,NULL,NULL,1,203.570375,9.75381,0,NULL,58940635525,920947430,14389803,16),(111064,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111064,37.48,0.46,313,47822,70,NULL,NULL,'2MASXi J1334175-013011',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000159,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,203.572833,-1.50328,0.049,NULL,43556935943,680577124,10634017,18),(111065,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111065,37.09,0.46,262,47823,70,NULL,NULL,'2MASX J13341762+5210434',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,203.5735417,52.17858,0,NULL,59210366099,925161970,14455655,17),(111066,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111066,37.64,0.09,338,47824,70,NULL,NULL,'SDSS J133418.06+593314.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,203.5752917,59.554,0.005,NULL,57388544161,896696002,14010875,17.9),(111067,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111067,37.54,0.46,323,47825,70,NULL,NULL,'2MASX J13341816+3932480',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000184,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,203.5757083,39.54658,0,NULL,59312322497,926755039,14480547,17),(111068,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111068,37.44,0.46,308,47826,70,NULL,NULL,'2MASX J13341876+1112320',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000175,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,203.578166667,11.209,0.006,NULL,58941836223,920966190,14390096,16.8),(111069,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111069,37.99,0.23,395,47827,70,NULL,NULL,'2MASX J13341892-0138318',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,203.5787917,-1.64217,0.073,NULL,43555094392,680548349,10633567,17.9),(111070,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111070,37.04,0.46,255,47828,70,NULL,NULL,'2MASX J13342057+3843239',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000175,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,203.585583333,38.72344,0,NULL,59312529570,926758274,14480598,16.6),(111071,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111071,38.16,0.46,429,47829,70,NULL,NULL,'2MASX J13342177+4917574',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,203.59075,49.29914,0,NULL,59276025492,926187898,14471685,17.3),(111072,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111072,34.79,0.53,90.9,47830,70,NULL,NULL,'2MASX J13342198-0816282',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000067,NULL,'15.81',0.4,NULL,NULL,NULL,NULL,NULL,1,203.591583,-8.27442,0.029,NULL,43862364927,685349451,10708585,15.81),(111073,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111073,35.61,0.17,132,47831,70,NULL,NULL,'2MASX J13342508+3438185',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000182,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,203.604375,34.63864,0,NULL,59175301042,924614078,14447094,16.7),(111074,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111074,34.32,0.45,73,47832,NULL,NULL,'K','NGC 5223',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000087,NULL,'13.99',1.3,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,203.605083333,34.69044,0,NULL,59175299219,924614050,14447094,13.99),(111075,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111075,35.13,0.4,106,47832,NULL,NULL,'mean','NGC 5223',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111076,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111076,36.92,0.46,242,47833,70,NULL,NULL,'SDSS J133425.23+381759.4',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.26,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,203.605125,38.29986,0,NULL,59294977562,926484024,14476312,16.9),(111077,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111077,37.64,0.09,338,47834,70,NULL,NULL,'2MASX J13342636+5922256',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000067,NULL,'15.5g',0.44,'E0',NULL,NULL,NULL,NULL,1,203.6099583,59.37372,0.005,NULL,57388206472,896690726,14010792,15.5),(111078,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111078,37.55,0.46,323,47835,70,NULL,NULL,'2MASX J13342631+5345204',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,203.61,53.75567,0,NULL,57280595962,895009311,13984520,17.5),(111079,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111079,35.38,0.68,119,47836,70,NULL,NULL,'2MASX J13342913-7301499',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,203.621667,-73.03053,0.849,NULL,44198913963,690608030,10790750,17.2),(111080,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111080,37.43,0.46,306,47837,70,NULL,NULL,'2MASX J13342932+1109002',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,203.622125,11.15014,0.006,NULL,58941843224,920966300,14390098,17.3),(111081,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111081,36.51,0.35,201,47838,NULL,NULL,'Malmquist cor.','AGC 530521',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.00003,NULL,'15.91',NULL,'Sc',NULL,NULL,NULL,NULL,1,203.6232917,-35.18803,0.109,NULL,46894765191,732730706,11448917,15.91),(111082,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111082,36.6,0.33,209,47838,NULL,NULL,NULL,'AGC 530521',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111083,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111083,36.64,0.2,213,47838,74.4,NULL,NULL,'AGC 530521',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111084,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111084,37.77,0.46,358,47839,70,NULL,NULL,'2MASX J13342963+0139377',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000085,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,203.623625,1.66033,0.01,NULL,58387516877,912304951,14254764,17.4),(111085,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111085,36.86,0.46,235,47840,70,NULL,NULL,'2MASX J13342997+1148501',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000188,NULL,'16.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,203.625,11.81378,0.005,NULL,58939302890,920926607,14389478,16.6),(111086,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111086,37.01,0.27,253,47841,70,NULL,NULL,'2MASX J13343002+5354574',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000172,NULL,'15.9g',0.37,'E0',NULL,NULL,NULL,NULL,1,203.625041667,53.91589,0.018,NULL,57280571989,895008937,13984514,15.9),(111087,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111087,37.73,0.33,351,47842,70,NULL,NULL,'2MASX J13343027+6240322',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000079,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,203.626,62.67558,0.029,NULL,57345096255,896017128,14000267,17.7),(111088,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111088,38,0.46,398,47843,70,NULL,NULL,'2MASX J13343052+1553304',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.80',0.12,NULL,NULL,NULL,NULL,NULL,1,203.627125,15.89181,0,NULL,58835986887,919312295,14364254,18.8),(111089,'IRAS','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111089,33.86,0.8,59.2,47844,75,NULL,'MAT, I','ESO 008- G 001',NULL,'1997ApJS..109..333W',1997,1,1.93,NULL,'G',0.000033,NULL,'13.80',0.25,'SB(s)d? sp',NULL,NULL,NULL,NULL,1,203.628583,-83.13006,0.265,NULL,44069630684,688587979,10759187,13.8),(111090,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111090,32.8,0.49,36.3,47844,75,NULL,'IR','ESO 008- G 001',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111091,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111091,32.94,0.32,38.8,47844,85,NULL,'I, inv','ESO 008- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111092,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111092,32.96,0.32,39,47844,85,NULL,'I, raw','ESO 008- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111093,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111093,33.2,0.43,43.6,47844,75,NULL,'MAT, I, raw','ESO 008- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111094,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111094,33.23,0.43,44.3,47844,75,NULL,'MAT, I, inv','ESO 008- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111095,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111095,33.34,0.58,46.6,47844,NULL,NULL,'Malmquist cor.','ESO 008- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111096,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111096,33.46,0.55,49.2,47844,NULL,NULL,NULL,'ESO 008- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111097,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111097,33.46,0.43,49.3,47844,75,NULL,'MAT, I, cor','ESO 008- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111098,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111098,33.5,0.2,50.1,47844,74.4,NULL,NULL,'ESO 008- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111099,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111099,33.53,NULL,50.8,47844,NULL,NULL,'Dipole + Quadrupole','ESO 008- G 001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111100,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111100,33.53,NULL,50.9,47844,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 008- G 001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111101,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111101,33.54,NULL,50.9,47844,NULL,NULL,'Dipole','ESO 008- G 001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111102,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111102,33.61,NULL,52.8,47844,NULL,NULL,NULL,'ESO 008- G 001',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111103,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111103,35.61,0.17,132,47845,70,NULL,NULL,'2MASX J13343095+3341245',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00013,NULL,'15.8g',0.43,'E1',NULL,NULL,NULL,NULL,1,203.629083,33.69025,0,NULL,59188795800,924824934,14450389,15.8),(111104,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111104,34.9,0.64,95.5,47846,NULL,NULL,NULL,'2MASX J13343156-3205084',NULL,'2009ApJS..182..474S',2009,1,0.39,NULL,'G',0.000033,NULL,'17.13',0.39,NULL,'Group member',NULL,NULL,NULL,1,203.631167,-32.08583,0.161,NULL,46903873745,732873027,11451141,17.13),(111105,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111105,34.94,0.2,97.3,47846,74.4,NULL,NULL,'2MASX J13343156-3205084',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111106,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111106,34.97,0.62,98.5,47846,NULL,NULL,'Malmquist cor.','2MASX J13343156-3205084',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111107,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111107,37.5,0.46,316,47847,70,NULL,NULL,'2MASX J13343189+0131407',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00008,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,203.6327917,1.52794,0.01,NULL,58387489766,912304527,14254758,16.9),(111108,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111108,37.68,0.46,344,47848,70,NULL,NULL,'SDSS J133432.39+543826.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000129,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,203.6349583,54.64058,0,NULL,57291881885,895185654,13987275,18.4),(111109,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111109,35.11,0.52,105,47849,70,NULL,NULL,'ESO 509- G 062',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'15.31',0.6,'SAB(r)a',NULL,NULL,NULL,NULL,1,203.639125,-23.53072,0.273,NULL,43768728579,683886384,10685724,15.31),(111110,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111110,37.97,0.46,392,47850,70,NULL,NULL,'2MASX J13343349+0104377',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000082,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,203.639625,1.07714,0,NULL,58388853307,912325832,14255091,17.5),(111111,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111111,36.16,0.46,170,47851,70,NULL,NULL,'2MASX J13343362+2756556',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000167,NULL,'15.6g',0.53,NULL,'Field galaxy',NULL,NULL,NULL,1,203.6400417,27.94875,0.02,NULL,59133339465,923958429,14436850,15.6),(111112,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111112,37.2,0.33,276,47852,70,NULL,NULL,'2MASX J13343402+4133022',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000149,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,203.6417083,41.55069,0,NULL,59320592105,926884251,14482566,17),(111113,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111113,37.66,0.46,341,47853,70,NULL,NULL,'SDSS J133434.23-020953.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000127,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,203.642625,-2.16481,0.073,NULL,43568931866,680764560,10636946,18.6),(111114,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111114,35.61,0.17,132,47854,70,NULL,NULL,'NGC 5228',NULL,'2015arXiv151105856S',2015,1,1.13,NULL,'G',0.000093,NULL,'13.9g',0.91,'S0-:','in a radial-velocity based grouping',NULL,NULL,NULL,1,203.646083333,34.77781,0,NULL,59175293253,924613957,14447093,13.9),(111115,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111115,35.29,0.4,114,47854,NULL,NULL,'mean','NGC 5228',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111116,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111116,36.21,0.45,174,47854,NULL,NULL,'K','NGC 5228',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111117,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111117,35.62,0.46,133,47855,70,NULL,NULL,'CGCG 294-046',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000175,NULL,'15.0g',0.57,'S0/a',NULL,NULL,NULL,NULL,1,203.650917,56.46447,0,NULL,57286144485,895096007,13985875,15),(111118,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111118,35.09,0.46,104,47856,70,NULL,NULL,'CGCG 246-014',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.00008,NULL,'15.2g',0.63,'S0^-',NULL,NULL,NULL,NULL,1,203.65325,46.15408,0.04,NULL,59285205075,926331329,14473927,15.2),(111119,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111119,36.92,0.46,243,47857,70,NULL,NULL,'2MASX J13343684+2307131',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',NULL,NULL,'15.8g',0.44,NULL,NULL,NULL,NULL,NULL,1,203.653583,23.12039,0,NULL,58803091581,918798305,14356223,15.8),(111120,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111120,36.01,0.46,159,47858,70,NULL,NULL,'2MASX J13343703+5525166',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00017,NULL,'15.6g',0.5,'S0a',NULL,NULL,NULL,NULL,1,203.6545,55.42117,0,NULL,57287370939,895115170,13986174,15.6),(111121,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111121,37.77,0.46,359,47859,70,NULL,NULL,'LCRS B133202.7-022059',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000206,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,203.6562917,-2.60506,0.049,NULL,43569316565,680770571,10637040,16.7),(111122,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111122,38.17,0.46,430,47860,70,NULL,NULL,'SDSS J133437.52+394107.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000158,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,203.656375,39.68536,0,NULL,59315585278,926806019,14481344,18.7),(111123,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111123,31.23,NULL,17.6,47861,72,NULL,NULL,'CGCG 073-036',NULL,'2014Ap.....57..457K',2014,1,0.8,NULL,'G',0.000005,NULL,'15.4g',0.6,'Ir','Group member',NULL,NULL,NULL,1,203.6574583,8.79361,0,NULL,58948058166,921063408,14391615,15.4),(111124,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111124,30.72,0.2,13.9,47862,74.4,NULL,NULL,'CGCG 073-036',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000005,NULL,'15.4g',0.6,'Ir','Group member',NULL,NULL,NULL,1,203.6574583,8.79361,0,NULL,58948058166,921063408,14391615,15.4),(111125,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111125,37.02,0.17,253,47863,70,NULL,NULL,'2MASX J13343825+4239134',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00017,NULL,'16.0g',0.41,'E0',NULL,NULL,NULL,NULL,1,203.659583,42.65372,0,NULL,59323857299,926935270,14483363,16),(111126,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111126,30.47,0.4,12.4,47864,NULL,NULL,NULL,'UGCA 364',NULL,'2013MNRAS.429.2677K',2013,1,1.4,NULL,'G',0.000037,NULL,NULL,1,'SAB(s)m:',NULL,NULL,NULL,NULL,1,203.665417,-12.33056,0.121,NULL,43990825861,687356654,10739947,NULL),(111127,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111127,35.82,0.7,146,47865,70,NULL,NULL,'ESO 509- G 065',NULL,'2014MNRAS.445.2677S',2014,1,1.5,'1986AJ.....91....6D has V = 3942.','G',0.000133,NULL,'15.72',1.2,'S0',NULL,NULL,NULL,NULL,1,203.6669583,-23.78911,0.273,NULL,43757302875,683707857,10682935,15.72),(111128,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111128,34.96,0.46,98,47866,70,NULL,NULL,'ARK 421',NULL,'2015arXiv151105856S',2015,1,0.84,'1999PASP..111..438F has z = 0.05804.','G',0.000182,NULL,'14.8g',0.68,'E1',NULL,NULL,NULL,NULL,1,203.668083,32.95111,0,NULL,59188336985,924817765,14450277,14.8),(111129,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111129,38.1,0.46,417,47867,70,NULL,NULL,'2MASX J13344034+1052502',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000187,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,203.668167,10.88061,0.006,NULL,58942018506,920969039,14390141,17.8),(111130,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111130,33.27,0.5,45.1,47868,NULL,NULL,'Malmquist cor.','NGC 5216A',NULL,'2009ApJS..182..474S',2009,1,1.37,NULL,'G',0.000012,NULL,'14.4g',0.43,'Sc(f)','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,203.67325,61.99336,0.037,NULL,57381957827,896593091,14009267,14.4),(111131,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111131,33.3,0.2,45.7,47868,74.4,NULL,NULL,'NGC 5216A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111132,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111132,33.35,0.49,46.8,47868,NULL,NULL,NULL,'NGC 5216A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111133,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111133,37.19,0.46,274,47869,70,NULL,NULL,'2MASX J13344187+0808332',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,203.6745417,8.1425,0,NULL,58948450958,921069546,14391711,17.7),(111134,'Brightest Stars','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111134,28.57,0.2,5.18,47870,NULL,NULL,NULL,'NGC 5238',NULL,'1998A&AS..133..181M',1998,1,1.68,NULL,'G',0.000007,NULL,'14.3g',0.99,'SAB(s)dm;WR?   HII?','Pair member (points to parent)',NULL,NULL,NULL,1,203.677125,51.61367,0,NULL,59210902305,925170348,14455786,14.3),(111135,'TRGB','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111135,28.12,0.13,4.21,47870,NULL,NULL,NULL,'NGC 5238',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111136,'TRGB','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111136,28.27,0.02,4.51,47870,NULL,NULL,'I','NGC 5238',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111137,'TRGB','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111137,28.27,0.1,4.51,47870,74.4,NULL,NULL,'NGC 5238',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111138,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111138,28.46,0.4,4.9,47870,75,NULL,'B','NGC 5238',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111139,'IRAS','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111139,34.96,0.8,98,47871,75,NULL,'HMCL, I','IC 0900',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000008,NULL,'13.60',1,'SAB(s)bc',NULL,NULL,NULL,NULL,1,203.6792083,9.33686,0,NULL,58940490892,920945170,14389768,13.6),(111140,'IRAS','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111140,34.96,0.8,98.4,47871,75,NULL,'A82, H','IC 0900',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111141,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111141,34.33,0.33,73.4,47871,91,NULL,'H','IC 0900',NULL,'1984ApJ...278..475B',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111142,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111142,34.34,0.69,73.8,47871,100,NULL,'mid-IR','IC 0900',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111143,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111143,34.52,NULL,80.2,47871,NULL,NULL,'B','IC 0900',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111144,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111144,34.55,0.4,81.5,47871,75,NULL,'HMCL, I, raw','IC 0900',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111145,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111145,34.77,NULL,90,47871,NULL,NULL,'I','IC 0900',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111146,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111146,34.78,0.4,90.4,47871,75,NULL,'HMCL, I, inv','IC 0900',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111147,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111147,34.8,0.47,91,47871,75,NULL,'A82, H, raw','IC 0900',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111148,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111148,34.82,0.32,92.2,47871,NULL,NULL,'Malmquist cor.','IC 0900',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111149,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111149,34.83,0.32,92.5,47871,NULL,NULL,NULL,'IC 0900',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111150,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111150,34.83,0.4,92.5,47871,75,NULL,'HMCL, I, cor','IC 0900',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111151,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111151,34.84,0.2,92.9,47871,74.4,NULL,NULL,'IC 0900',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111152,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111152,34.96,0.47,98.1,47871,NULL,NULL,'H','IC 0900',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111153,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111153,34.99,0.47,99.4,47871,75,NULL,'A82, H, inv','IC 0900',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111154,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111154,35.07,0.46,103,47871,NULL,NULL,'J','IC 0900',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111155,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111155,35.07,0.45,103,47871,NULL,NULL,'K','IC 0900',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111156,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111156,35.08,0.4,104,47871,NULL,NULL,'mean','IC 0900',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111157,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111157,35.09,0.47,104,47871,75,NULL,'A82, H, cor','IC 0900',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111158,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111158,36.65,0.46,214,47872,70,NULL,NULL,'2MASX J13344431+3610102',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,203.684625,36.16958,0,NULL,59173740986,924589702,14446714,17),(111159,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111159,37.9,0.46,380,47873,70,NULL,NULL,'2MASX J13344442+5046134',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000186,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,203.6850417,50.77039,0,NULL,59208639954,925134999,14455234,16.7),(111160,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111160,37.33,0.46,293,47874,70,NULL,NULL,'2MASX J13344494+5937085',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000174,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,203.686917,59.619,0.005,NULL,57388555987,896696187,14010877,16.8),(111161,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111161,37.63,0.19,336,47875,70,NULL,NULL,'2MASX J13344538+5026014',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000146,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,203.6892083,50.43372,0,NULL,59208868475,925138569,14455290,17.7),(111162,'TRGB','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111162,29.21,0.1,6.95,47876,74.4,NULL,NULL,'ESO 270- G 017',NULL,'2013AJ....146...86T',2013,1,15.12,'Extended HIPASS source','G',0.000007,NULL,'11.71',1.68,'SB(s)m:','Pair member (points to parent)',NULL,NULL,NULL,1,203.697083,-45.5475,0.393,NULL,46948754415,733574287,11462098,11.71),(111163,'Tully est','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111163,30.17,0.8,10.8,47876,75,NULL,NULL,'ESO 270- G 017',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111164,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111164,27.71,0.43,3.5,47876,75,NULL,'3.6 micron, color + selection bias corrected','ESO 270- G 017',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111165,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111165,27.94,0.43,3.9,47876,75,NULL,'3.6 micron, color corrected','ESO 270- G 017',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111166,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111166,28.17,0.41,4.3,47876,73,NULL,'opt','ESO 270- G 017',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111167,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111167,28.18,0.36,4.33,47876,NULL,NULL,NULL,'ESO 270- G 017',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111168,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111168,28.22,NULL,4.4,47876,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 270- G 017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111169,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111169,28.22,NULL,4.41,47876,NULL,NULL,'Dipole','ESO 270- G 017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111170,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111170,28.24,NULL,4.44,47876,NULL,NULL,'Dipole + Quadrupole','ESO 270- G 017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111171,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111171,29.21,0.1,6.95,47876,74.4,NULL,NULL,'ESO 270- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111172,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111172,36.69,0.46,217,47877,70,NULL,NULL,'2MASX J13344846+0627522',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,203.7019583,6.46456,0.047,NULL,58422642196,912853784,14263340,17.5),(111173,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111173,36.55,0.67,204,47878,70,NULL,NULL,'2MASX J13344947-3304436',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.0001,NULL,'15.34',0.2,NULL,NULL,NULL,NULL,NULL,1,203.70625,-33.07883,0.141,NULL,46906561293,732915020,11451797,15.34),(111174,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111174,37.63,0.19,336,47879,70,NULL,NULL,'2MASX J13344977+5024224',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00017,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,203.707208333,50.40614,0,NULL,59208879657,925138744,14455292,17.8),(111175,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111175,36.16,0.63,171,47880,70,NULL,NULL,'2MASX J13345012-3144476',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00008,NULL,'15.5V',0.32,'S0','Group member',NULL,NULL,NULL,1,203.708917,-31.74661,0.133,NULL,46903957827,732874341,11451161,15.5),(111176,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111176,37.05,0.56,257,47881,70,NULL,NULL,'2MASX J13345182-1734056',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,203.715833,-17.56833,0.253,NULL,43782623747,684103496,10689117,15.7),(111177,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111177,37.63,0.19,336,47882,70,NULL,NULL,'2MASX J13345281+5025173',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000186,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,203.719917,50.4215,0,NULL,59208876379,925138693,14455292,17),(111178,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111178,38.06,0.46,410,47883,70,NULL,NULL,'SDSS J133452.91+450155.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,203.7204583,45.03206,0,NULL,59317812725,926840823,14481887,18.6),(111179,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111179,37.99,0.23,395,47884,70,NULL,NULL,'SDSS J133453.36-013238.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'18.4g',0.14,'AGN',NULL,NULL,NULL,NULL,1,203.722375,-1.54406,0.077,NULL,43555064864,680547888,10633560,18.4),(111180,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111180,37.58,0.27,328,47885,70,NULL,NULL,'2MASX J13345372+0226046',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000086,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,203.724041667,2.43467,0.009,NULL,58399313519,912489273,14257644,17.1),(111181,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111181,35.58,0.46,131,47886,70,NULL,NULL,'ARK 422',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000077,NULL,'15.0',0.3,'S0','Field galaxy',NULL,NULL,'Emission-Line Galaxy',1,203.7255417,26.20628,0.028,NULL,58654590669,916477979,14319968,15),(111182,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111182,37.99,0.46,397,47887,70,NULL,NULL,'2MASX J13345435+2341441',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.93',0.15,NULL,NULL,NULL,NULL,NULL,1,203.7265,23.69556,0,NULL,58788524356,918570693,14352667,17.93),(111183,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111183,37.62,0.46,334,47888,70,NULL,NULL,'SDSS J133454.40+405340.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000169,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,203.726667,40.89447,0,NULL,59314956927,926796201,14481190,18.1),(111184,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111184,35.35,0.51,117,47889,70,NULL,NULL,'2MASX J13345440-0826327',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00013,NULL,'14.79',0.8,NULL,NULL,NULL,NULL,NULL,1,203.726875,-8.44247,0.029,NULL,43862006967,685343858,10708497,14.79),(111185,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111185,37.84,0.46,370,47890,70,NULL,NULL,'2MASX J13345540+2555338',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,203.73075,25.92606,0.018,NULL,58654606537,916478227,14319972,16.9),(111186,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111186,37.64,0.09,338,47891,70,NULL,NULL,'2MASX J13345555+5846523',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000175,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,203.731667,58.78117,0.013,NULL,57386789841,896668591,14010446,16.8),(111187,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111187,36.94,0.46,245,47892,70,NULL,NULL,'2MASX J13345586-0010271',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000078,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,203.7327917,-0.17422,0.021,NULL,43554230961,680534858,10633357,16.4),(111188,'IRAS','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111188,34.91,0.8,95.9,47893,75,NULL,'HMCL, I','NGC 5221',NULL,'1997ApJS..109..333W',1997,1,2.4,'Misidentified in VV as \'NGC 5226\'.','G',0.000027,NULL,'13.80',0.8,'Sb:','in a radial-velocity based grouping',NULL,NULL,NULL,1,203.732917,13.8325,0,NULL,58824890319,919138911,14361545,13.8),(111189,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111189,34.69,0.4,86.8,47893,75,NULL,'HMCL, I, raw','NGC 5221',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111190,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111190,34.94,0.4,97.1,47893,75,NULL,'HMCL, I, cor','NGC 5221',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111191,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111191,34.96,0.4,98,47893,75,NULL,'HMCL, I, inv','NGC 5221',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111192,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111192,34.97,0.49,98.7,47893,75,NULL,'IR','NGC 5221',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111193,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111193,35,0.47,99.8,47893,NULL,NULL,'H','NGC 5221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111194,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111194,35.01,0.46,100,47893,NULL,NULL,'J','NGC 5221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111195,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111195,35.04,0.45,102,47893,NULL,NULL,'K','NGC 5221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111196,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111196,35.05,0.4,103,47893,NULL,NULL,'mean','NGC 5221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111197,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111197,37.27,0.46,284,47894,70,NULL,NULL,'2MASX J13345599+6000383',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,203.7330417,60.01067,0.009,NULL,57387638134,896681845,14010653,17.1),(111198,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111198,35.13,0.46,106,47895,70,NULL,NULL,'NGC 5222 NED01',NULL,'2015arXiv151105856S',2015,1,1.39,'Component \'a)\' in UGC notes.','G',0.0001,NULL,'13.8g',0.92,'E','Pair member (points to parent)',NULL,NULL,NULL,1,203.733125,13.74217,0,NULL,58824396818,919131200,14361425,13.8),(111199,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111199,37.47,0.6,311,47896,70,NULL,NULL,'ESO 324- G 039',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'16.47',0.2,'Compact',NULL,NULL,NULL,NULL,1,203.735083333,-41.71656,0.381,NULL,46972492683,733945198,11467893,16.47),(111200,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111200,35.9,0.63,152,47897,NULL,NULL,NULL,'AGC 530530',NULL,'2009ApJS..182..474S',2009,1,0.36,NULL,'G',0.00003,NULL,'17.02',NULL,'Sc',NULL,NULL,NULL,NULL,1,203.737917,-35.1425,0.109,NULL,46894804331,732731317,11448926,17.02),(111201,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111201,35.94,0.2,154,47897,74.4,NULL,NULL,'AGC 530530',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111202,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111202,36.13,0.57,168,47897,NULL,NULL,'Malmquist cor.','AGC 530530',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111203,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111203,34.98,0.47,99,47898,NULL,NULL,'H','UGC 08561',NULL,'2007A&A...465...71T',2007,1,1.25,'Position in 1986AnTok..212.181T is for MCG +06-30-045.','G',0.00002,NULL,'13.7g',0.85,'Scd:','Parent (of companion) galaxy',NULL,NULL,NULL,1,203.738625,34.04408,0,NULL,59188782288,924824723,14450386,13.7),(111204,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111204,35.04,0.46,102,47898,NULL,NULL,'J','UGC 08561',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111205,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111205,35.1,0.4,105,47898,NULL,NULL,'mean','UGC 08561',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111206,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111206,35.11,0.45,105,47898,NULL,NULL,'K','UGC 08561',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111207,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111207,36.82,0.56,231,47899,70,NULL,NULL,'2MASX J13345742-3136047',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.000087,NULL,'14.3R',0.47,'E','Group member',NULL,NULL,NULL,1,203.7392083,-31.60125,0.133,NULL,46903467751,732866683,11451041,14.3),(111208,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111208,36.57,0.53,206,47900,70,NULL,NULL,'2MASX J13345852-3136577',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000103,NULL,'14.2R',0.63,'*+E','Group member',NULL,NULL,NULL,1,203.743833333,-31.61606,0.133,NULL,46903464196,732866628,11451041,14.2),(111209,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111209,36.64,0.52,213,47901,70,NULL,NULL,'2MASX J13345906-1525466',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.67',0.5,NULL,NULL,NULL,NULL,NULL,1,203.7462917,-15.42969,0.161,NULL,43785849836,684153903,10689904,16.67),(111210,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111210,33.94,0.54,61.4,47902,70,NULL,NULL,'IC 0899',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00011,NULL,'14.85',0.7,NULL,NULL,NULL,NULL,NULL,1,203.74775,-8.09164,0.021,NULL,43862355259,685349300,10708582,14.85),(111211,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111211,37.67,0.46,342,47903,70,NULL,NULL,'2MASX J13345997+3922532',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,203.749666667,39.38144,0,NULL,59312504285,926757879,14480591,17.8),(111212,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111212,36.52,0.46,201,47904,70,NULL,NULL,'2MASX J13350141+1138409',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000182,NULL,'16.2g',0.31,'S0^-',NULL,NULL,NULL,NULL,1,203.75575,11.6445,0.009,NULL,58939368254,920927628,14389494,16.2),(111213,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111213,37.78,0.33,360,47905,70,NULL,NULL,'LCRS B133226.2-030856',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,203.755916667,-3.40431,0.069,NULL,43560632400,680634881,10634920,17.6),(111214,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111214,36.72,0.46,221,47906,70,NULL,NULL,'2MASX J13350185+0638059',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.99',0.25,NULL,NULL,NULL,NULL,NULL,1,203.7577083,6.63489,0.036,NULL,58423373752,912865214,14263518,16.99),(111215,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111215,37.99,0.46,396,47907,70,NULL,NULL,'2MASX J13350218+4913359',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,203.7592917,49.22675,0,NULL,59276063169,926188487,14471695,18),(111216,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111216,37.64,0.09,338,47908,70,NULL,NULL,'2MASX J13350242+5920264',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000107,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,203.759833,59.34064,0.009,NULL,57388252920,896691451,14010803,17.2),(111217,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111217,35.39,0.53,120,47909,70,NULL,NULL,'2MASX J13350243-3016477',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.0',NULL,'*+S0',NULL,NULL,NULL,NULL,1,203.760167,-30.27997,0.085,NULL,46848003891,732000060,11437500,16),(111218,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111218,36.94,0.46,244,47910,70,NULL,NULL,'I Zw 063',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.1',0.24,NULL,NULL,NULL,NULL,NULL,1,203.763166667,35.48731,0,NULL,59177011714,924640808,14447512,17.1),(111219,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111219,37.73,0.33,351,47911,70,NULL,NULL,'2MASX J13350312+6232463',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000088,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,203.7632083,62.54631,0.029,NULL,57345107226,896017300,14000270,17),(111220,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111220,37.32,0.46,291,47912,70,NULL,NULL,'2MASX J13350408+0120506',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000098,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,203.767041667,1.34733,0,NULL,58387964300,912311942,14254874,16.4),(111221,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111221,37.01,0.27,253,47913,70,NULL,NULL,'2MASX J13350442+5352239',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000178,NULL,'15.6g',0.46,'S0^-',NULL,NULL,NULL,NULL,1,203.768083,53.87339,0.018,NULL,57278730641,894980166,13984065,15.6),(111222,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111222,36.19,0.57,173,47914,70,NULL,NULL,'MCG -03-35-005',NULL,'2014MNRAS.445.2677S',2014,1,0.7,'6dF has z = 0.033800 +- 0.000150.','G',0.00012,NULL,'14.84',0.6,NULL,NULL,NULL,NULL,NULL,1,203.7704583,-15.86781,0.161,NULL,43786091184,684157674,10689963,14.84),(111223,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111223,34.39,0.2,75.5,47915,74.4,NULL,NULL,'ESO 383- G 027',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.000027,NULL,'14.52',0.4,'S0             HII',NULL,NULL,NULL,NULL,1,203.7704583,-35.26903,0.109,NULL,46894800761,732731261,11448925,14.52),(111224,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111224,38.42,0.46,484,47916,70,NULL,NULL,'SDSS J133504.97+134343.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000139,NULL,'18.6g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,203.7707083,13.72875,0,NULL,58824860454,919138444,14361538,18.6),(111225,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111225,37.64,0.09,338,47917,70,NULL,NULL,'2MASX J13350521+5911504',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000137,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,203.771916667,59.19722,0.009,NULL,57388288466,896692007,14010812,17.9),(111226,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111226,36.5,0.46,199,47918,70,NULL,NULL,'2MASX J13350559-0140211',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,203.7732917,-1.67269,0.077,NULL,43555203846,680550060,10633594,16.6),(111227,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111227,34.96,0.6,98.3,47919,NULL,NULL,NULL,'ESO 509- G 068',NULL,'2009ApJS..182..474S',2009,1,1,'1993MNRAS.263..349S gives V = 13212 +- 37 km/sec.','G',0.000033,NULL,'16.11',0.2,'Sb',NULL,NULL,NULL,NULL,1,203.775,-26.75028,0.221,NULL,43298881336,676545020,10571015,16.11),(111228,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111228,35.01,0.59,100,47919,NULL,NULL,'Malmquist cor.','ESO 509- G 068',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111229,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111229,35,0.2,100,47919,74.4,NULL,NULL,'ESO 509- G 068',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111230,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111230,37.41,0.46,303,47920,70,NULL,NULL,'2MASX J13350617+2410448',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,203.775667,24.17922,0,NULL,58655349953,916489843,14320153,17.2),(111231,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111231,37.99,0.82,397,47921,70,NULL,NULL,'2MASX J13350705-1524252',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.8I',0.3,NULL,NULL,NULL,NULL,NULL,1,203.779416667,-15.40706,0.161,NULL,43785850693,684153917,10689904,14.8),(111232,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111232,36.59,0.46,208,47922,70,NULL,NULL,'2MASX J13350714+1312340',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00016,NULL,'16.2g',0.32,NULL,NULL,NULL,NULL,NULL,1,203.779833,13.20947,0,NULL,58821643683,919088182,14360752,16.2),(111233,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111233,37.02,0.17,253,47923,70,NULL,NULL,'2MASX J13350849+4238504',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000189,NULL,'15.9g',0.42,'BrClG',NULL,NULL,NULL,NULL,1,203.785333,42.64722,0,NULL,59320379958,926880936,14482514,15.9),(111234,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111234,38.26,0.33,449,47924,70,NULL,NULL,'2MASX J13350863+6149414',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000142,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,203.7862083,61.82806,0.037,NULL,57382243921,896597561,14009336,17.9),(111235,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111235,34.56,0.46,81.6,47925,70,NULL,NULL,'NGC 5224',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000113,NULL,'15.0',0.6,NULL,NULL,NULL,NULL,NULL,1,203.786916667,6.48111,0.047,NULL,58422639590,912853743,14263339,15),(111236,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111236,37.63,0.19,336,47926,70,NULL,NULL,'2MASX J13350969+5009069',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,203.790375,50.15189,0,NULL,59208840554,925138133,14455283,17.6),(111237,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111237,35.88,0.46,150,47927,70,NULL,NULL,'CGCG 218-025',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000197,NULL,'14.9g',0.65,'E/S0',NULL,NULL,NULL,NULL,1,203.7917917,41.18836,0,NULL,59313209341,926768895,14480763,14.9),(111238,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111238,37.75,0.46,356,47928,70,NULL,NULL,'SDSS J133510.81+124935.4',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000141,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,203.7950417,12.8265,0,NULL,58821772278,919090191,14360784,17.8),(111239,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111239,37.63,0.33,336,47929,70,NULL,NULL,'SDSS J133510.84+001226.0',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000068,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,203.7952083,0.20722,0.025,NULL,58388438704,912319354,14254989,17.7),(111240,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111240,37.7,0.46,346,47930,70,NULL,NULL,'2MASX J13351107+2418188',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,203.7962083,24.30525,0,NULL,58655372438,916490194,14320159,18.4),(111241,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111241,37.35,0.46,295,47931,70,NULL,NULL,'2MASX J13351125+5839504',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000187,NULL,'16.5g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,203.797167,58.66414,0.013,NULL,57386775081,896668360,14010443,16.5),(111242,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111242,37.64,0.09,338,47932,70,NULL,NULL,'2MASX J13351223+5921274',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.0001,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,203.800958333,59.35753,0.009,NULL,57388250751,896691417,14010803,17.1),(111243,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111243,37.64,0.09,338,47933,70,NULL,NULL,'2MASX J13351224+5914034',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00009,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,203.8012083,59.23428,0.009,NULL,57388299548,896692180,14010815,17.2),(111244,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111244,37.08,0.46,260,47934,70,NULL,NULL,'2MASX J13351256+4415404',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000154,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,203.8024583,44.26136,0,NULL,59317361583,926833774,14481777,17.2),(111245,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111245,35.5,0.46,126,47935,70,NULL,NULL,'CGCG 045-029',NULL,'2015arXiv151105856S',2015,1,0.91,NULL,'G',0.000083,NULL,'14.7g',0.54,'E0',NULL,NULL,NULL,NULL,1,203.802541667,3.65336,0.024,NULL,58394482826,912413794,14256465,14.7),(111246,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111246,37.99,0.23,395,47936,70,NULL,NULL,'2MASX J13351346-0136411',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,203.8062083,-1.61156,0.077,NULL,43555202099,680550032,10633594,16.7),(111247,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111247,37.78,0.33,360,47937,70,NULL,NULL,'LCRS B133239.9-031526',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00013,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,203.813333,-3.5125,0.041,NULL,43560638124,680634970,10634921,17.5),(111248,'IRAS','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111248,32.57,0.8,32.7,47938,75,NULL,'MAT, I','ESO 040- G 012',NULL,'1997ApJS..109..333W',1997,1,2.3,'Confused HIPASS source','G',0.000025,NULL,'11.53',0.4,'Sbc',NULL,NULL,NULL,NULL,1,203.817458333,-77.64119,0.661,NULL,44250311636,691411119,10803298,11.53),(111249,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111249,32.4,0.47,30.2,47938,NULL,NULL,'H','ESO 040- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111250,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111250,32.41,0.46,30.4,47938,NULL,NULL,'J','ESO 040- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111251,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111251,32.49,0.45,31.4,47938,NULL,NULL,'K','ESO 040- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111252,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111252,32.71,0.32,34.8,47938,85,NULL,'I, raw','ESO 040- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111253,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111253,32.72,0.43,35,47938,75,NULL,'MAT, I, raw','ESO 040- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111254,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111254,32.76,0.32,35.6,47938,85,NULL,'I, inv','ESO 040- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111255,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111255,32.82,0.49,36.6,47938,75,NULL,'IR','ESO 040- G 012',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111256,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111256,32.87,0.43,37.5,47938,75,NULL,'MAT, I, cor','ESO 040- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111257,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111257,32.87,0.43,37.5,47938,75,NULL,'3.6 micron, color + selection bias corrected','ESO 040- G 012',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111258,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111258,32.89,0.4,37.8,47938,NULL,NULL,'mean','ESO 040- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111259,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111259,32.94,0.43,38.8,47938,75,NULL,'3.6 micron, color corrected','ESO 040- G 012',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111260,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111260,32.95,0.43,39,47938,75,NULL,'MAT, I, inv','ESO 040- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111261,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111261,33.07,0.2,41.1,47938,74.4,NULL,NULL,'ESO 040- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111262,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111262,33.13,0.27,42.3,47938,NULL,NULL,'Malmquist cor.','ESO 040- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111263,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111263,33.32,0.24,46.1,47938,NULL,NULL,NULL,'ESO 040- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111264,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111264,36.93,0.46,244,47939,70,NULL,NULL,'2MASX J13351823+4106431',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000172,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,203.826125,41.11206,0,NULL,59313071319,926766739,14480730,16.2),(111265,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111265,37.08,0.57,261,47940,70,NULL,NULL,'2MASX J13351835-3125348',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.000127,NULL,'13.9R',0.3,'S0','Group member',NULL,NULL,NULL,1,203.826417,-31.42628,0.133,NULL,46903599094,732868735,11451073,13.9),(111266,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111266,37.52,0.46,319,47941,70,NULL,NULL,'2MASX J13351866+5508254',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,203.82775,55.14044,0,NULL,57291807740,895184495,13987257,17.4),(111267,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111267,33.89,0.47,59.9,47942,NULL,NULL,'H','IC 4290',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000023,NULL,'14.21',1.3,'(R\')SB(r)a',NULL,NULL,NULL,NULL,1,203.831583,-28.02181,0.193,NULL,46849154529,732018039,11437781,14.21),(111268,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111268,34.02,0.46,63.8,47942,NULL,NULL,'J','IC 4290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111269,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111269,34.1,0.45,66.2,47942,NULL,NULL,'K','IC 4290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111270,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111270,34.2,0.4,69.1,47942,NULL,NULL,'mean','IC 4290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111271,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111271,37.1,0.46,263,47943,70,NULL,NULL,'2MASX J13352069+1332561',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,203.836291667,13.54894,0,NULL,58821576674,919087135,14360736,17.3),(111272,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111272,34.65,0.58,85,47944,NULL,NULL,'Malmquist cor.','ESO 383- G 031',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000027,NULL,'14.38',0.6,'SA(rs)bc:',NULL,NULL,NULL,NULL,1,203.838833,-34.20578,0.125,NULL,46895015460,732734616,11448978,14.38),(111273,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111273,34.86,0.53,93.7,47944,NULL,NULL,NULL,'ESO 383- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111274,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111274,34.9,0.2,95.5,47944,74.4,NULL,NULL,'ESO 383- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111275,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111275,35.16,0.4,108,47944,NULL,NULL,'mean','ESO 383- G 031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111276,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111276,35.18,0.47,109,47944,NULL,NULL,'H','ESO 383- G 031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111277,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111277,35.31,0.46,116,47944,NULL,NULL,'J','ESO 383- G 031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111278,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111278,35.32,0.45,116,47944,NULL,NULL,'K','ESO 383- G 031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111279,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111279,37.64,0.09,338,47945,70,NULL,NULL,'2MASX J13352138+5921264',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000073,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,203.839125,59.35731,0.009,NULL,57388246818,896691356,14010802,17.6),(111280,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111280,37.8,0.46,363,47946,70,NULL,NULL,'2MASX J13352229+1532461',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,203.842917,15.54622,0,NULL,58836624614,919322259,14364410,17.8),(111281,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111281,37.25,0.33,281,47947,70,NULL,NULL,'2MASX J13352232+5444394',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,203.84325,54.74436,0,NULL,57291893476,895185835,13987278,17.3),(111282,'SNIa','2016-12-15 15:15:16','2016-12-16 11:20:28','1','SN 2000ca',NULL,111282,34.33,0.1,71.8,47948,74.2,NULL,'SALT 2','ESO 383- G 032',0.02362,'2010ApJ...716..712A',2010,1,0.9,NULL,'G',0.0002,NULL,'15.10',0.6,'(R:)Sbc:',NULL,NULL,NULL,NULL,1,203.8447083,-34.15958,0.121,NULL,46906351523,732911742,11451745,15.1),(111283,'SNIa','2016-12-15 15:15:16','2016-12-16 11:20:28','1','SN 2000ca',NULL,111283,34.5,0.03,77.6,47948,70,NULL,'SALT 2','ESO 383- G 032',0.02362,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111284,'SNIa','2016-12-15 15:15:16','2016-12-16 11:20:28','1','SN 2000ca',NULL,111284,34.78,0.1,88.3,47948,72,NULL,NULL,'ESO 383- G 032',0.02362,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111285,'SNIa','2016-12-15 15:15:16','2016-12-16 11:20:28','1','SN 2000ca',NULL,111285,34.79,0.06,88.7,47948,72,NULL,NULL,'ESO 383- G 032',0.02362,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111286,'SNIa','2016-12-15 15:15:16','2016-12-16 11:20:28','1','SN 2000ca',NULL,111286,34.89,0.03,92.9,47948,72,NULL,NULL,'ESO 383- G 032',0.02362,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111287,'SNIa','2016-12-15 15:15:16','2016-12-16 11:20:28','1','SN 2000ca',NULL,111287,34.87,0.05,94.3,47948,72,NULL,'M(H) = -18.317 mag','ESO 383- G 032',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111288,'SNIa','2016-12-15 15:15:16','2016-12-16 11:20:28','1','SN 2000ca',NULL,111288,34.93,0.09,94.7,47948,70,NULL,NULL,'ESO 383- G 032',0.02362,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111289,'SNIa','2016-12-15 15:15:16','2016-12-16 11:20:28','1','SN 2000ca',NULL,111289,34.96,0.11,95.9,47948,70,NULL,'SALT','ESO 383- G 032',0.02362,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111290,'SNIa','2016-12-15 15:15:16','2016-12-16 11:20:28','1','SN 2000ca',NULL,111290,34.91,0.08,95.9,47948,74.4,NULL,NULL,'ESO 383- G 032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111291,'SNIa','2016-12-15 15:15:16','2016-12-16 11:20:28','1','SN 2000ca',NULL,111291,35.01,0.16,98.3,47948,70,NULL,'SALT 2','ESO 383- G 032',0.02362,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111292,'SNIa','2016-12-15 15:15:16','2016-12-16 11:20:28','1','SN 2000ca',NULL,111292,35.03,0.19,99.1,47948,72,NULL,NULL,'ESO 383- G 032',0.02362,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111293,'SNIa','2016-12-15 15:15:16','2016-12-16 11:20:28','1','SN 2000ca',NULL,111293,35.07,0.06,101,47948,65,NULL,'SALT2','ESO 383- G 032',0.02362,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111294,'SNIa','2016-12-15 15:15:16','2016-12-16 11:20:28','1','SN 2000ca',NULL,111294,35.02,0.17,101,47948,70.8,NULL,NULL,'ESO 383- G 032',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111295,'SNIa','2016-12-15 15:15:16','2016-12-16 11:20:28','1','SN 2000ca',NULL,111295,35.07,0.16,101,47948,73.8,NULL,'SALT 2 (SNANA)','ESO 383- G 032',0.0234,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111296,'SNIa','2016-12-15 15:15:16','2016-12-16 11:20:28','1','SN 2000ca',NULL,111296,35.09,0.02,102,47948,72,NULL,NULL,'ESO 383- G 032',0.02362,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111297,'SNIa','2016-12-15 15:15:16','2016-12-16 11:20:28','1','SN 2000ca',NULL,111297,35.13,0.14,104,47948,65,NULL,'SALT','ESO 383- G 032',0.02362,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111298,'SNIa','2016-12-15 15:15:16','2016-12-16 11:20:28','1','SN 2000ca',NULL,111298,35.18,0.02,106,47948,65,NULL,'SALT','ESO 383- G 032',0.02362,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111299,'SNIa','2016-12-15 15:15:16','2016-12-16 11:20:28','1','SN 2000ca',NULL,111299,35.18,0.2,106,47948,65,NULL,'SALT2','ESO 383- G 032',0.02362,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111300,'SNIa','2016-12-15 15:15:16','2016-12-16 11:20:28','1','SN 2000ca',NULL,111300,35.18,0.16,106,47948,65,NULL,'MLCS17','ESO 383- G 032',0.02362,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111301,'SNIa','2016-12-15 15:15:16','2016-12-16 11:20:28','1','SN 2000ca',NULL,111301,35.25,0.06,107,47948,65,NULL,'MLCS2k2','ESO 383- G 032',0.02362,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111302,'SNIa','2016-12-15 15:15:16','2016-12-16 11:20:28','1','SN 2000ca',NULL,111302,35.25,0.06,109,47948,65,NULL,'MLCS2k2','ESO 383- G 032',0.02362,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111303,'SNIa','2016-12-15 15:15:16','2016-12-16 11:20:28','1','SN 2000ca',NULL,111303,35.26,0.15,110,47948,65,NULL,'MLCS31','ESO 383- G 032',0.02362,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111304,'SNIa','2016-12-15 15:15:16','2016-12-16 11:20:28','1','SN 2000ca',NULL,111304,35.27,0.05,111,47948,65,NULL,'MLCS2k2','ESO 383- G 032',0.02362,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111305,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111305,37.63,0.33,336,47949,70,NULL,NULL,'2MASX J13352278+0017456',NULL,'2015arXiv151105856S',2015,1,0.23,'The APM image includes a superposed star.','G',NULL,'FoF','17.04',0.21,'BrClG',NULL,NULL,NULL,NULL,1,203.844916667,0.29597,0.025,NULL,58388432991,912319265,14254988,17.04),(111306,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111306,36.28,0.52,181,47950,70,NULL,NULL,'ESO 324- G 040',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000103,NULL,'15.10',0.5,'S0',NULL,NULL,NULL,NULL,1,203.8472083,-40.07194,0.053,NULL,46971308876,733926701,11467604,15.1),(111307,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111307,36.9,0.46,240,47951,70,NULL,NULL,'2MASX J13352361+3414006',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.40',0.15,NULL,NULL,NULL,NULL,NULL,1,203.848333,34.23342,0,NULL,59174690623,924604540,14446945,18.4),(111308,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111308,37.61,0.46,332,47952,70,NULL,NULL,'2MASX J13352408+0244476',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000075,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,203.850333,2.74669,0.008,NULL,58399235282,912488051,14257625,17.6),(111309,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111309,37.63,0.19,336,47953,70,NULL,NULL,'2MASX J13352419+5022149',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000193,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,203.850625,50.37081,0,NULL,59208853534,925138336,14455286,17.5),(111310,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111310,36.13,0.46,168,47954,70,NULL,NULL,'IC 4300',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000093,NULL,'15.6g',0.45,'E4',NULL,NULL,NULL,NULL,1,203.855,33.41981,0,NULL,59188926505,924826976,14450421,15.6),(111311,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111311,38.26,0.33,449,47955,70,NULL,NULL,'2MASX J13352543+6150174',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000182,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,203.8557917,61.83811,0.037,NULL,57382242576,896597540,14009336,17.3),(111312,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111312,36.61,0.55,210,47956,70,NULL,NULL,'2MASX J13352536-1508092',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.77',0.4,NULL,NULL,NULL,NULL,NULL,1,203.855875,-15.13597,0.165,NULL,43785810372,684153287,10689895,16.77),(111313,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111313,38.31,0.46,460,47957,70,NULL,NULL,'SDSS J133525.46+041902.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,203.856125,4.31731,0.021,NULL,58396942074,912452219,14257065,18.1),(111314,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111314,37.63,0.19,336,47958,70,NULL,NULL,'2MASX J13352577+5026379',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000158,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,203.857375,50.44389,0,NULL,59208850438,925138288,14455285,18.4),(111315,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111315,37.82,0.46,367,47959,70,NULL,NULL,'2MASX J13352659+1647531',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,203.860875,16.79814,0,NULL,58828508485,919195445,14362428,17.2),(111316,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111316,35.61,0.17,132,47960,70,NULL,NULL,'CGCG 190-030',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000097,NULL,'15.1g',0.61,'E2',NULL,NULL,NULL,NULL,1,203.861917,33.72503,0,NULL,59188951165,924827361,14450427,15.1),(111317,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111317,37.31,0.46,289,47961,70,NULL,NULL,'2MASX J13352896+5937493',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000187,NULL,'16.1g',0.34,'E0',NULL,NULL,NULL,NULL,1,203.870417,59.63044,0.005,NULL,57388392092,896693626,14010837,16.1),(111318,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111318,35.25,0.46,112,47962,70,NULL,NULL,'2MASX J13352932+0804245',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00017,NULL,'16.1g',0.31,NULL,NULL,NULL,NULL,NULL,1,203.87225,8.07347,0,NULL,58425010802,912890793,14263918,16.1),(111319,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111319,37.28,0.15,286,47963,70,NULL,NULL,'2MASX J13352945+3558131',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000171,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,203.8727083,35.97028,0,NULL,59177124574,924642571,14447540,17.9),(111320,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111320,38.72,0.46,555,47964,70,NULL,NULL,'2MASX J13353101+5431173',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,203.879333333,54.52164,0,NULL,57291438700,895178729,13987167,18.1),(111321,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111321,37.64,0.09,338,47965,70,NULL,NULL,'2MASX J13353150+5911433',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000173,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,203.88125,59.19544,0.009,NULL,57388286426,896691975,14010812,18),(111322,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111322,37.99,0.23,395,47966,70,NULL,NULL,'2MASX J13353157-0123420',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,203.881583,-1.39514,0.053,NULL,43556840580,680575634,10633994,17.4),(111323,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111323,32.06,0.98,25.8,47967,NULL,NULL,'Malmquist cor.','NGC 5230',NULL,'2009ApJS..182..474S',2009,1,2.2,NULL,'G',0.00002,NULL,'12.77',1.9,'SA(s)c         HII','Possible field galaxy',NULL,NULL,NULL,1,203.882833,13.67617,0,NULL,58824866775,919138543,14361539,12.77),(111324,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111324,32.46,NULL,31,47967,NULL,NULL,'B','NGC 5230',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111325,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111325,32.64,0.75,33.7,47967,NULL,NULL,NULL,'NGC 5230',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111326,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111326,37.64,0.09,338,47968,70,NULL,NULL,'2MASX J13353415+5901583',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000067,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,203.8925,59.03292,0.013,NULL,57388095285,896688988,14010765,16.4),(111327,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111327,35.84,0.46,147,47969,70,NULL,NULL,'2MASX J13353518+4006401',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000073,NULL,'15.3g',0.5,'E/S0',NULL,NULL,NULL,NULL,1,203.896541667,40.11111,0,NULL,59315490185,926804534,14481320,15.3),(111328,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111328,37.27,0.33,285,47970,70,NULL,NULL,'2MASX J13353544+6354344',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000091,NULL,'17.7g',0.19,'AGN',NULL,NULL,NULL,NULL,1,203.8979583,63.90961,0.053,NULL,57867011471,904172054,14127688,17.7),(111329,'Tully est','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111329,31.24,0.8,17.7,47971,75,NULL,'B','UGC 08578',NULL,'1988NBGC.C....0000T',1988,1,0.9,'Salzer et al. (2002AJ....123.1292S) give z = 0.01.','G',0.000023,NULL,'15.37',0.3,'Sa             Sbrst',NULL,NULL,NULL,NULL,1,203.898333,29.21692,0.02,NULL,59134653499,923978960,14437171,15.37),(111330,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111330,34.99,0.49,99.5,47972,75,NULL,'IR','IC 4302',NULL,'2011yCatp016004901K',2011,1,1.48,NULL,'G',0.000015,NULL,'15.6g',0.24,'Sc',NULL,NULL,NULL,NULL,1,203.8997917,33.47958,0,NULL,59188748781,924824199,14450378,15.6),(111331,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111331,35.07,NULL,103,47972,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 4302',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111332,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111332,35.08,NULL,104,47972,NULL,NULL,'Dipole + Quadrupole','IC 4302',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111333,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111333,35.09,NULL,104,47972,NULL,NULL,NULL,'IC 4302',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111334,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111334,35.1,NULL,105,47972,NULL,NULL,'Dipole','IC 4302',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111335,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111335,35.22,0.4,111,47972,NULL,NULL,'Malmquist cor.','IC 4302',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111336,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111336,35.38,0.2,119,47972,74.4,NULL,NULL,'IC 4302',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111337,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111337,35.4,0.37,120,47972,NULL,NULL,NULL,'IC 4302',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111338,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111338,37.48,0.46,314,47973,70,NULL,NULL,'2MASX J13353839+2125478',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,203.91,21.42989,0,NULL,58800452213,918757065,14355579,18),(111339,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111339,37.28,0.15,286,47974,70,NULL,NULL,'2MASX J13354062+3600042',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000202,NULL,'15.7g',0.46,NULL,NULL,NULL,NULL,NULL,1,203.9192083,36.00131,0,NULL,59177062358,924641599,14447524,15.7),(111340,'IRAS','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111340,32.64,0.8,33.7,47975,75,NULL,'MAT, I','ESO 509- G 074',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.000023,NULL,'14.04',0.4,'S?             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,203.922375,-24.07381,0.217,NULL,43757153189,683705518,10682898,14.04),(111341,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111341,32.38,0.32,29.9,47975,85,NULL,'I, raw','ESO 509- G 074',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111342,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111342,32.41,0.32,30.4,47975,85,NULL,'I, inv','ESO 509- G 074',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111343,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111343,32.43,0.4,30.6,47975,75,NULL,NULL,'ESO 509- G 074',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111344,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111344,32.51,0.43,31.8,47975,75,NULL,'MAT, I, raw','ESO 509- G 074',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111345,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111345,32.55,0.46,32.3,47975,NULL,NULL,'J','ESO 509- G 074',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111346,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111346,32.59,0.47,33,47975,NULL,NULL,'H','ESO 509- G 074',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111347,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111347,32.66,0.45,34,47975,NULL,NULL,'K','ESO 509- G 074',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111348,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111348,32.69,0.43,34.5,47975,75,NULL,'MAT, I, inv','ESO 509- G 074',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111349,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111349,32.7,0.43,34.7,47975,75,NULL,'3.6 micron, color + selection bias corrected','ESO 509- G 074',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111350,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111350,32.72,0.43,34.9,47975,75,NULL,'3.6 micron, color corrected','ESO 509- G 074',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111351,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111351,32.74,0.49,35.3,47975,75,NULL,'IR','ESO 509- G 074',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111352,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111352,32.76,0.2,35.7,47975,74.4,NULL,NULL,'ESO 509- G 074',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111353,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111353,32.77,0.43,35.9,47975,75,NULL,'MAT, I, cor','ESO 509- G 074',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111354,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111354,32.9,0.4,38.1,47975,NULL,NULL,'mean','ESO 509- G 074',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111355,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111355,33.09,0.12,41.6,47975,NULL,NULL,NULL,'ESO 509- G 074',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111356,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111356,37.27,0.33,285,47976,70,NULL,NULL,'2MASX J13354191+6350413',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000077,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,203.924625,63.84469,0.053,NULL,57346125677,896033213,14000518,17.5),(111357,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111357,32.1,0.4,26.4,47977,75,NULL,'B','UGC 08588',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.00002,NULL,'15.4g',1.3,'Sm:','Dwarf, possible member',NULL,NULL,NULL,1,203.928041667,45.92958,0.007,NULL,59284736895,926324013,14473812,15.4),(111358,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111358,38.07,0.27,412,47978,70,NULL,NULL,'LCRS B133308.1-024120',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00013,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,203.929917,-2.944,0.041,NULL,43568752807,680761762,10636902,17),(111359,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111359,37.93,0.46,385,47979,70,NULL,NULL,'2MASX J13354379+1115565',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,203.932417,11.26578,0.009,NULL,58939081593,920923149,14389424,17.4),(111360,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111360,36.88,0.46,238,47980,70,NULL,NULL,'LCRS B133310.1-022923',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,203.9377083,-2.74472,0.061,NULL,43568774160,680762096,10636907,17.3),(111361,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111361,31.74,NULL,22.3,47981,72,NULL,NULL,'UGC 08575',NULL,'2014Ap.....57..457K',2014,1,2.43,NULL,'G',0.000002,NULL,'15.3g',0.33,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,203.9397083,8.96908,0,NULL,58424559477,912883741,14263808,15.3),(111362,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111362,31.8,0.4,22.9,47981,75,NULL,'B','UGC 08575',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111363,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111363,37.63,0.46,335,47982,70,NULL,NULL,'2MASX J13354565+6552303',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000086,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,203.9404583,65.87522,0.065,NULL,57881104439,904392256,14131129,17.3),(111364,'CMD','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'RN',111364,28.5,0.3,5.01,47983,NULL,NULL,NULL,'MESSIER 083 Dw1335-29',NULL,'2016AAS...22713625C',2016,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111365,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111365,37.48,0.46,313,47984,70,NULL,NULL,'2MASX J13354621+6201193',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,203.942375,62.02206,0.037,NULL,57381921373,896592521,14009258,17.5),(111366,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111366,37.49,0.27,315,47985,70,NULL,NULL,'2MASX J13354633+4726005',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000188,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,203.942958333,47.43358,0.017,NULL,59283837493,926309960,14473593,16.8),(111367,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111367,36.36,0.55,187,47986,70,NULL,NULL,'2MASX J13354632-4733375',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,203.943167,-47.56036,0.477,NULL,46949670489,733588601,11462321,16.6),(111368,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111368,38.28,0.46,452,47987,70,NULL,NULL,'2MASX J13354655+4215195',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,203.9442917,42.25531,0,NULL,59320854183,926888346,14482630,18.1),(111369,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111369,37.02,0.17,253,47988,70,NULL,NULL,'2MASX J13354706+4245505',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000111,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,203.9460417,42.76414,0,NULL,59320419720,926881558,14482524,16.2),(111370,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111370,37.83,0.33,367,47989,70,NULL,NULL,'2MASX J13354713+0526286',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000148,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,203.94625,5.44133,0.075,NULL,58439314776,913114293,14267410,17.4),(111371,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111371,37.64,0.09,338,47990,70,NULL,NULL,'2MASX J13354786+5908199',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000097,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,203.949333,59.13883,0.013,NULL,57388089859,896688904,14010764,16.5),(111372,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111372,37.64,0.09,338,47991,70,NULL,NULL,'2MASX J13354805+5916559',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,203.95025,59.28225,0.009,NULL,57388292397,896692068,14010813,17.8),(111373,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111373,36.32,0.46,183,47992,70,NULL,NULL,'2MASX J13354942+2846555',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000152,NULL,'16.6g',0.29,'E0',NULL,NULL,NULL,NULL,1,203.955916667,28.78214,0.018,NULL,59132713052,923948641,14436697,16.6),(111374,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111374,36.63,0.2,212,47993,74.4,NULL,NULL,'CGCG 073-046',NULL,'2013AJ....146...86T',2013,1,0.81,NULL,'G',0.000107,NULL,'15.4g',0.37,NULL,'Group member',NULL,NULL,NULL,1,203.9562917,13.41753,0,NULL,58821718343,919089349,14360771,15.4),(111375,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111375,37.02,0.17,253,47994,70,NULL,NULL,'2MASX J13354962+4240416',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000181,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,203.956917,42.67831,0,NULL,59320427984,926881687,14482526,16.5),(111376,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111376,36.31,0.52,183,47995,70,NULL,NULL,'2MASX J13354968-2913487',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.7b',NULL,'S0',NULL,NULL,NULL,NULL,1,203.957041667,-29.23022,0.129,NULL,46849530142,732023908,11437873,15.7),(111377,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111377,33.49,0.51,50,47996,70,NULL,NULL,'ESO 444- G 076',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00003,NULL,'14.31',0.8,'(R_1)SB(rl)0^+','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,203.957083,-30.38219,0.093,NULL,46847860970,731997827,11437466,14.31),(111378,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111378,37.28,0.15,286,47997,70,NULL,NULL,'2MASX J13355025+3551107',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000187,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,203.9595417,35.853,0,NULL,59177135895,924642748,14447542,17.3),(111379,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111379,37.54,0.46,322,47998,70,NULL,NULL,'2MASX J13355051+2928375',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00015,NULL,'16.9g',0.22,'E1',NULL,NULL,NULL,NULL,1,203.9605,29.47711,0.02,NULL,59134515035,923976797,14437137,16.9),(111380,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111380,38.07,0.27,412,47999,70,NULL,NULL,'LCRS B133316.5-024535',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,203.964666667,-3.0145,0.041,NULL,43568744564,680761633,10636900,17.9),(111381,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111381,38.07,0.27,412,48000,70,NULL,NULL,'LCRS B133318.6-022914',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,203.973125,-2.74217,0.061,NULL,43568772301,680762067,10636907,17.9),(111382,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111382,38.14,0.46,424,48001,70,NULL,NULL,'2MASX J13355367+2337518',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'18.45',NULL,NULL,NULL,NULL,NULL,NULL,1,203.9735417,23.63103,0,NULL,58789370157,918583908,14352873,18.45),(111383,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111383,36.56,0.33,205,48002,70,NULL,NULL,'2MASX J13355401+3644192',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000167,NULL,'15.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,203.975,36.73872,0,NULL,59174216956,924597139,14446830,15.8),(111384,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111384,37.2,0.33,276,48003,70,NULL,NULL,'2MASX J13355455+4129222',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00017,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,203.9775,41.48947,0,NULL,59313185936,926768530,14480758,16.2),(111385,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111385,31.68,0.69,21.7,48004,100,NULL,'mid-IR','NGC 5240',NULL,'2013ApJ...771...88L',2013,1,1.78,NULL,'G',0.000027,NULL,'13.6g',1,'SB(s)cd?',NULL,NULL,NULL,NULL,1,203.98,35.58825,0,NULL,59176997461,924640585,14447509,13.6),(111386,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111386,33.12,0.4,42.1,48004,NULL,NULL,'mean','NGC 5240',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111387,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111387,33.13,0.43,42.3,48004,75,NULL,'3.6 micron, color corrected','NGC 5240',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111388,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111388,33.17,0.43,43,48004,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5240',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111389,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111389,33.19,0.2,43.5,48004,74.4,NULL,NULL,'NGC 5240',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111390,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111390,33.42,0.57,48.2,48004,NULL,NULL,NULL,'NGC 5240',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111391,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111391,33.49,0.55,49.8,48004,NULL,NULL,'Malmquist cor.','NGC 5240',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111392,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111392,33.67,0.47,54.2,48004,NULL,NULL,'H','NGC 5240',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111393,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111393,33.73,0.46,55.7,48004,NULL,NULL,'J','NGC 5240',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111394,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111394,33.73,0.45,55.8,48004,NULL,NULL,'K','NGC 5240',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111395,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111395,38.19,0.21,434,48005,70,NULL,NULL,'SDSS J133556.12+545053.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000152,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,203.983833,54.84822,0,NULL,57291758868,895183732,13987245,18.4),(111396,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111396,37.64,0.09,338,48006,70,NULL,NULL,'2MASX J13355668+5913599',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00008,NULL,'16.0g',0.41,'AGN',NULL,NULL,NULL,NULL,1,203.986,59.23342,0.013,NULL,57388282297,896691910,14010811,16),(111397,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111397,36.14,0.61,169,48007,70,NULL,NULL,'2MASX J13355664-2055027',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.88',NULL,NULL,NULL,NULL,NULL,NULL,1,203.986083,-20.91744,0.293,NULL,43760741904,683761592,10683774,15.88),(111398,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111398,33.41,0.47,48.1,48008,NULL,NULL,'H','NGC 5220',NULL,'2007A&A...465...71T',2007,1,2.3,NULL,'G',0.00002,NULL,'13.11',0.7,'SAa pec sp     HII?',NULL,NULL,NULL,NULL,1,203.986125,-33.45381,0.129,NULL,46906758354,732918099,11451845,13.11),(111399,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111399,33.42,0.45,48.3,48008,NULL,NULL,'K','NGC 5220',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111400,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111400,33.53,0.46,50.7,48008,NULL,NULL,'J','NGC 5220',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111401,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111401,33.88,0.4,59.6,48008,NULL,NULL,'mean','NGC 5220',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111402,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111402,37.56,0.27,325,48009,70,NULL,NULL,'2MASX J13355690+3913472',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000175,NULL,'18.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,203.9872083,39.22981,0,NULL,59312655552,926760243,14480628,18.5),(111403,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111403,37.06,0.33,258,48010,70,NULL,NULL,'2MASX J13355714+4136162',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000103,NULL,'15.5g',0.49,'E0',NULL,NULL,NULL,NULL,1,203.988167,41.60472,0,NULL,59313113943,926767405,14480740,15.5),(111404,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111404,37.03,0.17,254,48011,70,NULL,NULL,'2MASX J13355730+3515307',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000175,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,203.98875,35.2585,0,NULL,59176989991,924640468,14447507,16.8),(111405,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111405,38.06,0.27,410,48012,70,NULL,NULL,'2MASX J13355797+6205264',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,203.9917083,62.09069,0.037,NULL,57381903753,896592246,14009253,17.4),(111406,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111406,35.61,0.17,132,48013,70,NULL,NULL,'IC 4305',NULL,'2015arXiv151105856S',2015,1,0.96,NULL,'G',0.000117,NULL,'14.4g',0.66,'E5','Group member',NULL,NULL,NULL,1,203.9932083,33.47392,0,NULL,59188758477,924824351,14450380,14.4),(111407,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111407,37.7,0.46,347,48014,70,NULL,NULL,'2MASX J13360004+0252435',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000079,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,204.0002917,2.87897,0.006,NULL,58398977756,912484027,14257562,17.4),(111408,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111408,35.61,0.17,132,48015,70,NULL,NULL,'MCG +06-30-057',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000107,NULL,'15.0g',0.5,NULL,NULL,NULL,NULL,NULL,1,204.001917,34.81797,0,NULL,59174643948,924603811,14446934,15),(111409,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111409,36.82,0.54,232,48016,70,NULL,NULL,'2MASX J13360059-0933579',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.29',NULL,NULL,NULL,NULL,NULL,NULL,1,204.0025417,-9.56622,0.069,NULL,43856850812,685263293,10707238,16.29),(111410,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111410,32.13,0.43,26.7,48017,75,NULL,'3.6 micron, color + selection bias corrected','IC 0902',NULL,'2014MNRAS.444..527S',2014,1,2.24,NULL,'G',0.00002,NULL,'14.0g',0.5,'Sb',NULL,NULL,NULL,NULL,1,204.005083,49.96083,0,NULL,59207941114,925124079,14455063,14),(111411,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111411,32.24,0.4,28.1,48017,NULL,NULL,'mean','IC 0902',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111412,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111412,32.27,0.43,28.4,48017,75,NULL,'3.6 micron, color corrected','IC 0902',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111413,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111413,32.27,0.4,28.5,48017,75,NULL,NULL,'IC 0902',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111414,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111414,32.4,0.2,30.2,48017,74.4,NULL,NULL,'IC 0902',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111415,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111415,32.53,0.46,32.1,48017,NULL,NULL,'Malmquist cor.','IC 0902',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111416,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111416,32.57,0.45,32.6,48017,NULL,NULL,NULL,'IC 0902',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111417,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111417,32.57,0.47,32.7,48017,NULL,NULL,'H','IC 0902',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111418,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111418,32.59,0.45,33,48017,NULL,NULL,'K','IC 0902',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111419,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111419,32.64,0.46,33.8,48017,NULL,NULL,'J','IC 0902',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111420,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111420,32.8,0.49,36.3,48017,75,NULL,'IR','IC 0902',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111421,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111421,34.72,0.36,87.9,48018,NULL,NULL,NULL,'NGC 5235',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.9',0.5,'SB',NULL,NULL,NULL,NULL,1,204.005875,6.58536,0.04,NULL,58423493857,912867091,14263548,14.9),(111422,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111422,34.76,0.2,89.5,48018,74.4,NULL,NULL,'NGC 5235',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111423,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111423,34.8,0.34,91.4,48018,NULL,NULL,'Malmquist cor.','NGC 5235',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111424,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111424,34.86,0.47,93.8,48018,NULL,NULL,'H','NGC 5235',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111425,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111425,34.96,0.4,98.3,48018,NULL,NULL,'mean','NGC 5235',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111426,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111426,34.99,0.46,99.6,48018,NULL,NULL,'J','NGC 5235',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111427,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111427,35.02,0.45,101,48018,NULL,NULL,'K','NGC 5235',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111428,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111428,37.64,0.09,338,48019,70,NULL,NULL,'2MASX J13360176+5913599',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000097,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,204.0074583,59.23325,0.013,NULL,57388282346,896691911,14010811,17.9),(111429,'D-Sigma','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111429,34.05,0.4,64.5,48020,75,NULL,'Edat, raw','IC 4293',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000133,NULL,'13.75',0.9,'SA0-',NULL,NULL,NULL,NULL,1,204.009417,-25.88231,0.257,NULL,43288038502,676375601,10568368,13.75),(111430,'D-Sigma','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111430,34.38,0.4,75.3,48020,75,NULL,'Edat, cor','IC 4293',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111431,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111431,34.1,0.4,66.2,48020,NULL,NULL,'mean','IC 4293',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111432,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111432,34.67,0.45,86,48020,NULL,NULL,'K','IC 4293',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111433,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111433,32.46,0.2,31.1,48021,74.4,NULL,NULL,'FGC 1642',NULL,'2013AJ....146...86T',2013,1,1.21,NULL,'G',0.000002,NULL,'17.33',0.13,'Sd',NULL,NULL,NULL,NULL,1,204.010833,8.18472,0,NULL,58425537367,912899021,14264047,17.33),(111434,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111434,32.54,0.91,32.2,48021,NULL,NULL,'Malmquist cor.','FGC 1642',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111435,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111435,32.69,NULL,34.5,48021,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1642',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111436,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111436,32.71,NULL,34.8,48021,72,NULL,NULL,'FGC 1642',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111437,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111437,32.72,NULL,35,48021,NULL,NULL,'Dipole + Quadrupole','FGC 1642',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111438,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111438,32.73,NULL,35.2,48021,NULL,NULL,'Dipole','FGC 1642',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111439,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111439,32.76,0.82,35.6,48021,NULL,NULL,NULL,'FGC 1642',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111440,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111440,32.82,NULL,36.6,48021,NULL,NULL,NULL,'FGC 1642',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111441,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111441,37.75,0.46,355,48022,70,NULL,NULL,'SDSS J133602.82+114329.9',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000152,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,204.01175,11.72497,0.032,NULL,58938559263,920914988,14389296,18.6),(111442,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111442,38.14,0.27,425,48023,70,NULL,NULL,'2MASX J13360303+6234044',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000176,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,204.012875,62.56792,0.029,NULL,57345080739,896016886,14000263,17.3),(111443,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111443,37.66,0.46,341,48024,70,NULL,NULL,'SDSS J133603.16+533225.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,204.0132083,53.54053,0,NULL,57278931968,894983312,13984114,17.9),(111444,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111444,37.02,0.17,253,48025,70,NULL,NULL,'2MASX J13360404+4239416',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000162,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,204.016958333,42.66158,0,NULL,59320396710,926881198,14482518,16.7),(111445,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111445,35.97,0.53,157,48026,70,NULL,NULL,'2MASX J13360455-2214253',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.96',NULL,NULL,NULL,NULL,NULL,NULL,1,204.019,-22.24042,0.253,NULL,43771701088,683932829,10686450,15.96),(111446,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111446,37.64,0.09,338,48027,70,NULL,NULL,'2MASX J13360450+5848379',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000177,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,204.019125,58.81056,0.013,NULL,57386731521,896667680,14010432,17.4),(111447,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,NULL,111447,37.45,0.71,310,48028,70,NULL,NULL,'2MASX J13360488-1616250',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.20',NULL,NULL,NULL,NULL,NULL,NULL,1,204.020375,-16.27383,0.221,NULL,43781684600,684088821,10688887,16.2),(111448,'FP','2016-12-15 15:15:16','2016-12-16 11:20:28','1',NULL,'R',111448,37.22,0.46,278,48029,70,NULL,NULL,'2MASX J13360561+4049272',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000177,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,204.023333,40.82422,0,NULL,59313042927,926766295,14480723,17),(111449,'BCG','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111449,37.61,0.35,311,48030,60,NULL,NULL,'ABELL 1767',0.0712,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',0.000397,NULL,NULL,NULL,'II     [BM]',NULL,NULL,NULL,NULL,1,204.025417,59.20778,0.013,NULL,57388279235,896691863,14010810,NULL),(111450,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111450,37.06,0.33,258,48031,70,NULL,NULL,'2MASX J13360644+4122312',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000155,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,204.026875,41.37531,0,NULL,59313218325,926769036,14480766,17.2),(111451,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111451,35.06,NULL,103,48032,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08590',NULL,'2010Ap&SS.325..163P',2010,1,1.43,NULL,'G',0.00006,NULL,'16.0g',0.19,'Sd',NULL,NULL,NULL,NULL,1,204.0277083,37.08806,0,NULL,59173327993,924583249,14446613,16),(111452,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111452,35.07,NULL,103,48032,NULL,NULL,'Dipole + Quadrupole','UGC 08590',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111453,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111453,35.08,NULL,104,48032,NULL,NULL,'Dipole','UGC 08590',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111454,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111454,35.09,NULL,104,48032,NULL,NULL,NULL,'UGC 08590',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111455,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111455,35.29,0.47,114,48032,NULL,NULL,'Malmquist cor.','UGC 08590',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111456,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111456,35.36,0.49,118,48032,75,NULL,'IR','UGC 08590',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111457,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111457,35.54,0.42,129,48032,NULL,NULL,NULL,'UGC 08590',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111458,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111458,35.59,0.2,131,48032,74.4,NULL,NULL,'UGC 08590',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111459,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111459,38.19,0.21,434,48033,70,NULL,NULL,'SDSS J133606.81+545140.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000132,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,204.028375,54.86131,0,NULL,57291758232,895183722,13987245,18.4),(111460,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111460,37.97,0.46,392,48034,70,NULL,NULL,'2MASX J13360720+4522176',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,204.029958333,45.37156,0,NULL,59317526147,926836346,14481817,17.5),(111461,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111461,33.96,0.46,62.1,48035,70,NULL,NULL,'NGC 5250',NULL,'2015arXiv151105856S',2015,1,1.3,NULL,'G',0.000103,NULL,'13.6g',0.97,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,204.0305417,51.23581,0,NULL,59210113073,925158016,14455594,13.6),(111462,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111462,34.27,0.4,71.5,48035,NULL,NULL,'mean','NGC 5250',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111463,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111463,34.36,0.45,74.3,48035,NULL,NULL,'K','NGC 5250',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111464,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111464,37.02,0.17,253,48036,70,NULL,NULL,'2MASX J13360731+4243126',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000161,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,204.03075,42.72008,0,NULL,59320390799,926881106,14482517,16.5),(111465,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111465,37.13,0.46,267,48037,70,NULL,NULL,'2MASX J13360814+5911359',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000077,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,204.03425,59.19331,0.013,NULL,57388279626,896691869,14010810,16.5),(111466,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111466,34.56,0.46,81.8,48038,70,NULL,NULL,'NGC 5232',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000097,NULL,'13.33',1.4,'SA(rs)0/a:    blazar',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,204.034416667,-8.49772,0.069,NULL,43580088455,680938882,10639670,13.33),(111467,'BCG','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111467,37.61,0.35,311,48039,60,NULL,'ABELL 1767, BCG','MCG +10-19-096',0.0712,'1980ApJ...241..486H',1980,1,0.5,NULL,'G',0.000117,NULL,'16.11',0.45,'cD;BrClG','Brightest group member',NULL,NULL,NULL,1,204.0347083,59.20639,0.013,NULL,57388279711,896691870,14010810,16.11),(111468,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111468,36.52,0.46,202,48040,70,NULL,NULL,'2MASX J13360830+0622396',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.91',0.21,NULL,NULL,NULL,NULL,NULL,1,204.0347917,6.37764,0.064,NULL,58423419551,912865930,14263530,17.91),(111469,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111469,38.17,0.23,431,48041,70,NULL,NULL,'SDSS J133608.35+624355.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000073,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,204.034833333,62.732,0.029,NULL,57345307692,896020432,14000319,18.4),(111470,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111470,37.39,0.46,300,48042,70,NULL,NULL,'2MASX J13360833+3850002',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000164,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,204.034875,38.83336,0,NULL,59312609441,926759522,14480617,16.6),(111471,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111471,37.92,0.27,384,48043,70,NULL,NULL,'2MASX J13360849+2926438',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000178,NULL,'16.5g',0.36,'E0',NULL,NULL,NULL,NULL,1,204.035458333,29.44539,0.02,NULL,59134563817,923977559,14437149,16.5),(111472,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111472,37.71,0.33,349,48044,70,NULL,NULL,'SDSS J133609.32+560308.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000151,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,204.038875,56.05231,0,NULL,57289986763,895156043,13986813,18.4),(111473,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111473,37.64,0.09,338,48045,70,NULL,NULL,'2MASX J13361217+5909239',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000154,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,204.050667,59.15678,0.013,NULL,57388063802,896688496,14010757,18.3),(111474,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111474,34.74,0.52,88.8,48046,70,NULL,NULL,'MCG -01-35-004',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00004,NULL,'15.05',0.4,'Sb',NULL,NULL,NULL,NULL,1,204.051333,-4.98003,0.029,NULL,43558288879,680598263,10634347,15.05),(111475,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111475,36.08,0.57,164,48047,70,NULL,NULL,'2MASX J13361248-4954104',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,204.052083,-49.90283,0.601,NULL,46810705604,731417275,11428394,15.4),(111476,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111476,37.77,0.46,358,48048,70,NULL,NULL,'2MASX J13361260+4452526',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00021,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,204.052417,44.88111,0,NULL,59317698874,926839044,14481860,16.6),(111477,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111477,37.83,0.33,367,48049,70,NULL,NULL,'SDSS J133613.13+052648.8',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,204.05475,5.44692,0.046,NULL,58439308094,913114188,14267409,18),(111478,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111478,37.56,0.27,325,48050,70,NULL,NULL,'2MASX J13361313+3908111',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000175,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,204.05475,39.13653,0,NULL,59312601592,926759399,14480615,17),(111479,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111479,37.49,0.27,315,48051,70,NULL,NULL,'SDSS J133613.61+472744.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000174,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,204.05675,47.46239,0.017,NULL,59283721921,926308155,14473564,18.4),(111480,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111480,37.64,0.09,338,48052,70,NULL,NULL,'2MASXi J1336146+590554',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000113,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,204.060875,59.09839,0.013,NULL,57388098740,896689042,14010766,17.5),(111481,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111481,33.44,0.49,48.7,48053,75,NULL,'IR','NGC 5243',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000087,NULL,'14.11',0.4,'S','Field galaxy',NULL,NULL,NULL,1,204.0622917,38.34392,0,NULL,59311675847,926744935,14480389,14.11),(111482,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111482,38.19,0.46,435,48054,70,NULL,NULL,'2MASX J13361489+2318216',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,204.062125,23.30608,0,NULL,58788822525,918575351,14352739,17.6),(111483,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111483,37.16,0.88,271,48055,70,NULL,NULL,'2MFGC 10966',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.0001,NULL,'15.54',NULL,NULL,NULL,NULL,NULL,NULL,1,204.062333,-12.21333,0.153,NULL,43990098342,687345286,10739770,15.54),(111484,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111484,38.17,0.23,431,48056,70,NULL,NULL,'2MASX J13361503+6259355',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000101,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,204.062333,62.99314,0.065,NULL,57345191054,896018610,14000290,17.9),(111485,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111485,36.94,0.6,244,48057,70,NULL,NULL,'2MASX J13361524-3653445',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.17',0.4,NULL,NULL,NULL,NULL,NULL,1,204.063625,-36.89567,0.201,NULL,46893199756,732706246,11448535,15.17),(111486,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111486,32.92,0.4,38.4,48058,75,NULL,'B','UGC 08597',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.000037,NULL,'14.16',1.3,'SB(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,204.0639583,46.19953,0.033,NULL,59284732828,926323950,14473811,14.16),(111487,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111487,36.29,0.46,181,48059,70,NULL,NULL,'2MASX J13361591+3514407',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00016,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,204.066208333,35.24464,0,NULL,59177241477,924644398,14447568,16.4),(111488,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111488,37.56,0.27,325,48060,70,NULL,NULL,'2MASX J13361651+3910525',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000198,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,204.068708333,39.18139,0,NULL,59312588255,926759191,14480612,16.4),(111489,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111489,37.12,0.46,265,48061,70,NULL,NULL,'2MASX J13361795+6020095',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,204.074833333,60.33606,0.005,NULL,57391962351,896749411,14011709,17.9),(111490,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111490,37.71,0.33,349,48062,70,NULL,NULL,'2MASX J13361877+5609109',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000205,NULL,'16.1g',0.34,NULL,NULL,NULL,NULL,NULL,1,204.078125,56.153,0,NULL,57289977092,895155892,13986810,16.1),(111491,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111491,37.49,0.27,315,48063,70,NULL,NULL,'2MASX J13361876+4717461',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000181,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,204.078333,47.29608,0.017,NULL,59283708706,926307948,14473561,16.8),(111492,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111492,37.32,0.46,291,48064,70,NULL,NULL,'2MASX J13361905+3136437',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.1g',0.25,'E2',NULL,NULL,NULL,NULL,1,204.079417,31.61233,0,NULL,59178829655,924669213,14447956,17.1),(111493,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111493,37.64,0.09,338,48065,70,NULL,NULL,'SDSS J133619.10+591728.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,204.079625,59.29117,0.013,NULL,57388276049,896691813,14010809,18.6),(111494,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111494,35,0.55,100,48066,NULL,NULL,'Malmquist cor.','IC 4306',NULL,'2009ApJS..182..474S',2009,1,1.22,NULL,'G',0.000173,NULL,'15.2g',0.36,'S01','Group member',NULL,NULL,NULL,1,204.081833,33.42344,0,NULL,59188764653,924824447,14450381,15.2),(111495,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111495,35.18,0.51,109,48066,NULL,NULL,NULL,'IC 4306',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111496,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111496,35.22,0.2,111,48066,74.4,NULL,NULL,'IC 4306',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111497,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111497,34.93,0.46,96.8,48067,70,NULL,NULL,'CGCG 045-039',NULL,'2015arXiv151105856S',2015,1,1.02,'MCG declination is +10 arcmin in error.','G',0.000105,NULL,'14.2g',0.86,'E0',NULL,NULL,NULL,NULL,1,204.0882917,3.33086,0.014,NULL,58394429037,912412953,14256452,14.2),(111498,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111498,38.55,0.46,512,48068,70,NULL,NULL,'2MASX J13362128+2327186',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,204.088708333,23.45517,0,NULL,58789390681,918584229,14352878,17.3),(111499,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111499,36.31,0.46,183,48069,70,NULL,NULL,'2MASX J13362191+2415227',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,204.091333,24.25639,0,NULL,58655647344,916494489,14320226,16.7),(111500,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111500,38.06,0.46,410,48070,70,NULL,NULL,'SDSS J133621.98+213716.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.73',0.15,NULL,NULL,NULL,NULL,NULL,1,204.091583,21.62133,0,NULL,58803842458,918810038,14356406,18.73),(111501,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111501,36.56,0.33,205,48071,70,NULL,NULL,'2MASX J13362204+3636155',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.66',0.21,NULL,NULL,NULL,NULL,NULL,1,204.091667,36.60428,0,NULL,59174243217,924597550,14446836,17.66),(111502,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111502,37.02,0.17,253,48072,70,NULL,NULL,'2MASX J13362394+4246281',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000196,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,204.09975,42.77444,0,NULL,59320390365,926881099,14482517,16.3),(111503,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111503,36.75,0.46,224,48073,70,NULL,NULL,'2MASX J13362493-0007191',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000078,NULL,'16.5g',0.32,'S0',NULL,NULL,NULL,NULL,1,204.1039583,-0.12197,0.009,NULL,43556055482,680563366,10633802,16.5),(111504,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111504,37.64,0.09,338,48074,70,NULL,NULL,'2MASX J13362491+5855578',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00009,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,204.1039583,58.93275,0.013,NULL,57388040461,896688132,14010752,16.6),(111505,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111505,37.86,0.46,374,48075,70,NULL,NULL,'2MASX J13362606+5410008',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000167,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,204.108458333,54.16686,0,NULL,57293205964,895206343,13987599,18.1),(111506,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111506,37.23,0.46,280,48076,70,NULL,NULL,'LCRS B133351.7-022314',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,204.11075,-2.64186,0.077,NULL,43568800060,680762500,10636914,17.6),(111507,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111507,38.19,0.21,434,48077,70,NULL,NULL,'2MASX J13362703+5453538',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000185,NULL,'15.9g',0.43,'BrClG',NULL,NULL,NULL,NULL,1,204.112375,54.89828,0,NULL,57291766970,895183858,13987247,15.9),(111508,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111508,36.92,0.46,242,48078,70,NULL,NULL,'SDSS J133627.52+613150.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000141,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,204.114708333,61.53081,0,NULL,57382205397,896596959,14009327,17.5),(111509,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111509,38.06,0.27,410,48079,70,NULL,NULL,'2MASX J13362774+6204464',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000166,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,204.115875,62.07956,0.037,NULL,57381901551,896592211,14009253,16.9),(111510,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111510,35.5,0.57,126,48080,70,NULL,NULL,'MCG -03-35-006',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.5',0.5,NULL,NULL,NULL,NULL,NULL,1,204.116375,-17.26781,0.273,NULL,43784226379,684128537,10689508,15.5),(111511,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111511,38.17,0.23,431,48081,70,NULL,NULL,'2MASX J13362870+6301314',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000093,NULL,'16.6g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,204.11975,63.02536,0.065,NULL,57345317873,896020591,14000321,16.6),(111512,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111512,37.24,0.46,281,48082,70,NULL,NULL,'2MASX J13362932+2608022',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000165,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,204.122041667,26.13383,0.008,NULL,58655157763,916486840,14320106,17.6),(111513,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111513,37.83,0.46,369,48083,70,NULL,NULL,'LCRS B133354.9-023351',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,204.1244583,-2.81858,0.077,NULL,43568843170,680763174,10636924,17.2),(111514,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111514,38.1,0.46,416,48084,70,NULL,NULL,'2MASX J13363041+3421160',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,204.126625,34.35444,0,NULL,59174700866,924604701,14446948,18.3),(111515,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111515,36.69,0.27,218,48085,70,NULL,NULL,'2MASX J13363049+4324172',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000208,NULL,'15.5g',0.54,'E0',NULL,NULL,NULL,NULL,1,204.127167,43.40481,0,NULL,59320317273,926879957,14482499,15.5),(111516,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111516,38.28,0.46,452,48086,70,NULL,NULL,'SDSS J133630.56+383101.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000144,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,204.127333,38.51706,0,NULL,59311888820,926748262,14480441,18.6),(111517,'TRGB','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111517,28.53,0.1,5.08,48087,NULL,NULL,NULL,'UGCA 365',NULL,'2012A&A...540A..49M',2012,1,1.2,NULL,'G',0.000003,NULL,'15.43',0.5,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,204.129625,-29.23489,0.129,NULL,46849551381,732024240,11437878,15.43),(111518,'TRGB','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111518,28.57,NULL,5.18,48087,NULL,NULL,NULL,'UGCA 365',NULL,'2007AJ....133..504K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111519,'TRGB','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111519,28.65,0.03,5.37,48087,NULL,NULL,'I','UGCA 365',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111520,'TRGB','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111520,28.67,0.1,5.42,48087,74.4,NULL,NULL,'UGCA 365',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111521,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111521,36.58,0.61,207,48088,70,NULL,NULL,'IC 4294',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000133,NULL,'15.59',0.5,'Sa-b',NULL,NULL,NULL,NULL,1,204.130125,-28.78114,0.085,NULL,46849016136,732015877,11437748,15.59),(111522,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111522,38,0.46,399,48089,70,NULL,NULL,'SDSS J133631.60+183325.8',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,204.1317083,18.55719,0,NULL,58842596407,919415568,14365868,17.2),(111523,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111523,38,0.46,397,48090,70,NULL,NULL,'2MASX J13363175+4336072',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000164,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,204.132333333,43.602,0,NULL,59318995277,926859301,14482176,17.2),(111524,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111524,37.64,0.09,338,48091,70,NULL,NULL,'2MASX J13363324+5918024',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,204.138458333,59.30078,0.013,NULL,57388148674,896689823,14010778,18),(111525,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111525,37.28,0.15,286,48092,70,NULL,NULL,'2MASX J13363328+3558496',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000174,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,204.138583,35.98058,0,NULL,59177100584,924642196,14447534,17.5),(111526,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111526,33.6,0.49,52.5,48093,75,NULL,'IR','IC 4295',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.08',0.4,'Sb',NULL,NULL,NULL,NULL,1,204.143583,-29.08944,0.129,NULL,46849576636,732024634,11437884,15.08),(111527,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111527,34.06,0.09,65,48093,NULL,NULL,NULL,'IC 4295',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111528,'IRAS','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111528,34.77,0.8,90.1,48094,75,NULL,'MAT, I','IC 4298',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'13.39',0.7,'(R\')SA(s)bc',NULL,NULL,NULL,NULL,1,204.144708333,-26.55386,0.257,NULL,43287556417,676368069,10568251,13.39),(111529,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111529,34.6,0.43,83.1,48094,75,NULL,'MAT, I, raw','IC 4298',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111530,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111530,34.68,0.32,86.1,48094,85,NULL,'I, raw','IC 4298',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111531,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111531,34.75,0.32,89.1,48094,85,NULL,'I, inv','IC 4298',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111532,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111532,34.77,0.43,90.1,48094,NULL,NULL,'Malmquist cor.','IC 4298',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111533,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111533,34.87,0.43,94.2,48094,75,NULL,'MAT, I, cor','IC 4298',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111534,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111534,34.91,0.43,96,48094,75,NULL,'MAT, I, inv','IC 4298',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111535,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111535,34.94,0.47,97.3,48094,NULL,NULL,'H','IC 4298',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111536,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111536,34.96,0.39,98.1,48094,NULL,NULL,NULL,'IC 4298',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111537,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111537,34.98,0.45,99.3,48094,NULL,NULL,'K','IC 4298',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111538,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111538,34.99,0.46,99.7,48094,NULL,NULL,'J','IC 4298',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111539,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111539,35,0.2,100,48094,74.4,NULL,NULL,'IC 4298',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111540,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111540,35.04,0.4,102,48094,NULL,NULL,'mean','IC 4298',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111541,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111541,36.69,0.27,218,48095,70,NULL,NULL,'2MASX J13363535+4325342',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,204.14725,43.42619,0,NULL,59320317044,926879953,14482499,16.9),(111542,'TRGB','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111542,28.35,NULL,4.68,48096,NULL,NULL,NULL,'LEDA 166170',NULL,'2002A&A...385...21K',2002,1,6,NULL,'G',NULL,NULL,'14.3',2.5,'dwarf Irr',NULL,NULL,NULL,NULL,1,204.147833333,-29.57144,0.137,NULL,46847566336,731993224,11437394,14.3),(111543,'TRGB','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111543,28.5,0.1,5.01,48096,74.4,NULL,NULL,'LEDA 166170',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111544,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111544,28.36,0.38,4.7,48096,73,NULL,'opt','LEDA 166170',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111545,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111545,37.51,0.46,318,48097,70,NULL,NULL,'2MASX J13363543+5819134',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000184,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,204.1479583,58.32044,0.013,NULL,57265450623,894772665,13980822,17.2),(111546,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111546,34.91,0.49,95.7,48098,75,NULL,'IR','CGCG 045-042',NULL,'2011yCatp016004901K',2011,1,0.63,NULL,'G',0.000013,NULL,'16.60',0.16,NULL,NULL,NULL,NULL,NULL,1,204.148917,8.19342,0,NULL,58425517180,912898705,14264042,16.6),(111547,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111547,34.98,0.32,99,48098,NULL,NULL,'Malmquist cor.','CGCG 045-042',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111548,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111548,35.21,0.29,110,48098,NULL,NULL,NULL,'CGCG 045-042',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111549,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111549,35.25,0.2,112,48098,74.4,NULL,NULL,'CGCG 045-042',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111550,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111550,37.46,0.46,311,48099,70,NULL,NULL,'2MASX J13363569+0313265',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000072,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,204.148833,3.22397,0.014,NULL,58394439885,912413123,14256455,17.5),(111551,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111551,37.97,0.33,392,48100,70,NULL,NULL,'2MASX J13363583+1605588',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.41',0.15,NULL,NULL,NULL,NULL,NULL,1,204.149333,16.09953,0,NULL,58827864922,919185389,14362271,18.41),(111552,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111552,35.75,0.46,141,48101,70,NULL,NULL,'IC 4307',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000087,NULL,'15.05',0.7,'S0?','Field galaxy',NULL,NULL,NULL,1,204.150708333,27.24219,0,NULL,59136591757,924009246,14437644,15.05),(111553,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111553,37.89,0.46,379,48102,70,NULL,NULL,'2MASX J13363636+0320285',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000088,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,204.151667,3.34117,0.021,NULL,58396280503,912441882,14256904,16.9),(111554,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111554,35.95,0.38,155,48103,NULL,NULL,'Malmquist cor.','ESO 577- G 012',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.44',0.2,'S...',NULL,NULL,NULL,NULL,1,204.152625,-18.40331,0.281,NULL,43814215291,684597113,10696829,16.44),(111555,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111555,36.19,0.34,173,48103,NULL,NULL,NULL,'ESO 577- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111556,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111556,36.23,0.2,176,48103,74.4,NULL,NULL,'ESO 577- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111557,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111557,36.08,0.46,165,48104,70,NULL,NULL,'2MASX J13363670+6126224',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000191,NULL,'15.5g',0.55,'E0',NULL,NULL,NULL,NULL,1,204.1529583,61.43953,0,NULL,57382154928,896596170,14009315,15.5),(111558,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111558,36,0.46,159,48105,70,NULL,NULL,'2MASX J13363714+5020013',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000172,NULL,'16.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,204.154875,50.33369,0,NULL,59208788170,925137315,14455270,16.2),(111559,'GCLF','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111559,34.01,0.25,63.4,48106,NULL,NULL,'IC 4296','ABELL 3565',NULL,'1998ApJ...499..577L',1998,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I      [BM];IR [A]',NULL,NULL,NULL,NULL,1,204.161667,-33.95833,0.117,NULL,46906414934,732912733,11451761,NULL),(111560,'SBF','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111560,33.47,0.13,49.4,48106,NULL,NULL,'IC 4296','ABELL 3565',NULL,'1998ApJ...499..577L',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111561,'SBF','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111561,33.77,0.17,56.8,48106,NULL,NULL,'HST KP Calibrated, F814W','ABELL 3565',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111562,'GCLF','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111562,33.97,0.16,62.2,48107,NULL,NULL,NULL,'IC 4296',NULL,'2002ApJ...567..294O',2002,1,3.4,NULL,'G',0.000033,NULL,'11.61',3.2,'E;RLG;BrClG    LINER','Group member, radial-velocity confirmed',NULL,'radio jet','Flat-Spectrum Radio Source',1,204.162625,-33.96583,0.117,NULL,46906414967,732912733,11451761,11.61),(111563,'GCLF','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111563,34.01,0.25,63.4,48107,NULL,NULL,NULL,'IC 4296',NULL,'1998ApJ...499..577L',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111564,'SBF','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111564,33.17,0.24,43.1,48107,NULL,NULL,NULL,'IC 4296',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111565,'SBF','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111565,33.32,0.24,46,48107,NULL,NULL,'Malmquist cor.','IC 4296',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111566,'SBF','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111566,33.44,0.17,48.8,48107,NULL,NULL,'K','IC 4296',NULL,'2001A&A...371..779M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111567,'SBF','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111567,33.44,0.17,49,48107,NULL,NULL,'I','IC 4296',NULL,'2000A&A...361...68M',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111568,'SBF','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111568,33.47,0.13,49.4,48107,NULL,NULL,'I','IC 4296',NULL,'1998ApJ...499..577L',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111569,'SBF','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111569,33.53,0.16,50.8,48107,NULL,NULL,'I','IC 4296',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111570,'SBF','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111570,33.69,0.16,54.7,48107,NULL,NULL,NULL,'IC 4296',NULL,'2001ApJ...550..503J',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111571,'SBF','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111571,33.77,0.17,56.8,48107,NULL,NULL,'HST KP Calibrated, F814W','IC 4296',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111572,'D-Sigma','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111572,33,0.4,39.9,48107,75,NULL,'Edat, raw','IC 4296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111573,'D-Sigma','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111573,33.23,0.4,44.3,48107,75,NULL,'Edat, cor','IC 4296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111574,'Faber-Jackson','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111574,32.05,0.37,25.7,48107,95,NULL,'Weighted Mean','IC 4296',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111575,'Faber-Jackson','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111575,32.48,0.46,31.3,48107,95,NULL,'Michard 1979a','IC 4296',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111576,'Faber-Jackson','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111576,32.88,0.63,37.7,48107,95,NULL,'Michard 1979b, c','IC 4296',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111577,'Faber-Jackson','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111577,32.91,0.81,38.2,48107,55,NULL,'Visvanathan & Sandage 1979','IC 4296',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111578,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111578,33.32,0.41,46.1,48107,NULL,NULL,NULL,'IC 4296',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111579,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111579,33.57,0.41,51.8,48107,NULL,NULL,'Malmquist cor.','IC 4296',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111580,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111580,33.59,0.45,52.2,48107,NULL,NULL,'K','IC 4296',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111581,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111581,33.69,0.4,54.7,48107,NULL,NULL,'mean','IC 4296',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111582,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111582,37.71,0.46,348,48108,70,NULL,NULL,'2MASX J13363962+2522152',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,204.1650417,25.37094,0,NULL,58656465142,916507267,14320426,17.7),(111583,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111583,37.39,0.23,300,48109,70,NULL,NULL,'2MASX J13363975+2459072',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,204.165541667,24.98544,0,NULL,58656370964,916505796,14320403,17.6),(111584,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111584,37.58,0.46,328,48110,70,NULL,NULL,'2MASX J13363985+1959400',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,204.166167,19.99436,0,NULL,58798211106,918722048,14355032,NULL),(111585,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111585,34.28,0.49,71.8,48111,75,NULL,'IR','UGC 08598',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.000033,NULL,'14.94',0.2,'Sbc','Isolated galaxy',NULL,NULL,NULL,1,204.16975,20.20014,0,NULL,58798232015,918722375,14355037,14.94),(111586,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111586,34.47,0.4,78.3,48111,NULL,NULL,'mean','UGC 08598',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111587,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111587,34.65,0.47,85.1,48111,NULL,NULL,'H','UGC 08598',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111588,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111588,34.72,0.46,88,48111,NULL,NULL,'J','UGC 08598',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111589,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111589,34.83,0.45,92.3,48111,NULL,NULL,'K','UGC 08598',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111590,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111590,37.97,0.33,392,48112,70,NULL,NULL,'2MASX J13364118+1605438',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,204.1715,16.09553,0,NULL,58827864720,919185386,14362271,17.8),(111591,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111591,36.76,0.33,224,48113,70,NULL,NULL,'LCRS B133406.2-031704',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00011,NULL,'16.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,204.172917,-3.53897,0.033,NULL,43561246172,680644471,10635069,16.4),(111592,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111592,38.06,0.46,410,48114,70,NULL,NULL,'SDSS J133642.08+522927.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000121,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,204.175333333,52.49089,0.023,NULL,59209352725,925146136,14455408,18.3),(111593,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111593,38.19,0.21,434,48115,70,NULL,NULL,'2MASX J13364213+5458295',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,204.175333333,54.97506,0,NULL,57291725915,895183217,13987237,18.2),(111594,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111594,36.76,0.33,224,48116,70,NULL,NULL,'2MASX J13364275+3912186',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000168,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,204.178125,39.20508,0,NULL,59312093214,926751456,14480491,16.4),(111595,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111595,37.33,0.46,292,48117,70,NULL,NULL,'2MASX J13364277+6249113',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000073,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,204.178208333,62.81983,0.029,NULL,57345250044,896019531,14000305,17.3),(111596,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111596,37.39,0.23,300,48118,70,NULL,NULL,'2MASX J13364298+2453472',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.55',0.2,NULL,NULL,NULL,NULL,NULL,1,204.179167,24.89656,0,NULL,58655901235,916498456,14320288,17.55),(111597,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111597,30.52,NULL,12.7,48119,72,NULL,NULL,'CGCG 073-051',NULL,'2014Ap.....57..457K',2014,1,0.71,NULL,'G',0.000007,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,204.182625,8.54689,0,NULL,58424782725,912887230,14263862,16.4),(111598,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111598,37.39,0.23,300,48120,70,NULL,NULL,'2MASX J13364394+2452332',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.55',0.19,NULL,'Field galaxy',NULL,NULL,NULL,1,204.183167,24.876,0,NULL,58655903416,916498490,14320288,17.55),(111599,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111599,37.39,0.23,300,48121,70,NULL,NULL,'2MASX J13364424+2458472',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000117,NULL,'17.42',0.34,'Elliptical','Field galaxy',NULL,NULL,NULL,1,204.184417,24.97992,0,NULL,58656374528,916505852,14320403,17.42),(111600,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111600,37.75,0.46,355,48122,70,NULL,NULL,'2MASX J13364522+4810543',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,204.188417,48.18183,0,NULL,59284306681,926317291,14473707,17.3),(111601,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111601,33.18,0.47,43.2,48123,70,NULL,NULL,'MCG -03-35-009',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000097,NULL,'14.45',0.5,NULL,NULL,NULL,NULL,NULL,1,204.1889583,-16.94839,0.229,NULL,43784165465,684127585,10689493,14.45),(111602,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111602,36.63,0.6,212,48124,70,NULL,NULL,'2MASX J13364598-4152375',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.7I',0.3,NULL,NULL,NULL,NULL,NULL,1,204.1915,-41.87714,0.369,NULL,46972460934,733944702,11467885,14.7),(111603,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111603,38.14,0.27,425,48125,70,NULL,NULL,'2MASX J13364636+6229003',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000152,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,204.1932917,62.48336,0.029,NULL,57378376567,896537133,14008392,16.9),(111604,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111604,38.14,0.27,425,48126,70,NULL,NULL,'SDSS J133646.92+622927.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000074,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,204.1955417,62.49111,0.029,NULL,57378376466,896537132,14008392,18.6),(111605,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111605,37.64,0.09,338,48127,70,NULL,NULL,'2MASX J13364694+5922225',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000161,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,204.1957083,59.37289,0.013,NULL,57388169248,896690144,14010783,17.5),(111606,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111606,37.31,0.46,290,48128,70,NULL,NULL,'2MASX J13364716+5141253',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.00021,NULL,'15.9g',0.41,NULL,NULL,NULL,NULL,NULL,1,204.196333,51.69028,0,NULL,59210063858,925157247,14455581,15.9),(111607,'SNIa','2016-12-15 15:15:16','2016-12-16 11:20:29','1','PS1 SN 2008050','N',111607,36.33,0.21,176,48129,73.8,NULL,'SALT 2 (SNANA)','PS1 SN 2008050 HOST',0.0486,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111608,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111608,38.01,0.46,400,48130,70,NULL,NULL,'2MASX J13364761+3857406',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000155,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,204.198375,38.96111,0,NULL,59312624858,926759763,14480621,17.2),(111609,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111609,35.36,0.48,118,48131,70,NULL,NULL,'MCG -03-35-008',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.5',0.4,NULL,NULL,NULL,NULL,NULL,1,204.199125,-18.31431,0.257,NULL,43814217008,684597140,10696830,15.5),(111610,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111610,33.06,0.4,40.9,48132,75,NULL,'B','UGC 08611',NULL,'1988NBGC.C....0000T',1988,1,1.29,NULL,'G',0.000037,NULL,'15.2g',0.68,'SAB(s)d',NULL,NULL,NULL,NULL,1,204.205458333,44.88144,0,NULL,59317599076,926837485,14481835,15.2),(111611,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111611,35.91,0.58,152,48133,70,NULL,NULL,'LCRS B133413.9-055150',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.000077,NULL,'16.62',0.35,NULL,NULL,NULL,NULL,NULL,1,204.210375,-6.11847,0.081,NULL,43579423667,680928494,10639507,16.62),(111612,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111612,37.03,0.17,254,48134,70,NULL,NULL,'2MASX J13365067+3450300',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000127,NULL,'15.8g',0.5,NULL,NULL,NULL,NULL,NULL,1,204.2112917,34.84153,0,NULL,59174662822,924604106,14446939,15.8),(111613,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111613,37.22,0.46,278,48135,70,NULL,NULL,'2MASX J13365073+3938292',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00018,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,204.2112917,39.64156,0,NULL,59312151449,926752366,14480505,16.5),(111614,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111614,37.28,0.15,286,48136,70,NULL,NULL,'2MASX J13365090+3600402',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,204.2119583,36.01117,0,NULL,59177047197,924641362,14447521,17),(111615,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111615,38.07,0.46,412,48137,70,NULL,NULL,'2MASX J13365090+6025190',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,204.2122083,60.42192,0.013,NULL,57391940748,896749074,14011704,17.5),(111616,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111616,37.87,0.46,376,48138,70,NULL,NULL,'SDSS J133652.14+264454.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'19.09',0.16,NULL,NULL,NULL,NULL,NULL,1,204.2172917,26.74836,0,NULL,59125038253,923828722,14434823,19.09),(111617,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111617,37.64,0.09,338,48139,70,NULL,NULL,'2MASX J13365230+5913035',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000087,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,204.218167,59.21781,0.013,NULL,57388270139,896691720,14010808,16.7),(111618,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111618,37.64,0.09,338,48140,70,NULL,NULL,'2MASX J13365282+5907015',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000067,NULL,'16.2g',0.32,NULL,NULL,NULL,NULL,NULL,1,204.2202917,59.11708,0.013,NULL,57388066551,896688539,14010758,16.2),(111619,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111619,36.43,0.46,193,48141,70,NULL,NULL,'2MASX J13365292+6047461',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000183,NULL,'15.8g',0.36,'E0',NULL,NULL,NULL,NULL,1,204.220375,60.796,0.013,NULL,57381086461,896579475,14009054,15.8),(111620,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111620,37.92,0.27,384,48142,70,NULL,NULL,'2MASX J13365341+2941332',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000168,NULL,'16.9g',0.31,'E0',NULL,NULL,NULL,NULL,1,204.222583333,29.69256,0,NULL,59134107299,923970426,14437037,16.9),(111621,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111621,36.18,0.46,172,48143,70,NULL,NULL,'2MASX J13365347+4124222',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000157,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,204.222875,41.40606,0,NULL,59313140631,926767822,14480747,16.5),(111622,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111622,37.74,0.46,354,48144,70,NULL,NULL,'SDSS J133654.30+304853.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'19.17',0.16,NULL,NULL,NULL,NULL,NULL,1,204.226291667,30.81481,0,NULL,59179345902,924677279,14448082,19.17),(111623,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111623,38.03,0.46,403,48145,70,NULL,NULL,'2MASX J13365435+1021329',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000169,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,204.2265417,10.35917,0.012,NULL,58419898754,912810918,14262670,17.1),(111624,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111624,34.31,0.46,72.7,48146,70,NULL,NULL,'CGCG 102-024',NULL,'2015arXiv151105856S',2015,1,0.3,'CGCG declination is incorrect.','G',0.000073,NULL,'14.9',0.25,'E','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,204.226917,17.39997,0,NULL,58828960427,919202506,14362539,14.9),(111625,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111625,37.68,0.46,344,48147,70,NULL,NULL,'2MASX J13365562+4903212',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,204.232083,49.05594,0,NULL,59213092875,925204576,14456321,17.3),(111626,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111626,38.02,0.46,402,48148,70,NULL,NULL,'2MASX J13365572+3144540',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000138,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,204.232208333,31.74842,0,NULL,59178947076,924671048,14447985,17.9),(111627,'TRGB','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111627,28.2,0.1,4.4,48149,NULL,NULL,NULL,'HIDEEP J1336-3321',NULL,'2007MNRAS.374..107G',2007,1,0.2,NULL,'G',NULL,NULL,'17.3B',0.2,NULL,NULL,NULL,NULL,NULL,1,204.2525,-33.36306,0.129,NULL,46906619777,732915934,11451811,17.3),(111628,'TRGB','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111628,28.29,0.1,4.55,48149,74.4,NULL,NULL,'HIDEEP J1336-3321',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111629,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111629,37.64,0.09,338,48150,70,NULL,NULL,'2MASX J13365596+5921475',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.0001,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,204.233333,59.36331,0.013,NULL,57388143647,896689744,14010777,17.5),(111630,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111630,36.77,0.46,226,48151,70,NULL,NULL,'2MASX J13365640+5600595',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000176,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,204.2349583,56.01653,0,NULL,57289948976,895155452,13986803,16.7),(111631,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111631,37.81,0.46,365,48152,70,NULL,NULL,'2MASX J13365678+5020572',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000103,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,204.236708333,50.34917,0,NULL,59208786674,925137291,14455270,17.6),(111632,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111632,37.77,0.46,358,48153,70,NULL,NULL,'2MASX J13365736+4155332',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,204.238875,41.92603,0,NULL,59320656760,926885261,14482582,17.6),(111633,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111633,37.19,0.46,274,48154,70,NULL,NULL,'SDSS J133657.38+365000.4',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,204.239083,36.83347,0,NULL,59174229487,924597335,14446833,17.8),(111634,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111634,37.64,0.09,338,48155,70,NULL,NULL,'2MASX J13365755+5928565',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,204.240125,59.48222,0.013,NULL,57388111493,896689242,14010769,18),(111635,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111635,36.69,0.27,218,48156,70,NULL,NULL,'2MASX J13365785+4343553',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000169,NULL,'16.0g',0.36,'E0',NULL,NULL,NULL,NULL,1,204.240875,43.73208,0,NULL,59319003430,926859428,14482178,16),(111636,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111636,37.28,0.15,286,48157,70,NULL,NULL,'2MASX J13365792+3545134',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,204.2412917,35.75378,0,NULL,59177076724,924641823,14447528,16.9),(111637,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111637,37.65,0.46,340,48158,70,NULL,NULL,'2MASX J13365866+1922200',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.72',0.18,NULL,NULL,NULL,NULL,NULL,1,204.244417,19.37231,0,NULL,58842210185,919409534,14365773,17.72),(111638,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111638,37.11,0.46,265,48159,70,NULL,NULL,'2MASX J13365866+4732033',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,204.244541667,47.53428,0,NULL,59283729966,926308280,14473566,17.9),(111639,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111639,36.43,0.58,194,48160,70,NULL,NULL,'2MASX J13365932-2708055',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.1b',NULL,'E+E',NULL,NULL,NULL,NULL,1,204.247125,-27.13486,0.241,NULL,46856705318,732136020,11439625,15.1),(111640,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111640,37.26,0.23,284,48161,70,NULL,NULL,'SDSS J133659.45+014235.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000075,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,204.2477083,1.70983,0.011,NULL,58400478293,912507473,14257929,18),(111641,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111641,35.12,0.52,106,48162,70,NULL,NULL,'2MASX J13365963-2201333',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.12',0.4,NULL,NULL,NULL,NULL,NULL,1,204.2485,-22.02589,0.237,NULL,43771689366,683932646,10686447,15.12),(111642,'Cepheids','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111642,28.25,0.15,4.5,48163,NULL,NULL,'12, VI','MESSIER 083',NULL,'2003ApJ...590..256T',2003,1,12.9,'Extended HIPASS source','G',0.000007,NULL,'8.20',11.5,'SAB(s)c;HII    Sbrst','Group member, radial-velocity confirmed',NULL,NULL,'Flat-Spectrum Radio Source',1,204.2539583,-29.86542,0.137,NULL,46848071786,732001121,11437517,8.2),(111643,'Cepheids','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111643,28.32,0.13,4.61,48163,NULL,18.54,'LMC ZP','MESSIER 083',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111644,'Cepheids','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111644,28.34,0.07,4.66,48163,74.4,NULL,NULL,'MESSIER 083',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111645,'PNLF','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111645,28.43,0.06,4.85,48163,NULL,NULL,NULL,'MESSIER 083',NULL,'2008ApJ...683..630H',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111646,'SNII radio','2016-12-15 15:15:16','2016-12-16 11:20:29','1','SN 1983N',NULL,111646,30.67,0.4,13.6,48163,NULL,NULL,'SN Type 1b, radio','MESSIER 083',NULL,'1986ApJ...300L..55P',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111647,'TRGB','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111647,28.27,0.15,4.51,48163,NULL,NULL,NULL,'MESSIER 083',NULL,'2002A&A...385...21K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111648,'TRGB','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111648,28.34,0.07,4.66,48163,74.4,NULL,NULL,'MESSIER 083',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111649,'TRGB','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111649,28.41,0.11,4.8,48163,NULL,NULL,'I','MESSIER 083',NULL,'2011ApJS..195...18R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111650,'TRGB','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111650,28.46,0.04,4.92,48163,NULL,NULL,'I','MESSIER 083',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111651,'Grav. Stability Gas. Disk','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111651,28.85,NULL,5.9,48163,NULL,NULL,NULL,'MESSIER 083',NULL,'1996AstL...22...71Z',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111652,'SNII optical','2016-12-15 15:15:16','2016-12-16 11:20:29','1','SN 1968L',NULL,111652,28.27,0.35,4.5,48163,NULL,NULL,NULL,'MESSIER 083',NULL,'1994ApJ...432...42S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111653,'SNII optical','2016-12-15 15:15:16','2016-12-16 11:20:29','1','SN 1968L',NULL,111653,28.41,0.54,4.8,48163,NULL,NULL,'EPM','MESSIER 083',NULL,'1992ApJ...395..366S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111654,'SNII optical','2016-12-15 15:15:16','2016-12-16 11:20:29','1','SN 1983N',NULL,111654,30.76,0.4,14.2,48163,NULL,NULL,'SN Type 1b, optical','MESSIER 083',NULL,'1986ApJ...300L..55P',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111655,'SNII optical','2016-12-15 15:15:16','2016-12-16 11:20:29','1','SN 1983N',NULL,111655,30.82,0.2,14.6,48163,NULL,NULL,'SN Type 1b, infrared','MESSIER 083',NULL,'1986ApJ...300L..55P',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111656,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111656,28.35,0.4,4.7,48163,75,NULL,'B','MESSIER 083',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111657,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111657,28.4,0.4,4.79,48163,NULL,18.45,'SN 1968L host','MESSIER 083',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111658,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111658,28.97,NULL,6.22,48163,NULL,NULL,'LEDA [April 2006]','MESSIER 083',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111659,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111659,33.27,NULL,45.1,48164,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08608',NULL,'2010Ap&SS.325..163P',2010,1,1.63,NULL,'G',0.000007,NULL,'15.7g',0.24,'Scd',NULL,NULL,NULL,NULL,1,204.2545,31.7665,0,NULL,59178918806,924670606,14447978,15.7),(111660,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111660,33.28,NULL,45.4,48164,NULL,NULL,'Dipole + Quadrupole','UGC 08608',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111661,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111661,33.29,NULL,45.6,48164,NULL,NULL,'Dipole','UGC 08608',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111662,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111662,33.36,NULL,47,48164,NULL,NULL,NULL,'UGC 08608',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111663,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111663,33.56,0.2,51.5,48164,74.4,NULL,NULL,'UGC 08608',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111664,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111664,34.26,0.49,71,48164,75,NULL,'IR','UGC 08608',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111665,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111665,37.92,0.27,384,48165,70,NULL,NULL,'2MASX J13370141+2937407',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.9g',0.13,'E1',NULL,NULL,NULL,NULL,1,204.255833,29.62792,0,NULL,59134115718,923970558,14437039,17.9),(111666,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111666,37.64,0.09,338,48166,70,NULL,NULL,'2MASXi J1337015+591258',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00018,NULL,'18.0g',0.11,NULL,NULL,NULL,NULL,NULL,1,204.256625,59.21625,0.013,NULL,57388057496,896688398,14010756,18),(111667,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111667,37.87,0.46,375,48167,70,NULL,NULL,'2MASX J13370302+5400415',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,204.2624583,54.01147,0,NULL,57292684411,895198193,13987471,17.5),(111668,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111668,37.77,0.33,358,48168,70,NULL,NULL,'2MASX J13370464+1703470',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,204.26925,17.063,0,NULL,58829304931,919207889,14362623,17.9),(111669,'Tully est','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111669,32.81,0.8,36.5,48169,75,NULL,NULL,'UGCA 367',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.00002,NULL,'14.74',1.4,'SB(s)dm',NULL,NULL,NULL,NULL,1,204.270417,-11.82986,0.125,NULL,43855667193,685244799,10706949,14.74),(111670,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111670,38.2,0.46,437,48170,70,NULL,NULL,'SDSS J133705.08+452110.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000175,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,204.2712083,45.35278,0,NULL,59317651399,926838303,14481848,18.5),(111671,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111671,37.28,0.15,286,48171,70,NULL,NULL,'SDSS J133705.63+360041.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000157,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,204.2735,36.01164,0,NULL,59177054620,924641478,14447523,18.4),(111672,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111672,38.17,0.23,431,48172,70,NULL,NULL,'2MASX J13370568+6301222',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000072,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,204.273708333,63.02278,0.065,NULL,57345370424,896021412,14000334,18.2),(111673,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111673,37.83,0.46,369,48173,70,NULL,NULL,'SDSS J133706.69+233116.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'19.00',0.13,NULL,NULL,NULL,NULL,NULL,1,204.277875,23.52122,0,NULL,58789428950,918584827,14352887,19),(111674,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111674,36.76,0.33,224,48174,70,NULL,NULL,'2MASX J13370686+3910333',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'15.86',0.24,NULL,NULL,NULL,NULL,NULL,1,204.278583,39.17594,0,NULL,59312086554,926751352,14480489,15.86),(111675,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111675,35.91,0.46,152,48175,70,NULL,NULL,'2MASX J13370800+0027079',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000081,NULL,'16.1g',0.37,'E0',NULL,NULL,NULL,NULL,1,204.283333,0.45214,0.009,NULL,58386565772,912290090,14254532,16.1),(111676,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111676,37.26,0.23,284,48176,70,NULL,NULL,'2MASX J13370889+0143499',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000068,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,204.287083,1.73044,0.011,NULL,58400484464,912507569,14257930,17.7),(111677,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111677,37.03,0.17,254,48177,70,NULL,NULL,'2MASX J13370902+3514525',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000183,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,204.2877083,35.24783,0,NULL,59177296705,924645261,14447582,16.4),(111678,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111678,37.77,0.33,357,48178,70,NULL,NULL,'2MASX J13370912+0240249',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000105,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,204.288125,2.67364,0,NULL,58399084179,912485690,14257588,16.5),(111679,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111679,37.83,0.61,367,48179,70,NULL,NULL,'2MASX J13370971-4216424',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.0I',0.2,NULL,NULL,NULL,NULL,NULL,1,204.2904583,-42.2785,0.361,NULL,46973051965,733953936,11468030,15),(111680,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111680,35.42,0.59,121,48180,70,NULL,NULL,'2MASX J13370971-0735286',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.95',0.44,NULL,NULL,NULL,NULL,NULL,1,204.290583,-7.59131,0.057,NULL,43580538116,680945908,10639779,16.95),(111681,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111681,37.77,0.33,357,48181,70,NULL,NULL,'2MASX J13371012+0239069',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000093,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,204.292208333,2.65189,0,NULL,58399081131,912485642,14257588,16.5),(111682,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111682,36.56,0.46,205,48182,70,NULL,NULL,'2MASX J13371060+0628288',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.95',0.19,NULL,NULL,NULL,NULL,NULL,1,204.294083,6.47456,0.064,NULL,58422820698,912856573,14263383,17.95),(111683,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111683,37.26,0.23,284,48183,70,NULL,NULL,'2MASX J13371068+0145549',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00007,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,204.294708333,1.76528,0.029,NULL,58400483141,912507549,14257930,17.8),(111684,'GRB','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111684,42.98,NULL,3940,48184,70,NULL,'Pseudo z = 3.93','GRB 030324',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,204.295833,-0.31667,0.009,NULL,43556210658,680565791,10633840,NULL),(111685,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111685,37.32,0.46,291,48185,70,NULL,NULL,'2MASX J13371116+3929283',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,204.296416667,39.49114,0,NULL,59312174049,926752719,14480511,17.4),(111686,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111686,37.64,0.09,338,48186,70,NULL,NULL,'SDSS J133711.34+592849.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000103,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,204.29725,59.48053,0.013,NULL,57388118625,896689353,14010771,17.7),(111687,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111687,36.61,0.46,210,48187,70,NULL,NULL,'2MASX J13371207+2222372',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,204.300458333,22.37692,0,NULL,58803354962,918802421,14356287,17),(111688,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111688,37.03,0.17,254,48188,70,NULL,NULL,'2MASX J13371220+3506165',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00016,NULL,'16.9g',0.32,NULL,NULL,NULL,NULL,NULL,1,204.3007083,35.10453,0,NULL,59176579653,924634057,14447407,16.9),(111689,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111689,37.77,0.33,358,48189,70,NULL,NULL,'2MASX J13371217+1702220',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,204.30075,17.03961,0,NULL,58829271241,919207363,14362615,16.9),(111690,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111690,36.76,0.33,224,48190,70,NULL,NULL,'LCRS B133437.1-031432',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000147,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,204.3020417,-3.49669,0.025,NULL,43561216161,680644002,10635062,16.3),(111691,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111691,36.25,0.54,178,48191,70,NULL,NULL,'2MASX J13371528-4818007',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,204.3137083,-48.30019,0.497,NULL,46949139409,733580303,11462192,14),(111692,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111692,37.03,0.17,254,48192,70,NULL,NULL,'2MASX J13371551+3432504',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00016,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,204.31475,34.5475,0,NULL,59174572257,924602691,14446917,17.2),(111693,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111693,36.86,0.46,235,48193,70,NULL,NULL,'2MASX J13371602+5619224',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000194,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,204.316875,56.32278,0,NULL,57289775535,895152742,13986761,16.3),(111694,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111694,35.35,0.49,118,48194,70,NULL,NULL,'2MASX J13371639-2202583',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000107,NULL,'15.25',0.7,'poss. LINER',NULL,NULL,NULL,NULL,1,204.318417,-22.04961,0.237,NULL,43771678957,683932483,10686445,15.25),(111695,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111695,37.74,0.33,353,48195,70,NULL,NULL,'2MASX J13371645+0330259',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000072,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,204.3185,3.50725,0.021,NULL,58396482693,912445042,14256953,17.6),(111696,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111696,34.54,0.5,81,48196,70,NULL,NULL,'MCG -02-35-008',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.74',0.4,NULL,NULL,NULL,NULL,NULL,1,204.3192917,-15.08047,0.157,NULL,43785462679,684147854,10689810,14.74),(111697,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111697,34.77,0.48,89.8,48197,70,NULL,NULL,'UGC 08607',NULL,'2014MNRAS.445.2677S',2014,1,0.74,NULL,'G',0.000087,NULL,'15.0g',0.5,'S0?',NULL,NULL,NULL,NULL,1,204.320041667,-2.15442,0.097,NULL,43569462254,680772847,10637075,15),(111698,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111698,37.28,0.15,286,48198,70,NULL,NULL,'SDSS J133717.98+354449.5',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'18.86',0.16,NULL,NULL,NULL,NULL,NULL,1,204.324958333,35.74708,0,NULL,59177204781,924643824,14447559,18.86),(111699,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111699,37.26,0.23,284,48199,70,NULL,NULL,'2MASX J13371972+0140544',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000094,NULL,'16.1g',0.41,'AGN',NULL,NULL,NULL,NULL,1,204.33225,1.68172,0.008,NULL,58400490463,912507663,14257932,16.1),(111700,'TRGB','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111700,28.28,0.1,4.53,48200,NULL,NULL,NULL,'ESO 444- G 084',NULL,'2012A&A...540A..49M',2012,1,1.3,NULL,'G',0.00001,NULL,'14.96',1,'Im',NULL,NULL,NULL,NULL,1,204.333291667,-28.045,0.225,NULL,46857063564,732141618,11439712,14.96),(111701,'TRGB','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111701,28.31,NULL,4.6,48200,NULL,NULL,NULL,'ESO 444- G 084',NULL,'2002A&A...385...21K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111702,'Tully est','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111702,28.75,0.8,5.6,48200,75,NULL,NULL,'ESO 444- G 084',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111703,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111703,37.74,0.33,353,48201,70,NULL,NULL,'SDSS J133720.32+033050.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000067,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,204.3347083,3.51411,0.021,NULL,58396482959,912445046,14256953,18.2),(111704,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111704,36.65,0.46,214,48202,70,NULL,NULL,'2MASX J13372203+0733278',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,204.341833333,7.55764,0.013,NULL,58424888310,912888879,14263888,17.2),(111705,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111705,38.19,0.46,434,48203,70,NULL,NULL,'2MASX J13372243+1949322',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.75',0.12,NULL,NULL,NULL,NULL,NULL,1,204.3434583,19.82567,0,NULL,58799378860,918740294,14355317,18.75),(111706,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111706,36.93,0.46,244,48204,70,NULL,NULL,'2MASX J13372275+6016292',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000168,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,204.344916667,60.27467,0.009,NULL,57391760175,896746252,14011660,16.9),(111707,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111707,34.57,0.46,82.1,48205,70,NULL,NULL,'NGC 5245',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000191,NULL,'14.9g',0.38,'S0/a',NULL,NULL,NULL,NULL,1,204.3467917,3.89742,0.041,NULL,58397223343,912456614,14257134,14.9),(111708,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111708,36.87,0.46,237,48206,70,NULL,NULL,'2MASXi J1337234-010512',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000077,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,204.347625,-1.08669,0.049,NULL,43556517438,680570584,10633915,17.8),(111709,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111709,37.28,0.15,286,48207,70,NULL,NULL,'2MASX J13372448+3551004',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,204.352125,35.85006,0,NULL,59177201139,924643767,14447558,17.1),(111710,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111710,37,0.46,251,48208,70,NULL,NULL,'2MASX J13372451+0955462',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,204.352167,9.92967,0,NULL,58420045306,912813207,14262706,17.2),(111711,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111711,37.98,0.46,394,48209,70,NULL,NULL,'2MASX J13372560+2147142',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,204.356667,21.78733,0,NULL,58803742914,918808483,14356382,17),(111712,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111712,37.64,0.09,338,48210,70,NULL,NULL,'2MASX J13372572+5923051',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000127,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,204.357125,59.38494,0.013,NULL,57388143069,896689735,14010777,16.9),(111713,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111713,35.46,0.47,123,48211,70,NULL,NULL,'ESO 509- G 082',NULL,'2014MNRAS.445.2677S',2014,1,1,'6dF DR2 has z = 0.039370.','G',0.000143,NULL,'15.11',0.6,'S0',NULL,NULL,NULL,NULL,1,204.358125,-23.65564,0.261,NULL,43758082811,683720043,10683125,15.11),(111714,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111714,30.5,NULL,12.6,48212,72,NULL,NULL,'UGC 08614',NULL,'2014Ap.....57..457K',2014,1,3.4,NULL,'G',0.000018,NULL,'13.2',1.8,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,204.359167,7.64444,0,NULL,58425358250,912896222,14264003,13.2),(111715,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111715,31.67,0.4,21.6,48212,75,NULL,'B','UGC 08614',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111716,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111716,38.02,0.46,402,48213,70,NULL,NULL,'2MASX J13372730+2442477',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,204.363666667,24.71336,0,NULL,58656693529,916510836,14320481,18.3),(111717,'IRAS','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111717,33.55,0.8,51.2,48214,75,NULL,'MAT, I','ESO 383- G 044',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000013,NULL,'14.06',0.7,'SA(s)d:        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,204.3659583,-33.00683,0.129,NULL,46908681381,732948146,11452314,14.06),(111718,'IRAS','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111718,33.55,0.8,51.2,48214,75,NULL,'HMCL, I','ESO 383- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111719,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111719,32.87,0.4,37.4,48214,75,NULL,'HMCL, I, raw','ESO 383- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111720,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111720,32.93,0.32,38.5,48214,85,NULL,'I, raw','ESO 383- G 044',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111721,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111721,32.94,0.4,38.6,48214,75,NULL,'HMCL, I, inv','ESO 383- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111722,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111722,32.94,0.32,38.7,48214,85,NULL,'I, inv','ESO 383- G 044',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111723,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111723,33.13,0.2,42.3,48214,74.4,NULL,NULL,'ESO 383- G 044',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111724,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111724,33.19,0.4,43.5,48214,75,NULL,'HMCL, I, cor','ESO 383- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111725,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111725,33.27,0.43,45,48214,75,NULL,'MAT, I, raw','ESO 383- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111726,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111726,33.38,0.43,47.4,48214,75,NULL,'MAT, I, inv','ESO 383- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111727,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111727,33.54,0.43,51,48214,75,NULL,'MAT, I, cor','ESO 383- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111728,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111728,33.85,0.09,59,48214,NULL,NULL,NULL,'ESO 383- G 044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111729,'SNIa','2016-12-15 15:15:16','2016-12-16 11:20:29','1','SN 2004bk',NULL,111729,34.92,0.16,94.1,48215,70,NULL,'SALT 2','NGC 5246',0.023124,'2013MNRAS.433.2240G',2013,1,1,NULL,'G',0.000098,NULL,'14.4g',0.8,'(R\')SB(s)b',NULL,NULL,NULL,NULL,1,204.372375,4.10444,0.026,NULL,58396683739,912448183,14257002,14.4),(111730,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111730,37.64,0.09,338,48216,70,NULL,NULL,'2MASX J13372947+5910561',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.0001,NULL,'16.6g',0.37,NULL,NULL,NULL,NULL,NULL,1,204.3725,59.18233,0.013,NULL,57267227717,894800433,13981256,16.6),(111731,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111731,38,0.46,398,48217,70,NULL,NULL,'SDSS J133729.54+423307.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,204.373125,42.552,0,NULL,59320976592,926890259,14482660,17.9),(111732,'TRGB','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111732,28.42,0.11,4.8,48218,NULL,NULL,NULL,'HIPASS J1337-39',NULL,'2007MNRAS.374..107G',2007,1,0.6,NULL,'G',0.000013,NULL,'16.5',0.5,'Im',NULL,NULL,NULL,NULL,1,204.355417,-39.89661,0.057,NULL,46971241777,733925652,11467588,16.5),(111733,'TRGB','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111733,28.53,0.1,5.08,48218,74.4,NULL,NULL,'HIPASS J1337-39',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111734,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111734,37.03,0.17,254,48219,70,NULL,NULL,'2MASX J13373077+3430526',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00011,NULL,'16.29',0.26,NULL,NULL,NULL,NULL,NULL,1,204.378333,34.51464,0,NULL,59174604665,924603197,14446924,16.29),(111735,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111735,37.54,0.46,323,48220,70,NULL,NULL,'2MASXi J1337317+542827',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,204.38225,54.47428,0,NULL,57293328053,895208250,13987628,18),(111736,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111736,30.17,0.43,10.8,48221,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5248',NULL,'2014MNRAS.444..527S',2014,1,6.2,NULL,'G',0.000002,NULL,'10.97',4.5,'(R)SB(rs)bc;Sy2HII','Isolated galaxy',NULL,NULL,NULL,1,204.383416667,8.88517,0,NULL,58433170106,913018282,14265910,10.97),(111737,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111737,30.35,0.43,11.8,48221,75,NULL,'3.6 micron, color corrected','NGC 5248',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111738,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111738,30.5,0.45,12.6,48221,NULL,NULL,'K','NGC 5248',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111739,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111739,30.52,0.36,12.7,48221,NULL,NULL,NULL,'NGC 5248',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111740,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111740,30.55,0.46,12.9,48221,NULL,NULL,'J','NGC 5248',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111741,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111741,30.57,0.2,13,48221,74.4,NULL,NULL,'NGC 5248',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111742,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111742,31.14,NULL,16.9,48221,72,NULL,NULL,'NGC 5248',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111743,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111743,31.3,0.4,18.2,48221,NULL,NULL,'mean','NGC 5248',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111744,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111744,31.73,0.3,22.2,48221,55,NULL,'B','NGC 5248',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111745,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111745,31.78,0.4,22.7,48221,75,NULL,'B','NGC 5248',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111746,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111746,38.19,0.21,434,48222,70,NULL,NULL,'2MASX J13373262+5455552',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000146,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,204.3860417,54.932,0,NULL,57293773136,895215205,13987737,17.8),(111747,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111747,38.16,0.46,428,48223,70,NULL,NULL,'2MASX J13373303+4830523',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000205,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,204.387666667,48.51458,0,NULL,59283595979,926306187,14473534,17.1),(111748,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111748,35.9,0.62,151,48224,70,NULL,NULL,'2MASX J13373424-3152440',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.38',NULL,NULL,NULL,NULL,NULL,NULL,1,204.3927083,-31.87881,0.177,NULL,46903440238,732866253,11451035,15.38),(111749,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111749,36.06,0.55,163,48225,70,NULL,NULL,'MCG -03-35-010',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.5',0.3,NULL,NULL,NULL,NULL,NULL,1,204.3970417,-16.63172,0.201,NULL,43784146417,684127287,10689488,15.5),(111750,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111750,38.36,0.46,470,48226,70,NULL,NULL,'2MASX J13373531+1950327',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,204.397208333,19.84233,0,NULL,58799409724,918740776,14355324,18.2),(111751,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111751,38.2,0.46,437,48227,70,NULL,NULL,'SDSS J133735.74+543444.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00015,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,204.398917,54.57914,0,NULL,57293329955,895208280,13987629,18.7),(111752,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111752,38.21,0.46,438,48228,70,NULL,NULL,'2MASX J13373615+2124397',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,204.400791667,21.411,0,NULL,58803647599,918806993,14356359,17.7),(111753,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111753,35.19,0.65,109,48229,70,NULL,NULL,'2MASX J13373648-2001066',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.9I',0.4,NULL,NULL,NULL,NULL,NULL,1,204.402083,-20.01844,0.265,NULL,43762933498,683795835,10684309,13.9),(111754,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111754,35.2,0.46,109,48230,70,NULL,NULL,'NGC 5249',NULL,'2015arXiv151105856S',2015,1,1.5,NULL,'G',0.000157,NULL,'13.94',1.1,'S0?',NULL,NULL,NULL,NULL,1,204.40625,15.97222,0,NULL,58828126504,919189476,14362335,13.94),(111755,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111755,38.23,0.46,442,48231,70,NULL,NULL,'SDSS J133738.50-012510.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,204.4104583,-1.41967,0.061,NULL,43567575205,680743362,10636615,18.2),(111756,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111756,35.61,0.51,132,48232,70,NULL,NULL,'2MASX J13373864-3146370',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000083,NULL,'15.8b',NULL,'E',NULL,NULL,NULL,NULL,1,204.4110417,-31.77692,0.177,NULL,46903459233,732866550,11451039,15.8),(111757,'SBF','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111757,27.78,0.27,3.6,48233,NULL,NULL,'T01','NGC 5237',NULL,'2007ApJ...668..130C',2007,1,1.9,NULL,'G',0.000013,NULL,'13.23',1.6,'I0?','Pair member (points to parent)',NULL,NULL,NULL,1,204.4127083,-42.84697,0.377,NULL,46972621140,733947205,11467925,13.23),(111758,'SBF','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111758,27.78,0.27,3.6,48233,NULL,NULL,'J03','NGC 5237',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111759,'SBF','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111759,28.02,0.27,4.02,48233,NULL,NULL,'BV A01','NGC 5237',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111760,'SBF','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111760,28.19,0.23,4.35,48233,NULL,NULL,'M06','NGC 5237',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111761,'TRGB','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111761,27.61,0.1,3.33,48233,74.4,NULL,NULL,'NGC 5237',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111762,'TRGB','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111762,27.61,0.11,3.33,48233,NULL,NULL,NULL,'NGC 5237',NULL,'2015ApJ...802L..25T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111763,'TRGB','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111763,27.63,0.02,3.36,48233,NULL,NULL,'I','NGC 5237',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111764,'TRGB','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111764,27.66,NULL,3.4,48233,NULL,NULL,NULL,'NGC 5237',NULL,'2007AJ....133..504K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111765,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111765,38.06,0.27,410,48234,70,NULL,NULL,'2MASX J13373975+6203461',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,204.415625,62.06281,0.037,NULL,57381887974,896591999,14009249,17.8),(111766,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111766,35.95,0.51,155,48235,70,NULL,NULL,'2MASX J13374075-1945566',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.7I',0.3,NULL,NULL,NULL,NULL,NULL,1,204.419833,-19.76569,0.265,NULL,43763062082,683797845,10684341,13.7),(111767,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111767,36.56,0.46,205,48236,70,NULL,NULL,'2MASX J13374176+3057197',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000161,NULL,'16.8g',0.26,'E3',NULL,NULL,NULL,NULL,1,204.423875,30.95536,0,NULL,59179360482,924677507,14448086,16.8),(111768,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111768,36.07,0.52,164,48237,NULL,NULL,NULL,'2MASX J13374326-3529441',NULL,'2009ApJS..182..474S',2009,1,0.28,NULL,'G',0.000027,NULL,'16.00',NULL,'Sc',NULL,NULL,NULL,NULL,1,204.4302083,-35.49558,0.137,NULL,46896504912,732757889,11449342,16),(111769,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111769,36.11,0.2,167,48237,74.4,NULL,NULL,'2MASX J13374326-3529441',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111770,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111770,36.28,0.47,181,48237,NULL,NULL,'Malmquist cor.','2MASX J13374326-3529441',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111771,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111771,38.19,0.33,434,48238,70,NULL,NULL,'SDSS J133745.05+534915.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'18.3g',0.1,NULL,NULL,NULL,NULL,NULL,1,204.4377083,53.82094,0.013,NULL,57292718402,895198725,13987480,18.3),(111772,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111772,37.03,0.17,254,48239,70,NULL,NULL,'2MASX J13374587+3517527',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,204.441125,35.29803,0,NULL,59177269224,924644831,14447575,17.4),(111773,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111773,35.71,0.61,139,48240,70,NULL,NULL,'2MASX J13374616-3254361',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00008,NULL,'15.10',NULL,NULL,NULL,NULL,NULL,NULL,1,204.442417,-32.91011,0.137,NULL,46908823915,732950373,11452349,15.1),(111774,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111774,38.89,0.46,600,48241,70,NULL,NULL,'SDSS J133746.75+172022.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,204.4447917,17.33972,0,NULL,58828916822,919201825,14362528,18.5),(111775,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111775,38.45,0.46,490,48242,70,NULL,NULL,'2MASX J13374693+1937337',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,204.445625,19.626,0,NULL,58799181187,918737206,14355268,18),(111776,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111776,37.73,0.99,351,48243,70,NULL,NULL,'2MFGC 10995',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'12.4K',NULL,NULL,NULL,NULL,NULL,NULL,1,204.44575,-47.33361,0.481,NULL,46950058358,733594661,11462416,12.4),(111777,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111777,37.26,0.46,283,48244,70,NULL,NULL,'2MASX J13374753+5420552',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000163,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,204.448125,54.34875,0,NULL,57293406057,895209469,13987647,18.1),(111778,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111778,36.68,0.55,217,48245,70,NULL,NULL,'2MASX J13374812-4222539',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,204.4504583,-42.38161,0.357,NULL,46973050429,733953912,11468029,14.5),(111779,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111779,38.24,0.46,444,48246,70,NULL,NULL,'2MASX J13374816+6152480',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000025,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,204.4505,61.88014,0.037,NULL,57382065373,896594771,14009293,16.7),(111780,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111780,37.5,0.46,316,48247,70,NULL,NULL,'2MASX J13374842+0842383',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000186,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,204.4517917,8.71078,0,NULL,58433155002,913018046,14265906,16.4),(111781,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111781,36.19,0.72,173,48248,70,NULL,NULL,'LCRS B133512.2-055408',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'15.18',0.23,NULL,NULL,NULL,NULL,NULL,1,204.4532917,-6.15633,0.053,NULL,43579579209,680930925,10639545,15.18),(111782,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111782,37.32,0.46,291,48249,70,NULL,NULL,'2MASX J13374902+0232225',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000066,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,204.45425,2.53953,0,NULL,58401199408,912518740,14258105,18),(111783,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111783,37.42,0.46,304,48250,70,NULL,NULL,'2MASX J13374910+1236537',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000168,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,204.454583,12.61494,0,NULL,58821022897,919078482,14360601,16.8),(111784,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111784,38.33,0.46,463,48251,70,NULL,NULL,'2MASX J13374945+2259207',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,204.456166667,22.989,0,NULL,58788716892,918573701,14352714,17.7),(111785,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111785,39.18,0.46,684,48252,70,NULL,NULL,'SDSS J133749.68+232448.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'19.27',0.15,NULL,NULL,NULL,NULL,NULL,1,204.457041667,23.41336,0,NULL,58789239394,918581865,14352841,19.27),(111786,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111786,36.95,0.46,245,48253,70,NULL,NULL,'2MASX J13375026+4047077',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000179,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,204.4595417,40.78542,0,NULL,59313395995,926771812,14480809,16.6),(111787,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111787,36.6,0.46,209,48254,70,NULL,NULL,'2MASX J13375072+3811577',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000165,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,204.461417,38.19925,0,NULL,59265536214,926024003,14469125,16.3),(111788,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111788,37.3,0.56,288,48255,70,NULL,NULL,'2MASX J13375236-3538271',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.68',0.5,'E',NULL,NULL,NULL,NULL,1,204.468167,-35.64094,0.137,NULL,46896469631,732757337,11449333,14.68),(111789,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111789,37.63,0.46,336,48256,70,NULL,NULL,'2MASX J13375267+2920064',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000137,NULL,'16.9g',0.28,'E1',NULL,NULL,NULL,NULL,1,204.469541667,29.33508,0,NULL,59133961694,923968151,14437002,16.9),(111790,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111790,37.75,0.46,355,48257,70,NULL,NULL,'2MASX J13375436-0202546',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00015,NULL,'17.0g',0.26,'AGN',NULL,NULL,NULL,NULL,1,204.4764583,-2.04867,0.101,NULL,43570337088,680786517,10637289,17),(111791,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111791,37.85,0.46,371,48258,70,NULL,NULL,'LCRS B133519.7-022537',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,204.47775,-2.68078,0.065,NULL,43569693160,680776455,10637132,18.3),(111792,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111792,38.22,0.46,441,48259,70,NULL,NULL,'2MASX J13375503+2818024',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,204.479416667,28.30067,0,NULL,59137176237,924018378,14437787,17.5),(111793,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111793,38.03,0.46,403,48260,70,NULL,NULL,'2MASX J13375529+2142367',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,204.480291667,21.71022,0,NULL,58801656571,918775883,14355873,16.7),(111794,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111794,37.81,0.46,364,48261,70,NULL,NULL,'2MASX J13375539+2943514',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000165,NULL,'16.9g',0.26,'E5',NULL,NULL,NULL,NULL,1,204.480625,29.73089,0,NULL,59134117200,923970581,14437040,16.9),(111795,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111795,37.13,0.46,267,48262,70,NULL,NULL,'2MASX J13375726+3708227',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00018,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,204.488458333,37.13958,0,NULL,59173427457,924584804,14446637,16.8),(111796,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111796,35.82,0.46,146,48263,70,NULL,NULL,'2MASX J13375734+3123117',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000123,NULL,'16.2g',0.26,'E6',NULL,NULL,NULL,NULL,1,204.488833,31.38653,0,NULL,59179446460,924678850,14448107,16.2),(111797,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111797,37.52,0.46,320,48264,70,NULL,NULL,'2MASX J13375740+4409580',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000133,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,204.489125,44.16603,0,NULL,59319145884,926861654,14482213,17.8),(111798,'IRAS','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111798,33.76,0.8,56.5,48265,75,NULL,'MAT, I','ESO 444- G 086',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'14.43',0.3,'S?             HII',NULL,NULL,NULL,NULL,1,204.489083,-30.93167,0.141,NULL,46902931116,732858298,11450910,14.43),(111799,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111799,33.84,0.45,58.5,48265,NULL,NULL,'K','ESO 444- G 086',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111800,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111800,33.84,0.47,58.7,48265,NULL,NULL,'H','ESO 444- G 086',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111801,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111801,33.85,0.4,59,48265,NULL,NULL,'mean','ESO 444- G 086',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111802,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111802,33.96,0.43,61.9,48265,75,NULL,'3.6 micron, color + selection bias corrected','ESO 444- G 086',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111803,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111803,33.97,0.43,62.2,48265,75,NULL,'3.6 micron, color corrected','ESO 444- G 086',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111804,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111804,33.97,0.43,62.3,48265,75,NULL,'MAT, I, raw','ESO 444- G 086',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111805,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111805,33.99,0.46,62.9,48265,NULL,NULL,'J','ESO 444- G 086',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111806,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111806,34.02,0.32,63.7,48265,85,NULL,'I, raw','ESO 444- G 086',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111807,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111807,34.07,0.2,65.2,48265,74.4,NULL,NULL,'ESO 444- G 086',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111808,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111808,34.07,0.43,65.3,48265,75,NULL,'MAT, I, cor','ESO 444- G 086',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111809,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111809,34.08,0.32,65.6,48265,85,NULL,'I, inv','ESO 444- G 086',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111810,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111810,34.23,0.49,70.3,48265,75,NULL,'IR','ESO 444- G 086',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111811,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111811,34.25,0.43,70.9,48265,75,NULL,'MAT, I, inv','ESO 444- G 086',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111812,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111812,34.29,0.11,72.3,48265,NULL,NULL,NULL,'ESO 444- G 086',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111813,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111813,37.6,0.21,332,48266,70,NULL,NULL,'2MASX J13375868+2543434',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,204.494667,25.72883,0,NULL,58654904858,916482888,14320045,17.5),(111814,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111814,35.92,0.46,153,48267,70,NULL,NULL,'2MASX J13375913+0731423',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.77',0.22,NULL,NULL,NULL,NULL,NULL,1,204.4964583,7.52831,0.011,NULL,58425673904,912901154,14264080,16.77),(111815,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111815,37.45,0.46,309,48268,70,NULL,NULL,'2MASXi J1337591+462617',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000147,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,204.49675,46.43831,0.058,NULL,59286384136,926349752,14474214,17.4),(111816,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111816,37.44,0.46,307,48269,70,NULL,NULL,'2MASX J13380005+0839243',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,204.500083,8.65689,0,NULL,58433034415,913016162,14265877,17.1),(111817,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111817,38.37,0.46,473,48270,70,NULL,NULL,'SDSS J133800.47+095216.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'18.1g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,204.502,9.87111,0,NULL,58420018826,912812794,14262699,18.1),(111818,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111818,35.42,0.63,122,48271,70,NULL,NULL,'ESO 509- G 085',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000027,NULL,'15.02',0.6,'SAB(rs)a',NULL,NULL,NULL,NULL,1,204.505083,-22.92425,0.229,NULL,43757652667,683713322,10683020,15.02),(111819,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111819,37.82,0.46,367,48272,70,NULL,NULL,'2MASX J13380167+4706000',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000158,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,204.507041667,47.10003,0.048,NULL,59286351621,926349244,14474206,17),(111820,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111820,37.06,0.46,259,48273,70,NULL,NULL,'2MASX J13380238+4923289',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000134,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,204.509875,49.39133,0,NULL,59221526986,925336359,14458380,17.1),(111821,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111821,38.06,0.46,409,48274,70,NULL,NULL,'SDSS J133802.93+144639.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,204.5122083,14.77775,0.013,NULL,58822178025,919096531,14360883,18.2),(111822,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111822,31.74,0.4,22.2,48275,75,NULL,'B','NGC 5247',NULL,'1988NBGC.C....0000T',1988,1,5.6,NULL,'G',0.00001,NULL,'10.5B',4.9,'SA(s)bc',NULL,NULL,NULL,NULL,1,204.512667,-17.88403,0.369,NULL,43780757409,684074334,10688661,10.5),(111823,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111823,37.61,0.46,333,48276,70,NULL,NULL,'2MASX J13380311+1931414',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.24',0.13,NULL,NULL,NULL,NULL,NULL,1,204.5129583,19.52808,0,NULL,58796492650,918695197,14354612,18.24),(111824,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111824,37.12,0.46,266,48277,70,NULL,NULL,'2MASX J13380346+3134327',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000139,NULL,'17.1g',0.28,'E2',NULL,NULL,NULL,NULL,1,204.5145,31.57589,0,NULL,59179407153,924678236,14448097,17.1),(111825,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111825,35.91,0.57,152,48278,70,NULL,NULL,'2MASX J13380353-4212579',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.8I',0.4,NULL,NULL,NULL,NULL,NULL,1,204.514667,-42.21608,0.357,NULL,46972999782,733953121,11468017,13.8),(111826,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111826,33.37,0.45,47.2,48279,NULL,NULL,'K','ESO 383- G 049',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000011,NULL,'14.27',0.4,'E+:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,204.5150417,-33.87369,0.125,NULL,46906314401,732911162,11451736,14.27),(111827,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111827,33.69,0.4,54.7,48279,NULL,NULL,'mean','ESO 383- G 049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111828,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111828,36.58,0.46,207,48280,70,NULL,NULL,'2MASX J13380435+3941103',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000198,NULL,'17.0g',0.19,'Candidate      BLAGN',NULL,NULL,NULL,NULL,1,204.517917,39.68617,0,NULL,59311967704,926749495,14480460,17),(111829,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111829,37.75,0.46,356,48281,70,NULL,NULL,'SDSS J133805.32+094615.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000156,NULL,'18.3g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,204.522166667,9.77089,0,NULL,58420131763,912814558,14262727,18.3),(111830,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111830,37.95,0.33,390,48282,70,NULL,NULL,'2MASX J13380532+4942539',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,204.5222083,49.71506,0,NULL,59221629787,925337965,14458405,17.1),(111831,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111831,37.47,0.46,312,48283,70,NULL,NULL,'2MASX J13380536+0314186',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000088,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,204.52225,3.23856,0.009,NULL,58395765458,912433835,14256778,17.2),(111832,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111832,38.19,0.33,434,48284,70,NULL,NULL,'2MASX J13380549+5355161',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,204.522666667,53.92122,0,NULL,57292865168,895201018,13987515,18.4),(111833,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111833,37.45,0.58,309,48285,70,NULL,NULL,'2MASX J13380607-3021282',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,204.5252083,-30.35783,0.125,NULL,46848114578,732001790,11437527,14.5),(111834,'IRAS','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111834,32.31,0.8,29,48286,75,NULL,'MAT, I','ESO 324- G 044',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.00001,NULL,'13.40',1,'SAB(rs)cd',NULL,NULL,NULL,NULL,1,204.526,-39.84022,0.057,NULL,46968377670,733880901,11466889,13.4),(111835,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111835,32.28,0.43,28.6,48286,75,NULL,'3.6 micron, color + selection bias corrected','ESO 324- G 044',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111836,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111836,32.35,0.32,29.5,48286,85,NULL,'I, raw','ESO 324- G 044',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111837,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111837,32.36,0.32,29.6,48286,85,NULL,'I, inv','ESO 324- G 044',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111838,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111838,32.41,0.43,30.3,48286,75,NULL,'3.6 micron, color corrected','ESO 324- G 044',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111839,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111839,32.5,0.2,31.6,48286,74.4,NULL,NULL,'ESO 324- G 044',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111840,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111840,32.69,0.4,34.5,48286,NULL,NULL,NULL,'ESO 324- G 044',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111841,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111841,32.71,0.43,34.8,48286,75,NULL,'MAT, I, raw','ESO 324- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111842,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111842,32.78,0.43,36,48286,75,NULL,'MAT, I, inv','ESO 324- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111843,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111843,33.03,0.43,40.4,48286,75,NULL,'MAT, I, cor','ESO 324- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111844,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111844,37.81,0.46,364,48287,70,NULL,NULL,'2MASX J13380643+1144063',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000185,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,204.526875,11.735,0,NULL,58418318807,912786231,14262284,17.2),(111845,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111845,36.55,0.61,204,48288,70,NULL,NULL,'2MASX J13380676-2042222',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.06',NULL,NULL,NULL,NULL,NULL,NULL,1,204.528083333,-20.70619,0.297,NULL,43762565515,683790086,10684220,16.06),(111846,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111846,37.51,0.46,318,48289,70,NULL,NULL,'2MASX J13380677+1221395',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000091,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,204.5282083,12.36086,0,NULL,58334415965,911475249,14241800,16.8),(111847,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111847,37.53,0.46,321,48290,70,NULL,NULL,'2MASX J13380681+0422375',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000159,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,204.528583,4.37697,0.017,NULL,58396564531,912446320,14256973,17.9),(111848,'GRB','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111848,44.79,1.54,3470,48291,100,NULL,NULL,'1SAX J1338.1-8030',1.6187,'2009EPJC...63..139W',2009,1,NULL,NULL,'G',0.0015,NULL,'18.9',NULL,NULL,NULL,NULL,NULL,NULL,1,204.531833,-80.49689,0.469,NULL,44256502352,691507849,10804810,18.9),(111849,'GRB','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111849,44.94,1.47,3710,48291,100,NULL,NULL,'1SAX J1338.1-8030',1.6187,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111850,'GRB','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111850,45.31,0.42,4400,48291,69.7,NULL,'Fiducial','1SAX J1338.1-8030',1.6187,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111851,'GRB','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111851,45.34,0.41,4470,48291,72,NULL,NULL,'1SAX J1338.1-8030',1.6187,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111852,'GRB','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111852,45.36,0.31,4510,48291,69.7,NULL,'Calibrated','1SAX J1338.1-8030',1.6187,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111853,'GRB','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111853,45.46,0.4,4720,48291,70,NULL,NULL,'1SAX J1338.1-8030',1.6187,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111854,'GRB','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111854,45.72,0.46,5310,48291,NULL,NULL,NULL,'1SAX J1338.1-8030',1.6187,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111855,'GRB','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111855,47.13,0.42,7430,48291,73,NULL,'H const./H=100','1SAX J1338.1-8030',1.6187,'2006astro.ph..9262M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111856,'GRB','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111856,45.46,0.34,12400,48291,NULL,NULL,NULL,'1SAX J1338.1-8030',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111857,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111857,36.33,0.46,184,48292,70,NULL,NULL,'2MASX J13380870+1920544',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'15.49',0.25,NULL,NULL,NULL,NULL,NULL,1,204.536375,19.34858,0,NULL,58796517780,918695590,14354618,15.49),(111858,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111858,36.54,0.4,204,48293,NULL,NULL,'Malmquist cor.','AGC 530533',NULL,'2009ApJS..182..474S',2009,1,0.43,NULL,'G',0.00003,NULL,'16.18',NULL,'Sc',NULL,NULL,NULL,NULL,1,204.537958333,-35.37958,0.109,NULL,46896449448,732757022,11449328,16.18),(111859,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111859,36.6,0.39,209,48293,NULL,NULL,NULL,'AGC 530533',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111860,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111860,36.64,0.2,213,48293,74.4,NULL,NULL,'AGC 530533',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111861,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111861,37.64,0.46,337,48294,70,NULL,NULL,'SDSS J133809.54+173945.0',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,204.5397917,17.66253,0,NULL,58825460742,919147824,14361684,17.3),(111862,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111862,31.78,0.4,22.7,48295,75,NULL,'B','DDO 180',NULL,'1988NBGC.C....0000T',1988,1,2.3,NULL,'G',0.000013,NULL,'13.00',1.9,'SB(s)m',NULL,NULL,NULL,NULL,1,204.543,-9.80183,0.101,NULL,43572880970,680826265,10637910,13),(111863,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111863,37.03,0.46,254,48296,70,NULL,NULL,'SDSS J133812.09+325726.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000166,NULL,'17.5g',0.18,'E3',NULL,NULL,NULL,NULL,1,204.550417,32.95742,0,NULL,59189433697,924834901,14450545,17.5),(111864,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111864,35.43,0.46,122,48297,NULL,NULL,'Malmquist cor.','UGC 08624',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.34',0.3,'Sbc',NULL,NULL,NULL,NULL,1,204.5507083,18.39008,0,NULL,58842795209,919418675,14365916,15.34),(111865,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111865,35.7,0.4,138,48297,NULL,NULL,NULL,'UGC 08624',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111866,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111866,35.74,0.2,141,48297,74.4,NULL,NULL,'UGC 08624',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111867,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111867,37.6,0.21,332,48298,70,NULL,NULL,'SDSS J133812.68+255413.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.90',0.17,NULL,NULL,NULL,NULL,NULL,1,204.552875,25.90361,0,NULL,58654918972,916483108,14320048,18.9),(111868,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111868,37.98,0.46,395,48299,70,NULL,NULL,'2MASX J13381351+3841334',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,204.5564583,38.69261,0,NULL,59265701729,926026589,14469165,17.5),(111869,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111869,34.2,NULL,69.3,48300,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08623',NULL,'2010Ap&SS.325..163P',2010,1,1.55,NULL,'G',0.000017,NULL,'16.0',0.09,'Sd',NULL,NULL,NULL,NULL,1,204.5565417,6.46567,0.032,NULL,58426281456,912910647,14264228,16),(111870,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111870,34.21,NULL,69.6,48300,NULL,NULL,'Dipole + Quadrupole','UGC 08623',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111871,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111871,34.23,NULL,70,48300,NULL,NULL,'Dipole','UGC 08623',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111872,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111872,37.53,0.46,320,48301,70,NULL,NULL,'2MASX J13381420+6407111',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000073,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,204.559083,64.11992,0.049,NULL,57867208134,904175127,14127736,17.2),(111873,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111873,35.95,0.46,155,48302,70,NULL,NULL,'2MASX J13381460+3109154',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000113,NULL,'15.9g',0.31,'S02',NULL,NULL,NULL,NULL,1,204.56075,31.15417,0,NULL,59178680635,924666884,14447920,15.9),(111874,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111874,37.01,0.2,252,48303,74.4,NULL,NULL,'CGCG 073-055',NULL,'2013AJ....146...86T',2013,1,0.79,NULL,'G',0.000002,NULL,'15.9g',0.34,NULL,NULL,NULL,NULL,NULL,1,204.5614583,11.25122,0.009,NULL,58419221880,912800341,14262505,15.9),(111875,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111875,34.16,0.45,67.9,48304,NULL,NULL,'K','NGC 5252',NULL,'2007A&A...465...71T',2007,1,1.44,NULL,'G',0.00001,NULL,'13.8g',0.81,'S0             Sy1.9',NULL,NULL,'radio jet','Sy 1.9',1,204.5665,4.54258,0.007,NULL,58393627445,912400428,14256256,13.8),(111876,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111876,34.98,0.4,99.3,48304,NULL,NULL,'mean','NGC 5252',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111877,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111877,36.99,0.46,250,48305,70,NULL,NULL,'2MASX J13381686+0449550',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00017,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,204.57025,4.83183,0.007,NULL,58439521856,913117529,14267461,17.3),(111878,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111878,37.05,0.54,257,48306,70,NULL,NULL,'2MASX J13381832-3103123',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.2b',NULL,'*+E            HII',NULL,NULL,NULL,NULL,1,204.576375,-31.05336,0.141,NULL,46902901233,732857831,11450903,16.2),(111879,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111879,37.42,0.33,305,48307,70,NULL,NULL,'2MASX J13381943+0934153',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000183,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,204.5810417,9.57081,0.009,NULL,58420318548,912817477,14262773,16.6),(111880,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111880,37.42,0.33,305,48308,70,NULL,NULL,'SDSS J133820.64+093249.8',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000159,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,204.5860417,9.54719,0.009,NULL,58420321914,912817529,14262773,17.3),(111881,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111881,35.58,0.33,130,48309,70,NULL,NULL,'IC 4313',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00009,NULL,'15.7g',0.44,'Elliptical','Field galaxy',NULL,NULL,NULL,1,204.586291667,26.75978,0,NULL,59125214257,923831472,14434866,15.7),(111882,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111882,36.94,0.33,244,48310,70,NULL,NULL,'2MASX J13382115+3057334',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000161,NULL,'16.6g',0.28,'E0',NULL,NULL,NULL,NULL,1,204.5880417,30.95936,0,NULL,59178665905,924666654,14447916,16.6),(111883,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111883,37.95,0.46,389,48311,70,NULL,NULL,'2MASX J13382202+3036214',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,204.591708333,30.60603,0,NULL,59133522431,923961287,14436895,18.1),(111884,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111884,37.6,0.46,331,48312,70,NULL,NULL,'2MASX J13382230+3847414',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,204.593125,38.79472,0,NULL,59266374073,926037094,14469329,17.4),(111885,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111885,37.15,0.46,269,48313,70,NULL,NULL,'2MASX J13382253+2032555',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,204.59375,20.54867,0,NULL,58799155327,918736801,14355262,16.8),(111886,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111886,35.44,0.46,123,48314,70,NULL,NULL,'2MASX J13382327+2358196',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.34',0.2,NULL,NULL,NULL,NULL,NULL,1,204.597083,23.97206,0,NULL,58789179196,918580924,14352826,17.34),(111887,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111887,36.75,0.33,224,48315,70,NULL,NULL,'2MASX J13382358+6556401',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000089,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,204.5984583,65.94461,0.045,NULL,57881362847,904396294,14131192,16.2),(111888,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111888,37.02,0.46,253,48316,70,NULL,NULL,'2MASX J13382372+1535006',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,204.598625,15.58331,0,NULL,58827365078,919177579,14362149,17.7),(111889,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111889,38.43,0.46,485,48317,70,NULL,NULL,'SDSS J133823.90+054949.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000115,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,204.599625,5.83042,0,NULL,58440008828,913125137,14267580,18.5),(111890,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111890,37.71,0.46,348,48318,70,NULL,NULL,'SDSS J133824.40+021320.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000079,NULL,'18.1g',0.1,NULL,NULL,NULL,NULL,NULL,1,204.601667,2.22242,0.021,NULL,58401328619,912520759,14258136,18.1),(111891,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111891,32.31,0.43,29,48319,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08630',NULL,'2014MNRAS.444..527S',2014,1,1.37,'2MASS position is on the western edge.','G',0.000004,NULL,'14.4g',0.48,'S?             HII',NULL,NULL,NULL,NULL,1,204.603625,33.11772,0,NULL,59189410620,924834540,14450539,14.4),(111892,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111892,32.98,0.49,39.5,48319,75,NULL,'IR','UGC 08630',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111893,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111893,35.58,0.33,130,48320,70,NULL,NULL,'IC 4314',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00008,NULL,'14.60',0.3,'Elliptical','Isolated elliptical galaxy',NULL,NULL,NULL,1,204.6044583,26.7425,0,NULL,59125213081,923831454,14434866,14.6),(111894,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111894,36.51,0.42,201,48321,NULL,NULL,'Malmquist cor.','AGC 530534',NULL,'2009ApJS..182..474S',2009,1,0.32,NULL,'G',0.000027,NULL,'16.24',NULL,'Sc',NULL,NULL,NULL,NULL,1,204.6052083,-35.64306,0.133,NULL,46896492600,732757696,11449339,16.24),(111895,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111895,36.52,0.42,202,48321,NULL,NULL,NULL,'AGC 530534',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111896,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111896,36.56,0.2,205,48321,74.4,NULL,NULL,'AGC 530534',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111897,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111897,37.05,0.46,257,48322,70,NULL,NULL,'2MASX J13382537+3547224',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000186,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,204.60575,35.78944,0,NULL,59177215466,924643991,14447562,16.5),(111898,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111898,38.08,0.46,413,48323,70,NULL,NULL,'2MASX J13382574+5254598',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000171,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,204.60725,52.91669,0,NULL,59208961205,925140018,14455312,16.9),(111899,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111899,36.74,0.46,222,48324,70,NULL,NULL,'2MASX J13382578-0024450',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000089,NULL,'17.8g',0.11,'NLAGN',NULL,NULL,NULL,NULL,1,204.607416667,-0.41261,0.013,NULL,43556736193,680574003,10633968,17.8),(111900,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111900,33.68,0.4,54.4,48325,NULL,NULL,'mean','IC 0903',NULL,'2007A&A...465...71T',2007,1,1.72,NULL,'G',0.000013,NULL,'14.2g',0.62,'(R\')Sab:',NULL,NULL,NULL,NULL,1,204.608625,-0.22764,0.013,NULL,43556721177,680573768,10633965,14.2),(111901,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111901,33.89,0.47,59.9,48325,NULL,NULL,'H','IC 0903',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111902,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111902,33.98,0.46,62.5,48325,NULL,NULL,'J','IC 0903',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111903,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111903,34.01,0.45,63.5,48325,NULL,NULL,'K','IC 0903',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111904,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111904,36.82,0.33,231,48326,70,NULL,NULL,'2MASX J13382608+3353434',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000179,NULL,'15.9g',0.44,NULL,NULL,NULL,NULL,NULL,1,204.608875,33.89542,0,NULL,59189199316,924831239,14450488,15.9),(111905,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111905,37.83,0.46,368,48327,70,NULL,NULL,'2MASX J13382686+4146074',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,204.6117917,41.76883,0,NULL,59320173753,926877714,14482464,17.6),(111906,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111906,38.13,0.33,423,48328,70,NULL,NULL,'2MASXi J1338283+585945',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000178,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,204.617583333,58.99589,0.013,NULL,57267220063,894800313,13981254,17.3),(111907,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111907,34.38,0.45,75.2,48329,70,NULL,NULL,'MCG -02-35-011',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00012,NULL,'13.79',1.2,'S0 pec',NULL,NULL,NULL,NULL,1,204.6239583,-10.70428,0.105,NULL,43571138019,680799031,10637484,13.79),(111908,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111908,37.6,0.21,332,48330,70,NULL,NULL,'2MASX J13382978+2549336',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.68',0.17,NULL,NULL,NULL,NULL,NULL,1,204.624167,25.82606,0,NULL,58654932268,916483316,14320051,17.68),(111909,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111909,37.58,0.46,328,48331,70,NULL,NULL,'2MASX J13382987+1711256',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,204.624417,17.19033,0,NULL,58828596580,919196821,14362450,16.8),(111910,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111910,31.94,NULL,24.4,48332,72,NULL,NULL,'UGC 08629',NULL,'2014Ap.....57..457K',2014,1,1.13,'Multiple SDSS entries describe this source.','G',0.000002,NULL,'15.9g',0.36,'Im:','Group member',NULL,NULL,NULL,1,204.627917,8.44317,0,NULL,58433920891,913030013,14266093,15.9),(111911,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111911,38.46,0.46,493,48333,70,NULL,NULL,'2MASX J13383088+1900020',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,204.628667,19.00061,0,NULL,58842289106,919410767,14365793,NULL),(111912,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111912,35.52,0.46,127,48334,70,NULL,NULL,'CGCG 131-016',NULL,'2015arXiv151105856S',2015,1,0.6,'HOLM 531B is a star.','G',0.0005,NULL,'15.7',0.35,'S0','Field galaxy',NULL,NULL,NULL,1,204.6317083,26.10544,0,NULL,58654798681,916481229,14320019,15.7),(111913,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111913,37.06,0.64,258,48335,70,NULL,NULL,'2MASX J13383232-2754495',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.5b',0.4,'E',NULL,NULL,NULL,NULL,1,204.63475,-27.91372,0.165,NULL,46857636654,732150572,11439852,16.5),(111914,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111914,37.4,0.46,302,48336,70,NULL,NULL,'2MASX J13383256+2608046',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.0005,NULL,'15.86',0.2,NULL,NULL,NULL,NULL,NULL,1,204.635833,26.13475,0,NULL,58654801605,916481275,14320019,15.86),(111915,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111915,37.93,0.46,385,48337,70,NULL,NULL,'LCRS B133559.1-024054',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000185,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,204.642083,-2.93522,0.065,NULL,43566788717,680731073,10636423,17.9),(111916,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111916,38.07,0.33,411,48338,70,NULL,NULL,'2MASX J13383417-0215550',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,204.642333,-2.26533,0.105,NULL,43569726022,680776969,10637140,17.5),(111917,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111917,37.78,0.17,361,48339,70,NULL,NULL,'LCRS B133559.3-023456',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00012,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,204.642875,-2.83564,0.065,NULL,43566811006,680731421,10636428,17.1),(111918,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111918,37.11,0.65,264,48340,70,NULL,NULL,'2MASX J13383614-3543182',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000117,NULL,'15.4',0.3,'E',NULL,NULL,NULL,NULL,1,204.650667,-35.72172,0.133,NULL,46896494445,732757725,11449339,15.4),(111919,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111919,34.58,0.09,82.6,48341,NULL,NULL,NULL,'ESO 509- G 087',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.04',0.6,'Sc             HII',NULL,NULL,NULL,NULL,1,204.657833,-24.14689,0.209,NULL,43286815693,676356495,10568070,14.04),(111920,'Tully-Fisher','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,NULL,111920,36.51,0.2,200,48342,74.4,NULL,NULL,'CGCG 073-057',NULL,'2013AJ....146...86T',2013,1,0.59,NULL,'G',0.00017,NULL,'15.9g',0.4,NULL,NULL,NULL,NULL,NULL,1,204.6650417,12.45706,0,NULL,58334532490,911477070,14241829,15.9),(111921,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111921,37.59,0.46,330,48343,70,NULL,NULL,'2MASX J13383976+5949065',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000189,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,204.66575,59.81853,0.013,NULL,57387677379,896682459,14010663,17.4),(111922,'FP','2016-12-15 15:15:16','2016-12-16 11:20:29','1',NULL,'R',111922,38.22,0.46,441,48344,70,NULL,NULL,'2MASX J13384053+6123510',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,204.669,61.39747,0.013,NULL,57381621780,896587840,14009185,17.8),(111923,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111923,36.52,0.46,201,48345,70,NULL,NULL,'2MASX J13384126+1931031',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,204.672083,19.51758,0,NULL,58796438500,918694351,14354599,17.3),(111924,'IRAS','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111924,32.25,0.8,28.2,48346,75,NULL,'MAT, I','NGC 5244',NULL,'1997ApJS..109..333W',1997,1,1.7,'The name ESO 270- ? 020 applies to the nominal position for NGC 5219.','G',0.000031,NULL,'13.32',0.6,'Sb:;HII;LINER; Sbrst',NULL,NULL,NULL,'H II',1,204.67375,-45.85597,0.421,NULL,46950540890,733602201,11462534,13.32),(111925,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111925,31.95,0.43,24.5,48346,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5244',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111926,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111926,32.09,0.43,26.2,48346,75,NULL,'3.6 micron, color corrected','NGC 5244',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111927,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111927,32.13,0.47,26.7,48346,NULL,NULL,'H','NGC 5244',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111928,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111928,32.16,0.46,27,48346,NULL,NULL,'J','NGC 5244',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111929,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111929,32.18,0.32,27.3,48346,85,NULL,'I, raw','NGC 5244',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111930,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111930,32.2,0.32,27.5,48346,85,NULL,'I, inv','NGC 5244',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111931,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111931,32.22,0.2,27.8,48346,74.4,NULL,NULL,'NGC 5244',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111932,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111932,32.27,0.45,28.4,48346,NULL,NULL,'K','NGC 5244',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111933,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111933,32.51,0.43,31.7,48346,75,NULL,'MAT, I, raw','NGC 5244',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111934,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111934,32.65,0.43,33.9,48346,75,NULL,'MAT, I, inv','NGC 5244',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111935,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111935,32.74,0.4,35.3,48346,NULL,NULL,'mean','NGC 5244',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111936,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111936,32.83,0.43,36.9,48346,75,NULL,'MAT, I, cor','NGC 5244',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111937,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111937,34.51,0.49,79.7,48347,NULL,NULL,NULL,'ESO 577- G 017',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.46',0.2,'Sb:',NULL,NULL,NULL,NULL,1,204.6760417,-21.81072,0.213,NULL,43770451737,683913308,10686145,15.46),(111938,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111938,34.55,0.2,81.3,48347,74.4,NULL,NULL,'ESO 577- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111939,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111939,34.61,0.47,83.4,48347,NULL,NULL,'Malmquist cor.','ESO 577- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111940,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111940,34.59,0.46,82.9,48348,70,NULL,NULL,'CGCG 161-101',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.00009,NULL,'14.6g',0.69,'E1',NULL,NULL,NULL,NULL,1,204.67975,31.27053,0,NULL,59178572543,924665195,14447893,14.6),(111941,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111941,37.2,0.46,276,48349,70,NULL,NULL,'2MASX J13384364+2139321',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,204.681958333,21.65889,0,NULL,58801688754,918776386,14355881,17.7),(111942,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111942,38.16,0.33,428,48350,70,NULL,NULL,'SDSS J133844.30-004510.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00013,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,204.684583,-0.75303,0.041,NULL,43556604163,680571940,10633936,18.5),(111943,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111943,37.6,0.21,332,48351,70,NULL,NULL,'2MASX J13384473+2538229',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,204.68625,25.63975,0,NULL,58654872843,916482388,14320037,17.4),(111944,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111944,38.87,0.46,594,48352,70,NULL,NULL,'SDSS J133844.74+545533.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000159,NULL,'18.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,204.686417,54.92589,0,NULL,57293783889,895215373,13987740,18.6),(111945,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111945,36.56,0.46,205,48353,70,NULL,NULL,'2MASX J13384492+1525457',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.41',0.21,NULL,NULL,NULL,NULL,NULL,1,204.687083,15.42947,0,NULL,58827246377,919175724,14362120,16.41),(111946,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111946,37.76,0.46,356,48354,70,NULL,NULL,'2MASX J13384575+5629514',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,204.69075,56.49761,0,NULL,57289447516,895147617,13986681,17.8),(111947,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111947,37.48,0.46,314,48355,70,NULL,NULL,'2MASXi J1338463+515057',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00014,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,204.693,51.84961,0.01,NULL,59209618179,925150284,14455473,17.7),(111948,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111948,36.51,0.43,201,48356,NULL,NULL,'Malmquist cor.','2MASX J13384653-3530518',NULL,'2009ApJS..182..474S',2009,1,0.47,NULL,'G',0.00003,NULL,'15.24',0.2,'Sc',NULL,NULL,NULL,NULL,1,204.693833333,-35.51442,0.133,NULL,46896337755,732755277,11449301,15.24),(111949,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111949,36.82,0.37,231,48356,NULL,NULL,NULL,'2MASX J13384653-3530518',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111950,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111950,36.86,0.2,236,48356,74.4,NULL,NULL,'2MASX J13384653-3530518',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111951,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111951,37.01,0.46,252,48357,70,NULL,NULL,'2MASX J13384822+6025130',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,204.701167,60.42014,0.013,NULL,57380221673,896565963,14008843,17.1),(111952,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111952,35.37,0.46,118,48358,70,NULL,NULL,'CGCG 294-056',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000067,NULL,'15.2g',0.56,'S0',NULL,NULL,NULL,NULL,1,204.7037083,56.97922,0,NULL,57286433951,895100530,13985945,15.2),(111953,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111953,38.07,0.33,411,48359,70,NULL,NULL,'2MASX J13384962-0214220',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000179,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,204.70675,-2.23939,0.105,NULL,43570215053,680784610,10637259,16.7),(111954,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111954,35.68,0.46,137,48360,70,NULL,NULL,'2MASX J13384959+4228152',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000176,NULL,'16.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,204.70675,42.47081,0,NULL,59320997656,926890588,14482665,16.4),(111955,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111955,35.95,0.46,155,48361,70,NULL,NULL,'2MASX J13385130+0150130',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000065,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,204.713791667,1.83686,0.047,NULL,58401401198,912521893,14258154,16.8),(111956,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111956,38.01,0.46,399,48362,70,NULL,NULL,'2MASX J13385140+1759141',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,204.714167,17.98733,0,NULL,58826044860,919156950,14361827,17.5),(111957,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111957,37.34,0.46,294,48363,70,NULL,NULL,'2MASX J13385275+4620101',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000167,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,204.7199583,46.33625,0.042,NULL,59285903502,926342242,14474097,17.2),(111958,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111958,38.05,0.73,407,48364,70,NULL,NULL,'2MASX J13385314-4623306',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.0I',0.2,NULL,NULL,NULL,NULL,NULL,1,204.7214583,-46.39189,0.421,NULL,46950713736,733604902,11462576,15),(111959,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111959,38.42,0.46,483,48365,70,NULL,NULL,'SDSS J133853.41+312252.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000174,NULL,'19.28',0.13,NULL,NULL,NULL,NULL,NULL,1,204.722583333,31.38114,0,NULL,59178612606,924665821,14447903,19.28),(111960,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111960,34.81,0.49,91.5,48366,75,NULL,'IR','UGC 08633',NULL,'2011yCatp016004901K',2011,1,1.51,NULL,'G',0.000029,NULL,'15.90',0.17,'Sc',NULL,NULL,NULL,NULL,1,204.723,14.74383,0.023,NULL,58822191792,919096746,14360886,15.9),(111961,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111961,34.87,0.2,94.2,48366,74.4,NULL,NULL,'UGC 08633',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111962,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111962,35.04,NULL,102,48366,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08633',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111963,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111963,35.05,NULL,102,48366,NULL,NULL,'Dipole + Quadrupole','UGC 08633',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111964,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111964,35.05,NULL,102,48366,NULL,NULL,'Dipole','UGC 08633',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111965,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111965,37.47,0.46,312,48367,70,NULL,NULL,'2MASX J13385399+0322150',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000086,NULL,'16.2g',0.45,NULL,NULL,NULL,NULL,NULL,1,204.724916667,3.37069,0.014,NULL,58395932839,912436450,14256819,16.2),(111966,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111966,37.21,0.73,276,48368,70,NULL,NULL,'ESO 383- G 053',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.00013,NULL,'15.89',0.2,'S...',NULL,NULL,NULL,NULL,1,204.7274583,-36.44731,0.161,NULL,46892698093,732698407,11448412,15.89),(111967,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111967,36.48,0.53,198,48369,NULL,NULL,'Malmquist cor.','2MFGC 11014',NULL,'2009ApJS..182..474S',2009,1,0.66,NULL,'G',0.00003,NULL,'15.38',NULL,'Sc',NULL,NULL,NULL,NULL,1,204.7277083,-35.62581,0.133,NULL,46896359009,732755609,11449306,15.38),(111968,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111968,36.58,0.49,207,48369,75,NULL,'IR','2MFGC 11014',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111969,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111969,36.97,0.42,248,48369,NULL,NULL,NULL,'2MFGC 11014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111970,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111970,37.01,0.2,252,48369,74.4,NULL,NULL,'2MFGC 11014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111971,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111971,36.72,0.46,221,48370,70,NULL,NULL,'2MASX J13385551+6213221',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,204.7310417,62.22269,0.033,NULL,57378433253,896538019,14008406,16.9),(111972,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111972,37.4,0.63,302,48371,70,NULL,NULL,'2MASX J13385582-3048438',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.6b',0.3,'E',NULL,NULL,NULL,NULL,1,204.732541667,-30.81214,0.133,NULL,46902917371,732858083,11450907,16.6),(111973,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111973,38.25,0.46,446,48372,70,NULL,NULL,'2MASX J13385625+1158104',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000147,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,204.7345417,11.96978,0,NULL,58451865889,913310404,14270475,17.4),(111974,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111974,38.02,0.46,402,48373,70,NULL,NULL,'2MASX J13385715+1752266',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,204.738125,17.87411,0,NULL,58826092719,919157698,14361839,NULL),(111975,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111975,36.06,0.46,163,48374,70,NULL,NULL,'MCG +04-32-017',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.000182,NULL,'15.1g',0.5,'S-','Field galaxy',NULL,NULL,NULL,1,204.738875,24.98022,0,NULL,58657132071,916517688,14320588,15.1),(111976,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111976,36.96,0.61,247,48375,70,NULL,NULL,'2MASX J13385791-3533348',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000107,NULL,'16.3b',0.4,'E',NULL,NULL,NULL,NULL,1,204.741333333,-35.55975,0.133,NULL,46896357994,732755593,11449306,16.3),(111977,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111977,37.73,0.27,352,48376,70,NULL,NULL,'2MASX J13385902-0153450',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,204.7460417,-1.89583,0.073,NULL,43570401485,680787523,10637305,17.5),(111978,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111978,36.71,0.12,220,48377,70,NULL,NULL,'ABELL 3566',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II     [BM];RI [A]',NULL,NULL,NULL,NULL,1,204.7474583,-35.55361,0.133,NULL,46896366045,732755719,11449308,NULL),(111979,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111979,36.94,0.33,244,48378,70,NULL,NULL,'2MASX J13385978+3102214',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000133,NULL,'16.2g',0.35,'E0',NULL,NULL,NULL,NULL,1,204.7489583,31.03928,0,NULL,59178738016,924667781,14447934,16.2),(111980,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111980,37.67,0.46,342,48379,70,NULL,NULL,'2MASX J13385974+2532219',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,204.749,25.53942,0,NULL,58656917342,916514333,14320536,17),(111981,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111981,32.34,0.4,29.4,48380,75,NULL,'B','UGC 08639',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.000033,NULL,'15.0',1.1,'Im:',NULL,NULL,NULL,NULL,1,204.749167,51.43472,0,NULL,59209457434,925147772,14455433,15),(111982,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111982,36.05,0.5,162,48381,70,NULL,NULL,'2MFGC 11016',NULL,'2014MNRAS.445.2677S',2014,1,0.8,'6dF DR2 has z = 0.039549.','G',0.00015,NULL,'14.76',0.3,'Sp',NULL,NULL,NULL,NULL,1,204.749208333,-32.60131,0.117,NULL,46905269566,732894836,11451481,14.76),(111983,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111983,38.13,0.33,423,48382,70,NULL,NULL,'2MASX J13390027+5904507',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,204.751083333,59.08075,0.017,NULL,57267214505,894800226,13981253,18.1),(111984,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111984,36.71,0.12,220,48383,70,NULL,'ABELL 3566, BGC','2MASX J13390299-3532558',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'G',0.000183,NULL,'15.9',NULL,'E',NULL,NULL,NULL,NULL,1,204.7624583,-35.54894,0.133,NULL,46896369185,732755768,11449308,15.9),(111985,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111985,35.61,0.48,132,48384,NULL,NULL,'Malmquist cor.','ESO 509- G 089',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'16.48',0.3,'Sb:',NULL,NULL,NULL,NULL,1,204.766417,-24.16706,0.209,NULL,43286804940,676356327,10568067,16.48),(111986,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111986,35.6,0.49,132,48384,NULL,NULL,NULL,'ESO 509- G 089',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111987,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111987,35.64,0.2,134,48384,74.4,NULL,NULL,'ESO 509- G 089',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111988,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111988,36.83,0.46,233,48385,70,NULL,NULL,'2MASX J13390406+3153024',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.2g',0.25,'E2',NULL,NULL,NULL,NULL,1,204.766833,31.88403,0,NULL,59186421043,924787828,14449809,17.2),(111989,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111989,35.3,0.46,115,48386,70,NULL,NULL,'2MASX J13390436-0317340',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000166,NULL,'16.0g',0.3,'S0^-',NULL,NULL,NULL,NULL,1,204.768167,-3.29283,0.029,NULL,43559361400,680615021,10634609,16),(111990,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111990,36.82,0.33,231,48387,70,NULL,NULL,'2MASX J13390506+3350064',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000208,NULL,'16.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,204.7712917,33.83508,0,NULL,59189204563,924831321,14450489,16.3),(111991,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111991,38.34,0.46,465,48388,70,NULL,NULL,'2MASX J13390656-0150300',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,204.7775,-1.84167,0.121,NULL,43570277681,680785588,10637274,17.9),(111992,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111992,39.18,0.46,686,48389,70,NULL,NULL,'2MASX J13390677+2411468',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,204.778083333,24.19642,0,NULL,58655522690,916492542,14320195,18.4),(111993,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111993,37.51,0.46,318,48390,70,NULL,NULL,'2MASX J13390746+0426360',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,204.781125,4.44336,0.007,NULL,58440822894,913137857,14267779,17.9),(111994,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111994,36.13,0.46,169,48391,70,NULL,NULL,'2MASX J13390765+1321331',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000156,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,204.782,13.35928,0,NULL,58334959603,911483743,14241933,16.8),(111995,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111995,38.16,0.33,428,48392,70,NULL,NULL,'2MASX J13390822-0054190',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000092,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,204.784166667,-0.90542,0.041,NULL,43568206300,680753223,10636769,16.7),(111996,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111996,36.75,0.33,224,48393,70,NULL,NULL,'2MASX J13390923+6558102',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000074,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,204.7882083,65.96956,0.081,NULL,57881376158,904396502,14131195,16.3),(111997,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111997,34.36,0.56,74.4,48394,70,NULL,NULL,'2MASX J13391025-3044357',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.6',NULL,'E',NULL,NULL,NULL,NULL,1,204.792791667,-30.74319,0.133,NULL,46847378900,731990295,11437348,15.6),(111998,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',111998,35.69,0.46,137,48395,70,NULL,NULL,'UGC 08649',NULL,'2015arXiv151105856S',2015,1,1.25,NULL,'G',0.000187,NULL,'14.5g',0.72,'E              AGN','Isolated galaxy',NULL,NULL,NULL,1,204.798458333,61.50603,0.013,NULL,57381639774,896588121,14009189,14.5),(111999,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,111999,36.46,0.75,196,48396,70,NULL,NULL,'2MASX J13391177-3536157',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.1b',0.3,'(R\':)SA(r)a:',NULL,NULL,NULL,NULL,1,204.798917,-35.60444,0.133,NULL,46896360136,732755627,11449306,16.1),(112000,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112000,36.39,0.55,189,48397,70,NULL,NULL,'2MASX J13391513-1619235',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,204.813,-16.32314,0.221,NULL,43781920412,684092506,10688945,14.4),(112001,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112001,36.33,0.46,184,48398,70,NULL,NULL,'2MASX J13391521+4520511',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,204.8135,45.34756,0,NULL,59317473361,926835521,14481805,17.1),(112002,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112002,38.33,0.46,464,48399,70,NULL,NULL,'SDSS J133915.30+141132.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000131,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,204.8137917,14.19242,0,NULL,58336877399,911513709,14242401,18.5),(112003,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112003,37.22,0.46,279,48400,70,NULL,NULL,'2MASX J13391632+1012555',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,204.818083,10.21547,0.036,NULL,58422133038,912845828,14263216,17.6),(112004,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112004,37.3,0.46,288,48401,70,NULL,NULL,'2MASX J13391635+1554041',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.38',0.14,NULL,NULL,NULL,NULL,NULL,1,204.818166667,15.90125,0,NULL,58828184527,919190383,14362349,18.38),(112005,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112005,37.6,0.21,332,48402,70,NULL,NULL,'2MASX J13391650+2547478',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,204.818833333,25.79669,0,NULL,58654960532,916483758,14320058,17.3),(112006,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112006,37.73,0.27,352,48403,70,NULL,NULL,'2MASX J13391730-0150486',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000171,NULL,'16.6g',0.31,'AGN',NULL,NULL,NULL,NULL,1,204.8222917,-1.84686,0.121,NULL,43570280172,680785627,10637275,16.6),(112007,'IRAS','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112007,34.84,0.8,93,48404,75,NULL,'HMCL, I','VV 422',NULL,'1997ApJS..109..333W',1997,1,1.14,NULL,'G',0.000027,NULL,'15.0g',0.39,NULL,NULL,NULL,NULL,NULL,1,204.8255,12.72403,0,NULL,58335269888,911488592,14242009,15),(112008,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112008,34.86,0.4,93.6,48404,75,NULL,'HMCL, I, raw','VV 422',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112009,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112009,34.99,0.4,99.3,48404,75,NULL,'HMCL, I, inv','VV 422',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112010,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112010,35.02,0.2,101,48404,74.4,NULL,NULL,'VV 422',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112011,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112011,35.03,0.4,102,48404,75,NULL,'HMCL, I, cor','VV 422',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112012,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112012,38.66,0.46,539,48405,70,NULL,NULL,'2MASX J13391925+3735073',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,204.830166667,37.58544,0,NULL,59143970694,924124542,14439445,18.2),(112013,'Brightest Stars','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112013,26.77,NULL,2.3,48406,NULL,NULL,NULL,'UGC 08638',NULL,'1998A&AS..128..459M',1998,1,1.2,NULL,'G',0.000001,NULL,'14.47',0.8,'Im',NULL,NULL,NULL,'Emission-Line Galaxy',1,204.830833,24.77558,0,1,58656648129,916510127,14320470,14.47),(112014,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112014,28.14,0.1,4.24,48406,NULL,NULL,NULL,'UGC 08638',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112015,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112015,28.15,NULL,4.27,48406,NULL,NULL,NULL,'UGC 08638',NULL,'2006AJ....131.1361K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112016,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112016,28.16,0.03,4.29,48406,NULL,NULL,'I','UGC 08638',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112017,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112017,28.16,0.1,4.29,48406,74.4,NULL,NULL,'UGC 08638',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112018,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112018,28.17,0.06,4.31,48406,NULL,NULL,NULL,'UGC 08638',NULL,'2013AstBu..68..125M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112019,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112019,37.27,0.46,284,48407,70,NULL,NULL,'2MASX J13392153+0619459',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.18',0.17,NULL,NULL,NULL,NULL,NULL,1,204.839667,6.32939,0.03,NULL,58426151965,912908624,14264197,18.18),(112020,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112020,36.51,0.4,200,48408,NULL,NULL,NULL,'AGC 530541',NULL,'2009ApJS..182..474S',2009,1,0.34,NULL,'G',0.000033,NULL,'16.21',NULL,'Sc',NULL,NULL,NULL,NULL,1,204.8412083,-35.72036,0.133,NULL,46896351003,732755484,11449304,16.21),(112021,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112021,36.51,0.4,200,48408,NULL,NULL,'Malmquist cor.','AGC 530541',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112022,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112022,36.55,0.2,204,48408,74.4,NULL,NULL,'AGC 530541',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112023,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112023,36.77,0.46,226,48409,70,NULL,NULL,'SDSS J133923.02+434721.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,204.845958333,43.78931,0,NULL,59319107199,926861049,14482203,17.8),(112024,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112024,33.49,0.46,49.9,48410,70,NULL,NULL,'ESO 445- G 002',NULL,'2014MNRAS.445.2677S',2014,1,2.4,NULL,'G',0.00007,NULL,'12.78',2,'SA0-','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,204.847833,-30.77406,0.133,NULL,46847377716,731990276,11437348,12.78),(112025,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112025,34.86,0.6,93.9,48411,70,NULL,NULL,'2MASX J13392470-1132489',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'15.19',NULL,NULL,NULL,NULL,NULL,NULL,1,204.852917,-11.54692,0.141,NULL,43688029752,682625464,10666022,15.19),(112026,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112026,37.14,0.46,267,48412,70,NULL,NULL,'2MASX J13392497-0141306',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000168,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,204.854125,-1.692,0.033,NULL,43570242163,680785033,10637266,16.6),(112027,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112027,38.32,0.46,461,48413,70,NULL,NULL,'2MASX J13392513+1139339',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000178,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,204.854917,11.65947,0,NULL,58451928458,913311382,14270490,17.6),(112028,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112028,37.99,0.46,396,48414,70,NULL,NULL,'2MASXi J1339258+583725',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000145,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,204.858083,58.62389,0.021,NULL,57265513540,894773649,13980838,17.7),(112029,'IRAS','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112029,35.08,0.8,104,48415,75,NULL,'MAT, I','ESO 383- G 055',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'15.01',0.6,'S              HII',NULL,NULL,NULL,NULL,1,204.86325,-34.18633,0.121,NULL,46908107885,732939185,11452174,15.01),(112030,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112030,34.55,0.43,81.2,48415,75,NULL,'MAT, I, raw','ESO 383- G 055',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112031,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112031,34.56,0.32,81.8,48415,85,NULL,'I, raw','ESO 383- G 055',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112032,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112032,34.62,0.32,84,48415,85,NULL,'I, inv','ESO 383- G 055',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112033,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112033,34.8,0.43,91.3,48415,75,NULL,'MAT, I, inv','ESO 383- G 055',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112034,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112034,34.83,0.43,92.6,48415,75,NULL,'MAT, I, cor','ESO 383- G 055',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112035,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112035,35.27,0.4,113,48415,NULL,NULL,'mean','ESO 383- G 055',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112036,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112036,35.43,0.49,122,48415,75,NULL,'IR','ESO 383- G 055',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112037,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112037,35.47,0.47,124,48415,NULL,NULL,'H','ESO 383- G 055',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112038,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112038,35.55,0.49,129,48415,NULL,NULL,'Malmquist cor.','ESO 383- G 055',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112039,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112039,35.59,0.48,131,48415,NULL,NULL,NULL,'ESO 383- G 055',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112040,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112040,35.63,0.2,134,48415,74.4,NULL,NULL,'ESO 383- G 055',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112041,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112041,37.37,0.46,298,48416,70,NULL,NULL,'SDSS J133928.29+614837.2',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000156,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,204.867917,61.81036,0.045,NULL,57381614922,896587733,14009183,16.8),(112042,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112042,32.48,NULL,31.3,48417,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08642',NULL,'2010Ap&SS.325..163P',2010,1,1.28,NULL,'G',0.000009,NULL,'16.1g',0.21,'Sm',NULL,NULL,NULL,NULL,1,204.8704583,46.01544,0.029,NULL,59285749926,926339842,14474060,16.1),(112043,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112043,32.51,NULL,31.7,48417,NULL,NULL,'Dipole + Quadrupole','UGC 08642',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112044,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112044,32.51,NULL,31.8,48417,NULL,NULL,'Dipole','UGC 08642',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112045,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112045,32.55,0.2,32.4,48417,74.4,NULL,NULL,'UGC 08642',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112046,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112046,32.59,0.43,32.9,48417,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08642',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112047,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112047,32.61,0.43,33.2,48417,75,NULL,'3.6 micron, color corrected','UGC 08642',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112048,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112048,33.16,NULL,42.9,48417,NULL,NULL,NULL,'UGC 08642',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112049,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112049,38.35,0.46,468,48418,70,NULL,NULL,'SDSS J133929.26+091316.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,204.871916667,9.22119,0,NULL,58419728492,912808257,14262629,18.5),(112050,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112050,34.99,0.46,99.4,48419,70,NULL,NULL,'CGCG 161-107 NED01',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00009,NULL,'15.5g',0.46,'S','Field galaxy',NULL,NULL,NULL,1,204.8850417,27.92867,0,NULL,59137567090,924024485,14437882,15.5),(112051,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112051,38.77,0.46,568,48420,70,NULL,NULL,'2MASX J13393275+1221358',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000167,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,204.886333333,12.35981,0,NULL,58334463479,911475991,14241812,18.6),(112052,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112052,35.15,0.46,107,48421,70,NULL,NULL,'2MASX J13393395+2533218',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000174,NULL,'15.7g',0.35,NULL,'Field galaxy',NULL,NULL,NULL,1,204.891375,25.55611,0,NULL,58654754554,916480539,14320008,15.7),(112053,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112053,37.72,0.46,350,48422,70,NULL,NULL,'2MASX J13393415+0119564',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000087,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,204.892458333,1.33231,0.041,NULL,58400183383,912502865,14257857,17.1),(112054,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112054,35.16,1.2,107,48423,NULL,NULL,'Malmquist cor.','ESO 577- G 020',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'14.66',1.2,'Sc',NULL,NULL,NULL,NULL,1,204.893083,-22.49794,0.217,NULL,43756354703,683693042,10682703,14.66),(112055,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112055,35.29,1.13,114,48423,NULL,NULL,NULL,'ESO 577- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112056,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112056,35.33,0.2,116,48423,74.4,NULL,NULL,'ESO 577- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112057,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112057,36.77,0.46,226,48424,70,NULL,NULL,'2MASX J13393495+1827188',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.25',0.13,NULL,NULL,NULL,NULL,NULL,1,204.895583333,18.45517,0.019,NULL,58842096071,919407751,14365746,18.25),(112058,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112058,37.3,0.46,288,48425,70,NULL,NULL,'2MASX J13393587+3542285',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000124,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,204.899375,35.70806,0,NULL,59176826907,924637920,14447467,18.1),(112059,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112059,37.78,0.17,361,48426,70,NULL,NULL,'LCRS B133701.5-022530',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000147,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,204.901833333,-2.67814,0.085,NULL,43566963946,680733811,10636465,17),(112060,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112060,38.2,0.33,436,48427,70,NULL,NULL,'2MASX J13393649+5319426',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,204.9019583,53.3285,0,NULL,57278552306,894977379,13984021,17.3),(112061,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112061,37.62,0.46,334,48428,70,NULL,NULL,'2MASX J13393696+1357598',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000142,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,204.904083333,13.96672,0.014,NULL,58336891227,911513925,14242405,17.3),(112062,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112062,34.43,0.16,76.9,48429,NULL,NULL,'B, Hubble-type-TF','ESO 383- G 056',NULL,'2005Ap&SS.298..577R',2005,1,1.4,NULL,'G',0.00003,NULL,'15.49',0.6,'Sb',NULL,NULL,NULL,NULL,1,204.904,-32.89303,0.117,NULL,46908858467,732950913,11452358,15.49),(112063,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112063,35.74,0.48,141,48429,NULL,NULL,'Malmquist cor.','ESO 383- G 056',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112064,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112064,35.82,0.46,146,48429,NULL,NULL,NULL,'ESO 383- G 056',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112065,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112065,35.86,0.2,149,48429,74.4,NULL,NULL,'ESO 383- G 056',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112066,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112066,37.78,0.17,361,48430,70,NULL,NULL,'LCRS B133702.2-023020',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,204.905083,-2.75853,0.073,NULL,43566968750,680733886,10636466,17.5),(112067,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112067,36.96,0.46,247,48431,70,NULL,NULL,'2MASX J13393738+5622367',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000182,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,204.90575,56.37703,0,NULL,57289469822,895147965,13986686,16.2),(112068,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112068,37.95,0.46,389,48432,70,NULL,NULL,'2MASX J13393787+1653008',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,204.90775,16.88339,0,NULL,58828540237,919195941,14362436,17.5),(112069,'IRAS','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112069,32.63,0.8,33.5,48433,75,NULL,'MAT, I','NGC 5254',NULL,'1997ApJS..109..333W',1997,1,3.2,NULL,'G',0.000019,NULL,'12.74',1.5,'SA(rs)c:',NULL,NULL,NULL,NULL,1,204.9079583,-11.49386,0.153,NULL,43688005707,682625089,10666017,12.74),(112070,'Sosies','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112070,32.33,0.11,29.2,48433,NULL,NULL,NULL,'NGC 5254',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112071,'Tully est','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112071,32.7,0.8,34.6,48433,75,NULL,NULL,'NGC 5254',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112072,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112072,32.21,0.4,27.7,48433,NULL,NULL,NULL,'NGC 5254',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112073,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112073,32.39,0.43,30,48433,75,NULL,'3.6 micron, color corrected','NGC 5254',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112074,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112074,32.39,0.2,30.1,48433,74.4,NULL,NULL,'NGC 5254',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112075,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112075,32.41,0.32,30.4,48433,85,NULL,'I, raw','NGC 5254',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112076,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112076,32.45,0.43,30.9,48433,75,NULL,'MAT, I, raw','NGC 5254',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112077,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112077,32.45,0.43,30.9,48433,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5254',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112078,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112078,32.46,0.32,31.1,48433,85,NULL,'I, inv','NGC 5254',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112079,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112079,32.58,0.4,32.8,48433,NULL,NULL,NULL,'NGC 5254',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112080,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112080,32.59,0.4,33,48433,NULL,NULL,'Malmquist cor.','NGC 5254',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112081,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112081,32.63,0.46,33.6,48433,NULL,NULL,'J','NGC 5254',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112082,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112082,32.66,0.47,34,48433,NULL,NULL,'H','NGC 5254',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112083,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112083,32.66,0.43,34.1,48433,75,NULL,'MAT, I, inv','NGC 5254',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112084,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112084,32.66,0.43,34.1,48433,75,NULL,'MAT, I, cor','NGC 5254',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112085,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112085,32.77,0.4,35.8,48433,NULL,NULL,'mean','NGC 5254',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112086,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112086,32.78,0.45,36,48433,NULL,NULL,'K','NGC 5254',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112087,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112087,37.83,0.33,368,48434,70,NULL,NULL,'2MASX J13393886+2612499',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,204.912,26.21389,0,NULL,59125463179,923835362,14434927,17.6),(112088,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112088,36.42,0.46,192,48435,70,NULL,NULL,'2MASX J13393885+2724169',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000147,NULL,'15.6g',0.53,'Elliptical','Field galaxy',NULL,NULL,NULL,1,204.9120417,27.40458,0,NULL,59137474299,924023035,14437859,15.6),(112089,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112089,36.07,0.57,164,48436,70,NULL,NULL,'2MASX J13393894-3529177',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'16.5b',NULL,'S0',NULL,NULL,NULL,NULL,1,204.91225,-35.48833,0.137,NULL,46896378095,732755907,11449311,16.5),(112090,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112090,38.22,0.46,440,48437,70,NULL,NULL,'2MASX J13394102+0027334',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000088,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,204.921,0.45931,0.017,NULL,58385873238,912279269,14254363,17.5),(112091,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112091,38.29,0.46,456,48438,70,NULL,NULL,'SDSS J133941.51-005257.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00008,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,204.9229583,-0.88278,0.041,NULL,43568252521,680753945,10636780,18.7),(112092,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112092,38.85,0.46,588,48439,70,NULL,NULL,'SDSS J133942.39+262843.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000127,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,204.926667,26.47864,0,NULL,59125946320,923842911,14435045,18.4),(112093,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112093,37.49,0.46,314,48440,70,NULL,NULL,'2MASX J13394258+4855066',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,204.927375,48.91844,0,NULL,59213338258,925208410,14456381,17.5),(112094,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112094,36.68,0.46,216,48441,70,NULL,NULL,'2MASX J13394282+3818535',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,204.928375,38.31483,0,NULL,59265639591,926025618,14469150,17.1),(112095,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112095,37.74,0.46,353,48442,70,NULL,NULL,'2MASX J13394283+4507334',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,204.9285,45.12589,0,NULL,59319539836,926867809,14482309,17.2),(112096,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112096,37.95,0.33,390,48443,70,NULL,NULL,'2MASX J13394309+4940586',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000172,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,204.9297083,49.68311,0,NULL,59221686159,925338846,14458419,17.6),(112097,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112097,37.88,0.46,377,48444,70,NULL,NULL,'2MASX J13394403-0104176',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000077,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,204.933375,-1.07172,0.041,NULL,43568289187,680754518,10636789,17.9),(112098,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112098,38.12,0.46,420,48445,70,NULL,NULL,'2MASX J13394400+0711039',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,204.933416667,7.18439,0.014,NULL,58425831020,912903609,14264118,17.4),(112099,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112099,37.92,0.27,384,48446,70,NULL,NULL,'2MASX J13394674+1848208',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.33',0.13,NULL,NULL,NULL,NULL,NULL,1,204.944625,18.80572,0,NULL,58795895977,918685874,14354466,18.33),(112100,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112100,37.19,0.46,274,48447,70,NULL,NULL,'2MASX J13394703+0536064',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,204.946083333,5.60183,0.015,NULL,58442887447,913170116,14268283,17.6),(112101,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112101,37.28,0.46,286,48448,70,NULL,NULL,'2MASX J13394815+5102036',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00021,NULL,'16.0g',0.37,NULL,NULL,NULL,NULL,NULL,1,204.950625,51.03431,0,NULL,59222006007,925343843,14458497,16),(112102,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112102,36.34,0.46,186,48449,70,NULL,NULL,'MCG +06-30-067',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000083,NULL,'15.1g',0.51,'E6',NULL,NULL,NULL,NULL,1,204.951667,33.68817,0,NULL,59189180599,924830946,14450483,15.1),(112103,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112103,37.85,0.46,372,48450,70,NULL,NULL,'2MASX J13394907+4345414',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000186,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,204.954583,43.76161,0,NULL,59319099361,926860927,14482201,17.3),(112104,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112104,34.12,0.2,66.7,48451,74.4,NULL,NULL,'ESO 577- G 022',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000033,NULL,'14.85',0.4,'Sb',NULL,NULL,NULL,NULL,1,204.956875,-22.30272,0.249,NULL,43756326806,683692606,10682696,14.85),(112105,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112105,34.26,0.48,71.2,48451,NULL,NULL,NULL,'ESO 577- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112106,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112106,34.41,0.45,76.1,48451,NULL,NULL,'Malmquist cor.','ESO 577- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112107,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112107,37.73,0.27,352,48452,70,NULL,NULL,'2MASX J13395007-0200050',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000177,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,204.958625,-2.00128,0.121,NULL,43570076795,680782449,10637225,17.6),(112108,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112108,38.11,0.46,419,48453,70,NULL,NULL,'2MASX J13395011+4050464',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000156,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,204.9587083,40.84631,0,NULL,59313318151,926770596,14480790,18.4),(112109,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112109,37.17,0.46,271,48454,70,NULL,NULL,'SDSS J133950.40+105415.4',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,204.9600417,10.90431,0.018,NULL,58419069646,912797963,14262468,17.8),(112110,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112110,34.37,0.53,74.8,48455,70,NULL,NULL,'2MASX J13395060-0738321',NULL,'2014MNRAS.445.2677S',2014,1,0.81,NULL,'G',0.000143,NULL,'15.09',0.71,NULL,NULL,NULL,NULL,NULL,1,204.960875,-7.6425,0.029,NULL,43580190731,680940480,10639695,15.09),(112111,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112111,37.78,0.17,361,48456,70,NULL,NULL,'LCRS B133715.9-022340',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000191,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,204.962,-2.64728,0.085,NULL,43566958427,680733725,10636464,17.7),(112112,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112112,36.67,0.46,216,48457,70,NULL,NULL,'2MASX J13395190+0553124',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.40',0.16,NULL,NULL,NULL,NULL,NULL,1,204.966375,5.88686,0.027,NULL,58442656931,913166514,14268226,18.4),(112113,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112113,37.83,0.33,368,48458,70,NULL,NULL,'2MASX J13395201+2610130',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.6g',0.21,NULL,'Group member',NULL,NULL,NULL,1,204.966833,26.17036,0,NULL,59125449045,923835141,14434924,17.6),(112114,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112114,37.6,0.33,331,48459,70,NULL,NULL,'2MASX J13395211+5317135',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00017,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,204.9672917,53.28722,0,NULL,57278673187,894979268,13984051,17.6),(112115,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112115,36.94,0.46,244,48460,70,NULL,NULL,'SDSS J133952.26+525928.9',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000161,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,204.967791667,52.99139,0,NULL,59208998900,925140607,14455321,17),(112116,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112116,37.82,0.46,366,48461,70,NULL,NULL,'2MASX J13395234+5820323',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000184,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,204.9682083,58.34244,0.025,NULL,57265684148,894776314,13980879,16.9),(112117,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112117,36,0.68,158,48462,70,NULL,NULL,'2MASX J13395283-3032041',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.1',NULL,'*+Sp',NULL,NULL,NULL,NULL,1,204.970083,-30.53439,0.145,NULL,46847490905,731992045,11437375,16.1),(112118,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112118,36.32,0.46,183,48463,70,NULL,NULL,'2MASX J13395325+6203491',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000177,NULL,'16.0g',0.35,'E0',NULL,NULL,NULL,NULL,1,204.97175,62.06367,0.045,NULL,57378880470,896545007,14008515,16),(112119,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112119,36.17,0.56,171,48464,70,NULL,NULL,'2MASX J13395334-4707180',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,204.9722917,-47.12167,0.541,NULL,46950431791,733600496,11462507,14.6),(112120,'Brightest Stars','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112120,27.66,NULL,3.4,48465,NULL,NULL,NULL,'UGC 08651',NULL,'1998A&AS..128..459M',1998,1,2.3,NULL,'G',0.000001,NULL,'14.7',1.3,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,204.97425,40.73908,0,NULL,59313343019,926770984,14480796,14.7),(112121,'Brightest Stars','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112121,28.7,NULL,5.4,48465,NULL,NULL,NULL,'UGC 08651',NULL,'2003AJ....125.1247H',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112122,'SBF','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112122,28.2,0.2,4.37,48465,NULL,NULL,NULL,'UGC 08651',NULL,'2003AJ....125.1247H',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112123,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112123,27.39,0.21,3.01,48465,NULL,NULL,NULL,'UGC 08651',NULL,'2002A&A...389..812K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112124,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112124,27.4,0.05,3.02,48465,NULL,NULL,NULL,'UGC 08651',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112125,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112125,27.41,0.13,3.04,48465,NULL,NULL,NULL,'UGC 08651',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112126,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112126,27.44,NULL,3.07,48465,NULL,NULL,NULL,'UGC 08651',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112127,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112127,27.45,0.1,3.09,48465,NULL,NULL,NULL,'UGC 08651',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112128,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112128,27.46,0.04,3.1,48465,NULL,NULL,'I','UGC 08651',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112129,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112129,27.45,0.07,3.1,48465,NULL,NULL,NULL,'UGC 08651',NULL,'2013AstBu..68..125M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112130,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112130,27.47,0.08,3.12,48465,74.4,NULL,NULL,'UGC 08651',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112131,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112131,27.49,0.03,3.14,48465,NULL,NULL,'I','UGC 08651',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112132,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112132,27.66,0.4,3.4,48465,75,NULL,'B','UGC 08651',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112133,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112133,36.82,0.33,232,48466,70,NULL,NULL,'2MASX J13395401+2240398',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,204.975333333,22.67772,0,NULL,58790528592,918602009,14353156,17.2),(112134,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112134,36.97,0.71,248,48467,70,NULL,NULL,'2MASX J13395431-0755401',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,204.976333,-7.92778,0.029,NULL,43584823805,681012871,10640826,16.4),(112135,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112135,36.02,0.58,160,48468,70,NULL,NULL,'2MASX J13395498-2117365',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.00',NULL,NULL,NULL,NULL,NULL,NULL,1,204.9792083,-21.29367,0.237,NULL,43770106478,683907913,10686061,16),(112136,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112136,33.63,0.49,53.3,48469,75,NULL,'IR','NGC 5263',NULL,'2011yCatp016004901K',2011,1,1.6,NULL,'G',0.000057,NULL,'14.28',0.4,'S+','Field galaxy',NULL,NULL,NULL,1,204.981833,28.40058,0,NULL,59137218211,924019034,14437797,14.28),(112137,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112137,33.83,0.47,58.4,48469,NULL,NULL,'H','NGC 5263',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112138,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112138,33.89,0.45,60.1,48469,NULL,NULL,'K','NGC 5263',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112139,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112139,33.93,0.46,61,48469,NULL,NULL,'J','NGC 5263',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112140,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112140,34.21,0.4,69.5,48469,NULL,NULL,'mean','NGC 5263',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112141,'Cepheids','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112141,27.39,0.18,3.01,48470,NULL,NULL,'MW HIPP','NGC 5253',NULL,'2002A&A...389...19P',2002,1,5,NULL,'G',0.00001,NULL,'10.87',1.9,'Im pec;HII     Sbrst','Group member, radial-velocity confirmed',NULL,NULL,'Flat-Spectrum Radio Source',1,204.983167,-31.64011,0.185,NULL,46905029114,732891079,11451423,10.87),(112142,'Cepheids','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112142,27.4,0.15,3.02,48470,NULL,NULL,'8, VI +Z','NGC 5253',NULL,'1997ApJ...491...13K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112143,'Cepheids','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112143,27.42,0.12,3.04,48470,NULL,NULL,'7, VI +Z','NGC 5253',NULL,'2001ApJ...547L.103G',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112144,'Cepheids','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112144,27.48,0.34,3.13,48470,NULL,NULL,'MW P02','NGC 5253',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112145,'Cepheids','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112145,27.49,0.12,3.14,48470,NULL,NULL,'7, VI','NGC 5253',NULL,'2001ApJ...547L.103G',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112146,'Cepheids','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112146,27.49,0.14,3.15,48470,NULL,NULL,'4, VI, +Z, KEY PROJECT','NGC 5253',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112147,'Cepheids','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112147,27.53,0.14,3.21,48470,NULL,NULL,'30, VI','NGC 5253',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112148,'Cepheids','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112148,27.53,0.17,3.21,48470,NULL,NULL,'LMC W01','NGC 5253',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112149,'Cepheids','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112149,27.53,0.14,3.21,48470,NULL,NULL,'MW GFG','NGC 5253',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112150,'Cepheids','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112150,27.56,0.14,3.25,48470,NULL,NULL,'4, VI, KEY PROJECT','NGC 5253',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112151,'Cepheids','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112151,27.57,0.13,3.27,48470,NULL,NULL,'8, VI','NGC 5253',NULL,'1997ApJ...491...13K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112152,'Cepheids','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112152,27.61,0.11,3.33,48470,NULL,NULL,'HST KP Calibrated','NGC 5253',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112153,'Cepheids','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112153,27.61,0.11,3.33,48470,NULL,NULL,'ALLFRAME','NGC 5253',NULL,'2000ApJ...529..723G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112154,'Cepheids','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112154,27.63,0.14,3.36,48470,NULL,NULL,'LMC VIHJK','NGC 5253',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112155,'Cepheids','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112155,27.75,0.06,3.55,48470,74.4,NULL,NULL,'NGC 5253',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112156,'Cepheids','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112156,27.78,0.24,3.59,48470,NULL,NULL,'cte MW GFG98','NGC 5253',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112157,'Cepheids','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112157,27.79,NULL,3.61,48470,NULL,NULL,'13, VI','NGC 5253',NULL,'2006A&A...452..423P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112158,'Cepheids','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112158,27.83,0.24,3.69,48470,NULL,NULL,'cte MW STS03','NGC 5253',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112159,'Cepheids','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112159,27.85,0.24,3.71,48470,NULL,NULL,'cte MW FSG03','NGC 5253',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112160,'Cepheids','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112160,27.85,0.25,3.72,48470,NULL,NULL,'cte LMC K03','NGC 5253',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112161,'Cepheids','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112161,27.87,0.25,3.75,48470,NULL,NULL,'cte LMC STS02','NGC 5253',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112162,'Cepheids','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112162,27.87,0.25,3.75,48470,NULL,NULL,'cte U99','NGC 5253',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112163,'Cepheids','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112163,27.88,0.24,3.77,48470,NULL,NULL,'cte MF91','NGC 5253',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112164,'Cepheids','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112164,27.96,0.05,3.91,48470,NULL,NULL,'BVRI','NGC 5253',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112165,'Cepheids','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112165,28,0.05,3.98,48470,NULL,NULL,'BVRI+','NGC 5253',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112166,'Cepheids','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112166,28.04,0.26,4.06,48470,NULL,NULL,NULL,'NGC 5253',NULL,'2003ApJ...590..256T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112167,'Cepheids','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112167,28.05,0.27,4.07,48470,NULL,18.54,'LMC ZP','NGC 5253',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112168,'Cepheids','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112168,28.08,0.1,4.13,48470,NULL,NULL,NULL,'NGC 5253',NULL,'1995ApJ...438....8S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112169,'Cepheids','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112169,28.08,0.34,4.13,48470,NULL,NULL,'ALLFRAME, Key Project','NGC 5253',NULL,'2000ApJ...529..723G',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112170,'Cepheids','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112170,28.09,0.1,4.15,48470,NULL,NULL,'5, V, app','NGC 5253',NULL,'1994ApJ...423L..13S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112171,'Cepheids','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112171,28.16,0.1,4.29,48470,NULL,NULL,NULL,'NGC 5253',NULL,'1996ASPC...94..357H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112172,'CMD','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112172,27.65,0.04,3.39,48470,NULL,NULL,'LSB','NGC 5253',NULL,'2010ApJ...721..297M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112173,'CMD','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112173,27.75,0.04,3.55,48470,NULL,NULL,'HSB','NGC 5253',NULL,'2010ApJ...721..297M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112174,'PNLF','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112174,27.4,0.5,3,48470,NULL,NULL,'10 Pne, A(V) = 0.7 mag','NGC 5253',NULL,'1992AAS...180.1304P',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112175,'PNLF','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112175,27.78,0.48,3.6,48470,NULL,NULL,NULL,'NGC 5253',NULL,'1994ApJ...421L..87B',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112176,'PNLF','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112176,28.1,0.5,4.17,48470,NULL,NULL,'10 PNe','NGC 5253',NULL,'1992AAS...180.1304P',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112177,'PNLF','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112177,28.13,0.41,4.23,48470,NULL,NULL,'HST KP Calibrated','NGC 5253',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112178,'SNIa','2016-12-15 15:15:17','2016-12-16 11:20:29','1','SN 1985B','R',112178,27.18,NULL,2.73,48470,NULL,NULL,'Photographic','NGC 5253',NULL,'1988SSRv...48....1R',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112179,'SNIa','2016-12-15 15:15:17','2016-12-16 11:20:29','1','SN 1972E',NULL,112179,27.21,0.09,2.77,48470,65,NULL,'Snapshot','NGC 5253',NULL,'1996ApJ...473...88R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112180,'SNIa','2016-12-15 15:15:17','2016-12-16 11:20:29','1','SN 1972E','R',112180,27.27,NULL,2.84,48470,NULL,NULL,'Photographic','NGC 5253',NULL,'1988SSRv...48....1R',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112181,'SNIa','2016-12-15 15:15:17','2016-12-16 11:20:29','1','SN 1972E',NULL,112181,27.54,0.14,3.22,48470,60,NULL,'M(B) = -19.48 mag','NGC 5253',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112182,'SNIa','2016-12-15 15:15:17','2016-12-16 11:20:29','1','SN 1972E',NULL,112182,27.58,0.15,3.28,48470,60,NULL,'M(V) = -19.47 mag','NGC 5253',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112183,'SNIa','2016-12-15 15:15:17','2016-12-16 11:20:29','1','SN 1972E',NULL,112183,27.68,NULL,3.44,48470,60,NULL,'M(I) = -19.19 mag','NGC 5253',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112184,'SNIa','2016-12-15 15:15:17','2016-12-16 11:20:29','1','SN 1972E',NULL,112184,27.83,0.11,3.67,48470,65,NULL,'MLCS2k2','NGC 5253',0.001358,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112185,'SNIa','2016-12-15 15:15:17','2016-12-16 11:20:29','1','SN 1972E',NULL,112185,27.9,NULL,3.8,48470,NULL,NULL,'three zone model','NGC 5253',NULL,'1987ApJ...315..588G',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112186,'SNIa','2016-12-15 15:15:17','2016-12-16 11:20:29','1','SN 1972E',NULL,112186,28,0.3,4,48470,67,NULL,NULL,'NGC 5253',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112187,'SNIa','2016-12-15 15:15:17','2016-12-16 11:20:29','1','SN 1972E',NULL,112187,28.04,0.14,4.06,48470,60,NULL,NULL,'NGC 5253',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112188,'SNIa','2016-12-15 15:15:17','2016-12-16 11:20:29','1','SN 1972E',NULL,112188,28.23,0.17,4.4,48470,NULL,NULL,'SN 1972E vs. SN 1937C identical','NGC 5253',NULL,'1994ApJ...421L..87B',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112189,'SNIa','2016-12-15 15:15:17','2016-12-16 11:20:29','1','SN 1972E',NULL,112189,28.27,NULL,4.5,48470,NULL,NULL,'two zone model','NGC 5253',NULL,'1987ApJ...315..588G',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112190,'SNIa','2016-12-15 15:15:17','2016-12-16 11:20:29','1','SN 1972E',NULL,112190,28.4,NULL,4.79,48470,66,NULL,NULL,'NGC 5253',NULL,'1994A&A...281...51M',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112191,'SNIa','2016-12-15 15:15:17','2016-12-16 11:20:29','1','SN 1972E',NULL,112191,28.58,0.23,5.2,48470,NULL,NULL,'SN 1972E vs. SN 1937C0.35 mag brighter','NGC 5253',NULL,'1994ApJ...421L..87B',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112192,'SBF','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112192,27.1,0.1,2.63,48470,NULL,NULL,NULL,'NGC 5253',NULL,'1992AAS...180.1304P',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112193,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112193,27.48,0.14,3.13,48470,NULL,NULL,NULL,'NGC 5253',NULL,'2007AJ....134.1799D',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112194,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112194,27.72,0.23,3.5,48470,NULL,NULL,NULL,'NGC 5253',NULL,'2014A&A...566A..71L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112195,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112195,27.75,0.06,3.55,48470,74.4,NULL,NULL,'NGC 5253',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112196,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112196,27.75,0.11,3.55,48470,NULL,NULL,NULL,'NGC 5253',NULL,'2015ApJ...802L..25T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112197,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112197,27.76,NULL,3.56,48470,NULL,NULL,'I','NGC 5253',NULL,'2008ApJ...686L..75M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112198,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112198,27.88,0.11,3.77,48470,NULL,NULL,NULL,'NGC 5253',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112199,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112199,25.88,NULL,1.5,48470,NULL,NULL,'LEDA [April 2006]','NGC 5253',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112200,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112200,27.53,0.4,3.2,48470,75,NULL,'B','NGC 5253',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112201,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112201,28.31,0.3,4.64,48470,NULL,NULL,'TF of HII regions','NGC 5253',NULL,'1992A&A...257L...1D',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112202,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112202,37.99,0.33,396,48471,70,NULL,NULL,'2MASX J13395613+5249015',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,204.983583333,52.81717,0,NULL,59209009600,925140775,14455324,17.4),(112203,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112203,37.78,0.17,361,48472,70,NULL,NULL,'LCRS B133721.1-022645',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000133,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,204.9837083,-2.69878,0.085,NULL,43566958998,680733734,10636464,17.9),(112204,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112204,38.15,0.33,426,48473,70,NULL,NULL,'2MASX J13395648-0218400',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00017,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,204.985333333,-2.31125,0.121,NULL,43567023671,680734744,10636480,17.9),(112205,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112205,38.2,0.33,436,48474,70,NULL,NULL,'2MASX J13395671+5320385',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,204.9862917,53.34397,0,NULL,57278550561,894977352,13984021,18),(112206,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112206,35.04,0.4,102,48475,NULL,NULL,'mean','NGC 5258',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000003,NULL,'12.93',1.1,'SA(s)b: pec;HIILINER','Pair member (points to parent)',NULL,NULL,NULL,1,204.990375,0.83094,0.009,NULL,58400275440,912504303,14257879,12.93),(112207,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112207,35.16,0.45,108,48475,NULL,NULL,'K','NGC 5258',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112208,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112208,35.21,0.47,110,48475,NULL,NULL,'H','NGC 5258',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112209,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112209,35.3,0.46,115,48475,NULL,NULL,'J','NGC 5258',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112210,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112210,36.82,0.33,232,48476,70,NULL,NULL,'SDSS J133958.19+224035.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.25',0.12,NULL,NULL,NULL,NULL,NULL,1,204.9925,22.67653,0,NULL,58790742312,918605348,14353208,18.25),(112211,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112211,38.16,0.46,428,48477,70,NULL,NULL,'SDSS J133958.72+085551.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,204.994708333,8.93103,0,NULL,58433578586,913024665,14266010,18.3),(112212,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112212,38.81,0.46,577,48478,70,NULL,NULL,'SDSS J133959.14+292110.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000156,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,204.9964583,29.35289,0,NULL,59135975228,923999612,14437493,18.5),(112213,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112213,38.38,0.46,475,48479,70,NULL,NULL,'2MASX J13400013+3024465',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000172,NULL,'17.4g',0.19,'E1',NULL,NULL,NULL,NULL,1,205.000708333,30.413,0,NULL,59133616419,923962756,14436918,17.4),(112214,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112214,38.15,0.33,426,48480,70,NULL,NULL,'2MASX J13400041-0218350',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000165,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,205.001708333,-2.30964,0.121,NULL,43567023744,680734746,10636480,17.5),(112215,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112215,38.15,0.46,426,48481,70,NULL,NULL,'2MASX J13400106-0122300',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000147,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,205.004375,-1.37497,0.049,NULL,43567950119,680749220,10636706,18.5),(112216,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112216,38.25,0.33,446,48482,70,NULL,NULL,'SDSS J134002.23+633211.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000076,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,205.0092917,63.5365,0.029,NULL,57344823227,896012862,14000200,18.7),(112217,'IRAS','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112217,34.24,0.8,70.5,48483,75,NULL,'MAT, I','IC 4315',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'15.45',0.2,'SB(s)cd: sp',NULL,NULL,NULL,NULL,1,205.0132917,-25.47456,0.317,NULL,43288663236,676385363,10568521,15.45),(112218,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112218,33.25,0.32,44.7,48483,85,NULL,'I, raw','IC 4315',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112219,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112219,33.26,0.32,44.9,48483,85,NULL,'I, inv','IC 4315',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112220,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112220,33.41,0.43,48.1,48483,75,NULL,'MAT, I, raw','IC 4315',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112221,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112221,33.5,0.43,50.1,48483,75,NULL,'MAT, I, inv','IC 4315',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112222,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112222,33.66,0.43,54.1,48483,75,NULL,'MAT, I, cor','IC 4315',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112223,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112223,33.87,0.2,59.4,48483,74.4,NULL,NULL,'IC 4315',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112224,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112224,34.06,0.49,65,48483,75,NULL,'IR','IC 4315',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112225,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112225,34.45,0.12,77.8,48483,NULL,NULL,NULL,'IC 4315',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112226,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112226,37.51,0.46,318,48484,70,NULL,NULL,'2MASX J13400350+1518362',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00018,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,205.0145,15.31017,0,NULL,58343856811,911622762,14244105,16.2),(112227,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112227,37.78,0.17,361,48485,70,NULL,NULL,'LCRS B133729.3-021705',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,205.01725,-2.53756,0.085,NULL,43567047719,680735120,10636486,17.6),(112228,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112228,37.43,0.46,306,48486,70,NULL,NULL,'2MASX J13400540+1915291',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.98',0.18,NULL,NULL,NULL,NULL,NULL,1,205.0225,19.25806,0,NULL,58796589592,918696712,14354636,17.98),(112229,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112229,37.54,0.33,322,48487,70,NULL,NULL,'2MASX J13400678+1617532',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.14',0.15,NULL,NULL,NULL,NULL,NULL,1,205.028333,16.29825,0,NULL,58827692922,919182701,14362229,18.14),(112230,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112230,37.27,0.46,285,48488,70,NULL,NULL,'2MASX J13400819+0117265',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000089,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,205.034166667,1.29047,0.041,NULL,58399744374,912496005,14257750,17.3),(112231,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112231,37.24,0.46,281,48489,70,NULL,NULL,'2MASX J13400865+2610380',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000166,NULL,'17.7g',0.17,NULL,'Group member',NULL,NULL,NULL,1,205.0362083,26.17728,0,NULL,59125470196,923835471,14434929,17.7),(112232,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112232,37.99,0.46,396,48490,70,NULL,NULL,'2MASX J13400935+2143461',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,205.0389583,21.72944,0.005,NULL,58801936658,918780260,14355941,17.6),(112233,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112233,38.46,0.46,493,48491,70,NULL,NULL,'LCRS B133735.7-024407',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000203,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,205.0450417,-2.98811,0.081,NULL,43566828616,680731697,10636432,17.8),(112234,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112234,37.99,0.33,396,48492,70,NULL,NULL,'2MASX J13401090+5242589',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,205.045417,52.7165,0,NULL,59208980700,925140323,14455317,17.4),(112235,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112235,37.78,0.17,361,48493,70,NULL,NULL,'2MASX J13401103-0225549',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000143,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,205.0459583,-2.43189,0.085,NULL,43567083195,680735674,10636494,18.3),(112236,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112236,37.62,0.1,334,48494,70,NULL,NULL,'2MASX J13401220+2614524',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.2g',0.25,NULL,'Group member',NULL,NULL,NULL,1,205.0507917,26.24789,0,NULL,59125471301,923835489,14434929,17.2),(112237,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112237,38.2,0.46,437,48495,70,NULL,NULL,'2MASX J13401232+5106429',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000164,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,205.0514583,51.11186,0,NULL,59222003133,925343798,14458496,18.4),(112238,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112238,35.95,0.46,155,48496,70,NULL,NULL,'2MASX J13401257+6123032',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000172,NULL,'16.0g',0.36,'E0',NULL,NULL,NULL,NULL,1,205.052083,61.38428,0.017,NULL,57380550581,896571102,14008923,16),(112239,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112239,34.82,0.47,92,48497,NULL,NULL,'H','UGC 08650',NULL,'2007A&A...465...71T',2007,1,1.91,NULL,'G',0.00002,NULL,'14.4g',0.44,'Sb pec sp',NULL,NULL,NULL,NULL,1,205.052375,2.48014,0.008,NULL,58398119284,912470613,14257353,14.4),(112240,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112240,34.93,0.46,97,48497,NULL,NULL,'J','UGC 08650',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112241,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112241,35,0.45,100,48497,NULL,NULL,'K','UGC 08650',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112242,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112242,35.07,0.4,103,48497,NULL,NULL,'mean','UGC 08650',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112243,'IRAS','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112243,33.35,0.8,46.7,48498,75,NULL,'MAT, I','ESO 220- G 028',NULL,'1997ApJS..109..333W',1997,1,2.35,NULL,'G',0.000026,NULL,'14.72',0.31,'Scd','in a triple',NULL,NULL,NULL,1,205.053417,-51.14225,0.881,NULL,46822326575,731598852,11431232,14.72),(112244,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112244,33.48,0.47,49.8,48498,NULL,NULL,'H','ESO 220- G 028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112245,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112245,33.5,0.46,50.1,48498,NULL,NULL,'J','ESO 220- G 028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112246,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112246,33.53,0.49,50.8,48498,75,NULL,'IR','ESO 220- G 028',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112247,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112247,33.53,0.45,50.8,48498,NULL,NULL,'K','ESO 220- G 028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112248,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112248,33.55,0.4,51.3,48498,NULL,NULL,'mean','ESO 220- G 028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112249,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112249,33.8,0.43,57.5,48498,75,NULL,'MAT, I, raw','ESO 220- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112250,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112250,33.87,0.43,59.3,48498,75,NULL,'MAT, I, cor','ESO 220- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112251,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112251,34.06,0.32,64.9,48498,85,NULL,'I, raw','ESO 220- G 028',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112252,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112252,34.09,0.43,65.8,48498,75,NULL,'MAT, I, inv','ESO 220- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112253,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112253,34.13,0.32,67,48498,85,NULL,'I, inv','ESO 220- G 028',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112254,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112254,34.43,NULL,77,48498,NULL,NULL,NULL,'ESO 220- G 028',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112255,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112255,34.48,NULL,78.6,48498,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 220- G 028',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112256,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112256,34.5,NULL,79.3,48498,NULL,NULL,'Dipole + Quadrupole','ESO 220- G 028',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112257,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112257,34.5,NULL,79.6,48498,NULL,NULL,'Dipole','ESO 220- G 028',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112258,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112258,37.3,0.57,288,48499,70,NULL,NULL,'2MASX J13401333-3540311',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.7b',NULL,'S0','Group member, 2nd ranked galaxy',NULL,NULL,NULL,1,205.0555417,-35.67525,0.137,NULL,46896114848,732751794,11449246,15.7),(112259,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112259,38.18,0.46,432,48500,70,NULL,NULL,'2MASX J13401351+2419345',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,205.0562917,24.32633,0,NULL,58653715303,916464301,14319754,17.1),(112260,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112260,37.6,0.46,332,48501,70,NULL,NULL,'2MASX J13401431+0359193',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000181,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,205.059583,3.98867,0.023,NULL,58440913909,913139279,14267801,16.8),(112261,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112261,37.88,0.46,376,48502,70,NULL,NULL,'SDSS J134014.78+653619.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000065,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,205.061625,65.60533,0.041,NULL,57880521989,904383156,14130986,18.4),(112262,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112262,38.7,0.46,548,48503,70,NULL,NULL,'2MASX J13401607+2219171',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,205.067083333,22.32147,0,NULL,58790228384,918597318,14353083,17.8),(112263,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112263,37.82,0.46,366,48504,70,NULL,NULL,'2MASX J13401623+2706065',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,205.06775,27.10178,0,NULL,59125870256,923841722,14435026,16.9),(112264,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112264,37.73,0.46,352,48505,70,NULL,NULL,'2MASX J13401645+5630053',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000197,NULL,'16.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,205.068375,56.50139,0,NULL,57289261155,895144705,13986636,16.4),(112265,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112265,37.6,0.33,331,48506,70,NULL,NULL,'2MASX J13401674+5320289',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000179,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,205.069875,53.34139,0,NULL,57278714083,894979907,13984061,16.7),(112266,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112266,37.95,0.46,389,48507,70,NULL,NULL,'2MASX J13401747-0040577',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000094,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,205.072958333,-0.68261,0.045,NULL,43567483790,680741934,10636592,17.1),(112267,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112267,37.59,0.63,330,48508,70,NULL,NULL,'2MASX J13401779-2005361',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.00',NULL,NULL,NULL,NULL,NULL,NULL,1,205.074167,-20.09358,0.289,NULL,43762751090,683792985,10684265,16),(112268,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112268,37.38,0.21,300,48509,70,NULL,NULL,'2MASX J13401792+5611023',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,205.074917,56.184,0,NULL,57289349072,895146079,13986657,17.4),(112269,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112269,37.64,0.46,337,48510,70,NULL,NULL,'2MASX J13401799+6354432',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00009,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,205.075,63.91189,0.029,NULL,57868054737,904188355,14127943,17.6),(112270,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112270,28.01,0.1,4,48511,NULL,NULL,NULL,'IC 4316',NULL,'2012A&A...540A..49M',2012,1,1.7,'Noted in MCG as possibly interacting.','G',0.00015,NULL,'14.97',1.1,'IBm? pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,205.0767083,-28.89222,0.141,NULL,46857999302,732156239,11439941,14.97),(112271,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112271,28.19,0.1,4.35,48511,74.4,NULL,NULL,'IC 4316',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112272,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112272,28.22,NULL,4.41,48511,NULL,NULL,NULL,'IC 4316',NULL,'2002A&A...385...21K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112273,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112273,28.24,0.08,4.45,48511,NULL,NULL,'I','IC 4316',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112274,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112274,37.92,0.46,384,48512,70,NULL,NULL,'2MASX J13401900+1614442',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,205.079167,16.24553,0,NULL,58827687578,919182618,14362228,17.8),(112275,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112275,37.51,0.46,318,48513,70,NULL,NULL,'SDSS J134019.57+001825.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00008,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,205.0815417,0.30719,0.009,NULL,58399426392,912491037,14257672,17.8),(112276,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112276,37.4,0.46,302,48514,70,NULL,NULL,'2MASX J13402055+5649193',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000178,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,205.085625,56.82211,0,NULL,57286355534,895099305,13985926,17),(112277,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112277,37.62,0.46,334,48515,70,NULL,NULL,'2MASX J13402148+0202033',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000077,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,205.089416667,2.03428,0.013,NULL,58400825243,912512894,14258013,18.1),(112278,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112278,37.38,0.21,300,48516,70,NULL,NULL,'2MASX J13402248+5612082',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000165,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,205.09375,56.20233,0,NULL,57289348845,895146075,13986657,17),(112279,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112279,38.02,0.46,401,48517,70,NULL,NULL,'2MASX J13402291+1758371',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.00',0.17,NULL,NULL,NULL,NULL,NULL,1,205.095375,17.97706,0,NULL,58825358354,919146224,14361659,18),(112280,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112280,37.92,0.27,384,48518,70,NULL,NULL,'2MASX J13402319+1843221',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.84',0.18,NULL,NULL,NULL,NULL,NULL,1,205.096833333,18.72269,0.015,NULL,58795934849,918686482,14354476,17.84),(112281,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112281,36.46,0.69,196,48519,70,NULL,NULL,'2MASX J13402418-4334105',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,205.1007083,-43.56958,0.369,NULL,46965061161,733829080,11466079,15.2),(112282,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112282,38.25,0.33,446,48520,70,NULL,NULL,'2MASX J13402438+6337352',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00009,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,205.1015417,63.62644,0.029,NULL,57865174989,904143359,14127239,17.4),(112283,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112283,37.77,0.46,358,48521,70,NULL,NULL,'2MASX J13402438+0839425',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,205.1017917,8.66183,0,NULL,58433646224,913025722,14266026,17.2),(112284,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112284,37.54,0.33,322,48522,70,NULL,NULL,'SDSS J134026.44+162112.5',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.0g',0.35,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,205.110167,16.3535,0,NULL,58827511271,919179863,14362185,16),(112285,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112285,37.48,0.46,314,48523,70,NULL,NULL,'MCG +10-20-006',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.0002,NULL,'16.0g',0.47,'AGN',NULL,NULL,NULL,NULL,1,205.1182917,60.84053,0.013,NULL,57380298985,896567171,14008862,16),(112286,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112286,38.05,0.46,408,48524,70,NULL,NULL,'LCRS B133753.3-025048',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,205.1185417,-3.09936,0.081,NULL,43558975696,680608995,10634515,17.3),(112287,'IRAS','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112287,33.64,0.8,53.4,48525,75,NULL,'HMCL, I','ESO 383- G 060',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00001,NULL,'13.54',1.2,'SB(rs)cd       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,205.1274583,-33.65686,0.137,NULL,46908141473,732939710,11452182,13.54),(112288,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112288,31.47,0.4,19.7,48525,75,NULL,'HMCL, I, inv','ESO 383- G 060',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112289,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112289,31.48,0.4,19.8,48525,75,NULL,'HMCL, I, raw','ESO 383- G 060',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112290,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112290,31.66,0.74,21.5,48525,NULL,NULL,NULL,'ESO 383- G 060',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112291,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112291,31.77,0.4,22.6,48525,75,NULL,'HMCL, I, cor','ESO 383- G 060',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112292,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112292,32.02,0.63,25.3,48525,NULL,NULL,'Malmquist cor.','ESO 383- G 060',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112293,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112293,37.44,0.46,308,48526,70,NULL,NULL,'2MASX J13403070+2639395',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000174,NULL,'16.8g',0.25,NULL,'Group member',NULL,NULL,NULL,1,205.1277917,26.66103,0,NULL,59126042590,923844415,14435068,16.8),(112294,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112294,37.18,0.46,273,48527,70,NULL,NULL,'2MASX J13403104+1731272',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,205.1294583,17.52417,0,NULL,58825990857,919156107,14361814,17.4),(112295,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112295,37.15,0.33,269,48528,70,NULL,NULL,'2MASX J13403119+5009349',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000184,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,205.130125,50.15969,0,NULL,59222373987,925349593,14458587,16.6),(112296,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112296,35.03,0.47,101,48529,70,NULL,NULL,'ESO 445- G 008',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'14.88',0.5,'S0?',NULL,NULL,NULL,NULL,1,205.1302083,-28.547,0.221,NULL,46858139181,732158424,11439975,14.88),(112297,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112297,37.58,0.21,328,48530,70,NULL,NULL,'SDSS J134031.68+070634.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,205.1320417,7.10961,0.014,NULL,58424002526,912875039,14263672,18),(112298,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112298,37.6,0.46,331,48531,70,NULL,NULL,'2MASX J13403233+5122199',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00017,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,205.134541667,51.37206,0,NULL,59220700852,925323450,14458178,17.4),(112299,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112299,37.92,0.27,384,48532,70,NULL,NULL,'SDSS J134032.49+184218.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,205.135375,18.70517,0.015,NULL,58795928926,918686389,14354474,18.2),(112300,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112300,37.98,0.46,395,48533,70,NULL,NULL,'2MASX J13403291+2849415',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,205.13725,28.82814,0,NULL,59139411670,924053307,14438332,17.8),(112301,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112301,38.09,0.46,415,48534,70,NULL,NULL,'2MASX J13403315+1139475',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000197,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,205.138,11.66314,0,NULL,58452804092,913325063,14270704,17),(112302,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112302,37.08,0.89,260,48535,70,NULL,NULL,'2MASX J13403359-3540268',NULL,'2014MNRAS.445.2677S',2014,1,NULL,'Not to be identified with ABELL 3566:[QMP97] 09.','G',0.00015,NULL,'15.54',NULL,NULL,NULL,NULL,NULL,NULL,1,205.139917,-35.67411,0.137,NULL,46896108620,732751697,11449245,15.54),(112303,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112303,38.56,0.46,514,48536,70,NULL,NULL,'2MASX J13403524+5154499',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000196,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,205.14675,51.91389,0,NULL,59209532589,925148946,14455452,17.5),(112304,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112304,38.36,0.46,470,48537,70,NULL,NULL,'SDSS J134035.46+093745.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,205.1477917,9.62939,0,NULL,58421612910,912837701,14263089,18.4),(112305,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112305,36.05,0.46,162,48538,70,NULL,NULL,'2MASX J13403678+2157038',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,205.15325,21.951,0,NULL,58801401996,918771906,14355811,16.3),(112306,'Tully est','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112306,32.89,0.8,37.8,48539,75,NULL,NULL,'NGC 5266A',NULL,'1988NBGC.C....0000T',1988,1,3.1,'Confused and extended HIPASS source','G',0.00001,NULL,'12.70',2.4,'SB(rs)cd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,205.154583,-48.34197,0.469,NULL,46818462536,731538477,11430288,12.7),(112307,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112307,37.48,0.46,313,48540,70,NULL,NULL,'2MASX J13403722+5713511',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,205.155125,57.23086,0,NULL,57294622166,895228471,13987944,17.8),(112308,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112308,36.67,0.59,216,48541,70,NULL,NULL,'2MASX J13403806-3359268',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00009,NULL,'14.32',0.5,'E',NULL,NULL,NULL,NULL,1,205.158666667,-33.99072,0.137,NULL,46908149583,732939837,11452184,14.32),(112309,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112309,37.58,0.21,328,48542,70,NULL,NULL,'2MASX J13403990+0717216',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.39',0.16,NULL,NULL,NULL,NULL,NULL,1,205.1662083,7.28936,0.014,NULL,58423830444,912872350,14263630,18.39),(112310,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112310,31.54,0.69,20.3,48543,100,NULL,'mid-IR','Holmberg V',NULL,'2013ApJ...771...88L',2013,1,1.95,NULL,'G',0.000023,NULL,'14.2g',0.9,'SAB(rs)c','Possible group member',NULL,NULL,NULL,1,205.166083,54.33286,0,NULL,57293224897,895206639,13987603,14.2),(112311,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112311,32.57,0.4,32.7,48543,NULL,NULL,NULL,'Holmberg V',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112312,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112312,32.62,0.4,33.4,48543,75,NULL,'B','Holmberg V',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112313,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112313,32.71,0.43,34.9,48543,75,NULL,'3.6 micron, color corrected','Holmberg V',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112314,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112314,32.74,0.43,35.3,48543,75,NULL,'3.6 micron, color + selection bias corrected','Holmberg V',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112315,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112315,32.74,0.2,35.3,48543,74.4,NULL,NULL,'Holmberg V',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112316,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112316,32.85,0.43,37.2,48543,NULL,NULL,'Malmquist cor.','Holmberg V',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112317,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112317,32.9,0.4,38,48543,NULL,NULL,'mean','Holmberg V',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112318,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112318,32.97,0.41,39.3,48543,NULL,NULL,NULL,'Holmberg V',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112319,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112319,33.62,0.46,53.1,48543,NULL,NULL,'J','Holmberg V',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112320,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112320,33.63,0.47,53.2,48543,NULL,NULL,'H','Holmberg V',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112321,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112321,33.49,0.47,50,48544,NULL,NULL,'H','NGC 5267',NULL,'2007A&A...465...71T',2007,1,1.77,NULL,'G',0.000147,NULL,'13.6g',0.62,'SBb',NULL,NULL,NULL,NULL,1,205.1665,38.79408,0,NULL,59266551019,926039859,14469372,13.6),(112322,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112322,33.68,0.46,54.4,48544,NULL,NULL,'J','NGC 5267',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112323,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112323,33.68,0.45,54.5,48544,NULL,NULL,'K','NGC 5267',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112324,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112324,34.64,0.4,84.7,48544,NULL,NULL,'mean','NGC 5267',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112325,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112325,36.78,0.46,227,48545,70,NULL,NULL,'2MASX J13404135+5634588',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,205.172208333,56.58311,0,NULL,57289275086,895144923,13986639,16.8),(112326,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112326,38.19,0.46,435,48546,70,NULL,NULL,'SDSS J134042.18+312341.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,205.175791667,31.39489,0,NULL,59186051708,924782057,14449719,18.6),(112327,'IRAS','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112327,34.72,0.8,87.9,48547,75,NULL,'MAT, I','MCG -01-35-008',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000023,NULL,'13.84',0.8,'SA(r)c pec?',NULL,NULL,NULL,NULL,1,205.176083,-7.751,0.021,NULL,43586708473,681042319,10641286,13.84),(112328,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112328,33.91,0.69,60.5,48547,100,NULL,'mid-IR','MCG -01-35-008',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112329,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112329,34.65,0.32,85.2,48547,85,NULL,'I, raw','MCG -01-35-008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112330,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112330,34.68,0.43,86.3,48547,75,NULL,'MAT, I, raw','MCG -01-35-008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112331,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112331,34.72,0.32,88,48547,85,NULL,'I, inv','MCG -01-35-008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112332,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112332,34.86,0.37,93.5,48547,NULL,NULL,'Malmquist cor.','MCG -01-35-008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112333,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112333,34.87,0.47,94.4,48547,NULL,NULL,'H','MCG -01-35-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112334,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112334,34.91,0.2,95.9,48547,74.4,NULL,NULL,'MCG -01-35-008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112335,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112335,34.95,0.4,97.6,48547,NULL,NULL,'mean','MCG -01-35-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112336,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112336,34.95,0.46,97.6,48547,NULL,NULL,'J','MCG -01-35-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112337,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112337,34.95,0.43,97.8,48547,75,NULL,'MAT, I, cor','MCG -01-35-008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112338,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112338,34.97,0.45,98.5,48547,NULL,NULL,'K','MCG -01-35-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112339,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112339,34.98,0.43,99.2,48547,75,NULL,'MAT, I, inv','MCG -01-35-008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112340,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112340,35.02,0.34,101,48547,NULL,NULL,NULL,'MCG -01-35-008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112341,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112341,37.62,0.1,334,48548,70,NULL,NULL,'SDSS J134042.34+262438.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,205.1764583,26.41061,0,NULL,59125352730,923833636,14434900,18.2),(112342,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112342,36.45,0.46,195,48549,70,NULL,NULL,'2MASX J13404266+3040560',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000157,NULL,'16.8g',0.3,'E0',NULL,NULL,NULL,NULL,1,205.1777083,30.68233,0,NULL,59133445123,923960080,14436876,16.8),(112343,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112343,38.21,0.33,439,48550,70,NULL,NULL,'2MASX J13404313+1205412',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000191,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,205.179583,12.09483,0,NULL,58334773435,911480834,14241888,17.3),(112344,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112344,37.92,0.46,383,48551,70,NULL,NULL,'2MASX J13404344+0417117',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000181,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,205.1809583,4.28642,0.044,NULL,58440984287,913140379,14267818,17.2),(112345,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112345,37.62,0.1,334,48552,70,NULL,NULL,'2MASX J13404422+2613448',NULL,'2015arXiv151105856S',2015,1,0.47,'Hintzen (1979PASP...91..426H) gives z=0.06548.','G',0.000164,NULL,'16.1g',0.37,NULL,'Group member',NULL,NULL,NULL,1,205.18425,26.22908,0,NULL,59125476428,923835569,14434930,16.1),(112346,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112346,37.58,0.21,328,48553,70,NULL,NULL,'2MASX J13404562+0712416',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.46',0.26,NULL,NULL,NULL,NULL,NULL,1,205.190125,7.21147,0.014,NULL,58423795268,912871801,14263621,17.46),(112347,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112347,36.67,0.69,216,48554,70,NULL,NULL,'2MASX J13404631-3541178',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.5b',NULL,'*+Irr',NULL,NULL,NULL,NULL,1,205.192958333,-35.68831,0.137,NULL,46896111309,732751739,11449245,16.5),(112348,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112348,35.64,0.52,134,48555,70,NULL,NULL,'2MASX J13404657-1711556',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.08',NULL,NULL,NULL,NULL,NULL,NULL,1,205.1940417,-17.19883,0.341,NULL,43780603548,684071930,10688623,16.08),(112349,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112349,35.51,0.46,126,48556,70,NULL,NULL,'CGCG 131-023 NED01',NULL,'2015arXiv151105856S',2015,1,1.06,NULL,'G',0.000097,NULL,'14.6g',0.63,'S','Group member',NULL,NULL,NULL,1,205.195375,25.89719,0,NULL,59125321648,923833150,14434892,14.6),(112350,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112350,38.52,0.46,506,48557,70,NULL,NULL,'SDSS J134046.91-004010.5',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000072,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,205.1954583,-0.66961,0.041,NULL,43567463987,680741624,10636587,18.1),(112351,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112351,37.58,0.21,328,48558,70,NULL,NULL,'2MASX J13404723+0720176',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,205.196833,7.33808,0.007,NULL,58423832753,912872386,14263631,17.6),(112352,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112352,37.32,0.33,291,48559,70,NULL,NULL,'2MASX J13404876+0327517',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000083,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,205.203167,3.46456,0.012,NULL,58395293476,912426460,14256663,17),(112353,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112353,37.25,0.46,282,48560,70,NULL,NULL,'LCSB S1947O',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00017,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,205.203875,38.27189,0,NULL,59266446644,926038228,14469347,16.5),(112354,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112354,37.58,0.21,328,48561,70,NULL,NULL,'2MASX J13405078+0706144',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.12',0.18,NULL,NULL,NULL,NULL,NULL,1,205.211625,7.10408,0.014,NULL,58424011592,912875181,14263674,18.12),(112355,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112355,37.3,0.46,289,48562,70,NULL,NULL,'2MASX J13405100+3858264',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000175,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,205.212583333,38.97408,0,NULL,59266325008,926036328,14469317,16.7),(112356,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112356,37.75,0.46,355,48563,70,NULL,NULL,'SDSS J134051.08+015047.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00008,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,205.212875,1.84653,0.012,NULL,58400933145,912514580,14258040,18.2),(112357,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112357,37.28,0.46,286,48564,70,NULL,NULL,'2MASX J13405192+1101204',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,205.21625,11.02225,0,NULL,58418904326,912795380,14262427,17.1),(112358,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112358,36.99,0.46,250,48565,70,NULL,NULL,'2MASX J13405281+1154542',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000203,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,205.220167,11.91506,0,NULL,58452685660,913323213,14270675,16.4),(112359,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112359,37.15,0.33,269,48566,70,NULL,NULL,'2MASX J13405324+5008415',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000182,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,205.221583,50.145,0,NULL,59222498115,925351533,14458617,16.6),(112360,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112360,38.88,0.46,598,48567,70,NULL,NULL,'2MASX J13405357+3157410',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,205.223333,31.96147,0,NULL,59186822327,924794098,14449907,18.4),(112361,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112361,37.38,0.21,300,48568,70,NULL,NULL,'SDSS J134054.11+561820.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,205.2254583,56.30561,0,NULL,57289373508,895146461,13986663,18.1),(112362,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112362,37.53,0.46,321,48569,70,NULL,NULL,'2MASX J13405626+3022010',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000172,NULL,'16.6g',0.33,'E1',NULL,NULL,NULL,NULL,1,205.234375,30.36706,0,NULL,59135593527,923993648,14437400,16.6),(112363,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112363,37.62,0.1,334,48570,70,NULL,NULL,'2MASX J13405655+2629119',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000201,NULL,'16.1g',0.44,'E','Group member',NULL,NULL,NULL,1,205.235833,26.48672,0,NULL,59125840229,923841253,14435019,16.1),(112364,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112364,35.48,0.6,125,48571,70,NULL,NULL,'AM 1338-232 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,'(R)SAB0^+',NULL,NULL,NULL,NULL,1,205.2372083,-23.59897,0.197,NULL,43758497364,683726521,10683226,14.9),(112365,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112365,36.39,0.46,190,48572,70,NULL,NULL,'2MASX J13405707+2610219',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000144,NULL,'16.8g',0.25,NULL,'Group member',NULL,NULL,NULL,1,205.2377917,26.17264,0,NULL,59125518998,923836234,14434941,16.8),(112366,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112366,38.21,0.33,439,48573,70,NULL,NULL,'2MASX J13405778+1200402',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000145,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,205.2407917,12.01114,0,NULL,58452412354,913318943,14270608,17.9),(112367,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112367,37.13,0.46,267,48574,70,NULL,NULL,'2MASX J13405782+3228460',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000174,NULL,'16.3g',0.33,'E4',NULL,NULL,NULL,NULL,1,205.240833,32.47939,0,NULL,59186664221,924791628,14449869,16.3),(112368,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112368,37.82,0.46,366,48575,70,NULL,NULL,'2MASX J13405838+1845321',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.58',0.12,NULL,NULL,NULL,NULL,NULL,1,205.2432917,18.75881,0.015,NULL,58795952919,918686764,14354480,18.58),(112369,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112369,37.5,0.12,317,48576,70,NULL,NULL,'2MASX J13405963+0208587',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000087,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,205.2485417,2.14956,0,NULL,58397993948,912468655,14257322,16.8),(112370,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112370,37.41,0.46,304,48577,70,NULL,NULL,'2MASX J13410080+2830599',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000186,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,205.253416667,28.51664,0,NULL,59139292425,924051444,14438303,17.7),(112371,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112371,36.19,0.27,173,48578,70,NULL,NULL,'2MASX J13410101+1410037',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000188,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,205.25425,14.16756,0,NULL,58337471049,911522985,14242546,16.2),(112372,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112372,35.8,0.6,145,48579,70,NULL,NULL,'MCG -02-35-013',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000033,NULL,'15.04',0.7,NULL,NULL,NULL,NULL,NULL,1,205.255625,-10.76678,0.113,NULL,43570941605,680795962,10637436,15.04),(112373,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112373,36.76,0.46,224,48580,70,NULL,NULL,'2MASX J13410172+2528319',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.72',0.2,NULL,'Field galaxy',NULL,NULL,NULL,1,205.257375,25.47547,0,NULL,58653410946,916459546,14319680,17.72),(112374,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112374,37.75,0.46,355,48581,70,NULL,NULL,'2MASX J13410218+1017595',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.57',0.11,NULL,NULL,NULL,NULL,NULL,1,205.2592083,10.29989,0.02,NULL,58421882719,912841917,14263154,18.57),(112375,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112375,38.13,0.46,422,48582,70,NULL,NULL,'SDSS J134102.77+014235.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000077,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,205.2615417,1.70978,0.017,NULL,58400723287,912511301,14257989,18.1),(112376,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112376,37.85,0.46,372,48583,70,NULL,NULL,'SDSS J134104.43+152353.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,205.2685,15.39814,0,NULL,58344019284,911625301,14244145,17.9),(112377,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112377,36.71,0.46,219,48584,70,NULL,NULL,'2MASX J13410522+2652339',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'16.9g',0.16,NULL,'Group member',NULL,NULL,NULL,1,205.271916667,26.87597,0,NULL,59126022306,923844098,14435064,16.9),(112378,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112378,37.38,0.21,300,48585,70,NULL,NULL,'2MASX J13410562+5606379',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000168,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,205.2735,56.11067,0,NULL,57288244065,895128813,13986387,18.1),(112379,'SNIa','2016-12-15 15:15:17','2016-12-16 11:20:29','1','SN 2005dv',NULL,112379,32.99,0.33,39.3,48586,65,NULL,'MLCS31','NGC 5283',0.010404,'2009ApJ...700.1097H',2009,1,1.1,'RC3 has V = 2700 +- 77 km/sec.','G',0.00014,NULL,'14.20',1,'S0?            Sy2',NULL,NULL,NULL,'Sy 2',1,205.274,67.67231,0.041,NULL,57900371138,904693299,14135832,14.2),(112380,'SNIa','2016-12-15 15:15:17','2016-12-16 11:20:29','1','SN 2005dv',NULL,112380,33.02,0.27,39.8,48586,74.2,NULL,'SALT 2','NGC 5283',0.010404,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112381,'SNIa','2016-12-15 15:15:17','2016-12-16 11:20:29','1','SN 2005dv',NULL,112381,33.13,0.29,41.9,48586,65,NULL,'MLCS17','NGC 5283',0.010404,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112382,'SNIa','2016-12-15 15:15:17','2016-12-16 11:20:29','1','SN 2005dv',NULL,112382,33.56,0.09,51.5,48586,74.4,NULL,NULL,'NGC 5283',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112383,'SNIa','2016-12-15 15:15:17','2016-12-16 11:20:29','1','SN 2005dv',NULL,112383,33.84,0.33,58.1,48586,65,NULL,'SALT2','NGC 5283',0.010404,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112384,'Tully est','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112384,33.08,0.8,41.4,48586,75,NULL,'B','NGC 5283',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112385,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112385,37.01,0.46,252,48587,70,NULL,NULL,'2MASX J13410612+3047541',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.0',0.22,'E0',NULL,NULL,NULL,NULL,1,205.275625,30.79833,0,NULL,59133405980,923959468,14436866,17),(112386,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112386,37.23,0.46,280,48588,70,NULL,NULL,'2MASX J13410696+6244515',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000073,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,205.279,62.74761,0.037,NULL,57345377692,896021526,14000336,17.5),(112387,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112387,38.79,0.46,573,48589,70,NULL,NULL,'SDSS J134107.17+442102.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,205.279916667,44.35067,0,NULL,59320035092,926875548,14482430,18.1),(112388,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112388,37.9,0.46,380,48590,70,NULL,NULL,'2MASX J13410736+4604406',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,205.2807083,46.07789,0.029,NULL,59283033693,926297401,14473396,17.6),(112389,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112389,37.38,0.21,300,48591,70,NULL,NULL,'MCG +09-22-093',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000231,NULL,'15.4g',0.51,'S0^-',NULL,NULL,NULL,NULL,1,205.282417,56.22397,0,NULL,57288283106,895129423,13986397,15.4),(112390,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112390,35.76,0.46,142,48592,70,NULL,NULL,'2MASX J13410919+2934478',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000163,NULL,'15.9g',0.34,'E4',NULL,NULL,NULL,NULL,1,205.288417,29.58008,0,NULL,59135952630,923999259,14437488,15.9),(112391,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112391,36.17,0.2,171,48593,74.4,NULL,NULL,'CGCG 073-061',NULL,'2013AJ....146...86T',2013,1,0.61,NULL,'G',0.000083,NULL,'15.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,205.288583,12.77153,0,NULL,58335168918,911487014,14241984,15.5),(112392,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112392,36.71,0.46,219,48594,70,NULL,NULL,'2MASX J13410993+5206085',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000191,NULL,'16.0g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,205.291583333,52.10244,0,NULL,59209497889,925148404,14455443,16),(112393,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112393,35.98,0.47,157,48595,NULL,NULL,'H','MRK 0268',NULL,'2007A&A...465...71T',2007,1,0.79,'UZC has V = 12251 +- 52 km/sec.','G',0.00004,NULL,'14.7g',0.46,'SBb            Sy2',NULL,NULL,NULL,'Sy 2',1,205.296416667,30.37811,0,NULL,59135592510,923993632,14437400,14.7),(112394,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112394,36.09,0.4,166,48595,NULL,NULL,'mean','MRK 0268',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112395,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112395,37.02,0.46,254,48596,70,NULL,NULL,'2MASX J13411160+3531181',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,205.298458333,35.52178,0,NULL,59175681089,924620017,14447187,17.2),(112396,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112396,38.24,0.33,445,48597,70,NULL,NULL,'2MASX J13411178+2952381',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000175,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,205.29925,29.87717,0,NULL,59136474673,924007416,14437615,17.6),(112397,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112397,38.2,0.46,437,48598,70,NULL,NULL,'2MASX J13411285+2923429',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.3g',0.25,'BrClG;E',NULL,NULL,NULL,NULL,1,205.303708333,29.39536,0,NULL,59135840848,923997513,14437461,17.3),(112398,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112398,37.89,0.46,378,48599,70,NULL,NULL,'SDSS J134113.15+522132.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000139,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,205.304833,52.35908,0.007,NULL,59209032040,925141125,14455330,18.3),(112399,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112399,38.24,0.33,445,48600,70,NULL,NULL,'2MASX J13411501+2955111',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000168,NULL,'17.3g',0.23,'BrClG',NULL,NULL,NULL,NULL,1,205.3127083,29.91983,0,NULL,59136474395,924007412,14437615,17.3),(112400,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112400,38.35,0.46,468,48601,70,NULL,NULL,'2MASX J13411529+1153587',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000162,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,205.313875,11.89975,0,NULL,58452680937,913323139,14270674,17.1),(112401,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112401,37.62,0.1,334,48602,70,NULL,NULL,'2MASX J13411658+2623360',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000171,NULL,'17.6g',0.17,NULL,'Group member',NULL,NULL,NULL,1,205.319166667,26.39325,0,NULL,59125361010,923833765,14434902,17.6),(112402,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112402,37.93,0.46,386,48603,70,NULL,NULL,'SDSS J134116.66+442836.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000164,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,205.3194583,44.47689,0,NULL,59320025461,926875397,14482428,18.4),(112403,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112403,35.8,0.25,145,48604,70,NULL,NULL,'GIN 317',NULL,'2001MNRAS.321..277C',2001,1,0.24,NULL,'G',0.000167,NULL,'15.47',0.19,'BrClG;E0',NULL,NULL,NULL,NULL,1,205.320375,29.83456,0,NULL,59136468066,924007313,14437614,15.47),(112404,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112404,38.01,0.46,401,48605,70,NULL,NULL,'2MASX J13411687+4619446',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,205.320416667,46.329,0.047,NULL,59282973691,926296463,14473382,18.1),(112405,'FP','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,'R',112405,37.94,0.46,387,48606,70,NULL,NULL,'2MASX J13411700+4053126',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000217,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,205.320708333,40.88675,0,NULL,59268009202,926062643,14469728,16.8),(112406,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112406,36.77,0.67,226,48607,NULL,NULL,'Malmquist cor.','CGCG 073-062',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000173,NULL,'15.4g',0.41,NULL,NULL,NULL,NULL,NULL,1,205.32075,13.77547,0,NULL,58337320502,911520632,14242509,15.4),(112407,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112407,37.16,0.56,271,48607,NULL,NULL,NULL,'CGCG 073-062',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112408,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:29','1',NULL,NULL,112408,37.2,0.2,275,48607,74.4,NULL,NULL,'CGCG 073-062',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112409,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112409,32.49,NULL,31.5,48608,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08662',NULL,'2010Ap&SS.325..163P',2010,1,1.51,NULL,'G',0.000007,NULL,'15.3g',0.26,'Sc',NULL,NULL,NULL,NULL,1,205.321875,33.77261,0,NULL,59189105959,924829780,14450465,15.3),(112410,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112410,32.52,NULL,31.9,48608,NULL,NULL,'Dipole + Quadrupole','UGC 08662',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112411,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112411,32.54,NULL,32.3,48608,NULL,NULL,'Dipole','UGC 08662',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112412,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112412,32.6,NULL,33.1,48608,NULL,NULL,NULL,'UGC 08662',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112413,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112413,32.75,0.43,35.4,48608,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08662',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112414,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112414,37.39,0.33,301,48609,70,NULL,NULL,'2MASX J13411747+3516201',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000178,NULL,'16.1g',0.39,NULL,NULL,NULL,NULL,NULL,1,205.3227083,35.27228,0,NULL,59176001931,924625030,14447266,16.1),(112415,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112415,37.32,0.33,291,48610,70,NULL,NULL,'2MASX J13411779+0324514',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000014,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,205.3242083,3.41417,0.012,NULL,58395312321,912426755,14256668,16.5),(112416,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112416,36.48,0.33,198,48611,70,NULL,NULL,'2MASX J13411811+3117420',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000097,NULL,'16.4',0.25,'E3',NULL,NULL,NULL,NULL,1,205.3254583,31.29517,0,NULL,59185874835,924779294,14449676,16.4),(112417,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112417,36.19,0.27,173,48612,70,NULL,NULL,'2MASX J13411826+1419077',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000179,NULL,'16.0g',0.38,NULL,NULL,NULL,NULL,NULL,1,205.326125,14.31886,0,NULL,58337355296,911521176,14242518,16),(112418,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112418,38.09,0.33,415,48613,70,NULL,NULL,'SDSS J134118.72+164815.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,205.3280417,16.80417,0,NULL,58343076342,911610567,14243915,18.6),(112419,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112419,36.68,0.64,217,48614,70,NULL,NULL,'2MASX J13411881-3422329',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00009,NULL,'15.40',NULL,NULL,NULL,NULL,NULL,NULL,1,205.328291667,-34.37575,0.137,NULL,46907763451,732933803,11452090,15.4),(112420,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112420,38.09,0.33,415,48615,70,NULL,NULL,'2MASX J13411957+1644227',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.64',0.12,NULL,NULL,NULL,NULL,NULL,1,205.331667,16.73981,0,NULL,58343095176,911610862,14243919,18.64),(112421,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112421,37.62,0.1,334,48616,70,NULL,NULL,'2MASX J13411971+2621150',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000172,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,205.3322083,26.35408,0,NULL,59125392625,923834259,14434910,18),(112422,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112422,38.6,0.46,525,48617,70,NULL,NULL,'2MASX J13411990+2014495',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,205.333125,20.24708,0,NULL,58797520918,918711264,14354863,17.3),(112423,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112423,37.81,0.46,365,48618,70,NULL,NULL,'2MASX J13412008+2630060',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000178,NULL,'17.3g',0.21,NULL,'Group member',NULL,NULL,NULL,1,205.333833,26.50183,0,NULL,59125846544,923841352,14435021,17.3),(112424,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112424,38.09,0.46,414,48619,70,NULL,NULL,'2MASX J13412018+6108295',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00017,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,205.334125,61.14144,0.013,NULL,57380612411,896572068,14008938,18.1),(112425,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112425,38.38,0.46,474,48620,70,NULL,NULL,'SDSS J134120.70+431546.9',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00017,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,205.33625,43.26306,0,NULL,59318976240,926859003,14482171,18.1),(112426,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112426,38.12,0.46,421,48621,70,NULL,NULL,'2MASX J13412159+3857206',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000102,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,205.339875,38.95561,0,NULL,59266353681,926036776,14469324,18.3),(112427,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112427,37.33,0.46,293,48622,70,NULL,NULL,'2MASX J13412172+5811268',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000172,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,205.3407083,58.19072,0,NULL,57265300670,894770322,13980786,16.8),(112428,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112428,37.87,0.46,374,48623,70,NULL,NULL,'2MASX J13412307+3322210',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,205.3460417,33.37253,0,NULL,59189860694,924841573,14450649,17.4),(112429,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112429,36.19,0.27,173,48624,70,NULL,NULL,'2MASX J13412466+1413427',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,205.352583,14.22839,0,NULL,58337350870,911521107,14242517,16.8),(112430,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112430,37.25,0.46,282,48625,70,NULL,NULL,'2MASX J13412478+1635137',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,205.35325,16.58725,0,NULL,58343035643,911609931,14243905,17.4),(112431,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112431,34.83,NULL,92.6,48626,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08660',NULL,'2010Ap&SS.325..163P',2010,1,1.29,NULL,'G',0.000013,NULL,'16.00',0.12,'Scd',NULL,NULL,NULL,NULL,1,205.35375,13.856,0,NULL,58337326589,911520727,14242511,16),(112432,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112432,34.85,NULL,93.3,48626,NULL,NULL,'Dipole','UGC 08660',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112433,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112433,34.86,NULL,93.5,48626,NULL,NULL,'Dipole + Quadrupole','UGC 08660',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112434,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112434,34.96,0.36,98.3,48626,NULL,NULL,'Malmquist cor.','UGC 08660',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112435,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112435,35.1,0.34,105,48626,NULL,NULL,NULL,'UGC 08660',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112436,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112436,35.11,0.2,105,48626,74.4,NULL,NULL,'UGC 08660',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112437,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112437,37.02,0.6,253,48627,70,NULL,NULL,'2MASX J13412522-1949493',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,205.355166667,-19.83033,0.285,NULL,43762802154,683793783,10684277,15.5),(112438,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112438,36.48,0.33,198,48628,70,NULL,NULL,'2MASX J13412628+3115221',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'16.8',0.19,'E6',NULL,NULL,NULL,NULL,1,205.359416667,31.25617,0,NULL,59185889223,924779519,14449679,16.8),(112439,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112439,37.53,0.46,320,48629,70,NULL,NULL,'2MASX J13412667+4039356',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000137,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,205.36125,40.66,0,NULL,59268070609,926063603,14469743,17.7),(112440,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112440,37.96,0.46,391,48630,70,NULL,NULL,'2MASX J13412688+0110414',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000107,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,205.3617917,1.17814,0.049,NULL,58399878162,912498096,14257782,17.2),(112441,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112441,38.09,0.27,415,48631,70,NULL,NULL,'2MASX J13412714-0109560',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00009,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,205.363083,-1.16558,0.025,NULL,43568045168,680750705,10636729,16.9),(112442,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112442,37.62,0.1,334,48632,70,NULL,NULL,'2MASX J13412723+2625420',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00017,NULL,'17.8g',0.19,NULL,'Group member',NULL,NULL,NULL,1,205.363416667,26.42825,0,NULL,59125392286,923834254,14434910,17.8),(112443,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112443,36.7,0.46,219,48633,70,NULL,NULL,'2MASX J13412845+1048216',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000173,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,205.368708333,10.80586,0,NULL,58418823058,912794110,14262407,16.6),(112444,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112444,36.48,0.46,198,48634,70,NULL,NULL,'2MASX J13412926+2041135',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,205.372,20.68722,0.02,NULL,58797792918,918715514,14354929,16.7),(112445,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112445,37.28,0.46,286,48635,70,NULL,NULL,'2MASX J13412998+6335404',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000112,NULL,'17.1g',0.24,'BLAGN',NULL,NULL,NULL,'Sy 1',1,205.374875,63.59469,0.029,NULL,57865386604,904146665,14127291,17.1),(112446,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112446,38.32,0.46,462,48636,70,NULL,NULL,'SDSS J134131.36+101801.1',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,205.380667,10.30033,0,NULL,58421933492,912842710,14263167,17.4),(112447,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112447,37.44,0.46,307,48637,70,NULL,NULL,'2MASX J13413231+5723136',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000165,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,205.384583333,57.38719,0,NULL,57295022738,895234730,13988042,17),(112448,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112448,37.58,0.46,328,48638,70,NULL,NULL,'SDSS J134133.03+062705.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,205.387666667,6.45144,0.037,NULL,58424539568,912883430,14263803,18),(112449,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112449,37.16,0.58,271,48639,70,NULL,NULL,'LCRS B133855.3-115032',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.57',NULL,NULL,NULL,NULL,NULL,NULL,1,205.395583333,-12.09464,0.173,NULL,43654943267,682108488,10657945,16.57),(112450,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112450,37.07,0.46,259,48640,70,NULL,NULL,'2MASX J13413498+3047401',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000144,NULL,'16.8g',0.28,'E1',NULL,NULL,NULL,NULL,1,205.395875,30.79442,0,NULL,59135498799,923992168,14437377,16.8),(112451,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112451,28.27,NULL,4.5,48641,NULL,NULL,NULL,'NGC 5264',NULL,'2002A&A...385...21K',2002,1,2.5,NULL,'G',0.00001,NULL,'12.60',1.5,'IB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,205.402833,-29.91308,0.181,NULL,46855473580,732116774,11439324,12.6),(112452,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112452,28.36,0.07,4.7,48641,NULL,NULL,'I','NGC 5264',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112453,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112453,28.4,0.1,4.78,48641,74.4,NULL,NULL,'NGC 5264',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112454,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112454,28.1,0.4,4.2,48641,75,NULL,'B','NGC 5264',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112455,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112455,29.14,0.49,6.73,48641,75,NULL,'IR','NGC 5264',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112456,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112456,36.65,0.46,213,48642,70,NULL,NULL,'2MASX J13413675+3444301',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,205.4032917,34.74164,0,NULL,59175970322,924624536,14447258,16.8),(112457,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112457,37.34,0.46,294,48643,70,NULL,NULL,'2MASX J13413717+3337221',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000145,NULL,'17.5g',0.16,'S02/Sa(s)',NULL,NULL,NULL,NULL,1,205.404875,33.62281,0,NULL,59189824519,924841008,14450640,17.5),(112458,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112458,37.67,0.46,342,48644,70,NULL,NULL,'2MASX J13413737+1848144',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,205.40575,18.80389,0.021,NULL,58795877368,918685583,14354462,17.3),(112459,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112459,37.62,0.1,334,48645,70,NULL,NULL,'SDSS J134137.42+262027.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00017,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,205.4059583,26.341,0,NULL,59125396237,923834316,14434911,18.5),(112460,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112460,37.64,0.33,337,48646,70,NULL,NULL,'2MASX J13413762+2048024',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,205.406667,20.80056,0.02,NULL,58797767013,918715109,14354923,17.4),(112461,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112461,37.69,0.27,346,48647,70,NULL,NULL,'2MASX J13413770-0013249',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000069,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,205.406917,-0.22369,0.033,NULL,43563118998,680673734,10635527,18.1),(112462,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112462,27.88,0.29,3.77,48648,NULL,NULL,'I','[KK2000] 57',NULL,'2009AJ....138..332J',2009,1,0.8,NULL,'G',NULL,NULL,'18.1',0.7,'Sph',NULL,NULL,NULL,NULL,1,205.408917,-42.58203,0.349,NULL,46964778508,733824664,11466010,18.1),(112463,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112463,27.92,0.11,3.83,48648,NULL,NULL,NULL,'[KK2000] 57',NULL,'2015ApJ...802L..25T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112464,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112464,27.97,NULL,3.93,48648,NULL,NULL,NULL,'[KK2000] 57',NULL,'2007AJ....133..504K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112465,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112465,35.43,0.46,122,48649,70,NULL,NULL,'2MASX J13413838+0908556',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000169,NULL,'16.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,205.409833,9.14875,0,NULL,58420896869,912826513,14262914,16.3),(112466,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112466,36.38,0.46,189,48650,70,NULL,NULL,'2MASX J13413844+0905246',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000155,NULL,'16.1g',0.37,NULL,NULL,NULL,NULL,NULL,1,205.4102917,9.09019,0,NULL,58420891551,912826430,14262912,16.1),(112467,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112467,37.71,0.33,348,48651,70,NULL,NULL,'2MASX J13413855+1823354',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.79',0.18,NULL,NULL,NULL,NULL,NULL,1,205.4105417,18.39333,0,NULL,58795775901,918683998,14354437,17.79),(112468,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112468,37.64,0.33,337,48652,70,NULL,NULL,'2MASX J13413861+2050354',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,205.410917,20.84317,0.02,NULL,58797758897,918714982,14354921,17.2),(112469,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112469,34.4,0.46,75.9,48653,70,NULL,NULL,'UGC 08663',NULL,'2015arXiv151105856S',2015,1,1.01,NULL,'G',0.000133,NULL,'14.1g',0.87,'S0-:','Group member',NULL,NULL,NULL,1,205.413833,5.03286,0,NULL,58443340694,913177198,14268393,14.1),(112470,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112470,36.4,0.46,191,48654,70,NULL,NULL,'CGCG 073-065',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000123,NULL,'15.4g',0.51,NULL,NULL,NULL,NULL,NULL,1,205.415667,12.64986,0,NULL,58334716444,911479944,14241874,15.4),(112471,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112471,37.42,0.46,305,48655,70,NULL,NULL,'2MASX J13413984+4644526',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000178,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,205.4157917,46.74806,0.062,NULL,59286109410,926345459,14474147,16.9),(112472,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112472,37.12,0.46,266,48656,70,NULL,NULL,'2MASX J13414028+0729336',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.98',0.17,NULL,NULL,NULL,NULL,NULL,1,205.418,7.49264,0.007,NULL,58431421532,912990961,14265483,17.98),(112473,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112473,37.66,0.33,341,48657,70,NULL,NULL,'2MASX J13414117+5804277',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000174,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,205.421541667,58.07442,0,NULL,57265349494,894771085,13980798,17),(112474,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112474,37.62,0.1,334,48658,70,NULL,NULL,'SDSS J134141.23+261745.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000167,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,205.421833,26.29589,0,NULL,59125389929,923834217,14434909,18),(112475,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112475,37.62,0.1,334,48659,70,NULL,NULL,'2MASX J13414239+2615319',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000175,NULL,'17.5g',0.18,NULL,'Group member',NULL,NULL,NULL,1,205.42675,26.25886,0,NULL,59125372036,923833938,14434905,17.5),(112476,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112476,37.09,0.46,262,48660,70,NULL,NULL,'2MASX J13414417+0132404',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000085,NULL,'16.5g',0.35,'S0',NULL,NULL,NULL,NULL,1,205.43425,1.54453,0.049,NULL,58400711984,912511124,14257986,16.5),(112477,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112477,38.29,0.46,456,48661,70,NULL,NULL,'2MASX J13414474+0020314',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000104,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,205.436417,0.34211,0.021,NULL,58391219286,912362801,14255668,17),(112478,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112478,36.78,0.46,227,48662,70,NULL,NULL,'2MASX J13414589+2449598',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000173,NULL,'16.1g',0.33,NULL,'Field galaxy',NULL,NULL,NULL,1,205.4412917,24.83331,0,NULL,58653491723,916460808,14319700,16.1),(112479,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112479,37.29,0.46,287,48663,70,NULL,NULL,'2MASX J13414613+6047373',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000182,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,205.442417,60.79364,0.009,NULL,57380253275,896566457,14008850,16.6),(112480,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112480,38.09,0.27,415,48664,70,NULL,NULL,'2MASX J13414634-0123507',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,205.4432083,-1.39744,0.025,NULL,43567870040,680747969,10636687,17.6),(112481,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112481,37.71,0.33,348,48665,70,NULL,NULL,'2MASX J13414656+1824255',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.53',0.12,NULL,NULL,NULL,NULL,NULL,1,205.444,18.40697,0,NULL,58795785607,918684150,14354439,18.53),(112482,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112482,37.6,0.33,331,48666,70,NULL,NULL,'2MASX J13414654+5454347',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,205.4440417,54.90975,0,NULL,57293935436,895217741,13987777,17.4),(112483,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112483,35.44,0.49,123,48667,NULL,NULL,'Malmquist cor.','ESO 509- G 094',NULL,'2009ApJS..182..474S',2009,1,1.1,'Da Costa, et al. (1998,AJ,116,1) give v = 5501 +/- 62 km/sec.','G',0.000033,NULL,'14.77',0.5,'Sb',NULL,NULL,NULL,NULL,1,205.449167,-23.60822,0.201,NULL,43755693884,683682716,10682542,14.77),(112484,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112484,35.47,0.49,124,48667,NULL,NULL,NULL,'ESO 509- G 094',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112485,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112485,35.51,0.2,126,48667,74.4,NULL,NULL,'ESO 509- G 094',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112486,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112486,37.39,0.33,301,48668,70,NULL,NULL,'2MASX J13414788+3510072',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,205.4495417,35.16861,0,NULL,59176154151,924627408,14447303,17.5),(112487,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112487,37.86,0.46,373,48669,70,NULL,NULL,'2MASX J13414798+6621154',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000074,NULL,'17.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,205.45,66.35431,0.081,NULL,57880731262,904386425,14131037,17.6),(112488,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112488,39.09,0.46,659,48670,70,NULL,NULL,'SDSS J134148.16+105311.3',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000171,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,205.450667,10.8865,0,NULL,58452131439,913314553,14270539,18.1),(112489,'BCG','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112489,37.62,0.35,312,48671,60,NULL,'ABELL 1775, BCG','UGC 08669 NED01',0.0718,'1980ApJ...241..486H',1980,1,0.84,NULL,'G',0.000103,NULL,'15.0g',0.64,'Elliptical;BrClG','Pair member (points to parent)',NULL,NULL,NULL,1,205.45475,26.37347,0,NULL,59125344314,923833504,14434898,15),(112490,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112490,38.09,0.27,415,48672,70,NULL,NULL,'SDSS J134149.76-011703.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,205.457375,-1.28431,0.025,NULL,43567837639,680747463,10636679,18),(112491,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112491,36.58,0.46,207,48673,70,NULL,NULL,'2MASX J13414985+1833475',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.70',0.17,NULL,NULL,NULL,NULL,NULL,1,205.4577083,18.56319,0,NULL,58795865258,918685394,14354459,17.7),(112492,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112492,37.08,0.46,261,48674,70,NULL,NULL,'2MASX J13415013+0020424',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000097,NULL,'16.7g',0.29,'S0',NULL,NULL,NULL,NULL,1,205.458875,0.34506,0.021,NULL,58391229885,912362966,14255671,16.7),(112493,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112493,37,0.46,251,48675,70,NULL,NULL,'2MASX J13415011+4753526',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,205.458875,47.89794,0,NULL,59283896506,926310882,14473607,18),(112494,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112494,37.83,0.46,368,48676,70,NULL,NULL,'2MASX J13415024+1918545',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,205.459417,19.31508,0,NULL,58796274882,918691795,14354559,17.3),(112495,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112495,38.16,0.46,430,48677,70,NULL,NULL,'2MASXi J1341508+393723',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,205.461541667,39.62317,0,NULL,59269159335,926080614,14470009,17.9),(112496,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112496,37.63,0.46,335,48678,70,NULL,NULL,'SDSS J134151.13+183913.0',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.5g',0.3,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,205.463083,18.65361,0,NULL,58795882517,918685664,14354463,16.5),(112497,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112497,36.16,0.46,171,48679,70,NULL,NULL,'UGC 08666 NED01',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000089,NULL,'15.6g',0.49,'E0',NULL,NULL,NULL,NULL,1,205.463375,2.07608,0.009,NULL,58398023734,912469120,14257330,15.6),(112498,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112498,37.02,1.02,254,48680,70,NULL,NULL,'2MASX J13415194-1939254',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,205.466416667,-19.657,0.301,NULL,43762608512,683790758,10684230,15.6),(112499,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112499,37.01,0.46,252,48681,70,NULL,NULL,'2MASX J13415324+3101481',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,205.47175,31.03,0,NULL,59183730567,924745790,14449152,17.4),(112500,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112500,37.33,0.46,293,48682,70,NULL,NULL,'2MASX J13415355-0213587',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,205.4730417,-2.23303,0.101,NULL,43566669592,680729212,10636393,17.1),(112501,'BCG','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112501,37.62,0.35,312,48683,60,NULL,NULL,'ABELL 1775',0.0718,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I      [BM]',NULL,NULL,NULL,NULL,1,205.474167,26.37194,0,NULL,59125344418,923833506,14434898,NULL),(112502,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112502,37.8,0.46,363,48684,70,NULL,NULL,'2MASX J13415389+2801479',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000146,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,205.4744583,28.03017,0,NULL,59136922316,924014411,14437725,17.7),(112503,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112503,37.49,0.46,314,48685,70,NULL,NULL,'2MASX J13415462+0651194',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.39',0.17,NULL,NULL,NULL,NULL,NULL,1,205.47775,6.85544,0.026,NULL,58423941103,912874079,14263657,17.39),(112504,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112504,37.62,0.1,334,48686,70,NULL,NULL,'2MASX J13415509+2620359',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000185,NULL,'17.2g',0.18,NULL,'Group member',NULL,NULL,NULL,1,205.47975,26.34325,0,NULL,59125344656,923833510,14434898,17.2),(112505,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112505,37.5,0.12,317,48687,70,NULL,NULL,'2MASX J13415576+0226144',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000094,NULL,'16.4g',0.33,'AGN',NULL,NULL,NULL,NULL,1,205.482417,2.43739,0.048,NULL,58398205596,912471962,14257374,16.4),(112506,'Tully est','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112506,31.75,0.8,22.4,48688,75,NULL,NULL,'UGCA 372',NULL,'1988NBGC.C....0000T',1988,1,0.2,NULL,'G',0.00002,NULL,'16.5',0.2,'BCD/Irr;WR?    HII',NULL,NULL,NULL,NULL,1,205.485333333,30.51933,0,NULL,59135738080,923995907,14437436,16.5),(112507,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112507,34.73,0.2,88.3,48689,74.4,NULL,NULL,'UGC 08668',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000027,NULL,'14.95',0.6,'Sd',NULL,NULL,NULL,NULL,1,205.4859583,18.14314,0,NULL,58321800125,911278126,14238720,14.95),(112508,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112508,34.81,0.42,91.7,48689,NULL,NULL,NULL,'UGC 08668',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112509,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112509,34.86,0.41,93.6,48689,NULL,NULL,'Malmquist cor.','UGC 08668',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112510,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112510,37.31,0.46,289,48690,70,NULL,NULL,'2MASX J13415770+5144104',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00017,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,205.490667,51.73619,0,NULL,59220842902,925325670,14458213,16.8),(112511,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112511,37.52,0.73,319,48691,70,NULL,NULL,'LCRS B133918.3-115055',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000133,NULL,'15.65',NULL,NULL,NULL,NULL,NULL,NULL,1,205.491625,-12.10086,0.169,NULL,43654942448,682108475,10657944,15.65),(112512,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112512,37.62,0.1,334,48692,70,NULL,NULL,'2MASX J13415851+2621469',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000156,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,205.493917,26.36286,0,NULL,59125345079,923833516,14434898,18.1),(112513,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112513,37.65,0.33,339,48693,70,NULL,NULL,'2MASX J13415941-0034457',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000098,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,205.497666667,-0.57939,0.045,NULL,43563160689,680674385,10635537,17.2),(112514,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112514,37.5,0.12,317,48694,70,NULL,NULL,'2MASX J13420017+0211104',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000085,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,205.500875,2.18631,0.009,NULL,58397943781,912467871,14257310,17),(112515,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112515,30.57,0.49,13,48695,75,NULL,'IR','ESO 220- G 032',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.00038,NULL,'14.40',0.7,'SB?...',NULL,NULL,NULL,NULL,1,205.501708333,-48.31022,0.489,NULL,46818512781,731539262,11430300,14.4),(112516,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112516,37.62,0.1,334,48696,70,NULL,NULL,'SDSS J134200.48+261838.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,205.5020417,26.31058,0,NULL,59125387710,923834182,14434909,18.3),(112517,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112517,36.86,0.46,235,48697,70,NULL,NULL,'2MASX J13420107+5850576',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,205.50425,58.84933,0.005,NULL,57268437259,894819332,13981552,17.3),(112518,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112518,37.06,0.46,258,48698,70,NULL,NULL,'2MASX J13420111+4815144',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000156,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,205.504583,48.254,0,NULL,59213502009,925210968,14456421,16.7),(112519,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112519,35.34,0.48,117,48699,70,NULL,NULL,'2MASX J13420216-3815426',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.4I',0.6,NULL,NULL,NULL,NULL,NULL,1,205.509125,-38.26183,0.189,NULL,46913933735,733030214,11453597,13.4),(112520,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112520,37.62,0.1,334,48700,70,NULL,NULL,'2MASX J13420283+2621379',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'16.32',0.19,NULL,'Group member',NULL,NULL,NULL,1,205.511833333,26.36061,0,NULL,59125346238,923833534,14434898,16.32),(112521,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112521,37.65,0.33,339,48701,70,NULL,NULL,'2MASX J13420414-0034377',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000073,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,205.517208333,-0.57703,0.045,NULL,43563161281,680674395,10635537,17.9),(112522,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112522,37.26,0.46,283,48702,70,NULL,NULL,'2MASX J13420417+2112575',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,205.5175417,21.21619,0,NULL,58801223239,918769113,14355767,16.5),(112523,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112523,37.34,0.46,294,48703,70,NULL,NULL,'SDSS J134204.65+093707.0',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,205.519417,9.61864,0,NULL,58421024256,912828504,14262945,17.6),(112524,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112524,37.69,0.27,346,48704,70,NULL,NULL,'2MASX J13420481-0016537',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000213,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,205.5199583,-0.28156,0.049,NULL,43563329693,680677026,10635578,17.3),(112525,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112525,38.19,0.46,434,48705,70,NULL,NULL,'SDSS J134204.88-002933.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000071,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,205.520375,-0.49275,0.045,NULL,43563220106,680675314,10635551,18.1),(112526,'BCG','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112526,37.77,0.35,332,48706,60,NULL,NULL,'ABELL 1773',0.0776,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,205.522917,2.2275,0.009,NULL,58397942376,912467849,14257310,NULL),(112527,'SBF','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112527,27.87,0.37,3.75,48707,NULL,NULL,'R','AM 1339-445',NULL,'2000AJ....119..166J',2000,1,1.3,NULL,'G',NULL,NULL,'17.6',1.3,'dE',NULL,NULL,NULL,NULL,1,205.5235,-45.20514,0.317,NULL,46964295156,733817111,11465892,17.6),(112528,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112528,27.76,NULL,3.58,48707,NULL,NULL,NULL,'AM 1339-445',NULL,'2002A&A...385...21K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112529,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112529,27.79,0.08,3.61,48707,NULL,NULL,'I','AM 1339-445',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112530,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112530,27.83,0.1,3.68,48707,74.4,NULL,NULL,'AM 1339-445',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112531,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112531,27.83,0.11,3.68,48707,NULL,NULL,NULL,'AM 1339-445',NULL,'2015ApJ...802L..25T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112532,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112532,35.72,0.46,140,48708,70,NULL,NULL,'2MASX J13420622+4649276',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000175,NULL,'15.7g',0.31,'S0/a',NULL,NULL,NULL,NULL,1,205.5259583,46.82428,0.024,NULL,59286098483,926345288,14474145,15.7),(112533,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112533,37.69,0.27,346,48709,70,NULL,NULL,'2MASX J13420800-0016314',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000109,NULL,'16.0g',0.44,'S0;BrClG',NULL,NULL,NULL,NULL,1,205.533417,-0.27544,0.049,NULL,43563336743,680677136,10635580,16),(112534,'SBF','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112534,30.93,0.26,15.3,48710,NULL,NULL,'I','NGC 5273',NULL,'2003ApJ...583..712J',2003,1,1.94,NULL,'G',0.000017,NULL,'12.5g',1.81,'SA(s)0^0^      Sy1.9','Possible field galaxy',NULL,NULL,'Sy 1.9',1,205.53475,35.65422,0,NULL,59175688164,924620127,14447189,12.5),(112535,'SBF','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112535,31.09,0.26,16.5,48710,NULL,NULL,'I','NGC 5273',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112536,'SBF','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112536,31.1,0.14,16.6,48710,74.4,NULL,NULL,'NGC 5273',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112537,'Tully est','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112537,31.65,0.8,21.3,48710,75,NULL,'B','NGC 5273',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112538,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112538,30.58,0.4,13.1,48710,NULL,NULL,'mean','NGC 5273',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112539,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112539,30.67,0.45,13.6,48710,NULL,NULL,'K','NGC 5273',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112540,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112540,33.6,0.47,52.6,48711,70,NULL,NULL,'ESO 445- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000097,NULL,'13.61',0.7,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,205.536667,-30.76342,0.173,NULL,46854628083,732103563,11439118,13.61),(112541,'BCG','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112541,37.77,0.35,332,48712,60,NULL,'ABELL 1773, BCG','2MASX J13420967+0213381',0.0776,'1980ApJ...241..486H',1980,1,0.75,NULL,'G',0.000143,NULL,'16.35',0.41,'BrClG','Brightest group member',NULL,NULL,NULL,1,205.540166667,2.22722,0.009,NULL,58397892240,912467066,14257297,16.35),(112542,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112542,37.62,0.1,334,48713,70,NULL,NULL,'2MASX J13420977+2633448',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.3g',0.23,NULL,'Group member',NULL,NULL,NULL,1,205.54075,26.56247,0,NULL,59125795988,923840562,14435008,17.3);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (112543,'CMD','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112543,15,NULL,0.01,48714,NULL,NULL,NULL,'MESSIER 003',NULL,'2008A&A...477..139L',2008,1,NULL,NULL,'*Cl',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,205.546791667,28.37544,0,0,59139549475,924055460,14438366,NULL),(112544,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112544,36.09,0.46,165,48715,70,NULL,NULL,'2MASX J13421137+2953442',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000174,NULL,'16.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,205.547375,29.89564,0,NULL,59136480922,924007514,14437617,16),(112545,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112545,38.15,0.46,426,48716,70,NULL,NULL,'2MASX J13421288+4810579',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000195,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,205.553666667,48.18286,0,NULL,59213503374,925210990,14456421,16.8),(112546,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112546,37.74,0.46,353,48717,70,NULL,NULL,'2MASX J13421319+1200515',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000165,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,205.555,12.01431,0,NULL,58452575561,913321493,14270648,17.3),(112547,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112547,37.5,0.12,317,48718,70,NULL,NULL,'2MASX J13421407+0157030',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000077,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,205.5587083,1.95094,0.009,NULL,58398050167,912469533,14257336,16.6),(112548,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112548,37.5,0.12,317,48719,70,NULL,NULL,'2MASX J13421441+0215530',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000086,NULL,'17.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,205.559958333,2.26478,0.009,NULL,58398156406,912471193,14257362,17.7),(112549,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112549,33.68,0.53,54.4,48720,70,NULL,NULL,'ESO 445- G 015',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000027,NULL,'14.49',0.5,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,205.560667,-31.03717,0.161,NULL,46897575546,732774617,11449603,14.49),(112550,'IRAS','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112550,33.93,0.8,61.2,48720,75,NULL,'HMCL, I','ESO 445- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112551,'IRAS','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112551,33.94,0.8,61.5,48720,75,NULL,'MAT, I','ESO 445- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112552,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112552,33.96,0.4,61.9,48720,NULL,NULL,'mean','ESO 445- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112553,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112553,34.17,0.43,68.3,48720,75,NULL,'MAT, I, raw','ESO 445- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112554,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112554,34.19,0.32,68.9,48720,85,NULL,'I, raw','ESO 445- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112555,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112555,34.2,0.2,69.2,48720,74.4,NULL,NULL,'ESO 445- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112556,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112556,34.25,0.32,70.8,48720,85,NULL,'I, inv','ESO 445- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112557,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112557,34.29,0.43,72,48720,75,NULL,'3.6 micron, color corrected','ESO 445- G 015',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112558,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112558,34.3,0.43,72.5,48720,75,NULL,'MAT, I, cor','ESO 445- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112559,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112559,34.3,0.07,72.6,48720,NULL,NULL,NULL,'ESO 445- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112560,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112560,34.34,0.47,74,48720,NULL,NULL,'H','ESO 445- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112561,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112561,34.38,0.4,75.3,48720,75,NULL,'HMCL, I, raw','ESO 445- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112562,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112562,34.38,0.46,75.3,48720,NULL,NULL,'J','ESO 445- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112563,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112563,34.42,0.43,76.7,48720,75,NULL,'MAT, I, inv','ESO 445- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112564,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112564,34.47,0.45,78.4,48720,NULL,NULL,'K','ESO 445- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112565,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112565,34.47,0.43,78.4,48720,75,NULL,'3.6 micron, color + selection bias corrected','ESO 445- G 015',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112566,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112566,34.54,0.4,80.8,48720,75,NULL,'HMCL, I, cor','ESO 445- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112567,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112567,34.6,0.4,83,48720,75,NULL,'HMCL, I, inv','ESO 445- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112568,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112568,38.07,0.46,411,48721,70,NULL,NULL,'SDSS J134215.71+053234.6',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,205.5655,5.54294,0.008,NULL,58442170305,913158911,14268107,17.8),(112569,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112569,31.89,0.43,23.9,48722,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08684',NULL,'2014MNRAS.444..527S',2014,1,1.55,NULL,'G',0.000043,NULL,'14.2g',0.51,'Scd(f)','in a radial-velocity based grouping',NULL,NULL,NULL,1,205.567,60.77689,0.009,NULL,57261825623,894716025,13979937,14.2),(112570,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112570,31.96,0.43,24.7,48722,75,NULL,'3.6 micron, color corrected','UGC 08684',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112571,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112571,32.02,0.2,25.4,48722,74.4,NULL,NULL,'UGC 08684',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112572,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112572,32.07,0.4,26,48722,75,NULL,NULL,'UGC 08684',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112573,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112573,32.32,0.49,29.1,48722,75,NULL,'IR','UGC 08684',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112574,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112574,32.76,0.4,35.6,48722,NULL,NULL,'mean','UGC 08684',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112575,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112575,32.81,0.47,36.5,48722,NULL,NULL,'H','UGC 08684',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112576,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112576,32.94,0.46,38.7,48722,NULL,NULL,'J','UGC 08684',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112577,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112577,32.98,0.45,39.5,48722,NULL,NULL,'K','UGC 08684',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112578,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112578,37.48,0.46,314,48723,70,NULL,NULL,'2MASX J13421621+1528225',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.81',0.19,NULL,NULL,NULL,NULL,NULL,1,205.567583333,15.47303,0,NULL,58344857833,911638403,14244350,17.81),(112579,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112579,37.5,0.12,317,48724,70,NULL,NULL,'2MASX J13421701+0214070',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000081,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,205.570875,2.23517,0.009,NULL,58397891249,912467050,14257297,17.3),(112580,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112580,37.32,0.46,292,48725,70,NULL,NULL,'2MASX J13421734+1933567',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,205.572333,19.56567,0,NULL,58796020486,918687820,14354497,17.2),(112581,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112581,37.62,0.1,334,48726,70,NULL,NULL,'2MASX J13421829+2619203',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'17.4g',0.24,NULL,'Group member',NULL,NULL,NULL,1,205.576166667,26.32231,0,NULL,59126452558,923850821,14435169,17.4),(112582,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112582,36.99,0.46,250,48727,70,NULL,NULL,'2MASX J13421903+0639048',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.17',0.16,NULL,NULL,NULL,NULL,NULL,1,205.579167,6.65128,0.037,NULL,58424490636,912882666,14263791,18.17),(112583,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112583,36.69,0.46,218,48728,70,NULL,NULL,'2MASX J13422022+0319520',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000064,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,205.584208333,3.33128,0.019,NULL,58440320411,913130006,14267656,17),(112584,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112584,35.22,0.46,110,48729,70,NULL,NULL,'2MASX J13422021+1727505',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.73',0.18,NULL,NULL,NULL,NULL,NULL,1,205.584416667,17.464,0,NULL,58342858181,911607159,14243861,17.73),(112585,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112585,37.5,0.12,317,48730,70,NULL,NULL,'2MASX J13422168+0212590',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,'FoF','18.13',0.19,NULL,NULL,NULL,NULL,NULL,1,205.590417,2.21636,0.009,NULL,58397899027,912467172,14257299,18.13),(112586,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112586,38.43,0.46,485,48731,70,NULL,NULL,'SDSS J134221.74-013957.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000177,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,205.590583333,-1.66608,0.093,NULL,43564667755,680697933,10635905,18.3),(112587,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112587,37.64,0.46,337,48732,70,NULL,NULL,'2MASX J13422203+0401030',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000217,NULL,'16.6g',0.31,'AGN',NULL,NULL,NULL,NULL,1,205.591667,4.01744,0.018,NULL,58441297606,913145275,14267894,16.6),(112588,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112588,38.67,0.46,541,48733,70,NULL,NULL,'2MASX J13422239+1842537',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,205.593167,18.71483,0,NULL,58321934501,911280226,14238753,17.5),(112589,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112589,37.92,0.46,383,48734,70,NULL,NULL,'2MASX J13422238+4045317',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,205.593417,40.75878,0,NULL,59268557962,926071218,14469862,17.7),(112590,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112590,37.5,0.12,317,48735,70,NULL,NULL,'2MASX J13422261+0213070',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000068,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,205.594375,2.21867,0.009,NULL,58397899114,912467173,14257299,17.2),(112591,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112591,37.29,0.46,288,48736,70,NULL,NULL,'2MASX J13422321+3105172',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,205.5967917,31.08811,0,NULL,59183732669,924745822,14449153,17.9),(112592,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112592,35.64,0.25,134,48737,74.4,NULL,NULL,'NGC 5274',NULL,'2013AJ....146...86T',2013,1,0.67,NULL,'G',0.00005,NULL,'15.2g',0.59,'E','Group member',NULL,NULL,NULL,1,205.597125,29.84783,0,NULL,59136537001,924008390,14437631,15.2),(112593,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112593,35.8,0.25,145,48737,70,NULL,NULL,'NGC 5274',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112594,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112594,36.47,0.21,196,48737,70,NULL,NULL,'NGC 5274',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112595,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112595,35.63,0.25,134,48738,74.4,NULL,NULL,'NGC 5275',NULL,'2013AJ....146...86T',2013,1,0.5,'RC3 gives v = 1395 +/- 49 km/sec.','G',0.00006,NULL,'15.2',0.5,'E/S0','Group member',NULL,NULL,NULL,1,205.598167,29.82489,0,NULL,59136540413,924008443,14437631,15.2),(112596,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112596,35.8,0.25,145,48738,70,NULL,NULL,'NGC 5275',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112597,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112597,36.18,0.2,172,48739,74.4,NULL,NULL,'CGCG 102-036',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000183,NULL,'15.3',0.6,NULL,NULL,NULL,NULL,NULL,1,205.5995417,14.73914,0,NULL,58348208565,911690758,14245168,15.3),(112598,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112598,36.47,0.21,196,48740,70,NULL,NULL,'SDSS J134224.69+294947.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000169,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,205.602917,29.82986,0,NULL,59136540309,924008442,14437631,17.6),(112599,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112599,37.32,0.23,291,48741,70,NULL,NULL,'2MASX J13422559+2612443',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000167,NULL,'15.9g',0.38,NULL,'Group member',NULL,NULL,NULL,1,205.60675,26.21244,0,NULL,59126506646,923851666,14435182,15.9),(112600,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112600,35.07,NULL,103,48742,NULL,NULL,NULL,'CGCG 045-077',NULL,'2000BSAO...50....5K',2000,1,1.07,NULL,'G',0.000023,NULL,'16.0g',0.18,'Sd(f)',NULL,NULL,NULL,NULL,1,205.607667,3.85606,0.024,NULL,58441250641,913144541,14267883,16),(112601,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112601,35.17,NULL,108,48742,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 045-077',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112602,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112602,35.2,NULL,110,48742,NULL,NULL,'Dipole + Quadrupole','CGCG 045-077',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112603,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112603,35.24,NULL,112,48742,NULL,NULL,'Dipole','CGCG 045-077',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112604,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112604,35.28,0.49,114,48742,75,NULL,'IR','CGCG 045-077',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112605,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112605,37.19,0.33,275,48743,70,NULL,NULL,'2MASX J13422613+0041460',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000078,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,205.6089583,0.69617,0.017,NULL,58391909922,912373592,14255837,17.3),(112606,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112606,37.28,0.13,285,48744,70,NULL,NULL,'2MASX J13422624+5527217',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000156,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,205.60925,55.45606,0,NULL,57290414304,895162723,13986917,16.5),(112607,'IRAS','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112607,32.28,0.8,28.6,48745,75,NULL,'MAT, I','ESO 021- G 005',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.00002,NULL,'13.69',0.5,'Sb? sp',NULL,NULL,NULL,NULL,1,205.613333,-79.01139,0.497,NULL,44252677592,691448087,10803876,13.69),(112608,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112608,31.68,0.32,21.7,48745,85,NULL,'I, inv','ESO 021- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112609,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112609,31.72,0.32,22.1,48745,85,NULL,'I, raw','ESO 021- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112610,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112610,32.25,0.43,28.2,48745,75,NULL,'MAT, I, inv','ESO 021- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112611,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112611,32.32,0.43,29.1,48745,75,NULL,'MAT, I, raw','ESO 021- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112612,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112612,32.55,0.43,32.4,48745,75,NULL,'MAT, I, cor','ESO 021- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112613,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112613,37.5,0.12,317,48746,70,NULL,NULL,'2MASX J13422948+0212040',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000079,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,205.62275,2.20122,0.009,NULL,58397899922,912467186,14257299,16.3),(112614,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112614,37.57,0.46,326,48747,70,NULL,NULL,'2MASX J13422983+2558194',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.9g',0.14,NULL,'Group member',NULL,NULL,NULL,1,205.62425,25.97211,0,NULL,59126535244,923852113,14435189,17.9),(112615,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112615,37.5,0.12,317,48748,70,NULL,NULL,'SDSS J134230.66+020329.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000059,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,205.6277917,2.05822,0.009,NULL,58397922290,912467535,14257305,18.1),(112616,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112616,38.09,0.46,414,48749,70,NULL,NULL,'SDSS J134231.15+491600.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,205.629833,49.26686,0,NULL,59213948601,925217946,14456530,18.2),(112617,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112617,29.75,NULL,8.91,48750,NULL,NULL,NULL,'UGC 08683',NULL,'2013AJ....145..101K',2013,1,0.8,NULL,'G',0.000009,NULL,'15.7g',0.59,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,205.6355,39.6585,0,NULL,59269128508,926080132,14470002,15.7),(112618,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112618,30.04,0.4,10.2,48750,75,NULL,'B','UGC 08683',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112619,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112619,37.6,0.33,331,48751,70,NULL,NULL,'2MASX J13423317+5457417',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00017,NULL,'16.2g',0.4,'BrClG',NULL,NULL,NULL,NULL,1,205.638083,54.96147,0,NULL,57293802261,895215660,13987744,16.2),(112620,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112620,36.94,0.46,244,48752,70,NULL,NULL,'2MASX J13423318+2520414',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000185,NULL,'15.6g',0.44,NULL,'Field galaxy',NULL,NULL,NULL,1,205.638167,25.34489,0,NULL,59123456446,923804006,14434437,15.6),(112621,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112621,37.62,0.1,334,48753,70,NULL,NULL,'2MASX J13423338+2637314',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000176,NULL,'17.4g',0.23,NULL,'Group member',NULL,NULL,NULL,1,205.639083333,26.62547,0,NULL,59125663538,923838492,14434976,17.4),(112622,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112622,36.47,0.46,197,48754,70,NULL,NULL,'2MASX J13423370+1943496',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.88',0.16,NULL,NULL,NULL,NULL,NULL,1,205.640333,19.73058,0,NULL,58797337819,918708403,14354818,17.88),(112623,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112623,37.83,0.46,368,48755,70,NULL,NULL,'2MASX J13423384+4853160',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000191,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,205.641125,48.88783,0,NULL,59214126159,925220721,14456573,16.7),(112624,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112624,36.53,0.6,203,48756,70,NULL,NULL,'2MASX J13423403-4006539',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.4,NULL,NULL,NULL,NULL,NULL,1,205.64175,-40.11508,0.157,NULL,46917064759,733079136,11454361,13.9),(112625,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112625,35.24,0.49,112,48757,70,NULL,NULL,'2MASX J13423447-1039134',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00011,NULL,'15.11',NULL,NULL,NULL,NULL,NULL,NULL,1,205.643625,-10.65381,0.125,NULL,43688396852,682631200,10666112,15.11),(112626,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112626,36.98,0.46,248,48758,70,NULL,NULL,'2MASX J13423466+1536527',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.09',0.15,NULL,NULL,NULL,NULL,NULL,1,205.644375,15.61456,0,NULL,58344648403,911635131,14244298,18.09),(112627,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112627,37.28,0.13,285,48759,70,NULL,NULL,'SDSS J134235.01+553419.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,205.645916667,55.57222,0,NULL,57288539027,895133422,13986459,18.4),(112628,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112628,37.05,0.46,257,48760,70,NULL,NULL,'2MASX J13423539+4907340',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000166,NULL,'16.9g',0.33,NULL,NULL,NULL,NULL,NULL,1,205.64725,49.12625,0,NULL,59213994837,925218669,14456541,16.9),(112629,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112629,37.19,0.33,275,48761,70,NULL,NULL,'2MASX J13423807+0041050',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000102,NULL,'16.5g',0.3,'S0',NULL,NULL,NULL,NULL,1,205.6584583,0.68486,0.017,NULL,58391910836,912373606,14255837,16.5),(112630,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112630,36.68,0.46,217,48762,70,NULL,NULL,'2MASX J13423804+3507169',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00016,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,205.6587083,35.12131,0,NULL,59176354893,924630545,14447352,16.9),(112631,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112631,35.67,0.46,136,48763,70,NULL,NULL,'2MASX J13423956+4535032',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000127,NULL,'15.3g',0.6,'S0',NULL,NULL,NULL,NULL,1,205.664666667,45.58433,0.01,NULL,59316338676,926817791,14481527,15.3),(112632,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112632,37.5,0.12,317,48764,70,NULL,NULL,'2MASX J13424009+0223460',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000073,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,205.667125,2.39608,0.019,NULL,58397432554,912459883,14257185,16.5),(112633,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112633,37.44,0.46,308,48765,70,NULL,NULL,'2MASX J13424030+0253560',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000091,NULL,'16.6g',0.3,'NLAGN',NULL,NULL,NULL,NULL,1,205.667833,2.89889,0.019,NULL,58397359746,912458746,14257167,16.6),(112634,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112634,37.5,0.12,317,48766,70,NULL,NULL,'2MASX J13424329+0207560',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000074,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,205.680417,2.13233,0.009,NULL,58390354626,912349291,14255457,17.7),(112635,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112635,37.51,0.46,317,48767,70,NULL,NULL,'2MASX J13424364+0317120',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000086,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,205.6817083,3.28672,0.018,NULL,58440349803,913130465,14267663,17.1),(112636,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112636,38.23,0.46,443,48768,70,NULL,NULL,'2MASX J13424533+6518024',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000099,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,205.688875,65.30067,0.049,NULL,57880359608,904380618,14130947,17.3),(112637,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112637,37.1,0.46,262,48769,70,NULL,NULL,'2MASX J13424545+2722523',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,205.6892917,27.38128,0,NULL,59125558076,923836844,14434950,17.5),(112638,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112638,36.08,0.46,165,48770,70,NULL,NULL,'2MASX J13424574+2435243',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.10',0.24,NULL,NULL,NULL,NULL,NULL,1,205.690417,24.59003,0,NULL,58654137749,916470902,14319857,17.1),(112639,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112639,37.73,0.46,351,48771,70,NULL,NULL,'2MASX J13424575+4500352',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000175,NULL,'16.5g',0.38,NULL,NULL,NULL,NULL,NULL,1,205.690667,45.00978,0,NULL,59316186934,926815420,14481490,16.5),(112640,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112640,37.66,0.33,341,48772,70,NULL,NULL,'2MASX J13424642+5802047',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,205.6935417,58.03472,0,NULL,57265322980,894770671,13980791,17.2),(112641,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112641,38.36,0.33,470,48773,70,NULL,NULL,'SDSS J134247.01+113516.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000137,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,205.695916667,11.58786,0.015,NULL,58452541270,913320957,14270639,18.4),(112642,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112642,35.64,0.25,134,48774,74.4,NULL,NULL,'CGCG 161-130',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000113,NULL,'15.5g',0.45,'E/S0','Group member',NULL,NULL,NULL,1,205.702583,29.70575,0,NULL,59136519902,924008123,14437626,15.5),(112643,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112643,35.8,0.25,145,48774,70,NULL,NULL,'CGCG 161-130',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112644,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112644,36.47,0.21,196,48774,70,NULL,NULL,'CGCG 161-130',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112645,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112645,38.06,0.46,408,48775,70,NULL,NULL,'SDSS J134249.40+120225.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,205.705875,12.04028,0,NULL,58452371956,913318311,14270598,18.5),(112646,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112646,37.8,0.46,363,48776,70,NULL,NULL,'2MASX J13424966+1148376',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000186,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,205.7067917,11.81042,0,NULL,58452563421,913321303,14270645,16.6),(112647,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112647,37.5,0.12,317,48777,70,NULL,NULL,'2MASX J13425078+0238590',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000086,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,205.711667,2.64975,0.019,NULL,58397508458,912461069,14257204,17.5),(112648,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112648,37.62,0.1,334,48778,70,NULL,NULL,'2MASX J13425082+2616399',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.6g',0.16,NULL,'Group member',NULL,NULL,NULL,1,205.71175,26.27792,0,NULL,59126504452,923851632,14435181,17.6),(112649,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112649,38.18,0.46,432,48779,70,NULL,NULL,'LCRS B134018.1-022822',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000158,NULL,'18.8g',0.08,NULL,NULL,NULL,NULL,NULL,1,205.721166667,-2.72394,0.065,NULL,43566254810,680722731,10636292,18.8),(112650,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112650,37.46,0.46,311,48780,70,NULL,NULL,'2MASX J13425390+5446067',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000184,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,205.7247083,54.76853,0,NULL,57293499881,895210935,13987670,17.1),(112651,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112651,35.3,0.46,115,48781,70,NULL,NULL,'CGCG 131-029',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000157,NULL,'15.2',0.3,'AGN',NULL,NULL,NULL,'Emission-Line Galaxy',1,205.727875,22.14519,0,NULL,58790477546,918601211,14353143,15.2),(112652,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112652,34.58,0.11,82.6,48782,NULL,NULL,NULL,'ESO 509- G 096',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'16.12',0.6,'S...',NULL,NULL,NULL,NULL,1,205.7307917,-25.12369,0.297,NULL,46842412767,731912699,11436135,16.12),(112653,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112653,35.47,0.25,124,48783,74.4,NULL,NULL,'NGC 5280',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.0001,NULL,'14.65',0.8,'E/S0','Group member',NULL,NULL,NULL,1,205.731417,29.86861,0,NULL,59136512483,924008007,14437625,14.65),(112654,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112654,35.8,0.25,145,48783,70,NULL,NULL,'NGC 5280',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112655,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112655,38.2,0.46,437,48784,70,NULL,NULL,'SDSS J134255.89+022754.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000079,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,205.732917,2.46517,0.019,NULL,58390057309,912344645,14255385,18.3),(112656,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112656,37.28,0.13,285,48785,70,NULL,NULL,'IC 0922',NULL,'2015arXiv151105856S',2015,1,0.66,'Identification as IC 0922 is not certain.','G',0.000189,NULL,'15.6g',0.52,'BrClG',NULL,NULL,NULL,NULL,1,205.734833,55.60389,0,NULL,57288529570,895133274,13986457,15.6),(112657,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112657,37.92,0.33,384,48786,70,NULL,NULL,'SDSS J134256.81+181645.1',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,205.73675,18.27919,0,NULL,58322046471,911281976,14238780,NULL),(112658,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112658,37.75,0.46,355,48787,70,NULL,NULL,'2MASX J13425681+0003229',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000075,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,205.736833,0.05644,0.021,NULL,58391117724,912361214,14255643,17.5),(112659,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112659,37.38,0.46,299,48788,70,NULL,NULL,'2MASX J13425701+0057050',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000086,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,205.7375417,0.95131,0.021,NULL,58391783676,912371619,14255806,17.1),(112660,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112660,36.88,0.46,237,48789,70,NULL,NULL,'2MASX J13425765+4713277',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000213,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,205.74025,47.22433,0,NULL,59282574265,926290222,14473284,16.6),(112661,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112661,36.17,0.46,172,48790,70,NULL,NULL,'2MASX J13425809-0045550',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000082,NULL,'16.5g',0.28,'S0',NULL,NULL,NULL,NULL,1,205.742,-0.76542,0.045,NULL,43563519522,680679992,10635624,16.5),(112662,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112662,36.05,0.52,162,48791,70,NULL,NULL,'2MASX J13425875-3153105',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000097,NULL,'15.8b',0.5,'SB',NULL,NULL,NULL,NULL,1,205.7447917,-31.88633,0.113,NULL,46905034072,732891157,11451424,15.8),(112663,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112663,37.32,0.23,291,48792,70,NULL,NULL,'2MASX J13425900+2615490',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000167,NULL,'15.9g',0.36,NULL,'Group member',NULL,NULL,NULL,1,205.745875,26.26369,0,NULL,59126504368,923851630,14435181,15.9),(112664,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112664,37.76,0.46,356,48793,70,NULL,NULL,'SDSS J134259.16+100704.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000173,NULL,'18.3g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,205.7465,10.11781,0.016,NULL,58420872908,912826139,14262908,18.3),(112665,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112665,37.5,0.12,317,48794,70,NULL,NULL,'2MASX J13425945+0232250',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000084,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,205.74775,2.54028,0.039,NULL,58390068043,912344813,14255387,16.5),(112666,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112666,36.81,0.46,230,48795,70,NULL,NULL,'2MASX J13425948+3616574',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000175,NULL,'17.65',0.21,NULL,NULL,NULL,NULL,NULL,1,205.747917,36.28261,0,NULL,59145458532,924147789,14439809,17.65),(112667,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112667,37.92,0.33,384,48796,70,NULL,NULL,'2MASX J13425967+1818335',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.92',0.16,NULL,NULL,NULL,NULL,NULL,1,205.748875,18.3095,0,NULL,58322044400,911281943,14238780,17.92),(112668,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112668,37.87,0.27,375,48797,70,NULL,NULL,'2MASX J13425967+4831190',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000155,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,205.748917,48.522,0,NULL,59213430946,925209858,14456404,17.2),(112669,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112669,37.18,0.46,273,48798,70,NULL,NULL,'2MASX J13430097+3042379',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,205.753917,30.71042,0,NULL,59128169782,923877652,14435588,17.4),(112670,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112670,37.87,0.27,375,48799,70,NULL,NULL,'2MASX J13430150+4827340',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000169,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,205.7562083,48.45961,0,NULL,59213548978,925211702,14456432,18),(112671,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112671,36.57,0.61,206,48800,70,NULL,NULL,'2MASX J13430151-1958025',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,205.7562917,-19.96744,0.329,NULL,43761746411,683777287,10684020,15.4),(112672,'Faber-Jackson','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112672,31.93,0.65,24.3,48801,95,NULL,'Weighted Mean','NGC 5266',NULL,'1984ApJS...56...91D',1984,1,3.2,'Confused HIPASS source','G',0.00002,NULL,'12.08',2.1,'SA0-:          LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,205.7587917,-48.16942,0.497,NULL,46818641919,731541279,11430332,12.08),(112673,'Faber-Jackson','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112673,33.37,0.81,47.2,48801,55,NULL,'Visvanathan & Sandage 1979','NGC 5266',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112674,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112674,31.89,0.48,23.9,48801,70,NULL,NULL,'NGC 5266',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112675,'Tully est','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112675,33.05,0.8,40.8,48801,75,NULL,'B','NGC 5266',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112676,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112676,31.72,0.45,22.1,48801,NULL,NULL,'K','NGC 5266',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112677,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112677,33.06,0.4,40.9,48801,NULL,NULL,'mean','NGC 5266',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112678,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112678,37.2,0.46,276,48802,70,NULL,NULL,'2MASX J13430217+5318030',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000147,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,205.759125,53.30103,0,NULL,57292104591,895189134,13987330,17.6),(112679,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112679,35.22,0.56,111,48803,70,NULL,NULL,'2MASX J13430232-2014585',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.58',NULL,NULL,NULL,NULL,NULL,NULL,1,205.7595417,-20.24969,0.329,NULL,43761676541,683776195,10684003,15.58),(112680,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112680,36.47,0.21,196,48804,70,NULL,NULL,'2MASX J13430283+2951440',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,205.761875,29.86214,0,NULL,59136515522,924008055,14437625,17.2),(112681,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112681,37.87,0.27,375,48805,70,NULL,NULL,'2MASX J13430290+4827290',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,205.7620417,48.45825,0,NULL,59213547879,925211685,14456432,17.2),(112682,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112682,34.74,0.46,88.8,48806,70,NULL,NULL,'CGCG 102-037',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000183,NULL,'15.4',0.3,NULL,NULL,NULL,NULL,NULL,1,205.766166667,16.70547,0,NULL,58343155843,911611810,14243934,15.4),(112683,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112683,36.75,0.46,223,48807,70,NULL,NULL,'LCRS B134028.9-025147',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,205.766958333,-3.11431,0.065,NULL,43614485001,681476328,10648067,16.5),(112684,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112684,37.52,0.46,320,48808,70,NULL,NULL,'2MASX J13430441+0307210',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.06',0.18,NULL,NULL,NULL,NULL,NULL,1,205.768458333,3.12247,0.023,NULL,58440301590,913129712,14267651,18.06),(112685,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112685,35.74,0.68,141,48809,70,NULL,NULL,'2MASX J13430580-2004221',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.96',NULL,NULL,NULL,NULL,NULL,NULL,1,205.774208333,-20.07297,0.329,NULL,43761694022,683776469,10684007,15.96),(112686,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112686,38.05,0.46,408,48810,70,NULL,NULL,'SDSS J134307.24+190830.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,205.7802083,19.14178,0,NULL,58322567065,911290110,14238907,18.1),(112687,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112687,36.84,0.46,233,48811,70,NULL,NULL,'2MASX J13430728+3055153',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000137,NULL,'16.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,205.780458333,30.92089,0,NULL,59128202439,923878163,14435596,16.1),(112688,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112688,37.03,0.46,254,48812,70,NULL,NULL,'2MASX J13430791+1721344',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,205.782833,17.35964,0,NULL,58342934412,911608350,14243880,17.6),(112689,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112689,37.28,0.13,285,48813,70,NULL,NULL,'IC 0921',NULL,'2015arXiv151105856S',2015,1,0.29,'Identification as IC 0921 is not certain.','G',0.000187,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,205.783333,55.65122,0,NULL,57288554850,895133669,13986463,17),(112690,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112690,38.66,0.46,540,48814,70,NULL,NULL,'2MASX J13430862+6049265',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000168,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,205.785916667,60.82397,0.009,NULL,57261830004,894716093,13979938,17.5),(112691,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112691,37.96,0.46,391,48815,70,NULL,NULL,'2MASX J13430871+2823150',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000185,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,205.786541667,28.38767,0,NULL,59139509653,924054838,14438356,17.2),(112692,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112692,38.06,0.46,409,48816,70,NULL,NULL,'2MASX J13430893+6348235',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000083,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,205.78725,63.80664,0.025,NULL,57865363886,904146310,14127286,17.8),(112693,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112693,38.01,0.27,399,48817,70,NULL,NULL,'SDSS J134309.88+101130.8',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.9g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,205.791166667,10.19192,0.04,NULL,58420670015,912822968,14262858,17.9),(112694,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112694,38.01,0.27,399,48818,70,NULL,NULL,'SDSS J134310.75+101639.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,205.7947917,10.27767,0.04,NULL,58420663705,912822870,14262857,18),(112695,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112695,38.38,0.46,475,48819,70,NULL,NULL,'2MASX J13431090+6031005',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,205.795417,60.51686,0.009,NULL,57261933949,894717717,13979964,18.1),(112696,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112696,37.41,0.46,303,48820,70,NULL,NULL,'2MASX J13431216+1724234',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.15',0.16,NULL,NULL,NULL,NULL,NULL,1,205.8007917,17.40647,0,NULL,58342945468,911608522,14243883,18.15),(112697,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112697,37.67,0.46,343,48821,70,NULL,NULL,'2MASX J13431300+4546017',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000182,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,205.80425,45.76725,0.01,NULL,59282921479,926295648,14473369,16.9),(112698,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112698,37.28,0.13,285,48822,70,NULL,NULL,'2MASX J13431372+5552283',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,205.807333,55.87464,0,NULL,57288918728,895139355,13986552,17.1),(112699,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112699,38.02,0.46,402,48823,70,NULL,NULL,'2MASX J13431384+4513267',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,205.80775,45.22414,0,NULL,59316196951,926815577,14481493,17.9),(112700,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112700,37.28,0.13,285,48824,70,NULL,NULL,'IC 0923',NULL,'2015arXiv151105856S',2015,1,0.45,'Identification as IC 0923 is not certain.','G',0.000218,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,205.809125,55.60314,0,NULL,57288545016,895133515,13986461,16.2),(112701,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112701,37.39,0.46,300,48825,70,NULL,NULL,'2MASX J13431531+2639040',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000155,NULL,'17.5g',0.21,NULL,'Group member',NULL,NULL,NULL,1,205.813833,26.65108,0,NULL,59126126357,923845724,14435089,17.5),(112702,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112702,38.01,0.27,399,48826,70,NULL,NULL,'2MASX J13431606+1016087',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000164,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,205.816916667,10.26911,0.04,NULL,58420672797,912823012,14262859,16.7),(112703,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112703,38.08,0.46,414,48827,70,NULL,NULL,'2MASX J13431657+1753455',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.98',0.14,NULL,NULL,NULL,NULL,NULL,1,205.819208333,17.896,0,NULL,58376568858,912133888,14252092,17.98),(112704,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112704,38.36,0.33,470,48828,70,NULL,NULL,'SDSS J134317.49+113441.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'18.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,205.822917,11.57808,0.015,NULL,58455333375,913364583,14271321,18.3),(112705,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112705,34.59,0.07,83,48829,NULL,NULL,NULL,'ESO 509- G 097',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.00003,NULL,'14.56',0.8,'Sb             HII',NULL,NULL,NULL,NULL,1,205.8247083,-25.26575,0.297,NULL,46842470532,731913602,11436150,14.56),(112706,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112706,37.32,0.23,291,48830,70,NULL,NULL,'2MASX J13431833+2614069',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000167,NULL,'18.33',0.17,NULL,'Group member',NULL,NULL,NULL,1,205.826333,26.23531,0,NULL,59126495597,923851493,14435179,18.33),(112707,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112707,36.9,0.46,240,48831,70,NULL,NULL,'2MASX J13432041+0108383',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00007,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,205.8350417,1.14394,0.025,NULL,58391560290,912368129,14255752,17),(112708,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112708,35.62,0.59,133,48832,70,NULL,NULL,'2MASX J13432084-1951191',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,205.836833,-19.85533,0.273,NULL,43630754838,681730544,10652039,14.7),(112709,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112709,37.17,0.46,271,48833,70,NULL,NULL,'SDSS J134321.00+031421.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000074,NULL,'17.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,205.837541667,3.23931,0.039,NULL,58447663841,913244747,14269449,17.9),(112710,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112710,36.76,0.46,225,48834,70,NULL,NULL,'2MASX J13432222+4627527',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000158,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,205.8425,46.46453,0.028,NULL,59283100713,926298448,14473413,16.9),(112711,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112711,35.63,0.25,134,48835,74.4,NULL,NULL,'NGC 5282',NULL,'2013AJ....146...86T',2013,1,0.87,NULL,'G',0.0001,NULL,'14.7g',0.71,'E/S0',NULL,NULL,NULL,NULL,1,205.853667,30.06953,0,NULL,59136404489,924006320,14437598,14.7),(112712,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112712,35.8,0.25,145,48835,70,NULL,NULL,'NGC 5282',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112713,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112713,37.28,0.13,285,48836,70,NULL,NULL,'2MASX J13432621+5546354',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000176,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,205.8594583,55.77647,0,NULL,57288517234,895133081,13986454,16.7),(112714,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112714,37.35,0.46,295,48837,70,NULL,NULL,'SDSS J134326.44+024420.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000079,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,205.860167,2.73906,0.039,NULL,58390017931,912344030,14255375,17.9),(112715,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112715,37.17,0.33,272,48838,70,NULL,NULL,'2MASX J13432641+5604244',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000166,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,205.860291667,56.07336,0,NULL,57288907554,895139180,13986549,16.6),(112716,'IRAS','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112716,34.07,0.8,65.2,48839,75,NULL,'MAT, I','IC 4319',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.31',0.5,'SA(s)bc?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,205.8607083,-29.80347,0.193,NULL,46855505646,732117275,11439332,14.31),(112717,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112717,33.75,0.43,56.3,48839,75,NULL,'MAT, I, raw','IC 4319',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112718,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112718,33.81,0.32,57.8,48839,85,NULL,'I, raw','IC 4319',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112719,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112719,33.87,0.32,59.3,48839,85,NULL,'I, inv','IC 4319',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112720,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112720,33.91,0.43,60.5,48839,75,NULL,'MAT, I, cor','IC 4319',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112721,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112721,33.99,0.43,62.9,48839,75,NULL,'MAT, I, inv','IC 4319',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112722,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112722,34.3,0.08,72.6,48839,NULL,NULL,NULL,'IC 4319',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112723,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112723,37.39,0.46,301,48840,70,NULL,NULL,'2MASX J13432680+1858397',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.44',0.13,NULL,NULL,NULL,NULL,NULL,1,205.861625,18.97769,0,NULL,58322410754,911287668,14238869,18.44),(112724,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112724,37.62,0.1,334,48841,70,NULL,NULL,'2MASX J13432910+2629368',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000172,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,205.871375,26.49353,0,NULL,59127027637,923859806,14435309,16.6),(112725,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112725,35.09,NULL,104,48842,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1660',NULL,'2010Ap&SS.325..163P',2010,1,1.08,'Multiple SDSS entries describe this source.','G',NULL,NULL,'17.32',0.1,'Sdm',NULL,NULL,NULL,NULL,1,205.871875,22.09572,0,NULL,58790409971,918600155,14353127,17.32),(112726,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112726,35.11,NULL,105,48842,NULL,NULL,'Dipole + Quadrupole','FGC 1660',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112727,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112727,35.11,NULL,105,48842,NULL,NULL,'Dipole','FGC 1660',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112728,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112728,35.15,NULL,107,48842,NULL,NULL,NULL,'FGC 1660',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112729,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112729,37.02,0.46,254,48843,70,NULL,NULL,'2MASX J13432928+0011403',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000059,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,205.872125,0.19458,0.009,NULL,58391973924,912374592,14255853,17.7),(112730,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112730,37.43,0.46,307,48844,70,NULL,NULL,'2MASX J13432974+5339390',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,205.874,53.66089,0,NULL,57292300772,895192199,13987378,18.2),(112731,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112731,36.11,0.46,166,48845,70,NULL,NULL,'2MASX J13433035+6255123',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00012,NULL,'16.1g',0.22,'S0^-',NULL,NULL,NULL,NULL,1,205.876583,62.91989,0.041,NULL,57344696733,896010886,14000170,16.1),(112732,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112732,37.28,0.46,285,48846,70,NULL,NULL,'2MASX J13433099+4201223',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000174,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,205.879125,42.02283,0,NULL,59269712044,926089250,14470144,16.9),(112733,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112733,37.28,0.13,285,48847,70,NULL,NULL,'2MASX J13433132+5533494',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000172,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,205.880583,55.56375,0,NULL,57290449728,895163277,13986926,17.1),(112734,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112734,37.15,0.46,269,48848,70,NULL,NULL,'2MASX J13433204+2412298',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,205.8835,24.20844,0,NULL,58653340573,916458446,14319663,17.1),(112735,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112735,35.52,0.25,127,48849,74.4,NULL,NULL,'ESO 325- G 004',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000028,NULL,'13.86',1,'SA(r)0-:;D/cD',NULL,NULL,NULL,NULL,1,205.888333333,-38.176,0.189,NULL,46884420605,732569071,11446391,13.86),(112736,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112736,35.55,0.47,129,48849,70,NULL,NULL,'ESO 325- G 004',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112737,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112737,35.78,0.45,143,48849,NULL,NULL,'K','ESO 325- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112738,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112738,36.02,0.4,160,48849,NULL,NULL,'mean','ESO 325- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112739,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112739,38.79,0.46,573,48850,70,NULL,NULL,'2MASX J13433343+3640486',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,205.889416667,36.68017,0,NULL,59147603179,924181299,14440332,17.9),(112740,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112740,37.95,0.46,388,48851,70,NULL,NULL,'2MASX J13433346+1135477',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000147,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,205.8895,11.59656,0.015,NULL,58455340801,913364700,14271323,17.2),(112741,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112741,35.64,0.52,134,48852,70,NULL,NULL,'2MASX J13433361-4326109',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,205.89,-43.43636,0.369,NULL,46965278408,733832475,11466132,14.2),(112742,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112742,35.02,0.46,101,48853,70,NULL,NULL,'2MASX J13433426-1317413',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00014,NULL,'15.36',NULL,NULL,NULL,NULL,NULL,NULL,1,205.892958333,-13.295,0.129,NULL,43657714853,682151794,10658621,15.36),(112743,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112743,36.65,0.46,213,48854,70,NULL,NULL,'2MASX J13433504+0908347',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000189,NULL,'15.8g',0.47,NULL,NULL,NULL,NULL,NULL,1,205.895875,9.14311,0,NULL,58421007644,912828244,14262941,15.8),(112744,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112744,35.17,0.46,108,48855,70,NULL,NULL,'LSBC F577-01',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000073,NULL,'14.9',0.9,'Ep',NULL,NULL,NULL,NULL,1,205.896125,18.05658,0,NULL,58376474318,912132411,14252068,14.9),(112745,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112745,27.8,NULL,3.63,48856,NULL,NULL,NULL,'LEDA 166172',NULL,'2002A&A...385...21K',2002,1,0.6,NULL,'G',NULL,NULL,'18.5',0.3,'dwarf Sph?',NULL,NULL,NULL,NULL,1,205.9,-43.76972,0.369,NULL,46965348995,733833578,11466149,18.5),(112746,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112746,27.88,0.11,3.77,48856,NULL,NULL,NULL,'LEDA 166172',NULL,'2015ApJ...802L..25T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112747,'SNIa','2016-12-15 15:15:17','2016-12-16 11:20:30','1','SN 1998ba','R',112747,41.43,NULL,1350,48857,65,NULL,'SALT','H-ZSNS J134336.92+021930.6',0.43,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,205.903833333,2.32517,0.008,NULL,58390049129,912344517,14255383,NULL),(112748,'SNIa','2016-12-15 15:15:17','2016-12-16 11:20:30','1','SN 1998ba',NULL,112748,41.47,0.15,1380,48857,74.2,NULL,'SALT 2','H-ZSNS J134336.92+021930.6',0.43,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112749,'SNIa','2016-12-15 15:15:17','2016-12-16 11:20:30','1','SN 1998ba',NULL,112749,42.2,0.14,1930,48857,70,NULL,'SALT','H-ZSNS J134336.92+021930.6',0.43,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112750,'SNIa','2016-12-15 15:15:17','2016-12-16 11:20:30','1','SN 1998ba',NULL,112750,42.36,0.25,2070,48857,65,NULL,NULL,'H-ZSNS J134336.92+021930.6',0.43,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112751,'SNIa','2016-12-15 15:15:17','2016-12-16 11:20:30','1','SN 1998ba',NULL,112751,42.36,0.12,2080,48857,65,NULL,'SALT','H-ZSNS J134336.92+021930.6',0.43,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112752,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112752,38.27,0.46,451,48858,70,NULL,NULL,'SDSS J134337.30+102706.6',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'18.0g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,205.905458333,10.45183,0.04,NULL,58453436490,913334945,14270858,18),(112753,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112753,36.47,0.21,196,48859,70,NULL,NULL,'2MASX J13433741+3004023',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000107,NULL,'16.0g',0.36,NULL,NULL,NULL,NULL,NULL,1,205.9060417,30.06736,0,NULL,59136405708,924006339,14437599,16),(112754,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112754,36.44,0.46,194,48860,70,NULL,NULL,'2MASX J13433802+2946518',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00009,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,205.908583333,29.781,0,NULL,59136377818,924005903,14437592,16.3),(112755,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112755,37.29,0.46,287,48861,70,NULL,NULL,'2MASX J13433828+5711244',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000173,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,205.9097917,57.19028,0,NULL,57298021945,895281592,13988774,16.8),(112756,'IRAS','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112756,33.76,0.8,56.5,48862,75,NULL,'MAT, I','ESO 383- G 067',NULL,'1997ApJS..109..333W',1997,1,1.76,NULL,'G',0.000027,NULL,'15.51',0.22,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,205.9110417,-32.91792,0.177,NULL,46908334220,732942722,11452230,15.51),(112757,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112757,33.13,0.43,42.3,48862,75,NULL,'3.6 micron, color + selection bias corrected','ESO 383- G 067',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112758,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112758,33.2,0.49,43.6,48862,75,NULL,'IR','ESO 383- G 067',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112759,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112759,33.27,0.32,45,48862,85,NULL,'I, inv','ESO 383- G 067',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112760,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112760,33.27,0.32,45.1,48862,85,NULL,'I, raw','ESO 383- G 067',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112761,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112761,33.32,0.43,46.1,48862,75,NULL,'3.6 micron, color corrected','ESO 383- G 067',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112762,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112762,33.41,0.43,48.1,48862,75,NULL,'MAT, I, raw','ESO 383- G 067',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112763,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112763,33.45,0.2,49,48862,74.4,NULL,NULL,'ESO 383- G 067',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112764,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112764,33.45,0.43,49.1,48862,75,NULL,'MAT, I, inv','ESO 383- G 067',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112765,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112765,33.63,NULL,53.2,48862,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 383- G 067',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112766,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112766,33.63,NULL,53.2,48862,NULL,NULL,NULL,'ESO 383- G 067',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112767,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112767,33.64,0.43,53.5,48862,75,NULL,'MAT, I, cor','ESO 383- G 067',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112768,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112768,33.66,NULL,53.8,48862,NULL,NULL,'Dipole + Quadrupole','ESO 383- G 067',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112769,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112769,33.67,NULL,54.3,48862,NULL,NULL,'Dipole','ESO 383- G 067',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112770,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112770,34.2,0.13,69.3,48862,NULL,NULL,NULL,'ESO 383- G 067',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112771,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112771,36.6,NULL,209,48863,NULL,NULL,NULL,'FGC 1661',NULL,'2000BSAO...50....5K',2000,1,1.32,NULL,'G',0.000177,NULL,'16.8g',0.13,'Sd',NULL,NULL,NULL,NULL,1,205.9215,54.95225,0,NULL,57290655079,895166485,13986976,16.8),(112772,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112772,36.75,0.46,224,48864,70,NULL,NULL,'2MASX J13434129+6531483',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000071,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,205.9220417,65.53008,0.049,NULL,57880578449,904384038,14131000,17.3),(112773,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112773,36.63,0.46,212,48865,70,NULL,NULL,'2MASX J13434138+4349533',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000176,NULL,'15.8g',0.4,'E0',NULL,NULL,NULL,NULL,1,205.922625,43.8315,0,NULL,59318318473,926848726,14482011,15.8),(112774,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112774,37.62,0.1,334,48866,70,NULL,NULL,'2MASX J13434227+2615468',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,205.926125,26.26308,0,NULL,59126991559,923859243,14435300,17.2),(112775,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112775,36.69,0.46,218,48867,70,NULL,NULL,'SDSS J134342.32+161832.2',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.2g',0.34,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,205.926375,16.30897,0.01,NULL,58346730676,911667666,14244807,16.2),(112776,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112776,35.16,0.46,108,48868,70,NULL,NULL,'IC 4322',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000187,NULL,'14.9g',0.8,'EL','Isolated elliptical galaxy',NULL,NULL,NULL,1,205.9339583,25.39214,0,NULL,59123635707,923806807,14434481,14.9),(112777,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112777,36.26,0.46,179,48869,70,NULL,NULL,'2MASX J13434430+6032563',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,205.9345417,60.54897,0.009,NULL,57261939763,894717808,13979965,16.6),(112778,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112778,37.28,0.13,285,48870,70,NULL,NULL,'IC 0929',NULL,'2015arXiv151105856S',2015,1,0.52,'Identification as IC 0929 is not certain.','G',0.000187,NULL,'15.8g',0.47,'E0',NULL,NULL,NULL,NULL,1,205.937583333,55.63378,0,NULL,57288501930,895132842,13986450,15.8),(112779,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112779,37.17,0.33,272,48871,70,NULL,NULL,'2MASX J13434550+5602134',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,205.939583,56.03717,0,NULL,57288935820,895139622,13986556,17.3),(112780,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112780,37.59,0.46,329,48872,70,NULL,NULL,'2MASX J13434638+1131366',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000182,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,205.94325,11.52694,0,NULL,58455335424,913364616,14271322,16.7),(112781,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112781,37.59,0.46,329,48873,70,NULL,NULL,'2MASX J13434645+6409543',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000074,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,205.943833333,64.16519,0.041,NULL,57868123699,904189432,14127959,17.4),(112782,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112782,37.65,0.33,338,48874,70,NULL,NULL,'SDSS J134346.97+133313.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.8g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,205.94575,13.55378,0,NULL,58337553509,911524273,14242566,17.8),(112783,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112783,37.28,0.13,285,48875,70,NULL,NULL,'IC 0928',NULL,'2015arXiv151105856S',2015,1,0.31,'Identification as IC 0928 is not certain.','G',0.000179,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,205.95,55.56786,0,NULL,57290399518,895162492,13986913,17.2),(112784,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112784,37.63,0.46,336,48876,70,NULL,NULL,'SDSS J134348.26+112009.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,205.951083,11.33606,0,NULL,58455298061,913364032,14271313,17.9),(112785,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112785,37.16,0.46,270,48877,70,NULL,NULL,'2MASX J13434890+0820326',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.27',0.19,NULL,NULL,NULL,NULL,NULL,1,205.953667,8.34244,0,NULL,58432226073,913003532,14265680,17.27),(112786,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112786,34.24,0.49,70.3,48878,75,NULL,'IR','ESO 445- G 020',NULL,'2011yCatp016004901K',2011,1,1.96,NULL,'G',0.000023,NULL,'15.83',0.2,'Scd',NULL,NULL,NULL,NULL,1,205.954416667,-29.74436,0.193,NULL,46855029166,732109830,11439216,15.83),(112787,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112787,35.69,0.7,137,48879,70,NULL,NULL,'2MASX J13434918-1949278',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'15.82',0.3,'cE1: pec',NULL,NULL,NULL,NULL,1,205.955167,-19.82439,0.273,NULL,43630963984,681733812,10652090,15.82),(112788,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112788,37.65,0.33,338,48880,70,NULL,NULL,'2MASXi J1343497+133459',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'17.7g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,205.957208333,13.58319,0,NULL,58337550715,911524229,14242566,17.7),(112789,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112789,37.27,0.46,284,48881,70,NULL,NULL,'2MASX J13434991+2011085',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,205.9580417,20.18572,0.009,NULL,58324298833,911317169,14239330,17.2),(112790,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112790,36.48,0.53,198,48882,70,NULL,NULL,'2MASX J13435039-1953038',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.55',NULL,NULL,NULL,NULL,NULL,NULL,1,205.9599583,-19.88442,0.273,NULL,43630964885,681733826,10652091,15.55),(112791,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112791,37.06,0.46,259,48883,70,NULL,NULL,'2MASX J13435185+2927214',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000113,NULL,'16.2g',0.32,'E',NULL,NULL,NULL,NULL,1,205.9662083,29.45603,0,NULL,59136212848,924003325,14437551,16.2),(112792,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112792,36.91,0.46,241,48884,70,NULL,NULL,'2MASX J13435247+3645467',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000178,NULL,'16.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,205.9687917,36.76297,0,NULL,59147768020,924183875,14440373,16.8),(112793,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112793,37.38,0.46,299,48885,70,NULL,NULL,'2MASX J13435261+1544137',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.28',0.15,NULL,NULL,NULL,NULL,NULL,1,205.969375,15.73697,0,NULL,58346051370,911657052,14244641,18.28),(112794,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112794,37.89,0.33,378,48886,70,NULL,NULL,'2MASX J13435328+6351244',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00008,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,205.971917,63.85681,0.025,NULL,57865325236,904145706,14127276,18),(112795,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112795,37.93,0.46,385,48887,70,NULL,NULL,'2MASX J13435403+5115195',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000148,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,205.975375,51.25553,0,NULL,59222684650,925354447,14458663,17.6),(112796,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112796,37.23,0.13,279,48888,70,NULL,NULL,'2MASX J13435539+2955254',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000152,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,205.980833,29.92383,0,NULL,59136383242,924005988,14437593,17),(112797,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112797,36.87,0.63,237,48889,70,NULL,NULL,'LCRS B134118.9-053631',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'17.14',0.46,NULL,NULL,NULL,NULL,NULL,1,205.981166667,-5.85939,0.069,NULL,43613645708,681463214,10647862,17.14),(112798,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112798,37.33,0.46,292,48890,70,NULL,NULL,'2MASX J13435640+5104465',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000173,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,205.985125,51.0795,0,NULL,59222725602,925355087,14458673,17.2),(112799,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112799,37.63,0.46,336,48891,70,NULL,NULL,'2MASX J13435690+1843295',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,205.9872083,18.72494,0,NULL,58322827660,911294182,14238971,17.7),(112800,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112800,37.23,0.13,279,48892,70,NULL,NULL,'2MASX J13435741+2938564',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000087,NULL,'16.8g',0.3,'E',NULL,NULL,NULL,NULL,1,205.989,29.649,0,NULL,59136193595,924003024,14437547,16.8),(112801,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112801,36.62,0.46,211,48893,70,NULL,NULL,'2MASX J13435798+0544098',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,205.991583333,5.73617,0.008,NULL,58441537444,913149022,14267953,17),(112802,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112802,38.01,0.46,400,48894,70,NULL,NULL,'LCRS B134123.8-023700',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,205.9952917,-2.86725,0.077,NULL,43609283110,681395048,10646797,17),(112803,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112803,34.85,0.61,93.5,48895,70,NULL,NULL,'2MASX J13435961-2000508',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,205.998417,-20.01414,0.273,NULL,43630841090,681731892,10652060,14.6),(112804,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112804,35.28,0.25,114,48896,74.4,NULL,NULL,'2MASX J13440027-3817106',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000011,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,206.0012083,-38.28622,0.185,NULL,46884239870,732566247,11446347,16.5),(112805,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112805,35.57,0.66,130,48896,70,NULL,NULL,'2MASX J13440027-3817106',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112806,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112806,37.21,0.46,276,48897,70,NULL,NULL,'SDSS J134400.79+262200.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000137,NULL,'18.0g',0.17,NULL,'Group member',NULL,NULL,NULL,1,206.003333,26.36681,0,NULL,59126996944,923859327,14435301,18),(112807,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112807,37.42,0.46,304,48898,70,NULL,NULL,'2MASX J13440138+4111373',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'15.96',0.45,NULL,NULL,NULL,NULL,NULL,1,206.005583,41.19383,0.035,NULL,59267779107,926059048,14469672,15.96),(112808,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112808,37.77,0.46,359,48899,70,NULL,NULL,'SDSS J134401.51+120634.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000926,NULL,'17.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,206.006333,12.10967,0,NULL,58335959083,911499360,14242177,17.9),(112809,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112809,37.29,0.21,287,48900,70,NULL,NULL,'2MASX J13440197+0208328',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000067,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,206.0082083,2.14239,0.008,NULL,58390914637,912358041,14255594,17.1),(112810,'Brightest Stars','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112810,34.89,NULL,95.1,48901,NULL,NULL,NULL,'IC 4320',NULL,'2015MNRAS.450..787S',2015,1,1,NULL,'G',0.00003,NULL,'14.21',1,'S0?','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,206.0155,-27.23169,0.241,NULL,46845196702,731956198,11436815,14.21),(112811,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112811,35.05,0.4,102,48901,NULL,NULL,'mean','IC 4320',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112812,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112812,35.67,0.45,136,48901,NULL,NULL,'K','IC 4320',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112813,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112813,37.23,0.13,279,48902,70,NULL,NULL,'2MASX J13440537+2954025',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000123,NULL,'16.0g',0.36,NULL,NULL,NULL,NULL,NULL,1,206.0224583,29.90094,0,NULL,59136109786,924001715,14437526,16),(112814,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112814,36.13,0.46,168,48903,70,NULL,NULL,'2MASX J13440839+4520283',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000185,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,206.034958333,45.34131,0,NULL,59316191343,926815489,14481492,16.2),(112815,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112815,35.8,0.25,145,48904,70,NULL,NULL,'GIN 316',NULL,'2001MNRAS.321..277C',2001,1,0.54,NULL,'G',0.000057,NULL,'15.8g',0.44,'E/S0',NULL,NULL,NULL,NULL,1,206.048333,29.58328,0,NULL,59136188847,924002950,14437546,15.8),(112816,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112816,36.26,0.25,179,48904,74.4,NULL,NULL,'GIN 316',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112817,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112817,36.62,0.46,211,48904,70,NULL,NULL,'GIN 316',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112818,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112818,35.98,0.46,157,48905,70,NULL,NULL,'2MASX J13441383+4647364',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000164,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,206.0575417,46.79331,0.031,NULL,59282640438,926291256,14473300,16.5),(112819,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112819,35.8,0.25,145,48906,70,NULL,NULL,'GIN 313',NULL,'2001MNRAS.321..277C',2001,1,0.53,NULL,'G',0.000093,NULL,'15.6g',0.46,'E/S0',NULL,NULL,NULL,NULL,1,206.058833333,29.80411,0,NULL,59136104590,924001634,14437525,15.6),(112820,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112820,36.24,0.25,177,48906,74.4,NULL,NULL,'GIN 313',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112821,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112821,37.23,0.13,279,48906,70,NULL,NULL,'GIN 313',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112822,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112822,37.32,0.23,291,48907,70,NULL,NULL,'2MASX J13441412+2559275',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000185,NULL,'17.5g',0.18,NULL,'Group member',NULL,NULL,NULL,1,206.058875,25.99108,0,NULL,59126410737,923850167,14435158,17.5),(112823,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112823,37.23,0.19,280,48908,70,NULL,NULL,'2MASX J13441437+0250522',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000065,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,206.059916667,2.84775,0.05,NULL,58445580620,913212197,14268940,17.7),(112824,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112824,37.19,0.46,275,48909,70,NULL,NULL,'2MASX J13441479+2619035',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000164,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,206.061583,26.31758,0,NULL,59127063859,923860372,14435318,17.1),(112825,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112825,34.95,0.46,97.5,48910,70,NULL,NULL,'SDSS J134414.85+135217.2',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000171,NULL,'15.3g',0.52,NULL,NULL,NULL,NULL,NULL,1,206.061916667,13.87147,0,NULL,58348338148,911692783,14245199,15.3),(112826,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112826,38.46,0.46,491,48911,70,NULL,NULL,'2MASX J13441576+0659275',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.54',0.17,NULL,NULL,NULL,NULL,NULL,1,206.06575,6.99092,0.058,NULL,58431889968,912998280,14265598,18.54),(112827,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112827,37.23,0.19,280,48912,70,NULL,NULL,'2MASX J13441584+0258382',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000081,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,206.066125,2.97736,0.05,NULL,58445576694,913212135,14268939,16.7),(112828,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112828,36.42,0.76,192,48913,70,NULL,NULL,'2MASX J13441654-1715576',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.47',0.3,NULL,NULL,NULL,NULL,NULL,1,206.0689583,-17.26603,0.345,NULL,43659429079,682178579,10659040,16.47),(112829,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112829,37.29,0.21,287,48914,70,NULL,NULL,'SDSS J134416.68+020105.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00007,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,206.0695,2.01817,0.045,NULL,58390996476,912359319,14255614,17.8),(112830,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112830,38.32,0.19,462,48915,70,NULL,NULL,'SDSS J134417.76+113839.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00015,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,206.0740417,11.64419,0,NULL,58455477171,913366830,14271356,18.7),(112831,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112831,36.36,0.46,187,48916,70,NULL,NULL,'2MASX J13441871+4123275',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000174,NULL,'16.1g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,206.077958333,41.39081,0,NULL,59267764650,926058822,14469669,16.1),(112832,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112832,37.6,0.33,331,48917,70,NULL,NULL,'SDSS J134418.75+024130.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000065,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,206.078125,2.69186,0.05,NULL,58445549239,913211706,14268932,18),(112833,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112833,35.87,0.5,149,48918,70,NULL,NULL,'2MASX J13441880-3911205',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000036,NULL,'13.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,206.07825,-39.18911,0.185,NULL,46916793259,733074894,11454295,13.7),(112834,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112834,37.9,0.46,380,48919,70,NULL,NULL,'2MASX J13441875+6624372',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000089,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,206.078291667,66.41028,0.033,NULL,57880852997,904388328,14131067,17.4),(112835,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112835,38.32,0.19,462,48920,70,NULL,NULL,'SDSS J134418.90+114148.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00018,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,206.07875,11.69669,0,NULL,58455449491,913366398,14271349,17.9),(112836,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112836,37.93,0.46,385,48921,70,NULL,NULL,'2MASX J13441947+5713312',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000157,NULL,'16.5g',0.36,'BrClG',NULL,NULL,NULL,NULL,1,206.0810417,57.22533,0,NULL,57298054356,895282099,13988782,16.5),(112837,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112837,36.53,0.58,202,48922,70,NULL,NULL,'2MASX J13441951-1105583',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,206.081375,-11.09961,0.133,NULL,43691847264,682685113,10666954,16.2),(112838,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112838,38.32,0.19,462,48923,70,NULL,NULL,'2MASX J13442117+1149186',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,206.088167,11.82189,0,NULL,58455267851,913363560,14271305,18),(112839,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112839,37.29,0.21,287,48924,70,NULL,NULL,'2MASX J13442136+0208082',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000079,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,206.089125,2.13575,0,NULL,58390951666,912358619,14255603,17.7),(112840,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112840,36.44,0.46,194,48925,70,NULL,NULL,'2MASX J13442220+3515332',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000174,NULL,'16.1g',0.41,NULL,NULL,NULL,NULL,NULL,1,206.092666667,35.25936,0,NULL,59176291653,924629557,14447336,16.1),(112841,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112841,37.53,0.46,320,48926,70,NULL,NULL,'2MASX J13442273+4726104',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000146,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,206.094875,47.43642,0,NULL,59282608532,926290758,14473293,18),(112842,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112842,37.29,0.21,287,48927,70,NULL,NULL,'2MASX J13442303+0205372',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00009,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,206.096125,2.09361,0,NULL,58390948730,912358573,14255602,16.9),(112843,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112843,38.32,0.19,462,48928,70,NULL,NULL,'2MASX J13442322+1138566',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.000197,NULL,'15.9g',0.41,'BrClG',NULL,NULL,NULL,NULL,1,206.09675,11.64908,0,NULL,58455446648,913366353,14271349,15.9),(112844,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112844,37.95,0.13,388,48929,70,NULL,NULL,'2MASX J13442342-0002369',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000077,NULL,'17.7g',0.22,'Sb-Sc',NULL,NULL,NULL,NULL,1,206.097791667,-0.04356,0.041,NULL,43563693717,680682714,10635667,17.7),(112845,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112845,38.32,0.19,462,48930,70,NULL,NULL,'2MASX J13442397+1134596',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000186,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,206.1,11.58339,0,NULL,58455483877,913366935,14271358,17.7),(112846,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112846,35.92,0.46,152,48931,70,NULL,NULL,'2MASX J13442407+5845392',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000165,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,206.100125,58.76092,0,NULL,57269024831,894828512,13981695,16.5),(112847,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112847,35.63,0.49,134,48932,75,NULL,'IR','UGC 08691 NED01',NULL,'2011yCatp016004901K',2011,1,NULL,NULL,'G',0.000203,NULL,'15.0',NULL,'AGN',NULL,NULL,NULL,NULL,1,206.102208333,20.40958,0.009,NULL,58323988869,911312326,14239255,15),(112848,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112848,35.87,0.2,149,48933,74.4,NULL,NULL,'CGCG 073-068',NULL,'2013AJ....146...86T',2013,1,0.68,NULL,'G',0.000178,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,206.102917,13.17536,0,NULL,58335792667,911496760,14242136,16.2),(112849,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112849,34.8,0.46,91.4,48934,70,NULL,NULL,'MRK 1358',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000175,NULL,'15.3g',0.5,'E0',NULL,NULL,NULL,NULL,1,206.103667,5.12533,0.011,NULL,58441981582,913155962,14268061,15.3),(112850,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112850,35.36,0.27,118,48935,70,NULL,NULL,'CGCG 131-032',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000193,NULL,'15.2',0.28,'AGN',NULL,NULL,NULL,NULL,1,206.104083,20.37303,0.009,NULL,58323988309,911312317,14239254,15.2),(112851,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112851,37.29,0.21,287,48936,70,NULL,NULL,'NGC 5285',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.00011,NULL,'14.9g',0.7,'E+ pec;BrClG',NULL,NULL,NULL,NULL,1,206.107458333,2.10992,0,NULL,58390949092,912358579,14255602,14.9),(112852,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112852,37.82,0.46,367,48937,70,NULL,NULL,'SDSS J134425.79+163105.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,206.1075,16.51833,0,NULL,58346254430,911660225,14244691,18),(112853,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112853,35.74,0.52,141,48938,70,NULL,NULL,'2MASX J13442647-4350454',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,206.110291667,-43.84589,0.373,NULL,46965408820,733834512,11466164,14.7),(112854,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112854,37.54,0.33,322,48939,70,NULL,NULL,'2MASX J13442660+1047016',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00017,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,206.110625,10.78383,0,NULL,58455584954,913368514,14271383,17.7),(112855,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112855,38.46,0.46,492,48940,70,NULL,NULL,'SDSS J134427.98+321031.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,206.116625,32.17542,0,NULL,59184378952,924755921,14449311,18.7),(112856,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112856,33,0.43,39.8,48941,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08693',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.00003,NULL,'14.53',0.4,'S?             HII',NULL,NULL,NULL,NULL,1,206.118333,35.19233,0,NULL,59175501857,924617216,14447144,14.53),(112857,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112857,33.13,0.43,42.3,48941,75,NULL,'3.6 micron, color corrected','UGC 08693',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112858,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112858,33.28,0.2,45.3,48941,74.4,NULL,NULL,'UGC 08693',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112859,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112859,37.89,0.33,378,48942,70,NULL,NULL,'2MASX J13442912+6350052',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00009,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,206.121583,63.83483,0.025,NULL,57865316352,904145568,14127274,17.6),(112860,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112860,38.27,0.46,452,48943,70,NULL,NULL,'SDSS J134429.34-005038.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000088,NULL,'18.3g',0.15,'NLAGN',NULL,NULL,NULL,NULL,1,206.1222917,-0.84417,0.045,NULL,43565320934,680708139,10636064,18.3),(112861,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112861,37.47,0.46,312,48944,70,NULL,NULL,'2MASX J13443064+1714158',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.39',0.13,NULL,NULL,NULL,NULL,NULL,1,206.1277083,17.23758,0,NULL,58343374000,911615218,14243987,18.39),(112862,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112862,34.7,0.59,86.9,48945,70,NULL,NULL,'ESO 509- G 103',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.87',1,'S0',NULL,NULL,NULL,NULL,1,206.129,-24.34439,0.221,NULL,43285466043,676335406,10567740,14.87),(112863,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112863,35.36,0.27,118,48946,70,NULL,NULL,'MRK 1359',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.00017,NULL,'15.4',0.2,NULL,NULL,NULL,NULL,NULL,1,206.1299583,20.21089,0.009,NULL,58324875835,911326184,14239471,15.4),(112864,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112864,37.18,0.46,273,48947,70,NULL,NULL,'2MASX J13443132+5752092',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,206.130375,57.86928,0,NULL,57294767847,895230747,13987980,17.7),(112865,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112865,37.6,0.33,331,48948,70,NULL,NULL,'SDSS J134431.45+023742.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000066,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,206.1310417,2.62844,0.022,NULL,58445628112,913212939,14268952,18),(112866,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112866,37.23,0.19,280,48949,70,NULL,NULL,'2MASX J13443253+0257142',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000098,NULL,'16.0g',0.39,'BrClG',NULL,NULL,NULL,NULL,1,206.135625,2.95408,0.027,NULL,58445564824,913211950,14268936,16),(112867,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112867,38.4,0.46,478,48950,70,NULL,NULL,'2MASX J13443431+6043153',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,206.14325,60.72106,0.009,NULL,57261854424,894716475,13979944,17.8),(112868,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112868,35.71,0.46,139,48951,70,NULL,NULL,'2MASX J13443458+2347476',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.00',0.25,NULL,NULL,NULL,NULL,NULL,1,206.14425,23.79661,0,NULL,58787577665,918555901,14352435,17),(112869,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112869,37.89,0.46,379,48952,70,NULL,NULL,'2MASX J13443500+4626104',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,206.145916667,46.43625,0,NULL,59283340062,926302188,14473471,17.7),(112870,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112870,37.35,0.46,295,48953,70,NULL,NULL,'2MASX J13443578+1627458',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.47',0.13,NULL,NULL,NULL,NULL,NULL,1,206.149125,16.46269,0,NULL,58346302111,911660970,14244702,18.47),(112871,'SNIa','2016-12-15 15:15:17','2016-12-16 11:20:30','1','SN 1997bh',NULL,112871,41.76,0.23,1610,48954,65,NULL,NULL,'H-ZSNS J134435.97-001949.3',0.4,'2004ApJ...607..665R',2004,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,206.149875,-0.33036,0.041,NULL,43563813915,680684592,10635696,NULL),(112872,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112872,38.56,0.46,515,48955,70,NULL,NULL,'SDSS J134436.86+051323.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000142,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,206.153625,5.22325,0.012,NULL,58441927672,913155119,14268048,18.6),(112873,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112873,35.09,0.46,104,48956,70,NULL,NULL,'CGCG 190-046',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000127,NULL,'15.3g',0.51,'E','Pair member (points to parent)',NULL,NULL,NULL,1,206.154333,37.17164,0,NULL,59147720222,924183128,14440361,15.3),(112874,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112874,36.29,0.33,181,48957,70,NULL,NULL,'2MASX J13443714+3116222',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000179,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,206.154875,31.27278,0,NULL,59183855827,924747747,14449183,16.1),(112875,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112875,38.24,0.46,445,48958,70,NULL,NULL,'2MASX J13443720+6015273',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000176,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,206.154917,60.25756,0.009,NULL,57275541991,894930343,13983286,17.2),(112876,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112876,35.9,0.65,152,48959,70,NULL,NULL,'2MASX J13443745-1831054',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.94',NULL,NULL,NULL,NULL,NULL,NULL,1,206.1560417,-18.51836,0.289,NULL,43630173242,681721456,10651897,15.94),(112877,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112877,37.23,0.13,279,48960,70,NULL,NULL,'2MASX J13443759+2956066',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00017,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,206.156667,29.93533,0,NULL,59136146651,924002291,14437535,16.5),(112878,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112878,36.64,0.46,213,48961,70,NULL,NULL,'2MASX J13443823+2105335',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000103,NULL,'15.70',0.22,NULL,NULL,NULL,NULL,NULL,1,206.159291667,21.09272,0.021,NULL,58318656018,911229000,14237953,15.7),(112879,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112879,37.95,0.13,388,48962,70,NULL,NULL,'2MASX J13443912+0002251',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000077,NULL,'17.5g',0.18,'Sa-Sb',NULL,NULL,NULL,NULL,1,206.163125,0.04028,0.041,NULL,58391454229,912366472,14255726,17.5),(112880,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112880,37.54,0.33,322,48963,70,NULL,NULL,'2MASX J13443970+1052196',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,206.165417,10.87214,0,NULL,58455866259,913372910,14271451,17.4),(112881,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112881,37.56,0.46,325,48964,70,NULL,NULL,'2MASX J13444063+1704488',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.20',0.14,NULL,NULL,NULL,NULL,NULL,1,206.1692083,17.08044,0,NULL,58343421408,911615959,14243999,18.2),(112882,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112882,37.65,0.46,339,48965,70,NULL,NULL,'SDSS J134440.72+093521.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'18.1g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,206.169708333,9.58942,0.032,NULL,58421321078,912833141,14263017,18.1),(112883,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112883,37.05,0.46,257,48966,70,NULL,NULL,'B3 1342+407',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000103,NULL,'15.6g',0.5,'BrClG',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,206.1730417,40.46728,0,NULL,59268403326,926068801,14469825,15.6),(112884,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112884,36.18,0.52,172,48967,70,NULL,NULL,'2MASX J13444224-3806095',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.8I',0.4,NULL,NULL,NULL,NULL,NULL,1,206.176,-38.10264,0.185,NULL,46884221740,732565964,11446343,13.8),(112885,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112885,37.99,0.46,397,48968,70,NULL,NULL,'LCRS B134208.3-024028',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00015,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,206.1807917,-2.92481,0.057,NULL,43609459712,681397808,10646840,16.9),(112886,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112886,37.58,0.46,328,48969,70,NULL,NULL,'2MASX J13444381+1351348',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,206.182541667,13.85975,0,NULL,58348302285,911692223,14245190,17.2),(112887,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112887,37.95,0.13,388,48970,70,NULL,NULL,'2MASX J13444414+0006484',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000085,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,206.184,0.11361,0.013,NULL,58391459775,912366558,14255727,17.6),(112888,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112888,35.39,0.54,120,48971,70,NULL,NULL,'2MASX J13444442-1915206',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,206.1850417,-19.25569,0.285,NULL,43633045462,681766335,10652598,15.3),(112889,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112889,36.27,0.46,179,48972,70,NULL,NULL,'2MASX J13444528+3020592',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000159,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,206.1887083,30.34992,0,NULL,59129083825,923891934,14435811,16.6),(112890,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112890,38.32,0.19,462,48973,70,NULL,NULL,'2MASX J13444543+1143442',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,206.189333333,11.72886,0,NULL,58455261375,913363458,14271304,17.7),(112891,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112891,37.23,0.13,279,48974,70,NULL,NULL,'2MASX J13444554+2939297',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00015,NULL,'16.8g',0.33,'E',NULL,NULL,NULL,NULL,1,206.1897917,29.65811,0,NULL,59136278232,924004347,14437567,16.8),(112892,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112892,37.95,0.13,388,48975,70,NULL,NULL,'2MASX J13444561+0005324',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000098,NULL,'17.1g',0.24,'AGN',NULL,NULL,NULL,NULL,1,206.1900417,0.09222,0.041,NULL,58391454837,912366481,14255726,17.1),(112893,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112893,37.35,0.46,296,48976,70,NULL,NULL,'2MASX J13444799-0035209',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000087,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,206.200125,-0.589,0.033,NULL,43563751297,680683614,10635681,16.9),(112894,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112894,37.23,0.13,279,48977,70,NULL,NULL,'2MASX J13444884+2937447',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000153,NULL,'16.5g',0.31,'E',NULL,NULL,NULL,NULL,1,206.2035417,29.62911,0,NULL,59136276335,924004317,14437567,16.5),(112895,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112895,37.11,0.46,265,48978,70,NULL,NULL,'2MASX J13444936+0124355',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000085,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,206.2057083,1.40989,0.029,NULL,58392192314,912378004,14255906,16.7),(112896,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112896,37.59,0.46,330,48979,70,NULL,NULL,'2MASX J13445000+1829025',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.15',0.15,NULL,NULL,NULL,NULL,NULL,1,206.208416667,18.48397,0,NULL,58322798846,911293731,14238964,18.15),(112897,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112897,36.27,0.46,179,48980,70,NULL,NULL,'2MASX J13445068+2928547',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000097,NULL,'16.8g',0.28,'E',NULL,NULL,NULL,NULL,1,206.211125,29.48175,0,NULL,59136232036,924003625,14437556,16.8),(112898,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112898,36.51,0.63,200,48981,70,NULL,NULL,'2MASX J13445098-1941396',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,206.212375,-19.69442,0.293,NULL,43630875749,681732433,10652069,15.5),(112899,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112899,38.07,0.76,411,48982,70,NULL,NULL,'2MASX J13445105-3313447',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.9I',0.2,NULL,NULL,NULL,NULL,NULL,1,206.2127917,-33.22908,0.149,NULL,46907315557,732926805,11451981,14.9),(112900,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112900,34.71,0.46,87.4,48983,70,NULL,NULL,'CGCG 190-047',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.000133,NULL,'14.4g',0.62,NULL,NULL,NULL,NULL,NULL,1,206.21325,32.52603,0,NULL,59184274742,924754292,14449285,14.4),(112901,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112901,37.23,0.13,279,48984,70,NULL,NULL,'NGC 5287',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.00012,NULL,'15.6g',0.48,NULL,NULL,NULL,NULL,NULL,1,206.218917,29.77092,0,NULL,59136266776,924004168,14437565,15.6),(112902,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112902,37.7,0.33,346,48985,70,NULL,NULL,'2MASX J13445278+3807328',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000247,NULL,'15.9g',0.47,'D/cD',NULL,NULL,NULL,NULL,1,206.219833,38.12583,0,NULL,59144443212,924131925,14439561,15.9),(112903,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112903,35.3,0.58,115,48986,70,NULL,NULL,'ESO 577- G 034',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.13',1,'Sb?',NULL,NULL,NULL,NULL,1,206.223333,-19.36975,0.285,NULL,43633073201,681766768,10652605,15.13),(112904,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112904,37.23,0.13,279,48987,70,NULL,NULL,'2MASX J13445359+2935037',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000165,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,206.2234583,29.58436,0,NULL,59136241705,924003776,14437559,17.9),(112905,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112905,36.67,0.46,216,48988,70,NULL,NULL,'2MASX J13445373+1222228',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,206.2239583,12.37297,0,NULL,58336211803,911503309,14242239,17.5),(112906,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112906,36.29,0.33,181,48989,70,NULL,NULL,'CGCG 161-141',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.00015,NULL,'15.6g',0.56,NULL,NULL,NULL,NULL,NULL,1,206.22775,31.06583,0,NULL,59128341965,923880343,14435630,15.6),(112907,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112907,37.7,0.33,346,48990,70,NULL,NULL,'2MASX J13445642+3811058',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000163,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,206.23525,38.185,0,NULL,59144461773,924132215,14439565,18.1),(112908,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112908,36.85,0.46,234,48991,70,NULL,NULL,'2MASX J13445672-0108379',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000087,NULL,'16.4g',0.32,'S0',NULL,NULL,NULL,NULL,1,206.23625,-1.14381,0.045,NULL,43566140905,680720951,10636264,16.4),(112909,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112909,37.95,0.13,388,48992,70,NULL,NULL,'2MASX J13445767+0016005',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00008,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,206.240333,0.26675,0.021,NULL,58391521526,912367523,14255742,17.5),(112910,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112910,36.05,0.68,162,48993,70,NULL,NULL,'2MASX J13445787-2008456',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.25',0.4,NULL,NULL,NULL,NULL,NULL,1,206.241125,-20.14619,0.293,NULL,43631235922,681738061,10652157,16.25),(112911,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112911,36.72,0.66,221,48994,70,NULL,NULL,'ESO 383- G 072',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000143,NULL,'15.36',0.6,'(R\')SB(rs)bc',NULL,NULL,NULL,NULL,1,206.246417,-34.28272,0.137,NULL,46907949589,732936712,11452136,15.36),(112912,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112912,37.14,0.46,268,48995,70,NULL,NULL,'2MASX J13445951+6025194',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000175,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,206.247833333,60.42208,0.009,NULL,57261792203,894715503,13979929,16.3),(112913,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112913,37.89,0.33,379,48996,70,NULL,NULL,'2MASX J13450007+1135572',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,206.250167,11.59914,0,NULL,58455392108,913365501,14271335,17.7),(112914,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112914,27.61,0.1,3.33,48997,NULL,NULL,NULL,'ESO 325- G 011',NULL,'2012A&A...540A..49M',2012,1,2.7,NULL,'G',0.000007,NULL,'13.99',1.3,'IB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,206.252083,-41.86111,0.273,NULL,46921896113,733154626,11455541,13.99),(112915,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112915,27.66,NULL,3.4,48997,NULL,NULL,NULL,'ESO 325- G 011',NULL,'2002A&A...385...21K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112916,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112916,27.66,0.1,3.4,48997,74.4,NULL,NULL,'ESO 325- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112917,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112917,27.66,0.11,3.4,48997,NULL,NULL,NULL,'ESO 325- G 011',NULL,'2015ApJ...802L..25T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112918,'TRGB','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112918,27.72,0.07,3.5,48997,NULL,NULL,'I','ESO 325- G 011',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112919,'Tully est','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112919,28.62,0.8,5.3,48997,75,NULL,NULL,'ESO 325- G 011',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112920,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112920,37.54,0.33,322,48998,70,NULL,NULL,'2MASX J13450120+1801346',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.26',0.25,NULL,NULL,NULL,NULL,NULL,1,206.255,18.02644,0,NULL,58377178342,912143411,14252240,17.26),(112921,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112921,37.75,0.27,354,48999,70,NULL,NULL,'2MASX J13450320+2651172',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000196,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,206.2632083,26.85483,0,NULL,59126230822,923847356,14435114,17.4),(112922,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112922,35.42,0.21,121,49000,70,NULL,NULL,'2MASX J13450336+2303406',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.99',0.21,NULL,NULL,NULL,NULL,NULL,1,206.264041667,23.06136,0,NULL,58788132877,918564576,14352571,16.99),(112923,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112923,37.07,0.33,259,49001,70,NULL,NULL,'SDSS J134503.41+301027.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000149,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,206.264208333,30.17419,0,NULL,59128560952,923883764,14435683,18.3),(112924,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112924,37.86,0.46,372,49002,70,NULL,NULL,'2MASX J13450342+2621142',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000203,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,206.264417,26.35397,0,NULL,59127088167,923860752,14435324,17.6),(112925,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112925,37.54,0.33,322,49003,70,NULL,NULL,'SDSS J134503.79+180651.2',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,206.2657917,18.11422,0,NULL,58322190621,911284228,14238816,NULL),(112926,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112926,37.01,0.46,252,49004,70,NULL,NULL,'2MASX J13450386+4102118',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000166,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,206.266125,41.03678,0,NULL,59268529957,926070780,14469855,17),(112927,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112927,37.28,0.13,285,49005,70,NULL,NULL,'2MASX J13450434+5528486',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000181,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,206.268375,55.48031,0,NULL,57290975576,895171493,13987054,16.3),(112928,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112928,37.23,0.19,280,49006,70,NULL,NULL,'2MASX J13450569+0239187',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000081,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,206.27375,2.65533,0.022,NULL,58445734078,913214594,14268978,17.2),(112929,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112929,37.95,0.13,388,49007,70,NULL,NULL,'2MASX J13450581+0013557',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000083,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,206.274417,0.23203,0.021,NULL,58391520527,912367508,14255742,17.2),(112930,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112930,35.88,0.52,150,49008,70,NULL,NULL,'2MASX J13450717-4130075',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,206.279958333,-41.50211,0.273,NULL,46921836270,733153691,11455526,15.5),(112931,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112931,32.66,NULL,34,49009,72,NULL,NULL,'AGC 238769',NULL,'2014Ap.....57..457K',2014,1,NULL,NULL,'RadioS',0.000142,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,206.281667,6.51194,0,NULL,58431092966,912985827,14265403,NULL),(112932,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112932,36.81,0.63,230,49010,70,NULL,NULL,'2MASX J13450848-1004507',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,206.285417,-10.08072,0.109,NULL,43690910824,682670481,10666726,16.4),(112933,'IRAS','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112933,32.97,0.8,39.3,49011,75,NULL,'A82, H','NGC 5289',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000013,NULL,'14.0',0.6,'(R)SABab: sp','in a radial-velocity based grouping',NULL,NULL,NULL,1,206.2862917,41.50339,0,NULL,59269814770,926090855,14470169,14),(112934,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112934,32.76,0.47,35.6,49011,75,NULL,'A82, H, raw','NGC 5289',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112935,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112935,32.87,0.47,37.5,49011,75,NULL,'A82, H, inv','NGC 5289',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112936,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112936,32.89,0.4,37.9,49011,NULL,NULL,'mean','NGC 5289',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112937,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112937,32.95,0.4,39,49011,75,NULL,NULL,'NGC 5289',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112938,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112938,32.98,0.38,39.4,49011,NULL,NULL,NULL,'NGC 5289',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112939,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112939,33,0.47,39.7,49011,75,NULL,'A82, H, cor','NGC 5289',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112940,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112940,33.14,0.47,42.4,49011,NULL,NULL,'H','NGC 5289',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112941,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112941,33.15,0.46,42.7,49011,NULL,NULL,'J','NGC 5289',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112942,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112942,33.2,0.45,43.6,49011,NULL,NULL,'K','NGC 5289',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112943,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112943,33.33,0.2,46.3,49011,74.4,NULL,NULL,'NGC 5289',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112944,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112944,33.37,0.43,47.2,49011,75,NULL,'3.6 micron, color corrected','NGC 5289',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112945,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112945,33.52,0.43,50.5,49011,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5289',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112946,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112946,33.61,0.49,52.7,49011,75,NULL,'IR','NGC 5289',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112947,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112947,37.89,0.33,379,49012,70,NULL,NULL,'SDSS J134508.91+113329.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,206.287167,11.55811,0,NULL,58455386887,913365420,14271334,18),(112948,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112948,36.29,0.73,181,49013,70,NULL,NULL,'2MASX J13450923-1319181',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.02',NULL,NULL,NULL,NULL,NULL,NULL,1,206.288583,-13.32189,0.125,NULL,43656988852,682140450,10658444,16.02),(112949,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112949,37.28,0.13,285,49014,70,NULL,NULL,'2MASX J13451022+5534556',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,206.292667,55.58225,0,NULL,57290919137,895170611,13987040,17.3),(112950,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112950,37.75,0.27,354,49015,70,NULL,NULL,'2MASX J13451164+2654443',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,206.298458333,26.91239,0,NULL,59126235825,923847434,14435116,17.8),(112951,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112951,38.25,0.46,448,49016,70,NULL,NULL,'SDSS J134512.07+064454.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'19.02',0.13,NULL,NULL,NULL,NULL,NULL,1,206.300333,6.74833,0,NULL,58430920402,912983131,14265361,19.02),(112952,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112952,37.75,0.27,354,49017,70,NULL,NULL,'2MASX J13451239+2653053',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000195,NULL,'15.7g',0.42,NULL,'Field galaxy',NULL,NULL,NULL,1,206.301625,26.88469,0,NULL,59126238962,923847483,14435116,15.7),(112953,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112953,37.95,0.13,388,49018,70,NULL,NULL,'2MASX J13451248+0006287',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00009,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,206.3019583,0.10811,0.045,NULL,58391491761,912367058,14255735,17.9),(112954,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112954,35.61,0.49,132,49019,70,NULL,NULL,'2MASX J13451261-4759008',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,206.302583333,-47.98361,0.541,NULL,46820515616,731570556,11430789,15.7),(112955,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112955,37.87,0.46,374,49020,70,NULL,NULL,'2MASX J13451286+5802036',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000179,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,206.303417,58.03425,0,NULL,57294723273,895230051,13987969,17.5),(112956,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112956,38.5,0.46,501,49021,70,NULL,NULL,'2MASX J13451453+1543449',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,206.310583,15.72903,0.008,NULL,58346002925,911656295,14244629,17.7),(112957,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112957,37.95,0.13,388,49022,70,NULL,NULL,'2MASX J13451528+0015227',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00008,NULL,'17.1g',0.27,'E/S0           AGN',NULL,NULL,NULL,NULL,1,206.3137917,0.25625,0.021,NULL,58391525973,912367593,14255743,17.1),(112958,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112958,36.18,0.2,172,49023,74.4,NULL,NULL,'KUG 1342+235',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00005,NULL,'15.5',0.35,'Spiral',NULL,NULL,NULL,NULL,1,206.313833,23.31653,0,NULL,58787969412,918562022,14352531,15.5),(112959,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112959,37.95,0.13,388,49024,70,NULL,NULL,'2MASX J13451557-0008310',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000083,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,206.314917,-0.14189,0.041,NULL,43563856530,680685258,10635707,16.9),(112960,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112960,37.07,0.33,259,49025,70,NULL,NULL,'2MASX J13451654+3008095',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000177,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,206.318875,30.13614,0,NULL,59128605147,923884455,14435694,16.7),(112961,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112961,38.11,0.33,420,49026,70,NULL,NULL,'2MASX J13451684+2745253',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000169,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,206.320125,27.75708,0,NULL,59138165727,924033839,14438028,18.1),(112962,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112962,35.56,0.47,129,49027,70,NULL,NULL,'ESO 325- G 013',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.000019,NULL,'15.50',0.2,'Compact:',NULL,NULL,NULL,NULL,1,206.322375,-38.17322,0.177,NULL,46887653438,732619584,11447181,15.5),(112963,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112963,35.66,0.25,136,49027,74.4,NULL,NULL,'ESO 325- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112964,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112964,35.42,0.21,121,49028,70,NULL,NULL,'2MASX J13451740+2310396',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.62',0.25,NULL,NULL,NULL,NULL,NULL,1,206.322625,23.17781,0,NULL,58788011429,918562678,14352541,16.62),(112965,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112965,38,0.46,397,49029,70,NULL,NULL,'2MASX J13451810+1818226',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.88',0.17,NULL,NULL,NULL,NULL,NULL,1,206.3254583,18.30631,0,NULL,58322229222,911284831,14238825,17.88),(112966,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112966,36.58,0.46,207,49030,70,NULL,NULL,'2MASX J13451847+2524123',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000168,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,206.327125,25.40336,0,NULL,59123716527,923808070,14434501,16.4),(112967,'FP','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112967,37.7,0.46,347,49031,70,NULL,NULL,'SDSS J134518.91+634240.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000076,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,206.328833,63.71139,0.025,NULL,57865421100,904147204,14127300,18.3),(112968,'IRAS','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112968,33.01,0.8,40.1,49032,75,NULL,'A82, H','NGC 5290',NULL,'1997ApJS..109..333W',1997,1,3.09,NULL,'G',0.00002,NULL,'12.6g',0.84,'Sbc: sp','in a radial-velocity based grouping',NULL,NULL,NULL,1,206.329917,41.71258,0,NULL,59269946068,926092907,14470201,12.6),(112969,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112969,32.42,0.38,30.5,49032,NULL,NULL,NULL,'NGC 5290',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112970,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112970,32.53,0.47,32,49032,NULL,NULL,'H','NGC 5290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112971,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112971,32.53,0.46,32.1,49032,NULL,NULL,'J','NGC 5290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112972,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112972,32.56,0.45,32.5,49032,NULL,NULL,'K','NGC 5290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112973,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112973,32.58,0.47,32.8,49032,75,NULL,'A82, H, raw','NGC 5290',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112974,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112974,32.68,0.2,34.4,49032,74.4,NULL,NULL,'NGC 5290',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112975,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112975,32.7,0.43,34.7,49032,75,NULL,'3.6 micron, color corrected','NGC 5290',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112976,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112976,32.73,0.4,35.2,49032,75,NULL,NULL,'NGC 5290',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112977,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112977,32.77,0.47,35.8,49032,75,NULL,'A82, H, inv','NGC 5290',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112978,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112978,32.79,0.43,36.2,49032,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5290',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112979,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112979,32.86,0.47,37.3,49032,75,NULL,'A82, H, cor','NGC 5290',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112980,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112980,32.89,0.4,37.8,49032,75,NULL,'B','NGC 5290',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112981,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,'R',112981,32.94,0.49,38.6,49032,75,NULL,'IR','NGC 5290',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112982,'Tully-Fisher','2016-12-15 15:15:17','2016-12-16 11:20:30','1',NULL,NULL,112982,32.95,0.4,38.9,49032,NULL,NULL,'mean','NGC 5290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112983,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',112983,37.84,0.46,371,49033,70,NULL,NULL,'2MASX J13452033+0507197',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000183,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,206.3347083,5.12208,0.012,NULL,58450699110,913292173,14270190,17.3),(112984,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',112984,37.48,0.46,313,49034,70,NULL,NULL,'2MASX J13452098+2639353',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,206.337333333,26.65983,0,NULL,59126934049,923858344,14435286,16.7),(112985,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',112985,37.95,0.13,388,49035,70,NULL,NULL,'2MASX J13452176+0001439',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000085,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,206.340583333,0.029,0.045,NULL,58391413171,912365830,14255716,17.5),(112986,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,112986,34.24,0.48,70.6,49036,70,NULL,NULL,'MCG -05-32-074',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.000063,NULL,'14.39',0.2,'S0',NULL,NULL,NULL,NULL,1,206.3407083,-30.01769,0.225,NULL,46853103056,732079735,11438745,14.39),(112987,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,112987,34.32,0.25,73.1,49036,74.4,NULL,NULL,'MCG -05-32-074',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112988,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',112988,38.11,0.33,420,49037,70,NULL,NULL,'2MASX J13452295+2746343',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000155,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,206.3455,27.77617,0,NULL,59138135566,924033368,14438021,17.5),(112989,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',112989,37.85,0.46,371,49038,70,NULL,NULL,'2MASX J13452296-0055200',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000091,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,206.345666667,-0.92239,0.033,NULL,43566080177,680720002,10636250,17.3),(112990,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,112990,37.44,0.55,307,49039,70,NULL,NULL,'2MASX J13452306-1006120',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.04',NULL,NULL,NULL,NULL,NULL,NULL,1,206.346,-10.10353,0.109,NULL,43690902598,682670353,10666724,16.04),(112991,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',112991,37.69,0.33,345,49040,70,NULL,NULL,'2MASX J13452400+1628319',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,206.349958333,16.47569,0,NULL,58346420530,911662820,14244731,17.8),(112992,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,112992,34.55,0.47,81.3,49041,70,NULL,NULL,'IC 0920',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00012,NULL,'14.39',0.4,NULL,NULL,NULL,NULL,NULL,1,206.3527917,-12.57417,0.157,NULL,43657234452,682144288,10658504,14.39),(112993,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',112993,37.75,0.46,354,49042,70,NULL,NULL,'2MASX J13452522+1411459',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.47',0.14,NULL,NULL,NULL,NULL,NULL,1,206.354875,14.196,0,NULL,58350252880,911722701,14245667,18.47),(112994,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',112994,35.47,0.46,124,49043,70,NULL,NULL,'CGCG 045-091',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.000174,NULL,'15.1g',0.38,'Sa',NULL,NULL,NULL,NULL,1,206.355417,3.80664,0.014,NULL,58448329703,913255151,14269611,15.1),(112995,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',112995,38.28,0.46,454,49044,70,NULL,NULL,'SDSS J134525.77+464907.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000129,NULL,'18.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,206.357416667,46.81869,0,NULL,59282725220,926292581,14473321,18.5),(112996,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',112996,37.27,0.46,284,49045,70,NULL,NULL,'2MASX J13452640+4526076',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,206.360125,45.43553,0,NULL,59316785545,926824774,14481637,17.2),(112997,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',112997,37.95,0.13,388,49046,70,NULL,NULL,'2MASX J13452662+0024307',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000076,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,206.360917,0.40844,0.029,NULL,58391366759,912365105,14255704,17.5),(112998,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,112998,35.54,0.31,128,49047,NULL,NULL,'Malmquist cor.','UGC 08702',NULL,'2009ApJS..182..474S',2009,1,1.17,NULL,'G',0.000094,NULL,'14.6g',0.6,'Sd',NULL,NULL,NULL,NULL,1,206.3634583,47.92269,0.036,NULL,59214447175,925225737,14456652,14.6),(112999,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,112999,35.62,0.2,133,49047,74.4,NULL,NULL,'UGC 08702',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113000,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113000,35.64,0.29,135,49047,NULL,NULL,NULL,'UGC 08702',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113001,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113001,37.36,0.46,297,49048,70,NULL,NULL,'2MASX J13452722+6401412',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000075,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,206.3635417,64.02803,0.049,NULL,57868093837,904188966,14127952,17.4),(113002,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113002,37.75,0.46,355,49049,70,NULL,NULL,'LCRS B134253.9-030002',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000159,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,206.3715417,-3.25053,0.069,NULL,43617476876,681523076,10648798,17.2),(113003,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113003,38.1,0.46,417,49050,70,NULL,NULL,'2MASX J13452962+1141359',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,206.3734583,11.69322,0,NULL,58454286880,913348232,14271066,17.7),(113004,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113004,36.06,0.46,163,49051,70,NULL,NULL,'2MASX J13453013+1521060',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.37',0.22,NULL,NULL,NULL,NULL,NULL,1,206.375583,15.35181,0.017,NULL,58345979422,911655928,14244623,17.37),(113005,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113005,38.28,0.46,452,49052,70,NULL,NULL,'SDSS J134530.22+183851.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,206.3759583,18.64758,0,NULL,58322185540,911284149,14238814,18.5),(113006,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113006,37.95,0.13,388,49053,70,NULL,NULL,'2MASX J13453042+0020367',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000086,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,206.376667,0.34333,0.029,NULL,58391496161,912367127,14255736,16.7),(113007,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113007,37.23,0.19,280,49054,70,NULL,NULL,'2MASX J13453173+0248032',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000078,NULL,'16.8g',0.23,'AGN',NULL,NULL,NULL,NULL,1,206.382166667,2.80075,0.036,NULL,58445703752,913214121,14268970,16.8),(113008,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113008,38.45,0.46,490,49055,70,NULL,NULL,'2MASX J13453214+1139399',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00017,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,206.383917,11.66092,0,NULL,58454296156,913348377,14271068,17.8),(113009,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113009,37.69,0.33,345,49056,70,NULL,NULL,'2MASX J13453375+1628150',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.27',0.16,NULL,NULL,NULL,NULL,NULL,1,206.390541667,16.47078,0,NULL,58346421809,911662840,14244731,18.27),(113010,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113010,37.23,0.13,279,49057,70,NULL,NULL,'2MASX J13453384+2940298',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000087,NULL,'16.8g',0.29,'Sa',NULL,NULL,NULL,NULL,1,206.390917,29.67503,0,NULL,59136037529,924000586,14437509,16.8),(113011,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113011,35.36,0.27,118,49058,70,NULL,NULL,'2MASX J13453386+2027516',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'15.93',0.19,NULL,NULL,NULL,NULL,NULL,1,206.391083,20.46442,0.016,NULL,58324089662,911313900,14239279,15.93),(113012,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113012,37.23,0.19,280,49059,70,NULL,NULL,'SDSS J134534.09+030624.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000069,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,206.392083,3.10678,0.019,NULL,58447707452,913245428,14269459,18.3),(113013,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:30','1','SN 2006cs',NULL,113013,34.92,0.1,96.4,49060,74.4,NULL,NULL,'CGCG 190-050',NULL,'2013AJ....146...86T',2013,1,1.06,NULL,'G',0.000063,NULL,'14.4g',0.58,'S0?',NULL,NULL,NULL,NULL,1,206.3957917,35.61114,0,NULL,59175405608,924615712,14447120,14.4),(113014,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:30','1','SN 2006cs',NULL,113014,35.2,0.24,107,49060,65,NULL,'MLCS31','CGCG 190-050',0.023676,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113015,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:30','1','SN 2006cs',NULL,113015,35.24,0.18,109,49060,65,NULL,'MLCS17','CGCG 190-050',0.023676,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113016,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113016,38.52,0.46,505,49061,70,NULL,NULL,'SDSS J134535.93+465543.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000165,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,206.39975,46.92881,0,NULL,59282750392,926292974,14473327,18.5),(113017,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113017,37.34,0.46,294,49062,70,NULL,NULL,'2MASX J13453602+3944144',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,206.400083333,39.73728,0,NULL,59269647177,926088237,14470128,17.7),(113018,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113018,36.92,0.46,242,49063,70,NULL,NULL,'2MASX J13453658+4520437',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000193,NULL,'15.8g',0.39,'E0',NULL,NULL,NULL,NULL,1,206.4022917,45.34556,0,NULL,59316891417,926826428,14481662,15.8),(113019,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113019,35.79,0.47,144,49064,NULL,NULL,NULL,'SDSS J134536.87+220315.3',NULL,'2009ApJS..182..474S',2009,1,0.3,NULL,'G',0.00002,NULL,'17.97',0.12,NULL,NULL,NULL,NULL,NULL,1,206.403667,22.05425,0,NULL,58319425865,911241029,14238141,17.97),(113020,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113020,35.83,0.2,147,49064,74.4,NULL,NULL,'SDSS J134536.87+220315.3',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113021,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113021,35.84,0.46,147,49064,NULL,NULL,'Malmquist cor.','SDSS J134536.87+220315.3',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113022,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113022,36.58,0.33,207,49065,70,NULL,NULL,'2MASX J13453776+0702349',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.09',0.18,NULL,NULL,NULL,NULL,NULL,1,206.407417,7.04308,0.027,NULL,58431301326,912989083,14265454,18.09),(113023,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113023,37.95,0.13,388,49066,70,NULL,NULL,'SDSS J134538.64+000553.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000079,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,206.411,0.09811,0.045,NULL,58391307669,912364182,14255690,18),(113024,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113024,37.12,0.46,265,49067,70,NULL,NULL,'2MASX J13453936+0851289',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,206.414083,8.858,0,NULL,58431983812,912999747,14265621,17.6),(113025,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113025,37.29,0.46,287,49068,70,NULL,NULL,'2MASX J13453988+1530280',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,206.416083,15.50786,0.017,NULL,58346146627,911658541,14244664,17.4),(113026,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113026,37.21,0.46,276,49069,70,NULL,NULL,'2MASX J13453999+2933478',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000123,NULL,'17.84',0.22,'E;BrClG',NULL,NULL,NULL,NULL,1,206.4167083,29.56333,0,NULL,59136067139,924001049,14437516,17.84),(113027,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113027,37.23,0.13,279,49070,70,NULL,NULL,'2MASX J13454053+2929178',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000143,NULL,'17.0g',0.25,'E',NULL,NULL,NULL,NULL,1,206.418917,29.48844,0,NULL,59136054561,924000852,14437513,17),(113028,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113028,38.27,0.33,451,49071,70,NULL,NULL,'2MASX J13454278+1535110',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,206.42825,15.58628,0.017,NULL,58346026020,911656656,14244635,17.8),(113029,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113029,35.69,0.63,137,49072,70,NULL,NULL,'2MASX J13454282-4451305',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,206.428417,-44.85844,0.321,NULL,46963967152,733811986,11465812,15.6),(113030,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113030,38.09,0.46,415,49073,70,NULL,NULL,'2MASX J13454296+2540498',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,206.429083333,25.68061,0,NULL,59123244305,923800692,14434385,17.8),(113031,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113031,37.29,0.46,287,49074,70,NULL,NULL,'2MASX J13454311+2535528',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00018,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,206.4297083,25.59811,0,NULL,59123749741,923808589,14434509,16.4),(113032,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113032,38.09,0.46,414,49075,70,NULL,NULL,'2MASX J13454331+3313202',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000184,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,206.430458333,33.22231,0,NULL,59182996349,924734317,14448973,17.1),(113033,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113033,37.51,0.46,318,49076,70,NULL,NULL,'2MASXi J1345437-014625',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,206.432167,-1.77361,0.117,NULL,43564606794,680696981,10635890,17.9),(113034,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113034,36.26,0.46,179,49077,70,NULL,NULL,'2MASX J13454444+2545398',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000159,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,206.435333333,25.76117,0,NULL,59123252675,923800823,14434387,16.6),(113035,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113035,38.04,0.46,405,49078,70,NULL,NULL,'2MASX J13454479+1959085',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,206.4365,19.98586,0.009,NULL,58324920039,911326875,14239482,17.2),(113036,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113036,35.54,0.4,128,49079,NULL,NULL,'mean','UGC 08701',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.00005,NULL,'15.00',0.3,'Sbc            AGN','Group member',NULL,NULL,NULL,1,206.440083,22.08883,0,NULL,58319437302,911241207,14238143,15),(113037,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113037,35.81,0.47,145,49079,NULL,NULL,'H','UGC 08701',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113038,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113038,35.82,0.2,146,49079,74.4,NULL,NULL,'UGC 08701',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113039,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113039,35.89,0.46,151,49079,NULL,NULL,'J','UGC 08701',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113040,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113040,35.9,0.45,151,49079,NULL,NULL,'K','UGC 08701',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113041,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113041,38.6,0.46,524,49080,70,NULL,NULL,'SDSS J134546.01+182408.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,206.4417083,18.40233,0,NULL,58322269015,911285453,14238835,18.5),(113042,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113042,35.56,0.25,129,49081,74.4,NULL,NULL,'2MASX J13454616-3756488',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000017,NULL,'13.4I',0.6,NULL,NULL,NULL,NULL,NULL,1,206.442375,-37.94681,0.193,NULL,46887821117,732622204,11447221,13.4),(113043,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113043,35.81,0.46,145,49082,70,NULL,NULL,'2MASX J13454705+5545248',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000179,NULL,'15.5g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,206.4462083,55.75706,0,NULL,57288043507,895125679,13986338,15.5),(113044,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113044,36.58,0.33,207,49083,70,NULL,NULL,'CGCG 045-093',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000093,NULL,'15.7',0.7,NULL,NULL,NULL,NULL,NULL,1,206.446833,6.99631,0.027,NULL,58431299829,912989059,14265454,15.7),(113045,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113045,37.65,0.46,339,49084,70,NULL,NULL,'2MASX J13454774+3626544',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,206.4489583,36.44836,0,NULL,59145635113,924150548,14439852,17.5),(113046,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113046,37.38,0.46,300,49085,70,NULL,NULL,'2MASX J13454792+3131021',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000177,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,206.449875,31.51714,0,NULL,59184709523,924761086,14449391,17),(113047,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113047,37.65,0.46,339,49086,70,NULL,NULL,'2MASX J13454968+4347417',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,206.457,43.79489,0,NULL,59318262076,926847844,14481997,17.9),(113048,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113048,36.96,0.46,246,49087,70,NULL,NULL,'2MASX J13454986+3220291',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000185,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,206.457583,32.34125,0,NULL,59184451620,924757056,14449329,16.7),(113049,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113049,37.23,0.13,279,49088,70,NULL,NULL,'2MASXi J1345502+295105',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,206.459625,29.8515,0,NULL,59136032929,924000514,14437508,17.6),(113050,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113050,38.11,0.46,418,49089,70,NULL,NULL,'2MASX J13455122+0607203',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,206.4635,6.12222,0,NULL,58428812442,912950194,14264846,17.9),(113051,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113051,37.23,0.13,279,49090,70,NULL,NULL,'2MASX J13455156+2933108',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000147,NULL,'16.5g',0.32,'E',NULL,NULL,NULL,NULL,1,206.464875,29.55286,0,NULL,59136079961,924001249,14437519,16.5),(113052,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113052,37.41,0.46,304,49091,70,NULL,NULL,'2MASX J13455289+5925479',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,206.4704583,59.43006,0.005,NULL,57267711434,894807991,13981374,17.9),(113053,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113053,37.24,0.46,281,49092,70,NULL,NULL,'SDSS J134553.31+041952.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,206.472167,4.33125,0.008,NULL,58451289184,913301393,14270334,18),(113054,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113054,37.43,0.12,306,49093,70,NULL,NULL,'2MASX J13455340+4538377',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000174,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,206.472625,45.64381,0,NULL,59316818911,926825295,14481645,17.1),(113055,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113055,37.25,0.46,282,49094,70,NULL,NULL,'2MASX J13455337+6659436',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000081,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,206.4727083,66.99522,0.013,NULL,57870278312,904223098,14128485,17.5),(113056,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113056,36.54,0.46,203,49095,70,NULL,NULL,'2MASX J13455527+5615519',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000162,NULL,'16.3g',0.34,'AGN',NULL,NULL,NULL,NULL,1,206.4805,56.2645,0,NULL,57288825767,895137902,13986529,16.3),(113057,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:30','1','SN 1996ci','R',113057,41.24,NULL,1190,49096,65,NULL,'SALT','H-ZSNS J134556.16+022653.7',0.495,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,'Scd',NULL,NULL,NULL,NULL,1,206.484,2.44825,0,NULL,58446502010,913226593,14269165,NULL),(113058,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:30','1','SN 1996ci',NULL,113058,41.41,0.45,1280,49096,74.2,NULL,'SALT 2','H-ZSNS J134556.16+022653.7',0.495,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113059,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:30','1','SN 1996ci',NULL,113059,42.12,0.4,1780,49096,70,NULL,'SALT','H-ZSNS J134556.16+022653.7',0.495,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113060,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:30','1','SN 1996ci',NULL,113060,42.25,0.19,1890,49096,65,NULL,NULL,'H-ZSNS J134556.16+022653.7',0.495,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113061,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:30','1','SN 1996ci',NULL,113061,42.29,0.38,1920,49096,65,NULL,'SALT','H-ZSNS J134556.16+022653.7',0.495,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113062,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113062,38.27,0.33,451,49097,70,NULL,NULL,'2MASX J13455670+1536139',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,206.486208333,15.60383,0.017,NULL,58346027814,911656684,14244635,17.5),(113063,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113063,37.52,0.33,320,49098,70,NULL,NULL,'2MASX J13455679+2816178',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,206.486708333,28.27158,0,NULL,59138301143,924035955,14438061,17.3),(113064,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113064,37.61,0.46,333,49099,70,NULL,NULL,'SDSS J134556.92+203243.0',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'19.38',0.17,NULL,NULL,NULL,NULL,NULL,1,206.4872083,20.54528,0.021,NULL,58332401721,911443776,14241309,19.38),(113065,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113065,37.52,0.33,320,49100,70,NULL,NULL,'2MASX J13455861+2814188',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000155,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,206.494125,28.23864,0,NULL,59138308481,924036070,14438063,17.7),(113066,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113066,38.52,0.46,505,49101,70,NULL,NULL,'2MASX J13455999+1706343',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,206.499916667,17.10958,0,NULL,58376841212,912138143,14252158,18.1),(113067,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113067,35.28,0.48,114,49102,70,NULL,NULL,'2MASX J13460112-3719586',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000014,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,206.5047917,-37.33292,0.201,NULL,46888100694,732626573,11447290,14.7),(113068,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113068,35.84,0.56,147,49103,70,NULL,NULL,'2MASX J13460147-3344377',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00012,NULL,'14.32',0.5,'E',NULL,NULL,NULL,NULL,1,206.506083,-33.74392,0.157,NULL,46907397047,732928078,11452001,14.32),(113069,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113069,38.11,0.33,419,49104,70,NULL,NULL,'2MASX J13460214+2258465',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,206.509,22.97956,0,NULL,58318017278,911219019,14237797,17.3),(113070,'IRAS','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113070,36.09,0.8,165,49105,75,NULL,'CF, r','UGC 08707',NULL,'1997ApJS..109..333W',1997,1,0.92,NULL,'G',0.000086,NULL,'14.9g',0.63,'Sbc',NULL,NULL,NULL,NULL,1,206.511583333,55.71539,0,NULL,57288039583,895125618,13986337,14.9),(113071,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113071,36.37,0.38,188,49105,75,NULL,'CF, r, raw','UGC 08707',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113072,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113072,36.6,0.38,209,49105,75,NULL,'CF, r, inv','UGC 08707',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113073,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113073,36.61,0.38,210,49105,75,NULL,'CF, r, cor','UGC 08707',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113074,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113074,34.67,0.46,86,49106,70,NULL,NULL,'CGCG 132-003',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000163,NULL,'15.3',0.6,NULL,'Group member',NULL,NULL,NULL,1,206.514708333,22.11883,0,NULL,58319399882,911240623,14238134,15.3),(113075,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113075,38.11,0.33,419,49107,70,NULL,NULL,'2MASX J13460576+2300235',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,206.524083,23.00653,0,NULL,58318045808,911219465,14237804,17.4),(113076,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113076,36.69,0.46,218,49108,70,NULL,NULL,'2MASX J13460609+2231485',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,206.5255,22.53025,0,NULL,58321328576,911270759,14238605,17.7),(113077,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113077,37.01,0.46,253,49109,70,NULL,NULL,'2MASX J13460849+1800485',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00012,NULL,'15.4g',0.56,NULL,NULL,NULL,NULL,NULL,1,206.535541667,18.01344,0,NULL,58376956459,912139944,14252186,15.4),(113078,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113078,35.11,0.4,105,49110,NULL,NULL,'Malmquist cor.','UGC 08703',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000157,NULL,'14.96',0.5,'S?',NULL,NULL,NULL,NULL,1,206.5375417,21.89428,0.023,NULL,58319372599,911240196,14238128,14.96),(113079,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113079,35.17,0.39,108,49110,NULL,NULL,NULL,'UGC 08703',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113080,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113080,35.27,0.2,113,49110,74.4,NULL,NULL,'UGC 08703',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113081,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113081,36.92,0.46,242,49111,70,NULL,NULL,'2MASX J13460979+0104252',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000088,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,206.54075,1.07369,0.033,NULL,58392856080,912388376,14256068,16.3),(113082,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113082,35.95,0.2,155,49112,74.4,NULL,NULL,'CGCG 073-071',NULL,'2013AJ....146...86T',2013,1,0.58,NULL,'G',0.000018,NULL,'15.1',0.33,NULL,NULL,NULL,NULL,NULL,1,206.5417083,9.29206,0,NULL,58420392451,912818632,14262791,15.1),(113083,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113083,37.81,0.46,365,49113,70,NULL,NULL,'2MASX J13461132+5608179',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000166,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,206.547083,56.13833,0,NULL,57288872805,895138637,13986541,16.7),(113084,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113084,37.93,0.33,385,49114,70,NULL,NULL,'2MASX J13461134-0113257',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000079,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,206.547333333,-1.22392,0.077,NULL,43565615237,680712738,10636136,18.2),(113085,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113085,37.13,0.27,267,49115,70,NULL,NULL,'SDSS J134612.50+171709.7',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'16.1g',0.4,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,206.552125,17.28606,0,NULL,58376681655,912135650,14252119,16.1),(113086,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113086,35.42,0.21,121,49116,70,NULL,NULL,'MRK 0795b',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000153,NULL,'15.80',0.33,'AGN',NULL,NULL,NULL,NULL,1,206.552917,23.05383,0,NULL,58318047058,911219485,14237804,15.8),(113087,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113087,38.04,0.46,406,49117,70,NULL,NULL,'2MASX J13461293+3324004',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00018,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,206.554,33.40011,0,NULL,59183167944,924736999,14449015,17.4),(113088,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:30','1','SN 2006ah',NULL,113088,36.22,0.18,167,49118,74.2,NULL,'SALT 2','NSF J134613.71-090750.6',0.0509,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,206.557125,-9.13072,0.113,NULL,43571505281,680804770,10637574,NULL),(113089,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:30','1','SN 2006ah',NULL,113089,36.8,0.1,229,49118,74.4,NULL,NULL,'NSF J134613.71-090750.6',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113090,'SBF','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113090,27.99,0.74,3.97,49119,NULL,NULL,'R','AM 1343-452',NULL,'2000AJ....119..166J',2000,1,1,NULL,'G',NULL,NULL,'19.2',0.9,'dwarf Sph',NULL,NULL,NULL,NULL,1,206.57,-45.68472,0.481,NULL,46963806833,733809481,11465773,19.2),(113091,'TRGB','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113091,27.67,0.23,3.42,49119,NULL,NULL,'I','AM 1343-452',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113092,'TRGB','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113092,27.72,0.1,3.5,49119,74.4,NULL,NULL,'AM 1343-452',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113093,'TRGB','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113093,27.72,0.11,3.5,49119,NULL,NULL,NULL,'AM 1343-452',NULL,'2015ApJ...802L..25T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113094,'TRGB','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113094,27.92,NULL,3.84,49119,NULL,NULL,NULL,'AM 1343-452',NULL,'2002A&A...385...21K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113095,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113095,36.17,0.69,171,49120,70,NULL,NULL,'2MASX J13461789-0528147',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'17.39',0.29,NULL,NULL,NULL,NULL,NULL,1,206.5745417,-5.47083,0.057,NULL,43617730775,681527043,10648860,17.39),(113096,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113096,37.75,0.46,354,49121,70,NULL,NULL,'2MASX J13461824+3234094',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000135,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,206.5760417,32.56936,0,NULL,59184399218,924756237,14449316,18),(113097,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113097,37.09,0.46,261,49122,70,NULL,NULL,'2MASX J13461854-0121317',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000156,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,206.5772917,-1.35894,0.077,NULL,43565601477,680712523,10636133,17.3),(113098,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113098,35.33,0.56,117,49123,70,NULL,NULL,'2MASX J13461861-3820196',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,206.577625,-38.33869,0.177,NULL,46885512681,732586135,11446658,15.4),(113099,'Tully est','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113099,32.89,0.8,37.8,49124,75,NULL,'B','NGC 5296',NULL,'1988NBGC.C....0000T',1988,1,0.89,NULL,'G',0.000007,NULL,'14.9g',0.58,'S0+:           Sbrst','Pair member (points to parent)',NULL,NULL,NULL,1,206.57775,43.85136,0,NULL,59262898888,925982795,14468481,14.9),(113100,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113100,35.2,0.4,110,49124,NULL,NULL,'mean','NGC 5296',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113101,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113101,37.27,0.45,284,49124,NULL,NULL,'K','NGC 5296',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113102,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113102,37.13,0.27,267,49125,70,NULL,NULL,'2MASX J13461890+1717253',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.91',0.23,NULL,NULL,NULL,NULL,NULL,1,206.578917,17.29031,0,NULL,58376682940,912135670,14252119,16.91),(113103,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113103,37.3,0.33,288,49126,70,NULL,NULL,'SDSS J134619.54+130409.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000152,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,206.5814583,13.06942,0,NULL,58335849838,911497653,14242150,18.3),(113104,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113104,36.68,0.46,217,49127,70,NULL,NULL,'2MASX J13461957+2707111',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,206.5817083,27.11978,0,NULL,59124335701,923817745,14434652,16.4),(113105,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113105,37.48,0.46,313,49128,70,NULL,NULL,'2MASX J13462019+1104441',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000168,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,206.584083,11.07886,0.008,NULL,58455096562,913360883,14271263,16.9),(113106,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113106,36.61,0.46,210,49129,70,NULL,NULL,'2MASX J13462024+2031052',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00002,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,206.584375,20.51808,0.036,NULL,58332361670,911443151,14241299,16.5),(113107,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113107,37.3,0.33,288,49130,70,NULL,NULL,'2MASX J13462044+1305013',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000015,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,206.585291667,13.08381,0,NULL,58335846756,911497605,14242150,16.1),(113108,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:30','1','SN 1998be',NULL,113108,42.05,0.19,1570,49131,74.2,NULL,'SALT 2','H-ZSNS J134620.89+020240.4',0.64,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,206.5870417,2.04456,0.053,NULL,58445950884,913217982,14269030,NULL),(113109,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:30','1','SN 1998be','R',113109,42.29,NULL,1750,49131,65,NULL,'SALT','H-ZSNS J134620.89+020240.4',0.64,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113110,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:30','1','SN 1998be',NULL,113110,42.73,0.23,2140,49131,70,NULL,'SALT','H-ZSNS J134620.89+020240.4',0.64,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113111,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:30','1','SN 1998be',NULL,113111,42.78,0.26,2190,49131,65,NULL,NULL,'H-ZSNS J134620.89+020240.4',0.64,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113112,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:30','1','SN 1998be',NULL,113112,42.88,0.2,2290,49131,65,NULL,'SALT','H-ZSNS J134620.89+020240.4',0.64,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113113,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113113,35.5,0.46,126,49132,70,NULL,NULL,'CGCG 017-068 NED01',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.00015,NULL,'15.3g',0.52,'E              AGN','in a triple',NULL,NULL,NULL,1,206.592375,-3.41828,0.077,NULL,43617256252,681519628,10648744,15.3),(113114,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113114,35.74,0.53,140,49132,70,NULL,NULL,'CGCG 017-068 NED01',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113115,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113115,37.13,0.27,267,49133,70,NULL,NULL,'SDSS J134623.21+171646.9',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.2g',0.37,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,206.596708333,17.27972,0,NULL,58376680158,912135627,14252119,16.2),(113116,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113116,36.65,0.46,214,49134,70,NULL,NULL,'2MASX J13462327-0103357',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000062,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,206.596916667,-1.05989,0.077,NULL,43566008166,680718877,10636232,17.5),(113117,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113117,38.52,0.46,505,49135,70,NULL,NULL,'SDSS J134623.40+462155.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00017,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,206.5975,46.36547,0,NULL,59282490340,926288911,14473264,18.6),(113118,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113118,32.06,0.4,25.9,49136,75,NULL,NULL,'NGC 5297',NULL,'2008Ap.....51..336K',2008,1,5.6,NULL,'G',0.000007,NULL,'12.47',1.3,'SAB(s)c: sp','Pair member (points to parent)',NULL,NULL,NULL,1,206.598625,43.87233,0,NULL,59262901727,925982839,14468481,12.47),(113119,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113119,32.31,0.36,29,49136,NULL,NULL,NULL,'NGC 5297',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113120,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113120,32.42,0.46,30.4,49136,NULL,NULL,'J','NGC 5297',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113121,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113121,32.43,0.49,30.6,49136,75,NULL,'IR','NGC 5297',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113122,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113122,32.5,0.47,31.6,49136,NULL,NULL,'H','NGC 5297',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113123,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113123,32.61,0.45,33.2,49136,NULL,NULL,'K','NGC 5297',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113124,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113124,32.83,0.4,36.9,49136,NULL,NULL,'mean','NGC 5297',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113125,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113125,32.89,0.4,37.8,49136,75,NULL,'B','NGC 5297',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113126,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113126,37.43,0.12,306,49137,70,NULL,NULL,'SDSS J134623.89+454107.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000172,NULL,'18.0g',0.11,NULL,NULL,NULL,NULL,NULL,1,206.599583,45.68533,0,NULL,59315970304,926812036,14481438,18),(113127,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113127,35.78,0.25,143,49138,74.4,NULL,NULL,'ESO 325- G 016',NULL,'2013AJ....146...86T',2013,1,0.2,NULL,'G',0.000022,NULL,'15.0',0.2,'E','Group member, 2nd ranked galaxy',NULL,NULL,'Flat-Spectrum Radio Source',1,206.600041667,-37.97103,0.221,NULL,46887841018,732622515,11447226,15),(113128,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113128,35.87,0.48,149,49138,70,NULL,NULL,'ESO 325- G 016',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113129,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113129,36.91,0.33,241,49139,70,NULL,NULL,'2MASX J13462427+4446026',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000185,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,206.601375,44.76758,0,NULL,59316579728,926821558,14481586,16.4),(113130,'Tully est','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113130,32.21,0.8,27.7,49140,75,NULL,'B','NGC 5301',NULL,'1988NBGC.C....0000T',1988,1,1.95,NULL,'G',0.000077,NULL,'12.6g',0.79,'SA(s)bc: sp','Isolated galaxy',NULL,NULL,NULL,1,206.6027917,46.10706,0,NULL,59282488276,926288879,14473263,12.6),(113131,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113131,31.37,0.4,18.8,49140,75,NULL,NULL,'NGC 5301',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113132,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113132,31.51,0.43,20,49140,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5301',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113133,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113133,31.55,0.43,20.4,49140,75,NULL,'3.6 micron, color corrected','NGC 5301',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113134,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113134,31.67,0.2,21.6,49140,74.4,NULL,NULL,'NGC 5301',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113135,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113135,31.68,0.4,21.7,49140,NULL,NULL,NULL,'NGC 5301',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113136,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113136,31.75,0.46,22.4,49140,NULL,NULL,'J','NGC 5301',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113137,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113137,31.77,0.47,22.6,49140,NULL,NULL,'H','NGC 5301',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113138,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113138,31.77,0.55,22.6,49140,NULL,NULL,'Malmquist cor.','NGC 5301',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113139,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113139,31.87,0.49,23.6,49140,75,NULL,'IR','NGC 5301',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113140,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113140,31.9,0.45,23.9,49140,NULL,NULL,'K','NGC 5301',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113141,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113141,31.96,0.5,24.6,49140,NULL,NULL,NULL,'NGC 5301',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113142,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113142,32.04,0.4,25.6,49140,NULL,NULL,'mean','NGC 5301',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113143,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113143,36.92,0.46,243,49141,70,NULL,NULL,'2MASX J13462614+0740551',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.16',0.28,NULL,NULL,NULL,NULL,NULL,1,206.6090417,7.68189,0.017,NULL,58427977513,912937148,14264642,17.16),(113144,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113144,37.93,0.33,385,49142,70,NULL,NULL,'2MASX J13462681-0117047',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00015,NULL,'16.3g',0.35,'S0',NULL,NULL,NULL,NULL,1,206.611667,-1.2845,0.077,NULL,43565703703,680714120,10636158,16.3),(113145,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113145,39.11,0.46,665,49143,70,NULL,NULL,'2MASX J13462689+6410117',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000092,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,206.612333333,64.16997,0.049,NULL,57868557074,904196204,14128065,18.2),(113146,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113146,36.85,0.46,234,49144,70,NULL,NULL,'2MASX J13462714+2613031',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',NULL,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,206.613125,26.21769,0,NULL,59126782666,923855979,14435249,16.2),(113147,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113147,37.13,0.46,267,49145,70,NULL,NULL,'2MASX J13462776+4505536',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000169,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,206.615666667,45.09836,0,NULL,59316745748,926824152,14481627,17.6),(113148,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113148,36.85,0.33,234,49146,70,NULL,NULL,'2MASX J13462856+2833121',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000158,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,206.618875,28.55333,0,NULL,59138384197,924037253,14438082,16.4),(113149,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113149,38.23,0.46,442,49147,70,NULL,NULL,'LCRS B134354.3-024146',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,206.62225,-2.94569,0.101,NULL,43609636524,681400570,10646883,18.3),(113150,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113150,37.68,0.33,343,49148,70,NULL,NULL,'SDSS J134630.02+192539.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.1g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,206.625125,19.42772,0,NULL,58325869174,911341705,14239714,18.1),(113151,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113151,36.85,0.33,234,49149,70,NULL,NULL,'2MASX J13463031+2836461',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.001009,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,206.626208333,28.61289,0,NULL,59137921532,924030023,14437969,16.4),(113152,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113152,35.42,0.21,121,49150,70,NULL,NULL,'UGC 08706 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00017,NULL,'15.4',0.4,'E',NULL,NULL,NULL,NULL,1,206.626583,23.09719,0,NULL,58318035314,911219301,14237801,15.4),(113153,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113153,36.94,0.46,245,49151,70,NULL,NULL,'2MASX J13463062+1849531',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,206.6275417,18.8315,0,NULL,58325638241,911338097,14239657,17.3),(113154,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113154,35.38,0.79,119,49152,70,NULL,NULL,'2MASX J13463146-1732447',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.16',NULL,NULL,NULL,NULL,NULL,NULL,1,206.6309583,-17.54583,0.361,NULL,43676129735,682439527,10663117,16.16),(113155,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113155,37.36,0.46,297,49153,70,NULL,NULL,'2MASX J13463147-0027434',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000074,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,206.631125,-0.46197,0.037,NULL,43565936860,680717763,10636215,17),(113156,'IRAS','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113156,34.86,0.8,93.8,49154,75,NULL,'CF, r','UGC 08705',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000003,NULL,'14.66',0.6,'Scd:','Isolated galaxy',NULL,NULL,NULL,1,206.63425,20.84753,0.022,NULL,58332460166,911444690,14241323,14.66),(113157,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113157,34.07,0.69,65.3,49154,100,NULL,'mid-IR','UGC 08705',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113158,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113158,34.68,0.48,86.4,49154,NULL,NULL,'Malmquist cor.','UGC 08705',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113159,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113159,34.74,0.38,88.8,49154,75,NULL,'CF, r, raw','UGC 08705',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113160,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113160,34.75,0.47,89.3,49154,NULL,NULL,NULL,'UGC 08705',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113161,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113161,34.79,0.2,90.8,49154,74.4,NULL,NULL,'UGC 08705',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113162,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113162,34.92,0.38,96.3,49154,75,NULL,'CF, r, inv','UGC 08705',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113163,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113163,35.03,0.38,101,49154,75,NULL,'CF, r, cor','UGC 08705',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113164,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113164,35.12,0.4,106,49154,NULL,NULL,'mean','UGC 08705',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113165,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113165,35.15,0.47,107,49154,NULL,NULL,'H','UGC 08705',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113166,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113166,35.24,0.45,112,49154,NULL,NULL,'K','UGC 08705',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113167,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113167,35.27,0.46,113,49154,NULL,NULL,'J','UGC 08705',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113168,'IRAS','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113168,34.29,0.8,72.1,49155,75,NULL,'MAT, I','ESO 445- G 026',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000027,NULL,'15.02',0.2,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,206.636917,-30.879,0.177,NULL,46853412666,732084572,11438821,15.02),(113169,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113169,33.24,NULL,44.5,49155,NULL,NULL,NULL,'ESO 445- G 026',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113170,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113170,34.1,0.43,66,49155,75,NULL,'MAT, I, raw','ESO 445- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113171,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113171,34.2,0.32,69.2,49155,85,NULL,'I, raw','ESO 445- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113172,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113172,34.2,0.11,69.3,49155,NULL,NULL,NULL,'ESO 445- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113173,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113173,34.23,0.43,70,49155,75,NULL,'MAT, I, cor','ESO 445- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113174,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113174,34.24,0.32,70.5,49155,85,NULL,'I, inv','ESO 445- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113175,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113175,34.29,0.43,72.2,49155,75,NULL,'MAT, I, inv','ESO 445- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113176,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113176,34.55,NULL,81.3,49155,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 445- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113177,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113177,34.56,NULL,81.6,49155,NULL,NULL,'Dipole + Quadrupole','ESO 445- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113178,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113178,34.56,NULL,81.6,49155,NULL,NULL,'Dipole','ESO 445- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113179,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113179,34.79,0.2,90.8,49155,74.4,NULL,NULL,'ESO 445- G 026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113180,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113180,38.51,0.46,505,49156,70,NULL,NULL,'2MASX J13463335+1828251',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,206.6389583,18.47375,0,NULL,58322292409,911285818,14238840,17.7),(113181,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113181,36.48,0.46,197,49157,70,NULL,NULL,'2MASX J13463399+4504396',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,206.641791667,45.07781,0,NULL,59316748063,926824188,14481627,16.6),(113182,'Tully est','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113182,32.63,0.8,33.5,49158,75,NULL,NULL,'UGC 08716',NULL,'1988NBGC.C....0000T',1988,1,0.33,'SDSS has z = 0.071966 +- 0.000181.','G',0.000037,NULL,'17.2g',0.17,'S?             AGN','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,206.642958333,60.307,0,NULL,57275489814,894929528,13983273,17.2),(113183,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113183,36.87,0.46,236,49159,70,NULL,NULL,'2MASX J13463551+4815079',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000185,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,206.647875,48.25219,0,NULL,59214570610,925227665,14456682,16.8),(113184,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113184,35.78,0.56,143,49160,70,NULL,NULL,'2MASX J13463643-3134573',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.1b',0.4,'SB',NULL,NULL,NULL,NULL,1,206.651875,-31.58253,0.185,NULL,46898177211,732784018,11449750,16.1),(113185,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113185,37.67,0.46,342,49161,70,NULL,NULL,'2MASX J13463664+0341451',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,206.652791667,3.69572,0.025,NULL,58447957139,913249330,14269520,17.3),(113186,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113186,38.13,0.46,422,49162,70,NULL,NULL,'SDSS J134637.59+274446.2',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,206.656667,27.74619,0,NULL,59138227273,924034801,14438043,18.1),(113187,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113187,37.66,0.46,341,49163,70,NULL,NULL,'2MASX J13463833+2917522',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000171,NULL,'16.83',0.15,NULL,NULL,NULL,NULL,NULL,1,206.6597917,29.29794,0,NULL,59138953681,924046151,14438221,16.83),(113188,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113188,38.03,0.46,404,49164,70,NULL,NULL,'2MASX J13463892+4350416',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000179,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,206.66225,43.845,0,NULL,59262900075,925982813,14468481,17.3),(113189,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113189,36.91,0.33,241,49165,70,NULL,NULL,'2MASX J13463893+4447186',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000193,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,206.6624583,44.78867,0,NULL,59316577212,926821518,14481586,16.3),(113190,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113190,38.31,0.27,459,49166,70,NULL,NULL,'SDSS J134639.27+395122.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,206.663625,39.85636,0,NULL,59268835240,926075550,14469930,18.3),(113191,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113191,35.51,0.46,127,49167,70,NULL,NULL,'2MASX J13463973+3413282',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000169,NULL,'15.5g',0.52,NULL,NULL,NULL,NULL,NULL,1,206.6655,34.22456,0,NULL,59187064136,924797877,14449966,15.5),(113192,'TRGB','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113192,28.47,0.1,4.94,49168,74.4,NULL,NULL,'Centaurus A-dE4',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',NULL,NULL,'19.',0.7,'dwarf Sph?',NULL,NULL,NULL,NULL,1,206.668333,-29.97806,0.213,NULL,46853238228,732081847,11438778,19),(113193,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113193,35.02,0.46,101,49169,70,NULL,NULL,'SBS 1344+527',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.00001,NULL,'15.4g',0.36,'SAB0;Sy2       LINER',NULL,NULL,NULL,'Sy 2',1,206.67,52.47683,0,NULL,59220569025,925321391,14458146,15.4),(113194,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113194,32.46,NULL,31,49170,72,NULL,NULL,'SDSS J134641.00+063915.5',NULL,'2014Ap.....57..457K',2014,1,0.43,NULL,'G',0.000157,NULL,'17.16',0.22,NULL,NULL,NULL,NULL,NULL,1,206.670875,6.65411,0.021,NULL,58429666570,912963540,14265055,17.16),(113195,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113195,35.42,0.21,121,49171,70,NULL,NULL,'CGCG 132-009',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000163,NULL,'15.2',0.43,'AGN',NULL,NULL,NULL,NULL,1,206.674375,22.69264,0,NULL,58318095485,911220241,14237816,15.2),(113196,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113196,37.43,0.12,306,49172,70,NULL,NULL,'2MASX J13464199+4542176',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000174,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,206.675083333,45.70494,0,NULL,59315971131,926812048,14481438,17.1),(113197,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113197,37.39,0.33,300,49173,70,NULL,NULL,'2MASX J13464224+6021528',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000211,NULL,'16.3g',0.32,'BrClG          AGN',NULL,NULL,NULL,NULL,1,206.676083,60.36475,0,NULL,57275459861,894929060,13983266,16.3),(113198,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113198,37.68,0.33,343,49174,70,NULL,NULL,'2MASX J13464252+1926504',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.02',0.18,NULL,NULL,NULL,NULL,NULL,1,206.6772083,19.44753,0,NULL,58325066517,911329164,14239518,18.02),(113199,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113199,37.43,0.12,306,49175,70,NULL,NULL,'2MASX J13464266+4541355',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000184,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,206.677667,45.69331,0,NULL,59315939383,926811552,14481430,17.1),(113200,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113200,38.85,0.46,589,49176,70,NULL,NULL,'SDSS J134642.79+072032.8',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.9g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,206.678333,7.34247,0.062,NULL,58429330178,912958284,14264973,17.9),(113201,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113201,37.01,0.46,253,49177,70,NULL,NULL,'2MASX J13464280+2054264',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,206.6785,20.90728,0.022,NULL,58332452849,911444575,14241321,17.4),(113202,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113202,38.02,0.46,402,49178,70,NULL,NULL,'2MASX J13464385+1936264',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,206.6827917,19.60736,0,NULL,58325016819,911328387,14239506,17.4),(113203,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113203,36.88,0.46,238,49179,70,NULL,NULL,'2MASX J13464420+2758102',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000182,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,206.68425,27.9695,0,NULL,59138203059,924034422,14438037,16.3),(113204,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113204,36.92,0.46,242,49180,70,NULL,NULL,'2MASX J13464495+3057282',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00018,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,206.6872917,30.95789,0,NULL,59129044126,923891314,14435801,16.2),(113205,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113205,37.43,0.12,306,49181,70,NULL,NULL,'2MASX J13464509+4537584',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000194,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,206.687625,45.63292,0,NULL,59315945134,926811642,14481431,17),(113206,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113206,37.43,0.12,306,49182,70,NULL,NULL,'2MASX J13464507+4541144',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000172,NULL,'17.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,206.6877083,45.68731,0,NULL,59315941416,926811584,14481431,17.3),(113207,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113207,38.35,0.46,467,49183,70,NULL,NULL,'2MASX J13464763+4955070',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,206.6984583,49.91869,0,NULL,59222841657,925356900,14458701,18.2),(113208,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113208,38.53,0.33,509,49184,70,NULL,NULL,'SDSS J134647.80+465149.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,206.699208333,46.86378,0,NULL,59282688467,926292007,14473312,18.3),(113209,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113209,36.58,0.54,207,49185,70,NULL,NULL,'2MASX J13464805-3302363',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000107,NULL,'16.4b',NULL,'S0',NULL,NULL,NULL,NULL,1,206.70025,-33.04336,0.149,NULL,46899679169,732807487,11450116,16.4),(113210,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113210,38.33,0.46,463,49186,70,NULL,NULL,'2MASX J13464819+0724054',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,206.700833,7.40139,0.062,NULL,58429805007,912965703,14265089,17.5),(113211,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113211,37.75,0.33,355,49187,70,NULL,NULL,'2MASX J13464885+1446320',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000194,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,206.7035417,14.77567,0.012,NULL,58350666093,911729157,14245768,17.6),(113212,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113212,36.52,0.62,201,49188,70,NULL,NULL,'2MASX J13464886-2945213',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000083,NULL,'16.04',0.5,'E',NULL,NULL,NULL,NULL,1,206.703625,-29.75589,0.213,NULL,46853057641,732079025,11438734,16.04),(113213,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113213,37.52,0.46,319,49189,70,NULL,NULL,'SDSS J134649.00+051237.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,206.704167,5.21053,0.015,NULL,58450633894,913291154,14270174,17.7),(113214,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113214,37.43,0.12,306,49190,70,NULL,NULL,'2MASX J13464945+4542334',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,206.705875,45.70942,0,NULL,59315964142,926811939,14481436,17.6),(113215,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113215,35.59,0.2,131,49191,74.4,NULL,NULL,'MRK 1360',NULL,'2013AJ....146...86T',2013,1,0.76,'ALFALFA source is blended with the galaxy CGCG 073-073.','G',0.000008,NULL,'15.3g',0.36,'Spiral?','Pair member (points to parent)',NULL,NULL,NULL,1,206.709167,11.62139,0,NULL,58454924430,913358194,14271221,15.3),(113216,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113216,37.43,0.12,306,49192,70,NULL,NULL,'2MASX J13465043+4537484',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,206.710125,45.63017,0,NULL,59315945363,926811646,14481431,18.1),(113217,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113217,38.06,0.46,410,49193,70,NULL,NULL,'2MASX J13465129+1129034',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,206.713875,11.48433,0,NULL,58454726382,913355099,14271173,17.3),(113218,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113218,37.2,0.46,275,49194,70,NULL,NULL,'2MASX J13465225+1220030',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,206.7177083,12.33422,0,NULL,58335600493,911493757,14242089,16.9),(113219,'Ring Diameter','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113219,34.3,0.84,71,49195,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5293',NULL,'1981ApJS...45..541P',1981,1,1.9,NULL,'G',0.000023,NULL,'13.71',1.5,'SA(r)c',NULL,NULL,NULL,NULL,1,206.7195,16.27286,0,NULL,58345159655,911643119,14244423,13.71),(113220,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113220,34.8,0.4,91.2,49195,NULL,NULL,'mean','NGC 5293',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113221,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113221,35.16,0.47,107,49195,NULL,NULL,'H','NGC 5293',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113222,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113222,38.53,0.33,509,49196,70,NULL,NULL,'2MASXi J1346543+465038',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000188,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,206.7264583,46.84422,0,NULL,59283214074,926300219,14473440,17.8),(113223,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113223,37.48,0.46,313,49197,70,NULL,NULL,'2MASX J13465518+5857575',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000154,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,206.729917,58.96603,0.005,NULL,57268151699,894814870,13981482,16.9),(113224,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113224,37.99,0.23,397,49198,70,NULL,NULL,'2MASX J13465653+0018581',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000093,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,206.735583,0.31622,0.053,NULL,58392344029,912380375,14255943,17.1),(113225,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113225,35.37,0.46,119,49199,70,NULL,NULL,'2MASX J13465658+0814454',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'15.96',0.27,NULL,NULL,NULL,NULL,NULL,1,206.7357083,8.246,0,NULL,58428622440,912947225,14264800,15.96),(113226,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113226,37.39,0.33,300,49200,70,NULL,NULL,'2MASX J13465653+6022319',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000175,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,206.735833,60.37544,0,NULL,57275461615,894929087,13983266,17),(113227,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113227,38.31,0.27,459,49201,70,NULL,NULL,'2MASX J13465727+3952455',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000149,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,206.738667,39.87942,0,NULL,59268834206,926075534,14469930,18),(113228,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113228,37.16,0.46,270,49202,70,NULL,NULL,'2MASX J13465808+4048486',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000207,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,206.742125,40.81353,0,NULL,59268373414,926068334,14469817,16.2),(113229,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113229,36.83,0.46,232,49203,70,NULL,NULL,'2MASX J13465996+2353494',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.42',0.21,NULL,NULL,NULL,NULL,NULL,1,206.749833,23.89697,0.01,NULL,59458478148,929038721,14516230,17.42),(113230,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113230,38.24,0.46,444,49204,70,NULL,NULL,'LCRS B134425.1-024258',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,206.750917,-2.96514,0.081,NULL,43609647791,681400746,10646886,17.7),(113231,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:30','1','SN 1996bk',NULL,113231,31.65,0.38,21.2,49205,74.2,NULL,'SALT 2','NGC 5308',0.00681,'2010ApJ...716..712A',2010,1,3.7,NULL,'G',0.000017,NULL,'12.31',0.7,'S0-','in a radial-velocity based grouping',NULL,NULL,NULL,1,206.7517917,60.97317,0.009,NULL,57262496216,894726503,13980101,12.31),(113232,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:30','1','SN 1996bk',NULL,113232,32.09,0.09,26.2,49205,74.4,NULL,NULL,'NGC 5308',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113233,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:30','1','SN 1996bk',NULL,113233,32.2,0.14,27.1,49205,65,NULL,'MLCS2k2','NGC 5308',0.00681,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113234,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:30','1','SN 1996bk',NULL,113234,32.33,0.28,29,49205,72,NULL,NULL,'NGC 5308',0.00681,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113235,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:30','1','SN 1996bk',NULL,113235,32.42,0.12,30.5,49205,70.8,NULL,NULL,'NGC 5308',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113236,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:30','1','SN 1996bk',NULL,113236,32.61,0.34,33,49205,70,NULL,'SALT','NGC 5308',0.00681,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113237,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:30','1','SN 1996bk',NULL,113237,32.77,0.14,35.8,49205,60,NULL,NULL,'NGC 5308',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113238,'SBF','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113238,32.55,0.21,32.4,49205,NULL,NULL,'I','NGC 5308',NULL,'2001ApJ...559..584A',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113239,'Tully est','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113239,32.55,0.8,32.4,49205,75,NULL,'B','NGC 5308',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113240,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113240,31.37,0.45,18.8,49205,NULL,NULL,'K','NGC 5308',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113241,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113241,31.59,0.49,20.8,49205,75,NULL,'IR','NGC 5308',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113242,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113242,31.97,0.4,24.8,49205,75,NULL,NULL,'NGC 5308',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113243,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113243,32.46,0.4,31,49205,NULL,NULL,'mean','NGC 5308',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113244,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113244,32.65,0.4,33.9,49205,75,NULL,'HOSTS SN 1996bk','NGC 5308',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113245,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113245,36.07,0.6,164,49206,70,NULL,NULL,'2MASX J13470074-3316492',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000017,NULL,'16.6b',NULL,'S0',NULL,NULL,NULL,NULL,1,206.753167,-33.28039,0.185,NULL,46899360175,732802502,11450039,16.6),(113246,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113246,33.6,0.2,52.5,49207,74.4,NULL,NULL,'UGC 08713',NULL,'2013AJ....146...86T',2013,1,1.11,NULL,'G',0.000033,NULL,'15.0g',0.31,'SB(s)d: sp','Pair member (points to parent)',NULL,NULL,NULL,1,206.755125,33.89361,0,NULL,59183610287,924743910,14449123,15),(113247,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113247,33.62,0.46,52.9,49207,NULL,NULL,NULL,'UGC 08713',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113248,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113248,33.72,0.49,55.4,49207,75,NULL,'IR','UGC 08713',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113249,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113249,33.78,0.43,57.1,49207,NULL,NULL,'Malmquist cor.','UGC 08713',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113250,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113250,37.62,0.33,335,49208,70,NULL,NULL,'2MASX J13470126+2722392',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,206.755333,27.3775,0,NULL,59124431744,923819246,14434675,17.6),(113251,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113251,36.2,0.55,174,49209,70,NULL,NULL,'2MASX J13470134-3518509',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.0001,NULL,'15.23',0.3,'E+S0     poss. LINER',NULL,NULL,NULL,NULL,1,206.7557083,-35.31425,0.141,NULL,46886047528,732594492,11446788,15.23),(113252,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113252,37.71,0.46,348,49210,70,NULL,NULL,'2MASX J13470146+1925454',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,206.756083,19.42917,0,NULL,58325029897,911328592,14239509,17),(113253,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113253,37.69,0.46,344,49211,70,NULL,NULL,'2MASX J13470250+1704199',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,206.760375,17.07208,0,NULL,58376684901,912135701,14252120,17.3),(113254,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113254,36.64,0.68,213,49212,70,NULL,NULL,'2MASX J13470270-3741565',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.1I',0.3,NULL,NULL,NULL,NULL,NULL,1,206.7612083,-37.69897,0.221,NULL,46887694417,732620225,11447191,14.1),(113255,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113255,38.31,0.27,459,49213,70,NULL,NULL,'2MASX J13470294+3952174',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,206.7622917,39.87136,0,NULL,59268834126,926075533,14469930,17.5),(113256,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113256,37.43,0.12,306,49214,70,NULL,NULL,'2MASX J13470329+4544315',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000186,NULL,'16.2g',0.4,'BrClG',NULL,NULL,NULL,NULL,1,206.763625,45.742,0,NULL,59315965379,926811959,14481436,16.2),(113257,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113257,37.62,0.33,335,49215,70,NULL,NULL,'2MASX J13470454+2727118',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'18.30',0.15,NULL,NULL,NULL,NULL,NULL,1,206.7689583,27.45328,0,NULL,59124395792,923818684,14434666,18.3),(113258,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113258,37.43,0.12,306,49216,70,NULL,NULL,'2MASX J13470501+4552315',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000184,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,206.7710417,45.87553,0,NULL,59315958370,926811849,14481435,17.1),(113259,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113259,37.97,0.46,393,49217,70,NULL,NULL,'2MASX J13470524+0402449',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,206.771875,4.04569,0.018,NULL,58451600623,913306259,14270410,17.6),(113260,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113260,37.43,0.12,306,49218,70,NULL,NULL,'2MASX J13470529+4607285',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000166,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,206.7720417,46.12461,0.038,NULL,59282444610,926288197,14473253,17.9),(113261,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113261,38.18,0.46,433,49219,70,NULL,NULL,'2MASX J13470537+1105304',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,206.7722917,11.09186,0.031,NULL,58454604871,913353201,14271143,17.4),(113262,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113262,37.92,0.46,383,49220,70,NULL,NULL,'2MASX J13470574+5629274',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000185,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,206.773666667,56.49089,0,NULL,57295888867,895248263,13988254,17),(113263,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113263,37.19,0.46,274,49221,70,NULL,NULL,'2MASX J13470730+0923594',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,206.780375,9.39975,0,NULL,58452892215,913326440,14270725,17.6),(113264,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:30','1','SN 1997ap','R',113264,42.72,NULL,1910,49222,65,NULL,'SALT','SCP J134709.90+022357.5',0.83,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,206.79125,2.39931,0,NULL,58446360008,913224375,14269130,NULL),(113265,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:30','1','SN 1997ap',NULL,113265,42.83,0.48,2010,49222,74.2,NULL,'SALT 2','SCP J134709.90+022357.5',0.83,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113266,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:30','1','SN 1997ap',NULL,113266,43.49,0.37,2730,49222,70,NULL,'SALT','SCP J134709.90+022357.5',0.83,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113267,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:30','1','SN 1997ap',NULL,113267,43.65,0.36,2930,49222,65,NULL,'SALT','SCP J134709.90+022357.5',0.83,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113268,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:30','1','SN 1997ap',NULL,113268,43.67,0.35,2960,49222,65,NULL,'Snapshot','SCP J134709.90+022357.5',0.83,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113269,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:30','1','SN 1997ap',NULL,113269,43.85,0.19,3220,49222,65,NULL,NULL,'SCP J134709.90+022357.5',0.83,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113270,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:30','1','SN 1997ap',NULL,113270,43.67,0.35,5420,49222,65,NULL,'Snapshot','SCP J134709.90+022357.5',NULL,'1998ApJ...504..935R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113271,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113271,36.66,0.46,215,49223,70,NULL,NULL,'2MASX J13471048+1439359',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.00019,NULL,'15.7g',0.48,NULL,NULL,NULL,NULL,NULL,1,206.793625,14.66014,0.012,NULL,58350783353,911730989,14245796,15.7),(113272,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113272,36.37,0.61,188,49224,70,NULL,NULL,'2MASX J13471056-3230550',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.0b',0.4,'S0',NULL,NULL,NULL,NULL,1,206.7940417,-32.51525,0.241,NULL,46899848385,732810131,11450158,16),(113273,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113273,36.36,0.46,187,49225,70,NULL,NULL,'2MASX J13471113+1131495',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000179,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,206.796291667,11.53039,0,NULL,58454944746,913358511,14271226,16.4),(113274,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113274,37.99,0.23,397,49226,70,NULL,NULL,'2MASX J13471161+0024109',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000079,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,206.7982917,0.40308,0.049,NULL,58389578422,912337162,14255268,17.1),(113275,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113275,36.88,0.72,237,49227,70,NULL,NULL,'2MASX J13471183-3807346',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,206.7992917,-38.12628,0.237,NULL,46885539276,732586551,11446664,15.6),(113276,'D-Sigma','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113276,34.52,0.4,80.3,49228,75,NULL,'Edat, raw','ESO 509- G 108',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000063,NULL,'14.17',0.5,'SAB? sp',NULL,NULL,NULL,NULL,1,206.800667,-24.37294,0.249,NULL,46976233520,734003648,11468807,14.17),(113277,'D-Sigma','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113277,34.86,0.4,93.7,49228,75,NULL,'Edat, cor','ESO 509- G 108',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113278,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113278,38.18,0.46,433,49229,70,NULL,NULL,'2MASX J13471346+3115208',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00017,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,206.806083,31.25581,0,NULL,59128795901,923887435,14435741,17),(113279,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113279,37.99,0.46,397,49230,70,NULL,NULL,'2MASX J13471419+3610565',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,206.80925,36.18231,0,NULL,59145965128,924155705,14439932,17.5),(113280,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113280,36.69,0.46,218,49231,70,NULL,NULL,'2MASX J13471444+1816086',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.58',0.18,NULL,NULL,NULL,NULL,NULL,1,206.8102917,18.26917,0,NULL,58322120176,911283127,14238798,17.58),(113281,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113281,37.99,0.23,397,49232,70,NULL,NULL,'2MASX J13471481+0023579',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,'FoF','17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,206.811583,0.39928,0.049,NULL,58389581492,912337210,14255268,17.5),(113282,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113282,34.88,0.6,94.4,49233,70,NULL,NULL,'IC 4330',NULL,'2014MNRAS.445.2677S',2014,1,1.2,'Two minute error in IC RA.','G',0.000033,NULL,'14.70',0.6,'SB(rs)bc       HII',NULL,NULL,NULL,NULL,1,206.811875,-28.33181,0.173,NULL,46856624405,732134756,11439605,14.7),(113283,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113283,34.73,NULL,88.3,49233,NULL,NULL,'B','IC 4330',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113284,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113284,34.76,NULL,89.5,49233,NULL,NULL,'B, Hubble-type-TF','IC 4330',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113285,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113285,34.76,0.29,89.5,49233,NULL,NULL,'B, Hubble-type-TF','IC 4330',NULL,'2005Ap&SS.299..387R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113286,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113286,34.76,NULL,89.5,49233,NULL,NULL,'B, Hubble-type-TF','IC 4330',NULL,'2005Ap&SS.299..405R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113287,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113287,35.43,NULL,122,49233,NULL,NULL,'I','IC 4330',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113288,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113288,35.66,0.42,135,49233,NULL,NULL,'Malmquist cor.','IC 4330',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113289,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113289,35.76,0.4,142,49233,NULL,NULL,NULL,'IC 4330',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113290,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113290,35.8,0.2,145,49233,74.4,NULL,NULL,'IC 4330',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113291,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113291,36.07,0.47,163,49233,NULL,NULL,'H','IC 4330',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113292,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113292,36.13,0.4,168,49233,NULL,NULL,'mean','IC 4330',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113293,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113293,36.17,0.45,171,49233,NULL,NULL,'K','IC 4330',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113294,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113294,36.24,0.46,177,49233,NULL,NULL,'J','IC 4330',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113295,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113295,38.17,0.46,432,49234,70,NULL,NULL,'SDSS J134715.38+182923.7',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,206.814083333,18.48992,0,NULL,58325509676,911336088,14239626,NULL),(113296,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113296,35.5,0.25,126,49235,74.4,NULL,NULL,'2MASX J13471545-3249000',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000017,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,206.8144583,-32.81661,0.161,NULL,46899920812,732811262,11450175,14.6),(113297,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113297,37.68,0.46,343,49236,70,NULL,NULL,'2MASX J13471587+0330389',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.51',0.16,NULL,NULL,NULL,NULL,NULL,1,206.816208333,3.51081,0.02,NULL,58447993480,913249898,14269529,18.51),(113298,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113298,36.83,0.46,232,49237,70,NULL,NULL,'2MASX J13471820+6658200',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000079,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,206.825916667,66.97219,0.013,NULL,57870370873,904224544,14128508,17.1),(113299,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113299,34.06,0.47,64.8,49238,70,NULL,NULL,'ESO 445- G 028',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000017,NULL,'14.25',0.8,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,206.827875,-29.80894,0.205,NULL,46853052875,732078951,11438733,14.25),(113300,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113300,34.22,0.23,69.8,49238,74.4,NULL,NULL,'ESO 445- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113301,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113301,38.04,0.46,405,49239,70,NULL,NULL,'SDSS J134718.69+395948.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000145,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,206.827875,39.99672,0,NULL,59268885389,926076334,14469942,18.4),(113302,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113302,37.02,0.46,253,49240,70,NULL,NULL,'2MASX J13472067+4449042',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,206.836083,44.81794,0,NULL,59316487291,926820113,14481564,17.7),(113303,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113303,38,0.46,399,49241,70,NULL,NULL,'2MASX J13472084+1647339',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,206.8367083,16.79278,0,NULL,58380056806,912188387,14252943,17.6),(113304,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113304,38.15,0.33,427,49242,70,NULL,NULL,'2MASX J13472185+4203402',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,206.841083,42.06119,0,NULL,59269849659,926091400,14470178,18.2),(113305,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113305,36.78,0.46,227,49243,70,NULL,NULL,'SDSS J134721.95+032039.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000097,NULL,'17.7g',0.15,'NLAGN',NULL,NULL,NULL,NULL,1,206.8415,3.34428,0.02,NULL,58448133629,913252087,14269563,17.7),(113306,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113306,37.48,0.46,314,49244,70,NULL,NULL,'SDSS J134721.97-000441.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000079,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,206.841541667,-0.07819,0.053,NULL,43562358617,680661853,10635341,18.2),(113307,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113307,38.15,0.33,427,49245,70,NULL,NULL,'2MASX J13472213+4204464',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000161,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,206.84225,42.07956,0,NULL,59269852625,926091447,14470178,18.3),(113308,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113308,35.91,0.6,152,49246,70,NULL,NULL,'2MASX J13472251-3305470',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000083,NULL,'14.99',0.3,NULL,NULL,NULL,NULL,NULL,1,206.84375,-33.09647,0.161,NULL,46899760892,732808763,11450136,14.99),(113309,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113309,37.51,0.09,318,49247,70,NULL,NULL,'2MASX J13472255+2622519',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.0001,NULL,'15.9g',0.43,NULL,'Field galaxy',NULL,NULL,NULL,1,206.8440417,26.38103,0,NULL,59126815707,923856495,14435257,15.9),(113310,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113310,38.7,0.46,549,49248,70,NULL,NULL,'SDSS J134722.84+543358.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,206.84525,54.56633,0,NULL,57290523362,895164427,13986944,18.1),(113311,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113311,38.51,0.46,503,49249,70,NULL,NULL,'SDSS J134722.86+272506.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000176,NULL,'18.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,206.8452917,27.41858,0,NULL,59124399262,923818738,14434667,18.4),(113312,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113312,33.55,0.25,51.3,49250,74.4,NULL,NULL,'AM 1344-301 NED01',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000019,NULL,'16',0.1,'S0','in a pair',NULL,NULL,NULL,1,206.847083,-30.41714,0.173,NULL,46853167415,732080740,11438761,16),(113313,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113313,38.48,0.46,497,49251,70,NULL,NULL,'2MASX J13472341+0208349',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000075,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,206.84775,2.14292,0.049,NULL,58445880710,913216886,14269013,17.9),(113314,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113314,37.81,0.46,364,49252,70,NULL,NULL,'2MASX J13472385+1709339',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.19',0.16,NULL,NULL,NULL,NULL,NULL,1,206.849417,17.15947,0,NULL,58380181831,912190341,14252974,18.19),(113315,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113315,37.82,0.46,367,49253,70,NULL,NULL,'2MASX J13472448+5949291',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,206.852,59.82478,0.005,NULL,57275767299,894933864,13983341,17.5),(113316,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113316,33.56,0.46,51.4,49254,70,NULL,NULL,'NGC 5291',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000019,NULL,'15.13',0.7,'E pec:   poss. LINER','Pair member (points to parent)',NULL,NULL,NULL,1,206.852,-30.407,0.173,NULL,46853168418,732080756,11438761,15.13),(113317,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113317,33.8,0.45,57.4,49254,NULL,NULL,'K','NGC 5291',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113318,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113318,33.96,0.4,61.9,49254,NULL,NULL,'mean','NGC 5291',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113319,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113319,37.21,0.46,277,49255,70,NULL,NULL,'2MASX J13472499+1323159',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,206.854167,13.38778,0,NULL,58349754725,911714917,14245545,17.7),(113320,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113320,37.62,0.46,334,49256,70,NULL,NULL,'2MASX J13472523+5110223',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,206.85525,51.17278,0,NULL,59223144405,925361631,14458775,17.5),(113321,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113321,37.78,0.46,359,49257,70,NULL,NULL,'2MASX J13472598+5315523',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000143,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,206.858291667,53.26453,0.005,NULL,59216381782,925255965,14457124,17.3),(113322,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113322,37.3,0.46,288,49258,70,NULL,NULL,'2MASX J13472715+2837399',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000175,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,206.863333,28.62792,0,NULL,59138412036,924037688,14438088,17.5),(113323,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113323,36.32,0.72,184,49259,70,NULL,NULL,'2MASX J13472730-4501361',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.4,NULL,NULL,NULL,NULL,NULL,1,206.863708333,-45.02669,0.297,NULL,46964024250,733812878,11465826,14.3),(113324,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113324,34.2,0.57,69.3,49260,70,NULL,NULL,'2MASX J13472825-4906033',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'16.5b',0.2,NULL,NULL,NULL,NULL,NULL,1,206.8677083,-49.10097,0.561,NULL,46820193066,731565516,11430711,16.5),(113325,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113325,37.29,0.46,287,49261,70,NULL,NULL,'2MASX J13472837-0053469',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000074,NULL,'17.3g',0.22,'AGN',NULL,NULL,NULL,NULL,1,206.86825,-0.89622,0.037,NULL,43562701320,680667208,10635425,17.3),(113326,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113326,35.06,0.45,103,49262,NULL,NULL,'K','ESO 383- G 076',NULL,'2007A&A...465...71T',2007,1,2.3,NULL,'G',0.000031,NULL,'13.01',1.1,'E+5;BrClG','Brightest group member',NULL,NULL,NULL,1,206.86825,-32.86497,0.161,NULL,46899912591,732811134,11450173,13.01),(113327,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113327,35.92,0.4,153,49262,NULL,NULL,'mean','ESO 383- G 076',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113328,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113328,36.98,0.46,249,49263,70,NULL,NULL,'2MASX J13472974+5826261',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,206.874125,58.44047,0,NULL,57266556239,894789941,13981092,17.7),(113329,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113329,37.01,0.46,253,49264,70,NULL,NULL,'2MASX J13473014+2638589',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000053,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,206.87575,26.64975,0,NULL,59124671252,923822988,14434734,16.6),(113330,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113330,37.1,0.46,264,49265,70,NULL,NULL,'2MASX J13473038+3517059',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000162,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,206.8765,35.28494,0,NULL,59144975346,924140239,14439691,16.8),(113331,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113331,35.91,0.48,152,49266,70,NULL,NULL,'2MASX J13473101-3335200',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000039,NULL,'16.0b',0.5,'S0',NULL,NULL,NULL,NULL,1,206.879125,-33.58883,0.185,NULL,46899218272,732800285,11450004,16),(113332,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113332,36.36,0.25,187,49266,74.4,NULL,NULL,'2MASX J13473101-3335200',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113333,'SZ effect','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113333,38.54,0.47,510,49267,NULL,NULL,'Isotherm., r < 100 kpc','LCDCS 0829',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,206.8775,-11.75278,0.133,NULL,43689789135,682652955,10666452,NULL),(113334,'SZ effect','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113334,39.4,0.53,760,49267,NULL,NULL,'Isotherm.','LCDCS 0829',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113335,'SZ effect','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113335,39.7,NULL,870,49267,NULL,NULL,'3.1 (red) calibration','LCDCS 0829',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113336,'SZ effect','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113336,39.91,0.17,960,49267,NULL,NULL,'Hydrost. Eq.','LCDCS 0829',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113337,'SZ effect','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113337,39.94,NULL,972,49267,NULL,NULL,'4.2 (black) calibration','LCDCS 0829',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113338,'SZ effect','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113338,40.33,NULL,1170,49267,NULL,NULL,NULL,'LCDCS 0829',NULL,'2005ApJ...625..108D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113339,'SZ effect','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113339,40.38,NULL,1190,49267,NULL,NULL,NULL,'LCDCS 0829',NULL,'2011A&A...532A..14C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113340,'SZ effect','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113340,40.41,NULL,1210,49267,NULL,NULL,'4.1 (blue) calibration','LCDCS 0829',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113341,'SZ effect','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113341,40.43,NULL,1220,49267,NULL,NULL,NULL,'LCDCS 0829',NULL,'2002ApJ...581...53R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113342,'SZ effect','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113342,40.89,0.02,1510,49267,NULL,NULL,'v(peculiar) = -1260 +760 - 530 km/s','LCDCS 0829',NULL,'2016ApJ...820..101S',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113343,'SZ effect','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113343,40.92,0.02,1530,49267,NULL,NULL,'v(peculiar) = +450 +/- 810 km/s','LCDCS 0829',NULL,'2012ApJ...749..114Z',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113344,'SZ effect','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113344,40.94,0.03,1540,49267,NULL,NULL,'v(peculiar) = +1420 +1170 -1270 km/s','LCDCS 0829',NULL,'2004PASJ...56...17K',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113345,'SZ effect','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113345,41.92,0.28,2430,49267,NULL,NULL,NULL,'LCDCS 0829',NULL,'2001ApJ...552...42P',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113346,'SZ effect','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113346,41.92,0.32,2430,49267,NULL,NULL,NULL,'LCDCS 0829',NULL,'1999ApJ...516L...1K',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113347,'SZ effect','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113347,42.3,0.33,2880,49267,NULL,NULL,NULL,'LCDCS 0829',NULL,'1999ApJ...516L...1K',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113348,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113348,36.86,0.33,235,49268,70,NULL,NULL,'2MASX J13473229+4501143',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000185,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,206.8847083,45.02058,0,NULL,59316441791,926819402,14481553,17.5),(113349,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113349,36.69,0.46,218,49269,70,NULL,NULL,'2MASX J13473277+5458461',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000166,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,206.886541667,54.97953,0,NULL,57290629234,895166081,13986970,16.9),(113350,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113350,35.67,0.62,136,49270,70,NULL,NULL,'2MASX J13473319-5053123',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,206.888375,-50.88681,0.873,NULL,46824990114,731640470,11431882,17),(113351,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113351,37.43,0.15,306,49271,70,NULL,NULL,'2MASX J13473342+0505518',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000173,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,206.889083333,5.09753,0.035,NULL,58450371302,913287051,14270110,17.4),(113352,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113352,35.4,0.62,120,49272,70,NULL,NULL,'2MASX J13473416-3040029',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.4,NULL,NULL,NULL,NULL,NULL,1,206.892333,-30.66753,0.157,NULL,46853304531,732082883,11438795,14.4),(113353,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113353,37.12,0.27,266,49273,70,NULL,NULL,'2MASX J13473518+1829066',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.00',0.25,NULL,NULL,NULL,NULL,NULL,1,206.896583,18.48528,0,NULL,58325488623,911335759,14239621,16),(113354,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113354,37.58,0.46,327,49274,70,NULL,NULL,'2MASX J13473550+3255379',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,206.898083,32.92725,0,NULL,59184997180,924765580,14449462,17.4),(113355,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113355,35.07,0.59,103,49275,70,NULL,NULL,'2MASX J13473724-3245035',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000022,NULL,'16.4b',NULL,'E',NULL,NULL,NULL,NULL,1,206.9052083,-32.75103,0.161,NULL,46899861470,732810335,11450161,16.4),(113356,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113356,35.66,0.25,136,49275,74.4,NULL,NULL,'2MASX J13473724-3245035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113357,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113357,35.8,0.46,145,49276,70,NULL,NULL,'CGCG 073-075',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000157,NULL,'15.4g',0.5,NULL,NULL,NULL,NULL,NULL,1,206.90575,9.76753,0,NULL,58452948258,913327316,14270739,15.4),(113358,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113358,37.01,0.46,252,49277,70,NULL,NULL,'2MASX J13473810+0941117',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.17',0.19,NULL,NULL,NULL,NULL,NULL,1,206.908666667,9.6865,0,NULL,58452946618,913327290,14270738,17.17),(113359,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113359,37.75,0.33,355,49278,70,NULL,NULL,'2MASX J13473869+1454525',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.15',0.15,NULL,NULL,NULL,NULL,NULL,1,206.911333,14.91464,0.012,NULL,58347482690,911679417,14244990,18.15),(113360,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113360,33.79,0.4,57.3,49279,NULL,NULL,'mean','IC 4325',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000023,NULL,'14.71',0.4,'SB?            HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,206.9152083,-29.43436,0.205,NULL,46851700295,732057817,11438403,14.71),(113361,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113361,34.15,0.47,67.7,49279,NULL,NULL,'H','IC 4325',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113362,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113362,34.18,0.45,68.4,49279,NULL,NULL,'K','IC 4325',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113363,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113363,34.24,0.46,70.4,49279,NULL,NULL,'J','IC 4325',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113364,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,'R',113364,37.73,0.12,352,49280,70,NULL,NULL,'2MASX J13473982+2814125',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,206.91575,28.23683,0,NULL,59138612312,924040817,14438137,17.8),(113365,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113365,32.94,0.48,38.8,49281,70,NULL,NULL,'NGC 5292',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.000017,NULL,'12.84',1.5,'(R\')SA(rs)ab  LINER?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,206.9169583,-30.93953,0.157,NULL,46852932937,732077077,11438704,12.84),(113366,'FP','2016-12-15 15:15:18','2016-12-16 11:20:30','1',NULL,NULL,113366,36.17,0.68,172,49282,70,NULL,NULL,'2MASX J13473975-3257065',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00006,NULL,'14.8I',0.2,NULL,NULL,NULL,NULL,NULL,1,206.9177083,-32.95539,0.161,NULL,46899765716,732808839,11450138,14.8),(113367,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113367,35.57,0.46,130,49283,70,NULL,NULL,'IC 0942',NULL,'2015arXiv151105856S',2015,1,0.99,NULL,'G',0.00008,NULL,'14.7g',0.66,'E0',NULL,NULL,NULL,NULL,1,206.921417,56.62158,0,NULL,57295848404,895247631,13988244,14.7),(113368,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113368,37.42,0.46,304,49284,70,NULL,NULL,'2MASX J13474139+3549209',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000158,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,206.922333,35.82242,0,NULL,59145011392,924140803,14439700,16.7),(113369,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113369,37.88,0.46,376,49285,70,NULL,NULL,'2MASX J13474163+4046012',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000185,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,206.92325,40.767,0,NULL,59268154746,926064917,14469764,17.4),(113370,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113370,37.73,0.46,352,49286,70,NULL,NULL,'2MASX J13474264-0138509',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00018,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,206.9275417,-1.64736,0.105,NULL,43609767609,681402618,10646915,17),(113371,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113371,37.5,0.46,316,49287,70,NULL,NULL,'2MASX J13474305+0430488',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00016,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,206.9294583,4.51347,0,NULL,58450846533,913294477,14270226,17),(113372,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113372,35,0.46,100,49288,70,NULL,NULL,'IC 0939',NULL,'2015arXiv151105856S',2015,1,1.02,NULL,'G',0.000073,NULL,'14.0g',1.01,'E0','Group member',NULL,NULL,NULL,1,206.9297083,3.41147,0.02,NULL,58451509406,913304834,14270388,14),(113373,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113373,35.52,0.54,127,49289,70,NULL,NULL,'ESO 383- G 079',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00006,NULL,'15.34',0.2,'(R)SB0^+:',NULL,NULL,NULL,NULL,1,206.929833,-33.19711,0.205,NULL,46899297802,732801528,11450023,15.34),(113374,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113374,37.91,0.46,382,49290,70,NULL,NULL,'2MASX J13474349+3417239',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000154,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,206.9312083,34.29,0,NULL,59182788014,924731062,14448922,17.2),(113375,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:31','1','SN 1998bi','R',113375,42.24,NULL,1600,49291,65,NULL,'SALT','H-ZSNS J134744.72+022057.2',0.75,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,206.936333,2.34922,0.045,NULL,58446327827,913223872,14269123,NULL),(113376,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:31','1','SN 1998bi',NULL,113376,42.53,0.14,1830,49291,74.2,NULL,'SALT 2','H-ZSNS J134744.72+022057.2',0.75,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113377,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:31','1','SN 1998bi',NULL,113377,43.17,0.14,2460,49291,70,NULL,'SALT','H-ZSNS J134744.72+022057.2',0.75,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113378,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:31','1','SN 1998bi',NULL,113378,43.34,0.11,2660,49291,65,NULL,'SALT','H-ZSNS J134744.72+022057.2',0.75,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113379,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:31','1','SN 1998bi',NULL,113379,43.35,0.3,2670,49291,65,NULL,NULL,'H-ZSNS J134744.72+022057.2',0.75,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113380,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113380,34.65,0.2,85.1,49292,74.4,NULL,NULL,'UGC 08720',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'14.97',0.5,'S?',NULL,NULL,NULL,NULL,1,206.937375,17.71911,0,NULL,58379829887,912184841,14252888,14.97),(113381,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113381,31.87,0.4,23.7,49293,NULL,NULL,'mean','NGC 5303',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000023,NULL,'12.2B',0.4,'Pec','Pair member (points to parent)',NULL,NULL,NULL,1,206.9374583,38.30464,0,NULL,59146485926,924163842,14440060,12.2),(113382,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113382,32.03,0.46,25.4,49293,NULL,NULL,'J','NGC 5303',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113383,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113383,32.06,0.47,25.9,49293,NULL,NULL,'H','NGC 5303',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113384,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113384,32.06,0.45,25.9,49293,NULL,NULL,'K','NGC 5303',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113385,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113385,37.51,0.09,318,49294,70,NULL,NULL,'2MASX J13474591+2620155',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000189,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,206.941167,26.33781,0,NULL,59126811457,923856429,14435256,16.9),(113386,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113386,37.73,0.12,352,49295,70,NULL,NULL,'SDSS J134746.62+281733.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000145,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,206.9442917,28.29275,0,NULL,59138628487,924041070,14438141,18.4),(113387,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113387,36.5,0.46,200,49296,70,NULL,NULL,'2MASX J13474689+5511201',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000175,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,206.945333,55.18883,0,NULL,57290906951,895170421,13987037,16.4),(113388,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113388,36.21,0.81,175,49297,70,NULL,NULL,'2MASX J13474740-3219445',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,206.9475417,-32.32903,0.225,NULL,46899792776,732809262,11450144,15.4),(113389,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113389,37.43,0.15,306,49298,70,NULL,NULL,'2MASX J13474774+0511578',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,206.948875,5.19933,0.035,NULL,58450315486,913286179,14270096,17.5),(113390,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113390,32.23,0.2,27.9,49299,74.4,NULL,NULL,'UGC 08726',NULL,'2013AJ....146...86T',2013,1,2.2,'Approximate center of the ill-defined bar.','G',0.000013,NULL,'15.00',0.4,'SB(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,206.955833,40.48611,0,NULL,59268192713,926065511,14469773,15),(113391,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113391,32.29,0.67,28.7,49299,NULL,NULL,NULL,'UGC 08726',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113392,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113392,32.33,0.4,29.2,49299,NULL,NULL,NULL,'UGC 08726',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113393,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113393,32.36,0.65,29.7,49299,NULL,NULL,'Malmquist cor.','UGC 08726',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113394,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113394,32.4,0.43,30.3,49299,75,NULL,'3.6 micron, color corrected','UGC 08726',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113395,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113395,32.49,0.43,31.5,49299,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08726',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113396,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113396,35.43,0.68,122,49300,70,NULL,NULL,'2MASX J13474895-3317245',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000014,NULL,'16.6b',NULL,'S0',NULL,NULL,NULL,NULL,1,206.953875,-33.29022,0.205,NULL,46899317752,732801839,11450028,16.6),(113397,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113397,35.55,0.25,129,49300,74.4,NULL,NULL,'2MASX J13474895-3317245',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113398,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113398,37.45,0.46,309,49301,70,NULL,NULL,'2MASX J13474911-0154389',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000213,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,206.95475,-1.91094,0.109,NULL,43609965917,681405717,10646964,17.6),(113399,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113399,36.08,0.52,164,49302,70,NULL,NULL,'2MASX J13474991-3311005',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000097,NULL,'14.92',NULL,NULL,NULL,NULL,NULL,NULL,1,206.9580417,-33.18356,0.205,NULL,46899293355,732801458,11450022,14.92),(113400,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113400,37.99,0.23,397,49303,70,NULL,NULL,'2MASX J13475069+0019018',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000077,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,206.961167,0.31714,0.057,NULL,58389687915,912338873,14255294,17.7),(113401,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113401,38.01,0.46,401,49304,70,NULL,NULL,'SDSS J134752.18+263935.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,206.967417,26.65992,0,NULL,59124675622,923823056,14434735,18.3),(113402,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113402,35.83,0.55,147,49305,70,NULL,NULL,'2MASX J13475310-3259025',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000025,NULL,'15.18',0.5,'S0',NULL,NULL,NULL,NULL,1,206.97125,-32.984,0.161,NULL,46899767612,732808868,11450138,15.18),(113403,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113403,36.28,0.7,180,49306,70,NULL,NULL,'2MASX J13475330-1024174',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,206.972083,-10.40486,0.109,NULL,43690550283,682664848,10666638,16.5),(113404,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113404,38.11,0.46,418,49307,70,NULL,NULL,'2MASX J13475433+3203520',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000183,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,206.976333,32.06456,0,NULL,59184065074,924751016,14449234,17.6),(113405,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113405,37.49,0.33,315,49308,70,NULL,NULL,'LCRS B134519.6-024231',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000163,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,206.978083,-2.95722,0.085,NULL,43609537883,681399029,10646859,16.7),(113406,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113406,34.56,0.4,81.8,49309,NULL,NULL,'mean','NGC 5305',NULL,'2007A&A...465...71T',2007,1,1.54,NULL,'G',0.000033,NULL,'14.0g',0.91,'SB(r)b',NULL,NULL,NULL,NULL,1,206.98225,37.82633,0,NULL,59147424095,924178501,14440289,14),(113407,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113407,34.96,0.47,98.3,49309,NULL,NULL,'H','NGC 5305',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113408,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113408,34.98,0.45,99.2,49309,NULL,NULL,'K','NGC 5305',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113409,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113409,35.05,0.46,102,49309,NULL,NULL,'J','NGC 5305',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113410,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113410,37.73,0.12,352,49310,70,NULL,NULL,'2MASX J13475585+2804335',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000177,NULL,'17.6',0.2,NULL,NULL,NULL,NULL,NULL,1,206.98275,28.07592,0,NULL,59138505127,924039142,14438111,17.6),(113411,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113411,37.43,0.15,306,49311,70,NULL,NULL,'2MASX J13475617+0503048',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,206.984041667,5.05125,0.035,NULL,58450369030,913287016,14270109,17.1),(113412,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113412,37.51,0.09,318,49312,70,NULL,NULL,'2MASX J13475769+2637335',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000077,NULL,'17.97',0.16,NULL,NULL,NULL,NULL,NULL,1,206.99025,26.626,0,NULL,59124642639,923822541,14434727,17.97),(113413,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113413,37.13,0.74,266,49313,70,NULL,NULL,'2MASX J13475849-3252075',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00011,NULL,'15.59',NULL,NULL,NULL,NULL,NULL,NULL,1,206.9937083,-32.86872,0.161,NULL,46899747073,732808548,11450133,15.59),(113414,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113414,36.7,0.46,218,49314,70,NULL,NULL,'2MASX J13475905+4437442',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00017,NULL,'16.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,206.99625,44.62894,0,NULL,59261734778,925964605,14468196,16.6),(113415,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113415,36.86,0.33,235,49315,70,NULL,NULL,'2MASX J13475975+4502362',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000165,NULL,'15.6g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,206.99875,45.04353,0,NULL,59316451475,926819554,14481555,15.6),(113416,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113416,38.72,0.46,556,49316,70,NULL,NULL,'SDSS J134800.46-005552.4',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00008,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,207.0019583,-0.93122,0.129,NULL,43562749216,680667956,10635436,17.9),(113417,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113417,36.24,0.46,177,49317,70,NULL,NULL,'2MASX J13480060+1939452',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'16.28',0.18,NULL,NULL,NULL,NULL,NULL,1,207.0027083,19.66253,0.006,NULL,58324458751,911319667,14239369,16.28),(113418,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113418,37.44,0.61,308,49318,70,NULL,NULL,'2MASX J13480197-1025264',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.31',NULL,NULL,NULL,NULL,NULL,NULL,1,207.0082083,-10.42403,0.113,NULL,43690553039,682664891,10666638,16.31),(113419,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113419,36.75,0.46,224,49319,70,NULL,NULL,'2MASX J13480243+5300144',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000182,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,207.010041667,53.004,0,NULL,59216444775,925256949,14457139,16.2),(113420,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113420,38.73,0.46,557,49320,70,NULL,NULL,'SDSS J134802.65+384221.4',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000199,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,207.0110417,38.70594,0,NULL,59267333508,926052086,14469563,17.2),(113421,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113421,35.27,0.55,113,49321,70,NULL,NULL,'2MASX J13480284-3047015',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.98',0.4,'S0',NULL,NULL,NULL,NULL,1,207.011875,-30.78383,0.157,NULL,46852828186,732075440,11438678,15.98),(113422,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113422,37.75,0.33,355,49322,70,NULL,NULL,'2MASX J13480432+3337449',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,207.017917,33.62903,0,NULL,59183678257,924744972,14449140,17.7),(113423,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113423,36.47,0.54,196,49323,70,NULL,NULL,'2MASX J13480447-1008304',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.01',NULL,NULL,NULL,NULL,NULL,NULL,1,207.018583,-10.142,0.113,NULL,43701914022,682842406,10669412,16.01),(113424,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113424,35.92,0.52,152,49324,70,NULL,NULL,'2MASX J13480452-3321025',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'14.35',NULL,NULL,NULL,NULL,NULL,NULL,1,207.01875,-33.35067,0.205,NULL,46899329986,732802031,11450031,14.35),(113425,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113425,37.5,0.46,317,49325,70,NULL,NULL,'2MASX J13480472+2019052',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,207.0197083,20.31803,0.016,NULL,58332743223,911449112,14241392,17.2),(113426,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113426,37.12,0.27,266,49326,70,NULL,NULL,'2MASX J13480504+1819162',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.54',0.18,NULL,NULL,NULL,NULL,NULL,1,207.0210417,18.32108,0,NULL,58325491719,911335808,14239622,16.54),(113427,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113427,36.45,0.46,195,49327,70,NULL,NULL,'2MASX J13480511+0448272',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000174,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,207.021375,4.80742,0.024,NULL,58450506439,913289163,14270143,17.1),(113428,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113428,38.08,0.46,414,49328,70,NULL,NULL,'2MASX J13480524+3231199',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000162,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,207.021875,32.52217,0,NULL,59184865699,924763526,14449430,17.9),(113429,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113429,36.33,0.65,184,49329,70,NULL,NULL,'2MASX J13480562-3244385',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000047,NULL,'14.7I',0.3,NULL,NULL,NULL,NULL,NULL,1,207.023375,-32.744,0.161,NULL,46899858587,732810290,11450160,14.7),(113430,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113430,36.72,0.74,221,49330,70,NULL,NULL,'2MASX J13480594-1615430',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.13',NULL,NULL,NULL,NULL,NULL,NULL,1,207.0245417,-16.26192,0.297,NULL,43677859921,682466561,10663540,16.13),(113431,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113431,37.38,0.19,300,49331,70,NULL,NULL,'2MASX J13480596+5605580',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000188,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,207.024917,56.09936,0,NULL,57288012049,895125188,13986331,16.6),(113432,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113432,36.03,0.25,161,49332,74.4,NULL,NULL,'2MASX J13480613-3230335',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000017,NULL,'15.9b',NULL,'E',NULL,NULL,NULL,NULL,1,207.025625,-32.50928,0.173,NULL,46899826825,732809794,11450153,15.9),(113433,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113433,36.13,0.5,168,49332,70,NULL,NULL,'2MASX J13480613-3230335',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113434,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113434,38.18,0.33,433,49333,70,NULL,NULL,'2MASX J13480634+0049202',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000097,NULL,'17.0g',0.26,'AGN',NULL,NULL,NULL,NULL,1,207.0265,0.82228,0,NULL,58389292621,912332697,14255198,17),(113435,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113435,36.87,0.46,237,49334,70,NULL,NULL,'2MASX J13480712+1644277',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,207.029583,16.74097,0,NULL,58380236603,912191196,14252987,17.4),(113436,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113436,37.51,0.09,318,49335,70,NULL,NULL,'2MASX J13480743+2628542',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000107,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,207.0310417,26.48189,0,NULL,59124695788,923823371,14434740,16.9),(113437,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113437,37.75,0.33,355,49336,70,NULL,NULL,'2MASX J13480784+3336014',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'17.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,207.032625,33.60033,0,NULL,59183497980,924742155,14449096,17.4),(113438,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113438,37.49,0.33,315,49337,70,NULL,NULL,'LCRS B134533.1-023600',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,207.034166667,-2.84847,0.085,NULL,43609539255,681399050,10646860,18.2),(113439,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113439,37.43,0.15,306,49338,70,NULL,NULL,'2MASX J13480838+0507372',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,207.034833333,5.12706,0.035,NULL,58436490127,913070158,14266721,17.8),(113440,'TRGB','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113440,27.75,0.14,3.55,49339,NULL,NULL,'I','Cen N',NULL,'2009AJ....138..332J',2009,1,0.9,NULL,'G',NULL,NULL,'17.5',0.7,NULL,'Brightest group member',NULL,NULL,NULL,1,207.038375,-47.565,0.605,NULL,46817177894,731518404,11429975,17.5),(113441,'TRGB','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113441,27.82,0.11,3.66,49339,NULL,NULL,NULL,'Cen N',NULL,'2015ApJ...802L..25T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113442,'TRGB','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113442,27.82,NULL,3.67,49339,NULL,NULL,NULL,'Cen N',NULL,'2007AJ....133..504K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113443,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113443,37.95,0.46,388,49340,70,NULL,NULL,'2MASX J13480953-0027036',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000076,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,207.0397917,-0.45089,0.049,NULL,43562399530,680662492,10635351,17.4),(113444,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113444,37.98,0.46,395,49341,70,NULL,NULL,'2MASX J13480960+3855283',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000177,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,207.040041667,38.92447,0,NULL,59267297427,926051522,14469555,17.8),(113445,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113445,38.32,0.46,462,49342,70,NULL,NULL,'2MASX J13480976+3430425',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,207.040667,34.51186,0,NULL,59182917127,924733080,14448954,17.9),(113446,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113446,35.14,0.46,106,49343,70,NULL,NULL,'CGCG 045-106',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000074,NULL,'15.5g',0.49,'S0',NULL,NULL,NULL,NULL,1,207.044667,2.85289,0.006,NULL,58446106305,913220411,14269068,15.5),(113447,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113447,36.38,0.46,189,49344,70,NULL,NULL,'2MASX J13481123+1229557',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000166,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,207.046917,12.49881,0,NULL,58335658458,911494663,14242104,16.3),(113448,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113448,37.12,0.27,266,49345,70,NULL,NULL,'2MASX J13481185+1813421',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,207.0492917,18.22847,0,NULL,58323381260,911302832,14239106,17.6),(113449,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113449,37.43,0.12,306,49346,70,NULL,NULL,'2MASX J13481274+4556267',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,207.053,45.94061,0,NULL,59315865309,926810395,14481412,16.9),(113450,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113450,37.73,0.12,352,49347,70,NULL,NULL,'2MASX J13481367+2806222',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000175,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,207.057125,28.10631,0,NULL,59138504652,924039135,14438111,16.7),(113451,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113451,34.82,0.62,91.9,49348,70,NULL,NULL,'2MASX J13481399-3322547',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000019,NULL,'15.5b',NULL,'cD;S0','Brightest group member',NULL,NULL,NULL,1,207.058333,-33.38192,0.205,NULL,46899321254,732801894,11450029,15.5),(113452,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113452,35.29,0.25,114,49348,74.4,NULL,NULL,'2MASX J13481399-3322547',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113453,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113453,37.43,0.12,306,49349,70,NULL,NULL,'2MASXi J1348140+454946',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,207.058416667,45.82958,0,NULL,59316086022,926813844,14481466,17.3),(113454,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113454,36.57,0.21,206,49350,70,NULL,NULL,'VV 190b',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00014,NULL,'16.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,207.059,25.73278,0,NULL,59123215530,923800242,14434378,16.1),(113455,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113455,38.37,0.23,472,49351,70,NULL,NULL,'SDSS J134814.20+335304.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000145,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,207.0592083,33.88469,0,NULL,59183637236,924744331,14449130,18.4),(113456,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113456,37.13,0.46,267,49352,70,NULL,NULL,'2MASX J13481467-0212156',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,207.06125,-2.20447,0.105,NULL,43609884630,681404447,10646944,16.4),(113457,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113457,36.21,0.46,174,49353,70,NULL,NULL,'2MASX J13481499+2718192',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'17.75',0.18,NULL,NULL,NULL,NULL,NULL,1,207.062625,27.30539,0,NULL,59124968613,923827634,14434806,17.75),(113458,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113458,37.51,0.09,318,49354,70,NULL,NULL,'SDSS J134815.23+264223.3',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00008,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,207.0635,26.7065,0,NULL,59124662615,923822853,14434732,17.8),(113459,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113459,37.74,0.21,354,49355,70,NULL,NULL,'2MASX J13481530+3220555',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000123,NULL,'16.8g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,207.063625,32.34881,0,NULL,59185705611,924776650,14449635,16.8),(113460,'BCG','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113460,38.36,0.35,433,49356,60,NULL,'ABELL 1793, BCG','2MASX J13481555+3214595',0.0849,'1980ApJ...241..486H',1980,1,0.39,NULL,'G',0.000067,NULL,'16.9g',0.27,NULL,'Brightest group member',NULL,NULL,NULL,1,207.0649583,32.24986,0,NULL,59185181843,924768466,14449507,16.9),(113461,'IRAS','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113461,31.33,0.8,18.4,49357,75,NULL,'A82, H','NGC 5300',NULL,'1997ApJS..109..333W',1997,1,3.9,NULL,'G',0.00002,NULL,'12.1B',2.6,'SAB(r)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,207.066833,3.95086,0.013,NULL,58451676647,913307447,14270428,12.1),(113462,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113462,29.48,0.69,7.88,49357,100,NULL,'mid-IR','NGC 5300',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113463,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113463,30.91,0.4,15.2,49357,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5300',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113464,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113464,31.21,0.43,17.5,49357,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5300',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113465,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113465,31.25,0.43,17.8,49357,75,NULL,'3.6 micron, color corrected','NGC 5300',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113466,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113466,31.33,0.2,18.5,49357,74.4,NULL,NULL,'NGC 5300',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113467,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113467,31.44,0.38,19.4,49357,NULL,NULL,NULL,'NGC 5300',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113468,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113468,31.5,0.49,19.9,49357,NULL,NULL,'Malmquist cor.','NGC 5300',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113469,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113469,31.58,0.4,20.7,49357,NULL,NULL,'mean','NGC 5300',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113470,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113470,31.59,0.47,20.8,49357,NULL,NULL,NULL,'NGC 5300',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113471,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113471,31.67,NULL,21.6,49357,72,NULL,NULL,'NGC 5300',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113472,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113472,31.82,0.4,23.1,49357,75,NULL,'B','NGC 5300',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113473,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113473,31.83,0.47,23.2,49357,75,NULL,'A82, H, raw','NGC 5300',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113474,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113474,31.85,0.47,23.5,49357,75,NULL,'A82, H, inv','NGC 5300',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113475,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113475,31.88,0.47,23.8,49357,NULL,NULL,'H','NGC 5300',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113476,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113476,31.9,0.45,24,49357,NULL,NULL,'K','NGC 5300',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113477,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113477,31.94,0.46,24.4,49357,NULL,NULL,'J','NGC 5300',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113478,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113478,31.96,0.47,24.7,49357,75,NULL,'A82, H, cor','NGC 5300',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113479,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113479,32.48,0.4,31.3,49358,NULL,NULL,'mean','UGC 08737',NULL,'2007A&A...465...71T',2007,1,2.2,NULL,'G',0.000057,NULL,'14.65',0.4,'Sbc',NULL,NULL,NULL,NULL,1,207.0695,68.085,0.045,NULL,57900735282,904698988,14135921,14.65),(113480,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113480,32.68,0.43,34.4,49358,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08737',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113481,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113481,32.84,0.43,37,49358,75,NULL,'3.6 micron, color corrected','UGC 08737',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113482,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113482,32.9,0.45,38,49358,NULL,NULL,'K','UGC 08737',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113483,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113483,32.93,0.47,38.5,49358,NULL,NULL,'H','UGC 08737',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113484,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113484,32.98,0.4,39.4,49358,NULL,NULL,NULL,'UGC 08737',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113485,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113485,33.03,0.46,40.3,49358,NULL,NULL,'J','UGC 08737',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113486,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113486,33.05,0.2,40.7,49358,74.4,NULL,NULL,'UGC 08737',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113487,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113487,33.08,0.42,41.4,49358,NULL,NULL,'Malmquist cor.','UGC 08737',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113488,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113488,33.19,0.4,43.5,49358,75,NULL,NULL,'UGC 08737',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113489,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113489,33.26,0.38,45,49358,NULL,NULL,NULL,'UGC 08737',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113490,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113490,33.33,0.49,46.3,49358,75,NULL,'IR','UGC 08737',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113491,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113491,37.46,0.33,310,49359,70,NULL,NULL,'2MASX J13481680+1308577',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000184,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,207.07,13.14928,0,NULL,58350106081,911720407,14245631,16.5),(113492,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113492,36.57,0.21,206,49360,70,NULL,NULL,'2MASX J13481758+2540163',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'16.6g',NULL,NULL,NULL,NULL,NULL,NULL,1,207.07325,25.67117,0,NULL,59123206178,923800096,14434376,16.6),(113493,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113493,37.51,0.09,318,49361,70,NULL,NULL,'SDSS J134818.23+263905.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000171,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,207.076,26.6515,0,NULL,59124634595,923822415,14434725,18.4),(113494,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113494,37.73,0.12,352,49362,70,NULL,NULL,'SDSS J134819.26+275424.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000173,NULL,'18.3g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,207.0802917,27.90672,0,NULL,59138456141,924038377,14438099,18.3),(113495,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113495,37.37,0.46,299,49363,70,NULL,NULL,'2MASX J13482049+6557370',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000088,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,207.085541667,65.96031,0.033,NULL,57880138419,904377162,14130893,17.1),(113496,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113496,37.46,0.33,310,49364,70,NULL,NULL,'2MASX J13482056+1309457',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,207.085833,13.16278,0,NULL,58350094522,911720226,14245628,17.8),(113497,'BCG','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113497,38.36,0.35,433,49365,60,NULL,NULL,'ABELL 1793',0.0849,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,207.086,32.28492,0,NULL,59185699800,924776559,14449633,NULL),(113498,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113498,37.43,0.12,306,49366,70,NULL,NULL,'2MASX J13482068+4609097',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000194,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,207.0862083,46.15275,0.038,NULL,59282335398,926286490,14473226,16.3),(113499,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113499,37.5,0.46,317,49367,70,NULL,NULL,'2MASX J13482100+1111349',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000143,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,207.087583,11.19308,0.034,NULL,58454558652,913352478,14271132,17.1),(113500,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113500,37.74,0.21,354,49368,70,NULL,NULL,'2MASX J13482124+3212536',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,207.0884583,32.21503,0,NULL,59185182216,924768472,14449507,18),(113501,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113501,37.53,0.46,320,49369,70,NULL,NULL,'2MASX J13482125+2555143',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,207.08875,25.92067,0,NULL,59123231989,923800499,14434382,17.6),(113502,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113502,37.71,0.46,349,49370,70,NULL,NULL,'2MASX J13482199+5752242',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,207.091708333,57.8735,0.005,NULL,57297633710,895275526,13988680,17.6),(113503,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113503,31.09,NULL,16.5,49371,72,NULL,NULL,'SDSS J134822.75+081241.7',NULL,'2014Ap.....57..457K',2014,1,0.27,NULL,'G',0.000065,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,207.094833333,8.21161,0.01,NULL,58428699715,912948433,14264819,17.8),(113504,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113504,37.43,0.12,306,49372,70,NULL,NULL,'2MASX J13482280+4609417',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000177,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,207.095083,46.16153,0.038,NULL,59282337352,926286521,14473226,16.6),(113505,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113505,35.29,0.55,115,49373,70,NULL,NULL,'2MASX J13482379-4858561',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000097,NULL,'15.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,207.0990417,-48.98222,0.641,NULL,46820174646,731565228,11430706,15.5),(113506,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113506,38.07,0.46,412,49374,70,NULL,NULL,'2MASX J13482445+1630187',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,207.102041667,16.50514,0,NULL,58378123632,912158181,14252471,17.7),(113507,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113507,37.43,0.15,306,49375,70,NULL,NULL,'2MASX J13482465+0502292',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000105,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,207.102667,5.04153,0.018,NULL,58436511136,913070486,14266726,17.2),(113508,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113508,36.57,0.21,206,49376,70,NULL,NULL,'SDSS J134825.35+253639.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00017,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,207.105625,25.61108,0,NULL,59123384790,923802887,14434420,17.7),(113509,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113509,32.82,NULL,36.7,49377,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 577- G 038',NULL,'2010Ap&SS.325..163P',2010,1,1.38,NULL,'G',0.000007,NULL,'16.52',0.11,'Sd',NULL,NULL,NULL,NULL,1,207.107083,-18.87222,0.265,NULL,43632690008,681760781,10652512,16.52),(113510,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113510,32.84,NULL,36.9,49377,NULL,NULL,'Dipole + Quadrupole','ESO 577- G 038',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113511,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113511,32.84,NULL,37,49377,NULL,NULL,'Dipole','ESO 577- G 038',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113512,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113512,32.88,NULL,37.6,49377,NULL,NULL,NULL,'ESO 577- G 038',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113513,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113513,37.74,0.21,354,49378,70,NULL,NULL,'2MASX J13482604+3214216',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00011,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,207.108583,32.23939,0,NULL,59185179835,924768434,14449506,16.9),(113514,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113514,36.88,0.46,237,49379,70,NULL,NULL,'2MASXi J1348269+475825',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,207.1122917,47.97389,0.01,NULL,59214469857,925226091,14456657,17.8),(113515,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:31','1','SN 1996cn',NULL,113515,41.07,0.47,1140,49380,74.2,NULL,'SALT 2','H-ZSNS J134827.22+022746.6',0.43,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,'S0',NULL,NULL,NULL,NULL,1,207.113416667,2.46294,0.025,NULL,58446241810,913222528,14269102,NULL),(113516,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:31','1','SN 1996cn',NULL,113516,41.89,0.39,1670,49380,70,NULL,'SALT','H-ZSNS J134827.22+022746.6',0.43,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113517,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:31','1','SN 1996cn','R',113517,41.89,NULL,1670,49380,65,NULL,'SALT','H-ZSNS J134827.22+022746.6',0.43,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113518,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:31','1','SN 1996cn',NULL,113518,41.98,0.37,1740,49380,65,NULL,'SALT','H-ZSNS J134827.22+022746.6',0.43,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113519,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113519,34.82,0.48,91.8,49381,70,NULL,NULL,'2MASX J13482728-3553437',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000137,NULL,'16.1b',NULL,'S0',NULL,NULL,NULL,NULL,1,207.113708333,-35.8955,0.197,NULL,46886907602,732607931,11446998,16.1),(113520,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113520,37.81,0.46,365,49382,70,NULL,NULL,'2MASX J13482735+5802112',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,207.1140417,58.03658,0.005,NULL,57296604179,895259440,13988428,17.5),(113521,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113521,36.48,0.46,197,49383,70,NULL,NULL,'2MASX J13482859+3604116',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000176,NULL,'16.1g',0.33,NULL,NULL,NULL,NULL,NULL,1,207.1190417,36.06986,0,NULL,59145898608,924154665,14439916,16.1),(113522,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113522,37.51,0.09,318,49384,70,NULL,NULL,'2MASX J13482872+2644513',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000073,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,207.119833333,26.74781,0,NULL,59124657726,923822776,14434730,17.4),(113523,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113523,38.18,0.33,433,49385,70,NULL,NULL,'2MASX J13482930+0047305',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000072,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,207.122,0.79186,0,NULL,58389253346,912332083,14255188,18.2),(113524,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113524,37.17,0.46,271,49386,70,NULL,NULL,'2MASX J13482949-0131497',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000142,NULL,'16.3g',0.34,'S0',NULL,NULL,NULL,NULL,1,207.122958333,-1.53033,0.097,NULL,43611857025,681435266,10647426,16.3),(113525,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113525,36.57,0.21,206,49387,70,NULL,NULL,'2MASX J13482971+2543183',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,207.123833333,25.72181,0,NULL,59123220440,923800319,14434379,16.7),(113526,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113526,37.74,0.21,354,49388,70,NULL,NULL,'2MASX J13482990+3216006',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00012,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,207.1247083,32.26678,0,NULL,59185180208,924768440,14449506,16.9),(113527,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113527,36.99,0.54,250,49389,70,NULL,NULL,'2MASX J13483100-3035357',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.61',NULL,'E',NULL,NULL,NULL,NULL,1,207.129167,-30.59331,0.153,NULL,46852801774,732075027,11438672,15.61),(113528,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113528,37.49,0.46,314,49390,70,NULL,NULL,'SDSS J134831.11+081741.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000176,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,207.129667,8.29492,0.01,NULL,58428573728,912946464,14264788,17.5),(113529,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113529,36.51,0.89,200,49391,70,NULL,NULL,'2MASX J13483199-3242587',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000083,NULL,'14.5I',0.2,NULL,NULL,NULL,NULL,NULL,1,207.133333,-32.71625,0.173,NULL,46900527203,732820737,11450324,14.5),(113530,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113530,37.43,0.15,306,49392,70,NULL,NULL,'2MASX J13483297+0456045',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000189,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,207.1374583,4.93458,0.018,NULL,58450349391,913286709,14270104,17.3),(113531,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113531,37.11,0.46,264,49393,70,NULL,NULL,'2MASX J13483301+5459282',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,207.1377917,54.99111,0,NULL,57290628121,895166064,13986969,17),(113532,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113532,37.3,0.46,288,49394,70,NULL,NULL,'2MASX J13483328+0228325',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000097,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,207.138583,2.47564,0.025,NULL,58446680849,913229388,14269209,16.8),(113533,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113533,37.51,0.09,318,49395,70,NULL,NULL,'2MASX J13483335+2625373',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000083,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,207.139041667,26.42714,0,NULL,59124528931,923820764,14434699,17.4),(113534,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113534,37.58,0.46,328,49396,70,NULL,NULL,'2MASX J13483335+1222081',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000133,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,207.139083333,12.36903,0,NULL,58335460918,911491576,14242055,17.5),(113535,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113535,36.66,0.46,215,49397,70,NULL,NULL,'2MASX J13483349+0123575',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000074,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,207.139583,1.39922,0.005,NULL,58444017791,913187777,14268559,17.2),(113536,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113536,37.34,0.46,294,49398,70,NULL,NULL,'2MASX J13483443+1355181',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,207.1435,13.92183,0.005,NULL,58350577715,911727776,14245746,17.1),(113537,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113537,37.51,0.09,318,49399,70,NULL,NULL,'2MASX J13483521+2630073',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000083,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,207.1467083,26.50203,0,NULL,59124710287,923823598,14434743,17.4),(113538,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113538,35.83,0.46,147,49400,70,NULL,NULL,'IC 0941',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000077,NULL,'15.2',0.4,NULL,NULL,NULL,NULL,NULL,1,207.1485,24.01508,0,NULL,59458682176,929041909,14516279,15.2),(113539,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113539,37.74,0.21,354,49401,70,NULL,NULL,'2MASX J13483613+3212396',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000153,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,207.1505417,32.21097,0,NULL,59185179070,924768422,14449506,17.1),(113540,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113540,33.08,0.5,41.3,49402,70,NULL,NULL,'NGC 5298',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000033,NULL,'14.0',0.7,'SB(r)bc','in a pair',NULL,NULL,NULL,1,207.1520417,-30.42853,0.137,NULL,46853129976,732080155,11438752,14),(113541,'IRAS','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113541,33.92,0.8,60.7,49402,75,NULL,'MAT, I','NGC 5298',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113542,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113542,33.25,0.47,44.6,49402,NULL,NULL,'H','NGC 5298',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113543,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113543,33.28,0.46,45.2,49402,NULL,NULL,'J','NGC 5298',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113544,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113544,33.29,0.45,45.6,49402,NULL,NULL,'K','NGC 5298',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113545,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113545,33.97,0.4,62.3,49402,NULL,NULL,'mean','NGC 5298',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113546,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113546,34.14,0.43,67.4,49402,75,NULL,'MAT, I, raw','NGC 5298',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113547,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113547,34.23,0.32,70.3,49402,85,NULL,'I, raw','NGC 5298',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113548,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113548,34.29,0.43,72.1,49402,75,NULL,'MAT, I, cor','NGC 5298',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113549,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113549,34.32,0.32,73.1,49402,85,NULL,'I, inv','NGC 5298',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113550,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113550,34.43,0.07,77.1,49402,NULL,NULL,NULL,'NGC 5298',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113551,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113551,34.48,0.43,78.7,49402,75,NULL,'MAT, I, inv','NGC 5298',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113552,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113552,37.03,0.6,255,49403,70,NULL,NULL,'2MASX J13483670-4958530',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,207.153,-49.98131,0.817,NULL,46821306877,731582919,11430983,17.1),(113553,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113553,37.51,0.09,318,49404,70,NULL,NULL,'2MASX J13483824+2711233',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000178,NULL,'18.33',0.16,NULL,NULL,NULL,NULL,NULL,1,207.159375,27.18994,0,NULL,59125005083,923828204,14434815,18.33),(113554,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113554,38.39,0.46,476,49405,70,NULL,NULL,'2MASX J13483828+1909584',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,207.159458333,19.16628,0,NULL,58325103793,911329746,14239527,18.1),(113555,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113555,37.52,0.46,319,49406,70,NULL,NULL,'2MASX J13483870+3146526',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000177,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,207.161167,31.78147,0,NULL,59184232969,924753640,14449275,16.5),(113556,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113556,32.38,0.4,29.9,49407,NULL,NULL,NULL,'UGC 08733',NULL,'2009AJ....138..323T',2009,1,2.3,NULL,'G',0.00002,NULL,'14.1',1.5,'SBcd:          Sbrst','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,207.162083,43.41239,0,NULL,59263083778,925985684,14468526,14.1),(113557,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113557,32.39,0.43,30.1,49407,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08733',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113558,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113558,32.42,0.43,30.5,49407,75,NULL,'3.6 micron, color corrected','UGC 08733',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113559,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113559,32.45,0.2,30.9,49407,74.4,NULL,NULL,'UGC 08733',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113560,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113560,32.55,0.45,32.3,49407,NULL,NULL,'Malmquist cor.','UGC 08733',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113561,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113561,32.65,0.43,33.9,49407,NULL,NULL,NULL,'UGC 08733',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113562,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113562,32.89,0.4,37.8,49407,75,NULL,'B','UGC 08733',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113563,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113563,33.55,0.23,51.3,49408,74.4,NULL,NULL,'ESO 445- G 040',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000014,NULL,'14.16',0.4,'SAB(r)0^0^','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,207.163167,-30.81072,0.153,NULL,46852864703,732076010,11438687,14.16),(113564,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113564,34.44,0.47,77.4,49408,70,NULL,NULL,'ESO 445- G 040',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113565,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113565,32.97,0.45,39.3,49408,NULL,NULL,'K','ESO 445- G 040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113566,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113566,34.27,0.4,71.3,49408,NULL,NULL,'mean','ESO 445- G 040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113567,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113567,37.73,0.12,352,49409,70,NULL,NULL,'2MASX J13483957+2755557',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,207.164875,27.93228,0,NULL,59137730011,924027031,14437922,17.7),(113568,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113568,37.93,0.46,386,49410,70,NULL,NULL,'2MASX J13484025+4353367',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000174,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,207.167833,43.89353,0,NULL,59265012329,926015817,14468997,16.8),(113569,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113569,38.14,0.46,425,49411,70,NULL,NULL,'2MASX J13484112+1225241',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,207.17125,12.42325,0,NULL,58349108143,911704814,14245387,17.3),(113570,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113570,37.33,0.46,292,49412,70,NULL,NULL,'2MASX J13484130-0142047',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,207.17225,-1.70125,0.097,NULL,43612094470,681438976,10647484,17.2),(113571,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113571,37.43,0.15,306,49413,70,NULL,NULL,'2MASX J13484167+0514015',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000187,NULL,'16.1g',0.4,'AGN',NULL,NULL,NULL,NULL,1,207.173583,5.23364,0.031,NULL,58436534188,913070846,14266731,16.1),(113572,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113572,37.51,0.09,318,49414,70,NULL,NULL,'2MASX J13484268+2631027',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000083,NULL,'18.29',0.15,NULL,NULL,NULL,NULL,NULL,1,207.177917,26.51739,0,NULL,59124702310,923823473,14434741,18.29),(113573,'IRAS','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113573,34.35,0.8,74,49415,75,NULL,'HMCL, I','IC 4327',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'14.50',0.6,'SB(s)c?        HII','Brightest group member',NULL,NULL,NULL,1,207.1825,-30.2175,0.137,NULL,46853642906,732088170,11438877,14.5),(113574,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113574,33.88,0.4,59.7,49415,75,NULL,'HMCL, I, raw','IC 4327',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113575,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113575,33.99,0.4,62.7,49415,75,NULL,'HMCL, I, inv','IC 4327',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113576,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113576,34,0.4,63,49415,75,NULL,'HMCL, I, cor','IC 4327',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113577,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113577,34.16,0.09,68.1,49415,NULL,NULL,NULL,'IC 4327',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113578,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113578,37.59,0.46,330,49416,70,NULL,NULL,'2MASX J13484393+1741091',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.04',0.14,NULL,NULL,NULL,NULL,NULL,1,207.183167,17.68589,0,NULL,58379949127,912186705,14252917,18.04),(113579,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113579,36.61,0.58,210,49417,70,NULL,NULL,'2MASX J13484404-2901342',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.2b',NULL,'E',NULL,NULL,NULL,NULL,1,207.1834583,-29.02625,0.237,NULL,46856256468,732129007,11439515,16.2),(113580,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113580,37.51,0.09,318,49418,70,NULL,NULL,'2MASX J13484525+2644527',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000077,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,207.1885417,26.74811,0,NULL,59124685856,923823216,14434737,17.2),(113581,'TRGB','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113581,27.91,0.1,3.82,49419,74.4,NULL,NULL,'LEDA 166179',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',NULL,NULL,'17.3B',1,'dwarf Sph?',NULL,NULL,NULL,NULL,1,207.193333,-46.99611,0.709,NULL,46817779452,731527803,11430121,17.3),(113582,'TRGB','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113582,27.91,0.11,3.82,49419,NULL,NULL,NULL,'LEDA 166179',NULL,'2015ApJ...802L..25T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113583,'TRGB','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113583,28,NULL,3.98,49419,NULL,NULL,NULL,'LEDA 166179',NULL,'2002A&A...385...21K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113584,'TRGB','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113584,28.02,0.07,4.02,49419,NULL,NULL,'I','LEDA 166179',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113585,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113585,36.3,0.65,182,49420,70,NULL,NULL,'2MASX J13484668-3233481',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,207.194583,-32.56342,0.173,NULL,46900534480,732820851,11450325,14.3),(113586,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113586,37.43,0.15,306,49421,70,NULL,NULL,'SDSS J134846.87+045722.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,207.1952917,4.95617,0.018,NULL,58436570417,913071412,14266740,17.9),(113587,'TRGB','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113587,28.8,NULL,5.75,49422,NULL,NULL,NULL,'HIPASS J1348-37',NULL,'2007AJ....133..504K',2007,1,0.5,NULL,'G',0.000026,NULL,'16.9',0.4,NULL,NULL,NULL,NULL,NULL,1,207.195833,-37.97461,0.209,NULL,46885691264,732588926,11446701,16.9),(113588,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113588,38.33,0.46,464,49423,70,NULL,NULL,'2MASX J13484704+3628296',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000127,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,207.1962083,36.47494,0,NULL,59145398234,924146847,14439794,17.6),(113589,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113589,36.92,0.46,243,49424,70,NULL,NULL,'2MASX J13484740+2840248',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000167,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,207.1975,28.67364,0,NULL,59138564544,924040071,14438126,16.8),(113590,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113590,36.07,0.63,164,49425,70,NULL,NULL,'2MASX J13484864-0923597',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.21',NULL,NULL,NULL,NULL,NULL,NULL,1,207.202791667,-9.40006,0.093,NULL,43701699861,682839060,10669360,16.21),(113591,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113591,36.9,0.46,240,49426,70,NULL,NULL,'2MASX J13484943+1258331',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,207.205833,12.97592,0,NULL,58350024198,911719128,14245611,17.2),(113592,'Faber-Jackson','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113592,31.74,1.1,22.3,49427,95,NULL,'de Vaucouleurs','NGC 5302',NULL,'1984ApJS...56...91D',1984,1,1.8,NULL,'G',0.00005,NULL,'13.05',1.1,'SAB(rl)a:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,207.207,-30.51111,0.137,NULL,46853914672,732092416,11438944,13.05),(113593,'Faber-Jackson','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113593,32.92,0.41,38.4,49427,95,NULL,'Weighted Mean','NGC 5302',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113594,'Faber-Jackson','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113594,33.45,0.46,49,49427,95,NULL,'Michard 1979a','NGC 5302',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113595,'Faber-Jackson','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113595,33.74,0.63,56,49427,95,NULL,'Michard 1979b, c','NGC 5302',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113596,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113596,33.62,0.48,52.8,49427,70,NULL,NULL,'NGC 5302',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113597,'Tertiary','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113597,33.2,0.5,43.7,49427,95,NULL,NULL,'NGC 5302',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113598,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113598,37.03,0.46,254,49428,70,NULL,NULL,'2MASX J13485024+3512159',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,207.2095,35.20442,0,NULL,59152323205,924255050,14441485,17),(113599,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113599,35.09,0.56,104,49429,70,NULL,NULL,'2MASX J13485033-3309071',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000067,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,207.2097917,-33.15197,0.201,NULL,46899737940,732808405,11450131,14.4),(113600,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113600,37.16,0.46,270,49430,70,NULL,NULL,'2MASX J13485043-0111456',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000089,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,207.21,-1.19594,0.133,NULL,43608475380,681382427,10646600,17),(113601,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113601,37.63,0.46,336,49431,70,NULL,NULL,'2MASXi J1348515+311924',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,207.2149583,31.32356,0,NULL,59128708890,923886076,14435719,18),(113602,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113602,38.37,0.23,472,49432,70,NULL,NULL,'2MASX J13485188+3354219',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,207.2162083,33.90606,0,NULL,59183674205,924744909,14449139,18),(113603,'BCG','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113603,37.41,0.35,285,49433,60,NULL,'ABELL 1795, BCG','CGCG 162-010',0.0631,'1980ApJ...241..486H',1980,1,1,NULL,'G',0.00003,NULL,'15.2',1,'cD;S0?;LINER   Sy3','Brightest group member',NULL,NULL,'LINER',1,207.218875,26.59269,0,NULL,59124730744,923823917,14434748,15.2),(113604,'BCG','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113604,37.41,0.35,285,49434,60,NULL,NULL,'ABELL 1795',0.0631,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',0.000294,NULL,NULL,NULL,'I      [BM]',NULL,NULL,NULL,NULL,1,207.220833,26.59556,0,NULL,59124730700,923823917,14434748,NULL),(113605,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113605,37.2,0.46,276,49435,70,NULL,NULL,'2MASX J13485316+0059515',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000083,NULL,'16.6g',0.31,'S0',NULL,NULL,NULL,NULL,1,207.221583,0.99772,0.017,NULL,58389392918,912334264,14255222,16.6),(113606,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113606,37.1,0.46,263,49436,70,NULL,NULL,'2MASX J13485374+1909481',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'16.19',0.22,NULL,NULL,NULL,NULL,NULL,1,207.223833,19.16328,0,NULL,58323207426,911300116,14239064,16.19),(113607,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113607,36.55,0.46,205,49437,70,NULL,NULL,'2MASX J13485433+4445505',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000161,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,207.226375,44.76397,0,NULL,59261778475,925965288,14468207,16.7),(113608,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113608,37.76,0.46,357,49438,70,NULL,NULL,'2MASX J13485464+3028420',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,207.2277083,30.47833,0,NULL,59131101622,923923462,14436304,17.8),(113609,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113609,37.51,0.09,318,49439,70,NULL,NULL,'2MASX J13485549+2636598',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000097,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,207.231333333,26.61675,0,NULL,59124741581,923824087,14434751,16.8),(113610,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113610,38.12,0.46,420,49440,70,NULL,NULL,'2MASX J13485559+1304021',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,207.231583333,13.06728,0,NULL,58350029114,911719204,14245612,17.8),(113611,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113611,37.51,0.09,318,49441,70,NULL,NULL,'2MASX J13485607+2654238',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000077,NULL,'17.79',0.2,NULL,NULL,NULL,NULL,NULL,1,207.233625,26.90669,0,NULL,59124564414,923821318,14434708,17.79),(113612,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113612,37.71,0.46,348,49442,70,NULL,NULL,'2MASX J13485668+2633368',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000087,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,207.236167,26.56031,0,NULL,59124731170,923823924,14434748,17.6),(113613,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113613,35.99,0.25,158,49443,74.4,NULL,NULL,'2MASX J13485806-3251252',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000017,NULL,'14.39',NULL,'E',NULL,NULL,NULL,NULL,1,207.241875,-32.85694,0.173,NULL,46900624685,732822260,11450347,14.39),(113614,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113614,36.07,0.55,164,49443,70,NULL,NULL,'2MASX J13485806-3251252',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113615,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113615,37.76,0.46,356,49444,70,NULL,NULL,'SDSS J134858.11+013959.9',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000076,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,207.242167,1.66667,0,NULL,58447080095,913235626,14269306,17.6),(113616,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113616,37.51,0.09,318,49445,70,NULL,NULL,'2MASX J13485899+2633368',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00011,NULL,'15.0',0.32,NULL,NULL,NULL,NULL,NULL,1,207.245875,26.56033,0,NULL,59124731383,923823927,14434748,15),(113617,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113617,37.55,0.46,323,49446,70,NULL,NULL,'2MASX J13485920-0028438',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00008,NULL,'17.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,207.24675,-0.47886,0.061,NULL,43563087017,680673234,10635519,17.3),(113618,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113618,38.37,0.23,472,49447,70,NULL,NULL,'2MASX J13485927+3354170',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000171,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,207.247208333,33.90475,0,NULL,59183672154,924744877,14449138,17.9),(113619,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113619,34.81,0.47,91.8,49448,NULL,NULL,'H','MCG -01-35-013',NULL,'2007A&A...465...71T',2007,1,2.1,NULL,'G',0.000033,NULL,'15.12',0.4,'Sb             AGN','in a triple',NULL,NULL,NULL,1,207.24775,-7.19494,0.029,NULL,43578723780,680917559,10639336,15.12),(113620,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113620,34.86,0.45,93.7,49448,NULL,NULL,'K','MCG -01-35-013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113621,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113621,34.86,0.49,93.9,49448,75,NULL,'IR','MCG -01-35-013',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113622,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113622,34.95,0.46,97.6,49448,NULL,NULL,'Malmquist cor.','MCG -01-35-013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113623,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113623,35.07,0.46,103,49448,NULL,NULL,'J','MCG -01-35-013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113624,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113624,35.15,0.4,107,49448,NULL,NULL,'mean','MCG -01-35-013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113625,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113625,35.2,0.41,110,49448,NULL,NULL,NULL,'MCG -01-35-013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113626,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113626,35.24,0.2,112,49448,74.4,NULL,NULL,'MCG -01-35-013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113627,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113627,37.58,0.46,328,49449,70,NULL,NULL,'2MASX J13485961+2938338',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'18.56',0.16,NULL,NULL,NULL,NULL,NULL,1,207.2485417,29.64261,0,NULL,59130267976,923910437,14436100,18.56),(113628,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113628,37.12,0.46,265,49450,70,NULL,NULL,'2MASX J13490109+2209421',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.53',0.13,NULL,NULL,NULL,NULL,NULL,1,207.2545,22.16161,0,NULL,58321783037,911277859,14238716,18.53),(113629,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113629,37.77,0.33,358,49451,70,NULL,NULL,'2MASX J13490142+3053410',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,207.256083,30.89478,0,NULL,59128839671,923888119,14435751,17.9),(113630,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113630,34.98,0.5,98.9,49452,70,NULL,NULL,'ESO 325- G 025',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00014,NULL,'14.69',1,'S0',NULL,NULL,NULL,NULL,1,207.25725,-41.93411,0.313,NULL,46922626541,733166039,11455719,14.69),(113631,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113631,37.48,0.46,313,49453,70,NULL,NULL,'2MASX J13490214-0114398',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000079,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,207.2589583,-1.24436,0.133,NULL,43608482929,681382545,10646602,17.3),(113632,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113632,37.32,0.46,291,49454,70,NULL,NULL,'2MASX J13490345+2508138',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,207.264583,25.13714,0,NULL,59995939782,937436559,14647446,17.4),(113633,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113633,37.13,0.33,267,49455,70,NULL,NULL,'2MASX J13490470+0651358',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'17.02',0.26,NULL,NULL,NULL,NULL,NULL,1,207.269583,6.85986,0.011,NULL,58430723688,912980057,14265313,17.02),(113634,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113634,37.11,0.46,265,49456,70,NULL,NULL,'2MASX J13490470+5414138',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000141,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,207.269667,54.23722,0,NULL,57284460065,895069688,13985463,17.5),(113635,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113635,38.02,0.46,402,49457,70,NULL,NULL,'2MASX J13490474+3645559',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,207.2697083,36.76553,0,NULL,59145293254,924145207,14439768,17.3),(113636,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113636,37.51,0.09,318,49458,70,NULL,NULL,'2MASX J13490496+2628148',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00009,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,207.270541667,26.47078,0,NULL,59124532138,923820814,14434700,16.7),(113637,'D-Sigma','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113637,33.74,0.22,56,49459,NULL,NULL,'ABELL 3574, 7 galaxies','IC 4329',NULL,'2000ApJ...529..768K',2000,1,3.4,NULL,'G',0.000028,NULL,'12.2',1.9,'SAB(s)0-;cD    Sy1','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,207.272125,-30.29586,0.137,NULL,46853646724,732088230,11438878,12.2),(113638,'D-Sigma','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113638,33.93,0.14,61.1,49459,72,NULL,'ABELL 3574 = KLEMOLA 27 Cluster, 10 galaxies','IC 4329',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113639,'Faber-Jackson','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113639,32.88,0.34,37.7,49459,95,NULL,'Weighted Mean','IC 4329',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113640,'Faber-Jackson','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113640,32.95,0.46,38.9,49459,95,NULL,'Michard 1979a','IC 4329',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113641,'Faber-Jackson','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113641,33.16,0.55,42.9,49459,95,NULL,'de Vaucouleurs','IC 4329',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113642,'Faber-Jackson','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113642,33.34,0.63,46.6,49459,95,NULL,'Michard 1979b, c','IC 4329',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113643,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113643,33.56,0.21,51.6,49459,NULL,NULL,'ABELL 3574, 7 galaxies','IC 4329',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113644,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113644,33.66,0.23,54,49459,NULL,NULL,'ABELL 3574, 7 galaxies','IC 4329',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113645,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113645,33.67,0.46,54.1,49459,70,NULL,NULL,'IC 4329',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113646,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113646,33.75,0.16,56.2,49459,75,NULL,'ABELL 3574, 7 galaxies','IC 4329',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113647,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113647,33.75,0.16,56.2,49459,75,NULL,'ABELL 3574 Cluster, 7 galaxies','IC 4329',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113648,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113648,34.01,0.23,63.4,49459,74.4,NULL,NULL,'IC 4329',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113649,'Tertiary','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113649,33.2,0.5,43.7,49459,95,NULL,NULL,'IC 4329',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113650,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113650,33.44,0.45,48.7,49459,NULL,NULL,'K','IC 4329',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113651,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113651,33.97,NULL,62.2,49459,71,NULL,'ABELL 3574, 11 galaxies','IC 4329',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113652,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113652,34.03,0.3,64.1,49459,NULL,NULL,'ABELL 3574, 14 galaxies','IC 4329',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113653,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113653,34.07,0.4,65.2,49459,NULL,NULL,'mean','IC 4329',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113654,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113654,35.64,0.46,134,49460,70,NULL,NULL,'CGCG 045-111',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000096,NULL,'15.3g',0.53,'S0/a',NULL,NULL,NULL,NULL,1,207.273417,2.92631,0.016,NULL,58446591076,913227985,14269187,15.3),(113655,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113655,37.13,0.33,267,49461,70,NULL,NULL,'SDSS J134907.51+064957.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.7g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,207.281333,6.83269,0.011,NULL,58430722414,912980037,14265313,17.7),(113656,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113656,36.03,0.39,161,49462,NULL,NULL,'Malmquist cor.','ESO 445- G 047',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.00',0.1,'Sb:            HII?',NULL,NULL,NULL,NULL,1,207.28225,-32.72639,0.173,NULL,46900656554,732822758,11450355,16),(113657,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113657,36.3,0.34,182,49462,NULL,NULL,NULL,'ESO 445- G 047',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113658,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113658,36.34,0.2,185,49462,74.4,NULL,NULL,'ESO 445- G 047',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113659,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113659,35.86,0.76,148,49463,70,NULL,NULL,'2MASX J13490801-3213291',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.5b',NULL,'E',NULL,NULL,NULL,NULL,1,207.283458333,-32.22469,0.237,NULL,46900275349,732816802,11450262,16.5),(113660,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113660,37.56,0.46,325,49464,70,NULL,NULL,'2MASX J13490825+4348255',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000163,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,207.2845,43.80714,0,NULL,59265226638,926019166,14469049,16.8),(113661,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113661,37.77,0.33,358,49465,70,NULL,NULL,'SDSS J134908.67+305138.9',NULL,'2015arXiv151105856S',2015,1,0.46,'May be a radio component of IRAS F13468+3107.','G',0.000227,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,207.286167,30.86083,0,NULL,59128837637,923888088,14435751,16.4),(113662,'IRAS','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113662,32.65,0.8,33.8,49466,75,NULL,'MAT, I','ESO 221- G 002',NULL,'1997ApJS..109..333W',1997,1,1.9,'Confused HIPASS source','G',0.00002,NULL,'14.74',0.6,'SB(s)dm',NULL,NULL,NULL,NULL,1,207.28725,-48.63003,0.601,NULL,46820925814,731576965,11430890,14.74),(113663,'Tully est','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113663,32.95,0.8,38.9,49466,75,NULL,'B','ESO 221- G 002',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113664,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113664,31.65,0.32,21.4,49466,85,NULL,'I, inv','ESO 221- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113665,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113665,31.67,0.32,21.6,49466,85,NULL,'I, raw','ESO 221- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113666,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113666,31.98,0.43,24.9,49466,75,NULL,'MAT, I, inv','ESO 221- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113667,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113667,32,0.43,25.2,49466,75,NULL,'MAT, I, raw','ESO 221- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113668,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113668,32.34,0.72,29.4,49466,NULL,NULL,NULL,'ESO 221- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113669,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113669,32.39,0.2,30.1,49466,74.4,NULL,NULL,'ESO 221- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113670,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113670,32.39,0.43,30.1,49466,75,NULL,'MAT, I, cor','ESO 221- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113671,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113671,32.81,0.58,36.5,49466,NULL,NULL,'Malmquist cor.','ESO 221- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113672,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113672,36.61,0.46,210,49467,70,NULL,NULL,'2MASX J13490893+2145270',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.27',0.16,NULL,NULL,NULL,NULL,NULL,1,207.287333,21.75758,0.006,NULL,58320922177,911264409,14238506,18.27),(113673,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113673,37.51,0.09,318,49468,70,NULL,NULL,'2MASX J13490900+2648128',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,207.2875417,26.80356,0,NULL,59124688859,923823263,14434738,17.4),(113674,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113674,37.3,0.46,288,49469,70,NULL,NULL,'SDSS J134909.03+093341.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'17.6g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,207.287625,9.56139,0,NULL,58467493849,913554591,14274290,17.6),(113675,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113675,36.62,0.99,211,49470,70,NULL,NULL,'2MASX J13490908-1942450',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.4,NULL,NULL,NULL,NULL,NULL,1,207.287917,-19.71244,0.233,NULL,43637015767,681828371,10653568,14.3),(113676,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113676,36.05,0.57,162,49471,70,NULL,NULL,'ESO 383- G 085',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000107,NULL,'15.31',0.2,'S0-a',NULL,NULL,NULL,NULL,1,207.288625,-33.09528,0.201,NULL,46900589601,732821712,11450339,15.31),(113677,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113677,37.47,0.46,312,49472,70,NULL,NULL,'2MASX J13490964+0404487',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000188,NULL,'16.7g',0.31,'AGN',NULL,NULL,NULL,NULL,1,207.290125,4.08008,0.03,NULL,58450924728,913295698,14270245,16.7),(113678,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113678,34.95,0.45,97.8,49473,NULL,NULL,'K','PGC 049039',NULL,'2007A&A...465...71T',2007,1,NULL,'Part of the GTrpl VV 135.','GPair',0.000087,NULL,NULL,NULL,'S0 pec?',NULL,NULL,NULL,NULL,1,207.294167,-7.21139,0.029,NULL,43578734166,680917721,10639339,NULL),(113679,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113679,35.09,0.4,104,49473,NULL,NULL,'mean','PGC 049039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113680,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113680,37.83,0.46,368,49474,70,NULL,NULL,'2MASX J13491060+1408492',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,207.294208333,14.14697,0.01,NULL,58347650769,911682043,14245031,17.5),(113681,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113681,37.65,0.46,339,49475,70,NULL,NULL,'2MASX J13491094-0206268',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000178,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,207.295625,-2.1075,0.109,NULL,43612232297,681441129,10647517,17),(113682,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113682,35.54,0.54,128,49476,70,NULL,NULL,'CGCG 017-072',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'15.9g',0.36,'S0',NULL,NULL,NULL,NULL,1,207.3007917,-2.42958,0.105,NULL,43611497336,681429645,10647338,15.9),(113683,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113683,37.48,0.46,313,49477,70,NULL,NULL,'2MASX J13491342+3133470',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000145,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,207.3059583,31.563,0,NULL,59184054163,924750846,14449231,17),(113684,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113684,37.26,0.11,283,49478,70,NULL,NULL,'2MASX J13491374+4612275',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,207.307208333,46.20761,0,NULL,59282357956,926286843,14473231,17.1),(113685,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113685,33.88,0.45,59.6,49479,NULL,NULL,'K','UGC 08739',NULL,'2007A&A...465...71T',2007,1,1.9,'87GB source with large sky, narrow minor axis, or very bad confusion.','G',0.00003,NULL,'14.57',0.4,'SB?            LIRG',NULL,NULL,NULL,NULL,1,207.3080417,35.25744,0,NULL,59152312573,924254883,14441482,14.57),(113686,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113686,33.93,0.47,61,49479,NULL,NULL,'H','UGC 08739',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113687,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113687,34.16,0.46,68,49479,NULL,NULL,'J','UGC 08739',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113688,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113688,34.27,0.4,71.3,49479,NULL,NULL,'mean','UGC 08739',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113689,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113689,38.08,0.46,414,49480,70,NULL,NULL,'SDSS J134914.47+073314.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,207.3102917,7.554,0.02,NULL,58428358920,912943108,14264736,18.4),(113690,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113690,35.55,0.51,129,49481,70,NULL,NULL,'ESO 383- G 086',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.97',0.2,'S0',NULL,NULL,NULL,NULL,1,207.310958333,-33.18506,0.201,NULL,46899724701,732808198,11450128,15.97),(113691,'SBF','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113691,32.47,0.23,31.2,49482,NULL,NULL,'I','NGC 5322',NULL,'2001ApJ...546..681T',2001,1,5.9,NULL,'G',0.000017,NULL,'11.14',3.9,'E3-4           LINER','in a radial-velocity based grouping',NULL,NULL,'Sy',1,207.313625,60.19053,0,NULL,57276346825,894942919,13983483,11.14),(113692,'SBF','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113692,32.47,0.23,31.2,49482,NULL,NULL,NULL,'NGC 5322',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113693,'SBF','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113693,32.52,0.14,31.9,49482,74.4,NULL,NULL,'NGC 5322',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113694,'SBF','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113694,32.56,0.23,32.6,49482,NULL,NULL,'Malmquist cor.','NGC 5322',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113695,'SBF','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113695,32.6,0.1,33.1,49482,NULL,NULL,NULL,'NGC 5322',NULL,'2005ApJ...634..239C',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113696,'D-Sigma','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113696,31.29,0.4,18.1,49482,75,NULL,'Edat, raw','NGC 5322',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113697,'D-Sigma','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113697,31.63,0.4,21.2,49482,75,NULL,'Edat, cor','NGC 5322',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113698,'Faber-Jackson','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113698,30.76,0.33,14.2,49482,95,NULL,'Weighted Mean','NGC 5322',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113699,'Faber-Jackson','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113699,30.85,0.81,14.8,49482,55,NULL,'Visvanathan & Sandage 1979','NGC 5322',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113700,'Faber-Jackson','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113700,30.94,0.71,15.4,49482,95,NULL,'de Vaucouleurs','NGC 5322',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113701,'Faber-Jackson','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113701,31.22,0.63,17.5,49482,95,NULL,'Michard 1979b, c','NGC 5322',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113702,'Faber-Jackson','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113702,31.38,0.46,18.9,49482,95,NULL,'Michard 1979a','NGC 5322',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113703,'Faber-Jackson','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113703,31.52,NULL,20.1,49482,NULL,NULL,'LEDA [April 2006]','NGC 5322',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113704,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113704,31.75,0.41,22.3,49482,NULL,NULL,NULL,'NGC 5322',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113705,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113705,32,0.41,25.2,49482,NULL,NULL,'Malmquist cor.','NGC 5322',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113706,'Tertiary','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113706,31.87,0.29,23.7,49482,95,NULL,NULL,'NGC 5322',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113707,'Tully est','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113707,32.5,0.8,31.6,49482,75,NULL,'B','NGC 5322',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113708,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113708,31.82,0.45,23.1,49482,NULL,NULL,'K','NGC 5322',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113709,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113709,32.26,0.4,28.3,49482,NULL,NULL,'mean','NGC 5322',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113710,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113710,37.73,0.12,352,49483,70,NULL,NULL,'2MASX J13491524+2809235',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000178,NULL,'18.53',0.16,NULL,NULL,NULL,NULL,NULL,1,207.313583,28.15656,0,NULL,59137767092,924027610,14437931,18.53),(113711,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113711,36.82,0.46,231,49484,70,NULL,NULL,'2MASX J13491569+1815502',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.12',0.15,NULL,NULL,NULL,NULL,NULL,1,207.31525,18.264,0,NULL,58323615317,911306489,14239163,18.12),(113712,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113712,37.51,0.09,318,49485,70,NULL,NULL,'2MASX J13491573+2638345',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000063,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,207.315625,26.64286,0,NULL,59124734205,923823971,14434749,17.1),(113713,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113713,36.88,0.46,238,49486,70,NULL,NULL,'2MASX J13491610+1824432',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.82',0.21,NULL,NULL,NULL,NULL,NULL,1,207.317,18.41197,0.009,NULL,58323628080,911306688,14239167,16.82),(113714,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113714,35.78,0.46,144,49487,70,NULL,NULL,'CGCG 295-016',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.00007,NULL,'14.8g',0.59,'E0',NULL,NULL,NULL,NULL,1,207.3185417,56.92778,0,NULL,57296030662,895250479,13988288,14.8),(113715,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113715,38,0.46,399,49488,70,NULL,NULL,'SDSS J134917.39+032432.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000072,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,207.3224583,3.40903,0.028,NULL,58449350194,913271096,14269860,18.4),(113716,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113716,36.6,0.46,209,49489,70,NULL,NULL,'2MASX J13491766+4018209',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000162,NULL,'16.0g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,207.323583,40.30597,0,NULL,59266841955,926044405,14469443,16),(113717,'TRGB','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113717,27.52,0.1,3.19,49490,74.4,NULL,NULL,'ESO 383- G 087',NULL,'2013AJ....146...86T',2013,1,4.5,NULL,'G',0.000003,NULL,'11.03',3.6,'SB(s)dm','Group member',NULL,NULL,NULL,1,207.322917,-36.06344,0.197,NULL,46886889219,732607644,11446994,11.03),(113718,'TRGB','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113718,27.52,0.11,3.19,49490,NULL,NULL,NULL,'ESO 383- G 087',NULL,'2015ApJ...802L..25T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113719,'TRGB','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113719,27.69,NULL,3.45,49490,NULL,NULL,NULL,'ESO 383- G 087',NULL,'2007AJ....133..504K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113720,'Tully est','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113720,26.39,0.8,1.9,49490,75,NULL,'B','ESO 383- G 087',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113721,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113721,26.69,NULL,2.18,49490,NULL,NULL,'LEDA [Oct 2006]','ESO 383- G 087',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113722,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113722,36.18,0.52,172,49491,70,NULL,NULL,'2MASX J13491794-3826563',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000025,NULL,'13.4I',0.6,NULL,NULL,NULL,NULL,NULL,1,207.324833333,-38.44897,0.245,NULL,46885631457,732587991,11446687,13.4),(113723,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113723,37.75,0.46,355,49492,70,NULL,NULL,'2MASX J13491828+1713292',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.50',0.14,NULL,NULL,NULL,NULL,NULL,1,207.326208333,17.22472,0,NULL,58380480298,912195004,14253046,18.5),(113724,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113724,37.91,0.27,382,49493,70,NULL,NULL,'2MASX J13491926+4033339',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000155,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,207.3302917,40.55928,0,NULL,59269973655,926093338,14470208,16.8),(113725,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113725,38.25,0.46,446,49494,70,NULL,NULL,'2MASX J13491971+4551354',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000175,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,207.3320417,45.86,0,NULL,59315911293,926811113,14481423,17.2),(113726,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113726,37.77,0.46,359,49495,70,NULL,NULL,'2MASX J13492009+1842022',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.11',0.14,NULL,NULL,NULL,NULL,NULL,1,207.3337917,18.70069,0,NULL,58323691066,911307672,14239182,18.11),(113727,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113727,37.99,0.33,395,49496,70,NULL,NULL,'2MASX J13492135+4301443',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000176,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,207.339,43.029,0,NULL,59263193331,925987395,14468553,17.3),(113728,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113728,37.73,0.12,352,49497,70,NULL,NULL,'2MASX J13492258+2802526',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00017,NULL,'17.5g',NULL,NULL,NULL,NULL,NULL,NULL,1,207.3442083,28.04803,0,NULL,59137770839,924027669,14437932,17.5),(113729,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113729,36.47,0.46,197,49498,70,NULL,NULL,'CGCG 162-012',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00015,NULL,'15.9g',0.41,'E',NULL,NULL,NULL,NULL,1,207.344916667,29.59317,0,NULL,59129938571,923905290,14436020,15.9),(113730,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113730,38.11,0.46,419,49499,70,NULL,NULL,'2MASX J13492271+5959138',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000109,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,207.344916667,59.98731,0,NULL,57276141354,894939708,13983432,17.9),(113731,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113731,37.73,0.12,352,49500,70,NULL,NULL,'2MASX J13492333+2815166',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000169,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,207.34725,28.25464,0,NULL,59137789111,924027954,14437936,17.9),(113732,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113732,37.73,0.12,352,49501,70,NULL,NULL,'UGC 08738',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000193,NULL,'15.31',0.4,'S0-?;BrClG     BLLAC',NULL,NULL,NULL,NULL,1,207.3482083,28.10736,0,NULL,59137763650,924027557,14437930,15.31),(113733,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113733,37.61,0.16,332,49502,70,NULL,NULL,'2MASX J13492418+2918006',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000165,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,207.3509583,29.30003,0,NULL,59129977714,923905901,14436029,17.6),(113734,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113734,37.91,0.46,382,49503,70,NULL,NULL,'2MASX J13492437+4010189',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000191,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,207.351583,40.17189,0,NULL,59266891639,926045181,14469455,16.7),(113735,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113735,37.51,0.09,318,49504,70,NULL,NULL,'2MASX J13492491+2629216',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00009,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,207.353917,26.48936,0,NULL,59124505668,923820401,14434693,16.8),(113736,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113736,37.73,0.12,352,49505,70,NULL,NULL,'2MASX J13492568+2805426',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00018,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,207.357,28.09511,0,NULL,59137763601,924027556,14437930,17.4),(113737,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113737,37.35,0.33,295,49506,70,NULL,NULL,'2MASX J13492580+1504339',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000204,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,207.357416667,15.07608,0.007,NULL,58347039008,911672484,14244882,16.5),(113738,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113738,37.73,0.12,352,49507,70,NULL,NULL,'2MASX J13492583+2756436',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000181,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,207.357625,27.9455,0,NULL,59137779555,924027805,14437934,17),(113739,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113739,38.37,0.23,472,49508,70,NULL,NULL,'2MASX J13492718+3357508',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000148,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,207.3632083,33.96408,0,NULL,59183550796,924742981,14449109,17.4),(113740,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113740,37.91,0.27,382,49509,70,NULL,NULL,'2MASX J13492724+4029534',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000153,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,207.3632917,40.49836,0,NULL,59273380303,926146567,14471040,17.5),(113741,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113741,35.67,0.16,136,49510,70,NULL,NULL,'2MASX J13492733+2501506',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000123,NULL,'16.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,207.3637917,25.03061,0,NULL,59996222356,937440974,14647515,16.6),(113742,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113742,37.86,0.46,372,49511,70,NULL,NULL,'2MASX J13492775+4323473',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,207.365833,43.39656,0,NULL,59263031357,925984864,14468513,18.1),(113743,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113743,36.21,0.46,175,49512,70,NULL,NULL,'SDSS J134928.65+160933.1',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.3g',0.25,'AGN',NULL,NULL,NULL,NULL,1,207.369375,16.15919,0,NULL,58377987111,912156048,14252438,16.3),(113744,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113744,37.74,0.27,354,49513,70,NULL,NULL,'2MASX J13492888+0532229',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000179,NULL,'17.2g',0.25,'AGN',NULL,NULL,NULL,NULL,1,207.3704583,5.53964,0.02,NULL,58436908770,913076699,14266823,17.2),(113745,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113745,37.3,0.46,288,49514,70,NULL,NULL,'2MASX J13492934+5728548',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000206,NULL,'15.8g',0.48,'E0',NULL,NULL,NULL,NULL,1,207.372375,57.482,0,NULL,57298320014,895286250,13988847,15.8),(113746,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113746,37.23,0.46,279,49515,70,NULL,NULL,'2MASX J13493090+2833496',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,207.379,28.56372,0,NULL,59138515008,924039297,14438114,17.6),(113747,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113747,37.73,0.12,352,49516,70,NULL,NULL,'2MASX J13493157+2800016',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000167,NULL,'15.7g',0.41,'cD',NULL,NULL,NULL,NULL,1,207.3815,28.00044,0,NULL,59137771724,924027683,14437932,15.7),(113748,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113748,37.74,0.27,354,49517,70,NULL,NULL,'2MASX J13493176+0531379',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000172,NULL,'16.5g',0.32,'BrClG          AGN',NULL,NULL,NULL,NULL,1,207.38225,5.52739,0.02,NULL,58436906016,913076656,14266822,16.5),(113749,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113749,37.93,0.46,385,49518,70,NULL,NULL,'2MASX J13493188+4418374',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,207.3829583,44.31056,0,NULL,59261683756,925963808,14468184,17.9),(113750,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113750,37.32,0.33,291,49519,70,NULL,NULL,'2MASX J13493219+2827246',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000155,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,207.384291667,28.45669,0,NULL,59137683372,924026302,14437910,17.3),(113751,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113751,36.07,0.46,163,49520,70,NULL,NULL,'2MASX J13493260+1140555',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'17.02',0.21,NULL,NULL,NULL,NULL,NULL,1,207.38575,11.68222,0,NULL,58465682499,913526289,14273848,17.02),(113752,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113752,37.51,0.09,318,49521,70,NULL,NULL,'2MASX J13493282+2647296',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000107,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,207.386708333,26.79156,0,NULL,59124597358,923821833,14434716,18),(113753,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113753,37.74,0.27,354,49522,70,NULL,NULL,'2MASX J13493283+0532419',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000189,NULL,'16.9g',0.29,'AGN',NULL,NULL,NULL,NULL,1,207.386833,5.54494,0.02,NULL,58436904955,913076639,14266822,16.9),(113754,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113754,37.6,0.46,331,49523,70,NULL,NULL,'2MASX J13493325+0110549',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000087,NULL,'16.6g',0.28,'S0',NULL,NULL,NULL,NULL,1,207.388666667,1.18183,0.025,NULL,58444191285,913190488,14268601,16.6),(113755,'IRAS','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113755,33.85,0.8,58.9,49524,75,NULL,'MAT, I','ESO 383- G 088',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000023,NULL,'14.16',0.7,'SAB(r)bc?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,207.389458333,-33.06911,0.201,NULL,46900589070,732821704,11450339,14.16),(113756,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113756,33.41,0.43,48,49524,75,NULL,'MAT, I, raw','ESO 383- G 088',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113757,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113757,33.41,0.32,48,49524,85,NULL,'I, raw','ESO 383- G 088',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113758,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113758,33.45,0.32,48.9,49524,85,NULL,'I, inv','ESO 383- G 088',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113759,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113759,33.5,0.2,50.1,49524,74.4,NULL,NULL,'ESO 383- G 088',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113760,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113760,33.57,0.43,51.8,49524,75,NULL,'3.6 micron, color corrected','ESO 383- G 088',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113761,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113761,33.6,0.43,52.4,49524,75,NULL,'MAT, I, inv','ESO 383- G 088',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113762,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113762,33.65,0.43,53.7,49524,75,NULL,'MAT, I, cor','ESO 383- G 088',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113763,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113763,33.71,0.43,55.2,49524,75,NULL,'3.6 micron, color + selection bias corrected','ESO 383- G 088',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113764,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113764,33.72,0.47,55.6,49524,NULL,NULL,'H','ESO 383- G 088',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113765,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113765,33.8,0.46,57.5,49524,NULL,NULL,'J','ESO 383- G 088',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113766,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113766,33.86,0.4,59.1,49524,NULL,NULL,'mean','ESO 383- G 088',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113767,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113767,33.87,0.45,59.4,49524,NULL,NULL,'K','ESO 383- G 088',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113768,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113768,34.26,0.08,71.3,49524,NULL,NULL,NULL,'ESO 383- G 088',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113769,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113769,37.92,0.33,384,49525,70,NULL,NULL,'SDSS J134933.60+384252.1',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000192,NULL,'16.6g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,207.39,38.71447,0,NULL,59267164740,926049449,14469522,16.6),(113770,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113770,37.99,0.33,395,49526,70,NULL,NULL,'SDSS J134933.85+425639.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00017,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,207.3910417,42.94436,0,NULL,59262724826,925980075,14468438,18.7),(113771,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113771,36.36,0.46,187,49527,70,NULL,NULL,'2MASX J13493391+1033435',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,207.3912917,10.56211,0,NULL,58467596948,913556202,14274315,16.8),(113772,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113772,38.26,0.46,448,49528,70,NULL,NULL,'2MASX J13493409+3137009',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,207.392166667,31.61717,0,NULL,59184049651,924750775,14449230,17.4),(113773,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113773,38.18,0.46,432,49529,70,NULL,NULL,'SDSS J134935.16+122041.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000165,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,207.396541667,12.345,0,NULL,58349117519,911704961,14245390,18.1),(113774,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113774,36.01,0.63,160,49530,70,NULL,NULL,'2MASX J13493600-2003263',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.17',0.3,NULL,NULL,NULL,NULL,NULL,1,207.4002083,-20.0575,0.213,NULL,43637128202,681830128,10653595,16.17),(113775,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113775,37.32,0.33,291,49531,70,NULL,NULL,'2MASX J13493605+2826256',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000182,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,207.400375,28.44039,0,NULL,59137682170,924026283,14437910,16.2),(113776,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113776,37.94,0.46,388,49532,70,NULL,NULL,'2MASX J13493625+1634540',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.11',0.16,NULL,NULL,NULL,NULL,NULL,1,207.401,16.58172,0,NULL,58378042415,912156912,14252451,18.11),(113777,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113777,37.05,0.46,257,49533,70,NULL,NULL,'2MASX J13493754+1702260',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,207.4065,17.04053,0,NULL,58380461511,912194711,14253042,17.4),(113778,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113778,37.88,0.46,377,49534,70,NULL,NULL,'2MASX J13493756+0802134',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000181,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,207.406583333,8.03703,0.016,NULL,58428320418,912942506,14264726,17.1),(113779,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113779,37.13,0.46,266,49535,70,NULL,NULL,'2MASX J13493766+3249059',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,207.406917,32.81839,0,NULL,59185676412,924776193,14449628,17.8),(113780,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113780,38.54,0.46,509,49536,70,NULL,NULL,'2MASX J13493769+6417290',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000086,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,207.406958333,64.29142,0.037,NULL,57868512883,904195513,14128054,18.5),(113781,'Tully est','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113781,32.89,0.8,37.8,49537,75,NULL,NULL,'UGC 08742',NULL,'1988NBGC.C....0000T',1988,1,0.77,NULL,'G',0.000017,NULL,'16.2g',0.48,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,207.407041667,38.92069,0,NULL,59267453610,926053962,14469593,16.2),(113782,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113782,32.25,0.4,28.2,49537,NULL,NULL,NULL,'UGC 08742',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113783,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113783,35.9,0.46,151,49538,70,NULL,NULL,'CGCG 162-013',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000153,NULL,'15.5g',0.51,'S0',NULL,NULL,NULL,NULL,1,207.4075,28.97211,0,NULL,59129801676,923903151,14435986,15.5),(113784,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113784,36.77,0.46,226,49539,70,NULL,NULL,'2MASX J13493780+3046059',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000083,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,207.4077083,30.76819,0,NULL,59130894457,923920225,14436253,16.2),(113785,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113785,36.14,0.46,169,49540,70,NULL,NULL,'2MASX J13493818+1838522',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'17.04',0.32,NULL,NULL,NULL,NULL,NULL,1,207.409167,18.64781,0.009,NULL,58323664168,911307252,14239175,17.04),(113786,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113786,36.96,0.46,246,49541,70,NULL,NULL,'2MASX J13493916+1757310',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.33',0.21,NULL,NULL,NULL,NULL,NULL,1,207.413208333,17.95867,0,NULL,58378900723,912170323,14252661,17.33),(113787,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113787,37.73,0.12,352,49542,70,NULL,NULL,'2MASX J13493928+2803585',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000193,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,207.4137083,28.06628,0,NULL,59137770105,924027657,14437932,17.2),(113788,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113788,37.74,0.46,353,49543,70,NULL,NULL,'2MASX J13494004+4617594',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,207.416833,46.29983,0,NULL,59282317467,926286210,14473222,17.7),(113789,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113789,37.51,0.09,318,49544,70,NULL,NULL,'2MASX J13494025+2621285',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.0001,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,207.417917,26.35806,0,NULL,59124507331,923820427,14434694,17.7),(113790,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113790,36.57,0.21,206,49545,70,NULL,NULL,'2MASX J13494201+2529045',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000155,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,207.4252083,25.48453,0,NULL,59996109401,937439209,14647487,16.7),(113791,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113791,36.88,0.65,238,49546,70,NULL,NULL,'2MASX J13494265-2721485',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.3b',NULL,'S0',NULL,NULL,NULL,NULL,1,207.427667,-27.36344,0.209,NULL,46845038324,731953723,11436776,16.3),(113792,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113792,37.43,0.15,306,49547,70,NULL,NULL,'2MASX J13494322+0514489',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000183,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,207.43,5.24683,0.035,NULL,58436477260,913069957,14266718,17.1),(113793,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113793,37.51,0.09,318,49548,70,NULL,NULL,'2MASX J13494338+2640271',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00008,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,207.430916667,26.67431,0,NULL,59124717644,923823713,14434745,17.5),(113794,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113794,37.26,0.46,284,49549,70,NULL,NULL,'LCRS B134708.7-024522',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,207.432833,-3.00392,0.085,NULL,43610825077,681419141,10647174,17.8),(113795,'Tully est','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113795,32.89,0.8,37.8,49550,75,NULL,'B','NGC 5313',NULL,'1988NBGC.C....0000T',1988,1,1.41,NULL,'G',0.000027,NULL,'12.6g',0.95,'Sb?','in a radial-velocity based grouping',NULL,NULL,NULL,1,207.43475,39.98478,0,NULL,59267043596,926047556,14469493,12.6),(113796,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113796,32.83,0.4,36.8,49550,NULL,NULL,'mean','NGC 5313',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113797,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113797,33.31,0.45,45.8,49550,NULL,NULL,'K','NGC 5313',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113798,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113798,33.31,0.47,45.9,49550,NULL,NULL,'H','NGC 5313',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113799,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113799,33.33,0.46,46.3,49550,NULL,NULL,'J','NGC 5313',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113800,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113800,33.33,0.43,46.4,49550,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5313',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113801,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113801,33.38,0.43,47.4,49550,75,NULL,'3.6 micron, color corrected','NGC 5313',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113802,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113802,33.55,0.2,51.3,49550,74.4,NULL,NULL,'NGC 5313',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113803,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113803,37.21,0.46,277,49551,70,NULL,NULL,'2MASX J13494474+5935298',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000178,NULL,'16.1g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,207.4362917,59.59153,0.005,NULL,57275644912,894931951,13983311,16.1),(113804,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113804,35.46,0.49,123,49552,70,NULL,NULL,'2MASX J13494594-3222568',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000022,NULL,'15.1b',NULL,'S0',NULL,NULL,NULL,NULL,1,207.441375,-32.38236,0.173,NULL,46900544071,732821001,11450328,15.1),(113805,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113805,35.88,0.25,150,49552,74.4,NULL,NULL,'2MASX J13494594-3222568',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113806,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113806,38.48,0.46,496,49553,70,NULL,NULL,'SDSS J134946.13+392218.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,207.4422083,39.37189,0,NULL,59267568963,926055765,14469621,18.6),(113807,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113807,37.23,0.46,280,49554,70,NULL,NULL,'2MASX J13494661+2024219',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.54',0.13,NULL,NULL,NULL,NULL,NULL,1,207.444167,20.40611,0.021,NULL,58333400714,911459386,14241552,18.54),(113808,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113808,37.96,0.46,391,49555,70,NULL,NULL,'2MASX J13494703+2712561',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,207.446,27.21575,0,NULL,59124836383,923825568,14434774,18.1),(113809,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113809,36.1,0.46,166,49556,70,NULL,NULL,'IC 4334',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000103,NULL,'15.4g',0.47,'S0?',NULL,NULL,NULL,NULL,1,207.451125,29.69408,0,NULL,59130361998,923911906,14436123,15.4),(113810,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113810,37.32,0.46,291,49557,70,NULL,NULL,'2MASX J13494835+3006409',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000142,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,207.4515417,30.11144,0,NULL,59130447598,923913243,14436144,18),(113811,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113811,35.31,0.7,115,49558,70,NULL,NULL,'2MASX J13494877-2936415',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000097,NULL,'15.61',NULL,'S0',NULL,NULL,NULL,NULL,1,207.4532917,-29.61156,0.221,NULL,46851800090,732059376,11438427,15.61),(113812,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113812,37.35,0.33,295,49559,70,NULL,NULL,'SDSS J134949.35+150926.2',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,207.455625,15.15731,0.007,NULL,58345026754,911641043,14244391,17.6),(113813,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113813,37.51,0.09,318,49560,70,NULL,NULL,'2MASX J13494960+2703571',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000143,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,207.4567917,27.06586,0,NULL,59124867059,923826047,14434781,16.5),(113814,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113814,38.24,0.46,445,49561,70,NULL,NULL,'SDSS J134950.48+185233.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.4g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,207.460375,18.87611,0,NULL,58323668706,911307323,14239176,18.4),(113815,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113815,37.25,0.46,282,49562,70,NULL,NULL,'2MASX J13495092+2850551',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000161,NULL,'18.52',0.16,NULL,NULL,NULL,NULL,NULL,1,207.4622083,28.8485,0,NULL,59129794334,923903036,14435984,18.52),(113816,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113816,37.61,0.16,332,49563,70,NULL,NULL,'2MASX J13495173+2908331',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000184,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,207.465667,29.14258,0,NULL,59129812800,923903325,14435989,17.1),(113817,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113817,37.92,0.33,384,49564,70,NULL,NULL,'2MASX J13495215+3841415',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,207.467333,38.69483,0,NULL,59267167681,926049495,14469523,17.6),(113818,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113818,38.57,0.46,517,49565,70,NULL,NULL,'2MASX J13495228+3815505',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000184,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,207.467875,38.264,0,NULL,59146914520,924170539,14440164,17.2),(113819,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113819,37.36,0.64,296,49566,70,NULL,NULL,'2MASX J13495250-0943278',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,207.4687083,-9.72436,0.085,NULL,43702332377,682848943,10669514,15.1),(113820,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113820,35.29,0.25,114,49567,74.4,NULL,NULL,'IC 4332',NULL,'2013AJ....146...86T',2013,1,0.77,NULL,'G',0.000053,NULL,'14.9g',0.75,'S',NULL,NULL,NULL,NULL,1,207.4689583,25.19089,0,NULL,59995930896,937436420,14647444,14.9),(113821,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113821,35.5,0.17,126,49567,70,NULL,NULL,'IC 4332',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113822,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113822,36.28,0.83,180,49568,70,NULL,NULL,'2MASX J13495287-1541371',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.26',NULL,NULL,NULL,NULL,NULL,NULL,1,207.4702083,-15.69369,0.217,NULL,43659747332,682183552,10659118,16.26),(113823,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113823,37.7,0.46,347,49569,70,NULL,NULL,'2MASX J13495364+1609130',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,207.4735417,16.15369,0,NULL,58378265821,912160403,14252506,18),(113824,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113824,37.84,0.46,370,49570,70,NULL,NULL,'2MASX J13495437+5141446',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000128,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,207.4765,51.69583,0,NULL,59221007273,925328238,14458253,18.3),(113825,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113825,37.44,0.46,308,49571,70,NULL,NULL,'2MASX J13495453+4421173',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,207.477166667,44.35478,0,NULL,59261692564,925963946,14468186,18),(113826,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113826,36.84,0.46,234,49572,70,NULL,NULL,'2MASX J13495466+4328563',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000163,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,207.477833,43.48225,0,NULL,59265062190,926016596,14469009,17.1),(113827,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113827,37.51,0.09,318,49573,70,NULL,NULL,'2MASX J13495544+2708512',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000187,NULL,'15.7g',0.54,NULL,NULL,NULL,NULL,NULL,1,207.481083,27.14758,0,NULL,59124871673,923826119,14434783,15.7),(113828,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113828,35.21,0.68,110,49574,NULL,NULL,NULL,'ESO 577- G 039',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.05',0.9,'Sb',NULL,NULL,NULL,NULL,1,207.4832083,-22.27606,0.205,NULL,43624641674,681635026,10650547,15.05),(113829,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113829,35.23,0.68,111,49574,NULL,NULL,'Malmquist cor.','ESO 577- G 039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113830,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113830,35.25,0.2,112,49574,74.4,NULL,NULL,'ESO 577- G 039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113831,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113831,36.12,0.46,167,49575,70,NULL,NULL,'2MASX J13495604+0408236',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000161,NULL,'16.1g',0.43,'E0',NULL,NULL,NULL,NULL,1,207.4835417,4.13981,0,NULL,58449169239,913268269,14269816,16.1),(113832,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113832,37.56,0.46,326,49576,70,NULL,NULL,'2MASX J13495636+3026070',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000195,NULL,'17.76',0.21,NULL,NULL,NULL,NULL,NULL,1,207.484875,30.43539,0,NULL,59131166036,923924469,14436319,17.76),(113833,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113833,37.44,0.46,307,49577,70,NULL,NULL,'2MASX J13495890+3841445',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000185,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,207.495375,38.69567,0,NULL,59267156729,926049323,14469520,17.1),(113834,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113834,37.37,0.46,298,49578,70,NULL,NULL,'2MASX J13495918+0105236',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000078,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,207.496625,1.08975,0.025,NULL,58444045531,913188211,14268565,17),(113835,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113835,37.03,0.46,255,49579,70,NULL,NULL,'2MASX J13500040+2526462',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,207.5017917,25.44606,0,NULL,59996103939,937439124,14647486,17.3),(113836,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113836,37.54,0.46,321,49580,70,NULL,NULL,'2MASX J13500086+5920149',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000162,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,207.503583,59.33761,0.005,NULL,57267981123,894812205,13981440,17),(113837,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113837,37.56,0.46,324,49581,70,NULL,NULL,'SDSS J135001.16+110233.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000179,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,207.504875,11.04253,0,NULL,58466389481,913537335,14274020,18.2),(113838,'Tully est','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113838,32.68,0.8,34.4,49582,75,NULL,NULL,'UGCA 374',NULL,'1988NBGC.C....0000T',1988,1,0.9,NULL,'G',0.00002,NULL,NULL,0.9,'Im:',NULL,NULL,NULL,NULL,1,207.505833,62.72972,0.037,NULL,57260702712,894698479,13979663,NULL),(113839,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:31','1','SN 2005al',NULL,113839,33.95,0.01,61.7,49583,72,NULL,NULL,'NGC 5304',NULL,'2011AJ....141...19B',2011,1,1.5,NULL,'G',0.000014,NULL,'13.57',1,'E+ pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,207.506167,-30.57847,0.149,NULL,46853952071,732093001,11438953,13.57),(113840,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:31','1','SN 2005al',NULL,113840,34.03,0.18,62.3,49583,72,NULL,NULL,'NGC 5304',0.01329,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113841,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:31','1','SN 2005al',NULL,113841,34,0.03,62.4,49583,70,NULL,NULL,'NGC 5304',0.012402,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113842,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:31','1','SN 2005al',NULL,113842,33.98,0.09,62.5,49583,74.4,NULL,NULL,'NGC 5304',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113843,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:31','1','SN 2005al',NULL,113843,34.01,0.06,62.6,49583,72,NULL,NULL,'NGC 5304',0.012402,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113844,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:31','1','SN 2005al',NULL,113844,34.03,0.21,63.3,49583,70,NULL,'SALT 2','NGC 5304',0.012402,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113845,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:31','1','SN 2005al',NULL,113845,34.09,0.19,64.9,49583,73.8,NULL,'SALT 2 (SNANA)','NGC 5304',0.0123,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113846,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:31','1','SN 2005al',NULL,113846,34.09,0.2,65,49583,72,NULL,NULL,'NGC 5304',0.012402,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113847,'SNIa','2016-12-15 15:15:18','2016-12-16 11:20:31','1','SN 2005al',NULL,113847,34.07,0.06,65,49583,72,NULL,'M(H) = -18.317 mag','NGC 5304',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113848,'D-Sigma','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113848,33.45,0.4,48.9,49583,75,NULL,'Edat, raw','NGC 5304',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113849,'D-Sigma','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113849,33.7,0.4,54.9,49583,75,NULL,'Edat, cor','NGC 5304',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113850,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113850,33.79,0.5,57.4,49583,70,NULL,NULL,'NGC 5304',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113851,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113851,33.98,0.09,62.5,49583,74.4,NULL,NULL,'NGC 5304',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113852,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113852,33.75,0.4,56.2,49583,NULL,NULL,'mean','NGC 5304',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113853,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113853,34.23,0.45,70,49583,NULL,NULL,'K','NGC 5304',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113854,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113854,34.86,0.59,93.6,49584,70,NULL,NULL,'2MASX J13500164-3013316',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000073,NULL,'15.91',NULL,'S0',NULL,NULL,NULL,NULL,1,207.506833333,-30.2255,0.137,NULL,46854473067,732101141,11439080,15.91),(113855,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113855,38.45,0.46,489,49585,70,NULL,NULL,'2MASX J13500199+4100595',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000182,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,207.5085,41.01653,0,NULL,59270201779,926096902,14470264,18.4),(113856,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113856,38.05,0.46,408,49586,70,NULL,NULL,'SDSS J135002.54+322849.3',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.8g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,207.510625,32.48039,0,NULL,59185775641,924777744,14449652,16.8),(113857,'SGRB','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113857,41.92,NULL,2420,49587,70,NULL,'Amati relation, minimum D','GRB 080207',NULL,'2012A&A...545A..77R',2012,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,207.5122083,7.50219,0.008,NULL,58430428484,912975445,14265241,NULL),(113858,'SGRB','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113858,42.9,NULL,3800,49587,70,NULL,'Photometric Distance, Host A, M(R) = -20 mag and spectral slope Beta = 1.0 ','GRB 080207',NULL,'2012A&A...545A..77R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113859,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113859,35,0.49,99.9,49588,75,NULL,'IR','FGC 1674',NULL,'2011yCatp016004901K',2011,1,1.08,NULL,'G',0.000016,NULL,'16.60',0.11,'Sc',NULL,NULL,NULL,NULL,1,207.512333,15.90297,0,NULL,58378248377,912160130,14252502,16.6),(113860,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113860,35,NULL,100,49588,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1674',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113861,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113861,35.02,NULL,101,49588,NULL,NULL,'Dipole + Quadrupole','FGC 1674',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113862,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113862,35.03,NULL,102,49588,NULL,NULL,'Dipole','FGC 1674',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113863,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113863,35.06,NULL,103,49588,NULL,NULL,NULL,'FGC 1674',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113864,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113864,35.25,0.2,112,49588,74.4,NULL,NULL,'FGC 1674',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113865,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113865,36.56,0.46,206,49589,70,NULL,NULL,'2MASX J13500333+2955501',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,207.513875,29.93061,0,NULL,59130336902,923911514,14436117,16.9),(113866,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113866,37.59,0.33,330,49590,70,NULL,NULL,'2MASX J13500379+0721329',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.31',0.17,NULL,NULL,NULL,NULL,NULL,1,207.515875,7.359,0.008,NULL,58430412008,912975187,14265237,18.31),(113867,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113867,37.51,0.17,318,49591,70,NULL,NULL,'2MASX J13500396+0612299',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000174,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,207.516541667,6.20836,0,NULL,58429072817,912954262,14264910,17.4),(113868,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113868,37.93,0.46,386,49592,70,NULL,NULL,'2MASX J13500402+0813549',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000144,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,207.516958333,8.23203,0.023,NULL,58458520944,913414389,14272099,18.1),(113869,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113869,38.19,0.46,434,49593,70,NULL,NULL,'SDSS J135004.13+064210.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,207.51725,6.70292,0,NULL,58430274285,912973035,14265203,18.1),(113870,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113870,37.55,0.46,324,49594,70,NULL,NULL,'2MASX J13500473+3609297',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,207.5197083,36.15822,0,NULL,59145330495,924145788,14439777,18),(113871,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113871,37.42,0.46,305,49595,70,NULL,NULL,'2MASX J13500488+3222471',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000152,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,207.52025,32.37975,0,NULL,59185594879,924774919,14449608,16.9),(113872,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113872,37.37,0.46,298,49596,70,NULL,NULL,'2MASX J13500499+3604207',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'17.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,207.520833,36.0725,0,NULL,59152861188,924263456,14441616,17.1),(113873,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113873,37.91,0.27,382,49597,70,NULL,NULL,'SDSS J135005.36+403517.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000135,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,207.522333,40.58828,0,NULL,59273385309,926146645,14471041,18.6),(113874,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113874,37.59,0.33,330,49598,70,NULL,NULL,'2MASX J13500540+0720569',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,207.522375,7.34917,0.008,NULL,58430411900,912975185,14265237,17.9),(113875,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113875,37.51,0.17,318,49599,70,NULL,NULL,'2MASX J13500550+0606456',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.49',0.21,NULL,NULL,NULL,NULL,NULL,1,207.522875,6.11253,0.015,NULL,58429071282,912954238,14264909,17.49),(113876,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113876,37.33,0.46,293,49600,70,NULL,NULL,'2MASX J13500579+0746099',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000182,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,207.524208333,7.76936,0.019,NULL,58428485500,912945085,14264766,16.8),(113877,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113877,37.26,0.11,283,49601,70,NULL,NULL,'SDSS J135005.87+461047.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000168,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,207.5244583,46.17981,0,NULL,59282307965,926286061,14473219,18),(113878,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113878,37.67,0.17,342,49602,70,NULL,NULL,'2MASX J13500628+2818562',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000204,NULL,'15.8g',0.39,NULL,NULL,NULL,NULL,NULL,1,207.526291667,28.31564,0,NULL,59137840006,924028750,14437949,15.8),(113879,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113879,37.38,0.19,300,49603,70,NULL,NULL,'2MASX J13500783+5603039',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000184,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,207.5324583,56.05128,0,NULL,57295280646,895238760,13988105,17.4),(113880,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113880,37.92,0.46,383,49604,70,NULL,NULL,'2MASX J13500804+1110409',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,207.533458333,11.17803,0.027,NULL,58466390484,913537351,14274021,17.5),(113881,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113881,37.3,0.46,288,49605,70,NULL,NULL,'2MASX J13500811+3426371',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,207.533667,34.44372,0,NULL,59182833951,924731780,14448934,16.8),(113882,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113882,37.61,0.46,333,49606,70,NULL,NULL,'2MASX J13500850+4048328',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,207.535583,40.80914,0,NULL,59273417986,926147156,14471049,17.7),(113883,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113883,37.51,0.09,318,49607,70,NULL,NULL,'2MASX J13500858+2629442',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000097,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,207.535875,26.49572,0,NULL,59997720257,937464379,14647880,16.7),(113884,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113884,37.61,0.16,332,49608,70,NULL,NULL,'2MASX J13500899+2914182',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,207.537667,29.2385,0,NULL,59129821197,923903456,14435991,17.3),(113885,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113885,37.19,0.46,274,49609,70,NULL,NULL,'2MASX J13500923+0223066',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000085,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,207.5385417,2.38514,0.041,NULL,58446759773,913230621,14269228,17),(113886,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113886,36.58,0.65,207,49610,70,NULL,NULL,'LCRS B134733.9-033118',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.000117,NULL,'16.92',0.29,NULL,NULL,NULL,NULL,NULL,1,207.53975,-3.769,0.073,NULL,43619475537,681554305,10649286,16.92),(113887,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113887,35.53,0.54,127,49611,70,NULL,NULL,'2MASX J13500961-3101436',NULL,'2014MNRAS.445.2677S',2014,1,0.7,'1984A&AS...58..131R has V = 3722.','G',0.000083,NULL,'15.06',NULL,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,207.5399583,-31.02875,0.149,NULL,46853825538,732091024,11438922,15.06),(113888,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113888,35.72,0.58,139,49612,70,NULL,NULL,'2MASX J13500984-3104156',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.52',NULL,'S0',NULL,NULL,NULL,NULL,1,207.5410417,-31.07103,0.149,NULL,46853830339,732091099,11438923,16.52),(113889,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113889,34.4,0.46,75.9,49613,70,NULL,NULL,'CGCG 218-055',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000083,NULL,'14.7g',0.66,NULL,NULL,NULL,NULL,NULL,1,207.541375,38.21956,0,NULL,59146917903,924170592,14440165,14.7),(113890,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113890,37.73,0.12,352,49614,70,NULL,NULL,'2MASX J13501147+2759551',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,207.5477083,27.99858,0,NULL,59137805227,924028206,14437940,17.3),(113891,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113891,35.33,0.47,116,49615,70,NULL,NULL,'MCG -03-35-019',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'14.77',0.3,NULL,NULL,NULL,NULL,NULL,1,207.5485417,-19.79067,0.249,NULL,43637235104,681831798,10653621,14.77),(113892,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113892,37.61,0.16,332,49616,70,NULL,NULL,'2MASX J13501166+2912061',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,207.548667,29.20169,0,NULL,59129821970,923903468,14435991,17.2),(113893,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113893,37.51,0.17,318,49617,70,NULL,NULL,'2MASX J13501241+0609509',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000167,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,207.5517917,6.16425,0.015,NULL,58429073572,912954274,14264910,16.7),(113894,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113894,37.67,0.17,342,49618,70,NULL,NULL,'2MASX J13501308+2811171',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000097,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,207.5544583,28.188,0,NULL,59137850953,924028921,14437951,16.7),(113895,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113895,37.32,0.46,291,49619,70,NULL,NULL,'2MASX J13501310+0247256',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000093,NULL,'17.2g',0.19,'NLAGN',NULL,NULL,NULL,NULL,1,207.55475,2.79042,0.045,NULL,58444980872,913202826,14268794,17.2),(113896,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113896,37.67,0.17,342,49620,70,NULL,NULL,'B2 1347+28',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000193,NULL,'16.3g',0.33,'E',NULL,NULL,NULL,NULL,1,207.556625,28.27917,0,NULL,59137843099,924028798,14437949,16.3),(113897,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113897,36.34,0.46,185,49621,70,NULL,NULL,'2MASX J13501447+1620109',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.80',0.17,NULL,NULL,NULL,NULL,NULL,1,207.5602917,16.33628,0.011,NULL,58378210471,912159538,14252492,17.8),(113898,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113898,37.38,0.19,300,49622,70,NULL,NULL,'UGC 08757',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.000223,NULL,'15.1g',0.54,'BrClG          AGN',NULL,NULL,NULL,NULL,1,207.561583,56.04247,0,NULL,57295281308,895238770,13988105,15.1),(113899,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113899,36.89,0.46,239,49623,70,NULL,NULL,'2MASX J13501506+5407279',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00016,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,207.56275,54.1245,0.005,NULL,57284424199,895069128,13985455,17.3),(113900,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113900,37.67,0.17,342,49624,70,NULL,NULL,'2MASX J13501567+2822451',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00015,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,207.565417,28.37911,0,NULL,59137696746,924026511,14437914,18.2),(113901,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113901,37.96,0.46,390,49625,70,NULL,NULL,'2MASX J13501599+2452100',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00017,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,207.56675,24.86953,0,NULL,59996371315,937443301,14647551,17.6),(113902,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113902,37.73,0.46,351,49626,70,NULL,NULL,'2MASX J13501617+1235049',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,207.567375,12.58472,0,NULL,58340824927,911575389,14243365,18.1),(113903,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113903,38.46,0.46,493,49627,70,NULL,NULL,'2MASX J13501641+5401039',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000141,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,207.568625,54.01789,0.005,NULL,57284550964,895071108,13985486,17.8),(113904,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113904,36.08,0.6,164,49628,70,NULL,NULL,'2MASX J13501714-1956551',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.21',0.2,NULL,NULL,NULL,NULL,NULL,1,207.571333,-19.94872,0.225,NULL,43637266098,681832282,10653629,16.21),(113905,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113905,37.51,0.09,318,49629,70,NULL,NULL,'2MASX J13501728+2640590',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000073,NULL,'18.51',0.15,NULL,NULL,NULL,NULL,NULL,1,207.572,26.68308,0,NULL,59124581397,923821584,14434712,18.51),(113906,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113906,37.66,0.27,341,49630,70,NULL,NULL,'SDSS J135017.33+432639.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000151,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,207.5722083,43.44428,0,NULL,59265329067,926020766,14469074,18.6),(113907,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113907,37.67,0.17,342,49631,70,NULL,NULL,'SDSS J135017.80+281257.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000137,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,207.5742083,28.21606,0,NULL,59137850445,924028913,14437951,18.5),(113908,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113908,37.17,0.46,272,49632,70,NULL,NULL,'2MASX J13501782+1701099',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.93',0.16,NULL,NULL,NULL,NULL,NULL,1,207.57425,17.01933,0.01,NULL,58379550988,912180484,14252820,17.93),(113909,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113909,36.72,0.46,220,49633,70,NULL,NULL,'2MASX J13501849+5027438',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000166,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,207.577041667,50.46217,0,NULL,59220087682,925313870,14458029,16.5),(113910,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113910,37.51,0.17,318,49634,70,NULL,NULL,'2MASX J13501871+0610289',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,207.577917,6.17464,0.015,NULL,58429019868,912953435,14264897,17.2),(113911,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113911,37.51,0.17,318,49635,70,NULL,NULL,'2MASX J13502012+0608409',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000161,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,207.5837917,6.14481,0.015,NULL,58429020034,912953438,14264897,17.1),(113912,'IRAS','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113912,33.03,0.8,40.4,49636,75,NULL,'A82, H','NGC 5320',NULL,'1997ApJS..109..333W',1997,1,3.4,NULL,'G',0.000007,NULL,'12.80',1.7,'SAB(rs)c:','in a radial-velocity based grouping',NULL,NULL,NULL,1,207.584917,41.36622,0,NULL,59270049975,926094530,14470227,12.8),(113913,'IRAS','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113913,33.05,0.8,40.8,49636,75,NULL,'CF, r','NGC 5320',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113914,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113914,31.83,0.4,23.2,49636,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5320',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113915,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113915,32.01,0.69,25.2,49636,100,NULL,'mid-IR','NGC 5320',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113916,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113916,32.08,0.38,26.1,49636,NULL,NULL,NULL,'NGC 5320',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113917,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113917,32.36,0.47,29.6,49636,75,NULL,'A82, H, raw','NGC 5320',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113918,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113918,32.43,0.47,30.7,49636,75,NULL,'A82, H, inv','NGC 5320',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113919,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113919,32.71,0.47,34.9,49636,75,NULL,'A82, H, cor','NGC 5320',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113920,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113920,32.74,0.38,35.3,49636,75,NULL,'CF, r, raw','NGC 5320',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113921,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113921,32.76,0.2,35.7,49636,74.4,NULL,NULL,'NGC 5320',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113922,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113922,32.76,0.37,35.7,49636,NULL,NULL,'Malmquist cor.','NGC 5320',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113923,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113923,32.77,0.43,35.8,49636,75,NULL,'3.6 micron, color corrected','NGC 5320',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113924,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113924,32.84,0.43,37,49636,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5320',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113925,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113925,32.85,0.38,37.1,49636,75,NULL,'CF, r, inv','NGC 5320',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113926,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113926,32.88,0.35,37.6,49636,NULL,NULL,NULL,'NGC 5320',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113927,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113927,32.89,0.4,37.8,49636,75,NULL,'B','NGC 5320',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113928,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113928,32.92,0.38,38.4,49636,75,NULL,'CF, r, cor','NGC 5320',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113929,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113929,32.93,0.4,38.6,49636,NULL,NULL,'mean','NGC 5320',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113930,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113930,32.94,0.46,38.8,49636,NULL,NULL,'J','NGC 5320',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113931,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113931,32.95,0.47,38.9,49636,NULL,NULL,'H','NGC 5320',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113932,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113932,32.96,0.45,39.2,49636,NULL,NULL,'K','NGC 5320',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113933,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113933,35.22,0.46,111,49637,70,NULL,NULL,'CGCG 190-062',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.000087,NULL,'14.7g',0.63,NULL,NULL,NULL,NULL,NULL,1,207.585917,35.47592,0,NULL,59152523778,924258184,14441534,14.7),(113934,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113934,36.03,0.61,161,49638,70,NULL,NULL,'2MASX J13502094-0457540',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,207.58725,-4.96519,0.041,NULL,43607243273,681363176,10646299,16.7),(113935,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113935,38.54,0.46,511,49639,70,NULL,NULL,'SDSS J135021.42+184210.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.6g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,207.5892917,18.70281,0.018,NULL,58323887247,911310738,14239230,18.6),(113936,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113936,37.66,0.27,341,49640,70,NULL,NULL,'2MASX J13502147+4325292',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000143,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,207.589375,43.42472,0,NULL,59265332831,926020825,14469075,17.8),(113937,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113937,38.27,0.46,450,49641,70,NULL,NULL,'SDSS J135021.72+395050.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000172,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,207.5905417,39.84742,0,NULL,59266978006,926046531,14469477,18.6),(113938,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113938,37.99,0.46,396,49642,70,NULL,NULL,'2MASX J13502184+6230225',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000082,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,207.59075,62.50633,0.037,NULL,57260896259,894701504,13979711,18.3),(113939,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113939,35.06,0.4,103,49643,NULL,NULL,'Malmquist cor.','UGC 08746',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000027,NULL,'15.11',0.4,'S?',NULL,NULL,NULL,NULL,1,207.591333,18.15458,0,NULL,58323444204,911303815,14239122,15.11),(113940,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113940,35.19,0.38,109,49643,NULL,NULL,NULL,'UGC 08746',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113941,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113941,35.2,0.2,110,49643,74.4,NULL,NULL,'UGC 08746',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113942,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113942,37.85,0.46,372,49644,70,NULL,NULL,'2MASX J13502328-0139239',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,207.597125,-1.65653,0.133,NULL,43612118036,681439344,10647489,17.8),(113943,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113943,37.31,0.46,289,49645,70,NULL,NULL,'2MASX J13502455+0645119',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000176,NULL,'16.1g',0.34,NULL,NULL,NULL,NULL,NULL,1,207.60225,6.75342,0,NULL,58430160448,912971257,14265175,16.1),(113944,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113944,37.49,0.46,315,49646,70,NULL,NULL,'SDSS J135024.65-011148.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000067,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,207.60275,-1.19694,0.133,NULL,43608525156,681383205,10646612,18.5),(113945,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113945,38.37,0.46,473,49647,70,NULL,NULL,'SDSS J135024.96+524216.6',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,207.604041667,52.70464,0,NULL,59217241544,925269399,14457334,17.7),(113946,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113946,35.5,0.17,126,49648,70,NULL,NULL,'GIN 329',NULL,'2001MNRAS.321..277C',2001,1,0.47,NULL,'G',0.000103,NULL,'16.0g',0.44,'E',NULL,NULL,NULL,NULL,1,207.604625,24.90892,0,NULL,59996358602,937443103,14647548,16),(113947,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113947,36.66,0.46,215,49648,70,NULL,NULL,'GIN 329',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113948,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113948,37.08,0.25,261,49648,74.4,NULL,NULL,'GIN 329',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113949,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113949,38.85,0.46,588,49649,70,NULL,NULL,'SDSS J135025.22+202413.2',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.8g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,207.605125,20.40369,0.013,NULL,58333454446,911460225,14241566,17.8),(113950,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113950,35.18,0.54,109,49650,70,NULL,NULL,'2MASX J13502599-3755247',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,207.608417,-37.92361,0.229,NULL,46885807744,732590746,11446730,14.1),(113951,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113951,37.58,0.46,329,49651,70,NULL,NULL,'2MASX J13502606+4637312',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000183,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,207.6085417,46.62533,0,NULL,59211229488,925175460,14455866,17.3),(113952,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113952,35.73,0.46,140,49652,70,NULL,NULL,'2MASX J13502694+0903009',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.04',0.14,NULL,NULL,NULL,NULL,NULL,1,207.6122917,9.05033,0.015,NULL,58458704572,913417258,14272144,18.04),(113953,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113953,37,0.33,251,49653,70,NULL,NULL,'2MASX J13502787+0234554',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000085,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,207.6160417,2.582,0.041,NULL,58444857342,913200895,14268763,16.5),(113954,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113954,37.76,0.46,356,49654,70,NULL,NULL,'SDSS J135027.96+583639.0',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,207.616583,58.61086,0.005,NULL,57266699436,894792178,13981127,17.6),(113955,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113955,37.61,0.16,332,49655,70,NULL,NULL,'SDSS J135028.22+291009.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.3g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,207.617625,29.16939,0,NULL,59129809151,923903267,14435988,18.3),(113956,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113956,33.12,0.47,42.1,49656,NULL,NULL,'H','ESO 221- G 007',NULL,'2007A&A...465...71T',2007,1,1.5,'Confused HIPASS source','G',0.00002,NULL,'14.64',0.9,'SAB(s)cd',NULL,NULL,NULL,NULL,1,207.6177917,-52.66075,NULL,NULL,46815754274,731496160,11429627,14.64),(113957,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113957,33.14,0.45,42.5,49656,NULL,NULL,'K','ESO 221- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113958,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113958,33.15,0.46,42.7,49656,NULL,NULL,'J','ESO 221- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113959,'Tully-Fisher','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,NULL,113959,33.55,0.4,51.3,49656,NULL,NULL,'mean','ESO 221- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113960,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113960,37.67,0.17,342,49657,70,NULL,NULL,'2MASX J13502838+2819501',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000186,NULL,'16.5g',0.38,NULL,NULL,NULL,NULL,NULL,1,207.618333,28.33075,0,NULL,59137825885,924028529,14437945,16.5),(113961,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113961,37,0.46,251,49658,70,NULL,NULL,'2MASX J13502871+3347473',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000188,NULL,'16.67',0.29,NULL,NULL,NULL,NULL,NULL,1,207.619625,33.79642,0,NULL,59183287405,924738865,14449044,16.67),(113962,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113962,37.38,0.19,300,49659,70,NULL,NULL,'2MASX J13502895+5614268',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000187,NULL,'16.0g',0.46,'E0',NULL,NULL,NULL,NULL,1,207.620666667,56.24081,0,NULL,57295502953,895242233,13988159,16),(113963,'FP','2016-12-15 15:15:18','2016-12-16 11:20:31','1',NULL,'R',113963,37.55,0.46,323,49660,70,NULL,NULL,'2MASX J13502904+3033493',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000172,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,207.621125,30.56372,0,NULL,59131149158,923924205,14436315,17.1),(113964,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,113964,35.29,0.25,114,49661,74.4,NULL,NULL,'CGCG 132-019 NED01',NULL,'2013AJ....146...86T',2013,1,0.65,NULL,'G',0.00008,NULL,'15.1g',0.55,'E','Pair member (points to parent)',NULL,NULL,NULL,1,207.628333,24.96292,0,NULL,59996352407,937443006,14647546,15.1),(113965,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,113965,35.5,0.17,126,49661,70,NULL,NULL,'CGCG 132-019 NED01',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113966,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',113966,37.35,0.46,296,49662,70,NULL,NULL,'2MASX J13503082+2934221',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000172,NULL,'16.2g',0.34,'cD?',NULL,NULL,NULL,NULL,1,207.6284583,29.57286,0,NULL,59129921198,923905018,14436015,16.2),(113967,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',113967,37.58,0.46,328,49663,70,NULL,NULL,'2MASX J13503081+5859138',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000179,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,207.628583,58.98731,0,NULL,57266377676,894787151,13981049,17.1),(113968,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,113968,35.5,0.17,126,49664,70,NULL,NULL,'CGCG 132-019 NED02',NULL,'2001MNRAS.321..277C',2001,1,0.4,NULL,'G',0.000053,NULL,'14.01',0.4,'E              RET','Pair member (points to parent)',NULL,NULL,NULL,1,207.628875,24.97661,0,NULL,59996352370,937443005,14647546,14.01),(113969,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',113969,38.05,0.46,407,49665,70,NULL,NULL,'2MASX J13503176+2014515',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.16',0.16,NULL,NULL,NULL,NULL,NULL,1,207.6322917,20.24767,0.013,NULL,58334311975,911473624,14241775,18.16),(113970,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',113970,37.51,0.17,318,49666,70,NULL,NULL,'2MASX J13503184+0607214',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,207.6327083,6.12261,0.015,NULL,58429029143,912953580,14264899,17.6),(113971,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',113971,37,0.33,251,49667,70,NULL,NULL,'2MASX J13503201+0235274',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000084,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,207.633375,2.59083,0.045,NULL,58444853562,913200836,14268763,16.4),(113972,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,113972,30.74,0.4,14.1,49668,NULL,NULL,NULL,'ESO 383- G 091',NULL,'2009AJ....138..323T',2009,1,2.4,'Cote, et al. (1997AJ....114.1313C) give v = 1077 +/- 155 km/sec.','G',0.000033,NULL,'14.30',0.3,'SB(s)d: sp','in a triple',NULL,NULL,NULL,1,207.6345,-37.28892,0.261,NULL,46885260400,732582193,11446596,14.3),(113973,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,113973,30.75,0.39,14.1,49668,73,NULL,'opt','ESO 383- G 091',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113974,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,113974,30.79,0.64,14.4,49668,NULL,NULL,NULL,'ESO 383- G 091',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113975,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,113975,30.83,0.2,14.7,49668,74.4,NULL,NULL,'ESO 383- G 091',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113976,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,113976,31.16,0.54,17,49668,NULL,NULL,'Malmquist cor.','ESO 383- G 091',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113977,'IRAS','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,113977,34.16,0.8,68,49669,75,NULL,'MAT, I','ESO 325- G 027',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'15.14',0.9,'Sc',NULL,NULL,NULL,NULL,1,207.6349583,-40.70717,0.181,NULL,46925150777,733205480,11456335,15.14),(113978,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,113978,33.07,0.32,41.2,49669,85,NULL,'I, inv','ESO 325- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113979,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,113979,33.09,0.32,41.5,49669,85,NULL,'I, raw','ESO 325- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113980,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,113980,33.92,0.43,60.8,49669,75,NULL,'MAT, I, raw','ESO 325- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113981,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,113981,33.96,0.43,61.9,49669,75,NULL,'MAT, I, inv','ESO 325- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113982,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,113982,34.05,0.43,64.5,49669,75,NULL,'MAT, I, cor','ESO 325- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113983,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,113983,34.1,0.89,66,49669,NULL,NULL,'Malmquist cor.','ESO 325- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113984,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,113984,34.13,0.2,67,49669,74.4,NULL,NULL,'ESO 325- G 027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113985,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,113985,34.35,0.79,74.1,49669,NULL,NULL,NULL,'ESO 325- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113986,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,113986,33.43,0.49,48.6,49670,70,NULL,NULL,'2MASX J13503245-4835225',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,207.635208333,-48.58961,0.637,NULL,46820397793,731568715,11430761,13.6),(113987,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,113987,32.67,0.25,34.2,49671,74.4,NULL,NULL,'ESO 445- G 054',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000047,NULL,'14.70',0.7,'S0',NULL,NULL,NULL,NULL,1,207.635875,-30.04867,0.173,NULL,46854403106,732100048,11439063,14.7),(113988,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,113988,33.96,0.45,61.9,49671,NULL,NULL,'K','ESO 445- G 054',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113989,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,113989,34.38,0.4,75.2,49671,NULL,NULL,'mean','ESO 445- G 054',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113990,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',113990,38.19,0.46,434,49672,70,NULL,NULL,'2MASX J13503282-0207269',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.1g',0.16,'Sa-Sb',NULL,NULL,NULL,NULL,1,207.6367917,-2.12433,0.129,NULL,43612294152,681442096,10647532,18.1),(113991,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',113991,37.26,0.11,283,49673,70,NULL,NULL,'2MASX J13503411+4614572',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,207.642208333,46.24925,0,NULL,59211005004,925171953,14455811,17.1),(113992,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',113992,37.66,0.27,341,49674,70,NULL,NULL,'2MASX J13503450+4326092',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.5g',0.22,'BrClG',NULL,NULL,NULL,NULL,1,207.6437917,43.436,0,NULL,59265331652,926020807,14469075,17.5),(113993,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,113993,32.09,0.4,26.2,49675,NULL,NULL,'mean','UGC 08756',NULL,'2007A&A...465...71T',2007,1,1.62,NULL,'G',0.00006,NULL,'14.3g',0.44,'Sab',NULL,NULL,NULL,NULL,1,207.649625,42.54128,0,NULL,59262860250,925982191,14468471,14.3),(113994,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,113994,32.42,0.43,30.5,49675,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08756',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113995,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,113995,32.77,0.47,35.9,49675,NULL,NULL,'H','UGC 08756',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113996,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,113996,32.78,0.45,36,49675,NULL,NULL,'K','UGC 08756',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113997,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,113997,32.85,0.46,37.1,49675,NULL,NULL,'J','UGC 08756',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113998,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',113998,33.67,0.46,54.2,49676,70,NULL,NULL,'NGC 5318 NED01',NULL,'2015arXiv151105856S',2015,1,1.43,NULL,'G',0.00015,NULL,'13.5g',0.94,'S0?            Sy?','in a pair',NULL,NULL,'Flat-Spectrum Radio Source',1,207.6500417,33.70489,0,NULL,59183401518,924740648,14449072,13.5),(113999,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',113999,37.62,0.46,335,49677,70,NULL,NULL,'2MASX J13503655+4211228',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,207.652333333,42.18967,0,NULL,59270468710,926101073,14470329,18.2),(114000,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114000,37.35,0.33,295,49678,70,NULL,NULL,'2MASX J13503768+1850424',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.96',0.15,NULL,NULL,NULL,NULL,NULL,1,207.656833,18.84519,0.018,NULL,58323790494,911309226,14239206,17.96),(114001,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114001,36.46,0.46,196,49679,70,NULL,NULL,'2MASX J13503787+3120114',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'18.00',0.18,NULL,NULL,NULL,NULL,NULL,1,207.6579583,31.33639,0,NULL,59130789428,923918584,14436227,18),(114002,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114002,37.9,0.46,381,49680,70,NULL,NULL,'2MASX J13503839+2924091',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,207.659917,29.40264,0,NULL,59129904236,923904753,14436011,17.6),(114003,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114003,36.51,NULL,200,49681,NULL,NULL,NULL,'FGCE 1105',NULL,'2000BSAO...50....5K',2000,1,0.8,NULL,'G',NULL,NULL,'17.28',0.1,'Sb',NULL,NULL,NULL,NULL,1,207.660375,-20.20869,0.225,NULL,43637405700,681834464,10653663,17.28),(114004,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114004,36.51,NULL,201,49681,NULL,NULL,'Dipole + Quadrupole + Octopole','FGCE 1105',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114005,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114005,36.56,NULL,205,49681,NULL,NULL,'Dipole + Quadrupole','FGCE 1105',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114006,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114006,36.6,NULL,209,49681,NULL,NULL,'Dipole','FGCE 1105',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114007,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114007,38.27,0.46,451,49682,70,NULL,NULL,'SDSS J135038.77-003629.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000085,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,207.661541667,-0.60811,0.137,NULL,43608252723,681378948,10646546,18.3),(114008,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114008,34.52,0.46,80.3,49683,70,NULL,NULL,'UGC 08754',NULL,'2015arXiv151105856S',2015,1,0.97,NULL,'G',0.000063,NULL,'14.2g',0.94,'S0-:',NULL,NULL,NULL,NULL,1,207.662917,35.03831,0,NULL,59150387469,924224804,14441012,14.2),(114009,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114009,37.48,0.46,314,49684,70,NULL,NULL,'2MASX J13503914+2732311',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,207.66325,27.54203,0,NULL,59124212044,923815813,14434622,17.2),(114010,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114010,36.59,0.46,208,49685,70,NULL,NULL,'MCG +06-30-102',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000103,NULL,'15.2g',0.58,NULL,NULL,NULL,NULL,NULL,1,207.665,35.60031,0,NULL,59152447127,924256986,14441515,15.2),(114011,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114011,36.6,0.46,209,49686,70,NULL,NULL,'2MASX J13503986+2844451',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,207.666083,28.74572,0,NULL,59129342786,923895981,14435874,17),(114012,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114012,37.23,0.46,279,49687,70,NULL,NULL,'2MASX J13504056+2504361',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000167,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,207.6689583,25.07672,0,NULL,59996142982,937439734,14647495,17.3),(114013,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114013,37.64,0.46,337,49688,70,NULL,NULL,'2MASX J13504069-0216509',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00015,NULL,'17.71',0.26,'Sc-Sd',NULL,NULL,NULL,NULL,1,207.669625,-2.28075,0.113,NULL,43611396460,681428069,10647313,17.71),(114014,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114014,37.92,0.46,384,49689,70,NULL,NULL,'SDSS J135040.72+242732.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,207.669708333,24.45906,0,NULL,59996247102,937441360,14647521,18.3),(114015,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114015,37.22,0.46,278,49690,70,NULL,NULL,'SDSS J135041.23+613107.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.0001,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,207.671791667,61.51883,0.033,NULL,57264508416,894757944,13980592,18.1),(114016,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114016,37.67,0.17,342,49691,70,NULL,NULL,'SDSS J135041.43+282349.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000159,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,207.672666667,28.397,0,NULL,59137701088,924026579,14437915,18.4),(114017,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114017,37.26,0.11,283,49692,70,NULL,NULL,'2MASX J13504231+4603089',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000184,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,207.6765417,46.05269,0,NULL,59261324668,925958197,14468096,17.1),(114018,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114018,37.61,0.16,332,49693,70,NULL,NULL,'2MASX J13504303+2913120',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000127,NULL,'16.8g',0.28,'S0',NULL,NULL,NULL,NULL,1,207.6792083,29.21997,0,NULL,59130089216,923907644,14436056,16.8),(114019,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114019,38.42,0.33,482,49694,70,NULL,NULL,'2MASX J13504326+6359117',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000101,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,207.680125,63.98667,0.029,NULL,57865139037,904142797,14127231,18),(114020,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114020,37.61,0.16,332,49695,70,NULL,NULL,'2MASX J13504463+2910270',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000113,NULL,'16.5g',0.35,'E',NULL,NULL,NULL,NULL,1,207.686167,29.17406,0,NULL,59130088508,923907632,14436056,16.5),(114021,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114021,37.26,0.11,283,49696,70,NULL,NULL,'2MASX J13504487+4615419',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000148,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,207.687083,46.26178,0,NULL,59211004291,925171942,14455811,17),(114022,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114022,35.01,0.49,100,49697,75,NULL,'IR','UGC 08753',NULL,'2011yCatp016004901K',2011,1,1.52,NULL,'G',0.000087,NULL,'15.3g',0.29,'Sbc',NULL,NULL,NULL,NULL,1,207.688167,25.18953,0,NULL,59996019538,937437805,14647465,15.3),(114023,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114023,35.34,0.2,117,49697,74.4,NULL,NULL,'UGC 08753',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114024,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114024,36.35,0.46,186,49698,70,NULL,NULL,'2MASX J13504548+2305256',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',NULL,NULL,'15.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,207.6897083,23.09031,0,NULL,59458941592,929045962,14516343,15.4),(114025,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114025,34.21,0.47,69.5,49699,70,NULL,NULL,'2MASX J13504607-2959553',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000047,NULL,'14.77',NULL,'S0',NULL,NULL,NULL,NULL,1,207.691916667,-29.99869,0.173,NULL,46854398331,732099973,11439062,14.77),(114026,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114026,34.55,0.23,81.3,49699,74.4,NULL,NULL,'2MASX J13504607-2959553',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114027,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114027,35.11,0.56,105,49700,70,NULL,NULL,'2MASX J13504679-7827417',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,207.695167,-78.46167,0.557,NULL,44253556531,691461820,10804090,16.4),(114028,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114028,37.35,0.33,295,49701,70,NULL,NULL,'2MASX J13504770+1855266',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.85',0.17,NULL,NULL,NULL,NULL,NULL,1,207.698875,18.92406,0.029,NULL,58323292552,911301446,14239085,17.85),(114029,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114029,37.45,0.46,309,49702,70,NULL,NULL,'2MASX J13504825+3120114',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.62',0.15,NULL,NULL,NULL,NULL,NULL,1,207.701125,31.33647,0,NULL,59130785660,923918525,14436226,18.62),(114030,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:31','1','SN 1996C',NULL,114030,34.92,0.18,93.8,49703,74.2,NULL,'SALT 2','MCG +08-25-047',0.027,'2010ApJ...716..712A',2010,1,1,NULL,'G',NULL,NULL,'16.00',0.5,'Sa',NULL,NULL,NULL,NULL,1,207.703458333,49.31514,0,NULL,59212415129,925193986,14456156,16),(114031,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:31','1','SN 1996C',NULL,114031,35.32,0.17,116,49703,70.8,NULL,NULL,'MCG +08-25-047',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114032,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:31','1','SN 1996C',NULL,114032,35.53,0.08,128,49703,74.4,NULL,NULL,'MCG +08-25-047',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114033,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:31','1','SN 1996C',NULL,114033,35.6,0.16,129,49703,70,NULL,'SALT 2','MCG +08-25-047',0.027,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114034,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:31','1','SN 1996C',NULL,114034,35.62,0.1,130,49703,65,NULL,'SALT2','MCG +08-25-047',0.027,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114035,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:31','1','SN 1996C',NULL,114035,35.63,0.16,130,49703,73.8,NULL,'SALT 2 (SNANA)','MCG +08-25-047',0.0277,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114036,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:31','1','SN 1996C',NULL,114036,35.64,0.23,131,49703,72,NULL,NULL,'MCG +08-25-047',0.027,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114037,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:31','1','SN 1996C',NULL,114037,35.67,0.18,133,49703,70,NULL,'SALT','MCG +08-25-047',0.027,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114038,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:31','1','SN 1996C',NULL,114038,35.7,0.03,134,49703,72,NULL,NULL,'MCG +08-25-047',0.027,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114039,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:31','1','SN 1996C',NULL,114039,35.79,0.2,140,49703,65,NULL,'SALT2','MCG +08-25-047',0.027,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114040,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:31','1','SN 1996C',NULL,114040,35.82,0.19,142,49703,65,NULL,'SALT','MCG +08-25-047',0.027,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114041,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:31','1','SN 1996C',NULL,114041,35.82,0.21,142,49703,70,NULL,NULL,'MCG +08-25-047',0.027,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114042,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:31','1','SN 1996C',NULL,114042,35.82,0.2,142,49703,65,NULL,'Template','MCG +08-25-047',0.027,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114043,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:31','1','SN 1996C',NULL,114043,35.88,0.07,146,49703,65,NULL,'MLCS2k2','MCG +08-25-047',0.027,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114044,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:31','1','SN 1996C',NULL,114044,35.95,0.1,147,49703,65,NULL,'MLCS2k2','MCG +08-25-047',0.027,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114045,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:31','1','SN 1996C',NULL,114045,35.9,0.2,147,49703,65,NULL,NULL,'MCG +08-25-047',0.027,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114046,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:31','1','SN 1996C',NULL,114046,35.91,0.16,148,49703,65,NULL,'MLCS17','MCG +08-25-047',0.027,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114047,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:31','1','SN 1996C',NULL,114047,35.93,0.17,149,49703,65,NULL,'MLCS31','MCG +08-25-047',0.027,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114048,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:31','1','SN 1996C',NULL,114048,35.88,0.08,150,49703,60,NULL,'M(I) = -19.19 mag','MCG +08-25-047',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114049,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:31','1','SN 1996C',NULL,114049,35.94,0.11,150,49703,65,NULL,'MLCS2k2','MCG +08-25-047',0.027,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114050,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:31','1','SN 1996C',NULL,114050,35.9,0.1,151,49703,60,NULL,'M(V) = -19.47 mag','MCG +08-25-047',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114051,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:31','1','SN 1996C',NULL,114051,35.98,0.2,153,49703,65,NULL,'MLCS','MCG +08-25-047',0.027,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114052,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:31','1','SN 1996C',NULL,114052,36.03,0.03,156,49703,65,NULL,'SALT','MCG +08-25-047',0.027,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114053,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:31','1','SN 1996C',NULL,114053,35.97,0.1,156,49703,60,NULL,'M(B) = -19.48 mag','MCG +08-25-047',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114054,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:31','1','SN 1996C',NULL,114054,36.04,0.03,157,49703,70,NULL,'SALT 2','MCG +08-25-047',0.027,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114055,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:31','1','SN 1996C',NULL,114055,36.1,0.14,166,49703,60,NULL,NULL,'MCG +08-25-047',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114056,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114056,37.32,0.46,291,49704,70,NULL,NULL,'SDSS J135049.47+394135.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00017,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,207.706166667,39.69325,0,NULL,59266995760,926046808,14469481,18.1),(114057,'Brightest Stars','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114057,27.9,NULL,3.8,49705,NULL,NULL,NULL,'UGC 08760',NULL,'1998AJ....116.2886S',1998,1,2.2,NULL,'G',0.000013,NULL,'14.36',0.7,'SAB(s)dm IV','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,207.710833,38.01917,0,NULL,59147004116,924171939,14440186,14.36),(114058,'Brightest Stars','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114058,28.54,NULL,5.1,49705,NULL,NULL,NULL,'UGC 08760',NULL,'1998A&AS..128..459M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114059,'TRGB','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114059,27.42,0.14,3.04,49705,NULL,NULL,NULL,'UGC 08760',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114060,'TRGB','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114060,27.54,0.08,3.22,49705,NULL,NULL,'I','UGC 08760',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114061,'TRGB','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114061,27.54,NULL,3.22,49705,NULL,NULL,NULL,'UGC 08760',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114062,'TRGB','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114062,27.55,0.06,3.24,49705,NULL,NULL,NULL,'UGC 08760',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114063,'TRGB','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114063,27.58,0.07,3.28,49705,NULL,NULL,NULL,'UGC 08760',NULL,'2013AstBu..68..125M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114064,'TRGB','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114064,27.58,0.08,3.28,49705,74.4,NULL,NULL,'UGC 08760',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114065,'TRGB','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114065,27.59,0.05,3.3,49705,NULL,NULL,'I','UGC 08760',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114066,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114066,27.58,0.4,3.3,49705,75,NULL,'B','UGC 08760',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114067,'Tully est','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114067,32.89,0.8,37.8,49706,75,NULL,'B','NGC 5326',NULL,'1988NBGC.C....0000T',1988,1,2.15,NULL,'G',0.000033,NULL,'12.7g',0.99,'SAa:','in a radial-velocity based grouping',NULL,NULL,NULL,1,207.71125,39.57486,0,NULL,59267509693,926054838,14469606,12.7),(114068,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114068,32.21,0.45,27.7,49706,NULL,NULL,'K','NGC 5326',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114069,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114069,32.22,0.47,27.8,49706,NULL,NULL,'H','NGC 5326',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114070,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114070,32.27,0.46,28.5,49706,NULL,NULL,'J','NGC 5326',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114071,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114071,32.81,0.4,36.5,49706,NULL,NULL,'mean','NGC 5326',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114072,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114072,38.37,0.46,472,49707,70,NULL,NULL,'SDSS J135050.88+102328.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000164,NULL,'18.6g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,207.7120417,10.39136,0,NULL,58467726192,913558221,14274347,18.6),(114073,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114073,37.39,0.46,301,49708,70,NULL,NULL,'2MASX J13505216+2910174',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00013,NULL,'16.2g',0.36,'E',NULL,NULL,NULL,NULL,1,207.717375,29.17156,0,NULL,59130099087,923907798,14436059,16.2),(114074,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114074,38.58,0.46,520,49709,70,NULL,NULL,'2MASX J13505375+6251237',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000197,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,207.723833,62.85669,0.037,NULL,57747237359,902300583,14098446,17.4),(114075,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114075,34.02,0.48,63.7,49710,70,NULL,NULL,'ESO 445- G 056',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000033,NULL,'14.60',0.2,'S0',NULL,NULL,NULL,NULL,1,207.723917,-30.28919,0.173,NULL,46854514688,732101792,11439090,14.6),(114076,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114076,37.21,0.46,277,49711,70,NULL,NULL,'2MASX J13505381-0223069',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000144,NULL,'17.9g',0.15,'Sa-Sb',NULL,NULL,NULL,NULL,1,207.724333,-2.38514,0.113,NULL,43610938180,681420909,10647201,17.9),(114077,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114077,37.39,0.46,300,49712,70,NULL,NULL,'2MASX J13505401+1356423',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,207.7250417,13.945,0,NULL,58339919677,911561244,14243144,17.4),(114078,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114078,38.42,0.33,482,49713,70,NULL,NULL,'2MASX J13505405+6400287',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00009,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,207.7252083,64.00786,0.029,NULL,57865141618,904142837,14127231,17.2),(114079,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114079,37.51,0.17,318,49714,70,NULL,NULL,'2MASX J13505419+0613491',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.69',0.12,NULL,NULL,NULL,NULL,NULL,1,207.725625,6.23017,0,NULL,58430067186,912969799,14265153,18.69),(114080,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114080,37.63,0.46,336,49715,70,NULL,NULL,'2MASX J13505514+1255266',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000171,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,207.729583,12.92397,0,NULL,58341289780,911582652,14243478,17.4),(114081,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114081,37.81,0.46,364,49716,70,NULL,NULL,'2MASX J13505662+6037487',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00018,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,207.7360417,60.63025,0.017,NULL,57262096738,894720261,13980004,17.4),(114082,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114082,37.27,0.46,284,49717,70,NULL,NULL,'2MASX J13505783+4942381',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,207.741083,49.71067,0,NULL,59212463085,925194735,14456167,16.9),(114083,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114083,37.16,0.46,270,49718,70,NULL,NULL,'2MASX J13505801+0623211',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,207.741667,6.38919,0,NULL,58430082258,912970035,14265156,17.3),(114084,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114084,35.95,0.33,155,49719,70,NULL,NULL,'2MASX J13505802+2926124',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000189,NULL,'15.9g',0.36,'E',NULL,NULL,NULL,NULL,1,207.74175,29.43694,0,NULL,59130013310,923906457,14436038,15.9),(114085,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114085,38.15,0.46,427,49720,70,NULL,NULL,'2MASX J13505981+0251054',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000088,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,207.749375,2.85153,0.045,NULL,58444926649,913201978,14268780,17.7),(114086,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114086,33.82,0.46,58,49721,70,NULL,NULL,'ARK 430',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000107,NULL,'14.4g',0.57,NULL,NULL,NULL,NULL,NULL,1,207.750917,36.95442,0,NULL,59147040747,924172511,14440195,14.4),(114087,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114087,38.2,0.46,436,49722,70,NULL,NULL,'SDSS J135100.47+620043.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000136,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,207.752,62.01219,0.017,NULL,57261469872,894710466,13979851,18.3),(114088,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114088,34.78,0.2,90.4,49723,74.4,NULL,NULL,'CGCG 073-083',NULL,'2013AJ....146...86T',2013,1,0.58,NULL,'G',0.000133,NULL,'15.9g',0.4,NULL,NULL,NULL,NULL,NULL,1,207.7539583,13.77317,0,NULL,58339940305,911561567,14243149,15.9),(114089,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114089,35.57,0.17,130,49724,70,NULL,NULL,'UGC 08759',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000143,NULL,'14.81',0.9,'S0',NULL,NULL,NULL,NULL,1,207.754167,21.99222,0.019,NULL,58320037348,911250583,14238290,14.81),(114090,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114090,36.33,0.57,184,49725,70,NULL,NULL,'2MASX J13510160-1128474',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,207.75675,-11.47978,0.121,NULL,43702679049,682854360,10669599,15),(114091,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114091,37.87,0.46,375,49726,70,NULL,NULL,'2MASX J13510195+2803204',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000175,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,207.7580417,28.05567,0,NULL,59137635234,924025550,14437899,16.9),(114092,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114092,37.62,0.46,335,49727,70,NULL,NULL,'2MASX J13510344+1619277',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.47',0.13,NULL,NULL,NULL,NULL,NULL,1,207.764417,16.32431,0.011,NULL,58377719531,912151867,14252372,18.47),(114093,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114093,38.32,0.46,462,49728,70,NULL,NULL,'SDSS J135103.63+302117.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000152,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,207.765125,30.35497,0,NULL,59131297056,923926516,14436351,18.5),(114094,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114094,37.05,0.13,257,49729,70,NULL,NULL,'2MASX J13510400+0926087',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,207.76675,9.43583,0.02,NULL,58466971403,913546428,14274162,17.5),(114095,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114095,37.17,0.46,271,49730,70,NULL,NULL,'2MASX J13510428+0743397',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000183,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,207.767917,7.72781,0.009,NULL,58428286041,912941969,14264718,17.3),(114096,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114096,38.94,0.46,614,49731,70,NULL,NULL,'2MASX J13510449+4315259',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000163,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,207.768791667,43.25719,0,NULL,59264653256,926010207,14468909,18.4),(114097,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114097,35.29,0.25,114,49732,74.4,NULL,NULL,'UGC 08763 NED01',NULL,'2013AJ....146...86T',2013,1,0.42,'MCG RA is +1 minute in error.','G',0.000067,NULL,'15.5g',0.34,'E',NULL,NULL,NULL,NULL,1,207.7692083,25.08311,0,NULL,59996169371,937440146,14647502,15.5),(114098,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114098,35.5,0.17,126,49732,70,NULL,NULL,'UGC 08763 NED01',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114099,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114099,35.29,0.25,114,49733,74.4,NULL,NULL,'UGC 08763 NED02',NULL,'2013AJ....146...86T',2013,1,0.9,'MCG RA is +1 minute in error.','G',0.00007,NULL,'13.39',0.9,'S0: pec        PAS',NULL,NULL,NULL,NULL,1,207.7725,25.09372,0,NULL,59996169792,937440153,14647502,13.39),(114100,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114100,35.5,0.17,126,49733,70,NULL,NULL,'UGC 08763 NED02',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114101,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114101,37.26,0.11,283,49734,70,NULL,NULL,'2MASX J13510648+4620579',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,207.7769583,46.34942,0,NULL,59240357909,925630592,14462978,17.8),(114102,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114102,36.82,0.46,231,49735,70,NULL,NULL,'2MASX J13510693+4407049',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000143,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,207.778833,44.11808,0,NULL,59265177321,926018395,14469037,16.8),(114103,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114103,37.92,0.46,384,49736,70,NULL,NULL,'2MASX J13510710+3316154',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,207.7795417,33.27089,0,NULL,59185413347,924772083,14449563,17.7),(114104,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114104,35.97,0.46,156,49737,70,NULL,NULL,'2MASX J13510729+6244247',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00007,NULL,'16.1g',0.4,'E0',NULL,NULL,NULL,NULL,1,207.780375,62.74014,0.037,NULL,57260685504,894698211,13979659,16.1),(114105,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114105,37.56,0.46,326,49738,70,NULL,NULL,'2MASX J13510769+0141094',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000092,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,207.781917,1.68608,0.033,NULL,58447288495,913238882,14269357,16.8),(114106,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114106,36.83,0.7,232,49739,70,NULL,NULL,'2MASX J13510767-3125434',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.4b',0.3,'S0',NULL,NULL,NULL,NULL,1,207.7819583,-31.42872,0.189,NULL,46850912710,732045511,11438211,16.4),(114107,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114107,35.67,0.16,136,49740,70,NULL,NULL,'2MASX J13510805+2508004',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00008,NULL,'15.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,207.783625,25.1335,0,NULL,59996135997,937439624,14647494,15.5),(114108,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114108,38,0.33,399,49741,70,NULL,NULL,'2MASX J13510809+0130034',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000088,NULL,'17.6g',0.21,'E/S0',NULL,NULL,NULL,NULL,1,207.783667,1.501,0.041,NULL,58443769714,913183901,14268498,17.6),(114109,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114109,34.22,0.06,70,49742,NULL,NULL,NULL,'ESO 445- G 057',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000013,NULL,'13.99',0.9,'SB?',NULL,NULL,NULL,NULL,1,207.786333,-30.77931,0.149,NULL,46853990305,732093598,11438962,13.99),(114110,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114110,37.86,0.33,373,49743,70,NULL,NULL,'SDSS J135109.56+295925.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000168,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,207.789875,29.99031,0,NULL,59131221686,923925338,14436333,18.3),(114111,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114111,37.69,0.46,346,49744,70,NULL,NULL,'2MASX J13511034+2919434',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000183,NULL,'16.8g',0.3,'E',NULL,NULL,NULL,NULL,1,207.793083,29.32869,0,NULL,59130017975,923906530,14436039,16.8),(114112,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114112,34.04,0.25,64.3,49745,74.4,NULL,NULL,'2MASX J13511128-3030384',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000033,NULL,'15.89',0.4,'E',NULL,NULL,NULL,NULL,1,207.797083,-30.51069,0.149,NULL,46854536187,732102127,11439095,15.89),(114113,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114113,36.63,0.6,212,49746,70,NULL,NULL,'2MASX J13511216-1957372',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.93',NULL,NULL,NULL,NULL,NULL,NULL,1,207.800583333,-19.96033,0.225,NULL,43637295702,681832745,10653636,15.93),(114114,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114114,36.66,0.46,214,49747,70,NULL,NULL,'2MASX J13511220+2246286',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00011,NULL,'16.36',0.31,NULL,NULL,NULL,NULL,NULL,1,207.800917,22.77469,0,NULL,59458729532,929042648,14516291,16.36),(114115,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114115,37.31,0.46,290,49748,70,NULL,NULL,'2MASX J13511248+1214058',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000173,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,207.8019583,12.23497,0,NULL,58340783850,911574747,14243355,16.8),(114116,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114116,36.3,0.87,182,49749,70,NULL,NULL,'2MASX J13511255-1529215',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,207.8022917,-15.48942,0.229,NULL,43677405589,682459462,10663429,14.5),(114117,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114117,35.57,0.17,130,49750,70,NULL,NULL,'2MASX J13511308+2159056',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.35',0.21,NULL,NULL,NULL,NULL,NULL,1,207.8045417,21.98475,0.019,NULL,58320038098,911250595,14238290,17.35),(114118,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114118,37.15,0.46,269,49751,70,NULL,NULL,'2MASX J13511348+2321356',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.76',0.18,NULL,NULL,NULL,NULL,NULL,1,207.806125,23.36,0,NULL,59458915086,929045548,14516336,17.76),(114119,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114119,38,0.33,399,49752,70,NULL,NULL,'2MASX J13511463+0124264',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000083,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,207.8110417,1.40731,0.041,NULL,58443765660,913183838,14268497,16.9),(114120,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114120,36.44,0.46,194,49753,70,NULL,NULL,'2MASX J13511553+2116506',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.58',0.21,NULL,NULL,NULL,NULL,NULL,1,207.81475,21.28075,0.009,NULL,58320248083,911253876,14238341,17.58),(114121,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114121,37.84,0.46,370,49754,70,NULL,NULL,'2MASX J13511692+3240334',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,207.820375,32.67592,0,NULL,59185587029,924774797,14449606,17.5),(114122,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114122,38.03,0.46,403,49755,70,NULL,NULL,'SDSS J135117.26+050717.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,207.8219583,5.12158,0.016,NULL,58439103666,913110994,14267359,18.2),(114123,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114123,37.8,0.33,364,49756,70,NULL,NULL,'2MASX J13511743+0148144',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000087,NULL,'17.6g',0.18,'NLAGN',NULL,NULL,NULL,NULL,1,207.822625,1.80386,0.045,NULL,58447313825,913239278,14269363,17.6),(114124,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114124,36.69,0.55,218,49757,70,NULL,NULL,'2MASX J13511744-2253557',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,207.8227083,-22.89886,0.201,NULL,46507032553,726672383,11354255,14.1),(114125,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114125,35.6,0.46,132,49758,70,NULL,NULL,'2MASX J13511763+0023054',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,'FoF','17.37',0.25,NULL,NULL,NULL,NULL,NULL,1,207.8237083,0.38489,0.053,NULL,58389004523,912328195,14255128,17.37),(114126,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114126,37.7,0.27,347,49759,70,NULL,NULL,'2MASX J13511780+0638307',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00017,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,207.824167,6.64181,0,NULL,58430136716,912970886,14265170,16.9),(114127,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114127,37.43,0.46,307,49760,70,NULL,NULL,'2MASX J13511787+0706477',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.82',0.19,NULL,NULL,NULL,NULL,NULL,1,207.824417,7.11322,0,NULL,58430485220,912976331,14265255,17.82),(114128,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114128,38.3,0.46,458,49761,70,NULL,NULL,'2MASX J13511787+6409365',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000088,NULL,'17.7g',0.19,'AGN',NULL,NULL,NULL,NULL,1,207.8245,64.16028,0.029,NULL,57864897634,904139025,14127172,17.7),(114129,'Tully est','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114129,31.55,0.8,20.5,49762,75,NULL,NULL,'ESO 384- G 002',NULL,'1988NBGC.C....0000T',1988,1,4.8,NULL,'G',0.000007,NULL,'12.5',2.6,'SB(s)dm',NULL,NULL,NULL,NULL,1,207.830417,-33.80786,0.173,NULL,46899052689,732797698,11449964,12.5),(114130,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114130,30.73,0.4,14,49762,NULL,NULL,NULL,'ESO 384- G 002',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114131,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114131,30.73,0.4,14,49762,73,NULL,'opt','ESO 384- G 002',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114132,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114132,30.92,0.2,15.3,49762,74.4,NULL,NULL,'ESO 384- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114133,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114133,30.95,0.79,15.5,49762,NULL,NULL,NULL,'ESO 384- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114134,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114134,31.48,0.62,19.8,49762,NULL,NULL,'Malmquist cor.','ESO 384- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114135,'IRAS','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114135,34.23,0.8,70.2,49763,75,NULL,'MAT, I','ESO 445- G 058',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000022,NULL,'13.85',0.9,'SB(r)bc        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,207.832,-31.14792,0.185,NULL,46853814789,732090856,11438919,13.85),(114136,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114136,33.61,0.43,52.7,49763,75,NULL,'MAT, I, raw','ESO 445- G 058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114137,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114137,33.65,0.32,53.8,49763,85,NULL,'I, raw','ESO 445- G 058',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114138,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114138,33.71,0.32,55.1,49763,85,NULL,'I, inv','ESO 445- G 058',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114139,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114139,33.76,NULL,56.5,49763,NULL,NULL,'B','ESO 445- G 058',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114140,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114140,33.81,0.43,57.7,49763,75,NULL,'MAT, I, cor','ESO 445- G 058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114141,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114141,33.83,0.43,58.5,49763,75,NULL,'MAT, I, inv','ESO 445- G 058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114142,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114142,33.9,NULL,60.2,49763,NULL,NULL,'I','ESO 445- G 058',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114143,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114143,34.09,0.47,65.7,49763,NULL,NULL,'H','ESO 445- G 058',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114144,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114144,34.16,0.46,67.8,49763,NULL,NULL,'J','ESO 445- G 058',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114145,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114145,34.2,0.08,69.3,49763,NULL,NULL,NULL,'ESO 445- G 058',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114146,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114146,34.21,0.45,69.4,49763,NULL,NULL,'K','ESO 445- G 058',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114147,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114147,34.23,0.4,70.1,49763,NULL,NULL,'mean','ESO 445- G 058',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114148,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114148,37.49,0.46,315,49764,70,NULL,NULL,'SDSS J135119.94+183947.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,207.833083,18.66322,0.017,NULL,58323802595,911309415,14239209,18.3),(114149,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114149,37.46,0.46,310,49765,70,NULL,NULL,'2MASX J13512006+2316219',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,207.8337083,23.27264,0,NULL,59458923159,929045674,14516338,17.5),(114150,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114150,37.51,0.46,318,49766,70,NULL,NULL,'2MASX J13512013+3831182',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000191,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,207.8337917,38.52161,0,NULL,59146101747,924157839,14439966,17.2),(114151,'TRGB','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114151,28.76,NULL,5.65,49767,NULL,NULL,NULL,'HIPASS J1351-47',NULL,'2007AJ....133..504K',2007,1,0.5,NULL,'G',0.000021,NULL,'17.5',0.3,NULL,NULL,NULL,NULL,NULL,1,207.799916667,-46.97025,0.641,NULL,46817007938,731515749,11429933,17.5),(114152,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114152,37.64,0.46,337,49768,70,NULL,NULL,'2MASX J13512221+1136217',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000155,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,207.842375,11.606,0,NULL,58461377182,913459018,14272797,17.8),(114153,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114153,38.14,0.46,425,49769,70,NULL,NULL,'2MASX J13512217+0729317',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,207.842417,7.49203,0,NULL,58430384489,912974757,14265230,17.3),(114154,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114154,38.25,0.46,447,49770,70,NULL,NULL,'2MASX J13512276+4508537',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000152,NULL,'16.7g',0.36,NULL,NULL,NULL,NULL,NULL,1,207.844666667,45.14828,0,NULL,59262307782,925973559,14468336,16.7),(114155,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114155,35.34,0.49,117,49771,70,NULL,NULL,'2MASX J13512288-1248145',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.9b',0.6,'Sa',NULL,NULL,NULL,NULL,1,207.8452917,-12.80419,0.125,NULL,43664701507,682260961,10660327,15.9),(114156,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114156,37.27,0.46,285,49772,70,NULL,NULL,'2MASX J13512428+5429208',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000177,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,207.851375,54.48908,0,NULL,57285012081,895078313,13985598,17),(114157,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114157,34.41,0.51,76.2,49773,70,NULL,NULL,'2MASX J13512523-2816236',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.6b',NULL,'S0',NULL,NULL,NULL,NULL,1,207.855166667,-28.27325,0.153,NULL,46855666153,732119783,11439371,15.6),(114158,'Tully est','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114158,32.89,0.8,37.8,49774,75,NULL,'B','MRK 0462',NULL,'1988NBGC.C....0000T',1988,1,0.71,NULL,'G',0.000011,NULL,'15.1g',0.69,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,207.8557083,40.21328,0,NULL,59271525129,926117580,14470587,15.1),(114159,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114159,32.77,0.4,35.8,49775,NULL,NULL,'mean','NGC 5342',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000017,NULL,'14.50',0.4,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,207.8577083,59.86394,0.005,NULL,57275684762,894932574,13983321,14.5),(114160,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114160,33.51,0.45,50.3,49775,NULL,NULL,'K','NGC 5342',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114161,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114161,37.7,0.27,347,49776,70,NULL,NULL,'2MASX J13512700+0637577',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,207.8625,6.63261,0,NULL,58427317846,912926841,14264481,18),(114162,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114162,37.32,0.33,291,49777,70,NULL,NULL,'2MASX J13512768+2443318',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000172,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,207.86525,24.72558,0,NULL,59996324678,937442573,14647540,17.1),(114163,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114163,36.74,0.46,222,49778,70,NULL,NULL,'MCG +06-30-106',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.00012,NULL,'15.2g',0.58,NULL,NULL,NULL,NULL,NULL,1,207.867583333,34.56678,0,NULL,59150263667,924222869,14440982,15.2),(114164,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114164,37.91,0.33,382,49779,70,NULL,NULL,'2MASX J13512955+1728026',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,207.873083333,17.4675,0,NULL,58379239356,912175614,14252743,17.4),(114165,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114165,37.61,0.16,332,49780,70,NULL,NULL,'2MASX J13512969+2936408',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00014,NULL,'17.50',0.27,'Sc',NULL,NULL,NULL,NULL,1,207.873875,29.6115,0,NULL,59130002722,923906292,14436035,17.5),(114166,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114166,37.91,0.33,382,49781,70,NULL,NULL,'SDSS J135130.00+173032.1',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.2g',0.36,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,207.875,17.50892,0,NULL,58379230188,912175471,14252741,16.2),(114167,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114167,36.49,0.46,199,49782,70,NULL,NULL,'2MASX J13513017+6256207',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.0001,NULL,'16.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,207.8757917,62.939,0.029,NULL,57747234210,902300534,14098445,16.2),(114168,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114168,34.83,0.45,92.5,49783,NULL,NULL,'K','IC 0944',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.00001,NULL,'14.33',0.5,'Sa','Pair member (points to parent)',NULL,NULL,NULL,1,207.878625,14.09222,0,NULL,58340068440,911563569,14243180,14.33),(114169,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114169,34.84,0.36,93.1,49783,NULL,NULL,'Malmquist cor.','IC 0944',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114170,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114170,34.87,0.47,94.3,49783,NULL,NULL,'H','IC 0944',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114171,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114171,34.91,0.35,95.7,49783,NULL,NULL,NULL,'IC 0944',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114172,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114172,34.99,0.46,99.4,49783,NULL,NULL,'J','IC 0944',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114173,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114173,35.04,0.4,102,49783,NULL,NULL,'mean','IC 0944',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114174,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114174,35.04,0.49,102,49783,75,NULL,'IR','IC 0944',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114175,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114175,35.27,0.2,113,49783,74.4,NULL,NULL,'IC 0944',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114176,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114176,37.05,0.13,257,49784,70,NULL,NULL,'SDSS J135131.50+092539.0',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,207.88125,9.4275,0.02,NULL,58467006765,913546980,14274171,17.4),(114177,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114177,37.26,0.11,283,49785,70,NULL,NULL,'SDSS J135131.54+461129.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000186,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,207.8815,46.19164,0,NULL,59240356945,925630577,14462977,17.8),(114178,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114178,36.06,0.74,163,49786,70,NULL,NULL,'2MASX J13513212-4256210',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.4,NULL,NULL,NULL,NULL,NULL,1,207.8837917,-42.93908,0.261,NULL,46920728717,733136386,11455256,14.4),(114179,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114179,34.98,0.49,98.9,49787,70,NULL,NULL,'2MASX J13513415-5022427',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,207.892375,-50.37853,0.865,NULL,46821836922,731591201,11431112,15.3),(114180,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114180,37.05,0.13,257,49788,70,NULL,NULL,'2MASX J13513459+0924513',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000182,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,207.8942917,9.41425,0.02,NULL,58467007923,913546998,14274171,16.8),(114181,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114181,37.99,0.46,396,49789,70,NULL,NULL,'SDSS J135134.83+072315.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'18.1g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,207.895125,7.38761,0,NULL,58430381495,912974710,14265229,18.1),(114182,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114182,32.55,0.5,32.4,49790,70,NULL,NULL,'ESO 221- G 013',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.00015,NULL,'13.80',1,'(R)SAB(r)0^+',NULL,NULL,NULL,NULL,1,207.896958333,-48.02658,0.685,NULL,46820330855,731567669,11430744,13.8),(114183,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114183,37.77,0.46,359,49791,70,NULL,NULL,'SDSS J135136.48+124913.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,207.9020417,12.82053,0,NULL,58341690527,911588914,14243576,18),(114184,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114184,37.3,0.46,289,49792,70,NULL,NULL,'2MASX J13513756+2623368',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,207.9065,26.39353,0,NULL,59997936599,937467759,14647933,16.9),(114185,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114185,37.86,0.33,373,49793,70,NULL,NULL,'2MASX J13513775+2950238',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000174,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,207.907333,29.84003,0,NULL,59130644783,923916324,14436192,17.9),(114186,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114186,35.95,0.8,155,49794,70,NULL,NULL,'2MASX J13513838-4143453',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,207.91,-41.72925,0.277,NULL,46925484114,733210689,11456417,14.9),(114187,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114187,37.8,0.33,364,49795,70,NULL,NULL,'2MASX J13513913+0149269',NULL,'2015arXiv151105856S',2015,1,0.18,'Autofib (1994MNRAS.267..541C) has z = 0.194 +- 0.001.','G',0.000075,NULL,'18.0g',0.17,'Sb-Sc',NULL,NULL,NULL,NULL,1,207.913167,1.82411,0.033,NULL,58447353492,913239898,14269373,18),(114188,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114188,35.5,0.17,126,49796,70,NULL,NULL,'GIN 335',NULL,'2001MNRAS.321..277C',2001,1,0.48,NULL,'G',0.000083,NULL,'16.1g',0.38,'E/S0',NULL,NULL,NULL,NULL,1,207.913625,24.68858,0,NULL,59995751275,937433613,14647400,16.1),(114189,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114189,37.32,0.33,291,49796,70,NULL,NULL,'GIN 335',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114190,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114190,33.99,0.23,62.8,49797,74.4,NULL,NULL,'ESO 445- G 059',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000014,NULL,'13.44',0.5,'E?','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,207.9147917,-30.48906,0.181,NULL,46854349504,732099211,11439050,13.44),(114191,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114191,34.24,0.5,70.4,49797,70,NULL,NULL,'ESO 445- G 059',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114192,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114192,34.07,0.4,65.2,49797,NULL,NULL,'mean','ESO 445- G 059',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114193,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114193,34.28,0.45,71.8,49797,NULL,NULL,'K','ESO 445- G 059',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114194,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114194,37.21,0.46,277,49798,70,NULL,NULL,'SDSS J135139.60+472112.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,207.9150417,47.35353,0.025,NULL,59211420324,925178442,14455913,18.2),(114195,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114195,37.05,0.13,257,49799,70,NULL,NULL,'2MASX J13513966+0926113',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000193,NULL,'15.8g',0.41,NULL,NULL,NULL,NULL,NULL,1,207.9152083,9.43647,0.02,NULL,58466993556,913546774,14274168,15.8),(114196,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114196,37.55,0.46,323,49800,70,NULL,NULL,'2MASX J13514120+2724038',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00018,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,207.921625,27.40122,0,NULL,59997534637,937461478,14647835,17.9),(114197,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114197,38.02,0.46,401,49801,70,NULL,NULL,'2MASX J13514156+4437398',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000151,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,207.923083,44.62778,0,NULL,59262172334,925971442,14468303,18.4),(114198,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114198,38.19,0.46,434,49802,70,NULL,NULL,'SDSS J135141.72+534144.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000147,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,207.923875,53.69558,0,NULL,57284142638,895064728,13985386,18.5),(114199,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114199,37.26,0.11,283,49803,70,NULL,NULL,'MCG +08-25-048',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000233,NULL,'15.3g',0.57,'E0',NULL,NULL,NULL,NULL,1,207.9245,46.36675,0,NULL,59240405183,925631330,14462989,15.3),(114200,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114200,37.26,0.11,283,49804,70,NULL,NULL,'2MASX J13514218+4611048',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000202,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,207.92575,46.18469,0,NULL,59240354569,925630540,14462977,16.4),(114201,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114201,35.95,0.33,155,49805,70,NULL,NULL,'CGCG 162-018',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.00015,NULL,'15.0g',0.52,'Sb',NULL,NULL,NULL,NULL,1,207.928208333,29.33194,0,NULL,59130224671,923909760,14436090,15),(114202,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114202,37.78,0.09,359,49806,70,NULL,NULL,'SDSS J135143.75+051039.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000127,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,207.9322917,5.17753,0,NULL,58439083151,913110674,14267354,18.4),(114203,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114203,35.69,0.56,137,49807,70,NULL,NULL,'2MASX J13514427-1716348',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,207.934458333,-17.27639,0.289,NULL,43676687782,682448246,10663253,15),(114204,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114204,38.53,0.46,509,49808,70,NULL,NULL,'SDSS J135145.69+564731.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000141,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,207.940417,56.79211,0,NULL,57295701781,895245340,13988208,18.5),(114205,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114205,37.05,0.13,257,49809,70,NULL,NULL,'2MASX J13514600+0945323',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000177,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,207.9417083,9.759,0,NULL,58467987465,913562304,14274411,17.7),(114206,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114206,37.02,0.33,254,49810,70,NULL,NULL,'2MASX J13514614+6647122',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000069,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,207.942375,66.78683,0.025,NULL,57871984795,904249762,14128902,17.3),(114207,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114207,37.05,0.46,258,49811,70,NULL,NULL,'SDSS J135146.65+100559.4',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.0g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,207.944375,10.09986,0,NULL,58468592374,913571755,14274558,17),(114208,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114208,37.26,0.11,283,49812,70,NULL,NULL,'2MASX J13514867+4624068',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000196,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,207.952875,46.40183,0,NULL,59240392738,925631136,14462986,16.6),(114209,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114209,36.54,0.46,203,49813,70,NULL,NULL,'2MASX J13514876+1033403',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,207.9529583,10.56111,0,NULL,58468154926,913564920,14274451,17.7),(114210,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114210,36.7,0.67,219,49814,70,NULL,NULL,'2MASX J13514978-0859278',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,207.957417,-8.991,0.081,NULL,43697783873,682777873,10668404,15.9),(114211,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114211,36.66,0.46,215,49815,70,NULL,NULL,'2MASX J13515119+3000287',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'17.93',0.35,NULL,NULL,NULL,NULL,NULL,1,207.963333,30.00808,0,NULL,59131170846,923924544,14436321,17.93),(114212,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114212,37.61,0.46,333,49816,70,NULL,NULL,'2MASX J13515256+4921359',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000148,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,207.969,49.36011,0,NULL,59212382572,925193477,14456148,17.6),(114213,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114213,37.38,0.19,300,49817,70,NULL,NULL,'2MASX J13515292+5609249',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000194,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,207.97075,56.15692,0,NULL,57295258918,895238420,13988100,16.5),(114214,'Tully est','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114214,32.26,0.8,28.4,49818,75,NULL,'B','UGCA 375',NULL,'1988NBGC.C....0000T',1988,1,NULL,NULL,'GPair',0.000015,NULL,NULL,NULL,'Irr(sa)        HII',NULL,NULL,NULL,NULL,1,207.972875,64.37228,0.025,NULL,57868341194,904192831,14128012,NULL),(114215,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114215,37.89,0.46,379,49819,70,NULL,NULL,'2MASX J13515374+6225038',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000107,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,207.9739583,62.41783,0.041,NULL,57260809067,894700141,13979689,16.9),(114216,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114216,34.37,NULL,74.7,49820,NULL,NULL,NULL,'FGC 1680',NULL,'2000BSAO...50....5K',2000,1,0.84,NULL,'G',0.000067,'?','17.0',0.09,'Sdm',NULL,NULL,NULL,NULL,1,207.975833,68.37444,0.037,NULL,57901743222,904714737,14136167,17),(114217,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114217,34.42,NULL,76.6,49820,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1680',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114218,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114218,34.44,NULL,77.2,49820,NULL,NULL,'Dipole + Quadrupole','FGC 1680',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114219,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114219,34.44,NULL,77.3,49820,NULL,NULL,'Dipole','FGC 1680',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114220,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114220,37.05,0.13,257,49821,70,NULL,NULL,'SDSS J135154.68+093051.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000165,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,207.977875,9.51439,0.02,NULL,58467959057,913561860,14274404,17.9),(114221,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114221,37.4,0.46,303,49822,70,NULL,NULL,'2MASX J13515486+0235225',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000074,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,207.9787083,2.58972,0.045,NULL,58445496061,913210875,14268919,17.9),(114222,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114222,36.06,0.46,163,49823,70,NULL,NULL,'2MASX J13515490+1952232',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.88',0.17,NULL,NULL,NULL,NULL,NULL,1,207.978833333,19.87319,0.034,NULL,58334179801,911471559,14241743,17.88),(114223,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114223,37.84,0.33,370,49824,70,NULL,NULL,'2MASX J13515538+0358365',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000192,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,207.98075,3.97683,0.033,NULL,58437784773,913090387,14267037,17.1),(114224,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114224,35.57,0.17,130,49825,70,NULL,NULL,'2MASX J13515580+2159192',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.70',0.28,NULL,NULL,NULL,NULL,NULL,1,207.982541667,21.98861,0.019,NULL,58320050805,911250793,14238293,16.7),(114225,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114225,36.92,0.27,242,49826,70,NULL,NULL,'2MASX J13515631+1810502',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.43',0.15,NULL,NULL,NULL,NULL,NULL,1,207.98475,18.18069,0.006,NULL,58323005263,911296957,14239014,18.43),(114226,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114226,37.57,0.46,326,49827,70,NULL,NULL,'2MASX J13515689+4851019',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,207.98725,48.85069,0,NULL,59212709572,925198587,14456227,17.8),(114227,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114227,37.39,0.46,300,49828,70,NULL,NULL,'SDSS J135156.96+332201.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000129,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,207.987375,33.36717,0,NULL,59185318340,924770599,14449540,18.5),(114228,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114228,35.64,0.54,134,49829,70,NULL,NULL,'2MASX J13515709-5047167',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,207.987833333,-50.78792,0.865,NULL,46821705474,731589148,11431080,16.9),(114229,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114229,37.02,0.33,254,49830,70,NULL,NULL,'2MASX J13515715+6653312',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000089,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,207.988125,66.89197,0.025,NULL,57872175136,904252736,14128949,17),(114230,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114230,37.85,0.46,372,49831,70,NULL,NULL,'2MASX J13515721+5709059',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000147,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,207.988458333,57.15172,0,NULL,57297554007,895274281,13988660,17.5),(114231,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114231,34.72,0.46,87.7,49832,70,NULL,NULL,'CGCG 017-080',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000096,NULL,'14.6g',0.63,'S0^-','Group member',NULL,NULL,NULL,1,207.989,2.00336,0.025,NULL,58447207389,913237615,14269337,14.6),(114232,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114232,37.78,0.09,359,49833,70,NULL,NULL,'SDSS J135158.15+052815.8',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000154,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,207.992333,5.47106,0.023,NULL,58438885409,913107584,14267306,17.7),(114233,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114233,38.07,0.46,411,49834,70,NULL,NULL,'2MASX J13515839+1735065',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.40',0.15,NULL,NULL,NULL,NULL,NULL,1,207.993416667,17.58528,0,NULL,58379441028,912178766,14252793,18.4),(114234,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114234,37.7,0.46,347,49835,70,NULL,NULL,'2MASX J13515905+0739104',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00017,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,207.9960417,7.65292,0,NULL,58458388533,913412320,14272067,17.8),(114235,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114235,38,0.27,398,49836,70,NULL,NULL,'2MASX J13515919+1349275',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000174,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,207.996791667,13.82428,0,NULL,58340120336,911564380,14243193,16.6),(114236,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114236,35.2,0.46,110,49837,70,NULL,NULL,'2MASX J13515967+0228115',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000082,NULL,'16.0g',0.34,'S0',NULL,NULL,NULL,NULL,1,207.998708333,2.46994,0.045,NULL,58445484242,913210691,14268917,16),(114237,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114237,37.77,0.46,357,49838,70,NULL,NULL,'2MASX J13515972+1533205',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.05',0.14,NULL,NULL,NULL,NULL,NULL,1,207.99875,15.55572,0,NULL,58377470373,912147974,14252312,18.05),(114238,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114238,37.26,0.11,283,49839,70,NULL,NULL,'2MASX J13520044+4627059',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000174,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,208.00175,46.45183,0,NULL,59240393906,925631154,14462986,16.9),(114239,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114239,38.38,0.46,474,49840,70,NULL,NULL,'2MASX J13520053+3129297',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,208.00225,31.49131,0,NULL,59127411476,923865804,14435403,18),(114240,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114240,36.16,0.56,171,49841,70,NULL,NULL,'2MASX J13520069-1431246',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.6b',0.3,NULL,NULL,NULL,NULL,NULL,1,208.002833333,-14.52353,0.197,NULL,43664976347,682265255,10660394,16.6),(114241,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114241,38,0.27,398,49842,70,NULL,NULL,'SDSS J135201.04+134940.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000166,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,208.004375,13.82806,0,NULL,58340120287,911564379,14243193,18.6),(114242,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114242,36.79,0.65,228,49843,70,NULL,NULL,'2MASX J13520119-4409078',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.7I',0.4,NULL,NULL,NULL,NULL,NULL,1,208.004958333,-44.15225,0.349,NULL,46921432394,733147381,11455427,14.7),(114243,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114243,37.55,0.46,323,49844,70,NULL,NULL,'2MASX J13520160+0251535',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000081,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,208.006667,2.86494,0.041,NULL,58445409407,913209521,14268898,17.4),(114244,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114244,37.47,0.46,312,49845,70,NULL,NULL,'2MASX J13520182+6255488',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000153,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,208.007833,62.93031,0.033,NULL,57747222539,902300352,14098443,17.4),(114245,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114245,38.18,0.46,432,49846,70,NULL,NULL,'SDSS J135202.20+411141.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,208.009167,41.19494,0,NULL,59273558306,926149348,14471083,18.7),(114246,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114246,37.05,0.13,257,49847,70,NULL,NULL,'UGC 08769',NULL,'2015arXiv151105856S',2015,1,1.06,NULL,'G',0.000117,NULL,'14.7g',0.69,'S0-:',NULL,NULL,NULL,NULL,1,208.012917,9.53128,0.02,NULL,58468026962,913562921,14274420,14.7),(114247,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114247,36.98,0.46,249,49848,70,NULL,NULL,'2MASX J13520322+3820070',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000173,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,208.013583,38.33533,0,NULL,59146175460,924158991,14439984,16.4),(114248,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114248,32.95,0.47,39,49849,NULL,NULL,'H','NGC 5327',NULL,'2007A&A...465...71T',2007,1,1.21,NULL,'G',0.00001,NULL,'13.7g',1.13,'SAB(rs)b:','Pair member, E + E',NULL,NULL,NULL,1,208.017375,-2.20661,0.145,NULL,43610662635,681416603,10647134,13.7),(114249,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114249,33.15,0.46,42.6,49849,NULL,NULL,'J','NGC 5327',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114250,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114250,33.16,0.45,42.9,49849,NULL,NULL,'K','NGC 5327',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114251,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114251,33.92,0.4,60.8,49849,NULL,NULL,'mean','NGC 5327',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114252,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114252,37.7,0.27,347,49850,70,NULL,NULL,'2MASX J13520472+0637134',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000184,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,208.019583,6.62047,0,NULL,58427499455,912929678,14264526,17.1),(114253,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114253,38.35,0.46,467,49851,70,NULL,NULL,'2MASX J13520473+1310165',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000169,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,208.0197083,13.17117,0,NULL,58341356792,911583699,14243495,17.8),(114254,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114254,39.25,0.46,709,49852,70,NULL,NULL,'2MASX J13520519+1230345',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,208.0217083,12.50967,0,NULL,58341610405,911587662,14243557,17.7),(114255,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114255,36.91,0.33,241,49853,70,NULL,NULL,'2MASX J13520585+4000390',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000167,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,208.0245,40.01072,0,NULL,59271413587,926115837,14470559,16.5),(114256,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114256,32.12,0.46,26.6,49854,NULL,NULL,'J','NGC 5324',NULL,'2007A&A...465...71T',2007,1,2.3,NULL,'G',0.000005,NULL,'12.55',2.1,'SA(rs)c:',NULL,NULL,NULL,NULL,1,208.0245417,-6.05831,0.061,NULL,43574920927,680858139,10638408,12.55),(114257,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114257,32.13,0.47,26.7,49854,NULL,NULL,'H','NGC 5324',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114258,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114258,32.2,0.45,27.6,49854,NULL,NULL,'K','NGC 5324',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114259,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114259,33.1,0.4,41.6,49854,NULL,NULL,'mean','NGC 5324',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114260,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114260,33.22,0.4,44,49854,75,NULL,'B','NGC 5324',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114261,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114261,38.33,0.46,463,49855,70,NULL,NULL,'2MASX J13520614+3442330',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,208.025625,34.70914,0,NULL,59151155895,924236810,14441200,17.8),(114262,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114262,37.05,0.13,257,49856,70,NULL,NULL,'2MASX J13520662+1006394',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000186,NULL,'15.9g',0.41,NULL,NULL,NULL,NULL,NULL,1,208.027417,10.11089,0,NULL,58468583286,913571613,14274556,15.9),(114263,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114263,33.47,0.4,49.5,49857,NULL,NULL,'mean','UGC 08778',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000063,NULL,'14.2g',0.41,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,208.0277917,38.06703,0,NULL,59146892461,924170194,14440159,14.2),(114264,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114264,33.76,0.47,56.5,49857,NULL,NULL,'H','UGC 08778',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114265,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114265,33.78,0.49,57,49857,75,NULL,'IR','UGC 08778',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114266,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114266,33.8,0.46,57.5,49857,NULL,NULL,'J','UGC 08778',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114267,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114267,33.91,0.45,60.4,49857,NULL,NULL,'K','UGC 08778',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114268,'IRAS','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114268,32.69,0.8,34.5,49858,75,NULL,'MAT, I','ESO 221- G 014',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'13.31',1.1,'SAB(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,208.029,-48.1705,0.685,NULL,46820468387,731569818,11430778,13.31),(114269,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114269,32.72,0.43,34.9,49858,75,NULL,'MAT, I, raw','ESO 221- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114270,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114270,32.83,0.32,36.8,49858,85,NULL,'I, raw','ESO 221- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114271,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114271,32.88,0.32,37.6,49858,85,NULL,'I, inv','ESO 221- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114272,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114272,32.91,0.43,38.3,49858,75,NULL,'MAT, I, inv','ESO 221- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114273,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114273,33,0.45,39.7,49858,NULL,NULL,'K','ESO 221- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114274,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114274,33.01,0.46,39.9,49858,NULL,NULL,'J','ESO 221- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114275,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114275,33.01,0.43,40,49858,75,NULL,'MAT, I, cor','ESO 221- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114276,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114276,33.02,0.47,40.1,49858,NULL,NULL,'H','ESO 221- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114277,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114277,33.09,0.4,41.5,49858,NULL,NULL,'mean','ESO 221- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114278,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114278,38,0.27,398,49859,70,NULL,NULL,'SDSS J135206.92+135017.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,208.028875,13.83814,0,NULL,58340135499,911564617,14243197,18.6),(114279,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114279,37.05,0.13,257,49860,70,NULL,NULL,'2MASX J13520730+0931324',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000188,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,208.030417,9.52567,0.02,NULL,58468037951,913563092,14274423,16.5),(114280,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114280,36.43,0.93,193,49861,70,NULL,NULL,'2MASX J13520787-3251438',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00014,NULL,'15.4',NULL,'S',NULL,NULL,NULL,NULL,1,208.0327917,-32.86219,0.213,NULL,46900030367,732812974,11450202,15.4),(114281,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114281,34.59,0.46,82.9,49862,70,NULL,NULL,'NGC 5332',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000103,NULL,'13.95',0.9,'S0-:',NULL,NULL,NULL,NULL,1,208.033,16.96975,0,NULL,58378993348,912171771,14252683,13.95),(114282,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114282,35.03,0.4,101,49862,NULL,NULL,'mean','NGC 5332',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114283,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114283,35.5,0.45,126,49862,NULL,NULL,'K','NGC 5332',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114284,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114284,33.41,0.25,48.1,49863,74.4,NULL,NULL,'ESO 445- G 062',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000067,NULL,'15.43',0.2,'S0',NULL,NULL,NULL,NULL,1,208.0332083,-30.45164,0.181,NULL,46854329413,732098897,11439045,15.43),(114285,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114285,34.83,0.46,92.4,49864,NULL,NULL,'Malmquist cor.','IC 0946',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.00014,NULL,'14.0g',0.82,'Sa','in a radial-velocity based grouping',NULL,NULL,NULL,1,208.034833333,14.11622,0,NULL,58340559034,911571234,14243300,14),(114286,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114286,35.06,0.42,103,49864,NULL,NULL,NULL,'IC 0946',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114287,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114287,35.1,0.2,105,49864,74.4,NULL,NULL,'IC 0946',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114288,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114288,37.33,0.23,292,49865,70,NULL,NULL,'2MASX J13520906+3731060',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000172,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,208.037833,37.51836,0,NULL,59146732787,924167699,14440120,17.3),(114289,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114289,38.45,0.46,489,49866,70,NULL,NULL,'SDSS J135209.59+133819.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000143,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,208.0399583,13.63878,0,NULL,58341867614,911591681,14243620,18.4),(114290,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114290,37.05,0.13,257,49867,70,NULL,NULL,'SDSS J135209.59+095226.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,208.04,9.87403,0,NULL,58468548778,913571074,14274548,17.7),(114291,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114291,35.13,0.4,106,49868,NULL,NULL,'mean','NGC 5329',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000103,NULL,'13.37',1.3,'E:','Group member',NULL,NULL,NULL,1,208.0420417,2.32511,0.029,NULL,58445299552,913207805,14268871,13.37),(114292,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114292,35.34,0.45,117,49868,NULL,NULL,'K','NGC 5329',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114293,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114293,37.28,0.46,286,49869,70,NULL,NULL,'2MASX J13521030+2128042',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.72',0.22,NULL,NULL,NULL,NULL,NULL,1,208.043083,21.46778,0.008,NULL,58320309588,911254837,14238356,17.72),(114294,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114294,32.46,NULL,31,49870,72,NULL,NULL,'SDSS J135210.84+053013.8',NULL,'2014Ap.....57..457K',2014,1,0.61,NULL,'G',0.00011,NULL,'17.70',0.15,NULL,NULL,NULL,NULL,NULL,1,208.0452083,5.50383,0.027,NULL,58438866832,913107294,14267301,17.7),(114295,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114295,36.28,0.46,181,49871,70,NULL,NULL,'2MASX J13521141+0243215',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000063,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,208.047667,2.72278,0.041,NULL,58445448375,913210130,14268908,17),(114296,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114296,36.9,0.46,240,49872,70,NULL,NULL,'2MASX J13521143+2328511',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.54',0.14,NULL,NULL,NULL,NULL,NULL,1,208.04775,23.48103,0,NULL,59459276910,929051201,14516425,18.54),(114297,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114297,37.05,0.13,257,49873,70,NULL,NULL,'2MASX J13521190+0958124',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.0002,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,208.0495,9.97017,0,NULL,58468563022,913571297,14274551,16.3),(114298,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114298,35.31,0.46,115,49874,70,NULL,NULL,'2MASX J13521290+1631115',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.24',0.23,NULL,NULL,NULL,NULL,NULL,1,208.053833,16.51989,0,NULL,58377698517,912151539,14252367,16.24),(114299,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114299,37.33,0.23,292,49875,70,NULL,NULL,'2MASX J13521393+3736160',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000179,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,208.0579583,37.60436,0,NULL,59146611239,924165800,14440090,17.1),(114300,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114300,37.72,0.46,349,49876,70,NULL,NULL,'2MASX J13521454+3931190',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000134,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,208.0605417,39.522,0,NULL,59266635021,926041172,14469393,18.2),(114301,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114301,37.45,0.46,308,49877,70,NULL,NULL,'2MASX J13521520+2810405',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000199,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,208.063458333,28.17797,0,NULL,59129210301,923893910,14435842,16.3),(114302,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114302,36.83,0.46,232,49878,70,NULL,NULL,'2MASX J13521522+3856060',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000179,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,208.063625,38.93508,0,NULL,59266719010,926042484,14469413,16.4),(114303,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114303,36.91,0.33,241,49879,70,NULL,NULL,'2MASX J13521525+4008570',NULL,'2015arXiv151105856S',2015,1,0.91,NULL,'G',0.00013,NULL,'15.4g',0.44,'E0',NULL,NULL,NULL,NULL,1,208.06375,40.14914,0,NULL,59271369366,926115146,14470549,15.4),(114304,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114304,35.78,0.54,143,49880,70,NULL,NULL,'2MASX J13521531-2900144',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.1b',NULL,'S0',NULL,NULL,NULL,NULL,1,208.0637917,-29.00406,0.237,NULL,46852294561,732067102,11438548,16.1),(114305,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114305,37.5,0.46,316,49881,70,NULL,NULL,'2MASX J13521637+3950150',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,208.06825,39.83736,0,NULL,59271363260,926115050,14470547,18.4),(114306,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114306,32.68,0.2,34.4,49882,74.4,NULL,NULL,'ESO 384- G 005',NULL,'2013AJ....146...86T',2013,1,1.9,NULL,'G',0.000007,NULL,'15.34',0.3,'SB(s)dm: sp','in a triple',NULL,NULL,NULL,1,208.068583,-37.45656,0.277,NULL,46885454592,732585228,11446644,15.34),(114307,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114307,32.76,0.71,35.6,49882,NULL,NULL,NULL,'ESO 384- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114308,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114308,33.05,0.62,40.8,49882,NULL,NULL,'Malmquist cor.','ESO 384- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114309,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114309,35.01,0.2,100,49883,74.4,NULL,NULL,'IC 0949',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.00002,NULL,'15.15',0.4,'Sdm:',NULL,NULL,NULL,NULL,1,208.069833333,22.52158,0,NULL,59460086572,929063852,14516622,15.15),(114310,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114310,37.26,0.11,283,49884,70,NULL,NULL,'2MASX J13521699+4627440',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000166,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,208.07075,46.46231,0,NULL,59240567347,925633864,14463029,16.8),(114311,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114311,37.84,0.33,370,49885,70,NULL,NULL,'SDSS J135217.39+040226.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000145,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,208.0725,4.04075,0.032,NULL,58437758082,913089970,14267030,18.4),(114312,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114312,37.23,0.46,279,49886,70,NULL,NULL,'2MASX J13521811+2746235',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000182,NULL,'17.63',0.22,NULL,NULL,NULL,NULL,NULL,1,208.0752917,27.77317,0,NULL,59997479360,937460615,14647822,17.63),(114313,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114313,37.3,0.46,288,49887,70,NULL,NULL,'2MASX J13521809+0758064',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000176,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,208.0755,7.96842,0.014,NULL,58459570877,913430794,14272356,16.6),(114314,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114314,37.54,0.17,322,49888,70,NULL,NULL,'2MASX J13521902-0228306',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000181,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,208.079333333,-2.47519,0.105,NULL,43611310220,681426722,10647292,16.9),(114315,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114315,36.4,0.46,190,49889,70,NULL,NULL,'2MASX J13521953+4355290',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000185,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,208.0814583,43.92472,0,NULL,59265294903,926020232,14469066,16.2),(114316,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114316,37.38,0.19,300,49890,70,NULL,NULL,'2MASX J13521950+5608065',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000182,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,208.081625,56.13508,0,NULL,57308906697,895451667,13991432,17.6),(114317,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114317,37.2,0.46,276,49891,70,NULL,NULL,'VII Zw 529',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00018,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,208.081917,62.41456,0.041,NULL,57261515040,894711172,13979862,16.9),(114318,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114318,37.38,0.46,300,49892,70,NULL,NULL,'2MASX J13521979+1808122',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.81',0.18,NULL,NULL,NULL,NULL,NULL,1,208.0825,18.13667,0.006,NULL,58378522197,912164409,14252568,17.81),(114319,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114319,35.13,0.65,106,49893,NULL,NULL,'Malmquist cor.','2MASX J13522123+3811450',NULL,'2009ApJS..182..474S',2009,1,0.62,NULL,'G',0.000067,NULL,'15.7g',0.35,NULL,NULL,NULL,NULL,NULL,1,208.0885,38.19589,0,NULL,59146855602,924169618,14440150,15.7),(114320,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114320,35.39,0.58,119,49893,NULL,NULL,NULL,'2MASX J13522123+3811450',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114321,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114321,35.43,0.2,122,49893,74.4,NULL,NULL,'2MASX J13522123+3811450',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114322,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114322,35.87,0.54,149,49894,70,NULL,NULL,'2MASX J13522163-1342166',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.4b',0.4,NULL,NULL,NULL,NULL,NULL,1,208.090125,-13.70472,0.213,NULL,43665489064,682273266,10660519,16.4),(114323,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114323,35.24,0.47,112,49895,NULL,NULL,'H','UGC 08781',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.00005,NULL,'14.15',0.8,'SBb            AGN','Group member',NULL,NULL,NULL,1,208.0947917,21.53936,0.008,NULL,58320716920,911261201,14238456,14.15),(114324,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114324,35.3,0.46,115,49895,NULL,NULL,'J','UGC 08781',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114325,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114325,35.33,0.45,116,49895,NULL,NULL,'K','UGC 08781',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114326,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114326,35.33,0.4,117,49895,NULL,NULL,'mean','UGC 08781',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114327,'Sosies','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114327,33.59,0.43,52.2,49896,NULL,NULL,NULL,'NGC 5337',NULL,'2002A&A...393...57T',2002,1,1.7,NULL,'G',0.000057,NULL,'13.46',0.8,'S?','in a radial-velocity based grouping',NULL,NULL,NULL,1,208.095958333,39.68725,0,NULL,59270889562,926107649,14470432,13.46),(114328,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114328,37.41,0.33,303,49897,70,NULL,NULL,'2MASX J13522339+3712370',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000176,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,208.097625,37.21028,0,NULL,59154684168,924291940,14442061,17.1),(114329,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114329,35.63,0.49,134,49898,70,NULL,NULL,'ESO 578- G 001',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.10',0.9,'S0',NULL,NULL,NULL,NULL,1,208.101166667,-20.38244,0.225,NULL,43637421128,681834705,10653667,15.1),(114330,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114330,36.92,0.46,242,49899,70,NULL,NULL,'2MASX J13522495+1907323',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.55',0.2,NULL,NULL,NULL,NULL,NULL,1,208.10375,19.12578,0.037,NULL,58331206637,911425103,14241017,17.55),(114331,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114331,36.31,0.49,183,49900,70,NULL,NULL,'ESO 384- G 007',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000133,NULL,'14.68',0.6,'S0?',NULL,NULL,NULL,NULL,1,208.105125,-34.93356,0.197,NULL,46881739195,732527174,11445737,14.68),(114332,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114332,37.13,0.46,266,49901,70,NULL,NULL,'2MASX J13522561+3656139',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000194,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,208.106583,36.93736,0,NULL,59155688510,924307632,14442306,16.8),(114333,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114333,37.71,0.46,349,49902,70,NULL,NULL,'2MASX J13522625+2038153',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.40',0.16,NULL,NULL,NULL,NULL,NULL,1,208.109333333,20.63767,0.011,NULL,58331627149,911431674,14241119,18.4),(114334,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114334,35.02,0.46,101,49903,70,NULL,NULL,'IC 0948',NULL,'2015arXiv151105856S',2015,1,1.3,NULL,'G',0.000103,NULL,'14.09',0.7,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,208.111291667,14.09128,0,NULL,58340625337,911572270,14243316,14.09),(114335,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114335,35.03,0.4,102,49903,NULL,NULL,'mean','IC 0948',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114336,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114336,35.39,0.45,120,49903,NULL,NULL,'K','IC 0948',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114337,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114337,37.95,0.46,389,49904,70,NULL,NULL,'2MASX J13522701+0652263',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000185,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,208.112375,6.874,0,NULL,58427013890,912922092,14264407,16.8),(114338,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,NULL,114338,36.74,0.69,223,49905,70,NULL,NULL,'2MASX J13522688-3221589',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.3b',NULL,'S0',NULL,NULL,NULL,NULL,1,208.1125,-32.36617,0.237,NULL,46896847023,732763234,11449425,16.3),(114339,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114339,37.33,0.23,292,49906,70,NULL,NULL,'2MASX J13522752+3730078',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000182,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,208.114833,37.50222,0,NULL,59146604343,924165692,14440088,17.6),(114340,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114340,37.05,0.13,257,49907,70,NULL,NULL,'2MASX J13522869+1006343',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,208.119417,10.10967,0,NULL,58468359022,913568109,14274501,17.6),(114341,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114341,38.08,0.46,414,49908,70,NULL,NULL,'2MASX J13522879+5321583',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000135,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,208.11975,53.36614,0,NULL,59216866944,925263546,14457242,17.6),(114342,'FP','2016-12-15 15:15:19','2016-12-16 11:20:31','1',NULL,'R',114342,37.54,0.17,322,49909,70,NULL,NULL,'LCRS B134954.4-022426',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000143,NULL,'16.2g',0.32,'E0',NULL,NULL,NULL,NULL,1,208.122667,-2.65347,0.105,NULL,43611158555,681424352,10647255,16.2),(114343,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114343,37.64,0.46,338,49910,70,NULL,NULL,'SDSS J135230.36+270143.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'17.8g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,208.1265,27.02883,0,NULL,59998377386,937474646,14648041,17.8),(114344,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114344,37.43,0.46,306,49911,70,NULL,NULL,'2MASX J13523068+3243561',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.11',0.15,NULL,NULL,NULL,NULL,NULL,1,208.1277083,32.73231,0,NULL,59185434630,924772416,14449569,18.11),(114345,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114345,36.95,0.46,245,49912,70,NULL,NULL,'2MASX J13523069+1043124',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.46',0.22,NULL,NULL,NULL,NULL,NULL,1,208.127958333,10.72011,0,NULL,58466202652,913534416,14273975,17.46),(114346,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114346,36.24,0.54,177,49913,70,NULL,NULL,'2MASX J13523080-2756234',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00009,NULL,'14.6',NULL,'E',NULL,NULL,NULL,NULL,1,208.128375,-27.93983,0.161,NULL,46977256130,734019627,11469056,14.6),(114347,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114347,37,0.19,251,49914,70,NULL,NULL,'2MASX J13523084+3312201',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.72',0.24,NULL,NULL,NULL,NULL,NULL,1,208.1285,33.20547,0,NULL,59185352369,924771130,14449548,16.72),(114348,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114348,35.57,0.17,130,49915,70,NULL,NULL,'2MASX J13523117+2134233',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.20',0.26,NULL,NULL,NULL,NULL,NULL,1,208.129875,21.57314,0.008,NULL,58320721213,911261268,14238457,17.2),(114349,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114349,37.92,0.46,384,49916,70,NULL,NULL,'2MASX J13523268+3458281',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,208.136291667,34.97442,0,NULL,59151082001,924235656,14441182,17.6),(114350,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114350,37.86,0.46,373,49917,70,NULL,NULL,'2MASX J13523299+0140338',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000081,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,208.1375,1.67608,0.009,NULL,58447153732,913236777,14269324,17.8),(114351,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114351,37.41,0.46,304,49918,70,NULL,NULL,'SDSS J135233.64+310811.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,208.1402083,31.13644,0,NULL,59127473474,923866773,14435418,17.5),(114352,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114352,38.14,0.46,426,49919,70,NULL,NULL,'2MASX J13523398+4629500',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,208.141416667,46.49714,0,NULL,59240568559,925633883,14463029,17.9),(114353,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114353,36.92,0.46,242,49920,70,NULL,NULL,'2MASX J13523520+1648331',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,208.14675,16.80925,0,NULL,58378955501,912171179,14252674,17.8),(114354,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114354,36.65,0.27,214,49921,70,NULL,NULL,'2MASX J13523532+2026313',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.13',0.16,NULL,NULL,NULL,NULL,NULL,1,208.147208333,20.44214,0.021,NULL,58333462839,911460356,14241568,18.13),(114355,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114355,36.87,0.46,236,49922,70,NULL,NULL,'2MASX J13523567+1907513',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.31',0.2,NULL,NULL,NULL,NULL,NULL,1,208.1485417,19.131,0.032,NULL,58331225505,911425398,14241021,17.31),(114356,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114356,31.29,0.45,18.1,49923,NULL,NULL,'K','IC 0947',NULL,'2007A&A...465...71T',2007,1,1.7,'The APM image includes a bright superposed star.','G',0.000067,NULL,'13.61',1.1,'S0- pec?',NULL,NULL,NULL,NULL,1,208.149583,0.81836,0.061,NULL,58444365741,913193214,14268643,13.61),(114357,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114357,33.91,0.4,60.6,49923,NULL,NULL,'mean','IC 0947',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114358,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114358,37.62,0.46,334,49924,70,NULL,NULL,'2MASX J13523665+5459056',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000151,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,208.15275,54.98483,0,NULL,57283493501,895054585,13985227,17.2),(114359,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114359,36.47,0.59,197,49925,70,NULL,NULL,'2MASX J13523729-2802084',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000117,NULL,'15.3',NULL,'S',NULL,NULL,NULL,NULL,1,208.1555,-28.03578,0.161,NULL,46990885115,734232579,11472384,15.3),(114360,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114360,35.29,0.25,114,49926,74.4,NULL,NULL,'UGC 08788',NULL,'2013AJ....146...86T',2013,1,0.99,NULL,'G',0.000123,NULL,'14.2g',0.81,'S0/a',NULL,NULL,NULL,NULL,1,208.156,24.74886,0,NULL,59995791428,937434241,14647410,14.2),(114361,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114361,35.5,0.17,126,49926,70,NULL,NULL,'UGC 08788',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114362,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114362,35.67,0.16,136,49926,70,NULL,NULL,'UGC 08788',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114363,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114363,36.92,0.27,242,49927,70,NULL,NULL,'2MASX J13523782+1806513',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.90',0.27,NULL,NULL,NULL,NULL,NULL,1,208.157625,18.11414,0,NULL,58378650166,912166408,14252600,16.9),(114364,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114364,37.26,0.11,283,49928,70,NULL,NULL,'CGCG 246-024',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000255,NULL,'15.0g',0.62,'BrClG',NULL,NULL,NULL,NULL,1,208.160583,46.34986,0,NULL,59240372716,925630823,14462981,15),(114365,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114365,36.5,0.54,199,49929,70,NULL,NULL,'2MASX J13523859-3253161',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000022,NULL,'16.4b',0.5,'E;BrClG','Brightest group member',NULL,NULL,NULL,1,208.1607917,-32.88778,0.221,NULL,46900020664,732812822,11450200,16.4),(114366,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114366,37.1,0.46,263,49930,70,NULL,NULL,'2MASX J13523893+2759159',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000172,NULL,'17.9',0.21,NULL,NULL,NULL,NULL,NULL,1,208.162333,27.98778,0,NULL,59997424994,937459765,14647808,17.9),(114367,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114367,36.52,0.46,201,49931,70,NULL,NULL,'2MASX J13524031+2543209',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000167,NULL,'16.2g',0.42,NULL,NULL,NULL,NULL,NULL,1,208.1682083,25.72247,0,NULL,59998931783,937483309,14648176,16.2),(114368,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114368,38.19,0.46,434,49932,70,NULL,NULL,'2MASX J13524070+3415516',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000147,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,208.169625,34.26431,0,NULL,59150612979,924228327,14441067,17.4),(114369,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114369,35.67,0.16,136,49933,70,NULL,NULL,'2MASX J13524113+2501019',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000164,NULL,'16.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,208.171333,25.01728,0,NULL,59995663342,937432239,14647378,16.2),(114370,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114370,37.05,0.13,257,49934,70,NULL,NULL,'2MASX J13524124+0954175',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000176,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,208.171833,9.90478,0.052,NULL,58468373824,913568341,14274505,16.9),(114371,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114371,36.49,0.46,199,49935,70,NULL,NULL,'2MASX J13524149+3632359',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000182,NULL,'16.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,208.1727917,36.54339,0,NULL,59153008214,924265753,14441652,16.3),(114372,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114372,37.65,0.27,339,49936,70,NULL,NULL,'2MASX J13524294+0944005',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.91',0.17,NULL,NULL,NULL,NULL,NULL,1,208.178833333,9.73361,0.04,NULL,58467901278,913560957,14274389,17.91),(114373,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114373,37.78,0.09,359,49937,70,NULL,NULL,'2MASX J13524416+0459368',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000159,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,208.183875,4.99358,0.023,NULL,58439010406,913109537,14267336,18),(114374,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114374,37.78,0.09,359,49938,70,NULL,NULL,'SDSS J135244.30+050548.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000168,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,208.184583,5.09681,0,NULL,58439018533,913109664,14267338,18.6),(114375,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114375,37.78,0.09,359,49939,70,NULL,NULL,'2MASX J13524449+0455398',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,208.18525,4.92775,0.023,NULL,58439190899,913112357,14267380,17.8),(114376,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114376,38.11,0.46,420,49940,70,NULL,NULL,'2MASX J13524489+0729515',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,208.1869583,7.49767,0,NULL,58456596435,913384319,14271629,17.7),(114377,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114377,35.29,0.25,114,49941,74.4,NULL,NULL,'CGCG 132-031',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000083,NULL,'13.92',0.7,'E/S0',NULL,NULL,NULL,NULL,1,208.187083,25.03997,0,NULL,59995663607,937432243,14647378,13.92),(114378,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114378,35.5,0.17,126,49941,70,NULL,NULL,'CGCG 132-031',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114379,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114379,37.62,0.33,334,49942,70,NULL,NULL,'SDSS J135245.21+200810.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'17.8g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,208.188417,20.13631,0.016,NULL,58333948690,911467948,14241686,17.8),(114380,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114380,37.62,0.33,334,49943,70,NULL,NULL,'2MASX J13524529+2004524',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,208.1885417,20.08125,0.038,NULL,58333953930,911468030,14241687,17.9),(114381,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114381,37.78,0.09,359,49944,70,NULL,NULL,'2MASX J13524603+0508268',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,208.1917083,5.14075,0,NULL,58439039441,913109991,14267343,18.1),(114382,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114382,33.42,0.25,48.3,49945,74.4,NULL,NULL,'ESO 445- G 065',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000011,NULL,'14.23',0.2,'S0?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,208.191833,-29.92975,0.189,NULL,46854149309,732096082,11439001,14.23),(114383,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114383,37.07,0.23,259,49946,70,NULL,NULL,'2MASX J13524631+1943114',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.96',0.16,NULL,NULL,NULL,NULL,NULL,1,208.192958333,19.71986,0.034,NULL,58334047620,911469494,14241710,17.96),(114384,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:32','1','SN 2006bu',NULL,114384,37.33,0.19,270,49947,74.2,NULL,'SALT 2','2MASX J13524703+0518496',0.0843,'2010ApJ...716..712A',2010,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,208.196,5.31383,0,NULL,58438854587,913107102,14267298,17.9),(114385,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:32','1','SN 2006bu',NULL,114385,37.96,0.14,390,49947,65,NULL,'MLCS17','2MASX J13524703+0518496',NULL,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114386,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:32','1','SN 2006bu',NULL,114386,38.02,0.13,401,49947,65,NULL,'MLCS31','2MASX J13524703+0518496',NULL,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114387,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:32','1','SN 2006bu',NULL,114387,38.13,0.23,423,49947,65,NULL,'SALT2','2MASX J13524703+0518496',NULL,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114388,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:32','1','SN 2006bu',NULL,114388,38.14,0.19,425,49947,65,NULL,'SALT','2MASX J13524703+0518496',NULL,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114389,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114389,37.48,0.46,314,49948,70,NULL,NULL,'2MASX J13524706+2733139',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00017,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,208.196125,27.55375,0,NULL,59997660003,937463437,14647866,16.7),(114390,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114390,37.12,0.46,266,49949,70,NULL,NULL,'2MASX J13524722+0841395',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,208.196791667,8.69417,0.006,NULL,58459258976,913425921,14272280,17.3),(114391,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114391,37.35,0.46,295,49950,70,NULL,NULL,'2MASX J13524759+5744185',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000196,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,208.198417,57.73844,0,NULL,57297101368,895267208,13988550,16.7),(114392,'Tully est','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114392,32.89,0.8,37.8,49951,75,NULL,NULL,'UGC 08798',NULL,'1988NBGC.C....0000T',1988,1,1.42,NULL,'G',0.000013,NULL,'15.5g',0.4,'Sdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,208.200125,43.82794,0,NULL,59265482229,926023159,14469111,15.5),(114393,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114393,38.59,0.46,523,49952,70,NULL,NULL,'SDSS J135248.09+003214.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000072,NULL,'18.7g',0.09,NULL,NULL,NULL,NULL,NULL,1,208.200375,0.53725,0.053,NULL,58443535002,913180234,14268441,18.7),(114394,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114394,35.57,0.17,130,49953,70,NULL,NULL,'2MASX J13524814+2134457',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.88',0.31,NULL,NULL,NULL,NULL,NULL,1,208.200791667,21.5795,0.01,NULL,58320740015,911261562,14238461,16.88),(114395,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114395,36.48,0.46,198,49954,70,NULL,NULL,'2MASX J13524843+3352536',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000172,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,208.2017083,33.88167,0,NULL,59150649033,924228891,14441076,16.2),(114396,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114396,32.9,0.43,38.1,49955,75,NULL,'3.6 micron, color corrected','UGC 08795',NULL,'2014MNRAS.444..527S',2014,1,1.1,NULL,'G',0.000127,NULL,'15.41',0.3,'Scd:',NULL,NULL,NULL,NULL,1,208.202083,37.49103,0,NULL,59154780016,924293437,14442084,15.41),(114397,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114397,32.91,0.2,38.2,49955,74.4,NULL,NULL,'UGC 08795',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114398,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114398,32.92,0.43,38.4,49955,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08795',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114399,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114399,33.15,0.6,42.6,49955,NULL,NULL,NULL,'UGC 08795',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114400,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114400,33.28,0.56,45.3,49955,NULL,NULL,'Malmquist cor.','UGC 08795',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114401,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114401,37.07,0.23,259,49956,70,NULL,NULL,'2MASX J13524932+1944237',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,208.205333,19.74,0.034,NULL,58334047278,911469488,14241710,17.4),(114402,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114402,37.78,0.09,359,49957,70,NULL,NULL,'2MASX J13524964+0504146',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00012,NULL,'16.9g',0.21,'E/S0',NULL,NULL,NULL,NULL,1,208.206875,5.07086,0,NULL,58439021177,913109705,14267339,16.9),(114403,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114403,33.82,0.49,58.1,49958,75,NULL,'IR','UGC 08787',NULL,'2011yCatp016004901K',2011,1,1.91,NULL,'G',0.000013,NULL,'14.5g',0.46,'Sbc: sp        LLIRG','Group member',NULL,NULL,NULL,1,208.2087917,2.26367,0.037,NULL,58445089246,913204519,14268820,14.5),(114404,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114404,33.85,0.2,58.9,49958,74.4,NULL,NULL,'UGC 08787',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114405,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114405,34.02,0.4,63.6,49958,NULL,NULL,NULL,'UGC 08787',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114406,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114406,34.2,0.37,69.1,49958,NULL,NULL,'Malmquist cor.','UGC 08787',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114407,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114407,37.65,0.27,339,49959,70,NULL,NULL,'SDSS J135250.28+093928.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000163,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,208.2095417,9.65789,0.04,NULL,58467918077,913561219,14274394,18.2),(114408,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:32','1','SN 1993H',NULL,114408,34.78,0.09,90.4,49960,74.4,NULL,NULL,'ESO 445- G 066',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.00004,NULL,'14.60',1,'SB(r)ab',NULL,NULL,NULL,NULL,1,208.209417,-30.71,0.181,NULL,46854311299,732098614,11439040,14.6),(114409,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:32','1','SN 1993H',NULL,114409,34.96,0.03,95.7,49960,72,NULL,NULL,'ESO 445- G 066',0.02421,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114410,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:32','1','SN 1993H',NULL,114410,35,0.19,97.6,49960,72,NULL,NULL,'ESO 445- G 066',0.02421,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114411,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:32','1','SN 1993H',NULL,114411,35,0.06,97.8,49960,65,NULL,'MLCS2k2','ESO 445- G 066',0.02421,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114412,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:32','1','SN 1993H',NULL,114412,35.04,0.13,99.3,49960,65,NULL,'SALT2','ESO 445- G 066',0.02421,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114413,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:32','1','SN 1993H',NULL,114413,35.11,0.1,100,49960,65,NULL,'MLCS2k2','ESO 445- G 066',0.02421,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114414,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:32','1','SN 1993H',NULL,114414,35.08,0.17,101,49960,65,NULL,'MLCS17','ESO 445- G 066',0.02421,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114415,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:32','1','SN 1993H',NULL,114415,35.09,0.21,102,49960,65,NULL,NULL,'ESO 445- G 066',0.02421,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114416,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:32','1','SN 1993H',NULL,114416,35.1,0.1,102,49960,65,NULL,'MLCS2k2','ESO 445- G 066',0.02421,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114417,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:32','1','SN 1993H',NULL,114417,35.13,0.17,103,49960,70,NULL,'SALT 2','ESO 445- G 066',0.02421,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114418,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:32','1','SN 1993H',NULL,114418,35.08,0.17,104,49960,70.8,NULL,NULL,'ESO 445- G 066',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114419,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:32','1','SN 1993H',NULL,114419,35.15,0.17,104,49960,65,NULL,'MLCS31','ESO 445- G 066',0.02421,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114420,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:32','1','SN 1993H',NULL,114420,35.17,0.17,106,49960,70,NULL,'SALT','ESO 445- G 066',0.02421,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114421,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:32','1','SN 1993H',NULL,114421,35.19,0.09,107,49960,70,NULL,NULL,'ESO 445- G 066',0.02421,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114422,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:32','1','SN 1993H',NULL,114422,35.2,0.26,107,49960,65,NULL,'MLCS','ESO 445- G 066',0.02421,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114423,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:32','1','SN 1993H',NULL,114423,35.2,0.16,107,49960,73.8,NULL,'SALT 2 (SNANA)','ESO 445- G 066',0.0251,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114424,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:32','1','SN 1993H',NULL,114424,35.23,0.25,109,49960,65,NULL,'Template','ESO 445- G 066',0.02421,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114425,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:32','1','SN 1993H',NULL,114425,35.26,0.19,110,49960,65,NULL,'SALT','ESO 445- G 066',0.02421,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114426,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:32','1','SN 1993H',NULL,114426,35.43,0.14,122,49960,60,NULL,NULL,'ESO 445- G 066',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114427,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:32','1','SN 1993H',NULL,114427,35.49,0.02,122,49960,65,NULL,'SALT','ESO 445- G 066',0.02421,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114428,'SNIa','2016-12-15 15:15:19','2016-12-16 11:20:32','1','SN 1993H',NULL,114428,36.92,0.03,237,49960,70,NULL,NULL,'ESO 445- G 066',0.02421,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114429,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114429,36.65,0.27,214,49961,70,NULL,NULL,'2MASX J13525060+2029507',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,':','16.36',0.19,NULL,NULL,NULL,NULL,NULL,1,208.2109583,20.49753,0.021,NULL,58332029970,911437968,14241218,16.36),(114430,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114430,37.14,0.46,268,49962,70,NULL,NULL,'2MASX J13525137+0529036',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000181,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,208.214167,5.48439,0.019,NULL,58435425815,913053528,14266461,16.5),(114431,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114431,37.54,0.17,322,49963,70,NULL,NULL,'2MASX J13525169-0236301',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000228,NULL,'15.7g',0.49,'E0',NULL,NULL,NULL,NULL,1,208.215291667,-2.60847,0.097,NULL,43611226855,681425419,10647272,15.7),(114432,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114432,38.14,0.46,424,49964,70,NULL,NULL,'2MASX J13525196+3931439',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,208.216583333,39.52872,0,NULL,59266638240,926041222,14469394,18.2),(114433,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114433,37.79,0.46,362,49965,70,NULL,NULL,'SDSS J135252.07+030703.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000067,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,208.2169583,3.11778,0.049,NULL,58448901138,913264080,14269751,18.6),(114434,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114434,37.54,0.17,322,49966,70,NULL,NULL,'LCRS B135018.0-021929',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00015,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,208.2207083,-2.5705,0.097,NULL,43611228977,681425452,10647272,17.1),(114435,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114435,37.26,0.11,283,49967,70,NULL,NULL,'2MASX J13525306+4631372',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000179,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,208.221,46.52708,0,NULL,59240609576,925634524,14463039,17.1),(114436,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114436,37.65,0.27,339,49968,70,NULL,NULL,'2MASX J13525315+0942385',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,208.22125,9.71083,0.04,NULL,58467929500,913561398,14274396,17.2),(114437,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114437,34.55,0.46,81.3,49969,70,NULL,NULL,'2MASX J13525317+3741219',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000087,NULL,'15.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,208.221667,37.68953,0,NULL,59146621143,924165955,14440093,15.2),(114438,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114438,36.44,0.33,194,49970,70,NULL,NULL,'2MASX J13525323+0749075',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000176,NULL,'16.0g',0.42,NULL,NULL,NULL,NULL,NULL,1,208.221875,7.81869,0,NULL,58459671487,913432366,14272380,16),(114439,'D-Sigma','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114439,33.45,0.4,48.9,49971,75,NULL,'Edat, raw','NGC 5328',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000019,NULL,'12.67',1.3,'E1:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,208.222125,-28.48939,0.237,NULL,46851459207,732054050,11438344,12.67),(114440,'D-Sigma','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114440,33.7,0.4,54.9,49971,75,NULL,'Edat, cor','NGC 5328',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114441,'Faber-Jackson','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114441,31.93,0.65,24.3,49971,95,NULL,'Weighted Mean','NGC 5328',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114442,'Faber-Jackson','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114442,33.36,0.81,47,49971,55,NULL,'Visvanathan & Sandage 1979','NGC 5328',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114443,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114443,33.88,0.46,59.8,49971,70,NULL,NULL,'NGC 5328',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114444,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114444,33.91,0.45,60.6,49971,NULL,NULL,'K','NGC 5328',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114445,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114445,34.09,0.4,65.8,49971,NULL,NULL,'mean','NGC 5328',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114446,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114446,37.78,0.09,359,49972,70,NULL,NULL,'2MASX J13525339+0510436',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00011,NULL,'17.2g',0.2,'S0',NULL,NULL,NULL,NULL,1,208.222333,5.17883,0,NULL,58438985796,913109153,14267330,17.2),(114447,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114447,38.25,0.33,446,49973,70,NULL,NULL,'2MASX J13525356+0715095',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.64',0.13,NULL,NULL,NULL,NULL,NULL,1,208.2232083,7.25253,0,NULL,58456558474,913383726,14271620,18.64),(114448,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114448,37.78,0.09,359,49974,70,NULL,NULL,'2MASX J13525386+0506336',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000133,NULL,'18.46',0.16,NULL,NULL,NULL,NULL,NULL,1,208.224375,5.10939,0,NULL,58439031068,913109860,14267341,18.46),(114449,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114449,37.78,0.09,359,49975,70,NULL,NULL,'2MASX J13525399+0508066',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000155,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,208.2249583,5.13514,0,NULL,58439032811,913109887,14267341,17.6),(114450,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114450,37.78,0.09,359,49976,70,NULL,NULL,'2MASX J13525406+0507136',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000153,NULL,'15.9g',0.4,'S0',NULL,NULL,NULL,NULL,1,208.2252083,5.12056,0,NULL,58439032312,913109879,14267341,15.9),(114451,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114451,37.78,0.09,359,49977,70,NULL,NULL,'2MASX J13525419+0505426',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000137,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,208.225917,5.09514,0,NULL,58439014103,913109595,14267337,17),(114452,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114452,31.96,0.4,24.7,49978,75,NULL,'B','NGC 5334',NULL,'1988NBGC.C....0000T',1988,1,4.2,NULL,'G',0.00001,NULL,'11.9B',3,'SB(rs)c:',NULL,NULL,NULL,NULL,1,208.226917,-1.11464,0.141,NULL,43608814777,681387730,10646683,11.9),(114453,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114453,32.32,0.4,29.1,49978,NULL,NULL,'mean','NGC 5334',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114454,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114454,32.57,NULL,32.6,49978,72,NULL,NULL,'NGC 5334',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114455,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114455,32.78,0.47,36,49978,NULL,NULL,'H','NGC 5334',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114456,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114456,32.81,0.45,36.5,49978,NULL,NULL,'K','NGC 5334',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114457,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114457,32.83,0.46,36.8,49978,NULL,NULL,'J','NGC 5334',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114458,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114458,37.22,0.46,277,49979,70,NULL,NULL,'2MASX J13525518+0905475',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.27',0.14,NULL,NULL,NULL,NULL,NULL,1,208.2297917,9.09636,0.026,NULL,58466763313,913543176,14274112,18.27),(114459,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114459,36.69,0.6,217,49980,70,NULL,NULL,'2MASX J13525534-4217361',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.4,NULL,NULL,NULL,NULL,NULL,1,208.230583,-42.29328,0.277,NULL,46925359391,733208740,11456386,14.5),(114460,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114460,35.94,0.6,154,49981,70,NULL,NULL,'2MASX J13525589-1744161',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,208.232875,-17.73781,0.289,NULL,43676425729,682444152,10663189,15),(114461,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114461,37.78,0.09,359,49982,70,NULL,NULL,'2MASX J13525600+0509276',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.001834,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,208.233333,5.15761,0,NULL,58439030297,913109848,14267341,17.5),(114462,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114462,37.33,0.23,292,49983,70,NULL,NULL,'2MASX J13525603+3740099',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000183,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,208.2334583,37.66944,0,NULL,59154784354,924293505,14442086,16.8),(114463,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114463,36.65,0.27,214,49984,70,NULL,NULL,'CGCG 132-032',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000103,NULL,'15.6',0.22,NULL,NULL,NULL,NULL,NULL,1,208.2337917,20.36178,0.016,NULL,58331893479,911435835,14241184,15.6),(114464,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114464,37.8,0.46,362,49985,70,NULL,NULL,'2MASX J13525649+3855179',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000147,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,208.2352083,38.9215,0,NULL,59266778189,926043409,14469428,18.3),(114465,'BL Lac Luminosity','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114465,40.67,NULL,1360,49986,70,NULL,'nucleus-to-host flux ratio, z > 0.39','PKS 1349-439',NULL,'2006AJ....132....1S',2006,1,NULL,'Not to be confused with the z=0.052 radio quiet QSO [V96] 1349-439.','QSO',NULL,NULL,'18.0',NULL,'BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,208.2355417,-44.21122,0.345,NULL,46921340910,733145951,11455405,18),(114466,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114466,36.44,0.33,194,49987,70,NULL,NULL,'2MASX J13525666+0747545',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000163,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,208.2360417,7.79853,0,NULL,58459671629,913432369,14272380,16.6),(114467,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114467,37,0.19,251,49988,70,NULL,NULL,'2MASX J13525684+3305337',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.89',0.19,NULL,NULL,NULL,NULL,NULL,1,208.236917,33.09269,0,NULL,59185333542,924770836,14449544,17.89),(114468,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114468,37.29,0.46,287,49989,70,NULL,NULL,'SDSS J135257.03+523522.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000172,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,208.237667,52.58956,0.008,NULL,59216566828,925258856,14457169,18.3),(114469,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114469,34.91,0.46,95.8,49990,NULL,NULL,'Malmquist cor.','UGC 08794',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000025,NULL,'15.09',0.4,'Sb',NULL,NULL,NULL,NULL,1,208.240333,20.91703,0.011,NULL,58331666957,911432296,14241129,15.09),(114470,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114470,34.96,0.45,98.2,49990,NULL,NULL,NULL,'UGC 08794',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114471,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114471,35.31,0.2,115,49990,74.4,NULL,NULL,'UGC 08794',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114472,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114472,35.64,0.4,134,49990,NULL,NULL,'mean','UGC 08794',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114473,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114473,35.73,0.47,140,49990,NULL,NULL,'H','UGC 08794',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114474,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114474,37,0.19,251,49991,70,NULL,NULL,'2MASX J13525834+3309447',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.94',0.17,NULL,NULL,NULL,NULL,NULL,1,208.243041667,33.16253,0,NULL,59185337633,924770900,14449545,17.94),(114475,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114475,38.25,0.33,446,49992,70,NULL,NULL,'2MASX J13525854+0719315',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000183,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,208.244,7.32547,0,NULL,58456568540,913383883,14271623,17.4),(114476,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114476,37,0.19,251,49993,70,NULL,NULL,'2MASX J13525859+3306277',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.02',0.17,NULL,NULL,NULL,NULL,NULL,1,208.244083333,33.10758,0,NULL,59185347279,924771051,14449547,18.02),(114477,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114477,37.36,0.46,296,49994,70,NULL,NULL,'2MASX J13525868+3720299',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000187,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,208.2445,37.34156,0,NULL,59154847950,924294499,14442101,17.5),(114478,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114478,37.07,0.46,259,49995,70,NULL,NULL,'2MASX J13525908+1312592',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000137,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,208.246166667,13.21661,0,NULL,58341818152,911590908,14243607,17.6),(114479,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114479,33.91,0.58,60.5,49996,70,NULL,NULL,'NGC 5330',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000033,NULL,'14.81',0.3,'E','Pair member, E + E',NULL,NULL,NULL,1,208.246625,-28.47067,0.237,NULL,46851459638,732054056,11438344,14.81),(114480,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114480,37.74,0.46,354,49997,70,NULL,NULL,'2MASX J13525925+3234167',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,208.247083,32.57119,0,NULL,59181964983,924718202,14448721,17.5),(114481,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114481,37.78,0.09,359,49998,70,NULL,NULL,'SDSS J135259.51+050818.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000174,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,208.2479583,5.13853,0,NULL,58439029024,913109828,14267341,18.2),(114482,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114482,36.92,0.27,242,49999,70,NULL,NULL,'2MASX J13525949+1813167',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.49',0.22,NULL,NULL,NULL,NULL,NULL,1,208.2479583,18.22144,0.01,NULL,58322884572,911295071,14238985,17.49),(114483,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114483,37.34,0.46,294,50000,70,NULL,NULL,'2MASX J13525967+1646512',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.41',0.12,NULL,NULL,NULL,NULL,NULL,1,208.24875,16.78092,0.006,NULL,58380789498,912199835,14253122,18.41),(114484,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114484,36.97,0.46,248,50001,70,NULL,NULL,'2MASX J13530145+4120398',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'15.99',0.24,NULL,NULL,NULL,NULL,NULL,1,208.255916667,41.34436,0,NULL,59273663439,926150991,14471109,15.99),(114485,'IRAS','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114485,32.98,0.8,39.4,50002,75,NULL,'CF, r','NGC 5346',NULL,'1997ApJS..109..333W',1997,1,1.71,NULL,'G',0.000027,NULL,'14.3g',0.73,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,208.257875,39.58078,0,NULL,59270897235,926107769,14470433,14.3),(114486,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114486,32.76,0.2,35.7,50002,74.4,NULL,NULL,'NGC 5346',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114487,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114487,32.82,0.37,36.6,50002,NULL,NULL,NULL,'NGC 5346',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114488,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114488,32.83,0.43,36.8,50002,75,NULL,'3.6 micron, color corrected','NGC 5346',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114489,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114489,32.9,0.52,38,50002,NULL,NULL,NULL,'NGC 5346',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114490,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114490,32.92,0.43,38.3,50002,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5346',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114491,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114491,32.95,0.51,38.9,50002,NULL,NULL,'Malmquist cor.','NGC 5346',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114492,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114492,33.17,0.38,43.1,50002,75,NULL,'CF, r, raw','NGC 5346',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114493,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114493,33.19,0.38,43.5,50002,75,NULL,'CF, r, inv','NGC 5346',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114494,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114494,33.3,0.38,45.6,50002,75,NULL,'CF, r, cor','NGC 5346',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114495,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114495,37,0.19,251,50003,70,NULL,NULL,'2MASX J13530201+3305287',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.20',0.25,NULL,NULL,NULL,NULL,NULL,1,208.258541667,33.09125,0,NULL,59185334203,924770846,14449544,17.2),(114496,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114496,36.08,0.46,165,50004,70,NULL,NULL,'CGCG 162-022',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00007,NULL,'15.02',0.5,NULL,NULL,NULL,NULL,NULL,1,208.2587917,31.81317,0,NULL,59182260592,924722821,14448794,15.02),(114497,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114497,35.67,0.16,136,50005,70,NULL,NULL,'SDSS J135302.41+244909.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,208.260041667,24.81925,0,NULL,59995696240,937432753,14647386,17.5),(114498,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114498,38.28,0.46,454,50006,70,NULL,NULL,'2MASX J13530337+3504227',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000176,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,208.264167,35.07294,0,NULL,59151033819,924234903,14441170,17.2),(114499,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114499,38.18,0.46,433,50007,70,NULL,NULL,'2MASX J13530384+0558556',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000182,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,208.265917,5.98225,0.039,NULL,58435497547,913054649,14266478,17.1),(114500,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114500,37.91,0.46,381,50008,70,NULL,NULL,'2MASX J13530422+0619570',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000182,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,208.267458333,6.33253,0.008,NULL,58427552315,912930504,14264539,17),(114501,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114501,37.07,0.23,259,50009,70,NULL,NULL,'2MASX J13530433+1949517',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,208.268083,19.83092,0.034,NULL,58334007528,911468867,14241701,17.7),(114502,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114502,37.78,0.09,359,50010,70,NULL,NULL,'SDSS J135304.35+045121.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000158,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,208.268125,4.85586,0.023,NULL,58438618560,913103415,14267240,18.1),(114503,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114503,37.71,0.46,349,50011,70,NULL,NULL,'2MASX J13530453+3633391',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000142,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,208.268917,36.56086,0,NULL,59152941077,924264704,14441636,17.2),(114504,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114504,37.28,0.93,286,50012,70,NULL,NULL,'2MASX J13530459-2735251',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,208.269083,-27.59036,0.277,NULL,46977491332,734023302,11469114,15.8),(114505,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114505,37.41,0.33,303,50013,70,NULL,NULL,'2MASX J13530461+3716091',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000149,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,208.2692917,37.26914,0,NULL,59154670559,924291727,14442058,17.1),(114506,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114506,37.54,0.17,322,50014,70,NULL,NULL,'LCRS B135029.8-022416',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,208.270417,-2.65014,0.097,NULL,43610474972,681413671,10647088,17.3),(114507,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114507,37.86,0.46,373,50015,70,NULL,NULL,'2MASX J13530550+1229232',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000173,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,208.272917,12.48983,0,NULL,58341143859,911580372,14243443,17.6),(114508,'BCG','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114508,37.58,0.35,304,50016,60,NULL,'ABELL 1809, BCG','2MASX J13530637+0508586',0.0788,'1980ApJ...241..486H',1980,1,0.87,NULL,'G',0.000053,NULL,'15.2g',0.58,'cD;BrClG       AGN:','Brightest group member',NULL,NULL,NULL,1,208.276667,5.14972,0.02,NULL,58438983961,913109124,14267330,15.2),(114509,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114509,37.78,0.09,359,50016,70,NULL,NULL,'2MASX J13530637+0508586',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114510,'BCG','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114510,37.58,0.35,304,50017,60,NULL,NULL,'ABELL 1809',0.0788,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',0.00037,NULL,NULL,NULL,'II:    [BM]',NULL,NULL,NULL,NULL,1,208.276667,5.14975,0.02,NULL,58438983961,913109124,14267330,NULL),(114511,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114511,37.38,0.23,299,50018,70,NULL,NULL,'2MASX J13530685+2813427',NULL,'2015arXiv151105856S',2015,1,0.55,'Galaxy (?) superposed 8\\\" north; star 19\\\" northwest.','G',0.000189,NULL,'15.7g',0.45,NULL,NULL,NULL,NULL,NULL,1,208.2785,28.2285,0,NULL,60004773158,937574580,14649602,15.7),(114512,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114512,37,0.19,251,50019,70,NULL,NULL,'2MASX J13530734+3306377',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.19',0.14,NULL,NULL,NULL,NULL,NULL,1,208.2805,33.11061,0,NULL,59185346792,924771043,14449547,18.19),(114513,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114513,34.04,0.49,64.2,50020,70,NULL,NULL,'MCG -03-35-020',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00009,NULL,'15',0.2,'poss. LINER?',NULL,NULL,NULL,NULL,1,208.2842083,-16.96036,0.285,NULL,43684219798,682565934,10665092,15),(114514,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114514,37.54,0.17,322,50021,70,NULL,NULL,'LCRS B135034.2-022152',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,208.288667,-2.60997,0.097,NULL,43610359264,681411863,10647060,18.2),(114515,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114515,35.9,0.46,151,50022,70,NULL,NULL,'2MASX J13530962+3242427',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.26',0.18,NULL,NULL,NULL,NULL,NULL,1,208.29,32.71197,0,NULL,59182021704,924719089,14448735,17.26),(114516,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114516,34.81,0.49,91.5,50023,70,NULL,NULL,'ESO 445- G 069',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000023,NULL,'14.90',0.7,'(R_1R\'_2)SB0/a',NULL,NULL,NULL,NULL,1,208.29025,-30.71275,0.229,NULL,46854177762,732096527,11439008,14.9),(114517,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114517,34.44,NULL,77.4,50024,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08796',NULL,'2010Ap&SS.325..163P',2010,1,1.61,NULL,'G',0.000012,NULL,'16.3g',0.14,'Sd(f)',NULL,NULL,NULL,NULL,1,208.2902083,4.96094,0.02,NULL,58438536216,913102128,14267220,16.3),(114518,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114518,34.48,NULL,78.6,50024,NULL,NULL,'Dipole + Quadrupole','UGC 08796',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114519,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114519,34.49,NULL,79.1,50024,NULL,NULL,'Dipole','UGC 08796',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114520,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114520,34.5,0.2,79.4,50024,74.4,NULL,NULL,'UGC 08796',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114521,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114521,34.51,NULL,79.9,50024,NULL,NULL,NULL,'UGC 08796',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114522,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114522,34.58,0.43,82.3,50024,NULL,NULL,NULL,'UGC 08796',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114523,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114523,34.8,0.39,91.1,50024,NULL,NULL,'Malmquist cor.','UGC 08796',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114524,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114524,37.78,0.09,359,50025,70,NULL,NULL,'2MASX J13531018+0459376',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000157,NULL,'17.4g',0.22,'S0',NULL,NULL,NULL,NULL,1,208.292375,4.99386,0.02,NULL,58438547217,913102300,14267223,17.4),(114525,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114525,37.07,0.23,259,50026,70,NULL,NULL,'SDSS J135310.43+194849.9',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',NULL,NULL,'15.4g',0.45,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,208.2935,19.81389,0.034,NULL,58334077335,911469958,14241718,15.4),(114526,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114526,37.58,0.46,327,50027,70,NULL,NULL,'2MASXi J1353107+141223',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,208.294875,14.20658,0,NULL,58340660130,911572814,14243325,17.9),(114527,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114527,35.74,0.33,140,50028,70,NULL,NULL,'CGCG 191-005',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000159,NULL,'15.3g',0.5,NULL,NULL,NULL,NULL,NULL,1,208.296625,35.57922,0,NULL,59153217279,924269019,14441703,15.3),(114528,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114528,36.68,0.27,217,50029,70,NULL,NULL,'2MASX J13531126+2514047',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000168,NULL,'16.1g',0.34,NULL,NULL,NULL,NULL,NULL,1,208.296833,25.23469,0,NULL,59999135466,937486491,14648226,16.1),(114529,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114529,37.42,0.46,304,50030,70,NULL,NULL,'2MASX J13531196+4245241',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,208.299667,42.75672,0,NULL,59264472635,926007384,14468865,18.3),(114530,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114530,36.6,0.94,209,50031,70,NULL,NULL,'2MASX J13531390-3256305',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'15.0',NULL,'Sc',NULL,NULL,NULL,NULL,1,208.3079583,-32.94181,0.221,NULL,46897253787,732769590,11449524,15),(114531,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114531,34.48,0.46,78.7,50032,70,NULL,NULL,'CGCG 017-089',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000056,NULL,'15.4g',0.32,'NLAGN',NULL,NULL,NULL,NULL,1,208.308791667,0.44725,0.065,NULL,58410030927,912656733,14260261,15.4),(114532,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114532,33.98,0.2,62.5,50033,74.4,NULL,NULL,'UGC 08806',NULL,'2013AJ....146...86T',2013,1,1.54,NULL,'G',0.000013,NULL,'14.5g',0.47,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,208.309333,38.22714,0,NULL,59146174452,924158975,14439983,14.5),(114533,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114533,34.01,0.47,63.5,50033,NULL,NULL,NULL,'UGC 08806',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114534,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114534,34.05,0.47,64.6,50033,NULL,NULL,'Malmquist cor.','UGC 08806',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114535,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114535,37.78,0.09,359,50034,70,NULL,NULL,'2MASX J13531421+0511236',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000117,NULL,'17.2g',0.17,'S0',NULL,NULL,NULL,NULL,1,208.3092083,5.18992,0.02,NULL,58438531270,913102051,14267219,17.2),(114536,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114536,38.3,0.46,457,50035,70,NULL,NULL,'2MASX J13531447+4344341',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000166,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,208.310125,43.74275,0,NULL,59265408391,926022006,14469093,17.1),(114537,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114537,37.73,0.33,352,50036,70,NULL,NULL,'2MASX J13531529+3744152',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,208.313667,37.73769,0,NULL,59154767728,924293245,14442081,18.2),(114538,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114538,37.78,0.09,359,50037,70,NULL,NULL,'2MASX J13531534+0510126',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.0002,NULL,'17.70',0.21,'S0',NULL,NULL,NULL,NULL,1,208.313917,5.17017,0.02,NULL,58438531462,913102054,14267219,17.7),(114539,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114539,36.41,0.46,191,50038,70,NULL,NULL,'2MASX J13531539+0913210',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000185,NULL,'17.19',0.17,NULL,NULL,NULL,NULL,NULL,1,208.314,9.2225,0.026,NULL,58464939634,913514681,14273666,17.19),(114540,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114540,37.78,0.09,359,50039,70,NULL,NULL,'SDSS J135315.73+050933.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,208.315583,5.15922,0.02,NULL,58438523638,913101931,14267217,18.1),(114541,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114541,37.78,0.09,359,50040,70,NULL,NULL,'2MASX J13531574+0512109',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000073,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,208.315708333,5.203,0.02,NULL,58438518152,913101846,14267216,17.6),(114542,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114542,38.67,0.46,543,50041,70,NULL,NULL,'2MASX J13531574+1216243',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00018,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,208.31575,12.27353,0,NULL,58341115972,911579937,14243436,17.5),(114543,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114543,37.33,0.27,293,50042,70,NULL,NULL,'SDSS J135315.79+241231.3',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.5g',0.27,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,208.3157917,24.20872,0,NULL,59459210100,929050157,14516408,16.5),(114544,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114544,37.52,0.46,319,50043,70,NULL,NULL,'LCRS B135040.8-023240',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00014,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,208.316375,-2.79003,0.097,NULL,43610533089,681414579,10647102,17.3),(114545,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114545,36.88,0.33,238,50044,70,NULL,NULL,'2MASX J13531605+4541267',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000178,NULL,'16.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,208.316916667,45.69069,0,NULL,59232070239,925501097,14460954,16.3),(114546,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114546,36.88,0.33,238,50045,70,NULL,NULL,'2MASX J13531698+4543387',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000191,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,208.32075,45.72744,0,NULL,59232071627,925501119,14460954,16.3),(114547,'Tully est','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114547,32.82,0.8,36.7,50046,75,NULL,'B','NGC 5347',NULL,'1988NBGC.C....0000T',1988,1,1.7,'Large position error in 1991ApJS...76.1043P.','G',0.000067,NULL,'13.4',1.3,'(R\')SB(rs)ab   Sy2','in a pair',NULL,NULL,'Sy 2',1,208.3242917,33.49083,0,NULL,59183216041,924737750,14449027,13.4),(114548,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114548,31.58,0.47,20.7,50046,NULL,NULL,'H','NGC 5347',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114549,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114549,31.69,0.46,21.8,50046,NULL,NULL,'J','NGC 5347',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114550,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114550,31.7,0.45,21.8,50046,NULL,NULL,'K','NGC 5347',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114551,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114551,32.75,0.4,35.5,50046,NULL,NULL,'mean','NGC 5347',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114552,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114552,37.14,0.46,268,50047,70,NULL,NULL,'2MASX J13531797+3806502',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,208.324958333,38.11406,0,NULL,59146122225,924158159,14439971,17),(114553,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114553,37.73,0.33,352,50048,70,NULL,NULL,'LCSB S1974P',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000144,NULL,'16.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,208.32725,37.64339,0,NULL,59154818824,924294044,14442094,16.6),(114554,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114554,37.61,0.46,333,50049,70,NULL,NULL,'SDSS J135319.73+394640.0',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000142,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,208.33225,39.77778,0,NULL,59271615454,926118991,14470609,17.7),(114555,'SBF','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114555,30.19,0.23,10.9,50050,NULL,NULL,'R','UGC 08799',NULL,'2005A&A...437..823R',2005,1,0.71,NULL,'G',0.000092,NULL,'16.2g',0.54,'Im?',NULL,NULL,NULL,NULL,1,208.332583,5.77164,0.039,NULL,58435483120,913054423,14266475,16.2),(114556,'SBF','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114556,30.61,0.26,13.2,50050,NULL,NULL,'R','UGC 08799',NULL,'2005A&A...437..823R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114557,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114557,38.16,0.46,428,50051,70,NULL,NULL,'2MASX J13532159+3959092',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000179,NULL,'17.6g',0.21,'BrClG',NULL,NULL,NULL,NULL,1,208.339708333,39.98603,0,NULL,59271665664,926119776,14470621,17.6),(114558,'Ring Diameter','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114558,33.1,0.84,41,50052,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5350',NULL,'1981ApJS...45..541P',1981,1,3.2,NULL,'G',0.000007,NULL,'12.15',2.3,'SB(r)b         Sbrst','in a triple',NULL,NULL,'Starburst?',1,208.340125,40.36394,0,NULL,59271461251,926116582,14470571,12.15),(114559,'Sosies','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114559,32.27,0.25,28.4,50052,NULL,NULL,NULL,'NGC 5350',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114560,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114560,31.77,0.69,22.6,50052,100,NULL,'mid-IR','NGC 5350',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114561,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114561,32.1,0.2,26.3,50052,74.4,NULL,NULL,'NGC 5350',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114562,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114562,32.18,0.43,27.3,50052,75,NULL,'3.6 micron, color corrected','NGC 5350',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114563,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114563,32.21,0.59,27.7,50052,NULL,NULL,'Malmquist cor.','NGC 5350',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114564,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114564,32.28,0.57,28.6,50052,NULL,NULL,NULL,'NGC 5350',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114565,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114565,32.36,0.43,29.7,50052,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5350',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114566,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114566,32.42,0.45,30.5,50052,NULL,NULL,'K','NGC 5350',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114567,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114567,32.43,0.47,30.7,50052,NULL,NULL,'H','NGC 5350',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114568,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114568,32.45,0.46,31,50052,NULL,NULL,'J','NGC 5350',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114569,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114569,32.75,0.4,35.4,50052,NULL,NULL,'mean','NGC 5350',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114570,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114570,32.89,0.4,37.8,50052,75,NULL,'B','NGC 5350',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114571,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114571,38.36,0.46,469,50053,70,NULL,NULL,'2MASX J13532287+3727372',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000186,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,208.3452083,37.46039,0,NULL,59154853497,924294585,14442102,17.6),(114572,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114572,35.89,0.48,150,50054,70,NULL,NULL,'ESO 578-G 003',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000023,NULL,'15.17',0.7,'(R)SB(l:)ab?',NULL,NULL,NULL,NULL,1,208.345375,-20.11697,0.257,NULL,43636913068,681826766,10653543,15.17),(114573,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114573,34.95,0.69,97.5,50054,100,NULL,'mid-IR','ESO 578-G 003',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114574,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114574,38.12,0.46,421,50055,70,NULL,NULL,'2MASX J13532302+3528405',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,208.346,35.47789,0,NULL,59152699847,924260935,14441577,18.1),(114575,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114575,37.78,0.09,359,50056,70,NULL,NULL,'SDSS J135323.53+051144.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000141,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,208.348083333,5.19561,0.02,NULL,58438530515,913102039,14267219,18.2),(114576,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114576,36.94,0.33,244,50057,70,NULL,NULL,'2MASX J13532434+0627560',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000202,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,208.3515417,6.46567,0,NULL,58427649444,912932022,14264562,16.7),(114577,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114577,37.26,0.11,283,50058,70,NULL,NULL,'2MASX J13532490+4627418',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000181,NULL,'16.1g',0.33,'S0^-',NULL,NULL,NULL,NULL,1,208.3539583,46.46147,0,NULL,59240601863,925634404,14463037,16.1),(114578,'SBF','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114578,30.53,0.14,12.8,50059,74.4,NULL,NULL,'NGC 5338',NULL,'2013AJ....146...86T',2013,1,2.11,NULL,'G',0.00003,NULL,'13.8g',0.8,'SB0:           HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,208.360625,5.20778,0.02,NULL,58438519634,913101869,14267216,13.8),(114579,'SBF','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114579,30.54,0.3,12.8,50059,NULL,NULL,'I','NGC 5338',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114580,'Faber-Jackson','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114580,31.91,0.44,24.1,50060,95,NULL,'Weighted Mean','NGC 5353',NULL,'1984ApJS...56...91D',1984,1,2.2,NULL,'G',0.00001,NULL,'11.96',1.1,'S0             AGN','in a triple',NULL,NULL,'Sy ?',1,208.3612083,40.28303,0,NULL,59271563628,926118181,14470596,11.96),(114581,'Faber-Jackson','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114581,32.13,0.46,26.7,50060,95,NULL,'Michard 1979a','NGC 5353',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114582,'Faber-Jackson','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114582,32.4,0.63,30.2,50060,95,NULL,'Michard 1979b, c','NGC 5353',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114583,'Tertiary','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114583,32.1,0.25,26.3,50060,95,NULL,NULL,'NGC 5353',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114584,'Tully est','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114584,32.89,0.8,37.8,50060,75,NULL,'B','NGC 5353',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114585,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114585,31.15,NULL,17,50060,72,NULL,NULL,'NGC 5353',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114586,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114586,32.22,0.45,27.8,50060,NULL,NULL,'K','NGC 5353',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114587,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114587,32.77,0.4,35.7,50060,NULL,NULL,'mean','NGC 5353',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114588,'Faber-Jackson','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114588,32.29,0.44,28.7,50061,95,NULL,'Weighted Mean','NGC 5354',NULL,'1984ApJS...56...91D',1984,1,1.4,NULL,'G',0.000043,NULL,'12.33',1.3,'SA0 sp         LINER','in a triple',NULL,NULL,NULL,1,208.36125,40.30275,0,NULL,59271564217,926118190,14470596,12.33),(114589,'Faber-Jackson','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114589,32.6,0.46,33.1,50061,95,NULL,'Michard 1979a','NGC 5354',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114590,'Faber-Jackson','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114590,32.74,0.63,35.3,50061,95,NULL,'Michard 1979b, c','NGC 5354',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114591,'Tertiary','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114591,32.1,0.25,26.3,50061,95,NULL,NULL,'NGC 5354',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114592,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114592,36.71,0.46,220,50062,70,NULL,NULL,'2MASX J13532676+2256193',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.36',0.14,NULL,NULL,NULL,NULL,NULL,1,208.3614583,22.93883,0,NULL,59462370597,929099540,14517180,18.36),(114593,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114593,36.19,0.47,173,50063,NULL,NULL,'Malmquist cor.','2MASX J13532728+2057013',NULL,'2009ApJS..182..474S',2009,1,0.42,NULL,'G',0.00003,NULL,'17.64',0.12,NULL,NULL,NULL,NULL,NULL,1,208.363708333,20.95042,0.011,NULL,58332212004,911440812,14241262,17.64),(114594,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114594,36.36,0.43,187,50063,NULL,NULL,NULL,'2MASX J13532728+2057013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114595,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114595,36.4,0.2,191,50064,74.4,NULL,NULL,'SDSS J135327.36+205704.4',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,208.3640417,20.95122,0.011,NULL,58332212004,911440812,14241262,NULL),(114596,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114596,38.01,0.46,400,50065,70,NULL,NULL,'2MASX J13532759+2752569',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000169,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,208.365,27.88239,0,NULL,60009016593,937640884,14650638,17.9),(114597,'IRAS','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114597,33.6,0.8,52.4,50066,75,NULL,'CF, r','NGC 5351',NULL,'1997ApJS..109..333W',1997,1,2.42,NULL,'G',0.000003,NULL,'13.1g',1.08,'SA(r)b:','in a radial-velocity based grouping',NULL,NULL,NULL,1,208.365458333,37.91497,0,NULL,59154759869,924293122,14442080,13.1),(114598,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114598,32.68,0.69,34.3,50066,100,NULL,'mid-IR','NGC 5351',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114599,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114599,33.23,0.47,44.2,50066,NULL,NULL,'H','NGC 5351',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114600,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114600,33.25,0.45,44.8,50066,NULL,NULL,'K','NGC 5351',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114601,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114601,33.26,0.46,44.8,50066,NULL,NULL,'J','NGC 5351',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114602,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114602,33.66,0.4,54,50066,NULL,NULL,'mean','NGC 5351',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114603,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114603,33.67,0.2,54.2,50066,74.4,NULL,NULL,'NGC 5351',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114604,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114604,33.75,0.36,56.2,50066,NULL,NULL,'Malmquist cor.','NGC 5351',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114605,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114605,33.82,0.35,58.2,50066,NULL,NULL,NULL,'NGC 5351',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114606,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114606,33.86,0.38,59.1,50066,75,NULL,'CF, r, raw','NGC 5351',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114607,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114607,34.04,0.38,64.4,50066,75,NULL,'CF, r, inv','NGC 5351',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114608,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114608,34.1,0.38,66,50066,75,NULL,'CF, r, cor','NGC 5351',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114609,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114609,36.91,0.46,242,50067,70,NULL,NULL,'2MASX J13532779+4354458',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000175,NULL,'15.9g',0.41,'E0',NULL,NULL,NULL,NULL,1,208.3659583,43.91261,0.009,NULL,59265401059,926021891,14469092,15.9),(114610,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114610,36.65,0.27,213,50068,70,NULL,NULL,'2MASX J13532793+3315226',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.50',0.21,NULL,NULL,NULL,NULL,NULL,1,208.366333,33.25642,0,NULL,59181895816,924717122,14448705,17.5),(114611,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114611,35.88,0.6,150,50069,70,NULL,NULL,'2MASX J13532883-2752431',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.4,NULL,NULL,NULL,NULL,NULL,1,208.37,-27.87869,0.189,NULL,46990941855,734233466,11472397,14.5),(114612,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114612,37.37,0.46,298,50070,70,NULL,NULL,'2MASX J13532880+0432180',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000171,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,208.370167,4.53833,0.041,NULL,58438606957,913103233,14267238,16.5),(114613,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114613,37.79,0.27,361,50071,70,NULL,NULL,'SDSS J135328.90+584443.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000143,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,208.370417,58.74547,0,NULL,57266843601,894794431,13981162,18.4),(114614,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114614,37.78,0.46,360,50072,70,NULL,NULL,'2MASX J13532958+3242146',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,208.37325,32.70408,0,NULL,59182008704,924718886,14448732,17),(114615,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114615,38.1,0.23,416,50073,70,NULL,NULL,'SDSS J135330.26+131248.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.4g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,208.376125,13.21356,0,NULL,58342672770,911604262,14243816,18.4),(114616,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114616,36.5,0.2,200,50074,74.4,NULL,NULL,'CGCG 073-093',NULL,'2013AJ....146...86T',2013,1,0.74,NULL,'G',0.000143,NULL,'15.8g',0.34,'Sc',NULL,NULL,NULL,NULL,1,208.377167,11.34372,0,NULL,58461603331,913462552,14272852,15.8),(114617,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114617,38.31,0.46,460,50075,70,NULL,NULL,'SDSS J135331.03+223659.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,208.379333333,22.61642,0,NULL,59460241264,929066269,14516660,18.4),(114618,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114618,34.55,0.49,81.2,50076,75,NULL,'IR','UGC 08801',NULL,'2011yCatp016004901K',2011,1,1.26,NULL,'G',0.000017,NULL,'14.9g',0.37,'Sbc? sp        HII',NULL,NULL,NULL,NULL,1,208.38325,-1.19447,0.141,NULL,43591712719,681120511,10642507,14.9),(114619,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114619,36.23,0.54,176,50077,70,NULL,NULL,'2MASX J13533290-2758081',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.3b',NULL,'*+E',NULL,NULL,NULL,NULL,1,208.387125,-27.96886,0.189,NULL,46990944482,734233507,11472398,16.3),(114620,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114620,37.09,0.46,261,50078,70,NULL,NULL,'2MASX J13533295+2339473',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,208.387291667,23.66328,0,NULL,59459116279,929048691,14516385,17.5),(114621,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114621,38.11,0.33,419,50079,70,NULL,NULL,'2MASX J13533297+4444128',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000179,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,208.3875,44.73697,0,NULL,59262049007,925969515,14468273,18.3),(114622,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114622,35.35,0.27,118,50080,70,NULL,NULL,'IC 4340',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000063,NULL,'14.1g',0.8,'S?','Group member',NULL,NULL,NULL,1,208.389708333,37.38697,0,NULL,59154883691,924295057,14442110,14.1),(114623,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114623,37.72,0.33,349,50081,70,NULL,NULL,'SDSS J135333.81+352518.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000157,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,208.390875,35.42192,0,NULL,59152719001,924261234,14441581,18.3),(114624,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114624,35.75,0.7,141,50082,70,NULL,NULL,'2MASX J13533394-3505095',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.6b',0.3,'E',NULL,NULL,NULL,NULL,1,208.391541667,-35.08592,0.197,NULL,46881189120,732518580,11445602,16.6),(114625,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114625,36.7,0.61,219,50083,70,NULL,NULL,'2MASX J13533424-4228563',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,208.392625,-42.48236,0.277,NULL,46923265291,733176020,11455875,15.3),(114626,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114626,37.29,0.27,287,50084,70,NULL,NULL,'2MASX J13533521+5454467',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000162,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,208.396791667,54.91292,0,NULL,57283504141,895054752,13985230,16.8),(114627,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114627,38.37,0.46,472,50085,70,NULL,NULL,'2MASX J13533541+1209130',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,208.3974583,12.15358,0,NULL,58461881401,913466896,14272920,17.2),(114628,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114628,37.72,0.33,349,50086,70,NULL,NULL,'2MASX J13533562+3531456',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,208.398708333,35.52919,0,NULL,59152700684,924260948,14441577,17.2),(114629,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114629,37.04,0.33,256,50087,70,NULL,NULL,'2MASX J13533602+2646230',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'18.16',0.17,NULL,NULL,NULL,NULL,NULL,1,208.4000417,26.77306,0,NULL,59998455280,937475863,14648060,18.16),(114630,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114630,35.57,0.17,130,50088,70,NULL,NULL,'2MASX J13533626+2134083',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000083,NULL,'15.59',0.25,NULL,NULL,NULL,NULL,NULL,1,208.40125,21.56906,0.008,NULL,58320650583,911260165,14238440,15.59),(114631,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114631,35.74,0.33,140,50089,70,NULL,NULL,'2MASX J13533710+3541176',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000176,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,208.4047917,35.68828,0,NULL,59152695534,924260867,14441576,16.3),(114632,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114632,37.38,0.23,299,50090,70,NULL,NULL,'2MASX J13533735+2812270',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000179,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,208.4057917,28.20733,0,NULL,60004826647,937575416,14649615,16.5),(114633,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114633,35.81,0.38,146,50091,NULL,NULL,'Malmquist cor.','ESO 578- G 004',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.97',0.2,'SB(r)0^+',NULL,NULL,NULL,NULL,1,208.4059583,-20.50808,0.213,NULL,43636271355,681816739,10653386,15.97),(114634,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114634,35.92,0.36,153,50091,NULL,NULL,NULL,'ESO 578- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114635,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114635,35.96,0.2,156,50091,74.4,NULL,NULL,'ESO 578- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114636,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114636,37.54,0.17,322,50092,70,NULL,NULL,'LCRS B135102.3-022431',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000191,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,208.406417,-2.65394,0.097,NULL,43610509481,681414210,10647097,17.9),(114637,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114637,35.07,0.46,103,50093,70,NULL,NULL,'NGC 5352',NULL,'2015arXiv151105856S',2015,1,1.2,NULL,'G',0.000113,NULL,'13.9g',1,'S0-:',NULL,NULL,NULL,NULL,1,208.410125,36.13406,0,NULL,59153063396,924266615,14441665,13.9),(114638,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114638,38.1,0.46,418,50094,70,NULL,NULL,'2MASX J13533857+1917303',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.42',0.14,NULL,NULL,NULL,NULL,NULL,1,208.410917,19.29181,0.048,NULL,58330646137,911416345,14240880,18.42),(114639,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114639,37.78,0.09,359,50095,70,NULL,NULL,'2MASX J13533931+0516120',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000083,NULL,'16.4g',0.37,'AGN',NULL,NULL,NULL,NULL,1,208.413917,5.26986,0.025,NULL,58435712129,913058002,14266531,16.4),(114640,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114640,38.1,0.23,416,50096,70,NULL,NULL,'2MASX J13533940+1326080',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000171,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,208.41425,13.43569,0,NULL,58342633300,911603645,14243806,18.3),(114641,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114641,38.1,0.23,416,50097,70,NULL,NULL,'2MASX J13533947+1326290',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.7g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,208.4145,13.44136,0,NULL,58342633464,911603647,14243806,16.7),(114642,'BL Lac Luminosity','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114642,38.87,NULL,595,50098,NULL,NULL,'Min. z = 0.15','2FGL J1353.5-6640',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,208.416,-66.676,NULL,NULL,44939327154,702176986,10971515,NULL),(114643,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114643,36.33,0.46,184,50099,70,NULL,NULL,'2MASX J13534004+1425110',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000173,NULL,'16.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,208.4170417,14.41978,0,NULL,58339764160,911558815,14243106,16.4),(114644,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114644,35.5,0.17,126,50100,70,NULL,NULL,'GIN 322',NULL,'2001MNRAS.321..277C',2001,1,0.84,NULL,'G',0.000083,NULL,'14.9g',0.67,'E/S0',NULL,NULL,NULL,NULL,1,208.41925,25.07939,0,NULL,59999190147,937487346,14648239,14.9),(114645,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114645,36.55,0.25,204,50100,74.4,NULL,NULL,'GIN 322',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114646,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114646,36.68,0.27,217,50100,70,NULL,NULL,'GIN 322',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114647,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114647,34.46,0.32,78,50101,NULL,NULL,'B, Hubble-type-TF','ESO 384- G 009',NULL,'2005Ap&SS.298..577R',2005,1,1.3,NULL,'G',0.000033,NULL,'14.66',1,'SB(s)c         HII',NULL,NULL,NULL,NULL,1,208.41975,-33.94939,0.197,NULL,46881526178,732523846,11445685,14.66),(114648,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114648,34.46,0.32,78,50101,NULL,NULL,'B, Hubble-type-TF','ESO 384- G 009',NULL,'2005Ap&SS.299..387R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114649,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114649,34.46,NULL,78,50101,NULL,NULL,'B, Hubble-type-TF','ESO 384- G 009',NULL,'2005Ap&SS.299..405R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114650,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114650,34.97,0.75,98.7,50101,NULL,NULL,'Malmquist cor.','ESO 384- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114651,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114651,35.14,0.69,107,50101,NULL,NULL,NULL,'ESO 384- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114652,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114652,35.18,0.2,109,50101,74.4,NULL,NULL,'ESO 384- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114653,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114653,36.7,0.33,219,50102,70,NULL,NULL,'2MASX J13534073+2400430',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.74',0.2,'AGN',NULL,NULL,NULL,NULL,1,208.41975,24.012,0,NULL,59459196313,929049942,14516405,17.74),(114654,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114654,36.67,0.65,216,50103,70,NULL,NULL,'2MASX J13534137-4658532',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'17.6b',0.3,NULL,NULL,NULL,NULL,NULL,1,208.422375,-46.98142,0.605,NULL,46826184268,731659129,11432173,17.6),(114655,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114655,37.58,0.46,329,50104,70,NULL,NULL,'2MASX J13534157+6217098',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000176,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,208.4232917,62.28597,0.045,NULL,57261530938,894711420,13979865,16.4),(114656,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114656,33.99,0.2,62.8,50105,74.4,NULL,NULL,'IC 0952',NULL,'2013AJ....146...86T',2013,1,1.37,NULL,'G',0.000033,NULL,'14.4g',0.49,'SBbc',NULL,NULL,NULL,NULL,1,208.424666667,3.37739,0.021,NULL,58437175879,913080873,14266888,14.4),(114657,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114657,34.08,0.4,65.6,50105,NULL,NULL,'mean','IC 0952',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114658,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114658,34.09,0.41,65.7,50105,NULL,NULL,NULL,'IC 0952',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114659,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114659,34.23,0.38,70.1,50105,NULL,NULL,'Malmquist cor.','IC 0952',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114660,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114660,34.26,0.47,71.1,50105,NULL,NULL,'H','IC 0952',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114661,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114661,37.79,0.27,361,50106,70,NULL,NULL,'2MASX J13534238+5839187',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,208.4267083,58.65528,0,NULL,57266868094,894794813,13981168,17.8),(114662,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114662,37.3,0.46,289,50107,70,NULL,NULL,'2MASX J13534261+3341140',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,208.427667,33.68728,0,NULL,59150446646,924225728,14441027,17.5),(114663,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114663,36.95,0.46,246,50108,70,NULL,NULL,'2MASX J13534321+3244066',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.97',0.17,NULL,NULL,NULL,NULL,NULL,1,208.429875,32.73506,0,NULL,59181981019,924718453,14448725,17.97),(114664,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114664,36.06,0.52,163,50109,70,NULL,NULL,'2MASX J13534346-4851557',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'16.14',0.36,NULL,NULL,NULL,NULL,NULL,1,208.4307083,-48.86539,0.669,NULL,46819390683,731552979,11430515,16.14),(114665,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114665,36.52,0.46,202,50110,70,NULL,NULL,'MCG +06-31-014',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.00012,NULL,'15.1g',0.6,NULL,NULL,NULL,NULL,NULL,1,208.434083,34.80383,0,NULL,59151189852,924237341,14441208,15.1),(114666,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114666,37.79,0.27,361,50111,70,NULL,NULL,'2MASX J13534506+5838206',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000161,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,208.437583333,58.63919,0,NULL,57266867702,894794807,13981168,16.5),(114667,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114667,32.76,0.4,35.7,50112,NULL,NULL,'mean','NGC 5355',NULL,'2007A&A...465...71T',2007,1,1.12,NULL,'G',0.000017,NULL,'13.9g',0.72,'E3','in a radial-velocity based grouping',NULL,NULL,NULL,1,208.439833333,40.33867,0,NULL,59271577314,926118395,14470599,13.9),(114668,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114668,32.99,0.45,39.6,50112,NULL,NULL,'K','NGC 5355',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114669,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114669,36.14,0.46,169,50113,70,NULL,NULL,'2MASX J13534685+5126055',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000162,NULL,'16.1g',0.3,'S0^-',NULL,NULL,NULL,NULL,1,208.445333,51.43489,0.008,NULL,59217828770,925278574,14457477,16.1),(114670,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114670,38.26,0.46,448,50114,70,NULL,NULL,'2MASX J13534744+2201257',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,208.4477083,22.02394,0.009,NULL,59460105989,929064156,14516627,18),(114671,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114671,37.92,0.27,383,50115,70,NULL,NULL,'SDSS J135348.70+121947.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,208.4529583,12.33,0,NULL,58341152730,911580511,14243445,18.2),(114672,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114672,37.52,0.46,319,50116,70,NULL,NULL,'2MASX J13535026+1629300',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.59',0.12,NULL,NULL,NULL,NULL,NULL,1,208.459375,16.49164,0.014,NULL,58384250084,912253907,14253967,18.59),(114673,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114673,38.1,0.23,416,50117,70,NULL,NULL,'2MASX J13535090+1311380',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,208.462,13.19403,0,NULL,58342715973,911604937,14243827,17.8),(114674,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114674,38.11,0.33,419,50118,70,NULL,NULL,'2MASX J13535098+4443448',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,208.4625417,44.72911,0,NULL,59262048118,925969501,14468273,18.2),(114675,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114675,36.94,0.33,244,50119,70,NULL,NULL,'2MASX J13535150+0629451',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000185,NULL,'15.8g',0.44,NULL,NULL,NULL,NULL,NULL,1,208.464625,6.49594,0,NULL,58427607819,912931372,14264552,15.8),(114676,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114676,30.47,NULL,12.4,50120,72,NULL,NULL,'AGC 238709',NULL,'2014Ap.....57..457K',2014,1,NULL,NULL,'RadioS',0.000043,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,208.473333,4.88361,0,NULL,58438688752,913104511,14267257,NULL),(114677,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114677,37.71,0.46,349,50121,70,NULL,NULL,'2MASX J13535414+5710056',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00016,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,208.4755,57.16828,0.005,NULL,57297392546,895271758,13988621,16.4),(114678,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114678,37.99,0.46,397,50122,70,NULL,NULL,'2MASX J13535419+6057598',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,208.476,60.96672,0.029,NULL,57263828967,894747327,13980426,17.9),(114679,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114679,37.5,0.46,317,50123,70,NULL,NULL,'SDSS J135355.14+023738.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000072,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,208.47975,2.62731,0.049,NULL,58444642420,913197537,14268711,17.8),(114680,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114680,36.11,0.46,167,50124,70,NULL,NULL,'2MASX J13535560+3050002',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000153,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,208.481833,30.83331,0,NULL,59127898026,923873406,14435521,16.8),(114681,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114681,36.68,0.27,217,50125,70,NULL,NULL,'2MASX J13535573+2500420',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000165,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,208.48225,25.01167,0,NULL,59999147689,937486682,14648229,17.1),(114682,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114682,36.36,0.56,187,50126,70,NULL,NULL,'2MASX J13535645-2755390',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,208.4852917,-27.92756,0.189,NULL,46990947694,734233557,11472399,15.5),(114683,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114683,37.08,0.46,261,50127,70,NULL,NULL,'2MASX J13535659+0657281',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,208.485917,6.95778,0,NULL,58456616050,913384625,14271634,17.9),(114684,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114684,37.29,0.27,287,50128,70,NULL,NULL,'2MASX J13535789+5501077',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000176,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,208.49125,55.01886,0,NULL,57283474014,895054281,13985223,17.1),(114685,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114685,36.65,0.27,213,50129,70,NULL,NULL,'2MASX J13535839+3308062',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.77',0.17,NULL,NULL,NULL,NULL,NULL,1,208.4935,33.13492,0,NULL,59181943446,924717866,14448716,17.77),(114686,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114686,34.21,0.52,69.6,50130,70,NULL,NULL,'ESO 510- G 007',NULL,'2014MNRAS.445.2677S',2014,1,1.9,NULL,'G',0.00011,NULL,'14.22',0.5,'SB(rs)a:',NULL,NULL,NULL,NULL,1,208.4935417,-27.62322,0.257,NULL,46977269844,734019841,11469060,14.22),(114687,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114687,34.71,0.2,87.5,50130,74.4,NULL,NULL,'ESO 510- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114688,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114688,37.58,0.46,328,50131,70,NULL,NULL,'2MASXi J1353584-021301',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,208.493625,-2.21722,0.101,NULL,43610670654,681416728,10647136,17.9),(114689,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114689,37.32,0.59,291,50132,70,NULL,NULL,'2MASX J13535907-2757075',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,208.496166667,-27.95211,0.189,NULL,46990948301,734233567,11472399,15.6),(114690,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114690,37.32,0.46,291,50133,70,NULL,NULL,'2MASX J13535956+2344098',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.05',0.16,NULL,NULL,NULL,NULL,NULL,1,208.498375,23.73622,0,NULL,59461964628,929093197,14517081,18.05),(114691,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114691,37.84,0.46,371,50134,70,NULL,NULL,'2MASX J13540005+3645137',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,208.500125,36.75378,0,NULL,59155938276,924311535,14442367,17.6),(114692,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114692,37.15,0.46,269,50135,70,NULL,NULL,'2MASX J13540071+6616507',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000069,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,208.5027917,66.28069,0.061,NULL,57879697675,904370276,14130785,17.5),(114693,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114693,37.33,0.27,293,50136,70,NULL,NULL,'2MASX J13540217+2424174',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000202,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,208.509083,24.40469,0,NULL,59995642309,937431911,14647373,16.3),(114694,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114694,37.11,0.46,264,50137,70,NULL,NULL,'SDSS J135402.36+214238.8',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.2g',0.41,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,208.509833,21.71081,0.007,NULL,58319825351,911247271,14238238,16.2),(114695,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114695,37.29,0.27,287,50138,70,NULL,NULL,'2MASX J13540260+5449287',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,208.510791667,54.82475,0,NULL,57283316178,895051815,13985184,17.3),(114696,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114696,35.35,0.27,118,50139,70,NULL,NULL,'CGCG 191-014',NULL,'2015arXiv151105856S',2015,1,0.87,NULL,'G',0.00008,NULL,'15.0g',0.42,NULL,'Group member',NULL,NULL,NULL,1,208.5120417,37.38094,0,NULL,59154879578,924294993,14442109,15),(114697,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114697,35.35,0.27,118,50140,70,NULL,NULL,'MCG +06-31-018',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000185,NULL,'15.2g',0.64,NULL,NULL,NULL,NULL,NULL,1,208.5155,37.41719,0,NULL,59154830393,924294224,14442097,15.2),(114698,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114698,34.27,0.2,71.5,50141,74.4,NULL,NULL,'UGC 08816',NULL,'2013AJ....146...86T',2013,1,0.95,NULL,'G',0.000277,NULL,'15.4g',0.45,'Scd:',NULL,NULL,NULL,NULL,1,208.515917,3.95136,0.03,NULL,58438110037,913095469,14267116,15.4),(114699,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114699,34.32,0.5,73,50141,NULL,NULL,NULL,'UGC 08816',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114700,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114700,34.58,0.44,82.3,50141,NULL,NULL,'Malmquist cor.','UGC 08816',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114701,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114701,38.61,0.46,527,50142,70,NULL,NULL,'SDSS J135404.02+073055.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,208.5167917,7.51533,0,NULL,58456697100,913385892,14271654,18.1),(114702,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114702,37.33,0.27,293,50143,70,NULL,NULL,'SDSS J135405.78+243148.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000175,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,208.524083,24.53022,0,NULL,59995649872,937432029,14647375,18.2),(114703,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114703,36.34,0.46,185,50144,70,NULL,NULL,'2MASX J13540576+3620487',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000173,NULL,'16.0g',0.47,NULL,NULL,NULL,NULL,NULL,1,208.524208333,36.34681,0,NULL,59155754571,924308665,14442322,16),(114704,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114704,37.01,0.27,252,50145,70,NULL,NULL,'SDSS J135406.58+120135.7',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,'PRED','16.2g',0.37,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,208.527417,12.02658,0,NULL,58462027438,913469178,14272955,16.2),(114705,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114705,37.78,0.46,360,50146,70,NULL,NULL,'2MASX J13540666+5637577',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000148,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,208.5279583,56.63264,0,NULL,57309476380,895460568,13991571,17.5),(114706,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114706,36.91,0.46,241,50147,70,NULL,NULL,'2MASX J13540676+0458119',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000152,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,208.528125,4.96997,0,NULL,58438551036,913102359,14267224,17.2),(114707,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114707,36.42,0.46,193,50148,70,NULL,NULL,'2MASX J13540789+1251159',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000157,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,208.533041667,12.85447,0,NULL,58342161903,911596279,14243691,16.6),(114708,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114708,37.01,0.27,252,50149,70,NULL,NULL,'SDSS J135408.37+120117.5',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.0g',0.32,'S0',NULL,NULL,NULL,NULL,1,208.534916667,12.02156,0,NULL,58462027487,913469179,14272955,16),(114709,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114709,36.7,0.33,219,50150,70,NULL,NULL,'2MASX J13540871+2407594',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.19',0.24,NULL,NULL,NULL,NULL,NULL,1,208.536375,24.13328,0,NULL,59459028839,929047325,14516364,17.19),(114710,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114710,34.34,0.2,73.8,50151,74.4,NULL,NULL,'CGCG 073-094',NULL,'2013AJ....146...86T',2013,1,0.41,NULL,'G',0.000244,NULL,'17.01',0.34,NULL,NULL,NULL,NULL,NULL,1,208.53675,9.41269,0.034,NULL,58465185611,913518525,14273726,17.01),(114711,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114711,37.72,0.19,351,50152,70,NULL,NULL,'2MASX J13540883+1936128',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'17.25',0.14,NULL,NULL,NULL,NULL,NULL,1,208.537041667,19.60342,0.052,NULL,58330480614,911413759,14240839,17.25),(114712,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114712,37.01,0.27,252,50153,70,NULL,NULL,'2MASX J13540927+1156479',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,208.5387083,11.94653,0,NULL,58462042180,913469409,14272959,17.7),(114713,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114713,33.05,0.45,40.8,50154,NULL,NULL,'K','NGC 5370',NULL,'2007A&A...465...71T',2007,1,1.18,NULL,'G',0.00009,NULL,'13.7g',1.05,'SB(r)0^0^','Group member',NULL,NULL,NULL,1,208.539041667,60.67806,0.013,NULL,57275857911,894935279,13983363,13.7),(114714,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114714,33.28,0.4,45.3,50154,NULL,NULL,'mean','NGC 5370',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114715,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114715,37.78,0.09,359,50155,70,NULL,NULL,'2MASX J13541038+0516539',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000173,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,208.543208333,5.28164,0.025,NULL,58435738085,913058407,14266537,16.8),(114716,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114716,36.1,0.46,166,50156,70,NULL,NULL,'2MASX J13541109+2433224',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,208.546416667,24.55628,0,NULL,59995645110,937431954,14647374,16.8),(114717,'IRAS','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114717,31.87,0.8,23.7,50157,75,NULL,'A82, H','NGC 5348',NULL,'1997ApJS..109..333W',1997,1,3.5,NULL,'G',0.000017,NULL,'13.90',0.5,'SBbc: sp','in a radial-velocity based grouping',NULL,NULL,NULL,1,208.546958333,5.22744,0.025,NULL,58435737572,913058399,14266537,13.9),(114718,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114718,30.3,0.4,11.5,50157,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5348',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114719,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114719,30.86,0.47,14.9,50157,75,NULL,'A82, H, inv','NGC 5348',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114720,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114720,30.88,0.4,15,50157,75,NULL,NULL,'NGC 5348',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114721,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114721,30.97,0.38,15.6,50157,NULL,NULL,NULL,'NGC 5348',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114722,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114722,31.01,0.43,15.9,50157,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5348',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114723,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114723,31.02,0.47,16,50157,75,NULL,'A82, H, raw','NGC 5348',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114724,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114724,31.07,0.43,16.4,50157,75,NULL,'3.6 micron, color corrected','NGC 5348',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114725,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114725,31.11,0.2,16.7,50157,74.4,NULL,NULL,'NGC 5348',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114726,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114726,31.3,0.47,18.2,50157,75,NULL,'A82, H, cor','NGC 5348',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114727,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114727,31.4,0.49,19.1,50157,75,NULL,'IR','NGC 5348',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114728,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114728,31.42,0.72,19.2,50157,NULL,NULL,NULL,'NGC 5348',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114729,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114729,31.48,NULL,19.8,50157,72,NULL,NULL,'NGC 5348',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114730,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114730,31.52,0.68,20.1,50157,NULL,NULL,'Malmquist cor.','NGC 5348',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114731,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114731,31.94,0.4,24.4,50157,NULL,NULL,'mean','NGC 5348',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114732,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114732,32.09,0.4,26.2,50157,75,NULL,'B','NGC 5348',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114733,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114733,32.22,0.47,27.8,50157,NULL,NULL,'H','NGC 5348',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114734,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114734,33.99,0.4,62.9,50158,NULL,NULL,'mean','MCG -01-35-020',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.00001,NULL,'14.96',1.3,'(R\')SB(r)bc:',NULL,NULL,NULL,NULL,1,208.5507917,-4.84697,0.049,NULL,43607882409,681373162,10646455,14.96),(114735,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114735,34.2,0.47,69.2,50158,NULL,NULL,'H','MCG -01-35-020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114736,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114736,34.25,0.45,70.6,50158,NULL,NULL,'K','MCG -01-35-020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114737,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114737,34.3,0.46,72.6,50158,NULL,NULL,'J','MCG -01-35-020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114738,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114738,34.31,0.59,72.8,50158,NULL,NULL,NULL,'MCG -01-35-020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114739,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114739,34.35,0.2,74.1,50158,74.4,NULL,NULL,'MCG -01-35-020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114740,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114740,34.38,0.57,75.2,50158,NULL,NULL,'Malmquist cor.','MCG -01-35-020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114741,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114741,37.92,0.27,383,50159,70,NULL,NULL,'2MASX J13541275+1219099',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.2g',0.24,'BrClG',NULL,NULL,NULL,NULL,1,208.5532917,12.3195,0,NULL,58340983144,911577861,14243404,17.2),(114742,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114742,37.78,0.09,359,50160,70,NULL,NULL,'2MASX J13541279+0512189',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000184,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,208.553417,5.20528,0.025,NULL,58435736615,913058384,14266537,18),(114743,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114743,37.78,0.09,359,50161,70,NULL,NULL,'SDSS J135413.20+052231.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000191,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,208.5550417,5.37531,0.025,NULL,58435860752,913060324,14266567,18.5),(114744,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114744,37.04,0.46,256,50162,70,NULL,NULL,'SDSS J135413.88+441845.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,208.557875,44.31264,0,NULL,59264840718,926013136,14468955,17.7),(114745,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114745,37.3,0.53,289,50163,70,NULL,NULL,'2MASX J13541461-2750515',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'14.8b',NULL,'*+E',NULL,NULL,NULL,NULL,1,208.560958333,-27.84769,0.181,NULL,46990926377,734233224,11472394,14.8),(114746,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114746,36.86,0.56,235,50164,70,NULL,NULL,'2MASX J13541491-2735325',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00013,NULL,'15.2',NULL,'E',NULL,NULL,NULL,NULL,1,208.562041667,-27.59242,0.257,NULL,46991032992,734234890,11472420,15.2),(114747,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114747,36.83,0.46,232,50165,70,NULL,NULL,'2MASX J13541624+2858484',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000137,NULL,'16.4g',0.37,'E',NULL,NULL,NULL,NULL,1,208.567625,28.98022,0,NULL,60004893335,937576458,14649632,16.4),(114748,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114748,36.19,0.59,173,50166,70,NULL,NULL,'2MASX J13541661-1603418',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,208.5692917,-16.06153,0.253,NULL,43686151463,682596116,10665564,15.6),(114749,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114749,38.69,0.46,547,50167,70,NULL,NULL,'2MASX J13541667+1132126',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000179,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,208.569583,11.53675,0,NULL,58462051978,913469562,14272961,17.1),(114750,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114750,36.45,0.51,195,50168,70,NULL,NULL,'2MASX J13541771-2751115',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.2b',NULL,'E',NULL,NULL,NULL,NULL,1,208.573833333,-27.85317,0.181,NULL,46990926451,734233225,11472394,16.2),(114751,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114751,37.53,0.46,320,50169,70,NULL,NULL,'2MASX J13541813+2459314',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000176,NULL,'17.98',0.16,NULL,NULL,NULL,NULL,NULL,1,208.575625,24.99194,0,NULL,59999216418,937487756,14648246,17.98),(114752,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114752,34.22,0.46,69.7,50170,70,NULL,NULL,'ESO 510- G 010',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000083,NULL,'13.67',1.1,'(R\'?)SB(s)a','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,208.577,-26.89378,0.233,NULL,46978195134,734034298,11469285,13.67),(114753,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114753,35.29,0.46,114,50171,70,NULL,NULL,'2MASX J13541884+0825086',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.55',0.17,NULL,NULL,NULL,NULL,NULL,1,208.5784583,8.419,0.023,NULL,58459337628,913427150,14272299,17.55),(114754,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114754,38.87,0.46,595,50172,70,NULL,NULL,'SDSS J135419.31+640650.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000078,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,208.5805417,64.11408,0.005,NULL,57932279700,905191870,14143622,18.4),(114755,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114755,36.22,0.85,176,50173,70,NULL,NULL,'2MASX J13541949-4720257',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'17.2b',0.3,NULL,NULL,NULL,NULL,NULL,1,208.581208333,-47.3405,0.729,NULL,46825646358,731650724,11432042,17.2),(114756,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114756,37.04,0.33,256,50174,70,NULL,NULL,'2MASX J13541970+2655234',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000169,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,208.582125,26.92333,0,NULL,59998324233,937473816,14648028,16.6),(114757,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114757,38.13,0.46,422,50175,70,NULL,NULL,'2MASX J13542092+3903161',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000173,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,208.5872083,39.05456,0.012,NULL,59266624822,926041012,14469390,17.2),(114758,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114758,36.8,0.46,229,50176,70,NULL,NULL,'2MASX J13542145+4449285',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000161,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,208.5895,44.82444,0,NULL,59262098908,925970295,14468285,16.7),(114759,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114759,37.58,0.33,329,50177,70,NULL,NULL,'2MASX J13542170+2816174',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000202,NULL,'16.1g',0.39,NULL,NULL,NULL,NULL,NULL,1,208.590375,28.2715,0,NULL,60005000740,937578136,14649658,16.1),(114760,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114760,36.84,0.46,234,50178,70,NULL,NULL,'2MASX J13542212+4406554',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000169,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,208.592167,44.11556,0,NULL,59264980928,926015327,14468989,16.5),(114761,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114761,37.4,0.46,301,50179,70,NULL,NULL,'2MASX J13542234+0745356',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000178,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,208.593125,7.75983,0,NULL,58460000696,913437510,14272461,16.4),(114762,'D-Sigma','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114762,31.7,0.4,21.9,50180,75,NULL,'Edat, raw','NGC 5333',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.00015,NULL,'11.67',1,'SB(r)0^0^:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,208.600916667,-48.51253,0.701,NULL,46819229995,731550468,11430476,11.67),(114763,'D-Sigma','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114763,32.04,0.4,25.6,50180,75,NULL,'Edat, cor','NGC 5333',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114764,'Tully est','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114764,32.82,0.8,36.6,50180,75,NULL,NULL,'NGC 5333',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114765,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114765,32.07,0.45,25.9,50180,NULL,NULL,'K','NGC 5333',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114766,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114766,32.91,0.4,38.1,50180,NULL,NULL,'mean','NGC 5333',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114767,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114767,36.93,0.46,243,50181,70,NULL,NULL,'2MASXi J1354246+463644',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000146,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,208.602583,46.61242,0.006,NULL,59240434203,925631784,14462996,17.2),(114768,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114768,32.59,0.4,33,50182,75,NULL,'B','NGC 5452',NULL,'1988NBGC.C....0000T',1988,1,2,NULL,'G',0.000037,NULL,'13.90',1.5,'SAB(s)d','Isolated galaxy (6 Mpc isolation)',NULL,NULL,NULL,1,208.60375,78.22056,0.037,NULL,57147696729,892932761,13952074,13.9),(114769,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114769,32.6,0.4,33.1,50182,NULL,NULL,NULL,'NGC 5452',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114770,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114770,36.35,0.46,186,50183,70,NULL,NULL,'2MASX J13542531+5327357',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000165,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,208.605166667,53.45997,0,NULL,59216808828,925262637,14457228,16.2),(114771,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114771,37.72,0.19,351,50184,70,NULL,NULL,'2MASX J13542527+1934453',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.11',0.14,NULL,NULL,NULL,NULL,NULL,1,208.605333333,19.57922,0.057,NULL,58330506442,911414163,14240846,18.11),(114772,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114772,37.3,0.46,289,50185,70,NULL,NULL,'2MASX J13542529+0633076',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,208.6055,6.55211,0.023,NULL,58426779052,912918422,14264350,17.1),(114773,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114773,37.37,0.46,297,50186,70,NULL,NULL,'2MASX J13542572+0837476',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.22',0.15,NULL,NULL,NULL,NULL,NULL,1,208.60725,8.62994,0.026,NULL,58459310958,913426733,14272292,18.22),(114774,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114774,36.98,0.46,248,50187,70,NULL,NULL,'SDSS J135425.85+092537.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'17.7g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,208.60775,9.42722,0.034,NULL,58465137208,913517768,14273715,17.7),(114775,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114775,37.78,0.46,359,50188,70,NULL,NULL,'2MASX J13542661+6050272',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000188,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,208.6109583,60.84092,0.041,NULL,57263794970,894746796,13980418,16.5),(114776,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114776,35.58,0.4,131,50189,NULL,NULL,'mean','UGC 08828',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000033,NULL,'15.19',0.4,'S?',NULL,NULL,NULL,NULL,1,208.611917,21.83006,0.007,NULL,59459647988,929056999,14516515,15.19),(114777,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114777,35.82,0.47,146,50189,NULL,NULL,'H','UGC 08828',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114778,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114778,35.91,0.45,152,50189,NULL,NULL,'K','UGC 08828',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114779,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114779,35.97,0.46,156,50189,NULL,NULL,'J','UGC 08828',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114780,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114780,36.16,0.42,170,50189,NULL,NULL,'Malmquist cor.','UGC 08828',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114781,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114781,36.51,0.36,200,50189,NULL,NULL,NULL,'UGC 08828',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114782,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114782,36.54,0.2,203,50189,74.4,NULL,NULL,'UGC 08828',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114783,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114783,38.16,0.46,428,50190,70,NULL,NULL,'2MASX J13542758+0830071',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.40',0.13,NULL,NULL,NULL,NULL,NULL,1,208.6147917,8.50217,0.023,NULL,58459354178,913427409,14272303,18.4),(114784,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114784,37.57,0.46,326,50191,70,NULL,NULL,'2MASX J13542765+4659014',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,208.615167,46.98361,0.007,NULL,59241254266,925644597,14463196,17.3),(114785,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114785,34.28,0.49,71.7,50192,75,NULL,'IR','UGC 08830',NULL,'2011yCatp016004901K',2011,1,1.19,NULL,'G',0.00011,NULL,'15.1g',0.31,'S',NULL,NULL,NULL,NULL,1,208.6184583,36.21897,0,NULL,59155742899,924308482,14442320,15.1),(114786,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114786,36.74,0.27,222,50193,70,NULL,NULL,'2MASX J13542861+2131493',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.2g',0.32,NULL,NULL,NULL,NULL,NULL,1,208.6192917,21.53039,0.011,NULL,58319933629,911248962,14238265,16.2),(114787,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114787,36.26,0.46,178,50194,70,NULL,NULL,'2MASX J13542890+0526367',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000127,NULL,'15.7g',0.47,'E0             AGN',NULL,NULL,NULL,NULL,1,208.620333,5.44339,0.029,NULL,58436072223,913063628,14266619,15.7),(114788,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114788,37.4,0.46,302,50195,70,NULL,NULL,'SDSS J135429.05+201908.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.5g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,208.6210417,20.31914,0.042,NULL,58331957827,911436841,14241200,17.5),(114789,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114789,37.94,0.33,387,50196,70,NULL,NULL,'2MASX J13542906+2109333',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.98',0.19,NULL,NULL,NULL,NULL,NULL,1,208.6210417,21.15925,0.01,NULL,58331338755,911427168,14241049,17.98),(114790,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114790,37,0.46,251,50197,70,NULL,NULL,'2MASX J13542954+3039357',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000174,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,208.623041667,30.66003,0,NULL,59127811073,923872048,14435500,16.5),(114791,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114791,36.15,0.2,170,50198,74.4,NULL,NULL,'KUG 1352+149',NULL,'2013AJ....146...86T',2013,1,0.88,NULL,'G',0.000106,NULL,'15.8g',0.27,'Spiral',NULL,NULL,NULL,NULL,1,208.625333,14.67569,0,NULL,58370996917,912046826,14250731,15.8),(114792,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114792,37.92,0.27,383,50199,70,NULL,NULL,'2MASXi J1354304+121644',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,208.627083,12.27897,0,NULL,58340998565,911578102,14243407,17.3),(114793,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114793,37.23,0.46,280,50200,70,NULL,NULL,'2MASX J13543104+0742481',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,208.6294583,7.71344,0,NULL,58459958459,913436850,14272450,17.9),(114794,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114794,37.75,0.46,355,50201,70,NULL,NULL,'2MASX J13543142+1529008',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,208.6310417,15.48353,0,NULL,58382505309,912226645,14253541,NULL),(114795,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114795,35.89,0.46,150,50202,70,NULL,NULL,'2MASX J13543156+5801507',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000172,NULL,'16.0g',0.36,'E0',NULL,NULL,NULL,NULL,1,208.631416667,58.03072,0,NULL,57297287635,895270119,13988595,16),(114796,'TRGB','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114796,27.06,0.15,2.59,50203,NULL,NULL,'I','kkh 086',NULL,'2009ApJS..183...67D',2009,1,0.7,NULL,'G',0.000002,NULL,'16.8',0.5,'Ir',NULL,NULL,NULL,NULL,1,208.639791667,4.243,0.035,1,58437658018,913088406,14267006,16.8),(114797,'TRGB','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114797,27.07,0.34,2.59,50203,NULL,NULL,'I','kkh 086',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114798,'TRGB','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114798,27.07,0.13,2.6,50203,NULL,NULL,NULL,'kkh 086',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114799,'TRGB','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114799,27.08,0.1,2.61,50203,NULL,NULL,NULL,'kkh 086',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114800,'TRGB','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114800,27.08,0.13,2.61,50203,NULL,NULL,NULL,'kkh 086',NULL,'2002A&A...389..812K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114801,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114801,36.62,0.46,210,50204,70,NULL,NULL,'2MASX J13543382+3420507',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000193,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,208.641083,34.34744,0,NULL,59150560724,924227511,14441054,16.3),(114802,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114802,37.72,0.19,351,50205,70,NULL,NULL,'SDSS J135434.36+193712.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,208.643167,19.62028,0.057,NULL,58330505765,911414152,14240846,18.3),(114803,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114803,36.88,0.46,238,50206,70,NULL,NULL,'2MASX J13543450+4246274',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000178,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,208.6435417,42.77439,0,NULL,59263995303,925999926,14468748,16.3),(114804,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114804,34.53,0.46,80.5,50207,70,NULL,NULL,'ESO 510- G 012',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000133,NULL,'14.82',1,'(R\'_2L)SB(s)0^0',NULL,NULL,NULL,NULL,1,208.644458333,-26.55611,0.233,NULL,46977606877,734025107,11469142,14.82),(114805,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114805,37.72,0.19,351,50208,70,NULL,NULL,'2MASX J13543489+1936574',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,208.645417,19.61592,0.057,NULL,58330508603,911414196,14240846,17.6),(114806,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114806,34.99,0.5,99.6,50209,70,NULL,NULL,'AM 1351-261 NED03',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000107,NULL,'15',0.4,'S0',NULL,NULL,NULL,NULL,1,208.647,-26.51219,0.233,NULL,46977609317,734025145,11469142,15),(114807,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114807,37.2,0.46,276,50210,70,NULL,NULL,'2MASX J13543599+1701058',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.15',0.16,NULL,NULL,NULL,NULL,NULL,1,208.650083333,17.01833,0.01,NULL,58380976832,912202763,14253168,18.15),(114808,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114808,38.27,0.46,451,50211,70,NULL,NULL,'2MASX J13543641+2242254',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,208.651667,22.70694,0,NULL,59460182837,929065356,14516646,17.8),(114809,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114809,37.25,0.27,281,50212,70,NULL,NULL,'2MASX J13543828+5407216',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000185,NULL,'16.0g',0.48,'E0',NULL,NULL,NULL,NULL,1,208.659417,54.12258,0,NULL,57285191630,895081119,13985642,16),(114810,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114810,37.31,0.46,289,50213,70,NULL,NULL,'2MASX J13543835+0912311',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,208.6597917,9.20861,0.034,NULL,58465035415,913516178,14273690,NULL),(114811,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114811,36.12,0.64,167,50214,70,NULL,NULL,'2MASX J13543893-2736167',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.8b',NULL,'Sp',NULL,NULL,NULL,NULL,1,208.6622083,-27.60469,0.257,NULL,46991046836,734235106,11472423,15.8),(114812,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114812,37.58,0.33,329,50215,70,NULL,NULL,'2MASX J13543935+2809524',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,208.66375,28.16469,0,NULL,60004779559,937574680,14649604,17.2),(114813,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114813,38.31,0.46,459,50216,70,NULL,NULL,'SDSS J135439.88+475546.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000135,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,208.6662083,47.92947,0.025,NULL,59240886991,925638859,14463107,18.4),(114814,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114814,37.72,0.19,351,50217,70,NULL,NULL,'2MASX J13544020+1937034',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.11',0.13,NULL,NULL,NULL,NULL,NULL,1,208.667667,19.61772,0.057,NULL,58330453659,911413338,14240833,18.11),(114815,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114815,37.38,0.23,299,50218,70,NULL,NULL,'SDSS J135440.78+281340.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'18.0g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,208.669917,28.22783,0,NULL,60005004682,937578198,14649659,18),(114816,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114816,36.74,0.27,222,50219,70,NULL,NULL,'2MASX J13544159+2128544',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.98',0.22,NULL,NULL,NULL,NULL,NULL,1,208.673333,21.48169,0.011,NULL,58319934805,911248981,14238265,16.98),(114817,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114817,37.63,0.46,335,50220,70,NULL,NULL,'2MASX J13544161+4345096',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000172,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,208.673417,43.75275,0,NULL,59264870800,926013606,14468962,17.1),(114818,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114818,37.54,0.46,322,50221,70,NULL,NULL,'2MASX J13544231+6422593',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000081,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,208.6760417,64.38322,0.005,NULL,57866194339,904159286,14127488,17.2),(114819,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114819,37.78,0.09,359,50222,70,NULL,NULL,'2MASX J13544229+0528557',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000205,NULL,'15.8g',0.42,'FR II          AGN',NULL,NULL,NULL,NULL,1,208.676125,5.48225,0.029,NULL,58436079758,913063746,14266621,15.8),(114820,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114820,35.97,0.46,156,50223,70,NULL,NULL,'2MASX J13544255+6514393',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000101,NULL,'15.4g',0.45,'E0',NULL,NULL,NULL,NULL,1,208.6770417,65.24431,0.033,NULL,57866650431,904166412,14127600,15.4),(114821,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114821,35.82,0.5,146,50224,70,NULL,NULL,'2MASX J13544429-1213149',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.95',NULL,NULL,NULL,NULL,NULL,NULL,1,208.684458333,-12.22086,0.121,NULL,43664283381,682254427,10660225,15.95),(114822,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114822,38.17,0.46,431,50225,70,NULL,NULL,'2MASX J13544442+3523467',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,208.6849583,35.39625,0,NULL,59152680796,924260637,14441572,17.6),(114823,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114823,35.57,0.17,130,50226,70,NULL,NULL,'CGCG 132-043',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000157,NULL,'15.5',0.39,NULL,NULL,NULL,NULL,NULL,1,208.689875,21.82992,0.007,NULL,59459645494,929056960,14516515,15.5),(114824,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114824,38.32,0.46,461,50227,70,NULL,NULL,'2MASX J13544570+4937201',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,208.690333,49.62219,0,NULL,59212133747,925189589,14456087,17.7),(114825,'Brightest Stars','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114825,29.6,NULL,8.3,50228,NULL,NULL,NULL,'Holmberg IV',NULL,'1994BSAO...38....5K',1994,1,4.3,'The UZC position refers to a knot 13 arcsec north of the faint nucleus.','G',0.00001,NULL,'13.81',1.3,'IB(s)m','Possible group member',NULL,NULL,NULL,1,208.690667,53.90075,0,NULL,57285052549,895078946,13985608,13.81),(114826,'TRGB','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114826,29.2,0.15,6.93,50228,NULL,NULL,NULL,'Holmberg IV',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114827,'TRGB','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114827,29.29,0.02,7.21,50228,NULL,NULL,'I','Holmberg IV',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114828,'TRGB','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114828,29.3,0.1,7.24,50228,74.4,NULL,NULL,'Holmberg IV',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114829,'HII region diameter','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114829,28.82,0.16,5.81,50228,NULL,NULL,'Method 2','Holmberg IV',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114830,'HII region diameter','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114830,28.87,0.09,5.94,50228,NULL,NULL,'Method 1','Holmberg IV',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114831,'IRAS','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114831,29.08,0.8,6.53,50228,75,NULL,'A82, H','Holmberg IV',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114832,'Magnitude','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114832,28.84,0.16,5.86,50228,NULL,NULL,NULL,'Holmberg IV',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114833,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114833,27.95,0.4,3.9,50228,75,NULL,'B','Holmberg IV',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114834,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114834,28.49,0.4,5,50228,NULL,NULL,'Virgo cluster at 15.6 Mpc','Holmberg IV',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114835,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114835,28.66,0.47,5.4,50228,75,NULL,'A82, H, inv','Holmberg IV',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114836,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114836,28.98,NULL,6.25,50228,NULL,NULL,'IR','Holmberg IV',NULL,'1980ApJ...237..655A',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114837,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114837,29.07,0.47,6.51,50228,75,NULL,'A82, H, raw','Holmberg IV',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114838,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114838,29.43,0.47,7.68,50228,75,NULL,'A82, H, cor','Holmberg IV',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114839,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114839,37.38,0.23,299,50229,70,NULL,NULL,'SDSS J135446.21+281431.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000164,NULL,'18.83',0.13,NULL,NULL,NULL,NULL,NULL,1,208.692583,28.24214,0,NULL,60005006546,937578227,14649659,18.83),(114840,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114840,37.01,0.74,252,50230,70,NULL,NULL,'2MASX J13544749-1454279',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,208.6979583,-14.90778,0.245,NULL,43673115521,682392430,10662381,17.1),(114841,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114841,36.62,0.46,211,50231,70,NULL,NULL,'2MASX J13544776+1615079',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.08',0.16,NULL,NULL,NULL,NULL,NULL,1,208.6989583,16.25228,0.033,NULL,58384294426,912254600,14253978,18.08),(114842,'Brightest Stars','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114842,27.53,NULL,3.2,50232,NULL,NULL,NULL,'UGC 08833',NULL,'1998A&AS..128..459M',1998,1,0.9,NULL,'G',0.000001,NULL,'16.5',0.8,'Im:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,208.702791667,35.83742,0,NULL,59152649815,924260153,14441564,16.5),(114843,'TRGB','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114843,27.4,0.1,3.02,50232,NULL,NULL,NULL,'UGC 08833',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114844,'TRGB','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114844,27.43,NULL,3.06,50232,NULL,NULL,NULL,'UGC 08833',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114845,'TRGB','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114845,27.45,0.04,3.08,50232,NULL,NULL,'I','UGC 08833',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114846,'TRGB','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114846,27.52,0.15,3.19,50232,NULL,NULL,NULL,'UGC 08833',NULL,'2003A&A...398..467K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114847,'TRGB','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114847,27.53,0.07,3.2,50232,NULL,NULL,NULL,'UGC 08833',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114848,'TRGB','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114848,27.52,0.08,3.2,50232,74.4,NULL,NULL,'UGC 08833',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114849,'TRGB','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114849,27.55,0.13,3.24,50232,NULL,NULL,'I','UGC 08833',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114850,'TRGB','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114850,27.55,0.08,3.24,50232,NULL,NULL,NULL,'UGC 08833',NULL,'2013AstBu..68..125M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114851,'Tully est','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114851,27.78,0.8,3.6,50232,75,NULL,NULL,'UGC 08833',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114852,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114852,38.43,0.46,486,50233,70,NULL,NULL,'SDSS J135448.74+344228.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000152,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,208.703125,34.70781,0,NULL,59150867834,924232309,14441129,18.4),(114853,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114853,36.4,0.27,190,50234,70,NULL,NULL,'2MASX J13544933+1436379',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,208.705583,14.61069,0,NULL,58370993459,912046772,14250730,17.1),(114854,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114854,38.52,0.46,506,50235,70,NULL,NULL,'2MASX J13544943+3606122',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,208.706,36.10342,0,NULL,59152599078,924259360,14441552,17.5),(114855,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114855,37.94,0.33,387,50236,70,NULL,NULL,'2MASX J13544974+2117266',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.27',0.16,NULL,NULL,NULL,NULL,NULL,1,208.70725,21.29083,0.011,NULL,58319927587,911248868,14238263,18.27),(114856,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114856,37.98,0.46,395,50237,70,NULL,NULL,'2MASX J13545011+4613596',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00017,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,208.7087083,46.23328,0,NULL,59232099876,925501560,14460961,17.7),(114857,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114857,38.06,0.46,409,50238,70,NULL,NULL,'SDSS J135450.20+663805.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00007,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,208.7092083,66.63472,0.061,NULL,57871688321,904245130,14128830,18.3),(114858,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114858,37.19,0.46,274,50239,70,NULL,NULL,'SDSS J135452.25+070839.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,208.7177083,7.14442,0.008,NULL,58457033226,913391144,14271736,18),(114859,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114859,36.74,0.27,222,50240,70,NULL,NULL,'2MASX J13545252+2125406',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,208.718917,21.42789,0.011,NULL,58319940273,911249066,14238266,17.3),(114860,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114860,37.53,0.19,321,50241,70,NULL,NULL,'2MASX J13545326+2645514',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,208.721917,26.76425,0.006,NULL,59998307852,937473560,14648024,17.2),(114861,'Tully est','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114861,32.89,0.8,37.8,50242,75,NULL,'B','NGC 5362',NULL,'1988NBGC.C....0000T',1988,1,2.3,NULL,'G',0.000013,NULL,'13.14',1,'Sb? pec','in a radial-velocity based grouping',NULL,NULL,NULL,1,208.722083,41.31353,0,NULL,59273807960,926153249,14471144,13.14),(114862,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114862,31.92,0.4,24.2,50242,NULL,NULL,NULL,'NGC 5362',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114863,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114863,32.17,0.43,27.2,50242,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5362',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114864,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114864,32.21,0.43,27.6,50242,75,NULL,'3.6 micron, color corrected','NGC 5362',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114865,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114865,32.21,0.2,27.7,50242,74.4,NULL,NULL,'NGC 5362',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114866,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114866,32.28,0.58,28.5,50242,NULL,NULL,NULL,'NGC 5362',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114867,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114867,32.32,0.57,29.1,50242,NULL,NULL,'Malmquist cor.','NGC 5362',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114868,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114868,32.59,0.46,33,50242,NULL,NULL,'J','NGC 5362',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114869,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114869,32.6,0.47,33.2,50242,NULL,NULL,'H','NGC 5362',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114870,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114870,32.63,0.4,33.6,50242,NULL,NULL,'mean','NGC 5362',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114871,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114871,32.64,0.45,33.8,50242,NULL,NULL,'K','NGC 5362',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114872,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114872,36.79,0.46,228,50243,70,NULL,NULL,'LCRS B135220.0-030156',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000113,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,208.73125,-3.27703,0.093,NULL,43597725547,681214461,10643975,17.5),(114873,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114873,35.29,0.25,114,50244,74.4,NULL,NULL,'IC 4343',NULL,'2013AJ....146...86T',2013,1,0.96,NULL,'G',0.00007,NULL,'14.8g',0.56,'E/S0           AGN','Group member',NULL,NULL,NULL,1,208.7325,25.12264,0,NULL,59999206937,937487608,14648243,14.8),(114874,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114874,35.5,0.17,126,50244,70,NULL,NULL,'IC 4343',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114875,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114875,35.67,0.16,136,50244,70,NULL,NULL,'IC 4343',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114876,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114876,35.66,0.5,135,50245,70,NULL,NULL,'2MASX J13545583-2717507',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.7b',NULL,'E',NULL,NULL,NULL,NULL,1,208.732667,-27.2975,0.245,NULL,46977330230,734020784,11469074,15.7),(114877,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114877,36.65,0.27,213,50246,70,NULL,NULL,'2MASX J13545710+3309137',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.25',0.17,NULL,NULL,NULL,NULL,NULL,1,208.737875,33.15381,0,NULL,59181926104,924717595,14448712,18.25),(114878,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114878,37.63,0.46,336,50247,70,NULL,NULL,'2MASX J13545807+0946304',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.47',0.13,NULL,NULL,NULL,NULL,NULL,1,208.742,9.77517,0.031,NULL,58465236106,913519314,14273739,18.47),(114879,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114879,35.69,0.51,137,50248,70,NULL,NULL,'2MASX J13545843-1937073',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.77',NULL,NULL,NULL,NULL,NULL,NULL,1,208.743416667,-19.61883,0.237,NULL,43633884171,681779440,10652803,15.77),(114880,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114880,31.45,0.4,19.5,50249,NULL,NULL,NULL,'NGC 5356',NULL,'2009AJ....138..323T',2009,1,3.71,NULL,'G',0.000017,NULL,'13.3g',0.76,'SABbc: sp      HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,208.743583,5.33372,0.029,NULL,58435942779,913061605,14266587,13.3),(114881,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114881,31.45,NULL,19.5,50249,72,NULL,NULL,'NGC 5356',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114882,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114882,31.91,0.4,24.1,50249,75,NULL,NULL,'NGC 5356',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114883,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114883,31.95,0.47,24.5,50249,NULL,NULL,'Malmquist cor.','NGC 5356',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114884,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114884,31.96,0.4,24.7,50249,NULL,NULL,'mean','NGC 5356',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114885,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114885,32.01,0.49,25.2,50249,75,NULL,'IR','NGC 5356',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114886,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114886,32.1,0.46,26.4,50249,NULL,NULL,'J','NGC 5356',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114887,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114887,32.11,0.47,26.4,50249,NULL,NULL,'H','NGC 5356',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114888,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114888,32.15,0.45,26.9,50249,NULL,NULL,'K','NGC 5356',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114889,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114889,32.21,0.41,27.7,50249,NULL,NULL,NULL,'NGC 5356',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114890,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114890,32.25,0.2,28.2,50249,74.4,NULL,NULL,'NGC 5356',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114891,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114891,35.98,0.46,157,50250,70,NULL,NULL,'LCRS B135223.4-021916',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00015,NULL,'15.9g',0.43,'SB0a',NULL,NULL,NULL,NULL,1,208.7437917,-2.56558,0.105,NULL,43592698786,681135918,10642748,15.9),(114892,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114892,36.04,0.6,161,50250,70,NULL,NULL,'LCRS B135223.4-021916',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114893,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114893,34.67,0.46,85.9,50251,70,NULL,NULL,'CGCG 246-025',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000169,NULL,'15.3g',0.45,'S0',NULL,NULL,NULL,NULL,1,208.745,46.94444,0.007,NULL,59241386326,925646661,14463229,15.3),(114894,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114894,37.15,0.46,269,50252,70,NULL,NULL,'2MASX J13550026+1541164',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.43',0.12,NULL,NULL,NULL,NULL,NULL,1,208.7512917,15.68778,0,NULL,58382393269,912224894,14253513,18.43),(114895,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114895,37.25,0.27,281,50253,70,NULL,NULL,'2MASX J13550056+5359421',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000187,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,208.75225,53.99508,0,NULL,57285242901,895081920,13985655,16.4),(114896,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114896,37.06,0.33,259,50254,70,NULL,NULL,'2MASX J13550062+1756526',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.26',0.15,NULL,NULL,NULL,NULL,NULL,1,208.7525417,17.94803,0,NULL,58373206489,912081351,14251271,18.26),(114897,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114897,37.59,0.46,329,50255,70,NULL,NULL,'2MASX J13550135+4550066',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00019,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,208.755833,45.835,0,NULL,59232944274,925514754,14461168,16.4),(114898,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114898,36.56,0.46,205,50256,70,NULL,NULL,'2MASX J13550168+2442524',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,208.757083,24.71458,0,NULL,59999045063,937485079,14648204,17),(114899,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114899,37.83,0.46,368,50257,70,NULL,NULL,'SDSS J135503.22+524708.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,208.7635,52.78558,0,NULL,59218925167,925295705,14457745,17.8),(114900,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114900,37.53,0.19,321,50258,70,NULL,NULL,'2MASX J13550388+2646344',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000175,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,208.76625,26.77611,0.006,NULL,59998030496,937469226,14647956,18.5),(114901,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114901,38.1,0.46,417,50259,70,NULL,NULL,'2MASX J13550399+0542549',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,208.7667083,5.71519,0.021,NULL,58435243119,913050673,14266416,17.6),(114902,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114902,36.6,0.46,209,50260,70,NULL,NULL,'2MASX J13550414+3410108',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00018,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,208.767416667,34.16958,0,NULL,59151639007,924244359,14441318,16.3),(114903,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114903,38.09,0.46,416,50261,70,NULL,NULL,'2MASX J13550420+0822404',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000186,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,208.767625,8.37778,0.023,NULL,58459305256,913426644,14272291,17.2),(114904,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114904,37.88,0.46,376,50262,70,NULL,NULL,'SDSS J135504.46+161139.4',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,208.768625,16.19431,0.033,NULL,58384315506,912254929,14253983,17.3),(114905,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114905,30.85,NULL,14.8,50263,72,NULL,NULL,'SDSS J135504.50+051122.2',NULL,'2014Ap.....57..457K',2014,1,0.39,NULL,'G',0.000006,NULL,'16.7g',0.36,NULL,NULL,NULL,NULL,NULL,1,208.768791667,5.18953,0.034,NULL,58435656395,913057131,14266517,16.7),(114906,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114906,37.06,0.33,259,50264,70,NULL,NULL,'2MASX J13550581+1755266',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.96',0.15,NULL,NULL,NULL,NULL,NULL,1,208.77425,17.92419,0.008,NULL,58373210096,912081407,14251271,17.96),(114907,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114907,37.2,0.21,275,50265,70,NULL,NULL,'2MASX J13550682+2020186',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.16',0.16,NULL,NULL,NULL,NULL,NULL,1,208.7785,20.33856,0.043,NULL,58331884699,911435698,14241182,18.16),(114908,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114908,38.48,0.33,497,50266,70,NULL,NULL,'SDSS J135507.19+531210.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,208.78,53.20281,0,NULL,59218870904,925294857,14457732,18.5),(114909,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114909,37.07,0.46,259,50267,70,NULL,NULL,'2MASX J13550792+5653401',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,208.783083333,56.89436,0.009,NULL,57309415034,895459609,13991556,17.6),(114910,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114910,37.24,0.46,280,50268,70,NULL,NULL,'2MASX J13550878+0008379',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000093,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,208.786667,0.14381,0.061,NULL,58410807938,912668874,14260451,16.7),(114911,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114911,37.21,0.46,277,50269,70,NULL,NULL,'2MASX J13550898+4007077',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000172,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,208.787333,40.11889,0,NULL,59271766802,926121356,14470646,16.8),(114912,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114912,36.42,0.46,192,50270,70,NULL,NULL,'2MASX J13550932+3559417',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000174,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,208.788833,35.99508,0,NULL,59152650437,924260163,14441565,16.3),(114913,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114913,36.11,0.46,167,50271,70,NULL,NULL,'2MASX J13551020+5817501',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000187,NULL,'15.5g',0.42,'E0',NULL,NULL,NULL,NULL,1,208.792375,58.29739,0.005,NULL,57296419242,895256550,13988383,15.5),(114914,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114914,37.07,0.46,260,50272,70,NULL,NULL,'2MASX J13551124+5831031',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000187,NULL,'16.0g',0.42,'E0',NULL,NULL,NULL,NULL,1,208.796667,58.51772,0,NULL,57266062265,894782222,13980972,16),(114915,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114915,35.59,0.46,131,50273,70,NULL,NULL,'CGCG 074-005 NED01',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000173,NULL,'15.49',0.37,NULL,NULL,NULL,NULL,NULL,1,208.796958333,10.02197,0.054,NULL,58464869869,913513591,14273649,15.49),(114916,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114916,36.4,0.27,190,50274,70,NULL,NULL,'2MASX J13551133+1436085',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000186,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,208.7972917,14.60228,0,NULL,58371039751,912047496,14250742,16.3),(114917,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114917,37.26,0.11,283,50275,70,NULL,NULL,'2MASX J13551211+4620006',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000218,NULL,'16.0g',0.42,'E0',NULL,NULL,NULL,NULL,1,208.800333,46.33358,0,NULL,59240429413,925631709,14462995,16),(114918,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114918,36.36,0.61,187,50276,70,NULL,NULL,'ESO 384- G 011',NULL,'2014MNRAS.445.2677S',2014,1,1,'RC3 gives V = 14380 +- 60 km/sec.','G',0.000033,NULL,'15.03',0.7,'S?',NULL,NULL,NULL,NULL,1,208.8022083,-36.31828,0.237,NULL,46892069778,732688590,11448259,15.03),(114919,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114919,35.9,0.41,151,50276,NULL,NULL,'Malmquist cor.','ESO 384- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114920,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114920,36.12,0.37,168,50276,NULL,NULL,NULL,'ESO 384- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114921,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114921,36.16,0.2,171,50276,74.4,NULL,NULL,'ESO 384- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114922,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114922,35.3,0.25,115,50277,74.4,NULL,NULL,'IC 4344',NULL,'2013AJ....146...86T',2013,1,0.95,NULL,'G',0.00008,NULL,'14.6g',0.7,'SB             AGN','Group member',NULL,NULL,NULL,1,208.8024583,25.02144,0,NULL,59999248173,937488252,14648253,14.6),(114923,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114923,35.5,0.17,126,50277,70,NULL,NULL,'IC 4344',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114924,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114924,37.73,0.46,351,50278,70,NULL,NULL,'2MASX J13551316+2610405',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.53',0.13,NULL,NULL,NULL,NULL,NULL,1,208.8050417,26.17806,0,NULL,59998592328,937478005,14648093,18.53),(114925,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114925,35.3,0.25,115,50279,74.4,NULL,NULL,'IC 4345',NULL,'2013AJ....146...86T',2013,1,0.98,NULL,'G',0.000107,NULL,'14.0g',0.93,'E/S0','Group member',NULL,NULL,NULL,1,208.805791667,25.05181,0,NULL,59999244785,937488199,14648253,14),(114926,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114926,35.5,0.17,126,50279,70,NULL,NULL,'IC 4345',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114927,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114927,35.67,0.16,136,50279,70,NULL,NULL,'IC 4345',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114928,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114928,37.2,0.21,275,50280,70,NULL,NULL,'2MASX J13551530+2028466',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,208.813667,20.47969,0.043,NULL,58332099066,911439047,14241235,17.4),(114929,'Ring Diameter','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114929,32.7,0.84,34,50281,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5376',NULL,'1981ApJS...45..541P',1981,1,1.74,NULL,'G',0.000003,NULL,'12.9g',0.9,'SAB(r)b?','in a radial-velocity based grouping',NULL,NULL,NULL,1,208.8169583,59.50661,0,NULL,57273905660,894904775,13982887,12.9),(114930,'Sosies','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114930,33.72,0.15,55.5,50281,NULL,NULL,NULL,'NGC 5376',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114931,'Tully est','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114931,32.63,0.8,33.6,50281,75,NULL,'B','NGC 5376',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114932,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114932,32.63,0.43,33.6,50281,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5376',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114933,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114933,32.69,0.43,34.6,50281,75,NULL,'3.6 micron, color corrected','NGC 5376',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114934,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114934,32.82,0.2,36.6,50281,74.4,NULL,NULL,'NGC 5376',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114935,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114935,36.24,0.55,177,50282,70,NULL,NULL,'2MASX J13551657-5025389',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,208.819,-50.42753,1.009,NULL,46821218596,731581540,11430961,17),(114936,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114936,37.25,0.27,281,50283,70,NULL,NULL,'2MASX J13551803+5402151',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000165,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,208.825083,54.03769,0,NULL,57285279486,895082491,13985663,17),(114937,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114937,36.91,0.46,241,50284,70,NULL,NULL,'2MASX J13551816+3410148',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00018,NULL,'16.0g',0.31,NULL,NULL,NULL,NULL,NULL,1,208.82575,34.17089,0,NULL,59151639040,924244360,14441318,16),(114938,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114938,37.79,0.46,362,50285,70,NULL,NULL,'2MASX J13551844+2124086',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,208.82675,21.40244,0.011,NULL,58319732197,911245815,14238215,17.2),(114939,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114939,37.85,0.33,372,50286,70,NULL,NULL,'2MASX J13551953+3525428',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000157,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,208.8314583,35.42856,0,NULL,59152566436,924258850,14441544,17.3),(114940,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114940,37.53,0.19,321,50287,70,NULL,NULL,'2MASX J13551957+2645535',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000182,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,208.831625,26.76481,0.006,NULL,59998042886,937469420,14647959,17.2),(114941,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114941,37.74,0.46,354,50288,70,NULL,NULL,'2MASX J13551971+2346566',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,208.8322917,23.78231,0,NULL,59462115191,929095549,14517117,17.8),(114942,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114942,37.53,0.19,321,50289,70,NULL,NULL,'2MASX J13552046+2649435',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,208.835458333,26.82883,0.006,NULL,59998040353,937469380,14647959,17.9),(114943,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114943,37.53,0.19,321,50290,70,NULL,NULL,'2MASX J13552135+2641315',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000158,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,208.839167,26.69217,0.006,NULL,59998155885,937471185,14647987,18.1),(114944,'IRAS','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114944,32.16,0.8,27,50291,75,NULL,'MAT, I','ESO 271- G 004',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'14.59',0.6,'SB(s)dm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,208.842625,-44.47839,0.337,NULL,46917772916,733090201,11454534,14.59),(114945,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114945,30.85,0.32,14.8,50291,85,NULL,'I, inv','ESO 271- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114946,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114946,30.89,0.32,15.1,50291,85,NULL,'I, raw','ESO 271- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114947,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114947,31.22,0.43,17.5,50291,75,NULL,'MAT, I, inv','ESO 271- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114948,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114948,31.3,0.43,18.2,50291,75,NULL,'MAT, I, raw','ESO 271- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114949,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114949,31.67,0.43,21.5,50291,75,NULL,'MAT, I, cor','ESO 271- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114950,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114950,32.44,0.49,30.7,50291,75,NULL,'IR','ESO 271- G 004',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114951,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114951,37.12,0.33,266,50292,70,NULL,NULL,'2MASX J13552295+2328110',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.51',0.15,NULL,NULL,NULL,NULL,NULL,1,208.845625,23.46986,0,NULL,59462420700,929100323,14517192,18.51),(114952,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114952,37.2,0.21,275,50293,70,NULL,NULL,'2MASX J13552314+2025010',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.98',0.18,NULL,NULL,NULL,NULL,NULL,1,208.846417,20.41714,0.043,NULL,58332095696,911438995,14241234,17.98),(114953,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114953,38.63,0.46,531,50294,70,NULL,NULL,'SDSS J135524.15+074630.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,208.850667,7.77506,0,NULL,58459859136,913435299,14272426,18.5),(114954,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114954,31.73,0.4,22.2,50295,75,NULL,'B','UGC 08839',NULL,'1988NBGC.C....0000T',1988,1,4,NULL,'G',0.000008,NULL,'13.6',2.7,'Im',NULL,NULL,NULL,NULL,1,208.854,17.79494,0.008,NULL,58373276181,912082440,14251288,13.6),(114955,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114955,37,0.46,251,50296,70,NULL,NULL,'2MASX J13552492+3735536',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000182,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,208.85375,37.59814,0,NULL,59155367138,924302611,14442228,16.6),(114956,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114956,37.53,0.19,321,50297,70,NULL,NULL,'MCG +05-33-019',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'15.6g',0.48,NULL,NULL,NULL,NULL,NULL,1,208.853875,26.79408,0.006,NULL,59998040730,937469386,14647959,15.6),(114957,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114957,37.41,0.46,303,50298,70,NULL,NULL,'2MASX J13552611+1847510',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.31',0.16,NULL,NULL,NULL,NULL,NULL,1,208.85875,18.79739,0.043,NULL,58329002491,911390663,14240479,18.31),(114958,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114958,37.85,0.33,372,50299,70,NULL,NULL,'2MASX J13552621+3525443',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000154,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,208.859167,35.42892,0,NULL,59152577999,924259031,14441547,17),(114959,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114959,37.11,0.46,264,50300,70,NULL,NULL,'2MASX J13552785+2506555',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000153,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,208.865917,25.11544,0,NULL,59999080908,937485639,14648213,16.9),(114960,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114960,37.72,0.19,351,50301,70,NULL,NULL,'SDSS J135528.70+193432.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,208.869625,19.57567,0.051,NULL,58328626400,911384787,14240387,18.1),(114961,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114961,37.34,0.46,294,50302,70,NULL,NULL,'2MASX J13552908+2101350',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,208.871167,21.02653,0.031,NULL,58331258513,911425914,14241029,17.2),(114962,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114962,35.65,0.47,135,50303,NULL,NULL,'H','UGC 08842 NED02',NULL,'2007A&A...465...71T',2007,1,1.58,'Component \'b)\' in UGC notes.','G',0.00016,NULL,'15.93',0.37,'Sc             PAS','Compact group member',NULL,NULL,NULL,1,208.874,25.07367,0,NULL,59999109142,937486080,14648220,15.93),(114963,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114963,35.71,0.4,139,50303,NULL,NULL,'mean','UGC 08842 NED02',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114964,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114964,35.75,0.45,141,50303,NULL,NULL,'K','UGC 08842 NED02',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114965,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114965,37.77,0.46,359,50304,70,NULL,NULL,'2MASXi J1355299+401229',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,208.875041667,40.20825,0,NULL,59271693343,926120208,14470628,17.7),(114966,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114966,36.34,0.46,186,50305,70,NULL,NULL,'2MASX J13553328+5439341',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000173,NULL,'16.2g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,208.888625,54.65956,0,NULL,57285372595,895083946,13985686,16.2),(114967,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114967,37.47,0.46,311,50306,70,NULL,NULL,'2MASX J13553359+1722209',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.46',0.16,NULL,NULL,NULL,NULL,NULL,1,208.8900417,17.37264,0.014,NULL,58381396658,912209322,14253270,18.46),(114968,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114968,36.4,0.27,190,50307,70,NULL,NULL,'CGCG 103-008',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000093,NULL,'15.7',0.6,NULL,NULL,NULL,NULL,NULL,1,208.890541667,14.76464,0,NULL,58371062696,912047854,14250747,15.7),(114969,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114969,36.44,0.46,194,50308,70,NULL,NULL,'2MASX J13553422+2309020',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.42',0.2,NULL,NULL,NULL,NULL,NULL,1,208.8927083,23.15047,0,NULL,59462492669,929101447,14517210,17.42),(114970,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114970,30.55,0.2,12.9,50309,74.4,NULL,NULL,'NGC 5379',NULL,'2013AJ....146...86T',2013,1,1.88,NULL,'G',0.000017,NULL,'13.9g',0.61,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,208.893,59.74281,0,NULL,57276723698,894948807,13983575,13.9),(114971,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114971,30.95,0.45,15.5,50309,NULL,NULL,'K','NGC 5379',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114972,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114972,32.26,0.4,28.3,50309,NULL,NULL,'mean','NGC 5379',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114973,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114973,35.29,0.25,114,50310,74.4,NULL,NULL,'CGCG 132-048',NULL,'2013AJ....146...86T',2013,1,0.59,NULL,'G',0.00009,NULL,'15.4g',0.38,'SBb','Group member',NULL,NULL,NULL,1,208.8932917,25.04978,0,NULL,59999101867,937485966,14648218,15.4),(114974,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114974,35.5,0.17,126,50310,70,NULL,NULL,'CGCG 132-048',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114975,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114975,38.89,0.46,600,50311,70,NULL,NULL,'2MASX J13553562+2210060',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.36',0.15,NULL,NULL,NULL,NULL,NULL,1,208.89825,22.16817,0,NULL,59460538521,929070914,14516733,18.36),(114976,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114976,36.49,0.46,198,50312,70,NULL,NULL,'2MASX J13553600+0635374',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000163,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,208.900083333,6.59367,0.023,NULL,58456236192,913378690,14271542,16.6),(114977,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114977,37.2,0.21,275,50313,70,NULL,NULL,'2MASX J13553609+2011570',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,208.9002917,20.19928,0.048,NULL,58331861723,911435339,14241177,17.7),(114978,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114978,38.24,0.46,445,50314,70,NULL,NULL,'SDSS J135537.04+035949.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000159,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,208.904333,3.99697,0.063,NULL,58407365252,912615082,14259610,18.5),(114979,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114979,37.14,0.46,268,50315,70,NULL,NULL,'SDSS J135537.61+500624.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000139,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,208.9067083,50.10672,0,NULL,59219604521,925306320,14457911,18),(114980,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114980,37.83,0.33,368,50316,70,NULL,NULL,'2MASX J13553774+4333387',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000157,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,208.90725,43.56089,0,NULL,59264207086,926003235,14468800,17.1),(114981,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114981,37.84,0.46,370,50317,70,NULL,NULL,'2MASX J13553819+4938051',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000139,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,208.909167,49.63492,0,NULL,59212247339,925191364,14456115,17.7),(114982,'Tully est','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114982,31.8,0.8,22.9,50318,75,NULL,'B','NGC 5360',NULL,'1988NBGC.C....0000T',1988,1,2.2,'Identification as IC 0958 is not certain.','G',0.00003,NULL,'14.1B',0.8,'I0','in a pair',NULL,NULL,NULL,1,208.9114583,4.98506,0.061,NULL,58435668768,913057324,14266520,14.1),(114983,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114983,31.66,NULL,21.5,50318,72,NULL,NULL,'NGC 5360',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114984,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114984,37.59,0.46,330,50319,70,NULL,NULL,'2MASX J13553903+6339266',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000154,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,208.912833333,63.65742,0.029,NULL,57932621198,905197206,14143706,17.3),(114985,'Sosies','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114985,32.57,0.36,32.7,50320,NULL,NULL,NULL,'NGC 5371',NULL,'2002A&A...393...57T',2002,1,4.4,'Identification as NGC 5390 is not certain.','G',0.00001,NULL,'11.32',3.5,'SAB(rs)bc;Sy?  LINER','in a radial-velocity based grouping',NULL,NULL,'Sy ?',1,208.916416667,40.46175,0,NULL,59271117469,926111210,14470487,11.32),(114986,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114986,31.8,0.45,23,50320,NULL,NULL,'K','NGC 5371',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114987,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114987,31.82,0.47,23.1,50320,NULL,NULL,'H','NGC 5371',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114988,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114988,31.85,0.46,23.4,50320,NULL,NULL,'J','NGC 5371',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114989,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114989,32.39,NULL,30.1,50320,NULL,NULL,'LEDA [April 2006]','NGC 5371',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114990,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114990,32.84,0.4,36.9,50320,NULL,NULL,'mean','NGC 5371',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114991,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114991,32.89,0.4,37.8,50320,75,NULL,'B','NGC 5371',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114992,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114992,38.28,0.46,454,50321,70,NULL,NULL,'2MASX J13554045+3052363',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,208.91875,30.87683,0,NULL,59127713177,923870518,14435476,17.7),(114993,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114993,37.11,0.46,264,50322,70,NULL,NULL,'2MASX J13554159+0251529',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000071,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,208.9234583,2.86475,0.049,NULL,58414121461,912720647,14261260,17.3),(114994,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114994,37.7,0.46,346,50323,70,NULL,NULL,'2MASX J13554172+0530529',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000168,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,208.923917,5.51464,0.038,NULL,58435229024,913050453,14266413,16.6),(114995,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114995,31.89,0.25,23.9,50324,74.4,NULL,NULL,'ESO 384- G 013',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000063,NULL,'13.94',1.1,'SA(r)0^0^?',NULL,NULL,NULL,NULL,1,208.924041667,-33.72486,0.209,NULL,46883625944,732556655,11446197,13.94),(114996,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114996,33.28,0.45,45.3,50324,NULL,NULL,'K','ESO 384- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114997,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114997,33.68,0.4,54.4,50324,NULL,NULL,'mean','ESO 384- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114998,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114998,38.56,0.33,516,50325,70,NULL,NULL,'LCRS B135307.7-021933',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000146,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,208.9285417,-2.56994,0.113,NULL,43592551229,681133612,10642712,18.5),(114999,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114999,37.83,0.33,368,50326,70,NULL,NULL,'2MASX J13554409+4333257',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000148,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,208.9337917,43.55722,0,NULL,59264218154,926003408,14468803,17.4),(115000,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115000,34.81,0.46,91.7,50327,70,NULL,NULL,'CGCG 103-011',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00018,NULL,'16.57',0.36,NULL,NULL,NULL,NULL,NULL,1,208.934708333,15.06131,0,NULL,58370685084,912041954,14250655,16.57),(115001,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115001,36.11,0.46,167,50328,70,NULL,NULL,'IC 4348',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.00009,NULL,'15.0g',0.61,NULL,'Group member',NULL,NULL,NULL,1,208.937875,25.20311,0,NULL,59999118425,937486225,14648222,15),(115002,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115002,37.38,0.46,300,50329,70,NULL,NULL,'2MASX J13554515+1922150',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.23',0.19,NULL,NULL,NULL,NULL,NULL,1,208.938167,19.37092,0.09,NULL,58328655989,911385249,14240394,18.23),(115003,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115003,37.08,0.27,261,50330,70,NULL,NULL,'2MASX J13554535+1910480',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.13',0.17,NULL,NULL,NULL,NULL,NULL,1,208.9390417,19.17994,0.09,NULL,58328873304,911388645,14240447,18.13),(115004,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115004,37.68,0.33,343,50331,70,NULL,NULL,'2MASX J13554581+2126480',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.61',0.13,NULL,NULL,NULL,NULL,NULL,1,208.940917,21.44683,0.03,NULL,59459542020,929055344,14516489,18.61),(115005,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115005,37.7,0.46,347,50332,70,NULL,NULL,'2MASX J13554613+5540312',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000151,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,208.942125,55.67519,0,NULL,57300572009,895321437,13989397,17.2),(115006,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115006,36.23,0.33,177,50333,70,NULL,NULL,'2MASX J13554769+1422309',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00017,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,208.94875,14.37531,0,NULL,58370379314,912037176,14250580,17.2),(115007,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,115007,35.5,0.17,126,50334,70,NULL,NULL,'GIN 331',NULL,'2001MNRAS.321..277C',2001,1,0.3,NULL,'G',0.000178,NULL,'14.92',0.25,'S',NULL,NULL,NULL,NULL,1,208.951333,24.80528,0,NULL,59999012200,937484565,14648196,14.92),(115008,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115008,36.84,0.33,233,50334,70,NULL,NULL,'GIN 331',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115009,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115009,38.1,0.46,417,50335,70,NULL,NULL,'2MASX J13555001+2040398',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,208.9585,20.67753,0.042,NULL,58331392643,911428010,14241062,17.8),(115010,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115010,37.68,0.33,343,50336,70,NULL,NULL,'2MASX J13555018+2126520',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,208.959167,21.44794,0.03,NULL,59459540467,929055319,14516489,17.7),(115011,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115011,36.97,0.46,247,50337,70,NULL,NULL,'2MASX J13555092+2508340',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000149,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,208.962083,25.14272,0,NULL,59999124533,937486320,14648223,17.2),(115012,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115012,37.23,0.33,279,50338,70,NULL,NULL,'LCRS B135316.6-030647',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.0001,NULL,'16.1g',0.4,'E0',NULL,NULL,NULL,NULL,1,208.9675,-3.35717,0.081,NULL,43597903518,681217242,10644019,16.1),(115013,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115013,36.23,0.33,177,50339,70,NULL,NULL,'2MASX J13555260+1422427',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000191,NULL,'17.08',0.28,NULL,NULL,NULL,NULL,NULL,1,208.969333,14.37844,0,NULL,58370378917,912037170,14250580,17.08),(115014,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115014,36.55,0.46,204,50340,70,NULL,NULL,'2MASX J13555338+2341208',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,208.9725,23.68917,0,NULL,59462064325,929094755,14517105,17.2),(115015,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115015,34.53,0.46,80.7,50341,70,NULL,NULL,'UGC 08854',NULL,'2015arXiv151105856S',2015,1,1.04,NULL,'G',0.000087,NULL,'14.2g',0.65,'S0',NULL,NULL,NULL,NULL,1,208.972666667,37.19658,0,NULL,59154696881,924292138,14442064,14.2),(115016,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115016,37.84,0.46,369,50342,70,NULL,NULL,'2MASX J13555410+2348408',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,208.97525,23.81122,0,NULL,59462119106,929095611,14517118,17.1),(115017,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115017,39.17,0.46,684,50343,70,NULL,NULL,'SDSS J135554.61+303520.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,208.977583,30.58917,0,NULL,59127863235,923872863,14435513,18.4),(115018,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115018,38.56,0.33,516,50344,70,NULL,NULL,'LCRS B135319.7-022945',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,208.979167,-2.73986,0.077,NULL,43600017675,681250276,10644535,18),(115019,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115019,37.32,0.46,291,50345,70,NULL,NULL,'2MASX J13555523+2227318',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.93',0.2,NULL,NULL,NULL,NULL,NULL,1,208.980167,22.45883,0,NULL,59460340330,929067817,14516684,17.93),(115020,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115020,37.72,0.27,350,50346,70,NULL,NULL,'2MASX J13555531+0713448',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000216,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,208.980625,7.22903,0,NULL,58456359627,913380619,14271572,16.4),(115021,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115021,38.25,0.46,446,50347,70,NULL,NULL,'SDSS J135556.15+634348.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000089,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,208.984,63.73011,0.029,NULL,57932611957,905197061,14143704,18.2),(115022,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,115022,35.29,0.25,114,50348,74.4,NULL,NULL,'GIN 332',NULL,'2013AJ....146...86T',2013,1,0.51,NULL,'G',0.000154,NULL,'15.8g',0.45,'S',NULL,NULL,NULL,NULL,1,208.984,24.95106,0,NULL,59999094945,937485858,14648216,15.8),(115023,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,115023,35.5,0.17,126,50348,70,NULL,NULL,'GIN 332',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115024,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115024,31.75,NULL,22.4,50349,72,NULL,NULL,'LSBC D721-10',NULL,'2014Ap.....57..457K',2014,1,0.8,NULL,'G',0.000075,NULL,NULL,NULL,'dI',NULL,NULL,NULL,NULL,1,208.98625,9.01417,0.034,NULL,58457982015,913405968,14271968,NULL),(115025,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115025,37.72,0.27,350,50350,70,NULL,NULL,'2MASX J13555760+0713238',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,208.9900417,7.22336,0,NULL,58456359908,913380623,14271572,17.2),(115026,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115026,38.43,0.46,484,50351,70,NULL,NULL,'2MASX J13555776+0848008',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000183,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,208.990667,8.80014,0.03,NULL,58458013310,913406457,14271975,17.4),(115027,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115027,37.72,0.27,350,50352,70,NULL,NULL,'SDSS J135558.25+071556.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,208.99275,7.26572,0,NULL,58456360706,913380636,14271572,18.1),(115028,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115028,38.06,0.46,409,50353,70,NULL,NULL,'2MASX J13555948+3513063',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,208.9977917,35.21842,0,NULL,59150748452,924230444,14441100,18.3),(115029,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115029,34.52,0.2,80.2,50354,74.4,NULL,NULL,'UGC 08844',NULL,'2013AJ....146...86T',2013,1,1.27,NULL,'G',0.000017,NULL,'14.7g',0.56,'SB(s)bc:',NULL,NULL,NULL,NULL,1,208.997917,-1.26172,0.193,NULL,43595167379,681174490,10643351,14.7),(115030,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115030,34.71,0.41,87.6,50354,NULL,NULL,NULL,'UGC 08844',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115031,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115031,34.88,0.38,94.8,50354,NULL,NULL,'Malmquist cor.','UGC 08844',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115032,'D-Sigma','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115032,33.45,0.4,48.9,50355,75,NULL,'Edat, raw','NGC 5357',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000014,NULL,'12.96',1.3,'E        poss. LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,208.998125,-30.34144,0.177,NULL,46850675870,732041810,11438153,12.96),(115033,'D-Sigma','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115033,33.7,0.4,54.9,50355,75,NULL,'Edat, cor','NGC 5357',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115034,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115034,33.24,0.25,44.5,50355,74.4,NULL,NULL,'NGC 5357',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115035,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115035,33.53,0.46,50.9,50355,70,NULL,NULL,'NGC 5357',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115036,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115036,33.69,0.45,54.6,50355,NULL,NULL,'K','NGC 5357',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115037,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115037,34.06,0.4,65,50355,NULL,NULL,'mean','NGC 5357',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115038,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115038,37.08,0.27,261,50356,70,NULL,NULL,'SDSS J135600.20+190657.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.000875,19.11586,0.054,NULL,58328869770,911388590,14240446,18.4),(115039,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115039,37.25,0.15,282,50357,70,NULL,NULL,'2MASX J13560061+2258478',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.04',0.17,NULL,NULL,NULL,NULL,NULL,1,209.002625,22.97992,0,NULL,59462511507,929101742,14517214,18.04),(115040,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115040,37.08,0.27,261,50358,70,NULL,NULL,'2MASX J13560174+1907078',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.32',0.17,NULL,NULL,NULL,NULL,NULL,1,209.007167,19.11881,0.054,NULL,58328869295,911388582,14240446,18.32),(115041,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115041,35.5,0.17,126,50359,70,NULL,NULL,'GIN 334',NULL,'2001MNRAS.321..277C',2001,1,0.31,NULL,'G',0.000157,NULL,'14.68',0.24,'E',NULL,NULL,NULL,NULL,1,209.008083333,24.67542,0,NULL,59996936961,937452140,14647689,14.68),(115042,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115042,36.84,0.33,233,50359,70,NULL,NULL,'GIN 334',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115043,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115043,37.12,0.33,266,50360,70,NULL,NULL,'2MASX J13560285+2329348',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.05',0.17,NULL,NULL,NULL,NULL,NULL,1,209.011917,23.49311,0,NULL,59462548292,929102317,14517223,18.05),(115044,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115044,36.85,0.76,235,50361,70,NULL,NULL,'2MASX J13560316-4334319',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,209.0132917,-43.57556,0.309,NULL,46919327035,733114484,11454913,15.4),(115045,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115045,34,0.69,63,50362,100,NULL,'mid-IR','IC 0959',NULL,'2013ApJ...771...88L',2013,1,1.7,NULL,'G',0.000033,NULL,'13.83',1,'Sa','Group member of poor cluster',NULL,NULL,NULL,1,209.014167,13.50583,0,NULL,58342300280,911598441,14243725,13.83),(115046,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115046,34.89,0.47,95,50362,NULL,NULL,'H','IC 0959',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115047,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115047,34.92,0.47,96.4,50362,NULL,NULL,'Malmquist cor.','IC 0959',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115048,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115048,34.93,0.45,96.6,50362,NULL,NULL,'K','IC 0959',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115049,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115049,35,0.46,99.9,50362,NULL,NULL,'J','IC 0959',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115050,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115050,35.02,0.4,101,50362,NULL,NULL,'mean','IC 0959',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115051,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115051,35.39,0.38,120,50362,NULL,NULL,NULL,'IC 0959',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115052,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115052,35.43,0.2,122,50362,74.4,NULL,NULL,'IC 0959',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115053,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115053,37.3,0.46,289,50363,70,NULL,NULL,'SDSS J135603.52+194752.6',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,209.014708333,19.79794,0.06,NULL,58327353772,911364902,14240076,NULL),(115054,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115054,37.8,0.46,363,50364,70,NULL,NULL,'2MASX J13560446+6156135',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000175,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,209.018917,61.93728,0.013,NULL,57261375543,894708992,13979828,17.7),(115055,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115055,38.83,0.46,583,50365,70,NULL,NULL,'SDSS J135606.29+143006.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000164,NULL,'18.5g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.02625,14.50172,0,NULL,58370856144,912044627,14250697,18.5),(115056,'Tully est','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115056,31.75,0.8,22.4,50366,75,NULL,'B','NGC 5363',NULL,'1988NBGC.C....0000T',1988,1,4.1,NULL,'G',0.000017,NULL,'11.05',2.6,'I0?            LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,209.0300417,5.25478,0.038,NULL,58406077204,912594956,14259296,11.05),(115057,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115057,31.1,NULL,16.6,50366,72,NULL,NULL,'NGC 5363',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115058,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115058,35.96,0.76,155,50367,70,NULL,NULL,'2MASX J13560869-2718222',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,209.0362917,-27.30617,0.225,NULL,46991752464,734246132,11472595,15.8),(115059,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115059,37.32,0.46,291,50368,70,NULL,NULL,'2MASX J13560921+4341570',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000177,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,209.038417,43.69931,0,NULL,59263806022,925996969,14468702,16.7),(115060,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115060,35.29,0.25,114,50369,74.4,NULL,NULL,'CGCG 132-055',NULL,'2013AJ....146...86T',2013,1,0.66,NULL,'G',0.000057,NULL,'15.4g',0.54,'E/S0','Group member',NULL,NULL,NULL,1,209.0387917,25.19544,0,NULL,59999121662,937486275,14648223,15.4),(115061,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115061,35.5,0.17,126,50369,70,NULL,NULL,'CGCG 132-055',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115062,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115062,35.67,0.16,136,50369,70,NULL,NULL,'CGCG 132-055',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115063,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115063,30.89,NULL,15.1,50370,72,NULL,NULL,'SDSS J135609.35+053233.2',NULL,'2014Ap.....57..457K',2014,1,NULL,NULL,'G',0.000023,NULL,'17.2g',NULL,NULL,NULL,NULL,NULL,NULL,1,209.039,5.54258,0.032,NULL,58435202649,913050041,14266406,17.2),(115064,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115064,37.5,0.46,317,50371,70,NULL,NULL,'2MASX J13560939+2026078',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,209.039083333,20.43556,0.04,NULL,58327106662,911361041,14240016,NULL),(115065,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115065,34.8,0.57,91.4,50372,NULL,NULL,NULL,'ESO 510- G 019',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.96',0.4,'Sb             HII',NULL,NULL,NULL,NULL,1,209.044083,-23.77139,0.205,NULL,46510227492,726722304,11355036,14.96),(115066,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115066,34.81,0.56,91.8,50372,NULL,NULL,'Malmquist cor.','ESO 510- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115067,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115067,34.84,0.2,92.9,50372,74.4,NULL,NULL,'ESO 510- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115068,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115068,35.9,0.2,151,50373,74.4,NULL,NULL,'UGC 08855',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000033,NULL,'15.3g',0.26,'S?',NULL,NULL,NULL,NULL,1,209.044208333,24.49383,0,NULL,59996956676,937452448,14647694,15.3),(115069,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115069,36.85,0.46,234,50374,70,NULL,NULL,'2MASX J13561082+1351187',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000178,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,209.0452083,13.85525,0,NULL,58370304410,912036006,14250562,16.6),(115070,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115070,37.79,0.33,361,50375,70,NULL,NULL,'2MASX J13561093+0539538',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000168,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,209.0455417,5.66489,0.032,NULL,58435191101,913049860,14266404,18),(115071,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115071,36.48,0.46,198,50376,70,NULL,NULL,'2MASX J13561182+3414333',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000184,NULL,'15.9g',0.45,NULL,NULL,NULL,NULL,NULL,1,209.049083,34.24264,0,NULL,59151667791,924244809,14441325,15.9),(115072,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115072,37.67,0.46,341,50377,70,NULL,NULL,'2MASX J13561190+1522247',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.31',0.17,NULL,NULL,NULL,NULL,NULL,1,209.04975,15.37344,0,NULL,58382074545,912219914,14253436,18.31),(115073,'Sosies','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115073,31.05,0.22,16.2,50378,NULL,NULL,NULL,'NGC 5364',NULL,'2002A&A...393...57T',2002,1,6.8,'NGC 5348 may also contribute to the HIPASS detection.','G',0.000013,NULL,'11.17',4.4,'SA(rs)bc pec   HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,209.05,5.01447,0.061,NULL,58406103063,912595360,14259302,11.17),(115074,'Tully est','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115074,32.03,0.8,25.5,50378,75,NULL,'B','NGC 5364',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115075,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115075,31.23,0.46,17.6,50378,NULL,NULL,'J','NGC 5364',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115076,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115076,31.24,NULL,17.7,50378,NULL,NULL,'B','NGC 5364',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115077,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115077,31.29,0.47,18.1,50378,NULL,NULL,'H','NGC 5364',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115078,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115078,31.3,0.45,18.2,50378,NULL,NULL,'K','NGC 5364',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115079,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115079,31.45,NULL,19.5,50378,72,NULL,NULL,'NGC 5364',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115080,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115080,31.55,NULL,20.4,50378,NULL,NULL,'LEDA [April 2006]','NGC 5364',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115081,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115081,31.63,0.3,21.2,50378,55,NULL,'B','NGC 5364',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115082,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115082,31.67,0.4,21.6,50378,NULL,NULL,'mean','NGC 5364',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115083,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115083,36.97,0.46,248,50379,70,NULL,NULL,'2MASX J13561238+3459533',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,209.051667,34.99828,0,NULL,59150913120,924233017,14441140,17.6),(115084,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115084,37.33,0.46,292,50380,70,NULL,NULL,'2MASX J13561442+5543230',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000143,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,209.0602083,55.72303,0,NULL,57300580481,895321570,13989399,16.9),(115085,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115085,38.48,0.33,497,50381,70,NULL,NULL,'2MASX J13561446+5302201',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,209.060375,53.039,0,NULL,59219107204,925298550,14457789,17.7),(115086,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115086,37.25,0.15,282,50382,70,NULL,NULL,'2MASX J13561532+2304508',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.59',0.2,NULL,NULL,NULL,NULL,NULL,1,209.063917,23.08072,0,NULL,59462480264,929101254,14517207,17.59),(115087,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115087,37.75,0.46,354,50383,70,NULL,NULL,'2MASX J13561550+2234138',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,209.06475,22.57039,0,NULL,59460345345,929067896,14516685,17.4),(115088,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115088,37.25,0.15,282,50384,70,NULL,NULL,'2MASX J13561590+2304308',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,209.0664583,23.07508,0,NULL,59462478411,929101225,14517206,17.5),(115089,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115089,38.1,0.46,417,50385,70,NULL,NULL,'2MASX J13561594+4751420',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000186,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,209.066625,47.86169,0,NULL,59243790222,925684222,14463815,17.4),(115090,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115090,36.95,0.46,246,50386,70,NULL,NULL,'2MASX J13561598+2206338',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.23',0.15,NULL,NULL,NULL,NULL,NULL,1,209.066667,22.10953,0,NULL,59460499763,929070308,14516723,18.23),(115091,'SNII optical','2016-12-15 15:15:20','2016-12-16 11:20:32','1','SN 1992H',NULL,115091,31.53,0.74,20.2,50387,NULL,NULL,'EPM','NGC 5377',NULL,'1996AJ....111.1286C',1996,1,3.92,NULL,'G',0.00002,NULL,'12.5g',0.98,'(R)SB(s)a      AGN','Isolated galaxy',NULL,NULL,NULL,1,209.0694583,47.23569,0.006,NULL,59241164394,925643193,14463174,12.5),(115092,'SNII optical','2016-12-15 15:15:20','2016-12-16 11:20:32','1','SN 1992H',NULL,115092,32.46,0.25,31,50387,NULL,NULL,NULL,'NGC 5377',NULL,'1994ApJ...432...42S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115093,'SNII optical','2016-12-15 15:15:20','2016-12-16 11:20:32','1','SN 1992H',NULL,115093,33.12,0.14,42.1,50387,NULL,NULL,'SCM','NGC 5377',NULL,'2015ApJ...799..215P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115094,'Tully est','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115094,32.46,0.8,31,50387,75,NULL,'B','NGC 5377',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115095,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115095,31.82,0.49,23.2,50387,NULL,NULL,'Malmquist cor.','NGC 5377',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115096,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115096,31.96,0.2,24.7,50387,74.4,NULL,NULL,'NGC 5377',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115097,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115097,32.03,0.43,25.5,50387,75,NULL,'3.6 micron, color corrected','NGC 5377',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115098,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115098,32.05,0.45,25.7,50387,NULL,NULL,NULL,'NGC 5377',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115099,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115099,32.09,0.47,26.2,50387,NULL,NULL,'H','NGC 5377',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115100,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115100,32.09,0.45,26.2,50387,NULL,NULL,'K','NGC 5377',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115101,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115101,32.11,0.46,26.4,50387,NULL,NULL,'J','NGC 5377',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115102,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115102,32.16,0.43,27.1,50387,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5377',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115103,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115103,32.2,0.3,27.5,50387,NULL,18.45,'SN 1992H host','NGC 5377',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115104,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115104,32.4,0.4,30.3,50387,NULL,NULL,'mean','NGC 5377',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115105,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115105,37.3,0.46,289,50388,70,NULL,NULL,'2MASX J13561707+1818408',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.071125,18.31119,0.017,NULL,58328214258,911378347,14240286,17.7),(115106,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115106,35.57,0.46,130,50389,70,NULL,NULL,'VV 158a',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000077,NULL,'14.9g',0.63,NULL,'Group member',NULL,NULL,NULL,1,209.080166667,28.53636,0,NULL,60005727303,937589489,14649835,14.9),(115107,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115107,38.36,0.46,469,50390,70,NULL,NULL,'2MASX J13561943+5742363',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,209.080875,57.70997,0.005,NULL,57296945037,895264766,13988511,18),(115108,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115108,37.26,0.46,283,50391,70,NULL,NULL,'2MASX J13562006+2110528',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000014,NULL,'17.54',0.21,NULL,NULL,NULL,NULL,NULL,1,209.083583,21.18122,0.031,NULL,58319700930,911245327,14238208,17.54),(115109,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115109,37.23,0.33,279,50392,70,NULL,NULL,'LCRS B135345.2-030542',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00014,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,209.0865,-3.33878,0.081,NULL,43597858460,681216538,10644008,16.7),(115110,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115110,35.7,0.46,138,50393,70,NULL,NULL,'2MASX J13562098+3825467',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000187,NULL,'15.9g',0.47,NULL,NULL,NULL,NULL,NULL,1,209.087333333,38.42964,0,NULL,59154593630,924290525,14442039,15.9),(115111,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115111,37.72,0.46,351,50394,70,NULL,NULL,'SDSS J135621.48+074851.4',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.089541667,7.81428,0,NULL,58459923098,913436298,14272442,18.2),(115112,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115112,37.62,0.46,335,50395,70,NULL,NULL,'2MASX J13562419+2152321',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.66',0.14,NULL,NULL,NULL,NULL,NULL,1,209.1007917,21.87572,0.011,NULL,59459700894,929057826,14516528,18.66),(115113,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115113,37.94,0.46,387,50396,70,NULL,NULL,'SDSS J135625.11+525540.5',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000134,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,209.104625,52.92794,0,NULL,59219060092,925297813,14457778,18),(115114,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115114,37.04,0.46,256,50397,70,NULL,NULL,'2MASX J13562715+2507485',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'17.32',0.23,NULL,NULL,NULL,NULL,NULL,1,209.113125,25.13017,0,NULL,59999113650,937486150,14648221,17.32),(115115,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115115,32.13,0.49,26.6,50398,75,NULL,'IR','ESO 384- G 015',NULL,'2011yCatp016004901K',2011,1,1.25,NULL,'G',0.00015,NULL,'15.69',0.17,'SBdm? sp',NULL,NULL,NULL,NULL,1,209.1159583,-33.06894,0.241,NULL,46880179708,732502807,11445356,15.69),(115116,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115116,37.81,0.46,365,50399,70,NULL,NULL,'2MASX J13562784+1420025',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,209.115917,14.33403,0,NULL,58370419764,912037808,14250590,18.1),(115117,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115117,32.85,0.43,37.1,50399,75,NULL,'3.6 micron, color + selection bias corrected','ESO 384- G 015',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115118,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115118,38.03,0.46,404,50400,70,NULL,NULL,'2MASX J13562861+3135472',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.51',0.17,NULL,NULL,NULL,NULL,NULL,1,209.119375,31.59642,0,NULL,59127190427,923862350,14435349,18.51),(115119,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115119,37.25,0.15,282,50401,70,NULL,NULL,'SDSS J135630.58+232146.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,209.1274583,23.36289,0,NULL,59462558350,929102474,14517226,18),(115120,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115120,39.03,0.46,641,50402,70,NULL,NULL,'2MASX J13563223+2203052',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,209.134291667,22.0515,0.009,NULL,59460466100,929069782,14516715,18.1),(115121,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115121,37.52,0.46,320,50403,70,NULL,NULL,'2MASX J13563232+3802336',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000093,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,209.134875,38.04275,0,NULL,59155248667,924300760,14442199,17.5),(115122,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115122,37.62,0.46,334,50404,70,NULL,NULL,'2MASX J13563270+4937110',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000198,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,209.136,49.61972,0,NULL,59212261689,925191588,14456118,16.7),(115123,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115123,37.36,0.46,297,50405,70,NULL,NULL,'SDSS J135633.22+310654.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'19.09',0.12,NULL,NULL,NULL,NULL,NULL,1,209.138458333,31.11528,0,NULL,59128016106,923875251,14435550,19.09),(115124,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115124,37.79,0.33,361,50406,70,NULL,NULL,'SDSS J135634.35+054029.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000142,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,209.143125,5.67486,0.032,NULL,58405701243,912589081,14259204,18.1),(115125,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115125,34.28,0.2,71.8,50407,74.4,NULL,NULL,'UGC 08861',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000013,NULL,'16.0g',0.5,'Sdm',NULL,NULL,NULL,NULL,1,209.144,10.19122,0.025,NULL,58462928660,913483260,14273175,16),(115126,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115126,37.43,0.46,306,50408,70,NULL,NULL,'2MASX J13563457+1316545',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00017,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,209.144167,13.28194,0,NULL,58339068069,911547938,14242936,16.8),(115127,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115127,35.91,0.55,152,50409,70,NULL,NULL,'LCRS B135353.9-121721',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00013,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,209.144458333,-12.53311,0.205,NULL,43663171953,682237061,10659954,16.8),(115128,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115128,37.2,0.21,275,50410,70,NULL,NULL,'2MASX J13563472+2028332',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.59',0.11,NULL,NULL,NULL,NULL,NULL,1,209.144833,20.47606,0.045,NULL,58327166707,911361979,14240030,18.59),(115129,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115129,33.75,0.47,56.2,50411,NULL,NULL,'H','ESO 445- G 081',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000033,NULL,'14.21',0.3,'Sbc: sp        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,209.145125,-32.62975,0.241,NULL,46896646879,732760107,11449376,14.21),(115130,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115130,33.76,0.46,56.5,50411,NULL,NULL,'J','ESO 445- G 081',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115131,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115131,33.77,0.45,56.6,50411,NULL,NULL,'K','ESO 445- G 081',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115132,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115132,33.9,0.4,60.2,50411,NULL,NULL,'mean','ESO 445- G 081',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115133,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115133,33.92,0.49,60.8,50411,75,NULL,'IR','ESO 445- G 081',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115134,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115134,34.2,0.12,69.3,50411,NULL,NULL,NULL,'ESO 445- G 081',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115135,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115135,34.78,0.43,90.5,50411,75,NULL,'3.6 micron, color corrected','ESO 445- G 081',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115136,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115136,34.82,0.43,92,50411,75,NULL,'3.6 micron, color + selection bias corrected','ESO 445- G 081',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115137,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115137,34.87,0.2,94.2,50411,74.4,NULL,NULL,'ESO 445- G 081',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115138,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115138,35.91,0.33,152,50412,70,NULL,NULL,'2MASX J13563554+4948460',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,209.148125,49.81269,0,NULL,59212279112,925191861,14456122,16.7),(115139,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115139,36.54,0.55,203,50413,70,NULL,NULL,'2MASX J13563714-2731191',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,209.1547083,-27.52197,0.225,NULL,46991769029,734246391,11472599,15.3),(115140,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115140,37.22,0.46,278,50414,70,NULL,NULL,'2MASX J13563717+3852516',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00016,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,209.154917,38.88106,0,NULL,59140790897,924074857,14438669,16.7),(115141,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115141,36.84,0.56,234,50415,70,NULL,NULL,'2MASX J13563729-4615571',NULL,'2014MNRAS.445.2677S',2014,1,0.11,NULL,'G',0.00015,NULL,'17.3b',NULL,'E?',NULL,NULL,NULL,NULL,1,209.1555,-46.26592,0.457,NULL,46796258884,731191545,11424867,17.3),(115142,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115142,37.97,0.46,392,50416,70,NULL,NULL,'2MASX J13563748+2159092',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.1562083,21.98586,0.009,NULL,59460453541,929069586,14516712,17.7),(115143,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115143,33.33,0.5,46.3,50417,70,NULL,NULL,'NGC 5369',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'14.38',0.7,'E0/S0-?',NULL,NULL,NULL,NULL,1,209.15675,-5.46989,0.061,NULL,43595778241,681184035,10643500,14.38),(115144,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115144,36.35,0.46,186,50418,70,NULL,NULL,'2MASX J13563780+1042498',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000178,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,209.157625,10.71381,0,NULL,58463433504,913491148,14273299,16.4),(115145,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115145,37.25,0.15,282,50419,70,NULL,NULL,'2MASX J13563841+2321512',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.5V',NULL,'AGN',NULL,NULL,NULL,NULL,1,209.159583,23.36417,0,NULL,59462561155,929102518,14517226,17.5),(115146,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115146,36.5,0.46,199,50420,70,NULL,NULL,'2MASX J13563884+2221372',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.16',0.25,NULL,NULL,NULL,NULL,NULL,1,209.1619583,22.3605,0,NULL,59460516030,929070562,14516727,17.16),(115147,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115147,35.38,0.55,119,50421,70,NULL,NULL,'2MASX J13563891-2709581',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.4b',NULL,'S0',NULL,NULL,NULL,NULL,1,209.162083,-27.16611,0.225,NULL,46991479064,734241860,11472529,16.4),(115148,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115148,32.36,0.46,29.7,50422,NULL,NULL,'J','NGC 5365A',NULL,'2007A&A...465...71T',2007,1,2.6,NULL,'G',0.000027,NULL,'13.58',0.5,'SAb: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,209.1647083,-44.00925,0.333,NULL,46919285822,733113840,11454903,13.58),(115149,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115149,32.36,0.47,29.7,50422,NULL,NULL,'H','NGC 5365A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115150,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115150,32.45,0.45,30.9,50422,NULL,NULL,'K','NGC 5365A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115151,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115151,32.53,0.49,32,50422,75,NULL,'IR','NGC 5365A',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115152,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115152,32.53,0.4,32.1,50422,75,NULL,NULL,'NGC 5365A',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115153,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115153,32.9,0.4,38,50422,NULL,NULL,'mean','NGC 5365A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115154,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115154,35.04,NULL,102,50423,NULL,NULL,NULL,'UGC 08862',NULL,'2000BSAO...50....5K',2000,1,1.06,NULL,'G',0.000017,NULL,'16.00',0.12,'Sc',NULL,NULL,NULL,NULL,1,209.16925,20.17156,0.01,NULL,58327983944,911374749,14240230,16),(115155,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115155,35.06,NULL,103,50423,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08862',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115156,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115156,35.09,NULL,104,50423,NULL,NULL,'Dipole + Quadrupole','UGC 08862',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115157,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115157,35.1,0.49,104,50423,75,NULL,'IR','UGC 08862',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115158,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115158,35.12,NULL,106,50423,NULL,NULL,'Dipole','UGC 08862',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115159,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115159,35.24,0.2,112,50423,74.4,NULL,NULL,'UGC 08862',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115160,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115160,36.27,0.46,180,50424,70,NULL,NULL,'2MASX J13564179+2203052',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.20',0.23,NULL,NULL,NULL,NULL,NULL,1,209.174208333,22.05147,0.009,NULL,59460468584,929069821,14516715,17.2),(115161,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115161,36.39,0.46,189,50425,70,NULL,NULL,'2MASX J13564209+1834372',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.07',0.24,NULL,NULL,NULL,NULL,NULL,1,209.175625,18.57708,0.042,NULL,58329096840,911392138,14240502,17.07),(115162,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115162,37.25,0.15,282,50426,70,NULL,NULL,'2MASX J13564247+2313192',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,209.177,23.22203,0,NULL,59462586011,929102906,14517232,17.3),(115163,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115163,38.16,0.46,428,50427,70,NULL,NULL,'2MASX J13564292+0711308',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,209.17875,7.19197,0.023,NULL,58456449084,913382016,14271594,18),(115164,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115164,38.39,0.46,477,50428,70,NULL,NULL,'2MASX J13564356+3440450',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000129,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,209.181375,34.67928,0,NULL,59151350818,924239856,14441247,18.1),(115165,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115165,36.98,0.19,249,50429,70,NULL,NULL,'2MASX J13564382+5836374',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000166,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,209.182625,58.61044,0.005,NULL,57266128534,894783258,13980988,17),(115166,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115166,36.17,0.46,171,50430,70,NULL,NULL,'2MASX J13564406+0556588',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.44',0.16,NULL,NULL,NULL,NULL,NULL,1,209.183625,5.94956,0,NULL,58405696810,912589012,14259203,17.44),(115167,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115167,37.46,0.46,310,50431,70,NULL,NULL,'2MASX J13564475+2831594',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000179,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,209.186375,28.53314,0,NULL,60005729432,937589522,14649836,16.7),(115168,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115168,37.72,0.46,351,50432,70,NULL,NULL,'2MASX J13564572+4800220',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,209.1904583,48.00619,0,NULL,59243799520,925684367,14463818,17),(115169,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115169,36.96,0.46,246,50433,70,NULL,NULL,'2MASX J13564614+1316005',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,209.1925,13.26686,0,NULL,58339075429,911548053,14242938,17.4),(115170,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115170,37.48,0.46,313,50434,70,NULL,NULL,'2MASX J13564667+2520144',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000177,NULL,'18.06',0.18,NULL,NULL,NULL,NULL,NULL,1,209.1945,25.33742,0,NULL,59999060432,937485319,14648208,18.06),(115171,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115171,35.66,0.46,135,50435,70,NULL,NULL,'CGCG 046-012',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00009,NULL,'15.5g',0.45,'S0',NULL,NULL,NULL,NULL,1,209.198125,5.52631,0.032,NULL,58405917221,912592456,14259257,15.5),(115172,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115172,36.21,0.61,175,50436,70,NULL,NULL,'2MASX J13564883-1804238',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.10',NULL,NULL,NULL,NULL,NULL,NULL,1,209.203458333,-18.07342,0.269,NULL,43681651926,682525811,10664465,16.1),(115173,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115173,38.5,0.46,501,50437,70,NULL,NULL,'2MASX J13564899+1955572',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,209.204125,19.93258,0.06,NULL,58327510944,911367358,14240114,17.5),(115174,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115174,35.22,0.46,111,50438,70,NULL,NULL,'2MASX J13564917+3818514',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000155,NULL,'15.8g',0.41,'AGN+SF',NULL,NULL,NULL,NULL,1,209.2047917,38.31411,0,NULL,59154548947,924289827,14442028,15.8),(115175,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115175,36.68,0.61,216,50439,70,NULL,NULL,'2MASX J13564916-4308181',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,209.204875,-43.13833,0.245,NULL,46919467991,733116687,11454948,15.8),(115176,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115176,37.96,0.46,392,50440,70,NULL,NULL,'2MASX J13564944+1402165',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,209.2059583,14.03811,0,NULL,58371375132,912052736,14250824,17.4),(115177,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115177,35.3,0.55,115,50441,70,NULL,NULL,'2MASX J13565043-2848332',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.5b',NULL,'Sp',NULL,NULL,NULL,NULL,1,209.210083333,-28.80917,0.221,NULL,46983542113,734117845,11470591,15.5),(115178,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115178,35.65,0.46,135,50442,70,NULL,NULL,'2MASX J13565156+1633327',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.74',0.19,NULL,NULL,NULL,NULL,NULL,1,209.214916667,16.55903,0.013,NULL,58384054951,912250858,14253919,17.74),(115179,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115179,37.25,0.15,282,50443,70,NULL,NULL,'UGC 08864',NULL,'2015arXiv151105856S',2015,1,1.2,NULL,'G',NULL,NULL,'16.0',0.7,'Sa',NULL,NULL,NULL,NULL,1,209.218375,23.23008,0,NULL,59462550496,929102351,14517224,16),(115180,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115180,37.29,0.46,287,50444,70,NULL,NULL,'2MASX J13565246+1635377',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.28',0.18,NULL,NULL,NULL,NULL,NULL,1,209.2187083,16.594,0,NULL,58384046282,912250723,14253917,18.28),(115181,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115181,37.24,0.46,280,50445,70,NULL,NULL,'2MASX J13565426+3309560',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.34',0.14,NULL,NULL,NULL,NULL,NULL,1,209.226125,33.16547,0,NULL,59148695632,924198369,14440599,18.34),(115182,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115182,35.91,0.33,152,50446,70,NULL,NULL,'2MASX J13565459+4936491',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000184,NULL,'15.5g',0.42,NULL,NULL,NULL,NULL,NULL,1,209.227375,49.61358,0,NULL,59212265057,925191641,14456119,15.5),(115183,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115183,37.13,0.46,266,50447,70,NULL,NULL,'2MASX J13565460+4626024',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000126,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,209.227625,46.43389,0,NULL,59240748822,925636700,14463073,17.1),(115184,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115184,37.25,0.15,282,50448,70,NULL,NULL,'2MASX J13565492+2321489',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.15',0.15,NULL,NULL,NULL,NULL,NULL,1,209.2289583,23.36356,0,NULL,59462562392,929102537,14517227,18.15),(115185,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115185,36.36,0.46,187,50449,70,NULL,NULL,'2MASX J13565565+1749177',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.73',0.21,NULL,NULL,NULL,NULL,NULL,1,209.23175,17.82164,0.022,NULL,58374049431,912094522,14251476,16.73),(115186,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115186,32.88,0.4,37.6,50450,NULL,NULL,'mean','NGC 5375',NULL,'2007A&A...465...71T',2007,1,3.2,NULL,'G',0.000013,NULL,'13.2g',2.8,'SB(r)ab','Isolated galaxy',NULL,NULL,NULL,1,209.233333,29.16436,0,NULL,60005452299,937585192,14649768,13.2),(115187,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115187,32.89,0.4,37.8,50450,75,NULL,'B','NGC 5375',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115188,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115188,33.17,0.47,43.1,50450,NULL,NULL,'H','NGC 5375',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115189,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115189,33.27,0.45,45,50450,NULL,NULL,'K','NGC 5375',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115190,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115190,33.32,0.46,46.1,50450,NULL,NULL,'J','NGC 5375',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115191,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115191,37.25,0.15,282,50451,70,NULL,NULL,'2MASX J13565611+2310489',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,209.233666667,23.18019,0,NULL,59461763292,929090051,14517032,18),(115192,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115192,37.22,0.46,278,50452,70,NULL,NULL,'2MASX J13565633+2424564',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000159,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,209.2347917,24.41578,0,NULL,59996923755,937451933,14647686,17),(115193,'Faber-Jackson','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115193,31.25,0.9,17.8,50453,95,NULL,'Weighted Mean','NGC 5380',NULL,'1984ApJS...56...91D',1984,1,1.7,NULL,'G',0.000077,NULL,'13.25',1.7,'SA0-','in a radial-velocity based grouping',NULL,NULL,NULL,1,209.236208333,37.61039,0,NULL,59155172478,924299569,14442180,13.25),(115194,'Faber-Jackson','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115194,31.25,0.9,17.8,50453,95,NULL,'de Vaucouleurs','NGC 5380',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115195,'Tertiary','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115195,32.81,0.27,36.5,50453,95,NULL,NULL,'NGC 5380',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115196,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115196,33.33,0.4,46.3,50453,NULL,NULL,'mean','NGC 5380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115197,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115197,33.42,0.45,48.3,50453,NULL,NULL,'K','NGC 5380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115198,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115198,37.69,0.46,346,50454,70,NULL,NULL,'2MASXi J1356567-002252',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000078,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,209.236417,-0.38147,0.097,NULL,43592073277,681126144,10642596,16.9),(115199,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115199,37.33,0.46,293,50455,70,NULL,NULL,'2MASX J13565853+2442564',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,209.243875,24.71575,0,NULL,59997116061,937454938,14647733,17.7),(115200,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115200,37.3,0.33,289,50456,70,NULL,NULL,'2MASX J13565912+1340168',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.86',0.18,NULL,NULL,NULL,NULL,NULL,1,209.2465,13.67133,0,NULL,58368468111,912007314,14250114,17.86),(115201,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115201,36.7,0.46,219,50457,70,NULL,NULL,'2MASX J13565935+2723184',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000153,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,209.2474583,27.38861,0,NULL,60009924944,937655077,14650860,16.6),(115202,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115202,37.64,0.46,337,50458,70,NULL,NULL,'SDSS J135659.74+273628.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000151,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.2489583,27.60797,0,NULL,60009953922,937655530,14650867,18.3),(115203,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115203,37.61,0.46,333,50459,70,NULL,NULL,'2MASX J13570026+3632234',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,209.251083333,36.53992,0,NULL,59156438584,924319352,14442489,16.7),(115204,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115204,37.3,0.33,289,50460,70,NULL,NULL,'2MASX J13570036+1340428',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000141,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.2515,13.67864,0,NULL,58371348918,912052326,14250817,17.9),(115205,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115205,38.15,0.27,426,50461,70,NULL,NULL,'2MASX J13570063+1742348',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.72',0.16,NULL,NULL,NULL,NULL,NULL,1,209.252625,17.70969,0.022,NULL,58374141047,912095953,14251499,18.72),(115206,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115206,37.55,0.46,324,50462,70,NULL,NULL,'2MASX J13570117+2746334',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000176,NULL,'18.32',0.17,NULL,NULL,NULL,NULL,NULL,1,209.255083,27.77606,0,NULL,60009839960,937653749,14650839,18.32),(115207,'SBF','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115207,27.85,NULL,3.72,50463,NULL,NULL,NULL,'ESO 384- G 016',NULL,'2000AJ....119..166J',2000,1,1.3,NULL,'G',0.000107,NULL,'15.1B',0.9,'dS0/Im',NULL,NULL,NULL,NULL,1,209.2557083,-35.33297,0.217,NULL,46881061024,732516578,11445571,15.1),(115208,'SBF','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115208,28.13,0.1,4.23,50463,NULL,NULL,'R','ESO 384- G 016',NULL,'2000AJ....119..166J',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115209,'TRGB','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115209,28.18,0.1,4.33,50463,NULL,NULL,NULL,'ESO 384- G 016',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115210,'TRGB','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115210,28.23,0.03,4.43,50463,NULL,NULL,'I','ESO 384- G 016',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115211,'TRGB','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115211,28.26,0.1,4.49,50463,74.4,NULL,NULL,'ESO 384- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115212,'TRGB','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115212,28.28,NULL,4.53,50463,NULL,NULL,NULL,'ESO 384- G 016',NULL,'2007AJ....133..504K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115213,'IRAS','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115213,34.84,0.8,92.9,50464,75,NULL,'HMCL, I','CGCG 074-012',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000033,NULL,'15.1',0.3,'Sdm',NULL,NULL,NULL,NULL,1,209.25575,10.86736,0,NULL,58464332433,913505194,14273518,15.1),(115214,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115214,34.98,0.42,99.1,50464,NULL,NULL,'Malmquist cor.','CGCG 074-012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115215,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115215,35.2,0.38,110,50464,NULL,NULL,NULL,'CGCG 074-012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115216,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115216,35.21,0.4,110,50464,75,NULL,'HMCL, I, raw','CGCG 074-012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115217,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115217,35.24,0.2,112,50464,74.4,NULL,NULL,'CGCG 074-012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115218,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115218,35.32,0.4,116,50464,75,NULL,'HMCL, I, inv','CGCG 074-012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115219,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115219,35.32,0.4,116,50464,75,NULL,'HMCL, I, cor','CGCG 074-012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115220,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115220,35.34,0.46,117,50465,70,NULL,NULL,'SDSS J135701.83-030859.3',NULL,'2015arXiv151105856S',2015,1,0.44,'The APM image includes a superposed star.','G',0.00015,NULL,'16.0g',0.33,'E0',NULL,NULL,NULL,NULL,1,209.257667,-3.14981,0.085,NULL,43598552058,681227375,10644177,16),(115221,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115221,37.61,0.46,332,50466,70,NULL,NULL,'2MASX J13570207+2500474',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000178,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,209.258666667,25.01311,0,NULL,59997090980,937454546,14647727,16.8),(115222,'SNIa','2016-12-15 15:15:20','2016-12-16 11:20:32','1','SN 2001gy',NULL,115222,41.66,0.09,1420,50467,74.2,NULL,'SALT 2','SCP J135704.54+043059.8',0.511,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,209.268917,4.51661,0.048,NULL,58409501591,912648462,14260132,NULL),(115223,'Ring Diameter','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115223,30.2,0.84,11,50468,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5383',NULL,'1981ApJS...45..541P',1981,1,3.2,NULL,'G',0.00001,NULL,'12.0B',2.7,'(R\')SB(rs)b:pecSbrst','in a radial-velocity based grouping',NULL,NULL,NULL,1,209.2707083,41.84625,0,NULL,59272599223,926134362,14470849,12),(115224,'Tully est','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115224,32.89,0.8,37.8,50468,75,NULL,'B','NGC 5383',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115225,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115225,32.69,0.4,34.5,50468,NULL,NULL,'mean','NGC 5383',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115226,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115226,32.89,0.45,37.9,50468,NULL,NULL,'K','NGC 5383',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115227,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115227,32.92,0.47,38.4,50468,NULL,NULL,'H','NGC 5383',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115228,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115228,32.99,0.46,39.6,50468,NULL,NULL,'J','NGC 5383',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115229,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115229,37.73,0.46,351,50469,70,NULL,NULL,'2MASX J13570573+1223408',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,209.27375,12.39456,0,NULL,58339188065,911549813,14242965,17.6),(115230,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115230,36.99,0.27,250,50470,70,NULL,NULL,'2MASX J13570614+3253159',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,209.2754583,32.88778,0,NULL,59148938351,924202161,14440658,17),(115231,'SNII optical','2016-12-15 15:15:20','2016-12-16 11:20:32','1','SN 2003cx',NULL,115231,36.17,0.44,171,50471,NULL,NULL,'SCM, B','NEAT J135706.53-170220.0',NULL,'2010ApJ...715..833O',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,209.2772083,-17.03889,0.265,NULL,43684159847,682564997,10665078,NULL),(115232,'SNII optical','2016-12-15 15:15:20','2016-12-16 11:20:32','1','SN 2003cx',NULL,115232,36.2,0.29,174,50471,NULL,NULL,'SCM, BVI','NEAT J135706.53-170220.0',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115233,'SNII optical','2016-12-15 15:15:20','2016-12-16 11:20:32','1','SN 2003cx',NULL,115233,36.23,0.55,176,50471,NULL,NULL,'SCM, V','NEAT J135706.53-170220.0',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115234,'SNII optical','2016-12-15 15:15:20','2016-12-16 11:20:32','1','SN 2003cx',NULL,115234,36.23,0.54,176,50471,NULL,NULL,'SCM, I','NEAT J135706.53-170220.0',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115235,'GRB','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115235,42.97,NULL,3930,50472,71,NULL,NULL,'GRB 080825B',NULL,'2011A&A...526A.153K',2011,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Fermi',NULL,NULL,NULL,NULL,1,209.280917,-68.94278,NULL,NULL,44949663581,702338493,10974038,NULL),(115236,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115236,36.83,0.46,232,50473,70,NULL,NULL,'2MASX J13570717+2730284',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000196,NULL,'17.18',0.27,NULL,NULL,NULL,NULL,NULL,1,209.2800417,27.50794,0,NULL,60009943632,937655369,14650865,17.18),(115237,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115237,38.33,0.33,464,50474,70,NULL,NULL,'SDSS J135708.03+075445.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.2835,7.91256,0,NULL,58457631277,913400488,14271882,18),(115238,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115238,37.28,0.33,285,50475,70,NULL,NULL,'2MASX J13570896+2431469',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,209.2874583,24.52978,0,NULL,59996920653,937451885,14647685,17.1),(115239,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115239,37.28,0.33,285,50476,70,NULL,NULL,'2MASX J13570942+2424230',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000038,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,209.28925,24.40639,0,NULL,59460846639,929075728,14516808,17.4),(115240,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115240,38.18,0.46,433,50477,70,NULL,NULL,'2MASX J13570955+1133062',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,209.2897083,11.55172,0,NULL,58464017956,913500280,14273441,17.4),(115241,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115241,38.09,0.33,416,50478,70,NULL,NULL,'2MASX J13570990+3547489',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000176,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,209.291375,35.79706,0,NULL,59155991638,924312369,14442380,17),(115242,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115242,37.99,0.33,396,50479,70,NULL,NULL,'2MASX J13571061+1557148',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,209.294208333,15.95411,0,NULL,58384628613,912259822,14254059,18),(115243,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115243,38.09,0.33,416,50480,70,NULL,NULL,'2MASX J13571072+3549529',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000138,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,209.2945417,35.8315,0,NULL,59155989146,924312330,14442380,18),(115244,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115244,38.16,0.46,428,50481,70,NULL,NULL,'2MASX J13571122+4144094',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,209.296667,41.73608,0,NULL,59272474072,926132407,14470818,17.1),(115245,'SNIa','2016-12-15 15:15:20','2016-12-16 11:20:32','1','SN 2001hb',NULL,115245,43.52,0.14,2490,50482,74.2,NULL,'SALT 2','SCP J135711.96+042026.9',1.03,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,209.299833,4.34081,0.038,NULL,58409612344,912650192,14260159,NULL),(115246,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115246,38.38,0.46,473,50483,70,NULL,NULL,'2MASX J13571215+3401579',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000146,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,209.30075,34.03278,0,NULL,59152041701,924250651,14441416,18),(115247,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115247,36.77,0.33,225,50484,70,NULL,NULL,'2MASX J13571220+3846084',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'17.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,209.300958333,38.76892,0,NULL,59140972751,924077699,14438714,17.8),(115248,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115248,38.46,0.46,491,50485,70,NULL,NULL,'2MASX J13571274+3855374',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,209.303083,38.92694,0,NULL,59140781883,924074716,14438667,18.3),(115249,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115249,37.99,0.33,396,50486,70,NULL,NULL,'2MASX J13571372+1554558',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.52',0.14,NULL,NULL,NULL,NULL,NULL,1,209.307125,15.91539,0,NULL,58383754345,912246161,14253846,18.52),(115250,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115250,34.14,0.46,67.2,50487,70,NULL,NULL,'IC 4350',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.00006,NULL,'13.15',0.8,'(R:)SAB(r)0/a  HII','in a pair',NULL,NULL,NULL,1,209.308,-25.24581,0.317,NULL,46978631599,734041118,11469392,13.15),(115251,'CMD','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115251,18.35,0.01,0.0468,50488,NULL,NULL,NULL,'Bootes III',NULL,'2009ApJ...693.1118G',2009,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,209.3,26.8,0,1,60009431662,937647369,14650740,NULL),(115252,'Red Clump','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115252,18.58,0.05,0.052,50488,NULL,NULL,NULL,'Bootes III',NULL,'2009MNRAS.397L..26C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115253,'RR Lyrae','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115253,18.31,0.09,0.046,50488,NULL,NULL,NULL,'Bootes III',NULL,'2014ApJ...793..135S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115254,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115254,37.35,0.46,295,50489,70,NULL,NULL,'2MASX J13571408+2150350',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000143,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,209.308625,21.84308,0.018,NULL,59459631669,929056744,14516511,17.2),(115255,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115255,37.81,0.46,364,50490,70,NULL,NULL,'2MASX J13571426+3129029',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.28',0.17,NULL,NULL,NULL,NULL,NULL,1,209.309291667,31.48417,0,NULL,59127360894,923865013,14435390,18.28),(115256,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115256,37.23,0.46,279,50491,70,NULL,NULL,'2MASX J13571434+0143171',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000072,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,209.309875,1.72139,0.041,NULL,58412753687,912699276,14260926,18),(115257,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115257,36.68,0.46,217,50492,70,NULL,NULL,'2MASX J13571465+2403000',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.57',0.21,NULL,NULL,NULL,NULL,NULL,1,209.311167,24.04986,0,NULL,59461056857,929079013,14516859,17.57),(115258,'SBF','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115258,29.6,0.2,8.3,50493,NULL,NULL,'R','UGC 08882',NULL,'2005A&A...437..823R',2005,1,1.1,NULL,'G',NULL,NULL,'16.0',0.8,'dE, N',NULL,NULL,NULL,NULL,1,209.31125,54.10089,0,NULL,57285122665,895080041,13985625,16),(115259,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115259,36.98,0.46,249,50494,70,NULL,NULL,'2MASX J13571480+2129140',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.28',0.16,NULL,NULL,NULL,NULL,NULL,1,209.311625,21.48714,0.025,NULL,59473180890,929268451,14519819,18.28),(115260,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115260,35.87,0.76,149,50495,70,NULL,NULL,'2MASX J13571505-1853052',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.26',NULL,NULL,NULL,NULL,NULL,NULL,1,209.312583333,-18.88475,0.257,NULL,43626802178,681668784,10651074,16.26),(115261,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115261,35.32,0.49,116,50496,75,NULL,'IR','UGC 08873',NULL,'2011yCatp016004901K',2011,1,1.5,'Holmberg 559b is a star.','G',0.000033,NULL,'15.04',0.3,'S?             HII',NULL,NULL,NULL,NULL,1,209.31425,24.25758,0,NULL,59460854075,929075844,14516810,15.04),(115262,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115262,35.88,0.2,150,50497,74.4,NULL,NULL,'UGC 08873',NULL,'2013AJ....146...86T',2013,1,1.5,'Holmberg 559b is a star.','G',0.000033,NULL,'15.04',0.3,'S?             HII',NULL,NULL,NULL,NULL,1,209.31425,24.25758,0,NULL,59460854075,929075844,14516810,15.04),(115263,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115263,38.11,0.27,420,50498,70,NULL,NULL,'SDSS J135716.59+035058.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000147,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,209.319166667,3.84972,0.029,NULL,58407398234,912615597,14259618,18.5),(115264,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115264,36.61,0.46,210,50499,70,NULL,NULL,'2MASX J13571749+1445168',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000171,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,209.322917,14.75469,0,NULL,58370706830,912042294,14250660,16.6),(115265,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115265,36.46,0.46,196,50500,70,NULL,NULL,'2MASX J13571822+3951005',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000166,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,209.326083333,39.85031,0,NULL,59259357877,925927466,14467616,16.5),(115266,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115266,33.52,0.49,50.7,50501,75,NULL,'IR','ESO 445- G 083',NULL,'2011yCatp016004901K',2011,1,1.55,NULL,'G',0.000033,NULL,'16.06',0.17,'Scd',NULL,NULL,NULL,NULL,1,209.326875,-28.19447,0.217,NULL,46983086183,734110721,11470480,16.06),(115267,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115267,34.18,0.2,68.6,50501,74.4,NULL,NULL,'ESO 445- G 083',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115268,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115268,34.25,0.5,70.8,50501,NULL,NULL,'Malmquist cor.','ESO 445- G 083',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115269,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115269,34.26,0.5,71,50501,NULL,NULL,NULL,'ESO 445- G 083',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115270,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115270,34.57,NULL,81.9,50501,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 445- G 083',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115271,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115271,34.58,NULL,82.3,50501,NULL,NULL,'Dipole + Quadrupole','ESO 445- G 083',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115272,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115272,34.59,NULL,82.9,50501,NULL,NULL,'Dipole','ESO 445- G 083',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115273,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115273,34.63,NULL,84.2,50501,NULL,NULL,NULL,'ESO 445- G 083',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115274,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115274,37.98,0.46,394,50502,70,NULL,NULL,'2MASX J13572442+3303080',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,209.351667,33.05217,0,NULL,59148974336,924202724,14440667,18.2),(115275,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115275,38.34,0.46,465,50503,70,NULL,NULL,'SDSS J135725.05+121743.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,209.354417,12.29544,0,NULL,58339228739,911550449,14242975,18.2),(115276,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115276,38.57,0.46,518,50504,70,NULL,NULL,'2MASX J13572687+5630532',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.361625,56.51475,0,NULL,57309906673,895467291,13991676,18.2),(115277,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115277,38.63,0.46,533,50505,70,NULL,NULL,'SDSS J135726.86+360206.5',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.361917,36.03514,0,NULL,59156174701,924315229,14442425,17.9),(115278,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115278,35.2,0.46,110,50506,70,NULL,NULL,'CGCG 074-017',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000093,NULL,'15.5g',0.47,NULL,NULL,NULL,NULL,NULL,1,209.373041667,9.95089,0.053,NULL,58463187865,913487310,14273239,15.5),(115279,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115279,37.57,0.46,326,50507,70,NULL,NULL,'SDSS J135729.55+065644.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000152,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.373167,6.94572,0.057,NULL,58511141265,914236582,14284946,18.6),(115280,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115280,37.89,0.46,379,50508,70,NULL,NULL,'2MASX J13572958+4032047',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000924,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,209.373167,40.53447,0,NULL,59271240205,926113128,14470517,18.4),(115281,'SNII optical','2016-12-15 15:15:20','2016-12-16 11:20:32','1','SN 2003bl',NULL,115281,33.95,0.45,61.7,50509,NULL,NULL,'SCM, B','NGC 5374',NULL,'2010ApJ...715..833O',2010,1,1.7,NULL,'G',0.000023,NULL,'13.27',1.5,'SB(r)bc?','in a radial-velocity based grouping',NULL,NULL,NULL,1,209.3734583,6.097,0.023,NULL,58510568467,914227632,14284806,13.27),(115282,'SNII optical','2016-12-15 15:15:20','2016-12-16 11:20:32','1','SN 2003bl',NULL,115282,33.99,0.09,62.8,50509,NULL,NULL,'I, photospheric magnitude method','NGC 5374',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115283,'SNII optical','2016-12-15 15:15:20','2016-12-16 11:20:32','1','SN 2003bl',NULL,115283,34,0.16,63.1,50509,NULL,NULL,'V, photospheric magnitude method','NGC 5374',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115284,'SNII optical','2016-12-15 15:15:20','2016-12-16 11:20:33','1','SN 2003bl',NULL,115284,34.07,0.3,65.2,50509,NULL,NULL,'SCM, BVI','NGC 5374',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115285,'SNII optical','2016-12-15 15:15:20','2016-12-16 11:20:33','1','SN 2003bl',NULL,115285,34.09,0.57,65.8,50509,NULL,NULL,'SCM, V','NGC 5374',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115286,'SNII optical','2016-12-15 15:15:20','2016-12-16 11:20:33','1','SN 2003bl',NULL,115286,34.23,0.55,70.1,50509,NULL,NULL,'SCM, I','NGC 5374',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115287,'SNII optical','2016-12-15 15:15:20','2016-12-16 11:20:33','1','SN 2003bl',NULL,115287,34.83,0.31,92.4,50509,NULL,NULL,'EPM D05','NGC 5374',NULL,'2009ApJ...696.1176J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115288,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115288,38.11,0.27,420,50510,70,NULL,NULL,'2MASX J13573054+0343381',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000181,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,209.377208333,3.72731,0.057,NULL,58407533848,912617716,14259651,17.1),(115289,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115289,38.33,0.33,464,50511,70,NULL,NULL,'SDSS J135731.04+075641.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.379375,7.94489,0,NULL,58457611727,913400183,14271877,18.4),(115290,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115290,38.38,0.33,473,50512,70,NULL,NULL,'SDSS J135732.90+154621.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.387125,15.77261,0,NULL,58383781874,912246591,14253852,18.5),(115291,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115291,36.7,0.46,219,50513,70,NULL,NULL,'2MASX J13573416+0953527',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.30',0.16,NULL,NULL,NULL,NULL,NULL,1,209.392208333,9.89803,0.053,NULL,58463184858,913487263,14273238,18.3),(115292,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115292,37.29,0.27,287,50514,70,NULL,NULL,'2MASX J13573420+3615277',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000174,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,209.392667,36.25767,0,NULL,59156034213,924313034,14442391,17.4),(115293,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115293,33.89,0.47,59.9,50515,NULL,NULL,'H','ESO 174- G 003',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000019,NULL,'14.1',1.1,'SB(s)cd',NULL,NULL,NULL,NULL,1,209.395083,-52.77178,NULL,NULL,46816606339,731509474,11429835,14.1),(115294,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115294,33.91,0.4,60.6,50515,NULL,NULL,'mean','ESO 174- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115295,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115295,34.03,0.45,64,50515,NULL,NULL,'K','ESO 174- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115296,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115296,34.14,0.46,67.2,50515,NULL,NULL,'J','ESO 174- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115297,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115297,37.04,0.46,256,50516,70,NULL,NULL,'2MASX J13573529+2744240',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.0002,NULL,'16.1g',0.34,NULL,NULL,NULL,NULL,NULL,1,209.397083,27.73992,0,NULL,60009857216,937654019,14650844,16.1),(115298,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115298,31.75,0.43,22.4,50517,75,NULL,'3.6 micron, color + selection bias corrected','ESO 510- G 026',NULL,'2014MNRAS.444..527S',2014,1,1.3,'Confused HIPASS source','G',0.000022,NULL,'15.43',0.8,'SB(rs)m',NULL,NULL,NULL,NULL,1,209.397333,-25.79175,0.297,NULL,46979452699,734053948,11469592,15.43),(115299,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115299,36.99,0.27,250,50518,70,NULL,NULL,'2MASX J13573537+3246010',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,209.3974583,32.76686,0,NULL,59148215233,924190863,14440482,16.5),(115300,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115300,37.69,0.46,344,50519,70,NULL,NULL,'2MASX J13573672+0820437',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.403041667,8.34558,0,NULL,58457657345,913400896,14271889,17.9),(115301,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115301,37.8,0.46,362,50520,70,NULL,NULL,'2MASX J13573706+5234488',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000136,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.404667,52.58006,0,NULL,59219354492,925302413,14457850,18),(115302,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115302,36.77,0.33,225,50521,70,NULL,NULL,'2MASX J13573721+3845247',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000154,NULL,'16.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,209.40525,38.75694,0,NULL,59140983846,924077872,14438716,16.4),(115303,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115303,38.47,0.46,494,50522,70,NULL,NULL,'2MASX J13573906+3059349',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,209.41275,30.99294,0,NULL,60004630704,937572354,14649568,17.6),(115304,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115304,37.53,0.46,320,50523,70,NULL,NULL,'2MASX J13573911+4203530',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000172,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,209.412917,42.06475,0,NULL,59272635014,926134922,14470858,17.1),(115305,'D-Sigma','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115305,33.26,0.4,44.9,50524,75,NULL,'Edat, raw','ESO 384- G 019',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00005,NULL,'12.8',1.2,'(R)SA(rl)0^+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,209.413333,-34.219,0.209,NULL,46883910562,732561102,11446267,12.8),(115306,'D-Sigma','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115306,33.44,0.4,48.7,50524,75,NULL,'Edat, cor','ESO 384- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115307,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115307,32.77,0.25,35.8,50524,74.4,NULL,NULL,'ESO 384- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115308,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115308,32.89,0.48,37.8,50524,70,NULL,NULL,'ESO 384- G 019',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115309,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115309,33.79,0.45,57.2,50524,NULL,NULL,'K','ESO 384- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115310,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115310,33.84,0.4,58.6,50524,NULL,NULL,'mean','ESO 384- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115311,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115311,37.59,0.23,330,50525,70,NULL,NULL,'2MASX J13573943+2250469',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.32',0.27,NULL,NULL,NULL,NULL,NULL,1,209.414417,22.84633,0,NULL,59461760428,929090006,14517031,17.32),(115312,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115312,37.29,0.27,287,50526,70,NULL,NULL,'2MASX J13573966+3620077',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.00011,NULL,'15.1g',0.56,'BrClG',NULL,NULL,NULL,NULL,1,209.415333,36.33561,0,NULL,59156031157,924312986,14442390,15.1),(115313,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115313,35.12,NULL,105,50527,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08879',NULL,'2010Ap&SS.325..163P',2010,1,1.65,NULL,'G',0.000014,NULL,'15.3g',0.3,'Sc',NULL,NULL,NULL,NULL,1,209.415375,25.77469,0,NULL,59998620967,937478452,14648100,15.3),(115314,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115314,35.12,NULL,106,50527,NULL,NULL,'Dipole + Quadrupole','UGC 08879',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115315,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115315,35.13,NULL,106,50527,NULL,NULL,'Dipole','UGC 08879',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115316,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115316,35.2,NULL,110,50527,NULL,NULL,NULL,'UGC 08879',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115317,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115317,35.27,0.49,113,50527,75,NULL,'IR','UGC 08879',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115318,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115318,35.6,0.39,132,50527,NULL,NULL,'Malmquist cor.','UGC 08879',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115319,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115319,35.78,0.36,143,50527,NULL,NULL,NULL,'UGC 08879',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115320,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115320,35.83,0.2,147,50527,74.4,NULL,NULL,'UGC 08879',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115321,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115321,37.44,0.46,307,50528,70,NULL,NULL,'2MASX J13574014+2231379',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.07',0.16,'AGN',NULL,NULL,NULL,NULL,1,209.417417,22.52714,0,NULL,59459972246,929062066,14516594,18.07),(115322,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115322,38.16,0.46,429,50529,70,NULL,NULL,'2MASX J13574027-0027164',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000074,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,209.4177083,-0.4545,0.113,NULL,43595058133,681172783,10643324,18.2),(115323,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115323,37.56,0.46,325,50530,70,NULL,NULL,'2MASX J13574024+5000158',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,209.417833,50.00447,0.009,NULL,59212042510,925188164,14456065,17.4),(115324,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115324,36.92,0.46,242,50531,70,NULL,NULL,'2MASX J13574054+2124579',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.00',0.18,NULL,NULL,NULL,NULL,NULL,1,209.419,21.41608,0.028,NULL,59473177037,929268391,14519818,18),(115325,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115325,32.37,0.4,29.7,50532,75,NULL,'B','UGC 08892',NULL,'1988NBGC.C....0000T',1988,1,NULL,NULL,'GTrpl',0.000037,NULL,NULL,NULL,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,209.42125,57.00167,0,NULL,57309938205,895467784,13991684,NULL),(115326,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115326,37.26,0.46,283,50533,70,NULL,NULL,'2MASX J13574167+2006339',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.01',0.19,NULL,NULL,NULL,NULL,NULL,1,209.4237917,20.10933,0.05,NULL,58328075742,911376183,14240252,18.01),(115327,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115327,37.17,0.46,272,50534,70,NULL,NULL,'2MASX J13574275+4628099',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000179,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,209.42825,46.46958,0,NULL,59240772058,925637063,14463079,16.3),(115328,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115328,36.91,0.46,241,50535,70,NULL,NULL,'2MASX J13574328+0633497',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.69',NULL,NULL,NULL,NULL,NULL,NULL,1,209.43025,6.56383,0.035,NULL,58510710508,914229851,14284841,17.69),(115329,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115329,38.38,0.33,473,50536,70,NULL,NULL,'SDSS J135744.21+154258.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.43425,15.71636,0,NULL,58383772281,912246441,14253850,18.3),(115330,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115330,38.16,0.46,428,50537,70,NULL,NULL,'SDSS J135744.72+023055.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000077,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,209.436375,2.5155,0.025,NULL,58415114695,912736167,14261502,18.5),(115331,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115331,37.76,0.46,356,50538,70,NULL,NULL,'2MASX J13574485+0247447',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000089,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,209.436917,2.79583,0.033,NULL,58414980139,912734064,14261469,16.9),(115332,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115332,36.99,0.27,250,50539,70,NULL,NULL,'2MASX J13574520+3235010',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,209.438375,32.58375,0,NULL,59148264554,924191633,14440494,16.5),(115333,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115333,36.96,0.23,247,50540,70,NULL,NULL,'2MASX J13574552+2032319',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.42',0.15,NULL,NULL,NULL,NULL,NULL,1,209.4397917,20.54231,0.055,NULL,58327221377,911362834,14240044,18.42),(115334,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115334,38.11,0.27,420,50541,70,NULL,NULL,'2MASX J13574609+0344147',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000185,NULL,'16.8g',0.33,NULL,NULL,NULL,NULL,NULL,1,209.441916667,3.73731,0.057,NULL,58407521724,912617526,14259648,16.8),(115335,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115335,37.26,0.46,283,50542,70,NULL,NULL,'SDSS J135746.79-002152.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00008,NULL,'17.7g',0.17,'NLAGN',NULL,NULL,NULL,'Sy 2',1,209.4449583,-0.36467,0.113,NULL,43594851323,681169551,10643274,17.7),(115336,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115336,38.43,0.46,486,50543,70,NULL,NULL,'2MASX J13574731+5456322',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000178,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,209.447125,54.94228,0,NULL,57283231119,895050486,13985163,17.1),(115337,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115337,35.21,0.46,110,50544,70,NULL,NULL,'IC 0965',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.00018,NULL,'15.2',0.6,NULL,'Group member',NULL,NULL,NULL,1,209.447917,17.51053,0.029,NULL,58374179780,912096559,14251508,15.2),(115338,'Tully est','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115338,32.37,0.8,29.8,50545,75,NULL,NULL,'UGC 08894',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.000037,NULL,'16.5',1.1,'Sm',NULL,NULL,NULL,NULL,1,209.4485417,63.39742,0.029,NULL,57932702752,905198480,14143726,16.5),(115339,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115339,38.57,0.46,518,50546,70,NULL,NULL,'SDSS J135747.80+305444.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00016,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.449167,30.91225,0,NULL,60004109210,937564206,14649440,18.5),(115340,'Tully est','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115340,32.4,0.8,30.3,50547,75,NULL,NULL,'ESO 008- G 004',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.000013,NULL,'13.6',1.9,'SAB(rs)cd',NULL,NULL,NULL,NULL,1,209.4500417,-83.08017,0.417,NULL,44068466504,688569789,10758902,13.6),(115341,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115341,38.42,0.46,483,50548,70,NULL,NULL,'SDSS J135748.04+460939.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,209.450167,46.16111,0,NULL,59232571673,925508932,14461077,18.4),(115342,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115342,37.29,0.27,287,50549,70,NULL,NULL,'2MASX J13574884+3618467',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000172,NULL,'16.8g',0.25,'AGN',NULL,NULL,NULL,NULL,1,209.45375,36.31289,0,NULL,59156032985,924313015,14442390,16.8),(115343,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115343,34.79,0.47,91,50550,NULL,NULL,'H','UGC 08878',NULL,'2007A&A...465...71T',2007,1,1.02,NULL,'G',0.00002,NULL,'14.3g',0.87,'SBb','Group member',NULL,NULL,NULL,1,209.4559583,9.87339,0.053,NULL,58462471934,913476123,14273064,14.3),(115344,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115344,34.97,0.45,98.6,50550,NULL,NULL,'K','UGC 08878',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115345,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115345,34.99,0.4,99.3,50550,NULL,NULL,'mean','UGC 08878',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115346,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115346,35.01,0.46,100,50550,NULL,NULL,'J','UGC 08878',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115347,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115347,34.75,0.56,89.2,50551,70,NULL,NULL,'ESO 384- G 020',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'15.37',0.3,'Sa-b',NULL,NULL,NULL,NULL,1,209.456166667,-36.03839,0.245,NULL,46891754741,732683667,11448182,15.37),(115348,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115348,38.85,0.46,588,50552,70,NULL,NULL,'2MASX J13574973+3146240',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,209.457333,31.77344,0,NULL,59127126010,923861343,14435333,18.2),(115349,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115349,37.18,0.23,273,50553,70,NULL,NULL,'2MASXi J1357499+213622',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.4g',NULL,NULL,NULL,NULL,NULL,NULL,1,209.457833,21.60617,0.025,NULL,59473349001,929271078,14519860,17.4),(115350,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115350,37.98,0.46,394,50554,70,NULL,NULL,'2MASX J13575043+1155599',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000144,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,209.460083333,11.93322,0,NULL,58460651221,913447675,14272619,17.8),(115351,'D-Sigma','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115351,32.13,0.4,26.7,50555,75,NULL,'Edat, raw','NGC 5365',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000113,NULL,'12.45',1.9,'(L)SB(s)0^-','in a pair',NULL,NULL,NULL,1,209.461,-43.93131,0.333,NULL,46919311345,733114239,11454909,12.45),(115352,'D-Sigma','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115352,32.47,0.4,31.1,50555,75,NULL,'Edat, cor','NGC 5365',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115353,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115353,32,0.5,25.1,50555,70,NULL,NULL,'NGC 5365',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115354,'Tully est','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115354,32.59,0.8,33,50555,75,NULL,'B','NGC 5365',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115355,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115355,32.48,0.45,31.4,50555,NULL,NULL,'K','NGC 5365',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115356,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115356,32.68,0.4,34.4,50555,NULL,NULL,'mean','NGC 5365',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115357,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115357,38.15,0.27,426,50556,70,NULL,NULL,'2MASX J13575070+1743531',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.80',0.23,NULL,NULL,NULL,NULL,NULL,1,209.461208333,17.73158,0.033,NULL,58374198375,912096849,14251513,17.8),(115358,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115358,37.85,0.16,372,50557,70,NULL,NULL,'SDSS J135753.38+493303.9',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000163,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,209.4724583,49.55111,0,NULL,59242548579,925664821,14463512,17.2),(115359,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115359,38.23,0.46,443,50558,70,NULL,NULL,'SDSS J135753.87+061920.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.4744583,6.32228,0.035,NULL,58510791787,914231121,14284861,17.9),(115360,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115360,31.77,0.5,22.6,50559,70,NULL,NULL,'IC 4351',NULL,'2014MNRAS.445.2677S',2014,1,7.56,NULL,'G',0.00001,NULL,'12.63',1.01,'SA(s)b: sp     HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,209.476083,-29.31572,0.165,NULL,46982881114,734107517,11470429,12.63),(115361,'IRAS','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115361,32.64,0.8,33.7,50559,75,NULL,'A82, H','IC 4351',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115362,'IRAS','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115362,32.64,0.8,33.7,50559,75,NULL,'HMCL, I','IC 4351',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115363,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115363,31.97,NULL,24.8,50559,NULL,NULL,'B','IC 4351',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115364,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115364,32.06,NULL,25.8,50559,NULL,NULL,NULL,'IC 4351',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115365,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115365,32.2,0.35,27.5,50559,NULL,NULL,NULL,'IC 4351',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115366,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115366,32.22,NULL,27.7,50559,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 4351',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115367,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115367,32.23,NULL,27.9,50559,NULL,NULL,'Dipole + Quadrupole','IC 4351',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115368,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115368,32.24,NULL,28.1,50559,NULL,NULL,'Dipole','IC 4351',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115369,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115369,32.31,0.47,28.9,50559,75,NULL,'A82, H, raw','IC 4351',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115370,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115370,32.31,0.46,29,50559,NULL,NULL,'J','IC 4351',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115371,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115371,32.32,0.47,29.1,50559,NULL,NULL,'H','IC 4351',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115372,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115372,32.37,0.45,29.8,50559,NULL,NULL,'K','IC 4351',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115373,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115373,32.54,0.47,32.2,50559,75,NULL,'A82, H, inv','IC 4351',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115374,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115374,32.6,0.4,33,50559,75,NULL,'HMCL, I, raw','IC 4351',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115375,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115375,32.61,0.43,33.2,50559,75,NULL,'3.6 micron, color corrected','IC 4351',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115376,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115376,32.64,0.43,33.7,50559,75,NULL,'3.6 micron, color + selection bias corrected','IC 4351',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115377,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115377,32.66,0.47,34.1,50559,75,NULL,'A82, H, cor','IC 4351',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115378,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115378,32.68,0.2,34.4,50559,74.4,NULL,NULL,'IC 4351',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115379,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115379,32.86,0.4,37.2,50559,75,NULL,'HMCL, I, cor','IC 4351',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115380,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115380,32.86,0.4,37.3,50559,75,NULL,'HMCL, I, inv','IC 4351',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115381,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115381,32.86,0.4,37.3,50559,75,NULL,'B','IC 4351',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115382,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115382,32.89,0.4,37.8,50559,NULL,NULL,'mean','IC 4351',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115383,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115383,36.78,0.46,227,50560,70,NULL,NULL,'2MASX J13575478+0844097',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,209.478375,8.73611,0.017,NULL,58457284671,913395072,14271798,17.3),(115384,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115384,36.73,0.46,222,50561,70,NULL,NULL,'2MASX J13575602+2121115',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.60',0.14,NULL,NULL,NULL,NULL,NULL,1,209.483416667,21.35317,0.028,NULL,59473155639,929268056,14519813,18.6),(115385,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115385,37.22,0.33,278,50562,70,NULL,NULL,'2MASX J13575663+1620221',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.94',0.2,NULL,NULL,NULL,NULL,NULL,1,209.4860417,16.33947,0,NULL,58384149868,912252341,14253942,17.94),(115386,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115386,35.97,0.46,157,50563,70,NULL,NULL,'2MASX J13575722+3718259',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,209.488458333,37.30728,0,NULL,59155047715,924297620,14442150,16.5),(115387,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115387,37.18,0.46,272,50564,70,NULL,NULL,'2MASX J13575827+3200271',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.52',0.22,NULL,NULL,NULL,NULL,NULL,1,209.492833,32.00744,0,NULL,59181685590,924713837,14448653,17.52),(115388,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115388,37.33,0.46,292,50565,70,NULL,NULL,'2MASX J13575963-0210524',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,209.498417,-2.18133,0.153,NULL,43600411931,681256436,10644631,17.6),(115389,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115389,37.48,0.46,313,50566,70,NULL,NULL,'2MASX J13575973+3425101',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00014,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,209.499083,34.41953,0,NULL,59152219801,924253434,14441459,18.1),(115390,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115390,36.72,0.72,221,50567,70,NULL,NULL,'2MASX J13575987-1540465',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,209.4995417,-15.67956,0.249,NULL,43686979004,682609046,10665766,15.5),(115391,'CMD','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115391,18.1,0.06,0.042,50568,NULL,NULL,NULL,'BOOTES II',NULL,'2008ApJ...688..245W',2008,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'dSph',NULL,NULL,NULL,NULL,1,209.5,12.85,0,1,58339521530,911555023,14243047,NULL),(115392,'CMD','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115392,18.3,0.2,0.046,50568,NULL,NULL,NULL,'BOOTES II',NULL,'2009ApJ...690..453K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115393,'CMD','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115393,18.9,0.5,0.06,50568,NULL,NULL,NULL,'BOOTES II',NULL,'2008AJ....135.1361D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115394,'CMD','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115394,18.9,0.5,0.06,50568,NULL,NULL,NULL,'BOOTES II',NULL,'2007ApJ...662L..83W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115395,'RR Lyrae','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115395,17.96,0.11,0.039,50568,NULL,NULL,NULL,'BOOTES II',NULL,'2014ApJ...793..135S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115396,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115396,37.55,0.33,323,50569,70,NULL,NULL,'2MASXi J1357599+585513',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00017,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,209.500083,58.92056,0.005,NULL,57273402148,894896908,13982764,17.6),(115397,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115397,35.83,0.46,146,50570,70,NULL,NULL,'2MASX J13580023+5843183',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00016,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,209.50075,58.72192,0,NULL,57265897991,894779656,13980932,16.3),(115398,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115398,38.55,0.33,514,50571,70,NULL,NULL,'SDSS J135800.28+312943.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.5012083,31.49544,0,NULL,59127319205,923864362,14435380,17.9),(115399,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115399,38.03,0.33,403,50572,70,NULL,NULL,'2MASX J13580066+0953027',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.48',0.14,NULL,NULL,NULL,NULL,NULL,1,209.50275,9.88408,0.053,NULL,58463174698,913487104,14273236,18.48),(115400,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115400,37.59,0.23,330,50573,70,NULL,NULL,'2MASX J13580181+2254136',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000087,NULL,'17.62',0.18,NULL,NULL,NULL,NULL,NULL,1,209.5074583,22.90392,0,NULL,59461815060,929090860,14517044,17.62),(115401,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115401,37.06,0.46,258,50574,70,NULL,NULL,'MCG +09-23-022',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000232,NULL,'15.3g',0.44,'E0',NULL,NULL,NULL,NULL,1,209.508833,53.01708,0,NULL,59219036957,925297452,14457772,15.3),(115402,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115402,36.95,0.46,246,50575,70,NULL,NULL,'2MASX J13580235+3811549',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000199,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,209.5099583,38.19872,0,NULL,59154497943,924289030,14442016,16.3),(115403,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115403,34.86,0.63,93.9,50576,NULL,NULL,'Malmquist cor.','ESO 325- G 038',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.90',0.8,'Sc',NULL,NULL,NULL,NULL,1,209.5097917,-40.82722,0.265,NULL,46924357226,733193081,11456141,14.9),(115404,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115404,34.96,0.6,98.2,50576,NULL,NULL,NULL,'ESO 325- G 038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115405,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115405,35,0.2,100,50576,74.4,NULL,NULL,'ESO 325- G 038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115406,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115406,38.17,0.46,431,50577,70,NULL,NULL,'2MASX J13580248+0956427',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,209.51025,9.94522,0.042,NULL,58463291039,913488922,14273264,17.6),(115407,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115407,35.31,0.63,115,50578,70,NULL,NULL,'2MASX J13580257-1542555',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,209.510625,-15.71558,0.249,NULL,43686981257,682609082,10665766,16),(115408,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115408,37.59,0.23,330,50579,70,NULL,NULL,'2MASX J13580258+2301116',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.36',0.17,NULL,NULL,NULL,NULL,NULL,1,209.510833,23.01981,0,NULL,59461822701,929090979,14517046,18.36),(115409,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115409,38.15,0.27,426,50580,70,NULL,NULL,'2MASX J13580316+1744311',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.41',0.16,NULL,NULL,NULL,NULL,NULL,1,209.5132083,17.74203,0.033,NULL,58374206797,912096981,14251515,18.41),(115410,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115410,36.96,0.23,247,50581,70,NULL,NULL,'UGC 08888 NED03',NULL,'2015arXiv151105856S',2015,1,2.29,NULL,'G',0.0002,NULL,'13.9',0.69,'AGN',NULL,NULL,NULL,NULL,1,209.513625,20.61903,0.056,NULL,58327197993,911362468,14240038,13.9),(115411,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115411,38.03,0.33,403,50582,70,NULL,NULL,'SDSS J135803.65+094800.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.0g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.51525,9.80006,0.053,NULL,58462504926,913476639,14273072,18),(115412,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115412,37.87,0.15,374,50583,70,NULL,NULL,'2MASX J13580373+2804371',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000176,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,209.5157917,28.07681,0,NULL,60009551236,937649238,14650769,16.5),(115413,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115413,37.22,0.33,278,50584,70,NULL,NULL,'2MASX J13580456+1631421',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.70',0.16,NULL,NULL,NULL,NULL,NULL,1,209.519125,16.52839,0.01,NULL,58383975059,912249610,14253900,18.7),(115414,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115414,36.98,0.19,249,50585,70,NULL,NULL,'2MASX J13580505+5816443',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000209,NULL,'16.1g',0.43,NULL,NULL,NULL,NULL,NULL,1,209.520875,58.27897,0,NULL,57296332288,895255192,13988362,16.1),(115415,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115415,35.78,0.2,143,50586,74.4,NULL,NULL,'UGC 08889',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000033,NULL,'14.70',0.7,'S?',NULL,NULL,NULL,NULL,1,209.523625,21.7975,0.018,NULL,59473322803,929270668,14519854,14.7),(115416,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115416,38.53,0.46,508,50587,70,NULL,NULL,'SDSS J135805.94+033007.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'17.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,209.5247917,3.50211,0.057,NULL,58407122043,912611281,14259551,17.9),(115417,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115417,37.18,0.23,273,50588,70,NULL,NULL,'2MASX J13580605+2140206',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.0002,NULL,'15.6g',0.49,NULL,NULL,NULL,'radio jet',NULL,1,209.52525,21.67258,0.025,NULL,59473293834,929270216,14519847,15.6),(115418,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115418,36.42,0.46,192,50589,70,NULL,NULL,'SDSS J135806.55+143505.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.34',0.16,NULL,NULL,NULL,NULL,NULL,1,209.5272917,14.58492,0,NULL,58371166823,912049481,14250773,18.34),(115419,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115419,37.84,0.33,370,50590,70,NULL,NULL,'2MASX J13580810+0601417',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,209.533667,6.02825,0.023,NULL,58477134216,913705222,14276644,17.4),(115420,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115420,37.86,0.23,374,50591,70,NULL,NULL,'2MASX J13580829+0814327',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,209.534625,8.24239,0,NULL,58457662804,913400981,14271890,17.9),(115421,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115421,37.11,0.46,265,50592,70,NULL,NULL,'2MASX J13580936+6143013',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000201,NULL,'16.1g',0.32,'S0',NULL,NULL,NULL,NULL,1,209.538833,61.71717,0,NULL,57264263060,894754110,13980532,16.1),(115422,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115422,37.18,0.23,273,50593,70,NULL,NULL,'2MASX J13580943+2136277',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.33',0.15,NULL,NULL,NULL,NULL,NULL,1,209.539333,21.60769,0.028,NULL,59473356370,929271193,14519862,18.33),(115423,'GRB','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115423,43.15,0.22,2510,50594,73,NULL,'H const./H=100','GRB 020405',0.7,'2010JCAP...08..020W',2010,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Ulysses/MO/SAX',NULL,NULL,NULL,NULL,1,209.541667,-31.38333,0.289,NULL,46850475236,732038675,11438104,NULL),(115424,'GRB','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115424,43.99,0.67,2700,50594,73,NULL,'H const./H=100','GRB 020405',0.7,'2006astro.ph..9262M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115425,'GRB','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115425,43.47,0.46,2910,50594,69.7,NULL,'Calibrated','GRB 020405',0.7,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115426,'GRB','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115426,43.48,0.52,2920,50594,69.7,NULL,'Fiducial','GRB 020405',0.7,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115427,'GRB','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115427,43.55,0.52,3020,50594,72,NULL,NULL,'GRB 020405',0.7,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115428,'GRB','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115428,43.68,0.51,3200,50594,70,NULL,NULL,'GRB 020405',0.7,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115429,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115429,38.55,0.33,514,50595,70,NULL,NULL,'SDSS J135810.48+313009.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.543666667,31.50258,0,NULL,59127319873,923864373,14435380,18.3),(115430,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115430,37.59,0.33,329,50596,70,NULL,NULL,'2MASX J13581472+1820457',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000067,NULL,'13.9',0.22,NULL,NULL,NULL,NULL,NULL,1,209.5614583,18.34617,0.037,NULL,58328575881,911383998,14240374,13.9),(115431,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115431,37.99,0.46,396,50597,70,NULL,NULL,'2MASX J13581505+0254306',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000094,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,209.562583333,2.90842,0.037,NULL,58414725891,912730092,14261407,17.1),(115432,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115432,37.85,0.16,372,50598,70,NULL,NULL,'SDSS J135815.49+492900.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000138,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,209.564583,49.48336,0,NULL,59242554545,925664914,14463514,18.1),(115433,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115433,38.8,0.46,575,50599,70,NULL,NULL,'SDSS J135815.69-015014.7',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000179,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,209.565375,-1.83742,0.149,NULL,43600333491,681255210,10644612,17.9),(115434,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115434,37.38,0.46,299,50600,70,NULL,NULL,'2MASX J13581600+3848369',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.00012,NULL,'15.7g',0.4,'E0',NULL,NULL,NULL,NULL,1,209.566833,38.81022,0,NULL,59140989645,924077963,14438718,15.7),(115435,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115435,33.31,0.4,45.9,50601,NULL,NULL,'mean','NGC 5402',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00012,NULL,'14.72',0.3,'S?',NULL,NULL,NULL,NULL,1,209.5689583,59.81456,0.005,NULL,57277178276,894955910,13983686,14.72),(115436,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115436,33.36,0.49,46.9,50601,75,NULL,'IR','NGC 5402',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115437,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115437,33.55,0.47,51.4,50601,NULL,NULL,'H','NGC 5402',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115438,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115438,36.86,0.46,235,50602,70,NULL,NULL,'2MASX J13581766+2728491',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'18.26',0.2,NULL,NULL,NULL,NULL,NULL,1,209.5735417,27.48022,0,NULL,60009959622,937655619,14650869,18.26),(115439,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115439,37.86,0.23,374,50603,70,NULL,NULL,'2MASX J13581820+0804128',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,209.5759583,8.07019,0,NULL,58513058343,914266536,14285414,17.5),(115440,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115440,37.59,0.33,329,50604,70,NULL,NULL,'2MASX J13581851+1822327',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,209.577083,18.37575,0.037,NULL,58328605841,911384466,14240382,17.4),(115441,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115441,35.58,0.46,131,50605,70,NULL,NULL,'2MASX J13581903+6515290',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000078,NULL,'15.9g',0.38,'S0',NULL,NULL,NULL,NULL,1,209.579125,65.25806,0.053,NULL,57865856531,904154008,14127406,15.9),(115442,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115442,38.31,0.46,460,50606,70,NULL,NULL,'2MASX J13581954+3900039',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,209.5815,39.00111,0,NULL,59140898669,924076541,14438695,17.8),(115443,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115443,38.05,0.46,408,50607,70,NULL,NULL,'SDSS J135819.80-010411.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000066,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,209.5825,-1.07,0.177,NULL,43594663580,681166618,10643228,18.4),(115444,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115444,37.79,0.46,362,50608,70,NULL,NULL,'2MASX J13582076+2343417',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,209.5865,23.72833,0,NULL,59461351000,929083609,14516931,17.4),(115445,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115445,36.8,0.46,230,50609,70,NULL,NULL,'2MASX J13582077+5912204',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,209.586625,59.20578,0.005,NULL,57274214785,894909606,13982962,16.6),(115446,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115446,35.8,0.49,144,50610,75,NULL,'IR','ESO 325- G 039',NULL,'2011yCatp016004901K',2011,1,1.01,NULL,'G',0.000033,NULL,'16.50',0.11,'Scd',NULL,NULL,NULL,NULL,1,209.5935417,-41.55169,0.217,NULL,46923241742,733175652,11455869,16.5),(115447,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115447,35.97,0.38,156,50610,NULL,NULL,'Malmquist cor.','ESO 325- G 039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115448,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115448,36.12,NULL,167,50610,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 325- G 039',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115449,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115449,36.13,NULL,168,50610,NULL,NULL,NULL,'ESO 325- G 039',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115450,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115450,36.13,NULL,169,50610,NULL,NULL,'Dipole + Quadrupole','ESO 325- G 039',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115451,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115451,36.16,NULL,171,50610,NULL,NULL,'Dipole','ESO 325- G 039',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115452,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115452,36.24,0.34,177,50610,NULL,NULL,NULL,'ESO 325- G 039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115453,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115453,36.28,0.2,180,50610,74.4,NULL,NULL,'ESO 325- G 039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115454,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115454,33.7,0.2,55,50611,74.4,NULL,NULL,'IC 0967',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00003,NULL,'14.7',0.3,'Spiral',NULL,NULL,NULL,NULL,1,209.595625,14.45725,0,NULL,58371166102,912049470,14250772,14.7),(115455,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115455,32.44,0.4,30.8,50612,75,NULL,NULL,'KUG 1356+257',NULL,'2008Ap.....51..336K',2008,1,0.83,NULL,'G',0.00001,NULL,'15.3g',0.25,'S?',NULL,NULL,NULL,NULL,1,209.5990417,25.54986,0,NULL,59996752362,937449255,14647644,15.3),(115456,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115456,33.23,0.58,44.2,50612,NULL,NULL,NULL,'KUG 1356+257',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115457,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115457,33.29,0.2,45.5,50612,74.4,NULL,NULL,'KUG 1356+257',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115458,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115458,33.48,0.49,49.6,50612,75,NULL,'IR','KUG 1356+257',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115459,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115459,33.59,0.49,52.3,50612,NULL,NULL,'Malmquist cor.','KUG 1356+257',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115460,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115460,37.84,0.33,370,50613,70,NULL,NULL,'SDSS J135824.09+055548.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.600375,5.93006,0.023,NULL,58477209158,913706393,14276662,18.2),(115461,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115461,33.91,0.49,60.5,50614,75,NULL,'IR','NGC 5387',NULL,'2011yCatp016004901K',2011,1,1.8,NULL,'G',0.000033,NULL,'14.64',0.3,'Sbc: sp',NULL,NULL,NULL,NULL,1,209.603291667,6.07128,0.023,NULL,58510653543,914228961,14284827,14.64),(115462,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115462,34.26,0.2,71.1,50614,74.4,NULL,NULL,'NGC 5387',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115463,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115463,34.38,0.47,75.3,50614,NULL,NULL,NULL,'NGC 5387',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115464,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115464,34.46,0.4,78,50614,NULL,NULL,'mean','NGC 5387',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115465,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115465,34.47,0.47,78.3,50614,NULL,NULL,'H','NGC 5387',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115466,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115466,34.5,0.45,79.3,50614,NULL,NULL,'Malmquist cor.','NGC 5387',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115467,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115467,34.57,0.45,82,50614,NULL,NULL,'K','NGC 5387',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115468,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115468,34.61,0.46,83.5,50614,NULL,NULL,'J','NGC 5387',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115469,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115469,37.64,0.46,337,50615,70,NULL,NULL,'2MASX J13582506+2046468',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.43',0.15,NULL,NULL,NULL,NULL,NULL,1,209.6045,20.77981,0.056,NULL,59464854573,929138352,14517786,18.43),(115470,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115470,32.96,0.46,39.1,50616,70,NULL,NULL,'IC 4352',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.000087,NULL,'13.57',0.7,'Sab:',NULL,NULL,NULL,NULL,1,209.604667,-34.51733,0.217,NULL,46883845764,732560090,11446251,13.57),(115471,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115471,35.66,0.79,136,50617,70,NULL,NULL,'2MASX J13582540-1517135',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,209.605917,-15.28703,0.249,NULL,43685051352,682578927,10665295,15.1),(115472,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115472,34.06,0.49,64.9,50618,75,NULL,'IR','ESO 445- G 085',NULL,'2011yCatp016004901K',2011,1,1.62,NULL,'G',0.000023,NULL,'16.30',0.11,'Scd',NULL,NULL,NULL,NULL,1,209.616167,-31.77622,0.289,NULL,46850435837,732038059,11438094,16.3),(115473,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115473,34.16,NULL,67.9,50618,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 445- G 085',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115474,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115474,34.17,NULL,68.3,50618,NULL,NULL,'Dipole + Quadrupole','ESO 445- G 085',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115475,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115475,34.19,NULL,68.7,50618,NULL,NULL,'Dipole','ESO 445- G 085',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115476,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115476,34.2,0.14,69.3,50618,NULL,NULL,NULL,'ESO 445- G 085',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115477,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115477,34.24,NULL,70.4,50618,NULL,NULL,NULL,'ESO 445- G 085',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115478,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115478,34.3,0.43,72.6,50618,75,NULL,'3.6 micron, color + selection bias corrected','ESO 445- G 085',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115479,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115479,34.45,0.43,77.5,50618,75,NULL,'3.6 micron, color corrected','ESO 445- G 085',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115480,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115480,34.47,0.2,78.3,50618,74.4,NULL,NULL,'ESO 445- G 085',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115481,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115481,36.96,0.23,247,50619,70,NULL,NULL,'2MASX J13582835+2037015',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.77',0.18,NULL,NULL,NULL,NULL,NULL,1,209.618167,20.61711,0.056,NULL,59464819313,929137801,14517778,17.77),(115482,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115482,37.86,0.23,374,50620,70,NULL,NULL,'2MASX J13582855+0814373',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000097,NULL,'18.58',0.13,NULL,NULL,NULL,NULL,NULL,1,209.618833,8.24375,0,NULL,58513046736,914266355,14285411,18.58),(115483,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115483,36.34,0.46,185,50621,70,NULL,NULL,'2MASX J13582851-0141166',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000178,NULL,'16.1g',0.36,'S0',NULL,NULL,NULL,NULL,1,209.618875,-1.68806,0.153,NULL,43592766224,681136972,10642765,16.1),(115484,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115484,37.28,0.46,286,50622,70,NULL,NULL,'2MASX J13582875+0656353',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.83',0.18,NULL,NULL,NULL,NULL,NULL,1,209.619916667,6.94311,0.038,NULL,58511278029,914238719,14284979,17.83),(115485,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115485,37.85,0.16,372,50623,70,NULL,NULL,'SDSS J135829.01+493446.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,209.620875,49.57961,0.021,NULL,59242689913,925667029,14463547,17.6),(115486,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115486,35.2,0.46,109,50624,70,NULL,NULL,'CGCG 103-032',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000197,NULL,'15.2',1,NULL,'Group member',NULL,NULL,NULL,1,209.6222917,17.39192,0.042,NULL,58373535276,912086488,14251351,15.2),(115487,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115487,36.29,0.33,181,50625,70,NULL,NULL,'2MASX J13582939+5541534',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00018,NULL,'16.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,209.6224583,55.69833,0,NULL,57301527785,895336371,13989630,16.3),(115488,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115488,37.86,0.23,374,50626,70,NULL,NULL,'2MASX J13583037+0808373',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,209.6265417,8.14381,0,NULL,58513091417,914267053,14285422,17.5),(115489,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115489,35.71,0.63,138,50627,70,NULL,NULL,'IC 4354',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.7b',0.2,NULL,NULL,NULL,NULL,NULL,1,209.62875,-12.60536,0.177,NULL,43663576790,682243387,10660052,15.7),(115490,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115490,37.76,0.46,357,50628,70,NULL,NULL,'2MASX J13583138+3534213',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000143,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,209.630583,35.57258,0,NULL,59153903297,924279739,14441870,18.3),(115491,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115491,38.91,0.46,606,50629,70,NULL,NULL,'2MASX J13583266+3844554',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.636083,38.74864,0,NULL,59140938345,924077161,14438705,18.2),(115492,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115492,38.59,0.46,522,50630,70,NULL,NULL,'2MASX J13583287+1515271',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,209.6370417,15.25753,0,NULL,58383165643,912236963,14253702,17.3),(115493,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115493,32.58,0.69,32.9,50631,100,NULL,'mid-IR','NGC 5394',NULL,'2013ApJ...771...88L',2013,1,1.7,'Multiple SDSS entries describe this object.','G',0.000007,NULL,'13.7',1,'SB(s)b pec;HII LIRG','Pair member (points to parent)',NULL,NULL,NULL,1,209.6402083,37.45347,0,NULL,59155119786,924298746,14442167,13.7),(115494,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115494,37.49,0.46,314,50632,70,NULL,NULL,'2MASX J13583379+5829423',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000174,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,209.6405,58.49506,0,NULL,57265890079,894779532,13980930,16.5),(115495,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115495,37.85,0.16,372,50633,70,NULL,NULL,'2MASX J13583401+4935497',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,209.641625,49.59719,0.021,NULL,59242690420,925667037,14463547,17.2),(115496,'IRAS','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115496,32.32,0.8,29.1,50634,75,NULL,'MAT, I','ESO 221- G 021',NULL,'1997ApJS..109..333W',1997,1,1.6,'Confused HIPASS source','G',0.000033,NULL,'14.90',0.5,'S.../Irr',NULL,NULL,NULL,NULL,1,209.641791667,-48.525,0.737,NULL,46826959863,731671247,11432363,14.9),(115497,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115497,32.85,0.4,37.1,50634,NULL,NULL,'mean','ESO 221- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115498,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115498,33.04,0.47,40.6,50634,NULL,NULL,'H','ESO 221- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115499,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115499,33.04,0.32,40.6,50634,85,NULL,'I, raw','ESO 221- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115500,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115500,33.07,0.32,41.1,50634,85,NULL,'I, inv','ESO 221- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115501,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115501,33.08,0.45,41.2,50634,NULL,NULL,'K','ESO 221- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115502,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115502,33.12,0.43,42.1,50634,75,NULL,'MAT, I, raw','ESO 221- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115503,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115503,33.13,0.46,42.3,50634,NULL,NULL,'J','ESO 221- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115504,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115504,33.28,0.43,45.3,50634,75,NULL,'MAT, I, inv','ESO 221- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115505,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115505,33.32,0.49,46.1,50634,75,NULL,'IR','ESO 221- G 021',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115506,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115506,33.36,0.43,46.9,50634,75,NULL,'MAT, I, cor','ESO 221- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115507,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115507,38.09,0.46,414,50635,70,NULL,NULL,'SDSS J135835.94+142622.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.6497917,14.43972,0,NULL,58371276862,912051200,14250800,18),(115508,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115508,38.57,0.46,518,50636,70,NULL,NULL,'2MASX J13583598-0142216',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,209.6499583,-1.70597,0.153,NULL,43600371752,681255808,10644622,17.8),(115509,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115509,37.4,0.46,302,50637,70,NULL,NULL,'SDSS J135836.56+192517.5',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.96',0.2,NULL,NULL,NULL,NULL,NULL,1,209.652375,19.42156,0.06,NULL,58330053836,911407091,14240735,17.96),(115510,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115510,38.48,0.33,497,50638,70,NULL,NULL,'2MASX J13583670+3520513',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,209.652875,35.34739,0,NULL,59149451079,924210173,14440783,18.2),(115511,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115511,37.87,0.15,374,50639,70,NULL,NULL,'2MASX J13583678+2808231',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000073,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.6532917,28.13975,0,NULL,60009602350,937650036,14650781,17.7),(115512,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115512,36.96,0.23,247,50640,70,NULL,NULL,'2MASXi J1358368+205249',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.12',0.16,NULL,NULL,NULL,NULL,NULL,1,209.653583,20.88058,0.038,NULL,59464979975,929140312,14517817,18.12),(115513,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115513,33.6,0.4,52.5,50641,NULL,NULL,'mean','NGC 5395',NULL,'2007A&A...465...71T',2007,1,3.31,'The Bologna position is 9 arcsec west of the nucleus.','G',0.00001,NULL,'12.8g',1.03,'SA(s)b pec     Sy2','Pair member (points to parent)',NULL,NULL,'Sy 2',1,209.65825,37.42447,0,NULL,59155119337,924298739,14442167,12.8),(115514,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115514,33.8,0.46,57.6,50641,NULL,NULL,'J','NGC 5395',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115515,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115515,33.8,0.47,57.6,50641,NULL,NULL,'H','NGC 5395',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115516,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115516,33.81,0.45,57.8,50641,NULL,NULL,'K','NGC 5395',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115517,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115517,37.42,0.46,305,50642,70,NULL,NULL,'2MASX J13583814+2538041',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000175,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,209.658917,25.63442,0,NULL,59996885199,937451331,14647677,16.7),(115518,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115518,37.2,0.46,276,50643,70,NULL,NULL,'2MASX J13583855+3850234',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,209.660583,38.83981,0,NULL,59140907655,924076682,14438698,17.1),(115519,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115519,33.89,0.49,60,50644,75,NULL,'IR','UGC 08896',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.00003,NULL,'15.06',0.2,'S?','Group member',NULL,NULL,NULL,1,209.660666667,7.21656,0.026,NULL,58511100883,914235951,14284936,15.06),(115520,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115520,37.86,0.46,374,50645,70,NULL,NULL,'2MASX J13583994+5709253',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000167,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.666083,57.15697,0.009,NULL,57310139314,895470926,13991733,17.9),(115521,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115521,37.87,0.46,375,50646,70,NULL,NULL,'SDSS J135840.02+053000.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.66675,5.50011,0.013,NULL,58477113594,913704899,14276639,18.4),(115522,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115522,37.59,0.23,330,50647,70,NULL,NULL,'2MASX J13584021+2303045',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.38',0.16,NULL,NULL,NULL,NULL,NULL,1,209.667583,23.05119,0,NULL,59461836840,929091200,14517050,18.38),(115523,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115523,33.3,0.23,45.7,50648,74.4,NULL,NULL,'ABELL S0753:[WFC91] 010',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.0001,NULL,'15.29',0.5,'S0',NULL,NULL,NULL,NULL,1,209.6704583,-33.46844,0.217,NULL,46880582757,732509105,11445454,15.29),(115524,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115524,34.18,0.55,68.4,50648,70,NULL,NULL,'ABELL S0753:[WFC91] 010',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115525,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115525,34.73,NULL,88.2,50649,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08897',NULL,'2010Ap&SS.325..163P',2010,1,1.12,NULL,'G',0.000007,NULL,'15.90',0.13,'Sbc',NULL,NULL,NULL,NULL,1,209.671833,12.59447,0,NULL,58338656806,911541512,14242836,15.9),(115526,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115526,34.74,NULL,88.9,50649,NULL,NULL,'Dipole + Quadrupole','UGC 08897',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115527,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115527,34.75,NULL,89.2,50649,NULL,NULL,'Dipole','UGC 08897',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115528,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115528,34.78,0.42,90.2,50649,NULL,NULL,NULL,'UGC 08897',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115529,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115529,34.79,0.49,90.9,50649,75,NULL,'IR','UGC 08897',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115530,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115530,34.83,0.41,92.4,50649,NULL,NULL,'Malmquist cor.','UGC 08897',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115531,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115531,34.86,0.2,93.8,50649,74.4,NULL,NULL,'UGC 08897',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115532,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115532,37.88,0.46,376,50650,70,NULL,NULL,'2MASX J13584181+0843073',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000093,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,209.674208333,8.71881,0.01,NULL,58512867419,914263553,14285368,17.1),(115533,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115533,36.97,0.46,248,50651,70,NULL,NULL,'2MASX J13584220+4307279',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,209.676,43.12439,0,NULL,59264296224,926004628,14468822,16.9),(115534,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115534,37.39,0.33,300,50652,70,NULL,NULL,'2MASX J13584315+2816071',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00008,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,209.6797917,28.2685,0,NULL,60005182541,937580977,14649702,17.9),(115535,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115535,37.95,0.46,388,50653,70,NULL,NULL,'2MASX J13584313+6623087',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000075,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,209.679917,66.38583,0.045,NULL,57871784800,904246637,14128853,17.6),(115536,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115536,36.95,0.46,245,50654,70,NULL,NULL,'2MASX J13584390+2018056',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.94',0.2,NULL,NULL,NULL,NULL,NULL,1,209.6830417,20.30161,0.047,NULL,58327903988,911373499,14240210,17.94),(115537,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115537,35.11,NULL,105,50655,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08895',NULL,'2010Ap&SS.325..163P',2010,1,1.52,NULL,'G',0.000018,NULL,'15.9g',0.22,'Sd(f)',NULL,NULL,NULL,NULL,1,209.686083,2.45672,0.053,NULL,58414916610,912733072,14261454,15.9),(115538,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115538,35.12,0.49,106,50655,75,NULL,'IR','UGC 08895',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115539,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115539,35.13,NULL,106,50655,NULL,NULL,'Dipole','UGC 08895',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115540,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115540,35.13,NULL,106,50655,NULL,NULL,'Dipole + Quadrupole','UGC 08895',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115541,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115541,35.19,NULL,109,50655,NULL,NULL,NULL,'UGC 08895',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115542,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115542,35.24,0.41,112,50655,NULL,NULL,'Malmquist cor.','UGC 08895',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115543,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115543,35.4,0.2,120,50655,74.4,NULL,NULL,'UGC 08895',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115544,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115544,35.55,0.35,129,50655,NULL,NULL,NULL,'UGC 08895',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115545,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115545,36.06,0.46,163,50656,70,NULL,NULL,'IC 4356',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000167,NULL,'15.7g',0.39,'S0',NULL,NULL,NULL,NULL,1,209.687917,37.49067,0,NULL,59155109348,924298583,14442165,15.7),(115546,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115546,34.44,0.46,77.3,50657,70,NULL,NULL,'CGCG 046-028',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000083,NULL,'14.6g',0.67,'E',NULL,NULL,NULL,NULL,1,209.690083,2.84425,0.033,NULL,58414830076,912731719,14261433,14.6),(115547,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115547,37.05,0.23,257,50658,70,NULL,NULL,'2MASX J13584576+2757058',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000083,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,209.690625,27.95161,0,NULL,60009568149,937649502,14650773,16.9),(115548,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115548,38.48,0.33,497,50659,70,NULL,NULL,'2MASX J13584636+3526232',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000187,NULL,'16.1g',0.42,'BrClG',NULL,NULL,NULL,NULL,1,209.693125,35.43981,0,NULL,59149424204,924209753,14440777,16.1),(115549,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115549,37.66,0.46,341,50660,70,NULL,NULL,'2MASX J13584647+4230319',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,209.693583,42.50897,0,NULL,59272778449,926137163,14470893,17.1),(115550,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115550,38.14,0.33,425,50661,70,NULL,NULL,'SDSS J135847.16+561704.4',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000143,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,209.696541667,56.28456,0,NULL,57309303438,895457866,13991529,17.6),(115551,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115551,37.99,0.46,396,50662,70,NULL,NULL,'2MASX J13584790+3705184',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000135,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,209.699625,37.0885,0,NULL,59155656712,924307136,14442299,17.8),(115552,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115552,37.08,0.46,260,50663,70,NULL,NULL,'2MASX J13584828+1519581',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,209.7010417,15.33281,0,NULL,58383380172,912240315,14253754,17.7),(115553,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115553,36.07,0.33,164,50664,70,NULL,NULL,'2MASX J13584864+0019292',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000083,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,209.702667,0.32483,0.117,NULL,58411679320,912682489,14260663,16.3),(115554,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115554,37.49,0.21,314,50665,70,NULL,NULL,'2MASX J13584877+2835288',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000013,NULL,'15.9g',0.42,NULL,NULL,NULL,NULL,NULL,1,209.703125,28.59136,0,NULL,60005236037,937581813,14649715,15.9),(115555,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115555,36.02,0.46,160,50666,70,NULL,NULL,'2MASX J13584964+6455341',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000094,NULL,'16.0g',0.29,'S0',NULL,NULL,NULL,NULL,1,209.706625,64.92611,0.021,NULL,57934228957,905222327,14144098,16),(115556,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115556,38.14,0.33,425,50667,70,NULL,NULL,'2MASX J13584719+5617042',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,209.708833,56.28608,0,NULL,57309306639,895457916,13991529,18.3),(115557,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115557,38.04,0.46,405,50668,70,NULL,NULL,'2MASX J13585017+0351412',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000178,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,209.709125,3.8615,0.053,NULL,58409713139,912651767,14260183,16.8),(115558,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115558,37.18,0.23,273,50669,70,NULL,NULL,'2MASX J13585100+2136456',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000127,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,209.712583333,21.61261,0.021,NULL,59473337775,929270902,14519857,16.4),(115559,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115559,37.78,0.46,360,50670,70,NULL,NULL,'2MASX J13585101+2527188',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000219,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,209.712625,25.45517,0,NULL,59996718346,937448724,14647636,16.6),(115560,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115560,36.13,0.46,168,50671,70,NULL,NULL,'2MASX J13585107+1604081',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.51',0.17,NULL,NULL,NULL,NULL,NULL,1,209.712917,16.06897,0,NULL,58383007225,912234487,14253663,18.51),(115561,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115561,33.91,0.23,60.5,50672,74.4,NULL,NULL,'ABELL S0753:[WFC91] 012',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000043,NULL,'14.84',0.9,'S0',NULL,NULL,NULL,NULL,1,209.713583,-33.48989,0.217,NULL,46880580362,732509068,11445454,14.84),(115562,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115562,37.61,0.46,332,50673,70,NULL,NULL,'SDSS J135851.28+080010.7',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.7137083,8.003,0,NULL,58513075566,914266805,14285418,17.6),(115563,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115563,35.22,0.51,110,50674,70,NULL,NULL,'2MASX J13585173-4937302',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.7b',0.22,NULL,NULL,NULL,NULL,NULL,1,209.7152083,-49.62506,0.977,NULL,46826479102,731663735,11432245,16.7),(115564,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115564,37.55,0.33,323,50675,70,NULL,NULL,'2MASX J13585199+5855225',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000185,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,209.71675,58.92308,0,NULL,57273477589,894898087,13982782,16.9),(115565,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115565,38.05,0.46,407,50676,70,NULL,NULL,'2MASXi J1358521-021335',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000189,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,209.716833,-2.22658,0.149,NULL,43600486116,681257595,10644649,17.8),(115566,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115566,37.87,0.15,374,50677,70,NULL,NULL,'2MASX J13585257+2748348',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000127,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,209.718917,27.80967,0,NULL,60009563656,937649432,14650772,17.7),(115567,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115567,38.51,0.46,503,50678,70,NULL,NULL,'2MASX J13585299+2942568',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,209.720667,29.71586,0,NULL,60007590074,937618594,14650290,18.1),(115568,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115568,37.61,0.46,332,50679,70,NULL,NULL,'2MASX J13585401+4501210',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,209.7250417,45.02256,0,NULL,59235858079,925560282,14461879,17.6),(115569,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115569,36.29,0.33,181,50680,70,NULL,NULL,'2MASX J13585433+5533426',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000189,NULL,'15.5g',0.44,'S0',NULL,NULL,NULL,NULL,1,209.726167,55.56181,0,NULL,57301484058,895335688,13989620,15.5),(115570,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115570,37.64,0.33,337,50681,70,NULL,NULL,'2MASX J13585435+6100450',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,209.7265417,61.01258,0.017,NULL,57263513446,894742397,13980349,17.3),(115571,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115571,34.61,0.46,83.6,50682,70,NULL,NULL,'MCG +06-31-037',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000168,NULL,'15.2g',0.57,NULL,NULL,NULL,NULL,NULL,1,209.727125,35.25556,0,NULL,59149409361,924209521,14440773,15.2),(115572,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115572,36.43,0.46,193,50683,70,NULL,NULL,'2MASX J13585450+3352111',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,209.7272083,33.86972,0,NULL,59151887037,924248234,14441378,16.4),(115573,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115573,33.41,0.2,48.1,50684,74.4,NULL,NULL,'UGC 08899',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000033,NULL,'15.16',0.5,'Sbc',NULL,NULL,NULL,NULL,1,209.7305,21.9885,0.006,NULL,59474000930,929281264,14520019,15.16),(115574,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115574,33.45,0.43,48.9,50684,75,NULL,'3.6 micron, color corrected','UGC 08899',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115575,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115575,33.46,0.43,49.2,50684,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08899',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115576,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115576,37.85,0.16,372,50685,70,NULL,NULL,'SDSS J135855.45+493059.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000135,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,209.731083,49.51656,0.021,NULL,59242698772,925667168,14463549,18.4),(115577,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115577,37.3,0.46,289,50686,70,NULL,NULL,'2MASX J13585798+5354146',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,209.741416667,53.90422,0,NULL,57282373684,895037088,13984954,17.4),(115578,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115578,37.94,0.46,388,50687,70,NULL,NULL,'2MASX J13585829+6230170',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000194,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,209.743125,62.50464,0.021,NULL,57747652014,902307062,14098547,17.1),(115579,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115579,36.98,0.19,249,50688,70,NULL,NULL,'2MASX J13585854+5819486',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000183,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,209.743666667,58.33008,0,NULL,57296328359,895255130,13988361,16.3),(115580,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115580,37.87,0.15,374,50689,70,NULL,NULL,'2MASX J13585859+2758568',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.744125,27.98242,0,NULL,60009595410,937649928,14650780,18.1),(115581,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115581,37.8,0.46,363,50690,70,NULL,NULL,'2MASX J13585955+2256399',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.40',0.17,NULL,NULL,NULL,NULL,NULL,1,209.7482083,22.94442,0,NULL,59461637121,929088080,14517001,18.4),(115582,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115582,36.19,0.46,173,50691,70,NULL,NULL,'LCRS B135624.4-022300',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00009,NULL,'16.3g',0.33,'S0',NULL,NULL,NULL,NULL,1,209.7482917,-2.62561,0.141,NULL,43600141082,681252204,10644565,16.3),(115583,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115583,36.22,0.65,175,50691,70,NULL,NULL,'LCRS B135624.4-022300',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115584,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115584,36.98,0.19,249,50692,70,NULL,NULL,'2MASX J13585980+5823596',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000217,NULL,'15.5g',0.51,'BrClG',NULL,NULL,NULL,NULL,1,209.748917,58.4,0,NULL,57296344237,895255378,13988365,15.5),(115585,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115585,37.87,0.15,374,50693,70,NULL,NULL,'SDSS J135859.98+275613.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000172,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,209.749916667,27.93714,0,NULL,60009569730,937649527,14650773,17.9),(115586,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115586,37.07,0.46,259,50694,70,NULL,NULL,'2MASX J13590023+1848059',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.750917,18.80156,0.048,NULL,58329575092,911399610,14240618,17.5),(115587,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115587,36.07,0.33,164,50695,70,NULL,NULL,'2MASX J13590151+0014283',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000213,NULL,'16.05',0.47,NULL,NULL,NULL,NULL,NULL,1,209.7562917,0.24122,0.117,NULL,58411698668,912682791,14260668,16.05),(115588,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115588,36.34,0.82,185,50696,70,NULL,NULL,'2MASX J13590199-3543446',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.7I',0.2,NULL,NULL,NULL,NULL,NULL,1,209.758333,-35.72906,0.233,NULL,46890524746,732664449,11447882,14.7),(115589,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115589,34.27,0.47,71.4,50697,NULL,NULL,'H','UGC 08902',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000083,NULL,'14.62',0.4,'Sb:','in a pair',NULL,NULL,NULL,1,209.7615417,15.56567,0,NULL,58383312036,912239250,14253738,14.62),(115590,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115590,34.42,0.45,76.4,50697,NULL,NULL,'K','UGC 08902',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115591,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115591,34.46,0.46,78,50697,NULL,NULL,'J','UGC 08902',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115592,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115592,35.25,0.4,112,50697,NULL,NULL,'mean','UGC 08902',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115593,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115593,35.59,0.44,131,50698,NULL,NULL,'Malmquist cor.','ESO 578- G 011',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000033,NULL,'14.26',0.5,'SB?            HII',NULL,NULL,NULL,NULL,1,209.762375,-19.05856,0.229,NULL,43629133767,681705215,10651643,14.26),(115594,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115594,35.65,0.43,135,50698,NULL,NULL,NULL,'ESO 578- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115595,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115595,35.7,0.2,138,50698,74.4,NULL,NULL,'ESO 578- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115596,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115596,37.6,0.46,332,50699,70,NULL,NULL,'SDSS J135904.06+002818.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000082,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,209.766958333,0.47192,0.121,NULL,58411631682,912681745,14260652,18),(115597,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115597,37.05,0.23,257,50700,70,NULL,NULL,'2MASX J13590432+2756388',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000087,NULL,'17.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,209.7680417,27.94419,0,NULL,60009566941,937649483,14650773,17.4),(115598,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115598,38.1,0.46,416,50701,70,NULL,NULL,'SDSS J135904.47+025333.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000094,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,209.768625,2.89256,0.033,NULL,58414835149,912731799,14261434,18.3),(115599,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115599,37.28,0.33,286,50702,70,NULL,NULL,'2MASX J13590518+0551551',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.55',0.24,NULL,NULL,NULL,NULL,NULL,1,209.7715,5.86519,0.029,NULL,58477155906,913705561,14276649,17.55),(115600,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115600,36.98,0.19,249,50703,70,NULL,NULL,'2MASX J13590565+5815476',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000184,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,209.7732917,58.26317,0,NULL,57296323664,895255057,13988360,16.4),(115601,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115601,37.57,0.27,327,50704,70,NULL,NULL,'2MASX J13590574+0150221',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000076,NULL,'17.5g',0.18,'NLAGN',NULL,NULL,NULL,NULL,1,209.7740417,1.83933,0.065,NULL,58414366133,912724470,14261319,17.5),(115602,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115602,38.07,0.46,411,50705,70,NULL,NULL,'SDSS J135905.94+534607.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000185,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,209.77475,53.76875,0,NULL,57282150582,895033602,13984900,18.7),(115603,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115603,37.1,0.46,263,50706,70,NULL,NULL,'2MASX J13590652+0303281',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000075,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,209.777083,3.05767,0.025,NULL,58407041949,912610030,14259531,16.6),(115604,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115604,36,0.5,159,50707,70,NULL,NULL,'CGCG 018-012',NULL,'2014MNRAS.445.2677S',2014,1,0.91,NULL,'G',0.000083,NULL,'15.4g',0.31,'S0',NULL,NULL,NULL,NULL,1,209.77775,-2.38481,0.149,NULL,43600587573,681259180,10644674,15.4),(115605,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115605,37.08,0.46,260,50708,70,NULL,NULL,'2MASX J13590686-0129180',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00015,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,209.7785417,-1.48839,0.157,NULL,43594547592,681164806,10643200,17),(115606,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115606,37.52,0.19,319,50709,70,NULL,NULL,'2MASX J13590705+3937355',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000174,NULL,'16.4g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,209.779375,39.62672,0,NULL,59260222493,925940976,14467827,16.4),(115607,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115607,37.52,0.19,319,50710,70,NULL,NULL,'2MASX J13590748+3936255',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000172,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.781208333,39.60706,0,NULL,59260222054,925940969,14467827,18.2),(115608,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115608,36.76,0.46,225,50711,70,NULL,NULL,'2MASX J13590797+4606049',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000182,NULL,'16.2g',0.32,NULL,NULL,NULL,NULL,NULL,1,209.783291667,46.1015,0,NULL,59232740405,925511568,14461118,16.2),(115609,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115609,37.87,0.15,374,50712,70,NULL,NULL,'2MASX J13590826+2810458',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000087,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,209.7845,28.17947,0,NULL,60009593429,937649897,14650779,16.6),(115610,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115610,38.09,0.46,414,50713,70,NULL,NULL,'SDSS J135908.32+104301.2',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.8g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.7847083,10.717,0,NULL,58463655796,913494621,14273353,17.8),(115611,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115611,37.05,0.23,257,50714,70,NULL,NULL,'CGCG 162-039',NULL,'2015arXiv151105856S',2015,1,0.95,'87GB source with large sky, narrow minor axis, or very bad confusion.','G',0.000047,NULL,'15.3g',0.41,'BrClG','Group member',NULL,NULL,NULL,1,209.7865,28.02261,0,NULL,60009587574,937649805,14650778,15.3),(115612,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115612,36.02,0.52,160,50715,70,NULL,NULL,'2MASX J13590918-1514179',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.09',NULL,NULL,NULL,NULL,NULL,NULL,1,209.7882083,-15.23842,0.261,NULL,43685203751,682581308,10665332,16.09),(115613,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115613,37.9,0.46,380,50716,70,NULL,NULL,'2MASX J13591008+6527249',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000087,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,209.792208333,65.45706,0.053,NULL,57865702249,904151597,14127368,17),(115614,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115614,36.45,0.46,195,50717,70,NULL,NULL,'2MASX J13591165+2557348',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000161,NULL,'16.0g',0.38,NULL,NULL,NULL,NULL,NULL,1,209.798625,25.95978,0,NULL,59996678336,937448099,14647626,16),(115615,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115615,37.77,0.46,357,50718,70,NULL,NULL,'2MASX J13591234+3813035',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000144,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.80125,38.21778,0,NULL,59141657161,924088393,14438881,18.1),(115616,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115616,38.58,0.46,521,50719,70,NULL,NULL,'2MASX J13591382+1525021',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,209.8077083,15.41719,0,NULL,58383344181,912239752,14253746,17.4),(115617,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115617,38.07,0.46,411,50720,70,NULL,NULL,'2MASX J13591438+3325262',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.14',0.16,NULL,NULL,NULL,NULL,NULL,1,209.809958333,33.42381,0,NULL,59148900481,924201570,14440649,18.14),(115618,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115618,37.39,0.33,300,50721,70,NULL,NULL,'2MASX J13591439+2816358',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000087,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,209.810125,28.27672,0,NULL,60005174488,937580851,14649700,17.8),(115619,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115619,37.49,0.21,314,50722,70,NULL,NULL,'2MASX J13591495+2832198',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000189,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,209.812167,28.53883,0,NULL,60005282299,937582535,14649727,16.5),(115620,'BCG','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115620,37.55,0.35,301,50723,60,NULL,'ABELL 1831, BCG','CGCG 162-041',0.0749,'1980ApJ...241..486H',1980,1,0.95,NULL,'G',0.00009,NULL,'15.7',0.85,'cD;BrClG','Group member',NULL,NULL,NULL,1,209.812875,27.97625,0,NULL,60009685027,937651328,14650802,15.7),(115621,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115621,37.87,0.15,374,50724,70,NULL,NULL,'SDSS J135915.54+275702.6',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000183,NULL,'18.2g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.81475,27.95075,0,NULL,60009685991,937651343,14650802,18.2),(115622,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115622,38.01,0.46,400,50725,70,NULL,NULL,'2MASX J13591721+1932509',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,209.8217917,19.5475,0.058,NULL,58329791535,911402992,14240671,18.1),(115623,'BCG','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115623,37.55,0.35,301,50726,60,NULL,NULL,'ABELL 1831',0.0749,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,209.822917,27.97278,0,NULL,60009730161,937652033,14650813,NULL),(115624,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115624,37.52,0.19,319,50727,70,NULL,NULL,'2MASX J13591847+3940176',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00017,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,209.827083,39.67164,0,NULL,59260220204,925940940,14467827,17.1),(115625,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115625,36.98,0.19,249,50728,70,NULL,NULL,'2MASX J13591876+5805305',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000162,NULL,'15.8g',0.46,'S0^-',NULL,NULL,NULL,NULL,1,209.828583,58.09181,0,NULL,57307935006,895436484,13991195,15.8),(115626,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115626,36.75,0.6,224,50729,70,NULL,NULL,'2MASX J13591933-1818015',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,209.830583,-18.30053,0.257,NULL,43626591220,681665487,10651023,15.4),(115627,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115627,37.85,0.16,372,50730,70,NULL,NULL,'2MASX J13592079+4926508',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000178,NULL,'16.5g',0.36,'BrClG',NULL,NULL,NULL,NULL,1,209.8365417,49.44756,0.021,NULL,59242705139,925667267,14463551,16.5),(115628,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115628,37.58,0.46,328,50731,70,NULL,NULL,'SDSS J135921.22+134757.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000177,NULL,'17.5g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.838416667,13.79939,0,NULL,58371882151,912060658,14250947,17.5),(115629,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115629,37.85,0.16,372,50732,70,NULL,NULL,'SDSS J135921.37+492835.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,209.8390417,49.47647,0.021,NULL,59242705697,925667276,14463551,18.1),(115630,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115630,37.05,0.23,257,50733,70,NULL,NULL,'SDSS J135921.84+275538.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000167,NULL,'18.1g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.8410417,27.92725,0,NULL,60009688369,937651380,14650802,18.1),(115631,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115631,36.35,0.63,186,50734,70,NULL,NULL,'2MASX J13592246-1459053',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,209.8435417,-14.98478,0.261,NULL,43673962432,682405663,10662588,15.3),(115632,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115632,33.79,0.2,57.3,50735,74.4,NULL,NULL,'UGC 08906',NULL,'2013AJ....146...86T',2013,1,1.5,'HOLM 564B is a star.','G',0.000203,NULL,'15.0g',0.44,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,209.84475,5.53867,0.013,NULL,58477952682,913718010,14276843,15),(115633,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115633,36.49,0.7,198,50736,70,NULL,NULL,'LCRS B135643.0-111801',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,209.847667,-11.54231,0.161,NULL,43693006212,682703222,10667237,16.4),(115634,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115634,35.65,0.46,135,50737,70,NULL,NULL,'2MASX J13592355+1242505',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,209.84825,12.71408,0,NULL,58338696537,911542133,14242845,16.4),(115635,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115635,38.18,0.33,433,50738,70,NULL,NULL,'2MASX J13592380+0811412',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,209.849125,8.19478,0,NULL,58513607769,914275121,14285548,17.5),(115636,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115636,37.87,0.15,374,50739,70,NULL,NULL,'SDSS J135924.49+275705.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000177,NULL,'18.1g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.852083,27.95161,0,NULL,60009730543,937652039,14650813,18.1),(115637,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115637,36.09,0.27,165,50740,70,NULL,NULL,'2MASX J13592448+5915345',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000182,NULL,'16.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,209.852083,59.25967,0.021,NULL,57274229732,894909839,13982966,16.3),(115638,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115638,35.35,0.69,117,50741,100,NULL,'mid-IR','UGC 08907',NULL,'2013ApJ...771...88L',2013,1,1.6,NULL,'G',0.000183,NULL,'15.2',0.9,NULL,NULL,NULL,NULL,NULL,1,209.858458333,12.78847,0,NULL,58368070335,912001098,14250017,15.2),(115639,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115639,36.09,0.27,165,50742,70,NULL,NULL,'2MASX J13592616+5914125',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000166,NULL,'16.1g',0.34,'S0/a',NULL,NULL,NULL,NULL,1,209.85925,59.23678,0.021,NULL,57274261512,894910336,13982974,16.1),(115640,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115640,36.36,0.46,187,50743,70,NULL,NULL,'2MASX J13592665+4722324',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000175,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,209.861125,47.37556,0,NULL,59244306656,925692291,14463942,16.2),(115641,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115641,37.82,0.46,366,50744,70,NULL,NULL,'2MASX J13592724+1723325',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'18.01',0.22,NULL,NULL,NULL,NULL,NULL,1,209.863666667,17.39242,0.042,NULL,58373507334,912086052,14251344,18.01),(115642,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115642,37.52,0.19,319,50745,70,NULL,NULL,'2MASX J13592816+3933196',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000186,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,209.867583333,39.55547,0,NULL,59260184322,925940380,14467818,17.2),(115643,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115643,38.21,0.23,438,50746,70,NULL,NULL,'2MASX J13592822+4915258',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,209.867625,49.25731,0.02,NULL,59242644229,925666316,14463536,17.8),(115644,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115644,37.16,0.46,271,50747,70,NULL,NULL,'2MASX J13593041-0217020',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00014,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,209.876583,-2.28381,0.149,NULL,43600576869,681259013,10644672,18.1),(115645,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115645,37.52,0.19,319,50748,70,NULL,NULL,'2MASX J13593051+3940166',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000183,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,209.8772917,39.67122,0,NULL,59260213072,925940829,14467825,16.6),(115646,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115646,37.57,0.27,327,50749,70,NULL,NULL,'SDSS J135930.72+015023.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00008,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,209.878,1.83994,0.065,NULL,58417778157,912777783,14262152,18),(115647,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115647,33.64,0.47,53.4,50750,NULL,NULL,'H','NGC 5399',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000047,NULL,'14.2g',0.5,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,209.880917,34.77358,0,NULL,59151366402,924240100,14441251,14.2),(115648,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115648,33.68,0.45,54.6,50750,NULL,NULL,'K','NGC 5399',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115649,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115649,33.7,0.46,55,50750,NULL,NULL,'J','NGC 5399',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115650,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115650,33.73,0.4,55.8,50750,NULL,NULL,'mean','NGC 5399',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115651,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115651,34.11,0.49,66.3,50750,75,NULL,'IR','NGC 5399',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115652,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115652,34.24,0.44,70.6,50750,NULL,NULL,'Malmquist cor.','NGC 5399',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115653,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115653,34.32,0.2,73.1,50750,74.4,NULL,NULL,'NGC 5399',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115654,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115654,34.37,0.42,74.9,50750,NULL,NULL,NULL,'NGC 5399',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115655,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115655,37.16,0.46,270,50751,70,NULL,NULL,'2MASX J13593224+5842224',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,209.884083,58.70611,0,NULL,57273284986,894895077,13982735,17.7),(115656,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115656,37.52,0.19,319,50752,70,NULL,NULL,'2MASX J13593518+3936326',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,209.896625,39.60922,0,NULL,59260214631,925940853,14467825,17.7),(115657,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115657,37.88,0.46,376,50753,70,NULL,NULL,'2MASX J13593572+5257134',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,209.8985417,52.95358,0,NULL,59215514510,925242414,14456912,17.8),(115658,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115658,37.85,0.16,372,50754,70,NULL,NULL,'2MASX J13593594+4927304',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00014,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,209.8995,49.45856,0.021,NULL,59242703225,925667237,14463550,18.1),(115659,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115659,37.87,0.15,374,50755,70,NULL,NULL,'2MASX J13593664+2805310',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000107,NULL,'16.3g',0.44,NULL,NULL,NULL,NULL,NULL,1,209.902625,28.09208,0,NULL,60009724720,937651948,14650811,16.3),(115660,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115660,38.21,0.23,438,50756,70,NULL,NULL,'2MASX J13593667+4909194',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000183,NULL,'16.5g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,209.902791667,49.15536,0.02,NULL,59243430555,925678602,14463728,16.5),(115661,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115661,38.18,0.33,433,50757,70,NULL,NULL,'2MASX J13593741+0805593',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.8g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,209.9057917,8.09986,0,NULL,58513647350,914275739,14285558,16.8),(115662,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115662,38.16,0.46,430,50758,70,NULL,NULL,'2MASX J13593890+5059255',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000159,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,209.911875,50.99044,0.069,NULL,59217404391,925271943,14457374,17.3),(115663,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115663,36.3,0.7,182,50759,70,NULL,NULL,'2MASX J13593890-2720164',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,209.912125,-27.33783,0.201,NULL,46991686432,734245100,11472579,15.8),(115664,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115664,35.31,0.2,115,50760,74.4,NULL,NULL,'UGC 08911',NULL,'2013AJ....146...86T',2013,1,0.93,NULL,'G',0.000037,NULL,'15.3g',0.6,'Scd:','Group member',NULL,NULL,NULL,1,209.9139583,28.06122,0,NULL,60009725210,937651956,14650811,15.3),(115665,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115665,37.61,0.33,332,50761,70,NULL,NULL,'2MASX J13593938-0153531',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00015,NULL,'16.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,209.914,-1.89797,0.157,NULL,43603299259,681301550,10645336,16.6),(115666,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115666,37.61,0.33,332,50762,70,NULL,NULL,'2MASX J13594045-0153091',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000183,NULL,'16.5g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,209.918416667,-1.88583,0.157,NULL,43603429196,681303581,10645368,16.5),(115667,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115667,37.64,0.33,337,50763,70,NULL,NULL,'SDSS J135941.23+610658.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000159,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,209.921833,61.11636,0.017,NULL,57263459775,894741558,13980336,18.4),(115668,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115668,37.28,0.33,286,50764,70,NULL,NULL,'2MASX J13594152+0557117',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,209.922917,5.95314,0.028,NULL,58477852573,913716446,14276819,17.8),(115669,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115669,37.49,0.21,314,50765,70,NULL,NULL,'2MASX J13594194+2827050',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000185,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,209.924916667,28.45147,0,NULL,60005242559,937581914,14649717,17),(115670,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115670,37.92,0.46,383,50766,70,NULL,NULL,'2MASX J13594213+4201193',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000152,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,209.925417,42.02203,0,NULL,59272723336,926136302,14470879,17.2),(115671,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115671,36.37,0.33,188,50767,70,NULL,NULL,'CGCG 074-028',NULL,'2015arXiv151105856S',2015,1,0.87,NULL,'G',0.000163,NULL,'14.7g',0.66,NULL,NULL,NULL,NULL,NULL,1,209.927583,12.73683,0,NULL,58368093482,912001460,14250022,14.7),(115672,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115672,37.57,0.27,327,50768,70,NULL,NULL,'2MASX J13594299+0152447',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000085,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,209.9292917,1.87914,0.065,NULL,58417957062,912780579,14262196,16.6),(115673,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115673,37.12,0.46,266,50769,70,NULL,NULL,'2MASX J13594357+1218096',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000161,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,209.9314583,12.30258,0,NULL,58338801987,911543781,14242871,16.6),(115674,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115674,36.07,0.46,163,50770,70,NULL,NULL,'2MASX J13594436+1748146',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.78',0.21,NULL,NULL,NULL,NULL,NULL,1,209.935,17.80417,0.037,NULL,58373850054,912091407,14251428,16.78),(115675,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115675,38.15,0.33,427,50771,70,NULL,NULL,'2MASX J13594747+3800506',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000171,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,209.9479583,38.01417,0,NULL,59141152312,924080504,14438757,17.7),(115676,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115676,33.34,0.49,46.6,50772,75,NULL,'IR','UGC 08917',NULL,'2011yCatp016004901K',2011,1,1.66,NULL,'G',0.000137,NULL,'15.1',0.17,'Scd',NULL,NULL,NULL,NULL,1,209.9487917,40.38236,0,NULL,59260003496,925937554,14467774,15.1),(115677,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115677,33.53,0.63,50.9,50772,NULL,NULL,NULL,'UGC 08917',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115678,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115678,33.54,NULL,51.1,50772,NULL,NULL,NULL,'UGC 08917',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115679,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115679,33.58,0.2,52,50772,74.4,NULL,NULL,'UGC 08917',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115680,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115680,33.66,0.59,53.9,50772,NULL,NULL,'Malmquist cor.','UGC 08917',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115681,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115681,33.76,NULL,56.5,50772,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08917',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115682,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115682,33.77,NULL,56.8,50772,NULL,NULL,'Dipole + Quadrupole','UGC 08917',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115683,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115683,33.78,NULL,57,50772,NULL,NULL,'Dipole','UGC 08917',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115684,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115684,33.89,0.49,59.9,50772,75,NULL,'IR','UGC 08917',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115685,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115685,38.12,0.46,421,50773,70,NULL,NULL,'2MASX J13594849+4336533',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,209.952083,43.61472,0,NULL,59264345903,926005404,14468834,17.5),(115686,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115686,38.21,0.23,438,50774,70,NULL,NULL,'2MASX J13594983+4905165',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'16.9g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,209.957417,49.088,0.02,NULL,59243444050,925678813,14463731,16.9),(115687,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115687,38.32,0.46,461,50775,70,NULL,NULL,'SDSS J135950.26+065456.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.959458333,6.91569,0.083,NULL,58514016479,914281507,14285648,18.6),(115688,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115688,38.65,0.46,537,50776,70,NULL,NULL,'2MASX J13595026+1226076',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.959458333,12.43539,0,NULL,58338815420,911543990,14242874,18.4),(115689,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115689,37.81,0.27,365,50777,70,NULL,NULL,'2MASX J13595115+0350147',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000181,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,209.963291667,3.83753,0.057,NULL,58409803054,912653172,14260205,17.1),(115690,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115690,33.06,0.23,40.9,50778,74.4,NULL,NULL,'ABELL S0753:[WFC91] 017',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00005,NULL,'15.17',NULL,'E',NULL,NULL,NULL,NULL,1,209.96425,-34.31725,0.217,NULL,46883320585,732551884,11446123,15.17),(115691,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115691,35.79,0.46,144,50779,70,NULL,NULL,'2MASX J13595148+3216104',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.66',0.21,NULL,NULL,NULL,NULL,NULL,1,209.964583,32.26944,0,NULL,60033110743,938017355,14656521,16.66),(115692,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115692,35.53,0.51,127,50780,70,NULL,NULL,'2MASX J13595165-1650502',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.15',NULL,NULL,NULL,NULL,NULL,NULL,1,209.965083,-16.84753,0.277,NULL,43682669528,682541711,10664714,16.15),(115693,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115693,34.13,0.49,66.9,50781,75,NULL,'IR','2MFGC 11312',NULL,'2011yCatp016004901K',2011,1,NULL,'This is the southeastern part of the galaxy NGC 5403.','PofG',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,209.968875,38.17656,0,NULL,59141173973,924080843,14438763,NULL),(115694,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115694,37.68,0.46,343,50782,70,NULL,NULL,'2MASX J13595354+5807231',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,209.973125,58.12311,0,NULL,57308061080,895438454,13991225,17.7),(115695,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115695,39.22,NULL,697,50783,NULL,NULL,NULL,'NSCS J135935+623032',NULL,'2005ApJ...625..108D',2005,1,NULL,NULL,'GClstr',0.003,NULL,NULL,NULL,'Compact [Zw]',NULL,NULL,NULL,NULL,1,209.97125,62.52111,0.037,NULL,57747528962,902305140,14098517,NULL),(115696,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115696,39.54,0.69,810,50783,NULL,NULL,'Isotherm., r < 100 kpc','NSCS J135935+623032',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115697,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115697,39.69,NULL,866,50783,NULL,NULL,NULL,'NSCS J135935+623032',NULL,'2002ApJ...581...53R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115698,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115698,39.93,NULL,970,50783,NULL,NULL,NULL,'NSCS J135935+623032',NULL,'2011A&A...532A..14C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115699,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115699,40.23,0.68,1110,50783,NULL,NULL,'Isotherm.','NSCS J135935+623032',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115700,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115700,40.27,0.18,1130,50783,NULL,NULL,'Hydrost. Eq.','NSCS J135935+623032',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115701,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115701,40.6,NULL,1320,50783,NULL,NULL,'3.1 (red) calibration','NSCS J135935+623032',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115702,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115702,40.84,NULL,1470,50783,NULL,NULL,'4.2 (black) calibration','NSCS J135935+623032',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115703,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115703,41.09,NULL,1650,50783,NULL,NULL,'4.1 (blue) calibration','NSCS J135935+623032',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115704,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115704,38.15,0.33,427,50784,70,NULL,NULL,'SDSS J135955.59+380147.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,209.981667,38.02989,0,NULL,59141177931,924080905,14438764,18.1),(115705,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115705,36.08,0.4,165,50785,NULL,NULL,'mean','ESO 325- G 043',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00004,NULL,'14.35',1.2,'SA(rs:)b:',NULL,NULL,NULL,NULL,1,209.9902083,-37.86358,0.297,NULL,46878393699,732474901,11444920,14.35),(115706,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115706,36.19,0.47,173,50785,NULL,NULL,'H','ESO 325- G 043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115707,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115707,36.28,0.45,180,50785,NULL,NULL,'K','ESO 325- G 043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115708,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115708,36.34,0.46,186,50785,NULL,NULL,'J','ESO 325- G 043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115709,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115709,37.39,0.46,300,50786,70,NULL,NULL,'2MASX J13595867+2144087',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.91',0.17,NULL,NULL,NULL,NULL,NULL,1,209.9942917,21.73569,0.006,NULL,59474119496,929283117,14520048,17.91),(115710,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115710,38.59,0.46,523,50787,70,NULL,NULL,'2MASX J13595936+5819261',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,209.9975,58.32389,0,NULL,57307883090,895435673,13991182,17.7),(115711,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115711,37.67,0.46,342,50788,70,NULL,NULL,'2MASX J14000080+1457338',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.13',0.18,NULL,NULL,NULL,NULL,NULL,1,210.0035417,14.95944,0,NULL,58369420887,912022201,14250346,18.13),(115712,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115712,38.21,0.23,438,50789,70,NULL,NULL,'2MASX J14000197+4915335',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,210.008125,49.25931,0.02,NULL,59242612166,925665815,14463528,18),(115713,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115713,36.09,0.27,165,50790,70,NULL,NULL,'CGCG 295-031',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.00012,NULL,'14.8g',0.67,'E?',NULL,NULL,NULL,NULL,1,210.010875,59.26522,0.021,NULL,57274160805,894908762,13982949,14.8),(115714,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115714,37.81,0.27,365,50791,70,NULL,NULL,'2MASX J14000271+0348057',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,210.011333333,3.80161,0.057,NULL,58409755497,912652429,14260194,18.1),(115715,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115715,36.61,0.53,210,50792,70,NULL,NULL,'2MASX J14000319-0504007',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,210.0132917,-5.06683,0.069,NULL,43726253222,683222706,10675354,16.7),(115716,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115716,35.55,0.49,129,50793,75,NULL,'IR','ESO 578- G 013',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'16.54',0.2,'S              HII',NULL,NULL,NULL,NULL,1,210.016166667,-21.54375,0.193,NULL,46520952641,726889885,11357654,16.54),(115717,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115717,35.83,0.42,147,50793,NULL,NULL,'Malmquist cor.','ESO 578- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115718,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115718,36.01,0.39,159,50793,NULL,NULL,NULL,'ESO 578- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115719,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115719,36.05,0.2,162,50793,74.4,NULL,NULL,'ESO 578- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115720,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115720,37.49,0.46,314,50794,70,NULL,NULL,'SDSS J140003.95+035526.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000174,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,210.0165,3.92417,0.057,NULL,58409807112,912653236,14260206,17.9),(115721,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115721,36.84,0.46,234,50795,70,NULL,NULL,'2MASX J14000425+2043058',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.03',0.15,NULL,NULL,NULL,NULL,NULL,1,210.017875,20.7185,0.039,NULL,59465711108,929151736,14517995,18.03),(115722,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115722,35.45,0.46,123,50796,70,NULL,NULL,'MCG +10-20-060',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00017,NULL,'15.8g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,210.018667,58.37033,0,NULL,57307883991,895435687,13991182,15.8),(115723,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115723,36.86,0.27,235,50797,70,NULL,NULL,'2MASX J14000513+3309003',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,210.0214583,33.15014,0,NULL,59149020665,924203447,14440678,17.4),(115724,'CMD','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115724,18.8,0.2,0.0575,50798,NULL,NULL,NULL,'Bootes Satellite',NULL,'2008AJ....135.1361D',2008,1,NULL,NULL,'G',0.000007,NULL,'11.5K',NULL,'Dwarf Spheroidal?',NULL,NULL,NULL,NULL,1,210.025,14.5,0,1,58369312415,912020506,14250320,11.5),(115725,'CMD','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115725,18.9,0.2,0.06,50798,NULL,NULL,NULL,'Bootes Satellite',NULL,'2008AJ....135.1361D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115726,'CMD','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115726,18.9,0.2,0.06,50798,NULL,NULL,'CMD','Bootes Satellite',NULL,'2006ApJ...647L.111B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115727,'CMD','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115727,19.06,NULL,0.065,50798,NULL,NULL,NULL,'Bootes Satellite',NULL,'2014MNRAS.439..788H',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115728,'Horizontal Branch','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115728,18.95,0.08,0.0617,50798,NULL,NULL,'Probability > 0.5','Bootes Satellite',NULL,'2011ApJ...731..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115729,'Horizontal Branch','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115729,18.95,0.12,0.0617,50798,NULL,NULL,'Red HB','Bootes Satellite',NULL,'2011ApJ...731..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115730,'Horizontal Branch','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115730,19.07,0.11,0.065,50798,NULL,NULL,NULL,'Bootes Satellite',NULL,'2012ApJ...744...96O',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115731,'RR Lyrae','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115731,18.85,NULL,0.059,50798,NULL,NULL,'4, V','Bootes Satellite',NULL,'2015AJ....150..160B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115732,'RR Lyrae','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115732,18.96,0.12,0.062,50798,NULL,NULL,'15','Bootes Satellite',NULL,'2006ApJ...649L..83S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115733,'RR Lyrae','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115733,19.11,0.08,0.066,50798,NULL,NULL,'11 RR Lyrae','Bootes Satellite',NULL,'2006ApJ...653L.109D',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115734,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115734,37.62,0.56,334,50799,70,NULL,NULL,'LCRS B135730.3-031215',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00012,NULL,'16.52',0.33,NULL,NULL,NULL,NULL,NULL,1,210.025041667,-3.44606,0.105,NULL,43598969405,681233896,10644279,16.52),(115735,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115735,36.03,0.65,161,50800,70,NULL,NULL,'2MASX J14000664-1733262',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.45',NULL,NULL,NULL,NULL,NULL,NULL,1,210.027625,-17.55747,0.309,NULL,43683085660,682548213,10664815,16.45),(115736,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115736,38.26,0.46,449,50801,70,NULL,NULL,'SDSS J140007.54+305609.4',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.0g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.0314583,30.93594,0,NULL,60004709680,937573588,14649587,18),(115737,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115737,37.81,0.27,365,50802,70,NULL,NULL,'2MASX J14000844+0348050',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000149,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,210.035333,3.8015,0.057,NULL,58409758415,912652475,14260194,17.1),(115738,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115738,38,0.46,397,50803,70,NULL,NULL,'SDSS J140009.00+010340.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00007,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,210.0375,1.06111,0.065,NULL,58411415429,912678366,14260599,18.1),(115739,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115739,37.49,0.21,314,50804,70,NULL,NULL,'SDSS J140009.78+283124.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000174,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.04075,28.52342,0,NULL,60005044972,937578827,14649669,18.4),(115740,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115740,36.86,0.27,235,50805,70,NULL,NULL,'2MASX J14000990+3313463',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.37',0.23,NULL,NULL,NULL,NULL,NULL,1,210.04125,33.22964,0,NULL,59148508066,924195438,14440553,17.37),(115741,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115741,37.16,0.46,271,50806,70,NULL,NULL,'2MASX J14000998+1757538',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.0g',0.38,NULL,NULL,NULL,NULL,NULL,1,210.0415,17.96492,0.039,NULL,58375859912,912122811,14251918,16),(115742,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115742,37.62,0.46,334,50807,70,NULL,NULL,'2MASX J14001028+2735121',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000093,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,210.0427083,27.58667,0,NULL,60009673159,937651143,14650799,16.6),(115743,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115743,38.2,0.46,436,50808,70,NULL,NULL,'SDSS J140010.40+135341.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000152,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.043375,13.89478,0,NULL,58371780030,912059062,14250922,18.4),(115744,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115744,38.09,0.46,415,50809,70,NULL,NULL,'2MASX J14001127+5738251',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000148,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,210.0470417,57.64033,0.005,NULL,57308823610,895450368,13991412,17.5),(115745,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115745,38,0.46,398,50810,70,NULL,NULL,'2MASX J14001160+0649023',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.41',0.15,NULL,NULL,NULL,NULL,NULL,1,210.048333,6.8175,0.042,NULL,58514342758,914286605,14285728,18.41),(115746,'IRAS','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115746,32.62,0.8,33.4,50811,75,NULL,'MAT, I','ESO 221- G 022',NULL,'1997ApJS..109..333W',1997,1,2.91,'Star superposed.','G',0.000018,NULL,'14.13',0.36,'SBd? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,210.048667,-48.26994,0.753,NULL,46829207897,731706373,11432912,14.13),(115747,'Tully est','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115747,32.9,0.8,38.1,50811,75,NULL,NULL,'ESO 221- G 022',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115748,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115748,32.12,0.4,26.6,50811,75,NULL,NULL,'ESO 221- G 022',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115749,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115749,32.56,0.43,32.5,50811,75,NULL,'MAT, I, raw','ESO 221- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115750,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115750,32.63,0.32,33.6,50811,85,NULL,'I, raw','ESO 221- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115751,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115751,32.65,0.2,33.9,50811,74.4,NULL,NULL,'ESO 221- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115752,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115752,32.66,0.32,34.1,50811,85,NULL,'I, inv','ESO 221- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115753,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115753,32.67,0.4,34.2,50811,NULL,NULL,NULL,'ESO 221- G 022',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115754,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115754,32.72,0.43,34.9,50811,75,NULL,'MAT, I, inv','ESO 221- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115755,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115755,32.8,0.49,36.4,50811,75,NULL,'IR','ESO 221- G 022',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115756,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115756,32.86,0.43,37.4,50811,75,NULL,'MAT, I, cor','ESO 221- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115757,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115757,33.01,0.4,40,50811,NULL,NULL,'mean','ESO 221- G 022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115758,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115758,33.04,0.47,40.5,50811,NULL,NULL,'H','ESO 221- G 022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115759,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115759,33.08,0.45,41.4,50811,NULL,NULL,'K','ESO 221- G 022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115760,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115760,33.11,0.46,42,50811,NULL,NULL,'J','ESO 221- G 022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115761,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115761,33.13,NULL,42.2,50811,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 221- G 022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115762,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115762,33.13,NULL,42.3,50811,NULL,NULL,'Dipole + Quadrupole','ESO 221- G 022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115763,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115763,33.13,NULL,42.3,50811,NULL,NULL,'Dipole','ESO 221- G 022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115764,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115764,33.39,NULL,47.6,50811,NULL,NULL,NULL,'ESO 221- G 022',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115765,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115765,37.29,0.46,287,50812,70,NULL,NULL,'2MASX J14001301+5428581',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,210.054417,54.48289,0,NULL,57281959563,895030618,13984853,18),(115766,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115766,37.37,0.46,298,50813,70,NULL,NULL,'2MASX J14001323+4625563',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000199,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,210.0549583,46.43222,0,NULL,59232493087,925507704,14461057,16.6),(115767,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115767,35.18,0.46,108,50814,70,NULL,NULL,'CGCG 018-016',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000062,NULL,'15.6g',0.37,'HII',NULL,NULL,NULL,NULL,1,210.055291667,-0.96272,0.125,NULL,43594130347,681158286,10643098,15.6),(115768,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115768,35.74,0.46,140,50815,70,NULL,NULL,'CGCG 103-040',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'15.7',0.28,NULL,NULL,NULL,NULL,NULL,1,210.055583,16.72764,0,NULL,58375294663,912113979,14251780,15.7),(115769,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115769,37.34,0.46,294,50816,70,NULL,NULL,'2MASX J14001388+4752043',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,210.0580417,47.86794,0.031,NULL,59244434276,925694285,14463973,17.2),(115770,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115770,37.1,0.46,264,50817,70,NULL,NULL,'SDSS J140014.44+351214.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,210.060167,35.20406,0,NULL,59149593301,924212395,14440818,18.2),(115771,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115771,33.84,0.25,58.6,50818,74.4,NULL,NULL,'ESO 384- G 026',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000093,NULL,'14.20',0.4,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,210.060916667,-34.03797,0.213,NULL,46883395868,732553060,11446141,14.2),(115772,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115772,33.37,0.45,47.3,50818,NULL,NULL,'K','ESO 384- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115773,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115773,33.84,0.4,58.6,50818,NULL,NULL,'mean','ESO 384- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115774,'IRAS','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115774,33.74,0.8,55.9,50819,75,NULL,'HMCL, I','UGC 08918',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000013,NULL,'15.05',0.4,'S?',NULL,NULL,NULL,NULL,1,210.060833,8.9675,0.014,NULL,58514776468,914293382,14285834,15.05),(115775,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115775,33.77,0.2,56.8,50819,74.4,NULL,NULL,'UGC 08918',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115776,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115776,33.77,0.4,56.8,50819,75,NULL,'HMCL, I, raw','UGC 08918',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115777,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115777,33.89,0.4,60,50819,75,NULL,'HMCL, I, inv','UGC 08918',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115778,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115778,33.9,0.35,60.3,50819,NULL,NULL,NULL,'UGC 08918',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115779,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115779,34.15,0.49,67.6,50819,75,NULL,'IR','UGC 08918',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115780,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115780,34.15,0.32,67.7,50819,NULL,NULL,'Malmquist cor.','UGC 08918',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115781,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115781,34.17,0.4,68.1,50819,75,NULL,'HMCL, I, cor','UGC 08918',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115782,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115782,34.5,0.51,79.6,50820,NULL,NULL,NULL,'CGCG 074-032',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000033,NULL,'15.6',0.2,'Sc',NULL,NULL,NULL,NULL,1,210.06725,9.28928,0.014,NULL,58507629989,914181718,14284089,15.6),(115783,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115783,34.55,0.2,81.3,50820,74.4,NULL,NULL,'CGCG 074-032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115784,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115784,34.62,0.49,84,50820,75,NULL,'IR','CGCG 074-032',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115785,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115785,34.68,0.47,86.2,50820,NULL,NULL,'Malmquist cor.','CGCG 074-032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115786,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115786,36.77,0.62,226,50821,70,NULL,NULL,'2MASX J14001783-4234450',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,210.0742917,-42.57925,0.245,NULL,46922928549,733170758,11455793,15.1),(115787,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115787,37.85,0.46,372,50822,70,NULL,NULL,'SDSS J140018.80+233443.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.078333,23.57872,0.019,NULL,59461285339,929082583,14516915,18),(115788,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115788,36.37,0.33,188,50823,70,NULL,NULL,'2MASX J14001886+1250288',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.67',0.21,NULL,NULL,NULL,NULL,NULL,1,210.0785,12.84133,0,NULL,58368107534,912001680,14250026,17.67),(115789,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115789,36.86,0.27,235,50824,70,NULL,NULL,'2MASX J14001938+3310013',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.18',0.16,NULL,NULL,NULL,NULL,NULL,1,210.0807917,33.16703,0,NULL,59148505223,924195394,14440553,18.18),(115790,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115790,34.28,0.45,71.8,50825,NULL,NULL,'K','NGC 5406',NULL,'2007A&A...465...71T',2007,1,2.04,NULL,'G',0.00013,NULL,'13.1g',1.1,'SAB(rs)bc','in a radial-velocity based grouping',NULL,NULL,NULL,1,210.083833,38.91542,0,NULL,59141642173,924088158,14438877,13.1),(115791,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115791,34.29,0.47,72,50825,NULL,NULL,'H','NGC 5406',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115792,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115792,34.35,0.46,74,50825,NULL,NULL,'J','NGC 5406',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115793,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115793,34.47,0.4,78.5,50825,NULL,NULL,'mean','NGC 5406',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115794,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115794,35.99,0.46,158,50826,70,NULL,NULL,'2MASX J14002018+2919218',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00011,NULL,'14.95',0.27,'S0',NULL,NULL,NULL,NULL,1,210.084083,29.32275,0,NULL,60007762134,937621283,14650332,14.95),(115795,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115795,37.68,0.33,343,50827,70,NULL,NULL,'2MASX J14002082+1318223',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000176,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,210.086875,13.30633,0,NULL,58368934968,912014608,14250228,18),(115796,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115796,37.71,0.23,348,50828,70,NULL,NULL,'2MASX J14002165+6204285',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,210.0905417,62.07467,0.029,NULL,57750851019,902357047,14099328,17.4),(115797,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115797,37.71,0.23,348,50829,70,NULL,NULL,'2MASX J14002333+6207215',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000164,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,210.096875,62.12272,0.029,NULL,57747445763,902303840,14098497,17.6),(115798,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115798,38.21,0.27,438,50830,70,NULL,NULL,'2MASX J14002624+0818158',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.44',0.16,'BrClG',NULL,NULL,NULL,NULL,1,210.109416667,8.30453,0,NULL,58513517028,914273703,14285526,18.44),(115799,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115799,36.06,0.46,163,50831,70,NULL,NULL,'CGCG 103-041',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000117,NULL,'15.4g',0.51,NULL,NULL,NULL,NULL,NULL,1,210.1100417,17.85925,0.039,NULL,58375848472,912122632,14251916,15.4),(115800,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115800,36.95,0.46,246,50832,70,NULL,NULL,'2MASX J14002807+4456217',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,210.1170417,44.93944,0,NULL,59235717761,925558090,14461845,17.1),(115801,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115801,33.68,0.49,54.4,50833,75,NULL,'IR','ESO 384- G 027',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000027,NULL,'14.62',0.4,'Sb:',NULL,NULL,NULL,NULL,1,210.120333,-34.62031,0.217,NULL,46882162892,732533795,11445840,14.62),(115802,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115802,33.7,0.2,55,50833,74.4,NULL,NULL,'ESO 384- G 027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115803,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115803,33.98,0.42,62.6,50833,NULL,NULL,'Malmquist cor.','ESO 384- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115804,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115804,34.04,0.41,64.3,50833,NULL,NULL,NULL,'ESO 384- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115805,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115805,37.55,0.46,323,50834,70,NULL,NULL,'2MASX J14002987+3504201',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,210.1245,35.07233,0,NULL,59149483800,924210684,14440791,17),(115806,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115806,35.08,0.33,104,50835,70,NULL,NULL,'CGCG 018-018',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000077,NULL,'15.2g',0.37,'S0^-','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,210.12525,-2.81064,0.121,NULL,43603520121,681305001,10645390,15.2),(115807,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115807,37.46,0.46,311,50836,70,NULL,NULL,'2MASX J14003073+5236008',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000209,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,210.127875,52.60031,0,NULL,59218713386,925292396,14457693,16.3),(115808,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115808,37.48,0.46,313,50837,70,NULL,NULL,'2MASX J14003088+1543333',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.45',0.14,NULL,NULL,NULL,NULL,NULL,1,210.128583,15.72597,0,NULL,58383573439,912243334,14253802,18.45),(115809,'IRAS','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115809,33.95,0.8,61.5,50838,75,NULL,'HMCL, I','CGCG 074-035',NULL,'1997ApJS..109..333W',1997,1,1.16,NULL,'G',0.000027,NULL,'15.4',0.11,'Sdm',NULL,NULL,NULL,NULL,1,210.129417,8.64981,0,NULL,58514848214,914294503,14285851,15.4),(115810,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115810,34.27,NULL,71.5,50838,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 074-035',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115811,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115811,34.28,0.2,71.8,50838,74.4,NULL,NULL,'CGCG 074-035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115812,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115812,34.29,NULL,72.1,50838,NULL,NULL,'Dipole + Quadrupole','CGCG 074-035',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115813,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115813,34.3,NULL,72.4,50838,NULL,NULL,'Dipole','CGCG 074-035',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115814,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115814,34.32,NULL,73,50838,NULL,NULL,NULL,'CGCG 074-035',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115815,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115815,34.86,0.4,93.6,50838,75,NULL,'HMCL, I, raw','CGCG 074-035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115816,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115816,34.88,0.4,94.8,50838,75,NULL,'HMCL, I, inv','CGCG 074-035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115817,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115817,35,0.4,99.8,50838,75,NULL,'HMCL, I, cor','CGCG 074-035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115818,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115818,37.68,0.33,343,50839,70,NULL,NULL,'2MASX J14003177+1331553',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.18',0.18,NULL,NULL,NULL,NULL,NULL,1,210.132333333,13.53197,0,NULL,58368314110,912004907,14250076,18.18),(115819,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115819,33.08,0.48,41.3,50840,70,NULL,NULL,'NGC 5393',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000087,NULL,'13.97',0.7,'(R_1R\'_2)SB(r)b: HII',NULL,NULL,NULL,NULL,1,210.1335,-28.87458,0.177,NULL,46983657041,734119641,11470619,13.97),(115820,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115820,37.71,0.23,348,50841,70,NULL,NULL,'2MASX J14003208+6153066',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,210.133583333,61.88511,0.021,NULL,57263052686,894735198,13980237,17.6),(115821,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115821,38.1,0.46,417,50842,70,NULL,NULL,'SDSS J140032.06+223631.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.133625,22.60869,0,NULL,59473722461,929276913,14519951,18.5),(115822,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115822,36.34,0.46,185,50843,70,NULL,NULL,'2MASX J14003276+1205213',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.90',0.25,NULL,NULL,NULL,NULL,NULL,1,210.1364583,12.08931,0,NULL,58460271803,913441746,14272527,16.9),(115823,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115823,34.99,0.49,99.4,50844,70,NULL,NULL,'2MASX J14003360-2014231',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00011,NULL,'15.21',NULL,NULL,NULL,NULL,NULL,NULL,1,210.14,-20.23989,0.185,NULL,46516638309,726822473,11356601,15.21),(115824,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115824,36.09,0.46,165,50845,70,NULL,NULL,'2MASX J14003448+2546069',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000182,NULL,'15.6g',0.4,NULL,NULL,NULL,NULL,NULL,1,210.143583,25.76856,0,NULL,60010633334,937666145,14651033,15.6),(115825,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115825,37.33,0.33,292,50846,70,NULL,NULL,'2MASX J14003466+2735519',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00017,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,210.1442917,27.59794,0,NULL,60009668897,937651076,14650798,17.3),(115826,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115826,38.18,0.46,432,50847,70,NULL,NULL,'2MASX J14003469+4354487',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,210.144333,43.91344,0,NULL,59233871032,925529234,14461394,18),(115827,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115827,37.73,0.46,352,50848,70,NULL,NULL,'2MASX J14003512+4549327',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00018,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,210.1465,45.82569,0,NULL,59235477939,925554342,14461786,17),(115828,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115828,37.85,0.46,372,50849,70,NULL,NULL,'2MASX J14003659-0131171',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,210.152333333,-1.52156,0.145,NULL,43603345570,681302274,10645348,17.8),(115829,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115829,35.25,0.51,112,50850,70,NULL,NULL,'IC 0968 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.000053,NULL,'15.83',0.46,NULL,'Group member, radial-velocity confirmed',NULL,NULL,NULL,1,210.1525417,-2.90911,0.121,NULL,43601372935,681271452,10644866,15.83),(115830,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115830,34.83,0.58,92.4,50851,70,NULL,NULL,'2MASX J14003696-1917231',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.57',0.3,NULL,NULL,NULL,NULL,NULL,1,210.1539583,-19.28983,0.225,NULL,43628471722,681694870,10651482,15.57),(115831,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115831,35.08,0.33,104,50852,70,NULL,NULL,'NGC 5400',NULL,'2015arXiv151105856S',2015,1,1.17,NULL,'G',0.00005,NULL,'13.9g',1.04,'(R\')S0-?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,210.155,-2.85781,0.121,NULL,43603465019,681304140,10645377,13.9),(115832,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115832,35.23,0.4,111,50852,NULL,NULL,'mean','NGC 5400',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115833,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115833,35.94,0.45,154,50852,NULL,NULL,'K','NGC 5400',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115834,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115834,34.69,0.49,86.7,50853,75,NULL,'IR','ESO 510- G 038',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'16.29',0.2,'S...',NULL,NULL,NULL,NULL,1,210.156083,-25.05008,0.329,NULL,46979172026,734049562,11469524,16.29),(115835,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115835,34.8,0.53,91.2,50853,NULL,NULL,'Malmquist cor.','ESO 510- G 038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115836,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115836,34.82,0.52,92,50853,NULL,NULL,NULL,'ESO 510- G 038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115837,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115837,34.86,0.2,93.8,50853,74.4,NULL,NULL,'ESO 510- G 038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115838,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115838,36.34,NULL,185,50854,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1700',NULL,'2010Ap&SS.325..163P',2010,1,0.81,NULL,'G',0.000087,NULL,'16.6g',0.2,'Scd',NULL,NULL,NULL,NULL,1,210.1672917,49.79072,0.018,NULL,59253999232,925843738,14466308,16.6),(115839,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115839,36.34,NULL,186,50854,NULL,NULL,NULL,'FGC 1700',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115840,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115840,36.36,NULL,187,50854,NULL,NULL,'Dipole + Quadrupole','FGC 1700',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115841,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115841,36.39,NULL,190,50854,NULL,NULL,'Dipole','FGC 1700',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115842,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115842,35.84,0.4,147,50855,NULL,NULL,'Malmquist cor.','ESO 510- G 039',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'16.06',0.3,'S...',NULL,NULL,NULL,NULL,1,210.1734583,-23.18828,0.189,NULL,46507791593,726684243,11354441,16.06),(115843,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115843,35.94,0.39,154,50855,NULL,NULL,NULL,'ESO 510- G 039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115844,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115844,35.98,0.2,157,50855,74.4,NULL,NULL,'ESO 510- G 039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115845,'Faber-Jackson','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115845,31.61,0.65,21,50856,95,NULL,'Weighted Mean','NGC 5422',NULL,'1984ApJS...56...91D',1984,1,2.19,'HOLM 567B is a star.','G',0.000017,NULL,'12.9g',0.7,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,210.175167,55.16447,0.005,NULL,57300771668,895324557,13989446,12.9),(115846,'Faber-Jackson','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115846,32.97,0.81,39.3,50856,55,NULL,'Visvanathan & Sandage 1979','NGC 5422',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115847,'Tertiary','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115847,31.87,0.29,23.7,50856,95,NULL,NULL,'NGC 5422',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115848,'Tully est','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115848,32.45,0.8,30.9,50856,75,NULL,'B','NGC 5422',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115849,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115849,31.76,0.45,22.5,50856,NULL,NULL,'K','NGC 5422',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115850,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115850,32.45,0.4,30.9,50856,NULL,NULL,'mean','NGC 5422',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115851,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115851,38.21,0.27,438,50857,70,NULL,NULL,'2MASX J14004240+0806378',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,210.17675,8.11053,0.013,NULL,58513536540,914274008,14285531,NULL),(115852,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115852,36.19,0.46,173,50858,70,NULL,NULL,'2MASX J14004291+5850501',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00014,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,210.178625,58.84722,0,NULL,57273452875,894897701,13982776,17),(115853,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115853,37.16,0.33,271,50859,70,NULL,NULL,'2MASX J14004291+2022590',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.65',0.21,NULL,NULL,NULL,NULL,NULL,1,210.1787917,20.38297,0.037,NULL,59465184890,929143513,14517867,16.65),(115854,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115854,37.88,0.46,377,50860,70,NULL,NULL,'2MASX J14004293+0315155',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000089,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,210.178875,3.25425,0.037,NULL,58408348198,912630440,14259850,17),(115855,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115855,37.22,0.33,279,50861,70,NULL,NULL,'2MASX J14004472+0600005',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.40',0.16,NULL,NULL,NULL,NULL,NULL,1,210.18625,6.00006,0,NULL,58477622771,913712855,14276763,18.4),(115856,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115856,37.81,0.46,364,50862,70,NULL,NULL,'2MASX J14004483+1157083',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,210.186708333,11.95236,0,NULL,58460254524,913441476,14272523,17.3),(115857,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115857,37.2,0.33,275,50863,70,NULL,NULL,'MCG +10-20-063',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000201,NULL,'15.8g',0.45,'E0',NULL,NULL,NULL,NULL,1,210.186833,59.62706,0.021,NULL,57273591593,894899868,13982810,15.8),(115858,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115858,38.04,0.46,405,50864,70,NULL,NULL,'2MASXi J1400449+125327',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,210.187375,12.89083,0,NULL,58368031753,912000496,14250007,18.1),(115859,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115859,38.21,0.27,438,50865,70,NULL,NULL,'2MASX J14004510+0814128',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,210.1880417,8.23706,0,NULL,58513552065,914274251,14285535,17.7),(115860,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115860,32.44,0.69,30.7,50866,100,NULL,'mid-IR','NGC 5430',NULL,'2013ApJ...771...88L',2013,1,2.63,'HOLM 569B is a part of NGC 5430.','G',0.000017,NULL,'13.0g',1.03,'SB(s)b;HII;WR? Sbrst','Group member',NULL,NULL,'Starburst',1,210.190583,59.32828,0.005,NULL,57274165081,894908829,13982950,13),(115861,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115861,32.81,0.45,36.4,50866,NULL,NULL,'K','NGC 5430',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115862,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115862,32.84,0.47,36.9,50866,NULL,NULL,'H','NGC 5430',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115863,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115863,32.9,0.48,37.9,50866,NULL,NULL,'Malmquist cor.','NGC 5430',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115864,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115864,32.92,0.46,38.4,50866,NULL,NULL,'J','NGC 5430',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115865,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115865,33.01,0.43,40,50866,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5430',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115866,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115866,33.12,0.43,42,50866,75,NULL,'3.6 micron, color corrected','NGC 5430',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115867,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115867,33.23,0.4,44.2,50866,NULL,NULL,'mean','NGC 5430',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115868,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115868,33.26,0.2,44.9,50866,74.4,NULL,NULL,'NGC 5430',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115869,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115869,33.29,0.4,45.5,50866,NULL,NULL,NULL,'NGC 5430',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115870,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115870,33.5,0.2,50.1,50867,74.4,NULL,NULL,'UGC 08924',NULL,'2013AJ....146...86T',2013,1,1.64,NULL,'G',0.000007,NULL,'14.8g',0.35,'Scd(f)',NULL,NULL,NULL,NULL,1,210.190708333,2.02203,0.061,NULL,58418034979,912781796,14262215,14.8),(115871,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115871,33.53,0.49,50.8,50867,75,NULL,'IR','UGC 08924',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115872,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115872,33.59,0.47,52.2,50867,NULL,NULL,NULL,'UGC 08924',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115873,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115873,33.63,NULL,53.3,50867,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08924',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115874,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115874,33.64,NULL,53.5,50867,NULL,NULL,'Dipole + Quadrupole','UGC 08924',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115875,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115875,33.65,NULL,53.7,50867,NULL,NULL,'Dipole','UGC 08924',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115876,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115876,33.73,NULL,55.8,50867,NULL,NULL,NULL,'UGC 08924',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115877,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115877,33.9,0.41,60.3,50867,NULL,NULL,'Malmquist cor.','UGC 08924',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115878,'IRAS','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115878,30.99,0.8,15.8,50868,75,NULL,'MAT, I','ESO 271- G 010',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000019,NULL,'12.75',1.8,'SA(s)c',NULL,NULL,NULL,NULL,1,210.1935,-45.41856,0.233,NULL,46799832369,731247380,11425740,12.75),(115879,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115879,30.25,0.32,11.2,50868,85,NULL,'I, inv','ESO 271- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115880,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115880,30.27,0.32,11.3,50868,85,NULL,'I, raw','ESO 271- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115881,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115881,31,0.43,15.9,50868,75,NULL,'MAT, I, raw','ESO 271- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115882,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115882,31.02,0.43,16,50868,75,NULL,'MAT, I, inv','ESO 271- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115883,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115883,31.34,0.43,18.6,50868,75,NULL,'MAT, I, cor','ESO 271- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115884,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115884,31.51,0.47,20.1,50868,NULL,NULL,'H','ESO 271- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115885,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115885,31.52,0.46,20.2,50868,NULL,NULL,'J','ESO 271- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115886,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115886,31.56,0.45,20.5,50868,NULL,NULL,'K','ESO 271- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115887,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115887,31.61,0.4,21,50868,75,NULL,'B','ESO 271- G 010',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115888,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115888,31.7,0.4,21.9,50868,NULL,NULL,'mean','ESO 271- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115889,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115889,33.38,0.25,47.4,50869,74.4,NULL,NULL,'ESO 384- G 029',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.00009,NULL,'13.87',1.2,'(R\'_2)SB(s)0/a',NULL,NULL,NULL,NULL,1,210.1964583,-34.22478,0.229,NULL,46883367963,732552624,11446134,13.87),(115890,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115890,33.51,0.4,50.5,50869,NULL,NULL,'mean','ESO 384- G 029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115891,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115891,34.04,0.45,64.2,50869,NULL,NULL,'K','ESO 384- G 029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115892,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115892,37.28,0.46,286,50870,70,NULL,NULL,'2MASX J14004709+4945008',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,210.196333,49.75017,0.018,NULL,59254211285,925847051,14466360,17.9),(115893,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115893,38.02,0.46,401,50871,70,NULL,NULL,'2MASX J14004727+3944183',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,210.1970417,39.73831,0,NULL,59260045428,925938209,14467784,17.8),(115894,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115894,37.23,0.46,279,50872,70,NULL,NULL,'2MASX J14004758+3611263',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,210.198166667,36.19067,0,NULL,59154127065,924283235,14441925,17.8),(115895,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115895,38.41,0.46,481,50873,70,NULL,NULL,'SDSS J140047.62+093851.2',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.1984583,9.64756,0.023,NULL,58508387852,914193560,14284274,17.6),(115896,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115896,32.14,0.4,26.7,50874,75,NULL,NULL,'NGC 5425',NULL,'2008Ap.....51..336K',2008,1,1.9,NULL,'G',0.000023,NULL,'14.21',0.5,'Sd             HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,210.198625,48.44386,0.034,NULL,59243114778,925673668,14463651,14.21),(115897,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115897,32.52,0.2,31.9,50874,74.4,NULL,NULL,'NGC 5425',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115898,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115898,32.54,0.43,32.2,50874,75,NULL,'3.6 micron, color corrected','NGC 5425',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115899,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115899,32.57,0.43,32.7,50874,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5425',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115900,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115900,32.62,0.49,33.4,50874,75,NULL,'IR','NGC 5425',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115901,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115901,32.66,0.4,34.1,50874,NULL,NULL,'mean','NGC 5425',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115902,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115902,33.18,0.47,43.2,50874,NULL,NULL,'H','NGC 5425',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115903,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115903,38.43,0.46,485,50875,70,NULL,NULL,'2MASX J14004826+5730401',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,210.2014583,57.51117,0.009,NULL,57308178748,895440292,13991254,17.9),(115904,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115904,34.61,0.46,83.7,50876,70,NULL,NULL,'NGC 5407',NULL,'2015arXiv151105856S',2015,1,1.21,NULL,'G',0.000143,NULL,'14.2g',0.69,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,210.20875,39.15622,0,NULL,59141334446,924083350,14438802,14.2),(115905,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115905,37.2,0.46,276,50877,70,NULL,NULL,'2MASX J14005251+3221172',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.07',0.17,NULL,NULL,NULL,NULL,NULL,1,210.218875,32.35478,0,NULL,60033293334,938020208,14656565,18.07),(115906,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115906,37.16,0.33,271,50878,70,NULL,NULL,'2MASX J14005331+2018581',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,210.2222917,20.31603,0.037,NULL,59465211863,929143935,14517873,17.2),(115907,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115907,34.99,0.54,99.3,50879,70,NULL,NULL,'2MASX J14005337-2120290',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000133,NULL,'15.44',0.6,NULL,NULL,NULL,NULL,NULL,1,210.222333,-21.34156,0.189,NULL,46520930053,726889532,11357648,15.44),(115908,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115908,38.29,0.46,456,50880,70,NULL,NULL,'2MASX J14005335+0333155',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000199,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,210.222375,3.55444,0.041,NULL,58408495645,912632744,14259886,17),(115909,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115909,37.49,0.21,314,50881,70,NULL,NULL,'2MASX J14005362+2838237',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,210.2235,28.64003,0,NULL,60006892663,937607697,14650120,17.7),(115910,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115910,38.16,0.46,428,50882,70,NULL,NULL,'2MASX J14005381+3836541',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000156,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,210.223917,38.61508,0,NULL,59141761699,924090026,14438906,18.5),(115911,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115911,37.17,0.46,272,50883,70,NULL,NULL,'2MASX J14005433+1713002',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.44',0.15,NULL,NULL,NULL,NULL,NULL,1,210.226291667,17.21686,0,NULL,58376266532,912129164,14252018,18.44),(115912,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115912,37.42,0.46,304,50884,70,NULL,NULL,'2MASX J14005492+1727152',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.92',0.12,NULL,NULL,NULL,NULL,NULL,1,210.22875,17.45422,0.025,NULL,58375881585,912123149,14251924,18.92),(115913,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115913,37.39,0.46,300,50885,70,NULL,NULL,'2MASX J14005503+2754027',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000097,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,210.229333,27.90072,0,NULL,60009515861,937648685,14650760,16.5),(115914,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115914,38.6,0.46,524,50886,70,NULL,NULL,'2MASX J14005693+3428562',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000129,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,210.237125,34.48228,0,NULL,59149804420,924215694,14440870,18.7),(115915,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115915,37.57,0.46,326,50887,70,NULL,NULL,'2MASX J14005694+0134005',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000082,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,210.23725,1.56686,0.061,NULL,58417845543,912778836,14262169,17.8),(115916,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115916,37.77,0.46,357,50888,70,NULL,NULL,'2MASX J14005723+6230575',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00017,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,210.238625,62.516,0.021,NULL,57747556212,902305565,14098524,17.3),(115917,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115917,36.54,0.93,203,50889,70,NULL,NULL,'2MASX J14005766-2115340',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.8I',0.5,NULL,NULL,NULL,NULL,NULL,1,210.24025,-21.25947,0.189,NULL,46516798348,726824974,11356640,13.8),(115918,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115918,37.71,0.23,348,50890,70,NULL,NULL,'2MASX J14005767+6151215',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000184,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,210.240417,61.85617,0.021,NULL,57263053005,894735203,13980237,16.4),(115919,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115919,37.75,0.46,355,50891,70,NULL,NULL,'2MASX J14005813+0006588',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000079,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,210.242167,0.11644,0.113,NULL,58411784354,912684130,14260689,17.5),(115920,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115920,35.3,0.49,115,50892,75,NULL,'IR','FGC 1699',NULL,'2011yCatp016004901K',2011,1,1.22,NULL,'G',0.000067,NULL,'16.5',0.1,'Scd',NULL,NULL,NULL,NULL,1,210.244541667,-16.61672,0.269,NULL,43680904177,682514127,10664283,16.5),(115921,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115921,35.58,NULL,131,50892,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1699',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115922,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115922,35.59,NULL,131,50892,NULL,NULL,'Dipole + Quadrupole','FGC 1699',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115923,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115923,35.59,NULL,131,50892,NULL,NULL,'Dipole','FGC 1699',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115924,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115924,35.63,NULL,134,50892,NULL,NULL,NULL,'FGC 1699',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115925,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115925,37.97,0.33,392,50893,70,NULL,NULL,'2MASX J14005877+3639321',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000186,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,210.244875,36.65881,0,NULL,59153668473,924276069,14441813,17.3),(115926,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115926,37.35,0.27,295,50894,70,NULL,NULL,'2MASX J14005912+1951048',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'18.18',0.18,NULL,NULL,NULL,NULL,NULL,1,210.246375,19.85142,0.047,NULL,59465019044,929140922,14517826,18.18),(115927,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115927,39.19,0.46,690,50895,NULL,NULL,'Isotherm., r < 100 kpc','ABELL 1835',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'Compact [Zw]',NULL,NULL,NULL,NULL,1,210.259583,2.88,0.065,NULL,58416494261,912757722,14261839,NULL),(115928,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115928,39.21,NULL,695,50895,NULL,NULL,'3.1 (red) calibration','ABELL 1835',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115929,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115929,39.54,NULL,810,50895,NULL,NULL,NULL,'ABELL 1835',NULL,'2011A&A...532A..14C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115930,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115930,39.64,NULL,847,50895,NULL,NULL,'4.2 (black) calibration','ABELL 1835',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115931,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115931,39.84,NULL,931,50895,NULL,NULL,'4.1 (blue) calibration','ABELL 1835',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115932,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115932,39.88,NULL,946,50895,NULL,NULL,NULL,'ABELL 1835',NULL,'2005ApJ...625..108D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115933,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115933,39.96,0.33,980,50895,NULL,NULL,'Isotherm.','ABELL 1835',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115934,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115934,40.02,0.6,1010,50895,NULL,NULL,NULL,'ABELL 1835',NULL,'2000ApJ...538..505M',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115935,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115935,40.06,NULL,1030,50895,NULL,NULL,NULL,'ABELL 1835',NULL,'2002ApJ...581...53R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115936,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115936,40.15,0.15,1070,50895,NULL,NULL,'Hydrost. Eq.','ABELL 1835',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115937,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115937,40.26,0.52,1130,50895,NULL,NULL,NULL,'ABELL 1835',NULL,'2000ApJ...538..505M',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115938,'Tully est','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115938,32.8,0.8,36.3,50896,75,NULL,NULL,'UGCA 378',NULL,'1988NBGC.C....0000T',1988,1,2.6,NULL,'G',0.000013,NULL,'13.10',2.2,'SB(s)d pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,210.266833,-30.32722,0.109,NULL,46980731612,734073931,11469905,13.1),(115939,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115939,35.72,0.68,139,50897,70,NULL,NULL,'LCRS B135823.6-114909',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.0001,NULL,'16.6b',0.3,NULL,NULL,NULL,NULL,NULL,1,210.2682083,-12.06047,0.217,NULL,43692072922,682688639,10667009,16.6),(115940,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115940,38.09,0.46,416,50898,70,NULL,NULL,'SDSS J140104.41+633525.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000142,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,210.268417,63.59044,0.025,NULL,57932075935,905188686,14143573,18.6),(115941,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115941,37.45,0.46,309,50899,70,NULL,NULL,'2MASX J14010504+3200472',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.08',0.18,NULL,NULL,NULL,NULL,NULL,1,210.271083333,32.01325,0,NULL,60049889493,938279523,14660617,18.08),(115942,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115942,37.35,0.46,295,50900,70,NULL,NULL,'2MASX J14010596+0919186',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.42',0.15,NULL,NULL,NULL,NULL,NULL,1,210.275,9.32164,0.013,NULL,58507485759,914179464,14284054,18.42),(115943,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115943,37.11,0.46,264,50901,70,NULL,NULL,'2MASX J14010750+4450158',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,210.281291667,44.83753,0,NULL,59235759100,925558735,14461855,17.7),(115944,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115944,37.22,0.33,279,50902,70,NULL,NULL,'2MASX J14010778+0557093',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,210.282333333,5.95258,0,NULL,58477753692,913714901,14276795,17.1),(115945,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115945,35.39,0.49,120,50903,70,NULL,NULL,'2MASX J14010939-4152081',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000167,NULL,'13.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,210.289083333,-41.869,0.237,NULL,46911785652,732996650,11453072,13.6),(115946,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115946,37.97,0.33,392,50904,70,NULL,NULL,'2MASX J14010949+3639262',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000198,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,210.2897083,36.65717,0,NULL,59153786053,924277907,14441842,17.9),(115947,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115947,37.43,0.46,306,50905,70,NULL,NULL,'2MASX J14011017+5738040',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000144,NULL,'16.8g',0.35,NULL,NULL,NULL,NULL,NULL,1,210.2922917,57.63453,0.009,NULL,57308657405,895447771,13991371,16.8),(115948,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115948,37.4,0.46,302,50906,70,NULL,NULL,'2MASX J14011016+0950546',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.84',0.12,NULL,NULL,NULL,NULL,NULL,1,210.292417,9.84844,0.012,NULL,58508201577,914190649,14284228,18.84),(115949,'D-Sigma','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115949,33.26,0.4,44.9,50907,75,NULL,'Edat, raw','NGC 5397',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000057,NULL,'12.73',1,'SAB(s)0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,210.293583,-33.94583,0.229,NULL,46883175782,732549621,11446087,12.73),(115950,'D-Sigma','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115950,33.44,0.4,48.7,50907,75,NULL,'Edat, cor','NGC 5397',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115951,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115951,33.49,0.49,49.8,50907,70,NULL,NULL,'NGC 5397',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115952,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115952,34.31,0.25,72.8,50907,74.4,NULL,NULL,'NGC 5397',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115953,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115953,33.84,0.4,58.5,50907,NULL,NULL,'mean','NGC 5397',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115954,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115954,34.63,0.45,84.2,50907,NULL,NULL,'K','NGC 5397',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115955,'IRAS','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115955,34.93,0.8,96.8,50908,75,NULL,'HMCL, I','UGC 08927',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000033,NULL,'15.10',0.4,'Sbc',NULL,NULL,NULL,NULL,1,210.2937083,7.48214,0.04,NULL,58513759383,914277490,14285585,15.1),(115956,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115956,34.49,0.4,79.1,50908,75,NULL,'HMCL, I, raw','UGC 08927',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115957,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115957,34.6,0.4,83.4,50908,75,NULL,'HMCL, I, inv','UGC 08927',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115958,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115958,34.68,0.46,86.4,50908,NULL,NULL,NULL,'UGC 08927',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115959,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115959,34.72,0.2,87.9,50908,74.4,NULL,NULL,'UGC 08927',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115960,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115960,34.78,0.4,90.4,50908,75,NULL,'HMCL, I, cor','UGC 08927',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115961,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115961,34.82,0.43,91.9,50908,NULL,NULL,'Malmquist cor.','UGC 08927',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115962,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115962,37.09,0.46,262,50909,70,NULL,NULL,'2MASX J14011097+2032498',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,210.295583,20.54725,0.047,NULL,59465748217,929152315,14518004,16.7),(115963,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115963,36.93,0.46,243,50910,70,NULL,NULL,'2MASX J14011223+3849432',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000177,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,210.300875,38.82864,0,NULL,59141621738,924087839,14438872,16.9),(115964,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115964,38.03,0.46,403,50911,70,NULL,NULL,'SDSS J140113.02+414513.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,210.3042917,41.75375,0,NULL,59258573916,925915217,14467425,18),(115965,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115965,37.6,0.46,332,50912,70,NULL,NULL,'2MASX J14011327+6501210',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000085,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,210.305417,65.02261,0.017,NULL,57934792436,905231131,14144236,17.2),(115966,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115966,38.47,0.46,493,50913,70,NULL,NULL,'SDSS J140113.47+580502.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000141,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,210.306166667,58.08406,0,NULL,57308026323,895437911,13991217,18.5),(115967,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115967,37.74,0.46,354,50914,70,NULL,NULL,'2MASX J14011438+2924278',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000133,NULL,'15.15',0.22,'S0',NULL,NULL,NULL,NULL,1,210.309958333,29.40769,0,NULL,60007854956,937622733,14650355,15.15),(115968,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115968,37.33,0.33,292,50915,70,NULL,NULL,'2MASX J14011480+6221240',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000179,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,210.311625,62.35664,0.029,NULL,57747456809,902304012,14098500,16.9),(115969,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115969,36.25,0.49,178,50916,75,NULL,'IR','UGC 08934 NOTES01',NULL,'2011yCatp016004901K',2011,1,0.5,NULL,'G',0.000223,NULL,'17.21',0.1,'Sbc',NULL,NULL,NULL,NULL,1,210.31375,10.48842,0.008,NULL,58510066305,914219786,14284684,17.21),(115970,'SNIa','2016-12-15 15:15:20','2016-12-16 11:20:33','1','SN 1975G','R',115970,34.11,NULL,66.4,50917,NULL,NULL,'Photographic','CGCG 272-018',NULL,'1988SSRv...48....1R',1988,1,0.94,NULL,'G',0.000127,NULL,'14.5g',0.45,NULL,NULL,NULL,NULL,NULL,1,210.316833,54.41872,0,NULL,57282428977,895037952,13984968,14.5),(115971,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115971,37.73,0.23,352,50918,70,NULL,NULL,'2MASX J14011623+3942562',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000213,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,210.317666667,39.71564,0,NULL,59259571699,925930807,14467668,16.3),(115972,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115972,37.73,0.23,352,50919,70,NULL,NULL,'2MASX J14011796+3945512',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000176,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,210.3247917,39.76428,0,NULL,59259570274,925930785,14467668,17.1),(115973,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115973,35.42,0.2,121,50920,74.4,NULL,NULL,'CGCG 074-039',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.00002,NULL,'15.1',0.9,'Sc','Group member of poor cluster',NULL,NULL,NULL,1,210.325417,10.11881,0,NULL,58508074159,914188658,14284197,15.1),(115974,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115974,37.2,0.46,275,50921,70,NULL,NULL,'2MASX J14011822+0620121',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000161,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,210.325875,6.33683,0.032,NULL,58510834337,914231786,14284871,17),(115975,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115975,37.66,0.46,341,50922,70,NULL,NULL,'2MASX J14011862+1558213',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.52',0.16,NULL,NULL,NULL,NULL,NULL,1,210.3275417,15.97264,0,NULL,58374816697,912106510,14251664,18.52),(115976,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115976,37.55,0.46,323,50923,70,NULL,NULL,'2MASX J14011865+3924152',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,210.327833,39.40425,0,NULL,59259667900,925932310,14467692,17.6),(115977,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115977,37.35,0.27,295,50924,70,NULL,NULL,'2MASX J14011909+1931528',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.12',0.23,NULL,NULL,NULL,NULL,NULL,1,210.329583,19.53119,0.049,NULL,58326261057,911347829,14239809,17.12),(115978,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115978,35.79,0.57,144,50925,70,NULL,NULL,'2MASX J14011913-4146251',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,210.32975,-41.77358,0.237,NULL,46911796055,732996813,11453075,14.5),(115979,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115979,35.24,0.62,112,50926,70,NULL,NULL,'2MFGC 11346',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00011,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,210.3304583,-15.76147,0.345,NULL,43684864574,682576008,10665250,15.9),(115980,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115980,37.8,0.33,363,50927,70,NULL,NULL,'2MASX J14011959+1404463',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,210.3317917,14.07956,0,NULL,58369720469,912026882,14250420,16.9),(115981,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115981,37.36,0.46,297,50928,70,NULL,NULL,'SDSS J140119.83+270859.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,210.332625,27.14997,0,NULL,60011966372,937686974,14651358,17.8),(115982,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115982,37.32,0.46,291,50929,70,NULL,NULL,'SDSS J140120.14+242848.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.3339583,24.48019,0,NULL,59460656817,929072762,14516761,17.9),(115983,'IRAS','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115983,34.64,0.8,84.6,50930,75,NULL,'MAT, I','ESO 510- G 040',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.75',1,'SB(s)cd',NULL,NULL,NULL,NULL,1,210.336125,-26.19794,0.193,NULL,46990335835,734223997,11472249,14.75),(115984,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115984,33.58,0.32,52,50930,85,NULL,'I, raw','ESO 510- G 040',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115985,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115985,33.58,0.32,52.1,50930,85,NULL,'I, inv','ESO 510- G 040',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115986,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115986,33.88,0.46,59.7,50930,NULL,NULL,NULL,'ESO 510- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115987,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115987,33.9,0.43,60.1,50930,75,NULL,'MAT, I, raw','ESO 510- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115988,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115988,33.92,0.2,60.8,50930,74.4,NULL,NULL,'ESO 510- G 040',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115989,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115989,33.98,0.43,62.4,50930,75,NULL,'MAT, I, inv','ESO 510- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115990,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115990,33.99,0.43,62.9,50930,NULL,NULL,'Malmquist cor.','ESO 510- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115991,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115991,34.17,0.43,68.1,50930,75,NULL,'MAT, I, cor','ESO 510- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115992,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115992,37.73,0.23,352,50931,70,NULL,NULL,'2MASX J14012160+3942482',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000165,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,210.3397917,39.71336,0,NULL,59259572116,925930814,14467668,18.1),(115993,'IRAS','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115993,30.61,0.8,13.3,50932,75,NULL,'MAT, I','NGC 5398',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.00001,NULL,'12.78',1.7,'SB(rs)dm',NULL,NULL,NULL,NULL,1,210.339833,-33.06378,0.233,NULL,47001778335,734402786,11475043,12.78),(115994,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115994,28.66,0.32,5.39,50932,85,NULL,'I, inv','NGC 5398',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115995,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115995,28.74,0.32,5.57,50932,85,NULL,'I, raw','NGC 5398',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115996,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115996,29.09,0.2,6.58,50932,74.4,NULL,NULL,'NGC 5398',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115997,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115997,29.11,0.43,6.64,50932,75,NULL,'MAT, I, inv','NGC 5398',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115998,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115998,29.31,0.43,7.27,50932,75,NULL,'MAT, I, raw','NGC 5398',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115999,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115999,29.42,0.67,7.66,50932,NULL,NULL,'Malmquist cor.','NGC 5398',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116000,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116000,29.54,NULL,8.09,50932,NULL,NULL,NULL,'NGC 5398',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116001,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116001,29.55,0.63,8.11,50932,NULL,NULL,NULL,'NGC 5398',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116002,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116002,29.6,0.43,8.33,50932,75,NULL,'MAT, I, cor','NGC 5398',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116003,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116003,29.65,0.4,8.5,50932,73,NULL,'opt','NGC 5398',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116004,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116004,29.65,0.4,8.51,50932,NULL,NULL,NULL,'NGC 5398',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116005,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116005,31.31,0.4,18.3,50932,75,NULL,'B','NGC 5398',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116006,'Tully est','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116006,33.1,0.8,41.7,50933,75,NULL,'B','MRK 0465',NULL,'1988NBGC.C....0000T',1988,1,0.7,NULL,'G',0.000104,NULL,'14.5g',0.69,'S0/a',NULL,NULL,NULL,'Starburst',1,210.350083,36.80008,0,NULL,59153839063,924278735,14441855,14.5),(116007,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116007,37.33,0.33,292,50934,70,NULL,NULL,'2MASX J14012471+6222210',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000164,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,210.352958333,62.37264,0.029,NULL,57747456016,902304000,14098500,17.1),(116008,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116008,37.66,0.46,340,50935,70,NULL,NULL,'2MASX J14012490+6239090',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000148,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,210.3537917,62.65269,0.021,NULL,57747512962,902304890,14098513,17.8),(116009,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116009,37.2,0.33,275,50936,70,NULL,NULL,'2MASX J14012526+5938168',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,210.35525,59.63797,0.021,NULL,57273728951,894902014,13982843,17.1),(116010,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116010,37.35,0.27,295,50937,70,NULL,NULL,'2MASX J14012531+1931497',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'16.96',0.23,NULL,NULL,NULL,NULL,NULL,1,210.355417,19.5305,0.049,NULL,58326259011,911347797,14239809,16.96),(116011,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116011,34.64,0.48,84.8,50938,70,NULL,NULL,'CGCG 018-026',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.000073,NULL,'15.0g',0.55,NULL,NULL,NULL,NULL,NULL,1,210.3555,-0.62392,0.125,NULL,43593639708,681150620,10642978,15),(116012,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116012,37.03,0.46,254,50939,70,NULL,NULL,'2MASX J14012549+5655188',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000179,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,210.356083333,56.92206,0,NULL,57310894935,895482733,13991917,16.3),(116013,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116013,37.8,0.33,363,50940,70,NULL,NULL,'2MASX J14012612+1406153',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000134,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,210.3589583,14.10436,0,NULL,58369724309,912026942,14250420,17.7),(116014,'GRB','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'N',116014,37.75,NULL,354,50941,65,NULL,'L = 10e57 photons/s','GRB 790307',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116015,'GRB','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'N',116015,40.79,NULL,1440,50941,65,NULL,'L = 2 x 10e58 photons/s','GRB 790307',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116016,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116016,36.59,0.46,208,50942,70,NULL,NULL,'2MASX J14012807+4625119',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000176,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,210.366875,46.42003,0,NULL,59235371617,925552681,14461760,16.4),(116017,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116017,37.38,0.46,300,50943,70,NULL,NULL,'2MASX J14012928+1009502',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,210.372083,10.16394,0,NULL,58508081137,914188767,14284199,17.2),(116018,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116018,36.41,0.46,191,50944,70,NULL,NULL,'2MASX J14012954+3432432',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000168,NULL,'16.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,210.37325,34.54533,0,NULL,59149830345,924216099,14440876,16.7),(116019,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116019,33.35,0.45,46.7,50945,NULL,NULL,'K','ESO 384- G 033',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.00007,NULL,'14.66',0.8,'SB(rl)0^+',NULL,NULL,NULL,NULL,1,210.3740417,-34.24219,0.229,NULL,46883179947,732549686,11446088,14.66),(116020,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116020,33.62,0.4,53,50945,NULL,NULL,'mean','ESO 384- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116021,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116021,36.02,0.46,160,50946,70,NULL,NULL,'2MASX J14013116+1342173',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,210.38,13.70489,0,NULL,58371644819,912056950,14250889,17),(116022,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116022,36.57,0.46,206,50947,70,NULL,NULL,'2MASX J14013130+2027009',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.50',0.22,NULL,NULL,NULL,NULL,NULL,1,210.380333333,20.45022,0.047,NULL,59465092135,929142064,14517844,17.5),(116023,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116023,37.93,0.46,385,50948,70,NULL,NULL,'2MASX J14013143+3409022',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,210.381083333,34.15058,0,NULL,59151777250,924246519,14441351,17.3),(116024,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116024,37,0.46,251,50949,70,NULL,NULL,'2MASX J14013151+2842345',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.14',0.18,NULL,NULL,NULL,NULL,NULL,1,210.381291667,28.70975,0,NULL,60006900382,937607818,14650122,18.14),(116025,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116025,37.16,0.46,271,50950,70,NULL,NULL,'2MASX J14013159+5625538',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000177,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,210.381625,56.43175,0.005,NULL,57309377489,895459023,13991547,16.4),(116026,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116026,37.06,0.55,258,50951,70,NULL,NULL,'LCRS B135851.5-112459',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,210.3837083,-11.65728,0.165,NULL,43746812731,683543948,10680374,16.2),(116027,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116027,38.15,0.46,426,50952,70,NULL,NULL,'SDSS J140132.51+054933.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.3855,5.82603,0.032,NULL,58477728099,913714501,14276789,18.2),(116028,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116028,37.33,0.33,292,50953,70,NULL,NULL,'SDSS J140132.98+274202.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000169,NULL,'18.3g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.387416667,27.70067,0,NULL,60011821092,937684704,14651323,18.3),(116029,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116029,36.4,0.64,190,50954,70,NULL,NULL,'2MASX J14013315-1120541',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00012,NULL,'16.3b',0.3,NULL,NULL,NULL,NULL,NULL,1,210.388041667,-11.34853,0.165,NULL,43747503236,683554738,10680542,16.3),(116030,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116030,37.36,0.27,296,50955,70,NULL,NULL,'2MASX J14013395+2459095',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.44',0.2,NULL,NULL,NULL,NULL,NULL,1,210.3915,24.98611,0,NULL,59996579558,937446555,14647602,17.44),(116031,'BCG','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116031,37.06,0.35,249,50956,60,NULL,'ABELL 1837, BCG','2MASX J14013635-1107431',0.0376,'1980ApJ...241..486H',1980,1,1.4,NULL,'G',0.00001,NULL,'14.59',NULL,'cD','Brightest group member',NULL,NULL,NULL,1,210.401583,-11.12872,0.113,NULL,43747476515,683554320,10680536,14.59),(116032,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116032,36.77,0.75,226,50957,70,NULL,NULL,'2MASX J14013657-2117063',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.93',0.3,NULL,NULL,NULL,NULL,NULL,1,210.4022083,-21.28528,0.185,NULL,46516280310,726816879,11356513,15.93),(116033,'BCG','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116033,37.06,0.35,249,50958,60,NULL,NULL,'ABELL 1837',0.0376,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',0.00041,NULL,NULL,NULL,'I-II   [BM]',NULL,NULL,NULL,NULL,1,210.402917,-11.12444,0.113,NULL,43747199075,683549985,10680468,NULL),(116034,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116034,37.22,0.57,277,50959,70,NULL,NULL,'2MASX J14013848-0225589',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.000127,NULL,'16.1g',0.34,'E0',NULL,NULL,NULL,NULL,1,210.41025,-2.433,0.157,NULL,43603581519,681305961,10645405,16.1),(116035,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116035,36.99,0.33,250,50960,70,NULL,NULL,'2MASX J14013876+3833549',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000181,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,210.4114583,38.56519,0,NULL,59141550129,924086720,14438855,16.2),(116036,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116036,36.41,0.46,191,50961,70,NULL,NULL,'2MASX J14013883+2418095',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000189,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,210.411875,24.30267,0.01,NULL,59460637560,929072461,14516757,16.4),(116037,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116037,37.36,0.27,296,50962,70,NULL,NULL,'2MASX J14013983+2500025',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,210.415875,25.00072,0,NULL,59996459556,937444680,14647573,17.3),(116038,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116038,38.42,0.46,483,50963,70,NULL,NULL,'2MASX J14014094+0910072',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000134,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,210.420625,9.16875,0,NULL,58507464233,914179128,14284048,17.7),(116039,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116039,38.48,0.46,495,50964,70,NULL,NULL,'2MASX J14014149+6250551',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,210.423,62.84867,0.037,NULL,57747870546,902310477,14098601,17.7),(116040,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116040,38.07,0.46,410,50965,70,NULL,NULL,'2MASX J14014226+4045379',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000184,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,210.426,40.76044,0,NULL,59260533861,925945841,14467903,17.5),(116041,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116041,38.32,0.46,461,50966,70,NULL,NULL,'2MASX J14014303+6341531',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,210.42925,63.69819,0.025,NULL,57932110625,905189228,14143581,18.1);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (116042,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116042,37.96,0.46,391,50967,70,NULL,NULL,'2MASX J14014397+2832545',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.95',0.11,NULL,NULL,NULL,NULL,NULL,1,210.43325,28.54858,0,NULL,60006913921,937608030,14650125,18.95),(116043,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116043,38.13,0.46,422,50968,70,NULL,NULL,'SDSS J140144.81+151735.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.43675,15.29328,0,NULL,58382768688,912230760,14253605,18.5),(116044,'IRAS','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116044,34.57,0.8,81.9,50969,75,NULL,'W91CL, r','NGC 5409',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000017,NULL,'14.06',1.1,'(R\')SAB(s)b','in a radial-velocity based grouping',NULL,NULL,NULL,1,210.442,9.49028,0.013,NULL,58508343373,914192865,14284263,14.06),(116045,'IRAS','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116045,34.57,0.8,81.9,50969,75,NULL,'HMCL, I','NGC 5409',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116046,'IRAS','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116046,34.6,0.8,83.1,50969,75,NULL,'CF, r','NGC 5409',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116047,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116047,34.17,0.4,68.3,50969,75,NULL,'HMCL, I, raw','NGC 5409',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116048,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116048,34.21,0.38,69.5,50969,75,NULL,'CF, r, raw','NGC 5409',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116049,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116049,34.23,0.38,70.1,50969,75,NULL,'W91CL, r, raw','NGC 5409',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116050,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116050,34.35,0.38,74.2,50969,75,NULL,'CF, r, inv','NGC 5409',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116051,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116051,34.36,0.4,74.6,50969,75,NULL,'HMCL, I, inv','NGC 5409',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116052,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116052,34.38,0.38,75.3,50969,75,NULL,'W91CL, r, inv','NGC 5409',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116053,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116053,34.51,0.4,79.7,50969,75,NULL,'HMCL, I, cor','NGC 5409',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116054,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116054,34.51,0.38,80,50969,75,NULL,'CF, r, cor','NGC 5409',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116055,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116055,34.53,0.38,80.6,50969,75,NULL,'W91CL, r, cor','NGC 5409',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116056,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116056,34.63,0.5,84.1,50969,NULL,NULL,NULL,'NGC 5409',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116057,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116057,34.67,0.2,85.9,50969,74.4,NULL,NULL,'NGC 5409',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116058,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116058,34.71,0.48,87.3,50969,NULL,NULL,'Malmquist cor.','NGC 5409',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116059,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116059,34.81,0.4,91.7,50969,NULL,NULL,'mean','NGC 5409',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116060,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116060,34.91,0.47,95.7,50969,NULL,NULL,'H','NGC 5409',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116061,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116061,35.02,0.46,101,50969,NULL,NULL,'J','NGC 5409',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116062,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116062,35.06,0.45,103,50969,NULL,NULL,'K','NGC 5409',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116063,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116063,36,0.46,159,50970,70,NULL,NULL,'2MASX J14014610+1848280',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.52',0.23,NULL,NULL,NULL,NULL,NULL,1,210.442167,18.80772,0.049,NULL,58326828290,911356692,14239948,17.52),(116064,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116064,35.49,0.62,126,50971,70,NULL,NULL,'IC 0969',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.79',NULL,NULL,NULL,NULL,NULL,NULL,1,210.4425,-4.18039,0.089,NULL,43597189774,681206090,10643845,15.79),(116065,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116065,36.99,0.33,250,50972,70,NULL,NULL,'2MASX J14014626+3834349',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000187,NULL,'16.1g',0.39,'E0',NULL,NULL,NULL,NULL,1,210.442875,38.5765,0,NULL,59141549005,924086703,14438854,16.1),(116066,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116066,37.29,0.64,287,50973,70,NULL,NULL,'LCRS B135905.8-112006',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000143,NULL,'15.8b',0.6,NULL,NULL,NULL,NULL,NULL,1,210.442917,-11.57583,0.165,NULL,43746795000,683543671,10680369,15.8),(116067,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116067,35.13,0.46,106,50974,70,NULL,NULL,'CGCG 191-035',NULL,'2015arXiv151105856S',2015,1,0.97,NULL,'G',0.00008,NULL,'14.3g',0.79,NULL,NULL,NULL,NULL,NULL,1,210.444375,34.66781,0,NULL,59149824954,924216014,14440875,14.3),(116068,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116068,38.03,0.46,404,50975,70,NULL,NULL,'2MASX J14014843+4803158',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,210.4515417,48.05447,0.036,NULL,59243592334,925681130,14463767,17.6),(116069,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116069,37.73,0.23,352,50976,70,NULL,NULL,'2MASX J14015048+3943089',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000204,NULL,'16.1g',0.39,'E0',NULL,NULL,NULL,NULL,1,210.460417,39.71914,0,NULL,59259575058,925930860,14467669,16.1),(116070,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116070,38.47,0.46,494,50977,70,NULL,NULL,'2MASX J14015133+3255583',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,210.4639583,32.93297,0,NULL,60033934626,938030228,14656722,17.4),(116071,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:33','1','SN 2001gq',NULL,116071,42.26,0.12,1690,50978,74.2,NULL,'SALT 2','SDSS J140151.41+045312.5',0.671,'2010ApJ...716..712A',2010,1,0.05,NULL,'G',NULL,NULL,'21.5g',0.04,NULL,NULL,NULL,NULL,NULL,1,210.46425,4.88681,0.036,NULL,58480883103,913763798,14277559,21.5),(116072,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116072,38.22,0.33,441,50979,70,NULL,NULL,'2MASX J14015236+4245415',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000163,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,210.4682083,42.76164,0,NULL,59271858789,926122793,14470668,16.9),(116073,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116073,37.25,0.46,282,50980,70,NULL,NULL,'2MASX J14015249+2401275',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000173,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,210.468833333,24.02442,0.022,NULL,59460719918,929073748,14516777,16.9),(116074,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116074,36.95,0.46,245,50981,70,NULL,NULL,'2MASX J14015257+2250520',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.30',0.22,NULL,NULL,NULL,NULL,NULL,1,210.469125,22.84797,0,NULL,59474221006,929284703,14520073,17.3),(116075,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116075,34.96,0.27,98.3,50982,70,NULL,NULL,'CGCG 074-046 NED01',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000073,NULL,'15.63',0.33,NULL,NULL,NULL,NULL,NULL,1,210.4697917,9.63036,0.009,NULL,58508228417,914191069,14284235,15.63),(116076,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116076,37.51,0.63,317,50983,70,NULL,NULL,'2MASX J14015321-3629135',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,210.471667,-36.48703,0.217,NULL,46891109345,732673583,11448024,15.8),(116077,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116077,37.48,0.46,313,50984,70,NULL,NULL,'2MASX J14015514+3902439',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,210.479625,39.04553,0,NULL,59141366347,924083849,14438810,17),(116078,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116078,38.22,0.33,441,50985,70,NULL,NULL,'2MASX J14015681+4247075',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,210.486791667,42.78531,0,NULL,59271870442,926122975,14470671,18),(116079,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:33','1','SN 2000fr','R',116079,41.42,NULL,1250,50986,65,NULL,'SALT','SCP J140157.75+044342.4',0.543,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,210.490625,4.72844,0.037,NULL,58480705950,913761030,14277516,NULL),(116080,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:33','1','SN 2000fr',NULL,116080,41.77,0.1,1460,50986,74.2,NULL,'SALT 2','SCP J140157.75+044342.4',0.543,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116081,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:33','1','SN 2000fr',NULL,116081,42.39,0.14,1950,50986,70,NULL,'SALT','SCP J140157.75+044342.4',0.543,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116082,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:33','1','SN 2000fr',NULL,116082,42.56,0.11,2100,50986,65,NULL,'SALT','SCP J140157.75+044342.4',0.543,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116083,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:33','1','SN 2000fr',NULL,116083,42.68,0.19,2230,50986,65,NULL,NULL,'SCP J140157.75+044342.4',0.543,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116084,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116084,35.4,0.65,120,50987,NULL,NULL,'Malmquist cor.','ESO 578- G 016',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000033,NULL,'14.98',0.7,'SAB(r)bc',NULL,NULL,NULL,NULL,1,210.4959583,-22.36361,0.165,NULL,46520441977,726881905,11357529,14.98),(116085,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116085,35.63,0.58,134,50987,NULL,NULL,NULL,'ESO 578- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116086,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116086,35.67,0.2,136,50987,74.4,NULL,NULL,'ESO 578- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116087,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:33','1','SN 2001gn',NULL,116087,43.85,0.2,2770,50988,74.2,NULL,'SALT 2','SCP J140159.90+050459.6',1.124,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,210.499583,5.08322,0.039,NULL,58480847432,913763241,14277550,NULL),(116088,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116088,36.59,0.46,208,50989,70,NULL,NULL,'2MASX J14015991+2651506',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000185,NULL,'17.43',0.22,NULL,NULL,NULL,NULL,NULL,1,210.49975,26.86397,0,NULL,60012004115,937687564,14651368,17.43),(116089,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116089,36.68,0.46,217,50990,70,NULL,NULL,'2MASX J14020006+4533425',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000193,NULL,'15.8g',0.48,'E0',NULL,NULL,NULL,NULL,1,210.500375,45.56186,0,NULL,59236108667,925564197,14461940,15.8),(116090,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116090,36.46,0.46,196,50991,70,NULL,NULL,'2MASX J14020009+1927413',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,210.5005,19.46136,0.053,NULL,58326290804,911348293,14239817,16.6),(116091,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116091,36.41,0.55,191,50992,70,NULL,NULL,'2MASX J14020028-3302384',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.6b',NULL,'E',NULL,NULL,NULL,NULL,1,210.501083333,-33.04406,0.241,NULL,47001774449,734402725,11475042,16.6),(116092,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116092,37.36,0.46,297,50993,70,NULL,NULL,'SDSS J140200.41+592932.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000141,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,210.50175,59.49231,0.005,NULL,57273740812,894902200,13982846,18.5),(116093,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:33','1','SN 2001go',NULL,116093,41.8,0.11,1480,50994,74.2,NULL,'SALT 2','SCP J140200.95+050059.2',0.552,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,210.5039583,5.01644,0.036,NULL,58480838808,913763106,14277548,NULL),(116094,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116094,36.23,0.81,176,50995,70,NULL,NULL,'2MASX J14020167-2211235',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,210.507,-22.18989,0.169,NULL,46520407935,726881373,11357521,14.7),(116095,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116095,38.07,0.46,411,50996,70,NULL,NULL,'2MASX J14020319+1054518',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,210.513333,10.91447,0.032,NULL,58506706524,914167289,14283863,17.7),(116096,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116096,34.22,0.46,70,50997,NULL,NULL,NULL,'NGC 5414',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000013,NULL,'13.8',0.8,'PECULR','Group member of poor cluster',NULL,NULL,NULL,1,210.514708333,9.92933,0.006,NULL,58508064657,914188510,14284195,13.8),(116097,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116097,34.27,0.2,71.5,50997,74.4,NULL,NULL,'NGC 5414',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116098,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116098,34.36,0.43,74.5,50997,NULL,NULL,'Malmquist cor.','NGC 5414',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116099,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116099,36.85,0.46,235,50998,70,NULL,NULL,'2MASX J14020473+3342063',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000164,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,210.519625,33.70175,0,NULL,59148393865,924193654,14440525,17.2),(116100,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116100,37.67,0.46,341,50999,70,NULL,NULL,'SDSS J140204.91+491250.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000146,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,210.5204583,49.21403,0.041,NULL,59243301809,925676590,14463696,18),(116101,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116101,35.05,0.46,102,51000,70,NULL,NULL,'CGCG 018-029',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000093,NULL,'14.9g',0.66,'E','in a triple',NULL,NULL,NULL,1,210.5260417,-1.39647,0.133,NULL,43602689219,681292019,10645187,14.9),(116102,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116102,38.33,0.33,463,51001,70,NULL,NULL,'2MASX J14020803+1534068',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,210.533417,15.56861,0,NULL,58382850050,912232032,14253625,NULL),(116103,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116103,36.08,0.46,164,51002,70,NULL,NULL,'2MASX J14020834+1830164',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.99',0.21,NULL,NULL,NULL,NULL,NULL,1,210.534875,18.50478,0.076,NULL,58326600111,911353126,14239892,17.99),(116104,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116104,36.62,0.33,211,51003,70,NULL,NULL,'2MASX J14020849+1557168',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.77',0.22,NULL,NULL,NULL,NULL,NULL,1,210.535583,15.95464,0,NULL,58375103397,912110990,14251734,17.77),(116105,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116105,37.27,0.46,285,51004,70,NULL,NULL,'SDSS J140208.71+460340.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,210.536333,46.06122,0,NULL,59235596691,925556198,14461815,18.2),(116106,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116106,38.49,0.46,499,51005,70,NULL,NULL,'2MASX J14020922+1024097',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,210.5382917,10.40261,0.007,NULL,58510218923,914222170,14284721,18),(116107,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116107,36.55,0.46,205,51006,70,NULL,NULL,'B3 1400+379',NULL,'2015arXiv151105856S',2015,1,0.42,'TXS codes: confusion(W);lobes(C)','G',0.000171,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,210.542333,37.72322,0,NULL,59142877605,924107462,14439179,16.3),(116108,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116108,36.52,0.92,202,51007,70,NULL,NULL,'CGCG 018-032',NULL,'2014MNRAS.445.2677S',2014,1,1.05,NULL,'G',0.000074,NULL,'15.3g',0.42,'Sc','Isolated galaxy',NULL,NULL,NULL,1,210.544083,-0.23622,0.113,NULL,43593747480,681152304,10643004,15.3),(116109,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116109,33.95,0.23,61.7,51008,74.4,NULL,NULL,'ABELL S0753:[WFC91] 037',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.00005,NULL,'14.93',NULL,'S0',NULL,NULL,NULL,NULL,1,210.544708333,-33.79072,0.233,NULL,46880272537,732504258,11445379,14.93),(116110,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116110,34.04,0.51,64.1,51008,70,NULL,NULL,'ABELL S0753:[WFC91] 037',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116111,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116111,34.56,0.8,81.5,51009,75,NULL,'HMCL, I','NGC 5416',NULL,'1997ApJS..109..333W',1997,1,1.37,NULL,'G',0.00002,NULL,'13.8g',0.75,'Scd:','in a radial-velocity based grouping',NULL,NULL,NULL,1,210.547167,9.44011,0,NULL,58507824257,914184754,14284136,13.8),(116112,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116112,34.56,0.8,81.5,51009,75,NULL,'W91CL, r','NGC 5416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116113,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116113,34.57,0.8,82.2,51009,75,NULL,'CF, r','NGC 5416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116114,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116114,33.76,0.69,56.4,51009,100,NULL,'mid-IR','NGC 5416',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116115,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116115,34.23,0.38,70.1,51009,75,NULL,'CF, r, raw','NGC 5416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116116,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116116,34.33,0.38,73.3,51009,75,NULL,'W91CL, r, raw','NGC 5416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116117,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116117,34.38,0.47,75.1,51009,NULL,NULL,'H','NGC 5416',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116118,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116118,34.39,0.38,75.4,51009,75,NULL,'CF, r, inv','NGC 5416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116119,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116119,34.49,0.45,79.2,51009,NULL,NULL,'K','NGC 5416',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116120,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116120,34.5,0.38,79.3,51009,75,NULL,'W91CL, r, inv','NGC 5416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116121,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116121,34.5,0.2,79.4,51009,74.4,NULL,NULL,'NGC 5416',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116122,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116122,34.51,0.46,79.8,51009,NULL,NULL,'J','NGC 5416',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116123,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116123,34.53,0.08,80.5,51009,71,NULL,'ZW 74-23 Cluster  ','NGC 5416',NULL,'1982PASAu...4..419V',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116124,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116124,34.53,0.48,80.5,51009,NULL,NULL,NULL,'NGC 5416',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116125,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116125,34.53,0.38,80.6,51009,75,NULL,'CF, r, cor','NGC 5416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116126,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116126,34.61,0.38,83.5,51009,75,NULL,'W91CL, r, cor','NGC 5416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116127,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116127,34.61,0.47,83.6,51009,NULL,NULL,'Malmquist cor.','NGC 5416',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116128,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116128,34.73,0.4,88.1,51009,75,NULL,'HMCL, I, raw','NGC 5416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116129,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116129,34.79,0.16,90.8,51009,70,NULL,'ZW 74-23 Cluster  ','NGC 5416',NULL,'1992ApJ...396..453H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116130,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116130,34.81,0.4,91.4,51009,NULL,NULL,'mean','NGC 5416',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116131,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116131,34.9,0.4,95.4,51009,75,NULL,'HMCL, I, cor','NGC 5416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116132,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116132,34.97,0.4,98.5,51009,75,NULL,'HMCL, I, inv','NGC 5416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116133,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116133,35.91,0.49,152,51010,70,NULL,NULL,'2MASX J14021131-2212375',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000143,NULL,'15.50',0.6,NULL,NULL,NULL,NULL,NULL,1,210.547167,-22.21036,0.169,NULL,46520415174,726881487,11357523,15.5),(116134,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116134,35.64,0.46,135,51011,70,NULL,NULL,'2MASX J14021137+3339305',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000168,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,210.5472917,33.65842,0,NULL,59148377785,924193402,14440521,16.3),(116135,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116135,35.28,0.49,114,51012,75,NULL,'IR','ESO 578- G 017',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'16.01',0.2,'Sb             HII',NULL,NULL,NULL,NULL,1,210.5475417,-18.75425,0.249,NULL,43625988186,681656065,10650876,16.01),(116136,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116136,35.35,0.55,118,51012,NULL,NULL,'Malmquist cor.','ESO 578- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116137,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116137,35.4,0.54,120,51012,NULL,NULL,NULL,'ESO 578- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116138,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116138,35.45,0.2,123,51012,74.4,NULL,NULL,'ESO 578- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116139,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116139,32.38,0.2,29.9,51013,74.4,NULL,NULL,'NGC 5443',NULL,'2013AJ....146...86T',2013,1,2.28,'HOLM 578B is a star.','G',0.000027,NULL,'12.9g',0.8,'SB(s)b?','in a radial-velocity based grouping',NULL,NULL,NULL,1,210.549167,55.81403,0,NULL,57301204516,895331320,13989551,12.9),(116140,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116140,32.41,0.4,30.4,51013,NULL,NULL,'mean','NGC 5443',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116141,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116141,32.43,0.46,30.7,51013,NULL,NULL,'J','NGC 5443',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116142,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116142,32.44,0.43,30.8,51013,75,NULL,'3.6 micron, color corrected','NGC 5443',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116143,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116143,32.45,0.47,30.9,51013,NULL,NULL,'H','NGC 5443',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116144,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116144,32.5,0.45,31.6,51013,NULL,NULL,'K','NGC 5443',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116145,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116145,32.6,0.43,33.1,51013,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5443',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116146,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116146,37.26,0.46,283,51014,70,NULL,NULL,'2MASX J14021215+2444176',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,210.550541667,24.73831,0,NULL,59996591502,937446742,14647605,17.9),(116147,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116147,37.63,0.46,336,51015,70,NULL,NULL,'2MASX J14021278+6257487',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000187,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,210.55325,62.96358,0.037,NULL,57747877349,902310583,14098602,17.1),(116148,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116148,37.34,0.46,293,51016,70,NULL,NULL,'2MASX J14021297+1808324',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.33',0.16,NULL,NULL,NULL,NULL,NULL,1,210.5540417,18.14231,0.024,NULL,58372549359,912071083,14251110,18.33),(116149,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116149,34.32,0.4,73.2,51017,NULL,NULL,'mean','NGC 5417',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000032,NULL,'13.86',0.6,'Sa','in a radial-velocity based grouping',NULL,NULL,NULL,1,210.554333,8.03711,0.033,NULL,58513262332,914269723,14285464,13.86),(116150,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116150,34.39,0.47,75.5,51017,NULL,NULL,'H','NGC 5417',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116151,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116151,34.4,0.46,75.8,51017,NULL,NULL,'J','NGC 5417',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116152,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116152,34.41,0.45,76.1,51017,NULL,NULL,'K','NGC 5417',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116153,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116153,34.58,0.46,82.5,51017,NULL,NULL,'Malmquist cor.','NGC 5417',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116154,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116154,34.64,0.45,84.7,51017,NULL,NULL,NULL,'NGC 5417',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116155,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116155,34.94,0.2,97.3,51017,74.4,NULL,NULL,'NGC 5417',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116156,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116156,35.61,0.54,132,51018,70,NULL,NULL,'2MASX J14021301-1155477',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.8b',0.5,NULL,NULL,NULL,NULL,NULL,1,210.5542083,-11.93011,0.217,NULL,43713083812,683016934,10672139,15.8),(116157,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116157,33.31,0.47,45.9,51019,NULL,NULL,'H','ESO 174- G 005',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.00002,NULL,'15.84',0.9,'SAB(s)cd;asymm.disk',NULL,NULL,NULL,NULL,1,210.557167,-53.54083,NULL,NULL,46813534358,731461474,11429085,15.84),(116158,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116158,33.42,0.45,48.3,51019,NULL,NULL,'K','ESO 174- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116159,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116159,33.5,0.46,50.1,51019,NULL,NULL,'J','ESO 174- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116160,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116160,33.67,0.4,54.1,51019,NULL,NULL,'mean','ESO 174- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116161,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116161,34.96,0.27,98.3,51020,70,NULL,NULL,'2MASX J14021471+0946557',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00007,NULL,'15.82',0.29,NULL,NULL,NULL,NULL,NULL,1,210.561417,9.78228,0.009,NULL,58508191048,914190485,14284226,15.82),(116162,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116162,35.81,0.6,145,51021,70,NULL,NULL,'LCRS B135935.2-111945',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000097,NULL,'16.6b',0.3,NULL,NULL,NULL,NULL,NULL,1,210.565667,-11.56964,0.129,NULL,43746797066,683543704,10680370,16.6),(116163,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116163,37.73,0.46,352,51022,70,NULL,NULL,'2MASX J14021598+1735548',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.66',0.13,NULL,NULL,NULL,NULL,NULL,1,210.5665,17.5985,0.005,NULL,58372467250,912069800,14251090,18.66),(116164,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116164,37.57,0.46,327,51023,70,NULL,NULL,'2MASX J14021638+0518186',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.0001,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,210.568333333,5.30525,0.052,NULL,58480466319,913757286,14277457,16.7),(116165,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116165,38.18,0.46,433,51024,70,NULL,NULL,'2MASX J14021647+4146262',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,210.56875,41.77403,0,NULL,59259120951,925923764,14467558,17.5),(116166,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116166,37.36,0.27,296,51025,70,NULL,NULL,'2MASX J14021677+2456346',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000191,NULL,'17.93',0.17,NULL,NULL,NULL,NULL,NULL,1,210.570041667,24.94294,0,NULL,59996608264,937447004,14647609,17.93),(116167,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116167,33.07,0.97,41,51026,NULL,NULL,NULL,'NGC 5418',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.42',0.5,'SB?','in a radial-velocity based grouping',NULL,NULL,NULL,1,210.5732917,7.68417,0.029,NULL,58513209180,914268893,14285451,14.42),(116168,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116168,33.1,0.96,41.7,51026,NULL,NULL,'Malmquist cor.','NGC 5418',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116169,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116169,33.11,0.2,41.9,51026,74.4,NULL,NULL,'NGC 5418',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116170,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116170,33.62,0.47,53,51026,NULL,NULL,'H','NGC 5418',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116171,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116171,33.8,0.45,57.6,51026,NULL,NULL,'K','NGC 5418',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116172,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116172,33.81,0.46,57.9,51026,NULL,NULL,'J','NGC 5418',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116173,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116173,34.11,0.4,66.5,51026,NULL,NULL,'mean','NGC 5418',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116174,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116174,36.14,0.55,169,51027,70,NULL,NULL,'2MASX J14021759-2159006',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.1I',0.3,NULL,NULL,NULL,NULL,NULL,1,210.573375,-21.98356,0.201,NULL,46520868381,726888568,11357633,14.1),(116175,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116175,37.61,0.46,333,51028,70,NULL,NULL,'SDSS J140218.84+195519.3',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.21',0.18,NULL,NULL,NULL,NULL,NULL,1,210.5785,19.92203,0.042,NULL,59466093758,929157714,14518089,18.21),(116176,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116176,37.77,0.46,359,51029,70,NULL,NULL,'2MASX J14022013+2128565',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.49',0.15,NULL,NULL,NULL,NULL,NULL,1,210.5839583,21.48242,0.014,NULL,59473579510,929274679,14519916,18.49),(116177,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116177,37.09,0.46,262,51030,70,NULL,NULL,'2MASX J14022028+2014225',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.46',0.26,NULL,NULL,NULL,NULL,NULL,1,210.5845,20.23969,0.041,NULL,59465120969,929142515,14517851,17.46),(116178,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116178,37.1,0.46,263,51031,70,NULL,NULL,'2MASX J14022031+2950536',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.13',0.2,NULL,NULL,NULL,NULL,NULL,1,210.584667,29.84817,0,NULL,60007217231,937612769,14650199,17.13),(116179,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116179,36.74,0.46,223,51032,70,NULL,NULL,'2MASX J14022087+0543436',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000178,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,210.587083,5.72886,0.031,NULL,58480425532,913756648,14277447,16.6),(116180,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116180,37.33,0.46,292,51033,70,NULL,NULL,'2MASX J14022187+2751026',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000147,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,210.591,27.85058,0,NULL,60011626599,937681665,14651276,17.7),(116181,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116181,38.64,0.46,534,51034,70,NULL,NULL,'SDSS J140222.21+545228.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,210.592583333,54.87458,0.009,NULL,57298933096,895295829,13988997,18.2),(116182,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116182,37.32,0.46,291,51035,70,NULL,NULL,'2MASX J14022234+2811316',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.14',0.19,NULL,NULL,NULL,NULL,NULL,1,210.59325,28.19211,0,NULL,60008170550,937627664,14650432,18.14),(116183,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116183,38.33,0.33,463,51036,70,NULL,NULL,'2MASX J14022284+1532045',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,210.5952083,15.53469,0,NULL,58382847903,912231998,14253624,17.7),(116184,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116184,36.98,0.46,248,51037,70,NULL,NULL,'SDSS J140223.79+043724.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000063,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,210.599167,4.62356,0.073,NULL,58480674007,913760531,14277508,17.7),(116185,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116185,35.11,0.46,105,51038,70,NULL,NULL,'SBS 1400+519',NULL,'2015arXiv151105856S',2015,1,0.57,'Two MAPS entries for the same object.','G',0.000163,NULL,'15.3g',0.49,'E',NULL,NULL,NULL,NULL,1,210.602167,51.68697,0.009,NULL,59217577763,925274652,14457416,15.3),(116186,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116186,35.05,0.49,102,51039,75,NULL,'IR','CGCG 074-054',NULL,'2011yCatp016004901K',2011,1,1.06,NULL,'G',0.000044,NULL,'15.1g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,210.608166667,10.40564,0.007,NULL,58510190484,914221726,14284714,15.1),(116187,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116187,38.77,0.46,568,51040,70,NULL,NULL,'SDSS J140226.19-013358.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000137,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,210.609167,-1.56633,0.133,NULL,43603012407,681297068,10645266,18.5),(116188,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116188,36.62,0.46,210,51041,70,NULL,NULL,'2MASX J14022700+2546096',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000107,NULL,'15.3g',0.58,NULL,NULL,NULL,NULL,NULL,1,210.61275,25.76925,0,NULL,60010902072,937670344,14651099,15.3),(116189,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116189,35.62,0.56,133,51042,70,NULL,NULL,'2MASX J14022715-2159415',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.05',NULL,NULL,NULL,NULL,NULL,NULL,1,210.613083,-21.99508,0.201,NULL,46520868262,726888566,11357633,16.05),(116190,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116190,35.98,0.46,157,51043,70,NULL,NULL,'2MASX J14023016+2922093',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00021,NULL,'15.14',0.29,'S0',NULL,NULL,NULL,NULL,1,210.625583,29.36933,0,NULL,60007838430,937622475,14650351,15.14),(116191,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116191,34.47,0.8,78.3,51044,75,NULL,'HMCL, I','UGC 08948',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000013,NULL,'15.37',0.6,'SBb','Group member of poor cluster',NULL,NULL,NULL,1,210.6372083,9.07972,0.009,NULL,58515379727,914302808,14285981,15.37),(116192,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116192,34.47,0.8,78.3,51044,75,NULL,'CF, r','UGC 08948',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116193,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116193,34.47,0.8,78.3,51044,75,NULL,'W91CL, r','UGC 08948',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116194,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116194,33.36,0.49,46.9,51044,NULL,NULL,NULL,'UGC 08948',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116195,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116195,33.4,0.2,47.9,51044,74.4,NULL,NULL,'UGC 08948',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116196,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116196,33.81,0.4,57.8,51044,NULL,NULL,'Malmquist cor.','UGC 08948',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116197,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116197,34.35,0.38,74.2,51044,75,NULL,'W91CL, r, raw','UGC 08948',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116198,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116198,34.47,0.4,78.3,51044,75,NULL,'HMCL, I, raw','UGC 08948',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116199,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116199,34.47,0.38,78.3,51044,75,NULL,'W91CL, r, inv','UGC 08948',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116200,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116200,34.62,0.4,83.9,51044,75,NULL,'HMCL, I, inv','UGC 08948',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116201,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116201,34.63,0.38,84.2,51044,75,NULL,'W91CL, r, cor','UGC 08948',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116202,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116202,34.73,0.38,88.3,51044,75,NULL,'CF, r, raw','UGC 08948',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116203,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116203,34.73,0.4,88.4,51044,75,NULL,'HMCL, I, cor','UGC 08948',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116204,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116204,34.88,0.38,94.6,51044,75,NULL,'CF, r, inv','UGC 08948',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116205,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116205,34.89,0.38,95.1,51044,75,NULL,'CF, r, cor','UGC 08948',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116206,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116206,32.73,0.46,35.1,51045,NULL,NULL,'J','ESO 384- G 035',NULL,'2007A&A...465...71T',2007,1,1.5,'Star superposed.','G',0.000013,NULL,'13.55',1.2,'I?             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,210.638125,-33.39942,0.241,NULL,47001861137,734404080,11475063,13.55),(116207,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116207,32.79,0.47,36.1,51045,NULL,NULL,'H','ESO 384- G 035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116208,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116208,32.93,0.45,38.5,51045,NULL,NULL,'K','ESO 384- G 035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116209,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116209,33.75,0.4,56.1,51045,NULL,NULL,'mean','ESO 384- G 035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116210,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116210,37.64,0.23,337,51046,70,NULL,NULL,'2MASX J14023314+0538565',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,210.6382083,5.64903,0.061,NULL,58480637640,913759963,14277499,17),(116211,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116211,37.71,0.46,348,51047,70,NULL,NULL,'SDSS J140233.43+020440.5',NULL,'2015arXiv151105856S',2015,1,0.1,NULL,'G',0.00008,NULL,'18.7g',0.09,NULL,NULL,NULL,NULL,NULL,1,210.639333333,2.07792,0.061,NULL,58417342774,912770980,14262046,18.7),(116212,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116212,32.76,0.49,35.7,51048,75,NULL,'IR','IC 0970',NULL,'2011yCatp016004901K',2011,1,1.37,NULL,'G',0.00009,NULL,'14.2g',0.39,'S0/a','Pair member (points to parent)',NULL,NULL,NULL,1,210.6425417,14.55256,0,NULL,58369840483,912028757,14250449,14.2),(116213,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116213,34.84,0.49,92.8,51049,75,NULL,'IR','CGCG 074-056',NULL,'2011yCatp016004901K',2011,1,0.77,NULL,'G',0.000107,NULL,'16.6g',0.22,'S','Group member',NULL,NULL,NULL,1,210.647917,9.11922,0.009,NULL,58515378411,914302787,14285981,16.6),(116214,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116214,33.92,0.49,60.8,51050,75,NULL,'IR','NGC 5433',NULL,'2011yCatp016004901K',2011,1,1.6,'HOLM 574B is a star.','G',0.000017,NULL,'14.10',0.4,'Sdm:           HII','Possible field galaxy',NULL,NULL,NULL,1,210.650333333,32.51044,0,NULL,60033269949,938019842,14656560,14.1),(116215,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116215,36.37,0.46,188,51051,70,NULL,NULL,'2MASX J14023664+2832074',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.99',0.25,NULL,NULL,NULL,NULL,NULL,1,210.652583,28.53547,0,NULL,60006388295,937599817,14649997,16.99),(116216,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116216,36.63,0.76,212,51052,70,NULL,NULL,'2MASX J14023758-0435589',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.72',0.23,NULL,NULL,NULL,NULL,NULL,1,210.656833,-4.59981,0.069,NULL,43729243586,683269431,10676084,16.72),(116217,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116217,37.53,0.46,321,51053,70,NULL,NULL,'2MASX J14023738+0342465',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,'FoF','16.77',0.24,NULL,NULL,NULL,NULL,NULL,1,210.6582083,3.70881,0.021,NULL,58408727505,912636367,14259943,16.77),(116218,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116218,34.86,0.49,93.9,51054,75,NULL,'IR','UGC 08953',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000033,NULL,'15.68',0.2,'S?',NULL,NULL,NULL,NULL,1,210.659708333,18.52311,0.052,NULL,58326886891,911357607,14239962,15.68),(116219,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116219,35.14,0.4,107,51054,NULL,NULL,'mean','UGC 08953',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116220,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116220,35.22,0.2,111,51054,74.4,NULL,NULL,'UGC 08953',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116221,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116221,35.36,0.47,118,51054,NULL,NULL,'H','UGC 08953',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116222,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116222,37.92,0.46,384,51055,70,NULL,NULL,'2MASX J14023829+5759006',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00014,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,210.659583,57.9835,0,NULL,57308704531,895448508,13991382,18.3),(116223,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116223,37.19,0.46,274,51056,70,NULL,NULL,'2MASX J14023928+5049524',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000163,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,210.6637083,50.83119,0.01,NULL,59250669249,925791707,14465495,17.1),(116224,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116224,37.05,0.33,258,51057,70,NULL,NULL,'2MASX J14023980+5509026',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000187,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,210.665917,55.15086,0.005,NULL,57301817802,895340903,13989701,16.2),(116225,'GRB','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116225,43.06,NULL,4090,51058,72,NULL,'Pseudo-Redshift D, zD = 9.4','GRB 090429B',NULL,'2011ApJ...736....7C',2011,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,210.667125,32.17053,0,NULL,60033194217,938018659,14656541,NULL),(116226,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116226,38.16,0.46,429,51059,70,NULL,NULL,'SDSS J140242.14+162349.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.675583,16.39719,0,NULL,58375060870,912110326,14251723,17.9),(116227,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116227,34.42,0.8,76.7,51060,75,NULL,'HMCL, I','UGC 08950',NULL,'1997ApJS..109..333W',1997,1,1.48,NULL,'G',0.00002,NULL,'16.5g',0.14,'Scd','Group member',NULL,NULL,NULL,1,210.675875,9.16414,0.009,NULL,58507816742,914184636,14284134,16.5),(116228,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116228,34.43,0.8,76.7,51060,75,NULL,'W91CL, r','UGC 08950',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116229,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116229,33.74,NULL,55.9,51060,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08950',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116230,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116230,33.76,NULL,56.4,51060,NULL,NULL,'Dipole + Quadrupole','UGC 08950',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116231,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116231,33.77,NULL,56.6,51060,NULL,NULL,'Dipole','UGC 08950',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116232,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116232,33.8,NULL,57.6,51060,NULL,NULL,NULL,'UGC 08950',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116233,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116233,34.18,0.38,68.6,51060,75,NULL,'W91CL, r, inv','UGC 08950',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116234,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116234,34.2,0.6,69.3,51060,NULL,NULL,NULL,'UGC 08950',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116235,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116235,34.24,0.38,70.4,51060,75,NULL,'W91CL, r, raw','UGC 08950',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116236,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116236,34.24,0.2,70.5,51060,74.4,NULL,NULL,'UGC 08950',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116237,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116237,34.27,0.4,71.3,51060,75,NULL,'HMCL, I, inv','UGC 08950',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116238,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116238,34.27,0.4,71.3,51060,75,NULL,'HMCL, I, raw','UGC 08950',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116239,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116239,34.54,0.51,80.9,51060,NULL,NULL,'Malmquist cor.','UGC 08950',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116240,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116240,34.54,0.38,80.9,51060,75,NULL,'W91CL, r, cor','UGC 08950',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116241,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116241,34.59,0.4,82.7,51060,75,NULL,'HMCL, I, cor','UGC 08950',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116242,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116242,37.72,0.46,350,51061,70,NULL,NULL,'2MASX J14024224+3210505',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.55',0.14,NULL,NULL,NULL,NULL,NULL,1,210.675875,32.18064,0,NULL,60033194141,938018658,14656541,18.55),(116243,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116243,37.64,0.23,337,51062,70,NULL,NULL,'2MASX J14024379+0544055',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000195,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,210.682583,5.73492,0.027,NULL,58480446736,913756980,14277452,16.1),(116244,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116244,33.26,0.25,44.9,51063,74.4,NULL,NULL,'ABELL S0753:[WFC91] 045',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000107,NULL,'16.6b',NULL,'S0',NULL,NULL,NULL,NULL,1,210.686125,-34.96258,0.241,NULL,46882773380,732543334,11445989,16.6),(116245,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116245,37.05,0.33,258,51064,70,NULL,NULL,'2MASX J14024473+5513335',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,210.686583,55.22589,0.005,NULL,57302044647,895344447,13989756,17.7),(116246,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116246,37.58,0.46,328,51065,70,NULL,NULL,'2MASX J14024628+2337332',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,210.692875,23.626,0.048,NULL,59472487539,929257617,14519650,17.6),(116247,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116247,37.89,0.46,378,51066,70,NULL,NULL,'2MASX J14024638+1111443',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.91',0.17,NULL,NULL,NULL,NULL,NULL,1,210.693167,11.1955,0,NULL,58507366768,914177605,14284025,17.91),(116248,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116248,37.37,0.46,298,51067,70,NULL,NULL,'2MASX J14024647+0510575',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000106,NULL,'16.2g',0.37,'AGN',NULL,NULL,NULL,NULL,1,210.693833333,5.18253,0.039,NULL,58480982613,913765353,14277583,16.2),(116249,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116249,36.98,0.46,249,51068,70,NULL,NULL,'2MASX J14024673+4435374',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,210.694917,44.59369,0,NULL,59233807950,925528249,14461378,17.4),(116250,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116250,35.81,0.59,145,51069,70,NULL,NULL,'LCRS B140006.5-112637',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.0001,NULL,'16.1b',0.3,NULL,NULL,NULL,NULL,NULL,1,210.6962917,-11.68389,0.129,NULL,43746696166,683542127,10680345,16.1),(116251,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116251,36.62,0.33,211,51070,70,NULL,NULL,'SDSS J140248.05+154743.5',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.0g',0.38,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.70025,15.79542,0,NULL,58374430674,912100479,14251569,16),(116252,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116252,37.71,0.33,348,51071,70,NULL,NULL,'2MASX J14024809+5952455',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000183,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,210.7004583,59.87928,0.021,NULL,57276953961,894952405,13983631,16.5),(116253,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116253,37.27,0.46,285,51072,70,NULL,NULL,'2MASX J14024822+4607214',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000205,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,210.700875,46.12267,0,NULL,59235582061,925555969,14461812,16.4),(116254,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116254,38.4,0.46,478,51073,70,NULL,NULL,'2MASX J14024840+2758175',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000174,NULL,'18.71',0.14,NULL,NULL,NULL,NULL,NULL,1,210.701583,27.97158,0,NULL,60011617315,937681520,14651273,18.71),(116255,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116255,34.48,0.25,78.7,51074,74.4,NULL,NULL,'NGC 5423',NULL,'2013AJ....146...86T',2013,1,1.31,NULL,'G',0.000073,NULL,'13.7g',0.89,'S0-:','in a radial-velocity based grouping',NULL,NULL,NULL,1,210.702583,9.34139,0,NULL,58507912179,914186127,14284158,13.7),(116256,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116256,34.96,0.27,98.3,51074,70,NULL,NULL,'NGC 5423',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116257,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116257,34.44,0.45,77.1,51074,NULL,NULL,'K','NGC 5423',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116258,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116258,34.72,0.4,87.9,51074,NULL,NULL,'mean','NGC 5423',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116259,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116259,34.84,0.56,93.1,51075,70,NULL,NULL,'2MASX J14024898-4138174',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.2,NULL,NULL,NULL,NULL,NULL,1,210.7042083,-41.63817,0.225,NULL,46912080143,733001252,11453144,13.9),(116260,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116260,37.22,0.46,278,51076,70,NULL,NULL,'2MASX J14024936+2440235',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00017,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,210.705833,24.67322,0,NULL,59996416750,937444011,14647562,16.9),(116261,'Ring Diameter','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116261,30.7,0.98,14,51077,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5448',NULL,'1981ApJS...45..541P',1981,1,1.49,NULL,'G',0.000033,NULL,'13.0g',1.02,'(R)SAB(r)a     AGN','in a radial-velocity based grouping',NULL,NULL,NULL,1,210.7084583,49.17269,0.041,NULL,59243046770,925672605,14463634,13),(116262,'Ring Diameter','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116262,31,0.76,16,51077,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5448',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116263,'Sosies','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116263,32.71,0.18,34.8,51077,NULL,NULL,NULL,'NGC 5448',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116264,'Tully est','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116264,32.57,0.8,32.6,51077,75,NULL,'B','NGC 5448',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116265,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116265,32.57,0.2,32.7,51077,74.4,NULL,NULL,'NGC 5448',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116266,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116266,32.58,0.43,32.8,51077,75,NULL,'3.6 micron, color corrected','NGC 5448',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116267,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116267,32.68,0.43,34.4,51077,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5448',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116268,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116268,32.71,0.4,34.8,51077,NULL,NULL,'mean','NGC 5448',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116269,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116269,32.92,0.45,38.3,51077,NULL,NULL,'K','NGC 5448',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116270,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116270,32.93,0.47,38.5,51077,NULL,NULL,'H','NGC 5448',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116271,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116271,32.94,0.46,38.8,51077,NULL,NULL,'J','NGC 5448',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116272,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116272,36.56,0.69,205,51078,70,NULL,NULL,'2MASX J14025013-1027263',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,210.709,-10.45736,0.081,NULL,43750089641,683595150,10681174,16.8),(116273,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116273,36.37,0.46,188,51079,70,NULL,NULL,'2MASX J14025018+2157352',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.26',0.15,NULL,NULL,NULL,NULL,NULL,1,210.7092083,21.95992,0.028,NULL,59473467345,929272927,14519889,18.26),(116274,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116274,36.66,0.46,215,51080,70,NULL,NULL,'2MASXi J1402503+571239',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,210.7097917,57.21092,0.013,NULL,57310837960,895481843,13991903,17.6),(116275,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116275,37.9,0.46,379,51081,70,NULL,NULL,'SDSS J140250.88+102447.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000132,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.7120417,10.41319,0.007,NULL,58510304784,914223512,14284742,18.4),(116276,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116276,34.43,0.8,76.9,51082,75,NULL,'HMCL, I','UGC 08951',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.00002,NULL,'16.24',0.2,'Scd:','Group member',NULL,NULL,NULL,1,210.712125,8.77981,0.018,NULL,58515623610,914306618,14286040,16.24),(116277,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116277,34.43,0.8,76.9,51082,75,NULL,'W91CL, r','UGC 08951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116278,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116278,34.52,0.53,80.1,51082,NULL,NULL,NULL,'UGC 08951',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116279,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116279,34.56,0.2,81.7,51082,74.4,NULL,NULL,'UGC 08951',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116280,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116280,34.72,0.48,88,51082,NULL,NULL,'Malmquist cor.','UGC 08951',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116281,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116281,34.82,0.4,92.2,51082,75,NULL,'HMCL, I, raw','UGC 08951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116282,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116282,34.92,0.4,96.3,51082,75,NULL,'HMCL, I, inv','UGC 08951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116283,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116283,34.94,0.38,97.4,51082,75,NULL,'W91CL, r, raw','UGC 08951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116284,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116284,34.98,0.4,98.9,51082,75,NULL,'HMCL, I, cor','UGC 08951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116285,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116285,34.99,0.38,99.6,51082,75,NULL,'W91CL, r, inv','UGC 08951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116286,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116286,35.04,0.38,102,51082,75,NULL,'W91CL, r, cor','UGC 08951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116287,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116287,36.46,0.46,196,51083,70,NULL,NULL,'2MASX J14025091+3840496',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000174,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,210.712125,38.68036,0,NULL,59141455854,924085247,14438831,16.2),(116288,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116288,37.64,0.23,337,51084,70,NULL,NULL,'2MASX J14025129+0542045',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.18',0.17,NULL,NULL,NULL,NULL,NULL,1,210.71375,5.70144,0.027,NULL,58480435356,913756802,14277450,18.18),(116289,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116289,36.23,0.46,177,51085,70,NULL,NULL,'2MASX J14025185+2956431',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.66',0.29,NULL,NULL,NULL,NULL,NULL,1,210.715917,29.94528,0,NULL,60007371508,937615179,14650237,16.66),(116290,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116290,37.02,0.33,254,51086,70,NULL,NULL,'2MASX J14025250+1649599',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.76',0.33,NULL,NULL,NULL,NULL,NULL,1,210.7187917,16.83347,0,NULL,58375691948,912120186,14251877,16.76),(116291,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116291,38.11,0.46,420,51087,70,NULL,NULL,'SDSS J140252.56+132444.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00016,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,210.7190417,13.41236,0,NULL,58360120735,911876886,14248076,18.7),(116292,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116292,38.09,0.46,415,51088,70,NULL,NULL,'SDSS J140253.04+531436.8',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000203,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,210.7210417,53.24356,0,NULL,59216230872,925253607,14457087,17.9),(116293,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116293,36.65,0.46,214,51089,70,NULL,NULL,'2MASX J14025316+4951175',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,210.721667,49.85467,0.049,NULL,59254192857,925846763,14466355,17.5),(116294,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116294,37.56,0.33,326,51090,70,NULL,NULL,'2MASX J14025438+1552599',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.30',0.16,NULL,NULL,NULL,NULL,NULL,1,210.726667,15.88325,0,NULL,58374426564,912100415,14251568,18.3),(116295,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116295,33.17,0.23,43.1,51091,74.4,NULL,NULL,'ABELL S0753:[WFC91] 047',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000047,NULL,'15.05',NULL,'S0',NULL,NULL,NULL,NULL,1,210.7317083,-34.25564,0.241,NULL,46882158679,732533729,11445839,15.05),(116296,'D-Sigma','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116296,34.44,0.4,77.4,51092,75,NULL,'Edat, raw','NGC 5424',NULL,'1997ApJS..109..333W',1997,1,1.6,'Often incorrectly called \\\"NGC 5724\\\" in the literature.','G',0.00005,NULL,'14.00',1.3,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,210.732083,9.42067,0,NULL,58507908505,914186070,14284157,14),(116297,'D-Sigma','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116297,34.78,0.4,90.3,51092,75,NULL,'Edat, cor','NGC 5424',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116298,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116298,34.33,0.25,73.5,51092,74.4,NULL,NULL,'NGC 5424',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116299,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116299,34.74,0.45,88.7,51092,NULL,NULL,'K','NGC 5424',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116300,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116300,34.78,0.4,90.5,51092,NULL,NULL,'mean','NGC 5424',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116301,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116301,38.04,0.19,406,51093,70,NULL,NULL,'SDSS J140259.13+153702.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.746417,15.61733,0,NULL,58374446238,912100722,14251573,18.2),(116302,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116302,37.23,0.33,279,51094,70,NULL,NULL,'2MASX J14025924+2859325',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'18.37',0.17,'E',NULL,NULL,NULL,NULL,1,210.746958333,28.99233,0,NULL,60006964861,937608825,14650137,18.37),(116303,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116303,36.89,0.55,239,51095,70,NULL,NULL,'2MASX J14025990-4625480',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,210.749666667,-46.43006,0.393,NULL,46797474391,731210537,11425164,17),(116304,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116304,38.18,0.46,432,51096,70,NULL,NULL,'2MASX J14030033+1535549',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,210.7514583,15.59864,0,NULL,58374446978,912100734,14251573,17.3),(116305,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1998D',NULL,116305,31.3,0.17,18.2,51097,70.8,NULL,NULL,'NGC 5440',NULL,'2008MNRAS.389.1577T',2008,1,2.64,NULL,'G',0.00002,NULL,'13.0g',0.87,'Sa','in a radial-velocity based grouping',NULL,NULL,NULL,1,210.754333333,34.75786,0,NULL,59149746093,924214782,14440855,13),(116306,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1998D',NULL,116306,33.67,0.31,53.6,51097,72,NULL,NULL,'NGC 5440',0.0123,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116307,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1998D',NULL,116307,33.79,0.08,57.3,51097,74.4,NULL,NULL,'NGC 5440',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116308,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1998D',NULL,116308,34.09,0.63,64.2,51097,65,NULL,'MLCS2k2','NGC 5440',0.0123,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116309,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116309,33.74,0.4,56,51097,NULL,NULL,'mean','NGC 5440',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116310,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116310,33.79,0.08,57.3,51097,74.4,NULL,NULL,'NGC 5440',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116311,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116311,34.01,0.47,63.4,51097,NULL,NULL,'H','NGC 5440',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116312,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116312,34.02,0.46,63.8,51097,NULL,NULL,'J','NGC 5440',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116313,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116313,34.04,0.45,64.4,51097,NULL,NULL,'K','NGC 5440',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116314,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116314,34.67,0.4,85.9,51097,75,NULL,'HOSTS SN 1998D','NGC 5440',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116315,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116315,36.6,0.46,209,51098,70,NULL,NULL,'2MASX J14030113+1905483',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.40',0.17,NULL,NULL,NULL,NULL,NULL,1,210.75475,19.09686,0.037,NULL,58326445151,911350705,14239854,18.4),(116316,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116316,37.71,0.33,348,51099,70,NULL,NULL,'2MASX J14030181+5947013',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00014,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,210.757875,59.78381,0.021,NULL,57276928097,894952001,13983625,17.8),(116317,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116317,36.82,0.46,232,51100,70,NULL,NULL,'2MASX J14030190+2648342',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000191,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,210.757917,26.80964,0,NULL,60012023032,937687859,14651372,16.2),(116318,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116318,37.11,0.46,264,51101,70,NULL,NULL,'2MASX J14030201+2820402',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000202,NULL,'16.0g',0.43,NULL,NULL,NULL,NULL,NULL,1,210.758417,28.34444,0,NULL,60006339475,937599054,14649985,16),(116319,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116319,36.67,0.46,216,51102,70,NULL,NULL,'2MASX J14030242-0020082',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000103,NULL,'16.1g',0.34,'S0',NULL,NULL,NULL,NULL,1,210.760125,-0.33556,0.145,NULL,43601918439,681279975,10644999,16.1),(116320,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116320,38.14,0.46,425,51103,70,NULL,NULL,'2MASXi J1403035-004947',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000083,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,210.76475,-0.82983,0.141,NULL,43602770746,681293292,10645207,18),(116321,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116321,33.88,0.47,59.6,51104,NULL,NULL,'H','UGC 08961',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000033,NULL,'14.87',0.3,'S?',NULL,NULL,NULL,NULL,1,210.76725,28.03342,0,NULL,60008197990,937628093,14650438,14.87),(116322,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116322,33.92,0.45,60.8,51104,NULL,NULL,'K','UGC 08961',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116323,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116323,33.94,0.46,61.5,51104,NULL,NULL,'J','UGC 08961',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116324,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116324,34.13,0.4,67,51104,NULL,NULL,'mean','UGC 08961',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116325,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116325,34.27,0.49,71.3,51104,75,NULL,'IR','UGC 08961',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116326,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116326,34.35,0.2,74.1,51104,74.4,NULL,NULL,'UGC 08961',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116327,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116327,34.36,0.46,74.4,51105,70,NULL,NULL,'CGCG 074-064',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000097,NULL,'15.1',0.6,NULL,'Group member',NULL,NULL,NULL,1,210.768583,8.9475,0.009,NULL,58515374919,914302733,14285980,15.1),(116328,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116328,37.02,0.33,254,51106,70,NULL,NULL,'2MASX J14030448+1653059',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.21',0.19,NULL,NULL,NULL,NULL,NULL,1,210.76875,16.88489,0,NULL,58375760338,912121255,14251894,18.21),(116329,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116329,36.64,0.46,212,51107,70,NULL,NULL,'2MASX J14030448+2446252',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000113,NULL,'15.3g',0.51,NULL,NULL,NULL,NULL,NULL,1,210.768833,24.77364,0,NULL,59996425007,937444140,14647564,15.3),(116330,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116330,38.25,0.46,446,51108,70,NULL,NULL,'2MASX J14030455+6536206',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000075,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,210.7689583,65.60569,0.049,NULL,57945383176,905396612,14146822,18.3),(116331,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116331,37.64,0.23,337,51109,70,NULL,NULL,'SDSS J140305.44+054718.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,210.7727083,5.78853,0.027,NULL,58480434180,913756784,14277449,17.7),(116332,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116332,37.3,0.46,289,51110,70,NULL,NULL,'2MASX J14030685+2248473',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.50',0.15,NULL,NULL,NULL,NULL,NULL,1,210.778667,22.81322,0,NULL,59474404973,929287577,14520118,18.5),(116333,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116333,38.24,0.46,444,51111,70,NULL,NULL,'2MASX J14030692+3857035',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,210.7787917,38.95108,0,NULL,59141484677,924085698,14438839,17.3),(116334,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116334,34.18,0.5,68.4,51112,70,NULL,NULL,'2MASX J14030755-0442102',NULL,'2014MNRAS.445.2677S',2014,1,0.91,NULL,'G',0.000093,NULL,'15.07',0.46,NULL,NULL,NULL,NULL,NULL,1,210.781291667,-4.70286,0.069,NULL,43729208827,683268887,10676076,15.07),(116335,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116335,34.37,0.23,74.8,51113,74.4,NULL,NULL,'ABELL S0753:[WFC91] 049',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.00005,NULL,'14.57',0.9,'S0',NULL,NULL,NULL,NULL,1,210.782917,-34.03286,0.233,NULL,47002944717,734421011,11475328,14.57),(116336,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116336,34.87,0.47,94,51113,70,NULL,NULL,'ABELL S0753:[WFC91] 049',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116337,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116337,34.13,0.23,67,51114,74.4,NULL,NULL,'ABELL S0753:[WFC91] 051',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000043,NULL,'14.67',NULL,'E',NULL,NULL,NULL,NULL,1,210.783667,-34.09864,0.241,NULL,46882104915,732532889,11445826,14.67),(116338,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116338,36.34,0.33,185,51115,70,NULL,NULL,'2MASX J14030823+3517020',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000183,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,210.78425,35.28389,0,NULL,59150074398,924219912,14440936,16.4),(116339,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116339,37.47,0.46,312,51116,70,NULL,NULL,'2MASX J14030859+5343394',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,210.785916667,53.72758,0,NULL,59215257066,925238391,14456849,17.7),(116340,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116340,37.72,0.33,349,51117,70,NULL,NULL,'2MASX J14030912+0606264',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,210.787917,6.10739,0.052,NULL,58512171298,914252676,14285198,17.1),(116341,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116341,37.38,0.46,300,51118,70,NULL,NULL,'2MASX J14030966+3309180',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.27',0.15,NULL,NULL,NULL,NULL,NULL,1,210.7902917,33.15494,0,NULL,60033804193,938028190,14656690,18.27),(116342,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116342,36.42,0.46,192,51119,70,NULL,NULL,'2MASX J14030976+1811033',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.41',0.17,NULL,NULL,NULL,NULL,NULL,1,210.790833,18.18419,0.04,NULL,58373046376,912078849,14251232,18.41),(116343,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116343,36.8,0.46,230,51120,70,NULL,NULL,'2MASX J14030979+5856123',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000159,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,210.790917,58.93672,0,NULL,57271307828,894864184,13982252,16.9),(116344,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116344,35.75,0.46,141,51121,70,NULL,NULL,'SDSS J140309.90+121504.2',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.1g',0.33,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.7912917,12.25117,0.021,NULL,58359656989,911869640,14247963,16.1),(116345,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116345,37.54,0.46,322,51122,70,NULL,NULL,'2MASX J14031049+1214188',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000139,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,210.7937083,12.23858,0.021,NULL,58359651334,911869552,14247961,17.6),(116346,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116346,37.17,0.46,272,51123,70,NULL,NULL,'2MASX J14031052+1545188',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.70',0.13,NULL,NULL,NULL,NULL,NULL,1,210.7937917,15.75514,0,NULL,58374477396,912101209,14251581,18.7),(116347,'Brightest Stars','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116347,28.4,NULL,4.79,51124,NULL,NULL,'M supergiants','MESSIER 101',NULL,'1986AJ.....91..808H',1986,1,28.8,'M102 may be a duplicate obs. of M101; see Sawyer, JRASC 41, Nos 7&8, 1947.','G',0.000007,NULL,'8.31',26.9,'SAB(rs)cd      HII','Isolated galaxy',NULL,NULL,NULL,1,210.80225,54.34894,0,NULL,57282582663,895040354,13985005,8.31),(116348,'Brightest Stars','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116348,28.9,NULL,6.03,51124,NULL,NULL,'Photographic','MESSIER 101',NULL,'1980A&A....83..354C',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116349,'Brightest Stars','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116349,29.2,NULL,6.92,51124,NULL,NULL,'Photographic','MESSIER 101',NULL,'1983AJ.....88.1569S',1983,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116350,'Brightest Stars','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116350,29.3,NULL,7.24,51124,NULL,NULL,'Photographic','MESSIER 101',NULL,'1980ApJ...241..598H',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116351,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116351,28.46,0.12,4.92,51124,73,NULL,'Cepheids periods Gaussian, Data 1','MESSIER 101',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116352,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116352,28.66,0.09,5.4,51124,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian, Data 1','MESSIER 101',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116353,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116353,28.73,0.03,5.57,51124,73,NULL,'Cepheids periods Gaussian, Data 2','MESSIER 101',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116354,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116354,28.79,0.06,5.73,51124,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian, Data 2','MESSIER 101',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116355,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116355,28.85,0.09,5.89,51124,73,NULL,'Cepheids magnitudes Gaussian, Data 2','MESSIER 101',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116356,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116356,28.87,0.06,5.94,51124,73,NULL,'Cepheids magnitudes Gaussian, Data 1','MESSIER 101',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116357,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116357,28.89,0.17,6,51124,NULL,18.45,'LMC ZP','MESSIER 101',NULL,'2009AcA....59..403M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116358,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116358,28.96,0.11,6.19,51124,NULL,NULL,'VI(W), Z, 619','MESSIER 101',NULL,'2013ApJ...777...79M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116359,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116359,29.04,0.08,6.43,51124,NULL,NULL,'8, H','MESSIER 101',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116360,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116360,29.04,0.08,6.43,51124,NULL,NULL,'8, H','MESSIER 101',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116361,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116361,29.04,0.05,6.43,51124,NULL,18.41,'235, VI','MESSIER 101',NULL,'2011ApJ...733..124S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116362,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116362,29.05,0.14,6.46,51124,NULL,NULL,NULL,'MESSIER 101',NULL,'1998ApJ...508..491S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116363,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116363,29.06,0.11,6.49,51124,NULL,NULL,'29, VI +Z','MESSIER 101',NULL,'2001ApJ...553..562N',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116364,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116364,29.13,0.11,6.7,51124,NULL,NULL,'25, VI, +Z, KEY PROJECT','MESSIER 101',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116365,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116365,29.13,0.11,6.7,51124,NULL,NULL,'25, VI, KEY PROJECT','MESSIER 101',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116366,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116366,29.14,0.09,6.73,51124,NULL,NULL,'LMC VIHJK','MESSIER 101',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116367,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116367,29.16,0.09,6.79,51124,NULL,NULL,'29, VI','MESSIER 101',NULL,'2001ApJ...553..562N',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116368,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116368,29.18,0.08,6.85,51124,NULL,18.54,'LMC ZP','MESSIER 101',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116369,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116369,29.2,0.08,6.91,51124,NULL,NULL,'LMC W01','MESSIER 101',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116370,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116370,29.2,0.07,6.92,51124,NULL,NULL,'50, VI, inner field','MESSIER 101',NULL,'1998ApJ...498..181K',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116371,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116371,29.21,0.17,6.95,51124,NULL,NULL,'61, VI','MESSIER 101',NULL,'1998ApJ...508..491S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116372,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116372,29.21,0.09,6.95,51124,NULL,NULL,'30, VI, inner field, log P > 1.2 days','MESSIER 101',NULL,'1998ApJ...498..181K',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116373,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116373,29.21,0.06,6.95,51124,74.4,NULL,NULL,'MESSIER 101',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116374,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116374,29.23,0.07,7.01,51124,NULL,NULL,'MW HIPP','MESSIER 101',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116375,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116375,29.24,0.08,7.05,51124,NULL,NULL,'LMC VIHJK','MESSIER 101',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116376,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116376,29.26,0.15,7.11,51124,NULL,NULL,'MW P02','MESSIER 101',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116377,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116377,29.27,NULL,7.14,51124,NULL,18.47,'2, R, Photographic','MESSIER 101',NULL,'1987SAAOC..11..125W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116378,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116378,29.29,0.2,7.21,51124,NULL,18.45,'LMC ZP','MESSIER 101',NULL,'2009AcA....59..403M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116379,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116379,29.3,0.07,7.24,51124,NULL,NULL,'MW GFG','MESSIER 101',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116380,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116380,29.3,NULL,7.24,51124,NULL,NULL,'2, R, for LMC m-M = 18.50','MESSIER 101',NULL,'1986ApJ...301L..45C',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116381,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116381,29.3,0.07,7.24,51124,NULL,NULL,'102, VI','MESSIER 101',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116382,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116382,29.34,0.1,7.38,51124,NULL,NULL,'HST KP Calibrated','MESSIER 101',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116383,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116383,29.34,0.08,7.38,51124,NULL,NULL,'24, VI, outer field, log P > 1.2 days','MESSIER 101',NULL,'1998ApJ...498..181K',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116384,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116384,29.34,0.1,7.38,51124,NULL,NULL,'61, VI','MESSIER 101',NULL,'1996ApJ...463...26K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116385,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116385,29.37,0.01,7.48,51124,NULL,NULL,'8, I','MESSIER 101',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116386,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116386,29.37,0.1,7.48,51124,NULL,NULL,'8, I','MESSIER 101',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116387,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116387,29.39,0.18,7.5,51124,NULL,NULL,'29, VIB','MESSIER 101',NULL,'1994AAS...185.2406K',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116388,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116388,29.38,NULL,7.52,51124,NULL,NULL,'2, R','MESSIER 101',NULL,'1991PASP..103..933M',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116389,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116389,29.39,0.07,7.55,51124,NULL,NULL,'29, VI, outer field','MESSIER 101',NULL,'1998ApJ...498..181K',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116390,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116390,29.45,0.08,7.76,51124,NULL,NULL,'8, H','MESSIER 101',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116391,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116391,29.45,0.08,7.76,51124,NULL,NULL,'8, H','MESSIER 101',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116392,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116392,29.58,0.09,8.24,51124,NULL,NULL,'8, I','MESSIER 101',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116393,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116393,29.58,0.09,8.24,51124,NULL,NULL,'8, I','MESSIER 101',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116394,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116394,29.59,NULL,8.28,51124,NULL,NULL,'31, VI','MESSIER 101',NULL,'2006A&A...452..423P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116395,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116395,29.6,0.04,8.32,51124,NULL,NULL,'BVRI+','MESSIER 101',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116396,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116396,29.61,0.04,8.36,51124,NULL,NULL,'BVRI','MESSIER 101',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116397,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116397,29.71,0.18,8.75,51124,NULL,NULL,'8, V','MESSIER 101',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116398,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116398,29.71,0.18,8.75,51124,NULL,NULL,'8, V','MESSIER 101',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116399,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116399,29.77,0.09,8.99,51124,NULL,NULL,'8, V','MESSIER 101',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116400,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116400,29.77,0.09,8.99,51124,NULL,NULL,'8, V','MESSIER 101',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116401,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116401,30.13,NULL,10.6,51124,NULL,18.48,'R(V) = 1.1450, Z fixed at gamma = -0.23 mag/dex','MESSIER 101',NULL,'2015MNRAS.449.1171N',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116402,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116402,30.14,NULL,10.7,51124,NULL,18.48,'R(V) = 1.2899, Z fixed at gamma = -0.23 mag/dex','MESSIER 101',NULL,'2015MNRAS.449.1171N',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116403,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116403,30.14,0.01,10.7,51124,NULL,18.48,'R(V) = 1.1450, Z any','MESSIER 101',NULL,'2015MNRAS.449.1171N',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116404,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116404,30.14,NULL,10.7,51124,NULL,18.48,'R(V) = 1.4695, Z fixed at gamma = -0.23 mag/dex','MESSIER 101',NULL,'2015MNRAS.449.1171N',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116405,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116405,30.15,0.01,10.7,51124,NULL,18.48,'R(V) = 1.2899, Z any','MESSIER 101',NULL,'2015MNRAS.449.1171N',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116406,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116406,30.15,0.01,10.7,51124,NULL,18.48,'R(V) = 1.4695, Z any','MESSIER 101',NULL,'2015MNRAS.449.1171N',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116407,'M Stars','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116407,28.6,0.2,5.25,51124,NULL,NULL,'Photographic','MESSIER 101',NULL,'1983ApJ...264..458H',1983,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116408,'PNLF','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116408,29.36,0.15,7.45,51124,NULL,NULL,NULL,'MESSIER 101',NULL,'1997ApJ...479..231F',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116409,'PNLF','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116409,29.42,0.13,7.66,51124,NULL,NULL,'HST KP Calibrated','MESSIER 101',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116410,'PNLF','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116410,29.42,0.15,7.7,51124,NULL,NULL,'27','MESSIER 101',NULL,'1996ApJ...461L..25F',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116411,'RSV Stars','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116411,29.35,0.24,7.4,51124,NULL,NULL,'19 RSGV','MESSIER 101',NULL,'2006AAS...208.1303J',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116412,'RSV Stars','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116412,29.4,0.16,7.59,51124,NULL,NULL,'42, I,RSGV','MESSIER 101',NULL,'2000MNRAS.313..868J',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116413,'RSV Stars','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116413,29.4,0.16,7.59,51124,NULL,NULL,'RSV','MESSIER 101',NULL,'1998PhDT.........5J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116414,'S Doradus Stars','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116414,28.6,NULL,5.25,51124,NULL,NULL,NULL,'MESSIER 101',NULL,'1989A&A...217...87W',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116415,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116415,28.86,0.12,5.92,51124,72,NULL,'H, Mandel et al. (2009)','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116416,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116416,28.87,0.17,5.94,51124,72,NULL,'J, Mandel et al. (2009)','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116417,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116417,28.91,0.33,6.05,51124,72,NULL,'J, Wood-Vasey et al. (2008)','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116418,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116418,28.93,0.2,6.11,51124,72,NULL,'Ks, Mandel et al. (2009)','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116419,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116419,28.93,0.16,6.11,51124,72,NULL,'H, Wood-Vasey et al. (2008)','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116420,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116420,28.94,0.18,6.14,51124,72,NULL,'J, Folatelli et al. (2010) [2]','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116421,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116421,28.94,0.13,6.14,51124,72,NULL,'J, Burns et al. (2011)','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116422,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116422,28.98,0.27,6.25,51124,72,NULL,'Ks, Folatelli et al. (2010) [1]','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116423,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116423,28.99,0.19,6.28,51124,72,NULL,'H, Krisciunas et al. (2004)','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116424,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116424,29,0.26,6.31,51124,72,NULL,'Ks, Wood-Vasey et al. (2008)','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116425,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116425,29.01,0.11,6.34,51124,72,NULL,'H, Burns et al. (2011)','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116426,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116426,29.01,NULL,6.34,51124,72,NULL,'MEAN OF 19','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116427,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116427,29.04,0.18,6.43,51124,72,NULL,'J, Folatelli et al. (2010) [1]','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116428,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116428,29.05,0.08,6.46,51124,73,NULL,'SALT2, all data','MESSIER 101',NULL,'2012A&A...546A..12V',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116429,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116429,29.06,0.13,6.49,51124,72,NULL,'Ks, Krisciunas et al. (2004)','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116430,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116430,29.08,0.14,6.55,51124,72,NULL,'J, Krisciunas et al. (2004)','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116431,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116431,29.08,0.19,6.55,51124,72,NULL,'H, Folatelli et al. (2010) [1]','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116432,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116432,29.08,0.15,6.55,51124,72,NULL,'J, Kattner et al. (2012)','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116433,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116433,29.1,0.08,6.61,51124,73,NULL,'SALT2, -7 to +40 days','MESSIER 101',NULL,'2012A&A...546A..12V',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116434,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116434,29.11,NULL,6.64,51124,NULL,NULL,'B','MESSIER 101',NULL,'2013NewA...20...30M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116435,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116435,29.11,0.27,6.64,51124,72,NULL,'Ks, Folatelli et al. (2010) [2]','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116436,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116436,29.13,0.01,6.69,51124,70,NULL,'SiFTO+SALT2, SN PTF11kly, SN 2011fe','MESSIER 101',0.000804,'2012MNRAS.426.2359M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116437,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116437,29.17,0.19,6.82,51124,72,NULL,'H, Folatelli et al. (2010) [2]','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116438,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116438,29.17,0.15,6.82,51124,72,NULL,'H, Kattner et al. (2012)','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116439,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116439,29.23,0.07,7.01,51124,73,NULL,'MLCS2k2, -7 to +40 days','MESSIER 101',NULL,'2012A&A...546A..12V',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116440,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116440,29.3,NULL,7.24,51124,NULL,NULL,'Rc','MESSIER 101',NULL,'2013NewA...20...30M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116441,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116441,29.33,NULL,7.35,51124,NULL,NULL,'Ic','MESSIER 101',NULL,'2013NewA...20...30M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116442,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116442,29.38,NULL,7.52,51124,NULL,NULL,'V','MESSIER 101',NULL,'2013NewA...20...30M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116443,'SNII radio','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1970G',NULL,116443,29.35,0.38,7.4,51124,NULL,NULL,NULL,'MESSIER 101',NULL,'1998ApJ...500...51W',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116444,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116444,29.05,0.06,6.46,51124,NULL,NULL,'I','MESSIER 101',NULL,'2011ApJ...733..124S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116445,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116445,29.12,0.14,6.68,51124,NULL,NULL,'Field 1','MESSIER 101',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116446,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116446,29.17,0.13,6.81,51124,NULL,NULL,'Field 2','MESSIER 101',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116447,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116447,29.19,0.14,6.89,51124,NULL,NULL,'Field 3','MESSIER 101',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116448,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116448,29.21,0.06,6.95,51124,74.4,NULL,NULL,'MESSIER 101',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116449,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116449,29.3,0.01,7.24,51124,NULL,NULL,'I, 0.12 mag systematic error','MESSIER 101',NULL,'2012ApJ...760L..14L',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116450,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116450,29.3,0.01,7.24,51124,NULL,NULL,'HOST SN 2011fe','MESSIER 101',NULL,'2013AAS...22143202J',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116451,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116451,29.34,0.09,7.38,51124,NULL,NULL,'I','MESSIER 101',NULL,'2007ApJ...661..815R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116452,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116452,29.39,0.05,7.55,51124,NULL,NULL,'I','MESSIER 101',NULL,'2011arXiv1112.0439T',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116453,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116453,29.42,0.11,7.66,51124,NULL,NULL,NULL,'MESSIER 101',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116454,'Type II Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116454,29.03,0.32,6.4,51124,NULL,18.45,'LMC ZP','MESSIER 101',NULL,'2009AcA....59..403M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116455,'Statistical','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116455,29.35,0.01,7.42,51124,NULL,NULL,'21 estimates','MESSIER 101',NULL,'2014arXiv1410.7843C',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116456,'HII region diameter','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116456,28.18,0.28,4.33,51124,NULL,NULL,'Photographic','MESSIER 101',NULL,'1982ApJ...255L..29L',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116457,'HII region diameter','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116457,28.8,NULL,5.75,51124,NULL,NULL,'Photographic','MESSIER 101',NULL,'1980A&A....83..354C',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116458,'HII region diameter','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116458,29.19,0.14,6.9,51124,NULL,NULL,NULL,'MESSIER 101',NULL,'2005JKAS...38....7I',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116459,'SNII optical','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1970G',NULL,116459,29.06,0.83,6.5,51124,NULL,NULL,'EPM, first use of','MESSIER 101',NULL,'1974ApJ...193...27K',1974,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116460,'SNII optical','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1970G',NULL,116460,29.35,0.4,7.4,51124,NULL,NULL,NULL,'MESSIER 101',NULL,'1994ApJ...432...42S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116461,'SNII optical','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1970G',NULL,116461,29.4,0.58,7.6,51124,NULL,NULL,'EPM','MESSIER 101',NULL,'1992ApJ...395..366S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116462,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116462,27.07,NULL,2.6,51124,75,NULL,'CO','MESSIER 101',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116463,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116463,27.96,NULL,3.9,51124,75,NULL,'HI','MESSIER 101',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116464,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116464,28.65,0.4,5.4,51124,75,NULL,'B','MESSIER 101',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116465,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116465,29.2,0.5,6.92,51124,NULL,18.45,'SN 1970G host','MESSIER 101',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116466,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116466,29.24,NULL,7.05,51124,NULL,NULL,'B','MESSIER 101',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116467,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116467,29.37,NULL,7.48,51124,NULL,NULL,'I','MESSIER 101',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116468,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116468,29.62,0.41,8.39,51124,53.9,NULL,'MESSIER 101 Group','MESSIER 101',NULL,'1984A&A...132..253R',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116469,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116469,30.91,NULL,15.2,51124,NULL,NULL,'LEDA [April 2006]','MESSIER 101',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116470,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116470,33.88,0.25,59.7,51125,74.4,NULL,NULL,'ESO 384- G 036',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000047,NULL,'14.05',0.9,'SA0-',NULL,NULL,NULL,NULL,1,210.80425,-33.35778,0.241,NULL,47001892255,734404566,11475071,14.05),(116471,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116471,34.01,0.4,63.3,51125,NULL,NULL,'mean','ESO 384- G 036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116472,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116472,34.31,0.45,72.9,51125,NULL,NULL,'K','ESO 384- G 036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116473,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116473,36.26,0.75,179,51126,70,NULL,NULL,'2MASX J14031312-1357499',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,210.804833,-13.96383,0.241,NULL,43643545378,681930396,10655162,16.7),(116474,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116474,37.72,0.33,349,51127,70,NULL,NULL,'2MASX J14031331+0610081',NULL,'2015arXiv151105856S',2015,1,0.45,'TXS codes: lobes(C)','G',0.000223,NULL,'16.2g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,210.805375,6.16897,0.052,NULL,58512135231,914252112,14285189,16.2),(116475,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116475,37.59,0.46,329,51128,70,NULL,NULL,'2MASX J14031338+4942240',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000151,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,210.805666667,49.7065,0.049,NULL,59254066085,925844782,14466324,16.8),(116476,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116476,37.81,0.46,364,51129,70,NULL,NULL,'SDSS J140314.49+091245.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.810375,9.21264,0.009,NULL,58507873428,914185522,14284148,18.2),(116477,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116477,37.31,0.46,290,51130,70,NULL,NULL,'2MASX J14031499+0609111',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.32',0.16,NULL,NULL,NULL,NULL,NULL,1,210.812333,6.15297,0.052,NULL,58512142561,914252227,14285191,18.32),(116478,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116478,36.44,0.46,194,51131,70,NULL,NULL,'2MASX J14031592+2627573',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000174,NULL,'16.0g',0.43,NULL,NULL,NULL,NULL,NULL,1,210.8165,26.46594,0,NULL,60011970729,937687042,14651360,16),(116479,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116479,38.01,0.46,400,51132,70,NULL,NULL,'2MASX J14031648+4314213',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,210.818583,43.23922,0,NULL,59233071514,925516742,14461199,17.7),(116480,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116480,34.9,0.8,95.6,51133,75,NULL,'MAT, I','ESO 446- G 001',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.21',0.9,'SA(s)bc:       HII',NULL,NULL,NULL,NULL,1,210.818666667,-31.34811,0.321,NULL,47035836037,734934938,11483358,14.21),(116481,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116481,34.28,0.43,71.9,51133,75,NULL,'MAT, I, raw','ESO 446- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116482,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116482,34.3,0.32,72.4,51133,85,NULL,'I, raw','ESO 446- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116483,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116483,34.35,0.57,74.2,51133,NULL,NULL,'Malmquist cor.','ESO 446- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116484,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116484,34.35,0.32,74.3,51133,85,NULL,'I, inv','ESO 446- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116485,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116485,34.51,0.43,80,51133,75,NULL,'MAT, I, cor','ESO 446- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116486,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116486,34.54,0.43,80.9,51133,75,NULL,'MAT, I, inv','ESO 446- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116487,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116487,34.57,0.51,82.2,51133,NULL,NULL,NULL,'ESO 446- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116488,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116488,34.65,0.2,85.1,51133,74.4,NULL,NULL,'ESO 446- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116489,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116489,35.06,0.47,103,51133,NULL,NULL,'H','ESO 446- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116490,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116490,35.22,0.4,110,51133,NULL,NULL,'mean','ESO 446- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116491,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116491,35.26,0.46,113,51133,NULL,NULL,'J','ESO 446- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116492,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116492,35.29,0.45,114,51133,NULL,NULL,'K','ESO 446- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116493,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116493,36.34,0.33,185,51134,70,NULL,NULL,'2MASX J14031702+3519373',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000193,NULL,'15.9g',0.35,NULL,NULL,NULL,NULL,NULL,1,210.82075,35.327,0,NULL,59149206130,924206345,14440724,15.9),(116494,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116494,35.95,0.53,155,51135,70,NULL,NULL,'2MASX J14031748-1419479',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,210.82275,-14.32992,0.229,NULL,43643386177,681927909,10655123,16.1),(116495,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116495,37.54,0.46,322,51136,70,NULL,NULL,'2MASX J14031889+1342080',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000137,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,210.8287083,13.70231,0,NULL,58361930636,911905166,14248518,17.5),(116496,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116496,38.04,0.19,406,51137,70,NULL,NULL,'2MASX J14031950+1531230',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.58',0.15,'BrClG',NULL,NULL,NULL,NULL,1,210.831208333,15.52297,0,NULL,58374278927,912098108,14251532,18.58),(116497,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116497,38.09,0.46,415,51138,70,NULL,NULL,'2MASX J14032000+2759154',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,210.833291667,27.98764,0,NULL,60008199519,937628117,14650439,17.8),(116498,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116498,37.83,0.46,367,51139,70,NULL,NULL,'2MASX J14032012+0341584',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000101,NULL,'16.8g',0.28,'AGN',NULL,NULL,NULL,NULL,1,210.83375,3.69958,0.021,NULL,58408712163,912636127,14259939,16.8),(116499,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116499,32.6,0.43,33.1,51140,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08988',NULL,'2014MNRAS.444..527S',2014,1,1.62,NULL,'G',0.000142,NULL,'15.1g',0.3,'Sc',NULL,NULL,NULL,NULL,1,210.83425,60.99019,0,NULL,57262881897,894732529,13980195,15.1),(116500,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116500,32.66,0.43,34.1,51140,75,NULL,'3.6 micron, color corrected','UGC 08988',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116501,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116501,32.74,0.4,35.3,51140,75,NULL,NULL,'UGC 08988',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116502,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116502,32.76,0.2,35.7,51140,74.4,NULL,NULL,'UGC 08988',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116503,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116503,32.99,0.44,39.7,51140,NULL,NULL,'Malmquist cor.','UGC 08988',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116504,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116504,33.06,0.43,40.9,51140,NULL,NULL,NULL,'UGC 08988',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116505,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116505,33.13,0.49,42.3,51140,75,NULL,'IR','UGC 08988',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116506,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116506,33.32,NULL,46.2,51140,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08988',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116507,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116507,33.33,NULL,46.4,51140,NULL,NULL,'Dipole + Quadrupole','UGC 08988',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116508,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116508,33.34,NULL,46.6,51140,NULL,NULL,'Dipole','UGC 08988',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116509,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116509,37.23,0.33,279,51141,70,NULL,NULL,'2MASX J14032036+2857224',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'18.05',0.17,'S0',NULL,NULL,NULL,NULL,1,210.834917,28.95619,0,NULL,60006493980,937601468,14650022,18.05),(116510,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116510,28.4,NULL,4.8,51142,NULL,NULL,NULL,'NGC 5408',NULL,'2002A&A...385...21K',2002,1,1.6,NULL,'G',0.00001,NULL,'12.5B',0.8,'IB(s)m         HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,210.837125,-41.37769,0.265,NULL,46911885554,732998211,11453097,12.5),(116511,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116511,28.45,0.1,4.9,51142,NULL,NULL,NULL,'NGC 5408',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116512,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116512,28.63,0.1,5.32,51142,74.4,NULL,NULL,'NGC 5408',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116513,'Tully est','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116513,28.43,0.8,4.9,51142,75,NULL,NULL,'NGC 5408',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116514,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116514,37.41,0.33,303,51143,70,NULL,NULL,'SDSS J140320.95+232556.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.837333333,23.43225,0.008,NULL,59472525888,929258217,14519659,18.1),(116515,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116515,34.36,0.49,74.5,51144,75,NULL,'IR','ESO 510- G 051',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000063,NULL,'16.46',0.1,'S...',NULL,NULL,NULL,NULL,1,210.838083,-26.56008,0.149,NULL,46992788034,734262313,11472848,16.46),(116516,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116516,36.64,0.46,213,51145,70,NULL,NULL,'2MASX J14032155+1253430',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00019,NULL,'16.1g',0.31,'E0',NULL,NULL,NULL,NULL,1,210.839625,12.89544,0,NULL,58360565297,911883832,14248184,16.1),(116517,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116517,27.88,1.22,3.77,51146,NULL,NULL,NULL,'NGC 5434',NULL,'2009ApJS..182..474S',2009,1,1.13,'UZC has V = 4651 +- 37 km/sec.','G',0.000058,NULL,'14.1g',1.11,'SAc','Pair member (points to parent)',NULL,NULL,NULL,1,210.846417,9.44808,0,NULL,58507900236,914185941,14284155,14.1),(116518,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116518,27.9,1.21,3.8,51146,NULL,NULL,'Malmquist cor.','NGC 5434',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116519,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116519,35.95,0.61,155,51147,70,NULL,NULL,'2MASX J14032369-1422097',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,210.848833333,-14.36947,0.229,NULL,43643635870,681931810,10655184,16.4),(116520,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116520,38.63,0.46,533,51148,70,NULL,NULL,'SDSS J140323.99+082013.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.85,8.33706,0.029,NULL,58515088119,914298251,14285910,18.2),(116521,'D-Sigma','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116521,33.39,0.4,47.6,51149,75,NULL,'Edat, raw','NGC 5444',NULL,'1997ApJS..109..333W',1997,1,1.62,NULL,'G',0.000033,NULL,'12.8g',1.25,'E+:','in a radial-velocity based grouping',NULL,NULL,NULL,1,210.8505417,35.13211,0,NULL,59150007667,924218869,14440919,12.8),(116522,'D-Sigma','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116522,33.72,0.4,55.5,51149,75,NULL,'Edat, cor','NGC 5444',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116523,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116523,33.69,0.45,54.7,51149,NULL,NULL,'K','NGC 5444',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116524,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116524,33.83,0.4,58.3,51149,NULL,NULL,'mean','NGC 5444',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116525,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116525,37.41,0.46,303,51150,70,NULL,NULL,'2MASX J14032483+1628571',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.62',0.17,NULL,NULL,NULL,NULL,NULL,1,210.8535417,16.48253,0,NULL,58374738421,912105287,14251645,18.62),(116526,'Tully est','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116526,32.77,0.8,35.9,51151,75,NULL,'B','NGC 5426',NULL,'1988NBGC.C....0000T',1988,1,3,NULL,'G',0.000017,NULL,'12.68',1.6,'SA(s)c pec','Pair member (points to parent)',NULL,NULL,NULL,1,210.8535417,-6.06911,0.081,NULL,43727217793,683237778,10675590,12.68),(116527,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116527,33,0.4,39.9,51151,NULL,NULL,'mean','NGC 5426',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116528,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116528,33.04,0.46,40.5,51151,NULL,NULL,'J','NGC 5426',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116529,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116529,33.04,0.47,40.6,51151,NULL,NULL,'H','NGC 5426',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116530,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116530,33.09,0.45,41.5,51151,NULL,NULL,'K','NGC 5426',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116531,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116531,38.04,0.19,406,51152,70,NULL,NULL,'2MASX J14032506+1520201',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,210.854291667,15.33892,0,NULL,58374235417,912097428,14251522,17.9),(116532,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116532,37.56,0.33,326,51153,70,NULL,NULL,'2MASX J14032504+1556131',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.82',0.19,NULL,NULL,NULL,NULL,NULL,1,210.854417,15.93706,0,NULL,58374319827,912098747,14251542,17.82),(116533,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116533,38.04,0.19,406,51154,70,NULL,NULL,'2MASX J14032581+1525541',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,210.857416667,15.43181,0,NULL,58374288002,912098250,14251535,17.7),(116534,'Sosies','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116534,32.34,0.83,29.4,51155,NULL,NULL,NULL,'NGC 5427',NULL,'2002A&A...393...57T',2002,1,2.8,'The APM position is 11 arcsec northwest of the nucleus.','G',0.00001,NULL,'11.93',2.4,'SA(s)c pec;Sy2 HII','Pair member (points to parent)',NULL,NULL,'Sy 2',1,210.8585417,-6.03081,0.081,NULL,43727217945,683237780,10675590,11.93),(116535,'Tully est','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116535,32.91,0.8,38.1,51155,75,NULL,'B','NGC 5427',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116536,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116536,37.41,0.33,303,51156,70,NULL,NULL,'2MASX J14032621+2326033',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,210.859333333,23.43417,0.008,NULL,59472512851,929258013,14519656,17.2),(116537,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116537,36.1,0.46,166,51157,70,NULL,NULL,'2MASX J14032713+4514074',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000174,NULL,'15.7g',0.45,'S0^-',NULL,NULL,NULL,NULL,1,210.862875,45.23533,0,NULL,59235303445,925551616,14461744,15.7),(116538,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116538,34.34,0.8,73.9,51158,75,NULL,'HMCL, I','NGC 5434B',NULL,'1997ApJS..109..333W',1997,1,1.81,'Declination in 1996ApJS..107...97M is -5 degrees in error.','G',0.00002,NULL,'14.9g',0.33,'Sbc','Pair member (points to parent)',NULL,NULL,NULL,1,210.8629583,9.46728,0,NULL,58507889310,914185770,14284152,14.9),(116539,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116539,34.35,0.8,74,51158,75,NULL,'W91CL, r','NGC 5434B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116540,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116540,34.03,0.38,63.8,51158,75,NULL,'W91CL, r, raw','NGC 5434B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116541,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116541,34.13,0.38,67.1,51158,75,NULL,'W91CL, r, inv','NGC 5434B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116542,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116542,34.36,0.38,74.4,51158,75,NULL,'W91CL, r, cor','NGC 5434B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116543,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116543,34.46,0.49,77.9,51158,75,NULL,'IR','NGC 5434B',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116544,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116544,34.48,0.2,78.7,51158,74.4,NULL,NULL,'NGC 5434B',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116545,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116545,34.61,0.4,83.4,51158,75,NULL,'HMCL, I, raw','NGC 5434B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116546,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116546,34.62,0.45,83.9,51158,NULL,NULL,NULL,'NGC 5434B',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116547,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116547,34.63,0.4,84.4,51158,NULL,NULL,'mean','NGC 5434B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116548,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116548,34.71,0.43,87.5,51158,NULL,NULL,'Malmquist cor.','NGC 5434B',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116549,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116549,34.76,0.4,89.6,51158,75,NULL,'HMCL, I, inv','NGC 5434B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116550,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116550,34.81,0.47,91.5,51158,NULL,NULL,'H','NGC 5434B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116551,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116551,34.82,0.4,92,51158,75,NULL,'HMCL, I, cor','NGC 5434B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116552,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116552,37.52,0.46,319,51159,70,NULL,NULL,'2MASX J14032757+2931184',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000113,NULL,'18.64',0.15,NULL,NULL,NULL,NULL,NULL,1,210.864833,29.52178,0,NULL,60007307189,937614174,14650221,18.64),(116553,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116553,38.06,0.33,409,51160,70,NULL,NULL,'2MASX J14032908+1547001',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.86',0.13,NULL,NULL,NULL,NULL,NULL,1,210.8712083,15.78339,0,NULL,58374341601,912099087,14251548,18.86),(116554,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116554,37.97,0.46,393,51161,70,NULL,NULL,'2MASX J14032925+1457451',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.51',0.16,NULL,NULL,NULL,NULL,NULL,1,210.871875,14.96239,0,NULL,58369022236,912015972,14250249,18.51),(116555,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116555,33,0.45,39.8,51162,NULL,NULL,'K','NGC 5445',NULL,'2007A&A...465...71T',2007,1,1.65,NULL,'G',0.000073,NULL,'13.6g',0.53,'S0?','in a radial-velocity based grouping',NULL,NULL,NULL,1,210.88125,35.02531,0,NULL,59150038666,924219354,14440927,13.6),(116556,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116556,33.76,0.4,56.4,51162,NULL,NULL,'mean','NGC 5445',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116557,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116557,35.29,0.2,114,51163,74.4,NULL,NULL,'UGC 08966',NULL,'2013AJ....146...86T',2013,1,1,'Position in 1991ApJ...377..349F is incorrect.','G',0.000011,NULL,'14.93',0.5,'Scd:',NULL,NULL,NULL,NULL,1,210.8825,6.77008,0.028,NULL,58512388600,914256071,14285251,14.93),(116558,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116558,38.06,0.33,409,51164,70,NULL,NULL,'2MASX J14033234+1546231',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,210.884667,15.77319,0,NULL,58374341065,912099079,14251548,17.4),(116559,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116559,37.34,0.33,294,51165,70,NULL,NULL,'2MASX J14033277+4958071',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000159,NULL,'15.9g',0.43,NULL,NULL,NULL,NULL,NULL,1,210.886625,49.96867,0.049,NULL,59254160652,925846260,14466347,15.9),(116560,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116560,38.64,0.46,535,51166,70,NULL,NULL,'2MASX J14033320+0432132',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000098,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,210.888458333,4.53697,0.061,NULL,58478694953,913729608,14277025,17.9),(116561,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116561,37.49,0.46,315,51167,70,NULL,NULL,'2MASX J14033345+2750090',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000192,NULL,'15.9g',0.52,NULL,NULL,NULL,NULL,NULL,1,210.890125,27.83092,0,NULL,60011724965,937683202,14651300,15.9),(116562,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116562,33.58,0.2,52,51168,74.4,NULL,NULL,'IC 4358',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',NULL,NULL,'14.92',0.3,'Sbc pec sp',NULL,NULL,NULL,NULL,1,210.892417,-10.15125,0.101,NULL,43750784737,683606011,10681343,14.92),(116563,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116563,37.54,0.33,322,51169,70,NULL,NULL,'2MASX J14033470+2440401',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000178,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,210.8945,24.67786,0,NULL,59996427308,937444176,14647565,16.9),(116564,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116564,38.98,0.46,626,51170,70,NULL,NULL,'SDSS J140336.67+383003.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000171,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,210.902791667,38.50092,0,NULL,59143437632,924116213,14439315,18.3),(116565,'D-Sigma','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116565,33.26,0.4,44.9,51171,75,NULL,'Edat, raw','NGC 5419',NULL,'1997ApJS..109..333W',1997,1,4.2,NULL,'G',0.00005,NULL,'11.9',3.3,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,210.911375,-33.97825,0.233,NULL,47002953689,734421151,11475330,11.9),(116566,'D-Sigma','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116566,33.44,0.4,48.7,51171,75,NULL,'Edat, cor','NGC 5419',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116567,'D-Sigma','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116567,33.5,0.11,50.1,51171,72,NULL,'ABELL S0753, 18 galaxies','NGC 5419',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116568,'D-Sigma','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116568,33.74,0.19,56,51171,NULL,NULL,'ABELL S0753, 16 galaxies','NGC 5419',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116569,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116569,33.48,0.18,49.7,51171,NULL,NULL,'ABELL S0753, 16 galaxies','NGC 5419',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116570,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116570,33.58,0.2,52,51171,NULL,NULL,'ABELL S0753, 16 galaxies','NGC 5419',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116571,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116571,33.69,0.23,54.7,51171,74.4,NULL,NULL,'NGC 5419',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116572,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116572,36.81,0.46,230,51172,70,NULL,NULL,'2MASX J14033949+5151240',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000145,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,210.914625,51.85664,0,NULL,59250370561,925787040,14465422,17.6),(116573,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116573,33.78,0.25,57,51173,74.4,NULL,NULL,'ABELL S0753:[WFC91] 065',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00006,NULL,'16.01',NULL,'S0',NULL,NULL,NULL,NULL,1,210.9187917,-34.18272,0.229,NULL,47003002377,734421912,11475342,16.01),(116574,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116574,37.34,0.75,294,51174,70,NULL,NULL,'2MASX J14034094-4238276',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,210.92075,-42.641,0.233,NULL,46911244478,732988194,11452940,15.6),(116575,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116575,36.56,0.68,205,51175,70,NULL,NULL,'2MASX J14034219-1100439',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,210.925917,-11.01225,0.141,NULL,43747064549,683547883,10680435,16.7),(116576,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116576,36.06,0.46,163,51176,70,NULL,NULL,'2MASX J14034253-0108147',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000092,NULL,'16.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,210.9270417,-1.13733,0.141,NULL,43602616763,681290886,10645170,16.1),(116577,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116577,33.53,0.8,50.7,51177,75,NULL,'MAT, I','ESO 446- G 002',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.00003,NULL,'14.69',0.3,'Sab: sp        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,210.928083,-32.71686,0.313,NULL,47002418936,734412795,11475199,14.69),(116578,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116578,32.41,0.49,30.3,51177,75,NULL,'IR','ESO 446- G 002',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116579,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116579,32.89,0.47,37.9,51177,NULL,NULL,'H','ESO 446- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116580,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116580,32.92,0.45,38.4,51177,NULL,NULL,'K','ESO 446- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116581,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116581,33.13,0.46,42.2,51177,NULL,NULL,'J','ESO 446- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116582,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116582,33.22,0.32,44.1,51177,85,NULL,'I, raw','ESO 446- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116583,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116583,33.27,0.32,45,51177,85,NULL,'I, inv','ESO 446- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116584,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116584,33.48,0.43,49.7,51177,75,NULL,'MAT, I, raw','ESO 446- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116585,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116585,33.69,0.4,54.6,51177,NULL,NULL,'mean','ESO 446- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116586,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116586,33.7,0.43,55,51177,75,NULL,'MAT, I, inv','ESO 446- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116587,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116587,33.72,0.43,55.4,51177,75,NULL,'MAT, I, cor','ESO 446- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116588,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116588,33.87,0.41,59.5,51177,NULL,NULL,'Malmquist cor.','ESO 446- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116589,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116589,33.95,0.39,61.7,51177,NULL,NULL,NULL,'ESO 446- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116590,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116590,33.99,0.2,62.8,51177,74.4,NULL,NULL,'ESO 446- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116591,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116591,37.03,0.46,255,51178,70,NULL,NULL,'2MASX J14034305+2957491',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.63',0.16,NULL,NULL,NULL,NULL,NULL,1,210.929375,29.96375,0,NULL,60007367605,937615118,14650236,18.63),(116592,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116592,38.36,0.46,469,51179,70,NULL,NULL,'2MASXi J1403442+185013',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.95',0.13,NULL,NULL,NULL,NULL,NULL,1,210.93425,18.83714,0.045,NULL,58326063311,911344739,14239761,18.95),(116593,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116593,38.21,0.33,439,51180,70,NULL,NULL,'SDSS J140344.34+314105.6',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.93475,31.68492,0,NULL,60050732341,938292692,14660823,18.7),(116594,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116594,37.94,0.46,387,51181,70,NULL,NULL,'2MASX J14034471+2726351',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000145,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,210.93625,27.44314,0,NULL,60011762372,937683787,14651309,17.5),(116595,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116595,38.12,0.27,422,51182,70,NULL,NULL,'SDSS J140345.14+100409.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000128,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.938125,10.06939,0,NULL,58510487691,914226370,14284787,18.4),(116596,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116596,38.32,0.46,460,51183,70,NULL,NULL,'2MASX J14034567+1507342',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.77',0.14,NULL,NULL,NULL,NULL,NULL,1,210.94025,15.12617,0,NULL,58361646213,911900722,14248448,18.77),(116597,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116597,38.45,0.46,489,51184,70,NULL,NULL,'SDSS J140346.10+072056.2',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.942125,7.34894,0.023,NULL,58511914735,914248667,14285135,17.9),(116598,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116598,37.54,0.33,322,51185,70,NULL,NULL,'2MASX J14034651+2448171',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000159,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,210.9437083,24.80469,0,NULL,59996430386,937444224,14647566,17.8),(116599,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116599,38.07,0.46,411,51186,70,NULL,NULL,'2MASX J14034697+5453450',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000156,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,210.945583333,54.89578,0,NULL,57299173235,895299581,13989055,17.2),(116600,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116600,37.27,0.23,284,51187,70,NULL,NULL,'SDSS J140347.13+241943.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.946417,24.32881,0,NULL,59460591030,929071734,14516745,18),(116601,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116601,35.16,0.2,108,51188,74.4,NULL,NULL,'UGC 08978',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'15.53',0.3,'S?','Group member',NULL,NULL,NULL,1,210.946917,15.7285,0,NULL,58374336944,912099014,14251547,15.53),(116602,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116602,35.16,0.25,108,51189,74.4,NULL,NULL,'NGC 5437',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000093,NULL,'15.1',0.4,'AGN','Group member',NULL,NULL,NULL,1,210.94725,9.52369,0,NULL,58509708811,914214200,14284596,15.1),(116603,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116603,36.55,0.46,204,51190,70,NULL,NULL,'2MASX J14034745+2943381',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.87',0.19,'Sb',NULL,NULL,NULL,NULL,1,210.947875,29.72722,0,NULL,60007274981,937613671,14650213,17.87),(116604,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116604,34.64,0.25,84.7,51191,74.4,NULL,NULL,'NGC 5438',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000087,NULL,'14.7',0.3,NULL,'Group member of poor cluster',NULL,NULL,NULL,1,210.95,9.61058,0,NULL,58509719109,914214361,14284599,14.7),(116605,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116605,36.99,0.46,250,51192,70,NULL,NULL,'2MASX J14034831+0933120',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000107,NULL,'17.46',0.25,NULL,NULL,NULL,NULL,NULL,1,210.95125,9.55336,0,NULL,58509708464,914214194,14284596,17.46),(116606,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116606,36.6,0.46,209,51193,70,NULL,NULL,'2MASX J14034843+0054272',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000075,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,210.9517917,0.90747,0.125,NULL,58416042514,912750664,14261729,17.5),(116607,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116607,34.7,0.2,87.1,51194,74.4,NULL,NULL,'UGC 08977',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000033,NULL,'14.90',0.7,'S?',NULL,NULL,NULL,NULL,1,210.9525,15.40231,0,NULL,58374283367,912098177,14251534,14.9),(116608,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116608,38.74,0.46,560,51195,70,NULL,NULL,'2MASX J14034874+1322063',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,210.953041667,13.36836,0,NULL,58363186250,911924785,14248824,18),(116609,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116609,38.12,0.27,422,51196,70,NULL,NULL,'2MASX J14034903+1004230',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,210.9542083,10.07303,0,NULL,58510481366,914226271,14284785,17.3),(116610,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116610,37.93,0.46,386,51197,70,NULL,NULL,'2MASX J14034918+1238403',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,210.954875,12.64458,0,NULL,58360588133,911884189,14248190,17.5),(116611,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116611,36.36,0.46,187,51198,70,NULL,NULL,'2MASX J14034931+0544512',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00009,NULL,'16.24',0.31,NULL,NULL,NULL,NULL,NULL,1,210.955583,5.74753,0.027,NULL,58479590606,913743603,14277243,16.24),(116612,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116612,37.27,0.23,284,51199,70,NULL,NULL,'2MASX J14034990+2416081',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000187,NULL,'18.40',0.14,NULL,NULL,NULL,NULL,NULL,1,210.957833,24.26897,0,NULL,59472114903,929251795,14519559,18.4),(116613,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116613,38.92,0.46,609,51200,70,NULL,NULL,'SDSS J140350.02+651941.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000083,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,210.9584583,65.32828,0.041,NULL,57934004550,905218821,14144044,18.7),(116614,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116614,34.75,0.48,89.3,51201,70,NULL,NULL,'ESO 446- G 003',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00008,NULL,'14.42',0.8,'S0?',NULL,NULL,NULL,NULL,1,210.9630417,-31.94958,0.257,NULL,47034997546,734921836,11483153,14.42),(116615,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116615,32.48,0.69,31.3,51202,100,NULL,'mid-IR','IC 0971',NULL,'2013ApJ...771...88L',2013,1,2.2,NULL,'G',0.000013,NULL,'13.26',1.2,'SB(s)c',NULL,NULL,NULL,NULL,1,210.9699583,-10.14058,0.093,NULL,43750776099,683605876,10681341,13.26),(116616,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116616,32.58,0.66,32.8,51202,NULL,NULL,'Malmquist cor.','IC 0971',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116617,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116617,32.71,0.2,34.8,51202,74.4,NULL,NULL,'IC 0971',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116618,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116618,32.79,0.6,36.2,51202,NULL,NULL,NULL,'IC 0971',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116619,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116619,33.44,0.47,48.7,51202,NULL,NULL,'H','IC 0971',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116620,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116620,33.51,0.4,50.5,51202,NULL,NULL,'mean','IC 0971',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116621,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116621,33.56,0.46,51.4,51202,NULL,NULL,'J','IC 0971',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116622,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116622,38.04,0.19,406,51203,70,NULL,NULL,'SDSS J140353.35+151951.0',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.8g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,210.972333,15.33086,0,NULL,58356412106,911818939,14247170,16.8),(116623,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116623,36.74,0.46,223,51204,70,NULL,NULL,'2MASX J14035370+1651474',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.75',0.3,NULL,NULL,NULL,NULL,NULL,1,210.973667,16.86311,0,NULL,58375588525,912118570,14251852,16.75),(116624,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116624,38.04,0.19,406,51205,70,NULL,NULL,'2MASX J14035339+1519514',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,'PHOT','18.29',0.16,NULL,NULL,NULL,NULL,NULL,1,210.976917,15.328,0,NULL,58356412256,911818941,14247170,18.29),(116625,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116625,36.75,0.46,223,51206,70,NULL,NULL,'2MASX J14035482+2142035',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.22',0.18,NULL,NULL,NULL,NULL,NULL,1,210.978417,21.70097,0.017,NULL,59473627945,929275436,14519928,18.22),(116626,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116626,38.21,0.33,439,51207,70,NULL,NULL,'2MASX J14035562+3143299',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.62',0.16,NULL,NULL,NULL,NULL,NULL,1,210.981833,31.72497,0,NULL,60050731363,938292677,14660823,18.62),(116627,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116627,36.16,0.71,170,51208,70,NULL,NULL,'2MASX J14035583-1032350',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,210.9827917,-10.54319,0.125,NULL,43750457192,683600893,10681263,16.8),(116628,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116628,38.62,0.46,530,51209,70,NULL,NULL,'2MASX J14035753+4842400',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000146,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,210.98975,48.711,0.044,NULL,59242993127,925671767,14463621,18.1),(116629,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116629,38.12,0.27,422,51210,70,NULL,NULL,'2MASX J14035858+1003160',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000176,NULL,'16.7g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,210.994083333,10.05456,0,NULL,58510482942,914226295,14284785,16.7),(116630,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116630,36.06,0.57,163,51211,70,NULL,NULL,'2MASX J14035876-2920103',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000103,NULL,'15.2b',NULL,'S0',NULL,NULL,NULL,NULL,1,210.994833,-29.33617,0.173,NULL,46982104719,734095386,11470240,15.2),(116631,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116631,37.2,0.33,276,51212,70,NULL,NULL,'2MASX J14035954+2356061',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000188,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,210.99825,23.93503,0.013,NULL,59472200229,929253128,14519580,16.6),(116632,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116632,36.99,0.33,250,51213,70,NULL,NULL,'MCG +11-17-015',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000125,NULL,'15.1g',0.61,'E0',NULL,NULL,NULL,NULL,1,211.000875,64.68272,0.021,NULL,57934625168,905228518,14144195,15.1),(116633,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116633,37.64,0.46,337,51214,70,NULL,NULL,'SDSS J140400.24+324012.1',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.7g',0.3,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.001,32.67006,0,NULL,60034115492,938033054,14656766,16.7),(116634,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116634,37.09,0.46,261,51215,70,NULL,NULL,'2MASX J14040065+6052516',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000173,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,211.0024583,60.88106,0,NULL,57274341208,894911581,13982993,16.3),(116635,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116635,36.97,0.87,247,51216,70,NULL,NULL,'2MASX J14040140-3254236',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,211.005791667,-32.90658,0.245,NULL,47002199088,734409360,11475146,15.6),(116636,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116636,38.06,0.46,410,51217,70,NULL,NULL,'2MASX J14040201+3744015',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,211.0085,37.73381,0,NULL,59142947227,924108550,14439196,17.1),(116637,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116637,37.93,0.27,386,51218,70,NULL,NULL,'2MASX J14040210+5942461',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000205,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,211.008833,59.71286,0.013,NULL,57273494300,894898348,13982786,17.3),(116638,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116638,36.98,0.46,249,51219,70,NULL,NULL,'SDSS J140402.64+165327.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.0110417,16.89106,0,NULL,58375563339,912118177,14251846,17.8),(116639,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116639,33.81,0.25,57.8,51220,74.4,NULL,NULL,'ESO 510- G 054',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000011,NULL,'14.11',0.9,'SAB0^0^: pec',NULL,NULL,NULL,NULL,1,211.013333,-26.21614,0.169,NULL,46990647355,734228864,11472326,14.11),(116640,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116640,35.08,NULL,104,51221,NULL,NULL,NULL,'UGC 08983',NULL,'2000BSAO...50....5K',2000,1,1.17,NULL,'G',0.000046,NULL,'16.2g',0.2,'Sc',NULL,NULL,NULL,NULL,1,211.015083333,12.00467,0,NULL,58489737275,913902144,14279721,16.2),(116641,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116641,35.1,NULL,105,51221,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08983',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116642,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116642,35.11,NULL,105,51221,NULL,NULL,'Dipole + Quadrupole','UGC 08983',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116643,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116643,35.12,NULL,106,51221,NULL,NULL,'Dipole','UGC 08983',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116644,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116644,35.31,0.49,115,51221,75,NULL,'IR','UGC 08983',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116645,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116645,35.77,0.2,143,51221,74.4,NULL,NULL,'UGC 08983',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116646,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116646,37.34,0.33,294,51222,70,NULL,NULL,'2MASX J14040521+4958470',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000194,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,211.021833333,49.97978,0.102,NULL,59254861478,925857210,14466518,16.2),(116647,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116647,37.91,0.46,382,51223,70,NULL,NULL,'2MASX J14040621+0434426',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000115,NULL,'16.0g',0.46,'E0',NULL,NULL,NULL,NULL,1,211.02575,4.57853,0.053,NULL,58480984989,913765390,14277584,16),(116648,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116648,36.11,0.63,167,51224,70,NULL,NULL,'2MASX J14040658-1655547',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,211.027417,-16.93183,0.261,NULL,43683192709,682549886,10664841,15.4),(116649,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116649,34.93,NULL,97,51225,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08979',NULL,'2010Ap&SS.325..163P',2010,1,1.74,NULL,'G',0.000027,NULL,'16.0',0.22,'Sbc',NULL,NULL,NULL,NULL,1,211.031917,6.48589,0.059,NULL,58512393176,914256143,14285252,16),(116650,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116650,34.94,NULL,97.3,51225,NULL,NULL,'Dipole','UGC 08979',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116651,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116651,34.95,NULL,97.8,51225,NULL,NULL,'Dipole + Quadrupole','UGC 08979',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116652,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116652,34.99,NULL,99.6,51225,NULL,NULL,NULL,'UGC 08979',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116653,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116653,35.07,0.49,103,51225,75,NULL,'IR','UGC 08979',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116654,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116654,35.24,0.38,112,51225,NULL,NULL,'Malmquist cor.','UGC 08979',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116655,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116655,35.47,0.2,124,51225,74.4,NULL,NULL,'UGC 08979',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116656,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116656,35.59,0.33,131,51225,NULL,NULL,NULL,'UGC 08979',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116657,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116657,37.97,0.46,392,51226,70,NULL,NULL,'2MASX J14040800+1629114',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.91',0.21,NULL,NULL,NULL,NULL,NULL,1,211.03325,16.4865,0,NULL,58374529466,912102022,14251594,17.91),(116658,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116658,37.2,0.33,276,51227,70,NULL,NULL,'2MASXi J1404081+235636',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'17.8g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.0342917,23.94328,0.013,NULL,59472171991,929252687,14519573,17.8),(116659,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116659,37.46,0.46,311,51228,70,NULL,NULL,'2MASX J14040832+3215370',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,211.0345417,32.26017,0,NULL,60034006827,938031356,14656739,17.4),(116660,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116660,36.06,0.2,163,51229,74.4,NULL,NULL,'KUG 1401+133',NULL,'2013AJ....146...86T',2013,1,0.63,NULL,'G',0.000094,NULL,'15.4g',0.34,'Spiral',NULL,NULL,NULL,NULL,1,211.038125,13.06725,0,NULL,58360261538,911879086,14248110,15.4),(116661,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116661,35.91,0.73,152,51230,70,NULL,NULL,'2MASX J14040946-2305454',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,211.0394583,-23.09594,0.189,NULL,46521788490,726902945,11357858,15.4),(116662,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116662,37.6,0.15,331,51231,70,NULL,NULL,'2MASX J14040979+0624040',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000157,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,211.040917,6.40103,0.075,NULL,58512199383,914253115,14285204,16.8),(116663,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116663,36.79,0.46,228,51232,70,NULL,NULL,'2MASX J14041010+4620405',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000154,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,211.0422917,46.34461,0,NULL,59234580111,925540314,14461567,17),(116664,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116664,35.83,0.64,146,51233,70,NULL,NULL,'2MASX J14041200-1809434',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.34',NULL,NULL,NULL,NULL,NULL,NULL,1,211.050125,-18.16231,0.285,NULL,43679640807,682494387,10663974,16.34),(116665,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116665,38.16,0.46,428,51234,70,NULL,NULL,'2MASX J14041243+0407316',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000082,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,211.0517083,4.12544,0.033,NULL,58479064409,913735381,14277115,17.3),(116666,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116666,36.98,0.27,249,51235,70,NULL,NULL,'2MASX J14041286+3844005',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,211.053833,38.73364,0,NULL,59143464238,924116628,14439322,16.7),(116667,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116667,37.96,0.46,391,51236,70,NULL,NULL,'2MASX J14041342+1308294',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,211.056,13.14156,0,NULL,58360225849,911878528,14248102,17.7),(116668,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116668,38.22,0.46,441,51237,70,NULL,NULL,'2MASX J14041379+1202224',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,211.0575,12.03967,0,NULL,58490429434,913912959,14279889,18.2),(116669,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116669,35.55,0.46,129,51238,70,NULL,NULL,'CGCG 191-048',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000097,NULL,'14.8g',0.57,'E0',NULL,NULL,NULL,NULL,1,211.064625,35.80067,0,NULL,59153531066,924273922,14441780,14.8),(116670,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116670,35.24,0.59,112,51239,70,NULL,NULL,'MCG -01-36-005',NULL,'2014MNRAS.445.2677S',2014,1,0.7,'MCG declination is -53 arcmin in error.','G',0.000147,NULL,'14.51',0.5,NULL,NULL,NULL,NULL,NULL,1,211.075583,-7.04825,0.061,NULL,43745269722,683519839,10679997,14.51),(116671,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116671,36.96,0.46,247,51240,70,NULL,NULL,'2MASX J14041850+5456431',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00019,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,211.076875,54.94542,0,NULL,57299166171,895299471,13989054,16.2),(116672,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116672,36.93,0.46,243,51241,70,NULL,NULL,'LCRS B140144.2-024508',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000147,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,211.0820417,-2.99117,0.125,NULL,43600989846,681265466,10644772,17.2),(116673,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116673,37.4,0.46,302,51242,70,NULL,NULL,'2MASX J14042036+4120064',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,211.084875,41.33522,0,NULL,59258968671,925921385,14467521,17.6),(116674,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116674,38.59,0.46,522,51243,70,NULL,NULL,'SDSS J140420.77+240529.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000165,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.086583333,24.09144,0,NULL,59472326704,929255104,14519611,18.3),(116675,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116675,37.3,0.46,289,51244,70,NULL,NULL,'2MASX J14042139+1817107',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.96',0.2,NULL,NULL,NULL,NULL,NULL,1,211.089,18.28622,0.035,NULL,58326153433,911346147,14239783,17.96),(116676,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116676,37.05,0.46,257,51245,70,NULL,NULL,'2MASX J14042222+0526355',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000076,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,211.0925,5.44314,0.034,NULL,58479421213,913740956,14277202,16.8),(116677,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116677,37.25,0.46,282,51246,70,NULL,NULL,'2MASX J14042252+6631309',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00007,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,211.093625,66.52522,0.057,NULL,57871316244,904239316,14128739,17.3),(116678,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116678,38.43,0.46,485,51247,70,NULL,NULL,'2MASX J14042252+5048050',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000145,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,211.093916667,50.80156,0,NULL,59250830987,925794234,14465534,18),(116679,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116679,37.62,0.46,334,51248,70,NULL,NULL,'2MASX J14042320+3358109',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,211.096833333,33.96961,0,NULL,60036518624,938070603,14657353,17.8),(116680,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116680,37.92,0.46,384,51249,70,NULL,NULL,'2MASX J14042622+0635397',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00016,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,211.109375,6.5945,0.059,NULL,58512616759,914259636,14285306,17.4),(116681,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116681,37.97,0.46,393,51250,70,NULL,NULL,'2MASX J14042632+3239516',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,211.1097083,32.66444,0,NULL,60034088277,938032629,14656759,17.4),(116682,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116682,35.65,0.5,135,51251,70,NULL,NULL,'2MASX J14042762-1432517',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.82',NULL,NULL,NULL,NULL,NULL,NULL,1,211.1152083,-14.54769,0.229,NULL,43642993161,681921768,10655027,15.82),(116683,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116683,37.82,0.46,367,51252,70,NULL,NULL,'2MASXi J1404276+241323',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.5g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.115458333,24.22311,0,NULL,59472105825,929251653,14519557,17.5),(116684,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116684,34.48,0.43,78.8,51253,75,NULL,'3.6 micron, color + selection bias corrected','ESO 384- G 043',NULL,'2014MNRAS.444..527S',2014,1,1.79,NULL,'G',0.00015,NULL,'15.78',0.22,'Scd',NULL,NULL,NULL,NULL,1,211.1160417,-33.51714,0.237,NULL,47005073436,734454272,11475848,15.78),(116685,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116685,35.99,0.2,158,51254,74.4,NULL,NULL,'UGC 08998',NULL,'2013AJ....146...86T',2013,1,1.01,NULL,'G',0.000033,NULL,'16.3g',0.22,'Scd:',NULL,NULL,NULL,NULL,1,211.116875,25.79828,0,NULL,60010943181,937670987,14651109,16.3),(116686,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116686,35.12,0.2,106,51255,74.4,NULL,NULL,'KUG 1402+341',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.000107,NULL,'15.4g',0.28,'Spiral',NULL,NULL,NULL,NULL,1,211.121833333,33.95336,0,NULL,60036521465,938070647,14657353,15.4),(116687,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116687,36.69,0.46,218,51256,70,NULL,NULL,'2MASXi J1404310-004522',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000067,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,211.129167,-0.75622,0.137,NULL,43589174857,681080857,10641888,17.5),(116688,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116688,35.16,0.49,108,51257,75,NULL,'IR','MCG -02-36-010',NULL,'2011yCatp016004901K',2011,1,1.27,NULL,'G',0.000057,NULL,'16.3b',0.18,'Sbc',NULL,NULL,NULL,NULL,1,211.1320417,-15.20386,0.269,NULL,43648061573,682000962,10656265,16.3),(116689,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116689,35.5,NULL,126,51257,NULL,NULL,'Dipole + Quadrupole','MCG -02-36-010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116690,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116690,35.51,NULL,126,51257,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -02-36-010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116691,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116691,35.51,NULL,126,51257,NULL,NULL,'Dipole','MCG -02-36-010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116692,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116692,36.97,0.46,247,51258,70,NULL,NULL,'2MASX J14043245+1812526',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.53',0.14,NULL,NULL,NULL,NULL,NULL,1,211.135291667,18.21469,0.012,NULL,58326139586,911345931,14239780,18.53),(116693,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116693,38,0.46,399,51259,70,NULL,NULL,'2MASX J14043313+4531061',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,211.138,45.51844,0,NULL,59235177502,925549648,14461713,17.5),(116694,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116694,36.87,0.46,236,51260,70,NULL,NULL,'2MASX J14043398+3109577',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00018,NULL,'17.62',0.22,NULL,NULL,NULL,NULL,NULL,1,211.141416667,31.16603,0,NULL,60050277891,938285592,14660712,17.62),(116695,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116695,36.89,0.46,238,51261,70,NULL,NULL,'2MASX J14043418+3710404',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000178,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,211.1425,37.17781,0,NULL,59142508138,924101689,14439088,16.2),(116696,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116696,33.78,0.23,57,51262,74.4,NULL,NULL,'MCG -06-31-020',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000057,NULL,'14.01',0.9,'S0',NULL,NULL,NULL,NULL,1,211.143083,-33.96075,0.237,NULL,47005066950,734454171,11475846,14.01),(116697,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116697,33.66,0.4,53.9,51262,NULL,NULL,'mean','MCG -06-31-020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116698,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116698,34.33,0.45,73.3,51262,NULL,NULL,'K','MCG -06-31-020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116699,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116699,37.5,0.46,316,51263,70,NULL,NULL,'2MASX J14043498+3518157',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000036,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,211.145625,35.30428,0,NULL,59149304483,924207882,14440748,17.9),(116700,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116700,37.24,0.46,280,51264,70,NULL,NULL,'SDSS J140435.95+265407.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000095,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,211.1497917,26.902,0,NULL,60011514587,937679915,14651248,18),(116701,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116701,37.77,0.46,358,51265,70,NULL,NULL,'2MASX J14043692+2159026',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.32',0.16,NULL,NULL,NULL,NULL,NULL,1,211.1537083,21.98417,0,NULL,59474624553,929291008,14520172,18.32),(116702,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116702,36.46,0.55,196,51266,70,NULL,NULL,'2MASX J14043719-2229263',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,211.1550417,-22.49064,0.177,NULL,46523167227,726924487,11358195,14.2),(116703,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116703,37.65,0.46,339,51267,70,NULL,NULL,'SDSS J140438.21-015601.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000154,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,211.15925,-1.93386,0.157,NULL,43601328907,681270764,10644855,18),(116704,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116704,37.88,0.46,377,51268,70,NULL,NULL,'2MASX J14043862+0757517',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000157,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,211.161,7.96436,0.064,NULL,58518659920,914354061,14286782,17.1),(116705,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116705,35.5,0.59,126,51269,70,NULL,NULL,'2MASX J14043929-2051283',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00014,NULL,'15.92',NULL,NULL,NULL,NULL,NULL,NULL,1,211.16375,-20.858,0.185,NULL,46518130866,726845794,11356965,15.92),(116706,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116706,38.3,0.46,457,51270,70,NULL,NULL,'2MASX J14044008+2520400',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000177,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,211.1669583,25.34453,0,NULL,60010090832,937657669,14650901,17),(116707,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116707,36.64,0.62,213,51271,70,NULL,NULL,'2MFGC 11401',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,211.167917,-14.44917,0.221,NULL,43643732033,681933313,10655208,15.9),(116708,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116708,36.42,0.46,193,51272,70,NULL,NULL,'2MASX J14044080+4444052',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.99',0.14,NULL,NULL,NULL,NULL,NULL,1,211.17,44.73483,0,NULL,59233372180,925521440,14461272,17.99),(116709,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116709,37.6,0.15,331,51273,70,NULL,NULL,'2MASX J14044228+0611198',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.32',0.14,NULL,NULL,NULL,NULL,NULL,1,211.176083,6.18872,0.041,NULL,58512185215,914252893,14285201,18.32),(116710,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116710,37.93,0.27,386,51274,70,NULL,NULL,'SDSS J140442.26+594036.9',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,211.176083,59.67692,0.013,NULL,57271652625,894869572,13982337,17.7),(116711,'Faber-Jackson','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116711,30.82,0.65,14.6,51275,95,NULL,'Weighted Mean','NGC 5473',NULL,'1984ApJS...56...91D',1984,1,1.9,NULL,'G',0.000017,NULL,'12.3g',1.46,'SAB(s)0-:','in a radial-velocity based grouping',NULL,NULL,NULL,1,211.180125,54.89264,0,NULL,57299122467,895298788,13989043,12.3),(116712,'Faber-Jackson','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116712,32,0.81,25.1,51275,55,NULL,'Visvanathan & Sandage 1979','NGC 5473',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116713,'Tertiary','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116713,31.87,0.29,23.7,51275,95,NULL,NULL,'NGC 5473',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116714,'Tully est','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116714,32.59,0.8,33,51275,75,NULL,'B','NGC 5473',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116715,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116715,32.35,0.4,29.5,51275,NULL,NULL,'mean','NGC 5473',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116716,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116716,32.88,0.45,37.7,51275,NULL,NULL,'K','NGC 5473',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116717,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116717,34.71,NULL,87.5,51276,NULL,NULL,'Dipole','UGC 08996',NULL,'2010Ap&SS.325..163P',2010,1,1.57,NULL,'G',0.000008,NULL,'15.5g',0.25,'Sbc','Pair member (points to parent)',NULL,NULL,NULL,1,211.18025,14.28042,0,NULL,58362631256,911916113,14248689,15.5),(116718,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116718,34.72,NULL,88.1,51276,NULL,NULL,'Dipole + Quadrupole','UGC 08996',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116719,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116719,34.73,NULL,88.2,51276,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08996',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116720,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116720,34.9,NULL,95.7,51276,NULL,NULL,NULL,'UGC 08996',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116721,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116721,35.13,0.49,106,51276,75,NULL,'IR','UGC 08996',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116722,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116722,35.33,0.2,116,51276,74.4,NULL,NULL,'UGC 08996',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116723,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116723,37.99,0.46,396,51277,70,NULL,NULL,'2MASX J14044380+6243172',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,211.1827083,62.72144,0.029,NULL,57751120512,902361258,14099394,17.9),(116724,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116724,37.64,0.46,337,51278,70,NULL,NULL,'2MASX J14044417+2218136',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,211.1839583,22.30375,0,NULL,59475123193,929298799,14520293,17.8),(116725,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116725,36.9,0.46,240,51279,70,NULL,NULL,'2MASX J14044455+4909213',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000171,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,211.1854583,49.15589,0.047,NULL,59254444135,925850689,14466417,16.3),(116726,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116726,34.88,0.46,94.7,51280,70,NULL,NULL,'NGC 5454',NULL,'2015arXiv151105856S',2015,1,1.29,NULL,'G',0.000103,NULL,'14.1g',0.71,'S0','Pair member (points to parent)',NULL,NULL,NULL,1,211.1904583,14.38206,0,NULL,58362628515,911916070,14248688,14.1),(116727,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116727,34.48,0.45,78.7,51280,NULL,NULL,'K','NGC 5454',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116728,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116728,35.24,0.4,112,51280,NULL,NULL,'mean','NGC 5454',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116729,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116729,37.33,0.46,292,51281,70,NULL,NULL,'2MASX J14044588-0049092',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000097,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,211.19125,-0.81919,0.137,NULL,43588659647,681072806,10641762,16.4),(116730,'Tully est','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116730,32.63,0.8,33.6,51282,75,NULL,NULL,'UGCA 383',NULL,'1988NBGC.C....0000T',1988,1,2.5,NULL,'G',0.000027,NULL,'13.61',2.1,'SB(s)cd','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,211.193125,-24.82717,0.325,NULL,46989845099,734216329,11472130,13.61),(116731,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116731,37.45,0.46,310,51283,70,NULL,NULL,'2MASX J14044691+1853146',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.41',0.16,NULL,NULL,NULL,NULL,NULL,1,211.195667,18.88733,0.048,NULL,59462834068,929106782,14517293,18.41),(116732,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116732,31.49,0.43,19.8,51284,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08995',NULL,'2014MNRAS.444..527S',2014,1,2.05,NULL,'G',0.000022,NULL,'14.2g',0.76,'SABdm',NULL,NULL,NULL,NULL,1,211.19725,8.80092,0.022,NULL,58518174349,914346474,14286663,14.2),(116733,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116733,31.61,0.43,21,51284,75,NULL,'3.6 micron, color corrected','UGC 08995',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116734,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116734,31.7,0.2,21.9,51284,74.4,NULL,NULL,'UGC 08995',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116735,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116735,31.7,0.53,21.9,51284,NULL,NULL,'Malmquist cor.','UGC 08995',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116736,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116736,31.86,NULL,23.6,51284,72,NULL,NULL,'UGC 08995',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116737,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116737,31.87,0.4,23.7,51284,75,NULL,'B','UGC 08995',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116738,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116738,31.88,0.37,23.8,51284,NULL,NULL,NULL,'UGC 08995',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116739,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116739,31.98,0.46,24.9,51284,NULL,NULL,NULL,'UGC 08995',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116740,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116740,37.63,0.46,335,51285,70,NULL,NULL,'2MASX J14044805+1716256',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,211.200333333,17.27375,0,NULL,58372768232,912074503,14251164,16.2),(116741,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116741,37.6,0.15,331,51286,70,NULL,NULL,'2MASX J14044845+0609078',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,211.20175,6.15214,0.041,NULL,58512192180,914253002,14285203,17.6),(116742,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116742,35.55,0.46,129,51287,70,NULL,NULL,'2MASX J14044887+1557476',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000083,NULL,'16.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,211.2035417,15.96311,0,NULL,58356996559,911828071,14247313,16.1),(116743,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116743,33.87,0.46,59.6,51288,70,NULL,NULL,'CGCG 074-086',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000083,NULL,'14.6g',0.56,NULL,NULL,NULL,NULL,NULL,1,211.206125,11.3955,0,NULL,58490010311,913906411,14279787,14.6),(116744,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116744,36.26,0.46,179,51289,70,NULL,NULL,'2MASX J14045011+4454382',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000178,NULL,'16.0g',0.41,'E0',NULL,NULL,NULL,NULL,1,211.208917,44.91064,0,NULL,59235323312,925551926,14461748,16),(116745,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116745,37.27,0.23,284,51290,70,NULL,NULL,'2MASX J14045022+2410490',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.77',0.28,NULL,NULL,NULL,NULL,NULL,1,211.209333,24.18022,0,NULL,59472302879,929254732,14519605,16.77),(116746,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116746,38.45,0.46,489,51291,70,NULL,NULL,'2MASX J14045099+6558361',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000097,NULL,'17.5g',0.19,'NLAGN',NULL,NULL,NULL,'Sy 2',1,211.2120417,65.97658,0.057,NULL,57941402394,905334412,14145850,17.5),(116747,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116747,34.76,0.49,89.4,51292,70,NULL,NULL,'2MASX J14045120-3240336',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.6b',NULL,'S0',NULL,NULL,NULL,NULL,1,211.213333,-32.67597,0.273,NULL,47002174604,734408978,11475140,16.6),(116748,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116748,36.08,NULL,165,51293,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09000',NULL,'2010Ap&SS.325..163P',2010,1,1.1,'Springob et al. (2005ApJS..160..149S) give v= 11495 km/sec.','G',0.00004,NULL,'15.30',0.13,'SB?',NULL,NULL,NULL,NULL,1,211.214125,10.80856,0,NULL,58506921512,914170648,14283916,15.3),(116749,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116749,36.09,NULL,165,51293,NULL,NULL,'Dipole + Quadrupole','UGC 09000',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116750,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116750,36.1,NULL,166,51293,NULL,NULL,'Dipole','UGC 09000',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116751,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116751,36.72,0.59,221,51294,70,NULL,NULL,'2MASX J14045187-1005280',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,211.216125,-10.09119,0.089,NULL,43750330472,683598913,10681233,16.9),(116752,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116752,38.67,0.46,541,51295,70,NULL,NULL,'SDSS J140452.20+141735.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,211.2175,14.29322,0,NULL,58362636996,911916203,14248690,18.3),(116753,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116753,34.98,0.43,99,51296,NULL,NULL,NULL,'UGC 08994',NULL,'2009ApJS..182..474S',2009,1,1.12,NULL,'G',0.000023,NULL,'14.5g',0.64,'SAB(s)bc pec:','Pair member (points to parent)',NULL,NULL,NULL,1,211.21925,-0.61128,0.129,NULL,43589226767,681081668,10641901,14.5),(116754,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116754,35.01,0.42,100,51296,NULL,NULL,'Malmquist cor.','UGC 08994',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116755,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116755,35.02,0.2,101,51296,74.4,NULL,NULL,'UGC 08994',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116756,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116756,37.23,0.46,279,51297,70,NULL,NULL,'SDSS J140452.60+104422.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.2192083,10.73953,0,NULL,58506916535,914170570,14283915,17.8),(116757,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116757,37.51,0.46,317,51298,70,NULL,NULL,'SDSS J140452.86+291844.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.03',0.22,NULL,NULL,NULL,NULL,NULL,1,211.2202917,29.31242,0,NULL,60006142049,937595969,14649937,17.03),(116758,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116758,36.02,0.49,160,51299,75,NULL,'IR','UGC 09001',NULL,'2011yCatp016004901K',2011,1,1,'Called \'MCG +02-36-032b\' in UGC.','G',0.00012,NULL,'15.1',0.4,'SB?',NULL,NULL,NULL,NULL,1,211.2232917,10.801,0,NULL,58506921555,914170649,14283916,15.1),(116759,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116759,37.93,0.27,386,51300,70,NULL,NULL,'2MASX J14045384+5940594',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000178,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,211.224291667,59.68328,0.013,NULL,57271654087,894869595,13982337,16.7),(116760,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116760,36.98,0.27,249,51301,70,NULL,NULL,'2MASX J14045451+3836244',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000154,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,211.227166667,38.60667,0,NULL,59143445420,924116334,14439317,17.3),(116761,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116761,37.12,0.33,266,51302,70,NULL,NULL,'2MASX J14045488+5144303',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000164,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,211.228417,51.74181,0.005,NULL,59250345962,925786655,14465416,16.9),(116762,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116762,37.35,0.33,296,51303,70,NULL,NULL,'2MASX J14045570+5424104',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000191,NULL,'16.0g',0.4,'E0',NULL,NULL,NULL,NULL,1,211.2317917,54.40297,0,NULL,57281686297,895026348,13984786,16),(116763,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116763,35.52,0.57,127,51304,70,NULL,NULL,'2MASX J14045594-1406231',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.2b',0.5,NULL,NULL,NULL,NULL,NULL,1,211.23325,-14.10658,0.245,NULL,43643814330,681934598,10655228,16.2),(116764,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116764,39.31,0.46,728,51305,70,NULL,NULL,'2MASX J14045615+0803288',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,211.234,8.05817,0.064,NULL,58518585226,914352894,14286763,NULL),(116765,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116765,38.11,0.46,418,51306,70,NULL,NULL,'2MASX J14045713+3933454',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000182,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,211.238083,39.56258,0,NULL,59260547656,925946057,14467907,17.9),(116766,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116766,34.38,0.56,75.3,51307,70,NULL,NULL,'MCG -02-36-012',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000113,NULL,'15.06',0.3,'SB(s)b? sp',NULL,NULL,NULL,NULL,1,211.239666667,-14.27814,0.221,NULL,43643772655,681933947,10655217,15.06),(116767,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116767,36.98,0.27,249,51308,70,NULL,NULL,'SDSS J140458.35+383803.3',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000207,NULL,'15.7g',0.49,NULL,NULL,NULL,NULL,NULL,1,211.243125,38.63422,0,NULL,59143562913,924118170,14439346,15.7),(116768,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116768,34.11,0.46,66.4,51309,70,NULL,NULL,'NGC 5456',NULL,'2015arXiv151105856S',2015,1,1.21,NULL,'G',0.000113,NULL,'13.8g',0.92,'S0','Group member of poor cluster',NULL,NULL,NULL,1,211.245375,11.87164,0,NULL,58490470264,913913597,14279899,13.8),(116769,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116769,34.75,0.46,89.2,51310,70,NULL,NULL,'NGC 5459',NULL,'2015arXiv151105856S',2015,1,1.3,NULL,'G',0.000083,NULL,'14.0g',0.84,'S0','Group member of poor cluster',NULL,NULL,NULL,1,211.2507917,13.13189,0,NULL,58363486263,911929472,14248898,14),(116770,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116770,34.53,0.4,80.6,51310,NULL,NULL,'mean','NGC 5459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116771,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116771,35.09,0.45,104,51310,NULL,NULL,'K','NGC 5459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116772,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116772,36.99,0.33,250,51311,70,NULL,NULL,'2MASX J14050084+6439005',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000075,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,211.253625,64.65006,0.029,NULL,57934495070,905226485,14144163,17.2),(116773,'Brightest Stars','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116773,28.9,0.9,6.03,51312,NULL,NULL,'3, B, blue stars','NGC 5474',NULL,'1994MNRAS.271..530R',1994,1,4.8,'Highly asymmetrical.','G',0.00003,NULL,'11.28',4.3,'SA(s)cd pec    HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,211.256708333,53.66222,0,NULL,59215392004,925240500,14456882,11.28),(116774,'Brightest Stars','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116774,28.9,0.9,6.03,51312,NULL,NULL,'3, B, blue stars','NGC 5474',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116775,'Brightest Stars','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116775,29.15,NULL,6.8,51312,NULL,NULL,NULL,'NGC 5474',NULL,'2000A&AS..142..425D',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116776,'Brightest Stars','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116776,29.29,NULL,7.2,51312,NULL,NULL,NULL,'NGC 5474',NULL,'1994BSAO...38....5K',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116777,'Brightest Stars','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116777,29.4,NULL,7.59,51312,NULL,NULL,'Photographic','NGC 5474',NULL,'1980A&A....83..354C',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116778,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116778,29.17,0.13,6.82,51312,NULL,NULL,NULL,'NGC 5474',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116779,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116779,29.22,0.1,6.98,51312,74.4,NULL,NULL,'NGC 5474',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116780,'HII region diameter','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116780,28.32,0.16,4.61,51312,NULL,NULL,'Method 2','NGC 5474',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116781,'HII region diameter','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116781,28.85,0.09,5.89,51312,NULL,NULL,'Method 1','NGC 5474',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116782,'Magnitude','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116782,28.33,0.16,4.63,51312,NULL,NULL,NULL,'NGC 5474',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116783,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116783,28.87,0.4,6,51312,75,NULL,'B','NGC 5474',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116784,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116784,37.12,0.33,266,51313,70,NULL,NULL,'2MASX J14050263+5143503',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000182,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,211.260916667,51.73053,0.005,NULL,59250345509,925786648,14465416,16.8),(116785,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116785,36.36,0.62,187,51314,70,NULL,NULL,'2MASX J14050288-2100542',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.20',0.3,NULL,NULL,NULL,NULL,NULL,1,211.262167,-21.01514,0.185,NULL,46518019498,726844054,11356938,16.2),(116786,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116786,37.27,0.23,284,51315,70,NULL,NULL,'2MASX J14050294+2413500',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000186,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,211.26225,24.23047,0,NULL,59472127357,929251989,14519562,16.4),(116787,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116787,35.21,0.46,110,51316,70,NULL,NULL,'CGCG 103-066',NULL,'2015arXiv151105856S',2015,1,1.2,NULL,'G',0.000157,NULL,'14.9',1,NULL,NULL,NULL,NULL,NULL,1,211.267458333,16.58208,0,NULL,58356940723,911827198,14247299,14.9),(116788,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116788,36.95,0.46,246,51317,70,NULL,NULL,'2MASX J14050552+1128318',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000191,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,211.2730417,11.47542,0,NULL,58490569054,913915141,14279924,16.2),(116789,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116789,35.51,0.33,127,51318,70,NULL,NULL,'2MASX J14050556+2100438',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.35',0.2,NULL,NULL,NULL,NULL,NULL,1,211.273166667,21.01206,0.038,NULL,59465816857,929153388,14518021,17.35),(116790,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116790,37.42,0.46,305,51319,70,NULL,NULL,'2MASX J14050631+5115243',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000204,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,211.276333333,51.25672,0.014,NULL,59250482303,925788785,14465449,16.5),(116791,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116791,35.34,0.2,117,51320,74.4,NULL,NULL,'UGC 09009',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'15.52',0.3,'S?',NULL,NULL,NULL,NULL,1,211.2772917,15.77467,0,NULL,58357313049,911833016,14247390,15.52),(116792,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116792,37.56,0.21,326,51321,70,NULL,NULL,'2MASX J14050661+4631501',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000179,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,211.277583,46.53061,0,NULL,59234502688,925539104,14461548,16.3),(116793,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116793,37.56,0.21,326,51322,70,NULL,NULL,'2MASX J14050796+4632561',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,211.283291667,46.54903,0,NULL,59234509846,925539216,14461550,17.3),(116794,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116794,37.54,0.46,323,51323,70,NULL,NULL,'2MASX J14050807+3349001',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00015,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,211.283541667,33.81681,0,NULL,60036700653,938073447,14657397,18.4),(116795,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116795,35.21,0.5,110,51324,70,NULL,NULL,'2MASX J14050967-3245513',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.4b',0.3,'S0',NULL,NULL,NULL,NULL,1,211.290333,-32.76425,0.249,NULL,47002189321,734409208,11475143,16.4),(116796,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116796,37.2,0.33,275,51325,70,NULL,NULL,'2MASX J14051020+0322233',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00008,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,211.292417,3.37325,0.057,NULL,58478077415,913719959,14276874,16.4),(116797,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116797,37.8,0.46,363,51326,70,NULL,NULL,'2MASX J14051042+2431232',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,211.2934583,24.52311,0.012,NULL,59467906413,929186037,14518531,17.3),(116798,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116798,37.3,0.46,288,51327,70,NULL,NULL,'2MASXi J1405106+223543',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.5g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.294417,22.59592,0,NULL,59475202203,929300034,14520313,17.5),(116799,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116799,37.54,0.46,322,51328,70,NULL,NULL,'SDSS J140511.06+375030.6',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'16.6g',0.32,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.296125,37.84183,0,NULL,59143803016,924121922,14439405,16.6),(116800,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116800,30.51,0.69,12.6,51329,100,NULL,'mid-IR','CGCG 018-043',NULL,'2013ApJ...771...88L',2013,1,1.8,NULL,'G',0.00001,NULL,'14.50',1.1,'(R)Sa pec?',NULL,NULL,NULL,NULL,1,211.296791667,-3.36983,0.077,NULL,43727740000,683245937,10675717,14.5),(116801,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116801,32.45,NULL,30.9,51329,72,NULL,NULL,'CGCG 018-043',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116802,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116802,37.35,0.33,296,51330,70,NULL,NULL,'2MASX J14051220+5425444',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,211.301167,54.42897,0,NULL,57281687096,895026360,13984786,18.2),(116803,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116803,39.03,0.46,639,51331,70,NULL,NULL,'SDSS J140513.84+482034.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000142,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,211.3077083,48.343,0.048,NULL,59243505316,925679770,14463746,18.3),(116804,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116804,38.5,0.46,502,51332,70,NULL,NULL,'SDSS J140514.78+174913.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.311583,17.82028,0,NULL,58372281197,912066893,14251045,18.5),(116805,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116805,37.56,0.21,326,51333,70,NULL,NULL,'2MASX J14051478+4621451',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000175,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,211.311583,46.36258,0,NULL,59234493873,925538966,14461546,17.6),(116806,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116806,38.26,0.46,449,51334,70,NULL,NULL,'2MASX J14051550+5244352',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000184,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,211.314875,52.74297,0,NULL,59249157855,925768091,14465126,17.7),(116807,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116807,35.51,0.33,127,51335,70,NULL,NULL,'CGCG 132-074',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000077,NULL,'15.6',0.36,NULL,NULL,NULL,NULL,NULL,1,211.319875,21.04428,0.038,NULL,59465815761,929153371,14518021,15.6),(116808,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116808,36.24,0.46,177,51336,70,NULL,NULL,'2MASX J14051707+2441283',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000158,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,211.321125,24.69108,0,NULL,60001621388,937525334,14648833,16.6),(116809,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116809,38.01,0.46,400,51337,70,NULL,NULL,'2MASX J14051930+2637013',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.90',0.15,NULL,NULL,NULL,NULL,NULL,1,211.330417,26.61708,0,NULL,60011541753,937680339,14651255,17.9),(116810,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116810,37.98,0.46,394,51338,70,NULL,NULL,'SDSS J140519.80+240515.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.3325,24.08778,0,NULL,59472307532,929254805,14519606,18.1),(116811,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116811,38.01,0.46,400,51339,70,NULL,NULL,'2MASX J14052020+0926117',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000163,NULL,'18.42',0.16,NULL,NULL,NULL,NULL,NULL,1,211.3339583,9.43647,0,NULL,58509002985,914203171,14284424,18.42),(116812,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116812,38.5,0.46,502,51340,70,NULL,NULL,'2MASX J14052181+3317161',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,211.340833,33.28775,0,NULL,60036554965,938071171,14657362,17.7),(116813,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116813,37.75,0.46,355,51341,70,NULL,NULL,'2MASX J14052179+4357332',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,211.340833,43.95917,0,NULL,59233927229,925530112,14461408,17.5),(116814,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116814,36.82,0.46,231,51342,70,NULL,NULL,'2MASX J14052194+1718308',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.39',0.16,NULL,NULL,NULL,NULL,NULL,1,211.341375,17.30861,0,NULL,58372727610,912073868,14251154,18.39),(116815,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116815,31.45,0.8,19.5,51343,75,NULL,'MAT, I','IC 4362',NULL,'1997ApJS..109..333W',1997,1,1.7,'This is a part of the galaxy IC 4362.','G',0.000033,NULL,'13.40',0.7,'SBc',NULL,NULL,NULL,'H_alpha Emission-Line Galaxy',1,211.342583333,-41.81897,0.249,NULL,46912140468,733002194,11453159,13.4),(116816,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116816,31.2,0.32,17.4,51343,85,NULL,'I, inv','IC 4362',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116817,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116817,31.22,0.32,17.5,51343,85,NULL,'I, raw','IC 4362',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116818,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116818,31.27,0.2,18,51343,74.4,NULL,NULL,'IC 4362',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116819,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116819,31.55,0.43,20.4,51343,75,NULL,'MAT, I, raw','IC 4362',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116820,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116820,31.57,0.43,20.6,51343,75,NULL,'MAT, I, inv','IC 4362',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116821,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116821,31.76,0.54,22.4,51343,NULL,NULL,NULL,'IC 4362',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116822,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116822,31.91,0.43,24.1,51343,75,NULL,'MAT, I, cor','IC 4362',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116823,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116823,31.97,0.49,24.7,51343,NULL,NULL,'Malmquist cor.','IC 4362',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116824,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116824,32.21,0.49,27.7,51343,75,NULL,'IR','IC 4362',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116825,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116825,33.93,0.47,61.2,51344,70,NULL,NULL,'2MASX J14052251-2908282',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000037,NULL,'15.2b',0.7,'E',NULL,NULL,NULL,NULL,1,211.343791667,-29.14111,0.165,NULL,46982286118,734098220,11470284,15.2),(116826,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116826,38.67,0.46,542,51345,70,NULL,NULL,'2MASX J14052250+5915474',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,211.343916667,59.26317,0,NULL,57271733223,894870831,13982356,18),(116827,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116827,37.94,0.46,388,51346,70,NULL,NULL,'2MASX J14052279+1153257',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,211.344875,11.89053,0,NULL,58490177294,913909020,14279828,17.5),(116828,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116828,33.72,0.47,55.5,51347,NULL,NULL,'H','IC 4359',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000033,NULL,'13.82',0.9,'SA(rs)bc',NULL,NULL,NULL,NULL,1,211.3472083,-45.26978,0.273,NULL,46799222763,731237855,11425591,13.82),(116829,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116829,33.82,0.46,58.2,51347,NULL,NULL,'J','IC 4359',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116830,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116830,33.83,0.45,58.3,51347,NULL,NULL,'K','IC 4359',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116831,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116831,33.86,0.4,59.1,51347,NULL,NULL,'mean','IC 4359',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116832,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116832,36.42,0.69,192,51348,70,NULL,NULL,'CGCG 018-045',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.000097,NULL,'15.5g',0.35,'NLAGN',NULL,NULL,NULL,NULL,1,211.35525,-0.81133,0.141,NULL,43588684571,681073196,10641768,15.5),(116833,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116833,37.2,0.33,275,51349,70,NULL,NULL,'2MASX J14052671+0315416',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000093,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,211.36125,3.26158,0.057,NULL,58478091322,913720176,14276877,16.9),(116834,'CMD','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116834,16.1,NULL,0.0166,51350,NULL,NULL,NULL,'NGC 5466',NULL,'2008A&A...477..139L',2008,1,NULL,NULL,'*Cl',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,211.364,28.5345,0,0,60006465394,937601021,14650015,NULL),(116835,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116835,35.38,0.46,119,51351,70,NULL,NULL,'UGC 09012',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000097,NULL,'15.5',0.6,'S0            AGN?','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,211.3680417,30.76722,0,NULL,60050354108,938286782,14660730,15.5),(116836,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116836,35.23,0.49,111,51352,75,NULL,'IR','UGC 09014',NULL,'2011yCatp016004901K',2011,1,1.64,'RC3 gives an HI velocity of 9,991 km/sec.','G',0.000093,NULL,'14.9g',0.29,'S?',NULL,NULL,NULL,NULL,1,211.369833333,34.92197,0,NULL,60036097240,938064019,14657250,14.9),(116837,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116837,35.68,0.47,137,51352,NULL,NULL,'H','UGC 09014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116838,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116838,35.81,0.45,145,51352,NULL,NULL,'K','UGC 09014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116839,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116839,35.82,0.4,146,51352,NULL,NULL,'mean','UGC 09014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116840,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116840,35.91,0.46,152,51352,NULL,NULL,'J','UGC 09014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116841,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116841,37.46,0.46,311,51353,70,NULL,NULL,'2MASX J14052932+3703451',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00018,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,211.372375,37.0625,0,NULL,59142814981,924106484,14439163,17.2),(116842,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116842,36.86,0.46,236,51354,70,NULL,NULL,'2MASX J14053105+2932303',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.42',0.16,'E',NULL,NULL,NULL,NULL,1,211.379333333,29.54186,0,NULL,60006277262,937598082,14649970,18.42),(116843,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116843,36.63,0.53,212,51355,70,NULL,NULL,'ESO 578- G 021',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.53',0.5,'S0',NULL,NULL,NULL,NULL,1,211.3797083,-22.23975,0.201,NULL,46522977367,726921521,11358148,15.53),(116844,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116844,33.76,0.2,56.5,51356,74.4,NULL,NULL,'CGCG 074-095',NULL,'2013AJ....146...86T',2013,1,0.66,NULL,'G',0.000103,NULL,'15.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,211.380041667,12.44653,0,NULL,58360068638,911876072,14248063,15.6),(116845,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116845,37.79,0.46,361,51357,70,NULL,NULL,'2MASX J14053137+4325092',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,211.3805417,43.41928,0,NULL,59237459938,925585311,14462270,17.5),(116846,'Brightest Stars','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116846,29.43,NULL,7.7,51358,NULL,NULL,NULL,'NGC 5477',NULL,'1994BSAO...38....5K',1994,1,1.7,'May be associated with MESSIER 101. Multiple SDSS entries describe this object.','G',0.000017,NULL,'14.36',1.3,'SA(s)m','in a radial-velocity based grouping',NULL,NULL,NULL,1,211.38875,54.46114,0,NULL,57298523957,895289436,13988897,14.36),(116847,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116847,29.15,0.1,6.76,51358,74.4,NULL,NULL,'NGC 5477',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116848,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116848,29.15,0.13,6.77,51358,NULL,NULL,NULL,'NGC 5477',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116849,'HII region diameter','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116849,28.71,0.16,5.52,51358,NULL,NULL,'Method 2','NGC 5477',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116850,'HII region diameter','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116850,29,0.09,6.31,51358,NULL,NULL,'Method 1','NGC 5477',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116851,'Magnitude','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116851,30.39,0.16,12,51358,NULL,NULL,NULL,'NGC 5477',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116852,'Tully est','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116852,29.01,0.8,6.4,51358,75,NULL,'B','NGC 5477',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116853,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116853,37.71,0.46,348,51359,70,NULL,NULL,'2MASX J14053333+3415314',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,211.388917,34.25864,0,NULL,60035685715,938057589,14657149,17.6),(116854,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116854,37.84,0.46,371,51360,70,NULL,NULL,'2MASX J14053418+1812087',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.77',0.14,NULL,NULL,NULL,NULL,NULL,1,211.392458333,18.20253,0.012,NULL,58372133489,912064585,14251009,18.77),(116855,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116855,37.6,0.15,331,51361,70,NULL,NULL,'2MASX J14053453+0615077',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000152,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,211.394083333,6.25206,0.05,NULL,58511774700,914246479,14285101,17.2),(116856,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116856,37.64,0.33,337,51362,70,NULL,NULL,'SDSS J140535.06+355735.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000154,NULL,'18.4g',0.09,NULL,NULL,NULL,NULL,NULL,1,211.396083333,35.96,0,NULL,59153380191,924271565,14441743,18.4),(116857,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116857,36.95,0.46,246,51363,70,NULL,NULL,'2MASX J14053517+2421183',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000164,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,211.3964583,24.35522,0,NULL,59467916579,929186196,14518534,16.8),(116858,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116858,36.65,0.46,214,51364,70,NULL,NULL,'2MASX J14053661+2024567',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.27',0.16,NULL,NULL,NULL,NULL,NULL,1,211.4024583,20.41592,0.045,NULL,59466789020,929168578,14518259,17.27),(116859,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116859,37.6,0.15,331,51365,70,NULL,NULL,'2MASX J14053662+0619377',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000182,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,211.402583,6.32719,0.041,NULL,58511759958,914246249,14285097,17.2),(116860,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116860,37.56,0.21,326,51366,70,NULL,NULL,'2MASX J14053826+4623281',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000185,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,211.409291667,46.39114,0,NULL,59234499846,925539060,14461547,16.5),(116861,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116861,37.23,0.46,279,51367,70,NULL,NULL,'2MASX J14053933+0138446',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000073,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,211.4139583,1.64564,0.081,NULL,58402823873,912544123,14258501,17.1),(116862,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116862,38.73,0.33,556,51368,70,NULL,NULL,'SDSS J140540.19+034710.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000104,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,211.4175,3.78636,0.049,NULL,58478125113,913720704,14276886,18.6),(116863,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116863,37.78,0.46,360,51369,70,NULL,NULL,'2MASX J14054062+5906584',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000187,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,211.419417,59.11617,0,NULL,57272144831,894877262,13982457,17.3),(116864,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116864,37.69,0.46,345,51370,70,NULL,NULL,'SDSS J140543.17+365537.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000152,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,211.429917,36.92714,0,NULL,59142775129,924105861,14439154,18.4),(116865,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116865,35.48,0.27,124,51371,70,NULL,NULL,'2MASX J14054358+6534315',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000095,NULL,'15.9g',0.29,'E0',NULL,NULL,NULL,NULL,1,211.43125,65.57553,0.053,NULL,57945594896,905399920,14146873,15.9),(116866,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116866,37.46,0.46,311,51372,70,NULL,NULL,'2MASX J14054484+4147567',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000163,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,211.437,41.79894,0,NULL,59258795730,925918683,14467479,17.2),(116867,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116867,37.06,0.56,258,51373,70,NULL,NULL,'2MASX J14054546-2718126',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000103,NULL,'15.3',0.4,'E',NULL,NULL,NULL,NULL,1,211.439375,-27.30353,0.201,NULL,46989126293,734205098,11471954,15.3),(116868,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116868,37.01,0.46,252,51374,70,NULL,NULL,'SDSS J140546.66+094151.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00018,NULL,'17.80',0.2,NULL,NULL,NULL,NULL,NULL,1,211.444458333,9.69775,0,NULL,58509155959,914205561,14284461,17.8),(116869,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116869,38.21,0.46,439,51375,70,NULL,NULL,'SDSS J140548.71+095446.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.453,9.913,0,NULL,58508777586,914199649,14284369,18.4),(116870,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116870,37.38,0.46,299,51376,70,NULL,NULL,'2MASX J14055076+0303553',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000076,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,211.4615,3.06533,0.057,NULL,58478035246,913719300,14276864,17.4),(116871,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116871,35.87,0.46,149,51377,70,NULL,NULL,'CGCG 272-026',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000103,NULL,'15.0g',0.48,'E0',NULL,NULL,NULL,NULL,1,211.468333,53.129,0,NULL,59215318525,925239351,14456864,15),(116872,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116872,35.48,0.27,124,51378,70,NULL,NULL,'SDSS J140553.34+654227.7',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'15.4g',0.4,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.4722917,65.70772,0.053,NULL,57945577086,905399641,14146869,15.4),(116873,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116873,36.75,0.46,223,51379,70,NULL,NULL,'2MASX J14055348+3310145',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.31',0.25,NULL,NULL,NULL,NULL,NULL,1,211.4730417,33.17086,0,NULL,60036549405,938071084,14657360,16.31),(116874,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116874,36.58,0.46,207,51380,70,NULL,NULL,'2MASX J14055380+4821555',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000103,NULL,'15.4g',0.53,NULL,NULL,NULL,NULL,NULL,1,211.474208333,48.36558,0.057,NULL,59241674497,925651164,14463299,15.4),(116875,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116875,36.64,0.46,212,51381,70,NULL,NULL,'2MASX J14055393-0044435',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00009,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,211.474666667,-0.74542,0.141,NULL,43589076697,681079323,10641864,16.5),(116876,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116876,38.07,0.46,411,51382,70,NULL,NULL,'2MASX J14055604+1751548',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,211.483583333,17.86511,0,NULL,58355368682,911802635,14246916,NULL),(116877,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116877,35.05,0.57,102,51383,70,NULL,NULL,'MCG -02-36-016',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.2b',0.3,NULL,NULL,NULL,NULL,NULL,1,211.487083,-15.29867,0.325,NULL,43648215175,682003362,10656302,15.2),(116878,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116878,36.28,0.46,181,51384,70,NULL,NULL,'2MASX J14055724+2648530',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000185,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,211.488625,26.81475,0,NULL,60011556261,937680566,14651258,16.4),(116879,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116879,35.48,0.27,124,51385,70,NULL,NULL,'NGC 5479',NULL,'2015arXiv151105856S',2015,1,0.91,NULL,'G',0.000093,NULL,'14.6g',0.77,'E0             AGN',NULL,NULL,NULL,NULL,1,211.4890417,65.69075,0.053,NULL,57945606963,905400108,14146876,14.6),(116880,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116880,37.28,0.46,285,51386,70,NULL,NULL,'2MASX J14055761+1127404',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,211.490167,11.46131,0,NULL,58490367616,913911994,14279874,17.5),(116881,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116881,35.39,0.65,120,51387,70,NULL,NULL,'MCG -02-36-015',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000127,NULL,'14.61',0.6,NULL,NULL,NULL,NULL,NULL,1,211.491916667,-12.07275,0.157,NULL,43713518177,683023721,10672245,14.61),(116882,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116882,38.01,0.46,400,51388,70,NULL,NULL,'2MASX J14055834+2438390',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00019,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,211.493167,24.64414,0,NULL,60001644286,937525691,14648838,17.2),(116883,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116883,37.27,0.46,284,51389,70,NULL,NULL,'2MASX J14055940+6251209',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,211.497333,62.85575,0.025,NULL,57750680270,902354379,14099287,17.3),(116884,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116884,36.24,0.46,177,51390,70,NULL,NULL,'2MASX J14060177+2715220',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,211.507375,27.25625,0,NULL,60008624042,937634750,14650542,16.9),(116885,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116885,38.26,0.46,448,51391,70,NULL,NULL,'2MASX J14060191+0944394',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000176,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,211.508083333,9.74414,0,NULL,58509288142,914207627,14284494,17.2),(116886,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116886,37.64,0.33,337,51392,70,NULL,NULL,'2MASX J14060222+3559167',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000171,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,211.5092917,35.98789,0,NULL,59153325167,924270705,14441729,17.8),(116887,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116887,36.59,0.46,208,51393,70,NULL,NULL,'2MASX J14060254+1856068',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.84',0.21,NULL,NULL,NULL,NULL,NULL,1,211.510583,18.93519,0.034,NULL,59462848432,929107006,14517296,16.84),(116888,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116888,37.36,0.46,297,51394,70,NULL,NULL,'2MASX J14060369+1701538',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.90',0.22,NULL,NULL,NULL,NULL,NULL,1,211.5155,17.03164,0,NULL,58355871369,911810490,14247038,17.9),(116889,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116889,36.15,0.46,170,51395,70,NULL,NULL,'2MASX J14060375+1230158',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.59',0.23,NULL,NULL,NULL,NULL,NULL,1,211.5157083,12.5045,0,NULL,58359827637,911872306,14248004,17.59),(116890,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116890,34.05,0.2,64.6,51396,74.4,NULL,NULL,'KUG 1403+120',NULL,'2013AJ....146...86T',2013,1,1.06,NULL,'G',0.00012,NULL,'15.2g',0.48,'Spiral',NULL,NULL,NULL,NULL,1,211.527041667,11.78883,0,NULL,58490266220,913910409,14279850,15.2),(116891,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116891,37.1,0.46,263,51397,70,NULL,NULL,'2MASX J14060665+5824104',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,211.5280417,58.40297,0,NULL,57304499058,895382797,13990356,17.7),(116892,'D-Sigma','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116892,33.26,0.4,44.9,51398,75,NULL,'Edat, raw','ESO 384- G 049',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.00004,NULL,'14.06',0.7,'E?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,211.5290417,-33.92344,0.213,NULL,47005155088,734455548,11475867,14.06),(116893,'D-Sigma','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116893,33.44,0.4,48.7,51398,75,NULL,'Edat, cor','ESO 384- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116894,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116894,33.77,0.23,56.8,51398,74.4,NULL,NULL,'ESO 384- G 049',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116895,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116895,33.95,0.47,61.6,51398,70,NULL,NULL,'ESO 384- G 049',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116896,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116896,32.98,0.25,39.5,51399,74.4,NULL,NULL,'ABELL S0753:[WFC91] 083',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000077,NULL,'16.0b',NULL,'S0',NULL,NULL,NULL,NULL,1,211.5295417,-33.20431,0.261,NULL,47005185446,734456022,11475875,16),(116897,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116897,36.6,0.46,209,51400,70,NULL,NULL,'2MASX J14060795+1812361',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.59',0.15,NULL,NULL,NULL,NULL,NULL,1,211.533125,18.21,0,NULL,58325991609,911343618,14239744,18.59),(116898,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116898,37.56,0.21,326,51401,70,NULL,NULL,'2MASX J14060821+4636095',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000191,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,211.5340417,46.60256,0,NULL,59234467401,925538553,14461539,16.4),(116899,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116899,36.74,0.46,223,51402,70,NULL,NULL,'2MASX J14060819+4711235',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000167,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,211.53425,47.18986,0.021,NULL,59242422112,925662845,14463481,16.6),(116900,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116900,37.01,0.46,252,51403,70,NULL,NULL,'2MASX J14061004+0547483',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000158,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,211.541917,5.79689,0.029,NULL,58479174666,913737104,14277142,17.6),(116901,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116901,37.16,0.46,271,51404,70,NULL,NULL,'2MASX J14061033+2205061',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.44',0.15,NULL,NULL,NULL,NULL,NULL,1,211.543,22.08519,0.005,NULL,59474572700,929290198,14520159,18.44),(116902,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116902,37.63,0.46,336,51405,70,NULL,NULL,'SDSS J140610.61+645241.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000074,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,211.54425,64.87814,0.017,NULL,57934546095,905227282,14144176,18.7),(116903,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116903,34.66,0.47,85.5,51406,70,NULL,NULL,'2MASX J14061234-2712454',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000087,NULL,'15.3b',NULL,'S0',NULL,NULL,NULL,NULL,1,211.5514583,-27.21261,0.201,NULL,46989153408,734205522,11471961,15.3),(116904,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116904,37.6,0.46,330,51407,70,NULL,NULL,'2MASX J14061335+0651292',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,211.555625,6.85808,0.024,NULL,58516636782,914322449,14286288,17),(116905,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116905,38.73,0.33,556,51408,70,NULL,NULL,'2MASX J14061432+0346503',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00009,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,211.5597917,3.78058,0.033,NULL,58478104092,913720376,14276880,17.6),(116906,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116906,37.93,0.46,385,51409,70,NULL,NULL,'2MASX J14061436+0633382',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,211.5597917,6.56056,0.036,NULL,58511718967,914245608,14285087,17.1),(116907,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116907,36.25,0.2,178,51410,74.4,NULL,NULL,'UGC 09019',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',NULL,NULL,'15.26',0.4,'Sbc',NULL,NULL,NULL,NULL,1,211.56275,20.14122,0.039,NULL,59466612530,929165820,14518215,15.26),(116908,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116908,37.6,0.15,331,51411,70,NULL,NULL,'2MASX J14061557+0615372',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000181,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,211.565041667,6.26036,0.05,NULL,58511810729,914247042,14285110,16.4),(116909,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116909,37.97,0.46,392,51412,70,NULL,NULL,'2MASX J14061566+0359393',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000103,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,211.565417,3.99433,0.025,NULL,58478488401,913726381,14276974,16.8),(116910,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116910,38.54,0.46,509,51413,70,NULL,NULL,'2MASX J14061581+6351211',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000088,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,211.565917,63.856,0,NULL,57935646787,905244481,14144445,17.7),(116911,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116911,37.68,0.46,344,51414,70,NULL,NULL,'2MASX J14061599-0038274',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000087,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,211.566833,-0.64108,0.137,NULL,43589086137,681079470,10641866,17),(116912,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116912,34.87,0.25,94.2,51415,74.4,NULL,NULL,'ESO 510- G 063',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000028,NULL,'14.76',0.5,'SAB(s)0-',NULL,NULL,NULL,NULL,1,211.5669583,-25.79931,0.213,NULL,46990436791,734225574,11472274,14.76),(116913,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116913,37.07,0.96,259,51416,70,NULL,NULL,'2MASX J14061694-3949188',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,211.570625,-39.82192,0.057,NULL,46909589882,732962341,11452536,15.5),(116914,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116914,37.75,0.46,355,51417,70,NULL,NULL,'2MASX J14061694+2909296',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.83',0.12,NULL,NULL,NULL,NULL,NULL,1,211.570791667,29.15819,0.011,NULL,60006825637,937606650,14650103,18.83),(116915,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116915,37.98,0.46,395,51418,70,NULL,NULL,'2MASX J14061798+4006378',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,211.574833333,40.1105,0,NULL,59260637596,925947462,14467929,17.7),(116916,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116916,35.37,0.47,119,51419,NULL,NULL,'H','MCG -03-36-006',NULL,'2007A&A...465...71T',2007,1,0.7,NULL,'G',0.00002,NULL,'15.15',0.5,'Sbc',NULL,NULL,NULL,NULL,1,211.5755,-16.64119,0.277,NULL,43649353607,682021150,10656580,15.15),(116917,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116917,35.51,0.45,126,51419,NULL,NULL,'K','MCG -03-36-006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116918,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116918,35.52,0.4,127,51419,NULL,NULL,'mean','MCG -03-36-006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116919,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116919,35.53,0.46,128,51419,NULL,NULL,'J','MCG -03-36-006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116920,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116920,37.17,0.46,272,51420,70,NULL,NULL,'2MASX J14061927+4833279',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000194,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,211.580125,48.55767,0.042,NULL,59256093307,925876457,14466819,16.5),(116921,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116921,37.55,0.33,324,51421,70,NULL,NULL,'2MASX J14061990+5612522',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000167,NULL,'16.8g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,211.582833,56.21447,0,NULL,57299756496,895308695,13989198,16.8),(116922,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116922,32.52,0.8,31.9,51422,75,NULL,'CF, r','NGC 5480',NULL,'1997ApJS..109..333W',1997,1,1.63,'UGC misprints dec as +50d39\', as is evident in the UGC notes.','G',0.000017,NULL,'12.8g',1.22,'SA(s)c:','Pair member (points to parent)',NULL,NULL,NULL,1,211.589917,50.72511,0.013,NULL,59250247103,925785110,14465392,12.8),(116923,'Tully est','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116923,32.52,0.8,31.9,51422,75,NULL,'B','NGC 5480',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116924,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116924,31.75,0.38,22.4,51422,75,NULL,'CF, r, raw','NGC 5480',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116925,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116925,31.79,0.38,22.8,51422,75,NULL,'CF, r, inv','NGC 5480',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116926,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116926,32.02,0.38,25.3,51422,75,NULL,'CF, r, cor','NGC 5480',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116927,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116927,32.43,0.45,30.6,51422,NULL,NULL,'K','NGC 5480',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116928,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116928,32.44,0.47,30.7,51422,NULL,NULL,'H','NGC 5480',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116929,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116929,32.45,0.46,30.9,51422,NULL,NULL,'J','NGC 5480',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116930,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116930,32.47,0.4,31.2,51422,NULL,NULL,'mean','NGC 5480',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116931,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116931,37.27,0.46,284,51423,70,NULL,NULL,'2MASX J14062279-0013253',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00011,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,211.594875,-0.22367,0.113,NULL,43589162454,681080663,10641885,16.7),(116932,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116932,36.73,0.23,222,51424,70,NULL,NULL,'2MASX J14062318+1539001',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.80',0.19,NULL,NULL,NULL,NULL,NULL,1,211.596667,15.65019,0,NULL,58357410681,911834541,14247414,17.8),(116933,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116933,37.5,0.46,317,51425,70,NULL,NULL,'2MASX J14062534+1303271',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000161,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,211.605583,13.05756,0.036,NULL,58363585784,911931027,14248922,17),(116934,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116934,37.64,0.46,338,51426,70,NULL,NULL,'2MASX J14062529+4858129',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000142,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,211.605583,48.97022,0.027,NULL,59254261450,925847835,14466372,17.1),(116935,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116935,37.8,0.46,364,51427,70,NULL,NULL,'2MASX J14062588+2232222',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.13',0.17,NULL,NULL,NULL,NULL,NULL,1,211.6080417,22.53956,0,NULL,59474987102,929296673,14520260,18.13),(116936,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116936,37.55,0.33,324,51428,70,NULL,NULL,'2MASX J14062760+5608293',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,211.614917,56.1415,0,NULL,57299728023,895308250,13989191,17.2),(116937,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116937,37.22,0.33,278,51429,70,NULL,NULL,'2MASX J14062816+2622446',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,211.6174583,26.37906,0,NULL,60010289103,937660767,14650949,17.5),(116938,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116938,37.89,0.46,378,51430,70,NULL,NULL,'2MASX J14062885+1143132',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,211.6202083,11.72039,0,NULL,58490251479,913910179,14279846,17.8),(116939,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116939,38.76,0.46,565,51431,70,NULL,NULL,'2MASX J14062911+1613181',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,211.6215417,16.22181,0,NULL,58359126116,911861345,14247833,18.2),(116940,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116940,34.64,0.46,84.6,51432,70,NULL,NULL,'CGCG 219-051',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000143,NULL,'15.0g',0.51,'S0^-',NULL,NULL,NULL,NULL,1,211.6242917,39.49619,0,NULL,59257678514,925901226,14467206,15),(116941,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116941,38.01,0.33,400,51433,70,NULL,NULL,'2MASX J14063028+4156380',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000166,NULL,'16.1g',0.42,NULL,NULL,NULL,NULL,NULL,1,211.626125,41.94378,0,NULL,59258820512,925919070,14467485,16.1),(116942,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116942,37.6,0.15,331,51434,70,NULL,NULL,'2MASX J14063033+0614452',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000179,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,211.626333,6.24592,0.05,NULL,58511813479,914247085,14285110,16.7),(116943,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116943,38.02,0.46,402,51435,70,NULL,NULL,'2MASX J14063131+6104501',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000128,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,211.630583,61.08067,0,NULL,57262949971,894733593,13980212,17.9),(116944,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116944,37.93,0.46,386,51436,70,NULL,NULL,'2MASX J14063159+0604128',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00019,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,211.6317917,6.07033,0.034,NULL,58479183455,913737241,14277144,17),(116945,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116945,31.54,0.43,20.3,51437,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5470',NULL,'2014MNRAS.444..527S',2014,1,1.52,NULL,'G',0.00003,NULL,'13.8g',0.6,'Sb','Group member of poor cluster',NULL,NULL,NULL,1,211.6329583,6.02969,0.034,NULL,58479197191,913737456,14277147,13.8),(116946,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116946,31.61,0.4,21,51437,75,NULL,NULL,'NGC 5470',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116947,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116947,31.68,0.4,21.7,51437,NULL,NULL,'mean','NGC 5470',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116948,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116948,31.96,NULL,24.7,51437,72,NULL,NULL,'NGC 5470',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116949,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116949,32.04,0.46,25.5,51437,NULL,NULL,'J','NGC 5470',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116950,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116950,32.04,0.47,25.6,51437,NULL,NULL,'H','NGC 5470',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116951,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116951,32.08,0.45,26,51437,NULL,NULL,'K','NGC 5470',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116952,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116952,32.11,0.49,26.5,51437,75,NULL,'IR','NGC 5470',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116953,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116953,37.91,0.46,382,51438,70,NULL,NULL,'2MASX J14063220+1906172',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,211.634083,19.10489,0.032,NULL,59463613992,929118968,14517483,17.7),(116954,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116954,34.66,0.2,85.5,51439,74.4,NULL,NULL,'UGC 09021',NULL,'2013AJ....146...86T',2013,1,1.29,NULL,'G',0.000033,NULL,'16.1g',0.26,'Sd',NULL,NULL,NULL,NULL,1,211.6345,12.71194,0,NULL,58363477747,911929339,14248895,16.1),(116955,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116955,37.56,0.33,325,51440,70,NULL,NULL,'2MASX J14063361+2502526',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000187,NULL,'17.86',0.2,NULL,NULL,NULL,NULL,NULL,1,211.6400417,25.04783,0,NULL,60001873542,937529274,14648894,17.86),(116956,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116956,36.08,0.53,165,51441,70,NULL,NULL,'ESO 384-IG 052 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000123,NULL,'15.85',NULL,'E',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,211.641416667,-33.58731,0.221,NULL,47005238602,734456853,11475888,15.85),(116957,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116957,35.8,0.46,144,51442,70,NULL,NULL,'2MASX J14063440-0111133',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000106,NULL,'15.4g',0.43,NULL,NULL,NULL,NULL,NULL,1,211.643375,-1.18703,0.161,NULL,43590610700,681103292,10642238,15.4),(116958,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116958,38.03,0.46,404,51443,70,NULL,NULL,'2MASX J14063454+5607553',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,211.644083333,56.13203,0,NULL,57299727726,895308245,13989191,17.4),(116959,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116959,32.54,0.22,31.9,51444,74.2,NULL,'SALT 2','NGC 5468',0.00948,'2010ApJ...716..712A',2010,1,2.6,'The APM position is 8 arcsec northeast of the nucleus.','G',0.000013,NULL,'12.7B',2.4,'SAB(rs)cd','in a pair',NULL,NULL,NULL,1,211.645375,-5.45311,0.077,NULL,43727637169,683244330,10675692,12.7),(116960,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2002cr',NULL,116960,32.62,0.26,33.1,51444,74.2,NULL,'SALT 2','NGC 5468',0.00948,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116961,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116961,32.9,0.16,37.7,51444,72,NULL,NULL,'NGC 5468',0.00948,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116962,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116962,32.94,0.14,38.4,51444,72,NULL,NULL,'NGC 5468',0.00948,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116963,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116963,33.06,0.04,40.9,51444,72,NULL,'M(H) = -18.317 mag','NGC 5468',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116964,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116964,33.12,0.25,41.7,51444,70,NULL,'SALT 2','NGC 5468',0.00948,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116965,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116965,33.12,0.04,41.7,51444,72,NULL,NULL,'NGC 5468',0.00948,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116966,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116966,33.17,0.28,42.6,51444,72,NULL,NULL,'NGC 5468',0.00948,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116967,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116967,33.2,0.08,43.7,51444,74.4,NULL,NULL,'NGC 5468',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116968,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116968,33.23,0.22,43.8,51444,70,NULL,'SALT','NGC 5468',0.00948,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116969,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2002cr',NULL,116969,33.23,0.03,43.8,51444,72,NULL,'MLCS17','NGC 5468',0.00948,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116970,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116970,33.21,0.17,43.9,51444,70.8,NULL,NULL,'NGC 5468',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116971,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2002cr',NULL,116971,33.3,0.23,45.2,51444,73.8,NULL,'SALT 2 (SNANA)','NGC 5468',0.0103,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116972,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2002cr',NULL,116972,33.3,0.25,45.3,51444,70,NULL,'SALT 2','NGC 5468',0.00948,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116973,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116973,33.36,0.23,46.5,51444,73.8,NULL,'SALT 2 (SNANA)','NGC 5468',0.0105,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116974,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116974,33.41,0.31,47.7,51444,65,NULL,'SALT2','NGC 5468',0.00948,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116975,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116975,33.44,0.3,48.3,51444,65,NULL,'MLCS17','NGC 5468',0.00948,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116976,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116976,33.45,0.03,48.6,51444,72,NULL,NULL,'NGC 5468',0.00948,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116977,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2002cr',NULL,116977,33.46,0.29,48.7,51444,65,NULL,'MLCS17','NGC 5468',0.00948,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116978,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2002cr',NULL,116978,33.49,0.31,49.4,51444,65,NULL,'SALT2','NGC 5468',0.00948,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116979,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116979,33.5,0.29,49.6,51444,65,NULL,'MLCS31','NGC 5468',0.00948,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116980,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116980,33.52,0.1,49.6,51444,65,NULL,'MLCS2k2','NGC 5468',0.00948,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116981,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2002cr',NULL,116981,33.51,0.29,49.8,51444,65,NULL,'MLCS31','NGC 5468',0.00948,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116982,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116982,33.56,0.13,51,51444,70,NULL,NULL,'NGC 5468',0.00948,'2000ApJ...539..658K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116983,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116983,33.56,0.31,51,51444,65,NULL,NULL,'NGC 5468',0.00948,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116984,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116984,33.09,0.4,41.5,51444,75,NULL,'B','NGC 5468',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116985,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116985,38.01,0.33,400,51445,70,NULL,NULL,'2MASX J14063491+4157445',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000175,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,211.6455,41.96214,0,NULL,59258775960,925918374,14467474,18),(116986,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116986,33.79,0.48,57.2,51446,70,NULL,NULL,'ESO 384- G 053',NULL,'2014MNRAS.445.2677S',2014,1,2.5,NULL,'G',0.000013,NULL,'12.94',2,'SAB(rs)b',NULL,NULL,NULL,NULL,1,211.647875,-34.31161,0.213,NULL,47003120164,734423752,11475371,12.94),(116987,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116987,34.15,0.8,67.5,51446,75,NULL,'MAT, I','ESO 384- G 053',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116988,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116988,30.89,0.32,15.1,51446,85,NULL,'I, raw','ESO 384- G 053',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116989,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116989,30.89,0.32,15.1,51446,85,NULL,'I, inv','ESO 384- G 053',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116990,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116990,31.18,0.43,17.2,51446,75,NULL,'MAT, I, raw','ESO 384- G 053',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116991,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116991,31.24,0.43,17.7,51446,75,NULL,'MAT, I, inv','ESO 384- G 053',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116992,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116992,31.5,0.43,20,51446,75,NULL,'MAT, I, cor','ESO 384- G 053',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116993,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116993,32.22,0.47,27.8,51446,NULL,NULL,'H','ESO 384- G 053',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116994,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116994,32.44,0.45,30.7,51446,NULL,NULL,'K','ESO 384- G 053',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116995,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116995,32.44,0.46,30.7,51446,NULL,NULL,'J','ESO 384- G 053',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116996,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116996,34.07,0.4,65.2,51446,NULL,NULL,'mean','ESO 384- G 053',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116997,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116997,37.56,0.33,325,51447,70,NULL,NULL,'SDSS J140636.29+245947.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000144,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.65125,24.99644,0,NULL,60001872905,937529264,14648894,18.3),(116998,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116998,36.22,0.25,175,51448,74.4,NULL,NULL,'GIN 339',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000053,NULL,'14.61',NULL,'E/S0',NULL,NULL,NULL,NULL,1,211.6520417,-9.22894,0.069,NULL,43748062059,683563469,10680679,14.61),(116999,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116999,36.44,0.24,194,51448,70,NULL,NULL,'GIN 339',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117000,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117000,38.3,0.46,458,51449,70,NULL,NULL,'SDSS J140639.23+110149.4',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000165,NULL,'18.6g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.663458333,11.03039,0,NULL,58493466549,913960414,14280631,18.6),(117001,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117001,37.6,0.15,331,51450,70,NULL,NULL,'2MASX J14064026+0616582',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000178,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,211.667625,6.28286,0.05,NULL,58511837524,914247461,14285116,16.5),(117002,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117002,38.48,0.46,496,51451,70,NULL,NULL,'SDSS J140640.23+192633.4',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,211.667625,19.44261,0.029,NULL,59463470470,929116726,14517448,NULL),(117003,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117003,37.79,0.46,361,51452,70,NULL,NULL,'2MASX J14064047+5923053',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000175,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,211.6687083,59.38483,0.009,NULL,57271824114,894872251,13982378,17.3),(117004,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117004,33.67,0.4,54.1,51453,NULL,NULL,'mean','ESO 175- G 001',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.00003,NULL,'13.85',1.2,'(R\')SA(rs)b',NULL,NULL,NULL,NULL,1,211.668625,-55.35731,NULL,NULL,44757211896,699331435,10927053,13.85),(117005,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117005,33.83,0.46,58.3,51453,NULL,NULL,'J','ESO 175- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117006,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117006,33.85,0.47,58.9,51453,NULL,NULL,'H','ESO 175- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117007,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117007,33.91,0.45,60.5,51453,NULL,NULL,'K','ESO 175- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117008,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117008,31.58,0.2,20.7,51454,74.4,NULL,NULL,'UGC 09024',NULL,'2013AJ....146...86T',2013,1,2.1,NULL,'G',0.000004,NULL,'16.0',2,'S?',NULL,NULL,NULL,NULL,1,211.668917,22.07011,0.027,NULL,59474566750,929290105,14520157,16),(117009,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117009,31.93,0.43,24.4,51454,75,NULL,'3.6 micron, color corrected','UGC 09024',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117010,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117010,32.24,0.43,28.1,51454,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09024',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117011,'GCLF','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117011,31.84,0.56,23.3,51455,NULL,NULL,'HST KP Calibrated, V','NGC 5481',NULL,'2000ApJ...529..745F',2000,1,1.8,NULL,'G',0.000017,NULL,'13.25',1.5,'E+','Pair member (points to parent)',NULL,NULL,NULL,1,211.671958333,50.72333,0.013,NULL,59250261371,925785333,14465395,13.25),(117012,'GCLF','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117012,31.9,0.5,24,51455,NULL,NULL,NULL,'NGC 5481',NULL,'2000ApJS..128..431F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117013,'GCLF','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117013,32.2,0.4,27.5,51455,NULL,NULL,NULL,'NGC 5481',NULL,'1995A&A...297..660M',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117014,'Tully est','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117014,32.76,0.8,35.6,51455,75,NULL,'B','NGC 5481',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117015,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117015,32.44,0.4,30.7,51455,NULL,NULL,'mean','NGC 5481',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117016,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117016,33.21,0.45,43.8,51455,NULL,NULL,'K','NGC 5481',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117017,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117017,38.37,0.33,472,51456,70,NULL,NULL,'2MASX J14064311+3559340',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000133,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,211.6797083,35.99281,0,NULL,59141784996,924090390,14438912,17.7),(117018,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117018,36.76,0.46,225,51457,70,NULL,NULL,'2MASX J14064772+2330581',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.54',0.2,NULL,NULL,NULL,NULL,NULL,1,211.6987917,23.51633,0,NULL,59472696396,929260881,14519701,17.54),(117019,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117019,37.76,0.46,356,51458,70,NULL,NULL,'SDSS J140648.10-013844.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,211.7004583,-1.64567,0.153,NULL,43590024465,681094132,10642095,17.9),(117020,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117020,36.59,0.27,208,51459,70,NULL,NULL,'2MASX J14064878+1842121',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.57',0.14,NULL,NULL,NULL,NULL,NULL,1,211.703417,18.70333,0.02,NULL,59462892409,929107693,14517307,18.57),(117021,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117021,36.59,0.27,208,51460,70,NULL,NULL,'2MASX J14064907+1857541',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.85',0.23,'AGN',NULL,NULL,NULL,NULL,1,211.704583,18.96517,0.032,NULL,59462740646,929105322,14517270,16.85),(117022,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117022,36.59,0.27,208,51461,70,NULL,NULL,'2MASX J14065055+1857201',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.00',0.34,'AGN',NULL,NULL,NULL,NULL,1,211.7107917,18.95558,0.022,NULL,59462740981,929105327,14517270,17),(117023,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117023,37.38,0.46,299,51462,70,NULL,NULL,'2MASX J14065093+0959392',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000162,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,211.712333,9.99428,0,NULL,58508904340,914201630,14284400,16.7),(117024,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117024,34.96,0.8,98.1,51463,75,NULL,'HMCL, I','UGC 09023',NULL,'1997ApJS..109..333W',1997,1,1.08,NULL,'G',0.00002,NULL,'15.7g',0.38,'Scd:',NULL,NULL,NULL,NULL,1,211.7127917,9.32119,0,NULL,58509092769,914204574,14284446,15.7),(117025,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117025,34.99,0.8,99.4,51463,75,NULL,'CF, r','UGC 09023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117026,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117026,34.46,0.38,78.1,51463,75,NULL,'CF, r, inv','UGC 09023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117027,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117027,34.47,0.38,78.2,51463,75,NULL,'CF, r, raw','UGC 09023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117028,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117028,34.72,0.38,87.8,51463,75,NULL,'CF, r, cor','UGC 09023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117029,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117029,34.81,0.4,91.4,51463,75,NULL,'HMCL, I, raw','UGC 09023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117030,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117030,34.88,0.4,94.7,51463,75,NULL,'HMCL, I, inv','UGC 09023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117031,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117031,34.97,0.4,98.5,51463,75,NULL,'HMCL, I, cor','UGC 09023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117032,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117032,34.98,0.41,99,51463,NULL,NULL,'Malmquist cor.','UGC 09023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117033,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117033,35.04,0.4,102,51463,NULL,NULL,NULL,'UGC 09023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117034,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117034,35.08,0.2,104,51463,74.4,NULL,NULL,'UGC 09023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117035,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117035,33.65,0.23,53.7,51464,74.4,NULL,NULL,'ABELL S0753:[WFC91] 095',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000047,NULL,'14.90',0.6,'E',NULL,NULL,NULL,NULL,1,211.713583,-34.49186,0.197,NULL,47003223182,734425362,11475396,14.9),(117036,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117036,34.28,0.56,71.7,51464,70,NULL,NULL,'ABELL S0753:[WFC91] 095',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117037,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117037,38.53,0.33,509,51465,70,NULL,NULL,'2MASX J14065141+1906181',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,211.714125,19.10508,0.032,NULL,59463603387,929118802,14517481,18.1),(117038,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117038,35.24,0.46,112,51466,70,NULL,NULL,'CGCG 018-049',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000093,NULL,'14.9g',0.61,'E0',NULL,NULL,NULL,NULL,1,211.7147083,-1.54075,0.153,NULL,43590017998,681094031,10642094,14.9),(117039,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117039,33.01,0.47,39.9,51467,NULL,NULL,'H','NGC 5472',NULL,'2007A&A...465...71T',2007,1,1.3,'6dF final data release has z = 0.023299 +- 0.000150.','G',0.000057,NULL,'14.76',0.4,'SA(r)ab? sp','in a pair',NULL,NULL,NULL,1,211.72925,-5.46047,0.077,NULL,43727642179,683244409,10675693,14.76),(117040,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117040,33.14,0.45,42.4,51467,NULL,NULL,'K','NGC 5472',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117041,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117041,33.16,0.4,42.9,51467,NULL,NULL,'mean','NGC 5472',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117042,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117042,33.22,0.46,44.1,51467,NULL,NULL,'J','NGC 5472',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117043,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117043,37.6,0.15,331,51468,70,NULL,NULL,'SDSS J140655.73+062809.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,211.73225,6.46928,0.051,NULL,58511688436,914245131,14285080,17.7),(117044,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117044,35.35,0.46,117,51469,70,NULL,NULL,'2MASX J14065594+1024512',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'16.76',0.21,NULL,NULL,NULL,NULL,NULL,1,211.733,10.41417,0,NULL,58491172547,913924571,14280071,16.76),(117045,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117045,35.38,0.49,119,51470,75,NULL,'IR','UGC 09039',NULL,'2011yCatp016004901K',2011,1,1.68,NULL,'G',0.000027,NULL,'15.32',0.17,'Sc',NULL,NULL,NULL,NULL,1,211.735833,72.12247,0.025,NULL,57896409431,904631397,14134865,15.32),(117046,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117046,35.57,NULL,130,51470,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09039',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117047,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117047,35.58,NULL,131,51470,NULL,NULL,'Dipole + Quadrupole','UGC 09039',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117048,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117048,35.59,NULL,131,51470,NULL,NULL,'Dipole','UGC 09039',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117049,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117049,35.6,NULL,132,51470,NULL,NULL,NULL,'UGC 09039',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117050,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117050,35.97,0.44,156,51470,NULL,NULL,'Malmquist cor.','UGC 09039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117051,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117051,36.4,0.36,191,51470,NULL,NULL,NULL,'UGC 09039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117052,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117052,36.44,0.2,194,51470,74.4,NULL,NULL,'UGC 09039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117053,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117053,36.22,0.46,176,51471,70,NULL,NULL,'2MASX J14065656+0100442',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000072,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,211.735833,1.01211,0.089,NULL,58404759464,912574366,14258974,17.1),(117054,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117054,38.17,0.46,430,51472,70,NULL,NULL,'2MASX J14065723+1014032',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000117,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,211.738458333,10.23442,0,NULL,58508932392,914202068,14284407,16.8),(117055,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117055,35.06,0.57,103,51473,70,NULL,NULL,'2MASX J14065741-2155309',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.49',NULL,NULL,NULL,NULL,NULL,NULL,1,211.739333333,-21.92544,0.213,NULL,46519401791,726865652,11357275,15.49),(117056,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117056,37.07,0.2,259,51474,74.4,NULL,NULL,'UGC 09025',NULL,'2013AJ....146...86T',2013,1,0.92,NULL,'G',0.000033,NULL,'15.4g',0.56,'SAB(s)bc',NULL,NULL,NULL,NULL,1,211.7455417,12.56078,0,NULL,58363239812,911925622,14248837,15.4),(117057,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117057,37.37,0.46,297,51475,70,NULL,NULL,'2MASX J14065950+1247387',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,211.748,12.79406,0,NULL,58363331207,911927050,14248860,17.1),(117058,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117058,37.58,0.46,328,51476,70,NULL,NULL,'2MASX J14070092+0649382',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,211.7537083,6.82733,0.024,NULL,58515962056,914311907,14286123,17.6),(117059,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117059,37.96,0.46,391,51477,70,NULL,NULL,'2MASX J14070180+1845271',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,211.7575,18.75764,0.02,NULL,59462760137,929105627,14517275,18),(117060,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117060,37.37,0.33,297,51478,70,NULL,NULL,'2MASX J14070301+4008376',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000156,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,211.762375,40.14378,0,NULL,59257841680,925903776,14467246,16.9),(117061,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117061,37.58,0.46,328,51479,70,NULL,NULL,'2MASX J14070343+4127426',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000168,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,211.76425,41.46183,0,NULL,59258742273,925917848,14467466,16.9),(117062,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117062,37.87,0.46,376,51480,70,NULL,NULL,'SDSS J140703.65+232224.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.7652083,23.37344,0,NULL,59472860863,929263450,14519741,18.4),(117063,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117063,37.08,0.33,261,51481,70,NULL,NULL,'2MASX J14070369+0812502',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,211.76525,8.214,0.02,NULL,58517951110,914342986,14286609,17.4),(117064,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117064,37.18,0.46,272,51482,70,NULL,NULL,'2MASX J14070372+3200401',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'18.06',0.15,NULL,NULL,NULL,NULL,NULL,1,211.765375,32.01122,0,NULL,60050613692,938290838,14660794,18.06),(117065,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117065,34.82,0.8,92,51483,75,NULL,'HMCL, I','UGC 09027',NULL,'1997ApJS..109..333W',1997,1,1.19,NULL,'G',0.000033,NULL,'15.8g',0.24,'S?',NULL,NULL,NULL,NULL,1,211.76675,10.64294,0,NULL,58491189657,913924838,14280075,15.8),(117066,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117066,35.02,0.49,101,51483,75,NULL,'IR','UGC 09027',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117067,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117067,35.03,0.43,101,51483,NULL,NULL,'Malmquist cor.','UGC 09027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117068,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117068,35.1,0.4,105,51483,75,NULL,'HMCL, I, raw','UGC 09027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117069,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117069,35.18,0.4,109,51483,75,NULL,'HMCL, I, inv','UGC 09027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117070,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117070,35.2,0.4,110,51483,75,NULL,'HMCL, I, cor','UGC 09027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117071,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117071,35.25,0.39,112,51483,NULL,NULL,NULL,'UGC 09027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117072,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117072,35.29,0.2,114,51483,74.4,NULL,NULL,'UGC 09027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117073,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117073,38.37,0.33,472,51484,70,NULL,NULL,'2MASX J14070400+3600296',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000053,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,211.7667083,36.00819,0,NULL,60029941326,937967833,14655747,18.4),(117074,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117074,32.65,0.8,33.8,51485,75,NULL,'HMCL, I','NGC 5464',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000022,NULL,'13.33',0.8,'IB(s)m?        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,211.768333,-30.01711,0.229,NULL,47037328038,734958250,11483722,13.33),(117075,'Tully est','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117075,32.87,0.8,37.5,51485,75,NULL,'B','NGC 5464',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117076,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117076,32.13,0.4,26.7,51485,NULL,NULL,NULL,'NGC 5464',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117077,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117077,32.6,0.4,33.2,51485,75,NULL,'HMCL, I, raw','NGC 5464',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117078,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117078,32.67,0.4,34.2,51485,75,NULL,'HMCL, I, inv','NGC 5464',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117079,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117079,32.85,0.4,37.2,51485,75,NULL,'HMCL, I, cor','NGC 5464',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117080,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117080,36.33,0.46,184,51486,70,NULL,NULL,'2MASX J14070780+2437101',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000144,NULL,'17.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,211.782625,24.61958,0,NULL,59468042226,929188159,14518564,17.9),(117081,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117081,36.12,0.62,168,51487,70,NULL,NULL,'2MASX J14070813-1231015',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,211.78425,-12.51728,0.157,NULL,43645189822,681956090,10655563,15.8),(117082,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117082,38.53,0.46,508,51488,70,NULL,NULL,'SDSS J140708.82+502453.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000148,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,211.7867917,50.41475,0,NULL,59250199715,925784370,14465380,18.3),(117083,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117083,36.73,0.23,222,51489,70,NULL,NULL,'IC 0975',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00011,NULL,'15.6',0.27,NULL,NULL,NULL,NULL,NULL,1,211.786833,15.31808,0,NULL,58356847727,911825745,14247277,15.6),(117084,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117084,38.12,0.46,420,51490,70,NULL,NULL,'2MASX J14070917+5356584',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,211.788333,53.94969,0,NULL,59215244654,925238197,14456846,18.1),(117085,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117085,37.76,0.14,356,51491,70,NULL,NULL,'2MASX J14070976+0520132',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,'FoF','17.90',0.19,NULL,NULL,NULL,NULL,NULL,1,211.790708333,5.33694,0.029,NULL,58479945661,913749150,14277330,17.9),(117086,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117086,37.22,0.33,278,51492,70,NULL,NULL,'2MASX J14070983+2618481',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000205,NULL,'16.0g',0.4,NULL,NULL,NULL,NULL,NULL,1,211.790917,26.31344,0,NULL,60010322302,937661285,14650957,16),(117087,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117087,38.23,0.27,442,51493,70,NULL,NULL,'2MASX J14071031+0820297',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000138,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,211.7929583,8.34164,0.02,NULL,58517947155,914342924,14286608,18.4),(117088,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117088,26.39,NULL,1.9,51494,NULL,NULL,NULL,'KKR 03',NULL,'2004AJ....127.2031K',2004,1,0.6,NULL,'G',0.000001,NULL,'17.90',0.5,'dwarf Irr',NULL,NULL,NULL,NULL,1,211.793833333,35.06036,0,1,60035369656,938052650,14657072,17.9),(117089,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117089,26.42,NULL,1.92,51494,NULL,NULL,NULL,'KKR 03',NULL,'2006AJ....131.1361K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117090,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117090,26.47,0.1,1.97,51494,NULL,NULL,NULL,'KKR 03',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117091,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117091,26.47,0.06,1.97,51494,NULL,NULL,'I','KKR 03',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117092,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117092,26.48,0.18,1.98,51494,NULL,NULL,NULL,'KKR 03',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117093,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117093,26.55,0.27,2.04,51494,NULL,NULL,NULL,'KKR 03',NULL,'2013AstBu..68..125M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117094,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117094,26.64,0.08,2.12,51494,74.4,NULL,NULL,'KKR 03',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117095,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117095,26.65,0.08,2.14,51494,NULL,NULL,NULL,'KKR 03',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117096,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117096,26.7,0.12,2.19,51494,NULL,NULL,'I','KKR 03',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117097,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117097,37.59,0.27,330,51495,70,NULL,NULL,'2MASX J14071082+2948071',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.11',0.17,NULL,NULL,NULL,NULL,NULL,1,211.7949583,29.80197,0,NULL,60051522396,938305037,14661016,18.11),(117098,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117098,36.73,0.23,222,51496,70,NULL,NULL,'2MASX J14071096+1516057',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,211.795667,15.26831,0,NULL,58356799472,911824991,14247265,17.7),(117099,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117099,36.79,0.19,228,51497,70,NULL,NULL,'2MASX J14071109-0052429',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000087,NULL,'16.1g',0.41,'E0',NULL,NULL,NULL,NULL,1,211.796291667,-0.87864,0.137,NULL,43591211441,681112678,10642385,16.1),(117100,'SBF','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117100,32.07,0.34,25.9,51498,NULL,NULL,'I','NGC 5485',NULL,'2001ApJ...546..681T',2001,1,2.13,NULL,'G',0.000017,NULL,'12.4g',1.51,'SA0 pec','in a radial-velocity based grouping',NULL,NULL,NULL,1,211.7972917,55.00169,0,NULL,57299227918,895300436,13989069,12.4),(117101,'SBF','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117101,32.07,0.34,25.9,51498,NULL,NULL,NULL,'NGC 5485',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117102,'SBF','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117102,32.13,0.14,26.7,51498,74.4,NULL,NULL,'NGC 5485',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117103,'SBF','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117103,32.3,0.34,28.8,51498,NULL,NULL,'Malmquist cor.','NGC 5485',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117104,'D-Sigma','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117104,31.99,0.4,25,51498,75,NULL,'Edat, raw','NGC 5485',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117105,'D-Sigma','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117105,32.32,0.4,29.2,51498,75,NULL,'Edat, cor','NGC 5485',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117106,'Faber-Jackson','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117106,31.64,0.65,21.3,51498,95,NULL,'Weighted Mean','NGC 5485',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117107,'Faber-Jackson','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117107,33.01,0.81,40,51498,55,NULL,'Visvanathan & Sandage 1979','NGC 5485',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117108,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117108,31.93,0.41,24.3,51498,NULL,NULL,NULL,'NGC 5485',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117109,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117109,32.23,0.41,28,51498,NULL,NULL,'Malmquist cor.','NGC 5485',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117110,'Tertiary','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117110,31.87,0.29,23.7,51498,95,NULL,NULL,'NGC 5485',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117111,'Tully est','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117111,32.58,0.8,32.8,51498,75,NULL,'B','NGC 5485',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117112,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117112,32.35,0.4,29.5,51498,NULL,NULL,'mean','NGC 5485',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117113,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117113,32.39,0.45,30,51498,NULL,NULL,'K','NGC 5485',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117114,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117114,37.76,0.14,356,51499,70,NULL,NULL,'2MASX J14071183+0515522',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000078,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,211.7992917,5.26439,0.037,NULL,58479678771,913744980,14277265,17.1),(117115,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117115,38.01,0.46,400,51500,70,NULL,NULL,'SDSS J140711.94+003112.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000073,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,211.79975,0.52019,0.097,NULL,58403974276,912562098,14258782,17.8),(117116,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117116,37.37,0.33,297,51501,70,NULL,NULL,'2MASX J14071296+4001556',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000198,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,211.803875,40.03203,0,NULL,59257832753,925903636,14467244,16.4),(117117,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117117,38.23,0.27,442,51502,70,NULL,NULL,'2MASX J14071449+0822177',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,'PHOT','18.34',0.14,'BrClG',NULL,NULL,NULL,NULL,1,211.8104583,8.37161,0.02,NULL,58517488215,914335753,14286496,18.34),(117118,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117118,37.35,0.46,295,51503,70,NULL,NULL,'2MASX J14071462+4905373',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00018,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,211.811125,49.09361,0.057,NULL,59256227980,925878562,14466852,16.6),(117119,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117119,38.08,0.46,413,51504,70,NULL,NULL,'2MASX J14071483+4331480',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,211.811916667,43.53003,0,NULL,59238158323,925596223,14462440,17.7),(117120,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:34','1','PS1 SN PS10jl','N',117120,42.05,0.22,1680,51505,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10jl HOST',0.5304,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117121,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117121,36.85,0.46,234,51506,70,NULL,NULL,'2MASX J14071502+1248567',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000172,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,211.8125417,12.81569,0,NULL,58363346321,911927286,14248863,16.5),(117122,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117122,37.08,0.33,261,51507,70,NULL,NULL,'2MASX J14071538+0801107',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,211.814125,8.01969,0.01,NULL,58517969574,914343274,14286613,17.5),(117123,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117123,34.71,0.25,87.5,51508,74.4,NULL,NULL,'ESO 510- G 066',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000017,NULL,'14.15',1,'SA(rs)0-',NULL,NULL,NULL,NULL,1,211.815333,-27.158,0.193,NULL,46989302747,734207855,11471997,14.15),(117124,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117124,35.17,0.4,108,51508,NULL,NULL,'mean','ESO 510- G 066',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117125,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117125,35.27,0.45,113,51508,NULL,NULL,'K','ESO 510- G 066',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117126,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117126,38.39,0.23,477,51509,70,NULL,NULL,'SDSS J140716.57+073206.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000152,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,211.8190417,7.53511,0.011,NULL,58516165957,914315093,14286173,18.6),(117127,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117127,37.35,0.46,295,51510,70,NULL,NULL,'2MASX J14071740+2929587',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,211.822375,29.49967,0,NULL,60006268731,937597948,14649967,17.3),(117128,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117128,37.59,0.27,330,51511,70,NULL,NULL,'2MASX J14071761+2939157',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000163,NULL,'16.9g',0.32,'E',NULL,NULL,NULL,NULL,1,211.823375,29.65447,0,NULL,60006233620,937597400,14649959,16.9),(117129,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117129,38.23,0.27,442,51512,70,NULL,NULL,'2MASX J14071800+0822247',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,211.824958333,8.37356,0.02,NULL,58517490949,914335796,14286496,17.7),(117130,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117130,35.21,0.46,110,51513,70,NULL,NULL,'CGCG 074-113',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00017,NULL,'15.4g',0.5,'S0',NULL,NULL,NULL,NULL,1,211.826208333,12.88722,0,NULL,58363287390,911926365,14248849,15.4),(117131,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117131,37.11,0.46,264,51514,70,NULL,NULL,'2MASX J14071870+2517317',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000185,NULL,'17.35',0.21,NULL,NULL,NULL,NULL,NULL,1,211.827917,25.29217,0,NULL,60002494263,937538972,14649046,17.35),(117132,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117132,37.86,0.46,373,51515,70,NULL,NULL,'2MASX J14071890+0711457',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000205,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,211.828833,7.19606,0,NULL,58516798354,914324974,14286327,16.9),(117133,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117133,34.51,0.48,79.8,51516,70,NULL,NULL,'ESO 446- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.00008,NULL,'15.5',0.4,'Sa-b',NULL,NULL,NULL,NULL,1,211.833917,-28.96981,0.153,NULL,46982432837,734100513,11470320,15.5),(117134,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117134,35.07,0.25,103,51517,74.4,NULL,NULL,'2MASX J14072087-2700403',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000022,NULL,'14.6',NULL,'E',NULL,NULL,NULL,NULL,1,211.8369583,-27.01131,0.177,NULL,46989288999,734207640,11471994,14.6),(117135,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117135,37.59,0.27,330,51518,70,NULL,NULL,'2MASX J14072167+2938397',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00012,NULL,'16.6g',0.33,'E',NULL,NULL,NULL,NULL,1,211.8402083,29.64425,0,NULL,60006229265,937597332,14649958,16.6),(117136,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117136,38.01,0.46,400,51519,70,NULL,NULL,'2MASX J14072403+0239092',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000092,NULL,'17.7g',0.2,'NLAGN',NULL,NULL,NULL,NULL,1,211.850041667,2.65264,0.057,NULL,58470930554,913608289,14275129,17.7),(117137,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117137,37.5,0.46,316,51520,70,NULL,NULL,'SDSS J140724.72+541059.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00014,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,211.8530417,54.18322,0,NULL,57281634748,895025542,13984774,18.1),(117138,'IRAS','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117138,31.95,0.8,24.5,51521,75,NULL,'A82, H','NGC 5486',NULL,'1997ApJS..109..333W',1997,1,1.68,NULL,'G',0.000017,NULL,'14.0g',0.95,'SA(s)m:','in a pair',NULL,NULL,NULL,1,211.854,55.10308,0,NULL,57298721786,895292527,13988945,14),(117139,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117139,32.04,0.4,25.6,51521,75,NULL,'B','NGC 5486',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117140,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117140,32.96,0.47,39.1,51521,75,NULL,'A82, H, inv','NGC 5486',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117141,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117141,33,0.47,39.8,51521,75,NULL,'A82, H, raw','NGC 5486',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117142,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117142,33.13,0.47,42.2,51521,75,NULL,'A82, H, cor','NGC 5486',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117143,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:34','1','PS1 SN PS10ig','N',117143,40.66,0.15,1070,51522,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10ig HOST',0.2604,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117144,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117144,36.64,0.46,213,51523,70,NULL,NULL,'2MASX J14072768+1619272',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.10',0.17,NULL,NULL,NULL,NULL,NULL,1,211.865417,16.32439,0,NULL,58359107123,911861048,14247828,18.1),(117145,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117145,34.85,0.21,93.5,51524,70,NULL,NULL,'ABELL 3581',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I      [BM];RI [A]',NULL,NULL,NULL,NULL,1,211.867083,-27.01528,0.177,NULL,46989287878,734207623,11471994,NULL),(117146,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117146,35.17,0.46,108,51525,70,NULL,NULL,'2MASX J14072916+2408408',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000164,NULL,'15.6g',0.46,NULL,NULL,NULL,NULL,NULL,1,211.8714583,24.14458,0,NULL,59467983577,929187243,14518550,15.6),(117147,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117147,35.12,0.25,106,51526,74.4,NULL,NULL,'IC 4374',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.000025,NULL,'13.59',1.2,'SA(rs)0-:;BrClG','Brightest group member',NULL,NULL,'Flat-Spectrum Radio Source',1,211.874,-27.01786,0.177,NULL,46989288349,734207630,11471994,13.59),(117148,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117148,34.82,0.4,92.1,51526,NULL,NULL,'mean','IC 4374',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117149,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117149,34.83,0.45,92.4,51526,NULL,NULL,'K','IC 4374',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117150,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117150,34.85,0.21,93.5,51526,70,NULL,'ABELL 3581, BGC','IC 4374',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117151,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117151,38.65,0.46,538,51527,70,NULL,NULL,'2MASX J14073123+4017552',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000191,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,211.880333333,40.29864,0,NULL,59257928693,925905135,14467267,17.5),(117152,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:34','1','SN 2008cf','R',117152,36.33,0.07,185,51528,NULL,NULL,'MLCS2k2, R(V) = 1.8','[WLF2008] J140732.38-263305.6',NULL,'2015Sci...347.1459K',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,211.884916667,-26.55156,0.165,NULL,46992459625,734257181,11472768,NULL),(117153,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:34','1','SN 2008cf','R',117153,36.38,0.07,189,51528,NULL,NULL,'MLCS2k2, R(V) = 3.1','[WLF2008] J140732.38-263305.6',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117154,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:34','1','SN 2008cf',NULL,117154,36.72,0.22,211,51528,73.8,NULL,'SALT 2 (SNANA)','[WLF2008] J140732.38-263305.6',0.0472,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117155,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117155,37.57,0.46,326,51529,70,NULL,NULL,'2MASX J14073295+0741157',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,211.8872083,7.68769,0.011,NULL,58518044085,914344438,14286631,17.6),(117156,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117156,36.95,0.46,245,51530,70,NULL,NULL,'2MASX J14073311+2924128',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000145,NULL,'17.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,211.8879583,29.40361,0,NULL,60006215080,937597110,14649954,17.4),(117157,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117157,35.4,0.33,120,51531,70,NULL,NULL,'CGCG 046-053',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.00018,NULL,'15.6g',0.46,NULL,NULL,NULL,NULL,NULL,1,211.889625,7.17786,0,NULL,58516785530,914324773,14286324,15.6),(117158,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117158,38.39,0.23,477,51532,70,NULL,NULL,'2MASX J14073436+0726287',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.89',0.17,NULL,NULL,NULL,NULL,NULL,1,211.893041667,7.44122,0.011,NULL,58516162889,914315045,14286172,17.89),(117159,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117159,37.28,0.46,286,51533,70,NULL,NULL,'2MASX J14073437+0601522',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,211.893083,6.03117,0.034,NULL,58479144311,913736629,14277134,16.9),(117160,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117160,38.39,0.23,477,51534,70,NULL,NULL,'SDSS J140734.69+072621.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000163,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,211.894541667,7.43942,0.011,NULL,58516162932,914315045,14286172,18.7),(117161,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117161,34.86,0.49,93.7,51535,75,NULL,'IR','UGC 09030',NULL,'2011yCatp016004901K',2011,1,1.19,NULL,'G',0.000014,NULL,'15.6g',0.25,'Sbc',NULL,NULL,NULL,NULL,1,211.909375,9.67536,0,NULL,58509405805,914209465,14284522,15.6),(117162,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117162,35.37,0.2,119,51535,74.4,NULL,NULL,'UGC 09030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117163,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117163,35.59,NULL,131,51535,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09030',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117164,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117164,35.6,NULL,132,51535,NULL,NULL,'Dipole + Quadrupole','UGC 09030',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117165,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117165,35.62,NULL,133,51535,NULL,NULL,'Dipole','UGC 09030',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117166,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117166,35.63,NULL,134,51535,NULL,NULL,NULL,'UGC 09030',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117167,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117167,36.79,0.19,228,51536,70,NULL,NULL,'CGCG 018-053',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.00012,NULL,'15.2g',0.53,'BrClG',NULL,NULL,NULL,NULL,1,211.9119583,-0.95533,0.161,NULL,43591227247,681112925,10642389,15.2),(117168,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117168,36.5,0.46,200,51537,70,NULL,NULL,'2MASX J14073933+2431428',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000173,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,211.914125,24.52869,0,NULL,59468073401,929188646,14518572,16.5),(117169,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117169,36.41,0.49,191,51538,75,NULL,'IR','UGC 09031',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.001182,NULL,'15.62',0.2,'S?',NULL,NULL,NULL,NULL,1,211.914,14.86447,0,NULL,58364628977,911947327,14249176,15.62),(117170,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117170,37.21,0.46,277,51539,70,NULL,NULL,'2MASX J14073971+0732181',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000146,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,211.915625,7.53822,0.011,NULL,58516160188,914315002,14286171,17.1),(117171,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117171,35.57,0.47,130,51540,70,NULL,NULL,'ESO 384- G 055',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00015,NULL,'14.08',0.9,'E+3 pec',NULL,NULL,NULL,NULL,1,211.919125,-37.28597,0.285,NULL,46877313918,732458029,11444656,14.08),(117172,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117172,36.27,0.46,179,51541,70,NULL,NULL,'VIII Zw 367 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000172,NULL,'17.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,211.921083333,9.80997,0,NULL,58509424165,914209752,14284527,17),(117173,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117173,36.22,0.46,176,51542,70,NULL,NULL,'2MASX J14074110+3840073',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000182,NULL,'16.1g',0.36,'S0/a',NULL,NULL,NULL,NULL,1,211.921125,38.66878,0,NULL,59140017597,924062774,14438480,16.1),(117174,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117174,37.28,0.46,285,51543,70,NULL,NULL,'2MASX J14074183+2801528',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000173,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,211.924291667,28.03142,0,NULL,60008872580,937638634,14650603,16.7),(117175,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117175,33.91,NULL,60.4,51544,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 325- G 055',NULL,'2010Ap&SS.325..163P',2010,1,1.99,NULL,'G',0.000033,NULL,'15.72',0.22,'Sbc',NULL,NULL,NULL,NULL,1,211.92475,-38.16628,0.285,NULL,46879387348,732490427,11445162,15.72),(117176,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117176,33.92,NULL,60.7,51544,NULL,NULL,'Dipole','ESO 325- G 055',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117177,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117177,33.92,NULL,60.8,51544,NULL,NULL,'Dipole + Quadrupole','ESO 325- G 055',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117178,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117178,34.05,0.43,64.5,51544,75,NULL,'3.6 micron, color + selection bias corrected','ESO 325- G 055',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117179,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117179,34.27,0.49,71.5,51544,75,NULL,'IR','ESO 325- G 055',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117180,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117180,35.47,NULL,124,51545,NULL,NULL,'Dipole + Quadrupole + Octopole','FGCE 1129',NULL,'2010Ap&SS.325..163P',2010,1,0.93,NULL,'G',0.000023,NULL,'16.2',0.1,'Sbc',NULL,NULL,NULL,NULL,1,211.9279583,-27.43,0.201,NULL,46989217716,734206526,11471976,16.2),(117181,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117181,35.49,NULL,125,51545,NULL,NULL,'Dipole + Quadrupole','FGCE 1129',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117182,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117182,35.51,NULL,126,51545,NULL,NULL,'Dipole','FGCE 1129',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117183,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117183,36.14,0.42,169,51545,NULL,NULL,NULL,'FGCE 1129',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117184,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117184,36.19,0.2,173,51545,74.4,NULL,NULL,'FGCE 1129',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117185,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117185,36.2,0.41,174,51545,NULL,NULL,'Malmquist cor.','FGCE 1129',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117186,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117186,37.5,0.46,316,51546,70,NULL,NULL,'2MASX J14074323+0624571',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,211.93,6.41572,0.038,NULL,58515826962,914309796,14286090,17.3),(117187,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117187,38.39,0.23,477,51547,70,NULL,NULL,'SDSS J140743.24+073034.1',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000145,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,211.930167,7.5095,0.011,NULL,58516155455,914314928,14286170,17.8),(117188,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117188,38.34,0.46,466,51548,70,NULL,NULL,'2MASX J14074383+0636191',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000209,NULL,'17.0g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,211.932625,6.60536,0.033,NULL,58516044034,914313188,14286143,17),(117189,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117189,36.73,0.23,222,51549,70,NULL,NULL,'2MASX J14074401+1507513',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.00',0.19,NULL,NULL,NULL,NULL,NULL,1,211.9332917,15.13086,0,NULL,58364367977,911943249,14249113,18),(117190,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117190,35.4,0.33,120,51550,70,NULL,NULL,'CGCG 046-054',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000172,NULL,'15.1g',0.53,NULL,NULL,NULL,NULL,NULL,1,211.936125,7.216,0,NULL,58516209757,914315777,14286184,15.1),(117191,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117191,34.61,0.25,83.6,51551,74.4,NULL,NULL,'2MASX J14074475-2704573',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000014,NULL,'15.0b',NULL,'E','Group member, 2nd ranked galaxy',NULL,NULL,NULL,1,211.936208333,-27.08289,0.177,NULL,46989297938,734207780,11471996,15),(117192,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117192,37.77,0.46,358,51552,70,NULL,NULL,'2MASX J14074517+3220496',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,211.938208333,32.34717,0,NULL,60033399830,938021872,14656591,17.2),(117193,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117193,36.86,0.66,235,51553,70,NULL,NULL,'2MASX J14074600-4231266',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,211.941583333,-42.52411,0.245,NULL,46793578835,731149669,11424213,15.9),(117194,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117194,38.07,0.46,411,51554,70,NULL,NULL,'SDSS J140746.28-010052.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000074,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,211.942833,-1.01444,0.161,NULL,43591345802,681114778,10642418,18.1),(117195,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117195,37.36,0.46,297,51555,70,NULL,NULL,'2MASX J14074664+2854453',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,211.944375,28.91261,0,NULL,60005893100,937592079,14649876,17.6),(117196,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117196,38.22,0.46,440,51556,70,NULL,NULL,'SDSS J140747.22+002414.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00007,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,211.946791667,0.404,0.117,NULL,58403956108,912561814,14258778,18.4),(117197,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117197,36.79,0.19,228,51557,70,NULL,NULL,'2MASX J14074853-0055531',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000086,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,211.95225,-0.93133,0.161,NULL,43591254703,681113354,10642396,17.3),(117198,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117198,36.82,0.33,231,51558,70,NULL,NULL,'2MASX J14074875+4138113',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,211.953167,41.63664,0,NULL,59258732382,925917693,14467463,17.2),(117199,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117199,37.62,0.23,335,51559,70,NULL,NULL,'2MASX J14074883+5241222',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000158,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,211.9535417,52.68944,0,NULL,59249672387,925776131,14465252,17.1),(117200,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117200,37.76,0.14,356,51560,70,NULL,NULL,'2MASX J14074913+0508110',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000072,NULL,'16.7g',0.35,'AGN',NULL,NULL,NULL,NULL,1,211.9547083,5.13633,0.029,NULL,58481586238,913774784,14277731,16.7),(117201,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117201,37.57,0.46,327,51561,70,NULL,NULL,'2MASX J14074968+2419443',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000181,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,211.957041667,24.32906,0,NULL,59468089184,929188893,14518576,17.4),(117202,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117202,36.29,0.33,181,51562,70,NULL,NULL,'2MASX J14075000+5808043',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000188,NULL,'15.9g',0.36,'E0',NULL,NULL,NULL,NULL,1,211.958416667,58.13464,0,NULL,57304059404,895375928,13990248,15.9),(117203,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117203,38.7,0.46,549,51563,70,NULL,NULL,'SDSS J140750.68+025328.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000078,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,211.961208333,2.89131,0.053,NULL,58470850091,913607032,14275109,18.7),(117204,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117204,37.76,0.14,356,51564,70,NULL,NULL,'2MASX J14075133+0524580',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000084,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,211.963833,5.41617,0.033,NULL,58481255690,913769620,14277650,17.5),(117205,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117205,37.49,0.46,315,51565,70,NULL,NULL,'VIII Zw 366',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000073,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,211.964125,0.74939,0.089,NULL,58405064876,912579138,14259049,17.4),(117206,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117206,37.63,0.46,336,51566,70,NULL,NULL,'2MASX J14075244+3705193',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000143,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,211.968666667,37.08878,0,NULL,59142214634,924097103,14439017,17.6),(117207,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117207,36.82,0.33,231,51567,70,NULL,NULL,'2MASX J14075285+4138213',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'15.79',0.33,NULL,NULL,NULL,NULL,NULL,1,211.97025,41.63919,0,NULL,59258732098,925917689,14467463,15.79),(117208,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117208,37.04,0.33,256,51568,70,NULL,NULL,'2MASX J14075333-0019281',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000086,NULL,'16.0g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,211.97225,-0.32436,0.133,NULL,43589009139,681078267,10641847,16),(117209,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117209,38.53,0.33,509,51569,70,NULL,NULL,'2MASX J14075353+1911434',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.54',0.17,NULL,NULL,NULL,NULL,NULL,1,211.973166667,19.19547,0.027,NULL,59463050889,929110170,14517346,18.54),(117210,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117210,37.88,0.46,376,51570,70,NULL,NULL,'2MASX J14075427+1058591',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000188,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,211.976083,10.98303,0,NULL,58493324095,913958188,14280596,16.8),(117211,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117211,36.13,0.46,168,51571,70,NULL,NULL,'2MASX J14075480+5530136',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000185,NULL,'15.9g',0.3,'S0/a',NULL,NULL,NULL,NULL,1,211.978167,55.50386,0.005,NULL,57302139086,895345923,13989780,15.9),(117212,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117212,33.53,0.25,50.8,51572,74.4,NULL,NULL,'ABELL S0753:[WFC91] 103',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000057,NULL,'15.73',0.4,'S0',NULL,NULL,NULL,NULL,1,211.9805,-34.30269,0.197,NULL,47003260871,734425951,11475405,15.73),(117213,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117213,35.34,0.53,117,51573,NULL,NULL,'Malmquist cor.','ESO 510- G 072',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.00003,NULL,'15.09',0.6,'SB(r)cd',NULL,NULL,NULL,NULL,1,211.982208333,-26.76719,0.177,NULL,46989060289,734204067,11471938,15.09),(117214,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117214,35.45,0.5,123,51573,NULL,NULL,NULL,'ESO 510- G 072',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117215,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117215,35.49,0.2,125,51573,74.4,NULL,NULL,'ESO 510- G 072',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117216,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117216,36.81,0.46,230,51574,70,NULL,NULL,'VIII Zw 367 NOTES03',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.91',0.18,NULL,NULL,NULL,NULL,NULL,1,211.982875,9.83111,0,NULL,58509373601,914208962,14284515,17.91),(117217,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117217,36.74,0.46,223,51575,70,NULL,NULL,'2MASX J14075761+0810571',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.0001,NULL,'16.81',0.25,NULL,NULL,NULL,NULL,NULL,1,211.99,8.18264,0,NULL,58517514660,914336166,14286502,16.81),(117218,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117218,37.96,0.46,391,51576,70,NULL,NULL,'SDSS J140758.15+320529.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.9922917,32.09142,0,NULL,60050433352,938288021,14660750,18.5),(117219,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117219,33.25,0.5,44.7,51577,70,NULL,NULL,'ESO 446- G 017',NULL,'2014MNRAS.445.2677S',2014,1,1.9,'Marginal HIPASS detection.','G',0.000013,NULL,'13.54',1.3,'(R)SB(rs)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,211.996166667,-32.05133,0.285,NULL,47035251057,734925797,11483215,13.54),(117220,'IRAS','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117220,33.76,0.8,56.4,51577,75,NULL,'HMCL, I','ESO 446- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117221,'IRAS','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117221,33.76,0.8,56.5,51577,75,NULL,'MAT, I','ESO 446- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117222,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117222,32.46,0.57,31.1,51577,NULL,NULL,NULL,'ESO 446- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117223,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117223,32.48,0.32,31.4,51577,85,NULL,'I, raw','ESO 446- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117224,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117224,32.52,0.32,31.9,51577,85,NULL,'I, inv','ESO 446- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117225,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117225,32.61,0.53,33.2,51577,NULL,NULL,'Malmquist cor.','ESO 446- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117226,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117226,32.64,0.2,33.7,51577,74.4,NULL,NULL,'ESO 446- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117227,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117227,32.66,0.43,34,51577,75,NULL,'MAT, I, raw','ESO 446- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117228,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117228,32.78,0.4,36.1,51577,75,NULL,'HMCL, I, raw','ESO 446- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117229,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117229,32.84,0.43,36.9,51577,75,NULL,'MAT, I, inv','ESO 446- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117230,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117230,32.94,0.4,38.7,51577,75,NULL,'HMCL, I, inv','ESO 446- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117231,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117231,32.98,0.43,39.4,51577,75,NULL,'MAT, I, cor','ESO 446- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117232,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117232,33.07,0.4,41.2,51577,75,NULL,'HMCL, I, cor','ESO 446- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117233,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117233,33.12,0.47,42.1,51577,NULL,NULL,'H','ESO 446- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117234,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117234,33.19,0.69,43.4,51577,100,NULL,'mid-IR','ESO 446- G 017',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117235,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117235,33.19,0.45,43.4,51577,NULL,NULL,'K','ESO 446- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117236,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117236,33.19,0.46,43.5,51577,NULL,NULL,'J','ESO 446- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117237,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117237,33.78,0.4,57.1,51577,NULL,NULL,'mean','ESO 446- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117238,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117238,36.33,0.64,185,51578,70,NULL,NULL,'2MASX J14075970-0900353',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,211.998875,-9.00978,0.049,NULL,43752692244,683635816,10681809,16.7),(117239,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117239,36.79,0.19,228,51579,70,NULL,NULL,'VIII Zw 368',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000099,NULL,'16.0g',0.41,'E0',NULL,NULL,NULL,NULL,1,212.002166667,-0.82181,0.133,NULL,43591253320,681113333,10642395,16),(117240,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117240,37.04,0.33,256,51580,70,NULL,NULL,'2MASX J14080159-0013321',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000085,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,212.006583333,-0.22561,0.133,NULL,43588997571,681078087,10641845,18.1),(117241,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117241,38.78,0.46,570,51581,70,NULL,NULL,'SDSS J140802.02+351507.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00014,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.008458333,35.25214,0,NULL,60035325751,938051964,14657061,18.2),(117242,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117242,33.68,0.47,54.4,51582,70,NULL,NULL,'NGC 5488',NULL,'2014MNRAS.445.2677S',2014,1,3.4,NULL,'G',0.000097,NULL,'12.72',1,'SABbc?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,212.0129583,-33.31492,0.205,NULL,47005523318,734461301,11475957,12.72),(117243,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117243,37.39,0.33,300,51583,70,NULL,NULL,'2MASX J14080330+0657481',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,212.0135417,6.96336,0.028,NULL,58516763606,914324431,14286319,17.6),(117244,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117244,37.58,0.46,328,51584,70,NULL,NULL,'2MASX J14080346+3120103',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.15',0.17,NULL,NULL,NULL,NULL,NULL,1,212.014375,31.33614,0,NULL,60053336928,938333389,14661459,18.15),(117245,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117245,38.21,0.46,438,51585,70,NULL,NULL,'2MASX J14080415+4548401',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000143,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,212.017291667,45.81106,0,NULL,59234675861,925541810,14461590,17.7),(117246,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117246,36.44,0.24,194,51586,70,NULL,NULL,'GIN 342',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.00007,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,212.017458333,-9.15242,0.085,NULL,43747718148,683558096,10680595,16.3),(117247,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117247,37.94,0.27,387,51587,70,NULL,NULL,'2MASX J14080477+1021387',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.67',0.13,NULL,NULL,NULL,NULL,NULL,1,212.019833333,10.36072,0,NULL,58491351512,913927367,14280115,18.67),(117248,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117248,37.76,0.14,356,51588,70,NULL,NULL,'2MASX J14080526+0525030',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.00009,NULL,'16.0g',0.33,'cD;BrClG',NULL,NULL,NULL,NULL,1,212.0220417,5.41756,0.033,NULL,58481307669,913770432,14277663,16),(117249,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117249,36.85,0.46,234,51589,70,NULL,NULL,'VIII Zw 369',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000078,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,212.024625,0.74928,0.089,NULL,58405067006,912579171,14259049,16.8),(117250,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117250,36.44,0.24,194,51590,70,NULL,NULL,'GIN 338',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.00009,NULL,'14.75',NULL,'E/S0',NULL,NULL,NULL,NULL,1,212.025833,-9.07819,0.049,NULL,43751978319,683624661,10681635,14.75),(117251,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117251,37.02,0.6,253,51591,70,NULL,NULL,'2MASX J14080637-4239516',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,212.0265,-42.66433,0.265,NULL,46793693784,731151465,11424241,15.6),(117252,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117252,37.4,0.46,301,51592,70,NULL,NULL,'2MASX J14080644+4957521',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,212.026875,49.9645,0.051,NULL,59254730424,925855162,14466486,17.2),(117253,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117253,36.21,0.25,175,51593,74.4,NULL,NULL,'MCG -01-36-010',NULL,'2013AJ....146...86T',2013,1,0.2,NULL,'G',0.000077,NULL,'13.38',0.2,'cD;E/S0',NULL,NULL,NULL,NULL,1,212.0285,-9.07169,0.049,NULL,43751978758,683624668,10681635,13.38),(117254,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117254,36.44,0.24,194,51593,70,NULL,NULL,'MCG -01-36-010',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117255,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117255,36.44,0.24,194,51594,70,NULL,NULL,'GIN 337',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.000063,NULL,'14.86',NULL,'E/S0',NULL,NULL,NULL,NULL,1,212.030958333,-9.06169,0.049,NULL,43751978703,683624667,10681635,14.86),(117256,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117256,34.78,0.64,90.3,51595,NULL,NULL,NULL,'2MASX J14080804-2712260',NULL,'2009ApJS..182..474S',2009,1,0.42,NULL,'G',0.000023,NULL,'16.0',NULL,'Sc',NULL,NULL,NULL,NULL,1,212.033583,-27.20728,0.177,NULL,46989271858,734207372,11471990,16),(117257,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117257,34.8,0.64,91.3,51595,NULL,NULL,'Malmquist cor.','2MASX J14080804-2712260',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117258,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117258,34.82,0.2,92,51595,74.4,NULL,NULL,'2MASX J14080804-2712260',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117259,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117259,36.37,0.46,188,51596,70,NULL,NULL,'MCG +10-20-075',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000183,NULL,'15.7g',0.45,'E0',NULL,NULL,NULL,NULL,1,212.034833333,60.335,0.041,NULL,57270523489,894851929,13982061,15.7),(117260,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117260,37.62,0.23,335,51597,70,NULL,NULL,'2MASX J14081050+5240481',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000188,NULL,'15.9g',0.44,'AGN',NULL,NULL,NULL,NULL,1,212.043583,52.68006,0,NULL,59249738040,925777156,14465268,15.9),(117261,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117261,37.55,0.46,324,51598,70,NULL,NULL,'2MASX J14081285+4059228',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000175,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,212.0534583,40.98964,0,NULL,59260831628,925950494,14467976,16.7),(117262,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117262,38.2,0.46,437,51599,70,NULL,NULL,'LCRS B140537.6-024515',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.0545417,-2.99061,0.105,NULL,43722551226,683164862,10674450,17.9),(117263,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117263,36.39,0.46,190,51600,70,NULL,NULL,'CGCG 272-033',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000204,NULL,'15.1g',0.58,'E0',NULL,NULL,NULL,NULL,1,212.057375,53.88347,0,NULL,59248744876,925761638,14465025,15.1),(117264,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117264,37.76,0.14,356,51601,70,NULL,NULL,'SDSS J140814.57+052508.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000074,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.0607083,5.41917,0.033,NULL,58481311238,913770488,14277663,18.1),(117265,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117265,38.22,0.46,441,51602,70,NULL,NULL,'2MASX J14081459+1751288',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,212.0607083,17.85803,0,NULL,59483853320,929435208,14522425,18.2),(117266,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117266,34.43,0.5,76.9,51603,70,NULL,NULL,'ESO 578- G 025',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.00015,NULL,'15.05',0.4,'Sa:',NULL,NULL,NULL,NULL,1,212.0647083,-20.00544,0.229,NULL,46518478158,726851221,11357050,15.05),(117267,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117267,33.54,0.5,51,51604,70,NULL,NULL,'2MASX J14081669-3256366',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000103,NULL,'15.1b',0.8,'E',NULL,NULL,NULL,NULL,1,212.069625,-32.94353,0.257,NULL,47004986934,734452920,11475826,15.1),(117268,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117268,37.94,0.27,387,51605,70,NULL,NULL,'2MASX J14081785+1023357',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,212.074333,10.39336,0,NULL,58491344940,913927264,14280113,17.5),(117269,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117269,37.67,0.46,342,51606,70,NULL,NULL,'2MASX J14081791+6237228',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'16.7g',0.27,'AGN',NULL,NULL,NULL,NULL,1,212.0747917,62.62308,0.037,NULL,57751311364,902364240,14099441,16.7),(117270,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117270,37.58,0.33,328,51607,70,NULL,NULL,'2MASX J14081814+2321003',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.37',0.16,NULL,NULL,NULL,NULL,NULL,1,212.0754583,23.35008,0,NULL,59472641110,929260017,14519687,18.37),(117271,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117271,38.09,0.46,414,51608,70,NULL,NULL,'2MASX J14081875+0726457',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,212.078125,7.44603,0.014,NULL,58516286859,914316982,14286202,17.6),(117272,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117272,36.79,0.19,228,51609,70,NULL,NULL,'2MASX J14081925-0038540',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00008,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,212.08025,-0.64828,0.133,NULL,43590965921,681108842,10642325,17.7),(117273,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117273,38.46,0.46,492,51610,70,NULL,NULL,'2MASX J14081975+5705338',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.0822917,57.09283,0,NULL,57307167183,895424487,13991007,18.1),(117274,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117274,37.46,0.27,310,51611,70,NULL,NULL,'2MASX J14082240+0954327',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000131,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.0934583,9.90922,0,NULL,58490749143,913917955,14279968,17.7),(117275,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117275,37.59,0.46,329,51612,70,NULL,NULL,'2MASX J14082276+0834577',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.09475,8.58275,0,NULL,58517870801,914341731,14286589,17.8),(117276,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117276,37.23,0.46,280,51613,70,NULL,NULL,'2MASX J14082311+1336277',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000132,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,212.0962083,13.60769,0,NULL,58360871154,911888611,14248259,17.4),(117277,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117277,37.99,0.46,397,51614,70,NULL,NULL,'2MASX J14082312-0102520',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000297,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,212.09625,-1.04789,0.153,NULL,43591364783,681115074,10642423,17.1),(117278,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117278,37.94,0.27,387,51615,70,NULL,NULL,'SDSS J140823.62+102007.5',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000096,NULL,'17.8g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.098417,10.33544,0,NULL,58491342719,913927229,14280112,17.8),(117279,'D-Sigma','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117279,30.28,0.4,11.4,51616,75,NULL,'Edat, raw','ESO 221- G 026',NULL,'1997ApJS..109..333W',1997,1,2.8,'Di Nella, et al. (1997,MNRAS,287,472) give v = 9300: +/- 70 km/sec.','G',0.000103,NULL,'12.10',1.7,'E',NULL,NULL,NULL,NULL,1,212.0992917,-47.97047,0.681,NULL,46839293685,731863963,11435374,12.1),(117280,'D-Sigma','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117280,30.62,0.4,13.3,51616,75,NULL,'Edat, cor','ESO 221- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117281,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117281,31.4,0.45,19.1,51616,NULL,NULL,'K','ESO 221- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117282,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117282,33.04,0.4,40.6,51616,NULL,NULL,'mean','ESO 221- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117283,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117283,36.33,0.33,185,51617,70,NULL,NULL,'2MASX J14082395+5306516',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000198,NULL,'15.7g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,212.09975,53.11425,0,NULL,59249703071,925776610,14465259,15.7),(117284,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117284,37.58,0.33,328,51618,70,NULL,NULL,'2MASX J14082490+2319013',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.10',0.15,NULL,NULL,NULL,NULL,NULL,1,212.103875,23.31711,0,NULL,59472638420,929259975,14519687,18.1),(117285,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117285,37.22,0.46,278,51619,70,NULL,NULL,'SDSS J140826.34+534543.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.1097917,53.76219,0,NULL,59248798905,925762482,14465038,17.9),(117286,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117286,38.39,0.46,477,51620,70,NULL,NULL,'SDSS J140826.63+051404.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000088,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.1109583,5.23464,0.033,NULL,58482154546,913783664,14277869,18),(117287,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117287,36.32,0.66,184,51621,70,NULL,NULL,'2MASX J14082671-1407105',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,212.1115417,-14.11967,0.241,NULL,43650862299,682044723,10656948,17),(117288,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117288,36.33,0.33,185,51622,70,NULL,NULL,'2MASX J14082696+5304077',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000169,NULL,'15.8g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,212.1125,53.06897,0,NULL,59249704139,925776627,14465259,15.8),(117289,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117289,37.65,0.27,338,51623,70,NULL,NULL,'2MASX J14082746+1218067',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000186,NULL,'16.0g',0.4,'E0',NULL,NULL,NULL,NULL,1,212.114583,12.30172,0,NULL,58361361797,911896278,14248379,16),(117290,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117290,37.45,0.46,309,51624,70,NULL,NULL,'2MASX J14082785+1854273',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.86',0.2,NULL,NULL,NULL,NULL,NULL,1,212.1160417,18.90769,0.038,NULL,59517316307,929958067,14530594,17.86),(117291,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117291,36.79,0.46,228,51625,70,NULL,NULL,'2MASX J14082783+4812007',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000159,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,212.116167,48.20017,0.033,NULL,59255789285,925871707,14466745,16.4),(117292,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117292,35.51,0.2,126,51626,74.4,NULL,NULL,'CGCG 074-116',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000099,NULL,'15.8g',0.25,'Sc',NULL,NULL,NULL,NULL,1,212.116583,13.59831,0,NULL,58360871711,911888620,14248259,15.8),(117293,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117293,35.26,0.49,113,51627,75,NULL,'IR','CGCG 074-116',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000099,NULL,'15.8g',0.25,'Sc',NULL,NULL,NULL,NULL,1,212.116583,13.59831,0,NULL,58360871711,911888620,14248259,15.8),(117294,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117294,37.53,0.15,320,51628,70,NULL,NULL,'2MASX J14082824+5533017',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,212.1179583,55.55042,0.005,NULL,57302154347,895346161,13989783,17.9),(117295,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117295,37.53,0.15,320,51629,70,NULL,NULL,'2MASX J14082880+5524197',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,212.1202917,55.40539,0,NULL,57302230777,895347355,13989802,18),(117296,'IRAS','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117296,34.45,0.8,77.6,51630,75,NULL,'CF, r','UGC 09037',NULL,'1997ApJS..109..333W',1997,1,1.34,'HOLM 591B is a star.','G',0.00003,NULL,'14.4g',0.64,'Scd:','Group member of poor cluster',NULL,NULL,NULL,1,212.1215,7.05792,0.028,NULL,58516231956,914316124,14286189,14.4),(117297,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117297,34.22,0.38,69.9,51630,75,NULL,'CF, r, raw','UGC 09037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117298,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117298,34.24,0.2,70.5,51630,74.4,NULL,NULL,'UGC 09037',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117299,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117299,34.31,0.46,72.8,51630,NULL,NULL,NULL,'UGC 09037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117300,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117300,34.32,0.38,73.2,51630,75,NULL,'CF, r, inv','UGC 09037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117301,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117301,34.44,0.44,77.3,51630,NULL,NULL,'Malmquist cor.','UGC 09037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117302,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117302,34.58,0.38,82.4,51630,75,NULL,'CF, r, cor','UGC 09037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117303,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117303,36.79,0.19,228,51631,70,NULL,NULL,'2MASX J14082925-0050290',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000087,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,212.122041667,-0.84147,0.153,NULL,43591371613,681115181,10642424,17.1),(117304,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117304,37.55,0.46,324,51632,70,NULL,NULL,'2MASX J14082983+4120158',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,212.124375,41.33789,0,NULL,59260803293,925950051,14467969,17.2),(117305,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117305,38.78,0.46,569,51633,70,NULL,NULL,'SDSS J140830.59+030854.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000072,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,212.1275,3.14844,0.049,NULL,58483160854,913799388,14278115,18.2),(117306,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117306,34.84,0.33,92.9,51634,70,NULL,NULL,'NGC 5482',NULL,'2015arXiv151105856S',2015,1,1.39,NULL,'G',0.000073,NULL,'13.6g',0.87,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,212.127917,8.93192,0.045,NULL,58516926352,914326974,14286358,13.6),(117307,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117307,34.96,0.45,98,51634,NULL,NULL,'K','NGC 5482',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117308,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117308,35.06,0.4,103,51634,NULL,NULL,'mean','NGC 5482',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117309,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117309,37.76,0.14,356,51635,70,NULL,NULL,'2MASX J14083075+0527142',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000074,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,212.128083333,5.45397,0.037,NULL,58481270518,913769851,14277653,17.8),(117310,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117310,37.89,0.46,379,51636,70,NULL,NULL,'2MASX J14083124+5724247',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,212.129917,57.40675,0,NULL,57310483446,895476303,13991817,17.3),(117311,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117311,37.39,0.33,300,51637,70,NULL,NULL,'2MASX J14083166+0651257',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,212.132125,6.85719,0.028,NULL,58516704166,914323502,14286304,17.7),(117312,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117312,37.76,0.14,356,51638,70,NULL,NULL,'SDSS J140832.02+052726.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000167,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,212.133458333,5.45722,0.037,NULL,58481270442,913769850,14277653,18.5),(117313,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117313,37.46,0.27,310,51639,70,NULL,NULL,'2MASX J14083207+0955317',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000176,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,212.133667,9.92564,0,NULL,58491471577,913929243,14280144,16.5),(117314,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117314,38.16,0.46,428,51640,70,NULL,NULL,'SDSS J140832.43+255912.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00013,NULL,'18.3g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.135166667,25.98694,0,NULL,60002388171,937537315,14649020,18.3),(117315,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117315,33.6,0.69,52.4,51641,100,NULL,'mid-IR','UGC 09041',NULL,'2013ApJ...771...88L',2013,1,1.04,NULL,'G',0.000108,NULL,'14.4g',0.64,'SBa',NULL,NULL,NULL,NULL,1,212.137416667,11.81622,0,NULL,58492030247,913937972,14280280,14.4),(117316,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117316,34.62,0.2,84,51641,74.4,NULL,NULL,'UGC 09041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117317,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117317,37.65,0.27,338,51642,70,NULL,NULL,'2MASX J14083306+1224257',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,212.137708333,12.407,0,NULL,58361370992,911896421,14248381,16.6),(117318,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117318,34.84,0.33,92.9,51643,70,NULL,NULL,'CGCG 074-117',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000057,NULL,'15.3g',0.47,NULL,'Group member',NULL,NULL,NULL,1,212.14075,9.03794,0.023,NULL,58516962796,914327543,14286367,15.3),(117319,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117319,37.53,0.15,320,51644,70,NULL,NULL,'2MASX J14083554+5532247',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000188,NULL,'15.8g',0.44,'BrClG',NULL,NULL,NULL,NULL,1,212.147917,55.54008,0.005,NULL,57302154199,895346159,13989783,15.8),(117320,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117320,37.35,0.46,295,51645,70,NULL,NULL,'2MASX J14083554+1757044',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,212.1480417,17.95119,0,NULL,59483870638,929435478,14522429,18.3),(117321,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117321,37.57,0.46,326,51646,70,NULL,NULL,'SDSS J140835.55+071311.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.148125,7.21978,0.025,NULL,58516200936,914315639,14286181,17.9),(117322,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117322,38.06,0.46,409,51647,70,NULL,NULL,'2MASX J14083561+1943254',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'18.20',0.17,NULL,NULL,NULL,NULL,NULL,1,212.1485,19.72367,0.035,NULL,59462934310,929108348,14517317,18.2),(117323,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117323,38.08,0.46,413,51648,70,NULL,NULL,'SDSS J140836.36+452022.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000133,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,212.1515417,45.33953,0,NULL,59236451992,925569562,14462024,18.6),(117324,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117324,35.71,0.46,139,51649,70,NULL,NULL,'2MASX J14083682+1259347',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000165,NULL,'15.8g',0.3,'S0',NULL,NULL,NULL,NULL,1,212.1535,12.993,0,NULL,58360950246,911889847,14248278,15.8),(117325,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117325,35.37,0.57,118,51650,NULL,NULL,NULL,'ESO 384- G 060',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.40',0.2,'S...',NULL,NULL,NULL,NULL,1,212.154625,-34.20392,0.197,NULL,47002752817,734418012,11475281,16.4),(117326,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117326,35.41,0.2,121,51650,74.4,NULL,NULL,'ESO 384- G 060',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117327,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117327,35.45,0.55,123,51650,NULL,NULL,'Malmquist cor.','ESO 384- G 060',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117328,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117328,37.16,0.46,271,51651,70,NULL,NULL,'2MASX J14083738+1944444',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,212.155667,19.74564,0.035,NULL,59462933673,929108338,14517317,18),(117329,'IRAS','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117329,34.08,0.8,65.5,51652,75,NULL,'MAT, I','ESO 446- G 018',NULL,'1997ApJS..109..333W',1997,1,3.11,NULL,'G',0.000005,NULL,'14.86',0.31,'Sb             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,212.1595,-29.57203,0.205,NULL,47037426806,734959793,11483746,14.86),(117330,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117330,33.78,0.49,57.1,51652,75,NULL,'IR','ESO 446- G 018',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117331,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117331,33.87,0.43,59.4,51652,75,NULL,'MAT, I, raw','ESO 446- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117332,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117332,33.91,0.47,60.7,51652,NULL,NULL,'H','ESO 446- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117333,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117333,33.95,0.45,61.7,51652,NULL,NULL,'K','ESO 446- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117334,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117334,34.03,0.46,63.9,51652,NULL,NULL,'J','ESO 446- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117335,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117335,34.05,0.32,64.5,51652,85,NULL,'I, raw','ESO 446- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117336,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117336,34.09,0.4,65.8,51652,NULL,NULL,'mean','ESO 446- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117337,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117337,34.1,0.43,66,51652,75,NULL,'MAT, I, inv','ESO 446- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117338,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117338,34.1,0.32,66.1,51652,85,NULL,'I, inv','ESO 446- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117339,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117339,34.11,0.43,66.3,51652,75,NULL,'MAT, I, cor','ESO 446- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117340,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117340,34.21,0.2,69.5,51652,74.4,NULL,NULL,'ESO 446- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117341,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117341,34.23,NULL,70.1,51652,NULL,NULL,NULL,'ESO 446- G 018',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117342,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117342,34.26,NULL,71.2,51652,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 446- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117343,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117343,34.27,NULL,71.3,51652,NULL,NULL,'Dipole','ESO 446- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117344,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117344,34.27,NULL,71.4,51652,NULL,NULL,'Dipole + Quadrupole','ESO 446- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117345,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117345,34.29,0.16,72.3,51652,NULL,NULL,NULL,'ESO 446- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117346,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117346,36.2,0.46,174,51653,70,NULL,NULL,'2MASX J14083854+1343527',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000152,NULL,'16.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,212.16075,13.73144,0,NULL,58367412004,911990812,14249856,16.2),(117347,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117347,37.47,0.33,312,51654,70,NULL,NULL,'SDSS J140838.57+295823.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.16075,29.97322,0,NULL,60051625880,938306654,14661041,18.2),(117348,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117348,37.27,0.46,284,51655,70,NULL,NULL,'2MASX J14083878+0427232',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000099,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,212.161625,4.45656,0.033,NULL,58485077419,913829334,14278583,16.4),(117349,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117349,37.53,0.15,320,51656,70,NULL,NULL,'2MASX J14083928+5527577',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000166,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.164,55.46611,0,NULL,57302269869,895347966,13989811,17.7),(117350,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117350,37.59,0.46,330,51657,70,NULL,NULL,'2MASX J14084049+1029241',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,212.1687083,10.49019,0,NULL,58491327309,913926989,14280109,17.5),(117351,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117351,37.76,0.14,356,51658,70,NULL,NULL,'2MASX J14084073+0529552',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000073,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,212.169667,5.49861,0.037,NULL,58481389026,913771703,14277682,17.9),(117352,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117352,35.64,0.4,134,51659,NULL,NULL,'mean','ESO 578- G 026',NULL,'2007A&A...465...71T',2007,1,1.8,'RC3 has V = 2781 +- 11 km/s.','G',0.00003,NULL,'15.05',1.2,'SB(rl)c','in a pair',NULL,NULL,NULL,1,212.174916667,-21.59725,0.237,NULL,46519484260,726866941,11357295,15.05),(117353,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117353,35.76,0.47,142,51659,NULL,NULL,'H','ESO 578- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117354,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117354,35.87,0.45,149,51659,NULL,NULL,'K','ESO 578- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117355,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117355,35.92,0.46,153,51659,NULL,NULL,'J','ESO 578- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117356,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117356,38.29,0.46,455,51660,70,NULL,NULL,'2MASX J14084266+5359547',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.177875,53.99844,0,NULL,59248738994,925761546,14465024,17.6),(117357,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117357,38.02,0.46,402,51661,70,NULL,NULL,'SDSS J140844.88+085309.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00017,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.1870417,8.88589,0.045,NULL,58516930464,914327038,14286359,18.3),(117358,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117358,37.29,0.46,287,51662,70,NULL,NULL,'2MASXi J1408460+522115',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.1920417,52.35422,0,NULL,59249073165,925766768,14465105,17.8),(117359,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117359,35.49,0.46,125,51663,70,NULL,NULL,'2MASX J14084664+1153181',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000184,NULL,'16.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,212.194458333,11.8885,0,NULL,58492163519,913940054,14280313,16.2),(117360,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117360,37.42,0.46,304,51664,70,NULL,NULL,'2MASX J14084709+2645114',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000144,NULL,'17.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,212.196375,26.75317,0,NULL,60000885965,937513843,14648653,17.2),(117361,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117361,35.22,0.49,111,51665,75,NULL,'IR','KUG 1406+274',NULL,'2011yCatp016004901K',2011,1,1.01,NULL,'G',0.00005,NULL,'15.9g',0.25,'Spiral',NULL,NULL,NULL,NULL,1,212.203625,27.25492,0,NULL,60008535232,937633363,14650521,15.9),(117362,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117362,37.46,0.27,310,51666,70,NULL,NULL,'2MASX J14084977+0955491',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,212.2075,9.93044,0,NULL,58491477405,913929334,14280145,17.4),(117363,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117363,36.27,0.76,179,51667,70,NULL,NULL,'2MASX J14085154-3006378',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000103,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,212.21475,-30.11053,0.217,NULL,47037399851,734959372,11483740,14.5),(117364,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117364,37.65,0.27,338,51668,70,NULL,NULL,'2MASX J14085245+1220458',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,212.218583,12.34614,0,NULL,58361228660,911894197,14248346,17.6),(117365,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117365,35.58,0.2,131,51669,74.4,NULL,NULL,'UGC 09048',NULL,'2013AJ....146...86T',2013,1,1.91,NULL,'G',0.000033,NULL,'14.8g',0.32,'Sbc','Isolated galaxy',NULL,NULL,NULL,1,212.22025,33.53211,0,NULL,60037217736,938081527,14657523,14.8),(117366,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117366,35.96,0.4,156,51669,NULL,NULL,'mean','UGC 09048',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117367,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117367,36.18,0.47,172,51669,NULL,NULL,'H','UGC 09048',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117368,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117368,37.53,0.46,320,51670,70,NULL,NULL,'2MASX J14085321+2252352',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.221833,22.8765,0.016,NULL,59474743419,929292865,14520201,17.7),(117369,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117369,37.53,0.15,320,51671,70,NULL,NULL,'SDSS J140853.27+553616.1',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,212.222,55.6045,0,NULL,57302181104,895346579,13989790,18),(117370,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117370,37.43,0.46,306,51672,70,NULL,NULL,'2MASX J14085391+1011561',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.90',0.18,NULL,NULL,NULL,NULL,NULL,1,212.224583,10.19897,0,NULL,58491515909,913929936,14280155,17.9),(117371,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117371,37.53,0.15,320,51673,70,NULL,NULL,'2MASX J14085406+5526265',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000194,NULL,'16.0g',0.43,'E0',NULL,NULL,NULL,NULL,1,212.225375,55.44075,0,NULL,57302259106,895347798,13989809,16),(117372,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117372,37.64,0.27,337,51674,70,NULL,NULL,'2MASX J14085473+1054511',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000174,NULL,'18.09',0.17,NULL,NULL,NULL,NULL,NULL,1,212.228,10.91414,0,NULL,58493627914,913962936,14280670,18.09),(117373,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117373,38.07,0.46,410,51675,70,NULL,NULL,'2MASX J14085494+1131031',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,212.228833333,11.51753,0,NULL,58493118598,913954978,14280546,17.2),(117374,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117374,37.08,0.46,261,51676,70,NULL,NULL,'2MASX J14085561+1911442',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.77',0.25,NULL,NULL,NULL,NULL,NULL,1,212.2317917,19.19553,0.034,NULL,59517774726,929965230,14530706,16.77),(117375,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117375,38.54,0.46,510,51677,70,NULL,NULL,'SDSS J140856.47-012312.7',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000135,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,212.2352917,-1.38686,0.161,NULL,43590837850,681106841,10642294,18.4),(117376,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117376,33.95,0.75,61.7,51678,NULL,NULL,NULL,'AGC 540216',NULL,'2009ApJS..182..474S',2009,1,0.76,NULL,'G',0.000043,NULL,'15.00',NULL,'Sbc',NULL,NULL,NULL,NULL,1,212.238333,-27.04886,0.161,NULL,46987313313,734176770,11471512,15),(117377,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117377,33.99,0.2,62.8,51678,74.4,NULL,NULL,'AGC 540216',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117378,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117378,34.2,0.67,69.1,51678,NULL,NULL,'Malmquist cor.','AGC 540216',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117379,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117379,31.67,NULL,21.6,51679,72,NULL,NULL,'IC 0978',NULL,'2014Ap.....57..457K',2014,1,0.89,NULL,'G',0.000037,NULL,'15.0g',0.49,'Sb','Pair member (points to parent)',NULL,NULL,NULL,1,212.242083,-2.97378,0.105,NULL,43722869736,683169839,10674528,15),(117380,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117380,37.47,0.46,312,51680,70,NULL,NULL,'SDSS J140858.65+092233.0',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000125,NULL,'17.8g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.244417,9.37586,0,NULL,58508703152,914198486,14284351,17.8),(117381,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117381,37.84,0.46,369,51681,70,NULL,NULL,'2MASX J14090127+3404109',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000188,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,212.2552083,34.06972,0,NULL,60036293049,938067078,14657298,16.6),(117382,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117382,38.41,0.46,480,51682,70,NULL,NULL,'SDSS J140901.89+242101.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.257917,24.35039,0,NULL,59468764905,929199451,14518741,18.3),(117383,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117383,34.55,0.4,81.3,51683,NULL,NULL,'mean','UGC 09044',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000033,NULL,'14.54',0.6,'S?',NULL,NULL,NULL,NULL,1,212.259583,14.31694,0,NULL,58367548533,911992945,14249889,14.54),(117384,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117384,34.83,0.47,92.5,51683,NULL,NULL,'H','UGC 09044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117385,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117385,37.03,0.63,254,51684,70,NULL,NULL,'LCRS B140625.4-061107',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'16.8b',0.32,NULL,NULL,NULL,NULL,NULL,1,212.262625,-6.42181,0.061,NULL,43739487287,683429488,10678585,16.8),(117386,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117386,34.54,0.46,81,51685,70,NULL,NULL,'CGCG 103-086',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.00022,NULL,'15.1',0.25,NULL,NULL,NULL,NULL,NULL,1,212.266417,17.76622,0,NULL,59483712009,929433000,14522390,15.1),(117387,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117387,38.15,0.46,427,51686,70,NULL,NULL,'2MASXi J1409041+120325',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000181,NULL,'18.1g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.267667,12.05725,0,NULL,58492153383,913939896,14280310,18.1),(117388,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117388,37.48,0.46,313,51687,70,NULL,NULL,'2MASX J14090438+2342223',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,212.268375,23.70608,0,NULL,59468357339,929193083,14518641,17.7),(117389,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117389,38.02,0.33,401,51688,70,NULL,NULL,'SDSS J140904.90+582623.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000138,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,212.2704583,58.43983,0,NULL,57304649703,895385151,13990392,17.8),(117390,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117390,37.93,0.46,385,51689,70,NULL,NULL,'2MASX J14090551+0611303',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,212.272917,6.19175,0.033,NULL,58504271785,914129246,14283269,18),(117391,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117391,37.8,0.46,363,51690,70,NULL,NULL,'2MASX J14090623+4944426',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,212.2760417,49.74506,0.051,NULL,59256706576,925886040,14466969,17.6),(117392,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117392,37.39,0.46,300,51691,70,NULL,NULL,'2MASX J14090688+5327486',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000185,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,212.278625,53.46353,0,NULL,59248998060,925765594,14465087,16.6),(117393,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117393,37.69,0.46,345,51692,70,NULL,NULL,'2MASX J14090710+0515013',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00008,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,212.2797083,5.25028,0.037,NULL,58482167617,913783869,14277872,17.2),(117394,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117394,37.34,0.46,294,51693,70,NULL,NULL,'2MASX J14090739+3213569',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.15',0.15,NULL,NULL,NULL,NULL,NULL,1,212.28075,32.23233,0,NULL,60033335420,938020865,14656576,18.15),(117395,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117395,37.94,0.46,387,51694,70,NULL,NULL,'2MASX J14090767+1931463',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.60',0.15,NULL,NULL,NULL,NULL,NULL,1,212.282041667,19.52947,0.054,NULL,59462946076,929108532,14517320,18.6),(117396,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117396,37.8,0.46,362,51695,70,NULL,NULL,'2MASX J14090856+2450182',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,212.285583,24.83833,0,NULL,60002548495,937539820,14649059,18.2),(117397,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117397,38.04,0.33,406,51696,70,NULL,NULL,'2MASX J14090884+0557233',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000177,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.286916667,5.9565,0.013,NULL,58473905253,913654769,14275855,17.7),(117398,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117398,36.7,0.46,218,51697,70,NULL,NULL,'2MASX J14091134+2708352',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.67',0.2,NULL,NULL,NULL,NULL,NULL,1,212.297375,27.14317,0,NULL,60000991136,937515486,14648679,17.67),(117399,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117399,37.45,0.46,309,51698,70,NULL,NULL,'SDSS J140911.85+043015.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000071,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,212.299416667,4.50433,0.029,NULL,58485042711,913828792,14278574,17.8),(117400,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117400,35.7,0.53,138,51699,70,NULL,NULL,'2MASX J14091203-4732599',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,212.300125,-47.54994,0.581,NULL,46827452872,731678951,11432483,16.7),(117401,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117401,37.64,0.27,337,51700,70,NULL,NULL,'2MASX J14091153+1059193',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.33',0.15,NULL,NULL,NULL,NULL,NULL,1,212.300333,10.99222,0,NULL,58492880578,913951259,14280488,18.33),(117402,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117402,36.02,0.46,160,51701,70,NULL,NULL,'I Zw 082',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000199,NULL,'15.1g',0.62,'E0',NULL,NULL,NULL,NULL,1,212.300458333,56.39892,0.037,NULL,57299857129,895310267,13989222,15.1),(117403,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117403,37.76,0.14,356,51702,70,NULL,NULL,'2MASX J14091233+0526103',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000077,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,212.301417,5.43606,0.033,NULL,58481354608,913771165,14277674,17.9),(117404,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117404,37.48,0.46,313,51703,70,NULL,NULL,'2MASX J14091264+3159348',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000141,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,212.3027917,31.99308,0,NULL,60053264329,938332255,14661441,17.5),(117405,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117405,37.64,0.27,337,51704,70,NULL,NULL,'2MASX J14091330+1052043',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000137,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,212.305417,10.86783,0,NULL,58492899868,913951560,14280493,17.8),(117406,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117406,37.44,0.46,308,51705,70,NULL,NULL,'2MASX J14091466+2614402',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,212.3112083,26.24461,0,NULL,60002694967,937542108,14649095,17.3),(117407,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117407,38.1,0.46,417,51706,70,NULL,NULL,'2MASX J14091518+6251146',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.313667,62.85406,0.025,NULL,57751266292,902363535,14099430,17.9),(117408,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117408,37.75,0.46,355,51707,70,NULL,NULL,'2MASX J14091701+3844053',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000203,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,212.320875,38.73469,0,NULL,59140500478,924070319,14438598,16.7),(117409,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117409,38.02,0.33,401,51708,70,NULL,NULL,'2MASX J14091804+5827545',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,212.325125,58.46506,0,NULL,57304645710,895385089,13990392,17.6),(117410,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117410,37.22,0.46,278,51709,70,NULL,NULL,'2MASX J14091833+4505270',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000211,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,212.3265417,45.09083,0,NULL,59236446374,925569474,14462023,16.8),(117411,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117411,36.42,0.46,192,51710,70,NULL,NULL,'2MASX J14091865+3509368',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000174,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,212.327917,35.16025,0,NULL,60035307947,938051686,14657057,16.4),(117412,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117412,35.53,0.52,128,51711,70,NULL,NULL,'MCG -03-36-008',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.00004,NULL,'15.80',0.2,'E',NULL,NULL,NULL,NULL,1,212.331375,-17.87917,0.273,NULL,46544391694,727256120,11363376,15.8),(117413,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117413,37.59,0.17,329,51712,70,NULL,NULL,'2MASX J14092041+2549322',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000153,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,212.335125,25.82547,0,NULL,60002324306,937536317,14649004,18.2),(117414,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117414,38.01,0.46,400,51713,70,NULL,NULL,'2MASX J14092106+0953563',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000144,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,212.337583,9.89883,0,NULL,58490788863,913918575,14279977,17.7),(117415,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117415,37.8,0.46,363,51714,70,NULL,NULL,'SDSS J140921.34+450827.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000138,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,212.338917,45.14114,0,NULL,59236439710,925569370,14462021,18.5),(117416,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117416,31.97,0.43,24.8,51715,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09056',NULL,'2014MNRAS.444..527S',2014,1,1.18,NULL,'G',0.000015,NULL,'14.4g',0.43,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,212.3407083,49.03756,0.055,NULL,59256278893,925879357,14466864,14.4),(117417,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117417,32,0.4,25.2,51715,75,NULL,NULL,'UGC 09056',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117418,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117418,32.1,0.43,26.3,51715,75,NULL,'3.6 micron, color corrected','UGC 09056',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117419,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117419,32.19,0.2,27.4,51715,74.4,NULL,NULL,'UGC 09056',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117420,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117420,32.7,0.49,34.6,51715,75,NULL,'IR','UGC 09056',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117421,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117421,37.76,0.46,356,51716,70,NULL,NULL,'SDSS J140923.36+285718.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000158,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.347333,28.95517,0,NULL,60005922652,937592541,14649883,18.3),(117422,'BL Lac Luminosity','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117422,42.15,NULL,1800,51717,NULL,NULL,NULL,'SDSS J140923.49+593940.8',0.495845,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.000205,NULL,'19.2g',NULL,'HBLLAC',NULL,NULL,NULL,'BL Lac',1,212.347875,59.66133,0.005,NULL,57272378073,894880907,13982514,19.2),(117423,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117423,38.04,0.33,406,51718,70,NULL,NULL,'2MASX J14092480+0557485',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.85',0.18,NULL,NULL,NULL,NULL,NULL,1,212.3532083,5.96339,0.049,NULL,58473885583,913654462,14275850,17.85),(117424,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117424,37.05,0.33,257,51719,70,NULL,NULL,'2MASX J14092509+2200086',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,212.354583,22.00225,0.036,NULL,59472062708,929250979,14519546,17.4),(117425,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117425,35.25,0.53,112,51720,NULL,NULL,'Malmquist cor.','ESO 510- G 075',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000027,NULL,'15.96',0.4,'Sb:',NULL,NULL,NULL,NULL,1,212.357375,-27.47561,0.141,NULL,46989184930,734206014,11471968,15.96),(117426,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117426,35.25,0.53,112,51720,NULL,NULL,NULL,'ESO 510- G 075',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117427,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117427,35.29,0.2,114,51720,74.4,NULL,NULL,'ESO 510- G 075',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117428,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117428,37.79,0.46,362,51721,70,NULL,NULL,'2MASX J14092579+5113537',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000178,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,212.35775,51.23164,0.009,NULL,59252057382,925813396,14465834,17.2),(117429,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117429,37.59,0.17,329,51722,70,NULL,NULL,'SDSS J140926.66+255519.6',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',NULL,NULL,'15.9g',0.41,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.361083,25.92214,0,NULL,60002300433,937535944,14648999,15.9),(117430,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117430,37.72,0.46,351,51723,70,NULL,NULL,'2MASX J14093229+4437109',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,212.384541667,44.61997,0,NULL,59240068601,925626071,14462907,18.3),(117431,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117431,36.71,0.46,219,51724,70,NULL,NULL,'2MASX J14093322+1329351',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,212.388291667,13.49322,0,NULL,58365337467,911958397,14249349,16.7),(117432,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117432,38.35,0.46,467,51725,70,NULL,NULL,'2MASX J14093410+1037365',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000183,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,212.39225,10.62692,0,NULL,58490956263,913921191,14280018,17.3),(117433,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117433,37.67,0.46,342,51726,70,NULL,NULL,'SDSS J140934.78-004911.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000072,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.394917,-0.81994,0.157,NULL,43591153055,681111766,10642371,18.2),(117434,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117434,38.91,0.46,607,51727,70,NULL,NULL,'2MASX J14093643+4136283',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.401833333,41.60781,0,NULL,59225935958,925405249,14459457,18.1),(117435,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117435,37.82,0.46,366,51728,70,NULL,NULL,'2MASX J14093697+5825536',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'17.1g',0.23,'AGN',NULL,NULL,NULL,NULL,1,212.404083333,58.43147,0,NULL,57304436057,895381813,13990340,17.1),(117436,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117436,37.93,0.46,386,51729,70,NULL,NULL,'2MASX J14093746+0126595',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000086,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.4060417,1.45,0.057,NULL,58405186454,912581038,14259078,17.7),(117437,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117437,37.53,0.15,320,51730,70,NULL,NULL,'2MASX J14093813+5538506',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000177,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.408833,55.64736,0.005,NULL,57302178485,895346538,13989789,17.5),(117438,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117438,37.47,0.33,312,51731,70,NULL,NULL,'2MASX J14093849+2959463',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.20',0.18,NULL,NULL,NULL,NULL,NULL,1,212.410333333,29.99636,0,NULL,60051601438,938306272,14661035,18.2),(117439,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117439,37.18,0.46,272,51732,70,NULL,NULL,'2MASX J14093915+1228401',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000165,NULL,'16.9g',0.33,NULL,NULL,NULL,NULL,NULL,1,212.413167,12.47778,0,NULL,58361510115,911898595,14248415,16.9),(117440,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117440,38.43,0.46,485,51733,70,NULL,NULL,'2MASXi J1409396+174133',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.7g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.414875,17.69256,0,NULL,59484581914,929446592,14522603,17.7),(117441,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117441,37.76,0.14,356,51734,70,NULL,NULL,'2MASX J14093974+0532245',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000079,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,212.4155,5.54019,0.033,NULL,58481339052,913770922,14277670,17.6),(117442,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117442,38.45,0.46,490,51735,70,NULL,NULL,'2MASX J14094004+4036023',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,212.416875,40.60075,0,NULL,59257600191,925900002,14467187,17.3),(117443,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117443,38.95,0.46,616,51736,70,NULL,NULL,'SDSS J140940.84+103846.4',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.4202083,10.64625,0,NULL,58490999772,913921871,14280029,17.9),(117444,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117444,37.53,0.15,320,51737,70,NULL,NULL,'2MASX J14094210+5527386',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000175,NULL,'16.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,212.425417,55.46061,0,NULL,57302317517,895348711,13989823,16.4),(117445,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117445,37.99,0.46,396,51738,70,NULL,NULL,'2MASX J14094241+1859040',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.52',0.16,NULL,NULL,NULL,NULL,NULL,1,212.426667,18.9845,0.038,NULL,59518068881,929969826,14530778,18.52),(117446,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117446,37.59,0.17,329,51739,70,NULL,NULL,'2MASX J14094330+2556478',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,212.430375,25.94653,0,NULL,60002297130,937535892,14648998,17.3),(117447,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117447,37.33,0.27,292,51740,70,NULL,NULL,'2MASX J14094357+0618275',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.0002,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,212.4314583,6.30753,0.042,NULL,58504499612,914132806,14283325,16.7),(117448,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117448,36.78,0.46,227,51741,70,NULL,NULL,'2MASX J14094388-0134220',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.433,-1.57286,0.153,NULL,43589626324,681087911,10641998,17.7),(117449,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117449,37.33,0.27,292,51742,70,NULL,NULL,'SDSS J140945.62+062324.6',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,212.440125,6.39019,0.042,NULL,58504460056,914132188,14283315,17.6),(117450,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117450,32.96,NULL,39,51743,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 221- G 029',NULL,'2010Ap&SS.325..163P',2010,1,1.43,'Stars superposed.','G',0.000038,NULL,'16.24',0.17,'Sdm',NULL,NULL,NULL,NULL,1,212.440291667,-48.33094,0.753,NULL,46839192238,731862378,11435349,16.24),(117451,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117451,32.96,NULL,39.1,51743,NULL,NULL,'Dipole + Quadrupole','ESO 221- G 029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117452,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117452,32.98,NULL,39.4,51743,NULL,NULL,'Dipole','ESO 221- G 029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117453,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117453,38.39,0.33,476,51744,70,NULL,NULL,'SDSS J140946.32+574110.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.443,57.68614,0,NULL,57305737064,895402141,13990658,18),(117454,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117454,37.53,0.15,320,51745,70,NULL,NULL,'2MASX J14094668+5529147',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000202,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,212.444625,55.48739,0,NULL,57302309817,895348590,13989821,16.3),(117455,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117455,35.88,0.46,150,51746,70,NULL,NULL,'CGCG 074-124',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.0001,NULL,'14.7g',0.65,NULL,NULL,NULL,NULL,NULL,1,212.445083,11.58486,0,NULL,58492464412,913944756,14280386,14.7),(117456,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117456,37,0.46,251,51747,70,NULL,NULL,'2MASX J14094738+5108428',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000158,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,212.447625,51.14517,0.005,NULL,59252088563,925813883,14465841,16.6),(117457,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117457,37.33,0.27,292,51748,70,NULL,NULL,'2MASX J14094753+0618015',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000194,NULL,'16.2g',0.41,'BrClG',NULL,NULL,NULL,NULL,1,212.448,6.30056,0.042,NULL,58504454305,914132098,14283314,16.2),(117458,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117458,37.64,0.33,337,51749,70,NULL,NULL,'2MASX J14094826+3354422',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000182,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,212.4510417,33.91172,0,NULL,60036337165,938067768,14657308,17.5),(117459,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117459,35.01,0.36,100,51750,NULL,NULL,'Malmquist cor.','UGC 09054',NULL,'2009ApJS..182..474S',2009,1,0.84,NULL,'G',0.000033,NULL,'15.3g',0.4,'SB?',NULL,NULL,NULL,NULL,1,212.4525417,9.85847,0,NULL,58490818293,913919035,14279984,15.3),(117460,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117460,35.07,0.35,103,51750,NULL,NULL,NULL,'UGC 09054',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117461,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117461,35.11,0.2,105,51750,74.4,NULL,NULL,'UGC 09054',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117462,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117462,38.36,0.46,469,51751,70,NULL,NULL,'SDSS J140948.65+473028.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,212.45275,47.50781,0.033,NULL,59255165025,925861953,14466593,18.3),(117463,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117463,38.18,0.46,433,51752,70,NULL,NULL,'2MASX J14094869+2711408',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000174,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,212.4529583,27.19461,0,NULL,60001023792,937515996,14648687,17.1),(117464,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117464,37.85,0.46,371,51753,70,NULL,NULL,'2MASX J14094952+1420515',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,212.4565,14.34767,0,NULL,58367734742,911995855,14249935,17.7),(117465,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117465,37.64,0.33,337,51754,70,NULL,NULL,'2MASX J14095033+3349252',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.001086,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.4597917,33.82369,0,NULL,60036305599,938067274,14657301,17.6),(117466,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117466,36.41,0.55,191,51755,70,NULL,NULL,'2MASX J14095066-4235006',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,212.461083,-42.58353,0.245,NULL,46793539118,731149048,11424203,14.9),(117467,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117467,37.65,0.46,338,51756,70,NULL,NULL,'2MASX J14095071+0348490',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000093,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,212.461125,3.81344,0.053,NULL,58485186045,913831031,14278609,16.8),(117468,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117468,37.7,0.46,347,51757,70,NULL,NULL,'2MASX J14095076+5859257',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,212.46175,58.99058,0.005,NULL,57271587866,894868560,13982321,17.1),(117469,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117469,36.92,0.46,242,51758,70,NULL,NULL,'2MASX J14095174-0004590',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000082,NULL,'17.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.4654583,-0.08303,0.101,NULL,43587523777,681055059,10641485,17),(117470,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117470,37.07,0.7,259,51759,70,NULL,NULL,'LCRS B140714.2-055516',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.9b',0.16,NULL,NULL,NULL,NULL,NULL,1,212.4654583,-6.15689,0.061,NULL,43739413074,683428329,10678567,16.9),(117471,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117471,37.05,0.33,257,51760,70,NULL,NULL,'2MASX J14095272+2157330',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.89',0.26,NULL,NULL,NULL,NULL,NULL,1,212.469667,21.95925,0.035,NULL,59472076525,929251195,14519549,16.89),(117472,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117472,33.43,NULL,48.5,51761,NULL,NULL,NULL,'FGC 1717',NULL,'2000BSAO...50....5K',2000,1,0.9,NULL,'G',0.00002,NULL,'17.82',0.1,'Sdm',NULL,NULL,NULL,NULL,1,212.473417,20.30994,0.03,NULL,59464441327,929131895,14517685,17.82),(117473,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117473,33.46,NULL,49.2,51761,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1717',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117474,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117474,33.48,NULL,49.6,51761,NULL,NULL,'Dipole + Quadrupole','FGC 1717',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117475,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117475,33.49,NULL,50,51761,NULL,NULL,'Dipole','FGC 1717',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117476,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117476,37.62,0.46,334,51762,70,NULL,NULL,'2MASX J14095360+2033000',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.16',0.14,NULL,NULL,NULL,NULL,NULL,1,212.473375,20.55017,0.024,NULL,59464424159,929131627,14517681,18.16),(117477,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117477,35.8,0.66,144,51763,70,NULL,NULL,'2MASX J14095364-3523287',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,212.4735,-35.39131,0.181,NULL,47006794907,734481170,11476268,15.6),(117478,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117478,36.44,0.24,194,51764,70,NULL,NULL,'GIN 341',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.00009,NULL,'14.96',NULL,'E/S0',NULL,NULL,NULL,NULL,1,212.4744583,-8.82244,0.057,NULL,43752078757,683626230,10681659,14.96),(117479,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117479,37.03,0.25,255,51764,74.4,NULL,NULL,'GIN 341',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117480,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117480,37.82,0.46,366,51765,70,NULL,NULL,'2MASX J14095412+0358110',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000093,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,212.4755417,3.96981,0.041,NULL,58485228620,913831697,14278620,17.4),(117481,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117481,38.09,0.23,415,51766,70,NULL,NULL,'SDSS J140954.76+085055.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.85',0.12,NULL,NULL,NULL,NULL,NULL,1,212.478208333,8.84869,0.01,NULL,58517061021,914329078,14286391,18.85),(117482,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117482,35.19,0.68,109,51767,70,NULL,NULL,'2MASX J14095516-1747230',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.94',NULL,NULL,NULL,NULL,NULL,NULL,1,212.479875,-17.78975,0.273,NULL,46545187853,727268560,11363571,15.94),(117483,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117483,37.71,0.46,349,51768,70,NULL,NULL,'2MASX J14095540+1048535',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.14',0.14,NULL,NULL,NULL,NULL,NULL,1,212.480916667,10.81503,0,NULL,58492870102,913951095,14280485,18.14),(117484,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117484,37.62,0.23,335,51769,70,NULL,NULL,'2MASX J14095567+5233108',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000168,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,212.482,52.55308,0.017,NULL,59249583827,925774747,14465230,16.6),(117485,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117485,36.44,0.24,194,51770,70,NULL,NULL,'GIN 340',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.000107,NULL,'15.24',NULL,'S',NULL,NULL,NULL,NULL,1,212.4824583,-9.08214,0.085,NULL,43751889274,683623269,10681613,15.24),(117486,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117486,37.12,0.25,265,51770,74.4,NULL,NULL,'GIN 340',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117487,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117487,36.94,0.46,244,51771,70,NULL,NULL,'2MASX J14095601+6141202',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000192,NULL,'16.0g',0.43,'E0',NULL,NULL,NULL,NULL,1,212.4832083,61.68897,0.021,NULL,57748310524,902317351,14098708,16),(117488,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:35','1','SN 1997cn',NULL,117488,34.2,0.09,69.2,51772,74.4,NULL,NULL,'NGC 5490',NULL,'2013AJ....146...86T',2013,1,1.74,'One of two 6cm sources associated with [WB92] 1407+1748','G',0.00008,NULL,'12.9g',1.12,'E','Possible field galaxy',NULL,'radio jet',NULL,1,212.4887083,17.54556,0,NULL,59484564236,929446316,14522598,12.9),(117489,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:35','1','SN 1997cn',NULL,117489,34.33,0.28,72.3,51772,72,NULL,NULL,'NGC 5490',0.0162,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117490,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:35','1','SN 1997cn',NULL,117490,34.43,0.19,75.5,51772,65,NULL,'MLCS17','NGC 5490',0.0162,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117491,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:35','1','SN 1997cn',NULL,117491,34.44,0.06,75.9,51772,72,NULL,NULL,'NGC 5490',0.0162,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117492,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:35','1','SN 1997cn',NULL,117492,34.53,0.07,78.1,51772,65,NULL,'MLCS2k2','NGC 5490',0.0162,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117493,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:35','1','SN 1997cn',NULL,117493,34.52,0.25,78.9,51772,65,NULL,NULL,'NGC 5490',0.0162,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117494,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:35','1','SN 1997cn',NULL,117494,34.55,0.2,79.9,51772,65,NULL,'MLCS31','NGC 5490',0.0162,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117495,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:35','1','SN 1997cn',NULL,117495,34.64,0.15,83.4,51772,70,NULL,'SALT','NGC 5490',0.0162,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117496,'D-Sigma','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117496,34.21,0.4,69.5,51772,75,NULL,'Edat, raw','NGC 5490',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117497,'D-Sigma','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117497,34.55,0.4,81.2,51772,75,NULL,'Edat, cor','NGC 5490',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117498,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117498,34.38,0.4,75.3,51772,NULL,NULL,'mean','NGC 5490',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117499,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117499,34.41,0.45,76.2,51772,NULL,NULL,'K','NGC 5490',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117500,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117500,38.2,0.46,437,51773,70,NULL,NULL,'2MASX J14095764+1040005',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,212.49025,10.66681,0,NULL,58490985296,913921645,14280025,17.7),(117501,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117501,35.02,0.5,101,51774,70,NULL,NULL,'2MASX J14095802-1453230',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00012,NULL,'15.77',NULL,NULL,NULL,NULL,NULL,NULL,1,212.491833,-14.89,0.245,NULL,43653844536,682091320,10657676,15.77),(117502,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117502,37.97,0.46,392,51775,70,NULL,NULL,'2MASX J14100080+5325228',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000139,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,212.5034583,53.42306,0,NULL,59248890671,925763916,14465061,17.7),(117503,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117503,37.85,0.46,372,51776,70,NULL,NULL,'2MASX J14100115+2426406',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000188,NULL,'18.09',0.17,NULL,NULL,NULL,NULL,NULL,1,212.504917,24.44467,0,NULL,59468506983,929195421,14518678,18.09),(117504,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117504,36.68,0.27,217,51777,70,NULL,NULL,'CGCG 272-037',NULL,'2015arXiv151105856S',2015,1,0.99,NULL,'G',0.000087,NULL,'14.4g',0.72,'S0^-',NULL,NULL,NULL,NULL,1,212.506583333,54.88172,0.013,NULL,57298818196,895294034,13988969,14.4),(117505,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117505,38.09,0.23,415,51778,70,NULL,NULL,'2MASX J14100169+0849118',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'18.22',0.18,NULL,NULL,NULL,NULL,NULL,1,212.507,8.81994,0.01,NULL,58517046538,914328852,14286388,18.22),(117506,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117506,37.59,0.17,329,51779,70,NULL,NULL,'2MASX J14100245+2601426',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000177,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.510291667,26.02856,0,NULL,60002778545,937543414,14649115,17.4),(117507,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117507,32.31,0.4,29,51780,75,NULL,NULL,'UGC 09071',NULL,'2008Ap.....51..336K',2008,1,1.92,NULL,'G',0.00002,NULL,'14.6g',0.45,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,212.512875,54.21831,0.005,NULL,57252313272,894567394,13977615,14.6),(117508,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117508,32.42,0.43,30.5,51780,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09071',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117509,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117509,32.44,0.4,30.8,51780,NULL,NULL,NULL,'UGC 09071',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117510,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117510,32.47,0.43,31.2,51780,75,NULL,'3.6 micron, color corrected','UGC 09071',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117511,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117511,32.51,0.2,31.8,51780,74.4,NULL,NULL,'UGC 09071',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117512,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117512,32.69,0.51,34.5,51780,NULL,NULL,'Malmquist cor.','UGC 09071',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117513,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117513,32.7,0.5,34.7,51780,NULL,NULL,NULL,'UGC 09071',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117514,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117514,32.71,0.49,34.8,51780,75,NULL,'IR','UGC 09071',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117515,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117515,37.92,0.46,384,51781,70,NULL,NULL,'2MASX J14100316+0621288',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,212.5132917,6.358,0.042,NULL,58504346302,914130410,14283287,17.8),(117516,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117516,37.6,0.46,330,51782,70,NULL,NULL,'2MASX J14100347-0021210',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000091,NULL,'16.4g',0.4,NULL,NULL,NULL,NULL,NULL,1,212.5145,-0.35586,0.117,NULL,43587704960,681057890,10641529,16.4),(117517,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117517,37.82,0.46,366,51783,70,NULL,NULL,'2MASX J14100357+3401431',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.514917,34.02856,0,NULL,60036330810,938067668,14657307,18),(117518,'Tully est','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117518,32.73,0.8,35.2,51784,75,NULL,NULL,'ESO 271- G 018',NULL,'1988NBGC.C....0000T',1988,1,2,NULL,'G',0.000028,NULL,'15.30',1.2,'SBm',NULL,NULL,NULL,NULL,1,212.515375,-46.22253,0.389,NULL,46797020043,731203438,11425053,15.3),(117519,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117519,37.47,0.33,312,51785,70,NULL,NULL,'2MASX J14100386+4831468',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000148,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,212.516375,48.52961,0.03,NULL,59255745267,925871019,14466734,17.4),(117520,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117520,36.29,0.33,181,51786,70,NULL,NULL,'CGCG 295-038',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000077,NULL,'14.9g',0.65,'E0',NULL,NULL,NULL,NULL,1,212.517291667,58.03939,0,NULL,57304001471,895375022,13990234,14.9),(117521,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117521,37.82,0.33,367,51787,70,NULL,NULL,'2MASX J14100418+4145208',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000198,NULL,'15.8g',0.5,'BrClG',NULL,NULL,NULL,NULL,1,212.517458333,41.75581,0,NULL,59227014345,925422099,14459720,15.8),(117522,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117522,37.38,0.46,299,51788,70,NULL,NULL,'2MASX J14100416+2356236',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,212.5175,23.94011,0,NULL,59468716734,929198698,14518729,17.6),(117523,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117523,37.82,0.33,367,51789,70,NULL,NULL,'SDSS J141004.51+414355.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000163,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,212.518833,41.73203,0,NULL,59227027657,925422307,14459723,18.5),(117524,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117524,37.47,0.33,312,51790,70,NULL,NULL,'SDSS J141004.74+482321.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000134,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,212.5197917,48.38933,0.03,NULL,59255730393,925870787,14466731,18.1),(117525,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117525,37.43,0.46,306,51791,70,NULL,NULL,'LCRS B140729.9-024441',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000127,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,212.52225,-2.98,0.157,NULL,43722884805,683170075,10674532,16.9),(117526,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117526,37.99,0.46,396,51792,70,NULL,NULL,'SDSS J141005.99+241411.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000131,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.524958333,24.23644,0,NULL,59468908717,929201698,14518776,18.1),(117527,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117527,38.16,0.46,429,51793,70,NULL,NULL,'2MASX J14100609+0429480',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000087,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,212.5255417,4.49675,0.033,NULL,58485115284,913829926,14278592,17.7),(117528,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117528,38.4,0.46,479,51794,70,NULL,NULL,'2MASX J14100681-0021590',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000089,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,212.52825,-0.36631,0.117,NULL,43587705168,681057893,10641529,18.5),(117529,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117529,34.87,0.49,94.2,51795,75,NULL,'IR','UGC 09066',NULL,'2011yCatp016004901K',2011,1,1.68,NULL,'G',0.000093,NULL,'15.9g',0.18,'Sd',NULL,NULL,NULL,NULL,1,212.529625,46.43953,0.01,NULL,59234284001,925535687,14461495,15.9),(117530,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117530,34.93,NULL,96.6,51795,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09066',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117531,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117531,34.94,NULL,97.3,51795,NULL,NULL,'Dipole + Quadrupole','UGC 09066',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117532,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117532,34.95,NULL,97.6,51795,NULL,NULL,'Dipole','UGC 09066',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117533,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117533,34.98,NULL,99,51795,NULL,NULL,NULL,'UGC 09066',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117534,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117534,33.7,0.49,54.9,51796,75,NULL,'IR','IC 0984',NULL,'2011yCatp016004901K',2011,1,0.79,'HOLM 596B is a star.','G',0.00003,NULL,'14.2g',0.5,'Sb','in a radial-velocity based grouping',NULL,NULL,NULL,1,212.532333333,18.36467,0,NULL,59517254720,929957105,14530579,14.2),(117535,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117535,33.77,0.4,56.7,51796,NULL,NULL,NULL,'IC 0984',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117536,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117536,33.81,0.2,57.8,51796,74.4,NULL,NULL,'IC 0984',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117537,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117537,33.98,0.47,62.6,51796,NULL,NULL,'H','IC 0984',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117538,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117538,33.99,0.36,62.9,51796,NULL,NULL,'Malmquist cor.','IC 0984',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117539,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117539,34.08,0.46,65.4,51796,NULL,NULL,'J','IC 0984',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117540,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117540,34.1,0.45,66.1,51796,NULL,NULL,'K','IC 0984',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117541,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117541,34.44,0.4,77.1,51796,NULL,NULL,'mean','IC 0984',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117542,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117542,38.05,0.33,407,51797,70,NULL,NULL,'2MASX J14100839+3214132',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000187,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.534875,32.23706,0,NULL,60034653453,938041460,14656897,18.1),(117543,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117543,35.38,0.49,119,51798,75,NULL,'IR','CGCG 074-127',NULL,'2011yCatp016004901K',2011,1,0.87,NULL,'G',0.000105,NULL,'15.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,212.54175,11.93436,0,NULL,58492611523,913947055,14280422,15.7),(117544,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117544,35.55,0.2,129,51799,74.4,NULL,NULL,'CGCG 074-127',NULL,'2013AJ....146...86T',2013,1,0.87,NULL,'G',0.000105,NULL,'15.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,212.54175,11.93436,0,NULL,58492611523,913947055,14280422,15.7),(117545,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117545,37.89,0.46,378,51800,70,NULL,NULL,'2MASX J14101021+1313325',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,212.54275,13.22558,0,NULL,58365417418,911959647,14249369,17.5),(117546,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117546,35.96,0.46,156,51801,70,NULL,NULL,'2MASX J14101058+5707596',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000174,NULL,'15.8g',0.43,'E',NULL,NULL,NULL,NULL,1,212.543917,57.13317,0,NULL,57307247292,895425738,13991027,15.8),(117547,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117547,37.93,0.46,386,51802,70,NULL,NULL,'2MASX J14101095+0818448',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,':','17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,212.545583,8.31239,0.011,NULL,58503596811,914118700,14283104,17.3),(117548,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117548,35.25,0.5,112,51803,70,NULL,NULL,'FAIRALL 0475',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,212.552166667,-47.54908,0.733,NULL,46838963433,731858803,11435293,16.2),(117549,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117549,32.13,0.4,26.6,51804,75,NULL,'B','UGC 09057',NULL,'1988NBGC.C....0000T',1988,1,2.4,'Diameter includes companions or long extensions.','G',0.000017,NULL,'14.5g',0.55,'SB(rs)d?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,212.553708333,-2.57581,0.217,NULL,43722831814,683169247,10674519,14.5),(117550,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117550,32.13,NULL,26.7,51804,72,NULL,NULL,'UGC 09057',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117551,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117551,32.24,0.2,28.1,51804,74.4,NULL,NULL,'UGC 09057',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117552,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117552,32.34,0.43,29.4,51804,75,NULL,'3.6 micron, color corrected','UGC 09057',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117553,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117553,32.42,0.43,30.5,51804,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09057',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117554,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117554,32.87,0.2,37.5,51805,74.4,NULL,NULL,'UGC 09068',NULL,'2013AJ....146...86T',2013,1,0.71,NULL,'G',0.00002,NULL,'15.8g',0.58,'SAdm',NULL,NULL,NULL,NULL,1,212.5550417,48.31775,0.03,NULL,59255733023,925870828,14466731,15.8),(117555,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117555,37.12,0.46,266,51806,70,NULL,NULL,'2MASX J14101364+3723488',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000176,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,212.556791667,37.39692,0,NULL,60030483442,937976303,14655879,17.3),(117556,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117556,37.75,0.46,354,51807,70,NULL,NULL,'SDSS J141014.78+262031.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000164,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.561625,26.342,0,NULL,60002912637,937545509,14649148,18),(117557,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117557,37.5,0.46,316,51808,70,NULL,NULL,'2MASX J14101544+1938384',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.30',0.17,NULL,NULL,NULL,NULL,NULL,1,212.564417,19.64397,0.054,NULL,59517763268,929965051,14530703,18.3),(117558,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117558,39.76,0.46,894,51809,70,NULL,NULL,'SDSS J141015.65+234127.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000134,NULL,'18.7g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.56525,23.69106,0.007,NULL,59468262830,929191606,14518618,18.7),(117559,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117559,36.68,0.27,217,51810,70,NULL,NULL,'2MASX J14101729+5451136',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000176,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,212.5719583,54.85367,0.013,NULL,57298836698,895294323,13988973,17.1),(117560,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117560,36.97,0.46,248,51811,70,NULL,NULL,'2MASX J14101790+6237033',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000195,NULL,'16.1g',0.35,'E0',NULL,NULL,NULL,NULL,1,212.5745417,62.61756,0.029,NULL,57750408522,902350133,14099220,16.1),(117561,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117561,36.71,0.46,220,51812,70,NULL,NULL,'2MASX J14101851+1300554',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000178,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,212.577208333,13.0155,0.007,NULL,58361003890,911890685,14248291,16.3),(117562,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117562,37.59,0.33,330,51813,70,NULL,NULL,'SDSS J141019.66+531754.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,212.581917,53.29839,0,NULL,59248924880,925764451,14465069,18.2),(117563,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117563,36.82,0.33,231,51814,70,NULL,NULL,'2MASX J14102058+6422043',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000095,NULL,'15.6g',0.45,'BrClG          NLAGN',NULL,NULL,NULL,NULL,1,212.585625,64.36792,0.021,NULL,57935035621,905234931,14144295,15.6),(117564,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117564,37.86,0.46,374,51815,70,NULL,NULL,'2MASX J14102136+3632407',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000158,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.588833,36.54458,0,NULL,60030796872,937981201,14655956,17.9),(117565,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117565,37.49,0.46,315,51816,70,NULL,NULL,'2MASX J14102250+2918036',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00018,NULL,'16.72',0.15,NULL,NULL,NULL,NULL,NULL,1,212.593625,29.30108,0,NULL,60051075379,938298052,14660907,16.72),(117566,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117566,34.69,0.49,86.7,51817,75,NULL,'IR','UGC 09064',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000033,NULL,'15.71',0.2,'Sb',NULL,NULL,NULL,NULL,1,212.595625,16.33583,0,NULL,58358908540,911857945,14247780,15.71),(117567,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117567,37.19,0.46,274,51818,70,NULL,NULL,'2MASX J14102406+2119564',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,212.600166667,21.33244,0.036,NULL,59464622990,929134734,14517730,17.8),(117568,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117568,31.96,0.4,24.7,51819,75,NULL,'B','NGC 5483',NULL,'1988NBGC.C....0000T',1988,1,3.7,'Extended HIPASS source','G',0.000007,NULL,'11.93',3.4,'SB(s)c pec',NULL,NULL,NULL,NULL,1,212.604291667,-43.32461,0.273,NULL,46806971992,731358937,11427483,11.93),(117569,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117569,36.87,0.46,236,51820,70,NULL,NULL,'VIII Zw 372',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000078,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,212.610333,0.44408,0.053,NULL,58402188235,912534191,14258346,17.3),(117570,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117570,37.59,0.33,330,51821,70,NULL,NULL,'2MASX J14102659+5322067',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,212.610625,53.3685,0,NULL,59248932141,925764564,14465071,17.1),(117571,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117571,37.66,0.46,341,51822,70,NULL,NULL,'2MASX J14102724+5721574',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,212.613125,57.36603,0,NULL,57307086547,895423227,13990987,17.5),(117572,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117572,37.59,0.17,329,51823,70,NULL,NULL,'2MASX J14102785+2613079',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,212.61625,26.21892,0,NULL,60002917120,937545580,14649149,17.6),(117573,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117573,35.87,0.46,149,51824,70,NULL,NULL,'MCG +10-20-081',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000176,NULL,'15.4g',0.5,'E0',NULL,NULL,NULL,NULL,1,212.619875,59.25972,0.005,NULL,57271463651,894866619,13982290,15.4),(117574,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117574,36.64,0.56,212,51825,70,NULL,NULL,'ESO 271- G 020',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'15.5',1,'S              WLRG',NULL,NULL,NULL,NULL,1,212.620375,-42.78211,0.249,NULL,46793176093,731143376,11424115,15.5),(117575,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117575,36.68,0.27,217,51826,70,NULL,NULL,'2MASX J14103050+5449274',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000183,NULL,'15.8g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,212.62725,54.82422,0.013,NULL,57298790601,895293603,13988962,15.8),(117576,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117576,37.2,0.46,275,51827,70,NULL,NULL,'2MASX J14103079+2116024',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.31',0.14,NULL,NULL,NULL,NULL,NULL,1,212.628291667,21.26733,0.031,NULL,59464651576,929135180,14517737,18.31),(117577,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117577,36.76,0.21,225,51828,70,NULL,NULL,'2MASX J14103087+1908564',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.62',0.16,NULL,NULL,NULL,NULL,NULL,1,212.628625,19.14894,0.053,NULL,59517894935,929967108,14530736,18.62),(117578,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117578,38.28,0.46,453,51829,70,NULL,NULL,'2MASX J14103146+1115333',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,212.631208333,11.25919,0,NULL,58492373106,913943329,14280364,17.7),(117579,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117579,38.07,0.46,412,51830,70,NULL,NULL,'2MASX J14103225+0038119',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.0001,NULL,'17.0g',0.31,NULL,NULL,NULL,NULL,NULL,1,212.634458333,0.63653,0.081,NULL,58402335669,912536494,14258382,17),(117580,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117580,38.05,0.46,408,51831,70,NULL,NULL,'SDSS J141032.35+044649.5',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000087,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,212.634833,4.78044,0.009,NULL,58481880137,913779377,14277802,17.6),(117581,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117581,38.09,0.23,415,51832,70,NULL,NULL,'2MASX J14103263+0844333',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000181,NULL,'18.03',0.17,NULL,NULL,NULL,NULL,NULL,1,212.635916667,8.74256,0,NULL,58503434026,914116156,14283064,18.03),(117582,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117582,36.76,0.21,225,51833,70,NULL,NULL,'2MASX J14103306+1909294',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.39',0.29,NULL,NULL,NULL,NULL,NULL,1,212.6377917,19.15808,0.053,NULL,59517898247,929967160,14530736,17.39),(117583,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117583,36.96,0.46,246,51834,70,NULL,NULL,'2MASX J14103320+2531239',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,212.638458333,25.52322,0,NULL,60002412403,937537693,14649026,16.9),(117584,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117584,38.06,0.46,410,51835,70,NULL,NULL,'2MASX J14103396+4045178',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,212.64175,40.755,0,NULL,59257541801,925899090,14467173,18.4),(117585,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117585,37.32,0.46,291,51836,70,NULL,NULL,'2MASX J14103470+5127528',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000169,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,212.644333,51.46461,0.009,NULL,59252848595,925825759,14466027,16.6),(117586,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117586,37.26,0.46,284,51837,70,NULL,NULL,'2MASX J14103467+3758308',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000192,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,212.644375,37.97533,0,NULL,59140226969,924066046,14438531,16.6),(117587,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117587,33.12,0.4,42.1,51838,NULL,NULL,'mean','NGC 5492',NULL,'2007A&A...465...71T',2007,1,2.4,NULL,'G',0.00002,NULL,'13.63',0.7,'Sb pec?','Field galaxy',NULL,NULL,NULL,1,212.646667,19.61233,0.037,NULL,59517761542,929965024,14530703,13.63),(117588,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117588,33.41,0.47,48.1,51838,NULL,NULL,'H','NGC 5492',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117589,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117589,33.44,0.46,48.8,51838,NULL,NULL,'J','NGC 5492',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117590,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117590,33.51,0.45,50.2,51838,NULL,NULL,'K','NGC 5492',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117591,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117591,33.78,0.49,57,51838,75,NULL,'IR','NGC 5492',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117592,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117592,37.35,0.46,295,51839,70,NULL,NULL,'2MASX J14103526+3909508',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000143,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,212.647,39.16406,0,NULL,59140645936,924072592,14438634,17.4),(117593,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117593,37.68,0.46,344,51840,70,NULL,NULL,'2MASX J14103585+2402459',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00014,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.649333,24.04614,0,NULL,59468739473,929199054,14518735,17.8),(117594,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117594,32.97,NULL,39.2,51841,NULL,NULL,NULL,'UGC 09080',NULL,'2000BSAO...50....5K',2000,1,1.66,NULL,'G',0.000123,NULL,'15.3g',0.26,'Sb(f)',NULL,NULL,NULL,NULL,1,212.649625,59.35797,0.005,NULL,57272579187,894884049,13982563,15.3),(117595,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117595,33.05,NULL,40.7,51841,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09080',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117596,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117596,33.08,NULL,41.4,51841,NULL,NULL,'Dipole + Quadrupole','UGC 09080',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117597,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117597,33.1,NULL,41.7,51841,NULL,NULL,'Dipole','UGC 09080',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117598,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117598,36.62,0.33,211,51842,70,NULL,NULL,'2MASX J14103632+2339114',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,212.651291667,23.65303,0.007,NULL,59468266890,929191670,14518619,16.9),(117599,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117599,38.36,0.46,470,51843,70,NULL,NULL,'SDSS J141038.32+092930.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.3g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.659708333,9.49172,0.017,NULL,58490649351,913916396,14279943,18.3),(117600,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117600,37.59,0.17,329,51844,70,NULL,NULL,'2MASX J14103894+2556290',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,212.6625,25.94128,0,NULL,60002792021,937543625,14649119,17.6),(117601,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117601,38.11,0.46,418,51845,70,NULL,NULL,'SDSS J141039.16+103838.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000169,NULL,'18.3g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.663208333,10.64397,0,NULL,58490899700,913920307,14280004,18.3),(117602,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117602,38.05,0.33,407,51846,70,NULL,NULL,'2MASX J14103922+3215171',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000169,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.663333,32.25492,0,NULL,60034671041,938041735,14656902,17.7),(117603,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:35','1','PS1 SN PS10kv','N',117603,42.52,0.15,2090,51847,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10kv HOST',0.5304,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117604,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117604,37.78,0.46,360,51848,70,NULL,NULL,'2MASX J14103937+1324195',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000179,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,212.6642083,13.40547,0,NULL,58365524608,911961322,14249395,17.2),(117605,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117605,34.46,0.46,78.2,51849,70,NULL,NULL,'2MASX J14103977-0241003',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000027,NULL,'14.8g',0.5,'SABa',NULL,NULL,NULL,NULL,1,212.665625,-2.68353,0.113,NULL,43722969430,683171397,10674553,14.8),(117606,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117606,37.93,0.46,385,51850,70,NULL,NULL,'2MASX J14103978+6610359',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000075,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.665708333,66.17692,0.037,NULL,57942144852,905346013,14146031,17.8),(117607,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117607,36.53,0.46,202,51851,70,NULL,NULL,'2MASX J14104105+3510181',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000167,NULL,'15.9g',0.44,NULL,NULL,NULL,NULL,NULL,1,212.670875,35.17172,0,NULL,60044486762,938195105,14659298,15.9),(117608,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117608,31.79,0.43,22.8,51852,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 074-129',NULL,'2014MNRAS.444..527S',2014,1,0.82,NULL,'G',0.000117,NULL,'15.0g',0.53,'Sy2',NULL,NULL,NULL,'LINER',1,212.6722917,13.558,0,NULL,58365496464,911960882,14249388,15),(117609,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117609,32.29,0.43,28.8,51852,75,NULL,'3.6 micron, color corrected','CGCG 074-129',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117610,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117610,38.4,0.46,479,51853,70,NULL,NULL,'2MASX J14104175+0808453',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,212.673875,8.14608,0.014,NULL,58503634292,914119285,14283113,17.3),(117611,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117611,36.39,0.46,189,51854,70,NULL,NULL,'SDSS J141042.08+215724.4',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',NULL,NULL,'14.9g',0.52,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.675375,21.95681,0.032,NULL,59472023291,929250363,14519536,14.9),(117612,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117612,37.62,0.23,335,51855,70,NULL,NULL,'2MASX J14104302+5228248',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000143,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,212.679083333,52.47369,0,NULL,59249450065,925772657,14465197,18.1),(117613,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117613,36.62,0.33,211,51856,70,NULL,NULL,'2MASX J14104339+2338446',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000192,NULL,'16.52',0.26,NULL,NULL,NULL,NULL,NULL,1,212.680916667,23.64575,0.007,NULL,59468266421,929191662,14518619,16.52),(117614,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117614,37.58,0.46,327,51857,70,NULL,NULL,'2MASX J14104343+5831035',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000177,NULL,'16.7g',0.27,'AGN',NULL,NULL,NULL,NULL,1,212.681125,58.51753,0,NULL,57304358282,895380598,13990321,16.7),(117615,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117615,38.15,0.46,426,51858,70,NULL,NULL,'2MASX J14104405+6242021',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000175,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,212.683416667,62.70058,0.029,NULL,57750416975,902350265,14099222,17.5),(117616,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117616,38.09,0.23,415,51859,70,NULL,NULL,'2MASX J14104423+0854213',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000183,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,212.6842083,8.90581,0.006,NULL,58503259961,914113436,14283022,17.2),(117617,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117617,35.51,0.48,127,51860,70,NULL,NULL,'LCRS B140807.3-054511',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00011,NULL,'15.46',0.46,NULL,NULL,NULL,NULL,NULL,1,212.686417,-5.9885,0.061,NULL,43731981542,683312211,10676753,15.46),(117618,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117618,34.97,0.2,98.6,51861,74.4,NULL,NULL,'UGC 09067',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000007,NULL,'14.42',0.7,'Sab',NULL,NULL,NULL,NULL,1,212.689417,15.20942,0,NULL,58366138601,911970915,14249545,14.42),(117619,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117619,35.31,0.4,115,51861,NULL,NULL,'mean','UGC 09067',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117620,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117620,35.46,0.47,124,51861,NULL,NULL,'H','UGC 09067',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117621,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117621,35.56,0.45,130,51861,NULL,NULL,'K','UGC 09067',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117622,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117622,37.85,0.46,371,51862,70,NULL,NULL,'2MASX J14104597+0545389',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,212.6915417,5.76083,0.069,NULL,58474008373,913656380,14275880,17.4),(117623,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117623,36.71,0.46,219,51863,70,NULL,NULL,'2MASX J14104713+5900195',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00016,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,212.696833,59.00536,0,NULL,57271632915,894869264,13982332,17),(117624,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117624,37.17,0.46,272,51864,70,NULL,NULL,'2MASX J14104759+4336270',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000176,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,212.698417,43.60753,0,NULL,59237720037,925589375,14462333,16.4),(117625,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117625,37.81,0.46,365,51865,70,NULL,NULL,'2MASX J14104821+0851363',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000195,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,212.701,8.86022,0,NULL,58503222280,914112848,14283013,16.9),(117626,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117626,36.55,0.46,205,51866,70,NULL,NULL,'2MASX J14104913+4836288',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000173,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,212.704625,48.608,0.046,NULL,59255686436,925870100,14466720,16.5),(117627,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117627,36.97,0.74,248,51867,70,NULL,NULL,'2MASX J14104930-2912086',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.3b',NULL,'S0',NULL,NULL,NULL,NULL,1,212.705333,-29.20244,0.177,NULL,47037230544,734956727,11483698,16.3),(117628,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117628,39.03,0.46,640,51868,70,NULL,NULL,'SDSS J141049.31+404509.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000136,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,212.7055,40.75272,0,NULL,59257578637,925899666,14467182,18.5),(117629,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117629,37.71,0.46,348,51869,70,NULL,NULL,'2MASX J14104958+1256419',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00014,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.7067083,12.94497,0,NULL,58364920749,911951886,14249248,18.1),(117630,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117630,36.94,0.46,244,51870,70,NULL,NULL,'2MASX J14105036+1903186',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000137,NULL,'16.92',0.42,NULL,NULL,NULL,NULL,NULL,1,212.709917,19.05519,0.006,NULL,59517977916,929968404,14530756,16.92),(117631,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117631,36.59,0.46,208,51871,70,NULL,NULL,'2MASX J14105152+2130496',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.25',0.23,NULL,NULL,NULL,NULL,NULL,1,212.7147083,21.51392,0.032,NULL,59463771012,929121422,14517522,17.25),(117632,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117632,37.52,0.33,319,51872,70,NULL,NULL,'2MASX J14105164+2444340',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000191,NULL,'18.02',0.16,NULL,NULL,NULL,NULL,NULL,1,212.715291667,24.74283,0,NULL,60002038834,937531856,14648935,18.02),(117633,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117633,37.84,0.46,369,51873,70,NULL,NULL,'2MASX J14105435+4031098',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,212.726417,40.51944,0,NULL,59258049401,925907021,14467297,17.9),(117634,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117634,35.73,0.46,140,51874,70,NULL,NULL,'CGCG 162-066',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.000077,NULL,'14.9g',0.63,NULL,NULL,NULL,NULL,NULL,1,212.7270417,26.81439,0,NULL,60000945040,937514766,14648668,14.9),(117635,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117635,36.66,0.33,215,51875,70,NULL,NULL,'2MASX J14105460+2211066',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.03',0.17,NULL,NULL,NULL,NULL,NULL,1,212.7275,22.18514,0.032,NULL,59472018883,929250295,14519535,18.03),(117636,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117636,36.76,0.21,225,51876,70,NULL,NULL,'2MASX J14105586+1902017',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'17.07',0.2,NULL,NULL,NULL,NULL,NULL,1,212.7327083,19.03392,0.006,NULL,59517991693,929968620,14530759,17.07),(117637,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117637,37.87,0.46,374,51877,70,NULL,NULL,'2MASX J14105707+4942468',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00014,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,212.73775,49.71306,0,NULL,59256815488,925887742,14466995,17.6),(117638,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117638,35.8,0.4,145,51878,NULL,NULL,'mean','NGC 5008',NULL,'2007A&A...465...71T',2007,1,1.01,NULL,'G',0.00003,NULL,'14.4g',0.83,'Scd:           AGN','Compact group member',NULL,NULL,NULL,1,212.7385,25.49722,0,NULL,60001959243,937530613,14648915,14.4),(117639,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117639,35.98,0.47,157,51878,NULL,NULL,'H','NGC 5008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117640,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117640,36.05,0.45,162,51878,NULL,NULL,'K','NGC 5008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117641,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117641,36.08,0.46,164,51878,NULL,NULL,'J','NGC 5008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117642,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117642,34.66,0.45,85.6,51879,NULL,NULL,'K','NGC 5491',NULL,'2007A&A...465...71T',2007,1,1.4,'HOLM 596C is a star.','G',0.00003,NULL,'13.80',0.8,'S?             HII','Possible field galaxy',NULL,NULL,NULL,1,212.7389583,6.36486,0.033,NULL,58505229511,914144211,14283503,13.8),(117643,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117643,34.67,0.47,85.8,51879,NULL,NULL,'H','NGC 5491',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117644,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117644,34.68,0.4,86.2,51879,NULL,NULL,'mean','NGC 5491',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117645,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117645,34.69,0.46,86.6,51879,NULL,NULL,'J','NGC 5491',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117646,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117646,34.93,0.41,97,51879,NULL,NULL,'Malmquist cor.','NGC 5491',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117647,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117647,35.03,0.39,102,51879,NULL,NULL,NULL,'NGC 5491',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117648,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117648,35.07,0.2,103,51879,74.4,NULL,NULL,'NGC 5491',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117649,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117649,36.68,0.15,217,51880,70,NULL,NULL,'2MASX J14105893+2501032',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.70',0.19,NULL,NULL,NULL,NULL,NULL,1,212.7454583,25.01758,0.008,NULL,60002135999,937533374,14648958,17.7),(117650,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117650,37.11,0.33,264,51881,70,NULL,NULL,'2MASX J14105901+1809207',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.27',0.29,NULL,NULL,NULL,NULL,NULL,1,212.746,18.15569,0,NULL,59484483180,929445049,14522578,17.27),(117651,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117651,37.17,0.46,272,51882,70,NULL,NULL,'2MASX J14105927+2726232',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,212.747083,27.43972,0,NULL,60001541176,937524080,14648813,17.3),(117652,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117652,37.59,0.17,329,51883,70,NULL,NULL,'2MASX J14105957+2559252',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000208,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,212.748166667,25.99039,0,NULL,60002789206,937543581,14649118,16.6),(117653,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117653,37.35,0.46,295,51884,70,NULL,NULL,'LCRS B140824.8-022409',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00015,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,212.750333,-2.63736,0.121,NULL,43722847359,683169489,10674523,16.8),(117654,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117654,37.93,0.46,385,51885,70,NULL,NULL,'SDSS J141100.41+005608.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000077,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,212.75175,0.93575,0.065,NULL,58401958826,912530606,14258290,18.3),(117655,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117655,37.52,0.33,319,51886,70,NULL,NULL,'2MASX J14110079+2444192',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000167,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,212.7532083,24.73872,0,NULL,60002028422,937531694,14648932,17),(117656,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117656,37.24,0.27,281,51887,70,NULL,NULL,'2MASX J14110145+3020461',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000103,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,212.756,30.34617,0,NULL,60051240184,938300627,14660947,17.7),(117657,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117657,36.66,0.33,215,51888,70,NULL,NULL,'2MASX J14110244+2210376',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.97',0.18,NULL,NULL,NULL,NULL,NULL,1,212.7604583,22.17722,0.032,NULL,59472008507,929250132,14519533,17.97),(117658,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117658,37.6,0.46,331,51889,70,NULL,NULL,'2MASX J14110581+4109202',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000158,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,212.7744583,41.15567,0,NULL,59224338071,925380282,14459066,17.1),(117659,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117659,37.59,0.46,330,51890,70,NULL,NULL,'SDSS J141105.91+024100.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000071,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,212.774625,2.68342,0.041,NULL,58471436190,913616190,14275252,17.8),(117660,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117660,37.36,0.21,296,51891,70,NULL,NULL,'2MASX J14110734+5302307',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,212.780583,53.04189,0,NULL,59249644871,925775701,14465245,17),(117661,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117661,37.47,0.46,311,51892,70,NULL,NULL,'2MASX J14110782+0656194',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000164,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,212.782667,6.93869,0.039,NULL,58504917217,914139331,14283427,16.7),(117662,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117662,37.21,0.46,277,51893,70,NULL,NULL,'2MASX J14110822+2415272',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.784375,24.25756,0,NULL,59468592028,929196750,14518699,17.6),(117663,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117663,34.02,0.49,63.8,51894,70,NULL,NULL,'ESO 326-IG 006',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.00015,NULL,'15.0',0.7,'N',NULL,NULL,NULL,NULL,1,212.785083,-40.10533,0.093,NULL,46909260430,732957194,11452456,15),(117664,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117664,36.82,0.33,231,51895,70,NULL,NULL,'2MASX J14110910+6417429',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000087,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,212.7877917,64.29542,0.013,NULL,57933141369,905205333,14143833,16.4),(117665,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117665,37.42,0.46,305,51896,70,NULL,NULL,'2MASX J14110906+2625522',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000165,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,212.787875,26.43133,0,NULL,60002845196,937544456,14649132,18),(117666,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117666,35.5,0.53,126,51897,70,NULL,NULL,'2MASX J14110975-2752528',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'16.2b',NULL,'S0',NULL,NULL,NULL,NULL,1,212.790583,-27.88142,0.145,NULL,46986913776,734170527,11471414,16.2),(117667,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117667,35.53,0.46,128,51898,70,NULL,NULL,'2MASX J14110981+2601332',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000167,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,212.790708333,26.02578,0,NULL,60002757219,937543081,14649110,16.3),(117668,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117668,37.42,0.33,305,51899,70,NULL,NULL,'2MASX J14110983+5715324',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,212.790833,57.25911,0,NULL,57307259944,895425936,13991030,17.1),(117669,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117669,35.12,0.5,106,51900,70,NULL,NULL,'2MASX J14111154-2859478',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,212.7980417,-28.99653,0.141,NULL,47037268912,734957326,11483708,14.6),(117670,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117670,37.59,0.46,329,51901,70,NULL,NULL,'2MASX J14111171+4444410',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,212.798875,44.74469,0,NULL,59240028565,925625446,14462897,18),(117671,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117671,37.78,0.46,360,51902,70,NULL,NULL,'2MASX J14111209+0532187',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000146,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,212.800625,5.53836,0.021,NULL,58474802626,913668791,14276074,17.4),(117672,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117672,34.75,0.2,89.1,51903,74.4,NULL,NULL,'CGCG 074-130',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000093,NULL,'16.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,212.805791667,11.3725,0,NULL,58492273844,913941778,14280340,16.3),(117673,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117673,38.05,0.46,408,51904,70,NULL,NULL,'2MASX J14111349+4012373',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000185,NULL,'17.0g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,212.806166667,40.21044,0,NULL,59257218082,925894032,14467094,17),(117674,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117674,37.23,0.59,280,51905,70,NULL,NULL,'AM 1408-271',NULL,'2014MNRAS.445.2677S',2014,1,0.1,NULL,'G',0.000103,NULL,'15.5R',NULL,'COMPACT',NULL,NULL,NULL,NULL,1,212.808125,-27.55781,0.177,NULL,46986860860,734169700,11471401,15.5),(117675,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117675,36.76,0.21,225,51906,70,NULL,NULL,'CGCG 103-110 NED01',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000123,NULL,'16.49',0.27,NULL,NULL,NULL,NULL,NULL,1,212.811667,19.18361,0,NULL,59517867996,929966687,14530729,16.49),(117676,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117676,37.11,0.33,264,51907,70,NULL,NULL,'2MASX J14111569+1819576',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.14',0.16,NULL,NULL,NULL,NULL,NULL,1,212.815333,18.33272,0,NULL,59517573256,929962082,14530657,18.14),(117677,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117677,38.39,0.33,476,51908,70,NULL,NULL,'2MASX J14111587+5736088',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00017,NULL,'16.4g',0.36,'BrClG',NULL,NULL,NULL,NULL,1,212.81625,57.6025,0,NULL,57305256473,895394632,13990541,16.4),(117678,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117678,37.5,0.46,316,51909,70,NULL,NULL,'2MASX J14111629-0057352',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000069,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.817791667,-0.95978,0.121,NULL,43587981679,681062213,10641597,17.9),(117679,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117679,34.73,0.4,88.2,51910,NULL,NULL,'Malmquist cor.','ESO 511- G 007',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15',0.4,'Sb             HII',NULL,NULL,NULL,NULL,1,212.821916667,-25.03639,0.269,NULL,46986427468,734162929,11471295,15),(117680,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117680,34.78,0.39,90.4,51910,NULL,NULL,NULL,'ESO 511- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117681,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117681,34.82,0.2,92,51910,74.4,NULL,NULL,'ESO 511- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117682,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117682,34.86,0.47,93.9,51910,NULL,NULL,'H','ESO 511- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117683,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117683,34.99,0.4,99.7,51910,NULL,NULL,'mean','ESO 511- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117684,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117684,35.02,0.45,101,51910,NULL,NULL,'K','ESO 511- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117685,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117685,35.07,0.46,103,51910,NULL,NULL,'J','ESO 511- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117686,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117686,37.01,0.46,253,51911,70,NULL,NULL,'2MASX J14111756+0705214',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000086,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,212.823,7.08914,0.039,NULL,58505420679,914147198,14283549,17.1),(117687,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117687,34.9,0.33,95.4,51912,70,NULL,NULL,'MRK 1374',NULL,'2015arXiv151105856S',2015,1,0.6,'Foreground star 18\\\" to the east.','G',0.000069,NULL,'15.3g',0.33,'NLAGN',NULL,NULL,NULL,NULL,1,212.823833333,1.27528,0.049,NULL,58469147909,913580436,14274694,15.3),(117688,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117688,33.9,0.2,60.3,51913,74.4,NULL,NULL,'UGC 09078',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000033,NULL,'14.10',1.1,'(R\')SB(s)a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,212.824417,17.50644,0,NULL,59483965661,929436963,14522452,14.1),(117689,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117689,34.31,0.4,72.7,51913,NULL,NULL,'mean','UGC 09078',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117690,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117690,34.44,0.47,77.2,51913,NULL,NULL,'H','UGC 09078',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117691,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117691,34.56,0.45,81.7,51913,NULL,NULL,'K','UGC 09078',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117692,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117692,34.58,0.46,82.3,51913,NULL,NULL,'J','UGC 09078',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117693,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117693,35.93,0.33,154,51914,70,NULL,NULL,'2MASX J14111792+5517169',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000174,NULL,'16.0g',0.33,'S0^-',NULL,NULL,NULL,NULL,1,212.824583,55.28808,0.005,NULL,57298674106,895291782,13988934,16),(117694,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117694,37.84,0.46,370,51915,70,NULL,NULL,'SDSS J141118.33+232544.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.36',0.18,NULL,NULL,NULL,NULL,NULL,1,212.826417,23.42903,0.028,NULL,59470206901,929221982,14519093,18.36),(117695,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117695,35.13,0.48,106,51916,70,NULL,NULL,'2MASX J14111849-2744058',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'16.3b',NULL,'S0',NULL,NULL,NULL,NULL,1,212.827083,-27.73492,0.189,NULL,46986863326,734169739,11471402,16.3),(117696,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117696,37.85,0.46,371,51917,70,NULL,NULL,'2MASX J14111958+0626544',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,212.831667,6.44839,0.037,NULL,58505184000,914143500,14283492,17.4),(117697,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117697,37.49,0.46,314,51918,70,NULL,NULL,'2MASX J14112009+2534372',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000196,NULL,'17.75',0.18,NULL,NULL,NULL,NULL,NULL,1,212.8339583,25.57697,0,NULL,60003072160,937548002,14649187,17.75),(117698,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117698,36.34,0.46,185,51919,70,NULL,NULL,'2MASX J14112433+1402036',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,212.851417,14.03442,0,NULL,58367769690,911996401,14249943,17.2),(117699,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117699,37.42,0.33,305,51920,70,NULL,NULL,'2MASX J14112458+5714559',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000175,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,212.8525417,57.24881,0,NULL,57307199930,895424998,13991015,16.6),(117700,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117700,36.43,0.53,193,51921,70,NULL,NULL,'2MASX J14112616-1957112',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.38',NULL,NULL,NULL,NULL,NULL,NULL,1,212.858875,-19.95333,0.249,NULL,46562595392,727540553,11367821,16.38),(117701,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117701,34.9,0.33,95.4,51922,70,NULL,NULL,'IC 0986',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000094,NULL,'14.4g',0.78,'S0             AGN',NULL,NULL,NULL,NULL,1,212.8592917,1.28653,0.049,NULL,58469151478,913580491,14274695,14.4),(117702,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117702,37.12,0.46,265,51923,70,NULL,NULL,'2MASX J14112636+2418142',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,212.8599583,24.30389,0,NULL,59468595666,929196807,14518700,17.5),(117703,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117703,32.52,0.4,31.9,51924,75,NULL,'B','UGC 09083',NULL,'1988NBGC.C....0000T',1988,1,0.97,NULL,'G',0.000013,NULL,'15.3g',0.58,'Sdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,212.862417,50.20906,0.02,NULL,59256642915,925885045,14466953,15.3),(117704,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117704,35.75,0.47,141,51925,NULL,NULL,'Malmquist cor.','ESO 326- G 007',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.57',0.2,'Sb-c',NULL,NULL,NULL,NULL,1,212.864083,-38.87222,0.209,NULL,46876520948,732445639,11444463,14.57),(117705,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117705,35.79,0.46,144,51925,NULL,NULL,NULL,'ESO 326- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117706,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117706,35.83,0.2,147,51925,74.4,NULL,NULL,'ESO 326- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117707,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117707,38.43,0.33,486,51926,70,NULL,NULL,'SDSS J141127.48+093601.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000165,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.864541667,9.60033,0,NULL,58498111064,914032985,14281765,18.5),(117708,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117708,36.88,0.74,237,51927,70,NULL,NULL,'2MASX J14112805-4241467',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,212.866833333,-42.69631,0.249,NULL,46793081910,731141904,11424092,15.7),(117709,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117709,38.37,0.23,472,51928,70,NULL,NULL,'2MASX J14112838+0450597',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.0001,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,212.868125,4.84997,0.013,NULL,58481943952,913780374,14277818,17.3),(117710,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117710,35.9,0.46,151,51929,70,NULL,NULL,'2MASX J14112879+3553516',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000196,NULL,'15.0g',0.65,'E0',NULL,NULL,NULL,NULL,1,212.870125,35.89775,0,NULL,60043704206,938182878,14659107,15),(117711,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117711,38.43,0.33,486,51930,70,NULL,NULL,'SDSS J141129.12+093719.8',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',NULL,'PHOT','17.7r',0.35,'BrClG',NULL,NULL,NULL,NULL,1,212.871375,9.62219,0,NULL,58498141053,914033453,14281772,17.7),(117712,'Faber-Jackson','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117712,29.58,0.65,8.24,51931,95,NULL,'Weighted Mean','NGC 5493',NULL,'1984ApJS...56...91D',1984,1,1.6,NULL,'G',0.000017,NULL,'12.27',1.3,'S0 pec sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,212.872417,-5.04361,0.073,NULL,43732548174,683321065,10676891,12.27),(117713,'Faber-Jackson','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117713,30.46,0.81,12.4,51931,55,NULL,'Visvanathan & Sandage 1979','NGC 5493',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117714,'Tully est','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117714,32.95,0.8,38.9,51931,75,NULL,'B','NGC 5493',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117715,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117715,36.68,0.15,217,51932,70,NULL,NULL,'2MASX J14112963+2450263',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.30',0.24,NULL,NULL,NULL,NULL,NULL,1,212.873417,24.84067,0,NULL,60002092842,937532700,14648948,17.3),(117716,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117716,37.75,0.27,355,51933,70,NULL,NULL,'2MASX J14113038+2810153',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000204,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,212.876583,28.17094,0,NULL,60000630606,937509853,14648591,16.6),(117717,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:35','1','PS1 SN PS10ia','N',117717,41.6,0.31,1480,51934,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10ia HOST',0.4094,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117718,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117718,38.95,0.46,617,51935,70,NULL,NULL,'SDSS J141132.00+364229.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000175,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,212.883333,36.70808,0,NULL,60030954476,937983663,14655994,18.4),(117719,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117719,38.37,0.23,472,51936,70,NULL,NULL,'2MASX J14113246+0452077',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000085,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,212.885333333,4.86883,0.013,NULL,58481947722,913780433,14277819,17.2),(117720,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117720,38.37,0.23,472,51937,70,NULL,NULL,'SDSS J141132.51+045519.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000087,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,212.8855,4.92206,0,NULL,58481938201,913780284,14277816,18),(117721,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117721,36.76,0.21,225,51938,70,NULL,NULL,'2MASX J14113272+1902456',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.63',0.21,'AGN',NULL,NULL,NULL,NULL,1,212.886291667,19.04617,0,NULL,59518020773,929969074,14530766,17.63),(117722,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117722,38.29,0.46,456,51939,70,NULL,NULL,'2MASX J14113316+2102596',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.64',0.12,NULL,NULL,NULL,NULL,NULL,1,212.88825,21.04992,0.023,NULL,59463875543,929123055,14517547,18.64),(117723,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117723,36.87,0.46,236,51940,70,NULL,NULL,'2MASX J14113355+1846086',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.07',0.17,NULL,NULL,NULL,NULL,NULL,1,212.889791667,18.76908,0,NULL,59517993681,929968651,14530760,18.07),(117724,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117724,38.15,0.46,427,51941,70,NULL,NULL,'2MASX J14113395+0715466',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,212.892875,7.25789,0.047,NULL,58505504731,914148511,14283570,17.6),(117725,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117725,36.96,0.46,247,51942,70,NULL,NULL,'2MASX J14113467+5723580',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000166,NULL,'16.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,212.894625,57.39939,0,NULL,57305220743,895394074,13990532,16.7),(117726,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117726,37.17,0.27,272,51943,70,NULL,NULL,'2MASX J14113606+2759343',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'17.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,212.9002917,27.99278,0,NULL,60000808261,937512629,14648634,17.8),(117727,'IRAS','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117727,34.83,0.8,92.7,51944,75,NULL,'MAT, I','ESO 446- G 023',NULL,'1997ApJS..109..333W',1997,1,1.88,NULL,'G',0.000027,NULL,'15.34',0.22,'Sb',NULL,NULL,NULL,NULL,1,212.9004583,-30.40192,0.289,NULL,47038189818,734971715,11483933,15.34),(117728,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117728,34.82,0.43,92,51944,75,NULL,'MAT, I, raw','ESO 446- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117729,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117729,34.84,0.49,92.7,51944,75,NULL,'IR','ESO 446- G 023',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117730,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117730,34.9,NULL,95.4,51944,NULL,NULL,NULL,'ESO 446- G 023',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117731,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117731,35.05,0.43,102,51944,75,NULL,'MAT, I, cor','ESO 446- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117732,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117732,35.08,0.4,104,51944,NULL,NULL,'mean','ESO 446- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117733,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117733,35.1,0.43,105,51944,75,NULL,'MAT, I, inv','ESO 446- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117734,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117734,35.12,0.32,106,51944,85,NULL,'I, raw','ESO 446- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117735,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117735,35.14,0.47,107,51944,NULL,NULL,'H','ESO 446- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117736,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117736,35.19,0.32,109,51944,85,NULL,'I, inv','ESO 446- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117737,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117737,35.21,NULL,110,51944,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 446- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117738,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117738,35.23,NULL,111,51944,NULL,NULL,'Dipole + Quadrupole','ESO 446- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117739,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117739,35.26,NULL,113,51944,NULL,NULL,'Dipole','ESO 446- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117740,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117740,35.28,0.45,114,51944,NULL,NULL,'K','ESO 446- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117741,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117741,35.29,0.2,114,51944,74.4,NULL,NULL,'ESO 446- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117742,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117742,35.3,0.43,115,51944,75,NULL,'3.6 micron, color corrected','ESO 446- G 023',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117743,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117743,35.33,0.46,116,51944,NULL,NULL,'J','ESO 446- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117744,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117744,35.41,0.5,121,51944,NULL,NULL,'Malmquist cor.','ESO 446- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117745,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117745,35.48,0.43,125,51944,75,NULL,'3.6 micron, color + selection bias corrected','ESO 446- G 023',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117746,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117746,35.52,0.48,127,51944,NULL,NULL,NULL,'ESO 446- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117747,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117747,35.12,0.33,106,51945,70,NULL,NULL,'CGCG 074-132',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000093,NULL,'15.4',0.3,NULL,NULL,NULL,NULL,NULL,1,212.901167,8.80972,0,NULL,58503237203,914113081,14283016,15.4),(117748,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117748,36.68,0.15,217,51946,70,NULL,NULL,'2MASX J14113647+2445504',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00016,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,212.9020417,24.76408,0,NULL,60001911587,937529868,14648904,16.6),(117749,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117749,37.78,0.33,360,51947,70,NULL,NULL,'2MASX J14113655+5413429',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00017,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,212.9025417,54.22856,0,NULL,57252495155,894570236,13977659,16.7),(117750,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117750,37.75,0.27,355,51948,70,NULL,NULL,'2MASX J14113696+2805093',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,212.903916667,28.08594,0,NULL,60000588033,937509188,14648581,18),(117751,'IRAS','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117751,31.88,0.8,23.7,51949,75,NULL,'MAT, I','NGC 5496',NULL,'1997ApJS..109..333W',1997,1,5.49,NULL,'G',0.000007,NULL,'12.7B',0.73,'SBcd','Isolated galaxy',NULL,NULL,NULL,1,212.90775,-1.15911,0.157,NULL,43721900370,683154693,10674292,12.7),(117752,'IRAS','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117752,31.88,0.8,23.8,51949,75,NULL,'A82, H','NGC 5496',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117753,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117753,31.43,0.4,19.3,51949,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5496',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117754,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117754,31.43,NULL,19.3,51949,NULL,NULL,NULL,'NGC 5496',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117755,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117755,31.47,NULL,19.6,51949,NULL,NULL,'Dipole','NGC 5496',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117756,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117756,31.48,NULL,19.7,51949,NULL,NULL,'Dipole + Quadrupole','NGC 5496',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117757,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117757,31.48,NULL,19.8,51949,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 5496',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117758,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117758,31.5,0.54,20,51949,NULL,NULL,'Malmquist cor.','NGC 5496',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117759,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117759,31.51,0.2,20,51949,74.4,NULL,NULL,'NGC 5496',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117760,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117760,31.58,0.52,20.7,51949,NULL,NULL,NULL,'NGC 5496',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117761,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117761,31.58,0.32,20.7,51949,85,NULL,'I, raw','NGC 5496',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117762,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117762,31.58,0.32,20.7,51949,85,NULL,'I, inv','NGC 5496',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117763,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117763,31.63,0.47,21.2,51949,75,NULL,'A82, H, inv','NGC 5496',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117764,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117764,31.67,0.47,21.6,51949,75,NULL,'A82, H, raw','NGC 5496',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117765,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117765,31.68,0.38,21.7,51949,NULL,NULL,NULL,'NGC 5496',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117766,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117766,31.71,0.43,21.9,51949,75,NULL,'MAT, I, raw','NGC 5496',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117767,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117767,31.77,0.43,22.6,51949,75,NULL,'3.6 micron, color corrected','NGC 5496',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117768,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117768,31.78,0.43,22.7,51949,75,NULL,'MAT, I, inv','NGC 5496',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117769,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117769,31.91,NULL,24.1,51949,72,NULL,NULL,'NGC 5496',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117770,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117770,31.93,0.43,24.3,51949,75,NULL,'MAT, I, cor','NGC 5496',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117771,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117771,31.93,0.47,24.3,51949,75,NULL,'A82, H, cor','NGC 5496',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117772,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117772,31.97,0.43,24.8,51949,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5496',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117773,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117773,32.11,0.4,26.4,51949,75,NULL,'B','NGC 5496',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117774,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117774,32.34,0.4,29.4,51949,NULL,NULL,'mean','NGC 5496',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117775,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117775,32.67,0.46,34.2,51949,NULL,NULL,'J','NGC 5496',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117776,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117776,32.68,0.47,34.3,51949,NULL,NULL,'H','NGC 5496',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117777,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117777,32.87,0.45,37.6,51949,NULL,NULL,'K','NGC 5496',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117778,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117778,36.68,0.15,217,51950,70,NULL,NULL,'2MASX J14113806+2501034',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000187,NULL,'16.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,212.90875,25.01767,0.008,NULL,60002127498,937533242,14648956,16.4),(117779,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117779,37.16,0.46,271,51951,70,NULL,NULL,'2MASX J14113852+2556274',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000201,NULL,'15.9g',0.39,NULL,NULL,NULL,NULL,NULL,1,212.9105,25.94103,0,NULL,60003622503,937556601,14649321,15.9),(117780,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117780,38.58,0.46,520,51952,70,NULL,NULL,'2MASX J14113939+5919440',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.914375,59.32894,0,NULL,57272622138,894884720,13982573,17.7),(117781,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117781,36.68,0.15,217,51953,70,NULL,NULL,'2MASX J14113990+2504164',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000176,NULL,'16.3g',0.4,NULL,NULL,NULL,NULL,NULL,1,212.91625,25.07139,0.008,NULL,60002118546,937533102,14648954,16.3),(117782,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117782,37.83,0.46,369,51954,70,NULL,NULL,'2MASX J14114120+5813210',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,212.921791667,58.2225,0,NULL,57303957757,895374339,13990224,18),(117783,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117783,38.2,0.46,436,51955,70,NULL,NULL,'SDSS J141141.42+030609.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000081,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,212.922625,3.10264,0.053,NULL,58483804606,913809446,14278272,18.3),(117784,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117784,37.52,0.46,320,51956,70,NULL,NULL,'2MASX J14114263+0511538',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000094,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,212.9277083,5.19853,0.013,NULL,58474278293,913660598,14275946,16.8),(117785,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117785,35.7,0.66,138,51957,70,NULL,NULL,'2MASX J14114384-3425080',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.2b',NULL,'S0',NULL,NULL,NULL,NULL,1,212.932625,-34.41892,0.189,NULL,47002729731,734417652,11475275,16.2),(117786,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117786,37.47,0.46,312,51958,70,NULL,NULL,'2MASX J14114413+4123436',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,212.934041667,41.39536,0,NULL,59224313169,925379893,14459060,17),(117787,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117787,37.78,0.33,360,51959,70,NULL,NULL,'2MASX J14114452+5409309',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,212.935666667,54.1585,0.005,NULL,57252479789,894569996,13977656,17.8),(117788,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117788,37.84,0.33,369,51960,70,NULL,NULL,'2MASX J14114555+4022146',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,212.93975,40.37083,0,NULL,59257200630,925893759,14467089,17.6),(117789,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117789,37.17,0.27,272,51961,70,NULL,NULL,'2MASX J14114603+2758474',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.46',0.16,NULL,NULL,NULL,NULL,NULL,1,212.941916667,27.97986,0,NULL,60000813543,937512711,14648636,18.46),(117790,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117790,37.76,0.46,357,51962,70,NULL,NULL,'2MASX J14114708+5311415',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000175,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,212.946,53.19475,0.005,NULL,59249594189,925774909,14465232,16.8),(117791,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117791,36.48,0.67,197,51963,70,NULL,NULL,'2MASX J14114753-2149439',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,'(RL)SA0^+',NULL,NULL,NULL,NULL,1,212.9480417,-21.82897,0.221,NULL,46519276592,726863696,11357245,15.2),(117792,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117792,38.32,0.46,460,51964,70,NULL,NULL,'2MASX J14114790+6302426',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,212.9497083,63.04528,0.029,NULL,57749609622,902337650,14099025,18.2),(117793,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117793,37.73,0.46,351,51965,70,NULL,NULL,'2MASX J14114842+1247309',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000209,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,212.9517083,12.79183,0,NULL,58364971340,911952677,14249260,17.3),(117794,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117794,37.17,0.27,272,51966,70,NULL,NULL,'2MASX J14114844+2758594',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000267,NULL,'15.2g',0.55,'cD',NULL,NULL,NULL,NULL,1,212.951917,27.98325,0,NULL,60000813403,937512709,14648636,15.2),(117795,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117795,36.78,0.46,227,51967,70,NULL,NULL,'2MASX J14114869+0220248',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000092,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,212.952917,2.34028,0.093,NULL,58471836081,913622438,14275350,16.7),(117796,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117796,37.36,0.21,296,51968,70,NULL,NULL,'2MASX J14114896+5250265',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000168,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,212.954167,52.84075,0.017,NULL,59249357355,925771208,14465175,16.7),(117797,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117797,37.84,0.46,369,51969,70,NULL,NULL,'2MASX J14114917+1154307',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000139,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.955083,11.90856,0,NULL,58491923406,913936303,14280254,18.1),(117798,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117798,37.36,0.21,296,51970,70,NULL,NULL,'SBS 1410+530',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000189,NULL,'15.6g',0.48,'BrClG',NULL,NULL,NULL,NULL,1,212.956,52.81672,0.017,NULL,59249351196,925771112,14465173,15.6),(117799,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117799,38.02,0.46,402,51971,70,NULL,NULL,'2MASX J14114959+0517448',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00009,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,212.956583333,5.29583,0.021,NULL,58474270666,913660479,14275944,17.1),(117800,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117800,37.76,0.46,356,51972,70,NULL,NULL,'2MASX J14114955+5457329',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000172,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,212.956625,54.95925,0.017,NULL,57252873847,894576153,13977752,16.7),(117801,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117801,36.96,0.33,247,51973,70,NULL,NULL,'2MASX J14114996+5427129',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000172,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,212.958167,54.45356,0,NULL,57252422931,894569108,13977642,16.9),(117802,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117802,38.07,0.46,411,51974,70,NULL,NULL,'SDSS J141150.44+062335.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000137,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,212.9602083,6.39319,0.045,NULL,58504722815,914136293,14283379,18.4),(117803,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117803,38.31,0.46,459,51975,70,NULL,NULL,'2MASX J14115114+2114589',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,212.963208333,21.24978,0.031,NULL,59463903478,929123491,14517554,18.4),(117804,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117804,38.37,0.23,472,51976,70,NULL,NULL,'SDSS J141152.11+045430.9',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000074,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,212.967125,4.90861,0,NULL,58474139340,913658427,14275912,17.7),(117805,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117805,36.68,0.15,217,51977,70,NULL,NULL,'2MASX J14115211+2455194',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000113,NULL,'16.35',0.33,NULL,NULL,NULL,NULL,NULL,1,212.9672083,24.92194,0.008,NULL,60001922739,937530042,14648906,16.35),(117806,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117806,38.54,0.46,510,51978,70,NULL,NULL,'SDSS J141153.19+572719.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,212.971625,57.45528,0,NULL,57305225641,895394150,13990533,18.3),(117807,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117807,38.74,0.46,559,51979,70,NULL,NULL,'2MASX J14115346+2315069',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'18.06',0.14,NULL,NULL,NULL,NULL,NULL,1,212.972833333,23.25183,0.012,NULL,59470232132,929222377,14519099,18.06),(117808,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117808,37.46,0.46,311,51980,70,NULL,NULL,'2MASX J14115361+0504558',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000071,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,212.973333,5.08211,0.013,NULL,58474327868,913661372,14275958,17.3),(117809,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117809,36.19,0.46,173,51981,70,NULL,NULL,'2MASX J14115391+0013228',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000093,NULL,'15.6g',0.43,'E0',NULL,NULL,NULL,NULL,1,212.9745,0.22297,0.089,NULL,58402402898,912537545,14258399,15.6),(117810,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117810,37.1,0.33,263,51982,70,NULL,NULL,'SDSS J141154.61+002952.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000083,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.9775417,0.49778,0.109,NULL,58402479680,912538745,14258417,17.8),(117811,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117811,37.06,0.46,259,51983,70,NULL,NULL,'2MASX J14115529+1930149',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'16.63',0.44,NULL,NULL,NULL,NULL,NULL,1,212.980458333,19.50425,0.011,NULL,59520682623,930010665,14531416,16.63),(117812,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117812,35.99,0.46,157,51984,70,NULL,NULL,'2MASX J14115540+4614170',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000162,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,212.980833,46.23806,0,NULL,59236405792,925568840,14462013,16.4),(117813,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117813,36.29,0.83,181,51985,70,NULL,NULL,'2MASX J14115588-0710238',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.5b',0.37,NULL,NULL,NULL,NULL,NULL,1,212.982833,-7.17353,0.065,NULL,43741513669,683461151,10679080,16.5),(117814,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117814,35.98,0.27,157,51986,70,NULL,NULL,'IC 4384',NULL,'2015arXiv151105856S',2015,1,1.16,NULL,'G',0.000083,NULL,'14.3g',0.75,'S0/a',NULL,NULL,NULL,NULL,1,212.983416667,27.11392,0,NULL,60001573849,937524591,14648821,14.3),(117815,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:35','1','PS1 SN PS10kf','N',117815,41.82,0.18,1600,51987,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10kf HOST',0.4504,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117816,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117816,35.93,0.33,154,51988,70,NULL,NULL,'CGCG 272-042',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000097,NULL,'15.2g',0.47,'E0',NULL,NULL,NULL,NULL,1,212.99175,55.40978,0,NULL,57302062619,895344728,13989761,15.2),(117817,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117817,37.75,0.27,355,51989,70,NULL,NULL,'2MASX J14115859+2810463',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000169,NULL,'18.86',0.13,NULL,NULL,NULL,NULL,NULL,1,212.994083333,28.17953,0,NULL,60000622774,937509730,14648589,18.86),(117818,'GRB','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117818,39.28,NULL,718,51990,65,NULL,'L = 10e57 photons/s','GRB 790613',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,212.990333,78.68858,0.061,NULL,57166637682,893228713,13956698,NULL),(117819,'GRB','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117819,39.86,NULL,938,51990,75,NULL,NULL,'GRB 790613',NULL,'1995ApJ...453..583W',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117820,'GRB','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117820,41.39,NULL,1900,51990,NULL,NULL,NULL,'GRB 790613',NULL,'1992grbo.book..107S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117821,'GRB','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117821,41.81,NULL,2300,51990,65,NULL,'L = 2 x 10e58 photons/s','GRB 790613',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117822,'SGRB','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117822,38.01,0.48,400,51990,NULL,NULL,NULL,'GRB 790613',NULL,'2006ApJ...640..849N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117823,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117823,37.24,0.27,281,51991,70,NULL,NULL,'2MASX J14115915+3013554',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000166,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,212.9965,30.23208,0,NULL,60051277784,938301215,14660956,16.6),(117824,'Tully est','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117824,32.99,0.8,39.7,51992,75,NULL,NULL,'NGC 5489',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.00017,NULL,'13.14',1,'SA(s)0^+',NULL,NULL,NULL,NULL,1,213.003,-46.08872,0.353,NULL,46804411501,731318929,11426858,13.14),(117825,'SGRB','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117825,38.73,NULL,557,51993,71,NULL,NULL,'GRB 060801',NULL,'2010ApJ...709..664R',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,213.005375,16.98167,0,NULL,59487334726,929489605,14523275,NULL),(117826,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117826,35.95,0.46,155,51994,70,NULL,NULL,'2MASX J14120213+2441391',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.18',0.38,NULL,NULL,NULL,NULL,NULL,1,213.00875,24.69411,0,NULL,59468447595,929194493,14518663,16.18),(117827,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117827,35.95,0.2,155,51995,74.4,NULL,NULL,'CGCG 074-133',NULL,'2013AJ....146...86T',2013,1,0.89,NULL,'G',0.00014,NULL,'15.8g',0.43,NULL,NULL,NULL,NULL,NULL,1,213.011333333,10.37547,0,NULL,58498503815,914039122,14281861,15.8),(117828,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117828,38.05,0.33,407,51996,70,NULL,NULL,'VIII Zw 377 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000076,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,213.016625,-0.02011,0.089,NULL,43587601174,681056268,10641504,17.5),(117829,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117829,38.66,0.46,540,51997,70,NULL,NULL,'LCRS B140928.9-023426',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000175,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,213.01775,-2.80806,0.129,NULL,43724631620,683197369,10674958,18.3),(117830,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117830,37.8,0.46,363,51998,70,NULL,NULL,'SDSS J141204.27+053257.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000146,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,213.0177917,5.54931,0.021,NULL,58474865511,913669773,14276090,18.2),(117831,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117831,37.44,0.27,308,51999,70,NULL,NULL,'2MASX J14120514+4945084',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000162,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,213.021417,49.75242,0.022,NULL,59256797802,925887465,14466991,18),(117832,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117832,37.32,0.46,292,52000,70,NULL,NULL,'2MASX J14120594+5604535',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000174,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.02475,56.0815,0.013,NULL,57300483378,895320052,13989375,17.3),(117833,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117833,38,0.46,398,52001,70,NULL,NULL,'2MASX J14120631+1854159',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.026375,18.90458,0,NULL,59517526918,929961358,14530646,17.6),(117834,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117834,37.45,0.46,309,52002,70,NULL,NULL,'2MASX J14120722+3726597',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.0302917,37.44994,0,NULL,60032565968,938008843,14656388,17.4),(117835,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117835,37.13,0.46,266,52003,70,NULL,NULL,'SDSS J141207.73+034447.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000069,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.03225,3.7465,0.045,NULL,58484394322,913818661,14278416,17.6),(117836,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117836,39.06,0.46,647,52004,70,NULL,NULL,'SDSS J141207.78+131328.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000178,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,213.0324583,13.22472,0,NULL,58365830322,911966098,14249470,18.7),(117837,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117837,38.05,0.33,407,52005,70,NULL,NULL,'VIII Zw 377 NOTES02',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000096,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,213.0344583,-0.02767,0.089,NULL,43588125617,681064462,10641632,17.2),(117838,'Tully est','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117838,32.93,0.8,38.5,52006,75,NULL,NULL,'ESO 221- G 032',NULL,'1988NBGC.C....0000T',1988,1,2.2,NULL,'G',0.000013,NULL,'12.76',1.9,'SA(r)c',NULL,NULL,NULL,NULL,1,213.037875,-49.38964,1.045,NULL,46841776400,731902756,11435980,12.76),(117839,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117839,36.63,0.46,212,52007,70,NULL,NULL,'2MASX J14120955+0537516',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,213.039833,5.63097,0.025,NULL,58474858651,913669666,14276088,17.4),(117840,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117840,36.88,0.46,238,52008,70,NULL,NULL,'2MASX J14120960+3104324',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000149,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,213.039917,31.07578,0,NULL,60053122458,938330038,14661406,17),(117841,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117841,36.55,0.46,204,52009,70,NULL,NULL,'2MASX J14120955+3228354',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000157,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,213.039917,32.47658,0.01,NULL,60034753460,938043022,14656922,16.5),(117842,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117842,36.51,0.46,200,52010,70,NULL,NULL,'SDSS J141209.60+044924.9',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000062,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,213.040041667,4.82361,0,NULL,58474143677,913658494,14275913,17.5),(117843,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117843,38.18,0.46,432,52011,70,NULL,NULL,'SDSS J141209.89+023907.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000076,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,213.04125,2.65206,0.097,NULL,58471961183,913624393,14275381,18.5),(117844,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117844,37.07,0.46,259,52012,70,NULL,NULL,'2MASX J14120999+3245194',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000191,NULL,'15.9g',0.39,NULL,NULL,NULL,NULL,NULL,1,213.0417083,32.7555,0,NULL,60034812871,938043951,14656936,15.9),(117845,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117845,37.57,0.46,327,52013,70,NULL,NULL,'2MASX J14121020+2636262',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,213.042583,26.60731,0,NULL,60002797455,937543710,14649120,17.2),(117846,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117846,37.84,0.33,369,52014,70,NULL,NULL,'2MASX J14121040+4021246',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000156,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.0435,40.35683,0,NULL,59257202800,925893793,14467090,17.3),(117847,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117847,36.91,0.46,241,52015,70,NULL,NULL,'2MASX J14121203+3929266',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.05025,39.49086,0,NULL,59139921211,924061268,14438457,17.5),(117848,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117848,34.36,0.79,74.6,52016,NULL,NULL,NULL,'UGC 09084',NULL,'2009ApJS..182..474S',2009,1,1.08,'HOLM 600C is a star.','G',0.000103,NULL,'14.5g',0.89,'Sb',NULL,NULL,NULL,NULL,1,213.053041667,8.66183,0.01,NULL,58495966186,913999471,14281241,14.5),(117849,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117849,34.4,0.2,75.9,52016,74.4,NULL,NULL,'UGC 09084',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117850,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117850,34.69,0.68,86.9,52016,NULL,NULL,'Malmquist cor.','UGC 09084',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117851,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117851,37.36,0.21,296,52017,70,NULL,NULL,'2MASX J14121314+5247194',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000183,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,213.054625,52.78867,0,NULL,59249349240,925771081,14465173,16.8),(117852,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117852,35.98,0.27,157,52018,70,NULL,NULL,'2MASX J14121311+2634522',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000174,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,213.054708333,26.58114,0,NULL,60002810373,937543912,14649123,16.4),(117853,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117853,37.24,0.27,281,52019,70,NULL,NULL,'2MASX J14121339+3002314',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.055833,30.04219,0,NULL,60051367013,938302609,14660978,17.5),(117854,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117854,38.05,0.46,407,52020,70,NULL,NULL,'2MASX J14121404+0759192',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000189,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.058667,7.98869,0,NULL,58504010608,914125165,14283205,17.2),(117855,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117855,38.54,0.46,512,52021,70,NULL,NULL,'SDSS J141214.71+082215.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000138,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,213.061333,8.37111,0.014,NULL,58504110280,914126723,14283230,18.7),(117856,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117856,37.68,0.46,343,52022,70,NULL,NULL,'2MASX J14121488+1437180',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,213.061916667,14.62175,0,NULL,58366632568,911978633,14249666,17.6),(117857,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117857,37.22,0.46,278,52023,70,NULL,NULL,'2MASX J14121591+1502150',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.20',0.18,NULL,NULL,NULL,NULL,NULL,1,213.066208333,15.03742,0,NULL,58366286319,911973223,14249581,18.2),(117858,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117858,34.2,NULL,69.2,52024,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09091',NULL,'2010Ap&SS.325..163P',2010,1,1.11,NULL,'G',0.000011,NULL,'16.6g',0.16,'Sbc',NULL,NULL,NULL,NULL,1,213.067833333,29.90744,0,NULL,60051327336,938301989,14660968,16.6),(117859,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117859,34.22,NULL,69.8,52024,NULL,NULL,'Dipole + Quadrupole','UGC 09091',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117860,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117860,34.23,NULL,70.1,52024,NULL,NULL,'Dipole','UGC 09091',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117861,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117861,34.29,NULL,72.1,52024,NULL,NULL,NULL,'UGC 09091',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117862,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117862,34.75,0.2,89.1,52024,74.4,NULL,NULL,'UGC 09091',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117863,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117863,38.58,0.33,521,52025,70,NULL,NULL,'2MASX J14121663+4103378',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000136,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,213.069333333,41.06047,0,NULL,59224302929,925379733,14459058,17.6),(117864,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117864,36.52,0.53,202,52026,70,NULL,NULL,'ESO 578- G 034',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000123,NULL,'15.40',0.5,'SA0-',NULL,NULL,NULL,NULL,1,213.069833333,-21.18642,0.249,NULL,46517179080,726830923,11356733,15.4),(117865,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117865,37.06,0.46,258,52027,70,NULL,NULL,'2MASX J14121770+2427362',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000207,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,213.0737083,24.46,0,NULL,59468634320,929197411,14518709,16.4),(117866,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117866,36.37,0.64,188,52028,70,NULL,NULL,'2MASX J14121779-3418097',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.6b',NULL,'E',NULL,NULL,NULL,NULL,1,213.0740417,-34.30278,0.161,NULL,47002693438,734417084,11475266,16.6),(117867,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117867,37.09,0.46,262,52029,70,NULL,NULL,'2MASX J14121785+0602466',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000184,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,213.074333,6.04625,0.049,NULL,58474478269,913663722,14275995,17),(117868,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117868,36.87,0.46,236,52030,70,NULL,NULL,'2MASX J14121844+5007204',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,213.077041667,50.12242,0.022,NULL,59253214735,925831480,14466116,16.7),(117869,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117869,37.84,0.46,370,52031,70,NULL,NULL,'2MASX J14121897+5757295',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000179,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,213.079125,57.95842,0,NULL,57305899043,895404672,13990698,17.2),(117870,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117870,37.61,0.46,332,52032,70,NULL,NULL,'2MASX J14121966+5722135',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000196,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,213.082166667,57.37047,0,NULL,57305433116,895397392,13990584,16.9),(117871,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117871,35.35,0.51,118,52033,70,NULL,NULL,'2MASX J14121985-3658093',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,213.0827917,-36.96933,0.185,NULL,46995432087,734303626,11473494,14.4),(117872,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117872,37.36,0.21,296,52034,70,NULL,NULL,'2MASX J14121998+5246383',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000183,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,213.083375,52.77717,0,NULL,59249467636,925772931,14465202,16.8),(117873,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117873,38.37,0.46,472,52035,70,NULL,NULL,'SDSS J141220.08+051032.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000075,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,213.0837083,5.17558,0.021,NULL,58474311539,913661117,14275954,18.4),(117874,'IRAS','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117874,34.84,0.8,93,52036,75,NULL,'HMCL, I','CGCG 074-135',NULL,'1997ApJS..109..333W',1997,1,1.13,NULL,'G',0.000027,NULL,'14.8g',0.47,NULL,NULL,NULL,NULL,NULL,1,213.087833,8.50861,0.014,NULL,58503337844,914114653,14283041,14.8),(117875,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117875,35.38,0.4,119,52036,75,NULL,'HMCL, I, raw','CGCG 074-135',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117876,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117876,35.49,0.4,125,52036,75,NULL,'HMCL, I, cor','CGCG 074-135',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117877,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117877,35.61,0.4,133,52036,75,NULL,'HMCL, I, inv','CGCG 074-135',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117878,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117878,36.47,0.87,197,52037,70,NULL,NULL,'2MASX J14122107-4750215',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,213.0877083,-47.83936,0.793,NULL,46839723466,731870679,11435479,16.7),(117879,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117879,37.1,0.33,263,52038,70,NULL,NULL,'2MASX J14122164+0031496',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000081,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,213.09025,0.53042,0.077,NULL,58402444565,912538196,14258409,16.6),(117880,'IRAS','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117880,32.45,0.8,30.8,52039,75,NULL,'CF, r','NGC 5520',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.00002,NULL,'13.25',1.1,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,213.094958333,50.34842,0,NULL,59253247110,925831986,14466124,13.25),(117881,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117881,31.38,0.69,18.9,52039,100,NULL,'mid-IR','NGC 5520',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117882,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117882,32.48,0.4,31.4,52039,NULL,NULL,'mean','NGC 5520',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117883,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117883,32.76,0.43,35.6,52039,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5520',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117884,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117884,32.92,0.43,38.4,52039,75,NULL,'3.6 micron, color corrected','NGC 5520',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117885,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117885,32.98,0.37,39.4,52039,NULL,NULL,NULL,'NGC 5520',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117886,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117886,32.98,0.45,39.5,52039,NULL,NULL,'K','NGC 5520',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117887,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117887,33.02,0.47,40.3,52039,NULL,NULL,'H','NGC 5520',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117888,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117888,33.05,0.46,40.7,52039,NULL,NULL,'J','NGC 5520',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117889,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117889,33.11,0.38,41.8,52039,75,NULL,'CF, r, raw','NGC 5520',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117890,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117890,33.13,0.2,42.3,52039,74.4,NULL,NULL,'NGC 5520',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117891,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117891,33.14,0.38,42.5,52039,75,NULL,'CF, r, cor','NGC 5520',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117892,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117892,33.22,0.38,44,52039,75,NULL,'CF, r, inv','NGC 5520',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117893,'Sosies','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117893,33.47,0.78,49.4,52040,NULL,NULL,NULL,'NGC 5494',NULL,'2002A&A...393...57T',2002,1,2.2,NULL,'G',0.000007,NULL,'12.59',1.9,'SA(s)c         HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,213.10075,-30.64408,0.273,NULL,47038324001,734973812,11483965,12.59),(117894,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117894,37.69,0.46,346,52041,70,NULL,NULL,'2MASX J14122420+4043538',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000169,NULL,'17.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,213.100875,40.73142,0,NULL,59224434379,925381787,14459090,17.1),(117895,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117895,34.64,0.56,84.8,52042,NULL,NULL,'Malmquist cor.','ESO 511- G 011',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000033,NULL,'15.08',0.6,'SB(r)b:',NULL,NULL,NULL,NULL,1,213.1015417,-27.41433,0.217,NULL,46987680500,734182507,11471601,15.08),(117896,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117896,34.65,0.56,85.2,52042,NULL,NULL,NULL,'ESO 511- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117897,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117897,34.69,0.2,86.7,52042,74.4,NULL,NULL,'ESO 511- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117898,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117898,34.57,0.46,82.1,52043,70,NULL,NULL,'UGC 09090',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000163,NULL,'14.56',0.8,'S0-:',NULL,NULL,NULL,NULL,1,213.1017917,18.41178,0,NULL,59517598480,929962476,14530663,14.56),(117899,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117899,37.4,0.46,302,52044,70,NULL,NULL,'2MASX J14122452+5403025',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000152,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,213.102167,54.05061,0,NULL,59194375161,924912111,14451751,17.1),(117900,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117900,37.93,0.46,386,52045,70,NULL,NULL,'SDSS J141225.09+533756.6',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.1045417,53.63239,0,NULL,59194300174,924910940,14451733,17.5),(117901,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117901,37.23,0.46,279,52046,70,NULL,NULL,'2MASX J14122528+4704564',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000177,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,213.1052083,47.08242,0.028,NULL,59255037722,925859964,14466561,16.7),(117902,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117902,37.19,0.33,274,52047,70,NULL,NULL,'2MASX J14122538+4028308',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000145,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,213.105833,40.47533,0,NULL,59223718115,925370595,14458915,17.5),(117903,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117903,38.18,0.27,432,52048,70,NULL,NULL,'2MASX J14122642+0720202',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000172,NULL,'17.0g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,213.1099583,7.33886,0.038,NULL,58506176721,914159011,14283734,17),(117904,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117904,37.1,0.46,264,52049,70,NULL,NULL,'2MASX J14122678+1838554',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.90',0.19,NULL,NULL,NULL,NULL,NULL,1,213.111625,18.64878,0,NULL,59517645039,929963203,14530675,17.9),(117905,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117905,37.19,0.33,274,52050,70,NULL,NULL,'2MASX J14122853+4030018',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,'PRED','18.42',0.18,NULL,NULL,NULL,NULL,NULL,1,213.1190417,40.50058,0,NULL,59223718767,925370605,14458915,18.42),(117906,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117906,36.87,0.46,236,52051,70,NULL,NULL,'2MASX J14122864+4525294',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,213.1192083,45.42472,0,NULL,59236992096,925578001,14462156,16.8),(117907,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117907,36.02,0.62,160,52052,70,NULL,NULL,'2MASX J14122917-3417417',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,213.1215417,-34.29494,0.161,NULL,47002691272,734417051,11475266,15.2),(117908,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117908,35.23,0.46,111,52053,70,NULL,NULL,'CGCG 317-018',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000083,NULL,'15.3g',0.38,'S0',NULL,NULL,NULL,NULL,1,213.12225,64.37681,0.013,NULL,57933273615,905207400,14143865,15.3),(117909,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117909,35.12,0.33,106,52054,70,NULL,NULL,'NGC 5469',NULL,'2015arXiv151105856S',2015,1,0.79,'Identification as NGC 5469 is uncertain.','G',0.000097,NULL,'14.7g',0.62,NULL,NULL,NULL,NULL,NULL,1,213.124583,8.64794,0.01,NULL,58495982538,913999727,14281245,14.7),(117910,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117910,38.18,0.27,432,52055,70,NULL,NULL,'2MASX J14123055+0718446',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000147,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,213.127333,7.31239,0.038,NULL,58506172320,914158942,14283733,17.8),(117911,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117911,35.85,0.46,148,52056,70,NULL,NULL,'2MASX J14123068+6135366',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000156,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,213.12775,61.59367,0.017,NULL,57748328600,902317634,14098713,16.6),(117912,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117912,37.19,0.33,274,52057,70,NULL,NULL,'2MASX J14123270+2627392',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.28',0.16,NULL,NULL,NULL,NULL,NULL,1,213.136291667,26.46072,0,NULL,60003523817,937555059,14649297,18.28),(117913,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117913,38.11,0.27,418,52058,70,NULL,NULL,'2MASX J14123405+5400345',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000168,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.1419583,54.00967,0,NULL,59194367044,924911985,14451749,17.8),(117914,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117914,35.98,0.27,157,52059,70,NULL,NULL,'2MASX J14123417+2645561',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000207,NULL,'15.7g',0.48,NULL,NULL,NULL,NULL,NULL,1,213.142333,26.76561,0,NULL,60001369098,937521392,14648771,15.7),(117915,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117915,37.19,0.33,274,52060,70,NULL,NULL,'2MASX J14123487+2628161',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000176,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,213.145125,26.47103,0,NULL,60003523077,937555048,14649297,17.8),(117916,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117916,37.41,0.33,304,52061,70,NULL,NULL,'2MASX J14123487+4946112',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000169,NULL,'16.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,213.14525,49.76983,0.022,NULL,59256793714,925887401,14466990,16.6),(117917,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117917,36.96,0.33,247,52062,70,NULL,NULL,'2MASX J14123609+5424085',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,213.1502083,54.40225,0.005,NULL,57252448600,894569509,13977648,17.2),(117918,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117918,37.96,0.46,392,52063,70,NULL,NULL,'2MASX J14123642+0536357',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000175,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,213.151667,5.61,0.025,NULL,58474534960,913664608,14276009,17.2),(117919,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117919,37.33,0.46,292,52064,70,NULL,NULL,'SDSS J141237.25+545256.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000141,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,213.15525,54.88239,0.013,NULL,57252890115,894576408,13977756,18.3),(117920,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117920,35.97,0.2,156,52065,74.4,NULL,NULL,'UGC 09093',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'16.0g',0.28,'Scd:',NULL,NULL,NULL,NULL,1,213.158,12.02017,0,NULL,58491722115,913933158,14280205,16),(117921,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117921,37.31,0.46,290,52066,70,NULL,NULL,'2MASX J14123824+2251114',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'18.18',0.17,NULL,NULL,NULL,NULL,NULL,1,213.15925,22.85317,0.013,NULL,59469674750,929213667,14518963,18.18),(117922,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117922,35.4,0.46,120,52067,70,NULL,NULL,'NGC 5509',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.00021,NULL,'15.2',0.6,'E/S0',NULL,NULL,NULL,NULL,1,213.164916667,20.387,0.008,NULL,59519709141,929995455,14531178,15.2),(117923,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117923,37.77,0.46,357,52068,70,NULL,NULL,'2MASX J14124174+2035556',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.59',0.12,NULL,NULL,NULL,NULL,NULL,1,213.174041667,20.59875,0.017,NULL,59519676145,929994939,14531170,18.59),(117924,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117924,37.49,0.46,314,52069,70,NULL,NULL,'2MASX J14124256+5415594',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000182,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,213.1775,54.26653,0.005,NULL,57252367978,894568249,13977628,16.9),(117925,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117925,37.41,0.33,304,52070,70,NULL,NULL,'2MASX J14124301+4948116',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,213.1792917,49.80325,0.022,NULL,59256794562,925887415,14466990,16.9),(117926,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117926,37.44,0.27,308,52071,70,NULL,NULL,'2MASX J14124382+4952066',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000215,NULL,'15.7g',0.43,NULL,NULL,NULL,NULL,NULL,1,213.182667,49.86847,0.024,NULL,59256758964,925886858,14466982,15.7),(117927,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117927,37.73,0.46,352,52072,70,NULL,NULL,'2MASX J14124406+3628498',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000241,NULL,'16.0g',0.42,'E0',NULL,NULL,NULL,NULL,1,213.1835,36.48058,0,NULL,60030927026,937983234,14655988,16),(117928,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117928,36.65,0.46,213,52073,70,NULL,NULL,'SDSS J141245.43+162251.7',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.8g',0.31,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,213.1892917,16.38106,0,NULL,59485436302,929459942,14522811,16.8),(117929,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117929,37.94,0.46,388,52074,70,NULL,NULL,'SDSS J141245.48+592417.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000167,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,213.1895417,59.40492,0,NULL,57272600380,894884380,13982568,18.2),(117930,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117930,38.22,0.46,441,52075,70,NULL,NULL,'SDSS J141245.58+050353.4',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000084,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.1899583,5.06483,0.029,NULL,58474339212,913661550,14275961,17.6),(117931,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117931,37.25,0.33,282,52076,70,NULL,NULL,'2MASX J14124563+4757347',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,213.1899583,47.95964,0.021,NULL,59255998416,925874975,14466796,16.8),(117932,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117932,37.74,0.46,353,52077,70,NULL,NULL,'2MASX J14124565+4109348',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000151,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,213.190125,41.15961,0,NULL,59224273976,925379280,14459051,17.4),(117933,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117933,37.94,0.46,388,52078,70,NULL,NULL,'2MASX J14124627+2001096',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'18.10',0.13,NULL,NULL,NULL,NULL,NULL,1,213.192958333,20.01928,0.009,NULL,59519634406,929994287,14531160,18.1),(117934,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117934,36.04,0.52,161,52079,70,NULL,NULL,'2MASX J14124688-3749123',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.7I',0.4,NULL,NULL,NULL,NULL,NULL,1,213.19525,-37.82008,0.213,NULL,46996408856,734318888,11473732,13.7),(117935,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117935,37.56,0.46,325,52080,70,NULL,NULL,'SDSS J141249.59+055628.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000123,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,213.206667,5.94133,0.049,NULL,58474606887,913665732,14276027,18),(117936,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117936,36.3,0.46,182,52081,70,NULL,NULL,'2MASX J14125010+0452247',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000083,NULL,'15.7g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,213.2087083,4.8735,0,NULL,58474135230,913658362,14275911,15.7),(117937,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117937,38.58,0.33,521,52082,70,NULL,NULL,'2MASX J14125132+4108094',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,213.21375,41.13586,0,NULL,59224263609,925379118,14459048,18.1),(117938,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117938,36.92,0.46,242,52083,70,NULL,NULL,'2MASX J14125329+2006037',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.93',0.3,NULL,NULL,NULL,NULL,NULL,1,213.222208333,20.10103,0.009,NULL,59519641096,929994392,14531162,16.93),(117939,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117939,36.72,0.46,221,52084,70,NULL,NULL,'2MASX J14125378+4805567',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000189,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,213.2239583,48.09922,0,NULL,59255979307,925874676,14466791,16.3),(117940,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117940,37.8,0.46,364,52085,70,NULL,NULL,'2MASX J14125408+1349424',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000173,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,213.22525,13.82864,0,NULL,58367105199,911986018,14249781,17),(117941,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117941,37.14,0.46,267,52086,70,NULL,NULL,'2MASX J14125428+2239577',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.84',0.22,NULL,NULL,NULL,NULL,NULL,1,213.226291667,22.66603,0.012,NULL,59469825409,929216022,14519000,17.84),(117942,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117942,37.63,0.46,336,52087,70,NULL,NULL,'2MASX J14125434+0659516',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,213.2265,6.99767,0.042,NULL,58506307055,914161047,14283766,17.3),(117943,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117943,36.81,0.46,231,52088,70,NULL,NULL,'2MASX J14125472+3540316',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,213.227917,35.67542,0,NULL,60044450649,938194541,14659289,17),(117944,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117944,37,0.46,251,52089,70,NULL,NULL,'2MASX J14125547+2118077',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.20',0.18,'AGN',NULL,NULL,NULL,NULL,1,213.231166667,21.30217,0.026,NULL,59463738898,929120920,14517514,18.2),(117945,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117945,34.74,0.47,88.6,52090,70,NULL,NULL,'ESO 446- G 029',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000103,NULL,'14.68',0.7,'Sab: pec',NULL,NULL,NULL,NULL,1,213.233833,-28.77408,0.189,NULL,47039140326,734986567,11484165,14.68),(117946,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117946,38.11,0.46,419,52091,70,NULL,NULL,'2MASX J14125678+2809271',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000158,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,213.236417,28.15761,0,NULL,60056161494,938377523,14662148,17.5),(117947,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:35','1','PS1 SN PS11fi','N',117947,37.74,0.15,326,52092,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11fi HOST',0.0822,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117948,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117948,36.26,0.46,179,52093,70,NULL,NULL,'2MASX J14125722+2844501',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000168,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,213.238333,28.74736,0,NULL,60058288615,938410759,14662668,16.4),(117949,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117949,37.58,0.46,329,52094,70,NULL,NULL,'2MASX J14125843+3027497',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000196,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,213.243625,30.46378,0,NULL,60053032204,938328628,14661384,16.6),(117950,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117950,37.52,0.46,319,52095,70,NULL,NULL,'LCRS B141024.3-025351',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000157,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,213.2495417,-3.13106,0.121,NULL,43735534122,683367720,10677620,17.3),(117951,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117951,37.44,0.27,308,52096,70,NULL,NULL,'2MASX J14130016+4953087',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000178,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,213.250583,49.88569,0.024,NULL,59253298093,925832782,14466137,17.3),(117952,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117952,37.36,0.46,296,52097,70,NULL,NULL,'VIII Zw 379 NED03',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000083,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,213.25525,-1.12408,0.133,NULL,43722359026,683161859,10674404,16.7),(117953,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117953,37.81,0.46,365,52098,70,NULL,NULL,'SDSS J141301.80+160438.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,213.257541667,16.07742,0,NULL,59485267172,929457299,14522770,18.2),(117954,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117954,38.21,0.46,438,52099,70,NULL,NULL,'2MASX J14130301+4057104',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.2625417,40.95283,0,NULL,59224458730,925382167,14459096,17.7),(117955,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117955,37.07,0.46,259,52100,70,NULL,NULL,'2MASX J14130450+4448329',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000133,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,213.269,44.80919,0,NULL,59240152531,925627383,14462927,17.8),(117956,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117956,36.01,0.52,159,52101,70,NULL,NULL,'2MASX J14130649-3405476',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.7b',0.7,'E',NULL,NULL,NULL,NULL,1,213.2769583,-34.09667,0.137,NULL,47003992395,734437381,11475584,15.7),(117957,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117957,37.74,0.33,354,52102,70,NULL,NULL,'2MASX J14130662+0820019',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,213.2777083,8.33378,0.029,NULL,58503792924,914121764,14283152,17.6),(117958,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117958,37.52,0.46,319,52103,70,NULL,NULL,'2MASX J14130799+3125147',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000183,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,213.283417,31.42081,0,NULL,60052739879,938324060,14661313,16.4),(117959,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117959,38.18,0.27,432,52104,70,NULL,NULL,'2MASX J14130840+0718199',NULL,'2015arXiv151105856S',2015,1,0.31,'May contribute to the IR source IRAS F14106+0732.','G',0.000167,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,213.284958333,7.30553,0.039,NULL,58506197662,914159338,14283739,17),(117960,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117960,37.5,0.46,316,52105,70,NULL,NULL,'SDSS J141308.52+210320.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.59',0.14,NULL,NULL,NULL,NULL,NULL,1,213.285583,21.05581,0.032,NULL,59519383788,929990371,14531099,18.59),(117961,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117961,33.76,0.33,56.4,52106,70,NULL,NULL,'NGC 5513',NULL,'2015arXiv151105856S',2015,1,1.9,NULL,'G',0.000103,NULL,'13.64',1.1,'S0',NULL,NULL,NULL,NULL,1,213.285958333,20.41628,0.008,NULL,59519698198,929995284,14531176,13.64),(117962,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117962,36.93,0.27,243,52107,70,NULL,NULL,'2MASX J14130965+2722135',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000123,NULL,'16.64',0.29,NULL,NULL,NULL,NULL,NULL,1,213.290333,27.37036,0,NULL,60001470169,937522971,14648796,16.64),(117963,'Tully est','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117963,28.11,0.8,4.2,52108,75,NULL,'B','Circinus Galaxy',NULL,'1988NBGC.C....0000T',1988,1,6.9,'Within 10 degrees of the galactic plane.','G',0.00001,NULL,'12.1',3,'SA(s)b:        Sy2','Pair member (points to parent)',NULL,NULL,'Sy 1 h',1,213.2914583,-65.33922,NULL,NULL,45078986730,704359167,11005611,12.1),(117964,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117964,28.12,NULL,4.21,52108,NULL,NULL,NULL,'Circinus Galaxy',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117965,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117965,28.12,0.36,4.21,52108,NULL,NULL,NULL,'Circinus Galaxy',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117966,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117966,37.16,0.46,271,52109,70,NULL,NULL,'2MASX J14131048+0146169',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000132,NULL,'15.8g',0.37,'S0',NULL,NULL,NULL,NULL,1,213.29375,1.77142,0.065,NULL,58472588716,913634198,14275534,15.8),(117967,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117967,35.38,0.46,119,52110,70,NULL,NULL,'2MASX J14131087+1056419',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000161,NULL,'15.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,213.295417,10.94511,0,NULL,58500568996,914071390,14282365,15.8),(117968,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117968,37.76,0.46,356,52111,70,NULL,NULL,'SDSS J141311.05+052825.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000083,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,213.296083,5.47383,0.025,NULL,58474506752,913664168,14276002,17.8),(117969,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117969,38.04,0.46,406,52112,70,NULL,NULL,'2MASX J14131122+1939517',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.1g',0.24,'AGN',NULL,NULL,NULL,NULL,1,213.296667,19.66436,0,NULL,59520785125,930012267,14531441,17.1),(117970,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117970,38.31,0.27,459,52113,70,NULL,NULL,'SDSS J141312.28+053300.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00018,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,213.3012083,5.55,0.025,NULL,58474558384,913664974,14276015,18),(117971,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117971,38.11,0.27,418,52114,70,NULL,NULL,'2MASX J14131235+5359343',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000172,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,213.3014583,53.99286,0.005,NULL,59194395659,924912432,14451756,16.9),(117972,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117972,36.68,0.15,217,52115,70,NULL,NULL,'2MASX J14131259+2432235',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,213.3025,24.53997,0,NULL,59470537512,929227148,14519174,17.2),(117973,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117973,38.21,0.46,438,52116,70,NULL,NULL,'LCRS B141037.5-022019',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,213.303375,-2.57206,0.149,NULL,43724207671,683190744,10674855,18.4),(117974,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117974,38.06,0.46,409,52117,70,NULL,NULL,'SDSS J141313.16+051304.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00008,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,213.304875,5.218,0.073,NULL,58474179740,913659058,14275922,18.3),(117975,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117975,36.79,0.59,228,52118,70,NULL,NULL,'2MASX J14131352-2024065',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.37',NULL,NULL,NULL,NULL,NULL,NULL,1,213.306417,-20.40192,0.269,NULL,46562627496,727541054,11367828,16.37),(117976,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117976,36.93,0.27,243,52119,70,NULL,NULL,'2MASX J14131386+2719135',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000176,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,213.307875,27.32047,0,NULL,60001462939,937522858,14648794,16.6),(117977,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117977,37.44,0.46,308,52120,70,NULL,NULL,'2MASX J14131485+2151444',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.23',0.17,NULL,NULL,NULL,NULL,NULL,1,213.311875,21.86244,0.024,NULL,59471066391,929235412,14519303,18.23),(117978,'Tully est','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117978,32.29,0.8,28.7,52121,75,NULL,NULL,'NGC 5506',NULL,'1988NBGC.C....0000T',1988,1,3.16,NULL,'G',0.000027,NULL,'12.8g',0.75,'Sa pec sp      Sy1.9','Pair member (points to parent)',NULL,NULL,'Sy 1 i',1,213.312041667,-3.20758,0.121,NULL,43735471042,683366735,10677605,12.8),(117979,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117979,31.1,0.45,16.6,52121,NULL,NULL,'K','NGC 5506',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117980,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117980,31.48,0.47,19.8,52121,NULL,NULL,'H','NGC 5506',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117981,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117981,31.68,0.46,21.7,52121,NULL,NULL,'J','NGC 5506',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117982,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117982,31.88,NULL,23.8,52121,72,NULL,NULL,'NGC 5506',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117983,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117983,32.04,0.49,25.6,52121,75,NULL,'IR','NGC 5506',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117984,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117984,32.17,0.4,27.2,52121,NULL,NULL,'mean','NGC 5506',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117985,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117985,32.31,0.3,29,52121,55,NULL,'B','NGC 5506',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117986,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117986,37.87,0.23,376,52122,70,NULL,NULL,'2MASX J14131550+4340109',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00008,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,213.314583,43.66961,0,NULL,59239352085,925614876,14462732,17),(117987,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117987,37.67,0.46,341,52123,70,NULL,NULL,'2MASX J14131589+4316109',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,213.31625,43.26964,0,NULL,59226197793,925409340,14459520,17),(117988,'IRAS','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117988,34.29,0.8,71.9,52124,75,NULL,'HMCL, I','UGC 09101',NULL,'1997ApJS..109..333W',1997,1,1.72,NULL,'G',0.00001,NULL,'14.2g',0.75,'Sb',NULL,NULL,NULL,NULL,1,213.3170417,27.00808,0,NULL,60001383462,937521616,14648775,14.2),(117989,'IRAS','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117989,34.29,0.8,72,52124,75,NULL,'CF, r','UGC 09101',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117990,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117990,33.5,0.69,50.2,52124,100,NULL,'mid-IR','UGC 09101',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117991,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117991,34.36,0.4,74.3,52124,75,NULL,'HMCL, I, raw','UGC 09101',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117992,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117992,34.42,0.4,76.7,52124,NULL,NULL,'mean','UGC 09101',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117993,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117993,34.55,0.4,81.2,52124,75,NULL,'HMCL, I, inv','UGC 09101',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117994,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117994,34.58,0.4,82.5,52124,75,NULL,'HMCL, I, cor','UGC 09101',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117995,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117995,34.6,0.38,83,52124,75,NULL,'CF, r, raw','UGC 09101',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117996,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117996,34.75,0.66,88.9,52124,NULL,NULL,'Malmquist cor.','UGC 09101',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117997,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117997,34.76,0.38,89.6,52124,75,NULL,'CF, r, inv','UGC 09101',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117998,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117998,34.78,0.2,90.4,52124,74.4,NULL,NULL,'UGC 09101',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117999,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117999,34.88,0.47,94.7,52124,NULL,NULL,'H','UGC 09101',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118000,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118000,34.91,0.38,95.9,52124,75,NULL,'CF, r, cor','UGC 09101',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118001,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118001,34.91,0.61,96.1,52124,NULL,NULL,NULL,'UGC 09101',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118002,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118002,36.68,0.15,217,52125,70,NULL,NULL,'2MASX J14131846+2429545',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000173,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,213.327083,24.49836,0,NULL,59470539444,929227178,14519174,16.9),(118003,'Tully est','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118003,32.68,0.8,34.3,52126,75,NULL,NULL,'NGC 5507',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000017,NULL,'13.55',0.9,'SAB(r)0^0^','Pair member (points to parent)',NULL,NULL,NULL,1,213.3327917,-3.14889,0.121,NULL,43735473187,683366768,10677605,13.55),(118004,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118004,37.94,0.33,387,52127,70,NULL,NULL,'2MASX J14132088+5241174',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00017,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,213.336667,52.68808,0,NULL,59249501674,925773463,14465210,18.2),(118005,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118005,38.11,0.27,418,52128,70,NULL,NULL,'2MASX J14132142+5359193',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.339083,53.98872,0.005,NULL,59194407631,924912619,14451759,17.4),(118006,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118006,37.46,0.46,311,52129,70,NULL,NULL,'2MASX J14132245+0838159',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000183,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,213.343667,8.63781,0.023,NULL,58496826876,914012919,14281451,17.2),(118007,'IRAS','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118007,34.94,0.8,97.1,52130,75,NULL,'HMCL, I','MCG +02-36-054',NULL,'1997ApJS..109..333W',1997,1,0.27,'Holmberg 608b includes the star just northeast.','G',0.000083,NULL,'17.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,213.34475,8.96297,0.006,NULL,58496028691,914000448,14281257,17.2),(118008,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118008,35.11,0.4,105,52130,75,NULL,'HMCL, I, raw','MCG +02-36-054',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118009,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118009,35.23,0.4,111,52130,75,NULL,'HMCL, I, cor','MCG +02-36-054',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118010,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118010,35.28,0.4,114,52130,75,NULL,'HMCL, I, inv','MCG +02-36-054',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118011,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118011,36.68,0.15,217,52131,70,NULL,NULL,'CGCG 133-012',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000117,NULL,'15.1g',0.6,NULL,NULL,NULL,NULL,NULL,1,213.346375,24.53242,0,NULL,59470573063,929227704,14519182,15.1),(118012,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118012,37.29,0.46,287,52132,70,NULL,NULL,'2MASX J14132390+1851414',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,213.3497083,18.86153,0,NULL,59517540981,929961577,14530649,16.5),(118013,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118013,35.69,0.46,137,52133,70,NULL,NULL,'2MASX J14132439+0623049',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000181,NULL,'15.4g',0.46,NULL,NULL,NULL,NULL,NULL,1,213.351667,6.38464,0.037,NULL,58505605863,914150091,14283595,15.4),(118014,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118014,37.78,0.46,360,52134,70,NULL,NULL,'2MASX J14132440+1709102',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.62',0.15,NULL,NULL,NULL,NULL,NULL,1,213.351833,17.15283,0,NULL,59487492587,929492071,14523313,18.62),(118015,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118015,38.4,0.46,478,52135,70,NULL,NULL,'SDSS J141326.32+065857.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000141,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,213.3597083,6.98269,0.029,NULL,58506129322,914158270,14283722,18.7),(118016,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118016,35.24,0.2,112,52136,74.4,NULL,NULL,'CGCG 074-145',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000027,NULL,'15.0',0.4,'Sy2',NULL,NULL,NULL,NULL,1,213.364083,8.98089,0.006,NULL,58496717656,914011213,14281425,15),(118017,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118017,35.24,0.49,112,52137,75,NULL,'IR','CGCG 074-145',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000027,NULL,'15.0',0.4,'Sy2',NULL,NULL,NULL,NULL,1,213.364083,8.98089,0.006,NULL,58496717656,914011213,14281425,15),(118018,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118018,37.59,0.46,330,52138,70,NULL,NULL,'2MASX J14132877+0929363',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'18.04',0.13,NULL,NULL,NULL,NULL,NULL,1,213.37,9.4935,0,NULL,58498906423,914045412,14281959,18.04),(118019,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118019,37.06,0.46,258,52139,70,NULL,NULL,'2MASX J14132880+2825345',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000184,NULL,'18.04',0.18,NULL,NULL,NULL,NULL,NULL,1,213.37,28.42614,0,NULL,60056188500,938377945,14662155,18.04),(118020,'IRAS','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118020,32.75,0.8,35.5,52140,75,NULL,'MAT, I','ESO 271- G 022',NULL,'1997ApJS..109..333W',1997,1,2.4,NULL,'G',0.00001,NULL,'14.02',0.4,'SB(s)cd: sp',NULL,NULL,NULL,NULL,1,213.3754583,-45.41358,0.421,NULL,46805065118,731329142,11427017,14.02),(118021,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118021,32.57,0.43,32.7,52140,75,NULL,'MAT, I, raw','ESO 271- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118022,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118022,32.64,0.32,33.7,52140,85,NULL,'I, raw','ESO 271- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118023,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118023,32.68,0.32,34.3,52140,85,NULL,'I, inv','ESO 271- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118024,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118024,32.74,0.49,35.3,52140,75,NULL,'IR','ESO 271- G 022',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118025,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118025,32.75,0.43,35.4,52140,75,NULL,'MAT, I, inv','ESO 271- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118026,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118026,32.84,0.43,36.9,52140,75,NULL,'MAT, I, cor','ESO 271- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118027,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118027,32.93,0.2,38.6,52140,74.4,NULL,NULL,'ESO 271- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118028,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118028,33.03,0.43,40.4,52140,75,NULL,'3.6 micron, color corrected','ESO 271- G 022',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118029,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118029,33.08,0.49,41.4,52140,NULL,NULL,NULL,'ESO 271- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118030,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118030,33.12,0.43,42.1,52140,75,NULL,'3.6 micron, color + selection bias corrected','ESO 271- G 022',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118031,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118031,33.14,0.47,42.4,52140,NULL,NULL,'Malmquist cor.','ESO 271- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118032,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118032,37.74,0.33,354,52141,70,NULL,NULL,'2MASX J14133032+0812143',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.0002,NULL,'18.18',0.17,NULL,NULL,NULL,NULL,NULL,1,213.3765,8.20386,0.035,NULL,58503798826,914121856,14283154,18.18),(118033,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118033,38.19,0.46,434,52142,70,NULL,NULL,'SDSS J141332.57+430713.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000143,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,213.3857083,43.12036,0,NULL,59226730633,925417666,14459651,18.4),(118034,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118034,36.95,0.46,245,52143,70,NULL,NULL,'2MASXi J1413340+400908',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00012,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,213.391916667,40.15247,0,NULL,59223606256,925368847,14458888,17.6),(118035,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118035,37.44,0.46,308,52144,70,NULL,NULL,'SDSS J141334.17+314345.1',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'15.9g',0.39,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,213.392375,31.72922,0,NULL,60052948179,938327315,14661364,15.9),(118036,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118036,36.72,0.55,221,52145,70,NULL,NULL,'2MASX J14133582-4534105',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.8b',0.3,NULL,NULL,NULL,NULL,NULL,1,213.39925,-45.56964,0.421,NULL,46805059872,731329060,11427016,16.8),(118037,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118037,37.91,0.46,382,52146,70,NULL,NULL,'SDSS J141335.98+472108.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,213.3999583,47.35233,0.017,NULL,59246854788,925732106,14464564,17.9),(118038,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118038,36.93,0.27,243,52147,70,NULL,NULL,'2MASX J14133652+2722365',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000174,NULL,'18.06',0.18,NULL,NULL,NULL,NULL,NULL,1,213.4020417,27.37681,0,NULL,60001475018,937523047,14648797,18.06),(118039,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118039,37.49,0.27,314,52148,70,NULL,NULL,'2MASX J14133699+1950224',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,213.4040417,19.83961,0.035,NULL,59520778091,930012157,14531439,17.7),(118040,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118040,37.59,0.33,329,52149,70,NULL,NULL,'2MASX J14133714+3105084',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,213.404917,31.08572,0,NULL,60052632466,938322382,14661287,17.4),(118041,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118041,36.04,0.46,161,52150,70,NULL,NULL,'2MASX J14133814+5415511',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000167,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,213.409041667,54.26428,0,NULL,57252374640,894568353,13977630,16.6),(118042,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118042,36.12,0.46,168,52151,70,NULL,NULL,'2MASX J14133979+4141251',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000183,NULL,'15.6g',0.46,'E0',NULL,NULL,NULL,NULL,1,213.4160417,41.69036,0,NULL,59227514379,925429912,14459842,15.6),(118043,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118043,38.37,0.46,472,52152,70,NULL,NULL,'2MASX J14134008+0530581',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000187,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,213.417083,5.51617,0.025,NULL,58476581044,913696578,14276509,17.6),(118044,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118044,37.69,0.33,345,52153,70,NULL,NULL,'2MASX J14134035+2553462',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,213.41825,25.89608,0.024,NULL,60003495686,937554620,14649290,17),(118045,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118045,37.49,0.27,314,52154,70,NULL,NULL,'2MASX J14134082+1953254',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,213.420083,19.89031,0.035,NULL,59520773195,930012081,14531438,16.7),(118046,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118046,37.87,0.23,376,52155,70,NULL,NULL,'2MASX J14134091+4345420',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00011,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,213.4202917,43.76175,0,NULL,59239324989,925614452,14462725,17.8),(118047,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118047,38.31,0.27,459,52156,70,NULL,NULL,'SDSS J141341.14+053608.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000167,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,213.4214583,5.60244,0.025,NULL,58476566748,913696355,14276505,18.4),(118048,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118048,36.66,0.46,215,52157,70,NULL,NULL,'SBS 1411+497',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000176,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,213.4260417,49.50106,0,NULL,59256420802,925881575,14466899,16.5),(118049,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118049,37.87,0.23,376,52158,70,NULL,NULL,'2MASX J14134352+4338410',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00006,NULL,'16.6g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,213.43125,43.64478,0,NULL,59239359720,925614995,14462734,16.6),(118050,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118050,37.87,0.23,376,52159,70,NULL,NULL,'2MASX J14134379+4339450',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00018,NULL,'18.4',0.15,'cD;BLRG       blazar',NULL,NULL,NULL,'Sy ?',1,213.432167,43.66253,0,NULL,59239322625,925614416,14462725,18.4),(118051,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118051,36.34,0.46,185,52160,70,NULL,NULL,'2MASX J14134472+2634583',NULL,'2015arXiv151105856S',2015,1,0.86,NULL,'G',0.000097,NULL,'15.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,213.4362917,26.58281,0,NULL,60003309235,937551706,14649245,15.5),(118052,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118052,37.33,0.46,292,52161,70,NULL,NULL,'2MASX J14134757+2231555',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.79',0.18,NULL,NULL,NULL,NULL,NULL,1,213.448333,22.532,0.013,NULL,59469932045,929217688,14519026,17.79),(118053,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118053,33.76,0.33,56.4,52162,70,NULL,NULL,'NGC 5518',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000147,NULL,'15.0',0.4,NULL,NULL,NULL,NULL,NULL,1,213.448667,20.84831,0.021,NULL,59519365562,929990086,14531095,15),(118054,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118054,36.83,0.12,232,52163,70,NULL,NULL,'2MASX J14134858+0155281',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,'FoF','18.11',0.21,NULL,NULL,NULL,NULL,NULL,1,213.4522917,1.92425,0.077,NULL,58472353347,913630521,14275476,18.11),(118055,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118055,37.87,0.33,374,52164,70,NULL,NULL,'SDSS J141348.66+065726.8',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,213.452791667,6.95747,0.033,NULL,58506148097,914158564,14283727,17.5),(118056,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118056,37.94,0.33,387,52165,70,NULL,NULL,'2MASX J14134939+5247115',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,213.4559583,52.78658,0,NULL,59249492727,925773323,14465208,17.5),(118057,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118057,38.09,0.46,415,52166,70,NULL,NULL,'2MASX J14134988+1345123',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,213.45775,13.75356,0,NULL,58366895418,911982740,14249730,17.5),(118058,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118058,37.41,0.46,303,52167,70,NULL,NULL,'SDSS J141350.16+035247.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000059,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,213.459,3.87992,0.041,NULL,58483718031,913808094,14278251,18.4),(118059,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118059,37.69,0.33,345,52168,70,NULL,NULL,'SDSS J141351.41+254408.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00018,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,213.46425,25.73572,0,NULL,60003490023,937554531,14649289,18),(118060,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118060,37.16,0.46,270,52169,70,NULL,NULL,'2MASX J14135226+2601164',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000217,NULL,'17.11',0.27,NULL,NULL,NULL,NULL,NULL,1,213.467833,26.02136,0,NULL,60003474823,937554294,14649285,17.11),(118061,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118061,37.33,0.46,293,52170,70,NULL,NULL,'2MASX J14135241+0713093',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000165,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,213.4685,7.21933,0.035,NULL,58505999448,914156241,14283691,16.5),(118062,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118062,31.39,0.49,19,52171,75,NULL,'IR','NGC 5526 NED02',NULL,'2011yCatp016004901K',2011,1,2.56,NULL,'G',0.00008,NULL,'14.1g',0.39,'Scd','Pair member (points to parent)',NULL,NULL,NULL,1,213.474,57.77133,0,NULL,57305835546,895403680,13990682,14.1),(118063,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118063,31.95,0.43,24.6,52171,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5526 NED02',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118064,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118064,32.26,0.43,28.3,52171,75,NULL,'3.6 micron, color corrected','NGC 5526 NED02',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118065,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118065,32.56,0.2,32.5,52171,74.4,NULL,NULL,'NGC 5526 NED02',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118066,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118066,33.05,NULL,40.7,52171,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 5526 NED02',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118067,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118067,33.06,NULL,41,52171,NULL,NULL,'Dipole + Quadrupole','NGC 5526 NED02',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118068,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118068,33.08,NULL,41.3,52171,NULL,NULL,'Dipole','NGC 5526 NED02',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118069,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118069,37.57,0.46,327,52172,70,NULL,NULL,'2MASX J14135437+4537330',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,213.476583,45.62592,0,NULL,59237040895,925578763,14462168,17.9),(118070,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118070,35.51,0.55,126,52173,NULL,NULL,'Malmquist cor.','ESO 446- G 033',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'15.82',0.6,'Sb',NULL,NULL,NULL,NULL,1,213.481125,-32.60944,0.177,NULL,47004450558,734444539,11475695,15.82),(118071,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118071,35.56,0.53,130,52173,NULL,NULL,NULL,'ESO 446- G 033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118072,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118072,35.6,0.2,132,52173,74.4,NULL,NULL,'ESO 446- G 033',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118073,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118073,38.25,0.21,447,52174,70,NULL,NULL,'2MASX J14135607+0648485',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000167,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,213.483583333,6.81358,0.037,NULL,58505683299,914151301,14283614,18),(118074,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118074,36.83,0.12,232,52175,70,NULL,NULL,'CGCG 018-085',NULL,'2015arXiv151105856S',2015,1,0.57,'UZC has V = 16026 +- 47 km/sec.','G',0.000095,NULL,'16.0g',0.31,'S0','Group member',NULL,NULL,NULL,1,213.497666667,1.83181,0.077,NULL,58472479371,913632490,14275507,16),(118075,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118075,36.69,0.46,218,52176,70,NULL,NULL,'2MASX J14140022-0259299',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000155,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,213.500833,-2.99169,0.129,NULL,43724122480,683189413,10674834,16.9),(118076,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118076,37.76,0.46,356,52177,70,NULL,NULL,'2MASX J14140067+4845564',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000171,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,213.5027083,48.76572,0.091,NULL,59256488903,925882639,14466916,17.5),(118077,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118077,37.59,0.33,329,52178,70,NULL,NULL,'2MASX J14140145+3108537',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'18.33',0.15,NULL,NULL,NULL,NULL,NULL,1,213.505916667,31.14822,0,NULL,60052652740,938322699,14661292,18.33),(118078,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118078,37.99,0.46,397,52179,70,NULL,NULL,'2MASX J14140149+1239404',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000176,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,213.5062083,12.66117,0,NULL,58353437897,911772467,14246444,18.2),(118079,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118079,37.41,0.46,304,52180,70,NULL,NULL,'SDSS J141401.96+190403.8',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,213.5082083,19.06772,0,NULL,59521038357,930016224,14531503,NULL),(118080,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118080,37.25,0.33,282,52181,70,NULL,NULL,'2MASX J14140222+4753520',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000177,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,213.5092083,47.89786,0.034,NULL,59255948571,925874196,14466784,17.7),(118081,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118081,37.15,0.46,270,52182,70,NULL,NULL,'SDSS J141402.27+241633.2',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000213,NULL,'16.0g',0.39,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,213.5094583,24.27592,0,NULL,59470772059,929230813,14519231,16),(118082,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118082,36.05,0.46,162,52183,70,NULL,NULL,'CGCG 018-086',NULL,'2015arXiv151105856S',2015,1,0.45,'Beers et al (1995AJ....109..874B) have V = 16064 +- 50 km/s.','G',0.00009,NULL,'15.9g',0.35,'S0a','Group member',NULL,NULL,NULL,1,213.509625,1.84789,0.077,NULL,58472480629,913632509,14275507,15.9),(118083,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:35','1','PS1 SN PS10kl','N',118083,41.82,0.16,1600,52184,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10kl HOST',0.4434,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118084,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118084,35.85,0.6,148,52185,70,NULL,NULL,'2MASX J14140548-0744061',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.2b',0.3,NULL,NULL,NULL,NULL,NULL,1,213.522917,-7.73525,0.093,NULL,43740583273,683446613,10678853,16.2),(118085,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118085,38.25,0.21,447,52186,70,NULL,NULL,'2MASX J14140580+0653395',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00013,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.52425,6.89444,0.033,NULL,58506095777,914157746,14283714,17.5),(118086,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118086,37.58,0.27,327,52187,70,NULL,NULL,'2MASX J14140648+0843195',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.98',0.17,NULL,NULL,NULL,NULL,NULL,1,213.526875,8.72219,0.017,NULL,58496900375,914014068,14281469,17.98),(118087,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118087,37.06,0.46,258,52188,70,NULL,NULL,'2MASX J14140900+4311510',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000195,NULL,'15.8g',0.42,'E0',NULL,NULL,NULL,NULL,1,213.537375,43.19736,0,NULL,59224890434,925388913,14459201,15.8),(118088,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118088,38.25,0.21,447,52189,70,NULL,NULL,'2MASX J14141231+0652025',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000169,NULL,'16.6g',0.38,'BrClG',NULL,NULL,NULL,NULL,1,213.551333,6.86747,0.033,NULL,58506093735,914157714,14283714,16.6),(118089,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118089,37.79,0.46,361,52190,70,NULL,NULL,'2MASX J14141245+1837255',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,213.551917,18.62381,0,NULL,59517462200,929960346,14530630,NULL),(118090,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118090,37.17,0.46,272,52191,70,NULL,NULL,'VIII Zw 384',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000069,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.5519583,1.07553,0.065,NULL,58469612727,913587698,14274807,17.4),(118091,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118091,38.14,0.46,425,52192,70,NULL,NULL,'2MASX J14141263+0816335',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.552541667,8.27614,0.036,NULL,58496298172,914004658,14281322,17.4),(118092,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118092,34.26,0.4,71.1,52193,NULL,NULL,'mean','UGC 09110',NULL,'2007A&A...465...71T',2007,1,1.85,NULL,'G',0.000031,NULL,'13.9g',0.62,'SBb','Group member',NULL,NULL,NULL,1,213.555833,15.62242,0,NULL,58357550171,911836721,14247448,13.9),(118093,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118093,34.45,0.47,77.6,52193,NULL,NULL,'H','UGC 09110',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118094,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118094,34.56,0.46,81.5,52193,NULL,NULL,'J','UGC 09110',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118095,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118095,34.58,0.45,82.4,52193,NULL,NULL,'K','UGC 09110',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118096,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118096,37.19,0.46,275,52194,70,NULL,NULL,'2MASX J14141406+0314360',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000087,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,213.558416667,3.24325,0.049,NULL,58484184239,913815378,14278365,16.4),(118097,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118097,37.61,0.46,332,52195,70,NULL,NULL,'2MASX J14141461+5057121',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000135,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.561,50.95347,0,NULL,59251558930,925805608,14465712,17.3),(118098,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118098,38.31,0.27,459,52196,70,NULL,NULL,'2MASX J14141479+0523490',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000077,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.561583,5.39711,0.037,NULL,58476555164,913696174,14276502,17.7),(118099,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118099,37.58,0.27,327,52197,70,NULL,NULL,'2MASX J14141579+0836405',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000186,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,213.565667,8.61131,0.017,NULL,58496895690,914013995,14281468,16.6),(118100,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118100,38.25,0.21,447,52198,70,NULL,NULL,'2MASX J14141601+0652365',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000057,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,213.566625,6.87686,0.033,NULL,58506097913,914157779,14283715,17.4),(118101,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118101,36.6,0.46,209,52199,70,NULL,NULL,'VII Zw 540 NOTES02',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000065,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,213.568417,63.5505,0.021,NULL,57749669667,902338588,14099040,17.4),(118102,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118102,35.72,0.76,139,52200,70,NULL,NULL,'LCRS B141143.7-025714',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.000094,NULL,'16.4b',0.3,'HII',NULL,NULL,NULL,'Post Starburst (E+A) or (a+k) Galaxy',1,213.580417,-3.18653,0.125,NULL,43735989603,683374837,10677731,16.4),(118103,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118103,37.69,0.46,344,52201,70,NULL,NULL,'2MASX J14141946+2831428',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,213.581125,28.52856,0,NULL,60056292104,938379564,14662180,17.8),(118104,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118104,38.24,0.46,445,52202,70,NULL,NULL,'SDSS J141419.61+302241.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,213.58175,30.37811,0,NULL,60051168877,938299513,14660929,18.6),(118105,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118105,37.49,0.27,314,52203,70,NULL,NULL,'2MASX J14141983+1949010',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,213.5825417,19.81697,0.035,NULL,59521241836,930019403,14531553,16.2),(118106,'IRAS','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118106,35.03,0.8,102,52204,75,NULL,'HMCL, I','NGC 5519',NULL,'1997ApJS..109..333W',1997,1,1.24,'Identification as NGC 5570 is uncertain.','G',0.00001,NULL,'14.4g',0.75,'Sa',NULL,NULL,NULL,NULL,1,213.5869583,7.51592,0.042,NULL,58505844089,914153813,14283653,14.4),(118107,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118107,34.19,0.69,69,52204,100,NULL,'mid-IR','NGC 5519',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118108,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118108,34.48,0.49,78.8,52204,NULL,NULL,NULL,'NGC 5519',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118109,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118109,34.57,0.47,82,52204,NULL,NULL,'Malmquist cor.','NGC 5519',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118110,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118110,34.97,0.2,98.6,52204,74.4,NULL,NULL,'NGC 5519',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118111,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118111,35.1,0.4,105,52204,75,NULL,'HMCL, I, raw','NGC 5519',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118112,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118112,35.17,0.4,108,52204,NULL,NULL,'mean','NGC 5519',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118113,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118113,35.23,0.4,111,52204,75,NULL,'HMCL, I, cor','NGC 5519',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118114,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118114,35.33,0.4,117,52204,75,NULL,'HMCL, I, inv','NGC 5519',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118115,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118115,35.47,0.47,124,52204,NULL,NULL,'H','NGC 5519',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118116,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118116,37.29,0.46,286,52205,70,NULL,NULL,'2MASX J14142188+2302340',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,213.591125,23.04272,0,NULL,59469737103,929214642,14518978,17.7),(118117,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118117,35.15,0.2,107,52206,74.4,NULL,NULL,'SDSS J141423.26+103445.5',NULL,'2013AJ....146...86T',2013,1,0.66,NULL,'G',0.000073,NULL,'16.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,213.5969583,10.57933,0.009,NULL,58501507326,914086051,14282594,16.9),(118118,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118118,35.62,0.54,133,52207,70,NULL,NULL,'2MASX J14142455-1931470',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000103,NULL,'16.02',0.3,'(R)SB0^0:',NULL,NULL,NULL,NULL,1,213.602417,-19.52978,0.277,NULL,46565135618,727580244,11368441,16.02),(118119,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118119,36.91,0.33,241,52208,70,NULL,NULL,'2MASX J14142455+0446040',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000079,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,213.6025,4.76767,0.073,NULL,58476187675,913690432,14276413,17),(118120,'GRB','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118120,38.4,NULL,480,52209,65,NULL,'L = 10e57 photons/s','GRB 910219',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,213.6,58.91667,0.009,NULL,57272438506,894881851,13982528,NULL),(118121,'GRB','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118121,41.24,NULL,1770,52209,65,NULL,'L = 2 x 10e58 photons/s','GRB 910219',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118122,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118122,36.88,0.46,237,52210,70,NULL,NULL,'2MASX J14142539+0128230',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000095,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.605875,1.47308,0.061,NULL,58468973979,913577718,14274651,16.9),(118123,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118123,37.52,0.46,320,52211,70,NULL,NULL,'2MASX J14142555+2144450',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.78',0.15,NULL,NULL,NULL,NULL,NULL,1,213.606583,21.74594,0.032,NULL,59468952275,929202379,14518787,18.78),(118124,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118124,37.75,0.46,354,52212,70,NULL,NULL,'2MASX J14142854+4321236',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000116,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,213.619083,43.35672,0,NULL,59238784298,925606004,14462593,18),(118125,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118125,37.14,0.46,268,52213,70,NULL,NULL,'SDSS J141428.93+161440.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,213.6205417,16.24472,0,NULL,59485566516,929461976,14522843,18.3),(118126,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118126,37.69,0.46,346,52214,70,NULL,NULL,'SDSS J141429.06+065951.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000135,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,213.621083,6.99767,0.033,NULL,58505969319,914155770,14283683,18.3),(118127,'FP','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,'R',118127,36.66,0.46,215,52215,70,NULL,NULL,'2MASX J14142997+2459019',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,213.62475,24.984,0,NULL,60000100173,937501565,14648461,17),(118128,'FP','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,'R',118128,36.91,0.33,241,52216,70,NULL,NULL,'2MASX J14143037+0440070',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000098,NULL,'16.1g',0.37,'S0/a',NULL,NULL,NULL,NULL,1,213.62675,4.66861,0.045,NULL,58476045610,913688212,14276378,16.1),(118129,'FP','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,NULL,118129,34.52,0.51,80.2,52217,70,NULL,NULL,'2MASX J14143086-4826542',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.00015,NULL,'15.23',0.46,NULL,NULL,NULL,NULL,NULL,1,213.629041667,-48.44861,0.861,NULL,46839626328,731869161,11435455,15.23),(118130,'FP','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,'R',118130,37.41,0.46,303,52218,70,NULL,NULL,'2MASX J14143267+2852289',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.1g',0.23,'S0',NULL,NULL,NULL,NULL,1,213.6360417,28.87478,0,NULL,60058445386,938413209,14662706,17.1),(118131,'FP','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,'R',118131,35.53,0.46,128,52219,70,NULL,NULL,'2MASX J14143324+4045228',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000084,NULL,'16.1g',0.3,'SF',NULL,NULL,NULL,NULL,1,213.638458333,40.75636,0,NULL,59224556966,925383702,14459120,16.1),(118132,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,NULL,118132,34.41,NULL,76.2,52220,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1731',NULL,'2010Ap&SS.325..163P',2010,1,0.76,'2dF final data release has z = 0.02310 +- 0.00030.','G',0.000027,NULL,'17.0',0.08,'Sd',NULL,NULL,NULL,NULL,1,213.642208333,-4.41728,0.077,NULL,43731360977,683302515,10676601,17),(118133,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,NULL,118133,34.42,NULL,76.4,52220,NULL,NULL,'Dipole + Quadrupole','FGC 1731',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118134,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,NULL,118134,34.44,NULL,77.3,52220,NULL,NULL,'Dipole','FGC 1731',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118135,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,NULL,118135,34.46,NULL,77.9,52220,NULL,NULL,NULL,'FGC 1731',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118136,'FP','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,'R',118136,37.78,0.46,360,52221,70,NULL,NULL,'2MASX J14143435+1445491',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.80',0.13,NULL,NULL,NULL,NULL,NULL,1,213.643041667,14.76356,0,NULL,58366019571,911969055,14249516,18.8),(118137,'FP','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,'R',118137,37.58,0.27,327,52222,70,NULL,NULL,'SDSS J141434.46+084357.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,213.643583,8.73272,0.017,NULL,58496880548,914013758,14281464,18.1),(118138,'FP','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,'R',118138,38.25,0.21,447,52223,70,NULL,NULL,'SDSS J141434.66+065240.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000149,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,213.644458333,6.87783,0.033,NULL,58506084440,914157569,14283712,18.6),(118139,'FP','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,'R',118139,38.3,0.33,458,52224,70,NULL,NULL,'SDSS J141435.50+455320.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,213.6479583,45.889,0,NULL,59237019419,925578428,14462162,18.3),(118140,'FP','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,'R',118140,37.15,0.46,269,52225,70,NULL,NULL,'2MASX J14143713+1242201',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,213.654667,12.7055,0,NULL,58354136657,911783385,14246615,16.6),(118141,'FP','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,NULL,118141,35.63,0.51,133,52226,70,NULL,NULL,'2MASX J14143796-4035499',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000087,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,213.658125,-40.59728,0.297,NULL,46791853570,731122712,11423792,14.6),(118142,'FP','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,'R',118142,37.88,0.46,376,52227,70,NULL,NULL,'2MASX J14143822+0846072',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00016,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,213.6592083,8.76867,0.017,NULL,58496877452,914013710,14281464,17),(118143,'FP','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,'R',118143,38.05,0.46,407,52228,70,NULL,NULL,'2MASX J14143840+2431099',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,213.659917,24.51942,0,NULL,59467130078,929173907,14518342,18.2),(118144,'FP','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,'R',118144,37.04,0.46,256,52229,70,NULL,NULL,'2MASX J14143863+4744476',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000167,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,213.660833,47.74661,0.026,NULL,59246774806,925730856,14464544,16.4),(118145,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118145,37.97,0.46,392,52230,70,NULL,NULL,'2MASX J14143913+3906110',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000178,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,213.663,39.10306,0,NULL,60029129446,937955147,14655549,16.7),(118146,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118146,37.88,0.46,376,52231,70,NULL,NULL,'2MASX J14144087+0602352',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000182,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,213.670333,6.04306,0.025,NULL,58473064934,913641639,14275650,18),(118147,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118147,37.69,0.46,345,52232,70,NULL,NULL,'SDSS J141441.14+193001.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,213.6714583,19.50047,0,NULL,59521361912,930021279,14531582,17.9),(118148,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118148,37.65,0.46,338,52233,70,NULL,NULL,'2MASX J14144215+1405101',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000137,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,213.675791667,14.08617,0,NULL,58352681004,911760640,14246260,17.6),(118149,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118149,38.3,0.33,458,52234,70,NULL,NULL,'2MASX J14144222+4552196',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000202,NULL,'18.1g',0.13,'Candidate      BLAGN',NULL,NULL,NULL,NULL,1,213.675791667,45.87208,0,NULL,59237015842,925578372,14462162,18.1),(118150,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118150,37.29,0.46,287,52235,70,NULL,NULL,'2MASX J14144260+4124290',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,213.677333333,41.40806,0,NULL,59223906666,925373541,14458961,17.2),(118151,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118151,35.54,0.68,128,52236,70,NULL,NULL,'2MASX J14144300-1707456',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.26',NULL,NULL,NULL,NULL,NULL,NULL,1,213.679167,-17.12944,0.281,NULL,46548286555,727316977,11364327,16.26),(118152,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118152,38.07,0.46,412,52237,70,NULL,NULL,'2MASX J14144350+6501080',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000081,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,213.681,65.01883,0.057,NULL,57947502916,905429733,14147339,17.6),(118153,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118153,36.92,0.87,242,52238,70,NULL,NULL,'2MASX J14144364-3951539',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,213.681875,-39.86497,0.097,NULL,46791658556,731119664,11423744,15.6),(118154,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118154,37.65,0.46,340,52239,70,NULL,NULL,'2MASX J14144399+3159406',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.18',0.16,NULL,NULL,NULL,NULL,NULL,1,213.6834583,31.99456,0,NULL,60052920447,938326881,14661357,18.18),(118155,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118155,38.23,0.46,443,52240,70,NULL,NULL,'2MASX J14144600+3706400',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00019,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,213.69175,37.111,0,NULL,60032931036,938014547,14656477,16.8),(118156,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118156,37.34,0.46,293,52241,70,NULL,NULL,'2MASX J14144643+5900340',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,213.693416667,59.00944,0.009,NULL,57272439581,894881868,13982529,18.1),(118157,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118157,37.35,0.46,295,52242,70,NULL,NULL,'2MASX J14144704+3548246',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000177,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.696,35.80692,0,NULL,60044330871,938192669,14659260,17.3),(118158,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118158,38.19,0.46,435,52243,70,NULL,NULL,'SDSS J141448.30-004113.8',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000073,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,213.70125,-0.68719,0.085,NULL,43721594037,683149906,10674217,18.8),(118159,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118159,37.78,0.46,360,52244,70,NULL,NULL,'2MASX J14144864+2759473',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000173,NULL,'18.28',0.16,NULL,NULL,NULL,NULL,NULL,1,213.702625,27.99664,0,NULL,60056239792,938378746,14662167,18.28),(118160,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118160,35.41,0.46,121,52245,70,NULL,NULL,'2MASX J14144876+3608410',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000164,NULL,'15.6g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,213.703,36.14481,0,NULL,60030235772,937972433,14655819,15.6),(118161,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118161,37.73,0.46,352,52246,70,NULL,NULL,'2MASX J14144931+0641443',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000164,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,213.705375,6.69567,0.033,NULL,58502820703,914106573,14282915,17.3),(118162,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118162,33.79,0.47,57.2,52247,NULL,NULL,'H','NGC 5522',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.00003,NULL,'14.27',0.4,'Sb','Group member',NULL,NULL,NULL,1,213.709875,15.14689,0,NULL,58365864320,911966630,14249478,14.27),(118163,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118163,33.82,0.45,58,52247,NULL,NULL,'K','NGC 5522',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118164,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118164,33.84,0.46,58.7,52247,NULL,NULL,'J','NGC 5522',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118165,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118165,34.01,0.33,63.3,52247,NULL,NULL,NULL,'NGC 5522',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118166,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118166,34.05,0.2,64.6,52247,74.4,NULL,NULL,'NGC 5522',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118167,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118167,34.09,0.49,65.6,52247,75,NULL,'IR','NGC 5522',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118168,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118168,34.13,0.31,66.9,52247,NULL,NULL,'Malmquist cor.','NGC 5522',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118169,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118169,34.22,0.4,69.9,52247,NULL,NULL,'mean','NGC 5522',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118170,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118170,37.34,0.46,294,52248,70,NULL,NULL,'2MASXi J1414505-003233',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000068,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,213.71025,-0.54264,0.085,NULL,43721577047,683149641,10674213,18),(118171,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118171,37.68,0.46,343,52249,70,NULL,NULL,'2MASX J14145101+4009180',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000172,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,213.712667,40.15514,0,NULL,59223594530,925368664,14458885,18),(118172,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118172,34.45,0.46,77.6,52250,70,NULL,NULL,'IC 0989',NULL,'2015arXiv151105856S',2015,1,1.09,'UGC misprints name as \'MCG +00-36-(27)\'.','G',0.000103,NULL,'13.9g',0.94,'E              LINER','in a pair',NULL,NULL,'Flat-Spectrum Radio Source',1,213.713917,3.13089,0.081,NULL,58483421600,913803462,14278179,13.9),(118173,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118173,34.56,0.45,81.6,52250,NULL,NULL,'K','IC 0989',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118174,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118174,35.22,0.4,110,52250,NULL,NULL,'mean','IC 0989',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118175,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118175,36.34,0.33,185,52251,70,NULL,NULL,'2MASX J14145153+4012270',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,213.71475,40.20739,0,NULL,59223593704,925368651,14458885,16.8),(118176,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118176,37.68,0.19,343,52252,70,NULL,NULL,'2MASX J14145163+5024086',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000191,NULL,'15.9g',0.49,'E0',NULL,NULL,NULL,NULL,1,213.715291667,50.40231,0.005,NULL,59253390063,925834219,14466159,15.9),(118177,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118177,36.85,0.33,235,52253,70,NULL,NULL,'2MASX J14145190+0328452',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000077,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,213.7162917,3.47936,0.045,NULL,58484229638,913816088,14278376,16.7),(118178,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118178,33.27,0.69,45,52254,100,NULL,'mid-IR','UGC 09117',NULL,'2013ApJ...771...88L',2013,1,1.44,NULL,'G',0.000004,NULL,'14.0g',0.79,'Sa','in a pair',NULL,NULL,NULL,1,213.716833,14.12586,0,NULL,58352618719,911759667,14246244,14),(118179,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118179,34.31,0.37,72.8,52254,NULL,NULL,NULL,'UGC 09117',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118180,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118180,34.32,0.2,73.1,52254,74.4,NULL,NULL,'UGC 09117',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118181,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118181,34.35,0.37,74,52254,NULL,NULL,'Malmquist cor.','UGC 09117',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118182,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118182,34.41,0.4,76.1,52254,NULL,NULL,'mean','UGC 09117',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118183,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118183,34.7,0.47,87.3,52254,NULL,NULL,'H','UGC 09117',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118184,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118184,34.74,0.45,88.5,52254,NULL,NULL,'K','UGC 09117',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118185,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118185,34.77,0.46,89.9,52254,NULL,NULL,'J','UGC 09117',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118186,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118186,37.68,0.19,343,52255,70,NULL,NULL,'2MASX J14145213+5030186',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000182,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,213.717,50.50506,0.005,NULL,59253387083,925834173,14466158,17.2),(118187,'IRAS','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118187,31.44,0.8,19.4,52256,75,NULL,'A82, H','NGC 5523',NULL,'1997ApJS..109..333W',1997,1,4.6,NULL,'G',0.000018,NULL,'12.75',1.3,'SA(s)cd:','Isolated galaxy',NULL,NULL,NULL,1,213.718,25.31761,0,NULL,60000194344,937503036,14648484,12.75),(118188,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118188,31.18,0.4,17.2,52256,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5523',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118189,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118189,31.38,0.4,18.9,52256,75,NULL,NULL,'NGC 5523',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118190,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118190,31.41,0.45,19.2,52256,NULL,NULL,'Malmquist cor.','NGC 5523',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118191,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118191,31.43,0.47,19.3,52256,75,NULL,'A82, H, inv','NGC 5523',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118192,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118192,31.44,0.47,19.4,52256,75,NULL,'A82, H, raw','NGC 5523',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118193,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118193,31.57,0.36,20.6,52256,NULL,NULL,NULL,'NGC 5523',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118194,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118194,31.59,0.47,20.8,52256,75,NULL,'A82, H, cor','NGC 5523',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118195,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118195,31.61,0.2,21,52256,74.4,NULL,NULL,'NGC 5523',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118196,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118196,31.66,0.4,21.5,52256,75,NULL,'B','NGC 5523',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118197,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118197,31.71,0.43,22,52256,75,NULL,'3.6 micron, color corrected','NGC 5523',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118198,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118198,31.75,0.38,22.4,52256,NULL,NULL,NULL,'NGC 5523',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118199,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118199,31.82,0.43,23.1,52256,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5523',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118200,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118200,32.2,0.49,27.5,52256,75,NULL,'IR','NGC 5523',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118201,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118201,38.13,0.33,423,52257,70,NULL,NULL,'2MASX J14145228+5654340',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000105,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,213.717917,56.9095,0,NULL,57306879268,895419988,13990937,18),(118202,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118202,37.01,0.58,253,52258,70,NULL,NULL,'2MASX J14145257-2222033',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.37',NULL,NULL,NULL,NULL,NULL,NULL,1,213.719,-22.36778,0.305,NULL,46511864213,726747878,11355435,16.37),(118203,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118203,38.24,0.46,445,52259,70,NULL,NULL,'SDSS J141453.39+550319.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,213.7225,55.05542,0.025,NULL,57252990871,894577982,13977780,18.3),(118204,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118204,38.17,0.46,431,52260,70,NULL,NULL,'2MASX J14145358+6045141',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000172,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,213.723083,60.75403,0.025,NULL,57753546944,902399171,14099987,18.3),(118205,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118205,37.73,0.46,351,52261,70,NULL,NULL,'2MASX J14145375+5924130',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,213.723833,59.40356,0.037,NULL,57272526958,894883233,13982550,17.3),(118206,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118206,31.81,NULL,23,52262,NULL,NULL,NULL,'SDSS J1414-0208',NULL,'2014A&A...562A..49M',2014,1,0.34,NULL,'G',0.000011,NULL,'18.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,213.725625,-2.13969,0.157,NULL,43723901967,683185968,10674780,18),(118207,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118207,36.25,0.33,178,52263,70,NULL,NULL,'NGC 5540',NULL,'2015arXiv151105856S',2015,1,0.87,NULL,'G',0.000073,NULL,'14.5g',0.7,'E0',NULL,NULL,NULL,NULL,1,213.7267917,60.01111,0.037,NULL,57272802309,894887536,13982617,14.5),(118208,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118208,36.53,0.46,202,52264,70,NULL,NULL,'2MASX J14145472+3053216',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000192,NULL,'15.7g',0.47,NULL,NULL,NULL,NULL,NULL,1,213.728,30.88933,0,NULL,60052513653,938320525,14661258,15.7),(118209,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118209,37.17,0.68,272,52265,70,NULL,NULL,'LCRS B141219.6-031320',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00009,NULL,'16.7b',0.34,NULL,NULL,NULL,NULL,NULL,1,213.7307083,-3.45467,0.097,NULL,43735220553,683362821,10677544,16.7),(118210,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118210,36.69,0.33,217,52266,70,NULL,NULL,'2MASX J14145536+1656490',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.57',0.15,NULL,NULL,NULL,NULL,NULL,1,213.7307083,16.94686,0,NULL,59487625479,929494148,14523346,18.57),(118211,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118211,36.57,0.27,206,52267,70,NULL,NULL,'ARK 442',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'15.7',0.17,NULL,NULL,NULL,NULL,NULL,1,213.732208333,18.52206,0,NULL,59520857744,930013402,14531459,15.7),(118212,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118212,38.13,0.33,423,52268,70,NULL,NULL,'2MASX J14145631+5654080',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,213.734375,56.90225,0,NULL,57306889492,895420148,13990939,18.1),(118213,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118213,37.24,0.46,280,52269,70,NULL,NULL,'2MASX J14145756+2221479',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.18',0.17,NULL,NULL,NULL,NULL,NULL,1,213.739833333,22.36333,0.009,NULL,59469030683,929203604,14518806,18.18),(118214,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118214,36.83,0.46,232,52270,70,NULL,NULL,'2MASX J14145772+2020539',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,213.7405,20.34856,0,NULL,59520081082,930001266,14531269,17.3),(118215,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118215,37.53,0.33,321,52271,70,NULL,NULL,'2MASX J14145870+2621594',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000209,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,213.744667,26.36661,0,NULL,60003447367,937553865,14649279,16.6),(118216,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118216,36.25,0.33,178,52272,70,NULL,NULL,'2MASX J14150016+5958061',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000178,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.750917,59.9685,0.037,NULL,57272806234,894887597,13982618,17),(118217,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118217,35.82,0.46,146,52273,70,NULL,NULL,'CGCG 018-093',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.00008,NULL,'15.1g',0.48,'E0',NULL,NULL,NULL,NULL,1,213.752625,-0.79694,0.085,NULL,43722285038,683160703,10674385,15.1),(118218,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118218,37.76,0.46,357,52274,70,NULL,NULL,'LCRS B141225.4-023440',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,213.7535417,-2.81003,0.129,NULL,43724434961,683194296,10674910,17.8),(118219,'Tully est','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118219,32.08,0.8,26,52275,75,NULL,NULL,'IC 4386',NULL,'1988NBGC.C....0000T',1988,1,3,'The 2MASX position refers to a knot northwest of the nucleus.','G',0.000027,NULL,'12.74',1.8,'SB(s)d pec','Pair member (points to parent)',NULL,NULL,NULL,1,213.759875,-43.96133,0.337,NULL,46805653913,731338342,11427161,12.74),(118220,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118220,31.54,0.36,20.3,52275,NULL,NULL,NULL,'IC 4386',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118221,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118221,32.1,0.2,26.3,52275,74.4,NULL,NULL,'IC 4386',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118222,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118222,33.6,0.49,52.5,52275,75,NULL,'IR','IC 4386',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118223,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118223,38.19,0.46,434,52276,70,NULL,NULL,'2MASX J14150249+0526414',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000086,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,213.760541667,5.44478,0.025,NULL,58476636146,913697439,14276522,17.5),(118224,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118224,37.79,0.46,361,52277,70,NULL,NULL,'2MASX J14150254+2842284',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000176,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,213.760541667,28.70797,0,NULL,60058369487,938412023,14662687,17.1),(118225,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118225,38.18,0.46,433,52278,70,NULL,NULL,'2MASX J14150364+5204336',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000178,NULL,'17.3g',0.22,'AGN',NULL,NULL,NULL,NULL,1,213.765083333,52.07619,0,NULL,59251125463,925798835,14465606,17.3),(118226,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118226,36.89,0.46,239,52279,70,NULL,NULL,'2MASX J14150416+0543304',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000156,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,213.767458333,5.72519,0.021,NULL,58476495715,913695245,14276488,16.8),(118227,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118227,37.53,0.33,321,52280,70,NULL,NULL,'2MASX J14150436+2622184',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.50',0.15,NULL,NULL,NULL,NULL,NULL,1,213.7682083,26.37192,0,NULL,60003447429,937553866,14649279,18.5),(118228,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118228,36.34,0.33,185,52281,70,NULL,NULL,'2MASX J14150507+4014059',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000172,NULL,'16.2g',0.38,'BrClG',NULL,NULL,NULL,NULL,1,213.771083333,40.23506,0,NULL,59223812041,925372063,14458938,16.2),(118229,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118229,37.61,0.46,333,52282,70,NULL,NULL,'2MASX J14150607+1629580',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.34',0.18,NULL,NULL,NULL,NULL,NULL,1,213.775583,16.49942,0,NULL,59485481015,929460640,14522822,18.34),(118230,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118230,38.39,0.46,477,52283,70,NULL,NULL,'2MASX J14150755+4407480',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,213.781625,44.13014,0,NULL,59239377540,925615274,14462738,17.4),(118231,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118231,36.2,0.46,174,52284,70,NULL,NULL,'2MASX J14150778+1105026',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,213.782333333,11.08397,0,NULL,58500662141,914072845,14282388,16.4),(118232,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118232,35.14,0.4,107,52285,NULL,NULL,'mean','UGC 09118',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.00009,NULL,'15.5g',0.36,'Sb(f)',NULL,NULL,NULL,NULL,1,213.783417,3.11272,0.081,NULL,58483469707,913804214,14278190,15.5),(118233,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118233,35.61,0.45,132,52285,NULL,NULL,'K','UGC 09118',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118234,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118234,35.65,0.47,135,52285,NULL,NULL,'H','UGC 09118',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118235,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118235,37.71,0.46,349,52286,70,NULL,NULL,'2MASX J14150801+4027149',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000156,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,213.783333,40.45414,0,NULL,59223658548,925369664,14458901,18.2),(118236,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118236,37.44,0.33,308,52287,70,NULL,NULL,'2MASX J14150819+0435044',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000082,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,213.784083333,4.58442,0.045,NULL,58476011883,913687685,14276370,17.3),(118237,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118237,37.78,0.33,360,52288,70,NULL,NULL,'SDSS J141509.09+131647.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000134,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,213.787917,13.27989,0,NULL,58354007499,911781367,14246583,18.5),(118238,'TRGB','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118238,29.74,0.1,8.87,52289,74.4,NULL,NULL,'KUG 1413+573',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000003,NULL,'16.5:',0.3,'Ir',NULL,NULL,NULL,NULL,1,213.7887917,57.08761,0,NULL,57304820129,895387814,13990434,16.5),(118239,'TRGB','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118239,29.86,0.14,9.4,52289,NULL,NULL,NULL,'KUG 1413+573',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118240,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118240,29.29,NULL,7.21,52289,NULL,NULL,NULL,'KUG 1413+573',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118241,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118241,36.42,0.46,193,52290,70,NULL,NULL,'2MASX J14150986+0428404',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000069,NULL,'16.2g',0.32,'S0^-',NULL,NULL,NULL,NULL,1,213.791,4.47792,0.045,NULL,58475604578,913681321,14276270,16.2),(118242,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118242,36.96,0.46,246,52291,70,NULL,NULL,'MRK 0807',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000188,NULL,'16.1g',0.4,'E0',NULL,NULL,NULL,NULL,1,213.797,58.96181,0.009,NULL,57269563685,894836932,13981827,16.1),(118243,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118243,35.28,0.46,114,52292,70,NULL,NULL,'2MASX J14151157+3704389',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000166,NULL,'15.5g',0.49,'E',NULL,NULL,NULL,NULL,1,213.798416667,37.07758,0,NULL,60032937144,938014642,14656478,15.5),(118244,'IRAS','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118244,34.27,0.8,71.4,52293,75,NULL,'CF, r','UGC 09121',NULL,'1997ApJS..109..333W',1997,1,1.4,'HOLM 617B is a double star.','G',0.00002,NULL,'14.47',0.7,'Sbc',NULL,NULL,NULL,NULL,1,213.7989583,15.74208,0,NULL,59484923622,929451931,14522686,14.47),(118245,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118245,34.58,0.38,82.5,52293,75,NULL,'CF, r, raw','UGC 09121',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118246,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118246,34.63,0.47,84.2,52293,NULL,NULL,'Malmquist cor.','UGC 09121',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118247,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118247,34.66,0.2,85.5,52293,74.4,NULL,NULL,'UGC 09121',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118248,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118248,34.66,0.46,85.7,52293,NULL,NULL,NULL,'UGC 09121',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118249,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118249,34.71,0.38,87.6,52293,75,NULL,'CF, r, inv','UGC 09121',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118250,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118250,34.76,0.38,89.5,52293,75,NULL,'CF, r, cor','UGC 09121',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118251,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118251,37.74,0.33,352,52294,70,NULL,NULL,'2MASX J14151372+4140278',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000195,NULL,'16.0g',0.36,'E0',NULL,NULL,NULL,NULL,1,213.8070417,41.67433,0,NULL,59227433846,925428653,14459822,16),(118252,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118252,36.67,0.46,216,52295,70,NULL,NULL,'2MASX J14151368+0450044',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000081,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.807125,4.83475,0.041,NULL,58476910662,913701729,14276589,17.4),(118253,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118253,35.71,0.46,139,52296,70,NULL,NULL,'2MASX J14151509+4752240',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000187,NULL,'15.5g',0.39,'S0a',NULL,NULL,NULL,NULL,1,213.813083333,47.87333,0.036,NULL,59247237126,925738080,14464657,15.5),(118254,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118254,37.41,0.46,304,52297,70,NULL,NULL,'2MASX J14151553+1342286',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'16.5r',NULL,NULL,NULL,NULL,NULL,NULL,1,213.81475,13.70794,0,NULL,58354340404,911786568,14246665,16.5),(118255,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118255,36.7,0.46,219,52298,70,NULL,NULL,'2MASX J14151668+4701000',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000177,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,213.819417,47.01675,0,NULL,59246742762,925730355,14464536,16.2),(118256,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118256,37.87,0.33,374,52299,70,NULL,NULL,'2MASX J14151673+0704026',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,213.819625,7.06731,0.025,NULL,58502523218,914101925,14282842,17.6),(118257,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118257,34.16,0.43,68,52300,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J14151678-0421318',NULL,'2014MNRAS.444..527S',2014,1,1.07,'HOLM 615B is a star.','G',0.000019,NULL,'14.99',0.41,'SBd',NULL,NULL,NULL,NULL,1,213.820083,-4.35886,0.089,NULL,43731218509,683300289,10676567,14.99),(118258,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118258,36.58,0.51,207,52301,70,NULL,NULL,'CGCG 018-095',NULL,'2014MNRAS.445.2677S',2014,1,1.05,NULL,'G',0.000103,NULL,'15.2g',0.34,'S0/a',NULL,NULL,NULL,NULL,1,213.824917,-2.44475,0.157,NULL,43724532373,683195818,10674934,15.2),(118259,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118259,37.84,0.46,369,52302,70,NULL,NULL,'2MASX J14151885+4231080',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000148,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,213.8284583,42.51881,0,NULL,59226861035,925419703,14459682,17.7),(118260,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118260,36.69,0.33,217,52303,70,NULL,NULL,'CGCG 103-130',NULL,'2015arXiv151105856S',2015,1,0.3,'HOLM 619B is a star.','G',0.000217,NULL,'15.4',0.25,NULL,NULL,NULL,NULL,NULL,1,213.828917,16.88797,0,NULL,59487620115,929494064,14523344,15.4),(118261,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118261,35.09,0.68,104,52304,70,NULL,NULL,'2MASX J14151916-4451403',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,213.8299583,-44.86128,0.349,NULL,46808165188,731377581,11427774,15.1),(118262,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118262,37.24,0.33,281,52305,70,NULL,NULL,'2MASX J14152031+5220446',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000207,NULL,'15.6g',0.45,'BrClG',NULL,NULL,NULL,NULL,1,213.834833,52.34589,0,NULL,59252148998,925814828,14465856,15.6),(118263,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118263,37.69,0.46,345,52306,70,NULL,NULL,'2MASX J14152044+0844526',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000172,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,213.835333,8.74794,0.033,NULL,58496560451,914008757,14281386,17.3),(118264,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118264,36.93,0.46,243,52307,70,NULL,NULL,'2MASX J14152109+0343044',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000072,NULL,'16.9g',0.32,NULL,NULL,NULL,NULL,NULL,1,213.838083,3.71797,0.049,NULL,58483345557,913802274,14278160,16.9),(118265,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118265,37.44,0.33,308,52308,70,NULL,NULL,'SDSS J141522.25+043947.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000068,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,213.84275,4.66317,0.041,NULL,58476017735,913687777,14276371,17.9),(118266,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118266,36.94,0.46,244,52309,70,NULL,NULL,'2MASX J14152382+6254261',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00018,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,213.849083333,62.90725,0,NULL,57750002563,902343790,14099121,16.5),(118267,'IRAS','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118267,35.04,0.8,102,52310,75,NULL,'HMCL, I','KUG 1412+082',NULL,'1997ApJS..109..333W',1997,1,0.99,NULL,'G',0.00007,NULL,'15.9g',0.26,'Spiral',NULL,NULL,NULL,NULL,1,213.850083,8.01117,0.065,NULL,58496352782,914005512,14281336,15.9),(118268,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118268,35.12,0.4,105,52310,75,NULL,'HMCL, I, raw','KUG 1412+082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118269,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118269,35.22,0.4,111,52310,75,NULL,'HMCL, I, inv','KUG 1412+082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118270,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118270,35.24,0.4,112,52310,75,NULL,'HMCL, I, cor','KUG 1412+082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118271,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118271,37.32,0.46,292,52311,70,NULL,NULL,'2MASX J14152524+3033534',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,213.855083333,30.56486,0,NULL,60052472916,938319889,14661248,17),(118272,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118272,37.47,0.46,311,52312,70,NULL,NULL,'2MASX J14152548+1833537',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.8560417,18.56492,0,NULL,59520848552,930013258,14531457,17.7),(118273,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118273,38.01,0.33,400,52313,70,NULL,NULL,'2MASX J14152649+4406419',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,213.860333,44.11147,0,NULL,59238914538,925608039,14462625,18.3),(118274,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118274,37.78,0.33,360,52314,70,NULL,NULL,'2MASX J14152822+1316296',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,213.867541667,13.27486,0,NULL,58353927926,911780123,14246564,17.6),(118275,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118275,37.75,0.46,354,52315,70,NULL,NULL,'2MASX J14152833+0501234',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000082,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.8680417,5.02328,0.037,NULL,58476949901,913702342,14276599,17.5),(118276,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118276,37.24,0.33,281,52316,70,NULL,NULL,'2MASX J14152908+5221538',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000159,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,213.871125,52.36497,0,NULL,59252149534,925814836,14465856,17),(118277,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118277,37.27,0.46,284,52317,70,NULL,NULL,'2MASX J14152975+4640029',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000173,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,213.8740417,46.6675,0.01,NULL,59229017769,925453402,14460209,16.9),(118278,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118278,37.85,0.46,372,52318,70,NULL,NULL,'2MASX J14153019+6331071',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000075,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,213.8757917,63.51856,0.025,NULL,57750205556,902346961,14099171,17.2),(118279,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118279,37.08,0.33,261,52319,70,NULL,NULL,'2MASX J14153017+5129549',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000195,NULL,'15.8g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,213.8759583,51.49856,0,NULL,59251656567,925807133,14465736,15.8),(118280,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118280,37.85,0.46,372,52320,70,NULL,NULL,'2MASX J14153036+5412550',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,213.876625,54.21536,0,NULL,59194805127,924918830,14451856,18),(118281,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118281,37.89,0.46,379,52321,70,NULL,NULL,'SDSS J141531.79+205410.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,213.8825,20.90303,0.008,NULL,59519458167,929991533,14531117,18.5),(118282,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118282,36.57,0.27,206,52322,70,NULL,NULL,'CGCG 103-131',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00009,NULL,'15.7',0.6,NULL,NULL,NULL,NULL,NULL,1,213.883083,18.52092,0,NULL,59518758018,929980594,14530946,15.7),(118283,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118283,37.22,0.27,278,52323,70,NULL,NULL,'2MASX J14153196+5155079',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.88325,51.91889,0,NULL,59251339227,925802175,14465658,17.4),(118284,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118284,38.46,0.46,492,52324,70,NULL,NULL,'2MASX J14153203+4900009',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.883291667,49.00031,0,NULL,59256402985,925881296,14466895,17.7),(118285,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118285,37.8,0.46,362,52325,70,NULL,NULL,'2MASX J14153210+2333437',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.8837917,23.56217,0,NULL,59470447909,929225748,14519152,17.6),(118286,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118286,37.9,0.46,380,52326,70,NULL,NULL,'2MASX J14153245+0457026',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000086,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,213.885,4.95078,0.037,NULL,58476878291,913701223,14276581,17.5),(118287,'IRAS','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118287,33.76,0.8,56.5,52327,75,NULL,'HMCL, I','ESO 385- G 002',NULL,'1997ApJS..109..333W',1997,1,0.8,NULL,'G',0.00015,NULL,'14.79',0.4,'S?',NULL,NULL,NULL,NULL,1,213.8864583,-35.53214,0.153,NULL,47006989363,734484208,11476315,14.79),(118288,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118288,33.43,0.4,48.6,52327,75,NULL,'HMCL, I, raw','ESO 385- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118289,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118289,33.45,0.4,49,52327,75,NULL,'HMCL, I, inv','ESO 385- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118290,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118290,33.65,0.4,53.7,52327,75,NULL,'HMCL, I, cor','ESO 385- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118291,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118291,36.23,0.46,176,52328,70,NULL,NULL,'CGCG 247-016',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000198,NULL,'15.5g',0.4,'S0',NULL,NULL,NULL,NULL,1,213.887167,50.18103,0.029,NULL,59253867849,925841685,14466276,15.5),(118292,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118292,37.08,0.33,261,52329,70,NULL,NULL,'2MASX J14153331+5123159',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000185,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,213.8889583,51.38792,0,NULL,59251664776,925807262,14465738,16.3),(118293,'IRAS','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118293,34,0.8,63.2,52330,75,NULL,'MAT, I','ESO 579- G 009',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000027,NULL,'15.39',0.7,'SAB:(r)d:',NULL,NULL,NULL,NULL,1,213.8912917,-20.66242,0.281,NULL,46562998798,727546856,11367919,15.39),(118294,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118294,33.65,0.32,53.6,52330,85,NULL,'I, raw','ESO 579- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118295,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118295,33.65,0.32,53.8,52330,85,NULL,'I, inv','ESO 579- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118296,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118296,33.93,0.43,61,52330,75,NULL,'MAT, I, raw','ESO 579- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118297,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118297,34,0.43,63.2,52330,75,NULL,'MAT, I, inv','ESO 579- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118298,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118298,34.05,0.2,64.6,52330,74.4,NULL,NULL,'ESO 579- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118299,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118299,34.21,0.43,69.4,52330,75,NULL,'MAT, I, cor','ESO 579- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118300,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118300,34.25,0.53,70.7,52330,NULL,NULL,NULL,'ESO 579- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118301,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118301,34.39,0.5,75.6,52330,NULL,NULL,'Malmquist cor.','ESO 579- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118302,'IRAS','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118302,33.17,0.8,43,52331,75,NULL,'A82, H','NGC 5529',NULL,'1997ApJS..109..333W',1997,1,6.35,NULL,'G',0.000001,NULL,'12.9g',0.64,'Sc','in a radial-velocity based grouping',NULL,NULL,NULL,1,213.8919583,36.22658,0,NULL,60030254314,937972723,14655823,12.9),(118303,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118303,32.82,0.46,36.6,52331,NULL,NULL,'J','NGC 5529',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118304,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118304,32.85,0.47,37.1,52331,NULL,NULL,'H','NGC 5529',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118305,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118305,32.94,0.45,38.6,52331,NULL,NULL,'K','NGC 5529',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118306,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118306,32.96,0.4,39.1,52331,75,NULL,NULL,'NGC 5529',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118307,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118307,32.99,NULL,39.7,52331,NULL,NULL,'Dipole','NGC 5529',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118308,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118308,33,NULL,39.7,52331,NULL,NULL,'Dipole + Quadrupole','NGC 5529',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118309,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118309,33,NULL,39.8,52331,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 5529',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118310,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118310,33.06,NULL,40.9,52331,NULL,NULL,NULL,'NGC 5529',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118311,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118311,33.15,0.4,42.7,52331,NULL,NULL,'mean','NGC 5529',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118312,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118312,33.21,0.4,43.9,52331,75,NULL,'B','NGC 5529',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118313,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118313,33.24,0.35,44.5,52331,NULL,NULL,NULL,'NGC 5529',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118314,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118314,33.25,0.49,44.7,52331,75,NULL,'IR','NGC 5529',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118315,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118315,33.36,0.4,46.9,52331,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5529',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118316,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118316,33.56,0.47,51.6,52331,75,NULL,'A82, H, raw','NGC 5529',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118317,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118317,33.83,0.47,58.3,52331,75,NULL,'A82, H, cor','NGC 5529',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118318,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118318,33.84,0.47,58.6,52331,75,NULL,'A82, H, inv','NGC 5529',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118319,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118319,38.01,0.33,400,52332,70,NULL,NULL,'2MASX J14153418+4406520',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000182,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,213.892208333,44.11453,0,NULL,59238914742,925608042,14462625,17.1),(118320,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118320,37.22,0.27,278,52333,70,NULL,NULL,'2MASX J14153522+5151529',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.89675,51.86483,0,NULL,59251337315,925802145,14465658,17.7),(118321,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118321,37.34,0.27,294,52334,70,NULL,NULL,'2MASX J14153685+2920151',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000163,NULL,'16.8g',0.31,'S0',NULL,NULL,NULL,NULL,1,213.903458333,29.33756,0,NULL,60059262030,938425969,14662905,16.8),(118322,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118322,37.34,0.27,294,52335,70,NULL,NULL,'2MASX J14153717+2928420',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.904833,29.47825,0,NULL,60059127143,938423861,14662872,17.6),(118323,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118323,37.52,0.46,318,52336,70,NULL,NULL,'2MASX J14153900-0027396',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000085,NULL,'17.0g',0.26,'AGN',NULL,NULL,NULL,NULL,1,213.912416667,-0.46108,0.077,NULL,43503432682,679741135,10620955,17),(118324,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118324,34.12,0.45,66.6,52337,NULL,NULL,'K','NGC 5525',NULL,'2007A&A...465...71T',2007,1,1.44,NULL,'G',0.000087,NULL,'13.6g',0.92,'S0','in a pair',NULL,NULL,NULL,1,213.913458333,14.28261,0,NULL,58353181578,911768462,14246382,13.6),(118325,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118325,34.61,0.4,83.7,52337,NULL,NULL,'mean','NGC 5525',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118326,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118326,37.31,0.46,290,52338,70,NULL,NULL,'2MASX J14153942+0236436',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000076,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,213.914083,2.61211,0.069,NULL,58470518299,913601848,14275028,17.6),(118327,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118327,37.39,0.46,300,52339,70,NULL,NULL,'SDSS J141539.42+051328.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000067,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,213.9142917,5.22467,0.033,NULL,58476787693,913699807,14276559,18.5),(118328,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118328,37.68,0.19,343,52340,70,NULL,NULL,'2MASX J14154008+5021189',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000163,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,213.916875,50.35525,0.005,NULL,59253874763,925841793,14466278,18.3),(118329,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118329,35.11,0.57,105,52341,70,NULL,NULL,'2MASX J14154044-0754348',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,213.9184583,-7.90983,0.089,NULL,43712541956,683008468,10672007,16),(118330,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118330,32.78,0.4,36,52342,75,NULL,'B','UGC 09126',NULL,'1988NBGC.C....0000T',1988,1,1.8,'Multiple SDSS entries describe this source.','G',0.000017,NULL,'15.0',1.7,'Im:','Group member',NULL,NULL,NULL,1,213.91875,16.55,0,NULL,59485510461,929461100,14522829,15),(118331,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118331,37.39,0.46,301,52343,70,NULL,NULL,'2MASX J14154189+0516146',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00009,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,213.924583,5.27053,0.025,NULL,58476785625,913699775,14276558,16.3),(118332,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118332,38.29,0.46,455,52344,70,NULL,NULL,'SDSS J141543.00+054413.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.9292083,5.73697,0.021,NULL,58473291089,913645173,14275705,17.8),(118333,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118333,33.76,0.49,56.5,52345,75,NULL,'IR','ESO 511- G 016',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'15.93',0.3,'S...',NULL,NULL,NULL,NULL,1,213.9312083,-24.423,0.257,NULL,46511315387,726739302,11355301,15.93),(118334,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118334,33.85,0.62,58.9,52345,NULL,NULL,NULL,'ESO 511- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118335,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118335,33.89,0.2,60,52345,74.4,NULL,NULL,'ESO 511- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118336,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118336,34.02,0.57,63.8,52345,NULL,NULL,'Malmquist cor.','ESO 511- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118337,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118337,36.94,0.46,244,52346,70,NULL,NULL,'2MASX J14154412+2433010',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000164,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,213.93375,24.55028,0,NULL,59467343936,929177249,14518394,16.7),(118338,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118338,37.74,0.33,352,52347,70,NULL,NULL,'2MASX J14154422+4136013',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,213.934333,41.60058,0,NULL,59227401758,925428152,14459814,18),(118339,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118339,33.35,0.51,46.8,52348,70,NULL,NULL,'ESO 271- G 026',NULL,'2014MNRAS.445.2677S',2014,1,1.3,'1984MNRAS.210...69F has V = 6800 +- 200 km/s.','G',0.00015,NULL,'14.44',0.8,'(R)SAB(rl)0^+:',NULL,NULL,NULL,NULL,1,213.9407917,-47.64114,0.749,NULL,46835603111,731806298,11434473,14.44),(118340,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118340,36.42,0.95,192,52349,70,NULL,NULL,'2MASX J14154590-1643168',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,213.9412917,-16.72136,0.273,NULL,46546958161,727296221,11364003,15.6),(118341,'G Lens','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118341,42.63,0.12,3360,52350,NULL,NULL,NULL,'[HB89] 1413+117',NULL,'2010ApJ...708..995G',2010,1,NULL,'This quasar is lensed into four images by a z=0.8(PHOT) galaxy.','QSO',0.000247,NULL,'17.0g',NULL,'ULIRG          BAL',NULL,NULL,NULL,'QSO',1,213.942667,11.49544,0,NULL,58487356724,913864948,14279139,17),(118342,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118342,37.78,0.46,360,52351,70,NULL,NULL,'2MASX J14154621+4140553',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000151,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,213.942583,41.68211,0,NULL,59227402367,925428161,14459815,17.1),(118343,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118343,37.93,0.46,385,52352,70,NULL,NULL,'2MASX J14154654+2526530',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,213.943917,25.44808,0,NULL,60000238982,937503734,14648495,17.5),(118344,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118344,37.66,0.46,341,52353,70,NULL,NULL,'2MASX J14154680+0657505',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000177,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.945,6.96411,0.025,NULL,58502502612,914101603,14282837,17.8),(118345,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118345,35.45,0.46,123,52354,70,NULL,NULL,'2MASX J14154699+0854365',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000067,NULL,'15.3g',0.43,'AGN',NULL,NULL,NULL,NULL,1,213.945916667,8.91019,0.033,NULL,58496427543,914006680,14281354,15.3),(118346,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118346,38.1,0.46,417,52355,70,NULL,NULL,'SDSS J141547.08+263820.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00017,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,213.9462083,26.63906,0,NULL,60003215930,937550248,14649222,18.4),(118347,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118347,38.2,0.46,437,52356,70,NULL,NULL,'2MASX J14154758+0525336',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000083,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,213.9482917,5.42592,0.025,NULL,58476606022,913696969,14276515,17),(118348,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118348,37.22,0.27,278,52357,70,NULL,NULL,'SDSS J141548.94+515542.0',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000145,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,213.953916667,51.92833,0,NULL,59251343798,925802246,14465660,17.8),(118349,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118349,37.93,0.46,385,52358,70,NULL,NULL,'SDSS J141548.95+291310.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,213.9539583,29.21964,0,NULL,60059283973,938426312,14662911,18.3),(118350,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118350,35.22,0.46,111,52359,70,NULL,NULL,'IC 0990',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000147,NULL,'15.0g',0.57,'E0',NULL,NULL,NULL,NULL,1,213.954958333,39.79792,0,NULL,59945000218,936640628,14635009,15),(118351,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118351,37.32,0.46,291,52360,70,NULL,NULL,'2MASX J14155042+5255269',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,213.960083333,52.92428,0,NULL,59194715580,924917430,14451834,17.3),(118352,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118352,36.62,0.46,211,52361,70,NULL,NULL,'2MASX J14155123+0843054',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000174,NULL,'16.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,213.9635417,8.71828,0.033,NULL,58496548271,914008566,14281383,16.5),(118353,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118353,37.32,0.46,292,52362,70,NULL,NULL,'2MASX J14155149+5335079',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000197,NULL,'16.0g',0.33,'E0',NULL,NULL,NULL,NULL,1,213.964833333,53.58556,0,NULL,59195244987,924925702,14451964,16),(118354,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118354,36.52,0.46,201,52363,70,NULL,NULL,'VII Zw 541',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000171,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,213.967375,62.79211,0.025,NULL,57750058096,902344657,14099135,16.3),(118355,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118355,37.01,0.46,252,52364,70,NULL,NULL,'2MASX J14155265+4028352',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000161,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,213.969167,40.47642,0,NULL,59223693426,925370209,14458909,17),(118356,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118356,37.34,0.27,294,52365,70,NULL,NULL,'2MASX J14155304+2931310',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,213.971166667,29.52528,0,NULL,60058927329,938420739,14662824,18.1),(118357,'D-Sigma','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118357,34.12,0.4,66.6,52366,75,NULL,'Edat, raw','NGC 5516',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000067,NULL,'13.00',1.2,'E','Pair member (points to parent)',NULL,NULL,NULL,1,213.977875,-48.11486,0.853,NULL,46835091486,731798304,11434348,13),(118358,'D-Sigma','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118358,34.45,0.4,77.8,52366,75,NULL,'Edat, cor','NGC 5516',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118359,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118359,34.03,0.45,64.1,52366,NULL,NULL,'K','NGC 5516',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118360,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118360,34.08,0.4,65.4,52366,NULL,NULL,'mean','NGC 5516',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118361,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118361,37.68,0.19,343,52367,70,NULL,NULL,'2MASX J14155512+5019079',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000194,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.97975,50.31892,0.005,NULL,59253877019,925841828,14466278,17.4),(118362,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118362,37.5,0.46,316,52368,70,NULL,NULL,'2MASX J14155608-0158356',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,213.983583333,-1.97667,0.169,NULL,43724003200,683187550,10674805,17.5),(118363,'Brightest Stars','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118363,26.2,NULL,1.74,52369,NULL,NULL,'1, V8 AGB star','UGC 09128',NULL,'1998AJ....116.1679H',1998,1,1.7,NULL,'G',0.000002,NULL,'14.38',1.3,'ImIV-V','Possible field galaxy',NULL,NULL,NULL,1,213.9855,23.05528,0,1,59469435593,929209931,14518905,14.38),(118364,'Brightest Stars','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118364,26.7,NULL,2.19,52369,NULL,NULL,'1, V8, Kinman et al 1987','UGC 09128',NULL,'1998AJ....116.1679H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118365,'Brightest Stars','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118365,27.6,NULL,3.31,52369,NULL,NULL,'1, V5','UGC 09128',NULL,'1998AJ....116.1679H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118366,'Brightest Stars','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118366,27.75,NULL,3.55,52369,NULL,NULL,'LF','UGC 09128',NULL,'1997AstL...23..656G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118367,'Brightest Stars','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118367,28.18,NULL,4.33,52369,NULL,NULL,'Blue','UGC 09128',NULL,'1997AstL...23..644G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118368,'Brightest Stars','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118368,28.2,0.6,4.4,52369,NULL,NULL,NULL,'UGC 09128',NULL,'1988A&AS...74..367A',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118369,'Brightest Stars','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118369,28.55,NULL,5.13,52369,NULL,NULL,'Red + Blue','UGC 09128',NULL,'1997AstL...23..644G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118370,'Brightest Stars','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118370,28.55,0.4,5.13,52369,NULL,NULL,'3B + 3R mean','UGC 09128',NULL,'1997AstL...23..656G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118371,'Brightest Stars','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118371,28.67,NULL,5.42,52369,NULL,NULL,'Red','UGC 09128',NULL,'1997AstL...23..644G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118372,'Brightest Stars','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118372,29.29,NULL,7.21,52369,NULL,NULL,'1, V8, Red Variable','UGC 09128',NULL,'1998AJ....116.1679H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118373,'Cepheids','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118373,28.91,NULL,6.05,52369,NULL,NULL,'5, V2, 3, 9, 19, 12','UGC 09128',NULL,'1998AJ....116.1679H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118374,'Cepheids','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118374,29.24,0.33,7.05,52369,NULL,NULL,'2, V9, V12','UGC 09128',NULL,'1998AJ....116.1679H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118375,'CMD','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118375,26.7,0.04,2.19,52369,NULL,NULL,NULL,'UGC 09128',NULL,'2010ApJ...721..297M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118376,'Miras','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118376,28.26,NULL,4.49,52369,NULL,NULL,NULL,'UGC 09128',NULL,'1998AJ....116.1679H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118377,'Red Clump','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118377,26.12,NULL,1.68,52369,NULL,NULL,'V, M RC(V) = +0.73 mag','UGC 09128',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118378,'Red Clump','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118378,26.52,NULL,2.01,52369,NULL,NULL,'I, M RC(I) = -0.50 mag','UGC 09128',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118379,'RSV Stars','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118379,29.4,0.5,7.59,52369,NULL,NULL,NULL,'UGC 09128',NULL,'1998AJ....116.1679H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118380,'TRGB','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118380,26.68,0.1,2.17,52369,NULL,NULL,NULL,'UGC 09128',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118381,'TRGB','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118381,26.71,0.1,2.2,52369,NULL,NULL,NULL,'UGC 09128',NULL,'2014A&A...566A..71L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118382,'TRGB','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118382,26.72,0.06,2.21,52369,NULL,NULL,'I','UGC 09128',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118383,'TRGB','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118383,26.75,0.05,2.24,52369,NULL,NULL,NULL,'UGC 09128',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118384,'TRGB','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118384,26.75,NULL,2.24,52369,NULL,NULL,NULL,'UGC 09128',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118385,'TRGB','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118385,26.78,0.08,2.27,52369,74.4,NULL,NULL,'UGC 09128',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118386,'TRGB','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118386,26.79,0.07,2.28,52369,NULL,NULL,NULL,'UGC 09128',NULL,'2013AstBu..68..125M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118387,'TRGB','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118387,26.8,NULL,2.29,52369,NULL,NULL,'I, M TRGB(I) = -4.05 mag','UGC 09128',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118388,'TRGB','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118388,26.8,0.04,2.29,52369,NULL,NULL,'I','UGC 09128',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118389,'TRGB','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118389,26.99,0.45,2.5,52369,NULL,NULL,NULL,'UGC 09128',NULL,'2000AJ....119..177A',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118390,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118390,26.68,0.4,2.2,52369,75,NULL,'B','UGC 09128',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118391,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118391,37.68,0.19,343,52370,70,NULL,NULL,'SDSS J141558.60+501751.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000192,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,213.9942083,50.29772,0.005,NULL,59253877660,925841838,14466278,18.1),(118392,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118392,36.68,0.56,216,52371,70,NULL,NULL,'2MASX J14155775-2235251',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.19',NULL,'E int',NULL,NULL,NULL,NULL,1,213.9952917,-22.59083,0.345,NULL,46512546207,726758534,11355602,16.19),(118393,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118393,37.68,0.19,343,52372,70,NULL,NULL,'2MASX J14155910+5021189',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000173,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,213.996083333,50.35519,0.005,NULL,59253907788,925842309,14466286,17.9),(118394,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118394,36.34,0.46,185,52373,70,NULL,NULL,'2MASX J14155989+2435230',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000173,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,213.9995417,24.58969,0,NULL,59467363799,929177559,14518399,16.2),(118395,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118395,36.83,0.12,232,52374,70,NULL,NULL,'SDSS J141601.79+015459.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000068,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,214.0074583,1.91658,0.013,NULL,58470410083,913600157,14275002,17.6),(118396,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118396,36.84,0.46,233,52375,70,NULL,NULL,'SDSS J141602.71+090640.3',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,214.0112917,9.11122,0.025,NULL,58496392234,914006128,14281345,17.4),(118397,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118397,37.63,0.46,336,52376,70,NULL,NULL,'SDSS J141603.37+155705.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,214.014083333,15.95156,0,NULL,59484766201,929449471,14522647,18),(118398,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118398,38.12,0.46,421,52377,70,NULL,NULL,'SDSS J141603.44+481110.0',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,214.014375,48.18614,0.039,NULL,59247273428,925738647,14464666,17.8),(118399,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118399,38.36,0.46,469,52378,70,NULL,NULL,'2MASX J14160380+5905520',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000185,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,214.0160417,59.09772,0.009,NULL,57269597719,894837464,13981835,17.4),(118400,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118400,36.83,0.12,232,52379,70,NULL,NULL,'2MASX J14160424+0127299',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000103,NULL,'16.1g',0.35,'E0',NULL,NULL,NULL,NULL,1,214.01775,1.45822,0.037,NULL,58468862795,913575981,14274624,16.1),(118401,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118401,36.58,0.46,207,52380,70,NULL,NULL,'2MASX J14160599+6139190',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,214.0252083,61.65531,0.021,NULL,57762733272,902542707,14102229,16.6),(118402,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118402,38.28,0.46,453,52381,70,NULL,NULL,'2MASX J14160659+1307040',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000201,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,214.0274583,13.11781,0,NULL,58353914878,911779919,14246561,17),(118403,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118403,35.04,0.2,102,52382,74.4,NULL,NULL,'UGC 09132',NULL,'2013AJ....146...86T',2013,1,1.04,NULL,'G',0.000033,NULL,'16.2g',0.22,'Scd:',NULL,NULL,NULL,NULL,1,214.0300417,33.72764,0,NULL,60042072755,938157386,14658709,16.2),(118404,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118404,35.46,0.49,124,52382,75,NULL,'IR','UGC 09132',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118405,'IRAS','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118405,33.7,0.8,55,52383,75,NULL,'CF, r','NGC 5533',NULL,'1997ApJS..109..333W',1997,1,3.1,NULL,'G',0.000017,NULL,'12.7',1.9,'SA(rs)ab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,214.03225,35.34383,0,NULL,60044737408,938199022,14659359,12.7),(118406,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118406,32.81,0.69,36.4,52383,100,NULL,'mid-IR','NGC 5533',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118407,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118407,33.02,0.42,40.2,52383,NULL,NULL,'Malmquist cor.','NGC 5533',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118408,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118408,33.14,0.4,42.5,52383,NULL,NULL,NULL,'NGC 5533',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118409,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118409,33.23,0.2,44.3,52383,74.4,NULL,NULL,'NGC 5533',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118410,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118410,33.33,0.43,46.4,52383,75,NULL,'3.6 micron, color corrected','NGC 5533',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118411,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118411,33.34,0.38,46.5,52383,75,NULL,'CF, r, raw','NGC 5533',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118412,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118412,33.46,0.43,49.3,52383,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5533',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118413,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118413,33.52,0.38,50.5,52383,75,NULL,'CF, r, cor','NGC 5533',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118414,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118414,33.56,0.38,51.5,52383,75,NULL,'CF, r, inv','NGC 5533',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118415,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118415,33.74,0.47,55.9,52383,NULL,NULL,'H','NGC 5533',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118416,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118416,33.74,0.45,56.1,52383,NULL,NULL,'K','NGC 5533',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118417,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118417,33.77,0.46,56.8,52383,NULL,NULL,'J','NGC 5533',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118418,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118418,33.79,0.4,57.2,52383,NULL,NULL,'mean','NGC 5533',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118419,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118419,36.85,0.33,235,52384,70,NULL,NULL,'SDSS J141607.69+034146.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000083,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,214.032083,3.69622,0.041,NULL,58475070539,913672977,14276140,17.5),(118420,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118420,35.31,0.19,115,52385,70,NULL,NULL,'2MASX J14160880+1020043',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00017,NULL,'16.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,214.0367917,10.3345,0,NULL,58501303442,914082866,14282544,16.2),(118421,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118421,36.57,0.27,206,52386,70,NULL,NULL,'2MASX J14160909+1835497',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.57',0.42,NULL,NULL,NULL,NULL,NULL,1,214.037833,18.59728,0,NULL,59518810157,929981408,14530959,16.57),(118422,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118422,37.46,0.46,310,52387,70,NULL,NULL,'2MASX J14161001+2718310',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,214.041625,27.30864,0,NULL,60056626385,938384787,14662262,17.2),(118423,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118423,37.12,0.46,265,52388,70,NULL,NULL,'2MASX J14161025+0541468',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'17.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,214.0427083,5.69628,0.021,NULL,58473142598,913642853,14275669,17),(118424,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118424,36.97,0.13,247,52389,70,NULL,NULL,'2MASX J14161077+0802383',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000081,NULL,'17.26',0.22,NULL,NULL,NULL,NULL,NULL,1,214.045,8.04414,0.047,NULL,58497323484,914020679,14281573,17.26),(118425,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118425,36.18,0.46,172,52390,70,NULL,NULL,'2MASX J14161194+0216358',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000069,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,214.049875,2.27658,0.073,NULL,58470241131,913597517,14274961,17),(118426,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118426,37.13,0.46,267,52391,70,NULL,NULL,'2MASX J14161309+2546020',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000179,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,214.054625,25.76708,0,NULL,60000314550,937504914,14648514,16.3),(118427,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118427,37.74,0.46,353,52392,70,NULL,NULL,'2MASX J14161360+6201280',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00017,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,214.0569583,62.02469,0.033,NULL,57762619175,902540924,14102201,17.8),(118428,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118428,36.88,0.46,237,52393,70,NULL,NULL,'2MASX J14161367+3612344',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000188,NULL,'16.2g',0.39,'AGN',NULL,NULL,NULL,NULL,1,214.057,36.20942,0,NULL,60030195494,937971804,14655809,16.2),(118429,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118429,36.68,0.46,217,52394,70,NULL,NULL,'2MASX J14161389+3031435',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.03',0.15,NULL,NULL,NULL,NULL,NULL,1,214.057875,30.52869,0,NULL,60060604048,938446938,14663233,18.03),(118430,'IRAS','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118430,34.24,0.8,70.4,52395,75,NULL,'HMCL, I','KUG 1413+257',NULL,'1997ApJS..109..333W',1997,1,0.94,NULL,'G',0.00002,NULL,'15.1g',0.3,'Spiral',NULL,NULL,NULL,NULL,1,214.0597083,25.54561,0,NULL,60000309252,937504832,14648513,15.1),(118431,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118431,34.39,0.4,75.5,52395,75,NULL,'HMCL, I, raw','KUG 1413+257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118432,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118432,34.49,0.4,78.9,52395,75,NULL,'HMCL, I, inv','KUG 1413+257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118433,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118433,34.59,0.4,82.9,52395,75,NULL,'HMCL, I, cor','KUG 1413+257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118434,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118434,37.27,0.46,284,52396,70,NULL,NULL,'2MASX J14161776+0408568',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000089,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,214.074167,4.14922,0.037,NULL,58475892997,913685828,14276341,16.3),(118435,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118435,36.95,0.46,246,52397,70,NULL,NULL,'2MASX J14161803+2712556',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00017,NULL,'16.6g',0.31,'AGN',NULL,NULL,NULL,NULL,1,214.075,27.21536,0,NULL,60056618327,938384661,14662260,16.6),(118436,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc','R',118436,42.64,NULL,1860,52398,65,NULL,'MLCS17','[HSP2005] J141618.22+521626.09',0.817,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.075916667,52.27392,0,NULL,59195791648,924934244,14452097,NULL),(118437,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc',NULL,118437,42.95,0.21,2140,52398,74.2,NULL,'SALT 2','[HSP2005] J141618.22+521626.09',0.817,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118438,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc',NULL,118438,43.24,0.06,2450,52398,70,NULL,'MLCS17','[HSP2005] J141618.22+521626.09',0.817,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118439,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc',NULL,118439,43.57,0.31,2850,52398,70,NULL,'SALT','[HSP2005] J141618.22+521626.09',0.817,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118440,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc',NULL,118440,43.65,0.25,2960,52398,70,NULL,NULL,'[HSP2005] J141618.22+521626.09',0.817,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118441,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc',NULL,118441,43.7,0.21,3020,52398,65,NULL,'MLCS17','[HSP2005] J141618.22+521626.09',0.817,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118442,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc',NULL,118442,43.72,0.18,3050,52398,65,NULL,'MLCS2k2','[HSP2005] J141618.22+521626.09',0.817,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118443,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc',NULL,118443,43.72,0.29,3050,52398,65,NULL,'SALT','[HSP2005] J141618.22+521626.09',0.817,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118444,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc',NULL,118444,43.72,0.19,3060,52398,65,NULL,'MLCS2k2','[HSP2005] J141618.22+521626.09',0.817,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118445,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc',NULL,118445,43.73,0.19,3060,52398,65,NULL,'MLCS31','[HSP2005] J141618.22+521626.09',0.817,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118446,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc',NULL,118446,43.73,0.22,3070,52398,70,NULL,'SALT 2','[HSP2005] J141618.22+521626.09',0.817,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118447,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc',NULL,118447,43.77,0.15,3120,52398,NULL,NULL,'SIFTO','[HSP2005] J141618.22+521626.09',0.817,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118448,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc',NULL,118448,43.78,0.27,3130,52398,65,NULL,'SALT2','[HSP2005] J141618.22+521626.09',0.817,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118449,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc',NULL,118449,43.89,0.44,3290,52398,65,NULL,'SALT2','[HSP2005] J141618.22+521626.09',0.817,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118450,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc',NULL,118450,43.92,0.2,3340,52398,65,NULL,'SALT','[HSP2005] J141618.22+521626.09',0.817,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118451,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc',NULL,118451,45.56,0.17,7130,52398,NULL,NULL,'SALT2','[HSP2005] J141618.22+521626.09',0.817,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118452,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118452,36.76,0.46,225,52399,70,NULL,NULL,'2MASX J14161955-0025519',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000071,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,214.0815417,-0.43103,0.069,NULL,43503418487,679740913,10620951,17.1),(118453,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118453,37.46,0.46,311,52400,70,NULL,NULL,'2MASX J14162012+0436398',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000069,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,214.083875,4.61125,0.037,NULL,58476335404,913692740,14276449,17.8),(118454,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118454,36.83,0.12,232,52401,70,NULL,NULL,'2MASX J14162214+0203368',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000079,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,214.092333,2.06017,0.077,NULL,58470281923,913598155,14274971,16.6),(118455,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118455,34.72,0.49,88.1,52402,NULL,NULL,NULL,'ESO 579- G 010',NULL,'2009ApJS..182..474S',2009,1,1.6,NULL,'G',0.000033,NULL,'15.39',0.6,'Sb:',NULL,NULL,NULL,NULL,1,214.098625,-21.33078,0.373,NULL,46569575482,727649616,11369525,15.39),(118456,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118456,34.73,0.49,88.4,52402,NULL,NULL,'Malmquist cor.','ESO 579- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118457,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118457,34.76,0.2,89.5,52402,74.4,NULL,NULL,'ESO 579- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118458,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118458,37.08,0.46,261,52403,70,NULL,NULL,'2MASX J14162436+2826196',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000167,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,214.1014583,28.43867,0,NULL,60057010127,938390783,14662355,16.8),(118459,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118459,36,0.75,159,52404,70,NULL,NULL,'2MASX J14162654-4821203',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.9b',0.2,NULL,NULL,NULL,NULL,NULL,1,214.110667,-48.35569,0.853,NULL,46835123215,731798800,11434356,16.9),(118460,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118460,37.35,0.46,295,52405,70,NULL,NULL,'2MASX J14162767+0457405',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000105,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,214.1152917,4.96136,0.033,NULL,58476288092,913692001,14276437,16.3),(118461,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118461,37.06,0.46,259,52406,70,NULL,NULL,'2MASX J14162771+3104586',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,214.115333,31.08286,0,NULL,60052576506,938321507,14661273,17.8),(118462,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','PS1 SN PS10iy','N',118462,42.49,0.19,2180,52407,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10iy HOST',0.4434,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118463,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118463,36.23,0.71,177,52408,70,NULL,NULL,'2MASX J14162872-4525137',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'17.1b',0.3,NULL,NULL,NULL,NULL,NULL,1,214.119583,-45.42056,0.321,NULL,46804551219,731321112,11426892,17.1),(118464,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118464,36.95,0.46,246,52409,70,NULL,NULL,'SDSS J141629.50+245053.4',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000125,NULL,'17.6g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,214.122958333,24.84819,0,NULL,60000142516,937502226,14648472,17.6),(118465,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118465,37.85,0.46,371,52410,70,NULL,NULL,'2MASX J14163046+2740416',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.0002,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,214.127041667,27.67833,0,NULL,60057079238,938391863,14662372,16.8),(118466,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118466,37.09,0.33,262,52411,70,NULL,NULL,'2MASX J14163054+0913440',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000193,NULL,'15.8g',0.4,NULL,NULL,NULL,NULL,NULL,1,214.1272917,9.229,0.035,NULL,58501629804,914087965,14282624,15.8),(118467,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118467,37.7,0.46,346,52412,70,NULL,NULL,'2MASX J14163054+3017156',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,214.1274583,30.28786,0,NULL,60061710058,938464219,14663503,17.8),(118468,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118468,33.29,0.49,45.6,52413,75,NULL,'IR','IC 0995',NULL,'2011yCatp016004901K',2011,1,1.75,NULL,'G',0.000023,NULL,'14.6g',0.39,'Sdm:',NULL,NULL,NULL,NULL,1,214.129625,57.81011,0,NULL,57306122337,895408161,13990752,14.6),(118469,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118469,37.98,0.46,394,52414,70,NULL,NULL,'2MASX J14163185+1859042',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.1327083,18.9845,0,NULL,59518902713,929982854,14530982,NULL),(118470,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118470,36.97,0.13,247,52415,70,NULL,NULL,'2MASX J14163303+0754110',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000153,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,214.137625,7.903,0.047,NULL,58497429700,914022339,14281599,17.1),(118471,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118471,38.08,0.46,414,52416,70,NULL,NULL,'SDSS J141633.17-001735.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000072,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,214.13825,-0.29322,0.069,NULL,43503532123,679742689,10620979,17.9),(118472,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118472,37.85,0.46,372,52417,70,NULL,NULL,'SDSS J141633.42+271700.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000149,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,214.13925,27.2835,0,NULL,60056630057,938384844,14662263,18.5),(118473,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn',NULL,118473,40.09,0.15,807,52418,74.2,NULL,'SALT 2','LSSP J141633.45+522030.5',0.291,'2010ApJ...716..712A',2010,1,0.08,NULL,'G',0.000006,NULL,'21.1g',0.05,'AGN',NULL,NULL,NULL,NULL,1,214.1392917,52.34183,0,NULL,59195800943,924934389,14452099,21.1),(118474,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn',NULL,118474,40.55,0.31,996,52418,65,NULL,'SNLS 03D3ba, MLCS31','LSSP J141633.45+522030.5',0.291,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118475,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn',NULL,118475,40.57,0.3,1000,52418,65,NULL,'SNLS 03D3ba, MLCS2k2','LSSP J141633.45+522030.5',0.291,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118476,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn',NULL,118476,40.62,0.2,1030,52418,65,NULL,'SNLS 03D3ba, MLCS2k2','LSSP J141633.45+522030.5',0.291,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118477,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn','R',118477,40.68,NULL,1060,52418,65,NULL,'SNLS 03D3ba, MLCS31','LSSP J141633.45+522030.5',0.291,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118478,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn',NULL,118478,40.79,0.13,1110,52418,70,NULL,'SNLS 03D3ba, SALT','LSSP J141633.45+522030.5',0.291,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118479,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn',NULL,118479,40.83,0.14,1130,52418,70,NULL,'SNLS 03D3ba, SALT 2','LSSP J141633.45+522030.5',0.291,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118480,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn',NULL,118480,40.87,0.15,1160,52418,NULL,NULL,'SNLS 03D3ba, SIFTO','LSSP J141633.45+522030.5',0.291,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118481,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn',NULL,118481,40.88,0.14,1160,52418,65,NULL,'SNLS 03D3ba, SALT2','LSSP J141633.45+522030.5',0.291,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118482,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn',NULL,118482,40.89,0.1,1170,52418,65,NULL,'SNLS 03D3ba, SALT','LSSP J141633.45+522030.5',0.291,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118483,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn',NULL,118483,40.89,0.24,1170,52418,65,NULL,'SNLS 03D3ba, MLCS17','LSSP J141633.45+522030.5',0.291,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118484,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn',NULL,118484,40.95,0.18,1200,52418,65,NULL,'SNLS 03D3ba, SALT2','LSSP J141633.45+522030.5',0.291,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118485,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn',NULL,118485,41,0.03,1230,52418,70,NULL,'SNLS 03D3ba','LSSP J141633.45+522030.5',0.291,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118486,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn',NULL,118486,41.26,0.05,1390,52418,65,NULL,'SNLS 03D3ba, SALT','LSSP J141633.45+522030.5',0.291,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118487,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn',NULL,118487,41.54,0.05,1570,52418,70,NULL,'SNLS 03D3ba, MLCS31','LSSP J141633.45+522030.5',0.291,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118488,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn',NULL,118488,42.01,0.17,1950,52418,NULL,NULL,'SNLS 03D3ba, SALT2','LSSP J141633.45+522030.5',0.291,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118489,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118489,36.33,0.46,185,52419,70,NULL,NULL,'2MASX J14163404+0748000',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.60',0.2,NULL,NULL,NULL,NULL,NULL,1,214.141916667,7.79997,0.047,NULL,58497413255,914022082,14281595,17.6),(118490,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118490,37.53,0.46,321,52420,70,NULL,NULL,'2MASX J14163441+1844462',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,214.143416667,18.74611,0,NULL,59518974599,929983978,14530999,17.4),(118491,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118491,36.33,0.46,184,52421,70,NULL,NULL,'2MASX J14163505+0400355',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000076,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,214.1459583,4.00981,0.033,NULL,58475930367,913686411,14276350,16.6),(118492,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3kr','R',118492,40.49,NULL,939,52422,65,NULL,'SALT','[HSP2005] J141635.93+522844.20',0.337,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.0002,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.14975,52.47894,0.005,NULL,59197889120,924967017,14452609,NULL),(118493,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3kr',NULL,118493,40.59,0.14,981,52422,74.2,NULL,'SALT 2','[HSP2005] J141635.93+522844.20',0.337,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118494,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3kr',NULL,118494,40.98,0.03,1170,52422,70,NULL,'SALT','[HSP2005] J141635.93+522844.20',0.337,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118495,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3kr',NULL,118495,41.18,0.12,1290,52422,70,NULL,'SALT','[HSP2005] J141635.93+522844.20',0.337,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118496,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3kr',NULL,118496,41.26,0.01,1340,52422,70,NULL,NULL,'[HSP2005] J141635.93+522844.20',0.337,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118497,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3kr',NULL,118497,41.33,0.09,1380,52422,65,NULL,'SALT','[HSP2005] J141635.93+522844.20',0.337,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118498,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3kr',NULL,118498,41.35,0.15,1400,52422,NULL,NULL,'SIFTO','[HSP2005] J141635.93+522844.20',0.337,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118499,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3kr',NULL,118499,41.39,0.14,1420,52422,65,NULL,'MLCS17','[HSP2005] J141635.93+522844.20',0.337,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118500,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3kr',NULL,118500,41.41,0.09,1430,52422,65,NULL,'SALT2','[HSP2005] J141635.93+522844.20',0.337,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118501,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3kr',NULL,118501,41.44,0.16,1450,52422,65,NULL,'MLCS31','[HSP2005] J141635.93+522844.20',0.337,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118502,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3kr',NULL,118502,41.46,0.08,1460,52422,65,NULL,'MLCS2k2','[HSP2005] J141635.93+522844.20',0.337,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118503,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3kr',NULL,118503,41.46,0.14,1460,52422,65,NULL,'MLCS2k2','[HSP2005] J141635.93+522844.20',0.337,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118504,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3kr',NULL,118504,41.46,0.17,1460,52422,65,NULL,'SALT2','[HSP2005] J141635.93+522844.20',0.337,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118505,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3kr',NULL,118505,41.52,0.01,1510,52422,65,NULL,'SALT','[HSP2005] J141635.93+522844.20',0.337,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118506,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3kr',NULL,118506,42.79,0.17,2700,52422,NULL,NULL,'SALT2','[HSP2005] J141635.93+522844.20',0.337,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118507,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118507,37.69,0.46,345,52423,70,NULL,NULL,'SDSS J141636.21-005258.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000062,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,214.150917,-0.88281,0.085,NULL,43503756967,679746202,10621034,18.1),(118508,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118508,36.04,0.2,161,52424,74.4,NULL,NULL,'UGC 09135',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000033,NULL,'15.16',0.5,'SB?            AGN',NULL,NULL,NULL,'Sy ?',1,214.153833333,24.50253,0,NULL,59467316986,929176827,14518387,15.16),(118509,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml','R',118509,42.82,NULL,1880,52425,65,NULL,'SALT2','[HSP2005] J141639.10+530535.66',0.95,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.02,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.1629583,53.09325,0,NULL,59194584506,924915382,14451802,NULL),(118510,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml',NULL,118510,43.27,0.3,2310,52425,74.2,NULL,'SALT 2','[HSP2005] J141639.10+530535.66',0.95,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118511,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml',NULL,118511,43.36,0.08,2410,52425,70,NULL,'SALT2','[HSP2005] J141639.10+530535.66',0.95,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118512,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml',NULL,118512,43.78,0.42,2920,52425,70,NULL,'SALT','[HSP2005] J141639.10+530535.66',0.95,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118513,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml',NULL,118513,43.84,0.4,3010,52425,65,NULL,'SALT2','[HSP2005] J141639.10+530535.66',0.95,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118514,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml',NULL,118514,43.91,0.45,3110,52425,65,NULL,'SALT','[HSP2005] J141639.10+530535.66',0.95,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118515,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml',NULL,118515,43.95,0.27,3170,52425,70,NULL,NULL,'[HSP2005] J141639.10+530535.66',0.95,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118516,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml',NULL,118516,44.06,0.25,3330,52425,65,NULL,'MLCS2k2','[HSP2005] J141639.10+530535.66',0.95,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118517,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml',NULL,118517,44.08,0.15,3350,52425,NULL,NULL,'SIFTO','[HSP2005] J141639.10+530535.66',0.95,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118518,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml',NULL,118518,44.11,0.29,3400,52425,65,NULL,'SALT2','[HSP2005] J141639.10+530535.66',0.95,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118519,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml',NULL,118519,44.12,0.17,3410,52425,65,NULL,'MLCS17','[HSP2005] J141639.10+530535.66',0.95,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118520,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml',NULL,118520,44.14,0.12,3440,52425,65,NULL,'MLCS2k2','[HSP2005] J141639.10+530535.66',0.95,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118521,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml',NULL,118521,44.15,0.15,3470,52425,65,NULL,'MLCS31','[HSP2005] J141639.10+530535.66',0.95,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118522,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml',NULL,118522,44.16,0.22,3480,52425,70,NULL,'SALT 2','[HSP2005] J141639.10+530535.66',0.95,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118523,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml',NULL,118523,44.22,0.17,3580,52425,65,NULL,'SALT','[HSP2005] J141639.10+530535.66',0.95,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118524,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml',NULL,118524,45.51,0.17,6490,52425,NULL,NULL,'SALT2','[HSP2005] J141639.10+530535.66',0.95,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118525,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118525,36.97,0.13,247,52426,70,NULL,NULL,'2MASX J14164065+0812510',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00019,NULL,'15.8g',0.44,NULL,NULL,NULL,NULL,NULL,1,214.169541667,8.21425,0.044,NULL,58497885869,914029466,14281710,15.8),(118526,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118526,37.41,0.46,303,52427,70,NULL,NULL,'2MASX J14164132+3557548',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000189,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,214.1722917,35.96514,0,NULL,60044096644,938189010,14659203,16.4),(118527,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118527,37.65,0.46,339,52428,70,NULL,NULL,'2MASX J14164253+4300262',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000175,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,214.1772083,43.00725,0,NULL,59225089342,925392020,14459250,16.9),(118528,'IRAS','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118528,33.96,0.8,62.1,52429,75,NULL,'HMCL, I','UGC 09138',NULL,'1997ApJS..109..333W',1997,1,1.99,NULL,'G',0.000007,NULL,'15.22',0.22,'Sc',NULL,NULL,NULL,NULL,1,214.1967083,23.00247,0,NULL,59469447715,929210120,14518908,15.22),(118529,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118529,33.84,NULL,58.5,52429,NULL,NULL,NULL,'UGC 09138',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118530,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118530,33.84,NULL,58.5,52429,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09138',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118531,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118531,33.86,NULL,59.1,52429,NULL,NULL,'Dipole + Quadrupole','UGC 09138',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118532,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118532,33.87,NULL,59.5,52429,NULL,NULL,'Dipole','UGC 09138',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118533,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118533,34.02,0.4,63.7,52429,75,NULL,'HMCL, I, raw','UGC 09138',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118534,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118534,34.13,0.4,66.9,52429,75,NULL,'HMCL, I, inv','UGC 09138',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118535,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118535,34.15,0.49,67.5,52429,75,NULL,'IR','UGC 09138',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118536,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118536,34.21,0.32,69.5,52429,NULL,NULL,'Malmquist cor.','UGC 09138',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118537,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118537,34.21,0.4,69.5,52429,75,NULL,'HMCL, I, cor','UGC 09138',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118538,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118538,34.25,0.2,70.8,52429,74.4,NULL,NULL,'UGC 09138',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118539,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118539,34.32,0.31,73,52429,NULL,NULL,NULL,'UGC 09138',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118540,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3jk',NULL,118540,42.56,0.05,1880,52430,70,NULL,'SIFTO','SNLS 05D3jk',0.736,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,214.19775,52.5925,0.005,NULL,59197937663,924967775,14452621,NULL),(118541,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3jk',NULL,118541,43.21,0.15,2520,52430,NULL,NULL,'SIFTO','SNLS 05D3jk',0.736,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118542,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3jk',NULL,118542,43.31,0.17,2640,52430,70,NULL,'SALT 2','SNLS 05D3jk',0.736,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118543,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3jk',NULL,118543,44.53,0.17,4630,52430,NULL,NULL,'SALT2','SNLS 05D3jk',0.736,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118544,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118544,36.61,0.46,210,52431,70,NULL,NULL,'2MASX J14164778+1740150',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.40',0.17,NULL,NULL,NULL,NULL,NULL,1,214.199167,17.67094,0,NULL,59487172241,929487066,14523235,18.4),(118545,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118545,37.59,0.46,329,52432,70,NULL,NULL,'2MASX J14164881+0509565',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000077,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,214.203375,5.16567,0.033,NULL,58476274583,913691790,14276434,17),(118546,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3is',NULL,118546,42.3,0.19,1690,52433,74.2,NULL,'SALT 2','[AGR2006] J141651.96+524845.7',0.71,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.2165417,52.81269,0,NULL,59197916761,924967449,14452616,NULL),(118547,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3is',NULL,118547,42.65,0.24,1980,52433,65,NULL,'MLCS2k2','[AGR2006] J141651.96+524845.7',0.71,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118548,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3is','R',118548,42.82,NULL,2140,52433,65,NULL,'MLCS17','[AGR2006] J141651.96+524845.7',0.71,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118549,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3is',NULL,118549,42.91,0.15,2230,52433,65,NULL,'SALT2','[AGR2006] J141651.96+524845.7',0.71,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118550,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3is',NULL,118550,43.03,0.19,2360,52433,70,NULL,'SALT','[AGR2006] J141651.96+524845.7',0.71,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118551,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3is',NULL,118551,43.09,0.37,2430,52433,65,NULL,'MLCS17','[AGR2006] J141651.96+524845.7',0.71,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118552,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3is',NULL,118552,43.13,0.16,2470,52433,65,NULL,'SALT','[AGR2006] J141651.96+524845.7',0.71,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118553,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3is',NULL,118553,43.18,0.08,2530,52433,70,NULL,NULL,'[AGR2006] J141651.96+524845.7',0.71,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118554,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3is',NULL,118554,43.19,0.2,2540,52433,65,NULL,'SALT2','[AGR2006] J141651.96+524845.7',0.71,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118555,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3is',NULL,118555,43.44,0.05,2850,52433,65,NULL,'SALT','[AGR2006] J141651.96+524845.7',0.71,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118556,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3is',NULL,118556,43.71,0.33,3230,52433,65,NULL,'MLCS2k2','[AGR2006] J141651.96+524845.7',0.71,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118557,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3is',NULL,118557,43.72,0.34,3240,52433,65,NULL,'MLCS31','[AGR2006] J141651.96+524845.7',0.71,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118558,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118558,36.84,0.46,233,52434,70,NULL,NULL,'SDSS J141651.97+052141.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000072,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,214.216583333,5.36158,0.021,NULL,58473586479,913649788,14275777,18.2),(118559,'Faber-Jackson','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118559,33.17,0.3,43.1,52435,95,NULL,'Weighted Mean','NGC 5532',NULL,'1984ApJS...56...91D',1984,1,1.32,NULL,'G',0.00007,NULL,'14.05',1.02,'FRI            LEG','Possible field galaxy',NULL,'FR I','Flat-Spectrum Radio Source',1,214.220625,10.80739,0,NULL,58500644492,914072570,14282383,14.05),(118560,'Faber-Jackson','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118560,33.25,0.46,44.7,52435,95,NULL,'Michard 1979a','NGC 5532',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118561,'Faber-Jackson','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118561,33.39,0.41,47.6,52435,95,NULL,'de Vaucouleurs','NGC 5532',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118562,'Faber-Jackson','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118562,33.54,0.63,51.1,52435,95,NULL,'Michard 1979b, c','NGC 5532',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118563,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118563,35.31,0.19,115,52435,70,NULL,NULL,'NGC 5532',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118564,'Tertiary','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118564,34.3,0.5,72.4,52435,95,NULL,NULL,'NGC 5532',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118565,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118565,34.44,0.45,77.3,52435,NULL,NULL,'K','NGC 5532',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118566,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118566,35.11,0.4,105,52435,NULL,NULL,'mean','NGC 5532',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118567,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118567,37.07,0.46,260,52436,70,NULL,NULL,'2MASX J14165303+3023034',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.11',0.26,NULL,NULL,NULL,NULL,NULL,1,214.220833,30.38428,0,NULL,60061684840,938463825,14663497,17.11),(118568,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118568,38.26,0.19,450,52437,70,NULL,NULL,'SDSS J141653.32+432304.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000149,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,214.222208333,43.38467,0,NULL,59225040303,925391254,14459238,18.5),(118569,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3cf',NULL,118569,41.93,0.17,1720,52438,NULL,NULL,'SALT2','DEEP2 11044756',0.418732,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.000011,NULL,'22.4V',NULL,'a',NULL,NULL,NULL,NULL,1,214.2225417,52.34511,0,NULL,59195795504,924934304,14452098,22.4),(118570,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3cf',NULL,118570,41.95,0.12,1730,52438,70,NULL,'SALT 2','DEEP2 11044756',0.418732,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118571,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3cf',NULL,118571,41.99,0.15,1760,52438,NULL,NULL,'SIFTO','DEEP2 11044756',0.418732,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118572,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3cf',NULL,118572,42.36,0.03,2090,52438,70,NULL,'SIFTO','DEEP2 11044756',0.418732,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118573,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118573,36.97,0.13,247,52439,70,NULL,NULL,'2MASX J14165359+0822324',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000182,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,214.22325,8.37567,0.073,NULL,58497866751,914029167,14281705,16.4),(118574,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118574,36.67,0.46,215,52440,70,NULL,NULL,'2MASX J14165378+2415244',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000173,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,214.223917,24.25672,0,NULL,59467666333,929182286,14518473,17.8),(118575,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118575,38.02,0.46,402,52441,70,NULL,NULL,'2MASX J14165555+4232052',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000174,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,214.23125,42.53483,0,NULL,59225408599,925397009,14459328,17.5),(118576,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118576,37.88,0.46,376,52442,70,NULL,NULL,'2MASX J14165639+1521031',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,214.235,15.35092,0,NULL,59488924910,929514451,14523663,18.2),(118577,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118577,36.16,0.46,171,52443,70,NULL,NULL,'2MASX J14165678+4538352',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000179,NULL,'16.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,214.236583,45.64328,0,NULL,59229110970,925454858,14460232,16.3),(118578,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118578,37.03,0.46,255,52444,70,NULL,NULL,'2MASX J14165705+2815144',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00009,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,214.2377917,28.25406,0,NULL,60057032585,938391134,14662361,16.6),(118579,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118579,35.84,0.46,147,52445,70,NULL,NULL,'CGCG 018-102',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.00009,NULL,'15.7g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,214.2395,2.17764,0.069,NULL,58286554269,910727410,14230115,15.7),(118580,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq',NULL,118580,42.58,0.2,1900,52446,74.2,NULL,'SALT 2','[HSP2005] J141657.90+522246.53',0.73,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.01,NULL,'22.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,214.2412083,52.37978,0,NULL,59195795964,924934311,14452098,22.5),(118581,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq','R',118581,42.59,NULL,1910,52446,65,NULL,'MLCS17','[HSP2005] J141657.90+522246.53',0.73,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118582,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq',NULL,118582,43.29,0.08,2630,52446,70,NULL,NULL,'[HSP2005] J141657.90+522246.53',0.73,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118583,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq',NULL,118583,43.29,0.05,2630,52446,70,NULL,'SALT 2','[HSP2005] J141657.90+522246.53',0.73,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118584,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq',NULL,118584,43.31,0.17,2650,52446,70,NULL,'SALT','[HSP2005] J141657.90+522246.53',0.73,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118585,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq',NULL,118585,43.31,0.17,2650,52446,NULL,NULL,'SALT2','[HSP2005] J141657.90+522246.53',0.73,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118586,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq',NULL,118586,43.32,0.24,2660,52446,70,NULL,'SALT 2','[HSP2005] J141657.90+522246.53',0.73,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118587,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq',NULL,118587,43.36,0.15,2720,52446,NULL,NULL,'SIFTO','[HSP2005] J141657.90+522246.53',0.73,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118588,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq',NULL,118588,43.43,0.25,2810,52446,65,NULL,'MLCS17','[HSP2005] J141657.90+522246.53',0.73,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118589,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq',NULL,118589,43.44,0.16,2820,52446,65,NULL,'MLCS2k2','[HSP2005] J141657.90+522246.53',0.73,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118590,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq',NULL,118590,43.44,0.2,2820,52446,65,NULL,'SALT2','[HSP2005] J141657.90+522246.53',0.73,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118591,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq',NULL,118591,43.45,0.15,2840,52446,65,NULL,'SALT2','[HSP2005] J141657.90+522246.53',0.73,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118592,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq',NULL,118592,43.47,0.14,2860,52446,65,NULL,'SALT','[HSP2005] J141657.90+522246.53',0.73,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118593,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq',NULL,118593,43.55,0.06,2970,52446,65,NULL,'SALT','[HSP2005] J141657.90+522246.53',0.73,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118594,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq',NULL,118594,43.57,0.24,2990,52446,65,NULL,'MLCS2k2','[HSP2005] J141657.90+522246.53',0.73,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118595,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq',NULL,118595,43.57,0.26,2990,52446,65,NULL,'MLCS31','[HSP2005] J141657.90+522246.53',0.73,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118596,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118596,31.52,0.43,20.1,52447,75,NULL,'3.6 micron, color + selection bias corrected','IC 4390',NULL,'2014MNRAS.444..527S',2014,1,1.8,NULL,'G',0.000667,NULL,'13.78',0.6,'SA(s)b         HII',NULL,NULL,NULL,NULL,1,214.246667,-44.97733,0.373,NULL,46807935172,731373987,11427718,13.78),(118597,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3do',NULL,118597,42.84,0.05,2140,52448,70,NULL,'SIFTO','SNLS 06D3do',0.726,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,214.2474583,52.88256,0,NULL,59194491039,924913922,14451780,NULL),(118598,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3do',NULL,118598,43.34,0.21,2690,52448,70,NULL,'SALT 2','SNLS 06D3do',0.726,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118599,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3do',NULL,118599,43.35,0.15,2720,52448,NULL,NULL,'SIFTO','SNLS 06D3do',0.726,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118600,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3do',NULL,118600,44.31,0.17,4230,52448,NULL,NULL,'SALT2','SNLS 06D3do',0.726,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118601,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118601,35.31,0.19,115,52449,70,NULL,NULL,'2MASX J14165944+1047224',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000174,NULL,'16.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,214.247666667,10.78947,0,NULL,58500640971,914072515,14282383,16.1),(118602,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118602,35.34,0.46,117,52450,70,NULL,NULL,'CGCG 074-157',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000147,NULL,'15.2g',0.43,NULL,NULL,NULL,NULL,NULL,1,214.248875,9.10589,0.033,NULL,58495086848,913985732,14281027,15.2),(118603,'IRAS','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118603,35.04,0.8,102,52451,75,NULL,'HMCL, I','CGCG 046-079',NULL,'1997ApJS..109..333W',1997,1,0.84,NULL,'G',0.000027,NULL,'15.4',0.37,NULL,NULL,NULL,NULL,NULL,1,214.254291667,7.26014,0.045,NULL,58494522128,913976908,14280889,15.4),(118604,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118604,35.18,0.4,109,52451,75,NULL,'HMCL, I, raw','CGCG 046-079',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118605,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118605,35.3,0.4,115,52451,75,NULL,'HMCL, I, cor','CGCG 046-079',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118606,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118606,35.37,0.4,118,52451,75,NULL,'HMCL, I, inv','CGCG 046-079',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118607,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3el',NULL,118607,41.75,0.04,1480,52452,70,NULL,'SIFTO','SNLS 06D3el',0.519,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,214.2545417,52.23239,0,NULL,59195844314,924935067,14452110,NULL),(118608,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3el',NULL,118608,42.41,0.15,2000,52452,NULL,NULL,'SIFTO','SNLS 06D3el',0.519,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118609,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3el',NULL,118609,42.54,0.12,2120,52452,70,NULL,'SALT 2','SNLS 06D3el',0.519,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118610,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3el',NULL,118610,43.71,0.17,3640,52452,NULL,NULL,'SALT2','SNLS 06D3el',0.519,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118611,'CMD','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118611,30.7,0.04,13.8,52453,NULL,NULL,NULL,'SBS 1415+437',NULL,'2010ApJ...721..297M',2010,1,0.75,'Multiple SDSS entries describe this object.','G',0.000007,NULL,'15.6',0.15,'BlueCG         HII',NULL,NULL,NULL,NULL,1,214.255875,43.50153,0,NULL,59238881186,925607518,14462617,15.6),(118612,'TRGB','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118612,30.66,NULL,13.6,52453,NULL,NULL,'BlueCG, HII','SBS 1415+437',NULL,'2005ApJ...631L..45A',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118613,'TRGB','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118613,30.67,0.21,13.6,52453,NULL,NULL,NULL,'SBS 1415+437',NULL,'2014A&A...566A..71L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118614,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118614,35.31,0.19,115,52454,70,NULL,NULL,'2MASX J14170154+1047274',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000067,NULL,'16.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,214.256417,10.79086,0,NULL,58500638929,914072483,14282382,16),(118615,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118615,36.55,0.46,204,52455,70,NULL,NULL,'2MASX J14170289+0838554',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000172,NULL,'16.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,214.261875,8.64878,0.073,NULL,58497171404,914018303,14281535,16.7),(118616,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3gx',NULL,118616,42.75,0.06,2020,52456,70,NULL,NULL,'SNLS 06D3gx HOST',0.76,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.02,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.264,52.93939,0,NULL,59194573786,924915215,14451800,NULL),(118617,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3gx',NULL,118617,43.48,0.25,2830,52456,70,NULL,'SALT 2','SNLS 06D3gx HOST',0.76,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118618,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118618,31.82,NULL,23.1,52457,72,NULL,NULL,'GALEXASC J141703.59-013013.2',NULL,'2014Ap.....57..457K',2014,1,0.66,NULL,'G',0.000007,NULL,'17.58',0.3,'Ir',NULL,NULL,NULL,NULL,1,214.264833,-1.50444,0.145,NULL,43507016461,679797132,10621830,17.58),(118619,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118619,37.6,0.46,330,52458,70,NULL,NULL,'2MASX J14170384+4616442',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,214.2659583,46.27908,0,NULL,59229757141,925464955,14460389,17.4),(118620,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118620,36.49,0.46,199,52459,70,NULL,NULL,'[HB89] 1414+092',NULL,'2015arXiv151105856S',2015,1,0.35,'HB89 calls this a QSO with z = 2.35.','G',0.000167,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,214.267083333,8.96858,0.033,NULL,58495131656,913986432,14281038,16.7),(118621,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118621,32.88,0.47,37.6,52460,NULL,NULL,'H','NGC 5545',NULL,'2007A&A...465...71T',2007,1,0.08,'Multiple SDSS entries describe this object.','G',0.000033,NULL,'18.5g',0.08,'SA(s)bc:','Pair member (points to parent)',NULL,NULL,NULL,1,214.2715,36.57511,0,NULL,60032265904,938004154,14656314,18.5),(118622,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118622,32.96,0.46,39.1,52460,NULL,NULL,'J','NGC 5545',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118623,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118623,33.04,0.45,40.6,52460,NULL,NULL,'K','NGC 5545',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118624,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118624,33.33,0.4,46.4,52460,NULL,NULL,'mean','NGC 5545',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118625,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118625,37.76,0.46,356,52461,70,NULL,NULL,'2MASX J14170704+1643082',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,214.279375,16.71894,0,NULL,59485037917,929453717,14522714,18.3),(118626,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118626,37.78,0.46,359,52462,70,NULL,NULL,'SDSS J141708.01-010526.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000065,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,214.283417,-1.09064,0.137,NULL,43503813939,679747092,10621048,18.5),(118627,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118627,36.97,0.46,248,52463,70,NULL,NULL,'2MASX J14170836+5251555',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000176,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,214.284875,52.86553,0,NULL,59197915736,924967433,14452616,16.8),(118628,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118628,37.09,0.33,262,52464,70,NULL,NULL,'2MASX J14170931+0915074',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,214.2887083,9.252,0.038,NULL,58499593826,914056153,14282127,16.8),(118629,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118629,36.64,0.46,212,52465,70,NULL,NULL,'2MASX J14170959+1707012',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.23',0.17,NULL,NULL,NULL,NULL,NULL,1,214.2899583,17.11692,0,NULL,59486966974,929483858,14523185,18.23),(118630,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118630,37.45,0.46,310,52466,70,NULL,NULL,'2MASX J14170991+5246586',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000182,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,214.291375,52.78294,0.005,NULL,59197928724,924967636,14452619,16.6),(118631,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3bz',NULL,118631,43.07,0.17,2390,52467,NULL,NULL,'SALT2','SNLS 06D3bz HOST',0.72,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',NULL,NULL,'23.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,214.29175,53.02472,0,NULL,59194587739,924915433,14451803,23.1),(118632,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3bz',NULL,118632,43.1,0.06,2420,52467,70,NULL,'SALT2','SNLS 06D3bz HOST',0.72,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118633,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3bz',NULL,118633,43.14,0.15,2460,52467,NULL,NULL,'SIFTO','SNLS 06D3bz HOST',0.72,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118634,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3bz',NULL,118634,43.31,0.22,2670,52467,70,NULL,'SALT 2','SNLS 06D3bz HOST',0.72,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118635,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118635,37.63,0.33,336,52468,70,NULL,NULL,'SDSS J141711.44+063609.3',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,'PHOT','16.6g',0.37,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,214.297667,6.60261,0.029,NULL,58503117176,914111205,14282987,16.6),(118636,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118636,35.95,0.41,155,52469,NULL,NULL,'Malmquist cor.','MCG +06-31-092',NULL,'2009ApJS..182..474S',2009,1,0.84,NULL,'G',0.000023,NULL,'15.3g',0.3,'SABc(r)',NULL,NULL,NULL,NULL,1,214.29925,35.40933,0,NULL,60044861025,938200953,14659389,15.3),(118637,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118637,36.27,0.36,180,52469,NULL,NULL,NULL,'MCG +06-31-092',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118638,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118638,36.31,0.2,183,52469,74.4,NULL,NULL,'MCG +06-31-092',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118639,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118639,35.31,0.19,115,52470,70,NULL,NULL,'2MASX J14171192+1036424',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000157,NULL,'16.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,214.299541667,10.61178,0,NULL,58501109568,914079837,14282497,16.1),(118640,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118640,36.83,0.12,232,52471,70,NULL,NULL,'2MASX J14171277+0142504',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000099,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,214.303208333,1.714,0.013,NULL,58286645788,910728840,14230138,16.7),(118641,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118641,36.36,0.46,187,52472,70,NULL,NULL,'2MASX J14171303+0721454',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000168,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,214.3045417,7.36264,0.045,NULL,58494543997,913977249,14280894,16.2),(118642,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118642,36.83,0.12,232,52473,70,NULL,NULL,'SDSS J141713.19+022051.7',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000062,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,214.305,2.34769,0.073,NULL,58286216659,910722135,14230033,17.4),(118643,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118643,38.83,0.46,583,52474,70,NULL,NULL,'2MASX J14171320-0134336',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,214.3050417,-1.57597,0.145,NULL,43504942158,679764721,10621323,18.1),(118644,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118644,36.43,0.46,193,52475,70,NULL,NULL,'2MASX J14171324+3112094',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00011,NULL,'16.30',0.35,NULL,NULL,NULL,NULL,NULL,1,214.305083,31.20267,0,NULL,60060734637,938448978,14663265,16.3),(118645,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118645,36.81,0.33,230,52476,70,NULL,NULL,'2MASX J14171357+0118064',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000103,NULL,'16.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,214.306583,1.30189,0.065,NULL,58287478236,910741847,14230341,16.4),(118646,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118646,38.41,0.46,481,52477,70,NULL,NULL,'SDSS J141714.52+431041.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,214.3105417,43.17833,0,NULL,59225058056,925391532,14459242,18.4),(118647,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118647,36.96,0.46,247,52478,70,NULL,NULL,'2MASX J14171550+2843544',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000172,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,214.314583,28.73175,0,NULL,60058693716,938417089,14662767,16.7),(118648,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118648,37.88,0.46,377,52479,70,NULL,NULL,'2MASX J14171549+2531114',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000175,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,214.3147083,25.51989,0,NULL,60000326395,937505099,14648517,17.5),(118649,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118649,37.39,0.15,300,52480,70,NULL,NULL,'2MASX J14171595+2619524',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000185,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,214.3164583,26.33128,0,NULL,59999803157,937496924,14648389,16.9),(118650,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118650,36.43,0.46,193,52481,70,NULL,NULL,'2MASX J14171627-0135216',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000173,NULL,'16.0g',0.39,'E0',NULL,NULL,NULL,NULL,1,214.317875,-1.58922,0.145,NULL,43504940393,679764693,10621323,16),(118651,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118651,36.41,0.46,191,52482,70,NULL,NULL,'2MASX J14171637+1933532',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.3182083,19.56478,0,NULL,59520472645,930007385,14531365,NULL),(118652,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118652,37.63,0.33,336,52483,70,NULL,NULL,'2MASX J14171764+0633374',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,214.3234583,6.56053,0.025,NULL,58503104344,914111005,14282984,17.9),(118653,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118653,36.81,0.33,230,52484,70,NULL,NULL,'2MASX J14171777+0113174',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000072,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,214.3239583,1.22153,0.065,NULL,58287474486,910741788,14230340,17.1),(118654,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118654,37.57,0.46,327,52485,70,NULL,NULL,'2MASX J14171791+2041032',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.77',0.15,NULL,NULL,NULL,NULL,NULL,1,214.324583,20.68422,0.016,NULL,59521765909,930027592,14531681,17.77),(118655,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118655,37.18,0.46,273,52486,70,NULL,NULL,'2MASX J14171828+1248319',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,214.326166667,12.80894,0,NULL,58354756962,911793077,14246766,17.7),(118656,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118656,37.04,0.46,256,52487,70,NULL,NULL,'2MASX J14171855+1809462',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'18.18',0.18,NULL,NULL,NULL,NULL,NULL,1,214.327417,18.16294,0,NULL,59486240711,929472511,14523007,18.18),(118657,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','PS1 SN PS10jp','N',118657,41.36,0.18,1350,52488,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10jp HOST',0.3874,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118658,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118658,36.79,0.16,228,52489,70,NULL,NULL,'2MASX J14171867+0005403',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000105,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,214.327833,0.09456,0.057,NULL,58284126819,910689481,14229523,16.4),(118659,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118659,36.83,0.12,232,52490,70,NULL,NULL,'2MASX J14171918+0233044',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000098,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,214.329875,2.55131,0.077,NULL,58286257949,910722780,14230043,16.5),(118660,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118660,37.39,0.15,300,52491,70,NULL,NULL,'2MASX J14171930+2618544',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000161,NULL,'17.97',0.13,NULL,NULL,NULL,NULL,NULL,1,214.3305417,26.31506,0,NULL,59999805032,937496953,14648389,17.97),(118661,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118661,36.73,0.72,221,52492,70,NULL,NULL,'2MASX J14172004-3451191',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,214.333458333,-34.85528,0.173,NULL,47009732322,734527067,11476985,15.8),(118662,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118662,38.74,0.46,560,52493,70,NULL,NULL,'LCRS B141444.3-030150',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000141,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,214.33375,-3.26133,0.109,NULL,43730918987,683295609,10676493,17.9),(118663,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118663,37.18,0.23,273,52494,70,NULL,NULL,'2MASX J14172122+3014261',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.49',0.32,NULL,NULL,NULL,NULL,NULL,1,214.3384583,30.24069,0,NULL,60061892803,938467075,14663548,16.49),(118664,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3dt',NULL,118664,40.94,0.15,1200,52495,NULL,NULL,'SIFTO','SNLS 06D3dt',0.282,'2010A&A...523A...7G',2010,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,214.34025,52.45281,0,NULL,59195822236,924934722,14452105,NULL),(118665,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3dt',NULL,118665,40.95,0.11,1210,52495,70,NULL,'SALT 2','SNLS 06D3dt',0.282,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118666,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3dt',NULL,118666,41.28,0.17,1400,52495,NULL,NULL,'SALT2','SNLS 06D3dt',0.282,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118667,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3dt',NULL,118667,41.77,0.03,1760,52495,70,NULL,'SIFTO','SNLS 06D3dt',0.282,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118668,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118668,36.83,0.12,232,52496,70,NULL,NULL,'2MASX J14172244+0202074',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000094,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,214.3435,2.03536,0.057,NULL,58286579310,910727801,14230121,16.4),(118669,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118669,38.99,0.46,628,52497,70,NULL,NULL,'SDSS J141722.56+025217.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000096,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,214.3440417,2.87158,0.073,NULL,58286150082,910721095,14230017,18.3),(118670,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118670,37.13,0.46,267,52498,70,NULL,NULL,'VIII Zw 395',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000099,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,214.348583,1.64469,0.013,NULL,58286651233,910728925,14230139,16.3),(118671,'SGRB','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118671,42.6,NULL,3310,52499,70,NULL,'Photometric Distance, Host A, M(R) = -20 mag and spectral slope Beta = 1.0 ','GRB 050717',NULL,'2012A&A...545A..77R',2012,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,214.352041667,-50.5335,1.109,NULL,46837934237,731842722,11435042,NULL),(118672,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118672,36.29,0.33,181,52500,70,NULL,NULL,'CGCG 046-081',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000203,NULL,'15.5',0.27,NULL,NULL,NULL,NULL,NULL,1,214.35425,8.05,0.044,NULL,58497923375,914030052,14281719,15.5),(118673,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118673,35.01,0.48,101,52501,70,NULL,NULL,'2MASX J14172504-3516311',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.5I',0.4,NULL,NULL,NULL,NULL,NULL,1,214.3544583,-35.27525,0.161,NULL,47008908682,734514198,11476784,13.5),(118674,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3jh',NULL,118674,42.73,0.17,2050,52502,NULL,NULL,'SALT2','SNLS 05D3jh',0.718,'2010A&A...523A...7G',2010,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,214.35575,52.61878,0.005,NULL,59197934100,924967720,14452620,NULL),(118675,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3jh',NULL,118675,42.76,0.05,2080,52502,70,NULL,'SALT2','SNLS 05D3jh',0.718,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118676,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3jh',NULL,118676,43.12,0.15,2450,52502,NULL,NULL,'SIFTO','SNLS 05D3jh',0.718,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118677,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3jh',NULL,118677,43.18,0.18,2520,52502,70,NULL,'SALT 2','SNLS 05D3jh',0.718,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118678,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118678,37.39,0.15,300,52503,70,NULL,NULL,'2MASX J14172547+2620534',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000196,NULL,'17.52',0.25,NULL,NULL,NULL,NULL,NULL,1,214.356291667,26.34814,0,NULL,59999832441,937497381,14648396,17.52),(118679,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118679,36.83,0.12,232,52504,70,NULL,NULL,'2MASX J14172681+0202488',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000101,NULL,'15.8g',0.47,'S0^-',NULL,NULL,NULL,NULL,1,214.3617083,2.04689,0.057,NULL,58286579070,910727797,14230121,15.8),(118680,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118680,37.39,0.15,300,52505,70,NULL,NULL,'2MASX J14172770+2620435',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,214.3655,26.34547,0,NULL,59999833477,937497398,14648396,17.1),(118681,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118681,37.72,0.46,350,52506,70,NULL,NULL,'2MASX J14172774+4141249',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000164,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,214.3657083,41.69036,0,NULL,59227282485,925426288,14459785,18.1),(118682,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118682,36.79,0.16,228,52507,70,NULL,NULL,'CGCG 018-107',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000093,NULL,'15.5g',0.48,'NLAGN',NULL,NULL,NULL,NULL,1,214.366541667,0.48278,0.073,NULL,58285093912,910704592,14229759,15.5),(118683,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118683,37.18,0.23,273,52508,70,NULL,NULL,'2MASX J14173001+3017351',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.82',0.21,NULL,NULL,NULL,NULL,NULL,1,214.374917,30.29308,0,NULL,60061867827,938466684,14663541,17.82),(118684,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118684,36.79,0.16,228,52509,70,NULL,NULL,'CGCG 018-108',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000104,NULL,'15.7g',0.42,'E0',NULL,NULL,NULL,NULL,1,214.3777083,0.35053,0.073,NULL,58284986780,910702918,14229733,15.7),(118685,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118685,38.26,0.19,450,52510,70,NULL,NULL,'2MASX J14173091+4320537',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000063,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,214.378583,43.34817,0,NULL,59225074441,925391788,14459246,17.3),(118686,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118686,36.97,0.13,247,52511,70,NULL,NULL,'NGC 5535',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.0002,NULL,'15.7g',0.5,'E',NULL,NULL,'radio jet',NULL,1,214.3802917,8.20839,0.044,NULL,58497904679,914029760,14281715,15.7),(118687,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118687,37.05,0.46,257,52512,70,NULL,NULL,'2MASX J14173150+0046178',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000085,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,214.381167,0.77164,0.069,NULL,58284743998,910699124,14229673,16.5),(118688,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3cc',NULL,118688,43.18,0.07,2280,52513,70,NULL,'SIFTO','SNLS 06D3cc HOST',0.9,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',NULL,NULL,'23.5R',NULL,'a',NULL,NULL,NULL,NULL,1,214.381416667,52.91233,0,NULL,59198031379,924969240,14452644,23.5),(118689,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3cc',NULL,118689,43.31,0.31,2420,52513,70,NULL,'SALT 2','SNLS 06D3cc HOST',0.9,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118690,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3cc',NULL,118690,43.33,0.15,2440,52513,NULL,NULL,'SIFTO','SNLS 06D3cc HOST',0.9,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118691,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3cc',NULL,118691,44.45,0.17,4090,52513,NULL,NULL,'SALT2','SNLS 06D3cc HOST',0.9,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118692,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3lb',NULL,118692,42.96,0.17,2370,52514,70,NULL,'SALT 2','SNLS 05D3lb HOST',0.647,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'a',NULL,NULL,NULL,NULL,1,214.382375,53.16789,0,NULL,59194593730,924915527,14451805,NULL),(118693,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3lb',NULL,118693,43.05,NULL,2480,52514,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SNLS 05D3lb HOST',0.647,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118694,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3lb',NULL,118694,43.06,0.15,2480,52514,NULL,NULL,'SIFTO','SNLS 05D3lb HOST',0.647,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118695,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3lb',NULL,118695,43.16,0.04,2600,52514,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SNLS 05D3lb HOST',0.647,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118696,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3lb',NULL,118696,43.62,0.17,3210,52514,NULL,NULL,'SALT2','SNLS 05D3lb HOST',0.647,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118697,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118697,37.1,0.46,262,52515,70,NULL,NULL,'2MASX J14173337+1908133',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,214.389041667,19.13708,0,NULL,59519023168,929984737,14531011,17.2),(118698,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118698,37.24,0.46,281,52516,70,NULL,NULL,'2MASX J14173402+4850375',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000175,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,214.39175,48.84378,0,NULL,59245855881,925716498,14464320,17.1),(118699,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118699,36.97,0.13,247,52517,70,NULL,NULL,'2MASX J14173411+0813258',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'17.88',0.14,NULL,NULL,NULL,NULL,NULL,1,214.392125,8.22397,0.044,NULL,58497903427,914029741,14281714,17.88),(118700,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118700,37.55,0.46,323,52518,70,NULL,NULL,'2MASXi J1417346+405430',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000182,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,214.394583,40.90861,0,NULL,59945594213,936649909,14635154,17.7),(118701,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118701,38.14,0.33,425,52519,70,NULL,NULL,'2MASX J14173576-0029023',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000075,NULL,'17.8g',0.15,'BrClG',NULL,NULL,NULL,NULL,1,214.3989583,-0.48422,0.085,NULL,43504347734,679755433,10621178,17.8),(118702,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118702,36.97,0.13,247,52520,70,NULL,NULL,'CGCG 046-084 NED02',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000175,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.4005,8.17914,0.044,NULL,58497953935,914030530,14281727,17.4),(118703,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118703,36.55,0.46,204,52521,70,NULL,NULL,'2MASX J14173629+0146058',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000098,NULL,'16.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,214.40125,1.76817,0.065,NULL,58286659135,910729048,14230141,16.2),(118704,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118704,36.97,0.13,247,52522,70,NULL,NULL,'NGC 5539',NULL,'2015arXiv151105856S',2015,1,0.9,'Called NGC 5535/5539 in CGCG and MCG.','G',0.000147,NULL,'14.20',0.72,'cD;BrClG',NULL,NULL,NULL,NULL,1,214.407375,8.17961,0.044,NULL,58497947525,914030430,14281725,14.2),(118705,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118705,36.73,0.46,222,52523,70,NULL,NULL,'2MASX J14173776+2452325',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,214.4074583,24.87567,0.009,NULL,60000118614,937501853,14648466,17.5),(118706,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118706,37.24,0.46,280,52524,70,NULL,NULL,'2MASX J14173805+0458408',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000076,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,214.408583333,4.978,0.033,NULL,58473533103,913648954,14275764,17.5),(118707,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118707,38.14,0.33,425,52525,70,NULL,NULL,'2MASX J14173817-0028553',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000101,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,214.409041667,-0.48222,0.085,NULL,43504347710,679755432,10621178,17.9),(118708,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118708,37.07,0.46,260,52526,70,NULL,NULL,'2MASX J14173847+2304143',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.66',0.23,NULL,NULL,NULL,NULL,NULL,1,214.4104583,23.07056,0,NULL,59469257670,929207151,14518861,17.66),(118709,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118709,38.19,0.23,435,52527,70,NULL,NULL,'SDSS J141738.58+052057.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000071,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,214.4107917,5.34939,0.033,NULL,58473595568,913649930,14275780,18.6),(118710,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118710,38.3,0.46,458,52528,70,NULL,NULL,'2MASX J14173904+4157097',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000199,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,214.412375,41.95269,0,NULL,59227274141,925426158,14459783,17),(118711,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118711,35.22,0.2,111,52529,74.4,NULL,NULL,'CGCG 074-159',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000127,NULL,'15.1',0.3,NULL,NULL,NULL,NULL,NULL,1,214.4152083,12.95917,0,NULL,58354736001,911792750,14246761,15.1),(118712,'SNII optical','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2001bq',NULL,118712,32.55,0.13,31.8,52530,NULL,NULL,'SEAM','NGC 5534',0.008748,'2009ApJ...694.1067P',2009,1,1.4,NULL,'G',0.000021,NULL,'12.8B',0.8,'(R\')SAB(s)abpecHII',NULL,NULL,NULL,'Starburst',1,214.41775,-7.41742,0.121,NULL,43709198507,682956226,10671191,12.8),(118713,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118713,37.09,0.46,262,52531,70,NULL,NULL,'2MASX J14174029+1829403',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,214.418041667,18.49458,0,NULL,59518858533,929982164,14530971,16.9),(118714,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118714,34.72,0.49,87.8,52532,75,NULL,'IR','FGC 1738',NULL,'2011yCatp016004901K',2011,1,1.38,NULL,'G',0.00015,NULL,'15.00',0.26,'Sc             HII',NULL,NULL,NULL,NULL,1,214.421333,-5.46317,0.105,NULL,43730828888,683294201,10676471,15),(118715,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118715,35.77,0.46,142,52533,70,NULL,NULL,'2MASX J14174126+4527568',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000177,NULL,'15.8g',0.45,'S0',NULL,NULL,NULL,NULL,1,214.422125,45.46583,0,NULL,59229131048,925455172,14460237,15.8),(118716,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118716,36.97,0.13,247,52534,70,NULL,NULL,'2MASX J14174159+0813068',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,214.423417,8.21844,0.043,NULL,58497904020,914029750,14281714,17.9),(118717,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3hq',NULL,118717,41.14,0.17,1260,52535,NULL,NULL,'SALT2','[NSB2006] J141743.05+521122.6',0.34,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',NULL,NULL,'20.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,214.42925,52.18953,0,NULL,59195809724,924934526,14452101,20.4),(118718,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3hq',NULL,118718,41.32,0.15,1370,52535,NULL,NULL,'SIFTO','[NSB2006] J141743.05+521122.6',0.34,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118719,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118719,38.04,0.46,406,52536,70,NULL,NULL,'2MASX J14174332+0611538',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,214.430541667,6.19822,0.025,NULL,58502345790,914099152,14282799,17.5),(118720,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118720,36.83,0.12,232,52537,70,NULL,NULL,'SDSS J141744.37+020336.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000077,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,214.434917,2.06028,0.057,NULL,58287092513,910735820,14230247,17.9),(118721,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3gn',NULL,118721,40.05,0.17,818,52538,NULL,NULL,'SALT2','SNLS 06D3gn',0.25,'2010A&A...523A...7G',2010,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,214.4359583,52.36119,0,NULL,59195830527,924934851,14452107,NULL),(118722,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3gn',NULL,118722,40.49,0.15,1000,52538,NULL,NULL,'SIFTO','SNLS 06D3gn',0.25,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118723,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3gn',NULL,118723,41.68,0.03,1730,52538,70,NULL,'SALT2','SNLS 06D3gn',0.25,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118724,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118724,38.27,0.33,451,52539,70,NULL,NULL,'2MASX J14174547+2444065',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000152,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,214.4395,24.73525,0,NULL,59467247550,929175742,14518370,18.4),(118725,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do','R',118725,42.02,NULL,1580,52540,65,NULL,'MLCS17','[AGR2006] J141746.11+521603.3',0.61,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.01,NULL,'22.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,214.44175,52.26747,0,NULL,59195838210,924934972,14452108,22.6),(118726,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do',NULL,118726,42.18,0.16,1700,52540,74.2,NULL,'SALT 2','[AGR2006] J141746.11+521603.3',0.61,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118727,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do',NULL,118727,42.24,0.17,1740,52540,NULL,NULL,'SALT2','[AGR2006] J141746.11+521603.3',0.61,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118728,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do',NULL,118728,42.61,0.04,2070,52540,70,NULL,'MLCS17','[AGR2006] J141746.11+521603.3',0.61,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118729,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do',NULL,118729,42.72,0.23,2180,52540,65,NULL,'MLCS17','[AGR2006] J141746.11+521603.3',0.61,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118730,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do',NULL,118730,42.8,0.04,2250,52540,70,NULL,NULL,'[AGR2006] J141746.11+521603.3',0.61,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118731,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do',NULL,118731,42.82,0.27,2270,52540,65,NULL,'MLCS2k2','[AGR2006] J141746.11+521603.3',0.61,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118732,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do',NULL,118732,42.82,0.28,2270,52540,65,NULL,'MLCS31','[AGR2006] J141746.11+521603.3',0.61,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118733,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do',NULL,118733,42.87,0.12,2320,52540,65,NULL,'MLCS2k2','[AGR2006] J141746.11+521603.3',0.61,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118734,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do',NULL,118734,42.88,0.15,2340,52540,70,NULL,'SALT','[AGR2006] J141746.11+521603.3',0.61,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118735,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do',NULL,118735,42.91,0.12,2370,52540,65,NULL,'SALT2','[AGR2006] J141746.11+521603.3',0.61,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118736,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do',NULL,118736,42.91,0.14,2370,52540,70,NULL,'SALT 2','[AGR2006] J141746.11+521603.3',0.61,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118737,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do',NULL,118737,42.99,0.15,2460,52540,NULL,NULL,'SIFTO','[AGR2006] J141746.11+521603.3',0.61,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118738,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do',NULL,118738,43.03,0.18,2510,52540,65,NULL,'SALT2','[AGR2006] J141746.11+521603.3',0.61,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118739,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do',NULL,118739,43.06,0.03,2540,52540,65,NULL,'SALT','[AGR2006] J141746.11+521603.3',0.61,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118740,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do',NULL,118740,43.07,0.12,2550,52540,65,NULL,'SALT','[AGR2006] J141746.11+521603.3',0.61,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118741,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118741,36.97,0.13,247,52541,70,NULL,NULL,'2MASX J14174617+0810418',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.442375,8.17819,0.044,NULL,58497949351,914030458,14281725,17.6),(118742,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118742,37.23,0.46,279,52542,70,NULL,NULL,'2MASX J14174629+4952231',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000197,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,214.443041667,49.87294,0.005,NULL,59253834776,925841168,14466268,16.2),(118743,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3dd',NULL,118743,43.31,0.38,2280,52543,74.2,NULL,'SALT 2','GSS 074_5532',1.01,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.02,NULL,'26.2V',NULL,NULL,NULL,NULL,NULL,NULL,1,214.4517083,52.47047,0,NULL,59197908814,924967325,14452614,26.2),(118744,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3dd','R',118744,43.56,NULL,2570,52543,65,NULL,'MLCS17','GSS 074_5532',1.01,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118745,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3dd',NULL,118745,44.24,0.15,3500,52543,70,NULL,'SALT 2','GSS 074_5532',1.01,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118746,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3dd',NULL,118746,44.33,0.33,3650,52543,65,NULL,'SALT2','GSS 074_5532',1.01,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118747,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3dd',NULL,118747,44.67,0.53,4280,52543,70,NULL,NULL,'GSS 074_5532',1.01,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118748,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3dd',NULL,118748,44.68,0.19,4290,52543,65,NULL,'MLCS17','GSS 074_5532',1.01,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118749,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3dd',NULL,118749,44.69,0.2,4310,52543,65,NULL,'MLCS2k2','GSS 074_5532',1.01,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118750,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3dd',NULL,118750,44.69,0.91,4310,52543,70,NULL,'SALT','GSS 074_5532',1.01,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118751,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3dd',NULL,118751,44.7,0.16,4320,52543,65,NULL,'MLCS31','GSS 074_5532',1.01,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118752,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3dd',NULL,118752,44.7,0.14,4330,52543,65,NULL,'MLCS2k2','GSS 074_5532',1.01,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118753,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3dd',NULL,118753,44.88,0.86,4700,52543,65,NULL,'SALT','GSS 074_5532',1.01,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118754,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3dd',NULL,118754,44.92,0.15,4790,52543,NULL,NULL,'SIFTO','GSS 074_5532',1.01,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118755,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3dd',NULL,118755,44.92,0.58,4800,52543,65,NULL,'SALT2','GSS 074_5532',1.01,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118756,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3dd',NULL,118756,44.94,0.33,4840,52543,65,NULL,'SALT','GSS 074_5532',1.01,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118757,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3dd',NULL,118757,45.22,0.17,5510,52543,NULL,NULL,'SALT2','GSS 074_5532',1.01,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118758,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118758,33.22,0.69,44.1,52544,100,NULL,'mid-IR','IC 0991',NULL,'2013ApJ...771...88L',2013,1,1.5,NULL,'G',0.000017,NULL,'13.84',0.9,'SB(s)c:        HII',NULL,NULL,NULL,NULL,1,214.452416667,-13.87294,0.213,NULL,43640022407,681875350,10654302,13.84),(118759,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118759,33.63,0.57,53.1,52544,NULL,NULL,'Malmquist cor.','IC 0991',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118760,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118760,33.89,0.47,59.9,52544,NULL,NULL,'H','IC 0991',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118761,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118761,33.92,0.2,60.8,52544,74.4,NULL,NULL,'IC 0991',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118762,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118762,34,0.46,63,52544,NULL,NULL,'J','IC 0991',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118763,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118763,34,0.45,63,52544,NULL,NULL,'K','IC 0991',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118764,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118764,34.02,0.47,63.7,52544,NULL,NULL,NULL,'IC 0991',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118765,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118765,34.07,0.4,65.1,52544,NULL,NULL,'mean','IC 0991',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118766,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118766,36.98,0.46,249,52545,70,NULL,NULL,'2MASX J14174881+4802231',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,214.4535417,48.03969,0.039,NULL,59247343467,925739741,14464683,17.8),(118767,'IRAS','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118767,32.71,0.8,34.9,52546,75,NULL,'MAT, I','IC 4393',NULL,'1997ApJS..109..333W',1997,1,2.49,'Confused HIPASS source','G',0.00002,NULL,'14.55',0.28,'Scd            HII',NULL,NULL,NULL,NULL,1,214.4539583,-31.34908,0.269,NULL,47041035841,735016185,11484627,14.55),(118768,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118768,32.48,0.4,31.4,52546,75,NULL,NULL,'IC 4393',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118769,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118769,32.99,0.43,39.5,52546,75,NULL,'3.6 micron, color + selection bias corrected','IC 4393',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118770,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118770,33.02,0.4,40.3,52546,NULL,NULL,'mean','IC 4393',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118771,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118771,33.1,0.43,41.7,52546,75,NULL,'MAT, I, raw','IC 4393',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118772,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118772,33.15,0.32,42.6,52546,85,NULL,'I, raw','IC 4393',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118773,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118773,33.18,0.32,43.2,52546,85,NULL,'I, inv','IC 4393',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118774,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118774,33.18,0.49,43.3,52546,75,NULL,'IR','IC 4393',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118775,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118775,33.19,0.43,43.5,52546,75,NULL,'3.6 micron, color corrected','IC 4393',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118776,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118776,33.23,0.44,44.3,52546,NULL,NULL,NULL,'IC 4393',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118777,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118777,33.24,0.2,44.5,52546,74.4,NULL,NULL,'IC 4393',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118778,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118778,33.25,0.43,44.7,52546,75,NULL,'MAT, I, inv','IC 4393',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118779,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118779,33.3,0.47,45.7,52546,NULL,NULL,'H','IC 4393',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118780,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118780,33.35,0.45,46.8,52546,NULL,NULL,'K','IC 4393',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118781,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118781,33.4,0.46,47.9,52546,NULL,NULL,'J','IC 4393',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118782,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118782,33.41,0.43,48.1,52546,75,NULL,'MAT, I, cor','IC 4393',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118783,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118783,33.45,0.39,49,52546,NULL,NULL,'Malmquist cor.','IC 4393',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118784,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118784,33.73,NULL,55.7,52546,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 4393',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118785,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118785,33.75,NULL,56.2,52546,NULL,NULL,'Dipole + Quadrupole','IC 4393',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118786,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118786,33.76,NULL,56.5,52546,NULL,NULL,'Dipole','IC 4393',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118787,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118787,33.81,NULL,57.9,52546,NULL,NULL,NULL,'IC 4393',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118788,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118788,37.85,0.46,372,52547,70,NULL,NULL,'2MASX J14174896+4149130',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,214.4540417,41.82033,0,NULL,59227305342,925426645,14459791,17.9),(118789,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118789,38.26,0.19,450,52548,70,NULL,NULL,'2MASX J14174934+4323008',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,214.455667,43.3835,0,NULL,59225019679,925390932,14459233,17.7),(118790,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118790,35.64,0.49,134,52549,NULL,NULL,'Malmquist cor.','ESO 511- G 019',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.92',0.4,'S...',NULL,NULL,NULL,NULL,1,214.457125,-26.37947,0.277,NULL,46985139259,734142800,11470981,15.92),(118791,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118791,35.69,0.48,138,52549,NULL,NULL,NULL,'ESO 511- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118792,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118792,35.73,0.2,140,52549,74.4,NULL,NULL,'ESO 511- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118793,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118793,36.79,0.16,228,52550,70,NULL,NULL,'CGCG 018-112',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000124,NULL,'15.6g',0.44,'BrClG          AGN',NULL,NULL,NULL,NULL,1,214.45775,0.51094,0.085,NULL,58284877217,910701206,14229706,15.6),(118794,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118794,36.97,0.13,247,52551,70,NULL,NULL,'2MASX J14174996+0816044',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000191,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,214.4582917,8.26806,0.043,NULL,58497785807,914027903,14281685,16.3),(118795,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co',NULL,118795,42.26,0.17,1750,52552,NULL,NULL,'SALT2','[AGR2006] J141750.03+525748.9',0.62,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.4584583,52.96358,0,NULL,59198044975,924969452,14452647,NULL),(118796,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co','R',118796,42.29,NULL,1780,52552,65,NULL,'MLCS31','[AGR2006] J141750.03+525748.9',0.62,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118797,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co',NULL,118797,42.31,0.17,1790,52552,74.2,NULL,'SALT 2','[AGR2006] J141750.03+525748.9',0.62,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118798,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co',NULL,118798,42.71,0.15,2150,52552,NULL,NULL,'SIFTO','[AGR2006] J141750.03+525748.9',0.62,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118799,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co',NULL,118799,42.86,0.17,2310,52552,70,NULL,'SALT 2','[AGR2006] J141750.03+525748.9',0.62,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118800,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co',NULL,118800,43.03,0.06,2490,52552,70,NULL,NULL,'[AGR2006] J141750.03+525748.9',0.62,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118801,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co',NULL,118801,43.1,0.15,2570,52552,70,NULL,'SALT','[AGR2006] J141750.03+525748.9',0.62,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118802,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co',NULL,118802,43.12,0.05,2590,52552,70,NULL,'SALT2','[AGR2006] J141750.03+525748.9',0.62,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118803,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co',NULL,118803,43.16,0.15,2640,52552,65,NULL,'SALT2','[AGR2006] J141750.03+525748.9',0.62,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118804,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co',NULL,118804,43.2,0.24,2700,52552,65,NULL,'MLCS2k2','[AGR2006] J141750.03+525748.9',0.62,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118805,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co',NULL,118805,43.21,0.25,2700,52552,65,NULL,'MLCS31','[AGR2006] J141750.03+525748.9',0.62,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118806,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co',NULL,118806,43.24,0.17,2740,52552,65,NULL,'MLCS2k2','[AGR2006] J141750.03+525748.9',0.62,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118807,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co',NULL,118807,43.23,0.24,2740,52552,65,NULL,'MLCS17','[AGR2006] J141750.03+525748.9',0.62,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118808,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co',NULL,118808,43.26,0.12,2780,52552,65,NULL,'SALT','[AGR2006] J141750.03+525748.9',0.62,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118809,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co',NULL,118809,43.3,0.05,2820,52552,65,NULL,'SALT','[AGR2006] J141750.03+525748.9',0.62,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118810,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co',NULL,118810,43.3,0.19,2830,52552,65,NULL,'SALT2','[AGR2006] J141750.03+525748.9',0.62,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118811,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118811,36.29,0.33,181,52553,70,NULL,NULL,'2MASX J14175003+0812504',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.17',0.21,NULL,NULL,NULL,NULL,NULL,1,214.458583333,8.21394,0.043,NULL,58497900638,914029697,14281714,17.17),(118812,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118812,36.79,0.16,228,52554,70,NULL,NULL,'SDSS J141750.34+001940.5',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000072,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,214.4597917,0.32792,0.073,NULL,58284997753,910703089,14229735,17.4),(118813,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','PS1 SN PS10iw','N',118813,41.96,0.19,1710,52555,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10iw HOST',0.4474,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118814,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118814,32.24,NULL,28,52556,72,NULL,NULL,'AGC 243881',NULL,'2014Ap.....57..457K',2014,1,NULL,NULL,'RadioS',0.000127,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.460833,6.83528,0.029,NULL,58493897371,913967146,14280736,NULL),(118815,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118815,37.53,0.46,321,52557,70,NULL,NULL,'2MASXi J1417509+370434',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,214.4624583,37.07619,0,NULL,60032995677,938015557,14656493,17.5),(118816,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118816,38.26,0.19,450,52558,70,NULL,NULL,'SDSS J141751.46+431449.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000083,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,214.464417,43.24711,0,NULL,59225067841,925391685,14459245,18.3),(118817,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118817,38.26,0.19,450,52559,70,NULL,NULL,'2MASX J14175154+4325058',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000188,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,214.464666667,43.41825,0,NULL,59225021206,925390956,14459233,16.9),(118818,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118818,37.63,0.46,335,52560,70,NULL,NULL,'2MASX J14175250+2842364',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000166,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,214.4687083,28.71003,0,NULL,60058661771,938416590,14662759,17.8),(118819,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118819,36.97,0.13,247,52561,70,NULL,NULL,'2MASX J14175266+0759324',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000169,NULL,'16.1g',0.39,NULL,NULL,NULL,NULL,NULL,1,214.469583,7.99247,0.017,NULL,58497717012,914026828,14281669,16.1),(118820,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118820,38.26,0.19,450,52562,70,NULL,NULL,'2MASX J14175420+4323168',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00006,NULL,'16.8g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,214.475833,43.38806,0,NULL,59225028878,925391076,14459235,16.8),(118821,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118821,36.12,0.56,168,52563,70,NULL,NULL,'2MASX J14175456-2126503',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000083,NULL,'16.24',0.3,NULL,NULL,NULL,NULL,NULL,1,214.477333333,-21.44739,0.361,NULL,46569449674,727647651,11369494,16.24),(118822,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118822,37.18,0.23,273,52564,70,NULL,NULL,'2MASX J14175467+3016062',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.77',0.24,NULL,NULL,NULL,NULL,NULL,1,214.477667,30.26847,0,NULL,60061870102,938466720,14663542,16.77),(118823,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3ht',NULL,118823,43.16,0.07,2260,52565,70,NULL,'SIFTO','SNLS 05D3ht',0.901,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,214.477917,53.16758,0,NULL,59198018532,924969039,14452641,NULL),(118824,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3ht',NULL,118824,44.04,0.22,3380,52565,70,NULL,'SALT 2','SNLS 05D3ht',0.901,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118825,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3ht',NULL,118825,44.1,0.15,3470,52565,NULL,NULL,'SIFTO','SNLS 05D3ht',0.901,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118826,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3ht',NULL,118826,45.23,0.17,5850,52565,NULL,NULL,'SALT2','SNLS 05D3ht',0.901,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118827,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118827,37.39,0.15,300,52566,70,NULL,NULL,'2MASX J14175502+2631494',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000193,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,214.4792083,26.53053,0,NULL,59999790014,937496718,14648386,16.2),(118828,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118828,37.39,0.15,300,52567,70,NULL,NULL,'2MASX J14175564+2619384',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,214.481833,26.32758,0,NULL,59999825133,937497267,14648394,17.7),(118829,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118829,36.12,0.53,168,52568,70,NULL,NULL,'2MASX J14175574-3452096',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000123,NULL,'13.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,214.482333,-34.86933,0.173,NULL,47009756710,734527448,11476991,13.3),(118830,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118830,36.97,0.13,247,52569,70,NULL,NULL,'2MASX J14175576+0758374',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.0002,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,214.482375,7.97708,0.017,NULL,58497719998,914026874,14281669,16.5),(118831,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118831,36.83,0.12,232,52570,70,NULL,NULL,'2MASX J14175577+0152096',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000069,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,214.4825,1.86944,0.057,NULL,58286490050,910726407,14230100,17),(118832,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118832,36.83,0.12,232,52571,70,NULL,NULL,'SDSS J141756.20+021827.8',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000118,NULL,'16.0g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,214.484167,2.30772,0.049,NULL,58286230511,910722351,14230036,16),(118833,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118833,37.27,0.46,285,52572,70,NULL,NULL,'2MASX J14175654+1730004',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.52',0.15,NULL,NULL,NULL,NULL,NULL,1,214.4857083,17.50028,0,NULL,59486379368,929474677,14523041,18.52),(118834,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118834,37.15,0.46,269,52573,70,NULL,NULL,'2MASX J14175717+0137507',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000071,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,214.488291667,1.63072,0.065,NULL,58286517077,910726829,14230106,17.4),(118835,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118835,38.03,0.46,403,52574,70,NULL,NULL,'2MASX J14175746+4137230',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000178,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,214.489417,41.62319,0,NULL,59223892856,925373325,14458958,17.2),(118836,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay','R',118836,40.71,NULL,1010,52575,65,NULL,'SALT','[AGR2006] J141758.44+522857.6',0.371,'2010arXiv1006.2112L',2010,1,0.09,NULL,'G',0.000011,NULL,'20.5g',0.07,NULL,NULL,NULL,NULL,NULL,1,214.493333,52.48275,0,NULL,59197912107,924967376,14452615,20.5),(118837,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay',NULL,118837,40.94,0.16,1120,52575,74.2,NULL,'SALT 2','[AGR2006] J141758.44+522857.6',0.371,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118838,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay',NULL,118838,41.37,0.05,1370,52575,70,NULL,'SALT','[AGR2006] J141758.44+522857.6',0.371,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118839,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay',NULL,118839,41.49,0.03,1450,52575,70,NULL,NULL,'[AGR2006] J141758.44+522857.6',0.371,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118840,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay',NULL,118840,41.5,0.13,1460,52575,70,NULL,'SALT','[AGR2006] J141758.44+522857.6',0.371,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118841,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay',NULL,118841,41.59,0.14,1520,52575,70,NULL,'SALT 2','[AGR2006] J141758.44+522857.6',0.371,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118842,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay',NULL,118842,41.63,0.15,1550,52575,NULL,NULL,'SIFTO','[AGR2006] J141758.44+522857.6',0.371,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118843,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay',NULL,118843,41.66,0.14,1570,52575,65,NULL,'SALT2','[AGR2006] J141758.44+522857.6',0.371,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118844,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay',NULL,118844,41.68,0.1,1580,52575,65,NULL,'SALT','[AGR2006] J141758.44+522857.6',0.371,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118845,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay',NULL,118845,41.75,0.03,1640,52575,65,NULL,'SALT','[AGR2006] J141758.44+522857.6',0.371,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118846,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay',NULL,118846,41.8,0.21,1670,52575,65,NULL,'MLCS2k2','[AGR2006] J141758.44+522857.6',0.371,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118847,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay',NULL,118847,41.8,0.22,1670,52575,65,NULL,'MLCS31','[AGR2006] J141758.44+522857.6',0.371,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118848,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay',NULL,118848,41.81,0.19,1680,52575,65,NULL,'SALT2','[AGR2006] J141758.44+522857.6',0.371,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118849,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay',NULL,118849,41.84,0.19,1710,52575,65,NULL,'MLCS17','[AGR2006] J141758.44+522857.6',0.371,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118850,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay',NULL,118850,41.89,0.19,1740,52575,65,NULL,'MLCS2k2','[AGR2006] J141758.44+522857.6',0.371,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118851,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay',NULL,118851,42.33,0.17,2140,52575,NULL,NULL,'SALT2','[AGR2006] J141758.44+522857.6',0.371,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118852,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118852,37.7,0.46,347,52576,70,NULL,NULL,'SDSS J141758.43+035516.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000083,NULL,'18.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,214.4934583,3.92114,0.041,NULL,58475297440,913676522,14276195,18.6),(118853,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118853,37.65,0.17,339,52577,70,NULL,NULL,'2MASX J14175939+5624560',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,214.497208333,56.41556,0,NULL,57254405543,894600086,13978126,17.5),(118854,'AGN time lag','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118854,34.83,0.03,92.5,52578,NULL,NULL,NULL,'NGC 5548',NULL,'2014ApJ...784L..11Y',2014,1,1.4,NULL,'G',0.000023,NULL,'13.3',1.3,'(R\')SA(s)0/a   Sy1.5','Group member, radial-velocity confirmed',NULL,'radio jet','Sy 1.5',1,214.4980417,25.13678,0,NULL,60000427142,937506674,14648541,13.3),(118855,'AGN time lag','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118855,37.66,0.36,341,52578,44,NULL,NULL,'NGC 5548',NULL,'2007MNRAS.380..669C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118856,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118856,36.79,0.16,228,52579,70,NULL,NULL,'2MASX J14175958+0016027',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000098,NULL,'15.9g',0.41,'E0',NULL,NULL,NULL,NULL,1,214.498333,0.26742,0.073,NULL,58284992381,910703005,14229734,15.9),(118857,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118857,36.67,0.46,216,52580,70,NULL,NULL,'SDSS J141759.65+014225.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000066,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,214.4985417,1.70717,0.065,NULL,58286524918,910726951,14230108,17.9),(118858,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118858,38.29,0.46,456,52581,70,NULL,NULL,'2MASX J14175997+1841392',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,214.499916667,18.69439,0,NULL,59518835042,929981797,14530965,17.5),(118859,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118859,36.92,0.61,243,52582,70,NULL,NULL,'2MASX J14180176-3449486',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,214.507375,-34.83008,0.173,NULL,47009756275,734527441,11476991,15.7),(118860,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118860,35.24,0.68,112,52583,70,NULL,NULL,'2MASX J14180256-1923253',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,214.510791667,-19.39031,0.321,NULL,46563781146,727559080,11368110,14.4),(118861,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118861,38.2,0.33,437,52584,70,NULL,NULL,'2MASX J14180273+1435224',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'19.00',0.09,NULL,NULL,NULL,NULL,NULL,1,214.511333333,14.58953,0,NULL,59477408088,929334501,14520851,19),(118862,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118862,39.18,0.46,687,52585,70,NULL,NULL,'2MASX J14180309+3717290',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000182,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.5129583,37.29139,0,NULL,60032970075,938015157,14656486,17.9),(118863,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118863,36.79,0.16,228,52586,70,NULL,NULL,'2MASX J14180405+0016257',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000074,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,214.517,0.27383,0.073,NULL,58284480721,910695011,14229609,17),(118864,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118864,36.61,0.5,210,52587,70,NULL,NULL,'2MASX J14180446-3823280',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,214.5185,-38.39114,0.257,NULL,46993448766,734272636,11473009,14),(118865,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118865,38.27,0.33,451,52588,70,NULL,NULL,'2MASX J14180445+2442414',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.518625,24.71164,0,NULL,59467767739,929183870,14518497,17.4),(118866,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118866,38.19,0.23,435,52589,70,NULL,NULL,'SDSS J141805.25+052111.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,214.521875,5.35328,0.037,NULL,58473677945,913651217,14275800,18.5),(118867,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118867,37.39,0.15,300,52590,70,NULL,NULL,'2MASX J14180561+2630294',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.89',0.17,NULL,NULL,NULL,NULL,NULL,1,214.523333,26.50825,0,NULL,60054593582,938353024,14661766,17.89),(118868,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118868,37.18,0.23,273,52591,70,NULL,NULL,'2MASX J14180841+3016323',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.535125,30.27561,0,NULL,60061871412,938466740,14663542,NULL),(118869,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118869,37.22,0.46,278,52592,70,NULL,NULL,'2MASX J14180889+4458523',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000142,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.537125,44.98119,0,NULL,59238576532,925602758,14462543,17.3),(118870,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118870,35.09,0.23,104,52593,70,NULL,NULL,'NGC 5546',NULL,'2015arXiv151105856S',2015,1,1.47,NULL,'G',0.000103,NULL,'13.4g',1.17,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,214.538458333,7.56456,0.049,NULL,58494551807,913977371,14280896,13.4),(118871,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118871,35.04,0.45,102,52593,NULL,NULL,'K','NGC 5546',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118872,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118872,35.14,0.4,106,52593,NULL,NULL,'mean','NGC 5546',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118873,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118873,38.11,0.46,418,52594,70,NULL,NULL,'2MASX J14180940+5731071',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,214.53925,57.51858,0,NULL,57305497884,895398404,13990600,17.4),(118874,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118874,37.65,0.17,339,52595,70,NULL,NULL,'2MASX J14180951+5627571',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000143,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,214.53975,56.46578,0,NULL,57254406370,894600099,13978126,18.1),(118875,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118875,36.83,0.12,232,52596,70,NULL,NULL,'2MASX J14180984+0206407',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000118,NULL,'16.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,214.541,2.11111,0.049,NULL,58287133649,910736463,14230257,16.2),(118876,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df',NULL,118876,40.09,0.17,711,52597,NULL,NULL,'SALT2','[AGR2006] J141810.04+521639.8',0.47,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.541833,52.27772,0,NULL,59196002883,924937545,14452149,NULL),(118877,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df',NULL,118877,41.41,0.15,1300,52597,74.2,NULL,'SALT 2','[AGR2006] J141810.04+521639.8',0.47,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118878,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df',NULL,118878,41.95,0.18,1670,52597,65,NULL,'MLCS17','[AGR2006] J141810.04+521639.8',0.47,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118879,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df',NULL,118879,41.99,0.13,1700,52597,70,NULL,'SALT 2','[AGR2006] J141810.04+521639.8',0.47,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118880,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df',NULL,118880,41.99,0.12,1700,52597,65,NULL,'MLCS2k2','[AGR2006] J141810.04+521639.8',0.47,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118881,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df',NULL,118881,42,0.2,1710,52597,65,NULL,'MLCS31','[AGR2006] J141810.04+521639.8',0.47,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118882,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df',NULL,118882,42.03,0.18,1730,52597,65,NULL,'MLCS2k2','[AGR2006] J141810.04+521639.8',0.47,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118883,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df',NULL,118883,42.06,0.14,1750,52597,65,NULL,'SALT2','[AGR2006] J141810.04+521639.8',0.47,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118884,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df',NULL,118884,42.14,0.15,1820,52597,NULL,NULL,'SIFTO','[AGR2006] J141810.04+521639.8',0.47,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118885,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df','R',118885,42.16,NULL,1840,52597,65,NULL,'MLCS17','[AGR2006] J141810.04+521639.8',0.47,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118886,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df',NULL,118886,42.27,0.03,1930,52597,70,NULL,NULL,'[AGR2006] J141810.04+521639.8',0.47,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118887,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df',NULL,118887,42.3,0.15,1960,52597,70,NULL,'SALT','[AGR2006] J141810.04+521639.8',0.47,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118888,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df',NULL,118888,42.37,0.19,2020,52597,65,NULL,'SALT2','[AGR2006] J141810.04+521639.8',0.47,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118889,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df',NULL,118889,42.44,0.12,2100,52597,65,NULL,'SALT','[AGR2006] J141810.04+521639.8',0.47,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118890,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df',NULL,118890,42.54,0.03,2190,52597,65,NULL,'SALT','[AGR2006] J141810.04+521639.8',0.47,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118891,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df',NULL,118891,43.37,0.03,3210,52597,70,NULL,'SALT2','[AGR2006] J141810.04+521639.8',0.47,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118892,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118892,37.54,0.46,322,52598,70,NULL,NULL,'2MASX J14181016+1426394',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,214.542208333,14.44411,0,NULL,59477721728,929339402,14520928,17.2),(118893,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118893,37.12,0.46,266,52599,70,NULL,NULL,'2MASX J14181063+0244497',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000091,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,214.544291667,2.74706,0.073,NULL,58286193642,910721775,14230027,16.4),(118894,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118894,37.76,0.46,357,52600,70,NULL,NULL,'SDSS J141811.59+212937.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,214.548333,21.49386,0.035,NULL,59521552740,930024261,14531629,18.2),(118895,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118895,37.97,0.33,394,52601,70,NULL,NULL,'2MASX J14181179+4400063',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,214.549125,44.00186,0,NULL,59239273521,925613648,14462713,17.8),(118896,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118896,37.04,0.46,256,52602,70,NULL,NULL,'2MASX J14181197+0456467',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000082,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,214.549916667,4.94644,0.033,NULL,58473357521,913646211,14275722,16.7),(118897,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118897,36.79,0.16,228,52603,70,NULL,NULL,'2MASX J14181212+0021317',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000079,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,214.550541667,0.35892,0.085,NULL,58284508088,910695438,14229616,16.8),(118898,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy','R',118898,42.28,NULL,1740,52604,65,NULL,'SALT','[AGR2006] J141812.45+523930.4',0.643,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.551875,52.65844,0,NULL,59198123736,924970683,14452666,NULL),(118899,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy',NULL,118899,42.29,0.17,1750,52604,74.2,NULL,'SALT 2','[AGR2006] J141812.45+523930.4',0.643,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118900,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy',NULL,118900,42.92,0.21,2330,52604,70,NULL,'SALT 2','[AGR2006] J141812.45+523930.4',0.643,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118901,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy',NULL,118901,42.98,0.17,2400,52604,NULL,NULL,'SALT2','[AGR2006] J141812.45+523930.4',0.643,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118902,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy',NULL,118902,43.01,0.06,2430,52604,70,NULL,'SALT','[AGR2006] J141812.45+523930.4',0.643,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118903,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy',NULL,118903,43.01,0.16,2430,52604,70,NULL,'SALT','[AGR2006] J141812.45+523930.4',0.643,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118904,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy',NULL,118904,43.02,0.06,2450,52604,70,NULL,NULL,'[AGR2006] J141812.45+523930.4',0.643,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118905,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy',NULL,118905,43.04,0.15,2470,52604,NULL,NULL,'SIFTO','[AGR2006] J141812.45+523930.4',0.643,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118906,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy',NULL,118906,43.15,0.13,2600,52604,65,NULL,'SALT2','[AGR2006] J141812.45+523930.4',0.643,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118907,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy',NULL,118907,43.16,0.13,2610,52604,65,NULL,'SALT','[AGR2006] J141812.45+523930.4',0.643,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118908,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy',NULL,118908,43.16,0.2,2610,52604,65,NULL,'MLCS2k2','[AGR2006] J141812.45+523930.4',0.643,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118909,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy',NULL,118909,43.22,0.19,2680,52604,65,NULL,'SALT2','[AGR2006] J141812.45+523930.4',0.643,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118910,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy',NULL,118910,43.29,0.05,2770,52604,65,NULL,'SALT','[AGR2006] J141812.45+523930.4',0.643,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118911,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy',NULL,118911,43.33,0.21,2820,52604,65,NULL,'MLCS31','[AGR2006] J141812.45+523930.4',0.643,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118912,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy',NULL,118912,43.34,0.19,2830,52604,65,NULL,'MLCS2k2','[AGR2006] J141812.45+523930.4',0.643,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118913,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy',NULL,118913,43.42,0.19,2940,52604,65,NULL,'MLCS17','[AGR2006] J141812.45+523930.4',0.643,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118914,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118914,36.83,0.12,232,52605,70,NULL,NULL,'2MASX J14181317+0206507',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,'FoF','17.90',0.28,NULL,NULL,NULL,NULL,NULL,1,214.554917,2.11411,0.049,NULL,58287136472,910736507,14230257,17.9),(118915,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118915,37.67,0.46,342,52606,70,NULL,NULL,'SDSS J141813.36+220329.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,214.555666667,22.05828,0.028,NULL,59514980584,929921571,14530024,18.3),(118916,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118916,38.19,0.23,435,52607,70,NULL,NULL,'2MASX J14181371+0527187',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000175,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,214.55725,5.45517,0.037,NULL,58473694331,913651473,14275804,17.9),(118917,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118917,34.72,0.25,87.9,52608,74.4,NULL,NULL,'ESO 511- G 021',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000087,NULL,'14.35',0.6,'E?',NULL,NULL,NULL,NULL,1,214.560167,-27.41517,0.273,NULL,47032463756,734882246,11482535,14.35),(118918,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118918,35.21,0.47,110,52608,70,NULL,NULL,'ESO 511- G 021',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118919,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118919,34.07,0.2,65.2,52609,74.4,NULL,NULL,'IC 0992',NULL,'2013AJ....146...86T',2013,1,1.03,'CGCG misprints name as \'IC 0942\'; corrected in vol III (errata).','G',0.000066,NULL,'14.6g',0.73,'SAB(r)c:',NULL,NULL,NULL,NULL,1,214.562125,0.89108,0.065,NULL,58287537756,910742777,14230355,14.6),(118920,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118920,38.19,0.23,435,52610,70,NULL,NULL,'2MASX J14181578+0526267',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000096,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,214.565917,5.44072,0.037,NULL,58473707762,913651683,14275807,17.6),(118921,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118921,34.07,0.4,65.1,52611,NULL,NULL,'mean','IC 4403',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000033,NULL,'14.82',0.5,'Sa','Isolated galaxy',NULL,NULL,NULL,1,214.5702917,31.65383,0,NULL,60060465228,938444769,14663199,14.82),(118922,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118922,34.27,0.47,71.5,52611,NULL,NULL,'H','IC 4403',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118923,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118923,34.3,0.45,72.4,52611,NULL,NULL,'K','IC 4403',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118924,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118924,34.35,0.46,74.1,52611,NULL,NULL,'J','IC 4403',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118925,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118925,37.7,0.46,347,52612,70,NULL,NULL,'SDSS J141817.40+045736.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000103,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,214.5725,4.96028,0.033,NULL,58473553991,913649281,14275770,18.2),(118926,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118926,37.91,0.46,382,52613,70,NULL,NULL,'2MASX J14181745+5347201',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00018,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,214.572833,53.78897,0,NULL,59194917655,924920588,14451884,16.7),(118927,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118927,36.64,0.46,213,52614,70,NULL,NULL,'2MASX J14182025+0314467',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000104,NULL,'17.1g',0.25,'NLAGN',NULL,NULL,NULL,NULL,1,214.584333333,3.24622,0.073,NULL,58293731455,910839553,14231868,17.1),(118928,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118928,38.18,0.27,432,52615,70,NULL,NULL,'2MASX J14182089+5937150',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,214.58725,59.62081,0.033,NULL,57269408834,894834513,13981789,17.4),(118929,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118929,38,0.46,398,52616,70,NULL,NULL,'2MASX J14182097+4109362',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000177,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.587541667,41.16003,0,NULL,59945750254,936652347,14635192,17.2),(118930,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118930,35.09,0.23,104,52617,70,NULL,NULL,'2MASX J14182164+0741144',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000148,NULL,'15.7g',0.39,NULL,NULL,NULL,NULL,NULL,1,214.5902083,7.68739,0.053,NULL,58497567248,914024488,14281632,15.7),(118931,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118931,37.28,0.46,286,52618,70,NULL,NULL,'2MASX J14182195+0548027',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000164,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,214.591583,5.80075,0.037,NULL,58473004779,913640699,14275635,16.5),(118932,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118932,36.76,0.46,225,52619,70,NULL,NULL,'2MASX J14182196+5527150',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,214.591667,55.45422,0,NULL,57254683090,894604423,13978194,17.3),(118933,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118933,36.21,0.33,175,52620,70,NULL,NULL,'2MASX J14182208+0527297',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000194,NULL,'16.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,214.591875,5.45822,0.037,NULL,58473709467,913651710,14275807,16.2),(118934,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118934,36.83,0.46,233,52621,70,NULL,NULL,'2MASXi J1418222+204402',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.67',0.15,NULL,NULL,NULL,NULL,NULL,1,214.592833333,20.73392,0.016,NULL,59521804707,930028198,14531690,18.67),(118935,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118935,38.18,0.27,432,52622,70,NULL,NULL,'SDSS J141822.46+593648.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000135,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,214.593583333,59.61361,0.033,NULL,57269416132,894834627,13981791,18.6),(118936,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118936,36.17,0.46,171,52623,70,NULL,NULL,'CGCG 046-091',NULL,'2015arXiv151105856S',2015,1,0.58,'Stellar object superposed 10\\\" northeast.','G',0.00016,NULL,'15.4g',0.52,NULL,NULL,NULL,NULL,NULL,1,214.593625,8.0975,0.021,NULL,58497797147,914028080,14281688,15.4),(118937,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118937,38.2,0.33,437,52624,70,NULL,NULL,'2MASX J14182349+1438348',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.14',0.18,NULL,NULL,NULL,NULL,NULL,1,214.597833,14.64292,0,NULL,59477398092,929334345,14520849,18.14),(118938,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118938,37.85,0.33,372,52625,70,NULL,NULL,'SDSS J141823.88+493654.6',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000173,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,214.5995417,49.61519,0.045,NULL,59253584613,925837259,14466207,18.6),(118939,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118939,35.88,0.2,150,52626,74.4,NULL,NULL,'IC 4399',NULL,'2013AJ....146...86T',2013,1,0.95,NULL,'G',0.000033,NULL,'15.3g',0.55,'Sb','Group member',NULL,NULL,NULL,1,214.599833333,26.38589,0,NULL,59999814706,937497104,14648392,15.3),(118940,'IRAS','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118940,33.9,0.8,60.4,52627,75,NULL,'HMCL, I','KUG 1416+257',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000023,NULL,'15.7',0.2,'Spiral',NULL,NULL,NULL,NULL,1,214.605833,25.50111,0,NULL,60000507622,937507931,14648561,15.7),(118941,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118941,33.88,0.4,59.6,52627,75,NULL,'HMCL, I, raw','KUG 1416+257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118942,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118942,33.89,0.4,60.1,52627,75,NULL,'HMCL, I, inv','KUG 1416+257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118943,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118943,34.1,0.4,66,52627,75,NULL,'HMCL, I, cor','KUG 1416+257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118944,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118944,34.46,0.49,78,52627,75,NULL,'IR','KUG 1416+257',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118945,'SBF','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118945,32.58,0.3,32.8,52628,NULL,NULL,NULL,'NGC 5557',NULL,'2001MNRAS.327.1004B',2001,1,1.93,NULL,'G',0.000017,NULL,'12.2g',1.58,'E1','in a radial-velocity based grouping',NULL,NULL,NULL,1,214.607166667,36.49356,0,NULL,60031715188,937995549,14656180,12.2),(118946,'SBF','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118946,32.78,0.3,36.1,52628,NULL,NULL,'Malmquist cor.','NGC 5557',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118947,'SBF','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118947,33.4,0.15,47.9,52628,NULL,NULL,NULL,'NGC 5557',NULL,'2005ApJ...634..239C',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118948,'D-Sigma','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118948,32.65,0.4,33.9,52628,75,NULL,'Edat, raw','NGC 5557',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118949,'D-Sigma','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118949,32.98,0.4,39.5,52628,75,NULL,'Edat, cor','NGC 5557',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118950,'Faber-Jackson','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118950,31.7,0.37,21.9,52628,95,NULL,'Weighted Mean','NGC 5557',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118951,'Faber-Jackson','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118951,31.85,0.63,23.4,52628,95,NULL,'Michard 1979b, c','NGC 5557',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118952,'Faber-Jackson','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118952,32.17,0.46,27.2,52628,95,NULL,'Michard 1979a','NGC 5557',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118953,'Faber-Jackson','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118953,32.98,0.81,39.4,52628,55,NULL,'Visvanathan & Sandage 1979','NGC 5557',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118954,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118954,32.92,0.41,38.3,52628,NULL,NULL,NULL,'NGC 5557',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118955,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118955,33.19,0.41,43.4,52628,NULL,NULL,'Malmquist cor.','NGC 5557',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118956,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118956,33.3,0.45,45.8,52628,NULL,NULL,'K','NGC 5557',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118957,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118957,33.43,0.4,48.6,52628,NULL,NULL,'mean','NGC 5557',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118958,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118958,37.85,0.33,372,52629,70,NULL,NULL,'2MASX J14182596+4938426',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,214.608333,49.64514,0.045,NULL,59253583959,925837249,14466207,17.7),(118959,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk',NULL,118959,40.69,0.14,1010,52630,74.2,NULL,'SALT 2','[AGR2006] J141826.19+523142.7',0.358,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.00001,NULL,'20.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,214.609167,52.52853,0,NULL,59197902583,924967227,14452612,20.4),(118960,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk',NULL,118960,41.04,0.17,1190,52630,NULL,NULL,'SALT2','[AGR2006] J141826.19+523142.7',0.358,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118961,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk','R',118961,41.14,NULL,1250,52630,65,NULL,'MLCS31','[AGR2006] J141826.19+523142.7',0.358,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118962,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk',NULL,118962,41.3,0.11,1340,52630,70,NULL,'SALT 2','[AGR2006] J141826.19+523142.7',0.358,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118963,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk',NULL,118963,41.34,0.15,1360,52630,NULL,NULL,'SIFTO','[AGR2006] J141826.19+523142.7',0.358,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118964,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk',NULL,118964,41.39,0.13,1400,52630,70,NULL,'SALT','[AGR2006] J141826.19+523142.7',0.358,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118965,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk',NULL,118965,41.39,0.2,1400,52630,65,NULL,'MLCS31','[AGR2006] J141826.19+523142.7',0.358,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118966,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk',NULL,118966,41.41,0.18,1410,52630,65,NULL,'MLCS2k2','[AGR2006] J141826.19+523142.7',0.358,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118967,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk',NULL,118967,41.42,0.07,1420,52630,65,NULL,'SALT2','[AGR2006] J141826.19+523142.7',0.358,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118968,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk',NULL,118968,41.47,0.01,1450,52630,70,NULL,NULL,'[AGR2006] J141826.19+523142.7',0.358,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118969,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk',NULL,118969,41.51,0.1,1470,52630,65,NULL,'SALT','[AGR2006] J141826.19+523142.7',0.358,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118970,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk',NULL,118970,41.51,0.09,1480,52630,65,NULL,'MLCS2k2','[AGR2006] J141826.19+523142.7',0.358,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118971,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk',NULL,118971,41.58,0.16,1530,52630,65,NULL,'MLCS17','[AGR2006] J141826.19+523142.7',0.358,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118972,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk',NULL,118972,41.59,0.17,1530,52630,65,NULL,'SALT2','[AGR2006] J141826.19+523142.7',0.358,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118973,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk',NULL,118973,41.74,0.01,1640,52630,65,NULL,'SALT','[AGR2006] J141826.19+523142.7',0.358,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118974,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk',NULL,118974,42.15,0.03,1980,52630,70,NULL,'SALT 2','[AGR2006] J141826.19+523142.7',0.358,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118975,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118975,37.94,0.46,387,52631,70,NULL,NULL,'SDSS J141826.43+253122.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000143,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,214.610167,25.52278,0,NULL,60000506114,937507908,14648561,18.6),(118976,'D-Sigma','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118976,34.55,0.4,81.4,52632,75,NULL,'Edat, raw','ESO 511- G 023',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000017,NULL,'13.79',1,'SAB(s)0-',NULL,NULL,NULL,NULL,1,214.6107083,-27.37883,0.273,NULL,47032461203,734882206,11482534,13.79),(118977,'D-Sigma','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118977,34.89,0.4,95,52632,75,NULL,'Edat, cor','ESO 511- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118978,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118978,34.53,0.25,80.5,52632,74.4,NULL,NULL,'ESO 511- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118979,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118979,34.67,0.45,86.1,52632,NULL,NULL,'K','ESO 511- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118980,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118980,34.96,0.4,98.3,52632,NULL,NULL,'mean','ESO 511- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118981,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118981,30.16,0.43,10.8,52633,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5530',NULL,'2014MNRAS.444..527S',2014,1,4.2,NULL,'G',0.000007,NULL,'11.87',1.9,'SA(rs)c',NULL,NULL,NULL,NULL,1,214.613125,-43.38858,0.397,NULL,46794344040,731161625,11424400,11.87),(118982,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118982,30.32,0.43,11.6,52633,75,NULL,'3.6 micron, color corrected','NGC 5530',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118983,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118983,30.35,0.36,11.7,52633,NULL,NULL,NULL,'NGC 5530',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118984,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118984,30.34,0.39,11.7,52633,73,NULL,'opt','NGC 5530',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118985,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118985,30.45,0.2,12.3,52633,74.4,NULL,NULL,'NGC 5530',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118986,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118986,31.14,0.4,16.9,52633,75,NULL,'B','NGC 5530',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118987,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118987,35.23,0.4,111,52634,NULL,NULL,'mean','NGC 5550',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000163,NULL,'14.05',0.8,'S?','in a radial-velocity based grouping',NULL,NULL,NULL,1,214.616541667,12.88308,0,NULL,58354662230,911791597,14246743,14.05),(118988,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118988,35.4,0.47,120,52634,NULL,NULL,'H','NGC 5550',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118989,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118989,35.45,0.46,123,52634,NULL,NULL,'J','NGC 5550',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118990,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118990,35.49,0.45,125,52634,NULL,NULL,'K','NGC 5550',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118991,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118991,37.15,0.27,269,52635,70,NULL,NULL,'2MASX J14182808+5557200',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000156,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,214.616875,55.95553,0.009,NULL,57255306438,894614163,13978346,17),(118992,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118992,37.42,0.46,304,52636,70,NULL,NULL,'SDSS J141828.24+043945.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000071,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,214.6177083,4.66267,0.029,NULL,58473319005,913645609,14275712,18.5),(118993,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118993,36.83,0.46,232,52637,70,NULL,NULL,'2MASX J14182853+2352032',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,214.618875,23.86767,0,NULL,59467622442,929181600,14518462,17.3),(118994,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118994,36.89,0.76,239,52638,70,NULL,NULL,'2MASX J14182907-2045422',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,214.6212083,-20.76178,0.373,NULL,46569968904,727655764,11369621,15.7),(118995,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118995,37.28,0.46,286,52639,70,NULL,NULL,'2MASX J14182937+1724438',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.42',0.15,NULL,NULL,NULL,NULL,NULL,1,214.6225417,17.41214,0,NULL,59486401009,929475015,14523047,18.42),(118996,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118996,36.85,0.46,235,52640,70,NULL,NULL,'2MASX J14183029+5254107',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000176,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,214.6260417,52.90306,0.005,NULL,59198136705,924970886,14452670,17),(118997,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118997,36.74,0.71,223,52641,70,NULL,NULL,'ESO 579- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000103,NULL,'14.6R',0.5,'Sa',NULL,NULL,NULL,NULL,1,214.626583,-19.039,0.309,NULL,46563895663,727560869,11368138,14.6),(118998,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118998,35.1,0.46,105,52642,70,NULL,NULL,'CGCG 163-026',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000153,NULL,'15.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,214.6282083,29.17008,0,NULL,60058619595,938415931,14662748,15.1),(118999,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118999,37.35,0.46,295,52643,70,NULL,NULL,'2MASX J14183128+1911182',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,214.630417,19.18847,0,NULL,59519047678,929985119,14531017,17.5),(119000,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3gh',NULL,119000,43.02,0.06,2340,52644,70,NULL,'SIFTO','SNLS 06D3gh',0.72,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,214.630917,52.44292,0,NULL,59195818642,924934666,14452104,NULL),(119001,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3gh',NULL,119001,43.15,0.15,2490,52644,NULL,NULL,'SIFTO','SNLS 06D3gh',0.72,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119002,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3gh',NULL,119002,43.25,NULL,2590,52644,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SNLS 06D3gh',0.72,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119003,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3gh',NULL,119003,43.28,0.23,2630,52644,70,NULL,'SALT 2','SNLS 06D3gh',0.72,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119004,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3gh',NULL,119004,43.91,0.17,3520,52644,NULL,NULL,'SALT2','SNLS 06D3gh',0.72,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119005,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119005,37.05,0.46,256,52645,70,NULL,NULL,'2MASX J14183167+2359545',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000207,NULL,'15.9g',0.35,NULL,NULL,NULL,NULL,NULL,1,214.631917,23.99842,0,NULL,59467566201,929180721,14518448,15.9),(119006,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119006,34.18,0.49,68.4,52646,75,NULL,'IR','FGC 1741',NULL,'2011yCatp016004901K',2011,1,1.15,NULL,'G',0.00015,NULL,'16.4',0.1,'Sd',NULL,NULL,NULL,NULL,1,214.639833333,-5.15325,0.113,NULL,43730258235,683285284,10676332,16.4),(119007,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119007,38.18,0.27,432,52647,70,NULL,NULL,'2MASX J14183385+5940559',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000153,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.641166667,59.68222,0.033,NULL,57269392437,894834256,13981785,17.7),(119008,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119008,37.97,0.33,394,52648,70,NULL,NULL,'2MASX J14183413+4402454',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,214.6420417,44.04603,0,NULL,59239300424,925614069,14462719,17.5),(119009,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119009,38.58,0.46,521,52649,70,NULL,NULL,'SDSS J141834.18+441615.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000138,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,214.642458333,44.27089,0,NULL,59239254845,925613356,14462708,18.6),(119010,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119010,37.39,0.15,300,52650,70,NULL,NULL,'2MASX J14183499+2630245',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,214.6457083,26.50686,0,NULL,60054595807,938353059,14661766,18),(119011,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119011,38.13,0.46,423,52651,70,NULL,NULL,'2MASX J14183503-0226266',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000176,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,214.645875,-2.44064,0.141,NULL,43504488348,679757630,10621212,17.3),(119012,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119012,35.77,0.46,142,52652,70,NULL,NULL,'2MASX J14183551+0240516',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000067,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,214.647833333,2.68114,0.065,NULL,58297910189,910904846,14232888,16.8),(119013,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119013,35.12,0.68,106,52653,70,NULL,NULL,'2MASX J14183552-1923091',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.83',NULL,NULL,NULL,NULL,NULL,NULL,1,214.648166667,-19.38586,0.321,NULL,46563764668,727558822,11368106,15.83),(119014,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119014,34.93,0.2,96.8,52654,74.4,NULL,NULL,'UGC 09159',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000033,NULL,'15.28',0.3,'Sbc',NULL,NULL,NULL,NULL,1,214.6482917,14.2785,0,NULL,59477778463,929340288,14520942,15.28),(119015,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119015,37.85,0.46,372,52655,70,NULL,NULL,'2MASX J14183605+6137475',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000146,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.650583,61.62978,0.013,NULL,57762867730,902544808,14102262,17.6),(119016,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119016,37.34,0.46,294,52656,70,NULL,NULL,'2MASX J14183647+2903445',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,214.6520417,29.06231,0,NULL,60058735003,938417734,14662777,17.7),(119017,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119017,38.22,0.46,440,52657,70,NULL,NULL,'2MASX J14183787+5603127',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000171,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,214.6580417,56.05364,0.009,NULL,57254429672,894600463,13978132,17.5),(119018,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119018,37.51,0.46,318,52658,70,NULL,NULL,'2MASX J14183836+1433457',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.01',0.16,NULL,NULL,NULL,NULL,NULL,1,214.659833,14.56256,0,NULL,59478258630,929347791,14521059,18.01),(119019,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119019,37.73,0.46,352,52659,70,NULL,NULL,'2MASX J14183843-0128326',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000138,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,214.66,-1.47569,0.121,NULL,43507069185,679797956,10621843,17.5),(119020,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119020,35.09,0.23,104,52660,70,NULL,NULL,'NGC 5549',NULL,'2015arXiv151105856S',2015,1,1.6,NULL,'G',0.000077,NULL,'13.5g',0.75,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,214.661708333,7.37733,0.049,NULL,58494606289,913978223,14280909,13.5),(119021,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119021,37.65,0.46,339,52661,70,NULL,NULL,'2MASX J14183877+4304054',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000146,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,214.661708333,43.06825,0,NULL,59225588229,925399816,14459372,17.2),(119022,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119022,36.26,0.56,178,52662,70,NULL,NULL,'2MASX J14183922-1951141',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'16.12',NULL,NULL,NULL,NULL,NULL,NULL,1,214.663375,-19.85411,0.345,NULL,46564139065,727564672,11368198,16.12),(119023,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi','R',119023,40.98,NULL,1070,52663,65,NULL,'SNLS 03D3cd, MLCS17','SDSS J141839.84+523644.9',0.461,'2010arXiv1006.2112L',2010,1,0.08,NULL,'G',0.000016,NULL,'20.8g',0.03,NULL,NULL,NULL,NULL,NULL,1,214.6660417,52.6125,0,NULL,59198127312,924970739,14452667,20.8),(119024,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi',NULL,119024,41.37,0.18,1290,52663,74.2,NULL,'SALT 2','SDSS J141839.84+523644.9',0.461,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119025,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi',NULL,119025,41.55,0.06,1400,52663,70,NULL,'SNLS 03D3cd, MLCS17','SDSS J141839.84+523644.9',0.461,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119026,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi',NULL,119026,41.97,0.26,1700,52663,70,NULL,'SNLS 03D3cd, SALT','SDSS J141839.84+523644.9',0.461,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119027,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi',NULL,119027,42.03,0.06,1740,52663,70,NULL,'SNLS 03D3cd','SDSS J141839.84+523644.9',0.461,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119028,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi',NULL,119028,42.03,0.16,1750,52663,70,NULL,'SNLS 03D3cd, SALT 2','SDSS J141839.84+523644.9',0.461,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119029,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi',NULL,119029,42.04,0.15,1750,52663,NULL,NULL,'SNLS 03D3cd, SIFTO','SDSS J141839.84+523644.9',0.461,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119030,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi',NULL,119030,42.05,0.17,1760,52663,65,NULL,'SNLS 03D3cd, MLCS17','SDSS J141839.84+523644.9',0.461,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119031,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi',NULL,119031,42.06,0.15,1770,52663,65,NULL,'SNLS 03D3cd, MLCS2k2','SDSS J141839.84+523644.9',0.461,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119032,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi',NULL,119032,42.09,0.23,1790,52663,65,NULL,'SNLS 03D3cd, SALT2','SDSS J141839.84+523644.9',0.461,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119033,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi',NULL,119033,42.13,0.15,1820,52663,65,NULL,'SNLS 03D3cd, MLCS2k2','SDSS J141839.84+523644.9',0.461,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119034,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi',NULL,119034,42.13,0.17,1820,52663,65,NULL,'SNLS 03D3cd, MLCS31','SDSS J141839.84+523644.9',0.461,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119035,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi',NULL,119035,42.13,0.27,1830,52663,65,NULL,'SNLS 03D3cd, SALT','SDSS J141839.84+523644.9',0.461,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119036,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi',NULL,119036,42.2,0.23,1890,52663,65,NULL,'SNLS 03D3cd, SALT2','SDSS J141839.84+523644.9',0.461,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119037,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi',NULL,119037,42.3,0.05,1970,52663,65,NULL,'SNLS 03D3cd, SALT','SDSS J141839.84+523644.9',0.461,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119038,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi',NULL,119038,44.36,0.17,5090,52663,NULL,NULL,'SNLS 03D3cd, SALT2','SDSS J141839.84+523644.9',0.461,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119039,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','PS1 SN PS11zd','N',119039,38.4,0.11,436,52664,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11zd HOST',0.1004,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119040,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119040,37.48,0.46,314,52665,70,NULL,NULL,'SDSS J141840.19+311308.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,214.667458333,31.21917,0,NULL,60061304943,938457889,14663404,17.5),(119041,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119041,37.65,0.17,339,52666,70,NULL,NULL,'2MASX J14184015+5628107',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000177,NULL,'15.5g',0.63,'E0',NULL,NULL,NULL,NULL,1,214.667458333,56.46956,0,NULL,57254403606,894600056,13978125,15.5),(119042,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119042,37.39,0.15,300,52667,70,NULL,NULL,'2MASX J14184051+2642105',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00018,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,214.668833333,26.70308,0,NULL,60054606088,938353220,14661769,16.6),(119043,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119043,35.13,0.46,106,52668,70,NULL,NULL,'2MASX J14184086+0949084',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000164,NULL,'15.5g',0.52,NULL,NULL,NULL,NULL,NULL,1,214.670375,9.81894,0.035,NULL,58500019461,914062804,14282231,15.5),(119044,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119044,37.08,0.46,261,52669,70,NULL,NULL,'2MASX J14184099+0219516',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000079,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.670625,2.33089,0.053,NULL,58286316721,910723698,14230057,17.2),(119045,'Tully est','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119045,32.96,0.8,39,52670,75,NULL,'B','VV 557',NULL,'1988NBGC.C....0000T',1988,1,1.1,NULL,'G',0.00002,NULL,'14.80',0.8,'S?','Group member of poor cluster',NULL,NULL,NULL,1,214.680625,21.81758,0.036,NULL,59514955061,929921172,14530018,14.8),(119046,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119046,36.87,0.46,236,52671,70,NULL,NULL,'2MASX J14184486+1144484',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.36',0.19,NULL,NULL,NULL,NULL,NULL,1,214.686833,11.74675,0.046,NULL,58489146465,913892913,14279576,17.36),(119047,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3mn',NULL,119047,43.2,0.05,2490,52672,70,NULL,'SIFTO','SNLS 05D3mn HOST',0.76,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',NULL,NULL,'23.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,214.6880417,52.32294,0,NULL,59196013937,924937717,14452151,23),(119048,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3mn',NULL,119048,43.27,0.18,2560,52672,70,NULL,'SALT 2','SNLS 05D3mn HOST',0.76,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119049,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3mn',NULL,119049,43.28,0.15,2570,52672,NULL,NULL,'SIFTO','SNLS 05D3mn HOST',0.76,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119050,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3mn',NULL,119050,43.31,NULL,2600,52672,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SNLS 05D3mn HOST',0.76,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119051,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3mn',NULL,119051,43.69,0.17,3110,52672,NULL,NULL,'SALT2','SNLS 05D3mn HOST',0.76,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119052,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119052,37.15,0.27,269,52673,70,NULL,NULL,'2MASX J14184523+5552277',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000213,NULL,'15.8g',0.48,'BrClG',NULL,NULL,NULL,NULL,1,214.688333,55.87422,0.009,NULL,57255391146,894615486,13978366,15.8),(119053,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3cq',NULL,119053,43.01,0.06,2120,52674,70,NULL,'SALT2','SNLS 05D3cq HOST',0.89,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'a',NULL,NULL,NULL,NULL,1,214.692375,53.13208,0,NULL,59198068095,924969813,14452653,NULL),(119054,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3cq',NULL,119054,43.05,0.17,2160,52674,NULL,NULL,'SALT2','SNLS 05D3cq HOST',0.89,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119055,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3cq',NULL,119055,43.83,0.21,3090,52674,70,NULL,'SALT 2','SNLS 05D3cq HOST',0.89,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119056,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3cq',NULL,119056,43.89,0.15,3170,52674,NULL,NULL,'SIFTO','SNLS 05D3cq HOST',0.89,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119057,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119057,36.94,0.33,245,52675,70,NULL,NULL,'2MASX J14184663-0108146',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00008,NULL,'17.0b',0.25,NULL,NULL,NULL,NULL,NULL,1,214.694375,-1.13733,0.165,NULL,43507482871,679804419,10621944,17),(119058,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119058,36.94,0.33,245,52676,70,NULL,NULL,'2MASX J14184763-0110556',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000072,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,214.6985417,-1.18197,0.165,NULL,43507355170,679802424,10621912,17.4),(119059,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3ed',NULL,119059,41.73,0.17,1580,52677,NULL,NULL,'SALT2','SNLS 06D3ed',0.404,'2010A&A...523A...7G',2010,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,214.699167,52.75656,0,NULL,59198142864,924970982,14452671,NULL),(119060,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3ed',NULL,119060,41.76,0.03,1600,52677,70,NULL,'SALT2','SNLS 06D3ed',0.404,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119061,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3ed',NULL,119061,41.84,0.11,1660,52677,70,NULL,'SALT 2','SNLS 06D3ed',0.404,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119062,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3ed',NULL,119062,41.88,0.15,1700,52677,NULL,NULL,'SIFTO','SNLS 06D3ed',0.404,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119063,'IRAS','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119063,34.26,0.8,71.3,52678,75,NULL,'HMCL, I','UGC 09165',NULL,'1997ApJS..109..333W',1997,1,1.3,'The position in 1992ApJS...79..157F is incorrect.','G',0.000027,NULL,'15.18',0.3,'S?             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,214.699375,24.94042,0.009,NULL,59999664678,937494760,14648355,15.18),(119064,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119064,33.93,0.49,61.1,52678,75,NULL,'IR','UGC 09165',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119065,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119065,34.12,0.4,66.7,52678,75,NULL,'HMCL, I, raw','UGC 09165',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119066,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119066,34.13,0.45,66.9,52678,NULL,NULL,'K','UGC 09165',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119067,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119067,34.17,0.47,68.1,52678,NULL,NULL,'H','UGC 09165',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119068,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119068,34.28,0.4,71.7,52678,75,NULL,'HMCL, I, cor','UGC 09165',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119069,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119069,34.29,0.4,72.2,52678,75,NULL,'HMCL, I, inv','UGC 09165',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119070,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119070,34.41,0.4,76.1,52678,NULL,NULL,'mean','UGC 09165',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119071,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119071,34.42,0.46,76.4,52678,NULL,NULL,'J','UGC 09165',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119072,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119072,35.79,0.39,144,52679,NULL,NULL,'Malmquist cor.','NGC 5555',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.03',0.5,'Sb             HII',NULL,NULL,NULL,NULL,1,214.700333333,-19.13892,0.309,NULL,46563876008,727560562,11368133,15.03),(119073,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119073,35.92,0.37,153,52679,NULL,NULL,NULL,'NGC 5555',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119074,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119074,35.96,0.2,156,52679,74.4,NULL,NULL,'NGC 5555',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119075,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119075,34.58,0.49,82.2,52680,70,NULL,NULL,'2MASX J14184871-2723387',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.4b',NULL,'E',NULL,NULL,NULL,NULL,1,214.702875,-27.39403,0.273,NULL,47034506917,734914170,11483033,16.4),(119076,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119076,35.13,0.25,106,52680,74.4,NULL,NULL,'2MASX J14184871-2723387',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119077,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119077,36.77,0.46,226,52681,70,NULL,NULL,'2MASX J14184873+0808508',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000166,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,214.703208333,8.14747,0.029,NULL,58497558067,914024344,14281630,16.5),(119078,'Tully est','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119078,31.24,0.8,17.7,52682,75,NULL,NULL,'ESO 222- G 001',NULL,'1988NBGC.C....0000T',1988,1,3,NULL,'G',0.000013,NULL,'11.7',1.5,'IBm:',NULL,NULL,NULL,NULL,1,214.704333,-47.73839,0.749,NULL,46835460152,731804064,11434438,11.7),(119079,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119079,36.81,0.46,230,52683,70,NULL,NULL,'2MASX J14184934+2329483',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000177,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,214.70575,23.49669,0,NULL,59467427227,929178550,14518414,17.6),(119080,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119080,37.28,0.46,286,52684,70,NULL,NULL,'2MASX J14184948+2020273',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.07',0.14,NULL,NULL,NULL,NULL,NULL,1,214.706125,20.34094,0.02,NULL,59521685582,930026337,14531661,17.07),(119081,'FP','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,'R',119081,36.01,0.46,159,52685,70,NULL,NULL,'VIII Zw 398',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'16.9b',0.32,NULL,NULL,NULL,NULL,NULL,1,214.709291667,-2.39375,0.141,NULL,43504496915,679757764,10621215,16.9),(119082,'IRAS','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,NULL,119082,35,0.8,99.8,52686,75,NULL,'HMCL, I','UGC 09163',NULL,'1997ApJS..109..333W',1997,1,1.36,NULL,'G',0.00004,NULL,'15.8g',0.26,'Scd:',NULL,NULL,NULL,NULL,1,214.7115,11.28878,0.005,NULL,58489377761,913896527,14279633,15.8),(119083,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,NULL,119083,34.7,0.2,87.1,52686,74.4,NULL,NULL,'UGC 09163',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119084,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,NULL,119084,34.86,0.4,93.7,52686,75,NULL,'HMCL, I, raw','UGC 09163',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119085,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,NULL,119085,34.95,0.4,97.9,52686,75,NULL,'HMCL, I, inv','UGC 09163',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119086,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,NULL,119086,35.04,0.4,102,52686,75,NULL,'HMCL, I, cor','UGC 09163',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119087,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,'R',119087,35.39,0.49,120,52686,75,NULL,'IR','UGC 09163',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119088,'FP','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,NULL,119088,35.08,0.25,104,52687,74.4,NULL,NULL,'ESO 511- G 026',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000097,NULL,'15',0.8,'S0',NULL,NULL,NULL,NULL,1,214.711667,-27.41044,0.273,NULL,47034503665,734914119,11483033,15),(119089,'FP','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,NULL,119089,35.41,0.52,121,52687,70,NULL,NULL,'ESO 511- G 026',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119090,'FP','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,'R',119090,36.21,0.33,175,52688,70,NULL,NULL,'2MASX J14185096+0525546',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000061,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,214.7125417,5.43175,0.037,NULL,58473658810,913650918,14275795,16.9),(119091,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,NULL,119091,35.41,0.54,121,52689,NULL,NULL,'Malmquist cor.','ESO 385- G 007',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.55',0.3,'Sb:',NULL,NULL,NULL,NULL,1,214.716875,-34.36306,0.177,NULL,47009051492,734516429,11476819,15.55),(119092,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,NULL,119092,35.49,0.52,125,52689,NULL,NULL,NULL,'ESO 385- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119093,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,NULL,119093,35.53,0.2,128,52689,74.4,NULL,NULL,'ESO 385- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119094,'FP','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,NULL,119094,34.59,0.25,82.8,52690,74.4,NULL,NULL,'2MASX J14185286-2729517',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00015,NULL,'16.0b',NULL,'Sp',NULL,NULL,NULL,NULL,1,214.7202083,-27.49764,0.273,NULL,47034474955,734913671,11483026,16),(119095,'FP','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,'R',119095,37.82,0.33,367,52691,70,NULL,NULL,'LCRS B141617.4-023441',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000164,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,214.720625,-2.80767,0.101,NULL,43518249331,679972645,10624572,17.5),(119096,'FP','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,'R',119096,37.44,0.46,307,52692,70,NULL,NULL,'2MASX J14185326-0055161',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000086,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,214.721875,-0.92111,0.117,NULL,43507312030,679801750,10621902,16.5),(119097,'FP','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,'R',119097,37.95,0.46,389,52693,70,NULL,NULL,'2MASX J14185335+0919579',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,214.722333,9.33278,0.057,NULL,58499866708,914060417,14282194,17.1),(119098,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,'R',119098,31.34,NULL,18.5,52694,72,NULL,NULL,'SDSS J141853.47+091728.6',NULL,'2014Ap.....57..457K',2014,1,0.26,NULL,'G',0.000022,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,214.722833333,9.29131,0.057,NULL,58499604279,914056316,14282129,17.9),(119099,'FP','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,'R',119099,37.52,0.46,318,52695,70,NULL,NULL,'2MASX J14185377+1844323',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.53',0.14,NULL,NULL,NULL,NULL,NULL,1,214.724,18.74231,0,NULL,59519114493,929986163,14531033,18.53),(119100,'FP','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,'R',119100,39.43,0.46,768,52696,70,NULL,NULL,'SDSS J141854.15+191105.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,214.725667,19.18497,0,NULL,59519055627,929985244,14531019,18.6),(119101,'FP','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,'R',119101,36.42,0.46,192,52697,70,NULL,NULL,'2MASX J14185445+0440137',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000079,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.7269583,4.67036,0.029,NULL,58292711691,910823620,14231619,17.1),(119102,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ny',NULL,119102,42.65,0.22,1870,52698,74.2,NULL,'SALT 2','[HSP2005] J141856.33+521115.06',0.81,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.02,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.734708333,52.18753,0.005,NULL,59196046984,924938234,14452159,NULL),(119103,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ny','R',119103,42.65,NULL,1870,52698,65,NULL,'MLCS17','[HSP2005] J141856.33+521115.06',0.81,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119104,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ny',NULL,119104,43.35,0.24,2590,52698,70,NULL,'SALT 2','[HSP2005] J141856.33+521115.06',0.81,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119105,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ny',NULL,119105,43.43,0.17,2680,52698,NULL,NULL,'SALT2','[HSP2005] J141856.33+521115.06',0.81,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119106,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ny',NULL,119106,43.46,0.26,2720,52698,65,NULL,'MLCS17','[HSP2005] J141856.33+521115.06',0.81,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119107,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ny',NULL,119107,43.47,0.08,2730,52698,70,NULL,'SALT 2','[HSP2005] J141856.33+521115.06',0.81,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119108,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ny',NULL,119108,43.55,0.15,2840,52698,NULL,NULL,'SIFTO','[HSP2005] J141856.33+521115.06',0.81,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119109,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ny',NULL,119109,43.64,0.25,2950,52698,65,NULL,'MLCS2k2','[HSP2005] J141856.33+521115.06',0.81,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119110,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ny',NULL,119110,43.65,0.26,2960,52698,65,NULL,'MLCS31','[HSP2005] J141856.33+521115.06',0.81,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119111,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ny',NULL,119111,43.69,0.3,3020,52698,70,NULL,NULL,'[HSP2005] J141856.33+521115.06',0.81,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119112,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ny',NULL,119112,43.73,0.49,3080,52698,70,NULL,'SALT','[HSP2005] J141856.33+521115.06',0.81,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119113,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ny',NULL,119113,43.93,0.48,3370,52698,65,NULL,'SALT','[HSP2005] J141856.33+521115.06',0.81,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119114,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ny',NULL,119114,43.96,0.22,3420,52698,65,NULL,'SALT','[HSP2005] J141856.33+521115.06',0.81,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119115,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ny',NULL,119115,44,0.46,3480,52698,65,NULL,'SALT2','[HSP2005] J141856.33+521115.06',0.81,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119116,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119116,38.15,0.46,427,52699,70,NULL,NULL,'2MASX J14185759+2853469',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.739875,28.89642,0,NULL,60058750285,938417973,14662780,17.6),(119117,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119117,34.81,0.43,91.8,52700,NULL,NULL,'Malmquist cor.','ESO 511- G 028',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.42',0.2,'S...',NULL,NULL,NULL,NULL,1,214.744375,-27.21633,0.221,NULL,47034636371,734916193,11483065,15.42),(119118,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119118,34.9,0.41,95.4,52700,NULL,NULL,NULL,'ESO 511- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119119,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119119,34.94,0.2,97.3,52700,74.4,NULL,NULL,'ESO 511- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119120,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119120,36.08,0.46,165,52701,70,NULL,NULL,'2MASX J14185924+0600497',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000162,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,214.746791667,6.01389,0.029,NULL,58472820933,913637827,14275591,16.6),(119121,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3mh',NULL,119121,43.1,0.2,2490,52702,70,NULL,'SALT 2','SDSS J141859.88+524004.3',0.67,'2013MNRAS.433.2240G',2013,1,0.11,NULL,'G',NULL,'PHOT','21.6g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,214.7495,52.66789,0,NULL,59198119140,924970611,14452665,21.6),(119122,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3mh',NULL,119122,43.31,0.15,2750,52702,NULL,NULL,'SIFTO','SDSS J141859.88+524004.3',0.67,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119123,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3mh',NULL,119123,43.37,0.06,2820,52702,70,NULL,'SIFTO','SDSS J141859.88+524004.3',0.67,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119124,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3mh',NULL,119124,44.55,0.17,4870,52702,NULL,NULL,'SALT2','SDSS J141859.88+524004.3',0.67,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119125,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119125,37.65,0.17,339,52703,70,NULL,NULL,'2MASX J14190006+5629558',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,214.750541667,56.49886,0,NULL,57256448152,894632002,13978625,17.4),(119126,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3mq',NULL,119126,39.75,0.17,719,52704,NULL,NULL,'SALT2','[NSB2006] J141900.39+522306.8',0.24,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'a',NULL,NULL,NULL,NULL,1,214.751667,52.38522,0,NULL,59196000395,924937506,14452148,NULL),(119127,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3mq',NULL,119127,40.47,0.12,1000,52704,70,NULL,'SALT 2','[NSB2006] J141900.39+522306.8',0.24,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119128,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3mq',NULL,119128,40.49,NULL,1010,52704,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','[NSB2006] J141900.39+522306.8',0.24,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119129,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3mq',NULL,119129,40.48,0.15,1010,52704,NULL,NULL,'SIFTO','[NSB2006] J141900.39+522306.8',0.24,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119130,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3mq',NULL,119130,40.96,0.03,1260,52704,70,NULL,'SALT2','[NSB2006] J141900.39+522306.8',0.24,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119131,'IRAS','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119131,34.3,0.8,72.6,52705,75,NULL,'HMCL, I','CGCG 133-031',NULL,'1997ApJS..109..333W',1997,1,0.82,NULL,'G',0.000027,NULL,'15.8g',0.36,'Sbc',NULL,NULL,NULL,NULL,1,214.755791667,24.94372,0.009,NULL,59999664385,937494756,14648355,15.8),(119132,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119132,34.14,0.4,67.3,52705,75,NULL,'HMCL, I, raw','CGCG 133-031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119133,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119133,34.14,0.4,67.3,52705,75,NULL,'HMCL, I, inv','CGCG 133-031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119134,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119134,34.29,0.4,72.2,52705,75,NULL,'HMCL, I, cor','CGCG 133-031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119135,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119135,34.81,0.25,91.6,52706,74.4,NULL,NULL,'MCG -04-34-008',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000083,NULL,'15.5',0.4,'E',NULL,NULL,NULL,NULL,1,214.758417,-27.38997,0.221,NULL,47034522016,734914406,11483037,15.5),(119136,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119136,37.53,0.46,320,52707,70,NULL,NULL,'2MASX J14190212+4052305',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000169,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,214.7590417,40.87514,0,NULL,59945613587,936650212,14635159,17),(119137,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119137,34.56,0.25,81.7,52708,74.4,NULL,NULL,'2MASX J14190223-2727348',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00015,NULL,'15.9b',NULL,'E',NULL,NULL,NULL,NULL,1,214.759333,-27.45969,0.273,NULL,47034523149,734914424,11483037,15.9),(119138,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119138,37.23,0.46,279,52709,70,NULL,NULL,'2MASX J14190250+3440577',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000193,NULL,'16.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,214.76025,34.68258,0,NULL,60045411057,938209547,14659524,16.1),(119139,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119139,37.82,0.33,367,52710,70,NULL,NULL,'LCRS B141627.6-022909',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,214.762875,-2.71533,0.101,NULL,43518225875,679972279,10624566,17.9),(119140,'IRAS','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119140,33.46,0.8,49.3,52711,75,NULL,'MAT, I','ESO 385- G 008',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'15.38',0.2,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,214.7682917,-34.85153,0.169,NULL,47009659933,734525936,11476967,15.38),(119141,'IRAS','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119141,33.47,0.8,49.5,52711,75,NULL,'HMCL, I','ESO 385- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119142,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119142,33.11,0.4,42,52711,75,NULL,'HMCL, I, raw','ESO 385- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119143,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119143,33.14,0.4,42.4,52711,75,NULL,'HMCL, I, inv','ESO 385- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119144,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119144,33.41,0.4,48,52711,75,NULL,'HMCL, I, cor','ESO 385- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119145,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119145,33.73,0.43,55.6,52711,75,NULL,'3.6 micron, color + selection bias corrected','ESO 385- G 008',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119146,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119146,33.78,0.32,56.9,52711,85,NULL,'I, raw','ESO 385- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119147,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119147,33.78,0.35,56.9,52711,NULL,NULL,NULL,'ESO 385- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119148,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119148,33.78,0.2,57,52711,74.4,NULL,NULL,'ESO 385- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119149,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119149,33.79,0.32,57.3,52711,85,NULL,'I, inv','ESO 385- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119150,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119150,33.82,0.43,58.1,52711,75,NULL,'3.6 micron, color corrected','ESO 385- G 008',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119151,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119151,33.83,0.43,58.2,52711,75,NULL,'MAT, I, raw','ESO 385- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119152,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119152,33.85,0.34,59,52711,NULL,NULL,'Malmquist cor.','ESO 385- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119153,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119153,33.9,0.49,60.4,52711,75,NULL,'IR','ESO 385- G 008',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119154,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119154,33.94,0.43,61.5,52711,75,NULL,'MAT, I, inv','ESO 385- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119155,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119155,33.99,0.43,62.8,52711,75,NULL,'MAT, I, cor','ESO 385- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119156,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119156,34.02,NULL,63.8,52711,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 385- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119157,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119157,34.03,NULL,64,52711,NULL,NULL,'Dipole + Quadrupole','ESO 385- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119158,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119158,34.04,NULL,64.4,52711,NULL,NULL,'Dipole','ESO 385- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119159,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119159,34.17,NULL,68.2,52711,NULL,NULL,NULL,'ESO 385- G 008',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119160,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119160,37.49,0.46,315,52712,70,NULL,NULL,'2MASX J14190484+5302506',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000191,NULL,'16.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,214.7702917,53.04739,0,NULL,59198058689,924969667,14452651,16.3),(119161,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119161,37.16,NULL,270,52713,NULL,NULL,NULL,'CGCG 247-017',NULL,'1996PASJ...48..657S',1996,1,0.45,NULL,'G',0.000097,NULL,'15.7g',0.34,'SBcd',NULL,NULL,NULL,NULL,1,214.7779583,47.75411,0.034,NULL,59247484213,925741940,14464717,15.7),(119162,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119162,39.52,0.17,634,52714,NULL,NULL,'SALT2','[AGR2006] J141907.89+530419.1',0.263,'2010A&A...523A...7G',2010,1,0.06,NULL,'G',0.0005,NULL,'21.1g',0.05,NULL,NULL,NULL,NULL,NULL,1,214.78275,53.07192,0,NULL,59198052275,924969566,14452649,21.1),(119163,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119163,39.9,0.14,756,52714,74.2,NULL,'SALT 2','[AGR2006] J141907.89+530419.1',0.263,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119164,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez','R',119164,40.3,NULL,908,52714,65,NULL,'MLCS31','[AGR2006] J141907.89+530419.1',0.263,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119165,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119165,40.4,0.15,952,52714,NULL,NULL,'SIFTO','[AGR2006] J141907.89+530419.1',0.263,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119166,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119166,40.46,NULL,977,52714,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','[AGR2006] J141907.89+530419.1',0.263,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119167,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119167,40.48,0.11,989,52714,70,NULL,'SALT 2','[AGR2006] J141907.89+530419.1',0.263,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119168,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119168,40.64,0.08,1060,52714,65,NULL,'SALT2','[AGR2006] J141907.89+530419.1',0.263,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119169,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119169,40.64,0.12,1060,52714,70,NULL,'SALT','[AGR2006] J141907.89+530419.1',0.263,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119170,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119170,40.68,0.01,1080,52714,70,NULL,NULL,'[AGR2006] J141907.89+530419.1',0.263,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119171,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119171,40.71,0.09,1100,52714,65,NULL,'MLCS2k2','[AGR2006] J141907.89+530419.1',0.263,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119172,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119172,40.74,0.2,1110,52714,65,NULL,'MLCS31','[AGR2006] J141907.89+530419.1',0.263,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119173,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119173,40.78,0.09,1130,52714,65,NULL,'SALT','[AGR2006] J141907.89+530419.1',0.263,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119174,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119174,40.76,0.17,1130,52714,65,NULL,'MLCS17','[AGR2006] J141907.89+530419.1',0.263,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119175,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119175,40.77,0.18,1130,52714,65,NULL,'MLCS2k2','[AGR2006] J141907.89+530419.1',0.263,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119176,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119176,40.79,0.17,1140,52714,65,NULL,'SALT2','[AGR2006] J141907.89+530419.1',0.263,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119177,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119177,40.95,0.01,1230,52714,65,NULL,'SALT','[AGR2006] J141907.89+530419.1',0.263,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119178,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119178,41.34,0.03,1470,52714,70,NULL,'SALT2','[AGR2006] J141907.89+530419.1',0.263,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119179,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3hh',NULL,119179,43.49,0.06,2820,52715,70,NULL,'SIFTO','SNLS 05D3hh',0.766,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia?',NULL,NULL,NULL,NULL,1,214.7922917,52.95933,0,NULL,59198056307,924969629,14452650,NULL),(119180,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3hh',NULL,119180,43.5,0.23,2840,52715,70,NULL,'SALT 2','SNLS 05D3hh',0.766,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119181,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3hh',NULL,119181,43.57,0.15,2940,52715,NULL,NULL,'SIFTO','SNLS 05D3hh',0.766,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119182,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3hh',NULL,119182,44.44,0.17,4370,52715,NULL,NULL,'SALT2','SNLS 05D3hh',0.766,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119183,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119183,34.34,0.25,73.8,52716,74.4,NULL,NULL,'2MASX J14191109-2726168',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.79625,-27.43797,0.221,NULL,47034521390,734914396,11483037,NULL),(119184,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119184,38.78,0.46,570,52717,70,NULL,NULL,'2MASX J14191127+1709038',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,214.796917,17.15106,0,NULL,59486280853,929473138,14523017,18.2),(119185,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119185,37.92,0.46,384,52718,70,NULL,NULL,'2MASX J14191170+3005198',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.81',0.2,NULL,NULL,NULL,NULL,NULL,1,214.798667,30.08875,0,NULL,60061811707,938465807,14663528,17.81),(119186,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119186,36.78,0.46,227,52719,70,NULL,NULL,'2MASX J14191193+2422300',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,214.799875,24.37506,0,NULL,59467834530,929184914,14518514,17.3),(119187,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119187,36.72,0.27,221,52720,70,NULL,NULL,'2MASX J14191237+2843370',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,214.801541667,28.72697,0,NULL,60058547520,938414805,14662731,16.9),(119188,'IRAS','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119188,34.23,0.8,70,52721,75,NULL,'HMCL, I','NGC 5559',NULL,'1997ApJS..109..333W',1997,1,1.69,NULL,'G',0.000033,NULL,'14.3g',0.46,'SBb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,214.80325,24.79872,0,NULL,59466917932,929170592,14518290,14.3),(119189,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119189,33.96,0.4,62,52721,75,NULL,'HMCL, I, raw','NGC 5559',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119190,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119190,34,0.49,63.2,52721,75,NULL,'IR','NGC 5559',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119191,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119191,34.14,0.4,67.2,52721,75,NULL,'HMCL, I, inv','NGC 5559',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119192,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119192,34.16,0.47,67.8,52721,NULL,NULL,'H','NGC 5559',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119193,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119193,34.16,0.4,67.9,52721,75,NULL,'HMCL, I, cor','NGC 5559',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119194,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119194,34.21,0.45,69.6,52721,NULL,NULL,'K','NGC 5559',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119195,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119195,34.28,0.46,71.8,52721,NULL,NULL,'J','NGC 5559',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119196,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119196,34.38,0.4,75.1,52721,NULL,NULL,'mean','NGC 5559',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119197,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119197,38.03,0.23,404,52722,70,NULL,NULL,'2MASX J14191304+2104164',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.84',0.15,NULL,NULL,NULL,NULL,NULL,1,214.8044583,21.07128,0.015,NULL,59522373232,930037081,14531829,18.84),(119198,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119198,35.61,0.33,132,52723,70,NULL,NULL,'ARK 447',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.00009,NULL,'14.7g',0.65,'S0^-',NULL,NULL,NULL,NULL,1,214.813,35.33889,0,NULL,60044744270,938199129,14659361,14.7),(119199,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119199,37.09,0.46,262,52724,70,NULL,NULL,'2MASX J14191607+1900144',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'16.63',0.19,NULL,NULL,NULL,NULL,NULL,1,214.817083333,19.00406,0,NULL,59519269416,929988584,14531071,16.63),(119200,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119200,35.61,0.33,132,52725,70,NULL,NULL,'2MASXi J1419175+350752',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000159,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,214.822791667,35.13153,0,NULL,60045464908,938210389,14659537,16.3),(119201,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ax',NULL,119201,42.62,0.06,2040,52726,70,NULL,'SALT2','EGSIRAC J141917.71+524115.5',0.643,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',NULL,NULL,'23.6L',NULL,'a',NULL,NULL,NULL,NULL,1,214.823791667,52.68764,0,NULL,59198116457,924970569,14452665,23.6),(119202,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ax',NULL,119202,42.97,0.15,2390,52726,NULL,NULL,'SIFTO','EGSIRAC J141917.71+524115.5',0.643,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119203,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ax',NULL,119203,43,0.22,2430,52726,70,NULL,'SALT 2','EGSIRAC J141917.71+524115.5',0.643,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119204,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ax',NULL,119204,43.88,0.17,3630,52726,NULL,NULL,'SALT2','EGSIRAC J141917.71+524115.5',0.643,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119205,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119205,37.35,0.46,295,52727,70,NULL,NULL,'2MASX J14191781+1932205',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',NULL,NULL,'16.9E',NULL,NULL,NULL,NULL,NULL,NULL,1,214.8242917,19.53894,0,NULL,59518746565,929980415,14530943,16.9),(119206,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119206,37.79,0.46,361,52728,70,NULL,NULL,'2MASX J14191802+0600217',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,214.825125,6.00594,0.029,NULL,58472852068,913638313,14275598,17.8),(119207,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119207,36.42,0.27,192,52729,70,NULL,NULL,'2MASX J14192059+5208200',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000166,NULL,'17.0g',NULL,NULL,NULL,NULL,NULL,NULL,1,214.835917,52.13892,0.005,NULL,59195994185,924937409,14452147,17),(119208,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119208,36.4,0.46,190,52730,70,NULL,NULL,'2MASX J14192180+0856224',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,214.840917,8.93947,0.039,NULL,58495787920,913996686,14281198,16.7),(119209,'Ring Diameter','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119209,32.7,0.84,34,52731,NULL,NULL,'Published at H = 100 km/s/Mpc','ESO 511- G 030',NULL,'1981ApJS...45..541P',1981,1,2.5,NULL,'G',0.000013,NULL,'12.7r',1.8,'SA(rs)c pec    Sy1',NULL,NULL,NULL,'Sy 1',1,214.843417,-26.64472,0.301,NULL,47031015574,734859618,11482181,12.7),(119210,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119210,33.96,0.47,61.9,52731,NULL,NULL,'H','ESO 511- G 030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119211,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119211,33.99,0.45,62.8,52731,NULL,NULL,'K','ESO 511- G 030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119212,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119212,34.13,0.46,67,52731,NULL,NULL,'J','ESO 511- G 030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119213,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119213,34.89,0.4,94.9,52731,NULL,NULL,'mean','ESO 511- G 030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119214,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119214,37.16,0.19,270,52732,70,NULL,NULL,'2MASX J14192310+1836064',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'16.39',0.24,NULL,NULL,NULL,NULL,NULL,1,214.8462083,18.60192,0,NULL,59519090287,929985785,14531027,16.39),(119215,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3em',NULL,119215,42.96,0.21,2320,52733,70,NULL,'SALT 2','SNLS 06D3em',0.69,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,214.847583,53.02303,0,NULL,59198061728,924969714,14452651,NULL),(119216,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3em',NULL,119216,43.17,0.15,2540,52733,NULL,NULL,'SIFTO','SNLS 06D3em',0.69,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119217,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3em',NULL,119217,43.2,0.17,2580,52733,NULL,NULL,'SALT2','SNLS 06D3em',0.69,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119218,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3em',NULL,119218,44.05,0.05,3820,52733,70,NULL,'SIFTO','SNLS 06D3em',0.69,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119219,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119219,37.78,0.46,360,52734,70,NULL,NULL,'SDSS J141923.79+051930.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000082,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,214.849125,5.32511,0.033,NULL,58293355157,910833674,14231776,18.5),(119220,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119220,34.76,0.46,89.7,52735,70,NULL,NULL,'CGCG 247-019',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00006,NULL,'15.4g',0.47,'S0',NULL,NULL,NULL,NULL,1,214.854667,45.86425,0,NULL,59229190792,925456106,14460251,15.4),(119221,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3mk',NULL,119221,43.24,0.06,2450,52736,70,NULL,'SALT2','[HSP2005] J141925.83+530949.56',0.813,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.857625,53.16378,0,NULL,59198169170,924971393,14452678,NULL),(119222,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3mk',NULL,119222,43.69,0.17,3010,52736,NULL,NULL,'SALT2','[HSP2005] J141925.83+530949.56',0.813,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119223,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3mk',NULL,119223,43.76,0.21,3110,52736,70,NULL,'SALT 2','[HSP2005] J141925.83+530949.56',0.813,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119224,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3mk',NULL,119224,43.76,0.15,3120,52736,NULL,NULL,'SIFTO','[HSP2005] J141925.83+530949.56',0.813,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119225,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3mk',NULL,119225,43.76,NULL,3120,52736,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','[HSP2005] J141925.83+530949.56',0.813,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119226,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119226,37.47,0.07,312,52737,70,NULL,NULL,'2MASX J14192777+4835590',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,214.865625,48.59969,0.022,NULL,59247937073,925749016,14464828,16.9),(119227,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119227,36.42,0.27,192,52738,70,NULL,NULL,'MCG +09-23-061',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000097,NULL,'15.2g',0.56,'E0',NULL,NULL,NULL,NULL,1,214.868,52.13542,0.005,NULL,59195994461,924937413,14452147,15.2),(119228,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119228,36.63,0.46,212,52739,70,NULL,NULL,'2MASX J14192845+5857254',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000177,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,214.868708333,58.957,0.021,NULL,57302999813,895359372,13989990,16.2),(119229,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119229,37.37,0.46,298,52740,70,NULL,NULL,'2MASX J14192857+3611464',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000151,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,214.869,36.19628,0,NULL,60031732010,937995812,14656184,17.2),(119230,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3jr',NULL,119230,40.6,0.17,961,52741,NULL,NULL,'SALT2','[NSB2006] J141928.76+525153.3',0.37,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.869875,52.86481,0,NULL,59198092935,924970202,14452659,NULL),(119231,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3jr',NULL,119231,41.4,0.11,1390,52741,70,NULL,'SALT 2','[NSB2006] J141928.76+525153.3',0.37,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119232,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3jr',NULL,119232,41.41,0.15,1390,52741,NULL,NULL,'SIFTO','[NSB2006] J141928.76+525153.3',0.37,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119233,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3jr',NULL,119233,42.31,0.03,2120,52741,70,NULL,'SALT2','[NSB2006] J141928.76+525153.3',0.37,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119234,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119234,37.27,0.33,284,52742,70,NULL,NULL,'2MASX J14193027+3234097',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000194,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,214.8760417,32.56942,0,NULL,60041468373,938147943,14658561,16.3),(119235,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119235,34.53,0.46,80.4,52743,70,NULL,NULL,'ESO 511- G 032',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000067,NULL,'14.37',1,'S0?','Pair member (points to parent)',NULL,NULL,NULL,1,214.87675,-27.37622,0.221,NULL,47034529579,734914524,11483039,14.37),(119236,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119236,34.86,0.25,93.8,52743,74.4,NULL,NULL,'ESO 511- G 032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119237,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119237,37.53,0.27,321,52744,70,NULL,NULL,'2MASX J14193076+5622474',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000223,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,214.878166667,56.37992,0,NULL,57254382621,894599728,13978120,17.1),(119238,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119238,36.98,0.46,249,52745,70,NULL,NULL,'2MASX J14193116+0223100',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000102,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,214.879875,2.38619,0.061,NULL,58297758990,910902484,14232851,16.6),(119239,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119239,35.56,0.63,130,52746,70,NULL,NULL,'2MASX J14193136-0409118',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.4b',0.37,NULL,NULL,NULL,NULL,NULL,1,214.880625,-4.15344,0.117,NULL,43510106629,679845416,10622584,16.4),(119240,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119240,37.16,0.19,270,52747,70,NULL,NULL,'2MASX J14193162+1833544',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.32',0.16,NULL,NULL,NULL,NULL,NULL,1,214.881667,18.56506,0,NULL,59519075626,929985556,14531024,18.32),(119241,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119241,37.85,0.21,372,52748,70,NULL,NULL,'2MASX J14193188+0503460',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000102,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,214.882917,5.06294,0.037,NULL,58292894762,910826480,14231663,16.7),(119242,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119242,38.46,0.46,492,52749,70,NULL,NULL,'2MASX J14193206+1515498',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,214.883667,15.26389,0,NULL,59477460045,929335313,14520864,17.9),(119243,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119243,35.88,0.57,150,52750,70,NULL,NULL,'2MASX J14193260-3503103',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000113,NULL,'14.1I',0.3,NULL,NULL,NULL,NULL,NULL,1,214.88575,-35.05286,0.169,NULL,47009634049,734525532,11476961,14.1),(119244,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119244,34.34,0.46,73.9,52751,70,NULL,NULL,'IC 0999',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000063,NULL,'14.86',0.4,'S0?','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,214.886125,17.87531,0,NULL,59486749738,929480464,14523132,14.86),(119245,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119245,37.38,0.46,299,52752,70,NULL,NULL,'2MASX J14193323+1651258',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.72',0.22,NULL,NULL,NULL,NULL,NULL,1,214.888416667,16.85717,0,NULL,59484930383,929452037,14522688,17.72),(119246,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119246,37.53,0.27,321,52753,70,NULL,NULL,'2MASXi J1419333+561724',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000184,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.888875,56.29011,0,NULL,57254573846,894602716,13978167,17.7),(119247,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119247,37.16,0.19,270,52754,70,NULL,NULL,'2MASX J14193344+1834154',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.75',0.21,NULL,NULL,NULL,NULL,NULL,1,214.889375,18.57097,0,NULL,59519089250,929985769,14531027,17.75),(119248,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119248,37.85,0.21,372,52755,70,NULL,NULL,'2MASX J14193355+0507570',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.889791667,5.13267,0.037,NULL,58292885482,910826335,14231661,17.6),(119249,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119249,37.41,0.46,304,52756,70,NULL,NULL,'2MASX J14193376+0243450',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000064,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,214.89075,2.72925,0.065,NULL,58297892040,910904563,14232883,18.1),(119250,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119250,36.62,0.46,211,52757,70,NULL,NULL,'2MASX J14193439+2636584',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.00007,NULL,'15.5g',0.47,NULL,NULL,NULL,NULL,NULL,1,214.8932917,26.61639,0,NULL,60054796728,938356198,14661815,15.5),(119251,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119251,37.16,0.19,270,52758,70,NULL,NULL,'2MASX J14193443+1833054',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,214.893583,18.55139,0,NULL,59519076132,929985564,14531024,17.5),(119252,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ki',NULL,119252,42.83,0.29,1910,52759,74.2,NULL,'SALT 2','[AGR2006] J141934.59+521732.6',0.93,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.894167,52.29239,0.005,NULL,59195936811,924936512,14452133,NULL),(119253,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ki','R',119253,43.33,NULL,2400,52759,65,NULL,'MLCS17','[AGR2006] J141934.59+521732.6',0.93,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119254,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ki',NULL,119254,43.5,0.23,2590,52759,65,NULL,'MLCS2k2','[AGR2006] J141934.59+521732.6',0.93,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119255,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ki',NULL,119255,43.67,0.31,2810,52759,65,NULL,'SALT2','[AGR2006] J141934.59+521732.6',0.93,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119256,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ki',NULL,119256,44.2,0.24,3590,52759,65,NULL,'MLCS17','[AGR2006] J141934.59+521732.6',0.93,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119257,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ki',NULL,119257,44.43,0.16,3990,52759,65,NULL,'MLCS2k2','[AGR2006] J141934.59+521732.6',0.93,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119258,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ki',NULL,119258,44.43,0.43,3990,52759,70,NULL,NULL,'[AGR2006] J141934.59+521732.6',0.93,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119259,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ki',NULL,119259,44.44,0.18,4000,52759,65,NULL,'MLCS31','[AGR2006] J141934.59+521732.6',0.93,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119260,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ki',NULL,119260,44.64,0.69,4390,52759,70,NULL,'SALT','[AGR2006] J141934.59+521732.6',0.93,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119261,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ki',NULL,119261,44.7,0.28,4500,52759,65,NULL,'SALT','[AGR2006] J141934.59+521732.6',0.93,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119262,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ki',NULL,119262,44.76,0.55,4650,52759,65,NULL,'SALT2','[AGR2006] J141934.59+521732.6',0.93,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119263,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ki',NULL,119263,44.88,0.64,4910,52759,65,NULL,'SALT','[AGR2006] J141934.59+521732.6',0.93,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119264,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119264,37.65,0.17,339,52760,70,NULL,NULL,'2MASX J14193577+5630284',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,214.899041667,56.50775,0,NULL,57256502962,894632858,13978638,18.1),(119265,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119265,37.16,0.19,270,52761,70,NULL,NULL,'2MASX J14193612+1835054',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.85',0.21,NULL,NULL,NULL,NULL,NULL,1,214.9005417,18.58486,0,NULL,59519089644,929985775,14531027,17.85),(119266,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119266,35.91,0.46,152,52762,70,NULL,NULL,'CGCG 047-009 NED02',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000186,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,214.9087083,6.13481,0.033,NULL,58502156277,914096191,14282752,16.2),(119267,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119267,37.53,0.46,320,52763,70,NULL,NULL,'2MASX J14193923+2328104',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00018,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,214.913583,23.46972,0,NULL,59513297731,929895277,14529613,16.8),(119268,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3oe','R',119268,42.47,NULL,1780,52764,65,NULL,'MLCS31','[HSP2005] J141939.38+523314.21',0.756,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,'22.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,214.913791667,52.55381,0,NULL,59197995302,924968676,14452635,22.8),(119269,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3oe',NULL,119269,42.89,0.06,2160,52764,70,NULL,'MLCS31','[HSP2005] J141939.38+523314.21',0.756,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119270,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3oe',NULL,119270,43.07,0.17,2340,52764,NULL,NULL,'SALT2','[HSP2005] J141939.38+523314.21',0.756,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119271,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3oe',NULL,119271,43.11,0.19,2380,52764,74.2,NULL,'SALT 2','[HSP2005] J141939.38+523314.21',0.756,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119272,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3oe',NULL,119272,43.45,0.06,2790,52764,70,NULL,NULL,'[HSP2005] J141939.38+523314.21',0.756,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119273,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3oe',NULL,119273,43.54,0.22,2900,52764,65,NULL,'MLCS2k2','[HSP2005] J141939.38+523314.21',0.756,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119274,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3oe',NULL,119274,43.54,0.15,2910,52764,NULL,NULL,'SIFTO','[HSP2005] J141939.38+523314.21',0.756,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119275,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3oe',NULL,119275,43.54,0.23,2910,52764,65,NULL,'MLCS31','[HSP2005] J141939.38+523314.21',0.756,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119276,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3oe',NULL,119276,43.58,0.21,2970,52764,65,NULL,'MLCS17','[HSP2005] J141939.38+523314.21',0.756,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119277,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3oe',NULL,119277,43.67,0.2,3090,52764,70,NULL,'SALT','[HSP2005] J141939.38+523314.21',0.756,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119278,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3oe',NULL,119278,43.72,0.06,3160,52764,65,NULL,'SALT','[HSP2005] J141939.38+523314.21',0.756,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119279,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3oe',NULL,119279,43.79,0.21,3260,52764,70,NULL,'SALT 2','[HSP2005] J141939.38+523314.21',0.756,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119280,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3oe',NULL,119280,43.91,0.17,3440,52764,65,NULL,'SALT','[HSP2005] J141939.38+523314.21',0.756,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119281,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3oe',NULL,119281,44.02,0.21,3620,52764,65,NULL,'SALT2','[HSP2005] J141939.38+523314.21',0.756,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119282,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119282,37.6,0.21,331,52765,70,NULL,NULL,'2MASX J14193956+2527414',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000199,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,214.9147917,25.46153,0,NULL,59999614740,937493980,14648343,16.6),(119283,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119283,37.02,0.46,254,52766,70,NULL,NULL,'SDSS J141939.73+075606.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,214.915541667,7.93514,0.041,NULL,58497678942,914026233,14281659,17.8),(119284,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119284,34.5,0.46,79.3,52767,70,NULL,NULL,'CGCG 104-005',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'15.4',0.2,'E','Isolated galaxy',NULL,NULL,NULL,1,214.916416667,19.94478,0.026,NULL,59522947557,930046055,14531969,15.4),(119285,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119285,38.59,0.46,522,52768,70,NULL,NULL,'SDSS J141940.19+125402.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,214.917458333,12.90058,0,NULL,58351816663,911747135,14246048,18.3),(119286,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119286,35.09,0.23,104,52769,70,NULL,NULL,'2MASX J14194026+0732184',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000167,NULL,'16.0g',0.31,NULL,NULL,NULL,NULL,NULL,1,214.917583,7.53833,0.049,NULL,58494256580,913972759,14280824,16),(119287,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119287,37.27,0.33,284,52770,70,NULL,NULL,'2MASX J14194030+3235442',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,214.918041667,32.59575,0,NULL,60039373136,938115205,14658050,17.7),(119288,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119288,36.31,0.76,183,52771,70,NULL,NULL,'2MASX J14194129-4743532',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,214.9220417,-47.73139,0.749,NULL,46835356340,731802442,11434413,17),(119289,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119289,36.72,0.27,221,52772,70,NULL,NULL,'2MASX J14194153+2848334',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00015,NULL,'16.5g',0.27,'S0',NULL,NULL,NULL,NULL,1,214.922917,28.80925,0,NULL,60058565353,938415083,14662735,16.5),(119290,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119290,37.16,0.19,270,52773,70,NULL,NULL,'2MASX J14194223+1832354',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,214.926,18.54328,0,NULL,59518356366,929974318,14530848,17.6),(119291,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119291,35.31,0.19,115,52774,70,NULL,NULL,'CGCG 075-009',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00016,NULL,'15.1g',0.46,NULL,NULL,NULL,NULL,NULL,1,214.926833333,11.62467,0,NULL,58489247424,913894491,14279601,15.1),(119292,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119292,37.85,0.21,372,52775,70,NULL,NULL,'SDSS J141942.95+050347.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000082,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,214.929,5.06322,0.037,NULL,58292885554,910826336,14231661,17.9),(119293,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119293,36.72,0.27,221,52776,70,NULL,NULL,'MCG +05-34-021',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00014,NULL,'16.38',0.3,'E',NULL,NULL,NULL,NULL,1,214.9305,28.87397,0,NULL,60058552523,938414883,14662732,16.38),(119294,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119294,37.31,0.46,289,52777,70,NULL,NULL,'2MASX J14194349+2724344',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,214.93125,27.40958,0,NULL,60057639368,938400615,14662509,18.1),(119295,'BL Lac Luminosity','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119295,40.01,NULL,1000,52778,NULL,NULL,'Min. z = 0.27','1FGL J1419.7+7731',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.933,77.524,0.065,NULL,57118613186,892478331,13944973,NULL),(119296,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119296,29.78,NULL,9.04,52779,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09169',NULL,'2010Ap&SS.325..163P',2010,1,5.15,NULL,'G',0.00001,NULL,'13.5',0.69,'Sdm','Group member of poor cluster',NULL,NULL,NULL,1,214.935875,9.36236,0.041,NULL,58499178085,914049657,14282025,13.5),(119297,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119297,29.8,NULL,9.13,52779,NULL,NULL,'Dipole + Quadrupole','UGC 09169',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119298,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119298,29.81,NULL,9.16,52779,NULL,NULL,'Dipole','UGC 09169',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119299,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119299,29.9,NULL,9.53,52779,NULL,NULL,NULL,'UGC 09169',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119300,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119300,30.96,0.4,15.6,52779,NULL,NULL,NULL,'UGC 09169',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119301,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119301,31.53,NULL,20.2,52779,72,NULL,NULL,'UGC 09169',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119302,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119302,31.9,0.4,24,52779,75,NULL,'B','UGC 09169',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119303,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fj',NULL,119303,41.33,0.15,1260,52780,74.2,NULL,'SALT 2','SDSS J141945.34+523224.8',0.463,'2010ApJ...716..712A',2010,1,0.09,NULL,'G',0.0003,NULL,'22.9g',0.05,NULL,NULL,NULL,NULL,NULL,1,214.9389583,52.54022,0,NULL,59197987466,924968554,14452633,22.9),(119304,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fj',NULL,119304,42.08,0.17,1780,52780,65,NULL,'SNLS 03D3cc, SALT2','SDSS J141945.34+523224.8',0.463,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119305,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fj',NULL,119305,42.09,0.03,1790,52780,70,NULL,'SNLS 03D3cc','SDSS J141945.34+523224.8',0.463,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119306,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fj',NULL,119306,42.09,0.1,1790,52780,70,NULL,'SNLS 03D3cc, SALT','SDSS J141945.34+523224.8',0.463,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119307,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fj',NULL,119307,42.1,0.15,1800,52780,65,NULL,'SNLS 03D3cc, MLCS2k2','SDSS J141945.34+523224.8',0.463,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119308,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fj',NULL,119308,42.17,0.2,1860,52780,65,NULL,'SNLS 03D3cc, SALT2','SDSS J141945.34+523224.8',0.463,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119309,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fj',NULL,119309,42.2,0.17,1890,52780,65,NULL,'SNLS 03D3cc, MLCS17','SDSS J141945.34+523224.8',0.463,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119310,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fj',NULL,119310,42.25,0.14,1930,52780,65,NULL,'SNLS 03D3cc, MLCS2k2','SDSS J141945.34+523224.8',0.463,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119311,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fj',NULL,119311,42.26,0.16,1940,52780,65,NULL,'SNLS 03D3cc, MLCS31','SDSS J141945.34+523224.8',0.463,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119312,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fj',NULL,119312,42.35,0.15,2010,52780,65,NULL,'SNLS 03D3cc, SALT','SDSS J141945.34+523224.8',0.463,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119313,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119313,37.53,0.27,321,52781,70,NULL,NULL,'2MASX J14194557+5625085',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000193,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,214.94,56.41889,0,NULL,57256462541,894632227,13978628,16.6),(119314,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119314,37.14,0.46,268,52782,70,NULL,NULL,'2MASX J14194567+2943334',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00017,NULL,'17.84',0.2,'E',NULL,NULL,NULL,NULL,1,214.940333,29.72611,0,NULL,60062192830,938471762,14663621,17.84),(119315,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119315,36.42,0.27,192,52783,70,NULL,NULL,'MCG +09-23-062',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000177,NULL,'15.8g',0.42,'E0',NULL,NULL,NULL,NULL,1,214.9405,52.11322,0.005,NULL,59195995421,924937428,14452147,15.8),(119316,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119316,36.38,0.46,189,52784,70,NULL,NULL,'2MASX J14194586+3117402',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000063,NULL,'16.25',0.35,NULL,NULL,NULL,NULL,NULL,1,214.9410417,31.29456,0,NULL,60061334850,938458357,14663411,16.25),(119317,'BL Lac Luminosity','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119317,39.26,NULL,617,52785,NULL,NULL,NULL,'[HB89] 1418+546',0.152561,'2005ApJ...635..173S',2005,1,NULL,'May be associated with 2EG J1430+5356.','QSO',0.000281,NULL,'15.9g',NULL,'Opt.var.       BLLAC',NULL,NULL,'radio jet','BL Lac',1,214.944167,54.38744,0.005,NULL,57252566402,894571350,13977677,15.9),(119318,'Brightest Stars','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119318,28.78,NULL,5.7,52786,NULL,NULL,NULL,'NGC 5585',NULL,'1994BSAO...38....5K',1994,1,5.8,NULL,'G',0.000007,NULL,'11.20',3.7,'SAB(s)d        HII','Possible field galaxy',NULL,NULL,NULL,1,214.950833,56.72906,0,NULL,57249167209,894518237,13976847,11.2),(119319,'Brightest Stars','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119319,29.4,0.9,7.59,52786,NULL,NULL,'3, B, blue stars','NGC 5585',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119320,'Brightest Stars','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119320,29.4,0.9,7.59,52786,NULL,NULL,'3, B, blue stars','NGC 5585',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119321,'Brightest Stars','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119321,29.7,NULL,8.7,52786,NULL,NULL,NULL,'NGC 5585',NULL,'2000A&AS..142..425D',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119322,'Brightest Stars','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119322,29.7,NULL,8.71,52786,NULL,NULL,'Photographic','NGC 5585',NULL,'1980A&A....83..354C',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119323,'HII region diameter','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119323,29.11,0.16,6.64,52786,NULL,NULL,'Method 2','NGC 5585',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119324,'HII region diameter','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119324,29.18,0.09,6.85,52786,NULL,NULL,'Method 1','NGC 5585',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119325,'IRAS','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119325,29.8,0.8,9.12,52786,75,NULL,'A82, H','NGC 5585',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119326,'Magnitude','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119326,28.36,0.16,4.7,52786,NULL,NULL,NULL,'NGC 5585',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119327,'Sosies','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119327,30.11,0.52,10.5,52786,NULL,NULL,NULL,'NGC 5585',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119328,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119328,27.9,0.69,3.8,52786,100,NULL,'mid-IR','NGC 5585',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119329,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119329,29.22,0.4,7,52786,75,NULL,'B','NGC 5585',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119330,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119330,29.23,0.4,7,52786,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5585',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119331,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119331,29.33,NULL,7.35,52786,NULL,NULL,'LEDA [April 2006]','NGC 5585',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119332,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119332,29.47,0.43,7.8,52786,75,NULL,'3.6 micron, color corrected','NGC 5585',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119333,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119333,29.46,0.43,7.8,52786,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5585',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119334,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119334,29.48,0.2,7.87,52786,74.4,NULL,NULL,'NGC 5585',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119335,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119335,29.62,NULL,8.39,52786,NULL,NULL,'IR','NGC 5585',NULL,'1980ApJ...237..655A',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119336,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119336,29.65,0.47,8.52,52786,75,NULL,'A82, H, inv','NGC 5585',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119337,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119337,29.66,0.35,8.55,52786,NULL,NULL,NULL,'NGC 5585',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119338,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119338,29.67,0.39,8.6,52786,73,NULL,'opt','NGC 5585',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119339,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119339,29.75,0.64,8.9,52786,NULL,NULL,NULL,'NGC 5585',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119340,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119340,29.78,0.47,9.05,52786,75,NULL,'A82, H, raw','NGC 5585',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119341,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119341,29.86,0.61,9.39,52786,NULL,NULL,'Malmquist cor.','NGC 5585',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119342,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119342,30.11,0.47,10.5,52786,75,NULL,'A82, H, cor','NGC 5585',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119343,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119343,38.03,0.23,404,52787,70,NULL,NULL,'2MASX J14194828+2050574',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.60',0.16,NULL,NULL,NULL,NULL,NULL,1,214.951083,20.84911,0.024,NULL,59521721827,930026903,14531670,18.6),(119344,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119344,36.94,0.46,244,52788,70,NULL,NULL,'2MASX J14194869+1729314',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.71',0.23,NULL,NULL,NULL,NULL,NULL,1,214.952833,17.49211,0,NULL,59486448605,929475759,14523058,17.71),(119345,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119345,38.15,0.46,426,52789,70,NULL,NULL,'SDSS J141948.84+185750.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,214.9535417,18.96389,0,NULL,59519218518,929987789,14531059,18.1),(119346,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119346,37.4,0.15,302,52790,70,NULL,NULL,'2MASX J14194965+3006252',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.44',0.14,NULL,NULL,NULL,NULL,NULL,1,214.9567917,30.10719,0,NULL,60062333267,938473957,14663655,18.44),(119347,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119347,38.25,0.46,446,52791,70,NULL,NULL,'2MASX J14194992+1952284',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,214.9579583,19.8745,0.026,NULL,59522965563,930046336,14531974,17.3),(119348,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119348,37.19,0.46,274,52792,70,NULL,NULL,'2MASX J14195013+0816582',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000176,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,214.9589583,8.28269,0.041,NULL,58495517904,913992467,14281132,16.7),(119349,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119349,37.29,0.46,288,52793,70,NULL,NULL,'2MASX J14195071+3558296',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000145,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,214.9614583,35.97494,0,NULL,60043001436,938171897,14658935,17.4),(119350,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lp',NULL,119350,42.48,0.17,1580,52794,NULL,NULL,'SALT2','[HSP2005] J141950.92+523011.85',0.983,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.9622083,52.50331,0,NULL,59195942442,924936600,14452134,NULL),(119351,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lp','R',119351,43.33,NULL,2340,52794,65,NULL,'SALT','[HSP2005] J141950.92+523011.85',0.983,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119352,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lp',NULL,119352,43.46,0.44,2480,52794,74.2,NULL,'SALT 2','[HSP2005] J141950.92+523011.85',0.983,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119353,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lp',NULL,119353,43.94,0.5,3100,52794,70,NULL,NULL,'[HSP2005] J141950.92+523011.85',0.983,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119354,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lp',NULL,119354,43.97,0.87,3140,52794,70,NULL,'SALT','[HSP2005] J141950.92+523011.85',0.983,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119355,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lp',NULL,119355,44.03,0.32,3230,52794,70,NULL,'SALT 2','[HSP2005] J141950.92+523011.85',0.983,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119356,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lp',NULL,119356,44.13,0.82,3380,52794,65,NULL,'SALT','[HSP2005] J141950.92+523011.85',0.983,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119357,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lp',NULL,119357,44.17,0.15,3440,52794,NULL,NULL,'SIFTO','[HSP2005] J141950.92+523011.85',0.983,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119358,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lp',NULL,119358,44.21,0.32,3500,52794,65,NULL,'SALT','[HSP2005] J141950.92+523011.85',0.983,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119359,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lp',NULL,119359,44.35,0.14,3740,52794,70,NULL,'SALT2','[HSP2005] J141950.92+523011.85',0.983,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119360,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lp',NULL,119360,44.39,0.42,3810,52794,65,NULL,'SALT2','[HSP2005] J141950.92+523011.85',0.983,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119361,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lp',NULL,119361,44.43,0.29,3880,52794,65,NULL,'MLCS2k2','[HSP2005] J141950.92+523011.85',0.983,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119362,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lp',NULL,119362,44.7,0.16,4400,52794,65,NULL,'MLCS2k2','[HSP2005] J141950.92+523011.85',0.983,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119363,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119363,37.85,0.21,372,52795,70,NULL,NULL,'2MASX J14195143+0503395',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00009,NULL,'16.1g',0.46,'BrClG',NULL,NULL,NULL,NULL,1,214.9642083,5.06111,0.037,NULL,58292868586,910826071,14231657,16.1),(119364,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119364,35.67,0.67,136,52796,70,NULL,NULL,'2MASX J14195259-0912045',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.00',NULL,NULL,NULL,NULL,NULL,NULL,1,214.969167,-9.2015,0.165,NULL,43719404164,683115690,10673682,16),(119365,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3kt',NULL,119365,42.61,0.17,2020,52797,NULL,NULL,'SALT2','DEEP2 12027456',0.647341,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.000032,NULL,'23.7R',NULL,'a',NULL,NULL,NULL,NULL,1,214.9739583,52.74303,0,NULL,59197969943,924968280,14452629,23.7),(119366,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3kt',NULL,119366,42.83,0.15,2240,52797,NULL,NULL,'SIFTO','DEEP2 12027456',0.647341,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119367,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3kt',NULL,119367,42.85,0.17,2250,52797,70,NULL,'SALT 2','DEEP2 12027456',0.647341,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119368,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3kt',NULL,119368,43.47,0.05,3000,52797,70,NULL,'SALT2','DEEP2 12027456',0.647341,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119369,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119369,37.85,0.21,372,52798,70,NULL,NULL,'2MASX J14195464+0458595',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000078,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,214.977667,4.98325,0.029,NULL,58292872584,910826134,14231658,17.2),(119370,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119370,37.05,0.46,257,52799,70,NULL,NULL,'2MASX J14195491+6309366',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000087,NULL,'16.0g',0.44,'E0',NULL,NULL,NULL,NULL,1,214.978667,63.16025,0.041,NULL,57749419406,902334678,14098979,16),(119371,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119371,38.03,0.23,404,52800,70,NULL,NULL,'2MASX J14195496+2051281',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.70',0.16,NULL,NULL,NULL,NULL,NULL,1,214.979,20.85789,0.024,NULL,59521724399,930026943,14531670,18.7),(119372,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119372,38.03,0.23,404,52801,70,NULL,NULL,'2MASX J14195560+2054091',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.35',0.19,'BrClG',NULL,NULL,NULL,NULL,1,214.9815417,20.90256,0.024,NULL,59522194927,930034295,14531785,17.35),(119373,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119373,37.19,0.46,274,52802,70,NULL,NULL,'LCRS B141720.6-021854',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00012,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.983083333,-2.54372,0.137,NULL,43518879159,679982486,10624726,17.8),(119374,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 03D3bl',NULL,119374,41.37,0.15,1380,52803,NULL,NULL,'SIFTO','LSSP J141956.04+530553.5',0.3553,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.9835,53.09819,0,NULL,59198175019,924971484,14452679,NULL),(119375,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 03D3bl',NULL,119375,41.39,NULL,1400,52803,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','LSSP J141956.04+530553.5',0.3553,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119376,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 03D3bl',NULL,119376,41.83,0.17,1710,52803,NULL,NULL,'SALT2','LSSP J141956.04+530553.5',0.3553,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119377,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 03D3bl',NULL,119377,42.92,0.03,2830,52803,70,NULL,'SIFTO','LSSP J141956.04+530553.5',0.3553,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119378,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119378,35.7,0.25,138,52804,74.4,NULL,NULL,'2MASX J14195603-2728185',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00015,NULL,'15.9b',NULL,'E',NULL,NULL,NULL,NULL,1,214.9835417,-27.47175,0.221,NULL,47034490933,734913920,11483030,15.9),(119379,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119379,38.21,0.46,438,52805,70,NULL,NULL,'2MASX J14195626+4508052',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,214.984291667,45.13467,0,NULL,59230439161,925475611,14460556,17.8),(119380,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119380,38.31,0.46,460,52806,70,NULL,NULL,'2MASX J14195678+0122155',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000088,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,214.986583,1.37106,0.065,NULL,58287322578,910739415,14230303,17.5),(119381,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119381,35.57,0.46,130,52807,70,NULL,NULL,'2MASX J14195689+3007022',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.52',0.22,NULL,NULL,NULL,NULL,NULL,1,214.987083,30.11736,0,NULL,60062325766,938473840,14663653,17.52),(119382,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119382,37.65,0.17,339,52808,70,NULL,NULL,'2MASX J14195713+5623285',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.98825,56.39117,0,NULL,57256460848,894632200,13978628,17.3),(119383,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119383,38.08,0.46,413,52809,70,NULL,NULL,'SDSS J141957.43+030404.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000065,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,214.9892917,3.06786,0.049,NULL,58293554172,910836783,14231824,18.3),(119384,'IRAS','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119384,34.97,0.8,98.4,52810,75,NULL,'HMCL, I','CGCG 075-010',NULL,'1997ApJS..109..333W',1997,1,0.98,NULL,'G',0.00007,NULL,'16.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.991416667,11.96208,0,NULL,58485669211,913838581,14278727,16.3),(119385,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119385,35.05,0.49,102,52810,75,NULL,'IR','CGCG 075-010',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119386,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119386,35.07,0.4,103,52810,75,NULL,'HMCL, I, raw','CGCG 075-010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119387,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119387,35.15,0.4,107,52810,75,NULL,'HMCL, I, inv','CGCG 075-010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119388,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119388,35.23,0.4,111,52810,75,NULL,'HMCL, I, cor','CGCG 075-010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119389,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119389,37.84,0.46,369,52811,70,NULL,NULL,'2MASX J14195986-0059254',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.0001,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.999208333,-0.99044,0.149,NULL,43507454691,679803979,10621937,17.1),(119390,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119390,35.32,0.46,116,52812,70,NULL,NULL,'2MASX J14200010+1018122',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00016,NULL,'16.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,215.0002917,10.30342,0,NULL,58488195309,913878051,14279344,16.1),(119391,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119391,37.93,0.46,385,52813,70,NULL,NULL,'2MASX J14200027+3600155',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,215.0010417,36.00444,0,NULL,60042999032,938171859,14658935,18),(119392,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119392,37.4,0.15,302,52814,70,NULL,NULL,'2MASX J14200099+3019552',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,215.004333333,30.33206,0,NULL,60062310263,938473597,14663649,16.9),(119393,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119393,36.71,0.65,220,52815,70,NULL,NULL,'2MASX J14200206-3458403',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,215.008625,-34.97794,0.169,NULL,47009114427,734517412,11476834,14),(119394,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3kp',NULL,119394,42.91,0.06,2060,52816,70,NULL,'SIFTO','SNLS 05D3kp HOST',0.85,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,215.0122917,52.27092,0.005,NULL,59195959655,924936869,14452138,NULL),(119395,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3kp',NULL,119395,43.78,0.19,3080,52816,70,NULL,'SALT 2','SNLS 05D3kp HOST',0.85,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119396,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3kp',NULL,119396,43.79,0.15,3090,52816,NULL,NULL,'SIFTO','SNLS 05D3kp HOST',0.85,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119397,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3kp',NULL,119397,45.47,0.17,6710,52816,NULL,NULL,'SALT2','SNLS 05D3kp HOST',0.85,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119398,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119398,37.15,0.27,269,52817,70,NULL,NULL,'2MASX J14200390+5548354',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,215.016375,55.80981,0.005,NULL,57255376699,894615260,13978363,17.1),(119399,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119399,31.37,0.47,18.8,52818,NULL,NULL,'H','NGC 5560',NULL,'2007A&A...465...71T',2007,1,3.7,NULL,'G',0.00001,NULL,'13.2',0.7,'SB(s)b pec','in an interacting triple',NULL,NULL,NULL,1,215.018708333,3.99247,0.057,NULL,58294199971,910846874,14231982,13.2),(119400,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119400,31.43,0.46,19.3,52818,NULL,NULL,'J','NGC 5560',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119401,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119401,31.44,0.45,19.4,52818,NULL,NULL,'K','NGC 5560',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119402,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119402,31.56,NULL,20.5,52818,72,NULL,NULL,'NGC 5560',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119403,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119403,31.59,0.49,20.8,52818,75,NULL,'IR','NGC 5560',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119404,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119404,31.97,0.4,24.8,52818,NULL,NULL,'mean','NGC 5560',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119405,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119405,36.77,0.46,226,52819,70,NULL,NULL,'2MASX J14200682+6209117',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,215.0287083,62.15333,0.029,NULL,57763019468,902547179,14102299,16.9),(119406,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119406,38.4,0.46,478,52820,70,NULL,NULL,'SDSS J142009.20+214351.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.038375,21.731,0.036,NULL,59514446435,929913225,14529894,17.7),(119407,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119407,37.05,0.46,257,52821,70,NULL,NULL,'2MASX J14200918+2143521',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.97',0.31,NULL,NULL,NULL,NULL,NULL,1,215.043375,21.73564,0.036,NULL,59514446366,929913224,14529894,16.97),(119408,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119408,37.47,0.46,312,52822,70,NULL,NULL,'SDSS J142010.53+184121.9',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.043875,18.68942,0,NULL,59518391193,929974862,14530857,17.1),(119409,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119409,37.82,0.46,366,52823,70,NULL,NULL,'2MASX J14201204+2130151',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.13',0.2,NULL,NULL,NULL,NULL,NULL,1,215.050333,21.50419,0.028,NULL,59522009177,930031393,14531740,18.13),(119410,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119410,37.4,0.15,302,52824,70,NULL,NULL,'2MASX J14201230+3023258',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,215.0512917,30.39061,0,NULL,60062317638,938473713,14663651,17.4),(119411,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119411,35.22,0.46,111,52825,70,NULL,NULL,'NGC 5563',NULL,'2015arXiv151105856S',2015,1,0.97,NULL,'G',0.00017,NULL,'14.8g',0.45,NULL,NULL,NULL,NULL,NULL,1,215.0545417,7.05542,0.045,NULL,58494211107,913972048,14280813,14.8),(119412,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx','R',119412,43.13,NULL,2210,52826,65,NULL,'MLCS17','[HSP2005] J142013.67+521658.60',0.91,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.02,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,215.057,52.28294,0.005,NULL,59195959501,924936867,14452138,NULL),(119413,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx',NULL,119413,43.6,0.27,2750,52826,74.2,NULL,'SALT 2','[HSP2005] J142013.67+521658.60',0.91,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119414,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx',NULL,119414,43.61,0.08,2760,52826,70,NULL,'MLCS17','[HSP2005] J142013.67+521658.60',0.91,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119415,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx',NULL,119415,43.73,0.17,2920,52826,NULL,NULL,'SALT2','[HSP2005] J142013.67+521658.60',0.91,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119416,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx',NULL,119416,44.11,0.23,3480,52826,70,NULL,'SALT 2','[HSP2005] J142013.67+521658.60',0.91,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119417,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx',NULL,119417,44.17,0.19,3570,52826,65,NULL,'MLCS17','[HSP2005] J142013.67+521658.60',0.91,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119418,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx',NULL,119418,44.18,0.15,3590,52826,NULL,NULL,'SIFTO','[HSP2005] J142013.67+521658.60',0.91,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119419,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx',NULL,119419,44.19,0.17,3610,52826,65,NULL,'MLCS2k2','[HSP2005] J142013.67+521658.60',0.91,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119420,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx',NULL,119420,44.21,0.15,3630,52826,65,NULL,'MLCS2k2','[HSP2005] J142013.67+521658.60',0.91,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119421,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx',NULL,119421,44.21,0.17,3630,52826,65,NULL,'MLCS31','[HSP2005] J142013.67+521658.60',0.91,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119422,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx',NULL,119422,44.26,0.35,3720,52826,70,NULL,NULL,'[HSP2005] J142013.67+521658.60',0.91,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119423,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx',NULL,119423,44.41,0.39,3990,52826,70,NULL,'SALT','[HSP2005] J142013.67+521658.60',0.91,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119424,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx',NULL,119424,44.44,0.27,4050,52826,65,NULL,'SALT2','[HSP2005] J142013.67+521658.60',0.91,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119425,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx',NULL,119425,44.53,0.23,4210,52826,65,NULL,'SALT','[HSP2005] J142013.67+521658.60',0.91,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119426,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx',NULL,119426,44.63,0.36,4420,52826,65,NULL,'SALT','[HSP2005] J142013.67+521658.60',0.91,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119427,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx',NULL,119427,44.7,0.47,4560,52826,65,NULL,'SALT2','[HSP2005] J142013.67+521658.60',0.91,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119428,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119428,38.63,0.46,532,52827,70,NULL,NULL,'2MASX J14201374+2112381',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'18.31',0.15,NULL,NULL,NULL,NULL,NULL,1,215.0572917,21.2105,0.028,NULL,59522173606,930033962,14531780,18.31),(119429,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119429,38.82,0.46,581,52828,70,NULL,NULL,'2MASX J14201385+2153371',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.2E',NULL,NULL,NULL,NULL,NULL,NULL,1,215.057667,21.89378,0.036,NULL,59514472175,929913627,14529900,16.2),(119430,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119430,37.91,0.46,381,52829,70,NULL,NULL,'2MASX J14201426+0544455',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.67',0.16,NULL,NULL,NULL,NULL,NULL,1,215.059583,5.74597,0.033,NULL,58292487074,910820110,14231564,18.67),(119431,'D-Sigma','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119431,32.74,0.4,35.3,52830,75,NULL,'Edat, raw','ESO 446- G 049',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'14.03',1,'SA(r)0^+:',NULL,NULL,NULL,NULL,1,215.0602083,-29.74747,0.397,NULL,47043271605,735051118,11485173,14.03),(119432,'D-Sigma','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119432,33.07,0.4,41.2,52830,75,NULL,'Edat, cor','ESO 446- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119433,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119433,33.03,0.51,40.3,52830,70,NULL,NULL,'ESO 446- G 049',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119434,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119434,33.67,0.45,54.3,52830,NULL,NULL,'K','ESO 446- G 049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119435,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119435,33.69,0.4,54.6,52830,NULL,NULL,'mean','ESO 446- G 049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119436,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119436,36.82,0.46,231,52831,70,NULL,NULL,'2MASX J14201586+6019147',NULL,'2015arXiv151105856S',2015,1,0.36,'This galaxy lenses a z = 0.535 object.','G',0.000174,NULL,'16.6g',0.26,'S0',NULL,NULL,NULL,NULL,1,215.066083333,60.32075,0,NULL,57753788688,902402948,14100046,16.6),(119437,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119437,37.86,0.46,373,52832,70,NULL,NULL,'2MASX J14201619+0051205',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000082,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,215.067583333,0.85583,0.057,NULL,58288101386,910751584,14230493,17.3),(119438,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119438,36.36,0.46,187,52833,70,NULL,NULL,'2MASX J14201651+0307595',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00007,NULL,'16.3g',0.36,'S0',NULL,NULL,NULL,NULL,1,215.068791667,3.13319,0.049,NULL,58294404270,910850066,14232032,16.3),(119439,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119439,38.01,0.46,400,52834,70,NULL,NULL,'2MASX J14201682+6248546',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00012,NULL,'16.7g',0.31,'HII',NULL,NULL,NULL,NULL,1,215.0704583,62.81508,0.041,NULL,57761223460,902519116,14101861,16.7),(119440,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119440,37.26,0.46,284,52835,70,NULL,NULL,'SDSS J142017.23-003911.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000066,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,215.071833333,-0.65317,0.137,NULL,43506904306,679795379,10621802,18.4),(119441,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119441,37.47,0.07,312,52836,70,NULL,NULL,'2MASX J14201838+4848032',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,215.076417,48.80097,0.031,NULL,59247851568,925747680,14464807,16.9),(119442,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3fp',NULL,119442,40.58,0.15,1030,52837,NULL,NULL,'SIFTO','SNLS 06D3fp',0.268,'2010A&A...523A...7G',2010,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,215.0775,52.89717,0,NULL,59197966698,924968229,14452628,NULL),(119443,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3fp',NULL,119443,40.61,0.11,1040,52837,70,NULL,'SALT 2','SNLS 06D3fp',0.268,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119444,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3fp',NULL,119444,40.62,NULL,1050,52837,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SNLS 06D3fp',0.268,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119445,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3fp',NULL,119445,40.82,0.17,1150,52837,NULL,NULL,'SALT2','SNLS 06D3fp',0.268,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119446,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3fp',NULL,119446,41.29,0.03,1430,52837,70,NULL,'SIFTO','SNLS 06D3fp',0.268,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119447,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119447,38.62,0.46,529,52838,70,NULL,NULL,'SDSS J142018.91+013102.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000086,NULL,'18.2g',0.17,'NLAGN',NULL,NULL,NULL,NULL,1,215.078833,1.51736,0.061,NULL,58287292869,910738951,14230296,18.2),(119448,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nq',NULL,119448,40.25,0.15,919,52839,NULL,NULL,'SIFTO','[HSP2005] J142019.19+530915.90',0.22,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,215.0799583,53.15442,0,NULL,59198168099,924971376,14452677,NULL),(119449,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nq',NULL,119449,41.07,0.17,1340,52839,NULL,NULL,'SALT2','[HSP2005] J142019.19+530915.90',0.22,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119450,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119450,35.57,0.2,130,52840,74.4,NULL,NULL,'KUG 1417+091',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000098,NULL,'15.9g',0.38,'Spiral',NULL,NULL,NULL,NULL,1,215.08,8.9275,0.038,NULL,58494906769,913982918,14280983,15.9),(119451,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119451,36.1,0.46,166,52841,70,NULL,NULL,'2MASX J14201947+2355229',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,215.081167,23.92306,0,NULL,59513376934,929896514,14529633,17.1),(119452,'Ring Diameter','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119452,31.2,0.76,17,52842,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5566',NULL,'1981ApJS...45..541P',1981,1,6.6,NULL,'G',0.000013,NULL,'11.46',2.2,'SB(r)ab        LINER','in an interacting triple',NULL,NULL,NULL,1,215.082875,3.93375,0.057,NULL,58294148928,910846077,14231969,11.46),(119453,'Ring Diameter','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119453,31.4,0.6,19,52842,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5566',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119454,'Tully est','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119454,32.11,0.8,26.4,52842,75,NULL,'B','NGC 5566',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119455,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119455,31.52,0.38,20.1,52842,NULL,NULL,NULL,'NGC 5566',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119456,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119456,31.69,NULL,21.8,52842,72,NULL,NULL,'NGC 5566',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119457,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119457,31.85,0.3,23.5,52842,55,NULL,'B','NGC 5566',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119458,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119458,37.06,0.46,259,52843,70,NULL,NULL,'2MASX J14202116+3412598',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000195,NULL,'16.0g',0.42,NULL,NULL,NULL,NULL,NULL,1,215.0880417,34.21667,0,NULL,60041824989,938153515,14658648,16),(119459,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119459,37.36,0.46,296,52844,70,NULL,NULL,'2MASX J14202129+0750181',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000175,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,215.088583333,7.83833,0.041,NULL,58497458829,914022794,14281606,17.2),(119460,'IRAS','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119460,35.13,0.8,106,52845,75,NULL,'HMCL, I','CGCG 075-013',NULL,'1997ApJS..109..333W',1997,1,0.83,NULL,'G',0.00007,NULL,'16.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,215.0947917,11.38447,0,NULL,58489334352,913895849,14279622,16.3),(119461,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119461,35.41,0.4,121,52845,75,NULL,'HMCL, I, raw','CGCG 075-013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119462,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119462,35.49,0.2,125,52845,74.4,NULL,NULL,'CGCG 075-013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119463,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119463,35.51,0.4,126,52845,75,NULL,'HMCL, I, inv','CGCG 075-013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119464,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119464,35.57,0.4,130,52845,75,NULL,'HMCL, I, cor','CGCG 075-013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119465,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119465,35.33,0.62,116,52846,70,NULL,NULL,'2MASX J14202327-1707260',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,215.097041667,-17.12386,0.317,NULL,46553129435,727392647,11365510,15.3),(119466,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119466,37.4,0.15,302,52847,70,NULL,NULL,'2MASX J14202359+3011448',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.72',0.34,NULL,NULL,NULL,NULL,NULL,1,215.098417,30.19594,0,NULL,60062366245,938474472,14663663,16.72),(119467,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp','R',119467,42.57,NULL,1790,52848,65,NULL,'MLCS31','[AGR2006] J142023.95+524915.4',0.83,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,215.0997917,52.82094,0,NULL,59197978349,924968411,14452631,NULL),(119468,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119468,42.69,0.06,1880,52848,70,NULL,'MLCS31','[AGR2006] J142023.95+524915.4',0.83,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119469,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119469,43.33,0.21,2530,52848,74.2,NULL,'SALT 2','[AGR2006] J142023.95+524915.4',0.83,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119470,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119470,43.61,0.15,2880,52848,65,NULL,'MLCS31','[AGR2006] J142023.95+524915.4',0.83,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119471,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119471,43.62,0.13,2890,52848,65,NULL,'MLCS2k2','[AGR2006] J142023.95+524915.4',0.83,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119472,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119472,43.66,0.16,2950,52848,65,NULL,'MLCS17','[AGR2006] J142023.95+524915.4',0.83,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119473,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119473,43.87,0.15,3250,52848,NULL,NULL,'SIFTO','[AGR2006] J142023.95+524915.4',0.83,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119474,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119474,43.9,0.09,3290,52848,65,NULL,'MLCS2k2','[AGR2006] J142023.95+524915.4',0.83,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119475,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119475,43.97,NULL,3410,52848,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','[AGR2006] J142023.95+524915.4',0.83,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119476,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119476,44.07,0.21,3550,52848,70,NULL,'SALT 2','[AGR2006] J142023.95+524915.4',0.83,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119477,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119477,44.3,0.18,3960,52848,65,NULL,'SALT2','[AGR2006] J142023.95+524915.4',0.83,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119478,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119478,44.41,0.35,4170,52848,70,NULL,NULL,'[AGR2006] J142023.95+524915.4',0.83,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119479,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119479,44.68,0.24,4720,52848,65,NULL,'SALT','[AGR2006] J142023.95+524915.4',0.83,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119480,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119480,44.69,0.46,4740,52848,70,NULL,'SALT','[AGR2006] J142023.95+524915.4',0.83,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119481,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119481,44.84,0.5,5090,52848,65,NULL,'SALT2','[AGR2006] J142023.95+524915.4',0.83,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119482,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119482,45.01,0.44,5480,52848,65,NULL,'SALT','[AGR2006] J142023.95+524915.4',0.83,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119483,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119483,45.05,0.17,5580,52848,NULL,NULL,'SALT2','[AGR2006] J142023.95+524915.4',0.83,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119484,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119484,36.81,0.46,231,52849,70,NULL,NULL,'2MASX J14202526+5440162',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000188,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,215.105166667,54.67114,0.013,NULL,57256138693,894627167,13978549,16.5),(119485,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119485,37.6,0.21,331,52850,70,NULL,NULL,'2MASX J14202592+2530249',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,215.107833,25.50694,0,NULL,59999648460,937494507,14648351,17.7),(119486,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119486,32.64,0.53,33.8,52851,NULL,NULL,NULL,'NGC 5579',NULL,'2009ApJS..182..474S',2009,1,1.22,NULL,'G',0.00002,NULL,'14.5g',0.93,'SABcd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,215.110333,35.18881,0,NULL,60043166344,938174474,14658976,14.5),(119487,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119487,32.77,0.5,35.7,52851,NULL,NULL,'Malmquist cor.','NGC 5579',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119488,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119488,38.07,0.46,410,52852,70,NULL,NULL,'2MASX J14202896+1213397',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,215.12075,12.22767,0,NULL,58351780845,911746575,14246040,17.1),(119489,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119489,38.15,0.46,428,52853,70,NULL,NULL,'SDSS J142030.05+024620.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,215.12525,2.77231,0.049,NULL,58298594792,910915543,14233055,18.1),(119490,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119490,36.73,0.46,221,52854,70,NULL,NULL,'I Zw 083',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00018,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,215.132416667,51.48208,0,NULL,59195457293,924929020,14452015,16.3),(119491,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119491,37.24,0.46,281,52855,70,NULL,NULL,'2MASX J14203206+0203514',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00008,NULL,'17.0g',0.28,'NLAGN',NULL,NULL,NULL,NULL,1,215.133625,2.06431,0.057,NULL,58298102188,910907846,14232935,17),(119492,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119492,31.2,0.4,17.4,52856,NULL,NULL,NULL,'NGC 5569',NULL,'2009AJ....138..323T',2009,1,1.7,NULL,'G',0.00001,NULL,'14.9g',1.4,'SAB(rs)cd:','in an interacting triple',NULL,NULL,NULL,1,215.1337083,3.98322,0.057,NULL,58296184193,910877878,14232466,14.9),(119493,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119493,36.8,0.46,229,52857,70,NULL,NULL,'2MASX J14203280+0506384',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000085,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,215.136833,5.11064,0.021,NULL,58293445427,910835084,14231798,16.6),(119494,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119494,37.6,0.21,331,52858,70,NULL,NULL,'2MASX J14203287+2520390',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00008,NULL,'15.9g',0.43,NULL,NULL,NULL,NULL,NULL,1,215.137083,25.34411,0,NULL,59999752624,937496134,14648377,15.9),(119495,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119495,35.05,0.5,103,52859,NULL,NULL,'Malmquist cor.','ESO 385- G 011',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.9b',0.8,'Sb',NULL,NULL,NULL,NULL,1,215.13925,-33.34606,0.249,NULL,47005705220,734464144,11476002,14.9),(119496,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119496,35.23,0.46,111,52859,NULL,NULL,NULL,'ESO 385- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119497,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119497,35.27,0.2,113,52859,74.4,NULL,NULL,'ESO 385- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119498,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119498,35.28,0.4,114,52859,NULL,NULL,'mean','ESO 385- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119499,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119499,35.55,0.47,129,52859,NULL,NULL,'H','ESO 385- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119500,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119500,34.8,0.47,91,52860,70,NULL,NULL,'2MASX J14203344-2854292',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.0001,NULL,'14.9b',NULL,'*+E',NULL,NULL,NULL,NULL,1,215.139375,-28.90811,0.309,NULL,47042585469,735040397,11485006,14.9),(119501,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119501,36.49,0.46,199,52861,70,NULL,NULL,'2MASX J14203397+0322114',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000078,NULL,'17.2g',0.22,'E2',NULL,NULL,NULL,NULL,1,215.141625,3.36989,0.037,NULL,58293915262,910842425,14231912,17.2),(119502,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119502,31.03,0.2,16.1,52862,74.4,NULL,NULL,'NGC 5556',NULL,'2013AJ....146...86T',2013,1,4,NULL,'G',0.000007,NULL,'12.43',3.2,'SAB(rs)d','Parent (of companion) galaxy',NULL,NULL,NULL,1,215.1420417,-29.24178,0.309,NULL,47042774052,735043344,11485052,12.43),(119503,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119503,31.1,0.4,16.6,52862,NULL,NULL,NULL,'NGC 5556',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119504,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119504,31.61,0.4,20.9,52862,75,NULL,'B','NGC 5556',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119505,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119505,37.64,0.46,337,52863,70,NULL,NULL,'2MASX J14203409+2049016',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.57',0.16,NULL,NULL,NULL,NULL,NULL,1,215.142166667,20.81717,0.024,NULL,59521708168,930026690,14531667,18.57),(119506,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119506,37.99,0.27,396,52864,70,NULL,NULL,'SDSS J142034.61+430825.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000161,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,215.1442083,43.14028,0,NULL,59224831457,925387991,14459187,18.4),(119507,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119507,37.12,0.46,266,52865,70,NULL,NULL,'2MASX J14203519-0124486',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000168,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,215.146541667,-1.41344,0.125,NULL,43506694843,679792106,10621751,16.6),(119508,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119508,37.6,0.21,331,52866,70,NULL,NULL,'2MASX J14203525+2509201',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000185,NULL,'17.69',0.23,NULL,NULL,NULL,NULL,NULL,1,215.147,25.15556,0,NULL,59999766771,937496355,14648380,17.69),(119509,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119509,37.82,0.46,367,52867,70,NULL,NULL,'2MASX J14203565+1456517',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,215.148667,14.94758,0,NULL,59478226713,929347292,14521051,17.9),(119510,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119510,37.04,0.58,256,52868,70,NULL,NULL,'2MASX J14203601-1918296',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00009,NULL,'16.20',NULL,NULL,NULL,NULL,NULL,NULL,1,215.150333333,-19.30825,0.321,NULL,46563660797,727557199,11368081,16.2),(119511,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119511,37.23,0.33,280,52869,70,NULL,NULL,'2MASX J14203749+4709384',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000191,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,215.156125,47.16078,0.061,NULL,59246939576,925733430,14464584,16.4),(119512,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119512,38.04,0.19,405,52870,70,NULL,NULL,'SDSS J142038.29+402445.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000149,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,215.159583,40.41258,0,NULL,59946008094,936656376,14635255,18.7),(119513,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119513,37.88,0.46,377,52871,70,NULL,NULL,'2MASX J14203876+5111451',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,215.161667,51.196,0,NULL,59195408533,924928258,14452004,17.5),(119514,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119514,37.4,0.15,302,52872,70,NULL,NULL,'2MASX J14203974+3037089',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.38',0.16,NULL,NULL,NULL,NULL,NULL,1,215.165583,30.61922,0,NULL,60061007006,938453234,14663331,18.38),(119515,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119515,38.04,0.19,405,52873,70,NULL,NULL,'2MASX J14203971+4025468',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,215.165583,40.42975,0,NULL,59946008228,936656378,14635255,17.8),(119516,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119516,37.47,0.07,312,52874,70,NULL,NULL,'2MASX J14203980+4815111',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,215.16575,48.25308,0,NULL,59247812715,925747073,14464798,17.4),(119517,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119517,37.4,0.15,302,52875,70,NULL,NULL,'2MASX J14204147+3024169',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,215.1729583,30.40461,0,NULL,60061457300,938460270,14663441,17.8),(119518,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119518,37.3,0.46,288,52876,70,NULL,NULL,'2MASX J14204159+3811528',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,215.17325,38.19803,0,NULL,60062704079,938479751,14663746,16.9),(119519,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119519,37.76,0.46,357,52877,70,NULL,NULL,'2MASX J14204177+0549294',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,215.174083,5.82486,0.033,NULL,58300855342,910950864,14233607,17.2),(119520,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119520,34.91,0.49,96,52878,75,NULL,'IR','ESO 511- G 033',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.000037,NULL,'14.93',0.3,'SAb? sp        HII',NULL,NULL,NULL,NULL,1,215.174666667,-27.38542,0.245,NULL,47034774958,734918358,11483099,14.93),(119521,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119521,34.92,0.47,96.4,52878,NULL,NULL,'H','ESO 511- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119522,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119522,34.96,0.45,98.3,52878,NULL,NULL,'K','ESO 511- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119523,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119523,35.18,0.46,109,52878,NULL,NULL,'J','ESO 511- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119524,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119524,35.32,0.4,116,52878,NULL,NULL,'mean','ESO 511- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119525,'SBF','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119525,32.24,0.14,28.1,52879,74.4,NULL,NULL,'NGC 5582',NULL,'2013AJ....146...86T',2013,1,2.8,NULL,'G',0.000017,NULL,'12.48',1.7,'E','Field galaxy',NULL,NULL,NULL,1,215.179667,39.69358,0,NULL,60063296142,938489002,14663890,12.48),(119526,'SBF','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119526,32.27,0.23,28.4,52879,NULL,NULL,'I','NGC 5582',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119527,'SBF','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119527,32.27,0.23,28.4,52879,NULL,NULL,NULL,'NGC 5582',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119528,'SBF','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119528,32.42,0.23,30.5,52879,NULL,NULL,'Malmquist cor.','NGC 5582',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119529,'D-Sigma','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119529,32.35,0.4,29.5,52879,75,NULL,'Edat, raw','NGC 5582',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119530,'D-Sigma','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119530,32.68,0.4,34.4,52879,75,NULL,'Edat, cor','NGC 5582',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119531,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119531,32.28,0.41,28.6,52879,NULL,NULL,NULL,'NGC 5582',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119532,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119532,32.65,0.41,33.9,52879,NULL,NULL,'Malmquist cor.','NGC 5582',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119533,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119533,32.13,0.4,26.6,52879,NULL,NULL,'mean','NGC 5582',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119534,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119534,32.36,0.45,29.6,52879,NULL,NULL,'K','NGC 5582',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119535,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3cb',NULL,119535,44.9,0.17,4680,52880,NULL,NULL,'SALT2','SNLS 06D3cb HOST',1.037,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',NULL,'PHOT','23.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,215.181667,52.19081,0,NULL,59195950087,924936720,14452136,23.9),(119536,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119536,35.52,0.66,127,52881,70,NULL,NULL,'2MASX J14204359-4800051',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,215.181667,-48.00142,0.797,NULL,46837335269,731833363,11434896,16.9),(119537,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119537,37.79,0.46,362,52882,70,NULL,NULL,'2MASX J14204371+0533514',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000177,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,215.182333,5.56436,0.033,NULL,58292658795,910822793,14231606,16.7),(119538,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119538,35.91,0.46,152,52883,70,NULL,NULL,'CGCG 075-016',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000187,NULL,'15.4g',0.47,NULL,NULL,NULL,NULL,NULL,1,215.1837083,8.984,0.031,NULL,58495046465,913985101,14281017,15.4);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (119539,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119539,32,NULL,25.1,52884,72,NULL,NULL,'SDSS J142044.53+083735.8',NULL,'2014Ap.....57..457K',2014,1,0.76,NULL,'G',0.000039,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,215.1855417,8.62664,0.041,NULL,58495693157,913995205,14281175,16.5),(119540,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119540,36.9,0.46,240,52885,70,NULL,NULL,'2MASX J14204528+2258486',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,215.188833,22.98025,0.047,NULL,59516884556,929951321,14530489,17.4),(119541,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119541,36.65,0.46,214,52886,70,NULL,NULL,'2MASX J14204569+5841562',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000175,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,215.190375,58.69894,0.005,NULL,57303583231,895368487,13990132,16.4),(119542,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119542,39.11,0.46,663,52887,70,NULL,NULL,'LCRS B141810.3-023743',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000139,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,215.191375,-2.85692,0.137,NULL,43518976040,679984000,10624750,18.3),(119543,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119543,37.48,0.46,313,52888,70,NULL,NULL,'2MASX J14204595+2656141',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.86',0.24,NULL,NULL,NULL,NULL,NULL,1,215.191625,26.93719,0,NULL,60057583492,938399742,14662495,17.86),(119544,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119544,33.24,0.49,44.5,52889,75,NULL,'IR','UGC 09182',NULL,'2011yCatp016004901K',2011,1,2.02,'HOLM 633B is a star.','G',0.000022,NULL,'14.3g',0.47,'Sd','Isolated galaxy',NULL,NULL,NULL,1,215.192167,21.93575,0.014,NULL,59514544773,929914762,14529918,14.3),(119545,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119545,33.27,0.2,45.1,52889,74.4,NULL,NULL,'UGC 09182',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119546,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119546,33.45,0.47,48.9,52889,NULL,NULL,NULL,'UGC 09182',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119547,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119547,33.69,0.42,54.6,52889,NULL,NULL,'Malmquist cor.','UGC 09182',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119548,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119548,34.04,0.47,64.4,52889,NULL,NULL,'H','UGC 09182',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119549,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119549,34.23,0.4,70,52889,NULL,NULL,'mean','UGC 09182',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119550,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119550,34.29,0.46,72.2,52889,NULL,NULL,'J','UGC 09182',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119551,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119551,34.34,0.45,73.9,52889,NULL,NULL,'K','UGC 09182',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119552,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119552,37.47,0.07,312,52890,70,NULL,NULL,'SDSS J142046.48+484429.3',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,215.1937083,48.74147,0.028,NULL,59247870520,925747976,14464812,17.6),(119553,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119553,36.05,0.49,162,52891,70,NULL,NULL,'2MASX J14204764-1947456',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'15.66',NULL,NULL,NULL,NULL,NULL,NULL,1,215.198667,-19.79592,0.329,NULL,46571944000,727686625,11370103,15.66),(119554,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119554,38.44,0.46,488,52892,70,NULL,NULL,'SDSS J142049.58+511026.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,215.206667,51.17408,0,NULL,59195293874,924926466,14451976,18.4),(119555,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119555,37.47,0.07,312,52893,70,NULL,NULL,'2MASX J14204999+4823042',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,215.2082083,48.3845,0,NULL,59247785285,925746645,14464791,17.3),(119556,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3dh',NULL,119556,42.98,0.23,2190,52894,70,NULL,'SALT 2','SNLS 05D3dh',0.8,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia?',NULL,NULL,NULL,NULL,1,215.21,52.66272,0,NULL,59197954014,924968031,14452625,NULL),(119557,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3dh',NULL,119557,43.27,0.15,2500,52894,NULL,NULL,'SIFTO','SNLS 05D3dh',0.8,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119558,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3dh',NULL,119558,43.42,0.17,2690,52894,NULL,NULL,'SALT2','SNLS 05D3dh',0.8,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119559,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3dh',NULL,119559,43.65,0.06,2980,52894,70,NULL,'SIFTO','SNLS 05D3dh',0.8,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119560,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ha',NULL,119560,43.16,0.22,2380,52895,70,NULL,'SALT 2','SNLS 05D3ha',0.805,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,215.210125,52.83403,0,NULL,59198250425,924972662,14452697,NULL),(119561,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ha',NULL,119561,43.29,0.17,2520,52895,NULL,NULL,'SALT2','SNLS 05D3ha',0.805,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119562,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ha',NULL,119562,43.3,0.15,2540,52895,NULL,NULL,'SIFTO','SNLS 05D3ha',0.805,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119563,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ha',NULL,119563,43.92,0.07,3370,52895,70,NULL,'SALT2','SNLS 05D3ha',0.805,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119564,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119564,37.4,0.46,302,52896,70,NULL,NULL,'2MASX J14205119+6254495',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000145,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,215.21325,62.91364,0.041,NULL,57761258032,902519656,14101869,17.4),(119565,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119565,38.04,0.19,405,52897,70,NULL,NULL,'2MASX J14205198+4021439',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000193,NULL,'16.0g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,215.216625,40.36214,0,NULL,59945994479,936656163,14635252,16),(119566,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119566,37.47,0.07,312,52898,70,NULL,NULL,'2MASX J14205223+4849092',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000182,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,215.217458333,48.81928,0.031,NULL,59247849701,925747651,14464807,16.9),(119567,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119567,37.03,0.71,254,52899,70,NULL,NULL,'2MASX J14205248-4535086',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,215.21875,-45.58581,0.305,NULL,46803445024,731303828,11426622,17.3),(119568,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119568,35.81,0.2,145,52900,74.4,NULL,NULL,'UGC 09185',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000033,NULL,'15.20',0.3,'S?',NULL,NULL,NULL,NULL,1,215.2222917,15.00075,0,NULL,59478213674,929347088,14521048,15.2),(119569,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp','R',119569,40.99,NULL,1090,52901,65,NULL,'SNLS 03D3aw, MLCS17','LSSP J142053.55+523620.4',0.449,'2010arXiv1006.2112L',2010,1,0.06,NULL,'G',0.001,NULL,'21.7g',0.03,NULL,NULL,NULL,NULL,NULL,1,215.22275,52.60561,0,NULL,59197963923,924968186,14452627,21.7),(119570,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp',NULL,119570,41.29,0.16,1250,52901,74.2,NULL,'SALT 2','LSSP J142053.55+523620.4',0.449,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119571,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp',NULL,119571,41.6,0.05,1450,52901,70,NULL,'SNLS 03D3aw, MLCS17','LSSP J142053.55+523620.4',0.449,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119572,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp',NULL,119572,41.87,0.03,1630,52901,70,NULL,'SNLS 03D3aw','LSSP J142053.55+523620.4',0.449,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119573,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp',NULL,119573,41.9,0.15,1660,52901,70,NULL,'SNLS 03D3aw, SALT','LSSP J142053.55+523620.4',0.449,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119574,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp',NULL,119574,41.97,0.15,1710,52901,65,NULL,'SNLS 03D3aw, SALT2','LSSP J142053.55+523620.4',0.449,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119575,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp',NULL,119575,42.06,0.21,1780,52901,65,NULL,'SNLS 03D3aw, MLCS17','LSSP J142053.55+523620.4',0.449,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119576,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp',NULL,119576,42.07,0.16,1790,52901,70,NULL,'SNLS 03D3aw, SALT 2','LSSP J142053.55+523620.4',0.449,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119577,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp',NULL,119577,42.07,0.2,1790,52901,65,NULL,'SNLS 03D3aw, MLCS2k2','LSSP J142053.55+523620.4',0.449,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119578,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp',NULL,119578,42.07,0.22,1790,52901,65,NULL,'SNLS 03D3aw, MLCS2k2','LSSP J142053.55+523620.4',0.449,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119579,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp',NULL,119579,42.07,0.23,1790,52901,65,NULL,'SNLS 03D3aw, MLCS31','LSSP J142053.55+523620.4',0.449,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119580,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp',NULL,119580,42.08,0.12,1800,52901,65,NULL,'SNLS 03D3aw, SALT','LSSP J142053.55+523620.4',0.449,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119581,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp',NULL,119581,42.13,0.03,1840,52901,65,NULL,'SNLS 03D3aw, SALT','LSSP J142053.55+523620.4',0.449,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119582,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp',NULL,119582,42.15,0.15,1860,52901,NULL,NULL,'SNLS 03D3aw, SIFTO','LSSP J142053.55+523620.4',0.449,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119583,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp',NULL,119583,42.18,0.19,1880,52901,65,NULL,'SNLS 03D3aw, SALT2','LSSP J142053.55+523620.4',0.449,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119584,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp',NULL,119584,42.94,0.17,2670,52901,NULL,NULL,'SNLS 03D3aw, SALT2','LSSP J142053.55+523620.4',0.449,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119585,'IRAS','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119585,34.94,0.8,97.2,52902,75,NULL,'MAT, I','ESO 446- G 051',NULL,'1997ApJS..109..333W',1997,1,1.52,NULL,'G',0.000023,NULL,'16.14',0.21,'Sc',NULL,NULL,NULL,NULL,1,215.224125,-29.02197,0.325,NULL,47042578963,735040296,11485004,16.14),(119586,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119586,34.12,0.32,66.6,52902,85,NULL,'I, raw','ESO 446- G 051',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119587,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119587,34.13,0.32,67,52902,85,NULL,'I, inv','ESO 446- G 051',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119588,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119588,34.17,0.43,68.2,52902,75,NULL,'MAT, I, raw','ESO 446- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119589,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119589,34.27,0.43,71.5,52902,75,NULL,'MAT, I, inv','ESO 446- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119590,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119590,34.38,NULL,75.2,52902,NULL,NULL,NULL,'ESO 446- G 051',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119591,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119591,34.5,0.43,79.3,52902,75,NULL,'MAT, I, cor','ESO 446- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119592,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119592,34.63,NULL,84.5,52902,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 446- G 051',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119593,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119593,34.64,NULL,84.7,52902,NULL,NULL,'Dipole + Quadrupole','ESO 446- G 051',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119594,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119594,34.66,NULL,85.6,52902,NULL,NULL,'Dipole','ESO 446- G 051',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119595,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119595,34.71,0.49,87.3,52902,75,NULL,'IR','ESO 446- G 051',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119596,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119596,34.89,0.44,95.2,52902,NULL,NULL,'Malmquist cor.','ESO 446- G 051',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119597,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119597,34.96,0.2,98.2,52902,74.4,NULL,NULL,'ESO 446- G 051',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119598,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119598,34.98,0.42,99,52902,NULL,NULL,NULL,'ESO 446- G 051',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119599,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119599,35.06,0.43,103,52902,75,NULL,'3.6 micron, color corrected','ESO 446- G 051',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119600,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119600,35.2,0.43,110,52902,75,NULL,'3.6 micron, color + selection bias corrected','ESO 446- G 051',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119601,'IRAS','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119601,33.94,0.8,61.3,52903,75,NULL,'HMCL, I','UGC 09186',NULL,'1997ApJS..109..333W',1997,1,0.95,NULL,'G',0.000027,NULL,'15.3g',0.34,'Sa',NULL,NULL,NULL,NULL,1,215.2252083,23.60275,0,NULL,59513499920,929898436,14529663,15.3),(119602,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119602,34,0.2,63.1,52903,74.4,NULL,NULL,'UGC 09186',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119603,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119603,34.14,0.4,67.2,52903,75,NULL,'HMCL, I, raw','UGC 09186',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119604,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119604,34.2,0.4,69.3,52903,75,NULL,'HMCL, I, inv','UGC 09186',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119605,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119605,34.29,0.4,72.2,52903,75,NULL,'HMCL, I, cor','UGC 09186',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119606,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119606,37.37,0.46,298,52904,70,NULL,NULL,'2MASX J14205406+0151427',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000092,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,215.225417,1.86194,0.061,NULL,58297978396,910905912,14232904,16.4),(119607,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119607,38.34,0.46,466,52905,70,NULL,NULL,'SDSS J142055.00+011629.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000076,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,215.229167,1.275,0.065,NULL,58287442324,910741286,14230332,18.7),(119608,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119608,37.47,0.07,312,52906,70,NULL,NULL,'2MASX J14205581+4818352',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,215.232417,48.30972,0,NULL,59247781401,925746584,14464790,17.4),(119609,'SBF','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119609,31.89,0.62,23.9,52907,NULL,NULL,'I','NGC 5574',NULL,'2001ApJ...546..681T',2001,1,1.6,NULL,'G',0.000017,NULL,'13.0g',1,'SB0-? sp','in a triple',NULL,NULL,NULL,1,215.2332083,3.238,0.037,NULL,58293931531,910842680,14231916,13),(119610,'SBF','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119610,31.93,0.14,24.3,52907,74.4,NULL,NULL,'NGC 5574',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119611,'Tully est','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119611,32.29,0.8,28.7,52907,75,NULL,'B','NGC 5574',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119612,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119612,31.2,0.45,17.4,52907,NULL,NULL,'K','NGC 5574',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119613,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119613,32.06,0.4,25.8,52907,NULL,NULL,'mean','NGC 5574',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119614,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119614,37.99,0.46,397,52908,70,NULL,NULL,'2MASX J14205619+1710220',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',NULL,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,215.23425,17.17289,0,NULL,59488122543,929501914,14523467,18.4),(119615,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119615,37.73,0.46,352,52909,70,NULL,NULL,'2MASX J14205677+3505120',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000148,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,215.2365,35.08675,0,NULL,60043173073,938174579,14658977,17.3),(119616,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119616,38.06,0.46,408,52910,70,NULL,NULL,'2MASX J14205729+2102105',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.36',0.18,NULL,NULL,NULL,NULL,NULL,1,215.238833,21.03619,0.019,NULL,59522033223,930031769,14531746,18.36),(119617,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119617,36.36,0.88,187,52911,70,NULL,NULL,'2MASX J14205760-8016096',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,215.240167,-80.26931,0.433,NULL,44246902164,691357846,10802466,17.1),(119618,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119618,38.57,0.33,517,52912,70,NULL,NULL,'SDSS J142058.51+020542.6',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000085,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,215.2437917,2.09519,0.057,NULL,58298196801,910909325,14232958,18.8),(119619,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119619,36.43,0.56,193,52913,70,NULL,NULL,'2MASX J14205883-1955257',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000083,NULL,'15.95',0.4,NULL,NULL,NULL,NULL,NULL,1,215.245125,-19.92389,0.329,NULL,46571737219,727683394,11370053,15.95),(119620,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119620,36.69,0.6,217,52914,70,NULL,NULL,'2MASX J14205921-1557545',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,215.2467083,-15.96517,0.261,NULL,46555529051,727430141,11366095,14.3),(119621,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3gv',NULL,119621,42.51,0.17,1850,52915,NULL,NULL,'SALT2','SNLS 05D3gv',0.715,'2010A&A...523A...7G',2010,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,215.246875,53.17889,0,NULL,59198390713,924974854,14452732,NULL),(119622,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3gv',NULL,119622,43.2,0.05,2550,52915,70,NULL,'SIFTO','SNLS 05D3gv',0.715,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119623,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3gv',NULL,119623,43.21,0.15,2550,52915,NULL,NULL,'SIFTO','SNLS 05D3gv',0.715,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119624,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3gv',NULL,119624,43.21,0.22,2550,52915,70,NULL,'SALT 2','SNLS 05D3gv',0.715,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119625,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119625,35.16,0.46,108,52916,70,NULL,NULL,'NGC 5575',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000067,NULL,'14.1g',0.9,'S0','Group member',NULL,NULL,NULL,1,215.2475417,6.20267,0.021,NULL,58271704073,910495376,14226490,14.1),(119626,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119626,36.79,0.65,229,52917,70,NULL,NULL,'2MASX J14210050-1635405',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.7I',0.2,NULL,NULL,NULL,NULL,NULL,1,215.252125,-16.59461,0.241,NULL,46556023377,727437865,11366216,14.7),(119627,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119627,37.44,0.46,308,52918,70,NULL,NULL,'2MASX J14210114+1907035',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,215.254833,19.11758,0,NULL,59519148223,929986690,14531042,16.9),(119628,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119628,38.04,0.19,405,52919,70,NULL,NULL,'2MASX J14210169+4020159',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,215.25725,40.33789,0,NULL,59945928504,936655132,14635236,18),(119629,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119629,36.94,0.27,244,52920,70,NULL,NULL,'IC 1004',NULL,'2015arXiv151105856S',2015,1,0.3,'HOLM 634B is a star.','G',NULL,NULL,'15.4',0.3,NULL,NULL,NULL,NULL,NULL,1,215.2595,17.70058,0,NULL,59486578234,929477784,14523090,15.4),(119630,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ne',NULL,119630,37.89,0.17,324,52921,NULL,NULL,'SALT2','SDSS J142102.53+522942.7',0.169221,'2010A&A...523A...7G',2010,1,0.19,NULL,'G',0.000177,NULL,'18.1g',0.18,'a',NULL,NULL,NULL,NULL,1,215.260583,52.49519,0.005,NULL,59195931606,924936431,14452131,18.1),(119631,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ne',NULL,119631,39.26,0.04,610,52921,70,NULL,'SALT2','SDSS J142102.53+522942.7',0.169221,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119632,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ne',NULL,119632,39.63,0.15,720,52921,NULL,NULL,'SIFTO','SDSS J142102.53+522942.7',0.169221,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119633,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ne',NULL,119633,39.64,0.12,724,52921,70,NULL,'SALT 2','SDSS J142102.53+522942.7',0.169221,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119634,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ne',NULL,119634,39.65,NULL,728,52921,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SDSS J142102.53+522942.7',0.169221,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119635,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119635,37.2,0.46,276,52922,70,NULL,NULL,'2MASX J14210319+0131247',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000067,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,215.2634583,1.5235,0.061,NULL,58287218753,910737793,14230278,17.5),(119636,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119636,37.01,0.46,252,52923,70,NULL,NULL,'2MASX J14210354+0602387',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.76',0.24,NULL,NULL,NULL,NULL,NULL,1,215.264708333,6.04419,0.033,NULL,58300871953,910951124,14233611,17.76),(119637,'SBF','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119637,32.03,0.14,25.5,52924,74.4,NULL,NULL,'NGC 5576',NULL,'2013AJ....146...86T',2013,1,3.5,NULL,'G',0.000017,NULL,'11.85',2.2,'E3','in a triple',NULL,NULL,NULL,1,215.265333,3.271,0.037,NULL,58293949270,910842957,14231921,11.85),(119638,'SBF','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119638,32.03,0.14,25.5,52924,NULL,NULL,'I','NGC 5576',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119639,'SBF','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119639,32.03,0.14,25.5,52924,NULL,NULL,NULL,'NGC 5576',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119640,'SBF','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119640,32.05,0.14,25.7,52924,NULL,NULL,'Malmquist cor.','NGC 5576',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119641,'D-Sigma','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119641,31.39,0.4,19,52924,75,NULL,'Edat, raw','NGC 5576',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119642,'D-Sigma','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119642,31.61,0.4,21,52924,75,NULL,'Edat, cor','NGC 5576',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119643,'Faber-Jackson','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119643,30.02,0.63,10.1,52924,95,NULL,'Michard 1979b, c','NGC 5576',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119644,'Faber-Jackson','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119644,30.18,0.81,10.9,52924,55,NULL,'Visvanathan & Sandage 1979','NGC 5576',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119645,'Faber-Jackson','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119645,30.38,0.31,11.9,52924,95,NULL,'Weighted Mean','NGC 5576',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119646,'Faber-Jackson','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119646,31.02,0.46,16,52924,95,NULL,'Michard 1979a','NGC 5576',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119647,'Faber-Jackson','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119647,31.06,0.58,16.3,52924,95,NULL,'de Vaucouleurs','NGC 5576',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119648,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119648,31.74,0.41,22.3,52924,NULL,NULL,NULL,'NGC 5576',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119649,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119649,31.91,0.41,24.1,52924,NULL,NULL,'Malmquist cor.','NGC 5576',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119650,'Tertiary','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119650,30.95,0.21,15.5,52924,95,NULL,NULL,'NGC 5576',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119651,'Tully est','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119651,32.11,0.8,26.4,52924,75,NULL,'B','NGC 5576',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119652,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119652,31.9,0.45,24,52924,NULL,NULL,'K','NGC 5576',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119653,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119653,32.06,0.4,25.8,52924,NULL,NULL,'mean','NGC 5576',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119654,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119654,37.47,0.07,312,52925,70,NULL,NULL,'2MASX J14210594+4818292',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000202,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,215.274833,48.30814,0,NULL,59248646793,925760106,14465001,16.5),(119655,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119655,37.23,0.33,280,52926,70,NULL,NULL,'2MASX J14210656+4713156',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000168,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,215.277417,47.22108,0.061,NULL,59246948807,925733575,14464587,16.9),(119656,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3cx',NULL,119656,42.71,0.06,1930,52927,70,NULL,'SIFTO','SNLS 05D3cx HOST',0.805,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',NULL,NULL,'22.9R',NULL,'a',NULL,NULL,NULL,NULL,1,215.277625,52.75042,0,NULL,59198218434,924972163,14452690,22.9),(119657,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3cx',NULL,119657,43.51,0.15,2790,52927,NULL,NULL,'SIFTO','SNLS 05D3cx HOST',0.805,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119658,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3cx',NULL,119658,43.55,0.19,2840,52927,70,NULL,'SALT 2','SNLS 05D3cx HOST',0.805,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119659,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3cx',NULL,119659,44.54,0.17,4490,52927,NULL,NULL,'SALT2','SNLS 05D3cx HOST',0.805,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119660,'G Lens','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119660,45.68,0.17,7580,52927,NULL,NULL,'SNLS 05D3cx HOST','SNLS 05D3cx HOST',0.805,'2010A&A...514A..44K',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119661,'Faber-Jackson','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119661,45.67,0.17,7540,52927,NULL,NULL,'SNLS 05D3cx HOST','SNLS 05D3cx HOST',0.805,'2010A&A...514A..44K',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119662,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119662,37.88,0.46,377,52928,70,NULL,NULL,'SDSS J142106.81+443904.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,215.278375,44.65119,0,NULL,59230459012,925475922,14460561,18.1),(119663,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119663,33.11,0.58,41.8,52929,NULL,NULL,NULL,'MCG +06-32-004',NULL,'2009ApJS..182..474S',2009,1,0.65,NULL,'G',0.000008,NULL,'16.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,215.283167,35.29539,0,NULL,60043302899,938176607,14659009,16.4),(119664,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119664,33.15,0.2,42.7,52929,74.4,NULL,NULL,'MCG +06-32-004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119665,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119665,33.41,0.51,48.1,52929,NULL,NULL,'Malmquist cor.','MCG +06-32-004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119666,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu','R',119666,42.73,NULL,1930,52930,65,NULL,'SALT2','[HSP2005] J142108.00+525829.74',0.822,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.0002,NULL,'23.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,215.283333,52.97531,0,NULL,59198253025,924972703,14452698,23.4),(119667,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu',NULL,119667,43.09,0.22,2280,52930,74.2,NULL,'SALT 2','[HSP2005] J142108.00+525829.74',0.822,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119668,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu',NULL,119668,43.37,0.17,2590,52930,NULL,NULL,'SALT2','[HSP2005] J142108.00+525829.74',0.822,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119669,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu',NULL,119669,43.41,0.06,2640,52930,70,NULL,'SALT2','[HSP2005] J142108.00+525829.74',0.822,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119670,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu',NULL,119670,43.53,0.35,2790,52930,65,NULL,'SALT2','[HSP2005] J142108.00+525829.74',0.822,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119671,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu',NULL,119671,43.54,0.35,2800,52930,70,NULL,'SALT','[HSP2005] J142108.00+525829.74',0.822,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119672,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu',NULL,119672,43.54,0.22,2810,52930,70,NULL,NULL,'[HSP2005] J142108.00+525829.74',0.822,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119673,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu',NULL,119673,43.63,0.17,2920,52930,65,NULL,'MLCS2k2','[HSP2005] J142108.00+525829.74',0.822,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119674,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu',NULL,119674,43.69,0.32,3000,52930,65,NULL,'SALT','[HSP2005] J142108.00+525829.74',0.822,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119675,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu',NULL,119675,43.74,0.21,3070,52930,70,NULL,'SALT 2','[HSP2005] J142108.00+525829.74',0.822,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119676,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu',NULL,119676,43.76,0.18,3100,52930,65,NULL,'SALT2','[HSP2005] J142108.00+525829.74',0.822,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119677,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu',NULL,119677,43.76,0.19,3100,52930,65,NULL,'MLCS2k2','[HSP2005] J142108.00+525829.74',0.822,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119678,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu',NULL,119678,43.77,0.21,3110,52930,65,NULL,'MLCS31','[HSP2005] J142108.00+525829.74',0.822,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119679,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu',NULL,119679,43.79,0.15,3140,52930,NULL,NULL,'SIFTO','[HSP2005] J142108.00+525829.74',0.822,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119680,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu',NULL,119680,43.79,0.22,3150,52930,65,NULL,'MLCS17','[HSP2005] J142108.00+525829.74',0.822,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119681,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu',NULL,119681,43.81,0.16,3170,52930,65,NULL,'SALT','[HSP2005] J142108.00+525829.74',0.822,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119682,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119682,36.48,0.19,198,52931,70,NULL,NULL,'2MASX J14210828+6116476',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000106,NULL,'16.1g',0.29,'S0/a',NULL,NULL,NULL,NULL,1,215.284166667,61.27986,0.009,NULL,57754104699,902407885,14100123,16.1),(119683,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119683,38.04,0.19,405,52932,70,NULL,NULL,'SDSS J142108.93+402028.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000178,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,215.28725,40.34133,0,NULL,59945930437,936655163,14635236,18.4),(119684,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119684,36.48,0.19,198,52933,70,NULL,NULL,'2MASX J14210907+6134566',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000181,NULL,'16.1g',0.3,'E0',NULL,NULL,NULL,NULL,1,215.287833,61.58236,0,NULL,57762332464,902536444,14102131,16.1),(119685,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119685,36.67,0.46,216,52934,70,NULL,NULL,'2MASX J14210958+2610243',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'17.33',0.18,NULL,NULL,NULL,NULL,NULL,1,215.290083333,26.17353,0,NULL,60054945684,938358526,14661851,17.33),(119686,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119686,37.45,0.46,309,52935,70,NULL,NULL,'SDSS J142109.85+315826.1',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'18.1g',NULL,NULL,NULL,NULL,NULL,NULL,1,215.291208333,31.97408,0,NULL,60046935901,938233373,14659896,18.1),(119687,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119687,37.58,0.27,328,52936,70,NULL,NULL,'2MASX J14210993+1831375',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,215.2915,18.52731,0,NULL,59518384120,929974751,14530855,17.1),(119688,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119688,37.6,0.21,331,52937,70,NULL,NULL,'2MASX J14211042+2522443',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000097,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,215.293583,25.37908,0,NULL,59999749715,937496089,14648376,17.4),(119689,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119689,37.2,0.46,275,52938,70,NULL,NULL,'2MASX J14211046+2312376',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000203,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,215.293666667,23.21061,0.019,NULL,59516875819,929951184,14530487,16.2),(119690,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119690,35.98,0.46,157,52939,70,NULL,NULL,'2MASX J14211168+0244067',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000056,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,215.298833,2.73508,0.037,NULL,58298288631,910910759,14232980,17.2),(119691,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119691,38.35,0.46,467,52940,70,NULL,NULL,'SDSS J142112.33+171737.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.6g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.301375,17.29364,0,NULL,59488291762,929504558,14523508,18.6),(119692,'IRAS','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119692,31.23,0.8,17.7,52941,75,NULL,'MAT, I','IC 4402',NULL,'1997ApJS..109..333W',1997,1,4.2,NULL,'G',0.000022,NULL,'12.5b',0.9,'Sb:',NULL,NULL,NULL,NULL,1,215.3045417,-46.29789,0.445,NULL,46803599303,731306239,11426659,12.5),(119693,'Tully est','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119693,31.8,0.8,22.9,52941,75,NULL,NULL,'IC 4402',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119694,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119694,31.13,0.4,16.8,52941,73,NULL,'IR','IC 4402',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119695,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119695,31.13,0.4,16.8,52941,75,NULL,NULL,'IC 4402',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119696,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119696,31.15,0.4,17,52941,73,NULL,'opt','IC 4402',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119697,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119697,31.17,0.36,17.1,52941,NULL,NULL,NULL,'IC 4402',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119698,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119698,31.21,0.43,17.5,52941,75,NULL,'MAT, I, raw','IC 4402',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119699,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119699,31.24,0.46,17.7,52941,NULL,NULL,'J','IC 4402',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119700,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119700,31.24,0.47,17.7,52941,NULL,NULL,'H','IC 4402',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119701,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119701,31.3,0.32,18.2,52941,85,NULL,'I, raw','IC 4402',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119702,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119702,31.31,0.45,18.2,52941,NULL,NULL,'K','IC 4402',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119703,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119703,31.34,0.32,18.5,52941,85,NULL,'I, inv','IC 4402',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119704,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119704,31.4,0.49,19.1,52941,75,NULL,'IR','IC 4402',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119705,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119705,31.4,0.43,19.1,52941,75,NULL,'MAT, I, inv','IC 4402',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119706,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119706,31.56,0.43,20.5,52941,75,NULL,'MAT, I, cor','IC 4402',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119707,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119707,31.7,0.4,21.9,52941,NULL,NULL,'mean','IC 4402',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119708,'IRAS','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119708,31.89,0.8,23.9,52942,75,NULL,'A82, H','NGC 5577',NULL,'1997ApJS..109..333W',1997,1,3.4,NULL,'G',0.000013,NULL,'13.05',1,'SA(rs)bc:      HII','in a triple',NULL,NULL,NULL,1,215.304625,3.43578,0.045,NULL,58293833772,910841152,14231893,13.05),(119709,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119709,31.02,0.4,16,52942,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5577',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119710,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119710,31.42,0.36,19.2,52942,NULL,NULL,NULL,'NGC 5577',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119711,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119711,31.47,0.47,19.7,52942,75,NULL,'A82, H, inv','NGC 5577',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119712,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119712,31.51,0.47,20.1,52942,75,NULL,'A82, H, raw','NGC 5577',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119713,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119713,31.78,0.57,22.7,52942,NULL,NULL,'Malmquist cor.','NGC 5577',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119714,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119714,31.8,0.47,23,52942,75,NULL,'A82, H, cor','NGC 5577',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119715,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119715,31.81,NULL,23,52942,72,NULL,NULL,'NGC 5577',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119716,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119716,31.91,0.46,24.1,52942,NULL,NULL,'J','NGC 5577',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119717,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119717,31.99,0.47,25,52942,NULL,NULL,'H','NGC 5577',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119718,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119718,32.07,0.4,25.9,52942,75,NULL,'B','NGC 5577',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119719,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119719,32.07,0.5,25.9,52942,NULL,NULL,NULL,'NGC 5577',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119720,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119720,32.1,0.45,26.3,52942,NULL,NULL,'K','NGC 5577',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119721,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119721,32.11,0.2,26.4,52942,74.4,NULL,NULL,'NGC 5577',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119722,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119722,32.15,0.4,27,52942,NULL,NULL,'mean','NGC 5577',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119723,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119723,35.46,0.47,124,52943,NULL,NULL,'H','IC 4408',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000113,NULL,'15.03',0.4,'S?',NULL,NULL,NULL,NULL,1,215.3045417,29.9935,0,NULL,60062381857,938474716,14663667,15.03),(119724,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119724,35.57,0.45,130,52943,NULL,NULL,'K','IC 4408',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119725,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119725,35.64,0.4,135,52943,NULL,NULL,'mean','IC 4408',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119726,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119726,35.66,0.46,135,52943,NULL,NULL,'J','IC 4408',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119727,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119727,37.99,0.27,396,52944,70,NULL,NULL,'2MASX J14211315+4303276',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,215.304833,43.05772,0,NULL,59224793953,925387405,14459178,17.1),(119728,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119728,34.6,0.47,83.4,52945,NULL,NULL,'H','ESO 511- G 034',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000063,NULL,'13.99',1.1,'(R\')SB(rs)b? pec',NULL,NULL,NULL,NULL,1,215.3055417,-27.26156,0.245,NULL,47034680325,734916880,11483076,13.99),(119729,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119729,34.65,0.45,85.3,52945,NULL,NULL,'K','ESO 511- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119730,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119730,34.73,0.46,88.3,52945,NULL,NULL,'J','ESO 511- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119731,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119731,34.75,0.4,89,52945,NULL,NULL,'mean','ESO 511- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119732,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3en',NULL,119732,43.03,0.17,1960,52946,NULL,NULL,'SALT2','SNLS 06D3en',1.06,'2010A&A...523A...7G',2010,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia?',NULL,NULL,NULL,NULL,1,215.305583,52.45608,0.005,NULL,59195930407,924936412,14452131,NULL),(119733,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3en',NULL,119733,43.73,0.13,2700,52946,70,NULL,'SALT2','SNLS 06D3en',1.06,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119734,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3en',NULL,119734,44.22,0.15,3390,52946,NULL,NULL,'SIFTO','SNLS 06D3en',1.06,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119735,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119735,37.86,0.33,372,52947,70,NULL,NULL,'2MASX J14211345-0027596',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000102,NULL,'17.1g',0.27,'NLAGN',NULL,NULL,NULL,NULL,1,215.3060417,-0.46656,0.137,NULL,43505791711,679777995,10621531,17.1),(119736,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3hs',NULL,119736,42.2,0.05,1660,52948,70,NULL,'SIFTO','SNLS 05D3hs',0.664,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,215.3065,52.90381,0,NULL,59198255181,924972737,14452699,NULL),(119737,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3hs',NULL,119737,43.16,0.15,2580,52948,NULL,NULL,'SIFTO','SNLS 05D3hs',0.664,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119738,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3hs',NULL,119738,43.25,0.17,2690,52948,70,NULL,'SALT 2','SNLS 05D3hs',0.664,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119739,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3hs',NULL,119739,44.06,0.17,3890,52948,NULL,NULL,'SALT2','SNLS 05D3hs',0.664,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119740,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119740,37.86,0.33,372,52949,70,NULL,NULL,'2MASX J14211365-0026506',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000074,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,215.306833333,-0.44753,0.137,NULL,43505794867,679778044,10621531,17.6),(119741,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003ff',NULL,119741,41.85,0.17,1530,52950,74.2,NULL,'SALT 2','LSSP J142114.54+523218.1',0.532,'2010ApJ...716..712A',2010,1,0.08,NULL,'G',0.0005,NULL,'21.4g',0.04,NULL,NULL,NULL,NULL,NULL,1,215.310333333,52.53839,0.005,NULL,59195918146,924936221,14452128,21.4),(119742,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003ff','R',119742,42.06,NULL,1690,52950,65,NULL,'SNLS 03D3af, MLCS17','LSSP J142114.54+523218.1',0.532,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119743,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003ff',NULL,119743,42.56,0.17,2120,52950,NULL,NULL,'SNLS 03D3af, SALT2','LSSP J142114.54+523218.1',0.532,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119744,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003ff',NULL,119744,42.59,0.08,2150,52950,70,NULL,'SNLS 03D3af','LSSP J142114.54+523218.1',0.532,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119745,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003ff',NULL,119745,42.65,0.2,2210,52950,70,NULL,'SNLS 03D3af, SALT','LSSP J142114.54+523218.1',0.532,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119746,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003ff',NULL,119746,42.67,0.14,2240,52950,65,NULL,'SNLS 03D3af, SALT2','LSSP J142114.54+523218.1',0.532,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119747,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003ff',NULL,119747,42.8,0.17,2370,52950,65,NULL,'SNLS 03D3af, SALT','LSSP J142114.54+523218.1',0.532,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119748,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003ff',NULL,119748,42.81,0.21,2380,52950,65,NULL,'SNLS 03D3af, MLCS2k2','LSSP J142114.54+523218.1',0.532,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119749,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003ff',NULL,119749,42.83,0.19,2400,52950,65,NULL,'SNLS 03D3af, SALT2','LSSP J142114.54+523218.1',0.532,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119750,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003ff',NULL,119750,42.83,0.29,2400,52950,65,NULL,'SNLS 03D3af, MLCS31','LSSP J142114.54+523218.1',0.532,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119751,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003ff',NULL,119751,42.85,0.24,2420,52950,65,NULL,'SNLS 03D3af, MLCS17','LSSP J142114.54+523218.1',0.532,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119752,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003ff',NULL,119752,42.84,0.27,2420,52950,65,NULL,'SNLS 03D3af, MLCS2k2','LSSP J142114.54+523218.1',0.532,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119753,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003ff',NULL,119753,42.93,0.05,2510,52950,65,NULL,'SNLS 03D3af, SALT','LSSP J142114.54+523218.1',0.532,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119754,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119754,38.57,0.33,517,52951,70,NULL,NULL,'2MASX J14211534+0201587',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000091,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,215.313875,2.03292,0.057,NULL,58298203764,910909433,14232959,17.3),(119755,'IRAS','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119755,33.42,0.8,48.2,52952,75,NULL,'MAT, I','ESO 385- G 012',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'16',1.2,'S.../Irr','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,215.315375,-36.22661,0.197,NULL,46994429933,734287967,11473249,16),(119756,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119756,32.94,0.32,38.8,52952,85,NULL,'I, raw','ESO 385- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119757,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119757,32.94,0.32,38.8,52952,85,NULL,'I, inv','ESO 385- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119758,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119758,33.19,0.43,43.5,52952,75,NULL,'MAT, I, raw','ESO 385- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119759,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119759,33.24,0.43,44.6,52952,75,NULL,'MAT, I, inv','ESO 385- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119760,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119760,33.5,0.43,50.1,52952,75,NULL,'MAT, I, cor','ESO 385- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119761,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119761,33.77,0.14,56.9,52952,NULL,NULL,NULL,'ESO 385- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119762,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119762,34.25,0.33,70.8,52953,70,NULL,NULL,'NGC 5581',NULL,'2015arXiv151105856S',2015,1,0.96,NULL,'G',0.0001,NULL,'14.3g',0.73,NULL,NULL,NULL,NULL,NULL,1,215.317958333,23.48003,0.041,NULL,59513478637,929898103,14529657,14.3),(119763,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119763,37.99,0.27,396,52954,70,NULL,NULL,'2MASX J14211625+4304155',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,215.317958333,43.07083,0,NULL,59224793258,925387394,14459178,17.3),(119764,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119764,37.93,0.33,386,52955,70,NULL,NULL,'2MASX J14211666+4329226',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.319375,43.4895,0,NULL,59224851228,925388300,14459192,17.6),(119765,'IRAS','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119765,31,0.8,15.8,52956,75,NULL,'MAT, I','ESO 446- G 053',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00003,NULL,'14.63',0.7,'IB(s)m','Pair member (points to parent)',NULL,NULL,NULL,1,215.321333,-29.26319,0.309,NULL,47042750595,735042978,11485046,14.63),(119766,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119766,29.75,0.32,8.91,52956,85,NULL,'I, inv','ESO 446- G 053',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119767,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119767,29.84,0.32,9.27,52956,85,NULL,'I, raw','ESO 446- G 053',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119768,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119768,30.31,0.43,11.5,52956,75,NULL,'MAT, I, inv','ESO 446- G 053',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119769,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119769,30.55,0.43,12.9,52956,75,NULL,'MAT, I, raw','ESO 446- G 053',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119770,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119770,30.84,0.43,14.7,52956,75,NULL,'MAT, I, cor','ESO 446- G 053',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119771,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119771,31.17,0.4,17.1,52956,NULL,NULL,NULL,'ESO 446- G 053',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119772,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119772,32.51,0.6,31.8,52956,NULL,NULL,NULL,'ESO 446- G 053',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119773,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119773,32.55,0.2,32.4,52956,74.4,NULL,NULL,'ESO 446- G 053',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119774,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119774,32.64,0.57,33.8,52956,NULL,NULL,'Malmquist cor.','ESO 446- G 053',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119775,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119775,38.02,0.19,402,52957,70,NULL,NULL,'2MASX J14211718+4438036',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000172,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,215.321417,44.63417,0,NULL,59230461555,925475961,14460561,18),(119776,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119776,37.47,0.07,312,52958,70,NULL,NULL,'2MASX J14211721+4825551',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,215.3219583,48.43192,0.027,NULL,59248640470,925760007,14465000,17.4),(119777,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119777,38.02,0.19,402,52959,70,NULL,NULL,'2MASX J14211738+4446426',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.322333,44.77842,0,NULL,59230475325,925476176,14460565,17.3),(119778,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119778,37.26,0.46,283,52960,70,NULL,NULL,'2MASX J14211739+2657394',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000184,NULL,'17.84',0.18,NULL,NULL,NULL,NULL,NULL,1,215.3225,26.96097,0,NULL,60057525987,938398843,14662481,17.84),(119779,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119779,37.76,0.46,357,52961,70,NULL,NULL,'SDSS J142117.62+301347.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.3234583,30.22975,0,NULL,60061475931,938460561,14663446,18.3),(119780,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119780,36.57,0.46,206,52962,70,NULL,NULL,'2MASX J14211836+3221328',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000173,NULL,'16.3g',0.42,NULL,NULL,NULL,NULL,NULL,1,215.326667,32.35925,0,NULL,60046740066,938230313,14659848,16.3),(119781,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119781,37.22,0.46,277,52963,70,NULL,NULL,'2MASX J14211885+5211261',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00018,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,215.328417,52.19064,0,NULL,59196076950,924938702,14452167,16.3),(119782,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119782,37.78,0.46,360,52964,70,NULL,NULL,'2MASX J14211901+5232341',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000178,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,215.329167,52.54281,0.005,NULL,59195917921,924936217,14452128,17),(119783,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119783,36.48,0.19,198,52965,70,NULL,NULL,'CGCG 295-046 NED02',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000211,NULL,'15.2g',0.54,'E0',NULL,NULL,NULL,NULL,1,215.32975,61.57925,0.009,NULL,57762329398,902536396,14102131,15.2),(119784,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119784,37.47,0.07,312,52966,70,NULL,NULL,'2MASX J14211921+4825331',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000184,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,215.330041667,48.42572,0.027,NULL,59248640481,925760007,14465000,17.2),(119785,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119785,37.56,0.85,324,52967,70,NULL,NULL,'2MASX J14211953-1003156',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.25',NULL,NULL,NULL,NULL,NULL,NULL,1,215.331291667,-10.05436,0.197,NULL,43706695434,682917116,10670579,16.25),(119786,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119786,36.48,0.19,198,52968,70,NULL,NULL,'2MASX J14211957+6131306',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000176,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,215.3317083,61.52511,0.009,NULL,57762320657,902536260,14102129,16.8),(119787,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119787,38.14,0.46,424,52969,70,NULL,NULL,'2MASX J14211962+0351513',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000086,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,215.33175,3.86431,0.049,NULL,58296440579,910881884,14232529,17.7),(119788,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119788,37.89,0.46,379,52970,70,NULL,NULL,'2MASX J14211979+2140536',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,215.332416667,21.68156,0.023,NULL,59521909245,930029831,14531716,17.8),(119789,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119789,37.22,0.46,278,52971,70,NULL,NULL,'2MASX J14212124+0548083',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00014,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.338375,5.80244,0.033,NULL,58301068114,910954189,14233659,17.5),(119790,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119790,32.68,0.43,34.3,52972,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-37-003',NULL,'2014MNRAS.444..527S',2014,1,1,NULL,'G',0.00001,NULL,'14.95',0.3,'Sc',NULL,NULL,NULL,NULL,1,215.3427917,-3.75886,0.129,NULL,43510732078,679855188,10622737,14.95),(119791,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119791,37.88,0.46,377,52973,70,NULL,NULL,'2MASX J14212287+3209358',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.345375,32.16006,0,NULL,60046950886,938233607,14659900,17.7),(119792,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119792,37.4,0.15,302,52974,70,NULL,NULL,'SDSS J142123.08+302158.7',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.4g',0.34,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.3462083,30.36633,0,NULL,60061508896,938461076,14663454,16.4),(119793,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119793,37.47,0.07,312,52975,70,NULL,NULL,'2MASX J14212317+4755065',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000189,NULL,'15.8g',0.35,NULL,NULL,NULL,NULL,NULL,1,215.3465417,47.91842,0.006,NULL,59248137605,925752150,14464877,15.8),(119794,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119794,36.5,0.46,200,52976,70,NULL,NULL,'2MASX J14212374+0045543',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000087,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,215.348833333,0.76506,0.065,NULL,58285424911,910709764,14229840,16.9),(119795,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119795,37,0.33,251,52977,70,NULL,NULL,'2MASX J14212464+2929054',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000186,NULL,'18.29',0.18,NULL,NULL,NULL,NULL,NULL,1,215.3527083,29.48475,0,NULL,60061996516,938468695,14663573,18.29),(119796,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119796,37.65,0.17,339,52978,70,NULL,NULL,'2MASX J14212522+5628486',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00018,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,215.354875,56.48022,0,NULL,57256704634,894636009,13978687,16.9),(119797,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3la',NULL,119797,43.49,0.07,2580,52979,70,NULL,'SALT2','SNLS 05D3la',0.936,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia?',NULL,NULL,NULL,NULL,1,215.355917,52.35797,0,NULL,59196055342,924938364,14452161,NULL),(119798,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3la',NULL,119798,43.87,0.17,3070,52979,NULL,NULL,'SALT2','SNLS 05D3la',0.936,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119799,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3la',NULL,119799,43.87,0.15,3070,52979,NULL,NULL,'SIFTO','SNLS 05D3la',0.936,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119800,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3la',NULL,119800,43.9,0.21,3110,52979,70,NULL,'SALT 2','SNLS 05D3la',0.936,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119801,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119801,37.47,0.07,312,52980,70,NULL,NULL,'2MASX J14212548+4829335',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00007,NULL,'16.2g',0.36,'Elliptical',NULL,NULL,NULL,NULL,1,215.356333,48.49258,0.028,NULL,59248558113,925758720,14464980,16.2),(119802,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119802,37.92,0.16,383,52981,70,NULL,NULL,'2MASX J14212607+4931025',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000173,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,215.358458333,49.51728,0.005,NULL,59246540902,925727201,14464487,18.1),(119803,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119803,37.21,0.46,277,52982,70,NULL,NULL,'2MASX J14212619+4906295',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,215.35925,49.10828,0.037,NULL,59245980683,925718448,14464350,17.1),(119804,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119804,37.47,0.07,312,52983,70,NULL,NULL,'2MASX J14212705+4816305',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00017,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.362541667,48.27528,0,NULL,59248652534,925760195,14465003,17.7),(119805,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119805,36.55,0.33,204,52984,70,NULL,NULL,'2MASX J14212711+2631204',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000173,NULL,'17.28',0.24,NULL,NULL,NULL,NULL,NULL,1,215.363,26.52219,0,NULL,60054737451,938355272,14661801,17.28),(119806,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119806,36.8,0.46,229,52985,70,NULL,NULL,'2MASX J14212723+3136498',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.82',0.21,NULL,NULL,NULL,NULL,NULL,1,215.363333,31.61381,0,NULL,60060480004,938445000,14663203,17.82),(119807,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119807,36.8,0.53,229,52986,70,NULL,NULL,'2MASX J14212788-0426057',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.4b',0.45,NULL,NULL,NULL,NULL,NULL,1,215.3660417,-4.43492,0.117,NULL,43511457126,679866517,10622914,16.4),(119808,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119808,37.84,0.46,369,52987,70,NULL,NULL,'2MASX J14212821+2546554',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000146,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.367666667,25.78222,0,NULL,60054231368,938347365,14661677,17.9),(119809,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119809,37.93,0.33,386,52988,70,NULL,NULL,'2MASX J14212822+4327173',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,215.367666667,43.45489,0,NULL,59224853400,925388334,14459192,17.7),(119810,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119810,38.42,0.46,483,52989,70,NULL,NULL,'2MASX J14212857+2529064',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000162,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,215.3689583,25.48519,0,NULL,60054195269,938346801,14661668,18.2),(119811,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119811,37.92,0.16,383,52990,70,NULL,NULL,'SDSS J142129.39+493205.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,215.3725,49.53483,0.005,NULL,59246533578,925727087,14464485,18.5),(119812,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119812,36.1,0.46,166,52991,70,NULL,NULL,'2MASX J14212956+1336183',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.00018,NULL,'15.6g',0.43,NULL,NULL,NULL,NULL,NULL,1,215.373375,13.60522,0,NULL,59475819181,929309674,14520463,15.6),(119813,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119813,35.22,0.33,111,52992,NULL,NULL,'Malmquist cor.','IC 1003',NULL,'2009ApJS..182..474S',2009,1,1.37,NULL,'G',0.000033,NULL,'15.2g',0.39,'cE0 pec:       NLAGN',NULL,NULL,NULL,NULL,1,215.374,5.07319,0.021,NULL,58293331070,910833297,14231770,15.2),(119814,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119814,35.34,0.31,117,52992,NULL,NULL,NULL,'IC 1003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119815,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119815,35.49,0.2,125,52992,74.4,NULL,NULL,'IC 1003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119816,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119816,36.58,0.89,207,52993,70,NULL,NULL,'2MASX J14213028-4723339',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,215.37625,-47.39281,0.597,NULL,46835215086,731800235,11434378,17.3),(119817,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119817,37.47,0.07,312,52994,70,NULL,NULL,'2MASX J14213084+4820336',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,215.3785,48.34258,0.027,NULL,59248653632,925760213,14465003,17.2),(119818,'IRAS','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119818,36.56,0.8,205,52995,75,NULL,'CF, r','UGC 09195',NULL,'1997ApJS..109..333W',1997,1,1.25,NULL,'G',0.000014,NULL,'15.0g',0.45,'Sb',NULL,NULL,NULL,NULL,1,215.3805417,23.94831,0.009,NULL,59513955297,929905551,14529774,15),(119819,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119819,36.85,0.2,234,52995,74.4,NULL,NULL,'UGC 09195',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119820,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119820,36.91,0.38,241,52995,75,NULL,'CF, r, raw','UGC 09195',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119821,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119821,37.15,0.38,269,52995,75,NULL,'CF, r, cor','UGC 09195',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119822,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119822,37.22,0.38,278,52995,75,NULL,'CF, r, inv','UGC 09195',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119823,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119823,37.92,0.46,383,52996,70,NULL,NULL,'2MASX J14213307+3006078',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.07',0.19,NULL,NULL,NULL,NULL,NULL,1,215.3877917,30.10211,0,NULL,60062335179,938473987,14663656,18.07),(119824,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119824,37.56,0.46,326,52997,70,NULL,NULL,'2MASX J14213329+2122360',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.388625,21.37681,0,NULL,59522116262,930033066,14531766,16.9),(119825,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119825,37.58,0.27,328,52998,70,NULL,NULL,'2MASX J14213327+1827060',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,215.388708333,18.45172,0,NULL,59485817092,929465892,14522904,16.1),(119826,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119826,36.99,0.46,250,52999,70,NULL,NULL,'2MASX J14213336+1914330',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.56',0.2,NULL,NULL,NULL,NULL,NULL,1,215.389083333,19.24239,0,NULL,59518291808,929973309,14530832,16.56),(119827,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119827,37.58,0.27,328,53000,70,NULL,NULL,'SDSS J142134.89+182753.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.395417,18.46481,0,NULL,59485815344,929465864,14522904,18.3),(119828,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119828,37.92,0.16,383,53001,70,NULL,NULL,'2MASX J14213541+4930136',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000197,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,215.3977083,49.50372,0.005,NULL,59246601440,925728147,14464502,16.2),(119829,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119829,37.92,0.16,383,53002,70,NULL,NULL,'MCG +08-26-021',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000189,NULL,'15.7g',0.54,'cD;BrClG',NULL,NULL,NULL,NULL,1,215.399291667,49.55122,0.005,NULL,59246533104,925727079,14464485,15.7),(119830,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119830,36.48,0.19,198,53003,70,NULL,NULL,'SDSS J142135.83+613502.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,215.399333,61.584,0.009,NULL,57762326698,902536354,14102130,17.7),(119831,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fh','R',119831,39.69,NULL,694,53004,65,NULL,'SNLS 03D3bh, SALT','SDSS J142135.88+523138.9',0.249,'2010arXiv1006.2112L',2010,1,0.11,NULL,'G',0.0003,NULL,'19.2g',0.09,'AGN',NULL,NULL,NULL,NULL,1,215.3995417,52.5275,0.005,NULL,59195917076,924936204,14452128,19.2),(119832,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fh',NULL,119832,39.9,0.16,765,53004,74.2,NULL,'SALT 2','SDSS J142135.88+523138.9',0.249,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119833,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fh',NULL,119833,40.57,0.02,1040,53004,70,NULL,'SNLS 03D3bh','SDSS J142135.88+523138.9',0.249,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119834,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fh',NULL,119834,40.63,0.14,1070,53004,70,NULL,'SNLS 03D3bh, SALT','SDSS J142135.88+523138.9',0.249,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119835,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fh',NULL,119835,40.72,0.21,1110,53004,65,NULL,'SNLS 03D3bh, SALT2','SDSS J142135.88+523138.9',0.249,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119836,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fh',NULL,119836,40.82,0.16,1170,53004,65,NULL,'SNLS 03D3bh, SALT','SDSS J142135.88+523138.9',0.249,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119837,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fh',NULL,119837,40.83,0.24,1170,53004,65,NULL,'SNLS 03D3bh, MLCS2k2','SDSS J142135.88+523138.9',0.249,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119838,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fh',NULL,119838,40.84,0.03,1180,53004,65,NULL,'SNLS 03D3bh, SALT','SDSS J142135.88+523138.9',0.249,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119839,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fh',NULL,119839,42.18,0.06,2180,53004,65,NULL,'SNLS 03D3bh, MLCS2k2','SDSS J142135.88+523138.9',0.249,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119840,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119840,38.02,0.19,402,53005,70,NULL,NULL,'2MASX J14213598+4442293',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000207,NULL,'16.1g',0.43,'BrClG',NULL,NULL,NULL,NULL,1,215.3997083,44.70806,0,NULL,59230479122,925476236,14460566,16.1),(119841,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119841,38.67,0.46,543,53006,70,NULL,NULL,'2MASX J14213593+0141313',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000103,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,215.3997917,1.69208,0.061,NULL,58297952888,910905513,14232898,17.8),(119842,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119842,36.48,0.19,198,53007,70,NULL,NULL,'2MASX J14213634+6127089',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000177,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,215.401125,61.45253,0.009,NULL,57762342421,902536600,14102134,16.2),(119843,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119843,37.36,0.46,297,53008,70,NULL,NULL,'2MASX J14213636+3940154',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.4015417,39.671,0,NULL,60063050216,938485159,14663830,17.7),(119844,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119844,37.39,0.46,301,53009,70,NULL,NULL,'2MASX J14213636+1718193',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.35',0.15,NULL,NULL,NULL,NULL,NULL,1,215.4017083,17.30547,0,NULL,59488298504,929504664,14523510,18.35),(119845,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119845,37.92,0.16,383,53010,70,NULL,NULL,'2MASX J14213685+4928096',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000177,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,215.403458333,49.46933,0.005,NULL,59246594633,925728041,14464500,16.8),(119846,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119846,38.04,0.19,405,53011,70,NULL,NULL,'SDSS J142137.99+403433.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000166,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,215.4082917,40.57586,0,NULL,59945817742,936653402,14635209,18.5),(119847,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119847,38.02,0.19,402,53012,70,NULL,NULL,'2MASX J14213850+4437063',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,215.4105,44.61844,0,NULL,59230724918,925480076,14460626,17.3),(119848,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119848,38.48,0.33,495,53013,70,NULL,NULL,'2MASX J14213983-0139467',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000177,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,215.415958333,-1.66292,0.133,NULL,43518541168,679977205,10624643,18.4),(119849,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119849,37.46,0.46,310,53014,70,NULL,NULL,'2MASX J14214087+0101243',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000081,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,215.420333,1.02342,0.065,NULL,58285473657,910710525,14229851,17.3),(119850,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119850,36.94,0.27,244,53015,70,NULL,NULL,'MCG +03-37-008',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'16.84',0.17,NULL,NULL,NULL,NULL,NULL,1,215.4239583,17.75236,0,NULL,59486568757,929477636,14523088,16.84),(119851,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119851,37.92,0.16,383,53016,70,NULL,NULL,'2MASX J14214188+4932306',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000159,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,215.424583,49.54192,0.005,NULL,59246601947,925728155,14464502,17.2),(119852,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119852,38.48,0.33,495,53017,70,NULL,NULL,'2MASX J14214209-0141147',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'17.2b',0.26,'BrClG',NULL,NULL,NULL,NULL,1,215.425333333,-1.68736,0.133,NULL,43518538680,679977166,10624643,17.2),(119853,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119853,37.57,0.33,326,53018,70,NULL,NULL,'2MASX J14214253+0414123',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.12',0.23,NULL,NULL,NULL,NULL,NULL,1,215.427375,4.23675,0.045,NULL,58296393260,910881144,14232517,17.12),(119854,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119854,37.29,0.46,287,53019,70,NULL,NULL,'2MASX J14214420+0110223',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000075,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,215.4342083,1.17289,0.065,NULL,58285376840,910709013,14229828,17.2),(119855,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119855,37.92,0.16,383,53020,70,NULL,NULL,'SDSS J142144.49+492854.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000165,NULL,'18.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,215.435375,49.48183,0.005,NULL,59246606138,925728220,14464503,18.6),(119856,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3jq',NULL,119856,42.42,0.04,1930,53021,70,NULL,'SIFTO','[NSB2006] J142145.46+530147.5',0.58,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',NULL,NULL,'20.7R',NULL,'a',NULL,NULL,NULL,NULL,1,215.439375,53.02947,0,NULL,59198394434,924974913,14452733,20.7),(119857,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3jq',NULL,119857,42.59,0.13,2080,53021,70,NULL,'SALT 2','[NSB2006] J142145.46+530147.5',0.58,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119858,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3jq',NULL,119858,42.64,0.15,2130,53021,NULL,NULL,'SIFTO','[NSB2006] J142145.46+530147.5',0.58,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119859,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3jq',NULL,119859,44.41,0.17,4830,53021,NULL,NULL,'SALT2','[NSB2006] J142145.46+530147.5',0.58,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119860,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119860,37.02,0.46,253,53022,70,NULL,NULL,'2MASX J14214663+2528463',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000154,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,215.4445,25.47947,0,NULL,60054260635,938347822,14661684,16.6),(119861,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119861,37.39,0.46,300,53023,70,NULL,NULL,'SDSS J142147.36+423046.6',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000137,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,215.447375,42.51297,0,NULL,59947497340,936679645,14635619,17.8),(119862,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119862,38.13,0.46,423,53024,70,NULL,NULL,'2MASX J14214745+3636214',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,215.447583333,36.606,0,NULL,60031872669,937998010,14656218,17.7),(119863,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119863,37.4,0.15,302,53025,70,NULL,NULL,'2MASX J14214746+3025518',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.80',0.14,NULL,NULL,NULL,NULL,NULL,1,215.44775,30.43089,0,NULL,60061500459,938460944,14663452,18.8),(119864,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119864,38.17,0.46,431,53026,70,NULL,NULL,'2MASX J14214792-0132030',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,215.44975,-1.53425,0.133,NULL,43504632022,679759875,10621248,17.9),(119865,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ci',NULL,119865,42.43,0.15,2020,53027,NULL,NULL,'SIFTO','[NSB2006] J142148.08+522643.3',0.51,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',NULL,NULL,'21.8R',NULL,'a',NULL,NULL,NULL,NULL,1,215.4505417,52.44514,0,NULL,59196048698,924938260,14452160,21.8),(119866,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ci',NULL,119866,43.05,0.07,2690,53027,70,NULL,'SIFTO','[NSB2006] J142148.08+522643.3',0.51,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119867,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ci',NULL,119867,45.11,0.17,6970,53027,NULL,NULL,'SALT2','[NSB2006] J142148.08+522643.3',0.51,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119868,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119868,37.51,0.46,318,53028,70,NULL,NULL,'2MASX J14214866+2042111',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,215.4527083,20.70297,0.016,NULL,59525223249,930081613,14532525,17.8),(119869,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3kx',NULL,119869,39.93,0.03,794,53029,70,NULL,'SIFTO','[NSB2006] J142150.02+530813.4',0.22,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,215.458416667,53.13708,0,NULL,59198403583,924975055,14452735,NULL),(119870,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3kx',NULL,119870,40.16,0.11,884,53029,70,NULL,'SALT 2','[NSB2006] J142150.02+530813.4',0.22,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119871,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3kx',NULL,119871,40.25,0.15,918,53029,NULL,NULL,'SIFTO','[NSB2006] J142150.02+530813.4',0.22,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119872,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3kx',NULL,119872,41.19,0.17,1420,53029,NULL,NULL,'SALT2','[NSB2006] J142150.02+530813.4',0.22,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119873,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119873,37.34,0.46,293,53030,70,NULL,NULL,'2MASX J14215013+2145541',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,215.4587083,21.76508,0.021,NULL,59514337756,929911527,14529867,17.6),(119874,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119874,37.47,0.07,312,53031,70,NULL,NULL,'2MASX J14215011+4827176',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,215.458917,48.45486,0.027,NULL,59248675962,925760561,14465008,18.1),(119875,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119875,36.45,0.46,195,53032,70,NULL,NULL,'2MASX J14215062+0620159',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000178,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,215.461125,6.33764,0.041,NULL,58271558712,910493104,14226454,16.6),(119876,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119876,35.51,0.46,127,53033,70,NULL,NULL,'I Zw 084',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000175,NULL,'15.5g',0.45,'S0/a',NULL,NULL,NULL,NULL,1,215.4619583,46.73019,0.014,NULL,59229373219,925458956,14460296,15.5),(119877,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119877,38.05,0.46,407,53034,70,NULL,NULL,'2MASX J14215111+5633494',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000135,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,215.463125,56.56375,0,NULL,57256667837,894635434,13978678,18.3),(119878,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119878,38.02,0.19,402,53035,70,NULL,NULL,'2MASX J14215121+4430522',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000153,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,215.463333,44.51439,0,NULL,59230728725,925480136,14460627,18.4),(119879,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119879,37.7,0.27,346,53036,70,NULL,NULL,'2MASX J14215173+2058251',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.76',0.29,NULL,NULL,NULL,NULL,NULL,1,215.465541667,20.97347,0.039,NULL,59524856910,930075889,14532435,16.76),(119880,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119880,34.25,0.33,70.8,53037,70,NULL,NULL,'MRK 0678',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000178,NULL,'15.0g',0.41,'Compact',NULL,NULL,NULL,NULL,1,215.46775,23.517,0.041,NULL,59513359325,929896239,14529628,15),(119881,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119881,37.47,0.07,312,53038,70,NULL,NULL,'2MASX J14215359+4840586',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000168,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,215.47325,48.68289,0.038,NULL,59247858420,925747787,14464809,17.8),(119882,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119882,37.7,0.27,346,53039,70,NULL,NULL,'SDSS J142153.62+205730.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.473417,20.95842,0.039,NULL,59524856790,930075887,14532435,18.5),(119883,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119883,36.58,0.44,207,53040,NULL,NULL,'Malmquist cor.','CGCG 019-007',NULL,'2009ApJS..182..474S',2009,1,0.57,NULL,'G',0.000013,NULL,'15.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,215.480417,-0.55658,0.137,NULL,43506241882,679785029,10621641,15.8),(119884,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119884,36.79,0.4,228,53040,NULL,NULL,NULL,'CGCG 019-007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119885,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119885,36.83,0.2,232,53040,74.4,NULL,NULL,'CGCG 019-007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119886,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119886,37.02,0.46,253,53041,70,NULL,NULL,'2MASX J14215581+5248465',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,215.4827917,52.81311,0,NULL,59198270145,924972971,14452702,17.8),(119887,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119887,37.47,0.07,312,53042,70,NULL,NULL,'MCG +08-26-023',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000182,NULL,'16.0g',0.41,NULL,NULL,NULL,NULL,NULL,1,215.489583,48.49836,0.027,NULL,59248559292,925758738,14464980,16),(119888,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119888,37.11,0.46,264,53043,70,NULL,NULL,'2MASX J14215773+4441401',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000163,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,215.490625,44.69444,0,NULL,59230756549,925480571,14460633,16.7),(119889,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119889,36.07,0.59,164,53044,70,NULL,NULL,'2MASX J14215787-1953100',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,215.4912083,-19.88603,0.337,NULL,46571966852,727686982,11370109,15.8),(119890,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119890,34.75,0.49,89.3,53045,75,NULL,'IR','UGC 09199',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000033,NULL,'15.33',0.2,'S?',NULL,NULL,NULL,NULL,1,215.4995417,11.10011,0,NULL,58488895289,913888988,14279515,15.33),(119891,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119891,34.98,0.2,99.1,53045,74.4,NULL,NULL,'UGC 09199',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119892,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119892,35.01,0.38,100,53045,NULL,NULL,'Malmquist cor.','UGC 09199',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119893,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119893,35.01,0.38,101,53045,NULL,NULL,NULL,'UGC 09199',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119894,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119894,35.3,0.4,115,53045,NULL,NULL,'mean','UGC 09199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119895,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119895,35.48,0.47,125,53045,NULL,NULL,'H','UGC 09199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119896,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119896,38,0.33,398,53046,70,NULL,NULL,'2MASX J14220006+1238202',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000191,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,215.500333,12.639,0,NULL,58352142018,911752219,14246128,17),(119897,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119897,37.47,0.07,312,53047,70,NULL,NULL,'2MASX J14220188+4827315',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000202,NULL,'16.3g',0.35,'S0',NULL,NULL,NULL,NULL,1,215.507917,48.45886,0.027,NULL,59248686519,925760726,14465011,16.3),(119898,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119898,35.7,0.61,138,53048,70,NULL,NULL,'2MASX J14220343-1809480',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.72',NULL,'(L)SB0^0',NULL,NULL,NULL,NULL,1,215.514417,-18.16356,0.313,NULL,46545474882,727273045,11363641,15.72),(119899,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3et',NULL,119899,41.28,0.17,1140,53049,NULL,NULL,'SALT2','SNLS 06D3et',0.576,'2010A&A...523A...7G',2010,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,215.519875,52.33836,0,NULL,59196057995,924938406,14452162,NULL),(119900,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3et',NULL,119900,42.6,0.15,2100,53049,NULL,NULL,'SIFTO','SNLS 06D3et',0.576,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119901,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3et',NULL,119901,42.65,0.14,2150,53049,70,NULL,'SALT 2','SNLS 06D3et',0.576,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119902,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3et',NULL,119902,42.79,0.04,2300,53049,70,NULL,'SALT2','SNLS 06D3et',0.576,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119903,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119903,37.7,0.27,346,53050,70,NULL,NULL,'2MASX J14220569+2057280',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.20',0.19,NULL,NULL,NULL,NULL,NULL,1,215.523833,20.95772,0.039,NULL,59524848765,930075761,14532433,18.2),(119904,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119904,37.47,0.07,312,53051,70,NULL,NULL,'2MASX J14220656+4827510',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000159,NULL,'16.9g',0.19,'S0',NULL,NULL,NULL,NULL,1,215.527333333,48.46406,0.027,NULL,59248687055,925760735,14465011,16.9),(119905,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2005ch',NULL,119905,35.27,0.11,110,53052,72,NULL,'z lit','APMUKS(BJ) B141934.25+021314.0',0.026527,'2009ApJ...704..629M',2009,1,0.13,NULL,'G',NULL,NULL,'20.40',0.1,NULL,NULL,NULL,NULL,NULL,1,215.5275,1.99308,0.057,NULL,58298041807,910906903,14232920,20.4),(119906,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2005ch',NULL,119906,35.27,0.41,110,53052,72,NULL,'z lit','APMUKS(BJ) B141934.25+021314.0',0.026527,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119907,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2005ch',NULL,119907,35.27,0.02,110,53052,72,NULL,'z lit','APMUKS(BJ) B141934.25+021314.0',0.026527,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119908,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2005ch',NULL,119908,35.31,0.07,116,53052,72,NULL,'M(H) = -18.317 mag','APMUKS(BJ) B141934.25+021314.0',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119909,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn',NULL,119909,41.56,0.15,1320,53053,74.2,NULL,'SALT 2','[HSP2005] J142206.87+521343.46',0.552,'2010ApJ...716..712A',2010,1,0.06,NULL,'G',0.0003,NULL,'22.0g',0.04,NULL,NULL,NULL,NULL,NULL,1,215.528583,52.22869,0,NULL,59196111012,924939234,14452175,22),(119910,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn',NULL,119910,41.89,0.17,1540,53053,NULL,NULL,'SALT2','[HSP2005] J142206.87+521343.46',0.552,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119911,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn',NULL,119911,41.94,0.14,1570,53053,65,NULL,'MLCS2k2','[HSP2005] J142206.87+521343.46',0.552,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119912,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn','R',119912,41.99,NULL,1610,53053,65,NULL,'MLCS31','[HSP2005] J142206.87+521343.46',0.552,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119913,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn',NULL,119913,42.1,0.1,1700,53053,65,NULL,'SALT2','[HSP2005] J142206.87+521343.46',0.552,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119914,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn',NULL,119914,42.2,0.38,1770,53053,65,NULL,'MLCS31','[HSP2005] J142206.87+521343.46',0.552,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119915,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn',NULL,119915,42.26,0.29,1820,53053,65,NULL,'MLCS17','[HSP2005] J142206.87+521343.46',0.552,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119916,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn',NULL,119916,42.27,0.14,1830,53053,70,NULL,'SALT 2','[HSP2005] J142206.87+521343.46',0.552,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119917,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn',NULL,119917,42.28,0.4,1840,53053,65,NULL,'MLCS2k2','[HSP2005] J142206.87+521343.46',0.552,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119918,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn',NULL,119918,42.31,0.15,1870,53053,NULL,NULL,'SIFTO','[HSP2005] J142206.87+521343.46',0.552,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119919,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn',NULL,119919,42.41,0.15,1950,53053,70,NULL,'SALT','[HSP2005] J142206.87+521343.46',0.552,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119920,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn',NULL,119920,42.43,0.17,1970,53053,65,NULL,'SALT2','[HSP2005] J142206.87+521343.46',0.552,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119921,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn',NULL,119921,42.46,0.04,2000,53053,70,NULL,NULL,'[HSP2005] J142206.87+521343.46',0.552,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119922,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn',NULL,119922,42.53,0.12,2060,53053,65,NULL,'SALT','[HSP2005] J142206.87+521343.46',0.552,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119923,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn',NULL,119923,42.73,0.03,2260,53053,65,NULL,'SALT','[HSP2005] J142206.87+521343.46',0.552,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119924,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn',NULL,119924,43.11,0.04,2690,53053,70,NULL,'SALT 2','[HSP2005] J142206.87+521343.46',0.552,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119925,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119925,37.99,0.33,397,53054,70,NULL,NULL,'2MASX J14220733-0059150',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00015,NULL,'17.2b',0.27,'BrClG',NULL,NULL,NULL,NULL,1,215.530625,-0.98761,0.129,NULL,43506196946,679784327,10621630,17.2),(119926,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119926,37.99,0.33,397,53055,70,NULL,NULL,'SDSS J142207.75-010001.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000075,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,215.5322917,-1.00039,0.109,NULL,43506200064,679784376,10621630,18.6),(119927,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119927,37.47,0.07,312,53056,70,NULL,NULL,'2MASX J14220777+4828060',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,215.532417,48.46847,0.027,NULL,59248686941,925760733,14465011,17.4),(119928,'BCG','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119928,37.38,0.35,279,53057,60,NULL,NULL,'ABELL 1904',0.0719,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III:[BM]',NULL,NULL,NULL,NULL,1,215.5327917,48.55619,0.027,NULL,59248573883,925758966,14464983,NULL),(119929,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119929,38.12,0.33,422,53058,70,NULL,NULL,'2MASX J14220786+1845330',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,215.5329583,18.75917,0,NULL,59518460478,929975944,14530874,17.4),(119930,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119930,37,0.33,251,53059,70,NULL,NULL,'2MASX J14220813+2937250',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000168,NULL,'16.2g',0.32,'E',NULL,NULL,NULL,NULL,1,215.53375,29.62372,0,NULL,60061979164,938468424,14663569,16.2),(119931,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119931,37.47,0.07,312,53060,70,NULL,NULL,'2MASX J14220858+4825560',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,215.535667,48.43211,0.027,NULL,59248688998,925760765,14465011,17.1),(119932,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3mx',NULL,119932,40.69,0.17,937,53061,NULL,NULL,'SALT2','[NSB2006] J142209.07+521309.3',0.47,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'a',NULL,NULL,NULL,NULL,1,215.537833,52.21928,0,NULL,59196097637,924939025,14452172,NULL),(119933,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3mx',NULL,119933,42.17,0.14,1850,53061,70,NULL,'SALT 2','[NSB2006] J142209.07+521309.3',0.47,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119934,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3mx',NULL,119934,42.18,0.15,1860,53061,NULL,NULL,'SIFTO','[NSB2006] J142209.07+521309.3',0.47,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119935,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3mx',NULL,119935,42.31,0.04,1970,53061,70,NULL,'SALT2','[NSB2006] J142209.07+521309.3',0.47,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119936,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119936,36.1,0.46,166,53062,70,NULL,NULL,'2MASX J14220972+0431157',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000099,NULL,'16.0g',0.39,'NLAGN',NULL,NULL,NULL,NULL,1,215.5404583,4.52114,0.045,NULL,58295967261,910874488,14232413,16),(119937,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3jb',NULL,119937,42.93,0.05,2210,53063,70,NULL,'SIFTO','SNLS 05D3jb',0.745,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,215.541667,52.87814,0,NULL,59198268568,924972946,14452702,NULL),(119938,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3jb',NULL,119938,43.32,0.15,2650,53063,NULL,NULL,'SIFTO','SNLS 05D3jb',0.745,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119939,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3jb',NULL,119939,43.35,0.18,2680,53063,70,NULL,'SALT 2','SNLS 05D3jb',0.745,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119940,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3jb',NULL,119940,44.62,0.17,4810,53063,NULL,NULL,'SALT2','SNLS 05D3jb',0.745,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119941,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119941,37.12,0.33,266,53064,70,NULL,NULL,'SDSS J142209.92+045136.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000082,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,215.541375,4.86008,0.021,NULL,58293164657,910830697,14231729,17.5),(119942,'BCG','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119942,37.38,0.35,279,53065,60,NULL,'ABELL 1904, BCG','MCG +08-26-024',0.0719,'1980ApJ...241..486H',1980,1,0.81,NULL,'G',0.000237,NULL,'15.2g',0.57,'BrClG','Brightest group member',NULL,NULL,NULL,1,215.5425,48.57072,0.027,NULL,59248573808,925758965,14464983,15.2),(119943,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119943,37.47,0.07,312,53065,70,NULL,NULL,'MCG +08-26-024',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119944,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119944,38.06,0.46,410,53066,70,NULL,NULL,'SDSS J142210.49+083027.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000146,NULL,'18.5g',0.09,NULL,NULL,NULL,NULL,NULL,1,215.5437083,8.50778,0.033,NULL,58273690440,910526413,14226975,18.5),(119945,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119945,36.65,0.46,214,53067,70,NULL,NULL,'2MASX J14221066+4223022',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,215.544417,42.38392,0,NULL,59947536933,936680264,14635629,16.8),(119946,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119946,37.91,0.46,382,53068,70,NULL,NULL,'2MASX J14221173+0716169',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000141,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,215.549041667,7.27128,0.029,NULL,58274889816,910545153,14227268,17.8),(119947,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119947,36.37,0.46,188,53069,70,NULL,NULL,'2MASX J14221204+1702175',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.05',0.19,NULL,NULL,NULL,NULL,NULL,1,215.550167,17.03819,0,NULL,59488311515,929504867,14523513,17.05),(119948,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3lr',NULL,119948,42.67,0.17,2140,53070,70,NULL,'SALT 2','SNLS 05D3lr',0.6,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,215.550583333,53.18428,0,NULL,59198398978,924974984,14452734,NULL),(119949,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3lr',NULL,119949,42.79,0.15,2260,53070,NULL,NULL,'SIFTO','SNLS 05D3lr',0.6,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119950,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3lr',NULL,119950,43.15,0.17,2670,53070,NULL,NULL,'SALT2','SNLS 05D3lr',0.6,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119951,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3lr',NULL,119951,43.34,0.05,2910,53070,70,NULL,'SIFTO','SNLS 05D3lr',0.6,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119952,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119952,37.48,0.46,314,53071,70,NULL,NULL,'2MASX J14221322+1051074',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.54',0.14,NULL,NULL,NULL,NULL,NULL,1,215.5550417,10.85217,0,NULL,58489000100,913890626,14279541,18.54),(119953,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119953,37.07,0.46,260,53072,70,NULL,NULL,'LCRS B141937.7-024721',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000133,NULL,'16.8b',0.29,NULL,NULL,NULL,NULL,NULL,1,215.555791667,-3.01636,0.149,NULL,43518304104,679973501,10624585,16.8),(119954,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119954,38,0.33,398,53073,70,NULL,NULL,'SDSS J142214.52+124046.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000169,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,215.5605,12.67964,0,NULL,58352122075,911751907,14246123,18.6),(119955,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119955,37.35,0.33,295,53074,70,NULL,NULL,'2MASX J14221519+3038186',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.13',0.2,NULL,NULL,NULL,NULL,NULL,1,215.563333,30.63856,0,NULL,60061009246,938453269,14663332,18.13),(119956,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119956,37.29,0.67,287,53075,70,NULL,NULL,'2MASX J14221524-3458422',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.4,NULL,NULL,NULL,NULL,NULL,1,215.5635,-34.97839,0.189,NULL,47008157861,734502466,11476601,14.4),(119957,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119957,36.94,0.27,244,53076,70,NULL,NULL,'2MASX J14221552+1750036',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.25',0.14,NULL,NULL,NULL,NULL,NULL,1,215.564625,17.83422,0,NULL,59487889193,929498268,14523410,18.25),(119958,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119958,37.47,0.07,312,53077,70,NULL,NULL,'2MASX J14221570+4833441',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000182,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,215.5654583,48.56228,0.027,NULL,59248570895,925758920,14464983,17.9),(119959,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119959,38.12,0.33,422,53078,70,NULL,NULL,'2MASX J14221624+1842300',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.567917,18.70847,0,NULL,59518271514,929972992,14530828,17.4),(119960,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119960,37.4,0.15,302,53079,70,NULL,NULL,'2MASX J14221656+3020106',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.71',0.14,NULL,NULL,NULL,NULL,NULL,1,215.569125,30.33622,0,NULL,60061618253,938462785,14663481,18.71),(119961,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119961,36.55,0.33,204,53080,70,NULL,NULL,'2MASXi J1422166+263158',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000176,NULL,'17.3g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.569333333,26.53306,0,NULL,60054893302,938357707,14661839,17.3),(119962,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119962,38.25,0.46,446,53081,70,NULL,NULL,'2MASX J14221691+2203090',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.17',0.19,NULL,NULL,NULL,NULL,NULL,1,215.5705417,22.05258,0.022,NULL,59514309835,929911091,14529860,18.17),(119963,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3df',NULL,119963,41.79,0.03,1580,53082,70,NULL,'SIFTO','SNLS 06D3df',0.442,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,215.571708333,52.95769,0,NULL,59198242050,924972532,14452695,NULL),(119964,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3df',NULL,119964,41.98,0.12,1720,53082,70,NULL,'SALT 2','SNLS 06D3df',0.442,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119965,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3df',NULL,119965,41.99,0.15,1730,53082,NULL,NULL,'SIFTO','SNLS 06D3df',0.442,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119966,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3df',NULL,119966,43.43,0.17,3370,53082,NULL,NULL,'SALT2','SNLS 06D3df',0.442,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119967,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119967,37.47,0.07,312,53083,70,NULL,NULL,'2MASX J14221731+4832441',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000177,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,215.5722917,48.54567,0.027,NULL,59248564783,925758824,14464981,16.6),(119968,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119968,37.84,0.46,369,53084,70,NULL,NULL,'2MASX J14221770+2215020',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.16',0.19,NULL,NULL,NULL,NULL,NULL,1,215.573875,22.25047,0.033,NULL,59516287643,929941994,14530343,18.16),(119969,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119969,37.17,0.46,272,53085,70,NULL,NULL,'SDSS J142218.35+505111.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000165,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,215.5764583,50.85308,0.005,NULL,59195264151,924926002,14451968,18.2),(119970,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119970,37.33,0.46,293,53086,70,NULL,NULL,'2MASX J14221910+1747516',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.05',0.18,NULL,NULL,NULL,NULL,NULL,1,215.5795417,17.79767,0,NULL,59487895113,929498361,14523411,18.05),(119971,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119971,37.35,0.33,295,53087,70,NULL,NULL,'2MASX J14221957+3038282',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',NULL,NULL,'16.88',0.21,NULL,NULL,NULL,NULL,NULL,1,215.581625,30.64122,0,NULL,60061009569,938453274,14663332,16.88),(119972,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119972,36.21,0.46,174,53088,70,NULL,NULL,'2MASX J14221965+5148391',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,215.582,51.81094,0.005,NULL,59196250980,924941421,14452209,17.3),(119973,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119973,37.3,0.46,289,53089,70,NULL,NULL,'2MASX J14221967+3128132',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.01',0.19,NULL,NULL,NULL,NULL,NULL,1,215.582125,31.47039,0,NULL,60047098330,938235911,14659936,18.01),(119974,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119974,37.3,0.46,289,53090,70,NULL,NULL,'2MASX J14222181+1758336',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.79',0.12,NULL,NULL,NULL,NULL,NULL,1,215.590917,17.97603,0,NULL,59485876024,929466812,14522918,17.79),(119975,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119975,37.47,0.07,312,53091,70,NULL,NULL,'SDSS J142221.91+483205.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,215.5912917,48.53486,0.027,NULL,59248565313,925758833,14464981,18.3),(119976,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3lc',NULL,119976,41.58,0.17,1420,53092,NULL,NULL,'SALT2','SNLS 05D3lc',0.461,'2010A&A...523A...7G',2010,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,215.5955,52.47886,0,NULL,59195603823,924931309,14452051,NULL),(119977,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3lc',NULL,119977,42.11,0.11,1810,53092,70,NULL,'SALT 2','SNLS 05D3lc',0.461,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119978,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3lc',NULL,119978,42.12,0.15,1820,53092,NULL,NULL,'SIFTO','SNLS 05D3lc',0.461,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119979,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3lc',NULL,119979,42.25,0.03,1930,53092,70,NULL,'SALT2','SNLS 05D3lc',0.461,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119980,'Cepheids','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119980,31.71,0.04,22,53093,NULL,NULL,'V, I, NIR (W), 78, Syst. +/- 0.32 mag','NGC 5584',NULL,'2013MNRAS.434.2866F',2013,1,2.45,'The APM image refers to part of the galaxy east of the nucleus.','G',0.000013,NULL,'13.3g',1.63,'SAB(rs)cd','Isolated galaxy',NULL,NULL,NULL,1,215.5990417,-0.38767,0.145,NULL,43506417829,679787778,10621684,13.3),(119981,'Cepheids','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119981,31.72,0.07,22.1,53093,NULL,NULL,'SNIa calibrated','NGC 5584',NULL,'2011ApJ...730..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119982,'Cepheids','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119982,31.76,0.07,22.5,53093,74.4,NULL,NULL,'NGC 5584',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119983,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2007af',NULL,119983,31.34,0.37,18.4,53093,74.2,NULL,'SALT 2','NGC 5584',0.005464,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119984,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2007af',NULL,119984,31.72,0.07,22.1,53093,NULL,NULL,'MLCS2k2, Cepheids calibrated','NGC 5584',NULL,'2011ApJ...730..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119985,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2007af',NULL,119985,31.76,0.07,22.5,53093,74.4,NULL,NULL,'NGC 5584',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119986,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2007af',NULL,119986,31.9,NULL,24,53093,72,NULL,'Malmquist cor.','NGC 5584',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119987,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2007af',NULL,119987,31.93,0.01,24.3,53093,72,NULL,'M(H) = -18.317 mag','NGC 5584',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119988,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2007af',NULL,119988,32.29,0.1,28.6,53093,72,NULL,'MLCS2k2, R(V) = 3.1','NGC 5584',0.005464,'2010ApJ...721.1608B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119989,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2007af',NULL,119989,32.3,0.08,28.7,53093,72,NULL,'MLCS2k2, R(V) = 1.7','NGC 5584',0.005464,'2010ApJ...721.1608B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119990,'TRGB','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119990,31.76,0.04,22.5,53093,NULL,NULL,'I','NGC 5584',NULL,'2015ApJ...807..133J',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119991,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119991,30.69,0.69,13.7,53093,100,NULL,'mid-IR','NGC 5584',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119992,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119992,31.28,0.43,18,53093,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5584',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119993,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119993,31.29,0.43,18.1,53093,75,NULL,'3.6 micron, color corrected','NGC 5584',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119994,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119994,31.36,0.4,18.7,53093,75,NULL,'HOSTS SN 2007af','NGC 5584',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119995,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119995,31.36,0.4,18.7,53093,75,NULL,'HOSTS SN 2007af','NGC 5584',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119996,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119996,31.41,0.42,19.1,53093,NULL,18.48,'3.6 micron','NGC 5584',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119997,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119997,31.48,0.52,19.7,53093,NULL,NULL,'Malmquist cor.','NGC 5584',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119998,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119998,31.59,0.49,20.8,53093,NULL,NULL,NULL,'NGC 5584',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119999,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119999,31.76,0.07,22.5,53093,74.4,NULL,NULL,'NGC 5584',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120000,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120000,32.12,0.4,26.5,53093,NULL,NULL,'mean','NGC 5584',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120001,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120001,32.19,0.4,27.4,53093,75,NULL,'B','NGC 5584',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120002,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120002,32.5,0.47,31.7,53093,NULL,NULL,'H','NGC 5584',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120003,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120003,32.66,0.45,34,53093,NULL,NULL,'K','NGC 5584',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120004,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120004,32.67,0.46,34.3,53093,NULL,NULL,'J','NGC 5584',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120005,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',120005,37.49,0.46,315,53094,70,NULL,NULL,'2MASX J14222401+6431110',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000089,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,215.600417,64.51961,0.041,NULL,57947446496,905428851,14147325,16.9),(120006,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120006,33.66,0.48,53.8,53095,70,NULL,NULL,'ESO 385- G 015',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000047,NULL,'13.84',0.7,'(R\')SA:(r)b','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,215.60575,-34.36539,0.237,NULL,47008979983,734515312,11476801,13.84),(120007,'IRAS','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120007,33.69,0.8,54.7,53095,75,NULL,'HMCL, I','ESO 385- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120008,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120008,32.9,0.4,38,53095,75,NULL,'HMCL, I, raw','ESO 385- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120009,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120009,33.05,0.4,40.7,53095,75,NULL,'HMCL, I, inv','ESO 385- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120010,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120010,33.18,0.4,43.2,53095,75,NULL,'HMCL, I, cor','ESO 385- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120011,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120011,33.41,0.47,48.1,53095,NULL,NULL,'H','ESO 385- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120012,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120012,33.52,0.46,50.6,53095,NULL,NULL,'J','ESO 385- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120013,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120013,33.54,0.45,51,53095,NULL,NULL,'K','ESO 385- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120014,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120014,33.7,0.4,55.1,53095,NULL,NULL,'mean','ESO 385- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120015,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120015,33.75,0.2,56.2,53095,74.4,NULL,NULL,'ESO 385- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120016,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',120016,37.57,0.33,326,53096,70,NULL,NULL,'2MASX J14222595+0407387',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000114,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,215.608083,4.12744,0.045,NULL,58296585039,910884141,14232564,16.9),(120017,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',120017,38.02,0.19,402,53097,70,NULL,NULL,'2MASX J14222601+4443152',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'17.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,215.608333,44.72083,0,NULL,59230759652,925480619,14460634,17.8),(120018,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',120018,37.47,0.07,312,53098,70,NULL,NULL,'2MASX J14222623+4752552',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.609208333,47.88197,0.006,NULL,59248155917,925752436,14464881,17.6),(120019,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120019,40.63,0.14,997,53099,74.2,NULL,'SALT 2','[HSP2005] J142226.72+522000.92',0.34,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.0002,NULL,'22.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,215.611083,52.33339,0,NULL,59196101564,924939086,14452173,22.6),(120020,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh','R',120020,40.69,NULL,1030,53099,65,NULL,'SALT','[HSP2005] J142226.72+522000.92',0.34,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120021,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120021,41.26,0.12,1330,53099,70,NULL,'SALT','[HSP2005] J142226.72+522000.92',0.34,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120022,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120022,41.3,0.03,1360,53099,70,NULL,'SALT 2','[HSP2005] J142226.72+522000.92',0.34,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120023,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120023,41.32,0.01,1370,53099,70,NULL,NULL,'[HSP2005] J142226.72+522000.92',0.34,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120024,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120024,41.36,0.11,1400,53099,70,NULL,'SALT 2','[HSP2005] J142226.72+522000.92',0.34,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120025,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120025,41.39,0.07,1410,53099,65,NULL,'SALT2','[HSP2005] J142226.72+522000.92',0.34,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120026,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120026,41.4,0.15,1420,53099,NULL,NULL,'SIFTO','[HSP2005] J142226.72+522000.92',0.34,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120027,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120027,41.41,0.09,1430,53099,65,NULL,'SALT','[HSP2005] J142226.72+522000.92',0.34,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120028,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120028,41.41,NULL,1430,53099,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','[HSP2005] J142226.72+522000.92',0.34,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120029,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120029,41.49,0.16,1480,53099,65,NULL,'SALT2','[HSP2005] J142226.72+522000.92',0.34,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120030,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120030,41.54,0.08,1510,53099,65,NULL,'MLCS2k2','[HSP2005] J142226.72+522000.92',0.34,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120031,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120031,41.57,0.15,1530,53099,65,NULL,'MLCS17','[HSP2005] J142226.72+522000.92',0.34,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120032,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120032,41.6,0.01,1560,53099,65,NULL,'SALT','[HSP2005] J142226.72+522000.92',0.34,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120033,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120033,41.61,0.16,1570,53099,65,NULL,'MLCS31','[HSP2005] J142226.72+522000.92',0.34,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120034,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120034,41.64,0.14,1580,53099,65,NULL,'MLCS2k2','[HSP2005] J142226.72+522000.92',0.34,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120035,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120035,42.2,0.17,2060,53099,NULL,NULL,'SALT2','[HSP2005] J142226.72+522000.92',0.34,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120036,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',120036,38.46,0.46,492,53100,70,NULL,NULL,'2MASX J14222730+4553302',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000172,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,215.613917,45.89183,0,NULL,59231909773,925498590,14460915,18),(120037,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120037,31.01,0.43,16,53101,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09206',NULL,'2014MNRAS.444..527S',2014,1,0.7,NULL,'G',0.000005,NULL,'14.9',0.4,'Pec','Group member',NULL,NULL,NULL,1,215.6140417,15.08683,0,NULL,59478100626,929345322,14521020,14.9),(120038,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',120038,34.11,0.33,66.5,53102,70,NULL,NULL,'NGC 5598',NULL,'2015arXiv151105856S',2015,1,1.24,NULL,'G',0.000103,NULL,'13.7g',0.85,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,215.617833333,40.31981,0,NULL,59945462497,936647851,14635122,13.7),(120039,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120039,34.57,0.4,82,53102,NULL,NULL,'mean','NGC 5598',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120040,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120040,34.73,0.45,88.2,53102,NULL,NULL,'K','NGC 5598',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120041,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',120041,38.42,0.46,482,53103,70,NULL,NULL,'2MASX J14222842+0445077',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000094,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,215.6185,4.75203,0.053,NULL,58293183167,910830986,14231734,17.2),(120042,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',120042,33.63,0.46,53.2,53104,70,NULL,NULL,'NGC 5596',NULL,'2015arXiv151105856S',2015,1,1.13,NULL,'G',0.000043,NULL,'14.0g',0.74,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,215.61975,37.12219,0,NULL,60031416406,937990881,14656107,14),(120043,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120043,33.43,0.4,48.5,53104,NULL,NULL,'mean','NGC 5596',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120044,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120044,34.09,0.45,65.8,53104,NULL,NULL,'K','NGC 5596',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120045,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',120045,37.11,0.46,265,53105,70,NULL,NULL,'2MASX J14222923+4039313',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000166,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,215.621833333,40.65886,0,NULL,59945327774,936645746,14635089,16.3),(120046,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',120046,36.66,0.23,215,53106,70,NULL,NULL,'SDSS J142230.16+285804.3',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000187,NULL,'15.6g',0.41,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.625667,28.96786,0,NULL,60059856890,938435263,14663050,15.6),(120047,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',120047,37.47,0.07,312,53107,70,NULL,NULL,'2MASX J14223041+4836331',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000176,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.626417,48.60925,0.039,NULL,59248593137,925759267,14464988,17.4),(120048,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3dd',NULL,120048,42.12,0.11,1800,53108,70,NULL,'SALT 2','[NSB2006] J142230.41+523624.7',0.48,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,215.6267083,52.60689,0,NULL,59197504353,924961005,14452515,NULL),(120049,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3dd',NULL,120049,42.12,0.04,1800,53108,70,NULL,'SALT2','[NSB2006] J142230.41+523624.7',0.48,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120050,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3dd',NULL,120050,42.12,0.17,1800,53108,NULL,NULL,'SALT2','[NSB2006] J142230.41+523624.7',0.48,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120051,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 05D3dd',NULL,120051,42.18,0.15,1850,53108,NULL,NULL,'SIFTO','[NSB2006] J142230.41+523624.7',0.48,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120052,'FP','2016-12-15 15:15:24','2016-12-16 11:20:38','1',NULL,'R',120052,34.93,0.46,96.7,53109,70,NULL,NULL,'CGCG 075-021',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00016,NULL,'14.8g',0.45,NULL,NULL,NULL,NULL,NULL,1,215.62825,11.30489,0,NULL,58486075195,913844924,14278826,14.8),(120053,'FP','2016-12-15 15:15:24','2016-12-16 11:20:38','1',NULL,'R',120053,37.29,0.33,287,53110,70,NULL,NULL,'2MASX J14223184+2312067',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000192,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,215.6327917,23.20189,0.043,NULL,59516791062,929949860,14530466,17),(120054,'FP','2016-12-15 15:15:24','2016-12-16 11:20:38','1',NULL,'R',120054,37.7,0.46,347,53111,70,NULL,NULL,'2MASX J14223199+2826079',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00018,NULL,'18.20',0.13,NULL,NULL,NULL,NULL,NULL,1,215.633333,28.43542,0,NULL,60055376968,938365265,14661957,18.2),(120055,'FP','2016-12-15 15:15:24','2016-12-16 11:20:38','1',NULL,'R',120055,36.68,0.46,217,53112,70,NULL,NULL,'SDSS J142232.07+121748.5',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,215.633625,12.29681,0,NULL,58351346954,911739796,14245934,17.5),(120056,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:38','1',NULL,NULL,120056,30.84,0.4,14.7,53113,75,NULL,'B','UGC 09211',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000003,NULL,'15.0',1.4,'Im:',NULL,NULL,NULL,NULL,1,215.6340417,45.38386,0,NULL,59230989903,925484217,14460690,15),(120057,'FP','2016-12-15 15:15:24','2016-12-16 11:20:38','1',NULL,'R',120057,37.92,0.46,383,53114,70,NULL,NULL,'2MASX J14223225+2629179',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000143,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.634333,26.48833,0,NULL,60054886644,938357603,14661837,18),(120058,'FP','2016-12-15 15:15:24','2016-12-16 11:20:38','1',NULL,'R',120058,38.23,0.46,442,53115,70,NULL,NULL,'SDSS J142232.35+143003.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.634833,14.50111,0,NULL,59479297781,929364027,14521312,18.4),(120059,'FP','2016-12-15 15:15:24','2016-12-16 11:20:38','1',NULL,'R',120059,34.61,0.33,83.5,53116,70,NULL,NULL,'CGCG 220-008',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000173,NULL,'15.2g',0.45,'E0',NULL,NULL,NULL,NULL,1,215.635291667,39.58494,0,NULL,60063163865,938486935,14663858,15.2),(120060,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt',NULL,120060,41.07,0.14,1130,53117,74.2,NULL,'SALT 2','[AGR2006] J142232.61+523849.3',0.451,'2010ApJ...716..712A',2010,1,0.11,NULL,'G',0.001,NULL,'22.0g',0.06,NULL,NULL,NULL,NULL,NULL,1,215.63575,52.64697,0,NULL,59197505509,924961023,14452515,22),(120061,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt',NULL,120061,41.35,0.21,1280,53117,65,NULL,'MLCS2k2','[AGR2006] J142232.61+523849.3',0.451,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120062,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt',NULL,120062,41.34,0.23,1280,53117,65,NULL,'MLCS31','[AGR2006] J142232.61+523849.3',0.451,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120063,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt',NULL,120063,41.65,0.17,1470,53117,NULL,NULL,'SALT2','[AGR2006] J142232.61+523849.3',0.451,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120064,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt',NULL,120064,41.66,0.1,1480,53117,65,NULL,'MLCS2k2','[AGR2006] J142232.61+523849.3',0.451,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120065,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt',NULL,120065,41.7,0.12,1510,53117,70,NULL,'SALT 2','[AGR2006] J142232.61+523849.3',0.451,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120066,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt',NULL,120066,41.71,0.15,1510,53117,NULL,NULL,'SIFTO','[AGR2006] J142232.61+523849.3',0.451,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120067,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt',NULL,120067,41.75,0.08,1540,53117,65,NULL,'SALT2','[AGR2006] J142232.61+523849.3',0.451,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120068,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt',NULL,120068,41.8,0.17,1580,53117,65,NULL,'MLCS17','[AGR2006] J142232.61+523849.3',0.451,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120069,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt',NULL,120069,41.85,0.14,1620,53117,70,NULL,'SALT','[AGR2006] J142232.61+523849.3',0.451,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120070,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt','R',120070,41.87,NULL,1630,53117,65,NULL,'MLCS31','[AGR2006] J142232.61+523849.3',0.451,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120071,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt',NULL,120071,41.91,0.11,1660,53117,65,NULL,'SALT','[AGR2006] J142232.61+523849.3',0.451,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120072,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt',NULL,120072,41.92,0.17,1670,53117,65,NULL,'SALT2','[AGR2006] J142232.61+523849.3',0.451,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120073,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt',NULL,120073,42.04,0.03,1760,53117,70,NULL,NULL,'[AGR2006] J142232.61+523849.3',0.451,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120074,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt',NULL,120074,42.3,0.03,1990,53117,65,NULL,'SALT','[AGR2006] J142232.61+523849.3',0.451,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120075,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt',NULL,120075,43.21,0.03,3020,53117,70,NULL,'SALT 2','[AGR2006] J142232.61+523849.3',0.451,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120076,'SNII optical','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SN 2003ga',NULL,120076,41.22,0.79,1050,53118,NULL,NULL,'SEAM','LSSP J142233.04+522253.9',0.29,'2009ApJ...694.1067P',2009,1,NULL,NULL,'G',NULL,NULL,'23.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,215.637666667,52.38164,0,NULL,59195593307,924931145,14452049,23),(120077,'SNII optical','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SN 2003ga',NULL,120077,41.1,0.4,1660,53118,NULL,NULL,'SNLS 03D3ce','LSSP J142233.04+522253.9',NULL,'2006ApJ...645..841N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120078,'FP','2016-12-15 15:15:24','2016-12-16 11:20:38','1',NULL,'R',120078,36.28,0.46,181,53119,70,NULL,NULL,'2MASX J14223306+3333042',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000162,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,215.63775,33.55133,0,NULL,60040017161,938125268,14658207,16.6),(120079,'FP','2016-12-15 15:15:24','2016-12-16 11:20:38','1',NULL,'R',120079,37.47,0.07,312,53120,70,NULL,NULL,'2MASX J14223317+4817221',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,215.638583,48.28947,0.027,NULL,59248731691,925761432,14465022,17.7),(120080,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3ks','R',120080,42.2,NULL,1570,53121,65,NULL,'SALT','[AGR2006] J142233.47+521107.4',0.752,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,215.6395,52.18539,0,NULL,59196096220,924939003,14452171,NULL),(120081,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3ks',NULL,120081,42.61,0.21,1900,53121,74.2,NULL,'SALT 2','[AGR2006] J142233.47+521107.4',0.752,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120082,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3ks',NULL,120082,42.87,0.06,2140,53121,70,NULL,'SALT','[AGR2006] J142233.47+521107.4',0.752,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120083,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3ks',NULL,120083,43.14,0.18,2420,53121,70,NULL,'SALT','[AGR2006] J142233.47+521107.4',0.752,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120084,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3ks',NULL,120084,43.17,0.09,2460,53121,70,NULL,NULL,'[AGR2006] J142233.47+521107.4',0.752,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120085,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3ks',NULL,120085,43.2,0.23,2490,53121,70,NULL,'SALT 2','[AGR2006] J142233.47+521107.4',0.752,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120086,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3ks',NULL,120086,43.26,0.15,2560,53121,NULL,NULL,'SIFTO','[AGR2006] J142233.47+521107.4',0.752,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120087,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3ks',NULL,120087,43.31,0.15,2610,53121,65,NULL,'SALT','[AGR2006] J142233.47+521107.4',0.752,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120088,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3ks',NULL,120088,43.3,0.23,2610,53121,65,NULL,'MLCS2k2','[AGR2006] J142233.47+521107.4',0.752,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120089,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3ks',NULL,120089,43.32,0.24,2640,53121,65,NULL,'MLCS17','[AGR2006] J142233.47+521107.4',0.752,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120090,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3ks',NULL,120090,43.36,0.21,2680,53121,65,NULL,'MLCS2k2','[AGR2006] J142233.47+521107.4',0.752,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120091,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3ks',NULL,120091,43.36,0.22,2680,53121,65,NULL,'MLCS31','[AGR2006] J142233.47+521107.4',0.752,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120092,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3ks',NULL,120092,43.44,0.08,2780,53121,65,NULL,'SALT','[AGR2006] J142233.47+521107.4',0.752,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120093,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3ks',NULL,120093,43.44,0.18,2780,53121,65,NULL,'SALT2','[AGR2006] J142233.47+521107.4',0.752,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120094,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3ks',NULL,120094,43.48,0.21,2830,53121,65,NULL,'SALT2','[AGR2006] J142233.47+521107.4',0.752,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120095,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3ks',NULL,120095,44.06,0.17,3700,53121,NULL,NULL,'SALT2','[AGR2006] J142233.47+521107.4',0.752,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120096,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120096,37.47,0.07,312,53122,70,NULL,NULL,'2MASX J14223480+4755080',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000197,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,215.645041667,47.91894,0.006,NULL,59248154831,925752419,14464881,17.1),(120097,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120097,37.8,0.46,363,53123,70,NULL,NULL,'2MASX J14223494+1050555',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.52',0.13,NULL,NULL,NULL,NULL,NULL,1,215.645667,10.84867,0,NULL,58488834938,913888045,14279500,18.52),(120098,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120098,36.66,0.23,215,53124,70,NULL,NULL,'2MASX J14223518+2848149',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000264,NULL,'16.3g',0.33,'S0',NULL,NULL,NULL,NULL,1,215.6465,28.80411,0,NULL,60059838522,938434976,14663046,16.3),(120099,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120099,38.19,0.46,435,53125,70,NULL,NULL,'2MASX J14223539+2758349',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,215.6475417,27.97622,0,NULL,60057372832,938396450,14662444,18),(120100,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120100,36.08,0.74,164,53126,70,NULL,NULL,'2MASX J14223556-3317226',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.2b',0.3,'Sp',NULL,NULL,NULL,NULL,1,215.648166667,-33.28956,0.265,NULL,46999201100,734362517,11474414,16.2),(120101,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120101,37.47,0.07,312,53127,70,NULL,NULL,'2MASX J14223646+4835180',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000192,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,215.652083,48.58836,0.039,NULL,59248593359,925759271,14464988,16.5),(120102,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120102,37.31,0.33,290,53128,70,NULL,NULL,'2MASX J14223701+2013437',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.12',0.17,NULL,NULL,NULL,NULL,NULL,1,215.654125,20.22886,0,NULL,59525165586,930080712,14532511,17.12),(120103,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120103,37.31,0.33,290,53129,70,NULL,NULL,'SDSS J142237.78+201604.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.6575,20.26783,0,NULL,59525168859,930080763,14532511,17.7),(120104,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 05D3km',NULL,120104,43.56,0.08,2620,53130,70,NULL,'SIFTO','SNLS 05D3km HOST',0.97,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'a',NULL,NULL,NULL,NULL,1,215.659583,53.06697,0,NULL,59198343729,924974120,14452720,NULL),(120105,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 05D3km',NULL,120105,44.36,0.21,3780,53130,70,NULL,'SALT 2','SNLS 05D3km HOST',0.97,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120106,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 05D3km',NULL,120106,44.44,0.15,3920,53130,NULL,NULL,'SIFTO','SNLS 05D3km HOST',0.97,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120107,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 05D3km',NULL,120107,45.11,0.17,5350,53130,NULL,NULL,'SALT2','SNLS 05D3km HOST',0.97,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120108,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr','R',120108,42.79,NULL,1850,53131,65,NULL,'SALT2','[HSP2005] J142238.52+523855.89',0.96,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.02,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,215.6605417,52.64886,0,NULL,59197504837,924961013,14452515,NULL),(120109,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr',NULL,120109,42.89,0.28,1930,53131,74.2,NULL,'SALT 2','[HSP2005] J142238.52+523855.89',0.96,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120110,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr',NULL,120110,43.59,0.43,2670,53131,70,NULL,'SALT','[HSP2005] J142238.52+523855.89',0.96,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120111,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr',NULL,120111,43.62,0.23,2710,53131,70,NULL,NULL,'[HSP2005] J142238.52+523855.89',0.96,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120112,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr',NULL,120112,43.66,0.28,2750,53131,65,NULL,'SALT2','[HSP2005] J142238.52+523855.89',0.96,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120113,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr',NULL,120113,43.7,0.25,2810,53131,70,NULL,'SALT 2','[HSP2005] J142238.52+523855.89',0.96,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120114,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr',NULL,120114,43.71,0.34,2810,53131,65,NULL,'SALT2','[HSP2005] J142238.52+523855.89',0.96,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120115,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr',NULL,120115,43.72,0.15,2830,53131,NULL,NULL,'SIFTO','[HSP2005] J142238.52+523855.89',0.96,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120116,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr',NULL,120116,43.72,0.4,2830,53131,65,NULL,'SALT','[HSP2005] J142238.52+523855.89',0.96,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120117,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr',NULL,120117,43.83,0.08,2970,53131,70,NULL,'SALT2','[HSP2005] J142238.52+523855.89',0.96,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120118,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr',NULL,120118,43.89,0.17,3060,53131,65,NULL,'SALT','[HSP2005] J142238.52+523855.89',0.96,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120119,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr',NULL,120119,43.9,0.28,3070,53131,65,NULL,'MLCS2k2','[HSP2005] J142238.52+523855.89',0.96,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120120,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr',NULL,120120,44.22,0.17,3560,53131,NULL,NULL,'SALT2','[HSP2005] J142238.52+523855.89',0.96,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120121,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr',NULL,120121,44.29,0.13,3680,53131,65,NULL,'MLCS2k2','[HSP2005] J142238.52+523855.89',0.96,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120122,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr',NULL,120122,44.29,0.22,3680,53131,65,NULL,'MLCS17','[HSP2005] J142238.52+523855.89',0.96,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120123,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr',NULL,120123,44.34,0.18,3770,53131,65,NULL,'MLCS31','[HSP2005] J142238.52+523855.89',0.96,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120124,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120124,38.26,0.46,449,53132,70,NULL,NULL,'2MASX J14224086+4629161',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.670333,46.48789,0.01,NULL,59231686783,925495105,14460861,18),(120125,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120125,36.66,0.23,215,53133,70,NULL,NULL,'2MASX J14224096+2851238',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'16.76',0.28,'S0',NULL,NULL,NULL,NULL,1,215.670583333,28.85669,0,NULL,60059833952,938434905,14663045,16.76),(120126,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120126,37.12,0.33,266,53134,70,NULL,NULL,'2MASX J14224153+0424207',NULL,'2015arXiv151105856S',2015,1,0.62,'Two MAPS entries for the same object.','G',0.00014,NULL,'15.5g',0.5,'E0',NULL,NULL,NULL,NULL,1,215.6732083,4.40581,0.049,NULL,58295951528,910874242,14232410,15.5),(120127,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 05D3gp',NULL,120127,42.33,0.17,1850,53135,NULL,NULL,'SALT2','[NSB2006] J142242.33+524328.7',0.58,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',NULL,NULL,'23.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,215.676167,52.72442,0,NULL,59197499884,924960935,14452514,23.7),(120128,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 05D3gp',NULL,120128,42.64,0.06,2130,53135,70,NULL,'SALT2','[NSB2006] J142242.33+524328.7',0.58,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120129,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 05D3gp',NULL,120129,42.79,0.17,2280,53135,70,NULL,'SALT 2','[NSB2006] J142242.33+524328.7',0.58,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120130,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 05D3gp',NULL,120130,42.82,0.15,2320,53135,NULL,NULL,'SIFTO','[NSB2006] J142242.33+524328.7',0.58,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120131,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120131,37.47,0.07,312,53136,70,NULL,NULL,'2MASX J14224339+4833180',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000184,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,215.680667,48.555,0.039,NULL,59248591561,925759243,14464988,16.7),(120132,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120132,36.49,0.46,199,53137,70,NULL,NULL,'2MASX J14224345+3049582',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.53',0.3,NULL,NULL,NULL,NULL,NULL,1,215.68125,30.83294,0,NULL,60061108600,938454821,14663356,16.53),(120133,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120133,36.73,0.46,222,53138,70,NULL,NULL,'2MASX J14224384+2526448',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000167,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,215.6827917,25.44567,0,NULL,60054291360,938348302,14661692,16.5),(120134,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120134,37.85,0.33,372,53139,70,NULL,NULL,'2MASX J14224558+1702525',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,215.689833333,17.04792,0,NULL,59488191737,929502995,14523484,17.9),(120135,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120135,38.04,0.23,406,53140,70,NULL,NULL,'2MASX J14224593+5639532',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,215.69125,56.66469,0,NULL,57256601927,894634405,13978662,18.4),(120136,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120136,37.76,0.46,356,53141,70,NULL,NULL,'2MASX J14224587+1836586',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.6912917,18.61625,0,NULL,59518278184,929973096,14530829,17.8),(120137,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120137,37.25,0.27,282,53142,70,NULL,NULL,'2MASX J14224602+4507501',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,215.691667,45.13069,0,NULL,59230556362,925477443,14460585,17.9),(120138,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120138,37.95,0.46,389,53143,70,NULL,NULL,'SDSS J142246.18+055339.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,215.692458333,5.89417,0.037,NULL,58301738421,910964662,14233822,18.2),(120139,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120139,37.39,0.33,301,53144,70,NULL,NULL,'2MASX J14224657+1552275',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.04',0.17,NULL,NULL,NULL,NULL,NULL,1,215.694125,15.8745,0,NULL,59489229280,929519207,14523737,18.04),(120140,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120140,35.32,0.47,116,53145,NULL,NULL,'H','UGC 09213',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000047,NULL,'14.4g',0.59,'Sb',NULL,NULL,NULL,NULL,1,215.694541667,37.99525,0,NULL,60064059988,938500937,14664077,14.4),(120141,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120141,35.39,0.4,120,53145,NULL,NULL,'mean','UGC 09213',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120142,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120142,35.49,0.46,125,53145,NULL,NULL,'J','UGC 09213',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120143,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120143,35.49,0.45,125,53145,NULL,NULL,'K','UGC 09213',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120144,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120144,35.72,0.46,139,53146,70,NULL,NULL,'2MASX J14224716+3342452',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00018,NULL,'15.5g',0.51,NULL,NULL,NULL,NULL,NULL,1,215.696583,33.71256,0,NULL,60040125427,938126959,14658233,15.5),(120145,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120145,37.85,0.33,372,53147,70,NULL,NULL,'2MASX J14224788+1706185',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,215.6995,17.10525,0,NULL,59488194436,929503038,14523484,16.8),(120146,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120146,36.66,0.23,215,53148,70,NULL,NULL,'2MASX J14224819+2853358',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000186,NULL,'15.9g',0.4,NULL,NULL,NULL,NULL,NULL,1,215.700833,28.89339,0,NULL,60059833241,938434894,14663045,15.9),(120147,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120147,37.69,0.46,344,53149,70,NULL,NULL,'2MASX J14224860+4326521',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,215.702375,43.44783,0,NULL,59224682664,925385666,14459151,17.8),(120148,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120148,37.87,0.46,375,53150,70,NULL,NULL,'LCRS B142013.6-023356',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,215.704667,-2.79242,0.149,NULL,43518289756,679973277,10624582,17.5),(120149,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120149,37.47,0.07,312,53151,70,NULL,NULL,'2MASX J14224965+4834062',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,215.7065417,48.56836,0.039,NULL,59248591179,925759237,14464988,17.1),(120150,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120150,37.25,0.27,282,53152,70,NULL,NULL,'2MASX J14225074+4509211',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,215.7115,45.15589,0,NULL,59230527529,925476992,14460578,17.4),(120151,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120151,37.54,0.33,323,53153,70,NULL,NULL,'2MASX J14225144+5603513',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00018,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.714333333,56.06417,0.005,NULL,57256852314,894638317,13978723,17.4),(120152,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120152,37.44,0.46,307,53154,70,NULL,NULL,'2MASX J14225239+4455131',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,215.7182917,44.92042,0,NULL,59230667784,925479184,14460612,17.1),(120153,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120153,38.27,0.46,452,53155,70,NULL,NULL,'2MASX J14225465+5902383',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000132,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,215.727416667,59.044,0.033,NULL,57269165546,894830711,13981729,17.9),(120154,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120154,37.25,0.27,282,53156,70,NULL,NULL,'2MASX J14225490+4508521',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000146,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.72875,45.14783,0,NULL,59230654485,925478976,14460609,17.4),(120155,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120155,35.64,0.47,134,53157,NULL,NULL,'H','UGC 09214',NULL,'2007A&A...465...71T',2007,1,0.89,NULL,'G',0.00002,NULL,'14.3g',0.6,'SBa            Sy1.8',NULL,NULL,NULL,'Sy 2',1,215.7307083,32.85075,0,NULL,60039448867,938116388,14658068,14.3),(120156,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120156,35.79,0.45,144,53157,NULL,NULL,'K','UGC 09214',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120157,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120157,35.82,0.46,146,53157,NULL,NULL,'J','UGC 09214',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120158,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120158,35.84,0.4,147,53157,NULL,NULL,'mean','UGC 09214',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120159,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120159,37.47,0.07,312,53158,70,NULL,NULL,'2MASX J14225553+4747141',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000219,NULL,'16.3g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,215.7314583,47.78722,0,NULL,59248210299,925753285,14464895,16.3),(120160,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120160,37.54,0.33,323,53159,70,NULL,NULL,'2MASX J14225585+5606343',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000188,NULL,'16.1g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,215.73275,56.10958,0.005,NULL,57256840005,894638125,13978720,16.1),(120161,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120161,37.39,0.33,301,53160,70,NULL,NULL,'2MASX J14225717+1551425',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,215.73825,15.86178,0,NULL,59491116233,929548691,14524198,NULL),(120162,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120162,35.65,0.46,135,53161,70,NULL,NULL,'IC 4413',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000185,NULL,'15.3g',0.54,'E',NULL,NULL,NULL,NULL,1,215.738833,37.52742,0,NULL,60031386466,937990413,14656100,15.3),(120163,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120163,38.1,0.46,417,53162,70,NULL,NULL,'2MASX J14225811+4401471',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,215.74225,44.02994,0,NULL,59230078133,925469970,14460468,17.7),(120164,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120164,38.19,0.46,434,53163,70,NULL,NULL,'2MASX J14230088+0054190',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000085,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.7537083,0.90522,0.081,NULL,58285540992,910711578,14229868,17.5),(120165,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120165,36.64,0.46,213,53164,70,NULL,NULL,'VIII Zw 406',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000104,NULL,'15.8g',0.46,'E0',NULL,NULL,NULL,NULL,1,215.754083,0.79436,0.081,NULL,58285529702,910711401,14229865,15.8),(120166,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120166,36.54,0.46,204,53165,70,NULL,NULL,'SDSS J142301.14+204356.1',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.7547917,20.73225,0.008,NULL,59525320759,930083136,14532549,17.4),(120167,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120167,34.11,0.33,66.5,53166,70,NULL,NULL,'NGC 5603',NULL,'2015arXiv151105856S',2015,1,1.04,NULL,'G',0.000067,NULL,'13.9g',0.93,'S0','Possible field galaxy',NULL,NULL,NULL,1,215.756375,40.37742,0,NULL,59945489291,936648270,14635129,13.9),(120168,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120168,36.19,0.46,173,53167,70,NULL,NULL,'2MASX J14230197-0126204',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,215.75825,-1.43906,0.129,NULL,43517245948,679956967,10624327,17.2),(120169,'D-Sigma','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120169,32.97,0.4,39.2,53168,75,NULL,'Edat, raw','ESO 385- G 017',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000113,NULL,'14.03',0.9,'E4','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,215.760333,-34.29192,0.237,NULL,47006089857,734470154,11476096,14.03),(120170,'D-Sigma','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120170,33.3,0.4,45.7,53168,75,NULL,'Edat, cor','ESO 385- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120171,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120171,35.22,0.46,111,53169,70,NULL,NULL,'UGC 09212',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.00019,NULL,'14.56',0.6,'S0',NULL,NULL,NULL,NULL,1,215.766291667,18.27917,0,NULL,59485756432,929464944,14522889,14.56),(120172,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120172,36.63,0.27,212,53170,70,NULL,NULL,'SDSS J142305.73+023013.0',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000072,NULL,'17.9g',0.11,NULL,NULL,NULL,NULL,NULL,1,215.773916667,2.50364,0.049,NULL,58300411310,910943926,14233498,17.9),(120173,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120173,36.28,0.15,180,53171,70,NULL,NULL,'2MASX J14230578+2617358',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000164,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,215.7742917,26.29328,0,NULL,60055046717,938360104,14661876,16.7),(120174,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120174,37.5,0.46,317,53172,70,NULL,NULL,'2MASX J14230610+0542060',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000204,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,215.775375,5.70169,0.037,NULL,58301862008,910966593,14233853,16.3),(120175,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120175,36.8,0.46,229,53173,70,NULL,NULL,'2MASX J14230685+5356533',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,215.7785417,53.94825,0,NULL,59196801197,924950018,14452344,17.7),(120176,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120176,37.98,0.46,395,53174,70,NULL,NULL,'LCRS B142031.5-021523',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00014,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,215.778625,-2.48289,0.157,NULL,43519464972,679991640,10624869,18.7),(120177,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120177,36.66,0.46,215,53175,70,NULL,NULL,'2MASX J14230813+1604475',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.17',0.17,NULL,NULL,NULL,NULL,NULL,1,215.783875,16.07986,0,NULL,59491147469,929549179,14524205,18.17),(120178,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120178,37.47,0.07,312,53176,70,NULL,NULL,'SDSS J142308.37+474757.3',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000164,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,215.784875,47.79928,0,NULL,59248203028,925753172,14464893,17.7),(120179,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120179,37.04,0.46,256,53177,70,NULL,NULL,'2MASX J14230871+2052593',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,215.7862917,20.88311,0.008,NULL,59525346584,930083540,14532555,18),(120180,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120180,34.67,0.46,85.7,53178,70,NULL,NULL,'CGCG 019-010',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000083,NULL,'14.8g',0.59,'S0^-',NULL,NULL,NULL,NULL,1,215.78725,1.67158,0.045,NULL,58300019245,910937800,14233403,14.8),(120181,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120181,36.28,0.15,180,53179,70,NULL,NULL,'SDSS J142309.29+261601.5',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000178,NULL,'16.2g',0.39,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.78875,26.26711,0,NULL,60055057481,938360273,14661879,16.2),(120182,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120182,37.29,0.33,287,53180,70,NULL,NULL,'2MASX J14230974+2308534',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000191,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,215.790583,23.14808,0.058,NULL,59516971106,929952673,14530510,16.4),(120183,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120183,37.54,0.33,322,53181,70,NULL,NULL,'2MASX J14231043+2532397',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000168,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,215.793375,25.54447,0,NULL,60054279575,938348118,14661689,17.2),(120184,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120184,37.92,0.16,383,53182,70,NULL,NULL,'2MASX J14231085+4922493',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000173,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,215.7950417,49.38044,0.005,NULL,59246402079,925725032,14464453,16.8),(120185,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120185,37.47,0.07,312,53183,70,NULL,NULL,'2MASX J14231172+4838123',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000185,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,215.799041667,48.63678,0.039,NULL,59248579615,925759056,14464985,16.3),(120186,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120186,35.88,0.51,150,53184,70,NULL,NULL,'MCG -02-37-001',NULL,'2014MNRAS.445.2677S',2014,1,0.1,NULL,'G',0.000137,NULL,'15.5',0.1,NULL,NULL,NULL,NULL,NULL,1,215.8029583,-10.851,0.249,NULL,43704917615,682889337,10670145,15.5),(120187,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120187,37.54,0.33,322,53185,70,NULL,NULL,'2MASX J14231285+2534512',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000201,NULL,'16.90',0.27,NULL,NULL,NULL,NULL,NULL,1,215.8035417,25.58086,0,NULL,60054282083,938348157,14661689,16.9),(120188,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120188,35.53,0.55,128,53186,70,NULL,NULL,'ESO 222- G 003',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'15.3b',0.4,'S...',NULL,NULL,NULL,NULL,1,215.80675,-49.32903,0.929,NULL,46836527777,731820746,11434699,15.3),(120189,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120189,37.47,0.07,312,53187,70,NULL,NULL,'2MASX J14231385+4843393',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000176,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,215.807625,48.72767,0.039,NULL,59248595748,925759308,14464989,17.4),(120190,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120190,38.04,0.23,406,53188,70,NULL,NULL,'2MASX J14231420+5639363',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000179,NULL,'16.9g',0.32,NULL,NULL,NULL,NULL,NULL,1,215.809083,56.66,0,NULL,57256636341,894634942,13978670,16.9),(120191,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120191,36.52,0.46,202,53189,70,NULL,NULL,'2MASX J14231540+0418082',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00006,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,215.81425,4.30239,0.049,NULL,58296104791,910876637,14232447,16.8),(120192,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120192,37.92,0.16,383,53190,70,NULL,NULL,'2MASX J14231573+4005293',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000161,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,215.815417,40.09161,0,NULL,59945483216,936648175,14635127,17.1),(120193,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120193,37.78,0.46,359,53191,70,NULL,NULL,'2MASX J14231573+1115096',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000201,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,215.815583,11.25264,0,NULL,58486104105,913845376,14278834,16.5),(120194,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120194,36.63,0.27,212,53192,70,NULL,NULL,'2MASX J14231586+0231392',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000087,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,215.816,2.52753,0.049,NULL,58300535107,910945861,14233529,16.7),(120195,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120195,36.95,0.46,245,53193,70,NULL,NULL,'2MASXi J1423163+323551',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000175,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,215.818125,32.59783,0,NULL,60039435429,938116178,14658065,17.9),(120196,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120196,29.87,0.4,9.4,53194,73,NULL,'opt','NGC 5608',NULL,'2011A&A...532A.104N',2011,1,2.6,NULL,'G',0.00002,NULL,'13.9',1.3,'Im:            HII','Isolated galaxy',NULL,NULL,NULL,1,215.8245417,41.77589,0,NULL,59947455046,936678985,14635609,13.9),(120197,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120197,30.52,0.4,12.7,53194,75,NULL,'B','NGC 5608',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120198,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120198,31.24,0.4,17.7,53194,NULL,NULL,NULL,'NGC 5608',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120199,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120199,36.67,0.33,216,53195,70,NULL,NULL,'2MASX J14231866+1718352',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.83',0.17,NULL,NULL,NULL,NULL,NULL,1,215.8277083,17.30992,0,NULL,59488636861,929509950,14523592,17.83),(120200,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120200,37.92,0.16,383,53196,70,NULL,NULL,'2MASX J14231913+4003424',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000155,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.829833,40.06181,0,NULL,59945469050,936647953,14635124,17.5),(120201,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120201,36.63,0.27,212,53197,70,NULL,NULL,'2MASX J14231960+0223382',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000064,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,215.831583,2.39392,0.049,NULL,58300389277,910943582,14233493,16.6),(120202,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120202,37.92,0.16,383,53198,70,NULL,NULL,'2MASX J14232024+4020144',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000179,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,215.83425,40.3375,0,NULL,59945489744,936648277,14635129,17.2),(120203,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120203,38.04,0.46,406,53199,70,NULL,NULL,'2MASX J14232078+5356172',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,215.836583333,53.93808,0,NULL,59196801291,924950020,14452344,18.1),(120204,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120204,38.21,0.46,438,53200,70,NULL,NULL,'2MASX J14232112+1805023',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,215.838125,18.08383,0,NULL,59488058407,929500912,14523451,17.5),(120205,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120205,37.5,0.33,316,53201,70,NULL,NULL,'2MASX J14232177+4605314',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000194,NULL,'16.2g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,215.840625,46.09206,0,NULL,59231941584,925499087,14460923,16.2),(120206,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120206,37.05,0.33,257,53202,70,NULL,NULL,'2MASX J14232320+2055503',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,215.846667,20.93078,0.011,NULL,59525333342,930083333,14532552,17.9),(120207,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120207,36.67,0.46,216,53203,70,NULL,NULL,'2MASX J14232328+2004463',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.42',0.14,NULL,NULL,NULL,NULL,NULL,1,215.846875,20.07956,0.014,NULL,59523074722,930048042,14532000,18.42),(120208,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120208,38.03,0.46,403,53204,70,NULL,NULL,'2MASX J14232423+3656244',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000187,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,215.851083333,36.94014,0,NULL,60031955462,937999304,14656239,17.7),(120209,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120209,37.99,0.46,396,53205,70,NULL,NULL,'2MASX J14232523+4314295',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,215.855166667,43.24144,0,NULL,59947119098,936673735,14635527,17),(120210,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120210,38.04,0.23,406,53206,70,NULL,NULL,'2MASX J14232522+5638112',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,215.855166667,56.63656,0,NULL,57256637362,894634958,13978671,17.4),(120211,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120211,36.28,0.15,180,53207,70,NULL,NULL,'2MASX J14232704+2612012',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000188,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,215.86275,26.20033,0,NULL,60054994398,938359287,14661863,16.7),(120212,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120212,31.82,0.4,23.1,53208,NULL,NULL,NULL,'UGC 09215',NULL,'2009AJ....138..323T',2009,1,2.2,'One APM position refers to the eastern side of the galaxy.','G',0.000005,NULL,'14.0g',1.3,'SB(s)d','in a radial-velocity based grouping',NULL,NULL,NULL,1,215.863,1.72631,0.045,NULL,58299863234,910935363,14233365,14),(120213,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120213,31.85,0.58,23.4,53208,NULL,NULL,'Malmquist cor.','UGC 09215',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120214,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120214,31.96,0.2,24.7,53208,74.4,NULL,NULL,'UGC 09215',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120215,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120215,32.01,0.43,25.2,53208,75,NULL,'3.6 micron, color corrected','UGC 09215',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120216,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120216,32.01,0.43,25.3,53208,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09215',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120217,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120217,32.06,0.53,25.8,53208,NULL,NULL,NULL,'UGC 09215',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120218,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120218,32.06,NULL,25.8,53208,72,NULL,NULL,'UGC 09215',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120219,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120219,32.27,0.4,28.4,53208,NULL,NULL,'mean','UGC 09215',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120220,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120220,33.03,0.47,40.3,53208,NULL,NULL,'H','UGC 09215',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120221,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120221,37.47,0.07,312,53209,70,NULL,NULL,'2MASX J14232740+4844182',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000179,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,215.8639583,48.73839,0.039,NULL,59248578795,925759043,14464985,17),(120222,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120222,38.35,0.46,469,53210,70,NULL,NULL,'SDSS J142328.11+082026.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000146,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,215.867125,8.34058,0.021,NULL,58274446394,910538224,14227159,18.4),(120223,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120223,38.01,0.33,399,53211,70,NULL,NULL,'2MASX J14232848+2440372',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,215.868791667,24.67697,0,NULL,59513018161,929890908,14529545,17.5),(120224,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120224,37.78,0.46,360,53212,70,NULL,NULL,'2MASX J14232871+5155062',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,215.869666667,51.9185,0.005,NULL,59196207156,924940736,14452199,18),(120225,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120225,37.44,0.33,308,53213,70,NULL,NULL,'2MASX J14232888+2955332',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.29',0.17,NULL,NULL,NULL,NULL,NULL,1,215.8704583,29.92606,0,NULL,60061540969,938461577,14663462,18.29),(120226,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120226,37.05,0.33,257,53214,70,NULL,NULL,'2MASX J14232910+2056130',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.35',0.26,NULL,NULL,NULL,NULL,NULL,1,215.87125,20.93708,0.011,NULL,59525333193,930083331,14532552,17.35),(120227,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120227,37.89,0.46,379,53215,70,NULL,NULL,'2MASX J14232963+2503562',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000201,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,215.8734583,25.06558,0,NULL,60020506174,937820408,14653443,17.1),(120228,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120228,37.5,0.33,316,53216,70,NULL,NULL,'2MASX J14233044+4600275',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00018,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,215.8767917,46.00778,0,NULL,59231946046,925499156,14460924,16.7),(120229,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120229,37.63,0.46,336,53217,70,NULL,NULL,'SDSS J142330.76+082131.7',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000141,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,215.8782083,8.35883,0.021,NULL,58274445276,910538207,14227159,18.6),(120230,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120230,38.04,0.23,406,53218,70,NULL,NULL,'2MASX J14233123+5643431',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000162,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,215.880166667,56.72861,0,NULL,57249181427,894518459,13976850,18.2),(120231,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120231,36.28,0.46,181,53219,70,NULL,NULL,'2MASX J14233194+2017180',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.05',0.23,NULL,NULL,NULL,NULL,NULL,1,215.883125,20.28833,0,NULL,59525379589,930084056,14532563,16.05),(120232,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120232,36.67,0.33,216,53220,70,NULL,NULL,'2MASX J14233199+1726582',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.13',0.17,NULL,NULL,NULL,NULL,NULL,1,215.883458333,17.4495,0,NULL,59488824382,929512880,14523638,17.13),(120233,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120233,37.21,0.46,276,53221,70,NULL,NULL,'2MASX J14233272+4238325',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,215.886208333,42.64242,0,NULL,59948047074,936688235,14635753,17.2),(120234,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120234,37.27,0.46,284,53222,70,NULL,NULL,'SDSS J142332.79+023604.2',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000076,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,215.886625,2.60119,0.049,NULL,58300551087,910946110,14233532,18.6),(120235,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120235,37.62,0.46,334,53223,70,NULL,NULL,'2MASX J14233311+3313519',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,215.887917,33.23119,0,NULL,60040387271,938131051,14658297,17.7),(120236,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120236,39.36,0.46,745,53224,70,NULL,NULL,'SDSS J142333.42+004353.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000082,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,215.88925,0.73144,0.081,NULL,58286022650,910719103,14229985,18.5),(120237,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120237,37.86,0.46,374,53225,70,NULL,NULL,'SDSS J142333.89+052503.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000137,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,215.89125,5.41756,0.029,NULL,58301646922,910963233,14233800,18),(120238,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120238,37.56,0.46,325,53226,70,NULL,NULL,'2MASX J14233410+0927046',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000172,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,215.89225,9.45133,0.025,NULL,58268575828,910446497,14225726,17),(120239,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120239,37.7,0.46,347,53227,70,NULL,NULL,'2MASX J14233451+1407162',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.07',0.15,NULL,NULL,NULL,NULL,NULL,1,215.893625,14.12111,0,NULL,59478721055,929355016,14521172,18.07),(120240,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120240,37.92,0.16,383,53228,70,NULL,NULL,'2MASXi J1423353+401123',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000175,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,215.897417,40.18975,0,NULL,59945500811,936648450,14635132,18),(120241,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120241,37.47,0.07,312,53229,70,NULL,NULL,'2MASX J14233661+4826104',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00007,NULL,'15.9g',0.42,NULL,NULL,NULL,NULL,NULL,1,215.902416667,48.43619,0.039,NULL,59248719545,925761242,14465019,15.9),(120242,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120242,33.37,0.43,47.2,53230,75,NULL,'3.6 micron, color + selection bias corrected','IC 4407',NULL,'2014MNRAS.444..527S',2014,1,1.4,NULL,'G',0.00001,NULL,'14.59',0.7,'SB(s)m IV:',NULL,NULL,NULL,NULL,1,215.903583,-5.98322,0.101,NULL,43537331571,680270805,10629231,14.59),(120243,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120243,38.11,0.11,418,53231,70,NULL,NULL,'2MASX J14233793+1739382',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,215.908125,17.66064,0,NULL,59488778196,929512159,14523627,17.2),(120244,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120244,37.04,0.46,256,53232,70,NULL,NULL,'2MASX J14233814+1246582',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000193,NULL,'16.1g',0.38,NULL,NULL,NULL,NULL,NULL,1,215.9089583,12.78292,0,NULL,59475420187,929303440,14520366,16.1),(120245,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120245,34.98,0.4,99.2,53233,NULL,NULL,'mean','MCG -02-37-002',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000047,NULL,'15.00',0.4,'Sc             HII',NULL,NULL,NULL,NULL,1,215.910875,-13.33797,0.293,NULL,46540931511,727202054,11362532,15),(120246,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120246,35.11,0.47,105,53233,NULL,NULL,'H','MCG -02-37-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120247,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120247,35.22,0.45,111,53233,NULL,NULL,'K','MCG -02-37-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120248,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120248,35.25,0.46,112,53233,NULL,NULL,'J','MCG -02-37-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120249,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120249,37.97,0.46,394,53234,70,NULL,NULL,'2MASX J14233885+4005097',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.0001,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,215.911791667,40.08617,0,NULL,59945297814,936645278,14635082,16.8),(120250,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120250,36.67,0.46,216,53235,70,NULL,NULL,'2MASX J14234007+0346023',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000069,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,215.917125,3.76736,0.033,NULL,58295193126,910862392,14232224,17.4),(120251,'Tully est','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120251,31.62,0.8,21.1,53236,75,NULL,NULL,'ESO 222-IG 004',NULL,'1988NBGC.C....0000T',1988,1,2.2,NULL,'G',0.00001,NULL,'14.7',1.6,'SB(s)m',NULL,NULL,NULL,NULL,1,215.917791667,-49.65503,0.929,NULL,46836635188,731822424,11434725,14.7),(120252,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120252,37.47,0.07,312,53237,70,NULL,NULL,'2MASX J14234096+4816575',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000181,NULL,'17.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,215.920583333,48.28261,0.027,NULL,59248526218,925758222,14464972,17.3),(120253,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120253,35.95,0.74,155,53238,70,NULL,NULL,'2MASX J14234133-1922399',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'15.88',NULL,NULL,NULL,NULL,NULL,NULL,1,215.922333,-19.37778,0.353,NULL,46572405485,727693835,11370216,15.88),(120254,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120254,37.44,0.33,308,53239,70,NULL,NULL,'2MASX J14234259+2954179',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000179,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.9275417,29.905,0,NULL,60059652950,938432077,14663001,17.2),(120255,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120255,36.87,0.46,237,53240,70,NULL,NULL,'2MASX J14234295+2030350',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.53',0.32,'AGN',NULL,NULL,NULL,NULL,1,215.928916667,20.50967,0.017,NULL,59525415668,930084619,14532572,16.53),(120256,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120256,38.19,0.33,434,53241,70,NULL,NULL,'2MASX J14234302+2100550',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.90',0.14,NULL,NULL,NULL,NULL,NULL,1,215.9292917,21.01533,0.011,NULL,59524974321,930077723,14532464,18.9),(120257,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120257,38.11,0.11,418,53242,70,NULL,NULL,'SDSS J142343.86+173225.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.9327917,17.54053,0,NULL,59488854766,929513355,14523646,17.9),(120258,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120258,36.28,0.15,180,53243,70,NULL,NULL,'2MASX J14234386+2622414',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000163,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,215.932833,26.37828,0,NULL,60054503709,938351620,14661744,16.4),(120259,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120259,38.06,0.21,409,53244,70,NULL,NULL,'2MASX J14234407+2500544',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,215.9337917,25.01503,0,NULL,60020497626,937820275,14653441,17.9),(120260,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120260,36.71,0.46,220,53245,70,NULL,NULL,'2MASX J14234471+0634197',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,215.936417,6.57228,0.037,NULL,58271843488,910497554,14226524,17.1),(120261,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120261,34.61,0.33,83.5,53246,70,NULL,NULL,'UGC 09223',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.000167,NULL,'14.1g',0.5,'S0',NULL,NULL,NULL,NULL,1,215.9370417,40.02386,0,NULL,59945303274,936645363,14635083,14.1),(120262,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120262,37.92,0.16,383,53247,70,NULL,NULL,'2MASX J14234498+4019567',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000185,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.9375417,40.33242,0,NULL,59945499779,936648434,14635131,17.9),(120263,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120263,38.01,0.33,399,53248,70,NULL,NULL,'2MASX J14234515+2441194',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000127,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,215.938083,24.68889,0,NULL,59513018791,929890918,14529545,17.3),(120264,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120264,36.83,0.46,232,53249,70,NULL,NULL,'2MASX J14234576+2429004',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000172,NULL,'16.0g',0.4,NULL,NULL,NULL,NULL,NULL,1,215.940541667,24.4835,0,NULL,59513206749,929893855,14529591,16),(120265,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120265,35.7,0.2,138,53250,74.4,NULL,NULL,'KUG 1421+094',NULL,'2013AJ....146...86T',2013,1,0.58,NULL,'G',0.000084,NULL,'16.0g',0.46,'Spiral',NULL,NULL,NULL,NULL,1,215.9417917,9.2365,0.013,NULL,58268551118,910446111,14225720,16),(120266,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120266,34.07,0.2,65.2,53251,74.4,NULL,NULL,'UGC 09222',NULL,'2013AJ....146...86T',2013,1,1.22,NULL,'G',0.00002,NULL,'14.7g',0.34,'S0/a','Pair member (points to parent)',NULL,NULL,NULL,1,215.943,34.017,0,NULL,60039945108,938124142,14658189,14.7),(120267,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120267,37.53,0.46,320,53252,70,NULL,NULL,'2MASX J14234665+3657417',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000134,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,215.944541667,36.96161,0,NULL,60031905176,937998518,14656226,17.7),(120268,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120268,37.47,0.07,312,53253,70,NULL,NULL,'2MASX J14234687+4816475',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00019,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,215.945333,48.27992,0.027,NULL,59248525688,925758213,14464972,17.2),(120269,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120269,35.59,0.46,131,53254,70,NULL,NULL,'2MASX J14234786+4833165',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000089,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,215.94925,48.55461,0.039,NULL,59248576871,925759013,14464984,16.5),(120270,'SZ effect','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120270,40.87,0.08,1490,53255,NULL,NULL,'Hydrost. Eq.','MACS J1423.8+2404',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,215.948583,24.07781,0.027,NULL,59513860886,929904076,14529751,NULL),(120271,'SZ effect','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120271,41.16,0.76,1710,53255,NULL,NULL,'Isotherm., r < 100 kpc','MACS J1423.8+2404',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120272,'SZ effect','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120272,41.75,NULL,2240,53255,NULL,NULL,'3.1 (red) calibration','MACS J1423.8+2404',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120273,'SZ effect','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120273,41.76,NULL,2250,53255,NULL,NULL,'4.2 (black) calibration','MACS J1423.8+2404',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120274,'SZ effect','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120274,42.01,0.68,2520,53255,NULL,NULL,'Isotherm.','MACS J1423.8+2404',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120275,'SZ effect','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120275,42.01,NULL,2520,53255,NULL,NULL,'4.1 (blue) calibration','MACS J1423.8+2404',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120276,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120276,37.52,0.33,318,53256,70,NULL,NULL,'2MASX J14234917+2447324',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000162,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,215.9547917,24.7925,0,NULL,59496263487,929629116,14525454,17.2),(120277,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120277,38,0.46,399,53257,70,NULL,NULL,'2MASX J14234912+2202470',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.30',0.19,NULL,NULL,NULL,NULL,NULL,1,215.954833,22.04642,0.028,NULL,59516152669,929939885,14530310,18.3),(120278,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120278,35.13,0.8,106,53258,75,NULL,'HMCL, I','NGC 5600',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000021,NULL,'12.66',1.4,'Sc pec         HII','Group member',NULL,NULL,NULL,1,215.956333333,14.63878,0,NULL,59478471470,929351116,14521111,12.66),(120279,'Tully est','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120279,32.87,0.8,37.5,53258,75,NULL,'B','NGC 5600',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120280,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120280,34.84,0.4,92.7,53258,75,NULL,'HMCL, I, raw','NGC 5600',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120281,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120281,35.03,0.4,101,53258,75,NULL,'HMCL, I, inv','NGC 5600',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120282,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120282,35.04,0.4,102,53258,75,NULL,'HMCL, I, cor','NGC 5600',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120283,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120283,32.42,0.8,30.5,53259,75,NULL,'MAT, I','ESO 041- G 006',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.00001,NULL,'13.16',2,'SB(s)m',NULL,NULL,NULL,NULL,1,215.960166667,-75.32203,0.893,NULL,44205051576,690703930,10792248,13.16),(120284,'Tully est','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120284,32.53,0.8,32,53259,75,NULL,NULL,'ESO 041- G 006',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120285,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120285,30.9,0.43,15.1,53259,75,NULL,'MAT, I, inv','ESO 041- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120286,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120286,30.92,0.32,15.3,53259,85,NULL,'I, inv','ESO 041- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120287,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120287,30.98,0.32,15.7,53259,85,NULL,'I, raw','ESO 041- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120288,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120288,31.04,0.43,16.1,53259,75,NULL,'MAT, I, raw','ESO 041- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120289,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120289,31.21,0.4,17.5,53259,NULL,NULL,NULL,'ESO 041- G 006',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120290,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120290,31.32,0.43,18.4,53259,75,NULL,'MAT, I, cor','ESO 041- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120291,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120291,34.91,0.8,95.9,53260,75,NULL,'HMCL, I','NGC 5599',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.42',0.5,'Sb',NULL,NULL,NULL,NULL,1,215.960875,6.57611,0.037,NULL,58271838442,910497475,14226523,14.42),(120292,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120292,34.93,0.8,96.7,53260,75,NULL,'CF, r','NGC 5599',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120293,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120293,34.08,0.4,65.5,53260,75,NULL,'HMCL, I, raw','NGC 5599',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120294,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120294,34.26,0.4,71.2,53260,75,NULL,'HMCL, I, inv','NGC 5599',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120295,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120295,34.45,0.38,77.8,53260,75,NULL,'CF, r, raw','NGC 5599',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120296,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120296,34.53,0.4,80.5,53260,75,NULL,'HMCL, I, cor','NGC 5599',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120297,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120297,34.61,0.38,83.7,53260,75,NULL,'CF, r, inv','NGC 5599',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120298,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120298,34.83,0.47,92.6,53260,NULL,NULL,'H','NGC 5599',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120299,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120299,34.85,0.38,93.5,53260,75,NULL,'CF, r, cor','NGC 5599',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120300,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120300,34.89,0.37,95.2,53260,NULL,NULL,NULL,'NGC 5599',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120301,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120301,34.92,0.2,96.4,53260,74.4,NULL,NULL,'NGC 5599',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120302,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120302,34.97,0.35,98.7,53260,NULL,NULL,'Malmquist cor.','NGC 5599',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120303,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120303,34.99,0.45,99.4,53260,NULL,NULL,'K','NGC 5599',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120304,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120304,34.99,0.46,99.6,53260,NULL,NULL,'J','NGC 5599',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120305,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120305,35.09,0.4,104,53260,NULL,NULL,'mean','NGC 5599',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120306,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120306,36.99,0.46,250,53261,70,NULL,NULL,'2MASX J14235098+0738128',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.962375,7.63672,0.029,NULL,58273891143,910529549,14227024,17.7),(120307,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120307,37.92,0.16,383,53262,70,NULL,NULL,'2MASX J14235155+4015318',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000213,NULL,'15.8g',0.44,'BrClG',NULL,NULL,NULL,NULL,1,215.96475,40.25883,0,NULL,59945494063,936648344,14635130,15.8),(120308,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120308,37.52,0.33,318,53263,70,NULL,NULL,'2MASX J14235172+2459054',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,215.965541667,24.98492,0,NULL,60020497767,937820277,14653441,18),(120309,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120309,38.11,0.11,418,53264,70,NULL,NULL,'SDSS J142352.24+172649.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.967667,17.44722,0,NULL,59488859154,929513424,14523647,18.5),(120310,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120310,38.11,0.11,418,53265,70,NULL,NULL,'SDSS J142352.33+173703.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.968083,17.61756,0,NULL,59488811406,929512678,14523635,18.4),(120311,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120311,36.93,0.46,243,53266,70,NULL,NULL,'SDSS J142352.97+050759.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000072,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.9707083,5.13325,0.033,NULL,58301341384,910958459,14233725,17.7),(120312,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120312,38.01,0.46,400,53267,70,NULL,NULL,'SDSS J142354.16+053208.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000138,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,215.975708333,5.53567,0.037,NULL,58301634123,910963033,14233797,18.1),(120313,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120313,35.37,NULL,119,53268,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09224',NULL,'2010Ap&SS.325..163P',2010,1,1.06,NULL,'G',0.00001,NULL,'16.8g',0.15,'Sc',NULL,NULL,NULL,NULL,1,215.977,34.72353,0,NULL,60043064611,938172884,14658951,16.8),(120314,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120314,35.37,NULL,119,53268,NULL,NULL,'Dipole + Quadrupole','UGC 09224',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120315,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120315,35.38,NULL,119,53268,NULL,NULL,'Dipole','UGC 09224',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120316,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120316,35.48,NULL,125,53268,NULL,NULL,NULL,'UGC 09224',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120317,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120317,35.91,0.2,152,53268,74.4,NULL,NULL,'UGC 09224',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120318,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120318,33.85,0.8,58.9,53269,75,NULL,'MAT, I','NGC 5592',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'13.53',0.8,'SB(s)bc?       HII','in a triple',NULL,NULL,NULL,1,215.979375,-28.68806,0.333,NULL,47033454156,734897721,11482776,13.53),(120319,'Sosies','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120319,33.57,0.15,51.8,53269,NULL,NULL,NULL,'NGC 5592',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120320,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120320,33.11,0.69,42,53269,100,NULL,'mid-IR','NGC 5592',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120321,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120321,33.54,0.45,51.2,53269,NULL,NULL,'K','NGC 5592',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120322,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120322,33.57,0.47,51.8,53269,NULL,NULL,'H','NGC 5592',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120323,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120323,33.6,0.46,52.6,53269,NULL,NULL,'J','NGC 5592',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120324,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120324,33.72,0.32,55.4,53269,85,NULL,'I, raw','NGC 5592',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120325,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120325,33.72,0.43,55.6,53269,75,NULL,'MAT, I, raw','NGC 5592',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120326,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120326,33.79,0.32,57.2,53269,85,NULL,'I, inv','NGC 5592',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120327,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120327,33.9,0.4,60.1,53269,NULL,NULL,'mean','NGC 5592',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120328,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120328,33.95,NULL,61.7,53269,NULL,NULL,'I','NGC 5592',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120329,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120329,33.97,NULL,62.2,53269,NULL,NULL,'B','NGC 5592',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120330,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120330,34,0.43,63,53269,75,NULL,'MAT, I, cor','NGC 5592',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120331,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120331,34,0.2,63.1,53269,74.4,NULL,NULL,'NGC 5592',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120332,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120332,34.02,0.43,63.6,53269,75,NULL,'MAT, I, inv','NGC 5592',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120333,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120333,34.08,0.06,65.6,53269,NULL,NULL,NULL,'NGC 5592',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120334,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120334,38.11,0.11,418,53270,70,NULL,NULL,'2MASX J14235508+1734194',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.36',0.16,NULL,NULL,NULL,NULL,NULL,1,215.979667,17.57219,0,NULL,59488802137,929512533,14523633,18.36),(120335,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120335,38.36,0.46,469,53271,70,NULL,NULL,'2MASX J14235536+1532534',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.89',0.12,NULL,NULL,NULL,NULL,NULL,1,215.9807083,15.54836,0,NULL,59490967713,929546370,14524162,18.89),(120336,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120336,37.14,0.27,268,53272,70,NULL,NULL,'2MASX J14235543+2246100',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.62',0.23,NULL,NULL,NULL,NULL,NULL,1,215.980875,22.76961,0.062,NULL,59517063382,929954115,14530533,17.62),(120337,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120337,38.11,0.11,418,53273,70,NULL,NULL,'2MASX J14235557+1733574',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.59',0.13,NULL,NULL,NULL,NULL,NULL,1,215.9814583,17.56606,0,NULL,59488802772,929512543,14523633,18.59),(120338,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120338,35.76,0.46,142,53274,70,NULL,NULL,'CGCG 163-036',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000083,NULL,'15.3g',0.48,NULL,NULL,NULL,NULL,NULL,1,215.9869583,28.98497,0,NULL,60060017228,938437769,14663090,15.3),(120339,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120339,38.19,0.33,434,53275,70,NULL,NULL,'2MASX J14235779+2106017',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.99',0.21,'BrClG',NULL,NULL,NULL,NULL,1,215.990875,21.10064,0.011,NULL,59524978955,930077796,14532465,17.99),(120340,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120340,38.41,0.33,480,53276,70,NULL,NULL,'2MASX J14235784+2434035',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,215.990958333,24.56758,0,NULL,59513012963,929890827,14529544,17.2),(120341,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120341,37.58,0.46,329,53277,70,NULL,NULL,'2MASX J14235826+1524474',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.992791667,15.41325,0,NULL,59489139215,929517800,14523715,17.2),(120342,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120342,37.51,0.33,318,53278,70,NULL,NULL,'2MASX J14235852+0746148',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000203,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.9937083,7.77089,0.021,NULL,58274355977,910536812,14227137,17.3),(120343,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120343,36.28,0.15,180,53279,70,NULL,NULL,'2MASXi J1424007+260918',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00009,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,216.003333,26.15503,0,NULL,60054987767,938359183,14661862,16.6),(120344,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120344,37.9,0.33,380,53280,70,NULL,NULL,'SDSS J142401.98+444002.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00016,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,216.0082917,44.66733,0,NULL,59230854544,925482102,14460657,18.3),(120345,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120345,38.02,0.46,402,53281,70,NULL,NULL,'SDSS J142403.11+445221.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,216.013,44.87275,0,NULL,59230876265,925482441,14460663,18.1),(120346,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120346,37.92,0.16,383,53282,70,NULL,NULL,'2MASX J14240395+4014418',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000175,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,216.016375,40.24492,0,NULL,59945279372,936644990,14635077,17.9),(120347,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120347,38.38,0.46,474,53283,70,NULL,NULL,'2MASX J14240444+2108337',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,216.018583,21.14267,0,NULL,59524976787,930077762,14532465,18.2),(120348,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120348,37.55,0.46,323,53284,70,NULL,NULL,'2MASX J14240451+2813195',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,216.019,28.222,0,NULL,60055444830,938366325,14661973,17.3),(120349,'SBF','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120349,32.01,0.46,25.2,53285,NULL,NULL,'I','NGC 5611',NULL,'2001ApJ...546..681T',2001,1,1.4,NULL,'G',0.000017,NULL,'13.63',0.68,'S0','Brightest group member',NULL,NULL,NULL,1,216.019917,33.04739,0,NULL,60040406964,938131358,14658302,13.63),(120350,'SBF','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120350,32.07,0.14,25.9,53285,74.4,NULL,NULL,'NGC 5611',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120351,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120351,37.39,0.27,300,53286,70,NULL,NULL,'2MASX J14240546+4807444',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000184,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,216.022583,48.12908,0.027,NULL,59248513518,925758023,14464969,17.6),(120352,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120352,38.11,0.11,418,53287,70,NULL,NULL,'2MASX J14240556+1729414',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,216.023333,17.49483,0,NULL,59488861963,929513468,14523647,17.7),(120353,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120353,36.99,0.46,250,53288,70,NULL,NULL,'2MASX J14240643+4900154',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000167,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,216.0269583,49.00442,0.013,NULL,59246305326,925723520,14464430,16.7),(120354,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120354,38.68,0.33,544,53289,70,NULL,NULL,'2MASX J14240788+0934478',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.38',0.17,NULL,NULL,NULL,NULL,NULL,1,216.0327917,9.58003,0.029,NULL,58269306174,910457908,14225904,18.38),(120355,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120355,38.15,0.46,427,53290,70,NULL,NULL,'SDSS J142408.09+222917.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.03375,22.48833,0.047,NULL,59516218176,929940909,14530326,18),(120356,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120356,34.99,0.2,99.5,53291,74.4,NULL,NULL,'KUG 1421+124',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.00052,NULL,'15.6',0.2,'Compact',NULL,NULL,NULL,NULL,1,216.0377917,12.25853,0,NULL,58351167953,911736999,14245890,15.6),(120357,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120357,37.51,0.33,318,53292,70,NULL,NULL,'2MASX J14240915+0746128',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000162,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,216.038125,7.77019,0.021,NULL,58274230027,910534844,14227106,17.9),(120358,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120358,38.68,0.33,544,53293,70,NULL,NULL,'SDSS J142409.64+093504.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,216.040166667,9.58447,0.029,NULL,58269305198,910457893,14225904,18.5),(120359,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120359,36.2,0.46,174,53294,70,NULL,NULL,'2MASX J14241034+3556250',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000157,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,216.043083,35.94022,0,NULL,60042596696,938165573,14658837,16.6),(120360,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120360,37.14,0.27,268,53295,70,NULL,NULL,'2MASX J14241145+2248397',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,216.047667,22.81114,0.062,NULL,59517066367,929954161,14530533,17.1),(120361,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120361,38.41,0.33,480,53296,70,NULL,NULL,'SDSS J142412.02+243338.8',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'18.51',0.15,NULL,NULL,NULL,NULL,NULL,1,216.050083333,24.56078,0,NULL,59513126951,929892608,14529572,18.51),(120362,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120362,35.42,0.53,121,53297,NULL,NULL,'Malmquist cor.','MCG +06-32-024',NULL,'2009ApJS..182..474S',2009,1,0.64,NULL,'G',0.00001,NULL,'15.2g',0.5,'Sa',NULL,NULL,NULL,NULL,1,216.0505,35.14611,0,NULL,60043161895,938174404,14658975,15.2),(120363,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120363,35.58,0.49,130,53297,NULL,NULL,NULL,'MCG +06-32-024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120364,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120364,35.62,0.2,133,53297,74.4,NULL,NULL,'MCG +06-32-024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120365,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120365,36.12,0.46,167,53298,70,NULL,NULL,'2MASX J14241214+1927547',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,216.0507083,19.46517,0,NULL,59523377101,930052767,14532074,17.1),(120366,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120366,37.03,0.23,255,53299,70,NULL,NULL,'2MASX J14241259+0244513',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000088,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,216.0525,2.74761,0.053,NULL,58296911684,910889245,14232644,17.1),(120367,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120367,32.89,0.8,37.9,53300,75,NULL,'MAT, I','NGC 5595',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000013,NULL,'13.12',1.2,'SAB(rs)c       HII','in a pair',NULL,NULL,NULL,1,216.055167,-16.723,0.349,NULL,46556574614,727446478,11366351,13.12),(120368,'Tully est','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120368,32.93,0.8,38.5,53300,75,NULL,'B','NGC 5595',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120369,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120369,32.18,0.43,27.2,53300,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5595',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120370,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120370,32.37,0.43,29.8,53300,75,NULL,'3.6 micron, color corrected','NGC 5595',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120371,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120371,32.48,0.32,31.3,53300,85,NULL,'I, raw','NGC 5595',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120372,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120372,32.52,0.32,31.9,53300,85,NULL,'I, inv','NGC 5595',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120373,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120373,32.57,0.43,32.6,53300,75,NULL,'MAT, I, raw','NGC 5595',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120374,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120374,32.58,0.2,32.8,53300,74.4,NULL,NULL,'NGC 5595',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120375,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120375,32.77,0.43,35.8,53300,75,NULL,'MAT, I, inv','NGC 5595',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120376,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120376,32.78,0.43,36,53300,75,NULL,'MAT, I, cor','NGC 5595',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120377,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120377,38.06,0.21,409,53301,70,NULL,NULL,'2MASX J14241327+2501474',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00019,NULL,'16.5g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,216.055417,25.02983,0,NULL,60020551171,937821112,14653454,16.5),(120378,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120378,37.74,0.46,353,53302,70,NULL,NULL,'2MASX J14241387+0413233',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000114,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,216.0579583,4.22289,0.049,NULL,58294814124,910856470,14232132,16.4),(120379,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120379,38.06,0.21,409,53303,70,NULL,NULL,'2MASX J14241518+2504233',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000202,NULL,'16.4g',0.38,'BrClG',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,216.0632917,25.07331,0,NULL,60020548800,937821075,14653454,16.4),(120380,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120380,37.14,0.27,268,53304,70,NULL,NULL,'2MASX J14241542+2250377',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.12',0.19,NULL,NULL,NULL,NULL,NULL,1,216.064417,22.84386,0.062,NULL,59517074364,929954286,14530535,18.12),(120381,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120381,38.11,0.11,418,53305,70,NULL,NULL,'2MASX J14241552+1732046',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,216.0647083,17.53456,0,NULL,59488851738,929513308,14523645,17.9),(120382,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120382,38.52,0.46,505,53306,70,NULL,NULL,'2MASX J14241623+3637099',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,216.067583333,36.61936,0,NULL,60031182182,937987221,14656050,17.4),(120383,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120383,35.32,0.46,116,53307,70,NULL,NULL,'2MASX J14241630+3336450',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000192,NULL,'15.3g',0.44,NULL,NULL,NULL,NULL,NULL,1,216.067958333,33.61258,0,NULL,60040061121,938125955,14658218,15.3),(120384,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120384,37.88,0.33,377,53308,70,NULL,NULL,'2MASX J14241644-0137380',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000144,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,216.068666667,-1.62719,0.125,NULL,43519190452,679987350,10624802,17.8),(120385,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120385,37.03,0.23,255,53309,70,NULL,NULL,'2MASX J14241653+0247263',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000104,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,216.068791667,2.7905,0.053,NULL,58297132873,910892701,14232698,16.6),(120386,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120386,37.16,0.46,270,53310,70,NULL,NULL,'2MASX J14241749+2954370',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000174,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,216.072958333,29.91019,0,NULL,60059658413,938432162,14663002,16.4),(120387,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120387,35.53,0.46,128,53311,70,NULL,NULL,'MCG +06-32-025',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000181,NULL,'15.4g',0.43,'E0',NULL,NULL,NULL,NULL,1,216.0767083,35.24286,0,NULL,60043105081,938173516,14658961,15.4),(120388,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120388,38.59,0.46,523,53312,70,NULL,NULL,'SDSS J142419.39+020506.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000081,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,216.0807917,2.08514,0.049,NULL,58300810193,910950159,14233596,18.7),(120389,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120389,36.81,0.57,230,53313,70,NULL,NULL,'2MASX J14241981-4525512',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'17.3b',0.4,NULL,NULL,NULL,NULL,NULL,1,216.082458333,-45.43086,0.453,NULL,46803789149,731309205,11426706,17.3),(120390,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120390,38.06,0.21,409,53314,70,NULL,NULL,'2MASX J14242026+2504333',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,216.084583,25.07592,0,NULL,60020516894,937820576,14653446,17.5),(120391,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120391,38.13,0.46,422,53315,70,NULL,NULL,'2MASX J14242049+0820395',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,216.085333,8.34439,0.017,NULL,58274428163,910537940,14227155,17.8),(120392,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120392,34.76,0.49,89.5,53316,75,NULL,'IR','NGC 5616',NULL,'2011yCatp016004901K',2011,1,1.17,NULL,'G',0.00002,NULL,'14.0g',0.51,'Sbc',NULL,NULL,NULL,NULL,1,216.08625,36.46142,0,NULL,60031230653,937987978,14656062,14),(120393,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120393,35.08,0.2,104,53316,74.4,NULL,NULL,'NGC 5616',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120394,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120394,35.09,0.4,104,53316,NULL,NULL,'Malmquist cor.','NGC 5616',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120395,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120395,35.21,0.38,110,53316,NULL,NULL,NULL,'NGC 5616',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120396,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120396,38.31,0.46,458,53317,70,NULL,NULL,'2MASX J14242077+6249166',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000095,NULL,'17.5g',0.18,'NLAGN',NULL,NULL,NULL,NULL,1,216.0865417,62.82125,0.033,NULL,57761639115,902525611,14101962,17.5),(120397,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120397,36.93,0.46,243,53318,70,NULL,NULL,'2MASX J14242114+1122045',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00011,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,216.088125,11.36783,0.008,NULL,58267666771,910432293,14225504,16.4),(120398,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120398,36.81,0.19,231,53319,70,NULL,NULL,'2MASX J14242114+2935213',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000167,NULL,'18.52',0.15,NULL,NULL,NULL,NULL,NULL,1,216.088167,29.58939,0,NULL,60060131121,938439548,14663117,18.52),(120399,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120399,37.61,0.46,332,53320,70,NULL,NULL,'2MASX J14242129+3804170',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000153,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,216.0887917,38.07136,0,NULL,60066201864,938534404,14664600,17.5),(120400,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120400,36.91,0.46,241,53321,70,NULL,NULL,'2MASX J14242153+5207278',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000181,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,216.089541667,52.12439,0.005,NULL,59195696564,924932758,14452074,17),(120401,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120401,36.28,0.15,180,53322,70,NULL,NULL,'2MASX J14242263+2638543',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000105,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,216.094333,26.64839,0,NULL,60054541770,938352215,14661753,16.5),(120402,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120402,34.18,0.8,68.5,53323,75,NULL,'HMCL, I','NGC 5610',NULL,'1997ApJS..109..333W',1997,1,2.03,NULL,'G',0.000073,NULL,'13.6g',0.67,'SB(s)ab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,216.095583,24.61414,0,NULL,59496435187,929631799,14525496,13.6),(120403,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120403,33.83,0.4,58.3,53323,75,NULL,'HMCL, I, raw','NGC 5610',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120404,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120404,34,0.2,63.1,53323,74.4,NULL,NULL,'NGC 5610',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120405,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120405,34.02,0.4,63.8,53323,75,NULL,'HMCL, I, inv','NGC 5610',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120406,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120406,34.08,0.4,65.6,53323,75,NULL,'HMCL, I, cor','NGC 5610',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120407,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120407,38.06,0.21,409,53324,70,NULL,NULL,'2MASX J14242306+2504023',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00017,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,216.096,25.06747,0,NULL,60020517040,937820578,14653446,17.8),(120408,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120408,34.04,0.52,64.3,53325,70,NULL,NULL,'2MFGC 11695',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,216.0969583,-80.46592,0.481,NULL,44247406009,691365718,10802589,16.2),(120409,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120409,32.03,NULL,25.5,53326,72,NULL,NULL,'UGC 09225',NULL,'2014Ap.....57..457K',2014,1,1.04,NULL,'G',0.000013,NULL,'15.6g',0.49,'Sm',NULL,NULL,NULL,NULL,1,216.101333,8.27614,0.021,NULL,58274424607,910537884,14227154,15.6),(120410,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120410,37.34,0.46,294,53327,70,NULL,NULL,'2MASX J14242442+2536073',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00017,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,216.101875,25.60194,0,NULL,60020649961,937822655,14653478,16.5),(120411,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120411,38.48,0.46,498,53328,70,NULL,NULL,'SDSS J142424.67+033513.0',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000086,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,216.1027917,3.58697,0.025,NULL,58295348943,910864827,14232262,18),(120412,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120412,36.57,0.59,206,53329,70,NULL,NULL,'2MASX J14242509-2045363',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000083,NULL,'14.0I',0.5,'(R)SA(r)b pec',NULL,NULL,NULL,NULL,1,216.1045,-20.76014,0.325,NULL,46573404696,727709448,11370460,14),(120413,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120413,35.03,0.4,101,53330,NULL,NULL,'mean','ESO 446- G 059',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000033,NULL,'15.28',0.4,'Sb             HII','in a triple',NULL,NULL,NULL,1,216.104417,-28.63408,0.313,NULL,47033463360,734897865,11482779,15.28),(120414,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120414,35.25,0.55,112,53330,NULL,NULL,'Malmquist cor.','ESO 446- G 059',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120415,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120415,35.25,0.47,112,53330,NULL,NULL,'H','ESO 446- G 059',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120416,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120416,35.32,0.45,116,53330,NULL,NULL,'K','ESO 446- G 059',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120417,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120417,35.34,0.46,117,53330,NULL,NULL,'J','ESO 446- G 059',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120418,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120418,35.44,0.5,122,53330,NULL,NULL,NULL,'ESO 446- G 059',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120419,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120419,35.48,0.2,125,53330,74.4,NULL,NULL,'ESO 446- G 059',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120420,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120420,37.37,0.46,298,53331,70,NULL,NULL,'2MASX J14242566+2711054',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000186,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,216.1067917,27.18486,0,NULL,60057975728,938405870,14662591,16.5),(120421,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120421,36.83,0.46,232,53332,70,NULL,NULL,'2MASX J14242575+0444503',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000119,NULL,'15.8g',0.42,'E0',NULL,NULL,NULL,NULL,1,216.107333333,4.74744,0.057,NULL,58304503874,911007873,14234498,15.8),(120422,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120422,37.31,0.46,289,53333,70,NULL,NULL,'2MASX J14242620+0535293',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000198,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,216.109125,5.59158,0.037,NULL,58301536765,910961511,14233773,16.3),(120423,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120423,37.89,0.46,378,53334,70,NULL,NULL,'2MASX J14242710+0913045',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000153,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,216.1130417,9.21786,0.013,NULL,58268442225,910444409,14225693,17.1),(120424,'Tully est','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120424,32.93,0.8,38.6,53335,75,NULL,'B','NGC 5597',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.000017,NULL,'12.60',1.7,'SAB(s)cd       HII','in a pair',NULL,NULL,'H II',1,216.114333,-16.76275,0.349,NULL,46556517901,727445592,11366337,12.6),(120425,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120425,37.31,0.46,290,53336,70,NULL,NULL,'2MASX J14242791-0149240',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00015,NULL,'16.7b',0.32,NULL,NULL,NULL,NULL,NULL,1,216.116417,-1.82328,0.133,NULL,43519952065,679999251,10624988,16.7),(120426,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120426,35.94,0.7,154,53337,70,NULL,NULL,'2MASX J14242834-0820234',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,216.1180417,-8.33989,0.149,NULL,43530454776,680163355,10627552,14),(120427,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120427,37.92,0.16,383,53338,70,NULL,NULL,'2MASX J14242902+4024231',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,216.121,40.40639,0,NULL,59948696471,936698382,14635912,18.1),(120428,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120428,38.11,0.11,418,53339,70,NULL,NULL,'SDSS J142429.98+173020.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.124958333,17.50561,0,NULL,59488835072,929513048,14523641,18.3),(120429,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120429,38.08,0.46,414,53340,70,NULL,NULL,'2MASX J14243115+1349076',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000191,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,216.12975,13.81886,0,NULL,59479163630,929361931,14521280,17.4),(120430,'HII LF','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120430,48.81,0.4,10000,53341,71,NULL,NULL,'[PBW92] B1422+231 D081',3.107,'2005MNRAS.356.1117S',2005,1,NULL,NULL,'G',0.001,NULL,'23.41',NULL,'LBG',NULL,NULL,NULL,NULL,1,216.131,22.99764,0.062,NULL,59516584571,929946633,14530416,23.41),(120431,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120431,37.4,0.46,302,53342,70,NULL,NULL,'2MASX J14243247+6425273',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00009,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,216.135125,64.42422,0.041,NULL,57947370308,905427661,14147307,17.1),(120432,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120432,37.69,0.33,345,53343,70,NULL,NULL,'2MASX J14243247+2120397',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,216.135291667,21.34431,0,NULL,59524989809,930077965,14532468,17.4),(120433,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120433,38.39,0.46,476,53344,70,NULL,NULL,'2MASX J14243346+2732114',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000184,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,216.139333333,27.5365,0,NULL,60057834456,938403663,14662557,17.4),(120434,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120434,36.81,0.19,231,53345,70,NULL,NULL,'2MASX J14243356+2935414',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00013,NULL,'16.6g',0.23,'E',NULL,NULL,NULL,NULL,1,216.1400417,29.59489,0,NULL,60060112619,938439259,14663113,16.6),(120435,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120435,37.82,0.46,366,53346,70,NULL,NULL,'2MASX J14243478+1342416',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,216.1449583,13.71158,0,NULL,59476021116,929312829,14520512,17.8),(120436,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120436,35.11,0.46,105,53347,NULL,NULL,NULL,'UGC 09233',NULL,'2009ApJS..182..474S',2009,1,1.35,NULL,'G',0.000153,NULL,'14.6g',0.47,'S',NULL,NULL,NULL,NULL,1,216.1457917,35.27983,0,NULL,60043372380,938177693,14659026,14.6),(120437,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120437,35.12,0.46,106,53347,NULL,NULL,'Malmquist cor.','UGC 09233',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120438,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120438,35.18,0.2,109,53347,74.4,NULL,NULL,'UGC 09233',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120439,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120439,38,0.46,398,53348,70,NULL,NULL,'2MASX J14243566+3638071',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,216.1485417,36.63506,0,NULL,60031181685,937987213,14656050,17.9),(120440,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120440,37.33,0.46,292,53349,70,NULL,NULL,'2MASX J14243561+6402593',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000077,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,216.148667,64.04994,0.053,NULL,57946437661,905413088,14147079,17.4),(120441,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120441,37.03,0.23,255,53350,70,NULL,NULL,'2MASX J14243629+0244423',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00012,NULL,'15.5g',0.49,'AGN',NULL,NULL,NULL,NULL,1,216.151083,2.74514,0.053,NULL,58297128028,910892625,14232697,15.5),(120442,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120442,36.81,0.19,231,53351,70,NULL,NULL,'2MASX J14243624+2936284',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000183,NULL,'17.70',0.22,'E',NULL,NULL,NULL,NULL,1,216.151125,29.60789,0,NULL,60060114550,938439289,14663113,17.7),(120443,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120443,38.51,0.46,503,53352,70,NULL,NULL,'SDSS J142436.61+110332.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.6g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.1525417,11.05892,0.049,NULL,58267705358,910432896,14225514,18.6),(120444,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120444,37.31,0.46,290,53353,70,NULL,NULL,'2MASX J14243687+1139075',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000107,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,216.1537083,11.652,0.007,NULL,58267375515,910427742,14225433,16.8),(120445,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120445,36.33,0.46,184,53354,70,NULL,NULL,'2MASX J14243712+2841203',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000197,NULL,'15.7g',0.4,NULL,NULL,NULL,NULL,NULL,1,216.154625,28.68914,0,NULL,60055511756,938367371,14661990,15.7),(120446,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120446,37.65,0.46,339,53355,70,NULL,NULL,'2MASX J14243759+0104483',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000081,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,216.1565,1.08022,0.077,NULL,58299745700,910933526,14233336,17.5),(120447,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120447,35.53,0.33,127,53356,70,NULL,NULL,'2MASX J14243758+3601491',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000167,NULL,'16.0g',0.27,'S0^-',NULL,NULL,NULL,NULL,1,216.1567917,36.03019,0,NULL,60042746224,938167909,14658873,16),(120448,'G Lens','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120448,43.62,2.5,5300,53357,NULL,NULL,NULL,'SDSS J142438.77+225555.7',NULL,'2007ApJ...660....1O',2007,1,0.06,NULL,'G',0.0001,NULL,'21.8',0.05,NULL,NULL,NULL,NULL,NULL,1,216.161541667,22.93214,0.062,NULL,59516555002,929946171,14530408,21.8),(120449,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120449,37.9,0.33,380,53358,70,NULL,NULL,'2MASX J14243907+4436356',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000152,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,216.162667,44.60989,0,NULL,59230819550,925481555,14460649,17.1),(120450,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120450,37.69,0.33,345,53359,70,NULL,NULL,'SDSS J142439.59+212133.6',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.1649583,21.35933,0,NULL,59524923447,930076928,14532452,17.4),(120451,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120451,35.71,0.54,138,53360,70,NULL,NULL,'2MASX J14243961-0441080',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.00015,NULL,'15.9b',0.53,NULL,NULL,NULL,NULL,NULL,1,216.1652083,-4.68558,0.133,NULL,43540288711,680317011,10629953,15.9),(120452,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SN 2002bz',NULL,120452,35.37,0.17,114,53361,74.2,NULL,'SALT 2','CGCG 163-041',0.037152,'2010ApJ...716..712A',2010,1,0.96,NULL,'G',0.000067,NULL,'14.9g',0.66,'S?','Group member of poor cluster',NULL,'radio jet',NULL,1,216.168875,26.62517,0,NULL,60054547383,938352302,14661754,14.9),(120453,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SN 2002bz',NULL,120453,36.01,0.09,159,53361,74.4,NULL,NULL,'CGCG 163-041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120454,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SN 2002bz',NULL,120454,36.24,0.17,170,53361,70,NULL,'SALT 2','CGCG 163-041',0.037152,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120455,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SN 2002bz',NULL,120455,36.25,0.18,172,53361,65,NULL,'MLCS17','CGCG 163-041',0.037152,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120456,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SN 2002bz',NULL,120456,36.38,0.25,182,53361,65,NULL,'SALT2','CGCG 163-041',0.037152,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120457,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120457,36.28,0.15,180,53361,70,NULL,NULL,'CGCG 163-041',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120458,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120458,36.33,0.46,185,53362,70,NULL,NULL,'CGCG 273-005',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000107,NULL,'15.0g',0.68,'E0',NULL,NULL,NULL,NULL,1,216.17325,55.70561,0,NULL,57254930219,894608284,13978254,15),(120459,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120459,38.11,0.11,418,53363,70,NULL,NULL,'2MASX J14244233+1735464',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,216.1764583,17.59636,0,NULL,59488686486,929510726,14523605,17.4),(120460,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120460,32.09,0.69,26.2,53364,100,NULL,'mid-IR','NGC 5604',NULL,'2013ApJ...771...88L',2013,1,1.8,NULL,'G',0.000013,NULL,'13.57',1,'Sa',NULL,NULL,NULL,NULL,1,216.178333,-3.21217,0.161,NULL,43508978075,679827782,10622309,13.57),(120461,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120461,33,0.45,39.8,53364,NULL,NULL,'K','NGC 5604',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120462,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120462,33.02,0.47,40.1,53364,NULL,NULL,'H','NGC 5604',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120463,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120463,33.11,0.46,41.9,53364,NULL,NULL,'J','NGC 5604',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120464,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120464,33.12,0.4,42,53364,NULL,NULL,'mean','NGC 5604',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120465,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120465,33.13,0.57,42.2,53364,NULL,NULL,'Malmquist cor.','NGC 5604',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120466,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120466,33.21,0.43,43.8,53364,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5604',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120467,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120467,33.26,0.54,44.8,53364,NULL,NULL,NULL,'NGC 5604',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120468,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120468,33.32,0.43,46.2,53364,75,NULL,'3.6 micron, color corrected','NGC 5604',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120469,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120469,33.36,0.2,47,53364,74.4,NULL,NULL,'NGC 5604',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120470,'TRGB','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120470,27.17,0.1,2.72,53365,NULL,NULL,NULL,'UGC 09240',NULL,'2012A&A...540A..49M',2012,1,1.8,NULL,'G',0.000012,NULL,'13.25',1.8,'IAm','Field galaxy',NULL,NULL,NULL,1,216.180833,44.52578,0,1,59230819065,925481547,14460649,13.25),(120471,'TRGB','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120471,27.23,0.2,2.79,53365,NULL,NULL,NULL,'UGC 09240',NULL,'2002A&A...389..812K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120472,'TRGB','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120472,27.23,0.03,2.79,53365,NULL,NULL,'I','UGC 09240',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120473,'TRGB','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120473,27.23,0.12,2.79,53365,NULL,NULL,NULL,'UGC 09240',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120474,'TRGB','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120474,27.24,0.04,2.8,53365,NULL,NULL,NULL,'UGC 09240',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120475,'TRGB','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120475,27.25,0.08,2.82,53365,74.4,NULL,NULL,'UGC 09240',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120476,'TRGB','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120476,27.26,0.03,2.83,53365,NULL,NULL,'I','UGC 09240',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120477,'TRGB','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120477,27.31,0.14,2.9,53365,NULL,NULL,NULL,'UGC 09240',NULL,'2000AJ....119.2183A',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120478,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120478,27.82,0.4,3.7,53365,75,NULL,'B','UGC 09240',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120479,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120479,36.64,0.46,213,53366,70,NULL,NULL,'2MASX J14244342-0134127',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000175,NULL,'16.2g',0.33,'S0^-',NULL,NULL,NULL,NULL,1,216.181,-1.57031,0.129,NULL,43519643197,679994424,10624912,16.2),(120480,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120480,36.17,0.46,172,53367,70,NULL,NULL,'2MASX J14244357+4701577',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000187,NULL,'15.8g',0.38,'S0',NULL,NULL,NULL,NULL,1,216.181417,47.03267,0.016,NULL,59228081191,925438768,14459980,15.8),(120481,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120481,36.38,0.46,189,53368,70,NULL,NULL,'2MASX J14244449+2308237',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,216.185333333,23.13992,0.06,NULL,59516476762,929944949,14530389,17.3),(120482,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120482,36.81,0.19,231,53369,70,NULL,NULL,'CGCG 163-042',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000191,NULL,'15.2g',0.51,NULL,NULL,NULL,NULL,NULL,1,216.190625,29.46017,0,NULL,60060126532,938439477,14663116,15.2),(120483,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120483,37.27,0.46,284,53370,70,NULL,NULL,'2MASX J14244575+5130178',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000165,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,216.190833,51.50486,0.005,NULL,59202739817,925042809,14453793,16.7),(120484,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120484,37.87,0.46,375,53371,70,NULL,NULL,'2MASX J14244582-0117197',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,216.1910417,-1.28872,0.117,NULL,43517795425,679965553,10624461,17.8),(120485,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120485,37.88,0.33,377,53372,70,NULL,NULL,'2MASX J14244588-0135567',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,216.1912083,-1.59906,0.125,NULL,43519640659,679994385,10624912,18),(120486,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120486,36.28,0.15,180,53373,70,NULL,NULL,'2MASX J14244724+2617176',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000117,NULL,'15.8g',0.45,NULL,NULL,NULL,NULL,NULL,1,216.196791667,26.28819,0,NULL,60054489780,938351402,14661740,15.8),(120487,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120487,37.03,0.23,255,53374,70,NULL,NULL,'2MASX J14244743+0239520',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000114,NULL,'15.2g',0.61,'BrClG',NULL,NULL,NULL,NULL,1,216.1975417,2.66444,0.053,NULL,58297000892,910890638,14232666,15.2),(120488,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120488,38.02,0.46,401,53375,70,NULL,NULL,'2MASX J14244751+2824296',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,216.197875,28.40839,0,NULL,60055533246,938367706,14661995,17.4),(120489,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120489,36.66,0.46,215,53376,70,NULL,NULL,'2MASX J14244762+0729567',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,216.1985,7.49897,0.029,NULL,58274742141,910542845,14227231,17),(120490,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120490,35.71,0.46,139,53377,70,NULL,NULL,'VIII Zw 413',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.00019,NULL,'15.4g',0.55,'E0',NULL,NULL,NULL,NULL,1,216.202375,-2.21553,0.133,NULL,43519846494,679997601,10624962,15.4),(120491,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120491,33.84,0.2,58.6,53378,74.4,NULL,NULL,'UGC 09238',NULL,'2013AJ....146...86T',2013,1,1.11,NULL,'G',0.000087,NULL,'15.5g',0.4,'Scd:',NULL,NULL,NULL,NULL,1,216.207208333,35.28492,0,NULL,60043364558,938177571,14659024,15.5),(120492,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120492,34.04,0.44,64.2,53378,NULL,NULL,'Malmquist cor.','UGC 09238',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120493,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120493,34.08,0.43,65.5,53378,NULL,NULL,NULL,'UGC 09238',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120494,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120494,37.24,0.46,280,53379,70,NULL,NULL,'LCRS B142215.1-022545',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000151,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,216.210833,-2.65469,0.169,NULL,43516579964,679946561,10624165,17.4),(120495,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120495,36.81,0.19,231,53380,70,NULL,NULL,'2MASX J14245111+2920467',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000182,NULL,'15.37',0.3,'Sb',NULL,NULL,NULL,NULL,1,216.2130417,29.34617,0,NULL,60060313154,938442393,14663162,15.37),(120496,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120496,38.11,0.11,418,53381,70,NULL,NULL,'2MASX J14245219+1739425',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,216.2175417,17.66194,0,NULL,59488694283,929510848,14523607,17.8),(120497,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120497,37.32,0.27,292,53382,70,NULL,NULL,'2MASX J14245257+3451474',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,216.2190417,34.86322,0,NULL,60038740639,938105322,14657895,17.8),(120498,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120498,36.86,0.09,235,53383,70,NULL,NULL,'IC 4417',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'15.5',0.2,'S0/D','Group member',NULL,NULL,NULL,1,216.223708333,17.03792,0,NULL,59488481871,929507529,14523555,15.5),(120499,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120499,37.31,0.46,290,53384,70,NULL,NULL,'2MASX J14245382+5457169',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000155,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,216.224375,54.95481,0.005,NULL,57254095606,894595243,13978050,17.6),(120500,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120500,33.9,0.8,60.3,53385,75,NULL,'HMCL, I','UGC 09236',NULL,'1997ApJS..109..333W',1997,1,1.39,NULL,'G',0.000027,NULL,'14.9g',0.39,'SBbc?',NULL,NULL,NULL,NULL,1,216.235875,25.02478,0,NULL,60020510550,937820477,14653444,14.9),(120501,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120501,34.01,0.4,63.5,53385,75,NULL,'HMCL, I, raw','UGC 09236',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120502,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120502,34.11,0.4,66.3,53385,75,NULL,'HMCL, I, inv','UGC 09236',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120503,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120503,34.2,0.4,69.1,53385,75,NULL,'HMCL, I, cor','UGC 09236',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120504,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120504,34.26,0.2,71.1,53385,74.4,NULL,NULL,'UGC 09236',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120505,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120505,37.39,0.27,300,53386,70,NULL,NULL,'SDSS J142456.97+475355.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,216.237416667,47.89872,0.024,NULL,59248070740,925751105,14464861,17.4),(120506,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120506,35.58,0.45,130,53387,NULL,NULL,NULL,'2MASX J14245831+3521164',NULL,'2009ApJS..182..474S',2009,1,0.74,NULL,'G',0.00001,NULL,'16.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,216.242917,35.35456,0,NULL,60043364283,938177566,14659024,16.5),(120507,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120507,35.57,0.45,130,53387,NULL,NULL,'Malmquist cor.','2MASX J14245831+3521164',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120508,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120508,35.62,0.2,133,53387,74.4,NULL,NULL,'2MASX J14245831+3521164',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120509,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120509,37.39,0.46,301,53388,70,NULL,NULL,'2MASX J14245842+5229370',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,216.2435417,52.49369,0,NULL,59195766250,924933847,14452091,17.2),(120510,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120510,36.18,0.74,172,53389,70,NULL,NULL,'CGCG 019-018 NED01',NULL,'2014MNRAS.445.2677S',2014,1,1.04,'Often confused with CGCG 019-018 NED02 at z = 0.031.','G',0.00012,NULL,'16.6b',0.3,'Sc',NULL,NULL,NULL,NULL,1,216.246375,-3.06703,0.153,NULL,43508985587,679827899,10622310,16.6),(120511,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120511,38.06,0.46,409,53390,70,NULL,NULL,'2MASX J14250106+5703549',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000146,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,216.254375,57.06525,0,NULL,57250112826,894533012,13977078,17.9),(120512,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120512,37.15,0.46,269,53391,70,NULL,NULL,'2MASX J14250113+1142417',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,216.254625,11.71172,0,NULL,58267506029,910429781,14225465,17),(120513,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120513,36.81,0.19,231,53392,70,NULL,NULL,'2MASX J14250112+2950478',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000173,NULL,'16.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,216.2547917,29.84664,0,NULL,60059758086,938433720,14663026,16.5),(120514,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120514,37.39,0.27,300,53393,70,NULL,NULL,'2MASX J14250144+4757128',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000221,NULL,'15.8g',0.45,NULL,NULL,NULL,NULL,NULL,1,216.256083,47.9535,0.024,NULL,59248029482,925750460,14464850,15.8),(120515,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120515,37.78,0.46,360,53394,70,NULL,NULL,'2MASX J14250156+2415298',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000188,NULL,'17.3g',0.23,'AGN',NULL,NULL,NULL,NULL,1,216.25675,24.25844,0.024,NULL,59513124995,929892578,14529571,17.3),(120516,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120516,36.31,0.46,183,53395,70,NULL,NULL,'2MASX J14250306+0435110',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000064,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,216.2627083,4.58639,0.033,NULL,58304520279,911008129,14234502,16.7),(120517,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120517,35.52,0.54,127,53396,70,NULL,NULL,'2MASX J14250311-4449336',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'17.2b',0.2,NULL,NULL,NULL,NULL,NULL,1,216.263083,-44.82606,0.365,NULL,46801992061,731281125,11426267,17.2),(120518,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120518,38.18,0.46,433,53397,70,NULL,NULL,'SDSS J142503.46+343748.9',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'18.1g',0.16,'E/S0',NULL,NULL,NULL,NULL,1,216.264458333,34.63028,0,NULL,60038796043,938106188,14657909,18.1),(120519,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120519,38.09,0.46,415,53398,70,NULL,NULL,'2MASX J14250368+0552080',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,216.265375,5.86881,0.033,NULL,58301398715,910959354,14233739,17.7),(120520,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120520,37.5,0.46,316,53399,70,NULL,NULL,'2MASX J14250379+4418108',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,216.2657917,44.30292,0,NULL,59229984825,925468512,14460445,17.6),(120521,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120521,39.16,0.46,681,53400,70,NULL,NULL,'SDSS J142504.63+180937.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.269333,18.16053,0,NULL,59488026631,929500416,14523444,18.2),(120522,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120522,36.86,0.09,235,53401,70,NULL,NULL,'2MASX J14250562+1709335',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,216.273375,17.15928,0,NULL,59488525241,929508206,14523565,17.5),(120523,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120523,38.11,0.11,418,53402,70,NULL,NULL,'2MASX J14250618+1740215',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.87',0.13,NULL,NULL,NULL,NULL,NULL,1,216.275625,17.67275,0,NULL,59488724479,929511319,14523614,18.87),(120524,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120524,38.78,0.46,571,53403,70,NULL,NULL,'SDSS J142506.81+253257.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.278416667,25.54919,0,NULL,60020671834,937822997,14653484,18.4),(120525,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120525,36.65,0.46,214,53404,70,NULL,NULL,'2MASX J14250749+3603270',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000174,NULL,'16.0g',0.41,NULL,NULL,NULL,NULL,NULL,1,216.28125,36.05742,0,NULL,60042753719,938168026,14658875,16),(120526,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120526,33.58,0.4,52.1,53405,NULL,NULL,'mean','NGC 5605',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000023,NULL,'13.19',1.3,'(R\')SAB(rs)c   HII',NULL,NULL,NULL,NULL,1,216.281541667,-13.163,0.309,NULL,46540988822,727202950,11362546,13.19),(120527,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120527,33.87,0.47,59.4,53405,NULL,NULL,'H','NGC 5605',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120528,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120528,33.88,0.45,59.6,53405,NULL,NULL,'K','NGC 5605',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120529,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120529,33.89,0.46,60.1,53405,NULL,NULL,'J','NGC 5605',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120530,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120530,38.25,0.46,446,53406,70,NULL,NULL,'2MASX J14250811+4219208',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000178,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,216.283583,42.32233,0,NULL,59948116530,936689320,14635770,17.3),(120531,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120531,37.54,0.33,322,53407,70,NULL,NULL,'2MASX J14250982+1348143',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,216.290833,13.80411,0,NULL,59479046377,929360099,14521251,17.8),(120532,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120532,37.13,0.46,267,53408,70,NULL,NULL,'2MASX J14251004+6040455',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,216.2917917,60.67939,0.009,NULL,57755493588,902429587,14100462,16.7),(120533,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120533,36.18,0.46,172,53409,70,NULL,NULL,'2MASX J14251252+3328254',NULL,'2015arXiv151105856S',2015,1,0.51,'Sanchez-Blazquez et al (2009MNRAS.400.1264S) give z=0.133.','G',0.000188,NULL,'16.0g',0.39,'E/S0',NULL,NULL,NULL,NULL,1,216.3022083,33.47372,0,NULL,60040031698,938125495,14658210,16),(120534,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120534,37.49,0.46,315,53410,70,NULL,NULL,'2MASX J14251327+2949348',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000185,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,216.30525,29.82639,0,NULL,60059755912,938433686,14663026,16.2),(120535,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120535,34.49,0.49,79,53411,75,NULL,'IR','UGC 09239',NULL,'2011yCatp016004901K',2011,1,1.14,NULL,'G',0.000033,NULL,'16.6g',0.21,'Sbc',NULL,NULL,NULL,NULL,1,216.3055,13.74581,0,NULL,59475572434,929305819,14520403,16.6),(120536,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120536,34.97,0.2,98.6,53411,74.4,NULL,NULL,'UGC 09239',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120537,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120537,35.08,0.37,104,53411,NULL,NULL,'Malmquist cor.','UGC 09239',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120538,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120538,35.2,0.35,109,53411,NULL,NULL,NULL,'UGC 09239',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120539,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120539,36.8,0.46,229,53412,70,NULL,NULL,'2MASX J14251406+1120334',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.0001,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,216.3085,11.34264,0.008,NULL,58268231727,910441120,14225642,16.7),(120540,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120540,38.05,0.46,407,53413,70,NULL,NULL,'2MASX J14251447+2448558',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000193,NULL,'18.22',0.16,NULL,NULL,NULL,NULL,NULL,1,216.3102917,24.81544,0.006,NULL,59496428360,929631693,14525495,18.22),(120541,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120541,38.13,0.46,424,53414,70,NULL,NULL,'2MASX J14251479-0018286',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000297,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,216.311667,-0.308,0.105,NULL,43505454263,679772722,10621448,17.8),(120542,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120542,37.7,0.46,347,53415,70,NULL,NULL,'SDSS J142514.87+143440.9',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.311958333,14.57806,0,NULL,59479254783,929363355,14521302,18.4),(120543,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120543,37.35,0.46,295,53416,70,NULL,NULL,'2MASX J14251520+4404388',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000172,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,216.3132917,44.07739,0,NULL,59954643523,936791305,14637364,16.9),(120544,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120544,36.86,0.09,235,53417,70,NULL,NULL,'2MASX J14251593+1641303',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.60',0.13,NULL,NULL,NULL,NULL,NULL,1,216.316417,16.69189,0,NULL,59491318969,929551858,14524247,18.6),(120545,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120545,35.76,0.51,142,53418,70,NULL,NULL,'2MASX J14251727-1455467',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,216.3219583,-14.92967,0.293,NULL,46543373963,727240218,11363128,14.3),(120546,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120546,37.95,0.46,389,53419,70,NULL,NULL,'2MASX J14251742+1609303',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,216.32275,16.15836,0,NULL,59491049636,929547650,14524182,17.3),(120547,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120547,37.11,0.46,264,53420,70,NULL,NULL,'2MASX J14251850+2314177',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000179,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,216.327167,23.23822,0.06,NULL,59516623578,929947243,14530425,16.4),(120548,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120548,37.44,0.46,307,53421,70,NULL,NULL,'2MASX J14251861+4029230',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000175,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,216.327417,40.48978,0,NULL,59948883107,936701298,14635957,16.5),(120549,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120549,37.68,0.33,343,53422,70,NULL,NULL,'2MASX J14251945+0020535',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00007,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,216.331083333,0.34817,0.101,NULL,58298764975,910918202,14233096,17.4),(120550,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120550,37.54,0.46,322,53423,70,NULL,NULL,'SDSS J142520.09+054512.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,216.3337083,5.75347,0.033,NULL,58304253251,911003957,14234436,17.8),(120551,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120551,37.63,0.46,335,53424,70,NULL,NULL,'2MASX J14252017+2332007',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00019,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,216.3340417,23.53347,0.051,NULL,59513726211,929901972,14529718,17),(120552,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120552,30.69,NULL,13.8,53425,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09242',NULL,'2010Ap&SS.325..163P',2010,1,5.69,NULL,'G',0.00001,NULL,'14.0B',0.36,'Sc',NULL,NULL,NULL,NULL,1,216.337583,39.53958,0.028,NULL,60065859518,938529054,14664516,14),(120553,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120553,30.72,NULL,13.9,53425,NULL,NULL,'Dipole + Quadrupole','UGC 09242',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120554,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120554,30.72,NULL,13.9,53425,NULL,NULL,'Dipole','UGC 09242',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120555,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120555,30.85,NULL,14.8,53425,NULL,NULL,NULL,'UGC 09242',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120556,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120556,31.68,0.36,21.7,53425,NULL,NULL,NULL,'UGC 09242',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120557,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120557,32.07,0.2,25.9,53425,74.4,NULL,NULL,'UGC 09242',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120558,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120558,32.1,0.4,26.3,53425,75,NULL,'B','UGC 09242',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120559,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120559,32.15,0.43,26.9,53425,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09242',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120560,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120560,32.17,0.43,27.1,53425,75,NULL,'3.6 micron, color corrected','UGC 09242',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120561,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120561,38.15,0.46,427,53426,70,NULL,NULL,'2MASX J14252121+2605163',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.55',0.16,NULL,NULL,NULL,NULL,NULL,1,216.3384583,26.08783,0,NULL,60021092114,937829564,14653586,18.55),(120562,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120562,36.86,0.09,235,53427,70,NULL,NULL,'CGCG 104-018',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000207,NULL,'15.5',0.6,'S0','Group member',NULL,NULL,NULL,1,216.3410417,17.29081,0,NULL,59488504796,929507887,14523560,15.5),(120563,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120563,37.76,0.46,356,53428,70,NULL,NULL,'2MASX J14252265+1403223',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,216.344417,14.05633,0,NULL,59479071703,929360495,14521257,16.9),(120564,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120564,36.28,0.15,180,53429,70,NULL,NULL,'2MASX J14252442+2556314',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000197,NULL,'17.04',0.32,NULL,NULL,NULL,NULL,NULL,1,216.351916667,25.94217,0,NULL,60021094545,937829602,14653587,17.04),(120565,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120565,37.94,0.46,387,53430,70,NULL,NULL,'2MASX J14252572+4711442',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,216.357,47.19561,0,NULL,59228063365,925438490,14459976,17.5),(120566,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120566,38.53,0.46,509,53431,70,NULL,NULL,'2MASX J14252610+3303504',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000174,NULL,'17.6g',0.2,'E/S0',NULL,NULL,NULL,NULL,1,216.358625,33.06411,0,NULL,60040184873,938127888,14658248,17.6),(120567,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120567,37.54,0.33,322,53432,70,NULL,NULL,'2MASX J14252623+1348373',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,216.35925,13.81047,0,NULL,59479039471,929359991,14521249,17.1),(120568,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120568,37.36,0.33,296,53433,70,NULL,NULL,'2MASX J14252645+4408092',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000182,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,216.360375,44.13583,0,NULL,59954580597,936790321,14637348,16.7),(120569,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120569,31.04,0.43,16.2,53434,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09245',NULL,'2014MNRAS.444..527S',2014,1,1.65,NULL,'G',0.000013,NULL,'15.5g',0.34,'SB(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,216.361917,56.32017,0,NULL,57257478376,894648099,13978876,15.5),(120570,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120570,31.07,0.63,16.4,53434,NULL,NULL,NULL,'UGC 09245',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120571,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120571,31.17,0.2,17.1,53434,74.4,NULL,NULL,'UGC 09245',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120572,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120572,31.22,0.43,17.5,53434,75,NULL,'3.6 micron, color corrected','UGC 09245',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120573,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120573,31.23,0.58,17.6,53434,NULL,NULL,'Malmquist cor.','UGC 09245',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120574,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120574,36.34,0.46,186,53435,70,NULL,NULL,'2MASX J14253013+0655214',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000185,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,216.375583,6.92269,0.029,NULL,58275473679,910554276,14227410,16.7),(120575,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120575,38.11,0.11,418,53436,70,NULL,NULL,'2MASX J14253096+1749243',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,216.379,17.82336,0,NULL,59487955500,929499304,14523426,17.8),(120576,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120576,36.66,0.46,215,53437,70,NULL,NULL,'2MASX J14253276+0746344',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000176,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,216.3864583,7.77622,0.021,NULL,58274131608,910533306,14227082,16.9),(120577,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120577,33.29,0.2,45.5,53438,74.4,NULL,NULL,'UGC 09243',NULL,'2013AJ....146...86T',2013,1,1.19,NULL,'G',0.000033,NULL,'15.4g',0.53,'Scd:',NULL,NULL,NULL,NULL,1,216.388458333,33.84811,0,NULL,60040521118,938133142,14658330,15.4),(120578,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120578,33.59,0.49,52.4,53438,NULL,NULL,NULL,'UGC 09243',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120579,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120579,33.72,0.46,55.4,53438,NULL,NULL,'Malmquist cor.','UGC 09243',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120580,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120580,37.18,0.46,273,53439,70,NULL,NULL,'2MASX J14253327+3935298',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000167,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,216.38875,39.59167,0.028,NULL,60065873398,938529271,14664519,16.2),(120581,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120581,37.68,0.33,343,53440,70,NULL,NULL,'2MASX J14253432+0019565',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000081,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,216.393167,0.33247,0.101,NULL,58298777204,910918393,14233099,16.9),(120582,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120582,38.11,0.11,418,53441,70,NULL,NULL,'2MASX J14253628+1743433',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.13',0.18,'BrClG',NULL,NULL,NULL,NULL,1,216.40125,17.72867,0,NULL,59488680228,929510628,14523603,18.13),(120583,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120583,37.34,0.46,294,53442,70,NULL,NULL,'2MASX J14253648+2620574',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000127,NULL,'18.14',0.2,NULL,NULL,NULL,NULL,NULL,1,216.401917,26.34928,0,NULL,60054457793,938350903,14661732,18.14),(120584,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120584,38.11,0.11,418,53443,70,NULL,NULL,'2MASX J14253914+1742219',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,216.413208333,17.70614,0,NULL,59488681343,929510645,14523603,17.3),(120585,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120585,33.87,0.8,59.6,53444,75,NULL,'HMCL, I','IC 4420',NULL,'1997ApJS..109..333W',1997,1,0.88,NULL,'G',0.000027,NULL,'15.6g',0.32,'SB(b)',NULL,NULL,NULL,NULL,1,216.4142083,25.37836,0,NULL,60020703027,937823484,14653491,15.6),(120586,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120586,33.6,0.4,52.4,53444,75,NULL,'HMCL, I, raw','IC 4420',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120587,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120587,33.61,0.4,52.8,53444,75,NULL,'HMCL, I, inv','IC 4420',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120588,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120588,33.92,0.4,60.8,53444,75,NULL,'HMCL, I, cor','IC 4420',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120589,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120589,37.03,0.46,255,53445,70,NULL,NULL,'2MASX J14253952+2709384',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000182,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,216.4147917,27.16067,0,NULL,60057740556,938402196,14662534,16.7),(120590,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120590,38.52,0.46,505,53446,70,NULL,NULL,'2MASX J14254036+2345131',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000172,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,216.418125,23.75367,0.043,NULL,59513740978,929902202,14529721,18.3),(120591,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120591,36.99,0.46,250,53447,70,NULL,NULL,'2MASX J14254059+1454440',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.26',0.16,NULL,NULL,NULL,NULL,NULL,1,216.4190417,14.91206,0,NULL,59478526942,929351983,14521124,18.26),(120592,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120592,37.8,0.33,363,53448,70,NULL,NULL,'2MASX J14254111+3222225',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000183,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,216.421417,32.37297,0,NULL,60047358077,938239969,14659999,17),(120593,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120593,37.78,0.46,360,53449,70,NULL,NULL,'SDSS J142541.49+035914.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000076,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,216.422875,3.98736,0.049,NULL,58294986644,910859166,14232174,18.2),(120594,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120594,37.36,0.33,296,53450,70,NULL,NULL,'2MASX J14254271+4411222',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000159,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,216.428,44.18939,0,NULL,59954593298,936790520,14637351,17),(120595,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120595,36.86,0.09,235,53451,70,NULL,NULL,'2MASX J14254279+1644450',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.01',0.2,'S0/E','Group member',NULL,NULL,NULL,1,216.428333,16.746,0,NULL,59491308287,929551691,14524245,17.01),(120596,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120596,37.61,0.27,333,53452,70,NULL,NULL,'2MASX J14254280+2542404',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000158,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,216.428333,25.71133,0,NULL,60021400529,937834383,14653662,18.1),(120597,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120597,37.7,0.46,347,53453,70,NULL,NULL,'2MASX J14254294+5538494',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,216.429,55.64703,0.005,NULL,57254872973,894607390,13978240,17),(120598,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120598,37.8,0.33,363,53454,70,NULL,NULL,'2MASX J14254459+3221395',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000184,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,216.435833,32.36089,0,NULL,60047358137,938239970,14659999,16.2),(120599,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120599,37.25,0.46,282,53455,70,NULL,NULL,'SDSS J142544.65+221207.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.75',0.14,NULL,NULL,NULL,NULL,NULL,1,216.436083,22.20214,0.017,NULL,59515773118,929933954,14530218,18.75),(120600,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120600,30.79,0.43,14.4,53456,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-37-006',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.00001,NULL,'13.88',0.6,'I0 pec?        HII',NULL,NULL,NULL,NULL,1,216.439125,-5.40192,0.125,NULL,43540715303,680323676,10630057,13.88),(120601,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120601,36.86,0.09,235,53457,70,NULL,NULL,'2MASX J14254612+1702300',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.62',0.13,'S0','Group member',NULL,NULL,NULL,1,216.4422083,17.04161,0,NULL,59488501408,929507834,14523559,18.62),(120602,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120602,36.95,0.46,246,53458,70,NULL,NULL,'2MASX J14254690+1752420',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,216.4452917,17.87847,0,NULL,59487951465,929499241,14523425,17.5),(120603,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120603,36.23,0.46,176,53459,70,NULL,NULL,'2MASX J14254760+2814104',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000173,NULL,'16.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,216.448333,28.23625,0,NULL,60056102260,938376597,14662134,16.1),(120604,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120604,38.51,0.33,504,53460,70,NULL,NULL,'LCRS B142312.9-021859',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000163,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,216.4515,-2.54108,0.173,NULL,43516721623,679948775,10624199,18.2),(120605,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120605,37.77,0.46,358,53461,70,NULL,NULL,'2MASX J14254893+1204520',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'18.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,216.453667,12.08103,0,NULL,59357852016,927466437,14491663,18),(120606,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120606,37.05,0.46,258,53462,70,NULL,NULL,'2MASX J14254913+2008481',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'16.79',0.2,NULL,NULL,NULL,NULL,NULL,1,216.454667,20.14664,0.023,NULL,59522777802,930043403,14531928,16.79),(120607,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120607,33.94,0.48,61.3,53463,70,NULL,NULL,'2MASX J14255221-4221512',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,216.4675417,-42.36425,0.401,NULL,47078852464,735607069,11493860,14),(120608,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120608,34.06,0.2,64.9,53464,74.4,NULL,NULL,'ESO 511- G 040',NULL,'2013AJ....146...86T',2013,1,2,NULL,'G',0.000017,NULL,'15.5',1.2,'Sc',NULL,NULL,NULL,NULL,1,216.475333333,-23.97872,0.257,NULL,46565614499,727587726,11368558,15.5),(120609,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120609,37.48,0.46,313,53465,70,NULL,NULL,'2MASX J14255504+3532176',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000141,NULL,'17.5g',0.22,'E/S0',NULL,NULL,NULL,NULL,1,216.479375,35.53817,0,NULL,60042666229,938166659,14658854,17.5),(120610,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120610,38.11,0.11,418,53466,70,NULL,NULL,'2MASX J14255545+1749340',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,216.4809583,17.82631,0,NULL,59487947922,929499186,14523424,17.7),(120611,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120611,37.74,0.33,353,53467,70,NULL,NULL,'2MASX J14255592+0405321',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000074,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,216.483125,4.09211,0.037,NULL,58302502813,910976606,14234009,17.1),(120612,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120612,38,0.46,398,53468,70,NULL,NULL,'2MASX J14255605+1426180',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,216.483666667,14.43831,0,NULL,59479285455,929363835,14521309,NULL),(120613,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120613,37.15,0.46,269,53469,70,NULL,NULL,'2MASX J14255631-0215101',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000158,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,216.484667,-2.25283,0.169,NULL,43516236066,679941188,10624081,16.9),(120614,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120614,37.86,0.33,373,53470,70,NULL,NULL,'2MASX J14255640+0614557',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000172,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,216.485083333,6.24867,0.025,NULL,58273093387,910517084,14226829,17.1),(120615,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120615,38,0.46,399,53471,70,NULL,NULL,'SDSS J142556.45+234221.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,216.4852083,23.70594,0.043,NULL,59513745744,929902277,14529723,18.4),(120616,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120616,38.65,0.46,538,53472,70,NULL,NULL,'2MASX J14255682+1341510',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00014,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,216.486833,13.69758,0,NULL,59475621932,929306592,14520415,18.1),(120617,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120617,38.51,0.33,504,53473,70,NULL,NULL,'LCRS B142322.6-021610',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000162,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,216.4915417,-2.49417,0.173,NULL,43516711265,679948613,10624197,18.5),(120618,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120618,39.3,0.46,726,53474,70,NULL,NULL,'2MASXi J1425579+250504',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000183,NULL,'17.9g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.491583333,25.08461,0.036,NULL,60020601697,937821901,14653467,17.9),(120619,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120619,37.48,0.33,313,53475,70,NULL,NULL,'2MASX J14255962+0621557',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,216.498417,6.36542,0.025,NULL,58273087486,910516991,14226827,17.8),(120620,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120620,38.61,0.46,527,53476,70,NULL,NULL,'2MASX J14260114+3651190',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,216.504958333,36.85517,0,NULL,60063645026,938494453,14663975,18.1),(120621,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120621,37.76,0.46,357,53477,70,NULL,NULL,'2MASX J14260173+3508546',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.5g',0.17,'S0',NULL,NULL,NULL,NULL,1,216.5072083,35.14856,0,NULL,60039240324,938113130,14658017,17.5),(120622,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120622,37.04,0.46,256,53478,70,NULL,NULL,'2MASX J14260190+3007256',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000165,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,216.507917,30.12372,0,NULL,60059764098,938433814,14663028,16.8),(120623,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120623,37.99,0.46,396,53479,70,NULL,NULL,'2MASX J14260214+0128251',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00008,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,216.5089583,1.47361,0.065,NULL,58299221514,910925336,14233208,17.5),(120624,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120624,35.39,0.46,120,53480,70,NULL,NULL,'CGCG 047-039',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000177,NULL,'15.5g',0.54,NULL,NULL,NULL,NULL,NULL,1,216.509667,8.11125,0.037,NULL,58282436742,910663074,14229110,15.5),(120625,'SZ effect','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120625,38.22,0.23,440,53481,NULL,NULL,'Hydrost. Eq.','ABELL 1914',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II:    [BM]',NULL,NULL,NULL,NULL,1,216.506667,37.82722,0,NULL,60064174811,938502731,14664105,NULL),(120626,'SZ effect','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120626,38.88,NULL,596,53481,NULL,NULL,'3.1 (red) calibration','ABELL 1914',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120627,'SZ effect','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120627,39.13,0.39,670,53481,NULL,NULL,'Isotherm., r < 100 kpc','ABELL 1914',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120628,'SZ effect','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120628,39.16,NULL,678,53481,NULL,NULL,'4.2 (black) calibration','ABELL 1914',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120629,'SZ effect','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120629,39.16,0.38,680,53481,NULL,NULL,'Isotherm.','ABELL 1914',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120630,'SZ effect','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120630,39.55,NULL,812,53481,NULL,NULL,'4.1 (blue) calibration','ABELL 1914',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120631,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120631,38.3,0.27,458,53482,70,NULL,NULL,'2MASX J14260298+2255233',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000141,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,216.5125417,22.92308,0.056,NULL,59516547771,929946058,14530407,17.9),(120632,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120632,37.86,0.33,373,53483,70,NULL,NULL,'SDSS J142603.05+061445.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000167,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,216.5127083,6.24608,0.025,NULL,58273103134,910517236,14226831,18),(120633,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120633,36.13,0.57,169,53484,70,NULL,NULL,'LCRS B142321.0-122145',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000127,NULL,'16.05',NULL,NULL,NULL,NULL,NULL,NULL,1,216.5142917,-12.58736,0.313,NULL,46674444929,729288202,11395128,16.05),(120634,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120634,37.41,0.33,303,53485,70,NULL,NULL,'2MASX J14260359+2434519',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000142,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,216.514958333,24.58114,0.019,NULL,59496286198,929629471,14525460,17.4),(120635,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120635,38.21,0.46,439,53486,70,NULL,NULL,'2MASX J14260431+3022206',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000205,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,216.517958333,30.37219,0,NULL,60048302751,938254730,14660230,17.3),(120636,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120636,37.78,0.46,359,53487,70,NULL,NULL,'2MASX J14260478+1940123',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,216.5199583,19.67017,0.034,NULL,59522872830,930044887,14531951,17.8),(120637,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120637,37.54,0.33,322,53488,70,NULL,NULL,'2MASX J14260486-0132201',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000176,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,216.520167,-1.53894,0.101,NULL,43519590499,679993601,10624900,17.4),(120638,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120638,36.83,0.46,232,53489,70,NULL,NULL,'2MASX J14260572+2448159',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000186,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,216.523833,24.80447,0.036,NULL,59496382962,929630983,14525484,16.8),(120639,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120639,37.54,0.46,321,53490,70,NULL,NULL,'2MASX J14260646+1232510',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000189,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,216.526791667,12.54747,0,NULL,59542554477,930352413,14536756,16.8),(120640,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120640,38.14,0.33,425,53491,70,NULL,NULL,'2MASX J14260717+5717225',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000192,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,216.529916667,57.28972,0,NULL,57249950093,894530470,13977038,17.2),(120641,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120641,34.62,0.69,83.8,53492,100,NULL,'mid-IR','UGC 09244',NULL,'2013ApJ...771...88L',2013,1,1.22,NULL,'G',0.000033,NULL,'14.4g',0.68,'SBbc',NULL,NULL,NULL,NULL,1,216.534958333,5.23792,0.045,NULL,58304800084,911012501,14234570,14.4),(120642,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120642,35.15,0.2,107,53492,74.4,NULL,NULL,'UGC 09244',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120643,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120643,35.41,0.4,121,53492,NULL,NULL,'mean','UGC 09244',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120644,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120644,35.43,0.47,122,53492,NULL,NULL,'H','UGC 09244',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120645,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120645,35.56,0.45,129,53492,NULL,NULL,'K','UGC 09244',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120646,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120646,35.62,0.46,133,53492,NULL,NULL,'J','UGC 09244',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120647,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120647,37.48,0.33,313,53493,70,NULL,NULL,'2MASX J14260905+0630469',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,216.537625,6.51308,0,NULL,58273186893,910518545,14226852,17.1),(120648,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120648,38.19,0.46,434,53494,70,NULL,NULL,'2MASX J14261029+2634419',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,216.542875,26.57856,0,NULL,60054345991,938349156,14661705,18.2),(120649,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120649,37.41,0.33,303,53495,70,NULL,NULL,'2MASX J14261034+2437089',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,216.543083,24.61922,0.019,NULL,59496402346,929631286,14525488,18.2),(120650,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120650,35.93,0.46,153,53496,70,NULL,NULL,'SBS 1424+497',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000187,NULL,'16.0g',0.28,'S0^-',NULL,NULL,NULL,NULL,1,216.54325,49.49283,0,NULL,59246224444,925722256,14464410,16),(120651,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120651,35.12,0.5,106,53497,NULL,NULL,'Malmquist cor.','UGC 09244 NOTES01',NULL,'2009ApJS..182..474S',2009,1,0.63,NULL,'G',0.00009,NULL,'16.2g',0.33,'S',NULL,NULL,NULL,NULL,1,216.544208333,5.25653,0.045,NULL,58304804020,911012562,14234571,16.2),(120652,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120652,35.34,0.45,117,53497,NULL,NULL,NULL,'UGC 09244 NOTES01',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120653,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120653,35.38,0.2,119,53497,74.4,NULL,NULL,'UGC 09244 NOTES01',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120654,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120654,37.12,0.23,265,53498,70,NULL,NULL,'2MASX J14261125+4353564',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,216.547,43.89897,0.006,NULL,59954676365,936791818,14637372,17.3),(120655,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120655,37.32,0.27,292,53499,70,NULL,NULL,'2MASX J14261138+3453015',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000198,NULL,'16.5g',0.29,'S0',NULL,NULL,NULL,NULL,1,216.5475,34.88386,0,NULL,60038757963,938105593,14657899,16.5),(120656,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120656,33.73,0.8,55.7,53500,75,NULL,'CF, r','NGC 5622',NULL,'1997ApJS..109..333W',1997,1,1.56,NULL,'G',0.000007,NULL,'13.9g',0.78,'Sb','Isolated galaxy',NULL,NULL,NULL,1,216.5507917,48.564,0.033,NULL,59248368499,925755757,14464933,13.9),(120657,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120657,32.91,0.69,38.2,53500,100,NULL,'mid-IR','NGC 5622',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120658,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120658,33.85,0.38,58.8,53500,75,NULL,'CF, r, raw','NGC 5622',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120659,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120659,33.96,0.38,62,53500,75,NULL,'CF, r, inv','NGC 5622',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120660,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120660,34.04,0.4,64.3,53500,NULL,NULL,'mean','NGC 5622',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120661,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120661,34.05,0.38,64.6,53500,75,NULL,'CF, r, cor','NGC 5622',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120662,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120662,34.28,0.2,71.8,53500,74.4,NULL,NULL,'NGC 5622',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120663,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120663,34.32,0.47,73.1,53500,NULL,NULL,'H','NGC 5622',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120664,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120664,34.34,0.46,73.8,53500,NULL,NULL,'J','NGC 5622',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120665,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120665,34.38,0.45,75.1,53500,NULL,NULL,'K','NGC 5622',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120666,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120666,38.24,0.46,444,53501,70,NULL,NULL,'2MASX J14261225+2111414',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.85',0.23,NULL,NULL,NULL,NULL,NULL,1,216.551083,21.19475,0.045,NULL,59523850873,930060169,14532190,17.85),(120667,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120667,38.14,0.33,425,53502,70,NULL,NULL,'2MASX J14261233+5721415',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000163,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,216.5515,57.36164,0,NULL,57249771099,894527673,13976994,18.5),(120668,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120668,37.88,0.46,377,53503,70,NULL,NULL,'2MASX J14261314+4508175',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,216.5549583,45.13814,0,NULL,59230388078,925474813,14460543,18.1),(120669,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120669,37.41,0.46,303,53504,70,NULL,NULL,'2MASX J14261353+1623058',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.59',0.13,NULL,NULL,NULL,NULL,NULL,1,216.556417,16.38497,0,NULL,59491363112,929552548,14524258,18.59),(120670,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120670,37.54,0.33,322,53505,70,NULL,NULL,'2MASX J14261377-0111237',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000078,NULL,'16.9b',0.31,NULL,NULL,NULL,NULL,NULL,1,216.55725,-1.19003,0.105,NULL,43517684812,679963825,10624434,16.9),(120671,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120671,38.34,0.46,465,53506,70,NULL,NULL,'2MASX J14261457+4600494',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000173,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,216.560583,46.01383,0,NULL,59231304538,925489133,14460767,17.8),(120672,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120672,35.63,0.46,134,53507,70,NULL,NULL,'2MASX J14261468+3531050',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000166,NULL,'15.7g',0.36,'E/S0',NULL,NULL,NULL,NULL,1,216.5610417,35.51814,0,NULL,60038438145,938100596,14657821,15.7),(120673,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120673,38.3,0.27,458,53508,70,NULL,NULL,'2MASX J14261617+2245314',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.93',0.13,NULL,NULL,NULL,NULL,NULL,1,216.5675417,22.75886,0.056,NULL,59515413091,929928329,14530130,18.93),(120674,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120674,37.74,0.33,353,53509,70,NULL,NULL,'SDSS J142616.38+040234.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00008,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,216.568291667,4.04297,0.041,NULL,58302526249,910976972,14234015,18),(120675,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120675,35.9,0.75,152,53510,70,NULL,NULL,'2MASX J14261664-1630034',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.07',0.3,NULL,NULL,NULL,NULL,NULL,1,216.56925,-16.50106,0.353,NULL,46556367710,727443245,11366300,16.07),(120676,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120676,38.3,0.27,458,53511,70,NULL,NULL,'2MASX J14261724+2253574',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,216.571916667,22.89931,0.056,NULL,59516548941,929946077,14530407,17.4),(120677,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SN 2001ay',NULL,120677,35.19,0.18,106,53512,74.2,NULL,'SALT 2','IC 4423',0.03024,'2010ApJ...716..712A',2010,1,1.1,NULL,'G',0.000033,NULL,'15.00',0.6,'S?             AGN',NULL,NULL,NULL,NULL,1,216.573916667,26.24614,0,NULL,60021122659,937830041,14653594,15),(120678,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SN 2001ay',NULL,120678,35.75,0.22,137,53512,72,NULL,NULL,'IC 4423',0.03024,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120679,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SN 2001ay',NULL,120679,35.72,0.08,139,53512,74.4,NULL,NULL,'IC 4423',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120680,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SN 2001ay',NULL,120680,35.93,0.1,145,53512,65,NULL,'MLCS2k2','IC 4423',0.03024,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120681,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SN 2001ay',NULL,120681,35.98,0.17,152,53512,73.8,NULL,'SALT 2 (SNANA)','IC 4423',0.0312,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120682,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120682,35.72,0.08,139,53512,74.4,NULL,NULL,'IC 4423',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120683,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120683,35.91,0.43,152,53512,75,NULL,'3.6 micron, color corrected','IC 4423',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120684,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120684,36.04,0.43,161,53512,75,NULL,'3.6 micron, color + selection bias corrected','IC 4423',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120685,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120685,36.06,0.4,163,53512,75,NULL,'HOSTS SN 2001ay','IC 4423',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120686,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120686,37.41,0.64,303,53513,70,NULL,NULL,'2MASX J14261770-0930423',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.99',NULL,NULL,NULL,NULL,NULL,NULL,1,216.573833333,-9.51175,0.209,NULL,43522974094,680046470,10625726,15.99),(120687,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120687,36.74,0.46,223,53514,70,NULL,NULL,'2MASX J14261795+0009157',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,216.5747917,0.15433,0.149,NULL,58298736077,910917751,14233089,17.6),(120688,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120688,35.56,0.46,130,53515,70,NULL,NULL,'2MASX J14261833+3024110',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'16.54',0.27,NULL,NULL,NULL,NULL,NULL,1,216.5762917,30.40325,0,NULL,60048336033,938255250,14660238,16.54),(120689,'BCG','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120689,37.49,0.35,299,53516,60,NULL,'ABELL 1913, BCG','CGCG 104-021',0.0533,'1980ApJ...241..486H',1980,1,0.8,NULL,'G',NULL,NULL,'15.7',0.5,'SBab','Group member',NULL,NULL,NULL,1,216.58275,16.79728,0,NULL,59491456254,929554003,14524281,15.7),(120690,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120690,36.5,0.46,200,53517,70,NULL,NULL,'2MASX J14261996+3132421',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000168,NULL,'16.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,216.583166667,31.54497,0,NULL,60047039272,938234988,14659921,16.4),(120691,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120691,37.12,0.23,265,53518,70,NULL,NULL,'2MASX J14262004+4354395',NULL,'2015arXiv151105856S',2015,1,0.51,'The MAPS image includes a superposed star.','G',0.000185,NULL,'16.1g',0.36,'E0',NULL,NULL,NULL,NULL,1,216.5835417,43.91119,0.022,NULL,59954679746,936791871,14637372,16.1),(120692,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120692,37.61,0.27,333,53519,70,NULL,NULL,'SDSS J142620.17+254433.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.5840417,25.74267,0,NULL,60021394557,937834289,14653660,18.1),(120693,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120693,37.5,0.46,316,53520,70,NULL,NULL,'2MASX J14262043+1458448',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.30',0.16,NULL,NULL,NULL,NULL,NULL,1,216.585125,14.97922,0,NULL,59476651607,929322681,14520666,18.3),(120694,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120694,37.45,0.46,309,53521,70,NULL,NULL,'2MASX J14262103-0123308',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000145,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,216.587583,-1.39181,0.105,NULL,43517696711,679964011,10624437,17),(120695,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120695,37.96,0.46,390,53522,70,NULL,NULL,'2MASX J14262200+1633168',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,216.59175,16.55483,0,NULL,59491402155,929553158,14524268,17.4),(120696,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120696,35.78,0.46,143,53523,70,NULL,NULL,'2MASX J14262266+2528368',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00012,NULL,'15.8g',0.46,NULL,NULL,NULL,NULL,NULL,1,216.5942083,25.47697,0,NULL,60021474181,937835534,14653680,15.8),(120697,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120697,37.61,0.27,333,53524,70,NULL,NULL,'2MASX J14262525+2542358',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,216.6049583,25.70994,0,NULL,60021394703,937834292,14653660,17.9),(120698,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120698,38.29,0.46,455,53525,70,NULL,NULL,'SDSS J142625.28+475936.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,216.605333333,47.99342,0.053,NULL,59245338567,925708415,14464193,18.5),(120699,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120699,38.21,0.46,439,53526,70,NULL,NULL,'2MASX J14262586+1203078',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,216.607875,12.05225,0,NULL,59357831772,927466121,14491658,18),(120700,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120700,38.11,0.46,419,53527,70,NULL,NULL,'2MASX J14262595+5450456',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000178,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,216.608083,54.84589,0.005,NULL,57254322874,894598794,13978106,17.3),(120701,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120701,36.86,0.09,235,53528,70,NULL,NULL,'2MASX J14262644+1644418',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'18.05',0.3,'S0','Group member',NULL,NULL,NULL,1,216.6102083,16.74494,0,NULL,59491482301,929554410,14524287,18.05),(120702,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120702,36.4,0.33,191,53529,70,NULL,NULL,'2MASX J14262649+2934198',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000163,NULL,'16.71',0.33,'E',NULL,NULL,NULL,NULL,1,216.610458333,29.57217,0,NULL,60060233774,938441152,14663143,16.71),(120703,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120703,37.85,0.46,371,53530,70,NULL,NULL,'2MASX J14262665+3304391',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.8g',0.18,'AGN',NULL,NULL,NULL,NULL,1,216.6109583,33.07764,0,NULL,60039744548,938121008,14658140,17.8),(120704,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120704,37.48,0.46,313,53531,70,NULL,NULL,'2MASX J14262677+2501468',NULL,'2015arXiv151105856S',2015,1,0.28,'1999ApJS..122..415A has z = 0.022 +- 0.004.','G',0.000177,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,216.611667,25.02964,0,NULL,60020609147,937822017,14653469,17.2),(120705,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120705,35.02,0.23,101,53532,70,NULL,NULL,'CGCG 075-031 NED01',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000077,NULL,'15.8g',0.37,NULL,NULL,NULL,NULL,NULL,1,216.615833,11.18925,0.044,NULL,58268166105,910440095,14225626,15.8),(120706,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120706,36.86,0.09,235,53533,70,NULL,NULL,'CGCG 104-023',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',NULL,NULL,'15.7',0.6,'SB0','Group member',NULL,NULL,NULL,1,216.622667,16.81764,0,NULL,59491461703,929554089,14524282,15.7),(120707,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120707,36.86,0.09,235,53534,70,NULL,NULL,'2MASX J14262943+1645458',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00025,NULL,'15.9g',0.46,'E','Group member',NULL,NULL,NULL,1,216.62275,16.76281,0,NULL,59491468677,929554198,14524284,15.9),(120708,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120708,35.98,0.5,157,53535,70,NULL,NULL,'ESO 579- G 023',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000083,NULL,'15.77',0.9,'S0',NULL,NULL,NULL,NULL,1,216.6234583,-20.19442,0.317,NULL,46572532792,727695824,11370247,15.77),(120709,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120709,37.98,0.46,395,53536,70,NULL,NULL,'2MASX J14263013+2205464',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.37',0.16,NULL,NULL,NULL,NULL,NULL,1,216.625625,22.09622,0.041,NULL,59515806744,929934480,14530226,18.37),(120710,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120710,36.45,0.46,195,53537,70,NULL,NULL,'2MASX J14263019+0502437',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00007,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,216.6257083,5.04553,0.045,NULL,58305009775,911015777,14234621,16.9),(120711,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120711,36.86,0.09,235,53538,70,NULL,NULL,'2MASX J14263014+1636238',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000367,NULL,'16.56',0.5,'E/S0','Group member',NULL,NULL,NULL,1,216.62575,16.60667,0,NULL,59491442861,929553794,14524278,16.56),(120712,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120712,36.86,0.09,235,53539,70,NULL,NULL,'2MASX J14263055+1641428',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'17.70',0.3,'E','Group member',NULL,NULL,NULL,1,216.627167,16.69536,0,NULL,59491481206,929554393,14524287,17.7),(120713,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120713,34.89,0.39,94.9,53540,NULL,NULL,NULL,'UGC 09246',NULL,'2009ApJS..182..474S',2009,1,0.99,NULL,'G',0.000033,NULL,'15.4g',0.39,'S?',NULL,NULL,NULL,NULL,1,216.627583,5.97636,0.053,NULL,58303235375,910988052,14234188,15.4),(120714,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120714,35.01,0.37,100,53540,NULL,NULL,'Malmquist cor.','UGC 09246',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120715,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120715,35.02,0.2,101,53540,74.4,NULL,NULL,'UGC 09246',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120716,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120716,37.49,0.46,315,53541,70,NULL,NULL,'2MASX J14263114+1417098',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,216.6299583,14.28603,0,NULL,59479017537,929359649,14521244,17.9),(120717,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120717,37.64,0.46,338,53542,70,NULL,NULL,'2MASX J14263141+1422238',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,216.631,14.37322,0,NULL,59479026798,929359793,14521246,18.2),(120718,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120718,35.84,0.46,147,53543,70,NULL,NULL,'CGCG 133-056',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000077,NULL,'15.6',0.5,NULL,NULL,NULL,NULL,NULL,1,216.6330417,21.55717,0.043,NULL,59523903195,930060987,14532202,15.6),(120719,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120719,36.86,0.09,235,53544,70,NULL,NULL,'2MASX J14263306+1650478',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'18.21',0.2,'E','Group member',NULL,NULL,NULL,1,216.637917,16.84664,0,NULL,59491460405,929554068,14524282,18.21),(120720,'SBF','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120720,32.22,0.24,27.8,53545,NULL,NULL,'I','NGC 5631',NULL,'2001ApJ...546..681T',2001,1,1.86,NULL,'G',0.000017,NULL,'12.3g',1.62,'SA(s)0^0^      Sy2','Group member, radial-velocity confirmed',NULL,NULL,'Sy 2',1,216.63875,56.58264,0,NULL,57257063975,894641624,13978775,12.3),(120721,'SBF','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120721,32.27,0.14,28.4,53545,74.4,NULL,NULL,'NGC 5631',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120722,'Faber-Jackson','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120722,30.67,0.63,13.6,53545,95,NULL,'Michard 1979b, c','NGC 5631',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120723,'Faber-Jackson','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120723,30.87,0.37,14.9,53545,95,NULL,'Weighted Mean','NGC 5631',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120724,'Faber-Jackson','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120724,31.52,0.46,20.1,53545,95,NULL,'Michard 1979a','NGC 5631',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120725,'Faber-Jackson','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120725,31.78,0.81,22.7,53545,55,NULL,'Visvanathan & Sandage 1979','NGC 5631',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120726,'Tertiary','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120726,31.87,0.29,23.7,53545,95,NULL,NULL,'NGC 5631',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120727,'Tully est','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120727,32.57,0.8,32.7,53545,75,NULL,'B','NGC 5631',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120728,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120728,32.17,0.4,27.1,53545,NULL,NULL,'mean','NGC 5631',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120729,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120729,32.49,0.45,31.5,53545,NULL,NULL,'K','NGC 5631',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120730,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120730,36.86,0.09,235,53546,70,NULL,NULL,'CGCG 104-025',NULL,'2015arXiv151105856S',2015,1,2.5,NULL,'G',0.0002,NULL,'15.6',0.4,'E','Group member',NULL,NULL,NULL,1,216.639791667,16.75967,0,NULL,59491468774,929554199,14524284,15.6),(120731,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120731,35.53,0.33,127,53547,70,NULL,NULL,'2MASX J14263391+3548541',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00017,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,216.6412917,35.81517,0,NULL,60042543367,938164740,14658824,16.5),(120732,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120732,36.86,0.09,235,53548,70,NULL,NULL,'CGCG 104-026',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.0003,NULL,'15.6g',0.4,'S0/E','Group member',NULL,NULL,NULL,1,216.6435417,16.81917,0,NULL,59491461771,929554090,14524282,15.6),(120733,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120733,36.62,0.46,211,53549,70,NULL,NULL,'2MASX J14263458+0623237',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000166,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,216.644125,6.39003,0,NULL,58273298267,910520285,14226879,16.6),(120734,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120734,36.49,0.46,198,53550,70,NULL,NULL,'2MASX J14263750+6428163',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000101,NULL,'16.1g',0.38,'E0',NULL,NULL,NULL,NULL,1,216.6567083,64.47114,0.041,NULL,57947331191,905427049,14147297,16.1),(120735,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120735,36.89,0.46,238,53551,70,NULL,NULL,'2MASX J14263796+1210199',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000093,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,216.6582917,12.17225,0,NULL,59357826084,927466032,14491656,16.9),(120736,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120736,36.86,0.09,235,53552,70,NULL,NULL,'2MASX J14263884+1716379',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.13',0.16,'S0/E','Group member',NULL,NULL,NULL,1,216.661791667,17.27708,0,NULL,59488584848,929509138,14523580,18.13),(120737,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120737,37.64,0.46,337,53553,70,NULL,NULL,'SDSS J142638.82+543323.5',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000154,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,216.661791667,54.55656,0,NULL,57253895824,894592122,13978001,17.5),(120738,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120738,36.86,0.09,235,53554,70,NULL,NULL,'CGCG 104-027',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.000287,NULL,'15.7',0.8,'E','Group member',NULL,NULL,NULL,1,216.66425,16.68728,0,NULL,59491476519,929554320,14524286,15.7),(120739,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120739,36.86,0.09,235,53555,70,NULL,NULL,'2MASX J14263994+1723299',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.93',0.2,'S0','Group member',NULL,NULL,NULL,1,216.666375,17.39158,0,NULL,59488446176,929506971,14523546,17.93),(120740,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120740,36.57,0.61,206,53556,70,NULL,NULL,'2MASX J14264068-3610534',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.3I',0.4,NULL,NULL,NULL,NULL,NULL,1,216.669541667,-36.18161,0.265,NULL,47007673495,734494898,11476482,14.3),(120741,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120741,37.81,0.46,365,53557,70,NULL,NULL,'2MASX J14264079+4703233',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000175,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,216.669833,47.05658,0,NULL,59228180891,925440326,14460005,17.7),(120742,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120742,37.37,0.46,298,53558,70,NULL,NULL,'2MASX J14264199+2229466',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.06',0.2,NULL,NULL,NULL,NULL,NULL,1,216.6750417,22.49633,0.052,NULL,59515925222,929936331,14530255,18.06),(120743,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120743,38.18,0.46,433,53559,70,NULL,NULL,'2MASX J14264384+1808036',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,216.6827917,18.13428,0,NULL,59480571290,929383926,14521623,17),(120744,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120744,36.66,0.46,215,53560,70,NULL,NULL,'2MASX J14264471+0910447',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000203,NULL,'15.6g',0.49,NULL,NULL,NULL,NULL,NULL,1,216.6862917,9.17925,0.017,NULL,58268618375,910447162,14225736,15.6),(120745,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120745,35.47,0.46,124,53561,70,NULL,NULL,'VIII Zw 420',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000068,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,216.69175,4.57594,0.029,NULL,58302535688,910977120,14234017,16.2),(120746,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120746,36.93,0.46,243,53562,70,NULL,NULL,'2MASX J14264606+3008571',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00019,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,216.691833,30.14925,0,NULL,60048376516,938255883,14660248,16.2),(120747,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120747,36.35,0.16,186,53563,70,NULL,NULL,'2MASX J14264737+5413454',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,216.6972917,54.22919,0.005,NULL,59196756118,924949314,14452333,16.9),(120748,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120748,38.18,0.46,433,53564,70,NULL,NULL,'2MASX J14264755+0441592',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000092,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,216.6980417,4.69969,0.029,NULL,58304832642,911013010,14234578,17.7),(120749,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120749,37.77,0.33,357,53565,70,NULL,NULL,'2MASX J14264807+2356096',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000173,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,216.70025,23.93597,0.031,NULL,59496618572,929634665,14525541,17.1),(120750,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120750,36.86,0.09,235,53566,70,NULL,NULL,'2MASX J14264820+1640459',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000167,NULL,'18.25',0.2,'S0','Group member',NULL,NULL,NULL,1,216.700833,16.67939,0,NULL,59491447720,929553870,14524279,18.25),(120751,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120751,37.92,0.46,384,53567,70,NULL,NULL,'SDSS J142649.02+185405.8',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.7042917,18.90164,0,NULL,59511093237,929860831,14529075,17.4),(120752,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120752,38.05,0.46,408,53568,70,NULL,NULL,'2MASX J14264919+6210063',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00018,NULL,'16.6g',0.32,'AGN',NULL,NULL,NULL,NULL,1,216.705167,62.16831,0.013,NULL,57763733505,902558336,14102474,16.6),(120753,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120753,37.74,0.46,353,53569,70,NULL,NULL,'2MASX J14264992+2732376',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,216.708,27.54392,0,NULL,60055871446,938372991,14662077,18.3),(120754,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120754,36.63,0.46,212,53570,70,NULL,NULL,'2MASX J14265017+3335072',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,216.708875,33.58517,0,NULL,60041342880,938145982,14658530,16.5),(120755,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120755,38.41,0.15,480,53571,70,NULL,NULL,'2MASX J14265170+5655248',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000153,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,216.715333,56.92367,0,NULL,57249538790,894524043,13976938,18.6),(120756,'BCG','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120756,37.49,0.35,299,53572,60,NULL,NULL,'ABELL 1913',0.0533,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,216.715833,16.676,0,NULL,59491447605,929553868,14524279,NULL),(120757,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120757,37.77,0.33,357,53573,70,NULL,NULL,'2MASXi J1426530+235611',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,216.720916667,23.93661,0.031,NULL,59496618951,929634671,14525541,17.9),(120758,'Tully est','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120758,32.13,0.8,26.7,53574,75,NULL,NULL,'ESO 272- G 009',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000022,NULL,'15.00',0.9,'SAB(s)d',NULL,NULL,NULL,NULL,1,216.7309583,-45.87769,0.549,NULL,46803929792,731311403,11426740,15),(120759,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120759,37.71,0.46,348,53575,70,NULL,NULL,'B3 1424+423',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.16',0.21,'BrClG',NULL,NULL,NULL,NULL,1,216.7315,42.09608,0,NULL,59947815802,936684621,14635697,17.16),(120760,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120760,36.64,0.54,213,53576,70,NULL,NULL,'2MASX J14265706-2120143',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'16.29',NULL,NULL,NULL,NULL,NULL,NULL,1,216.737917,-21.33758,0.321,NULL,46571212771,727675199,11369924,16.29),(120761,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120761,36.86,0.09,235,53577,70,NULL,NULL,'2MASX J14265794+1636019',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000227,NULL,'18.16',0.2,'S0','Group member',NULL,NULL,NULL,1,216.7414583,16.60056,0,NULL,59491443712,929553808,14524278,18.16),(120762,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120762,36.4,0.33,191,53578,70,NULL,NULL,'2MASX J14265818+2935542',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,216.7422917,29.59844,0,NULL,60060265414,938441647,14663150,17.5),(120763,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120763,33.35,0.2,46.8,53579,74.4,NULL,NULL,'UGC 09253',NULL,'2013AJ....146...86T',2013,1,2.07,'HOLM 646B is a star.','G',0.00002,NULL,'14.4g',0.43,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,216.7437917,31.51703,0,NULL,60047035663,938234932,14659920,14.4),(120764,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120764,33.44,0.49,48.9,53579,75,NULL,'IR','UGC 09253',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120765,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120765,33.45,0.47,49.1,53579,NULL,NULL,NULL,'UGC 09253',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120766,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120766,33.58,0.45,52,53579,NULL,NULL,'Malmquist cor.','UGC 09253',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120767,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120767,37.15,0.57,269,53580,70,NULL,NULL,'2MASX J14265933-1550176',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.98',0.4,NULL,NULL,NULL,NULL,NULL,1,216.747208333,-15.83836,0.273,NULL,46553987482,727406054,11365719,15.98),(120768,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120768,33.73,0.8,55.8,53581,75,NULL,'HMCL, I','IC 4427',NULL,'1997ApJS..109..333W',1997,1,0.8,NULL,'G',0.000117,NULL,'15.46',0.3,'S?             HII',NULL,NULL,NULL,NULL,1,216.7482083,26.86397,0,NULL,60023898902,937873420,14654272,15.46),(120769,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120769,33.65,0.4,53.8,53581,75,NULL,'HMCL, I, inv','IC 4427',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120770,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120770,33.7,0.4,55.1,53581,75,NULL,'HMCL, I, raw','IC 4427',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120771,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120771,33.97,0.4,62.1,53581,75,NULL,'HMCL, I, cor','IC 4427',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120772,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120772,37.13,0.33,267,53582,70,NULL,NULL,'2MASX J14265968+1255509',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,216.7487917,12.93075,0,NULL,59542473330,930351145,14536736,17.3),(120773,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120773,31.16,NULL,17.1,53583,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09249',NULL,'2010Ap&SS.325..163P',2010,1,2.2,NULL,'G',0.000009,NULL,'15.0g',0.36,'Sdm',NULL,NULL,NULL,NULL,1,216.749083,8.68361,0.021,NULL,58282670226,910666722,14229167,15),(120774,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120774,31.19,NULL,17.3,53583,NULL,NULL,'Dipole + Quadrupole','UGC 09249',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120775,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120775,31.21,NULL,17.4,53583,NULL,NULL,'Dipole','UGC 09249',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120776,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120776,31.42,NULL,19.2,53583,72,NULL,NULL,'UGC 09249',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120777,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120777,31.47,NULL,19.6,53583,NULL,NULL,NULL,'UGC 09249',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120778,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120778,31.97,0.4,24.8,53583,75,NULL,'B','UGC 09249',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120779,'BL Lac Luminosity','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120779,41.37,NULL,1880,53584,70,NULL,NULL,'FBQS J142700.4+234800',NULL,'2013ApJ...768L..31F',2013,1,NULL,NULL,'QSO',NULL,'TENT','14.6V',NULL,'BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,216.751625,23.8,0.031,NULL,59496499630,929632806,14525512,14.6),(120780,'GeV TeV ratio','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120780,39.73,NULL,882,53584,72,NULL,NULL,'FBQS J142700.4+234800',NULL,'2010MNRAS.405L..76P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120781,'GeV TeV ratio','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120781,41.39,0.28,1900,53584,70,NULL,'z =0.61 +/- 0.10','FBQS J142700.4+234800',NULL,'2014A&A...567A.135A',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120782,'GeV TeV ratio','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120782,41.55,0.15,2040,53584,70,NULL,'z(photo) = 0.68 +/- 0.08','FBQS J142700.4+234800',NULL,'2015MNRAS.447.2810Y',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120783,'GeV TeV ratio','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120783,41.99,0.34,2500,53584,70,NULL,'z(photo) = 0.95 +/- 0.35','FBQS J142700.4+234800',NULL,'2015MNRAS.449.1018Y',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120784,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120784,37.4,0.46,302,53585,70,NULL,NULL,'2MASX J14270131+2557052',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00014,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,216.755458333,25.95144,0,NULL,60021097082,937829641,14653588,17.4),(120785,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120785,38.48,0.33,497,53586,70,NULL,NULL,'SDSS J142702.03+251153.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000157,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.7585,25.19811,0,NULL,60020560402,937821256,14653457,18.5),(120786,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120786,37.9,0.46,380,53587,70,NULL,NULL,'2MASX J14270255+4511574',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000213,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,216.760583,45.19947,0,NULL,59230167532,925471367,14460490,16.2),(120787,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120787,37.71,0.46,348,53588,70,NULL,NULL,'SDSS J142702.69+214913.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.7612083,21.82031,0.073,NULL,59515675438,929932428,14530194,18.4),(120788,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120788,37.32,0.27,292,53589,70,NULL,NULL,'2MASX J14270324+3451342',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000159,NULL,'16.5g',0.34,'E/S0',NULL,NULL,NULL,NULL,1,216.7634583,34.85964,0,NULL,60039316457,938114319,14658036,16.5),(120789,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120789,37.24,0.46,280,53590,70,NULL,NULL,'2MASX J14270529+1116182',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000171,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,216.7720417,11.27183,0.022,NULL,58267868874,910435451,14225553,17.8),(120790,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120790,36.86,0.09,235,53591,70,NULL,NULL,'2MASXi J1427079+164830',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.6g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.783291667,16.80844,0,NULL,59491271080,929551110,14524236,17.6),(120791,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120791,38.09,0.65,415,53592,70,NULL,NULL,'2MASX J14270852-1942349',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,216.785541667,-19.70972,0.313,NULL,46558235861,727472435,11366756,15.5),(120792,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120792,37.12,0.23,265,53593,70,NULL,NULL,'2MASX J14270862+4343064',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,216.7857917,43.71833,0.011,NULL,59954530639,936789541,14637336,17.6),(120793,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120793,33.73,0.2,55.7,53594,74.4,NULL,NULL,'IC 1012',NULL,'2013AJ....146...86T',2013,1,0.86,NULL,'G',0.000033,NULL,'14.7g',0.64,'S?',NULL,NULL,NULL,NULL,1,216.789583,30.94822,0,NULL,60049050207,938266409,14660412,14.7),(120794,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120794,33.85,0.45,58.8,53594,NULL,NULL,NULL,'IC 1012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120795,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120795,33.88,0.44,59.7,53594,NULL,NULL,'Malmquist cor.','IC 1012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120796,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120796,31.46,NULL,19.6,53595,72,NULL,NULL,'UGC 09252',NULL,'2014Ap.....57..457K',2014,1,1,NULL,'G',0.000017,NULL,'15.67',0.2,'Irr(f)',NULL,NULL,NULL,NULL,1,216.7949583,5.13294,0.041,NULL,58304932832,911014575,14234602,15.67),(120797,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120797,37.13,0.33,267,53596,70,NULL,NULL,'2MASX J14271104+1301246',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000212,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,216.7959583,13.02347,0,NULL,59543193914,930362404,14536912,16.7),(120798,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120798,37.36,0.46,296,53597,70,NULL,NULL,'2MASX J14271160+1448226',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.47',0.15,NULL,NULL,NULL,NULL,NULL,1,216.7982083,14.80619,0,NULL,59477073981,929329280,14520770,18.47),(120799,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120799,34.47,0.69,78.4,53598,NULL,NULL,'Malmquist cor.','NGC 5618',NULL,'2009ApJS..182..474S',2009,1,1.57,NULL,'G',0.000023,NULL,'13.8b',1.03,'SB(rs)c',NULL,NULL,NULL,NULL,1,216.7992083,-2.26242,0.157,NULL,43516337230,679942769,10624105,13.8),(120800,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120800,34.56,0.66,81.8,53598,NULL,NULL,NULL,'NGC 5618',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120801,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120801,34.6,0.2,83.2,53598,74.4,NULL,NULL,'NGC 5618',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120802,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120802,35.07,0.47,103,53598,NULL,NULL,'H','NGC 5618',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120803,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120803,35.1,0.4,105,53598,NULL,NULL,'mean','NGC 5618',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120804,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120804,35.22,0.46,111,53598,NULL,NULL,'J','NGC 5618',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120805,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120805,35.22,0.45,111,53598,NULL,NULL,'K','NGC 5618',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120806,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120806,39.2,0.46,693,53599,70,NULL,NULL,'SDSS J142712.72+181833.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.803,18.30919,0,NULL,59480651097,929385173,14521643,18.4),(120807,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120807,37.8,0.46,364,53600,70,NULL,NULL,'2MASX J14271272+5700599',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000211,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,216.803083,57.01664,0,NULL,57249575236,894524613,13976947,17.9),(120808,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120808,36.96,0.46,246,53601,70,NULL,NULL,'2MASX J14271283+4052195',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,216.8034583,40.87203,0,NULL,59948734169,936698971,14635921,16.8),(120809,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120809,37.12,0.23,265,53602,70,NULL,NULL,'2MASX J14271287+4344054',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000183,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,216.8035417,43.73467,0.025,NULL,59954531182,936789549,14637336,16.6),(120810,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120810,35.85,0.46,148,53603,70,NULL,NULL,'2MASX J14271381+0250483',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000093,NULL,'15.4g',0.41,'E0',NULL,NULL,NULL,NULL,1,216.807417,2.84683,0.045,NULL,58296882118,910888783,14232637,15.4),(120811,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120811,34.57,0.69,82.1,53604,100,NULL,'mid-IR','CGCG 075-035',NULL,'2013ApJ...771...88L',2013,1,1.09,NULL,'G',0.000098,NULL,'14.6g',0.69,'SBa',NULL,NULL,NULL,NULL,1,216.8107083,11.33908,0.022,NULL,58267874805,910435543,14225555,14.6),(120812,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120812,35.78,0.27,143,53605,70,NULL,NULL,'2MASX J14271494+3726539',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000151,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,216.812125,37.44822,0,NULL,60064524969,938508202,14664190,16.3),(120813,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120813,37.75,0.33,355,53606,70,NULL,NULL,'2MASX J14271582+6308213',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000074,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,216.8160417,63.13914,0.025,NULL,57761720522,902526883,14101982,17.6),(120814,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120814,37.98,0.46,395,53607,70,NULL,NULL,'SDSS J142716.97+421209.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000134,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,216.82075,42.2025,0,NULL,59947821311,936684707,14635698,18.2),(120815,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120815,36.86,0.09,235,53608,70,NULL,NULL,'IC 4426',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000294,NULL,'15.50',0.5,'E','Group member',NULL,NULL,NULL,1,216.8212083,16.83097,0,NULL,59491273858,929551154,14524236,15.5),(120816,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120816,36.86,0.09,235,53609,70,NULL,NULL,'2MASX J14271731+1633176',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.0002,NULL,'14.2',0.5,'S0','Group member',NULL,NULL,NULL,1,216.82225,16.55492,0,NULL,59491371364,929552677,14524260,14.2),(120817,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120817,35.35,0.8,117,53610,75,NULL,'CF, r','NGC 5619',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.00002,NULL,'13.6g',1.2,'SAB(rs)b','Possible field galaxy',NULL,NULL,NULL,1,216.8259583,4.80283,0.029,NULL,58304848263,911013254,14234582,13.6),(120818,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120818,34.75,0.47,89.2,53610,NULL,NULL,'H','NGC 5619',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120819,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120819,34.76,0.46,89.7,53610,NULL,NULL,'J','NGC 5619',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120820,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120820,34.84,0.45,92.9,53610,NULL,NULL,'K','NGC 5619',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120821,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120821,34.91,0.38,96.1,53610,75,NULL,'CF, r, raw','NGC 5619',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120822,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120822,35.11,0.3,105,53610,NULL,NULL,'Malmquist cor.','NGC 5619',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120823,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120823,35.1,0.3,105,53610,NULL,NULL,NULL,'NGC 5619',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120824,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120824,35.14,0.2,107,53610,74.4,NULL,NULL,'NGC 5619',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120825,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120825,35.16,0.38,107,53610,75,NULL,'CF, r, cor','NGC 5619',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120826,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120826,35.22,0.38,111,53610,75,NULL,'CF, r, inv','NGC 5619',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120827,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120827,35.4,0.4,120,53610,NULL,NULL,'mean','NGC 5619',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120828,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120828,37.73,0.46,352,53611,70,NULL,NULL,'LCRS B142444.2-022526',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000119,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,216.832125,-2.6475,0.169,NULL,43516001089,679937517,10624023,18),(120829,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120829,36.35,0.16,186,53612,70,NULL,NULL,'2MASX J14272001+5417199',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000201,NULL,'15.2g',0.52,'E0',NULL,NULL,NULL,NULL,1,216.833291667,54.28892,0,NULL,59197234250,924956785,14452449,15.2),(120830,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120830,32.13,0.8,26.6,53613,75,NULL,'MAT, I','ESO 001- G 006',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000017,NULL,'13.89',0.7,'SA:(rs)bc:',NULL,NULL,NULL,NULL,1,216.83525,-87.77225,0.377,NULL,44037540533,688086570,10751352,13.89),(120831,'Tully est','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120831,32.19,0.8,27.5,53613,75,NULL,NULL,'ESO 001- G 006',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120832,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120832,31.96,0.32,24.7,53613,85,NULL,'I, raw','ESO 001- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120833,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120833,31.98,0.32,24.9,53613,85,NULL,'I, inv','ESO 001- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120834,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120834,32.15,0.43,27,53613,75,NULL,'MAT, I, raw','ESO 001- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120835,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120835,32.28,0.43,28.5,53613,75,NULL,'MAT, I, inv','ESO 001- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120836,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120836,32.4,0.43,30.3,53613,75,NULL,'MAT, I, cor','ESO 001- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120837,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120837,32.41,0.43,30.4,53613,75,NULL,'3.6 micron, color corrected','ESO 001- G 006',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120838,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120838,32.42,0.43,30.5,53613,75,NULL,'3.6 micron, color + selection bias corrected','ESO 001- G 006',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120839,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120839,32.43,0.2,30.6,53613,74.4,NULL,NULL,'ESO 001- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120840,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120840,32.55,0.4,32.3,53613,73,NULL,'opt','ESO 001- G 006',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120841,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120841,32.63,0.52,33.6,53613,NULL,NULL,'Malmquist cor.','ESO 001- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120842,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120842,32.64,0.52,33.7,53613,NULL,NULL,NULL,'ESO 001- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120843,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120843,36.86,0.09,235,53614,70,NULL,NULL,'2MASX J14272162+1635366',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.22',0.17,NULL,NULL,NULL,NULL,NULL,1,216.8402917,16.59333,0,NULL,59491369939,929552655,14524260,18.22),(120844,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120844,36.42,0.54,192,53615,70,NULL,NULL,'2MASX J14272388-1435248',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000097,NULL,'13.7I',0.4,NULL,NULL,NULL,NULL,NULL,1,216.849625,-14.59022,0.265,NULL,46542428861,727225450,11362897,13.7),(120845,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120845,35.78,0.27,143,53616,70,NULL,NULL,'IC 4435',NULL,'2015arXiv151105856S',2015,1,0.86,NULL,'G',0.0001,NULL,'14.6g',0.62,'E0',NULL,NULL,NULL,NULL,1,216.851166667,37.47144,0,NULL,60064526157,938508221,14664190,14.6),(120846,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120846,36.35,0.16,186,53617,70,NULL,NULL,'2MASX J14272490+5413328',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000175,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,216.853875,54.22581,0,NULL,59197286908,924957607,14452462,16.4),(120847,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120847,37.01,0.46,252,53618,70,NULL,NULL,'2MASX J14272548+2406551',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000147,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,216.856333,24.11547,0.015,NULL,59496662016,929635344,14525552,17.1),(120848,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120848,34.05,0.8,64.5,53619,75,NULL,'HMCL, I','UGC 09265',NULL,'1997ApJS..109..333W',1997,1,1.25,NULL,'G',0.000033,NULL,'14.9g',0.45,'S?',NULL,NULL,NULL,NULL,1,216.858166667,25.51447,0,NULL,60021531522,937836430,14653694,14.9),(120849,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120849,33.68,0.4,54.4,53619,75,NULL,'HMCL, I, raw','UGC 09265',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120850,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120850,33.77,0.4,56.9,53619,75,NULL,'HMCL, I, inv','UGC 09265',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120851,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120851,33.98,0.4,62.4,53619,75,NULL,'HMCL, I, cor','UGC 09265',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120852,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120852,36.72,0.33,221,53620,70,NULL,NULL,'2MASX J14272685+0618302',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000192,NULL,'15.6g',0.46,NULL,NULL,NULL,NULL,NULL,1,216.862,6.30842,0.005,NULL,58273125427,910517584,14226837,15.6),(120853,'Tully est','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120853,32.85,0.8,37.1,53621,75,NULL,'B','NGC 5633',NULL,'1988NBGC.C....0000T',1988,1,1.56,NULL,'G',0.00002,NULL,'12.9g',0.97,'(R)SA(rs)b','Isolated galaxy',NULL,NULL,NULL,1,216.86825,46.14653,0.039,NULL,59228473583,925444899,14460076,12.9),(120854,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120854,31.8,0.69,22.9,53621,100,NULL,'mid-IR','NGC 5633',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120855,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120855,32.72,0.45,35,53621,NULL,NULL,'K','NGC 5633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120856,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120856,32.75,0.47,35.5,53621,NULL,NULL,'H','NGC 5633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120857,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120857,32.77,0.46,35.9,53621,NULL,NULL,'J','NGC 5633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120858,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120858,32.78,0.4,36,53621,NULL,NULL,'mean','NGC 5633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120859,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120859,32.81,0.4,36.5,53621,NULL,NULL,NULL,'NGC 5633',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120860,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120860,33.54,0.56,51,53621,NULL,NULL,'Malmquist cor.','NGC 5633',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120861,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120861,33.63,0.53,53.3,53621,NULL,NULL,NULL,'NGC 5633',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120862,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120862,33.68,0.2,54.5,53621,74.4,NULL,NULL,'NGC 5633',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120863,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120863,34.61,0.69,83.6,53622,100,NULL,'mid-IR','UGC 09259',NULL,'2013ApJ...771...88L',2013,1,0.9,NULL,'G',0.000033,NULL,'14.98',0.5,'S?',NULL,NULL,NULL,NULL,1,216.868916667,11.04072,0.026,NULL,58268045390,910438209,14225597,14.98),(120864,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120864,36.68,0.33,217,53623,70,NULL,NULL,'2MASX J14272903+0427333',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000084,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,216.8710417,4.45914,0.029,NULL,58302208390,910972006,14233937,16.9),(120865,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120865,37.59,0.46,329,53624,70,NULL,NULL,'2MASX J14272923+1930123',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,216.871667,19.50344,0.04,NULL,59511493653,929867088,14529173,17.9),(120866,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120866,38.08,0.33,412,53625,70,NULL,NULL,'2MASX J14273023+5409238',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000177,NULL,'16.5g',0.34,'candidate      BLLAC',NULL,NULL,NULL,'BL Lac ?',1,216.876166667,54.15658,0,NULL,59197290065,924957657,14452463,16.5),(120867,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120867,36.08,0.46,164,53626,70,NULL,NULL,'CGCG 075-038',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000157,NULL,'15.4g',0.52,NULL,NULL,NULL,NULL,NULL,1,216.878083333,13.23633,0,NULL,59542966341,930358849,14536857,15.4),(120868,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120868,35.35,0.4,117,53627,NULL,NULL,'mean','ESO 385- G 025',NULL,'2007A&A...465...71T',2007,1,1.5,'Star superposed?','G',0.00002,NULL,'14.19',1.1,'SAB(r)c:',NULL,NULL,NULL,NULL,1,216.880166667,-33.94422,0.285,NULL,47001272652,734394885,11474920,14.19),(120869,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120869,35.43,0.47,122,53627,NULL,NULL,'H','ESO 385- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120870,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120870,35.54,0.46,128,53627,NULL,NULL,'J','ESO 385- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120871,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120871,34.32,0.49,73.2,53628,75,NULL,'IR','ESO 447- G 005',NULL,'2011yCatp016004901K',2011,1,1.23,NULL,'G',0.000073,NULL,'16.98',0.11,'Sd',NULL,NULL,NULL,NULL,1,216.883166667,-31.23878,0.313,NULL,47029810390,734840787,11481887,16.98),(120872,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120872,34.98,NULL,98.9,53628,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 447- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120873,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120873,34.99,NULL,99.6,53628,NULL,NULL,'Dipole + Quadrupole','ESO 447- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120874,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120874,35.01,NULL,100,53628,NULL,NULL,'Dipole','ESO 447- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120875,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120875,35.03,NULL,101,53628,NULL,NULL,NULL,'ESO 447- G 005',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120876,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120876,36.87,0.46,237,53629,70,NULL,NULL,'2MASX J14273266+1531305',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.10',0.32,NULL,NULL,NULL,NULL,NULL,1,216.886208333,15.52497,0,NULL,59490565010,929540078,14524063,17.1),(120877,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120877,38.48,0.33,497,53630,70,NULL,NULL,'2MASX J14273290+2512302',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,216.886958333,25.20842,0,NULL,60021420625,937834697,14653667,17.7),(120878,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120878,36.47,0.33,197,53631,70,NULL,NULL,'2MASX J14273316+1506535',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.76',0.22,NULL,NULL,NULL,NULL,NULL,1,216.88825,15.11486,0,NULL,59476707466,929323554,14520680,17.76),(120879,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120879,37.62,0.33,334,53632,70,NULL,NULL,'2MASX J14273393+1416165',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,216.8912083,14.27108,0,NULL,59479002746,929359417,14521240,17.7),(120880,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120880,37.97,0.33,392,53633,70,NULL,NULL,'2MASX J14273403+0209559',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00008,NULL,'17.0g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,216.891916667,2.16564,0.045,NULL,58297283204,910895050,14232735,17),(120881,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120881,37.49,0.46,315,53634,70,NULL,NULL,'SDSS J142734.32+015001.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000079,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,216.893,1.83378,0.081,NULL,58297186101,910893532,14232711,17.6),(120882,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120882,38.41,0.15,480,53635,70,NULL,NULL,'SDSS J142734.58+565935.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,216.894083333,56.99317,0,NULL,57249622163,894525346,13976958,18.4),(120883,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120883,35.02,0.23,101,53636,70,NULL,NULL,'CGCG 075-037',NULL,'2015arXiv151105856S',2015,1,1.18,NULL,'G',0.000087,NULL,'14.2g',0.59,'SAB0^+^',NULL,NULL,NULL,NULL,1,216.894583,11.33061,0.022,NULL,59358190215,927471722,14491745,14.2),(120884,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120884,37.43,0.23,306,53637,70,NULL,NULL,'2MASX J14273492+2322263',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.85',0.23,NULL,NULL,NULL,NULL,NULL,1,216.8954583,23.37408,0.033,NULL,59516390855,929943607,14530368,17.85),(120885,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120885,37.97,0.46,393,53638,70,NULL,NULL,'2MASX J14273517+5425487',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000197,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,216.896625,54.43036,0,NULL,59197227403,924956678,14452448,16.8),(120886,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120886,35.11,0.8,105,53639,75,NULL,'HMCL, I','CGCG 047-050',NULL,'1997ApJS..109..333W',1997,1,0.86,NULL,'G',0.000027,NULL,'15.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,216.8987917,8.12475,0.049,NULL,58283455680,910678995,14229359,15.4),(120887,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120887,34.67,0.4,85.9,53639,75,NULL,'HMCL, I, raw','CGCG 047-050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120888,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120888,34.78,0.4,90.3,53639,75,NULL,'HMCL, I, inv','CGCG 047-050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120889,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120889,35.01,0.4,100,53639,75,NULL,'HMCL, I, cor','CGCG 047-050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120890,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120890,33.05,0.8,40.7,53640,75,NULL,'A82, H','NGC 5630',NULL,'1997ApJS..109..333W',1997,1,2.05,'HOLM 649B is a star.','G',0.000017,NULL,'13.6g',0.65,'Sdm:','Field galaxy',NULL,NULL,NULL,1,216.9025417,41.25775,0,NULL,59948308246,936692316,14635817,13.6),(120891,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120891,32.08,0.47,26,53640,75,NULL,'A82, H, inv','NGC 5630',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120892,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120892,32.16,0.47,27,53640,75,NULL,'A82, H, raw','NGC 5630',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120893,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120893,32.37,0.43,29.8,53640,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5630',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120894,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120894,32.38,0.43,29.9,53640,75,NULL,'3.6 micron, color corrected','NGC 5630',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120895,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120895,32.41,0.2,30.3,53640,74.4,NULL,NULL,'NGC 5630',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120896,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120896,32.48,0.38,31.3,53640,NULL,NULL,NULL,'NGC 5630',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120897,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120897,32.59,0.47,33,53640,75,NULL,'A82, H, cor','NGC 5630',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120898,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120898,33.08,0.4,41.3,53640,75,NULL,'B','NGC 5630',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120899,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120899,38.12,0.46,420,53641,70,NULL,NULL,'2MASX J14273733+5537427',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000184,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,216.905541667,55.62861,0,NULL,57260118766,894689355,13979521,17.7),(120900,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120900,36.86,0.09,235,53642,70,NULL,NULL,'IC 4429',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000157,NULL,'15.19',0.7,'E','Group member',NULL,NULL,NULL,1,216.9057083,16.89986,0,NULL,59491283903,929551310,14524239,15.19),(120901,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120901,36.47,0.33,197,53643,70,NULL,NULL,'SDSS J142737.41+150702.9',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.0g',0.4,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.905916667,15.11747,0,NULL,59476707951,929323561,14520680,16),(120902,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120902,36.68,0.33,217,53644,70,NULL,NULL,'2MASX J14273825+0427369',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000084,NULL,'16.1g',0.39,'S0',NULL,NULL,NULL,NULL,1,216.909291667,4.46033,0.029,NULL,58302209868,910972029,14233937,16.1),(120903,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120903,37.22,0.46,278,53645,70,NULL,NULL,'2MASX J14273919+3749361',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000166,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,216.91325,37.82678,0,NULL,60064308566,938504821,14664137,16.8),(120904,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120904,34.99,0.2,99.5,53646,74.4,NULL,NULL,'UGC 09264',NULL,'2013AJ....146...86T',2013,1,0.98,NULL,'G',0.000033,NULL,'16.0g',0.26,'Scd:',NULL,NULL,NULL,NULL,1,216.916875,6.04136,0.049,NULL,58303375120,910990236,14234222,16),(120905,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120905,35.2,0.49,109,53646,75,NULL,'IR','UGC 09264',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120906,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120906,36.86,0.09,235,53647,70,NULL,NULL,'2MASX J14274102+1637086',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.94',0.2,'S0','Group member',NULL,NULL,NULL,1,216.921,16.61917,0,NULL,59490189734,929534214,14523972,17.94),(120907,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120907,38.19,0.46,435,53648,70,NULL,NULL,'2MASX J14274171+1144058',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000158,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,216.923667,11.73489,0.036,NULL,59357881750,927466902,14491670,17.5),(120908,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120908,37.62,0.33,334,53649,70,NULL,NULL,'2MASX J14274181+1417166',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.99',0.16,NULL,NULL,NULL,NULL,NULL,1,216.924291667,14.28794,0,NULL,59476953362,929327396,14520740,17.99),(120909,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120909,35.15,0.47,107,53650,NULL,NULL,'H','NGC 5671',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000143,NULL,'14.10',1.2,'SB(r)b','in a radial-velocity based grouping',NULL,NULL,NULL,1,216.925,69.69417,0.041,NULL,57922577860,905040279,14141254,14.1),(120910,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120910,35.21,0.43,110,53650,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5671',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120911,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120911,35.29,0.46,114,53650,NULL,NULL,'J','NGC 5671',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120912,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120912,35.29,0.45,114,53650,NULL,NULL,'K','NGC 5671',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120913,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120913,35.39,0.4,120,53650,NULL,NULL,'mean','NGC 5671',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120914,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120914,36.68,0.27,216,53651,70,NULL,NULL,'2MASX J14274201-0145202',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.0002,NULL,'15.9g',0.43,'E0',NULL,NULL,NULL,NULL,1,216.925,-1.75572,0.105,NULL,43514359330,679911864,10623622,15.9),(120915,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120915,36.86,0.09,235,53652,70,NULL,NULL,'SDSS J142742.91+165455.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.7g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.928833333,16.91556,0,NULL,59491280944,929551264,14524238,17.7),(120916,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120916,38.03,0.46,404,53653,70,NULL,NULL,'2MASX J14274302+4242305',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,216.929167,42.70842,0.013,NULL,59959021124,936859705,14638432,17.6),(120917,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120917,37.58,0.46,328,53654,70,NULL,NULL,'2MASX J14274320-0044002',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000072,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,216.93,-0.73339,0.101,NULL,43513703796,679901621,10623462,18.2),(120918,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120918,37.97,0.33,392,53655,70,NULL,NULL,'2MASX J14274451+0205509',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000082,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,216.935333333,2.09758,0.045,NULL,58297259576,910894680,14232729,17.3),(120919,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120919,37.47,0.33,312,53656,70,NULL,NULL,'2MASX J14274480+0344519',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000079,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,216.936833,3.74781,0.025,NULL,58302051765,910969558,14233899,16.9),(120920,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120920,37.75,0.33,355,53657,70,NULL,NULL,'2MASX J14274597+6306410',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000074,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,216.941416667,63.11147,0.025,NULL,57761671650,902526119,14101970,17.4),(120921,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120921,38.41,0.15,480,53658,70,NULL,NULL,'SDSS J142746.10+563836.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,216.942125,56.64339,0,NULL,57257218639,894644041,13978813,18.5),(120922,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120922,38.2,0.46,437,53659,70,NULL,NULL,'2MASX J14274657+2644102',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000193,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,216.944083333,26.73625,0,NULL,60023958510,937874351,14654286,17),(120923,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120923,37.32,0.46,290,53660,70,NULL,NULL,'2MASX J14274780+1833243',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,216.94925,18.55686,0,NULL,59480619354,929384677,14521635,17.8),(120924,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120924,37.41,0.46,304,53661,70,NULL,NULL,'2MASX J14274828+4303255',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000139,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,216.951167,43.05694,0.012,NULL,59958717916,936854967,14638358,17.4),(120925,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120925,35.88,0.33,150,53662,70,NULL,NULL,'2MASX J14274888+2629002',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000133,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,216.9537083,26.48353,0,NULL,60021050520,937828914,14653576,16.1),(120926,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120926,37.48,0.46,314,53663,70,NULL,NULL,'2MASX J14274934+0340259',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00007,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,216.955667,3.67389,0.025,NULL,58302077208,910969956,14233905,16.8),(120927,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120927,36.56,0.46,205,53664,70,NULL,NULL,'2MASX J14274959+2324463',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000175,NULL,'16.0g',0.42,NULL,NULL,NULL,NULL,NULL,1,216.956833,23.41294,0.033,NULL,59497775108,929652736,14525824,16),(120928,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120928,38.08,0.33,412,53665,70,NULL,NULL,'2MASX J14274988+5405548',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,216.957833,54.09869,0,NULL,59197279821,924957497,14452460,17.9),(120929,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120929,38.41,0.15,480,53666,70,NULL,NULL,'2MASX J14275132+5653568',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000176,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,216.963583,56.89925,0,NULL,57249588480,894524820,13976950,17.4),(120930,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120930,37.74,0.46,354,53667,70,NULL,NULL,'SDSS J142752.52+462605.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000162,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,216.968875,46.43472,0,NULL,59228582150,925446596,14460103,18.2),(120931,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120931,36.67,0.46,216,53668,70,NULL,NULL,'2MASX J14275258+2811112',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.13',0.29,NULL,NULL,NULL,NULL,NULL,1,216.9690417,28.18639,0,NULL,60055272322,938363630,14661931,17.13),(120932,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120932,38.32,0.46,461,53669,70,NULL,NULL,'2MASX J14275348+4640496',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,216.9730417,46.68028,0,NULL,59228772686,925449573,14460149,17.9),(120933,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120933,37.04,0.46,255,53670,70,NULL,NULL,'2MASX J14275375+0034109',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000078,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,216.974,0.56961,0.093,NULL,58291214049,910800219,14231253,16.8),(120934,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120934,36.09,0.46,165,53671,70,NULL,NULL,'2MASX J14275389+0658209',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000168,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,216.974625,6.9725,0.025,NULL,58272950882,910514857,14226794,16.4),(120935,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120935,36.71,0.46,220,53672,70,NULL,NULL,'2MASX J14275397+1316416',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000176,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,216.97475,13.27825,0,NULL,59542975147,930358986,14536859,16.4),(120936,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120936,35.75,0.46,141,53673,70,NULL,NULL,'SDSS J142754.73+161226.0',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',NULL,NULL,'15.1g',0.54,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.978083,16.20725,0,NULL,59490736638,929542759,14524105,15.1),(120937,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120937,37.55,0.33,324,53674,70,NULL,NULL,'2MASX J14275542+4100488',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,216.981,41.01356,0,NULL,59948992293,936703004,14635984,17.7),(120938,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120938,36.23,0.27,176,53675,70,NULL,NULL,'2MASX J14275560+2424052',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000189,NULL,'15.5g',0.48,NULL,NULL,NULL,NULL,NULL,1,216.981833,24.40144,0.022,NULL,59497209458,929643897,14525685,15.5),(120939,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120939,38.4,0.46,478,53676,70,NULL,NULL,'LCRS B142520.5-024552',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,216.984375,-2.98767,0.177,NULL,43515942517,679936601,10624009,18.2),(120940,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120940,36.59,0.46,208,53677,70,NULL,NULL,'2MASX J14275761+5220538',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000182,NULL,'15.9g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,216.9897917,52.34833,0,NULL,59203189982,925049843,14453903,15.9),(120941,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120941,37.84,0.46,370,53678,70,NULL,NULL,'2MASX J14275804+1853532',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,216.991875,18.89814,0.008,NULL,59511837810,929872465,14529257,18),(120942,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120942,36.72,0.33,221,53679,70,NULL,NULL,'2MASX J14275805+0617499',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,216.991916667,6.29731,0.005,NULL,58273374964,910521483,14226898,17.5),(120943,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120943,36.11,0.6,167,53680,70,NULL,NULL,'2MASX J14275808-0703054',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.15',0.46,NULL,NULL,NULL,NULL,NULL,1,216.992125,-7.05175,0.149,NULL,43531226721,680175417,10627740,16.15),(120944,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120944,35.88,0.33,150,53681,70,NULL,NULL,'IC 4436',NULL,'2015arXiv151105856S',2015,1,0.96,NULL,'G',0.000087,NULL,'14.5g',0.8,'E?',NULL,NULL,NULL,NULL,1,216.992417,26.5045,0,NULL,60023917021,937873703,14654276,14.5),(120945,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120945,37.25,0.27,282,53682,70,NULL,NULL,'SDSS J142758.90+123509.9',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000197,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,216.995417,12.58608,0,NULL,59542422003,930350343,14536724,16.6),(120946,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120946,37.71,0.46,348,53683,70,NULL,NULL,'2MASX J14275993+3441290',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000137,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,216.999583,34.69153,0,NULL,60039158393,938111849,14657997,18),(120947,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120947,36.87,0.46,236,53684,70,NULL,NULL,'2MASX J14280059+3724038',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000184,NULL,'15.8g',0.48,'E0',NULL,NULL,NULL,NULL,1,217.002417,37.40092,0,NULL,60064449294,938507020,14664172,15.8),(120948,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120948,38.41,0.15,480,53685,70,NULL,NULL,'2MASX J14280084+5700458',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000185,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,217.003416667,57.01286,0,NULL,57249618463,894525288,13976957,17.7),(120949,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120949,35.25,0.2,112,53686,74.4,NULL,NULL,'CGCG 075-041',NULL,'2013AJ....146...86T',2013,1,0.72,NULL,'G',0.00005,NULL,'15.2g',0.43,NULL,NULL,NULL,NULL,NULL,1,217.004667,11.69083,0.036,NULL,59358747648,927480432,14491881,15.2),(120950,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120950,35.78,0.27,143,53687,70,NULL,NULL,'2MASX J14280173+3730558',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000171,NULL,'15.8g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,217.0072917,37.51556,0,NULL,60064422823,938506606,14664165,15.8),(120951,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120951,36.23,0.27,176,53688,70,NULL,NULL,'2MASX J14280181+2423426',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,217.0077083,24.39531,0.022,NULL,59497209154,929643893,14525685,17),(120952,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120952,37.06,0.33,258,53689,70,NULL,NULL,'LCRS B142527.3-021600',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,217.011167,-2.48975,0.157,NULL,43516026397,679937912,10624029,17.5),(120953,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120953,31.01,0.49,15.9,53690,75,NULL,'IR','UGC 09274',NULL,'2011yCatp016004901K',2011,1,1.3,'Noted as a possible \\\"nest\\\" in MCG.','G',0.000033,NULL,'14.35',0.8,'SB?',NULL,NULL,NULL,NULL,1,217.0114583,21.30381,0.068,NULL,59524513310,930070520,14532351,14.35),(120954,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120954,37.42,0.33,304,53691,70,NULL,NULL,'2MASX J14280354+2036463',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,217.0147917,20.61303,0.047,NULL,59524206749,930065730,14532277,16.3),(120955,'TRGB','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120955,27.74,0.23,3.53,53692,NULL,NULL,'I','UKS 1424-460',NULL,'2009AJ....138..332J',2009,1,2.4,NULL,'G',0.000007,NULL,'16.50',0.9,'IB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,217.015417,-46.30167,0.549,NULL,46800404475,731256319,11425879,16.5),(120956,'TRGB','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120956,27.78,NULL,3.6,53692,NULL,NULL,NULL,'UKS 1424-460',NULL,'2002A&A...385...21K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120957,'TRGB','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120957,27.79,0.1,3.61,53692,74.4,NULL,NULL,'UKS 1424-460',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120958,'TRGB','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120958,27.79,0.11,3.62,53692,NULL,NULL,NULL,'UKS 1424-460',NULL,'2015ApJ...802L..25T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120959,'Tully est','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120959,27.48,0.8,3.1,53692,75,NULL,NULL,'UKS 1424-460',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120960,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120960,37.85,0.46,372,53693,70,NULL,NULL,'2MASX J14280424+1812054',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.61',0.15,NULL,NULL,NULL,NULL,NULL,1,217.017667,18.20161,0,NULL,59481466596,929397915,14521842,18.61),(120961,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120961,33.99,0.43,62.9,53694,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09279',NULL,'2014MNRAS.444..527S',2014,1,0.93,NULL,'G',0.000033,NULL,'16.2g',0.3,'Scd:',NULL,NULL,NULL,NULL,1,217.024708333,33.81828,0,NULL,60041409197,938147018,14658547,16.2),(120962,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120962,37,0.46,251,53695,70,NULL,NULL,'2MASX J14280681+0321318',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000066,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,217.028416667,3.35878,0.049,NULL,58301920043,910967500,14233867,17.4),(120963,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120963,37.25,0.27,282,53696,70,NULL,NULL,'SDSS J142806.93+123737.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.028916667,12.62706,0,NULL,59543290065,930363907,14536936,17.4),(120964,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120964,36.58,0.46,207,53697,70,NULL,NULL,'SDSS J142806.97+254332.0',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,217.0290417,25.72556,0,NULL,60021318170,937833096,14653642,17.2),(120965,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120965,36.86,0.09,235,53698,70,NULL,NULL,'2MASX J14280741+1654115',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,217.031,16.90325,0,NULL,59491231177,929550487,14524226,17.7),(120966,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120966,38.21,0.46,439,53699,70,NULL,NULL,'2MASX J14280800+1513401',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,217.03325,15.22769,0,NULL,59476725893,929323842,14520685,17.7),(120967,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120967,37.29,0.46,287,53700,70,NULL,NULL,'2MASX J14280801+0648349',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000151,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,217.033583,6.80981,0.013,NULL,58273460667,910522822,14226919,17.3),(120968,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120968,37.53,0.46,321,53701,70,NULL,NULL,'VII Zw 550',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000176,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,217.040417,58.19114,0.009,NULL,57248403291,894506301,13976660,17),(120969,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120969,36.87,0.46,236,53702,70,NULL,NULL,'2MASX J14280988+5657078',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000158,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,217.041083333,56.95222,0,NULL,57249614674,894525229,13976956,16.7),(120970,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120970,33.88,0.8,59.7,53703,75,NULL,'HMCL, I','KUG 1425+271',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000027,NULL,'15.38',0.4,'S?',NULL,NULL,NULL,NULL,1,217.042083,26.93583,0,NULL,60022874776,937857418,14654022,15.38),(120971,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120971,34.47,0.4,78.3,53703,75,NULL,'HMCL, I, raw','KUG 1425+271',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120972,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120972,34.53,0.4,80.5,53703,75,NULL,'HMCL, I, inv','KUG 1425+271',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120973,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120973,34.75,0.4,89.1,53703,75,NULL,'HMCL, I, cor','KUG 1425+271',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120974,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120974,36.7,0.33,218,53704,70,NULL,NULL,'2MASX J14281005+5953268',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,217.042208333,59.89089,0,NULL,57752419920,902381561,14099711,17.4),(120975,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120975,37.34,0.46,293,53705,70,NULL,NULL,'LCRS B142534.5-024337',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00013,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,217.0427083,-2.95014,0.173,NULL,43515966047,679936969,10624015,17.2),(120976,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120976,37.25,0.27,282,53706,70,NULL,NULL,'SDSS J142810.35+123711.7',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',NULL,NULL,'15.8g',0.37,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.043125,12.61994,0,NULL,59543290719,930363917,14536936,15.8),(120977,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120977,30.25,0.2,11.2,53707,74.4,NULL,NULL,'UGC 09273',NULL,'2013AJ....146...86T',2013,1,0.97,NULL,'G',0.000017,NULL,'15.4g',0.47,'Irr;WR?        HII',NULL,NULL,NULL,NULL,1,217.04525,13.55158,0,NULL,59475531797,929305184,14520393,15.4),(120978,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120978,37.47,0.33,312,53708,70,NULL,NULL,'SDSS J142810.89+034606.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000064,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,217.045417,3.76858,0.025,NULL,58301957475,910968085,14233876,18.3),(120979,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120979,37.55,0.33,323,53709,70,NULL,NULL,'2MASX J14281149+0244488',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000083,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,217.0479583,2.747,0.049,NULL,58296666182,910885409,14232584,16.6),(120980,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120980,38.31,0.46,459,53710,70,NULL,NULL,'2MASX J14281151+0957069',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,217.048125,9.95192,0.049,NULL,58271343985,910489749,14226402,17.7),(120981,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120981,36.72,0.46,220,53711,70,NULL,NULL,'2MASX J14281154+1500532',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.26',0.16,'AGN',NULL,NULL,NULL,NULL,1,217.048125,15.01467,0,NULL,59477280939,929332514,14520820,18.26),(120982,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120982,38.06,0.33,409,53712,70,NULL,NULL,'SDSS J142812.35+201138.1',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,217.0515,20.19394,0.042,NULL,59511406842,929865731,14529152,NULL),(120983,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120983,37.06,0.33,258,53713,70,NULL,NULL,'LCRS B142537.1-021749',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000103,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,217.0522083,-2.52,0.165,NULL,43516007194,679937612,10624025,16.6),(120984,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120984,37.08,0.46,260,53714,70,NULL,NULL,'2MASX J14281367+1008479',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,217.056875,10.14658,0.049,NULL,58270866794,910482293,14226285,17),(120985,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120985,34.92,0.8,96.4,53715,75,NULL,'MAT, I','ESO 511- G 042',NULL,'1997ApJS..109..333W',1997,1,3.14,NULL,'G',0.00003,NULL,'16.12',0.34,'Sbc',NULL,NULL,NULL,NULL,1,217.058625,-23.87303,0.281,NULL,46532360465,727068132,11360439,16.12),(120986,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120986,34.46,NULL,77.9,53715,NULL,NULL,'Dipole','ESO 511- G 042',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120987,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120987,34.46,NULL,78,53715,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 511- G 042',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120988,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120988,34.47,NULL,78.4,53715,NULL,NULL,'Dipole + Quadrupole','ESO 511- G 042',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120989,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120989,34.58,NULL,82.5,53715,NULL,NULL,NULL,'ESO 511- G 042',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120990,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120990,35.27,0.49,113,53715,75,NULL,'IR','ESO 511- G 042',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120991,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120991,35.31,0.43,115,53715,75,NULL,'MAT, I, raw','ESO 511- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120992,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120992,35.47,0.32,124,53715,85,NULL,'I, raw','ESO 511- G 042',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120993,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120993,35.53,0.32,128,53715,85,NULL,'I, inv','ESO 511- G 042',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120994,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120994,35.58,0.43,130,53715,75,NULL,'MAT, I, inv','ESO 511- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120995,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120995,35.64,0.43,134,53715,75,NULL,'MAT, I, cor','ESO 511- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120996,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120996,37.55,0.33,324,53716,70,NULL,NULL,'2MASX J14281426+4052199',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000181,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,217.059333,40.87217,0,NULL,59946698429,936667162,14635424,16.9),(120997,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120997,36.68,0.27,216,53717,70,NULL,NULL,'CGCG 019-037',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000103,NULL,'16.0g',0.28,'S0',NULL,NULL,NULL,NULL,1,217.064917,-1.9825,0.137,NULL,43514439802,679913121,10623642,16),(120998,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120998,35.32,0.4,116,53718,NULL,NULL,'mean','ESO 385- G 026',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000033,NULL,'14.67',0.6,'SB(r)bc',NULL,NULL,NULL,NULL,1,217.065708333,-33.3085,0.257,NULL,47000936375,734389630,11474837,14.67),(120999,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120999,35.51,0.54,127,53718,NULL,NULL,'Malmquist cor.','ESO 385- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121000,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,121000,35.53,0.47,128,53718,NULL,NULL,'H','ESO 385- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121001,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,121001,35.64,0.46,134,53718,NULL,NULL,'J','ESO 385- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121002,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,121002,35.66,0.5,136,53718,NULL,NULL,NULL,'ESO 385- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121003,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,121003,35.7,0.2,138,53718,74.4,NULL,NULL,'ESO 385- G 026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121004,'D-Sigma','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,121004,34,0.4,63.1,53719,75,NULL,'Edat, raw','NGC 5629',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.00008,NULL,'13.03',1.8,'S0             RET','in a pair',NULL,NULL,NULL,1,217.0682083,25.84878,0,NULL,60021335427,937833366,14653646,13.03),(121005,'D-Sigma','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,121005,34.34,0.4,73.7,53719,75,NULL,'Edat, cor','NGC 5629',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121006,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,121006,34.18,0.4,68.6,53719,NULL,NULL,'mean','NGC 5629',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121007,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,121007,34.73,0.45,88.2,53719,NULL,NULL,'K','NGC 5629',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121008,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121008,36.23,0.27,176,53720,70,NULL,NULL,'2MASX J14281791+2424107',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000185,NULL,'15.8g',0.41,NULL,NULL,NULL,NULL,NULL,1,217.074833333,24.40303,0,NULL,59497029773,929641090,14525642,15.8),(121009,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121009,38.74,0.46,560,53721,70,NULL,NULL,'2MASX J14281802+5334079',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,217.074917,53.56883,0,NULL,59196918265,924951847,14452372,17.4),(121010,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,121010,31.92,0.4,24.2,53722,75,NULL,'B','IC 1014',NULL,'1988NBGC.C....0000T',1988,1,1.59,NULL,'G',0.000019,NULL,'13.8g',1.07,'Sdm','in a pair',NULL,NULL,NULL,1,217.0767917,13.78022,0,NULL,59475505697,929304776,14520387,13.8),(121011,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121011,37.65,0.46,339,53723,70,NULL,NULL,'2MASX J14281920+2918437',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000196,NULL,'16.5g',0.27,'Sa',NULL,NULL,NULL,NULL,1,217.080125,29.31225,0,NULL,60059396390,938428068,14662938,16.5),(121012,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121012,38.53,0.46,507,53724,70,NULL,NULL,'SDSS J142819.60+490043.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.0817083,49.01217,0.025,NULL,59244809964,925700155,14464064,18.3),(121013,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121013,36.68,0.27,216,53725,70,NULL,NULL,'2MASX J14281988-0148460',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000185,NULL,'16.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.082917,-1.81272,0.133,NULL,43514570881,679915170,10623674,16.9),(121014,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121014,37.48,0.21,313,53726,70,NULL,NULL,'2MASX J14281992+4559098',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000182,NULL,'16.2g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,217.082917,45.986,0.014,NULL,59228511444,925445491,14460085,16.2),(121015,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121015,37.92,0.46,383,53727,70,NULL,NULL,'2MASX J14282020+4646568',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000149,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,217.084,46.78253,0,NULL,59228778426,925449662,14460150,18.1),(121016,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,121016,34.04,0.2,64.3,53728,74.4,NULL,NULL,'CGCG 075-043',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00006,NULL,'15.4',0.5,'S','Group member',NULL,NULL,NULL,1,217.08625,11.35944,0.017,NULL,59358238858,927472482,14491757,15.4),(121017,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121017,36.86,0.46,235,53729,70,NULL,NULL,'2MASXi J1428208+142746',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.5g',NULL,NULL,NULL,NULL,NULL,NULL,1,217.086833,14.46289,0,NULL,59476976557,929327758,14520746,17.5),(121018,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121018,36.18,0.33,172,53730,70,NULL,NULL,'2MASX J14282141+3629529',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,217.089375,36.49814,0,NULL,60077150671,938705479,14667273,17.2),(121019,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121019,36.51,0.46,200,53731,70,NULL,NULL,'2MASX J14282210+1247022',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000137,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,217.092167,12.78392,0,NULL,59543215504,930362742,14536917,17.2),(121020,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121020,37.48,0.21,313,53732,70,NULL,NULL,'2MASX J14282213+4557098',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000176,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,217.092541667,45.95283,0.014,NULL,59228510573,925445477,14460085,17.2),(121021,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121021,38.41,0.15,480,53733,70,NULL,NULL,'2MASX J14282237+5646437',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000169,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.0932917,56.77883,0,NULL,57256984965,894640390,13978756,18),(121022,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121022,37.28,0.46,286,53734,70,NULL,NULL,'2MASX J14282249+4412318',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000126,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,217.093667,44.20881,0,NULL,59955416027,936803375,14637552,17.5),(121023,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121023,36.52,0.21,201,53735,70,NULL,NULL,'2MASX J14282314+1729332',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.42',0.14,NULL,NULL,NULL,NULL,NULL,1,217.0965,17.49258,0,NULL,59480984354,929390380,14521724,18.42),(121024,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121024,37.55,0.33,323,53736,70,NULL,NULL,'2MASX J14282470+0250018',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000086,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,217.103,2.83386,0.065,NULL,58296672023,910885500,14232585,17),(121025,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121025,34.87,0.46,94.3,53737,70,NULL,NULL,'NGC 5628',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.00007,NULL,'14.33',0.7,'E',NULL,NULL,NULL,NULL,1,217.107458333,17.92436,0,NULL,59481486611,929398228,14521847,14.33),(121026,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121026,37.48,0.21,313,53738,70,NULL,NULL,'2MASX J14282587+4558098',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000206,NULL,'16.2g',0.37,'AGN',NULL,NULL,NULL,NULL,1,217.107875,45.96944,0.014,NULL,59228512211,925445503,14460085,16.2),(121027,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121027,36.52,0.21,201,53739,70,NULL,NULL,'SDSS J142826.09+173552.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.10875,17.59792,0,NULL,59480991932,929390498,14521726,17.4),(121028,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121028,37.24,0.46,280,53740,70,NULL,NULL,'2MASX J14282652+4538348',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000149,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,217.11075,45.64294,0,NULL,59228301281,925442207,14460034,18.1),(121029,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121029,36.7,0.33,218,53741,70,NULL,NULL,'2MASX J14282689+5956413',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000182,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,217.1122917,59.94472,0,NULL,57752377160,902380893,14099701,16.6),(121030,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121030,36.52,0.21,201,53742,70,NULL,NULL,'2MASX J14282726+1735012',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00009,NULL,'11.6K',NULL,NULL,NULL,NULL,NULL,NULL,1,217.113625,17.58364,0,NULL,59480994212,929390534,14521727,11.6),(121031,'FP','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,'R',121031,38.41,0.15,480,53743,70,NULL,NULL,'2MASX J14282822+5659180',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,217.1174583,56.98831,0,NULL,57249613481,894525210,13976956,17.9),(121032,'FP','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121032,36.46,0.56,195,53744,70,NULL,NULL,'2MASX J14282931-0319260',NULL,'2014MNRAS.445.2677S',2014,1,0.8,'The APM image includes a superposed star (or compact companion galaxy?).','G',0.000117,NULL,'15.22',0.49,NULL,NULL,NULL,NULL,NULL,1,217.122083,-3.32386,0.217,NULL,43539036957,680297452,10629647,15.22),(121033,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121033,33.68,0.8,54.3,53745,75,NULL,'HMCL, I','KUG 1426+274A',NULL,'1997ApJS..109..333W',1997,1,0.68,NULL,'G',0.000027,NULL,'15.1g',0.32,'S?','Group member of poor cluster',NULL,NULL,NULL,1,217.1285,27.26592,0,NULL,60023075532,937860555,14654071,15.1),(121034,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121034,34.96,0.4,98,53745,75,NULL,'HMCL, I, raw','KUG 1426+274A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121035,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121035,35.07,0.4,103,53745,75,NULL,'HMCL, I, inv','KUG 1426+274A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121036,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121036,35.39,0.4,120,53745,75,NULL,'HMCL, I, cor','KUG 1426+274A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121037,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121037,33.24,0.47,44.5,53746,NULL,NULL,'H','ESO 385- G 028',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000017,NULL,'14.5',1.5,'S(r)a',NULL,NULL,NULL,NULL,1,217.1295,-34.71064,0.261,NULL,47000115381,734376802,11474637,14.5),(121038,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121038,33.4,0.46,47.9,53746,NULL,NULL,'J','ESO 385- G 028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121039,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121039,33.41,0.45,48.1,53746,NULL,NULL,'K','ESO 385- G 028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121040,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121040,33.77,0.4,56.7,53746,NULL,NULL,'mean','ESO 385- G 028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121041,'D-Sigma','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121041,33.08,0.4,41.2,53747,75,NULL,'Edat, raw','IC 4421',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000047,NULL,'13.36',1,'E?',NULL,NULL,NULL,NULL,1,217.1304583,-37.58375,0.325,NULL,47214069531,737719836,11526872,13.36),(121042,'D-Sigma','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121042,33.41,0.4,48.1,53747,75,NULL,'Edat, cor','IC 4421',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121043,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121043,33.56,0.4,51.5,53747,NULL,NULL,'mean','IC 4421',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121044,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121044,33.83,0.45,58.4,53747,NULL,NULL,'K','IC 4421',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121045,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121045,34.13,0.4,67.1,53748,NULL,NULL,'mean','NGC 5635',NULL,'2007A&A...465...71T',2007,1,2.23,NULL,'G',0.00002,NULL,'13.1g',0.84,'S pec;LINER    Sy3','Group member, radial-velocity confirmed',NULL,NULL,'Flat-Spectrum Radio Source',1,217.132333333,27.40894,0,NULL,60023003896,937859435,14654053,13.1),(121046,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121046,34.47,0.46,78.3,53748,NULL,NULL,'J','NGC 5635',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121047,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121047,34.48,0.47,78.9,53748,NULL,NULL,'H','NGC 5635',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121048,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121048,34.57,0.45,81.9,53748,NULL,NULL,'K','NGC 5635',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121049,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121049,34.73,0.44,88.5,53749,NULL,NULL,'Malmquist cor.','ESO 447- G 006',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.25',0.6,'Sb             HII',NULL,NULL,NULL,NULL,1,217.135541667,-31.66347,0.281,NULL,47030114031,734845531,11481961,15.25),(121050,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121050,34.79,0.43,91,53749,NULL,NULL,NULL,'ESO 447- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121051,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121051,34.83,0.2,92.5,53749,74.4,NULL,NULL,'ESO 447- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121052,'FP','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,'R',121052,37.68,0.46,343,53750,70,NULL,NULL,'2MASX J14283247+5446000',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000198,NULL,'16.2g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,217.135417,54.76681,0,NULL,57254170127,894596408,13978068,16.2),(121053,'BL Lac Luminosity','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121053,38.88,NULL,529,53751,NULL,NULL,NULL,'2MASX J14283260+4240210',0.129139,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.000165,NULL,'16.8g',NULL,'BLLAC',NULL,NULL,NULL,'BL Lac',1,217.136083,42.67239,0.011,NULL,59959071776,936860496,14638445,16.8),(121054,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121054,34.14,0.39,67.4,53752,NULL,NULL,'Malmquist cor.','UGC 09277',NULL,'2009ApJS..182..474S',2009,1,1.8,NULL,'G',0.000033,NULL,'14.5g',0.34,'Sb(f)','Group member',NULL,NULL,NULL,1,217.138791667,3.262,0.049,NULL,58301934421,910967725,14233870,14.5),(121055,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121055,34.22,0.38,69.9,53752,NULL,NULL,NULL,'UGC 09277',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121056,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121056,34.26,0.2,71.1,53752,74.4,NULL,NULL,'UGC 09277',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121057,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121057,34.87,0.47,94.2,53752,NULL,NULL,'H','UGC 09277',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121058,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121058,35.07,0.45,103,53752,NULL,NULL,'K','UGC 09277',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121059,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121059,35.09,0.46,104,53752,NULL,NULL,'J','UGC 09277',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121060,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121060,35.36,0.4,118,53752,NULL,NULL,'mean','UGC 09277',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121061,'FP','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,'R',121061,36.67,0.46,216,53753,70,NULL,NULL,'2MASX J14283377+2559386',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'18.10',0.21,NULL,NULL,NULL,NULL,NULL,1,217.140708333,25.99397,0,NULL,60021154113,937830533,14653602,18.1),(121062,'FP','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121062,36.16,0.68,170,53754,70,NULL,NULL,'2MASX J14283425-2946213',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.4,NULL,NULL,NULL,NULL,NULL,1,217.1427083,-29.77264,0.349,NULL,47028516495,734820570,11481571,14.5),(121063,'FP','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,'R',121063,38.33,0.46,464,53755,70,NULL,NULL,'2MASXi J1428356+450234',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000192,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,217.148708333,45.04294,0,NULL,59954977168,936796518,14637445,17.4),(121064,'FP','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,'R',121064,37.48,0.21,313,53756,70,NULL,NULL,'2MASX J14283581+4600421',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000155,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,217.149375,46.01164,0.014,NULL,59228539156,925445924,14460092,17.1),(121065,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121065,32.21,0.69,27.6,53757,100,NULL,'mid-IR','UGC 09291',NULL,'2013ApJ...771...88L',2013,1,2.03,NULL,'G',0.000037,NULL,'13.7g',0.9,'Sd','Field galaxy',NULL,NULL,NULL,1,217.1537083,38.99914,0,NULL,60066510513,938539226,14664675,13.7),(121066,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121066,32.71,0.2,34.8,53757,74.4,NULL,NULL,'UGC 09291',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121067,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121067,32.84,0.43,37,53757,75,NULL,'3.6 micron, color corrected','UGC 09291',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121068,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121068,32.87,0.46,37.5,53757,NULL,NULL,NULL,'UGC 09291',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121069,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121069,32.95,0.45,38.9,53757,NULL,NULL,'Malmquist cor.','UGC 09291',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121070,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121070,33.04,0.43,40.5,53757,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09291',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121071,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121071,33.19,0.4,43.5,53757,NULL,NULL,'mean','UGC 09291',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121072,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121072,33.75,0.47,56.2,53757,NULL,NULL,'H','UGC 09291',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121073,'FP','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,'R',121073,38.32,0.33,462,53758,70,NULL,NULL,'2MASX J14283711+2557126',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.64',0.16,NULL,NULL,NULL,NULL,NULL,1,217.1547083,25.95353,0,NULL,60021281424,937832522,14653633,18.64),(121074,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,'R',121074,32.08,NULL,26.1,53759,72,NULL,NULL,'CGCG 019-041',NULL,'2014Ap.....57..457K',2014,1,0.86,NULL,'G',0.000063,NULL,'14.96',0.32,NULL,NULL,NULL,NULL,NULL,1,217.157667,0.55314,0.105,NULL,58291375688,910802745,14231292,14.96),(121075,'FP','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,'R',121075,35.21,0.46,110,53760,70,NULL,NULL,'CGCG 075-049',NULL,'2015arXiv151105856S',2015,1,0.45,'CGCG position is incorrect (B. Skiff).','G',0.00009,NULL,'15.5',0.29,NULL,NULL,NULL,NULL,NULL,1,217.157667,13.46606,0,NULL,59542887194,930357612,14536837,15.5),(121076,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121076,38.11,0.46,419,53761,70,NULL,NULL,'SDSS J142838.37+164909.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.159917,16.81928,0,NULL,59490227262,929534800,14523981,17.8),(121077,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121077,36.71,0.46,220,53762,70,NULL,NULL,'2MASX J14283845-0049501',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000078,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,217.160333333,-0.83067,0.101,NULL,43513115086,679892423,10623319,16.7),(121078,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121078,38.28,0.46,453,53763,70,NULL,NULL,'SDSS J142838.49+144147.8',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.0g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.160417,14.69661,0,NULL,59477083900,929329435,14520772,18),(121079,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121079,36.52,0.21,201,53764,70,NULL,NULL,'SDSS J142838.60+173425.3',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',NULL,NULL,'15.3g',0.45,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.160875,17.57372,0,NULL,59480986892,929390420,14521725,15.3),(121080,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121080,38.32,0.33,462,53765,70,NULL,NULL,'SDSS J142838.91+255734.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000184,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.162166667,25.95972,0,NULL,60021284153,937832564,14653633,18.7),(121081,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121081,38.02,0.46,402,53766,70,NULL,NULL,'2MASX J14284015+0136323',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000087,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,217.1672917,1.60908,0.081,NULL,58289784919,910777889,14230904,17.7),(121082,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121082,37.95,0.46,389,53767,70,NULL,NULL,'2MASX J14284041+3116187',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,217.1685,31.27186,0,NULL,60049684897,938276326,14660567,17.5),(121083,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121083,37.81,0.46,365,53768,70,NULL,NULL,'2MASX J14284045+5203242',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000148,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,217.16875,52.05675,0.009,NULL,59203347184,925052299,14453942,17.1),(121084,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121084,37.64,0.46,338,53769,70,NULL,NULL,'2MASX J14284267+3031317',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000176,NULL,'18.12',0.17,NULL,NULL,NULL,NULL,NULL,1,217.177875,30.52547,0,NULL,60048471907,938257373,14660271,18.12),(121085,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121085,36.78,0.46,227,53770,70,NULL,NULL,'2MASX J14284385+2902027',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000173,NULL,'16.4g',0.31,'E',NULL,NULL,NULL,NULL,1,217.182625,29.03408,0,NULL,60059534330,938430223,14662972,16.4),(121086,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121086,36.52,0.21,201,53771,70,NULL,NULL,'2MASX J14284401+1720074',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.6g',0.28,'S0','Group member',NULL,NULL,NULL,1,217.1835,17.33536,0,NULL,59480787031,929387297,14521676,16.6),(121087,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121087,38.13,0.46,423,53772,70,NULL,NULL,'SDSS J142844.30+004410.2',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000071,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,217.184583,0.73617,0.113,NULL,58291152333,910799255,14231238,18.8),(121088,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121088,37.34,0.46,293,53773,70,NULL,NULL,'2MASX J14284513+5031472',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000147,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.188167,50.52989,0,NULL,59201401773,925021902,14453467,17.7),(121089,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121089,33.81,0.8,57.7,53774,75,NULL,'HMCL, I','IC 4442',NULL,'1997ApJS..109..333W',1997,1,1.02,'HOLM 652B is a star.','G',0.000033,NULL,'14.6g',0.61,'SBa',NULL,NULL,NULL,NULL,1,217.188625,28.96425,0,NULL,60059505210,938429768,14662965,14.6),(121090,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121090,32.96,0.69,39,53774,100,NULL,'mid-IR','IC 4442',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121091,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121091,34.09,0.4,65.7,53774,NULL,NULL,'mean','IC 4442',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121092,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121092,34.1,0.4,66.1,53774,75,NULL,'HMCL, I, raw','IC 4442',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121093,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121093,34.24,0.4,70.5,53774,75,NULL,'HMCL, I, inv','IC 4442',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121094,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121094,34.27,0.4,71.6,53774,75,NULL,'HMCL, I, cor','IC 4442',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121095,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121095,34.4,0.47,75.8,53774,NULL,NULL,'H','IC 4442',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121096,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121096,38.1,0.46,416,53775,70,NULL,NULL,'SDSS J142846.06+192328.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.1919583,19.39111,0.039,NULL,59511687745,929870121,14529220,18.1),(121097,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121097,37.06,0.23,258,53776,70,NULL,NULL,'2MASX J14284608+3023147',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000162,NULL,'17.77',0.14,NULL,NULL,NULL,NULL,NULL,1,217.19225,30.38744,0,NULL,60048452210,938257065,14660266,17.77),(121098,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121098,37.48,0.21,313,53777,70,NULL,NULL,'2MASX J14284637+4600312',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000175,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,217.193375,46.00878,0.014,NULL,59228540730,925445948,14460092,17.7),(121099,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121099,33.8,0.4,57.5,53778,NULL,NULL,'mean','NGC 5639',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000033,NULL,'14.24',0.9,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,217.1939583,30.41294,0,NULL,60048451670,938257057,14660266,14.24),(121100,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121100,34.13,0.47,66.8,53778,NULL,NULL,'H','NGC 5639',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121101,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121101,36.14,NULL,169,53779,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1757',NULL,'2010Ap&SS.325..163P',2010,1,0.95,NULL,'G',0.000189,NULL,'16.9g',0.13,'Sd(f)',NULL,NULL,NULL,NULL,1,217.199833,59.2625,0,NULL,57751377142,902365267,14099457,16.9),(121102,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121102,36.17,NULL,171,53779,NULL,NULL,'Dipole + Quadrupole','FGC 1757',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121103,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121103,36.17,NULL,171,53779,NULL,NULL,NULL,'FGC 1757',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121104,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121104,36.18,0.49,173,53779,75,NULL,'IR','FGC 1757',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121105,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121105,36.2,NULL,174,53779,NULL,NULL,'Dipole','FGC 1757',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121106,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121106,36.96,0.46,247,53780,70,NULL,NULL,'SDSS J142850.16+310329.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000131,NULL,'17.4g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.209,31.05819,0,NULL,60049753852,938277403,14660584,17.4),(121107,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121107,37.42,0.33,304,53781,70,NULL,NULL,'2MASX J14285036+2021245',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.27',0.17,NULL,NULL,NULL,NULL,NULL,1,217.209708333,20.35686,0.042,NULL,59510107538,929845430,14528834,18.27),(121108,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121108,38.35,0.33,467,53782,70,NULL,NULL,'2MASX J14285100+1524484',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.87',0.13,NULL,NULL,NULL,NULL,NULL,1,217.212667,15.41339,0,NULL,59476345737,929317902,14520592,18.87),(121109,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121109,37.71,0.33,349,53783,70,NULL,NULL,'2MASX J14285390+5527111',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,217.224666667,55.45311,0,NULL,57258258011,894660281,13979066,17.8),(121110,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121110,38.01,0.11,400,53784,70,NULL,NULL,'2MASX J14285504+2521567',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.2292917,25.36564,0.01,NULL,60020925588,937826962,14653546,18),(121111,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121111,37.24,0.46,281,53785,70,NULL,NULL,'2MASX J14285613+4624573',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000189,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,217.234125,46.41583,0,NULL,59228652325,925447692,14460120,16.2),(121112,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121112,33.76,0.8,56.4,53786,75,NULL,'HMCL, I','UGC 09294',NULL,'1997ApJS..109..333W',1997,1,1.18,NULL,'G',0.000033,NULL,'14.7g',0.65,'SAB(s)bc',NULL,NULL,NULL,NULL,1,217.2375417,25.55342,0,NULL,60020835610,937825556,14653524,14.7),(121113,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121113,33.78,0.4,56.9,53786,75,NULL,'HMCL, I, raw','UGC 09294',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121114,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121114,33.86,0.4,59,53786,75,NULL,'HMCL, I, inv','UGC 09294',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121115,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121115,34.04,0.4,64.2,53786,75,NULL,'HMCL, I, cor','UGC 09294',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121116,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121116,35.23,0.2,111,53787,74.4,NULL,NULL,'UGC 09286',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000033,NULL,'14.76',0.6,'SBb',NULL,NULL,NULL,NULL,1,217.2372917,11.19683,0,NULL,59358307957,927473561,14491774,14.76),(121117,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121117,35.28,0.4,114,53787,NULL,NULL,'mean','UGC 09286',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121118,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121118,35.62,0.47,133,53787,NULL,NULL,'H','UGC 09286',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121119,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121119,35.7,0.45,138,53787,NULL,NULL,'K','UGC 09286',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121120,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121120,38.48,0.46,496,53788,70,NULL,NULL,'2MASX J14285719+3123007',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,217.238291667,31.38353,0,NULL,60049703851,938276622,14660572,17.7),(121121,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121121,36.51,0.46,201,53789,70,NULL,NULL,'2MASX J14285794+1032088',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000097,NULL,'16.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,217.2415417,10.53589,0.049,NULL,58270735993,910480249,14226253,16.9),(121122,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121122,36.88,0.46,238,53790,70,NULL,NULL,'2MASX J14285812+0543253',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,217.2422083,5.72361,0.049,NULL,58303913277,910998644,14234353,17.2),(121123,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121123,33.79,0.46,57.3,53791,70,NULL,NULL,'UGC 09288',NULL,'2015arXiv151105856S',2015,1,1.2,NULL,'G',0.00004,NULL,'13.85',1.2,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,217.242625,13.86189,0,NULL,59476803614,929325056,14520704,13.85),(121124,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121124,37.48,0.46,314,53792,70,NULL,NULL,'SDSS J142858.93+072542.9',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00014,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,217.245583333,7.42858,0.033,NULL,58280553926,910633655,14228650,17.8),(121125,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121125,34.25,0.8,70.9,53793,75,NULL,'HMCL, I','NGC 5637',NULL,'1997ApJS..109..333W',1997,1,0.88,NULL,'G',0.000027,NULL,'14.1g',0.63,'Sc',NULL,NULL,NULL,NULL,1,217.248333,23.1915,0.06,NULL,59497804603,929653196,14525831,14.1),(121126,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121126,33.84,0.4,58.7,53793,75,NULL,'HMCL, I, raw','NGC 5637',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121127,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121127,33.98,0.4,62.6,53793,75,NULL,'HMCL, I, inv','NGC 5637',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121128,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121128,34.11,0.4,66.5,53793,75,NULL,'HMCL, I, cor','NGC 5637',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121129,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121129,38.01,0.11,400,53794,70,NULL,NULL,'2MASX J14290013+2521577',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.0001,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,217.250625,25.36589,0.01,NULL,60020956094,937827438,14653553,17.2),(121130,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121130,38.35,0.33,467,53795,70,NULL,NULL,'2MASX J14290069+1526254',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,217.2527917,15.44053,0,NULL,59490042170,929531908,14523936,17.4),(121131,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121131,38.06,0.33,409,53796,70,NULL,NULL,'2MASX J14290128+1957544',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.98',0.12,NULL,NULL,NULL,NULL,NULL,1,217.255458333,19.96522,0.041,NULL,59511957161,929874330,14529286,18.98),(121132,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121132,38.52,0.46,505,53797,70,NULL,NULL,'2MASX J14290251+1434494',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.66',0.15,NULL,NULL,NULL,NULL,NULL,1,217.260541667,14.58044,0,NULL,59477002642,929328166,14520752,18.66),(121133,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121133,37.71,0.33,349,53798,70,NULL,NULL,'2MASX J14290344+5531031',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000181,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,217.264167,55.5175,0,NULL,57258234745,894659917,13979061,16.8),(121134,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121134,31.84,0.2,23.3,53799,74.4,NULL,NULL,'UGC 09285',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000073,NULL,'15.07',0.3,'Sc(f)','Group member',NULL,NULL,NULL,1,217.266166667,3.14903,0.049,NULL,58315516036,911179938,14237186,15.07),(121135,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121135,31.91,0.63,24.1,53799,NULL,NULL,'Malmquist cor.','UGC 09285',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121136,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121136,32.04,NULL,25.6,53799,72,NULL,NULL,'UGC 09285',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121137,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121137,32.17,0.56,27.2,53799,NULL,NULL,NULL,'UGC 09285',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121138,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121138,37.88,0.46,377,53800,70,NULL,NULL,'2MASX J14290500+3525529',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00016,NULL,'17.5g',0.16,'S0',NULL,NULL,NULL,NULL,1,217.270667,35.43131,0,NULL,60038503000,938101609,14657837,17.5),(121139,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121139,38.41,0.15,480,53801,70,NULL,NULL,'2MASX J14290533+5645170',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.2725,56.75478,0,NULL,57257000364,894640630,13978759,17.9),(121140,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121140,34.63,0.43,84.3,53802,75,NULL,'3.6 micron, color corrected','UGC 09303',NULL,'2014MNRAS.444..527S',2014,1,1.1,NULL,'G',0.000027,NULL,'15.8g',0.24,'S?',NULL,NULL,NULL,NULL,1,217.2827917,32.91017,0,NULL,60040727303,938136364,14658380,15.8),(121141,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121141,34.63,0.43,84.3,53802,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09303',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121142,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121142,34.66,0.2,85.5,53802,74.4,NULL,NULL,'UGC 09303',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121143,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121143,37.49,0.46,315,53803,70,NULL,NULL,'2MASX J14290911+3716093',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000167,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,217.2877917,37.26933,0,NULL,60064413316,938506458,14664163,17),(121144,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121144,38.14,0.23,425,53804,70,NULL,NULL,'SDSS J142909.63+145545.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.290125,14.92928,0,NULL,59477272682,929332385,14520818,18),(121145,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121145,33.21,0.2,43.9,53805,74.4,NULL,NULL,'UGC 09302',NULL,'2013AJ....146...86T',2013,1,1.26,NULL,'G',0.000043,NULL,'15.7g',0.28,'Sdm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,217.29075,31.79867,0,NULL,60049534777,938273980,14660530,15.7),(121146,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121146,33.51,0.49,50.3,53805,75,NULL,'IR','UGC 09302',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121147,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121147,37.57,0.46,327,53806,70,NULL,NULL,'SDSS J142909.86+362250.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,217.291083333,36.38083,0,NULL,60077175810,938705872,14667279,18),(121148,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121148,36.16,0.56,171,53807,70,NULL,NULL,'2MASX J14290988-4649556',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,217.2912917,-46.83217,0.617,NULL,46801037286,731266207,11426034,16.8),(121149,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121149,35.28,0.4,114,53808,NULL,NULL,'mean','UGC 09292',NULL,'2007A&A...465...71T',2007,1,1.66,NULL,'G',0.000067,NULL,'14.7g',0.34,'SABb',NULL,NULL,NULL,NULL,1,217.294375,2.287,0.081,NULL,58290242604,910785040,14231016,14.7),(121150,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121150,35.45,0.49,123,53808,75,NULL,'IR','UGC 09292',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121151,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121151,35.62,0.47,133,53808,NULL,NULL,'H','UGC 09292',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121152,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121152,35.67,0.46,136,53808,NULL,NULL,'J','UGC 09292',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121153,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121153,35.7,0.45,138,53808,NULL,NULL,'K','UGC 09292',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121154,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121154,36.62,0.46,211,53809,70,NULL,NULL,'2MASX J14291093+5659240',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00016,NULL,'16.7g',0.37,NULL,NULL,NULL,NULL,NULL,1,217.2955417,56.99011,0,NULL,57249389974,894521718,13976901,16.7),(121155,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121155,37.53,0.46,321,53810,70,NULL,NULL,'2MASX J14291095+4315393',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,217.295833,43.26089,0.012,NULL,59959494536,936867102,14638548,17.4),(121156,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121156,37.5,0.46,316,53811,70,NULL,NULL,'2MASX J14291313+2616589',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000143,NULL,'17.68',0.23,NULL,NULL,NULL,NULL,NULL,1,217.30475,26.28311,0,NULL,60024019680,937875307,14654301,17.68),(121157,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121157,33.97,0.45,62.1,53812,NULL,NULL,'K','NGC 5642',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.00007,NULL,'13.64',1.3,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,217.3062083,30.02644,0,NULL,60048651803,938260184,14660315,13.64),(121158,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121158,33.97,0.4,62.4,53812,NULL,NULL,'mean','NGC 5642',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121159,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121159,38.3,0.46,458,53813,70,NULL,NULL,'SDSS J142914.03+303514.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000137,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.3085,30.58733,0,NULL,60048421472,938256585,14660259,18.5),(121160,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121160,38.14,0.23,425,53814,70,NULL,NULL,'2MASX J14291441+1459396',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.309916667,14.99431,0,NULL,59477277954,929332468,14520819,17.7),(121161,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121161,37.88,0.46,376,53815,70,NULL,NULL,'SDSS J142914.76+191615.7',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,217.3115,19.27103,0.055,NULL,59511721019,929870640,14529228,NULL),(121162,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121162,34.62,0.2,84,53816,74.4,NULL,NULL,'KUG 1426+119',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00005,NULL,'15.7g',0.28,'Spiral',NULL,NULL,NULL,NULL,1,217.3127083,11.69475,0.011,NULL,59358836485,927481820,14491903,15.7),(121163,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121163,37.52,0.46,319,53817,70,NULL,NULL,'2MASX J14291547+3609444',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,217.3145,36.16233,0,NULL,60068762866,938574419,14665225,17.2),(121164,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121164,37.01,0.46,252,53818,70,NULL,NULL,'SDSS J142915.72-000500.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000064,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,217.315541667,-0.08336,0.093,NULL,43513362768,679896293,10623379,17.7),(121165,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121165,34.69,0.57,86.6,53819,NULL,NULL,'Malmquist cor.','ESO 511- G 043',NULL,'2009ApJS..182..474S',2009,1,1.1,'FLASH project (2003MNRAS.339..652K) gives v = 8591 +/- 108 km/sec.','G',0.000033,NULL,'15.67',0.7,'Sb',NULL,NULL,NULL,NULL,1,217.317125,-27.13806,0.269,NULL,47015750087,734621095,11478454,15.67),(121166,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121166,34.72,0.56,88,53819,NULL,NULL,NULL,'ESO 511- G 043',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121167,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121167,34.76,0.2,89.5,53819,74.4,NULL,NULL,'ESO 511- G 043',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121168,'Ring Diameter','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121168,32.8,0.84,37,53820,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5641',NULL,'1981ApJS...45..541P',1981,1,2.36,NULL,'G',0.00003,NULL,'13.0g',1.1,'(R\')SAB(r)ab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,217.31925,28.82189,0,NULL,60059328471,938427007,14662921,13),(121169,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121169,33.87,0.8,59.4,53820,75,NULL,'HMCL, I','NGC 5641',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121170,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121170,34.05,0.46,64.6,53820,NULL,NULL,'J','NGC 5641',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121171,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121171,34.06,0.4,65,53820,75,NULL,'HMCL, I, raw','NGC 5641',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121172,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121172,34.08,0.47,65.4,53820,NULL,NULL,'H','NGC 5641',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121173,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121173,34.1,0.45,66.2,53820,NULL,NULL,'K','NGC 5641',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121174,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121174,34.13,0.4,67.1,53820,NULL,NULL,'mean','NGC 5641',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121175,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121175,34.23,0.4,70.2,53820,75,NULL,'HMCL, I, cor','NGC 5641',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121176,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121176,34.34,0.4,73.7,53820,75,NULL,'HMCL, I, inv','NGC 5641',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121177,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121177,37.43,0.23,306,53821,70,NULL,NULL,'SDSS J142916.60+231745.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000158,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,217.319166667,23.29603,0.07,NULL,59497826073,929653532,14525836,18.2),(121178,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121178,37.06,0.23,258,53822,70,NULL,NULL,'2MASX J14291793+3016179',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00018,NULL,'16.0g',0.34,NULL,NULL,NULL,NULL,NULL,1,217.324667,30.27181,0,NULL,60048558958,938258733,14660292,16),(121179,'SNIa','2016-12-15 15:15:26','2016-12-16 11:20:39','1','SCP 06G04',NULL,121179,44.82,0.05,3910,53823,70,NULL,'SALT2, M(B) -19.289 mag, Alpha -0.019, Beta 3.480, Delta -0.151','SDWFS J142918.75+343837.8',1.35,'2012ApJ...746...85S',2012,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia*',NULL,NULL,NULL,NULL,1,217.328083333,34.64372,0,NULL,60039009943,938109530,14657961,NULL),(121180,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121180,38.14,0.27,424,53824,70,NULL,NULL,'SDSS J142919.46+102002.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00014,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,217.331083333,10.33392,0.049,NULL,58269662064,910463469,14225991,18.4),(121181,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121181,36.75,0.46,224,53825,70,NULL,NULL,'2MASX J14292009+1345226',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,217.333833,13.75614,0,NULL,59545761899,930402529,14537539,17.3),(121182,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121182,38.41,0.15,480,53826,70,NULL,NULL,'2MASX J14292076+5636011',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,217.3365417,56.60036,0,NULL,57257187895,894643560,13978805,17.6),(121183,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121183,37.07,0.46,260,53827,70,NULL,NULL,'2MASX J14292146+4913173',NULL,'2015arXiv151105856S',2015,1,0.33,'1987ApJ...314..493K has z = 0.070164 +- 0.000334.','G',0.000158,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,217.339583,49.22161,0.025,NULL,59201824941,925028514,14453570,17),(121184,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121184,37.63,0.46,335,53828,70,NULL,NULL,'2MASX J14292188+3345020',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,217.341375,33.75067,0,NULL,60041437640,938147463,14658554,17.9),(121185,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121185,34.56,0.49,81.7,53829,75,NULL,'IR','ESO 511- G 044',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.000037,NULL,'14.95',0.5,'SBb            HII',NULL,NULL,NULL,NULL,1,217.341667,-22.92869,0.333,NULL,46534124762,727095699,11360870,14.95),(121186,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121186,35.21,0.47,110,53829,NULL,NULL,'H','ESO 511- G 044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121187,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121187,35.26,0.4,113,53829,NULL,NULL,'mean','ESO 511- G 044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121188,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121188,35.28,0.45,114,53829,NULL,NULL,'K','ESO 511- G 044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121189,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121189,35.37,0.46,118,53829,NULL,NULL,'J','ESO 511- G 044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121190,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121190,38.14,0.27,424,53830,70,NULL,NULL,'2MASX J14292204+1016253',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000196,NULL,'16.6g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,217.341833333,10.27381,0.049,NULL,58269873588,910466774,14226043,16.6),(121191,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121191,38.07,0.33,412,53831,70,NULL,NULL,'2MASX J14292263+2457219',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,217.344167,24.95619,0.029,NULL,59496838815,929638106,14525595,17.6),(121192,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121192,37.43,0.23,306,53832,70,NULL,NULL,'2MASX J14292386+2254436',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,217.3495417,22.91189,0.041,NULL,59497879948,929654374,14525849,17.8),(121193,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121193,37.06,0.23,258,53833,70,NULL,NULL,'2MASX J14292403+3016369',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000169,NULL,'17.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,217.350333,30.27689,0,NULL,60048569797,938258903,14660295,17.5),(121194,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121194,38.49,0.46,500,53834,70,NULL,NULL,'2MASX J14292533+1938396',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.76',0.14,NULL,NULL,NULL,NULL,NULL,1,217.355583,19.64433,0.042,NULL,59511566446,929868225,14529191,18.76),(121195,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121195,37.83,0.46,368,53835,70,NULL,NULL,'2MASX J14292564+0738393',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000187,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,217.3567917,7.64411,0.033,NULL,58283330007,910677031,14229328,17),(121196,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121196,37.9,0.23,380,53836,70,NULL,NULL,'SDSS J142925.83+234116.1',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000131,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,217.357667,23.68781,0.041,NULL,59500090014,929688906,14526389,18.2),(121197,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121197,37.93,0.33,386,53837,70,NULL,NULL,'SDSS J142926.73+345727.9',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000155,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,217.361416667,34.95778,0,NULL,60039204088,938112563,14658008,18.7),(121198,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121198,38.21,0.46,438,53838,70,NULL,NULL,'2MASX J14292682+3453079',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000179,NULL,'17.2g',0.26,'E/S0',NULL,NULL,NULL,NULL,1,217.361833,34.88567,0,NULL,60039200967,938112515,14658008,17.2),(121199,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121199,38.01,0.11,400,53839,70,NULL,NULL,'2MASX J14292751+2526259',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00017,NULL,'18.32',0.17,NULL,NULL,NULL,NULL,NULL,1,217.364708333,25.44053,0.01,NULL,60020960044,937827500,14653554,18.32),(121200,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121200,37.78,0.46,360,53840,70,NULL,NULL,'SDSS J142927.64+002236.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000071,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,217.3652083,0.37675,0.117,NULL,58290799436,910793741,14231152,18.2),(121201,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121201,37.76,0.46,356,53841,70,NULL,NULL,'LCRS B142653.0-022825',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.0002,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,217.368833,-2.69558,0.161,NULL,43513824640,679903510,10623492,17.1),(121202,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121202,37.43,0.23,306,53842,70,NULL,NULL,'CGCG 133-074',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000103,NULL,'15.2g',0.61,'BrClG',NULL,NULL,NULL,NULL,1,217.3722917,23.30675,0.07,NULL,59497819558,929653430,14525834,15.2),(121203,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121203,37.93,0.33,386,53843,70,NULL,NULL,'2MASX J14293016+3457239',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000191,NULL,'17.1g',0.26,'E/S0',NULL,NULL,NULL,NULL,1,217.375875,34.95656,0,NULL,60039202122,938112533,14658008,17.1),(121204,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121204,38.14,0.27,424,53844,70,NULL,NULL,'2MASX J14293165+1016079',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000176,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,217.381875,10.26894,0.049,NULL,58269871251,910466738,14226042,18),(121205,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121205,32.84,0.43,37,53845,75,NULL,'3.6 micron, color + selection bias corrected','ESO 385- G 031',NULL,'2014MNRAS.444..527S',2014,1,1.14,'Star superposed.','G',0.00015,NULL,'16.53',0.11,'Scd',NULL,NULL,NULL,NULL,1,217.382166667,-34.62436,0.261,NULL,46999659570,734369680,11474526,16.53),(121206,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121206,38.03,0.46,405,53846,70,NULL,NULL,'2MASX J14293180+1808176',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.3825,18.13831,0,NULL,59481279535,929394992,14521796,17.9),(121207,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121207,37.78,0.46,360,53847,70,NULL,NULL,'2MASX J14293300+1712346',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,217.387416667,17.20969,0,NULL,59482626916,929416045,14522125,17.2),(121208,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121208,35.51,0.57,127,53848,70,NULL,NULL,'2MASX J14293327-0933405',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00011,NULL,'15.54',0.5,'poss. LINER',NULL,NULL,NULL,NULL,1,217.388917,-9.56117,0.225,NULL,43521492760,680023324,10625364,15.54),(121209,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121209,34.79,0.49,90.8,53849,75,NULL,'IR','NGC 5646',NULL,'2011yCatp016004901K',2011,1,1.33,NULL,'G',0.000033,NULL,'14.6g',0.47,'SBb:',NULL,NULL,NULL,NULL,1,217.3917083,35.46194,0,NULL,60038506594,938101665,14657838,14.6),(121210,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121210,36.39,0.46,190,53850,70,NULL,NULL,'2MASX J14293440+1434496',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,217.393333,14.58039,0,NULL,59476898213,929326534,14520727,NULL),(121211,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121211,31.89,0.8,23.9,53851,75,NULL,'CF, r','UGC 09299',NULL,'1997ApJS..109..333W',1997,1,1.31,NULL,'G',0.00001,NULL,'14.6g',0.64,'SAB(s)d pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,217.394167,-0.01822,0.093,NULL,43513360071,679896251,10623378,14.6),(121212,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121212,32.29,0.2,28.7,53851,74.4,NULL,NULL,'UGC 09299',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121213,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121213,32.32,0.62,29.1,53851,NULL,NULL,'Malmquist cor.','UGC 09299',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121214,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121214,32.33,0.43,29.3,53851,75,NULL,'3.6 micron, color corrected','UGC 09299',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121215,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121215,32.34,0.43,29.3,53851,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09299',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121216,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121216,32.44,NULL,30.8,53851,72,NULL,NULL,'UGC 09299',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121217,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121217,32.47,0.58,31.2,53851,NULL,NULL,NULL,'UGC 09299',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121218,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121218,32.58,0.38,32.9,53851,75,NULL,'CF, r, inv','UGC 09299',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121219,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121219,32.63,0.38,33.6,53851,75,NULL,'CF, r, raw','UGC 09299',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121220,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121220,32.68,0.38,34.3,53851,75,NULL,'CF, r, cor','UGC 09299',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121221,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121221,37.39,0.46,301,53852,70,NULL,NULL,'2MASX J14293560+5151284',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,217.3982083,51.85781,0.005,NULL,59203313293,925051770,14453933,17.7),(121222,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121222,38.07,0.21,412,53853,70,NULL,NULL,'SDSS J142936.33+571721.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000121,NULL,'18.7g',0.09,NULL,NULL,NULL,NULL,NULL,1,217.401375,57.28919,0,NULL,57251382532,894552852,13977388,18.7),(121223,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121223,35.74,0.8,140,53854,75,NULL,'CF, r','UGC 09309',NULL,'1997ApJS..109..333W',1997,1,1.22,NULL,'G',0.00004,NULL,'14.9g',0.43,'Sbc',NULL,NULL,NULL,NULL,1,217.4105,10.58408,0.053,NULL,59359369242,927490144,14492033,14.9),(121224,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121224,34.87,0.38,94,53854,75,NULL,'CF, r, raw','UGC 09309',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121225,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121225,34.97,0.38,98.7,53854,75,NULL,'CF, r, inv','UGC 09309',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121226,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121226,35.1,0.38,105,53854,75,NULL,'CF, r, cor','UGC 09309',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121227,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121227,35.28,0.2,114,53854,74.4,NULL,NULL,'UGC 09309',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121228,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121228,38.09,0.33,415,53855,70,NULL,NULL,'2MASX J14293888+3013309',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000132,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.411875,30.22531,0,NULL,60048570435,938258913,14660295,17.9),(121229,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121229,37,0.46,251,53856,70,NULL,NULL,'2MASX J14293949+2058462',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.04',0.22,NULL,NULL,NULL,NULL,NULL,1,217.4145417,20.97947,0.059,NULL,59524067900,930063560,14532243,18.04),(121230,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121230,38.07,0.33,412,53857,70,NULL,NULL,'2MASX J14294040+2452044',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000133,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,217.4182917,24.86803,0.029,NULL,59496963660,929640057,14525625,16.8),(121231,'SBF','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121231,32.1,0.24,26.3,53858,NULL,NULL,'I','NGC 5638',NULL,'2001ApJ...546..681T',2001,1,1.91,NULL,'G',0.000014,NULL,'12.2g',1.55,'E1','in a radial-velocity based grouping',NULL,NULL,NULL,1,217.41825,3.23331,0.045,NULL,58315744104,911183501,14237242,12.2),(121232,'SBF','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121232,32.1,0.24,26.3,53858,NULL,NULL,NULL,'NGC 5638',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121233,'SBF','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121233,32.12,0.14,26.6,53858,74.4,NULL,NULL,'NGC 5638',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121234,'SBF','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121234,32.15,0.24,26.9,53858,NULL,NULL,'Malmquist cor.','NGC 5638',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121235,'D-Sigma','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121235,31.39,0.4,19,53858,75,NULL,'Edat, raw','NGC 5638',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121236,'D-Sigma','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121236,31.61,0.4,21,53858,75,NULL,'Edat, cor','NGC 5638',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121237,'Faber-Jackson','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121237,31.4,0.58,19.1,53858,95,NULL,'de Vaucouleurs','NGC 5638',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121238,'Faber-Jackson','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121238,31.68,0.35,21.7,53858,95,NULL,'Weighted Mean','NGC 5638',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121239,'Faber-Jackson','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121239,31.91,0.63,24.1,53858,95,NULL,'Michard 1979b, c','NGC 5638',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121240,'Faber-Jackson','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121240,32.3,0.46,28.8,53858,95,NULL,'Michard 1979a','NGC 5638',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121241,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121241,31.69,0.41,21.8,53858,NULL,NULL,NULL,'NGC 5638',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121242,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121242,31.9,0.41,23.9,53858,NULL,NULL,'Malmquist cor.','NGC 5638',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121243,'Tertiary','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121243,30.95,0.21,15.5,53858,95,NULL,NULL,'NGC 5638',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121244,'Tully est','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121244,32.27,0.8,28.4,53858,75,NULL,'B','NGC 5638',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121245,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121245,32.14,0.4,26.8,53858,NULL,NULL,'mean','NGC 5638',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121246,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121246,32.24,0.45,28,53858,NULL,NULL,'K','NGC 5638',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121247,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121247,36.82,0.17,231,53859,70,NULL,NULL,'CGCG 019-045',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000135,NULL,'15.4g',0.54,'BrClG',NULL,NULL,NULL,NULL,1,217.4192917,0.36639,0.117,NULL,58290800806,910793762,14231152,15.4),(121248,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121248,38.5,0.46,502,53860,70,NULL,NULL,'2MASX J14294071+1207079',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000203,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,217.419583,12.11892,0.009,NULL,59358387004,927474796,14491793,18),(121249,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121249,36.67,0.46,216,53861,70,NULL,NULL,'2MASX J14294077+0414123',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000067,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,217.4199583,4.23661,0.037,NULL,58316046944,911188233,14237316,17.1),(121250,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121250,37.5,0.46,316,53862,70,NULL,NULL,'2MASX J14294079+1414330',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.62',0.13,NULL,NULL,NULL,NULL,NULL,1,217.420125,14.24244,0,NULL,59476821650,929325338,14520708,18.62),(121251,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121251,37.9,0.23,380,53863,70,NULL,NULL,'2MASX J14294090+2353374',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00014,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,217.4202917,23.89386,0.033,NULL,59500027024,929687922,14526373,18.5),(121252,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121252,38.08,0.46,413,53864,70,NULL,NULL,'SDSS J142941.22-003148.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000068,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.42175,-0.53,0.093,NULL,43513470248,679897972,10623405,18.2),(121253,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121253,35.68,0.48,137,53865,70,NULL,NULL,'2MASX J14294200-0352226',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00014,NULL,'15.30',0.47,NULL,NULL,NULL,NULL,NULL,1,217.4252083,-3.87303,0.185,NULL,43550916150,680483064,10632547,15.3),(121254,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121254,36.56,0.23,205,53866,70,NULL,NULL,'CGCG 047-064',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.00017,NULL,'15.1g',0.57,NULL,NULL,NULL,NULL,NULL,1,217.4295417,7.25356,0.029,NULL,58280879165,910638736,14228730,15.1),(121255,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121255,38.22,0.46,440,53867,70,NULL,NULL,'SDSS J142943.53+091552.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000132,NULL,'18.2g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.431375,9.26469,0.025,NULL,58270000410,910468756,14226074,18.2),(121256,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121256,38.02,0.46,403,53868,70,NULL,NULL,'2MASX J14294367+2319312',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.49',0.17,NULL,NULL,NULL,NULL,NULL,1,217.432125,23.32542,0.07,NULL,59497817944,929653405,14525834,18.49),(121257,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121257,37.9,0.23,380,53869,70,NULL,NULL,'2MASX J14294408+2343552',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000193,NULL,'16.1g',0.4,'BrClG',NULL,NULL,NULL,NULL,1,217.43375,23.73206,0.041,NULL,59500120288,929689379,14526396,16.1),(121258,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121258,36.35,0.16,186,53870,70,NULL,NULL,'2MASX J14294457+5349414',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000176,NULL,'15.4g',0.52,'E0',NULL,NULL,NULL,NULL,1,217.435917,53.82825,0,NULL,59197189379,924956084,14452438,15.4),(121259,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121259,36.82,0.17,231,53871,70,NULL,NULL,'2MASX J14294491+0014014',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000056,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,217.437,0.23372,0.105,NULL,58290777835,910793403,14231146,17.6),(121260,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121260,36.56,0.23,205,53872,70,NULL,NULL,'2MASX J14294591+0710039',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000188,NULL,'16.2g',0.42,NULL,NULL,NULL,NULL,NULL,1,217.4412083,7.16783,0.029,NULL,58280884541,910638820,14228731,16.2),(121261,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121261,36.86,0.27,236,53873,70,NULL,NULL,'2MASX J14294598+4933304',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000182,NULL,'15.9g',0.36,'E0',NULL,NULL,NULL,NULL,1,217.441667,49.55833,0.005,NULL,59200995381,925015552,14453368,15.9),(121262,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121262,37.66,0.46,340,53874,70,NULL,NULL,'2MASX J14294699+2045572',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.68',0.15,NULL,NULL,NULL,NULL,NULL,1,217.4457917,20.76586,0.066,NULL,59510255484,929847741,14528870,18.68),(121263,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121263,37.9,0.23,380,53875,70,NULL,NULL,'2MASX J14294801+2346532',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000138,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,217.4500417,23.7815,0.041,NULL,59500096400,929689006,14526390,17.6),(121264,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121264,36.82,0.17,231,53876,70,NULL,NULL,'2MASX J14294824+0016584',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000068,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,217.4510417,0.28289,0.117,NULL,58290805308,910793832,14231153,17),(121265,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121265,36.55,0.46,204,53877,70,NULL,NULL,'2MASX J14294845+1759082',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,217.451833333,17.98553,0,NULL,59481320566,929395633,14521806,17.4),(121266,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121266,36.35,0.16,186,53878,70,NULL,NULL,'IC 1027',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000107,NULL,'14.8g',0.7,'BrClG',NULL,NULL,NULL,NULL,1,217.452083,53.96503,0.021,NULL,59196474446,924944913,14452264,14.8),(121267,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121267,38.06,0.46,410,53879,70,NULL,NULL,'SDSS J142948.91+335620.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,217.4537917,33.93906,0,NULL,60041297959,938145280,14658520,17.9),(121268,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121268,36.35,0.16,186,53880,70,NULL,NULL,'2MASX J14294909+5359342',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000177,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,217.454833,53.99297,0.021,NULL,59196474720,924944917,14452264,16.5),(121269,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121269,32.85,0.4,37.2,53881,75,NULL,'B','NGC 5660',NULL,'1988NBGC.C....0000T',1988,1,2.8,NULL,'G',0.000023,NULL,'12.4',2.5,'SAB(rs)c','Parent (of companion) galaxy',NULL,NULL,NULL,1,217.457541667,49.62267,0,NULL,59200868121,925013564,14453336,12.4),(121270,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121270,36.52,0.46,202,53882,70,NULL,NULL,'2MASX J14294984+0039534',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000069,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,217.457541667,0.66486,0.109,NULL,58290681238,910791894,14231123,17.3),(121271,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121271,37.6,0.46,331,53883,70,NULL,NULL,'SDSS J142950.07+151548.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.458625,15.26356,0,NULL,59476403298,929318801,14520606,18.4),(121272,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121272,34.44,0.2,77.3,53884,74.4,NULL,NULL,'KUG 1427+140',NULL,'2013AJ....146...86T',2013,1,0.98,NULL,'G',0.000108,NULL,'15.5g',0.25,'Spiral',NULL,NULL,NULL,NULL,1,217.460666667,13.79967,0,NULL,59545758064,930402469,14537538,15.5),(121273,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121273,33.13,0.4,42.3,53885,75,NULL,'B','UGC 09324',NULL,'1988NBGC.C....0000T',1988,1,2.3,'Coordinates for VV 152 are incorrect in VV Atlas.','G',0.00002,NULL,'14.9',1.4,'SBm',NULL,NULL,NULL,NULL,1,217.4614583,44.44783,0,NULL,59955455660,936803994,14637562,14.9),(121274,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121274,36.82,0.17,231,53886,70,NULL,NULL,'2MASX J14295104+0020564',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000085,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,217.462625,0.34892,0.117,NULL,58290808293,910793879,14231154,17.1),(121275,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121275,36.35,0.16,186,53887,70,NULL,NULL,'2MASX J14295195+5404552',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000165,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,217.46675,54.08194,0.021,NULL,59196507515,924945429,14452272,16.6),(121276,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121276,38.72,0.33,554,53888,70,NULL,NULL,'2MASX J14295239+1850222',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,217.4682083,18.83953,0.018,NULL,59511317349,929864333,14529130,17.2),(121277,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121277,38.07,0.46,412,53889,70,NULL,NULL,'2MASX J14295255+2426185',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00017,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,217.469,24.43844,0.041,NULL,59496868043,929638563,14525602,17.7),(121278,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121278,37.43,0.46,307,53890,70,NULL,NULL,'2MASX J14295295+2515215',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,217.470833,25.256,0.01,NULL,60020970563,937827665,14653557,17.6),(121279,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121279,34.52,0.51,80.3,53891,70,NULL,NULL,'2MASX J14295422-2937094',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.2b',NULL,'E',NULL,NULL,NULL,NULL,1,217.476,-29.61928,0.377,NULL,47027681577,734807524,11481367,15.2),(121280,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121280,38.09,0.33,415,53892,70,NULL,NULL,'2MASX J14295454+3011519',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000141,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,217.47725,30.19778,0,NULL,60048777473,938262148,14660346,17.8),(121281,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121281,36.56,0.23,205,53893,70,NULL,NULL,'CGCG 047-067',NULL,'2015arXiv151105856S',2015,1,0.93,'One of two 6cm sources associated with [WB92] 1427+0728','G',0.000203,NULL,'14.9g',0.6,NULL,NULL,NULL,NULL,NULL,1,217.48075,7.25358,0.017,NULL,58280878555,910638727,14228730,14.9),(121282,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121282,37.06,0.23,258,53894,70,NULL,NULL,'2MASX J14295608+3016279',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000155,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,217.4837917,30.27447,0,NULL,60048561751,938258777,14660293,17.4),(121283,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121283,37.15,0.46,269,53895,70,NULL,NULL,'2MASX J14295673+0756329',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.73',0.16,NULL,NULL,NULL,NULL,NULL,1,217.486375,7.9425,0.033,NULL,58283689812,910682653,14229416,18.73),(121284,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121284,37.59,0.46,329,53896,70,NULL,NULL,'2MASX J14295700-0044506',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00008,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,217.487667,-0.74742,0.081,NULL,43515447281,679928863,10623888,16.9),(121285,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121285,34.13,0.59,66.9,53897,70,NULL,NULL,'AM 1427-263',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.0',NULL,'S0',NULL,NULL,NULL,NULL,1,217.494875,-26.81017,0.289,NULL,47017734257,734652097,11478939,15),(121286,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121286,38.14,0.23,425,53898,70,NULL,NULL,'SDSS J142958.96+145146.8',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.0g',0.26,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.4957083,14.86303,0,NULL,59477158128,929330595,14520790,17),(121287,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121287,37.19,0.46,275,53899,70,NULL,NULL,'2MASX J14295894+1656291',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.78',0.2,NULL,NULL,NULL,NULL,NULL,1,217.4957083,16.94153,0,NULL,59482089485,929407648,14521994,17.78),(121288,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121288,37.66,0.46,341,53900,70,NULL,NULL,'2MASX J14295944+2918045',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000177,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,217.497666667,29.30139,0,NULL,60047981560,938249711,14660151,16.8),(121289,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121289,38.72,0.33,554,53901,70,NULL,NULL,'2MASX J14295943+1850102',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.55',0.15,NULL,NULL,NULL,NULL,NULL,1,217.4977917,18.83611,0.018,NULL,59511316543,929864320,14529130,18.55),(121290,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121290,36.82,0.17,231,53902,70,NULL,NULL,'2MASX J14295965+0012010',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000083,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,217.4984583,0.20033,0.117,NULL,58290856881,910794638,14231166,17.3),(121291,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121291,37.6,0.46,331,53903,70,NULL,NULL,'2MASX J14300069+2054442',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.52',0.25,NULL,NULL,NULL,NULL,NULL,1,217.503,20.91228,0.066,NULL,59510233478,929847398,14528865,17.52),(121292,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121292,31.63,NULL,21.2,53904,72,NULL,NULL,'UGC 09310',NULL,'2014Ap.....57..457K',2014,1,2,NULL,'G',0.000013,NULL,'14.50',0.6,'SBdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,217.504583,3.22056,0.057,NULL,58315740596,911183446,14237241,14.5),(121293,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121293,32.4,0.4,30.2,53904,75,NULL,'B','UGC 09310',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121294,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121294,37.64,0.33,337,53905,70,NULL,NULL,'2MASX J14300174+0607060',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000173,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,217.507375,6.11822,0.057,NULL,58272548578,910508571,14226696,16.7),(121295,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121295,32.86,NULL,37.3,53906,72,NULL,NULL,'IC 1022',NULL,'2014Ap.....57..457K',2014,1,1.25,NULL,'G',0.00003,NULL,'14.7g',0.43,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,217.507667,3.77286,0.045,NULL,58316411163,911193924,14237405,14.7),(121296,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121296,32.86,0.2,37.3,53906,74.4,NULL,NULL,'IC 1022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121297,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121297,33.14,0.79,42.5,53906,NULL,NULL,NULL,'IC 1022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121298,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121298,33.19,0.78,43.4,53906,NULL,NULL,'Malmquist cor.','IC 1022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121299,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121299,38.85,0.33,588,53907,70,NULL,NULL,'2MASX J14300188+2037122',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.76',0.15,NULL,NULL,NULL,NULL,NULL,1,217.5077917,20.62,0.058,NULL,59510318852,929848732,14528886,18.76),(121300,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121300,38.07,0.21,412,53908,70,NULL,NULL,'2MASX J14300211+5722531',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000169,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,217.508875,57.38139,0,NULL,57251380152,894552814,13977387,18.1),(121301,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121301,38.47,0.27,494,53909,70,NULL,NULL,'2MASX J14300246+1949002',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,217.5102083,19.81675,0.042,NULL,59512039347,929875614,14529306,17.8),(121302,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121302,37.44,0.46,307,53910,70,NULL,NULL,'2MASX J14300284+5839361',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000167,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,217.512125,58.66019,0,NULL,57248228963,894503577,13976618,17),(121303,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121303,38.34,0.46,466,53911,70,NULL,NULL,'2MASX J14300307+5654171',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,217.512833,56.90478,0,NULL,57249428319,894522317,13976911,17.9),(121304,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121304,36.76,0.16,225,53912,70,NULL,NULL,'2MASX J14300558+5239217',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000184,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,217.523083,52.65589,0.005,NULL,59206056244,925094628,14454603,16.4),(121305,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121305,38.85,0.33,588,53913,70,NULL,NULL,'SDSS J143006.22+203016.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.5259583,20.50461,0.057,NULL,59510344658,929849135,14528892,18.4),(121306,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121306,36.67,0.46,215,53914,70,NULL,NULL,'2MASX J14300641+3045249',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000167,NULL,'16.1g',0.42,NULL,NULL,NULL,NULL,NULL,1,217.526833333,30.75697,0,NULL,60049721005,938276890,14660576,16.1),(121307,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121307,35.51,0.54,127,53915,70,NULL,NULL,'FGC 1758',NULL,'2014MNRAS.445.2677S',2014,1,1.46,NULL,'G',0.000097,NULL,'14.08',0.17,'Sbc',NULL,NULL,NULL,NULL,1,217.52975,-6.42856,0.165,NULL,43530619222,680165925,10627592,14.08),(121308,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121308,38.14,0.23,425,53916,70,NULL,NULL,'2MASX J14301012+1502067',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.43',0.14,NULL,NULL,NULL,NULL,NULL,1,217.542,15.03517,0,NULL,59476446558,929319477,14520616,18.43),(121309,'Sosies','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121309,33.3,0.4,45.7,53917,NULL,NULL,NULL,'NGC 5653',NULL,'2002A&A...393...57T',2002,1,1.7,NULL,'G',0.000017,NULL,'12.86',1.3,'(R\')SA(rs)b;HIILIRG','Pair member, wide',NULL,NULL,NULL,1,217.543417,31.2155,0,NULL,60049812073,938278313,14660598,12.86),(121310,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121310,33.41,0.2,48.1,53917,74.4,NULL,NULL,'NGC 5653',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121311,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121311,33.59,0.45,52.2,53917,NULL,NULL,'K','NGC 5653',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121312,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121312,33.65,0.47,53.6,53917,NULL,NULL,'H','NGC 5653',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121313,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121313,33.71,0.46,55.1,53917,NULL,NULL,'J','NGC 5653',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121314,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121314,33.76,0.4,56.5,53917,NULL,NULL,'mean','NGC 5653',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121315,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121315,36.56,0.23,205,53918,70,NULL,NULL,'2MASX J14301090+0716440',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.50',0.15,NULL,NULL,NULL,NULL,NULL,1,217.5454583,7.27894,0.017,NULL,58280685244,910635706,14228682,18.5),(121316,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121316,34.37,0.46,75,53919,70,NULL,NULL,'MRK 0683',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000012,NULL,'14.7g',0.64,'Compact        HII',NULL,NULL,NULL,NULL,1,217.5457083,23.02628,0.055,NULL,59497889975,929654530,14525852,14.7),(121317,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121317,38.47,0.27,494,53920,70,NULL,NULL,'2MASX J14301136+1936377',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.62',0.14,NULL,NULL,NULL,NULL,NULL,1,217.547416667,19.61061,0.044,NULL,59512008503,929875132,14529298,18.62),(121318,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121318,38.01,0.11,400,53921,70,NULL,NULL,'SDSS J143011.44+253920.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000143,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.5477083,25.65561,0.019,NULL,60020856161,937825877,14653529,18.3),(121319,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121319,32.71,0.8,34.9,53922,75,NULL,'MAT, I','ESO 385- G 032',NULL,'1997ApJS..109..333W',1997,1,2.2,'Lawrence, et al. (1999MNRAS.308..897L) also give v=29379km/sec (cosmic ray?).','G',0.00002,NULL,'13.30',1.3,'SAB(r)c        HII?',NULL,NULL,NULL,NULL,1,217.5497917,-36.96436,0.313,NULL,47224843067,737888172,11529502,13.3),(121320,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121320,31.8,0.69,22.9,53922,100,NULL,'mid-IR','ESO 385- G 032',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121321,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121321,32.63,0.47,33.6,53922,NULL,NULL,'H','ESO 385- G 032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121322,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121322,32.68,0.4,34.4,53922,NULL,NULL,NULL,'ESO 385- G 032',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121323,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121323,32.7,0.32,34.6,53922,85,NULL,'I, raw','ESO 385- G 032',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121324,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121324,32.74,0.32,35.3,53922,85,NULL,'I, inv','ESO 385- G 032',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121325,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121325,32.75,0.45,35.5,53922,NULL,NULL,'K','ESO 385- G 032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121326,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121326,32.76,0.46,35.6,53922,NULL,NULL,'J','ESO 385- G 032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121327,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121327,32.8,0.43,36.2,53922,75,NULL,'MAT, I, raw','ESO 385- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121328,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121328,32.96,0.43,39.1,53922,75,NULL,'3.6 micron, color + selection bias corrected','ESO 385- G 032',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121329,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121329,32.98,0.43,39.5,53922,75,NULL,'3.6 micron, color corrected','ESO 385- G 032',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121330,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121330,32.99,0.43,39.6,53922,75,NULL,'MAT, I, inv','ESO 385- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121331,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121331,33.01,0.4,40.1,53922,NULL,NULL,'mean','ESO 385- G 032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121332,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121332,33.07,0.2,41.1,53922,74.4,NULL,NULL,'ESO 385- G 032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121333,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121333,33.1,0.43,41.6,53922,75,NULL,'MAT, I, cor','ESO 385- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121334,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121334,33.27,0.42,45.2,53922,NULL,NULL,NULL,'ESO 385- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121335,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121335,33.49,0.38,49.8,53922,NULL,NULL,'Malmquist cor.','ESO 385- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121336,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121336,38.47,0.27,494,53923,70,NULL,NULL,'2MASX J14301249+1935217',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,217.552166667,19.58936,0.044,NULL,59512008269,929875129,14529298,NULL),(121337,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121337,38.07,0.21,412,53924,70,NULL,NULL,'2MASX J14301306+5729337',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000128,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,217.554375,57.49286,0,NULL,57252076504,894563695,13977557,18.2),(121338,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121338,38.01,0.11,400,53925,70,NULL,NULL,'SDSS J143013.47+254720.2',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000147,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.556125,25.78897,0,NULL,60024296380,937879630,14654369,18.7),(121339,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121339,37.24,0.46,280,53926,70,NULL,NULL,'2MASX J14301357+1754497',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,217.556417,17.91389,0,NULL,59481275019,929394922,14521795,17.4),(121340,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121340,37.98,0.46,395,53927,70,NULL,NULL,'2MASX J14301400-0050341',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,217.5584583,-0.84286,0.081,NULL,43515762478,679933788,10623965,17.4),(121341,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121341,38.98,0.46,625,53928,70,NULL,NULL,'SDSS J143015.58+013857.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000074,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,217.5649583,1.64936,0.109,NULL,58290092457,910782694,14230979,18.6),(121342,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121342,32.92,0.8,38.4,53929,75,NULL,'MAT, I','ESO 385- G 033',NULL,'1997ApJS..109..333W',1997,1,2.3,'The 6dF data apply to a knot 7 arcsec southwest of the galaxy\'s center.','G',0.000007,NULL,'13.26',1.8,'SAB(s)d pec:   HII',NULL,NULL,NULL,NULL,1,217.565375,-34.23592,0.265,NULL,47000739383,734386552,11474789,13.26),(121343,'Tully est','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121343,33.08,0.8,41.3,53929,75,NULL,'B','ESO 385- G 033',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121344,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121344,32.04,0.32,25.6,53929,85,NULL,'I, raw','ESO 385- G 033',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121345,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121345,32.04,0.32,25.6,53929,85,NULL,'I, inv','ESO 385- G 033',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121346,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121346,32.12,0.4,26.5,53929,NULL,NULL,NULL,'ESO 385- G 033',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121347,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121347,32.71,0.43,34.8,53929,75,NULL,'MAT, I, raw','ESO 385- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121348,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121348,32.81,0.43,36.5,53929,75,NULL,'MAT, I, inv','ESO 385- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121349,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121349,32.99,0.43,39.7,53929,75,NULL,'MAT, I, cor','ESO 385- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121350,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121350,36.92,0.27,242,53930,70,NULL,NULL,'2MASX J14301628-0135371',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000183,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,217.567875,-1.59369,0.105,NULL,43514596743,679915574,10623680,16.9),(121351,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121351,37.75,0.46,354,53931,70,NULL,NULL,'SDSS J143017.14+153448.6',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.5714583,15.58019,0,NULL,59490064036,929532250,14523941,17.5),(121352,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121352,37.33,0.46,293,53932,70,NULL,NULL,'2MASX J14301758+1451318',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.76',0.11,NULL,NULL,NULL,NULL,NULL,1,217.5732917,14.85881,0,NULL,59477189018,929331078,14520798,18.76),(121353,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121353,34.44,0.49,77.3,53933,70,NULL,NULL,'2MASX J14301781-0514571',NULL,'2014MNRAS.445.2677S',2014,1,0.97,NULL,'G',0.00008,NULL,'14.95',0.47,NULL,NULL,NULL,NULL,NULL,1,217.574333,-5.24939,0.109,NULL,43538322904,680286295,10629473,14.95),(121354,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121354,38.29,0.46,456,53934,70,NULL,NULL,'2MASX J14301801+3657574',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.32',0.15,NULL,NULL,NULL,NULL,NULL,1,217.5752083,36.96594,0,NULL,60077301343,938707833,14667309,18.32),(121355,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121355,35.17,0.2,108,53935,74.4,NULL,NULL,'UGC 09316',NULL,'2013AJ....146...86T',2013,1,1.8,NULL,'G',0.000047,NULL,'14.80',0.5,'S0?',NULL,NULL,NULL,NULL,1,217.575417,21.74678,0.099,NULL,59523708175,930057940,14532155,14.8),(121356,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121356,35.6,0.46,132,53936,70,NULL,NULL,'CGCG 247-037',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000063,NULL,'15.2g',0.51,NULL,NULL,NULL,NULL,NULL,1,217.577208333,48.0685,0.057,NULL,59245516788,925711199,14464237,15.2),(121357,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121357,38.28,0.46,453,53937,70,NULL,NULL,'SDSS J143018.88+355159.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,217.5787083,35.86656,0,NULL,60068975250,938577738,14665277,18.4),(121358,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121358,37.42,0.23,305,53938,70,NULL,NULL,'2MASX J14301951+2305097',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000189,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,217.58125,23.08614,0.055,NULL,59497983329,929655989,14525874,16.4),(121359,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121359,36.82,0.17,231,53939,70,NULL,NULL,'2MASX J14301972+0007090',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000084,NULL,'16.3g',0.33,'E0',NULL,NULL,NULL,NULL,1,217.582125,0.11914,0.093,NULL,58290830503,910794226,14231159,16.3),(121360,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121360,37.64,0.33,337,53940,70,NULL,NULL,'2MASX J14302004+0607570',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000177,NULL,'16.3g',0.43,NULL,NULL,NULL,NULL,NULL,1,217.583417,6.13239,0.057,NULL,58272554486,910508663,14226697,16.3),(121361,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121361,37.5,0.46,316,53941,70,NULL,NULL,'2MASX J14302008+4115565',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000185,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,217.5837917,41.26564,0,NULL,59946537742,936664652,14635385,16.9),(121362,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121362,37.42,0.23,305,53942,70,NULL,NULL,'2MASX J14302038+2302077',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,217.585083,23.03553,0.055,NULL,59497861799,929654090,14525845,17.6),(121363,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121363,38.85,0.46,590,53943,70,NULL,NULL,'SDSS J143021.84-000950.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000082,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,217.591,-0.16406,0.093,NULL,43513522810,679898793,10623418,18.5),(121364,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121364,37.99,0.33,395,53944,70,NULL,NULL,'SDSS J143021.87+194338.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.591125,19.72731,0.044,NULL,59512060903,929875951,14529311,17.9),(121365,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121365,37.65,0.46,339,53945,70,NULL,NULL,'SDSS J143022.34+583740.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,217.593167,58.62794,0,NULL,57248235251,894503675,13976619,17.7),(121366,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121366,37.77,0.46,359,53946,70,NULL,NULL,'2MASX J14302324+1129060',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00015,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,217.59675,11.48494,0.013,NULL,59358629972,927478593,14491853,17.3),(121367,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121367,38.39,0.46,477,53947,70,NULL,NULL,'SDSS J143023.33+544408.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,217.5972917,54.73581,0,NULL,57253550017,894586719,13977917,18.3),(121368,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121368,38.01,0.11,400,53948,70,NULL,NULL,'2MASX J14302408+2533316',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000143,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,217.6005417,25.55883,0.019,NULL,60020853332,937825833,14653528,18.5),(121369,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121369,37.99,0.33,395,53949,70,NULL,NULL,'2MASX J14302417+1947187',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.51',0.15,NULL,NULL,NULL,NULL,NULL,1,217.600667,19.78844,0.034,NULL,59512049193,929875768,14529308,18.51),(121370,'Sosies','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121370,33.92,0.28,60.8,53950,NULL,NULL,NULL,'NGC 5656',NULL,'2002A&A...393...57T',2002,1,1.66,'Jangren et al. (2005AJ....130.2571J) give v = 8694 km/sec.','G',0.00002,NULL,'12.8g',1.12,'SAab           LINER','Group member',NULL,NULL,NULL,1,217.606291667,35.32103,0,NULL,60039168966,938112015,14658000,12.8),(121371,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121371,32.37,0.69,29.8,53950,100,NULL,'mid-IR','NGC 5656',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121372,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121372,33.46,0.4,49.2,53950,NULL,NULL,'mean','NGC 5656',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121373,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121373,33.63,0.45,53.2,53950,NULL,NULL,'K','NGC 5656',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121374,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121374,33.67,0.47,54.1,53950,NULL,NULL,'H','NGC 5656',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121375,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121375,33.73,0.46,55.8,53950,NULL,NULL,'J','NGC 5656',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121376,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121376,33.88,0.43,59.7,53950,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5656',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121377,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121377,33.97,0.43,62.1,53950,75,NULL,'3.6 micron, color corrected','NGC 5656',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121378,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121378,34.17,0.2,68.2,53950,74.4,NULL,NULL,'NGC 5656',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121379,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121379,35.02,0.23,101,53951,70,NULL,NULL,'NGC 5644',NULL,'2015arXiv151105856S',2015,1,1.24,NULL,'G',0.000073,NULL,'13.5g',1.08,'S0',NULL,NULL,NULL,NULL,1,217.606583,11.928,0,NULL,59358398222,927474972,14491796,13.5),(121380,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121380,37.42,0.23,305,53952,70,NULL,NULL,'2MASX J14302589+2302257',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000178,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,217.6079583,23.04047,0.055,NULL,59497864488,929654132,14525845,17.3),(121381,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121381,34.91,0.46,96,53953,70,NULL,NULL,'2MASX J14302773+4913108',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000159,NULL,'15.6g',0.33,'S0^-',NULL,NULL,NULL,NULL,1,217.615583333,49.21956,0.025,NULL,59201843962,925028811,14453575,15.6),(121382,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121382,36.82,0.17,231,53954,70,NULL,NULL,'SDSS J143028.95+001823.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000065,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,217.620625,0.30644,0.117,NULL,58290847422,910794490,14231163,18.1),(121383,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121383,38,0.46,398,53955,70,NULL,NULL,'2MASX J14303078+2334487',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000139,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,217.628333,23.58025,0.057,NULL,59499980451,929687194,14526362,17.4),(121384,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121384,38.01,0.11,400,53956,70,NULL,NULL,'2MASX J14303131+2521446',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00012,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.6305,25.36239,0.01,NULL,60020991507,937827992,14653562,18.1),(121385,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121385,39,0.46,630,53957,70,NULL,NULL,'SDSS J143031.55+101719.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000136,NULL,'18.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,217.6315,10.28875,0.017,NULL,59359461498,927491585,14492056,18.8),(121386,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121386,38.16,0.46,428,53958,70,NULL,NULL,'2MASX J14303235+3253260',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,217.6347917,32.89056,0,NULL,60037838074,938091219,14657675,17.9),(121387,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121387,33.89,0.2,60,53959,74.4,NULL,NULL,'NGC 5648',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000004,NULL,'14.06',0.8,'S?','Possible field galaxy',NULL,NULL,NULL,1,217.635833,14.02306,0,NULL,59544719810,930386247,14537285,14.06),(121388,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121388,38.07,0.46,412,53960,70,NULL,NULL,'2MASX J14303329+4652151',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,217.6385417,46.87097,0.006,NULL,59227933570,925436462,14459944,17.8),(121389,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121389,38.01,0.11,400,53961,70,NULL,NULL,'2MASX J14303442+2533195',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.0001,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,217.643375,25.55531,0.019,NULL,60020854560,937825852,14653528,17.7),(121390,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121390,38.24,0.46,444,53962,70,NULL,NULL,'2MASX J14303483+1455457',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.645,14.92944,0,NULL,59476448989,929319515,14520617,17.9),(121391,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121391,37.44,0.33,308,53963,70,NULL,NULL,'2MASX J14303483+4215011',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000213,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,217.6452083,42.25025,0.015,NULL,59958938645,936858416,14638412,16.4),(121392,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121392,36.86,0.27,236,53964,70,NULL,NULL,'2MASX J14303597+4936257',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000173,NULL,'15.8g',0.5,'E0',NULL,NULL,NULL,NULL,1,217.649916667,49.60714,0.009,NULL,59201976741,925030886,14453607,15.8),(121393,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121393,38.12,0.46,422,53965,70,NULL,NULL,'2MASX J14303603+0131506',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000076,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,217.6502917,1.53058,0.109,NULL,58289947689,910780432,14230944,17.7),(121394,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121394,36.85,0.46,234,53966,70,NULL,NULL,'2MASX J14303856+2825102',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000162,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,217.660666667,28.41967,0,NULL,60022609859,937853279,14653957,17),(121395,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121395,38.45,0.23,489,53967,70,NULL,NULL,'SDSS J143038.63+602337.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000164,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,217.6609583,60.39367,0,NULL,57755202048,902425032,14100391,18.3),(121396,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121396,30.3,0.69,11.5,53968,100,NULL,'mid-IR','NGC 5645',NULL,'2013ApJ...771...88L',2013,1,2.64,NULL,'G',0.000005,NULL,'12.8g',1.04,'SB(s)d','Group member',NULL,NULL,NULL,1,217.6639583,7.27508,0.021,NULL,58280674303,910635535,14228680,12.8),(121397,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121397,30.85,0.43,14.8,53968,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5645',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121398,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121398,30.88,0.43,15,53968,75,NULL,'3.6 micron, color corrected','NGC 5645',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121399,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121399,30.9,0.2,15.1,53968,74.4,NULL,NULL,'NGC 5645',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121400,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121400,31.14,0.39,16.9,53968,NULL,NULL,NULL,'NGC 5645',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121401,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121401,31.2,0.38,17.4,53968,NULL,NULL,'Malmquist cor.','NGC 5645',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121402,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121402,31.73,NULL,22.2,53968,72,NULL,NULL,'NGC 5645',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121403,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121403,31.82,0.46,23.2,53968,NULL,NULL,'J','NGC 5645',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121404,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121404,31.88,0.45,23.8,53968,NULL,NULL,'K','NGC 5645',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121405,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121405,31.9,0.47,24,53968,NULL,NULL,'H','NGC 5645',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121406,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121406,31.97,0.4,24.8,53968,75,NULL,'B','NGC 5645',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121407,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121407,32.01,0.4,25.3,53968,NULL,NULL,'mean','NGC 5645',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121408,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121408,38.01,0.11,400,53969,70,NULL,NULL,'2MASX J14303952+2538472',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000087,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,217.6647083,25.64653,0.019,NULL,60024321103,937880017,14654375,17.7),(121409,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121409,37.7,0.46,346,53970,70,NULL,NULL,'SDSS J143041.27+141358.0',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.3g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.671958333,14.23278,0,NULL,59544921597,930389399,14537334,17.3),(121410,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121410,35.02,0.23,101,53971,70,NULL,NULL,'2MASX J14304163+1159130',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000077,NULL,'15.8g',0.34,NULL,NULL,NULL,NULL,NULL,1,217.673417,11.98703,0,NULL,59358402975,927475046,14491797,15.8),(121411,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121411,37.27,0.33,285,53972,70,NULL,NULL,'2MASX J14304169+2240108',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.87',0.21,'AGN',NULL,NULL,NULL,NULL,1,217.67375,22.66989,0.061,NULL,59498103914,929657873,14525904,17.87),(121412,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121412,37.43,0.46,306,53973,70,NULL,NULL,'2MASX J14304276+1828278',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,217.678083,18.47433,0,NULL,59481238116,929394345,14521786,17.6),(121413,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121413,37.42,0.23,305,53974,70,NULL,NULL,'2MASX J14304289+2303038',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.6787917,23.05119,0.055,NULL,59497871372,929654240,14525847,18),(121414,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121414,38.23,0.46,443,53975,70,NULL,NULL,'2MASX J14304289+0408196',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000093,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,217.678833333,4.13872,0.049,NULL,58316255903,911191498,14237367,17.8),(121415,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121415,37.44,0.33,308,53976,70,NULL,NULL,'2MASX J14304293+4216131',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000172,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,217.678833333,42.27019,0.015,NULL,59958937945,936858405,14638412,16.8),(121416,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121416,33.88,0.8,59.7,53977,75,NULL,'MAT, I','ESO 511- G 046',NULL,'1997ApJS..109..333W',1997,1,1.8,'Fairall, et al. (1992,AJ,103,11) give v=6989 +/- 80 km/sec.','G',0.000013,NULL,'15',1.4,'SA(r)dm',NULL,NULL,NULL,NULL,1,217.680333,-27.45419,0.289,NULL,47016032014,734625500,11478523,15),(121417,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121417,32.57,0.32,32.7,53977,85,NULL,'I, raw','ESO 511- G 046',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121418,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121418,32.57,0.32,32.7,53977,85,NULL,'I, inv','ESO 511- G 046',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121419,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121419,32.85,0.43,37.2,53977,75,NULL,'MAT, I, raw','ESO 511- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121420,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121420,32.92,0.43,38.4,53977,75,NULL,'MAT, I, inv','ESO 511- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121421,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121421,33.09,0.43,41.4,53977,75,NULL,'MAT, I, cor','ESO 511- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121422,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121422,33.27,0.2,45.1,53977,74.4,NULL,NULL,'ESO 511- G 046',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121423,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121423,33.54,0.59,51,53977,NULL,NULL,NULL,'ESO 511- G 046',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121424,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121424,33.72,0.54,55.5,53977,NULL,NULL,'Malmquist cor.','ESO 511- G 046',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121425,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121425,33.66,0.8,54,53978,75,NULL,'HMCL, I','NGC 5657',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.00003,NULL,'14.05',0.8,'SBb:           Sbrst','Group member, radial-velocity confirmed',NULL,NULL,'Starburst',1,217.681667,29.18083,0,NULL,60047805198,938246956,14660108,14.05),(121426,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121426,33.43,0.4,48.5,53978,75,NULL,'HMCL, I, raw','NGC 5657',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121427,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121427,33.57,0.4,51.8,53978,75,NULL,'HMCL, I, inv','NGC 5657',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121428,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121428,33.7,0.4,54.9,53978,75,NULL,'HMCL, I, cor','NGC 5657',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121429,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121429,33.99,0.4,62.7,53978,NULL,NULL,'mean','NGC 5657',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121430,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121430,34.23,0.47,70.2,53978,NULL,NULL,'H','NGC 5657',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121431,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121431,34.24,0.45,70.4,53978,NULL,NULL,'K','NGC 5657',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121432,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121432,34.3,0.46,72.5,53978,NULL,NULL,'J','NGC 5657',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121433,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121433,37.91,0.46,383,53979,70,NULL,NULL,'SDSS J143045.59+432038.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.6899583,43.34411,0.016,NULL,59959525341,936867583,14638555,17.9),(121434,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121434,38.06,0.46,410,53980,70,NULL,NULL,'2MASX J14304680+3455064',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.7g',0.17,'E/S0',NULL,NULL,NULL,NULL,1,217.695083,34.91844,0,NULL,60038955920,938108686,14657948,17.7),(121435,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121435,37.67,0.46,342,53981,70,NULL,NULL,'2MASX J14304785+2053219',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.86',0.21,NULL,NULL,NULL,NULL,NULL,1,217.6994583,20.88936,0.076,NULL,59510235440,929847428,14528866,17.86),(121436,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121436,38.06,0.46,408,53982,70,NULL,NULL,'SDSS J143048.18+485550.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,217.700833,48.93067,0.041,NULL,59199148727,924986698,14452917,18.4),(121437,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121437,37.7,0.46,346,53983,70,NULL,NULL,'2MASX J14304826+3456064',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00019,NULL,'17.1g',0.23,'E/S0           LINER',NULL,NULL,NULL,NULL,1,217.701167,34.93503,0,NULL,60038958736,938108730,14657948,17.1),(121438,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121438,38.01,0.46,400,53984,70,NULL,NULL,'2MASX J14304833+3503354',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00017,NULL,'18.2g',0.14,'E/S0',NULL,NULL,NULL,NULL,1,217.701333,35.05992,0,NULL,60038967839,938108872,14657951,18.2),(121439,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121439,37.34,0.46,294,53985,70,NULL,NULL,'2MASX J14305007+5515488',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000147,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,217.7084583,55.26361,0,NULL,57258107752,894657933,13979030,17.2),(121440,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121440,36.16,0.2,171,53986,74.4,NULL,NULL,'CGCG 104-039',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000103,NULL,'15.3',0.4,NULL,NULL,NULL,NULL,NULL,1,217.710875,14.50319,0,NULL,59544837287,930388082,14537313,15.3),(121441,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121441,37.21,0.43,276,53986,75,NULL,'3.6 micron, color corrected','CGCG 104-039',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121442,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121442,38.58,0.43,521,53986,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 104-039',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121443,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121443,38.19,0.27,435,53987,70,NULL,NULL,'2MASX J14305086+2438493',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000087,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,217.711917,24.64714,0.053,NULL,59496874336,929638661,14525604,17.3),(121444,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121444,36.35,0.16,186,53988,70,NULL,NULL,'2MASX J14305102+5354278',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000161,NULL,'15.5g',0.5,'AGN+SF',NULL,NULL,NULL,NULL,1,217.7127917,53.90778,0.013,NULL,59196505547,924945399,14452271,15.5),(121445,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121445,37.56,0.46,325,53989,70,NULL,NULL,'2MASX J14305138+2421073',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00015,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,217.714167,24.35225,0.081,NULL,59499680804,929682512,14526289,17.3),(121446,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121446,37.69,0.46,346,53990,70,NULL,NULL,'SDSS J143055.52+120644.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000138,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,217.731375,12.11242,0,NULL,59358424670,927475385,14491802,18.7),(121447,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121447,36.86,0.27,236,53991,70,NULL,NULL,'2MASX J14305554+4934088',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,217.731417,49.56919,0.009,NULL,59202036027,925031812,14453622,17.5),(121448,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121448,37.65,0.33,339,53992,70,NULL,NULL,'SDSS J143055.62+341428.1',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.7g',0.35,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.7317917,34.24117,0,NULL,60041182482,938143476,14658491,16.7),(121449,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121449,38.53,0.46,508,53993,70,NULL,NULL,'SDSS J143056.29+262844.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.734583,26.479,0,NULL,60024571755,937883933,14654436,18.6),(121450,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121450,37.65,0.33,339,53994,70,NULL,NULL,'2MASX J14305649+3416334',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.5g',0.19,'S0',NULL,NULL,NULL,NULL,1,217.7354583,34.27594,0,NULL,60041181828,938143466,14658491,17.5),(121451,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121451,38.45,0.23,489,53995,70,NULL,NULL,'SDSS J143057.82+602044.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.740917,60.34578,0,NULL,57755191970,902424874,14100388,18.3),(121452,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121452,35.32,0.46,116,53996,70,NULL,NULL,'2MASX J14305852+2856563',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000162,NULL,'15.9g',0.4,NULL,NULL,NULL,NULL,NULL,1,217.7437083,28.94889,0,NULL,60047759502,938246242,14660097,15.9),(121453,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121453,36.92,0.27,242,53997,70,NULL,NULL,'2MASX J14305967-0149232',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000179,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,217.74875,-1.82317,0.105,NULL,43514279675,679910619,10623603,17),(121454,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121454,37.38,0.46,299,53998,70,NULL,NULL,'2MASX J14310000+2322258',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000178,NULL,'17.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,217.7499583,23.37381,0.057,NULL,59497964691,929655698,14525870,17.5),(121455,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121455,36.86,0.46,236,53999,70,NULL,NULL,'2MASX J14310016+3544274',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000179,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,217.750875,35.741,0,NULL,60068822398,938575349,14665239,16.7),(121456,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121456,34.18,0.69,68.5,54000,100,NULL,'mid-IR','NGC 5650',NULL,'2013ApJ...771...88L',2013,1,2,'HOLM 656B is a star.','G',0.00002,NULL,'13.26',1.4,'SABbc','in a radial-velocity based grouping',NULL,NULL,NULL,1,217.7545,5.97842,0.041,NULL,58302934794,910983356,14234114,13.26),(121457,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121457,34.84,0.47,92.7,54000,NULL,NULL,'H','NGC 5650',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121458,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121458,34.92,0.46,96.4,54000,NULL,NULL,'J','NGC 5650',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121459,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121459,35.02,0.45,101,54000,NULL,NULL,'K','NGC 5650',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121460,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121460,35.14,0.4,106,54000,NULL,NULL,'mean','NGC 5650',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121461,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121461,35.13,0.2,106,54000,74.4,NULL,NULL,'NGC 5650',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121462,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121462,35.15,0.41,107,54000,NULL,NULL,'Malmquist cor.','NGC 5650',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121463,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121463,35.27,0.38,113,54000,NULL,NULL,NULL,'NGC 5650',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121464,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121464,38.45,0.23,489,54001,70,NULL,NULL,'2MASX J14310131+6017364',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,217.755458333,60.2935,0,NULL,57751735307,902370864,14099544,18.2),(121465,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121465,36.18,0.33,172,54002,70,NULL,NULL,'2MASX J14310209+3607114',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000167,NULL,'16.0g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,217.758666667,36.11981,0,NULL,60068880022,938576250,14665253,16),(121466,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121466,38.01,0.11,400,54003,70,NULL,NULL,'2MASX J14310252+2541263',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000097,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,217.760541667,25.69053,0.021,NULL,60024314462,937879913,14654373,17.7),(121467,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121467,37.99,0.33,397,54004,70,NULL,NULL,'2MASX J14310296+1907408',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,217.7625,19.12797,0.034,NULL,59511255687,929863370,14529115,17.8),(121468,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121468,36.37,0.46,188,54005,70,NULL,NULL,'2MASX J14310297+5532080',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000198,NULL,'15.4g',0.51,'S0^-',NULL,NULL,NULL,NULL,1,217.762583,55.53556,0,NULL,57258198556,894659352,13979052,15.4),(121469,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121469,38.01,0.11,400,54006,70,NULL,NULL,'2MASX J14310510+2536443',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000087,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,217.771125,25.61231,0.019,NULL,60024376249,937880878,14654388,17.1),(121470,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121470,33.92,0.8,60.9,54007,75,NULL,'HMCL, I','NGC 5659',NULL,'1997ApJS..109..333W',1997,1,1.82,NULL,'G',0.00002,NULL,'14.2g',0.52,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,217.775583,25.35511,0.048,NULL,60020780041,937824688,14653510,14.2),(121471,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121471,33.69,0.4,54.8,54007,75,NULL,'HMCL, I, raw','NGC 5659',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121472,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121472,33.71,0.49,55.2,54007,75,NULL,'IR','NGC 5659',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121473,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121473,33.85,0.4,58.9,54007,75,NULL,'HMCL, I, inv','NGC 5659',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121474,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121474,33.93,0.47,61.1,54007,NULL,NULL,'H','NGC 5659',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121475,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121475,33.94,0.2,61.4,54007,74.4,NULL,NULL,'NGC 5659',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121476,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121476,33.99,0.4,62.8,54007,75,NULL,'HMCL, I, cor','NGC 5659',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121477,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121477,34.04,0.46,64.1,54007,NULL,NULL,'J','NGC 5659',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121478,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121478,34.07,0.25,65.1,54007,NULL,NULL,'Malmquist cor.','NGC 5659',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121479,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121479,34.08,0.45,65.6,54007,NULL,NULL,'K','NGC 5659',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121480,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121480,34.15,0.24,67.6,54007,NULL,NULL,NULL,'NGC 5659',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121481,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121481,34.19,0.4,68.9,54007,NULL,NULL,'mean','NGC 5659',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121482,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121482,35.68,0.46,137,54008,70,NULL,NULL,'2MASX J14310622+5110168',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000163,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,217.776083333,51.17144,0,NULL,59203122353,925048786,14453887,16.4),(121483,'BCG','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121483,38.2,0.35,406,54009,60,NULL,'ABELL 1927, BCG','2MASX J14310681+2538013',0.074,'1980ApJ...241..486H',1980,1,0.61,NULL,'G',0.000067,NULL,'16.70',0.29,'BrClG;cD','Brightest group member',NULL,NULL,NULL,1,217.778333,25.63369,0.019,NULL,60024375528,937880867,14654388,16.7),(121484,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121484,37.76,0.46,357,54010,70,NULL,NULL,'SDSS J143106.88+443217.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000155,NULL,'18.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,217.7787917,44.53817,0.011,NULL,59955276692,936801198,14637518,18.6),(121485,'BCG','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121485,38.2,0.35,406,54011,60,NULL,NULL,'ABELL 1927',0.074,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',0.000327,NULL,NULL,NULL,'I-II:  [BM]',NULL,NULL,NULL,NULL,1,217.779583,25.63889,0.019,NULL,60024375359,937880864,14654388,NULL),(121486,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121486,38.07,0.21,412,54012,70,NULL,NULL,'2MASX J14310744+5721030',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,217.781333,57.35089,0,NULL,57251400426,894553131,13977392,17.7),(121487,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121487,38.18,0.46,432,54013,70,NULL,NULL,'SDSS J143108.31+182641.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.784625,18.44475,0,NULL,59481243698,929394432,14521788,17.9),(121488,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121488,38.16,0.27,428,54014,70,NULL,NULL,'2MASX J14310908+2256492',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.18',0.19,NULL,NULL,NULL,NULL,NULL,1,217.7877917,22.94708,0.05,NULL,59498150903,929658607,14525915,18.18),(121489,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121489,38.01,0.11,400,54015,70,NULL,NULL,'2MASX J14310926+2539532',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000077,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,217.788667,25.66472,0.021,NULL,60024382611,937880978,14654390,17.6),(121490,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121490,38.19,0.21,435,54016,70,NULL,NULL,'2MASX J14311011+4229501',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.791917,42.49733,0.015,NULL,59959123143,936861299,14638457,17.9),(121491,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121491,38.19,0.21,435,54017,70,NULL,NULL,'2MASX J14311056+4234247',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000153,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,217.793875,42.57353,0,NULL,59959120081,936861251,14638457,18.3),(121492,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121492,36.11,0.46,167,54018,70,NULL,NULL,'2MASX J14311063+1431091',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.88',0.27,NULL,NULL,NULL,NULL,NULL,1,217.79425,14.51931,0,NULL,59544842549,930388164,14537315,16.88),(121493,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121493,38.01,0.11,400,54019,70,NULL,NULL,'2MASX J14311062+2530342',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000067,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,217.794417,25.50947,0.048,NULL,60024196551,937878071,14654344,17.7),(121494,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121494,38.19,0.21,435,54020,70,NULL,NULL,'SDSS J143110.76+423601.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,217.794875,42.60028,0.047,NULL,59959001123,936859392,14638428,18.3),(121495,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121495,35.3,0.34,115,54021,NULL,NULL,'Malmquist cor.','UGC 09338',NULL,'2009ApJS..182..474S',2009,1,1.16,NULL,'G',0.000033,NULL,'15.1g',0.41,'Sb',NULL,NULL,NULL,NULL,1,217.7987083,5.30733,0.041,NULL,58315386293,911177910,14237154,15.1),(121496,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121496,35.37,0.2,119,54021,74.4,NULL,NULL,'UGC 09338',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121497,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121497,35.41,0.32,121,54021,NULL,NULL,NULL,'UGC 09338',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121498,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121498,35.95,0.46,155,54022,70,NULL,NULL,'MCG +06-32-055',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000178,NULL,'15.3g',0.6,'E/S0',NULL,NULL,NULL,NULL,1,217.803083,35.33197,0,NULL,60069131503,938580179,14665315,15.3),(121499,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121499,37.53,0.46,321,54023,70,NULL,NULL,'2MASX J14311463+3550173',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000178,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,217.811,35.83803,0,NULL,60068924377,938576943,14665264,16.6),(121500,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121500,38.16,0.27,428,54024,70,NULL,NULL,'2MASX J14311523+2258482',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,217.813417,22.97994,0.05,NULL,59498138780,929658418,14525912,17.8),(121501,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121501,38.16,0.27,428,54025,70,NULL,NULL,'2MASX J14311522+2302282',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000158,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.813458333,23.04108,0.055,NULL,59498135677,929658369,14525912,17.5),(121502,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121502,38.2,0.46,436,54026,70,NULL,NULL,'2MASX J14311534+1031016',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.814041667,10.51706,0.021,NULL,59359583984,927493499,14492085,17.6),(121503,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121503,37.99,0.33,397,54027,70,NULL,NULL,'2MASX J14311609+1904112',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.8169583,19.06981,0.019,NULL,59511245803,929863215,14529112,18.1),(121504,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121504,38.07,0.21,412,54028,70,NULL,NULL,'SDSS J143116.11+572041.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,217.8172083,57.34481,0,NULL,57251411851,894553310,13977395,17.9),(121505,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121505,38.45,0.23,489,54029,70,NULL,NULL,'SDSS J143116.60+602354.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000136,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,217.819208333,60.39853,0,NULL,57755257074,902425891,14100404,18.6),(121506,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121506,38.19,0.21,435,54030,70,NULL,NULL,'2MASX J14311697+4241307',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,217.820708333,42.69183,0.047,NULL,59958974378,936858974,14638421,18),(121507,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121507,38.19,0.21,435,54031,70,NULL,NULL,'2MASX J14311699+4235357',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.4g',0.19,'BrClG',NULL,NULL,NULL,NULL,1,217.82075,42.59322,0,NULL,59959001205,936859393,14638428,17.4),(121508,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121508,37.26,0.33,284,54032,70,NULL,NULL,'2MASX J14311741+1742572',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,217.8224583,17.71581,0,NULL,59483430674,929428604,14522321,17.6),(121509,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121509,35.04,0.35,102,54033,NULL,NULL,NULL,'UGC 09339',NULL,'2009ApJS..182..474S',2009,1,0.99,NULL,'G',0.000033,NULL,'14.6g',0.49,'S?',NULL,NULL,NULL,NULL,1,217.824917,7.94464,0.037,NULL,58283755717,910683683,14229432,14.6),(121510,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121510,35.08,0.2,104,54033,74.4,NULL,NULL,'UGC 09339',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121511,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121511,35.09,0.34,104,54033,NULL,NULL,'Malmquist cor.','UGC 09339',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121512,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121512,35.36,0.4,118,54033,NULL,NULL,'mean','UGC 09339',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121513,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121513,35.45,0.47,123,54033,NULL,NULL,'H','UGC 09339',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121514,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121514,35.57,0.45,130,54033,NULL,NULL,'K','UGC 09339',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121515,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121515,36.74,0.46,223,54034,70,NULL,NULL,'2MASX J14311873+1340452',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.21',0.16,NULL,NULL,NULL,NULL,NULL,1,217.828,13.67933,0,NULL,59545971661,930405807,14537590,18.21),(121516,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121516,35.43,0.46,122,54035,70,NULL,NULL,'CGCG 047-074',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.00006,NULL,'14.9g',0.41,'S0/a',NULL,NULL,NULL,NULL,1,217.828291667,3.50717,0.049,NULL,58316517770,911195590,14237431,14.9),(121517,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121517,37.26,0.33,284,54036,70,NULL,NULL,'SDSS J143120.05+174232.9',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.9g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.833583,17.70917,0,NULL,59483430622,929428603,14522321,16.9),(121518,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121518,36.92,0.27,242,54037,70,NULL,NULL,'SDSS J143120.11-014503.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,217.833833,-1.75092,0.105,NULL,43514322033,679911281,10623613,17),(121519,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121519,38.16,0.46,429,54038,70,NULL,NULL,'2MASX J14312078+1835482',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,217.836833,18.59683,0,NULL,59481025073,929391016,14521734,18.1),(121520,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121520,38.19,0.27,435,54039,70,NULL,NULL,'2MASX J14312098+2441523',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,217.8372917,24.69794,0.07,NULL,59499630379,929681724,14526276,17.4),(121521,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121521,35.7,0.46,138,54040,70,NULL,NULL,'SDSS J143121.04+213203.5',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.2g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.8377083,21.53431,0.125,NULL,59523500367,930054693,14532104,16.2),(121522,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121522,38.01,0.11,400,54041,70,NULL,NULL,'SDSS J143121.37+254820.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00014,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.8390417,25.80583,0.021,NULL,60024333307,937880207,14654378,18.6),(121523,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121523,38.01,0.11,400,54042,70,NULL,NULL,'2MASX J14312139+2556483',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000136,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,217.83925,25.94675,0.021,NULL,60024339089,937880298,14654379,17.9),(121524,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121524,38.16,0.46,428,54043,70,NULL,NULL,'SDSS J143121.82+605648.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,217.841,60.94669,0.013,NULL,57752748333,902386692,14099792,17.8),(121525,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121525,37.54,0.46,322,54044,70,NULL,NULL,'2MASX J14312187+2358033',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,217.8410417,23.96772,0.093,NULL,59500165274,929690082,14526407,17.3),(121526,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121526,36.18,0.46,173,54045,70,NULL,NULL,'2MASX J14312186+2812033',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,217.8412083,28.20097,0,NULL,60022842556,937856914,14654014,16.6),(121527,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121527,37.85,0.33,371,54046,70,NULL,NULL,'2MASX J14312201-0139501',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,217.841625,-1.66386,0.101,NULL,43514304856,679911013,10623609,17.5),(121528,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121528,34.71,0.8,87.3,54047,75,NULL,'MAT, I','ESO 447- G 017',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000017,NULL,'14.02',0.6,'SA(s)bc',NULL,NULL,NULL,NULL,1,217.84375,-28.74961,0.321,NULL,47022357623,734724337,11480067,14.02),(121529,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121529,34.32,0.47,73.3,54047,NULL,NULL,'H','ESO 447- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121530,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121530,34.36,0.46,74.5,54047,NULL,NULL,'J','ESO 447- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121531,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121531,34.41,0.45,76.2,54047,NULL,NULL,'K','ESO 447- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121532,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121532,34.43,0.43,76.8,54047,75,NULL,'MAT, I, raw','ESO 447- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121533,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121533,34.47,0.32,78.3,54047,85,NULL,'I, raw','ESO 447- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121534,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121534,34.55,0.32,81.4,54047,85,NULL,'I, inv','ESO 447- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121535,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121535,34.57,0.49,82,54047,NULL,NULL,'Malmquist cor.','ESO 447- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121536,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121536,34.72,0.43,88,54047,75,NULL,'MAT, I, cor','ESO 447- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121537,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121537,34.77,0.43,90.1,54047,75,NULL,'MAT, I, inv','ESO 447- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121538,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121538,34.79,0.4,90.8,54047,NULL,NULL,'mean','ESO 447- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121539,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121539,34.81,0.43,91.7,54047,NULL,NULL,NULL,'ESO 447- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121540,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121540,34.94,0.2,97.3,54047,74.4,NULL,NULL,'ESO 447- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121541,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121541,34.73,0.63,88.3,54048,70,NULL,NULL,'2MASX J14312433-0808456',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'15.95',NULL,NULL,NULL,NULL,NULL,NULL,1,217.8514583,-8.14622,0.129,NULL,43535148426,680236694,10628698,15.95),(121542,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121542,36.94,0.46,244,54049,70,NULL,NULL,'2MASX J14312482+6419226',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000111,NULL,'17.0g',0.21,'NLAGN',NULL,NULL,NULL,NULL,1,217.853667,64.32303,0.049,NULL,57939039049,905297485,14145273,17),(121543,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121543,38.01,0.11,400,54050,70,NULL,NULL,'2MASX J14312509+2551553',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00007,NULL,'16.6g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,217.8547083,25.86547,0.021,NULL,60024334116,937880220,14654378,16.6),(121544,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121544,35.51,0.61,126,54051,NULL,NULL,'Malmquist cor.','ESO 447- G 016',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'16.16',0.4,'S...',NULL,NULL,NULL,NULL,1,217.855583,-32.41622,0.257,NULL,47027299494,734801554,11481274,16.16),(121545,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121545,35.59,0.59,131,54051,NULL,NULL,NULL,'ESO 447- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121546,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121546,35.63,0.2,134,54051,74.4,NULL,NULL,'ESO 447- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121547,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121547,34.26,0.2,71.1,54052,74.4,NULL,NULL,'KUG 1429+334',NULL,'2013AJ....146...86T',2013,1,0.89,NULL,'G',0.000111,NULL,'14.7g',0.42,'Spiral         Sbrst',NULL,NULL,NULL,NULL,1,217.855667,33.23053,0,NULL,60037984339,938093505,14657711,14.7),(121548,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121548,37.56,0.33,324,54053,70,NULL,NULL,'2MASX J14312560+6230356',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,217.856625,62.51003,0.025,NULL,57763475335,902554302,14102410,17),(121549,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121549,36.88,0.46,237,54054,70,NULL,NULL,'2MASXi J1431269+241146',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000134,NULL,'17.5g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.862458333,24.19608,0.074,NULL,59500173227,929690206,14526409,17.5),(121550,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121550,31.77,NULL,22.6,54055,72,NULL,NULL,'IC 1024',NULL,'2014Ap.....57..457K',2014,1,1.6,NULL,'G',0.000017,NULL,'13.87',0.6,'S0?','in a radial-velocity based grouping',NULL,NULL,NULL,1,217.863333,3.00908,0.053,NULL,58307251667,911050807,14235168,13.87),(121551,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121551,36.95,0.46,246,54056,70,NULL,NULL,'2MASX J14312731+0015187',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000095,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,217.8637917,0.25514,0.093,NULL,58291706732,910807917,14231373,16.3),(121552,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121552,35.53,0.46,128,54057,70,NULL,NULL,'CGCG 220-026',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.000063,NULL,'14.7g',0.47,'SB0',NULL,NULL,NULL,NULL,1,217.865625,39.25925,0,NULL,60065347696,938521057,14664391,14.7),(121553,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121553,38.01,0.11,400,54058,70,NULL,NULL,'2MASX J14312894+2534383',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000067,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,217.870666667,25.57719,0.053,NULL,60024388014,937881062,14654391,16.8),(121554,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121554,37.27,0.46,284,54059,70,NULL,NULL,'2MASX J14312909+3714360',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.871167,37.24344,0,NULL,60078002792,938718793,14667481,18),(121555,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121555,36.46,0.46,196,54060,70,NULL,NULL,'2MASX J14312905+1635062',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000057,NULL,'16.64',0.29,NULL,NULL,NULL,NULL,NULL,1,217.8712083,16.58519,0,NULL,59482142525,929408476,14522007,16.64),(121556,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121556,34.91,0.8,95.8,54061,75,NULL,'MAT, I','ESO 579- G 025',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.00001,NULL,'15',1.2,'Sb',NULL,NULL,NULL,NULL,1,217.873791667,-22.36717,0.337,NULL,46533817730,727090902,11360795,15),(121557,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121557,34.38,0.32,75.1,54061,85,NULL,'I, raw','ESO 579- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121558,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121558,34.41,0.32,76.3,54061,85,NULL,'I, inv','ESO 579- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121559,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121559,34.45,0.43,77.5,54061,75,NULL,'MAT, I, raw','ESO 579- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121560,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121560,34.62,0.43,83.8,54061,75,NULL,'MAT, I, inv','ESO 579- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121561,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121561,34.81,0.43,91.5,54061,NULL,NULL,'Malmquist cor.','ESO 579- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121562,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121562,34.85,0.43,93.2,54061,75,NULL,'MAT, I, cor','ESO 579- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121563,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121563,34.89,0.41,95,54061,NULL,NULL,NULL,'ESO 579- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121564,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121564,34.91,0.2,95.9,54061,74.4,NULL,NULL,'ESO 579- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121565,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121565,38.01,0.11,400,54062,70,NULL,NULL,'2MASX J14313019+2533253',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000087,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,217.8757083,25.55714,0.048,NULL,60024379579,937880930,14654389,17.9),(121566,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121566,38.32,0.15,462,54063,70,NULL,NULL,'2MASX J14313023+2001173',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,217.8760417,20.02156,0.047,NULL,59512107420,929876678,14529323,17.5),(121567,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121567,37.27,0.33,285,54064,70,NULL,NULL,'2MASX J14313059+2230543',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'17.16',0.21,NULL,NULL,NULL,NULL,NULL,1,217.877583,22.51519,0.054,NULL,59497434121,929647408,14525740,17.16),(121568,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121568,32.63,0.8,33.5,54065,75,NULL,'A82, H','NGC 5673',NULL,'1997ApJS..109..333W',1997,1,2.57,NULL,'G',0.000023,NULL,'14.0g',0.54,'SBc? sp','in a radial-velocity based grouping',NULL,NULL,NULL,1,217.8787917,49.95872,0,NULL,59202471514,925038617,14453728,14),(121569,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121569,32.21,0.4,27.7,54065,75,NULL,NULL,'NGC 5673',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121570,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121570,32.72,0.2,35,54065,74.4,NULL,NULL,'NGC 5673',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121571,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121571,32.83,0.43,36.8,54065,75,NULL,'3.6 micron, color corrected','NGC 5673',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121572,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121572,32.88,0.38,37.7,54065,NULL,NULL,NULL,'NGC 5673',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121573,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121573,32.92,0.43,38.4,54065,NULL,NULL,NULL,'NGC 5673',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121574,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121574,32.94,0.43,38.7,54065,NULL,NULL,'Malmquist cor.','NGC 5673',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121575,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121575,33,0.43,39.8,54065,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5673',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121576,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121576,33.04,0.49,40.6,54065,75,NULL,'IR','NGC 5673',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121577,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121577,33.08,0.47,41.2,54065,75,NULL,'A82, H, raw','NGC 5673',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121578,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121578,33.08,0.47,41.3,54065,75,NULL,'A82, H, inv','NGC 5673',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121579,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121579,33.21,0.47,43.9,54065,75,NULL,'A82, H, cor','NGC 5673',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121580,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121580,37.56,0.33,324,54066,70,NULL,NULL,'2MASX J14313149+6234227',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,217.881083333,62.57306,0.025,NULL,57763493157,902554580,14102415,17.3),(121581,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121581,37.39,0.46,300,54067,70,NULL,NULL,'2MASX J14313312+1212473',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,217.888,12.21322,0,NULL,59358331348,927473927,14491780,18.2),(121582,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121582,37.48,0.46,313,54068,70,NULL,NULL,'2MASX J14313438+1017159',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000144,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,217.893416667,10.28781,0.017,NULL,59359478616,927491853,14492060,17.3),(121583,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121583,38.47,0.46,494,54069,70,NULL,NULL,'2MASX J14313472+2230171',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000171,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,217.8947917,22.50467,0.054,NULL,59497434306,929647411,14525740,16.8),(121584,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121584,38.37,0.46,471,54070,70,NULL,NULL,'2MASX J14313481+3306185',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.7g',0.2,'E/S0',NULL,NULL,NULL,NULL,1,217.895,33.10511,0,NULL,60037975655,938093369,14657708,17.7),(121585,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121585,36.99,0.46,250,54071,70,NULL,NULL,'2MASX J14313552+1649030',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.48',0.15,NULL,NULL,NULL,NULL,NULL,1,217.8980417,16.81769,0,NULL,59482222181,929409721,14522026,18.48),(121586,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121586,38.41,0.46,480,54072,70,NULL,NULL,'SDSS J143136.63+025056.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000071,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,217.902625,2.84917,0.061,NULL,58308028780,911062949,14235358,18.5),(121587,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121587,38.62,0.46,530,54073,70,NULL,NULL,'SDSS J143137.00+580159.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000134,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,217.90425,58.03308,0.009,NULL,57248718530,894511227,13976737,18.5),(121588,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121588,37.87,0.46,375,54074,70,NULL,NULL,'2MASX J14313818+2615432',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000215,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,217.909125,26.26206,0,NULL,60024670120,937885470,14654460,16.4),(121589,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121589,34.93,0.46,96.9,54075,70,NULL,NULL,'VIII Zw 429',NULL,'2015arXiv151105856S',2015,1,0.38,'VIII Zw -5\' Dec error.','G',0.000161,NULL,'16.2g',0.3,'E0',NULL,NULL,NULL,NULL,1,217.910375,-1.35133,0.101,NULL,43515339549,679927180,10623862,16.2),(121590,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121590,36.15,NULL,170,54076,NULL,NULL,NULL,'FGC 1764',NULL,'2000BSAO...50....5K',2000,1,0.92,NULL,'G',0.000067,NULL,'16.8g',0.13,'Sc',NULL,NULL,NULL,NULL,1,217.910583,52.74944,0.009,NULL,59205060525,925079070,14454360,16.8),(121591,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121591,36.36,NULL,187,54076,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1764',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121592,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121592,36.38,NULL,189,54076,NULL,NULL,'Dipole + Quadrupole','FGC 1764',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121593,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121593,36.42,NULL,192,54076,NULL,NULL,'Dipole','FGC 1764',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121594,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121594,30.64,0.45,13.5,54077,NULL,NULL,'K','IC 4441',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000018,NULL,'12.00',1.4,'(R\')SA:(s)bc',NULL,NULL,NULL,NULL,1,217.910917,-43.41844,0.433,NULL,47091988129,735812314,11497067,12),(121595,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121595,30.66,0.47,13.6,54077,NULL,NULL,'H','IC 4441',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121596,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121596,30.68,0.46,13.7,54077,NULL,NULL,'J','IC 4441',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121597,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121597,31.77,0.4,22.6,54077,NULL,NULL,'mean','IC 4441',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121598,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121598,32.15,0.4,26.9,54077,75,NULL,'B','IC 4441',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121599,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121599,37.74,0.33,354,54078,70,NULL,NULL,'2MASX J14313892+4400187',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000186,NULL,'16.5g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,217.9120417,44.00528,0.026,NULL,59954867966,936794811,14637418,16.5),(121600,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121600,35.27,0.46,113,54079,70,NULL,NULL,'2MASX J14313915-2109189',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'15.18',NULL,NULL,NULL,NULL,NULL,NULL,1,217.9130417,-21.15522,0.329,NULL,46559058094,727485282,11366957,15.18),(121601,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121601,38.09,0.46,415,54080,70,NULL,NULL,'SDSS J143140.54+253923.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000142,NULL,'18.8g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.9189583,25.65661,0.021,NULL,60024383501,937880992,14654390,18.8),(121602,'GRB','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'RN',121602,43.07,1.24,2120,54081,NULL,NULL,NULL,'GRB 080319B HOST',0.937,'2010JCAP...08..020W',2010,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121603,'GRB','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'N',121603,43.07,NULL,4110,54081,NULL,NULL,NULL,'GRB 080319B HOST',NULL,'2011MNRAS.410.1611C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121604,'GRB','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'N',121604,43.09,NULL,4150,54081,NULL,NULL,NULL,'GRB 080319B HOST',NULL,'2011MNRAS.410.1611C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121605,'GRB','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'RN',121605,43.82,0.08,5810,54081,NULL,NULL,NULL,'GRB 080319B HOST',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121606,'GRB','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'RN',121606,45.36,0.17,11800,54081,NULL,NULL,NULL,'GRB 080319B HOST',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121607,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121607,37.85,0.33,371,54082,70,NULL,NULL,'2MASX J14314093-0129526',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,217.9205,-1.49803,0.101,NULL,43515331148,679927049,10623860,16.9),(121608,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121608,35.72,0.46,139,54083,70,NULL,NULL,'2MASX J14314130+2841033',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000157,NULL,'16.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,217.922208333,28.68414,0,NULL,60024689874,937885779,14654465,16.3),(121609,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121609,38.22,0.46,440,54084,70,NULL,NULL,'2MASX J14314312+2626463',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,217.9295417,26.44639,0,NULL,60024676518,937885570,14654462,17.6),(121610,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121610,37.03,0.84,255,54085,70,NULL,NULL,'2MASX J14314339-0114196',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.000116,NULL,'16.3g',0.21,'Sab',NULL,NULL,NULL,NULL,1,217.93075,-1.23881,0.101,NULL,43515327055,679926985,10623859,16.3),(121611,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121611,38.33,0.33,464,54086,70,NULL,NULL,'2MASX J14314352+5635229',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000148,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,217.931333333,56.58981,0,NULL,57259901464,894685960,13979468,17.8),(121612,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121612,37.57,0.46,326,54087,70,NULL,NULL,'2MASX J14314355+3535555',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000194,NULL,'16.6g',0.3,'E/S0',NULL,NULL,NULL,NULL,1,217.931417,35.59889,0,NULL,60069680351,938588755,14665449,16.6),(121613,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121613,36.62,0.46,210,54088,70,NULL,NULL,'2MASX J14314407+1236400',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000176,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,217.9337917,12.61111,0.019,NULL,59542838293,930356848,14536825,16.8),(121614,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121614,33.85,NULL,58.9,54089,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09345',NULL,'2010Ap&SS.325..163P',2010,1,1.43,NULL,'G',0.000053,NULL,'15.5g',0.27,'Scd','Group member',NULL,NULL,NULL,1,217.934041667,6.15814,0.045,NULL,58277764964,910590077,14227969,15.5),(121615,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121615,33.87,NULL,59.3,54089,NULL,NULL,'Dipole + Quadrupole','UGC 09345',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121616,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121616,33.87,NULL,59.4,54089,NULL,NULL,'Dipole','UGC 09345',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121617,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121617,34.1,0.43,66.2,54089,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09345',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121618,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121618,37.84,0.46,369,54090,70,NULL,NULL,'2MASX J14314433+2123022',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.83',0.15,NULL,NULL,NULL,NULL,NULL,1,217.93475,21.38406,0.125,NULL,59510064378,929844755,14528824,18.83),(121619,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121619,37.8,0.46,362,54091,70,NULL,NULL,'SDSS J143144.39+203558.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.935,20.59947,0.07,NULL,59510654568,929853977,14528968,18.5),(121620,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121620,37.33,0.46,292,54092,70,NULL,NULL,'SDSS J143145.05+332931.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000141,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,217.93775,33.492,0.115,NULL,60038056346,938094630,14657728,18.2),(121621,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121621,37.4,0.46,302,54093,70,NULL,NULL,'2MASX J14314517+0917279',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,217.938333,9.29119,0.057,NULL,58269521510,910461273,14225957,17.2),(121622,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121622,37.65,0.46,338,54094,70,NULL,NULL,'2MASX J14314524+1608520',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,217.938417,16.14761,0,NULL,59481712777,929401762,14521902,17.8),(121623,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121623,38.32,0.15,462,54095,70,NULL,NULL,'2MASX J14314564+2000362',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.12',0.19,'BrClG',NULL,NULL,NULL,NULL,1,217.9402083,20.01019,0.047,NULL,59512101384,929876584,14529321,18.12),(121624,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121624,38.13,0.33,422,54096,70,NULL,NULL,'2MASX J14314624+6222567',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.942417,62.38242,0.025,NULL,57763577976,902555905,14102436,17.9),(121625,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121625,34.9,0.46,95.7,54097,70,NULL,NULL,'2MASX J14314788+2822204',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000167,NULL,'15.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,217.9495417,28.37242,0,NULL,60022623623,937853494,14653960,15.4),(121626,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121626,37.34,0.33,294,54098,70,NULL,NULL,'2MASX J14314877+2115132',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.68',0.2,NULL,NULL,NULL,NULL,NULL,1,217.953125,21.25369,0.091,NULL,59509948902,929842951,14528796,17.68),(121627,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121627,38.05,0.27,408,54099,70,NULL,NULL,'LCRS B142913.4-025250',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,217.955125,-3.10111,0.209,NULL,43551110501,680486101,10632595,18),(121628,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121628,37.12,0.46,266,54100,70,NULL,NULL,'2MASX J14314932+0637259',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000084,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,217.955541667,6.62378,0.069,NULL,58277916085,910592438,14228006,18),(121629,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121629,37.34,0.46,293,54101,70,NULL,NULL,'2MASX J14315038+5454520',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000153,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,217.9600417,54.91447,0,NULL,57257653874,894650841,13978919,16.8),(121630,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121630,37.92,0.23,384,54102,70,NULL,NULL,'SDSS J143151.63+260707.6',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.00014,NULL,'18.6g',0.09,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.965125,26.11878,0,NULL,60024653106,937885204,14654456,18.6),(121631,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121631,38.19,0.27,435,54103,70,NULL,NULL,'SDSS J143151.82+243816.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000147,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,217.965958333,24.63781,0.07,NULL,59499850909,929685170,14526330,18.4),(121632,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121632,38.05,0.27,408,54104,70,NULL,NULL,'LCRS B142916.0-025425',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000181,NULL,'16.4g',0.33,'S0^-',NULL,NULL,NULL,NULL,1,217.9660417,-3.12761,0.209,NULL,43551109760,680486090,10632595,16.4),(121633,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121633,38.11,0.46,418,54105,70,NULL,NULL,'2MASX J14315206+0421227',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000066,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,217.967083,4.35628,0.049,NULL,58316811551,911200180,14237502,17.5),(121634,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121634,33.58,0.2,52,54106,74.4,NULL,NULL,'CGCG 075-061',NULL,'2013AJ....146...86T',2013,1,0.93,NULL,'G',0.00013,NULL,'15.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,217.968666667,8.933,0.037,NULL,58280997684,910640588,14228759,15.4),(121635,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121635,36.66,0.46,215,54107,70,NULL,NULL,'2MASX J14315414+4616131',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000159,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,217.975417,46.27028,0,NULL,59953786717,936777917,14637154,16.3),(121636,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121636,36.22,0.46,175,54108,70,NULL,NULL,'CGCG 104-041',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000173,NULL,'15.5',0.32,NULL,NULL,NULL,NULL,NULL,1,217.985833,16.77097,0,NULL,59482225156,929409768,14522027,15.5),(121637,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121637,33.21,0.4,43.9,54109,NULL,NULL,NULL,'NGC 5661',NULL,'2009AJ....138..323T',2009,1,1.46,NULL,'G',0.000007,NULL,'14.2g',0.53,'SBb:','Group member',NULL,NULL,NULL,1,217.989125,6.25042,0.045,NULL,58277808846,910590763,14227980,14.2),(121638,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121638,33.39,0.72,47.7,54109,NULL,NULL,NULL,'NGC 5661',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121639,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121639,33.43,0.2,48.5,54109,74.4,NULL,NULL,'NGC 5661',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121640,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121640,33.67,0.63,54.1,54109,NULL,NULL,'Malmquist cor.','NGC 5661',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121641,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121641,38.05,0.27,408,54110,70,NULL,NULL,'LCRS B142922.0-024923',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000182,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,217.990667,-3.04358,0.205,NULL,43546712257,680417379,10631521,17.3),(121642,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121642,38.77,0.46,568,54111,70,NULL,NULL,'2MASX J14315889+2228042',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,217.995167,22.46786,0.054,NULL,59497504990,929648515,14525758,18),(121643,'Tully est','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121643,33.04,0.8,40.6,54112,75,NULL,NULL,'ESO 175- G 009',NULL,'1988NBGC.C....0000T',1988,1,1.4,NULL,'G',0.000023,NULL,'15.44',1.2,'Dwarf spiral',NULL,NULL,NULL,NULL,1,217.9954583,-55.46664,NULL,NULL,44710017243,698594019,10915531,15.44),(121644,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121644,37.34,0.33,294,54113,70,NULL,NULL,'2MASX J14315915+2116232',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,217.996417,21.27319,0.091,NULL,59509940264,929842816,14528794,NULL),(121645,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121645,38.32,0.15,462,54114,70,NULL,NULL,'2MASX J14320018+1954032',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,218.000875,19.90097,0.047,NULL,59512800745,929887511,14529492,NULL),(121646,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121646,36.64,0.46,213,54115,70,NULL,NULL,'2MASX J14320291+0719546',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00018,NULL,'16.7g',0.31,'AGN',NULL,NULL,NULL,NULL,1,218.012167,7.33175,0.029,NULL,58280151384,910627365,14228552,16.7),(121647,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121647,35.27,0.59,113,54116,70,NULL,NULL,'LCRS B142924.9-060137',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.07',0.4,NULL,NULL,NULL,NULL,NULL,1,218.012833,-6.24747,0.145,NULL,43525391971,680084249,10626316,16.07),(121648,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121648,38.35,0.46,468,54117,70,NULL,NULL,'2MASX J14320347+3516234',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.5g',0.22,'E/S0',NULL,NULL,NULL,NULL,1,218.014625,35.27319,0,NULL,60069174054,938580844,14665325,17.5),(121649,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121649,37.73,0.46,351,54118,70,NULL,NULL,'2MASX J14320353+0400366',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.0001,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,218.01475,4.01003,0.053,NULL,58316625037,911197266,14237457,16.6),(121650,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121650,38.22,0.46,441,54119,70,NULL,NULL,'2MASX J14320432-0018589',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000082,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,218.018,-0.31617,0.073,NULL,43515414522,679928351,10623880,17.6),(121651,'Sosies','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121651,32.26,0.13,28.3,54120,NULL,NULL,NULL,'NGC 5678',NULL,'2002A&A...393...57T',2002,1,1.34,'The 2MASS position is 6 arcsec northwest of the optical nucleus.','G',0.00001,NULL,'12.6g',1.19,'SAB(rs)b       LINER','Parent (of companion) galaxy',NULL,NULL,NULL,1,218.023375,57.92144,0.017,NULL,57251593565,894556149,13977439,12.6),(121652,'Tully est','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121652,32.76,0.8,35.6,54120,75,NULL,'B','NGC 5678',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121653,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121653,31.94,0.47,24.5,54120,NULL,NULL,'H','NGC 5678',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121654,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121654,31.96,0.45,24.6,54120,NULL,NULL,'K','NGC 5678',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121655,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121655,31.96,0.46,24.7,54120,NULL,NULL,'J','NGC 5678',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121656,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121656,32.17,0.4,27.1,54120,NULL,NULL,'mean','NGC 5678',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121657,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121657,32.33,0.4,29.2,54120,NULL,NULL,NULL,'NGC 5678',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121658,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121658,32.51,NULL,31.8,54120,NULL,NULL,'LEDA [April 2006]','NGC 5678',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121659,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121659,32.64,0.43,33.7,54120,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5678',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121660,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121660,32.68,0.43,34.3,54120,75,NULL,'3.6 micron, color corrected','NGC 5678',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121661,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121661,32.73,0.36,35.1,54120,NULL,NULL,'Malmquist cor.','NGC 5678',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121662,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121662,32.76,0.2,35.7,54120,74.4,NULL,NULL,'NGC 5678',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121663,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121663,32.79,0.35,36.1,54120,NULL,NULL,NULL,'NGC 5678',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121664,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121664,37.36,0.46,297,54121,70,NULL,NULL,'2MASX J14320578+1951135',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.25',0.16,'BrClG',NULL,NULL,NULL,NULL,1,218.0240417,19.85372,0.047,NULL,59512916219,929889315,14529520,18.25),(121665,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121665,36.85,0.46,235,54122,70,NULL,NULL,'2MASX J14320592+0651586',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.97',0.26,NULL,NULL,NULL,NULL,NULL,1,218.024625,6.86631,0.065,NULL,58278611309,910603301,14228176,16.97),(121666,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121666,37.57,0.46,327,54123,70,NULL,NULL,'2MASX J14320619+3231274',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000183,NULL,'16.4g',0.31,'S0',NULL,NULL,NULL,NULL,1,218.02575,32.52419,0,NULL,60046068936,938219827,14659684,16.4),(121667,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121667,37.92,0.23,384,54124,70,NULL,NULL,'2MASX J14320693+2604224',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,218.028875,26.07289,0.012,NULL,60024523073,937883173,14654424,17.2),(121668,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121668,36.92,0.33,243,54125,70,NULL,NULL,'2MASX J14320705+1933545',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.74',0.22,NULL,NULL,NULL,NULL,NULL,1,218.029458333,19.56508,0.037,NULL,59512870352,929888599,14529509,17.74),(121669,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121669,36.01,0.46,159,54126,70,NULL,NULL,'2MASX J14320736+3320344',NULL,'2015arXiv151105856S',2015,1,0.43,'Jangren et al. (2005AJ....130.2571J) give z=0.0701 +/- 0.0028.','G',0.000177,NULL,'16.3g',0.34,'S',NULL,NULL,NULL,NULL,1,218.030833,33.343,0.115,NULL,60038061671,938094713,14657729,16.3),(121670,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121670,38.7,0.33,548,54127,70,NULL,NULL,'2MASX J14320762+4707362',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,218.031625,47.12661,0.025,NULL,59227807752,925434496,14459914,17.8),(121671,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121671,38.33,0.33,464,54128,70,NULL,NULL,'2MASX J14320761+5637051',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,218.0317917,56.61822,0,NULL,57259902553,894685977,13979468,17.5),(121672,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121672,37.92,0.23,384,54129,70,NULL,NULL,'2MASX J14320767+2600364',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000133,NULL,'17.75',0.23,NULL,NULL,NULL,NULL,NULL,1,218.031917,26.01025,0.012,NULL,60024242703,937878792,14654356,17.75),(121673,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121673,37.58,0.33,329,54130,70,NULL,NULL,'2MASX J14320800+0457036',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000102,NULL,'17.5g',0.22,'NLAGN',NULL,NULL,NULL,NULL,1,218.033333,4.95086,0.053,NULL,58315285572,911176337,14237130,17.5),(121674,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121674,37.3,0.46,289,54131,70,NULL,NULL,'2MASX J14320834+2714224',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000194,NULL,'16.1g',0.37,NULL,NULL,NULL,NULL,NULL,1,218.0347083,27.23958,0.021,NULL,60023282944,937863796,14654121,16.1),(121675,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121675,37.58,0.33,329,54132,70,NULL,NULL,'SDSS J143208.85+045853.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000076,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,218.036916667,4.98144,0.053,NULL,58315463574,911179118,14237173,18.2),(121676,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121676,37.77,0.46,358,54133,70,NULL,NULL,'2MASX J14320920+4049148',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,'FoF','17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.038333,40.82083,0,NULL,59947008596,936672009,14635500,17.6),(121677,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121677,36.51,0.46,201,54134,70,NULL,NULL,'2MASX J14320976+4609001',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000186,NULL,'16.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,218.040833,46.15014,0,NULL,59953813104,936778329,14637161,16.4),(121678,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121678,37.99,0.46,396,54135,70,NULL,NULL,'2MASX J14321016+2633254',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.042417,26.55706,0,NULL,60024602289,937884410,14654443,18.1),(121679,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121679,36.5,0.46,199,54136,70,NULL,NULL,'2MASX J14321060+0811216',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000178,NULL,'17.38',0.24,NULL,NULL,NULL,NULL,NULL,1,218.04425,8.18939,0.033,NULL,58281677582,910651212,14228925,17.38),(121680,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121680,37.74,0.33,354,54137,70,NULL,NULL,'2MASX J14321112+4351412',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,218.046291667,43.86161,0,NULL,59954846590,936794477,14637413,17.6),(121681,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121681,35.82,0.38,146,54138,NULL,NULL,'Malmquist cor.','ESO 385- G 038',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.33',0.3,'Sb:',NULL,NULL,NULL,NULL,1,218.048375,-36.93081,0.293,NULL,47225706270,737901660,11529713,15.33),(121682,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121682,35.94,0.36,154,54138,NULL,NULL,NULL,'ESO 385- G 038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121683,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121683,35.98,0.2,157,54138,74.4,NULL,NULL,'ESO 385- G 038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121684,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121684,39.18,0.46,686,54139,70,NULL,NULL,'SDSS J143211.62+230249.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,218.048458333,23.047,0.037,NULL,59498278671,929660604,14525946,18.5),(121685,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121685,37.88,0.46,376,54140,70,NULL,NULL,'2MASX J14321177+2657441',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.19',0.19,NULL,NULL,NULL,NULL,NULL,1,218.049041667,26.96228,0,NULL,60023249088,937863267,14654113,18.19),(121686,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121686,38,0.33,398,54141,70,NULL,NULL,'2MASX J14321315+0530576',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'18.33',0.21,'BrClG',NULL,NULL,NULL,NULL,1,218.054875,5.51611,0.049,NULL,58314629974,911166093,14236970,18.33),(121687,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121687,37.41,0.46,304,54142,70,NULL,NULL,'2MASX J14321388+1806346',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.37',0.17,NULL,NULL,NULL,NULL,NULL,1,218.0579583,18.10956,0,NULL,59483329075,929427016,14522297,18.37),(121688,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121688,38.01,0.11,400,54143,70,NULL,NULL,'2MASX J14321419+2548241',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00008,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.059125,25.80681,0.021,NULL,60024368467,937880757,14654386,17.6),(121689,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121689,37.92,0.23,384,54144,70,NULL,NULL,'2MASX J14321432+2603161',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000143,NULL,'17.58',0.22,NULL,NULL,NULL,NULL,NULL,1,218.05975,26.05453,0.012,NULL,60024522081,937883157,14654424,17.58),(121690,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121690,37.17,0.46,271,54145,70,NULL,NULL,'2MASX J14321590+2319196',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,218.066208333,23.32211,0.058,NULL,59498050062,929657032,14525891,17.1),(121691,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121691,38,0.33,398,54146,70,NULL,NULL,'SDSS J143216.68+053036.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000161,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,218.069541667,5.51017,0.049,NULL,58314629729,911166089,14236970,18.3),(121692,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121692,38.21,0.33,438,54147,70,NULL,NULL,'SDSS J143217.47+104716.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,218.072833,10.78786,0.013,NULL,59361570963,927524546,14492571,18),(121693,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121693,36.99,0.46,250,54148,70,NULL,NULL,'2MASX J14321892+2202377',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'18.18',0.16,NULL,NULL,NULL,NULL,NULL,1,218.079041667,22.04381,0.091,NULL,59497262149,929644721,14525698,18.18),(121694,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121694,38.32,0.15,462,54149,70,NULL,NULL,'2MASX J14321932+1946547',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.60',0.15,NULL,NULL,NULL,NULL,NULL,1,218.080417,19.78189,0.033,NULL,59512927178,929889487,14529523,18.6),(121695,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121695,37.19,0.46,275,54150,70,NULL,NULL,'2MASX J14322002+5619341',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,218.083625,56.32622,0,NULL,57260052084,894688313,13979504,17.3),(121696,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121696,37.04,0.46,256,54151,70,NULL,NULL,'2MASX J14322015+4157468',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00018,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,218.084208333,41.963,0.042,NULL,59960746726,936886667,14638854,16.4),(121697,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121697,38.13,0.33,422,54152,70,NULL,NULL,'2MASX J14322029+6225129',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,218.084375,62.42025,0.021,NULL,57760042349,902500661,14101572,16.4),(121698,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121698,38.27,0.46,450,54153,70,NULL,NULL,'2MASX J14322151+0448205',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000088,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.08975,4.80569,0.049,NULL,58315300173,911176565,14237133,18.1),(121699,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121699,37.41,0.46,304,54154,70,NULL,NULL,'2MASX J14322157+2347427',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.089833,23.79528,0.08,NULL,59500252388,929691443,14526428,17.5),(121700,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121700,38.2,0.46,436,54155,70,NULL,NULL,'2MASX J14322214+4120408',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.12',0.2,NULL,NULL,NULL,NULL,NULL,1,218.092167,41.34483,0.017,NULL,59946465991,936663531,14635367,18.12),(121701,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121701,33.56,0.8,51.5,54156,75,NULL,'MAT, I','ESO 447- G 019',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'14.68',0.3,'(R\')SB(s)a:    HII',NULL,NULL,NULL,NULL,1,218.093583333,-28.37892,0.389,NULL,47022555791,734727434,11480116,14.68),(121702,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121702,33.08,0.49,41.2,54156,75,NULL,'IR','ESO 447- G 019',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121703,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121703,33.13,0.43,42.2,54156,75,NULL,'MAT, I, raw','ESO 447- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121704,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121704,33.15,0.32,42.6,54156,85,NULL,'I, raw','ESO 447- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121705,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121705,33.18,0.32,43.3,54156,85,NULL,'I, inv','ESO 447- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121706,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121706,33.2,0.43,43.6,54156,75,NULL,'3.6 micron, color + selection bias corrected','ESO 447- G 019',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121707,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121707,33.2,0.43,43.7,54156,75,NULL,'3.6 micron, color corrected','ESO 447- G 019',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121708,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121708,33.3,0.47,45.7,54156,NULL,NULL,'H','ESO 447- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121709,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121709,33.32,0.43,46,54156,75,NULL,'MAT, I, inv','ESO 447- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121710,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121710,33.38,0.45,47.4,54156,NULL,NULL,'K','ESO 447- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121711,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121711,33.38,0.43,47.4,54156,75,NULL,'MAT, I, cor','ESO 447- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121712,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121712,33.4,0.2,47.9,54156,74.4,NULL,NULL,'ESO 447- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121713,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121713,33.41,0.46,48,54156,NULL,NULL,'J','ESO 447- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121714,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121714,33.67,0.4,54.3,54156,NULL,NULL,'mean','ESO 447- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121715,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121715,33.8,0.41,57.6,54156,NULL,NULL,'Malmquist cor.','ESO 447- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121716,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121716,33.85,0.41,58.8,54156,NULL,NULL,NULL,'ESO 447- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121717,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121717,38.7,0.33,548,54157,70,NULL,NULL,'2MASX J14322280+4706381',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000163,NULL,'17.0g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,218.094916667,47.11064,0.033,NULL,59227811173,925434549,14459914,17),(121718,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121718,37.44,0.46,308,54158,70,NULL,NULL,'2MASX J14322297+0638486',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,218.095708333,6.64692,0.065,NULL,58277941765,910592840,14228013,17.7),(121719,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121719,37.79,0.46,361,54159,70,NULL,NULL,'2MASX J14322306+4658441',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.0960417,46.97903,0.021,NULL,59227981219,925437206,14459956,17.1),(121720,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121720,37.25,0.46,282,54160,70,NULL,NULL,'2MASX J14322308+3010134',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.0962083,30.17036,0,NULL,60048190863,938252982,14660202,17.3),(121721,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121721,36.92,0.33,243,54161,70,NULL,NULL,'2MASX J14322318+1933587',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.38',0.14,NULL,NULL,NULL,NULL,NULL,1,218.096667,19.56625,0.037,NULL,59512879201,929888737,14529511,18.38),(121722,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121722,37.88,0.46,376,54162,70,NULL,NULL,'SDSS J143223.69+073846.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.7g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.09875,7.64631,0.021,NULL,58283524733,910680073,14229376,17.7),(121723,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121723,38.17,0.46,431,54163,70,NULL,NULL,'SDSS J143223.93+343137.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000141,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,218.0997083,34.52719,0,NULL,60038895442,938107741,14657933,18.5),(121724,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121724,38.19,0.46,435,54164,70,NULL,NULL,'SDSS J143224.38+034045.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000074,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.101625,3.67942,0.061,NULL,58315847171,911185112,14237267,17.9),(121725,'Tully est','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121725,32.74,0.8,35.4,54165,75,NULL,'B','NGC 5665',NULL,'1988NBGC.C....0000T',1988,1,2.06,NULL,'G',0.000017,NULL,'12.7g',1.08,'SAB(rs)c pec?  HII','Pair member (points to parent)',NULL,NULL,NULL,1,218.10725,8.07864,0.037,NULL,58281672537,910651133,14228923,12.7),(121726,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121726,30.87,0.43,14.9,54165,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5665',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121727,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121727,31.09,0.43,16.5,54165,75,NULL,'3.6 micron, color corrected','NGC 5665',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121728,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121728,31.3,0.2,18.2,54165,74.4,NULL,NULL,'NGC 5665',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121729,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121729,31.48,0.4,19.8,54165,NULL,NULL,NULL,'NGC 5665',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121730,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121730,32.11,0.47,26.4,54165,NULL,NULL,'H','NGC 5665',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121731,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121731,32.13,0.45,26.6,54165,NULL,NULL,'K','NGC 5665',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121732,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121732,32.13,0.46,26.7,54165,NULL,NULL,'J','NGC 5665',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121733,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121733,32.48,0.4,31.3,54165,NULL,NULL,'mean','NGC 5665',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121734,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121734,38.53,0.46,509,54166,70,NULL,NULL,'2MASX J14322598+0003269',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000102,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.10825,0.05756,0.089,NULL,58288826674,910762916,14230670,17.5),(121735,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121735,37.41,0.33,304,54167,70,NULL,NULL,'2MASX J14322625+2416482',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000144,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,218.1092917,24.28003,0.081,NULL,59499774339,929683974,14526312,17.9),(121736,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121736,32.87,0.8,37.5,54168,75,NULL,'A82, H','IC 1029',NULL,'1997ApJS..109..333W',1997,1,3.34,NULL,'G',0.000023,NULL,'13.3g',0.61,'SAb: sp','in a radial-velocity based grouping',NULL,NULL,NULL,1,218.113583333,49.90461,0,NULL,59202531765,925039558,14453743,13.3),(121737,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121737,32.46,0.4,31.1,54168,75,NULL,NULL,'IC 1029',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121738,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121738,32.87,0.4,37.5,54168,NULL,NULL,'mean','IC 1029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121739,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121739,33,0.47,39.7,54168,75,NULL,'A82, H, raw','IC 1029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121740,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121740,33.04,0.46,40.5,54168,NULL,NULL,'J','IC 1029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121741,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121741,33.05,0.47,40.7,54168,NULL,NULL,'H','IC 1029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121742,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121742,33.14,0.49,42.4,54168,75,NULL,'IR','IC 1029',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121743,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121743,33.14,0.47,42.5,54168,75,NULL,'A82, H, cor','IC 1029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121744,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121744,33.16,0.45,42.8,54168,NULL,NULL,'K','IC 1029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121745,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121745,33.18,0.47,43.3,54168,75,NULL,'A82, H, inv','IC 1029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121746,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121746,33.53,0.43,50.7,54168,75,NULL,'3.6 micron, color corrected','IC 1029',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121747,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121747,33.58,0.2,52,54168,74.4,NULL,NULL,'IC 1029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121748,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121748,33.61,0.43,52.6,54168,75,NULL,'3.6 micron, color + selection bias corrected','IC 1029',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121749,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121749,35.11,0.38,105,54168,NULL,NULL,NULL,'IC 1029',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121750,'Tully est','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121750,32.69,0.8,34.5,54169,75,NULL,NULL,'NGC 5665A',NULL,'1988NBGC.C....0000T',1988,1,NULL,NULL,'PofG',NULL,NULL,NULL,NULL,NULL,'Pair member (points to parent)',NULL,NULL,NULL,1,218.113917,8.07872,0.037,NULL,58281671932,910651123,14228923,NULL),(121751,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121751,31.82,0.4,23.1,54170,75,NULL,NULL,'UGC 09348',NULL,'2008Ap.....51..336K',2008,1,1.8,'NGC 5658 is a star.','G',0.00003,NULL,'16.58',0.3,'S0^0^: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,218.118791667,0.294,0.093,NULL,58288994345,910765536,14230711,16.58),(121752,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121752,31.89,NULL,23.9,54170,72,NULL,NULL,'UGC 09348',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121753,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121753,32.46,0.49,31.1,54170,75,NULL,'IR','UGC 09348',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121754,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121754,34.82,0.8,92.1,54171,75,NULL,'MAT, I','ESO 447- G 021',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.74',0.5,'(R\'_1)SB(r)b   HII',NULL,NULL,NULL,NULL,1,218.1190417,-29.92281,0.373,NULL,47028181781,734815340,11481489,14.74),(121755,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121755,34.57,0.43,81.9,54171,75,NULL,'MAT, I, raw','ESO 447- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121756,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121756,34.61,0.32,83.7,54171,85,NULL,'I, raw','ESO 447- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121757,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121757,34.67,0.32,86,54171,85,NULL,'I, inv','ESO 447- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121758,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121758,34.79,0.41,90.7,54171,NULL,NULL,'Malmquist cor.','ESO 447- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121759,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121759,34.82,0.43,92.1,54171,75,NULL,'MAT, I, cor','ESO 447- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121760,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121760,34.82,0.43,92.2,54171,75,NULL,'MAT, I, inv','ESO 447- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121761,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121761,34.98,0.4,98.9,54171,NULL,NULL,'mean','ESO 447- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121762,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121762,34.99,0.38,99.6,54171,NULL,NULL,NULL,'ESO 447- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121763,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121763,35.03,0.2,101,54171,74.4,NULL,NULL,'ESO 447- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121764,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121764,35.16,0.47,108,54171,NULL,NULL,'H','ESO 447- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121765,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121765,37.77,0.46,358,54172,70,NULL,NULL,'2MASX J14322881+3539277',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000123,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,218.119916667,35.65775,0,NULL,60069712648,938589260,14665457,18.1),(121766,'SNIa','2016-12-15 15:15:26','2016-12-16 11:20:39','1','SCP 06F12',NULL,121766,45.05,0.07,4850,54173,70,NULL,'SALT2, M(B) -19.289 mag, Alpha -0.019, Beta 3.480, Delta -0.151','[EBG2008] ser J143228.7+333210',1.11,'2012ApJ...746...85S',2012,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,218.1197917,33.53611,0.115,NULL,60037599620,938087494,14657617,NULL),(121767,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121767,37.19,0.46,274,54174,70,NULL,NULL,'LCRS B142953.2-023659',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,218.1202083,-2.83631,0.205,NULL,43546751942,680417999,10631531,18),(121768,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121768,37.99,0.46,397,54175,70,NULL,NULL,'2MASX J14323012+3220037',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,218.1254583,32.33444,0,NULL,60046090461,938220163,14659690,17.5),(121769,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121769,33.55,0.46,51.4,54176,70,NULL,NULL,'KUG 1430+264',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.00011,NULL,'14.6g',0.44,'Spiral',NULL,NULL,NULL,NULL,1,218.125625,26.18603,0.017,NULL,60024532232,937883316,14654426,14.6),(121770,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121770,37.58,0.46,328,54177,70,NULL,NULL,'SDSS J143230.96+432412.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,218.129041667,43.40342,0,NULL,59959355424,936864928,14638514,18.3),(121771,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121771,37.38,0.46,299,54178,70,NULL,NULL,'2MASX J14323153+1623468',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.1315,16.39644,0,NULL,59482397926,929412467,14522069,17.7),(121772,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121772,37.38,0.46,299,54179,70,NULL,NULL,'SDSS J143232.21+104011.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00017,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,218.134208333,10.66972,0.013,NULL,59359551895,927492998,14492078,18.1),(121773,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121773,34.48,NULL,78.7,54180,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09351',NULL,'2010Ap&SS.325..163P',2010,1,1.16,NULL,'G',0.00002,NULL,'16.5g',0.18,'Sdm',NULL,NULL,NULL,NULL,1,218.1364583,5.67122,0.041,NULL,58310362745,911099417,14235928,16.5),(121774,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121774,34.48,NULL,78.9,54180,NULL,NULL,'Dipole + Quadrupole','UGC 09351',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121775,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121775,34.49,NULL,79.2,54180,NULL,NULL,'Dipole','UGC 09351',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121776,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121776,37.96,0.46,391,54181,70,NULL,NULL,'2MASX J14323273+0439189',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000092,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,218.136375,4.65539,0.053,NULL,58314786730,911168542,14237008,17.4),(121777,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121777,37.08,0.46,261,54182,70,NULL,NULL,'2MASX J14323283+2741541',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.136708333,27.69828,0.019,NULL,60023495403,937867115,14654173,17.3),(121778,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121778,36.55,0.46,204,54183,70,NULL,NULL,'2MASX J14323285+1953577',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.13675,19.89936,0.047,NULL,59512803711,929887557,14529493,17.2),(121779,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121779,37.85,0.33,372,54184,70,NULL,NULL,'2MASX J14323379+2420261',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,218.140708333,24.34056,0.081,NULL,59499776810,929684012,14526312,17.4),(121780,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121780,37.83,0.46,368,54185,70,NULL,NULL,'2MASXi J1432343+210027',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.1432083,21.00789,0.097,NULL,59510820443,929856569,14529008,17.8),(121781,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121781,37.02,0.46,254,54186,70,NULL,NULL,'2MASX J14323491+5933550',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000183,NULL,'15.9g',0.4,'E0',NULL,NULL,NULL,NULL,1,218.1457083,59.56542,0,NULL,57768343892,902630373,14103599,15.9),(121782,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121782,37.85,0.46,371,54187,70,NULL,NULL,'2MASX J14323573+2305207',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000157,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,218.148875,23.08914,0.037,NULL,59498078627,929657478,14525898,17.2),(121783,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121783,38.32,0.15,462,54188,70,NULL,NULL,'SDSS J143236.44+194724.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.6g',0.09,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.151875,19.79011,0.033,NULL,59512968980,929890140,14529533,18.6),(121784,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121784,36.72,0.46,221,54189,70,NULL,NULL,'2MASX J14323672+2044547',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,218.1529583,20.74856,0.036,NULL,59510869940,929857342,14529020,17.6),(121785,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121785,36.35,0.46,186,54190,70,NULL,NULL,'2MASX J14323755-0131481',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00016,NULL,'17.5g',NULL,NULL,NULL,NULL,NULL,NULL,1,218.1565,-1.53011,0.101,NULL,43514075542,679907430,10623553,17.5),(121786,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121786,37.82,0.46,366,54191,70,NULL,NULL,'SDSS J143237.55+154835.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.1565,15.80992,0,NULL,59481570627,929399541,14521867,17.9),(121787,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121787,33.75,0.4,56.1,54192,NULL,NULL,'mean','NGC 5672',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000017,NULL,'14.08',0.6,'Sb? sp         HII','Pair member, wide',NULL,NULL,NULL,1,218.15975,31.67017,0,NULL,60046457674,938225901,14659779,14.08),(121788,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121788,34.55,0.47,81.3,54192,NULL,NULL,'H','NGC 5672',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121789,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121789,37.26,0.46,283,54193,70,NULL,NULL,'2MASX J14323892+2327334',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.162083,23.45939,0.069,NULL,59497581911,929649717,14525776,17.7),(121790,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121790,38.33,0.46,464,54194,70,NULL,NULL,'2MASX J14323919+4332560',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,218.163291667,43.54875,0,NULL,59959383375,936865365,14638521,18.1),(121791,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121791,37.93,0.33,386,54195,70,NULL,NULL,'2MASX J14324066+5610165',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000149,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.169583,56.17131,0,NULL,57260600365,894696880,13979638,18.1),(121792,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121792,31.14,0.4,16.9,54196,75,NULL,'B','NGC 5643',NULL,'1988NBGC.C....0000T',1988,1,4.6,NULL,'G',0.000007,NULL,'10.74',4,'SAB(rs)c       Sy2',NULL,NULL,NULL,'Sy 2',1,218.16975,-44.17442,0.501,NULL,47083937867,735686529,11495102,10.74),(121793,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121793,36.44,0.46,194,54197,70,NULL,NULL,'2MASX J14324203+5442335',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,218.1752917,54.70922,0.005,NULL,57253326809,894583231,13977862,16.8),(121794,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121794,36.22,0.68,175,54198,70,NULL,NULL,'2MASX J14324228-3837105',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,218.1762083,-38.61956,0.409,NULL,47212441875,737694404,11526475,14.6),(121795,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121795,37.69,0.33,346,54199,70,NULL,NULL,'2MASX J14324231+1430498',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.94',0.18,NULL,NULL,NULL,NULL,NULL,1,218.17625,14.51389,0,NULL,59545396075,930396813,14537450,17.94),(121796,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121796,37.97,0.33,393,54200,70,NULL,NULL,'2MASX J14324234+1913594',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.46',0.14,NULL,NULL,NULL,NULL,NULL,1,218.1765,19.23317,0.027,NULL,59512451476,929882054,14529407,18.46),(121797,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121797,37.79,0.46,361,54201,70,NULL,NULL,'2MASX J14324285+2616451',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,218.178375,26.279,0,NULL,60024510082,937882970,14654421,17.6),(121798,'SNII optical','2016-12-15 15:15:26','2016-12-16 11:20:39','1','SN 2013ab',NULL,121798,31.85,0.07,23.5,54202,NULL,NULL,'EPM + Explosion Epoch','NGC 5669',NULL,'2015MNRAS.450.2373B',2015,1,4,NULL,'G',0.000007,NULL,'12.03',2.8,'SAB(rs)cd','in a pair',NULL,NULL,NULL,1,218.1812083,9.89044,0.021,NULL,59359023834,927484747,14491949,12.03),(121799,'SNII optical','2016-12-15 15:15:26','2016-12-16 11:20:39','1','SN 2013ab',NULL,121799,31.92,0.09,24.3,54202,NULL,NULL,'EPM','NGC 5669',NULL,'2015MNRAS.450.2373B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121800,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121800,30.8,0.43,14.5,54202,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5669',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121801,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121801,30.85,0.43,14.8,54202,75,NULL,'3.6 micron, color corrected','NGC 5669',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121802,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121802,30.97,0.2,15.6,54202,74.4,NULL,NULL,'NGC 5669',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121803,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121803,31.24,0.49,17.7,54202,NULL,NULL,'Malmquist cor.','NGC 5669',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121804,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121804,31.33,0.47,18.5,54202,NULL,NULL,NULL,'NGC 5669',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121805,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121805,31.47,0.37,19.7,54202,NULL,NULL,NULL,'NGC 5669',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121806,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121806,31.47,NULL,19.7,54202,72,NULL,NULL,'NGC 5669',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121807,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121807,31.98,0.4,24.9,54202,75,NULL,'B','NGC 5669',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121808,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121808,32.01,0.4,25.2,54202,NULL,NULL,'mean','NGC 5669',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121809,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121809,32.44,0.47,30.8,54202,NULL,NULL,'H','NGC 5669',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121810,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121810,32.47,0.46,31.2,54202,NULL,NULL,'J','NGC 5669',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121811,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121811,32.51,0.45,31.7,54202,NULL,NULL,'K','NGC 5669',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121812,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121812,38.1,0.46,416,54203,70,NULL,NULL,'SDSS J143244.56+470947.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000143,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,218.1857083,47.16336,0.033,NULL,59227830437,925434850,14459919,18.7),(121813,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121813,37.95,0.46,390,54204,70,NULL,NULL,'2MASX J14324501+5327451',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000141,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,218.18725,53.46264,0,NULL,59205667542,925088555,14454508,18),(121814,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121814,36.27,0.46,180,54205,70,NULL,NULL,'2MASX J14324630-0206170',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000213,NULL,'16.0g',0.39,'E0',NULL,NULL,NULL,NULL,1,218.192958333,-2.10492,0.133,NULL,43547038599,680422478,10631601,16),(121815,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121815,36.39,0.46,189,54206,70,NULL,NULL,'SDSS J143246.36+143517.6',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',NULL,NULL,'15.4g',0.47,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.193167,14.58822,0,NULL,59545400852,930396888,14537451,15.4),(121816,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121816,37.85,0.33,372,54207,70,NULL,NULL,'2MASX J14324674+2423304',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000097,NULL,'17.82',0.23,NULL,NULL,NULL,NULL,NULL,1,218.194667,24.39192,0.081,NULL,59499783676,929684119,14526314,17.82),(121817,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121817,37.94,0.27,387,54208,70,NULL,NULL,'SDSS J143246.87+171802.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.195333,17.30072,0.018,NULL,59483543306,929430364,14522349,18.3),(121818,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121818,32.66,0.8,34,54209,75,NULL,'A82, H','NGC 5676',NULL,'1997ApJS..109..333W',1997,1,4.01,NULL,'G',0.000017,NULL,'12.3g',1.05,'SA(rs)bc       HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,218.1952083,49.45789,0.025,NULL,59201912389,925029881,14453591,12.3),(121819,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121819,32.07,0.47,26,54209,NULL,NULL,'H','NGC 5676',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121820,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121820,32.11,0.45,26.4,54209,NULL,NULL,'K','NGC 5676',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121821,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121821,32.14,0.46,26.8,54209,NULL,NULL,'J','NGC 5676',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121822,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121822,32.18,0.4,27.3,54209,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5676',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121823,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121823,32.54,0.4,32.3,54209,NULL,NULL,'mean','NGC 5676',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121824,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121824,32.6,0.47,33.1,54209,75,NULL,'A82, H, raw','NGC 5676',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121825,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121825,32.61,0.43,33.3,54209,75,NULL,'3.6 micron, color corrected','NGC 5676',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121826,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121826,32.61,0.43,33.3,54209,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5676',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121827,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121827,32.69,0.4,34.5,54209,75,NULL,'B','NGC 5676',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121828,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121828,32.7,0.2,34.7,54209,74.4,NULL,NULL,'NGC 5676',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121829,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121829,32.72,0.36,35,54209,NULL,NULL,NULL,'NGC 5676',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121830,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121830,32.77,0.35,35.9,54209,NULL,NULL,'Malmquist cor.','NGC 5676',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121831,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121831,32.82,0.47,36.7,54209,75,NULL,'A82, H, inv','NGC 5676',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121832,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121832,32.83,0.47,36.8,54209,75,NULL,'A82, H, cor','NGC 5676',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121833,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121833,32.85,0.34,37.1,54209,NULL,NULL,NULL,'NGC 5676',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121834,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121834,38.32,0.15,462,54210,70,NULL,NULL,'2MASX J14324729+1945494',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,218.1970417,19.76375,0.033,NULL,59512977898,929890279,14529535,NULL),(121835,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121835,36.11,NULL,167,54211,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1766',NULL,'2010Ap&SS.325..163P',2010,1,0.85,NULL,'G',0.000167,NULL,'16.7g',0.15,'Sbc',NULL,NULL,NULL,NULL,1,218.198,28.39258,0,NULL,60024929212,937889518,14654523,16.7),(121836,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121836,36.12,NULL,168,54211,NULL,NULL,'Dipole + Quadrupole','FGC 1766',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121837,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121837,36.13,NULL,168,54211,NULL,NULL,'Dipole','FGC 1766',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121838,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121838,38.49,0.46,499,54212,70,NULL,NULL,'2MASX J14324801+0845444',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,218.200083333,8.76242,0.029,NULL,58281083063,910641922,14228780,18.2),(121839,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121839,37.69,0.33,346,54213,70,NULL,NULL,'SDSS J143249.80+142657.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.2075,14.44936,0,NULL,59545444964,930397577,14537462,18.4),(121840,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121840,37.94,0.27,387,54214,70,NULL,NULL,'2MASX J14325077+1721139',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.68',0.13,NULL,NULL,NULL,NULL,NULL,1,218.211708333,17.35389,0,NULL,59483552551,929430508,14522351,18.68),(121841,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121841,38.64,0.46,536,54215,70,NULL,NULL,'2MASXi J1432519+270645',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.216625,27.11286,0,NULL,60023294555,937863977,14654124,18.1),(121842,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121842,37.77,0.46,358,54216,70,NULL,NULL,'2MASX J14325222+2653034',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,218.217458333,26.88431,0,NULL,60023757097,937871204,14654237,17.9),(121843,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121843,38.21,0.33,438,54217,70,NULL,NULL,'2MASX J14325269+1051544',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,218.219667,10.86503,0.005,NULL,59361587092,927524798,14492574,17.2),(121844,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121844,33.79,0.8,57.3,54218,75,NULL,'MAT, I','MCG -02-37-006',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.00001,NULL,'14.90',1,'SB(rs)bc',NULL,NULL,NULL,NULL,1,218.2204583,-12.97558,0.285,NULL,46677717701,729339339,11395927,14.9),(121845,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121845,34.42,0.32,76.7,54218,85,NULL,'I, raw','MCG -02-37-006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121846,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121846,34.46,0.32,77.9,54218,85,NULL,'I, inv','MCG -02-37-006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121847,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121847,35.22,0.43,111,54218,75,NULL,'MAT, I, raw','MCG -02-37-006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121848,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121848,35.47,0.43,124,54218,75,NULL,'MAT, I, inv','MCG -02-37-006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121849,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121849,35.49,0.43,125,54218,75,NULL,'MAT, I, cor','MCG -02-37-006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121850,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121850,36.92,0.46,242,54219,70,NULL,NULL,'2MASX J14325296+4040453',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000148,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,218.220583333,40.67933,0.02,NULL,59946993117,936671767,14635496,16.8),(121851,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121851,38.48,0.46,497,54220,70,NULL,NULL,'2MASX J14325418+1500429',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.225667,15.01181,0,NULL,59544676535,930385570,14537274,17.2),(121852,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121852,37.94,0.27,387,54221,70,NULL,NULL,'2MASX J14325419+1720099',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.22575,17.33597,0.018,NULL,59483553268,929430519,14522351,17.2),(121853,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121853,35.88,0.33,150,54222,70,NULL,NULL,'CGCG 273-011',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000117,NULL,'15.1g',0.57,'E0',NULL,NULL,NULL,NULL,1,218.2335,55.72653,0,NULL,57260442554,894694414,13979600,15.1),(121854,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121854,38.05,0.17,406,54223,70,NULL,NULL,'2MASX J14325605+0952108',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000182,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.233625,9.86956,0.021,NULL,59359008767,927484511,14491945,18),(121855,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121855,37.97,0.33,393,54224,70,NULL,NULL,'SDSS J143256.61+191744.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.235917,19.29567,0.03,NULL,59512400697,929881260,14529394,18),(121856,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121856,38.17,0.33,430,54225,70,NULL,NULL,'2MASX J14325694+0436044',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.0001,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.237333,4.60133,0.053,NULL,58315116179,911173690,14237088,17.3),(121857,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121857,37.41,0.33,304,54226,70,NULL,NULL,'2MASX J14325713+2425084',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000113,NULL,'16.0g',0.35,NULL,NULL,NULL,NULL,NULL,1,218.238125,24.41908,0.081,NULL,59499784545,929684133,14526314,16),(121858,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121858,37.13,0.46,266,54227,70,NULL,NULL,'2MASX J14325748+2303214',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000144,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.2397083,23.05614,0.037,NULL,59498265527,929660398,14525943,17),(121859,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121859,38.04,0.46,406,54228,70,NULL,NULL,'2MASX J14325778+1949164',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,218.240708333,19.82142,0.033,NULL,59512952498,929889882,14529529,17.9),(121860,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121860,38.17,0.33,430,54229,70,NULL,NULL,'2MASX J14325781+0437154',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000111,NULL,'16.9g',0.25,'AGN',NULL,NULL,NULL,NULL,1,218.240917,4.62086,0.053,NULL,58315116495,911173695,14237088,16.9),(121861,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121861,37.96,0.46,392,54230,70,NULL,NULL,'2MASX J14325896+2148014',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.44',0.17,NULL,NULL,NULL,NULL,NULL,1,218.245875,21.80044,0.094,NULL,59502509041,929726703,14526979,18.44),(121862,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121862,37.95,0.46,389,54231,70,NULL,NULL,'2MASX J14330136+2322434',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00014,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.255625,23.37886,0.066,NULL,59497584087,929649751,14525777,17.6),(121863,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121863,38.08,0.46,414,54232,70,NULL,NULL,'2MASX J14330202+1540360',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,218.258417,15.67681,0,NULL,59481532582,929398946,14521858,17.8),(121864,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121864,36.53,0.46,203,54233,70,NULL,NULL,'2MASX J14330323+5809376',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,218.26375,58.16056,0.017,NULL,57248801487,894512523,13976758,16.4),(121865,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121865,37.18,0.46,272,54234,70,NULL,NULL,'2MASX J14330356+0605398',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000166,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,218.26475,6.09461,0.053,NULL,58310423732,911100370,14235943,17.1),(121866,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121866,38.05,0.17,406,54235,70,NULL,NULL,'2MASX J14330391+0936218',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,218.266375,9.60606,0.025,NULL,59359065390,927485396,14491959,18.1),(121867,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121867,37.58,0.46,328,54236,70,NULL,NULL,'2MASX J14330411+4309210',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000157,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,218.267208333,43.15589,0,NULL,59959344221,936864753,14638511,17.1),(121868,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121868,36.31,0.46,183,54237,70,NULL,NULL,'2MASX J14330414+3318465',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000183,NULL,'16.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,218.26725,33.31289,0,NULL,60038106813,938095418,14657740,16.8),(121869,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121869,36.99,0.33,250,54238,70,NULL,NULL,'2MASX J14330452+2336114',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000179,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,218.268917,23.60322,0.069,NULL,59499490290,929679535,14526242,16.9),(121870,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121870,35.79,0.1,144,54239,70,NULL,NULL,'2MASX J14330467+0409134',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000068,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,218.269417,4.15369,0.049,NULL,58317548301,911211692,14237682,16.5),(121871,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121871,38.32,0.15,462,54240,70,NULL,NULL,'2MASX J14330529+1946284',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.272125,19.77456,0.033,NULL,59512957138,929889955,14529530,17.8),(121872,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121872,38.05,0.17,406,54241,70,NULL,NULL,'2MASX J14330593+0940098',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000194,NULL,'15.9g',0.48,'BrClG',NULL,NULL,NULL,NULL,1,218.274583,9.66933,0.025,NULL,59359061778,927485340,14491958,15.9),(121873,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121873,37.24,0.46,280,54242,70,NULL,NULL,'2MASX J14330623+0532224',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,218.275875,5.53958,0.045,NULL,58310338867,911099044,14235922,17.1),(121874,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121874,38.05,0.17,406,54243,70,NULL,NULL,'SDSS J143306.47+094528.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,218.277,9.758,0.021,NULL,59359019949,927484686,14491948,18.3),(121875,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121875,31.53,NULL,20.2,54244,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 326- G 029',NULL,'2010Ap&SS.325..163P',2010,1,1.23,NULL,'G',0.000029,NULL,'16.4',0.16,'Sdm',NULL,NULL,NULL,NULL,1,218.277083,-41.75889,0.389,NULL,47090782933,735793483,11496773,16.4),(121876,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121876,31.56,NULL,20.5,54244,NULL,NULL,'Dipole + Quadrupole','ESO 326- G 029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121877,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121877,31.6,NULL,20.9,54244,NULL,NULL,'Dipole','ESO 326- G 029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121878,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121878,38.05,0.17,406,54245,70,NULL,NULL,'SDSS J143306.76+094021.2',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000157,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,218.278166667,9.67258,0.025,NULL,59359061694,927485338,14491958,17.3),(121879,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121879,38.45,0.46,490,54246,70,NULL,NULL,'2MASX J14330737+1413386',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.1E',NULL,NULL,NULL,NULL,NULL,NULL,1,218.280667,14.22742,0,NULL,59545266671,930394791,14537418,17.1),(121880,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121880,35.87,0.46,149,54247,70,NULL,NULL,'MCG +09-24-015',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000191,NULL,'15.2g',0.55,'E0',NULL,NULL,NULL,NULL,1,218.285667,56.29189,0,NULL,57260021814,894687840,13979497,15.2),(121881,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121881,38.32,0.15,462,54248,70,NULL,NULL,'2MASX J14330884+1946166',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.286916667,19.77117,0.033,NULL,59512957818,929889965,14529530,17.8),(121882,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121882,37.83,0.46,367,54249,70,NULL,NULL,'SDSS J143309.32+104030.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,218.288875,10.67522,0.005,NULL,59359509490,927492335,14492067,18.1),(121883,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121883,38.21,0.46,438,54250,70,NULL,NULL,'2MASX J14330964+5532296',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,218.290166667,55.54161,0,NULL,57258340935,894661577,13979087,17.5),(121884,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121884,35.52,0.4,127,54251,NULL,NULL,'mean','CGCG 047-086',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000183,NULL,'14.9',0.8,'Sc','Group member',NULL,NULL,NULL,1,218.2904583,3.94667,0.065,NULL,58317495687,911210870,14237669,14.9),(121885,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121885,35.78,0.47,143,54251,NULL,NULL,'H','CGCG 047-086',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121886,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121886,38.05,0.17,406,54252,70,NULL,NULL,'2MASX J14330972+0947188',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,218.2905,9.78842,0.021,NULL,59359011487,927484554,14491946,17.6),(121887,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121887,36.76,0.16,225,54253,70,NULL,NULL,'CGCG 273-013',NULL,'2015arXiv151105856S',2015,1,1.25,NULL,'G',0.0001,NULL,'14.4g',0.8,'E0',NULL,NULL,NULL,NULL,1,218.290833,53.23269,0,NULL,59205698981,925089046,14454516,14.4),(121888,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121888,37.85,0.46,372,54254,70,NULL,NULL,'2MASX J14331007+2406014',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000206,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,218.2920417,24.10036,0.104,NULL,59500318448,929692475,14526444,16.5),(121889,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121889,37.68,0.46,344,54255,70,NULL,NULL,'SDSS J143310.85+384728.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000149,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,218.2952083,38.79131,0,NULL,60065285301,938520082,14664376,18.6),(121890,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121890,36.41,0.46,191,54256,70,NULL,NULL,'2MASX J14331123+3622163',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000161,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,218.296958333,36.37108,0,NULL,60077510082,938711095,14667360,16.9),(121891,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121891,37.85,0.46,371,54257,70,NULL,NULL,'SDSS J143311.63+071652.4',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.7g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.2985,7.28122,0.069,NULL,58278323279,910598801,14228106,17.7),(121892,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121892,36.5,0.46,199,54258,70,NULL,NULL,'2MASX J14331281+2748404',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000145,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.303208333,27.81119,0,NULL,60023442245,937866285,14654160,17.6),(121893,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121893,36.76,0.16,225,54259,70,NULL,NULL,'MCG +09-24-014',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000229,NULL,'16.0g',0.37,'E0',NULL,NULL,NULL,NULL,1,218.304,52.96314,0,NULL,59205083305,925079426,14454366,16),(121894,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121894,36.28,0.46,180,54260,70,NULL,NULL,'2MASX J14331302+0841438',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'16.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,218.30425,8.69544,0.029,NULL,58281066040,910641656,14228775,16.8),(121895,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121895,38.22,0.33,441,54261,70,NULL,NULL,'SDSS J143313.73+564407.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,218.30725,56.73556,0,NULL,57258862571,894669727,13979214,18.5),(121896,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121896,37.93,0.33,386,54262,70,NULL,NULL,'2MASX J14331382+5608236',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000155,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.30775,56.13981,0,NULL,57260630068,894697344,13979646,17.4),(121897,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121897,36.76,0.16,225,54263,70,NULL,NULL,'2MASX J14331403+5306120',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000187,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,218.3084583,53.10328,0,NULL,59205532151,925086439,14454475,16.7),(121898,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121898,35.88,0.33,150,54264,70,NULL,NULL,'2MASX J14331423+5531376',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000175,NULL,'15.6g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,218.30925,55.52708,0,NULL,57258343739,894661620,13979087,15.6),(121899,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121899,37.67,0.46,342,54265,70,NULL,NULL,'2MASX J14331438+2003156',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.38',0.14,NULL,NULL,NULL,NULL,NULL,1,218.3100417,20.05444,0.044,NULL,59512820644,929887822,14529497,18.38),(121900,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121900,37.92,0.46,384,54266,70,NULL,NULL,'SDSS J143314.47+250305.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000156,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.310333333,25.0515,0.077,NULL,59498570466,929665163,14526018,18.6),(121901,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121901,34.52,0.2,80.2,54267,74.4,NULL,NULL,'KUG 1430+140',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.00013,NULL,'15.5',0.2,'Sc','Isolated galaxy',NULL,NULL,NULL,1,218.310625,13.84272,0.01,NULL,59545879282,930404363,14537568,15.5),(121902,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121902,35.15,0.49,107,54267,75,NULL,'IR','KUG 1430+140',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121903,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121903,37.53,0.46,321,54268,70,NULL,NULL,'2MASX J14331505-0049289',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000093,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.312833,-0.82461,0.101,NULL,43512403567,679881305,10623145,17),(121904,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121904,37.4,0.46,302,54269,70,NULL,NULL,'2MASX J14331549+2804169',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000135,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,218.314375,28.07122,0,NULL,60024759581,937886868,14654482,17.7),(121905,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121905,33.81,NULL,57.8,54270,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09359',NULL,'2010Ap&SS.325..163P',2010,1,1.11,'There is a star superposed north of the nucleus.','G',0.000015,NULL,'16.5g',0.18,'Scd',NULL,NULL,NULL,NULL,1,218.3159583,-1.14014,0.093,NULL,43512453566,679882086,10623157,16.5),(121906,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121906,33.82,NULL,58.2,54270,NULL,NULL,'Dipole','UGC 09359',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121907,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121907,33.83,NULL,58.2,54270,NULL,NULL,'Dipole + Quadrupole','UGC 09359',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121908,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121908,34.29,0.2,72.1,54270,74.4,NULL,NULL,'UGC 09359',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121909,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121909,36.2,0.46,174,54271,70,NULL,NULL,'CGCG 248-004',NULL,'2015arXiv151105856S',2015,1,0.91,NULL,'G',0.000207,NULL,'15.0g',0.58,'E0',NULL,NULL,NULL,NULL,1,218.316125,45.78108,0,NULL,59953760509,936777507,14637148,15),(121910,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121910,38.13,0.23,422,54272,70,NULL,NULL,'SDSS J143315.87+572950.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000132,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,218.316166667,57.49753,0,NULL,57252131271,894564551,13977571,18.5),(121911,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121911,38.44,0.46,487,54273,70,NULL,NULL,'2MASX J14331606+5936546',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.316916667,59.61522,0,NULL,57768317153,902629955,14103593,17.7),(121912,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121912,37.74,0.46,354,54274,70,NULL,NULL,'SDSS J143316.30+125340.1',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.3g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.317917,12.89447,0,NULL,59546214245,930409597,14537649,17.3),(121913,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121913,39.03,0.46,640,54275,70,NULL,NULL,'SDSS J143316.30+241835.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000155,NULL,'18.8g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.317958333,24.30975,0.081,NULL,59499778858,929684044,14526313,18.8),(121914,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121914,37.46,0.46,311,54276,70,NULL,NULL,'2MASX J14331642+3528146',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000142,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,218.3185417,35.47086,0,NULL,60069725504,938589461,14665460,18.2),(121915,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121915,38.08,0.46,414,54277,70,NULL,NULL,'SDSS J143316.88+111154.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000168,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.320375,11.19856,0.013,NULL,59361962123,927530658,14492666,18.1),(121916,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121916,38.05,0.33,407,54278,70,NULL,NULL,'2MASX J14331755+2336016',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,218.323083333,23.60044,0.084,NULL,59499540656,929680322,14526255,18),(121917,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121917,38.16,0.46,429,54279,70,NULL,NULL,'SDSS J143319.41+484242.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000144,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,218.330875,48.71175,0.069,NULL,59199424619,924991009,14452984,18.5),(121918,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121918,34.06,0.8,65,54280,75,NULL,'HMCL, I','KUG 1431+264',NULL,'1997ApJS..109..333W',1997,1,0.18,NULL,'G',0.00001,NULL,'15.4g',0.17,'Spiral',NULL,NULL,NULL,NULL,1,218.3325417,26.19906,0.017,NULL,60024547810,937883559,14654430,15.4),(121919,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121919,33.78,0.4,57.1,54280,75,NULL,'HMCL, I, raw','KUG 1431+264',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121920,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121920,33.83,0.4,58.4,54280,75,NULL,'HMCL, I, inv','KUG 1431+264',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121921,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121921,34.03,0.4,64,54280,75,NULL,'HMCL, I, cor','KUG 1431+264',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121922,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121922,36.71,0.51,220,54281,70,NULL,NULL,'2MASX J14332008-3344390',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.1I',0.3,NULL,NULL,NULL,NULL,NULL,1,218.3337917,-33.74422,0.253,NULL,46997955189,734343049,11474110,14.1),(121923,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121923,37.92,0.46,384,54282,70,NULL,NULL,'SDSS J143321.63+460613.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,218.340167,46.10364,0,NULL,59954317081,936786204,14637284,17.8),(121924,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121924,36.19,0.53,173,54283,70,NULL,NULL,'2MASX J14332272-1847443',NULL,'2014MNRAS.445.2677S',2014,1,NULL,'6dF DR2 has z = 0.035279.','G',0.00013,NULL,'15.28',NULL,NULL,NULL,NULL,NULL,NULL,1,218.344666667,-18.79569,0.349,NULL,46557043909,727453811,11366465,15.28),(121925,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121925,38.82,0.46,582,54284,70,NULL,NULL,'SDSS J143323.00+605742.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000159,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,218.345875,60.96167,0.009,NULL,57753231937,902394249,14099910,18.3),(121926,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121926,36.33,0.46,185,54285,70,NULL,NULL,'2MASX J14332309+1952236',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.00',0.19,NULL,NULL,NULL,NULL,NULL,1,218.34625,19.87322,0.033,NULL,59512947881,929889810,14529528,18),(121927,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121927,38.05,0.17,406,54286,70,NULL,NULL,'2MASX J14332330+0940350',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000182,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,218.347167,9.67647,0.021,NULL,59359062461,927485350,14491958,17.7),(121928,'SNIa','2016-12-15 15:15:26','2016-12-16 11:20:39','1','SN 1954B','R',121928,32.15,NULL,26.9,54287,NULL,NULL,'Photographic','NGC 5668',NULL,'1988SSRv...48....1R',1988,1,3.3,'2MASS position refers to a superposed star.','G',0.000003,NULL,'13.4g',3,'SA(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,218.351417,4.45044,0.053,NULL,58317203748,911206308,14237598,13.4),(121929,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121929,32.15,0.4,26.9,54287,75,NULL,'B','NGC 5668',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121930,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121930,36.69,0.46,218,54288,70,NULL,NULL,'2MASX J14332453+1924116',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.37',0.17,NULL,NULL,NULL,NULL,NULL,1,218.3524583,19.40308,0.03,NULL,59512288013,929879500,14529367,18.37),(121931,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121931,36.91,0.46,241,54289,70,NULL,NULL,'2MASX J14332506+2304316',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000169,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.3544583,23.0755,0.037,NULL,59498251256,929660175,14525940,17.1),(121932,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121932,36.99,0.33,250,54290,70,NULL,NULL,'2MASX J14332527+2337576',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.0002,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,218.3554583,23.63281,0.084,NULL,59499544020,929680375,14526255,17),(121933,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121933,35.24,0.49,112,54291,75,NULL,'IR','ESO 385- G 042',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'16.51',0.2,'S...',NULL,NULL,NULL,NULL,1,218.35575,-33.75581,0.253,NULL,46997957907,734343092,11474110,16.51),(121934,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121934,35.36,0.6,118,54291,NULL,NULL,'Malmquist cor.','ESO 385- G 042',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121935,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121935,35.49,0.57,125,54291,NULL,NULL,NULL,'ESO 385- G 042',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121936,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121936,35.53,0.2,128,54291,74.4,NULL,NULL,'ESO 385- G 042',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121937,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121937,37.41,0.33,303,54292,70,NULL,NULL,'2MASX J14332579+3626333',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000153,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,218.357667,36.44269,0,NULL,60077520509,938711257,14667363,17.1),(121938,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121938,36.76,0.16,225,54293,70,NULL,NULL,'2MASX J14332584+5250530',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000173,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,218.357917,52.84808,0,NULL,59205040460,925078757,14454355,16.5),(121939,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121939,37.51,0.46,318,54294,70,NULL,NULL,'2MASX J14332706+5718363',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000156,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,218.362917,57.31019,0,NULL,57251320408,894551881,13977373,16.6),(121940,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121940,37.6,0.46,331,54295,70,NULL,NULL,'2MASX J14332716+1858346',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.46',0.15,NULL,NULL,NULL,NULL,NULL,1,218.3632917,18.97647,0.021,NULL,59512219034,929878422,14529350,18.46),(121941,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121941,35.56,0.46,129,54296,70,NULL,NULL,'CGCG 075-070',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000172,NULL,'15.4g',0.54,NULL,NULL,NULL,NULL,NULL,1,218.363416667,9.24536,0.029,NULL,58269383627,910459119,14225923,15.4),(121942,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121942,38.05,0.33,407,54297,70,NULL,NULL,'2MASX J14332772+2325546',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000176,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,218.3655,23.43172,0.066,NULL,59497635579,929650555,14525789,17.2),(121943,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121943,38.9,0.46,602,54298,70,NULL,NULL,'2MASX J14332874+1834536',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,218.369833333,18.58147,0,NULL,59479700075,929370313,14521411,17.7),(121944,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121944,36.61,0.46,210,54299,70,NULL,NULL,'2MASX J14332894+3655003',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000149,NULL,'17.1g',NULL,NULL,NULL,NULL,NULL,NULL,1,218.3705417,36.91678,0,NULL,60078127573,938720743,14667511,17.1),(121945,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121945,37.2,0.46,275,54300,70,NULL,NULL,'2MASX J14332899+0208103',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000097,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.370791667,2.13619,0.057,NULL,58307453536,911053961,14235218,18),(121946,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121946,38.32,0.15,462,54301,70,NULL,NULL,'2MASX J14332953+1947386',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,218.372917,19.79406,0.033,NULL,59512960203,929890003,14529531,18.1),(121947,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121947,37.64,0.33,337,54302,70,NULL,NULL,'2MASX J14332989+0354193',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000072,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.3747083,3.90531,0.065,NULL,58317556969,911211827,14237684,17.7),(121948,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121948,36.81,0.46,230,54303,70,NULL,NULL,'2MASX J14332993+1906126',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.34',0.23,NULL,NULL,NULL,NULL,NULL,1,218.374833333,19.10364,0.021,NULL,59512425234,929881644,14529400,17.34),(121949,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121949,35.84,0.46,147,54304,70,NULL,NULL,'CGCG 296-011',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000192,NULL,'15.1g',0.5,'S0','Isolated galaxy',NULL,NULL,NULL,1,218.381125,57.71178,0.013,NULL,57251636498,894556820,13977450,15.1),(121950,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121950,37.55,0.46,324,54305,70,NULL,NULL,'2MASX J14333188+1631356',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,218.3827917,16.52664,0,NULL,59482530425,929414537,14522102,17.2),(121951,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121951,34.62,0.57,83.8,54306,NULL,NULL,'Malmquist cor.','ESO 385- G 043',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.24',0.9,'Sb',NULL,NULL,NULL,NULL,1,218.3835,-33.80444,0.253,NULL,46997955868,734343060,11474110,15.24),(121952,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121952,34.7,0.55,86.9,54306,NULL,NULL,NULL,'ESO 385- G 043',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121953,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121953,34.74,0.2,88.7,54306,74.4,NULL,NULL,'ESO 385- G 043',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121954,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121954,36.76,0.16,225,54307,70,NULL,NULL,'2MASX J14333472+5243099',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000211,NULL,'15.6g',0.38,'E0',NULL,NULL,NULL,NULL,1,218.394583,52.71953,0,NULL,59206141283,925095957,14454624,15.6),(121955,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121955,37.85,0.46,371,54308,70,NULL,NULL,'LCRS B143059.5-022313',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,218.39575,-2.606,0.205,NULL,43546684330,680416942,10631514,17.2),(121956,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121956,36.69,0.46,218,54309,70,NULL,NULL,'2MASX J14333602+5832293',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000181,NULL,'15.7g',0.48,'E0',NULL,NULL,NULL,NULL,1,218.3999583,58.54142,0,NULL,57248647196,894510112,13976720,15.7),(121957,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121957,36.76,0.16,225,54310,70,NULL,NULL,'2MASX J14333619+5300449',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,218.401,53.01258,0,NULL,59205538434,925086538,14454477,17),(121958,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121958,37.41,0.33,303,54311,70,NULL,NULL,'2MASX J14333648+3623432',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00018,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,218.402166667,36.39553,0,NULL,60077522362,938711286,14667363,16.9),(121959,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121959,35.61,0.46,132,54312,70,NULL,NULL,'2MASX J14333652+2138205',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.68',0.2,NULL,NULL,NULL,NULL,NULL,1,218.4022083,21.63894,0.085,NULL,59502525990,929726968,14526983,17.68),(121960,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121960,35.79,0.1,144,54313,70,NULL,NULL,'2MASX J14333824+0341463',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00008,NULL,'15.8g',0.42,'BLAGN',NULL,NULL,NULL,'Sy 1',1,218.409375,3.69617,0.069,NULL,58317027829,911203559,14237555,15.8),(121961,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121961,38.66,0.21,539,54314,70,NULL,NULL,'2MASX J14333901+6122037',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'17.0g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,218.4127917,61.36761,0.013,NULL,57752851219,902388300,14099817,17),(121962,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121962,37.85,0.46,371,54315,70,NULL,NULL,'2MASX J14333948+2341529',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000019,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,218.414583,23.69792,0.084,NULL,59499523000,929680046,14526250,17.8),(121963,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121963,35.38,0.46,119,54316,70,NULL,NULL,'ARK 452',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000169,NULL,'14.8g',0.74,'E0',NULL,NULL,NULL,NULL,1,218.414833333,35.31203,0,NULL,60069070256,938579222,14665300,14.8),(121964,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121964,38.51,0.46,503,54317,70,NULL,NULL,'SDSS J143339.79+264020.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,218.415833,26.6725,0,NULL,60023887488,937873242,14654269,18.5),(121965,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121965,36.7,0.46,219,54318,70,NULL,NULL,'2MASX J14334023+0615530',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000179,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,218.4177083,6.26458,0.053,NULL,58278686217,910604472,14228194,16.7),(121966,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121966,35.09,0.49,104,54319,75,NULL,'IR','UGC 09478',NULL,'2011yCatp016004901K',2011,1,1.24,NULL,'G',0.000087,NULL,'17.',0.1,'Sd',NULL,NULL,NULL,NULL,1,218.41875,85.29206,0.229,NULL,56971675804,890182434,13909100,17),(121967,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121967,35.59,NULL,131,54319,NULL,NULL,NULL,'UGC 09478',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121968,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121968,35.61,NULL,132,54319,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09478',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121969,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121969,35.61,NULL,132,54319,NULL,NULL,'Dipole + Quadrupole','UGC 09478',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121970,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121970,35.62,NULL,133,54319,NULL,NULL,'Dipole','UGC 09478',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121971,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121971,38.53,0.46,508,54320,70,NULL,NULL,'2MASX J14334064+0825240',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000181,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,218.419417,8.42333,0.013,NULL,58276781399,910574709,14227729,17.2),(121972,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121972,35.2,0.46,110,54321,70,NULL,NULL,'CGCG 163-079',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000083,NULL,'14.7g',0.68,NULL,NULL,NULL,NULL,NULL,1,218.42225,28.05414,0,NULL,60024756810,937886825,14654481,14.7),(121973,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121973,38.26,0.46,450,54322,70,NULL,NULL,'2MASX J14334183+1700428',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,218.424417,17.01186,0,NULL,59481863060,929404110,14521939,18.3),(121974,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121974,36.68,0.46,217,54323,70,NULL,NULL,'2MASX J14334194+1124490',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,218.42475,11.41361,0.033,NULL,59361938552,927530289,14492660,17.5),(121975,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121975,37.64,0.33,337,54324,70,NULL,NULL,'2MASX J14334246+0356473',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00008,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,218.427083,3.94656,0.065,NULL,58317383294,911209113,14237642,17),(121976,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121976,35.46,0.46,124,54325,70,NULL,NULL,'SDSS J143343.45+145527.8',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.1g',0.36,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.4310417,14.92442,0,NULL,59544658552,930385289,14537270,16.1),(121977,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121977,37.98,0.16,395,54326,70,NULL,NULL,'2MASX J14334354+1854259',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,218.4315417,18.90722,0.021,NULL,59509347649,929833557,14528649,NULL),(121978,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121978,38.22,0.33,441,54327,70,NULL,NULL,'2MASX J14334359+5651014',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.431625,56.85047,0,NULL,57258843934,894669436,13979209,17.4),(121979,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121979,32.93,0.47,38.5,54328,NULL,NULL,'H','NGC 5664',NULL,'2007A&A...465...71T',2007,1,0.6,NULL,'G',0.000023,NULL,'14.52',0.25,'Sa             Sy2',NULL,NULL,NULL,'Sy 2',1,218.43175,-14.61969,0.329,NULL,46676227446,729316053,11395563,14.52),(121980,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121980,33.11,0.45,41.9,54328,NULL,NULL,'K','NGC 5664',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121981,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121981,33.16,0.46,42.9,54328,NULL,NULL,'J','NGC 5664',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121982,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121982,33.73,0.4,55.7,54328,NULL,NULL,'mean','NGC 5664',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121983,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121983,37.98,0.16,395,54329,70,NULL,NULL,'SDSS J143344.49+185226.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.435417,18.874,0.021,NULL,59509365163,929833830,14528653,18.3),(121984,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121984,37.24,0.46,280,54330,70,NULL,NULL,'2MASX J14334454+5158297',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.435583,51.97494,0,NULL,59206764544,925105696,14454776,17.9),(121985,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121985,36.6,0.46,209,54331,70,NULL,NULL,'2MASX J14334496+4207044',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000151,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,218.437333,42.11786,0.017,NULL,59960963585,936890056,14638907,17.1),(121986,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121986,33.19,NULL,43.4,54332,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09377',NULL,'2010Ap&SS.325..163P',2010,1,1,NULL,'G',0.00005,NULL,'16.7g',0.15,'Sd',NULL,NULL,NULL,NULL,1,218.439333333,44.08219,0.02,NULL,59954714862,936792419,14637381,16.7),(121987,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121987,33.21,NULL,43.9,54332,NULL,NULL,'Dipole + Quadrupole','UGC 09377',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121988,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121988,33.23,NULL,44.2,54332,NULL,NULL,'Dipole','UGC 09377',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121989,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121989,33.31,NULL,45.8,54332,NULL,NULL,NULL,'UGC 09377',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121990,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121990,37.22,0.46,278,54333,70,NULL,NULL,'2MASX J14334584+2423269',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000156,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,218.441083,24.39092,0.111,NULL,59499753516,929683648,14526307,16.9),(121991,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121991,37.81,0.46,365,54334,70,NULL,NULL,'2MASX J14334704+2248209',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000176,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,218.446083333,22.80569,0.059,NULL,59498229854,929659841,14525935,16.3),(121992,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121992,37.5,0.46,316,54335,70,NULL,NULL,'2MASX J14334727+1821049',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.56',0.15,NULL,NULL,NULL,NULL,NULL,1,218.446875,18.35144,0.01,NULL,59479706011,929370406,14521412,18.56),(121993,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121993,37.98,0.16,395,54336,70,NULL,NULL,'SDSS J143347.44+185034.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.4477083,18.84286,0.015,NULL,59509365299,929833832,14528653,18.4),(121994,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121994,38.19,0.46,435,54337,70,NULL,NULL,'SDSS J143347.55+115231.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.448125,11.87531,0.025,NULL,59361415753,927522121,14492533,18.4),(121995,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121995,37.98,0.16,395,54338,70,NULL,NULL,'2MASX J14334762+1832069',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.37',0.16,NULL,NULL,NULL,NULL,NULL,1,218.4485,18.53528,0,NULL,59479747084,929371048,14521422,18.37),(121996,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121996,37.25,0.46,281,54339,70,NULL,NULL,'2MASX J14334776+5636294',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00017,NULL,'16.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,218.449083,56.60811,0,NULL,57259033172,894672393,13979256,16.4),(121997,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121997,37.47,0.33,312,54340,70,NULL,NULL,'SDSS J143347.91+092047.7',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.449666667,9.34661,0.029,NULL,59358851286,927482051,14491907,17.5),(121998,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121998,37.64,0.46,338,54341,70,NULL,NULL,'2MASX J14334810+0111142',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000076,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,218.450417,1.18722,0.077,NULL,58288551684,910758620,14230603,17.3),(121999,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121999,37.47,0.33,312,54342,70,NULL,NULL,'SDSS J143348.10+091946.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.2g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.450417,9.32972,0.029,NULL,59358851924,927482061,14491907,18.2),(122000,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',122000,37.62,0.27,334,54343,70,NULL,NULL,'2MASX J14334861+0621410',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000175,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.452625,6.36125,0.053,NULL,58278739321,910605301,14228207,17.5),(122001,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',122001,37.62,0.27,334,54344,70,NULL,NULL,'2MASX J14334921+0623240',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000197,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,218.455167,6.39003,0.053,NULL,58278739089,910605298,14228207,17.1),(122002,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',122002,37.73,0.46,352,54345,70,NULL,NULL,'2MASX J14334985+5413454',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000179,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,218.457667,54.22947,0,NULL,59204760660,925074385,14454287,17.3),(122003,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',122003,37.28,0.33,286,54346,70,NULL,NULL,'2MASX J14334989+2440028',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00018,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,218.4580417,24.6675,0.091,NULL,59498662595,929666603,14526040,16.8),(122004,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',122004,37.98,0.16,395,54347,70,NULL,NULL,'2MASX J14335017+1850209',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.68',0.15,NULL,NULL,NULL,NULL,NULL,1,218.4592083,18.83933,0.015,NULL,59509373224,929833956,14528655,18.68),(122005,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',122005,37.28,0.33,286,54348,70,NULL,NULL,'2MASX J14335105+2447498',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000137,NULL,'17.53',0.26,NULL,NULL,NULL,NULL,NULL,1,218.462667,24.79733,0.091,NULL,59498800570,929668758,14526074,17.53),(122006,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',122006,35.79,0.1,144,54349,70,NULL,NULL,'CGCG 047-095',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000057,NULL,'15.2g',0.3,'S0','Group member',NULL,NULL,NULL,1,218.46425,3.6795,0.069,NULL,58317022491,911203476,14237554,15.2),(122007,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',122007,37.38,0.46,299,54350,70,NULL,NULL,'2MASX J14335158+3214500',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000155,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,218.465083,32.24728,0,NULL,60046601067,938228141,14659814,17.5),(122008,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',122008,38,0.27,398,54351,70,NULL,NULL,'2MASX J14335159+2835168',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000184,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,218.465125,28.58789,0,NULL,60024885484,937888835,14654513,16.7),(122009,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',122009,37.98,0.16,395,54352,70,NULL,NULL,'2MASX J14335164+1844449',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.4652083,18.74603,0.015,NULL,59509370260,929833910,14528654,17.7),(122010,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',122010,38.13,0.23,422,54353,70,NULL,NULL,'2MASX J14335199+5729394',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000165,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.466916667,57.49436,0,NULL,57252119914,894564373,13977568,17.5),(122011,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,122011,34.26,0.47,71.2,54354,NULL,NULL,'H','NGC 5674',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.00003,NULL,'13.70',1,'SABc           Sy1.9','in a radial-velocity based grouping',NULL,NULL,'Sy 1.9',1,218.467667,5.45822,0.057,NULL,58311234611,911113040,14236141,13.7),(122012,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,122012,34.34,0.45,73.8,54354,NULL,NULL,'K','NGC 5674',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122013,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,122013,34.42,0.46,76.4,54354,NULL,NULL,'J','NGC 5674',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122014,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,122014,35.1,0.4,105,54354,NULL,NULL,'mean','NGC 5674',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122015,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',122015,37.47,0.46,312,54355,70,NULL,NULL,'2MASX J14335221+2418248',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000185,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,218.467625,24.307,0.111,NULL,59499751252,929683613,14526306,16.4),(122016,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',122016,37.69,0.46,345,54356,70,NULL,NULL,'2MASX J14335234+0752284',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.93',0.15,NULL,NULL,NULL,NULL,NULL,1,218.468083,7.87461,0.021,NULL,58277224261,910581629,14227837,18.93),(122017,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',122017,35.85,0.49,148,54357,75,NULL,'IR','UGC 09375',NULL,'2011yCatp016004901K',2011,1,1.18,NULL,'G',0.000033,NULL,'15.5g',0.24,'Sb',NULL,NULL,NULL,NULL,1,218.4704583,28.40208,0,NULL,60024895297,937888989,14654515,15.5),(122018,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122018,36.05,0.2,162,54357,74.4,NULL,NULL,'UGC 09375',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122019,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122019,31.87,NULL,23.7,54358,72,NULL,NULL,'SDSS J143353.30+012905.6',NULL,'2014Ap.....57..457K',2014,1,1,NULL,'G',0.00001,NULL,'17.4',0.2,'dI',NULL,NULL,NULL,NULL,1,218.471333,1.48803,0.101,NULL,58305598150,911024971,14234765,17.4),(122020,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122020,37.98,0.16,395,54359,70,NULL,NULL,'2MASX J14335347+1845209',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.84',0.18,NULL,NULL,NULL,NULL,NULL,1,218.472917,18.75581,0.015,NULL,59509370762,929833918,14528654,17.84),(122021,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122021,36.99,0.46,250,54360,70,NULL,NULL,'2MASX J14335388+5508234',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.2g',0.23,NULL,'Group non-member, foreground',NULL,NULL,NULL,1,218.474666667,55.13992,0,NULL,57258443011,894663172,13979112,17.2),(122022,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122022,37.25,0.27,282,54361,70,NULL,NULL,'SDSS J143354.01+281234.7',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000169,NULL,'16.3g',0.34,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.475083333,28.20964,0,NULL,60024778016,937887156,14654486,16.3),(122023,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122023,38.01,0.46,400,54362,70,NULL,NULL,'2MASX J14335435+3051309',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.476667,30.85867,0,NULL,60049124216,938267565,14660430,18),(122024,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122024,36.48,0.46,198,54363,70,NULL,NULL,'2MASX J14335491+4946138',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000169,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,218.47875,49.77053,0.033,NULL,59202598508,925040601,14453759,16.2),(122025,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122025,37.03,0.46,254,54364,70,NULL,NULL,'2MASX J14335501+0709514',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000175,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,218.47925,7.16419,0.061,NULL,58278910007,910607968,14228249,16.3),(122026,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122026,35.79,0.1,144,54365,70,NULL,NULL,'2MASX J14335534+0350028',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000078,NULL,'16.0g',0.28,'S0',NULL,NULL,NULL,NULL,1,218.480541667,3.83414,0.065,NULL,58317387810,911209184,14237643,16),(122027,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122027,34.7,0.52,86.9,54366,70,NULL,NULL,'NGC 5663',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00012,NULL,'15.31',1.3,'SA0-:',NULL,NULL,NULL,NULL,1,218.484583,-16.58106,0.321,NULL,46550332598,727348946,11364827,15.31),(122028,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122028,37.62,0.27,334,54367,70,NULL,NULL,'2MASX J14335653+0621585',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00014,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.4855417,6.36625,0.053,NULL,58278733265,910605207,14228206,18),(122029,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122029,37.52,0.46,319,54368,70,NULL,NULL,'2MASX J14335685+2542338',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.486833,25.70947,0.061,NULL,60022252675,937847698,14653870,17.8),(122030,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122030,37.98,0.16,395,54369,70,NULL,NULL,'SDSS J143357.09+183830.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.487917,18.64186,0.015,NULL,59479741241,929370956,14521421,18),(122031,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122031,38,0.27,398,54370,70,NULL,NULL,'SDSS J143357.39+283350.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000124,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,218.4892083,28.56392,0,NULL,60024885872,937888841,14654513,18.3),(122032,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122032,38.66,0.21,539,54371,70,NULL,NULL,'2MASX J14335779+6121456',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000154,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,218.491333333,61.36256,0.013,NULL,57753363437,902396303,14099942,18.3),(122033,'SNIa','2016-12-15 15:15:26','2016-12-16 11:20:40','1','SN 2006bw',NULL,122033,34.89,0.17,92.3,54372,74.2,NULL,'SALT 2','SDSS J143358.05+034750.3',0.030002,'2010ApJ...716..712A',2010,1,0.33,NULL,'G',0.00006,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.491916667,3.79731,0.065,NULL,58316912547,911201758,14237527,17.3),(122034,'SNIa','2016-12-15 15:15:26','2016-12-16 11:20:40','1','SN 2006bw',NULL,122034,35.5,0.16,122,54372,70,NULL,'SALT 2','SDSS J143358.05+034750.3',0.030002,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122035,'SNIa','2016-12-15 15:15:26','2016-12-16 11:20:40','1','SN 2006bw',NULL,122035,35.51,0.07,123,54372,72,NULL,'MLCS17','SDSS J143358.05+034750.3',0.030002,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122036,'SNIa','2016-12-15 15:15:26','2016-12-16 11:20:40','1','SN 2006bw',NULL,122036,35.47,0.09,124,54372,74.4,NULL,NULL,'SDSS J143358.05+034750.3',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122037,'SNIa','2016-12-15 15:15:26','2016-12-16 11:20:40','1','SN 2006bw',NULL,122037,35.66,0.18,132,54372,65,NULL,'MLCS17','SDSS J143358.05+034750.3',0.030002,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122038,'SNIa','2016-12-15 15:15:26','2016-12-16 11:20:40','1','SN 2006bw',NULL,122038,35.68,0.21,133,54372,65,NULL,'MLCS31','SDSS J143358.05+034750.3',0.030002,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122039,'SNIa','2016-12-15 15:15:26','2016-12-16 11:20:40','1','SN 2006bw',NULL,122039,35.78,0.21,139,54372,65,NULL,'SALT2','SDSS J143358.05+034750.3',0.030002,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122040,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122040,36.75,0.46,224,54373,70,NULL,NULL,'2MASX J14335858+2003259',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.09',0.2,NULL,NULL,NULL,NULL,NULL,1,218.494167,20.05719,0.025,NULL,59512542709,929883479,14529429,18.09),(122041,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122041,37.25,0.27,282,54374,70,NULL,NULL,'2MASX J14335868+2810108',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000144,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.494458333,28.16967,0,NULL,60024775495,937887117,14654486,17.3),(122042,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122042,38.26,0.46,449,54375,70,NULL,NULL,'SDSS J143359.34+294837.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.49725,29.81033,0,NULL,60017992567,937781133,14652830,18.6),(122043,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122043,38.25,0.46,446,54376,70,NULL,NULL,'2MASX J14335971+5924304',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000163,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,218.498583,59.40847,0,NULL,57768237093,902628704,14103573,17.1),(122044,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122044,36.44,0.33,194,54377,70,NULL,NULL,'SDSS J143359.84+175432.7',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.4g',0.32,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.499375,17.90911,0,NULL,59483279528,929426242,14522285,16.4),(122045,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122045,37.63,0.46,335,54378,70,NULL,NULL,'2MASX J14340119+1634048',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.45',0.22,NULL,NULL,NULL,NULL,NULL,1,218.505083,16.56794,0,NULL,59482470768,929413605,14522087,17.45),(122046,'Tully est','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122046,32.7,0.8,34.6,54379,75,NULL,'B','NGC 5612',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000137,NULL,'13.04',1,'SAB(s)b',NULL,NULL,NULL,NULL,1,218.5052083,-78.3875,0.453,NULL,44286275092,691973048,10812078,13.04),(122047,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122047,35.79,0.1,144,54380,70,NULL,NULL,'2MASX J14340149+0347508',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00008,NULL,'15.9g',0.33,'S0^-',NULL,NULL,NULL,NULL,1,218.506125,3.79742,0.065,NULL,58316907907,911201686,14237526,15.9),(122048,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122048,34.99,0.68,99.6,54381,70,NULL,NULL,'2MASX J14340257-1720279',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.14',NULL,NULL,NULL,NULL,NULL,NULL,1,218.510625,-17.34108,0.337,NULL,46552150348,727377349,11365271,16.14),(122049,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122049,38.2,0.27,436,54382,70,NULL,NULL,'2MASX J14340363+2947578',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000184,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,218.515083333,29.79947,0,NULL,60017991792,937781121,14652830,17.1),(122050,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122050,35.79,0.1,144,54383,70,NULL,NULL,'CGCG 047-100',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000057,NULL,'15.3g',0.44,'E','Group member',NULL,NULL,NULL,1,218.516541667,3.74764,0.065,NULL,58316911246,911201738,14237527,15.3),(122051,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122051,36.76,0.16,225,54384,70,NULL,NULL,'2MASX J14340431+5239098',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000202,NULL,'16.1g',0.33,'S0',NULL,NULL,NULL,NULL,1,218.5177917,52.65283,0,NULL,59206679044,925104360,14454755,16.1),(122052,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122052,38.13,0.23,422,54385,70,NULL,NULL,'2MASX J14340425+5725134',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.517958333,57.42056,0,NULL,57251268938,894551077,13977360,17.8),(122053,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122053,34.61,0.55,83.5,54386,70,NULL,NULL,'MCG -01-37-008',NULL,'2014MNRAS.445.2677S',2014,1,1,'Diameter includes companions or long extensions.','G',0.0001,NULL,'14.91',0.5,'SBc            HII',NULL,NULL,NULL,NULL,1,218.518791667,-7.67567,0.153,NULL,43527065580,680110399,10626724,14.91),(122054,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122054,34.44,0.47,77.1,54386,NULL,NULL,'H','MCG -01-37-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122055,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122055,34.67,0.45,85.8,54386,NULL,NULL,'K','MCG -01-37-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122056,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122056,34.68,0.46,86.3,54386,NULL,NULL,'J','MCG -01-37-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122057,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122057,35.01,0.4,101,54386,NULL,NULL,'mean','MCG -01-37-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122058,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122058,34.58,NULL,82.6,54387,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 272- G 017',NULL,'2010Ap&SS.325..163P',2010,1,1.34,NULL,'G',0.000029,NULL,'16.23',0.13,'Sc',NULL,NULL,NULL,NULL,1,218.5217917,-43.17708,0.417,NULL,47091914840,735811169,11497049,16.23),(122059,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122059,34.58,NULL,82.6,54387,NULL,NULL,'Dipole + Quadrupole','ESO 272- G 017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122060,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122060,34.59,NULL,82.6,54387,NULL,NULL,'Dipole','ESO 272- G 017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122061,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122061,38.66,0.21,539,54388,70,NULL,NULL,'SDSS J143405.22+611943.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000166,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,218.5217917,61.32867,0.013,NULL,57753365170,902396330,14099942,18.5),(122062,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122062,35.48,0.46,125,54389,70,NULL,NULL,'CGCG 019-063',NULL,'2015arXiv151105856S',2015,1,1.16,NULL,'G',0.000113,NULL,'14.3g',0.77,'E0',NULL,NULL,NULL,NULL,1,218.524375,0.62008,0.089,NULL,58289254674,910769604,14230775,14.3),(122063,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122063,35.59,0.46,132,54390,70,NULL,NULL,'2MASX J14340627+5907044',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000185,NULL,'15.4g',0.43,'S0',NULL,NULL,NULL,NULL,1,218.526167,59.11792,0,NULL,57722164436,901908819,14092325,15.4),(122064,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122064,37.87,0.46,376,54391,70,NULL,NULL,'2MASX J14340691+2536488',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000172,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,218.528833,25.61361,0.061,NULL,60022218490,937847163,14653861,17.9),(122065,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122065,38.18,0.19,432,54392,70,NULL,NULL,'SDSS J143406.96+171157.1',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.5g',0.28,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.5290417,17.19922,0,NULL,59483027005,929422296,14522223,16.5),(122066,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122066,37.25,0.27,282,54393,70,NULL,NULL,'2MASX J14340707+2810348',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000145,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,218.529458333,28.17625,0,NULL,60025639540,937900617,14654697,17.5),(122067,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122067,38.13,0.46,423,54394,70,NULL,NULL,'SDSS J143407.80+312132.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000167,NULL,'18.89',0.12,NULL,NULL,NULL,NULL,NULL,1,218.5325,31.35894,0,NULL,60046402195,938225034,14659766,18.89),(122068,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122068,35.79,0.1,144,54395,70,NULL,NULL,'2MASX J14340823+0354058',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000073,NULL,'15.9g',0.42,'S0',NULL,NULL,NULL,NULL,1,218.534416667,3.90156,0.065,NULL,58317396979,911209327,14237645,15.9),(122069,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122069,37.46,0.46,311,54396,70,NULL,NULL,'2MASX J14340971+5504153',NULL,'2015arXiv151105856S',2015,1,0.27,'1977AJ.....82..187F has z = 0.094198 +- 0.000334, with z flagged uncertain.','G',0.000161,NULL,'17.6g',0.2,NULL,'Group non-member, foreground',NULL,NULL,NULL,1,218.540417,55.07106,0,NULL,57257588813,894649825,13978903,17.6),(122070,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122070,38,0.27,398,54397,70,NULL,NULL,'2MASX J14340989+2832298',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.541208333,28.54178,0,NULL,60024858279,937888410,14654506,18.1),(122071,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122071,37.85,0.46,372,54398,70,NULL,NULL,'2MASX J14340991+2909508',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'18.21',0.17,'Sc',NULL,NULL,NULL,NULL,1,218.541333,29.16406,0.01,NULL,60017441095,937772517,14652695,18.21),(122072,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122072,38.66,0.21,539,54399,70,NULL,NULL,'SDSS J143409.95+613506.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000145,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,218.5415,61.58508,0.021,NULL,57760351658,902505494,14101648,18.5),(122073,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122073,38.17,0.46,430,54400,70,NULL,NULL,'2MASX J14341090+2002199',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.07',0.19,NULL,NULL,NULL,NULL,NULL,1,218.545417,20.03878,0.025,NULL,59512543713,929883495,14529429,18.07),(122074,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122074,34.85,0.69,93.2,54401,100,NULL,'mid-IR','UGC 09374',NULL,'2013ApJ...771...88L',2013,1,1.04,NULL,'G',0.000033,NULL,'15.0g',0.56,'BrClG;S?',NULL,NULL,NULL,NULL,1,218.545667,10.21217,0.033,NULL,59359849276,927497644,14492150,15),(122075,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122075,35.81,0.4,145,54401,NULL,NULL,'mean','UGC 09374',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122076,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122076,36.09,0.47,165,54401,NULL,NULL,'H','UGC 09374',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122077,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122077,36.11,0.45,167,54401,NULL,NULL,'K','UGC 09374',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122078,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122078,38.28,0.46,453,54402,70,NULL,NULL,'2MASX J14341166+1452377',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,218.548667,14.87722,0,NULL,59544620016,930384687,14537260,17.9),(122079,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122079,37.12,0.46,265,54403,70,NULL,NULL,'2MASX J14341172+2711468',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.32',0.16,NULL,NULL,NULL,NULL,NULL,1,218.5487917,27.19622,0.038,NULL,60023329191,937864518,14654133,18.32),(122080,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122080,38.25,0.46,447,54404,70,NULL,NULL,'2MASX J14341235+5303557',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000181,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,218.551541667,53.06558,0,NULL,59205549683,925086713,14454479,17.2),(122081,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122081,38.18,0.19,432,54405,70,NULL,NULL,'2MASX J14341245+1739357',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.5519583,17.65981,0,NULL,59483395437,929428053,14522313,17.6),(122082,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122082,34.14,0.47,67.4,54406,NULL,NULL,'H','NGC 5677',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000033,NULL,'14.69',0.7,'S?             AGN',NULL,NULL,NULL,NULL,1,218.553083,25.46803,0.061,NULL,60022318929,937848733,14653886,14.69),(122083,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122083,34.22,0.46,69.7,54406,NULL,NULL,'J','NGC 5677',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122084,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122084,34.25,0.45,70.8,54406,NULL,NULL,'K','NGC 5677',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122085,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122085,34.31,0.4,72.7,54406,NULL,NULL,'mean','NGC 5677',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122086,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122086,37.66,0.46,341,54407,70,NULL,NULL,'2MASX J14341270+0858375',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000187,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.5529583,8.97708,0.029,NULL,58276717283,910573707,14227714,17.5),(122087,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122087,37.52,0.46,320,54408,70,NULL,NULL,'2MASX J14341386+1243047',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.557833333,12.71797,0,NULL,59546241537,930410024,14537656,17.4),(122088,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122088,38.06,0.27,410,54409,70,NULL,NULL,'2MASXi J1434147+261731',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.7g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.5615,26.29208,0.023,NULL,60023827436,937872303,14654254,17.7),(122089,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122089,38.13,0.23,422,54410,70,NULL,NULL,'2MASX J14341565+5728163',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000142,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,218.565417,57.47131,0,NULL,57252118621,894564353,13977568,18),(122090,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122090,37.07,0.46,260,54411,70,NULL,NULL,'2MASX J14341572+1255247',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.6g',0.12,'2MASS Extended Ver.2',NULL,NULL,NULL,NULL,1,218.565541667,12.92367,0,NULL,59546126610,930408228,14537628,17.6),(122091,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122091,37.83,0.46,367,54412,70,NULL,NULL,'2MASX J14341602+4212487',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000141,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.566708333,42.21361,0.017,NULL,59960927178,936889487,14638898,18.4),(122092,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122092,36.91,0.46,241,54413,70,NULL,NULL,'SDSS J143416.32+504835.8',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.5680417,50.80997,0,NULL,59201568313,925024504,14453507,17.1),(122093,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122093,35.56,0.46,129,54414,70,NULL,NULL,'2MASX J14341647+4012572',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000175,NULL,'15.8g',0.34,'S0',NULL,NULL,NULL,NULL,1,218.5685,40.21586,0.029,NULL,59946256752,936660261,14635316,15.8),(122094,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122094,34.61,0.57,83.5,54415,70,NULL,NULL,'LCRS B143138.2-063929',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.00009,NULL,'15.55',0.5,NULL,NULL,NULL,NULL,NULL,1,218.57,-6.87711,0.181,NULL,43526137678,680095901,10626498,15.55),(122095,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122095,38.17,0.27,431,54416,70,NULL,NULL,'2MASX J14341859+1343286',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,218.577583,13.72478,0,NULL,59545611506,930400179,14537502,18.2),(122096,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122096,37.73,0.46,352,54417,70,NULL,NULL,'2MASX J14341969+1718546',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.582125,17.31506,0.018,NULL,59483008472,929422007,14522218,17.9),(122097,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122097,38.2,0.27,436,54418,70,NULL,NULL,'2MASX J14342051+3005030',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000183,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,218.585541667,30.08431,0,NULL,60017977059,937780891,14652826,16.9),(122098,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122098,38.17,0.27,431,54419,70,NULL,NULL,'SDSS J143420.62+134512.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.585917,13.75333,0.01,NULL,59545612723,930400198,14537503,18.5),(122099,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122099,38.2,0.27,436,54420,70,NULL,NULL,'2MASX J14342074+2956010',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000169,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,218.5865417,29.93353,0,NULL,60017986456,937781038,14652828,17.7),(122100,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122100,36.35,0.46,186,54421,70,NULL,NULL,'2MASX J14342163+2318199',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000187,NULL,'16.0g',0.35,NULL,NULL,NULL,NULL,NULL,1,218.5902917,23.3055,0.066,NULL,59497746714,929652292,14525817,16),(122101,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122101,37.54,0.46,322,54422,70,NULL,NULL,'2MASXi J1434221+292011',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000167,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.5925,29.33658,0.01,NULL,60018328553,937786383,14652912,17.8),(122102,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122102,35.62,0.46,133,54423,70,NULL,NULL,'IC 1031',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000195,NULL,'15.0g',0.57,NULL,'Group member',NULL,NULL,NULL,1,218.599917,48.03744,0.033,NULL,59198658185,924979034,14452797,15),(122103,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122103,35.79,0.1,144,54424,70,NULL,NULL,'CGCG 047-102',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.000083,NULL,'15.1g',0.58,'E0',NULL,NULL,NULL,NULL,1,218.603291667,2.79894,0.057,NULL,58308224587,911066009,14235406,15.1),(122104,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122104,38.17,0.27,431,54425,70,NULL,NULL,'2MASX J14342519+1347596',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.27',0.16,NULL,NULL,NULL,NULL,NULL,1,218.604917,13.79983,0.01,NULL,59545605466,930400085,14537501,18.27),(122105,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122105,37.91,0.46,382,54426,70,NULL,NULL,'2MASX J14342516+1410236',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.605,14.17331,0,NULL,59545140449,930392819,14537387,17.7),(122106,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122106,38.06,0.27,409,54427,70,NULL,NULL,'SDSS J143425.38+090750.7',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000158,NULL,'18.7g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.6057917,9.13078,0.029,NULL,59364095724,927563995,14493187,18.7),(122107,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122107,37.5,0.33,316,54428,70,NULL,NULL,'2MASX J14342739+1349056',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.34',0.15,NULL,NULL,NULL,NULL,NULL,1,218.614125,13.81839,0,NULL,59545608046,930400125,14537501,18.34),(122108,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122108,37.2,0.33,276,54429,70,NULL,NULL,'2MASX J14342818+1438296',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.48',0.15,NULL,NULL,NULL,NULL,NULL,1,218.617541667,14.64156,0,NULL,59545349404,930396084,14537438,18.48),(122109,'D-Sigma','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122109,31.7,0.4,21.9,54430,75,NULL,'Edat, raw','IC 4453',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.00004,NULL,'13.17',1,'SAB(rs)0^0^: sp',NULL,NULL,NULL,NULL,1,218.619375,-27.51856,0.389,NULL,47015414386,734615849,11478372,13.17),(122110,'D-Sigma','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122110,32.04,0.4,25.6,54430,75,NULL,'Edat, cor','IC 4453',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122111,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122111,32.61,0.45,33.3,54430,NULL,NULL,'K','IC 4453',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122112,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122112,33.51,0.4,50.4,54430,NULL,NULL,'mean','IC 4453',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122113,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SCP 06H03',NULL,122113,43.59,0.04,2830,54431,70,NULL,'SALT2, M(B) -19.307 mag, Alpha 0.124, Beta 1.460, Delta 0.023','FLX J143429.18+342739.0',0.85,'2012ApJ...746...85S',2012,1,NULL,NULL,'G',0.0005,NULL,'16.9V',NULL,NULL,NULL,NULL,NULL,NULL,1,218.621708333,34.46086,0,NULL,60070042933,938594420,14665537,16.9),(122114,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SCP 06H05',NULL,122114,45.1,0.11,4690,54432,70,NULL,'SALT2, M(B) -19.289 mag, Alpha -0.019, Beta 3.480, Delta -0.151','FLX J143430.10+342657.0',1.231,'2012ApJ...746...85S',2012,1,NULL,NULL,'G',0.01,NULL,'15.9V',NULL,'Ia',NULL,NULL,NULL,NULL,1,218.625625,34.44922,0,NULL,60067163661,938549432,14664834,15.9),(122115,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122115,37.13,0.46,266,54433,70,NULL,NULL,'2MASX J14343020+1052340',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000159,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,218.626,10.876,0.005,NULL,59361124326,927517567,14492461,16.7),(122116,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122116,37.58,0.46,329,54434,70,NULL,NULL,'2MASX J14343154+0907300',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000186,NULL,'18.00',0.18,NULL,NULL,NULL,NULL,NULL,1,218.6315,9.12506,0.029,NULL,59364092949,927563952,14493186,18),(122117,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122117,34.46,0.49,78.1,54435,75,NULL,'IR','CGCG 104-044',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.00004,NULL,'15.28',0.5,'S?',NULL,NULL,NULL,NULL,1,218.631833,19.74206,0.018,NULL,59512623418,929884740,14529449,15.28),(122118,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122118,38.18,0.19,432,54436,70,NULL,NULL,'2MASX J14343376+1712298',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,218.640833333,17.20825,0,NULL,59482985981,929421655,14522213,18.2),(122119,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122119,36.15,0.46,170,54437,70,NULL,NULL,'2MASX J14343440+2924424',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000183,NULL,'15.03',0.32,'Sa',NULL,NULL,NULL,NULL,1,218.6435,29.41183,0.01,NULL,60018340955,937786577,14652915,15.03),(122120,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122120,37.09,0.23,261,54438,70,NULL,NULL,'2MASX J14343511+0951130',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000188,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.646375,9.85372,0.017,NULL,59358931000,927483296,14491926,17.2),(122121,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122121,33.52,0.8,50.5,54439,75,NULL,'MAT, I','ESO 447- G 023',NULL,'1997ApJS..109..333W',1997,1,2.4,NULL,'G',0.000017,NULL,'13.0B',1.1,'SAB(rs)cd:     HII',NULL,NULL,NULL,NULL,1,218.646541667,-27.99528,0.389,NULL,47023249029,734738266,11480285,13),(122122,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122122,32.7,0.69,34.6,54439,100,NULL,'mid-IR','ESO 447- G 023',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122123,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122123,33.35,0.32,46.7,54439,85,NULL,'I, raw','ESO 447- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122124,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122124,33.38,0.32,47.5,54439,85,NULL,'I, inv','ESO 447- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122125,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122125,33.44,0.43,48.8,54439,75,NULL,'MAT, I, raw','ESO 447- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122126,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122126,33.55,0.43,51.4,54439,75,NULL,'3.6 micron, color corrected','ESO 447- G 023',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122127,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122127,33.56,0.43,51.6,54439,75,NULL,'3.6 micron, color + selection bias corrected','ESO 447- G 023',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122128,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122128,33.59,0.2,52.2,54439,74.4,NULL,NULL,'ESO 447- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122129,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122129,33.62,0.4,53,54439,NULL,NULL,'mean','ESO 447- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122130,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122130,33.63,0.43,53.3,54439,75,NULL,'MAT, I, inv','ESO 447- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122131,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122131,33.69,0.43,54.8,54439,75,NULL,'MAT, I, cor','ESO 447- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122132,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122132,33.72,0.4,55.6,54439,NULL,NULL,'Malmquist cor.','ESO 447- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122133,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122133,33.73,0.4,55.8,54439,NULL,NULL,NULL,'ESO 447- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122134,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122134,33.8,0.47,57.5,54439,NULL,NULL,'H','ESO 447- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122135,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122135,33.81,0.45,57.7,54439,NULL,NULL,'K','ESO 447- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122136,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122136,33.84,0.46,58.5,54439,NULL,NULL,'J','ESO 447- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122137,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122137,37.5,0.33,316,54440,70,NULL,NULL,'SDSS J143435.22+135006.2',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.26,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.64675,13.83508,0,NULL,59545607449,930400116,14537501,16.8),(122138,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SN 2003du',NULL,122138,32.1,0.36,26.1,54441,74.2,NULL,'SALT 2','UGC 09391',0.00638,'2010ApJ...716..712A',2010,1,1.7,NULL,'G',0.000013,NULL,'14.6B',1,'SBdm','Dwarf, possible member',NULL,NULL,NULL,1,218.65425,59.33781,0,NULL,57768273004,902629265,14103582,14.6),(122139,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SN 2003du',NULL,122139,32.61,0.17,33.1,54441,72,NULL,NULL,'UGC 09391',0.00638,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122140,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SN 2003du',NULL,122140,32.63,0.16,33.4,54441,72,NULL,NULL,'UGC 09391',0.00638,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122141,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SN 2003du',NULL,122141,32.73,0.05,35.2,54441,72,NULL,'M(H) = -18.317 mag','UGC 09391',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122142,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SN 2003du',NULL,122142,32.77,0.04,35.6,54441,72,NULL,NULL,'UGC 09391',0.00638,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122143,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SN 2003du',NULL,122143,32.79,0.15,36.1,54441,72,NULL,'VJHK','UGC 09391',0.00638,'2007A&A...469..645S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122144,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SN 2003du',NULL,122144,32.83,0.1,36.8,54441,74.4,NULL,NULL,'UGC 09391',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122145,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SN 2003du',NULL,122145,32.89,0.4,37.6,54441,NULL,NULL,NULL,'UGC 09391',0.00638,'2005A&A...429..667A',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122146,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SN 2003du',NULL,122146,32.99,0.19,39.4,54441,72,NULL,NULL,'UGC 09391',0.00638,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122147,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SN 2003du',NULL,122147,33.19,0.05,42.9,54441,65,NULL,'MLCS2k2','UGC 09391',0.00638,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122148,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122148,32.51,0.4,31.8,54441,75,NULL,'B','UGC 09391',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122149,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122149,32.6,0.4,33.1,54441,75,NULL,'HOSTS SN 2003du','UGC 09391',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122150,'D-Sigma','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122150,32.98,0.4,39.5,54442,75,NULL,'Edat, raw','IC 4451',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000107,NULL,'12.0',1.1,'E+:',NULL,NULL,NULL,NULL,1,218.65475,-36.28583,0.253,NULL,47220943619,737827244,11528550,12),(122151,'D-Sigma','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122151,33.34,0.4,46.6,54442,75,NULL,'Edat, cor','IC 4451',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122152,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122152,33.53,0.47,50.7,54442,70,NULL,NULL,'IC 4451',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122153,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122153,33.73,0.4,55.8,54442,NULL,NULL,'mean','IC 4451',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122154,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122154,33.91,0.45,60.5,54442,NULL,NULL,'K','IC 4451',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122155,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122155,37.97,0.46,393,54443,70,NULL,NULL,'2MASX J14343819+1828128',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.68',0.13,NULL,NULL,NULL,NULL,NULL,1,218.659,18.47011,0.01,NULL,59479933855,929373966,14521468,18.68),(122156,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122156,37.35,0.46,295,54444,70,NULL,NULL,'2MASX J14343856+1445448',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.34',0.17,NULL,NULL,NULL,NULL,NULL,1,218.66075,14.76242,0,NULL,59544579070,930384047,14537250,18.34),(122157,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122157,31.68,0.4,21.7,54445,NULL,NULL,NULL,'UGC 09380',NULL,'2009AJ....138..323T',2009,1,1.9,'Multiple SDSS entries describe this object.','G',0.00002,NULL,'14.2',1,'Im; LSBG       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,218.663333,4.26278,0.065,NULL,58317334066,911208344,14237630,14.2),(122158,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122158,31.68,NULL,21.7,54445,72,NULL,NULL,'UGC 09380',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122159,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122159,32.27,0.4,28.5,54445,75,NULL,'B','UGC 09380',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122160,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122160,37.2,0.33,276,54446,70,NULL,NULL,'2MASX J14344001+1439478',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.44',0.15,NULL,NULL,NULL,NULL,NULL,1,218.6667083,14.66344,0,NULL,59545296888,930395263,14537425,18.44),(122161,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122161,38.06,0.27,410,54447,70,NULL,NULL,'SDSS J143440.62+262632.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.66925,26.44242,0.023,NULL,60023798869,937871857,14654247,18.5),(122162,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122162,38.06,0.27,410,54448,70,NULL,NULL,'2MASX J14344081+2620284',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,218.669917,26.34136,0.023,NULL,60023795515,937871804,14654246,16.8),(122163,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122163,37.51,0.46,318,54449,70,NULL,NULL,'SDSS J143441.26+253011.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000153,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.671958333,25.50328,0.061,NULL,60022265638,937847900,14653873,18.5),(122164,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122164,36.52,0.46,202,54450,70,NULL,NULL,'2MASX J14344213+0054500',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00009,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,218.675667,0.91386,0.093,NULL,58288693815,910760840,14230638,16.5),(122165,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122165,38.04,0.33,405,54451,70,NULL,NULL,'SDSS J143442.56+245323.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.677375,24.88978,0.085,NULL,59498817297,929669020,14526078,18.4),(122166,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122166,37.72,0.46,351,54452,70,NULL,NULL,'2MASX J14344275+0947470',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.24',0.16,NULL,NULL,NULL,NULL,NULL,1,218.678208333,9.79631,0.017,NULL,59358954767,927483668,14491932,18.24),(122167,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122167,38.18,0.19,432,54453,70,NULL,NULL,'SDSS J143442.88+172154.5',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.5g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,218.6787083,17.36514,0,NULL,59483037280,929422457,14522225,16.5),(122168,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122168,34.8,0.8,91.1,54454,75,NULL,'MAT, I','ESO 512- G 005',NULL,'1997ApJS..109..333W',1997,1,1.74,NULL,'G',0.00002,NULL,'16.61',0.09,'Sc',NULL,NULL,NULL,NULL,1,218.68,-25.44389,0.309,NULL,47016514593,734633040,11478641,16.61),(122169,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122169,34.36,0.32,74.5,54454,85,NULL,'I, raw','ESO 512- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122170,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122170,34.36,0.32,74.6,54454,85,NULL,'I, inv','ESO 512- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122171,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122171,34.46,NULL,78,54454,NULL,NULL,NULL,'ESO 512- G 005',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122172,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122172,34.49,0.43,79.2,54454,75,NULL,'MAT, I, raw','ESO 512- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122173,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122173,34.56,0.43,81.5,54454,75,NULL,'MAT, I, inv','ESO 512- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122174,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122174,34.62,NULL,84.1,54454,NULL,NULL,'Dipole + Quadrupole','ESO 512- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122175,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122175,34.63,NULL,84.3,54454,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 512- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122176,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122176,34.64,NULL,84.6,54454,NULL,NULL,'Dipole','ESO 512- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122177,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122177,34.83,0.43,92.6,54454,75,NULL,'MAT, I, cor','ESO 512- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122178,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122178,34.93,0.45,96.7,54454,NULL,NULL,'Malmquist cor.','ESO 512- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122179,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122179,34.99,0.2,99.5,54454,74.4,NULL,NULL,'ESO 512- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122180,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122180,35.01,0.44,101,54454,NULL,NULL,NULL,'ESO 512- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122181,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122181,38.06,0.27,409,54455,70,NULL,NULL,'2MASX J14344316+0907060',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.68,9.11836,0.029,NULL,59364092220,927563940,14493186,17.7),(122182,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122182,38.04,0.33,405,54456,70,NULL,NULL,'2MASX J14344330+2448354',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000161,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,218.680541667,24.80989,0.091,NULL,59498819774,929669058,14526079,17.1),(122183,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122183,38.42,0.46,484,54457,70,NULL,NULL,'2MASX J14344458+1040260',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.6859583,10.67381,0.009,NULL,59359220077,927487813,14491997,17.8),(122184,'Tully est','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122184,32.8,0.8,36.3,54458,75,NULL,'B','NGC 5682',NULL,'1988NBGC.C....0000T',1988,1,2.13,NULL,'G',0.000012,NULL,'14.5g',0.47,'SB(s)b         Sy1','in a pair',NULL,NULL,NULL,1,218.687416667,48.67025,0.129,NULL,59199421925,924990967,14452983,14.5),(122185,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122185,32.55,0.2,32.4,54458,74.4,NULL,NULL,'NGC 5682',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122186,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122186,37.09,0.23,261,54459,70,NULL,NULL,'SDSS J143445.22+095525.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,218.688458333,9.92383,0.017,NULL,59358929740,927483277,14491926,18),(122187,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122187,33.69,0.8,54.7,54460,75,NULL,'MAT, I','ESO 385- G 047',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.00001,NULL,'15.09',1.6,'SB.../Irr',NULL,NULL,NULL,NULL,1,218.6897083,-32.97928,0.233,NULL,46998142075,734345969,11474155,15.09),(122188,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122188,30.85,0.32,14.8,54460,85,NULL,'I, inv','ESO 385- G 047',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122189,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122189,30.92,0.32,15.3,54460,85,NULL,'I, raw','ESO 385- G 047',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122190,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122190,31.85,0.43,23.4,54460,75,NULL,'MAT, I, inv','ESO 385- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122191,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122191,31.98,0.43,24.9,54460,75,NULL,'MAT, I, raw','ESO 385- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122192,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122192,32.28,0.43,28.6,54460,75,NULL,'MAT, I, cor','ESO 385- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122193,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122193,32.96,0.94,39.1,54460,NULL,NULL,NULL,'ESO 385- G 047',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122194,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122194,33,0.2,39.8,54460,74.4,NULL,NULL,'ESO 385- G 047',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122195,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122195,33.55,0.71,51.2,54460,NULL,NULL,'Malmquist cor.','ESO 385- G 047',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122196,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122196,37.16,0.46,271,54461,70,NULL,NULL,'2MASX J14344669+2255336',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000173,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,218.6945,22.92589,0.062,NULL,59497705538,929651649,14525807,16.5),(122197,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122197,37.47,0.46,312,54462,70,NULL,NULL,'2MASX J14344727+0815100',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000173,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,218.6970417,8.25267,0.017,NULL,58277704154,910589127,14227955,16.8),(122198,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122198,37.65,0.46,339,54463,70,NULL,NULL,'2MASX J14344775+5625194',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.6987917,56.422,0,NULL,57259987668,894687307,13979489,17.6),(122199,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122199,37.32,0.46,291,54464,70,NULL,NULL,'SDSS J143447.91+051753.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000172,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,218.699666667,5.29811,0.057,NULL,58310691285,911104551,14236008,18),(122200,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122200,35.95,0.2,155,54465,74.4,NULL,NULL,'CGCG 075-078',NULL,'2013AJ....146...86T',2013,1,0.56,NULL,'G',0.00017,NULL,'15.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,218.7002083,10.02558,0.033,NULL,59359812716,927497073,14492141,15.9),(122201,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122201,38.25,0.46,446,54466,70,NULL,NULL,'2MASX J14344878+2316016',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,218.7032917,23.26719,0.069,NULL,59497760214,929652503,14525820,18),(122202,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122202,38.66,0.21,539,54467,70,NULL,NULL,'2MASX J14345056+6136478',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00017,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.711167,61.6135,0.021,NULL,57760613660,902509588,14101712,17.8),(122203,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122203,38.18,0.19,432,54468,70,NULL,NULL,'2MASX J14345071+1740047',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.45',0.14,NULL,NULL,NULL,NULL,NULL,1,218.7112917,17.668,0,NULL,59482959849,929421247,14522206,18.45),(122204,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122204,37.78,0.46,359,54469,70,NULL,NULL,'2MASX J14345178+4307539',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.7157917,43.13172,0.024,NULL,59961355365,936896177,14639002,17.6),(122205,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122205,38.25,0.46,446,54470,70,NULL,NULL,'2MASX J14345233+0653213',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000185,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.7182083,6.88944,0.045,NULL,58279723289,910620676,14228448,17.8),(122206,'SBF','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122206,32.23,0.51,27.9,54471,NULL,NULL,'I','NGC 5687',NULL,'2001ApJ...546..681T',2001,1,2.13,NULL,'G',0.000017,NULL,'12.8g',1.08,'S0-?','Isolated galaxy',NULL,NULL,NULL,1,218.718333,54.47586,0,NULL,59191082462,924860663,14450947,12.8),(122207,'SBF','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122207,32.3,0.14,28.8,54471,74.4,NULL,NULL,'NGC 5687',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122208,'Tully est','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122208,32.68,0.8,34.4,54471,75,NULL,'B','NGC 5687',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122209,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122209,32.69,0.4,34.5,54471,NULL,NULL,'mean','NGC 5687',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122210,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122210,33.23,0.45,44.4,54471,NULL,NULL,'K','NGC 5687',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122211,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122211,38.49,0.46,498,54472,70,NULL,NULL,'2MASX J14345404+1154297',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,218.725167,11.90819,0.025,NULL,59360379574,927505930,14492280,18.5),(122212,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122212,38.45,0.46,490,54473,70,NULL,NULL,'2MASX J14345434+2407348',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000134,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,218.726375,24.1265,0.096,NULL,59499425110,929678517,14526226,18.6),(122213,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122213,38.32,0.27,461,54474,70,NULL,NULL,'2MASX J14345436+2254086',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.7265417,22.90231,0.062,NULL,59497649772,929650777,14525793,17.9),(122214,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122214,37.61,0.46,332,54475,70,NULL,NULL,'2MASX J14345505+0818153',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,218.729416667,8.30442,0.017,NULL,58277582996,910587234,14227925,17.4),(122215,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122215,36.44,0.46,194,54476,70,NULL,NULL,'2MASX J14345520+0851123',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000083,NULL,'15.6g',0.5,NULL,NULL,NULL,NULL,NULL,1,218.729917,8.85347,0.025,NULL,59364101975,927564093,14493188,15.6),(122216,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122216,34.92,0.49,96.5,54477,75,NULL,'IR','MCG -01-37-009',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.00015,NULL,'16',0.2,'S?             HII',NULL,NULL,NULL,NULL,1,218.737333,-8.84106,0.189,NULL,46465584468,726024757,11344136,16),(122217,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122217,35,0.4,99.9,54477,NULL,NULL,'mean','MCG -01-37-009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122218,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122218,35.13,0.47,106,54477,NULL,NULL,'H','MCG -01-37-009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122219,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122219,35.26,0.45,113,54477,NULL,NULL,'K','MCG -01-37-009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122220,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122220,35.48,0.2,125,54477,74.4,NULL,NULL,'MCG -01-37-009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122221,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122221,35.53,0.5,128,54477,NULL,NULL,'Malmquist cor.','MCG -01-37-009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122222,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122222,35.71,0.46,138,54477,NULL,NULL,NULL,'MCG -01-37-009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122223,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122223,37.02,0.46,254,54478,70,NULL,NULL,'2MASX J14345715+4039520',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000171,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.73825,40.66439,0.011,NULL,59946155898,936658685,14635291,17.2),(122224,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122224,37.11,0.46,264,54479,70,NULL,NULL,'2MASX J14345797+0237403',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000094,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,218.7415,2.62794,0.089,NULL,58308386407,911068537,14235445,17.1),(122225,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122225,38.08,0.46,414,54480,70,NULL,NULL,'SDSS J143459.57+304433.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000166,NULL,'18.3g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.7482083,30.7425,0,NULL,60016558218,937758722,14652480,18.3),(122226,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122226,35.96,0.46,156,54481,70,NULL,NULL,'2MASX J14350112+2950248',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000084,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,218.754833,29.84019,0,NULL,60017954537,937780539,14652820,16.4),(122227,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122227,38.77,0.46,568,54482,70,NULL,NULL,'2MASX J14350197+4652529',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,218.758333,46.88139,0.013,NULL,59953610043,936775156,14637111,17.8),(122228,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122228,37.69,0.46,345,54483,70,NULL,NULL,'SDSS J143502.29+463040.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000146,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,218.759583,46.51125,0.009,NULL,59953548903,936774201,14637096,18.6),(122229,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122229,28.82,NULL,5.81,54484,NULL,NULL,NULL,'ESO 222- G 010',NULL,'2013AJ....145..101K',2013,1,1,NULL,'G',0.000017,NULL,'16.33',0.5,'cl.to br.*',NULL,NULL,NULL,NULL,1,218.76075,-49.42064,0.869,NULL,46782571338,730977677,11421526,16.33),(122230,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122230,38.37,0.46,473,54485,70,NULL,NULL,'2MASX J14350331+5603423',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000176,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,218.763833,56.06169,0.005,NULL,57259687822,894682622,13979415,17.2),(122231,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122231,38.29,0.46,454,54486,70,NULL,NULL,'SDSS J143503.58+061145.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000158,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,218.764917,6.19608,0.053,NULL,58278182344,910596599,14228071,18.5),(122232,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122232,37.96,0.46,391,54487,70,NULL,NULL,'2MASX J14350563-0045358',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000079,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.7734583,-0.76006,0.089,NULL,43512564009,679883812,10623184,17.6),(122233,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122233,37.09,0.23,261,54488,70,NULL,NULL,'2MASX J14350737+0945443',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.7807083,9.76236,0.025,NULL,59358960959,927483764,14491933,17.6),(122234,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122234,38.15,0.46,426,54489,70,NULL,NULL,'SDSS J143507.55+214818.6',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,218.7814583,21.80517,0.086,NULL,59502647307,929728864,14527013,NULL),(122235,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122235,37.4,0.46,302,54490,70,NULL,NULL,'2MASX J14350784+1600445',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.12',0.16,NULL,NULL,NULL,NULL,NULL,1,218.782833,16.01225,0,NULL,59551959172,930499362,14539052,18.12),(122236,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122236,39.23,0.46,701,54491,70,NULL,NULL,'SDSS J143508.78+461816.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,218.786625,46.30447,0.025,NULL,59954376359,936787130,14637298,18.7),(122237,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122237,37.94,0.46,388,54492,70,NULL,NULL,'2MASX J14350926+2422068',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.78875,24.36858,0.095,NULL,59499102129,929673470,14526147,18),(122238,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122238,37.3,0.46,289,54493,70,NULL,NULL,'2MASX J14350959+2442368',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'18.42',0.17,NULL,NULL,NULL,NULL,NULL,1,218.790041667,24.71019,0.095,NULL,59498760196,929668128,14526064,18.42),(122239,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122239,37.54,0.46,323,54494,70,NULL,NULL,'2MASX J14351191+0741364',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000181,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,218.7997917,7.69356,0.041,NULL,58277037630,910578712,14227792,17.1),(122240,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122240,37.65,0.46,338,54495,70,NULL,NULL,'2MASX J14351191+2310026',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000186,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,218.799833,23.16728,0.069,NULL,59497742076,929652219,14525815,17),(122241,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122241,38.34,0.46,465,54496,70,NULL,NULL,'SDSS J143512.88+242557.7',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.803708333,24.43272,0.095,NULL,59499097154,929673393,14526146,17.4),(122242,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122242,36.71,0.46,220,54497,70,NULL,NULL,'2MASX J14351323+0826074',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.64',0.22,NULL,NULL,NULL,NULL,NULL,1,218.8052083,8.43544,0.021,NULL,58276893308,910576457,14227757,17.64),(122243,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122243,37.99,0.46,397,54498,70,NULL,NULL,'2MASX J14351374+4300519',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,218.807333,43.01467,0.022,NULL,59961333409,936895834,14638997,17.7),(122244,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122244,37.53,0.46,321,54499,70,NULL,NULL,'2MASX J14351472+2439208',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000192,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,218.8112917,24.65564,0.095,NULL,59498658876,929666544,14526039,16.5),(122245,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122245,38.06,0.27,409,54500,70,NULL,NULL,'2MASX J14351483+0913094',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,218.811667,9.21919,0.025,NULL,59372497948,927695280,14495238,17.1),(122246,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122246,37.77,0.46,358,54501,70,NULL,NULL,'2MASX J14351692+0419304',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000094,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,218.8205417,4.32506,0.065,NULL,58317126439,911205100,14237579,16.4),(122247,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122247,34.63,0.8,84.3,54502,75,NULL,'HMCL, I','UGC 09387',NULL,'1997ApJS..109..333W',1997,1,0.91,NULL,'G',0.00007,NULL,'15.2g',0.42,'SB0(ring)',NULL,NULL,NULL,NULL,1,218.821333,22.96264,0.062,NULL,59497672462,929651132,14525798,15.2),(122248,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122248,34.65,0.4,85,54502,75,NULL,'HMCL, I, raw','UGC 09387',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122249,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122249,34.78,0.4,90.3,54502,75,NULL,'HMCL, I, inv','UGC 09387',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122250,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122250,34.94,0.4,97.5,54502,75,NULL,'HMCL, I, cor','UGC 09387',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122251,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122251,37.65,0.46,338,54503,70,NULL,NULL,'2MASX J14351724+1713025',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.82175,17.21747,0,NULL,59483060828,929422825,14522231,17.8),(122252,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122252,37.7,0.33,346,54504,70,NULL,NULL,'SDSS J143517.81+183545.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.5g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.82425,18.59603,0.027,NULL,59479913523,929373648,14521463,17.5),(122253,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122253,38.32,0.27,461,54505,70,NULL,NULL,'SDSS J143517.87+225339.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000135,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,218.8245,22.89419,0.062,NULL,59505189084,929768579,14527634,18.3),(122254,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122254,38.03,0.33,404,54506,70,NULL,NULL,'2MASX J14351799+2823137',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.42',0.16,NULL,NULL,NULL,NULL,NULL,1,218.825041667,28.38722,0,NULL,60025559424,937899366,14654677,18.42),(122255,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122255,37.36,0.46,296,54507,70,NULL,NULL,'SDSS J143518.43+195154.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.826833,19.86503,0.018,NULL,59512609994,929884531,14529445,18),(122256,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122256,36.48,0.46,198,54508,70,NULL,NULL,'2MASX J14351962+1643535',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.29',0.16,NULL,NULL,NULL,NULL,NULL,1,218.83175,16.73147,0,NULL,59482006364,929406349,14521974,18.29),(122257,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122257,38.03,0.33,404,54509,70,NULL,NULL,'SDSS J143519.91+282241.5',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.8g',0.28,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.833,28.37819,0,NULL,60025677407,937901209,14654706,16.8),(122258,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122258,38.6,0.46,525,54510,70,NULL,NULL,'2MASX J14352103+2355206',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.77',0.14,NULL,NULL,NULL,NULL,NULL,1,218.837458333,23.92247,0.099,NULL,59499449239,929678894,14526232,18.77),(122259,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122259,37.9,0.46,381,54511,70,NULL,NULL,'2MASX J14352162+2354376',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.840167,23.9105,0.078,NULL,59499448710,929678886,14526232,17.1),(122260,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122260,38.1,0.46,416,54512,70,NULL,NULL,'2MASX J14352162+5051233',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'17.3g',0.22,'AGN',NULL,NULL,NULL,NULL,1,218.840333,50.85636,0,NULL,59199778907,924996545,14453071,17.3),(122261,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122261,36.95,0.46,246,54513,70,NULL,NULL,'2MASX J14352193+0757497',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'18.11',0.19,NULL,NULL,NULL,NULL,NULL,1,218.841375,7.96367,0.041,NULL,58277526867,910586357,14227911,18.11),(122262,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122262,37.59,0.46,330,54514,70,NULL,NULL,'SDSS J143522.58+122411.2',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.844125,12.40314,0.009,NULL,59543935435,930373991,14537093,17.2),(122263,'Tully est','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122263,32.22,0.8,27.8,54515,75,NULL,NULL,'UGC 09385',NULL,'1988NBGC.C....0000T',1988,1,0.51,NULL,'G',0.000013,NULL,'17.3g',0.37,'Im:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,218.844958333,5.27656,0.069,NULL,58310620116,911103439,14235991,17.3),(122264,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122264,37.76,0.33,357,54516,70,NULL,NULL,'2MASX J14352351+2058446',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,218.847791667,20.97917,0.065,NULL,59502894475,929732726,14527073,16.6),(122265,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122265,34.99,0.2,99.5,54517,74.4,NULL,NULL,'KUG 1432+096',NULL,'2013AJ....146...86T',2013,1,0.72,NULL,'G',0.00008,NULL,'15.3g',0.4,'Sa',NULL,NULL,NULL,NULL,1,218.8489583,9.46492,0.025,NULL,59372689934,927698280,14495285,15.3),(122266,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122266,37.08,0.27,261,54518,70,NULL,NULL,'2MASX J14352435+5756139',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000177,NULL,'16.1g',0.4,'E0',NULL,NULL,NULL,NULL,1,218.851208333,57.93733,0.013,NULL,57251515438,894554928,13977420,16.1),(122267,'Brightest Stars','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122267,29.52,0.2,8.02,54519,NULL,NULL,NULL,'UGC 09405',NULL,'1998A&AS..133..181M',1998,1,1.17,NULL,'G',0.00002,NULL,'15.1g',0.71,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,218.850333,57.25594,0,NULL,57250853601,894544587,13977259,15.1),(122268,'TRGB','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122268,28.82,0.1,5.81,54519,74.4,NULL,NULL,'UGC 09405',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122269,'TRGB','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122269,29,0.13,6.3,54519,NULL,NULL,NULL,'UGC 09405',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122270,'Tully est','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122270,28.79,0.8,5.7,54519,75,NULL,NULL,'UGC 09405',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122271,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122271,37.55,0.33,323,54520,70,NULL,NULL,'2MASX J14352483+1358096',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.42',0.16,NULL,NULL,NULL,NULL,NULL,1,218.8535,13.96936,0,NULL,59545177017,930393390,14537396,18.42),(122272,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122272,36.4,0.46,191,54521,70,NULL,NULL,'2MASX J14352496+5504369',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'16.4g',0.29,NULL,'Group non-member, foreground',NULL,NULL,NULL,1,218.854041667,55.07694,0,NULL,57257620440,894650319,13978911,16.4),(122273,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122273,38.32,0.27,461,54522,70,NULL,NULL,'2MASX J14352510+2256056',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00019,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,218.854833,22.93506,0.062,NULL,59505218400,929769037,14527641,17.3),(122274,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122274,37.06,0.46,258,54523,70,NULL,NULL,'2MASX J14352557-0123564',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.856667,-1.39908,0.109,NULL,43545653601,680400837,10631263,17.4),(122275,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122275,35.92,0.46,153,54524,70,NULL,NULL,'2MASX J14352601+5157503',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000166,NULL,'16.1g',0.42,NULL,NULL,NULL,NULL,NULL,1,218.8585417,51.96414,0.005,NULL,59206654404,925103975,14454749,16.1),(122276,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122276,37.62,0.46,335,54525,70,NULL,NULL,'2MASX J14352638+3021087',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,218.859917,30.35256,0,NULL,60017913925,937779905,14652811,17.6),(122277,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122277,37.76,0.33,357,54526,70,NULL,NULL,'2MASX J14352643+2948565',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,218.860125,29.81569,0,NULL,60018033468,937781772,14652840,17.7),(122278,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122278,36.27,0.46,179,54527,70,NULL,NULL,'2MASX J14352709+5842389',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000148,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,218.8629583,58.71069,0,NULL,57722980414,901921568,14092524,16.7),(122279,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122279,36.64,0.46,213,54528,70,NULL,NULL,'2MASX J14352715+2101146',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.37',0.28,NULL,NULL,NULL,NULL,NULL,1,218.8630417,21.02064,0.065,NULL,59502902579,929732852,14527075,17.37),(122280,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122280,37.7,0.33,346,54529,70,NULL,NULL,'2MASX J14352715+1833126',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.84',0.12,NULL,NULL,NULL,NULL,NULL,1,218.8632083,18.55358,0.027,NULL,59479909896,929373592,14521462,18.84),(122281,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122281,35.3,0.46,115,54530,70,NULL,NULL,'CGCG 133-091',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000165,NULL,'15.4g',0.47,NULL,NULL,NULL,NULL,NULL,1,218.865583333,23.53878,0.078,NULL,59499388815,929677950,14526217,15.4),(122282,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122282,37.76,0.33,357,54531,70,NULL,NULL,'SDSS J143528.08+210254.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.867,21.04856,0.065,NULL,59502903138,929732861,14527075,18.2),(122283,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122283,34.73,NULL,88.2,54532,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09390',NULL,'2010Ap&SS.325..163P',2010,1,0.97,NULL,'G',0.000017,NULL,'17.2g',0.09,'Sd',NULL,NULL,NULL,NULL,1,218.872583,22.40631,0.063,NULL,59504769095,929762017,14527531,17.2),(122284,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122284,34.75,NULL,89.2,54532,NULL,NULL,'Dipole + Quadrupole','UGC 09390',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122285,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122285,34.75,NULL,89.3,54532,NULL,NULL,'Dipole','UGC 09390',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122286,'Tully est','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122286,32.76,0.8,35.6,54533,75,NULL,'B','NGC 5689',NULL,'1988NBGC.C....0000T',1988,1,3.5,NULL,'G',0.000033,NULL,'12.8',1,'SB(s)0/a:','in a radial-velocity based grouping',NULL,NULL,NULL,1,218.8737083,48.74164,0.121,NULL,59199406320,924990723,14452980,12.8),(122287,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122287,38.19,0.46,435,54534,70,NULL,NULL,'2MASX J14353154+3235317',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000162,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,218.881416667,32.59214,0,NULL,60045758704,938214979,14659609,18.1),(122288,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122288,37.33,0.46,293,54535,70,NULL,NULL,'2MASX J14353216+4337170',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.883875,43.62133,0.095,NULL,59961252632,936894572,14638977,17.9),(122289,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122289,35.61,0.46,132,54536,70,NULL,NULL,'2MASX J14353261+6331475',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000076,NULL,'15.8g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,218.886167,63.52994,0.049,NULL,57757420256,902459691,14100932,15.8),(122290,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122290,32.31,0.4,29,54537,75,NULL,NULL,'UGC 09389',NULL,'2008Ap.....51..336K',2008,1,2.31,NULL,'G',0.00002,NULL,'14.1g',0.57,'SBb','Pair member (points to parent)',NULL,NULL,NULL,1,218.888666667,12.90825,0.021,NULL,59544049023,930375765,14537121,14.1),(122291,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122291,32.33,0.2,29.2,54537,74.4,NULL,NULL,'UGC 09389',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122292,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122292,32.59,0.43,32.9,54537,75,NULL,'3.6 micron, color corrected','UGC 09389',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122293,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122293,32.88,0.43,37.6,54537,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09389',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122294,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122294,33.24,0.49,44.5,54537,75,NULL,'IR','UGC 09389',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122295,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122295,34.57,0.8,82.2,54538,75,NULL,'HMCL, I','CGCG 133-090',NULL,'1997ApJS..109..333W',1997,1,0.7,NULL,'G',0.000047,NULL,'15.5',0.2,NULL,NULL,NULL,NULL,NULL,1,218.89175,22.73247,0.062,NULL,59505188267,929768566,14527633,15.5),(122296,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122296,33.84,0.2,58.6,54538,74.4,NULL,NULL,'CGCG 133-090',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122297,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122297,34.27,0.4,71.5,54538,75,NULL,'HMCL, I, raw','CGCG 133-090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122298,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122298,34.36,0.4,74.5,54538,75,NULL,'HMCL, I, inv','CGCG 133-090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122299,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122299,34.45,0.4,77.7,54538,75,NULL,'HMCL, I, cor','CGCG 133-090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122300,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122300,36.98,0.46,249,54539,70,NULL,NULL,'SDSS J143535.34+501123.9',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000201,NULL,'15.7g',0.45,'E0',NULL,NULL,NULL,NULL,1,218.89725,50.19,0.029,NULL,59201740017,925027187,14453549,15.7),(122301,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122301,37.76,0.33,357,54540,70,NULL,NULL,'SDSS J143535.71+295130.4',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.9g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.8987917,29.85844,0,NULL,60018035448,937781803,14652840,16.9),(122302,'D-Sigma','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122302,31.88,0.4,23.7,54541,75,NULL,'Edat, raw','NGC 5670',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.00005,NULL,'12.95',1,'SAB(s:)0^0',NULL,NULL,NULL,NULL,1,218.900125,-45.96697,0.613,NULL,47081897943,735654655,11494603,12.95),(122303,'D-Sigma','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122303,32.21,0.4,27.7,54541,75,NULL,'Edat, cor','NGC 5670',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122304,'Tully est','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122304,32.96,0.8,39,54541,75,NULL,NULL,'NGC 5670',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122305,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122305,31.89,0.45,23.8,54541,NULL,NULL,'K','NGC 5670',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122306,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122306,32.88,0.4,37.7,54541,NULL,NULL,'mean','NGC 5670',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122307,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122307,38.18,0.19,432,54542,70,NULL,NULL,'SDSS J143536.14+173755.4',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.900625,17.63206,0,NULL,59482937141,929420892,14522201,16.9),(122308,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122308,37.65,0.33,339,54543,70,NULL,NULL,'2MASX J14353637+4317060',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,218.90175,43.28525,0.024,NULL,59961486419,936898225,14639034,17.4),(122309,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122309,37.97,0.78,393,54544,70,NULL,NULL,'2MASX J14353644-0523104',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'17.37',0.18,NULL,NULL,NULL,NULL,NULL,1,218.901875,-5.38631,0.177,NULL,43543957917,680374342,10630849,17.37),(122310,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122310,37.01,0.46,252,54545,70,NULL,NULL,'2MASX J14353673+5915279',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,218.903,59.25783,0,NULL,57768230062,902628594,14103571,17.1),(122311,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122311,37.76,0.27,357,54546,70,NULL,NULL,'2MASX J14353710-0027384',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000074,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.9045417,-0.46069,0.105,NULL,43511893244,679873331,10623020,17.7),(122312,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122312,32.03,0.75,25.4,54547,NULL,NULL,'Malmquist cor.','UGC 09394',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'GTrpl',0.00003,NULL,NULL,NULL,'Scd?','Pair member (points to parent)',NULL,NULL,NULL,1,218.912083,13.16556,0,NULL,59545619559,930400305,14537504,NULL),(122313,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122313,32.21,0.2,27.7,54547,74.4,NULL,NULL,'UGC 09394',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122314,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122314,32.22,0.43,27.8,54547,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09394',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122315,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122315,32.24,0.43,28,54547,75,NULL,'3.6 micron, color corrected','UGC 09394',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122316,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122316,32.3,0.4,28.8,54547,NULL,NULL,NULL,'UGC 09394',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122317,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122317,32.41,0.63,30.3,54547,NULL,NULL,NULL,'UGC 09394',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122318,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122318,37.78,0.46,360,54548,70,NULL,NULL,'2MASX J14353920+1930585',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.9135,19.51636,0.024,NULL,59509119070,929829985,14528593,17.7),(122319,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122319,37.55,0.33,323,54549,70,NULL,NULL,'2MASX J14354210+1356316',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.01',0.19,NULL,NULL,NULL,NULL,NULL,1,218.9255417,13.94208,0,NULL,59545174278,930393348,14537396,18.01),(122320,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122320,37.18,0.46,273,54550,70,NULL,NULL,'2MASX J14354218+2135508',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.39',0.27,NULL,NULL,NULL,NULL,NULL,1,218.925833,21.59731,0.069,NULL,59502691551,929729555,14527024,17.39),(122321,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122321,38.85,0.46,589,54551,70,NULL,NULL,'2MASX J14354241+1554186',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,218.926833333,15.90514,0,NULL,59551979937,930499686,14539057,NULL),(122322,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122322,37.09,0.23,261,54552,70,NULL,NULL,'2MASX J14354248+0943268',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,218.927166667,9.72394,0.025,NULL,59372662702,927697854,14495278,17.4),(122323,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122323,34.35,0.69,74.1,54553,100,NULL,'mid-IR','NGC 5681',NULL,'2013ApJ...771...88L',2013,1,0.9,NULL,'G',0.000133,NULL,'14.3P',0.6,'SA:(rs)bc II',NULL,NULL,NULL,NULL,1,218.928625,8.30061,0.021,NULL,58277571322,910587051,14227922,14.3),(122324,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122324,35.3,0.4,115,54553,NULL,NULL,'mean','NGC 5681',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122325,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122325,35.56,0.47,129,54553,NULL,NULL,'H','NGC 5681',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122326,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122326,37.66,0.46,340,54554,70,NULL,NULL,'2MASX J14354323+5220043',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.930375,52.33461,0,NULL,59205910571,925092352,14454568,17.3),(122327,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122327,36.54,0.19,204,54555,70,NULL,NULL,'2MASX J14354331+6004394',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000076,NULL,'16.8g',0.29,'NLAGN',NULL,NULL,NULL,NULL,1,218.930375,60.07761,0,NULL,57768911715,902639245,14103738,16.8),(122328,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122328,34.73,0.46,88.1,54556,70,NULL,NULL,'CGCG 192-045',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000111,NULL,'15.2g',0.45,'Sy2',NULL,NULL,NULL,'Sy 2',1,218.934,35.07614,0,NULL,60070229191,938597331,14665583,15.2),(122329,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122329,35.48,0.46,125,54557,70,NULL,NULL,'2MASX J14354434+0459348',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.12',0.31,NULL,NULL,NULL,NULL,NULL,1,218.934875,4.99308,0.065,NULL,58310757772,911105590,14236024,16.12),(122330,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122330,38.03,0.46,404,54558,70,NULL,NULL,'2MASX J14354476+2552015',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000181,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,218.936541667,25.867,0.065,NULL,60022378076,937849657,14653900,17.1),(122331,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122331,36.44,0.33,194,54559,70,NULL,NULL,'2MASX J14354629+1755236',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.17',0.23,NULL,NULL,NULL,NULL,NULL,1,218.943041667,17.92325,0,NULL,59480217792,929378403,14521537,17.17),(122332,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122332,37.86,0.46,373,54560,70,NULL,NULL,'2MASX J14354651+3833582',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,218.9437083,38.56606,0.009,NULL,60076535324,938695864,14667122,17.3),(122333,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122333,37.53,0.46,321,54561,70,NULL,NULL,'2MASX J14354657+0219563',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000072,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,218.9442917,2.33225,0.089,NULL,58308350705,911067979,14235437,18),(122334,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122334,37.76,0.27,357,54562,70,NULL,NULL,'2MASX J14354663-0022164',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000111,NULL,'16.8g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,218.944417,-0.37125,0.121,NULL,43511930960,679873921,10623030,16.8),(122335,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122335,37.34,0.46,294,54563,70,NULL,NULL,'2MASX J14354687+4305358',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000185,NULL,'16.1g',0.41,NULL,NULL,NULL,NULL,NULL,1,218.9452917,43.0935,0.024,NULL,59961452819,936897700,14639026,16.1),(122336,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122336,37.76,0.27,357,54564,70,NULL,NULL,'2MASX J14354723-0028374',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000091,NULL,'16.6g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,218.947,-0.47714,0.105,NULL,43511867401,679872928,10623014,16.6),(122337,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122337,37.36,0.46,297,54565,70,NULL,NULL,'2MASX J14354744+4509188',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000183,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,218.9475417,45.15539,0.024,NULL,59957356402,936833693,14638026,16.7),(122338,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122338,31.35,NULL,18.6,54566,72,NULL,NULL,'UGC 09392',NULL,'2014Ap.....57..457K',2014,1,0.87,NULL,'G',0.000019,NULL,'17.5g',0.19,'Irr(f)','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,218.9517917,3.03825,0.061,NULL,58306543817,911039747,14234996,17.5),(122339,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122339,31.63,NULL,21.2,54567,72,NULL,NULL,'SDSS J143549.94+023618.4',NULL,'2014Ap.....57..457K',2014,1,0.7,NULL,'G',0.000067,NULL,'16.8',0.2,'Irr(f)',NULL,NULL,NULL,NULL,1,218.9587917,2.60547,0.097,NULL,58306443959,911038186,14234971,16.8),(122340,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122340,37.28,0.46,285,54568,70,NULL,NULL,'SDSS J143550.36-003651.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00006,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.959833,-0.61442,0.105,NULL,43545338544,680395914,10631186,18.2),(122341,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122341,36.55,0.46,204,54569,70,NULL,NULL,'MCG +05-34-079',NULL,'2015arXiv151105856S',2015,1,0.94,NULL,'G',0.00009,NULL,'15.1g',0.63,NULL,NULL,NULL,NULL,NULL,1,218.960833,28.14686,0.023,NULL,60025696303,937901504,14654711,15.1),(122342,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122342,38.11,0.46,419,54570,70,NULL,NULL,'2MASX J14355174-0053191',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00009,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.965583,-0.88869,0.089,NULL,43546246962,680410108,10631407,17.9),(122343,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122343,36.93,0.46,243,54571,70,NULL,NULL,'2MASX J14355225+2403034',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00014,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.967625,24.05083,0.096,NULL,59498985826,929671653,14526119,18),(122344,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122344,37.2,0.46,275,54572,70,NULL,NULL,'SDSS J143552.23+192749.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.967667,19.46361,0.024,NULL,59509583295,929837238,14528706,18.1),(122345,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122345,38.37,0.46,472,54573,70,NULL,NULL,'SDSS J143553.22+134340.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.971791667,13.72786,0,NULL,59545726920,930401983,14537530,18.3),(122346,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122346,37.94,0.11,387,54574,70,NULL,NULL,'2MASX J14355455+2433164',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.977166667,24.55444,0.095,NULL,59499130081,929673907,14526154,17.3),(122347,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122347,34.33,0.46,73.3,54575,70,NULL,NULL,'CGCG 192-047',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.00009,NULL,'14.7g',0.58,'S0^-',NULL,NULL,NULL,NULL,1,218.9817917,36.71956,0,NULL,60077615312,938712739,14667386,14.7),(122348,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122348,37.47,0.46,312,54576,70,NULL,NULL,'2MASX J14355669+5626097',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00013,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,218.986167,56.43592,0.009,NULL,57258876805,894669950,13979217,17.7),(122349,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122349,37.23,0.46,280,54577,70,NULL,NULL,'2MASX J14355760+1606156',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.31',0.15,NULL,NULL,NULL,NULL,NULL,1,218.99,16.10422,0,NULL,59552654243,930510222,14539222,18.31),(122350,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122350,37.39,0.33,300,54578,70,NULL,NULL,'2MASX J14355957+1654286',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.16',0.18,NULL,NULL,NULL,NULL,NULL,1,218.998083,16.90808,0,NULL,59481825937,929403530,14521930,18.16),(122351,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122351,38.43,0.46,486,54579,70,NULL,NULL,'SDSS J143559.90+132312.3',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.999625,13.38675,0.005,NULL,59545643043,930400672,14537510,17.2),(122352,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122352,38.99,0.46,628,54580,70,NULL,NULL,'SDSS J143600.19+282740.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.0007917,28.46128,0.032,NULL,60025580340,937899692,14654682,18.4),(122353,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122353,36.45,0.46,195,54581,70,NULL,NULL,'LCRS B143324.7-023710',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000158,NULL,'16.4g',0.26,'E0',NULL,NULL,NULL,NULL,1,219.0014583,-2.83669,0.189,NULL,43548146536,680439789,10631871,16.4),(122354,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122354,38.16,0.33,428,54582,70,NULL,NULL,'SDSS J143600.67+392800.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,219.0027917,39.46681,0,NULL,60076168303,938690129,14667033,18.3),(122355,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122355,35.45,0.74,123,54583,70,NULL,NULL,'CGCG 019-069',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.00015,NULL,'15.87',0.34,NULL,NULL,NULL,NULL,NULL,1,219.002875,-3.24311,0.197,NULL,43549901044,680467203,10632300,15.87),(122356,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122356,37.65,0.33,339,54584,70,NULL,NULL,'2MASX J14360072+4321369',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,219.002958333,43.36025,0.058,NULL,59961294934,936895233,14638988,17.9),(122357,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122357,36.82,0.46,231,54585,70,NULL,NULL,'2MASX J14360093-0006371',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000086,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,219.003833,-0.11044,0.069,NULL,43511952741,679874261,10623035,17.1),(122358,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122358,37.96,0.46,392,54586,70,NULL,NULL,'2MASX J14360147+1847226',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.68',0.13,NULL,NULL,NULL,NULL,NULL,1,219.0062917,18.78953,0.04,NULL,59509431253,929834863,14528669,18.68),(122359,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122359,38,0.46,398,54587,70,NULL,NULL,'SDSS J143601.99+202358.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.0082917,20.39956,0.022,NULL,59510414574,929850227,14528909,18.3),(122360,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122360,37.56,0.33,325,54588,70,NULL,NULL,'2MASX J14360283+0716155',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,219.0117083,7.27081,0.053,NULL,58279699654,910620307,14228442,16.9),(122361,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122361,38.08,0.33,413,54589,70,NULL,NULL,'2MASX J14360288-0107111',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000072,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,219.011917,-1.11986,0.105,NULL,43546278273,680410598,10631415,18.3),(122362,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122362,37.94,0.11,387,54590,70,NULL,NULL,'2MASX J14360313+2433059',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000195,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,219.0132083,24.55153,0.095,NULL,59499130649,929673916,14526154,16.8),(122363,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122363,37.94,0.11,387,54591,70,NULL,NULL,'2MASX J14360345+2417389',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000204,NULL,'17.78',0.22,NULL,NULL,NULL,NULL,NULL,1,219.0145417,24.29408,0.095,NULL,59498995108,929671798,14526121,17.78),(122364,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122364,34.93,0.46,96.9,54592,70,NULL,NULL,'2MASX J14360368+2150456',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'16.59',0.35,NULL,NULL,NULL,NULL,NULL,1,219.015375,21.84597,0.049,NULL,59502684531,929729445,14527022,16.59),(122365,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122365,36.33,0.33,184,54593,70,NULL,NULL,'2MASX J14360415+2335556',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000188,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,219.017083333,23.59864,0.076,NULL,59499358408,929677475,14526210,16.7),(122366,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122366,37.23,0.46,279,54594,70,NULL,NULL,'2MASX J14360520+5615178',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.021833333,56.25486,0.005,NULL,57259657228,894682144,13979408,17.5),(122367,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122367,38.73,0.46,557,54595,70,NULL,NULL,'2MASX J14360828+1614070',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.034625,16.23542,0,NULL,59552639201,930509987,14539218,17.7),(122368,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122368,32.66,0.2,34,54596,74.4,NULL,NULL,'HARO 43',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000033,NULL,'16.1',0.2,'S?',NULL,NULL,NULL,NULL,1,219.03675,28.44972,0.032,NULL,60025580554,937899696,14654682,16.1),(122369,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122369,37.66,0.46,340,54597,70,NULL,NULL,'2MASX J14360911+0456153',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000069,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.038041667,4.93756,0.065,NULL,58312576673,911134010,14236468,17.7),(122370,'Sosies','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122370,35.29,0.42,114,54598,NULL,NULL,NULL,'UGC 09401',NULL,'2002A&A...393...57T',2002,1,1.5,NULL,'G',0.000033,NULL,'14.32',0.7,'S?',NULL,NULL,NULL,NULL,1,219.038583,21.79353,0.049,NULL,59502687041,929729485,14527023,14.32),(122371,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122371,34.24,0.29,70.6,54598,NULL,NULL,'Malmquist cor.','UGC 09401',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122372,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122372,34.41,0.47,76.2,54598,NULL,NULL,'H','UGC 09401',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122373,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122373,34.42,0.46,76.7,54598,NULL,NULL,'J','UGC 09401',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122374,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122374,34.5,0.45,79.5,54598,NULL,NULL,'K','UGC 09401',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122375,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122375,34.51,0.26,79.8,54598,NULL,NULL,NULL,'UGC 09401',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122376,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122376,34.57,0.4,82.2,54598,NULL,NULL,'mean','UGC 09401',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122377,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122377,34.73,0.2,88.3,54598,74.4,NULL,NULL,'UGC 09401',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122378,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122378,36.68,0.58,217,54599,70,NULL,NULL,'LCRS B143330.8-063439',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'16.83',0.34,NULL,NULL,NULL,NULL,NULL,1,219.039375,-6.79486,0.165,NULL,43528162158,680127533,10626992,16.83),(122379,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122379,37.86,0.46,373,54600,70,NULL,NULL,'2MASX J14360951+0353493',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000079,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.03975,3.89697,0.069,NULL,58313753723,911152401,14236756,17.4),(122380,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122380,36.09,0.46,165,54601,70,NULL,NULL,'2MASX J14360988+0904315',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000189,NULL,'16.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,219.041208333,9.07542,0.021,NULL,59364308052,927567313,14493239,16),(122381,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122381,35.4,0.49,120,54602,75,NULL,'IR','FGC 1774',NULL,'2011yCatp016004901K',2011,1,0.92,NULL,'G',0.00002,NULL,'17.1g',0.13,'Sd',NULL,NULL,NULL,NULL,1,219.0415,-2.88064,0.189,NULL,43548122845,680439419,10631865,17.1),(122382,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122382,35.79,0.1,144,54603,70,NULL,NULL,'2MASX J14361098+0321153',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,'FoF','17.82',0.24,NULL,NULL,NULL,NULL,NULL,1,219.045916667,3.35428,0.057,NULL,58314016018,911156500,14236820,17.82),(122383,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122383,38.36,0.46,470,54604,70,NULL,NULL,'2MASX J14361177+2951019',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,219.049083,29.85064,0,NULL,60018040432,937781881,14652841,18.2),(122384,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122384,36.33,0.33,184,54605,70,NULL,NULL,'CGCG 133-094',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000194,NULL,'15.6g',0.5,NULL,NULL,NULL,NULL,NULL,1,219.055708333,23.57719,0.076,NULL,59499360574,929677508,14526211,15.6),(122385,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122385,37.58,0.46,329,54606,70,NULL,NULL,'2MASX J14361346+2540419',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000144,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,219.0559583,25.67825,0.059,NULL,60022567789,937852621,14653947,17.5),(122386,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122386,35.97,0.49,157,54607,75,NULL,'IR','FGC 1782',NULL,'2011yCatp016004901K',2011,1,0.96,NULL,'G',NULL,NULL,'16.5',0.1,'Sc',NULL,NULL,NULL,NULL,1,219.059875,73.50603,0.017,NULL,57881721806,904401903,14131279,16.5),(122387,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122387,36.26,NULL,179,54607,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1782',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122388,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122388,36.28,NULL,180,54607,NULL,NULL,'Dipole + Quadrupole','FGC 1782',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122389,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122389,36.28,NULL,181,54607,NULL,NULL,NULL,'FGC 1782',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122390,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122390,36.31,NULL,183,54607,NULL,NULL,'Dipole','FGC 1782',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122391,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122391,37.21,0.33,277,54608,70,NULL,NULL,'2MASX J14361504+2807529',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,219.062583333,28.13142,0.023,NULL,60025688741,937901386,14654709,NULL),(122392,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122392,37.57,0.46,326,54609,70,NULL,NULL,'SDSS J143615.06+524911.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,219.062833,52.81972,0.005,NULL,59205380061,925084063,14454438,17.6),(122393,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122393,38.01,0.46,400,54610,70,NULL,NULL,'2MASX J14361539+1337540',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,219.064041667,13.63167,0,NULL,59545705977,930401655,14537525,17.6),(122394,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122394,35.37,0.46,119,54611,70,NULL,NULL,'NGC 5685',NULL,'2015arXiv151105856S',2015,1,0.93,NULL,'G',0.000097,NULL,'14.3g',0.8,'E:',NULL,NULL,NULL,NULL,1,219.064041667,29.90839,0,NULL,60018055332,937782114,14652845,14.3),(122395,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122395,37.81,0.46,365,54612,70,NULL,NULL,'SDSS J143615.50+364141.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'18.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,219.064583,36.69489,0,NULL,60077616974,938712765,14667386,18),(122396,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122396,37.51,0.46,317,54613,70,NULL,NULL,'2MASX J14361608+4623579',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000138,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.0669583,46.39936,0.009,NULL,59954293297,936785832,14637278,17.7),(122397,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122397,38.16,0.33,428,54614,70,NULL,NULL,'2MASX J14361622+3935513',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000179,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.0675417,39.59781,0.007,NULL,60076166021,938690094,14667032,17.4),(122398,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122398,37.88,0.46,376,54615,70,NULL,NULL,'2MASX J14361645+1636270',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,219.0685417,16.60758,0,NULL,59552414396,930506474,14539163,17.4),(122399,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122399,37.12,0.46,266,54616,70,NULL,NULL,'2MASX J14361666+4947173',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,219.0694583,49.78831,0.045,NULL,59202170007,925033906,14453654,17),(122400,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122400,37.94,0.11,387,54617,70,NULL,NULL,'2MASX J14361669+2426449',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000146,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,219.069666667,24.44581,0.095,NULL,59499110233,929673597,14526149,17.5),(122401,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122401,38.36,0.33,470,54618,70,NULL,NULL,'SDSS J143617.35+045403.3',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000083,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,219.0722917,4.90094,0.065,NULL,58312587867,911134185,14236471,18.8),(122402,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122402,38.36,0.33,470,54619,70,NULL,NULL,'2MASX J14361750+0457067',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000085,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,219.073041667,4.95178,0.065,NULL,58312575814,911133997,14236468,17.2),(122403,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122403,38.01,0.46,400,54620,70,NULL,NULL,'2MASX J14361853+3624323',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,219.077083,36.40892,0,NULL,60077423509,938709742,14667339,17.1),(122404,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122404,36.79,0.27,229,54621,70,NULL,NULL,'2MASX J14361902+0536387',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000183,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,219.079125,5.61072,0.065,NULL,58310945125,911108517,14236070,16.6),(122405,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122405,38.08,0.33,413,54622,70,NULL,NULL,'SDSS J143620.06-010748.8',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.0001,NULL,'16.5g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,219.083583,-1.13025,0.097,NULL,43546296539,680410883,10631420,16.5),(122406,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122406,37.85,0.46,371,54623,70,NULL,NULL,'2MASX J14362031+1557480',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,219.084625,15.96317,0,NULL,59552645680,930510088,14539220,17.1),(122407,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122407,35.6,0.46,132,54624,70,NULL,NULL,'UGC 09400',NULL,'2015arXiv151105856S',2015,1,0.99,NULL,'G',0.000187,NULL,'14.3g',0.81,'S0',NULL,NULL,NULL,NULL,1,219.0849583,5.33097,0.065,NULL,58312491145,911132674,14236448,14.3),(122408,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122408,37.56,0.33,325,54625,70,NULL,NULL,'2MASX J14362177+0718492',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'18.14',0.2,NULL,NULL,NULL,NULL,NULL,1,219.090666667,7.31369,0.045,NULL,58279415062,910615860,14228372,18.14),(122409,'AGN time lag','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122409,35.16,0.19,108,54626,NULL,NULL,NULL,'UGC 09412',NULL,'2014ApJ...784L..11Y',2014,1,0.6,NULL,'G',0.000117,NULL,'14.6r',0.6,'SBc            Sy1.5',NULL,NULL,NULL,'Sy 1.5',1,219.0919583,58.79428,0.005,NULL,57723055678,901922744,14092542,14.6),(122410,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122410,37.66,0.46,341,54627,70,NULL,NULL,'2MASX J14362329+4405424',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00018,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.096916667,44.09511,0.031,NULL,59956555677,936821182,14637830,17.1),(122411,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122411,36.54,0.19,204,54628,70,NULL,NULL,'SBS 1435+606',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000183,NULL,'15.3g',0.49,'BrClG',NULL,NULL,NULL,NULL,1,219.097875,60.47128,0.009,NULL,57770517574,902664337,14104130,15.3),(122412,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122412,37.35,0.46,295,54629,70,NULL,NULL,'2MASX J14362469+1023032',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.102875,10.38419,0.009,NULL,59359327920,927489498,14492023,17.9),(122413,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122413,38.48,0.46,498,54630,70,NULL,NULL,'2MASX J14362472+5655209',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000149,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,219.103166667,56.92253,0.017,NULL,57250779788,894543434,13977241,18.2),(122414,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122414,37.39,0.33,300,54631,70,NULL,NULL,'2MASX J14362508+1650520',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.73',0.19,NULL,NULL,NULL,NULL,NULL,1,219.1045,16.84789,0,NULL,59481832252,929403628,14521931,17.73),(122415,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122415,37.96,0.33,391,54632,70,NULL,NULL,'2MASX J14362569+4504254',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,219.1070417,45.07378,0.024,NULL,59957529492,936836398,14638068,17.6),(122416,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122416,36.52,0.46,201,54633,70,NULL,NULL,'2MASX J14362765+1708200',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.89',0.17,NULL,NULL,NULL,NULL,NULL,1,219.11525,17.13906,0,NULL,59482842065,929419407,14522178,17.89),(122417,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122417,37.23,0.46,279,54634,70,NULL,NULL,'2MASX J14362852+5518169',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.4g',0.18,NULL,'Group non-member, foreground',NULL,NULL,NULL,1,219.118708333,55.30461,0,NULL,57257896905,894654639,13978978,17.4),(122418,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122418,37.95,0.46,389,54635,70,NULL,NULL,'SDSS J143628.96+461534.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00015,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,219.120708333,46.25964,0.009,NULL,59954272214,936785503,14637273,18.6),(122419,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122419,37.21,0.33,277,54636,70,NULL,NULL,'2MASX J14362975+2803408',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.82',0.21,NULL,NULL,NULL,NULL,NULL,1,219.123791667,28.06122,0.023,NULL,60025514707,937898667,14654666,17.82),(122420,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122420,36.79,0.27,229,54637,70,NULL,NULL,'2MASX J14362974+0534468',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000173,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,219.1239583,5.57967,0.065,NULL,58312987370,911140427,14236569,16.4),(122421,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122421,38.45,0.27,489,54638,70,NULL,NULL,'2MASX J14363181+1924190',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,219.132667,19.40522,0.033,NULL,59509615447,929837741,14528714,18.3),(122422,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122422,37.54,0.46,321,54639,70,NULL,NULL,'2MASX J14363273+1700468',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.54',0.15,NULL,NULL,NULL,NULL,NULL,1,219.136417,17.013,0,NULL,59481838688,929403729,14521933,18.54),(122423,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122423,36.96,0.33,246,54640,70,NULL,NULL,'2MASX J14363301+0040347',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000104,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,219.137416667,0.67636,0.097,NULL,58305197945,911018717,14234667,16.3),(122424,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122424,37.45,0.46,309,54641,70,NULL,NULL,'2MASX J14363301+0025577',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000072,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,219.137625,0.43286,0.093,NULL,58305235645,911019306,14234676,16.9),(122425,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122425,36.85,0.46,234,54642,70,NULL,NULL,'2MASX J14363325+2030580',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.45',0.22,NULL,NULL,NULL,NULL,NULL,1,219.1385,20.51622,0.034,NULL,59510415592,929850243,14528910,17.45),(122426,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122426,35.84,0.46,147,54643,70,NULL,NULL,'2MASX J14363339+2004420',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.40',0.21,NULL,NULL,NULL,NULL,NULL,1,219.139083333,20.07833,0.007,NULL,59509072370,929829255,14528582,17.4),(122427,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122427,36.79,0.27,229,54644,70,NULL,NULL,'2MASX J14363430+0530037',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.26',0.3,NULL,NULL,NULL,NULL,NULL,1,219.143,5.50111,0.065,NULL,58312958470,911139976,14236562,17.26),(122428,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122428,35.78,0.2,143,54645,74.4,NULL,NULL,'CGCG 075-091',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000133,NULL,'15.5g',0.45,NULL,NULL,NULL,NULL,NULL,1,219.14675,11.93842,0,NULL,59360349392,927505459,14492272,15.5),(122429,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122429,31.34,NULL,18.6,54646,NULL,NULL,NULL,'FGC 1775',NULL,'2000BSAO...50....5K',2000,1,0.72,NULL,'G',0.000033,NULL,'17.1',0.1,'Sm',NULL,NULL,NULL,NULL,1,219.147666667,49.41772,0.077,NULL,59202298523,925035914,14453686,17.1),(122430,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122430,31.81,NULL,23,54646,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1775',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122431,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122431,31.85,NULL,23.4,54646,NULL,NULL,'Dipole + Quadrupole','FGC 1775',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122432,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122432,31.91,NULL,24.1,54646,NULL,NULL,'Dipole','FGC 1775',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122433,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122433,37.38,0.46,300,54647,70,NULL,NULL,'2MASX J14363543+3043429',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000176,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.147666667,30.72856,0,NULL,60020005816,937812590,14653321,17.6),(122434,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122434,37.18,0.23,272,54648,70,NULL,NULL,'SDSS J143635.47+095416.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,219.1477917,9.90456,0.029,NULL,59373338117,927708408,14495443,17.7),(122435,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122435,34.49,0.55,79.2,54649,NULL,NULL,NULL,'ESO 447- G 027',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.48',0.2,'Sb:',NULL,NULL,NULL,NULL,1,219.150083333,-29.05672,0.469,NULL,47020893475,734701460,11479710,16.48),(122436,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122436,34.53,0.2,80.5,54649,74.4,NULL,NULL,'ESO 447- G 027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122437,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122437,34.54,0.49,80.9,54649,75,NULL,'IR','ESO 447- G 027',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122438,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122438,34.55,0.53,81.2,54649,NULL,NULL,'Malmquist cor.','ESO 447- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122439,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122439,38.45,0.27,489,54650,70,NULL,NULL,'2MASX J14363604+1912030',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,219.150083333,19.20075,0.036,NULL,59509814950,929840858,14528763,18.2),(122440,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122440,37.08,0.27,261,54651,70,NULL,NULL,'2MASX J14363973+5749118',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000189,NULL,'16.0g',0.43,'E0',NULL,NULL,NULL,NULL,1,219.165583,57.82014,0,NULL,57250447271,894538238,13977159,16),(122441,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122441,36.98,0.46,249,54652,70,NULL,NULL,'2MASX J14363985+0640312',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,219.165958333,6.67542,0.053,NULL,58279317694,910614338,14228349,17.2),(122442,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122442,36.54,0.19,204,54653,70,NULL,NULL,'2MASX J14363995+6025016',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000089,NULL,'15.8g',0.38,'S0/a',NULL,NULL,NULL,NULL,1,219.1664583,60.41708,0.009,NULL,57770523483,902664429,14104131,15.8),(122443,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122443,37.78,0.33,359,54654,70,NULL,NULL,'2MASX J14364065+2643358',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,219.169375,26.72672,0.036,NULL,60021857611,937841525,14653773,17.9),(122444,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122444,36.54,0.19,204,54655,70,NULL,NULL,'2MASX J14364124+6039395',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000212,NULL,'16.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,219.171791667,60.66092,0.009,NULL,57752976106,902390251,14099847,16.3),(122445,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122445,37.61,0.46,333,54656,70,NULL,NULL,'2MASX J14364119+1616559',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,219.171833,16.28236,0,NULL,59552669531,930510461,14539225,17.9),(122446,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122446,37.96,0.33,391,54657,70,NULL,NULL,'2MASX J14364202+4508175',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000204,NULL,'16.1g',0.36,'BrClG',NULL,NULL,NULL,NULL,1,219.175083333,45.13825,0.024,NULL,59957526674,936836354,14638068,16.1),(122447,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122447,37.08,0.27,261,54658,70,NULL,NULL,'2MASX J14364215+5753158',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000179,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,219.17575,57.88772,0,NULL,57250439839,894538122,13977158,17),(122448,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122448,38.49,0.46,499,54659,70,NULL,NULL,'SDSS J143642.23+171634.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.175958333,17.27617,0,NULL,59482840579,929419384,14522177,17.9),(122449,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122449,34.93,0.46,96.6,54660,70,NULL,NULL,'CGCG 220-034',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00009,NULL,'15.0g',0.46,'E1',NULL,NULL,NULL,NULL,1,219.177667,39.94356,0,NULL,60076069084,938688579,14667009,15),(122450,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122450,36.47,0.33,197,54661,70,NULL,NULL,'2MASX J14364273+3418379',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00018,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,219.1779583,34.31044,0,NULL,60067306757,938551668,14664869,16.4),(122451,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122451,38.29,0.46,455,54662,70,NULL,NULL,'SDSS J143645.69+223517.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,219.190417,22.58808,0.054,NULL,59505613793,929775215,14527737,18.4),(122452,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122452,37.78,0.46,359,54663,70,NULL,NULL,'SDSS J143645.76+203501.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.9g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.190708333,20.58381,0.034,NULL,59502794271,929731160,14527049,17.9),(122453,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122453,33.85,0.55,59,54664,NULL,NULL,NULL,'ESO 447- G 028',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000033,NULL,'15.48',0.5,'Sb',NULL,NULL,NULL,NULL,1,219.191333333,-27.84611,0.493,NULL,47023036297,734734942,11480233,15.48),(122454,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122454,33.9,0.2,60.3,54664,74.4,NULL,NULL,'ESO 447- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122455,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122455,33.96,0.53,61.9,54664,NULL,NULL,'Malmquist cor.','ESO 447- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122456,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122456,38.45,0.27,489,54665,70,NULL,NULL,'SDSS J143646.05+190857.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'19.25',0.1,NULL,NULL,NULL,NULL,NULL,1,219.191916667,19.14931,0.06,NULL,59509815685,929840870,14528763,19.25),(122457,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122457,37.6,0.46,331,54666,70,NULL,NULL,'2MASX J14364653+2136241',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.67',0.15,NULL,NULL,NULL,NULL,NULL,1,219.193917,21.60686,0.026,NULL,59503367265,929740113,14527189,18.67),(122458,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122458,36.96,0.33,246,54667,70,NULL,NULL,'2MASX J14364683+0043113',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000114,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,219.195,0.71983,0.101,NULL,58305217162,911019018,14234672,16.4),(122459,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122459,37.78,0.33,359,54668,70,NULL,NULL,'SDSS J143647.49+264313.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.2g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.197875,26.72047,0.036,NULL,60021838225,937841222,14653769,18.2),(122460,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122460,38.11,0.46,419,54669,70,NULL,NULL,'SDSS J143647.59+170407.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.198333,17.06872,0,NULL,59481800138,929403127,14521923,18.5),(122461,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122461,35.95,0.46,155,54670,70,NULL,NULL,'2MASX J14364762+5556105',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000179,NULL,'15.7g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,219.1984583,55.93628,0,NULL,57259830631,894684853,13979450,15.7),(122462,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122462,36.21,0.75,174,54671,70,NULL,NULL,'2MASX J14364777-0540132',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.88',0.29,NULL,NULL,NULL,NULL,NULL,1,219.199,-5.67039,0.161,NULL,43544626760,680384793,10631012,16.88),(122463,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122463,36.94,0.46,245,54672,70,NULL,NULL,'2MASX J14364777-0155532',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000181,NULL,'17.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.199125,-1.93128,0.125,NULL,43548847802,680450746,10632042,17),(122464,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122464,37.32,0.46,292,54673,70,NULL,NULL,'SDSS J143648.31+445333.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,219.201333,44.89261,0,NULL,59957507995,936836062,14638063,18),(122465,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122465,37.59,0.46,330,54674,70,NULL,NULL,'LCRS B143413.4-022516',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,219.203916667,-2.63786,0.169,NULL,43548053201,680438331,10631848,17.9),(122466,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122466,37.92,0.46,384,54675,70,NULL,NULL,'2MASX J14364896+4437205',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000191,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,219.203916667,44.62228,0.02,NULL,59956651692,936822682,14637854,17.1),(122467,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122467,36.54,0.19,204,54676,70,NULL,NULL,'2MASX J14364892+6031305',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000087,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.204167,60.52517,0.009,NULL,57770561980,902665030,14104141,17.7),(122468,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122468,36.49,0.65,199,54677,70,NULL,NULL,'2MASX J14365049-0037192',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.000081,NULL,'16.2g',0.38,'S0/a',NULL,NULL,NULL,NULL,1,219.210375,-0.62211,0.121,NULL,43545476792,680398074,10631219,16.2),(122469,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122469,37.72,0.46,350,54678,70,NULL,NULL,'2MASX J14365065+2740008',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.26',0.16,NULL,NULL,NULL,NULL,NULL,1,219.2110417,27.66703,0.03,NULL,60025057086,937891516,14654554,18.26),(122470,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122470,36.47,0.33,197,54679,70,NULL,NULL,'MCG +06-32-076',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000189,NULL,'15.1g',0.62,'E0',NULL,NULL,NULL,NULL,1,219.211417,34.29269,0,NULL,60067304424,938551631,14664869,15.1),(122471,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122471,37.61,0.46,333,54680,70,NULL,NULL,'SDSS J143650.98+094726.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000145,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,219.212416667,9.79067,0.029,NULL,59373380938,927709077,14495454,18.7),(122472,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122472,38.15,0.46,426,54681,70,NULL,NULL,'2MASXi J1436519+263423',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.216667,26.57303,0.036,NULL,60021847664,937841369,14653771,18),(122473,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122473,38.38,0.46,474,54682,70,NULL,NULL,'2MASX J14365343+2051362',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.77',0.14,NULL,NULL,NULL,NULL,NULL,1,219.2227083,20.86011,0.044,NULL,59503011794,929734559,14527102,18.77),(122474,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122474,37.33,0.46,292,54683,70,NULL,NULL,'2MASX J14365359+0154194',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000071,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,219.2232083,1.90553,0.097,NULL,58308895624,911076494,14235570,17.4),(122475,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122475,35.38,0.46,119,54684,70,NULL,NULL,'CGCG 133-096',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000073,NULL,'15.7',0.5,NULL,NULL,NULL,NULL,NULL,1,219.2232083,21.2975,0.029,NULL,59503505283,929742270,14527222,15.7),(122476,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122476,35.65,0.46,135,54685,70,NULL,NULL,'IC 4467',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000073,NULL,'16.55',0.27,NULL,NULL,NULL,NULL,NULL,1,219.223625,18.37064,0.049,NULL,59480366083,929380720,14521573,16.55),(122477,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122477,37.51,0.46,318,54686,70,NULL,NULL,'2MASX J14365469+2230302',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.26',0.19,NULL,NULL,NULL,NULL,NULL,1,219.227833,22.50839,0.038,NULL,59505630038,929775469,14527741,18.26),(122478,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122478,36.31,0.46,183,54687,70,NULL,NULL,'2MASX J14365627+1609239',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000497,NULL,'17.11',0.22,NULL,NULL,NULL,NULL,NULL,1,219.234375,16.15664,0,NULL,59552670571,930510477,14539226,17.11),(122479,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122479,38.09,0.33,414,54688,70,NULL,NULL,'2MASX J14365651+4517185',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.235417,45.28836,0.024,NULL,59956886446,936826350,14637911,18),(122480,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122480,38.59,0.46,523,54689,70,NULL,NULL,'2MASX J14365649+3038227',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000158,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,219.2355417,30.63981,0,NULL,60020013047,937812703,14653323,18.2),(122481,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122481,37.47,0.46,311,54690,70,NULL,NULL,'2MASX J14365657+0226504',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000072,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,219.235875,2.44744,0.077,NULL,58306912107,911045501,14235085,17.3),(122482,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122482,36.54,0.19,204,54691,70,NULL,NULL,'2MASX J14365661+6028334',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,219.236,60.47581,0.009,NULL,57770518659,902664354,14104130,16.9),(122483,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122483,35.98,0.46,157,54692,70,NULL,NULL,'2MASX J14365688+1213359',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000081,NULL,'16.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,219.2370417,12.22656,0,NULL,59360341373,927505333,14492270,16.1),(122484,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122484,35.53,0.46,128,54693,70,NULL,NULL,'2MASX J14365694+0331064',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000097,NULL,'15.4g',0.48,'S0/a',NULL,NULL,NULL,NULL,1,219.237375,3.51847,0.061,NULL,58314401979,911162530,14236914,15.4),(122485,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122485,34.61,0.4,83.7,54694,NULL,NULL,'mean','NGC 5696',NULL,'2007A&A...465...71T',2007,1,2,NULL,'G',0.000017,NULL,'13.9g',1.5,'Sbc','in a radial-velocity based grouping',NULL,NULL,NULL,1,219.237833333,41.82811,0,NULL,59960468819,936882325,14638786,13.9),(122486,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122486,34.69,0.47,86.9,54694,NULL,NULL,'H','NGC 5696',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122487,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122487,34.72,0.46,87.9,54694,NULL,NULL,'J','NGC 5696',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122488,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122488,34.76,0.45,89.7,54694,NULL,NULL,'K','NGC 5696',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122489,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122489,34.79,0.59,91,54694,NULL,NULL,'Malmquist cor.','NGC 5696',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122490,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122490,34.92,0.2,96.4,54694,74.4,NULL,NULL,'NGC 5696',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122491,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122491,35.06,0.52,103,54694,NULL,NULL,NULL,'NGC 5696',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122492,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122492,38.03,0.46,404,54695,70,NULL,NULL,'2MASX J14365711+5245412',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,219.238208333,52.76164,0.005,NULL,59205848544,925091383,14454552,17.2),(122493,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122493,36.42,0.46,192,54696,70,NULL,NULL,'2MASX J14365757-0123542',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000168,NULL,'16.3g',0.4,NULL,NULL,NULL,NULL,NULL,1,219.24,-1.3985,0.105,NULL,43545971696,680405807,10631340,16.3),(122494,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122494,38.46,0.46,492,54697,70,NULL,NULL,'2MASX J14365770-0104002',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000171,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.240417,-1.06678,0.097,NULL,43546281118,680410642,10631416,17.7),(122495,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122495,35.72,0.46,140,54698,70,NULL,NULL,'2MASX J14370076+5951436',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000085,NULL,'16.1g',0.25,'E0',NULL,NULL,NULL,NULL,1,219.253125,59.86206,0,NULL,57768852678,902638323,14103723,16.1),(122496,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122496,37.94,0.11,387,54699,70,NULL,NULL,'2MASX J14370106+2437017',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.254583,24.61725,0.115,NULL,59499344810,929677262,14526207,17.5),(122497,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122497,37.41,0.33,303,54700,70,NULL,NULL,'2MASX J14370377+4836132',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000173,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,219.2659583,48.60372,0.161,NULL,59198865040,924982266,14452847,16.8),(122498,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122498,37.57,0.46,327,54701,70,NULL,NULL,'2MASX J14370410+0023004',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000078,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,219.267166667,0.38336,0.097,NULL,58305237027,911019328,14234677,17.6),(122499,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122499,37.03,0.46,255,54702,70,NULL,NULL,'2MASX J14370473+0940274',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,219.269875,9.67436,0.025,NULL,59373353515,927708648,14495447,18),(122500,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122500,33.86,0.8,59.1,54703,75,NULL,'HMCL, I','CGCG 133-097',NULL,'1997ApJS..109..333W',1997,1,1.23,NULL,'G',0.000027,NULL,'15.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,219.2715417,24.97811,0.082,NULL,59499228312,929675442,14526178,15.3),(122501,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122501,34.09,0.4,65.8,54703,75,NULL,'HMCL, I, raw','CGCG 133-097',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122502,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122502,34.19,0.4,68.9,54703,75,NULL,'HMCL, I, inv','CGCG 133-097',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122503,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122503,34.28,0.4,71.7,54703,75,NULL,'HMCL, I, cor','CGCG 133-097',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122504,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122504,34.52,0.2,80.2,54703,74.4,NULL,NULL,'CGCG 133-097',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122505,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122505,34.81,0.49,91.6,54703,75,NULL,'IR','CGCG 133-097',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122506,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122506,38.75,0.46,561,54704,70,NULL,NULL,'2MASX J14370542+1005464',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.2725417,10.09636,0.017,NULL,59373124849,927705075,14495391,17.8),(122507,'GRB','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122507,45.42,1.12,4480,54705,72,NULL,NULL,'GRB 050802',1.71,'2008JCAP...07..004M',2008,1,NULL,NULL,'VisS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,219.27425,27.78683,0.024,NULL,60025077628,937891837,14654559,NULL),(122508,'GRB','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122508,45.5,0.66,4650,54705,69.7,NULL,'Fiducial','GRB 050802',1.71,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122509,'GRB','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122509,45.52,0.98,4690,54705,69.7,NULL,'Calibrated','GRB 050802',1.71,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122510,'GRB','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122510,45.59,1.05,4840,54705,70,NULL,NULL,'GRB 050802',1.71,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122511,'GRB','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122511,45.64,1.32,4940,54705,NULL,NULL,NULL,'GRB 050802',1.71,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122512,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122512,37.94,0.11,387,54706,70,NULL,NULL,'SDSS J143705.96+242907.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,219.274875,24.48553,0.115,NULL,59499322615,929676915,14526201,18.4),(122513,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122513,37.96,0.33,391,54707,70,NULL,NULL,'SDSS J143705.98+005318.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000073,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,219.274958333,0.88836,0.101,NULL,58305988478,911031069,14234860,18.3),(122514,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122514,38.23,0.46,443,54708,70,NULL,NULL,'SDSS J143706.03+205738.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.275167,20.96078,0.036,NULL,59502965601,929733837,14527091,18),(122515,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122515,37.38,0.33,299,54709,70,NULL,NULL,'2MASX J14370636+2324242',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000191,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,219.276625,23.40661,0.06,NULL,59505129446,929767647,14527619,16.5),(122516,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122516,37.18,0.23,272,54710,70,NULL,NULL,'2MASX J14370732+1003254',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000191,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,219.280458333,10.05706,0.021,NULL,59373123191,927705049,14495391,16.3),(122517,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122517,37.69,0.23,346,54711,70,NULL,NULL,'2MASX J14370761+2140411',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.08',0.2,NULL,NULL,NULL,NULL,NULL,1,219.281667,21.67806,0.026,NULL,59503407803,929740746,14527199,18.08),(122518,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122518,37.55,0.33,323,54712,70,NULL,NULL,'2MASX J14370762+5622426',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,219.282,56.37839,0,NULL,57259388203,894677940,13979342,18.2),(122519,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122519,36.65,0.46,214,54713,70,NULL,NULL,'2MASX J14370813+0548464',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000173,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,219.284,5.81292,0.065,NULL,58312936343,911139630,14236556,16.5),(122520,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122520,37.36,0.46,296,54714,70,NULL,NULL,'2MASX J14370881+4201056',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.286583,42.01822,0.009,NULL,59961116071,936892438,14638944,17.9),(122521,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122521,37.62,0.46,334,54715,70,NULL,NULL,'2MASX J14370953+4604517',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,219.289875,46.08094,0.009,NULL,59954002159,936781283,14637207,17.4),(122522,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122522,37.71,0.46,349,54716,70,NULL,NULL,'SDSS J143709.68+451808.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000136,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,219.290375,45.30247,0.024,NULL,59956878211,936826222,14637909,18.3),(122523,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122523,37.94,0.11,387,54717,70,NULL,NULL,'2MASX J14371014+2448398',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00067,NULL,'17.75',0.1,NULL,NULL,NULL,NULL,NULL,1,219.29225,24.81117,0.082,NULL,59499260053,929675938,14526186,17.75),(122524,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122524,38.23,0.46,442,54718,70,NULL,NULL,'2MASX J14371012+5318242',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000149,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,219.292375,53.30681,0,NULL,59205337751,925083402,14454428,17.1),(122525,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122525,37.8,0.46,363,54719,70,NULL,NULL,'2MASXi J1437106+282038',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.49',0.13,NULL,NULL,NULL,NULL,NULL,1,219.294375,28.34411,0.016,NULL,60025374417,937896475,14654632,18.49),(122526,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122526,37.96,0.33,391,54720,70,NULL,NULL,'2MASX J14371129+0049444',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000077,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,219.296958333,0.829,0.105,NULL,58305976309,911030879,14234857,17.1),(122527,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122527,38.04,0.46,406,54721,70,NULL,NULL,'2MASX J14371144+1942341',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.297583,19.7095,0.017,NULL,59509256301,929832129,14528627,17.7),(122528,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122528,37.69,0.23,346,54722,70,NULL,NULL,'2MASX J14371295+2141492',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.50',0.14,NULL,NULL,NULL,NULL,NULL,1,219.304083333,21.69706,0.026,NULL,59503400390,929740631,14527197,18.5),(122529,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122529,38.77,0.46,567,54723,70,NULL,NULL,'2MASX J14371320+2916438',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000198,NULL,'17.1g',0.25,'S0',NULL,NULL,NULL,NULL,1,219.305083,29.27903,0,NULL,60017818805,937778418,14652787,17.1),(122530,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122530,33.49,0.2,49.9,54724,74.4,NULL,NULL,'UGC 09422',NULL,'2013AJ....146...86T',2013,1,2.69,NULL,'G',0.000023,NULL,'14.8g',0.27,'Scd',NULL,NULL,NULL,NULL,1,219.306583,43.69594,0.031,NULL,59957892531,936842070,14638157,14.8),(122531,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122531,33.5,0.52,50.1,54724,NULL,NULL,NULL,'UGC 09422',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122532,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122532,33.5,0.49,50.2,54724,75,NULL,'IR','UGC 09422',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122533,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122533,33.6,0.5,52.5,54724,NULL,NULL,'Malmquist cor.','UGC 09422',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122534,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122534,33.77,NULL,56.8,54724,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09422',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122535,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122535,33.79,NULL,57.4,54724,NULL,NULL,'Dipole + Quadrupole','UGC 09422',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122536,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122536,33.8,NULL,57.7,54724,NULL,NULL,'Dipole','UGC 09422',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122537,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122537,35.35,0.2,117,54725,74.4,NULL,NULL,'UGC 09410',NULL,'2013AJ....146...86T',2013,1,1.04,NULL,'G',0.000063,NULL,'15.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,219.307917,8.64603,0.025,NULL,59365042743,927578792,14493418,15.4),(122538,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122538,37.94,0.11,387,54726,70,NULL,NULL,'2MASX J14371395+2456288',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.86',0.19,NULL,NULL,NULL,NULL,NULL,1,219.3082083,24.94136,0.082,NULL,59499225795,929675403,14526178,17.86),(122539,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122539,38.61,0.46,527,54727,70,NULL,NULL,'SDSS J143714.18+391624.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000153,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,219.309125,39.27356,0,NULL,60076150464,938689851,14667028,18.5),(122540,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122540,38.71,0.46,553,54728,70,NULL,NULL,'2MASX J14371443+2536078',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.310083,25.60214,0.034,NULL,60022531078,937852048,14653938,18.2),(122541,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SN 2005bc',NULL,122541,33.95,0.22,61,54729,70,NULL,'SALT 2','NGC 5698',0.012272,'2013MNRAS.433.2240G',2013,1,2.07,NULL,'G',0.00002,NULL,'13.6g',0.78,'SBb            HII','Field galaxy',NULL,NULL,NULL,1,219.31125,38.45428,0.013,NULL,60076398861,938693732,14667089,13.6),(122542,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122542,32.74,0.69,35.3,54729,100,NULL,'mid-IR','NGC 5698',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122543,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122543,32.97,0.43,39.2,54729,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5698',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122544,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122544,33.52,0.47,50.6,54729,NULL,NULL,'H','NGC 5698',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122545,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122545,33.6,0.45,52.6,54729,NULL,NULL,'K','NGC 5698',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122546,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122546,33.61,0.46,52.7,54729,NULL,NULL,'J','NGC 5698',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122547,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122547,33.65,0.4,53.7,54729,NULL,NULL,'mean','NGC 5698',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122548,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122548,37.94,0.11,387,54730,70,NULL,NULL,'2MASX J14371499+2445318',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000177,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,219.3125417,24.75894,0.091,NULL,59499259260,929675925,14526186,17.2),(122549,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122549,35.33,0.8,117,54731,75,NULL,'CF, r','CGCG 075-092',NULL,'1997ApJS..109..333W',1997,1,NULL,NULL,'GPair',NULL,NULL,NULL,NULL,'Sbc',NULL,NULL,NULL,NULL,1,219.312917,8.65333,0.025,NULL,59365041412,927578772,14493418,NULL),(122550,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122550,34.93,0.38,97,54731,75,NULL,'CF, r, raw','CGCG 075-092',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122551,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122551,35.01,0.38,101,54731,75,NULL,'CF, r, inv','CGCG 075-092',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122552,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122552,35.21,0.38,110,54731,75,NULL,'CF, r, cor','CGCG 075-092',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122553,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122553,35.26,0.36,113,54731,NULL,NULL,'Malmquist cor.','CGCG 075-092',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122554,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122554,35.31,0.36,115,54731,NULL,NULL,NULL,'CGCG 075-092',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122555,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122555,38.4,0.46,479,54732,70,NULL,NULL,'SDSS J143715.35+145648.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.3139583,14.94683,0,NULL,59557012222,930578315,14540286,18.4),(122556,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122556,36.14,0.46,169,54733,70,NULL,NULL,'2MASX J14371570+0812334',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000107,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,219.315625,8.20922,0.025,NULL,59364497254,927570269,14493285,16.5),(122557,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122557,37.41,0.33,303,54734,70,NULL,NULL,'2MASX J14371597+4836381',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.316708333,48.61069,0.161,NULL,59198858603,924982165,14452846,18),(122558,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122558,37.98,0.46,395,54735,70,NULL,NULL,'2MASX J14371621-0005589',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000083,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,219.317458333,-0.09981,0.121,NULL,43545278681,680394979,10631171,17.7),(122559,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122559,38.23,0.46,443,54736,70,NULL,NULL,'2MASX J14371648+0010384',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000085,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,219.318583,0.17731,0.093,NULL,58305030323,911016098,14234626,17.1),(122560,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122560,37.94,0.11,387,54737,70,NULL,NULL,'2MASX J14371682+2452098',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000204,NULL,'15.2',0.5,NULL,NULL,NULL,NULL,NULL,1,219.320083,24.86922,0.082,NULL,59499255344,929675864,14526185,15.2),(122561,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122561,37.52,0.46,320,54738,70,NULL,NULL,'2MASX J14371754+1638578',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.68',0.14,NULL,NULL,NULL,NULL,NULL,1,219.3232083,16.64953,0,NULL,59552548693,930508573,14539196,18.68),(122562,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122562,35.65,0.46,135,54739,70,NULL,NULL,'VIII Zw 440',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000088,NULL,'15.8g',0.36,'S0',NULL,NULL,NULL,NULL,1,219.32325,1.20372,0.101,NULL,58305494266,911023347,14234739,15.8),(122563,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122563,34.58,0.5,82.4,54740,70,NULL,NULL,'ESO 385- G 049',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000093,NULL,'15.09',0.3,'S0',NULL,NULL,NULL,NULL,1,219.33075,-36.12706,0.189,NULL,47220813212,737825206,11528518,15.09),(122564,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122564,33.9,0.49,60.1,54741,75,NULL,'IR','IC 4469',NULL,'2011yCatp016004901K',2011,1,1.99,NULL,'G',0.000006,NULL,'15.58',0.17,'Scd',NULL,NULL,NULL,NULL,1,219.335375,18.24933,0.019,NULL,59480468605,929382321,14521598,15.58),(122565,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122565,34.29,NULL,72.1,54741,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 4469',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122566,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122566,34.3,NULL,72.4,54741,NULL,NULL,'Dipole','IC 4469',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122567,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122567,34.3,NULL,72.4,54741,NULL,NULL,'Dipole + Quadrupole','IC 4469',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122568,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122568,34.36,NULL,74.4,54741,NULL,NULL,NULL,'IC 4469',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122569,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122569,34.38,0.43,75.3,54741,NULL,NULL,'Malmquist cor.','IC 4469',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122570,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122570,34.41,0.2,76.2,54741,74.4,NULL,NULL,'IC 4469',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122571,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122571,34.46,0.41,78.1,54741,NULL,NULL,NULL,'IC 4469',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122572,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122572,37.55,0.33,323,54742,70,NULL,NULL,'2MASX J14372087+5623116',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.337167,56.38653,0,NULL,57259388511,894677945,13979342,17.6),(122573,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122573,37.38,0.33,299,54743,70,NULL,NULL,'2MASX J14372098+2323112',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00018,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,219.337541667,23.3865,0.06,NULL,59505124885,929767576,14527618,16.5),(122574,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122574,37.53,0.33,321,54744,70,NULL,NULL,'2MASX J14372109+1916372',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.98',0.19,NULL,NULL,NULL,NULL,NULL,1,219.337875,19.27694,0.057,NULL,59509831220,929841112,14528767,17.98),(122575,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122575,33.54,0.45,51,54745,NULL,NULL,'K','NGC 5695',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00003,NULL,'13.4g',0.93,'SBb            Sy2','in a radial-velocity based grouping',NULL,NULL,'Sy 2',1,219.342167,36.56781,0,NULL,60077436223,938709940,14667342,13.4),(122576,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122576,33.56,0.47,51.6,54745,NULL,NULL,'H','NGC 5695',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122577,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122577,33.57,0.46,51.7,54745,NULL,NULL,'J','NGC 5695',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122578,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122578,33.88,0.4,59.8,54745,NULL,NULL,'mean','NGC 5695',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122579,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122579,36.31,0.27,183,54746,70,NULL,NULL,'2MASX J14372295+0803487',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000188,NULL,'15.9g',0.39,NULL,NULL,NULL,NULL,NULL,1,219.345625,8.06353,0.025,NULL,59364560818,927571262,14493300,15.9),(122580,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122580,37.94,0.11,387,54747,70,NULL,NULL,'2MASX J14372365+2452128',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000177,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,219.3487083,24.87028,0.082,NULL,59499257619,929675900,14526185,17.3),(122581,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122581,37.6,0.33,331,54748,70,NULL,NULL,'2MASX J14372400+2405418',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.349875,24.09489,0.095,NULL,59499057559,929672774,14526137,17.9),(122582,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122582,37.69,0.23,346,54749,70,NULL,NULL,'SDSS J143724.53+213754.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.35225,21.63194,0.026,NULL,59503383612,929740368,14527193,18.4),(122583,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122583,37.94,0.33,386,54750,70,NULL,NULL,'SDSS J143724.93+310536.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.353917,31.09344,0,NULL,60016816194,937762753,14652543,18.1),(122584,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122584,36.75,0.46,224,54751,70,NULL,NULL,'2MASX J14372598+1926142',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,219.358333,19.43719,0.033,NULL,59509786828,929840419,14528756,16.8),(122585,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122585,35.12,0.46,106,54752,70,NULL,NULL,'2MASX J14372624+3857328',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000165,NULL,'16.0g',0.3,'S0^-',NULL,NULL,NULL,NULL,1,219.359416667,38.959,0.021,NULL,60077107910,938704811,14667262,16),(122586,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122586,37.6,0.33,331,54753,70,NULL,NULL,'2MASX J14372714+2412468',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.68',0.23,NULL,NULL,NULL,NULL,NULL,1,219.363,24.21286,0.095,NULL,59498912880,929670513,14526101,17.68),(122587,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122587,36.26,0.46,179,54754,70,NULL,NULL,'VIII Zw 441',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000071,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,219.363833,4.60947,0.085,NULL,58312464521,911132258,14236441,16.8),(122588,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122588,37.94,0.33,386,54755,70,NULL,NULL,'2MASX J14372800+3106561',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,219.366708333,31.1155,0,NULL,60016814202,937762721,14652542,17.5),(122589,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122589,37.53,0.33,321,54756,70,NULL,NULL,'2MASX J14372829+1912212',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.40',0.15,NULL,NULL,NULL,NULL,NULL,1,219.3679583,19.20583,0.057,NULL,59509778505,929840289,14528754,18.4),(122590,'L(H{beta})-{sigma}','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122590,46.05,NULL,1605,54757,74.3,NULL,NULL,'WISP 064_0210',2.177,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,219.368083,-1.83178,0.133,NULL,43548900137,680451564,10632055,NULL),(122591,'Tully est','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122591,32.83,0.8,36.9,54758,75,NULL,NULL,'UGC 09426',NULL,'1988NBGC.C....0000T',1988,1,0.71,NULL,'G',0.000017,NULL,'16.3g',0.41,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,219.371417,48.62375,0.137,NULL,59198826974,924981671,14452838,16.3),(122592,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122592,37.18,0.23,272,54759,70,NULL,NULL,'2MASX J14372974+0958317',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000179,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,219.3739583,9.97556,0.021,NULL,59373085821,927704465,14495382,17.3),(122593,'L(H{beta})-{sigma}','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122593,45.24,NULL,1642,54760,74.3,NULL,NULL,'WISP 064_2056',1.61,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,219.375833,-1.84761,0.133,NULL,43548899942,680451561,10632055,NULL),(122594,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122594,37.7,0.46,347,54761,70,NULL,NULL,'2MASX J14373023+3021321',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000175,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,219.375875,30.35903,0,NULL,60020219851,937815935,14653373,16.7),(122595,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122595,37.78,0.46,360,54762,70,NULL,NULL,'2MASX J14373049+1000468',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.377083,10.01292,0.017,NULL,59373092583,927704571,14495383,17.6),(122596,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122596,32.99,0.2,39.6,54763,74.4,NULL,NULL,'NGC 5707',NULL,'2013AJ....146...86T',2013,1,2.5,NULL,'G',0.00001,NULL,'13.1g',0.61,'Sab: sp','Line-of-sight pair member',NULL,NULL,NULL,1,219.3782083,51.56186,0.009,NULL,59204348144,925067939,14454186,13.1),(122597,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122597,33.14,0.43,42.5,54763,75,NULL,'3.6 micron, color corrected','NGC 5707',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122598,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122598,33.42,0.43,48.4,54763,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5707',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122599,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122599,36.85,0.46,234,54764,70,NULL,NULL,'2MASX J14373083-0157509',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00015,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,219.3784583,-1.96419,0.133,NULL,43548821814,680450340,10632036,16.7),(122600,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122600,37.94,0.11,387,54765,70,NULL,NULL,'2MASX J14373113+2446522',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.379625,24.78111,0.091,NULL,59499263263,929675988,14526187,18),(122601,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122601,38.17,0.46,430,54766,70,NULL,NULL,'2MASX J14373139+4541177',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,219.380875,45.68831,0.021,NULL,59954068205,936782315,14637223,17.7),(122602,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122602,37.84,0.33,370,54767,70,NULL,NULL,'2MASX J14373209+2922322',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00019,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,219.383625,29.37564,0,NULL,60017696559,937776508,14652757,17.2),(122603,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122603,37.17,0.46,271,54768,70,NULL,NULL,'2MASX J14373271+1643248',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.386333333,16.72361,0,NULL,59552518350,930508099,14539189,17.1),(122604,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122604,37.94,0.11,387,54769,70,NULL,NULL,'2MASX J14373281+2450362',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000176,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,219.386833,24.84331,0.091,NULL,59499256686,929675885,14526185,17.2),(122605,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122605,36.31,0.27,183,54770,70,NULL,NULL,'2MASX J14373292+0804427',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000171,NULL,'16.0g',0.34,'SF',NULL,NULL,NULL,NULL,1,219.387291667,8.07861,0.025,NULL,59364572213,927571440,14493303,16),(122606,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122606,37.23,0.46,280,54771,70,NULL,NULL,'2MASX J14373312+2330052',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000139,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,219.388167,23.50153,0.056,NULL,59508012913,929812701,14528323,17.3),(122607,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122607,37.69,0.23,346,54772,70,NULL,NULL,'2MASX J14373325+2141222',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,219.3885,21.68958,0.026,NULL,59503382818,929740356,14527193,17.4),(122608,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122608,36.21,0.46,175,54773,70,NULL,NULL,'2MASX J14373353+6112171',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000146,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,219.389791667,61.20475,0.025,NULL,57753302268,902395347,14099927,16.4),(122609,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122609,37.94,0.11,387,54774,70,NULL,NULL,'SDSS J143734.80+245258.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.395041667,24.883,0.082,NULL,59498391042,929662360,14525974,18.2),(122610,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122610,38.09,0.33,414,54775,70,NULL,NULL,'SDSS J143735.04+452743.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000147,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,219.3960417,45.46208,0.061,NULL,59956897492,936826523,14637914,18.4),(122611,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122611,37.26,0.46,283,54776,70,NULL,NULL,'2MASX J14373591+2736022',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,219.3994583,27.60064,0.025,NULL,60028511318,937945489,14655398,18.1),(122612,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122612,34.53,0.46,80.4,54777,70,NULL,NULL,'2MASX J14373754+0520474',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000163,NULL,'15.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,219.406417,5.34667,0.065,NULL,58313245631,911144462,14236632,15.6),(122613,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122613,37.94,0.11,387,54778,70,NULL,NULL,'2MASX J14373788+2447262',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000156,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,219.407917,24.79061,0.091,NULL,59499251184,929675799,14526184,17),(122614,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122614,38.47,0.46,495,54779,70,NULL,NULL,'SDSS J143737.94+603808.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000082,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.408125,60.63567,0.009,NULL,57770543649,902664744,14104136,17.8),(122615,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122615,37.85,0.46,372,54780,70,NULL,NULL,'2MASX J14373834+4740186',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000146,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,219.409833,47.672,0.021,NULL,59932663263,936447863,14631997,17.1),(122616,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122616,36.94,0.46,245,54781,70,NULL,NULL,'2MASX J14373977+2315031',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000138,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,219.415667,23.251,0.06,NULL,59505154836,929768044,14527625,17.7),(122617,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122617,37.72,0.46,350,54782,70,NULL,NULL,'2MASX J14374062+1838151',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.87',0.19,NULL,NULL,NULL,NULL,NULL,1,219.41925,18.6375,0.043,NULL,59479505830,929367278,14521363,17.87),(122618,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122618,32.2,0.8,27.6,54783,75,NULL,'A82, H','NGC 5690',NULL,'1997ApJS..109..333W',1997,1,2.35,NULL,'G',0.000013,NULL,'12.7g',0.96,'Sc? sp         HII','Isolated galaxy',NULL,NULL,NULL,1,219.421125,2.29083,0.117,NULL,58306757841,911043091,14235048,12.7),(122619,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122619,30.97,0.4,15.6,54783,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5690',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122620,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122620,31.24,0.47,17.7,54783,75,NULL,'A82, H, raw','NGC 5690',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122621,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122621,31.27,0.47,17.9,54783,75,NULL,'A82, H, inv','NGC 5690',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122622,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122622,31.33,0.43,18.5,54783,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5690',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122623,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122623,31.41,0.4,19.1,54783,75,NULL,NULL,'NGC 5690',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122624,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122624,31.41,0.43,19.1,54783,75,NULL,'3.6 micron, color corrected','NGC 5690',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122625,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122625,31.51,0.2,20,54783,74.4,NULL,NULL,'NGC 5690',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122626,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122626,31.53,0.36,20.2,54783,NULL,NULL,NULL,'NGC 5690',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122627,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122627,31.53,NULL,20.2,54783,72,NULL,NULL,'NGC 5690',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122628,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122628,31.63,0.47,21.2,54783,75,NULL,'A82, H, cor','NGC 5690',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122629,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122629,31.91,0.49,24.1,54783,75,NULL,'IR','NGC 5690',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122630,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122630,32.3,0.4,28.8,54783,75,NULL,'B','NGC 5690',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122631,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122631,37.91,0.46,381,54784,70,NULL,NULL,'2MASX J14374141+4234400',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000178,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,219.422625,42.57778,0.01,NULL,59961554271,936899285,14639051,17.9),(122632,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122632,37.02,0.46,253,54785,70,NULL,NULL,'2MASX J14374144+5908565',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000102,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,219.422666667,59.14914,0.005,NULL,57722608782,901915762,14092433,16.5),(122633,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122633,37.97,0.46,392,54786,70,NULL,NULL,'2MASX J14374184+4619250',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,219.424333,46.32378,0.009,NULL,59953977230,936780894,14637201,18.1),(122634,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122634,37.5,0.46,316,54787,70,NULL,NULL,'2MASX J14374292+6128241',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,219.428625,61.47342,0.021,NULL,57752536602,902383384,14099740,17.5),(122635,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122635,37.33,0.46,292,54788,70,NULL,NULL,'2MASX J14374341+3737479',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000193,NULL,'16.2g',0.41,NULL,NULL,NULL,NULL,NULL,1,219.4309583,37.62997,0,NULL,60079205614,938737587,14667774,16.2),(122636,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122636,37,0.46,251,54789,70,NULL,NULL,'2MASX J14374441+0351020',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00008,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.435083333,3.8505,0.085,NULL,58313802177,911153159,14236768,17.5),(122637,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122637,37.43,0.46,306,54790,70,NULL,NULL,'2MASX J14374491+1853208',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.4370417,18.88925,0.043,NULL,59508924921,929826951,14528546,17.7),(122638,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122638,35.79,0.1,144,54791,70,NULL,NULL,'2MASX J14374543+0318310',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000091,NULL,'16.1g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,219.4392917,3.30861,0.113,NULL,58313586224,911149784,14236715,16.1),(122639,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122639,37.94,0.46,387,54792,70,NULL,NULL,'SDSS J143745.65+214323.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.44025,21.72314,0.026,NULL,59503108270,929736066,14527126,18),(122640,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122640,35.8,0.46,144,54793,70,NULL,NULL,'2MASX J14374580+2803313',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000267,NULL,'16.7',0.26,NULL,NULL,NULL,NULL,NULL,1,219.440917,28.05864,0.02,NULL,60025485703,937898214,14654659,16.7),(122641,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122641,38.38,0.23,474,54794,70,NULL,NULL,'2MASX J14374651+1632359',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,219.443833333,16.54336,0,NULL,59552558367,930508724,14539198,17.9),(122642,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122642,37.94,0.11,387,54795,70,NULL,NULL,'2MASX J14374779+2451273',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000198,NULL,'16.73',0.3,'BrClG',NULL,NULL,NULL,NULL,1,219.449167,24.85753,0.091,NULL,59498395470,929662429,14525975,16.73),(122643,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122643,36.14,0.56,169,54796,70,NULL,NULL,'2MASX J14374892-1901548',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.06',NULL,NULL,NULL,NULL,NULL,NULL,1,219.454,-19.03208,0.365,NULL,46557740288,727464692,11366635,16.06),(122644,'D-Sigma','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122644,32.98,0.4,39.5,54797,75,NULL,'Edat, raw','IC 4464',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000107,NULL,'12.59',0.6,'SAB(r)0^0^:',NULL,NULL,NULL,NULL,1,219.454167,-36.878,0.285,NULL,47227579934,737930936,11530170,12.59),(122645,'D-Sigma','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122645,33.34,0.4,46.6,54797,75,NULL,'Edat, cor','IC 4464',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122646,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122646,33.09,0.47,41.5,54797,70,NULL,NULL,'IC 4464',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122647,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122647,32.95,0.45,38.9,54797,NULL,NULL,'K','IC 4464',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122648,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122648,33.89,0.4,60,54797,NULL,NULL,'mean','IC 4464',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122649,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122649,38.94,0.46,614,54798,70,NULL,NULL,'2MASX J14374911+5713246',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000161,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,219.454625,57.22347,0.017,NULL,57251173020,894549578,13977337,18.2),(122650,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122650,38.07,0.21,410,54799,70,NULL,NULL,'2MASX J14374924+2100518',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,219.45525,21.01433,0.027,NULL,59502843696,929731932,14527061,17.7),(122651,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122651,38.56,0.46,516,54800,70,NULL,NULL,'2MASX J14374932+1619540',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.455625,16.33181,0,NULL,59552466456,930507288,14539176,17.7),(122652,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122652,35.02,0.47,101,54801,70,NULL,NULL,'2MASX J14375074-2136438',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.53',NULL,NULL,NULL,NULL,NULL,NULL,1,219.461583,-21.61228,0.321,NULL,46529410997,727022046,11359719,15.53),(122653,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SN 2001ck','R',122653,35.89,0.06,151,54802,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 09425',NULL,'2015Sci...347.1459K',2015,1,NULL,NULL,'GPair',0.00011,NULL,NULL,NULL,'Sb',NULL,NULL,NULL,NULL,1,219.4619583,30.48122,0,NULL,60020223305,937815989,14653374,NULL),(122654,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SN 2001ck',NULL,122654,35.96,0.15,151,54802,70,NULL,'SALT 2','UGC 09425',0.034717,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122655,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SN 2001ck','R',122655,35.93,0.06,153,54802,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 09425',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122656,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122656,38.38,0.23,474,54803,70,NULL,NULL,'2MASX J14375096+1632340',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,219.462416667,16.54272,0,NULL,59552555725,930508683,14539198,17.4),(122657,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122657,37.71,0.46,349,54804,70,NULL,NULL,'2MASX J14375161-0040209',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000077,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.4649583,-0.67244,0.105,NULL,43545408053,680397000,10631203,17.5),(122658,'Tully est','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122658,32.4,0.8,30.2,54805,75,NULL,'B','NGC 5691',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000027,NULL,'12.52',1.4,'SAB(s)a: pec   HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,219.47225,-0.39889,0.121,NULL,43490837501,679544335,10617880,12.52),(122659,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122659,32.01,NULL,25.2,54805,72,NULL,NULL,'NGC 5691',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122660,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122660,37.7,0.46,347,54806,70,NULL,NULL,'2MASX J14375334+1952568',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'18.16',0.13,NULL,NULL,NULL,NULL,NULL,1,219.472208333,19.88242,0.013,NULL,59509275660,929832432,14528631,18.16),(122661,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122661,37.84,0.33,370,54807,70,NULL,NULL,'2MASX J14375435+2922523',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00018,NULL,'18.02',0.18,'Sb',NULL,NULL,NULL,NULL,1,219.476417,29.38128,0,NULL,60017713737,937776777,14652762,18.02),(122662,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122662,37.58,0.46,329,54808,70,NULL,NULL,'2MASX J14375520+1507440',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,219.480167,15.12908,0,NULL,59556867628,930576056,14540250,16.6),(122663,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122663,37.78,0.27,360,54809,70,NULL,NULL,'2MASX J14375681+2351403',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000133,NULL,'18.78',0.14,NULL,NULL,NULL,NULL,NULL,1,219.486875,23.86133,0.08,NULL,59506984614,929796634,14528072,18.78),(122664,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122664,37.59,0.46,329,54810,70,NULL,NULL,'SDSS J143757.21+335517.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.488417,33.92144,0,NULL,60067644447,938556944,14664952,17.7),(122665,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122665,37.82,0.46,366,54811,70,NULL,NULL,'2MASX J14375745+1838438',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.16',0.19,NULL,NULL,NULL,NULL,NULL,1,219.48925,18.64553,0.043,NULL,59479503841,929367247,14521363,18.16),(122666,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122666,37.94,0.11,387,54812,70,NULL,NULL,'2MASX J14375828+2409063',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.12',0.23,'BrClG',NULL,NULL,NULL,NULL,1,219.492833,24.15164,0.095,NULL,59498939506,929670929,14526108,17.12),(122667,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122667,38.38,0.23,474,54813,70,NULL,NULL,'SDSS J143758.45+163119.0',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.493583,16.52194,0,NULL,59552501976,930507843,14539185,17.5),(122668,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122668,36.99,0.46,250,54814,70,NULL,NULL,'2MASX J14375878+0352120',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000085,NULL,'16.8g',0.24,'NLAGN',NULL,NULL,NULL,NULL,1,219.495,3.87008,0.085,NULL,58312167297,911127614,14236368,16.8),(122669,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122669,35.21,0.54,110,54815,70,NULL,NULL,'2MASX J14375967-1644049',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.24',0.3,NULL,NULL,NULL,NULL,NULL,1,219.4985417,-16.73467,0.337,NULL,46681007117,729390736,11396730,16.24),(122670,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122670,37.86,0.46,374,54816,70,NULL,NULL,'SDSS J143759.65+333948.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,219.498583,33.66353,0,NULL,60067506237,938554784,14664918,18.6),(122671,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122671,38.38,0.23,474,54817,70,NULL,NULL,'2MASX J14375847+1631190',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.4989583,16.51914,0,NULL,59552501906,930507842,14539185,18.1),(122672,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122672,36.57,0.46,206,54818,70,NULL,NULL,'2MASX J14375993+5114561',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00018,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,219.4997917,51.24894,0.013,NULL,59204259959,925066561,14454165,16.3),(122673,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122673,37.94,0.11,387,54819,70,NULL,NULL,'SDSS J143800.23+245409.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000155,NULL,'18.7g',0.09,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.5009583,24.90272,0.091,NULL,59498394609,929662415,14525975,18.7),(122674,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122674,35.66,0.46,136,54820,70,NULL,NULL,'CGCG 075-096',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00013,NULL,'15.5g',0.46,'AGN',NULL,NULL,NULL,NULL,1,219.50425,10.18097,0.017,NULL,59373245833,927706966,14495421,15.5),(122675,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122675,36.23,0.46,176,54821,70,NULL,NULL,'2MASX J14380121+1954428',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.16',0.17,NULL,NULL,NULL,NULL,NULL,1,219.505167,19.912,0.013,NULL,59509263960,929832249,14528628,18.16),(122676,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122676,36.07,0.46,164,54822,70,NULL,NULL,'SDSS J143801.30+033011.5',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00008,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,219.505458333,3.50322,0.081,NULL,58313496418,911148381,14236693,17),(122677,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122677,37.78,0.27,360,54823,70,NULL,NULL,'2MASX J14380153+2343158',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,219.506417,23.72114,0.083,NULL,59507005599,929796962,14528077,17),(122678,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122678,37.18,0.23,272,54824,70,NULL,NULL,'2MASX J14380153+1013393',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000189,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,219.5065,10.22756,0.017,NULL,59373254979,927707109,14495423,16.4),(122679,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122679,37.61,0.33,332,54825,70,NULL,NULL,'2MASX J14380189+2338478',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00018,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,219.5077917,23.64658,0.056,NULL,59507012079,929797063,14528079,17.1),(122680,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122680,37.48,0.46,313,54826,70,NULL,NULL,'2MASX J14380257+1757258',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.510833,17.95717,0,NULL,59480316904,929379951,14521561,17.5),(122681,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122681,37.71,0.46,348,54827,70,NULL,NULL,'2MASX J14380368+3108444',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.515167,31.14581,0,NULL,60016757487,937761835,14652528,18),(122682,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122682,38.07,0.21,410,54828,70,NULL,NULL,'2MASX J14380366+2054298',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,219.515417,20.90819,0.027,NULL,59502865474,929732273,14527066,17.3),(122683,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122683,37.78,0.27,360,54829,70,NULL,NULL,'2MASX J14380429+2342088',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,219.518083,23.70244,0.056,NULL,59507014642,929797103,14528079,17.6),(122684,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122684,38.07,0.21,410,54830,70,NULL,NULL,'2MASX J14380452+2058248',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,219.518917,20.97353,0.027,NULL,59502873810,929732403,14527068,17.5),(122685,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122685,35.5,0.46,126,54831,70,NULL,NULL,'2MASX J14380603+2221458',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000161,NULL,'16.1g',0.43,NULL,NULL,NULL,NULL,NULL,1,219.525167,22.36269,0.018,NULL,59505410627,929772041,14527688,16.1),(122686,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122686,37.62,0.46,335,54832,70,NULL,NULL,'SDSS J143808.03+133921.1',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,219.5335,13.65589,0.021,NULL,59543707018,930370422,14537037,NULL),(122687,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122687,37.96,0.46,390,54833,70,NULL,NULL,'2MASX J14380841+3510004',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000151,NULL,'17.3g',0.23,'E/S0',NULL,NULL,NULL,NULL,1,219.534958333,35.16678,0,NULL,60070813969,938606468,14665726,17.3),(122688,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SCP 06K00',NULL,122688,44.59,0.09,3420,54834,70,NULL,'SALT2, M(B) -19.289 mag, Alpha -0.019, Beta 3.480, Delta -0.151','FLX J143808.38+341417.6',1.415,'2012ApJ...746...85S',2012,1,NULL,NULL,'G',NULL,NULL,'17.4J',NULL,NULL,NULL,NULL,NULL,NULL,1,219.534916667,34.23825,0,NULL,60067438712,938553729,14664902,17.4),(122689,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122689,36.14,0.46,169,54835,70,NULL,NULL,'2MASX J14380968+3629202',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000169,NULL,'16.1g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,219.540166667,36.48894,0,NULL,60078426938,938725420,14667584,16.1),(122690,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122690,35.53,0.46,127,54836,70,NULL,NULL,'IC 1035',NULL,'2015arXiv151105856S',2015,1,0.86,'HOLM 664B is the star superposed on the northeast side.','G',0.00017,NULL,'14.8g',0.62,NULL,NULL,NULL,NULL,NULL,1,219.5425417,9.33603,0.029,NULL,59373400709,927709386,14495459,14.8),(122691,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122691,36.77,0.46,226,54837,70,NULL,NULL,'2MASX J14381129+0522248',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000177,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,219.547083,5.37367,0.069,NULL,58313055620,911141494,14236585,16.9),(122692,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122692,32.34,0.4,29.4,54838,75,NULL,NULL,'NGC 5714',NULL,'2008Ap.....51..336K',2008,1,1.73,NULL,'G',0.000023,NULL,'13.9g',0.48,'Sc','Group member',NULL,NULL,NULL,1,219.548,46.63825,0.009,NULL,59987866847,937310419,14645475,13.9),(122693,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122693,32.71,0.4,34.8,54838,NULL,NULL,'mean','NGC 5714',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122694,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122694,32.78,0.4,36.1,54838,75,NULL,'B','NGC 5714',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122695,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122695,32.89,0.43,37.9,54838,75,NULL,'3.6 micron, color corrected','NGC 5714',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122696,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122696,32.9,0.46,38,54838,NULL,NULL,'J','NGC 5714',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122697,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122697,32.9,0.43,38.1,54838,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5714',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122698,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122698,32.91,0.47,38.2,54838,NULL,NULL,'H','NGC 5714',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122699,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122699,32.94,0.2,38.7,54838,74.4,NULL,NULL,'NGC 5714',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122700,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122700,32.97,0.49,39.2,54838,75,NULL,'IR','NGC 5714',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122701,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122701,33.04,0.45,40.6,54838,NULL,NULL,'K','NGC 5714',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122702,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122702,33.08,0.47,41.3,54838,NULL,NULL,'Malmquist cor.','NGC 5714',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122703,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122703,33.16,0.45,42.9,54838,NULL,NULL,NULL,'NGC 5714',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122704,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122704,33.28,NULL,45.2,54838,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 5714',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122705,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122705,33.28,NULL,45.3,54838,NULL,NULL,NULL,'NGC 5714',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122706,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122706,33.28,NULL,45.3,54838,NULL,NULL,'Dipole + Quadrupole','NGC 5714',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122707,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122707,33.28,NULL,45.4,54838,NULL,NULL,'Dipole','NGC 5714',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122708,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122708,37.18,0.46,273,54839,70,NULL,NULL,'2MASX J14381196+1422285',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.5499583,14.37456,0,NULL,59556475232,930569925,14540155,17.3),(122709,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122709,37.52,0.46,319,54840,70,NULL,NULL,'2MASX J14381234+0806513',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000136,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,219.551333,8.11431,0.033,NULL,59364592680,927571760,14493308,17.2),(122710,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122710,37.61,0.46,333,54841,70,NULL,NULL,'2MASX J14381310+2708029',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.40',0.15,NULL,NULL,NULL,NULL,NULL,1,219.5545417,27.13403,0.044,NULL,60028377092,937943392,14655365,18.4),(122711,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122711,37.9,0.46,381,54842,70,NULL,NULL,'SDSS J143813.39+164718.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.555833,16.78839,0,NULL,59552335203,930505237,14539144,18.3),(122712,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122712,37.25,0.46,282,54843,70,NULL,NULL,'2MASX J14381342+5056402',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000187,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,219.5559583,50.94444,0.005,NULL,59199876013,924998062,14453094,16.3),(122713,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122713,35.13,0.46,106,54844,70,NULL,NULL,'2MASX J14381411+1338215',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.13',0.28,NULL,NULL,NULL,NULL,NULL,1,219.558875,13.63933,0.021,NULL,59543688930,930370139,14537033,16.13),(122714,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122714,38.2,0.46,436,54845,70,NULL,NULL,'2MASX J14381472+2331264',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,219.561333,23.524,0.056,NULL,59508036581,929813071,14528329,18.1),(122715,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122715,37.29,0.46,287,54846,70,NULL,NULL,'2MASX J14381551+5704455',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000198,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,219.5644583,57.07922,0.021,NULL,57251058718,894547792,13977309,17),(122716,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122716,38.32,0.46,461,54847,70,NULL,NULL,'SDSS J143815.67+240311.6',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000147,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,219.565333,24.05325,0.08,NULL,59498936405,929670881,14526107,18.8),(122717,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122717,32.36,0.43,29.7,54848,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5704',NULL,'2014MNRAS.444..527S',2014,1,1.85,'Identification as NGC 5704 is not certain.','G',0.000057,NULL,'13.7g',0.6,'Sdm:','Field galaxy',NULL,NULL,NULL,1,219.567833333,40.45675,0.02,NULL,59951325126,936739455,14636553,13.7),(122718,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122718,32.44,0.43,30.8,54848,75,NULL,'3.6 micron, color corrected','NGC 5704',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122719,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122719,32.54,0.2,32.2,54848,74.4,NULL,NULL,'NGC 5704',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122720,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122720,37.95,0.46,388,54849,70,NULL,NULL,'2MASX J14381669+0244168',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000092,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,219.569666667,2.73806,0.081,NULL,58306154066,911033657,14234900,17.5),(122721,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122721,38.05,0.46,407,54850,70,NULL,NULL,'2MASX J14381689+4721110',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00018,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,219.5702917,47.35297,0,NULL,59987098950,937298421,14645287,17.2),(122722,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122722,37.72,0.46,350,54851,70,NULL,NULL,'2MASX J14381685+0539468',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,219.570333,5.66297,0.065,NULL,58309575875,911087123,14235736,17.3),(122723,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122723,34.84,0.2,92.9,54852,74.4,NULL,NULL,'CGCG 075-099',NULL,'2013AJ....146...86T',2013,1,0.86,NULL,'G',0.000088,NULL,'16.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,219.573875,12.03433,0,NULL,59360860976,927513452,14492397,16.4),(122724,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122724,35.24,0.49,112,54852,75,NULL,'IR','CGCG 075-099',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122725,'Tully est','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122725,32.36,0.8,29.7,54853,75,NULL,'B','NGC 5692',NULL,'1988NBGC.C....0000T',1988,1,1.04,NULL,'G',0.000079,NULL,'13.5g',0.64,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,219.5754583,3.41033,0.081,NULL,58313659239,911150925,14236733,13.5),(122726,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122726,31.56,NULL,20.5,54853,72,NULL,NULL,'NGC 5692',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122727,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122727,37.14,0.46,267,54854,70,NULL,NULL,'2MASX J14381813+1433445',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.39',0.15,NULL,NULL,NULL,NULL,NULL,1,219.5755,14.56244,0,NULL,59556319565,930567493,14540117,18.39),(122728,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122728,36.3,0.33,182,54855,70,NULL,NULL,'2MASX J14381862+1736335',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000117,NULL,'10.9K',NULL,NULL,NULL,NULL,NULL,NULL,1,219.5775417,17.60939,0,NULL,59480050137,929375783,14521496,10.9),(122729,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122729,38.07,0.21,410,54856,70,NULL,NULL,'2MASX J14382136+2105285',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.5889583,21.09114,0.027,NULL,59502879286,929732488,14527070,17.6),(122730,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122730,37.29,0.46,288,54857,70,NULL,NULL,'2MASX J14382289+3012245',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000181,NULL,'18.03',0.16,NULL,NULL,NULL,NULL,NULL,1,219.595375,30.20681,0,NULL,60020050556,937813289,14653332,18.03),(122731,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122731,37.29,0.46,287,54858,70,NULL,NULL,'2MASX J14382314+3042245',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000178,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,219.596583,30.70681,0,NULL,60020125157,937814455,14653350,17.1),(122732,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122732,38.13,0.27,423,54859,70,NULL,NULL,'2MASX J14382443+0850174',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000189,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.60175,8.83822,0.041,NULL,59364978464,927577788,14493402,17.6),(122733,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122733,38.19,0.46,435,54860,70,NULL,NULL,'2MASX J14382475+2140125',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,219.6032083,21.67,0,NULL,59503106660,929736041,14527125,16.9),(122734,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122734,37.54,0.46,322,54861,70,NULL,NULL,'2MASX J14382488+5201182',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000159,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,219.603417,52.02172,0,NULL,59204036694,925063073,14454110,17.4),(122735,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122735,36.48,0.46,198,54862,70,NULL,NULL,'2MASX J14382500+1458045',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.00',0.19,NULL,NULL,NULL,NULL,NULL,1,219.604125,14.96792,0,NULL,59556781351,930574708,14540229,18),(122736,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122736,37.26,0.46,284,54863,70,NULL,NULL,'2MASX J14382512+1928435',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.34',0.16,NULL,NULL,NULL,NULL,NULL,1,219.604667,19.47878,0.03,NULL,59509763578,929840055,14528750,18.34),(122737,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122737,37.91,0.46,382,54864,70,NULL,NULL,'2MASX J14382567+1834205',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.48',0.15,NULL,NULL,NULL,NULL,NULL,1,219.607125,18.57256,0.042,NULL,59479554002,929368031,14521375,18.48),(122738,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122738,35.66,0.46,136,54865,70,NULL,NULL,'2MASX J14382571+2320185',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000174,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,219.6072917,23.3385,0.028,NULL,59508019508,929812804,14528325,16.3),(122739,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122739,38.3,0.33,457,54866,70,NULL,NULL,'2MASX J14382644+2717529',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,219.610083,27.29806,0.044,NULL,60028615338,937947114,14655423,17.9),(122740,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122740,32.59,0.8,32.9,54867,75,NULL,'MAT, I','IC 4468',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000017,NULL,'13.75',0.6,'SB(s)c         HII','Pair member (points to parent)',NULL,NULL,NULL,1,219.611416667,-22.36761,0.297,NULL,46536495062,727132735,11361448,13.75),(122741,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122741,31.69,0.4,21.8,54867,75,NULL,NULL,'IC 4468',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122742,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122742,32.13,0.43,26.7,54867,75,NULL,'3.6 micron, color + selection bias corrected','IC 4468',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122743,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122743,32.14,0.49,26.8,54867,75,NULL,'IR','IC 4468',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122744,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122744,32.2,0.43,27.5,54867,75,NULL,'3.6 micron, color corrected','IC 4468',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122745,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122745,32.36,0.2,29.7,54867,74.4,NULL,NULL,'IC 4468',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122746,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122746,32.41,0.32,30.3,54867,85,NULL,'I, raw','IC 4468',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122747,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122747,32.44,0.32,30.7,54867,85,NULL,'I, inv','IC 4468',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122748,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122748,32.5,0.46,31.6,54867,NULL,NULL,'J','IC 4468',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122749,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122749,32.52,0.47,31.9,54867,NULL,NULL,'H','IC 4468',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122750,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122750,32.53,0.43,32.1,54867,75,NULL,'MAT, I, raw','IC 4468',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122751,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122751,32.61,0.45,33.3,54867,NULL,NULL,'K','IC 4468',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122752,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122752,32.68,0.43,34.3,54867,75,NULL,'MAT, I, inv','IC 4468',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122753,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122753,32.7,0.4,34.7,54867,NULL,NULL,'mean','IC 4468',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122754,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122754,32.74,0.51,35.3,54867,NULL,NULL,NULL,'IC 4468',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122755,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122755,32.78,0.43,35.9,54867,75,NULL,'MAT, I, cor','IC 4468',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122756,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122756,32.88,0.48,37.6,54867,NULL,NULL,'Malmquist cor.','IC 4468',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122757,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122757,38,0.46,399,54868,70,NULL,NULL,'2MASX J14382813+3501435',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000174,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,219.6170417,35.02883,0,NULL,60070777145,938605892,14665717,17.2),(122758,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122758,36.31,0.46,183,54869,70,NULL,NULL,'2MASX J14382948+1459206',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.16',0.14,NULL,NULL,NULL,NULL,NULL,1,219.622917,14.98914,0,NULL,59556780968,930574702,14540229,18.16),(122759,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122759,37.61,0.33,332,54870,70,NULL,NULL,'2MASX J14382963+2336495',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000173,NULL,'18.31',0.14,NULL,NULL,NULL,NULL,NULL,1,219.623333,23.61381,0.056,NULL,59506979244,929796550,14528071,18.31),(122760,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122760,38.13,0.27,423,54871,70,NULL,NULL,'SDSS J143830.09+085709.3',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,'PHOT','16.5g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,219.625417,8.95258,0.037,NULL,59364990431,927577975,14493405,16.5),(122761,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122761,37.45,0.46,309,54872,70,NULL,NULL,'2MASX J14383051+3511084',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,219.627,35.18581,0,NULL,60070816334,938606505,14665726,17.5),(122762,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122762,38.13,0.27,423,54873,70,NULL,NULL,'2MASX J14383009+0857094',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,'PHOT','17.88',0.18,NULL,NULL,NULL,NULL,NULL,1,219.6285,8.95786,0.037,NULL,59364990444,927577975,14493405,17.88),(122763,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122763,36.42,0.33,192,54874,70,NULL,NULL,'2MASX J14383118+0619304',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,219.629833,6.325,0.057,NULL,58276388974,910568577,14227634,17.1),(122764,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122764,37.16,0.46,271,54875,70,NULL,NULL,'SDSS J143831.60-003557.9',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000098,NULL,'17.2g',0.22,'ELG',NULL,NULL,NULL,NULL,1,219.631667,-0.59944,0.109,NULL,43490808449,679543882,10617873,17.2),(122765,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122765,38.52,0.46,507,54876,70,NULL,NULL,'SDSS J143831.76+245343.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000129,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.632333333,24.89536,0.078,NULL,59498504554,929664133,14526002,18.7),(122766,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122766,37.59,0.46,330,54877,70,NULL,NULL,'2MASX J14383209-0058202',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00008,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,219.633625,-0.97228,0.105,NULL,43491158999,679549359,10617958,17.3),(122767,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122767,37.66,0.46,341,54878,70,NULL,NULL,'2MASX J14383219+4447212',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000145,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,219.634083,44.78925,0.024,NULL,59956924156,936826939,14637920,17.6),(122768,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122768,36.42,0.33,192,54879,70,NULL,NULL,'2MASX J14383259+0622084',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000175,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,219.6357083,6.36917,0.057,NULL,58276390422,910568600,14227634,16.7),(122769,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122769,35.29,0.47,114,54880,NULL,NULL,'H','NGC 5720',NULL,'2007A&A...465...71T',2007,1,1.46,NULL,'G',0.00002,NULL,'14.0g',0.86,'Sb',NULL,NULL,NULL,NULL,1,219.638708333,50.81522,0.013,NULL,59199911973,924998624,14453103,14),(122770,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122770,35.31,0.4,115,54880,NULL,NULL,'mean','NGC 5720',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122771,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122771,35.34,0.2,117,54880,74.4,NULL,NULL,'NGC 5720',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122772,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122772,35.34,0.43,117,54880,75,NULL,'3.6 micron, color corrected','NGC 5720',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122773,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122773,35.4,0.46,120,54880,NULL,NULL,'J','NGC 5720',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122774,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122774,35.4,0.45,120,54880,NULL,NULL,'K','NGC 5720',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122775,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122775,35.5,0.43,126,54880,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5720',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122776,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122776,36.3,0.33,182,54881,70,NULL,NULL,'SDSS J143833.36+174615.4',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.0g',0.38,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.639041667,17.77097,0.008,NULL,59480070727,929376105,14521501,16),(122777,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122777,37.92,0.46,384,54882,70,NULL,NULL,'2MASX J14383362+1827375',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.99',0.12,NULL,NULL,NULL,NULL,NULL,1,219.640083333,18.46053,0.042,NULL,59479522198,929367534,14521367,18.99),(122778,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122778,36.85,0.46,235,54883,70,NULL,NULL,'2MASX J14383383-0127302',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,219.641125,-1.45839,0.093,NULL,43545803431,680403178,10631299,16.9),(122779,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122779,38.51,0.46,504,54884,70,NULL,NULL,'SDSS J143834.68+553939.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000168,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,219.644541667,55.66089,0.005,NULL,57257808184,894653252,13978957,18.8),(122780,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122780,37.6,0.46,331,54885,70,NULL,NULL,'2MASX J14383558+2132565',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.648375,21.54917,0.018,NULL,59503216332,929737755,14527152,18),(122781,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122781,38.46,0.46,491,54886,70,NULL,NULL,'2MASX J14383563+4640132',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,219.648375,46.67031,0,NULL,59987864201,937310378,14645474,18.3),(122782,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122782,36.31,0.27,183,54887,70,NULL,NULL,'2MASX J14383583+0816194',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.54',0.27,NULL,NULL,NULL,NULL,NULL,1,219.649291667,8.27203,0.041,NULL,59364552192,927571128,14493298,17.54),(122783,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122783,38.25,0.46,446,54888,70,NULL,NULL,'2MASX J14383658+2441295',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00018,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,219.652333333,24.69164,0.091,NULL,59498479181,929663737,14525995,18.3),(122784,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122784,38.06,0.46,410,54889,70,NULL,NULL,'2MASX J14383753+4220462',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,219.6564583,42.34631,0.01,NULL,59961194752,936893668,14638963,18.1),(122785,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122785,37.26,0.46,283,54890,70,NULL,NULL,'2MASX J14383889+4917291',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.6620417,49.29167,0.109,NULL,59202088199,925032628,14453634,18),(122786,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122786,38.27,0.46,451,54891,70,NULL,NULL,'2MASX J14383989+1725268',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.666375,17.42425,0.024,NULL,59551037311,930484957,14538827,17.9),(122787,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122787,38.65,0.46,537,54892,70,NULL,NULL,'SDSS J143840.06-021447.4',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000179,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.666916667,-2.24653,0.169,NULL,43547808259,680434504,10631789,17.9),(122788,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122788,37.44,0.46,308,54893,70,NULL,NULL,'SDSS J143841.17+001025.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000071,NULL,'18.1g',0.13,'AGN',NULL,NULL,NULL,'Post Starburst (E+A) or (a+k) Galaxy',1,219.671583,0.17367,0.105,NULL,58259122357,910298786,14223418,18.1),(122789,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122789,35.43,0.2,122,54894,74.4,NULL,NULL,'CGCG 075-100',NULL,'2013AJ....146...86T',2013,1,0.97,NULL,'G',0.000101,NULL,'15.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,219.671833,9.54219,0.021,NULL,59373419496,927709679,14495463,15.6),(122790,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122790,37.71,0.46,348,54895,70,NULL,NULL,'SDSS J143841.34+184210.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.6722917,18.70289,0.042,NULL,59479531469,929367679,14521369,18.5),(122791,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122791,35.23,0.33,111,54896,70,NULL,NULL,'2MASX J14384182+1957055',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.10',0.27,NULL,NULL,NULL,NULL,NULL,1,219.6744583,19.95153,0,NULL,59501151945,929705499,14526648,17.1),(122792,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122792,36.72,0.46,221,54897,70,NULL,NULL,'2MASX J14384205+5105561',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000169,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,219.6752083,51.09886,0.005,NULL,59204296421,925067131,14454173,16.6),(122793,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122793,38.37,0.33,471,54898,70,NULL,NULL,'SDSS J143842.18+451432.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,219.675791667,45.24239,0.046,NULL,59957013167,936828330,14637942,18),(122794,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122794,37.12,0.46,265,54899,70,NULL,NULL,'2MASX J14384347+2218319',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,219.681166667,22.30897,0.018,NULL,59505063828,929766622,14527603,17.2),(122795,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122795,35.88,0.46,150,54900,70,NULL,NULL,'2MASX J14384372+2235449',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00016,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,219.682208333,22.59589,0.015,NULL,59505389327,929771708,14527682,16.5),(122796,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122796,36.48,0.46,198,54901,70,NULL,NULL,'2MASX J14384436+4732162',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000186,NULL,'16.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,219.6850417,47.538,0.009,NULL,59932531711,936445807,14631965,16.5),(122797,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122797,38.07,0.21,410,54902,70,NULL,NULL,'2MASX J14384570+2108379',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,219.6905,21.14389,0.027,NULL,59503289391,929738896,14527170,17.5),(122798,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122798,37.75,0.46,354,54903,70,NULL,NULL,'2MASX J14384599+1557328',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,219.6915417,15.95908,0,NULL,59552121413,930501897,14539092,17.2),(122799,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122799,38.37,0.33,471,54904,70,NULL,NULL,'2MASX J14384605+4515172',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000165,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,219.692,45.255,0.057,NULL,59957014936,936828358,14637943,18.6),(122800,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122800,37.05,0.33,257,54905,70,NULL,NULL,'CGCG 075-101',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000157,NULL,'15.3g',0.46,NULL,NULL,NULL,NULL,NULL,1,219.698333,10.12147,0.017,NULL,59373175091,927705860,14495404,15.3),(122801,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122801,37.53,0.46,320,54906,70,NULL,NULL,'2MASX J14384868+0413186',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000084,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,219.702917,4.22178,0.057,NULL,58312118362,911126849,14236357,16.9),(122802,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122802,33.85,0.4,58.9,54907,NULL,NULL,'mean','NGC 5703',NULL,'2007A&A...465...71T',2007,1,1.45,NULL,'G',0.00003,NULL,'14.1g',0.56,'SBa','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,219.708416667,30.44253,0,NULL,60020144587,937814759,14653355,14.1),(122803,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122803,33.89,0.47,59.9,54907,NULL,NULL,'H','NGC 5703',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122804,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122804,33.96,0.46,61.9,54907,NULL,NULL,'J','NGC 5703',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122805,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122805,34.02,0.45,63.7,54907,NULL,NULL,'K','NGC 5703',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122806,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122806,37.66,0.46,341,54908,70,NULL,NULL,'SDSS J143852.06+553233.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000129,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,219.716916667,55.54269,0.005,NULL,57246514808,894476793,13976199,18),(122807,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122807,36.81,0.46,230,54909,70,NULL,NULL,'2MASX J14385282+3103288',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000175,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,219.7202083,31.05783,0,NULL,60016649970,937760155,14652502,16.4),(122808,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122808,36.05,0.33,163,54910,70,NULL,NULL,'NGC 5721',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.0002,NULL,'16.4g',0.25,NULL,'Group member',NULL,NULL,NULL,1,219.720667,46.67444,0,NULL,59987907789,937311059,14645485,16.4),(122809,'Tully est','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122809,32.3,0.8,28.8,54911,75,NULL,NULL,'DDO 195',NULL,'1988NBGC.C....0000T',1988,1,2.9,'MCG R.A.=14h35.2m is presumably a misprint.','G',0.000017,NULL,'14',0.7,'IB(s)m',NULL,NULL,NULL,NULL,1,219.7249583,-8.62861,0.181,NULL,46466376473,726037132,11344330,14),(122810,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122810,36.05,0.33,163,54912,70,NULL,NULL,'NGC 5722',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000093,NULL,'15.0g',0.64,NULL,NULL,NULL,NULL,NULL,1,219.7267083,46.66561,0,NULL,59987907821,937311059,14645485,15),(122811,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122811,38.18,0.19,432,54913,70,NULL,NULL,'2MASX J14385471+1743398',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.23',0.19,'BrClG',NULL,NULL,NULL,NULL,1,219.728125,17.72783,0.008,NULL,59480052607,929375821,14521497,18.23),(122812,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122812,34.25,0.45,70.7,54914,NULL,NULL,'K','NGC 5702',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000103,NULL,'14.32',0.8,'S0','in a pair',NULL,NULL,NULL,1,219.7295,20.50672,0.009,NULL,59503825492,929747273,14527301,14.32),(122813,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122813,34.49,0.4,79,54914,NULL,NULL,'mean','NGC 5702',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122814,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122814,37.93,0.46,386,54915,70,NULL,NULL,'2MASX J14385520+5602028',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000146,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,219.72975,56.03406,0,NULL,57259109813,894673590,13979274,18.3),(122815,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122815,38.2,0.46,437,54916,70,NULL,NULL,'2MASX J14385564+1810120',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.95',0.2,NULL,NULL,NULL,NULL,NULL,1,219.7317917,18.17014,0.01,NULL,59479593090,929368642,14521385,17.95),(122816,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122816,38.1,0.46,416,54917,70,NULL,NULL,'2MASX J14385631+2525516',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000205,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,219.734833,25.43094,0.054,NULL,60021798426,937840600,14653759,16.9),(122817,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122817,37.92,0.46,383,54918,70,NULL,NULL,'2MASX J14385675+2014100',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.40',0.15,NULL,NULL,NULL,NULL,NULL,1,219.736583,20.23619,0.016,NULL,59500963324,929702551,14526602,18.4),(122818,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122818,37.05,0.33,257,54919,70,NULL,NULL,'2MASX J14385680+1007349',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000179,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,219.736625,10.12631,0.017,NULL,59373178831,927705919,14495404,17.2),(122819,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122819,37.05,0.46,257,54920,70,NULL,NULL,'2MASX J14385683+2821116',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.85',0.25,NULL,NULL,NULL,NULL,NULL,1,219.736791667,28.35319,0.024,NULL,60025359081,937896235,14654628,16.85),(122820,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122820,37.08,0.33,260,54921,70,NULL,NULL,'2MASX J14385748+4949586',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000147,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,219.7395,49.83308,0.037,NULL,59200202306,925003161,14453174,17.8),(122821,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122821,37.08,0.33,260,54922,70,NULL,NULL,'2MASX J14385882+4953006',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000149,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,219.745083,49.88344,0.037,NULL,59200131717,925002058,14453157,16.7),(122822,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122822,33.13,0.4,42.3,54923,75,NULL,NULL,'UGC 09448',NULL,'2008Ap.....51..336K',2008,1,1.54,NULL,'G',0.000027,NULL,'14.9g',0.33,'Sbc',NULL,NULL,NULL,NULL,1,219.7464583,51.12069,0.005,NULL,59204249762,925066402,14454162,14.9),(122823,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122823,33.32,NULL,46.2,54923,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09448',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122824,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122824,33.35,NULL,46.7,54923,NULL,NULL,'Dipole + Quadrupole','UGC 09448',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122825,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122825,33.37,NULL,47.1,54923,NULL,NULL,'Dipole','UGC 09448',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122826,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122826,33.61,0.49,52.7,54923,75,NULL,'IR','UGC 09448',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122827,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122827,38.06,0.46,410,54924,70,NULL,NULL,'2MASX J14385947+2219460',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000176,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,219.7479583,22.32953,0.015,NULL,59505061472,929766585,14527602,17.7),(122828,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122828,35.31,0.2,115,54925,74.4,NULL,NULL,'CGCG 164-007',NULL,'2013AJ....146...86T',2013,1,0.76,'Noted in MCG as possibly interacting.','G',0.000091,NULL,'15.3g',0.42,'SB?',NULL,NULL,NULL,NULL,1,219.7500417,30.814,0,NULL,60016634885,937759920,14652498,15.3),(122829,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122829,39.01,0.46,634,54926,70,NULL,NULL,'2MASX J14390013+4855476',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,219.7505,48.93011,0.133,NULL,59932960560,936452508,14632070,18.4),(122830,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122830,38.08,0.46,412,54927,70,NULL,NULL,'2MASX J14390167+2626256',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.756875,26.44044,0.037,NULL,60026344456,937911632,14654869,17.4),(122831,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122831,37.74,0.46,354,54928,70,NULL,NULL,'SDSS J143902.50+220327.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000132,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.7604583,22.05758,0,NULL,59505075443,929766803,14527606,18.6),(122832,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122832,38.18,0.19,432,54929,70,NULL,NULL,'SDSS J143902.99+173801.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.7625,17.63383,0.008,NULL,59551153885,930486779,14538855,18.4),(122833,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122833,36.89,0.46,239,54930,70,NULL,NULL,'2MASX J14390368+3122027',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000126,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,219.7655417,31.36736,0,NULL,60017306698,937770417,14652662,17.8),(122834,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122834,32.13,0.4,26.7,54931,75,NULL,'B','UGC 09432',NULL,'1988NBGC.C....0000T',1988,1,1.2,NULL,'G',0.000023,NULL,'14.60',0.8,'Im:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,219.767917,2.94917,0.089,NULL,58306092129,911032689,14234885,14.6),(122835,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122835,37.51,0.46,318,54932,70,NULL,NULL,'LCRS B143629.3-023620',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000173,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.7710417,-2.82053,0.201,NULL,43547610734,680431417,10631740,17.8),(122836,'Tully est','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122836,29.92,0.8,9.6,54933,75,NULL,NULL,'MRK 0475',NULL,'1988NBGC.C....0000T',1988,1,0.36,NULL,'G',0.000007,NULL,'16.2g',0.27,'BCD            WR',NULL,NULL,NULL,NULL,1,219.77275,36.80608,0,NULL,60078443232,938725675,14667588,16.2),(122837,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122837,29.82,NULL,9.2,54933,NULL,NULL,NULL,'MRK 0475',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122838,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122838,37.66,0.46,340,54934,70,NULL,NULL,'2MASX J14390562+2333220',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.0001,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,219.7735417,23.55619,0.052,NULL,59506967411,929796365,14528068,18.1),(122839,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122839,35.98,0.46,157,54935,70,NULL,NULL,'2MASX J14390570-0206569',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000103,NULL,'16.2g',0.28,'S0',NULL,NULL,NULL,NULL,1,219.773708333,-2.11569,0.161,NULL,43547812205,680434565,10631790,16.2),(122840,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122840,38.06,0.46,409,54936,70,NULL,NULL,'SDSS J143906.58+061756.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.7774583,6.29908,0.069,NULL,58276307405,910567303,14227614,17.9),(122841,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122841,35.81,0.46,145,54937,70,NULL,NULL,'CGCG 192-051',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000192,NULL,'15.2g',0.58,'E0',NULL,NULL,NULL,NULL,1,219.783333,38.13422,0.049,NULL,60078817011,938731515,14667679,15.2),(122842,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122842,35.58,0.58,131,54938,70,NULL,NULL,'2MASX J14390888-0212515',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.787083,-2.2145,0.161,NULL,43547770331,680433911,10631779,16.3),(122843,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122843,37.44,0.27,308,54939,70,NULL,NULL,'2MASX J14390952+1416465',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.7897083,14.27942,0.017,NULL,59558285258,930598207,14540596,17.8),(122844,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122844,37.97,0.46,393,54940,70,NULL,NULL,'2MASX J14390989+1654105',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,219.791125,16.90281,0,NULL,59554636494,930541195,14539706,18),(122845,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122845,37.51,0.46,317,54941,70,NULL,NULL,'2MASX J14391007+2353290',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,219.792,23.89131,0.052,NULL,59507207856,929800122,14528126,17.4),(122846,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122846,36.92,0.43,242,54942,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09437',NULL,'2014MNRAS.444..527S',2014,1,0.9,NULL,'G',NULL,NULL,'16.0',0.5,'SB?',NULL,NULL,NULL,NULL,1,219.7939583,18.71314,0.024,NULL,59479527256,929367613,14521368,16),(122847,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122847,37.44,0.27,308,54943,70,NULL,NULL,'2MASX J14391083+1417245',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,219.7952083,14.29028,0.017,NULL,59558284708,930598198,14540596,16.7),(122848,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122848,37.71,0.46,348,54944,70,NULL,NULL,'2MASX J14391093+3755163',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,219.795625,37.92108,0.053,NULL,60078770958,938730796,14667668,17.1),(122849,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122849,32.08,0.4,26.1,54945,75,NULL,'B','NGC 5701',NULL,'1988NBGC.C....0000T',1988,1,4.3,NULL,'G',0.000003,NULL,'11.76',4.1,'(R)SB(rs)0/a   LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,219.796167,5.36347,0.089,NULL,58310000721,911093761,14235840,11.76),(122850,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122850,37.45,0.46,309,54946,70,NULL,NULL,'2MASX J14391122+5644427',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00016,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,219.796625,56.74536,0,NULL,57259514301,894679910,13979373,18.4),(122851,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122851,37.45,0.46,310,54947,70,NULL,NULL,'SDSS J143911.45+171717.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.7977083,17.28806,0.024,NULL,59551013145,930484580,14538821,18.1),(122852,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122852,36.26,0.46,179,54948,70,NULL,NULL,'2MASX J14391180+3347067',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000178,NULL,'15.4g',0.49,NULL,NULL,NULL,NULL,NULL,1,219.799,33.78531,0,NULL,60067616442,938556506,14664945,15.4),(122853,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122853,37.44,0.27,308,54949,70,NULL,NULL,'2MASX J14391186+1415215',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,219.799458333,14.25611,0.017,NULL,59558282582,930598165,14540596,17.2),(122854,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122854,37.96,0.46,391,54950,70,NULL,NULL,'SDSS J143912.31+164750.9',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.23,'AGN',NULL,NULL,NULL,NULL,1,219.801333,16.79747,0,NULL,59554643413,930541303,14539707,17.2),(122855,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122855,32.21,NULL,27.7,54951,72,NULL,NULL,'SDSS J143912.44+090805.7',NULL,'2014Ap.....57..457K',2014,1,0.5,NULL,'G',0.000177,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,219.801833,9.13494,0.037,NULL,59364728482,927573882,14493341,16.4),(122856,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122856,37.9,0.46,380,54952,70,NULL,NULL,'2MASX J14391245+2732390',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.8019583,27.54408,0,NULL,60028521517,937945648,14655400,17.8),(122857,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122857,34.12,0.46,66.8,54953,70,NULL,NULL,'IC 4478',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00017,NULL,'15.3',0.35,NULL,NULL,NULL,NULL,NULL,1,219.802875,15.87739,0.008,NULL,59552251062,930503922,14539123,15.3),(122858,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122858,38.01,0.46,400,54954,70,NULL,NULL,'2MASX J14391326+4246007',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.805333,42.76694,0.027,NULL,59961065470,936891647,14638931,17.8),(122859,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122859,38.72,0.46,556,54955,70,NULL,NULL,'2MASX J14391340+5458046',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000177,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.805708333,54.96803,0,NULL,57246955408,894483678,13976307,17.6),(122860,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122860,37.44,0.15,308,54956,70,NULL,NULL,'2MASX J14391394+2306040',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000194,NULL,'17.74',0.21,NULL,NULL,NULL,NULL,NULL,1,219.80825,23.10122,0.015,NULL,59508113788,929814277,14528348,17.74),(122861,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122861,38.46,0.46,491,54957,70,NULL,NULL,'SDSS J143914.46-021640.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000147,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,219.81025,-2.27792,0.161,NULL,43547758043,680433719,10631776,18.5),(122862,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122862,36.2,0.46,174,54958,70,NULL,NULL,'2MASX J14391521+1237035',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000163,NULL,'15.9g',0.41,NULL,NULL,NULL,NULL,NULL,1,219.813375,12.61772,0,NULL,59543554956,930368046,14537000,15.9),(122863,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122863,36.33,0.46,185,54959,70,NULL,NULL,'2MASX J14391540+2715230',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.46',0.18,NULL,NULL,NULL,NULL,NULL,1,219.814083333,27.25631,0.024,NULL,60028440975,937944390,14655381,17.46),(122864,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122864,35.44,0.46,122,54960,70,NULL,NULL,'CGCG 047-126',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.000053,NULL,'14.5g',0.66,'E0',NULL,NULL,NULL,NULL,1,219.814666667,2.72803,0.085,NULL,58306297405,911035896,14234935,14.5),(122865,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122865,35.79,0.1,144,54961,70,NULL,NULL,'VIII Zw 443',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.00006,NULL,'15.6g',0.58,'S0^-',NULL,NULL,NULL,NULL,1,219.8152917,3.6775,0.077,NULL,58311515260,911117425,14236209,15.6),(122866,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122866,38.25,0.46,447,54962,70,NULL,NULL,'SDSS J143916.00+324733.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,219.816667,32.79261,0,NULL,60066643449,938541303,14664707,18.3),(122867,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122867,38.12,0.46,420,54963,70,NULL,NULL,'2MASX J14391603+2057046',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'18.13',0.16,NULL,NULL,NULL,NULL,NULL,1,219.816791667,20.95128,0.029,NULL,59503940744,929749074,14527329,18.13),(122868,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122868,35.23,0.33,111,54964,70,NULL,NULL,'NGC 5710',NULL,'2015arXiv151105856S',2015,1,1.2,NULL,'G',0.000103,NULL,'14.00',1.1,'E','in a pair',NULL,NULL,NULL,1,219.817458333,20.04369,0.027,NULL,59501172924,929705826,14526653,14),(122869,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122869,35.64,0.45,134,54964,NULL,NULL,'K','NGC 5710',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122870,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122870,35.69,0.4,138,54964,NULL,NULL,'mean','NGC 5710',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122871,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122871,36.96,0.46,247,54965,70,NULL,NULL,'2MASX J14391710+1729505',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.8212917,17.49739,0.016,NULL,59551214234,930487722,14538870,17.2),(122872,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122872,37.99,0.27,397,54966,70,NULL,NULL,'2MASX J14391742+2712210',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.20',0.17,'BrClG',NULL,NULL,NULL,NULL,1,219.822583,27.20594,0.024,NULL,60028472877,937944888,14655388,18.2),(122873,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122873,37.81,0.46,365,54967,70,NULL,NULL,'SDSS J143917.46+495257.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000137,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.822791667,49.88264,0.037,NULL,59200201304,925003145,14453174,18.3),(122874,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122874,37.5,0.46,317,54968,70,NULL,NULL,'2MASX J14391875+4458237',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000208,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,219.828291667,44.97336,0.029,NULL,59955844044,936810063,14637657,16.4),(122875,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122875,37.46,0.46,311,54969,70,NULL,NULL,'2MASX J14391911+6012097',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000083,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,219.829917,60.20283,0,NULL,57771798591,902684352,14104443,17),(122876,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122876,38.18,0.19,432,54970,70,NULL,NULL,'2MASX J14392045+1744345',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'BrClG',NULL,NULL,NULL,NULL,1,219.835333,17.74283,0.008,NULL,59551181078,930487204,14538862,NULL),(122877,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122877,38.18,0.19,432,54971,70,NULL,NULL,'SDSS J143920.69+174347.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.83625,17.72992,0.008,NULL,59551182213,930487222,14538862,17.5),(122878,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122878,37.99,0.46,397,54972,70,NULL,NULL,'SDSS J143920.91+201252.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.837167,20.21447,0.016,NULL,59501149594,929705462,14526647,17.9),(122879,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122879,38.18,0.19,432,54973,70,NULL,NULL,'VIII Zw 445 NOTES03',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,219.838083,17.71064,0.008,NULL,59551182030,930487219,14538862,17.9),(122880,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122880,37.44,0.15,308,54974,70,NULL,NULL,'SDSS J143921.27+232146.5',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,219.838625,23.36292,0.028,NULL,59508222803,929815981,14528374,17.7),(122881,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122881,37.5,0.46,317,54975,70,NULL,NULL,'2MASX J14392168+5601528',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,219.840333,56.03144,0,NULL,57259117949,894673717,13979276,17.8),(122882,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122882,38.18,0.19,432,54976,70,NULL,NULL,'SDSS J143922.15+174111.0',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.28,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.842333,17.68642,0.008,NULL,59551180209,930487190,14538862,17),(122883,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122883,37.01,0.46,252,54977,70,NULL,NULL,'2MASX J14392247+5716449',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.8435,57.27936,0.021,NULL,57251137471,894549022,13977328,17.5),(122884,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122884,38.3,0.33,457,54978,70,NULL,NULL,'2MASX J14392245+2712100',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.843667,27.20286,0.024,NULL,60028472952,937944889,14655388,17.9),(122885,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122885,35.28,0.2,114,54979,74.4,NULL,NULL,'NGC 5711',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'14.88',0.6,'S?',NULL,NULL,NULL,NULL,1,219.844,19.99089,0.027,NULL,59501171455,929705803,14526653,14.88),(122886,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122886,35.68,0.4,137,54979,NULL,NULL,'mean','NGC 5711',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122887,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122887,35.89,0.47,151,54979,NULL,NULL,'H','NGC 5711',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122888,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122888,38.2,0.46,437,54980,70,NULL,NULL,'SDSS J143924.30+170347.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.85125,17.06333,0.007,NULL,59554433131,930538017,14539656,18),(122889,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122889,37.44,0.15,308,54981,70,NULL,NULL,'2MASX J14392642+2241546',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,219.860083,22.69839,0.008,NULL,59508395523,929818680,14528416,17),(122890,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122890,37.01,0.46,252,54982,70,NULL,NULL,'2MASX J14392879+1342055',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'16.90',0.21,NULL,NULL,NULL,NULL,NULL,1,219.869916667,13.70153,0.005,NULL,59557781528,930590336,14540474,16.9),(122891,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122891,37.2,0.46,275,54983,70,NULL,NULL,'2MASX J14392888+1759036',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.870333,17.98425,0.011,NULL,59479556682,929368073,14521376,17.4),(122892,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122892,37.99,0.27,397,54984,70,NULL,NULL,'2MASX J14393047+2713540',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,'PHOT','18.48',0.16,NULL,NULL,NULL,NULL,NULL,1,219.877,27.23158,0.024,NULL,60028472125,937944876,14655388,18.48),(122893,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122893,37.47,0.46,312,54985,70,NULL,NULL,'2MASX J14393063+5636139',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000195,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,219.8777083,56.60383,0,NULL,57259539830,894680309,13979379,17.2),(122894,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122894,37.83,0.33,369,54986,70,NULL,NULL,'2MASX J14393132+0657194',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,219.880667,6.95558,0.041,NULL,58276109245,910564206,14227565,17.4),(122895,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122895,37.99,0.27,397,54987,70,NULL,NULL,'2MASX J14393152+2714240',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.881375,27.24014,0.024,NULL,60028472282,937944879,14655388,17.9),(122896,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122896,35.99,0.2,158,54988,74.4,NULL,NULL,'UGC 09443',NULL,'2013AJ....146...86T',2013,1,1.14,NULL,'G',0.000033,NULL,'15.1g',0.38,'S?',NULL,NULL,NULL,NULL,1,219.8822083,9.23497,0.037,NULL,59372892071,927701438,14495334,15.1),(122897,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122897,36.45,0.33,195,54989,70,NULL,NULL,'2MASX J14393202+1220415',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.883375,12.34475,0.013,NULL,59543551502,930367992,14536999,17.4),(122898,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122898,36.61,0.46,210,54990,70,NULL,NULL,'2MASX J14393368+2942500',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000169,NULL,'16.2g',0.42,'Sa',NULL,NULL,NULL,NULL,1,219.890416667,29.71375,0,NULL,60019619332,937806552,14653227,16.2),(122899,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122899,38.09,0.33,415,54991,70,NULL,NULL,'2MASX J14393502+0642504',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000155,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,219.8957917,6.71408,0.057,NULL,58276627272,910572301,14227692,17.3),(122900,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122900,37.48,0.46,313,54992,70,NULL,NULL,'2MASX J14393502+0113499',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00009,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,219.8959583,1.23056,0.105,NULL,58259440864,910303763,14223496,17.5),(122901,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122901,32.58,0.8,32.8,54993,75,NULL,'MAT, I','NGC 5688',NULL,'1997ApJS..109..333W',1997,1,3.8,NULL,'G',0.00001,NULL,'12.3b',2.5,'SAB(r)bc',NULL,NULL,NULL,NULL,1,219.8964583,-45.019,0.469,NULL,47082792301,735668629,11494822,12.3),(122902,'Tully est','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122902,32.88,0.8,37.7,54993,75,NULL,NULL,'NGC 5688',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122903,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122903,32.45,0.36,30.9,54993,NULL,NULL,NULL,'NGC 5688',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122904,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122904,32.58,0.46,32.8,54993,NULL,NULL,'J','NGC 5688',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122905,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122905,32.61,0.47,33.2,54993,NULL,NULL,'H','NGC 5688',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122906,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122906,32.69,0.45,34.5,54993,NULL,NULL,'K','NGC 5688',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122907,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122907,32.77,0.43,35.8,54993,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5688',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122908,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122908,32.78,0.43,36,54993,75,NULL,'MAT, I, raw','NGC 5688',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122909,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122909,32.81,0.4,36.5,54993,NULL,NULL,'mean','NGC 5688',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122910,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122910,32.83,0.43,36.9,54993,75,NULL,'3.6 micron, color corrected','NGC 5688',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122911,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122911,32.87,0.32,37.5,54993,85,NULL,'I, raw','NGC 5688',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122912,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122912,32.94,0.32,38.8,54993,85,NULL,'I, inv','NGC 5688',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122913,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122913,32.95,0.2,38.9,54993,74.4,NULL,NULL,'NGC 5688',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122914,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122914,33.03,0.43,40.4,54993,75,NULL,'MAT, I, cor','NGC 5688',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122915,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122915,33.09,0.43,41.4,54993,75,NULL,'MAT, I, inv','NGC 5688',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122916,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122916,37.75,0.46,355,54994,70,NULL,NULL,'2MASX J14393554+1523073',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,219.8982917,15.38547,0,NULL,59556731528,930573930,14540217,17.4),(122917,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122917,33.91,0.8,60.7,54995,75,NULL,'HMCL, I','UGC 09449',NULL,'1997ApJS..109..333W',1997,1,1.19,NULL,'G',0.000027,NULL,'15.4g',0.26,'Sbc',NULL,NULL,NULL,NULL,1,219.905291667,24.5385,0.089,NULL,59498435526,929663055,14525985,15.4),(122918,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122918,33.82,0.4,57.9,54995,75,NULL,'HMCL, I, raw','UGC 09449',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122919,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122919,33.87,0.4,59.3,54995,75,NULL,'HMCL, I, inv','UGC 09449',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122920,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122920,34.02,0.2,63.7,54995,74.4,NULL,NULL,'UGC 09449',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122921,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122921,34.02,0.49,63.7,54995,75,NULL,'IR','UGC 09449',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122922,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122922,34.09,0.4,65.7,54995,75,NULL,'HMCL, I, cor','UGC 09449',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122923,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122923,37.44,0.15,308,54996,70,NULL,NULL,'SDSS J143937.60+231125.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'18.0g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.9067083,23.19036,0.015,NULL,59508206812,929815731,14528370,18),(122924,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122924,37.9,0.46,380,54997,70,NULL,NULL,'2MASX J14393851+1426444',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.9105417,14.44578,0.005,NULL,59558258501,930597789,14540590,17.6),(122925,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122925,37.87,0.46,375,54998,70,NULL,NULL,'2MASX J14393992+1514044',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.2g',NULL,NULL,NULL,NULL,NULL,NULL,1,219.916333333,15.2345,0,NULL,59556753644,930574275,14540223,17.2),(122926,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122926,36.45,0.33,195,54999,70,NULL,NULL,'2MASX J14394015+1217104',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.0001,NULL,'16.83',0.3,'BrClG',NULL,NULL,NULL,NULL,1,219.917167,12.28633,0.013,NULL,59360000055,927500000,14492187,16.83),(122927,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122927,38.09,0.33,415,55000,70,NULL,NULL,'2MASX J14394046+0639344',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000143,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.9185417,6.65969,0.057,NULL,58276618740,910572167,14227690,18.1),(122928,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122928,38.14,0.46,424,55001,70,NULL,NULL,'2MASX J14394126+1857095',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.922083,18.95286,0.029,NULL,59509033375,929828646,14528572,17.9),(122929,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122929,37.3,0.46,289,55002,70,NULL,NULL,'2MASX J14394160+0219183',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000074,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,219.9234583,2.32183,0.081,NULL,58261060174,910329065,14223891,17.1),(122930,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122930,37.52,0.46,319,55003,70,NULL,NULL,'2MASX J14394479+2208404',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.9365,22.14442,0,NULL,59505070988,929766734,14527605,17.7),(122931,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122931,38.04,0.46,405,55004,70,NULL,NULL,'SDSS J143944.91+555321.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,219.937166667,55.88942,0,NULL,57259072242,894673003,13979265,18),(122932,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122932,37.44,0.15,308,55005,70,NULL,NULL,'2MASX J14394527+2255039',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.62',0.23,NULL,NULL,NULL,NULL,NULL,1,219.9385417,22.91778,0.018,NULL,59508531611,929820806,14528450,17.62),(122933,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122933,33.9,0.8,60.4,55006,75,NULL,'HMCL, I','UGC 09450',NULL,'1997ApJS..109..333W',1997,1,0.66,NULL,'G',0.000013,NULL,'16.6g',0.16,'Sdm:',NULL,NULL,NULL,NULL,1,219.93875,23.39658,0.028,NULL,59508151003,929814859,14528357,16.6),(122934,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122934,34.14,0.2,67.3,55006,74.4,NULL,NULL,'UGC 09450',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122935,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122935,34.59,0.4,82.9,55006,75,NULL,'HMCL, I, raw','UGC 09450',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122936,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122936,34.61,0.4,83.6,55006,75,NULL,'HMCL, I, inv','UGC 09450',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122937,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122937,34.88,0.4,94.6,55006,75,NULL,'HMCL, I, cor','UGC 09450',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122938,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122938,37.46,0.46,311,55007,70,NULL,NULL,'2MASX J14394549+2252449',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.939583,22.87911,0.018,NULL,59508532869,929820826,14528450,17.8),(122939,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122939,37.17,0.46,272,55008,70,NULL,NULL,'2MASX J14394573+3226125',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000156,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,219.9405,32.43678,0,NULL,60016304633,937754759,14652418,17),(122940,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122940,37.03,0.46,255,55009,70,NULL,NULL,'2MASX J14394691+4616284',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,219.945417,46.27464,0.009,NULL,59987353505,937302398,14645349,18),(122941,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122941,37.27,0.46,285,55010,70,NULL,NULL,'2MASX J14394760+0544283',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000183,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,219.9482083,5.74131,0.077,NULL,58310162443,911096288,14235879,17),(122942,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122942,36.8,0.46,230,55011,70,NULL,NULL,'VIII Zw 446 NOTES02',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.8g',0.25,'AGN',NULL,NULL,NULL,NULL,1,219.950708333,14.73875,0.009,NULL,59556758476,930574351,14540224,16.8),(122943,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122943,37.94,0.27,387,55012,70,NULL,NULL,'2MASX J14394823+2119569',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.61',0.21,NULL,NULL,NULL,NULL,NULL,1,219.950917,21.33253,0.02,NULL,59503154164,929736783,14527137,17.61),(122944,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122944,36.85,0.46,235,55013,70,NULL,NULL,'2MASX J14394845+3048165',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00013,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,219.952,30.80444,0,NULL,60017083385,937766927,14652608,18.1),(122945,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122945,32.17,0.8,27.1,55014,75,NULL,'MAT, I','NGC 5705',NULL,'1997ApJS..109..333W',1997,1,2.9,'Confused HIPASS source','G',0.000013,NULL,'13.3',1.7,'SB(rs)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,219.957041667,-0.71847,0.109,NULL,43491560475,679555632,10618056,13.3),(122946,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122946,32.18,0.8,27.3,55014,75,NULL,'A82, H','NGC 5705',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122947,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122947,31.46,0.2,19.6,55014,74.4,NULL,NULL,'NGC 5705',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122948,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122948,31.55,0.32,20.4,55014,85,NULL,'I, inv','NGC 5705',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122949,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122949,31.56,0.32,20.5,55014,85,NULL,'I, raw','NGC 5705',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122950,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122950,31.6,0.38,20.9,55014,NULL,NULL,NULL,'NGC 5705',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122951,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122951,31.95,0.43,24.6,55014,75,NULL,'MAT, I, raw','NGC 5705',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122952,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122952,31.98,0.43,24.9,55014,75,NULL,'MAT, I, inv','NGC 5705',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122953,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122953,32.07,0.4,26,55014,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5705',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122954,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122954,32.16,0.43,27,55014,75,NULL,'MAT, I, cor','NGC 5705',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122955,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122955,32.21,NULL,27.7,55014,72,NULL,NULL,'NGC 5705',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122956,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122956,32.29,0.4,28.8,55014,75,NULL,'B','NGC 5705',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122957,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122957,32.55,0.47,32.3,55014,75,NULL,'A82, H, inv','NGC 5705',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122958,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122958,32.55,0.47,32.4,55014,75,NULL,'A82, H, raw','NGC 5705',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122959,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122959,32.62,0.47,33.4,55014,75,NULL,'A82, H, cor','NGC 5705',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122960,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122960,37.63,0.46,336,55015,70,NULL,NULL,'2MASX J14395125+3447075',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000192,NULL,'16.2g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,219.9635,34.78528,0,NULL,60070467542,938601055,14665641,16.2),(122961,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122961,37.77,0.46,358,55016,70,NULL,NULL,'SDSS J143951.42+535432.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000169,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,219.96425,53.90906,0,NULL,59192074501,924876164,14451190,18.2),(122962,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122962,33.35,0.48,46.8,55017,70,NULL,NULL,'IC 4476',NULL,'2014MNRAS.445.2677S',2014,1,1,'6dF DR2 has z = 0.013824.','G',0.000143,NULL,'15.43',0.8,NULL,NULL,NULL,NULL,NULL,1,219.9660417,-16.24475,0.373,NULL,46681163198,729393174,11396768,15.43),(122963,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122963,32.21,0.4,27.6,55018,75,NULL,NULL,'NGC 5730',NULL,'2008Ap.....51..336K',2008,1,1.42,NULL,'G',0.000017,NULL,'14.2g',0.44,'Im:            Sbrst','Pair member (points to parent)',NULL,NULL,NULL,1,219.967333,42.74236,0.014,NULL,59958235876,936847435,14638241,14.2),(122964,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122964,33.06,0.49,41,55018,75,NULL,'IR','NGC 5730',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122965,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122965,37.05,0.46,257,55019,70,NULL,NULL,'2MASX J14395246+0931401',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000174,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,219.9685,9.52783,0.009,NULL,59372944940,927702264,14495347,16.5),(122966,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122966,37.1,0.46,263,55020,70,NULL,NULL,'2MASX J14395384+1007551',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000191,NULL,'16.1g',0.38,NULL,NULL,NULL,NULL,NULL,1,219.9745417,10.13186,0.013,NULL,59373593061,927712391,14495506,16.1),(122967,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122967,38.44,0.46,487,55021,70,NULL,NULL,'2MASX J14395474+2859314',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,219.9782917,28.99214,0,NULL,60017621991,937775343,14652739,18.2),(122968,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122968,36.43,0.46,193,55022,70,NULL,NULL,'2MASX J14395484+6138046',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,219.978458333,61.63461,0.017,NULL,57759808158,902497002,14101515,16.6),(122969,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122969,37.48,0.46,313,55023,70,NULL,NULL,'2MASX J14395508+4220074',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000175,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,219.979375,42.33533,0.034,NULL,59961224157,936894127,14638970,16.6),(122970,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122970,35.79,0.1,144,55024,70,NULL,NULL,'2MASX J14395699+0349323',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00007,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,219.987416667,3.82561,0.069,NULL,58312265765,911129152,14236393,16.5),(122971,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122971,36.26,0.33,179,55025,70,NULL,NULL,'2MASX J14395703+2133420',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,219.987667,21.56158,0.02,NULL,59503233057,929738016,14527156,16.1),(122972,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122972,37.94,0.27,387,55026,70,NULL,NULL,'2MASX J14395803+2119260',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.62',0.14,NULL,NULL,NULL,NULL,NULL,1,219.991916667,21.32397,0.02,NULL,59503616893,929744013,14527250,18.62),(122973,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122973,38.03,0.46,403,55027,70,NULL,NULL,'2MASXi J1439587+140926',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.994541667,14.15733,0.017,NULL,59558329117,930598892,14540607,17.9),(122974,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122974,36.33,0.46,185,55028,70,NULL,NULL,'SDSS J143958.78+130127.0',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.3g',0.32,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.994917,13.02419,0,NULL,59543455718,930366495,14536976,16.3),(122975,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122975,37.91,0.33,383,55029,70,NULL,NULL,'2MASX J14395900+1806430',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.41',0.16,'BrClG',NULL,NULL,NULL,NULL,1,219.995833,18.11186,0,NULL,59550802186,930481284,14538770,18.41),(122976,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122976,37.28,0.46,285,55030,70,NULL,NULL,'2MASX J14395920+3744525',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000156,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,219.996625,37.74808,0,NULL,60078865831,938732278,14667691,16.7),(122977,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122977,38.13,0.16,422,55031,70,NULL,NULL,'2MASX J14395939+3703534',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000155,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,219.997666667,37.06494,0,NULL,60078528781,938727012,14667609,18.5),(122978,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122978,38.13,0.16,422,55032,70,NULL,NULL,'SDSS J144000.64+370547.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000147,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,220.0027083,37.09661,0,NULL,60078527059,938726985,14667609,18.5),(122979,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122979,37.79,0.46,361,55033,70,NULL,NULL,'2MASX J14400147+5034064',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.006083,50.56853,0.025,NULL,59200496579,925007759,14453246,17.8),(122980,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122980,38.34,0.46,466,55034,70,NULL,NULL,'SDSS J144001.60+525530.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,220.006708333,52.92508,0,NULL,59191330880,924864545,14451008,18.6),(122981,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122981,36.81,0.46,230,55035,70,NULL,NULL,'2MASX J14400208+1101081',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000179,NULL,'16.0g',0.36,NULL,NULL,NULL,NULL,NULL,1,220.008708333,11.01897,0.013,NULL,59371931800,927686434,14495100,16),(122982,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122982,37.83,0.33,369,55036,70,NULL,NULL,'2MASX J14400267+0700231',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,220.011083333,7.00644,0.041,NULL,58276059541,910563430,14227553,17.3),(122983,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122983,38.13,0.16,422,55037,70,NULL,NULL,'2MASX J14400273+3711035',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,220.011417,37.1845,0,NULL,60078498349,938726536,14667602,17.3),(122984,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122984,38.13,0.16,422,55038,70,NULL,NULL,'LCSB S2067P',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000189,NULL,'16.6g',0.38,'BrClG',NULL,NULL,NULL,'USS',1,220.014375,37.12428,0,NULL,60078526571,938726977,14667609,16.6),(122985,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,122985,34.8,0.46,91,55039,70,NULL,NULL,'ESO 386- G 002',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'15',1.3,'S0',NULL,NULL,NULL,NULL,1,220.016166667,-36.62742,0.249,NULL,47223980855,737874700,11529292,15),(122986,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122986,38.13,0.16,422,55040,70,NULL,NULL,'2MASX J14400390+3706555',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.95',0.19,NULL,NULL,NULL,NULL,NULL,1,220.0162083,37.11547,0,NULL,60078526663,938726979,14667609,17.95),(122987,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122987,37.91,0.33,383,55041,70,NULL,NULL,'SDSS J144005.13+181509.2',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.021417,18.25258,0,NULL,59479583749,929368496,14521382,17.9),(122988,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122988,37.94,0.27,387,55042,70,NULL,NULL,'2MASX J14400555+2127240',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.43',0.14,NULL,NULL,NULL,NULL,NULL,1,220.023208333,21.45658,0.02,NULL,59503178933,929737170,14527143,18.43),(122989,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122989,37.29,0.46,287,55043,70,NULL,NULL,'2MASX J14400569+5003023',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,220.023583,50.05056,0.037,NULL,59200178782,925002793,14453168,17.3),(122990,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122990,38.26,0.46,450,55044,70,NULL,NULL,'2MASX J14400687+2021290',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.32',0.16,NULL,NULL,NULL,NULL,NULL,1,220.028583,20.35806,0.012,NULL,59503909769,929748590,14527321,18.32),(122991,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122991,37.04,0.46,256,55045,70,NULL,NULL,'2MASX J14400697+3109476',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00019,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,220.029167,31.16308,0,NULL,60017111571,937767368,14652615,16.3),(122992,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122992,36.91,0.46,241,55046,70,NULL,NULL,'SDSS J144007.11+522401.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,220.029667,52.40047,0,NULL,59203932331,925061442,14454085,17.8),(122993,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122993,38.19,0.46,434,55047,70,NULL,NULL,'2MASXi J1440079+123918',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000159,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.032917,12.65486,0,NULL,59543638397,930369349,14537021,17.6),(122994,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122994,38.02,0.46,402,55048,70,NULL,NULL,'2MASX J14400922+1630578',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.45',0.16,NULL,NULL,NULL,NULL,NULL,1,220.0385,16.51614,0.008,NULL,59554468433,930538569,14539665,18.45),(122995,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122995,38.09,0.27,415,55049,70,NULL,NULL,'2MASX J14400936+3633425',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,220.039,36.56164,0,NULL,60075562802,938680668,14666885,17.9),(122996,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122996,38.71,0.46,551,55050,70,NULL,NULL,'2MASX J14401066+2244149',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000177,NULL,'17.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,220.0445417,22.73753,0.008,NULL,59508403871,929818810,14528418,17.4),(122997,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,122997,32.66,0.8,34,55051,75,NULL,'MAT, I','IC 4472',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000024,NULL,'13.92',0.5,'Sc? sp',NULL,NULL,NULL,NULL,1,220.045167,-44.31458,0.501,NULL,47082930342,735670786,11494856,13.92),(122998,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122998,32.15,0.4,26.9,55051,75,NULL,NULL,'IC 4472',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122999,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,122999,32.25,0.43,28.2,55051,75,NULL,'MAT, I, raw','IC 4472',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123000,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123000,32.3,0.32,28.8,55051,85,NULL,'I, raw','IC 4472',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123001,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123001,32.33,0.4,29.2,55051,NULL,NULL,NULL,'IC 4472',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123002,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123002,32.33,0.32,29.3,55051,85,NULL,'I, inv','IC 4472',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123003,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123003,32.44,0.43,30.8,55051,75,NULL,'MAT, I, inv','IC 4472',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123004,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123004,32.53,0.43,32.1,55051,75,NULL,'MAT, I, cor','IC 4472',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123005,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123005,32.69,0.49,34.6,55051,75,NULL,'IR','IC 4472',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123006,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123006,33.31,0.8,45.9,55052,75,NULL,'MAT, I','ESO 512- G 012',NULL,'1997ApJS..109..333W',1997,1,3.02,'ESO-LV has V = 1839 +- 10 km/sec.','G',0.000033,NULL,'14.32',0.34,'Sbc            HII',NULL,NULL,NULL,NULL,1,220.0475417,-25.77661,0.461,NULL,47024553548,734758649,11480603,14.32),(123007,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123007,32.44,NULL,30.8,55052,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 512- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123008,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123008,32.45,NULL,30.8,55052,NULL,NULL,'Dipole + Quadrupole','ESO 512- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123009,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123009,32.46,NULL,31,55052,NULL,NULL,'Dipole','ESO 512- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123010,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123010,32.48,NULL,31.4,55052,NULL,NULL,NULL,'ESO 512- G 012',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123011,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123011,33.56,0.43,51.5,55052,75,NULL,'MAT, I, raw','ESO 512- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123012,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123012,33.65,0.32,53.7,55052,85,NULL,'I, raw','ESO 512- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123013,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123013,33.72,0.32,55.5,55052,85,NULL,'I, inv','ESO 512- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123014,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123014,33.73,0.42,55.7,55052,NULL,NULL,'Malmquist cor.','ESO 512- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123015,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123015,33.74,0.2,56,55052,74.4,NULL,NULL,'ESO 512- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123016,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123016,33.78,0.43,57,55052,75,NULL,'MAT, I, cor','ESO 512- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123017,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123017,33.86,0.43,59.1,55052,75,NULL,'MAT, I, inv','ESO 512- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123018,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123018,33.92,0.38,60.7,55052,NULL,NULL,NULL,'ESO 512- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123019,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123019,32.33,0.8,29.3,55053,75,NULL,'MAT, I','NGC 5713',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.000023,NULL,'12.18',2.5,'SAB(rs)bc pec  HII','in a pair',NULL,NULL,NULL,1,220.0479583,-0.28897,0.105,NULL,43491640322,679556880,10618076,12.18),(123020,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123020,30.67,NULL,13.6,55053,65.2,NULL,'CO','NGC 5713',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123021,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123021,31.31,0.43,18.3,55053,75,NULL,'MAT, I, raw','NGC 5713',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123022,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123022,31.42,0.32,19.2,55053,85,NULL,'I, raw','NGC 5713',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123023,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123023,31.45,0.32,19.5,55053,85,NULL,'I, inv','NGC 5713',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (123024,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123024,31.46,0.43,19.6,55053,75,NULL,'MAT, I, inv','NGC 5713',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123025,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123025,31.65,0.43,21.4,55053,75,NULL,'MAT, I, cor','NGC 5713',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123026,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123026,31.65,NULL,21.4,55053,54,NULL,'HI','NGC 5713',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123027,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123027,32.42,0.4,30.4,55053,75,NULL,'B','NGC 5713',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123028,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123028,35.41,0.62,121,55054,70,NULL,NULL,'2MASX J14401261-4220215',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,220.052625,-42.33931,0.357,NULL,47093340809,735833450,11497397,14.4),(123029,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123029,36.27,0.46,180,55055,70,NULL,NULL,'2MASX J14401291+2657362',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.96',0.24,NULL,NULL,NULL,NULL,NULL,1,220.053917,26.96014,0.031,NULL,60026401342,937912520,14654883,16.96),(123030,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123030,36.9,0.46,240,55056,70,NULL,NULL,'2MASX J14401299+3409566',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000209,NULL,'15.8g',0.42,'E0',NULL,NULL,NULL,NULL,1,220.054083333,34.16578,0,NULL,60066972949,938546452,14664788,15.8),(123031,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123031,36.28,0.46,180,55057,70,NULL,NULL,'2MASX J14401309+1953309',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.71',0.22,NULL,NULL,NULL,NULL,NULL,1,220.054708333,19.89183,0.015,NULL,59501005427,929703209,14526612,16.71),(123032,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123032,38.13,0.16,422,55058,70,NULL,NULL,'2MASX J14401410+3701385',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00018,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,220.05875,37.02742,0,NULL,60075698832,938682794,14666918,16.8),(123033,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123033,38.7,0.46,550,55059,70,NULL,NULL,'2MASX J14401450+0315491',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000091,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,220.060583,3.26367,0.077,NULL,58255773864,910246466,14222601,17.4),(123034,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123034,37.52,0.46,319,55060,70,NULL,NULL,'2MASX J14401550+0504101',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000084,NULL,'17.0g',0.25,'NLAGN',NULL,NULL,NULL,'Sy 2',1,220.064666667,5.06964,0.089,NULL,58309900498,911092195,14235815,17),(123035,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123035,35.79,0.1,144,55061,70,NULL,NULL,'2MASX J14401636+0331121',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00006,NULL,'16.2g',0.32,'S0',NULL,NULL,NULL,NULL,1,220.068333333,3.52014,0.077,NULL,58311412843,911115825,14236184,16.2),(123036,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123036,37.44,0.15,308,55062,70,NULL,NULL,'2MASX J14401781+2252273',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000176,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,220.0742917,22.87444,0,NULL,59508585264,929821644,14528463,16.9),(123037,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123037,36.66,0.33,215,55063,70,NULL,NULL,'2MASX J14401795+0556341',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000205,NULL,'15.5g',0.51,'BrClG;Cand.grav.lens',NULL,NULL,NULL,NULL,1,220.074917,5.94281,0.069,NULL,58309284093,911082563,14235665,15.5),(123038,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123038,38.24,0.46,445,55064,70,NULL,NULL,'SDSS J144018.08-022633.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,220.075375,-2.44269,0.189,NULL,43491959479,679561866,10618154,18.4),(123039,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123039,35.3,0.38,115,55065,NULL,NULL,'Malmquist cor.','IC 4483',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.00003,NULL,'14.71',0.5,'Sb',NULL,NULL,NULL,NULL,1,220.081291667,16.68522,0,NULL,59554495687,930538995,14539671,14.71),(123040,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123040,35.37,0.37,118,55065,NULL,NULL,NULL,'IC 4483',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123041,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123041,35.53,0.2,128,55065,74.4,NULL,NULL,'IC 4483',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123042,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123042,37.9,0.46,381,55066,70,NULL,NULL,'2MASX J14402062+3826595',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.085917,38.44981,0,NULL,60076816290,938700254,14667191,17.3),(123043,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123043,38.12,0.46,421,55067,70,NULL,NULL,'SDSS J144024.32+131851.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,220.101375,13.31433,0.005,NULL,59557667377,930588552,14540446,17.8),(123044,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123044,37.44,0.15,308,55068,70,NULL,NULL,'SDSS J144024.92+231605.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000161,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.103875,23.26833,0,NULL,59508177950,929815280,14528363,18.3),(123045,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123045,38.2,0.46,436,55069,70,NULL,NULL,'2MASX J14402525+5524390',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,220.105417,55.41075,0.005,NULL,57246706053,894479782,13976246,18.3),(123046,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123046,32.15,0.4,26.9,55070,75,NULL,'B','NGC 5727',NULL,'1988NBGC.C....0000T',1988,1,1.91,NULL,'G',0.000006,NULL,'14.1g',0.81,'SABdm','Isolated galaxy',NULL,NULL,NULL,1,220.108833,33.98911,0,NULL,60067055337,938547739,14664808,14.1),(123047,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123047,33.17,0.4,43.1,55070,NULL,NULL,NULL,'NGC 5727',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123048,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123048,38.11,0.33,419,55071,70,NULL,NULL,'2MASX J14402663+2337293',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.1110417,23.62478,0.034,NULL,59507072633,929798009,14528093,17.8),(123049,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123049,35.86,0.33,148,55072,70,NULL,NULL,'CGCG 104-065',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000183,NULL,'16.70',0.34,NULL,NULL,NULL,NULL,NULL,1,220.1169583,14.82725,0.013,NULL,59558671873,930604248,14540691,16.7),(123050,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123050,38.13,0.16,422,55073,70,NULL,NULL,'2MASX J14402823+3713416',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,220.117625,37.22817,0,NULL,60075677899,938682467,14666913,17.6),(123051,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123051,36.95,0.46,245,55074,70,NULL,NULL,'2MASX J14402823+2624302',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.27',0.16,NULL,NULL,NULL,NULL,NULL,1,220.117666667,26.40836,0.039,NULL,60026757016,937918078,14654969,18.27),(123052,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123052,36.66,0.33,215,55075,70,NULL,NULL,'2MASX J14402854+0558131',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000172,NULL,'16.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,220.118875,5.97025,0.069,NULL,58309340285,911083441,14235678,16.6),(123053,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123053,36.75,0.67,223,55076,70,NULL,NULL,'2MASX J14402883-2926485',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.3b',0.4,'E',NULL,NULL,NULL,NULL,1,220.120167,-29.44678,0.497,NULL,47021512559,734711133,11479861,15.3),(123054,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123054,35.69,0.46,138,55077,70,NULL,NULL,'2MASX J14402974+0230101',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000066,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,220.123875,2.50286,0.085,NULL,58261231386,910331740,14223933,16.3),(123055,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123055,37.52,0.46,319,55078,70,NULL,NULL,'2MASX J14403083+0645539',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000151,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,220.128375,6.76483,0.065,NULL,58275740796,910558449,14227475,17.4),(123056,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123056,36.6,0.46,209,55079,70,NULL,NULL,'2MASX J14403092+1123259',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.73',0.22,NULL,NULL,NULL,NULL,NULL,1,220.128833,11.39056,0.009,NULL,59371825108,927684767,14495074,17.73),(123057,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123057,38.11,0.33,419,55080,70,NULL,NULL,'SDSS J144030.94+233340.3',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000185,NULL,'16.3g',0.35,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.1289583,23.56122,0.028,NULL,59507023950,929797249,14528082,16.3),(123058,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123058,38.09,0.27,415,55081,70,NULL,NULL,'2MASX J14403114+3637516',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000188,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,220.129625,36.63094,0,NULL,60075778819,938684044,14666938,17.6),(123059,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123059,36.8,0.2,229,55082,74.4,NULL,NULL,'IC 4485',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00014,NULL,'15.7',0.4,NULL,NULL,NULL,NULL,NULL,1,220.131083333,28.66886,0,NULL,60028146896,937939795,14655309,15.7),(123060,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123060,37.44,0.15,308,55083,70,NULL,NULL,'SDSS J144031.68+231629.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000148,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,220.1320417,23.27497,0,NULL,59508177905,929815279,14528363,18.4),(123061,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123061,35.79,0.1,144,55084,70,NULL,NULL,'SDSS J144032.44+033334.3',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00005,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,220.135166667,3.55953,0.069,NULL,58255894279,910248348,14222630,16.8),(123062,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123062,37.68,0.46,344,55085,70,NULL,NULL,'SDSS J144032.53+530301.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000124,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,220.135541667,53.05033,0,NULL,59191334897,924864607,14451009,18.7),(123063,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123063,37.32,0.46,291,55086,70,NULL,NULL,'2MASX J14403342+5508190',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000158,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,220.139125,55.13867,0,NULL,57246767128,894480736,13976261,17.3),(123064,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123064,37.03,0.46,255,55087,70,NULL,NULL,'2MASX J14403552+2644011',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.47',0.21,NULL,NULL,NULL,NULL,NULL,1,220.1479583,26.73353,0.036,NULL,60026578439,937915288,14654926,17.47),(123065,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123065,35.79,0.1,144,55088,70,NULL,NULL,'2MASX J14403693+0327531',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00005,NULL,'16.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.1540417,3.46469,0.077,NULL,58255886227,910248222,14222628,16.8),(123066,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123066,38.3,0.46,458,55089,70,NULL,NULL,'2MASX J14403758+2932051',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000134,NULL,'19.04',0.12,NULL,NULL,NULL,NULL,NULL,1,220.1565,29.53475,0,NULL,60019676700,937807448,14653241,19.04),(123067,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123067,36.97,0.46,248,55090,70,NULL,NULL,'SDSS J144038.57+124336.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,220.16075,12.72683,0.005,NULL,59543495744,930367121,14536986,17.8),(123068,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123068,37.8,0.46,363,55091,70,NULL,NULL,'SDSS J144038.75+032356.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000069,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,220.1615,3.39908,0.077,NULL,58255952944,910249264,14222644,18),(123069,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123069,33.65,0.8,53.7,55092,75,NULL,'CF, r','NGC 5732',NULL,'1997ApJS..109..333W',1997,1,1.45,NULL,'G',0.000053,NULL,'14.1g',0.71,'Sbc','in a pair',NULL,NULL,NULL,1,220.1622917,38.63781,0,NULL,60076849812,938700778,14667199,14.1),(123070,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123070,33.85,0.38,58.8,55092,75,NULL,'CF, r, raw','NGC 5732',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123071,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123071,33.92,0.38,60.9,55092,75,NULL,'CF, r, inv','NGC 5732',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123072,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123072,34.04,0.38,64.4,55092,75,NULL,'CF, r, cor','NGC 5732',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123073,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123073,34.08,0.45,65.6,55093,NULL,NULL,'K','IC 1042',NULL,'2007A&A...465...71T',2007,1,0.98,NULL,'G',0.000043,NULL,'14.5g',0.87,'S0?','Pair member (points to parent)',NULL,NULL,NULL,1,220.162583333,3.46972,0.077,NULL,58255899215,910248425,14222631,14.5),(123074,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123074,35.22,0.4,111,55093,NULL,NULL,'mean','IC 1042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123075,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123075,38.04,0.46,405,55094,70,NULL,NULL,'2MASX J14403998+0137415',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000078,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,220.1667083,1.62803,0.105,NULL,58261370988,910333921,14223967,17.8),(123076,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123076,38.81,0.46,578,55095,70,NULL,NULL,'SDSS J144040.04+202609.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.166875,20.43597,0.015,NULL,59503925022,929748828,14527325,18.2),(123077,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123077,35.85,0.46,148,55096,70,NULL,NULL,'MRK 0821',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',NULL,NULL,'16.0',0.5,'Compact',NULL,NULL,NULL,NULL,1,220.167791667,16.66308,0.008,NULL,59554760653,930543135,14539736,16),(123078,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123078,37.44,0.15,308,55097,70,NULL,NULL,'2MASX J14404114+2310503',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.58',0.14,NULL,NULL,NULL,NULL,NULL,1,220.171541667,23.18069,0,NULL,59508674254,929823035,14528484,18.58),(123079,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123079,36.14,0.46,169,55098,70,NULL,NULL,'2MASX J14404122+6019379',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000074,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,220.171791667,60.32722,0,NULL,57771709137,902682955,14104421,17),(123080,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123080,37.04,0.33,256,55099,70,NULL,NULL,'2MASX J14404276+3311259',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000175,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,220.1782917,33.19061,0,NULL,60121304020,939395375,14678052,17.2),(123081,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123081,34.5,0.45,79.3,55100,NULL,NULL,'K','NGC 5718',NULL,'2007A&A...465...71T',2007,1,1.43,NULL,'G',0.00004,NULL,'13.8g',0.98,'S0-:;BrClG','Pair member (points to parent)',NULL,NULL,NULL,1,220.1785,3.46542,0.069,NULL,58255898715,910248417,14222631,13.8),(123082,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123082,35.3,0.4,115,55100,NULL,NULL,'mean','NGC 5718',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123083,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123083,35.79,0.1,144,55101,70,NULL,NULL,'IC 1043',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000073,NULL,'15.5g',0.3,'Sa',NULL,NULL,NULL,NULL,1,220.180625,3.37403,0.077,NULL,58255964863,910249450,14222647,15.5),(123084,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123084,38.13,0.16,422,55102,70,NULL,NULL,'2MASX J14404332+3700537',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,220.1807083,37.015,0,NULL,60075723343,938683177,14666924,17),(123085,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123085,35.79,0.1,144,55103,70,NULL,NULL,'CGCG 047-136',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000057,NULL,'15.3g',0.51,'Sa','Group member',NULL,NULL,NULL,1,220.1812917,3.25406,0.113,NULL,58255780102,910246564,14222602,15.3),(123086,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123086,35.43,0.49,122,55104,75,NULL,'IR','FGC 1792',NULL,'2011yCatp016004901K',2011,1,0.96,NULL,'G',0.000008,NULL,'16.5',0.1,'Sbc',NULL,NULL,NULL,NULL,1,220.1852917,14.36342,0.017,NULL,59558235388,930597427,14540584,16.5),(123087,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123087,35.89,NULL,151,55104,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1792',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123088,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123088,35.9,NULL,152,55104,NULL,NULL,'Dipole + Quadrupole','FGC 1792',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123089,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123089,35.92,NULL,152,55104,NULL,NULL,NULL,'FGC 1792',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123090,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123090,35.93,NULL,154,55104,NULL,NULL,'Dipole','FGC 1792',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123091,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123091,36.29,0.2,181,55104,74.4,NULL,NULL,'FGC 1792',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123092,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123092,37.04,0.46,256,55105,70,NULL,NULL,'2MASX J14404549+0522495',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000193,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,220.1895,5.38042,0.097,NULL,58310100300,911095317,14235864,16.2),(123093,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123093,33.93,0.8,61.2,55106,75,NULL,'MAT, I','ESO 386- G 006',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'14.86',0.3,'SAab pec:','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,220.189666667,-35.14806,0.237,NULL,47223052052,737860188,11529065,14.86),(123094,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123094,33.32,0.32,46.2,55106,85,NULL,'I, raw','ESO 386- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123095,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123095,33.35,0.32,46.8,55106,85,NULL,'I, inv','ESO 386- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123096,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123096,33.46,0.2,49.2,55106,74.4,NULL,NULL,'ESO 386- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123097,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123097,33.54,0.43,51,55106,75,NULL,'MAT, I, raw','ESO 386- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123098,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123098,33.64,0.39,53.5,55106,NULL,NULL,NULL,'ESO 386- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123099,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123099,33.68,0.43,54.5,55106,75,NULL,'MAT, I, inv','ESO 386- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123100,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123100,33.79,0.37,57.3,55106,NULL,NULL,'Malmquist cor.','ESO 386- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123101,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123101,33.82,0.43,58,55106,75,NULL,'MAT, I, cor','ESO 386- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123102,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123102,33.97,0.4,62.4,55106,NULL,NULL,'mean','ESO 386- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123103,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123103,34.24,0.47,70.6,55106,NULL,NULL,'H','ESO 386- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123104,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123104,35.79,0.1,144,55107,70,NULL,NULL,'CGCG 047-138',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000083,NULL,'15.5g',0.38,'S0/a','Group member',NULL,NULL,NULL,1,220.192125,3.09883,0.137,NULL,58255794645,910246791,14222606,15.5),(123105,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123105,37.79,0.33,361,55108,70,NULL,NULL,'2MASX J14404653+1822341',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,220.1939583,18.37631,0.053,NULL,59550745540,930480399,14538756,17.3),(123106,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123106,37.58,0.46,329,55109,70,NULL,NULL,'LCRS B143811.4-022307',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000147,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,220.1957083,-2.59886,0.189,NULL,43492029427,679562959,10618171,17.1),(123107,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123107,36.93,0.46,243,55110,70,NULL,NULL,'2MASX J14404847+1840441',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,220.201875,18.67889,0.035,NULL,59479484505,929366945,14521358,17.6),(123108,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123108,37.75,0.46,355,55111,70,NULL,NULL,'2MASX J14404870+5455229',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00019,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,220.202917,54.92319,0,NULL,57246898686,894482791,13976293,16.6),(123109,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123109,38.13,0.46,422,55112,70,NULL,NULL,'2MASX J14404965+2225441',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,220.206917,22.42903,0.03,NULL,59508487609,929820118,14528439,18.3),(123110,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123110,37.79,0.33,361,55113,70,NULL,NULL,'2MASX J14404983+1823101',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,220.2077083,18.38608,0.053,NULL,59550745359,930480396,14538756,18.2),(123111,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123111,37.9,0.46,380,55114,70,NULL,NULL,'2MASX J14405053+5539239',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000137,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,220.2102083,55.65658,0,NULL,57247064371,894485380,13976334,17.5),(123112,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123112,37.44,0.15,308,55115,70,NULL,NULL,'2MASX J14405062+2325501',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000174,NULL,'18.19',0.15,NULL,NULL,NULL,NULL,NULL,1,220.211,23.43058,0,NULL,59508140403,929814693,14528354,18.19),(123113,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123113,36.57,0.33,206,55116,70,NULL,NULL,'2MASX J14405080+1033032',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000183,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,220.211833,10.55078,0,NULL,59373690936,927713920,14495530,16.2),(123114,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123114,35.79,0.1,144,55117,70,NULL,NULL,'CGCG 047-140',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00006,NULL,'15.3g',0.38,'S0^-','Group member',NULL,NULL,NULL,1,220.219541667,3.41831,0.069,NULL,58255959680,910249370,14222646,15.3),(123115,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123115,37.95,0.46,389,55118,70,NULL,NULL,'SDSS J144054.29+340841.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,220.2262083,34.14481,0,NULL,60067102072,938548469,14664819,18.2),(123116,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123116,37.94,0.33,387,55119,70,NULL,NULL,'2MASX J14405444+1850562',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,220.227,18.84889,0.04,NULL,59508795615,929824931,14528514,18),(123117,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123117,37.94,0.46,387,55120,70,NULL,NULL,'2MASX J14405490+2813350',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.228916667,28.22636,0.017,NULL,60028349809,937942965,14655358,17.7),(123118,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123118,37.13,0.46,267,55121,70,NULL,NULL,'2MASX J14405496+0935322',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.229125,9.59225,0.037,NULL,59372832790,927700512,14495320,17),(123119,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123119,37.92,0.46,384,55122,70,NULL,NULL,'2MASX J14405530-0124364',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000159,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,220.230417,-1.41008,0.101,NULL,43494537888,679602154,10618783,17),(123120,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123120,38.09,0.27,415,55123,70,NULL,NULL,'2MASX J14405540+3637587',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000147,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,220.23075,36.63303,0,NULL,60075783079,938684110,14666939,17.8),(123121,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123121,38.35,0.33,468,55124,70,NULL,NULL,'2MASX J14405633+2543550',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,220.234833,25.732,0.053,NULL,60025958548,937905602,14654775,18.1),(123122,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123122,31.92,0.45,24.2,55125,NULL,NULL,'K','NGC 5719',NULL,'2007A&A...465...71T',2007,1,3.01,'One APM position is on the eastern end of the bulge.','G',0.00001,NULL,'12.8g',1,'SAB(s)ab pec   NLAGN','in a pair',NULL,NULL,NULL,1,220.234833,-0.31822,0.105,NULL,43491472799,679554262,10618035,12.8),(123123,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123123,31.94,0.47,24.5,55125,NULL,NULL,'H','NGC 5719',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123124,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123124,32.01,0.43,25.3,55125,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5719',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123125,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123125,32.05,0.46,25.7,55125,NULL,NULL,'J','NGC 5719',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123126,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123126,32.08,0.49,26,55125,NULL,NULL,'Malmquist cor.','NGC 5719',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123127,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123127,32.07,NULL,26,55125,72,NULL,NULL,'NGC 5719',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123128,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123128,32.14,0.4,26.8,55125,NULL,NULL,'mean','NGC 5719',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123129,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123129,32.14,0.43,26.8,55125,75,NULL,'3.6 micron, color corrected','NGC 5719',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123130,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123130,32.15,0.4,26.9,55125,NULL,NULL,NULL,'NGC 5719',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123131,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123131,32.22,0.46,27.8,55125,NULL,NULL,NULL,'NGC 5719',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123132,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123132,32.23,0.2,27.9,55125,74.4,NULL,NULL,'NGC 5719',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123133,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123133,38.23,0.46,442,55126,70,NULL,NULL,'SDSS J144056.61+030910.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000086,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,220.235917,3.153,0.137,NULL,58255766133,910246345,14222599,17.9),(123134,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123134,35.79,0.1,144,55127,70,NULL,NULL,'2MASX J14405803+0327055',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000073,NULL,'15.7g',0.32,'S0^-',NULL,NULL,NULL,NULL,1,220.241916667,3.45156,0.069,NULL,58255889260,910248269,14222629,15.7),(123135,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123135,31.94,NULL,24.4,55128,72,NULL,NULL,'NGC 5725',NULL,'2014Ap.....57..457K',2014,1,1.1,NULL,'G',0.00002,NULL,'14.25',0.7,'SB(s)d:','in a radial-velocity based grouping',NULL,NULL,NULL,1,220.243,2.18656,0.097,NULL,58261976432,910343381,14224115,14.25),(123136,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123136,37.37,0.46,298,55129,70,NULL,NULL,'2MASX J14405867+4628073',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000171,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,220.244625,46.46872,0,NULL,59987397747,937303089,14645360,16.8),(123137,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123137,37.02,0.46,253,55130,70,NULL,NULL,'2MASX J14405878+4507503',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000178,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,220.244708333,45.13081,0.017,NULL,59955981085,936812204,14637690,16.3),(123138,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123138,38.44,0.46,487,55131,70,NULL,NULL,'2MASX J14405941+0033415',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000084,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.2475417,0.56158,0.125,NULL,58259271121,910301111,14223454,17.4),(123139,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123139,36.6,0.33,209,55132,70,NULL,NULL,'2MASX J14410063+1429402',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.69',0.17,NULL,NULL,NULL,NULL,NULL,1,220.2525417,14.49456,0.029,NULL,59558949259,930608582,14540759,17.69),(123140,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123140,38.42,0.46,484,55133,70,NULL,NULL,'LCRS B143826.7-022940',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,220.259916667,-2.70792,0.189,NULL,43491803756,679559433,10618116,18.5),(123141,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123141,37.42,0.46,305,55134,70,NULL,NULL,'2MASX J14410373+1959102',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.265583,19.98625,0,NULL,59501213825,929706466,14526663,17.5),(123142,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123142,37.94,0.33,387,55135,70,NULL,NULL,'2MASX J14410486+1851152',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.26',0.17,'BrClG',NULL,NULL,NULL,NULL,1,220.270417,18.85433,0.04,NULL,59508798159,929824971,14528515,18.26),(123143,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123143,32.95,0.47,38.9,55136,NULL,NULL,'H','NGC 5716',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.00001,NULL,'13.25',1.3,'SB(rs)c?       HII','in a pair',NULL,NULL,NULL,1,220.273,-17.47697,0.341,NULL,46679225420,729362897,11396295,13.25),(123144,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123144,33.01,0.46,40.1,55136,NULL,NULL,'J','NGC 5716',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123145,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123145,33.03,0.45,40.3,55136,NULL,NULL,'K','NGC 5716',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123146,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123146,33.64,0.4,53.6,55136,NULL,NULL,'mean','NGC 5716',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123147,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123147,37.04,0.46,256,55137,70,NULL,NULL,'2MASX J14410575+3002089',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000157,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,220.274083,30.03578,0,NULL,60020411133,937818923,14653420,16.8),(123148,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123148,38.21,0.46,438,55138,70,NULL,NULL,'2MASXi J1441061+501521',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,220.275583,50.25617,0.049,NULL,59200345337,925005395,14453209,17.7),(123149,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123149,38.52,0.46,505,55139,70,NULL,NULL,'2MASX J14410619+0124209',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000078,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.275833,1.40569,0.105,NULL,58262483659,910351307,14224239,17.6),(123150,'IRAS','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123150,33.19,0.8,43.5,55140,75,NULL,'MAT, I','ESO 327- G 007',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000026,NULL,'12.60',1.2,'SAB(rs)bc',NULL,NULL,NULL,NULL,1,220.276167,-39.98642,0.261,NULL,47217492604,737773321,11527708,12.6),(123151,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123151,32.72,0.32,35,55140,85,NULL,'I, raw','ESO 327- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123152,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123152,32.73,0.32,35.2,55140,85,NULL,'I, inv','ESO 327- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123153,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123153,32.8,0.43,36.3,55140,75,NULL,'MAT, I, raw','ESO 327- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123154,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123154,32.88,0.43,37.6,55140,75,NULL,'MAT, I, inv','ESO 327- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123155,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123155,33.1,0.43,41.6,55140,75,NULL,'MAT, I, cor','ESO 327- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123156,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123156,32.44,0.43,30.7,55141,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-37-011',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.000033,NULL,'14.04',0.9,'SAB(rs)a pec?',NULL,NULL,NULL,NULL,1,220.2767083,-8.87522,0.257,NULL,46466042569,726031915,11344248,14.04),(123157,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123157,37.97,0.46,393,55142,70,NULL,NULL,'SDSS J144106.63+471647.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000142,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,220.277667,47.27975,0.013,NULL,59987799836,937309372,14645458,18),(123158,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123158,38.35,0.33,468,55143,70,NULL,NULL,'2MASX J14410691+2541150',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,220.278875,25.68758,0.053,NULL,60025953820,937905528,14654773,17.6),(123159,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123159,36.73,0.46,222,55144,70,NULL,NULL,'2MASX J14410837+2112302',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.284916667,21.20836,0.015,NULL,59503637997,929744343,14527255,16.8),(123160,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123160,37.67,0.46,342,55145,70,NULL,NULL,'SDSS J144110.53+081846.7',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.8g',0.29,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.293917,8.313,0.033,NULL,59366107339,927595427,14493678,16.8),(123161,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123161,31.43,NULL,19.3,55146,NULL,NULL,NULL,'FGC 1793',NULL,'2000BSAO...50....5K',2000,1,0.65,'Matthews (2000A&AS..143..421M) detects another feature at v=4140 km/sec.','G',0.000013,'?','17.1',0.09,'Sd',NULL,NULL,NULL,NULL,1,220.300458333,-17.64606,0.341,NULL,46679439702,729366245,11396347,17.1),(123162,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123162,35.86,0.33,148,55147,70,NULL,NULL,'2MASX J14411233+1453242',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000934,NULL,'17.50',0.24,NULL,NULL,NULL,NULL,NULL,1,220.3014583,14.89014,0.005,NULL,59558710317,930604848,14540700,17.5),(123163,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123163,37.38,0.46,300,55148,70,NULL,NULL,'SDSS J144113.04+095057.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000144,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,220.304375,9.84919,0.017,NULL,59373973915,927718342,14495599,18),(123164,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123164,36.6,0.33,209,55149,70,NULL,NULL,'2MASX J14411329+1432032',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.77',0.18,NULL,NULL,NULL,NULL,NULL,1,220.305333,14.53417,0.029,NULL,59558972312,930608942,14540764,17.77),(123165,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123165,37.59,0.46,329,55150,70,NULL,NULL,'2MASX J14411340+0908555',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,220.305708333,9.14861,0.041,NULL,59364633066,927572391,14493318,16.7),(123166,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123166,36.53,NULL,202,55151,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09468',NULL,'2010Ap&SS.325..163P',2010,1,0.85,NULL,'G',0.000027,NULL,'16.9g',0.16,'Sbc',NULL,NULL,NULL,NULL,1,220.311625,10.05672,0.017,NULL,59374496763,927726511,14495726,16.9),(123167,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123167,36.54,NULL,203,55151,NULL,NULL,'Dipole + Quadrupole','UGC 09468',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123168,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123168,36.55,NULL,204,55151,NULL,NULL,'Dipole','UGC 09468',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123169,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123169,36.69,NULL,217,55151,NULL,NULL,NULL,'UGC 09468',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123170,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123170,36.74,0.49,223,55151,75,NULL,'IR','UGC 09468',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123171,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123171,37.58,0.46,328,55152,70,NULL,NULL,'2MASX J14411535+2522450',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,220.314,25.37919,0.067,NULL,60025744382,937902255,14654722,18),(123172,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123172,36.85,0.46,235,55153,70,NULL,NULL,'2MASX J14411541+1108305',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000162,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,220.314167,11.14192,0.009,NULL,59371847836,927685122,14495080,16.7),(123173,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123173,37.95,0.46,389,55154,70,NULL,NULL,'2MASX J14411551+1900372',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.16',0.14,NULL,NULL,NULL,NULL,NULL,1,220.31475,19.0105,0.037,NULL,59500433712,929694276,14526473,18.16),(123174,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123174,36.69,0.46,218,55155,70,NULL,NULL,'2MASX J14411557+2156382',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000183,NULL,'16.1g',0.42,NULL,NULL,NULL,NULL,NULL,1,220.3147917,21.94378,0.03,NULL,59503019704,929734682,14527104,16.1),(123175,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123175,37.08,0.46,261,55156,70,NULL,NULL,'2MASX J14411650+0750165',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,220.318708333,7.83792,0.045,NULL,59365509576,927586087,14493532,17),(123176,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123176,37.16,0.46,271,55157,70,NULL,NULL,'2MASX J14411672+2340026',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000143,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,220.3197917,23.66739,0.034,NULL,59507487801,929804496,14528195,17.7),(123177,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123177,37.73,0.46,352,55158,70,NULL,NULL,'SDSS J144118.00+033519.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000087,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,220.325041667,3.58883,0.065,NULL,58255905471,910248522,14222633,18.3),(123178,'Tully est','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123178,32.84,0.8,37,55159,75,NULL,NULL,'UGC 09477',NULL,'1988NBGC.C....0000T',1988,1,0.59,NULL,'G',0.000017,NULL,'16.5g',0.44,'Im:',NULL,NULL,NULL,NULL,1,220.327125,59.30142,0,NULL,57768458955,902632171,14103627,16.5),(123179,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123179,32.07,NULL,25.9,55160,72,NULL,NULL,'KUG 1438+080',NULL,'2014Ap.....57..457K',2014,1,0.49,NULL,'G',0.000005,NULL,'16.1g',0.31,'Spiral',NULL,NULL,NULL,NULL,1,220.329917,7.793,0.045,NULL,59365521947,927586280,14493535,16.1),(123180,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123180,36.57,0.33,206,55161,70,NULL,NULL,'CGCG 075-110',NULL,'2015arXiv151105856S',2015,1,1.05,NULL,'G',0.000173,NULL,'14.8g',0.59,NULL,NULL,NULL,NULL,NULL,1,220.334833,10.79719,0.009,NULL,59371803274,927684426,14495069,14.8),(123181,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123181,36.05,0.46,162,55162,70,NULL,NULL,'2MASX J14412105+1940556',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'16.90',0.18,NULL,NULL,NULL,NULL,NULL,1,220.3377083,19.68225,0.016,NULL,59501271166,929707361,14526677,16.9),(123182,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123182,36.39,0.46,189,55163,70,NULL,NULL,'2MASX J14412117+0911355',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000198,NULL,'15.4g',0.48,NULL,NULL,NULL,NULL,NULL,1,220.3380417,9.19322,0.041,NULL,59364630778,927572355,14493318,15.4),(123183,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123183,36.26,0.33,179,55164,70,NULL,NULL,'2MASX J14412133+2139316',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.70',0.25,NULL,NULL,NULL,NULL,NULL,1,220.338833,21.65889,0.027,NULL,59503593530,929743648,14527244,16.7),(123184,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123184,36.98,0.46,249,55165,70,NULL,NULL,'SDSS J144121.41+534458.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000139,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,220.33925,53.74956,0,NULL,59191420056,924865938,14451030,18.2),(123185,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123185,37.74,0.46,353,55166,70,NULL,NULL,'2MASX J14412172+3019598',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000168,NULL,'18.40',0.15,NULL,NULL,NULL,NULL,NULL,1,220.3405,30.33342,0,NULL,60019901238,937810956,14653296,18.4),(123186,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123186,35.82,0.46,146,55167,70,NULL,NULL,'2MASX J14412228+1150225',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000174,NULL,'16.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,220.3429583,11.83953,0.009,NULL,59371523148,927680049,14495000,16.1),(123187,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123187,38.12,0.46,420,55168,70,NULL,NULL,'2MASX J14412242+0733285',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,220.343417,7.55783,0.041,NULL,59362702965,927542233,14492847,17.8),(123188,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123188,35.5,0.46,126,55169,70,NULL,NULL,'2MASX J14412360+1229432',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000143,NULL,'16.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,220.348417,12.49542,0.005,NULL,59543446702,930366354,14536974,16.3),(123189,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123189,37.45,0.46,309,55170,70,NULL,NULL,'2MASX J14412402+1413472',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,220.350041667,14.22978,0.017,NULL,59559032884,930609888,14540779,17.4),(123190,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123190,38.19,0.46,434,55171,70,NULL,NULL,'SDSS J144124.03+002421.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000077,NULL,'18.3g',0.1,NULL,NULL,NULL,NULL,NULL,1,220.350166667,0.40594,0.109,NULL,58259251984,910300812,14223450,18.3),(123191,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123191,37.54,0.46,321,55172,70,NULL,NULL,'2MASX J14412484+3247068',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.353583,32.78533,0,NULL,60121392274,939396754,14678074,17.4),(123192,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123192,37.55,0.46,323,55173,70,NULL,NULL,'SDSS J144126.53+560023.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000135,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,220.360583333,56.00656,0,NULL,57245213948,894456467,13975882,18.5),(123193,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123193,37.71,0.27,348,55174,70,NULL,NULL,'2MASX J14412686+4635144',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000146,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,220.361833,46.58744,0,NULL,59987756861,937308700,14645448,17.9),(123194,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123194,37.48,0.46,313,55175,70,NULL,NULL,'2MASX J14412724+1709172',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.73',0.14,NULL,NULL,NULL,NULL,NULL,1,220.363666667,17.15467,0.031,NULL,59554530439,930539538,14539680,18.73),(123195,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123195,37.21,0.46,277,55176,70,NULL,NULL,'2MASX J14412907+2906481',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00012,NULL,'17.0g',NULL,'S0',NULL,NULL,NULL,NULL,1,220.371167,29.11328,0,NULL,60018981812,937796590,14653071,17),(123196,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123196,36.54,0.46,203,55177,70,NULL,NULL,'2MASX J14412999+4618564',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000143,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,220.374875,46.31572,0.005,NULL,59987448135,937303877,14645373,17.1),(123197,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123197,37.69,0.46,345,55178,70,NULL,NULL,'SDSS J144130.40+273511.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.3767083,27.58658,0.033,NULL,60028828410,937950443,14655475,18.3),(123198,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123198,35.73,0.19,140,55179,70,NULL,NULL,'2MASX J14413067+0845055',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00017,NULL,'15.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,220.377667,8.75144,0.033,NULL,59365232058,927581750,14493464,15.7),(123199,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123199,37.61,0.46,332,55180,70,NULL,NULL,'2MASX J14413135+2258186',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,220.380583,22.97186,0.032,NULL,59508769818,929824528,14528508,17.5),(123200,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123200,38.14,0.15,425,55181,70,NULL,NULL,'2MASX J14413172+2206286',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.56',0.15,NULL,NULL,NULL,NULL,NULL,1,220.3822083,22.10789,0.03,NULL,59508276987,929816827,14528387,18.56),(123201,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123201,38.01,0.17,400,55182,70,NULL,NULL,'2MASX J14413173+2005566',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.48',0.14,NULL,NULL,NULL,NULL,NULL,1,220.3822917,20.09903,0,NULL,59501246199,929706971,14526671,18.48),(123202,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123202,32.86,0.2,37.3,55183,74.4,NULL,NULL,'UGC 09476',NULL,'2013AJ....146...86T',2013,1,1.64,NULL,'G',0.000027,NULL,'13.6g',0.97,'SAB(rs)c','Pair member (points to parent)',NULL,NULL,NULL,1,220.383416667,44.51275,0.037,NULL,59956512989,936820515,14637820,13.6),(123203,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123203,33.49,0.4,49.9,55183,NULL,NULL,'mean','UGC 09476',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123204,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123204,33.53,0.47,50.9,55183,NULL,NULL,'H','UGC 09476',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123205,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123205,33.57,0.45,51.7,55183,NULL,NULL,'K','UGC 09476',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123206,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123206,33.59,0.46,52.2,55183,NULL,NULL,'J','UGC 09476',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123207,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123207,35.79,0.1,144,55184,70,NULL,NULL,'CGCG 047-143',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000083,NULL,'15.4g',0.33,'S0/a','Group member',NULL,NULL,NULL,1,220.3837917,3.59922,0.065,NULL,58256616177,910259627,14222806,15.4),(123208,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123208,37.59,0.46,330,55185,70,NULL,NULL,'2MASX J14413253+4529293',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,220.385625,45.49158,0.017,NULL,59955750166,936808596,14637634,17.2),(123209,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123209,33.92,0.45,60.8,55186,NULL,NULL,'K','UGC 09473',NULL,'2007A&A...465...71T',2007,1,1.23,NULL,'G',0.00008,NULL,'13.6g',0.95,'S0:','in a radial-velocity based grouping',NULL,NULL,NULL,1,220.387333333,38.85136,0,NULL,60076691038,938698297,14667160,13.6),(123210,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123210,34.11,0.4,66.3,55186,NULL,NULL,'mean','UGC 09473',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123211,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123211,38.01,0.27,401,55187,70,NULL,NULL,'2MASX J14413641+2403331',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'17.7g',0.22,'BrClG',NULL,NULL,NULL,NULL,1,220.4017083,24.05931,0.087,NULL,59507721641,929808150,14528252,17.7),(123212,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123212,36.3,0.46,182,55188,70,NULL,NULL,'2MASX J14413639+2505011',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.40',0.23,NULL,NULL,NULL,NULL,NULL,1,220.4017083,25.08378,0.076,NULL,59506691061,929792047,14528000,17.4),(123213,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123213,37.71,0.27,348,55189,70,NULL,NULL,'2MASX J14413689+4654307',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000151,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,220.403583,46.90858,0,NULL,59987965454,937311960,14645499,17.2),(123214,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123214,36.19,0.46,173,55190,70,NULL,NULL,'MCG +10-21-025',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000193,NULL,'15.6g',0.45,'E0',NULL,NULL,NULL,NULL,1,220.407667,62.33822,0.045,NULL,57758564574,902477571,14101212,15.6),(123215,'IRAS','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123215,33.95,0.8,61.5,55191,75,NULL,'MAT, I','ESO 386- G 009',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'15',1.2,'Sb             HII',NULL,NULL,NULL,NULL,1,220.409333,-33.31106,0.269,NULL,47227990693,737937354,11530271,15),(123216,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123216,33.99,0.4,62.9,55191,NULL,NULL,'mean','ESO 386- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123217,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123217,34.12,0.45,66.8,55191,NULL,NULL,'K','ESO 386- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123218,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123218,34.13,0.32,67.1,55191,85,NULL,'I, raw','ESO 386- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123219,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123219,34.14,0.43,67.3,55191,75,NULL,'MAT, I, raw','ESO 386- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123220,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123220,34.16,0.47,67.9,55191,NULL,NULL,'H','ESO 386- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123221,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123221,34.19,0.46,69,55191,NULL,NULL,'J','ESO 386- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123222,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123222,34.21,0.32,69.5,55191,85,NULL,'I, inv','ESO 386- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123223,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123223,34.41,0.43,76.1,55191,75,NULL,'MAT, I, cor','ESO 386- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123224,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123224,34.47,0.43,78.2,55191,75,NULL,'MAT, I, inv','ESO 386- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123225,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123225,36.26,0.46,179,55192,70,NULL,NULL,'2MASXi J1441383-002729',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000213,NULL,'16.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,220.409708333,-0.45819,0.105,NULL,43491425909,679553529,10618023,16.2),(123226,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123226,38.14,0.15,425,55193,70,NULL,NULL,'2MASX J14413848+2203526',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,220.410166667,22.06467,0.03,NULL,59508262182,929816596,14528384,18.5),(123227,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123227,38.01,0.46,399,55194,70,NULL,NULL,'2MASX J14413890+3159539',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000165,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,220.4120417,31.99825,0,NULL,60087721081,938870641,14669853,18.4),(123228,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123228,38.08,0.33,412,55195,70,NULL,NULL,'2MASX J14413900+1623565',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,220.4125,16.39908,0,NULL,59554745501,930542898,14539732,17.5),(123229,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123229,37.71,0.27,348,55196,70,NULL,NULL,'2MASX J14414065+4635127',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000192,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,220.419167,46.58692,0,NULL,59987769592,937308899,14645451,16.6),(123230,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123230,35.49,0.33,125,55197,70,NULL,NULL,'IC 4486',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00008,NULL,'15.2',0.26,NULL,NULL,NULL,NULL,NULL,1,220.4199583,18.55722,0.036,NULL,59550787832,930481059,14538766,15.2),(123231,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123231,37.58,0.46,328,55198,70,NULL,NULL,'2MASX J14414160+1238596',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000178,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.4235,12.64992,0,NULL,59557067316,930579176,14540299,17.5),(123232,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123232,37.04,0.33,256,55199,70,NULL,NULL,'2MASX J14414253+3318099',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000173,NULL,'16.2g',0.42,NULL,NULL,NULL,NULL,NULL,1,220.42725,33.30283,0,NULL,60121349448,939396085,14678063,16.2),(123233,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123233,33.52,0.85,50.5,55200,NULL,NULL,'Malmquist cor.','UGC 09471',NULL,'2009ApJS..182..474S',2009,1,1.33,NULL,'G',0.000033,NULL,'14.7g',0.54,'SBb',NULL,NULL,NULL,NULL,1,220.4289583,5.95275,0.069,NULL,58309235651,911081807,14235653,14.7),(123234,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123234,33.54,0.85,51,55200,NULL,NULL,NULL,'UGC 09471',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123235,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123235,33.58,0.2,52,55200,74.4,NULL,NULL,'UGC 09471',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123236,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123236,38.08,0.33,412,55201,70,NULL,NULL,'2MASX J14414345+1631026',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,220.4309583,16.5175,0,NULL,59554869167,930544830,14539762,17.7),(123237,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123237,38.21,0.46,438,55202,70,NULL,NULL,'2MASX J14414432+5319336',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000141,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,220.434583,53.32608,0,NULL,59191559165,924868111,14451064,18.3),(123238,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123238,38.05,0.46,407,55203,70,NULL,NULL,'2MASX J14414447+1237596',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000183,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,220.4355,12.63336,0,NULL,59557067393,930579178,14540299,17.1),(123239,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123239,35.71,0.46,139,55204,70,NULL,NULL,'CGCG 104-069',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000157,NULL,'15.5',0.29,NULL,NULL,NULL,NULL,NULL,1,220.444583,19.25194,0.037,NULL,59500643701,929697557,14526524,15.5),(123240,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123240,35.79,0.1,144,55205,70,NULL,NULL,'2MASX J14414691+0327195',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00006,NULL,'16.2g',0.29,'S0',NULL,NULL,NULL,NULL,1,220.4454583,3.45542,0.089,NULL,58256605411,910259459,14222804,16.2),(123241,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123241,35.33,0.46,116,55206,70,NULL,NULL,'MCG +10-21-024',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000087,NULL,'14.9g',0.58,'E0',NULL,NULL,NULL,NULL,1,220.445625,56.91789,0.017,NULL,57258774243,894668347,13979192,14.9),(123242,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123242,37.62,0.46,334,55207,70,NULL,NULL,'2MASX J14414729+0259195',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000074,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,220.447167,2.98872,0.113,NULL,58263239250,910363113,14224423,17.2),(123243,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123243,37.78,0.27,359,55208,70,NULL,NULL,'2MASX J14414754+2829232',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,220.4482917,28.48978,0.01,NULL,60027060701,937922823,14655044,18),(123244,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123244,38.14,0.15,425,55209,70,NULL,NULL,'2MASX J14414829+2220231',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.45125,22.33969,0.068,NULL,59508285185,929816956,14528389,17.7),(123245,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123245,37.39,0.46,300,55210,70,NULL,NULL,'2MASX J14414853+2202391',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000153,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,220.452166667,22.04408,0.028,NULL,59508262017,929816594,14528384,18.2),(123246,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123246,31.58,NULL,20.7,55211,72,NULL,NULL,'UGC 09470',NULL,'2014Ap.....57..457K',2014,1,1.26,NULL,'G',0.000017,NULL,'14.9g',0.64,'SB(rs)dm pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,220.452833,0.68697,0.145,NULL,58262739952,910355311,14224301,14.9),(123247,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123247,36.79,0.46,228,55212,70,NULL,NULL,'2MASX J14414911+1719405',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.23',0.16,NULL,NULL,NULL,NULL,NULL,1,220.4545,17.32808,0.036,NULL,59551527306,930492614,14538947,18.23),(123248,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123248,37.84,0.46,369,55213,70,NULL,NULL,'2MASX J14414955+3035559',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000199,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,220.456625,30.59897,0,NULL,60019810612,937809540,14653274,17.1),(123249,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123249,35.65,0.52,135,55214,70,NULL,NULL,'2MASX J14414968-3645593',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.7I',0.5,NULL,NULL,NULL,NULL,NULL,1,220.456917,-36.76642,0.301,NULL,47224134538,737877102,11529329,13.7),(123250,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123250,37.99,0.46,396,55215,70,NULL,NULL,'SDSS J144150.70+182803.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.4612917,18.46753,0.053,NULL,59550778771,930480918,14538764,18.2),(123251,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123251,32.45,NULL,30.9,55216,72,NULL,NULL,'UGC 09472',NULL,'2014Ap.....57..457K',2014,1,1,NULL,'G',0.000017,NULL,'15.59',0.5,'Sdm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,220.461917,-1.39244,0.133,NULL,43494742768,679605355,10618833,15.59),(123252,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123252,37.14,0.46,268,55217,70,NULL,NULL,'2MASX J14415146+1259395',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000172,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,220.4644583,12.99419,0,NULL,59557193085,930581141,14540330,16.8),(123253,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123253,38.1,0.46,416,55218,70,NULL,NULL,'SDSS J144151.57+311136.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,220.464916667,31.19339,0,NULL,60017028490,937766070,14652594,18.3),(123254,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123254,37.08,0.46,261,55219,70,NULL,NULL,'2MASX J14415194+1936221',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,220.4665,19.60633,0.016,NULL,59501347475,929708554,14526696,17.7),(123255,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123255,38.01,0.27,401,55220,70,NULL,NULL,'2MASX J14415229+2405173',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000136,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,220.467875,24.08828,0.087,NULL,59507709109,929807954,14528249,17.9),(123256,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123256,37.12,0.46,265,55221,70,NULL,NULL,'2MASX J14415260+2052461',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.55',0.14,NULL,NULL,NULL,NULL,NULL,1,220.469125,20.87964,0.024,NULL,59504589025,929759203,14527487,18.55),(123257,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123257,36.3,0.51,182,55222,70,NULL,NULL,'2MASX J14415280-1456548',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.14',NULL,NULL,NULL,NULL,NULL,NULL,1,220.470125,-14.94867,0.337,NULL,46690463187,729538487,11399038,16.14),(123258,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123258,37.64,0.33,337,55223,70,NULL,NULL,'2MASX J14415424+2738383',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,220.476083,27.64406,0.033,NULL,60028796051,937949938,14655467,18),(123259,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123259,38.02,0.46,402,55224,70,NULL,NULL,'2MASX J14415445+2100431',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.477083,21.01194,0.024,NULL,59504537464,929758397,14527474,17.5),(123260,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123260,38.14,0.15,425,55225,70,NULL,NULL,'SDSS J144154.59+222820.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.4775,22.47242,0.068,NULL,59508495383,929820240,14528441,18.3),(123261,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123261,35.87,0.46,150,55226,70,NULL,NULL,'CGCG 075-112',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000147,NULL,'14.8g',0.58,NULL,'Group member',NULL,NULL,NULL,1,220.479,9.38269,0.037,NULL,59372736614,927699009,14495297,14.8),(123262,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123262,37.61,0.46,332,55227,70,NULL,NULL,'2MASX J14415621+3400408',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000181,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.484083,34.01136,0,NULL,60067042797,938547543,14664805,17.2),(123263,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123263,38.62,0.33,531,55228,70,NULL,NULL,'2MASX J14415746+1356415',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,220.4895,13.94489,0,NULL,59558137281,930595895,14540560,NULL),(123264,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123264,35.79,0.1,144,55229,70,NULL,NULL,'CGCG 047-145',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000047,NULL,'15.0g',0.57,'E0','Group member',NULL,NULL,NULL,1,220.494708333,3.38997,0.101,NULL,58256688818,910260762,14222824,15),(123265,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123265,35.49,0.33,125,55230,70,NULL,NULL,'2MASX J14420105+1838292',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.74',0.26,NULL,NULL,NULL,NULL,NULL,1,220.504291667,18.64156,0.036,NULL,59550738374,930480287,14538754,16.74),(123266,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123266,37.67,0.46,341,55231,70,NULL,NULL,'SDSS J144201.28+000611.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00007,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,220.505333,0.10317,0.105,NULL,58259188427,910299819,14223434,18.3),(123267,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123267,38.18,0.46,432,55232,70,NULL,NULL,'2MASX J14420258+4614197',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.51075,46.23892,0,NULL,59987433638,937303650,14645369,17.6),(123268,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123268,37.78,0.27,359,55233,70,NULL,NULL,'2MASX J14420263+2830423',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00012,NULL,'17.10',0.26,'cD',NULL,NULL,NULL,NULL,1,220.510916667,28.51169,0.01,NULL,60027275952,937926186,14655096,17.1),(123269,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123269,39.12,0.46,666,55234,70,NULL,NULL,'2MASX J14420262-0044089',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000084,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,220.511,-0.73581,0.085,NULL,43494242216,679597534,10618711,18.4),(123270,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123270,38.06,0.27,409,55235,70,NULL,NULL,'2MASX J14420278+2219391',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,220.5115,22.3275,0.068,NULL,59508291885,929817060,14528391,17.7),(123271,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123271,37.53,0.46,321,55236,70,NULL,NULL,'SDSS J144202.77+303520.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000165,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.5115417,30.58894,0,NULL,60019941202,937811581,14653305,18.7),(123272,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123272,34.82,0.46,91.9,55237,70,NULL,NULL,'CGCG 220-048',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000161,NULL,'15.1g',0.45,'S0',NULL,NULL,NULL,NULL,1,220.5120417,43.89828,0.063,NULL,59955612945,936806452,14637600,15.1),(123273,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123273,37.08,0.46,261,55238,70,NULL,NULL,'2MASX J14420306+4806467',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000164,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,220.512917,48.11308,0.069,NULL,59933241939,936456905,14632139,16.8),(123274,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123274,34.91,NULL,95.8,55239,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09475',NULL,'2010Ap&SS.325..163P',2010,1,1.44,NULL,'G',0.000033,NULL,'15.9g',0.2,'Sc',NULL,NULL,NULL,NULL,1,220.513916667,12.06986,0.013,NULL,59371482839,927679419,14494990,15.9),(123275,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123275,34.92,NULL,96.3,55239,NULL,NULL,'Dipole + Quadrupole','UGC 09475',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123276,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123276,34.92,NULL,96.5,55239,NULL,NULL,'Dipole','UGC 09475',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123277,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123277,34.97,NULL,98.5,55239,NULL,NULL,NULL,'UGC 09475',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123278,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123278,35.19,0.49,109,55239,75,NULL,'IR','UGC 09475',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123279,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123279,35.39,0.2,120,55239,74.4,NULL,NULL,'UGC 09475',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123280,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123280,35.71,0.2,139,55240,74.4,NULL,NULL,'CGCG 075-115',NULL,'2013AJ....146...86T',2013,1,0.66,NULL,'G',0.000354,NULL,'16.1g',0.35,NULL,'Group member',NULL,NULL,NULL,1,220.52,9.38261,0.037,NULL,59373790148,927715471,14495554,16.1),(123281,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123281,36.69,0.46,218,55241,70,NULL,NULL,'2MASX J14420507+2331071',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000148,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,220.52125,23.51861,0.032,NULL,59507817615,929809650,14528275,17.5),(123282,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123282,37.28,0.46,286,55242,70,NULL,NULL,'2MASX J14420556+3033229',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000169,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,220.523166667,30.55631,0,NULL,60019939050,937811547,14653305,16.8),(123283,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123283,38.31,0.46,459,55243,70,NULL,NULL,'2MASX J14420589+1508537',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.44',0.12,NULL,NULL,NULL,NULL,NULL,1,220.5244583,15.14814,0.013,NULL,59558641711,930603776,14540684,18.44),(123284,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123284,38.14,0.15,425,55244,70,NULL,NULL,'2MASX J14420688+2212071',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.5287083,22.20206,0.068,NULL,59508286318,929816973,14528390,17.7),(123285,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123285,31.95,0.46,24.6,55245,NULL,NULL,'J','NGC 5729',NULL,'2007A&A...465...71T',2007,1,2.6,NULL,'G',0.000003,NULL,'12.99',0.7,'Sb pec:',NULL,NULL,NULL,NULL,1,220.528667,-9.00944,0.269,NULL,46467699598,726057806,11344653,12.99),(123286,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123286,31.97,0.49,24.8,55245,75,NULL,'IR','NGC 5729',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123287,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123287,32.01,0.45,25.2,55245,NULL,NULL,'K','NGC 5729',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123288,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123288,32.09,0.47,26.2,55245,NULL,NULL,'H','NGC 5729',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123289,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123289,32.18,0.4,27.3,55245,NULL,NULL,'mean','NGC 5729',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123290,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123290,36.66,0.71,214,55246,70,NULL,NULL,'2MASX J14420746-1742136',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.58',NULL,NULL,NULL,NULL,NULL,NULL,1,220.531125,-17.70381,0.349,NULL,46679451441,729366428,11396350,16.58),(123291,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123291,38.62,0.33,531,55247,70,NULL,NULL,'SDSS J144208.06+135113.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.533583,13.85378,0,NULL,59557807764,930590746,14540480,18.4),(123292,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123292,37.64,0.33,337,55248,70,NULL,NULL,'2MASX J14420839+2734513',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.46',0.24,NULL,NULL,NULL,NULL,NULL,1,220.534958333,27.58086,0.033,NULL,60027914542,937936164,14655252,17.46),(123293,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123293,37.36,0.46,297,55249,70,NULL,NULL,'2MASX J14420866+2552533',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000139,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,220.5360417,25.88153,0.051,NULL,60025851451,937903928,14654748,17.7),(123294,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123294,38.13,0.46,422,55250,70,NULL,NULL,'2MASX J14420884+2744043',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.69',0.14,NULL,NULL,NULL,NULL,NULL,1,220.536833,27.73442,0.033,NULL,60028786396,937949787,14655465,18.69),(123295,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123295,35.84,0.69,147,55251,70,NULL,NULL,'2MASX J14420926-3526576',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,220.538625,-35.44928,0.237,NULL,47221906637,737842291,11528785,14.1),(123296,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123296,35.9,0.53,151,55252,70,NULL,NULL,'2MASX J14420941-1633566',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.74',NULL,NULL,NULL,NULL,NULL,NULL,1,220.5392917,-16.56581,0.361,NULL,46682592930,729415514,11397117,15.74),(123297,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123297,37.78,0.27,359,55253,70,NULL,NULL,'2MASX J14421015+2834113',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,220.542208333,28.56969,0.01,NULL,60027282877,937926294,14655098,17.7),(123298,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123298,38.14,0.15,425,55254,70,NULL,NULL,'2MASX J14421141+2211221',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.5475417,22.1895,0.068,NULL,59508285566,929816961,14528390,17.7),(123299,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123299,37.87,0.46,376,55255,70,NULL,NULL,'2MASX J14421183+2708203',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,220.5495,27.13903,0.031,NULL,60028020522,937937820,14655278,18.1),(123300,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123300,37.46,0.69,310,55256,70,NULL,NULL,'2MASX J14421212-1624146',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.68',NULL,NULL,NULL,NULL,NULL,NULL,1,220.5507083,-16.40408,0.365,NULL,46682424977,729412890,11397076,16.68),(123301,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123301,38.35,0.19,467,55257,70,NULL,NULL,'2MASX J14421242+5517546',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,220.5520417,55.29833,0,NULL,57246625958,894478530,13976227,18.1),(123302,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123302,35.59,0.48,131,55258,70,NULL,NULL,'2MASX J14421266-3752452',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,220.552875,-37.87925,0.329,NULL,47224226762,737878543,11529352,14),(123303,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123303,38.14,0.15,425,55259,70,NULL,NULL,'2MASX J14421337+2217201',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000208,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,220.555666667,22.28892,0.068,NULL,59508291210,929817050,14528391,17.6),(123304,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123304,37.16,0.46,270,55260,70,NULL,NULL,'2MASX J14421426+3528139',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000173,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,220.5595417,35.47056,0,NULL,60068343466,938567866,14665122,16.2),(123305,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123305,36.97,0.46,248,55261,70,NULL,NULL,'2MASX J14421460+2918093',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000047,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.560958333,29.30247,0,NULL,60019143088,937799110,14653111,17.2),(123306,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123306,38.27,0.46,451,55262,70,NULL,NULL,'SDSS J144217.68+181942.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.573667,18.32856,0.042,NULL,59550955977,930483687,14538807,18.1),(123307,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123307,37.54,0.46,321,55263,70,NULL,NULL,'2MASX J14421805+2902216',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00013,NULL,'16.9g',0.28,'S0',NULL,NULL,NULL,NULL,1,220.575125,29.03919,0,NULL,60018940743,937795949,14653061,16.9),(123308,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123308,38.14,0.15,425,55264,70,NULL,NULL,'2MASX J14421860+2225162',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000153,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,220.5772917,22.42125,0.073,NULL,59508491526,929820180,14528440,17.7),(123309,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123309,37.9,0.46,380,55265,70,NULL,NULL,'2MASX J14421855+5633316',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,220.57775,56.55878,0.029,NULL,57258733985,894667718,13979183,18.1),(123310,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123310,38.14,0.15,425,55266,70,NULL,NULL,'SDSS J144218.76+222131.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000159,NULL,'18.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.578166667,22.35886,0.068,NULL,59508279138,929816861,14528388,18.4),(123311,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123311,35.31,0.46,115,55267,70,NULL,NULL,'CGCG 134-017',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000167,NULL,'15.5',0.22,NULL,NULL,NULL,NULL,NULL,1,220.580833,26.23922,0.056,NULL,60026715435,937917428,14654959,15.5),(123312,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123312,38.06,0.27,409,55268,70,NULL,NULL,'2MASX J14421950+2217082',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000171,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,220.581208333,22.28564,0.068,NULL,59508291490,929817054,14528391,17.8),(123313,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123313,37.05,0.46,257,55269,70,NULL,NULL,'SDSS J144221.70+034157.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000069,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,220.590417,3.69931,0.077,NULL,58256762250,910261910,14222842,17.7),(123314,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123314,38.01,0.27,401,55270,70,NULL,NULL,'2MASX J14422248+2400496',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000146,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,220.593875,24.01389,0.081,NULL,59507707761,929807933,14528248,17.7),(123315,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123315,38.06,0.27,409,55271,70,NULL,NULL,'2MASX J14422281+2219073',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000182,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.595,22.31867,0.068,NULL,59508279967,929816874,14528388,17.3),(123316,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123316,37.35,0.46,295,55272,70,NULL,NULL,'2MASX J14422328+4800198',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000152,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,220.597125,48.00558,0.057,NULL,59932756881,936449326,14632020,17.2),(123317,'SNIa','2016-12-15 15:15:28','2016-12-16 11:20:41','1','SN 2009Y',NULL,123317,32.98,0.26,39,55273,73.8,NULL,'SALT 2 (SNANA)','NGC 5728',0.0101,'2014ApJ...795...44R',2014,1,3.1,NULL,'G',0.000067,NULL,'12.81',1.8,'(R_1)SAB(r)a;HII Sy2','in a pair',NULL,NULL,'Sy 1.9',1,220.599583,-17.25308,0.349,NULL,46678751728,729355495,11396179,12.81),(123318,'Sosies','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123318,32.4,0.25,30.2,55273,NULL,NULL,NULL,'NGC 5728',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123319,'Tully est','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123319,33.13,0.8,42.2,55273,75,NULL,'B','NGC 5728',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123320,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123320,31.9,0.55,24,55273,NULL,NULL,'Malmquist cor.','NGC 5728',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123321,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123321,31.95,0.4,24.5,55273,NULL,NULL,NULL,'NGC 5728',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123322,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123322,31.95,0.53,24.6,55273,NULL,NULL,NULL,'NGC 5728',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123323,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123323,32.11,0.2,26.4,55273,74.4,NULL,NULL,'NGC 5728',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123324,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123324,32.22,0.43,27.8,55273,75,NULL,'3.6 micron, color corrected','NGC 5728',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123325,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123325,32.23,0.43,27.9,55273,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5728',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123326,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123326,32.36,0.45,29.7,55273,NULL,NULL,'K','NGC 5728',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123327,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123327,32.39,0.47,30,55273,NULL,NULL,'H','NGC 5728',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123328,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123328,32.44,0.46,30.7,55273,NULL,NULL,'J','NGC 5728',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123329,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123329,32.97,0.4,39.2,55273,NULL,NULL,'mean','NGC 5728',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123330,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123330,36.66,0.46,215,55274,70,NULL,NULL,'2MASX J14422423+2015153',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.87',0.15,NULL,NULL,NULL,NULL,NULL,1,220.6009583,20.25425,0,NULL,59500730237,929698909,14526545,17.87),(123331,'D-Sigma','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123331,34.57,0.4,82,55275,75,NULL,'Edat, raw','ESO 386- G 011',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000123,NULL,'14.33',0.8,'E?',NULL,NULL,NULL,NULL,1,220.601916667,-36.57242,0.225,NULL,47224123893,737876935,11529327,14.33),(123332,'D-Sigma','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123332,34.9,0.4,95.7,55275,75,NULL,'Edat, cor','ESO 386- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123333,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123333,35.2,0.4,110,55275,NULL,NULL,'mean','ESO 386- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123334,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123334,35.46,0.45,124,55275,NULL,NULL,'K','ESO 386- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123335,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123335,36.05,0.53,162,55276,70,NULL,NULL,'2MASX J14422455-1703566',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.51',NULL,NULL,NULL,NULL,NULL,NULL,1,220.6024583,-17.06578,0.349,NULL,46682224369,729409755,11397027,16.51),(123336,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123336,37.33,0.77,293,55277,70,NULL,NULL,'2MASX J14422767-2127036',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,220.615417,-21.45108,0.321,NULL,46530667726,727041683,11360026,15.1),(123337,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123337,37.5,0.46,316,55278,70,NULL,NULL,'SDSS J144228.42+294220.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.1g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.6184583,29.70572,0,NULL,60019063554,937797868,14653091,18.1),(123338,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123338,36.47,0.46,197,55279,70,NULL,NULL,'2MASX J14422876+1718468',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.16',0.16,NULL,NULL,NULL,NULL,NULL,1,220.619958333,17.31311,0.036,NULL,59551392389,930490506,14538914,18.16),(123339,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123339,35.73,0.19,140,55280,70,NULL,NULL,'2MASX J14422896+0841394',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000183,NULL,'17.36',0.2,NULL,NULL,NULL,NULL,NULL,1,220.620625,8.69414,0.041,NULL,59365392312,927584254,14493503,17.36),(123340,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123340,35.2,0.46,110,55281,70,NULL,NULL,'2MASX J14422909+0840474',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.91',0.22,NULL,NULL,NULL,NULL,NULL,1,220.6212083,8.67969,0.041,NULL,59365391729,927584245,14493503,16.91),(123341,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123341,38.13,0.46,423,55282,70,NULL,NULL,'SDSS J144229.08+144717.0',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.6212083,14.78808,0.005,NULL,59558759070,930605610,14540712,17.3),(123342,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123342,38.17,0.46,431,55283,70,NULL,NULL,'2MASX J14422950+2940417',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.622875,29.67828,0,NULL,60019064288,937797879,14653091,17.8),(123343,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123343,38.66,0.46,539,55284,70,NULL,NULL,'SDSS J144229.58+242255.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000142,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.62325,24.382,0.094,NULL,59506856823,929794637,14528041,18.5),(123344,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123344,37.18,0.46,273,55285,70,NULL,NULL,'2MASX J14422959+5636035',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000154,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,220.6235,56.60092,0.029,NULL,57258734795,894667731,13979183,17),(123345,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123345,37.88,0.46,376,55286,70,NULL,NULL,'2MASX J14422978+0754044',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.60',0.14,NULL,NULL,NULL,NULL,NULL,1,220.624125,7.90117,0.041,NULL,59365978769,927593418,14493647,18.6),(123346,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123346,34.3,NULL,72.5,55287,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09484',NULL,'2010Ap&SS.325..163P',2010,1,0.96,NULL,'G',0.000111,NULL,'16.8g',0.15,'Scd',NULL,NULL,NULL,NULL,1,220.633,42.47578,0,NULL,59958121096,936845642,14638213,16.8),(123347,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123347,34.32,NULL,73.1,55287,NULL,NULL,'Dipole + Quadrupole','UGC 09484',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123348,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123348,34.33,NULL,73.5,55287,NULL,NULL,'Dipole','UGC 09484',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123349,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123349,34.38,NULL,75.1,55287,NULL,NULL,NULL,'UGC 09484',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123350,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123350,37.18,0.46,272,55288,70,NULL,NULL,'2MASX J14423199+2659097',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.36',0.22,NULL,NULL,NULL,NULL,NULL,1,220.63325,26.98606,0.03,NULL,60026099000,937907796,14654809,17.36),(123351,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123351,37.62,0.46,334,55289,70,NULL,NULL,'2MASX J14423212+0427224',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000088,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,220.63375,4.45606,0.125,NULL,58258403103,910287548,14223242,16.7),(123352,'IRAS','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123352,35.25,0.8,112,55290,75,NULL,'CF, r','UGC 09479',NULL,'1997ApJS..109..333W',1997,1,1.54,NULL,'G',0.00008,NULL,'14.9g',0.41,'Sb',NULL,NULL,NULL,NULL,1,220.636,4.43044,0.125,NULL,58258400254,910287503,14223242,14.9),(123353,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123353,34.84,0.49,92.8,55290,75,NULL,'IR','UGC 09479',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123354,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123354,34.97,0.38,98.5,55290,75,NULL,'CF, r, raw','UGC 09479',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123355,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123355,35.11,0.38,105,55290,75,NULL,'CF, r, inv','UGC 09479',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123356,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123356,35.23,0.38,111,55290,75,NULL,'CF, r, cor','UGC 09479',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123357,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123357,37.76,0.46,356,55291,70,NULL,NULL,'2MASX J14423268+2018223',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.27',0.15,NULL,NULL,NULL,NULL,NULL,1,220.636167,20.30628,0,NULL,59500735386,929698990,14526546,18.27),(123358,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123358,38,0.46,399,55292,70,NULL,NULL,'2MASX J14423301+3417144',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000179,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,220.637583333,34.28742,0,NULL,60066933389,938545834,14664778,17.1),(123359,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123359,33.78,0.47,56.9,55293,NULL,NULL,'H','NGC 5735',NULL,'2007A&A...465...71T',2007,1,2.4,NULL,'G',0.000023,NULL,'13.10',1.9,'SB(rs)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,220.6385,28.72644,0,NULL,60027264975,937926015,14655093,13.1),(123360,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123360,33.86,0.46,59.1,55293,NULL,NULL,'J','NGC 5735',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123361,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123361,33.86,0.45,59.2,55293,NULL,NULL,'K','NGC 5735',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123362,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123362,33.87,0.4,59.4,55293,NULL,NULL,'mean','NGC 5735',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123363,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123363,38.08,0.46,413,55294,70,NULL,NULL,'2MASX J14423387+3626391',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,220.6410417,36.44414,0,NULL,60068074084,938563657,14665057,17.4),(123364,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123364,34.68,0.46,86.3,55295,70,NULL,NULL,'IC 4492',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000198,NULL,'15.2g',0.51,'E',NULL,NULL,NULL,NULL,1,220.641125,37.45233,0,NULL,60075371152,938677674,14666838,15.2),(123365,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123365,36.24,0.46,177,55296,70,NULL,NULL,'CGCG 164-014',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000143,NULL,'15.7g',0.4,NULL,NULL,NULL,NULL,NULL,1,220.647375,28.65533,0,NULL,60027293624,937926462,14655100,15.7),(123366,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123366,37.1,0.46,262,55297,70,NULL,NULL,'2MASX J14423540+0319024',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00007,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,220.6475417,3.31736,0.089,NULL,58256719794,910261246,14222831,17.5),(123367,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123367,38.34,0.46,465,55298,70,NULL,NULL,'2MASX J14423625+2446097',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,220.6512083,24.7695,0.077,NULL,59506901047,929795328,14528052,17.7),(123368,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123368,36.01,0.33,159,55299,70,NULL,NULL,'2MASX J14423794+2417437',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000161,NULL,'16.1g',0.34,NULL,NULL,NULL,NULL,NULL,1,220.6580417,24.29553,0.081,NULL,59507600552,929806258,14528222,16.1),(123369,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123369,38.14,0.15,425,55300,70,NULL,NULL,'2MASX J14423808+2221454',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000171,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,220.6587917,22.36264,0.073,NULL,59508277445,929816835,14528388,18),(123370,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123370,37.41,0.46,303,55301,70,NULL,NULL,'2MASX J14423828+3010344',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000199,NULL,'17.00',0.21,NULL,NULL,NULL,NULL,NULL,1,220.659333,30.17617,0,NULL,60019898191,937810909,14653295,17),(123371,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123371,35.31,0.47,116,55302,NULL,NULL,'H','ESO 386- G 012',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000033,NULL,'15',0.7,'Sb             HII',NULL,NULL,NULL,NULL,1,220.661125,-35.0755,0.273,NULL,47221932831,737842700,11528792,15),(123372,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123372,35.37,0.45,119,55302,NULL,NULL,'K','ESO 386- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123373,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123373,35.38,0.4,119,55302,NULL,NULL,'mean','ESO 386- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123374,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123374,35.44,0.46,122,55302,NULL,NULL,'J','ESO 386- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123375,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123375,36.68,0.46,217,55303,70,NULL,NULL,'2MASX J14424152+1007430',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.20',0.2,NULL,NULL,NULL,NULL,NULL,1,220.672917,10.12878,0.033,NULL,59374525536,927726961,14495733,16.2),(123376,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123376,37.77,0.46,358,55304,70,NULL,NULL,'2MASX J14424211+1550419',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,220.675583,15.84497,0.009,NULL,59553899965,930529686,14539526,17.9),(123377,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123377,35.79,0.46,144,55305,70,NULL,NULL,'2MASX J14424260+0119114',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000094,NULL,'16.0g',0.41,'BLAGN          LINER',NULL,NULL,NULL,'Sy 1',1,220.677625,1.31975,0.117,NULL,58262118020,910345594,14224149,16),(123378,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123378,37.44,0.46,307,55306,70,NULL,NULL,'2MASX J14424302+1849584',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.92',0.11,NULL,NULL,NULL,NULL,NULL,1,220.679416667,18.83297,0.061,NULL,59529816330,930153380,14533646,18.92),(123379,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123379,37.77,0.46,359,55307,70,NULL,NULL,'2MASX J14424325+2237184',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000142,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,220.680458333,22.62181,0.073,NULL,59508390222,929818597,14528415,17.9),(123380,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123380,36.37,0.33,188,55308,70,NULL,NULL,'2MASX J14424414+1449579',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.41',0.14,NULL,NULL,NULL,NULL,NULL,1,220.684,14.83267,0.005,NULL,59558768956,930605764,14540715,18.41),(123381,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123381,32.07,NULL,25.9,55309,72,NULL,NULL,'NGC 5733',NULL,'2014Ap.....57..457K',2014,1,1.19,NULL,'G',0.000052,NULL,'14.5g',0.36,'Irr(f)         HII',NULL,NULL,NULL,NULL,1,220.691375,-0.35108,0.093,NULL,43494196215,679596815,10618700,14.5),(123382,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123382,35.73,0.19,140,55310,70,NULL,NULL,'CGCG 076-003',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00018,NULL,'15.1g',0.53,NULL,'Group member',NULL,NULL,NULL,1,220.693333,8.72558,0.041,NULL,59365378056,927584032,14493500,15.1),(123383,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123383,36.03,0.46,161,55311,70,NULL,NULL,'MCG +10-21-027',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000107,NULL,'15.0g',0.55,'E0',NULL,NULL,NULL,NULL,1,220.6937917,61.71247,0.021,NULL,57757677432,902463709,14100995,15),(123384,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123384,32.57,0.2,32.7,55312,74.4,NULL,NULL,'ESO 512- G 016',NULL,'2013AJ....146...86T',2013,1,1.9,'The 2MASS position applies to a superposed star.','G',0.000027,NULL,'15.69',0.3,'S',NULL,NULL,NULL,NULL,1,220.695083,-24.21031,0.365,NULL,46537827802,727153559,11361774,15.69),(123385,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123385,32.85,0.58,37.1,55312,NULL,NULL,NULL,'ESO 512- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123386,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123386,33.01,0.54,39.9,55312,NULL,NULL,'Malmquist cor.','ESO 512- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123387,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123387,32.79,NULL,36.1,55313,72,NULL,NULL,'UGC 09482',NULL,'2014Ap.....57..457K',2014,1,1.34,NULL,'G',0.000031,NULL,'15.60',0.17,'Sd(f)','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,220.695625,0.66175,0.129,NULL,58262641193,910353768,14224277,15.6),(123388,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123388,32.97,0.43,39.3,55313,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09482',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123389,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123389,33.29,NULL,45.6,55313,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09482',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123390,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123390,33.31,NULL,45.9,55313,NULL,NULL,'Dipole + Quadrupole','UGC 09482',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123391,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123391,33.32,NULL,46.1,55313,NULL,NULL,'Dipole','UGC 09482',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123392,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123392,36.88,0.23,237,55314,70,NULL,NULL,'2MASX J14424754+1022200',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,220.6979583,10.37225,0.009,NULL,59374413339,927725208,14495706,17.4),(123393,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123393,38.11,0.46,418,55315,70,NULL,NULL,'2MASX J14424777+2846257',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.6989583,28.77394,0,NULL,60027273126,937926142,14655095,17.6),(123394,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123394,34.34,0.55,73.8,55316,70,NULL,NULL,'ESO 580- G 011',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00005,NULL,'14.99',0.5,'(R)SA(l)0^+',NULL,NULL,NULL,NULL,1,220.700167,-19.89769,0.353,NULL,46528302287,727004723,11359448,14.99),(123395,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123395,35.33,0.59,116,55317,70,NULL,NULL,'2MASX J14424829-3634465',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'13.4I',0.5,'SB(r)0/a',NULL,NULL,NULL,NULL,1,220.701167,-36.57956,0.225,NULL,47224073054,737876141,11529314,13.4),(123396,'BL Lac Luminosity','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123396,39.45,NULL,667,55318,NULL,NULL,NULL,'SDSS J144248.28+120040.3',0.163058,'2005ApJ...635..173S',2005,1,NULL,'87GB source with large sky, narrow minor axis, or very bad confusion.','QSO',0.000187,NULL,'17.3g',NULL,'BrClG          BLLAC',NULL,NULL,NULL,'BL Lac',1,220.701167,12.01119,0.013,NULL,59371466935,927679170,14494987,17.3),(123397,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123397,37.55,0.71,324,55319,70,NULL,NULL,'2MASX J14424843-4224210',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,220.7017917,-42.40589,0.345,NULL,47089759149,735777486,11496523,15.9),(123398,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123398,34.9,0.33,95.6,55320,70,NULL,NULL,'CGCG 048-003',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000156,NULL,'15.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,220.702083,6.65675,0.065,NULL,59362237687,927534963,14492733,15.4),(123399,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123399,38.35,0.19,467,55321,70,NULL,NULL,'2MASX J14424847+5501550',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000183,NULL,'16.8g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,220.702083,55.03208,0,NULL,57246313126,894473642,13976150,16.8),(123400,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123400,38.35,0.19,467,55322,70,NULL,NULL,'2MASX J14424859+5511130',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000152,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.702667,55.18697,0,NULL,57246758329,894480598,13976259,17.3),(123401,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123401,34.57,0.65,82.1,55323,NULL,NULL,NULL,'ESO 327- G 012',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'13.56',0.5,'Sb-c',NULL,NULL,NULL,NULL,1,220.7037083,-40.59997,0.089,NULL,47087209586,735737649,11495900,13.56),(123402,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123402,34.58,0.65,82.5,55323,NULL,NULL,'Malmquist cor.','ESO 327- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123403,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123403,34.61,0.2,83.6,55323,74.4,NULL,NULL,'ESO 327- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123404,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123404,36.37,0.33,188,55324,70,NULL,NULL,'2MASX J14424973+1451039',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.19',0.17,NULL,NULL,NULL,NULL,NULL,1,220.707167,14.85097,0.009,NULL,59558767590,930605743,14540714,18.19),(123405,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123405,38.35,0.19,467,55325,70,NULL,NULL,'2MASX J14425255+5507360',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,220.71925,55.12664,0,NULL,57246293291,894473332,13976145,17.6),(123406,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123406,37.18,0.33,273,55326,70,NULL,NULL,'2MASX J14425293+2252579',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000178,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,220.720667,22.88267,0.078,NULL,59508650154,929822658,14528479,16.4),(123407,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123407,38.01,0.17,400,55327,70,NULL,NULL,'2MASX J14425310+2009159',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.72125,20.15442,0.031,NULL,59500746636,929699166,14526549,17.9),(123408,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123408,38.35,0.19,467,55328,70,NULL,NULL,'2MASX J14425374+5516200',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000144,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.724208333,55.27211,0,NULL,57246617410,894478397,13976224,17.5),(123409,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123409,36.53,0.68,202,55329,70,NULL,NULL,'2MASX J14425415-1749154',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.4,NULL,NULL,NULL,NULL,NULL,1,220.725667,-17.82097,0.349,NULL,46679391449,729365491,11396335,14.2),(123410,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123410,38.41,0.46,481,55330,70,NULL,NULL,'2MASX J14425463+3615466',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000175,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,220.727583,36.26289,0,NULL,60068122916,938564420,14665069,17.6),(123411,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123411,38.01,0.17,400,55331,70,NULL,NULL,'2MASX J14425480+2011269',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.728333,20.19078,0.031,NULL,59500776398,929699631,14526556,17.8),(123412,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123412,35.64,0.46,134,55332,70,NULL,NULL,'2MASX J14425567+0109044',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000061,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,220.731875,1.15111,0.117,NULL,58262226502,910347289,14224176,16.5),(123413,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123413,34.9,0.33,95.6,55333,70,NULL,NULL,'CGCG 048-006',NULL,'2015arXiv151105856S',2015,1,1.03,NULL,'G',0.00008,NULL,'15.1g',0.34,NULL,NULL,NULL,NULL,NULL,1,220.7332083,6.72183,0.069,NULL,59362189952,927534218,14492722,15.1),(123414,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123414,32.7,0.5,34.7,55334,70,NULL,NULL,'NGC 5726',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000067,NULL,'14.17',1,'S0- pec sp',NULL,NULL,NULL,NULL,1,220.7335417,-18.44489,0.329,NULL,46695223230,729612862,11400200,14.17),(123415,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123415,37.37,0.46,298,55335,70,NULL,NULL,'2MASX J14425640+1134260',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000159,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,220.735083333,11.57394,0.009,NULL,59371600553,927681258,14495019,16.7),(123416,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123416,36.59,0.46,208,55336,70,NULL,NULL,'CGCG 134-021',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000073,NULL,'15.3g',0.48,NULL,NULL,NULL,NULL,NULL,1,220.736417,25.0165,0.066,NULL,59493109328,929579833,14524684,15.3),(123417,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123417,36.99,0.46,250,55337,70,NULL,NULL,'2MASX J14425716+1738119',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.45',0.26,NULL,NULL,NULL,NULL,NULL,1,220.73825,17.63669,0.028,NULL,59551616945,930494014,14538968,17.45),(123418,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123418,37.8,0.46,363,55338,70,NULL,NULL,'2MASX J14425718+0917170',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000187,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,220.738375,9.28806,0.041,NULL,59370911514,927670492,14494851,16.7),(123419,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123419,38.07,0.46,412,55339,70,NULL,NULL,'2MASX J14425737+3121484',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000198,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,220.7390417,31.36339,0,NULL,60016933104,937764579,14652571,17.2),(123420,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123420,37.56,0.46,324,55340,70,NULL,NULL,'2MASX J14425748+0713220',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.739583,7.22286,0.065,NULL,59362989351,927546708,14492917,17.6),(123421,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123421,36.59,0.2,208,55341,74.4,NULL,NULL,'UGC 09487',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000033,NULL,'15.33',0.4,'Sab','Isolated galaxy',NULL,NULL,NULL,1,220.74025,21.42061,0.031,NULL,59503701212,929745331,14527270,15.33),(123422,'IRAS','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123422,32.1,0.8,26.3,55342,75,NULL,'A82, H','IC 1048',NULL,'1997ApJS..109..333W',1997,1,2.2,'HOLM 670B is a star.','G',0.00002,NULL,'13.6B',0.7,'S','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,220.741667,4.88947,0.077,NULL,58255149299,910236707,14222448,13.6),(123423,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123423,31.77,0.4,22.6,55342,NULL,NULL,'Virgo cluster at 15.6 Mpc','IC 1048',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123424,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123424,32.08,0.4,26.1,55342,75,NULL,NULL,'IC 1048',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123425,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123425,32.19,0.4,27.4,55342,NULL,NULL,'mean','IC 1048',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123426,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123426,32.2,0.4,27.6,55342,75,NULL,'B','IC 1048',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123427,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123427,32.28,0.47,28.6,55342,75,NULL,'A82, H, raw','IC 1048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123428,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123428,32.33,0.47,29.2,55342,75,NULL,'A82, H, inv','IC 1048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123429,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123429,32.34,NULL,29.4,55342,72,NULL,NULL,'IC 1048',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123430,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123430,32.39,0.47,30.1,55342,75,NULL,'A82, H, cor','IC 1048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123431,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123431,32.43,0.47,30.6,55342,NULL,NULL,'Malmquist cor.','IC 1048',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123432,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123432,32.48,0.47,31.4,55342,NULL,NULL,'H','IC 1048',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123433,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123433,32.5,0.46,31.7,55342,NULL,NULL,'J','IC 1048',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123434,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123434,32.55,0.45,32.4,55342,NULL,NULL,'K','IC 1048',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123435,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123435,32.63,0.49,33.5,55342,75,NULL,'IR','IC 1048',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123436,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123436,32.73,0.41,35.2,55342,NULL,NULL,NULL,'IC 1048',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123437,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123437,32.77,0.2,35.8,55342,74.4,NULL,NULL,'IC 1048',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123438,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123438,38.01,0.17,400,55343,70,NULL,NULL,'2MASX J14425963+2013059',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.72',0.19,'BrClG',NULL,NULL,NULL,NULL,1,220.7485417,20.21825,0.042,NULL,59500776694,929699635,14526556,17.72),(123439,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123439,37.66,0.46,340,55344,70,NULL,NULL,'2MASX J14430056+2558181',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.68',0.14,NULL,NULL,NULL,NULL,NULL,1,220.752375,25.97175,0.056,NULL,60025810090,937903282,14654738,18.68),(123440,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123440,37.84,0.46,370,55345,70,NULL,NULL,'2MASX J14430083+2429471',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.7535417,24.49639,0.087,NULL,59506824372,929794130,14528033,17.5),(123441,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123441,32.48,NULL,31.3,55346,72,NULL,NULL,'UGC 09485',NULL,'2014Ap.....57..457K',2014,1,1.4,NULL,'G',0.000023,NULL,'14.9B',0.4,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,220.7617917,4.76567,0.085,NULL,58255065777,910235402,14222428,14.9),(123442,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123442,38.35,0.19,467,55347,70,NULL,NULL,'2MASX J14430282+5507559',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000214,NULL,'17.4g',0.2,'BrClG',NULL,NULL,NULL,NULL,1,220.762,55.13231,0,NULL,57246292666,894473322,13976145,17.4),(123443,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123443,37.4,0.46,302,55348,70,NULL,NULL,'2MASX J14430291+4441233',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000154,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,220.762333,44.68972,0.017,NULL,59956457447,936819647,14637806,17.2),(123444,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123444,38.28,0.46,453,55349,70,NULL,NULL,'2MASX J14430353+2057589',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.76475,20.96625,0,NULL,59504434729,929756792,14527449,17.8),(123445,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123445,37.18,0.46,273,55350,70,NULL,NULL,'2MASX J14430456+0501329',NULL,'2015arXiv151105856S',2015,1,0.32,'Star superposed 7\\\" southeast of the galaxy. HOLM 671B is a star.','G',0.000113,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,220.768917,5.02567,0.077,NULL,58255625756,910244152,14222564,16.6),(123446,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123446,38.09,0.46,415,55351,70,NULL,NULL,'2MASX J14430551+3644357',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000175,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,220.773125,36.74331,0,NULL,60075905339,938686020,14666969,18.3),(123447,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123447,37.62,0.46,334,55352,70,NULL,NULL,'SDSS J144305.92+095932.7',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,220.774667,9.99244,0.033,NULL,59374344447,927724131,14495689,17.4),(123448,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123448,36.01,0.33,159,55353,70,NULL,NULL,'2MASX J14430737+2412411',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000183,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,220.780625,24.21133,0.081,NULL,59507593628,929806150,14528221,17.2),(123449,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123449,36.32,0.46,184,55354,70,NULL,NULL,'2MASX J14430756+2342589',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,220.781541667,23.71653,0.057,NULL,59507365411,929802584,14528165,16.7),(123450,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123450,38.01,0.17,400,55355,70,NULL,NULL,'2MASX J14430787+2011199',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.41',0.13,NULL,NULL,NULL,NULL,NULL,1,220.782917,20.18892,0.042,NULL,59500774106,929699595,14526556,18.41),(123451,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123451,34.78,0.46,90.3,55356,70,NULL,NULL,'ESO 386- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000067,NULL,'15',0.7,'S0',NULL,NULL,NULL,NULL,1,220.7832083,-36.48914,0.229,NULL,47224063385,737875990,11529312,15),(123452,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123452,38.14,0.46,424,55357,70,NULL,NULL,'2MASX J14430834+2929431',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00009,NULL,'18.05',0.17,'E',NULL,NULL,NULL,NULL,1,220.78475,29.49525,0,NULL,60019094218,937798347,14653099,18.05),(123453,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123453,37.18,0.33,273,55358,70,NULL,NULL,'2MASX J14430878+2252359',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.786583,22.87667,0.078,NULL,59508601421,929821897,14528467,17.5),(123454,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123454,37.68,0.46,344,55359,70,NULL,NULL,'2MASX J14430951+1326256',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.91',0.14,NULL,NULL,NULL,NULL,NULL,1,220.7897083,13.44036,0.005,NULL,59558021238,930594081,14540532,18.91),(123455,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123455,36.04,0.46,162,55360,70,NULL,NULL,'2MASX J14431112+4637283',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000171,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,220.796291667,46.62467,0.025,NULL,59987736264,937308379,14645443,16.7),(123456,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123456,34.87,0.69,94.4,55361,100,NULL,'mid-IR','NGC 5737',NULL,'2013ApJ...771...88L',2013,1,1.3,NULL,'G',0.000033,NULL,'14.28',0.8,'SBb',NULL,NULL,NULL,NULL,1,220.79925,18.87994,0.061,NULL,59529778201,930152784,14533637,14.28),(123457,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123457,35.57,0.2,130,55361,74.4,NULL,NULL,'NGC 5737',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123458,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123458,35.66,0.47,136,55361,NULL,NULL,'H','NGC 5737',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123459,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123459,35.77,0.4,143,55361,NULL,NULL,'mean','NGC 5737',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123460,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123460,35.8,0.45,145,55361,NULL,NULL,'K','NGC 5737',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123461,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123461,35.81,0.46,145,55361,NULL,NULL,'J','NGC 5737',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123462,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123462,36.58,0.46,207,55362,70,NULL,NULL,'2MASX J14431174+5925198',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000071,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,220.799167,59.42236,0,NULL,57768468666,902632322,14103630,16.9),(123463,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123463,37.71,0.46,348,55363,70,NULL,NULL,'2MASX J14431229+2540251',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000151,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,220.80125,25.67361,0.037,NULL,60014353377,937724271,14651941,17.3),(123464,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123464,37.27,0.46,285,55364,70,NULL,NULL,'2MASX J14431388+1357266',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.41',0.12,NULL,NULL,NULL,NULL,NULL,1,220.807833333,13.95739,0,NULL,59558465969,930601030,14540641,18.41),(123465,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123465,37.32,0.46,291,55365,70,NULL,NULL,'2MASX J14431471+1156246',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,220.8112917,11.94017,0.013,NULL,59371457996,927679031,14494984,17.1),(123466,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123466,38.47,0.46,494,55366,70,NULL,NULL,'2MASX J14431595+3125274',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,220.816417,31.42411,0,NULL,60088024772,938875387,14669927,17.9),(123467,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123467,37.79,0.33,362,55367,70,NULL,NULL,'2MASX J14431715+5029443',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000171,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,220.821417,50.49583,0.049,NULL,59199644793,924994449,14453038,16.8),(123468,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123468,36.97,0.79,248,55368,70,NULL,NULL,'2MASX J14431809-1808243',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,220.8254583,-18.14008,0.321,NULL,46678531768,729352058,11396125,14.5),(123469,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123469,36.3,0.46,182,55369,70,NULL,NULL,'CGCG 134-022',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.0001,NULL,'15.7',0.5,NULL,NULL,NULL,NULL,NULL,1,220.827958333,20.78625,0,NULL,59504149528,929752336,14527380,15.7),(123470,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123470,37.86,0.46,373,55370,70,NULL,NULL,'2MASX J14431913+0327049',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000095,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,220.829667,3.45125,0.077,NULL,58256081406,910251271,14222676,17),(123471,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123471,37.5,0.46,316,55371,70,NULL,NULL,'2MASX J14432069+1301266',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00021,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,220.836333333,13.02419,0.005,NULL,59557143979,930580374,14540318,16.9),(123472,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123472,37.79,0.46,362,55372,70,NULL,NULL,'2MASX J14432104+4651393',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,220.837541667,46.86089,0.017,NULL,59987628337,937306692,14645417,17.4),(123473,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123473,37.59,0.46,329,55373,70,NULL,NULL,'2MASX J14432198+1453526',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,220.841583,14.89797,0,NULL,59558786585,930606040,14540719,NULL),(123474,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123474,38.54,0.46,510,55374,70,NULL,NULL,'2MASX J14432225+5755235',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.842583333,57.92314,0,NULL,57723762883,901933795,14092715,18),(123475,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123475,35.57,0.66,130,55375,70,NULL,NULL,'2MASX J14432242-1732029',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.2I',0.2,NULL,NULL,NULL,NULL,NULL,1,220.8434583,-17.53414,0.365,NULL,46678869351,729357333,11396208,14.2),(123476,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123476,37.86,0.46,374,55376,70,NULL,NULL,'SDSS J144323.21+080839.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.846708333,8.14439,0.049,NULL,59366017082,927594016,14493656,18.3),(123477,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123477,37.66,0.46,341,55377,70,NULL,NULL,'SDSS J144323.51+220806.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000143,NULL,'18.1g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.848,22.13517,0.059,NULL,59506184725,929784136,14527877,18.1),(123478,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123478,37.81,0.33,366,55378,70,NULL,NULL,'SDSS J144323.75+290253.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000149,NULL,'18.5g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.849,29.04811,0,NULL,60019026480,937797288,14653082,18.5),(123479,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123479,37.88,0.46,376,55379,70,NULL,NULL,'2MASX J14432454+2245293',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000193,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,220.852208333,22.75819,0.054,NULL,59508328413,929817631,14528400,16.6),(123480,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123480,36.51,0.46,201,55380,70,NULL,NULL,'2MASX J14432455+0739269',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000174,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,220.85225,7.65736,0.041,NULL,59362320671,927536260,14492754,16.5),(123481,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123481,37.14,0.46,267,55381,70,NULL,NULL,'2MASX J14432460+0321209',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000081,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,220.852417,3.35581,0.077,NULL,58256165119,910252579,14222696,17.1),(123482,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123482,38.19,0.46,435,55382,70,NULL,NULL,'2MASX J14432463+2825110',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000141,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,220.852625,28.41975,0,NULL,60027132517,937923945,14655061,18),(123483,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123483,37.33,0.46,292,55383,70,NULL,NULL,'2MASX J14432473+5113373',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,220.852958333,51.22711,0.033,NULL,59203869558,925060461,14454069,17.6),(123484,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123484,36.37,0.46,188,55384,70,NULL,NULL,'MCG +09-24-032',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000196,NULL,'15.4g',0.54,'S0',NULL,NULL,NULL,NULL,1,220.853125,52.61453,0,NULL,59192899446,924889053,14451391,15.4),(123485,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123485,35.73,0.19,140,55385,70,NULL,NULL,'2MASX J14432505+0840479',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,220.854417,8.68,0.029,NULL,59365284384,927582568,14493477,16.7),(123486,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123486,37.79,0.33,362,55386,70,NULL,NULL,'2MASX J14432532+5029353',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000176,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,220.8555,50.49306,0.061,NULL,59199645248,924994457,14453038,16.4),(123487,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123487,37.39,0.46,300,55387,70,NULL,NULL,'VII Zw 561',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000179,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,220.85675,57.43217,0,NULL,57723254203,901925846,14092591,16.9),(123488,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123488,34.91,0.46,96.1,55388,70,NULL,NULL,'CGCG 048-008',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000103,NULL,'14.7g',0.64,'E0',NULL,NULL,NULL,NULL,1,220.856917,4.37908,0.069,NULL,58258531076,910289548,14223274,14.7),(123489,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123489,37,0.46,252,55389,70,NULL,NULL,'2MASX J14432600+3508534',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000183,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,220.858333,35.14817,0,NULL,60068426631,938569166,14665143,16.5),(123490,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123490,37.5,1.06,316,55390,70,NULL,NULL,'ESO 580- G 013',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'15.75',1,'SB(r)bc',NULL,NULL,NULL,NULL,1,220.866667,-17.87397,0.349,NULL,46679339542,729364680,11396323,15.75),(123491,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123491,36.21,0.46,174,55391,70,NULL,NULL,'2MASX J14432822+0347009',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000101,NULL,'16.0g',0.34,'NLAGN',NULL,NULL,NULL,NULL,1,220.8675,3.78369,0.069,NULL,58256523835,910258184,14222784,16),(123492,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123492,38.01,0.17,400,55392,70,NULL,NULL,'SDSS J144330.18+200453.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.09,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.87575,20.08161,0.031,NULL,59500867651,929701057,14526579,18.5),(123493,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123493,36.85,0.33,235,55393,70,NULL,NULL,'2MASX J14433035+3135573',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000181,NULL,'15.9g',0.44,NULL,NULL,NULL,NULL,NULL,1,220.876625,31.59942,0,NULL,60088055889,938875873,14669935,15.9),(123494,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123494,37.46,0.46,311,55394,70,NULL,NULL,'2MASX J14433095+0543029',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000179,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.878875,5.71744,0.069,NULL,58254904904,910232889,14222388,17.8),(123495,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123495,36.88,0.23,237,55395,70,NULL,NULL,'2MASX J14433164+1020509',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000158,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,220.8817917,10.34767,0.049,NULL,59374322570,927723790,14495684,17.2),(123496,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123496,37.81,0.33,366,55396,70,NULL,NULL,'2MASX J14433238+2858320',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.6g',0.21,'S0',NULL,NULL,NULL,NULL,1,220.884916667,28.97561,0,NULL,60019022872,937797232,14653081,17.6),(123497,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123497,36.22,0.46,175,55397,70,NULL,NULL,'SDSS J144333.30+201856.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.92',0.17,NULL,NULL,NULL,NULL,NULL,1,220.888791667,20.31569,0.042,NULL,59500759679,929699369,14526552,17.92),(123498,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123498,36.43,0.27,194,55398,70,NULL,NULL,'2MASX J14433343+1514502',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.97',0.18,NULL,NULL,NULL,NULL,NULL,1,220.8892083,15.24742,0.021,NULL,59555423262,930553488,14539898,17.97),(123499,'D-Sigma','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123499,32.75,0.4,35.5,55399,75,NULL,'Edat, raw','ESO 512- G 018',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.000067,NULL,'12.95',1.5,'SAB0^0^: pec','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,220.891375,-24.46089,0.385,NULL,46536919113,727139361,11361552,12.95),(123500,'D-Sigma','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123500,32.86,0.4,37.3,55399,75,NULL,'Edat, cor','ESO 512- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123501,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123501,33.02,0.45,40.1,55399,NULL,NULL,'K','ESO 512- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123502,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123502,33.48,0.4,49.6,55399,NULL,NULL,'mean','ESO 512- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123503,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123503,35.23,0.48,111,55400,70,NULL,NULL,'MCG -01-38-001',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'14.88',0.2,NULL,NULL,NULL,NULL,NULL,1,220.90225,-5.17608,0.153,NULL,43495920752,679623761,10619121,14.88),(123504,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123504,37.75,0.46,355,55401,70,NULL,NULL,'2MASX J14433859+3559265',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000138,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.910917,35.99053,0,NULL,60068614308,938572098,14665189,17.7),(123505,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123505,38.3,0.46,458,55402,70,NULL,NULL,'SDSS J144338.94+194335.8',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,220.9122917,19.72661,0.077,NULL,59500799797,929699996,14526562,NULL),(123506,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123506,35.73,0.19,140,55403,70,NULL,NULL,'2MASX J14433896+0833506',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000172,NULL,'16.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,220.912375,8.56411,0.057,NULL,59365326641,927583228,14493487,16.2),(123507,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123507,35.3,NULL,115,55404,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09490',NULL,'2010Ap&SS.325..163P',2010,1,1.57,NULL,'G',0.000016,NULL,'15.48',0.16,'Scd','in a triple',NULL,NULL,NULL,1,220.9142083,11.13931,0,NULL,59372143453,927689741,14495152,15.48),(123508,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123508,35.31,NULL,115,55404,NULL,NULL,'Dipole + Quadrupole','UGC 09490',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123509,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123509,35.32,NULL,116,55404,NULL,NULL,'Dipole','UGC 09490',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123510,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123510,35.35,NULL,117,55404,NULL,NULL,NULL,'UGC 09490',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123511,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123511,37.73,0.46,352,55405,70,NULL,NULL,'2MASX J14434022+1335203',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.54',0.13,NULL,NULL,NULL,NULL,NULL,1,220.9175,13.58897,0,NULL,59557481451,930585647,14540400,18.54),(123512,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123512,38.49,0.46,499,55406,70,NULL,NULL,'SDSS J144341.54+470313.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,220.923125,47.05369,0.021,NULL,59987661504,937307211,14645425,18.3),(123513,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123513,35.06,0.2,103,55407,74.4,NULL,NULL,'CGCG 134-023',NULL,'2013AJ....146...86T',2013,1,0.94,NULL,'G',0.000007,NULL,'14.8g',0.48,'Sa',NULL,NULL,NULL,NULL,1,220.9237917,23.01872,0.03,NULL,59507922388,929811287,14528301,14.8),(123514,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123514,36.93,0.46,243,55408,70,NULL,NULL,'2MASX J14434245+5644136',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000181,NULL,'16.0g',0.41,'E0',NULL,NULL,NULL,NULL,1,220.92725,56.73725,0.029,NULL,57258577334,894665270,13979144,16),(123515,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123515,37.28,0.46,286,55409,70,NULL,NULL,'2MASX J14434271+4416024',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00017,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,220.927875,44.26739,0.025,NULL,59955678257,936807472,14637616,16.5),(123516,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123516,32.89,NULL,37.9,55410,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1809',NULL,'2010Ap&SS.325..163P',2010,1,0.92,NULL,'G',0.000023,NULL,'16.6',0.1,'Sd',NULL,NULL,NULL,NULL,1,220.93,79.76778,0.085,NULL,57175296632,893364009,13958812,16.6),(123517,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123517,32.92,NULL,38.4,55410,NULL,NULL,'Dipole + Quadrupole','FGC 1809',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123518,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123518,32.95,NULL,38.9,55410,NULL,NULL,'Dipole','FGC 1809',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123519,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123519,33.02,NULL,40.3,55410,NULL,NULL,NULL,'FGC 1809',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123520,'SGRB','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123520,42.89,NULL,3780,55411,70,NULL,'Photometric Distance, Host A, M(R) = -20 mag and spectral slope Beta = 1.0 ','GRB 060805A',NULL,'2012A&A...545A..77R',2012,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,220.931166667,12.5865,0.009,NULL,59548673974,930448030,14538250,NULL),(123521,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123521,37.56,0.33,326,55412,70,NULL,NULL,'2MASX J14434452+4832593',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000188,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,220.9357083,48.54986,0.101,NULL,59935890146,936498283,14632785,16.5),(123522,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123522,37.56,0.33,326,55413,70,NULL,NULL,'2MASX J14434531+4829563',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,220.9385417,48.49881,0.101,NULL,59935884373,936498193,14632784,17.3),(123523,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123523,37.82,0.27,366,55414,70,NULL,NULL,'SDSS J144345.28+221728.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.938667,22.29128,0.051,NULL,59506419137,929787799,14527934,18.5),(123524,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123524,38.57,0.33,517,55415,70,NULL,NULL,'2MASX J14434627+2807519',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,220.942791667,28.13119,0.031,NULL,60027579315,937930926,14655170,17.7),(123525,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123525,36.77,0.46,226,55416,70,NULL,NULL,'2MASX J14434707+2726539',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.27',0.24,'Sbrst(PHOT)',NULL,NULL,NULL,NULL,1,220.946375,27.44839,0.043,NULL,60028075975,937938687,14655291,17.27),(123526,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123526,38.27,0.46,452,55417,70,NULL,NULL,'SDSS J144348.84+224350.7',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000149,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.9535417,22.73078,0.054,NULL,59506298503,929785914,14527904,18.5),(123527,'IRAS','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123527,33.47,0.8,49.5,55418,75,NULL,'CF, r','NGC 5751',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000027,NULL,'13.8g',0.8,'Scd:','Field galaxy',NULL,NULL,NULL,1,220.954917,53.40067,0,NULL,59193338295,924895910,14451498,13.8),(123528,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123528,32.93,0.38,38.5,55418,75,NULL,'CF, r, raw','NGC 5751',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123529,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123529,32.97,0.38,39.2,55418,75,NULL,'CF, r, inv','NGC 5751',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123530,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123530,33.05,0.38,40.7,55418,75,NULL,'CF, r, cor','NGC 5751',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123531,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123531,33.58,0.47,52,55418,NULL,NULL,'H','NGC 5751',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123532,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123532,33.6,0.4,52.6,55418,NULL,NULL,'mean','NGC 5751',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123533,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123533,33.72,0.46,55.5,55418,NULL,NULL,'J','NGC 5751',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123534,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123534,33.8,0.45,57.5,55418,NULL,NULL,'K','NGC 5751',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123535,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123535,37.31,0.46,289,55419,70,NULL,NULL,'2MASX J14434992+2241182',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000143,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,220.958083333,22.68847,0.054,NULL,59506297864,929785904,14527904,17.7),(123536,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123536,35.09,0.53,104,55420,70,NULL,NULL,'AM 1440-365 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.000087,NULL,'13.2I',0.6,NULL,NULL,NULL,NULL,NULL,1,220.960333333,-37.07008,0.253,NULL,47224713404,737886146,11529471,13.2),(123537,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123537,37.55,0.46,323,55421,70,NULL,NULL,'SDSS J144351.09+321257.7',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000159,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,220.962917,32.21603,0,NULL,60088482025,938882531,14670039,18.7),(123538,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123538,36.88,0.23,237,55422,70,NULL,NULL,'SDSS J144351.63+102018.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,220.965167,10.33856,0.049,NULL,59374210897,927722045,14495656,17.7),(123539,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123539,36.95,0.46,245,55423,70,NULL,NULL,'2MASX J14435229+2541399',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000184,NULL,'15.9g',0.38,NULL,NULL,NULL,NULL,NULL,1,220.967833,25.69439,0.064,NULL,60014374231,937724597,14651946,15.9),(123540,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123540,38.57,0.33,517,55424,70,NULL,NULL,'2MASX J14435292+2808069',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,220.9705,28.13542,0.031,NULL,60027622562,937931602,14655181,17.7),(123541,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123541,38.14,0.46,425,55425,70,NULL,NULL,'2MASX J14435418+1941202',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,220.975875,19.68894,0.077,NULL,59500803333,929700052,14526563,17.6),(123542,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123542,35.44,0.46,122,55426,70,NULL,NULL,'IC 4496',NULL,'2015arXiv151105856S',2015,1,0.99,NULL,'G',0.000093,NULL,'14.6g',0.69,NULL,NULL,NULL,NULL,NULL,1,220.977416667,33.40656,0,NULL,60122177201,939409018,14678265,14.6),(123543,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123543,34.84,0.46,92.7,55427,70,NULL,NULL,'CGCG 220-051',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.000157,NULL,'14.8g',0.33,'Sb','Isolated galaxy',NULL,NULL,NULL,1,220.977833,43.58061,0.043,NULL,59957664023,936838500,14638101,14.8),(123544,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123544,37.55,0.46,324,55428,70,NULL,NULL,'2MASX J14435656+3351056',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,220.9857083,33.85169,0,NULL,60121885149,939404455,14678194,17.4),(123545,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123545,36.85,0.33,235,55429,70,NULL,NULL,'2MASX J14435660+3128136',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000185,NULL,'15.8g',0.4,NULL,NULL,NULL,NULL,NULL,1,220.9859583,31.47047,0,NULL,60088082526,938876289,14669942,15.8),(123546,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123546,39.17,0.46,681,55430,70,NULL,NULL,'SDSS J144356.65+073659.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00017,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.986083,7.6165,0.061,NULL,59362350412,927536725,14492761,18.6),(123547,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123547,37.5,0.46,316,55431,70,NULL,NULL,'2MASX J14435680+2024122',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'17.94',0.09,NULL,NULL,NULL,NULL,NULL,1,220.986708333,20.40356,0.042,NULL,59504279670,929754369,14527412,17.94),(123548,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123548,37.66,0.33,340,55432,70,NULL,NULL,'SDSS J144357.82+425026.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000132,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,220.991,42.84069,0.015,NULL,59958226991,936847296,14638239,18.5),(123549,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123549,38.49,0.27,499,55433,70,NULL,NULL,'2MASX J14435799+1755462',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,220.9915417,17.92956,0.04,NULL,59551318311,930489348,14538896,17.8),(123550,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123550,37.12,0.46,265,55434,70,NULL,NULL,'2MASX J14435912+5557596',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000171,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,220.9965,55.96653,0.009,NULL,57245289734,894457652,13975900,16.4),(123551,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123551,37.76,0.46,356,55435,70,NULL,NULL,'2MASX J14435995+5439146',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000177,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.999833,54.65403,0,NULL,59191608302,924868879,14451076,17.5),(123552,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123552,37.66,0.33,340,55436,70,NULL,NULL,'2MASX J14440003+4250375',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,221.000083,42.84369,0.015,NULL,59958219783,936847184,14638237,17.3),(123553,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123553,36,0.46,158,55437,70,NULL,NULL,'2MASX J14440012+2337522',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000204,NULL,'15.5g',0.47,NULL,NULL,NULL,NULL,NULL,1,221.000541667,23.63108,0.043,NULL,59507248446,929800756,14528136,15.5),(123554,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123554,38.32,0.46,460,55438,70,NULL,NULL,'SDSS J144401.68+164027.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.007041667,16.67422,0.005,NULL,59554318160,930536221,14539628,18.4),(123555,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123555,35.08,0.49,104,55439,75,NULL,'IR','ESO 386- G 016',NULL,'2011yCatp016004901K',2011,1,1.68,NULL,'G',0.000023,NULL,'16.46',0.17,'Sb',NULL,NULL,NULL,NULL,1,221.0077917,-36.13594,0.237,NULL,47222482831,737851294,11528926,16.46),(123556,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123556,35.21,NULL,110,55439,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 386- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123557,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123557,35.23,NULL,111,55439,NULL,NULL,'Dipole','ESO 386- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123558,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123558,35.23,NULL,111,55439,NULL,NULL,'Dipole + Quadrupole','ESO 386- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123559,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123559,35.54,0.43,128,55439,75,NULL,'3.6 micron, color + selection bias corrected','ESO 386- G 016',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123560,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123560,37.92,0.46,384,55440,70,NULL,NULL,'2MASX J14440342+2552068',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,221.0142917,25.86869,0.056,NULL,60014384073,937724751,14651949,17.8),(123561,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123561,38.38,0.46,474,55441,70,NULL,NULL,'2MASX J14440345+1929322',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,221.014375,19.49233,0.066,NULL,59529890424,930154537,14533664,17.8),(123562,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123562,38.49,0.27,499,55442,70,NULL,NULL,'SDSS J144403.49+175537.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.5g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.014583,17.92697,0.035,NULL,59551318395,930489349,14538896,18.5),(123563,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123563,37.89,0.46,379,55443,70,NULL,NULL,'2MASX J14440428+1913142',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'19.19',0.1,NULL,NULL,NULL,NULL,NULL,1,221.017917,19.22067,0.066,NULL,59529929315,930155145,14533674,19.19),(123564,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123564,37.84,0.46,370,55444,70,NULL,NULL,'2MASX J14440508+3400166',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,221.021167,34.00483,0,NULL,60121926787,939405106,14678204,17.4),(123565,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123565,37.79,0.46,362,55445,70,NULL,NULL,'2MASX J14440707+4701375',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00018,NULL,'16.3g',0.4,NULL,NULL,NULL,NULL,NULL,1,221.0295417,47.027,0.017,NULL,59987612578,937306446,14645413,16.3),(123566,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123566,38.18,0.46,433,55446,70,NULL,NULL,'2MASX J14440728+5530155',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000136,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,221.030625,55.50419,0.005,NULL,57247103546,894485992,13976343,17.5),(123567,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123567,37.37,0.46,298,55447,70,NULL,NULL,'SDSS J144407.59+094939.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000173,NULL,'18.0g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.031667,9.82767,0.033,NULL,59373855742,927716495,14495570,18),(123568,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123568,35.73,0.19,140,55448,70,NULL,NULL,'2MASX J14440930+0838401',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000083,NULL,'15.6g',0.39,NULL,NULL,NULL,NULL,NULL,1,221.038667,8.6445,0.077,NULL,59363397674,927553088,14493017,15.6),(123569,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123569,38.06,0.46,409,55449,70,NULL,NULL,'2MASX J14440956+3521216',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000193,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.04,35.35614,0,NULL,60068406705,938568854,14665138,17.3),(123570,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123570,36.6,0.46,209,55450,70,NULL,NULL,'2MASX J14441032+1507135',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.14',0.17,NULL,NULL,NULL,NULL,NULL,1,221.043083,15.12031,0,NULL,59555291784,930551434,14539866,18.14),(123571,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123571,38.01,0.17,400,55451,70,NULL,NULL,'SDSS J144410.49+201420.7',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.8g',0.27,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.04375,20.23911,0.042,NULL,59500897614,929701525,14526586,16.8),(123572,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123572,36.97,0.46,248,55452,70,NULL,NULL,'SDSS J144410.78+282423.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000151,NULL,'18.3g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.0449583,28.40642,0,NULL,60027601566,937931274,14655176,18.3),(123573,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123573,36.5,0.46,200,55453,70,NULL,NULL,'IC 1051',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000177,NULL,'15.4',0.7,NULL,NULL,NULL,NULL,NULL,1,221.0482917,19.02022,0.076,NULL,59530009713,930156401,14533693,15.4),(123574,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123574,37.59,0.46,330,55454,70,NULL,NULL,'2MASX J14441234+0346508',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00008,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,221.0515,3.78092,0.069,NULL,58258018583,910281540,14223149,17.5),(123575,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123575,37.23,0.71,279,55455,70,NULL,NULL,'2MASX J14441271-2914081',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000103,NULL,'14.8I',0.3,NULL,NULL,NULL,NULL,NULL,1,221.053,-29.23556,0.529,NULL,47019629353,734681708,11479401,14.8),(123576,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123576,38.13,0.46,423,55456,70,NULL,NULL,'2MASX J14441317+4604423',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,221.0549583,46.0785,0,NULL,59990863488,937357242,14646206,17),(123577,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123577,38.67,0.46,542,55457,70,NULL,NULL,'2MASX J14441322+2745478',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.37',0.14,NULL,NULL,NULL,NULL,NULL,1,221.055083,27.76344,0.04,NULL,60027495646,937929619,14655150,18.37),(123578,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123578,36.43,0.27,194,55458,70,NULL,NULL,'SDSS J144413.57+152308.5',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',NULL,NULL,'15.6g',0.42,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.056583,15.38572,0.013,NULL,59555410531,930553289,14539895,15.6),(123579,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123579,38.49,0.27,499,55459,70,NULL,NULL,'2MASX J14441368+1759485',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,221.0569583,17.99692,0.091,NULL,59585200913,931018764,14547168,17.9),(123580,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123580,35.79,0.2,144,55460,74.4,NULL,NULL,'IC 1052',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.00003,NULL,'15.33',0.3,'SBcd?',NULL,NULL,NULL,NULL,1,221.058791667,20.614,0.034,NULL,59504316174,929754940,14527420,15.33),(123581,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123581,36.88,0.23,237,55461,70,NULL,NULL,'2MASX J14441461+1024401',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000204,NULL,'15.7g',0.42,NULL,NULL,NULL,NULL,NULL,1,221.060958333,10.41122,0.041,NULL,59374246635,927722603,14495665,15.7),(123582,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123582,34.97,0.2,98.6,55462,74.4,NULL,NULL,'CGCG 134-026',NULL,'2013AJ....146...86T',2013,1,1.14,NULL,'G',0.000112,NULL,'15.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,221.0615,22.74772,0.054,NULL,59506428450,929787944,14527936,15.4),(123583,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123583,37.5,0.46,316,55463,70,NULL,NULL,'2MASX J14441561+0234288',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000071,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,221.065,2.57475,0.101,NULL,58263771167,910371424,14224553,17.8),(123584,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123584,36.47,0.46,197,55464,70,NULL,NULL,'2MASX J14441656+5706179',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000183,NULL,'16.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,221.069,57.10492,0,NULL,57250156939,894533702,13977089,16.5),(123585,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123585,37.82,0.27,366,55465,70,NULL,NULL,'2MASX J14441733+2221301',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,221.0722083,22.3585,0.061,NULL,59506367057,929786985,14527921,17.7),(123586,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123586,37.86,0.46,373,55466,70,NULL,NULL,'2MASX J14441757+4609214',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,221.0732083,46.15619,0,NULL,59990778041,937355906,14646186,18.2),(123587,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123587,37.79,0.46,362,55467,70,NULL,NULL,'SDSS J144418.79+093710.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.078333,9.61964,0.029,NULL,59371051813,927672684,14494885,18),(123588,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123588,37.63,0.46,335,55468,70,NULL,NULL,'2MASX J14441936+0330488',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000089,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,221.08075,3.51367,0.061,NULL,58256099209,910251550,14222680,17.1),(123589,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123589,36.66,0.46,215,55469,70,NULL,NULL,'2MASX J14441956+1101381',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000214,NULL,'16.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,221.0814583,11.02711,0,NULL,59372202885,927690670,14495166,16.1),(123590,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123590,36.7,0.46,219,55470,70,NULL,NULL,'2MASX J14442003+2257554',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,221.083583,22.96553,0.05,NULL,59507871887,929810498,14528289,16.8),(123591,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123591,37.65,0.46,339,55471,70,NULL,NULL,'SDSS J144422.06+313945.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000139,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,221.091917,31.66253,0,NULL,60088027600,938875431,14669928,18.6),(123592,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123592,36.62,0.46,211,55472,70,NULL,NULL,'2MASX J14442273+0905461',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000158,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,221.09475,9.096,0.037,NULL,59363514437,927554913,14493045,16.6),(123593,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123593,37.82,0.27,366,55473,70,NULL,NULL,'2MASX J14442297+2223324',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000157,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,221.095833,22.39228,0.061,NULL,59506336796,929786512,14527914,17),(123594,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123594,37.57,0.33,327,55474,70,NULL,NULL,'2MASX J14442405+0443288',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000084,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,221.10025,4.72461,0.089,NULL,58255355222,910239925,14222498,18),(123595,'IRAS','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123595,31.97,0.8,24.8,55475,75,NULL,'A82, H','NGC 5740',NULL,'1997ApJS..109..333W',1997,1,2.55,'The APM position is northwest of the nucleus.','G',0.000018,NULL,'12.8g',0.94,'SAB(rs)b       NLAGN','Pair member (points to parent)',NULL,NULL,NULL,1,221.101875,1.67978,0.133,NULL,58263346268,910364785,14224449,12.8),(123596,'IRAS','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123596,32.07,0.8,25.9,55475,75,NULL,'CF, r','NGC 5740',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123597,'Sosies','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123597,32.42,0.17,30.5,55475,NULL,NULL,NULL,'NGC 5740',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123598,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123598,32.02,NULL,25.4,55475,NULL,NULL,'B','NGC 5740',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123599,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123599,32.13,0.4,26.6,55475,75,NULL,'B','NGC 5740',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123600,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123600,32.15,0.47,27,55475,75,NULL,'A82, H, raw','NGC 5740',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123601,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123601,32.26,0.4,28.4,55475,NULL,NULL,'mean','NGC 5740',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123602,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123602,32.27,0.38,28.4,55475,NULL,NULL,NULL,'NGC 5740',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123603,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123603,32.27,0.47,28.5,55475,75,NULL,'A82, H, inv','NGC 5740',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123604,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123604,32.31,0.47,29,55475,75,NULL,'A82, H, cor','NGC 5740',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123605,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123605,32.31,NULL,29,55475,72,NULL,NULL,'NGC 5740',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123606,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123606,32.41,0.47,30.3,55475,NULL,NULL,'H','NGC 5740',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123607,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123607,32.46,0.45,31,55475,NULL,NULL,'K','NGC 5740',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123608,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123608,32.46,0.46,31.1,55475,NULL,NULL,'J','NGC 5740',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123609,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123609,32.49,0.38,31.5,55475,75,NULL,'CF, r, raw','NGC 5740',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123610,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123610,32.53,0.38,32,55475,75,NULL,'CF, r, cor','NGC 5740',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123611,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123611,32.62,0.38,33.4,55475,75,NULL,'CF, r, inv','NGC 5740',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123612,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123612,37.09,0.46,262,55476,70,NULL,NULL,'SDSS J144425.58+193701.4',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.106583,19.61706,0.068,NULL,59530361422,930161897,14533779,17.1),(123613,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123613,38.17,0.46,430,55477,70,NULL,NULL,'SDSS J144426.09+114554.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,221.1087083,11.76522,0.025,NULL,59367349403,927614834,14493981,18.4),(123614,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123614,36.65,0.46,214,55478,70,NULL,NULL,'2MASX J14442672+5604219',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000167,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,221.1114583,56.07283,0.013,NULL,57245257208,894457143,13975892,16.2),(123615,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123615,36.43,0.27,194,55479,70,NULL,NULL,'CGCG 105-014',NULL,'2015arXiv151105856S',2015,1,0.6,'This may possibly be IC 4494, but that is more likely CGCG 105-013.','G',0.00019,NULL,'15.5',0.6,NULL,'Group member',NULL,NULL,NULL,1,221.1125,15.48092,0.005,NULL,59555400138,930553127,14539892,15.5),(123616,'Tully est','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123616,32.44,0.8,30.7,55480,75,NULL,NULL,'ESO 222- G 015',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.00002,NULL,'14.2',0.7,'Scd?;s.p.br.* on blg',NULL,NULL,NULL,NULL,1,221.113375,-49.39978,NULL,NULL,47053432893,735209888,11487654,14.2),(123617,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123617,37.35,0.46,295,55481,70,NULL,NULL,'2MASX J14442896-0258338',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000167,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,221.120583,-2.97628,0.205,NULL,43499603137,679681299,10620020,17),(123618,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123618,36.2,0.46,174,55482,70,NULL,NULL,'2MASX J14442906+5624319',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000171,NULL,'16.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,221.1212917,56.40897,0.017,NULL,57245003273,894453176,13975830,16.3),(123619,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123619,37.64,0.46,337,55483,70,NULL,NULL,'2MASX J14442926+1324424',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,221.122,13.41189,0,NULL,59557477613,930585587,14540399,18),(123620,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123620,36.85,0.46,235,55484,70,NULL,NULL,'2MASX J14443008+3607166',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,221.125375,36.12131,0,NULL,60068633306,938572395,14665193,17.7),(123621,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123621,36.25,0.46,178,55485,70,NULL,NULL,'2MASX J14443128+1928115',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000073,NULL,'16.19',0.33,NULL,NULL,NULL,NULL,NULL,1,221.130583,19.46978,0.066,NULL,59530616007,930165875,14533841,16.19),(123622,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123622,37.89,0.46,378,55486,70,NULL,NULL,'2MASX J14443205+1225454',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,221.1335,12.42939,0.009,NULL,59548874090,930451157,14538299,18.2),(123623,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123623,36.6,0.46,209,55487,70,NULL,NULL,'2MASX J14443251+0335098',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000066,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,221.1354583,3.58606,0.069,NULL,58257997056,910281204,14223143,16.7),(123624,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123624,36.84,0.46,233,55488,70,NULL,NULL,'2MASX J14443332+2027035',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.92',0.24,NULL,NULL,NULL,NULL,NULL,1,221.138833,20.45094,0.059,NULL,59504115169,929751799,14527371,16.92),(123625,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123625,38.51,0.46,504,55489,70,NULL,NULL,'2MASX J14443514+2619465',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,221.146583,26.32964,0.058,NULL,60014852160,937732065,14652063,17.7),(123626,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123626,36.85,0.46,234,55490,70,NULL,NULL,'2MASX J14443524+2115565',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.15',0.18,NULL,NULL,NULL,NULL,NULL,1,221.146833,21.26589,0.043,NULL,59502244833,929722575,14526915,18.15),(123627,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123627,37.19,0.46,274,55491,70,NULL,NULL,'SDSS J144435.43+223535.1',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.8g',0.26,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.147666667,22.59311,0.061,NULL,59506483646,929788806,14527950,16.8),(123628,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123628,37.52,0.46,320,55492,70,NULL,NULL,'2MASX J14443838+0420048',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000087,NULL,'17.0g',0.31,NULL,NULL,NULL,NULL,NULL,1,221.159833,4.33469,0.081,NULL,58258676153,910291814,14223309,17),(123629,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123629,37.63,0.46,335,55493,70,NULL,NULL,'2MASX J14443870+3022113',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000191,NULL,'18.45',0.13,NULL,NULL,NULL,NULL,NULL,1,221.161208333,30.36978,0,NULL,60018676196,937791815,14652997,18.45),(123630,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123630,37.68,0.46,343,55494,70,NULL,NULL,'2MASX J14443888+3725049',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000161,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,221.1619583,37.418,0,NULL,60075446888,938678857,14666857,17.2),(123631,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123631,36.77,0.46,226,55495,70,NULL,NULL,'2MASX J14444027+2419516',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000182,NULL,'16.0g',0.36,NULL,NULL,NULL,NULL,NULL,1,221.167917,24.33106,0.094,NULL,59493460790,929585324,14524770,16),(123632,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123632,38.57,0.46,519,55496,70,NULL,NULL,'SDSS J144441.51+192704.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.173,19.45117,0.068,NULL,59530668320,930166692,14533854,18.4),(123633,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123633,35.86,0.46,149,55497,70,NULL,NULL,'LCRS B144208.2-023644',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000154,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,221.183333,-2.82294,0.205,NULL,43499638371,679681849,10620028,16.8),(123634,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123634,37.06,0.46,258,55498,70,NULL,NULL,'SDSS J144447.32+013723.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000093,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,221.197167,1.62328,0.133,NULL,58266759266,910418113,14225283,17.8),(123635,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123635,37.57,0.33,327,55499,70,NULL,NULL,'2MASX J14444761+0446038',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000093,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,221.198417,4.76772,0.093,NULL,58255394576,910240540,14222508,17),(123636,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123636,37.57,0.46,326,55500,70,NULL,NULL,'2MASX J14444929+2930266',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00017,NULL,'16.9g',0.24,'S0',NULL,NULL,NULL,NULL,1,221.205458333,29.50731,0,NULL,60019431674,937803619,14653181,16.9),(123637,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123637,34.2,0.54,69.3,55501,70,NULL,NULL,'ESO 222- G 016',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000087,NULL,'14.8b',0.6,'(R)SAB0^+',NULL,NULL,NULL,NULL,1,221.2064583,-48.35994,0.925,NULL,47055183440,735237241,11488081,14.8),(123638,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123638,37.5,0.46,316,55502,70,NULL,NULL,'2MASX J14445020+4433344',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000138,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,221.209041667,44.55972,0.021,NULL,59955555205,936805550,14637586,17.8),(123639,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123639,38.28,0.33,452,55503,70,NULL,NULL,'SDSS J144450.55+333520.0',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00018,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,221.210625,33.58889,0,NULL,60121970586,939405790,14678215,18),(123640,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123640,38.28,0.33,452,55504,70,NULL,NULL,'SDSS J144451.09+333639.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,221.212917,33.61103,0,NULL,60121969888,939405779,14678215,18.1),(123641,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123641,37.8,0.46,362,55505,70,NULL,NULL,'2MASX J14445110+2358466',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.213125,23.97981,0.101,NULL,59507441747,929803777,14528184,17.9),(123642,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123642,37.19,0.46,274,55506,70,NULL,NULL,'2MASX J14445130+5723339',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000156,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,221.213625,57.39278,0,NULL,57723317473,901926835,14092606,18.2),(123643,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123643,36.65,0.46,213,55507,70,NULL,NULL,'2MASX J14445221+2448336',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,221.217625,24.80944,0.109,NULL,59493253237,929582081,14524720,16.6),(123644,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123644,38.26,0.33,449,55508,70,NULL,NULL,'SDSS J144454.18+461332.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00015,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,221.225833,46.22564,0.005,NULL,59990785807,937356028,14646187,18.5),(123645,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123645,37.48,0.46,313,55509,70,NULL,NULL,'2MASX J14445466+0625292',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000181,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,221.22775,6.42478,0.101,NULL,59379018608,927797165,14496830,16.8),(123646,'IRAS','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123646,32.16,0.8,27.1,55510,75,NULL,'A82, H','NGC 5746',NULL,'1997ApJS..109..333W',1997,1,7.4,NULL,'G',0.000033,NULL,'11.29',1.3,'SAB(rs)b? sp','Pair member (points to parent)',NULL,NULL,NULL,1,221.233,1.955,0.117,NULL,58266897460,910420272,14225316,11.29),(123647,'Tully est','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123647,32.34,0.8,29.4,55510,75,NULL,'B','NGC 5746',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123648,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123648,31.96,0.35,24.7,55510,NULL,NULL,NULL,'NGC 5746',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123649,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123649,32.12,0.32,26.5,55510,NULL,NULL,'Malmquist cor.','NGC 5746',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123650,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123650,32.31,0.3,29,55510,NULL,NULL,NULL,'NGC 5746',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123651,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123651,32.31,NULL,29,55510,72,NULL,NULL,'NGC 5746',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123652,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123652,32.33,0.2,29.2,55510,74.4,NULL,NULL,'NGC 5746',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123653,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123653,32.38,0.47,29.9,55510,75,NULL,'A82, H, raw','NGC 5746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123654,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123654,32.47,0.47,31.1,55510,75,NULL,'A82, H, cor','NGC 5746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123655,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123655,32.49,0.43,31.5,55510,75,NULL,'3.6 micron, color corrected','NGC 5746',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123656,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123656,32.69,0.47,34.6,55510,75,NULL,'A82, H, inv','NGC 5746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123657,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123657,32.7,0.43,34.7,55510,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5746',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123658,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123658,36.76,0.46,225,55511,70,NULL,NULL,'2MASX J14445625-0128487',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00014,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,221.234333,-1.48028,0.153,NULL,43501491683,679710807,10620481,17.3),(123659,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123659,36.23,0.68,176,55512,70,NULL,NULL,'2MASX J14445626-1547103',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.40',NULL,NULL,NULL,NULL,NULL,NULL,1,221.2345,-15.78625,0.357,NULL,46679892408,729373318,11396458,16.4),(123660,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123660,37.98,0.46,395,55513,70,NULL,NULL,'2MASX J14445671+2721086',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.42',0.13,NULL,NULL,NULL,NULL,NULL,1,221.236208333,27.35242,0.044,NULL,60027343547,937927242,14655113,18.42),(123661,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123661,38.09,0.46,415,55514,70,NULL,NULL,'2MASX J14445724+1932533',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00008,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,221.2385417,19.54811,0.068,NULL,59530617368,930165896,14533842,17),(123662,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123662,37.63,0.46,336,55515,70,NULL,NULL,'2MASX J14445796+2740452',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.40',0.14,NULL,NULL,NULL,NULL,NULL,1,221.241375,27.67925,0.04,NULL,60027531137,937930174,14655158,18.4),(123663,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123663,34.49,0.49,79.2,55516,75,NULL,'IR','UGC 09502',NULL,'2011yCatp016004901K',2011,1,1.14,NULL,'G',0.000088,NULL,'16.3g',0.17,'Scd',NULL,NULL,NULL,NULL,1,221.247167,40.87572,0.012,NULL,59951639918,936744373,14636630,16.3),(123664,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123664,36.68,0.46,217,55517,70,NULL,NULL,'2MASX J14445950+0928152',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000199,NULL,'15.6g',0.51,NULL,NULL,NULL,NULL,NULL,1,221.247917,9.47097,0.029,NULL,59371148992,927674203,14494909,15.6),(123665,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123665,35.01,0.46,100,55518,70,NULL,NULL,'IC 4498',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00016,NULL,'15.25',0.5,'S0?',NULL,NULL,NULL,NULL,1,221.253291667,26.30114,0.067,NULL,60014840163,937731877,14652060,15.25),(123666,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123666,37.97,0.46,393,55519,70,NULL,NULL,'2MASX J14450188+2215183',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,221.2579583,22.25525,0.052,NULL,59506261857,929785341,14527895,18),(123667,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123667,37.48,0.46,313,55520,70,NULL,NULL,'2MASX J14450324+1024281',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000192,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,221.263416667,10.40781,0.029,NULL,59374265687,927722901,14495670,17.2),(123668,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123668,36.99,0.46,250,55521,70,NULL,NULL,'2MASX J14450359+0635471',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000181,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,221.2647917,6.59661,0.093,NULL,59378935853,927795872,14496810,16.7),(123669,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123669,36.43,0.64,193,55522,70,NULL,NULL,'2MASX J14450376-3616047',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,221.265667,-36.26808,0.237,NULL,47221767108,737840111,11528751,14.5),(123670,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123670,35.14,0.2,107,55523,74.4,NULL,NULL,'SDSS J144503.96+163211.4',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000012,NULL,'16.94',0.2,NULL,NULL,NULL,NULL,NULL,1,221.266541667,16.53653,0.005,NULL,59553210259,930518910,14539357,16.94),(123671,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123671,37.14,0.46,267,55524,70,NULL,NULL,'2MASX J14450492+5648180',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00018,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,221.270667,56.80508,0.025,NULL,57244968314,894452629,13975822,17.1),(123672,'BL Lac Luminosity','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123672,41.11,NULL,1670,55525,70,NULL,'nucleus-to-host flux ratio, z > 0.51','WISE J144506.24-032612.5',NULL,'2006AJ....132....1S',2006,1,NULL,NULL,'QSO',NULL,NULL,'17.2',NULL,'BLLAC',NULL,NULL,NULL,'BL Lac',1,221.27625,-3.43678,0.249,NULL,43498101012,679657828,10619653,17.2),(123673,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123673,37.5,0.46,317,55526,70,NULL,NULL,'2MASX J14450644+5559380',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000205,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,221.276875,55.994,0.005,NULL,57245262732,894457230,13975894,16.5),(123674,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123674,35.55,0.46,129,55527,70,NULL,NULL,'ARK 458',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000203,NULL,'15.3',0.25,NULL,NULL,NULL,NULL,NULL,1,221.283791667,19.43161,0.074,NULL,59530671554,930166743,14533855,15.3),(123675,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123675,37.34,0.46,294,55528,70,NULL,NULL,'2MASX J14450843-0203376',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,221.2850417,-2.06053,0.125,NULL,43502656619,679729009,10620765,17.7),(123676,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123676,35.2,0.46,109,55529,70,NULL,NULL,'CGCG 076-016',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000077,NULL,'14.9g',0.62,NULL,NULL,NULL,NULL,NULL,1,221.290667,9.27467,0.029,NULL,59371011325,927672051,14494875,14.9),(123677,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123677,37.05,0.23,257,55530,70,NULL,NULL,'2MASX J14451057+0351386',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,221.294125,3.86069,0.109,NULL,58258799200,910293737,14223339,16.6),(123678,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123678,37.05,0.23,257,55531,70,NULL,NULL,'2MASX J14451057+0350456',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000097,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.294167,3.84589,0.109,NULL,58258786198,910293534,14223336,17.2),(123679,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123679,39.36,0.46,746,55532,70,NULL,NULL,'2MASX J14451117+5605290',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,221.296667,56.09153,0.005,NULL,57245742904,894464732,13976011,18.5),(123680,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123680,37.25,0.46,282,55533,70,NULL,NULL,'2MASX J14451471+2204293',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,221.311167,22.07481,0.052,NULL,59506239597,929784993,14527890,16.6),(123681,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123681,35.24,0.46,112,55534,70,NULL,NULL,'CGCG 048-014',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000091,NULL,'15.5g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,221.318125,3.404,0.085,NULL,58257875481,910279304,14223114,15.5),(123682,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123682,36.5,0.84,200,55535,70,NULL,NULL,'2MASX J14451652-3808255',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.7I',0.2,NULL,NULL,NULL,NULL,NULL,1,221.3189583,-38.14036,0.329,NULL,47216640944,737760014,11527500,14.7),(123683,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123683,37.84,0.46,370,55536,70,NULL,NULL,'2MASX J14451692+0345466',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000083,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,221.320375,3.76283,0.073,NULL,58257931374,910280177,14223127,17.4),(123684,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123684,37.72,0.46,350,55537,70,NULL,NULL,'SDSS J144518.42+271733.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.3267917,27.29267,0.058,NULL,60027317515,937926836,14655106,18.1),(123685,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123685,37.1,0.33,263,55538,70,NULL,NULL,'2MASX J14451856+3216328',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000188,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,221.327125,32.27575,0,NULL,60088485172,938882580,14670040,16.8),(123686,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123686,38.01,0.46,400,55539,70,NULL,NULL,'2MASX J14451940+4705118',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,221.3310417,47.08675,0.021,NULL,59987673430,937307397,14645428,17.5),(123687,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123687,37.05,0.23,257,55540,70,NULL,NULL,'2MASX J14451946+0349406',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,221.331208333,3.82792,0.109,NULL,58258790509,910293601,14223337,16.7),(123688,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123688,37.8,0.33,364,55541,70,NULL,NULL,'2MASX J14451994+3204019',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00019,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,221.333208333,32.06708,0,NULL,60088625007,938884765,14670074,17.2),(123689,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123689,35.15,0.46,107,55542,70,NULL,NULL,'2MASX J14452050+3637566',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000179,NULL,'15.3g',0.4,'S0/a',NULL,NULL,NULL,NULL,1,221.335291667,36.63256,0,NULL,60075199465,938674991,14666796,15.3),(123690,'GRB','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123690,43.9,0.23,3270,55543,NULL,NULL,NULL,'GRB 060814',0.84,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,221.338708333,20.58631,0.06,NULL,59504124395,929751943,14527374,NULL),(123691,'Tully est','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123691,32.27,0.8,28.4,55544,75,NULL,NULL,'UGC 09500',NULL,'1988NBGC.C....0000T',1988,1,2.8,NULL,'G',0.000013,NULL,'15.12',2.8,'Sm:',NULL,NULL,NULL,NULL,1,221.339583,7.86278,0.057,NULL,59365703829,927589122,14493580,15.12),(123692,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123692,31.41,NULL,19.1,55544,72,NULL,NULL,'UGC 09500',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123693,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123693,37.02,0.46,254,55545,70,NULL,NULL,'2MASX J14452270+1400198',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.50',0.16,NULL,NULL,NULL,NULL,NULL,1,221.344625,14.0055,0.013,NULL,59558386107,930599782,14540621,18.5),(123694,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123694,37.36,0.46,296,55546,70,NULL,NULL,'2MASX J14452286+1208288',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000187,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,221.345375,12.14125,0.029,NULL,59367407944,927615749,14493996,16.3),(123695,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123695,37.47,0.46,312,55547,70,NULL,NULL,'LCRS B144248.4-023436',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00017,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.3504583,-2.78664,0.193,NULL,43499418782,679678418,10619975,17.7),(123696,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123696,37.8,0.33,364,55548,70,NULL,NULL,'2MASX J14452475+3159179',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,221.35325,31.98831,0,NULL,60088406526,938881351,14670021,17.4),(123697,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123697,38.02,0.46,402,55549,70,NULL,NULL,'2MASX J14452572+0951121',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,221.357166667,9.85333,0.025,NULL,59371219429,927675303,14494926,17.7),(123698,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123698,36.94,0.46,244,55550,70,NULL,NULL,'2MASX J14452607+4605428',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,221.358833,46.09517,0,NULL,59990805899,937356342,14646192,17),(123699,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123699,37.72,0.46,350,55551,70,NULL,NULL,'2MASX J14452733+0932181',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,221.364083,9.53842,0.029,NULL,59371096951,927673389,14494896,17.2),(123700,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123700,38.12,0.33,421,55552,70,NULL,NULL,'2MASX J14452757+1639178',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.74',0.13,NULL,NULL,NULL,NULL,NULL,1,221.36475,16.655,0,NULL,59553200021,930518750,14539355,18.74),(123701,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123701,38.14,0.46,425,55553,70,NULL,NULL,'2MASX J14452756+2922231',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000176,NULL,'16.9g',0.32,'S0',NULL,NULL,NULL,NULL,1,221.364917,29.37322,0,NULL,60019268227,937801066,14653141,16.9),(123702,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123702,38.12,0.33,421,55554,70,NULL,NULL,'2MASX J14452806+1638439',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.63',0.15,NULL,NULL,NULL,NULL,NULL,1,221.367125,16.64547,0,NULL,59553200108,930518751,14539355,18.63),(123703,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123703,37.25,0.46,282,55555,70,NULL,NULL,'2MASX J14452843+5107159',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,221.368417,51.12108,0.061,NULL,59203652580,925057071,14454016,17.7),(123704,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123704,37.65,0.46,338,55556,70,NULL,NULL,'2MASX J14452855+2752181',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.01',0.18,NULL,NULL,NULL,NULL,NULL,1,221.3690417,27.87164,0.042,NULL,60027517985,937929968,14655155,18.01),(123705,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123705,37.05,0.23,257,55557,70,NULL,NULL,'2MASX J14452991+0355262',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000124,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,221.374667,3.92406,0.109,NULL,58258815276,910293988,14223343,16.3),(123706,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123706,38.27,0.46,451,55558,70,NULL,NULL,'2MASX J14453000+6124514',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,221.374667,61.41425,0.029,NULL,57778652542,902791445,14106116,17.8),(123707,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123707,37.47,0.33,312,55559,70,NULL,NULL,'2MASX J14453040+2244540',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000175,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,221.376625,22.7485,0.051,NULL,59506473331,929788645,14527947,16.5),(123708,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123708,35.94,0.46,154,55560,70,NULL,NULL,'2MASX J14453167+0756440',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,221.381833,7.94564,0.057,NULL,59365677300,927588707,14493573,16.3),(123709,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123709,36.95,0.46,245,55561,70,NULL,NULL,'2MASX J14453203+4346043',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00015,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,221.383458333,43.76792,0.029,NULL,59957606688,936837604,14638087,17.1),(123710,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123710,37.78,0.46,360,55562,70,NULL,NULL,'SDSS J144532.67+180821.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.386167,18.13936,0.063,NULL,59585252856,931019575,14547180,18.1),(123711,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123711,36.49,0.46,199,55563,70,NULL,NULL,'2MASX J14453370-0205165',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000113,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,221.390458333,-2.08792,0.169,NULL,43502657663,679729025,10620766,16.7),(123712,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123712,37.3,0.33,289,55564,70,NULL,NULL,'2MASX J14453380+0202232',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000084,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,221.390667,2.03967,0.077,NULL,58266916599,910420571,14225321,17.7),(123713,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123713,37.1,0.33,263,55565,70,NULL,NULL,'2MASX J14453433+3219419',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.392958333,32.3285,0,NULL,60088207493,938878242,14669972,17.4),(123714,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123714,37.63,0.33,335,55566,70,NULL,NULL,'2MASX J14453438+3734207',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000177,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,221.393375,37.57239,0,NULL,60075417514,938678398,14666849,16.9),(123715,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123715,37.63,0.33,335,55567,70,NULL,NULL,'2MASX J14453446+3734547',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.38',0.12,NULL,NULL,NULL,NULL,NULL,1,221.3937083,37.58186,0,NULL,60075417555,938678399,14666849,18.38),(123716,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123716,37.3,0.33,289,55568,70,NULL,NULL,'2MASX J14453587+0203472',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000102,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,221.399375,2.06317,0.077,NULL,58266915272,910420551,14225321,16.7),(123717,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123717,37.59,0.46,329,55569,70,NULL,NULL,'2MASX J14453680+3418389',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000166,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,221.403458333,34.31092,0,NULL,60124583260,939446613,14678853,16.6),(123718,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123718,32.79,0.47,36.2,55570,70,NULL,NULL,'NGC 5742',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000073,NULL,'13.84',0.5,'SB(r)0^0^?',NULL,NULL,NULL,NULL,1,221.403667,-11.80964,0.293,NULL,46463285016,725988828,11343575,13.84),(123719,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123719,37.54,0.46,323,55571,70,NULL,NULL,'2MASX J14453711+2718340',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.40',0.15,NULL,NULL,NULL,NULL,NULL,1,221.404625,27.30953,0.058,NULL,60027365414,937927584,14655118,18.4),(123720,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123720,38.63,0.46,533,55572,70,NULL,NULL,'SDSS J144537.14+274304.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.4047917,27.71786,0.057,NULL,60027557172,937930580,14655165,18.5),(123721,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123721,38.62,0.46,531,55573,70,NULL,NULL,'2MASX J14453794+5013189',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,221.40825,50.22194,0.045,NULL,59934591949,936477999,14632468,18),(123722,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123722,38.04,0.46,406,55574,70,NULL,NULL,'2MASX J14453814+5151499',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,221.4092083,51.86375,0.037,NULL,59192289066,924879516,14451242,17.3),(123723,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123723,36.75,0.46,224,55575,70,NULL,NULL,'2MASX J14453940+1801180',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.90',0.2,NULL,NULL,NULL,NULL,NULL,1,221.414083,18.02178,0.063,NULL,59585226028,931019156,14547174,17.9),(123724,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123724,37.06,0.46,258,55576,70,NULL,NULL,'2MASX J14454014+5612380',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000177,NULL,'16.4g',0.38,'BrClG          AGN',NULL,NULL,NULL,NULL,1,221.417458333,56.21067,0.013,NULL,57245955926,894468061,13976063,16.4),(123725,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123725,37.61,0.33,332,55577,70,NULL,NULL,'2MASX J14454185+1244110',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,221.4244583,12.7365,0.013,NULL,59549499617,930460931,14538452,18.2),(123726,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123726,37.54,0.46,322,55578,70,NULL,NULL,'2MASX J14454257+5544500',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000179,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,221.427416667,55.74722,0.005,NULL,57247147590,894486681,13976354,16.9),(123727,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123727,37.08,0.46,260,55579,70,NULL,NULL,'2MASX J14454285-0224405',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,221.4285417,-2.41119,0.177,NULL,43502992151,679734252,10620847,17.4),(123728,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123728,36.28,0.46,181,55580,70,NULL,NULL,'2MASX J14454284+3628028',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000154,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,221.4287083,36.46753,0,NULL,60067788805,938559200,14664987,16.5),(123729,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123729,33.52,NULL,50.6,55581,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 580- G 019',NULL,'2010Ap&SS.325..163P',2010,1,0.95,NULL,'G',NULL,'?','17.28',0.1,'Sd',NULL,NULL,NULL,NULL,1,221.43,-22.45806,0.353,NULL,46538912209,727170503,11362039,17.28),(123730,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123730,33.55,NULL,51.3,55581,NULL,NULL,'Dipole + Quadrupole','ESO 580- G 019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123731,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123731,33.58,NULL,52,55581,NULL,NULL,'Dipole','ESO 580- G 019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123732,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123732,33.63,NULL,53.3,55581,NULL,NULL,NULL,'ESO 580- G 019',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123733,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123733,37.54,0.46,322,55582,70,NULL,NULL,'SDSS J144544.29+272028.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.434583,27.34128,0.058,NULL,60027366108,937927595,14655118,18.2),(123734,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123734,37.96,0.46,391,55583,70,NULL,NULL,'2MASX J14454491+2433580',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.71',0.13,NULL,NULL,NULL,NULL,NULL,1,221.4370417,24.56622,0.086,NULL,59494067851,929594810,14524918,18.71),(123735,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123735,36.26,0.33,179,55584,70,NULL,NULL,'2MASX J14454512+1405580',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.79',0.14,'AGN',NULL,NULL,NULL,NULL,1,221.4379583,14.09964,0.009,NULL,59558391003,930599859,14540622,18.79),(123736,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123736,35.71,0.2,139,55585,74.4,NULL,NULL,'UGC 09510',NULL,'2013AJ....146...86T',2013,1,1.28,NULL,'G',0.000033,NULL,'15.2g',0.36,'Sbc',NULL,NULL,NULL,NULL,1,221.43875,32.63011,0,NULL,60088242879,938878794,14669981,15.2),(123737,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123737,37.61,0.33,332,55586,70,NULL,NULL,'2MASX J14454691+1256170',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,221.445583333,12.93808,0.009,NULL,59549535175,930461487,14538460,17.7),(123738,'Tully est','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123738,32.68,0.8,34.3,55587,75,NULL,NULL,'UGCA 393',NULL,'1988NBGC.C....0000T',1988,1,NULL,NULL,'GPair',0.000019,NULL,NULL,NULL,'Im',NULL,NULL,NULL,NULL,1,221.4475,-20.79722,0.353,NULL,46530012896,727031451,11359866,NULL),(123739,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123739,38.24,0.46,444,55588,70,NULL,NULL,'SDSS J144547.55+241014.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000171,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.448166667,24.17081,0.082,NULL,59493576486,929587132,14524798,18.4),(123740,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123740,37.47,0.33,312,55589,70,NULL,NULL,'2MASX J14455021+2246140',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000148,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.459333,22.77044,0.051,NULL,59506462480,929788476,14527944,17.4),(123741,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123741,36.26,0.33,179,55590,70,NULL,NULL,'2MASX J14455089+1405050',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.23',0.19,'AGN',NULL,NULL,NULL,NULL,1,221.462,14.08489,0.009,NULL,59558390086,930599845,14540622,17.23),(123742,'IRAS','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123742,32.61,0.8,33.3,55591,75,NULL,'MAT, I','ESO 022- G 003',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000021,NULL,'13.91',1.3,'SA(rs)c',NULL,NULL,NULL,NULL,1,221.462583333,-77.92489,0.429,NULL,44285645882,691963216,10811925,13.91),(123743,'Tully est','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123743,32.68,0.8,34.3,55591,75,NULL,NULL,'ESO 022- G 003',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123744,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123744,32.36,0.32,29.7,55591,85,NULL,'I, raw','ESO 022- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123745,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123745,32.36,0.32,29.7,55591,85,NULL,'I, inv','ESO 022- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123746,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123746,32.62,0.43,33.3,55591,75,NULL,'MAT, I, raw','ESO 022- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123747,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123747,32.66,0.43,34,55591,75,NULL,'MAT, I, inv','ESO 022- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123748,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123748,32.74,0.4,35.3,55591,NULL,NULL,NULL,'ESO 022- G 003',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123749,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123749,32.8,0.43,36.3,55591,75,NULL,'MAT, I, cor','ESO 022- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123750,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123750,35.32,0.58,116,55592,70,NULL,NULL,'LCRS B144308.3-114057',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.07',0.3,NULL,NULL,NULL,NULL,NULL,1,221.463375,-11.89217,0.293,NULL,46463386163,725990408,11343600,16.07),(123751,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123751,36.99,0.46,250,55593,70,NULL,NULL,'2MASX J14455222+3048542',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00018,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,221.4675417,30.815,0,NULL,60091273392,938926146,14670721,16.9),(123752,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123752,37.8,0.46,364,55594,70,NULL,NULL,'SDSS J144552.70+201516.6',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.0g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.469625,20.25464,0.068,NULL,59530287930,930160748,14533761,17),(123753,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123753,38.56,0.46,516,55595,70,NULL,NULL,'SDSS J144554.38+095057.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000177,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,221.476583,9.84919,0.025,NULL,59371211776,927675184,14494924,18.3),(123754,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123754,36.28,0.2,180,55596,74.4,NULL,NULL,'CGCG 164-021',NULL,'2013AJ....146...86T',2013,1,0.64,'HOLM 675B does not exist (it is probably a plate defect).','G',0.00005,NULL,'15.4g',0.28,'SBc            Sbrst',NULL,NULL,NULL,NULL,1,221.482917,28.52561,0.019,NULL,60027745649,937933525,14655211,15.4),(123755,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123755,38.04,0.46,406,55597,70,NULL,NULL,'2MASX J14455658+0729219',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,221.48575,7.48944,0.061,NULL,59362302887,927535982,14492749,17.1),(123756,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123756,37.46,0.46,310,55598,70,NULL,NULL,'2MASX J14455744+2425430',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,221.489375,24.42867,0.094,NULL,59493990860,929593607,14524900,17.8),(123757,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123757,37.92,0.46,384,55599,70,NULL,NULL,'2MASX J14455808+3012522',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000164,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,221.491916667,30.21467,0,NULL,60018817623,937794025,14653031,17),(123758,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123758,35.19,0.2,109,55600,74.4,NULL,NULL,'KUG 1443+110',NULL,'2013AJ....146...86T',2013,1,0.72,NULL,'G',0.000047,NULL,'16.0g',0.32,'Spiral',NULL,NULL,NULL,NULL,1,221.49225,10.81986,0.025,NULL,59371956591,927686821,14495106,16),(123759,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123759,38.11,0.46,418,55601,70,NULL,NULL,'2MASX J14460093+1549016',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,221.503833,15.81714,0.025,NULL,59553717959,930526843,14539481,18.5),(123760,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123760,36.52,0.46,201,55602,70,NULL,NULL,'2MASX J14460173+0303582',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000073,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,221.507,3.06608,0.085,NULL,58257310724,910270480,14222976,17.1),(123761,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123761,35.97,0.48,156,55603,70,NULL,NULL,'2MASX J14460201-1318108',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.95',0.4,NULL,NULL,NULL,NULL,NULL,1,221.5082917,-13.30319,0.301,NULL,46684094914,729438983,11397484,15.95),(123762,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123762,37.17,0.46,272,55604,70,NULL,NULL,'SDSS J144603.98-013203.4',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000046,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,221.516583,-1.53431,0.117,NULL,43502685062,679729454,10620772,18.4),(123763,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123763,31.69,0.43,21.8,55605,75,NULL,'3.6 micron, color + selection bias corrected','ESO 580- G 022',NULL,'2014MNRAS.444..527S',2014,1,2.2,NULL,'G',0.000017,NULL,'14.46',1.4,'SAB(s)m',NULL,NULL,NULL,NULL,1,221.5217917,-18.02211,0.337,NULL,46696075166,729626174,11400408,14.46),(123764,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123764,34.74,0.46,88.5,55606,70,NULL,NULL,'CGCG 076-020',NULL,'2015arXiv151105856S',2015,1,0.66,'GSC 0911-0106 (mag. 16) superposed 11 arcsec south of nucleus.','G',0.00011,NULL,'15.6',0.5,NULL,NULL,NULL,NULL,NULL,1,221.5219583,8.91561,0.061,NULL,59363969182,927562018,14493156,15.6),(123765,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123765,38.33,0.46,463,55607,70,NULL,NULL,'2MASX J14460776+3557012',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,221.53225,35.95053,0,NULL,60067852169,938560190,14665002,17.6),(123766,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123766,37.61,0.33,332,55608,70,NULL,NULL,'2MASX J14460937+2950589',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.538917,29.84972,0,NULL,60019368141,937802627,14653166,17.3),(123767,'Ring Diameter','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123767,31.5,0.76,20,55609,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5750',NULL,'1981ApJS...45..541P',1981,1,2.16,'The APM position is 6 arcsec northwest of the nucleus.','G',0.000033,NULL,'12.6g',1.08,'SB(r)0/a;HII?  NLAGN','Group member, radial-velocity confirmed',NULL,NULL,'Sy 2',1,221.546333333,-0.22294,0.105,NULL,43492929179,679577018,10618390,12.6),(123768,'Ring Diameter','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123768,31.5,0.6,20,55609,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5750',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123769,'Tully est','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123769,32.51,0.8,31.8,55609,75,NULL,'B','NGC 5750',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123770,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123770,32.55,0.45,32.4,55609,NULL,NULL,'Malmquist cor.','NGC 5750',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123771,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123771,32.55,NULL,32.4,55609,72,NULL,NULL,'NGC 5750',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123772,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123772,32.82,0.4,36.7,55609,NULL,NULL,NULL,'NGC 5750',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123773,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123773,32.86,0.2,37.3,55609,74.4,NULL,NULL,'NGC 5750',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123774,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123774,35.42,0.33,121,55610,70,NULL,NULL,'2MASX J14461185+3234583',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000172,NULL,'15.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,221.549458333,32.58286,0,NULL,60088234923,938878670,14669979,15.6),(123775,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123775,37.16,0.46,270,55611,70,NULL,NULL,'2MASX J14461220-0148519',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000158,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,221.5507917,-1.81456,0.153,NULL,43502712108,679729876,10620779,17.2),(123776,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123776,37.06,0.33,258,55612,70,NULL,NULL,'2MASX J14461229+1608056',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.08',0.2,NULL,NULL,NULL,NULL,NULL,1,221.551083,16.13486,0,NULL,59553861410,930529084,14539516,18.08),(123777,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123777,38.41,0.46,482,55613,70,NULL,NULL,'2MASX J14461236+1617526',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,221.551541667,16.29792,0.017,NULL,59553647613,930525743,14539464,NULL),(123778,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123778,37.99,0.46,396,55614,70,NULL,NULL,'2MASX J14461300+4314213',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,221.5542917,43.23925,0.029,NULL,59950341261,936724082,14636313,17.8),(123779,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123779,37.04,0.46,255,55615,70,NULL,NULL,'2MASX J14461319+1904078',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.88',0.2,NULL,NULL,NULL,NULL,NULL,1,221.555083,19.06881,0.091,NULL,59530739596,930167806,14533871,17.88),(123780,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123780,35.72,0.46,139,55616,70,NULL,NULL,'CGCG 164-022',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000176,NULL,'15.6g',0.49,NULL,NULL,NULL,NULL,NULL,1,221.557333,29.96914,0,NULL,60018841396,937794396,14653037,15.6),(123781,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123781,35.75,0.46,141,55617,70,NULL,NULL,'2MASX J14461380+1459056',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.24',0.16,NULL,NULL,NULL,NULL,NULL,1,221.5575,14.98481,0,NULL,59555958124,930561845,14540028,18.24),(123782,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123782,36.93,0.46,243,55618,70,NULL,NULL,'2MASX J14461395+2027488',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.56',0.14,NULL,NULL,NULL,NULL,NULL,1,221.558333,20.46367,0.075,NULL,59501973101,929718329,14526848,18.56),(123783,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123783,37.61,0.33,332,55619,70,NULL,NULL,'2MASX J14461413+2945099',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000177,NULL,'17.4g',0.22,'E',NULL,NULL,NULL,NULL,1,221.558833333,29.75269,0,NULL,60019372337,937802692,14653167,17.4),(123784,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123784,37.88,0.46,377,55620,70,NULL,NULL,'2MASX J14461454+5150321',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,221.560583,51.84231,0.045,NULL,59192327997,924880124,14451251,17.9),(123785,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123785,38.33,0.46,462,55621,70,NULL,NULL,'2MASX J14461564+1122095',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,221.5652917,11.36922,0.025,NULL,59367661716,927619714,14494058,17.8),(123786,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123786,37.98,0.46,395,55622,70,NULL,NULL,'2MASX J14461773+3417413',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000164,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,221.573916667,34.29494,0,NULL,60124810814,939450168,14678908,17),(123787,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123787,37.58,0.46,328,55623,70,NULL,NULL,'2MASX J14461797+1934429',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,221.574958333,19.57869,0.081,NULL,59530559557,930164993,14533828,17.4),(123788,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123788,38.53,0.46,509,55624,70,NULL,NULL,'2MASX J14461823+2815569',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,221.5760417,28.26578,0.058,NULL,60027657805,937932153,14655189,18),(123789,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123789,35.23,0.46,111,55625,70,NULL,NULL,'MCG +06-32-098',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000166,NULL,'15.4g',0.49,'E0',NULL,NULL,NULL,NULL,1,221.58125,35.62769,0,NULL,60067810226,938559534,14664992,15.4),(123790,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123790,38.48,0.46,496,55626,70,NULL,NULL,'2MASX J14461983+2147019',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,221.5827083,21.78381,0.042,NULL,59502417578,929725274,14526957,17.6),(123791,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123791,38.01,0.46,399,55627,70,NULL,NULL,'2MASX J14462005+2116579',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,221.583583,21.28269,0.041,NULL,59502462117,929725970,14526968,17.1),(123792,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123792,31.51,NULL,20,55628,72,NULL,NULL,'SDSS J144620.20+044358.4',NULL,'2014Ap.....57..457K',2014,1,0.35,NULL,'G',0.000058,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,221.584208333,4.73297,0.105,NULL,58255272295,910238629,14222478,17.8),(123793,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123793,36.85,0.46,234,55629,70,NULL,NULL,'2MASX J14462035+4305453',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000179,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,221.584833,43.09603,0.025,NULL,59950362689,936724417,14636319,16.5),(123794,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123794,38.42,0.46,483,55630,70,NULL,NULL,'2MASX J14462162+3025283',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,221.590125,30.42456,0,NULL,60089404363,938896943,14670264,17.9),(123795,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123795,35.42,0.33,121,55631,70,NULL,NULL,'UGC 09518',NULL,'2015arXiv151105856S',2015,1,1.27,NULL,'G',0.0001,NULL,'14.0g',0.82,'E',NULL,NULL,NULL,NULL,1,221.590625,32.78022,0,NULL,60121578925,939399670,14678119,14),(123796,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123796,35.48,0.4,125,55631,NULL,NULL,'mean','UGC 09518',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123797,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123797,35.9,0.45,151,55631,NULL,NULL,'K','UGC 09518',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123798,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123798,37.06,0.33,258,55632,70,NULL,NULL,'2MASX J14462284+1606136',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.44',0.15,NULL,NULL,NULL,NULL,NULL,1,221.595083,16.10383,0,NULL,59553872422,930529256,14539519,18.44),(123799,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123799,37.97,0.46,392,55633,70,NULL,NULL,'2MASX J14462377+3214153',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000046,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,221.598916667,32.23769,0,NULL,60088334553,938880227,14670003,17.4),(123800,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123800,37.95,0.46,390,55634,70,NULL,NULL,'2MASX J14462397+5543151',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000191,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,221.5997083,55.72086,0.005,NULL,57247871365,894497990,13976531,17.6),(123801,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123801,36.86,0.46,235,55635,70,NULL,NULL,'2MASX J14462397+6405191',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000334,NULL,'16.92',0.3,'AGN',NULL,NULL,NULL,NULL,1,221.599917,64.08875,0.021,NULL,57936690512,905260789,14144699,16.92),(123802,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123802,35.51,0.21,127,55636,70,NULL,NULL,'2MASX J14462449+1346076',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00009,NULL,'18.12',0.21,NULL,NULL,NULL,NULL,NULL,1,221.601958333,13.76894,0.017,NULL,59549163507,930455679,14538369,18.12),(123803,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123803,37.6,0.46,331,55637,70,NULL,NULL,'2MASX J14462467+4139517',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000182,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,221.602917,41.66428,0.014,NULL,59952532591,936758321,14636848,16.4),(123804,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123804,36.84,0.23,234,55638,70,NULL,NULL,'2MASX J14462547+2218135',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000189,NULL,'17.12',0.18,NULL,NULL,NULL,NULL,NULL,1,221.606167,22.30369,0.057,NULL,59506520072,929789376,14527959,17.12),(123805,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123805,37.61,0.46,332,55639,70,NULL,NULL,'2MASX J14462556+5446291',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,221.606625,54.77492,0,NULL,57246227336,894472302,13976129,17.8),(123806,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123806,36.63,0.46,212,55640,70,NULL,NULL,'2MASX J14462612+2351095',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000204,NULL,'15.6g',0.45,NULL,NULL,NULL,NULL,NULL,1,221.6087917,23.85278,0.075,NULL,59493377721,929584026,14524750,15.6),(123807,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123807,37.59,0.46,329,55641,70,NULL,NULL,'2MASX J14462615+0633584',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000177,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,221.609083,6.56642,0.101,NULL,59379760574,927808758,14497011,16.9),(123808,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123808,36.79,0.69,228,55642,70,NULL,NULL,'LCRS B144343.2-124115',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.58',0.3,NULL,NULL,NULL,NULL,NULL,1,221.6122083,-12.89681,0.281,NULL,46684696383,729448380,11397630,15.58),(123809,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123809,35.21,0.21,110,55643,70,NULL,NULL,'ARK 459',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.00007,NULL,'14.7g',0.5,'S0','Group member',NULL,NULL,NULL,1,221.615375,11.50736,0.025,NULL,59367656671,927619635,14494056,14.7),(123810,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123810,35.52,0.25,127,55643,74.4,NULL,NULL,'ARK 459',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123811,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123811,35.73,0.22,140,55643,70,NULL,NULL,'ARK 459',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123812,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123812,36.57,0.46,206,55644,70,NULL,NULL,'2MASX J14462885+2145205',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,221.6202083,21.75564,0.042,NULL,59502419449,929725303,14526957,17.5),(123813,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123813,37.36,0.46,297,55645,70,NULL,NULL,'2MASX J14463082+1855005',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.31',0.14,NULL,NULL,NULL,NULL,NULL,1,221.6284583,18.91683,0.078,NULL,59530680452,930166882,14533857,18.31),(123814,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123814,35.15,0.46,107,55646,70,NULL,NULL,'IC 1054',NULL,'2015arXiv151105856S',2015,1,1.05,NULL,'G',0.000073,NULL,'14.4g',0.75,'S0',NULL,NULL,NULL,NULL,1,221.630166667,1.27475,0.109,NULL,58264852955,910388327,14224817,14.4),(123815,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123815,38.1,0.46,417,55647,70,NULL,NULL,'SDSS J144632.29+034643.4',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000082,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,221.634541667,3.77875,0.093,NULL,58257575540,910274617,14223040,17.9),(123816,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123816,37.84,0.46,370,55648,70,NULL,NULL,'2MASX J14463321+4236383',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.32',0.2,NULL,NULL,NULL,NULL,NULL,1,221.63825,42.61064,0.033,NULL,59951171913,936737061,14636516,17.32),(123817,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123817,36.91,0.46,241,55649,70,NULL,NULL,'2MASX J14463324+0411006',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000077,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,221.638458333,4.18364,0.049,NULL,58258244224,910285066,14223204,17),(123818,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123818,35.48,0.33,124,55650,70,NULL,NULL,'IC 4505',NULL,'2015arXiv151105856S',2015,1,1.05,NULL,'G',0.000113,NULL,'14.4g',0.76,'S0-:',NULL,NULL,NULL,NULL,1,221.639041667,33.40861,0,NULL,60121488949,939398264,14678097,14.4),(123819,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123819,35.7,0.46,138,55651,70,NULL,NULL,'2MASX J14463441-0050578',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000083,NULL,'16.0g',0.28,'S0',NULL,NULL,NULL,NULL,1,221.6434583,-0.84956,0.125,NULL,43501620075,679712813,10620512,16),(123820,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123820,38,0.46,399,55652,70,NULL,NULL,'2MASX J14463485+0440246',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000085,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.645167,4.67342,0.105,NULL,58255227241,910237925,14222467,17.7),(123821,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123821,37.77,0.21,358,55653,70,NULL,NULL,'2MASX J14463558+1433440',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.47',0.15,NULL,NULL,NULL,NULL,NULL,1,221.648333,14.56214,0.013,NULL,59555655838,930557122,14539955,18.47),(123822,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123822,36.64,0.46,213,55654,70,NULL,NULL,'2MASX J14463563+1919445',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.72',0.21,NULL,NULL,NULL,NULL,NULL,1,221.648417,19.329,0.079,NULL,59530791304,930168614,14533884,17.72),(123823,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123823,37.77,0.46,359,55655,70,NULL,NULL,'2MASX J14463570+0958097',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000209,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,221.648625,9.96939,0.025,NULL,59371196182,927674940,14494920,16.8),(123824,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123824,35.91,0.23,152,55656,70,NULL,NULL,'2MASX J14463605+1055257',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000176,NULL,'15.7g',0.38,NULL,NULL,NULL,NULL,NULL,1,221.650083333,10.92378,0.029,NULL,59367500970,927617202,14494018,15.7),(123825,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123825,35.21,0.21,110,55657,70,NULL,NULL,'2MASX J14463661+1151087',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000163,NULL,'16.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,221.652625,11.85244,0.029,NULL,59368264895,927629138,14494205,16),(123826,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123826,38.49,0.46,499,55658,70,NULL,NULL,'SDSS J144636.81+293603.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000138,NULL,'18.6g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.653417,29.60092,0.022,NULL,60019350889,937802357,14653161,18.6),(123827,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123827,35.72,0.46,139,55659,70,NULL,NULL,'IC 4504',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000174,NULL,'15.2g',0.44,NULL,NULL,NULL,NULL,NULL,1,221.654083333,31.69919,0,NULL,60087941693,938874088,14669907,15.2),(123828,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123828,38.25,0.33,447,55660,70,NULL,NULL,'2MASX J14463778+0728107',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000168,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,221.6574583,7.46969,0.077,NULL,59379346922,927802295,14496910,17.2),(123829,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123829,36.89,0.46,239,55661,70,NULL,NULL,'2MASX J14463818+3409001',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000107,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,221.659,34.14989,0,NULL,60124795315,939449926,14678905,17.2),(123830,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123830,36.84,0.23,234,55662,70,NULL,NULL,'2MASX J14463828+2203574',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.97',0.18,NULL,NULL,NULL,NULL,NULL,1,221.659375,22.06606,0.046,NULL,59505786023,929777906,14527779,17.97),(123831,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123831,35.51,0.21,127,55663,70,NULL,NULL,'CGCG 076-031',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000087,NULL,'14.13',0.35,'E','Group member',NULL,NULL,NULL,1,221.662917,13.67628,0.017,NULL,59549220558,930456571,14538383,14.13),(123832,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123832,36.02,0.58,160,55664,70,NULL,NULL,'2MASX J14463914-3817172',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,221.6630417,-38.28819,0.285,NULL,47216702814,737760981,11527515,15),(123833,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123833,37.5,0.46,316,55665,70,NULL,NULL,'2MASXi J1446396+461937',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000165,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,221.66525,46.32708,0.005,NULL,59991106086,937361032,14646266,17.9),(123834,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123834,37.7,0.33,346,55666,70,NULL,NULL,'2MASX J14463984+5531490',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000187,NULL,'16.2g',0.36,'BrClG',NULL,NULL,NULL,NULL,1,221.666167,55.53042,0,NULL,57248027118,894500423,13976569,16.2),(123835,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123835,35.48,0.33,124,55667,70,NULL,NULL,'IC 4506',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.0001,NULL,'15.5g',0.49,NULL,NULL,NULL,NULL,NULL,1,221.666416667,33.40122,0,NULL,60121541010,939399078,14678110,15.5),(123836,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123836,38.5,0.46,502,55668,70,NULL,NULL,'2MASX J14464012+0927147',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,221.6670417,9.45403,0.021,NULL,59371281627,927676275,14494941,17.8),(123837,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123837,36.84,0.23,234,55669,70,NULL,NULL,'2MASX J14464015+2206294',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000113,NULL,'16.76',0.26,NULL,NULL,NULL,NULL,NULL,1,221.66725,22.10817,0.046,NULL,59505779993,929777812,14527778,16.76),(123838,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123838,35.06,0.2,103,55670,74.4,NULL,NULL,'UGC 09517',NULL,'2013AJ....146...86T',2013,1,1.01,NULL,'G',0.000033,NULL,'14.8g',0.55,'Sb:',NULL,NULL,NULL,NULL,1,221.669625,12.60508,0.021,NULL,59549612821,930462700,14538479,14.8),(123839,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123839,36.17,0.46,171,55671,70,NULL,NULL,'CGCG 076-029',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000087,NULL,'15.5g',0.43,NULL,NULL,NULL,NULL,NULL,1,221.66975,10.16511,0.029,NULL,59370842807,927669418,14494834,15.5),(123840,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123840,35.91,0.23,152,55672,70,NULL,NULL,'2MASX J14464249+1058538',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000077,NULL,'15.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,221.676875,10.98178,0.029,NULL,59367544826,927617887,14494029,15.6),(123841,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123841,38.51,0.46,504,55673,70,NULL,NULL,'SDSS J144643.04+344209.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,221.679333,34.70275,0,NULL,60123743548,939433492,14678648,18.3),(123842,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123842,37.77,0.21,358,55674,70,NULL,NULL,'2MASX J14464350+1427520',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,221.681333333,14.46428,0.013,NULL,59555707704,930557932,14539967,17.9),(123843,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123843,36.19,0.46,173,55675,70,NULL,NULL,'MCG +07-30-064',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000093,NULL,'16.73',0.17,NULL,NULL,NULL,NULL,NULL,1,221.6814583,42.30725,0.012,NULL,59950584833,936727888,14636373,16.73),(123844,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123844,37.7,0.33,346,55676,70,NULL,NULL,'2MASX J14464405+5531083',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000185,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,221.6837083,55.519,0,NULL,57248028194,894500440,13976569,17.1),(123845,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123845,38.14,0.46,425,55677,70,NULL,NULL,'2MASX J14464607+4759539',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000137,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,221.691916667,47.99856,0.045,NULL,59936297381,936504646,14632885,18.3),(123846,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123846,35.21,0.21,110,55678,70,NULL,NULL,'CGCG 076-032',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.000083,NULL,'14.8g',0.62,'SB','Group member',NULL,NULL,NULL,1,221.693666667,11.57019,0.025,NULL,59368226953,927628546,14494196,14.8),(123847,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123847,35.51,0.25,126,55678,74.4,NULL,NULL,'CGCG 076-032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123848,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123848,35.73,0.22,140,55678,70,NULL,NULL,'CGCG 076-032',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123849,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123849,36.2,0.6,174,55679,70,NULL,NULL,'2MASX J14464892-1351109',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.64',0.4,NULL,NULL,NULL,NULL,NULL,1,221.703916667,-13.85297,0.321,NULL,46683916250,729436191,11397440,15.64),(123850,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123850,37.87,0.27,376,55680,70,NULL,NULL,'SDSS J144650.43+220418.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000152,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.710166667,22.07181,0.046,NULL,59505783497,929777867,14527779,18.5),(123851,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123851,35.67,0.46,136,55681,70,NULL,NULL,'2MASX J14465088+0151066',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000082,NULL,'15.3g',0.52,'E0',NULL,NULL,NULL,NULL,1,221.711917,1.85189,0.101,NULL,58267127401,910423865,14225372,15.3),(123852,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123852,37.77,0.21,358,55682,70,NULL,NULL,'2MASX J14465121+1438260',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.74',0.14,NULL,NULL,NULL,NULL,NULL,1,221.713333,14.64067,0.013,NULL,59555656747,930557136,14539955,18.74),(123853,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123853,37.08,0.46,260,55683,70,NULL,NULL,'2MASX J14465132-0206577',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000184,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.713917,-2.11603,0.157,NULL,43503292916,679738951,10620921,17),(123854,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123854,37.6,0.46,332,55684,70,NULL,NULL,'2MASX J14465208+1331410',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,221.7170417,13.52825,0.009,NULL,59549373016,930458953,14538421,17.6),(123855,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123855,36.84,0.23,234,55685,70,NULL,NULL,'2MASX J14465248+2153473',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.54',0.14,'AGN',NULL,NULL,NULL,NULL,1,221.7187917,21.8965,0.021,NULL,59501515891,929711185,14526737,18.54),(123856,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123856,35.73,0.22,140,55686,70,NULL,NULL,'GIN 361',NULL,'2001MNRAS.321..277C',2001,1,0.49,NULL,'G',0.000102,NULL,'15.8g',0.46,'SB',NULL,NULL,NULL,NULL,1,221.7230417,11.37975,0.025,NULL,59367698818,927620294,14494067,15.8),(123857,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123857,35.21,0.21,110,55687,70,NULL,NULL,'CGCG 076-033',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000093,NULL,'14.9g',0.53,'S0','Group member',NULL,NULL,NULL,1,221.723375,11.62622,0.021,NULL,59368228218,927628565,14494196,14.9),(123858,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123858,35.52,0.25,127,55687,74.4,NULL,NULL,'CGCG 076-033',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123859,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123859,35.73,0.22,140,55687,70,NULL,NULL,'CGCG 076-033',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123860,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123860,33.93,0.49,61.2,55688,NULL,NULL,NULL,'ESO 386- G 022',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.59',0.4,'Sb             HII',NULL,NULL,NULL,NULL,1,221.7244583,-35.50703,0.249,NULL,47229767534,737965117,11530704,15.59),(123861,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123861,33.97,0.2,62.2,55688,74.4,NULL,NULL,'ESO 386- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123862,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123862,34.07,0.46,65.1,55688,NULL,NULL,'Malmquist cor.','ESO 386- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123863,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123863,38.26,0.33,449,55689,70,NULL,NULL,'SDSS J144654.08+461808.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,221.725333333,46.30233,0.005,NULL,59991115610,937361181,14646268,18.5),(123864,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123864,38.25,0.33,447,55690,70,NULL,NULL,'SDSS J144654.92+072623.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.728833333,7.43983,0.077,NULL,59379348239,927802316,14496911,18.3),(123865,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123865,38.05,0.33,407,55691,70,NULL,NULL,'SDSS J144655.13+355250.8',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.72975,35.88078,0,NULL,60067834058,938559907,14664998,17.4),(123866,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123866,37.98,0.46,394,55692,70,NULL,NULL,'2MASX J14465572+4856490',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,221.732125,48.94703,0.017,NULL,59936523903,936508185,14632940,17.5),(123867,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123867,36.63,0.55,212,55693,70,NULL,NULL,'2MASX J14465783-1350261',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.97',0.4,NULL,NULL,NULL,NULL,NULL,1,221.740917,-13.84064,0.321,NULL,46685751299,729464864,11397888,16.97),(123868,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123868,37.96,0.46,390,55694,70,NULL,NULL,'SDSS J144658.00+182358.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.7417083,18.39972,0.057,NULL,59585169662,931018275,14547160,18.3),(123869,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123869,37.44,0.33,308,55695,70,NULL,NULL,'2MASX J14465915+4122178',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00022,NULL,'16.8g',0.27,'Candidate      BLAGN',NULL,NULL,NULL,NULL,1,221.7465,41.37172,0.009,NULL,59953314649,936770541,14637039,16.8),(123870,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123870,35.91,0.23,152,55696,70,NULL,NULL,'SDSS J144659.85+105921.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000172,NULL,'17.2g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.749417,10.98933,0.025,NULL,59367549723,927617964,14494030,17.2),(123871,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123871,34.82,0.69,91.8,55697,100,NULL,'mid-IR','UGC 09521',NULL,'2013ApJ...771...88L',2013,1,1.19,NULL,'G',0.000067,NULL,'14.1g',0.74,'SBa:           LINER','Group member',NULL,NULL,NULL,1,221.750417,11.59203,0.021,NULL,59368049969,927625780,14494152,14.1),(123872,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123872,35.67,0.47,136,55697,NULL,NULL,'H','UGC 09521',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123873,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123873,35.75,0.45,141,55697,NULL,NULL,'K','UGC 09521',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123874,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123874,35.76,0.4,142,55697,NULL,NULL,'mean','UGC 09521',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123875,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123875,35.81,0.46,145,55697,NULL,NULL,'J','UGC 09521',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123876,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123876,37.01,0.46,252,55698,70,NULL,NULL,'2MASX J14470037+3025513',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000169,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,221.7515417,30.43092,0.009,NULL,60089407317,938896989,14670265,16.3),(123877,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123877,37.71,0.33,348,55699,70,NULL,NULL,'2MASX J14470042+1201396',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000172,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,221.75175,12.02769,0.025,NULL,59368129641,927627025,14494172,17),(123878,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123878,37.71,0.33,348,55700,70,NULL,NULL,'SDSS J144701.53+120631.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000173,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,221.756417,12.10867,0.021,NULL,59368134279,927627098,14494173,18.2),(123879,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123879,35.61,0.4,133,55701,NULL,NULL,'mean','NGC 5758',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.0001,NULL,'14.49',0.6,'S0-:','Group member',NULL,NULL,NULL,1,221.758666667,13.66839,0.017,NULL,59549211060,930456422,14538381,14.49),(123880,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123880,36.37,0.45,188,55701,NULL,NULL,'K','NGC 5758',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123881,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123881,36.05,0.46,162,55702,70,NULL,NULL,'2MASX J14470211+1005293',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000179,NULL,'15.8g',0.41,NULL,NULL,NULL,NULL,NULL,1,221.75875,10.09144,0.029,NULL,59370833009,927669265,14494832,15.8),(123882,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123882,36.06,0.68,163,55703,70,NULL,NULL,'2MFGC 11967',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,221.7595417,-18.21678,0.345,NULL,46696014243,729625222,11400394,15.1),(123883,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123883,37.93,0.15,385,55704,70,NULL,NULL,'2MASX J14470283+3320103',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000165,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,221.761667,33.33611,0,NULL,60121544984,939399140,14678111,17.4),(123884,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123884,36.59,0.39,208,55705,NULL,NULL,NULL,'AGC 540233',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.00001,NULL,'15.5I',NULL,NULL,NULL,NULL,NULL,NULL,1,221.764583,-13.81139,0.321,NULL,46685759045,729464985,11397890,15.5),(123885,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123885,36.63,0.2,212,55705,74.4,NULL,NULL,'AGC 540233',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123886,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123886,36.72,0.37,221,55705,NULL,NULL,'Malmquist cor.','AGC 540233',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123887,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123887,37.09,0.33,262,55706,70,NULL,NULL,'2MASX J14470363+0535250',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000164,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,221.765375,5.59042,0.121,NULL,59333670187,927088596,14485759,16.7),(123888,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123888,37.91,0.46,382,55707,70,NULL,NULL,'2MASX J14470446+2036231',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.68',0.14,NULL,NULL,NULL,NULL,NULL,1,221.76875,20.60631,0.079,NULL,59532154466,930189913,14534217,18.68),(123889,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123889,36.87,0.33,237,55708,70,NULL,NULL,'2MASX J14470470+0934563',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00018,NULL,'18.60',0.16,NULL,NULL,NULL,NULL,NULL,1,221.7694583,9.58233,0.049,NULL,59371249291,927675770,14494933,18.6),(123890,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123890,37.56,0.46,325,55709,70,NULL,NULL,'2MASX J14470560+2548075',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.45',0.15,NULL,NULL,NULL,NULL,NULL,1,221.773208333,25.80219,0.076,NULL,60015033378,937734896,14652107,18.45),(123891,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123891,37.77,0.21,358,55710,70,NULL,NULL,'2MASX J14470559+1431006',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,221.7732917,14.51703,0.013,NULL,59555697268,930557769,14539965,18.5),(123892,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123892,36.98,0.15,249,55711,70,NULL,NULL,'2MASX J14470571+1133453',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000158,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,221.773708333,11.56267,0.021,NULL,59368050429,927625787,14494152,16.8),(123893,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123893,37.29,0.46,287,55712,70,NULL,NULL,'SDSS J144705.78+494542.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,221.774083,49.76172,0.045,NULL,59935316038,936489313,14632645,18.3),(123894,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123894,37.94,0.46,387,55713,70,NULL,NULL,'2MASX J14470617+1723216',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.89',0.12,NULL,NULL,NULL,NULL,NULL,1,221.775791667,17.38942,0.037,NULL,59587990451,931062350,14547849,18.89),(123895,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123895,37.12,0.46,265,55714,70,NULL,NULL,'SDSS J144706.23+631353.8',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,221.7759583,63.23164,0.017,NULL,57759096025,902485875,14101341,17.8),(123896,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123896,35.21,0.21,110,55715,70,NULL,NULL,'UGC 09523',NULL,'2015arXiv151105856S',2015,1,0.95,NULL,'G',0.000097,NULL,'14.1g',0.84,'S0/a','Group member',NULL,NULL,NULL,1,221.776333333,11.59381,0.021,NULL,59368049729,927625777,14494152,14.1),(123897,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123897,35.51,0.25,126,55715,74.4,NULL,NULL,'UGC 09523',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123898,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123898,35.73,0.22,140,55715,70,NULL,NULL,'UGC 09523',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123899,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123899,37.93,0.15,385,55716,70,NULL,NULL,'2MASX J14470653+3310454',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000175,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,221.777083,33.17919,0,NULL,60121523100,939398798,14678106,17.8),(123900,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123900,35.52,0.25,127,55717,74.4,NULL,NULL,'CGCG 076-037',NULL,'2013AJ....146...86T',2013,1,0.86,'Two MAPS entries for the same object.','G',0.000063,NULL,'15.1g',0.57,'E/S0',NULL,NULL,NULL,NULL,1,221.7787083,10.99967,0.025,NULL,59367550974,927617983,14494030,15.1),(123901,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123901,35.73,0.22,140,55717,70,NULL,NULL,'CGCG 076-037',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123902,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123902,35.91,0.23,152,55717,70,NULL,NULL,'CGCG 076-037',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123903,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123903,38.18,0.46,433,55718,70,NULL,NULL,'LCRS B144432.3-022935',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000141,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,221.783458333,-2.70172,0.197,NULL,43500926088,679701970,10620343,18.7),(123904,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123904,37.09,0.33,262,55719,70,NULL,NULL,'2MASX J14470979+0526270',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000137,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,221.790708333,5.44072,0.133,NULL,59333625003,927087890,14485748,18.3),(123905,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123905,37.93,0.15,385,55720,70,NULL,NULL,'2MASX J14471003+3312374',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000191,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,221.792,33.21047,0,NULL,60121525616,939398837,14678106,16.7),(123906,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123906,37.77,0.21,358,55721,70,NULL,NULL,'2MASX J14471028+1431277',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.49',0.19,'BrClG',NULL,NULL,NULL,NULL,1,221.7930417,14.52433,0.013,NULL,59555680350,930557505,14539961,17.49),(123907,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123907,37.72,0.46,350,55722,70,NULL,NULL,'2MASX J14471162+3002244',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,221.7985417,30.03989,0.027,NULL,60089251540,938894555,14670227,17.2),(123908,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123908,37.87,0.27,376,55723,70,NULL,NULL,'2MASX J14471250+2214520',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,221.802083,22.24781,0.057,NULL,59505816240,929778378,14527787,17.7),(123909,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123909,37.87,0.27,376,55724,70,NULL,NULL,'2MASX J14471329+2213410',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000155,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,221.805375,22.22803,0.057,NULL,59505815732,929778370,14527787,17.1),(123910,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123910,38.65,0.46,536,55725,70,NULL,NULL,'SDSS J144714.53+282838.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000176,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.8105417,28.47739,0.033,NULL,60026955584,937921181,14655018,18),(123911,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123911,38.28,0.46,452,55726,70,NULL,NULL,'2MASX J14471549+6355268',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.81475,63.92425,0.017,NULL,57755990960,902437358,14100583,17.7),(123912,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123912,37.44,0.33,308,55727,70,NULL,NULL,'2MASX J14471636+4125424',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,221.818083,41.42839,0.021,NULL,59953294764,936770230,14637034,17.1),(123913,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123913,37.93,0.15,385,55728,70,NULL,NULL,'SDSS J144717.06+331435.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,221.821083333,33.24308,0,NULL,60121525216,939398831,14678106,18.5),(123914,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123914,35.73,0.22,140,55729,70,NULL,NULL,'GIN 360',NULL,'2001MNRAS.321..277C',2001,1,0.62,NULL,'G',0.000171,NULL,'15.9g',0.35,'S',NULL,NULL,NULL,NULL,1,221.823417,11.13017,0.025,NULL,59367520664,927617510,14494023,15.9),(123915,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123915,36.3,0.25,182,55729,74.4,NULL,NULL,'GIN 360',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123916,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123916,37.14,0.46,268,55730,70,NULL,NULL,'2MASX J14471764+2657546',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.84',0.19,NULL,NULL,NULL,NULL,NULL,1,221.8234583,26.96536,0.084,NULL,60015293324,937738958,14652171,17.84),(123917,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123917,37.82,0.46,366,55731,70,NULL,NULL,'SDSS J144717.63+030503.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000076,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,221.8235,3.08436,0.101,NULL,58257411648,910272057,14223000,18.5),(123918,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123918,36.98,0.46,249,55732,70,NULL,NULL,'2MASX J14471791+1656497',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,221.82475,16.94706,0.029,NULL,59585884059,931029438,14547334,17.6),(123919,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123919,37.3,0.46,289,55733,70,NULL,NULL,'2MASX J14471854+4605103',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.827125,46.08617,0,NULL,59990986329,937359161,14646236,17.6),(123920,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123920,38.05,0.33,407,55734,70,NULL,NULL,'2MASX J14471916+3545314',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000195,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,221.829833,35.75878,0,NULL,60123370438,939427663,14678557,17),(123921,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123921,38.32,0.46,461,55735,70,NULL,NULL,'SDSS J144719.22+284926.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00016,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,221.830125,28.82406,0.028,NULL,60027017227,937922144,14655033,18.5),(123922,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123922,35.11,0.53,105,55736,70,NULL,NULL,'LCRS B144441.3-061451',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'15.57',0.5,NULL,NULL,NULL,NULL,NULL,1,221.832458333,-6.45553,0.205,NULL,46498951457,726546116,11352283,15.57),(123923,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123923,37.93,0.15,385,55737,70,NULL,NULL,'2MASX J14472070+3305224',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000177,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,221.8362083,33.08947,0,NULL,60121650614,939400790,14678137,17.9),(123924,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123924,37.72,0.46,349,55738,70,NULL,NULL,'2MASX J14472064+4035354',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000134,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,221.83625,40.59311,0.012,NULL,59951577033,936743391,14636615,18.5),(123925,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123925,37.85,0.33,371,55739,70,NULL,NULL,'2MASX J14472307+0552094',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,221.8462917,5.86931,0.109,NULL,59333514968,927086171,14485721,17.6),(123926,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123926,36.87,0.33,237,55740,70,NULL,NULL,'2MASX J14472404+0941173',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000174,NULL,'18.25',0.21,NULL,NULL,NULL,NULL,NULL,1,221.8502083,9.68808,0.033,NULL,59371371981,927677687,14494963,18.25),(123927,'IRAS','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123927,32.41,0.8,30.3,55741,75,NULL,'MAT, I','UGCA 394',NULL,'1997ApJS..109..333W',1997,1,3.7,NULL,'G',0.000018,NULL,'13.5',0.5,'SB(s)cd: sp    HII',NULL,NULL,NULL,NULL,1,221.85075,-17.44558,0.349,NULL,46698624733,729666011,11401031,13.5),(123928,'Tully est','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123928,32.57,0.8,32.7,55741,75,NULL,NULL,'UGCA 394',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123929,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123929,30.71,0.4,13.9,55741,75,NULL,NULL,'UGCA 394',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123930,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123930,30.72,0.4,13.9,55741,73,NULL,'IR','UGCA 394',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123931,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123931,30.82,0.43,14.6,55741,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 394',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123932,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123932,31.11,0.43,16.7,55741,75,NULL,'3.6 micron, color corrected','UGCA 394',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123933,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123933,31.32,0.4,18.4,55741,NULL,NULL,NULL,'UGCA 394',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123934,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123934,31.35,0.2,18.6,55741,74.4,NULL,NULL,'UGCA 394',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123935,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',123935,31.54,0.49,20.3,55741,75,NULL,'IR','UGCA 394',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123936,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123936,31.62,0.49,21,55741,NULL,NULL,NULL,'UGCA 394',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123937,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123937,31.67,0.48,21.6,55741,NULL,NULL,'Malmquist cor.','UGCA 394',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123938,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123938,31.69,NULL,21.8,55741,NULL,NULL,'Dipole + Quadrupole + Octopole','UGCA 394',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123939,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123939,31.7,NULL,21.9,55741,NULL,NULL,'Dipole + Quadrupole','UGCA 394',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123940,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123940,31.7,NULL,21.9,55741,NULL,NULL,'Dipole','UGCA 394',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123941,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123941,31.76,0.32,22.5,55741,85,NULL,'I, raw','UGCA 394',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123942,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123942,31.77,0.32,22.6,55741,85,NULL,'I, inv','UGCA 394',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123943,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123943,31.85,0.43,23.5,55741,75,NULL,'MAT, I, raw','UGCA 394',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123944,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123944,31.94,0.43,24.5,55741,75,NULL,'MAT, I, inv','UGCA 394',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123945,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123945,31.98,0.47,24.9,55741,NULL,NULL,'H','UGCA 394',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123946,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123946,32.02,0.46,25.3,55741,NULL,NULL,'J','UGCA 394',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123947,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123947,32.04,0.45,25.5,55741,NULL,NULL,'K','UGCA 394',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123948,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123948,32.05,NULL,25.7,55741,NULL,NULL,NULL,'UGCA 394',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123949,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123949,32.2,0.43,27.5,55741,75,NULL,'MAT, I, cor','UGCA 394',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123950,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123950,32.45,0.4,31,55741,NULL,NULL,'mean','UGCA 394',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123951,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',123951,35.64,0.46,134,55742,70,NULL,NULL,'2MASX J14472519+0326274',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000108,NULL,'15.7g',0.4,'S0',NULL,NULL,NULL,NULL,1,221.854833,3.44111,0.093,NULL,58257506317,910273536,14223024,15.7),(123952,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123952,32.83,0.37,36.9,55743,NULL,NULL,'Malmquist cor.','IC 1055',NULL,'2009ApJS..182..474S',2009,1,2,'HOLM 677B,C are stars.','G',0.000017,NULL,'13.43',0.7,'(R\')SA(r)b:    HII',NULL,NULL,NULL,NULL,1,221.8570417,-13.71614,0.301,NULL,46685786885,729465420,11397897,13.43),(123953,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123953,32.9,0.46,38,55743,NULL,NULL,'J','IC 1055',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123954,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123954,32.91,0.47,38.2,55743,NULL,NULL,'H','IC 1055',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123955,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123955,32.94,0.2,38.7,55743,74.4,NULL,NULL,'IC 1055',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123956,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123956,32.95,0.36,38.9,55743,NULL,NULL,NULL,'IC 1055',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123957,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123957,32.99,0.45,39.6,55743,NULL,NULL,'K','IC 1055',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123958,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123958,33.1,0.43,41.7,55743,75,NULL,'3.6 micron, color corrected','IC 1055',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123959,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123959,33.19,0.4,43.5,55743,NULL,NULL,'mean','IC 1055',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123960,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123960,33.27,0.43,45,55743,75,NULL,'3.6 micron, color + selection bias corrected','IC 1055',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123961,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',123961,37.86,0.46,373,55744,70,NULL,NULL,'2MASX J14472589+4831516',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,221.857917,48.53089,0.045,NULL,59936454223,936507097,14632923,17.3),(123962,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',123962,36.28,0.46,180,55745,70,NULL,NULL,'2MASX J14472616+2228355',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000174,NULL,'17.19',0.17,NULL,NULL,NULL,NULL,NULL,1,221.859125,22.47661,0.071,NULL,59506591359,929790489,14527976,17.19),(123963,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',123963,37.7,0.46,347,55746,70,NULL,NULL,'2MASX J14472800+2517425',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.48',0.14,NULL,NULL,NULL,NULL,NULL,1,221.866667,25.29511,0.072,NULL,60014618702,937728417,14652006,18.48),(123964,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',123964,37.82,0.46,366,55747,70,NULL,NULL,'SDSS J144728.13+274547.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.8672917,27.76331,0.112,NULL,60013601449,937712522,14651758,18.2),(123965,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',123965,36.99,0.46,250,55748,70,NULL,NULL,'2MASX J14472843+6009008',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000095,NULL,'16.7g',0.29,'NLAGN',NULL,NULL,NULL,NULL,1,221.8682917,60.15033,0.013,NULL,57771469783,902679215,14104362,16.7),(123966,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',123966,37.75,0.46,355,55749,70,NULL,NULL,'2MASX J14472859+1644350',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.07',0.18,NULL,NULL,NULL,NULL,NULL,1,221.869,16.74303,0.009,NULL,59553301066,930520329,14539380,18.07),(123967,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',123967,37.15,0.46,269,55750,70,NULL,NULL,'2MASX J14472861+4544253',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00018,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,221.869125,45.74028,0,NULL,59990934441,937358350,14646224,16.4),(123968,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',123968,36.56,0.46,205,55751,70,NULL,NULL,'2MASX J14472895+3151584',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000158,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,221.870583,31.86617,0,NULL,60091085845,938923216,14670675,16.5),(123969,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',123969,37.93,0.15,385,55752,70,NULL,NULL,'2MASX J14473121+3306064',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000179,NULL,'16.0g',0.46,'BrClG',NULL,NULL,NULL,NULL,1,221.8802083,33.10175,0,NULL,60121660923,939400951,14678139,16),(123970,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',123970,37.42,0.46,305,55753,70,NULL,NULL,'2MASX J14473163+1521240',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,221.8817917,15.35658,0,NULL,59555015042,930547110,14539798,16.3),(123971,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',123971,38.62,0.46,529,55754,70,NULL,NULL,'2MASX J14473234+0310514',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00009,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,221.884667,3.18103,0.101,NULL,58257426313,910272286,14223004,17.9),(123972,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',123972,34.56,0.49,81.8,55755,75,NULL,'IR','ESO 580- G 028',NULL,'2011yCatp016004901K',2011,1,1.12,NULL,'G',0.000043,NULL,'15.56',0.15,'Sc',NULL,NULL,NULL,NULL,1,221.888875,-19.32992,0.341,NULL,46649865820,728904153,11389127,15.56),(123973,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123973,34.34,0.51,73.8,55756,70,NULL,NULL,'MCG -03-38-010',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000087,NULL,'15',0.6,'poss. LINER',NULL,NULL,NULL,NULL,1,221.8895,-20.46739,0.353,NULL,46650660627,728916572,11389321,15),(123974,'IRAS','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123974,32.39,0.8,30.1,55757,75,NULL,'MAT, I','NGC 5756',NULL,'1997ApJS..109..333W',1997,1,2.1,'HOLM 676B does not exist (it is probably a plate defect).','G',0.000017,NULL,'13.09',0.9,'(R\')SB(s)bc pecHII',NULL,NULL,NULL,NULL,1,221.890541667,-14.85358,0.341,NULL,46687777923,729496530,11398383,13.09),(123975,'Tully est','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123975,32.56,0.8,32.6,55757,75,NULL,'B','NGC 5756',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123976,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123976,31.86,0.43,23.5,55757,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5756',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123977,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123977,31.91,0.32,24.1,55757,85,NULL,'I, raw','NGC 5756',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123978,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123978,31.95,0.32,24.5,55757,85,NULL,'I, inv','NGC 5756',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123979,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123979,31.96,0.43,24.6,55757,75,NULL,'3.6 micron, color corrected','NGC 5756',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123980,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123980,32.01,0.43,25.2,55757,75,NULL,'MAT, I, raw','NGC 5756',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123981,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123981,32.06,0.2,25.8,55757,74.4,NULL,NULL,'NGC 5756',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123982,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123982,32.07,0.46,25.9,55757,NULL,NULL,'J','NGC 5756',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123983,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123983,32.09,0.47,26.2,55757,NULL,NULL,'H','NGC 5756',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123984,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123984,32.14,0.45,26.8,55757,NULL,NULL,'K','NGC 5756',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123985,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123985,32.17,0.43,27.1,55757,75,NULL,'MAT, I, inv','NGC 5756',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123986,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123986,32.24,0.5,28.1,55757,NULL,NULL,NULL,'NGC 5756',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123987,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123987,32.29,0.49,28.7,55757,NULL,NULL,'Malmquist cor.','NGC 5756',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123988,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123988,32.31,0.43,28.9,55757,75,NULL,'MAT, I, cor','NGC 5756',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123989,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123989,32.42,0.4,30.4,55757,NULL,NULL,'mean','NGC 5756',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123990,'IRAS','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123990,32.75,0.8,35.5,55758,75,NULL,'MAT, I','ESO 580- G 029',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.00002,NULL,'14.47',0.3,'S(r)b:         HII',NULL,NULL,NULL,NULL,1,221.89025,-19.76411,0.377,NULL,46649433317,728897395,11389021,14.47),(123991,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',123991,32.29,0.4,28.7,55758,75,NULL,NULL,'ESO 580- G 029',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123992,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123992,32.42,0.32,30.5,55758,85,NULL,'I, raw','ESO 580- G 029',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123993,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123993,32.45,0.43,30.9,55758,75,NULL,'MAT, I, raw','ESO 580- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123994,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123994,32.45,0.32,30.9,55758,85,NULL,'I, inv','ESO 580- G 029',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123995,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123995,32.46,0.47,31,55758,NULL,NULL,'H','ESO 580- G 029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123996,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123996,32.47,0.46,31.2,55758,NULL,NULL,'J','ESO 580- G 029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123997,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123997,32.52,0.45,31.9,55758,NULL,NULL,'K','ESO 580- G 029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123998,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123998,32.6,0.43,33.1,55758,75,NULL,'MAT, I, inv','ESO 580- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123999,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123999,32.6,0.43,33.1,55758,75,NULL,'3.6 micron, color + selection bias corrected','ESO 580- G 029',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124000,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124000,32.68,0.49,34.4,55758,75,NULL,'IR','ESO 580- G 029',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124001,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124001,32.7,0.43,34.7,55758,75,NULL,'MAT, I, cor','ESO 580- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124002,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124002,32.71,0.43,34.8,55758,75,NULL,'3.6 micron, color corrected','ESO 580- G 029',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124003,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124003,32.8,0.4,36.3,55758,NULL,NULL,'mean','ESO 580- G 029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124004,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124004,32.8,0.2,36.3,55758,74.4,NULL,NULL,'ESO 580- G 029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124005,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124005,32.91,0.45,38.3,55758,NULL,NULL,NULL,'ESO 580- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124006,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124006,32.99,0.44,39.6,55758,NULL,NULL,'Malmquist cor.','ESO 580- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124007,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124007,35.2,0.2,110,55759,74.4,NULL,NULL,'CGCG 076-045',NULL,'2013AJ....146...86T',2013,1,0.97,NULL,'G',0.000137,NULL,'15.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,221.894083333,9.23103,0.021,NULL,59370510775,927664230,14494753,15.9),(124008,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124008,35.29,0.49,114,55760,75,NULL,'IR','CGCG 076-045',NULL,'2011yCatp016004901K',2011,1,0.97,NULL,'G',0.000137,NULL,'15.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,221.894083333,9.23103,0.021,NULL,59370510775,927664230,14494753,15.9),(124009,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124009,37.02,0.46,254,55761,70,NULL,NULL,'2MASX J14473553+1035149',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.47',0.18,NULL,NULL,NULL,NULL,NULL,1,221.8982083,10.58756,0.025,NULL,59368858105,927638407,14494350,16.47),(124010,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124010,37.43,0.46,306,55762,70,NULL,NULL,'2MASX J14473568+3756364',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000192,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,221.8985,37.94344,0,NULL,60073608125,938650126,14666408,16.7),(124011,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124011,35.23,0.46,111,55763,70,NULL,NULL,'2MASX J14473588+0347174',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000068,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,221.8995,3.78817,0.089,NULL,58257608623,910275134,14223048,16.4),(124012,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124012,34.41,0.69,76.3,55764,NULL,NULL,NULL,'ESO 580- G 031',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.82',0.7,'Sb',NULL,NULL,NULL,NULL,1,221.90325,-19.38739,0.341,NULL,46649862508,728904101,11389126,14.82),(124013,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124013,34.45,0.2,77.6,55764,74.4,NULL,NULL,'ESO 580- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124014,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124014,34.6,0.63,83.2,55764,NULL,NULL,'Malmquist cor.','ESO 580- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124015,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124015,37.93,0.15,385,55765,70,NULL,NULL,'2MASX J14473680+3317100',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.903333,33.28614,0,NULL,60121528630,939398884,14678107,17.5),(124016,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124016,37.74,0.46,353,55766,70,NULL,NULL,'2MASX J14473681+0344424',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000091,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.9035,3.74511,0.093,NULL,58257618028,910275281,14223051,17.2),(124017,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124017,37.54,0.46,322,55767,70,NULL,NULL,'2MASX J14473727-0145544',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000136,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,221.905291667,-1.76514,0.173,NULL,43502367029,679724484,10620695,16.9),(124018,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124018,37.72,0.46,350,55768,70,NULL,NULL,'2MASX J14473797+2812331',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,221.908125,28.20922,0.058,NULL,60026923626,937920681,14655010,17.5),(124019,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124019,37.46,0.46,310,55769,70,NULL,NULL,'2MASX J14473888+5615217',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000177,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,221.911917,56.25597,0.005,NULL,57245807299,894465739,13976027,17.1),(124020,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124020,38.16,0.46,429,55770,70,NULL,NULL,'2MASX J14473895+4738594',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000185,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,221.9122083,47.64981,0.041,NULL,59933992860,936468638,14632322,17.2),(124021,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124021,32.76,0.73,35.7,55771,NULL,NULL,'Malmquist cor.','AGC 540235',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000017,NULL,'16.71',NULL,NULL,NULL,NULL,NULL,NULL,1,221.9135417,-13.63664,0.301,NULL,46685783119,729465361,11397896,16.71),(124022,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124022,32.94,0.67,38.8,55771,NULL,NULL,NULL,'AGC 540235',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124023,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124023,32.98,0.2,39.5,55771,74.4,NULL,NULL,'AGC 540235',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124024,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124024,37.81,0.33,364,55772,70,NULL,NULL,'2MASX J14473938+1648430',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.59',0.15,NULL,NULL,NULL,NULL,NULL,1,221.914167,16.81183,0.009,NULL,59585872339,931029255,14547332,18.59),(124025,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124025,37.93,0.15,385,55773,70,NULL,NULL,'2MASX J14474057+3307401',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000177,NULL,'16.8g',0.34,NULL,NULL,NULL,NULL,NULL,1,221.9192083,33.12775,0,NULL,60121660008,939400937,14678139,16.8),(124026,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124026,37.93,0.15,385,55774,70,NULL,NULL,'SDSS J144740.69+325843.8',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000142,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,221.919541667,32.97883,0,NULL,60121653702,939400839,14678138,18.5),(124027,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124027,38.3,0.46,456,55775,70,NULL,NULL,'2MASX J14474083+4622454',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000176,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,221.92025,46.37942,0.025,NULL,59991125533,937361336,14646270,16.8),(124028,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124028,37.85,0.33,371,55776,70,NULL,NULL,'2MASX J14474123+0555314',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,221.921917,5.92539,0.113,NULL,59333239501,927081867,14485654,17.3),(124029,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124029,34.62,0.43,83.9,55777,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09530',NULL,'2014MNRAS.444..527S',2014,1,0.9,NULL,'G',0.000033,NULL,'14.87',0.5,'S?','Group member',NULL,NULL,NULL,1,221.9270417,9.65944,0.033,NULL,59371359818,927677497,14494960,14.87),(124030,'IRAS','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124030,33.84,0.8,58.7,55778,75,NULL,'MAT, I','IC 4484',NULL,'1997ApJS..109..333W',1997,1,3.53,'Stars superposed.','G',0.00003,NULL,'12.34',0.34,'Sc',NULL,NULL,NULL,NULL,1,221.932833,-73.30594,0.573,NULL,44913606292,701775098,10965235,12.34),(124031,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124031,33.22,0.47,44,55778,NULL,NULL,'H','IC 4484',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124032,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124032,33.24,0.43,44.5,55778,75,NULL,'MAT, I, raw','IC 4484',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124033,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124033,33.28,0.49,45.2,55778,75,NULL,'IR','IC 4484',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124034,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124034,33.33,0.32,46.4,55778,85,NULL,'I, raw','IC 4484',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124035,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124035,33.38,0.46,47.4,55778,NULL,NULL,'J','IC 4484',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124036,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124036,33.38,0.32,47.5,55778,85,NULL,'I, inv','IC 4484',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124037,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124037,33.39,0.45,47.6,55778,NULL,NULL,'K','IC 4484',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124038,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124038,33.41,0.43,48.1,55778,75,NULL,'MAT, I, cor','IC 4484',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124039,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124039,33.45,0.43,49.1,55778,75,NULL,'MAT, I, inv','IC 4484',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124040,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124040,33.52,0.55,50.6,55778,NULL,NULL,NULL,'IC 4484',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124041,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124041,33.55,0.54,51.2,55778,NULL,NULL,'Malmquist cor.','IC 4484',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124042,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124042,33.56,0.2,51.5,55778,74.4,NULL,NULL,'IC 4484',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124043,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124043,33.59,NULL,52.2,55778,NULL,NULL,NULL,'IC 4484',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124044,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124044,33.73,0.4,55.8,55778,NULL,NULL,'mean','IC 4484',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124045,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124045,33.8,NULL,57.5,55778,NULL,NULL,'Dipole','IC 4484',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124046,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124046,33.8,NULL,57.5,55778,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 4484',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124047,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124047,33.81,NULL,57.7,55778,NULL,NULL,'Dipole + Quadrupole','IC 4484',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124048,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124048,36.98,0.15,249,55779,70,NULL,NULL,'2MASX J14474484+1126119',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000176,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,221.9369583,11.43667,0.021,NULL,59367618478,927619038,14494047,16.1),(124049,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124049,36.56,0.46,205,55780,70,NULL,NULL,'SDSS J144745.51+132032.3',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'15.9g',0.42,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.939666667,13.34233,0.009,NULL,59549308157,930457939,14538405,15.9),(124050,'Tully est','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124050,32.98,0.8,39.5,55781,75,NULL,'B','NGC 5757',NULL,'1988NBGC.C....0000T',1988,1,2,NULL,'G',0.000023,NULL,'13.50',1.6,'(R\')SB(r)b     HII','in a pair',NULL,NULL,'H II',1,221.94325,-19.07856,0.341,NULL,46649779328,728902802,11389106,13.5),(124051,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124051,36.66,0.49,215,55782,75,NULL,'IR','2MFGC 11989',NULL,'2011yCatp016004901K',2011,1,0.6,NULL,'G',0.000068,NULL,'17.64',0.1,NULL,NULL,NULL,NULL,NULL,1,221.947375,16.83006,0.013,NULL,59586087412,931032615,14547384,17.64),(124052,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124052,37.47,0.46,312,55783,70,NULL,NULL,'2MASX J14474832+3249271',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000141,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,221.951333,32.82428,0.02,NULL,60121459578,939397805,14678090,17.4),(124053,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124053,38.06,0.46,409,55784,70,NULL,NULL,'2MASX J14474984+2833592',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000142,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.957875,28.56658,0.033,NULL,60027037278,937922457,14655038,17.9),(124054,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124054,37.98,0.46,395,55785,70,NULL,NULL,'2MASX J14475006+1321500',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.9585,13.36381,0.009,NULL,59549316033,930458063,14538407,17.6),(124055,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124055,37.22,0.46,278,55786,70,NULL,NULL,'2MASXi J1447511+255346',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.6g',NULL,NULL,NULL,NULL,NULL,NULL,1,221.9630417,25.89619,0.07,NULL,60014584675,937727885,14651998,17.6),(124056,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124056,37.81,0.33,364,55787,70,NULL,NULL,'2MASX J14475143+1649230',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.964375,16.823,0.013,NULL,59586088002,931032625,14547384,17.5),(124057,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124057,36.98,0.15,249,55788,70,NULL,NULL,'2MASX J14475240+1122299',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,221.968375,11.37486,0.025,NULL,59367618744,927619042,14494047,16.7),(124058,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124058,37.69,0.46,346,55789,70,NULL,NULL,'2MASX J14475244+0715529',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,221.968625,7.26461,0.077,NULL,59379499715,927804683,14496948,17.4),(124059,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124059,38.42,0.46,484,55790,70,NULL,NULL,'SDSS J144753.94+114436.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,221.9747917,11.74339,0,NULL,59368035330,927625552,14494149,18),(124060,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124060,37.5,0.46,317,55791,70,NULL,NULL,'2MASX J14475406+2006563',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'18.00',0.18,NULL,NULL,NULL,NULL,NULL,1,221.9752083,20.11572,0.108,NULL,59533405234,930209456,14534522,18),(124061,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124061,35.51,0.21,127,55792,70,NULL,NULL,'CGCG 076-053',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000103,NULL,'15.4',0.61,NULL,NULL,NULL,NULL,NULL,1,221.976375,13.66172,0.017,NULL,59549711157,930464236,14538503,15.4),(124062,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124062,36.97,0.46,247,55793,70,NULL,NULL,'SDSS J144755.22+222607.4',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000153,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,221.980083,22.43539,0.071,NULL,59505728076,929777001,14527765,16.9),(124063,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124063,32.56,0.2,32.5,55794,74.4,NULL,NULL,'MCG -02-38-015',NULL,'2013AJ....146...86T',2013,1,2.2,NULL,'G',0.000003,NULL,'14.07',1.9,'SB(s)cd',NULL,NULL,NULL,NULL,1,221.9832917,-14.28253,0.321,NULL,46685242976,729456921,11397764,14.07),(124064,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124064,32.68,0.46,34.4,55794,NULL,NULL,NULL,'MCG -02-38-015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124065,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124065,32.73,0.45,35.1,55794,NULL,NULL,'Malmquist cor.','MCG -02-38-015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124066,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124066,32.75,0.43,35.5,55794,75,NULL,'3.6 micron, color corrected','MCG -02-38-015',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124067,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124067,32.94,0.43,38.6,55794,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-38-015',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124068,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124068,36.33,0.46,185,55795,70,NULL,NULL,'UGC 09532 NED05',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000133,NULL,'16.12',0.2,'E2','Compact group member',NULL,NULL,NULL,1,221.986708333,19.04508,0.075,NULL,59530220201,930159690,14533745,16.12),(124069,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124069,37.04,0.46,255,55796,70,NULL,NULL,'2MASXi J1447578+120551',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,221.9910417,12.09764,0.021,NULL,59367846490,927622601,14494103,18.1),(124070,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124070,38.55,0.46,513,55797,70,NULL,NULL,'SDSS J144759.10+254609.8',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.9962917,25.76939,0.064,NULL,60014548169,937727315,14651989,17.1),(124071,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124071,37.54,0.46,322,55798,70,NULL,NULL,'2MASX J14475915+1504284',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,221.996625,15.07458,0,NULL,59555087604,930548243,14539816,17.6),(124072,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124072,37.19,0.46,274,55799,70,NULL,NULL,'SDSS J144759.73+190202.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.998917,19.03392,0.075,NULL,59530220485,930159695,14533745,17.9),(124073,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124073,38.55,0.46,513,55800,70,NULL,NULL,'SDSS J144759.81-015318.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000135,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,221.99925,-1.88853,0.173,NULL,43502475869,679726185,10620721,18.2),(124074,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124074,37.98,0.33,394,55801,70,NULL,NULL,'2MASX J14480079+0354175',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000076,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,222.003375,3.90489,0.093,NULL,58257227511,910269179,14222955,17.3),(124075,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124075,36.05,0.46,162,55802,70,NULL,NULL,'2MASX J14480118+2106001',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.24',0.23,NULL,NULL,NULL,NULL,NULL,1,222.004875,21.10006,0.063,NULL,59502044362,929719443,14526866,17.24),(124076,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124076,36.83,0.46,232,55803,70,NULL,NULL,'2MASX J14480162+0209285',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000067,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,222.0067917,2.15792,0.117,NULL,58266304177,910411002,14225171,17.9),(124077,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124077,38.26,0.46,448,55804,70,NULL,NULL,'2MASX J14480255+5415348',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,222.010625,54.25961,0,NULL,59193723164,924901924,14451592,18.2),(124078,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124078,38.21,0.46,439,55805,70,NULL,NULL,'2MASX J14480357+0529075',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000177,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,222.014917,5.48558,0.121,NULL,59333476338,927085567,14485711,18.1),(124079,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124079,36.3,0.5,182,55806,70,NULL,NULL,'2MASX J14480447-2916319',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,222.018708333,-29.27547,0.377,NULL,47019416766,734678386,11479349,15),(124080,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124080,35.51,0.21,127,55807,70,NULL,NULL,'GIN 348',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000053,NULL,'14.70',0.24,'E/S0',NULL,NULL,NULL,NULL,1,222.0210417,13.48056,0.017,NULL,59549779771,930465308,14538520,14.7),(124081,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124081,37.7,0.46,347,55808,70,NULL,NULL,'2MASX J14480528+0317485',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000084,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,222.0219583,3.29669,0.073,NULL,58257694091,910276470,14223069,17.7),(124082,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124082,37.54,0.33,322,55809,70,NULL,NULL,'SDSS J144806.74+494642.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000143,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,222.028125,49.77853,0.017,NULL,59935391752,936490496,14632664,18.2),(124083,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124083,36.72,0.46,221,55810,70,NULL,NULL,'2MASX J14480692+2013351',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,222.028875,20.22639,0.108,NULL,59533381962,930209093,14534517,NULL),(124084,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124084,35.46,0.46,124,55811,70,NULL,NULL,'CGCG 164-028',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000147,NULL,'15.9g',0.35,'E','Group member',NULL,NULL,NULL,1,222.03075,31.73803,0,NULL,60091543216,938930362,14670786,15.9),(124085,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124085,34.53,0.46,80.4,55812,70,NULL,NULL,'CGCG 248-021',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000167,NULL,'14.9g',0.55,'S0^-',NULL,NULL,NULL,NULL,1,222.032041667,48.09378,0.045,NULL,59936187405,936502928,14632858,14.9),(124086,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124086,36.98,0.15,249,55813,70,NULL,NULL,'SDSS J144808.01+111728.5',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.033375,11.29125,0.025,NULL,59367594618,927618665,14494041,17.4),(124087,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124087,35.79,0.33,144,55814,70,NULL,NULL,'CGCG 164-027',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000143,NULL,'15.6g',0.36,'E','Group member',NULL,NULL,NULL,1,222.034916667,31.71033,0,NULL,60091542956,938930358,14670786,15.6),(124088,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124088,35.05,0.2,102,55815,74.4,NULL,NULL,'CGCG 076-054',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000057,NULL,'15.7',0.3,NULL,NULL,NULL,NULL,NULL,1,222.039583,14.13378,0.017,NULL,59547894675,930435854,14538060,15.7),(124089,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124089,36.48,0.46,198,55816,70,NULL,NULL,'2MASX J14480957+0604129',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.00017,NULL,'15.9g',0.45,NULL,NULL,NULL,NULL,NULL,1,222.0397917,6.07028,0.109,NULL,59333269789,927082340,14485661,15.9),(124090,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124090,37.93,0.15,385,55817,70,NULL,NULL,'SDSS J144810.31+325525.1',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000177,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,222.043,32.92364,0,NULL,60121467087,939397923,14678092,17.4),(124091,'IRAS','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124091,33.88,0.8,59.8,55818,75,NULL,'MAT, I','ESO 327- G 020',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000013,NULL,'15',1.6,'SBc            HII',NULL,NULL,NULL,'H_alpha Emission-Line Galaxy',1,222.047167,-37.82578,0.301,NULL,47217344335,737771005,11527671,15),(124092,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124092,32.51,0.43,31.7,55818,75,NULL,'MAT, I, raw','ESO 327- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124093,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124093,32.64,0.43,33.7,55818,75,NULL,'MAT, I, inv','ESO 327- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124094,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124094,32.76,0.43,35.7,55818,75,NULL,'MAT, I, cor','ESO 327- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124095,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124095,32.82,0.32,36.6,55818,85,NULL,'I, raw','ESO 327- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124096,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124096,32.85,0.32,37.2,55818,85,NULL,'I, inv','ESO 327- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124097,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124097,37.28,0.46,286,55819,70,NULL,NULL,'2MASX J14481182+1951081',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,222.049375,19.85217,0.085,NULL,59533287302,930207614,14534493,17.2),(124098,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124098,37.86,0.46,372,55820,70,NULL,NULL,'SDSS J144813.15+073110.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.0547917,7.51947,0.053,NULL,59382221916,927847217,14497612,18),(124099,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124099,36.98,0.15,249,55821,70,NULL,NULL,'2MASX J14481476+1123169',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,222.061583,11.38789,0.021,NULL,59367612184,927618940,14494045,17.7),(124100,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124100,35.99,0.46,157,55822,70,NULL,NULL,'2MASX J14481584+2617048',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000097,NULL,'15.97',0.28,NULL,NULL,NULL,NULL,NULL,1,222.066208333,26.28467,0.061,NULL,60015327880,937739498,14652179,15.97),(124101,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124101,35.09,0.72,104,55823,70,NULL,NULL,'2MASX J14481687-1346124',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.11',NULL,NULL,NULL,NULL,NULL,NULL,1,222.0702917,-13.77025,0.313,NULL,46685770127,729465158,11397893,16.11),(124102,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124102,37.43,0.46,306,55824,70,NULL,NULL,'2MASX J14481712+1345265',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',NULL,NULL,'15.7g',0.41,NULL,NULL,NULL,NULL,NULL,1,222.071333,13.75725,0.017,NULL,59549728894,930464513,14538508,15.7),(124103,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124103,36.49,0.33,199,55825,70,NULL,NULL,'2MASX J14481906+1829351',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.24',0.22,NULL,NULL,NULL,NULL,NULL,1,222.079625,18.493,0.049,NULL,59585008693,931015760,14547121,17.24),(124104,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124104,37.3,0.46,288,55826,70,NULL,NULL,'2MASX J14481916+1017089',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,222.0799583,10.28589,0.025,NULL,59368904876,927639138,14494361,17.5),(124105,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124105,37.54,0.33,322,55827,70,NULL,NULL,'SDSS J144820.16+494348.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,222.0840417,49.73025,0.017,NULL,59935228207,936487940,14632624,18.1),(124106,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124106,35.15,0.49,107,55828,75,NULL,'IR','UGC 09533',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000033,NULL,'15.35',0.2,'S?','Pair member (points to parent)',NULL,NULL,NULL,1,222.086875,13.95775,0.017,NULL,59547874539,930435539,14538055,15.35),(124107,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124107,35.58,0.2,131,55829,74.4,NULL,NULL,'UGC 09533',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000033,NULL,'15.35',0.2,'S?','Pair member (points to parent)',NULL,NULL,NULL,1,222.086875,13.95775,0.017,NULL,59547874539,930435539,14538055,15.35),(124108,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124108,36.49,0.33,199,55830,70,NULL,NULL,'SDSS J144821.14+182200.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.63',0.14,NULL,NULL,NULL,NULL,NULL,1,222.088125,18.36669,0.041,NULL,59584982833,931015356,14547114,18.63),(124109,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124109,38.09,0.33,414,55831,70,NULL,NULL,'2MASX J14482137+5727267',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.2g',0.25,'AGN',NULL,NULL,NULL,NULL,1,222.089,57.45753,0.013,NULL,57727393428,901990522,14093601,17.2),(124110,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124110,35.58,0.69,131,55832,70,NULL,NULL,'2MASX J14482257-4347345',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,222.0939583,-43.79292,0.665,NULL,47094707377,735854802,11497731,15.3),(124111,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124111,37.5,0.33,316,55833,70,NULL,NULL,'2MASX J14482399+1053439',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,222.099917,10.89564,0.025,NULL,59369346829,927646044,14494469,17.7),(124112,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124112,36.04,0.46,161,55834,70,NULL,NULL,'2MASX J14482435+3318272',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,222.1015417,33.30769,0,NULL,60124986193,939452909,14678951,16.8),(124113,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124113,38.59,0.46,522,55835,70,NULL,NULL,'SDSS J144824.60+365018.6',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.8g',0.29,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.1025,36.83853,0,NULL,60072957213,938639956,14666249,16.8),(124114,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124114,37.28,0.46,285,55836,70,NULL,NULL,'2MASX J14482505+0825569',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.73',0.16,NULL,NULL,NULL,NULL,NULL,1,222.104417,8.4325,0.053,NULL,59363629940,927556717,14493073,18.73),(124115,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124115,37.61,0.46,332,55837,70,NULL,NULL,'2MASX J14482623+0232161',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000097,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,222.10925,2.53781,0.101,NULL,58266002746,910406292,14225098,17.2),(124116,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124116,35.03,0.47,101,55838,NULL,NULL,'H','UGC 09537',NULL,'2007A&A...465...71T',2007,1,1.42,NULL,'G',0.00003,NULL,'14.3g',0.53,'Sb',NULL,NULL,NULL,NULL,1,222.1114583,34.99806,0,NULL,60124084973,939438827,14678731,14.3),(124117,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124117,35.1,0.49,105,55838,75,NULL,'IR','UGC 09537',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124118,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124118,35.1,0.45,105,55838,NULL,NULL,'Malmquist cor.','UGC 09537',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124119,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124119,35.13,0.45,106,55838,NULL,NULL,'K','UGC 09537',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124120,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124120,35.13,0.2,106,55838,74.4,NULL,NULL,'UGC 09537',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124121,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124121,35.15,0.46,107,55838,NULL,NULL,'J','UGC 09537',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124122,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124122,35.17,0.44,108,55838,NULL,NULL,NULL,'UGC 09537',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124123,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124123,35.43,0.4,122,55838,NULL,NULL,'mean','UGC 09537',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124124,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124124,35.79,0.46,144,55839,70,NULL,NULL,'2MASX J14482692+2254431',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000159,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,222.112167,22.91203,0.05,NULL,59494709789,929604840,14525075,16.5),(124125,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124125,37.98,0.33,394,55840,70,NULL,NULL,'SDSS J144827.32+040152.9',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000083,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,222.113875,4.03136,0.093,NULL,58257203869,910268810,14222950,17.8),(124126,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124126,36.98,0.15,249,55841,70,NULL,NULL,'SDSS J144828.06+112039.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000156,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,222.116917,11.34417,0.021,NULL,59369480435,927648131,14494502,18.1),(124127,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124127,38.34,0.46,465,55842,70,NULL,NULL,'2MASX J14482804+3106052',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,222.117,31.1015,0,NULL,60091364333,938927567,14670743,17.9),(124128,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124128,36.34,0.61,185,55843,70,NULL,NULL,'2MASX J14482828-3610473',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,222.117833333,-36.17989,0.257,NULL,47228952566,737952383,11530505,14.8),(124129,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124129,37.18,0.27,273,55844,70,NULL,NULL,'2MASX J14482920+1957591',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.47',0.14,NULL,NULL,NULL,NULL,NULL,1,222.1217917,19.96656,0.085,NULL,59533280063,930207500,14534492,18.47),(124130,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124130,37.18,0.27,273,55845,70,NULL,NULL,'2MASX J14482985+1951271',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.96',0.21,NULL,NULL,NULL,NULL,NULL,1,222.1245,19.85769,0.085,NULL,59533291840,930207685,14534495,17.96),(124131,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124131,36.42,0.54,193,55846,70,NULL,NULL,'2MASX J14482985-3945163',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,222.1245417,-39.75456,0.105,NULL,47218908724,737795448,11528053,14.4),(124132,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124132,39.27,0.46,714,55847,70,NULL,NULL,'SDSS J144830.74+244829.2',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'18.0g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.128125,24.80814,0.076,NULL,59493732541,929589570,14524837,18),(124133,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124133,37.62,0.27,334,55848,70,NULL,NULL,'2MASX J14483097+5524398',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,222.12925,55.41103,0,NULL,57247854182,894497721,13976526,17.3),(124134,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124134,36.98,0.15,249,55849,70,NULL,NULL,'2MASX J14483270+1120253',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000191,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,222.136291667,11.3405,0.021,NULL,59369513082,927648641,14494510,16.8),(124135,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124135,36.98,0.15,249,55850,70,NULL,NULL,'2MASX J14483277+1121033',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.87',0.16,NULL,NULL,NULL,NULL,NULL,1,222.136583333,11.351,0.021,NULL,59369513211,927648643,14494510,18.87),(124136,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124136,37.55,0.46,324,55851,70,NULL,NULL,'2MASX J14483282+2227181',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000164,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,222.136666667,22.45492,0.071,NULL,59505746440,929777288,14527770,16.9),(124137,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124137,37.34,0.33,294,55852,70,NULL,NULL,'2MASX J14483328+1507324',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.25',0.17,NULL,NULL,NULL,NULL,NULL,1,222.1385417,15.12578,0,NULL,59555098411,930548412,14539818,18.25),(124138,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124138,34.92,0.46,96.5,55853,70,NULL,NULL,'CGCG 076-061',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000127,NULL,'15.6g',0.41,NULL,NULL,NULL,NULL,NULL,1,222.1422917,11.81603,0.041,NULL,59367921335,927623770,14494121,15.6),(124139,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124139,36.98,0.15,249,55854,70,NULL,NULL,'SDSS J144836.22+111939.8',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',NULL,NULL,'17.1g',0.37,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.150917,11.32775,0.009,NULL,59369513466,927648647,14494510,17.1),(124140,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124140,35.73,0.22,140,55855,70,NULL,NULL,'UGC 09534',NULL,'2001MNRAS.321..277C',2001,1,1,NULL,'G',0.000107,NULL,'14.00',0.7,'E?',NULL,NULL,NULL,NULL,1,222.152083,11.32567,0.009,NULL,59369513471,927648647,14494510,14),(124141,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124141,36.3,0.25,182,55855,74.4,NULL,NULL,'UGC 09534',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124142,'SNIa','2016-12-15 15:15:29','2016-12-16 11:20:42','1','SN 2006cz',NULL,124142,35.19,0.19,105,55856,74.2,NULL,'SALT 2','MCG -01-38-002',0.0425,'2010ApJ...716..712A',2010,1,1.6,NULL,'G',0.000213,NULL,'15.30',1.4,'SA(s)cd:',NULL,NULL,NULL,NULL,1,222.1525,-4.73619,0.193,NULL,46446980736,725734074,11339594,15.3),(124143,'SNIa','2016-12-15 15:15:29','2016-12-16 11:20:42','1','SN 2006cz',NULL,124143,35.77,0.1,143,55856,74.4,NULL,NULL,'MCG -01-38-002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124144,'SNIa','2016-12-15 15:15:29','2016-12-16 11:20:42','1','SN 2006cz',NULL,124144,36.01,0.25,153,55856,73.8,NULL,'SALT 2 (SNANA)','MCG -01-38-002',0.0425,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124145,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124145,37.5,0.33,316,55857,70,NULL,NULL,'2MASX J14483849+1055363',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'QSO',0.001237,NULL,'17.2g',NULL,NULL,NULL,NULL,NULL,NULL,1,222.1602917,10.92675,0.013,NULL,59369565749,927649464,14494522,17.2),(124146,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124146,36.27,0.46,180,55858,70,NULL,NULL,'2MASX J14483856+2302311',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.59',0.23,NULL,NULL,NULL,NULL,NULL,1,222.16075,23.04194,0.093,NULL,59494756278,929605566,14525086,16.59),(124147,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124147,38.24,0.46,445,55859,70,NULL,NULL,'2MASX J14483906+1801461',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,222.162875,18.02944,0.041,NULL,59584938962,931014671,14547104,17.8),(124148,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124148,37.34,0.33,294,55860,70,NULL,NULL,'2MASX J14484033+1503484',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.92',0.2,NULL,NULL,NULL,NULL,NULL,1,222.167958333,15.06347,0,NULL,59555104650,930548510,14539820,17.92),(124149,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124149,36.85,0.46,235,55861,70,NULL,NULL,'2MASX J14484069+1010333',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,222.169583,10.17597,0.029,NULL,59368874764,927638668,14494354,17.1),(124150,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124150,37.32,0.46,290,55862,70,NULL,NULL,'2MASX J14484133+5829089',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000084,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,222.1724583,58.48586,0,NULL,57725272530,901957383,14093084,16.9),(124151,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124151,37.85,0.46,372,55863,70,NULL,NULL,'2MASX J14484151+2955236',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00016,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,222.1729583,29.92333,0,NULL,60089557387,938899334,14670302,17.2),(124152,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124152,29.05,0.69,6.45,55864,100,NULL,'mid-IR','NGC 5762',NULL,'2013ApJ...771...88L',2013,1,1.37,'RC3 has V = 837 +- 9 km/sec.','G',0.000003,NULL,'14.0g',0.85,'Sa             HII',NULL,NULL,NULL,NULL,1,222.177375,12.45722,0.025,NULL,59549116361,930454943,14538358,14),(124153,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124153,32.84,0.4,37,55864,NULL,NULL,'mean','NGC 5762',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124154,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124154,33.34,0.47,46.6,55864,NULL,NULL,'H','NGC 5762',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124155,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124155,33.4,0.46,47.8,55864,NULL,NULL,'J','NGC 5762',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124156,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124156,35.17,0.2,108,55865,74.4,NULL,NULL,'KUG 1446+089',NULL,'2013AJ....146...86T',2013,1,0.72,NULL,'G',0.000127,NULL,'15.8g',0.42,'Spiral',NULL,NULL,NULL,NULL,1,222.17775,8.77469,0.045,NULL,59363207753,927550121,14492970,15.8),(124157,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124157,37.24,0.33,281,55866,70,NULL,NULL,'2MASX J14484305+1903431',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.97',0.21,NULL,NULL,NULL,NULL,NULL,1,222.1795,19.06211,0.041,NULL,59530279428,930160616,14533759,17.97),(124158,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124158,37.3,0.46,289,55867,70,NULL,NULL,'2MASXi J1448437+293833',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,222.182583,29.64272,0,NULL,60088800502,938887507,14670117,17.4),(124159,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124159,38.22,0.46,440,55868,70,NULL,NULL,'2MASX J14484405+0711583',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,222.183666667,7.19956,0.065,NULL,59382280370,927848130,14497627,17.4),(124160,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124160,37.98,0.46,395,55869,70,NULL,NULL,'2MASXi J1448448+241548',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.186708333,24.26344,0.078,NULL,59495294621,929613978,14525218,17.6),(124161,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124161,36.79,0.46,228,55870,70,NULL,NULL,'LCRS B144610.8-024439',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00014,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,222.194875,-2.95142,0.189,NULL,43501033682,679703651,10620369,17.3),(124162,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124162,38.12,0.33,422,55871,70,NULL,NULL,'2MASX J14484686+3027446',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000182,NULL,'17.96',0.18,NULL,NULL,NULL,NULL,NULL,1,222.195375,30.46242,0,NULL,60089337039,938895891,14670248,17.96),(124163,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124163,31.19,NULL,17.3,55872,72,NULL,NULL,'MCG -01-38-003',NULL,'2014Ap.....57..457K',2014,1,1.4,'HOLM 678B is a star.','G',0.000017,NULL,'15.38',1,'SB(s)m:',NULL,NULL,NULL,NULL,1,222.2000417,-3.71639,0.201,NULL,43496838305,679638098,10619345,15.38),(124164,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124164,35.59,0.46,131,55873,70,NULL,NULL,'2MASX J14484950+6207152',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000184,NULL,'15.2g',0.59,'E0',NULL,NULL,NULL,NULL,1,222.2065,62.12081,0.041,NULL,57765916518,902592445,14103006,15.2),(124165,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124165,37.97,0.46,393,55874,70,NULL,NULL,'SDSS J144850.46+103234.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,222.21025,10.543,0.025,NULL,59369049328,927641395,14494396,18.1),(124166,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124166,36.8,0.38,229,55875,NULL,NULL,'Malmquist cor.','2MASX J14485104+1649554',NULL,'2009ApJS..182..474S',2009,1,0.83,NULL,'G',0.000023,NULL,'15.9g',0.23,'Sb',NULL,NULL,NULL,NULL,1,222.212625,16.83206,0.013,NULL,59586062603,931032228,14547378,15.9),(124167,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124167,37.06,0.33,258,55875,NULL,NULL,NULL,'2MASX J14485104+1649554',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124168,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124168,37.1,0.2,263,55875,74.4,NULL,NULL,'2MASX J14485104+1649554',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124169,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124169,37.03,0.74,255,55876,70,NULL,NULL,'2MASX J14485106-2648545',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,222.2127083,-26.81519,0.673,NULL,47012991620,734577994,11477781,15.7),(124170,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124170,35.79,0.33,144,55877,70,NULL,NULL,'2MASX J14485193+3140576',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000073,NULL,'15.6g',0.4,'AGN',NULL,NULL,NULL,NULL,1,222.2162917,31.68272,0,NULL,60091576958,938930889,14670795,15.6),(124171,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124171,38.6,0.46,525,55878,70,NULL,NULL,'2MASXi J1448532+243156',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.9g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.2217083,24.53228,0.076,NULL,59495753524,929621148,14525330,17.9),(124172,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124172,37.84,0.46,370,55879,70,NULL,NULL,'2MASX J14485391+3058227',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,222.224666667,30.97286,0,NULL,60091394112,938928033,14670750,17.8),(124173,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124173,35.85,0.73,148,55880,70,NULL,NULL,'LCRS B144616.3-061538',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'16.42',0.26,NULL,NULL,NULL,NULL,NULL,1,222.2294583,-6.46781,0.217,NULL,46498780816,726543450,11352241,16.42),(124174,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124174,36.93,0.46,243,55881,70,NULL,NULL,'2MASX J14485524+1514504',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.23',0.28,NULL,NULL,NULL,NULL,NULL,1,222.230083,15.24725,0.009,NULL,59555178461,930549663,14539838,17.23),(124175,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124175,35.64,0.51,134,55882,70,NULL,NULL,'2MASX J14485543-1125097',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.98',NULL,NULL,NULL,NULL,NULL,NULL,1,222.231,-11.41961,0.297,NULL,46463532643,725992697,11343635,15.98),(124176,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124176,36.79,0.46,228,55883,70,NULL,NULL,'2MASX J14485571+3248367',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000164,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,222.232208333,32.81031,0,NULL,60121431317,939397364,14678083,16.8),(124177,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124177,38.09,0.33,414,55884,70,NULL,NULL,'SDSS J144856.50+572710.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000145,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,222.2354583,57.45281,0.013,NULL,57727396052,901990563,14093602,18.7),(124178,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124178,35.87,0.46,150,55885,70,NULL,NULL,'SDSS J144856.99+160913.0',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',NULL,NULL,'15.3g',0.58,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.2374583,16.15361,0.005,NULL,59552945853,930514778,14539293,15.3),(124179,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124179,35.38,0.58,119,55886,70,NULL,NULL,'2MASX J14485745-4131538',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,222.2395,-41.53156,0.353,NULL,47089414783,735772105,11496439,13.9),(124180,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124180,35.28,0.55,114,55887,NULL,NULL,'Malmquist cor.','ESO 448- G 003',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000123,NULL,'17.0R',0.3,'Sc:            HII',NULL,NULL,NULL,NULL,1,222.243833333,-29.47153,0.373,NULL,47200833396,737513021,11523640,17),(124181,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124181,35.59,0.47,131,55887,NULL,NULL,NULL,'ESO 448- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124182,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124182,35.63,0.2,134,55887,74.4,NULL,NULL,'ESO 448- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124183,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124183,37.93,0.46,386,55888,70,NULL,NULL,'2MASX J14485861+3036167',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,222.244167,30.60464,0,NULL,60089356994,938896203,14670253,17.6),(124184,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124184,36.04,0.46,162,55889,70,NULL,NULL,'NGC 5763',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.00017,NULL,'15.2g',0.56,NULL,NULL,NULL,NULL,NULL,1,222.244667,12.49014,0.025,NULL,59549119273,930454988,14538359,15.2),(124185,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124185,36.28,0.46,181,55890,70,NULL,NULL,'2MASX J14485936+0930168',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000186,NULL,'16.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,222.247375,9.50478,0.017,NULL,59370631834,927666122,14494783,16),(124186,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124186,36.21,0.46,175,55891,70,NULL,NULL,'SDSS J144859.42+172331.0',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.3g',0.28,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.247625,17.39197,0.013,NULL,59588203056,931065672,14547901,16.3),(124187,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124187,37.23,0.33,279,55892,70,NULL,NULL,'2MASX J14490056+1622378',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.32',0.18,NULL,NULL,NULL,NULL,NULL,1,222.2524583,16.37706,0.005,NULL,59586186759,931034168,14547408,18.32),(124188,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124188,38.53,0.46,509,55893,70,NULL,NULL,'SDSS J144900.71+433412.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,222.252958333,43.57011,0.013,NULL,59950274616,936723040,14636297,18.2),(124189,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124189,35.33,0.75,116,55894,70,NULL,NULL,'ESO 580- G 037',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000023,NULL,'14.72',0.7,'SAB(rs)c',NULL,NULL,NULL,NULL,1,222.253875,-20.84744,0.337,NULL,46650719215,728917487,11389335,14.72),(124190,'IRAS','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124190,34.53,0.8,80.7,55894,75,NULL,'MAT, I','ESO 580- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124191,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124191,33.79,0.32,57.3,55894,85,NULL,'I, raw','ESO 580- G 037',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124192,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124192,33.83,0.32,58.3,55894,85,NULL,'I, inv','ESO 580- G 037',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124193,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124193,33.93,0.43,61,55894,75,NULL,'MAT, I, raw','ESO 580- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124194,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124194,34.11,0.43,66.2,55894,75,NULL,'MAT, I, inv','ESO 580- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124195,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124195,34.13,0.43,66.9,55894,75,NULL,'MAT, I, cor','ESO 580- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124196,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124196,34.4,0.2,75.9,55894,74.4,NULL,NULL,'ESO 580- G 037',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124197,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124197,34.49,0.44,79.1,55894,NULL,NULL,NULL,'ESO 580- G 037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124198,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124198,34.7,0.4,87.3,55894,NULL,NULL,'Malmquist cor.','ESO 580- G 037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124199,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124199,36.43,0.46,193,55895,70,NULL,NULL,'2MASX J14490100-0038516',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000097,NULL,'16.4g',0.22,'S0',NULL,NULL,NULL,NULL,1,222.2542083,-0.64772,0.133,NULL,43501414479,679709601,10620462,16.4),(124200,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124200,33.96,0.49,61.9,55896,75,NULL,'IR','UGC 09542',NULL,'2011yCatp016004901K',2011,1,1.72,NULL,'G',0.000095,NULL,'14.5g',0.49,'Sd',NULL,NULL,NULL,NULL,1,222.254958333,42.46392,0.017,NULL,59951052111,936735189,14636487,14.5),(124201,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124201,33.97,0.44,62.2,55896,NULL,NULL,NULL,'UGC 09542',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124202,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124202,33.97,0.2,62.2,55896,74.4,NULL,NULL,'UGC 09542',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124203,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124203,34.09,0.42,65.7,55896,NULL,NULL,'Malmquist cor.','UGC 09542',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124204,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124204,37.41,0.46,303,55897,70,NULL,NULL,'2MASX J14490224+2423027',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.89',0.1,NULL,NULL,NULL,NULL,NULL,1,222.259333,24.38397,0.078,NULL,59496019784,929625309,14525395,18.89),(124205,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124205,37.19,0.46,275,55898,70,NULL,NULL,'2MASX J14490303+1842219',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,222.2627917,18.70606,0.053,NULL,59584838072,931013094,14547079,17),(124206,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124206,37.94,0.46,388,55899,70,NULL,NULL,'2MASXi J1449036+244555',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.9g',NULL,NULL,NULL,NULL,NULL,NULL,1,222.265,24.76542,0.069,NULL,59493743136,929589736,14524839,17.9),(124207,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124207,36.45,0.46,195,55900,70,NULL,NULL,'2MASX J14490373+6137023',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000177,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,222.2655,61.6175,0.021,NULL,57778792871,902793638,14106150,16.2),(124208,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124208,35.93,0.58,153,55901,70,NULL,NULL,'2MASX J14490405-4126518',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,222.267,-41.44772,0.353,NULL,47089406911,735771982,11496437,15.6),(124209,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124209,37.24,0.33,281,55902,70,NULL,NULL,'2MASX J14490463+1911129',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.24',0.17,NULL,NULL,NULL,NULL,NULL,1,222.269167,19.18703,0.037,NULL,59530262645,930160353,14533755,18.24),(124210,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124210,35.43,NULL,122,55903,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1813',NULL,'2010Ap&SS.325..163P',2010,1,0.86,NULL,'G',0.000027,NULL,'16.00',0.09,'Sc',NULL,NULL,NULL,NULL,1,222.270541667,17.18142,0.013,NULL,59586005391,931031334,14547364,16),(124211,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124211,35.45,NULL,123,55903,NULL,NULL,'Dipole + Quadrupole','FGC 1813',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124212,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124212,35.47,NULL,124,55903,NULL,NULL,'Dipole','FGC 1813',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124213,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124213,36.18,0.43,172,55903,NULL,NULL,NULL,'FGC 1813',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124214,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124214,36.18,0.43,172,55903,NULL,NULL,'Malmquist cor.','FGC 1813',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124215,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124215,36.22,0.2,175,55903,74.4,NULL,NULL,'FGC 1813',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124216,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124216,38.54,0.46,510,55904,70,NULL,NULL,'2MASX J14490494+1537348',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.73',0.16,NULL,NULL,NULL,NULL,NULL,1,222.270583333,15.62631,0.029,NULL,59552860832,930513450,14539272,18.73),(124217,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124217,38.96,0.46,618,55905,70,NULL,NULL,'2MASX J14490498+4036013',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000173,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,222.270667,40.60036,0.02,NULL,59952622484,936759726,14636870,18.1),(124218,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124218,37.41,0.46,304,55906,70,NULL,NULL,'2MASX J14490601+5609458',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000176,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,222.275167,56.16272,0.009,NULL,57245520683,894461260,13975957,17.6),(124219,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124219,37.43,0.46,307,55907,70,NULL,NULL,'2MASX J14490646+4903243',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000196,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,222.276791667,49.05667,0.017,NULL,59935760728,936496261,14632754,17.1),(124220,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124220,36.97,0.46,248,55908,70,NULL,NULL,'SDSS J144907.15+054929.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00014,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,222.2797917,5.82497,0.109,NULL,59333405927,927084467,14485694,17.9),(124221,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124221,36.07,0.46,164,55909,70,NULL,NULL,'SBS 1447+589',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000079,NULL,'16.0g',0.41,'E0',NULL,NULL,NULL,NULL,1,222.280166667,58.72786,0.009,NULL,57724766909,901949482,14092960,16),(124222,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124222,35.45,0.46,123,55910,70,NULL,NULL,'CGCG 076-065',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000047,NULL,'15.1g',0.56,'E/S0',NULL,NULL,NULL,NULL,1,222.281625,10.97992,0.013,NULL,59369576543,927649633,14494525,15.1),(124223,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124223,35.51,0.25,126,55910,74.4,NULL,NULL,'CGCG 076-065',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124224,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124224,35.73,0.22,140,55910,70,NULL,NULL,'CGCG 076-065',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124225,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124225,37.65,0.46,338,55911,70,NULL,NULL,'2MASX J14490793+2631247',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.47',0.14,NULL,NULL,NULL,NULL,NULL,1,222.283167,26.52356,0.058,NULL,60016199528,937753117,14652392,18.47),(124226,'D-Sigma','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124226,32.75,0.4,35.5,55912,75,NULL,'Edat, raw','NGC 5761',NULL,'1997ApJS..109..333W',1997,1,1.3,'NGC identification is not certain.','G',0.00006,NULL,'13.35',1,'S0^0^ pec:',NULL,NULL,NULL,NULL,1,222.285333,-20.37603,0.373,NULL,46652824163,728950377,11389849,13.35),(124227,'D-Sigma','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124227,32.86,0.4,37.3,55912,75,NULL,'Edat, cor','NGC 5761',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124228,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124228,33.49,0.45,49.8,55912,NULL,NULL,'K','NGC 5761',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124229,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124229,33.69,0.4,54.6,55912,NULL,NULL,'mean','NGC 5761',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124230,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124230,36.41,0.46,191,55913,70,NULL,NULL,'2MASX J14490979-0217296',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.00015,NULL,'15.5g',0.55,'E0',NULL,NULL,NULL,NULL,1,222.290833,-2.29153,0.237,NULL,43500520049,679695625,10620244,15.5),(124231,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124231,38.27,0.46,450,55914,70,NULL,NULL,'SDSS J144910.26+625106.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,222.292791667,62.85192,0.041,NULL,57759028098,902484814,14101325,17.9),(124232,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124232,37.63,0.46,335,55915,70,NULL,NULL,'SDSS J144910.72+174727.4',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.6g',0.32,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.294667,17.79097,0.045,NULL,59588136965,931064640,14547885,16.6),(124233,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124233,36.76,0.2,225,55916,74.4,NULL,NULL,'CGCG 076-066',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.000177,NULL,'15.4g',0.57,NULL,NULL,NULL,NULL,NULL,1,222.29625,11.11522,0.005,NULL,59369526794,927648856,14494513,15.4),(124234,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124234,35.51,0.21,127,55917,70,NULL,NULL,'2MASX J14491203+1329238',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000083,NULL,'17.43',0.24,NULL,NULL,NULL,NULL,NULL,1,222.3002083,13.48992,0.029,NULL,59549767424,930465116,14538517,17.43),(124235,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124235,35.07,0.49,103,55918,75,NULL,'IR','UGC 09541',NULL,'2011yCatp016004901K',2011,1,1.79,NULL,'G',0.000033,NULL,'15.5g',0.2,'Sc',NULL,NULL,NULL,NULL,1,222.3005,29.74483,0,NULL,60088822848,938887857,14670122,15.5),(124236,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124236,35.39,NULL,120,55918,NULL,NULL,'Dipole + Quadrupole','UGC 09541',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124237,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124237,35.39,NULL,120,55918,NULL,NULL,'Dipole','UGC 09541',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124238,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124238,35.39,NULL,120,55918,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09541',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124239,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124239,35.42,NULL,121,55918,NULL,NULL,NULL,'UGC 09541',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124240,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124240,35.75,0.2,141,55918,74.4,NULL,NULL,'UGC 09541',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124241,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124241,35.43,0.32,122,55919,NULL,NULL,'Malmquist cor.','IC 1058',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000021,NULL,'14.8',0.25,'S',NULL,NULL,NULL,NULL,1,222.301625,17.02094,0.013,NULL,59586007714,931031370,14547365,14.8),(124242,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124242,35.51,0.3,127,55919,NULL,NULL,NULL,'IC 1058',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124243,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124243,35.56,0.49,130,55919,75,NULL,'IR','IC 1058',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124244,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124244,35.78,0.2,143,55919,74.4,NULL,NULL,'IC 1058',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124245,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124245,35.96,0.47,155,55919,NULL,NULL,'H','IC 1058',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124246,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124246,36.08,0.46,164,55919,NULL,NULL,'J','IC 1058',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124247,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124247,36.08,0.4,165,55919,NULL,NULL,'mean','IC 1058',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124248,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124248,36.1,0.45,166,55919,NULL,NULL,'K','IC 1058',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124249,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124249,37.18,0.27,273,55920,70,NULL,NULL,'SDSS J144912.43+195043.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.301833,19.84547,0.074,NULL,59533726442,930214475,14534601,17.8),(124250,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124250,35.85,0.33,148,55921,70,NULL,NULL,'2MASX J14491307+0716068',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,222.304333,7.26867,0.065,NULL,59382256046,927847750,14497621,16.5),(124251,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124251,38.12,0.33,422,55922,70,NULL,NULL,'2MASX J14491413+3033248',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.85',0.12,NULL,NULL,NULL,NULL,NULL,1,222.308833333,30.55697,0,NULL,60089459557,938897805,14670278,18.85),(124252,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124252,38.12,0.46,422,55923,70,NULL,NULL,'2MASX J14491521+1146008',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,222.313333,11.76694,0.021,NULL,59367943615,927624118,14494126,17.4),(124253,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124253,36.62,0.46,211,55924,70,NULL,NULL,'2MASX J14491563+0538595',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000155,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,222.3152083,5.64989,0.085,NULL,59333331522,927083305,14485676,16.7),(124254,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124254,36.43,0.7,193,55925,70,NULL,NULL,'2MASX J14491576-3617028',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,222.315667,-36.28417,0.257,NULL,47228917675,737951838,11530497,14.6),(124255,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124255,37.12,0.23,266,55926,70,NULL,NULL,'2MASX J14491671+3644133',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,222.319625,36.737,0,NULL,60072978872,938640294,14666254,17.5),(124256,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124256,38.1,0.33,416,55927,70,NULL,NULL,'2MASX J14491670+0446515',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000077,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,222.319666667,4.78103,0.109,NULL,59336529734,927133277,14486457,17.4),(124257,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124257,36.02,0.33,160,55928,70,NULL,NULL,'2MASX J14491705+2745303',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.75',0.17,NULL,NULL,NULL,NULL,NULL,1,222.321083333,27.7585,0.059,NULL,60014091846,937720185,14651877,17.75),(124258,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124258,37.71,0.46,348,55929,70,NULL,NULL,'2MASX J14491750+6140352',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000128,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,222.323041667,61.67639,0.021,NULL,57765105747,902579777,14102809,17.9),(124259,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124259,37.95,0.46,389,55930,70,NULL,NULL,'2MASX J14492078+0341183',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000097,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,222.336416667,3.68831,0.081,NULL,58256867031,910263547,14222867,17.1),(124260,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124260,37.92,0.46,384,55931,70,NULL,NULL,'2MASX J14492174+1828479',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,222.340583333,18.47994,0.049,NULL,59585035087,931016173,14547127,18.1),(124261,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124261,37.23,0.33,279,55932,70,NULL,NULL,'SDSS J144922.36+162557.0',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,'PHOT','16.7g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.343167,16.4325,0.005,NULL,59586198806,931034356,14547411,16.7),(124262,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124262,36.79,0.26,228,55933,70,NULL,NULL,'GIN 371',NULL,'2001MNRAS.321..277C',2001,1,0.31,NULL,'G',0.000077,NULL,'15.26',0.22,'S',NULL,NULL,NULL,NULL,1,222.343375,16.43217,0.005,NULL,59586198806,931034356,14547411,15.26),(124263,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124263,37.11,0.33,264,55934,70,NULL,NULL,'2MASX J14492245+1725119',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.53',0.15,NULL,NULL,NULL,NULL,NULL,1,222.343667,17.41992,0.013,NULL,59588039419,931063115,14547861,18.53),(124264,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124264,37.55,0.46,323,55935,70,NULL,NULL,'2MASX J14492245+1610359',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,222.343708333,16.17678,0,NULL,59585519844,931023747,14547246,16.5),(124265,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124265,38.1,0.33,416,55936,70,NULL,NULL,'SDSS J144922.52+044918.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000105,NULL,'17.7g',0.18,'AGN',NULL,NULL,NULL,NULL,1,222.343875,4.82189,0.105,NULL,59336547523,927133555,14486461,17.7),(124266,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124266,37.36,0.33,296,55937,70,NULL,NULL,'2MASX J14492252+2559353',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.50',0.15,NULL,NULL,NULL,NULL,NULL,1,222.3439583,25.99308,0.036,NULL,60015705873,937745404,14652271,18.5),(124267,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124267,38.25,0.46,447,55938,70,NULL,NULL,'SDSS J144924.73+084035.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.353083333,8.6765,0.045,NULL,59363221825,927550341,14492974,18.3),(124268,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124268,36.02,0.33,160,55939,70,NULL,NULL,'2MASX J14492496+2746223',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000073,NULL,'17.29',0.24,'AGN',NULL,NULL,NULL,NULL,1,222.354125,27.77292,0.059,NULL,60014088651,937720135,14651877,17.29),(124269,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124269,36.25,0.46,178,55940,70,NULL,NULL,'2MASX J14492661+0858158',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000083,NULL,'16.09',0.21,NULL,NULL,NULL,NULL,NULL,1,222.360875,8.97111,0.041,NULL,59363251824,927550809,14492981,16.09),(124270,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124270,37.89,0.46,378,55941,70,NULL,NULL,'2MASX J14492707+2159518',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,222.3627917,21.99772,0.065,NULL,59501469884,929710466,14526726,17.8),(124271,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124271,36.65,0.46,213,55942,70,NULL,NULL,'2MASX J14492757+1130287',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00017,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,222.365083,11.50789,0.009,NULL,59370190138,927659220,14494675,16.6),(124272,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124272,37.59,0.46,329,55943,70,NULL,NULL,'2MASX J14492785+4452532',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,222.366083,44.88139,0,NULL,59988912633,937326759,14645730,17.5),(124273,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124273,36.67,0.46,216,55944,70,NULL,NULL,'2MASX J14492811+2836083',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.0002,NULL,'16.82',0.34,NULL,NULL,NULL,NULL,NULL,1,222.3670417,28.60239,0.009,NULL,60013179137,937705924,14651655,16.82),(124274,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124274,37.12,0.23,266,55945,70,NULL,NULL,'2MASX J14492919+3650524',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,222.37175,36.84792,0,NULL,60072945915,938639779,14666246,16.7),(124275,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124275,37.4,0.46,302,55946,NULL,NULL,'Malmquist cor.','MCG +03-38-030',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000023,NULL,'15.5',0.3,'Sab',NULL,NULL,NULL,NULL,1,222.374125,16.55994,0.009,NULL,59586237082,931034954,14547421,15.5),(124276,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124276,37.5,0.44,317,55946,NULL,NULL,NULL,'MCG +03-38-030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124277,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124277,37.55,0.2,324,55946,74.4,NULL,NULL,'MCG +03-38-030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124278,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124278,31.44,0.49,19.4,55947,75,NULL,'IR','ARP 261 NED01',NULL,'2011yCatp016004901K',2011,1,3,NULL,'G',0.000007,NULL,'13.35',2,'IB(s)m pec','in a triple',NULL,NULL,NULL,1,222.377417,-10.17331,0.317,NULL,46461755777,725964934,11343202,13.35),(124279,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124279,32.3,0.4,28.8,55947,75,NULL,'B','ARP 261 NED01',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124280,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124280,38.02,0.69,401,55948,70,NULL,NULL,'2MASX J14493213-2310215',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,222.383917,-23.17272,0.417,NULL,46525203258,726956300,11358692,16.2),(124281,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124281,37.66,0.46,340,55949,70,NULL,NULL,'2MASX J14493276+3117430',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,222.3865,31.29528,0,NULL,60091638205,938931846,14670810,17.8),(124282,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124282,35.42,0.62,121,55950,NULL,NULL,'Malmquist cor.','CGCG 105-039',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000023,NULL,'15.7',0.21,'Sa',NULL,NULL,NULL,NULL,1,222.38875,17.2,0.013,NULL,59588058467,931063413,14547865,15.7),(124283,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124283,35.55,0.59,129,55950,NULL,NULL,NULL,'CGCG 105-039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124284,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124284,35.59,0.2,131,55950,74.4,NULL,NULL,'CGCG 105-039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124285,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124285,37.88,0.21,376,55951,70,NULL,NULL,'2MASX J14493368+3345070',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,222.390416667,33.75189,0,NULL,60125316423,939458069,14679032,17.8),(124286,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124286,38.85,0.46,589,55952,70,NULL,NULL,'2MASX J14493457+2329438',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,222.3939583,23.49569,0.055,NULL,59494825661,929606650,14525103,17.9),(124287,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124287,36.31,0.25,183,55953,74.4,NULL,NULL,'CGCG 076-068',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'GTrpl',0.000097,NULL,NULL,NULL,'DB',NULL,NULL,NULL,NULL,1,222.394125,11.24808,0.009,NULL,59369504249,927648503,14494507,NULL),(124288,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124288,37.12,0.23,266,55954,70,NULL,NULL,'2MASX J14493479+3645124',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,222.3947917,36.75342,0,NULL,60072977352,938640271,14666254,17.2),(124289,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124289,37.12,0.23,266,55955,70,NULL,NULL,'2MASX J14493480+3642454',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000174,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,222.394833,36.71278,0,NULL,60072924142,938639439,14666241,16.5),(124290,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124290,35.73,0.22,140,55956,70,NULL,NULL,'SDSS J144934.93+111455.1',NULL,'2001MNRAS.321..277C',2001,1,0.47,NULL,'G',NULL,'PHOT','16.0g',0.4,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.395583333,11.24867,0.009,NULL,59369504220,927648503,14494507,16),(124291,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124291,36.51,0.46,201,55957,70,NULL,NULL,'2MASX J14493615+2208508',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000168,NULL,'15.8g',0.45,NULL,NULL,NULL,NULL,NULL,1,222.400791667,22.1475,0.072,NULL,59505704634,929776634,14527759,15.8),(124292,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124292,37.72,0.46,350,55958,70,NULL,NULL,'LCRS B144701.7-023859',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000166,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,222.406875,-2.85625,0.233,NULL,43500348061,679692938,10620202,17.5),(124293,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124293,38.4,0.46,478,55959,70,NULL,NULL,'SDSS J144937.88-013249.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000164,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,222.407875,-1.547,0.161,NULL,43502278841,679723106,10620673,18.3),(124294,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124294,37.93,0.33,385,55960,70,NULL,NULL,'SDSS J144938.44+472730.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000142,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,222.4102083,47.45847,0.017,NULL,59989341566,937333461,14645835,18.6),(124295,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124295,37.69,0.46,345,55961,70,NULL,NULL,'2MASX J14493915+4632503',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000193,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,222.41325,46.54739,0.025,NULL,59991015185,937359612,14646243,16.3),(124296,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124296,38.37,0.46,471,55962,70,NULL,NULL,'SDSS J144939.47+070656.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.4144583,7.11567,0.065,NULL,59382259958,927847811,14497622,18.5),(124297,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124297,33.84,NULL,58.7,55963,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09546',NULL,'2010Ap&SS.325..163P',2010,1,1.46,NULL,'G',0.000013,NULL,'17.01',0.1,'Sd',NULL,NULL,NULL,NULL,1,222.415333,23.56103,0.055,NULL,59494821175,929606580,14525102,17.01),(124298,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124298,33.86,NULL,59.1,55963,NULL,NULL,NULL,'UGC 09546',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124299,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124299,33.86,NULL,59.1,55963,NULL,NULL,'Dipole + Quadrupole','UGC 09546',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124300,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124300,33.86,NULL,59.3,55963,NULL,NULL,'Dipole','UGC 09546',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124301,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124301,34.33,0.2,73.5,55963,74.4,NULL,NULL,'UGC 09546',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124302,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124302,37.62,0.27,334,55964,70,NULL,NULL,'2MASX J14494036+5516303',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000172,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,222.418125,55.27517,0.005,NULL,57247335379,894489615,13976400,16.7),(124303,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124303,38.08,0.46,414,55965,70,NULL,NULL,'2MASX J14494065+2034257',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.65',0.15,NULL,NULL,NULL,NULL,NULL,1,222.419417,20.57389,0.081,NULL,59532244716,930191323,14534239,18.65),(124304,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124304,35.76,0.46,142,55966,70,NULL,NULL,'CGCG 193-003',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000073,NULL,'15.2g',0.45,'S0',NULL,NULL,NULL,NULL,1,222.4197917,35.69031,0,NULL,60123424593,939428509,14678570,15.2),(124305,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124305,37.58,0.46,329,55967,70,NULL,NULL,'2MASX J14494135+1850147',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.79',0.13,NULL,NULL,NULL,NULL,NULL,1,222.422375,18.83728,0.049,NULL,59530072957,930157389,14533709,18.79),(124306,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124306,37.76,0.46,356,55968,70,NULL,NULL,'2MASX J14494135+1334193',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,222.4224583,13.57206,0.029,NULL,59549880201,930466878,14538544,17.2),(124307,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124307,37.36,0.33,296,55969,70,NULL,NULL,'2MASX J14494148+3314410',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000191,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,222.4227083,33.24478,0,NULL,60125070850,939454232,14678972,16.9),(124308,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124308,38.1,0.46,417,55970,70,NULL,NULL,'2MASX J14494252+2828433',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,222.427333333,28.47858,0,NULL,60013389561,937709211,14651706,17.2),(124309,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124309,37.62,0.27,334,55971,70,NULL,NULL,'2MASX J14494259+5518283',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000165,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,222.4275,55.30778,0.025,NULL,57247793576,894496774,13976512,16.8),(124310,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124310,36.3,0.8,182,55972,70,NULL,NULL,'2MASX J14494262-4132261',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000103,NULL,'14.5I',0.4,NULL,NULL,NULL,NULL,NULL,1,222.4277083,-41.54072,0.345,NULL,47089224394,735769131,11496392,14.5),(124311,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124311,36.28,0.1,180,55973,70,NULL,NULL,'ABELL 1983b',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',0.000207,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,222.433333,16.89333,0.013,NULL,59586033097,931031767,14547371,NULL),(124312,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124312,38.02,0.46,402,55974,70,NULL,NULL,'LCRS B144709.8-022959',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,222.439833333,-2.70639,0.237,NULL,43500375959,679693374,10620208,17.9),(124313,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124313,37.72,0.46,351,55975,70,NULL,NULL,'2MASX J14494578+4907075',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000152,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,222.440667,49.11869,0.017,NULL,59935790973,936496733,14632761,18.3),(124314,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124314,37.5,0.46,317,55976,70,NULL,NULL,'2MASX J14494583+4941285',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000185,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,222.441,49.69117,0.005,NULL,59935282504,936488789,14632637,16.9),(124315,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124315,33.4,NULL,47.9,55977,NULL,NULL,'Dipole','UGC 09556',NULL,'2010Ap&SS.325..163P',2010,1,1.18,NULL,'G',0.000068,NULL,'15.3g',0.25,'Scd(f)','Isolated galaxy',NULL,NULL,NULL,1,222.4420417,60.39853,0.013,NULL,57771359482,902677491,14104335,15.3),(124316,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124316,33.41,NULL,48.1,55977,NULL,NULL,'Dipole + Quadrupole','UGC 09556',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124317,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124317,33.42,NULL,48.4,55977,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09556',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124318,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124318,33.71,0.4,55.2,55977,NULL,NULL,NULL,'UGC 09556',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124319,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124319,33.78,0.49,57,55977,75,NULL,'IR','UGC 09556',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124320,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124320,33.83,0.2,58.3,55977,74.4,NULL,NULL,'UGC 09556',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124321,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124321,33.92,0.49,60.9,55977,NULL,NULL,'Malmquist cor.','UGC 09556',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124322,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124322,34.05,0.46,64.6,55977,NULL,NULL,NULL,'UGC 09556',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124323,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124323,38.13,0.27,422,55978,70,NULL,NULL,'2MASX J14494760+3458029',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,222.4482917,34.96747,0,NULL,60124066699,939438542,14678727,17.5),(124324,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124324,35.85,0.33,148,55979,70,NULL,NULL,'2MASX J14494832+0723257',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',NULL,NULL,'15.7g',0.45,NULL,NULL,NULL,NULL,NULL,1,222.451417,7.39039,0.065,NULL,59382380616,927849697,14497651,15.7),(124325,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124325,38.13,0.27,422,55980,70,NULL,NULL,'2MASX J14494857+3501329',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,222.4522917,35.02569,0,NULL,60124060166,939438440,14678725,17.6),(124326,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124326,37.88,0.21,376,55981,70,NULL,NULL,'2MASX J14494890+3351269',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000182,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,222.45375,33.85744,0,NULL,60125323059,939458172,14679033,17),(124327,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124327,37.11,0.33,264,55982,70,NULL,NULL,'2MASX J14494934+1742234',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00009,NULL,'17.07',0.31,NULL,NULL,NULL,NULL,NULL,1,222.455583,17.70636,0.013,NULL,59588246163,931066346,14547911,17.07),(124328,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124328,37.53,0.46,320,55983,70,NULL,NULL,'2MASX J14494996+1602144',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.60',0.14,NULL,NULL,NULL,NULL,NULL,1,222.45825,16.03722,0.005,NULL,59585482646,931023166,14547236,18.6),(124329,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124329,37.85,0.46,372,55984,70,NULL,NULL,'2MASX J14495000+4853235',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000192,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,222.45825,48.88994,0.037,NULL,59935756427,936496194,14632753,17),(124330,'D-Sigma','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124330,32.75,0.4,35.5,55985,75,NULL,'Edat, raw','ESO 580- G 040',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.00015,NULL,'14.49',0.8,'SAB0^0^:',NULL,NULL,NULL,NULL,1,222.458375,-20.27825,0.373,NULL,46652844659,728950697,11389854,14.49),(124331,'D-Sigma','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124331,32.86,0.4,37.3,55985,75,NULL,'Edat, cor','ESO 580- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124332,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124332,33.59,0.48,52.3,55985,70,NULL,NULL,'ESO 580- G 040',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124333,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124333,36.62,0.46,211,55986,70,NULL,NULL,'2MASX J14495021+1644134',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00015,NULL,'17.96',0.4,'E/S0','Group member',NULL,NULL,NULL,1,222.459125,16.73706,0.013,NULL,59586216763,931034636,14547416,17.96),(124334,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124334,37.94,0.46,387,55987,70,NULL,NULL,'2MASXi J1449504+333013',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,222.460166667,33.50381,0,NULL,60125030345,939453599,14678962,18.3),(124335,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124335,38.04,0.46,406,55988,70,NULL,NULL,'SDSS J144950.58+241024.2',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.4607917,24.17342,0.098,NULL,59496030085,929625470,14525397,17.7),(124336,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124336,37.52,0.46,319,55989,70,NULL,NULL,'2MASX J14495068+6344153',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00009,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,222.4615,63.73775,0.017,NULL,57756515094,902445548,14100711,18),(124337,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124337,37.25,0.46,282,55990,70,NULL,NULL,'2MASX J14495165+2329026',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000178,NULL,'18.42',0.15,NULL,NULL,NULL,NULL,NULL,1,222.46525,23.48403,0.055,NULL,59494815597,929606493,14525101,18.42),(124338,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124338,36.36,0.64,187,55991,70,NULL,NULL,'2MASX J14495279-3123548',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.5I',0.4,NULL,NULL,NULL,NULL,NULL,1,222.470041667,-31.39856,0.433,NULL,47202692075,737542063,11524094,14.5),(124339,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124339,37.66,0.46,341,55992,70,NULL,NULL,'2MASX J14495419+4403342',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,222.475875,44.05953,0.013,NULL,59992200959,937378139,14646533,17.5),(124340,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124340,38.13,0.27,422,55993,70,NULL,NULL,'2MASX J14495469+3452450',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,222.477875,34.87897,0,NULL,60124062279,939438473,14678726,17.4),(124341,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124341,37.82,0.46,366,55994,70,NULL,NULL,'2MASX J14495601+0754117',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,222.4835417,7.90325,0.057,NULL,59381210999,927831421,14497365,17.8),(124342,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124342,37.06,0.46,258,55995,70,NULL,NULL,'SDSS J144956.19+034758.0',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00009,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,222.484167,3.79944,0.085,NULL,59333816191,927090877,14485794,16.8),(124343,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124343,37.71,0.46,349,55996,70,NULL,NULL,'SDSS J144956.60+041901.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000082,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,222.485875,4.31711,0.101,NULL,59334370339,927099536,14485930,17.9),(124344,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124344,36.86,0.46,236,55997,70,NULL,NULL,'2MASX J14495698+1054221',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000179,NULL,'16.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,222.487333,10.90614,0.005,NULL,59369454206,927647721,14494495,16.8),(124345,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124345,36.56,0.25,205,55998,74.4,NULL,NULL,'GIN 368',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.00005,NULL,'14.80',0.55,'E/S0','Group member',NULL,NULL,NULL,1,222.4874583,16.80847,0.013,NULL,59586134622,931033353,14547396,14.8),(124346,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124346,36.79,0.26,228,55998,70,NULL,NULL,'GIN 368',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124347,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124347,36.28,0.1,180,55998,70,NULL,'ABELL 1983b, BGC','GIN 368',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124348,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124348,35.52,0.33,127,55999,70,NULL,NULL,'CGCG 020-021',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000077,NULL,'15.2g',0.55,'E0',NULL,NULL,NULL,NULL,1,222.489083,0.55831,0.117,NULL,58252759293,910199363,14221865,15.2),(124349,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124349,37.77,0.33,358,56000,70,NULL,NULL,'2MASX J14495860+6232593',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000179,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,222.494333,62.54989,0.033,NULL,57765545852,902586653,14102916,17.6),(124350,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124350,37.45,0.46,309,56001,70,NULL,NULL,'2MASX J14495883+3133190',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,222.495167,31.55533,0,NULL,60091754853,938933669,14670838,17.4),(124351,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124351,36.56,0.25,205,56002,74.4,NULL,NULL,'GIN 367',NULL,'2013AJ....146...86T',2013,1,0.37,NULL,'G',0.00005,NULL,'17.42',0.22,'S0','Group member',NULL,NULL,NULL,1,222.4964583,16.80989,0.013,NULL,59586134698,931033354,14547396,17.42),(124352,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124352,36.79,0.26,228,56002,70,NULL,NULL,'GIN 367',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124353,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124353,36.49,0.09,198,56003,70,NULL,NULL,'SDSS J144959.10+164837.0',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'16.0g',0.32,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.4962917,16.81028,0.013,NULL,59586134698,931033354,14547396,16),(124354,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124354,36.89,0.46,238,56004,70,NULL,NULL,'2MASX J14495920+5510272',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000138,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,222.496875,55.17436,0.005,NULL,57244529419,894445772,13975715,17.8),(124355,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124355,36.18,0.2,172,56005,74.4,NULL,NULL,'2MASX J14495928+1644166',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.00005,NULL,'17.28',0.2,'Sc','Group member',NULL,NULL,NULL,1,222.49725,16.73772,0.013,NULL,59586350628,931036728,14547448,17.28),(124356,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124356,36.22,0.44,175,56005,NULL,NULL,'Malmquist cor.','2MASX J14495928+1644166',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124357,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124357,36.27,0.43,179,56005,NULL,NULL,NULL,'2MASX J14495928+1644166',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124358,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124358,37.89,0.46,378,56006,70,NULL,NULL,'SDSS J145000.08+341401.4',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000145,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,222.500333,34.23375,0,NULL,60125262492,939457226,14679019,18.6),(124359,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124359,36.68,0.33,216,56007,70,NULL,NULL,'2MASX J14500035+2944396',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000201,NULL,'16.6g',0.3,'S0',NULL,NULL,NULL,NULL,1,222.5015417,29.74425,0,NULL,60088858247,938888410,14670131,16.6),(124360,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124360,35.78,0.41,143,56008,NULL,NULL,'Malmquist cor.','CGCG 105-041',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000023,NULL,'15.40',0.5,'SBb','Group member',NULL,NULL,NULL,1,222.506708333,17.04653,0.013,NULL,59586041284,931031895,14547373,15.4),(124361,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124361,36.03,0.36,161,56008,NULL,NULL,NULL,'CGCG 105-041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124362,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124362,36.19,0.2,173,56008,74.4,NULL,NULL,'CGCG 105-041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124363,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124363,35.52,0.33,127,56009,70,NULL,NULL,'2MASX J14500215+0034436',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000084,NULL,'16.0g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,222.5090417,0.57878,0.117,NULL,58253500855,910210950,14222046,16),(124364,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124364,37.93,0.33,385,56010,70,NULL,NULL,'2MASX J14500229+4730321',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000151,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,222.5097917,47.50886,0.017,NULL,59989328565,937333258,14645832,17.5),(124365,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124365,37.99,0.46,396,56011,70,NULL,NULL,'2MASX J14500236+3250000',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00016,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,222.51,32.83336,0,NULL,60122735743,939417745,14678402,17.1),(124366,'GRB','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124366,42.08,NULL,2610,56012,65,NULL,'L = 10e57 photons/s','GRB 970402',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'SAX/WFC',NULL,NULL,NULL,NULL,1,222.5125,-69.335,NULL,NULL,45041427247,703772300,10996442,NULL),(124367,'GRB','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124367,43.17,NULL,4300,56012,65,NULL,'L = 2 x 10e58 photons/s','GRB 970402',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124368,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124368,33.77,NULL,56.7,56013,NULL,NULL,NULL,'FGC 1830',NULL,'2000BSAO...50....5K',2000,1,1,NULL,'G',0.00016,':','17.0',0.08,'Sd',NULL,NULL,NULL,NULL,1,222.514583,83.30403,0.185,NULL,56962730138,890042658,13906916,17),(124369,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124369,33.8,NULL,57.4,56013,NULL,NULL,'Dipole + Quadrupole','FGC 1830',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124370,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124370,33.8,NULL,57.4,56013,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1830',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124371,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124371,33.8,NULL,57.6,56013,NULL,NULL,'Dipole','FGC 1830',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124372,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124372,36.31,0.46,183,56014,70,NULL,NULL,'VII Zw 565 NOTES03',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,222.515083333,57.30456,0.017,NULL,57727453004,901991453,14093616,17),(124373,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124373,35.83,0.33,147,56015,70,NULL,NULL,'2MASX J14500451+5421593',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000183,NULL,'15.9g',0.36,'E0',NULL,NULL,NULL,NULL,1,222.518625,54.36647,0,NULL,59190532651,924852072,14450813,15.9),(124374,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124374,36.84,0.46,233,56016,70,NULL,NULL,'2MASX J14500466+1919163',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,222.519541667,19.32139,0.053,NULL,59533648979,930213265,14534582,17.3),(124375,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124375,37.36,0.33,296,56017,70,NULL,NULL,'2MASX J14500473+2603406',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,222.519833333,26.06136,0.082,NULL,60015687482,937745116,14652267,17.4),(124376,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124376,37.44,0.46,307,56018,70,NULL,NULL,'2MASX J14500479+3054370',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000138,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,222.5202083,30.91028,0,NULL,60090878937,938919983,14670624,17.8),(124377,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124377,37.88,0.21,376,56019,70,NULL,NULL,'2MASX J14500503+3350480',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000175,NULL,'17.0g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,222.521125,33.84669,0,NULL,60125192537,939456133,14679002,17),(124378,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124378,36.81,0.46,230,56020,70,NULL,NULL,'2MASX J14500564+1757036',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.44',0.16,NULL,NULL,NULL,NULL,NULL,1,222.5235417,17.95089,0.017,NULL,59588254874,931066482,14547913,18.44),(124379,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124379,37.05,0.46,257,56021,70,NULL,NULL,'2MASX J14500618+0523386',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,222.5257083,5.39422,0.085,NULL,59336102362,927126599,14486353,17.4),(124380,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124380,37.46,0.46,310,56022,70,NULL,NULL,'2MASX J14500647+6323573',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,222.526875,63.39936,0.017,NULL,57756269121,902441705,14100651,17.1),(124381,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124381,37.47,0.46,312,56023,70,NULL,NULL,'2MASX J14500852+5236205',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,222.535417,52.60561,0,NULL,59192596268,924884316,14451317,16.9),(124382,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124382,37.87,0.46,376,56024,70,NULL,NULL,'2MASX J14500894+2521046',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.61',0.13,NULL,NULL,NULL,NULL,NULL,1,222.537416667,25.35131,0.065,NULL,60014468320,937726067,14651969,18.61),(124383,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124383,38.42,0.46,483,56025,70,NULL,NULL,'2MASX J14500941+1458346',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,222.5392917,14.97625,0.021,NULL,59547691367,930432677,14538010,17.9),(124384,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124384,37.05,0.46,257,56026,70,NULL,NULL,'2MASX J14500994+1959413',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.10',0.19,NULL,NULL,NULL,NULL,NULL,1,222.541583333,19.995,0.053,NULL,59533915255,930217425,14534647,18.1),(124385,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124385,37.88,0.21,376,56027,70,NULL,NULL,'2MASX J14501034+3352520',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000181,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,222.543083,33.88106,0,NULL,60125200493,939456257,14679004,17.9),(124386,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124386,37.24,0.46,281,56028,70,NULL,NULL,'2MASX J14501321+4826485',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,222.5549583,48.44686,0.049,NULL,59933786359,936465411,14632272,17),(124387,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124387,36.24,0.46,177,56029,70,NULL,NULL,'2MASX J14501485+2132133',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.43',0.15,NULL,NULL,NULL,NULL,NULL,1,222.561833,21.53717,0.082,NULL,59532096498,930189007,14534203,18.43),(124388,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124388,37.96,0.46,390,56030,70,NULL,NULL,'2MASX J14501496+3734264',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000143,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,222.562375,37.57389,0,NULL,60073900509,938654695,14666479,18),(124389,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124389,37.93,0.46,385,56031,70,NULL,NULL,'SDSS J145017.75+364847.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,222.574,36.81319,0,NULL,60118056226,939344628,14677259,18.2),(124390,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124390,38.42,0.46,482,56032,70,NULL,NULL,'SDSS J145018.19+115158.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000139,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,222.575833,11.86617,0.025,NULL,59369949254,927655457,14494616,18.5),(124391,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124391,37.88,0.21,376,56033,70,NULL,NULL,'2MASX J14501823+3405380',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000193,NULL,'16.4g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,222.5760417,34.09394,0,NULL,60125285529,939457586,14679024,16.4),(124392,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124392,37.75,0.33,355,56034,70,NULL,NULL,'2MASX J14501881+5450553',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000142,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,222.578417,54.84872,0,NULL,57244619982,894447187,13975737,18),(124393,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124393,36.02,0.46,160,56035,70,NULL,NULL,'2MASX J14501890+1019482',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'18.22',0.21,'AGN',NULL,NULL,NULL,NULL,1,222.578833,10.32997,0.025,NULL,59369293415,927645209,14494456,18.22),(124394,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124394,38.08,0.46,412,56036,70,NULL,NULL,'2MASX J14502071+2901329',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000158,NULL,'18.45',0.14,NULL,NULL,NULL,NULL,NULL,1,222.58625,29.02589,0,NULL,60092844712,938950698,14671104,18.45),(124395,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124395,37.75,0.33,355,56037,70,NULL,NULL,'2MASX J14502124+5449073',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000156,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,222.5882917,54.81872,0,NULL,57244630331,894447348,13975739,18.2),(124396,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124396,35.75,0.74,141,56038,NULL,NULL,'Malmquist cor.','ESO 448- G 005',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.49',0.5,'Sb',NULL,NULL,NULL,NULL,1,222.594083,-31.03289,0.441,NULL,47201719153,737526861,11523857,14.49),(124397,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124397,36.19,0.6,173,56038,NULL,NULL,NULL,'ESO 448- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124398,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124398,36.23,0.2,176,56038,74.4,NULL,NULL,'ESO 448- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124399,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124399,37.64,0.46,338,56039,70,NULL,NULL,'SDSS J145022.80+125430.2',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.8g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.5950417,12.90839,0.037,NULL,59550097212,930470268,14538597,16.8),(124400,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124400,35.58,NULL,131,56040,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09547',NULL,'2010Ap&SS.325..163P',2010,1,1.22,NULL,'G',0.000043,NULL,'15.5g',0.27,'Sb',NULL,NULL,NULL,NULL,1,222.597417,10.32772,0.025,NULL,59369293768,927645215,14494456,15.5),(124401,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124401,35.6,NULL,132,56040,NULL,NULL,'Dipole + Quadrupole','UGC 09547',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124402,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124402,35.61,NULL,132,56040,NULL,NULL,'Dipole','UGC 09547',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124403,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124403,36,0.49,159,56040,75,NULL,'IR','UGC 09547',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124404,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124404,36.56,0.2,205,56040,74.4,NULL,NULL,'UGC 09547',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124405,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124405,38.39,0.46,477,56041,70,NULL,NULL,'2MASX J14502339+2239593',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000192,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,222.597583,22.66658,0.124,NULL,59494309762,929598590,14524977,17.4),(124406,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124406,37.63,0.46,336,56042,70,NULL,NULL,'SDSS J145024.20+010013.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000077,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,222.600875,1.00389,0.133,NULL,58253368393,910208881,14222013,18.3),(124407,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124407,37.68,0.46,343,56043,70,NULL,NULL,'2MASX J14502547+0437594',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000091,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,222.606291667,4.63319,0.109,NULL,59336371692,927130807,14486418,17),(124408,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124408,37.28,0.46,286,56044,70,NULL,NULL,'2MASX J14502575+1523217',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.67',0.15,NULL,NULL,NULL,NULL,NULL,1,222.607416667,15.38939,0.029,NULL,59554930852,930545794,14539778,18.67),(124409,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124409,35.69,0.35,138,56045,NULL,NULL,'Malmquist cor.','UGC 09550',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.00002,NULL,'15.32',0.2,'Sc','Group member',NULL,NULL,NULL,1,222.611125,16.74522,0,NULL,59586360926,931036889,14547451,15.32),(124410,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124410,35.95,0.2,155,56045,74.4,NULL,NULL,'UGC 09550',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124411,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124411,35.96,0.31,156,56045,NULL,NULL,NULL,'UGC 09550',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124412,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124412,36.98,0.15,249,56046,70,NULL,NULL,'2MASX J14502809+1106497',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000123,NULL,'15.4g',0.44,NULL,NULL,NULL,NULL,NULL,1,222.617,11.11375,0.009,NULL,59370276339,927660567,14494696,15.4),(124413,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124413,35.87,0.33,149,56047,70,NULL,NULL,'2MASX J14502856+0957477',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00017,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,222.619083,9.96319,0.029,NULL,59368447198,927631987,14494249,16.5),(124414,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124414,35.45,0.46,123,56048,70,NULL,NULL,'CGCG 134-040',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000093,NULL,'15.7',0.33,NULL,NULL,NULL,NULL,NULL,1,222.6192917,26.03114,0.082,NULL,60015721044,937745641,14652275,15.7),(124415,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124415,38.24,0.33,445,56049,70,NULL,NULL,'2MASX J14502991+5158585',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,222.62475,51.98289,0.029,NULL,59930127395,936408240,14631378,17.7),(124416,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124416,37.83,0.46,368,56050,70,NULL,NULL,'2MASX J14503049+2410480',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,222.626958333,24.18003,0.098,NULL,59496193261,929628019,14525437,16.9),(124417,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124417,36.58,0.33,207,56051,70,NULL,NULL,'2MASX J14503094+0929507',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000182,NULL,'16.5g',0.34,'AGN',NULL,NULL,NULL,NULL,1,222.628875,9.49739,0.037,NULL,59368315318,927629926,14494217,16.5),(124418,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124418,38.15,0.46,427,56052,70,NULL,NULL,'LCRS B144756.0-024337',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00022,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,222.633208333,-2.93286,0.237,NULL,43500226174,679691033,10620172,17.7),(124419,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124419,37.74,0.46,353,56053,70,NULL,NULL,'2MASX J14503238+5759513',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000172,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,222.6347917,57.99769,0,NULL,57723371142,901927674,14092619,17),(124420,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124420,36.58,0.33,207,56054,70,NULL,NULL,'CGCG 076-071',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00008,NULL,'15.6',0.31,NULL,NULL,NULL,NULL,NULL,1,222.638167,9.62839,0.037,NULL,59368490875,927632669,14494260,15.6),(124421,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124421,37.81,0.46,366,56055,70,NULL,NULL,'2MASX J14503359+3047224',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,222.640083333,30.7895,0,NULL,60088989203,938890456,14670163,18.1),(124422,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124422,38.29,0.46,455,56056,70,NULL,NULL,'2MASX J14503384+3453184',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000178,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,222.640917,34.88847,0,NULL,60123951729,939436745,14678699,17.5),(124423,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124423,34.25,0.2,70.8,56057,74.4,NULL,NULL,'CGCG 134-042',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000332,NULL,'15.44',0.4,NULL,NULL,NULL,NULL,NULL,1,222.642166667,24.82158,0.055,NULL,59495699008,929620297,14525317,15.44),(124424,'IRAS','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124424,33.06,0.8,40.9,56058,75,NULL,'MAT, I','ESO 580- G 041',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.00001,NULL,'14.77',0.4,'Sbc? sp','in a pair',NULL,NULL,NULL,1,222.651917,-18.15117,0.293,NULL,46699059968,729672812,11401137,14.77),(124425,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124425,31.76,0.32,22.5,56058,85,NULL,'I, inv','ESO 580- G 041',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124426,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124426,31.77,0.32,22.6,56058,85,NULL,'I, raw','ESO 580- G 041',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124427,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124427,31.99,0.4,25,56058,75,NULL,NULL,'ESO 580- G 041',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124428,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124428,32.06,0.43,25.9,56058,75,NULL,'MAT, I, raw','ESO 580- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124429,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124429,32.09,0.43,26.1,56058,75,NULL,'MAT, I, inv','ESO 580- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124430,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124430,32.22,0.62,27.8,56058,NULL,NULL,NULL,'ESO 580- G 041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124431,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124431,32.23,0.2,27.9,56058,74.4,NULL,NULL,'ESO 580- G 041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124432,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124432,32.32,0.59,29.1,56058,NULL,NULL,'Malmquist cor.','ESO 580- G 041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124433,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124433,32.32,0.43,29.1,56058,75,NULL,'3.6 micron, color + selection bias corrected','ESO 580- G 041',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124434,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124434,32.33,0.43,29.2,56058,75,NULL,'3.6 micron, color corrected','ESO 580- G 041',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124435,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124435,32.37,0.43,29.9,56058,75,NULL,'MAT, I, cor','ESO 580- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124436,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124436,32.55,0.49,32.3,56058,75,NULL,'IR','ESO 580- G 041',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124437,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124437,33.13,0.4,42.2,56058,NULL,NULL,'mean','ESO 580- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124438,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124438,33.29,0.47,45.5,56058,NULL,NULL,'H','ESO 580- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124439,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124439,36.87,0.86,237,56059,70,NULL,NULL,'2MASX J14503678-4215356',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,222.6532917,-42.25983,0.353,NULL,47087724060,735745688,11496026,15.7),(124440,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124440,37.67,0.46,342,56060,70,NULL,NULL,'2MASX J14503831+3452134',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000179,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,222.659625,34.87053,0,NULL,60123951300,939436739,14678699,17),(124441,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124441,36.29,0.63,181,56061,70,NULL,NULL,'2MASX J14503834-2836195',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,222.6597917,-28.60547,0.593,NULL,47011885318,734560708,11477511,15.3),(124442,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124442,38.09,0.33,414,56062,70,NULL,NULL,'2MASX J14503993+3425415',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,222.66625,34.42808,0,NULL,60124427967,939444186,14678815,16.8),(124443,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124443,38.09,0.33,414,56063,70,NULL,NULL,'SDSS J145041.24+342541.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000149,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,222.671833,34.42828,0,NULL,60124427913,939444186,14678815,18.7),(124444,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124444,38.11,0.46,419,56064,70,NULL,NULL,'2MASX J14504123+0620107',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,222.671875,6.33642,0.097,NULL,59379048648,927797635,14496838,18),(124445,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124445,36.68,0.33,216,56065,70,NULL,NULL,'2MASX J14504148+2947050',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000173,NULL,'16.2g',0.38,'E',NULL,NULL,NULL,NULL,1,222.6727917,29.78481,0,NULL,60088742721,938886605,14670103,16.2),(124446,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124446,37.83,0.46,368,56066,70,NULL,NULL,'2MASX J14504170+2129295',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,222.67375,21.49164,0.073,NULL,59532115917,930189311,14534207,17.6),(124447,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124447,37.6,0.46,331,56067,70,NULL,NULL,'2MASX J14504186+1814565',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.32',0.18,NULL,NULL,NULL,NULL,NULL,1,222.6745,18.24922,0.029,NULL,59587943472,931061616,14547837,18.32),(124448,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124448,36.43,0.46,193,56068,70,NULL,NULL,'2MASX J14504193+0515094',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,222.674666667,5.25264,0.085,NULL,59336600241,927134378,14486474,17.6),(124449,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124449,38.49,0.46,499,56069,70,NULL,NULL,'2MASX J14504352+4938036',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000206,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,222.681417,49.63444,0.013,NULL,59935272941,936488639,14632634,16.7),(124450,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124450,38.24,0.33,445,56070,70,NULL,NULL,'2MASX J14504441+5200396',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000158,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,222.6849583,52.01114,0.029,NULL,59930124646,936408197,14631378,17.5),(124451,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124451,37.32,0.46,291,56071,70,NULL,NULL,'2MASX J14504458+1505378',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.86',0.2,NULL,NULL,NULL,NULL,NULL,1,222.6857083,15.09372,0.029,NULL,59547823092,930434735,14538042,17.86),(124452,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124452,36.9,0.46,240,56072,70,NULL,NULL,'2MASX J14504551+1958025',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.33',0.15,NULL,NULL,NULL,NULL,NULL,1,222.6897917,19.96744,0.041,NULL,59533943115,930217861,14534654,18.33),(124453,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124453,35.83,0.33,147,56073,70,NULL,NULL,'IC 1069',NULL,'2015arXiv151105856S',2015,1,1.3,NULL,'G',0.000206,NULL,'14.5g',0.8,'S0',NULL,NULL,NULL,NULL,1,222.693833333,54.41117,0,NULL,59190482603,924851290,14450801,14.5),(124454,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124454,37.36,0.46,296,56074,70,NULL,NULL,'2MASX J14504673+3610014',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000188,NULL,'16.3g',0.4,NULL,NULL,NULL,NULL,NULL,1,222.694541667,36.167,0,NULL,60125378658,939459041,14679047,16.3),(124455,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124455,35.49,0.46,125,56075,70,NULL,NULL,'SDSS J145047.30+252530.0',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.24',0.32,NULL,NULL,NULL,NULL,NULL,1,222.697083,25.42503,0.052,NULL,60015515019,937742422,14652225,16.24),(124456,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124456,37.34,0.46,294,56076,70,NULL,NULL,'2MASX J14504849+2428012',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.07',0.18,NULL,NULL,NULL,NULL,NULL,1,222.702125,24.46708,0.065,NULL,59495874866,929623044,14525360,18.07),(124457,'Maser','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124457,35.51,0.19,126,56077,NULL,NULL,NULL,'NGC 5765B',NULL,'2016ApJ...817..128G',2016,1,0.7,'Component \'b)\' in UGC notes.','G',0.000063,NULL,'14.9',0.6,'Sa-b','Pair member (points to parent)',NULL,NULL,NULL,1,222.714625,5.11447,0.109,NULL,59336797655,927137463,14486522,14.9),(124458,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124458,37.84,0.33,369,56078,70,NULL,NULL,'2MASX J14505256+1131137',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,222.7189583,11.52039,0.025,NULL,59370212551,927659571,14494680,17.5),(124459,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124459,36.52,0.46,201,56079,70,NULL,NULL,'2MASX J14505258+0005402',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000105,NULL,'16.1g',0.41,'E0',NULL,NULL,NULL,NULL,1,222.719125,0.0945,0.117,NULL,58252711028,910198609,14221853,16.1),(124460,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124460,37.96,0.46,392,56080,70,NULL,NULL,'2MASX J14505385+0442592',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000081,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,222.7245417,4.7165,0.109,NULL,59336366429,927130725,14486417,17.2),(124461,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124461,38.18,0.46,433,56081,70,NULL,NULL,'SDSS J145055.03+315936.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.729333,31.99356,0,NULL,60091189395,938924834,14670700,18.4),(124462,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124462,36.62,0.46,211,56082,70,NULL,NULL,'2MASX J14505526+5610220',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000184,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,222.729958333,56.17269,0,NULL,57245532237,894461441,13975960,16.7),(124463,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124463,37.36,0.33,296,56083,70,NULL,NULL,'2MASX J14505543+3312422',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000138,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,222.7310417,33.21161,0,NULL,60122873989,939419906,14678436,17.4),(124464,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124464,36.58,0.33,207,56084,70,NULL,NULL,'2MASX J14505547-0029324',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000112,NULL,'16.0g',0.38,'E0',NULL,NULL,NULL,NULL,1,222.73125,-0.49239,0.121,NULL,43488637025,679509953,10617343,16),(124465,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124465,35.23,0.46,111,56085,70,NULL,NULL,'SDSS J145055.73+381852.4',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,222.73225,38.31456,0.049,NULL,60073295647,938645244,14666331,16.8),(124466,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124466,36.27,0.46,180,56086,70,NULL,NULL,'2MASX J14505632+0248012',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000081,NULL,'16.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,222.734625,2.80033,0.157,NULL,58265221453,910394085,14224907,16.9),(124467,'Tully est','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124467,31.82,0.8,23.1,56087,75,NULL,'B','UGC 09560',NULL,'1988NBGC.C....0000T',1988,1,0.94,NULL,'G',0.000007,NULL,'14.7g',0.33,'pec; BCDG      HII','Pair member (points to parent)',NULL,NULL,NULL,1,222.735375,35.57156,0,NULL,60123391521,939427992,14678562,14.7),(124468,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124468,38.39,0.46,476,56088,70,NULL,NULL,'2MASX J14505944+5058104',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00017,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,222.7475,50.96964,0.013,NULL,59943078609,936610603,14634540,17.6),(124469,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124469,36.8,0.33,229,56089,70,NULL,NULL,'2MASX J14505983+3031193',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000211,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,222.74925,30.52203,0,NULL,60089005752,938890714,14670167,16.3),(124470,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124470,37.08,0.27,261,56090,70,NULL,NULL,'2MASX J14510119+4853176',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,222.755,48.88831,0.037,NULL,59935704204,936495378,14632740,17.6),(124471,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124471,35.31,0.2,115,56091,74.4,NULL,NULL,'CGCG 076-075',NULL,'2013AJ....146...86T',2013,1,0.69,NULL,'G',0.000096,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,222.7592083,11.98878,0.021,NULL,59369872959,927654264,14494597,16.4),(124472,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124472,38.06,0.17,410,56092,70,NULL,NULL,'2MASX J14510234+3229273',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,222.7597917,32.49094,0,NULL,60090009681,938906401,14670412,18),(124473,'IRAS','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124473,34.13,0.8,66.9,56093,75,NULL,'MAT, I','ESO 273- G 006',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'13.58',0.5,'S...',NULL,NULL,NULL,NULL,1,222.760916667,-43.91867,0.629,NULL,47108472970,736069890,11501092,13.58),(124474,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124474,33.73,0.32,55.8,56093,85,NULL,'I, raw','ESO 273- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124475,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124475,33.75,0.32,56.3,56093,85,NULL,'I, inv','ESO 273- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124476,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124476,33.81,0.48,57.8,56093,NULL,NULL,'Malmquist cor.','ESO 273- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124477,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124477,33.94,0.43,61.5,56093,75,NULL,'MAT, I, raw','ESO 273- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124478,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124478,33.98,0.44,62.6,56093,NULL,NULL,NULL,'ESO 273- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124479,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124479,34.02,0.2,63.7,56093,74.4,NULL,NULL,'ESO 273- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124480,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124480,34.07,0.43,65.2,56093,75,NULL,'MAT, I, inv','ESO 273- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124481,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124481,34.13,0.43,66.9,56093,75,NULL,'MAT, I, cor','ESO 273- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124482,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124482,36.68,0.33,216,56094,70,NULL,NULL,'2MASX J14510274+1847321',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.11',0.19,NULL,NULL,NULL,NULL,NULL,1,222.7615,18.79239,0.049,NULL,59586642751,931041292,14547520,18.11),(124483,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124483,37.59,0.33,329,56095,70,NULL,NULL,'2MASX J14510314+0344061',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000093,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,222.763166667,3.73494,0.101,NULL,59333838850,927091232,14485800,16.4),(124484,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124484,36.8,0.46,229,56096,70,NULL,NULL,'2MASX J14510317+1017288',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000178,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,222.763333,10.29131,0.029,NULL,59369322670,927645666,14494463,16.3),(124485,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124485,36.1,0.27,166,56097,70,NULL,NULL,'2MASX J14510352+5531140',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.0002,NULL,'15.1g',0.64,'E0',NULL,NULL,NULL,NULL,1,222.7645,55.52064,0.025,NULL,57247680622,894495009,13976484,15.1),(124486,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124486,36.58,0.33,207,56098,70,NULL,NULL,'2MASX J14510387-0027434',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000102,NULL,'16.2g',0.29,'S0',NULL,NULL,NULL,NULL,1,222.766291667,-0.46222,0.125,NULL,43488630134,679509845,10617341,16.2),(124487,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124487,37.66,0.46,340,56099,70,NULL,NULL,'2MASX J14510410+2112541',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,222.766958333,21.21492,0.056,NULL,59532724693,930198823,14534356,17.8),(124488,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124488,37.08,0.27,261,56100,70,NULL,NULL,'2MASX J14510457+4915184',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000204,NULL,'16.0g',0.41,'E0',NULL,NULL,NULL,NULL,1,222.7692083,49.25514,0.021,NULL,59935585155,936493518,14632711,16),(124489,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124489,38.08,0.46,414,56101,70,NULL,NULL,'SDSS J145105.53+201202.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.773083,20.20064,0.049,NULL,59533876886,930216826,14534637,18.6),(124490,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124490,37.61,0.33,332,56102,70,NULL,NULL,'2MASX J14510676+5518180',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,222.7780417,55.30503,0.005,NULL,57244196344,894440567,13975633,17.3),(124491,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124491,37.59,0.33,329,56103,70,NULL,NULL,'2MASX J14510674+0340291',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000091,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,222.77825,3.67469,0.101,NULL,59333876940,927091827,14485809,17.1),(124492,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124492,36.65,0.46,214,56104,70,NULL,NULL,'2MASX J14510739+2829052',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,222.780833,28.48475,0.006,NULL,60013364159,937708814,14651700,17.3),(124493,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124493,38.31,0.46,459,56105,70,NULL,NULL,'2MASX J14510744+3551023',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,222.781208333,35.85086,0,NULL,60125450972,939460171,14679065,17.8),(124494,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124494,37.24,0.46,281,56106,70,NULL,NULL,'2MASX J14510833+1813081',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.08',0.18,NULL,NULL,NULL,NULL,NULL,1,222.7847917,18.21886,0.029,NULL,59587947920,931061686,14547838,18.08),(124495,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124495,35.33,0.5,116,56107,70,NULL,NULL,'2MASX J14510866-3755217',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'13.2I',0.4,NULL,NULL,NULL,NULL,NULL,1,222.786167,-37.92267,0.261,NULL,47216941960,737764718,11527573,13.2),(124496,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124496,37.06,0.46,258,56108,70,NULL,NULL,'2MASX J14510952+5823371',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000073,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,222.7895417,58.39364,0,NULL,57724672888,901948013,14092937,17.4),(124497,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124497,37.15,0.46,269,56109,70,NULL,NULL,'2MASX J14510983+1450482',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.92',0.18,NULL,NULL,NULL,NULL,NULL,1,222.791,14.84675,0.021,NULL,59547781075,930434079,14538032,17.92),(124498,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124498,35.8,0.33,145,56110,91,NULL,'H','UGC 09558',NULL,'1984ApJ...278..475B',1984,1,1,NULL,'G',0.00001,NULL,'15.11',0.6,'Scd:','Group member',NULL,NULL,NULL,1,222.7912917,17.18892,0.025,NULL,59585659421,931025928,14547280,15.11),(124499,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124499,36.15,0.2,170,56110,74.4,NULL,NULL,'UGC 09558',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124500,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124500,37.55,0.46,323,56111,70,NULL,NULL,'2MASX J14511010+1944411',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,222.7920417,19.74469,0.049,NULL,59533924750,930217574,14534649,16.7),(124501,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124501,38.06,0.17,410,56112,70,NULL,NULL,'2MASX J14511049+3220313',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,222.793625,32.34217,0,NULL,60089975989,938905874,14670404,17.9),(124502,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124502,36.53,0.46,202,56113,70,NULL,NULL,'2MASX J14511168+2525072',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.06',0.23,NULL,NULL,NULL,NULL,NULL,1,222.798625,25.41864,0.052,NULL,60012634556,937697414,14651522,17.06),(124503,'IRAS','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124503,33.23,0.8,44.3,56114,75,NULL,'MAT, I','UGCA 395',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000017,NULL,'13.98',1.1,'SB(s)dm pec:',NULL,NULL,NULL,NULL,1,222.801625,-20.44075,0.357,NULL,46650428269,728912941,11389264,13.98),(124504,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124504,31.6,0.32,20.9,56114,85,NULL,'I, inv','UGCA 395',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124505,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124505,31.61,0.32,21,56114,85,NULL,'I, raw','UGCA 395',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124506,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124506,32.09,0.43,26.2,56114,75,NULL,'MAT, I, raw','UGCA 395',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124507,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124507,32.1,0.43,26.3,56114,75,NULL,'MAT, I, inv','UGCA 395',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124508,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124508,32.28,0.2,28.6,56114,74.4,NULL,NULL,'UGCA 395',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124509,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124509,32.41,0.43,30.4,56114,75,NULL,'MAT, I, cor','UGCA 395',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124510,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124510,32.48,0.6,31.3,56114,NULL,NULL,NULL,'UGCA 395',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124511,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124511,32.58,0.58,32.8,56114,NULL,NULL,'Malmquist cor.','UGCA 395',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124512,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124512,37.63,0.46,336,56115,70,NULL,NULL,'SDSS J145112.45+021250.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000073,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,222.801875,2.214,0.125,NULL,58252473335,910194895,14221795,18.3),(124513,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124513,38.31,0.46,458,56116,70,NULL,NULL,'2MASX J14511256+3528483',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000178,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,222.802583333,35.48019,0,NULL,60124118828,939439356,14678739,18),(124514,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124514,35.87,0.33,149,56117,70,NULL,NULL,'2MASX J14511395+0939588',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000162,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,222.8082083,9.66636,0.037,NULL,59368522507,927633164,14494268,16.2),(124515,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124515,37.4,0.27,302,56118,70,NULL,NULL,'2MASX J14511409+4636551',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,222.808916667,46.61528,0.017,NULL,59989701837,937339091,14645923,17.8),(124516,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124516,36.68,0.33,216,56119,70,NULL,NULL,'IC 1061',NULL,'2015arXiv151105856S',2015,1,0.5,'Mislabeled as A1983 D in Colless, et al. (1993,MNRAS,262,475).','G',0.000147,NULL,'14.62',0.4,'E/S0',NULL,NULL,NULL,NULL,1,222.809333,18.75756,0.037,NULL,59586643432,931041303,14547520,14.62),(124517,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124517,36.68,0.23,217,56119,70,NULL,NULL,'IC 1061',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124518,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124518,37.11,0.25,264,56119,74.4,NULL,NULL,'IC 1061',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124519,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124519,36.63,0.46,212,56120,70,NULL,NULL,'2MASX J14511425+2407442',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.21',0.14,NULL,NULL,NULL,NULL,NULL,1,222.809333,24.12914,0.088,NULL,59496158514,929627476,14525429,17.21),(124520,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124520,37.4,0.27,302,56121,70,NULL,NULL,'SDSS J145114.27+512231.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000012,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,222.809458333,51.37536,0.037,NULL,59929358568,936396227,14631191,18.3),(124521,'Tully est','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124521,31.88,0.8,23.8,56122,75,NULL,'B','UGC 09562',NULL,'1988NBGC.C....0000T',1988,1,0.98,NULL,'G',0.00006,NULL,'14.3g',0.77,'Pec            HII','Pair member (points to parent)',NULL,NULL,NULL,1,222.8100417,35.54228,0,NULL,60124117246,939439331,14678739,14.3),(124522,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124522,36.8,0.33,229,56123,70,NULL,NULL,'CGCG 164-036',NULL,'2015arXiv151105856S',2015,1,1.03,NULL,'G',0.000203,NULL,'15.1g',0.58,'cD',NULL,NULL,NULL,NULL,1,222.8100417,30.69222,0,NULL,60089039520,938891242,14670175,15.1),(124523,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124523,38.06,0.17,410,56124,70,NULL,NULL,'2MASX J14511444+3222413',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000163,NULL,'16.9g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,222.810125,32.37819,0,NULL,60089981142,938905955,14670405,16.9),(124524,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124524,38.06,0.17,410,56125,70,NULL,NULL,'SDSS J145114.50+322105.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000163,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.810417,32.35153,0,NULL,60090189855,938909216,14670456,18.3),(124525,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124525,36.21,0.16,175,56126,74.4,NULL,NULL,'CGCG 105-046',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000048,NULL,'15.3',0.4,'Sab','Group member',NULL,NULL,NULL,1,222.811083,16.69544,0,NULL,59586335764,931036496,14547445,15.3),(124526,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124526,36.79,0.26,228,56126,70,NULL,NULL,'CGCG 105-046',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124527,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124527,35.52,0.85,127,56126,NULL,NULL,'Malmquist cor.','CGCG 105-046',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124528,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124528,35.94,0.7,154,56126,NULL,NULL,NULL,'CGCG 105-046',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124529,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124529,36.21,0.16,175,56126,74.4,NULL,NULL,'CGCG 105-046',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124530,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124530,36.99,NULL,250,56126,NULL,NULL,NULL,'CGCG 105-046',NULL,'1996PASJ...48..657S',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124531,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124531,38.06,0.17,410,56127,70,NULL,NULL,'SDSS J145115.69+321947.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000139,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,222.815417,32.32983,0,NULL,60090190799,938909231,14670456,18.6),(124532,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124532,37.07,0.46,260,56128,70,NULL,NULL,'2MASX J14511576+2003071',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.0g',0.22,'AGN',NULL,NULL,NULL,NULL,1,222.815875,20.05211,0.049,NULL,59533866598,930216665,14534635,17),(124533,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124533,37.62,0.46,334,56129,70,NULL,NULL,'2MASX J14511660+0619518',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,222.819208333,6.33119,0.101,NULL,59382486040,927851344,14497677,16.9),(124534,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124534,36.68,0.23,217,56130,70,NULL,NULL,'IC 1062',NULL,'2001MNRAS.321..277C',2001,1,NULL,'Mislabeled as A1983 E in Colless, et al. (1993,MNRAS,262,475).','G',0.00017,NULL,'13.96',NULL,'E/S0',NULL,NULL,NULL,NULL,1,222.823583,18.68697,0.037,NULL,59586648480,931041382,14547521,13.96),(124535,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124535,37.11,0.25,264,56130,74.4,NULL,NULL,'IC 1062',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124536,'SNII optical','2016-12-15 15:15:29','2016-12-16 11:20:42','1','SN 2001dc',NULL,124536,31.9,0.19,24,56131,NULL,NULL,'SCM','NGC 5777',NULL,'2015ApJ...799..215P',2015,1,3.1,NULL,'G',0.000017,NULL,'14.1B',0.4,'Sbc            NLAGN',NULL,NULL,NULL,NULL,1,222.824375,58.97794,0.005,NULL,57725121027,901955016,14093047,14.1),(124537,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124537,33.14,0.43,42.5,56131,75,NULL,'3.6 micron, color corrected','NGC 5777',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124538,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124538,33.17,0.2,43.1,56131,74.4,NULL,NULL,'NGC 5777',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124539,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124539,33.19,0.43,43.4,56131,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5777',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124540,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124540,33.5,NULL,50.2,56131,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 5777',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124541,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124541,33.5,NULL,50.2,56131,NULL,NULL,'Dipole','NGC 5777',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124542,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124542,33.5,NULL,50.2,56131,NULL,NULL,'Dipole + Quadrupole','NGC 5777',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124543,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124543,33.59,NULL,52.3,56131,NULL,NULL,NULL,'NGC 5777',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124544,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124544,37.35,0.46,296,56132,70,NULL,NULL,'2MASX J14511786+1610122',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00015,NULL,'18.41',0.2,'E','Group member',NULL,NULL,NULL,1,222.8245417,16.17008,0,NULL,59585581340,931024708,14547261,18.41),(124545,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124545,35.53,0.68,128,56133,NULL,NULL,NULL,'AGC 241306',NULL,'2009ApJS..182..474S',2009,1,0.29,NULL,'G',0.000017,NULL,'19.08',0.09,'Sc',NULL,NULL,NULL,NULL,1,222.828625,16.69503,0,NULL,59586343160,931036611,14547447,19.08),(124546,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124546,35.57,0.2,130,56133,74.4,NULL,NULL,'AGC 241306',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124547,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124547,35.78,0.61,143,56133,NULL,NULL,'Malmquist cor.','AGC 241306',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124548,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124548,38.19,0.46,435,56134,70,NULL,NULL,'2MASX J14511950+2708032',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.65',0.14,NULL,NULL,NULL,NULL,NULL,1,222.831125,27.13433,0.085,NULL,60013813404,937715834,14651809,18.65),(124549,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124549,37.49,0.46,315,56135,70,NULL,NULL,'2MASX J14512003+3039504',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000207,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,222.833625,30.66383,0,NULL,60089025891,938891029,14670172,16.6),(124550,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124550,37.49,0.46,315,56136,70,NULL,NULL,'2MASX J14512014+3605281',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,222.833875,36.09111,0,NULL,60125591817,939462372,14679099,17.6),(124551,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124551,36.1,0.27,166,56137,70,NULL,NULL,'2MASX J14512270+5524051',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.00011,NULL,'15.1g',0.62,'E0',NULL,NULL,NULL,NULL,1,222.8447083,55.40136,0.005,NULL,57244253472,894441460,13975647,15.1),(124552,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124552,38.46,0.46,492,56138,70,NULL,NULL,'SDSS J145123.48+104812.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.847875,10.80344,0.013,NULL,59369718588,927651852,14494560,18.2),(124553,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124553,37.41,0.33,303,56139,70,NULL,NULL,'2MASX J14512384+0516490',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,222.8492917,5.28022,0.101,NULL,59336772269,927137066,14486516,17.1),(124554,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124554,38.14,0.46,424,56140,70,NULL,NULL,'2MASX J14512453+0807498',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,222.852333,8.13056,0.045,NULL,59381892639,927842072,14497532,17.8),(124555,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124555,37.23,0.46,279,56141,70,NULL,NULL,'2MASX J14512494+1539402',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.28',0.16,NULL,NULL,NULL,NULL,NULL,1,222.8539583,15.66117,0.025,NULL,59589539705,931086557,14548227,18.28),(124556,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124556,37.56,0.27,324,56142,70,NULL,NULL,'2MASX J14512598+3133243',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000184,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,222.858291667,31.55669,0,NULL,60091716289,938933067,14670829,16.3),(124557,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124557,38.02,0.46,401,56143,70,NULL,NULL,'2MASX J14512634+4816557',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000174,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,222.859917,48.28225,0.037,NULL,59934304947,936473514,14632398,17.3),(124558,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124558,37.08,0.27,261,56144,70,NULL,NULL,'2MASX J14512674+4911226',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000175,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,222.861375,49.18947,0.021,NULL,59935618543,936494039,14632719,16.7),(124559,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124559,36.94,0.46,244,56145,70,NULL,NULL,'2MASX J14512699+3931342',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00014,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,222.8627083,39.52622,0.022,NULL,60071165648,938611963,14665811,17.8),(124560,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124560,36.16,0.46,171,56146,70,NULL,NULL,'2MASX J14512748+2803478',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,222.864708333,28.06342,0.037,NULL,60013290101,937707657,14651682,17.3),(124561,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124561,38.6,0.46,525,56147,70,NULL,NULL,'2MASX J14513121+5553530',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000174,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,222.88,55.89825,0,NULL,57245445577,894460087,13975938,18.1),(124562,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124562,38.23,0.46,443,56148,70,NULL,NULL,'2MASX J14513273+2454288',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.72',0.13,NULL,NULL,NULL,NULL,NULL,1,222.88625,24.90803,0.091,NULL,59495711854,929620497,14525320,18.72),(124563,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124563,36.29,0.46,181,56149,70,NULL,NULL,'2MASX J14513327+4526182',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000186,NULL,'16.0g',0.35,'AGN',NULL,NULL,NULL,NULL,1,222.888666667,45.43847,0.025,NULL,59988466989,937319796,14645621,16),(124564,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124564,37.1,0.46,263,56150,70,NULL,NULL,'2MASX J14513371+5013457',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,222.890458333,50.22928,0.021,NULL,59943325893,936614467,14634601,17.7),(124565,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124565,37.4,0.27,302,56151,70,NULL,NULL,'2MASX J14513439+5117007',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000145,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,222.8932917,51.28347,0.037,NULL,59929389644,936396713,14631198,17.5),(124566,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124566,37.77,0.33,358,56152,70,NULL,NULL,'2MASX J14513538+6243055',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000179,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,222.8977083,62.71803,0.033,NULL,57765538474,902586538,14102914,16.4),(124567,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124567,37.44,0.46,308,56153,70,NULL,NULL,'2MASX J14513554+0005520',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000082,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,222.898,0.09789,0.125,NULL,58253523089,910211298,14222051,17.7),(124568,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124568,37.41,0.33,303,56154,70,NULL,NULL,'2MASX J14513709+0520260',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,222.904416667,5.34053,0.101,NULL,59336707508,927136054,14486500,16.3),(124569,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124569,36.49,0.09,198,56155,70,NULL,NULL,'2MASX J14513715+1634558',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00007,NULL,'17.3g',0.17,'E','Group member',NULL,NULL,NULL,1,222.9047917,16.58222,0,NULL,59586298009,931035906,14547436,17.3),(124570,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124570,37.56,0.27,324,56156,70,NULL,NULL,'2MASX J14513804+3125386',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00017,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,222.908625,31.42731,0,NULL,60090836233,938919316,14670614,17.5),(124571,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124571,37.84,0.33,369,56157,70,NULL,NULL,'SDSS J145138.52+114052.9',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000177,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,222.9105417,11.68139,0.025,NULL,59370022572,927656602,14494634,17.7),(124572,'Sosies','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124572,35.2,0.25,110,56158,NULL,NULL,NULL,'NGC 5772',NULL,'2002A&A...393...57T',2002,1,1.91,NULL,'G',0.000023,NULL,'13.3g',0.94,'SA(r)b:','Isolated galaxy',NULL,NULL,NULL,1,222.912,40.59917,0.049,NULL,59949970028,936718281,14636223,13.3),(124573,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124573,33.36,0.69,46.9,56158,100,NULL,'mid-IR','NGC 5772',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124574,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124574,34.07,0.47,65.1,56158,NULL,NULL,'H','NGC 5772',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124575,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124575,34.12,0.46,66.8,56158,NULL,NULL,'J','NGC 5772',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124576,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124576,34.14,0.45,67.4,56158,NULL,NULL,'K','NGC 5772',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124577,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124577,34.21,0.4,69.6,56158,NULL,NULL,'mean','NGC 5772',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124578,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124578,37.42,0.46,305,56159,70,NULL,NULL,'2MASX J14513892+5339486',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,222.9124583,53.66369,0.013,NULL,59190737463,924855272,14450863,17.7),(124579,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124579,37.81,0.33,364,56160,70,NULL,NULL,'2MASX J14514007+0002470',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00008,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,222.916875,0.04639,0.125,NULL,58252987800,910202934,14221920,17.3),(124580,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124580,37.4,0.27,302,56161,70,NULL,NULL,'2MASX J14514157+5127476',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000127,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,222.923417,51.46328,0.037,NULL,59929355297,936396176,14631190,17.8),(124581,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124581,37.41,0.27,304,56162,70,NULL,NULL,'2MASX J14514191+4522112',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000196,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,222.9245,45.36967,0.025,NULL,59988474695,937319917,14645623,16.7),(124582,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124582,37.41,0.27,304,56163,70,NULL,NULL,'2MASX J14514305+4522362',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,222.9294583,45.37669,0.025,NULL,59988474035,937319906,14645623,17.5),(124583,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124583,37.81,0.33,364,56164,70,NULL,NULL,'2MASX J14514384+0003460',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000084,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,222.932667,0.06283,0.125,NULL,58252986983,910202921,14221920,17.7),(124584,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124584,38.51,0.46,504,56165,70,NULL,NULL,'SDSS J145144.38+243917.6',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.2r',NULL,NULL,NULL,NULL,NULL,NULL,1,222.935,24.65492,0.042,NULL,59495830952,929622358,14525349,17.2),(124585,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124585,34.3,0.74,72.3,56166,NULL,NULL,NULL,'ESO 580- G 046',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'15.91',0.5,'Sb',NULL,NULL,NULL,NULL,1,222.9354583,-22.67792,0.445,NULL,46524464338,726944755,11358511,15.91),(124586,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124586,34.34,0.2,73.8,56166,74.4,NULL,NULL,'ESO 580- G 046',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124587,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124587,34.47,0.68,78.4,56166,NULL,NULL,'Malmquist cor.','ESO 580- G 046',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124588,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124588,37.65,0.33,340,56167,70,NULL,NULL,'2MASX J14514517+3245096',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000195,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,222.938291667,32.75275,0,NULL,60122745533,939417898,14678404,16.3),(124589,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124589,36.88,0.27,238,56168,70,NULL,NULL,'2MASX J14514576+3017396',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000177,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,222.940583,30.29439,0.006,NULL,60089090033,938892031,14670187,16.6),(124590,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124590,37.41,0.27,304,56169,70,NULL,NULL,'2MASX J14514675+4523422',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000131,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,222.944833,45.39525,0.025,NULL,59988465674,937319776,14645621,17.8),(124591,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124591,36.6,0.46,209,56170,70,NULL,NULL,'2MASX J14514721+1044358',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000172,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,222.9467083,10.74336,0.013,NULL,59368617639,927634650,14494291,16.3),(124592,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124592,37.51,0.46,317,56171,70,NULL,NULL,'2MASX J14514720+0508550',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,222.946791667,5.14861,0.109,NULL,59336811328,927137677,14486526,17.1),(124593,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124593,34.03,0.47,64,56172,NULL,NULL,'H','IC 1060',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00002,NULL,'14.2b',0.8,'(R\')SB(r)a:',NULL,NULL,NULL,NULL,1,222.9472917,-7.23264,0.237,NULL,46502199058,726596860,11353075,14.2),(124594,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124594,34.12,0.45,66.7,56172,NULL,NULL,'K','IC 1060',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124595,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124595,34.16,0.46,68,56172,NULL,NULL,'J','IC 1060',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124596,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124596,34.17,0.4,68.1,56172,NULL,NULL,'mean','IC 1060',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124597,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124597,36.77,0.46,226,56173,70,NULL,NULL,'2MASX J14514796+2609478',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'18.03',0.14,NULL,NULL,NULL,NULL,NULL,1,222.949833,26.16317,0.11,NULL,60016042093,937750657,14652354,18.03),(124598,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124598,38.03,0.46,404,56174,70,NULL,NULL,'2MASX J14514836+1348098',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,222.951583,13.80261,0.029,NULL,59550275075,930473048,14538641,17.4),(124599,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124599,37.06,0.46,258,56175,70,NULL,NULL,'2MASX J14514938+3133266',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00017,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,222.955875,31.55739,0,NULL,60090815381,938918990,14670609,17.2),(124600,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124600,37.57,0.46,326,56176,70,NULL,NULL,'2MASX J14515010+4502552',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,222.958875,45.04853,0.033,NULL,59992822283,937387848,14646685,17.6),(124601,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124601,37.78,0.46,360,56177,70,NULL,NULL,'2MASX J14515268+2458596',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.53',0.15,NULL,NULL,NULL,NULL,NULL,1,222.969375,24.98325,0.091,NULL,59492299580,929567180,14524487,18.53),(124602,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124602,36.88,0.27,238,56178,70,NULL,NULL,'2MASX J14515264+3024476',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.35',0.25,NULL,NULL,NULL,NULL,NULL,1,222.969541667,30.41322,0.006,NULL,60089113326,938892395,14670193,17.35),(124603,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124603,36.28,0.56,180,56179,70,NULL,NULL,'2MASX J14515290-3606141',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.2,NULL,NULL,NULL,NULL,NULL,1,222.970583333,-36.10394,0.249,NULL,47242800452,738168757,11533886,14.2),(124604,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124604,38.07,0.46,411,56180,70,NULL,NULL,'2MASX J14515299+3141226',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000198,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,222.970833,31.68972,0,NULL,60091675715,938932433,14670819,16.8),(124605,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124605,38.16,0.46,428,56181,70,NULL,NULL,'2MASX J14515338+2830487',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'18.46',0.13,NULL,NULL,NULL,NULL,NULL,1,222.972417,28.51364,0.006,NULL,60081551572,938774243,14668347,18.46),(124606,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124606,37.63,0.46,335,56182,70,NULL,NULL,'2MASX J14515427+3116486',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00018,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,222.976291667,31.28014,0,NULL,60090950979,938921109,14670642,16.7),(124607,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124607,37.99,0.46,396,56183,70,NULL,NULL,'2MASX J14515516+1007258',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,222.98,10.12369,0.033,NULL,59369237447,927644335,14494442,17.5),(124608,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124608,38.21,0.46,438,56184,70,NULL,NULL,'SDSS J145156.10+101703.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000149,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,222.98375,10.28439,0.037,NULL,59369285468,927645085,14494454,18.3),(124609,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124609,38.53,0.46,509,56185,70,NULL,NULL,'SDSS J145156.66-013327.4',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,222.986083,-1.55761,0.165,NULL,43489325025,679520703,10617510,17.7),(124610,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124610,36.88,0.27,238,56186,70,NULL,NULL,'2MASX J14515798+3027106',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000174,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,222.9915,30.45292,0.006,NULL,60089111995,938892374,14670193,17),(124611,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124611,37.29,0.46,287,56187,70,NULL,NULL,'2MASX J14515804+0509250',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'15.8g',0.42,NULL,NULL,NULL,NULL,NULL,1,222.9917917,5.15686,0.101,NULL,59336729513,927136398,14486506,15.8),(124612,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124612,36.49,0.09,198,56188,70,NULL,NULL,'SDSS J145158.13+163656.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'16.8g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.9922083,16.61572,0,NULL,59586270640,931035478,14547429,16.8),(124613,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124613,37.4,0.27,302,56189,70,NULL,NULL,'2MASX J14515980+4645041',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000182,NULL,'16.6g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,222.999125,46.75103,0.017,NULL,59989879307,937341864,14645966,16.6),(124614,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124614,37.94,0.46,388,56190,70,NULL,NULL,'2MASX J14520006+4610581',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00017,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,223.00025,46.18278,0.017,NULL,59990311148,937348611,14646072,18),(124615,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124615,37.28,0.46,286,56191,70,NULL,NULL,'2MASX J14520010+4940036',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000175,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,223.0002917,49.66778,0.021,NULL,59935056931,936485264,14632582,16.9),(124616,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124616,37.39,0.46,301,56192,70,NULL,NULL,'2MASX J14520026+1758226',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'18.11',0.15,NULL,NULL,NULL,NULL,NULL,1,223.001125,17.97289,0.025,NULL,59588404146,931068814,14547950,18.11),(124617,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124617,37.56,0.27,324,56193,70,NULL,NULL,'SDSS J145200.37+313221.7',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000175,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,223.0015417,31.53936,0,NULL,60090870073,938919844,14670622,17.2),(124618,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124618,37.67,0.46,342,56194,70,NULL,NULL,'2MASX J14520087+1956203',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.11',0.19,NULL,NULL,NULL,NULL,NULL,1,223.0037083,19.939,0.041,NULL,59533773452,930215210,14534612,18.11),(124619,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124619,36.01,0.46,159,56195,70,NULL,NULL,'2MASX J14520211+2727577',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.29',0.27,NULL,NULL,NULL,NULL,NULL,1,223.00875,27.466,0.036,NULL,60013886937,937716983,14651827,17.29),(124620,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124620,37.84,0.46,369,56196,70,NULL,NULL,'2MASXi J1452023+534606',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.009625,53.76844,0.013,NULL,59190711576,924854868,14450857,18.1),(124621,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124621,37.5,0.46,317,56197,70,NULL,NULL,'2MASX J14520234+3100316',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.009875,31.00872,0.009,NULL,60090967385,938921365,14670646,17.4),(124622,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124622,37.29,0.46,287,56198,70,NULL,NULL,'2MASX J14520453+6214067',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000174,NULL,'16.5g',0.29,'AGN',NULL,NULL,NULL,NULL,1,223.0192917,62.23514,0.033,NULL,57765809239,902590769,14102980,16.5),(124623,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124623,36.29,0.46,181,56199,70,NULL,NULL,'2MASX J14520592+2926457',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000173,NULL,'16.1g',0.31,'E',NULL,NULL,NULL,NULL,1,223.0247917,29.44592,0.031,NULL,60092995869,938953060,14671141,16.1),(124624,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124624,37.78,0.33,360,56200,70,NULL,NULL,'2MASX J14520747-0206169',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.031208333,-2.10486,0.201,NULL,43489634568,679525540,10617586,17.9),(124625,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124625,32.26,0.45,28.3,56201,NULL,NULL,'K','NGC 5768',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000007,NULL,'13.4g',1.06,'SA(rs)c:       HII','Isolated galaxy',NULL,NULL,NULL,1,223.033125,-2.52975,0.209,NULL,43488891396,679513928,10617405,13.4),(124626,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124626,32.3,0.4,28.8,56201,NULL,NULL,'mean','NGC 5768',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124627,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124627,32.3,0.47,28.8,56201,NULL,NULL,'H','NGC 5768',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124628,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124628,32.3,NULL,28.8,56201,72,NULL,NULL,'NGC 5768',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124629,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124629,32.34,0.46,29.4,56201,NULL,NULL,'J','NGC 5768',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124630,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124630,36.96,0.33,247,56202,70,NULL,NULL,'2MASX J14520871-0023069',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000069,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,223.036333,-0.38533,0.125,NULL,43488283521,679504430,10617256,17.9),(124631,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124631,37.03,0.46,255,56203,70,NULL,NULL,'2MASX J14520904+3857153',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000168,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,223.0377917,38.95433,0.017,NULL,60074340832,938661575,14666587,16.2),(124632,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124632,37.46,0.46,311,56204,70,NULL,NULL,'2MASX J14520938+1320547',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.4g',NULL,NULL,NULL,NULL,NULL,NULL,1,223.0392083,13.34853,0.037,NULL,59550487701,930476370,14538693,17.4),(124633,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124633,37.62,0.46,335,56205,70,NULL,NULL,'2MASX J14520942+2130424',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000178,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,223.039375,21.51186,0.045,NULL,59532010537,930187664,14534182,16.9),(124634,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124634,38.09,0.46,416,56206,70,NULL,NULL,'2MASX J14520983+0657359',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.041,6.95986,0.081,NULL,59382798045,927856219,14497753,18),(124635,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124635,37.97,0.46,393,56207,70,NULL,NULL,'2MASX J14521012+5107596',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,223.042333,51.13336,0.029,NULL,59943041032,936610016,14634531,17.4),(124636,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124636,37.9,0.46,380,56208,70,NULL,NULL,'2MASX J14521029+0507040',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.042875,5.11775,0.101,NULL,59336729943,927136405,14486506,17.8),(124637,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124637,32.82,0.4,36.6,56209,NULL,NULL,'mean','MCG -02-38-022',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00003,NULL,'13.97',0.6,'Sb pec?',NULL,NULL,NULL,NULL,1,223.043417,-10.74044,0.289,NULL,46462013711,725968964,11343265,13.97),(124638,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124638,32.96,0.47,39.1,56209,NULL,NULL,'H','MCG -02-38-022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124639,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124639,32.96,0.45,39.1,56209,NULL,NULL,'K','MCG -02-38-022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124640,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124640,32.98,0.46,39.5,56209,NULL,NULL,'J','MCG -02-38-022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124641,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124641,33.19,0.43,43.4,56209,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-38-022',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124642,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124642,36.9,0.46,240,56210,70,NULL,NULL,'2MASX J14521056+3556153',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.0439583,35.9375,0,NULL,60125435024,939459922,14679061,17.7),(124643,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124643,37.61,0.33,332,56211,70,NULL,NULL,'2MASX J14521073+5512531',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000178,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,223.044625,55.21461,0.013,NULL,57244691395,894448303,13975754,17.2),(124644,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124644,36.22,0.46,175,56212,70,NULL,NULL,'SDSS J145211.02+200435.9',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',NULL,NULL,'15.5g',0.5,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.0459583,20.07667,0.049,NULL,59533101397,930204709,14534448,15.5),(124645,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124645,37.93,0.46,386,56213,70,NULL,NULL,'LCRS B144935.3-022951',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,223.04625,-2.70203,0.209,NULL,43488661070,679510329,10617348,17.2),(124646,'GRB','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124646,43.97,1.53,2510,56214,100,NULL,NULL,'SMM J14522+4301',1.47688,'2009EPJC...63..139W',2009,1,NULL,NULL,'G',NULL,NULL,'20.0R',NULL,'SAX/WFC',NULL,NULL,NULL,NULL,1,223.052166667,43.01833,0.009,NULL,59981566487,937211976,14643937,20),(124647,'GRB','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124647,43.98,0.46,2520,56214,69.7,NULL,'Fiducial','SMM J14522+4301',1.47688,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124648,'GRB','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124648,44.15,1.46,2730,56214,100,NULL,NULL,'SMM J14522+4301',1.47688,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124649,'GRB','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124649,44.28,0.43,2900,56214,72,NULL,NULL,'SMM J14522+4301',1.47688,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124650,'GRB','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124650,44.48,0.42,3180,56214,70,NULL,NULL,'SMM J14522+4301',1.47688,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124651,'GRB','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124651,45.28,0.21,3350,56214,73,NULL,'H const./H=100','SMM J14522+4301',1.47688,'2006astro.ph..9262M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124652,'GRB','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124652,44.62,0.29,3390,56214,69.7,NULL,'Calibrated','SMM J14522+4301',1.47688,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124653,'GRB','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124653,44.75,0.52,3600,56214,NULL,NULL,NULL,'SMM J14522+4301',1.47688,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124654,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124654,36.49,0.09,198,56215,70,NULL,NULL,'SDSS J145212.64+171458.8',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',NULL,NULL,'15.6g',0.41,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.0527083,17.24967,0.013,NULL,59587618309,931056536,14547758,15.6),(124655,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124655,38.5,0.46,501,56216,70,NULL,NULL,'2MASX J14521267+5533381',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000191,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.053167,55.56058,0.005,NULL,57244366834,894443231,13975675,17.5),(124656,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124656,36.49,0.09,198,56217,70,NULL,NULL,'2MASX J14521293+1726347',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00015,NULL,'15.9g',0.39,'SB0/a','Group member',NULL,NULL,NULL,1,223.053875,17.44297,0.013,NULL,59587603462,931056304,14547754,15.9),(124657,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124657,38.14,0.46,425,56218,70,NULL,NULL,'2MASX J14521291+5325306',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000176,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,223.054,53.42517,0,NULL,59190770006,924855781,14450871,17),(124658,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124658,34.37,0.33,74.9,56219,70,NULL,NULL,'NGC 5771',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000073,NULL,'14.5g',0.72,'E?','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,223.0597083,29.84542,0.028,NULL,60088715534,938886180,14670096,14.5),(124659,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124659,35.03,0.4,102,56219,NULL,NULL,'mean','NGC 5771',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124660,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124660,35.21,0.45,110,56219,NULL,NULL,'K','NGC 5771',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124661,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124661,35.81,0.54,145,56220,70,NULL,NULL,'2MASX J14521508-2904505',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,223.062917,-29.08064,0.245,NULL,47209202918,737643795,11525684,15.6),(124662,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124662,38.06,0.17,410,56221,70,NULL,NULL,'2MASX J14521546+3217066',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.064417,32.28528,0,NULL,60090209192,938909518,14670461,17.8),(124663,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124663,37.61,0.27,332,56222,70,NULL,NULL,'2MASX J14521549+5022246',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000185,NULL,'16.2g',0.44,'BrClG',NULL,NULL,NULL,NULL,1,223.064417,50.37364,0.021,NULL,59943836921,936622451,14634725,16.2),(124664,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124664,36.56,0.55,205,56223,70,NULL,NULL,'2MASX J14521607-0017365',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000101,NULL,'15.6g',0.48,'E0',NULL,NULL,NULL,NULL,1,223.066916667,-0.29364,0.125,NULL,43488327252,679505113,10617267,15.6),(124665,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124665,36.96,0.33,247,56223,70,NULL,NULL,'2MASX J14521607-0017365',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124666,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124666,35.67,0.46,136,56224,70,NULL,NULL,'SDSS J145216.49+121711.5',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',NULL,NULL,'15.1g',0.57,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.06875,12.28653,0.017,NULL,59366494539,927601477,14493773,15.1),(124667,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124667,37.86,0.46,373,56225,70,NULL,NULL,'2MASX J14521725+5110506',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'17.0g',0.3,'AGN',NULL,NULL,NULL,NULL,1,223.0719583,51.18064,0.029,NULL,59929343378,936395990,14631187,17),(124668,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124668,36.26,0.46,178,56226,70,NULL,NULL,'2MASX J14521732+2446337',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.38',0.26,NULL,NULL,NULL,NULL,NULL,1,223.072167,24.77603,0.091,NULL,59492369678,929568276,14524504,17.38),(124669,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124669,37.4,0.27,302,56227,70,NULL,NULL,'2MASX J14521786+4645598',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,223.074375,46.76664,0.017,NULL,59989882053,937341907,14645967,17),(124670,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124670,36.44,0.46,194,56228,70,NULL,NULL,'2MASX J14521927+1102379',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.79',0.16,NULL,NULL,NULL,NULL,NULL,1,223.0802917,11.04386,0.025,NULL,59369766902,927652607,14494571,18.79),(124671,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124671,36.49,0.09,198,56229,70,NULL,NULL,'2MASX J14521952+1704367',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00015,NULL,'18.20',0.3,'E/S0','Group member',NULL,NULL,NULL,1,223.081333,17.07692,0.025,NULL,59585709154,931026705,14547292,18.2),(124672,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124672,38.05,0.46,408,56230,70,NULL,NULL,'2MASX J14521983+2313174',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,223.082583,23.22144,0.132,NULL,59494533355,929602083,14525032,17.5),(124673,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124673,37.8,0.46,362,56231,70,NULL,NULL,'SDSS J145220.22+491006.4',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000188,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,223.0842917,49.16842,0.025,NULL,59935564523,936493195,14632706,16.8),(124674,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124674,37.27,0.46,285,56232,70,NULL,NULL,'2MASX J14522226+1808454',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.48',0.15,NULL,NULL,NULL,NULL,NULL,1,223.0927083,18.14606,0.029,NULL,59587881422,931060647,14547822,18.48),(124675,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124675,36.49,0.09,198,56233,70,NULL,NULL,'CGCG 105-050',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000067,NULL,'15.00',0.8,'S0?','Group member',NULL,NULL,NULL,1,223.095167,17.12158,0.013,NULL,59585697713,931026526,14547289,15),(124676,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124676,36.56,0.25,205,56233,74.4,NULL,NULL,'CGCG 105-050',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124677,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124677,36.79,0.26,228,56233,70,NULL,NULL,'CGCG 105-050',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124678,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124678,37.54,0.46,322,56234,70,NULL,NULL,'2MASX J14522357+0317243',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000111,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,223.098167,3.29006,0.105,NULL,59337913105,927154892,14486795,16.7),(124679,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124679,36.36,0.46,187,56235,70,NULL,NULL,'CGCG 134-045',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00018,NULL,'15.5',0.3,NULL,NULL,NULL,NULL,NULL,1,223.1012917,20.33428,0.061,NULL,59533013329,930203333,14534427,15.5),(124680,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124680,35.8,0.5,144,56236,NULL,NULL,NULL,'2MASX J14522455+1659227',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000026,NULL,'16.96',0.4,'Sc','Group member',NULL,NULL,NULL,1,223.102375,16.98969,0.025,NULL,59585679662,931026244,14547285,16.96),(124681,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124681,35.89,0.48,150,56236,NULL,NULL,'Malmquist cor.','2MASX J14522455+1659227',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124682,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124682,36.02,0.2,160,56236,74.4,NULL,NULL,'2MASX J14522455+1659227',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124683,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124683,37.53,0.46,321,56237,70,NULL,NULL,'2MASX J14522462+2044314',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.30',0.16,NULL,NULL,NULL,NULL,NULL,1,223.102667,20.74211,0.077,NULL,59532589387,930196709,14534323,18.3),(124684,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124684,37.06,0.46,259,56238,70,NULL,NULL,'2MASX J14522501+2525219',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.104333333,25.42267,0.094,NULL,60012647417,937697615,14651525,17.4),(124685,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124685,37.13,0.46,267,56239,70,NULL,NULL,'2MASX J14522514+0517203',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,223.104833,5.28903,0.101,NULL,59336748117,927136689,14486510,17.3),(124686,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124686,37.59,0.46,329,56240,70,NULL,NULL,'SDSS J145225.36+105632.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000136,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.1057083,10.94231,0.025,NULL,59369768226,927652628,14494572,17.9),(124687,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124687,37.8,0.46,364,56241,70,NULL,NULL,'2MASX J14522563+5734380',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000182,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.10675,57.57719,0,NULL,57728270846,902004231,14093816,17.8),(124688,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124688,38.25,0.46,447,56242,70,NULL,NULL,'2MASX J14522794+0806195',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,223.116375,8.10531,0.053,NULL,59381465830,927835403,14497428,17.4),(124689,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124689,37.78,0.33,360,56243,70,NULL,NULL,'2MASX J14522860-0203215',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000158,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,223.1192917,-2.05597,0.201,NULL,43489682790,679526293,10617598,17.1),(124690,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124690,36.44,0.42,194,56244,NULL,NULL,'Malmquist cor.','2MASX J14522928+1620515',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000023,NULL,'17.35',0.4,'SBbc','Group member',NULL,NULL,NULL,1,223.122041667,16.34764,0.013,NULL,59585403539,931021930,14547217,17.35),(124691,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124691,36.62,0.39,211,56244,NULL,NULL,NULL,'2MASX J14522928+1620515',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124692,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124692,36.66,0.2,215,56244,74.4,NULL,NULL,'2MASX J14522928+1620515',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124693,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124693,34.37,0.33,74.9,56245,70,NULL,NULL,'NGC 5773',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000067,NULL,'14.47',0.9,'Sab','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,223.12675,29.80739,0.028,NULL,60092975793,938952746,14671136,14.47),(124694,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124694,37.42,0.46,305,56246,70,NULL,NULL,'2MASX J14523065+3614351',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000209,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,223.127958333,36.24311,0.008,NULL,60125549510,939461711,14679089,16.3),(124695,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124695,36.1,0.27,166,56247,70,NULL,NULL,'2MASX J14523128+5524262',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000197,NULL,'15.1g',0.61,'E0',NULL,NULL,NULL,NULL,1,223.1305417,55.40714,0.013,NULL,57244331520,894442680,13975666,15.1),(124696,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124696,38.81,0.46,578,56248,70,NULL,NULL,'2MASX J14523367+1120225',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000181,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.1402917,11.33969,0.049,NULL,59370151788,927658621,14494665,17.8),(124697,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124697,37,0.46,251,56249,70,NULL,NULL,'2MASX J14523428+5837083',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000073,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,223.142958333,58.61889,0.005,NULL,57724884802,901951325,14092989,17.3),(124698,'Tully est','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124698,32.44,0.8,30.7,56250,75,NULL,NULL,'UGCA 396',NULL,'1988NBGC.C....0000T',1988,1,2.9,NULL,'G',0.000013,NULL,'13.5',2.4,'SB(s)dm pec',NULL,NULL,NULL,NULL,1,223.1449583,-3.56156,0.197,NULL,46445787007,725715421,11339303,13.5),(124699,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124699,30.9,0.43,15.1,56250,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 396',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124700,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124700,32.18,NULL,27.3,56250,72,NULL,NULL,'UGCA 396',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124701,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124701,36.28,0.33,180,56251,70,NULL,NULL,'CGCG 048-041',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000118,NULL,'14.9g',0.52,'S0/a',NULL,NULL,NULL,NULL,1,223.14675,4.54589,0.117,NULL,59334039084,927094360,14485849,14.9),(124702,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124702,37.63,0.46,335,56252,70,NULL,NULL,'VII Zw 566',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000177,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,223.1504583,63.06547,0.013,NULL,57756120198,902439378,14100615,16.4),(124703,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124703,36.18,0.46,173,56253,70,NULL,NULL,'CGCG 076-082',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000168,NULL,'15.5g',0.46,NULL,NULL,NULL,NULL,NULL,1,223.151083,12.04764,0.021,NULL,59366679605,927604368,14493818,15.5),(124704,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124704,37.73,0.46,352,56254,70,NULL,NULL,'2MASX J14523669+1756446',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.8g',0.34,NULL,NULL,NULL,NULL,NULL,1,223.153083,17.94569,0.013,NULL,59588362161,931068158,14547939,16.8),(124705,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124705,37.03,0.46,255,56255,70,NULL,NULL,'2MASX J14523716+2352100',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000165,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,223.154917,23.86939,0.108,NULL,59495673329,929619895,14525310,17.1),(124706,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124706,37.28,0.46,286,56256,70,NULL,NULL,'2MASX J14523873+2649279',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.41',0.15,NULL,NULL,NULL,NULL,NULL,1,223.161333,26.82436,0.146,NULL,60016024294,937750379,14652349,18.41),(124707,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124707,37.81,0.46,365,56257,70,NULL,NULL,'2MASX J14523931+3103362',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000135,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.163875,31.06003,0.048,NULL,60090965757,938921339,14670645,18),(124708,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124708,37.47,0.46,311,56258,70,NULL,NULL,'2MASX J14524000+2535299',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.166583333,25.59169,0.13,NULL,60012849187,937700768,14651574,17.9),(124709,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124709,37.14,0.46,268,56259,70,NULL,NULL,'2MASX J14524078+2906589',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.0002,NULL,'18.58',0.13,NULL,NULL,NULL,NULL,NULL,1,223.16975,29.11644,0,NULL,60093086091,938954470,14671163,18.58),(124710,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124710,37.65,0.33,340,56260,70,NULL,NULL,'2MASX J14524123+3247332',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.171917,32.79256,0,NULL,60122838323,939419348,14678427,17.8),(124711,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124711,35.97,0.33,156,56261,70,NULL,NULL,'NGC 5769',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000123,NULL,'14.9',0.3,'E','Group member',NULL,NULL,NULL,1,223.1730417,7.93181,0.053,NULL,59381556959,927836827,14497450,14.9),(124712,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124712,38.39,0.33,477,56262,70,NULL,NULL,'SDSS J145241.80+212335.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.174167,21.39311,0.089,NULL,59540320021,930317500,14536210,17.9),(124713,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124713,35.22,0.27,111,56263,70,NULL,NULL,'CGCG 048-044',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000107,NULL,'15.0g',0.57,'E0','Group member',NULL,NULL,NULL,1,223.1795,3.22483,0.105,NULL,59337920318,927155004,14486796,15),(124714,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124714,36.49,0.09,198,56264,70,NULL,NULL,'CGCG 105-053',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00011,NULL,'15.02',0.5,'E;BrClG','Group member',NULL,NULL,NULL,1,223.18025,16.90375,0.025,NULL,59585800872,931028138,14547314,15.02),(124715,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124715,36.56,0.25,205,56264,74.4,NULL,NULL,'CGCG 105-053',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124716,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124716,36.79,0.26,228,56264,70,NULL,NULL,'CGCG 105-053',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124717,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124717,36.49,0.09,198,56265,70,NULL,NULL,'SDSS J145243.42+164326.4',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.1809583,16.724,0.005,NULL,59585773235,931027706,14547307,17),(124718,'BCG','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124718,37.52,0.35,306,56266,60,NULL,NULL,'ABELL 1983',0.0438,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III:   [BM]',NULL,NULL,NULL,NULL,1,223.183333,16.74606,0.005,NULL,59585771251,931027675,14547307,NULL),(124719,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124719,36.5,0.17,200,56266,70,NULL,NULL,'ABELL 1983',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124720,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124720,31.8,NULL,22.9,56267,72,NULL,NULL,'AGC 249264',NULL,'2014Ap.....57..457K',2014,1,NULL,NULL,'RadioS',0.000057,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,223.184167,4.60972,0.109,NULL,59335927444,927123866,14486310,NULL),(124721,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124721,36.55,0.43,204,56268,NULL,NULL,'Malmquist cor.','2MASX J14524547+1649237',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000023,NULL,'17.30',0.3,'Sc','Group member',NULL,NULL,NULL,1,223.1894583,16.82333,0.005,NULL,59585796717,931028073,14547313,17.3),(124722,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124722,36.78,0.39,227,56268,NULL,NULL,NULL,'2MASX J14524547+1649237',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124723,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124723,36.82,0.2,231,56268,74.4,NULL,NULL,'2MASX J14524547+1649237',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124724,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124724,37.44,0.46,308,56269,70,NULL,NULL,'2MASX J14524821+3141513',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00018,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,223.200875,31.6975,0,NULL,60090366647,938911978,14670499,16.7),(124725,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124725,38.06,0.17,410,56270,70,NULL,NULL,'2MASX J14524879+3221013',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000147,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,223.203333,32.35033,0.028,NULL,60090167962,938908874,14670451,17.4),(124726,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124726,38.21,0.46,439,56271,70,NULL,NULL,'2MASX J14524908+2808179',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'18.27',0.14,NULL,NULL,NULL,NULL,NULL,1,223.204375,28.13844,0,NULL,60081374243,938771472,14668304,18.27),(124727,'SZ effect','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124727,39.73,NULL,885,56272,NULL,NULL,NULL,'ABELL 1995',NULL,'2005ApJ...625..108D',2005,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,223.23375,58.04889,0.005,NULL,57727790395,901996724,14093698,NULL),(124728,'SZ effect','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124728,40.06,NULL,1030,56272,NULL,NULL,'3.1 (red) calibration','ABELL 1995',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124729,'SZ effect','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124729,40.25,NULL,1120,56272,NULL,NULL,NULL,'ABELL 1995',NULL,'2002ApJ...581...53R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124730,'SZ effect','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124730,40.38,0.25,1190,56272,NULL,NULL,'Hydrost. Eq.','ABELL 1995',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124731,'SZ effect','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124731,40.38,NULL,1190,56272,NULL,NULL,'4.2 (black) calibration','ABELL 1995',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124732,'SZ effect','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124732,40.4,0.35,1200,56272,NULL,NULL,'Isotherm., r < 100 kpc','ABELL 1995',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124733,'SZ effect','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124733,40.56,0.44,1290,56272,NULL,NULL,NULL,'ABELL 1995',NULL,'2000ApJ...541...37P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124734,'SZ effect','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124734,40.57,0.32,1300,56272,NULL,NULL,'Isotherm.','ABELL 1995',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124735,'SZ effect','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124735,40.64,NULL,1340,56272,NULL,NULL,'4.1 (blue) calibration','ABELL 1995',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124736,'SZ effect','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124736,41.33,0.42,1840,56272,NULL,NULL,NULL,'ABELL 1995',NULL,'2001PhDT.........5P',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124737,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124737,37.22,0.23,278,56273,70,NULL,NULL,'2MASX J14525046+1804320',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'18.29',0.16,NULL,NULL,NULL,NULL,NULL,1,223.210333333,18.07564,0.021,NULL,59587823512,931059742,14547808,18.29),(124738,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124738,37.25,0.46,281,56274,70,NULL,NULL,'2MASX J14525120-0044234',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000096,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,223.21325,-0.73994,0.141,NULL,43490283938,679535686,10617745,16.3),(124739,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124739,38.89,0.46,599,56275,70,NULL,NULL,'SDSS J145251.43+004414.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000073,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,223.214333333,0.73739,0.133,NULL,58254041801,910219403,14222178,18.6),(124740,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124740,37.47,0.46,312,56276,70,NULL,NULL,'2MASX J14525145+4413592',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000164,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,223.214417,44.23322,0.049,NULL,59993135501,937392742,14646761,16.8),(124741,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124741,35.97,0.33,156,56277,70,NULL,NULL,'2MASX J14525190+0754033',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,223.21625,7.90083,0.053,NULL,59381584053,927837250,14497457,16.5),(124742,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124742,37.21,0.46,277,56278,70,NULL,NULL,'2MASX J14525234-0128384',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,223.218125,-1.47739,0.153,NULL,43490610660,679540791,10617824,16.5),(124743,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124743,38.39,0.33,477,56279,70,NULL,NULL,'SDSS J145253.00+211945.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.220875,21.32922,0.089,NULL,59540322190,930317534,14536211,18.2),(124744,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124744,38.42,0.46,483,56280,70,NULL,NULL,'2MASX J14525325+3353473',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000162,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,223.222,33.8965,0,NULL,60122583897,939415373,14678365,17.3),(124745,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124745,37.5,0.46,316,56281,70,NULL,NULL,'2MASX J14525363+1602048',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.93',0.18,'Sa/0','Group member',NULL,NULL,NULL,1,223.223583,16.03469,0.017,NULL,59589678565,931088727,14548261,17.93),(124746,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124746,37.83,0.33,369,56282,70,NULL,NULL,'2MASX J14525441+3118053',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,223.226833333,31.30156,0,NULL,60090980384,938921568,14670649,17.7),(124747,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124747,37.61,0.27,332,56283,70,NULL,NULL,'2MASX J14525482+5010331',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.228417,50.17586,0,NULL,59943355921,936614936,14634608,17.7),(124748,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124748,31.73,NULL,22.2,56284,72,NULL,NULL,'MCG -01-38-005',NULL,'2014Ap.....57..457K',2014,1,1.1,NULL,'G',0.0001,NULL,'15.03',0.5,'IBm?',NULL,NULL,NULL,NULL,1,223.2287917,-3.82678,0.225,NULL,46445765686,725715088,11339298,15.03),(124749,'BCG','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124749,37.52,0.35,306,56285,60,NULL,'ABELL 1983, BCG','GIN 363',0.0438,'1980ApJ...241..486H',1980,1,1.3,NULL,'G',0.000063,NULL,'14.55',0.9,'E;cD;BrClG','Group member, 2nd ranked galaxy',NULL,NULL,NULL,1,223.230417,16.70292,0.017,NULL,59585767644,931027619,14547306,14.55),(124750,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124750,36.55,0.25,204,56285,74.4,NULL,NULL,'GIN 363',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124751,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124751,36.79,0.26,228,56285,70,NULL,NULL,'GIN 363',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124752,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124752,36.5,0.17,200,56285,70,NULL,'ABELL 1983, BGC','GIN 363',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124753,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124753,36.49,0.09,198,56286,70,NULL,NULL,'SDSS J145255.31+164210.2',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',NULL,'PHOT','15.2g',0.62,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.2305,16.70286,0.017,NULL,59585767644,931027619,14547306,15.2),(124754,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124754,38,0.46,399,56287,70,NULL,NULL,'2MASX J14525616+6045525',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000073,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,223.234291667,60.76458,0,NULL,57778928744,902795761,14106183,18.1),(124755,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124755,38.33,0.46,464,56288,70,NULL,NULL,'2MASX J14525650+2207010',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000189,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,223.235375,22.11703,0.089,NULL,59526843091,930106923,14532920,17.6),(124756,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124756,36.79,0.26,228,56289,70,NULL,NULL,'CGCG 105-055',NULL,'2001MNRAS.321..277C',2001,1,0.8,NULL,'G',0.00008,NULL,'14.53',0.8,'SBa','Group member',NULL,NULL,NULL,1,223.2369583,16.72794,0.017,NULL,59585768239,931027628,14547306,14.53),(124757,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124757,36.49,0.09,198,56290,70,NULL,NULL,'SDSS J145257.75+164149.5',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'15.7g',0.36,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.240667,16.69708,0.017,NULL,59585774638,931027728,14547308,15.7),(124758,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124758,36.56,0.25,205,56291,74.4,NULL,NULL,'CGCG 105-056',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.000047,NULL,'15.2V',1.7,'E','Group member',NULL,NULL,NULL,1,223.240708333,16.69703,0.017,NULL,59585774638,931027728,14547308,15.2),(124759,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124759,36.79,0.26,228,56291,70,NULL,NULL,'CGCG 105-056',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124760,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124760,36.53,0.4,203,56291,NULL,NULL,'mean','CGCG 105-056',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124761,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124761,37.51,0.45,318,56291,NULL,NULL,'K','CGCG 105-056',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124762,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124762,38.22,0.46,440,56292,70,NULL,NULL,'2MASX J14525796+0141201',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000086,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,223.241583333,1.68911,0.121,NULL,58252333802,910192715,14221761,17.1),(124763,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124763,36.89,0.46,239,56293,70,NULL,NULL,'2MASX J14530014+2725297',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.12',0.16,NULL,NULL,NULL,NULL,NULL,1,223.250583,27.42494,0.074,NULL,60013921466,937717522,14651836,18.12),(124764,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124764,37.98,0.46,395,56294,70,NULL,NULL,'2MASX J14530040+3102253',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000191,NULL,'17.90',0.2,NULL,NULL,NULL,NULL,NULL,1,223.2515417,31.04036,0.048,NULL,60090786669,938918541,14670602,17.9),(124765,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124765,36.49,0.09,198,56295,70,NULL,NULL,'2MASX J14530086+1640577',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000083,NULL,'18.02',0.2,'E','Group member',NULL,NULL,NULL,1,223.253667,16.68258,0.013,NULL,59585788123,931027939,14547311,18.02),(124766,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124766,36.46,0.5,196,56296,70,NULL,NULL,'MCG -03-38-022',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.5',0.4,NULL,NULL,NULL,NULL,NULL,1,223.254958333,-15.88278,0.437,NULL,46705924308,729780067,11402813,15.5),(124767,'IRAS','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124767,34.38,0.8,75.1,56297,75,NULL,'MAT, I','ESO 327- G 027',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000033,NULL,'14.25',0.5,'Sb-c',NULL,NULL,NULL,NULL,1,223.256167,-39.92033,0.101,NULL,47215889166,737748268,11527316,14.25),(124768,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124768,33.76,0.32,56.5,56297,85,NULL,'I, raw','ESO 327- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124769,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124769,33.76,0.32,56.6,56297,85,NULL,'I, inv','ESO 327- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124770,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124770,34.03,0.43,64,56297,75,NULL,'MAT, I, raw','ESO 327- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124771,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124771,34.04,0.44,64.3,56297,NULL,NULL,'Malmquist cor.','ESO 327- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124772,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124772,34.06,0.44,64.8,56297,NULL,NULL,NULL,'ESO 327- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124773,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124773,34.1,0.43,66,56297,75,NULL,'MAT, I, inv','ESO 327- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124774,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124774,34.1,0.2,66.1,56297,74.4,NULL,NULL,'ESO 327- G 027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124775,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124775,34.21,0.43,69.6,56297,75,NULL,'MAT, I, cor','ESO 327- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124776,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124776,34.26,0.49,71,56297,75,NULL,'IR','ESO 327- G 027',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124777,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124777,37.85,0.46,371,56298,70,NULL,NULL,'SDSS J145301.59+101433.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,223.256667,10.24269,0.033,NULL,59368722976,927636296,14494317,18.1),(124778,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124778,37.61,0.27,332,56299,70,NULL,NULL,'2MASX J14530158+5015242',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00018,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,223.256667,50.25686,0.021,NULL,59943829706,936622339,14634724,17),(124779,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124779,37.22,0.33,278,56300,70,NULL,NULL,'2MASX J14530188+2519417',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.11',0.15,NULL,NULL,NULL,NULL,NULL,1,223.2577917,25.32817,0.13,NULL,60012858610,937700915,14651576,18.11),(124780,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124780,37.98,0.46,395,56301,70,NULL,NULL,'2MASX J14530200+4659412',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000179,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,223.2582917,46.99497,0.009,NULL,59990044844,937344450,14646007,17.3),(124781,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124781,32.14,0.4,26.8,56302,NULL,NULL,'mean','IC 1066',NULL,'2007A&A...465...71T',2007,1,1.28,NULL,'G',0.00002,NULL,'13.9g',0.7,'Sab            HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,223.261917,3.29603,0.101,NULL,59338084659,927157572,14486837,13.9),(124782,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124782,32.65,0.47,33.9,56302,NULL,NULL,'H','IC 1066',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124783,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124783,32.67,0.45,34.2,56302,NULL,NULL,'K','IC 1066',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124784,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124784,32.7,0.46,34.6,56302,NULL,NULL,'J','IC 1066',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124785,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124785,37.83,0.33,369,56303,70,NULL,NULL,'SDSS J145304.58+311248.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.269125,31.21353,0.048,NULL,60090988304,938921692,14670651,18.2),(124786,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124786,36.89,0.59,238,56304,NULL,NULL,'Malmquist cor.','2MASX J14530511+1708247',NULL,'2009ApJS..182..474S',2009,1,0.34,NULL,'G',0.000023,NULL,'16.42',0.1,'Sc',NULL,NULL,NULL,NULL,1,223.27125,17.14025,0.013,NULL,59585826362,931028536,14547320,16.42),(124787,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124787,37.21,0.51,277,56304,NULL,NULL,NULL,'2MASX J14530511+1708247',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124788,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124788,37.25,0.2,282,56304,74.4,NULL,NULL,'2MASX J14530511+1708247',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124789,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124789,37.84,0.46,370,56305,70,NULL,NULL,'2MASX J14530522+2830147',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,223.27175,28.50422,0,NULL,60081513519,938773648,14668338,17.7),(124790,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124790,37.57,0.46,327,56306,70,NULL,NULL,'2MASX J14530535-0146094',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000175,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,223.272417,-1.76928,0.165,NULL,43488996893,679515576,10617430,17),(124791,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124791,37.19,0.61,274,56307,70,NULL,NULL,'2MASX J14530574-1931349',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,223.273916667,-19.52644,0.361,NULL,46651476488,728929320,11389520,15.4),(124792,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124792,35.79,0.27,144,56308,70,NULL,NULL,'CGCG 193-007',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000107,NULL,'15.0g',0.54,'S0^-',NULL,NULL,NULL,NULL,1,223.2744583,36.92439,0.04,NULL,60118093482,939345210,14677268,15),(124793,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124793,37.95,0.46,389,56309,70,NULL,NULL,'SDSS J145307.26+575208.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000075,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,223.28025,57.86906,0.005,NULL,57727998999,901999984,14093749,18.5),(124794,'IRAS','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124794,33.66,0.8,53.9,56310,75,NULL,'MAT, I','ESO 580- G 049',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000017,NULL,'15.13',0.3,'Sbc: sp',NULL,NULL,NULL,NULL,1,223.28275,-19.73697,0.369,NULL,46652275857,728941810,11389715,15.13),(124795,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124795,32.79,0.32,36.1,56310,85,NULL,'I, inv','ESO 580- G 049',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124796,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124796,32.79,0.32,36.2,56310,85,NULL,'I, raw','ESO 580- G 049',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124797,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124797,33.1,0.43,41.6,56310,75,NULL,'MAT, I, raw','ESO 580- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124798,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124798,33.15,0.43,42.7,56310,75,NULL,'MAT, I, inv','ESO 580- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124799,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124799,33.28,0.43,45.3,56310,75,NULL,'MAT, I, cor','ESO 580- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124800,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124800,33.38,0.41,47.3,56310,NULL,NULL,'Malmquist cor.','ESO 580- G 049',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124801,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124801,33.52,0.49,50.6,56310,75,NULL,'IR','ESO 580- G 049',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124802,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124802,33.59,0.43,52.3,56310,75,NULL,'3.6 micron, color + selection bias corrected','ESO 580- G 049',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124803,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124803,33.6,0.43,52.5,56310,75,NULL,'3.6 micron, color corrected','ESO 580- G 049',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124804,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124804,33.63,0.2,53.2,56310,74.4,NULL,NULL,'ESO 580- G 049',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124805,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124805,33.78,0.34,57,56310,NULL,NULL,NULL,'ESO 580- G 049',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124806,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124806,37.97,0.11,392,56311,70,NULL,NULL,'2MASX J14530838+5408103',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000179,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,223.285,54.13622,0,NULL,59191063872,924860373,14450943,17.9),(124807,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124807,37.15,0.33,269,56312,70,NULL,NULL,'2MASX J14530851+0447069',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00009,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,223.285541667,4.78525,0.117,NULL,59335992046,927124875,14486326,16.4),(124808,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124808,36.49,0.09,198,56313,70,NULL,NULL,'CGCG 105-058',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00015,NULL,'15.7',0.4,'S0','Group member',NULL,NULL,NULL,1,223.286583,17.04414,0.013,NULL,59585838433,931028725,14547323,15.7),(124809,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124809,37.84,0.46,370,56314,70,NULL,NULL,'2MASX J14530932+2241086',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.2887083,22.68567,0.102,NULL,59526751528,930105492,14532898,17.7),(124810,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124810,36.57,0.25,206,56315,74.4,NULL,NULL,'CGCG 105-057',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'GPair',0.00015,NULL,NULL,NULL,'S0?','Group member',NULL,NULL,NULL,1,223.288917,16.66586,0.013,NULL,59585788994,931027953,14547311,NULL),(124811,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124811,38.37,0.46,471,56316,70,NULL,NULL,'2MASX J14531059+3315160',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000176,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.294083,33.25453,0,NULL,60122893924,939420217,14678440,17.9),(124812,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124812,35.79,0.27,144,56317,70,NULL,NULL,'MCG +06-33-006',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000168,NULL,'15.8g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,223.294917,36.91381,0.04,NULL,60118093713,939345214,14677268,15.8),(124813,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124813,37.03,0.1,254,56318,70,NULL,NULL,'2MASX J14531090+1805476',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.23',0.16,NULL,NULL,NULL,NULL,NULL,1,223.295333333,18.09653,0.021,NULL,59586710571,931042352,14547536,18.23),(124814,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124814,36.49,0.09,198,56319,70,NULL,NULL,'2MASX J14531137+1635277',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000093,NULL,'18.63',0.15,'E',NULL,NULL,NULL,NULL,1,223.2975417,16.59097,0.013,NULL,59585778748,931027792,14547309,18.63),(124815,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124815,37.45,0.46,310,56320,70,NULL,NULL,'2MASX J14531172+1312517',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.96',0.14,NULL,NULL,NULL,NULL,NULL,1,223.2987917,13.21433,0.037,NULL,59550337456,930474022,14538656,18.96),(124816,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124816,35.62,0.48,133,56321,NULL,NULL,NULL,'AGC 240869',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000023,NULL,'15.7V',0.5,'Sab            AGN','Group member',NULL,NULL,NULL,1,223.299083,16.92347,0.021,NULL,59585855472,931028991,14547327,15.7),(124817,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124817,35.63,0.48,134,56321,NULL,NULL,'Malmquist cor.','AGC 240869',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124818,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124818,35.66,0.2,136,56321,74.4,NULL,NULL,'AGC 240869',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124819,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124819,37.11,0.46,265,56322,70,NULL,NULL,'2MASX J14531188+2941567',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,223.2995,29.69908,0.028,NULL,60093752171,938964877,14671326,17.6),(124820,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124820,35.79,0.27,144,56323,70,NULL,NULL,'2MASX J14531265+3652596',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00016,NULL,'16.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,223.30275,36.88319,0.04,NULL,60118092503,939345195,14677268,16.2),(124821,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124821,37.22,0.23,278,56324,70,NULL,NULL,'2MASX J14531307+1807296',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.37',0.18,NULL,NULL,NULL,NULL,NULL,1,223.304583,18.12494,0.021,NULL,59586722457,931042538,14547539,18.37),(124822,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124822,36.75,0.46,224,56325,70,NULL,NULL,'2MASX J14531317+2935477',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000163,NULL,'16.5g',0.37,'S0',NULL,NULL,NULL,NULL,1,223.3050417,29.59656,0.023,NULL,60093012478,938953319,14671145,16.5),(124823,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124823,36.49,0.09,198,56326,70,NULL,NULL,'SDSS J145313.70+170049.6',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00015,NULL,'18.09',0.3,'S0','Group member',NULL,NULL,NULL,1,223.307083,17.01381,0.013,NULL,59585835093,931028673,14547323,18.09),(124824,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124824,37.44,0.46,307,56327,70,NULL,NULL,'2MASX J14531374+0039229',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000079,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,223.3072917,0.65647,0.133,NULL,58254076013,910219937,14222186,17),(124825,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124825,38.37,0.46,473,56328,70,NULL,NULL,'2MASX J14531422+2205476',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.48',0.13,NULL,NULL,NULL,NULL,NULL,1,223.309333,22.09656,0.057,NULL,59526712219,930104878,14532888,18.48),(124826,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124826,37.03,0.1,254,56329,70,NULL,NULL,'2MASX J14531469+1809076',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.15',0.18,NULL,NULL,NULL,NULL,NULL,1,223.31125,18.15228,0.025,NULL,59586723313,931042551,14547539,18.15),(124827,'SBF','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124827,31.39,0.29,19,56330,NULL,NULL,'I','NGC 5770',NULL,'2001ApJ...546..681T',2001,1,1.7,NULL,'G',0.000017,NULL,'13.15',1.3,'SB0','in a radial-velocity based grouping',NULL,NULL,NULL,1,223.312583333,3.95972,0.129,NULL,59334076305,927094942,14485858,13.15),(124828,'SBF','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124828,31.42,0.14,19.2,56330,74.4,NULL,NULL,'NGC 5770',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124829,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124829,31.86,0.45,23.5,56330,NULL,NULL,'K','NGC 5770',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124830,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124830,31.96,0.4,24.7,56330,NULL,NULL,'mean','NGC 5770',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124831,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124831,37.28,0.46,286,56331,70,NULL,NULL,'2MASX J14531667+0446489',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000075,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,223.319625,4.78031,0.117,NULL,59335993854,927124903,14486326,17.1),(124832,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124832,38.07,0.46,412,56332,70,NULL,NULL,'2MASX J14531680+0805333',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,223.319916667,8.09256,0.057,NULL,59381470003,927835468,14497429,17.3),(124833,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124833,37.15,0.33,269,56333,70,NULL,NULL,'2MASX J14531701+0447359',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,223.32075,4.79339,0.117,NULL,59336025839,927125403,14486334,16.6),(124834,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124834,36.49,0.09,198,56334,70,NULL,NULL,'2MASX J14531708+1731248',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.19',0.16,'AGN',NULL,NULL,NULL,NULL,1,223.321333,17.52353,0.029,NULL,59587681034,931057516,14547773,18.19),(124835,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124835,36.88,0.46,238,56335,70,NULL,NULL,'2MASX J14531722+5749405',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,223.321583,57.82781,0,NULL,57728002670,902000041,14093750,17.1),(124836,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124836,36.49,0.09,198,56336,70,NULL,NULL,'CGCG 105-059',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000097,NULL,'15.7',0.5,'S0','Group member',NULL,NULL,NULL,1,223.328833,16.64214,0.013,NULL,59585789489,931027960,14547311,15.7),(124837,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124837,37.07,0.46,259,56337,70,NULL,NULL,'2MASX J14531963+2745467',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.23',0.16,NULL,NULL,NULL,NULL,NULL,1,223.332,27.76314,0.083,NULL,60081725944,938776967,14668390,18.23),(124838,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124838,36.56,0.33,205,56338,70,NULL,NULL,'2MASX J14532027+0917161',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000187,NULL,'16.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,223.334625,9.28769,0.045,NULL,59375848722,927747636,14496056,16.1),(124839,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124839,37.97,0.11,392,56339,70,NULL,NULL,'2MASX J14532051+5408125',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000165,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,223.335625,54.13672,0,NULL,59191066368,924860412,14450943,16.5),(124840,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124840,36.65,0.46,214,56340,70,NULL,NULL,'2MASX J14532098+0358010',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000086,NULL,'16.9g',0.23,'NLAGN',NULL,NULL,NULL,'Sy 2',1,223.337375,3.96694,0.129,NULL,59334080059,927095000,14485859,16.9),(124841,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124841,37.17,0.27,272,56341,70,NULL,NULL,'2MASX J14532119+5502195',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000188,NULL,'15.5g',0.54,'BrClG',NULL,NULL,NULL,NULL,1,223.338416667,55.03889,0.009,NULL,57244898263,894451535,13975805,15.5),(124842,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124842,38.14,0.46,425,56342,70,NULL,NULL,'2MASX J14532363+1618108',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.98',0.13,NULL,NULL,NULL,NULL,NULL,1,223.348333,16.30311,0.013,NULL,59589659568,931088430,14548256,18.98),(124843,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124843,37.79,0.46,362,56343,70,NULL,NULL,'SDSS J145323.82-000451.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000091,NULL,'18.4g',0.14,'NLAGN',NULL,NULL,NULL,NULL,1,223.3492917,-0.08097,0.133,NULL,43488143505,679502242,10617222,18.4),(124844,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124844,37.97,0.11,392,56344,70,NULL,NULL,'2MASX J14532418+5419485',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000123,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,223.350875,54.33019,0,NULL,59190985071,924859141,14450924,17.3),(124845,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124845,36.71,0.46,219,56345,70,NULL,NULL,'2MASX J14532426+3851576',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000158,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,223.350916667,38.86594,0.043,NULL,60071381351,938615333,14665864,16.8),(124846,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124846,37.03,0.1,254,56346,70,NULL,NULL,'2MASX J14532426+1829285',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.0001,NULL,'17.21',0.5,'E/S0','Group member',NULL,NULL,NULL,1,223.3509583,18.49142,0.025,NULL,59586848891,931044513,14547570,17.21),(124847,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124847,36.49,0.09,198,56347,70,NULL,NULL,'2MASX J14532456+1639435',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000093,NULL,'16.8g',0.23,'E','Group member',NULL,NULL,NULL,1,223.352333,16.662,0.017,NULL,59585787471,931027929,14547311,16.8),(124848,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124848,36.57,0.46,206,56348,70,NULL,NULL,'LCRS B145049.0-023456',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,223.3537083,-2.78578,0.213,NULL,46440642254,725635035,11338047,17.8),(124849,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124849,34.8,0.49,91,56349,75,NULL,'IR','MCG -01-38-007',NULL,'2011yCatp016004901K',2011,1,1.6,NULL,'G',0.00001,NULL,'15',0.4,'Sc: sp',NULL,NULL,NULL,NULL,1,223.356167,-4.69786,0.165,NULL,46446918377,725733099,11339579,15),(124850,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124850,35.16,0.2,108,56349,74.4,NULL,NULL,'MCG -01-38-007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124851,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124851,35.31,0.41,115,56349,NULL,NULL,'Malmquist cor.','MCG -01-38-007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124852,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124852,35.42,0.39,121,56349,NULL,NULL,NULL,'MCG -01-38-007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124853,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124853,37.69,0.46,345,56350,70,NULL,NULL,'2MASX J14532548+1030551',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000177,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,223.356291667,10.51547,0.029,NULL,59368799856,927637497,14494335,17.3),(124854,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124854,38.74,0.46,560,56351,70,NULL,NULL,'2MASX J14532552+5549385',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.3564583,55.82728,0,NULL,57714148745,901783574,14090368,17.7),(124855,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124855,37.3,0.46,289,56352,70,NULL,NULL,'2MASX J14532616+0533070',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,223.3589583,5.55181,0.097,NULL,59335059504,927110304,14486098,16.8),(124856,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124856,37.8,0.46,363,56353,70,NULL,NULL,'2MASX J14532721+0757421',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.363333,7.96175,0.053,NULL,59381644764,927838199,14497471,17.5),(124857,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124857,32.85,0.4,37.1,56354,75,NULL,'B','NGC 5783',NULL,'1988NBGC.C....0000T',1988,1,2.9,NULL,'G',0.00001,NULL,'13.5',1.8,'SAB(s)c','Field galaxy',NULL,NULL,NULL,1,223.3679583,52.07611,0.013,NULL,59929953639,936405525,14631336,13.5),(124858,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124858,32.91,0.4,38.2,56354,NULL,NULL,NULL,'NGC 5783',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124859,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124859,32.98,0.2,39.5,56354,74.4,NULL,NULL,'NGC 5783',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124860,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124860,33.02,0.43,40.2,56354,75,NULL,'3.6 micron, color corrected','NGC 5783',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124861,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124861,33.12,0.43,42,56354,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5783',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124862,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124862,35.85,0.46,148,56355,70,NULL,NULL,'2MASX J14532853+0050020',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000069,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,223.368916667,0.834,0.129,NULL,58254641533,910228773,14222324,16.6),(124863,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124863,37.17,0.27,272,56356,70,NULL,NULL,'2MASX J14532931+5507316',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000182,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,223.372,55.12556,0.017,NULL,57244902666,894451604,13975806,16.5),(124864,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124864,37.17,0.27,272,56357,70,NULL,NULL,'SDSS J145329.62+550146.8',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,223.373417,55.02967,0.009,NULL,57244853111,894450829,13975794,17.8),(124865,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124865,37.61,0.46,332,56358,70,NULL,NULL,'2MASX J14532968+4716086',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,223.373667,47.26917,0.037,NULL,59990015642,937343994,14645999,18.1),(124866,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124866,36.49,0.09,198,56359,70,NULL,NULL,'2MASX J14533014+1627575',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000073,NULL,'18.28',0.2,'E','Group member',NULL,NULL,NULL,1,223.3757083,16.46603,0.017,NULL,59590117583,931095587,14548368,18.28),(124867,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124867,36.59,0.46,208,56360,70,NULL,NULL,'2MASX J14533106+2750004',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,223.379375,27.83342,0.036,NULL,60081762156,938777533,14668398,16.2),(124868,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124868,36.84,0.33,233,56361,70,NULL,NULL,'2MASX J14533115+1421125',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.78',0.21,NULL,NULL,NULL,NULL,NULL,1,223.379875,14.35356,0.041,NULL,59548340971,930442827,14538169,16.78),(124869,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124869,37.03,0.62,254,56362,70,NULL,NULL,'2MASX J14533169-2334257',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,223.382,-23.57383,0.441,NULL,46524841048,726950641,11358603,15.6),(124870,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124870,36.51,0.46,200,56363,70,NULL,NULL,'2MASX J14533223+4126306',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000176,NULL,'15.8g',0.32,'S0',NULL,NULL,NULL,NULL,1,223.38425,41.44192,0,NULL,59949699306,936714051,14636157,15.8),(124871,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124871,38.36,0.46,471,56364,70,NULL,NULL,'LCRS B145056.8-024224',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000165,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,223.386333333,-2.90997,0.217,NULL,46440624838,725634763,11338043,18.4),(124872,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124872,35.22,0.27,111,56365,70,NULL,NULL,'IC 1068',NULL,'2015arXiv151105856S',2015,1,0.91,NULL,'G',0.000077,NULL,'14.3g',0.74,'E0',NULL,NULL,NULL,NULL,1,223.387167,3.07731,0.125,NULL,59337965721,927155714,14486808,14.3),(124873,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124873,38.17,0.46,430,56366,70,NULL,NULL,'2MASX J14533313+2039503',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.52',0.15,NULL,NULL,NULL,NULL,NULL,1,223.3879583,20.66383,0.077,NULL,59532616423,930197131,14534330,18.52),(124874,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124874,35.75,0.46,141,56367,70,NULL,NULL,'2MASX J14533391+4841552',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000172,NULL,'16.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,223.39125,48.69881,0.025,NULL,59933977573,936468399,14632318,16.3),(124875,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124875,37.8,0.46,363,56368,70,NULL,NULL,'2MASX J14533528+0338320',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000081,NULL,'17.9g',0.17,'NLAGN',NULL,NULL,NULL,NULL,1,223.397167,3.64219,0.125,NULL,59338008689,927156385,14486818,17.9),(124876,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124876,38.02,0.46,401,56369,70,NULL,NULL,'2MASX J14533540+0517450',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,223.397583333,5.29581,0.101,NULL,59335838073,927122469,14486288,16.5),(124877,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124877,37.16,0.46,270,56370,70,NULL,NULL,'2MASX J14533785+1624225',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000097,NULL,'16.7g',0.28,'E','Group member',NULL,NULL,NULL,1,223.407625,16.40617,0.017,NULL,59590117163,931095580,14548368,16.7),(124878,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124878,37.62,0.46,334,56371,70,NULL,NULL,'2MASX J14533852+1959094',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,223.4105417,19.98594,0.029,NULL,59533065169,930204143,14534439,NULL),(124879,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124879,37.14,0.46,268,56372,70,NULL,NULL,'SDSS J145339.94-003552.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000058,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.4164583,-0.59794,0.141,NULL,43490421508,679537836,10617778,18),(124880,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124880,36.68,0.23,217,56373,70,NULL,NULL,'GIN 377',NULL,'2001MNRAS.321..277C',2001,1,0.8,'Mislabeled as A1983 F in Colless, et al. (1993,MNRAS,262,475).','G',0.000213,NULL,'14.67',0.4,'S0','Group member',NULL,NULL,NULL,1,223.4165,18.07017,0.021,NULL,59587181819,931049715,14547651,14.67),(124881,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124881,37.22,0.23,278,56373,70,NULL,NULL,'GIN 377',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124882,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124882,37.39,0.25,301,56373,74.4,NULL,NULL,'GIN 377',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124883,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124883,35.97,0.46,157,56374,70,NULL,NULL,'2MASX J14533997+0255140',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000076,NULL,'16.5g',0.3,'NLAGN',NULL,NULL,NULL,NULL,1,223.416667,2.92067,0.125,NULL,59326555451,926977428,14484022,16.5),(124884,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124884,37.51,0.46,318,56375,70,NULL,NULL,'2MASX J14534239+0412020',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00008,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,223.4264583,4.20069,0.117,NULL,59334087318,927095114,14485861,17.2),(124885,'Tully est','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124885,32.14,0.8,26.8,56376,75,NULL,'B','NGC 5774',NULL,'1988NBGC.C....0000T',1988,1,1.9,'The Kiso position is for a superposed star or knot.','G',0.000007,NULL,'13.7g',1.12,'SAB(rs)d','Pair member (points to parent)',NULL,NULL,NULL,1,223.426917,3.5825,0.125,NULL,59338054394,927157099,14486829,13.7),(124886,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124886,31.55,NULL,20.4,56376,72,NULL,NULL,'NGC 5774',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124887,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124887,32.13,0.4,26.6,56376,NULL,NULL,'mean','NGC 5774',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124888,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124888,32.68,0.46,34.3,56376,NULL,NULL,'J','NGC 5774',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124889,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124889,32.71,0.47,34.8,56376,NULL,NULL,'H','NGC 5774',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124890,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124890,36.92,0.27,242,56377,70,NULL,NULL,'2MASX J14534327+3125182',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000161,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,223.430291667,31.42181,0,NULL,60090369950,938912030,14670500,17.9),(124891,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124891,36.35,0.46,186,56378,NULL,NULL,'Malmquist cor.','2MASX J14534439+1642015',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000023,NULL,'18.06',0.1,'S0','Group member',NULL,NULL,NULL,1,223.4352083,16.70042,0.017,NULL,59585753361,931027396,14547303,18.06),(124892,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124892,36.45,0.44,195,56378,NULL,NULL,NULL,'2MASX J14534439+1642015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124893,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124893,36.49,0.2,199,56378,74.4,NULL,NULL,'2MASX J14534439+1642015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124894,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124894,36.92,0.27,242,56379,70,NULL,NULL,'2MASX J14534461+3123154',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000195,NULL,'16.0g',0.41,NULL,NULL,NULL,NULL,NULL,1,223.4360417,31.3875,0,NULL,60090369585,938912024,14670500,16),(124895,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124895,37.03,0.1,254,56380,70,NULL,NULL,'2MASX J14534495+1827594',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.56',0.16,NULL,NULL,NULL,NULL,NULL,1,223.437333,18.46656,0.025,NULL,59586854030,931044594,14547571,18.56),(124896,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124896,37.4,0.46,303,56381,70,NULL,NULL,'2MASX J14534497+3230304',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,223.437416667,32.50858,0,NULL,60090145145,938908517,14670445,17.5),(124897,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124897,36.91,0.46,240,56382,70,NULL,NULL,'2MASX J14534502+1834064',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00009,NULL,'17.93',0.3,'Sa/0','Group member',NULL,NULL,NULL,1,223.437583333,18.56836,0.025,NULL,59586843269,931044426,14547569,17.93),(124898,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124898,38.23,0.46,442,56383,70,NULL,NULL,'SDSS J145345.97+351144.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000166,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,223.4415417,35.19583,0.057,NULL,60125837254,939466207,14679159,18.6),(124899,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124899,37.97,0.11,392,56384,70,NULL,NULL,'2MASX J14534771+5409046',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000166,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,223.448667,54.15117,0,NULL,59191011408,924859553,14450930,18.5),(124900,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124900,37.7,0.33,347,56385,70,NULL,NULL,'2MASX J14534793+0623271',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.449916667,6.391,0.085,NULL,59380586074,927821657,14497213,17.7),(124901,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124901,36.84,0.33,233,56386,70,NULL,NULL,'2MASX J14534856+1421075',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'19.00',0.12,NULL,NULL,NULL,NULL,NULL,1,223.452333333,14.35211,0.041,NULL,59548342312,930442848,14538169,19),(124902,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124902,37.03,0.1,254,56387,70,NULL,NULL,'2MASX J14534868+1828224',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,223.452917,18.47286,0.025,NULL,59586854131,931044595,14547571,17.3),(124903,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124903,36.47,0.46,197,56388,70,NULL,NULL,'2MASX J14534908+0005230',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000103,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,223.4544583,0.08967,0.137,NULL,58252865704,910201026,14221891,16.4),(124904,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124904,37.47,0.46,312,56389,70,NULL,NULL,'2MASX J14534964+5348032',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.45675,53.80108,0,NULL,59190638474,924853726,14450839,18.1),(124905,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124905,37.22,0.33,278,56390,70,NULL,NULL,'2MASX J14534984+2517084',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.11',0.16,NULL,NULL,NULL,NULL,NULL,1,223.457625,25.28578,0.157,NULL,60012731614,937698931,14651545,18.11),(124906,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124906,37.22,0.23,278,56391,70,NULL,NULL,'SDSS J145350.18+180444.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.459125,18.07903,0.025,NULL,59587179192,931049674,14547651,18.1),(124907,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124907,37.97,0.11,392,56392,70,NULL,NULL,'2MASX J14535020+5404406',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,223.459125,54.07808,0,NULL,59191055254,924860238,14450941,17.1),(124908,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124908,37.81,0.46,365,56393,70,NULL,NULL,'2MASX J14535032+0450000',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000078,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,223.459667,4.83331,0.093,NULL,59336019479,927125304,14486332,17.4),(124909,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124909,37.56,0.46,325,56394,70,NULL,NULL,'2MASX J14535080+5000522',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000148,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,223.461708333,50.01458,0.029,NULL,59943408551,936615758,14634621,16.9),(124910,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124910,37.57,0.46,326,56395,70,NULL,NULL,'2MASX J14535308+3422095',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,223.471083333,34.36931,0.017,NULL,60124337089,939442767,14678793,17.1),(124911,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124911,37.86,0.46,373,56396,70,NULL,NULL,'2MASX J14535347+2547233',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.31',0.16,NULL,NULL,NULL,NULL,NULL,1,223.472875,25.78983,0.181,NULL,60012906562,937701665,14651588,18.31),(124912,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124912,37.03,0.1,254,56397,70,NULL,NULL,'SDSS J145354.38+184743.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.5g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.476625,18.79533,0.025,NULL,59586799371,931043740,14547558,17.5),(124913,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124913,37.7,0.33,347,56398,70,NULL,NULL,'2MASX J14535437+0627124',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,223.476667,6.45344,0.085,NULL,59380544179,927821002,14497203,16.3),(124914,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124914,37.97,0.11,392,56399,70,NULL,NULL,'2MASX J14535469+5416426',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00009,NULL,'16.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,223.477625,54.27847,0,NULL,59191007296,924859489,14450929,16.9),(124915,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124915,35.7,0.46,138,56400,70,NULL,NULL,'2MASX J14535568+2435253',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00007,NULL,'15.66',0.31,NULL,NULL,NULL,NULL,NULL,1,223.482125,24.59053,0.121,NULL,59492850857,929575794,14524621,15.66),(124916,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124916,37.03,0.1,254,56401,70,NULL,NULL,'2MASX J14535670+1847244',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00008,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,223.486167,18.79,0.025,NULL,59586800779,931043762,14547558,17),(124917,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124917,37.97,0.11,392,56402,70,NULL,NULL,'2MASX J14535691+5425466',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00016,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,223.4872917,54.42958,0,NULL,59190974190,924858971,14450921,18.5),(124918,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124918,36.92,0.27,242,56403,70,NULL,NULL,'2MASX J14535757+3128405',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000181,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,223.4897917,31.47781,0,NULL,60090374573,938912102,14670501,16.8),(124919,'Tully est','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124919,32.13,0.8,26.7,56404,75,NULL,'B','NGC 5775',NULL,'1988NBGC.C....0000T',1988,1,4.2,'Multiple SDSS entries describe this object.','G',0.000017,NULL,'12.2B',1,'Sb(f)','Pair member (points to parent)',NULL,NULL,NULL,1,223.49,3.54444,0.125,NULL,59338036625,927156822,14486825,12.2),(124920,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124920,31,0.4,15.9,56404,75,NULL,NULL,'NGC 5775',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124921,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124921,31.2,0.43,17.4,56404,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5775',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124922,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124922,31.23,0.47,17.7,56404,NULL,NULL,'H','NGC 5775',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124923,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124923,31.24,0.45,17.7,56404,NULL,NULL,'K','NGC 5775',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124924,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124924,31.29,0.46,18.1,56404,NULL,NULL,'J','NGC 5775',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124925,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124925,31.33,0.43,18.4,56404,75,NULL,'3.6 micron, color corrected','NGC 5775',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124926,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124926,31.47,0.2,19.7,56404,74.4,NULL,NULL,'NGC 5775',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124927,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124927,31.52,0.49,20.1,56404,75,NULL,'IR','NGC 5775',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124928,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124928,31.65,NULL,21.4,56404,72,NULL,NULL,'NGC 5775',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124929,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124929,32.15,0.4,27,56404,NULL,NULL,'mean','NGC 5775',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124930,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124930,36.28,0.33,180,56405,70,NULL,NULL,'SDSS J145359.48+044742.5',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000076,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,223.497875,4.79517,0.093,NULL,59336015922,927125248,14486332,17.1),(124931,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124931,37.14,0.46,268,56406,70,NULL,NULL,'2MASX J14535998+1114024',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.73',0.15,NULL,NULL,NULL,NULL,NULL,1,223.499916667,11.23392,0.037,NULL,59369700558,927651571,14494555,18.73),(124932,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124932,36.34,0.63,185,56407,70,NULL,NULL,'2MASX J14540191-4236575',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.8I',0.2,NULL,NULL,NULL,NULL,NULL,1,223.508083333,-42.61589,0.437,NULL,47095464758,735866636,11497916,14.8),(124933,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124933,37.97,0.11,392,56408,70,NULL,NULL,'2MASX J14540279+5415565',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000113,NULL,'16.3g',0.4,'BrClG',NULL,NULL,NULL,NULL,1,223.511417,54.26564,0,NULL,59191007440,924859491,14450929,16.3),(124934,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124934,37.49,0.46,315,56409,70,NULL,NULL,'2MASX J14540275+1901497',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000093,NULL,'18.41',0.17,NULL,NULL,NULL,NULL,NULL,1,223.5114583,19.0305,0.037,NULL,59531417302,930178395,14534037,18.41),(124935,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124935,37.8,0.46,363,56410,70,NULL,NULL,'SDSS J145403.03+255652.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.512667,25.94794,0.183,NULL,60012950672,937702354,14651599,18.3),(124936,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124936,35.05,0.46,103,56411,70,NULL,NULL,'SDSS J145403.73+305046.4',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.0g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.515583,30.84625,0.022,NULL,60088916410,938889318,14670145,16),(124937,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124937,37.29,0.46,286,56412,70,NULL,NULL,'2MASX J14540401+5953239',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000073,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,223.5167917,59.89014,0,NULL,57770176294,902659004,14104046,18.1),(124938,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124938,36.56,0.33,205,56413,70,NULL,NULL,'2MASX J14540477+0915014',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.70',0.22,NULL,NULL,NULL,NULL,NULL,1,223.5199583,9.25033,0.045,NULL,59375721379,927745646,14496025,16.7),(124939,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124939,36.51,0.25,200,56414,74.4,NULL,NULL,'GIN 379',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000093,NULL,'14.90',0.6,'E','Group member',NULL,NULL,NULL,1,223.5212917,18.4335,0.025,NULL,59586839228,931044362,14547568,14.9),(124940,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124940,36.68,0.23,217,56414,70,NULL,NULL,'GIN 379',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124941,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124941,37.03,0.1,254,56414,70,NULL,NULL,'GIN 379',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124942,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124942,37.97,0.11,392,56415,70,NULL,NULL,'2MASX J14540515+5416389',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000147,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,223.521375,54.2775,0,NULL,59191007247,924859488,14450929,18),(124943,'BCG','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124943,38.45,0.35,444,56416,60,NULL,NULL,'ABELL 1999',0.1032,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III [BM]',NULL,NULL,NULL,NULL,1,223.52375,54.31425,0,NULL,59190982512,924859101,14450923,NULL),(124944,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124944,38.66,0.46,539,56417,70,NULL,NULL,'2MASX J14540609+4329029',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000195,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,223.52525,43.48397,0.013,NULL,59981537374,937211521,14643930,17.9),(124945,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124945,37.37,0.27,298,56418,70,NULL,NULL,'2MASX J14540724+2717226',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.87',0.17,NULL,NULL,NULL,NULL,NULL,1,223.530125,27.28967,0.109,NULL,60013734995,937714609,14651790,17.87),(124946,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124946,37.33,0.46,292,56419,70,NULL,NULL,'2MASX J14540748+0456076',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,223.531125,4.93533,0.097,NULL,59336014375,927125224,14486331,16.8),(124947,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124947,35.56,0.46,129,56420,70,NULL,NULL,'2MASX J14540774+4925452',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000189,NULL,'15.4g',0.26,'Sa',NULL,NULL,NULL,NULL,1,223.5322083,49.42914,0.025,NULL,59944222704,936628479,14634819,15.4),(124948,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124948,37.6,0.46,332,56421,70,NULL,NULL,'2MASX J14540869+0920254',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.71',0.16,NULL,NULL,NULL,NULL,NULL,1,223.5360417,9.34044,0.045,NULL,59375724733,927745698,14496026,18.71),(124949,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124949,38.45,0.46,491,56422,70,NULL,NULL,'2MASX J14541017+1304277',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,223.542417,13.07428,0.049,NULL,59547331413,930427053,14537922,17.7),(124950,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124950,38.93,0.46,611,56423,70,NULL,NULL,'SDSS J145410.66+291600.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.40',0.16,NULL,NULL,NULL,NULL,NULL,1,223.544417,29.26692,0,NULL,60092933634,938952088,14671126,17.4),(124951,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124951,36.37,0.84,188,56424,70,NULL,NULL,'2MFGC 12073',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,223.545291667,-13.49056,0.317,NULL,46686111538,729470492,11397976,15),(124952,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124952,36.49,0.09,198,56425,70,NULL,NULL,'2MASX J14541123+1626237',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00015,NULL,'17.90',0.2,'S0/E','Group member',NULL,NULL,NULL,1,223.546875,16.44003,0.013,NULL,59590120972,931095640,14548369,17.9),(124953,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124953,35.86,0.71,149,56426,70,NULL,NULL,'ESO 448- G 006',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'14.8R',0.2,'Sb:',NULL,NULL,NULL,NULL,1,223.5470417,-31.07072,0.437,NULL,47201702113,737526595,11523853,14.8),(124954,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124954,36.02,0.33,160,56427,70,NULL,NULL,'2MASX J14541142+0456476',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,223.5475417,4.94656,0.097,NULL,59336000995,927125015,14486328,16.5),(124955,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124955,36.07,0.46,164,56428,70,NULL,NULL,'2MASX J14541212+5430240',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000073,NULL,'15.5g',0.5,'E0',NULL,NULL,NULL,NULL,1,223.5507083,54.50675,0.009,NULL,59190087682,924845120,14450705,15.5),(124956,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124956,38.1,0.19,416,56429,70,NULL,NULL,'2MASX J14541233+2135476',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'17.07',0.24,'BrClG',NULL,NULL,NULL,NULL,1,223.551333,21.5965,0.093,NULL,59541193577,930331149,14536424,17.07),(124957,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124957,36.02,0.33,160,56430,70,NULL,NULL,'IC 1072',NULL,'2015arXiv151105856S',2015,1,0.96,NULL,'G',0.000116,NULL,'14.8g',0.58,'E','Group member',NULL,NULL,NULL,1,223.55475,4.84156,0.093,NULL,59335792918,927121764,14486277,14.8),(124958,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124958,37.36,0.33,297,56431,70,NULL,NULL,'2MASX J14541331+1058205',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.56',0.24,NULL,NULL,NULL,NULL,NULL,1,223.555583,10.97247,0.037,NULL,59369639218,927650612,14494540,16.56),(124959,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124959,37.36,0.33,297,56432,70,NULL,NULL,'SDSS J145413.48+105725.9',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000171,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,223.5562083,10.95722,0.037,NULL,59369639888,927650623,14494540,17.7),(124960,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124960,38.12,0.33,421,56433,70,NULL,NULL,'2MASX J14541358+0543026',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,223.556708333,5.71747,0.097,NULL,59335068863,927110450,14486100,17.1),(124961,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124961,36.49,0.09,198,56434,70,NULL,NULL,'2MASX J14541415+1622197',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'18.44',0.15,'E','Group member',NULL,NULL,NULL,1,223.559125,16.37222,0.017,NULL,59590386638,931099791,14548434,18.44),(124962,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124962,36.85,0.33,234,56435,70,NULL,NULL,'2MASX J14541512+4925503',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000205,NULL,'15.5g',0.5,'E0',NULL,NULL,NULL,NULL,1,223.562875,49.43053,0.025,NULL,59944219323,936628426,14634819,15.5),(124963,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124963,37.92,0.46,383,56436,70,NULL,NULL,'2MASX J14541598+5509241',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000152,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,223.566667,55.15672,0.009,NULL,57244819637,894450306,13975786,16.9),(124964,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124964,36.32,0.46,184,56437,70,NULL,NULL,'2MASX J14541623-0140174',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.56775,-1.6715,0.153,NULL,43489142134,679517845,10617466,17.5),(124965,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124965,34.56,0.4,81.6,56438,NULL,NULL,'mean','NGC 5784',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000053,NULL,'13.38',1.8,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,223.5685417,42.55792,0.005,NULL,59980927841,937201997,14643781,13.38),(124966,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124966,34.59,0.45,82.9,56438,NULL,NULL,'K','NGC 5784',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124967,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124967,37.97,0.11,392,56439,70,NULL,NULL,'2MASX J14541747+5418271',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000137,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,223.573083333,54.30742,0,NULL,59190971238,924858925,14450920,17.4),(124968,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124968,36.73,0.46,222,56440,70,NULL,NULL,'2MASX J14541761+2447597',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,223.573333,24.79989,0.127,NULL,59493007772,929578246,14524660,NULL),(124969,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124969,34.57,0.46,82.2,56441,70,NULL,NULL,'CGCG 048-065',NULL,'2015arXiv151105856S',2015,1,1.02,NULL,'G',0.000106,NULL,'14.2g',0.78,'E',NULL,NULL,NULL,NULL,1,223.574333,4.28389,0.145,NULL,59334150081,927096095,14485876,14.2),(124970,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124970,36.5,0.25,200,56442,74.4,NULL,NULL,'MCG +03-38-048',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.0001,NULL,'14.67',0.4,'Sa','Group member',NULL,NULL,NULL,1,223.574625,18.55325,0.025,NULL,59586822131,931044095,14547563,14.67),(124971,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124971,36.68,0.23,217,56442,70,NULL,NULL,'MCG +03-38-048',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124972,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124972,35.73,0.46,140,56443,70,NULL,NULL,'CGCG 105-065',NULL,'2015arXiv151105856S',2015,1,0.83,'Bright star to the northeast.','G',NULL,NULL,'15.7',0.33,NULL,NULL,NULL,NULL,NULL,1,223.5765,17.72058,0.013,NULL,59587067100,931047923,14547623,15.7),(124973,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124973,37.37,0.33,298,56444,70,NULL,NULL,'2MASX J14541929+3527521',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.580375,35.46447,0.025,NULL,60125807663,939465744,14679152,17.9),(124974,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124974,38.1,0.19,416,56445,70,NULL,NULL,'SDSS J145419.48+213736.7',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.1g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.581167,21.62689,0.093,NULL,59541226306,930331661,14536432,17.1),(124975,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124975,38.25,0.46,446,56446,70,NULL,NULL,'2MASX J14541963+1058015',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00016,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,223.581833,10.96717,0.037,NULL,59369638689,927650604,14494540,18.2),(124976,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124976,38.1,0.19,416,56447,70,NULL,NULL,'2MASX J14541950+2137366',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.30',0.18,NULL,NULL,NULL,NULL,NULL,1,223.582833,21.63181,0.093,NULL,59541111170,930329862,14536404,18.3),(124977,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124977,37.77,0.46,359,56448,70,NULL,NULL,'2MASX J14542014+1431067',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.70',0.13,NULL,NULL,NULL,NULL,NULL,1,223.5839583,14.51858,0.057,NULL,59578413566,930912711,14545511,18.7),(124978,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124978,37.44,0.46,307,56449,70,NULL,NULL,'2MASX J14542059+2715396',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.13',0.18,NULL,NULL,NULL,NULL,NULL,1,223.585667,27.26106,0.109,NULL,60013680338,937713755,14651777,18.13),(124979,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124979,36.85,0.33,234,56450,70,NULL,NULL,'2MASX J14542221+4921014',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000176,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,223.592541667,49.35036,0.021,NULL,59941332597,936583321,14634114,16.7),(124980,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124980,36.92,0.46,242,56451,70,NULL,NULL,'SDSS J145422.81+071523.8',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.595083,7.25664,0.089,NULL,59382058266,927844660,14497572,17.5),(124981,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124981,36.49,0.09,198,56452,70,NULL,NULL,'IC 4516',NULL,'2015arXiv151105856S',2015,1,1.3,NULL,'G',0.000067,NULL,'14.22',1.1,'cD;E','Group member',NULL,NULL,NULL,1,223.5977083,16.35528,0.017,NULL,59590431614,931100493,14548445,14.22),(124982,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124982,36.56,0.25,205,56452,74.4,NULL,NULL,'IC 4516',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124983,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124983,36.79,0.26,228,56452,70,NULL,NULL,'IC 4516',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124984,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124984,36.45,0.45,195,56452,NULL,NULL,'K','IC 4516',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124985,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124985,36.53,0.4,203,56452,NULL,NULL,'mean','IC 4516',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124986,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124986,38.1,0.19,416,56453,70,NULL,NULL,'2MASX J14542432+2142476',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.23',0.15,NULL,NULL,NULL,NULL,NULL,1,223.601375,21.71339,0.093,NULL,59540407451,930318866,14536232,18.23),(124987,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124987,37.46,0.46,311,56454,70,NULL,NULL,'2MASX J14542464+4936484',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,223.602625,49.61356,0.021,NULL,59944246651,936628853,14634825,17.2),(124988,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124988,37.36,0.46,296,56455,70,NULL,NULL,'2MASX J14542533+5737221',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00016,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,223.6055417,57.62278,0,NULL,57727963159,901999424,14093741,17.1),(124989,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124989,37.97,0.11,392,56456,70,NULL,NULL,'2MASX J14542559+5416241',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000124,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.606625,54.27339,0,NULL,59191002864,924859419,14450928,18.1),(124990,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124990,36.53,0.46,202,56457,70,NULL,NULL,'2MASX J14542571+2250536',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.40',0.26,NULL,NULL,NULL,NULL,NULL,1,223.607166667,22.84814,0.089,NULL,59527229157,930112955,14533014,17.4),(124991,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124991,37.35,0.46,295,56458,70,NULL,NULL,'2MASX J14542596-0111184',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000096,NULL,'17.0g',0.22,'NLAGN',NULL,NULL,NULL,'Sy 2',1,223.608208333,-1.18831,0.169,NULL,43490160569,679533758,10617714,17),(124992,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124992,37.03,0.1,254,56459,70,NULL,NULL,'2MASX J14542692+1821156',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.65',0.14,NULL,NULL,NULL,NULL,NULL,1,223.612167,18.35436,0.025,NULL,59587201329,931050020,14547656,18.65),(124993,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124993,37.37,0.33,298,56460,70,NULL,NULL,'2MASX J14542740+3526271',NULL,'2015arXiv151105856S',2015,1,0.4,'May be a resolved component of 87GB[BWE91] 1452+3539.','G',0.000197,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,223.613917,35.44094,0.025,NULL,60125821800,939465965,14679155,16.7),(124994,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124994,36.2,0.46,174,56461,70,NULL,NULL,'2MASX J14542741+0632105',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,223.614167,6.53636,0.093,NULL,59380499363,927820302,14497192,16.2),(124995,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124995,36.94,0.46,244,56462,70,NULL,NULL,'2MASX J14542745+1106375',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,223.614375,11.11042,0.033,NULL,59369607015,927650109,14494532,17.2),(124996,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124996,37.03,0.1,254,56463,70,NULL,NULL,'SDSS J145428.00+183656.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'17.8O',0.14,'QSO:',NULL,NULL,NULL,NULL,1,223.616708333,18.61569,0.025,NULL,59586811509,931043929,14547561,17.8),(124997,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124997,37.37,0.27,298,56464,70,NULL,NULL,'2MASX J14542824+2717116',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.14',0.16,NULL,NULL,NULL,NULL,NULL,1,223.617541667,27.28664,0.109,NULL,60013679416,937713740,14651777,18.14),(124998,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124998,36.1,0.46,166,56465,70,NULL,NULL,'2MASX J14542852+2156575',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.80',0.18,NULL,NULL,NULL,NULL,NULL,1,223.618875,21.94936,0.081,NULL,59540378852,930318419,14536225,17.8),(124999,'BCG','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124999,37.42,0.35,288,56466,60,NULL,NULL,'ABELL 1991',0.0589,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I:     [BM]',NULL,NULL,NULL,NULL,1,223.630833,18.64194,0.025,NULL,59586829711,931044214,14547565,NULL),(125000,'BCG','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125000,37.42,0.35,288,56467,60,NULL,'ABELL 1991, BCG','NGC 5778',0.0589,'1980ApJ...241..486H',1980,1,1.2,'1990ApJ...360..436B has V = 17034 +- 50 km/sec.','G',0.000077,NULL,'14.80',0.9,'cD;BrClG','Group member',NULL,'NAT',NULL,1,223.631208333,18.64231,0.025,NULL,59586829711,931044214,14547565,14.8),(125001,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125001,36.52,0.25,201,56467,74.4,NULL,NULL,'NGC 5778',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125002,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125002,36.68,0.23,217,56467,70,NULL,NULL,'NGC 5778',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125003,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125003,37.03,0.1,254,56467,70,NULL,NULL,'NGC 5778',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125004,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125004,35.82,0.46,146,56468,70,NULL,NULL,'CGCG 193-008',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000103,NULL,'15.1g',0.57,'S0/a',NULL,NULL,NULL,NULL,1,223.634458333,37.07561,0.006,NULL,60119052139,939360189,14677502,15.1),(125005,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125005,35.22,0.27,111,56469,70,NULL,NULL,'NGC 5776',NULL,'2015arXiv151105856S',2015,1,1.24,NULL,'G',0.000087,NULL,'14.1g',0.79,'E0',NULL,NULL,NULL,NULL,1,223.6364583,2.96644,0.129,NULL,59326527000,926976984,14484015,14.1),(125006,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125006,34.99,0.46,99.5,56470,70,NULL,NULL,'2MASX J14543279+4223079',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'16.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,223.6364583,42.38542,0.013,NULL,59980967574,937202618,14643790,16.3),(125007,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125007,35.19,0.2,109,56471,74.4,NULL,NULL,'CGCG 164-042',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000047,NULL,'15.6',0.6,'Sa             Sbrst',NULL,NULL,NULL,NULL,1,223.6372083,29.06436,0.02,NULL,60092922725,938951917,14671123,15.6),(125008,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125008,38.33,0.46,464,56472,70,NULL,NULL,'2MASX J14543320+2218289',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.91',0.13,NULL,NULL,NULL,NULL,NULL,1,223.638333333,22.30811,0.089,NULL,59527568280,930118254,14533097,18.91),(125009,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125009,37.97,0.11,392,56473,70,NULL,NULL,'2MASX J14543335+5407131',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00014,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,223.639,54.12028,0,NULL,59190893296,924857707,14450901,18.3),(125010,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125010,34.5,0.52,79.5,56474,70,NULL,NULL,'2MASX J14543338-3747544',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'13.4I',0.5,NULL,NULL,NULL,NULL,NULL,1,223.639041667,-37.79847,0.277,NULL,47234677510,738041836,11531903,13.4),(125011,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125011,37.92,0.46,384,56475,70,NULL,NULL,'2MASX J14543335+1118305',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,223.639041667,11.30861,0.033,NULL,59366866345,927607286,14493863,17.7),(125012,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125012,35.05,0.46,102,56476,70,NULL,NULL,'2MASX J14543467+3412171',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000162,NULL,'16.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,223.644667,34.20483,0.017,NULL,60122513982,939414280,14678348,16),(125013,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125013,34.57,0.4,82.2,56477,NULL,NULL,'mean','IC 4517',NULL,'2007A&A...465...71T',2007,1,1.08,NULL,'G',0.000173,NULL,'15.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,223.6462083,23.64328,0.102,NULL,59495425185,929616018,14525250,15.1),(125014,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125014,34.95,0.47,97.8,56477,NULL,NULL,'H','IC 4517',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125015,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125015,34.98,0.45,98.9,56477,NULL,NULL,'K','IC 4517',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125016,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125016,35.05,0.46,102,56477,NULL,NULL,'J','IC 4517',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125017,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125017,35.13,0.2,106,56477,74.4,NULL,NULL,'IC 4517',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125018,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125018,38.12,0.33,421,56478,70,NULL,NULL,'2MASX J14543526+0536478',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,223.646791667,5.61322,0.097,NULL,59335556888,927118076,14486219,16.4),(125019,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125019,37.89,0.27,378,56479,70,NULL,NULL,'2MASX J14543543+3137001',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,223.647875,31.61658,0,NULL,60090423964,938912874,14670513,17.8),(125020,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125020,38.47,0.23,495,56480,70,NULL,NULL,'2MASX J14543558+2239200',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,223.6482083,22.65561,0.097,NULL,59527512991,930117390,14533084,18.1),(125021,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125021,37.62,0.46,334,56481,70,NULL,NULL,'2MASX J14543598-0202593',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000127,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,223.649875,-2.04975,0.205,NULL,46441021208,725640956,11338139,17.9),(125022,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125022,37.03,0.1,254,56482,70,NULL,NULL,'2MASX J14543620+1841190',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000103,NULL,'17.64',0.2,'S0/E','Group member',NULL,NULL,NULL,1,223.650917,18.68847,0.025,NULL,59586828136,931044189,14547565,17.64),(125023,'Tully est','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125023,32.99,0.8,39.6,56483,75,NULL,'B','I Zw 097',NULL,'1988NBGC.C....0000T',1988,1,0.8,'MCG position is -1 minute, +8 arcmin in error.','G',0.00024,NULL,'14.9',0.6,'SABab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,223.663625,42.02389,0.009,NULL,59979086846,937173231,14643331,14.9),(125024,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125024,37.35,0.46,295,56484,70,NULL,NULL,'2MASX J14543901+1214430',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'18.15',0.22,NULL,NULL,NULL,NULL,NULL,1,223.6625,12.24528,0.029,NULL,59366632263,927603629,14493806,18.15),(125025,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125025,37.03,0.1,254,56485,70,NULL,NULL,'2MASX J14543928+1846120',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000097,NULL,'18.06',0.17,'E','Group member',NULL,NULL,NULL,1,223.6635417,18.77017,0.025,NULL,59586778387,931043412,14547553,18.06),(125026,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125026,37.28,0.46,286,56486,70,NULL,NULL,'2MASX J14543989+2929486',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000177,NULL,'18.12',0.17,'E',NULL,NULL,NULL,NULL,1,223.666416667,29.49694,0.026,NULL,60093832772,938966137,14671345,18.12),(125027,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125027,36.52,0.55,202,56487,70,NULL,NULL,'2MASX J14544029-1041252',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,223.667917,-10.69028,0.309,NULL,46461939899,725967810,11343247,15.7),(125028,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125028,38.1,0.19,416,56488,70,NULL,NULL,'2MASX J14544030+2144010',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,223.668083,21.73369,0.085,NULL,59541120401,930330006,14536406,17.2),(125029,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125029,35.76,0.2,142,56489,74.4,NULL,NULL,'CGCG 134-053',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000672,NULL,'16.00',0.1,NULL,NULL,NULL,NULL,NULL,1,223.669125,25.71081,0.181,NULL,60013118493,937704976,14651640,16),(125030,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125030,35.36,0.49,118,56490,75,NULL,'IR','CGCG 134-053',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.000672,NULL,'16.00',0.1,NULL,NULL,NULL,NULL,NULL,1,223.669125,25.71081,0.181,NULL,60013118493,937704976,14651640,16),(125031,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125031,38.04,0.46,406,56491,70,NULL,NULL,'SDSS J145440.66+525752.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000165,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,223.669458333,52.96467,0.005,NULL,59928503118,936382861,14630982,18.6),(125032,'IRAS','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125032,33.11,0.8,41.8,56492,75,NULL,'MAT, I','MCG -03-38-025',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'13.70',0.9,'SAB(rs)bc:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,223.669417,-17.40567,0.393,NULL,46698369502,729662023,11400969,13.7),(125033,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125033,33,0.32,39.8,56492,85,NULL,'I, raw','MCG -03-38-025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125034,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125034,33.03,0.32,40.4,56492,85,NULL,'I, inv','MCG -03-38-025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125035,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125035,33.09,0.2,41.5,56492,74.4,NULL,NULL,'MCG -03-38-025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125036,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125036,33.16,0.43,42.9,56492,75,NULL,'MAT, I, raw','MCG -03-38-025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125037,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125037,33.2,0.44,43.7,56492,NULL,NULL,'Malmquist cor.','MCG -03-38-025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125038,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125038,33.23,0.4,44.4,56492,NULL,NULL,'mean','MCG -03-38-025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125039,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125039,33.32,0.43,46.2,56492,75,NULL,'MAT, I, inv','MCG -03-38-025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125040,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125040,33.33,0.43,46.3,56492,75,NULL,'MAT, I, cor','MCG -03-38-025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125041,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125041,33.35,0.41,46.8,56492,NULL,NULL,NULL,'MCG -03-38-025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125042,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125042,33.44,0.47,48.8,56492,NULL,NULL,'H','MCG -03-38-025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125043,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125043,33.44,0.46,48.8,56492,NULL,NULL,'J','MCG -03-38-025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125044,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125044,33.53,0.45,50.9,56492,NULL,NULL,'K','MCG -03-38-025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125045,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125045,37.03,0.1,254,56493,70,NULL,NULL,'2MASX J14544070+1844570',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000167,NULL,'18.58',0.13,NULL,NULL,NULL,NULL,NULL,1,223.669625,18.74922,0.025,NULL,59586785916,931043529,14547555,18.58),(125046,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125046,38.47,0.23,495,56494,70,NULL,NULL,'2MASX J14544141+2245210',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,'PHOT',NULL,NULL,'BrClG',NULL,NULL,NULL,NULL,1,223.6725417,22.75581,0.097,NULL,59527511717,930117370,14533083,NULL),(125047,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125047,38.47,0.23,495,56495,70,NULL,NULL,'SDSS J145441.43+224258.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.672666667,22.71639,0.097,NULL,59527507049,930117297,14533082,18.5),(125048,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125048,36.49,0.09,198,56496,70,NULL,NULL,'2MASX J14544150+1613360',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.00015,NULL,'17.37',0.7,'E','Group member',NULL,NULL,NULL,1,223.6730417,16.22672,0.033,NULL,59590430411,931100475,14548444,17.37),(125049,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125049,37.03,0.1,254,56497,70,NULL,NULL,'2MASX J14544220+1835590',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00009,NULL,'18.41',0.17,NULL,NULL,NULL,NULL,NULL,1,223.675917,18.59983,0.025,NULL,59586810672,931043916,14547561,18.41),(125050,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125050,37.02,0.46,254,56498,70,NULL,NULL,'SDSS J145442.22+310130.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.7g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.675958333,31.02517,0.028,NULL,60090230031,938909844,14670466,17.7),(125051,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125051,37.37,0.27,298,56499,70,NULL,NULL,'2MASX J14544315+2719316',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.22',0.2,NULL,NULL,NULL,NULL,NULL,1,223.679667,27.32564,0.109,NULL,60081578531,938774664,14668354,17.22),(125052,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125052,37.49,0.33,315,56500,70,NULL,NULL,'2MASX J14544368+1249530',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,223.681917,12.8315,0.045,NULL,59547551763,930430496,14537976,17),(125053,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125053,38,0.46,397,56501,70,NULL,NULL,'SDSS J145443.80+383256.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000161,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,223.682541667,38.54892,0.037,NULL,60071352361,938614880,14665857,18.7),(125054,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125054,37.03,0.1,254,56502,70,NULL,NULL,'SDSS J145444.19+182958.2',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.0g',0.27,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.684125,18.49953,0.025,NULL,59587327987,931051999,14547687,17),(125055,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125055,37.03,0.1,254,56503,70,NULL,NULL,'2MASXi J1454442+183502',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,223.68425,18.58392,0.025,NULL,59586810604,931043915,14547561,17.8),(125056,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125056,38.51,0.46,503,56504,70,NULL,NULL,'2MASX J14544439+2412406',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,223.6850417,24.21142,0.13,NULL,59492753581,929574274,14524598,17.6),(125057,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125057,38.1,0.19,416,56505,70,NULL,NULL,'2MASX J14544449+2136410',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.6854583,21.61142,0.093,NULL,59541238868,930331857,14536435,18),(125058,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125058,36.49,0.09,198,56506,70,NULL,NULL,'2MASX J14544664+1615230',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00015,NULL,'16.7g',0.23,'S0','Group member',NULL,NULL,NULL,1,223.694333,16.25631,0.033,NULL,59590420942,931100327,14548442,16.7),(125059,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125059,37.96,0.33,390,56507,70,NULL,NULL,'2MASX J14544684+0526578',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,223.69525,5.44931,0.097,NULL,59335566487,927118226,14486222,16.4),(125060,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125060,36.66,0.46,215,56508,70,NULL,NULL,'2MASX J14544706+0242128',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000075,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,223.696166667,2.70356,0.125,NULL,59327201920,926987530,14484180,16.7),(125061,'BCG','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125061,38.45,0.35,444,56509,60,NULL,'ABELL 1999, BCG','2MASX J14544709+5422331',0.1032,'1980ApJ...241..486H',1980,1,0.36,NULL,'G',0.000217,NULL,'16.6g',0.35,NULL,'Brightest group member',NULL,NULL,NULL,1,223.696166667,54.37581,0.013,NULL,59190103021,924845359,14450708,16.6),(125062,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125062,36.75,0.46,224,56510,70,NULL,NULL,'2MASX J14544716+2513546',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.82',0.23,NULL,NULL,NULL,NULL,NULL,1,223.6965,25.23192,0.144,NULL,59492415491,929568992,14524515,16.82),(125063,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125063,37.87,0.46,374,56511,70,NULL,NULL,'2MASX J14544725-0041337',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000068,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,223.696958333,-0.69281,0.141,NULL,43490360064,679536876,10617763,17.6),(125064,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125064,37.69,0.46,345,56512,70,NULL,NULL,'2MASX J14544775+5737571',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000198,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.699,57.63269,0,NULL,57727921803,901998778,14093730,17.8),(125065,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125065,37.06,0.46,258,56513,70,NULL,NULL,'2MASX J14544778+3400580',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,223.699083,34.01597,0.045,NULL,60122723696,939417557,14678399,17.1),(125066,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125066,36.51,0.25,200,56514,74.4,NULL,NULL,'CGCG 105-068',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000117,NULL,'14.54',0.4,'SBbc','Group member',NULL,NULL,NULL,1,223.6995,18.56433,0.025,NULL,59587325661,931051963,14547686,14.54),(125067,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125067,36.68,0.23,217,56514,70,NULL,NULL,'CGCG 105-068',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125068,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125068,37.67,0.46,342,56515,70,NULL,NULL,'2MASX J14544820-0220447',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,223.700791667,-2.34561,0.225,NULL,46441272989,725644890,11338201,17.8),(125069,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125069,34.44,0.2,77.3,56516,74.4,NULL,NULL,'IC 1075',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000007,NULL,'14.62',0.7,'SBb','Pair member, S + S',NULL,NULL,NULL,1,223.7052083,18.10597,0.025,NULL,59587195624,931049931,14547655,14.62),(125070,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125070,37.95,0.46,390,56517,70,NULL,NULL,'2MASX J14545020+0059248',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000076,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.709125,0.99039,0.129,NULL,58254356906,910224326,14222255,17.8),(125071,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125071,38.05,0.46,407,56518,70,NULL,NULL,'2MASX J14545061+2315231',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,223.711,23.25656,0.093,NULL,59527158755,930111855,14532997,17.6),(125072,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125072,37.72,0.46,350,56519,70,NULL,NULL,'2MASX J14545067+3020028',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,223.711125,30.33406,0.043,NULL,60093612540,938962695,14671292,18.1),(125073,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125073,37.96,0.33,390,56520,70,NULL,NULL,'2MASX J14545073+0528318',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,223.711375,5.47553,0.097,NULL,59335559403,927118115,14486220,17.5),(125074,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125074,37.6,0.46,331,56521,70,NULL,NULL,'2MASX J14545109+3036108',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000148,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,223.712833333,30.60303,0.037,NULL,60093425874,938959779,14671246,17.7),(125075,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125075,37.79,0.46,361,56522,70,NULL,NULL,'2MASX J14545157+1824351',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00011,NULL,'18.71',0.13,NULL,NULL,NULL,NULL,NULL,1,223.714833333,18.40969,0.025,NULL,59587392568,931053008,14547703,18.71),(125076,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125076,37.13,0.46,267,56523,70,NULL,NULL,'2MASX J14545250+2231381',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.37',0.14,NULL,NULL,NULL,NULL,NULL,1,223.7187917,22.52728,0.101,NULL,59527607178,930118862,14533107,18.37),(125077,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125077,37.3,0.46,289,56524,70,NULL,NULL,'2MASX J14545289+2536527',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'17.04',0.2,NULL,NULL,NULL,NULL,NULL,1,223.720417,25.61464,0.153,NULL,60012999073,937703110,14651611,17.04),(125078,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125078,36.52,0.25,201,56525,74.4,NULL,NULL,'GIN 378',NULL,'2013AJ....146...86T',2013,1,0.28,NULL,'G',0.000067,NULL,'15.15',0.25,'Sa/0','Group member',NULL,NULL,NULL,1,223.725125,18.83681,0.033,NULL,59531408481,930178257,14534035,15.15),(125079,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125079,36.68,0.23,217,56525,70,NULL,NULL,'GIN 378',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125080,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125080,37.42,0.46,305,56526,70,NULL,NULL,'2MASX J14545401+3257389',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00014,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,223.725,32.96075,0.008,NULL,60123059389,939422802,14678481,17.9),(125081,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125081,37.03,0.1,254,56527,70,NULL,NULL,'2MASX J14545478+1841361',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000073,NULL,'17.71',0.24,'SB0','Group member',NULL,NULL,NULL,1,223.728417,18.69328,0.025,NULL,59586785100,931043517,14547554,17.71),(125082,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125082,37.17,0.33,271,56528,70,NULL,NULL,'2MASX J14545561+4921082',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000184,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,223.731958333,49.35244,0.021,NULL,59941330959,936583296,14634114,17.1),(125083,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125083,38.47,0.23,495,56529,70,NULL,NULL,'2MASX J14545616+2240151',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,223.7342083,22.67086,0.097,NULL,59527634404,930119287,14533113,18.1),(125084,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125084,36.41,0.33,191,56530,70,NULL,NULL,'2MASX J14545693+0044068',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00009,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,223.737125,0.73511,0.133,NULL,58253968020,910218250,14222160,17.9),(125085,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125085,37.63,0.46,336,56531,70,NULL,NULL,'2MASX J14545786+5450092',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000201,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,223.7412083,54.83583,0.005,NULL,57244056866,894438388,13975599,16.4),(125086,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125086,37.51,0.46,318,56532,70,NULL,NULL,'2MASX J14545881+2547417',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,223.745041667,25.79489,0.156,NULL,60013122763,937705043,14651641,17.8),(125087,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125087,34.86,0.4,93.6,56533,NULL,NULL,'mean','IC 1076',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.00003,NULL,'14.2',0.5,'SBc            Sbrst','Possible field galaxy',NULL,NULL,'Starburst',1,223.748417,18.03733,0.025,NULL,59587185243,931049769,14547652,14.2),(125088,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125088,35.03,0.47,102,56533,NULL,NULL,'H','IC 1076',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125089,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125089,37.89,0.27,378,56534,70,NULL,NULL,'2MASX J14550031+3140529',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,223.7514583,31.68139,0.017,NULL,60090420087,938912813,14670512,17.6),(125090,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125090,37.81,0.46,365,56535,70,NULL,NULL,'2MASX J14550160+4230287',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000178,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,223.756583333,42.50803,0.013,NULL,59980925497,937201960,14643780,17.2),(125091,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125091,38.26,0.46,448,56536,70,NULL,NULL,'2MASX J14550242+1629413',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,223.760083,16.49489,0.017,NULL,59590138436,931095913,14548373,17.5),(125092,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125092,37.49,0.33,315,56537,70,NULL,NULL,'2MASX J14550250+1251113',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.35',0.21,NULL,NULL,NULL,NULL,NULL,1,223.760333,12.85333,0.045,NULL,59547560988,930430640,14537978,18.35),(125093,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125093,37.97,0.11,392,56538,70,NULL,NULL,'2MASX J14550366+5419452',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000083,NULL,'16.8g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,223.765083333,54.32931,0.005,NULL,59190100436,924845319,14450708,16.8),(125094,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125094,37.78,0.46,359,56539,70,NULL,NULL,'2MASX J14550626+1318113',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,223.776083333,13.30308,0.029,NULL,59546882609,930420040,14537813,NULL),(125095,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125095,37.07,0.46,260,56540,70,NULL,NULL,'2MASX J14550728+3450359',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000186,NULL,'15.9g',0.45,'E0',NULL,NULL,NULL,NULL,1,223.78025,34.84333,0.017,NULL,60125614893,939462732,14679105,15.9),(125096,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125096,37.89,0.27,378,56541,70,NULL,NULL,'SDSS J145507.48+314001.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000167,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.781167,31.66703,0.017,NULL,60090430515,938912976,14670515,18.5),(125097,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125097,38.06,0.46,409,56542,70,NULL,NULL,'2MASX J14550771+3857206',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000185,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,223.78225,38.95575,0.045,NULL,60071591091,938618610,14665915,16.7),(125098,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125098,37.97,0.11,392,56543,70,NULL,NULL,'2MASX J14550825+5418063',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000173,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,223.784125,54.30183,0.005,NULL,59190215667,924847119,14450736,18.1),(125099,'IRAS','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125099,34.39,0.8,75.5,56544,75,NULL,'CF, r','UGC 09598',NULL,'1997ApJS..109..333W',1997,1,1.74,NULL,'G',0.000162,NULL,'14.3g',0.55,'Scd:','Isolated galaxy',NULL,NULL,NULL,1,223.78775,43.81858,0.037,NULL,59981288465,937207632,14643869,14.3),(125100,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125100,34.46,0.2,78,56544,74.4,NULL,NULL,'UGC 09598',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125101,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125101,34.47,0.41,78.5,56544,NULL,NULL,'Malmquist cor.','UGC 09598',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125102,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125102,34.59,0.38,82.6,56544,75,NULL,'CF, r, raw','UGC 09598',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125103,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125103,34.63,0.38,84.4,56544,NULL,NULL,NULL,'UGC 09598',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125104,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125104,34.68,0.4,86.4,56544,NULL,NULL,'mean','UGC 09598',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125105,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125105,34.74,0.38,88.8,56544,75,NULL,'CF, r, inv','UGC 09598',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125106,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125106,34.83,0.47,92.5,56544,NULL,NULL,'H','UGC 09598',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125107,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125107,34.85,0.38,93.3,56544,75,NULL,'CF, r, cor','UGC 09598',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125108,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125108,34.93,0.46,96.9,56544,NULL,NULL,'J','UGC 09598',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125109,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125109,35.03,0.45,101,56544,NULL,NULL,'K','UGC 09598',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125110,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125110,38.16,0.46,428,56545,70,NULL,NULL,'2MASX J14550921+5151153',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.7885417,51.85406,0.037,NULL,59930107691,936407932,14631373,17.8),(125111,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125111,37.03,0.1,254,56546,70,NULL,NULL,'2MASX J14551187+1853594',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000077,NULL,'18.25',0.16,NULL,NULL,NULL,NULL,NULL,1,223.799416667,18.89997,0.033,NULL,59531396239,930178066,14534032,18.25),(125112,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125112,37.04,0.33,256,56547,70,NULL,NULL,'2MASX J14551222+1908484',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.26',0.18,NULL,NULL,NULL,NULL,NULL,1,223.800875,19.14675,0.057,NULL,59531707523,930182930,14534108,18.26),(125113,'IRAS','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125113,33.39,0.8,47.6,56548,75,NULL,'MAT, I','ESO 580- G 052',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000019,NULL,'14.06',1.2,'SB(s)d pec?    HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,223.803417,-19.66478,0.357,NULL,46651837922,728934967,11389608,14.06),(125114,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125114,33.52,0.62,50.5,56548,NULL,NULL,'Malmquist cor.','ESO 580- G 052',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125115,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125115,33.7,0.32,54.9,56548,85,NULL,'I, raw','ESO 580- G 052',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125116,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125116,33.74,0.32,55.9,56548,85,NULL,'I, inv','ESO 580- G 052',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125117,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125117,33.77,0.43,56.9,56548,75,NULL,'MAT, I, raw','ESO 580- G 052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125118,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125118,33.78,0.2,57,56548,74.4,NULL,NULL,'ESO 580- G 052',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125119,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125119,33.91,0.52,60.5,56548,NULL,NULL,NULL,'ESO 580- G 052',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125120,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125120,33.96,0.43,61.9,56548,75,NULL,'MAT, I, inv','ESO 580- G 052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125121,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125121,33.96,0.43,62,56548,75,NULL,'MAT, I, cor','ESO 580- G 052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125122,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125122,33.62,0.49,52.9,56549,75,NULL,'IR','UGC 09605',NULL,'2011yCatp016004901K',2011,1,1.21,NULL,'G',0.00001,NULL,'15.7g',0.21,'Sd',NULL,NULL,NULL,NULL,1,223.815917,48.36564,0.041,NULL,59934436349,936475567,14632430,15.7),(125123,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125123,34.1,NULL,66.2,56549,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09605',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125124,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125124,34.12,NULL,66.7,56549,NULL,NULL,'Dipole','UGC 09605',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125125,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125125,34.12,NULL,66.7,56549,NULL,NULL,'Dipole + Quadrupole','UGC 09605',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125126,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125126,34.74,NULL,88.5,56549,NULL,NULL,NULL,'UGC 09605',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125127,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125127,37.65,0.46,339,56550,70,NULL,NULL,'SDSS J145516.86+173320.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.82025,17.55567,0.029,NULL,59586948404,931046068,14547594,17.9),(125128,'D-Sigma','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125128,35.15,0.4,107,56551,75,NULL,'Edat, raw','ESO 386- G 031',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.00015,NULL,'15.5',0.7,'S0',NULL,NULL,NULL,NULL,1,223.830417,-35.72536,0.261,NULL,47243353979,738177405,11534021,15.5),(125129,'D-Sigma','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125129,35.49,0.4,125,56551,75,NULL,'Edat, cor','ESO 386- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125130,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125130,37.56,0.46,325,56552,70,NULL,NULL,'2MASX J14551968+0104104',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000084,NULL,'17.2g',0.23,'AGN',NULL,NULL,NULL,NULL,1,223.832166667,1.06956,0.133,NULL,58250856439,910169631,14221400,17.2),(125131,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125131,36.3,0.46,182,56553,70,NULL,NULL,'2MASX J14551998+0929564',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.82',0.15,NULL,NULL,NULL,NULL,NULL,1,223.833417,9.49911,0.037,NULL,59376589823,927759215,14496237,18.82),(125132,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125132,37.97,0.11,392,56554,70,NULL,NULL,'2MASX J14552184+5427413',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000132,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,223.840666667,54.46153,0.013,NULL,59190108065,924845438,14450709,18.1),(125133,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125133,38.16,0.27,429,56555,70,NULL,NULL,'SDSS J145523.31+092705.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000172,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.847167,9.45161,0.037,NULL,59376588440,927759194,14496237,17.9),(125134,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125134,38.04,0.33,405,56556,70,NULL,NULL,'SDSS J145523.65+223012.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.848583,22.50344,0.101,NULL,59527654987,930119609,14533118,18),(125135,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125135,36.51,0.25,200,56557,74.4,NULL,NULL,'CGCG 105-076',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000077,NULL,'14.43',0.6,'Sa','Group member',NULL,NULL,NULL,1,223.8490417,18.83567,0.033,NULL,59531657424,930182147,14534096,14.43),(125136,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125136,36.68,0.23,217,56557,70,NULL,NULL,'CGCG 105-076',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125137,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125137,37.83,0.33,368,56558,70,NULL,NULL,'2MASX J14552471+3237316',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000169,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.852917,32.6255,0.013,NULL,60089776608,938902759,14670355,18),(125138,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125138,37.71,0.46,349,56559,70,NULL,NULL,'SDSS J145525.55+312020.1',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.8564583,31.33892,0.034,NULL,60090459251,938913425,14670522,17.5),(125139,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125139,37.95,0.46,388,56560,70,NULL,NULL,'2MASXi J1455258-003420',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000079,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.85775,-0.57233,0.149,NULL,43486929635,679483275,10616926,17.9),(125140,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125140,37.38,0.46,299,56561,70,NULL,NULL,'2MASX J14552661+3130047',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.27',0.15,NULL,NULL,NULL,NULL,NULL,1,223.860625,31.50122,0.034,NULL,60090454383,938913349,14670521,18.27),(125141,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125141,34.63,0.46,84.3,56562,70,NULL,NULL,'CGCG 221-014',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000147,NULL,'14.6g',0.53,'S0/a',NULL,NULL,NULL,NULL,1,223.8642083,41.25733,0.017,NULL,59949617428,936712772,14636137,14.6),(125142,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125142,37.6,0.46,331,56563,70,NULL,NULL,'2MASX J14552907+3329477',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,223.871125,33.4965,0.036,NULL,60123140577,939424071,14678501,18.2),(125143,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125143,38.59,0.46,523,56564,70,NULL,NULL,'2MASX J14552912+5453523',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,223.871125,54.89792,0.005,NULL,57244036884,894438076,13975594,18),(125144,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125144,37.45,0.46,310,56565,70,NULL,NULL,'2MASX J14552912+2942334',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000197,NULL,'18.14',0.17,'Pec',NULL,NULL,NULL,NULL,1,223.87125,29.70942,0.06,NULL,60093866894,938966670,14671354,18.14),(125145,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125145,36.49,0.09,198,56566,70,NULL,NULL,'2MASX J14552971+1627465',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00015,NULL,'16.43',0.5,'S0','Group member',NULL,NULL,NULL,1,223.8739583,16.46286,0.025,NULL,59590250333,931097661,14548400,16.43),(125146,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125146,36.43,0.76,193,56567,70,NULL,NULL,'LCRS B145254.3-052427',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.69',NULL,NULL,NULL,NULL,NULL,NULL,1,223.885083,-5.60958,0.241,NULL,46445624325,725712880,11339263,16.69),(125147,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125147,35.86,0.46,148,56568,70,NULL,NULL,'2MASX J14553300+0302143',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000089,NULL,'16.1g',0.36,'S0',NULL,NULL,NULL,NULL,1,223.8874583,3.03717,0.133,NULL,59326464607,926976009,14484000,16.1),(125148,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125148,38.43,0.46,486,56569,70,NULL,NULL,'2MASX J14553388+2841234',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,223.8910417,28.68997,0.066,NULL,60082196964,938784327,14668505,17.9),(125149,'IRAS','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125149,33.92,0.8,60.7,56570,75,NULL,'MAT, I','ESO 327- G 031',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000023,NULL,'12.70',0.4,'SB(s)c? sp',NULL,NULL,NULL,NULL,1,223.8927083,-38.27833,0.265,NULL,47235526820,738055106,11532111,12.7),(125150,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125150,32.96,0.32,39.1,56570,85,NULL,'I, raw','ESO 327- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125151,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125151,32.98,0.32,39.5,56570,85,NULL,'I, inv','ESO 327- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125152,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125152,33.01,0.43,39.9,56570,75,NULL,'MAT, I, raw','ESO 327- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125153,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125153,33.14,0.43,42.5,56570,75,NULL,'MAT, I, inv','ESO 327- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125154,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125154,33.19,0.8,43.4,56570,NULL,NULL,NULL,'ESO 327- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125155,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125155,33.23,0.2,44.3,56570,74.4,NULL,NULL,'ESO 327- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125156,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125156,33.27,0.77,45.1,56570,NULL,NULL,'Malmquist cor.','ESO 327- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125157,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125157,33.42,0.43,48.2,56570,75,NULL,'MAT, I, cor','ESO 327- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125158,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125158,37.18,0.33,273,56571,70,NULL,NULL,'2MASX J14553476+5000380',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000185,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,223.895,50.01069,0.009,NULL,59943261023,936613453,14634585,16.9),(125159,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125159,35.75,0.46,142,56572,70,NULL,NULL,'2MASX J14553517+6305271',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000093,NULL,'16.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,223.896833,63.09072,0.013,NULL,57764474048,902569907,14102654,16.8),(125160,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125160,38.19,0.46,434,56573,70,NULL,NULL,'2MASX J14553541+2105274',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.8975417,21.09106,0.049,NULL,59540710863,930323607,14536306,17.9),(125161,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125161,38.11,0.46,418,56574,70,NULL,NULL,'SDSS J145535.85+525713.0',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000142,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,223.899375,52.95361,0.005,NULL,59928496335,936382755,14630980,18.1),(125162,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125162,36.78,0.33,227,56575,70,NULL,NULL,'2MASX J14553630+2527129',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.15',0.29,NULL,NULL,NULL,NULL,NULL,1,223.9012083,25.45353,0.153,NULL,60012961513,937702523,14651601,17.15),(125163,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125163,36.93,0.46,243,56576,70,NULL,NULL,'2MASX J14553633+0326333',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000073,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,223.9015,3.44264,0.141,NULL,59338825961,927169155,14487018,17.4),(125164,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125164,35.74,0.65,140,56577,70,NULL,NULL,'ESO 581- G 001',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'16',1,'SAB(r)bc',NULL,NULL,NULL,NULL,1,223.90825,-21.59222,0.397,NULL,46655303603,728989118,11390454,16),(125165,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125165,38.35,0.46,467,56578,70,NULL,NULL,'SDSS J145539.41+020319.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000075,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,223.91425,2.0555,0.149,NULL,59326856834,926982138,14484095,18.4),(125166,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125166,36.38,0.46,188,56579,70,NULL,NULL,'2MASX J14553971+2335334',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.98',0.17,NULL,NULL,NULL,NULL,NULL,1,223.915375,23.59261,0.085,NULL,59529235688,930144307,14533504,17.98),(125167,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125167,38.04,0.33,405,56580,70,NULL,NULL,'2MASX J14553970+2224214',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.54',0.27,NULL,NULL,NULL,NULL,NULL,1,223.915541667,22.406,0.101,NULL,59527552907,930118014,14533093,17.54),(125168,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125168,37.04,0.33,256,56581,70,NULL,NULL,'2MASX J14554049+1916514',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.31',0.27,'E','Group member',NULL,NULL,NULL,1,223.9187917,19.281,0.081,NULL,59531798907,930184357,14534130,17.31),(125169,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125169,38.02,0.46,402,56582,70,NULL,NULL,'2MASX J14554058+4925471',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,223.9189583,49.42964,0.021,NULL,59944238770,936628730,14634823,17.8),(125170,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125170,36.99,0.46,250,56583,70,NULL,NULL,'2MASX J14554233+2819509',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.49',0.24,NULL,NULL,NULL,NULL,NULL,1,223.92625,28.33069,0.061,NULL,60082332013,938786437,14668538,17.49),(125171,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125171,36.58,0.46,207,56584,70,NULL,NULL,'2MASX J14554341+2108314',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.57',0.18,NULL,NULL,NULL,NULL,NULL,1,223.9310417,21.14197,0.049,NULL,59540601031,930321891,14536279,17.57),(125172,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125172,37.59,0.33,329,56585,70,NULL,NULL,'2MASX J14554489-0018218',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000098,NULL,'16.1g',0.32,NULL,NULL,NULL,NULL,NULL,1,223.937166667,-0.30617,0.161,NULL,43487015895,679484623,10616947,16.1),(125173,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125173,37.18,0.33,273,56586,70,NULL,NULL,'2MASX J14554521+5008091',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000189,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,223.938291667,50.13589,0.009,NULL,59943232772,936613012,14634578,16.5),(125174,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125174,37.62,0.27,335,56587,70,NULL,NULL,'2MASX J14554528+4731329',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,223.9385417,47.52572,0.041,NULL,59989138172,937330283,14645785,17.8),(125175,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125175,35.46,0.54,124,56588,70,NULL,NULL,'2MASX J14554568-3946020',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000113,NULL,'13.4I',0.6,NULL,NULL,NULL,NULL,NULL,1,223.9404583,-39.76725,0.185,NULL,47216234261,737753660,11527400,13.4),(125176,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125176,37.59,0.33,329,56589,70,NULL,NULL,'2MASX J14554576-0020058',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000102,NULL,'16.3g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,223.940708333,-0.33494,0.161,NULL,43487016594,679484634,10616947,16.3),(125177,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125177,36.36,0.33,187,56590,70,NULL,NULL,'2MASX J14554655+2151074',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'17.15',0.24,NULL,NULL,NULL,NULL,NULL,1,223.9439583,21.85211,0.081,NULL,59541103609,930329743,14536402,17.15),(125178,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125178,38.09,0.46,414,56591,70,NULL,NULL,'2MASX J14554707+3954583',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000184,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,223.946333,39.91608,0.041,NULL,60070907757,938607933,14665748,17.2),(125179,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125179,37.03,0.1,254,56592,70,NULL,NULL,'2MASX J14554754+1823044',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000097,NULL,'18.33',0.16,NULL,NULL,NULL,NULL,NULL,1,223.948083,18.38469,0.025,NULL,59587370108,931052657,14547697,18.33),(125180,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125180,36.41,0.33,191,56593,70,NULL,NULL,'2MASX J14554837+0052073',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000079,NULL,'16.7g',0.3,'AGN',NULL,NULL,NULL,NULL,1,223.951625,0.86881,0.133,NULL,58250872858,910169888,14221404,16.7),(125181,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125181,38.17,0.46,431,56594,70,NULL,NULL,'SDSS J145548.81+260140.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.7g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.953375,26.02794,0.156,NULL,60013042782,937703793,14651621,18.7),(125182,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125182,37.97,0.11,392,56595,70,NULL,NULL,'2MASX J14555059+5414209',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,223.9605417,54.23906,0.005,NULL,59190195731,924846808,14450731,18),(125183,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125183,38.99,0.46,627,56596,70,NULL,NULL,'SDSS J145551.30+130245.4',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.963791667,13.04597,0.029,NULL,59547473923,930429280,14537957,18.4),(125184,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125184,37.17,0.33,271,56597,70,NULL,NULL,'2MASX J14555216+4925302',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000175,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,223.967583,49.42511,0.021,NULL,59944238285,936628723,14634823,16.7),(125185,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125185,34.69,NULL,86.6,56598,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09606',NULL,'2010Ap&SS.325..163P',2010,1,1.62,NULL,'G',0.000008,NULL,'16.0',0.18,'Sbc',NULL,NULL,NULL,NULL,1,223.96825,24.71972,0.081,NULL,59493002351,929578161,14524658,16),(125186,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125186,34.69,NULL,86.9,56598,NULL,NULL,'Dipole + Quadrupole','UGC 09606',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125187,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125187,34.71,NULL,87.3,56598,NULL,NULL,'Dipole','UGC 09606',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125188,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125188,34.74,NULL,88.6,56598,NULL,NULL,NULL,'UGC 09606',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125189,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125189,34.79,0.49,90.8,56598,75,NULL,'IR','UGC 09606',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125190,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125190,35.34,0.2,117,56598,74.4,NULL,NULL,'UGC 09606',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125191,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125191,37.32,0.33,291,56599,70,NULL,NULL,'2MASX J14555287-0155338',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00015,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,223.9702917,-1.92617,0.161,NULL,46441124502,725642570,11338165,17),(125192,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125192,37.62,0.27,335,56600,70,NULL,NULL,'2MASX J14555467+4732134',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.97775,47.53706,0.041,NULL,59989145721,937330401,14645787,17.8),(125193,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125193,35.79,0.4,144,56601,NULL,NULL,'mean','NGC 5782',NULL,'2007A&A...465...71T',2007,1,0.8,NULL,'G',0.000147,NULL,'14.59',0.8,'S0','Pair member (points to parent)',NULL,'radio jet','Flat-Spectrum Radio Source',1,223.980291667,11.86153,0.037,NULL,59367174184,927612096,14493939,14.59),(125194,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125194,36.59,0.45,208,56601,NULL,NULL,'K','NGC 5782',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125195,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125195,38.11,0.46,418,56602,70,NULL,NULL,'2MASX J14555582+2944019',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000183,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,223.982667,29.73389,0.051,NULL,60093680763,938963761,14671308,17.6),(125196,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125196,36.5,0.25,200,56603,74.4,NULL,NULL,'CGCG 105-077',NULL,'2013AJ....146...86T',2013,1,0.37,NULL,'G',0.000077,NULL,'14.45',0.33,'E','Group member',NULL,NULL,NULL,1,223.9862917,18.04733,0.041,NULL,59587279474,931051241,14547675,14.45),(125197,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125197,36.54,0.46,204,56603,70,NULL,NULL,'CGCG 105-077',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125198,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125198,36.68,0.23,217,56603,70,NULL,NULL,'CGCG 105-077',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125199,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125199,36.93,0.46,243,56604,70,NULL,NULL,'2MASX J14555687-0152018',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.9869583,-1.86731,0.161,NULL,46440950851,725639857,11338122,17.3),(125200,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125200,37.83,0.33,368,56605,70,NULL,NULL,'SDSS J145557.16+323459.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000149,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,223.988167,32.58319,0.013,NULL,60089823568,938903493,14670367,18.7),(125201,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125201,37.36,0.46,297,56606,70,NULL,NULL,'2MASX J14555745+0523323',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,223.989583,5.39225,0.085,NULL,59335610228,927118909,14486232,17.6),(125202,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125202,36.5,0.25,200,56607,74.4,NULL,NULL,'GIN 381',NULL,'2013AJ....146...86T',2013,1,0.43,NULL,'G',0.000244,NULL,'15.25',0.4,'Sc','Group member',NULL,NULL,NULL,1,223.991583333,18.50233,0.025,NULL,59587345766,931052277,14547691,15.25),(125203,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125203,36.68,0.23,217,56607,70,NULL,NULL,'GIN 381',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125204,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125204,37.61,0.46,332,56608,70,NULL,NULL,'SDSS J145558.09+353208.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000128,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,223.9920417,35.53569,0,NULL,60125733873,939464591,14679134,18),(125205,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125205,36.78,0.33,227,56609,70,NULL,NULL,'2MASX J14555853+2536289',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.61',0.13,NULL,NULL,NULL,NULL,NULL,1,223.993833333,25.60808,0.143,NULL,60012983988,937702874,14651607,18.61),(125206,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125206,37.32,0.33,291,56610,70,NULL,NULL,'2MASX J14555874-0157458',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000113,NULL,'17.4g',0.23,'AGN',NULL,NULL,NULL,NULL,1,223.994708333,-1.96261,0.161,NULL,46441125223,725642581,11338165,17.4),(125207,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125207,37.62,0.33,335,56611,70,NULL,NULL,'SDSS J145558.88+260348.6',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.4g',0.31,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.995333,26.0635,0.156,NULL,60013048667,937703885,14651623,16.4),(125208,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125208,35.46,0.46,124,56612,70,NULL,NULL,'2MASX J14555917+3539479',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000171,NULL,'16.0g',0.29,'S0^-',NULL,NULL,NULL,NULL,1,223.996417,35.66342,0.009,NULL,60126191450,939471741,14679245,16),(125209,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125209,37.29,0.46,287,56613,70,NULL,NULL,'2MASX J14555965+0446523',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000094,NULL,'16.3g',0.36,'AGN',NULL,NULL,NULL,NULL,1,223.9985,4.78108,0.117,NULL,59335250423,927113287,14486145,16.3),(125210,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125210,37.42,0.46,304,56614,70,NULL,NULL,'2MASX J14555967+1153097',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000166,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.998708333,11.88622,0.037,NULL,59367174884,927612107,14493939,17.5),(125211,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125211,38.58,0.46,520,56615,70,NULL,NULL,'SDSS J145601.36+441820.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000138,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,224.0057083,44.30556,0.049,NULL,59992652465,937385194,14646643,18.3),(125212,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125212,37.38,0.46,300,56616,70,NULL,NULL,'2MASX J14560225+0516001',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,224.009375,5.26681,0.085,NULL,59335334069,927114594,14486165,17.3),(125213,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125213,37.46,0.46,311,56617,70,NULL,NULL,'SDSS J145602.33+211059.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.0097083,21.18311,0.037,NULL,59540600374,930321880,14536279,18.4),(125214,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125214,37.42,0.46,305,56618,70,NULL,NULL,'2MASX J14560238+0008041',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000076,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,224.01,0.1345,0.153,NULL,58251128314,910173879,14221466,16.9),(125215,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125215,38.16,0.27,429,56619,70,NULL,NULL,'2MASX J14560243+0911427',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,224.010125,9.19533,0.045,NULL,59389850893,927966420,14499475,18.2),(125216,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125216,37.54,0.27,322,56620,70,NULL,NULL,'2MASX J14560260+3131539',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000175,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,224.0107083,31.53156,0.046,NULL,60090329935,938911405,14670490,16.6),(125217,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125217,37.54,0.27,322,56621,70,NULL,NULL,'2MASX J14560346+3130500',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000138,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,224.0145417,31.51392,0.046,NULL,60090331540,938911430,14670491,17.5),(125218,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125218,35.28,0.55,114,56622,NULL,NULL,'Malmquist cor.','ESO 448- G 008',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'13.29',0.4,'Sb             HII',NULL,NULL,NULL,NULL,1,224.0177083,-27.76797,0.625,NULL,47196036251,737438066,11522469,13.29),(125219,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125219,35.69,0.46,138,56622,NULL,NULL,NULL,'ESO 448- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125220,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125220,35.73,0.2,140,56622,74.4,NULL,NULL,'ESO 448- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125221,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2007O',NULL,125221,35.24,0.16,108,56623,74.2,NULL,'SALT 2','UGC 09612',0.036212,'2010ApJ...716..712A',2010,1,0.85,NULL,'G',0.000087,NULL,'14.7g',0.76,'SAB(s)c',NULL,NULL,NULL,NULL,1,224.0182083,45.40528,0.029,NULL,59995043343,937422552,14647227,14.7),(125222,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2007O',NULL,125222,35.79,0.09,144,56623,74.4,NULL,NULL,'UGC 09612',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125223,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2007O',NULL,125223,35.95,0.15,150,56623,70,NULL,'SALT 2','UGC 09612',0.036212,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125224,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2007O',NULL,125224,35.98,0.04,152,56623,72,NULL,'SALT2','UGC 09612',0.036212,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125225,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2007O',NULL,125225,36.07,0.18,158,56623,65,NULL,'SALT2','UGC 09612',0.036212,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125226,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2007O',NULL,125226,36.12,0.16,161,56623,65,NULL,'MLCS17','UGC 09612',0.036212,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125227,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2007O',NULL,125227,36.17,0.16,165,56623,65,NULL,'SALT','UGC 09612',0.036212,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125228,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2007O',NULL,125228,36.23,0.15,170,56623,65,NULL,'MLCS31','UGC 09612',0.036212,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125229,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125229,37.62,0.27,335,56624,70,NULL,NULL,'B3 1454+476',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000202,NULL,'16.1g',0.44,'BrClG',NULL,NULL,NULL,NULL,1,224.020375,47.45344,0.037,NULL,59989145193,937330393,14645787,16.1),(125230,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125230,37.7,0.46,347,56625,70,NULL,NULL,'2MASX J14560580+2459189',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.16',0.17,NULL,NULL,NULL,NULL,NULL,1,224.024083,24.98875,0.093,NULL,59492101644,929564088,14524438,18.16),(125231,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125231,37.69,0.46,345,56626,70,NULL,NULL,'2MASX J14560686+0815107',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,224.0284583,8.25294,0.045,NULL,59389759675,927964994,14499453,17.2),(125232,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125232,37.51,0.46,318,56627,70,NULL,NULL,'2MASX J14560718+0850597',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.98',0.13,NULL,NULL,NULL,NULL,NULL,1,224.030083,8.85,0.053,NULL,59390269468,927972960,14499577,18.98),(125233,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125233,34.53,0.45,80.7,56628,NULL,NULL,'K','ESO 386- G 034',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000033,NULL,'13.54',1,'SB(r)a: pec    Sy2?',NULL,NULL,NULL,NULL,1,224.035125,-37.64786,0.269,NULL,47234536805,738039637,11531869,13.54),(125234,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125234,34.54,0.47,81.1,56628,NULL,NULL,'H','ESO 386- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125235,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125235,34.62,0.46,84.1,56628,NULL,NULL,'J','ESO 386- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125236,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125236,35.08,0.4,104,56628,NULL,NULL,'mean','ESO 386- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125237,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125237,36.43,0.46,193,56629,70,NULL,NULL,'2MASX J14560842+0347171',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000102,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,224.035167,3.78822,0.145,NULL,59338683877,927166935,14486983,16.4),(125238,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125238,38.08,0.46,412,56630,70,NULL,NULL,'2MASX J14560937+3924437',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,224.03925,39.41208,0.045,NULL,60071685203,938620081,14665938,18),(125239,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125239,36.36,0.33,187,56631,70,NULL,NULL,'2MASX J14561021+2159328',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.72',0.3,NULL,NULL,NULL,NULL,NULL,1,224.042667,21.99233,0.065,NULL,59540843612,930325681,14536338,16.72),(125240,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125240,37.54,0.27,322,56632,70,NULL,NULL,'SDSS J145610.72+313035.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.044708333,31.50986,0.046,NULL,60090331822,938911434,14670491,18.4),(125241,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125241,37.5,0.46,316,56633,70,NULL,NULL,'2MASX J14561092+5008596',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,224.045417,50.15003,0.009,NULL,59944338468,936630288,14634848,17),(125242,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125242,38.48,0.46,497,56634,70,NULL,NULL,'2MASX J14561195+2153309',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.58',0.15,NULL,NULL,NULL,NULL,NULL,1,224.0497083,21.89186,0.069,NULL,59540892471,930326444,14536350,18.58),(125243,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125243,38.16,0.27,429,56635,70,NULL,NULL,'2MASX J14561250+0917328',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.80',0.16,NULL,NULL,NULL,NULL,NULL,1,224.052166667,9.29247,0.037,NULL,59376024988,927750390,14496099,18.8),(125244,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125244,35.29,0.33,114,56636,70,NULL,NULL,'2MASX J14561256+0924188',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,224.0522083,9.40522,0.033,NULL,59376018292,927750285,14496098,16.2),(125245,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125245,37.16,0.33,270,56637,70,NULL,NULL,'2MASX J14561284+0303041',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000088,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,224.053583333,3.05119,0.173,NULL,59326936104,926983376,14484115,16.6),(125246,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125246,37.43,0.33,306,56638,70,NULL,NULL,'2MASX J14561312+3525310',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000182,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,224.054583,35.42539,0,NULL,60125730178,939464534,14679133,17.5),(125247,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125247,37.43,0.33,306,56639,70,NULL,NULL,'2MASX J14561369+3529370',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000167,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,224.057083,35.49369,0,NULL,60125681222,939463769,14679121,16.8),(125248,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125248,36.42,0.33,192,56640,70,NULL,NULL,'CGCG 134-057',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000157,NULL,'15.3',0.32,NULL,NULL,NULL,NULL,NULL,1,224.0675,20.52239,0.061,NULL,59541612571,930337696,14536526,15.3),(125249,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125249,37.25,0.46,282,56641,70,NULL,NULL,'2MASX J14561668+4654585',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00017,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,224.069625,46.91628,0.029,NULL,59989220681,937331573,14645805,16.7),(125250,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125250,35.21,0.46,110,56642,70,NULL,NULL,'MCG -06-33-005',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000097,NULL,'15',0.4,NULL,NULL,NULL,NULL,NULL,1,224.0710417,-37.73283,0.269,NULL,47234519367,738039365,11531865,15),(125251,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125251,36.12,0.46,167,56643,70,NULL,NULL,'2MASX J14561732+2444511',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000067,NULL,'15.85',0.34,NULL,NULL,NULL,NULL,NULL,1,224.072417,24.74744,0.097,NULL,59492877518,929576211,14524628,15.85),(125252,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125252,37.16,0.33,270,56644,70,NULL,NULL,'2MASX J14561771+0259521',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00008,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,224.073791667,2.99775,0.173,NULL,59326935396,926983365,14484115,16.8),(125253,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125253,37.77,0.46,357,56645,70,NULL,NULL,'2MASX J14561771+0130461',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000077,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,224.073833333,1.51264,0.145,NULL,59324770184,926949534,14483586,17.8),(125254,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125254,37.21,0.46,277,56646,70,NULL,NULL,'2MASX J14561832+0847030',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.56',0.18,NULL,NULL,NULL,NULL,NULL,1,224.07625,8.78425,0.073,NULL,59390277071,927973079,14499579,18.56),(125255,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125255,37.22,0.46,279,56647,70,NULL,NULL,'2MASX J14561853+2102079',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.15',0.17,NULL,NULL,NULL,NULL,NULL,1,224.077333,21.03556,0.049,NULL,59540621030,930322203,14536284,18.15),(125256,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125256,37.52,0.33,319,56648,70,NULL,NULL,'2MASXi J1456188+222259',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'16.5I',0.16,NULL,NULL,NULL,NULL,NULL,1,224.078667,22.38333,0.101,NULL,59527547141,930117924,14533092,16.5),(125257,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125257,37.52,0.33,319,56649,70,NULL,NULL,'2MASX J14562084+2222469',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.56',0.17,NULL,NULL,NULL,NULL,NULL,1,224.086917,22.37975,0.101,NULL,59527038475,930109976,14532968,18.56),(125258,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125258,36.57,0.57,206,56650,70,NULL,NULL,'2MASX J14562221-1327302',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.39',0.4,NULL,NULL,NULL,NULL,NULL,1,224.092666667,-13.45858,0.337,NULL,46683358264,729427472,11397304,16.39),(125259,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125259,37.43,0.46,306,56651,70,NULL,NULL,'2MASX J14562273+3424169',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000172,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,224.0947083,34.40478,0.021,NULL,60126973203,939483956,14679436,17),(125260,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125260,38.16,0.46,428,56652,70,NULL,NULL,'2MASX J14562360+6201050',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00008,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,224.098,62.01814,0.017,NULL,57765374608,902583978,14102874,18.1),(125261,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125261,38.17,0.46,431,56653,70,NULL,NULL,'2MASX J14562434+5149587',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000135,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,224.101375,51.83322,0.033,NULL,59929596959,936399952,14631249,18.1),(125262,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125262,32.04,0.47,25.6,56654,NULL,NULL,'H','ESO 386-IG 039',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000029,NULL,'13.16',1,'SB(s)c: pec',NULL,NULL,NULL,NULL,1,224.1055417,-37.60094,0.269,NULL,47234493015,738038953,11531858,13.16),(125263,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125263,32.1,0.46,26.2,56654,NULL,NULL,'J','ESO 386-IG 039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125264,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125264,32.2,0.45,27.6,56654,NULL,NULL,'K','ESO 386-IG 039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125265,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125265,32.72,0.4,35,56654,NULL,NULL,'mean','ESO 386-IG 039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125266,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125266,37.76,0.46,356,56655,70,NULL,NULL,'2MASX J14562603+4749584',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000187,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,224.1085,47.83292,0.057,NULL,59933715706,936464307,14632254,17.3),(125267,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125267,38.27,0.46,451,56656,70,NULL,NULL,'2MASX J14562806+4843117',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000179,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,224.1170417,48.71994,0.021,NULL,59941443018,936585047,14634141,17.1),(125268,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125268,36.28,0.46,180,56657,70,NULL,NULL,'2MASX J14562917+3442149',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000168,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,224.1215417,34.70425,0.011,NULL,60129046999,939516359,14679943,16.1),(125269,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125269,37.62,0.33,335,56658,70,NULL,NULL,'2MASX J14562916+2604522',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.43',0.15,NULL,NULL,NULL,NULL,NULL,1,224.121625,26.08125,0.156,NULL,60013079310,937704364,14651630,18.43),(125270,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125270,37.47,0.46,312,56659,70,NULL,NULL,'2MASX J14563056+2533272',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.27',0.16,NULL,NULL,NULL,NULL,NULL,1,224.1274583,25.55753,0.155,NULL,60012281688,937691901,14651435,18.27),(125271,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125271,37.02,0.46,254,56660,70,NULL,NULL,'2MASX J14563225+4910527',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000166,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,224.134208333,49.18144,0.017,NULL,59941548786,936586699,14634167,16.2),(125272,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125272,38.11,0.46,418,56661,70,NULL,NULL,'SDSS J145632.34+413104.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000143,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,224.13475,41.51786,0,NULL,59979175653,937174619,14643353,18.7),(125273,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125273,38.29,0.46,455,56662,70,NULL,NULL,'2MASX J14563299+1438283',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.38',0.18,NULL,NULL,NULL,NULL,NULL,1,224.137375,14.64111,0.069,NULL,59578382089,930912220,14545503,18.38),(125274,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125274,34.26,0.2,71.1,56663,74.4,NULL,NULL,'ESO 513- G 009',NULL,'2013AJ....146...86T',2013,1,NULL,'Monnier-Ragaigne et al. (2003A&A...408..465M) also give v = 8563+/-14 km/sec.','GPair',0.000027,NULL,NULL,NULL,'Sc',NULL,NULL,NULL,NULL,1,224.140583,-24.50272,0.509,NULL,46524198299,726940598,11358446,NULL),(125275,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125275,34.35,0.57,74.1,56663,NULL,NULL,NULL,'ESO 513- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125276,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125276,34.46,0.54,77.9,56663,NULL,NULL,'Malmquist cor.','ESO 513- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125277,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125277,35.29,0.33,114,56664,70,NULL,NULL,'IC 1079',NULL,'2015arXiv151105856S',2015,1,1.7,NULL,'G',0.000097,NULL,'13.90',1,'E','Group member',NULL,NULL,NULL,1,224.150667,9.36975,0.033,NULL,59376071317,927751114,14496111,13.9),(125278,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125278,38.11,0.46,419,56665,70,NULL,NULL,'2MASX J14563653+0919551',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,224.15225,9.33189,0.033,NULL,59376069205,927751081,14496110,17.7),(125279,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125279,37.16,0.46,270,56666,70,NULL,NULL,'2MASX J14563855+2501296',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,224.160666667,25.02481,0.113,NULL,59492095831,929563997,14524437,17),(125280,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125280,31.72,0.69,22.1,56667,100,NULL,'mid-IR','MCG -03-38-029',NULL,'2013ApJ...771...88L',2013,1,0.6,NULL,'G',0.000017,NULL,'15.09',0.25,'HII',NULL,NULL,NULL,NULL,1,224.1609583,-16.48786,0.429,NULL,46706059836,729782184,11402846,15.09),(125281,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125281,38.15,0.46,428,56668,70,NULL,NULL,'SDSS J145638.70+165051.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.1612917,16.84764,0.029,NULL,59592167067,931127610,14548868,18.3),(125282,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125282,37.78,0.46,359,56669,70,NULL,NULL,'2MASX J14563882+3230306',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,224.161833,32.50844,0.013,NULL,60089811137,938903299,14670364,17.2),(125283,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125283,38.23,0.46,443,56670,70,NULL,NULL,'2MASX J14563933+0008376',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000097,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,224.163833,0.14364,0.141,NULL,58251088225,910173253,14221457,17.9),(125284,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125284,32.37,0.4,29.8,56671,NULL,NULL,'mean','NGC 5781',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.00001,NULL,'13.82',0.8,'(R\')SBb pec sp',NULL,NULL,NULL,NULL,1,224.17175,-17.24394,0.433,NULL,46704153323,729752395,11402381,13.82),(125285,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125285,32.54,0.45,32.2,56671,NULL,NULL,'K','NGC 5781',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125286,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125286,32.57,0.47,32.6,56671,NULL,NULL,'H','NGC 5781',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125287,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125287,32.59,0.46,32.9,56671,NULL,NULL,'J','NGC 5781',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125288,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125288,37.79,0.46,362,56672,70,NULL,NULL,'SDSS J145641.56+011616.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000083,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,224.1732083,1.27131,0.137,NULL,59324792390,926949881,14483591,17.8),(125289,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005ag',NULL,125289,37.3,0.08,288,56673,72,NULL,'M(H) = -18.317 mag','2MASX J14564322+0919361',NULL,'2014ApJ...784..105W',2013,1,0.28,NULL,'G',NULL,NULL,'18.05',0.22,NULL,NULL,NULL,NULL,NULL,1,224.1800417,9.32678,0.033,NULL,59376069675,927751088,14496110,18.05),(125290,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005ag',NULL,125290,37.57,0.02,302,56673,70,NULL,NULL,'2MASX J14564322+0919361',0.07937,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125291,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005ag','R',125291,37.41,0.05,303,56673,NULL,NULL,'MLCS2k2, R(V) = 3.1','2MASX J14564322+0919361',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125292,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005ag','R',125292,37.44,0.04,308,56673,NULL,NULL,'MLCS2k2, R(V) = 1.8','2MASX J14564322+0919361',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125293,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005ag',NULL,125293,37.62,0.08,310,56673,72,NULL,NULL,'2MASX J14564322+0919361',0.07937,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125294,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005ag',NULL,125294,37.8,0.37,311,56673,72,NULL,NULL,'2MASX J14564322+0919361',0.0804,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125295,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005ag',NULL,125295,37.64,0.12,313,56673,72,NULL,'z lit','2MASX J14564322+0919361',0.07937,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125296,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005ag',NULL,125296,37.67,0.14,317,56673,70,NULL,'SALT 2','2MASX J14564322+0919361',0.07937,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125297,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005ag',NULL,125297,37.54,0.01,322,56673,72,NULL,'z lit','2MASX J14564322+0919361',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125298,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005ag',NULL,125298,37.71,0.13,323,56673,73.8,NULL,'SALT 2 (SNANA)','2MASX J14564322+0919361',0.0801,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125299,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005ag',NULL,125299,37.56,0.1,325,56673,74.4,NULL,NULL,'2MASX J14564322+0919361',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125300,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125300,36.5,0.46,200,56674,70,NULL,NULL,'UGC 09613 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00013,NULL,'16.69',0.3,'S',NULL,NULL,NULL,NULL,1,224.180125,5.59292,0.061,NULL,59335603182,927118799,14486231,16.69),(125301,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125301,37.66,0.46,341,56675,70,NULL,NULL,'2MASX J14564495+1007409',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'19.03',0.15,NULL,NULL,NULL,NULL,NULL,1,224.1874583,10.12797,0.033,NULL,59376333469,927755210,14496175,19.03),(125302,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125302,35.5,0.2,126,56676,74.4,NULL,NULL,'UGC 09613',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.00018,NULL,'15.07',0.5,NULL,NULL,NULL,NULL,NULL,1,224.191333333,5.58378,0.061,NULL,59335603111,927118798,14486231,15.07),(125303,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125303,38,0.46,397,56677,70,NULL,NULL,'2MASX J14564686+3358567',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,224.1952917,33.98236,0.016,NULL,60127026908,939484795,14679449,17.8),(125304,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125304,37.67,0.46,341,56678,70,NULL,NULL,'2MASX J14564687+5002236',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000152,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,224.195417,50.03997,0.009,NULL,59944348596,936630446,14634850,16.9),(125305,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125305,37.71,0.46,349,56679,70,NULL,NULL,'SDSS J145647.54+215438.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.5g',0.09,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.198083,21.91075,0.065,NULL,59540882592,930326290,14536348,18.5),(125306,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125306,38.24,0.46,446,56680,70,NULL,NULL,'2MASX J14564768+5304056',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00015,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,224.198708333,53.06839,0.005,NULL,59928713259,936386144,14631033,17.5),(125307,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125307,37.71,0.46,348,56681,70,NULL,NULL,'SDSS J145648.43+250237.1',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.201833333,25.04367,0.113,NULL,59492126011,929564468,14524444,17.4),(125308,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125308,37.84,0.27,369,56682,70,NULL,NULL,'2MASX J14564896+1103339',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,224.2039583,11.05947,0.025,NULL,59374876446,927732444,14495819,17.8),(125309,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125309,37.83,0.46,369,56683,70,NULL,NULL,'SDSS J145649.21+290930.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.205083,29.15836,0.04,NULL,60093256054,938957125,14671205,18),(125310,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125310,36.49,0.33,199,56684,70,NULL,NULL,'2MASX J14565083+0849530',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.85',0.23,NULL,NULL,NULL,NULL,NULL,1,224.211875,8.83144,0.073,NULL,59389936594,927967759,14499496,16.85),(125311,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125311,34.59,0.46,82.9,56685,70,NULL,NULL,'UGC 09623',NULL,'2015arXiv151105856S',2015,1,1.14,NULL,'G',0.000103,NULL,'14.1g',0.73,'S0',NULL,NULL,NULL,NULL,1,224.2144583,38.75647,0.045,NULL,60117469403,939335459,14677116,14.1),(125312,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125312,37.84,0.27,369,56686,70,NULL,NULL,'2MASX J14565215+1103530',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,224.217417,11.06472,0.025,NULL,59374876507,927732445,14495819,17.3),(125313,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125313,38.04,0.46,406,56687,70,NULL,NULL,'SDSS J145652.56+062024.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.2190417,6.34014,0.089,NULL,59379985300,927812270,14497066,18),(125314,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125314,38.39,0.33,476,56688,70,NULL,NULL,'SDSS J145652.62+322658.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000188,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,224.2192917,32.44956,0.013,NULL,60089901585,938904712,14670386,18.5),(125315,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125315,32.59,0.48,32.9,56689,70,NULL,NULL,'ESO 386- G 040',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'14',0.8,'S0:',NULL,NULL,NULL,NULL,1,224.2290417,-35.94486,0.245,NULL,47242899502,738170304,11533911,14),(125316,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125316,38.16,0.46,429,56690,70,NULL,NULL,'2MASX J14565606+3443267',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00018,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,224.233625,34.72422,0.011,NULL,60129035336,939516177,14679940,17.2),(125317,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125317,38.31,0.46,459,56691,70,NULL,NULL,'2MASX J14565700+3411127',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000193,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,224.2374583,34.18694,0.016,NULL,60127158157,939486846,14679481,17),(125318,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125318,35.1,0.2,105,56692,74.4,NULL,NULL,'CGCG 164-044',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00007,NULL,'15.6g',0.46,NULL,NULL,NULL,NULL,NULL,1,224.2399583,31.48956,0.035,NULL,60092213548,938940836,14670950,15.6),(125319,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125319,34.12,0.46,66.8,56693,70,NULL,NULL,'CGCG 020-035',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000117,NULL,'15.0g',0.44,'E0',NULL,NULL,NULL,NULL,1,224.2457083,-2.11444,0.213,NULL,46441096749,725642136,11338158,15),(125320,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125320,34.5,0.64,79.6,56693,70,NULL,NULL,'CGCG 020-035',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125321,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125321,36.49,0.33,199,56694,70,NULL,NULL,'2MASX J14565906+0851210',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,224.246083333,8.85569,0.073,NULL,59389971970,927968312,14499504,17.2),(125322,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125322,37.19,0.46,274,56695,70,NULL,NULL,'2MASX J14565921+4509423',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,224.246875,45.16186,0.029,NULL,59994928508,937420757,14647199,17.4),(125323,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125323,38.39,0.33,476,56696,70,NULL,NULL,'SDSS J145659.56+322713.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000165,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,224.248166667,32.45372,0.013,NULL,60089949847,938905466,14670397,18.5),(125324,'D-Sigma','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125324,32.98,0.4,39.5,56697,75,NULL,'Edat, raw','ESO 386- G 041',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.00015,NULL,'13.87',1,'S?',NULL,NULL,NULL,NULL,1,224.251583,-35.88483,0.245,NULL,47242929494,738170773,11533918,13.87),(125325,'D-Sigma','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125325,33.32,0.4,46.1,56697,75,NULL,'Edat, cor','ESO 386- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125326,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125326,36.42,0.33,192,56698,70,NULL,NULL,'2MASX J14570117+2032365',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,224.255,20.5435,0.069,NULL,59541574998,930337109,14536517,16.4),(125327,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125327,36.51,0.46,200,56699,70,NULL,NULL,'2MASX J14570224+3533027',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000117,NULL,'15.6g',0.4,'E0',NULL,NULL,NULL,NULL,1,224.259333,35.55064,0,NULL,60125679235,939463738,14679120,15.6),(125328,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125328,36.5,0.46,200,56700,70,NULL,NULL,'2MASX J14570243+2441086',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.90',0.25,NULL,NULL,NULL,NULL,NULL,1,224.260167,24.68569,0.117,NULL,59492176527,929565258,14524457,16.9),(125329,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125329,37.96,0.46,391,56701,70,NULL,NULL,'2MASX J14570291+0809030',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000159,NULL,'16.8g',0.33,NULL,NULL,NULL,NULL,NULL,1,224.2620417,8.15072,0.045,NULL,59390707854,927979810,14499684,16.8),(125330,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125330,37.27,0.46,284,56702,70,NULL,NULL,'SDSS J145704.32+294740.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.28',0.15,NULL,NULL,NULL,NULL,NULL,1,224.2680417,29.79469,0.051,NULL,60093637863,938963091,14671298,18.28),(125331,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125331,35.54,NULL,128,56703,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1832',NULL,'2010Ap&SS.325..163P',2010,1,0.87,NULL,'G',0.000009,NULL,'16.8',0.09,'Scd',NULL,NULL,NULL,NULL,1,224.273417,9.54606,0.037,NULL,59376090050,927751407,14496115,16.8),(125332,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125332,35.56,NULL,130,56703,NULL,NULL,'Dipole + Quadrupole','FGC 1832',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125333,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125333,35.58,NULL,130,56703,NULL,NULL,'Dipole','FGC 1832',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125334,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125334,36.33,0.2,185,56703,74.4,NULL,NULL,'FGC 1832',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125335,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125335,37.77,0.46,358,56704,70,NULL,NULL,'2MASX J14570652-0059499',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000098,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,224.277167,-0.99725,0.193,NULL,43487174084,679487095,10616985,17),(125336,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125336,35.31,0.47,116,56705,NULL,NULL,'H','ESO 448- G 009',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000033,NULL,'15',0.7,'Sb-c           HII',NULL,NULL,NULL,NULL,1,224.277833333,-31.80358,0.537,NULL,47200472630,737507384,11523552,15),(125337,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125337,35.37,0.45,118,56705,NULL,NULL,'K','ESO 448- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125338,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125338,35.44,0.46,122,56705,NULL,NULL,'J','ESO 448- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125339,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125339,35.53,0.5,128,56705,NULL,NULL,'Malmquist cor.','ESO 448- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125340,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125340,35.54,0.4,128,56705,NULL,NULL,'mean','ESO 448- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125341,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125341,35.85,0.43,148,56705,NULL,NULL,NULL,'ESO 448- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125342,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125342,35.89,0.2,151,56705,74.4,NULL,NULL,'ESO 448- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125343,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125343,38.02,0.46,401,56706,70,NULL,NULL,'2MASX J14570909+3315201',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000179,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,224.28775,33.25564,0.02,NULL,60122291925,939410811,14678293,17.6),(125344,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125344,32.13,0.46,26.7,56707,NULL,NULL,'J','ESO 176- G 006',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000021,NULL,'15.6',0.4,'S',NULL,NULL,NULL,NULL,1,224.2917917,-54.39214,NULL,NULL,46775120779,730861262,11419707,15.6),(125345,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125345,32.21,0.47,27.7,56707,NULL,NULL,'H','ESO 176- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125346,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125346,32.36,0.45,29.7,56707,NULL,NULL,'K','ESO 176- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125347,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125347,32.78,0.4,36,56707,NULL,NULL,'mean','ESO 176- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125348,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125348,34.56,0.49,81.8,56708,75,NULL,'IR','CGCG 105-080',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000009,NULL,'15.7',0.1,NULL,NULL,NULL,NULL,NULL,1,224.294667,17.18778,0.037,NULL,59592194268,931128035,14548875,15.7),(125349,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125349,34.34,0.2,73.8,56709,74.4,NULL,NULL,'CGCG 105-080',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000009,NULL,'15.7',0.1,NULL,NULL,NULL,NULL,NULL,1,224.294667,17.18778,0.037,NULL,59592194268,931128035,14548875,15.7),(125350,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125350,38.37,0.33,472,56710,70,NULL,NULL,'SDSS J145711.71+235326.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.2987917,23.89072,0.105,NULL,59526043150,930094424,14532725,18.5),(125351,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125351,36.44,0.46,194,56711,70,NULL,NULL,'2MASX J14571313+1851391',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',NULL,NULL,'17.15',0.6,'S0/E','Group member',NULL,NULL,NULL,1,224.304875,18.86086,0.053,NULL,59530966450,930171350,14533927,17.15),(125352,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125352,37.15,0.23,270,56712,70,NULL,NULL,'2MASX J14571344+1248136',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000113,NULL,'16.91',0.29,NULL,NULL,NULL,NULL,NULL,1,224.306,12.80364,0.049,NULL,59546632101,930416126,14537751,16.91),(125353,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125353,38.67,0.46,541,56713,70,NULL,NULL,'SDSS J145713.61+203226.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.30675,20.54061,0.069,NULL,59541576545,930337133,14536517,18.7),(125354,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125354,34.75,NULL,89.1,56714,NULL,NULL,NULL,'FGC 1838',NULL,'2000BSAO...50....5K',2000,1,0.73,NULL,'G',0.00003,NULL,'17.2g',0.13,'Sdm',NULL,NULL,NULL,NULL,1,224.316375,38.63453,0.037,NULL,60117455944,939335249,14677113,17.2),(125355,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125355,34.8,NULL,91.1,56714,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1838',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125356,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125356,34.8,NULL,91.4,56714,NULL,NULL,'Dipole + Quadrupole','FGC 1838',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125357,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125357,34.82,NULL,92.1,56714,NULL,NULL,'Dipole','FGC 1838',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125358,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125358,37.84,0.27,369,56715,70,NULL,NULL,'2MASX J14571590+1100317',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,224.3162917,11.00892,0.025,NULL,59375046745,927735105,14495861,17.6),(125359,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125359,34.36,0.48,74.3,56716,70,NULL,NULL,'2MASX J14571724-3727568',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000103,NULL,'12.9I',0.5,NULL,NULL,NULL,NULL,NULL,1,224.321833333,-37.46578,0.261,NULL,47235268651,738051072,11532048,12.9),(125360,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125360,37.78,0.17,360,56717,70,NULL,NULL,'SDSS J145717.61+084303.4',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000159,NULL,'18.6g',0.09,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.323417,8.71761,0.073,NULL,59389943457,927967866,14499497,18.6),(125361,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125361,37.78,0.17,360,56718,70,NULL,NULL,'SDSS J145718.86+084614.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.328625,8.77061,0.073,NULL,59389948575,927967946,14499499,18.1),(125362,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125362,37.97,0.46,392,56719,70,NULL,NULL,'2MASXi J1457188+183233',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.3287083,18.54286,0.049,NULL,59586587541,931040430,14547506,17.8),(125363,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125363,37.81,0.46,365,56720,70,NULL,NULL,'SDSS J145719.09+004747.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000067,NULL,'18.2g',0.15,'E+A',NULL,NULL,NULL,NULL,1,224.3295417,0.79647,0.133,NULL,58250898613,910170290,14221410,18.2),(125364,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125364,37.49,0.23,315,56721,70,NULL,NULL,'SDSS J145719.83+202612.0',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'18.96',0.07,NULL,NULL,NULL,NULL,NULL,1,224.332667,20.43669,0.061,NULL,59541572082,930337063,14536516,18.96),(125365,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125365,37.38,0.46,299,56722,70,NULL,NULL,'SDSS J145721.05+224816.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.33775,22.80453,0.089,NULL,59527401462,930115647,14533056,18.4),(125366,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125366,34.3,0.4,72.5,56723,NULL,NULL,'mean','UGC 09622',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000033,NULL,'14.07',0.8,'S?','Pair member (points to parent)',NULL,NULL,NULL,1,224.338833,19.67294,0.053,NULL,59531201684,930175026,14533984,14.07),(125367,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125367,34.75,0.46,89.2,56723,NULL,NULL,'J','UGC 09622',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125368,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125368,34.8,0.45,91.4,56723,NULL,NULL,'K','UGC 09622',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125369,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125369,34.81,0.47,91.4,56723,NULL,NULL,'H','UGC 09622',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125370,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125370,38.67,0.46,541,56724,70,NULL,NULL,'2MASX J14572302+2653525',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'17.16',0.14,NULL,NULL,NULL,NULL,NULL,1,224.345917,26.898,0.141,NULL,60079953884,938749279,14667957,17.16),(125371,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125371,37.19,0.46,274,56725,70,NULL,NULL,'2MASXi J1457231+523408',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000133,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,224.3465,52.56906,0.013,NULL,59932097630,936439025,14631859,17.7),(125372,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125372,37.15,0.23,270,56726,70,NULL,NULL,'2MASX J14572380+1248217',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,224.349125,12.80619,0.049,NULL,59546628627,930416072,14537751,17.9),(125373,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125373,36.71,0.46,220,56727,70,NULL,NULL,'2MASX J14572473+3109502',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00015,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,224.3530417,31.16397,0.031,NULL,60092317602,938942462,14670975,17.4),(125374,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125374,38.37,0.33,472,56728,70,NULL,NULL,'SDSS J145724.97+235926.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.6g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.354041667,23.99069,0.105,NULL,59526049058,930094516,14532726,18.6),(125375,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125375,36.53,0.46,202,56729,70,NULL,NULL,'2MASX J14572532+1935481',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000087,NULL,'16.09',0.4,NULL,NULL,NULL,NULL,NULL,1,224.355417,19.59667,0.061,NULL,59531726826,930183231,14534112,16.09),(125376,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125376,38.34,0.46,466,56730,70,NULL,NULL,'2MASX J14572531+2029191',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.72',0.13,NULL,NULL,NULL,NULL,NULL,1,224.355417,20.48875,0.069,NULL,59541571353,930337052,14536516,18.72),(125377,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125377,37.78,0.17,360,56731,70,NULL,NULL,'SDSS J145725.38+084528.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.3557917,8.75794,0.073,NULL,59389948037,927967938,14499499,17.9),(125378,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125378,37.35,0.46,296,56732,70,NULL,NULL,'2MASX J14572629+1103348',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000181,NULL,'18.71',0.18,NULL,NULL,NULL,NULL,NULL,1,224.359375,11.05978,0.029,NULL,59375048526,927735133,14495861,18.71),(125379,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125379,37.84,0.46,370,56733,70,NULL,NULL,'2MASX J14572700+3252102',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000188,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,224.362417,32.86958,0.016,NULL,60122430105,939412970,14678327,17.5),(125380,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125380,34.93,0.47,96.8,56734,70,NULL,NULL,'ESO 581- G 003',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.0001,NULL,'16',0.9,'(R_1)SB0^+',NULL,NULL,NULL,NULL,1,224.3635,-21.66542,0.373,NULL,46654762314,728980661,11390322,16),(125381,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125381,36.27,0.46,180,56735,70,NULL,NULL,'2MASX J14572735+1625197',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.00011,NULL,'16.35',0.48,NULL,NULL,NULL,NULL,NULL,1,224.363875,16.42217,0.025,NULL,59590184953,931096639,14548384,16.35),(125382,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125382,37.86,0.23,373,56736,70,NULL,NULL,'2MASX J14572753+3229391',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,224.364625,32.49428,0.013,NULL,60089943084,938905360,14670396,18),(125383,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125383,37.86,0.23,373,56737,70,NULL,NULL,'2MASX J14572760+3220431',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000165,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,224.365083,32.34544,0.014,NULL,60089954167,938905533,14670398,18.3),(125384,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125384,36.81,0.46,230,56738,70,NULL,NULL,'2MASX J14572770+2438545',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'16.44',0.34,NULL,NULL,NULL,NULL,NULL,1,224.3655417,24.64861,0.129,NULL,59492194145,929565533,14524461,16.44),(125385,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125385,36.52,0.46,201,56739,70,NULL,NULL,'2MASX J14572796+2116291',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.33',0.31,NULL,NULL,NULL,NULL,NULL,1,224.366583,21.27467,0.033,NULL,59541032690,930328635,14536384,16.33),(125386,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125386,36.01,0.46,159,56740,70,NULL,NULL,'2MASX J14572815+0550375',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.63',0.37,NULL,NULL,NULL,NULL,NULL,1,224.367417,5.84392,0.085,NULL,59334930539,927108289,14486067,16.63),(125387,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125387,36.39,0.27,190,56741,70,NULL,NULL,'CGCG 134-059',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.0001,NULL,'15.6',0.6,NULL,NULL,NULL,NULL,NULL,1,224.3685,21.94431,0.065,NULL,59540997206,930328081,14536376,15.6),(125388,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125388,37.75,0.46,355,56742,70,NULL,NULL,'SDSS J145728.45+390821.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,224.368583333,39.13942,0.005,NULL,60117362965,939333796,14677090,18.3),(125389,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125389,35.89,0.46,151,56743,70,NULL,NULL,'CGCG 248-033',NULL,'2015arXiv151105856S',2015,1,1.04,NULL,'G',0.0002,NULL,'14.5g',0.76,'E0',NULL,NULL,NULL,NULL,1,224.370958333,45.8455,0.017,NULL,59991504662,937367260,14646363,14.5),(125390,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125390,37.74,0.46,353,56744,70,NULL,NULL,'2MASX J14572942+3314301',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000139,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,224.3724583,33.24169,0.02,NULL,60122309237,939411081,14678298,17.9),(125391,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125391,37.49,0.23,315,56745,70,NULL,NULL,'2MASX J14572965+2028241',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.11',0.18,NULL,NULL,NULL,NULL,NULL,1,224.373583,20.47344,0.069,NULL,59541573160,930337080,14536516,18.11),(125392,'IRAS','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125392,33.57,0.8,51.7,56746,75,NULL,'MAT, I','ESO 581- G 004',NULL,'1997ApJS..109..333W',1997,1,2.65,NULL,'G',0.00002,NULL,'15.16',0.36,'SB(s)cd: sp',NULL,NULL,NULL,NULL,1,224.374417,-18.45331,0.397,NULL,46696443257,729631925,11400498,15.16),(125393,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125393,32.9,NULL,37.9,56746,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 581- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125394,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125394,32.9,NULL,38,56746,NULL,NULL,'Dipole','ESO 581- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125395,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125395,32.9,NULL,38.1,56746,NULL,NULL,'Dipole + Quadrupole','ESO 581- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125396,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125396,33.05,NULL,40.7,56746,NULL,NULL,NULL,'ESO 581- G 004',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125397,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125397,33.33,0.32,46.4,56746,85,NULL,'I, raw','ESO 581- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125398,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125398,33.34,0.32,46.5,56746,85,NULL,'I, inv','ESO 581- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125399,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125399,33.37,0.44,47.2,56746,NULL,NULL,'Malmquist cor.','ESO 581- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125400,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125400,33.45,0.43,48.9,56746,75,NULL,'MAT, I, raw','ESO 581- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125401,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125401,33.53,0.43,50.8,56746,75,NULL,'MAT, I, inv','ESO 581- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125402,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125402,33.56,0.2,51.5,56746,74.4,NULL,NULL,'ESO 581- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125403,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125403,33.6,0.43,52.4,56746,75,NULL,'MAT, I, cor','ESO 581- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125404,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125404,33.71,0.37,55.2,56746,NULL,NULL,NULL,'ESO 581- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125405,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125405,33.72,0.49,55.4,56746,75,NULL,'IR','ESO 581- G 004',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125406,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125406,37.78,0.17,360,56747,70,NULL,NULL,'2MASX J14572988+0846538',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.50',0.21,NULL,NULL,NULL,NULL,NULL,1,224.374625,8.78167,0.073,NULL,59389946692,927967917,14499498,18.5),(125407,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125407,37.12,0.46,265,56748,70,NULL,NULL,'2MASX J14572990+0542055',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,224.374667,5.70144,0.085,NULL,59334896286,927107754,14486058,16.9),(125408,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125408,37.97,0.46,393,56749,70,NULL,NULL,'2MASX J14573034+1310087',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,224.3765,13.16914,0.089,NULL,59546930635,930420791,14537824,17.9),(125409,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125409,37.86,0.23,373,56750,70,NULL,NULL,'2MASX J14573037+3225471',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000148,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,224.3767083,32.42961,0.013,NULL,60089957591,938905587,14670399,18.2),(125410,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125410,35.22,0.46,110,56751,70,NULL,NULL,'CGCG 076-111',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000147,NULL,'15.0g',0.45,NULL,NULL,NULL,NULL,NULL,1,224.378875,8.39067,0.065,NULL,59389577383,927962146,14499408,15),(125411,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125411,37.55,0.46,324,56752,70,NULL,NULL,'2MASX J14573100+0459315',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,224.379125,4.99208,0.113,NULL,59337234718,927144292,14486629,16.6),(125412,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125412,38.18,0.46,433,56753,70,NULL,NULL,'SDSS J145731.76+012555.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00007,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,224.382333333,1.43211,0.153,NULL,59324802111,926950032,14483594,18.3),(125413,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125413,37.86,0.23,373,56754,70,NULL,NULL,'2MASX J14573180+3227341',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000181,NULL,'17.6g',0.2,'BrClG',NULL,NULL,NULL,NULL,1,224.382375,32.45953,0.013,NULL,60089943452,938905366,14670396,17.6),(125414,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125414,37.78,0.17,360,56755,70,NULL,NULL,'SDSS J145732.53+084714.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.385583333,8.78747,0.073,NULL,59389946875,927967919,14499498,18.1),(125415,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125415,37.15,0.23,270,56756,70,NULL,NULL,'2MASX J14573310+1251317',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.75',0.13,NULL,NULL,NULL,NULL,NULL,1,224.388041667,12.85903,0.049,NULL,59546662035,930416594,14537759,18.75),(125416,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125416,36.12,NULL,168,56757,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1836',NULL,'2010Ap&SS.325..163P',2010,1,1.25,NULL,'G',0.000029,NULL,'16.7g',0.12,'Sc',NULL,NULL,NULL,NULL,1,224.3885,7.21244,0.065,NULL,59387783189,927934112,14498970,16.7),(125417,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125417,36.15,NULL,169,56757,NULL,NULL,'Dipole + Quadrupole','FGC 1836',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125418,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125418,36.15,NULL,170,56757,NULL,NULL,NULL,'FGC 1836',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125419,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125419,36.17,NULL,171,56757,NULL,NULL,'Dipole','FGC 1836',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125420,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125420,37.15,0.23,270,56758,70,NULL,NULL,'2MASX J14573646+1234258',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,224.402083,12.57392,0.037,NULL,59546789236,930418581,14537790,17.3),(125421,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125421,38.33,0.46,463,56759,70,NULL,NULL,'2MASX J14573643+6125276',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000175,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,224.402125,61.42444,0.025,NULL,57779372518,902802695,14106292,17.2),(125422,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125422,37.15,0.46,269,56760,70,NULL,NULL,'2MASX J14573674+2818205',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.60',0.2,NULL,NULL,NULL,NULL,NULL,1,224.403167,28.30578,0.053,NULL,60082023241,938781613,14668462,17.6),(125423,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125423,38.32,0.46,462,56761,70,NULL,NULL,'2MASX J14573715+5215535',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,224.404625,52.26494,0.033,NULL,59932267211,936441675,14631901,17.4),(125424,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125424,35.19,0.2,109,56762,74.4,NULL,NULL,'CGCG 076-112',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000153,NULL,'15.0',0.4,'Sa',NULL,NULL,NULL,NULL,1,224.407625,9.14617,0.065,NULL,59390002279,927968785,14499512,15),(125425,'IRAS','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125425,32.36,0.8,29.7,56763,75,NULL,'A82, H','NGC 5798',NULL,'1997ApJS..109..333W',1997,1,1.4,'Multiple SDSS entries describe this object.','G',0.000017,NULL,'13.64',1,'Im:','Pair member, wide',NULL,NULL,'Emission-Line Galaxy',1,224.4082083,29.9685,0.05,NULL,60095791669,938996744,14671824,13.64),(125426,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125426,33.4,0.47,47.8,56763,75,NULL,'A82, H, inv','NGC 5798',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125427,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125427,33.42,0.47,48.3,56763,75,NULL,'A82, H, raw','NGC 5798',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125428,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125428,33.74,0.47,56,56763,75,NULL,'A82, H, cor','NGC 5798',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125429,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125429,37.54,0.33,323,56764,70,NULL,NULL,'2MASX J14573867+2541275',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.30',0.16,NULL,NULL,NULL,NULL,NULL,1,224.411083,25.691,0.117,NULL,60012351697,937692995,14651453,18.3),(125430,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125430,36.66,0.46,215,56765,70,NULL,NULL,'2MASX J14573869+5511102',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00018,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,224.411167,55.18628,0,NULL,57713812151,901778314,14090286,16.7),(125431,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125431,37.49,0.23,315,56766,70,NULL,NULL,'2MASX J14573877+2029532',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.93',0.19,NULL,NULL,NULL,NULL,NULL,1,224.4114583,20.49817,0.069,NULL,59541786523,930340414,14536568,17.93),(125432,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125432,38.3,0.27,456,56767,70,NULL,NULL,'2MASX J14573943+5426002',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000155,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,224.414417,54.43344,0.009,NULL,59190237625,924847462,14450741,17.2),(125433,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125433,36.63,0.46,212,56768,70,NULL,NULL,'2MASX J14574054+0959458',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.66',0.25,NULL,NULL,NULL,NULL,NULL,1,224.418833333,9.99617,0.053,NULL,59376403305,927756301,14496192,16.66),(125434,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125434,37.95,0.17,389,56769,70,NULL,NULL,'2MASX J14574126+4713007',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000178,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,224.42175,47.217,0.057,NULL,59989260797,937332199,14645815,16.6),(125435,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125435,37.35,0.46,295,56770,70,NULL,NULL,'2MASX J14574369+1231518',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000176,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,224.432041667,12.53108,0.053,NULL,59546757368,930418083,14537782,16.7),(125436,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125436,37.49,0.23,315,56771,70,NULL,NULL,'SDSS J145743.78+203010.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.4324583,20.50303,0.069,NULL,59541786490,930340413,14536568,18.4),(125437,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125437,37.54,0.33,323,56772,70,NULL,NULL,'2MASX J14574450+2542037',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.34',0.16,NULL,NULL,NULL,NULL,NULL,1,224.4355,25.70114,0.117,NULL,60012335242,937692738,14651449,18.34),(125438,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125438,38.2,0.46,437,56773,70,NULL,NULL,'SDSS J145744.64+231203.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.4360417,23.20092,0.097,NULL,59529347683,930146057,14533532,18.3),(125439,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125439,34.58,0.49,82.4,56774,75,NULL,'IR','UGC 09625',NULL,'2011yCatp016004901K',2011,1,1.5,'UZC has V = 6459 km/sec.','G',0.000334,NULL,'14.44',0.5,'SBab:',NULL,NULL,NULL,NULL,1,224.4370417,6.62692,0.077,NULL,59379938809,927811543,14497055,14.44),(125440,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125440,34.59,0.47,83,56774,NULL,NULL,'H','UGC 09625',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125441,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125441,34.68,0.46,86.2,56774,NULL,NULL,'J','UGC 09625',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125442,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125442,34.69,0.45,86.7,56774,NULL,NULL,'K','UGC 09625',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125443,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125443,34.78,0.4,90.4,56774,NULL,NULL,'mean','UGC 09625',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125444,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125444,37.13,0.46,266,56775,70,NULL,NULL,'2MASX J14574501+2500437',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.63',0.22,NULL,NULL,NULL,NULL,NULL,1,224.437667,25.01225,0.113,NULL,59492255106,929566486,14524476,17.63),(125445,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125445,36.39,0.27,190,56776,70,NULL,NULL,'2MASX J14574559+2202312',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.49',0.21,NULL,NULL,NULL,NULL,NULL,1,224.4399583,22.04217,0.065,NULL,59526905968,930107905,14532936,17.49),(125446,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125446,29.9,0.43,9.5,56777,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5832',NULL,'2014MNRAS.444..527S',2014,1,3.7,NULL,'G',0.000004,NULL,'12.9',2.2,'SB(rs)b?','Isolated galaxy',NULL,NULL,NULL,1,224.4404583,71.68233,0.057,NULL,57918249419,904972647,14140197,12.9),(125447,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125447,30.3,0.4,11.5,56777,75,NULL,'B','NGC 5832',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125448,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125448,38.1,0.27,416,56778,70,NULL,NULL,'2MASX J14574649+2248022',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,224.443625,22.80081,0.089,NULL,59528839633,930138119,14533408,18.1),(125449,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125449,36.03,0.46,161,56779,70,NULL,NULL,'2MASX J14574654+4004067',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000178,NULL,'15.5g',0.43,'E0',NULL,NULL,NULL,NULL,1,224.443917,40.06853,0.009,NULL,60071067902,938610435,14665788,15.5),(125450,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125450,35.44,0.45,122,56780,NULL,NULL,NULL,'ESO 273- G 013',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.29',0.7,'S...',NULL,NULL,NULL,NULL,1,224.445083,-44.14653,0.601,NULL,47108898974,736076546,11501196,14.29),(125451,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125451,35.48,0.2,125,56780,74.4,NULL,NULL,'ESO 273- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125452,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125452,35.59,0.42,131,56780,NULL,NULL,'Malmquist cor.','ESO 273- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125453,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125453,37.71,0.46,348,56781,70,NULL,NULL,'2MASX J14574754+5658302',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000172,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,224.4480417,56.97508,0.009,NULL,57716302888,901817232,14090894,17.5),(125454,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125454,37.29,0.46,287,56782,70,NULL,NULL,'2MASX J14574780+2755218',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.70',0.2,NULL,NULL,NULL,NULL,NULL,1,224.449083,27.92264,0.073,NULL,60082762812,938793168,14668643,17.7),(125455,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125455,37.04,0.46,256,56783,70,NULL,NULL,'2MASX J14575082+2531098',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000127,NULL,'16.04',0.31,NULL,NULL,NULL,NULL,NULL,1,224.461667,25.5195,0.117,NULL,60012350700,937692979,14651452,16.04),(125456,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125456,38.3,0.46,457,56784,70,NULL,NULL,'2MASX J14575271+4846066',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,224.46975,48.76861,0.021,NULL,59941690294,936588910,14634201,18.3),(125457,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125457,36.39,0.27,190,56785,70,NULL,NULL,'2MASX J14575472+2141532',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.89',0.16,NULL,NULL,NULL,NULL,NULL,1,224.4779583,21.69822,0.069,NULL,59540990370,930327974,14536374,17.89),(125458,'GRB','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125458,46.82,1.48,6440,56786,NULL,NULL,NULL,'GRB 080721',2.591,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,224.4827083,-11.72358,0.349,NULL,46460381908,725943467,11342866,NULL),(125459,'GRB','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125459,46.6,0.28,20900,56786,NULL,NULL,NULL,'GRB 080721',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125460,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125460,37.78,0.17,360,56787,70,NULL,NULL,'2MASX J14575622+0853341',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,224.48425,8.89281,0.073,NULL,59389993493,927968648,14499510,17.8),(125461,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125461,36.95,0.46,245,56788,70,NULL,NULL,'2MASX J14575645+4920396',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000185,NULL,'15.8g',0.47,'E0',NULL,NULL,NULL,NULL,1,224.485125,49.34439,0.017,NULL,59941482195,936585659,14634150,15.8),(125462,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125462,38.39,0.46,476,56789,70,NULL,NULL,'2MASX J14575671+2349272',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.51',0.14,NULL,NULL,NULL,NULL,NULL,1,224.486375,23.82422,0.105,NULL,59526061790,930094715,14532729,18.51),(125463,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125463,37.78,0.17,360,56790,70,NULL,NULL,'SDSS J145757.60+085320.9',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.49,8.88914,0.073,NULL,59389993686,927968651,14499510,17.4),(125464,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125464,37.6,0.46,331,56791,70,NULL,NULL,'2MASX J14575772+2108332',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.08',0.17,NULL,NULL,NULL,NULL,NULL,1,224.490625,21.14253,0.061,NULL,59542209598,930347024,14536672,18.08),(125465,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125465,37.67,0.23,342,56792,70,NULL,NULL,'MCG +06-33-013',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.00011,NULL,'15.6g',0.54,'BrClG',NULL,NULL,NULL,NULL,1,224.4915,34.16308,0,NULL,60127126578,939486352,14679474,15.6),(125466,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125466,37.67,0.23,342,56793,70,NULL,NULL,'2MASX J14580098+3410116',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,224.504167,34.16994,0,NULL,60127130644,939486416,14679475,18.1),(125467,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125467,38.1,0.27,416,56794,70,NULL,NULL,'2MASX J14580139+2252102',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.97',0.16,NULL,NULL,NULL,NULL,NULL,1,224.505666667,22.86947,0.093,NULL,59529563322,930149426,14533584,17.97),(125468,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125468,38.89,0.46,601,56795,70,NULL,NULL,'LCRS B145526.4-024041',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000169,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,224.509833,-2.87767,0.237,NULL,46440863466,725638491,11338101,18.4),(125469,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125469,37.47,0.46,312,56796,70,NULL,NULL,'2MASX J14580237+0832532',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000161,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,224.509833,8.54811,0.073,NULL,59389904018,927967250,14499488,16.2),(125470,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125470,38.25,0.46,447,56797,70,NULL,NULL,'SDSS J145802.86+005637.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000084,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,224.511958333,0.94367,0.137,NULL,59324831383,926950490,14483601,18.4),(125471,'IRAS','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125471,33.16,0.8,42.9,56798,75,NULL,'MAT, I','ESO 581- G 006',NULL,'1997ApJS..109..333W',1997,1,1.74,NULL,'G',0.000033,NULL,'15.56',0.17,'SB(s)d pec sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,224.512875,-19.38975,0.341,NULL,46651338438,728927163,11389486,15.56),(125472,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125472,32.59,NULL,33,56798,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 581- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125473,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125473,32.6,NULL,33.2,56798,NULL,NULL,'Dipole + Quadrupole','ESO 581- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125474,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125474,32.62,NULL,33.4,56798,NULL,NULL,'Dipole','ESO 581- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125475,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125475,32.68,NULL,34.3,56798,NULL,NULL,NULL,'ESO 581- G 006',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125476,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125476,33.13,0.49,42.3,56798,NULL,NULL,'Malmquist cor.','ESO 581- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125477,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125477,33.35,0.44,46.7,56798,NULL,NULL,NULL,'ESO 581- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125478,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125478,33.38,0.32,47.4,56798,85,NULL,'I, inv','ESO 581- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125479,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125479,33.38,0.32,47.5,56798,85,NULL,'I, raw','ESO 581- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125480,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125480,33.39,0.2,47.6,56798,74.4,NULL,NULL,'ESO 581- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125481,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125481,33.56,0.43,51.5,56798,75,NULL,'MAT, I, raw','ESO 581- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125482,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125482,33.59,0.43,52.3,56798,75,NULL,'MAT, I, inv','ESO 581- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125483,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125483,33.72,0.43,55.4,56798,75,NULL,'MAT, I, cor','ESO 581- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125484,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125484,37.67,0.23,342,56799,70,NULL,NULL,'2MASX J14580364+3411306',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,224.515083333,34.19172,0.009,NULL,60127131579,939486430,14679475,17.4),(125485,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125485,38.1,0.46,417,56800,70,NULL,NULL,'SDSS J145803.78+120937.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000127,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.5157917,12.16044,0.045,NULL,59366419925,927600311,14493754,18.4),(125486,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125486,37.67,0.23,342,56801,70,NULL,NULL,'2MASX J14580460+3407206',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000187,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,224.519167,34.12233,0.009,NULL,60127017801,939484653,14679447,16.5),(125487,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125487,37.69,0.27,345,56802,70,NULL,NULL,'2MASX J14580469+0545527',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,224.519583,5.76453,0.081,NULL,59334946526,927108539,14486070,17.2),(125488,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125488,37.95,0.17,389,56803,70,NULL,NULL,'2MASX J14580475+4724238',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000246,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,224.519667,47.40664,0.057,NULL,59989084924,937329451,14645772,16.5),(125489,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125489,37.95,0.17,389,56804,70,NULL,NULL,'SDSS J145805.12+472517.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00014,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,224.521333,47.42153,0.057,NULL,59989084738,937329449,14645772,18.6),(125490,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125490,38.3,0.27,456,56805,70,NULL,NULL,'2MASX J14580624+5423321',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,224.5257083,54.39222,0.009,NULL,59190053616,924844587,14450696,17.7),(125491,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125491,36.19,0.46,173,56806,70,NULL,NULL,'2MASX J14580620+0130207',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000113,NULL,'15.6g',0.41,'E0',NULL,NULL,NULL,NULL,1,224.526,1.50572,0.153,NULL,59324911568,926951743,14483620,15.6),(125492,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125492,36.85,0.27,234,56807,70,NULL,NULL,'2MASX J14580675+0841192',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000126,NULL,'16.99',0.19,NULL,NULL,NULL,NULL,NULL,1,224.5282083,8.68856,0.073,NULL,59389964082,927968188,14499502,16.99),(125493,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125493,38.43,0.46,485,56808,70,NULL,NULL,'2MASX J14580762+1556379',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,224.531875,15.94375,0.037,NULL,59590024209,931094128,14548345,17.8),(125494,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125494,31.58,NULL,20.7,56809,72,NULL,NULL,'SDSS J145808.78+064447.4',NULL,'2014Ap.....57..457K',2014,1,0.3,NULL,'G',0.00005,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,224.536583,6.74653,0.081,NULL,59379887876,927810748,14497042,18.1),(125495,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125495,37.87,0.46,375,56810,70,NULL,NULL,'SDSS J145809.08+215755.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.537875,21.96536,0.065,NULL,59540798085,930324970,14536327,18.4),(125496,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125496,32.63,0.4,33.6,56811,NULL,NULL,NULL,'UGC 09638',NULL,'2009AJ....138..323T',2009,1,0.84,NULL,'G',0.000023,NULL,'15.5g',0.63,'Im',NULL,NULL,NULL,NULL,1,224.5405,58.87181,0,NULL,57726336839,901974013,14093343,15.5),(125497,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125497,32.8,0.4,36.3,56811,75,NULL,'B','UGC 09638',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125498,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125498,38.12,0.46,421,56812,70,NULL,NULL,'SDSS J145809.80+201345.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.540875,20.22928,0.061,NULL,59538923620,930295681,14535870,18.4),(125499,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125499,37.9,0.46,380,56813,70,NULL,NULL,'2MASX J14581025+0247057',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000101,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,224.5427083,2.78481,0.173,NULL,59327075581,926985555,14484149,16.6),(125500,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125500,37.57,0.46,326,56814,70,NULL,NULL,'2MASX J14581067+0512157',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,224.544417,5.20422,0.109,NULL,59337223815,927144122,14486626,17.3),(125501,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125501,37.88,0.27,376,56815,70,NULL,NULL,'2MASXi J1458111+221955',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.6g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.546583,22.33211,0.077,NULL,59527113236,930111144,14532986,17.6),(125502,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125502,38.93,0.46,611,56816,70,NULL,NULL,'2MASX J14581191+1629569',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,224.5497917,16.49922,0.049,NULL,59592484268,931132566,14548946,17.8),(125503,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125503,37.17,0.46,272,56817,70,NULL,NULL,'2MASX J14581364+3242384',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000161,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,224.557,32.71064,0.017,NULL,60089722836,938901919,14670342,16.7),(125504,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125504,38.2,0.46,436,56818,70,NULL,NULL,'2MASX J14581558+2937409',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00027,NULL,'18.51',0.14,'E',NULL,NULL,NULL,NULL,1,224.564875,29.62806,0.039,NULL,60095095042,938985860,14671654,18.51),(125505,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125505,37.88,0.27,376,56819,70,NULL,NULL,'2MASX J14581606+2222160',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.20',0.17,'BrClG',NULL,NULL,NULL,NULL,1,224.567,22.37117,0.077,NULL,59527118793,930111231,14532987,18.2),(125506,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125506,37.14,0.46,267,56820,70,NULL,NULL,'2MASX J14581646+3149314',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000174,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,224.56875,31.82533,0.008,NULL,60091865739,938935402,14670865,17),(125507,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125507,37.88,0.27,376,56821,70,NULL,NULL,'2MASX J14581743+2223250',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,224.572833,22.39025,0.081,NULL,59527117468,930111210,14532987,18.3),(125508,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125508,36.99,0.46,250,56822,70,NULL,NULL,'2MASX J14581754+3310054',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000159,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,224.572958333,33.16814,0.014,NULL,60122434742,939413042,14678328,16.7),(125509,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125509,37.75,0.46,354,56823,70,NULL,NULL,'SDSS J145818.86+091159.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.578625,9.19978,0.065,NULL,59389801813,927965653,14499463,18.5),(125510,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125510,36.71,0.46,220,56824,70,NULL,NULL,'2MASX J14581906+0228397',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000093,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,224.579417,2.47772,0.149,NULL,59326992603,926984259,14484129,16.8),(125511,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125511,35.28,0.46,114,56825,70,NULL,NULL,'I Zw 099',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000182,NULL,'14.8g',0.69,'S0?',NULL,NULL,NULL,NULL,1,224.579833,53.2375,0.005,NULL,59928575725,936383995,14630999,14.8),(125512,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125512,38.43,0.46,485,56826,70,NULL,NULL,'2MASX J14581941+2315120',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'18.04',0.14,NULL,NULL,NULL,NULL,NULL,1,224.5809583,23.25342,0.097,NULL,59529431215,930147362,14533552,18.04),(125513,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125513,34.54,0.47,81.1,56827,70,NULL,NULL,'ESO 386- G 043',NULL,'2014MNRAS.445.2677S',2014,1,2.5,NULL,'G',0.000017,NULL,'14.14',0.9,'SA(rs)bc:      HII',NULL,NULL,NULL,NULL,1,224.582416667,-37.55617,0.261,NULL,47236131736,738064558,11532258,14.14),(125514,'IRAS','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125514,35.08,0.8,104,56827,75,NULL,'MAT, I','ESO 386- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125515,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125515,34.93,0.43,96.9,56827,75,NULL,'MAT, I, raw','ESO 386- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125516,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125516,35.07,0.38,103,56827,NULL,NULL,'Malmquist cor.','ESO 386- G 043',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125517,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125517,35.12,0.32,106,56827,85,NULL,'I, raw','ESO 386- G 043',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125518,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125518,35.21,0.32,110,56827,85,NULL,'I, inv','ESO 386- G 043',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125519,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125519,35.25,0.43,112,56827,75,NULL,'MAT, I, cor','ESO 386- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125520,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125520,35.3,0.43,115,56827,75,NULL,'MAT, I, inv','ESO 386- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125521,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125521,35.32,0.34,116,56827,NULL,NULL,NULL,'ESO 386- G 043',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125522,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125522,35.36,0.2,118,56827,74.4,NULL,NULL,'ESO 386- G 043',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125523,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125523,37.95,0.17,389,56828,70,NULL,NULL,'2MASX J14582092+4733449',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,224.587,47.56242,0.057,NULL,59989057546,937329024,14645766,17.5),(125524,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125524,37.44,0.46,308,56829,70,NULL,NULL,'SDSS J145821.05+241213.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.3g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.58775,24.20386,0.121,NULL,59526504924,930101639,14532838,18.3),(125525,'IRAS','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125525,32.35,0.8,29.6,56830,75,NULL,'A82, H','NGC 5792',NULL,'1997ApJS..109..333W',1997,1,6.9,'Extended HIPASS source','G',0.000013,NULL,'12.08',1.7,'SB(rs)b        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,224.594625,-1.09108,0.157,NULL,46439776114,725621501,11337835,12.08),(125526,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125526,31.58,0.47,20.7,56830,75,NULL,'A82, H, raw','NGC 5792',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125527,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125527,31.61,0.46,20.9,56830,NULL,NULL,'J','NGC 5792',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125528,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125528,31.63,0.47,21.1,56830,NULL,NULL,'H','NGC 5792',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125529,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125529,31.72,0.45,22.1,56830,NULL,NULL,'K','NGC 5792',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125530,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125530,31.77,0.47,22.5,56830,75,NULL,'A82, H, inv','NGC 5792',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125531,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125531,31.76,NULL,22.5,56830,72,NULL,NULL,'NGC 5792',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125532,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125532,31.93,0.47,24.4,56830,75,NULL,'A82, H, cor','NGC 5792',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125533,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125533,32.05,0.43,25.8,56830,75,NULL,'3.6 micron, color corrected','NGC 5792',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125534,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125534,32.09,0.43,26.2,56830,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5792',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125535,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125535,32.11,0.2,26.4,56830,74.4,NULL,NULL,'NGC 5792',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125536,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125536,32.24,0.4,28.1,56830,NULL,NULL,'mean','NGC 5792',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125537,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125537,32.43,0.4,30.6,56830,75,NULL,'B','NGC 5792',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125538,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125538,37.3,0.46,289,56831,70,NULL,NULL,'SDSS J145823.22+183344.7',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.8g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,224.5967917,18.56244,0.049,NULL,59586600401,931040631,14547509,16.8),(125539,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125539,38.06,0.46,409,56832,70,NULL,NULL,'2MASX J14582331+2727050',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.47',0.15,NULL,NULL,NULL,NULL,NULL,1,224.597041667,27.45144,0.081,NULL,60082824435,938794131,14668658,18.47),(125540,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125540,38.47,0.46,494,56833,70,NULL,NULL,'2MASXi J1458242+331203',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00017,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,224.601,33.20108,0.014,NULL,60122431805,939412996,14678328,17.7),(125541,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125541,37.95,0.17,389,56834,70,NULL,NULL,'SDSS J145825.42+471548.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000139,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,224.6059583,47.26356,0.057,NULL,59989082006,937329406,14645771,18.6),(125542,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125542,38.31,0.46,460,56835,70,NULL,NULL,'SDSS J145825.88+031509.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000118,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,224.607833,3.25253,0.149,NULL,59338178605,927159040,14486860,18.5),(125543,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125543,36.46,0.46,196,56836,70,NULL,NULL,'2MASX J14582603+0858290',NULL,'2015arXiv151105856S',2015,1,0.33,'Two MAPS entries for the same object.','G',NULL,NULL,'16.71',0.18,NULL,NULL,NULL,NULL,NULL,1,224.608625,8.97478,0.073,NULL,59389991683,927968620,14499509,16.71),(125544,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125544,36.74,0.46,222,56837,70,NULL,NULL,'2MASX J14582713+2515200',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.62',0.21,NULL,NULL,NULL,NULL,NULL,1,224.613083,25.25553,0.109,NULL,60012140882,937689701,14651401,17.62),(125545,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125545,35.51,0.33,126,56838,70,NULL,NULL,'CGCG 248-034',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000173,NULL,'14.9g',0.4,'E','Group member',NULL,NULL,NULL,1,224.615791667,48.49239,0.009,NULL,59941675587,936588681,14634198,14.9),(125546,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125546,37.95,0.17,389,56839,70,NULL,NULL,'2MASX J14582789+4721488',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000174,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,224.616083,47.36358,0.057,NULL,59989096521,937329633,14645775,17.1),(125547,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125547,38.1,0.27,416,56840,70,NULL,NULL,'2MASX J14582873+2252269',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.64',0.15,NULL,NULL,NULL,NULL,NULL,1,224.619875,22.87425,0.093,NULL,59529567313,930149489,14533585,18.64),(125548,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125548,36.34,0.46,185,56841,70,NULL,NULL,'2MASX J14582897+0324249',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000075,NULL,'16.4g',0.29,'S0^-',NULL,NULL,NULL,NULL,1,224.620708333,3.40697,0.181,NULL,59338373657,927162088,14486907,16.4),(125549,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125549,36.88,0.55,237,56842,70,NULL,NULL,'2MASX J14582982-2320281',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,224.624333,-23.34119,0.417,NULL,46644274181,728816784,11387762,15),(125550,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125550,35.3,0.4,115,56843,NULL,NULL,'mean','MCG -01-38-012',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000033,NULL,'14.62',1.1,'SAB(s)c',NULL,NULL,NULL,NULL,1,224.625,-6.82064,0.261,NULL,46502327173,726598862,11353107,14.62),(125551,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125551,35.61,0.47,133,56843,NULL,NULL,'H','MCG -01-38-012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125552,'Tully est','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125552,30.83,0.8,14.7,56844,75,NULL,NULL,'ESO 223- ?006',NULL,'1988NBGC.C....0000T',1988,1,3.8,'Two entries for this object in the ESO/Uppsala Catalogue.','G',0.00001,NULL,'12.9',2.8,'SB(s)m pec',NULL,NULL,NULL,NULL,1,224.6265417,-47.69894,NULL,NULL,47053861668,735216588,11487759,12.9),(125553,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125553,28.21,0.38,4.39,56844,NULL,NULL,NULL,'ESO 223- ?006',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125554,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125554,29.98,0.4,9.9,56844,73,NULL,'opt','ESO 223- ?006',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125555,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125555,29.98,NULL,9.91,56844,NULL,NULL,NULL,'ESO 223- ?006',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125556,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125556,38.19,0.33,434,56845,70,NULL,NULL,'SDSS J145831.42+030136.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000079,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,224.6309583,3.02692,0.149,NULL,59326883094,926982548,14484102,18.1),(125557,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125557,37.35,0.46,296,56846,70,NULL,NULL,'2MASX J14583166+2200529',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.68',0.13,NULL,NULL,NULL,NULL,NULL,1,224.6319583,22.01464,0.065,NULL,59540794974,930324921,14536326,18.68),(125558,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125558,37.95,0.17,389,56847,70,NULL,NULL,'2MASX J14583359+4729510',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00021,NULL,'15.6g',0.51,'BrClG',NULL,NULL,NULL,NULL,1,224.64,47.49761,0.057,NULL,59989092639,937329572,14645774,15.6),(125559,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125559,38.27,0.46,450,56848,70,NULL,NULL,'2MASX J14583366+2740381',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,224.640125,27.67739,0.053,NULL,60083292242,938801441,14668772,18.2),(125560,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125560,37.08,0.46,261,56849,70,NULL,NULL,'2MASX J14583404+0530349',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,224.641875,5.50958,0.121,NULL,59336939217,927139675,14486557,17.1),(125561,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125561,37.13,0.46,267,56850,70,NULL,NULL,'2MASX J14583419+1852349',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.70',0.23,NULL,NULL,NULL,NULL,NULL,1,224.642375,18.87639,0.061,NULL,59530845312,930169458,14533897,16.7),(125562,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125562,36.34,0.46,185,56851,70,NULL,NULL,'2MASX J14583419+4426370',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,224.6425417,44.4435,0.041,NULL,59994423778,937412871,14647076,16.9),(125563,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125563,38.19,0.33,434,56852,70,NULL,NULL,'2MASX J14583451+0258559',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000093,NULL,'17.5g',0.24,'NLAGN',NULL,NULL,NULL,NULL,1,224.6437083,2.98222,0.173,NULL,59326886002,926982593,14484103,17.5),(125564,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125564,37.69,0.27,345,56853,70,NULL,NULL,'2MASX J14583451+0547269',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'15.9g',0.42,NULL,NULL,NULL,NULL,NULL,1,224.64375,5.79078,0.081,NULL,59334937852,927108403,14486068,15.9),(125565,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125565,36.49,0.46,199,56854,70,NULL,NULL,'2MASX J14583482+2807031',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000334,NULL,'16.5',0.59,NULL,NULL,NULL,NULL,NULL,1,224.645167,28.11769,0.037,NULL,60082481442,938788772,14668574,16.5),(125566,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125566,36.25,0.46,177,56855,70,NULL,NULL,'2MASX J14583658+1245583',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.59',0.14,NULL,NULL,NULL,NULL,NULL,1,224.652583,12.76625,0.057,NULL,59546635726,930416183,14537752,18.59),(125567,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125567,37.23,0.46,279,56856,70,NULL,NULL,'2MASX J14583677+2035519',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,224.653083,20.59769,0.077,NULL,59541671002,930338609,14536540,16.8),(125568,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125568,38.12,0.46,420,56857,70,NULL,NULL,'LCRS B145601.1-022000',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000182,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,224.65325,-2.5325,0.217,NULL,46442638975,725666233,11338534,17.5),(125569,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125569,37.75,0.46,354,56858,70,NULL,NULL,'SDSS J145837.12+463840.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,224.654667,46.64461,0.021,NULL,59992085478,937376335,14646505,18.5),(125570,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125570,36.23,0.46,176,56859,70,NULL,NULL,'2MASX J14583727+3255384',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000168,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,224.655291667,32.92736,0.017,NULL,60122265000,939410390,14678287,16.5),(125571,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125571,32.19,NULL,27.4,56860,72,NULL,NULL,'KUG 1456+069',NULL,'2014Ap.....57..457K',2014,1,0.4,NULL,'G',0.000041,NULL,'15.4',0.3,'Spiral',NULL,NULL,NULL,NULL,1,224.6577083,6.77517,0.081,NULL,59387341630,927927212,14498862,15.4),(125572,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125572,37.07,0.46,259,56861,70,NULL,NULL,'2MASX J14583791+4736300',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000153,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,224.658167,47.60853,0.057,NULL,59933467280,936460426,14632194,17.2),(125573,'BCG','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125573,38.82,0.35,516,56862,60,NULL,'ABELL 2005, BCG','2MASX J14583892+2751041',0.1251,'1980ApJ...241..486H',1980,1,0.32,NULL,'G',NULL,NULL,'17.74',0.18,'BrClG','Brightest group member',NULL,NULL,NULL,1,224.6622083,27.85119,0.049,NULL,60083332509,938802070,14668782,17.74),(125574,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125574,32.09,0.37,26.2,56863,95,NULL,'Weighted Mean','NGC 5820',NULL,'1984ApJS...56...91D',1984,1,1.7,'Springob et al. (2005ApJS..160..149S) give v= 883 km/sec.','G',0.00003,NULL,'13.42',1.1,'S0','Possible field galaxy',NULL,NULL,NULL,1,224.665917,53.88608,0.025,NULL,59928308818,936379825,14630934,13.42),(125575,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125575,32.26,0.63,28.3,56863,95,NULL,'Michard 1979b, c','NGC 5820',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125576,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125576,32.59,0.46,33,56863,95,NULL,'Michard 1979a','NGC 5820',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125577,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125577,33.5,0.81,50.1,56863,55,NULL,'Visvanathan & Sandage 1979','NGC 5820',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125578,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125578,33.24,0.45,44.6,56863,NULL,NULL,'K','NGC 5820',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125579,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125579,33.62,0.4,53,56863,NULL,NULL,'mean','NGC 5820',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125580,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125580,38.93,0.46,612,56864,70,NULL,NULL,'SDSS J145840.32+461330.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00018,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,224.668041667,46.22514,0.017,NULL,59992130343,937377036,14646516,18.6),(125581,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125581,36.84,0.46,233,56865,70,NULL,NULL,'2MASX J14584182+5324460',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,224.674333,53.41272,0.005,NULL,59929218662,936394041,14631156,17.5),(125582,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125582,36.61,0.46,210,56866,70,NULL,NULL,'2MASX J14584204+2643511',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.11',0.18,NULL,NULL,NULL,NULL,NULL,1,224.6750417,26.73072,0.109,NULL,60079901760,938748465,14667944,18.11),(125583,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125583,38.02,0.46,401,56867,70,NULL,NULL,'2MASX J14584251+3802273',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00016,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,224.6770417,38.04086,0.025,NULL,60120794882,939387420,14677928,17.4),(125584,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125584,37.98,0.27,395,56868,70,NULL,NULL,'2MASX J14584285+5340090',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000154,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,224.67825,53.66919,0.029,NULL,59929186022,936393531,14631148,17.4),(125585,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125585,38.15,0.46,427,56869,70,NULL,NULL,'2MASX J14584285+4038523',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000139,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,224.678667,40.64775,0,NULL,59949217204,936706518,14636039,17.5),(125586,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125586,36.92,0.46,242,56870,70,NULL,NULL,'2MASX J14584341+1340503',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',NULL,NULL,'16.65',0.41,NULL,NULL,NULL,NULL,NULL,1,224.6809583,13.68061,0.029,NULL,59576596326,930884317,14545067,16.65),(125587,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125587,37.38,0.46,299,56871,70,NULL,NULL,'2MASX J14584391-0105486',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000113,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,224.683083333,-1.09675,0.157,NULL,46439761451,725621272,11337832,16.5),(125588,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125588,36.5,0.59,200,56872,70,NULL,NULL,'2MASX J14584396-2843233',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,224.6832083,-28.72319,0.201,NULL,47195648168,737432002,11522375,15.5),(125589,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125589,38.12,0.46,420,56873,70,NULL,NULL,'SDSS J145844.72-021506.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000156,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,224.686375,-2.25181,0.217,NULL,46443339321,725677176,11338705,18.4),(125590,'BCG','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125590,38.82,0.35,516,56874,60,NULL,NULL,'ABELL 2005',0.1251,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,224.6875,27.81786,0.049,NULL,60083336203,938802128,14668783,NULL),(125591,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125591,31.75,NULL,22.4,56875,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09637',NULL,'2010Ap&SS.325..163P',2010,1,1.9,NULL,'G',0.000023,NULL,'16.0',0.27,'Sm',NULL,NULL,NULL,NULL,1,224.689083,41.76603,0,NULL,59979237215,937175581,14643368,16),(125592,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125592,31.76,NULL,22.5,56875,NULL,NULL,'Dipole + Quadrupole','UGC 09637',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125593,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125593,31.77,NULL,22.6,56875,NULL,NULL,'Dipole','UGC 09637',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125594,'D-Sigma','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125594,32.75,0.4,35.5,56876,75,NULL,'Edat, raw','NGC 5791',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.000037,NULL,'12.68',1.3,'E6:','in a pair',NULL,NULL,NULL,1,224.692583,-19.26686,0.341,NULL,46653342170,728958471,11389976,12.68),(125595,'D-Sigma','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125595,32.86,0.4,37.3,56876,75,NULL,'Edat, cor','NGC 5791',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125596,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125596,31.73,0.69,22.2,56876,95,NULL,'de Vaucouleurs','NGC 5791',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125597,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125597,32.34,0.47,29.4,56876,95,NULL,'Weighted Mean','NGC 5791',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125598,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125598,34.54,0.81,80.9,56876,55,NULL,'Visvanathan & Sandage 1979','NGC 5791',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125599,'Tertiary','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125599,32.08,0.35,26.1,56876,95,NULL,NULL,'NGC 5791',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125600,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125600,32.9,0.45,38,56876,NULL,NULL,'K','NGC 5791',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125601,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125601,33.35,0.4,46.7,56876,NULL,NULL,'mean','NGC 5791',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125602,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125602,36.97,0.46,247,56877,70,NULL,NULL,'2MASX J14584646+5344099',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,224.693666667,53.73619,0.025,NULL,59929178197,936393409,14631147,17.2),(125603,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125603,37.69,0.27,345,56878,70,NULL,NULL,'2MASX J14584765+0551469',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,224.698417,5.86297,0.077,NULL,59334768599,927105759,14486027,17.1),(125604,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125604,37.98,0.27,395,56879,70,NULL,NULL,'2MASX J14584953+5349119',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000194,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,224.70625,53.81975,0.025,NULL,59929172968,936393327,14631145,17.1),(125605,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125605,38.3,0.27,456,56880,70,NULL,NULL,'SDSS J145849.63+542807.8',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,224.706833,54.46883,0.009,NULL,59190055472,924844616,14450697,17.8),(125606,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125606,36.93,0.46,243,56881,70,NULL,NULL,'SDSS J145850.32+333756.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,224.709667,33.63236,0,NULL,60126564662,939477572,14679337,17.8),(125607,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125607,36.85,0.27,234,56882,70,NULL,NULL,'SDSS J145851.25+083101.6',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000179,NULL,'17.6g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.713583,8.51714,0.049,NULL,59390422379,927975349,14499614,17.6),(125608,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125608,36.17,0.54,172,56883,70,NULL,NULL,'LCRS B145608.3-112826',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000143,NULL,'16.47',NULL,NULL,NULL,NULL,NULL,NULL,1,224.714833333,-11.67283,0.333,NULL,46489858595,726404040,11350063,16.47),(125609,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125609,38.18,0.46,432,56884,70,NULL,NULL,'2MASX J14585306+1608452',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.75',0.13,NULL,NULL,NULL,NULL,NULL,1,224.7210417,16.146,0.045,NULL,59591783194,931121612,14548775,18.75),(125610,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125610,36.83,0.46,233,56885,70,NULL,NULL,'2MASX J14585351+2053584',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.10',0.17,NULL,NULL,NULL,NULL,NULL,1,224.722917,20.89975,0.041,NULL,59542228569,930347321,14536676,18.1),(125611,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125611,37.01,0.46,253,56886,70,NULL,NULL,'2MASX J14585406+2028054',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.45',0.16,NULL,NULL,NULL,NULL,NULL,1,224.72525,20.46831,0.069,NULL,59541672361,930338630,14536541,17.45),(125612,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125612,36.54,0.46,203,56887,70,NULL,NULL,'SDSS J145854.49+192630.8',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.0g',0.36,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.727083,19.44189,0.061,NULL,59538327710,930286370,14535724,16),(125613,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125613,39.47,0.46,782,56888,70,NULL,NULL,'SDSS J145854.54+004243.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000085,NULL,'18.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,224.7272917,0.71219,0.145,NULL,59324423943,926944124,14483501,18.6),(125614,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125614,34.23,0.63,70,56889,70,NULL,NULL,'IC 1081',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'14.72',0.5,'SAB(s)0/a:',NULL,NULL,NULL,NULL,1,224.729416667,-19.23908,0.341,NULL,46653472999,728960515,11390008,14.72),(125615,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125615,34.47,0.46,78.2,56890,70,NULL,NULL,'CGCG 076-119',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000147,NULL,'15.5g',0.44,NULL,NULL,NULL,NULL,NULL,1,224.7325,11.65078,0.045,NULL,59374691680,927729557,14495774,15.5),(125616,'Sosies','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125616,32.1,0.63,26.3,56891,NULL,NULL,NULL,'NGC 5786',NULL,'2002A&A...393...57T',2002,1,2.3,NULL,'G',0.000017,NULL,'12',1.1,'(R\'_2)SAB(s)bc',NULL,NULL,NULL,NULL,1,224.734417,-42.01336,0.337,NULL,47093985332,735843520,11497555,12),(125617,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125617,32.35,0.47,29.5,56891,NULL,NULL,'H','NGC 5786',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125618,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125618,32.37,0.45,29.8,56891,NULL,NULL,'K','NGC 5786',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125619,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125619,32.38,0.46,30,56891,NULL,NULL,'J','NGC 5786',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125620,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125620,32.85,0.4,37.2,56891,NULL,NULL,'mean','NGC 5786',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125621,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125621,37.45,0.33,310,56892,70,NULL,NULL,'2MASX J14585691+3508559',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000149,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,224.7370417,35.14878,0.029,NULL,60129513248,939523644,14680056,17.3),(125622,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125622,37.79,0.46,361,56893,70,NULL,NULL,'SDSS J145857.41+041303.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000071,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,224.73925,4.21753,0.117,NULL,59340767258,927199488,14487492,18.4),(125623,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125623,36.15,0.2,170,56894,74.4,NULL,NULL,'UGC 09634',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'15.12',0.5,'SB(s)b',NULL,NULL,NULL,NULL,1,224.741167,20.05275,0.065,NULL,59538948965,930296077,14535876,15.12),(125624,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125624,38.07,0.46,412,56895,70,NULL,NULL,'2MASX J14585816+4548290',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000133,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,224.7425417,45.80819,0.021,NULL,59991469112,937366704,14646354,18.3),(125625,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125625,38.24,0.46,445,56896,70,NULL,NULL,'SDSS J145858.78+321424.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000162,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,224.744917,32.24022,0.009,NULL,60092026229,938937909,14670904,18.7),(125626,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125626,36.85,0.27,234,56897,70,NULL,NULL,'2MASX J14585975+0839424',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000157,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,224.749167,8.66189,0.049,NULL,59390404716,927975073,14499610,16.8),(125627,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125627,35.51,0.33,126,56898,70,NULL,NULL,'CGCG 248-038',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.00022,NULL,'14.9g',0.51,NULL,'Group member',NULL,NULL,NULL,1,224.749666667,48.40983,0.053,NULL,59940976911,936577764,14634027,14.9),(125628,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125628,35.23,0.46,111,56899,70,NULL,NULL,'CGCG 221-019',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.000143,NULL,'14.7g',0.56,'S0^-',NULL,NULL,NULL,NULL,1,224.7525,43.40769,0.033,NULL,59981937263,937217769,14644027,14.7),(125629,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125629,37.34,0.46,294,56900,70,NULL,NULL,'SDSS J145900.76+322616.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,224.7532083,32.43797,0.005,NULL,60089735821,938902122,14670345,18),(125630,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125630,37.27,0.33,284,56901,70,NULL,NULL,'2MASX J14590130+2432595',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.38',0.16,NULL,NULL,NULL,NULL,NULL,1,224.755333,24.54981,0.097,NULL,59525690570,930088915,14532639,18.38),(125631,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125631,31.78,0.49,22.7,56902,75,NULL,'IR','ESO 327- G 039',NULL,'2011yCatp016004901K',2011,1,2.1,NULL,'G',0.000007,NULL,'16.1R',0.5,'Sb: sp',NULL,NULL,NULL,NULL,1,224.755625,-42.58172,0.441,NULL,47097809343,735903270,11498488,16.1),(125632,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125632,31.83,0.4,23.2,56902,75,NULL,NULL,'ESO 327- G 039',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125633,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125633,36.09,0.59,165,56903,70,NULL,NULL,'2MASX J14590220-2215136',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,224.75925,-22.25375,0.417,NULL,46643320485,728801882,11387529,14.1),(125634,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125634,34.27,0.46,71.4,56904,70,NULL,NULL,'UGC 09641',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.000137,NULL,'14.4g',0.78,'S',NULL,NULL,NULL,NULL,1,224.762125,41.44683,0.005,NULL,59979440712,937178761,14643418,14.4),(125635,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125635,38.82,0.46,580,56905,70,NULL,NULL,'SDSS J145903.64+151148.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.09,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.7652083,15.19683,0.017,NULL,59579056901,930922764,14545668,18.5),(125636,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125636,35.91,0.46,152,56906,70,NULL,NULL,'2MASX J14590376+0729584',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,224.7657083,7.49947,0.065,NULL,59387861384,927935334,14498989,16.4),(125637,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125637,37.85,0.46,372,56907,70,NULL,NULL,'SDSS J145904.77+293208.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.769917,29.53558,0.029,NULL,60095155036,938986797,14671668,18.4),(125638,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125638,38.35,0.46,467,56908,70,NULL,NULL,'SDSS J145904.92+280512.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.770541667,28.08681,0.041,NULL,60082450380,938788287,14668566,17.9),(125639,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125639,38.43,0.46,485,56909,70,NULL,NULL,'2MASX J14590551+1555333',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,224.772833,15.92597,0.037,NULL,59591657210,931119643,14548744,18.2),(125640,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125640,37.58,0.46,328,56910,70,NULL,NULL,'2MASX J14590604+2651135',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.01',0.18,NULL,NULL,NULL,NULL,NULL,1,224.775083,26.85369,0.109,NULL,60079906480,938748538,14667945,18.01),(125641,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125641,37.56,0.46,325,56911,70,NULL,NULL,'SDSS J145907.37-022355.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000135,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,224.7807083,-2.39867,0.229,NULL,46442674410,725666787,11338543,18.3),(125642,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125642,37.17,0.46,272,56912,70,NULL,NULL,'2MASX J14590766+4841595',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,224.781875,48.69981,0.009,NULL,59941818401,936590912,14634233,17.3),(125643,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125643,37.45,0.33,310,56913,70,NULL,NULL,'2MASX J14590785+3518529',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000177,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,224.782875,35.31472,0.025,NULL,60129301275,939520332,14680005,16.9),(125644,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125644,38.51,0.46,503,56914,70,NULL,NULL,'SDSS J145908.14+623802.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000156,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,224.783916667,62.63392,0.021,NULL,57767915942,902623686,14103495,18.7),(125645,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125645,37.92,0.46,384,56915,70,NULL,NULL,'2MASX J14590820+0408518',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000073,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,224.784125,4.14758,0.117,NULL,59340982091,927202845,14487544,17.9),(125646,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125646,35.99,0.46,158,56916,70,NULL,NULL,'2MASX J14590984+0045348',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000078,NULL,'16.2g',0.4,'E0',NULL,NULL,NULL,NULL,1,224.791083333,0.75958,0.145,NULL,59324404276,926943816,14483497,16.2),(125647,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125647,38.52,0.46,506,56917,70,NULL,NULL,'SDSS J145910.18+122804.0',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.8g',0.2,'AGN',NULL,NULL,NULL,NULL,1,224.7924583,12.46781,0.053,NULL,59546594128,930415533,14537742,17.8),(125648,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125648,37.64,0.46,337,56918,70,NULL,NULL,'2MASX J14591139+2026068',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,224.797333333,20.43533,0.069,NULL,59541628439,930337944,14536530,17.1),(125649,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125649,36.52,0.27,201,56919,70,NULL,NULL,'2MASX J14591200+2342268',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.82',0.18,NULL,NULL,NULL,NULL,NULL,1,224.800083333,23.70742,0.093,NULL,59525900916,930092201,14532690,17.82),(125650,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125650,37.27,0.33,284,56920,70,NULL,NULL,'2MASX J14591223+2445515',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.93',0.18,NULL,NULL,NULL,NULL,NULL,1,224.800958333,24.76439,0.097,NULL,59525806662,930090729,14532667,17.93),(125651,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125651,37.63,0.46,336,56921,70,NULL,NULL,'2MASX J14591249+1726103',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,224.802083,17.43614,0.045,NULL,59588832905,931075514,14548054,NULL),(125652,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125652,37.6,0.46,331,56922,70,NULL,NULL,'SDSS J145913.86+090809.9',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.80775,9.13611,0.049,NULL,59389782252,927965347,14499458,18.4),(125653,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125653,37.29,0.46,287,56923,70,NULL,NULL,'2MASX J14591446+3830589',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,224.810125,38.51647,0.021,NULL,60117302602,939332853,14677075,17.2),(125654,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125654,37.34,0.46,294,56924,70,NULL,NULL,'2MASX J14591468+3128569',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,224.8112083,31.4825,0.025,NULL,60092802715,938950042,14671094,17.4),(125655,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125655,37.14,0.46,268,56925,70,NULL,NULL,'2MASX J14591474-0007450',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000073,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,224.811333,-0.12925,0.185,NULL,43486606047,679478219,10616847,17.4),(125656,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125656,37.6,0.2,331,56926,74.4,NULL,NULL,'2MASX J14591474+1717063',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000046,NULL,'17.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,224.811541667,17.28508,0.041,NULL,59588817847,931075278,14548051,17),(125657,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125657,37.31,0.46,290,56927,70,NULL,NULL,'2MASX J14591520+3736459',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000193,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,224.8135417,37.61294,0.021,NULL,60120978785,939390293,14677973,16.2),(125658,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125658,36.79,0.46,228,56928,70,NULL,NULL,'2MASX J14591558+1713403',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,224.815041667,17.22772,0.041,NULL,59588814628,931075228,14548050,16.9),(125659,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125659,36.52,0.27,201,56929,70,NULL,NULL,'CGCG 134-061 NED02',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00013,NULL,'15.96',0.32,NULL,NULL,NULL,NULL,NULL,1,224.82675,24.00028,0.097,NULL,59526395347,930099927,14532811,15.96),(125660,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125660,37.91,0.13,382,56930,70,NULL,NULL,'2MASX J14592170+4717562',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000139,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,224.8402917,47.29897,0.057,NULL,59991187921,937362311,14646286,17.8),(125661,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125661,36.24,0.46,177,56931,70,NULL,NULL,'2MASXi J1459222+174352',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.87',0.19,NULL,NULL,NULL,NULL,NULL,1,224.842666667,17.73133,0.065,NULL,59589485897,931085717,14548214,16.87),(125662,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125662,38.44,0.46,488,56932,70,NULL,NULL,'2MASX J14592244+0046448',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000105,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,224.843667,0.77903,0.157,NULL,59325113439,926954897,14483670,17.7),(125663,'IRAS','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125663,33.75,0.8,56.3,56933,75,NULL,'MAT, I','ESO 581- G 010',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000017,NULL,'15.22',0.9,'SAB(rs)d pec:',NULL,NULL,NULL,NULL,1,224.84375,-20.01931,0.389,NULL,46654244066,728972563,11390196,15.22),(125664,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125664,33.86,0.32,59.1,56933,85,NULL,'I, raw','ESO 581- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125665,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125665,33.87,0.32,59.5,56933,85,NULL,'I, inv','ESO 581- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125666,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125666,34.07,0.43,65.2,56933,75,NULL,'MAT, I, raw','ESO 581- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125667,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125667,34.17,0.43,68.2,56933,75,NULL,'MAT, I, inv','ESO 581- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125668,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125668,34.24,0.2,70.5,56933,74.4,NULL,NULL,'ESO 581- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125669,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125669,34.37,0.43,74.8,56933,75,NULL,'MAT, I, cor','ESO 581- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125670,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125670,34.59,0.43,82.8,56933,NULL,NULL,NULL,'ESO 581- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125671,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125671,34.83,0.38,92.4,56933,NULL,NULL,'Malmquist cor.','ESO 581- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125672,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125672,37.98,0.27,395,56934,70,NULL,NULL,'2MASX J14592355+5334105',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,224.848125,53.56958,0.029,NULL,59929259732,936394683,14631166,17.6),(125673,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125673,36.05,0.46,162,56935,70,NULL,NULL,'2MASX J14592382+0654245',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',NULL,NULL,'15.5g',0.47,NULL,NULL,NULL,NULL,NULL,1,224.8492083,6.90681,0.065,NULL,59387320555,927926883,14498857,15.5),(125674,'D-Sigma','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125674,32.75,0.4,35.5,56936,75,NULL,'Edat, raw','NGC 5796',NULL,'1997ApJS..109..333W',1997,1,2.5,'Confused HIPASS source','G',0.000023,NULL,'12.7',1.8,'E0-1','in a pair',NULL,NULL,NULL,1,224.8504583,-16.62386,0.477,NULL,46707729343,729808270,11403254,12.7),(125675,'D-Sigma','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125675,32.86,0.4,37.3,56936,75,NULL,'Edat, cor','NGC 5796',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125676,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125676,33.5,0.51,50.1,56936,95,NULL,'de Vaucouleurs','NGC 5796',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125677,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125677,33.57,0.4,51.8,56936,95,NULL,'Weighted Mean','NGC 5796',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125678,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125678,35.54,0.81,128,56936,55,NULL,'Visvanathan & Sandage 1979','NGC 5796',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125679,'Tertiary','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125679,32.08,0.35,26.1,56936,95,NULL,NULL,'NGC 5796',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125680,'Tully est','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125680,33.11,0.8,41.9,56936,75,NULL,'B','NGC 5796',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125681,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125681,33.27,0.4,45.1,56936,NULL,NULL,'mean','NGC 5796',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125682,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125682,33.6,0.45,52.4,56936,NULL,NULL,'K','NGC 5796',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125683,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125683,36.22,0.2,175,56937,74.4,NULL,NULL,'IC 4521',NULL,'2013AJ....146...86T',2013,1,0.45,NULL,'G',0.000137,NULL,'15.3',0.3,'HII',NULL,NULL,NULL,NULL,1,224.864375,25.58408,0.117,NULL,60079248855,938738263,14667785,15.3),(125684,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125684,37.64,0.46,338,56938,70,NULL,NULL,'2MASX J14592754+1238200',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.55',0.18,NULL,NULL,NULL,NULL,NULL,1,224.864667,12.63889,0.057,NULL,59575933960,930873968,14544905,18.55),(125685,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2008af',NULL,125685,35.03,0.17,98.1,56939,74.2,NULL,'SALT 2','UGC 09640',0.033507,'2010ApJ...716..712A',2010,1,1.3,NULL,'G',0.000153,NULL,'14.02',1.1,'E',NULL,NULL,NULL,NULL,1,224.865167,16.64511,0.041,NULL,59592646279,931135098,14548985,14.02),(125686,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2008af',NULL,125686,35.6,0.09,132,56939,74.4,NULL,NULL,'UGC 09640',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125687,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2008af',NULL,125687,35.74,0.05,136,56939,72,NULL,'MLCS31','UGC 09640',0.033507,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125688,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2008af',NULL,125688,35.75,0.16,137,56939,70,NULL,'SALT 2','UGC 09640',0.033507,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125689,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2008af',NULL,125689,35.9,0.19,147,56939,65,NULL,'SALT2','UGC 09640',0.033507,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125690,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2008af',NULL,125690,35.99,0.17,152,56939,65,NULL,'MLCS17','UGC 09640',0.033507,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125691,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2008af',NULL,125691,36.1,0.17,160,56939,65,NULL,'MLCS31','UGC 09640',0.033507,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125692,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125692,34.99,0.46,99.6,56939,70,NULL,NULL,'UGC 09640',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125693,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125693,36.14,0.46,169,56940,70,NULL,NULL,'2MASX J14592788+6206353',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000181,NULL,'16.1g',0.4,'S0',NULL,NULL,NULL,NULL,1,224.866125,62.10981,0.013,NULL,57767358417,902614975,14103358,16.1),(125694,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125694,38.72,0.33,555,56941,70,NULL,NULL,'2MASX J14592849+1155135',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,224.868708333,11.92042,0.061,NULL,59374810989,927731421,14495803,17.3),(125695,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125695,37.91,0.13,382,56942,70,NULL,NULL,'2MASX J14592859+4716593',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,224.8692917,47.28322,0.057,NULL,59991189025,937362328,14646286,17.6),(125696,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125696,37.31,0.33,290,56943,70,NULL,NULL,'2MASX J14592887+1209040',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,224.8702917,12.15111,0.073,NULL,59374571583,927727680,14495745,17.8),(125697,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125697,37.89,0.46,378,56944,70,NULL,NULL,'SDSS J145929.97+460026.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,224.874917,46.0075,0.017,NULL,59991970560,937374540,14646477,18.3),(125698,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125698,37.82,0.46,367,56945,70,NULL,NULL,'2MASX J14593040+4637433',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000166,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,224.876583,46.62881,0.045,NULL,59992083586,937376306,14646504,17.2),(125699,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125699,38.42,0.46,483,56946,70,NULL,NULL,'2MASX J14593093+5435048',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,224.87925,54.58481,0,NULL,59928222706,936378479,14630913,18.1),(125700,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125700,37.39,0.46,300,56947,70,NULL,NULL,'2MASX J14593147+2215437',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.25',0.13,NULL,NULL,NULL,NULL,NULL,1,224.881208333,22.26214,0.085,NULL,59528762228,930136909,14533389,18.25),(125701,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125701,37.04,0.46,256,56948,70,NULL,NULL,'2MASX J14593175+5603098',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,224.8822083,56.05269,0.021,NULL,57717612319,901837692,14091213,16.9),(125702,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125702,37.02,0.46,254,56949,70,NULL,NULL,'2MASX J14593225+3416021',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000169,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,224.884541667,34.26736,0.009,NULL,60127211610,939487681,14679495,16.6),(125703,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005be',NULL,125703,35.7,0.16,129,56950,72,NULL,NULL,'2MASX J14593310+1640070',0.03562,'2013ApJ...773...53F',2013,1,0.5,NULL,'G',NULL,NULL,'16.34',0.18,NULL,NULL,NULL,NULL,NULL,1,224.887833,16.66858,0.041,NULL,59592644261,931135066,14548985,16.34),(125704,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005be',NULL,125704,35.85,0.05,143,56950,72,NULL,NULL,'2MASX J14593310+1640070',0.035,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125705,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005be',NULL,125705,35.79,0.1,144,56950,74.4,NULL,NULL,'2MASX J14593310+1640070',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125706,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005be',NULL,125706,35.82,0.02,146,56950,72,NULL,NULL,'2MASX J14593310+1640070',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125707,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005be',NULL,125707,35.93,0.16,148,56950,70,NULL,'SALT 2','2MASX J14593310+1640070',0.035,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125708,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125708,37.82,0.46,366,56951,70,NULL,NULL,'2MASX J14593473+1559370',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.77',0.13,NULL,NULL,NULL,NULL,NULL,1,224.894625,15.99358,0.045,NULL,59591842751,931122542,14548789,18.77),(125709,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125709,37.5,0.46,316,56952,70,NULL,NULL,'2MASX J14593801+3513542',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000184,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,224.9085417,35.23183,0.029,NULL,60129519672,939523744,14680058,16.8),(125710,'IRAS','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125710,33.25,0.8,44.7,56953,75,NULL,'MAT, I','ESO 581- G 011',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000027,NULL,'15.23',0.4,'Sc: sp',NULL,NULL,NULL,NULL,1,224.909167,-18.73158,0.341,NULL,46696249590,729628899,11400451,15.23),(125711,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125711,32.48,0.32,31.3,56953,85,NULL,'I, inv','ESO 581- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125712,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125712,32.49,0.32,31.5,56953,85,NULL,'I, raw','ESO 581- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125713,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125713,32.83,0.43,36.9,56953,75,NULL,'MAT, I, inv','ESO 581- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125714,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125714,32.84,0.43,36.9,56953,75,NULL,'MAT, I, raw','ESO 581- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125715,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125715,33.03,0.43,40.3,56953,75,NULL,'MAT, I, cor','ESO 581- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125716,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125716,33.25,0.49,44.7,56953,NULL,NULL,'Malmquist cor.','ESO 581- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125717,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125717,33.41,0.2,48.1,56953,74.4,NULL,NULL,'ESO 581- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125718,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125718,33.48,0.44,49.8,56953,NULL,NULL,NULL,'ESO 581- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125719,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125719,33.85,0.49,58.9,56953,75,NULL,'IR','ESO 581- G 011',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125720,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125720,36.53,0.2,202,56954,74.4,NULL,NULL,'CGCG 164-052',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00017,NULL,'15.7',0.4,'Sc',NULL,NULL,NULL,NULL,1,224.909417,28.95428,0.033,NULL,60081835589,938778681,14668416,15.7),(125721,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125721,37.57,0.46,327,56955,70,NULL,NULL,'2MASX J14593856+0543441',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,224.9105,5.72883,0.113,NULL,59337058061,927141532,14486586,17.3),(125722,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125722,34.52,0.52,80.3,56956,70,NULL,NULL,'2MASX J14593893-3754206',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000083,NULL,'13.5I',0.4,NULL,NULL,NULL,NULL,NULL,1,224.9122083,-37.90583,0.237,NULL,47236210632,738065791,11532277,13.5),(125723,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125723,37.79,0.46,361,56957,70,NULL,NULL,'SDSS J145939.83+332854.9',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.6g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.915958333,33.48192,0.009,NULL,60126601194,939478143,14679345,17.6),(125724,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125724,38.72,0.33,555,56958,70,NULL,NULL,'SDSS J145941.59+115609.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000157,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,224.923333,11.93586,0.061,NULL,59374808682,927731385,14495802,18.7),(125725,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125725,35.03,NULL,102,56959,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09646',NULL,'2010Ap&SS.325..163P',2010,1,1.1,NULL,'G',0.000012,NULL,'16.0',0.11,'Scd',NULL,NULL,NULL,NULL,1,224.924041667,27.32628,0.081,NULL,60083154418,938799287,14668738,16),(125726,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125726,35.05,NULL,102,56959,NULL,NULL,'Dipole + Quadrupole','UGC 09646',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125727,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125727,35.06,NULL,103,56959,NULL,NULL,'Dipole','UGC 09646',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125728,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125728,35.09,NULL,104,56959,NULL,NULL,NULL,'UGC 09646',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125729,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125729,35.73,0.2,140,56959,74.4,NULL,NULL,'UGC 09646',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125730,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125730,38.19,0.46,435,56960,70,NULL,NULL,'2MASX J14594222+1446100',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,224.925791667,14.76947,0.017,NULL,59579123970,930923812,14545684,18.2),(125731,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125731,37.91,0.13,382,56961,70,NULL,NULL,'2MASX J14594265+4721073',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000168,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,224.927875,47.35189,0.057,NULL,59991135941,937361499,14646273,16.9),(125732,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125732,38.09,0.46,416,56962,70,NULL,NULL,'2MASX J14594364+0325111',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000084,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,224.931917,3.41975,0.149,NULL,59340009455,927187647,14487306,17.9),(125733,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125733,36.79,0.46,228,56963,70,NULL,NULL,'2MASX J14594454+4756423',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000189,NULL,'16.1g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,224.935333333,47.94508,0.053,NULL,59940841872,936575654,14633994,16.1),(125734,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125734,37.75,0.46,355,56964,70,NULL,NULL,'2MASX J14594544+0118171',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000083,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,224.9394583,1.30472,0.157,NULL,59325083584,926954431,14483662,17.2),(125735,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125735,38.14,0.46,424,56965,70,NULL,NULL,'2MASX J14594679+4724172',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000176,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,224.9447917,47.40489,0.057,NULL,59991144756,937361636,14646275,17.8),(125736,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125736,37.89,0.46,379,56966,70,NULL,NULL,'2MASX J14594683+3602228',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00017,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,224.945,36.03972,0.021,NULL,60128993619,939515525,14679930,17.5),(125737,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125737,37.64,0.46,337,56967,70,NULL,NULL,'SDSS J145947.75+254546.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.949,25.76294,0.109,NULL,60079431196,938741112,14667829,18.3),(125738,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125738,36.1,0.46,166,56968,70,NULL,NULL,'2MASX J14594830+4751592',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000169,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,224.951125,47.86639,0.065,NULL,59940862454,936575975,14633999,16.2),(125739,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125739,37.66,0.46,340,56969,70,NULL,NULL,'2MASX J14594852+4307332',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000163,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,224.952125,43.126,0.033,NULL,59981892604,937217071,14644016,17.1),(125740,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125740,36.75,0.33,224,56970,70,NULL,NULL,'SDSS J145950.28+210100.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.9595417,21.01669,0.061,NULL,59542334423,930348975,14536702,17.9),(125741,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125741,38.38,0.46,475,56971,70,NULL,NULL,'2MASX J14595046+5442467',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000145,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,224.960375,54.71294,0,NULL,59190018939,924844045,14450688,18.3),(125742,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125742,36.52,0.27,201,56972,70,NULL,NULL,'2MASX J14595271+2347261',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.93',0.18,NULL,NULL,NULL,NULL,NULL,1,224.969583,23.79058,0.093,NULL,59526361351,930099396,14532803,17.93),(125743,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125743,37.94,0.46,387,56973,70,NULL,NULL,'SDSS J145953.15+393508.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,224.9715,39.58581,0.005,NULL,60117166247,939330722,14677042,18.1),(125744,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125744,36.29,0.46,181,56974,70,NULL,NULL,'2MASX J14595430-0126437',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00015,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,224.9764583,-1.44547,0.173,NULL,46440123074,725626923,11337920,16.6),(125745,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125745,36.63,0.73,212,56974,70,NULL,NULL,'2MASX J14595430-0126437',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125746,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125746,37.85,0.46,372,56975,70,NULL,NULL,'2MASX J14595432+3904438',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,224.976583,39.07875,0.009,NULL,60118004205,939343815,14677247,17.9),(125747,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125747,38.26,0.46,450,56976,70,NULL,NULL,'SDSS J145955.35+080753.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.5g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.980625,8.13158,0.065,NULL,59391331824,927989559,14499836,18.5),(125748,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125748,37.8,0.46,363,56977,70,NULL,NULL,'2MASX J14595606+3929418',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,224.983666667,39.49511,0.005,NULL,60117169456,939330772,14677043,17.5),(125749,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125749,37.21,0.46,276,56978,70,NULL,NULL,'2MASX J14595618+2032131',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'16.83',0.17,NULL,NULL,NULL,NULL,NULL,1,224.984,20.53708,0.073,NULL,59542091223,930345175,14536643,16.83),(125750,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125750,37.56,0.46,326,56979,70,NULL,NULL,'2MASX J14595683+2625114',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'18.02',0.12,NULL,NULL,NULL,NULL,NULL,1,224.98675,26.41981,0.109,NULL,60080248045,938753875,14668029,18.02),(125751,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125751,35.84,0.46,147,56980,70,NULL,NULL,'2MASX J14595817+5619542',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000176,NULL,'15.9g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,224.9922917,56.33181,0.005,NULL,57717764318,901840067,14091251,15.9),(125752,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125752,38.79,0.46,573,56981,70,NULL,NULL,'SDSS J145958.15+293219.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.992333,29.53869,0.045,NULL,60095188056,938987313,14671676,18.2),(125753,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125753,37.4,0.46,302,56982,70,NULL,NULL,'2MASX J14595863+3346184',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000218,NULL,'16.0g',0.39,NULL,NULL,NULL,NULL,NULL,1,224.994375,33.77192,0.013,NULL,60127382617,939490353,14679536,16),(125754,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125754,38.05,0.46,407,56983,70,NULL,NULL,'2MASX J14595913+1921251',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,224.996333,19.35706,0.061,NULL,59538407254,930287613,14535743,18.3),(125755,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125755,37.6,0.46,331,56984,70,NULL,NULL,'2MASX J14595950+3704158',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,224.9977917,37.07114,0.025,NULL,60120354615,939380540,14677820,17.8),(125756,'IRAS','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125756,31.66,0.8,21.5,56985,75,NULL,'A82, H','NGC 5806',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.000017,NULL,'12.5g',1.15,'SAB(s)b        NLAGN','in a radial-velocity based grouping',NULL,NULL,'Sy 2',1,225.001667,1.89131,0.157,NULL,59328217251,927003394,14484428,12.5),(125757,'IRAS','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125757,31.71,0.8,22,56985,75,NULL,'CF, r','NGC 5806',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125758,'Sosies','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125758,31.65,0.08,21.4,56985,NULL,NULL,NULL,'NGC 5806',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125759,'Tully est','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125759,32.27,0.8,28.5,56985,75,NULL,'B','NGC 5806',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125760,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125760,31.76,0.36,22.5,56985,NULL,NULL,NULL,'NGC 5806',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125761,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125761,31.93,0.47,24.3,56985,75,NULL,'A82, H, raw','NGC 5806',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125762,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125762,32.01,0.5,25.2,56985,NULL,NULL,'Malmquist cor.','NGC 5806',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125763,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125763,32.04,NULL,25.6,56985,72,NULL,NULL,'NGC 5806',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125764,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125764,32.05,0.47,25.7,56985,75,NULL,'A82, H, inv','NGC 5806',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125765,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125765,32.07,0.4,26,56985,NULL,NULL,'mean','NGC 5806',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125766,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125766,32.08,0.46,26.1,56985,NULL,NULL,'J','NGC 5806',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125767,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125767,32.09,0.47,26.1,56985,NULL,NULL,'H','NGC 5806',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125768,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125768,32.09,0.45,26.2,56985,NULL,NULL,'K','NGC 5806',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125769,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125769,32.14,0.47,26.7,56985,NULL,NULL,NULL,'NGC 5806',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125770,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125770,32.14,0.2,26.8,56985,74.4,NULL,NULL,'NGC 5806',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125771,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125771,32.16,0.47,27.1,56985,75,NULL,'A82, H, cor','NGC 5806',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125772,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125772,32.17,0.38,27.2,56985,75,NULL,'CF, r, raw','NGC 5806',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125773,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125773,32.17,0.43,27.2,56985,75,NULL,'3.6 micron, color corrected','NGC 5806',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125774,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125774,32.18,0.43,27.3,56985,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5806',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125775,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125775,32.28,0.38,28.6,56985,75,NULL,'CF, r, cor','NGC 5806',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125776,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125776,32.32,0.38,29.1,56985,75,NULL,'CF, r, inv','NGC 5806',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125777,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125777,37.13,0.71,266,56986,70,NULL,NULL,'2MASX J15000087-2749458',NULL,'2014MNRAS.445.2677S',2014,1,0.27,NULL,'G',0.00015,NULL,'15.5R',0.27,NULL,NULL,NULL,NULL,NULL,1,225.00375,-27.82933,0.649,NULL,47198449884,737475779,11523059,15.5),(125778,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125778,37.16,0.46,270,56987,70,NULL,NULL,'2MASX J15000118+4022318',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000142,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.004917,40.37553,0,NULL,59978550925,937164858,14643200,17.4),(125779,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125779,37.41,0.46,304,56988,70,NULL,NULL,'2MASX J15000142+2429305',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,225.005916667,24.49183,0.097,NULL,59525762700,930090042,14532656,18.2),(125780,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125780,37.31,0.33,290,56989,70,NULL,NULL,'2MASX J15000148+1212227',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00017,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,225.006333,12.20633,0.073,NULL,59374583571,927727868,14495747,16.7),(125781,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125781,36.75,0.33,224,56990,70,NULL,NULL,'2MASX J15000164+2100491',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.39',0.26,NULL,NULL,NULL,NULL,NULL,1,225.007,21.01367,0.061,NULL,59542335667,930348994,14536703,16.39),(125782,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125782,37.91,0.13,382,56991,70,NULL,NULL,'2MASX J15000201+4715294',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,225.008458333,47.25831,0.057,NULL,59991195564,937362430,14646287,17.8),(125783,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125783,38.16,0.46,428,56992,70,NULL,NULL,'2MASX J15000240+2048341',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,225.01025,20.80964,0.073,NULL,59542126773,930345730,14536652,18.5),(125784,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125784,37.23,0.46,279,56993,70,NULL,NULL,'2MASX J15000348+2126371',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,225.014417,21.44372,0.077,NULL,59541547221,930336675,14536510,16.8),(125785,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125785,37.25,0.33,282,56994,70,NULL,NULL,'2MASX J15000454+2527015',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.46',0.23,NULL,NULL,NULL,NULL,NULL,1,225.018791667,25.45047,0.093,NULL,60079215692,938737745,14667777,17.46),(125786,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125786,37.91,0.13,382,56995,70,NULL,NULL,'2MASX J15000494+4730344',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,225.0204583,47.50969,0.077,NULL,59991133537,937361461,14646272,16.9),(125787,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125787,37.58,0.46,328,56996,70,NULL,NULL,'2MASX J15000817+3954328',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000186,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,225.0339583,39.90931,0,NULL,60117011994,939328312,14677004,16.5),(125788,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125788,37.25,0.33,282,56997,70,NULL,NULL,'2MASX J15000889+2524205',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.037,25.40578,0.097,NULL,60079225148,938737892,14667779,17.5),(125789,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125789,37.14,0.46,268,56998,70,NULL,NULL,'2MASX J15000919+2436075',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000182,NULL,'18.06',0.16,NULL,NULL,NULL,NULL,NULL,1,225.0382917,24.60208,0.093,NULL,59525764584,930090071,14532657,18.06),(125790,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125790,36.35,0.46,186,56999,70,NULL,NULL,'2MASX J15001003+2800555',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.0002,NULL,'16.5',0.48,NULL,NULL,NULL,NULL,NULL,1,225.041875,28.01544,0.041,NULL,60083224914,938800389,14668756,16.5),(125791,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125791,37.68,0.46,344,57000,70,NULL,NULL,'SDSS J150010.30+042512.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000069,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,225.0429583,4.42025,0.109,NULL,59340761424,927199397,14487490,18.5),(125792,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125792,37.44,0.46,307,57001,70,NULL,NULL,'2MASX J15001063+0944550',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,225.044333333,9.7485,0.053,NULL,59377974202,927780846,14496575,17),(125793,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125793,37.91,0.46,381,57002,70,NULL,NULL,'2MASX J15001212+2702335',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.22',0.17,NULL,NULL,NULL,NULL,NULL,1,225.050583333,27.04258,0.085,NULL,60079539735,938742808,14667856,18.22),(125794,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125794,37.08,0.46,261,57003,70,NULL,NULL,'2MASX J15001223+1937307',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.16',0.19,NULL,NULL,NULL,NULL,NULL,1,225.051,19.62528,0.065,NULL,59538227817,930284809,14535700,18.16),(125795,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125795,37.91,0.16,381,57004,70,NULL,NULL,'2MASX J15001227+3220424',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.051,32.34511,0.025,NULL,60091844204,938935065,14670860,17.9),(125796,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125796,37.2,0.46,275,57005,70,NULL,NULL,'2MASX J15001225+4554384',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,225.051083,45.9105,0.021,NULL,59991931185,937373924,14646467,17),(125797,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125797,38.51,0.46,504,57006,70,NULL,NULL,'SDSS J150013.04+331855.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000161,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,225.054375,33.31533,0.021,NULL,60126643405,939478803,14679356,18.7),(125798,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125798,37.87,0.46,374,57007,70,NULL,NULL,'2MASX J15001323+5146084',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000164,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,225.055333,51.769,0.021,NULL,59931621635,936431588,14631743,17.5),(125799,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125799,36.88,0.46,237,57008,70,NULL,NULL,'2MASX J15001330+5440423',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000176,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,225.0555417,54.67839,0,NULL,59928218883,936378420,14630912,17),(125800,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125800,37.35,0.46,296,57009,70,NULL,NULL,'2MASX J15001359+1732438',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,225.056583,17.54569,0.061,NULL,59589285462,931082585,14548165,17.7),(125801,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125801,37.97,0.46,393,57010,70,NULL,NULL,'2MASX J15001432+0027495',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000091,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,225.05975,0.46367,0.153,NULL,59324475490,926944929,14483514,17.2),(125802,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125802,37.91,0.13,382,57011,70,NULL,NULL,'2MASX J15001684+4713574',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.070208333,47.23264,0.057,NULL,59991193748,937362402,14646287,18),(125803,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125803,37.53,0.46,320,57012,70,NULL,NULL,'2MASX J15001730+4505104',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000185,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,225.072375,45.08617,0.033,NULL,59995318640,937426853,14647294,17.3),(125804,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125804,37.85,0.46,372,57013,70,NULL,NULL,'2MASX J15001773+3117274',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,225.073833333,31.29089,0.017,NULL,60092604208,938946940,14671045,18.2),(125805,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125805,38.06,0.46,409,57014,70,NULL,NULL,'SDSS J150018.80+002809.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000076,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,225.078333,0.46925,0.153,NULL,59324477666,926944963,14483515,18),(125806,'CMD','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125806,17.1,NULL,0.0263,57015,NULL,NULL,NULL,'IC 4499',NULL,'2000ApJS..129..315V',2000,1,NULL,NULL,'*Cl',NULL,NULL,NULL,NULL,'Globular',NULL,NULL,NULL,NULL,1,225.0802083,-82.2135,0.385,0,44073795942,688653061,10760204,NULL),(125807,'Horizontal Branch','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125807,16.33,0.33,0.0185,57015,NULL,NULL,NULL,'IC 4499',NULL,'1995MNRAS.275.1057F',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125808,'RR Lyrae','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125808,16.2,0.23,0.0174,57015,NULL,NULL,'13, V','IC 4499',NULL,'1986AJ.....92..825C',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125809,'RR Lyrae','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125809,16.36,NULL,0.0187,57015,NULL,NULL,'10, K','IC 4499',NULL,'1992MmSAI..63..433B',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125810,'RR Lyrae','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125810,16.47,0.04,0.0197,57015,NULL,18.5,'32, K, 0.06 mag systematic error','IC 4499',NULL,'2004A&A...415..987S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125811,'RR Lyrae','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125811,17.09,0.04,0.0262,57015,NULL,NULL,NULL,'IC 4499',NULL,'2004ApJ...612.1092D',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125812,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125812,37.93,0.46,385,57016,70,NULL,NULL,'SDSS J150019.35+450912.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,225.080667,45.15347,0.021,NULL,59995318156,937426846,14647294,18.4),(125813,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125813,37.58,0.46,328,57017,70,NULL,NULL,'2MASX J15001966+0837290',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,225.0819583,8.62472,0.025,NULL,59390500190,927976565,14499633,17.4),(125814,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125814,37.53,0.46,320,57018,70,NULL,NULL,'2MASX J15001973+4756544',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,225.0819583,47.94836,0.053,NULL,59940820684,936575323,14633989,17.6),(125815,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125815,37.33,0.46,293,57019,70,NULL,NULL,'2MASX J15001983+5949064',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000079,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,225.0825,59.81836,0.017,NULL,57776745115,902761642,14105650,17),(125816,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125816,37.67,0.46,342,57020,70,NULL,NULL,'2MASX J15001992+5148294',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000138,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,225.082833,51.80825,0.021,NULL,59931612860,936431450,14631741,18.3),(125817,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125817,38.54,0.46,511,57021,70,NULL,NULL,'SDSS J150020.53+013516.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000075,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,225.085583333,1.58803,0.157,NULL,59328039670,927000619,14484384,18.4),(125818,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125818,37.95,0.46,389,57022,70,NULL,NULL,'SDSS J150020.76+371553.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000133,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,225.0865417,37.26481,0.029,NULL,60120313295,939379895,14677810,18.6),(125819,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125819,37.93,0.33,386,57023,70,NULL,NULL,'SDSS J150021.53+154838.9',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.08975,15.81083,0.017,NULL,59591683726,931120058,14548750,17.5),(125820,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125820,37.7,0.46,346,57024,70,NULL,NULL,'2MASX J15002177+1440358',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.61',0.12,NULL,NULL,NULL,NULL,NULL,1,225.0907083,14.67667,0.041,NULL,59579922634,930936291,14545879,18.61),(125821,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125821,37.08,0.46,261,57025,70,NULL,NULL,'2MASX J15002233+0642260',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,225.0929583,6.70722,0.061,NULL,59387400611,927928134,14498877,16.2),(125822,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125822,37.41,0.46,303,57026,70,NULL,NULL,'2MASX J15002282+2905541',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000207,NULL,'17.56',0.21,'E',NULL,NULL,NULL,NULL,1,225.095083,29.09844,0.037,NULL,60094428193,938975440,14671491,17.56),(125823,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125823,35.73,0.46,140,57027,70,NULL,NULL,'2MASX J15002314+0351402',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000079,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,225.096417,3.86117,0.129,NULL,59340916080,927201813,14487528,16.5),(125824,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125824,37.91,0.16,381,57028,70,NULL,NULL,'SDSS J150023.43+321825.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000155,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,225.097625,32.30719,0.025,NULL,60091837611,938934962,14670858,18.7),(125825,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125825,36.19,0.46,173,57029,70,NULL,NULL,'2MASX J15002362+2617091',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.61',0.17,NULL,NULL,NULL,NULL,NULL,1,225.0984583,26.28572,0.101,NULL,60080174299,938752723,14668011,17.61),(125826,'IRAS','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125826,35.03,0.8,101,57030,75,NULL,'MAT, I','ESO 386- G 044',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000027,NULL,'14.83',0.9,'Sc',NULL,NULL,NULL,NULL,1,225.099167,-37.36211,0.245,NULL,47235380278,738052816,11532075,14.83),(125827,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125827,34.63,0.32,84.5,57030,85,NULL,'I, raw','ESO 386- G 044',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125828,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125828,34.68,0.32,86.1,57030,85,NULL,'I, inv','ESO 386- G 044',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125829,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125829,34.77,0.43,89.8,57030,75,NULL,'MAT, I, raw','ESO 386- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125830,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125830,34.97,0.43,98.6,57030,75,NULL,'MAT, I, inv','ESO 386- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125831,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125831,35.08,0.43,104,57030,75,NULL,'MAT, I, cor','ESO 386- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125832,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125832,35.09,0.44,104,57030,NULL,NULL,'Malmquist cor.','ESO 386- G 044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125833,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125833,35.22,0.42,111,57030,NULL,NULL,NULL,'ESO 386- G 044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125834,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125834,35.24,0.2,112,57030,74.4,NULL,NULL,'ESO 386- G 044',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125835,'Tully est','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125835,33.02,0.8,40.2,57031,75,NULL,NULL,'UGCA 397',NULL,'1988NBGC.C....0000T',1988,1,2.2,NULL,'G',0.000019,NULL,'14.15',1.8,'SB(s)m:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,225.1012917,-13.55197,0.381,NULL,46692017742,729562777,11399418,14.15),(125836,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125836,37.91,0.13,382,57032,70,NULL,NULL,'2MASX J15002573+4724193',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000158,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,225.107375,47.40539,0.077,NULL,59991140120,937361564,14646274,18.1),(125837,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125837,36.52,0.46,202,57033,70,NULL,NULL,'2MASX J15002575+1925298',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.17',0.28,NULL,NULL,NULL,NULL,NULL,1,225.107458333,19.42486,0.069,NULL,59538396047,930287438,14535741,16.17),(125838,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125838,37.97,0.46,392,57034,70,NULL,NULL,'2MASX J15002602+2943521',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,225.108333,29.73122,0.037,NULL,60095147555,938986680,14671666,17.4),(125839,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125839,37.55,0.33,323,57035,70,NULL,NULL,'2MASX J15002700+1004490',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.55',0.17,NULL,NULL,NULL,NULL,NULL,1,225.112583,10.08017,0.049,NULL,59378677089,927791829,14496747,18.55),(125840,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125840,38.95,0.46,615,57036,70,NULL,NULL,'SDSS J150027.01+250832.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.7g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.112583,25.14239,0.101,NULL,59408137089,928252142,14503939,18.7),(125841,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125841,37.37,0.46,298,57037,70,NULL,NULL,'2MASX J15002721+4632283',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,225.113333,46.54117,0.037,NULL,59992004671,937375072,14646485,18.1),(125842,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125842,37.5,0.33,317,57038,70,NULL,NULL,'2MASX J15002827+4737223',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,225.117875,47.62294,0.073,NULL,59938704486,936542257,14633472,17.9),(125843,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125843,37.97,0.46,393,57039,70,NULL,NULL,'2MASX J15002907+5028168',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,225.121083,50.47122,0,NULL,59944145171,936627268,14634801,17.9),(125844,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125844,37.5,0.33,317,57040,70,NULL,NULL,'2MASX J15003005+4737446',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000164,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,225.125166667,47.62919,0.073,NULL,59938704090,936542251,14633472,16.8),(125845,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125845,37.91,0.16,381,57041,70,NULL,NULL,'2MASX J15003113+3213392',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.129875,32.22772,0.017,NULL,60092013162,938937705,14670901,17.7),(125846,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125846,37.82,0.46,366,57042,70,NULL,NULL,'2MASX J15003150+3628496',NULL,'2015arXiv151105856S',2015,1,0.37,'May be a resolved component of 87GB[BWE91] 1458+3640.','G',0.000202,NULL,'16.7g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,225.131167,36.4805,0.009,NULL,60127709753,939495464,14679616,16.7),(125847,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125847,37.55,0.33,323,57043,70,NULL,NULL,'2MASX J15003296+0954460',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000197,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,225.137167,9.91283,0.049,NULL,59377802300,927778160,14496533,16.5),(125848,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125848,35.81,0.46,145,57044,70,NULL,NULL,'2MASX J15003389+0903430',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.95',0.18,NULL,NULL,NULL,NULL,NULL,1,225.1412083,9.06206,0.057,NULL,59388465391,927944771,14499137,17.95),(125849,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125849,37.21,0.46,276,57045,70,NULL,NULL,'SDSS J150035.77+320610.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,225.149083,32.10306,0.005,NULL,60092018115,938937783,14670902,17.9),(125850,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125850,35.03,0.34,101,57046,NULL,NULL,'Malmquist cor.','ESO 581- G 014',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.30',0.4,'S              HII',NULL,NULL,NULL,NULL,1,225.151333,-21.89161,0.377,NULL,46655876423,728998069,11390594,15.3),(125851,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125851,35.27,0.31,113,57046,NULL,NULL,NULL,'ESO 581- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125852,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125852,35.31,0.2,115,57046,74.4,NULL,NULL,'ESO 581- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125853,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125853,33.06,0.49,40.9,57047,75,NULL,'IR','FGC 1842',NULL,'2011yCatp016004901K',2011,1,0.98,'2000A&AS..143..421M has z = 0.007965 +- 0.000057.','G',0.000208,NULL,'16.5g',0.17,'Sd',NULL,NULL,NULL,NULL,1,225.1535,38.00894,0.009,NULL,60120938128,939389658,14677963,16.5),(125854,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125854,33.53,NULL,50.7,57047,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1842',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125855,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125855,33.55,NULL,51.4,57047,NULL,NULL,'Dipole + Quadrupole','FGC 1842',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125856,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125856,33.58,NULL,52,57047,NULL,NULL,'Dipole','FGC 1842',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125857,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125857,33.62,NULL,53.1,57047,NULL,NULL,NULL,'FGC 1842',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125858,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125858,38.8,0.46,574,57048,70,NULL,NULL,'SDSS J150037.52+521301.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000153,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,225.156375,52.21717,0.025,NULL,59932350725,936442980,14631921,18.6),(125859,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125859,37.93,0.33,386,57049,70,NULL,NULL,'SDSS J150037.75+154749.1',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.6g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.157333,15.797,0.017,NULL,59591135410,931111490,14548617,17.6),(125860,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125860,35.67,0.33,136,57050,70,NULL,NULL,'2MASX J15003823+0618070',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'16.61',0.36,NULL,NULL,NULL,NULL,NULL,1,225.159333,6.302,0.085,NULL,59385106821,927892294,14498317,16.61),(125861,'IRAS','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125861,35.4,0.8,120,57051,75,NULL,'MAT, I','ESO 581- G 015',NULL,'1997ApJS..109..333W',1997,1,1.6,'6dF DR1 has z = 0.026274.','G',0.000033,NULL,'15.54',0.5,'SB(r)c:',NULL,NULL,NULL,NULL,1,225.160875,-21.71797,0.409,NULL,46656419512,729006554,11390727,15.54),(125862,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125862,34.55,0.43,81.3,57051,75,NULL,'MAT, I, raw','ESO 581- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125863,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125863,34.58,0.32,82.6,57051,85,NULL,'I, raw','ESO 581- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125864,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125864,34.63,0.32,84.2,57051,85,NULL,'I, inv','ESO 581- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125865,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125865,34.75,0.43,88.9,57051,75,NULL,'MAT, I, inv','ESO 581- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125866,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125866,34.85,0.43,93.4,57051,75,NULL,'MAT, I, cor','ESO 581- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125867,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125867,34.98,0.31,99.1,57051,NULL,NULL,'Malmquist cor.','ESO 581- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125868,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125868,35.13,0.29,106,57051,NULL,NULL,NULL,'ESO 581- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125869,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125869,35.17,0.2,108,57051,74.4,NULL,NULL,'ESO 581- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125870,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125870,37.4,0.46,302,57052,70,NULL,NULL,'2MASX J15003983+3358272',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00019,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,225.165917,33.97414,0.025,NULL,60127404815,939490700,14679542,16.4),(125871,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125871,37.25,0.46,281,57053,70,NULL,NULL,'SDSS J150039.99+054531.3',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.7g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.166625,5.75869,0.113,NULL,59336854452,927138350,14486536,17.7),(125872,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125872,37.5,0.46,316,57054,70,NULL,NULL,'2MASX J15004034+2542092',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.18',0.16,NULL,NULL,NULL,NULL,NULL,1,225.1682917,25.70269,0.065,NULL,60079227945,938737936,14667780,18.18),(125873,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125873,37.48,0.46,313,57055,70,NULL,NULL,'2MASX J15004113+2205566',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,225.1714583,22.09911,0.085,NULL,59528199651,930128119,14533251,17.1),(125874,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125874,37.75,0.46,355,57056,70,NULL,NULL,'2MASX J15004312+0346362',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000078,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,225.1797083,3.77678,0.129,NULL,59340057111,927188392,14487318,17.5),(125875,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125875,37.83,0.46,368,57057,70,NULL,NULL,'2MASX J15004347+3325452',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,225.181125,33.42922,0.021,NULL,60126503017,939476609,14679322,17.6),(125876,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125876,36.57,0.46,206,57058,70,NULL,NULL,'2MASX J15004369+0029242',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000106,NULL,'16.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,225.182125,0.49017,0.141,NULL,59324471497,926944867,14483513,16.7),(125877,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125877,38.13,0.46,422,57059,70,NULL,NULL,'SDSS J150044.91+292451.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.32',0.14,NULL,NULL,NULL,NULL,NULL,1,225.187166667,29.41419,0.045,NULL,60094956989,938983702,14671620,17.32),(125878,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125878,37.25,0.46,282,57060,70,NULL,NULL,'2MASXi J1500451+133623',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.85',0.14,NULL,NULL,NULL,NULL,NULL,1,225.188375,13.60639,0.053,NULL,59576714514,930886164,14545096,18.85),(125879,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125879,36.6,0.46,209,57061,70,NULL,NULL,'2MASX J15004586+2457262',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00019,NULL,'15.9g',0.45,NULL,NULL,NULL,NULL,NULL,1,225.1912083,24.95725,0.097,NULL,59525602244,930087535,14532617,15.9),(125880,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125880,36.34,0.46,185,57062,70,NULL,NULL,'2MASX J15004691+0808385',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000494,NULL,'16.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,225.1954583,8.14397,0.053,NULL,59391313849,927989278,14499832,16.2),(125881,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125881,32.72,0.4,35.1,57063,75,NULL,NULL,'UGC 09657',NULL,'2008Ap.....51..336K',2008,1,1.13,'HOLM 689B is a star.','G',0.000037,NULL,'15.2g',0.32,'SBdm?',NULL,NULL,NULL,NULL,1,225.202833,48.36081,0.021,NULL,59940896054,936576500,14634007,15.2),(125882,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125882,33.64,0.49,53.6,57063,75,NULL,'IR','UGC 09657',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125883,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125883,37.8,0.46,364,57064,70,NULL,NULL,'2MASX J15004880+4109388',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000179,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,225.2035,41.16075,0.029,NULL,59978645217,937166331,14643223,16.7),(125884,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125884,37.99,0.46,397,57065,70,NULL,NULL,'2MASX J15005100+0942425',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.2125,9.71181,0.053,NULL,59377943762,927780371,14496568,17.3),(125885,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125885,38.85,0.46,589,57066,70,NULL,NULL,'2MASX J15005188+1621282',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,225.216125,16.35789,0.021,NULL,59591716820,931120575,14548758,18.2),(125886,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125886,37.91,0.16,381,57067,70,NULL,NULL,'SDSS J150052.02+322110.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.2167917,32.35281,0.025,NULL,60091841353,938935021,14670859,18.1),(125887,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125887,35.84,0.33,147,57068,70,NULL,NULL,'2MASX J15005255+0145509',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000085,NULL,'15.9g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,225.219083333,1.76419,0.145,NULL,59328077046,927001203,14484393,15.9),(125888,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125888,37.72,0.46,350,57069,70,NULL,NULL,'2MASX J15005276+2052387',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.34',0.16,NULL,NULL,NULL,NULL,NULL,1,225.2199583,20.87742,0.073,NULL,59542310731,930348605,14536696,18.34),(125889,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125889,37.39,0.33,300,57070,70,NULL,NULL,'2MASX J15005339+3434361',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,225.2224583,34.57664,0.033,NULL,60126735381,939480240,14679378,17.8),(125890,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125890,37.91,0.16,381,57071,70,NULL,NULL,'2MASX J15005374+3210421',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.223917,32.17836,0.017,NULL,60092009280,938937645,14670900,17.6),(125891,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125891,36.12,0.46,168,57072,70,NULL,NULL,'2MASX J15005393+1955227',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.00',0.25,NULL,NULL,NULL,NULL,NULL,1,225.2247917,19.923,0.065,NULL,59539093532,930298336,14535911,16),(125892,'SBF','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125892,32.15,0.29,26.9,57073,NULL,NULL,'I','NGC 5812',NULL,'2001ApJ...546..681T',2001,1,2.1,NULL,'G',0.000007,NULL,'12.19',1.9,'E0','in a pair',NULL,NULL,NULL,1,225.232083,-7.45736,0.301,NULL,46502941968,726608468,11353257,12.19),(125893,'SBF','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125893,32.15,0.29,26.9,57073,NULL,NULL,NULL,'NGC 5812',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125894,'SBF','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125894,32.21,0.14,27.7,57073,74.4,NULL,NULL,'NGC 5812',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125895,'SBF','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125895,32.25,0.29,28.2,57073,NULL,NULL,'Malmquist cor.','NGC 5812',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125896,'D-Sigma','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125896,31.81,0.4,23,57073,75,NULL,'Edat, raw','NGC 5812',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125897,'D-Sigma','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125897,32.14,0.4,26.8,57073,75,NULL,'Edat, cor','NGC 5812',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125898,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125898,33.4,0.65,47.9,57073,95,NULL,'Weighted Mean','NGC 5812',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125899,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125899,35.18,0.81,109,57073,55,NULL,'Visvanathan & Sandage 1979','NGC 5812',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125900,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125900,32.23,0.41,28,57073,NULL,NULL,NULL,'NGC 5812',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125901,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125901,32.37,0.41,29.8,57073,NULL,NULL,'Malmquist cor.','NGC 5812',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125902,'Tully est','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125902,32.5,0.8,31.7,57073,75,NULL,'B','NGC 5812',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125903,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125903,32.29,0.4,28.7,57073,NULL,NULL,'mean','NGC 5812',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125904,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125904,32.35,0.45,29.5,57073,NULL,NULL,'K','NGC 5812',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125905,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125905,37.51,0.46,318,57074,70,NULL,NULL,'2MASX J15005599+4622527',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000182,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,225.2332917,46.38125,0.029,NULL,59992150577,937377352,14646521,17),(125906,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125906,37.54,0.46,322,57075,70,NULL,NULL,'2MASX J15005606-0215162',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000177,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,225.233625,-2.25453,0.229,NULL,46443434244,725678660,11338729,17.3),(125907,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125907,37.39,0.33,300,57076,70,NULL,NULL,'2MASX J15005695+3433521',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000208,NULL,'15.6g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,225.2372083,34.56444,0.033,NULL,60126735025,939480234,14679378,15.6),(125908,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125908,37.15,0.46,269,57077,70,NULL,NULL,'2MASX J15005732+2146087',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.238833,21.76928,0.093,NULL,59539482041,930304406,14536006,17.1),(125909,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125909,38.43,0.46,485,57078,70,NULL,NULL,'2MASX J15005824+4701477',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000176,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,225.24275,47.02992,0.057,NULL,59991356763,937364949,14646327,17.9),(125910,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125910,37.97,0.46,392,57079,70,NULL,NULL,'2MASX J15005906+4031449',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000177,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.2459583,40.52911,0,NULL,59970212603,937034571,14641165,17.5),(125911,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125911,36.91,0.46,241,57080,70,NULL,NULL,'2MASX J15005913+4040229',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'16.70',0.2,NULL,NULL,NULL,NULL,NULL,1,225.2464583,40.67303,0.017,NULL,59978577021,937165265,14643207,16.7),(125912,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125912,37.11,0.46,265,57081,70,NULL,NULL,'2MASX J15005980+2811455',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.09',0.17,NULL,NULL,NULL,NULL,NULL,1,225.249333,28.196,0.041,NULL,60082538374,938789662,14668588,18.09),(125913,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125913,37.83,0.27,369,57082,70,NULL,NULL,'2MASX J15005996+4153169',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,225.2499583,41.88806,0.033,NULL,59978900172,937170315,14643286,17.6),(125914,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125914,32.6,0.54,33.1,57083,NULL,NULL,'Malmquist cor.','MCG -02-38-027',NULL,'2009ApJS..182..474S',2009,1,2.5,NULL,'G',0.000013,NULL,'15.39',0.5,'SB(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,225.2502917,-15.12175,0.429,NULL,46694239503,729597492,11399960,15.39),(125915,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125915,32.74,0.2,35.3,57083,74.4,NULL,NULL,'MCG -02-38-027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125916,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125916,32.74,0.51,35.4,57083,NULL,NULL,NULL,'MCG -02-38-027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125917,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125917,32.96,0.43,39.1,57083,75,NULL,'3.6 micron, color corrected','MCG -02-38-027',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125918,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125918,33.07,0.43,41.2,57083,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-38-027',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125919,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125919,37.33,0.46,293,57084,70,NULL,NULL,'2MASX J15010045+0441209',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000084,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,225.251875,4.68906,0.105,NULL,59337534196,927148971,14486702,17.4),(125920,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125920,37.58,0.46,328,57085,70,NULL,NULL,'2MASX J15010073+4434507',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000178,NULL,'16.3g',0.43,NULL,NULL,NULL,NULL,NULL,1,225.253125,44.58061,0.045,NULL,59994382693,937412229,14647066,16.3),(125921,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125921,37.45,0.46,310,57086,70,NULL,NULL,'SDSS J150100.98+092153.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.254083,9.36472,0.069,NULL,59377250947,927769546,14496399,17.9),(125922,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125922,37.94,0.46,388,57087,70,NULL,NULL,'2MASX J15010124+2329147',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000158,NULL,'17.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,225.255167,23.48742,0.141,NULL,59529096195,930142128,14533470,17.4),(125923,'BL Lac Luminosity','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125923,40.38,NULL,965,57088,NULL,NULL,NULL,'FBQS J150101.8+223806',0.235,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.003,':','16.79',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,225.257667,22.63511,0.085,NULL,59528817538,930137774,14533402,16.79),(125924,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125924,38.42,0.46,483,57089,70,NULL,NULL,'2MASX J15010231+0032149',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000091,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.259625,0.53728,0.141,NULL,59324346819,926942919,14483483,17.5),(125925,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125925,37.45,0.46,309,57090,70,NULL,NULL,'SDSS J150105.42+532908.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000152,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,225.272625,53.48569,0.013,NULL,59929246508,936394476,14631163,18.4),(125926,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125926,36.3,0.46,182,57091,70,NULL,NULL,'2MASX J15010565+0031499',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000075,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,225.2734583,0.53047,0.141,NULL,59324347142,926942924,14483483,16.4),(125927,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125927,35.67,0.33,136,57092,70,NULL,NULL,'2MASX J15010578+0607349',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.22',0.31,NULL,NULL,NULL,NULL,NULL,1,225.2740417,6.12628,0.089,NULL,59329531948,927023936,14484749,17.22),(125928,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125928,37.83,0.27,369,57093,70,NULL,NULL,'SDSS J150105.83+415354.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,225.274333,41.89839,0.033,NULL,59978899968,937170312,14643286,18.3),(125929,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125929,38.26,0.46,448,57094,70,NULL,NULL,'2MASX J15010708+1058225',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,225.279458333,10.97281,0.053,NULL,59375286486,927738851,14495919,17.8),(125930,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125930,35.34,0.52,117,57095,70,NULL,NULL,'2MASX J15010759-2210349',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.45',NULL,NULL,NULL,NULL,NULL,NULL,1,225.281667,-22.17639,0.377,NULL,46642036419,728781819,11387215,16.45),(125931,'TRGB','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125931,27.93,0.04,3.85,57096,NULL,NULL,'I','ESO 223- G 009',NULL,'2009AJ....138..332J',2009,1,2.6,'Extended HIPASS source','G',0.000007,NULL,'14.8',2.4,'IAB(s)m;diff.sp.str','Group member',NULL,NULL,NULL,1,225.286125,-48.29047,NULL,NULL,47056080614,735251259,11488300,14.8),(125932,'TRGB','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125932,28.98,0.1,6.25,57096,NULL,NULL,NULL,'ESO 223- G 009',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125933,'TRGB','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125933,29,0.1,6.31,57096,74.4,NULL,NULL,'ESO 223- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125934,'TRGB','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125934,29.03,NULL,6.4,57096,NULL,NULL,NULL,'ESO 223- G 009',NULL,'2007AJ....133..504K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125935,'Tully est','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125935,29.42,0.8,7.7,57096,75,NULL,NULL,'ESO 223- G 009',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125936,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125936,35.09,0.49,104,57097,70,NULL,NULL,'AM 1458-364 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,225.287333,-36.98547,0.241,NULL,47235236513,738050570,11532040,14.6),(125937,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125937,36.99,0.46,250,57098,70,NULL,NULL,'2MASX J15010892+1818167',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.9g',NULL,NULL,NULL,NULL,NULL,NULL,1,225.287375,18.30456,0.065,NULL,59588639957,931072499,14548007,17.9),(125938,'TRGB','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125938,30.17,0.1,10.8,57099,74.4,NULL,NULL,'UGC 09660',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000092,NULL,'14.2g',0.49,'Sm','Isolated galaxy',NULL,NULL,NULL,1,225.288667,44.69817,0.049,NULL,59994393550,937412399,14647068,14.2),(125939,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125939,29.35,NULL,7.41,57099,NULL,NULL,NULL,'UGC 09660',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125940,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125940,36.92,0.27,242,57100,70,NULL,NULL,'2MASX J15010949+2212576',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.08',0.23,NULL,NULL,NULL,NULL,NULL,1,225.2894583,22.21611,0.081,NULL,59528247382,930128865,14533263,17.08),(125941,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125941,37.75,0.46,355,57101,70,NULL,NULL,'2MASX J15011062+4759125',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000143,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,225.294417,47.98694,0.065,NULL,59940818788,936575293,14633988,18),(125942,'SBF','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125942,32.5,0.12,31.6,57102,74.4,NULL,NULL,'NGC 5813',NULL,'2013AJ....146...86T',2013,1,4.2,NULL,'G',0.000017,NULL,'11.45',3,'E1-2           LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,225.296791667,1.70197,0.149,NULL,59328087997,927001374,14484396,11.45),(125943,'SBF','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125943,32.53,0.18,32.1,57102,NULL,NULL,'Malmquist cor.','NGC 5813',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125944,'SBF','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125944,32.54,0.18,32.2,57102,NULL,NULL,'I','NGC 5813',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125945,'SBF','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125945,32.54,0.18,32.2,57102,NULL,NULL,NULL,'NGC 5813',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125946,'D-Sigma','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125946,32.22,0.4,27.7,57102,75,NULL,'Edat, raw','NGC 5813',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125947,'D-Sigma','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125947,32.37,0.4,29.7,57102,75,NULL,'Edat, cor','NGC 5813',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125948,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125948,30.83,0.55,14.7,57102,95,NULL,'de Vaucouleurs','NGC 5813',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125949,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125949,31.71,0.3,22,57102,95,NULL,'Weighted Mean','NGC 5813',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125950,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125950,31.96,NULL,24.7,57102,NULL,NULL,'LEDA [April 2006]','NGC 5813',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125951,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125951,32.54,0.46,32.2,57102,95,NULL,'Michard 1979a','NGC 5813',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125952,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125952,32.91,0.63,38.2,57102,95,NULL,'Michard 1979b, c','NGC 5813',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125953,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125953,33,0.81,39.8,57102,55,NULL,'Visvanathan & Sandage 1979','NGC 5813',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125954,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125954,32.32,0.41,29.1,57102,NULL,NULL,NULL,'NGC 5813',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125955,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125955,32.36,0.41,29.7,57102,NULL,NULL,'Malmquist cor.','NGC 5813',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125956,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125956,32.5,0.12,31.6,57102,74.4,NULL,NULL,'NGC 5813',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125957,'Tertiary','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125957,31.08,0.25,16.4,57102,95,NULL,NULL,'NGC 5813',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125958,'Tully est','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125958,32.27,0.8,28.5,57102,75,NULL,'B','NGC 5813',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125959,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125959,37.44,0.23,307,57103,70,NULL,NULL,'2MASX J15011134+3043260',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,225.297125,30.72381,0.025,NULL,60095328938,938989514,14671711,17.4),(125960,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125960,37.6,0.46,330,57104,70,NULL,NULL,'2MASX J15011169+4409205',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000165,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,225.2985417,44.15553,0.057,NULL,59993807125,937403236,14646925,18.2),(125961,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125961,37.76,0.46,356,57105,70,NULL,NULL,'2MASX J15011197+5448241',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000142,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.299667,54.80667,0,NULL,57579417656,899678400,14057475,17.3),(125962,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125962,37.91,0.16,381,57106,70,NULL,NULL,'2MASX J15011285+3216460',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,225.3035417,32.27931,0.017,NULL,60091826376,938934787,14670856,18.2),(125963,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125963,38.24,0.46,445,57107,70,NULL,NULL,'SDSS J150113.43+212858.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.306,21.48281,0.089,NULL,59541451117,930335173,14536487,18.6),(125964,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125964,32.91,0.4,38.2,57108,75,NULL,'B','UGC 09663',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000013,NULL,'14.9',1.3,'Im:',NULL,NULL,NULL,NULL,1,225.307083,52.59556,0.021,NULL,59932194987,936440546,14631883,14.9),(125965,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125965,33.68,0.54,54.5,57109,70,NULL,NULL,'AM 1458-364 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000117,NULL,'15.5',0.3,NULL,NULL,NULL,NULL,NULL,1,225.309667,-36.9385,0.241,NULL,47233387839,738021684,11531588,15.5),(125966,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125966,38.29,0.46,454,57110,70,NULL,NULL,'2MASX J15011461+0541099',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.3107083,5.68625,0.113,NULL,59336968664,927140135,14486564,17.7),(125967,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125967,37.72,0.46,349,57111,70,NULL,NULL,'2MASX J15011605+3034569',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,225.317083333,30.58267,0.029,NULL,60095296498,938989007,14671703,18),(125968,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125968,35.84,0.33,147,57112,70,NULL,NULL,'2MASX J15011770+0153039',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000087,NULL,'16.0g',0.29,'E0',NULL,NULL,NULL,NULL,1,225.323667,1.88461,0.137,NULL,59328106123,927001658,14484400,16),(125969,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125969,35.86,0.46,149,57113,70,NULL,NULL,'CGCG 105-092',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'15.7',0.36,NULL,NULL,NULL,NULL,NULL,1,225.325417,16.77794,0.029,NULL,59592049458,931125772,14548840,15.7),(125970,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125970,33.77,0.49,56.7,57114,75,NULL,'IR','UGC 09656',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.00004,NULL,'15.20',0.3,'S?',NULL,NULL,NULL,NULL,1,225.3330417,9.15097,0.069,NULL,59388516402,927945568,14499149,15.2),(125971,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125971,33.49,0.2,49.9,57115,74.4,NULL,NULL,'UGC 09656',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.00004,NULL,'15.20',0.3,'S?',NULL,NULL,NULL,NULL,1,225.3330417,9.15097,0.069,NULL,59388516402,927945568,14499149,15.2),(125972,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125972,37.91,0.13,382,57116,70,NULL,NULL,'SDSS J150121.14+472235.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,225.338083,47.37656,0.077,NULL,59983848807,937247637,14644494,18.6),(125973,'IRAS','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125973,34.98,0.8,99.1,57117,75,NULL,'MAT, I','ESO 328- G 003',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'13.16',0.3,'Sb:',NULL,NULL,NULL,NULL,1,225.338416667,-39.74917,0.141,NULL,47232158793,738002481,11531288,13.16),(125974,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125974,35.16,0.49,108,57117,75,NULL,'IR','ESO 328- G 003',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125975,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125975,35.16,0.43,108,57117,75,NULL,'MAT, I, raw','ESO 328- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125976,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125976,35.2,0.32,109,57117,85,NULL,'I, raw','ESO 328- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125977,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125977,35.22,0.4,111,57117,NULL,NULL,'mean','ESO 328- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125978,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125978,35.24,0.45,112,57117,NULL,NULL,'Malmquist cor.','ESO 328- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125979,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125979,35.27,0.32,113,57117,85,NULL,'I, inv','ESO 328- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125980,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125980,35.26,0.47,113,57117,NULL,NULL,'H','ESO 328- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125981,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125981,35.35,0.43,117,57117,NULL,NULL,NULL,'ESO 328- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125982,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125982,35.37,0.45,119,57117,NULL,NULL,'K','ESO 328- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125983,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125983,35.39,0.2,120,57117,74.4,NULL,NULL,'ESO 328- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125984,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125984,35.43,0.43,122,57117,75,NULL,'MAT, I, cor','ESO 328- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125985,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125985,35.45,0.43,123,57117,75,NULL,'MAT, I, inv','ESO 328- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125986,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125986,38.04,0.46,405,57118,70,NULL,NULL,'2MASX J15012116+2507015',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.338333,25.11717,0.101,NULL,59408186236,928252909,14503951,17.9),(125987,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125987,37.91,0.13,382,57119,70,NULL,NULL,'2MASX J15012125+4725565',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,225.338583333,47.43244,0.077,NULL,59983852453,937247694,14644495,17.3),(125988,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125988,37.91,0.16,381,57120,70,NULL,NULL,'2MASX J15012276+3209379',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000146,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,225.34475,32.16067,0.005,NULL,60091943672,938936619,14670884,17.6),(125989,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125989,37.5,0.46,316,57121,70,NULL,NULL,'2MASX J15012282+0915031',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'19.06',0.13,NULL,NULL,NULL,NULL,NULL,1,225.345167,9.25078,0.069,NULL,59377217050,927769016,14496390,19.06),(125990,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125990,37.4,0.46,303,57122,70,NULL,NULL,'2MASX J15012328+4200195',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000084,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.3469583,42.0055,0.033,NULL,59978937066,937170891,14643295,17.7),(125991,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125991,37.83,0.27,369,57123,70,NULL,NULL,'SDSS J150123.47+415001.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,225.347833,41.83369,0.037,NULL,59978907387,937170427,14643287,18.3),(125992,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125992,37.44,0.23,307,57124,70,NULL,NULL,'2MASX J15012445+3043489',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.52',0.14,NULL,NULL,NULL,NULL,NULL,1,225.351916667,30.73019,0.025,NULL,60095331225,938989550,14671711,18.52),(125993,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125993,37.15,0.46,269,57125,70,NULL,NULL,'2MASX J15012553+2232196',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.52',0.15,NULL,NULL,NULL,NULL,NULL,1,225.3564583,22.53875,0.085,NULL,59528820772,930137824,14533403,18.52),(125994,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125994,37.73,0.46,352,57126,70,NULL,NULL,'2MASX J15012563+2026196',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.42',0.12,NULL,NULL,NULL,NULL,NULL,1,225.357,20.43869,0.073,NULL,59541974564,930343352,14536614,18.42),(125995,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125995,38.56,0.46,516,57127,70,NULL,NULL,'2MASX J15012587+4513065',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,225.357917,45.21844,0.021,NULL,59995211396,937425178,14647268,17.6),(125996,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125996,37.74,0.27,353,57128,70,NULL,NULL,'2MASX J15012707+3120119',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,225.3627083,31.33661,0.021,NULL,60092400573,938943758,14670996,17.6),(125997,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125997,37.91,0.46,383,57129,70,NULL,NULL,'2MASX J15012724+5307576',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000184,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,225.363375,53.13272,0.021,NULL,59928927323,936389489,14631085,16.9),(125998,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125998,37.47,0.46,312,57130,70,NULL,NULL,'SDSS J150131.15+243655.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.3797917,24.6155,0.097,NULL,59525754533,930089914,14532654,18.3),(125999,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125999,38.21,0.46,438,57131,70,NULL,NULL,'2MASX J15013132+2536316',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,225.3805,25.60875,0.077,NULL,59894875241,935857425,14622772,18.1),(126000,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126000,31.91,0.4,24.1,57132,75,NULL,NULL,'UGC 09665',NULL,'2008Ap.....51..336K',2008,1,1.83,'HOLM 691B is a star.','G',0.0001,NULL,'14.2g',0.42,'Sbc',NULL,NULL,NULL,NULL,1,225.38525,48.31975,0.037,NULL,59940928654,936577010,14634015,14.2),(126001,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126001,32.62,0.43,33.5,57132,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09665',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126002,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126002,32.82,0.43,36.7,57132,75,NULL,'3.6 micron, color corrected','UGC 09665',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126003,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126003,32.9,0.49,38,57132,75,NULL,'IR','UGC 09665',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126004,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126004,32.9,0.47,38.1,57132,NULL,NULL,'H','UGC 09665',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126005,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126005,32.98,0.45,39.4,57132,NULL,NULL,'K','UGC 09665',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126006,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126006,33.02,0.4,40.1,57132,NULL,NULL,'mean','UGC 09665',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126007,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126007,33.05,0.46,40.7,57132,NULL,NULL,'J','UGC 09665',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126008,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126008,33.05,0.2,40.7,57132,74.4,NULL,NULL,'UGC 09665',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126009,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126009,36.3,0.46,182,57133,70,NULL,NULL,'2MASX J15013565+0156514',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000083,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,225.398583,1.94772,0.137,NULL,59328002914,927000045,14484375,16.9),(126010,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126010,36.78,0.46,227,57134,70,NULL,NULL,'2MASX J15013582+2352557',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.22',0.17,NULL,NULL,NULL,NULL,NULL,1,225.399291667,23.88222,0.105,NULL,59526262309,930097848,14532778,18.22),(126011,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126011,36.92,0.27,242,57135,70,NULL,NULL,'2MASX J15013613+2208446',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'16.45',0.23,NULL,NULL,NULL,NULL,NULL,1,225.400708333,22.14561,0.093,NULL,59528206270,930128222,14533253,16.45),(126012,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126012,37.74,0.27,353,57136,70,NULL,NULL,'2MASX J15013632+3119172',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,225.401291667,31.32156,0.021,NULL,60092517647,938945588,14671024,18.1),(126013,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126013,38.11,0.46,418,57137,70,NULL,NULL,'2MASX J15013633+2659537',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,225.401417,26.99828,0.081,NULL,60079583467,938743491,14667867,18),(126014,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126014,38.29,0.46,455,57138,70,NULL,NULL,'SDSS J150137.54+003726.6',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000071,NULL,'17.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,225.4064583,0.62406,0.177,NULL,59324313347,926942396,14483474,17.9),(126015,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126015,37.11,0.46,265,57139,70,NULL,NULL,'2MASX J15013907+3216292',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,225.412875,32.27486,0.017,NULL,60084684326,938823192,14669112,17.9),(126016,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126016,38.08,0.46,412,57140,70,NULL,NULL,'2MASX J15013968+3326562',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,225.415291667,33.44886,0.021,NULL,60126515721,939476808,14679325,16.7),(126017,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126017,37.63,0.46,335,57141,70,NULL,NULL,'2MASXi J1501397-022422',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000175,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.41575,-2.40639,0.229,NULL,46442556560,725664946,11338514,17.9),(126018,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126018,37.31,0.46,290,57142,70,NULL,NULL,'2MASX J15014074+5542540',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000161,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.4199583,55.71503,0.017,NULL,57713979852,901780935,14090327,17.4),(126019,'D-Sigma','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126019,32.75,0.4,35.5,57143,75,NULL,'Edat, raw','ESO 581- G 016',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000143,NULL,'13.68',0.6,'E6:',NULL,NULL,NULL,NULL,1,225.424375,-19.29003,0.337,NULL,46646017986,728844031,11388187,13.68),(126020,'D-Sigma','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126020,32.86,0.4,37.3,57143,75,NULL,'Edat, cor','ESO 581- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126021,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126021,32.66,0.48,34,57143,70,NULL,NULL,'ESO 581- G 016',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126022,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126022,33.69,0.45,54.8,57143,NULL,NULL,'K','ESO 581- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126023,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126023,33.88,0.4,59.7,57143,NULL,NULL,'mean','ESO 581- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126024,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126024,37.95,0.33,390,57144,70,NULL,NULL,'2MASX J15014205+5231466',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,225.425125,52.52964,0.021,NULL,59931705921,936432905,14631764,17.4),(126025,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126025,37.91,0.16,381,57145,70,NULL,NULL,'2MASX J15014223+3213012',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,225.426083,32.217,0.017,NULL,60084554998,938821171,14669080,17.8),(126026,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126026,37.51,0.46,318,57146,70,NULL,NULL,'2MASX J15014264+2539317',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,225.42775,25.65883,0.065,NULL,59894887929,935857623,14622775,17.3),(126027,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126027,37.91,0.46,382,57147,70,NULL,NULL,'2MASX J15014266+3359162',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000189,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,225.427875,33.98792,0.013,NULL,60127340231,939489691,14679526,17.3),(126028,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126028,35.88,0.46,150,57148,70,NULL,NULL,'2MASX J15014311+0057444',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00008,NULL,'16.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.429583,0.96231,0.169,NULL,59324682355,926948161,14483565,16.9),(126029,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126029,37.25,0.46,282,57149,70,NULL,NULL,'2MASX J15014337+2007126',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.60',0.14,NULL,NULL,NULL,NULL,NULL,1,225.4307083,20.12028,0.077,NULL,59538619954,930290936,14535795,18.6),(126030,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126030,38.2,0.46,437,57150,70,NULL,NULL,'2MASX J15014342+1519323',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.431,15.32556,0.037,NULL,59577442968,930897546,14545274,18.1),(126031,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126031,35.2,0.46,110,57151,70,NULL,NULL,'CGCG 105-094',NULL,'2015arXiv151105856S',2015,1,0.45,'IRAS F14591+1603 is the large proper-motion star HD 132950 (V=9.2).','G',NULL,NULL,'15.7',0.4,NULL,NULL,NULL,NULL,NULL,1,225.4329583,15.86469,0.021,NULL,59591318683,931114354,14548661,15.7),(126032,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126032,37.8,0.46,362,57152,70,NULL,NULL,'SDSS J150144.71+193948.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.4362917,19.6635,0.069,NULL,59539077085,930298079,14535907,18.3),(126033,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126033,34.97,0.75,98.8,57153,70,NULL,NULL,'LCRS B145907.9-034331',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.83',0.4,NULL,NULL,NULL,NULL,NULL,1,225.436791667,-3.92172,0.257,NULL,46455928648,725873885,11341779,15.83),(126034,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126034,37.91,0.13,382,57154,70,NULL,NULL,'2MASX J15014501+4708155',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000133,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.4374583,47.13767,0.077,NULL,59984020341,937250317,14644536,18.2),(126035,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126035,37.74,0.27,353,57155,70,NULL,NULL,'2MASX J15014522+3117232',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.42',0.11,NULL,NULL,NULL,NULL,NULL,1,225.438417,31.28989,0.017,NULL,60092517060,938945579,14671024,18.42),(126036,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126036,36.27,0.46,180,57156,70,NULL,NULL,'2MASX J15014521+0000311',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000114,NULL,'15.4g',0.52,'E0',NULL,NULL,NULL,NULL,1,225.4385,0.00847,0.137,NULL,56371558438,880805600,13762587,15.4),(126037,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126037,36.7,0.46,218,57157,70,NULL,NULL,'2MASX J15014524+2855337',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00017,NULL,'18.06',0.17,'E',NULL,NULL,NULL,NULL,1,225.438583,28.92608,0.033,NULL,60080568636,938758884,14668107,18.06),(126038,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126038,37.75,0.46,355,57158,70,NULL,NULL,'2MASX J15014536+4644385',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.4389583,46.74386,0.037,NULL,59991316132,937364314,14646317,18.1),(126039,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126039,37.62,0.46,334,57159,70,NULL,NULL,'SDSS J150149.52+574723.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000064,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,225.456375,57.78992,0.009,NULL,57730298729,902035917,14094311,17.7),(126040,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126040,37.95,0.33,390,57160,70,NULL,NULL,'2MASX J15015014+5229056',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000146,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,225.458875,52.48483,0.025,NULL,59932295202,936442112,14631908,17.4),(126041,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126041,36.65,0.46,213,57161,70,NULL,NULL,'2MASX J15015016+0659153',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,225.459125,6.98761,0.053,NULL,59388082317,927938786,14499043,16.4),(126042,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126042,36.19,0.46,173,57162,70,NULL,NULL,'2MASX J15015110+0931033',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'18.04',0.24,NULL,NULL,NULL,NULL,NULL,1,225.462875,9.51764,0.057,NULL,59377407153,927771986,14496437,18.04),(126043,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126043,35.83,0.46,147,57163,70,NULL,NULL,'2MASX J15015170+0943333',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.70',0.28,NULL,NULL,NULL,NULL,NULL,1,225.465375,9.72594,0.061,NULL,59377348627,927771072,14496423,17.7),(126044,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126044,37.68,0.46,344,57164,70,NULL,NULL,'SDSS J150151.99+263934.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.466667,26.6595,0.101,NULL,60079683822,938745059,14667891,18.2),(126045,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126045,36.66,0.46,215,57165,70,NULL,NULL,'2MASX J15015229+1742283',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000153,NULL,'16.66',0.38,NULL,NULL,NULL,NULL,NULL,1,225.467917,17.70783,0.049,NULL,59589095500,931079617,14548119,16.66),(126046,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126046,37.44,0.23,307,57166,70,NULL,NULL,'2MASX J15015295+3048132',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.73',0.14,NULL,NULL,NULL,NULL,NULL,1,225.4707083,30.80378,0.033,NULL,60095314298,938989285,14671707,18.73),(126047,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126047,37.75,0.46,354,57167,70,NULL,NULL,'2MASX J15015349+3036172',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,225.472875,30.60481,0.025,NULL,60095406319,938990723,14671730,17.8),(126048,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126048,34.86,0.47,93.8,57168,NULL,NULL,'H','NGC 5827',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.00004,NULL,'13.91',0.9,'Sab pec:       LINER','Field galaxy',NULL,NULL,NULL,1,225.473875,25.96453,0.089,NULL,59894796422,935856194,14622753,13.91),(126049,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126049,34.9,0.45,95.4,57168,NULL,NULL,'K','NGC 5827',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126050,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126050,34.9,0.46,95.6,57168,NULL,NULL,'J','NGC 5827',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126051,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126051,34.98,0.4,99.1,57168,NULL,NULL,'mean','NGC 5827',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126052,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126052,38.1,0.46,417,57169,70,NULL,NULL,'2MASX J15015403+1132133',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,225.475167,11.53717,0.077,NULL,59375423357,927740989,14495952,17.1),(126053,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126053,37.44,0.23,307,57170,70,NULL,NULL,'2MASX J15015426+3045262',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.97',0.18,NULL,NULL,NULL,NULL,NULL,1,225.476125,30.75744,0.033,NULL,60095315669,938989307,14671707,17.97),(126054,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126054,38.22,0.46,440,57171,70,NULL,NULL,'2MASX J15015455+0330370',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00009,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,225.477333333,3.51017,0.125,NULL,59339593708,927181151,14487205,17.4),(126055,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126055,37.07,0.46,259,57172,70,NULL,NULL,'2MASX J15015667+4159088',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000144,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.48625,41.98569,0.033,NULL,59978918786,937170606,14643290,17.3),(126056,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126056,37.91,0.13,382,57173,70,NULL,NULL,'SDSS J150156.78+471441.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,225.486583,47.24486,0.077,NULL,59983820902,937247201,14644487,18.4),(126057,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126057,37.42,0.46,304,57174,70,NULL,NULL,'2MASX J15015864+2911138',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.18',0.15,'E',NULL,NULL,NULL,NULL,1,225.49425,29.18714,0.037,NULL,60094653326,938978958,14671546,18.18),(126058,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126058,36.18,0.33,172,57175,70,NULL,NULL,'2MASX J15015919+4722078',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000186,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,225.496583,47.36883,0.077,NULL,59983843225,937247550,14644492,17),(126059,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126059,38.14,0.46,424,57176,70,NULL,NULL,'SDSS J150159.58+034520.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000079,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,225.49825,3.75558,0.121,NULL,59339573114,927180829,14487200,18.5),(126060,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126060,37.98,0.46,394,57177,70,NULL,NULL,'2MASX J15020091+2801228',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.37',0.14,NULL,NULL,NULL,NULL,NULL,1,225.503833,28.02294,0.041,NULL,60083210233,938800159,14668752,18.37),(126061,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126061,37.38,0.46,299,57178,70,NULL,NULL,'2MASX J15020092+2322477',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.504083,23.38003,0.141,NULL,59529221801,930144090,14533501,17.9),(126062,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126062,37.45,0.33,309,57179,70,NULL,NULL,'2MASX J15020110+2859498',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000143,NULL,'18.48',0.14,NULL,NULL,NULL,NULL,NULL,1,225.5045,28.99722,0.033,NULL,60094434255,938975535,14671492,18.48),(126063,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126063,36.89,0.46,239,57180,70,NULL,NULL,'2MASX J15020164+0924283',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.19',0.22,NULL,NULL,NULL,NULL,NULL,1,225.50675,9.40786,0.053,NULL,59377429182,927772330,14496442,18.19),(126064,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126064,37.64,0.33,338,57181,70,NULL,NULL,'2MASX J15020231+2253377',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.50',0.18,NULL,NULL,NULL,NULL,NULL,1,225.50975,22.89381,0.109,NULL,59529626968,930150421,14533600,17.5),(126065,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126065,36.18,0.33,172,57182,70,NULL,NULL,'2MASX J15020255+4713488',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000183,NULL,'15.8g',0.25,'Sa',NULL,NULL,NULL,NULL,1,225.510625,47.23036,0.077,NULL,59984028683,937250448,14644538,15.8),(126066,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126066,37.17,0.17,272,57183,70,NULL,NULL,'CGCG 134-067',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00021,NULL,'15.2',0.6,NULL,NULL,NULL,NULL,NULL,1,225.51325,21.32694,0.085,NULL,59541423140,930334736,14536480,15.2),(126067,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126067,37.29,0.46,287,57184,70,NULL,NULL,'2MASX J15020415+0454080',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,225.517416667,4.90222,0.105,NULL,59337594658,927149916,14486717,16.6),(126068,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126068,37.17,0.17,272,57185,70,NULL,NULL,'2MASX J15020615+2116227',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.63',0.12,NULL,NULL,NULL,NULL,NULL,1,225.525667,21.27297,0.085,NULL,59541425912,930334779,14536480,18.63),(126069,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126069,37.38,0.46,299,57186,70,NULL,NULL,'2MASX J15020850+3726022',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000198,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,225.535625,37.43406,0.029,NULL,60120185436,939377897,14677779,17.1),(126070,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126070,36.18,0.46,172,57187,70,NULL,NULL,'2MASX J15020891+4409388',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000164,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,225.537041667,44.16097,0.041,NULL,59993800820,937403137,14646924,16.9),(126071,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126071,37.91,0.13,382,57188,70,NULL,NULL,'2MASX J15021001+4717119',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,225.541625,47.28658,0.077,NULL,59983813951,937247092,14644485,18),(126072,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126072,37.17,0.17,272,57189,70,NULL,NULL,'2MASX J15021016+2123437',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.31',0.15,NULL,NULL,NULL,NULL,NULL,1,225.542333,21.39547,0.089,NULL,59539532331,930305192,14536018,18.31),(126073,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126073,37.04,0.46,256,57190,70,NULL,NULL,'2MASX J15021049+2516188',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.70',0.18,NULL,NULL,NULL,NULL,NULL,1,225.543917,25.27181,0.097,NULL,59894677965,935854343,14622724,17.7),(126074,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126074,37.14,0.46,268,57191,70,NULL,NULL,'2MASX J15021107+5040373',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000175,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,225.546,50.67719,0.009,NULL,59942211485,936597054,14634328,16.5),(126075,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126075,36.92,0.27,242,57192,70,NULL,NULL,'SDSS J150212.68+220554.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.2g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.552875,22.09858,0.093,NULL,59528415505,930131492,14533304,18.2),(126076,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126076,35.9,0.46,151,57193,70,NULL,NULL,'2MASX J15021284+1628034',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,225.553583333,16.46772,0.025,NULL,59592019015,931125297,14548832,16.4),(126077,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126077,35.18,0.46,109,57194,70,NULL,NULL,'CGCG 164-054',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00011,NULL,'15.7g',0.31,'Sa',NULL,NULL,NULL,NULL,1,225.55775,32.12947,0.037,NULL,60084574433,938821475,14669085,15.7),(126078,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126078,36.91,0.46,241,57195,70,NULL,NULL,'SDSS J150219.87+530406.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,225.582833,53.06833,0.029,NULL,59928892449,936388944,14631077,17.8),(126079,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126079,37.52,0.46,319,57196,70,NULL,NULL,'LCRS B145944.3-023259',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00026,NULL,'17.13',0.14,NULL,NULL,NULL,NULL,NULL,1,225.5842917,-2.74558,0.237,NULL,46442211740,725659558,11338430,17.13),(126080,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126080,37.62,0.46,335,57197,70,NULL,NULL,'2MASX J15022040+2801578',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0',0.19,NULL,NULL,NULL,NULL,NULL,1,225.585083,28.03289,0.041,NULL,60083209132,938800142,14668752,18),(126081,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126081,36.55,0.46,205,57198,70,NULL,NULL,'2MASX J15022251+1156191',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000185,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,225.593916667,11.93872,0.073,NULL,59345294099,927270220,14488597,16.5),(126082,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126082,37.66,0.46,341,57199,70,NULL,NULL,'2MASX J15022258+1536262',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.39',0.15,NULL,NULL,NULL,NULL,NULL,1,225.594125,15.60722,0.029,NULL,59591197270,931112457,14548632,18.39),(126083,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126083,37.27,0.46,285,57200,70,NULL,NULL,'2MASX J15022317+4906453',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,225.596667,49.11261,0.013,NULL,59941146761,936580418,14634069,17.1),(126084,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126084,36.12,0.2,167,57201,74.4,NULL,NULL,'CGCG 076-137',NULL,'2013AJ....146...86T',2013,1,0.66,NULL,'G',0.000155,NULL,'15.4g',0.42,NULL,NULL,NULL,NULL,NULL,1,225.5992917,11.20636,0.061,NULL,59375198855,927737482,14495898,15.4),(126085,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126085,36.75,0.46,223,57202,70,NULL,NULL,'2MASX J15022413+0820551',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.84',0.12,NULL,NULL,NULL,NULL,NULL,1,225.6004583,8.34864,0.045,NULL,59390899335,927982802,14499731,18.84),(126086,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126086,35.77,0.33,142,57203,70,NULL,NULL,'CGCG 105-096',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000107,NULL,'15.7',0.35,NULL,NULL,NULL,NULL,NULL,1,225.6015417,16.19822,0.021,NULL,59591240597,931113134,14548642,15.7),(126087,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126087,37.26,0.46,283,57204,70,NULL,NULL,'2MASX J15022435+1152151',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,225.601583,11.87083,0.073,NULL,59345324146,927270689,14488604,17.9),(126088,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126088,37.8,0.46,363,57205,70,NULL,NULL,'2MASX J15022455-0122560',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00015,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,225.602417,-1.38211,0.165,NULL,46440078459,725626225,11337909,17),(126089,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126089,37.86,0.27,373,57206,70,NULL,NULL,'2MASX J15022456+3412416',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000171,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,225.6024583,34.21142,0.009,NULL,60126863074,939482235,14679409,16.7),(126090,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126090,37.64,0.33,338,57207,70,NULL,NULL,'SDSS J150224.80+225407.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.67',0.13,NULL,NULL,NULL,NULL,NULL,1,225.603375,22.90208,0.113,NULL,59529104988,930142265,14533472,18.67),(126091,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126091,37.91,0.46,382,57208,70,NULL,NULL,'2MASX J15022750+1944070',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.13',0.19,NULL,NULL,NULL,NULL,NULL,1,225.614583,19.73519,0.065,NULL,59538553720,930289901,14535779,18.13),(126092,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126092,37.39,0.46,301,57209,70,NULL,NULL,'2MASX J15022889+1835320',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,225.620333,18.59239,0.061,NULL,59581392200,930959253,14546238,17.9),(126093,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126093,38.24,0.46,445,57210,70,NULL,NULL,'SDSS J150230.80+294408.1',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,225.628333,29.73558,0.037,NULL,60094558983,938977484,14671523,NULL),(126094,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126094,37.87,0.11,375,57211,70,NULL,NULL,'2MASX J15023168+0732231',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000157,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.6322083,7.53989,0.037,NULL,59387653858,927932091,14498938,17.8),(126095,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126095,37.17,0.17,272,57212,70,NULL,NULL,'2MASX J15023182+2146340',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.27',0.18,NULL,NULL,NULL,NULL,NULL,1,225.632625,21.77611,0.093,NULL,59539712745,930308011,14536062,17.27),(126096,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126096,35.77,0.33,142,57213,70,NULL,NULL,'2MASX J15023247+1614352',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.64',0.25,NULL,NULL,NULL,NULL,NULL,1,225.635208333,16.24317,0.021,NULL,59591239436,931113116,14548642,17.64),(126097,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126097,36.7,0.33,218,57214,70,NULL,NULL,'2MASX J15023772+4532015',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000173,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,225.657,45.53364,0.045,NULL,59994771964,937418311,14647161,16.2),(126098,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126098,36.2,0.46,174,57215,70,NULL,NULL,'2MASX J15023773+2413562',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000099,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,225.657208333,24.23222,0.093,NULL,59526207025,930096984,14532765,16.8),(126099,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126099,36.7,0.33,218,57216,70,NULL,NULL,'2MASX J15023802+4527145',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.6585,45.45414,0.045,NULL,59994789620,937418587,14647165,17.9),(126100,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126100,37.17,0.17,272,57217,70,NULL,NULL,'2MASX J15023981+2114349',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,225.665833,21.24314,0.085,NULL,59539982046,930312219,14536128,17.8),(126101,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126101,36.44,0.46,194,57218,70,NULL,NULL,'2MASX J15024108-0106210',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000077,NULL,'16.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,225.6712083,-1.10592,0.157,NULL,46439970484,725624538,11337883,16.9),(126102,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126102,38.96,0.46,620,57219,70,NULL,NULL,'2MASX J15024185+1452451',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,225.674417,14.87925,0.033,NULL,59577738659,930902166,14545346,18.4),(126103,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126103,37.74,0.19,354,57220,70,NULL,NULL,'2MASX J15024182+2713412',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'15.83',0.15,NULL,NULL,NULL,NULL,NULL,1,225.674417,27.22808,0.073,NULL,60083108051,938798563,14668727,15.83),(126104,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126104,33.25,0.68,44.6,57221,NULL,NULL,NULL,'NGC 5829',NULL,'2009ApJS..182..474S',2009,1,1.43,NULL,'G',0.000023,NULL,'14.1g',1.02,'SA(s)c         HII','Pair member (points to parent)',NULL,NULL,NULL,1,225.6750417,23.33361,0.141,NULL,59529195569,930143680,14533495,14.1),(126105,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126105,33.29,0.2,45.5,57221,74.4,NULL,NULL,'NGC 5829',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126106,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126106,33.64,0.56,53.4,57221,NULL,NULL,'Malmquist cor.','NGC 5829',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126107,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126107,35.2,0.46,109,57222,70,NULL,NULL,'CGCG 193-013',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000093,NULL,'15.0g',0.58,'E0',NULL,NULL,NULL,NULL,1,225.678916667,37.94936,0.013,NULL,60120567854,939383872,14677873,15),(126108,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126108,35.58,0.33,131,57223,70,NULL,NULL,'IC 1085',NULL,'2015arXiv151105856S',2015,1,1.2,NULL,'G',0.000193,NULL,'15.0',1.2,NULL,NULL,NULL,NULL,NULL,1,225.6807083,17.25253,0.017,NULL,59589048840,931078888,14548107,15),(126109,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126109,38.12,0.23,421,57224,70,NULL,NULL,'2MASX J15024377+3559487',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.68225,35.99686,0,NULL,60127822479,939497226,14679644,18.1),(126110,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126110,37.91,0.13,382,57225,70,NULL,NULL,'2MASX J15024426+4722425',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.6845,47.37858,0.077,NULL,59984010581,937250165,14644533,17.4),(126111,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126111,37.17,0.17,272,57226,70,NULL,NULL,'2MASX J15024541+2122141',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.65',0.19,NULL,NULL,NULL,NULL,NULL,1,225.6892917,21.37067,0.089,NULL,59539990248,930312347,14536130,17.65),(126112,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126112,37.45,0.33,309,57227,70,NULL,NULL,'2MASX J15024611+2855493',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,225.6922917,28.93028,0.033,NULL,60080672342,938760505,14668132,17.8),(126113,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126113,37.26,0.46,283,57228,70,NULL,NULL,'LCRS B150010.3-023801',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000124,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,225.692917,-2.829,0.237,NULL,46442160613,725658759,11338418,18.1),(126114,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126114,38.13,0.46,423,57229,70,NULL,NULL,'SDSS J150246.53-011921.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000178,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,225.693917,-1.32269,0.193,NULL,46439878844,725623106,11337861,18.6),(126115,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126115,38.12,0.23,421,57230,70,NULL,NULL,'2MASX J15024831+3554158',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.7014583,35.9045,0,NULL,60127835778,939497434,14679647,17.8),(126116,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126116,37.99,0.46,396,57231,70,NULL,NULL,'SDSS J150249.57+242537.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000141,NULL,'18.6g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.706583333,24.42708,0.089,NULL,59408518060,928258094,14504032,18.6),(126117,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126117,36.43,0.46,193,57232,70,NULL,NULL,'2MASX J15024985+2321351',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000087,NULL,'17.00',0.2,'S0','Compact group member',NULL,NULL,NULL,1,225.70775,23.35975,0.141,NULL,59529189146,930143580,14533493,17),(126118,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126118,37.74,0.19,354,57233,70,NULL,NULL,'2MASX J15025007+2659253',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,225.7087083,26.99028,0.081,NULL,60079495203,938742112,14667845,17.8),(126119,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126119,37.87,0.11,375,57234,70,NULL,NULL,'2MASX J15025066+0805357',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000167,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,225.711167,8.09342,0.045,NULL,59390921559,927983149,14499736,17),(126120,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126120,37.87,0.11,375,57235,70,NULL,NULL,'2MASX J15025133+0808357',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,225.714125,8.14325,0.045,NULL,59390933700,927983339,14499739,17.2),(126121,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126121,37.39,0.46,301,57236,70,NULL,NULL,'SDSS J150252.30+300051.0',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.717958333,30.01417,0.029,NULL,60094220436,938972194,14671440,17.5),(126122,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126122,37.89,0.21,378,57237,70,NULL,NULL,'2MASX J15025342+0847357',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00018,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,225.7225,8.79311,0.053,NULL,59388556585,927946196,14499159,17.1),(126123,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126123,35.21,0.51,110,57238,70,NULL,NULL,'2MASX J15025374-4236395',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,225.724041667,-42.61094,0.377,NULL,47097233800,735894278,11498348,14.3),(126124,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126124,36.27,0.33,179,57239,70,NULL,NULL,'2MASX J15025512+5535389',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000162,NULL,'15.9g',0.41,'S0',NULL,NULL,NULL,NULL,1,225.729958333,55.59408,0.029,NULL,57714058842,901782169,14090346,15.9),(126125,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126125,33.44,NULL,48.8,57240,NULL,NULL,NULL,'FGC 1845',NULL,'2000BSAO...50....5K',2000,1,1.46,NULL,'G',0.00002,NULL,'16.3',0.11,'Sdm',NULL,NULL,NULL,NULL,1,225.73,-13.32833,0.401,NULL,46662083555,729095055,11392110,16.3),(126126,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126126,33.48,NULL,49.6,57240,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1845',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126127,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126127,33.48,NULL,49.8,57240,NULL,NULL,'Dipole + Quadrupole','FGC 1845',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126128,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126128,33.49,NULL,49.8,57240,NULL,NULL,'Dipole','FGC 1845',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126129,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126129,38.13,0.46,423,57241,70,NULL,NULL,'2MASX J15025523+5533409',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00015,NULL,'17.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,225.7302083,55.56131,0.029,NULL,57714059831,901782184,14090346,17.3),(126130,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126130,35.42,0.46,121,57242,70,NULL,NULL,'2MASX J15025541-0211107',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.00015,NULL,'15.7g',0.42,'E0',NULL,NULL,NULL,NULL,1,225.730875,-2.18633,0.213,NULL,46441769061,725652641,11338322,15.7),(126131,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126131,38.36,0.46,470,57243,70,NULL,NULL,'SDSS J150255.94+105638.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.733125,10.944,0.061,NULL,59375144492,927736632,14495884,18.5),(126132,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126132,37.86,0.27,373,57244,70,NULL,NULL,'2MASX J15025688+3408538',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00014,NULL,'16.1g',0.35,'E0',NULL,NULL,NULL,NULL,1,225.737125,34.14831,0.009,NULL,60126810679,939481416,14679397,16.1),(126133,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126133,36.03,0.46,160,57245,70,NULL,NULL,'2MASX J15025695+1108067',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000175,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,225.737166667,11.13533,0.061,NULL,59375324180,927739440,14495928,16.1),(126134,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126134,37.02,0.46,254,57246,70,NULL,NULL,'2MASX J15025730+2850373',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000397,NULL,'17.60',0.22,'E',NULL,NULL,NULL,NULL,1,225.738791667,28.84367,0.033,NULL,60080675781,938760559,14668133,17.6),(126135,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126135,37.99,0.46,397,57247,70,NULL,NULL,'2MASX J15025770+3401528',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,225.740375,34.03136,0.013,NULL,60126852105,939482064,14679407,17.3),(126136,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126136,38.06,0.46,409,57248,70,NULL,NULL,'2MASX J15025805+5359409',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000155,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.7417917,53.99483,0.005,NULL,59928354083,936380532,14630945,17.6),(126137,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126137,38.41,0.46,480,57249,70,NULL,NULL,'2MASX J15025883+5012330',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,225.7452917,50.20903,0,NULL,59944800183,936637502,14634960,18.4),(126138,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126138,38.44,0.46,488,57250,70,NULL,NULL,'SDSS J150259.16+215537.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.746541667,21.92719,0.093,NULL,59539609086,930306391,14536037,17.8),(126139,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126139,37.91,0.46,381,57251,70,NULL,NULL,'2MASX J15025912+3311498',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000175,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,225.746541667,33.19725,0.017,NULL,60115065116,939297892,14676529,17.5),(126140,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126140,32.25,0.5,28.2,57252,70,NULL,NULL,'MCG -02-38-030',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000017,NULL,'14.54',0.4,'Sa? sp',NULL,NULL,NULL,NULL,1,225.750833,-13.28267,0.373,NULL,46662085028,729095078,11392110,14.54),(126141,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126141,31.45,0.47,19.5,57252,NULL,NULL,'H','MCG -02-38-030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126142,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126142,31.63,0.45,21.1,57252,NULL,NULL,'K','MCG -02-38-030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126143,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126143,31.67,0.46,21.5,57252,NULL,NULL,'J','MCG -02-38-030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126144,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126144,32.69,0.4,34.5,57252,NULL,NULL,'mean','MCG -02-38-030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126145,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126145,38.12,0.23,421,57253,70,NULL,NULL,'2MASX J15030132+3553188',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,225.755458333,35.88858,0,NULL,60127831853,939497372,14679646,17.3),(126146,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126146,37.17,0.17,272,57254,70,NULL,NULL,'2MASX J15030146+2130431',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'16.58',0.23,NULL,NULL,NULL,NULL,NULL,1,225.7562083,21.51189,0.089,NULL,59539547961,930305436,14536022,16.58),(126147,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126147,38.17,0.33,431,57255,70,NULL,NULL,'SDSS J150302.12+093212.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.758833,9.53667,0.061,NULL,59377271819,927769872,14496404,18),(126148,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126148,37.87,0.11,375,57256,70,NULL,NULL,'2MASX J15030236+0732317',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,225.759875,7.54214,0.033,NULL,59387464344,927929130,14498892,16.8),(126149,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126149,38.17,0.33,431,57257,70,NULL,NULL,'SDSS J150304.00+093024.6',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000199,NULL,'16.5g',0.37,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.7667083,9.50686,0.061,NULL,59377277774,927769965,14496405,16.5),(126150,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126150,37.82,0.46,367,57258,70,NULL,NULL,'2MASX J15030574+2856191',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.7739583,28.93872,0.033,NULL,60080682897,938760670,14668135,17.9),(126151,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126151,37.8,0.46,363,57259,70,NULL,NULL,'2MASX J15030600+2336061',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,225.775,23.60167,0.121,NULL,59528996339,930140567,14533446,17.2),(126152,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126152,37.56,0.46,326,57260,70,NULL,NULL,'2MASX J15030659+5908168',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000077,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,225.7775417,59.13797,0.021,NULL,57719107972,901861062,14091579,16.7),(126153,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126153,36.89,0.33,239,57261,70,NULL,NULL,'2MASX J15030670+0725416',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,225.777917,7.42822,0.037,NULL,59387459179,927929049,14498891,17.1),(126154,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126154,38.24,0.46,445,57262,70,NULL,NULL,'2MASX J15030740+0954206',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'19.32',0.14,NULL,NULL,NULL,NULL,NULL,1,225.781,9.90572,0.037,NULL,59377513379,927773646,14496463,19.32),(126155,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126155,36.94,0.46,245,57263,70,NULL,NULL,'2MASX J15030863+0859446',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.76',0.15,NULL,NULL,NULL,NULL,NULL,1,225.786083,8.99572,0.053,NULL,59388638734,927947480,14499179,18.76),(126156,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126156,37.74,0.19,354,57264,70,NULL,NULL,'2MASX J15030925+2713271',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.51',0.15,NULL,NULL,NULL,NULL,NULL,1,225.788583,27.22417,0.065,NULL,60082925856,938795716,14668683,18.51),(126157,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126157,35.73,0.54,140,57265,70,NULL,NULL,'2MASX J15030951-4120438',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000117,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,225.789666667,-41.34553,0.321,NULL,47094248611,735847634,11497619,14.6),(126158,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126158,37.87,0.11,375,57266,70,NULL,NULL,'2MASX J15031033+0756386',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000171,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,225.793125,7.94406,0.045,NULL,59390851424,927982053,14499719,17.6),(126159,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126159,35.78,0.49,143,57267,75,NULL,'IR','CGCG 134-071',NULL,'2011yCatp016004901K',2011,1,1.15,NULL,'G',0.00002,NULL,'16.20',0.12,'Sc',NULL,NULL,NULL,NULL,1,225.794625,21.53942,0.089,NULL,59539551288,930305488,14536023,16.2),(126160,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126160,35.8,NULL,145,57267,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 134-071',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126161,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126161,35.83,NULL,146,57267,NULL,NULL,'Dipole + Quadrupole','CGCG 134-071',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126162,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126162,35.84,NULL,147,57267,NULL,NULL,'Dipole','CGCG 134-071',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126163,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126163,37.87,0.11,375,57268,70,NULL,NULL,'2MASX J15031086+0807196',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000175,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,225.79525,8.12203,0.045,NULL,59388871222,927951112,14499236,16.9),(126164,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126164,37.09,0.46,262,57269,70,NULL,NULL,'2MASX J15031149+2652291',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.68',0.24,NULL,NULL,NULL,NULL,NULL,1,225.797917,26.87475,0.089,NULL,60079521864,938742529,14667852,17.68),(126165,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126165,38.17,0.46,430,57270,70,NULL,NULL,'2MASX J15031352+0042106',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000074,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,225.8062917,0.70294,0.165,NULL,56372344162,880817877,13762779,18.2),(126166,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126166,36.79,0.46,228,57271,70,NULL,NULL,'2MASX J15031377+4853559',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000172,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,225.807375,48.89886,0.017,NULL,59941232891,936581763,14634090,16.4),(126167,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126167,36.7,0.64,218,57272,70,NULL,NULL,'2MASX J15031406-0422087',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,225.808583,-4.36917,0.237,NULL,46455616285,725869004,11341703,15.7),(126168,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126168,37.89,0.21,378,57273,70,NULL,NULL,'SDSS J150314.06+090112.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000169,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.808625,9.02006,0.053,NULL,59388638094,927947470,14499179,18.5),(126169,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126169,37.95,0.46,389,57274,70,NULL,NULL,'2MASX J15031457+0405566',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000082,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.810667,4.09906,0.109,NULL,59339291734,927176433,14487131,17.7),(126170,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126170,37.96,0.46,391,57275,70,NULL,NULL,'2MASX J15031457+0718596',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.81075,7.31661,0.037,NULL,59387445397,927928834,14498888,17.6),(126171,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126171,37.87,0.11,375,57276,70,NULL,NULL,'SDSS J150314.59+080520.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000165,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.810833,8.08903,0.045,NULL,59390918752,927983105,14499736,18.2),(126172,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126172,37.47,0.33,312,57277,70,NULL,NULL,'2MASX J15031516+0503376',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,225.813125,5.06047,0.105,NULL,59329891531,927029555,14484836,17.5),(126173,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126173,37.33,0.46,292,57278,70,NULL,NULL,'2MASX J15031519+3608520',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000214,NULL,'15.5g',0.47,NULL,NULL,NULL,NULL,NULL,1,225.813125,36.14772,0,NULL,60127916851,939498700,14679667,15.5),(126174,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126174,37.87,0.11,375,57279,70,NULL,NULL,'2MASX J15031619+0800456',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,225.817417,8.01275,0.045,NULL,59390840812,927981887,14499716,17.6),(126175,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126175,37.92,0.46,384,57280,70,NULL,NULL,'2MASX J15031686+5305069',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,225.820167,53.08542,0.017,NULL,59928962957,936390046,14631094,17.6),(126176,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126176,35.58,0.33,131,57281,70,NULL,NULL,'2MASX J15031714+1709177',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.58',0.23,NULL,NULL,NULL,NULL,NULL,1,225.8215,17.15492,0.017,NULL,59591942453,931124100,14548814,16.58),(126177,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126177,35.97,0.46,157,57282,70,NULL,NULL,'2MASX J15031736+3108132',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.17',0.24,NULL,NULL,NULL,NULL,NULL,1,225.822417,31.13703,0.037,NULL,60092555769,938946183,14671034,17.17),(126178,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126178,37.27,0.46,284,57283,70,NULL,NULL,'2MASX J15031780+4350195',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00015,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,225.824167,43.83864,0.037,NULL,59980073051,937188641,14643572,17.3),(126179,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126179,37.87,0.11,375,57284,70,NULL,NULL,'2MASX J15031780+0737206',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.8242917,7.62256,0.033,NULL,59387473881,927929279,14498894,17.7),(126180,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126180,37.87,0.11,375,57285,70,NULL,NULL,'2MASX J15031794+0759526',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000157,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,225.824917,7.99797,0.045,NULL,59390839920,927981873,14499716,18.5),(126181,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126181,37.47,0.33,312,57286,70,NULL,NULL,'2MASX J15031875+0503518',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,225.828,5.06444,0.105,NULL,59329889644,927029525,14484836,16.9),(126182,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126182,38.39,0.46,476,57287,70,NULL,NULL,'SDSS J150319.22+104751.5',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000148,NULL,'18.9g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.830083333,10.79764,0.085,NULL,59375145016,927736640,14495885,18.9),(126183,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126183,37.86,0.27,373,57288,70,NULL,NULL,'SDSS J150319.24+341019.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,225.8302083,34.17222,0.009,NULL,60126885105,939482579,14679415,18.2),(126184,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126184,36.68,0.46,216,57289,70,NULL,NULL,'2MASX J15031996+5744089',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000078,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,225.833333,57.73589,0.005,NULL,57729756320,902027442,14094178,17.3),(126185,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126185,35.92,0.46,153,57290,70,NULL,NULL,'SDSS J150320.19+091121.4',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'16.74',0.18,NULL,NULL,NULL,NULL,NULL,1,225.834167,9.18931,0.053,NULL,59388652906,927947701,14499182,16.74),(126186,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126186,36.19,0.46,173,57291,70,NULL,NULL,'2MASX J15032035+0708236',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,225.83475,7.14008,0.065,NULL,59385688499,927901382,14498459,17),(126187,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126187,37.74,0.19,354,57292,70,NULL,NULL,'2MASX J15032094+2706561',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,225.83725,27.11558,0.073,NULL,60082919708,938795620,14668681,NULL),(126188,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126188,36.89,0.33,239,57293,70,NULL,NULL,'2MASX J15032136+0734436',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.839,7.57894,0.033,NULL,59387474377,927929287,14498895,17.3),(126189,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126189,34.83,0.2,92.5,57294,74.4,NULL,NULL,'UGC 09675',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000033,NULL,'14.60',0.9,'SB?',NULL,NULL,NULL,NULL,1,225.8422083,10.65594,0.077,NULL,59378040309,927781879,14496591,14.6),(126190,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126190,37.74,0.19,354,57295,70,NULL,NULL,'2MASX J15032244+2709181',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.42',0.15,NULL,NULL,NULL,NULL,NULL,1,225.843417,27.15497,0.073,NULL,60082921306,938795645,14668681,18.42),(126191,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126191,38.12,0.23,421,57296,70,NULL,NULL,'2MASX J15032239+3556240',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000158,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,225.8435417,35.94,0,NULL,60127804939,939496952,14679639,17.1),(126192,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126192,36.92,0.46,243,57297,70,NULL,NULL,'SDSS J150323.10+225159.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.8462917,22.86664,0.113,NULL,59527991749,930124871,14533201,18.2),(126193,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126193,35.31,0.46,115,57298,70,NULL,NULL,'2MASX J15032330+0542049',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'16.36',0.41,NULL,NULL,NULL,NULL,NULL,1,225.847041667,5.70125,0.085,NULL,59330432258,927038004,14484968,16.36),(126194,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126194,37.75,0.27,356,57299,70,NULL,NULL,'2MASX J15032330+0706476',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000204,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,225.8472083,7.11317,0.065,NULL,59385686951,927901358,14498458,16.9),(126195,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126195,36.99,0.46,250,57300,70,NULL,NULL,'2MASX J15032412+2831061',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.37',0.16,NULL,NULL,NULL,NULL,NULL,1,225.850417,28.51844,0.017,NULL,60080720155,938761252,14668144,18.37),(126196,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126196,37.16,0.46,271,57301,70,NULL,NULL,'2MASX J15032408+4112441',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,225.850583,41.21236,0.029,NULL,59971013053,937047078,14641360,17.6),(126197,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126197,37.81,0.46,365,57302,70,NULL,NULL,'2MASX J15032414+3212153',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000189,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,225.850625,32.20439,0.041,NULL,60084538368,938820912,14669076,16.6),(126198,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126198,36.96,0.33,246,57303,70,NULL,NULL,'2MASX J15032415+3448543',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000172,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,225.85075,34.81508,0.005,NULL,60128535236,939508363,14679818,16.3),(126199,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126199,37.54,0.46,322,57304,70,NULL,NULL,'2MASX J15032424+1131136',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000191,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,225.851125,11.52053,0.077,NULL,59345654334,927275848,14488685,16.6),(126200,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126200,37.2,0.27,276,57305,70,NULL,NULL,'2MASX J15032475+2523201',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.28',0.19,NULL,NULL,NULL,NULL,NULL,1,225.853166667,25.38886,0.093,NULL,59894791240,935856113,14622751,16.28),(126201,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126201,36.89,0.46,239,57306,70,NULL,NULL,'2MASX J15032542+1835282',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.36',0.17,NULL,NULL,NULL,NULL,NULL,1,225.855875,18.59117,0.061,NULL,59581313996,930958031,14546219,18.36),(126202,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126202,37.96,0.46,391,57307,70,NULL,NULL,'SDSS J150325.95+095109.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000145,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.858166667,9.85264,0.037,NULL,59377502924,927773483,14496460,18.4),(126203,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126203,38.29,0.46,454,57308,70,NULL,NULL,'2MASX J15032606-0208403',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,225.858583,-2.14475,0.213,NULL,46441811158,725653299,11338332,17.6),(126204,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126204,37.2,0.27,276,57309,70,NULL,NULL,'2MASX J15032652+2523301',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000168,NULL,'17.48',0.12,NULL,NULL,NULL,NULL,NULL,1,225.860375,25.39153,0.093,NULL,59894791288,935856113,14622751,17.48),(126205,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126205,38.16,0.46,428,57310,70,NULL,NULL,'2MASX J15032658+3134563',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000177,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,225.8607917,31.58228,0.025,NULL,60084904260,938826629,14669166,17.3),(126206,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126206,37.89,0.21,378,57311,70,NULL,NULL,'2MASX J15032665+0851166',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.8609583,8.85461,0.053,NULL,59389133196,927955206,14499300,17.6),(126207,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126207,37.2,0.27,276,57312,70,NULL,NULL,'2MASX J15032711+2521570',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000174,NULL,'18.00',0.17,NULL,NULL,NULL,NULL,NULL,1,225.863,25.36569,0.093,NULL,59894790626,935856103,14622751,18),(126208,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126208,36.23,0.46,176,57313,70,NULL,NULL,'2MASX J15032728+3424543',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,225.863583333,34.41519,0.005,NULL,60126708595,939479821,14679372,16.9),(126209,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126209,37.87,0.46,375,57314,70,NULL,NULL,'2MASX J15032773+6131195',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000074,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,225.865458333,61.52217,0,NULL,57778094449,902782725,14105980,18),(126210,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126210,35.92,0.2,153,57315,74.4,NULL,NULL,'CGCG 076-140',NULL,'2013AJ....146...86T',2013,1,0.55,NULL,'G',0.000096,NULL,'15.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,225.866875,10.60011,0.077,NULL,59378030981,927781734,14496589,15.4),(126211,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126211,38.19,0.46,435,57316,70,NULL,NULL,'2MASX J15032814+3944401',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.8672917,39.74453,0.025,NULL,60100276555,939066821,14672919,17.7),(126212,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126212,37.75,0.27,356,57317,70,NULL,NULL,'2MASX J15032867+0705556',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,225.8694583,7.09889,0.065,NULL,59385693937,927901467,14498460,16.3),(126213,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126213,37.88,0.33,377,57318,70,NULL,NULL,'2MASX J15032897+4754055',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,225.870583,47.90142,0.037,NULL,59938957443,936546210,14633534,18.3),(126214,'IRAS','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126214,32.42,0.8,30.5,57319,75,NULL,'MAT, I','ESO 008- G 007',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000021,NULL,'14.2',1,'SB(s)m',NULL,NULL,NULL,NULL,1,225.870875,-82.79631,0.445,NULL,44074561868,688665029,10760391,14.2),(126215,'Tully est','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126215,32.47,0.8,31.2,57319,75,NULL,NULL,'ESO 008- G 007',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126216,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126216,32.34,0.32,29.4,57319,85,NULL,'I, inv','ESO 008- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126217,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126217,32.35,0.32,29.5,57319,85,NULL,'I, raw','ESO 008- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126218,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126218,32.56,0.43,32.5,57319,75,NULL,'MAT, I, raw','ESO 008- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126219,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126219,32.58,0.43,32.7,57319,75,NULL,'MAT, I, inv','ESO 008- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126220,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126220,32.58,0.4,32.8,57319,73,NULL,'opt','ESO 008- G 007',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126221,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126221,32.66,0.65,34.1,57319,NULL,NULL,NULL,'ESO 008- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126222,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126222,32.66,0.66,34.1,57319,NULL,NULL,'Malmquist cor.','ESO 008- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126223,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126223,32.71,0.2,34.8,57319,74.4,NULL,NULL,'ESO 008- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126224,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126224,32.73,0.43,35.2,57319,75,NULL,'MAT, I, cor','ESO 008- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126225,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126225,35.08,0.46,104,57320,70,NULL,NULL,'IC 1086',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00019,NULL,'15.4',0.25,NULL,NULL,NULL,NULL,NULL,1,225.8715417,17.11442,0.017,NULL,59591944879,931124138,14548814,15.4),(126226,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126226,37.75,0.27,356,57321,70,NULL,NULL,'2MASX J15033069+0705596',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.877917,7.10008,0.065,NULL,59385693758,927901464,14498460,17.8),(126227,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126227,37.14,0.13,268,57322,70,NULL,NULL,'2MASX J15033076+2844160',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.06',0.18,NULL,NULL,NULL,NULL,NULL,1,225.878417,28.73792,0.021,NULL,60080695772,938760871,14668138,18.06),(126228,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126228,37.42,0.46,304,57323,70,NULL,NULL,'SDSS J150330.98+192932.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.879125,19.49231,0.061,NULL,59536964734,930265073,14535391,18.5),(126229,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126229,38.17,0.23,430,57324,70,NULL,NULL,'2MASX J15033294+1015006',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'BrClG',NULL,NULL,NULL,NULL,1,225.887291667,10.25011,0.069,NULL,59377036454,927766194,14496346,NULL),(126230,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126230,38.33,0.46,464,57325,70,NULL,NULL,'2MASX J15033313+1537432',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.56',0.15,NULL,NULL,NULL,NULL,NULL,1,225.8879583,15.62861,0.029,NULL,59591174424,931112100,14548626,18.56),(126231,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126231,37.87,0.11,375,57326,70,NULL,NULL,'2MASX J15033391+0817186',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.8912917,8.28856,0.045,NULL,59388906952,927951671,14499244,17.5),(126232,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126232,36.13,0.46,168,57327,70,NULL,NULL,'2MASX J15033399+2248432',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.34',0.22,NULL,NULL,NULL,NULL,NULL,1,225.8915,22.81194,0.109,NULL,59528499336,930132802,14533325,17.34),(126233,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126233,34.98,0.52,99.1,57328,70,NULL,NULL,'2MASX J15033414-2206080',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.28',0.6,NULL,NULL,NULL,NULL,NULL,1,225.89225,-22.10247,0.389,NULL,46642163127,728783798,11387246,16.28),(126234,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126234,37.87,0.11,375,57329,70,NULL,NULL,'2MASX J15033451+0807484',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,225.8937917,8.13017,0.029,NULL,59388938932,927952170,14499252,16.6),(126235,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126235,37.88,0.33,377,57330,70,NULL,NULL,'2MASX J15033473+4753575',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000148,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,225.8945,47.89947,0.037,NULL,59938959376,936546240,14633535,18.4),(126236,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126236,38.17,0.23,430,57331,70,NULL,NULL,'SDSS J150335.23+101258.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.6g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.896833,10.21614,0.077,NULL,59377036600,927766196,14496346,18.6),(126237,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126237,36.59,0.56,208,57332,NULL,NULL,'Malmquist cor.','CGCG 164-057 NED01',NULL,'2009ApJS..182..474S',2009,1,1.03,NULL,'G',0.00003,NULL,'16.7g',0.19,'SBb',NULL,NULL,NULL,NULL,1,225.902833,28.47594,0.017,NULL,60080603762,938759433,14668116,16.7),(126238,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126238,36.79,0.51,228,57332,NULL,NULL,NULL,'CGCG 164-057 NED01',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126239,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126239,36.83,0.2,232,57332,74.4,NULL,NULL,'CGCG 164-057 NED01',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126240,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126240,38.24,0.46,444,57333,70,NULL,NULL,'2MASX J15033721+0210309',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000354,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.904958333,2.17528,0.137,NULL,59325983159,926968486,14483882,17.6),(126241,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126241,38.63,0.46,533,57334,70,NULL,NULL,'SDSS J150337.40+283318.3',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,225.905833,28.55508,0.021,NULL,60080718112,938761220,14668144,NULL),(126242,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126242,36.9,0.23,240,57335,70,NULL,NULL,'2MASX J15033770+2042581',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.35',0.2,'BrClG',NULL,NULL,NULL,NULL,1,225.907083,20.71622,0.081,NULL,59541845957,930341343,14536583,17.35),(126243,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126243,38.45,0.46,491,57336,70,NULL,NULL,'2MASX J15033892+5512510',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,225.91225,55.21411,0.013,NULL,57579550456,899680475,14057507,17.5),(126244,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126244,37.99,0.46,397,57337,70,NULL,NULL,'SDSS J150338.96+383856.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.912375,38.649,0.025,NULL,60117532837,939336450,14677132,18),(126245,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126245,34.21,NULL,69.4,57338,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09681',NULL,'2010Ap&SS.325..163P',2010,1,1.62,NULL,'G',0.000033,NULL,'16.0g',0.16,'Sd',NULL,NULL,NULL,NULL,1,225.9154583,42.12631,0.013,NULL,59982251013,937222672,14644104,16),(126246,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126246,34.22,NULL,69.8,57338,NULL,NULL,'Dipole + Quadrupole','UGC 09681',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126247,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126247,34.23,NULL,70.2,57338,NULL,NULL,'Dipole','UGC 09681',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126248,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126248,34.28,NULL,71.7,57338,NULL,NULL,NULL,'UGC 09681',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126249,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126249,34.59,0.55,82.7,57338,NULL,NULL,'Malmquist cor.','UGC 09681',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126250,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126250,34.68,0.53,86.4,57338,NULL,NULL,NULL,'UGC 09681',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126251,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126251,34.72,0.2,87.9,57338,74.4,NULL,NULL,'UGC 09681',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126252,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126252,36.81,0.35,230,57339,NULL,NULL,'Malmquist cor.','CGCG 164-057 NED03',NULL,'2009ApJS..182..474S',2009,1,0.73,NULL,'G',0.000027,NULL,'15.8g',0.32,'Sbc',NULL,NULL,NULL,NULL,1,225.9184583,28.47567,0.017,NULL,60081078665,938766854,14668232,15.8),(126253,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126253,36.94,0.33,245,57339,NULL,NULL,NULL,'CGCG 164-057 NED03',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126254,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126254,37.15,0.2,269,57339,74.4,NULL,NULL,'CGCG 164-057 NED03',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126255,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126255,36.11,0.49,167,57340,75,NULL,'IR','UGC 09677',NULL,'2011yCatp016004901K',2011,1,1.46,NULL,'G',0.000008,NULL,'16.0',0.27,'Sb',NULL,NULL,NULL,NULL,1,225.918833333,22.70064,0.109,NULL,59528510193,930132971,14533327,16),(126256,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126256,36.4,0.2,191,57340,74.4,NULL,NULL,'UGC 09677',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126257,'BL Lac Luminosity','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126257,40.63,NULL,1330,57341,70,NULL,'nucleus-to-host flux ratio, z > 0.38','WISE J150340.67-154114.0',NULL,'2006AJ....132....1S',2006,1,NULL,NULL,'QSO',NULL,NULL,'18.1',NULL,'candidate      BLLAC',NULL,NULL,NULL,'BL Lac',1,225.919167,-15.68719,0.473,NULL,46705071142,729766736,11402605,18.1),(126258,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126258,37.68,0.33,344,57342,70,NULL,NULL,'2MASX J15034141+5449599',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000169,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.922333,54.83336,0.017,NULL,57579641650,899681900,14057529,17.8),(126259,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126259,37.89,0.21,378,57343,70,NULL,NULL,'SDSS J150341.75+085207.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.9239583,8.86886,0.053,NULL,59389134847,927955231,14499300,18.5),(126260,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126260,37.68,0.33,344,57344,70,NULL,NULL,'2MASX J15034209+5448039',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00016,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.92525,54.80097,0.017,NULL,57579505673,899679776,14057496,17.2),(126261,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126261,35.76,0.4,142,57345,NULL,NULL,'mean','CGCG 135-002',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'GPair',0.000033,NULL,NULL,NULL,'S?',NULL,NULL,NULL,NULL,1,225.926625,26.10772,0.089,NULL,59895569714,935868276,14622941,NULL),(126262,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126262,35.79,0.47,144,57345,NULL,NULL,'H','CGCG 135-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126263,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126263,35.95,0.46,155,57345,NULL,NULL,'J','CGCG 135-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126264,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126264,35.99,0.45,158,57345,NULL,NULL,'K','CGCG 135-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126265,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126265,37.91,0.46,382,57346,70,NULL,NULL,'2MASX J15034248+2043480',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.03',0.14,NULL,NULL,NULL,NULL,NULL,1,225.927125,20.73006,0.081,NULL,59541845010,930341328,14536583,18.03),(126266,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126266,37.87,0.11,375,57347,70,NULL,NULL,'2MASX J15034287+0749374',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,225.9285417,7.82697,0.033,NULL,59390828058,927981688,14499713,16.9),(126267,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126267,36.32,0.46,184,57348,70,NULL,NULL,'2MASX J15034370+3622250',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000166,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,225.93225,36.37375,0,NULL,60127890345,939498286,14679660,16.3),(126268,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126268,37.89,0.21,378,57349,70,NULL,NULL,'2MASX J15034372+0853314',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,225.9322917,8.89189,0.053,NULL,59389147666,927955432,14499303,17.6),(126269,'SNIa','2016-12-15 15:15:31','2016-12-16 11:20:44','1','SN 2004bw','R',126269,34.74,0.06,88.7,57350,NULL,NULL,'MLCS2k2, R(V) = 1.8','CGCG 020-052',NULL,'2015Sci...347.1459K',2015,1,1.8,NULL,'G',0.000023,NULL,'15.00',1.2,'SAB(s)cd       HII',NULL,NULL,NULL,NULL,1,225.93875,-3.30258,0.269,NULL,46453907812,725842309,11341286,15),(126270,'SNIa','2016-12-15 15:15:31','2016-12-16 11:20:44','1','SN 2004bw','R',126270,34.79,0.06,90.8,57350,NULL,NULL,'MLCS2k2, R(V) = 3.1','CGCG 020-052',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126271,'SNIa','2016-12-15 15:15:31','2016-12-16 11:20:44','1','SN 2004bw',NULL,126271,34.9,0.17,93.6,57350,70,NULL,'SALT 2','CGCG 020-052',0.021198,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126272,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126272,35.45,0.49,123,57351,75,NULL,'IR','IC 4530',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.00016,NULL,'15.5',0.15,'S              LINER',NULL,NULL,NULL,NULL,1,225.938791667,26.10086,0.089,NULL,59895568682,935868260,14622941,15.5),(126273,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126273,35.89,0.2,151,57351,74.4,NULL,NULL,'IC 4530',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126274,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126274,38.88,0.33,596,57352,70,NULL,NULL,'2MASX J15034534+4444525',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.9389583,44.74789,0.049,NULL,59994028410,937406693,14646979,17.9),(126275,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126275,36.42,0.46,192,57353,70,NULL,NULL,'2MASX J15034671+0749444',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,225.944667,7.82897,0.033,NULL,59390828181,927981690,14499713,16.7),(126276,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126276,36.39,0.46,190,57354,70,NULL,NULL,'2MASX J15034687+1013484',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000181,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,225.945167,10.23,0.069,NULL,59377033295,927766145,14496346,16.5),(126277,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126277,37.87,0.11,375,57355,70,NULL,NULL,'2MASX J15034738+0739394',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.947375,7.66103,0.033,NULL,59387427767,927928558,14498883,17.5),(126278,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126278,38.16,0.46,428,57356,70,NULL,NULL,'2MASX J15034742+2034039',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.947583333,20.56789,0.081,NULL,59541875488,930341804,14536590,17.5),(126279,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126279,38.17,0.23,430,57357,70,NULL,NULL,'2MASX J15034788+1020584',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.92',0.15,NULL,NULL,NULL,NULL,NULL,1,225.9495,10.34964,0.069,NULL,59377171604,927768306,14496379,18.92),(126280,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126280,37.45,0.46,309,57358,70,NULL,NULL,'2MASX J15034830+5404029',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,225.951291667,54.06747,0.005,NULL,59659905927,932186030,14565406,17.2),(126281,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126281,37.77,0.46,358,57359,70,NULL,NULL,'2MASX J15034849+3044011',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.42',0.16,NULL,NULL,NULL,NULL,NULL,1,225.952083,30.73353,0.025,NULL,60095264265,938988504,14671695,18.42),(126282,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126282,38.88,0.33,596,57360,70,NULL,NULL,'2MASX J15034894+4437216',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,225.9537917,44.62278,0.029,NULL,59994017830,937406528,14646977,17.2),(126283,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126283,37.94,0.46,388,57361,70,NULL,NULL,'2MASX J15035006+0404256',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000089,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,225.958666667,4.07394,0.109,NULL,59339415225,927178362,14487161,17),(126284,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126284,36.15,0.46,170,57362,70,NULL,NULL,'2MASX J15035018+2012279',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.00',0.17,NULL,NULL,NULL,NULL,NULL,1,225.959083,20.20767,0.085,NULL,59538444614,930288197,14535753,18),(126285,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126285,37.56,0.46,326,57363,70,NULL,NULL,'2MASX J15035030+2134099',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.02',0.18,NULL,NULL,NULL,NULL,NULL,1,225.9595417,21.56947,0.097,NULL,59540194733,930315542,14536180,18.02),(126286,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126286,36.27,0.33,179,57364,70,NULL,NULL,'2MASX J15035031+5537379',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000165,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,225.9595417,55.62725,0.005,NULL,57714109931,901782967,14090358,16.3),(126287,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126287,37.38,0.46,300,57365,70,NULL,NULL,'2MASX J15035135+0810374',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.963875,8.17722,0.029,NULL,59388946997,927952296,14499254,17.4),(126288,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126288,37.42,0.46,305,57366,70,NULL,NULL,'2MASX J15035213+0358036',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000072,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.967333,3.96761,0.109,NULL,59339267583,927176055,14487125,17.8),(126289,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126289,37.43,0.46,306,57367,70,NULL,NULL,'2MASX J15035309+2252349',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000087,NULL,'17.48',0.11,NULL,NULL,NULL,NULL,NULL,1,225.971333,22.87633,0.113,NULL,59528015093,930125235,14533206,17.48),(126290,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126290,37.14,0.13,268,57368,70,NULL,NULL,'2MASX J15035333+2831306',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'18.08',0.18,NULL,NULL,NULL,NULL,NULL,1,225.972333,28.52511,0.017,NULL,60081193927,938768655,14668260,18.08),(126291,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126291,38.43,0.46,485,57369,70,NULL,NULL,'2MASX J15035340+5417009',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,225.972583333,54.28361,0,NULL,59659868416,932185444,14565397,18.3),(126292,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126292,31.87,NULL,23.7,57370,72,NULL,NULL,'KKR 15',NULL,'2014Ap.....57..457K',2014,1,0.5,'This object contains two SDSS emission line objects.','G',0.00002,NULL,'16.3',0.35,'BCD;Irr',NULL,NULL,NULL,NULL,1,225.982917,0.42917,0.129,NULL,56372265614,880816650,13762760,16.3),(126293,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126293,37.62,0.46,334,57371,70,NULL,NULL,'2MASX J15035620+2442146',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000172,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,225.984083,24.70417,0.101,NULL,59409111547,928267367,14504177,16.9),(126294,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126294,37.32,0.46,291,57372,70,NULL,NULL,'2MASX J15035631+2323038',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.984708333,23.38431,0.121,NULL,59529009435,930140772,14533449,17.4),(126295,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126295,35.01,0.46,100,57373,70,NULL,NULL,'CGCG 248-050',NULL,'2015arXiv151105856S',2015,1,1.05,NULL,'G',0.000153,NULL,'14.2g',0.82,'E0',NULL,NULL,NULL,NULL,1,225.9847917,48.55025,0.037,NULL,59939305431,936551647,14633619,14.2),(126296,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126296,37.77,0.46,358,57374,70,NULL,NULL,'2MASX J15035730-0220001',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000186,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,225.988583,-2.33333,0.213,NULL,46442251536,725660180,11338440,17.4),(126297,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126297,35.69,0.46,137,57375,70,NULL,NULL,'2MASX J15035744+1438026',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.28',0.37,NULL,NULL,NULL,NULL,NULL,1,225.989375,14.63417,0.049,NULL,59577642853,930900669,14545322,16.28),(126298,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126298,37.9,0.33,380,57376,70,NULL,NULL,'2MASX J15035878+0919144',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00018,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.994875,9.32067,0.053,NULL,59377269750,927769839,14496403,17.6),(126299,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126299,37.9,0.33,380,57377,70,NULL,NULL,'2MASX J15035911+0917254',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'19.03',0.14,NULL,NULL,NULL,NULL,NULL,1,225.996375,9.29033,0.053,NULL,59377255683,927769620,14496400,19.03),(126300,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126300,37.74,0.19,354,57378,70,NULL,NULL,'2MASX J15035913+2719016',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.9965,27.31717,0.073,NULL,60082941552,938795961,14668686,17.9),(126301,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126301,38.53,0.46,508,57379,70,NULL,NULL,'SDSS J150359.79+095738.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.999167,9.96061,0.077,NULL,59377497396,927773396,14496459,17.9),(126302,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126302,38.01,0.46,400,57380,70,NULL,NULL,'SDSS J150400.63+314457.3',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000187,NULL,'18.2g',0.1,NULL,NULL,NULL,NULL,NULL,1,226.002667,31.74928,0.033,NULL,60084883926,938826311,14669161,18.2),(126303,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126303,38.39,0.46,476,57381,70,NULL,NULL,'2MASX J15040075+2246098',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,226.00325,22.76942,0.109,NULL,59528494438,930132725,14533323,17.3),(126304,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126304,37.14,0.13,268,57382,70,NULL,NULL,'2MASX J15040084+2830446',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.30',0.16,NULL,NULL,NULL,NULL,NULL,1,226.0034583,28.51239,0.017,NULL,60081193271,938768644,14668260,18.3),(126305,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126305,38.1,0.21,417,57383,70,NULL,NULL,'2MASX J15040103+2240538',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,226.004333333,22.68161,0.109,NULL,59528487467,930132616,14533322,17.6),(126306,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126306,37.87,0.11,375,57384,70,NULL,NULL,'2MASX J15040165+0757054',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000179,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,226.007,7.95142,0.045,NULL,59388778881,927949670,14499213,17),(126307,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126307,32.99,0.43,39.7,57385,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-38-031',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.00015,NULL,'15',0.2,'S?',NULL,NULL,NULL,NULL,1,226.0110417,-10.73869,0.449,NULL,46493336853,726458388,11350912,15),(126308,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126308,37.3,0.46,288,57386,70,NULL,NULL,'2MASX J15040469+4816536',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,226.01925,48.28164,0.033,NULL,59939558169,936555596,14633681,17.4),(126309,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126309,36.44,0.46,194,57387,70,NULL,NULL,'SDSS J150405.77+163506.3',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'15.6g',0.4,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.024083,16.58511,0.033,NULL,59591041916,931110029,14548594,15.6),(126310,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126310,37.74,0.46,353,57388,70,NULL,NULL,'2MASX J15040586+2034228',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,226.0244583,20.57311,0.081,NULL,59541822832,930340981,14536577,NULL),(126311,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126311,38.26,0.46,449,57389,70,NULL,NULL,'2MASX J15040595+0111587',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000082,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,226.025,1.19961,0.137,NULL,56372013321,880812708,13762698,17.9),(126312,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126312,37.68,0.46,343,57390,70,NULL,NULL,'2MASX J15040657+5106323',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,226.02725,51.10911,0.013,NULL,59942259234,936597800,14634340,17.7),(126313,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126313,32.16,0.12,27,57391,74.4,NULL,NULL,'NGC 5831',NULL,'2013AJ....146...86T',2013,1,1.94,NULL,'G',0.000014,NULL,'12.4g',1.6,'E3             BLLAC','in a radial-velocity based grouping',NULL,NULL,NULL,1,226.029167,1.21992,0.137,NULL,56372021089,880812829,13762700,12.4),(126314,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126314,32.17,0.17,27.2,57391,NULL,NULL,'I','NGC 5831',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126315,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126315,32.17,0.17,27.2,57391,NULL,NULL,NULL,'NGC 5831',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126316,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126316,32.2,0.17,27.5,57391,NULL,NULL,'Malmquist cor.','NGC 5831',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126317,'D-Sigma','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126317,32.22,0.4,27.7,57391,75,NULL,'Edat, raw','NGC 5831',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126318,'D-Sigma','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126318,32.37,0.4,29.7,57391,75,NULL,'Edat, cor','NGC 5831',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126319,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126319,31.64,0.49,21.3,57391,95,NULL,'de Vaucouleurs','NGC 5831',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126320,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126320,31.7,0.39,21.9,57391,95,NULL,'Weighted Mean','NGC 5831',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126321,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126321,33.23,0.81,44.3,57391,55,NULL,'Visvanathan & Sandage 1979','NGC 5831',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126322,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126322,32.11,0.41,26.4,57391,NULL,NULL,NULL,'NGC 5831',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126323,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126323,32.16,0.12,27,57391,74.4,NULL,NULL,'NGC 5831',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126324,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126324,32.24,0.41,28.1,57391,NULL,NULL,'Malmquist cor.','NGC 5831',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126325,'Tertiary','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126325,31.08,0.25,16.4,57391,95,NULL,NULL,'NGC 5831',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126326,'Tully est','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126326,32.27,0.8,28.5,57391,75,NULL,'B','NGC 5831',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126327,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126327,32.17,0.4,27.1,57391,NULL,NULL,'mean','NGC 5831',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126328,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126328,32.53,0.45,32,57391,NULL,NULL,'K','NGC 5831',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126329,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126329,36.9,0.23,240,57392,70,NULL,NULL,'2MASX J15040695+2042408',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,226.028916667,20.71128,0.069,NULL,59539756407,930308693,14536073,16.4),(126330,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126330,37.14,0.13,268,57393,70,NULL,NULL,'CGCG 165-005',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000103,NULL,'15.5',0.3,NULL,'Group member',NULL,NULL,NULL,1,226.0302083,28.5195,0.017,NULL,60081194738,938768667,14668260,15.5),(126331,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126331,35.65,0.58,135,57394,70,NULL,NULL,'CGCG 020-053',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'15.5g',0.45,'E0',NULL,NULL,NULL,NULL,1,226.0305,-2.00372,0.209,NULL,46441940202,725655315,11338364,15.5),(126332,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126332,35.87,0.46,149,57394,70,NULL,NULL,'CGCG 020-053',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126333,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126333,37.82,0.46,366,57395,70,NULL,NULL,'2MASX J15040946+1556036',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.66',0.15,NULL,NULL,NULL,NULL,NULL,1,226.0395,15.93433,0.025,NULL,59591470305,931116723,14548698,18.66),(126334,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126334,36.04,0.46,162,57396,70,NULL,NULL,'2MASX J15041035-0135221',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,226.043125,-1.58944,0.193,NULL,46441694739,725651480,11338304,15.2),(126335,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126335,36.12,0.68,168,57396,70,NULL,NULL,'2MASX J15041035-0135221',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126336,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126336,37.14,0.13,268,57397,70,NULL,NULL,'2MASX J15041077+2830290',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.55',0.22,NULL,NULL,NULL,NULL,NULL,1,226.044833,28.50819,0.017,NULL,60081260935,938769702,14668276,17.55),(126337,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126337,37.87,0.11,375,57398,70,NULL,NULL,'2MASX J15041093+0758072',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.8g',0.33,NULL,NULL,NULL,NULL,NULL,1,226.045583,7.96869,0.045,NULL,59388786892,927949795,14499215,16.8),(126338,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126338,37.33,0.46,293,57399,70,NULL,NULL,'2MASX J15041095+4032256',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.0457917,40.54044,0.045,NULL,59970245790,937035090,14641173,17.7),(126339,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126339,37.24,0.46,281,57400,70,NULL,NULL,'2MASX J15041218+2928560',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000127,NULL,NULL,NULL,'Sa',NULL,NULL,NULL,NULL,1,226.05075,29.48228,0.029,NULL,60094907766,938982933,14671608,NULL),(126340,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126340,36.18,0.72,172,57401,70,NULL,NULL,'2MASX J15041345-2011360',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,226.0560417,-20.19339,0.397,NULL,46646219421,728847178,11388237,15.6),(126341,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126341,31.59,0.43,20.8,57402,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-38-020',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.000057,NULL,'14.28',0.9,'SAB(r)b?',NULL,NULL,NULL,NULL,1,226.0565,-7.22269,0.233,NULL,46495419359,726490927,11351420,14.28),(126342,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126342,37.74,0.46,354,57403,70,NULL,NULL,'2MASX J15041542+1555496',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'18.19',0.17,NULL,NULL,NULL,NULL,NULL,1,226.0642917,15.93044,0.025,NULL,59591469428,931116709,14548698,18.19),(126343,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126343,38.17,0.23,430,57404,70,NULL,NULL,'2MASX J15041545+1020222',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000155,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.0644583,10.33947,0.065,NULL,59377174257,927768347,14496380,17.7),(126344,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126344,37.14,0.13,268,57405,70,NULL,NULL,'2MASX J15041570+2828400',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.20',0.19,NULL,NULL,NULL,NULL,NULL,1,226.065375,28.47792,0.033,NULL,60081261132,938769705,14668276,18.2),(126345,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126345,35.84,0.49,147,57406,75,NULL,'IR','FGC 1853',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.00008,NULL,'16.9g',0.13,'Scd',NULL,NULL,NULL,NULL,1,226.06575,48.16469,0.037,NULL,59938871776,936544871,14633513,16.9),(126346,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126346,35.88,NULL,150,57406,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1853',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126347,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126347,35.9,NULL,151,57406,NULL,NULL,'Dipole + Quadrupole','FGC 1853',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126348,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126348,35.92,NULL,153,57406,NULL,NULL,NULL,'FGC 1853',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126349,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126349,35.93,NULL,153,57406,NULL,NULL,'Dipole','FGC 1853',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126350,'BCG','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126350,37.33,0.35,277,57407,60,NULL,'ABELL 2022, BCG','CGCG 165-006 NED01',0.0565,'1980ApJ...241..486H',1980,1,0.94,NULL,'G',0.000123,NULL,'16.58',0.42,NULL,'Brightest group member',NULL,NULL,NULL,1,226.066166667,28.49656,0.033,NULL,60081260751,938769699,14668276,16.58),(126351,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126351,36.82,0.14,231,57407,70,NULL,'ABELL 2022, BGC','CGCG 165-006 NED01',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126352,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126352,38.39,0.46,476,57408,70,NULL,NULL,'2MASX J15041586+4550396',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000187,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,226.066333,45.84442,0.045,NULL,59991699602,937370306,14646411,17.7),(126353,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126353,38.05,0.46,407,57409,70,NULL,NULL,'SDSS J150416.81-003915.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000065,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,226.070083,-0.65439,0.153,NULL,45366440870,708850638,11075791,18.4),(126354,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126354,37.14,0.13,268,57410,70,NULL,NULL,'CGCG 165-006 NED03',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.42',0.2,NULL,NULL,NULL,NULL,NULL,1,226.0764583,28.50717,0.033,NULL,60081260575,938769696,14668276,17.42),(126355,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126355,37.24,0.21,280,57411,70,NULL,NULL,'2MASX J15041944+2558510',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.06',0.14,NULL,NULL,NULL,NULL,NULL,1,226.081125,25.98078,0.089,NULL,59895681577,935870024,14622969,18.06),(126356,'BCG','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126356,37.33,0.35,277,57412,60,NULL,NULL,'ABELL 2022',0.0565,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,226.08225,28.42267,0.033,NULL,60081274779,938769918,14668279,NULL),(126357,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126357,36.82,0.14,231,57412,70,NULL,NULL,'ABELL 2022',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126358,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126358,38.13,0.46,423,57413,70,NULL,NULL,'SDSS J150420.43+403305.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000123,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,226.085125,40.55167,0.045,NULL,59970250896,937035170,14641174,18.2),(126359,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126359,37.69,0.33,345,57414,70,NULL,NULL,'2MASX J15042093+2127137',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.10',0.15,NULL,NULL,NULL,NULL,NULL,1,226.087167,21.45375,0.089,NULL,59540229805,930316090,14536188,18.1),(126360,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126360,37.99,0.46,396,57415,70,NULL,NULL,'2MASX J15042159+1609337',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.24',0.16,NULL,NULL,NULL,NULL,NULL,1,226.0900417,16.15925,0.029,NULL,59591608995,931118890,14548732,18.24),(126361,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126361,38.09,0.46,415,57416,70,NULL,NULL,'SDSS J150421.89+225931.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.09125,22.99222,0.117,NULL,59528130135,930127033,14533234,18.1),(126362,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126362,37.79,0.46,362,57417,70,NULL,NULL,'2MASX J15042218+4741116',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000192,NULL,'16.3g',0.32,'E0',NULL,NULL,NULL,NULL,1,226.092583333,47.68669,0.045,NULL,59938810087,936543907,14633498,16.3),(126363,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126363,37.14,0.13,268,57418,70,NULL,NULL,'2MASX J15042298+2814390',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.90',0.23,NULL,NULL,NULL,NULL,NULL,1,226.095791667,28.24422,0.041,NULL,60081066843,938766669,14668229,17.9),(126364,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126364,37.08,0.46,261,57419,70,NULL,NULL,'2MASX J15042396+4323516',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,226.099875,43.39758,0.021,NULL,59980416645,937194010,14643656,17.5),(126365,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126365,38.12,0.46,421,57420,70,NULL,NULL,'2MASX J15042504+3526509',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000178,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,226.10425,35.44758,0.033,NULL,60128143391,939502240,14679722,16.9),(126366,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126366,37.55,0.33,323,57421,70,NULL,NULL,'2MASX J15042534+0802361',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000144,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.1055417,8.04314,0.029,NULL,59388772955,927949577,14499212,17.5),(126367,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126367,38.17,0.33,430,57422,70,NULL,NULL,'SDSS J150426.12+350451.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.108833,35.08089,0.005,NULL,60128004479,939500069,14679688,17.9),(126368,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126368,36.2,0.46,173,57423,70,NULL,NULL,'IC 4531',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000189,NULL,'15.4g',0.45,NULL,NULL,NULL,NULL,NULL,1,226.110167,23.41494,0.117,NULL,59527982532,930124727,14533198,15.4),(126369,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126369,37.91,0.46,382,57424,70,NULL,NULL,'2MASX J15042704+4857564',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000176,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,226.112541667,48.96572,0,NULL,59941274908,936582420,14634100,17.3),(126370,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126370,36.56,0.46,206,57425,70,NULL,NULL,'2MASX J15042708+3743032',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000166,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,226.112875,37.7175,0.009,NULL,60119427351,939366052,14677594,16.5),(126371,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126371,32.93,NULL,38.5,57426,NULL,NULL,'Dipole','MCG -02-38-032',NULL,'2010Ap&SS.325..163P',2010,1,2.27,NULL,'G',0.000007,NULL,'15',0.28,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,226.1132083,-14.43983,0.409,NULL,46693600428,729587506,11399804,15),(126372,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126372,32.93,NULL,38.5,57426,NULL,NULL,'Dipole + Quadrupole','MCG -02-38-032',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126373,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126373,32.93,NULL,38.5,57426,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -02-38-032',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126374,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126374,33.38,0.43,47.3,57426,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-38-032',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126375,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126375,37.4,0.46,302,57427,70,NULL,NULL,'2MASX J15042833+2544010',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.11',0.12,NULL,NULL,NULL,NULL,NULL,1,226.1179583,25.73356,0.085,NULL,59895652105,935869564,14622961,18.11),(126376,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126376,37.87,0.11,375,57428,70,NULL,NULL,'2MASX J15042885+0823551',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,226.1202917,8.39853,0.053,NULL,59388922223,927951909,14499248,17),(126377,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126377,37.69,0.33,345,57429,70,NULL,NULL,'SDSS J150429.12+212738.9',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.1g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.121375,21.46083,0.089,NULL,59540227413,930316053,14536188,18.1),(126378,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126378,36.17,0.33,172,57430,70,NULL,NULL,'CGCG 105-105',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000083,NULL,'15.5',0.6,NULL,NULL,NULL,NULL,NULL,1,226.1225417,17.69228,0.029,NULL,59581647516,930963242,14546300,15.5),(126379,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126379,36.68,0.46,216,57431,70,NULL,NULL,'2MASX J15042946+2426140',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.41',0.22,NULL,NULL,NULL,NULL,NULL,1,226.12275,24.43728,0.101,NULL,59409056364,928266505,14504164,16.41),(126380,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126380,37.87,0.11,375,57432,70,NULL,NULL,'2MASX J15043005+0801251',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.1252917,8.02361,0.029,NULL,59388774670,927949604,14499212,17.2),(126381,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126381,32.29,NULL,28.7,57433,72,NULL,NULL,'UGC 09682',NULL,'2014Ap.....57..457K',2014,1,1.8,NULL,'G',0.000023,NULL,'14.50',0.6,'SB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,226.125625,-0.85133,0.149,NULL,45365979375,708843427,11075678,14.5),(126382,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126382,32.94,0.43,38.8,57433,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09682',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126383,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126383,36.38,0.2,189,57434,74.4,NULL,NULL,'IC 4533',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'14.68',0.7,'Sa',NULL,NULL,NULL,NULL,1,226.126417,27.79286,0.045,NULL,60081038185,938766221,14668222,14.68),(126384,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126384,36.58,0.46,207,57435,70,NULL,NULL,'2MASX J15043102+3749152',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.129417,37.82083,0.009,NULL,60119426059,939366032,14677594,17.3),(126385,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126385,36.78,0.46,227,57436,70,NULL,NULL,'2MASX J15043206+0544321',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.1337083,5.74211,0.085,NULL,59330499274,927039051,14484985,17.5),(126386,'SNIa','2016-12-15 15:15:31','2016-12-16 11:20:44','1','SN 2006bk',NULL,126386,34.72,0.37,87.3,57437,74.2,NULL,'SALT 2','CGCG 193-015',0.0065,'2010ApJ...716..712A',2010,1,0.99,NULL,'G',0.000113,NULL,'14.3g',0.85,'E?',NULL,NULL,NULL,NULL,1,226.136291667,35.96503,0,NULL,60128459349,939507177,14679799,14.3),(126387,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126387,36.02,0.33,160,57437,70,NULL,NULL,'CGCG 193-015',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126388,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126388,32.18,NULL,27.3,57438,72,NULL,NULL,'SDSS J150434.22-023513.0',NULL,'2014Ap.....57..457K',2014,1,0.63,NULL,'G',0.00001,NULL,'16.4g',0.46,'Ir',NULL,NULL,NULL,NULL,1,226.142625,-2.58697,0.245,NULL,46442468412,725663568,11338493,16.4),(126389,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126389,36.72,0.46,221,57439,70,NULL,NULL,'2MASX J15043448+2403420',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.30',0.25,NULL,NULL,NULL,NULL,NULL,1,226.143583,24.06175,0.105,NULL,59408601517,928259398,14504053,16.3),(126390,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126390,34.36,0.48,74.6,57440,70,NULL,NULL,'ESO 067- G 005',NULL,'2014MNRAS.445.2677S',2014,1,1,'1984MNRAS.210...69F has V = 5900 +- 200 km/s.','G',0.00015,NULL,'13.7R',0.7,NULL,NULL,NULL,NULL,NULL,1,226.145417,-72.61661,0.453,NULL,45030425470,703600397,10993756,13.7),(126391,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126391,37.14,0.13,268,57441,70,NULL,NULL,'2MASX J15043557+2829380',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.08',0.21,NULL,NULL,NULL,NULL,NULL,1,226.1482083,28.49394,0.033,NULL,60081268420,938769819,14668278,18.08),(126392,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126392,38.17,0.33,430,57442,70,NULL,NULL,'2MASX J15043676+3510170',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00019,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,226.153,35.17142,0.005,NULL,60128197882,939503091,14679735,17.2),(126393,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126393,35.97,0.46,156,57443,70,NULL,NULL,'2MASX J15043704+1026278',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000147,NULL,'16.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,226.154375,10.44106,0.065,NULL,59376971210,927765175,14496330,16),(126394,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126394,36.62,0.46,211,57444,70,NULL,NULL,'2MASX J15043789+0900418',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.97',0.14,NULL,NULL,NULL,NULL,NULL,1,226.1579583,9.01183,0.053,NULL,59389173698,927955839,14499309,18.97),(126395,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126395,36.17,0.33,172,57445,70,NULL,NULL,'2MASX J15043853+1745397',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,226.1604583,17.76108,0.029,NULL,59581657642,930963400,14546303,16.4),(126396,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126396,34.53,0.69,80.4,57446,100,NULL,'mid-IR','NGC 5837',NULL,'2013ApJ...771...88L',2013,1,1,NULL,'G',0.000107,NULL,'14.5P',0.6,'SB(s)b',NULL,NULL,NULL,NULL,1,226.169083333,12.63344,0.081,NULL,59568481337,930757520,14543086,14.5),(126397,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126397,35.01,0.2,100,57446,74.4,NULL,NULL,'NGC 5837',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126398,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126398,35.31,0.47,115,57446,NULL,NULL,'H','NGC 5837',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126399,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126399,35.42,0.45,122,57446,NULL,NULL,'K','NGC 5837',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126400,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126400,35.49,0.4,125,57446,NULL,NULL,'mean','NGC 5837',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126401,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126401,35.51,0.46,126,57446,NULL,NULL,'J','NGC 5837',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126402,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126402,37.05,0.46,257,57447,70,NULL,NULL,'2MASX J15044158+2456510',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000179,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,226.173417,24.94761,0.113,NULL,59409037968,928266218,14504159,16.6),(126403,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126403,36.96,0.33,246,57448,70,NULL,NULL,'2MASX J15044319+3449220',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000185,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,226.179875,34.82275,0.005,NULL,60128498542,939507789,14679809,16.2),(126404,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126404,36.6,0.33,209,57449,70,NULL,NULL,'2MASX J15044418-0021071',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000094,NULL,'16.3g',0.33,'E0',NULL,NULL,NULL,NULL,1,226.184083,-0.35197,0.153,NULL,45366341616,708849087,11075766,16.3),(126405,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126405,37.8,0.46,363,57450,70,NULL,NULL,'2MASX J15044485+0751128',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000179,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,226.1870417,7.85353,0.045,NULL,59388727998,927948874,14499201,16.7),(126406,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126406,37.05,0.46,257,57451,70,NULL,NULL,'2MASX J15044511-0000461',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000068,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.1880417,-0.01286,0.157,NULL,45366144747,708846011,11075718,17.2),(126407,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126407,36.21,0.46,175,57452,70,NULL,NULL,'CGCG 048-102',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',NULL,NULL,'15.6',0.4,NULL,NULL,NULL,NULL,NULL,1,226.189,6.33297,0.065,NULL,59386028876,927906701,14498542,15.6),(126408,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126408,36.95,0.41,245,57453,NULL,NULL,'Malmquist cor.','2MASX J15044627+2821140',NULL,'2009ApJS..182..474S',2009,1,0.52,NULL,'G',0.000027,NULL,'17.54',0.16,'Sb',NULL,NULL,NULL,NULL,1,226.192875,28.35397,0.041,NULL,60081304984,938770390,14668287,17.54),(126409,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126409,37.17,0.37,272,57453,NULL,NULL,NULL,'2MASX J15044627+2821140',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126410,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126410,37.21,0.2,277,57453,74.4,NULL,NULL,'2MASX J15044627+2821140',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126411,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126411,37.55,0.33,323,57454,70,NULL,NULL,'2MASX J15044640+0800148',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.1932917,8.00403,0.029,NULL,59388752465,927949257,14499207,17.6),(126412,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126412,36.93,0.23,243,57455,70,NULL,NULL,'SDSS J150447.06+162025.1',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.7g',0.32,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.196083333,16.34033,0.033,NULL,59591511630,931117369,14548708,16.7),(126413,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126413,35.32,0.2,116,57456,74.4,NULL,NULL,'UGC 09685',NULL,'2013AJ....146...86T',2013,1,1.05,NULL,'G',0.000033,NULL,'14.8g',0.71,'Scd:',NULL,NULL,NULL,NULL,1,226.196791667,8.17119,0.029,NULL,59388965440,927952585,14499259,14.8),(126414,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126414,37.3,0.46,289,57457,70,NULL,NULL,'2MASX J15044853+3250130',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,226.202083,32.83694,0.009,NULL,60114942194,939295971,14676499,17.1),(126415,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126415,37.71,0.33,349,57458,70,NULL,NULL,'2MASX J15044853+2121517',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.97',0.17,NULL,NULL,NULL,NULL,NULL,1,226.202333333,21.36439,0.089,NULL,59540224474,930316007,14536187,17.97),(126416,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126416,37.64,0.46,337,57459,70,NULL,NULL,'2MASX J15044920+2837530',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'18.08',0.2,NULL,NULL,NULL,NULL,NULL,1,226.2052083,28.63133,0.037,NULL,60081239944,938769374,14668271,18.08),(126417,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126417,37.92,0.46,383,57460,70,NULL,NULL,'SDSS J150449.39+205325.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.2057917,20.89042,0.089,NULL,59539958224,930311847,14536122,18.5),(126418,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126418,37.56,0.33,325,57461,70,NULL,NULL,'2MASX J15044980+0457185',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,226.207541667,4.95522,0.077,NULL,59329772422,927027694,14484807,18.4),(126419,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126419,37.93,0.46,386,57462,70,NULL,NULL,'SDSS J150449.80+470825.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,226.207541667,47.14047,0.037,NULL,59983954886,937249295,14644520,17.9),(126420,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126420,38.45,0.33,490,57463,70,NULL,NULL,'2MASX J15045036+0652038',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.209708333,6.86789,0.065,NULL,59385869797,927904215,14498503,17.2),(126421,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126421,37.79,0.46,362,57464,70,NULL,NULL,'2MASX J15045076+2244527',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.38',0.15,NULL,NULL,NULL,NULL,NULL,1,226.211375,22.74814,0.113,NULL,59528662007,930135343,14533364,18.38),(126422,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126422,37.33,0.46,292,57465,70,NULL,NULL,'2MASX J15045188+0441555',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000073,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.216,4.69889,0.105,NULL,59331585285,927056020,14485250,17.6),(126423,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126423,38.26,0.46,448,57466,70,NULL,NULL,'SDSS J150451.91+273924.2',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,226.2162917,27.65672,0.049,NULL,60081032577,938766134,14668220,NULL),(126424,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126424,38.25,0.46,447,57467,70,NULL,NULL,'2MASX J15045280+2215307',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.220083,22.25867,0.085,NULL,59528571533,930133930,14533342,18.1),(126425,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126425,36.91,0.46,241,57468,70,NULL,NULL,'2MASX J15045346+5603341',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00019,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,226.223,56.05933,0.013,NULL,57717317000,901833078,14091141,16.3),(126426,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126426,36.51,0.27,201,57469,70,NULL,NULL,'IC 4532',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000117,NULL,'15.6',0.31,NULL,NULL,NULL,NULL,NULL,1,226.224208333,23.25661,0.121,NULL,59527963449,930124428,14533194,15.6),(126427,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126427,37.56,0.33,325,57470,70,NULL,NULL,'2MASX J15045388+0455525',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.224417,4.93117,0.077,NULL,59329772614,927027697,14484807,17.3),(126428,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126428,37.65,0.46,339,57471,70,NULL,NULL,'2MASX J15045412+3141060',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000148,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,226.225417,31.68483,0.013,NULL,60084913401,938826771,14669168,17.5),(126429,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126429,37.77,0.46,358,57472,70,NULL,NULL,'2MASX J15045423+2759350',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,226.225958333,27.99308,0.049,NULL,60080980428,938765319,14668208,17.9),(126430,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126430,37.55,0.17,324,57473,70,NULL,NULL,'2MASX J15045441+0505515',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,226.226667,5.09756,0.081,NULL,59329977428,927030897,14484857,17.2),(126431,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126431,37.71,0.33,348,57474,70,NULL,NULL,'2MASX J15045440+0702028',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,226.22675,7.03425,0.061,NULL,59385753537,927902399,14498474,NULL),(126432,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126432,36.19,0.21,173,57475,70,NULL,NULL,'CGCG 048-104',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000063,NULL,'15.7',0.43,NULL,'Group member',NULL,NULL,NULL,1,226.22875,5.90917,0.089,NULL,59330368361,927037005,14484953,15.7),(126433,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126433,36.78,0.46,227,57476,70,NULL,NULL,'CGCG 165-012',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000137,NULL,'15.4g',0.49,'E0',NULL,NULL,NULL,NULL,1,226.2317917,31.12497,0.025,NULL,60084770155,938824533,14669133,15.4),(126434,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126434,37.88,0.33,377,57477,70,NULL,NULL,'2MASX J15045649+3051410',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,226.235417,30.86131,0.021,NULL,60092318583,938942477,14670976,17.2),(126435,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126435,37.65,0.46,338,57478,70,NULL,NULL,'2MASX J15045664+2958400',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.39',0.17,NULL,NULL,NULL,NULL,NULL,1,226.236125,29.97794,0.017,NULL,60094352703,938974260,14671472,18.39),(126436,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126436,36.4,0.46,191,57479,70,NULL,NULL,'2MASX J15045666+0607488',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.0g',0.38,NULL,NULL,NULL,NULL,NULL,1,226.236167,6.13022,0.077,NULL,59330077737,927032464,14484882,16),(126437,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126437,37.07,0.46,259,57480,70,NULL,NULL,'2MASX J15045710+2435330',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,226.237917,24.5925,0.105,NULL,59409129398,928267646,14504181,16.3),(126438,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126438,36.25,0.57,178,57481,NULL,NULL,'Malmquist cor.','2MASX J15045771+2836450',NULL,'2009ApJS..182..474S',2009,1,0.29,NULL,'G',0.00004,NULL,'18.68',0.12,'Sc',NULL,NULL,NULL,NULL,1,226.240417,28.61256,0.037,NULL,60081228818,938769200,14668268,18.68),(126439,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126439,36.31,0.56,183,57481,NULL,NULL,NULL,'2MASX J15045771+2836450',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126440,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126440,36.35,0.2,186,57481,74.4,NULL,NULL,'2MASX J15045771+2836450',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126441,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126441,36.6,0.33,209,57482,70,NULL,NULL,'2MASX J15045838-0031111',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000083,NULL,'17.3g',0.13,'NLAGN',NULL,NULL,NULL,NULL,1,226.243416667,-0.51992,0.153,NULL,45366306325,708848536,11075758,17.3),(126442,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126442,36.51,0.27,201,57483,70,NULL,NULL,'2MASX J15045945+2313277',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00018,NULL,'17.84',0.18,NULL,NULL,NULL,NULL,NULL,1,226.2477083,23.22444,0.121,NULL,59528142111,930127220,14533237,17.84),(126443,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126443,36.76,0.68,225,57484,NULL,NULL,'Malmquist cor.','2MASX J15045952+2826490',NULL,'2009ApJS..182..474S',2009,1,0.45,NULL,'G',0.000037,NULL,'16.14',0.11,'SBab',NULL,NULL,NULL,NULL,1,226.248083,28.44689,0.033,NULL,60081302849,938770357,14668286,16.14),(126444,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126444,37.01,0.6,252,57484,NULL,NULL,NULL,'2MASX J15045952+2826490',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126445,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126445,37.05,0.2,257,57484,74.4,NULL,NULL,'2MASX J15045952+2826490',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126446,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126446,36.93,0.23,243,57485,70,NULL,NULL,'SDSS J150500.02+161751.0',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.9g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.250167,16.29753,0.033,NULL,59591522763,931117543,14548711,16.9),(126447,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126447,36.89,0.46,239,57486,70,NULL,NULL,'2MASX J15050063+0843468',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.252667,8.72969,0.041,NULL,59389191810,927956122,14499314,17.8),(126448,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126448,37.24,0.21,280,57487,70,NULL,NULL,'MCG +04-36-006',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.4g',0.33,'AGN',NULL,NULL,NULL,NULL,1,226.255083,26.01708,0.089,NULL,59895687091,935870110,14622970,16.4),(126449,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126449,36.67,0.45,216,57488,NULL,NULL,'Malmquist cor.','2MASX J15050119+2823030',NULL,'2009ApJS..182..474S',2009,1,0.53,NULL,'G',0.000027,NULL,'15.06',0.33,'Sc',NULL,NULL,NULL,NULL,1,226.255375,28.38414,0.033,NULL,60081303869,938770372,14668287,15.06),(126450,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126450,36.78,0.42,227,57488,NULL,NULL,NULL,'2MASX J15050119+2823030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126451,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126451,36.82,0.2,231,57488,74.4,NULL,NULL,'2MASX J15050119+2823030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126452,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126452,37.55,0.17,324,57489,70,NULL,NULL,'2MASX J15050144+0507545',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,226.256,5.13175,0.081,NULL,59329847564,927028868,14484826,16.9),(126453,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126453,37.55,0.17,324,57490,70,NULL,NULL,'SDSS J150501.64+050459.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.256833333,5.08331,0.081,NULL,59329977157,927030893,14484857,17.8),(126454,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126454,36.7,0.46,219,57491,70,NULL,NULL,'2MASX J15050185+3718082',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000149,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,226.257833,37.30228,0,NULL,60120062246,939375972,14677749,16.7),(126455,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126455,38.1,0.21,417,57492,70,NULL,NULL,'2MASX J15050212+2252357',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,226.259,22.87667,0.113,NULL,59528088661,930126385,14533224,17.9),(126456,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126456,36.93,0.23,243,57493,70,NULL,NULL,'2MASX J15050242+1621094',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.95',0.18,NULL,NULL,NULL,NULL,NULL,1,226.260083,16.35275,0.033,NULL,59591522205,931117534,14548711,17.95),(126457,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126457,37.24,0.21,280,57494,70,NULL,NULL,'2MASX J15050244+2602450',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,226.260167,26.04575,0.089,NULL,59895686148,935870096,14622970,17.8),(126458,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126458,37.24,0.21,280,57495,70,NULL,NULL,'SDSS J150502.68+255353.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000164,NULL,'18.0g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.2612083,25.89828,0.089,NULL,59895697392,935870271,14622972,18),(126459,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126459,37.85,0.46,372,57496,70,NULL,NULL,'SDSS J150502.80+343456.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000158,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,226.2617083,34.58228,0.025,NULL,60126661970,939479093,14679360,18.3),(126460,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126460,37.49,0.46,315,57497,70,NULL,NULL,'SDSS J150502.97+200908.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.262375,20.15242,0.085,NULL,59536610976,930259546,14535305,18.4),(126461,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126461,37.55,0.17,324,57498,70,NULL,NULL,'2MASX J15050438+0504035',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,226.268333,5.06764,0.081,NULL,59329984718,927031011,14484859,16.2),(126462,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126462,37.24,0.21,280,57499,70,NULL,NULL,'SDSS J150504.64+260031.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.269375,26.00872,0.089,NULL,59895687136,935870111,14622970,17.4),(126463,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126463,38.45,0.33,490,57500,70,NULL,NULL,'2MASX J15050473+0650197',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,226.269667,6.83889,0.065,NULL,59385868683,927904198,14498503,17.5),(126464,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126464,36.95,0.72,246,57501,70,NULL,NULL,'2MASX J15050486-0106351',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.000101,NULL,'16.0g',0.4,NULL,NULL,NULL,NULL,NULL,1,226.270375,-1.10972,0.161,NULL,45369416721,708897136,11076517,16),(126465,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126465,36.02,0.33,160,57502,70,NULL,NULL,'2MASX J15050539+3557501',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000165,NULL,'16.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,226.2724583,35.96386,0,NULL,60128455593,939507118,14679798,16.4),(126466,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126466,36.51,0.27,201,57503,70,NULL,NULL,'2MASX J15050541+2325117',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.75',0.19,NULL,NULL,NULL,NULL,NULL,1,226.27275,23.42,0.117,NULL,59527975280,930124613,14533197,17.75),(126467,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126467,37.07,0.33,259,57504,70,NULL,NULL,'2MASX J15050745+3656232',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'16.71',0.19,NULL,NULL,NULL,NULL,NULL,1,226.280958333,36.93986,0.021,NULL,60119952463,939374257,14677722,16.71),(126468,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126468,37.05,0.27,257,57505,70,NULL,NULL,'2MASX J15050759+3012471',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,226.281541667,30.21308,0.025,NULL,60094414515,938975226,14671487,16.7),(126469,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126469,37.84,0.46,369,57506,70,NULL,NULL,'2MASX J15050767+2713380',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.57',0.18,NULL,NULL,NULL,NULL,NULL,1,226.282041667,27.22731,0.073,NULL,60080797873,938762466,14668163,18.57),(126470,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126470,38.14,0.33,425,57507,70,NULL,NULL,'2MASX J15050863+2012157',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,226.286,20.20433,0.085,NULL,59536609356,930259521,14535305,17.5),(126471,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126471,37.63,0.46,335,57508,70,NULL,NULL,'SDSS J150508.70+115422.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000151,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.2862917,11.90628,0.149,NULL,59346226409,927284787,14488824,18.4),(126472,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126472,36.19,0.21,173,57509,70,NULL,NULL,'2MASX J15050874+0553235',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,226.2865,5.88986,0.089,NULL,59330094731,927032730,14484886,16.9),(126473,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126473,36.93,0.23,243,57510,70,NULL,NULL,'SDSS J150509.51+161524.4',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.289666667,16.25678,0.033,NULL,59591513734,931117402,14548709,17.4),(126474,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126474,37.47,0.5,311,57511,NULL,NULL,'Malmquist cor.','2MASX J15050966+2848480',NULL,'2009ApJS..182..474S',2009,1,0.45,NULL,'G',0.00003,NULL,'15.45',NULL,'Sab',NULL,NULL,NULL,NULL,1,226.2902083,28.81342,0.041,NULL,60081190420,938768600,14668259,15.45),(126475,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126475,37.6,0.47,331,57511,NULL,NULL,NULL,'2MASX J15050966+2848480',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126476,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126476,37.64,0.2,337,57511,74.4,NULL,NULL,'2MASX J15050966+2848480',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126477,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126477,37.37,0.46,298,57512,70,NULL,NULL,'2MASX J15050994+4533390',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000179,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,226.2914583,45.56072,0.025,NULL,59994595014,937415547,14647117,16.5),(126478,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126478,37.07,0.46,260,57513,70,NULL,NULL,'2MASX J15050993+0826037',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,226.2915,8.43442,0.053,NULL,59388817279,927950269,14499222,17.4),(126479,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126479,37.55,0.17,324,57514,70,NULL,NULL,'2MASX J15051041+0459555',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,226.293417,4.99883,0.077,NULL,59329973735,927030839,14484856,16.7),(126480,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126480,36.9,0.23,240,57515,70,NULL,NULL,'2MASX J15051080+2037027',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.34',0.14,'AGN',NULL,NULL,NULL,NULL,1,226.294875,20.61731,0.113,NULL,59535269906,930238592,14534978,18.34),(126481,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126481,37.05,0.27,257,57516,70,NULL,NULL,'2MASXi J1505107+301357',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.4g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.294917,30.23247,0.025,NULL,60094412428,938975194,14671487,17.4),(126482,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126482,38.14,0.33,425,57517,70,NULL,NULL,'2MASX J15051097+2011027',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,226.29575,20.18403,0.085,NULL,59536610102,930259532,14535305,17.9),(126483,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126483,35.46,NULL,124,57518,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09704',NULL,'2010Ap&SS.325..163P',2010,1,1.38,NULL,'G',0.000102,NULL,'16.1g',0.17,'Sd(f)',NULL,NULL,NULL,NULL,1,226.305625,57.31847,0.017,NULL,57729024460,902016007,14094000,16.1),(126484,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126484,35.48,NULL,125,57518,NULL,NULL,'Dipole + Quadrupole','UGC 09704',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126485,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126485,35.5,NULL,126,57518,NULL,NULL,'Dipole','UGC 09704',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126486,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126486,35.51,NULL,126,57518,NULL,NULL,NULL,'UGC 09704',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126487,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126487,38.39,0.46,476,57519,70,NULL,NULL,'2MASX J15051345+6026085',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000075,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.3062917,60.43578,0.029,NULL,57776821585,902762837,14105669,17.6),(126488,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126488,36.22,0.27,175,57520,70,NULL,NULL,'CGCG 076-145',NULL,'2015arXiv151105856S',2015,1,0.73,'1994AJ....107.1629T has V = 8677 +- 100 km/sec.','G',0.00018,NULL,'15.2g',0.52,'Sc',NULL,NULL,NULL,NULL,1,226.30675,8.79658,0.041,NULL,59389184347,927956005,14499312,15.2),(126489,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126489,37.71,0.33,348,57521,70,NULL,NULL,'SDSS J150513.72+071357.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.3g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.307208333,7.23261,0.061,NULL,59385792932,927903014,14498484,18.3),(126490,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126490,36.9,0.23,240,57522,70,NULL,NULL,'2MASX J15051450+2037066',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.77',0.18,'AGN',NULL,NULL,NULL,NULL,1,226.3105,20.61844,0.105,NULL,59535314973,930239296,14534989,17.77);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (126491,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126491,38.1,0.21,417,57523,70,NULL,NULL,'2MASX J15051485+2252576',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.3117917,22.88281,0.117,NULL,59528100504,930126570,14533227,17.7),(126492,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126492,36.17,0.46,172,57524,70,NULL,NULL,'2MASX J15051533+3233181',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.314083333,32.55514,0.065,NULL,60085321366,938833146,14669267,17),(126493,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126493,37.14,0.13,268,57525,70,NULL,NULL,'2MASX J15051570+2836561',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.95',0.23,NULL,NULL,NULL,NULL,NULL,1,226.3155,28.61564,0.037,NULL,60081226794,938769168,14668268,16.95),(126494,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126494,37.82,0.46,367,57526,70,NULL,NULL,'2MASX J15051660+4144293',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000159,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,226.319208333,41.74144,0.033,NULL,59970712215,937042378,14641287,16.9),(126495,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126495,37.64,0.46,338,57527,70,NULL,NULL,'2MASX J15051707+3218261',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,226.32125,32.30722,0.005,NULL,60085354793,938833668,14669276,17.6),(126496,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126496,37.05,0.27,257,57528,70,NULL,NULL,'2MASX J15051731+3012581',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,226.322083,30.21606,0.025,NULL,60094408151,938975127,14671486,17.1),(126497,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126497,37.38,0.33,300,57529,70,NULL,NULL,'SDSS J150517.64+112413.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000212,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.3235,11.40378,0.093,NULL,59345587379,927274802,14488668,18),(126498,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126498,38.1,0.21,417,57530,70,NULL,NULL,'2MASX J15051831+2249341',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.32625,22.82617,0.113,NULL,59528606756,930134480,14533351,17.7),(126499,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126499,37.02,0.46,254,57531,70,NULL,NULL,'2MASX J15051924+0442526',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,226.330083333,4.71461,0.089,NULL,59331638066,927056844,14485263,17.3),(126500,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126500,35.69,0.49,137,57532,75,NULL,'IR','UGC 09694',NULL,'2011yCatp016004901K',2011,1,0.91,NULL,'G',0.000081,NULL,'15.4g',0.27,'Sb',NULL,NULL,NULL,NULL,1,226.334167,4.48056,0.093,NULL,59331113738,927048652,14485135,15.4),(126501,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126501,37.47,0.33,312,57533,70,NULL,NULL,'2MASX J15052040+2638201',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.92',0.2,NULL,NULL,NULL,NULL,NULL,1,226.3350417,26.63881,0.097,NULL,59895227546,935862930,14622858,17.92),(126502,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126502,38.1,0.21,417,57534,70,NULL,NULL,'2MASX J15052098+2251131',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.70',0.14,NULL,NULL,NULL,NULL,NULL,1,226.337583,22.85347,0.113,NULL,59528091782,930126434,14533225,18.7),(126503,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126503,37.55,0.17,324,57535,70,NULL,NULL,'2MASX J15052104+0505256',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,226.3377083,5.09036,0.081,NULL,59329852758,927028949,14484827,16.6),(126504,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126504,37.81,0.46,365,57536,70,NULL,NULL,'2MASX J15052212+1225166',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,226.342083,12.42136,0.081,NULL,59567959038,930749359,14542958,NULL),(126505,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126505,36.37,0.66,188,57537,70,NULL,NULL,'2MASX J15052225-0148107',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.0g',0.35,'S0',NULL,NULL,NULL,NULL,1,226.3427083,-1.80286,0.177,NULL,45367196447,708862444,11075975,16),(126506,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126506,38.34,0.46,466,57538,70,NULL,NULL,'2MASX J15052230+3646143',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,'FoF','17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,226.3429583,36.77058,0.021,NULL,60119962828,939374419,14677725,17.4),(126507,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126507,37.38,0.33,300,57539,70,NULL,NULL,'2MASX J15052256+1125317',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'19.00',0.15,NULL,NULL,NULL,NULL,NULL,1,226.3440417,11.42547,0.093,NULL,59345597752,927274964,14488671,19),(126508,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126508,37.58,0.33,329,57540,70,NULL,NULL,'SDSS J150522.71+094527.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000149,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.344625,9.75778,0.061,NULL,59377628882,927775451,14496491,18.3),(126509,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126509,36.15,0.65,170,57541,70,NULL,NULL,'2MASX J15052272-4508311',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,226.344666667,-45.14194,0.541,NULL,47108026230,736062909,11500982,15.3),(126510,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126510,37.71,0.33,349,57542,70,NULL,NULL,'SDSS J150523.21+213405.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.34675,21.56822,0.097,NULL,59540190504,930315476,14536179,18.3),(126511,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126511,37.88,0.33,377,57543,70,NULL,NULL,'2MASX J15052407+3056011',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,226.3502917,30.93364,0.025,NULL,60086553521,938852398,14669568,17.5),(126512,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126512,37.55,0.17,324,57544,70,NULL,NULL,'2MASX J15052426+0503336',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,226.351083333,5.05925,0.081,NULL,59329842291,927028785,14484824,16.7),(126513,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126513,37.07,0.33,259,57545,70,NULL,NULL,'2MASX J15052455+3644513',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000185,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,226.3522917,36.74753,0.021,NULL,60119918814,939373731,14677714,16.6),(126514,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126514,38.38,0.46,474,57546,70,NULL,NULL,'SDSS J150524.90-004138.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000072,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,226.3537917,-0.69392,0.157,NULL,45369071524,708891742,11076433,18.4),(126515,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126515,36.81,0.46,230,57547,70,NULL,NULL,'2MASX J15052604+0817577',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00019,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,226.358417,8.29939,0.053,NULL,59388853093,927950829,14499231,16.2),(126516,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126516,31.61,0.63,21,57548,95,NULL,'Michard 1979b, c','NGC 5838',NULL,'1984ApJS...56...91D',1984,1,4.2,NULL,'G',0.000017,NULL,'11.92',1.5,'SA0-           LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,226.359416667,2.09933,0.121,NULL,59325912120,926967376,14483865,11.92),(126517,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126517,31.61,0.46,21,57548,95,NULL,'Michard 1979a','NGC 5838',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126518,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126518,31.8,0.37,22.9,57548,95,NULL,'Weighted Mean','NGC 5838',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126519,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126519,34.44,0.81,77.3,57548,55,NULL,'Visvanathan & Sandage 1979','NGC 5838',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126520,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126520,32.69,0.25,34.5,57548,74.4,NULL,NULL,'NGC 5838',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126521,'Tertiary','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126521,31.08,0.25,16.4,57548,95,NULL,NULL,'NGC 5838',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126522,'Tully est','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126522,32.27,0.8,28.5,57548,75,NULL,'B','NGC 5838',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126523,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126523,32.01,0.4,25.2,57548,NULL,NULL,'mean','NGC 5838',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126524,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126524,32.16,NULL,27,57548,72,NULL,NULL,'NGC 5838',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126525,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126525,32.17,0.45,27.2,57548,NULL,NULL,'K','NGC 5838',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126526,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126526,32.29,0.43,28.6,57549,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09703',NULL,'2014MNRAS.444..527S',2014,1,1.36,'HOLM 696B is a star.','G',0.000107,NULL,'14.6g',0.41,'Sbc',NULL,NULL,NULL,NULL,1,226.35975,46.56506,0.085,NULL,59984229127,937253580,14644587,14.6),(126527,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126527,32.94,0.4,38.7,57549,NULL,NULL,'mean','UGC 09703',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126528,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126528,33.09,0.4,41.5,57549,75,NULL,NULL,'UGC 09703',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126529,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126529,33.66,0.47,54,57549,NULL,NULL,'H','UGC 09703',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126530,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126530,33.67,0.49,54.3,57549,75,NULL,'IR','UGC 09703',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126531,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126531,37.58,0.33,329,57550,70,NULL,NULL,'2MASX J15052681+0947177',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,226.361917,9.78822,0.061,NULL,59377628057,927775438,14496491,17.3),(126532,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126532,32.89,0.2,37.8,57551,74.4,NULL,NULL,'UGC 09698',NULL,'2013AJ....146...86T',2013,1,1.05,NULL,'G',0.00002,NULL,'15.9g',0.32,'S?',NULL,NULL,NULL,NULL,1,226.3632083,23.68833,0.113,NULL,59411804679,928309448,14504835,15.9),(126533,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126533,37.47,0.33,312,57552,70,NULL,NULL,'2MASX J15052718+2638432',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.05',0.2,NULL,NULL,NULL,NULL,NULL,1,226.363333,26.64542,0.097,NULL,59895231514,935862992,14622859,18.05),(126534,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126534,31.77,0.3,22.6,57553,NULL,NULL,'I','NGC 5839',NULL,'2001ApJ...546..681T',2001,1,1.3,NULL,'G',0.000017,NULL,'13.7',1.2,'SAB(rs)0^0^:','in a radial-velocity based grouping',NULL,NULL,NULL,1,226.364541667,1.63481,0.141,NULL,56373827049,880841047,13763141,13.7),(126535,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126535,31.78,0.12,22.7,57553,74.4,NULL,NULL,'NGC 5839',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126536,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126536,31.41,1.29,19.1,57553,95,NULL,'Weighted Mean','NGC 5839',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126537,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126537,31.41,1.29,19.1,57553,95,NULL,'de Vaucouleurs','NGC 5839',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126538,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126538,31.78,0.12,22.7,57553,74.4,NULL,NULL,'NGC 5839',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126539,'Tertiary','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126539,31.08,0.25,16.4,57553,95,NULL,NULL,'NGC 5839',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126540,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126540,32.15,0.4,27,57553,NULL,NULL,'mean','NGC 5839',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126541,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126541,32.86,0.45,37.3,57553,NULL,NULL,'K','NGC 5839',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126542,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126542,36.98,0.2,249,57554,74.4,NULL,NULL,'UGC 09695',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000187,NULL,'15.02',0.5,'SBb',NULL,NULL,NULL,NULL,1,226.365833,14.42889,0.073,NULL,59577567735,930899495,14545304,15.02),(126543,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126543,34.98,0.47,98.9,57555,NULL,NULL,'H','UGC 09696',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000037,NULL,'14.1g',0.81,'Sa',NULL,NULL,NULL,NULL,1,226.3772917,8.52436,0.029,NULL,59389107792,927954809,14499293,14.1),(126544,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126544,35.16,0.45,107,57555,NULL,NULL,'K','UGC 09696',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126545,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126545,35.17,0.46,108,57555,NULL,NULL,'J','UGC 09696',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126546,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126546,35.31,0.4,115,57555,NULL,NULL,'mean','UGC 09696',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126547,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126547,37.31,0.33,290,57556,70,NULL,NULL,'2MASX J15053125+0906337',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,226.380375,9.10936,0.053,NULL,59388329902,927942654,14499103,17.4),(126548,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126548,37.87,0.46,375,57557,70,NULL,NULL,'2MASX J15053212+0803145',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,226.38375,8.05406,0.029,NULL,59384479823,927882497,14498164,17.7),(126549,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126549,36.87,0.46,236,57558,70,NULL,NULL,'2MASX J15053279+3759112',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00019,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,226.386541667,37.9865,0.017,NULL,60119368681,939365135,14677580,16.2),(126550,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126550,37.31,0.33,290,57559,70,NULL,NULL,'2MASX J15053438+0902505',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000175,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,226.3934583,9.04744,0.053,NULL,59388315749,927942433,14499100,16.7),(126551,'D-Sigma','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126551,32.26,0.4,28.3,57560,75,NULL,'Edat, raw','NGC 5799',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000143,NULL,'13.32',1,'S0+: pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,226.3967083,-72.43283,0.525,NULL,45033866720,703654167,10994596,13.32),(126552,'D-Sigma','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126552,32.6,0.4,33.1,57560,75,NULL,'Edat, cor','NGC 5799',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126553,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126553,32.1,0.56,26.3,57560,70,NULL,NULL,'NGC 5799',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126554,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126554,32.82,0.45,36.6,57560,NULL,NULL,'K','NGC 5799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126555,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126555,32.97,0.4,39.2,57560,NULL,NULL,'mean','NGC 5799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126556,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126556,36.19,0.21,173,57561,70,NULL,NULL,'2MASX J15053585+0534276',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,226.399375,5.57442,0.077,NULL,59330292524,927035820,14484934,16.6),(126557,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126557,38.93,0.46,611,57562,70,NULL,NULL,'SDSS J150536.62+273449.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.2g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.402625,27.58042,0.053,NULL,60081014829,938765856,14668216,18.2),(126558,'IRAS','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126558,35.69,0.8,137,57563,75,NULL,'CF, r','UGC 09701',NULL,'1997ApJS..109..333W',1997,1,0.88,NULL,'G',0.000033,NULL,'15.2g',0.49,'Scd:',NULL,NULL,NULL,NULL,1,226.404167,31.16383,0.025,NULL,60084742644,938824103,14669126,15.2),(126559,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126559,35.09,0.38,104,57563,75,NULL,'CF, r, raw','UGC 09701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126560,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126560,35.2,0.38,109,57563,75,NULL,'CF, r, inv','UGC 09701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126561,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126561,35.41,0.38,121,57563,75,NULL,'CF, r, cor','UGC 09701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126562,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126562,36.22,0.27,175,57564,70,NULL,NULL,'2MASX J15053729+0838066',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,226.405417,8.63503,0.041,NULL,59389110061,927954844,14499294,17),(126563,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126563,38.2,0.46,436,57565,70,NULL,NULL,'2MASX J15053962+2207401',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.70',0.14,NULL,NULL,NULL,NULL,NULL,1,226.415083,22.12767,0.097,NULL,59527850175,930122658,14533166,18.7),(126564,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126564,37.35,0.46,296,57566,70,NULL,NULL,'2MASX J15053963+2231591',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,226.4152083,22.53325,0.109,NULL,59528623214,930134737,14533355,16.6),(126565,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126565,39.35,0.46,743,57567,70,NULL,NULL,'SDSS J150539.79+225909.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000131,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.415833,22.98586,0.117,NULL,59528105182,930126643,14533228,18.4),(126566,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126566,36.01,0.2,159,57568,74.4,NULL,NULL,'CGCG 135-008',NULL,'2013AJ....146...86T',2013,1,0.52,NULL,'G',0.000554,NULL,'15.7',0.32,NULL,NULL,NULL,NULL,NULL,1,226.417167,25.44553,0.113,NULL,59895110612,935861103,14622829,15.7),(126567,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126567,38,0.46,399,57569,70,NULL,NULL,'2MASX J15054037+1037306',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,226.418125,10.62519,0.077,NULL,59346832061,927294250,14488972,17.7),(126568,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126568,37.36,0.46,297,57570,70,NULL,NULL,'2MASX J15054087+4005277',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000152,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,226.4202917,40.09094,0.029,NULL,60101046517,939078851,14673107,16.9),(126569,'IRAS','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126569,34.29,0.8,72,57571,75,NULL,'MAT, I','IC 4527',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'15',0.7,'SA(s)c pec',NULL,NULL,NULL,NULL,1,226.420916667,-42.44953,0.377,NULL,47096067176,735876049,11498063,15),(126570,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126570,33.49,0.32,50,57571,85,NULL,'I, raw','IC 4527',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126571,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126571,33.55,0.32,51.3,57571,85,NULL,'I, inv','IC 4527',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126572,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126572,33.63,0.43,53.3,57571,75,NULL,'MAT, I, raw','IC 4527',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126573,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126573,33.76,0.47,56.5,57571,NULL,NULL,'Malmquist cor.','IC 4527',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126574,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126574,33.81,0.46,57.9,57571,NULL,NULL,NULL,'IC 4527',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126575,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126575,33.85,0.2,58.9,57571,74.4,NULL,NULL,'IC 4527',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126576,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126576,33.89,0.43,59.9,57571,75,NULL,'MAT, I, inv','IC 4527',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126577,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126577,33.96,0.43,62,57571,75,NULL,'MAT, I, cor','IC 4527',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126578,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126578,37.62,0.46,335,57572,70,NULL,NULL,'2MASX J15054296-0102273',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000078,NULL,'17.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,226.429167,-1.04089,0.165,NULL,45369432256,708897379,11076521,17.3),(126579,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126579,37.83,0.46,368,57573,70,NULL,NULL,'2MASX J15054325+2611047',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.430375,26.18467,0.121,NULL,59895354005,935864906,14622889,17.6),(126580,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126580,38.07,0.46,411,57574,70,NULL,NULL,'2MASX J15054445+4715403',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.435166667,47.26108,0.053,NULL,59984670168,937260471,14644694,18.1),(126581,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126581,37.14,0.13,268,57575,70,NULL,NULL,'2MASX J15054493+2817417',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.37',0.17,NULL,NULL,NULL,NULL,NULL,1,226.4372917,28.29506,0.041,NULL,60081132519,938767695,14668245,18.37),(126582,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126582,38.5,0.46,501,57576,70,NULL,NULL,'2MASX J15054537+0238047',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000103,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,226.439167,2.63467,0.117,NULL,59325451486,926960179,14483752,17.3),(126583,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126583,37.68,0.33,343,57577,70,NULL,NULL,'2MASX J15054647+3356475',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.44375,33.94644,0,NULL,60115640783,939306887,14676670,18.2),(126584,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126584,37.34,0.46,293,57578,70,NULL,NULL,'2MASX J15054676+6102047',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000084,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.445125,61.03481,0.005,NULL,57778296021,902785875,14106029,17.2),(126585,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126585,35.24,0.48,111,57579,70,NULL,NULL,'MCG -02-38-033',NULL,'2014MNRAS.445.2677S',2014,1,0.27,NULL,'G',0.000133,NULL,'15.23',0.2,NULL,NULL,NULL,NULL,NULL,1,226.4495,-14.96483,0.449,NULL,46694062495,729594726,11399917,15.23),(126586,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126586,36.93,0.46,243,57580,70,NULL,NULL,'2MASX J15055077+0253047',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000137,NULL,'17.11',0.44,NULL,NULL,NULL,NULL,NULL,1,226.4615,2.88461,0.117,NULL,59325400001,926959375,14483740,17.11),(126587,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126587,37.14,0.13,268,57581,70,NULL,NULL,'2MASX J15055100+2809447',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'18.22',0.18,NULL,NULL,NULL,NULL,NULL,1,226.4625,28.16256,0.053,NULL,60081154068,938768032,14668250,18.22),(126588,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126588,36.83,0.46,232,57582,70,NULL,NULL,'2MASX J15055306+2043202',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.47125,20.72239,0.105,NULL,59535308181,930239190,14534987,17.3),(126589,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126589,35.1,0.48,105,57583,70,NULL,NULL,'2MASX J15055334-1409089',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00014,NULL,'15.68',0.7,NULL,NULL,NULL,NULL,NULL,1,226.472417,-14.15244,0.441,NULL,46663254590,729113352,11392396,15.68),(126590,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126590,35.78,0.73,143,57584,70,NULL,NULL,'2MASX J15055379-0143502',NULL,'2014MNRAS.445.2677S',2014,1,0.71,NULL,'G',0.00015,NULL,'15.8g',0.36,'S0/a',NULL,NULL,NULL,NULL,1,226.474167,-1.73072,0.177,NULL,45367412989,708865827,11076028,15.8),(126591,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126591,38.03,0.16,404,57585,70,NULL,NULL,'SDSS J150554.35+271944.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.4764583,27.32892,0.065,NULL,59897076180,935891815,14623309,17.8),(126592,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126592,36.7,0.51,219,57586,NULL,NULL,'Malmquist cor.','2MASX J15055536+2832247',NULL,'2009ApJS..182..474S',2009,1,0.35,NULL,'G',0.000023,NULL,'16.13',0.11,'Sb:',NULL,NULL,NULL,NULL,1,226.480625,28.54022,0.037,NULL,60081213404,938768959,14668264,16.13),(126593,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126593,36.85,0.48,234,57586,NULL,NULL,NULL,'2MASX J15055536+2832247',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126594,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126594,36.89,0.2,239,57586,74.4,NULL,NULL,'2MASX J15055536+2832247',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126595,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126595,38.2,0.46,437,57587,70,NULL,NULL,'2MASX J15055590+1621457',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.64',0.16,NULL,NULL,NULL,NULL,NULL,1,226.4830417,16.36286,0.037,NULL,59591499170,931117174,14548705,18.64),(126596,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126596,34.13,0.46,66.9,57588,70,NULL,NULL,'ARK 469',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00008,NULL,'15.2',0.2,'S0','Pair member (points to parent)',NULL,NULL,NULL,1,226.483917,12.72808,0.073,NULL,59567967172,930749487,14542960,15.2),(126597,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126597,37.75,0.27,355,57589,70,NULL,NULL,'2MASX J15055803+3131085',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000185,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,226.4917083,31.51892,0.021,NULL,60084822357,938825349,14669146,17.3),(126598,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126598,38.12,0.33,421,57590,70,NULL,NULL,'2MASX J15055832+0814275',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000148,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.492958333,8.24106,0.053,NULL,59384423306,927881614,14498150,17.4),(126599,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126599,37.75,0.27,355,57591,70,NULL,NULL,'2MASX J15055865+3132065',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000196,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.494333,31.53528,0.021,NULL,60084822801,938825356,14669146,17.4),(126600,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126600,37.59,0.46,329,57592,70,NULL,NULL,'2MASX J15055971+1639027',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.12',0.2,NULL,NULL,NULL,NULL,NULL,1,226.498833,16.65072,0.037,NULL,59590993610,931109275,14548582,18.12),(126601,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126601,38.12,0.33,421,57593,70,NULL,NULL,'2MASX J15055994+0812555',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,226.4997083,8.21556,0.053,NULL,59384426123,927881658,14498150,18.4),(126602,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126602,38.11,0.46,418,57594,70,NULL,NULL,'2MASX J15060064+5402265',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,226.502667,54.04092,0,NULL,59660718292,932198723,14565605,17.5),(126603,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126603,31.91,0.21,24.1,57595,NULL,NULL,'I','NGC 5845',NULL,'2003ApJ...583..712J',2003,1,0.8,NULL,'G',0.000017,NULL,'13.50',0.5,'E:','in a radial-velocity based grouping',NULL,NULL,NULL,1,226.503375,1.63381,0.141,NULL,56374040629,880844384,13763193,13.5),(126604,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126604,32.07,0.21,25.9,57595,NULL,NULL,'I','NGC 5845',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126605,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126605,32.36,0.12,29.7,57595,74.4,NULL,NULL,'NGC 5845',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126606,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126606,32.36,0.12,29.7,57595,74.4,NULL,NULL,'NGC 5845',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126607,'Tully est','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126607,32.27,0.8,28.5,57595,75,NULL,'B','NGC 5845',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126608,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126608,36.22,0.27,175,57596,70,NULL,NULL,'CGCG 076-148',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000163,NULL,'15.1g',0.57,NULL,NULL,NULL,NULL,NULL,1,226.507875,8.78981,0.045,NULL,59388379111,927943423,14499115,15.1),(126609,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126609,35.83,0.53,146,57597,70,NULL,NULL,'2MASX J15060197-1116298',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.11',NULL,NULL,NULL,NULL,NULL,NULL,1,226.508333,-11.27508,0.409,NULL,46484789769,726324840,11348825,16.11),(126610,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126610,37.68,0.46,343,57598,70,NULL,NULL,'2MASX J15060212+0920355',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,226.508625,9.34317,0.049,NULL,59376819258,927762800,14496293,17.6),(126611,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126611,37.88,0.46,377,57599,70,NULL,NULL,'2MASX J15060289+0525517',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.5122083,5.43089,0.077,NULL,59330280567,927035633,14484931,17.2),(126612,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126612,37.32,0.46,291,57600,70,NULL,NULL,'2MASX J15060323+1027175',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.513375,10.45492,0.077,NULL,59347025797,927297278,14489019,17.6),(126613,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126613,35.68,0.46,137,57601,70,NULL,NULL,'NGC 5862',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000182,NULL,'15.1g',0.61,'E0',NULL,NULL,NULL,NULL,1,226.5137917,55.57386,0,NULL,57580172358,899690193,14057659,15.1),(126614,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126614,37.48,0.46,313,57602,70,NULL,NULL,'SDSS J150603.50+152029.4',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.1g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.514583,15.3415,0.041,NULL,59577029234,930891081,14545173,17.1),(126615,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126615,36.94,0.46,244,57603,70,NULL,NULL,'2MASX J15060559+2032162',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'16.45',0.23,NULL,NULL,NULL,NULL,NULL,1,226.523333,20.53789,0.113,NULL,59535312913,930239264,14534988,16.45),(126616,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126616,36.58,0.33,207,57604,70,NULL,NULL,'2MASX J15060439+4620074',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000188,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,226.5284583,46.33522,0.045,NULL,59984312172,937254877,14644607,16.4),(126617,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126617,37.64,0.46,337,57605,70,NULL,NULL,'2MASX J15060686+0303057',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000071,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,226.528625,3.05147,0.113,NULL,59325384557,926959133,14483736,17.9),(126618,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126618,38.16,0.46,428,57606,70,NULL,NULL,'2MASX J15060780+5019452',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000156,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,226.532667,50.32911,0.017,NULL,59942664838,936604138,14634439,17.3),(126619,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126619,38.03,0.16,404,57607,70,NULL,NULL,'2MASX J15060788+2708397',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,226.5327083,27.14431,0.073,NULL,59897078750,935891855,14623310,17.5),(126620,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126620,35.92,0.33,152,57608,NULL,NULL,'Malmquist cor.','ESO 328- G 016',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'13.14',0.6,'Sb-c     poss. LINER',NULL,NULL,NULL,NULL,1,226.5340417,-39.91789,0.085,NULL,47186866764,737294793,11520231,13.14),(126621,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126621,36.21,0.29,175,57608,NULL,NULL,NULL,'ESO 328- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126622,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126622,36.25,0.2,178,57608,74.4,NULL,NULL,'ESO 328- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126623,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126623,37.69,0.46,344,57609,70,NULL,NULL,'2MASX J15060880-0054143',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000076,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,226.5367917,-0.90411,0.165,NULL,45369568637,708899509,11076554,17.4),(126624,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126624,34,0.69,63.1,57610,100,NULL,'mid-IR','UGC 09705',NULL,'2013ApJ...771...88L',2013,1,0.91,NULL,'G',0.00009,NULL,'14.6g',0.55,'S0/a',NULL,NULL,NULL,NULL,1,226.539041667,25.78278,0.117,NULL,59895008170,935859502,14622804,14.6),(126625,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126625,35.95,0.2,155,57610,74.4,NULL,NULL,'UGC 09705',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126626,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126626,35.76,0.46,142,57611,70,NULL,NULL,'CGCG 048-117',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.00012,NULL,'14.9g',0.58,'BrClG','Group member',NULL,NULL,NULL,1,226.539917,3.67506,0.105,NULL,59338989031,927171703,14487057,14.9),(126627,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126627,37.5,0.46,317,57612,70,NULL,NULL,'2MASX J15061085+5942114',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000068,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.5452083,59.70314,0.021,NULL,57775310840,902739231,14105300,17.6),(126628,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126628,36.36,0.46,187,57613,70,NULL,NULL,'2MASX J15061096+1947082',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'16.75',0.23,NULL,NULL,NULL,NULL,NULL,1,226.545583,19.78556,0.077,NULL,59536761364,930261896,14535342,16.75),(126629,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126629,37.64,0.46,337,57614,70,NULL,NULL,'2MASX J15061118+0106522',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000089,NULL,'16.8g',0.33,NULL,NULL,NULL,NULL,NULL,1,226.5465,1.11442,0.129,NULL,56375594769,880868668,13763572,16.8),(126630,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126630,37.4,0.33,302,57615,70,NULL,NULL,'2MASX J15061139+2055532',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,226.547458333,20.93142,0.105,NULL,59535418483,930240913,14535014,17.4),(126631,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126631,34.68,0.49,86.3,57616,75,NULL,'IR','FGC 1856',NULL,'2011yCatp016004901K',2011,1,0.99,'The 2MASX position is for the northern end of the galaxy.','G',0.000105,NULL,'16.1g',0.18,'Sc',NULL,NULL,NULL,NULL,1,226.547667,48.62972,0,NULL,59939434356,936553661,14633650,16.1),(126632,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126632,34.84,NULL,92.9,57616,NULL,NULL,NULL,'FGC 1856',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126633,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126633,34.87,NULL,94.2,57616,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1856',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126634,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126634,34.9,NULL,95.6,57616,NULL,NULL,'Dipole + Quadrupole','FGC 1856',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126635,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126635,34.93,NULL,96.9,57616,NULL,NULL,'Dipole','FGC 1856',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126636,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126636,36.5,0.27,199,57617,70,NULL,NULL,'CGCG 048-118',NULL,'2015arXiv151105856S',2015,1,0.87,NULL,'G',0.000123,NULL,'14.9g',0.71,'BrClG',NULL,NULL,NULL,NULL,1,226.548667,3.14258,0.109,NULL,59339064430,927172881,14487076,14.9),(126637,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126637,36.19,0.21,173,57618,70,NULL,NULL,'2MASX J15061220+0523342',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,226.550917,5.39272,0.077,NULL,59330269116,927035454,14484928,16.4),(126638,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126638,38.6,0.33,524,57619,70,NULL,NULL,'SDSS J150612.32+524715.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000138,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,226.551375,52.78767,0.041,NULL,59931635098,936431798,14631746,18.3),(126639,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126639,37.68,0.33,343,57620,70,NULL,NULL,'2MASX J15061242+3355107',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000189,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,226.55175,33.91953,0,NULL,60115538411,939305287,14676645,16.4),(126640,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126640,36.12,0.49,168,57621,75,NULL,'IR','CGCG 135-012',NULL,'2011yCatp016004901K',2011,1,0.79,NULL,'G',0.000081,NULL,'15.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,226.5540417,25.60769,0.117,NULL,59895134337,935861474,14622835,15.9),(126641,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126641,37.4,0.33,302,57622,70,NULL,NULL,'2MASXi J1506143+205135',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.559667,20.85964,0.101,NULL,59535410681,930240791,14535012,17.7),(126642,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126642,36.5,0.27,199,57623,70,NULL,NULL,'2MASX J15061597+0308342',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00009,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.566625,3.14292,0.109,NULL,59339064477,927172882,14487076,17.1),(126643,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126643,38.53,0.46,507,57624,70,NULL,NULL,'2MASX J15061687+2046162',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.5702917,20.77128,0.101,NULL,59535490091,930242032,14535031,17.6),(126644,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126644,38.16,0.46,428,57625,70,NULL,NULL,'2MASX J15061788+3651063',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.5744583,36.85186,0.017,NULL,60119934769,939373980,14677718,17.6),(126645,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126645,36.4,0.46,191,57626,70,NULL,NULL,'2MASX J15061790+6107524',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000086,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,226.574625,61.13125,0.013,NULL,57778430292,902787973,14106062,16.5),(126646,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126646,37.68,0.55,343,57627,NULL,NULL,'Malmquist cor.','AGC 251802',NULL,'2009ApJS..182..474S',2009,1,0.26,NULL,'G',0.00003,NULL,'17.70',0.07,'Sc',NULL,NULL,NULL,NULL,1,226.575083,28.72828,0.041,NULL,60080346345,938755411,14668053,17.7),(126647,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126647,37.71,0.54,349,57627,NULL,NULL,NULL,'AGC 251802',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126648,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126648,37.76,0.2,356,57627,74.4,NULL,NULL,'AGC 251802',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126649,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126649,36.19,0.66,173,57628,70,NULL,NULL,'2MASX J15061928-0146403',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.1g',0.25,'S0',NULL,NULL,NULL,NULL,1,226.580417,-1.77789,0.177,NULL,45367369497,708865148,11076017,16.1),(126650,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126650,36.71,0.46,220,57629,70,NULL,NULL,'2MASX J15061937+2930305',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000137,NULL,'17.57',0.19,'Sa',NULL,NULL,NULL,NULL,1,226.580667,29.50842,0.037,NULL,60094844583,938981946,14671592,17.57),(126651,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126651,37.32,0.46,291,57630,70,NULL,NULL,'2MASX J15061938+0324392',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000095,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,226.580833,3.41086,0.109,NULL,59339124066,927173813,14487090,16.5),(126652,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126652,34.61,0.54,83.5,57631,NULL,NULL,NULL,'ESO 328- G 017',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.16',0.4,'S...',NULL,NULL,NULL,NULL,1,226.582,-41.03028,0.289,NULL,47065289242,735395144,11490549,14.16),(126653,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126653,34.65,0.2,85.1,57631,74.4,NULL,NULL,'ESO 328- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126654,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126654,34.8,0.49,91.3,57631,NULL,NULL,'Malmquist cor.','ESO 328- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126655,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126655,37.92,0.46,384,57632,70,NULL,NULL,'2MASX J15062021+4508524',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000168,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,226.584375,45.14786,0.053,NULL,59993749260,937402332,14646911,16.9),(126656,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126656,36.5,0.27,199,57633,70,NULL,NULL,'2MASX J15062111+0309442',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000094,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,226.587875,3.16219,0.109,NULL,59339142215,927174097,14487095,16.7),(126657,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126657,36.75,0.33,224,57634,70,NULL,NULL,'2MASX J15062136+3634313',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000155,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,226.588875,36.57533,0.013,NULL,60119194678,939362416,14677537,17.3),(126658,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126658,37.75,0.27,355,57635,70,NULL,NULL,'2MASX J15062188+3131447',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,226.5912083,31.52917,0.021,NULL,60084826228,938825409,14669147,17.6),(126659,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126659,38.25,0.46,447,57636,70,NULL,NULL,'2MASX J15062195+3115267',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000193,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,226.591333,31.25731,0.025,NULL,60086587064,938852922,14669576,16.8),(126660,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126660,36.94,0.46,244,57637,70,NULL,NULL,'2MASX J15062195+2034181',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,226.591583,20.57164,0.105,NULL,59535286029,930238844,14534981,16.4),(126661,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126661,37.51,0.46,318,57638,70,NULL,NULL,'2MASX J15062197+0830456',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.591667,8.51272,0.041,NULL,59389052625,927953947,14499280,17.9),(126662,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126662,35.33,0.48,117,57639,70,NULL,NULL,'CGCG 020-060',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.000087,NULL,'15.1g',0.63,'E0',NULL,NULL,NULL,NULL,1,226.5927917,-1.75183,0.173,NULL,45367337401,708864646,11076010,15.1),(126663,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126663,35.8,0.33,145,57639,70,NULL,NULL,'CGCG 020-060',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126664,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126664,38.11,0.46,420,57640,70,NULL,NULL,'2MASX J15062285+0539272',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,226.5952083,5.65761,0.113,NULL,59330185103,927034142,14484908,17),(126665,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126665,37.42,0.46,305,57641,70,NULL,NULL,'2MASX J15062337+0809186',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,226.597333,8.155,0.053,NULL,59384449967,927882030,14498156,17.1),(126666,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126666,37.67,0.46,341,57642,70,NULL,NULL,'2MASX J15062429+1148475',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.95',0.15,NULL,NULL,NULL,NULL,NULL,1,226.6012917,11.81303,0.149,NULL,59345918700,927279979,14488749,18.95),(126667,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126667,34.67,0.53,86,57643,70,NULL,NULL,'MCG -02-38-034',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000143,NULL,'14.80',0.2,NULL,NULL,NULL,NULL,NULL,1,226.6025417,-9.90711,0.405,NULL,46490858690,726419667,11350307,14.8),(126668,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126668,34.47,0.46,78.3,57644,70,NULL,NULL,'2MASX J15062613-1407010',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00012,NULL,'15.25',NULL,'poss. LINER',NULL,NULL,NULL,NULL,1,226.6089583,-14.11697,0.441,NULL,46663425953,729116030,11392437,15.25),(126669,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126669,36.75,0.33,224,57645,70,NULL,NULL,'2MASX J15062625+3636214',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000186,NULL,'15.6g',0.49,'E0',NULL,NULL,NULL,NULL,1,226.6094583,36.60594,0.013,NULL,60119193527,939362398,14677537,15.6),(126670,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126670,37.85,0.46,372,57646,70,NULL,NULL,'2MASX J15062663+5226493',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000159,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.610917,52.44703,0.033,NULL,59930818147,936419033,14631547,17.8),(126671,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126671,35.61,0.46,133,57647,70,NULL,NULL,'2MASX J15062843+3825324',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000167,NULL,'15.8g',0.38,NULL,NULL,NULL,NULL,NULL,1,226.618417,38.42586,0.029,NULL,60103859095,939122798,14673793,15.8),(126672,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126672,36.58,0.33,207,57648,70,NULL,NULL,'MCG +08-27-065',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000186,NULL,'15.3g',0.58,'S0/a',NULL,NULL,NULL,NULL,1,226.6189583,46.34422,0.045,NULL,59984312679,937254885,14644607,15.3),(126673,'Tully est','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126673,32.27,0.8,28.5,57649,75,NULL,'B','NGC 5846A',NULL,'1988NBGC.C....0000T',1988,1,0.4,'Called \'NGC 5846b\' in MCG.','G',0.000047,NULL,'14.1',0.3,'cE2-3','is a companion galaxy',NULL,NULL,NULL,1,226.621667,1.59486,0.141,NULL,56373927838,880842622,13763165,14.1),(126674,'GCLF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126674,32.1,0.2,26.3,57650,NULL,NULL,'TOM(V) = -7.3 mag','NGC 5846',NULL,'2009ApJ...690..512H',2009,1,4.1,'Called \'NGC 5846a\' in MCG.','G',0.000017,NULL,'11.05',3.8,'E0-1;LINER     HII','Parent (of companion) galaxy',NULL,NULL,NULL,1,226.622,1.60561,0.141,NULL,56373926986,880842609,13763165,11.05),(126675,'GCLF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126675,32.32,0.23,29.1,57650,NULL,NULL,NULL,'NGC 5846',NULL,'1996AJ....112.2448F',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126676,'GCLF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126676,32.41,0.1,30.3,57650,NULL,NULL,NULL,'NGC 5846',NULL,'2002ApJ...567..294O',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126677,'GCLF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126677,32.61,0.28,33.3,57650,NULL,NULL,'HST KP Calibrated, V','NGC 5846',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126678,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126678,31.98,0.2,24.9,57650,NULL,NULL,'I','NGC 5846',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126679,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126679,31.98,0.2,24.9,57650,NULL,NULL,NULL,'NGC 5846',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126680,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126680,31.99,0.12,25,57650,74.4,NULL,NULL,'NGC 5846',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126681,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126681,32.04,0.2,25.6,57650,NULL,NULL,'Malmquist cor.','NGC 5846',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126682,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126682,32.05,0.22,25.7,57650,NULL,NULL,'HST KP Calibrated, I','NGC 5846',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126683,'D-Sigma','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126683,32.22,0.4,27.7,57650,75,NULL,'Edat, raw','NGC 5846',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126684,'D-Sigma','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126684,32.37,0.4,29.7,57650,75,NULL,'Edat, cor','NGC 5846',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126685,'D-Sigma','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126685,32.46,0.17,31.1,57650,72,NULL,'HDCE 0897 Group; HG 50 Group, 7 galaxies','NGC 5846',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126686,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126686,30.71,0.35,13.9,57650,95,NULL,'de Vaucouleurs','NGC 5846',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126687,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126687,31.26,0.25,17.9,57650,95,NULL,'Weighted Mean','NGC 5846',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126688,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126688,31.49,NULL,19.9,57650,NULL,NULL,'LEDA [April 2006]','NGC 5846',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126689,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126689,32.02,0.46,25.4,57650,95,NULL,'Michard 1979a','NGC 5846',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126690,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126690,32.32,0.63,29.1,57650,95,NULL,'Michard 1979b, c','NGC 5846',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126691,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126691,33.9,0.81,60.3,57650,55,NULL,'Visvanathan & Sandage 1979','NGC 5846',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126692,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126692,31.72,0.41,22,57650,NULL,NULL,NULL,'NGC 5846',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126693,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126693,31.97,0.41,24.8,57650,NULL,NULL,'Malmquist cor.','NGC 5846',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126694,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126694,31.99,0.12,25,57650,74.4,NULL,NULL,'NGC 5846',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126695,'Tertiary','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126695,31.08,0.25,16.4,57650,95,NULL,NULL,'NGC 5846',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126696,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126696,32.27,0.4,28.5,57650,75,NULL,'B','NGC 5846',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126697,'GCLF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126697,30.75,0.1,14.1,57651,NULL,NULL,'TOM(V) = 7.29 mag','NGC 5866',NULL,'2007ApJ...668..209C',2007,1,4.7,'z=0.002242 (1988AJ.....95.1602S), this may be M102','G',0.000017,NULL,'10.74',1.9,'S0_3       HII/LINER','X-ray-faint group member',NULL,NULL,'Sy',1,226.622917,55.76322,0,NULL,57579937041,899686516,14057601,10.74),(126698,'PNLF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126698,30.73,0.12,14,57651,NULL,NULL,NULL,'NGC 5866',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126699,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126699,30.84,0.14,14.7,57651,74.4,NULL,NULL,'NGC 5866',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126700,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126700,30.93,0.12,15.3,57651,NULL,NULL,'I','NGC 5866',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126701,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126701,29.12,0.63,6.67,57651,95,NULL,'Michard 1979b, c','NGC 5866',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126702,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126702,29.71,0.37,8.75,57651,95,NULL,'Weighted Mean','NGC 5866',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126703,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126703,29.84,0.46,9.29,57651,95,NULL,'Michard 1979a','NGC 5866',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126704,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126704,30.21,NULL,11,57651,NULL,NULL,'LEDA [April 2006]','NGC 5866',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126705,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126705,31.18,0.81,17.2,57651,55,NULL,'Visvanathan & Sandage 1979','NGC 5866',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126706,'Tully est','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126706,30.92,0.8,15.3,57651,75,NULL,'B','NGC 5866',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126707,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126707,29.66,0.45,8.54,57651,NULL,NULL,'K','NGC 5866',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126708,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126708,30.2,0.4,10.9,57651,NULL,NULL,'mean','NGC 5866',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126709,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126709,38.03,0.16,404,57652,70,NULL,NULL,'SDSS J150629.79+265242.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.624167,26.87856,0.085,NULL,59898119020,935908109,14623564,17.9),(126710,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126710,36.61,0.33,210,57653,70,NULL,NULL,'2MASX J15063058+3857084',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000176,NULL,'16.2g',0.32,NULL,NULL,NULL,NULL,NULL,1,226.6274583,38.95239,0.025,NULL,60100688440,939073256,14673019,16.2),(126711,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126711,38.58,0.46,520,57654,70,NULL,NULL,'2MASX J15063089-0221003',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000164,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,226.628875,-2.35008,0.221,NULL,46441500452,725648444,11338256,18.4),(126712,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126712,36.89,0.46,238,57655,70,NULL,NULL,'2MASX J15063135+0756278',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,226.6305417,7.94111,0.057,NULL,59384528720,927883261,14498175,17.1),(126713,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126713,36.99,0.46,250,57656,70,NULL,NULL,'2MASX J15063204+4526231',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,226.6337083,45.43981,0.045,NULL,59993545331,937399145,14646861,17),(126714,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126714,33.52,NULL,50.7,57657,NULL,NULL,NULL,'FGC 1854',NULL,'2000BSAO...50....5K',2000,1,1.34,NULL,'G',0.00001,NULL,'16.26',0.1,'Sdm',NULL,NULL,NULL,NULL,1,226.638791667,-12.71706,0.381,NULL,46662410369,729100162,11392190,16.26),(126715,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126715,33.56,NULL,51.6,57657,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1854',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126716,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126716,33.57,NULL,51.9,57657,NULL,NULL,'Dipole + Quadrupole','FGC 1854',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126717,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126717,33.58,NULL,51.9,57657,NULL,NULL,'Dipole','FGC 1854',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126718,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126718,35.8,0.33,145,57658,70,NULL,NULL,'2MASX J15063422-0151293',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00015,NULL,'16.3g',0.29,'E0',NULL,NULL,NULL,NULL,1,226.6427083,-1.85825,0.177,NULL,45367362908,708865045,11076016,16.3),(126719,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126719,36,0.61,159,57658,70,NULL,NULL,'2MASX J15063422-0151293',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126720,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126720,37.36,0.46,297,57659,70,NULL,NULL,'SDSS J150635.77+140458.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.649083,14.083,0.061,NULL,59570108044,930782938,14543483,17.9),(126721,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126721,37.43,0.17,306,57660,70,NULL,NULL,'2MASX J15063614-0117533',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,226.6505417,-1.29822,0.165,NULL,45369627127,708900423,11076569,16.9),(126722,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126722,36.3,0.46,182,57661,70,NULL,NULL,'2MASX J15063617+0938578',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.0001,NULL,'15.2g',0.55,NULL,NULL,NULL,NULL,NULL,1,226.650583,9.6495,0.061,NULL,59376779357,927762177,14496284,15.2),(126723,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126723,37.23,0.46,279,57662,70,NULL,NULL,'SDSS J150636.28+162614.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.651167,16.4375,0.037,NULL,59590968842,931108888,14548576,18.2),(126724,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126724,33.8,0.48,57.5,57663,70,NULL,NULL,'ESO 328- G 019',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000083,NULL,'14',0.9,'S0',NULL,NULL,NULL,NULL,1,226.65425,-41.31986,0.289,NULL,47064642275,735385035,11490391,14),(126725,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126725,37.83,0.46,368,57664,70,NULL,NULL,'NGC 5846 CH02',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000086,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,226.6555,1.22917,0.129,NULL,56375537841,880867778,13763559,17.1),(126726,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126726,36.43,0.46,194,57665,70,NULL,NULL,'2MASX J15063885+4456031',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.00019,NULL,'15.7g',0.44,'E0',NULL,NULL,NULL,NULL,1,226.661791667,44.93431,0.049,NULL,59993666799,937401043,14646891,15.7),(126727,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126727,37.02,0.46,253,57666,70,NULL,NULL,'2MASX J15063887+3559374',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.662083,35.99375,0.013,NULL,60128313644,939504900,14679764,17.2),(126728,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126728,37.43,0.17,306,57667,70,NULL,NULL,'SDSS J150639.65-011551.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000147,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,226.66525,-1.26444,0.193,NULL,45369627791,708900434,11076569,18.3),(126729,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126729,37,0.46,251,57668,70,NULL,NULL,'2MASXi J1506399+374415',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,226.666667,37.73761,0.017,NULL,60119473292,939366770,14677605,17.4),(126730,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126730,37.05,0.46,257,57669,70,NULL,NULL,'SDSS J150640.02+021726.2',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000075,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,226.6667917,2.29064,0.109,NULL,56374463749,880850996,13763296,17.2),(126731,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126731,36.61,0.33,210,57670,70,NULL,NULL,'2MASX J15064164+3854074',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.6735417,38.90192,0.025,NULL,60100677089,939073079,14673016,17.3),(126732,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126732,34.29,0.2,72.1,57671,74.4,NULL,NULL,'CGCG 077-006',NULL,'2013AJ....146...86T',2013,1,0.8,'HOLM 695B is a star.','G',0.000137,NULL,'14.9',0.8,NULL,NULL,NULL,NULL,NULL,1,226.67525,12.67644,0.109,NULL,59568020894,930750326,14542973,14.9),(126733,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126733,36.4,0.46,190,57672,70,NULL,NULL,'2MASX J15064216+2559425',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,226.675625,25.99519,0.117,NULL,59894995220,935859300,14622801,16.9),(126734,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126734,35.95,0.33,155,57673,70,NULL,NULL,'UGC 09719',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.000203,NULL,'14.8g',0.59,'COMPACT',NULL,NULL,NULL,NULL,1,226.6765,40.58067,0.029,NULL,59970592219,937040503,14641257,14.8),(126735,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126735,37.43,0.17,306,57674,70,NULL,NULL,'2MASX J15064238-0117092',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,226.676583,-1.28583,0.193,NULL,45369645433,708900709,11076573,16.4),(126736,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126736,37.43,0.17,306,57675,70,NULL,NULL,'2MASX J15064331-0121082',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.6805,-1.35222,0.165,NULL,45369598947,708899983,11076562,17.5),(126737,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126737,36.19,0.21,173,57676,70,NULL,NULL,'CGCG 049-003',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000157,NULL,'15.5',0.47,NULL,NULL,NULL,NULL,NULL,1,226.6809583,5.32719,0.077,NULL,59332431610,927069243,14485456,15.5),(126738,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126738,37.57,0.33,327,57677,70,NULL,NULL,'2MASX J15064395+0959578',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000144,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.683,9.99944,0.061,NULL,59346387959,927287311,14488864,17.7),(126739,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126739,38.6,0.33,524,57678,70,NULL,NULL,'2MASX J15064445+5248094',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000177,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.685083333,52.80253,0.037,NULL,59930581098,936415329,14631489,17.8),(126740,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126740,37.4,0.46,302,57679,70,NULL,NULL,'SDSS J150644.54+135011.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.685583,13.83642,0.077,NULL,59571139967,930799061,14543735,18.3),(126741,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126741,37.12,0.46,265,57680,70,NULL,NULL,'2MASX J15064480+2012112',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.85',0.16,NULL,NULL,NULL,NULL,NULL,1,226.686791667,20.20308,0.097,NULL,59537345331,930271020,14535484,17.85),(126742,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126742,34.29,0.49,72.1,57681,75,NULL,'IR','UGC 09712',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.00003,NULL,'15.02',0.3,'Scd:',NULL,NULL,NULL,NULL,1,226.688333,12.56139,0.113,NULL,59568016145,930750252,14542972,15.02),(126743,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126743,34.68,0.2,86.3,57681,74.4,NULL,NULL,'UGC 09712',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126744,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126744,36.98,0.46,249,57682,70,NULL,NULL,'2MASX J15064613-0149212',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.692125,-1.82264,0.173,NULL,45367330263,708864535,11076008,17.6),(126745,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126745,38.34,0.46,465,57683,70,NULL,NULL,'SDSS J150646.36+084955.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000171,NULL,'18.7g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.6932083,8.83206,0.045,NULL,59388351157,927942986,14499109,18.7),(126746,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126746,36.76,0.46,225,57684,70,NULL,NULL,'2MASX J15064725+2207203',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.98',0.19,NULL,NULL,NULL,NULL,NULL,1,226.696791667,22.12239,0.097,NULL,59527874802,930123043,14533172,16.98),(126747,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126747,37.57,0.33,327,57685,70,NULL,NULL,'SDSS J150648.11+095637.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000154,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.7004583,9.94375,0.061,NULL,59346388558,927287321,14488864,18.4),(126748,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126748,36.27,0.82,179,57686,70,NULL,NULL,'LCRS B150404.8-114604',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,226.703083,-11.95994,0.385,NULL,46481773275,726277707,11348089,16.8),(126749,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126749,36.06,0.46,163,57687,70,NULL,NULL,'2MASX J15064880+0844398',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,226.7032917,8.74433,0.045,NULL,59388392494,927943632,14499119,16.8),(126750,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126750,35.56,0.58,129,57688,70,NULL,NULL,'NGC 5849',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00011,NULL,'15',0.8,'poss. LINER',NULL,NULL,NULL,NULL,1,226.711208333,-14.57183,0.449,NULL,46663276372,729113693,11392401,15),(126751,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126751,37.46,0.27,310,57689,70,NULL,NULL,'2MASX J15065196+1033068',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,226.716416667,10.552,0.089,NULL,59347038133,927297470,14489022,18),(126752,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126752,38.43,0.46,484,57690,70,NULL,NULL,'SDSS J150652.62+151710.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'19.24',0.1,NULL,NULL,NULL,NULL,NULL,1,226.7187083,15.28642,0.061,NULL,59577202685,930893791,14545215,19.24),(126753,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126753,34.97,0.4,98.6,57691,NULL,NULL,'mean','NGC 5851',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000137,NULL,'15.04',0.3,'S?             LINER','in a pair',NULL,NULL,'LINER',1,226.722583333,12.85886,0.105,NULL,59567888635,930748259,14542941,15.04),(126754,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126754,35.04,0.47,102,57691,NULL,NULL,'H','NGC 5851',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126755,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126755,37.54,0.46,321,57692,70,NULL,NULL,'2MASX J15065390+3911441',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.724417,39.19553,0.037,NULL,60100572512,939071445,14672991,17.8),(126756,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126756,37.37,0.27,298,57693,70,NULL,NULL,'2MASX J15065403+1134028',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000173,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.7252917,11.56744,0.089,NULL,59348682277,927323160,14489424,17.7),(126757,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126757,37.83,0.46,368,57694,70,NULL,NULL,'2MASX J15065419+1529185',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,226.72575,15.48847,0.041,NULL,59577174983,930893359,14545208,NULL),(126758,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126758,37.43,0.17,306,57695,70,NULL,NULL,'2MASX J15065418-0107351',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00009,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.725833,-1.1265,0.193,NULL,45369732773,708902074,11076594,17.5),(126759,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126759,37.37,0.27,298,57696,70,NULL,NULL,'2MASX J15065525+1120408',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,226.730125,11.34456,0.065,NULL,59349065357,927329146,14489517,17.4),(126760,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126760,37.52,0.46,319,57697,70,NULL,NULL,'2MASX J15065553+0835528',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000185,NULL,'18.53',0.15,NULL,NULL,NULL,NULL,NULL,1,226.731583333,8.59789,0.041,NULL,59388336604,927942759,14499105,18.53),(126761,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126761,38.6,0.46,524,57698,70,NULL,NULL,'SDSS J150656.22+182919.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.6g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.73425,18.48878,0.053,NULL,59581916809,930967450,14546366,18.6),(126762,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126762,37.46,0.27,310,57699,70,NULL,NULL,'SDSS J150656.33+102606.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'18.0g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.734708333,10.43511,0.073,NULL,59346988208,927296690,14489010,18),(126763,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126763,37.46,0.27,310,57700,70,NULL,NULL,'2MASX J15065670+1027028',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00018,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,226.736333,10.45083,0.073,NULL,59346987554,927296680,14489010,16.3),(126764,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126764,37.42,0.46,304,57701,70,NULL,NULL,'2MASX J15065699+1819323',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,226.737583333,18.32569,0.037,NULL,59581844450,930966319,14546348,17.7),(126765,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126765,38.02,0.46,402,57702,70,NULL,NULL,'2MASX J15065745+0905478',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.7394583,9.09661,0.033,NULL,59388438076,927944344,14499130,17.6),(126766,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126766,37.43,0.17,306,57703,70,NULL,NULL,'2MASX J15065811-0105481',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000081,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.7422083,-1.09669,0.193,NULL,45369731590,708902056,11076594,17.8),(126767,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126767,38.06,0.46,409,57704,70,NULL,NULL,'2MASX J15065838+1259145',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,226.743375,12.98739,0.069,NULL,59567845100,930747579,14542930,17.9),(126768,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126768,37.85,0.33,372,57705,70,NULL,NULL,'SDSS J150658.44+071202.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000165,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.7435417,7.20064,0.045,NULL,59386196359,927909318,14498583,18.3),(126769,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126769,38.36,0.46,469,57706,70,NULL,NULL,'2MASX J15065852+4802503',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,226.744,48.04728,0.009,NULL,59939712943,936558014,14633718,17.9),(126770,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126770,36.98,0.46,249,57707,70,NULL,NULL,'SDSS J150659.59+323039.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.748333,32.51103,0.065,NULL,60085093268,938829582,14669212,17.9),(126771,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126771,37.72,0.46,349,57708,70,NULL,NULL,'2MASX J15065978+0627346',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,226.749208333,6.4595,0.057,NULL,59385560424,927899381,14498427,17.7),(126772,'Magnetic energy','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126772,21.28,NULL,0.18,57709,NULL,NULL,'1.7 microgauss, Vorster et al. 2013','2FGL J1507.0-6223',NULL,'2014arXiv1404.0889D',2014,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,226.752,-62.397,NULL,0,44880809418,701262647,10957228,NULL),(126773,'Magnetic energy','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126773,28.01,NULL,4,57709,NULL,NULL,'1 microgauss','2FGL J1507.0-6223',NULL,'2014arXiv1404.0889D',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126774,'Magnetic energy','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126774,35,NULL,100,57709,NULL,NULL,'hadronic senario','2FGL J1507.0-6223',NULL,'2014arXiv1404.0889D',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126775,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126775,35.67,0.46,136,57710,70,NULL,NULL,'CGCG 135-017',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.000177,NULL,'14.9g',0.63,NULL,NULL,NULL,NULL,NULL,1,226.752625,25.75417,0.117,NULL,59895038648,935859978,14622812,14.9),(126776,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126776,37.53,0.15,320,57711,70,NULL,NULL,'2MASX J15070116+0844026',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.754958333,8.73403,0.045,NULL,59388357433,927943084,14499110,17.4),(126777,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126777,37.83,0.46,369,57712,70,NULL,NULL,'SDSS J150701.46+034609.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000075,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,226.756125,3.76936,0.089,NULL,59330674627,927041791,14485027,18.3),(126778,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126778,36.01,0.46,159,57713,70,NULL,NULL,'2MASX J15070302+0353404',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000095,NULL,'16.1g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,226.762583,3.8945,0.089,NULL,59331395582,927053055,14485203,16.1),(126779,'IRAS','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126779,36.11,0.8,167,57714,75,NULL,'CF, r','UGC 09718',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.00001,NULL,'14.93',0.5,'Sb',NULL,NULL,NULL,NULL,1,226.76725,21.21067,0.117,NULL,59535917138,930248705,14535136,14.93),(126780,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126780,35.55,0.38,129,57714,75,NULL,'CF, r, raw','UGC 09718',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126781,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126781,35.74,0.38,140,57714,75,NULL,'CF, r, inv','UGC 09718',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126782,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126782,35.85,0.38,148,57714,75,NULL,'CF, r, cor','UGC 09718',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126783,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126783,36.31,0.2,183,57714,74.4,NULL,NULL,'UGC 09718',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126784,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126784,37.37,0.27,298,57715,70,NULL,NULL,'2MASX J15070450+1132196',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.83',0.22,NULL,NULL,NULL,NULL,NULL,1,226.768875,11.53869,0.089,NULL,59349141635,927330338,14489536,17.83),(126785,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126785,37.53,0.15,320,57716,70,NULL,NULL,'2MASX J15070460+0845066',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,226.7692917,8.75175,0.045,NULL,59388357144,927943080,14499110,17.1),(126786,'Ring Diameter','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126786,30.7,0.84,14,57717,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5850',NULL,'1981ApJS...45..541P',1981,1,4.3,NULL,'G',0.000013,NULL,'12.7g',3.7,'SB(r)b','in a pair',NULL,NULL,NULL,1,226.782041667,1.54425,0.145,NULL,56373870701,880841729,13763152,12.7),(126787,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126787,31.25,NULL,17.8,57717,NULL,NULL,'B','NGC 5850',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126788,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126788,32.27,0.4,28.5,57717,75,NULL,'B','NGC 5850',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126789,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126789,37.66,0.46,340,57718,70,NULL,NULL,'2MASX J15070837+0748396',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,226.784875,7.81106,0.057,NULL,59384377274,927880894,14498138,16.9),(126790,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126790,37.14,0.13,268,57719,70,NULL,NULL,'2MASX J15070904+2823181',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.74',0.14,NULL,NULL,NULL,NULL,NULL,1,226.78775,28.38828,0.045,NULL,60080435206,938756800,14668075,18.74),(126791,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126791,35.95,0.33,155,57720,70,NULL,NULL,'2MASX J15070971+4051132',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000189,NULL,'15.9g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,226.790625,40.85375,0.029,NULL,59970980894,937046576,14641352,15.9),(126792,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126792,38.6,0.33,524,57721,70,NULL,NULL,'SDSS J150710.20-021210.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000179,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,226.7925417,-2.203,0.213,NULL,45367551386,708867990,11076062,18.6),(126793,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126793,38.12,0.46,420,57722,70,NULL,NULL,'2MASX J15071141+1617155',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,226.7975417,16.28769,0.037,NULL,59582331786,930973934,14546467,NULL),(126794,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126794,35.79,0.46,144,57723,70,NULL,NULL,'2MASX J15071294+0401061',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000081,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,226.803875,4.01833,0.085,NULL,59331433084,927053641,14485213,16.5),(126795,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126795,38.03,0.46,403,57724,70,NULL,NULL,'2MASX J15071385+1706485',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.68',0.15,NULL,NULL,NULL,NULL,NULL,1,226.807625,17.11353,0.037,NULL,59582872555,930982383,14546599,18.68),(126796,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126796,38.14,0.46,425,57725,70,NULL,NULL,'2MASX J15071422+2259463',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000145,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,226.80925,22.99608,0.113,NULL,59409765732,928277589,14504337,17.6),(126797,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126797,37.43,0.17,306,57726,70,NULL,NULL,'2MASX J15071569-0116580',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000189,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.815583,-1.28275,0.193,NULL,45369618201,708900284,11076566,17.2),(126798,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126798,37.9,0.46,381,57727,70,NULL,NULL,'2MASX J15071604+5407481',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.816708333,54.13014,0.021,NULL,59660813897,932200217,14565628,17.8),(126799,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126799,38.63,0.46,532,57728,70,NULL,NULL,'SDSS J150717.14+101318.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000174,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.8214583,10.22186,0.069,NULL,59347145714,927299151,14489049,17.9),(126800,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126800,37.85,0.33,372,57729,70,NULL,NULL,'SDSS J150717.18+071105.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000173,NULL,'18.1g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.821625,7.18481,0.045,NULL,59386193073,927909266,14498582,18.1),(126801,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126801,38.6,0.33,524,57730,70,NULL,NULL,'SDSS J150718.19-021749.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.825833,-2.29708,0.213,NULL,45366809165,708856393,11075881,18.1),(126802,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126802,37.59,0.46,330,57731,70,NULL,NULL,'2MASX J15071893+1638034',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.15',0.2,NULL,NULL,NULL,NULL,NULL,1,226.829,16.63439,0.037,NULL,59582800570,930981258,14546582,18.15),(126803,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126803,37.5,0.46,316,57732,70,NULL,NULL,'2MASX J15071918+0652466',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.8299583,6.87961,0.049,NULL,59386507133,927914173,14498658,17.1),(126804,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126804,36.77,0.46,225,57733,70,NULL,NULL,'2MASX J15071993+1058426',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000167,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,226.8329583,10.97858,0.073,NULL,59348992622,927328009,14489500,16.6),(126805,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126805,38.04,0.33,405,57734,70,NULL,NULL,'2MASX J15072006+0703406',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.8335,7.06144,0.045,NULL,59387076184,927923065,14498797,17.3),(126806,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126806,37.95,0.14,390,57735,70,NULL,NULL,'2MASX J15072007-0021590',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00008,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,226.8337917,-0.3665,0.169,NULL,45368185766,708877902,11076217,18.1),(126807,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126807,35.22,0.54,111,57736,70,NULL,NULL,'2MASX J15072054-3835425',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'13.6I',0.6,NULL,NULL,NULL,NULL,NULL,1,226.8355,-38.59511,0.233,NULL,47189380988,737334077,11520844,13.6),(126808,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126808,35.99,0.7,158,57737,70,NULL,NULL,'2MASX J15072131-3836295',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,226.838917,-38.60828,0.233,NULL,47189381104,737334079,11520844,14.5),(126809,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126809,36.24,0.27,177,57738,70,NULL,NULL,'2MASX J15072141+1608224',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.95',0.2,NULL,NULL,NULL,NULL,NULL,1,226.839167,16.13956,0.037,NULL,59590677153,931104330,14548505,16.95),(126810,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126810,36.43,0.46,193,57739,70,NULL,NULL,'CGCG 077-013',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.000153,NULL,'15.0g',0.55,NULL,NULL,NULL,NULL,NULL,1,226.839667,9.92808,0.061,NULL,59346399337,927287489,14488867,15),(126811,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126811,37.74,0.46,352,57740,70,NULL,NULL,'2MASX J15072173+2659239',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.40',0.17,NULL,NULL,NULL,NULL,NULL,1,226.8405,26.99014,0.085,NULL,59898284631,935910697,14623604,18.4),(126812,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126812,36.24,0.27,177,57741,70,NULL,NULL,'SDSS J150722.10+161501.5',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'15.6g',0.46,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.842083,16.25044,0.037,NULL,59582324598,930973821,14546465,15.6),(126813,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126813,37.16,0.33,270,57742,70,NULL,NULL,'2MASX J15072266+2048052',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.56',0.21,NULL,NULL,NULL,NULL,NULL,1,226.844417,20.80156,0.105,NULL,59535465453,930241647,14535025,17.56),(126814,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126814,36.76,0.46,225,57743,70,NULL,NULL,'2MASX J15072356+0354371',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00008,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,226.848167,3.91017,0.085,NULL,59331438717,927053729,14485214,17.1),(126815,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126815,35.81,0.46,145,57744,70,NULL,NULL,'2MASX J15072408+3404340',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000157,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,226.850417,34.07611,0.017,NULL,60116024869,939312888,14676763,16.5),(126816,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126816,37.53,0.15,320,57745,70,NULL,NULL,'2MASX J15072530+0829446',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000097,NULL,'15.4g',0.55,NULL,NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,226.8555,8.49569,0.053,NULL,59384078099,927876220,14498065,15.4),(126817,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126817,35.26,0.46,113,57746,70,NULL,NULL,'2MASX J15072560+1025096',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.66',0.27,NULL,NULL,NULL,NULL,NULL,1,226.856583,10.41917,0.073,NULL,59346980182,927296565,14489008,17.66),(126818,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126818,35.58,0.33,131,57747,70,NULL,NULL,'IC 1089',NULL,'2015arXiv151105856S',2015,1,0.91,NULL,'G',0.000167,NULL,'14.7g',0.64,NULL,NULL,NULL,NULL,NULL,1,226.858291667,7.11675,0.045,NULL,59387057834,927922778,14498793,14.7),(126819,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126819,38.04,0.33,405,57748,70,NULL,NULL,'2MASX J15072631+0702506',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.6g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,226.8597917,7.04744,0.045,NULL,59387074004,927923031,14498797,16.6),(126820,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126820,34.2,0.47,69.3,57749,NULL,NULL,'H','NGC 5857',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000083,NULL,'13.86',0.6,'SB(s)b','Pair member, S + S',NULL,NULL,NULL,1,226.8637917,19.59764,0.057,NULL,59537503313,930273489,14535523,13.86),(126821,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126821,34.22,0.45,69.8,57749,NULL,NULL,'K','NGC 5857',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126822,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126822,34.24,0.4,70.4,57749,NULL,NULL,'mean','NGC 5857',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126823,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126823,34.27,0.46,71.4,57749,NULL,NULL,'J','NGC 5857',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126824,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126824,37.53,0.15,320,57750,70,NULL,NULL,'2MASX J15072766+0833115',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000165,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,226.865375,8.55339,0.053,NULL,59384129755,927877027,14498078,17),(126825,'IRAS','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126825,33.68,0.8,54.4,57751,75,NULL,'MAT, I','NGC 5843',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'13.11',1.1,'SB(s)b:        HII',NULL,NULL,NULL,NULL,1,226.8662083,-36.32742,0.309,NULL,47240598309,738134348,11533349,13.11),(126826,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126826,33.31,0.43,46,57751,75,NULL,'MAT, I, raw','NGC 5843',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126827,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126827,33.41,0.32,48,57751,85,NULL,'I, raw','NGC 5843',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126828,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126828,33.48,0.32,49.7,57751,85,NULL,'I, inv','NGC 5843',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126829,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126829,33.49,0.47,50,57751,NULL,NULL,'H','NGC 5843',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126830,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126830,33.5,0.45,50,57751,NULL,NULL,'K','NGC 5843',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126831,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126831,33.51,0.46,50.3,57751,NULL,NULL,'J','NGC 5843',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126832,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126832,33.61,0.43,52.8,57751,75,NULL,'MAT, I, inv','NGC 5843',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126833,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126833,33.73,0.43,55.6,57751,75,NULL,'MAT, I, cor','NGC 5843',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126834,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126834,33.75,0.39,56.2,57751,NULL,NULL,NULL,'NGC 5843',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126835,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126835,33.79,0.4,57.4,57751,NULL,NULL,'mean','NGC 5843',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126836,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126836,33.86,0.2,59.2,57751,74.4,NULL,NULL,'NGC 5843',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126837,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126837,33.95,0.35,61.6,57751,NULL,NULL,'Malmquist cor.','NGC 5843',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126838,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126838,37.72,0.46,350,57752,70,NULL,NULL,'2MASX J15072921+2742109',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.29',0.16,NULL,NULL,NULL,NULL,NULL,1,226.871708333,27.70314,0.057,NULL,59897215768,935893996,14623343,18.29),(126839,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126839,37.94,0.46,387,57753,70,NULL,NULL,'SDSS J150730.01+230817.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000152,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,226.875041667,23.13828,0.109,NULL,59409789344,928277958,14504343,18.8),(126840,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126840,38.41,0.46,482,57754,70,NULL,NULL,'SDSS J150730.06+185523.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.8752917,18.92331,0.057,NULL,59536354028,930255531,14535242,18.1),(126841,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126841,36.57,0.46,206,57755,70,NULL,NULL,'2MASX J15073079+3931003',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,226.87825,39.51675,0.029,NULL,60101028246,939078566,14673102,17.2),(126842,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126842,36.24,0.27,177,57756,70,NULL,NULL,'CGCG 106-004',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00015,NULL,'15.6',0.6,NULL,'Group member',NULL,NULL,NULL,1,226.881,16.19783,0.037,NULL,59582374232,930974597,14546478,15.6),(126843,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126843,37.88,0.46,376,57757,70,NULL,NULL,'2MASX J15073260+0102591',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000092,NULL,'16.8g',0.3,'AGN',NULL,NULL,NULL,NULL,1,226.8860417,1.04972,0.129,NULL,56375469057,880866704,13763542,16.8),(126844,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126844,36.41,0.46,192,57758,70,NULL,NULL,'2MASX J15073259+0744568',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000189,NULL,'16.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,226.8860417,7.74919,0.057,NULL,59384387950,927881061,14498141,16.1),(126845,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126845,35.58,0.33,131,57759,70,NULL,NULL,'2MASX J15073381+0707148',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000156,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,226.890875,7.12081,0.045,NULL,59387057269,927922769,14498793,16.4),(126846,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126846,37.78,0.33,360,57760,70,NULL,NULL,'2MASX J15073439+0239271',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,226.893375,2.65775,0.113,NULL,56373641387,880838146,13763096,17.3),(126847,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126847,33.34,0.47,46.5,57761,NULL,NULL,'H','NGC 5859',NULL,'2007A&A...465...71T',2007,1,2.9,NULL,'G',0.000017,NULL,'13.27',0.9,'SB(s)bc','Pair member, S + S',NULL,NULL,NULL,1,226.89475,19.58231,0.057,NULL,59537499603,930273431,14535522,13.27),(126848,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126848,33.38,0.46,47.5,57761,NULL,NULL,'J','NGC 5859',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126849,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126849,33.41,0.45,48,57761,NULL,NULL,'K','NGC 5859',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126850,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126850,34.24,0.4,70.4,57761,NULL,NULL,'mean','NGC 5859',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126851,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126851,37.26,0.21,283,57762,70,NULL,NULL,'2MASX J15073470+1019548',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,226.894667,10.33194,0.073,NULL,59347142322,927299098,14489048,17.9),(126852,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126852,37.16,0.33,270,57763,70,NULL,NULL,'2MASX J15073485+2049162',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.8955,20.82103,0.105,NULL,59535459375,930241552,14535024,17.7),(126853,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126853,37.52,0.46,319,57764,70,NULL,NULL,'2MASX J15073583+1903372',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,226.899333,19.06033,0.057,NULL,59536331300,930255176,14535237,16.5),(126854,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126854,35.69,0.46,138,57765,70,NULL,NULL,'2MASX J15073763+0653228',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000168,NULL,'17.23',0.37,NULL,NULL,NULL,NULL,NULL,1,226.906875,6.88983,0.049,NULL,59386548421,927914819,14498669,17.23),(126855,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126855,37.36,0.46,297,57766,70,NULL,NULL,'2MASX J15073786+0430348',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000084,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,226.9077917,4.50975,0.093,NULL,59331242530,927050664,14485166,16.9),(126856,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126856,37.53,0.15,320,57767,70,NULL,NULL,'2MASX J15073898+0816568',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000168,NULL,'16.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,226.912333,8.28244,0.053,NULL,59384984829,927890387,14498287,16.6),(126857,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126857,35.71,0.52,139,57768,70,NULL,NULL,'CGCG 021-008',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.000096,NULL,'15.7g',0.29,'S0/a',NULL,NULL,NULL,NULL,1,226.913833,-0.10947,0.161,NULL,45368133871,708877091,11076204,15.7),(126858,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126858,36.56,0.46,205,57769,70,NULL,NULL,'2MASX J15074014+3926084',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,226.917333,39.43575,0.037,NULL,60100984458,939077882,14673091,16.7),(126859,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126859,38.63,0.46,531,57770,70,NULL,NULL,'2MASX J15074027+2300531',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000134,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,226.917833,23.01475,0.113,NULL,59410075878,928282435,14504413,18.3),(126860,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126860,37.1,0.46,263,57771,70,NULL,NULL,'2MASX J15074027+2122301',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,226.918,21.37494,0.121,NULL,59535073800,930235528,14534930,18),(126861,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126861,37.72,0.46,350,57772,70,NULL,NULL,'2MASX J15074045+1813451',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.918583,18.22931,0.037,NULL,59583864489,930997882,14546841,17.6),(126862,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126862,37.24,0.46,280,57773,70,NULL,NULL,'2MASX J15074108+2640249',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.60',0.22,NULL,NULL,NULL,NULL,NULL,1,226.921083333,26.67361,0.101,NULL,59898279440,935910616,14623603,17.6),(126863,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126863,37.95,0.14,390,57774,70,NULL,NULL,'SDSS J150741.07-001715.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000063,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,226.921125,-0.28753,0.161,NULL,45368162571,708877540,11076211,18.5),(126864,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126864,39.11,0.46,663,57775,70,NULL,NULL,'SDSS J150743.84+090528.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000168,NULL,'18.9g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.9327083,9.09133,0.033,NULL,59388262755,927941605,14499087,18.9),(126865,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126865,37.26,0.21,283,57776,70,NULL,NULL,'2MASX J15074500+1015418',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,226.9375,10.26167,0.073,NULL,59347156732,927299323,14489051,16.6),(126866,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126866,37.44,0.33,307,57777,70,NULL,NULL,'2MASX J15074610+0329588',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000096,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.942125,3.49961,0.081,NULL,59330742568,927042852,14485044,17.3),(126867,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126867,30.51,0.63,12.6,57778,95,NULL,'Michard 1979b, c','NGC 5854',NULL,'1984ApJS...56...91D',1984,1,2.95,NULL,'G',0.000017,NULL,'12.7g',0.74,'SB(s)0+','in a radial-velocity based grouping',NULL,NULL,NULL,1,226.94875,2.56864,0.113,NULL,56373779101,880840298,13763129,12.7),(126868,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126868,30.89,0.44,15.1,57778,95,NULL,'Weighted Mean','NGC 5854',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126869,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126869,31.48,0.46,19.8,57778,95,NULL,'Michard 1979a','NGC 5854',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126870,'Tertiary','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126870,31.08,0.25,16.4,57778,95,NULL,NULL,'NGC 5854',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126871,'Tully est','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126871,32.27,0.8,28.5,57778,75,NULL,'B','NGC 5854',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126872,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126872,30.87,0.45,14.9,57778,NULL,NULL,'K','NGC 5854',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126873,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126873,31.86,NULL,23.5,57778,72,NULL,NULL,'NGC 5854',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126874,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126874,32.16,0.4,27,57778,NULL,NULL,'mean','NGC 5854',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126875,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126875,37.94,0.33,387,57779,70,NULL,NULL,'2MASX J15074806+2202391',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.44',0.2,NULL,NULL,NULL,NULL,NULL,1,226.950167,22.04428,0.121,NULL,59527698808,930120293,14533129,17.44),(126876,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126876,37.26,0.21,283,57780,70,NULL,NULL,'2MASX J15074805+1019018',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000209,NULL,'15.8g',0.41,NULL,NULL,NULL,NULL,NULL,1,226.95025,10.31728,0.073,NULL,59347143657,927299119,14489048,15.8),(126877,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126877,37.31,0.46,290,57781,70,NULL,NULL,'2MASX J15075014+2842260',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,226.958917,28.70736,0.041,NULL,60080508588,938757946,14668092,17.9),(126878,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126878,37.57,0.46,326,57782,70,NULL,NULL,'2MASX J15075019+1332577',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,226.959041667,13.5495,0.077,NULL,59571585251,930806019,14543844,17.5),(126879,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126879,37.26,0.21,283,57783,70,NULL,NULL,'2MASX J15075103+1012298',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00015,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.9625,10.20814,0.073,NULL,59347151292,927299238,14489050,17.2),(126880,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126880,35.34,0.59,117,57784,70,NULL,NULL,'2MASX J15075112-0922108',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.45',0.8,NULL,NULL,NULL,NULL,NULL,1,226.963167,-9.36981,0.405,NULL,46490768784,726418262,11350285,15.45),(126881,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126881,37.2,0.46,276,57785,70,NULL,NULL,'2MASX J15075116+1149488',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000176,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,226.963291667,11.83006,0.089,NULL,59348727658,927323869,14489435,16.9),(126882,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126882,37.75,0.46,355,57786,70,NULL,NULL,'SDSS J150751.50+370450.3',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000152,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,226.964625,37.08064,0.017,NULL,60119143549,939361617,14677525,17.6),(126883,'Sosies','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126883,33.41,0.28,48.1,57787,NULL,NULL,NULL,'NGC 5874',NULL,'2002A&A...393...57T',2002,1,1.27,NULL,'G',0.000007,NULL,'13.7g',1.17,'SAB(rs)c       HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,226.965958333,54.75278,0.013,NULL,57579806229,899684472,14057569,13.7),(126884,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126884,33.51,0.4,50.4,57787,NULL,NULL,'mean','NGC 5874',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126885,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126885,33.53,0.2,50.8,57787,74.4,NULL,NULL,'NGC 5874',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126886,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126886,33.58,0.46,51.9,57787,NULL,NULL,NULL,'NGC 5874',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126887,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126887,33.58,0.46,52.1,57787,NULL,NULL,'Malmquist cor.','NGC 5874',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126888,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126888,33.99,0.46,62.7,57787,NULL,NULL,'J','NGC 5874',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126889,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126889,34.01,0.47,63.4,57787,NULL,NULL,'H','NGC 5874',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126890,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126890,34.02,0.45,63.6,57787,NULL,NULL,'K','NGC 5874',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126891,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126891,37.67,0.46,342,57788,70,NULL,NULL,'SDSS J150752.56+054418.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.9690417,5.73856,0.077,NULL,59332332851,927067700,14485432,18.5),(126892,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126892,37.44,0.33,307,57789,70,NULL,NULL,'2MASX J15075291+0337358',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000076,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,226.9704583,3.62658,0.069,NULL,59330682402,927041912,14485029,17.4),(126893,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126893,38.01,0.46,400,57790,70,NULL,NULL,'SDSS J150753.54+272939.9',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,226.973083,27.49442,0.065,NULL,59897232846,935894263,14623347,NULL),(126894,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126894,37.98,0.27,395,57791,70,NULL,NULL,'2MASX J15075382+4621043',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000172,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,226.974375,46.35133,0.057,NULL,59984166564,937252602,14644571,18),(126895,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126895,37.72,0.46,351,57792,70,NULL,NULL,'2MASX J15075397+3755044',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000148,NULL,'17.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,226.975083333,37.91786,0.017,NULL,60101863060,939091610,14673306,17.5),(126896,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126896,36.55,0.46,204,57793,70,NULL,NULL,'2MASX J15075440+0108168',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000026,NULL,'16.4g',0.34,'BLAGN',NULL,NULL,NULL,'Sy 1',1,226.976583,1.138,0.129,NULL,56374765420,880855709,13763370,16.4),(126897,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126897,36.73,0.46,222,57794,70,NULL,NULL,'2MASX J15075653+0905058',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000179,NULL,'16.0g',0.4,NULL,NULL,NULL,NULL,NULL,1,226.9857083,9.08511,0.033,NULL,59388256122,927941501,14499085,16),(126898,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126898,34.14,0.46,67.4,57795,70,NULL,NULL,'CGCG 274-019',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00008,NULL,'14.7g',0.53,'S0^-','Group member',NULL,NULL,NULL,1,226.985833,52.52247,0.033,NULL,59930621537,936415961,14631499,14.7),(126899,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126899,37.78,0.33,360,57796,70,NULL,NULL,'2MASX J15075693+0235358',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000087,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.9872917,2.59328,0.113,NULL,56373785439,880840397,13763131,17.8),(126900,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126900,37.53,0.15,320,57797,70,NULL,NULL,'2MASX J15075707+0816393',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,226.987833333,8.27758,0.053,NULL,59384974611,927890228,14498284,17),(126901,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126901,36.63,0.46,212,57798,70,NULL,NULL,'2MASX J15075775+2852550',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.83',0.24,'E',NULL,NULL,NULL,NULL,1,226.990583,28.88186,0.041,NULL,60080290398,938754537,14668039,17.83),(126902,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126902,37.53,0.15,320,57799,70,NULL,NULL,'2MASX J15075802+0812183',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',NULL,NULL,'16.0g',0.39,NULL,NULL,NULL,NULL,NULL,1,226.991875,8.20519,0.053,NULL,59384945059,927889766,14498277,16),(126903,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126903,37.26,0.21,283,57800,70,NULL,NULL,'2MASX J15075849+1020533',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,226.9937083,10.34822,0.073,NULL,59347273037,927301141,14489080,17.3),(126904,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126904,36.41,0.46,191,57801,70,NULL,NULL,'2MASX J15080021+1127133',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,227.001,11.45375,0.089,NULL,59349182494,927330976,14489546,17.2),(126905,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126905,38.4,0.46,479,57802,70,NULL,NULL,'2MASX J15080035+1318178',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.0015,13.30494,0.097,NULL,59571490734,930804542,14543820,18.1),(126906,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126906,37.95,0.14,390,57803,70,NULL,NULL,'SDSS J150801.02-001712.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000083,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,227.004291667,-0.28689,0.161,NULL,45368128768,708877012,11076203,18.6),(126907,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126907,37.19,0.46,274,57804,70,NULL,NULL,'2MASX J15080153+0352338',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000076,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.0064583,3.87617,0.085,NULL,59331409416,927053272,14485207,17.1),(126908,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126908,37.58,0.46,328,57805,70,NULL,NULL,'2MASX J15080155+1911483',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.0064583,19.19686,0.069,NULL,59536326855,930255107,14535236,17.3),(126909,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126909,37.94,0.33,387,57806,70,NULL,NULL,'2MASX J15080257+2159113',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,227.010667,21.9865,0.121,NULL,59539218966,930300296,14535942,17.8),(126910,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126910,37.53,0.15,320,57807,70,NULL,NULL,'SDSS J150802.99+081831.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000156,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.0125,8.30878,0.053,NULL,59384971576,927890180,14498284,18.3),(126911,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126911,38.7,0.33,549,57808,70,NULL,NULL,'SDSS J150803.29+291024.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'19.11',0.13,NULL,NULL,NULL,NULL,NULL,1,227.0137083,29.1735,0.041,NULL,60094108495,938970445,14671413,19.11),(126912,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126912,37.11,0.46,264,57809,70,NULL,NULL,'2MASX J15080372+2715440',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',NULL,NULL,'16.98',0.33,NULL,NULL,NULL,NULL,NULL,1,227.0157083,27.26231,0.077,NULL,59897129271,935892644,14623322,16.98),(126913,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126913,38.9,0.46,604,57810,70,NULL,NULL,'2MASX J15080407+2855150',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.016833,28.92106,0.041,NULL,60080289223,938754519,14668039,18),(126914,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126914,37.53,0.15,320,57811,70,NULL,NULL,'2MASX J15080408+0813543',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.017083333,8.23158,0.053,NULL,59384943339,927889739,14498277,17.5),(126915,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126915,38.29,0.46,454,57812,70,NULL,NULL,'SDSS J150804.13+195159.4',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.5g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.01725,19.86653,0.065,NULL,59538059598,930282181,14535659,17.5),(126916,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126916,37.18,0.46,272,57813,70,NULL,NULL,'2MASX J15080546+0120539',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000075,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.022666667,1.34831,0.145,NULL,56374825053,880856641,13763385,17.6),(126917,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126917,38.07,0.46,411,57814,70,NULL,NULL,'2MASX J15080567+3020135',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,227.0235,30.33697,0.033,NULL,60086115020,938845547,14669461,17.5),(126918,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126918,37.95,0.14,390,57815,70,NULL,NULL,'2MASX J15080682-0009303',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00008,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,227.028583,-0.15853,0.161,NULL,45368139453,708877178,11076205,17.1),(126919,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126919,37.4,0.46,302,57816,70,NULL,NULL,'2MASX J15080697+2946040',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000133,NULL,'17.97',0.21,'E',NULL,NULL,NULL,NULL,1,227.029167,29.76786,0.037,NULL,60085639862,938838122,14669345,17.97),(126920,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126920,38.19,0.46,434,57817,70,NULL,NULL,'2MASX J15080786+0051469',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000078,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.032833,0.86283,0.133,NULL,56372831351,880825489,13762898,17.5),(126921,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126921,37.98,0.27,395,57818,70,NULL,NULL,'2MASX J15080803+4626443',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,227.033625,46.44581,0.057,NULL,59984173763,937252715,14644573,18.2),(126922,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126922,36.37,0.46,188,57819,70,NULL,NULL,'2MASX J15080825+2654580',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00042,NULL,'17.51',0.24,NULL,NULL,NULL,NULL,NULL,1,227.034416667,26.916,0.085,NULL,59898253197,935910206,14623596,17.51),(126923,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126923,36.49,0.46,199,57820,70,NULL,NULL,'2MASX J15080889+3601078',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000182,NULL,'15.9g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,227.037041667,36.01894,0.013,NULL,60127625434,939494147,14679596,15.9),(126924,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126924,38.44,0.46,487,57821,70,NULL,NULL,'SDSS J150810.36+025708.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00008,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,227.043208333,2.95247,0.093,NULL,59325293922,926957717,14483714,18.6),(126925,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126925,37.65,0.46,338,57822,70,NULL,NULL,'2MASX J15081103+1303188',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,227.0459583,13.05514,0.081,NULL,59571352352,930802380,14543787,17.1),(126926,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126926,38.03,0.16,404,57823,70,NULL,NULL,'2MASX J15081182+2714249',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.56',0.16,NULL,NULL,NULL,NULL,NULL,1,227.049375,27.24031,0.077,NULL,59897136208,935892753,14623324,18.56),(126927,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126927,37.51,0.46,318,57824,70,NULL,NULL,'2MASX J15081241+1759302',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,227.051833,17.99183,0.041,NULL,59584123600,931001931,14546905,16.8),(126928,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126928,37.71,0.46,348,57825,70,NULL,NULL,'SDSS J150812.67+274921.2',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'18.0g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.052833,27.82258,0.057,NULL,59897733901,935902092,14623470,18),(126929,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126929,38.03,0.16,404,57826,70,NULL,NULL,'SDSS J150813.22+270736.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.055125,27.12667,0.081,NULL,59897126666,935892604,14623321,18.2),(126930,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126930,38.3,0.46,456,57827,70,NULL,NULL,'2MASX J15081328+2538159',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000163,NULL,'17.4g',0.2,'BrClG',NULL,NULL,NULL,NULL,1,227.055291667,25.63789,0.129,NULL,59894940346,935858442,14622788,17.4),(126931,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126931,36.37,0.46,188,57828,70,NULL,NULL,'2MASX J15081350+0746483',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.0562083,7.78003,0.049,NULL,59384346932,927880420,14498131,16.9),(126932,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126932,34.52,0.4,80,57829,NULL,NULL,'mean','IC 1091',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000053,NULL,'14.5',0.7,'SB(s)b?','in a pair',NULL,NULL,NULL,1,227.0562917,-11.14092,0.413,NULL,46485371892,726333935,11348967,14.5),(126933,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126933,34.71,0.47,87.3,57829,NULL,NULL,'H','IC 1091',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126934,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126934,34.74,0.45,88.7,57829,NULL,NULL,'K','IC 1091',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126935,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126935,34.75,0.46,89.3,57829,NULL,NULL,'J','IC 1091',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126936,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126936,37.47,0.46,312,57830,70,NULL,NULL,'2MASX J15081422+1056203',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.0592083,10.93892,0.077,NULL,59348947763,927327308,14489489,17.3),(126937,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126937,38.7,0.33,549,57831,70,NULL,NULL,'2MASX J15081434+2915219',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'19.60',0.1,NULL,NULL,NULL,NULL,NULL,1,227.059667,29.25611,0.041,NULL,60094128609,938970759,14671418,19.6),(126938,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126938,36.95,0.46,245,57832,70,NULL,NULL,'2MASX J15081478+3417185',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.0614583,34.28853,0.021,NULL,60116166820,939315106,14676798,17.4),(126939,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126939,37.95,0.14,390,57833,70,NULL,NULL,'2MASX J15081496-0015443',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000092,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,227.06225,-0.26225,0.161,NULL,45368632925,708884889,11076326,17.4),(126940,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126940,38.24,0.46,444,57834,70,NULL,NULL,'2MASX J15081524+1106223',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000171,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.0635417,11.10617,0.065,NULL,59349254120,927332095,14489563,18.3),(126941,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126941,37.95,0.14,390,57835,70,NULL,NULL,'2MASX J15081529-0013153',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00008,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,227.0637083,-0.22094,0.161,NULL,45368631684,708884870,11076326,17),(126942,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126942,37.07,0.46,260,57836,70,NULL,NULL,'2MASX J15081624+2418019',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000194,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,227.0677083,24.30053,0.101,NULL,59412118301,928314348,14504911,16.4),(126943,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126943,35.46,0.46,124,57837,70,NULL,NULL,'2MASX J15081645+5640081',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000081,NULL,'16.0g',0.31,'E0',NULL,NULL,NULL,NULL,1,227.068333333,56.66886,0.013,NULL,57715668502,901807320,14090739,16),(126944,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126944,36.04,0.23,162,57838,70,NULL,NULL,'MCG +04-36-019',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.02',0.3,NULL,NULL,NULL,NULL,NULL,1,227.078667,20.48572,0.093,NULL,59535337898,930239654,14534994,17.02),(126945,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126945,39.03,0.46,639,57839,70,NULL,NULL,'SDSS J150818.90+213407.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.0787917,21.56878,0.105,NULL,59535230471,930237976,14534968,18.6),(126946,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126946,37.44,0.46,307,57840,70,NULL,NULL,'2MASX J15081987+0643503',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000156,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.0827917,6.73064,0.053,NULL,59386565420,927915084,14498673,17.4),(126947,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126947,37.35,0.46,295,57841,70,NULL,NULL,'2MASX J15081986+2742091',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.77',0.24,NULL,NULL,NULL,NULL,NULL,1,227.0829583,27.70264,0.057,NULL,59897701448,935901585,14623462,17.77),(126948,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126948,37.95,0.14,390,57842,70,NULL,NULL,'2MASX J15082076-0022233',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000081,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,227.086583333,-0.37308,0.161,NULL,45368624723,708884761,11076324,17.1),(126949,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126949,38.44,0.46,487,57843,70,NULL,NULL,'2MASX J15082205+0741143',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,227.092,7.68744,0.045,NULL,59384334741,927880230,14498128,17.6),(126950,'IRAS','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126950,34.39,0.8,75.5,57844,75,NULL,'MAT, I','ESO 448- G 013',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'12.37',0.5,'Sb             HII',NULL,NULL,NULL,NULL,1,227.09525,-28.8445,0.537,NULL,47196448813,737444512,11522570,12.37),(126951,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126951,34.17,0.45,68.3,57844,NULL,NULL,'K','ESO 448- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126952,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126952,34.22,0.47,69.8,57844,NULL,NULL,'H','ESO 448- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126953,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126953,34.3,0.46,72.5,57844,NULL,NULL,'J','ESO 448- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126954,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126954,34.34,0.4,73.9,57844,NULL,NULL,'mean','ESO 448- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126955,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126955,34.5,0.43,79.6,57844,75,NULL,'MAT, I, raw','ESO 448- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126956,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126956,34.53,0.32,80.5,57844,85,NULL,'I, raw','ESO 448- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126957,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126957,34.53,0.49,80.6,57844,75,NULL,'IR','ESO 448- G 013',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126958,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126958,34.55,0.42,81.4,57844,NULL,NULL,'Malmquist cor.','ESO 448- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126959,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126959,34.6,0.32,83.3,57844,85,NULL,'I, inv','ESO 448- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126960,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126960,34.74,0.43,88.8,57844,75,NULL,'MAT, I, cor','ESO 448- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126961,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126961,34.74,0.38,88.8,57844,NULL,NULL,NULL,'ESO 448- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126962,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126962,34.78,0.2,90.4,57844,74.4,NULL,NULL,'ESO 448- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126963,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126963,34.81,0.43,91.7,57844,75,NULL,'MAT, I, inv','ESO 448- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126964,'SNIa','2016-12-15 15:15:31','2016-12-16 11:20:45','1','PTF11v','N',126964,35.94,0.04,149,57845,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF11v',0.0373,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126965,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126965,35.82,0.46,146,57846,70,NULL,NULL,'CGCG 249-007',NULL,'2015arXiv151105856S',2015,1,0.94,NULL,'G',0.000173,NULL,'14.7g',0.6,'S0',NULL,NULL,NULL,NULL,1,227.097583,49.666,0.005,NULL,59937962707,936530667,14633291,14.7),(126966,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126966,36.49,0.46,198,57847,70,NULL,NULL,'2MASX J15082358+0723533',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,227.098375,7.39822,0.045,NULL,59386980567,927921571,14498774,17.2),(126967,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126967,38.42,0.46,483,57848,70,NULL,NULL,'SDSS J150823.78+332324.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000188,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,227.099125,33.39006,0.029,NULL,60115243628,939300681,14676573,18.2),(126968,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126968,34.33,0.46,73.4,57849,70,NULL,NULL,'CGCG 106-011',NULL,'2015arXiv151105856S',2015,1,0.7,'Sometimes incorrectly referred to as IC 1096.','G',0.000163,NULL,'15.1',0.7,'S?','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,227.099875,19.20811,0.069,NULL,59537394089,930271782,14535496,15.1),(126969,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126969,37.21,0.46,277,57850,70,NULL,NULL,'SDSS J150824.07+044133.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.8g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.100333,4.69278,0.089,NULL,59331647491,927056992,14485265,17.8),(126970,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126970,37.35,0.46,295,57851,70,NULL,NULL,'2MASX J15082458+0532029',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.1025417,5.53414,0.093,NULL,59332308418,927067319,14485426,17.9),(126971,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126971,35.81,0.46,145,57852,70,NULL,NULL,'ARK 472',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.000172,NULL,'15.2g',0.52,'E0',NULL,NULL,NULL,NULL,1,227.10325,37.66394,0.009,NULL,60101825933,939091030,14673297,15.2),(126972,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126972,36.86,0.46,236,57853,70,NULL,NULL,'2MASX J15082489+3612118',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000148,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,227.10375,36.20325,0.013,NULL,60127693514,939495211,14679612,16.4),(126973,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126973,37.98,0.27,395,57854,70,NULL,NULL,'2MASX J15082494+4622438',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,227.104083,46.37881,0.057,NULL,59984158021,937252469,14644569,17.4),(126974,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126974,37.76,0.46,357,57855,70,NULL,NULL,'SDSS J150825.42+163342.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.1059583,16.56181,0.041,NULL,59583057994,930985281,14546645,18.4),(126975,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126975,37.95,0.14,390,57856,70,NULL,NULL,'SDSS J150826.08-001904.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000081,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,227.108667,-0.31806,0.161,NULL,45368638808,708884981,11076327,18.5),(126976,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126976,37.32,0.21,291,57857,70,NULL,NULL,'2MASX J15082641+2647361',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'19.07',0.13,NULL,NULL,NULL,NULL,NULL,1,227.1100417,26.79336,0.085,NULL,59898248543,935910133,14623595,19.07),(126977,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126977,38.08,0.46,412,57858,70,NULL,NULL,'2MASX J15082697+2224337',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.1122083,22.40933,0.117,NULL,59409206627,928268853,14504200,18.1),(126978,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126978,37.52,0.46,318,57859,70,NULL,NULL,'2MASX J15082736+5415071',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000149,NULL,'17.1g',0.25,'FR II          AGN',NULL,NULL,NULL,NULL,1,227.113833,54.25211,0.021,NULL,59660469166,932194830,14565544,17.1),(126979,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126979,37.53,0.46,321,57860,70,NULL,NULL,'2MASX J15082826+2543421',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.1177083,25.72842,0.129,NULL,59898548008,935914812,14623668,17.2),(126980,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126980,35.11,0.46,105,57861,70,NULL,NULL,'CGCG 135-021',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00007,NULL,'15.3',0.3,'S0             Sy?',NULL,NULL,NULL,NULL,1,227.121,21.94772,0.121,NULL,59539199069,930299985,14535937,15.3),(126981,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126981,34.98,0.4,99,57861,NULL,NULL,'mean','CGCG 135-021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126982,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126982,36.01,0.47,159,57861,NULL,NULL,'H','CGCG 135-021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126983,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126983,38.03,0.46,404,57862,70,NULL,NULL,'2MASX J15083011+0952597',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000132,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,227.1255417,9.88314,0.065,NULL,59346459589,927288431,14488881,17.6),(126984,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126984,35.88,0.2,150,57863,74.4,NULL,NULL,'CGCG 077-018',NULL,'2013AJ....146...86T',2013,1,0.95,NULL,'G',0.0001,NULL,'15.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,227.1277083,10.19625,0.073,NULL,59347250487,927300788,14489074,15.6),(126985,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126985,37.95,0.14,390,57864,70,NULL,NULL,'2MASX J15083069-0014493',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000082,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.1277917,-0.24706,0.161,NULL,45368665910,708885404,11076334,17.9),(126986,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126986,37.95,0.14,390,57865,70,NULL,NULL,'SDSS J150831.98-001602.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000063,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,227.13325,-0.26744,0.161,NULL,45368665289,708885395,11076334,18.6),(126987,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126987,37.95,0.14,390,57866,70,NULL,NULL,'2MASX J15083209-0017093',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000073,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.133667,-0.286,0.161,NULL,45368633357,708884896,11076326,18),(126988,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126988,37.53,0.15,320,57867,70,NULL,NULL,'2MASX J15083284+0828567',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000222,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.136875,8.48236,0.053,NULL,59384087171,927876362,14498068,17.3),(126989,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126989,37.82,0.46,366,57868,70,NULL,NULL,'2MASX J15083345+0604223',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.13925,6.07292,0.053,NULL,59332101683,927064088,14485376,17.7),(126990,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126990,37.25,0.33,282,57869,70,NULL,NULL,'2MASX J15083362+0611187',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000113,NULL,'16.68',0.51,NULL,NULL,NULL,NULL,NULL,1,227.1400417,6.1885,0.053,NULL,59386366269,927911972,14498624,16.68),(126991,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126991,36.4,0.46,190,57870,70,NULL,NULL,'2MASX J15083381+2528591',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'18.39',0.16,NULL,NULL,NULL,NULL,NULL,1,227.1410417,25.48306,0.129,NULL,59894948670,935858572,14622790,18.39),(126992,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126992,37.27,0.46,285,57871,70,NULL,NULL,'2MASX J15083427+5731231',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00007,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.142917,57.52317,0.029,NULL,57729243025,902019422,14094053,17.8),(126993,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126993,37.96,0.46,391,57872,70,NULL,NULL,'2MASX J15083525+1012587',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.146917,10.21633,0.073,NULL,59347293865,927301466,14489085,17.5),(126994,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126994,37.38,0.46,299,57873,70,NULL,NULL,'2MASX J15083540+5828351',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000101,NULL,'17.2g',0.21,'NLAGN',NULL,NULL,NULL,'Sy 2',1,227.147375,58.47639,0,NULL,57719370805,901865168,14091643,17.2),(126995,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126995,37.36,0.46,297,57874,70,NULL,NULL,'2MASX J15083739+2041068',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.32',0.21,NULL,NULL,NULL,NULL,NULL,1,227.1557917,20.68514,0.081,NULL,59535826351,930247286,14535113,17.32),(126996,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126996,37.25,0.33,282,57875,70,NULL,NULL,'2MASX J15083737+0611177',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,227.155833,6.18831,0.053,NULL,59386367485,927911991,14498624,17.9),(126997,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126997,36.04,0.23,162,57876,70,NULL,NULL,'SDSS J150838.16+201000.0',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.0g',0.36,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.159,20.16669,0.053,NULL,59537976962,930280890,14535638,16),(126998,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126998,35.53,0.33,127,57877,70,NULL,NULL,'SDSS J150838.96+262438.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.18',0.18,NULL,NULL,NULL,NULL,NULL,1,227.162583333,26.41081,0.121,NULL,59898637806,935916215,14623690,18.18),(126999,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126999,37.7,0.11,346,57878,70,NULL,NULL,'2MASX J15083945+0714107',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.16425,7.23639,0.045,NULL,59387141832,927924091,14498813,17.4),(127000,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127000,35.05,0.49,102,57879,75,NULL,'IR','ESO 448- G 014',NULL,'2011yCatp016004901K',2011,1,1.43,NULL,'G',0.00004,NULL,'16.1',0.18,'Sc',NULL,NULL,NULL,NULL,1,227.171791667,-29.12831,0.537,NULL,47208004828,737625075,11525391,16.1),(127001,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127001,35.34,NULL,117,57879,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 448- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127002,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127002,35.35,NULL,118,57879,NULL,NULL,'Dipole + Quadrupole','ESO 448- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127003,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127003,35.36,NULL,118,57879,NULL,NULL,'Dipole','ESO 448- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127004,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127004,33.82,0.47,58.1,57880,70,NULL,NULL,'ESO 387- G 005',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000073,NULL,'14.58',0.5,'Sa:',NULL,NULL,NULL,NULL,1,227.1717083,-37.66772,0.261,NULL,47188422013,737319093,11520610,14.58),(127005,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127005,36.37,0.64,188,57881,70,NULL,NULL,'2MASX J15084181-3259205',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.0I',0.2,NULL,NULL,NULL,NULL,NULL,1,227.174208333,-32.98903,0.645,NULL,47237865844,738091653,11532682,15),(127006,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127006,38.03,0.16,404,57882,70,NULL,NULL,'SDSS J150841.85+270500.0',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.174375,27.08336,0.081,NULL,59898204885,935909451,14623585,18.5),(127007,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127007,36.66,0.46,215,57883,70,NULL,NULL,'2MASX J15084275+1914338',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'15.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,227.178167,19.24281,0.069,NULL,59537578588,930274665,14535541,15.7),(127008,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127008,36.66,0.46,215,57884,70,NULL,NULL,'2MASX J15084331+3516487',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000199,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,227.180375,35.28033,0.017,NULL,60114244564,939285071,14676329,16.3),(127009,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127009,38.5,0.33,500,57885,70,NULL,NULL,'2MASX J15084357+0034193',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000086,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,227.1815417,0.572,0.133,NULL,56373526661,880836354,13763068,17.3),(127010,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127010,38.03,0.16,404,57886,70,NULL,NULL,'2MASX J15084362+2711581',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.57',0.17,NULL,NULL,NULL,NULL,NULL,1,227.1817083,27.19942,0.081,NULL,59897140446,935892819,14623325,18.57),(127011,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127011,37.71,0.46,348,57887,70,NULL,NULL,'SDSS J150844.55+053951.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.185625,5.66433,0.085,NULL,59332348574,927067946,14485436,18),(127012,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127012,38.1,0.46,417,57888,70,NULL,NULL,'SDSS J150844.79+010912.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000074,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.186625,1.15342,0.125,NULL,56374805226,880856331,13763380,18.4),(127013,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127013,37.74,0.12,354,57889,70,NULL,NULL,'2MASX J15084553+0906387',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.189833333,9.11067,0.049,NULL,59384020934,927875327,14498051,18),(127014,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127014,38.91,0.46,606,57890,70,NULL,NULL,'SDSS J150845.57+065632.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.189875,6.9425,0.049,NULL,59387101603,927923462,14498804,18.3),(127015,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127015,37.07,0.46,259,57891,70,NULL,NULL,'2MASX J15084578+0229333',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00007,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.19075,2.49267,0.113,NULL,56373695708,880838995,13763109,17.4),(127016,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127016,37.69,0.46,345,57892,70,NULL,NULL,'2MASX J15084585+1157167',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,227.190917,11.95478,0.121,NULL,59348635666,927322432,14489413,17.2),(127017,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127017,37.74,0.12,354,57893,70,NULL,NULL,'SDSS J150846.43+084605.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.1934583,8.76828,0.037,NULL,59384253668,927878963,14498108,18.1),(127018,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127018,38.5,0.33,500,57894,70,NULL,NULL,'SDSS J150847.13+003331.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000081,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,227.196375,0.55881,0.133,NULL,56373527193,880836362,13763068,18.6),(127019,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127019,37.22,0.2,278,57895,74.4,NULL,NULL,'CGCG 165-022',NULL,'2013AJ....146...86T',2013,1,0.48,NULL,'G',0.00011,NULL,'15.5',0.31,NULL,NULL,NULL,NULL,NULL,1,227.2002083,30.1705,0.029,NULL,60086399559,938849993,14669531,15.5),(127020,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127020,37.17,0.46,271,57896,70,NULL,NULL,'2MASX J15084869+1114517',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000185,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,227.202875,11.24764,0.085,NULL,59349392563,927334258,14489597,16.3),(127021,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127021,35.78,0.6,143,57897,70,NULL,NULL,'2MASX J15084883-3654287',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,227.2035417,-36.90797,0.293,NULL,47233334935,738020858,11531575,14.6),(127022,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127022,37.59,0.46,330,57898,70,NULL,NULL,'2MASX J15084927+1638162',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,227.20525,16.63769,0.041,NULL,59583224539,930987883,14546685,16.8),(127023,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127023,38.02,0.46,401,57899,70,NULL,NULL,'2MASX J15084948+3026593',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.82',0.13,NULL,NULL,NULL,NULL,NULL,1,227.2062917,30.44975,0.033,NULL,60086193591,938846774,14669480,18.82),(127024,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127024,33.91,0.46,60.4,57900,70,NULL,NULL,'ESO 328- G 025',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000103,NULL,'15',1.1,'S0',NULL,NULL,NULL,NULL,1,227.2170417,-38.47931,0.241,NULL,47189490415,737335787,11520871,15),(127025,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127025,37.44,0.46,307,57901,70,NULL,NULL,'2MASX J15085267+2647521',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.26',0.18,NULL,NULL,NULL,NULL,NULL,1,227.219375,26.79797,0.101,NULL,59898752565,935918008,14623718,18.26),(127026,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127026,37.23,0.27,280,57902,70,NULL,NULL,'2MASX J15085302+5901161',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000075,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,227.2207917,59.02122,0.013,NULL,57719896814,901873387,14091771,17.6),(127027,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127027,36.04,0.23,162,57903,70,NULL,NULL,'2MASX J15085325+2012034',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.1g',0.34,NULL,NULL,NULL,NULL,NULL,1,227.222,20.20103,0.073,NULL,59538006681,930281354,14535646,16.1),(127028,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127028,38.03,0.16,404,57904,70,NULL,NULL,'SDSS J150854.15+270659.2',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,227.225667,27.11644,0.081,NULL,59897096149,935892127,14623314,NULL),(127029,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127029,37.32,0.46,291,57905,70,NULL,NULL,'2MASX J15085462+0437453',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00008,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,227.2275417,4.62931,0.089,NULL,59331972434,927062069,14485344,16.9),(127030,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127030,38.14,0.46,425,57906,70,NULL,NULL,'2MASX J15085658+1034035',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.235833,10.56781,0.081,NULL,59347097381,927298396,14489037,18.1),(127031,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127031,37.76,0.21,356,57907,70,NULL,NULL,'2MASX J15085728+0947005',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.2385417,9.78358,0.049,NULL,59346507110,927289173,14488893,17.1),(127032,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127032,37.7,0.11,346,57908,70,NULL,NULL,'2MASX J15085730+0753155',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000174,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,227.238625,7.88772,0.049,NULL,59384850924,927888295,14498254,16.8),(127033,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127033,37.32,0.21,291,57909,70,NULL,NULL,'2MASX J15085776+2639081',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.29',0.21,NULL,NULL,NULL,NULL,NULL,1,227.240708333,26.65228,0.117,NULL,59898755267,935918051,14623719,17.29),(127034,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127034,37.85,0.46,372,57910,70,NULL,NULL,'SDSS J150858.92+295708.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.2455417,29.95228,0.029,NULL,60086411575,938850180,14669534,18.1),(127035,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127035,34.95,0.51,97.6,57911,70,NULL,NULL,'LCRS B150616.0-114824',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000143,NULL,'15.95',0.4,NULL,NULL,NULL,NULL,NULL,1,227.249916667,-11.99692,0.397,NULL,46484969183,726327643,11348869,15.95),(127036,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127036,36.04,0.23,162,57912,70,NULL,NULL,'CGCG 135-022',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000177,NULL,'15.6',0.4,NULL,NULL,NULL,NULL,NULL,1,227.25,20.44203,0.093,NULL,59535330631,930239541,14534992,15.6),(127037,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127037,36.76,0.46,225,57913,70,NULL,NULL,'2MASX J15090088+0258312',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,'FoF','17.05',0.36,NULL,NULL,NULL,NULL,NULL,1,227.253583,2.97522,0.117,NULL,56385090412,881017037,13765891,17.05),(127038,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127038,35.51,0.48,126,57914,70,NULL,NULL,'CGCG 021-018',NULL,'2014MNRAS.445.2677S',2014,1,0.69,NULL,'G',0.000083,NULL,'15.0g',0.57,'E0',NULL,NULL,NULL,NULL,1,227.254375,-0.16589,0.161,NULL,45367812731,708872073,11076126,15),(127039,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127039,35.59,0.46,131,57914,70,NULL,NULL,'CGCG 021-018',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127040,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127040,38.11,0.23,419,57915,70,NULL,NULL,'2MASX J15090127+3017034',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.255417,30.28439,0.033,NULL,60086389086,938849829,14669528,18.1),(127041,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127041,36.83,0.46,233,57916,70,NULL,NULL,'2MASX J15090143+2831031',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'18.00',0.2,NULL,NULL,NULL,NULL,NULL,1,227.256125,28.5175,0.041,NULL,59896778437,935887163,14623236,18),(127042,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127042,38.23,0.46,442,57917,70,NULL,NULL,'SDSS J150901.79+031729.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000081,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.2574583,3.29153,0.069,NULL,59330588374,927040443,14485006,17.9),(127043,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127043,37.59,0.46,330,57918,70,NULL,NULL,'2MASX J15090195+3825280',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,227.2580417,38.42428,0.037,NULL,60103964848,939124450,14673819,17.4),(127044,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127044,36.74,0.46,223,57919,70,NULL,NULL,'2MASX J15090349+2823022',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.60',0.16,NULL,NULL,NULL,NULL,NULL,1,227.2645,28.38392,0.045,NULL,59897002032,935890656,14623291,18.6),(127045,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127045,36.44,0.64,194,57920,70,NULL,NULL,'2MASX J15090466-0717169',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,227.2694583,-7.288,0.249,NULL,46498014920,726531483,11352054,15.3),(127046,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127046,38.25,0.46,447,57921,70,NULL,NULL,'2MASX J15090474+2912442',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000203,NULL,'17.3g',0.22,'E',NULL,NULL,NULL,NULL,1,227.269833333,29.21233,0.041,NULL,60093918673,938967479,14671366,17.3),(127047,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127047,37.7,0.11,346,57922,70,NULL,NULL,'SDSS J150906.08+072027.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.275333,7.34106,0.045,NULL,59386997818,927921840,14498778,18.6),(127048,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127048,35.53,0.33,127,57923,70,NULL,NULL,'CGCG 165-023',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000073,NULL,'14.8',0.3,'S0',NULL,NULL,NULL,NULL,1,227.2785417,26.50992,0.121,NULL,59898818693,935919042,14623735,14.8),(127049,'CMD','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127049,19,0.1,0.063,57924,NULL,NULL,NULL,'UMI DWARF',NULL,'1985AJ.....90.2221O',1985,1,30.2,NULL,'G',0.000003,NULL,'11.9',19.1,'E','Isolated galaxy',NULL,NULL,NULL,1,227.285375,67.22261,0.037,1,57980457329,905944645,14155385,11.9),(127050,'CMD','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127050,19.1,0.1,0.0661,57924,NULL,NULL,NULL,'UMI DWARF',NULL,'2013ApJ...763..110K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127051,'CMD','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127051,19.16,0.11,0.0679,57924,NULL,NULL,NULL,'UMI DWARF',NULL,'2002MNRAS.332...91D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127052,'CMD','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127052,19.18,0.12,0.0685,57924,NULL,NULL,NULL,'UMI DWARF',NULL,'1999AJ....118..366M',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127053,'CMD','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127053,19.31,NULL,0.0728,57924,NULL,NULL,NULL,'UMI DWARF',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127054,'Horizontal Branch','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127054,19.04,0.17,0.064,57924,NULL,NULL,NULL,'UMI DWARF',NULL,'1995MNRAS.277.1354I',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127055,'Horizontal Branch','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127055,19.15,0.07,0.0676,57924,NULL,NULL,'Red HB','UMI DWARF',NULL,'2011ApJ...731..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127056,'Horizontal Branch','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127056,19.17,0.07,0.0682,57924,NULL,NULL,'Probability > 0.5','UMI DWARF',NULL,'2011ApJ...731..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127057,'Horizontal Branch','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127057,19.19,NULL,0.069,57924,NULL,NULL,NULL,'UMI DWARF',NULL,'1985IAUS..113..541W',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127058,'Horizontal Branch','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127058,19.28,0.25,0.0718,57924,NULL,NULL,NULL,'UMI DWARF',NULL,'2002MNRAS.332...91D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127059,'Horizontal Branch','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127059,19.4,0.1,0.076,57924,NULL,NULL,NULL,'UMI DWARF',NULL,'2002AJ....123.3199C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127060,'RR Lyrae','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127060,19,0.1,0.063,57924,NULL,NULL,NULL,'UMI DWARF',NULL,'1986AJ.....92..766C',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127061,'RR Lyrae','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127061,19.24,0.24,0.07,57924,NULL,NULL,NULL,'UMI DWARF',NULL,'1988AJ.....96..528N',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127062,'RR Lyrae','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127062,19.29,NULL,0.0721,57924,NULL,NULL,NULL,'UMI DWARF',NULL,'2008ApJ...679...52T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127063,'RR Lyrae','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127063,19.94,0.13,0.0973,57924,NULL,NULL,'7','UMI DWARF',NULL,'2013ApJ...767...62G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127064,'TRGB','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127064,18.9,NULL,0.06,57924,NULL,NULL,NULL,'UMI DWARF',NULL,'2000glg..book.....V',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127065,'TRGB','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127065,19.15,NULL,0.0676,57924,NULL,NULL,NULL,'UMI DWARF',NULL,'2003MNRAS.339..887F',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127066,'TRGB','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127066,19.16,0.14,0.07,57924,74.4,NULL,NULL,'UMI DWARF',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127067,'TRGB','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127067,19.41,0.12,0.076,57924,NULL,NULL,'I','UMI DWARF',NULL,'2002AJ....124.3222B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127068,'Tully est','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127068,20,0.8,0.1,57924,75,NULL,'B','UMI DWARF',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127069,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127069,36.56,0.46,205,57925,70,NULL,NULL,'2MASX J15090933+1830524',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.288875,18.51469,0.061,NULL,59583822373,930997224,14546831,17.5),(127070,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127070,37.74,0.12,354,57926,70,NULL,NULL,'2MASX J15090936+0838595',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.288917,8.64994,0.053,NULL,59384206214,927878222,14498097,17.7),(127071,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127071,35.48,0.67,125,57927,70,NULL,NULL,'2MASX J15090958-3956236',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,227.290041667,-39.94,0.109,NULL,47186422331,737287848,11520122,15),(127072,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127072,37.92,0.46,384,57928,70,NULL,NULL,'2MASX J15090999+4444484',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.291667,44.74686,0.053,NULL,59993296505,937395257,14646800,17.8),(127073,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127073,38.11,0.23,419,57929,70,NULL,NULL,'SDSS J150911.23+300141.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.296833,30.02833,0.029,NULL,60086405148,938850080,14669532,18.2),(127074,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127074,36.87,0.46,236,57930,70,NULL,NULL,'2MASX J15091133+0040385',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000078,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.2972917,0.67731,0.133,NULL,56373496679,880835885,13763060,17.1),(127075,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127075,37.09,0.33,262,57931,70,NULL,NULL,'2MASX J15091140+6116048',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000099,NULL,'16.1g',0.42,'BrClG',NULL,NULL,NULL,NULL,1,227.297625,61.26789,0.005,NULL,57778577960,902790280,14106098,16.1),(127076,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127076,37.32,0.21,291,57932,70,NULL,NULL,'SDSS J150911.46+265230.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.29775,26.87522,0.101,NULL,59898729251,935917644,14623713,18.1),(127077,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127077,37.76,0.21,356,57933,70,NULL,NULL,'2MASX J15091270+0951085',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.302833,9.85236,0.065,NULL,59346460963,927288452,14488882,17.4),(127078,'IRAS','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127078,33.57,0.8,51.8,57934,75,NULL,'CF, r','NGC 5875',NULL,'1997ApJS..109..333W',1997,1,1.53,NULL,'G',0.000067,NULL,'13.2g',1.01,'SAb:','in a pair',NULL,NULL,NULL,1,227.304833,52.52844,0.013,NULL,59661585726,932212276,14565816,13.2),(127079,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127079,33,0.38,39.8,57934,75,NULL,'CF, r, raw','NGC 5875',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127080,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127080,33.12,0.38,42.1,57934,75,NULL,'CF, r, inv','NGC 5875',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127081,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127081,33.15,0.38,42.7,57934,75,NULL,'CF, r, cor','NGC 5875',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127082,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127082,33.59,0.47,52.3,57934,NULL,NULL,'H','NGC 5875',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127083,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127083,33.61,0.45,52.8,57934,NULL,NULL,'K','NGC 5875',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127084,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127084,33.63,0.44,53.3,57934,NULL,NULL,'Malmquist cor.','NGC 5875',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127085,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127085,33.64,0.2,53.5,57934,74.4,NULL,NULL,'NGC 5875',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127086,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127086,33.65,0.46,53.7,57934,NULL,NULL,'J','NGC 5875',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127087,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127087,33.68,0.4,54.3,57934,NULL,NULL,'mean','NGC 5875',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127088,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127088,33.78,0.41,57.1,57934,NULL,NULL,NULL,'NGC 5875',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127089,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127089,38.01,0.46,401,57935,70,NULL,NULL,'2MASX J15091368+0848355',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000177,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,227.306917,8.81008,0.037,NULL,59384232411,927878631,14498103,17.1),(127090,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127090,36.87,0.46,237,57936,70,NULL,NULL,'SDSS J150914.45+343947.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.31025,34.66325,0.021,NULL,60114195164,939284299,14676317,17.7),(127091,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127091,37.7,0.11,346,57937,70,NULL,NULL,'SDSS J150915.85+073915.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000186,NULL,'18.4g',0.13,NULL,'Group member',NULL,NULL,NULL,1,227.316083333,7.65431,0.049,NULL,59386705863,927917279,14498707,18.4),(127092,'IRAS','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127092,32.12,0.8,26.6,57938,75,NULL,'MAT, I','NGC 5861',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000003,NULL,'12.30',1.7,'SAB(rs)c       HII','in a pair',NULL,NULL,'Sy 2',1,227.3170417,-11.32167,0.405,NULL,46485414653,726334603,11348978,12.3),(127093,'IRAS','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127093,32.14,0.8,26.8,57938,75,NULL,'A82, H','NGC 5861',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127094,'Sosies','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127094,31.94,0.15,24.4,57938,NULL,NULL,NULL,'NGC 5861',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127095,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127095,31.85,0.46,23.4,57938,NULL,NULL,'J','NGC 5861',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127096,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127096,31.87,0.43,23.7,57938,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5861',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127097,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127097,31.89,0.47,23.9,57938,NULL,NULL,'H','NGC 5861',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127098,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127098,31.9,0.4,24,57938,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5861',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127099,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127099,31.93,0.43,24.3,57938,75,NULL,'3.6 micron, color corrected','NGC 5861',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127100,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127100,31.96,0.45,24.7,57938,NULL,NULL,'K','NGC 5861',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127101,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127101,32,0.32,25.1,57938,85,NULL,'I, raw','NGC 5861',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127102,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127102,32.05,0.32,25.7,57938,85,NULL,'I, inv','NGC 5861',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127103,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127103,32.05,0.2,25.7,57938,74.4,NULL,NULL,'NGC 5861',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127104,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127104,32.15,0.43,26.9,57938,75,NULL,'MAT, I, raw','NGC 5861',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127105,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127105,32.21,0.4,27.7,57938,NULL,NULL,'mean','NGC 5861',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127106,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127106,32.24,0.38,28.1,57938,NULL,NULL,NULL,'NGC 5861',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127107,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127107,32.3,0.4,28.9,57938,75,NULL,'B','NGC 5861',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127108,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127108,32.31,0.52,28.9,57938,NULL,NULL,'Malmquist cor.','NGC 5861',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127109,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127109,32.31,0.52,29,57938,NULL,NULL,NULL,'NGC 5861',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127110,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127110,32.36,0.43,29.6,57938,75,NULL,'MAT, I, cor','NGC 5861',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127111,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127111,32.37,0.43,29.8,57938,75,NULL,'MAT, I, inv','NGC 5861',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127112,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127112,32.53,0.47,32.1,57938,75,NULL,'A82, H, raw','NGC 5861',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127113,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127113,32.66,0.47,34,57938,75,NULL,'A82, H, cor','NGC 5861',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127114,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127114,32.67,0.47,34.3,57938,75,NULL,'A82, H, inv','NGC 5861',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127115,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127115,37.7,0.11,346,57939,70,NULL,NULL,'2MASX J15091606+0727575',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000179,NULL,'17.7g',0.19,NULL,'Group member',NULL,NULL,NULL,1,227.317083333,7.46608,0.045,NULL,59386990672,927921729,14498777,17.7),(127116,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127116,38.11,0.23,419,57940,70,NULL,NULL,'SDSS J150916.60+301110.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.2g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.319208333,30.18611,0.029,NULL,60086398699,938849979,14669530,18.2),(127117,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127117,37.9,0.46,380,57941,70,NULL,NULL,'SDSS J150916.61+483247.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000161,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.31925,48.54639,0.017,NULL,59939371908,936552686,14633635,18.3),(127118,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127118,37.41,0.46,303,57942,70,NULL,NULL,'2MASX J15091668-0040365',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000073,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,227.319375,-0.67669,0.173,NULL,45368576056,708884000,11076312,17.1),(127119,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127119,36.74,0.46,222,57943,70,NULL,NULL,'2MASX J15091668+2452522',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00018,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,227.319625,24.88142,0.125,NULL,59411582769,928305980,14504780,17),(127120,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127120,37.7,0.11,346,57944,70,NULL,NULL,'2MASX J15091687+0738015',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000137,NULL,'15.3',0.27,NULL,'Group member',NULL,NULL,NULL,1,227.3202917,7.63392,0.049,NULL,59386707520,927917305,14498707,15.3),(127121,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127121,37.15,0.33,269,57945,70,NULL,NULL,'2MASX J15091851+0537075',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,227.3272917,5.61881,0.085,NULL,59332324982,927067577,14485430,16.9),(127122,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127122,37.7,0.11,346,57946,70,NULL,NULL,'2MASX J15091889+0737295',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,'Group member',NULL,NULL,NULL,1,227.328833,7.62492,0.049,NULL,59386707537,927917305,14498707,18),(127123,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127123,37.66,0.46,340,57947,70,NULL,NULL,'2MASX J15092013+0650235',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000178,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.333917,6.83986,0.049,NULL,59386461828,927913466,14498647,17.3),(127124,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127124,37.98,0.46,395,57948,70,NULL,NULL,'2MASX J15092022+1000185',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,227.334167,10.00522,0.077,NULL,59346347014,927286672,14488854,17.2),(127125,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127125,37.32,0.21,291,57949,70,NULL,NULL,'2MASX J15092045+2642491',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.30',0.25,NULL,NULL,NULL,NULL,NULL,1,227.335291667,26.71356,0.117,NULL,59898775619,935918369,14623724,17.3),(127126,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127126,36.87,0.46,236,57950,70,NULL,NULL,'2MASX J15092061+3419485',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00016,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,227.336,34.33006,0.021,NULL,60116087390,939313865,14676779,16.9),(127127,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127127,37.82,0.46,366,57951,70,NULL,NULL,'2MASX J15092162+1049215',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,227.3400417,10.82272,0.081,NULL,59348498781,927320293,14489379,17.3),(127128,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127128,35.38,0.2,119,57952,74.4,NULL,NULL,'CGCG 165-024',NULL,'2013AJ....146...86T',2013,1,0.67,NULL,'G',0.00005,NULL,'15.7',0.23,NULL,NULL,NULL,NULL,NULL,1,227.3407083,27.99758,0.053,NULL,59897710482,935901726,14623464,15.7),(127129,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127129,37.44,0.46,308,57953,70,NULL,NULL,'2MASX J15092190+3639004',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000165,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.341417,36.65014,0,NULL,60119120747,939361261,14677519,17),(127130,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127130,34.46,NULL,78,57954,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 328- G 026',NULL,'2010Ap&SS.325..163P',2010,1,1.34,NULL,'G',0.000036,NULL,'16.4',0.13,'Sd',NULL,NULL,NULL,NULL,1,227.342666667,-41.80939,0.321,NULL,47068163375,735440052,11491250,16.4),(127131,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127131,34.47,NULL,78.4,57954,NULL,NULL,'Dipole + Quadrupole','ESO 328- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127132,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127132,34.49,NULL,79,57954,NULL,NULL,'Dipole','ESO 328- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127133,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127133,34.6,0.46,83.1,57955,70,NULL,NULL,'2MASX J15092224+1056285',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000161,NULL,'15.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,227.342583333,10.94128,0.081,NULL,59348493153,927320205,14489378,15.7),(127134,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127134,38.23,0.33,442,57956,70,NULL,NULL,'2MASX J15092300+1221226',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,227.345875,12.35647,0.113,NULL,59569093556,930767086,14543235,17.5),(127135,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127135,37.15,0.33,269,57957,70,NULL,NULL,'2MASX J15092333+0543385',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,227.3472917,5.72742,0.077,NULL,59332314928,927067420,14485428,17.1),(127136,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127136,38.35,0.46,468,57958,70,NULL,NULL,'SDSS J150924.43+215109.3',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.7g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.351833,21.85258,0.109,NULL,59535012284,930234566,14534915,17.7),(127137,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127137,37.76,0.21,356,57959,70,NULL,NULL,'2MASX J15092454+0946155',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000197,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,227.352167,9.771,0.065,NULL,59346489896,927288904,14488889,16.4),(127138,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127138,37.25,0.46,282,57960,70,NULL,NULL,'SDSS J150924.53+561341.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000076,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,227.35225,56.22814,0.013,NULL,57715308557,901801696,14090651,18.3),(127139,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127139,37.7,0.11,346,57961,70,NULL,NULL,'SDSS J150924.62+073323.0',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000173,NULL,'16.0',NULL,NULL,'Group member',NULL,NULL,NULL,1,227.352625,7.55642,0.049,NULL,59386697420,927917147,14498705,16),(127140,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127140,37.32,0.21,291,57962,70,NULL,NULL,'2MASX J15092504+2637147',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.92',0.21,NULL,NULL,NULL,NULL,NULL,1,227.354291667,26.62067,0.117,NULL,59898814543,935918977,14623734,17.92),(127141,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127141,37.76,0.21,356,57963,70,NULL,NULL,'2MASX J15092591+0951527',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000171,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,227.358083,9.86469,0.065,NULL,59346345482,927286648,14488853,18.3),(127142,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127142,38.23,0.33,442,57964,70,NULL,NULL,'2MASX J15092628+1217596',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,227.3595,12.29994,0.113,NULL,59347576216,927305878,14489154,17.1),(127143,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127143,37.74,0.12,354,57965,70,NULL,NULL,'2MASX J15092661+0847457',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,227.3609583,8.79614,0.037,NULL,59384231171,927878612,14498103,16.9),(127144,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127144,38.44,0.46,488,57966,70,NULL,NULL,'2MASX J15092755+3025299',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.76',0.15,NULL,NULL,NULL,NULL,NULL,1,227.364833,30.42489,0.033,NULL,60086319763,938848746,14669511,18.76),(127145,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127145,37.7,0.11,346,57967,70,NULL,NULL,'2MASX J15092779+0732167',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000177,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,227.365917,7.53786,0.049,NULL,59386751250,927917988,14498718,18),(127146,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127146,38.17,0.46,431,57968,70,NULL,NULL,'2MASX J15092808+2344093',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.3669583,23.73597,0.109,NULL,59412134855,928314607,14504915,17.6),(127147,'BCG','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127147,37.73,0.35,326,57969,60,NULL,'ABELL 2028, BCG','GIN 416',0.0772,'1980ApJ...241..486H',1980,1,0.79,NULL,'G',0.000117,NULL,'15.4g',0.52,'E/S0','Group member',NULL,NULL,NULL,1,227.367375,7.55683,0.049,NULL,59386751367,927917990,14498718,15.4),(127148,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127148,36.82,0.27,231,57969,70,NULL,NULL,'GIN 416',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127149,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127149,37.7,0.11,346,57969,70,NULL,NULL,'GIN 416',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127150,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127150,37.74,0.12,354,57970,70,NULL,NULL,'2MASX J15092844+0851157',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000168,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,227.3685,8.85433,0.049,NULL,59384039845,927875622,14498056,17.6),(127151,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127151,37.02,0.33,253,57971,70,NULL,NULL,'CGCG 165-025',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00014,NULL,'15.6',0.4,NULL,NULL,NULL,NULL,NULL,1,227.370375,27.42258,0.069,NULL,59897608318,935900129,14623439,15.6),(127152,'Tully est','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127152,31.4,0.8,19.1,57972,75,NULL,NULL,'ESO 223- G 012',NULL,'1988NBGC.C....0000T',1988,1,2.3,NULL,'G',0.000017,NULL,'14.1',0.5,'SA(s)bc?sp;dust lane',NULL,NULL,NULL,NULL,1,227.3705417,-52.55547,NULL,NULL,46307703420,723557865,11305591,14.1),(127153,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127153,30.39,0.46,12,57972,NULL,NULL,'J','ESO 223- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127154,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127154,30.51,0.47,12.7,57972,NULL,NULL,'H','ESO 223- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127155,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127155,30.64,0.45,13.4,57972,NULL,NULL,'K','ESO 223- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127156,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127156,31.11,0.4,16.7,57972,NULL,NULL,'mean','ESO 223- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127157,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127157,37.76,0.21,356,57973,70,NULL,NULL,'SDSS J150929.14+095048.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.3714583,9.84689,0.065,NULL,59346371230,927287050,14488860,18.4),(127158,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127158,36.88,0.46,237,57974,70,NULL,NULL,'2MASX J15092923+4443384',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,227.371916667,44.72742,0.041,NULL,59993295786,937395246,14646800,16.9),(127159,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127159,37.54,0.46,322,57975,70,NULL,NULL,'2MASX J15092943+1641496',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.3727083,16.69717,0.053,NULL,59583198166,930987471,14546679,17.2),(127160,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127160,35.88,0.54,150,57976,70,NULL,NULL,'2MASX J15092957-3748117',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,227.373125,-37.80331,0.273,NULL,47188964423,737327569,11520743,14.1),(127161,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127161,38.29,0.46,455,57977,70,NULL,NULL,'2MASX J15092960+3227189',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.3735,32.45531,0.033,NULL,60085014904,938828357,14669193,18.1),(127162,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127162,36.86,0.46,236,57978,70,NULL,NULL,'2MASX J15093036+0536455',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,227.376417,5.61258,0.085,NULL,59332254515,927066476,14485413,16.7),(127163,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127163,37.7,0.11,346,57979,70,NULL,NULL,'2MASX J15093034+0744207',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.3764583,7.73917,0.049,NULL,59384665431,927885397,14498209,17.8),(127164,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127164,35.52,0.46,127,57980,70,NULL,NULL,'CGCG 249-008',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000167,NULL,'14.9g',0.67,'E0',NULL,NULL,NULL,NULL,1,227.3765,46.49269,0.057,NULL,59986034598,937281790,14645027,14.9),(127165,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127165,37.27,0.46,285,57981,70,NULL,NULL,'2MASX J15093088+1131267',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.378625,11.524,0.101,NULL,59349296494,927332757,14489574,17.2),(127166,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127166,37.57,0.46,326,57982,70,NULL,NULL,'2MASX J15093110+4714004',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000162,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,227.379583,47.23356,0.065,NULL,59984573066,937258954,14644671,17),(127167,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127167,37.74,0.12,354,57983,70,NULL,NULL,'SDSS J150931.16+085211.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.7g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.379833,8.86986,0.049,NULL,59384040835,927875638,14498056,18.7),(127168,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127168,33.56,0.4,51.6,57984,NULL,NULL,'mean','NGC 5876',NULL,'2007A&A...465...71T',2007,1,2.13,NULL,'G',0.000027,NULL,'13.3g',0.85,'SB(r)ab:','in a radial-velocity based grouping',NULL,NULL,NULL,1,227.3815,54.5065,0.005,NULL,59660539574,932195930,14565561,13.3),(127169,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127169,34.08,0.45,65.4,57984,NULL,NULL,'K','NGC 5876',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127170,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127170,34.08,0.47,65.4,57984,NULL,NULL,'H','NGC 5876',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127171,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127171,34.1,0.46,66,57984,NULL,NULL,'J','NGC 5876',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127172,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127172,36.92,0.46,242,57985,70,NULL,NULL,'2MASX J15093274+5614338',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000188,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,227.386666667,56.24264,0.013,NULL,57581921422,899717522,14058086,16.3),(127173,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127173,38.19,0.46,434,57986,70,NULL,NULL,'SDSS J150932.87+222459.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.387,22.41644,0.117,NULL,59409191663,928268619,14504197,18.1),(127174,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127174,37.03,0.46,255,57987,70,NULL,NULL,'2MASX J15093290+4229234',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000189,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,227.387,42.48994,0.017,NULL,59972730330,937073911,14641779,16.5),(127175,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127175,38.14,0.46,426,57988,70,NULL,NULL,'2MASX J15093314+3321119',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000201,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.388,33.35347,0.029,NULL,60116326857,939317607,14676837,17.4),(127176,'BCG','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127176,37.73,0.35,326,57989,60,NULL,NULL,'ABELL 2028',0.0772,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III [BM]',NULL,NULL,NULL,NULL,1,227.388458333,7.52708,0.049,NULL,59386752938,927918014,14498718,NULL),(127177,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127177,37.74,0.46,353,57990,70,NULL,NULL,'2MASX J15093360+3302189',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.389917,33.03858,0.025,NULL,60116212622,939315822,14676809,17.7),(127178,'Tully est','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127178,32.27,0.8,28.5,57991,75,NULL,'B','NGC 5864',NULL,'1988NBGC.C....0000T',1988,1,2.8,NULL,'G',0.000013,NULL,'12.77',0.9,'SB(s)0^0^? sp','in a radial-velocity based grouping',NULL,NULL,NULL,1,227.389833333,3.05275,0.105,NULL,56385116445,881017444,13765897,12.77),(127179,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127179,31.26,0.45,17.8,57991,NULL,NULL,'K','NGC 5864',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127180,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127180,32.16,0.4,27,57991,NULL,NULL,'mean','NGC 5864',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127181,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127181,32.16,NULL,27,57991,72,NULL,NULL,'NGC 5864',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127182,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127182,37.7,0.11,346,57992,70,NULL,NULL,'2MASX J15093377+0730557',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000123,NULL,'15.1',0.31,NULL,'Group member',NULL,NULL,NULL,1,227.390667,7.51531,0.049,NULL,59386752879,927918013,14498718,15.1),(127183,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127183,38.11,0.23,419,57993,70,NULL,NULL,'2MASX J15093387+3007170',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'19.25',0.11,NULL,NULL,NULL,NULL,NULL,1,227.391125,30.12131,0.029,NULL,60086493418,938851459,14669554,19.25),(127184,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127184,37.02,0.33,253,57994,70,NULL,NULL,'2MASX J15093475+2725177',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.42',0.16,NULL,NULL,NULL,NULL,NULL,1,227.394875,27.42158,0.069,NULL,59897609193,935900143,14623439,18.42),(127185,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127185,37.65,0.46,339,57995,70,NULL,NULL,'2MASX J15093485+0615087',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000184,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,227.395375,6.25256,0.053,NULL,59383534976,927867734,14497933,17),(127186,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127186,37.78,0.46,359,57996,70,NULL,NULL,'2MASX J15093530+0120288',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000084,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.397208333,1.34139,0.117,NULL,56372760846,880824388,13762881,17.5),(127187,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127187,37.74,0.12,354,57997,70,NULL,NULL,'SDSS J150936.28+084748.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000171,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.401167,8.79678,0.037,NULL,59384219978,927878437,14498100,18.5),(127188,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127188,37.74,0.12,354,57998,70,NULL,NULL,'SDSS J150936.37+084527.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000168,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.401583,8.75756,0.037,NULL,59384153127,927877392,14498084,18.2),(127189,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127189,37.7,0.11,346,57999,70,NULL,NULL,'2MASX J15093640+0734007',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000117,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,227.40175,7.56686,0.049,NULL,59386753099,927918017,14498719,16.6),(127190,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127190,38.17,0.33,430,58000,70,NULL,NULL,'SDSS J150938.73+004049.4',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000075,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,227.411417,0.68039,0.133,NULL,56373438487,880834976,13763046,18.8),(127191,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127191,37.23,0.27,280,58001,70,NULL,NULL,'2MASX J15093865+5907118',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000066,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,227.4114583,59.11989,0.013,NULL,57719485740,901866964,14091671,17.2),(127192,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127192,34,0.46,63,58002,70,NULL,NULL,'CGCG 221-032',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000147,NULL,'14.8g',0.46,'S0/a',NULL,NULL,NULL,NULL,1,227.411708333,42.71339,0.017,NULL,59972689691,937073276,14641769,14.8),(127193,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127193,37.74,0.12,354,58003,70,NULL,NULL,'2MASX J15093889+0845007',NULL,'2015arXiv151105856S',2015,1,0.26,'TXS codes: lobes(C)','G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,227.412125,8.75022,0.037,NULL,59384153184,927877393,14498084,17.3),(127194,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127194,38.08,0.46,413,58004,70,NULL,NULL,'2MASX J15093928-0219192',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000181,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,227.413583,-2.32192,0.257,NULL,45381138305,709080286,11079379,17.6),(127195,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127195,37.99,0.46,396,58005,70,NULL,NULL,'2MASX J15094037+0745507',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.418333,7.76403,0.049,NULL,59384720325,927886255,14498222,17.9),(127196,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127196,37.74,0.12,354,58006,70,NULL,NULL,'2MASX J15094247+0846497',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000181,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.427083,8.78044,0.037,NULL,59384153845,927877403,14498084,17.7),(127197,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127197,36.09,0.46,165,58007,70,NULL,NULL,'2MASX J15094384+0123238',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000101,NULL,'16.3g',0.24,'NLAGN',NULL,NULL,NULL,'Sy 2',1,227.4325,1.38994,0.113,NULL,56372771074,880824548,13762883,16.3),(127198,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127198,37.34,0.46,294,58008,70,NULL,NULL,'2MASX J15094432+3034230',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.70',0.14,NULL,NULL,NULL,NULL,NULL,1,227.434833,30.573,0.033,NULL,60086346551,938849164,14669518,18.7),(127199,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127199,37.7,0.11,346,58009,70,NULL,NULL,'2MASX J15094534+0730247',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000163,NULL,'17.0g',0.24,NULL,'Group member',NULL,NULL,NULL,1,227.4389583,7.50681,0.049,NULL,59386750069,927917969,14498718,17),(127200,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127200,38.17,0.33,430,58010,70,NULL,NULL,'2MASX J15094624+0035338',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000089,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,227.44275,0.59281,0.133,NULL,56373467269,880835426,13763053,17),(127201,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127201,37.7,0.11,346,58011,70,NULL,NULL,'2MASX J15094642+0728587',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000182,NULL,'17.8g',0.19,NULL,'Group member',NULL,NULL,NULL,1,227.443333,7.48294,0.049,NULL,59386718256,927917472,14498710,17.8),(127202,'IRAS','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127202,31.06,0.8,16.3,58012,75,NULL,'A82, H','NGC 5879',NULL,'1997ApJS..109..333W',1997,1,3.74,NULL,'G',0.000017,NULL,'12.4g',1.01,'SA(rs)bc:?     LINER','X-ray-faint group member',NULL,NULL,NULL,1,227.444708333,57.00019,0.017,NULL,57714776716,901793386,14090521,12.4),(127203,'IRAS','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127203,31.17,0.8,17.2,58012,75,NULL,'CF, r','NGC 5879',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127204,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127204,30.45,0.4,12.3,58012,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 5879',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127205,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127205,30.53,0.47,12.7,58012,75,NULL,'A82, H, raw','NGC 5879',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127206,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127206,30.53,0.47,12.8,58012,75,NULL,'A82, H, inv','NGC 5879',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127207,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127207,30.56,NULL,12.9,58012,NULL,NULL,'B','NGC 5879',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127208,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127208,30.79,0.47,14.4,58012,75,NULL,'A82, H, cor','NGC 5879',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127209,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127209,31,0.35,15.8,58012,NULL,NULL,NULL,'NGC 5879',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127210,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127210,31.05,0.43,16.2,58012,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5879',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127211,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127211,31.11,0.43,16.6,58012,75,NULL,'3.6 micron, color corrected','NGC 5879',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127212,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127212,31.12,0.4,16.8,58012,75,NULL,'B','NGC 5879',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127213,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127213,31.2,0.2,17.4,58012,74.4,NULL,NULL,'NGC 5879',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127214,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127214,31.48,0.38,19.7,58012,75,NULL,'CF, r, raw','NGC 5879',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127215,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127215,31.56,0.38,20.5,58012,75,NULL,'CF, r, inv','NGC 5879',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127216,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127216,31.71,0.38,22,58012,75,NULL,'CF, r, cor','NGC 5879',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127217,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127217,37.74,0.12,354,58013,70,NULL,NULL,'2MASX J15094780+0850197',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,227.449291667,8.83889,0.049,NULL,59384217842,927878403,14498100,17.4),(127218,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127218,36.23,0.46,176,58014,70,NULL,NULL,'2MASX J15094919+2528257',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000161,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,227.454917,25.47378,0.129,NULL,59898388600,935912321,14623630,16.8),(127219,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127219,31.98,1.22,24.9,58015,NULL,NULL,'I','NGC 5869',NULL,'2001ApJ...546..681T',2001,1,2.3,'HOLM 699B,C are stars.','G',0.000013,NULL,'12.91',1.7,'S0^0^:','Pair member (points to parent)',NULL,NULL,NULL,1,227.456,0.47003,0.129,NULL,56372589822,880821715,13762839,12.91),(127220,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127220,32.06,0.14,25.8,58015,74.4,NULL,NULL,'NGC 5869',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127221,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127221,32.47,0.4,31.1,58015,NULL,NULL,'mean','NGC 5869',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127222,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127222,32.63,0.45,33.5,58015,NULL,NULL,'K','NGC 5869',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127223,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127223,37.66,0.46,341,58016,70,NULL,NULL,'2MASX J15095009+4552327',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000182,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.458666667,45.87583,0.045,NULL,59986123771,937283183,14645049,17.4),(127224,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127224,36.76,0.46,225,58017,70,NULL,NULL,'2MASX J15095067+3616379',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000183,NULL,'16.0g',0.42,'E0',NULL,NULL,NULL,NULL,1,227.4610417,36.27714,0.005,NULL,60127501622,939492212,14679565,16),(127225,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127225,34.24,0.2,70.5,58018,74.4,NULL,NULL,'UGC 09744',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.00007,NULL,'14.8g',0.62,'SB(r)ab',NULL,NULL,NULL,NULL,1,227.464,1.77897,0.081,NULL,56385380147,881021564,13765961,14.8),(127226,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127226,37.74,0.12,354,58019,70,NULL,NULL,'2MASX J15095158+0850467',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.464875,8.84644,0.049,NULL,59351597056,927368704,14490136,17.3),(127227,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127227,37.81,0.17,365,58020,70,NULL,NULL,'2MASX J15095217+0424278',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000093,NULL,'16.6g',0.37,NULL,NULL,NULL,NULL,NULL,1,227.467458333,4.40772,0.089,NULL,59330906233,927045409,14485084,16.6),(127228,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127228,37.65,0.06,339,58021,70,NULL,NULL,'2MASX J15095251+0540468',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,227.468875,5.67972,0.077,NULL,59332249974,927066405,14485412,17.8),(127229,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127229,37.7,0.11,346,58022,70,NULL,NULL,'2MASX J15095254+0729027',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000173,NULL,'17.8g',0.2,NULL,'Group member',NULL,NULL,NULL,1,227.469083333,7.48403,0.049,NULL,59386713302,927917395,14498709,17.8),(127230,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127230,37.81,0.17,365,58023,70,NULL,NULL,'SDSS J150953.83+042436.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.474291667,4.41011,0.089,NULL,59330907071,927045422,14485084,18.1),(127231,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127231,37.74,0.12,354,58024,70,NULL,NULL,'2MASX J15095435+0857490',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000184,NULL,'16.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,227.476417,8.96356,0.049,NULL,59351530571,927367665,14490119,16.6),(127232,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127232,35.62,0.2,133,58025,74.4,NULL,NULL,'CGCG 077-024',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.000014,NULL,'15.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,227.4864583,9.38767,0.057,NULL,59353660143,927400939,14490639,15.9),(127233,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127233,36.08,0.46,164,58026,70,NULL,NULL,'2MASX J15095709+3241241',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000159,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,227.4877917,32.68997,0.025,NULL,60084979485,938827804,14669184,16.4),(127234,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127234,37.81,0.17,365,58027,70,NULL,NULL,'2MASX J15095718+0424558',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000079,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.488167,4.41567,0.089,NULL,59330906462,927045413,14485084,17.4),(127235,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127235,37.65,0.46,338,58028,70,NULL,NULL,'2MASX J15095851+0012038',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000065,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.49375,0.20092,0.129,NULL,56372749473,880824210,13762878,18),(127236,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127236,37.35,0.46,295,58029,70,NULL,NULL,'2MASX J15095896+3031381',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.81',0.14,NULL,NULL,NULL,NULL,NULL,1,227.4955417,30.52739,0.033,NULL,60086351378,938849240,14669519,18.81),(127237,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127237,38.13,0.33,423,58030,70,NULL,NULL,'2MASX J15100033+1815007',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.501375,18.25039,0.057,NULL,59583913076,930998641,14546853,17.5),(127238,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127238,38.3,0.23,456,58031,70,NULL,NULL,'2MASX J15100076+3330501',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000159,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,227.503333,33.51394,0.025,NULL,60116346862,939317919,14676842,18.5),(127239,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127239,37.84,0.46,369,58032,70,NULL,NULL,'SDSS J151001.40+200417.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.505875,20.07158,0.053,NULL,59537982920,930280983,14535640,18),(127240,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127240,37.87,0.27,374,58033,70,NULL,NULL,'2MASX J15100157+0256038',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000094,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,227.5065417,2.93439,0.105,NULL,56385304212,881020378,13765943,17),(127241,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127241,36.37,0.46,188,58034,70,NULL,NULL,'2MASX J15100167+1048200',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000173,NULL,'16.1g',0.37,NULL,NULL,NULL,NULL,NULL,1,227.507125,10.80544,0.081,NULL,59348509345,927320458,14489382,16.1),(127242,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127242,34.44,0.47,77.3,58035,70,NULL,NULL,'2MASX J15100233-1051019',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.33',0.7,NULL,NULL,NULL,NULL,NULL,1,227.509833,-10.85072,0.401,NULL,46484543909,726320998,11348765,15.33),(127243,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127243,37.05,0.46,257,58036,70,NULL,NULL,'2MASX J15100309+0312548',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000094,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.512917,3.21522,0.097,NULL,56381124459,880955069,13764922,17.5),(127244,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127244,38.3,0.23,456,58037,70,NULL,NULL,'2MASX J15100413+3328231',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000159,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.517208333,33.47317,0.025,NULL,60116377044,939318391,14676849,18.4),(127245,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127245,36.96,0.46,247,58038,70,NULL,NULL,'2MASX J15100496+0721020',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,'Group member',NULL,NULL,NULL,1,227.5207083,7.35069,0.053,NULL,59386825535,927919148,14498736,17.3),(127246,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127246,36.87,0.27,236,58039,70,NULL,NULL,'2MASX J15100555+0113198',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000086,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,227.523,1.22203,0.117,NULL,56372804579,880825071,13762891,16.4),(127247,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127247,38.13,0.33,423,58040,70,NULL,NULL,'2MASX J15100559+1812416',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,227.5235,18.21161,0.057,NULL,59583911786,930998621,14546853,16.7),(127248,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127248,36.87,0.27,236,58041,70,NULL,NULL,'2MASX J15100576+0114398',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000084,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,227.5239583,1.24428,0.113,NULL,56372795976,880824937,13762889,16.2),(127249,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127249,37.7,0.11,346,58042,70,NULL,NULL,'SDSS J151006.09+073802.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000154,NULL,'18.1g',0.17,NULL,'Group member',NULL,NULL,NULL,1,227.525375,7.63417,0.049,NULL,59386731651,927917682,14498713,18.1),(127250,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127250,37.15,0.46,269,58043,70,NULL,NULL,'2MASX J15100613-0006015',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000095,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,227.5255,-0.10042,0.129,NULL,45367931959,708873936,11076155,16.4),(127251,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127251,36.64,0.46,213,58044,70,NULL,NULL,'2MASX J15100628+1926226',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'17.17',0.28,NULL,NULL,NULL,NULL,NULL,1,227.526333333,19.4395,0.089,NULL,59537476738,930273074,14535516,17.17),(127252,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127252,37.74,0.12,354,58045,70,NULL,NULL,'2MASX J15100656+0850400',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000183,NULL,'16.1g',0.38,NULL,NULL,NULL,NULL,NULL,1,227.527375,8.84436,0.049,NULL,59351597583,927368712,14490136,16.1),(127253,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127253,37.21,0.46,277,58046,70,NULL,NULL,'2MASX J15100710+1006390',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.5g',0.38,NULL,NULL,NULL,NULL,NULL,1,227.5295,10.11094,0.073,NULL,59347234841,927300544,14489071,16.5),(127254,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127254,34.81,0.46,91.5,58047,70,NULL,NULL,'CGCG 165-027',NULL,'2015arXiv151105856S',2015,1,0.88,NULL,'G',0.000177,NULL,'14.6g',0.64,'S0',NULL,NULL,NULL,NULL,1,227.536875,31.88783,0.025,NULL,60087284800,938863825,14669747,14.6),(127255,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127255,37.26,0.46,283,58048,70,NULL,NULL,'2MASX J15100913+0823280',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000192,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,227.537917,8.391,0.045,NULL,59384862649,927888478,14498257,16.6),(127256,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127256,36.94,0.46,245,58049,70,NULL,NULL,'2MASX J15100914+3737280',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000155,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,227.538041667,37.62447,0.009,NULL,60102134021,939095844,14673372,16.7),(127257,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127257,37.87,0.27,374,58050,70,NULL,NULL,'SDSS J151010.30+025538.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000082,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,227.542917,2.92731,0.105,NULL,56385300197,881020315,13765942,18.3),(127258,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127258,36.87,0.27,236,58051,70,NULL,NULL,'2MASX J15101041+0132528',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000068,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.543291667,1.54811,0.109,NULL,56387178090,881049657,13766400,17.7),(127259,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127259,36.52,0.09,202,58052,70,NULL,NULL,'2MASX J15101034+0742300',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16',0.3,'S0','Group member',NULL,NULL,NULL,1,227.543291667,7.70819,0.049,NULL,59384685890,927885717,14498214,16),(127260,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127260,37.64,0.46,337,58053,70,NULL,NULL,'2MASX J15101078+0520198',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,227.5450417,5.33886,0.093,NULL,59332369376,927068271,14485441,17.4),(127261,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127261,36.58,0.25,207,58054,74.4,NULL,NULL,'CGCG 049-018',NULL,'2013AJ....146...86T',2013,1,0.59,NULL,'G',0.000147,NULL,'15.6g',0.57,'Sbc','Group member',NULL,NULL,NULL,1,227.5457083,7.62897,0.049,NULL,59386729776,927917652,14498713,15.6),(127262,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127262,36.82,0.27,231,58054,70,NULL,NULL,'CGCG 049-018',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127263,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127263,36.49,0.46,199,58055,70,NULL,NULL,'2MASX J15101137+0313318',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000103,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,227.5475,3.22547,0.097,NULL,56381123145,880955049,13764922,16.4),(127264,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127264,38.3,0.23,456,58056,70,NULL,NULL,'2MASX J15101140+3329542',NULL,'2015arXiv151105856S',2015,1,0.19,'1997A&AS..123..411M has z = 0.114459 +- 0.000394.','G',0.000155,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,227.547583,33.49839,0.025,NULL,60116376551,939318383,14676849,18.4),(127265,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127265,37.65,0.06,339,58057,70,NULL,NULL,'2MASX J15101181+0609400',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,227.5492917,6.16119,0.069,NULL,59383506427,927867287,14497926,17.5),(127266,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127266,37.54,0.46,322,58058,70,NULL,NULL,'2MASX J15101340+2514037',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000185,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.556,25.2345,0.125,NULL,59896238769,935878730,14623105,17.7),(127267,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127267,37.16,0.46,270,58059,70,NULL,NULL,'2MASX J15101393+0937010',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.558083,9.61692,0.065,NULL,59353811385,927403302,14490676,17.2),(127268,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127268,36.89,0.46,238,58060,70,NULL,NULL,'SDSS J151015.11+094713.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.563,9.78703,0.065,NULL,59346358949,927286858,14488857,17.8),(127269,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127269,38.01,0.46,399,58061,70,NULL,NULL,'2MASX J15101614+1818435',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.567167,18.31208,0.061,NULL,59583908892,930998576,14546852,17.5),(127270,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127270,36.14,0.11,169,58062,70,NULL,NULL,'2MASX J15101616+0431498',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00009,NULL,'16.0g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,227.567375,4.53036,0.093,NULL,59330903854,927045372,14485083,16),(127271,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127271,37.68,0.46,343,58063,70,NULL,NULL,'2MASX J15101631+0641290',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000177,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.568125,6.69144,0.049,NULL,59386466447,927913538,14498649,17.4),(127272,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127272,32.15,0.4,26.9,58064,75,NULL,NULL,'UGC 09746',NULL,'2008Ap.....51..336K',2008,1,1.85,NULL,'G',0.00002,NULL,'14.6g',0.45,'Sbc:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,227.5689583,1.93428,0.081,NULL,56385557458,881024335,13766005,14.6),(127273,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127273,32.16,0.43,27.1,58064,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09746',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127274,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127274,32.29,0.43,28.7,58064,75,NULL,'3.6 micron, color corrected','UGC 09746',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127275,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127275,32.38,0.2,29.9,58064,74.4,NULL,NULL,'UGC 09746',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127276,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127276,32.41,NULL,30.4,58064,72,NULL,NULL,'UGC 09746',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127277,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127277,32.51,0.49,31.8,58064,75,NULL,'IR','UGC 09746',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127278,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127278,37.65,0.06,339,58065,70,NULL,NULL,'2MASX J15101702+0443558',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,227.570791667,4.73214,0.093,NULL,59331993271,927062394,14485349,16.6),(127279,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127279,37.09,0.33,262,58066,70,NULL,NULL,'2MASX J15101749+6117010',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000082,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,227.572667,61.2835,0.005,NULL,57778470798,902788606,14106071,16.6),(127280,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127280,37.29,0.46,287,58067,70,NULL,NULL,'SDSS J151017.64+060630.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.5735,6.10853,0.069,NULL,59328739453,927011553,14484555,18),(127281,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127281,37.91,0.46,382,58068,70,NULL,NULL,'SDSS J151018.63+475104.3',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000153,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,227.577667,47.85119,0.033,NULL,59939203978,936550062,14633594,18.6),(127282,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127282,37.65,0.06,339,58069,70,NULL,NULL,'2MASX J15101955+0547118',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.581583,5.78653,0.073,NULL,59328936759,927014636,14484603,17.7),(127283,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127283,38.3,0.23,456,58070,70,NULL,NULL,'2MASX J15102011+3329092',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000103,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,227.583833,33.48597,0.025,NULL,60116384058,939318500,14676851,16.9),(127284,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127284,38.42,0.46,483,58071,70,NULL,NULL,'2MASX J15102018+2514237',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,227.584333333,25.23992,0.165,NULL,59896239031,935878734,14623105,17.9),(127285,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127285,37.71,0.46,349,58072,70,NULL,NULL,'SDSS J151020.49+021824.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000074,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,227.585417,2.30681,0.105,NULL,56386020580,881031571,13766118,18.5),(127286,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127286,34.9,0.53,95.3,58073,70,NULL,NULL,'2MASX J15102148-4451226',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00014,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,227.589458333,-44.85633,0.617,NULL,47104011426,736000178,11500002,14.7),(127287,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127287,37.43,0.46,306,58074,70,NULL,NULL,'2MASX J15102166+2405017',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.5902083,24.08378,0.117,NULL,59412221336,928315958,14504936,17.5),(127288,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127288,38.08,0.46,413,58075,70,NULL,NULL,'2MASX J15102195+5929535',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.5914583,59.49806,0.013,NULL,57774878506,902732476,14105194,17.8),(127289,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127289,37.74,0.12,354,58076,70,NULL,NULL,'2MASX J15102359+0847239',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000177,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,227.5982083,8.79011,0.049,NULL,59351613306,927368957,14490139,16.9),(127290,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127290,37.35,0.46,296,58077,70,NULL,NULL,'2MASX J15102438+5424034',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000172,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,227.6014583,54.40094,0.013,NULL,59660523128,932195673,14565557,16.9),(127291,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127291,38.5,0.46,501,58078,70,NULL,NULL,'2MASX J15102503+0655549',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.60425,6.93197,0.057,NULL,59386901889,927920342,14498755,17.2),(127292,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127292,38.01,0.46,399,58079,70,NULL,NULL,'2MASX J15102512+0410498',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000095,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,227.6047917,4.18047,0.073,NULL,59330962864,927046294,14485098,16.8),(127293,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127293,37.65,0.06,339,58080,70,NULL,NULL,'2MASX J15102544+0550278',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.08',0.2,NULL,'Group member, radial-velocity confirmed',NULL,NULL,NULL,1,227.6060417,5.84111,0.073,NULL,59328934276,927014598,14484603,17.08),(127294,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127294,38.25,0.46,446,58081,70,NULL,NULL,'SDSS J151026.29+012457.8',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000094,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,227.609583,1.41608,0.113,NULL,56386712502,881042382,13766287,17.9),(127295,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127295,37.81,0.17,365,58082,70,NULL,NULL,'2MASX J15102686+0404498',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000087,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.611875,4.08044,0.073,NULL,59330959082,927046235,14485097,17.6),(127296,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127296,38.49,0.46,500,58083,70,NULL,NULL,'SDSS J151027.19+295050.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.613333,29.84739,0.029,NULL,60085587795,938837309,14669332,18.4),(127297,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127297,37.23,0.27,280,58084,70,NULL,NULL,'2MASX J15102828+5902194',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000092,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,227.617875,59.03889,0.013,NULL,57719556165,901868065,14091688,16.2),(127298,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127298,37.65,0.06,339,58085,70,NULL,NULL,'SDSS J151028.69+053817.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.6195417,5.63819,0.077,NULL,59328796579,927012446,14484569,18.3),(127299,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127299,37.39,0.46,301,58086,70,NULL,NULL,'2MASX J15102872+0704190',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.619666667,7.07183,0.057,NULL,59386765766,927918215,14498722,17.4),(127300,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127300,34.81,0.48,91.6,58087,70,NULL,NULL,'ARK 473',NULL,'2014MNRAS.445.2677S',2014,1,0.87,NULL,'G',0.000145,NULL,'14.6g',0.53,'S0       poss. LINER',NULL,NULL,NULL,NULL,1,227.623041667,-2.16864,0.221,NULL,45381006953,709078233,11079347,14.6),(127301,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127301,36.78,0.46,227,58088,70,NULL,NULL,'2MASX J15103002+1746042',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.1g',0.34,NULL,NULL,NULL,NULL,NULL,1,227.625125,17.76794,0.045,NULL,59584061283,931000957,14546889,16.1),(127302,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127302,37.94,0.33,387,58089,70,NULL,NULL,'2MASX J15103014+0358386',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000095,NULL,'17.7g',0.21,'NLAGN',NULL,NULL,NULL,NULL,1,227.625583,3.97744,0.085,NULL,59330932478,927045819,14485090,17.7),(127303,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127303,36.75,0.46,224,58090,70,NULL,NULL,'2MASX J15103016+1849504',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,227.6257083,18.83086,0.077,NULL,59534503553,930226618,14534790,16.7),(127304,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127304,37.88,0.46,376,58091,70,NULL,NULL,'2MASX J15103169+0636140',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.631875,6.60375,0.041,NULL,59383640271,927869379,14497959,17.4),(127305,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127305,36.18,0.46,172,58092,70,NULL,NULL,'2MASX J15103241+4607298',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000196,NULL,'15.8g',0.38,'E0',NULL,NULL,NULL,NULL,1,227.635125,46.12486,0.049,NULL,59986087144,937282611,14645040,15.8),(127306,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127306,37.94,0.33,387,58093,70,NULL,NULL,'SDSS J151033.76+040002.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000085,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,227.640708333,4.00069,0.073,NULL,59330932215,927045815,14485090,18.5),(127307,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127307,37.72,0.46,349,58094,70,NULL,NULL,'2MASX J15103543+2922148',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'16.55',0.14,NULL,NULL,NULL,NULL,NULL,1,227.647583333,29.37067,0.045,NULL,60085532948,938836452,14669319,16.55),(127308,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127308,36.05,0.46,162,58095,70,NULL,NULL,'2MASX J15103595+5423143',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000184,NULL,'15.2g',0.57,'E0',NULL,NULL,NULL,NULL,1,227.649833,54.38739,0.013,NULL,59660522849,932195669,14565557,15.2),(127309,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127309,38.33,0.33,464,58096,70,NULL,NULL,'2MASX J15103617+0200596',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000096,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,227.650708333,2.01653,0.085,NULL,56385599513,881024992,13766015,17.3),(127310,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127310,37.65,0.06,339,58097,70,NULL,NULL,'SDSS J151036.41+055003.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'17.0I',0.11,NULL,NULL,NULL,NULL,NULL,1,227.6517083,5.83436,0.073,NULL,59328926772,927014480,14484601,17),(127311,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127311,37.65,0.06,339,58098,70,NULL,NULL,'2MASX J15103647+0601316',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,227.6519583,6.02556,0.069,NULL,59328911396,927014240,14484597,16.9),(127312,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127312,37.63,0.21,335,58099,70,NULL,NULL,'2MASX J15103803+0322386',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000068,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.658583333,3.3775,0.093,NULL,56381092470,880954569,13764915,17.6),(127313,'IRAS','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127313,32.76,0.8,35.7,58100,75,NULL,'A82, H','UGC 09764',NULL,'1997ApJS..109..333W',1997,1,1.9,'Often misidentified as NGC 5881.','G',0.000037,NULL,'15.1',1.2,'SB(s)dm',NULL,NULL,NULL,NULL,1,227.659041667,64.89847,NULL,NULL,57957644322,905588192,14149815,15.1),(127314,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127314,32.77,0.4,35.8,58100,75,NULL,'B','UGC 09764',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127315,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127315,33.34,0.4,46.6,58100,NULL,NULL,'Virgo cluster at 15.6 Mpc','UGC 09764',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127316,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127316,34.45,0.47,77.8,58100,75,NULL,'A82, H, raw','UGC 09764',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127317,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127317,34.48,0.47,78.8,58100,75,NULL,'A82, H, inv','UGC 09764',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127318,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127318,34.94,0.47,97.2,58100,75,NULL,'A82, H, cor','UGC 09764',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127319,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127319,37.65,0.06,339,58101,70,NULL,NULL,'2MASX J15103848+0514196',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,227.660417,5.23878,0.093,NULL,59331910477,927061101,14485329,16.5),(127320,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127320,37.65,0.06,339,58102,70,NULL,NULL,'2MASX J15103888+0510576',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,227.662083,5.18258,0.093,NULL,59331909271,927061082,14485329,16.5),(127321,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127321,36.38,0.33,189,58103,70,NULL,NULL,'2MASX J15103895+0601506',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,227.662375,6.03067,0.069,NULL,59328919597,927014368,14484599,16.3),(127322,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127322,37.88,0.46,377,58104,70,NULL,NULL,'2MASX J15103918+2925288',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'16.71',0.16,NULL,NULL,NULL,NULL,NULL,1,227.663208333,29.42464,0.045,NULL,60085740596,938839696,14669370,16.71),(127323,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127323,37.87,0.27,374,58105,70,NULL,NULL,'2MASX J15103970+0254476',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000104,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,227.665375,2.91317,0.105,NULL,56385272179,881019877,13765935,16.9),(127324,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127324,37.65,0.06,339,58106,70,NULL,NULL,'2MASX J15103989+0539186',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'15.8I',0.2,NULL,NULL,NULL,NULL,NULL,1,227.666375,5.65528,0.073,NULL,59328808182,927012627,14484572,15.8),(127325,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127325,37.65,0.06,339,58107,70,NULL,NULL,'2MASX J15104042+0557216',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.668333,5.95603,0.069,NULL,59328910984,927014234,14484597,17.3),(127326,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127326,33.6,0.45,52.4,58108,NULL,NULL,NULL,'UGC 09759',NULL,'2009ApJS..182..474S',2009,1,2,NULL,'G',0.000027,NULL,'15.10',0.4,'S0a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,227.6707917,55.34983,0.013,NULL,57583350983,899739859,14058435,15.1),(127327,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127327,33.65,0.44,53.6,58108,NULL,NULL,'Malmquist cor.','UGC 09759',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127328,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127328,33.65,0.4,53.7,58108,NULL,NULL,'mean','UGC 09759',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127329,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127329,33.73,0.2,55.7,58108,74.4,NULL,NULL,'UGC 09759',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127330,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127330,33.83,0.47,58.2,58108,NULL,NULL,'H','UGC 09759',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127331,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127331,33.91,0.45,60.6,58108,NULL,NULL,'K','UGC 09759',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127332,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127332,34.03,0.46,64.1,58108,NULL,NULL,'J','UGC 09759',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127333,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127333,36.32,0.46,183,58109,70,NULL,NULL,'2MASX J15104100+0828500',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000179,NULL,'16.0g',0.37,NULL,NULL,NULL,NULL,NULL,1,227.6709583,8.48061,0.041,NULL,59384139101,927877173,14498080,16),(127334,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127334,37.16,0.46,270,58110,70,NULL,NULL,'2MASX J15104125+0026396',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000093,NULL,'16.3g',0.41,NULL,NULL,NULL,NULL,NULL,1,227.671875,0.44419,0.125,NULL,56372608106,880822001,13762843,16.3),(127335,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127335,38.01,0.46,400,58111,70,NULL,NULL,'2MASX J15104353+2249322',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000195,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,227.6812917,22.8255,0.117,NULL,59410099745,928282808,14504418,17.3),(127336,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127336,37.65,0.06,339,58112,70,NULL,NULL,'SDSS J151043.53+052851.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.681417,5.48089,0.081,NULL,59328771856,927012060,14484563,18.3),(127337,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127337,37.65,0.06,339,58113,70,NULL,NULL,'2MASX J15104377+0558146',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,227.68225,5.97061,0.069,NULL,59328910835,927014231,14484597,18),(127338,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127338,37.81,0.17,365,58114,70,NULL,NULL,'2MASX J15104411+0418386',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000078,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,227.683833,4.31058,0.077,NULL,59331047863,927047622,14485119,17.1),(127339,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127339,37.65,0.06,339,58115,70,NULL,NULL,'2MASX J15104431+0453216',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.684667,4.88939,0.097,NULL,59332089753,927063902,14485373,17.6),(127340,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127340,37.57,0.46,326,58116,70,NULL,NULL,'2MASX J15104454+2211152',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.685666667,22.18756,0.109,NULL,59422855023,928482109,14507532,18),(127341,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127341,36.38,0.33,189,58117,70,NULL,NULL,'2MASX J15104605+0603326',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000167,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,227.6917917,6.05914,0.069,NULL,59328906933,927014170,14484596,16.4),(127342,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127342,37.65,0.06,339,58118,70,NULL,NULL,'SDSS J151046.82+054740.4',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.1I',NULL,NULL,NULL,NULL,NULL,NULL,1,227.695,5.79464,0.073,NULL,59328945439,927014772,14484605,17.1),(127343,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127343,37.65,0.06,339,58119,70,NULL,NULL,'2MASX J15104752+0538566',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.698125,5.64908,0.073,NULL,59328808336,927012630,14484572,17.8),(127344,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127344,36.89,0.46,239,58120,70,NULL,NULL,'2MASX J15104789+3855423',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.699583,38.92853,0.057,NULL,60104349054,939130453,14673913,17.3),(127345,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127345,37.63,0.21,335,58121,70,NULL,NULL,'2MASX J15104792+0329026',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000096,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,227.6997917,3.48419,0.097,NULL,56381060840,880954075,13764907,16.7),(127346,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127346,38.33,0.33,464,58122,70,NULL,NULL,'SDSS J151048.03+020103.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00008,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.700125,2.01761,0.085,NULL,56385575997,881024624,13766009,18.3),(127347,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127347,32.94,0.49,38.8,58123,70,NULL,NULL,'NGC 5863',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00003,NULL,'13.70',1.2,'(R\')SAB(rs)a','in a pair',NULL,NULL,NULL,1,227.7015,-18.43103,0.433,NULL,46700132266,729689566,11401399,13.7),(127348,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127348,34.06,0.4,64.9,58123,NULL,NULL,'mean','NGC 5863',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127349,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127349,34.18,0.47,68.6,58123,NULL,NULL,'H','NGC 5863',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127350,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127350,34.18,0.45,68.7,58123,NULL,NULL,'K','NGC 5863',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127351,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127351,34.26,0.46,71,58123,NULL,NULL,'J','NGC 5863',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127352,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127352,37.69,0.46,345,58124,70,NULL,NULL,'2MASX J15104865+6057030',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000076,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.7029583,60.95094,0.021,NULL,57778232781,902784887,14106013,17.6),(127353,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127353,37.65,0.06,339,58125,70,NULL,NULL,'2MASX J15105101+0548026',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'15.8I',0.21,NULL,'Group member, radial-velocity confirmed',NULL,NULL,NULL,1,227.712625,5.80086,0.073,NULL,59328945957,927014780,14484605,15.8),(127354,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127354,37.81,0.17,365,58126,70,NULL,NULL,'2MASX J15105133+0409026',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000067,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.713917,4.15069,0.073,NULL,59330973483,927046460,14485100,17.8),(127355,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127355,37.65,0.06,339,58127,70,NULL,NULL,'2MASX J15105208+0539266',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'15.8I',0.2,NULL,'Group member, radial-velocity confirmed',NULL,NULL,NULL,1,227.717167,5.65747,0.073,NULL,59328810045,927012656,14484572,15.8),(127356,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127356,36.18,0.26,172,58128,70,NULL,NULL,'GIN 405',NULL,'2001MNRAS.321..277C',2001,1,0.49,NULL,'G',NULL,NULL,'16.0g',0.42,'S',NULL,NULL,NULL,NULL,1,227.7175417,4.86769,0.097,NULL,59332099550,927064055,14485375,16),(127357,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127357,37.65,0.06,339,58128,70,NULL,NULL,'GIN 405',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127358,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127358,37.65,0.06,339,58129,70,NULL,NULL,'2MASX J15105275+0543296',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'15.9I',0.22,NULL,NULL,NULL,NULL,NULL,1,227.7199583,5.72483,0.073,NULL,59328807083,927012610,14484572,15.9),(127359,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127359,37.26,0.46,283,58130,70,NULL,NULL,'SDSS J151052.80+265636.4',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,227.720041667,26.94347,0.085,NULL,59897936651,935905260,14623519,NULL),(127360,'BCG','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127360,37.25,0.35,262,58131,60,NULL,NULL,'ABELL 2029',0.0777,'1980ApJ...241..486H',1980,1,NULL,'Position for IC 1101 adopted for ABELL 2029.','GClstr',0.00056,NULL,NULL,NULL,'I      [BM]',NULL,NULL,NULL,NULL,1,227.729167,5.72,0.073,NULL,59328807745,927012621,14484572,NULL),(127361,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127361,37.66,0.16,340,58131,NULL,NULL,'ABELL 2029 cluster, avg. of 14 spiral galaxies                    ','ABELL 2029',NULL,'2003AJ....126..675D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127362,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127362,37.65,0.06,339,58132,70,NULL,NULL,'2MASX J15105509+0533316',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.729625,5.55881,0.081,NULL,59328817392,927012771,14484574,17.3),(127363,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127363,35.51,0.2,126,58133,74.4,NULL,NULL,'CGCG 077-030',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000178,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,227.7305,10.95242,0.081,NULL,59348578379,927321537,14489399,16.3),(127364,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127364,34.79,0.46,90.9,58134,70,NULL,NULL,'NGC 5872',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00011,NULL,'13.58',0.9,'SAB0^0^:',NULL,NULL,NULL,NULL,1,227.731917,-11.48014,0.409,NULL,46484556865,726321201,11348768,13.58),(127365,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127365,37.81,0.17,365,58135,70,NULL,NULL,'2MASX J15105567+0405346',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000111,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,227.731917,4.09283,0.073,NULL,59330983689,927046620,14485103,17.2),(127366,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127366,37.28,0.46,286,58136,70,NULL,NULL,'2MASX J15105577-0019252',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000098,NULL,'16.3g',0.37,'E0',NULL,NULL,NULL,NULL,1,227.732375,-0.32356,0.161,NULL,45367725795,708870715,11076104,16.3),(127367,'BCG','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127367,37.25,0.35,262,58137,60,NULL,'ABELL 2029, BCG','IC 1101',0.0777,'1980ApJ...241..486H',1980,1,1.2,NULL,'G',0.000087,NULL,'14.73',0.6,'cD;S0-:','Group member, radial-velocity confirmed',NULL,'radio jet',NULL,1,227.73375,5.74478,0.073,NULL,59328897120,927014017,14484594,14.73),(127368,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127368,38.04,0.46,406,58138,70,NULL,NULL,'2MASX J15105652+0758499',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000147,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,227.7355,7.98064,0.045,NULL,59384781849,927887216,14498237,18),(127369,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127369,38.39,0.46,476,58139,70,NULL,NULL,'SDSS J151057.64+562150.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000101,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,227.7402083,56.36408,0.013,NULL,57581898312,899717161,14058080,18.2),(127370,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127370,37.65,0.06,339,58140,70,NULL,NULL,'2MASX J15105810+0514506',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,227.74225,5.24744,0.093,NULL,59331917611,927061212,14485331,17.9),(127371,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127371,38.19,0.46,435,58141,70,NULL,NULL,'2MASX J15105827+5425104',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.7427083,54.41964,0.013,NULL,59660347028,932192922,14565514,17.8),(127372,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127372,36.95,0.46,246,58142,70,NULL,NULL,'2MASX J15105828+4958487',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,227.743041667,49.98019,0.021,NULL,59938099335,936532802,14633325,17.2),(127373,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127373,37.59,0.46,329,58143,70,NULL,NULL,'2MASX J15105846+1323573',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,227.743666667,13.39919,0.101,NULL,59570847185,930794487,14543663,NULL),(127374,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127374,32.16,NULL,27,58144,72,NULL,NULL,'UGC 09751',NULL,'2014Ap.....57..457K',2014,1,1,NULL,'G',0.00005,NULL,'15.62',0.2,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,227.74375,1.4375,0.109,NULL,56386696813,881042137,13766283,15.62),(127375,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127375,37.65,0.06,339,58145,70,NULL,NULL,'2MASX J15105878+0541308',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000167,NULL,'16.4I',0.16,NULL,NULL,NULL,NULL,NULL,1,227.744917,5.69189,0.073,NULL,59328810248,927012660,14484572,16.4),(127376,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127376,37.65,0.06,339,58146,70,NULL,NULL,'SDSS J151059.92+045644.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.749666667,4.94575,0.101,NULL,59332071927,927063623,14485369,17.9),(127377,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127377,37.65,0.06,339,58147,70,NULL,NULL,'SDSS J151100.91+045029.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.753833,4.84156,0.097,NULL,59332085038,927063828,14485372,18.4),(127378,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127378,37.63,0.21,335,58148,70,NULL,NULL,'2MASX J15110098+0325318',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000076,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,227.754,3.42558,0.097,NULL,56381079877,880954373,13764912,16.9),(127379,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127379,38.01,0.33,400,58149,70,NULL,NULL,'SDSS J151101.44+031921.0',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000074,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,227.7560417,3.32253,0.093,NULL,56380981175,880952830,13764887,17.7),(127380,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127380,35.28,0.61,114,58150,70,NULL,NULL,'ESO 448- G 015',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000033,NULL,'13.53',0.3,'S...',NULL,NULL,NULL,NULL,1,227.758167,-31.2595,0.333,NULL,47206730484,737605163,11525080,13.53),(127381,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127381,35.98,0.46,157,58150,NULL,NULL,'Malmquist cor.','ESO 448- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127382,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127382,36.3,0.4,182,58150,NULL,NULL,NULL,'ESO 448- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127383,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127383,36.34,0.2,185,58150,74.4,NULL,NULL,'ESO 448- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127384,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127384,37.65,0.06,339,58151,70,NULL,NULL,'2MASX J15110220+0518558',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.7592083,5.31544,0.093,NULL,59329089050,927017016,14484640,17.2),(127385,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127385,37.73,0.46,351,58152,70,NULL,NULL,'2MASX J15110227+2903489',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.0001,NULL,'18.48',0.18,'E',NULL,NULL,NULL,NULL,1,227.759625,29.06378,0.045,NULL,59904157872,936002466,14625038,18.48),(127386,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127386,37.91,0.46,382,58153,70,NULL,NULL,'2MASX J15110277+2227589',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'18.09',0.14,NULL,NULL,NULL,NULL,NULL,1,227.761625,22.46647,0.113,NULL,59422965638,928483838,14507559,18.09),(127387,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127387,36.4,0.46,191,58154,70,NULL,NULL,'2MASX J15110303+2024329',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'17.04',0.31,NULL,NULL,NULL,NULL,NULL,1,227.762833,20.40925,0.077,NULL,59537720465,930276882,14535576,17.04),(127388,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127388,37.69,0.46,346,58155,70,NULL,NULL,'2MASX J15110344+3619185',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,227.764458333,36.32178,0.005,NULL,60113822979,939278484,14676226,17.9),(127389,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127389,36.83,0.46,232,58156,70,NULL,NULL,'MCG +06-33-025',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000117,NULL,'15.4g',0.58,'E0',NULL,NULL,NULL,NULL,1,227.765833,37.02586,0.017,NULL,60101476841,939085575,14673212,15.4),(127390,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127390,37.63,0.21,335,58157,70,NULL,NULL,'SDSS J151104.62+032743.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000072,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,227.7692917,3.46217,0.097,NULL,56381047602,880953868,13764904,18.8),(127391,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127391,37.25,0.46,282,58158,70,NULL,NULL,'2MASX J15110516+1414103',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,227.771417,14.23619,0.101,NULL,59570385619,930787275,14543551,NULL),(127392,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127392,38.69,0.46,548,58159,70,NULL,NULL,'SDSS J151105.14+253449.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.771417,25.58031,0.177,NULL,59896462832,935882231,14623159,18.1),(127393,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127393,37.65,0.06,339,58160,70,NULL,NULL,'2MASX J15110529+0450088',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.772083,4.83583,0.097,NULL,59332085118,927063829,14485372,17.6),(127394,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127394,38.03,0.12,403,58161,70,NULL,NULL,'2MASX J15110565+0000502',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000073,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,227.7734583,0.01394,0.137,NULL,56372497898,880820279,13762816,17.1),(127395,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127395,36.14,0.11,169,58162,70,NULL,NULL,'2MASX J15110563+0430068',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000081,NULL,'16.2g',0.41,'NLAGN',NULL,NULL,NULL,NULL,1,227.7734583,4.50197,0.081,NULL,59331020859,927047200,14485112,16.2),(127396,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127396,37.65,0.06,339,58163,70,NULL,NULL,'SDSS J151105.83+053842.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.774333,5.64506,0.077,NULL,59328820285,927012816,14484575,18.5),(127397,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127397,37.62,0.46,334,58164,70,NULL,NULL,'2MASX J15110628+2507059',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,227.7760417,25.11819,0.165,NULL,59410527848,928289497,14504523,17.3),(127398,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127398,37.17,0.46,272,58165,70,NULL,NULL,'2MASX J15110672-0212267',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.7780417,-2.20753,0.221,NULL,45380972788,709077699,11079339,17.7),(127399,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127399,38.03,0.12,403,58166,70,NULL,NULL,'SDSS J151106.77-000807.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000072,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,227.77825,-0.13536,0.129,NULL,45367698981,708870296,11076098,18.8),(127400,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127400,36.78,0.46,227,58167,70,NULL,NULL,'2MASX J15110723+1032399',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,'PRED','17.20',0.42,NULL,NULL,NULL,NULL,NULL,1,227.780125,10.54453,0.077,NULL,59346765083,927293204,14488956,17.2),(127401,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127401,37.65,0.06,339,58168,70,NULL,NULL,'2MASX J15110743+0519018',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000167,NULL,'15.3g',0.52,NULL,NULL,NULL,NULL,NULL,1,227.7807917,5.31728,0.093,NULL,59329089355,927017021,14484640,15.3),(127402,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127402,37.65,0.06,339,58169,70,NULL,NULL,'2MASX J15110742+0532598',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,227.781083,5.54992,0.081,NULL,59328763394,927011928,14484561,16.9),(127403,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127403,37.65,0.06,339,58170,70,NULL,NULL,'2MASX J15110776+0519379',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.782333333,5.32714,0.093,NULL,59329089527,927017023,14484640,17.2),(127404,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127404,37.65,0.06,339,58171,70,NULL,NULL,'2MASX J15110775+0553049',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,227.782417,5.88461,0.069,NULL,59328949006,927014828,14484606,17.4),(127405,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127405,37.92,0.46,385,58172,70,NULL,NULL,'SDSS J151107.89+223454.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000109,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.782917,22.58181,0.109,NULL,59422990776,928484230,14507566,18.5),(127406,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127406,37.04,0.46,256,58173,70,NULL,NULL,'2MASX J15110870-0150407',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00015,NULL,'16.6g',0.37,NULL,NULL,NULL,NULL,NULL,1,227.7862083,-1.84481,0.217,NULL,45381553065,709086766,11079480,16.6),(127407,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127407,37.27,0.46,285,58174,70,NULL,NULL,'SDSS J151108.79+082557.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.786667,8.43258,0.041,NULL,59351895808,927373372,14490208,18.2),(127408,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127408,38.03,0.12,403,58175,70,NULL,NULL,'2MASX J15110939-0005507',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,'FoF','17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.7892083,-0.09733,0.129,NULL,45367698437,708870288,11076098,17.4),(127409,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127409,37.65,0.06,339,58176,70,NULL,NULL,'2MASX J15110976+0612039',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.79075,6.20119,0.065,NULL,59383580838,927868450,14497944,17.5),(127410,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127410,36.97,0.46,248,58177,70,NULL,NULL,'2MASX J15111002+3631526',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.79175,36.53133,0.005,NULL,60108574030,939196469,14674944,17),(127411,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127411,37.81,0.16,365,58178,70,NULL,NULL,'2MASX J15111008+1801279',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.79225,18.0245,0.045,NULL,59583893127,930998330,14546848,18),(127412,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127412,37.65,0.06,339,58179,70,NULL,NULL,'2MASX J15111016+0549239',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'15.6I',0.25,NULL,'Group member, radial-velocity confirmed',NULL,NULL,NULL,1,227.7922917,5.82322,0.069,NULL,59328899228,927014050,14484594,15.6),(127413,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127413,38.03,0.12,403,58180,70,NULL,NULL,'2MASX J15111079-0005177',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00008,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,227.794833,-0.08828,0.137,NULL,45379224615,709050384,11078912,17.4),(127414,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127414,38.03,0.12,403,58181,70,NULL,NULL,'2MASX J15111126-0008447',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000077,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,227.79675,-0.14564,0.129,NULL,45379231135,709050486,11078913,17.8),(127415,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127415,37.65,0.06,339,58182,70,NULL,NULL,'2MASX J15111125+0447539',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.796917,4.79833,0.097,NULL,59332084403,927063818,14485372,17.4),(127416,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127416,37.65,0.06,339,58183,70,NULL,NULL,'2MASX J15111238+0454279',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,227.8015,4.90789,0.101,NULL,59332080201,927063753,14485371,16.9),(127417,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127417,36.21,0.13,174,58184,70,NULL,NULL,'SDSS J151112.57+014433.7',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000081,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.802417,1.74272,0.101,NULL,56387391678,881052994,13766453,17.4),(127418,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127418,37.9,0.46,380,58185,70,NULL,NULL,'SDSS J151112.64+274540.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.802666667,27.76133,0.065,NULL,59897650807,935900793,14623449,17.9),(127419,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127419,37.85,0.46,372,58186,70,NULL,NULL,'2MASX J15111269+1816279',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,227.802917,18.27439,0.061,NULL,59580480440,930945006,14546015,17.4),(127420,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127420,37.65,0.06,339,58187,70,NULL,NULL,'2MASX J15111291+0618179',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,227.803833,6.30497,0.061,NULL,59383714170,927870533,14497977,17.5),(127421,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127421,37.81,0.16,365,58188,70,NULL,NULL,'2MASX J15111423+1805379',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,227.809458333,18.09403,0.057,NULL,59580418880,930944045,14546000,18.3),(127422,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127422,37.63,0.21,335,58189,70,NULL,NULL,'2MASX J15111467+0329559',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000097,NULL,'16.1g',0.44,'BrClG',NULL,NULL,NULL,NULL,1,227.8112917,3.49878,0.097,NULL,56381755050,880964922,13765076,16.1),(127423,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127423,37.47,0.27,311,58190,70,NULL,NULL,'SDSS J151115.02+190823.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.812625,19.13983,0.089,NULL,59534698907,930229670,14534838,17.8),(127424,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127424,34.53,0.52,80.7,58191,70,NULL,NULL,'2MASX J15111535-1141427',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,227.813833,-11.69544,0.401,NULL,46482990401,726296725,11348386,16),(127425,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127425,36.52,0.09,202,58192,70,NULL,NULL,'GIN 418',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000137,NULL,'15.4g',0.54,'E','Group member',NULL,NULL,NULL,1,227.816708333,7.4895,0.057,NULL,59386864236,927919753,14498746,15.4),(127426,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127426,36.59,0.25,208,58192,74.4,NULL,NULL,'GIN 418',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127427,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127427,36.82,0.27,231,58192,70,NULL,NULL,'GIN 418',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127428,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127428,38.03,0.12,403,58193,70,NULL,NULL,'2MASX J15111605-0006297',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000076,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.816791667,-0.10831,0.137,NULL,45379238856,709050607,11078915,18.1),(127429,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127429,37.65,0.06,339,58194,70,NULL,NULL,'2MASX J15111627+0623539',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,227.817958333,6.39822,0.061,NULL,59383688086,927870126,14497970,16.3),(127430,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127430,37.65,0.06,339,58195,70,NULL,NULL,'SDSS J151116.65+060718.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.819375,6.12167,0.065,NULL,59328842677,927013166,14484580,18.2),(127431,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127431,37.52,0.46,319,58196,70,NULL,NULL,'2MASX J15111703+3943306',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,227.821083333,39.72511,0.049,NULL,60103839691,939122495,14673788,17.4),(127432,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127432,35.13,0.51,106,58197,70,NULL,NULL,'2MASX J15111714-0952317',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00008,NULL,'16.25',NULL,NULL,NULL,NULL,NULL,NULL,1,227.821333,-9.87572,0.349,NULL,46485543348,726336614,11349009,16.25),(127433,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127433,36.93,0.46,244,58198,70,NULL,NULL,'2MASX J15111722+0658229',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,227.821833333,6.97303,0.053,NULL,59383297449,927864022,14497875,16.6),(127434,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127434,37.65,0.06,339,58199,70,NULL,NULL,'2MASX J15111721+0626229',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,227.8219583,6.43967,0.061,NULL,59383690221,927870159,14497971,18.2),(127435,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127435,37.65,0.06,339,58200,70,NULL,NULL,'2MASX J15111734+0513199',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,227.8222917,5.22214,0.093,NULL,59329092919,927017076,14484641,16.7),(127436,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127436,37.65,0.06,339,58201,70,NULL,NULL,'2MASX J15111761+0622129',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000163,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.8235417,6.37036,0.061,NULL,59383685634,927870088,14497970,18),(127437,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127437,36.24,0.46,177,58202,70,NULL,NULL,'2MASX J15111773+1345040',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.823916667,13.75119,0.117,NULL,59570891258,930795175,14543674,17.2),(127438,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127438,36.6,0.46,209,58203,70,NULL,NULL,'2MASX J15111832+3037207',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000107,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,227.826417,30.62228,0.037,NULL,60085888419,938842006,14669406,17.1),(127439,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127439,37.79,0.46,362,58204,70,NULL,NULL,'2MASX J15111863+4433112',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000204,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,227.827833,44.55308,0.029,NULL,59984990881,937265482,14644773,16.7),(127440,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127440,37.65,0.06,339,58205,70,NULL,NULL,'2MASX J15111901+0514179',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000127,NULL,'16.66',0.55,NULL,NULL,NULL,NULL,NULL,1,227.829167,5.23833,0.093,NULL,59329091919,927017061,14484641,16.66),(127441,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127441,38.69,0.46,546,58206,70,NULL,NULL,'SDSS J151119.65+305205.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000133,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,227.831917,30.86825,0.021,NULL,60086948308,938858567,14669665,18.7),(127442,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127442,37.81,0.16,365,58207,70,NULL,NULL,'2MASX J15111969+1802399',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,227.832083,18.04422,0.057,NULL,59580416665,930944010,14546000,16.2),(127443,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127443,37.65,0.06,339,58208,70,NULL,NULL,'2MASX J15112035+0603569',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,227.834875,6.06569,0.065,NULL,59328855155,927013361,14484583,16.1),(127444,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127444,37.11,0.46,265,58209,70,NULL,NULL,'2MASX J15112062+0251239',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000072,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.8359583,2.85675,0.069,NULL,56385983571,881030993,13766109,17.2),(127445,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127445,37.65,0.06,339,58210,70,NULL,NULL,'SDSS J151121.39+061845.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.1I',0.11,NULL,NULL,NULL,NULL,NULL,1,227.839167,6.3125,0.061,NULL,59383714010,927870531,14497977,17.1),(127446,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127446,37.65,0.06,339,58211,70,NULL,NULL,'SDSS J151121.51+054120.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'16.7I',0.15,NULL,NULL,NULL,NULL,NULL,1,227.839625,5.68897,0.077,NULL,59328789928,927012342,14484567,16.7),(127447,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127447,36.52,0.09,202,58212,70,NULL,NULL,'2MASX J15112156+0722508',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00019,NULL,'15.7g',0.5,'E','Group member',NULL,NULL,NULL,1,227.839708333,7.38072,0.049,NULL,59386852041,927919563,14498743,15.7),(127448,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127448,37.9,0.46,381,58213,70,NULL,NULL,'2MASX J15112218+2447550',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000194,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.842583333,24.79875,0.145,NULL,59410588011,928290437,14504538,17.2),(127449,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127449,37.39,0.46,301,58214,70,NULL,NULL,'2MASX J15112252+2030376',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.843791667,20.51042,0.101,NULL,59535750216,930246097,14535095,17.7),(127450,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127450,36.52,0.09,202,58215,70,NULL,NULL,'2MASX J15112351+0716258',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',NULL,NULL,'16',0.3,'S0','Group member',NULL,NULL,NULL,1,227.847875,7.27381,0.049,NULL,59386779780,927918434,14498725,16),(127451,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127451,37.81,0.16,365,58216,70,NULL,NULL,'2MASX J15112423+1747420',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,227.851208333,17.79497,0.033,NULL,59583572018,930993312,14546770,17.3),(127452,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127452,36.94,0.46,244,58217,70,NULL,NULL,'2MASX J15112458+0010449',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000085,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.8522917,0.17908,0.125,NULL,56386138336,881033411,13766147,16.6),(127453,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127453,38.2,0.19,436,58218,70,NULL,NULL,'2MASX J15112521+1723260',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,227.8549583,17.3905,0.049,NULL,59583744231,930996003,14546812,18.2),(127454,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127454,35.55,0.46,129,58219,70,NULL,NULL,'CGCG 077-033',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.00012,NULL,'15.7',0.58,NULL,NULL,NULL,NULL,NULL,1,227.855041667,9.22453,0.049,NULL,59351648486,927369507,14490148,15.7),(127455,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127455,36.21,0.13,174,58220,70,NULL,NULL,'CGCG 021-034',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000104,NULL,'16.1g',0.44,'E0','Group member',NULL,NULL,NULL,1,227.855875,1.68564,0.101,NULL,56387414562,881053352,13766458,16.1),(127456,'GRB','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127456,45.41,1.1,3260,58221,69.7,NULL,'Fiducial','GRB 060714',2.71,'2009MNRAS.400..775C',2009,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,227.8602083,-6.56619,0.217,NULL,46494219343,726472177,11351127,NULL),(127457,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127457,37.27,0.46,284,58222,70,NULL,NULL,'2MASX J15112647+3706516',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000147,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.86025,37.11442,0.017,NULL,60101465975,939085405,14673209,17.5),(127458,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127458,35.95,0.46,155,58223,70,NULL,NULL,'2MASX J15112677+0409539',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000082,NULL,'16.5g',0.3,'NLAGN',NULL,NULL,NULL,'Sy 2',1,227.8615,4.16483,0.077,NULL,59330951897,927046123,14485095,16.5),(127459,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127459,36.21,0.13,174,58224,70,NULL,NULL,'SDSS J151127.08+014607.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000084,NULL,'17.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,227.862875,1.76875,0.101,NULL,56387423348,881053489,13766460,17.6),(127460,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127460,37.87,0.46,376,58225,70,NULL,NULL,'2MASX J15112713+1638540',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.862917,16.64839,0.053,NULL,59582641746,930978777,14546543,17.5),(127461,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127461,36.91,0.33,241,58226,70,NULL,NULL,'2MASX J15112726+2000446',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.863708333,20.01247,0.053,NULL,59537821910,930278467,14535601,17.6),(127462,'SNIa','2016-12-15 15:15:32','2016-12-16 11:20:45','1','SN 1999dg','R',127462,34.81,0.09,91.6,58227,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 09758',NULL,'2015Sci...347.1459K',2015,1,1.2,NULL,'G',0.000143,NULL,'14.19',1.2,'S0',NULL,NULL,NULL,NULL,1,227.866875,13.48356,0.101,NULL,59570804020,930793812,14543653,14.19),(127463,'SNIa','2016-12-15 15:15:32','2016-12-16 11:20:45','1','SN 1999dg','R',127463,34.86,0.09,93.8,58227,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 09758',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127464,'SNIa','2016-12-15 15:15:32','2016-12-16 11:20:45','1','SN 1999dg',NULL,127464,35,0.18,97.9,58227,70,NULL,'SALT 2','UGC 09758',0.022059,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127465,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127465,38.03,0.12,403,58228,70,NULL,NULL,'SDSS J151128.32-000358.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000068,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,227.868,-0.06625,0.137,NULL,45375031153,708984861,11077888,18.8),(127466,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127466,36.52,0.09,202,58229,70,NULL,NULL,'2MASX J15112862+0715438',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'17.5g',0.16,'E','Group member',NULL,NULL,NULL,1,227.8692083,7.26225,0.049,NULL,59386788721,927918573,14498727,17.5),(127467,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127467,37.84,0.46,370,58230,70,NULL,NULL,'2MASX J15112861+1319120',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.869333,13.31989,0.125,NULL,59570787327,930793551,14543649,17.9),(127468,'Tully est','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127468,32.77,0.8,35.9,58231,75,NULL,NULL,'IC 4522',NULL,'1988NBGC.C....0000T',1988,1,2.9,NULL,'G',0.00001,NULL,'13.7b',0.9,'Sb',NULL,NULL,NULL,NULL,1,227.8705,-75.85997,0.393,NULL,44238809594,691231399,10800490,13.7),(127469,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127469,32.91,0.46,38.1,58231,NULL,NULL,'J','IC 4522',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127470,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127470,32.96,0.4,39.1,58231,NULL,NULL,'mean','IC 4522',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127471,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127471,32.98,0.45,39.4,58231,NULL,NULL,'K','IC 4522',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127472,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127472,33,0.47,39.8,58231,NULL,NULL,'H','IC 4522',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127473,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127473,37.81,0.16,365,58232,70,NULL,NULL,'2MASX J15112898+1806347',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,227.870708333,18.10961,0.057,NULL,59580431122,930944236,14546003,17.1),(127474,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127474,36.53,0.2,202,58233,74.4,NULL,NULL,'2MASX J15112959+1219370',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.00063,NULL,'16.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.8732083,12.327,0.109,NULL,59569177646,930768400,14543256,16),(127475,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127475,38.2,0.19,436,58234,70,NULL,NULL,'2MASX J15113002+1722360',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.87525,17.37678,0.049,NULL,59583715172,930995549,14546805,17.4),(127476,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127476,38.03,0.12,403,58235,70,NULL,NULL,'2MASX J15113028-0017417',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000072,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,227.8762917,-0.29492,0.129,NULL,45379275506,709051179,11078924,18.3),(127477,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127477,38.03,0.12,403,58236,70,NULL,NULL,'SDSS J151130.54-000614.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000082,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,227.87725,-0.10406,0.137,NULL,45379236911,709050576,11078915,18.7),(127478,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127478,37.65,0.06,339,58237,70,NULL,NULL,'2MASX J15113128+0615468',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,227.8802083,6.26297,0.061,NULL,59383590177,927868596,14497946,17.4),(127479,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127479,36.52,0.09,202,58238,70,NULL,NULL,'CGCG 049-033',NULL,'2015arXiv151105856S',2015,1,1.9,NULL,'G',0.00012,NULL,'13.44',1,'S0','Group member',NULL,NULL,'Flat-Spectrum Radio Source',1,227.88075,7.25197,0.049,NULL,59386788593,927918571,14498727,13.44),(127480,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127480,36.58,0.25,207,58238,74.4,NULL,NULL,'CGCG 049-033',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127481,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127481,36.82,0.27,231,58238,70,NULL,NULL,'CGCG 049-033',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127482,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127482,37.65,0.06,339,58239,70,NULL,NULL,'2MASX J15113148+0622258',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,227.8810417,6.37383,0.061,NULL,59383688764,927870136,14497970,18.1),(127483,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127483,35.96,0.25,156,58240,74.4,NULL,NULL,'CGCG 049-030',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.00008,NULL,'13.93',0.8,'S;BrClG','Group member',NULL,NULL,NULL,1,227.881416667,4.5175,0.081,NULL,59330819025,927044047,14485063,13.93),(127484,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127484,36.14,0.11,169,58240,70,NULL,NULL,'CGCG 049-030',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127485,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127485,36.18,0.26,172,58240,70,NULL,NULL,'CGCG 049-030',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127486,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127486,37.65,0.06,339,58241,70,NULL,NULL,'SDSS J151131.49+055115.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.88125,5.85417,0.073,NULL,59328895983,927013999,14484593,18.4),(127487,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127487,36.21,0.13,174,58242,70,NULL,NULL,'CGCG 021-037 NED01',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000102,NULL,'15.0g',0.66,'BrClG',NULL,NULL,NULL,NULL,1,227.882375,1.76389,0.101,NULL,56387435064,881053672,13766463,15),(127488,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127488,37.81,0.16,365,58243,70,NULL,NULL,'SDSS J151131.90+180618.3',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'16.3g',0.37,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.882917,18.10511,0.057,NULL,59580431189,930944237,14546003,16.3),(127489,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127489,37.65,0.06,339,58244,70,NULL,NULL,'2MASX J15113252+0605229',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.885333333,6.08986,0.065,NULL,59328849201,927013268,14484582,17.8),(127490,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127490,36.21,0.13,174,58245,70,NULL,NULL,'2MASX J15113284+0146549',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000073,NULL,'15.8g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,227.886875,1.78206,0.101,NULL,56387433954,881053655,13766463,15.8),(127491,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127491,37.81,0.16,365,58246,70,NULL,NULL,'2MASX J15113290+1805067',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.88725,18.08525,0.057,NULL,59580417113,930944017,14546000,17.8),(127492,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127492,35.75,0.46,141,58247,70,NULL,NULL,'CGCG 077-036',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000087,NULL,'15.3',0.7,NULL,NULL,NULL,NULL,NULL,1,227.8895,9.47339,0.081,NULL,59353804505,927403195,14490674,15.3),(127493,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127493,37.94,0.46,387,58248,70,NULL,NULL,'SDSS J151133.68+242102.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.2g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.890333,24.35078,0.133,NULL,59411336867,928302138,14504720,18.2),(127494,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127494,37.87,0.46,376,58249,70,NULL,NULL,'2MASX J15113399+1847377',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,227.891667,18.79367,0.077,NULL,59580498801,930945293,14546020,17.9),(127495,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127495,37.81,0.16,365,58250,70,NULL,NULL,'SDSS J151134.08+180758.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.8920417,18.13297,0.057,NULL,59580422883,930944107,14546001,18.1),(127496,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127496,36.91,0.33,241,58251,70,NULL,NULL,'2MASX J15113421+2004177',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,227.892667,20.07158,0.053,NULL,59537878609,930279353,14535614,NULL),(127497,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127497,37.65,0.06,339,58252,70,NULL,NULL,'2MASX J15113437+0612038',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,227.893125,6.20111,0.061,NULL,59383591783,927868621,14497947,16.6),(127498,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127498,37.47,0.27,311,58253,70,NULL,NULL,'2MASX J15113489+1914297',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,227.895417,19.2415,0.093,NULL,59534648047,930228875,14534826,18.1),(127499,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127499,36.14,0.11,169,58254,70,NULL,NULL,'2MASX J15113491+0425349',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000068,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.895583333,4.42639,0.081,NULL,59330839169,927044362,14485068,17.4),(127500,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127500,37.65,0.06,339,58255,70,NULL,NULL,'2MASX J15113530+0621018',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.897083,6.35056,0.061,NULL,59383567037,927868234,14497941,18),(127501,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127501,37.65,0.06,339,58256,70,NULL,NULL,'2MASX J15113537+0615098',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,227.89725,6.25269,0.061,NULL,59383589308,927868582,14497946,17.8),(127502,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127502,37.47,0.27,311,58257,70,NULL,NULL,'IC 1103',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.00016,NULL,'16.73',0.56,'BrClG',NULL,NULL,NULL,NULL,1,227.8994583,19.20778,0.089,NULL,59534648193,930228878,14534826,16.73),(127503,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127503,38.03,0.12,403,58258,70,NULL,NULL,'2MASX J15113607-0007167',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000074,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,227.9002083,-0.12131,0.137,NULL,45375035791,708984934,11077889,18.2),(127504,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127504,37.77,0.46,359,58259,70,NULL,NULL,'2MASX J15113613+0748388',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000178,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.9005417,7.81097,0.049,NULL,59384572402,927883943,14498186,17.5),(127505,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127505,35.95,0.25,155,58260,74.4,NULL,NULL,'CGCG 049-034',NULL,'2013AJ....146...86T',2013,1,0.53,NULL,'G',0.000073,NULL,'15.6g',0.46,'E','Group member',NULL,NULL,NULL,1,227.904125,4.46725,0.081,NULL,59330841531,927044398,14485068,15.6),(127506,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127506,36.14,0.11,169,58260,70,NULL,NULL,'CGCG 049-034',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127507,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127507,36.18,0.26,172,58260,70,NULL,NULL,'CGCG 049-034',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127508,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127508,37.77,0.46,358,58261,70,NULL,NULL,'2MASX J15113731+5634467',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000081,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.9057083,56.57947,0.009,NULL,57714860223,901794690,14090542,17.4),(127509,'IRAS','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127509,36.07,0.8,164,58262,75,NULL,'CF, r','UGC 09757',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.00003,NULL,'14.61',0.6,'Sbc',NULL,NULL,NULL,NULL,1,227.905625,5.39758,0.081,NULL,59329223887,927019123,14484673,14.61),(127510,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127510,35.72,0.38,139,58262,75,NULL,'CF, r, raw','UGC 09757',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127511,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127511,35.97,0.38,156,58262,75,NULL,'CF, r, inv','UGC 09757',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127512,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127512,35.99,0.38,158,58262,75,NULL,'CF, r, cor','UGC 09757',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127513,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127513,36.29,0.4,181,58262,NULL,NULL,'mean','UGC 09757',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127514,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127514,36.29,0.47,181,58262,NULL,NULL,'H','UGC 09757',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127515,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127515,36.41,0.46,191,58262,NULL,NULL,'J','UGC 09757',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127516,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127516,36.41,0.45,192,58262,NULL,NULL,'K','UGC 09757',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127517,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127517,37.84,0.27,369,58263,70,NULL,NULL,'SDSS J151137.59+200847.2',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.906625,20.14644,0.049,NULL,59537882323,930279411,14535615,18.5),(127518,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127518,38.15,0.46,426,58264,70,NULL,NULL,'2MASX J15113908+1809367',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,227.912875,18.16033,0.057,NULL,59580424140,930944127,14546001,17.9),(127519,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127519,38.03,0.12,403,58265,70,NULL,NULL,'2MASX J15114001-0008467',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000067,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.91675,-0.14631,0.137,NULL,45375033870,708984904,11077889,17.9),(127520,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127520,37.65,0.46,339,58266,70,NULL,NULL,'2MASX J15114054+0343419',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000073,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.918917,3.72819,0.101,NULL,56381778065,880965282,13765082,17.7),(127521,'IRAS','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127521,32.95,0.8,38.9,58267,75,NULL,'A82, H','NGC 5894',NULL,'1997ApJS..109..333W',1997,1,3.57,NULL,'G',0.000013,NULL,'13.1g',0.59,'SBdm?','Field galaxy',NULL,NULL,NULL,1,227.92075,59.80894,0.013,NULL,57774782955,902730983,14105171,13.1),(127522,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127522,32.57,0.4,32.6,58267,75,NULL,NULL,'NGC 5894',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127523,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127523,32.72,0.49,34.9,58267,75,NULL,'IR','NGC 5894',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127524,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127524,32.92,0.4,38.3,58267,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5894',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127525,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127525,32.95,0.36,38.9,58267,NULL,NULL,NULL,'NGC 5894',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127526,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127526,32.95,0.4,38.9,58267,75,NULL,'B','NGC 5894',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127527,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127527,32.98,0.2,39.5,58267,74.4,NULL,NULL,'NGC 5894',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127528,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127528,33.1,0.43,41.7,58267,75,NULL,'3.6 micron, color corrected','NGC 5894',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127529,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127529,33.2,0.47,43.7,58267,75,NULL,'A82, H, raw','NGC 5894',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127530,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127530,33.23,0.43,44.3,58267,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5894',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127531,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127531,33.36,0.47,46.9,58267,75,NULL,'A82, H, cor','NGC 5894',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127532,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127532,33.38,0.47,47.5,58267,75,NULL,'A82, H, inv','NGC 5894',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127533,'Tully est','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127533,32.8,0.8,36.3,58268,75,NULL,NULL,'UGC 09762',NULL,'1988NBGC.C....0000T',1988,1,1,'Multiple SDSS entries describe this source.','G',0.00002,NULL,'17.',0.9,'Sm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,227.922083,32.64306,0.045,NULL,60083720960,938808140,14668877,17),(127534,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127534,35.96,0.25,156,58269,74.4,NULL,NULL,'CGCG 049-037',NULL,'2013AJ....146...86T',2013,1,0.85,NULL,'G',0.000073,NULL,'13.93',0.72,'cD','Group member',NULL,NULL,NULL,1,227.923,4.49128,0.085,NULL,59330851897,927044560,14485071,13.93),(127535,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127535,36.18,0.26,172,58269,70,NULL,NULL,'CGCG 049-037',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127536,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127536,37.84,0.46,369,58270,70,NULL,NULL,'2MASX J15114160+4030388',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000167,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.923333,40.51092,0.025,NULL,59973888471,937092007,14642062,18),(127537,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127537,37.65,0.06,339,58271,70,NULL,NULL,'2MASX J15114308+0617528',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,227.9295,6.29794,0.061,NULL,59383598500,927868726,14497948,17.1),(127538,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127538,37.65,0.06,339,58272,70,NULL,NULL,'2MASX J15114356+0610448',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',NULL,NULL,'15.8g',0.38,NULL,NULL,NULL,NULL,NULL,1,227.9315,6.17925,0.061,NULL,59383584434,927868506,14497945,15.8),(127539,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127539,37.9,0.46,380,58273,70,NULL,NULL,'2MASX J15114398+1145538',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.933416667,11.76492,0.117,NULL,59348128070,927314501,14489289,17.6),(127540,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127540,37.68,0.46,344,58274,70,NULL,NULL,'SDSS J151144.60+334948.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.935833,33.83022,0.013,NULL,60116759865,939324372,14676943,17.8),(127541,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127541,38.21,0.46,439,58275,70,NULL,NULL,'2MASX J15114526+0109309',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000095,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,227.938625,1.15844,0.109,NULL,56386928838,881045763,13766340,17.5),(127542,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127542,38.2,0.19,436,58276,70,NULL,NULL,'SDSS J151145.86+173223.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.941125,17.53981,0.041,NULL,59583732233,930995816,14546809,18),(127543,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127543,37.75,0.46,355,58277,70,NULL,NULL,'SDSS J151146.15+065458.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.9g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.9422917,6.91631,0.049,NULL,59383288468,927863882,14497873,17.9),(127544,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127544,38.53,0.46,507,58278,70,NULL,NULL,'2MASX J15114614+0026499',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000082,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.942333,0.44725,0.113,NULL,56386373271,881037082,13766204,18),(127545,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127545,37.71,0.33,349,58279,70,NULL,NULL,'2MASX J15114722+0421509',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000095,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,227.946833,4.36411,0.081,NULL,59330832939,927044264,14485066,17.5),(127546,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127546,37.49,0.46,315,58280,70,NULL,NULL,'2MASX J15114852-0157017',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.952125,-1.95042,0.217,NULL,45381436064,709084938,11079452,17.9),(127547,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127547,32.82,NULL,36.6,58281,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 581- G 023',NULL,'2010Ap&SS.325..163P',2010,1,1.57,NULL,'G',0.000017,NULL,'16.88',0.11,'SB(s)d pec sp',NULL,NULL,NULL,NULL,1,227.9574583,-17.94392,0.377,NULL,46699723317,729683176,11401299,16.88),(127548,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127548,32.84,NULL,36.9,58281,NULL,NULL,'Dipole + Quadrupole','ESO 581- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127549,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127549,32.85,NULL,37.2,58281,NULL,NULL,'Dipole','ESO 581- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127550,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127550,33.22,0.65,44.1,58281,NULL,NULL,'Malmquist cor.','ESO 581- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127551,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127551,33.52,0.57,50.5,58281,NULL,NULL,NULL,'ESO 581- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127552,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127552,33.56,0.2,51.5,58281,74.4,NULL,NULL,'ESO 581- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127553,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127553,37.21,0.46,277,58282,70,NULL,NULL,'SDSS J151150.66+343724.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000168,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,227.961125,34.62347,0.033,NULL,60114473913,939288654,14676385,18),(127554,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127554,38.13,0.46,423,58283,70,NULL,NULL,'SDSS J151151.39+172918.9',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.964125,17.48858,0.041,NULL,59583738155,930995908,14546811,17.5),(127555,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127555,38.03,0.12,403,58284,70,NULL,NULL,'SDSS J151151.51-000634.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000063,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,227.964666667,-0.10944,0.137,NULL,45375034514,708984914,11077889,18.3),(127556,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127556,36.52,0.09,202,58285,70,NULL,NULL,'2MASX J15115182+0742450',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000113,NULL,'16.0g',0.32,'S0','Group member',NULL,NULL,NULL,1,227.966,7.71242,0.053,NULL,59384566270,927883847,14498185,16),(127557,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127557,37.65,0.06,339,58286,70,NULL,NULL,'2MASX J15115230+0601469',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000163,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.967791667,6.02986,0.065,NULL,59328886382,927013849,14484591,17),(127558,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127558,38.2,0.19,436,58287,70,NULL,NULL,'2MASX J15115295+1732051',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.970583333,17.53483,0.041,NULL,59583741316,930995958,14546811,18.2),(127559,'IRAS','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127559,32.81,0.8,36.5,58288,75,NULL,'MAT, I','NGC 5833',NULL,'1997ApJS..109..333W',1997,1,3.1,'Confused and extended HIPASS source','G',0.000017,NULL,'12.82',2.3,'SAB(r)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,227.9735417,-72.85942,0.421,NULL,44997254941,703082108,10985657,12.82),(127560,'Sosies','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127560,32.62,0.15,33.4,58288,NULL,NULL,NULL,'NGC 5833',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127561,'Tully est','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127561,32.9,0.8,38,58288,75,NULL,NULL,'NGC 5833',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127562,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127562,32.4,0.43,30.2,58288,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5833',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127563,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127563,32.46,0.43,31.1,58288,75,NULL,'3.6 micron, color corrected','NGC 5833',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127564,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127564,32.61,0.47,33.3,58288,NULL,NULL,'H','NGC 5833',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127565,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127565,32.62,0.45,33.4,58288,NULL,NULL,'K','NGC 5833',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127566,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127566,32.62,0.46,33.5,58288,NULL,NULL,'J','NGC 5833',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127567,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127567,32.78,0.43,35.9,58288,75,NULL,'MAT, I, raw','NGC 5833',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127568,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127568,32.78,0.2,36,58288,74.4,NULL,NULL,'NGC 5833',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127569,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127569,32.88,0.32,37.7,58288,85,NULL,'I, raw','NGC 5833',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127570,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127570,32.96,0.32,39,58288,85,NULL,'I, inv','NGC 5833',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127571,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127571,32.99,0.43,39.6,58288,75,NULL,'MAT, I, cor','NGC 5833',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127572,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127572,32.99,0.4,39.7,58288,NULL,NULL,'mean','NGC 5833',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127573,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127573,33.08,0.43,41.3,58288,75,NULL,'MAT, I, inv','NGC 5833',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127574,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127574,33.18,0.36,43.3,58288,NULL,NULL,'Malmquist cor.','NGC 5833',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127575,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127575,33.35,0.33,46.7,58288,NULL,NULL,NULL,'NGC 5833',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127576,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127576,37.22,0.46,279,58289,70,NULL,NULL,'2MASX J15115467+2706380',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.9777083,27.11061,0.089,NULL,59897430413,935897350,14623396,17.9),(127577,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127577,37.01,0.46,253,58290,70,NULL,NULL,'2MASX J15115468+3036281',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000166,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.978,30.60792,0.037,NULL,60085879787,938841871,14669404,17.8),(127578,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127578,37.84,0.27,369,58291,70,NULL,NULL,'SDSS J151155.17+200528.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.979917,20.09131,0.049,NULL,59537847213,930278862,14535607,18.2),(127579,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127579,37.46,0.46,311,58292,70,NULL,NULL,'2MASX J15115519+0538171',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'15.9g',0.44,NULL,NULL,NULL,NULL,NULL,1,227.98,5.63817,0.077,NULL,59329264161,927019752,14484683,15.9),(127580,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127580,37.51,0.46,318,58293,70,NULL,NULL,'SDSS J151157.11+233959.7',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.8g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.988,23.66658,0.137,NULL,59411303165,928301611,14504712,17.8),(127581,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127581,37.72,0.27,351,58294,70,NULL,NULL,'2MASX J15115759+0407431',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.989833333,4.12853,0.077,NULL,56381508527,880961070,13765016,17.6),(127582,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127582,37.72,0.27,351,58295,70,NULL,NULL,'2MASX J15115833+0410531',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.992958333,4.18125,0.077,NULL,56381637054,880963078,13765048,17.4),(127583,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127583,36.54,0.66,203,58296,70,NULL,NULL,'2MASX J15115838-0711276',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,227.99325,-7.19106,0.237,NULL,46494545158,726477268,11351207,14.5),(127584,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127584,37.71,0.33,349,58297,70,NULL,NULL,'2MASX J15115872+0415301',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000086,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,227.9947917,4.25833,0.081,NULL,59330825887,927044154,14485064,16.5),(127585,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127585,37.14,0.46,268,58298,70,NULL,NULL,'2MASX J15115954+0358361',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000066,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.998125,3.97656,0.053,NULL,56381493547,880960836,13765013,17.5),(127586,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127586,37.27,0.46,284,58299,70,NULL,NULL,'2MASX J15120015+2150580',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.92',0.17,NULL,NULL,NULL,NULL,NULL,1,228.00075,21.84956,0.153,NULL,59414638126,928353720,14505526,17.92),(127587,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127587,36.45,0.46,195,58300,70,NULL,NULL,'MCG +06-33-027',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000191,NULL,'15.1g',0.62,'E',NULL,NULL,NULL,NULL,1,228.00075,36.65197,0.033,NULL,60108625327,939197270,14674957,15.1),(127588,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127588,37.72,0.27,351,58301,70,NULL,NULL,'2MASX J15120034+0403131',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000083,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.0015,4.05358,0.077,NULL,56381517533,880961211,13765018,17.1),(127589,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127589,37.65,0.06,339,58302,70,NULL,NULL,'2MASX J15120047+0603381',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,228.001917,6.06064,0.065,NULL,59328884104,927013814,14484590,17.2),(127590,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127590,36.52,0.09,202,58303,70,NULL,NULL,'2MASX J15120111+0723221',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000107,NULL,'16.9g',0.21,'E','Group member',NULL,NULL,NULL,1,228.004583,7.38956,0.057,NULL,59386673671,927916776,14498699,16.9),(127591,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127591,34.69,0.2,86.7,58304,74.4,NULL,NULL,'UGC 09763',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.00002,NULL,'15.16',0.4,'S?',NULL,NULL,NULL,NULL,1,228.009083,21.29836,0.121,NULL,59415345011,928364765,14505699,15.16),(127592,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127592,34.67,0.49,85.7,58305,75,NULL,'IR','UGC 09763',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.00002,NULL,'15.16',0.4,'S?',NULL,NULL,NULL,NULL,1,228.009083,21.29836,0.121,NULL,59415345011,928364765,14505699,15.16),(127593,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127593,31.25,NULL,17.8,58306,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09760',NULL,'2010Ap&SS.325..163P',2010,1,3.25,'Star superposed.','G',0.000006,NULL,'14.67',0.22,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,228.010167,1.69875,0.101,NULL,56387292484,881051445,13766428,14.67),(127594,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127594,31.27,NULL,18,58306,NULL,NULL,'Dipole + Quadrupole','UGC 09760',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127595,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127595,31.28,NULL,18,58306,NULL,NULL,'Dipole','UGC 09760',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127596,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127596,31.37,NULL,18.8,58306,NULL,NULL,NULL,'UGC 09760',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127597,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127597,31.75,NULL,22.4,58306,72,NULL,NULL,'UGC 09760',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127598,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127598,32.11,0.2,26.4,58306,74.4,NULL,NULL,'UGC 09760',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127599,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127599,32.17,0.43,27.1,58306,75,NULL,'3.6 micron, color corrected','UGC 09760',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127600,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127600,32.21,0.43,27.7,58306,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09760',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127601,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127601,32.27,0.4,28.5,58306,75,NULL,'B','UGC 09760',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127602,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127602,32.34,0.4,29.4,58306,NULL,NULL,NULL,'UGC 09760',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127603,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127603,32.42,0.57,30.5,58306,NULL,NULL,'Malmquist cor.','UGC 09760',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127604,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127604,32.44,0.57,30.8,58306,NULL,NULL,NULL,'UGC 09760',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127605,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127605,36.34,0.49,185,58307,NULL,NULL,'Malmquist cor.','SDSS J151202.58+065553.9',NULL,'2009ApJS..182..474S',2009,1,0.41,NULL,'G',0.00003,NULL,'16.01',NULL,'Sb','Group member',NULL,NULL,NULL,1,228.010791667,6.93164,0.049,NULL,59383341453,927864710,14497886,16.01),(127606,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127606,36.75,0.4,224,58307,NULL,NULL,NULL,'SDSS J151202.58+065553.9',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127607,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127607,36.8,0.2,229,58307,74.4,NULL,NULL,'SDSS J151202.58+065553.9',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127608,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127608,37.8,0.33,363,58308,70,NULL,NULL,'2MASX J15120335+1255322',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,228.014125,12.92569,0.097,NULL,59569367144,930771361,14543302,17.6),(127609,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127609,37.65,0.06,339,58309,70,NULL,NULL,'2MASX J15120409+0551321',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,228.016958333,5.85911,0.073,NULL,59328871211,927013612,14484587,16.8),(127610,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127610,35.95,0.46,155,58310,70,NULL,NULL,'CGCG 165-028',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'15.7',0.3,NULL,NULL,NULL,NULL,NULL,1,228.017166667,28.42058,0.037,NULL,59908401633,936068775,14626074,15.7),(127611,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127611,37.65,0.06,339,58311,70,NULL,NULL,'2MASX J15120449+0602491',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.01875,6.04694,0.065,NULL,59328883690,927013807,14484590,17.7),(127612,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127612,38.01,0.33,400,58312,70,NULL,NULL,'SDSS J151204.51+030713.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000069,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.018833,3.12053,0.093,NULL,56381282088,880957532,13764961,18.4),(127613,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127613,33.84,0.4,58.5,58313,NULL,NULL,'mean','IC 1110',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000047,NULL,'14.90',0.4,'Sa','Isolated galaxy',NULL,NULL,NULL,1,228.021125,67.36258,0.037,NULL,57980259388,905941552,14155336,14.9),(127614,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127614,34.16,0.45,67.9,58313,NULL,NULL,'K','IC 1110',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127615,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127615,34.17,0.47,68.1,58313,NULL,NULL,'H','IC 1110',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127616,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127616,34.27,0.46,71.4,58313,NULL,NULL,'J','IC 1110',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127617,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127617,37.69,0.27,345,58314,70,NULL,NULL,'2MASX J15120558+3050232',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000166,NULL,'16.0g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,228.023208333,30.83986,0.021,NULL,60086973657,938858963,14669671,16),(127618,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127618,37.79,0.46,361,58315,70,NULL,NULL,'SDSS J151206.33+085522.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000134,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.026417,8.92289,0.049,NULL,59351663986,927369749,14490152,18.5),(127619,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127619,31.24,0.4,17.7,58316,75,NULL,'B','NGC 5866B',NULL,'1988NBGC.C....0000T',1988,1,1.46,NULL,'G',0.000013,NULL,'14.7g',0.82,'SAB(rs)dm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,228.030125,55.78508,0.013,NULL,57583004196,899734440,14058350,14.7),(127620,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127620,37.8,0.33,363,58317,70,NULL,NULL,'2MASX J15120745+1253482',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,228.0310417,12.89678,0.097,NULL,59569370074,930771407,14543303,NULL),(127621,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127621,36.81,0.62,230,58318,70,NULL,NULL,'2MASX J15120791-7022508',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,228.033125,-70.38081,0.209,NULL,45045236458,703831819,10997372,15.5),(127622,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127622,37.32,0.46,291,58319,70,NULL,NULL,'2MASX J15120882+1912251',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,228.0367083,19.20686,0.093,NULL,59534641221,930228769,14534824,16.7),(127623,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127623,36.21,0.13,174,58320,70,NULL,NULL,'2MASX J15120987+0155211',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000085,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,228.041208333,1.92258,0.081,NULL,56387340492,881052195,13766440,16.3),(127624,'GRB','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127624,42.68,NULL,3440,58321,71,NULL,NULL,'GRB 080906',NULL,'2011A&A...526A.153K',2011,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,228.045167,-80.51808,0.441,NULL,44278821668,691856588,10810259,NULL),(127625,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127625,38.01,0.46,400,58322,70,NULL,NULL,'2MASX J15121107+0526201',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,228.046125,5.43883,0.077,NULL,59329243247,927019425,14484678,NULL),(127626,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127626,36.13,0.47,168,58323,NULL,NULL,'Malmquist cor.','2MFGC 12301',NULL,'2009ApJS..182..474S',2009,1,0.74,NULL,'G',0.000027,NULL,'16.5g',0.15,'Sb','Group member',NULL,NULL,NULL,1,228.046875,7.56431,0.053,NULL,59386687624,927916994,14498703,16.5),(127627,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127627,36.39,0.42,189,58323,NULL,NULL,NULL,'2MFGC 12301',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127628,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127628,36.43,0.2,193,58323,74.4,NULL,NULL,'2MFGC 12301',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127629,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127629,36.59,0.49,208,58323,75,NULL,'IR','2MFGC 12301',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127630,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127630,36.21,0.13,174,58324,70,NULL,NULL,'CGCG 021-043',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000077,NULL,'16.0g',0.37,'S0','Group member',NULL,NULL,NULL,1,228.047875,2.01019,0.081,NULL,56387343629,881052244,13766441,16),(127631,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127631,36.52,0.09,202,58325,70,NULL,NULL,'2MASX J15121153+0714141',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000097,NULL,'16.6g',0.24,'S0/S','Group member',NULL,NULL,NULL,1,228.048083,7.23725,0.049,NULL,59383449301,927866395,14497912,16.6),(127632,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127632,38.2,0.19,436,58326,70,NULL,NULL,'2MASX J15121225+1733091',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.7g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,228.050958333,17.55256,0.041,NULL,59583729649,930995775,14546808,16.7),(127633,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127633,38.63,0.46,532,58327,70,NULL,NULL,'2MASX J15121258+4554114',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000172,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,228.052541667,45.90317,0.033,NULL,59986816916,937294014,14645218,17.9),(127634,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127634,37.84,0.27,369,58328,70,NULL,NULL,'2MASX J15121328+2010401',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,228.0555,20.17792,0.049,NULL,59537662380,930275974,14535562,NULL),(127635,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127635,37.63,0.33,335,58329,70,NULL,NULL,'2MASX J15121439+2749102',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'18.02',0.17,NULL,NULL,NULL,NULL,NULL,1,228.06,27.81961,0.081,NULL,59897360829,935896262,14623379,18.02),(127636,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127636,37.23,0.46,279,58330,70,NULL,NULL,'2MASX J15121488+6046124',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.061916667,60.77017,0.013,NULL,57773908199,902717315,14104958,17.1),(127637,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127637,38.28,0.46,452,58331,70,NULL,NULL,'2MASX J15121511+4758495',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,228.063041667,47.98061,0.041,NULL,59940239372,936566240,14633847,18.4),(127638,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127638,38.06,0.46,409,58332,70,NULL,NULL,'SDSS J151215.44+100945.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,228.064333,10.1625,0.081,NULL,59354238143,927409970,14490780,18.2),(127639,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127639,37.21,0.46,277,58333,70,NULL,NULL,'2MASX J15121549+0502511',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,228.064375,5.0475,0.097,NULL,59329169545,927018274,14484660,17.2),(127640,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127640,37.63,0.33,335,58334,70,NULL,NULL,'2MASX J15121575+2750052',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.69',0.16,NULL,NULL,NULL,NULL,NULL,1,228.065667,27.83486,0.081,NULL,59897360668,935896260,14623379,18.69),(127641,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127641,37.72,0.46,350,58335,70,NULL,NULL,'SDSS J151216.54+390526.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.0689583,39.09061,0.057,NULL,60104288515,939129508,14673898,17.9),(127642,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127642,35.67,0.33,136,58336,70,NULL,NULL,'2MASX J15121720+4025507',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000179,NULL,'15.5g',0.58,'E0',NULL,NULL,NULL,NULL,1,228.071583,40.43072,0.041,NULL,59971741972,937058468,14641538,15.5),(127643,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127643,37.75,0.46,355,58337,70,NULL,NULL,'2MASX J15121756+2939262',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00013,NULL,'17.76',0.19,'E',NULL,NULL,NULL,NULL,1,228.0732917,29.65719,0.033,NULL,59904237112,936003704,14625057,17.76),(127644,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127644,36.21,0.13,174,58338,70,NULL,NULL,'CGCG 021-045',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000103,NULL,'15.7g',0.49,'S0','Group member',NULL,NULL,NULL,1,228.074917,2.03253,0.081,NULL,56387345190,881052268,13766441,15.7),(127645,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127645,38.45,0.46,490,58339,70,NULL,NULL,'2MASX J15121820+2959199',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.075875,29.98903,0.029,NULL,60086420505,938850320,14669536,18),(127646,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127646,37.34,0.46,294,58340,70,NULL,NULL,'2MASX J15121865+2033362',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.51',0.14,NULL,NULL,NULL,NULL,NULL,1,228.07775,20.55997,0.101,NULL,59535576636,930243384,14535052,18.51),(127647,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127647,37.65,0.06,339,58341,70,NULL,NULL,'SDSS J151218.76+054856.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.0782083,5.81578,0.073,NULL,59329378183,927021534,14484711,17.8),(127648,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127648,36.42,0.46,192,58342,70,NULL,NULL,'2MASX J15121970+1042570',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,228.0822083,10.71594,0.081,NULL,59346523927,927289436,14488897,16.7),(127649,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127649,37.71,0.46,348,58343,70,NULL,NULL,'2MASX J15121990+0731202',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000177,NULL,'17.7g',0.17,NULL,'Group member',NULL,NULL,NULL,1,228.082875,7.52228,0.053,NULL,59386683079,927916923,14498701,17.7),(127650,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127650,36.43,0.46,193,58344,70,NULL,NULL,'2MASX J15122049+0904532',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000166,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,228.085333,9.08139,0.049,NULL,59351684740,927370074,14490157,16.5),(127651,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127651,36.21,0.13,174,58345,70,NULL,NULL,'2MASX J15122061+0147021',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00009,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,228.0859583,1.78403,0.101,NULL,56387272673,881051135,13766423,16.4),(127652,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127652,37.71,0.33,348,58346,70,NULL,NULL,'SDSS J151221.71+182834.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.0905,18.47617,0.073,NULL,59580517311,930945582,14546024,18.2),(127653,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127653,35.96,0.46,156,58347,70,NULL,NULL,'2MASX J15122206+0323481',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000133,NULL,'15.3g',0.5,'BrClG',NULL,NULL,NULL,NULL,1,228.091917,3.39681,0.101,NULL,56381820294,880965942,13765092,15.3),(127654,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127654,36.65,0.46,214,58348,70,NULL,NULL,'2MASX J15122240+0313021',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000071,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,228.093333,3.21719,0.097,NULL,56381340240,880958441,13764975,17.2),(127655,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127655,37.41,0.46,304,58349,70,NULL,NULL,'2MASX J15122259+2006462',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,228.094167,20.11286,0.101,NULL,59537663031,930275984,14535562,NULL),(127656,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127656,38.03,0.12,403,58350,70,NULL,NULL,'2MASX J15122434-0028403',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00009,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.1015,-0.47806,0.129,NULL,45379372324,709052692,11078948,17.7),(127657,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127657,38.21,0.46,439,58351,70,NULL,NULL,'2MASXi J1512246+384600',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,228.1025417,38.76681,0.053,NULL,60103493281,939117082,14673704,17.8),(127658,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127658,36.2,0.19,174,58352,70,NULL,NULL,'2MASX J15122500+0431051',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000108,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,228.104167,4.51806,0.085,NULL,59330805379,927043834,14485059,16.4),(127659,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127659,38.35,0.46,467,58353,70,NULL,NULL,'SDSS J151225.32+301356.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.1055417,30.23233,0.033,NULL,60085958689,938843104,14669423,18.5),(127660,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127660,35.67,0.33,136,58354,70,NULL,NULL,'CGCG 221-035',NULL,'2015arXiv151105856S',2015,1,0.82,'UZC gives v = 9490 +/- 100 km/sec.','G',0.000187,NULL,'14.6g',0.63,'S?',NULL,NULL,NULL,NULL,1,228.106375,40.55247,0.025,NULL,59971771799,937058934,14641545,14.6),(127661,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127661,37.37,0.46,298,58355,70,NULL,NULL,'SDSS J151226.79+391937.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,228.111667,39.32703,0.049,NULL,60104270214,939129222,14673894,18.3),(127662,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127662,36.81,0.2,230,58356,74.4,NULL,NULL,'UGC 09765',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000033,NULL,'16.64',0.6,'Sab            AGN',NULL,NULL,NULL,NULL,1,228.114625,20.65181,0.109,NULL,59535547514,930242929,14535045,16.64),(127663,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127663,36.52,0.09,202,58357,70,NULL,NULL,'2MASX J15122757+0730453',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00012,NULL,'17.0g',0.22,'S0','Group member',NULL,NULL,NULL,1,228.114917,7.51261,0.053,NULL,59386679686,927916870,14498701,17),(127664,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127664,31.15,0.48,17,58358,NULL,NULL,NULL,'ESO 328- G 030',NULL,'2009ApJS..182..474S',2009,1,1.6,NULL,'G',0.000027,NULL,'13.10',0.8,'SAB:',NULL,NULL,NULL,NULL,1,228.116541667,-42.63236,0.465,NULL,47066346274,735411660,11490807,13.1),(127665,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127665,31.19,0.2,17.3,58358,74.4,NULL,NULL,'ESO 328- G 030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127666,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127666,31.39,0.4,19,58358,73,NULL,'opt','ESO 328- G 030',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127667,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127667,31.48,0.41,19.8,58358,NULL,NULL,'Malmquist cor.','ESO 328- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127668,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127668,36.82,0.27,231,58359,70,NULL,NULL,'GIN 417',NULL,'2001MNRAS.321..277C',2001,1,0.61,NULL,'G',0.00023,NULL,'14.88',0.46,'S0/E','Group member',NULL,NULL,NULL,1,228.11725,7.97389,0.041,NULL,59351808405,927372006,14490187,14.88),(127669,'IRAS','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127669,34.06,0.8,65,58360,75,NULL,'MAT, I','ESO 328- G 031',NULL,'1997ApJS..109..333W',1997,1,1.57,NULL,'G',0.000033,NULL,'15.15',0.1,'Sc',NULL,NULL,NULL,NULL,1,228.1174583,-42.01781,0.353,NULL,47067578301,735430910,11491107,15.15),(127670,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127670,32.53,0.32,32.1,58360,85,NULL,'I, inv','ESO 328- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127671,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127671,32.58,0.32,32.8,58360,85,NULL,'I, raw','ESO 328- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127672,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127672,32.98,0.43,39.5,58360,75,NULL,'MAT, I, inv','ESO 328- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127673,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127673,33.1,0.43,41.7,58360,75,NULL,'MAT, I, raw','ESO 328- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127674,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127674,33.2,NULL,43.7,58360,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 328- G 031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127675,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127675,33.21,NULL,43.8,58360,NULL,NULL,'Dipole','ESO 328- G 031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127676,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127676,33.21,NULL,43.9,58360,NULL,NULL,'Dipole + Quadrupole','ESO 328- G 031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127677,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127677,33.37,NULL,47.3,58360,NULL,NULL,NULL,'ESO 328- G 031',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127678,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127678,33.57,0.43,51.9,58360,75,NULL,'MAT, I, cor','ESO 328- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127679,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127679,37.27,0.46,285,58361,70,NULL,NULL,'2MASX J15122821+2526182',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,228.117541667,25.43847,0.177,NULL,59896349210,935880456,14623132,17.2),(127680,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127680,37.56,0.46,325,58362,70,NULL,NULL,'2MASX J15122872-0217593',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000135,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.11975,-2.29967,0.233,NULL,45381715979,709089312,11079520,18.2),(127681,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127681,36.5,0.46,200,58363,70,NULL,NULL,'2MASX J15122919+0133212',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000086,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,228.121583,1.55589,0.101,NULL,56387254159,881050846,13766419,16.9),(127682,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127682,38.03,0.12,403,58364,70,NULL,NULL,'SDSS J151229.93-002127.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000082,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,228.1247083,-0.35756,0.137,NULL,45375262574,708988477,11077944,18.3),(127683,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127683,38.18,0.46,433,58365,70,NULL,NULL,'SDSS J151230.31+141935.2',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.1262917,14.32644,0.093,NULL,59571998036,930812469,14543944,17.2),(127684,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127684,36.61,0.33,210,58366,70,NULL,NULL,'2MASX J15123061+2039581',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.2,'AGN',NULL,NULL,NULL,NULL,1,228.1277083,20.66608,0.109,NULL,59535547126,930242923,14535045,17.4),(127685,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127685,37.43,0.27,307,58367,70,NULL,NULL,'2MASX J15123065+0749273',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,228.12775,7.82422,0.049,NULL,59384536731,927883386,14498177,17.3),(127686,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127686,36.94,0.46,244,58368,70,NULL,NULL,'2MASX J15123105+1507545',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,228.129333333,15.13181,0.077,NULL,59572683392,930823178,14544112,16.2),(127687,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127687,37.48,0.46,313,58369,70,NULL,NULL,'2MASX J15123342+1709235',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.139333333,17.15656,0.057,NULL,59582452663,930975822,14546497,17.1),(127688,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127688,37.67,0.46,342,58370,70,NULL,NULL,'2MASX J15123349+3218501',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,228.1395,32.31392,0.017,NULL,60083901518,938810961,14668921,17.5),(127689,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127689,35.15,0.33,107,58371,70,NULL,NULL,'2MASX J15123368+0304252',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000085,NULL,'15.8g',0.27,'S0',NULL,NULL,NULL,NULL,1,228.1402917,3.07364,0.053,NULL,56381306088,880957907,13764967,15.8),(127690,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127690,37.24,0.46,281,58372,70,NULL,NULL,'2MASX J15123399+4848065',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00018,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,228.141833333,48.80194,0.017,NULL,59940749016,936574203,14633971,16.7),(127691,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127691,36.52,0.09,202,58373,70,NULL,NULL,'CGCG 049-042',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000113,NULL,'15.3g',0.36,'S0','Group member',NULL,NULL,NULL,1,228.1427083,7.76172,0.049,NULL,59384544735,927883511,14498179,15.3),(127692,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127692,36.52,0.09,202,58374,70,NULL,NULL,'GIN 413',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00007,NULL,'15.9g',0.37,'Ep','Group member',NULL,NULL,NULL,1,228.143041667,7.43153,0.053,NULL,59383246205,927863221,14497862,15.9),(127693,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127693,36.58,0.25,207,58374,74.4,NULL,NULL,'GIN 413',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127694,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127694,36.82,0.27,231,58374,70,NULL,NULL,'GIN 413',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127695,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127695,37.77,0.46,358,58375,70,NULL,NULL,'SDSS J151234.30+012512.4',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.26,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.142958333,1.42014,0.101,NULL,56386927564,881045743,13766339,17),(127696,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127696,36.52,0.09,202,58376,70,NULL,NULL,'2MASX J15123510+0729343',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'15.82',0.28,'S0','Group member',NULL,NULL,NULL,1,228.146166667,7.49278,0.053,NULL,59383222313,927862848,14497857,15.82),(127697,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127697,38.16,0.46,428,58377,70,NULL,NULL,'2MASX J15123518+2508022',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,228.146541667,25.13389,0.165,NULL,59410671196,928291737,14504558,18),(127698,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127698,36.06,0.46,163,58378,70,NULL,NULL,'2MASX J15123519+5523218',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000169,NULL,'15.9g',0.37,'S0',NULL,NULL,NULL,NULL,1,228.146833,55.38947,0.013,NULL,57583358368,899739974,14058437,15.9),(127699,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127699,37.62,0.46,334,58379,70,NULL,NULL,'2MASX J15123658+1938171',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.152375,19.63822,0.097,NULL,59534336993,930224015,14534750,17),(127700,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127700,37.31,0.46,289,58380,70,NULL,NULL,'2MASX J15123684+3051111',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.153417,30.853,0.021,NULL,60086960552,938858758,14669668,17.8),(127701,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127701,37.83,0.46,369,58381,70,NULL,NULL,'2MASX J15123713+3108161',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000141,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.154667,31.13797,0.009,NULL,60087071138,938860486,14669695,17.3),(127702,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127702,38.2,0.19,436,58382,70,NULL,NULL,'2MASX J15123746+1742215',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,228.156125,17.70589,0.033,NULL,59580775209,930949612,14546087,17.7),(127703,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127703,36.82,0.27,231,58383,70,NULL,NULL,'GIN 412',NULL,'2001MNRAS.321..277C',2001,1,0.32,NULL,'G',0.000077,NULL,'15.63',0.25,'S0','Group member',NULL,NULL,NULL,1,228.156583333,7.45181,0.053,NULL,59383243367,927863177,14497862,15.63),(127704,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127704,37.9,0.46,380,58383,70,NULL,NULL,'GIN 412',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127705,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127705,36.52,0.09,202,58384,70,NULL,NULL,'2MASX J15123773+0706513',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000147,NULL,'15.9g',0.38,'E','Group member',NULL,NULL,NULL,1,228.157083,7.11436,0.049,NULL,59383468890,927866701,14497917,15.9),(127706,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127706,37.85,0.46,371,58385,70,NULL,NULL,'SDSS J151237.73+063606.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.157208333,6.60175,0.057,NULL,59383985053,927874766,14498043,17.8),(127707,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127707,37.47,0.46,312,58386,70,NULL,NULL,'2MASX J15123879+4444050',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000146,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.161417,44.73475,0.033,NULL,59984922308,937264411,14644756,17.7),(127708,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127708,36.19,0.46,173,58387,70,NULL,NULL,'2MASX J15123880+0551452',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.161541667,5.86258,0.073,NULL,59329374638,927021478,14484710,16.6),(127709,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127709,37.29,0.46,287,58388,70,NULL,NULL,'2MASX J15123887+0532482',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,228.162,5.54669,0.073,NULL,59329454661,927022729,14484730,17),(127710,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127710,36.52,0.09,202,58389,70,NULL,NULL,'2MASX J15123940+0731103',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00014,NULL,'16.7g',0.3,'E/S0','Group member',NULL,NULL,NULL,1,228.1642083,7.51944,0.053,NULL,59383223009,927862859,14497857,16.7),(127711,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127711,36.82,0.46,232,58390,70,NULL,NULL,'2MASX J15123946+0840493',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000165,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,228.1645417,8.68031,0.049,NULL,59352486302,927382598,14490353,16.5),(127712,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127712,37.56,0.46,325,58391,70,NULL,NULL,'2MASX J15124085+3448161',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000176,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,228.1702083,34.80458,0.029,NULL,60114489542,939288899,14676389,17),(127713,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127713,36.79,0.46,228,58392,70,NULL,NULL,'2MASX J15124088+0721393',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00013,NULL,'17.2g',0.2,'E/S0','Group member',NULL,NULL,NULL,1,228.170375,7.36103,0.057,NULL,59383247441,927863241,14497863,17.2),(127714,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127714,37.03,0.72,254,58393,70,NULL,NULL,'2MASX J15124151-0148293',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'16.5g',0.23,'Sa',NULL,NULL,NULL,NULL,1,228.173,-1.80808,0.185,NULL,45382200366,709096880,11079638,16.5),(127715,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127715,38.49,0.33,499,58394,70,NULL,NULL,'2MASX J15124163+0041522',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000085,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,228.173333,0.69778,0.113,NULL,56386252175,881035190,13766174,18.3),(127716,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127716,37.4,0.46,302,58395,70,NULL,NULL,'2MASX J15124167+3415491',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,228.173583,34.26356,0.021,NULL,60116642572,939322540,14676914,17.8),(127717,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127717,38.16,0.46,428,58396,70,NULL,NULL,'SDSS J151241.68-020547.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000132,NULL,'19.0g',0.11,NULL,NULL,NULL,NULL,NULL,1,228.173708333,-2.09642,0.161,NULL,45382281419,709098147,11079658,19),(127718,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127718,37.09,0.21,262,58397,70,NULL,NULL,'2MASX J15124194+1806561',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,228.17475,18.11558,0.057,NULL,59580937608,930952150,14546127,17.1),(127719,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127719,37.71,0.33,348,58398,70,NULL,NULL,'SDSS J151242.18+183011.6',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.175791667,18.50322,0.081,NULL,59580529496,930945773,14546027,17.6),(127720,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127720,36.99,0.33,250,58399,70,NULL,NULL,'2MASX J15124253+1539565',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.1772917,15.66583,0.037,NULL,59564430567,930694227,14542097,17.5),(127721,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127721,37.43,0.27,307,58400,70,NULL,NULL,'SDSS J151242.70+075745.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000147,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.177917,7.96253,0.041,NULL,59351799716,927371870,14490185,18.3),(127722,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127722,36.52,0.09,202,58401,70,NULL,NULL,'GIN 411',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00005,NULL,'15.9g',0.52,'S0/E','Group member',NULL,NULL,NULL,1,228.180417,7.44722,0.053,NULL,59383279315,927863739,14497870,15.9),(127723,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127723,36.58,0.25,207,58401,74.4,NULL,NULL,'GIN 411',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127724,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127724,36.82,0.27,231,58401,70,NULL,NULL,'GIN 411',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127725,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127725,36.52,0.09,202,58402,70,NULL,NULL,'2MASX J15124350+0730173',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.2g',0.2,NULL,'Group member',NULL,NULL,NULL,1,228.181375,7.50472,0.053,NULL,59383223050,927862860,14497857,17.2),(127726,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127726,37.03,0.46,255,58403,70,NULL,NULL,'2MASX J15124353+1851431',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,228.181583333,18.86211,0.085,NULL,59534595606,930228056,14534813,16.3),(127727,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127727,36.52,0.09,202,58404,70,NULL,NULL,'2MASX J15124384+0723343',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000113,NULL,'15.97',0.34,'E','Group member',NULL,NULL,NULL,1,228.182625,7.393,0.053,NULL,59383245016,927863203,14497862,15.97),(127728,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127728,36.52,0.09,202,58405,70,NULL,NULL,'2MASX J15124391+0733373',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.00007,NULL,'15.9g',0.29,'S0','Group member',NULL,NULL,NULL,1,228.1829583,7.56039,0.053,NULL,59386636108,927916189,14498690,15.9),(127729,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127729,37.38,0.46,299,58406,70,NULL,NULL,'2MASX J15124461+1530486',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.1859583,15.51342,0.065,NULL,59571837958,930809968,14543905,17.2),(127730,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127730,37.31,0.46,290,58407,70,NULL,NULL,'2MASX J15124482+3243152',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000167,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.186541667,32.72075,0.005,NULL,60113308994,939270453,14676100,18),(127731,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127731,37.65,0.06,339,58408,70,NULL,NULL,'2MASX J15124478+0610443',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.186583,6.17917,0.069,NULL,59383547259,927867925,14497936,17.1),(127732,'BCG','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127732,37.44,0.35,294,58409,60,NULL,NULL,'ABELL 2040',0.0456,'1980ApJ...241..486H',1980,1,NULL,'Katgert (1996,A&A,310,8) identifies multiple redshift systems in this cluster.','GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,228.188458333,7.42997,0.053,NULL,59383277304,927863707,14497870,NULL),(127733,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127733,36.45,0.13,195,58409,70,NULL,NULL,'ABELL 2040',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127734,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127734,37.55,0.46,323,58410,70,NULL,NULL,'2MASX J15124540+2341011',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00021,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,228.189125,23.68367,0.137,NULL,59411324073,928301938,14504717,17.2),(127735,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127735,35.47,0.46,124,58411,70,NULL,NULL,'NGC 5886',NULL,'2015arXiv151105856S',2015,1,0.86,NULL,'G',0.00006,NULL,'14.5g',0.63,'E0',NULL,NULL,NULL,NULL,1,228.189333333,41.23358,0.029,NULL,59974196754,937096824,14642137,14.5),(127736,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127736,31.84,NULL,23.3,58412,72,NULL,NULL,'AGC 258278',NULL,'2014Ap.....57..457K',2014,1,NULL,NULL,'RadioS',0.000073,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,228.19125,6.16139,0.069,NULL,59383549896,927867967,14497936,NULL),(127737,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127737,37.53,0.46,320,58413,70,NULL,NULL,'2MASX J15124597+4605310',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000173,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.191625,46.092,0.025,NULL,59986857251,937294644,14645228,17.2),(127738,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127738,37.96,0.46,391,58414,70,NULL,NULL,'2MASX J15124623+1816341',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.1927083,18.27617,0.069,NULL,59580916846,930951825,14546122,17.7),(127739,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127739,38,0.46,397,58415,70,NULL,NULL,'2MASX J15124653+3358582',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,228.1937083,33.98289,0.005,NULL,60116604073,939321938,14676905,17.5),(127740,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127740,38,0.33,397,58416,70,NULL,NULL,'SDSS J151246.79+002846.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000082,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.195,0.47947,0.137,NULL,56377894147,880904596,13764134,18.2),(127741,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127741,37.2,0.46,276,58417,70,NULL,NULL,'SDSS J151247.23+310950.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,228.196833,31.16411,0.009,NULL,60087074062,938860532,14669695,18),(127742,'BCG','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127742,37.44,0.35,294,58418,60,NULL,'ABELL 2040, BCG','UGC 09767',0.0456,'1980ApJ...241..486H',1980,1,1,NULL,'G',0.00005,NULL,'14.22',0.9,'BrClG','Group member',NULL,NULL,NULL,1,228.197917,7.43439,0.053,NULL,59383277196,927863706,14497870,14.22),(127743,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127743,36.59,0.25,208,58418,74.4,NULL,NULL,'UGC 09767',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127744,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127744,36.82,0.27,231,58418,70,NULL,NULL,'UGC 09767',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127745,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127745,36.45,0.13,195,58418,70,NULL,'ABELL 2040, BGC','UGC 09767',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127746,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127746,38.19,0.46,434,58419,70,NULL,NULL,'2MASX J15124870+1604586',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.203,16.08286,0.041,NULL,59565352947,930708639,14542322,17.3),(127747,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127747,37.69,0.46,345,58420,70,NULL,NULL,'2MASX J15124943+0618426',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000187,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,228.206,6.31175,0.061,NULL,59383818731,927872167,14498002,17.2),(127748,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127748,37.9,0.46,381,58421,70,NULL,NULL,'SDSS J151250.30+381141.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000141,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,228.209625,38.19492,0.037,NULL,60101611339,939087677,14673244,18.4),(127749,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127749,36.52,0.09,202,58422,70,NULL,NULL,'GIN 409',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.00008,NULL,'14.88',0.36,'S0/E','Group member',NULL,NULL,NULL,1,228.211167,7.42439,0.053,NULL,59383277344,927863708,14497870,14.88),(127750,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127750,36.59,0.25,208,58422,74.4,NULL,NULL,'GIN 409',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127751,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127751,36.82,0.27,231,58422,70,NULL,NULL,'GIN 409',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127752,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127752,37.38,0.46,299,58423,70,NULL,NULL,'2MASX J15125110+1245297',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.213,12.75836,0.101,NULL,59569576602,930774634,14543353,16.9),(127753,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127753,37.17,0.46,271,58424,70,NULL,NULL,'2MASX J15125163+1141516',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,228.2152083,11.69775,0.117,NULL,59348332147,927317689,14489338,17.5),(127754,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127754,38.3,0.21,457,58425,70,NULL,NULL,'2MASX J15125231+0248552',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000092,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,228.218125,2.81544,0.061,NULL,56385849854,881028903,13766076,17.4),(127755,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127755,35.96,0.25,156,58426,74.4,NULL,NULL,'CGCG 049-043',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.00009,NULL,'14.9g',0.55,'E/S0','Group member',NULL,NULL,NULL,1,228.2207083,4.514,0.089,NULL,56381409079,880959516,13764992,14.9),(127756,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127756,36.14,0.11,169,58426,70,NULL,NULL,'CGCG 049-043',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127757,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127757,36.18,0.26,172,58426,70,NULL,NULL,'CGCG 049-043',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127758,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127758,37.57,0.23,327,58427,70,NULL,NULL,'2MASX J15125306+1859470',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,228.221125,18.99644,0.089,NULL,59534598405,930228100,14534814,16.9),(127759,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127759,37.69,0.27,345,58428,70,NULL,NULL,'2MASX J15125308+3053423',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000184,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,228.22125,30.89517,0.021,NULL,60087027351,938859802,14669684,18.3),(127760,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127760,36.75,0.46,224,58429,70,NULL,NULL,'2MASX J15125429+3527523',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000181,NULL,'16.2g',0.4,'E0',NULL,NULL,NULL,NULL,1,228.226375,35.46453,0.041,NULL,60114679264,939291863,14676435,16.2),(127761,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127761,36.91,0.46,241,58430,70,NULL,NULL,'SDSS J151255.00+194242.4',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'16.0g',0.47,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.2292083,19.71181,0.089,NULL,59534329898,930223904,14534748,16),(127762,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127762,37.63,0.46,336,58431,70,NULL,NULL,'2MASX J15125544+1151086',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,228.231166667,11.8525,0.109,NULL,59348314348,927317411,14489334,17.3),(127763,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127763,35.86,0.46,149,58432,70,NULL,NULL,'2MASX J15125651+0730306',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'16.7g',0.21,'S0','Group member',NULL,NULL,NULL,1,228.2355,7.50861,0.053,NULL,59383223634,927862869,14497857,16.7),(127764,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127764,38.25,0.46,446,58433,70,NULL,NULL,'SDSS J151256.54+260601.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.235583,26.1005,0.169,NULL,59896550393,935883599,14623181,18.2),(127765,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127765,37.85,0.33,372,58434,70,NULL,NULL,'2MASX J15125671+1433067',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.3g',NULL,'BrClG',NULL,NULL,NULL,NULL,1,228.236333,14.55197,0.097,NULL,59572163467,930815054,14543985,17.3),(127766,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127766,37.63,0.46,336,58435,70,NULL,NULL,'2MASX J15125763+0443410',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,228.24025,4.72803,0.089,NULL,59328970491,927015163,14484611,17.2),(127767,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127767,38.67,0.46,541,58436,70,NULL,NULL,'SDSS J151257.71+095421.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000138,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,228.2405,9.90597,0.081,NULL,59354612849,927415825,14490872,18.6),(127768,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127768,37.63,0.46,335,58437,70,NULL,NULL,'2MASX J15125853+2200120',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.57',0.12,NULL,NULL,NULL,NULL,NULL,1,228.2437917,22.00333,0.157,NULL,59422875942,928482436,14507538,18.57),(127769,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127769,36.52,0.09,202,58438,70,NULL,NULL,'2MASX J15125853+0731276',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00012,NULL,'16.9g',0.28,'E','Group member',NULL,NULL,NULL,1,228.243833333,7.52444,0.053,NULL,59383223590,927862868,14497857,16.9),(127770,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127770,37.3,0.33,288,58439,70,NULL,NULL,'2MASX J15125904+1928310',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.245916667,19.47533,0.097,NULL,59534780800,930230950,14534858,17.8),(127771,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127771,38,0.33,397,58440,70,NULL,NULL,'2MASX J15125932+0025530',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000085,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.247333,0.43133,0.137,NULL,56377890317,880904536,13764133,17.3),(127772,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127772,35.15,0.33,107,58441,70,NULL,NULL,'CGCG 049-044',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.000109,NULL,'14.3g',0.83,'E',NULL,NULL,NULL,NULL,1,228.2489583,3.15525,0.053,NULL,56381361155,880958768,13764980,14.3),(127773,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127773,38.29,0.46,454,58442,70,NULL,NULL,'2MASX J15125974+0328270',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000084,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,228.249041667,3.47431,0.101,NULL,56381241780,880956902,13764951,18.3),(127774,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127774,36.99,0.33,250,58443,70,NULL,NULL,'2MASX J15130033+0841196',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,228.2514583,8.68889,0.049,NULL,59352544826,927383512,14490367,17.9),(127775,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127775,38.3,0.21,457,58444,70,NULL,NULL,'SDSS J151300.40+024807.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000092,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.251667,2.80214,0.061,NULL,56385822634,881028478,13766069,18.4),(127776,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127776,36.21,0.13,174,58445,70,NULL,NULL,'CGCG 021-050',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000101,NULL,'15.3g',0.63,'BrClG',NULL,NULL,NULL,NULL,1,228.252417,2.02614,0.061,NULL,56388168701,881065135,13766642,15.3),(127777,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127777,37.5,0.46,316,58446,70,NULL,NULL,'2MASX J15130186+2829333',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.93',0.21,NULL,NULL,NULL,NULL,NULL,1,228.25775,28.49275,0.061,NULL,59908492224,936070191,14626096,17.93),(127778,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127778,38.59,0.46,522,58447,70,NULL,NULL,'2MASX J15130220+1648427',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.2592083,16.81194,0.061,NULL,59564915038,930701797,14542215,18.1),(127779,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127779,37.09,0.21,262,58448,70,NULL,NULL,'2MASX J15130231+1802380',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.259667,18.04406,0.057,NULL,59580907095,930951673,14546119,17.7),(127780,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127780,37.71,0.46,348,58449,70,NULL,NULL,'2MASX J15130299+1606017',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,228.262417,16.1005,0.041,NULL,59565353312,930708645,14542322,17.4),(127781,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127781,37.63,0.46,335,58450,70,NULL,NULL,'2MASX J15130364+3648146',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00015,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,228.2650417,36.80394,0.049,NULL,60108791375,939199865,14674997,17.6),(127782,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127782,38.24,0.46,446,58451,70,NULL,NULL,'2MASX J15130361+1418077',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.265125,14.30233,0.101,NULL,59572006823,930812606,14543946,17.1),(127783,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127783,37.61,0.46,333,58452,70,NULL,NULL,'2MASX J15130365+2213580',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.11',0.19,'BrClG',NULL,NULL,NULL,NULL,1,228.265167,22.23272,0.117,NULL,59422895933,928482748,14507542,18.11),(127784,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127784,38.26,0.23,449,58453,70,NULL,NULL,'SDSS J151304.98+181152.9',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.2g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.270791667,18.19806,0.057,NULL,59581091894,930954560,14546165,17.2),(127785,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127785,36.99,0.33,250,58454,70,NULL,NULL,'SDSS J151305.12+084022.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.271375,8.67297,0.049,NULL,59352545150,927383517,14490367,18.1),(127786,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127786,37.57,0.23,327,58455,70,NULL,NULL,'2MASX J15130591+1855500',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.2745,18.93047,0.089,NULL,59534548836,930227325,14534801,17.7),(127787,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127787,37.44,0.46,307,58456,70,NULL,NULL,'2MASX J15130593+2242130',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000172,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,228.2747917,22.70364,0.101,NULL,59423699168,928495299,14507739,16.8),(127788,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127788,36.21,0.13,174,58457,70,NULL,NULL,'2MASX J15130610+0206100',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000063,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,228.275417,2.10269,0.061,NULL,56388211274,881065801,13766653,16.8),(127789,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127789,37.85,0.33,372,58458,70,NULL,NULL,'2MASX J15130622+1437377',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.2760417,14.62706,0.097,NULL,59572164815,930815075,14543985,18.2),(127790,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127790,38.26,0.23,449,58459,70,NULL,NULL,'2MASX J15130707+1758180',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,228.2795417,17.97161,0.041,NULL,59580790930,930949858,14546091,17.8),(127791,'Tully est','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127791,31.21,0.8,17.4,58460,75,NULL,NULL,'UGC 09776',NULL,'1988NBGC.C....0000T',1988,1,0.8,'Multiple SDSS entries describe this object.','G',0.000017,NULL,'16',0.3,'Im','X-ray-faint group member',NULL,NULL,NULL,1,228.281541667,56.96864,0.013,NULL,57714679345,901791864,14090497,16),(127792,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127792,37.85,0.46,372,58461,70,NULL,NULL,'2MASX J15130737+1806180',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,228.280833,18.10503,0.057,NULL,59580898415,930951537,14546117,16.7),(127793,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127793,36.99,0.33,250,58462,70,NULL,NULL,'SDSS J151308.10+153631.5',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',NULL,NULL,'15.7g',0.4,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.283791667,15.60878,0.065,NULL,59564428441,930694194,14542096,15.7),(127794,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127794,38.26,0.23,449,58463,70,NULL,NULL,'2MASX J15130817+1758387',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.2839583,17.9775,0.041,NULL,59580777706,930949651,14546088,17.7),(127795,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127795,37.57,0.23,327,58464,70,NULL,NULL,'2MASX J15130817+1857060',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,228.2839583,18.95175,0.089,NULL,59534545222,930227269,14534801,16.5),(127796,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127796,37.69,0.27,345,58465,70,NULL,NULL,'SDSS J151308.74+304839.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,228.286417,30.81092,0.033,NULL,60085782993,938840359,14669380,18.1),(127797,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127797,37.46,0.46,310,58466,70,NULL,NULL,'2MASX J15131022+4230031',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000179,NULL,'17.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,228.292417,42.50097,0.033,NULL,59973059193,937079049,14641860,17.4),(127798,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127798,37.66,0.46,341,58467,70,NULL,NULL,'2MASX J15131022+0636496',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.2925,6.61378,0.057,NULL,59384001093,927875017,14498047,17.7),(127799,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127799,35.96,0.25,156,58468,74.4,NULL,NULL,'CGCG 049-049',NULL,'2013AJ....146...86T',2013,1,0.57,NULL,'G',0.000098,NULL,'15.2g',0.49,'E','Group member',NULL,NULL,NULL,1,228.293417,4.48206,0.089,NULL,56383511540,880992367,13765505,15.2),(127800,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127800,36.18,0.26,172,58468,70,NULL,NULL,'CGCG 049-049',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127801,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127801,35.91,0.55,152,58469,70,NULL,NULL,'2MASX J15131063-0401334',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000087,NULL,'16.24',NULL,NULL,NULL,NULL,NULL,NULL,1,228.294333333,-4.02614,0.337,NULL,45372249106,708941392,11077209,16.24),(127802,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127802,37.46,0.46,310,58470,70,NULL,NULL,'2MASX J15131076+0246170',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000104,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,228.2949583,2.77136,0.061,NULL,56385636561,881025571,13766024,17.4),(127803,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127803,36.52,0.09,202,58471,70,NULL,NULL,'2MASX J15131137+0737186',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000123,NULL,'16.4g',0.27,'S0','Group member',NULL,NULL,NULL,1,228.297333333,7.62197,0.049,NULL,59383221547,927862836,14497856,16.4),(127804,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127804,37.69,0.33,345,58472,70,NULL,NULL,'SDSS J151313.00+462648.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,228.3042083,46.44675,0.057,NULL,59986912808,937295512,14645242,18.4),(127805,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127805,37.43,0.27,307,58473,70,NULL,NULL,'SDSS J151313.42+075609.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.3059583,7.93592,0.041,NULL,59351824123,927372251,14490191,18.2),(127806,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127806,37.84,0.46,369,58474,70,NULL,NULL,'2MASX J15131396+0558160',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,228.3082083,5.97122,0.069,NULL,59329359077,927021235,14484706,17.5),(127807,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127807,36.94,0.46,245,58475,70,NULL,NULL,'2MASX J15131435+4148166',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,228.309875,41.80456,0.037,NULL,59973399293,937084363,14641943,17.1),(127808,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127808,38.3,0.21,457,58476,70,NULL,NULL,'2MASX J15131510+0249010',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000092,NULL,'16.8g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,228.312958333,2.81692,0.061,NULL,56385643830,881025684,13766026,16.8),(127809,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127809,37.3,0.33,288,58477,70,NULL,NULL,'2MASX J15131536+1923209',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,228.314167,19.38931,0.101,NULL,59534983415,930234115,14534908,16.6),(127810,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127810,37.73,0.46,352,58478,70,NULL,NULL,'SDSS J151315.78+230917.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000141,NULL,'18.7g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.31575,23.15494,0.121,NULL,59423569258,928493269,14507707,18.7),(127811,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127811,38.11,0.46,419,58479,70,NULL,NULL,'SDSS J151316.26+305817.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000151,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,228.317791667,30.97158,0.013,NULL,60086855389,938857115,14669642,18.8),(127812,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127812,38.3,0.46,456,58480,70,NULL,NULL,'SDSS J151316.59+122237.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.319166667,12.37706,0.101,NULL,59569409751,930772027,14543312,18.1),(127813,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127813,37.86,0.46,374,58481,70,NULL,NULL,'2MASX J15131744+0546000',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,228.3227083,5.76658,0.073,NULL,59329392413,927021756,14484714,17.3),(127814,'Tully est','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127814,32.62,0.8,33.4,58482,75,NULL,NULL,'IC 4536',NULL,'1988NBGC.C....0000T',1988,1,2.2,'The 2MASX position applies to a knot north of the nucleus.','G',0.00001,NULL,'13.69',1.8,'SB(s)dm','in a pair',NULL,NULL,NULL,1,228.3217917,-18.13728,0.509,NULL,46700386578,729693540,11401461,13.69),(127815,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127815,31.7,0.43,21.9,58482,75,NULL,'3.6 micron, color + selection bias corrected','IC 4536',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127816,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127816,36.2,0.19,174,58483,70,NULL,NULL,'CGCG 049-056',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'15.7',0.45,NULL,NULL,NULL,NULL,NULL,1,228.324917,5.04522,0.093,NULL,59329194832,927018669,14484666,15.7),(127817,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127817,35.96,0.25,156,58484,74.4,NULL,NULL,'CGCG 049-054',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.00007,NULL,'15.2g',0.55,'E','Group member',NULL,NULL,NULL,1,228.327417,4.47747,0.089,NULL,56383509880,880992341,13765505,15.2),(127818,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127818,36.14,0.11,169,58484,70,NULL,NULL,'CGCG 049-054',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127819,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127819,36.18,0.26,172,58484,70,NULL,NULL,'CGCG 049-054',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127820,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127820,38.3,0.21,457,58485,70,NULL,NULL,'2MASX J15131910+0249240',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00009,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,228.329583,2.82339,0.061,NULL,56385646867,881025732,13766027,17.3),(127821,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127821,36.22,0.46,175,58486,70,NULL,NULL,'2MASX J15131914+0626462',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'17.31',0.41,NULL,'Group member',NULL,NULL,NULL,1,228.3297083,6.44614,0.049,NULL,59383830474,927872351,14498005,17.31),(127822,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127822,38.3,0.21,457,58487,70,NULL,NULL,'SDSS J151319.74+024805.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000085,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,228.3322917,2.80153,0.061,NULL,56385650517,881025789,13766027,18.3),(127823,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127823,37.57,0.23,327,58488,70,NULL,NULL,'2MASX J15132015+1856139',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,228.3339583,18.93725,0.105,NULL,59534812909,930231451,14534866,17),(127824,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127824,37.7,0.46,347,58489,70,NULL,NULL,'SDSS J151321.49+015933.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000068,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,228.339541667,1.99267,0.061,NULL,56388216665,881065885,13766654,18.7),(127825,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127825,37.69,0.46,345,58490,70,NULL,NULL,'2MASX J15132160+5254573',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.34,52.91594,0.033,NULL,59663515743,932242433,14566288,17.8),(127826,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127826,37.67,0.46,342,58491,70,NULL,NULL,'2MASX J15132176-0225514',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000149,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,228.340625,-2.43089,0.233,NULL,45381758661,709089979,11079530,17.8),(127827,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127827,36.96,0.46,246,58492,70,NULL,NULL,'UGC 09770 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000201,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,228.341708333,25.2075,0.149,NULL,59896301630,935879712,14623120,16.3),(127828,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127828,36.32,0.46,184,58493,70,NULL,NULL,'2MASX J15132207+3057050',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000173,NULL,'16.1g',0.33,NULL,NULL,NULL,NULL,NULL,1,228.3420417,30.95156,0.037,NULL,60086856853,938857138,14669642,16.1),(127829,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127829,38.36,0.46,470,58494,70,NULL,NULL,'SDSS J151323.58+593228.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000151,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,228.3482917,59.54117,0.013,NULL,57774720223,902730003,14105156,18.6),(127830,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127830,38.49,0.33,499,58495,70,NULL,NULL,'2MASX J15132493+0049211',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000093,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.353875,0.82261,0.105,NULL,56386522403,881039412,13766240,17.4),(127831,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127831,37.71,0.46,348,58496,70,NULL,NULL,'2MASX J15132508+2337088',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000161,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,228.354583,23.61911,0.137,NULL,59411270490,928301101,14504704,17.3),(127832,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127832,37.98,0.1,394,58497,70,NULL,NULL,'2MASX J15132520+0435551',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,228.355041667,4.59869,0.089,NULL,56380102909,880939107,13764673,17.4),(127833,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127833,36.2,0.19,174,58498,70,NULL,NULL,'2MASX J15132532+0452161',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,228.3554583,4.87106,0.097,NULL,59328981882,927015341,14484614,16.4),(127834,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127834,38.13,0.46,423,58499,70,NULL,NULL,'SDSS J151325.78+110842.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,228.357458333,11.145,0.109,NULL,59347852778,927310199,14489221,18.6),(127835,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127835,38.11,0.46,418,58500,70,NULL,NULL,'2MASXi J1513258+355634',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00018,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,228.3577083,35.94289,0.053,NULL,60106591959,939165499,14674460,17.7),(127836,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127836,37.25,0.46,282,58501,70,NULL,NULL,'2MASX J15132637+2059534',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,228.3597917,20.99828,0.133,NULL,59414930243,928358285,14505598,NULL),(127837,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127837,36.32,0.46,183,58502,70,NULL,NULL,'2MASX J15132756+2027424',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.54',0.17,NULL,NULL,NULL,NULL,NULL,1,228.364875,20.46194,0.121,NULL,59535525153,930242580,14535040,17.54),(127838,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127838,38.1,0.27,418,58503,70,NULL,NULL,'2MASX J15132759+2249464',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000176,NULL,'17.6g',0.2,'AGN',NULL,NULL,NULL,NULL,1,228.365167,22.82967,0.101,NULL,59423410886,928490795,14507668,17.6),(127839,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127839,38.11,0.33,419,58504,70,NULL,NULL,'2MASX J15132762+0015151',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000082,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.36525,0.25417,0.137,NULL,56377826158,880903533,13764117,17.7),(127840,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127840,36.38,0.49,189,58505,NULL,NULL,'Malmquist cor.','2MASX J15132872+0659283',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000027,NULL,'15.06',0.2,'Sc','Group member',NULL,NULL,NULL,1,228.3697083,6.99117,0.049,NULL,59383396220,927865565,14497899,15.06),(127841,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127841,36.79,0.41,228,58505,NULL,NULL,NULL,'2MASX J15132872+0659283',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127842,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127842,36.83,0.2,232,58505,74.4,NULL,NULL,'2MASX J15132872+0659283',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127843,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127843,36.86,0.33,235,58506,70,NULL,NULL,'2MASX J15132878+1729036',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.369958333,17.48444,0.077,NULL,59580663739,930947870,14546060,17.1),(127844,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127844,38.54,0.33,512,58507,70,NULL,NULL,'2MASX J15132892+2342544',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,228.3705,23.71506,0.137,NULL,59411274702,928301167,14504705,17.2),(127845,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127845,36.52,0.09,202,58508,70,NULL,NULL,'2MASX J15132911+0720183',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00016,NULL,'16.8g',0.25,'E/S0','Group member',NULL,NULL,NULL,1,228.371417,7.33836,0.049,NULL,59383261696,927863464,14497866,16.8),(127846,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127846,37.09,0.21,262,58509,70,NULL,NULL,'2MASX J15132912+1749236',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,228.3715417,17.82319,0.041,NULL,59580814653,930950228,14546097,17.3),(127847,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127847,38.54,0.33,512,58510,70,NULL,NULL,'2MASX J15133060+2348274',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,228.377667,23.80756,0.137,NULL,59410796968,928293702,14504589,17.9),(127848,'IRAS','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127848,32.45,0.8,30.9,58511,75,NULL,'MAT, I','UGCA 402',NULL,'1997ApJS..109..333W',1997,1,3.5,NULL,'G',0.000013,NULL,'11.7B',0.7,'SBd pec sp     HII',NULL,NULL,NULL,NULL,1,228.378875,-20.67506,0.485,NULL,46617126723,728392605,11381134,11.7),(127849,'Tully est','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127849,32.6,0.8,33.1,58511,75,NULL,NULL,'UGCA 402',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127850,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127850,32.01,0.4,25.2,58511,NULL,NULL,NULL,'UGCA 402',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127851,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127851,32.03,0.43,25.4,58511,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 402',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127852,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127852,32.13,0.43,26.7,58511,75,NULL,'3.6 micron, color corrected','UGCA 402',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127853,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127853,32.18,0.32,27.3,58511,85,NULL,'I, raw','UGCA 402',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127854,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127854,32.21,0.32,27.7,58511,85,NULL,'I, inv','UGCA 402',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127855,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127855,32.23,0.2,27.9,58511,74.4,NULL,NULL,'UGCA 402',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127856,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127856,32.25,0.43,28.1,58511,75,NULL,'MAT, I, raw','UGCA 402',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127857,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127857,32.3,0.49,28.9,58511,75,NULL,'IR','UGCA 402',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127858,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127858,32.43,0.43,30.6,58511,75,NULL,'MAT, I, inv','UGCA 402',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127859,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127859,32.5,0.43,31.7,58511,75,NULL,'MAT, I, cor','UGCA 402',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127860,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127860,37.39,0.46,301,58512,70,NULL,NULL,'2MASX J15133091+0526241',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,228.3789583,5.44019,0.085,NULL,59329328791,927020762,14484699,16.7),(127861,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127861,37.62,0.46,334,58513,70,NULL,NULL,'2MASX J15133121+3739027',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000173,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.3799583,37.65069,0.041,NULL,60101634551,939088039,14673250,17.3),(127862,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127862,37.71,0.33,349,58514,70,NULL,NULL,'2MASX J15133198+3359230',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.383125,33.98978,0.045,NULL,60116624398,939322256,14676910,17.7),(127863,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127863,38.47,0.46,494,58515,70,NULL,NULL,'SDSS J151332.03+310459.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,228.3835,31.08311,0.033,NULL,60086833782,938856777,14669637,18.4),(127864,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127864,33.08,0.49,41.4,58516,70,NULL,NULL,'ESO 328- G 035',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000103,NULL,'14.5',1,'SAb:',NULL,NULL,NULL,NULL,1,228.3839583,-39.21536,0.245,NULL,47189932962,737342702,11520979,14.5),(127865,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127865,37.23,0.46,279,58517,70,NULL,NULL,'MCG +10-22-007',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000201,NULL,'15.9g',0.46,'E0',NULL,NULL,NULL,NULL,1,228.386875,58.91808,0.017,NULL,57721601806,901900028,14092187,15.9),(127866,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127866,37.68,0.46,344,58518,70,NULL,NULL,'2MASX J15133331+2824368',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.0002,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,228.388708333,28.41008,0.065,NULL,59909246439,936081975,14626280,17.1),(127867,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127867,37.1,0.46,262,58519,70,NULL,NULL,'2MASX J15133447+0809313',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.393625,8.15853,0.041,NULL,59352003171,927375049,14490235,17.1),(127868,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127868,37.71,0.33,349,58520,70,NULL,NULL,'SDSS J151334.89+335840.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000172,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,228.395417,33.978,0.045,NULL,60116592739,939321761,14676902,18.6),(127869,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127869,37.98,0.1,394,58521,70,NULL,NULL,'2MASX J15133537+0437411',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,228.3974583,4.62808,0.097,NULL,56380104554,880939133,13764673,NULL),(127870,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127870,37.66,0.46,341,58522,70,NULL,NULL,'2MASX J15133543+2825458',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.0002,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,228.3977083,28.42944,0.065,NULL,59909243630,936081931,14626280,16.8),(127871,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127871,38.03,0.46,404,58523,70,NULL,NULL,'2MASX J15133599+2002334',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,228.399916667,20.04261,0.101,NULL,59534237430,930222459,14534725,17),(127872,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127872,36.8,0.46,229,58524,70,NULL,NULL,'2MASX J15133687+1144563',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,228.4037083,11.74903,0.105,NULL,59348341597,927317837,14489341,17.4),(127873,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127873,37.38,0.46,299,58525,70,NULL,NULL,'2MASX J15133717+1909184',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.404958333,19.15517,0.109,NULL,59534852390,930232068,14534876,17.6),(127874,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127874,36.52,0.09,202,58526,70,NULL,NULL,'2MASX J15133832+0704373',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000113,NULL,'14.0',0.5,'E','Group member',NULL,NULL,NULL,1,228.409667,7.07706,0.049,NULL,59383390356,927865474,14497898,14),(127875,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127875,36.49,0.57,199,58527,NULL,NULL,'Malmquist cor.','AGC 251758',NULL,'2009ApJS..182..474S',2009,1,0.41,NULL,'G',0.00003,NULL,'16.3',NULL,'Sc','Group member',NULL,NULL,NULL,1,228.410417,7.3275,0.049,NULL,59383265071,927863516,14497867,16.3),(127876,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127876,36.94,0.46,245,58527,NULL,NULL,NULL,'AGC 251758',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127877,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127877,36.98,0.2,249,58527,74.4,NULL,NULL,'AGC 251758',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127878,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127878,36.59,0.46,208,58528,70,NULL,NULL,'2MASX J15133927+1932404',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,228.4135417,19.54453,0.097,NULL,59534953989,930233656,14534900,16.8),(127879,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127879,37.09,0.46,262,58529,70,NULL,NULL,'2MASX J15134010+0323221',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000071,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.417167,3.38939,0.057,NULL,56381388092,880959188,13764987,17.5),(127880,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127880,37.69,0.46,345,58530,70,NULL,NULL,'2MASX J15134013+2156514',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.61',0.15,NULL,NULL,NULL,NULL,NULL,1,228.417375,21.94761,0.157,NULL,59414546707,928352292,14505504,18.61),(127881,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127881,37.77,0.46,358,58531,70,NULL,NULL,'SDSS J151340.20+252805.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.4175417,25.46814,0.145,NULL,59896618985,935884671,14623197,18.4),(127882,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127882,37.36,0.33,296,58532,70,NULL,NULL,'2MASX J15134062+1130313',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000184,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,228.419417,11.50853,0.117,NULL,59347924417,927311319,14489239,16.4),(127883,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127883,37.14,0.46,268,58533,70,NULL,NULL,'2MASX J15134074+1037223',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000194,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,228.4197917,10.62275,0.097,NULL,59357008524,927453258,14491457,16.5),(127884,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127884,36.52,0.09,202,58534,70,NULL,NULL,'2MASX J15134175+0721183',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'13.98',0.17,NULL,NULL,NULL,NULL,NULL,1,228.423917,7.35508,0.049,NULL,59383266428,927863537,14497867,13.98),(127885,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127885,35.96,0.25,156,58535,74.4,NULL,NULL,'GIN 404',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.00007,NULL,'15.9g',0.34,'S             BLAGN?',NULL,NULL,NULL,'Sy 1',1,228.4305,4.36214,0.049,NULL,56383528423,880992631,13765509,15.9),(127886,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127886,36.18,0.26,172,58535,70,NULL,NULL,'GIN 404',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127887,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127887,37.22,0.46,279,58536,70,NULL,NULL,'2MASX J15134511+0119241',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000075,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,228.438083,1.32342,0.097,NULL,56386638501,881041226,13766269,17.8),(127888,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127888,38.1,0.46,416,58537,70,NULL,NULL,'2MASX J15134519+3041390',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000151,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.438333,30.69422,0.033,NULL,60085822482,938840976,14669390,17.2),(127889,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127889,32,0.53,25.2,58538,70,NULL,NULL,'NGC 5878',NULL,'2014MNRAS.445.2677S',2014,1,3.5,'Confused HIPASS source','G',0.000007,NULL,'12.98',1.4,'SA(s)b','Group member',NULL,NULL,NULL,1,228.4404583,-14.26983,0.485,NULL,46670590414,729227975,11394187,12.98),(127890,'IRAS','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127890,32.25,0.8,28.1,58538,75,NULL,'MAT, I','NGC 5878',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127891,'Sosies','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127891,32.32,0.1,29.1,58538,NULL,NULL,NULL,'NGC 5878',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127892,'Tully est','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127892,32.5,0.8,31.6,58538,75,NULL,'B','NGC 5878',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127893,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127893,32.13,0.4,26.7,58538,NULL,NULL,NULL,'NGC 5878',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127894,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127894,32.23,0.43,28,58538,75,NULL,'MAT, I, raw','NGC 5878',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127895,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127895,32.3,0.46,28.9,58538,NULL,NULL,'J','NGC 5878',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127896,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127896,32.34,0.47,29.3,58538,NULL,NULL,'H','NGC 5878',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127897,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127897,32.35,0.32,29.5,58538,85,NULL,'I, raw','NGC 5878',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127898,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127898,32.35,0.4,29.5,58538,NULL,NULL,'mean','NGC 5878',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127899,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127899,32.39,0.45,30,58538,NULL,NULL,'K','NGC 5878',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127900,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127900,32.41,0.32,30.4,58538,85,NULL,'I, inv','NGC 5878',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127901,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127901,32.44,0.43,30.8,58538,75,NULL,'MAT, I, cor','NGC 5878',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127902,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127902,32.48,0.2,31.3,58538,74.4,NULL,NULL,'NGC 5878',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127903,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127903,32.52,0.43,31.9,58538,75,NULL,'MAT, I, inv','NGC 5878',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127904,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127904,32.58,0.43,32.8,58538,75,NULL,'3.6 micron, color corrected','NGC 5878',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127905,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127905,32.61,0.36,33.2,58538,NULL,NULL,'Malmquist cor.','NGC 5878',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127906,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127906,32.7,0.34,34.7,58538,NULL,NULL,NULL,'NGC 5878',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127907,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127907,32.78,0.43,35.9,58538,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5878',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127908,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127908,36.21,0.13,174,58539,70,NULL,NULL,'CGCG 021-053',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000074,NULL,'16.1g',0.37,'E0','Group member',NULL,NULL,NULL,1,228.441167,2.12494,0.045,NULL,56388010126,881062658,13766604,16.1),(127909,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127909,37.3,0.46,288,58540,70,NULL,NULL,'CGCG 165-033',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000107,NULL,'15.7',0.5,NULL,NULL,NULL,NULL,NULL,1,228.442,26.89786,0.101,NULL,59897818778,935903418,14623490,15.7),(127910,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127910,35.14,0.5,107,58541,70,NULL,NULL,'2MASX J15134622-4343365',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,228.4425,-43.72683,0.709,NULL,47072738337,735511536,11492367,14.7),(127911,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127911,37.67,0.46,342,58542,70,NULL,NULL,'2MASX J15134634+1813523',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,228.443167,18.23125,0.069,NULL,59581135166,930955236,14546175,16.9),(127912,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127912,37.98,0.1,394,58543,70,NULL,NULL,'SDSS J151346.69+043920.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.444541667,4.65567,0.097,NULL,56380157844,880939966,13764686,17.8),(127913,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127913,36.21,0.13,174,58544,70,NULL,NULL,'CGCG 021-052',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.0001,NULL,'15.6g',0.47,'E0','Group member',NULL,NULL,NULL,1,228.44625,2.09803,0.045,NULL,56388002682,881062541,13766602,15.6),(127914,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127914,37.59,0.46,329,58545,70,NULL,NULL,'2MASX J15134729+5745491',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000077,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,228.4474583,57.76358,0.013,NULL,57720936751,901889636,14092025,16.9),(127915,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127915,37.32,0.46,291,58546,70,NULL,NULL,'SDSS J151347.93+041204.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000064,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.44975,4.20133,0.045,NULL,56383612508,880993945,13765530,18.1),(127916,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127916,32.34,0.47,29.3,58547,NULL,NULL,'H','NGC 5892',NULL,'2007A&A...465...71T',2007,1,3.5,NULL,'G',0.000013,NULL,'12.30',2.8,'SA(s)d         HII',NULL,NULL,NULL,NULL,1,228.450875,-15.46389,0.441,NULL,46670427391,729225427,11394147,12.3),(127917,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127917,32.42,0.46,30.5,58547,NULL,NULL,'J','NGC 5892',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127918,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127918,32.47,0.45,31.2,58547,NULL,NULL,'K','NGC 5892',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127919,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127919,32.49,0.4,31.5,58547,NULL,NULL,'mean','NGC 5892',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127920,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127920,32.64,0.4,33.7,58547,75,NULL,'B','NGC 5892',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127921,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127921,37.34,0.46,294,58548,70,NULL,NULL,'2MASX J15134826+4022289',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,228.4512083,40.37472,0.041,NULL,59971762206,937058784,14641543,17.7),(127922,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127922,35.91,0.36,152,58549,NULL,NULL,NULL,'AGC 251759',NULL,'2009ApJS..182..474S',2009,1,0.47,NULL,'G',0.00003,NULL,'15.6',NULL,'Sc','Group member',NULL,NULL,NULL,1,228.453125,7.1545,0.049,NULL,59383372249,927865191,14497893,15.6),(127923,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127923,35.95,0.2,155,58549,74.4,NULL,NULL,'AGC 251759',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127924,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127924,36.02,0.34,160,58549,NULL,NULL,'Malmquist cor.','AGC 251759',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127925,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127925,38.1,0.27,418,58550,70,NULL,NULL,'SDSS J151349.12+224947.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000143,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.4547083,22.82978,0.121,NULL,59423523451,928492553,14507696,18.1),(127926,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127926,37.09,0.21,262,58551,70,NULL,NULL,'2MASX J15134931+1750439',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000107,NULL,'17.11',0.48,NULL,NULL,NULL,NULL,NULL,1,228.4555,17.84542,0.041,NULL,59580818834,930950294,14546098,17.11),(127927,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127927,38.1,0.27,418,58552,70,NULL,NULL,'2MASX J15134936+2251223',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00021,NULL,'16.0g',0.43,NULL,NULL,NULL,NULL,NULL,1,228.4557917,22.85606,0.121,NULL,59423526346,928492599,14507696,16),(127928,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127928,37.23,0.46,280,58553,70,NULL,NULL,'SDSS J151349.43+104510.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.456,10.75294,0.101,NULL,59357013928,927453342,14491458,18),(127929,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127929,38.11,0.33,419,58554,70,NULL,NULL,'2MASX J15134962+0021341',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000092,NULL,'16.7g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,228.4567083,0.35939,0.137,NULL,56378688292,880917004,13764328,16.7),(127930,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127930,36.18,0.26,172,58555,70,NULL,NULL,'GIN 403',NULL,'2001MNRAS.321..277C',2001,1,0.54,NULL,'G',0.000083,NULL,'15.9g',0.42,'S',NULL,NULL,NULL,NULL,1,228.457,4.72353,0.097,NULL,56380161486,880940023,13764687,15.9),(127931,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127931,36.64,0.25,213,58555,74.4,NULL,NULL,'GIN 403',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127932,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127932,37.78,0.46,360,58556,70,NULL,NULL,'SDSS J151350.68+252045.0',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000187,NULL,'16.8g',0.31,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.461208333,25.34586,0.149,NULL,59896575627,935883994,14623187,16.8),(127933,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127933,35.98,0.25,157,58557,74.4,NULL,NULL,'GIN 402',NULL,'2013AJ....146...86T',2013,1,0.53,NULL,'G',0.000077,NULL,'15.8g',0.41,'E/S0',NULL,NULL,NULL,NULL,1,228.461583,4.62258,0.053,NULL,56380121855,880939403,13764678,15.8),(127934,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127934,36.18,0.26,172,58557,70,NULL,NULL,'GIN 402',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127935,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127935,36.2,0.19,174,58557,70,NULL,NULL,'GIN 402',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127936,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127936,37.89,0.46,379,58558,70,NULL,NULL,'2MASX J15135124+2756007',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.0002,NULL,'17.51',0.15,NULL,NULL,NULL,NULL,NULL,1,228.463667,27.93361,0.073,NULL,59908731427,936073928,14626155,17.51),(127937,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127937,38.26,0.23,449,58559,70,NULL,NULL,'SDSS J151351.43+181142.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.464333333,18.19506,0.069,NULL,59581127111,930955111,14546173,18.1),(127938,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127938,37.6,0.46,331,58560,70,NULL,NULL,'2MASX J15135209+0443580',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,228.4669583,4.73292,0.097,NULL,56380161920,880940030,13764687,17),(127939,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127939,35.49,0.63,125,58561,70,NULL,NULL,'2MASX J15135321-3848251',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,228.471791667,-38.80694,0.253,NULL,47189320261,737333129,11520830,14.9),(127940,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127940,36.77,0.78,226,58562,70,NULL,NULL,'2MASX J15135348-2135462',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.4,NULL,NULL,NULL,NULL,NULL,1,228.472917,-21.59617,0.465,NULL,46617550854,728399232,11381238,14.4),(127941,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127941,37.54,0.23,322,58563,70,NULL,NULL,'2MASX J15135400+2412317',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000191,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,228.474833,24.20894,0.125,NULL,59410952242,928296128,14504627,16.8),(127942,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127942,37.58,0.46,328,58564,70,NULL,NULL,'2MASX J15135467+1848212',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,228.477917,18.80578,0.097,NULL,59534082507,930220039,14534688,17.2),(127943,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127943,37.7,0.27,347,58565,70,NULL,NULL,'2MASX J15135520+1937112',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,228.480125,19.61994,0.089,NULL,59534377953,930224655,14534760,16.9),(127944,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127944,37.7,0.27,347,58566,70,NULL,NULL,'SDSS J151355.52+193615.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.481417,19.60428,0.089,NULL,59534377916,930224654,14534760,18.4),(127945,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127945,37.98,0.1,394,58567,70,NULL,NULL,'2MASX J15135611+0437061',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,228.483666667,4.61822,0.053,NULL,56380125158,880939455,13764678,17.3),(127946,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127946,37.54,0.23,322,58568,70,NULL,NULL,'2MASX J15135692+2408547',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000187,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,228.487166667,24.14864,0.125,NULL,59411002013,928296906,14504639,16.6),(127947,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127947,36.14,0.46,169,58569,70,NULL,NULL,'2MASX J15135716+2336436',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.54',0.25,'AGN',NULL,NULL,NULL,NULL,1,228.488167,23.61222,0.137,NULL,59422015637,928468994,14507328,16.54),(127948,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127948,37.54,0.23,322,58570,70,NULL,NULL,'2MASX J15135721+2408237',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.488291667,24.13981,0.125,NULL,59411004874,928296951,14504639,17.4),(127949,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127949,34.76,NULL,89.5,58571,NULL,NULL,NULL,'FGC 1865',NULL,'2000BSAO...50....5K',2000,1,1.1,NULL,'G',0.0001,NULL,'16.9g',0.14,'Sdm',NULL,NULL,NULL,NULL,1,228.488167,37.33864,0.037,NULL,60108704188,939198502,14674976,16.9),(127950,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127950,34.81,NULL,91.6,58571,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1865',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127951,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127951,34.81,NULL,91.7,58571,NULL,NULL,'Dipole + Quadrupole','FGC 1865',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127952,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127952,34.83,NULL,92.4,58571,NULL,NULL,'Dipole','FGC 1865',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127953,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127953,36.2,0.19,174,58572,70,NULL,NULL,'2MASX J15135764+0445231',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,228.490083,4.75647,0.097,NULL,56380147108,880939798,13764684,16.6),(127954,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127954,37.98,0.1,394,58573,70,NULL,NULL,'2MASX J15135764+0447481',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,228.49025,4.79658,0.093,NULL,56380139673,880939682,13764682,16.7),(127955,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127955,36.43,0.46,194,58574,70,NULL,NULL,'2MASX J15135820+3950471',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.492667,39.84647,0.033,NULL,60102791681,939106120,14673533,17.1),(127956,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127956,37.94,0.46,386,58575,70,NULL,NULL,'SDSS J151359.66+485136.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00014,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,228.498625,48.86022,0.021,NULL,59940771943,936574561,14633977,18.5),(127957,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127957,36.8,0.57,229,58576,70,NULL,NULL,'2MASX J15140013-2131260',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,228.500583,-21.524,0.465,NULL,46617585314,728399770,11381246,14.7),(127958,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127958,36.96,0.46,246,58577,70,NULL,NULL,'2MASX J15140022+2112486',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.46',0.15,NULL,NULL,NULL,NULL,NULL,1,228.501,21.21353,0.145,NULL,59415233535,928363023,14505672,18.46),(127959,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127959,38.18,0.46,433,58578,70,NULL,NULL,'2MASX J15140047+2603347',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.44',0.15,NULL,NULL,NULL,NULL,NULL,1,228.502125,26.05956,0.153,NULL,59896712800,935886137,14623220,18.44),(127960,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127960,38.57,0.33,519,58579,70,NULL,NULL,'SDSS J151400.55+233451.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.502333,23.58097,0.137,NULL,59423851462,928497679,14507776,18.2),(127961,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127961,33.87,NULL,59.5,58580,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09780',NULL,'2010Ap&SS.325..163P',2010,1,1.27,NULL,'G',0.000017,NULL,'14.9g',0.36,'Scd','Isolated galaxy',NULL,NULL,NULL,1,228.504375,44.59053,0.033,NULL,59984960352,937265005,14644765,14.9),(127962,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127962,33.88,NULL,59.7,58580,NULL,NULL,'Dipole + Quadrupole','UGC 09780',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127963,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127963,33.88,NULL,59.8,58580,NULL,NULL,'Dipole','UGC 09780',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127964,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127964,33.92,0.49,60.8,58580,75,NULL,'IR','UGC 09780',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127965,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127965,34,0.2,63.1,58580,74.4,NULL,NULL,'UGC 09780',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127966,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127966,34.03,0.52,64,58580,NULL,NULL,NULL,'UGC 09780',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127967,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127967,34.14,0.49,67.4,58580,NULL,NULL,'Malmquist cor.','UGC 09780',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127968,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127968,38.57,0.33,519,58581,70,NULL,NULL,'SDSS J151401.20+232756.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.5050417,23.46558,0.117,NULL,59423340283,928489691,14507651,18.4),(127969,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127969,37.36,0.33,296,58582,70,NULL,NULL,'2MASX J15140130+1131411',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,228.505417,11.52808,0.117,NULL,59347922649,927311291,14489238,17.4),(127970,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127970,37.46,0.27,311,58583,70,NULL,NULL,'2MASX J15140150+1503300',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,228.50625,15.05825,0.077,NULL,59572729559,930823899,14544123,16.8),(127971,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127971,37.69,0.33,345,58584,70,NULL,NULL,'SDSS J151401.83+462601.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000136,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.507667,46.43378,0.041,NULL,59986725912,937292592,14645196,17.9),(127972,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127972,38.45,0.46,490,58585,70,NULL,NULL,'SDSS J151402.17+014401.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000077,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.509083,1.73386,0.081,NULL,56387637460,881056835,13766513,18.1),(127973,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127973,37.7,0.27,347,58586,70,NULL,NULL,'2MASX J15140391+1935035',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,228.516333,19.58439,0.089,NULL,59534888240,930232628,14534884,16.8),(127974,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127974,37.79,0.27,362,58587,70,NULL,NULL,'B2 1512+30',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',NULL,NULL,'15.9g',0.38,NULL,NULL,NULL,NULL,NULL,1,228.517375,30.14647,0.041,NULL,59904731890,936011435,14625178,15.9),(127975,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127975,37.47,0.46,312,58588,70,NULL,NULL,'2MASX J15140431+5630186',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000089,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,228.51775,56.50517,0.013,NULL,57581713250,899714269,14058035,16.6),(127976,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127976,36.26,0.53,179,58589,70,NULL,NULL,'2MASX J15140456-2208200',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.7I',0.5,NULL,NULL,NULL,NULL,NULL,1,228.5189583,-22.13883,0.449,NULL,46621599216,728462487,11382226,13.7),(127977,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127977,37.79,0.27,362,58590,70,NULL,NULL,'2MASX J15140602+3010521',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,228.5252083,30.18131,0.041,NULL,59904734945,936011483,14625179,17.9),(127978,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127978,35.96,0.25,156,58591,74.4,NULL,NULL,'CGCG 049-067',NULL,'2013AJ....146...86T',2013,1,0.58,NULL,'G',0.000077,NULL,'14.22',0.4,'E',NULL,NULL,NULL,NULL,1,228.52575,4.22217,0.045,NULL,56383709362,880995458,13765554,14.22),(127979,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127979,36.14,0.11,169,58591,70,NULL,NULL,'CGCG 049-067',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127980,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127980,36.18,0.26,172,58591,70,NULL,NULL,'CGCG 049-067',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127981,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127981,38.11,0.46,419,58592,70,NULL,NULL,'SDSS J151407.69+193622.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.532083,19.60614,0.089,NULL,59534378714,930224667,14534760,17.9),(127982,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127982,34.92,0.49,96.2,58593,75,NULL,'IR','CGCG 135-030',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000704,NULL,'16.20',0.1,NULL,NULL,NULL,NULL,NULL,1,228.5342917,25.69961,0.153,NULL,59896701567,935885961,14623218,16.2),(127983,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127983,35.54,0.2,128,58594,74.4,NULL,NULL,'CGCG 135-030',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000704,NULL,'16.20',0.1,NULL,NULL,NULL,NULL,NULL,1,228.5342917,25.69961,0.153,NULL,59896701567,935885961,14623218,16.2),(127984,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127984,37.46,0.27,311,58595,70,NULL,NULL,'2MASX J15140978+1514380',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,228.5409583,15.24378,0.073,NULL,59572598879,930821857,14544091,16.7),(127985,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127985,38.74,0.46,560,58596,70,NULL,NULL,'SDSS J151410.55+211356.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.6g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.544,21.2325,0.145,NULL,59415236544,928363071,14505672,18.6),(127986,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127986,36.24,0.43,177,58597,NULL,NULL,'Malmquist cor.','2MASX J15141134+0711511',NULL,'2009ApJS..182..474S',2009,1,0.38,NULL,'G',0.000027,NULL,'17.1g',0.17,'Sc','Group member',NULL,NULL,NULL,1,228.547125,7.19756,0.049,NULL,59383368228,927865128,14497892,17.1),(127987,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127987,36.54,0.38,203,58597,NULL,NULL,NULL,'2MASX J15141134+0711511',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127988,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127988,36.58,0.2,207,58597,74.4,NULL,NULL,'2MASX J15141134+0711511',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127989,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127989,36.21,0.46,175,58598,70,NULL,NULL,'2MASX J15141177+1901135',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,228.549041667,19.02039,0.109,NULL,59534860682,930232198,14534878,16.5),(127990,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127990,37.04,0.46,256,58599,70,NULL,NULL,'2MASX J15141201+4049183',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000138,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,228.5500417,40.82164,0.033,NULL,59971914363,937061161,14641580,17.1),(127991,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127991,34.71,0.2,87.5,58600,74.4,NULL,NULL,'CGCG 077-047',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000023,NULL,'15.4',0.3,NULL,NULL,NULL,NULL,NULL,1,228.550458333,13.89431,0.085,NULL,59573284295,930832567,14544258,15.4),(127992,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127992,37.82,0.46,367,58601,70,NULL,NULL,'2MASX J15141269+0403431',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000084,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,228.553,4.06206,0.045,NULL,56383595218,880993675,13765526,17.3),(127993,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127993,36.2,0.19,174,58602,70,NULL,NULL,'2MASX J15141296+0448431',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,228.5540417,4.81194,0.093,NULL,56380137978,880939655,13764682,16),(127994,'TRGB','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127994,27.41,0.09,3.03,58603,74.4,NULL,NULL,'ESO 274- G 001',NULL,'2013AJ....146...86T',2013,1,13.44,'The 2MASX position is centered on two knots southwest of the center.','G',0.000007,NULL,'11.7',1.34,'Sd',NULL,NULL,NULL,NULL,1,228.557667,-46.80794,NULL,NULL,47105558462,736024350,11500380,11.7),(127995,'TRGB','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127995,27.42,NULL,3.05,58603,NULL,NULL,NULL,'ESO 274- G 001',NULL,'2007AJ....133..504K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127996,'TRGB','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127996,27.49,0.02,3.15,58603,NULL,NULL,'I','ESO 274- G 001',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127997,'Tully est','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127997,29.28,0.8,7.2,58603,75,NULL,'B','ESO 274- G 001',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127998,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127998,27.41,0.09,3.03,58603,74.4,NULL,NULL,'ESO 274- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127999,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127999,27.94,0.43,3.9,58603,75,NULL,'3.6 micron, color + selection bias corrected','ESO 274- G 001',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128000,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128000,28.13,0.43,4.2,58603,75,NULL,'3.6 micron, color corrected','ESO 274- G 001',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128001,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128001,28.54,NULL,5.11,58603,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 274- G 001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128002,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128002,28.55,NULL,5.13,58603,NULL,NULL,'Dipole','ESO 274- G 001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128003,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128003,28.56,NULL,5.14,58603,NULL,NULL,'Dipole + Quadrupole','ESO 274- G 001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128004,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128004,28.64,NULL,5.34,58603,NULL,NULL,NULL,'ESO 274- G 001',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128005,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128005,34.94,0.55,97.1,58604,70,NULL,NULL,'LCRS B151137.6-033415',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000063,NULL,'17.59',0.7,'HII',NULL,NULL,NULL,NULL,1,228.558167,-3.75217,0.333,NULL,45373057847,708954028,11077406,17.59),(128006,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128006,36.58,0.64,207,58605,70,NULL,NULL,'2MASX J15141418-2312340',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,228.5590417,-23.20936,0.497,NULL,46621022568,728453477,11382085,15.6),(128007,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128007,38.54,0.46,511,58606,70,NULL,NULL,'2MASX J15141468+0331491',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,228.561125,3.53047,0.057,NULL,56383195193,880987424,13765428,17.3),(128008,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128008,36.13,0.46,169,58607,70,NULL,NULL,'2MASX J15141471+2644321',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.02',0.21,NULL,NULL,NULL,NULL,NULL,1,228.5612917,26.74233,0.093,NULL,59896036534,935875570,14623055,17.02),(128009,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128009,35.12,0.46,106,58608,70,NULL,NULL,'CGCG 077-046',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00008,NULL,'15.3',NULL,NULL,NULL,NULL,NULL,NULL,1,228.562125,12.08761,0.141,NULL,59347399104,927303111,14489111,15.3),(128010,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128010,33.22,0.69,44,58609,100,NULL,'mid-IR','UGC 09777',NULL,'2013ApJ...771...88L',2013,1,1.5,NULL,'G',0.00002,NULL,'14.40',0.9,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,228.563125,20.47867,0.125,NULL,59415738280,928370910,14505795,14.4),(128011,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128011,34.16,0.4,68.1,58609,NULL,NULL,'mean','UGC 09777',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128012,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128012,34.17,0.2,68.2,58609,74.4,NULL,NULL,'UGC 09777',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128013,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128013,34.46,0.47,77.9,58609,NULL,NULL,'H','UGC 09777',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128014,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128014,37.97,0.46,393,58610,70,NULL,NULL,'SDSS J151415.35+365747.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,228.564,36.96306,0.041,NULL,60108743766,939199121,14674986,18.2),(128015,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128015,37.79,0.27,362,58611,70,NULL,NULL,'2MASX J15141535+3003421',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.78',0.14,NULL,NULL,NULL,NULL,NULL,1,228.564083333,30.06164,0.041,NULL,59904740694,936011573,14625180,18.78),(128016,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128016,37.09,0.21,262,58612,70,NULL,NULL,'2MASX J15141565+1741525',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.565166667,17.69786,0.089,NULL,59580848782,930950762,14546105,17.1),(128017,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128017,36.3,0.59,182,58613,NULL,NULL,'Malmquist cor.','AGC 251761',NULL,'2009ApJS..182..474S',2009,1,0.33,NULL,'G',0.000027,NULL,'16.78',NULL,'Sc',NULL,NULL,NULL,NULL,1,228.56775,7.33994,0.049,NULL,59349945918,927342904,14489732,16.78),(128018,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128018,36.6,0.52,209,58613,NULL,NULL,NULL,'AGC 251761',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128019,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128019,36.64,0.2,213,58613,74.4,NULL,NULL,'AGC 251761',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128020,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128020,37.62,0.46,334,58614,70,NULL,NULL,'2MASX J15141681+3516431',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000182,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,228.5702917,35.27875,0.041,NULL,60106892130,939170189,14674534,16.9),(128021,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128021,37.27,0.46,285,58615,70,NULL,NULL,'2MASX J15141720+0020151',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000081,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.5715417,0.33747,0.125,NULL,56378699062,880917172,13764330,17.3),(128022,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128022,37.32,0.46,291,58616,70,NULL,NULL,'2MASX J15141732+4012264',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000176,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,228.5722917,40.20742,0.037,NULL,60102755036,939105547,14673524,16.7),(128023,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128023,37.54,0.23,322,58617,70,NULL,NULL,'SDSS J151419.47+241925.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000174,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.581167,24.32381,0.129,NULL,59410840258,928294379,14504599,18.3),(128024,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128024,36.86,0.33,235,58618,70,NULL,NULL,'2MASX J15141959+1724505',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,228.5817083,17.41408,0.077,NULL,59563610678,930681416,14541897,17.3),(128025,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128025,35.65,0.33,135,58619,70,NULL,NULL,'CGCG 049-069',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.00008,NULL,'15.7',0.48,NULL,NULL,NULL,NULL,NULL,1,228.584917,8.28872,0.045,NULL,59351882455,927373163,14490205,15.7),(128026,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128026,37.94,0.17,387,58620,70,NULL,NULL,'2MASX J15142050+0350470',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000082,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,228.585458333,3.84642,0.049,NULL,56383836230,880997441,13765585,18.2),(128027,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128027,37.98,0.1,394,58621,70,NULL,NULL,'2MASX J15142162+0437261',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,228.5902083,4.62375,0.053,NULL,56380113377,880939271,13764676,17),(128028,'HII LF','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128028,47.49,1.57,6000,58622,71,NULL,NULL,'MS 1512-cB58',2.7233,'2005MNRAS.356.1117S',2005,1,NULL,NULL,'G',0.0005,NULL,'20.31',NULL,'Sb-Sc',NULL,NULL,NULL,NULL,1,228.5927917,36.607,0.033,NULL,60108679830,939198122,14674970,20.31),(128029,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128029,38,0.46,398,58623,70,NULL,NULL,'SDSS J151424.15+023232.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.600667,2.54233,0.057,NULL,56387860790,881060324,13766567,18.2),(128030,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128030,35.53,0.33,128,58624,NULL,NULL,NULL,'SDSS J151424.70+073652.6',NULL,'2009ApJS..182..474S',2009,1,0.34,NULL,'G',0.000033,NULL,'15.94',NULL,'Scd','Group member',NULL,NULL,NULL,1,228.602958333,7.61461,0.049,NULL,59349964480,927343195,14489737,15.94),(128031,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128031,35.57,0.2,130,58624,74.4,NULL,NULL,'SDSS J151424.70+073652.6',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128032,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128032,35.89,0.28,150,58624,NULL,NULL,'Malmquist cor.','SDSS J151424.70+073652.6',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128033,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128033,36.22,0.46,175,58625,70,NULL,NULL,'2MASX J15142471+0336161',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000097,NULL,'16.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,228.603,3.60433,0.057,NULL,56383132410,880986443,13765413,16.3),(128034,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128034,36.13,0.52,168,58626,70,NULL,NULL,'2MASX J15142471-2129480',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00013,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,228.6030417,-21.49672,0.465,NULL,46617555468,728399304,11381239,14.6),(128035,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128035,36.02,0.46,160,58627,70,NULL,NULL,'CGCG 049-071',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000103,NULL,'15.6',0.41,'S0/E','Group member',NULL,NULL,NULL,1,228.608625,7.89142,0.049,NULL,59352854425,927388350,14490442,15.6),(128036,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128036,37.75,0.46,355,58628,70,NULL,NULL,'2MASX J15142624+2710161',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,228.609208333,27.17114,0.089,NULL,59908556268,936071191,14626112,18),(128037,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128037,36.61,0.33,210,58629,70,NULL,NULL,'CGCG 135-034',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00017,NULL,'15.4',0.32,NULL,NULL,NULL,NULL,NULL,1,228.613708333,20.78933,0.145,NULL,59414692925,928354576,14505540,15.4),(128038,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128038,39.09,0.46,658,58630,70,NULL,NULL,'2MASX J15142799-0221011',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000174,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,228.616625,-2.35031,0.221,NULL,45381654180,709088346,11079505,18.4),(128039,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128039,36.88,0.2,238,58631,74.4,NULL,NULL,'CGCG 077-048',NULL,'2013AJ....146...86T',2013,1,0.82,NULL,'G',0.000159,NULL,'15.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,228.6195417,9.95489,0.069,NULL,59354390098,927412345,14490817,15.9),(128040,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128040,37.18,0.46,273,58632,70,NULL,NULL,'2MASX J15142965+0642023',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,'Group member',NULL,NULL,NULL,1,228.623625,6.70056,0.033,NULL,59383910875,927873607,14498025,17.5),(128041,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128041,37.9,0.27,380,58633,70,NULL,NULL,'2MASX J15143032+0155261',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'17.00',0.33,NULL,NULL,NULL,NULL,NULL,1,228.626417,1.92408,0.089,NULL,56387523422,881055053,13766485,17),(128042,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128042,37.98,0.1,394,58634,70,NULL,NULL,'2MASX J15143145+0425291',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000087,NULL,'17.1g',0.27,'S0',NULL,NULL,NULL,NULL,1,228.631167,4.42481,0.049,NULL,56383725905,880995717,13765558,17.1),(128043,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128043,37.92,0.46,384,58635,70,NULL,NULL,'SDSS J151432.05+532600.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000129,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,228.633583333,53.4335,0.017,NULL,59663910108,932248595,14566384,18.6),(128044,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128044,38.26,0.46,449,58636,70,NULL,NULL,'2MASX J15143226+0804073',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000177,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.634458333,8.06867,0.041,NULL,59352958661,927389979,14490468,17.1),(128045,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128045,37.95,0.46,389,58637,70,NULL,NULL,'2MASX J15143269+2311374',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000164,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,228.636208333,23.19389,0.129,NULL,59423361134,928490017,14507656,18.1),(128046,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128046,37.65,0.46,339,58638,70,NULL,NULL,'2MASX J15143268+1526545',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.636291667,15.44853,0.065,NULL,59572351540,930817992,14544031,18.1),(128047,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128047,37.46,0.46,311,58639,70,NULL,NULL,'SDSS J151433.90+183200.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.6412917,18.53356,0.089,NULL,59580179781,930940309,14545942,18),(128048,'Sosies','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128048,31.61,0.24,21,58640,NULL,NULL,NULL,'WKK 4748',NULL,'2002A&A...393...57T',2002,1,3.53,'Extended HIPASS source','G',0.00001,NULL,'13.9',0.93,'SBb?sp;ext.dust lane',NULL,NULL,NULL,NULL,1,228.6437917,-52.98886,NULL,NULL,46308339728,723567808,11305747,13.9),(128049,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128049,30.61,0.46,13.2,58640,NULL,NULL,'J','WKK 4748',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128050,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128050,31.12,0.4,16.8,58640,NULL,NULL,'mean','WKK 4748',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128051,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128051,37.37,0.46,298,58641,70,NULL,NULL,'2MASX J15143496+3104592',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000091,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,228.645583333,31.08308,0.033,NULL,60083966560,938811977,14668937,17.2),(128052,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128052,35.65,0.33,135,58642,70,NULL,NULL,'CGCG 077-049',NULL,'2015arXiv151105856S',2015,1,0.98,NULL,'G',0.000103,NULL,'14.7g',0.42,'S0',NULL,NULL,NULL,NULL,1,228.649666667,8.33394,0.045,NULL,59351837685,927372463,14490194,14.7),(128053,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128053,37.06,0.46,259,58643,70,NULL,NULL,'2MASX J15143710+2709060',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.39',0.16,NULL,NULL,NULL,NULL,NULL,1,228.6545,27.15172,0.077,NULL,59910392713,936099886,14626560,18.39),(128054,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128054,37.86,0.46,373,58644,70,NULL,NULL,'2MASX J15143787+2532450',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.6577917,25.54592,0.145,NULL,59896591890,935884248,14623191,17.5),(128055,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128055,39.03,0.46,640,58645,70,NULL,NULL,'SDSS J151439.59+021128.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.6649583,2.19119,0.053,NULL,56387508249,881054816,13766481,18.5),(128056,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128056,34.8,0.69,91,58646,100,NULL,'mid-IR','CGCG 165-035',NULL,'2013ApJ...771...88L',2013,1,0.8,NULL,'G',0.000015,NULL,'15.41',0.3,'S?',NULL,NULL,NULL,NULL,1,228.6657917,26.59419,0.097,NULL,59896191373,935877990,14623093,15.41),(128057,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128057,36.2,0.2,174,58646,74.4,NULL,NULL,'CGCG 165-035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128058,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128058,37.9,0.27,380,58647,70,NULL,NULL,'2MASX J15144139+0153451',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,228.672583333,1.89575,0.089,NULL,56387670715,881057354,13766521,17.9),(128059,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128059,37.33,0.46,292,58648,70,NULL,NULL,'2MASX J15144231+1235425',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.676375,12.59503,0.097,NULL,59568757659,930761838,14543153,17.6),(128060,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128060,37.48,0.46,313,58649,70,NULL,NULL,'2MASX J15144301+1842394',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,228.67925,18.71092,0.097,NULL,59580208917,930940764,14545949,NULL),(128061,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128061,37.94,0.46,387,58650,70,NULL,NULL,'2MASX J15144455+5138106',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,228.685625,51.63633,0.025,NULL,59661073384,932204271,14565691,17.1),(128062,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128062,35.65,0.46,135,58651,70,NULL,NULL,'2MASX J15144460+0606351',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,228.6857083,6.10978,0.049,NULL,59328529492,927008273,14484504,16.3),(128063,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128063,37.65,0.33,339,58652,70,NULL,NULL,'2MASX J15144508+0323201',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000093,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,228.6879583,3.389,0.057,NULL,56383002133,880984408,13765381,16.3),(128064,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128064,38.01,0.33,401,58653,70,NULL,NULL,'SDSS J151446.66+284628.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.80',0.16,NULL,NULL,NULL,NULL,NULL,1,228.694417,28.77453,0.045,NULL,59909160744,936080636,14626259,18.8),(128065,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128065,34.72,0.52,87.8,58654,70,NULL,NULL,'2MASX J15144710-0932171',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000077,NULL,'16.02',NULL,NULL,NULL,NULL,NULL,NULL,1,228.696166667,-9.53825,0.373,NULL,46486208488,726347007,11349171,16.02),(128066,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128066,35.59,0.46,131,58655,70,NULL,NULL,'2MASX J15144812+4339572',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000156,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,228.700708333,43.66594,0.029,NULL,59974571741,937102683,14642229,16.3),(128067,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128067,38.47,0.46,494,58656,70,NULL,NULL,'2MASX J15144852+4602332',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.702375,46.04247,0.033,NULL,59986361245,937286894,14645107,17.8),(128068,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128068,36.67,0.54,215,58657,70,NULL,NULL,'2MASX J15144894-0829061',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.83',NULL,NULL,NULL,NULL,NULL,NULL,1,228.703916667,-8.48517,0.321,NULL,46478932734,726233323,11347395,16.83),(128069,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128069,37.3,0.46,288,58658,70,NULL,NULL,'2MASX J15144924+5754265',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00009,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.7052083,57.90728,0.021,NULL,57720752587,901886759,14091980,17.3),(128070,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128070,37.1,0.27,263,58659,70,NULL,NULL,'2MASX J15144933+1017035',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000208,NULL,'15.5g',0.48,NULL,NULL,NULL,NULL,NULL,1,228.705667,10.28422,0.097,NULL,59357114936,927454920,14491483,15.5),(128071,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128071,37.46,0.27,311,58660,70,NULL,NULL,'2MASX J15144947+1516043',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,228.706125,15.26781,0.053,NULL,59572312315,930817379,14544021,16.9),(128072,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128072,37.94,0.17,387,58661,70,NULL,NULL,'2MASX J15145063+0350054',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00007,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.7110417,3.83464,0.041,NULL,56383850914,880997670,13765588,18.2),(128073,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128073,35.57,0.46,130,58662,70,NULL,NULL,'2MASX J15145064+3715095',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000164,NULL,'15.7g',0.33,'S0',NULL,NULL,NULL,NULL,1,228.711125,37.25258,0.009,NULL,60109482726,939210667,14675166,15.7),(128074,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128074,38.41,0.46,481,58663,70,NULL,NULL,'2MASX J15145073+3535433',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000182,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.711583,35.59525,0.041,NULL,60107452067,939178938,14674670,17.8),(128075,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128075,38.24,0.46,444,58664,70,NULL,NULL,'2MASX J15145098+1859154',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.7124583,18.98758,0.109,NULL,59534137357,930220896,14534701,17.7),(128076,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128076,37.1,0.27,263,58665,70,NULL,NULL,'2MASX J15145170+1015305',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000067,NULL,'15.6g',0.49,NULL,NULL,NULL,NULL,NULL,1,228.715333,10.25847,0.073,NULL,59357107968,927454812,14491481,15.6),(128077,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128077,37.98,0.1,394,58666,70,NULL,NULL,'2MASX J15145182+0417374',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000093,NULL,'16.5g',0.35,'E/S0',NULL,NULL,NULL,NULL,1,228.715833,4.29369,0.049,NULL,56383669523,880994836,13765544,16.5),(128078,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128078,37.98,0.1,394,58667,70,NULL,NULL,'2MASX J15145182+0407214',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00008,NULL,'17.6g',0.17,'S0',NULL,NULL,NULL,NULL,1,228.715958333,4.12269,0.045,NULL,56383996947,880999952,13765624,17.6),(128079,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128079,37.98,0.1,394,58668,70,NULL,NULL,'2MASX J15145390+0404234',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000072,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,228.7245,4.07317,0.045,NULL,56384002329,881000036,13765625,17.8),(128080,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128080,37.49,0.46,314,58669,70,NULL,NULL,'2MASX J15145480+2040474',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,228.728333,20.67972,0.133,NULL,59415771864,928371435,14505803,17.8),(128081,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128081,37.65,0.46,339,58670,70,NULL,NULL,'2MASX J15145540+0532465',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,228.730875,5.54622,0.077,NULL,59328569859,927008904,14484514,16.8),(128082,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128082,35.97,NULL,156,58671,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09782',NULL,'2010Ap&SS.325..163P',2010,1,0.99,NULL,'G',0.000081,NULL,'16.4g',0.21,'Sc',NULL,NULL,NULL,NULL,1,228.737583333,1.18789,0.097,NULL,56378292723,880910823,13764231,16.4),(128083,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128083,35.99,NULL,157,58671,NULL,NULL,'Dipole + Quadrupole','UGC 09782',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128084,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128084,36,NULL,159,58671,NULL,NULL,'Dipole','UGC 09782',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128085,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128085,36.02,0.49,160,58671,75,NULL,'IR','UGC 09782',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128086,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128086,38.01,0.33,401,58672,70,NULL,NULL,'2MASX J15145974+2851024',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000183,NULL,'17.57',0.22,'E',NULL,NULL,NULL,NULL,1,228.7487917,28.85067,0.045,NULL,59909147066,936080422,14626256,17.57),(128087,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128087,37.98,0.1,394,58673,70,NULL,NULL,'SDSS J151501.06+043358.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.754417,4.56625,0.053,NULL,56383660818,880994700,13765542,18.2),(128088,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128088,34.17,0.51,68.1,58674,70,NULL,NULL,'NGC 5880',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00006,NULL,'14.9b',0.3,'E1 or S0-',NULL,NULL,NULL,NULL,1,228.75475,-14.57903,0.485,NULL,46670681041,729229391,11394209,14.9),(128089,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128089,21.17,NULL,0.171,58675,NULL,NULL,NULL,'FGC 1869',NULL,'2000BSAO...50....5K',2000,1,1.15,NULL,'G',0.00007,NULL,'16.7g',0.13,'Sdm',NULL,NULL,NULL,NULL,1,228.760833,5.92817,0.077,1,59328682426,927010662,14484541,16.7),(128090,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128090,34.14,NULL,67.4,58675,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1869',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128091,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128091,34.15,NULL,67.6,58675,NULL,NULL,'Dipole + Quadrupole','FGC 1869',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128092,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128092,34.17,NULL,68.4,58675,NULL,NULL,'Dipole','FGC 1869',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128093,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128093,37.98,0.1,394,58676,70,NULL,NULL,'2MASX J15150292+0423465',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000069,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.762125,4.39611,0.053,NULL,56383673930,880994905,13765545,18.2),(128094,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128094,38.88,0.46,596,58677,70,NULL,NULL,'SDSS J151502.99+153540.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.7625,15.59447,0.061,NULL,59564783337,930699739,14542183,18.2),(128095,'Tully est','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128095,33,0.8,39.8,58678,75,NULL,'B','NGC 5899',NULL,'1988NBGC.C....0000T',1988,1,3.2,'The position in 1988BoPos.M...0000V is 5.5 arcsec south of the nucleus.','G',0.000017,NULL,'12.50',1.2,'SAB(rs)c       Sy2','in a pair',NULL,NULL,'AGN',1,228.763416667,42.04983,0.077,NULL,59973324254,937083191,14641924,12.5),(128096,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128096,32.35,0.46,29.5,58678,NULL,NULL,'J','NGC 5899',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128097,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128097,32.39,0.47,30.1,58678,NULL,NULL,'H','NGC 5899',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128098,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128098,32.4,0.45,30.2,58678,NULL,NULL,'K','NGC 5899',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128099,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128099,32.67,0.4,34.2,58678,75,NULL,NULL,'NGC 5899',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128100,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128100,32.96,0.4,39.2,58678,NULL,NULL,'mean','NGC 5899',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128101,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128101,32.99,0.49,39.7,58678,75,NULL,'IR','NGC 5899',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128102,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128102,33.02,0.4,40.2,58678,NULL,NULL,NULL,'NGC 5899',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128103,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128103,33.22,0.43,44,58678,75,NULL,'3.6 micron, color corrected','NGC 5899',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128104,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128104,33.28,0.2,45.3,58678,74.4,NULL,NULL,'NGC 5899',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128105,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128105,33.29,0.43,45.5,58678,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5899',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128106,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128106,33.32,0.4,46.2,58678,NULL,NULL,'Malmquist cor.','NGC 5899',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128107,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128107,33.47,0.37,49.4,58678,NULL,NULL,NULL,'NGC 5899',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128108,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128108,37.98,0.1,394,58679,70,NULL,NULL,'2MASX J15150372+0430315',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000097,NULL,'17.1g',0.24,'S0',NULL,NULL,NULL,NULL,1,228.7655417,4.50875,0.053,NULL,56383696106,880995251,13765550,17.1),(128109,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128109,32.22,0.46,27.7,58680,NULL,NULL,'J','NGC 5885',NULL,'2007A&A...465...71T',2007,1,3.5,'This is a part of the galaxy NGC 5885.','G',0.000004,NULL,'12.50',3.1,'SAB(r)c        HII',NULL,NULL,NULL,NULL,1,228.767333333,-10.086,0.441,NULL,46489273357,726394896,11349920,12.5),(128110,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128110,32.27,0.45,28.4,58680,NULL,NULL,'K','NGC 5885',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128111,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128111,32.34,0.4,29.3,58680,NULL,NULL,'mean','NGC 5885',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128112,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128112,32.35,0.47,29.5,58680,NULL,NULL,'H','NGC 5885',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128113,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128113,32.44,0.4,30.7,58680,75,NULL,'B','NGC 5885',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128114,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128114,32.9,0.4,37.9,58681,NULL,NULL,'mean','NGC 5900',NULL,'2007A&A...465...71T',2007,1,1.49,'HOLM 702B is a star.','G',0.000027,NULL,'14.8g',0.55,'Sb: sp         HII','in a pair',NULL,NULL,NULL,1,228.7715,42.20942,0.049,NULL,59973000098,937078126,14641845,14.8),(128115,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128115,33.24,0.45,44.5,58681,NULL,NULL,'K','NGC 5900',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128116,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128116,33.27,0.4,45,58681,75,NULL,NULL,'NGC 5900',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128117,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128117,33.33,0.43,46.3,58681,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5900',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128118,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128118,33.4,0.47,47.8,58681,NULL,NULL,'H','NGC 5900',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128119,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128119,33.6,0.46,52.4,58681,NULL,NULL,'J','NGC 5900',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128120,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128120,33.69,0.43,54.7,58681,75,NULL,'3.6 micron, color corrected','NGC 5900',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128121,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128121,33.8,0.4,57.5,58681,NULL,NULL,NULL,'NGC 5900',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128122,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128122,34.1,0.2,66.1,58681,74.4,NULL,NULL,'NGC 5900',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128123,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128123,34.21,0.47,69.6,58681,NULL,NULL,NULL,'NGC 5900',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128124,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128124,34.25,0.46,70.7,58681,NULL,NULL,'Malmquist cor.','NGC 5900',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128125,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128125,36.98,0.55,248,58682,70,NULL,NULL,'2MASX J15150615-3704445',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,228.77575,-37.07903,0.365,NULL,47191080092,737360626,11521259,15),(128126,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128126,37.65,0.33,339,58683,70,NULL,NULL,'2MASX J15150633+0332195',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000078,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,228.776375,3.53861,0.057,NULL,56383222290,880987848,13765435,17.4),(128127,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128127,37.31,0.27,290,58684,70,NULL,NULL,'2MASX J15150679+0519435',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,228.778166667,5.32883,0.077,NULL,59329020495,927015945,14484624,17.2),(128128,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128128,37.35,0.46,295,58685,70,NULL,NULL,'SDSS J151506.80+283602.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.778333,28.60069,0.053,NULL,59909182641,936080978,14626265,18.2),(128129,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128129,37.24,0.46,281,58686,70,NULL,NULL,'2MASX J15150758+3529115',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000163,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,228.7814583,35.48644,0.033,NULL,60106907612,939170431,14674537,16.9),(128130,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128130,38.68,0.46,544,58687,70,NULL,NULL,'2MASX J15150758+3107085',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,228.7817083,31.11897,0.033,NULL,60083992965,938812390,14668943,18),(128131,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128131,37.82,0.46,366,58688,70,NULL,NULL,'2MASX J15150784+3015115',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00016,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,228.782667,30.25308,0.037,NULL,59904872304,936013629,14625212,17.3),(128132,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128132,37.7,0.46,346,58689,70,NULL,NULL,'2MASX J15150803+3116486',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000188,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,228.783458333,31.28003,0.029,NULL,60084146940,938814795,14668981,16.5),(128133,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128133,34.76,0.53,89.4,58690,70,NULL,NULL,'2MASX J15150818-4321380',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00009,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,228.784125,-43.36053,0.477,NULL,47072857640,735513400,11492396,14.6),(128134,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128134,36.56,0.46,205,58691,70,NULL,NULL,'2MASX J15150900+0330095',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000121,NULL,'15.6g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,228.787667,3.50258,0.057,NULL,56383225060,880987891,13765435,15.6),(128135,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128135,36.12,0.46,168,58692,70,NULL,NULL,'2MASX J15150914-0158057',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00015,NULL,'16.4g',0.36,'E0',NULL,NULL,NULL,NULL,1,228.788167,-1.96822,0.221,NULL,45381995327,709093676,11079588,16.4),(128136,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128136,37.13,0.46,267,58693,70,NULL,NULL,'2MASX J15150948+3515575',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.789625,35.266,0.041,NULL,60106887542,939170117,14674533,17.2),(128137,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128137,37.31,0.27,290,58694,70,NULL,NULL,'2MASX J15150953+0520375',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,228.78975,5.34375,0.077,NULL,59329020115,927015939,14484624,16.5),(128138,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128138,37.98,0.1,394,58695,70,NULL,NULL,'2MASX J15150967+0420585',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000083,NULL,'17.6g',0.2,'E/S0',NULL,NULL,NULL,NULL,1,228.790417,4.34958,0.053,NULL,56383792640,880996760,13765574,17.6),(128139,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128139,36.13,0.09,168,58696,70,NULL,NULL,'CGCG 049-075',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000083,NULL,'15.3',NULL,NULL,NULL,NULL,NULL,NULL,1,228.795,5.57758,0.069,NULL,59328623467,927009741,14484527,15.3),(128140,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128140,37.31,0.27,290,58697,70,NULL,NULL,'2MASX J15151094+0512385',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,228.795625,5.21064,0.085,NULL,56380238883,880941232,13764706,16.7),(128141,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128141,37.94,0.17,387,58698,70,NULL,NULL,'2MASX J15151114+0350545',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000016,NULL,'15.9g',0.38,'AGN',NULL,NULL,NULL,NULL,1,228.796291667,3.8485,0.061,NULL,56383931232,880998925,13765608,15.9),(128142,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128142,37.58,0.33,328,58699,70,NULL,NULL,'2MASX J15151144-0032517',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000092,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,228.79775,-0.54767,0.173,NULL,45375837517,708997461,11078085,16.8),(128143,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128143,38.61,0.46,527,58700,70,NULL,NULL,'SDSS J151511.84+255209.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.1g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.799375,25.86939,0.153,NULL,59896672382,935885505,14623211,18.1),(128144,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128144,35.81,0.2,145,58701,74.4,NULL,NULL,'CGCG 135-037',NULL,'2013AJ....146...86T',2013,1,0.86,'GSC 2027-0289 (mag. 14) superposed 6\\\" south of nucleus.','G',0.000173,NULL,'15.5g',0.38,'S?',NULL,NULL,NULL,NULL,1,228.804167,25.00392,0.149,NULL,59410336731,928286511,14504476,15.5),(128145,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128145,35.44,0.52,123,58702,70,NULL,NULL,'2MASX J15151299-1252467',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.15',NULL,NULL,NULL,NULL,NULL,NULL,1,228.8042083,-12.87975,0.461,NULL,46663916745,729123699,11392557,16.15),(128146,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128146,37.94,0.17,387,58703,70,NULL,NULL,'2MASX J15151301+0354025',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000077,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,228.804375,3.90058,0.061,NULL,56383964991,880999452,13765616,18.1),(128147,'BCG','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128147,38.15,0.35,390,58704,60,NULL,'ABELL 2048, BCG','MCG +01-39-011',0.0945,'1980ApJ...241..486H',1980,1,0.46,NULL,'G',0.000083,NULL,'16.3g',0.39,'S0;BrClG','Brightest group member',NULL,NULL,NULL,1,228.808791667,4.38622,0.053,NULL,56383672489,880994882,13765545,16.3),(128148,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128148,37.98,0.1,394,58704,70,NULL,NULL,'MCG +01-39-011',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128149,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128149,37.94,0.17,387,58705,70,NULL,NULL,'SDSS J151514.69+035017.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000069,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,228.81125,3.83825,0.061,NULL,56383934096,880998970,13765608,18.2),(128150,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128150,36.15,0.46,170,58706,70,NULL,NULL,'2MASX J15151474+2427335',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,228.811541667,24.45933,0.097,NULL,59411125876,928298841,14504669,17.2),(128151,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128151,37.9,0.27,380,58707,70,NULL,NULL,'2MASX J15151528+0202455',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.8137917,2.04603,0.073,NULL,56384709971,881011093,13765798,17.8),(128152,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128152,37.41,0.46,303,58708,70,NULL,NULL,'2MASX J15151533+0940305',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,228.813917,9.67519,0.069,NULL,59353976704,927405886,14490716,17.3),(128153,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128153,36.58,0.46,207,58709,70,NULL,NULL,'2MASX J15151569+2704315',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.02',0.27,NULL,NULL,NULL,NULL,NULL,1,228.815417,27.0755,0.077,NULL,59910397201,936099956,14626561,17.02),(128154,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128154,37.91,0.46,383,58710,70,NULL,NULL,'SDSS J151516.30+035910.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000078,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.817958333,3.98625,0.061,NULL,56383976024,880999625,13765619,18),(128155,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128155,37.94,0.17,387,58711,70,NULL,NULL,'SDSS J151516.39+035615.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000083,NULL,'18.7g',0.09,NULL,NULL,NULL,NULL,NULL,1,228.818291667,3.93772,0.061,NULL,56383978483,880999663,13765619,18.7),(128156,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128156,37.17,0.46,272,58712,70,NULL,NULL,'2MASX J15151640+1750135',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,228.8184583,17.83719,0.081,NULL,59580689832,930948278,14546066,16.8),(128157,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128157,37.76,0.27,356,58713,70,NULL,NULL,'SDSS J151517.08+484408.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000145,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.8212083,48.73569,0.025,NULL,59940566073,936571344,14633927,18.5),(128158,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128158,37.72,0.46,350,58714,70,NULL,NULL,'2MASX J15151712+1423435',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,228.821375,14.3955,0.093,NULL,59575522648,930867541,14544805,16.8),(128159,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128159,37.98,0.1,394,58715,70,NULL,NULL,'2MASX J15151749+0423495',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000107,NULL,'16.7g',0.3,'E/S0',NULL,NULL,NULL,NULL,1,228.822917,4.39697,0.053,NULL,56383672322,880994880,13765545,16.7),(128160,'BCG','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128160,38.15,0.35,390,58716,60,NULL,NULL,'ABELL 2048',0.0945,'1980ApJ...241..486H',1980,1,NULL,'Katgert (1996,A&A,310,8) identifies multiple redshift systems in this cluster.','GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,228.824417,4.38225,0.053,NULL,56383791255,880996738,13765574,NULL),(128161,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128161,37.71,0.46,349,58717,70,NULL,NULL,'2MASX J15151800+0813097',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.824875,8.21939,0.053,NULL,59353002856,927390669,14490479,17.6),(128162,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128162,37.98,0.1,394,58718,70,NULL,NULL,'2MASX J15151817+0418374',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000096,NULL,'17.1g',0.23,'S0',NULL,NULL,NULL,NULL,1,228.825667,4.31031,0.053,NULL,56383794043,880996781,13765574,17.1),(128163,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128163,35.39,0.62,120,58719,70,NULL,NULL,'LCRS B151233.5-121327',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00012,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,228.8257917,-12.40883,0.473,NULL,46663959978,729124374,11392568,16.3),(128164,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128164,38.04,0.33,405,58720,70,NULL,NULL,'2MASX J15151851+0342074',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000095,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,228.827208333,3.70194,0.041,NULL,56383070157,880985471,13765397,17.2),(128165,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128165,38.18,0.46,433,58721,70,NULL,NULL,'2MASX J15151859+5446286',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,228.8277083,54.77475,0.013,NULL,57581000226,899703128,14057861,17.7),(128166,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128166,37.08,0.46,260,58722,70,NULL,NULL,'2MASX J15151920+2435415',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000177,NULL,'17.41',0.26,NULL,NULL,NULL,NULL,NULL,1,228.830166667,24.59481,0.109,NULL,59411097912,928298404,14504662,17.41),(128167,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128167,36.16,0.46,170,58723,70,NULL,NULL,'2MASX J15151923+0543134',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000037,NULL,'16.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.8302083,5.72044,0.069,NULL,59328582568,927009102,14484517,16.6),(128168,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128168,37.42,0.46,305,58724,70,NULL,NULL,'2MASX J15151934+3049006',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000178,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.830625,30.81692,0.037,NULL,60083929326,938811395,14668928,17),(128169,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128169,36.41,0.46,192,58725,70,NULL,NULL,'2MASX J15151985+3518276',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000161,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,228.832917,35.30764,0.041,NULL,60106915910,939170561,14674540,16.3),(128170,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128170,37.98,0.1,394,58726,70,NULL,NULL,'2MASX J15152098+0421504',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000103,NULL,'17.0g',0.26,'E/S0',NULL,NULL,NULL,NULL,1,228.837417,4.36389,0.053,NULL,56383824340,880997255,13765582,17),(128171,'SNIa','2016-12-15 15:15:32','2016-12-16 11:20:46','1','SN 1963O','R',128171,35.25,NULL,112,58727,NULL,NULL,'Photographic','NGC 5905',NULL,'1988SSRv...48....1R',1988,1,4,NULL,'G',0.000017,NULL,'12.49',2.6,'SB(r)b;HII     Sy1','Pair member, radial velocity confirmed',NULL,NULL,'H II',1,228.847167,55.51736,0.017,NULL,57582715295,899729926,14058280,12.49),(128172,'Ring Diameter','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128172,32.6,0.84,33,58727,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5905',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128173,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128173,32.67,0.69,34.2,58727,100,NULL,'mid-IR','NGC 5905',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128174,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128174,33.13,0.52,42.3,58727,NULL,NULL,'Malmquist cor.','NGC 5905',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128175,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128175,33.27,0.48,45,58727,NULL,NULL,NULL,'NGC 5905',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128176,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128176,33.34,0.2,46.6,58727,74.4,NULL,NULL,'NGC 5905',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128177,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128177,33.4,0.45,47.9,58727,NULL,NULL,'K','NGC 5905',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128178,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128178,33.43,0.46,48.5,58727,NULL,NULL,'J','NGC 5905',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128179,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128179,33.44,0.47,48.8,58727,NULL,NULL,'H','NGC 5905',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128180,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128180,33.57,0.4,51.8,58727,NULL,NULL,'mean','NGC 5905',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128181,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128181,37.58,0.46,328,58728,70,NULL,NULL,'SDSS J151523.42+284057.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.847625,28.68256,0.053,NULL,59909181648,936080963,14626265,18.5),(128182,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128182,37.58,0.33,328,58729,70,NULL,NULL,'SDSS J151523.61-003243.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000075,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,228.848417,-0.54542,0.173,NULL,45375843017,708997547,11078086,18.2),(128183,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128183,37.98,0.1,394,58730,70,NULL,NULL,'SDSS J151523.97+043115.8',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,228.849917,4.52106,0.053,NULL,56383651642,880994556,13765539,NULL),(128184,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128184,38.95,0.46,616,58731,70,NULL,NULL,'2MASX J15152444-0020248',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.5g',0.24,'NLAGN',NULL,NULL,NULL,NULL,1,228.851916667,-0.34019,0.161,NULL,45375765204,708996331,11078067,17.5),(128185,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128185,37.98,0.1,394,58732,70,NULL,NULL,'2MASX J15152466+0423474',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000076,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.8527083,4.3965,0.053,NULL,56383824502,880997257,13765582,18),(128186,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128186,37.98,0.46,394,58733,70,NULL,NULL,'2MASX J15152548+0801387',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000145,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.856333,8.0275,0.049,NULL,59353010516,927390789,14490481,17.8),(128187,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128187,38.05,0.17,407,58734,70,NULL,NULL,'SDSS J151525.55+015903.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.8g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.8564583,1.98428,0.073,NULL,56384702113,881010970,13765796,17.8),(128188,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128188,37.23,0.46,280,58735,70,NULL,NULL,'2MASX J15152584+1551535',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'16.64',0.4,NULL,NULL,NULL,NULL,NULL,1,228.857625,15.86497,0.041,NULL,59564828716,930700448,14542194,16.64),(128189,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128189,37.25,0.46,281,58736,70,NULL,NULL,'2MASX J15152588-0158388',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.85775,-1.97736,0.221,NULL,45378537978,709039655,11078744,17.7),(128190,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128190,37.77,0.33,358,58737,70,NULL,NULL,'2MASX J15152587+3154306',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00018,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.857833,31.90844,0.049,NULL,60084436668,938819322,14669051,17.1),(128191,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128191,37.37,0.27,298,58738,70,NULL,NULL,'2MASX J15152598+1700235',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,228.85825,17.00656,0.109,NULL,59567201561,930737524,14542773,16.9),(128192,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128192,36.99,0.46,250,58739,70,NULL,NULL,'2MASX J15152734+1752552',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,228.863917,17.882,0.081,NULL,59580692061,930948313,14546067,17.8),(128193,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128193,37.94,0.17,387,58740,70,NULL,NULL,'2MASX J15152740+0356214',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000115,NULL,'15.8g',0.42,'AGN',NULL,NULL,NULL,NULL,1,228.864083,3.93928,0.061,NULL,56383940588,880999071,13765610,15.8),(128194,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128194,38.37,0.46,473,58741,70,NULL,NULL,'2MASX J15152841+3343295',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000168,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,228.868583333,33.72489,0.057,NULL,60113110229,939267347,14676052,18.4),(128195,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128195,37.1,0.27,263,58742,70,NULL,NULL,'2MASX J15152863+1014518',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.8692917,10.24789,0.073,NULL,59357132542,927455195,14491487,16.6),(128196,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128196,37.09,0.46,262,58743,70,NULL,NULL,'2MASX J15152871+3121336',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00019,NULL,'16.1g',0.33,'E0',NULL,NULL,NULL,NULL,1,228.869666667,31.35931,0.029,NULL,60084176649,938815260,14668988,16.1),(128197,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128197,38.04,0.33,405,58744,70,NULL,NULL,'2MASX J15153020+0350054',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000123,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,228.876,3.83478,0.061,NULL,56383936593,880999009,13765609,16.9),(128198,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128198,36.13,0.63,168,58745,70,NULL,NULL,'2MASX J15153096-2153002',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,228.879041667,-21.88333,0.441,NULL,46616958253,728389972,11381093,15.6),(128199,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128199,37.36,0.33,296,58746,70,NULL,NULL,'2MASX J15153099+2826415',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.15',0.21,NULL,NULL,NULL,NULL,NULL,1,228.879041667,28.44494,0.049,NULL,59909310142,936082970,14626296,18.15),(128200,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128200,37.27,0.46,284,58747,70,NULL,NULL,'2MASX J15153166+2049423',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.80',0.19,NULL,NULL,NULL,NULL,NULL,1,228.8819583,20.82842,0.145,NULL,59415886618,928373228,14505831,17.8),(128201,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128201,34.06,0.51,64.8,58748,70,NULL,NULL,'2MASX J15153172-4353259',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000087,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,228.882083,-43.89053,0.609,NULL,47070727660,735480119,11491876,14.7),(128202,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128202,37.19,0.46,274,58749,70,NULL,NULL,'SDSS J151532.07-000020.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000071,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,228.883667,-0.00578,0.165,NULL,45375570099,708993282,11078020,18),(128203,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128203,37.2,0.27,276,58750,70,NULL,NULL,'2MASX J15153432+0137064',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,228.892875,1.61856,0.081,NULL,56384555179,881008674,13765760,16.6),(128204,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128204,37.98,0.1,394,58751,70,NULL,NULL,'SDSS J151534.57+042140.9',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000075,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,228.8940417,4.36136,0.053,NULL,56383828421,880997319,13765583,18.7),(128205,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128205,37.98,0.46,394,58752,70,NULL,NULL,'2MASX J15153500+4629360',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,228.8957083,46.49347,0.069,NULL,59986216084,937284626,14645072,17.1),(128206,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128206,36.34,0.57,185,58753,70,NULL,NULL,'2MFGC 12340',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,228.896125,-21.89975,0.441,NULL,46616968670,728390135,11381095,15.5),(128207,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128207,37.36,0.33,296,58754,70,NULL,NULL,'2MASX J15153667+2826505',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.29',0.18,NULL,NULL,NULL,NULL,NULL,1,228.902791667,28.44731,0.049,NULL,59909312222,936083003,14626296,18.29),(128208,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128208,36.73,0.46,222,58755,70,NULL,NULL,'2MASX J15153668+1249285',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'16.91',0.45,NULL,NULL,NULL,NULL,NULL,1,228.902833,12.82464,0.089,NULL,59568683198,930760674,14543135,16.91),(128209,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128209,37.63,0.46,336,58756,70,NULL,NULL,'2MASX J15153718-0031098',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000092,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,228.9050417,-0.51947,0.221,NULL,45375724890,708995701,11078057,17),(128210,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128210,35.8,0.46,144,58757,70,NULL,NULL,'2MASX J15153770+2605495',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000364,NULL,'16.77',0.17,NULL,NULL,NULL,NULL,NULL,1,228.907333,26.09711,0.141,NULL,59896634764,935884918,14623201,16.77),(128211,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128211,37.98,0.1,394,58758,70,NULL,NULL,'2MASX J15153823+0420234',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000114,NULL,'17.2g',0.23,'E/S0',NULL,NULL,NULL,NULL,1,228.9092083,4.33978,0.053,NULL,56383831544,880997367,13765583,17.2),(128212,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128212,37.66,0.46,340,58759,70,NULL,NULL,'2MASX J15153823+2948405',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.89',0.15,NULL,NULL,NULL,NULL,NULL,1,228.909333,29.81133,0.037,NULL,59904915211,936014300,14625223,18.89),(128213,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128213,36.54,0.46,203,58760,70,NULL,NULL,'2MASX J15153830+0010324',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000071,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,228.909583,0.17561,0.157,NULL,56378224886,880909763,13764215,17.1),(128214,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128214,36.84,0.46,234,58761,70,NULL,NULL,'2MASX J15153839+3129574',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000159,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,228.910083333,31.49922,0.029,NULL,60084180576,938815321,14668989,16.7),(128215,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128215,37.53,0.46,320,58762,70,NULL,NULL,'2MASX J15153852+0515274',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.9104583,5.25767,0.077,NULL,56380813314,880950208,13764847,17.8),(128216,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128216,37.77,0.33,358,58763,70,NULL,NULL,'2MASX J15153904+3156324',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.70',0.23,NULL,NULL,NULL,NULL,NULL,1,228.9125,31.94225,0.049,NULL,60084426541,938819164,14669049,17.7),(128217,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128217,36.61,0.46,210,58764,70,NULL,NULL,'2MASX J15154086+5314545',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,228.920333,53.24833,0,NULL,59663138748,932236542,14566195,17),(128218,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128218,37.98,0.1,394,58765,70,NULL,NULL,'SDSS J151542.05+040543.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000074,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.92525,4.09542,0.081,NULL,56383991036,880999859,13765622,18),(128219,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128219,32.59,NULL,33,58766,72,NULL,NULL,'UGC 09787',NULL,'2014Ap.....57..457K',2014,1,1.1,NULL,'G',0.000033,NULL,'14.70',0.8,'SABm:',NULL,NULL,NULL,NULL,1,228.928667,1.4555,0.081,NULL,56378786906,880918545,13764352,14.7),(128220,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128220,37.26,0.46,283,58767,70,NULL,NULL,'2MASX J15154328+3104474',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,228.930417,31.07997,0.033,NULL,60083990219,938812347,14668942,17.5),(128221,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128221,36.86,0.46,236,58768,70,NULL,NULL,'2MASX J15154336+1308293',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,228.930583,13.14147,0.101,NULL,59573604016,930837562,14544336,17),(128222,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128222,36.48,0.33,198,58769,70,NULL,NULL,'2MASX J15154355+0258034',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.53',0.41,NULL,NULL,NULL,NULL,NULL,1,228.931333333,2.9675,0.069,NULL,56384505999,881007906,13765748,16.53),(128223,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128223,37.37,0.27,298,58770,70,NULL,NULL,'2MASX J15154373+1702033',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'16.80',0.46,NULL,NULL,NULL,NULL,NULL,1,228.932083,17.03425,0.109,NULL,59567208822,930737637,14542775,16.8),(128224,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128224,35.61,0.6,132,58771,70,NULL,NULL,'2MASX J15154537-3828501',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,228.9389583,-38.48058,0.293,NULL,47189076144,737329314,11520770,15.4),(128225,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128225,35.27,0.46,113,58772,70,NULL,NULL,'CGCG 077-051',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000237,NULL,'15.5',0.61,NULL,NULL,NULL,NULL,NULL,1,228.9399583,12.15997,0.089,NULL,59347545643,927305400,14489146,15.5),(128226,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128226,37.37,0.27,298,58773,70,NULL,NULL,'2MASX J15154673+1659573',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,228.944708333,16.99928,0.109,NULL,59567207005,930737609,14542775,17.1),(128227,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128227,36.13,0.09,168,58774,70,NULL,NULL,'SDSS J151547.43+065809.4',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000043,NULL,'15.1',0.29,NULL,'Group member',NULL,NULL,NULL,1,228.947666667,6.96928,0.041,NULL,59350269600,927347962,14489811,15.1),(128228,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128228,36.19,0.4,173,58775,NULL,NULL,'mean','UGC 09793',NULL,'2007A&A...465...71T',2007,1,1.37,NULL,'G',0.000009,NULL,'15.74',0.18,'Sbc',NULL,NULL,NULL,NULL,1,228.950417,18.37858,0.101,NULL,59580260739,930941574,14545962,15.74),(128229,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128229,36.21,NULL,175,58775,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09793',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128230,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128230,36.23,NULL,176,58775,NULL,NULL,'Dipole + Quadrupole','UGC 09793',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128231,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128231,36.24,NULL,177,58775,NULL,NULL,NULL,'UGC 09793',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128232,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128232,36.25,0.49,178,58775,75,NULL,'IR','UGC 09793',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128233,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128233,36.26,NULL,178,58775,NULL,NULL,'Dipole','UGC 09793',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128234,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128234,36.36,0.47,187,58775,NULL,NULL,'H','UGC 09793',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128235,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128235,36.43,0.45,193,58775,NULL,NULL,'K','UGC 09793',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128236,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128236,36.83,0.2,232,58775,74.4,NULL,NULL,'UGC 09793',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128237,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128237,37.97,0.46,393,58776,70,NULL,NULL,'2MASX J15155010+2801024',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.75',0.16,NULL,NULL,NULL,NULL,NULL,1,228.9587083,28.01733,0.069,NULL,59909132363,936080193,14626253,18.75),(128238,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128238,38.52,0.46,506,58777,70,NULL,NULL,'2MASX J15155028+2641204',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'BrClG',NULL,NULL,NULL,NULL,1,228.959458333,26.68903,0.093,NULL,59910109089,936095454,14626491,NULL),(128239,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128239,35.42,0.59,121,58778,70,NULL,NULL,'2MASX J15155036-3909008',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.8I',0.4,NULL,NULL,NULL,NULL,NULL,1,228.96,-39.15025,0.257,NULL,47187348366,737302318,11520348,13.8),(128240,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128240,37.2,0.27,276,58779,70,NULL,NULL,'2MASX J15155059+0133421',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'16.80',0.34,NULL,NULL,NULL,NULL,NULL,1,228.960666667,1.56181,0.081,NULL,56376954038,880889906,13763904,16.8),(128241,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128241,37.76,0.46,356,58780,70,NULL,NULL,'2MASX J15155056+2448214',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000195,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,228.96075,24.80581,0.121,NULL,59410422087,928287845,14504497,17.1),(128242,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128242,37.61,0.46,333,58781,70,NULL,NULL,'SDSS J151550.66+062031.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000047,NULL,'17.5R',0.14,NULL,NULL,NULL,NULL,NULL,1,228.961083,6.34203,0.033,NULL,59382977101,927859017,14497797,17.5),(128243,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128243,37.39,0.33,301,58782,70,NULL,NULL,'2MASX J15155092+1531193',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,228.962333,15.52194,0.065,NULL,59572240725,930816261,14544004,16.8),(128244,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128244,36.97,0.46,248,58783,70,NULL,NULL,'2MASX J15155121+0208261',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,228.963375,2.1405,0.093,NULL,56384725780,881011340,13765802,16.7),(128245,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128245,36.13,0.09,168,58784,70,NULL,NULL,'2MASX J15155149+0701008',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000036,NULL,'15.30',0.6,'S0','Group member',NULL,NULL,NULL,1,228.964583,7.01694,0.041,NULL,59350264128,927347877,14489810,15.3),(128246,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128246,36.29,0.25,181,58784,74.4,NULL,NULL,'2MASX J15155149+0701008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128247,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128247,38,0.46,399,58785,70,NULL,NULL,'2MASX J15155189+4904296',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00016,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,228.966125,49.075,0.033,NULL,59940380685,936568448,14633882,17.1),(128248,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128248,34.81,0.5,91.5,58786,NULL,NULL,'Malmquist cor.','ESO 328- G 037',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'13.03',0.7,'Sb',NULL,NULL,NULL,NULL,1,228.9687917,-40.10442,0.117,NULL,47187619913,737306561,11520415,13.03),(128249,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128249,34.87,0.49,94.3,58786,NULL,NULL,NULL,'ESO 328- G 037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128250,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128250,34.91,0.2,95.9,58786,74.4,NULL,NULL,'ESO 328- G 037',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128251,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128251,35.25,0.4,112,58786,NULL,NULL,'mean','ESO 328- G 037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128252,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128252,35.4,0.47,120,58786,NULL,NULL,'H','ESO 328- G 037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128253,'TRGB','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128253,31.13,0.1,16.8,58787,NULL,NULL,'I','NGC 5907',NULL,'2011ApJS..195...18R',2011,1,12.77,'NGC 5906 is the part of NGC 5907 west of the dust lane.','G',0.00001,NULL,'11.12',1.4,'SA(s)c: sp     HII:','X-ray-faint group member',NULL,NULL,NULL,1,228.974041667,56.32878,0.013,NULL,57582416133,899725252,14058207,11.12),(128254,'TRGB','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128254,31.17,0.09,17.1,58787,74.4,NULL,NULL,'NGC 5907',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128255,'IRAS','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128255,30.52,0.27,12.7,58787,NULL,NULL,NULL,'NGC 5907',NULL,'2000AJ....119.1701Z',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128256,'IRAS','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128256,30.86,0.8,14.9,58787,75,NULL,'A82, H','NGC 5907',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128257,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128257,30.32,NULL,11.6,58787,75,NULL,'CO','NGC 5907',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128258,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128258,30.4,NULL,12,58787,75,NULL,'HI','NGC 5907',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128259,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128259,30.57,0.4,13,58787,75,NULL,NULL,'NGC 5907',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128260,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128260,30.64,0.35,13.4,58787,NULL,NULL,NULL,'NGC 5907',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128261,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128261,30.86,0.4,14.9,58787,75,NULL,'B','NGC 5907',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128262,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128262,30.87,0.31,14.9,58787,NULL,NULL,NULL,'NGC 5907',NULL,'2000AJ....119.1701Z',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128263,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128263,30.91,0.4,15.2,58787,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 5907',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128264,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128264,31.08,0.43,16.5,58787,75,NULL,'3.6 micron, color corrected','NGC 5907',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128265,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128265,31.1,0.43,16.6,58787,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5907',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128266,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128266,31.15,NULL,17,58787,NULL,NULL,'Dipole','NGC 5907',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128267,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128267,31.16,NULL,17.1,58787,NULL,NULL,'Dipole + Quadrupole','NGC 5907',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128268,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128268,31.16,NULL,17.1,58787,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 5907',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128269,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128269,31.17,0.47,17.1,58787,75,NULL,'A82, H, raw','NGC 5907',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128270,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128270,31.17,0.09,17.1,58787,74.4,NULL,NULL,'NGC 5907',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128271,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128271,31.24,NULL,17.7,58787,NULL,NULL,NULL,'NGC 5907',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128272,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128272,31.37,0.47,18.8,58787,75,NULL,'A82, H, inv','NGC 5907',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128273,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128273,31.48,0.47,19.8,58787,75,NULL,'A82, H, cor','NGC 5907',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128274,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128274,37.77,0.46,359,58788,70,NULL,NULL,'2MASX J15155426+1815193',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,228.9760417,18.25531,0.081,NULL,59580284028,930941937,14545967,16.3),(128275,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128275,37.72,0.33,350,58789,70,NULL,NULL,'SDSS J151554.59+475355.1',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.7g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.9775,47.89867,0.041,NULL,59937353658,936521150,14633142,16.7),(128276,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128276,38.05,0.17,407,58790,70,NULL,NULL,'SDSS J151554.88+020029.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.978667,2.00825,0.073,NULL,56384812038,881012688,13765823,17.6),(128277,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128277,37.68,0.46,344,58791,70,NULL,NULL,'2MASX J15155545+1413234',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,228.981,14.22308,0.097,NULL,59575576779,930868387,14544818,NULL),(128278,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128278,37.87,0.46,375,58792,70,NULL,NULL,'2MASX J15155621+0535331',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,228.98425,5.59244,0.069,NULL,56379940253,880936566,13764633,17.1),(128279,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128279,37.2,0.27,276,58793,70,NULL,NULL,'2MASX J15155633+0129551',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,228.98475,1.49869,0.081,NULL,56378799980,880918749,13764355,16.7),(128280,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128280,37.72,0.33,350,58794,70,NULL,NULL,'2MASX J15155463+4753551',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000177,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,228.9874583,47.90153,0.041,NULL,59937353121,936521142,14633142,18.6),(128281,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128281,37.83,0.46,368,58795,70,NULL,NULL,'2MASX J15155718+0041441',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000096,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,228.988125,0.69564,0.125,NULL,56378526530,880914477,13764288,16.8),(128282,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128282,38.09,0.46,415,58796,70,NULL,NULL,'SDSS J151557.27+191856.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.988625,19.31569,0.105,NULL,59534079620,930219994,14534687,18.6),(128283,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128283,37.18,0.46,273,58797,70,NULL,NULL,'2MASX J15155803+1943133',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,228.9917083,19.72033,0.109,NULL,59412919966,928326874,14505107,16.9),(128284,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128284,38.05,0.17,407,58798,70,NULL,NULL,'2MASX J15155808+0200211',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.9920417,2.00597,0.073,NULL,56384800901,881012514,13765820,17.8),(128285,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128285,38.13,0.46,422,58799,70,NULL,NULL,'2MASX J15155861-0034452',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000075,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,228.994167,-0.57922,0.221,NULL,45375694968,708995233,11078050,18.4),(128286,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128286,35.57,0.66,130,58800,70,NULL,NULL,'2MASX J15155892-0801291',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,228.995583333,-8.02475,0.321,NULL,46480951987,726264874,11347888,15),(128287,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128287,37.65,0.46,340,58801,70,NULL,NULL,'2MASX J15155953+2156330',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,228.998125,21.94264,0.145,NULL,59415036465,928359944,14505624,18),(128288,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128288,36.05,0.46,162,58802,70,NULL,NULL,'2MASX J15155957+0739538',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00017,NULL,'16.1g',0.35,NULL,'Group member',NULL,NULL,NULL,1,228.998166667,7.66481,0.049,NULL,59350083180,927345049,14489766,16.1),(128289,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128289,37.78,0.46,360,58803,70,NULL,NULL,'2MASX J15155980+5153176',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000173,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,228.9995417,51.88828,0.033,NULL,59660910301,932201723,14565651,17),(128290,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128290,37.5,0.46,317,58804,70,NULL,NULL,'2MASX J15155988+3019424',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,228.999666667,30.32833,0.017,NULL,59904837217,936013081,14625204,17.4),(128291,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128291,37.69,0.46,345,58805,70,NULL,NULL,'2MASX J15160025+0344421',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.001,3.74508,0.061,NULL,56383058266,880985285,13765395,16.9),(128292,'IRAS','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128292,36.05,0.8,162,58806,75,NULL,'CF, r','UGC 09800',NULL,'1997ApJS..109..333W',1997,1,1.11,'1997AJ....114.2402C has z = 0.0452.','G',0.00016,NULL,'14.7g',0.56,'Sb',NULL,NULL,NULL,NULL,1,229.003875,54.48228,0.013,NULL,59662357867,932224341,14566005,14.7),(128293,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128293,36.26,0.38,178,58806,75,NULL,'CF, r, raw','UGC 09800',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128294,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128294,36.49,0.38,199,58806,75,NULL,'CF, r, cor','UGC 09800',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128295,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128295,36.52,0.38,201,58806,75,NULL,'CF, r, inv','UGC 09800',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128296,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128296,37.91,0.46,382,58807,70,NULL,NULL,'2MASX J15160105+5740003',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000082,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.004625,57.66667,0.025,NULL,57720876306,901888692,14092010,17.1),(128297,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128297,38.05,0.17,407,58808,70,NULL,NULL,'2MASX J15160135+0201001',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'16.92',NULL,'BrClG          AGN',NULL,NULL,NULL,'Sy',1,229.0057083,2.01672,0.073,NULL,56384812461,881012694,13765823,16.92),(128298,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128298,37.33,0.58,293,58809,70,NULL,NULL,'2MASX J15160189-0829541',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.80',NULL,NULL,NULL,NULL,NULL,NULL,1,229.00775,-8.4985,0.317,NULL,46480370422,726255787,11347746,16.8),(128299,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128299,37.4,0.33,301,58810,70,NULL,NULL,'2MASX J15160230+2912424',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,229.009667,29.21178,0.033,NULL,59904537284,936008395,14625131,NULL),(128300,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128300,35.84,0.46,147,58811,70,NULL,NULL,'2MASX J15160242+0447291',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.0g',0.4,NULL,NULL,NULL,NULL,NULL,1,229.010041667,4.79147,0.057,NULL,56380682283,880948160,13764815,16),(128301,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128301,36.46,0.78,196,58812,70,NULL,NULL,'LCRS B151323.4-062635',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.58',NULL,NULL,NULL,NULL,NULL,NULL,1,229.012375,-6.62719,0.245,NULL,46477187267,726206051,11346969,15.58),(128302,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128302,37.51,0.46,317,58813,70,NULL,NULL,'2MASX J15160353+2556194',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.45',0.15,NULL,NULL,NULL,NULL,NULL,1,229.014708333,25.93889,0.153,NULL,59895782874,935871607,14622993,18.45),(128303,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128303,36.11,0.46,167,58814,70,NULL,NULL,'2MASX J15160443+0510081',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,229.018583,5.16883,0.081,NULL,56380792844,880949888,13764842,16.6),(128304,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128304,37.62,0.33,334,58815,70,NULL,NULL,'2MASX J15160505+4605111',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000138,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.0212083,46.08636,0.049,NULL,59986386677,937287291,14645113,17.5),(128305,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128305,36.74,0.46,222,58816,70,NULL,NULL,'2MASX J15160517+3217074',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.0215,32.28556,0.049,NULL,60084371073,938818298,14669035,17.5),(128306,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128306,37.96,0.33,390,58817,70,NULL,NULL,'2MASX J15160525+2732124',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.87',0.13,NULL,NULL,NULL,NULL,NULL,1,229.021875,27.53672,0.077,NULL,59910539115,936102173,14626596,18.87),(128307,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128307,37.51,0.33,318,58818,70,NULL,NULL,'SDSS J151606.51+154338.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.027125,15.72744,0.065,NULL,59564839709,930700620,14542197,18.2),(128308,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128308,37.35,0.46,295,58819,70,NULL,NULL,'2MASX J15160675+1723374',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,229.02825,17.39358,0.105,NULL,59563827131,930684798,14541949,16.7),(128309,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128309,37.39,0.33,301,58820,70,NULL,NULL,'2MASX J15160794+1527313',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.033167,15.45867,0.061,NULL,59572255137,930816486,14544007,17.2),(128310,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128310,38.05,0.17,407,58821,70,NULL,NULL,'SDSS J151608.32+020756.4',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,229.034666667,2.13233,0.093,NULL,56384755131,881011798,13765809,NULL),(128311,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128311,37.96,0.33,390,58822,70,NULL,NULL,'2MASX J15160901+2729194',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.60',0.17,NULL,NULL,NULL,NULL,NULL,1,229.0375,27.48864,0.077,NULL,59910616455,936103382,14626615,18.6),(128312,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128312,36.13,0.09,168,58823,70,NULL,NULL,'I Zw 104',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'17.3',0.32,NULL,NULL,NULL,NULL,NULL,1,229.0392917,6.01514,0.069,NULL,59328493426,927007709,14484495,17.3),(128313,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128313,38.2,0.46,436,58824,70,NULL,NULL,'2MASX J15160980+4131511',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.0407917,41.531,0.013,NULL,59971570163,937055783,14641496,17.7),(128314,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128314,35.27,0.52,113,58825,NULL,NULL,NULL,'ESO 328- G 039',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.7b',0.5,'S...',NULL,NULL,NULL,NULL,1,229.040875,-41.82411,0.437,NULL,47067457767,735429027,11491078,15.7),(128315,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128315,35.31,0.51,115,58825,NULL,NULL,'Malmquist cor.','ESO 328- G 039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128316,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128316,35.31,0.2,115,58825,74.4,NULL,NULL,'ESO 328- G 039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128317,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128317,35.76,0.25,142,58826,74.4,NULL,NULL,'GIN 422',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000047,NULL,'14.97',0.6,'S','Group member',NULL,NULL,NULL,1,229.0407917,6.96458,0.041,NULL,59350313398,927348646,14489822,14.97),(128318,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128318,35.99,0.21,158,58826,70,NULL,NULL,'GIN 422',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128319,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128319,38.3,0.46,456,58827,70,NULL,NULL,'SDSS J151609.87+311307.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000151,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,229.041166667,31.21867,0.017,NULL,60083946984,938811671,14668932,18.6),(128320,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128320,35.76,0.25,142,58828,74.4,NULL,NULL,'GIN 423',NULL,'2013AJ....146...86T',2013,1,0.57,NULL,'G',0.00004,NULL,'15.9g',0.38,'S','Group member',NULL,NULL,NULL,1,229.041375,6.95153,0.041,NULL,59350259229,927347800,14489809,15.9),(128321,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128321,35.99,0.21,158,58828,70,NULL,NULL,'GIN 423',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128322,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128322,36.98,0.33,249,58829,70,NULL,NULL,'SDSS J151609.94+451245.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,229.041417,45.21272,0.041,NULL,59985254483,937269601,14644837,17.4),(128323,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128323,37.48,0.23,314,58830,70,NULL,NULL,'2MASX J15160990+5701563',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000095,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,229.041417,57.0325,0.017,NULL,57588902324,899826598,14059790,16.5),(128324,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128324,38.28,0.46,453,58831,70,NULL,NULL,'2MASX J15161017+0027411',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,229.042375,0.46139,0.145,NULL,56378110887,880907982,13764187,16.7),(128325,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128325,37.52,0.46,319,58832,70,NULL,NULL,'2MASX J15161077+2948064',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00023,NULL,'18.40',0.19,'E',NULL,NULL,NULL,NULL,1,229.045,29.80178,0.029,NULL,59904945808,936014778,14625230,18.4),(128326,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128326,34.34,0.49,74,58833,75,NULL,'IR','UGC 09794',NULL,'2011yCatp016004901K',2011,1,3,NULL,'G',0.000023,NULL,'13.50',0.9,'SBdm:','Isolated galaxy (6 Mpc isolation)',NULL,NULL,NULL,1,229.045291667,10.50964,0.085,NULL,59357177647,927455900,14491498,13.5),(128327,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128327,34.51,0.2,79.8,58833,74.4,NULL,NULL,'UGC 09794',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128328,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128328,34.62,0.47,84.1,58833,NULL,NULL,NULL,'UGC 09794',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128329,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128329,34.65,0.46,85.2,58833,NULL,NULL,'Malmquist cor.','UGC 09794',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128330,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128330,38.1,0.46,417,58834,70,NULL,NULL,'SDSS J151611.98+062337.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00005,NULL,'18.0g',0.15,NULL,'Group member',NULL,NULL,NULL,1,229.0499583,6.39381,0.065,NULL,59382987543,927859180,14497799,18),(128331,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128331,36.98,0.33,249,58835,70,NULL,NULL,'2MASX J15161248+4513590',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000196,NULL,'15.8g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,229.052083,45.23306,0.041,NULL,59985323259,937270675,14644854,15.8),(128332,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128332,35.37,0.68,119,58836,70,NULL,NULL,'2MASX J15161274-4403377',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,229.053208333,-44.06042,0.669,NULL,47070757567,735480586,11491884,15.9),(128333,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128333,37.76,0.27,356,58837,70,NULL,NULL,'2MASX J15161443+4843437',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000191,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,229.0600417,48.72883,0.025,NULL,59940468775,936569824,14633903,16.5),(128334,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128334,38.37,0.46,473,58838,70,NULL,NULL,'2MASX J15161481+0145281',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.061625,1.75786,0.089,NULL,56376988176,880890440,13763913,17.7),(128335,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128335,34.88,0.46,94.6,58839,70,NULL,NULL,'CGCG 077-053',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000107,NULL,'15.1g',0.44,NULL,NULL,NULL,NULL,NULL,1,229.0622917,8.69442,0.045,NULL,59352660464,927385319,14490395,15.1),(128336,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128336,38.08,0.33,414,58840,70,NULL,NULL,'2MASX J15161509+2924494',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.13',0.19,NULL,NULL,NULL,NULL,NULL,1,229.062958333,29.41361,0.029,NULL,59904443227,936006925,14625108,17.13),(128337,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128337,36.13,0.09,168,58841,70,NULL,NULL,'CGCG 049-081',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.00004,NULL,'15.3',0.33,'S0','Group member',NULL,NULL,NULL,1,229.0639583,6.79653,0.041,NULL,59349594848,927337419,14489647,15.3),(128338,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128338,37.49,0.46,315,58842,70,NULL,NULL,'2MASX J15161662+1202477',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,229.069208333,12.04658,0.093,NULL,59347346819,927302294,14489098,17.3),(128339,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128339,38.05,0.17,407,58843,70,NULL,NULL,'2MASX J15161676+0210367',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,229.0699583,2.17697,0.093,NULL,56384765069,881011954,13765811,17.3),(128340,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128340,38.05,0.17,407,58844,70,NULL,NULL,'2MASX J15161756+0204107',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,229.073167,2.06969,0.093,NULL,56384806739,881012605,13765821,18),(128341,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128341,37.86,0.46,373,58845,70,NULL,NULL,'2MASX J15161795+1413127',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,229.074958333,14.22019,0.097,NULL,59575575712,930868370,14544818,17.7),(128342,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128342,37.91,0.46,381,58846,70,NULL,NULL,'2MASX J15161816+1901231',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.0757917,19.02317,0.129,NULL,59534200689,930221885,14534716,16.9),(128343,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128343,36.48,0.33,198,58847,70,NULL,NULL,'2MASX J15161841+0304017',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000145,NULL,'15.5g',0.41,'E0',NULL,NULL,NULL,NULL,1,229.076583,3.06714,0.069,NULL,56382558964,880977483,13765273,15.5),(128344,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128344,34.58,0.49,82.4,58848,75,NULL,'IR','CGCG 135-039',NULL,'2011yCatp016004901K',2011,1,0.7,NULL,'G',0.00003,NULL,'15.1',0.15,'S',NULL,NULL,NULL,NULL,1,229.079,24.86728,0.125,NULL,59410474790,928288668,14504510,15.1),(128345,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128345,37.89,0.19,378,58849,70,NULL,NULL,'2MASX J15162077+1848531',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,229.0865,18.81475,0.113,NULL,59533987004,930218546,14534664,17.1),(128346,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128346,37.51,0.33,318,58850,70,NULL,NULL,'2MASX J15162082+1544247',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,229.086917,15.74028,0.065,NULL,59564671178,930697987,14542156,17),(128347,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128347,38.08,0.33,414,58851,70,NULL,NULL,'2MASX J15162207+2924111',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000257,NULL,'16.59',0.17,'S0',NULL,NULL,NULL,NULL,1,229.092167,29.40308,0.029,NULL,59904442876,936006919,14625108,16.59),(128348,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128348,37.4,0.33,301,58852,70,NULL,NULL,'2MASX J15162219+2906591',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.66',0.16,NULL,NULL,NULL,NULL,NULL,1,229.092625,29.11639,0.037,NULL,59904544760,936008511,14625132,18.66),(128349,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128349,37.63,0.46,335,58853,70,NULL,NULL,'2MASX J15162240+2711491',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.15',0.19,NULL,NULL,NULL,NULL,NULL,1,229.093333,27.19697,0.069,NULL,59910413186,936100206,14626565,18.15),(128350,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128350,36.86,0.46,236,58854,70,NULL,NULL,'2MASX J15162308-0018056',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000107,NULL,'16.3g',0.35,'E0',NULL,NULL,NULL,NULL,1,229.09625,-0.30144,0.209,NULL,45375589365,708993583,11078024,16.3),(128351,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128351,37.16,0.65,270,58854,70,NULL,NULL,'2MASX J15162308-0018056',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128352,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128352,37.37,0.46,298,58855,70,NULL,NULL,'2MASX J15162331+1445137',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'15.27',0.17,NULL,NULL,NULL,NULL,NULL,1,229.097125,14.75381,0.053,NULL,59575179633,930862181,14544721,15.27),(128353,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128353,35.34,0.63,117,58856,70,NULL,NULL,'2MASX J15162371-3710247',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,229.098791667,-37.1735,0.381,NULL,47191124012,737361312,11521270,14.9),(128354,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128354,37.22,0.46,278,58857,70,NULL,NULL,'2MASX J15162377-0151476',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000173,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,229.0989583,-1.86314,0.229,NULL,45378471192,709038612,11078728,17.3),(128355,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128355,38.3,0.27,458,58858,70,NULL,NULL,'2MASX J15162438+0122337',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,229.1017083,1.37597,0.113,NULL,56378835223,880919300,13764364,17.1),(128356,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128356,36.34,0.46,185,58859,70,NULL,NULL,'2MASX J15162544+1425267',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.42',0.43,NULL,NULL,NULL,NULL,NULL,1,229.106083333,14.42397,0.093,NULL,59575534643,930867728,14544808,16.42),(128357,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128357,36.13,0.09,168,58860,70,NULL,NULL,'2MASX J15162562+0712552',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000047,NULL,'14.9',0.26,'S0','Group member',NULL,NULL,NULL,1,229.106625,7.21539,0.049,NULL,59350289817,927348278,14489816,14.9),(128358,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128358,38.13,0.46,423,58861,70,NULL,NULL,'SDSS J151626.39+334300.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000157,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,229.1099583,33.71692,0.017,NULL,60113207025,939268859,14676075,18.2),(128359,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128359,36.4,0.71,191,58862,70,NULL,NULL,'2MASX J15162665-3811585',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,229.1109583,-38.19956,0.333,NULL,47190390355,737349849,11521091,15.4),(128360,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128360,36.72,0.46,221,58863,70,NULL,NULL,'2MASX J15162688+3525556',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,229.112125,35.432,0.013,NULL,60106819570,939169055,14674516,16.8),(128361,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128361,36.43,0.46,193,58864,70,NULL,NULL,'2MASX J15162700+0023037',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000077,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.1125,0.38425,0.145,NULL,56378098293,880907785,13764184,16.8),(128362,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128362,37.43,0.46,306,58865,70,NULL,NULL,'2MASX J15162745+2734121',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,229.114375,27.57,0.077,NULL,59910544617,936102259,14626597,NULL),(128363,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128363,36.13,0.09,168,58866,70,NULL,NULL,'2MASX J15162830+0606532',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00011,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,229.117875,6.11489,0.065,NULL,59328434813,927006793,14484481,16.7),(128364,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128364,37.46,0.46,310,58867,70,NULL,NULL,'2MASX J15162832+5808461',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000065,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.1180417,58.14603,0.021,NULL,57721362788,901896293,14092129,17.7),(128365,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128365,38.1,0.46,416,58868,70,NULL,NULL,'SDSS J151629.72+073737.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000119,NULL,'18.7g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.123833333,7.62719,0.049,NULL,59350061333,927344708,14489761,18.7),(128366,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128366,37.29,0.46,287,58869,70,NULL,NULL,'2MASX J15163047+1104332',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000143,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,229.127,11.07589,0.113,NULL,59356041090,927438142,14491220,18),(128367,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128367,36.13,0.09,168,58870,70,NULL,NULL,'2MASX J15163072+0657062',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000047,NULL,'16.4g',0.29,NULL,'Group member',NULL,NULL,NULL,1,229.127875,6.95189,0.041,NULL,59350280670,927348135,14489814,16.4),(128368,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128368,37.72,0.46,349,58871,70,NULL,NULL,'2MASX J15163086+1353287',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,229.1287083,13.89125,0.097,NULL,59573428971,930834827,14544294,17.8),(128369,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128369,37.02,0.46,253,58872,70,NULL,NULL,'2MASX J15163094+2712301',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.85',0.22,NULL,NULL,NULL,NULL,NULL,1,229.129,27.20847,0.069,NULL,59910628775,936103574,14626618,17.85),(128370,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128370,36.26,0.49,178,58873,75,NULL,'IR','UGC 09795',NULL,'2011yCatp016004901K',2011,1,1.49,NULL,'G',0.000137,NULL,'15.1g',0.4,'Sab','Group member',NULL,NULL,NULL,1,229.131875,7.74375,0.049,NULL,59352930169,927389533,14490461,15.1),(128371,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128371,37.15,0.27,269,58874,70,NULL,NULL,'2MASX J15163237+1025272',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000175,NULL,'16.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,229.134833,10.42422,0.085,NULL,59357171253,927455800,14491496,16.1),(128372,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128372,35.09,0.46,104,58875,70,NULL,NULL,'CGCG 077-056',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000167,NULL,'15.3',0.53,NULL,NULL,NULL,NULL,NULL,1,229.1355,12.75419,0.089,NULL,59572896554,930826508,14544164,15.3),(128373,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128373,36.13,0.09,168,58876,70,NULL,NULL,'2MASX J15163294+0653382',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00005,NULL,'14.8',0.29,'S0','Group member',NULL,NULL,NULL,1,229.137333333,6.89397,0.041,NULL,59350278446,927348100,14489814,14.8),(128374,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128374,37.3,0.46,289,58877,70,NULL,NULL,'2MASX J15163322+3214376',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000164,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,229.138375,32.24394,0.017,NULL,60084358860,938818107,14669032,16.6),(128375,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128375,37.15,0.27,269,58878,70,NULL,NULL,'2MASX J15163325+1016592',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,229.1385417,10.28317,0.077,NULL,59357563764,927461933,14491592,17.4),(128376,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128376,37.06,0.33,258,58879,70,NULL,NULL,'2MASX J15163382+2431581',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000175,NULL,'18.28',0.16,NULL,NULL,NULL,NULL,NULL,1,229.141166667,24.53272,0.109,NULL,59410357712,928286839,14504481,18.28),(128377,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128377,37.44,0.46,308,58880,70,NULL,NULL,'2MASX J15163448+2639351',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,229.1437083,26.65983,0.093,NULL,59910119315,936095614,14626493,18.1),(128378,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128378,38.29,0.33,456,58881,70,NULL,NULL,'SDSS J151634.72+024750.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.144708333,2.79739,0.069,NULL,56384973124,881015205,13765862,18.2),(128379,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128379,37.53,0.46,320,58882,70,NULL,NULL,'2MASX J15163507+3119116',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000159,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,229.1460417,31.32003,0.021,NULL,60084030945,938812983,14668952,16.9),(128380,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128380,37.31,0.46,290,58883,70,NULL,NULL,'2MASX J15163587+0009597',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000081,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.1495,0.16661,0.145,NULL,56378057379,880907146,13764174,17.5),(128381,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128381,37.06,0.33,258,58884,70,NULL,NULL,'2MASX J15163602+2434241',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.149916667,24.57322,0.109,NULL,59410354607,928286790,14504481,18),(128382,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128382,34.89,0.49,94.9,58885,70,NULL,NULL,'2MASX J15163602-7135139',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,229.1502083,-71.58719,0.593,NULL,45031262035,703613469,10993960,14.7),(128383,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128383,37.89,0.19,378,58886,70,NULL,NULL,'2MASX J15163614+1847033',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.1505417,18.78433,0.113,NULL,59533989938,930218592,14534665,18),(128384,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128384,37.76,0.27,356,58887,70,NULL,NULL,'2MASX J15163668+4841140',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00017,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,229.152833,48.68725,0.033,NULL,59940470753,936569855,14633903,16.8),(128385,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128385,36.13,0.09,168,58888,70,NULL,NULL,'2MASX J15163717+0657552',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000057,NULL,'17.40',0.2,'S0','Group member',NULL,NULL,NULL,1,229.155,6.96533,0.045,NULL,59350281049,927348141,14489814,17.4),(128386,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128386,38.19,0.46,434,58889,70,NULL,NULL,'SDSS J151637.58+544333.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000138,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,229.156583333,54.72589,0.013,NULL,57581078626,899704353,14057880,18.3),(128387,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128387,38.08,0.46,413,58890,70,NULL,NULL,'2MASX J15163807+1739307',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.158625,17.65867,0.117,NULL,59563751518,930683617,14541931,17.9),(128388,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128388,36.72,0.46,221,58891,70,NULL,NULL,'2MASX J15163831+1212257',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,229.1597917,12.20719,0.097,NULL,59347366792,927302606,14489103,17.5),(128389,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128389,35.41,0.46,121,58892,70,NULL,NULL,'CGCG 221-047',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.00009,NULL,'14.9g',0.68,'E0',NULL,NULL,NULL,NULL,1,229.161333,41.03022,0.033,NULL,59972036049,937063063,14641610,14.9),(128390,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128390,36.76,0.63,225,58893,70,NULL,NULL,'2MASX J15163909-3548138',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,229.1629583,-35.80389,0.477,NULL,47183808775,737247012,11519484,15.2),(128391,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128391,35.55,0.46,129,58894,70,NULL,NULL,'2MASX J15163929+3845201',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000161,NULL,'15.6g',0.45,'E0',NULL,NULL,NULL,NULL,1,229.163833,38.75572,0.097,NULL,60102856412,939107131,14673548,15.6),(128392,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128392,36.13,0.09,168,58895,70,NULL,NULL,'SDSS J151641.28+070006.1',NULL,'2015arXiv151105856S',2015,1,0.11,NULL,'G',NULL,NULL,'18.5g',0.09,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.172,7.00169,0.045,NULL,59350275234,927348050,14489813,18.5),(128393,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128393,36.13,0.09,168,58896,70,NULL,NULL,'2MASX J15164167+0701452',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000063,NULL,'16.0g',0.26,'S0','Group member',NULL,NULL,NULL,1,229.1735,7.02931,0.045,NULL,59350305238,927348519,14489820,16),(128394,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:46','1','SN 2007ba',NULL,128394,35.59,0.4,122,58897,72,NULL,NULL,'UGC 09798',0.03908,'2013ApJ...773...53F',2013,1,1,NULL,'G',0.000093,NULL,'15.03',0.5,'S0/a','Group member',NULL,NULL,NULL,1,229.17425,7.39692,0.049,NULL,59350214478,927347101,14489798,15.03),(128395,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:46','1','SN 2007ba',NULL,128395,35.8,0.15,139,58897,65,NULL,'MLCS17','UGC 09798',0.038513,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128396,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:46','1','SN 2007ba',NULL,128396,35.91,0.16,146,58897,65,NULL,'MLCS31','UGC 09798',0.038513,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128397,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:46','1','SN 2007ba',NULL,128397,36.38,0.1,189,58897,74.4,NULL,NULL,'UGC 09798',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128398,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128398,37.36,0.27,297,58898,70,NULL,NULL,'2MASX J15164192+2159553',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.14,'AGN',NULL,NULL,NULL,NULL,1,229.174583,21.99881,0.137,NULL,59423111366,928486115,14507595,18),(128399,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128399,38.29,0.33,456,58899,70,NULL,NULL,'SDSS J151641.97+024735.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.7g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.174916667,2.79328,0.069,NULL,56385004629,881015697,13765870,18.7),(128400,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128400,37.19,0.97,274,58900,70,NULL,NULL,'2MASX J15164204-1907005',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,229.175167,-19.11686,0.513,NULL,46645082771,728829418,11387959,15.8),(128401,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128401,36.56,0.46,205,58901,70,NULL,NULL,'2MASX J15164220+2522011',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.17575,25.36689,0.125,NULL,59895927358,935873864,14623029,17.4),(128402,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128402,34,0.47,63.1,58902,70,NULL,NULL,'ESO 387- G 016',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000067,NULL,'14.23',0.7,'E5',NULL,NULL,NULL,NULL,1,229.175791667,-36.80242,0.389,NULL,47191021581,737359712,11521245,14.23),(128403,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128403,37.22,0.46,278,58903,70,NULL,NULL,'2MASX J15164277+4142401',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00018,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,229.178333,41.71111,0.037,NULL,59971499576,937054680,14641479,17.1),(128404,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128404,37.14,0.46,268,58904,70,NULL,NULL,'2MASX J15164304+1029169',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000207,NULL,'16.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,229.179416667,10.48817,0.085,NULL,59357173963,927455843,14491497,16.1),(128405,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128405,33.58,0.4,51.9,58905,NULL,NULL,'mean','NGC 5908',NULL,'2007A&A...465...71T',2007,1,3.2,NULL,'G',0.000017,NULL,'12.79',1.2,'Sb','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,229.180083,55.40925,0.013,NULL,57582744184,899730377,14058287,12.79),(128406,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128406,33.6,0.45,52.4,58905,NULL,NULL,'K','NGC 5908',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128407,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128407,33.64,0.47,53.5,58905,NULL,NULL,'H','NGC 5908',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128408,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128408,33.74,0.46,55.9,58905,NULL,NULL,'J','NGC 5908',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128409,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128409,38.79,0.46,573,58906,70,NULL,NULL,'SDSS J151643.19+275636.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.18,27.94336,0.069,NULL,59908623819,936072247,14626128,18.2),(128410,'BCG','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128410,36.41,0.35,185,58907,60,NULL,NULL,'ABELL 2052',0.0351,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',0.0003,NULL,NULL,NULL,'I-II   [BM]',NULL,NULL,NULL,NULL,1,229.183333,7.01861,0.045,NULL,59350275786,927348059,14489813,NULL),(128411,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128411,36.13,0.09,168,58908,70,NULL,NULL,'2MASX J15164408+0705350',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000057,NULL,'16.83',0.3,'E/S0','Group member',NULL,NULL,NULL,1,229.1837917,7.09317,0.045,NULL,59350295415,927348365,14489818,16.83),(128412,'BCG','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128412,36.41,0.35,185,58909,60,NULL,'ABELL 2052, BCG','UGC 09799',0.0351,'1980ApJ...241..486H',1980,1,1.8,NULL,'G',0.000022,NULL,'13.96',0.9,'cD;E;Sy2       LEG','in a pair',NULL,'FR I','USS',1,229.185375,7.02164,0.045,NULL,59350275837,927348059,14489813,13.96),(128413,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128413,35.44,0.23,122,58909,74.4,NULL,NULL,'UGC 09799',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128414,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128414,35.99,0.21,158,58909,70,NULL,NULL,'UGC 09799',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128415,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128415,36.13,0.09,168,58909,70,NULL,NULL,'UGC 09799',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128416,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128416,34.84,0.45,93,58909,NULL,NULL,'K','UGC 09799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128417,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128417,35.83,0.4,147,58909,NULL,NULL,'mean','UGC 09799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128418,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128418,37.59,0.46,329,58910,70,NULL,NULL,'2MASX J15164466+1603268',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,229.186167,16.05744,0.053,NULL,59566618039,930728406,14542631,NULL),(128419,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128419,37.36,0.27,297,58911,70,NULL,NULL,'2MASX J15164479+2159323',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.91',0.21,'AGN',NULL,NULL,NULL,NULL,1,229.186625,21.99228,0.137,NULL,59423111265,928486113,14507595,17.91),(128420,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128420,37.89,0.19,378,58912,70,NULL,NULL,'2MASX J15164509+1847103',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'16.2g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,229.1877917,18.78633,0.109,NULL,59533990312,930218598,14534665,16.2),(128421,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128421,37.78,0.33,360,58913,70,NULL,NULL,'2MASX J15164531+1418108',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,229.188875,14.30319,0.093,NULL,59575452239,930866441,14544788,16.6),(128422,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128422,36.89,0.46,239,58914,70,NULL,NULL,'2MASX J15164550+1555008',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'16.16',0.38,NULL,NULL,NULL,NULL,NULL,1,229.18975,15.91683,0.065,NULL,59564638619,930697478,14542148,16.16),(128423,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128423,36.13,0.09,168,58915,70,NULL,NULL,'2MASX J15164560+0616070',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000057,NULL,'16.6g',0.2,NULL,'Group member',NULL,NULL,NULL,1,229.1900417,6.26861,0.065,NULL,59382960405,927858756,14497793,16.6),(128424,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128424,35.61,0.23,132,58916,74.4,NULL,NULL,'CGCG 049-089',NULL,'2013AJ....146...86T',2013,1,0.63,'UZC has V = 10336 +- 30 km/sec.','G',0.000014,NULL,'15.2g',0.58,'E/S0','Group member',NULL,NULL,NULL,1,229.190708333,7.00439,0.045,NULL,59350275881,927348060,14489813,15.2),(128425,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128425,35.99,0.21,158,58916,70,NULL,NULL,'CGCG 049-089',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128426,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128426,37.62,0.33,334,58917,70,NULL,NULL,'SDSS J151646.21+460346.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,229.1925417,46.06292,0.037,NULL,59986392372,937287380,14645115,18.2),(128427,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128427,36.13,0.09,168,58918,70,NULL,NULL,'2MASX J15164731+0656000',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00004,NULL,'16.3g',0.39,NULL,'Group member',NULL,NULL,NULL,1,229.1970417,6.93333,0.045,NULL,59350284008,927348187,14489815,16.3),(128428,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128428,38.3,0.27,458,58919,70,NULL,NULL,'SDSS J151647.88+012750.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.1995417,1.464,0.109,NULL,56378821000,880919078,13764360,18.5),(128429,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128429,36.14,0.11,169,58920,70,NULL,NULL,'CGCG 049-088 NED01',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000113,NULL,'16.21',0.53,NULL,NULL,NULL,NULL,NULL,1,229.20125,4.91128,0.061,NULL,56380524243,880945691,13764776,16.21),(128430,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128430,38.36,0.46,471,58921,70,NULL,NULL,'SDSS J151648.37+294552.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.201583,29.76472,0.029,NULL,59904900796,936014074,14625219,18.5),(128431,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128431,37.34,0.46,293,58922,70,NULL,NULL,'2MASX J15164871+1541138',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,229.202833,15.68728,0.065,NULL,59564687191,930698237,14542159,16.3),(128432,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128432,37.6,0.46,331,58923,70,NULL,NULL,'SDSS J151649.63+362850.8',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.206833,36.48078,0.021,NULL,60108965283,939202582,14675040,17.7),(128433,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128433,36.13,0.09,168,58924,70,NULL,NULL,'2MASX J15165011+0712400',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000047,NULL,'16.3g',0.19,'S0','Group member',NULL,NULL,NULL,1,229.208875,7.21125,0.049,NULL,59350433716,927350526,14489851,16.3),(128434,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128434,38.28,0.46,453,58925,70,NULL,NULL,'2MASX J15165057-0210054',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00018,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,229.2107083,-2.16817,0.277,NULL,45378632420,709041131,11078767,18.2),(128435,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128435,37.56,0.46,324,58926,70,NULL,NULL,'2MASX J15165063+2839035',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,229.2110417,28.65103,0.053,NULL,59909070845,936079231,14626237,18.3),(128436,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128436,38.3,0.46,458,58927,70,NULL,NULL,'2MASX J15165117-0205594',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000176,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,229.213333,-2.09978,0.277,NULL,45378589756,709040464,11078757,18.6),(128437,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128437,36.13,0.09,168,58928,70,NULL,NULL,'2MASX J15165140+0706330',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00006,NULL,'17.29',0.2,'S0','Group member',NULL,NULL,NULL,1,229.21425,7.10903,0.045,NULL,59350421670,927350338,14489849,17.29),(128438,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128438,38.62,0.33,530,58929,70,NULL,NULL,'SDSS J151651.49+311206.4',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,229.214583,31.20181,0.017,NULL,59903528685,935992635,14624884,18.3),(128439,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128439,37.44,0.33,307,58930,70,NULL,NULL,'2MASX J15165182+3039500',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000195,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,229.215917,30.66394,0.005,NULL,59906763005,936043171,14625674,16.4),(128440,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128440,38.3,0.27,458,58931,70,NULL,NULL,'2MASX J15165196+0137063',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.6g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,229.216333333,1.6185,0.109,NULL,56376981748,880890339,13763911,16.6),(128441,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128441,35.41,0.46,121,58932,70,NULL,NULL,'2MASX J15165224+1646168',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'16.64',0.39,NULL,NULL,NULL,NULL,NULL,1,229.217667,16.77136,0.109,NULL,59567177835,930737153,14542768,16.64),(128442,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128442,37.6,0.46,332,58933,70,NULL,NULL,'2MASX J15165242+0427323',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000084,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,229.218333,4.45897,0.037,NULL,56383350509,880989851,13765466,17.9),(128443,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128443,37.36,0.27,297,58934,70,NULL,NULL,'2MASX J15165255+2155073',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.84',0.16,NULL,NULL,NULL,NULL,NULL,1,229.219083333,21.91867,0.145,NULL,59414964767,928358824,14505606,17.84),(128444,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128444,36.13,0.09,168,58935,70,NULL,NULL,'2MASX J15165306+0724500',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00017,NULL,'16.55',0.3,NULL,'Group member',NULL,NULL,NULL,1,229.221,7.41403,0.049,NULL,59350216509,927347132,14489798,16.55),(128445,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128445,36.29,0.46,181,58936,70,NULL,NULL,'2MASX J15165336+0338063',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000093,NULL,'16.0g',0.39,'S0',NULL,NULL,NULL,NULL,1,229.2222917,3.63519,0.041,NULL,56382776935,880980889,13765326,16),(128446,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128446,37.74,0.46,354,58937,70,NULL,NULL,'2MASX J15165337+2929505',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,229.2225,29.49725,0.029,NULL,59904455084,936007110,14625111,17.8),(128447,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128447,36.01,0.46,159,58938,70,NULL,NULL,'2MASX J15165360+1454278',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.11',0.3,NULL,NULL,NULL,NULL,NULL,1,229.22325,14.90783,0.081,NULL,59575223754,930862871,14544732,16.11),(128448,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128448,35.76,0.23,142,58939,74.4,NULL,NULL,'CGCG 049-092',NULL,'2013AJ....146...86T',2013,1,0.69,NULL,'G',0.000025,NULL,'15.1',0.5,'E/S0','Group member',NULL,NULL,NULL,1,229.224625,6.93947,0.045,NULL,59350283595,927348181,14489815,15.1),(128449,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128449,35.99,0.21,158,58939,70,NULL,NULL,'CGCG 049-092',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128450,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128450,36.13,0.09,168,58939,70,NULL,NULL,'CGCG 049-092',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128451,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128451,37.88,0.46,377,58940,70,NULL,NULL,'2MASX J15165422+6106198',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000066,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,229.225875,61.10553,0.009,NULL,57773589679,902712338,14104880,18),(128452,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128452,37.2,0.46,275,58941,70,NULL,NULL,'2MASX J15165493+2226062',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.80',0.2,NULL,NULL,NULL,NULL,NULL,1,229.2287917,22.43517,0.133,NULL,59423163863,928486935,14507608,17.8),(128453,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128453,38.62,0.33,530,58942,70,NULL,NULL,'2MASX J15165598+3106170',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,229.233375,31.10483,0.017,NULL,59903354711,935989917,14624842,18.2),(128454,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128454,36.99,0.21,250,58943,70,NULL,NULL,'2MASX J15165710+0512123',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',NULL,NULL,'17.15',0.46,NULL,NULL,NULL,NULL,NULL,1,229.2379583,5.20347,0.081,NULL,56380739065,880949047,13764828,17.15),(128455,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128455,37.62,0.46,334,58944,70,NULL,NULL,'SDSS J151658.35-010538.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000082,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,229.243125,-1.09397,0.177,NULL,45377305812,709020403,11078443,18.6),(128456,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128456,37.15,0.27,269,58945,70,NULL,NULL,'SDSS J151700.06+102525.1',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.2502917,10.42364,0.085,NULL,59357691274,927463926,14491623,17.6),(128457,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128457,37.44,0.33,307,58946,70,NULL,NULL,'2MASX J15170011+3039490',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000176,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.250417,30.66361,0.005,NULL,59906763464,936043179,14625674,16.8),(128458,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128458,37.78,0.33,360,58947,70,NULL,NULL,'2MASX J15170203+1423489',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,229.258417,14.397,0.093,NULL,59575863893,930872873,14544888,16.9),(128459,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128459,37.55,0.46,324,58948,70,NULL,NULL,'SDSS J151702.27+304040.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00014,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.2594583,30.67778,0.005,NULL,59906765268,936043207,14625675,18.1),(128460,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128460,36.78,0.56,227,58949,70,NULL,NULL,'2MASX J15170305-2227520',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.5,NULL,NULL,NULL,NULL,NULL,1,229.2627083,-22.46442,0.409,NULL,46623458514,728491539,11382680,14.1),(128461,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128461,36.5,0.46,199,58950,70,NULL,NULL,'2MASX J15170341+2327505',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000163,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,229.2642917,23.46419,0.149,NULL,59424032977,928500515,14507820,16.3),(128462,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128462,36.99,0.21,250,58951,70,NULL,NULL,'IC 1109',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000083,NULL,'15.5',0.68,NULL,NULL,NULL,NULL,NULL,1,229.266583,5.25611,0.073,NULL,56380748853,880949200,13764831,15.5),(128463,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128463,36.68,0.46,216,58952,70,NULL,NULL,'2MASX J15170422+4020392',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.267583,40.34439,0.049,NULL,59972062213,937063472,14641616,16.9),(128464,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128464,38.57,0.46,517,58953,70,NULL,NULL,'SDSS J151704.37+085140.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000164,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.26825,8.86128,0.053,NULL,59352570417,927383912,14490373,18.5),(128465,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128465,37.59,0.46,329,58954,70,NULL,NULL,'2MASX J15170513+2801145',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.82',0.15,NULL,NULL,NULL,NULL,NULL,1,229.2715,28.02078,0.069,NULL,59910980222,936109065,14626704,18.82),(128466,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128466,38.7,0.46,550,58955,70,NULL,NULL,'SDSS J151705.50+015722.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.272958333,1.95619,0.093,NULL,56377112903,880892389,13763943,18.2),(128467,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128467,37.89,0.19,378,58956,70,NULL,NULL,'2MASX J15170576+1846555',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,229.274125,18.78208,0.109,NULL,59533987903,930218560,14534665,18.2),(128468,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128468,37.88,0.46,376,58957,70,NULL,NULL,'2MASX J15170759+0332143',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000074,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.2817083,3.53731,0.041,NULL,56382960784,880983762,13765371,17.9),(128469,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128469,38.67,0.46,542,58958,70,NULL,NULL,'LCRS B151431.9-021651',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000169,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,229.282083,-2.46331,0.281,NULL,45379143476,709049116,11078892,18.7),(128470,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128470,37.91,0.46,382,58959,70,NULL,NULL,'2MASX J15170811+2848595',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,229.28375,28.81656,0.041,NULL,59909047790,936078871,14626232,16.7),(128471,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128471,36.13,0.09,168,58960,70,NULL,NULL,'2MASX J15171041+0705350',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,'Group member',NULL,NULL,NULL,1,229.29325,7.09322,0.049,NULL,59350441490,927350648,14489853,17.7),(128472,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128472,37.38,0.33,299,58961,70,NULL,NULL,'2MASX J15171054+0712330',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000167,NULL,'16.19',0.4,'E/S0','Group member',NULL,NULL,NULL,1,229.2939583,7.20911,0.049,NULL,59350428595,927350446,14489850,16.19),(128473,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128473,37.18,0.46,273,58962,70,NULL,NULL,'2MASX J15171066+2717015',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.36',0.18,NULL,NULL,NULL,NULL,NULL,1,229.294417,27.28375,0.077,NULL,59910640228,936103753,14626621,18.36),(128474,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128474,35.93,0.23,153,58963,74.4,NULL,NULL,'GIN 425',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000028,NULL,'14.45',NULL,'E/S0','Group member',NULL,NULL,NULL,1,229.2954583,6.94147,0.045,NULL,59350271673,927347994,14489812,14.45),(128475,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128475,35.99,0.21,158,58963,70,NULL,NULL,'GIN 425',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128476,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128476,36.34,0.46,185,58964,70,NULL,NULL,'CGCG 049-095',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000105,NULL,'15.3g',0.54,'S0^-',NULL,NULL,NULL,NULL,1,229.2965,3.35161,0.053,NULL,56382828723,880981698,13765339,15.3),(128477,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128477,38.42,0.46,483,58965,70,NULL,NULL,'LCRS B151435.2-022943',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.2970417,-2.67781,0.281,NULL,45379044928,709047577,11078868,18.1),(128478,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128478,37.47,0.33,312,58966,70,NULL,NULL,'2MASX J15171133+1439129',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'16.64',0.38,NULL,NULL,NULL,NULL,NULL,1,229.29725,14.65375,0.089,NULL,59575677748,930869964,14544843,16.64),(128479,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128479,35.78,0.61,143,58967,70,NULL,NULL,'LCRS B151435.9-025026',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00013,NULL,'16.73',0.4,NULL,NULL,NULL,NULL,NULL,1,229.3010417,-3.02339,0.297,NULL,45378309392,709036084,11078688,16.73),(128480,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128480,35.77,0.25,143,58968,74.4,NULL,NULL,'ARK 474',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000063,NULL,'14.56',0.3,'S0','in a pair',NULL,NULL,NULL,1,229.3024583,7.02858,0.045,NULL,59350394358,927349911,14489842,14.56),(128481,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128481,35.99,0.21,158,58968,70,NULL,NULL,'ARK 474',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128482,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128482,35.31,0.5,115,58969,70,NULL,NULL,'2MASX J15171263-3243367',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,229.302583333,-32.72689,0.629,NULL,47236355844,738068060,11532313,14.9),(128483,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128483,36.07,0.63,164,58970,70,NULL,NULL,'2MASX J15171268-1112533',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.5b',0.4,NULL,NULL,NULL,NULL,NULL,1,229.303,-11.21489,0.489,NULL,46487546445,726367913,11349498,16.5),(128484,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128484,37.38,0.33,299,58971,70,NULL,NULL,'2MASX J15171290+0714240',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000077,NULL,'16.48',0.3,'E','Group member',NULL,NULL,NULL,1,229.303833,7.24,0.049,NULL,59350429128,927350455,14489850,16.48),(128485,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128485,36.19,0.65,173,58972,70,NULL,NULL,'2MASX J15171471-4452566',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,229.311375,-44.88239,0.721,NULL,47071033456,735484897,11491951,15.8),(128486,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128486,38.01,0.46,400,58973,70,NULL,NULL,'2MASX J15171492+1733525',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,229.312041667,17.56461,0.117,NULL,59564310822,930692356,14542068,17),(128487,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128487,37.5,0.46,316,58974,70,NULL,NULL,'2MASX J15171529+2821125',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.42',0.17,NULL,NULL,NULL,NULL,NULL,1,229.313833,28.35347,0.045,NULL,59909000110,936078126,14626220,18.42),(128488,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128488,37.48,0.23,314,58975,70,NULL,NULL,'2MASX J15171560+5700173',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000106,NULL,'15.8g',0.46,'E0',NULL,NULL,NULL,NULL,1,229.314917,57.00475,0.025,NULL,57588872845,899826138,14059783,15.8),(128489,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128489,36.99,0.21,250,58976,70,NULL,NULL,'2MASX J15171566+0510433',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.315375,5.1785,0.073,NULL,56380742438,880949100,13764829,16.4),(128490,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128490,36.13,0.09,168,58977,70,NULL,NULL,'2MASX J15171586+0705570',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00004,NULL,'16.1g',0.36,'S0','Group member',NULL,NULL,NULL,1,229.3160417,7.09922,0.049,NULL,59350439913,927350623,14489853,16.1),(128491,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128491,37.73,0.46,352,58978,70,NULL,NULL,'2MASX J15171714+1938215',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'17.41',0.35,NULL,NULL,NULL,NULL,NULL,1,229.321375,19.63939,0.173,NULL,59413229281,928331707,14505182,17.41),(128492,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128492,35.6,0.46,132,58979,70,NULL,NULL,'2MASX J15171716+4642302',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000178,NULL,'16.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.3214583,46.70847,0.077,NULL,59983590226,937243597,14644431,16.3),(128493,'IRAS','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128493,34.7,0.8,87.1,58980,75,NULL,'MAT, I','ESO 582- G 001',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000027,NULL,'14.5',0.7,'SA(rs)b:       HII',NULL,NULL,NULL,NULL,1,229.32575,-22.29761,0.389,NULL,46621297830,728457778,11382152,14.5),(128494,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128494,33.98,0.43,62.4,58980,75,NULL,'MAT, I, raw','ESO 582- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128495,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128495,34.13,0.32,67,58980,85,NULL,'I, raw','ESO 582- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128496,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128496,34.19,0.32,68.9,58980,85,NULL,'I, inv','ESO 582- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128497,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128497,34.24,0.43,70.3,58980,75,NULL,'MAT, I, inv','ESO 582- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128498,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128498,34.29,0.43,72.1,58980,75,NULL,'MAT, I, cor','ESO 582- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128499,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128499,34.43,0.2,76.9,58980,74.4,NULL,NULL,'ESO 582- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128500,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128500,34.46,0.57,77.9,58980,NULL,NULL,'Malmquist cor.','ESO 582- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128501,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128501,34.48,0.56,78.7,58980,NULL,NULL,NULL,'ESO 582- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128502,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128502,34.63,0.47,84.5,58980,NULL,NULL,'H','ESO 582- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128503,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128503,34.74,0.45,88.6,58980,NULL,NULL,'K','ESO 582- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128504,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128504,34.76,0.46,89.4,58980,NULL,NULL,'J','ESO 582- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128505,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128505,34.82,0.4,92,58980,NULL,NULL,'mean','ESO 582- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128506,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128506,36.48,0.46,198,58981,70,NULL,NULL,'2MASX J15171976+2032145',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000127,NULL,'16.48',0.24,NULL,NULL,NULL,NULL,NULL,1,229.3322917,20.53728,0.165,NULL,59415848224,928372628,14505822,16.48),(128507,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128507,36.39,0.46,189,58982,70,NULL,NULL,'2MASX J15171975+0433103',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,229.332333333,4.55297,0.029,NULL,56383258896,880988420,13765444,16.5),(128508,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128508,37.89,0.46,378,58983,70,NULL,NULL,'2MASX J15172265+0254013',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000089,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.344333,2.90025,0.061,NULL,56384098712,881001542,13765649,17.5),(128509,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128509,38.57,0.46,518,58984,70,NULL,NULL,'SDSS J151722.79+302254.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,229.344958333,30.38181,0.017,NULL,59906954903,936046170,14625721,18.4),(128510,'Tully est','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128510,33.05,0.8,40.7,58985,75,NULL,NULL,'ESO 068- G 001',NULL,'1988NBGC.C....0000T',1988,1,1.1,'Confused HIPASS source','G',0.000019,NULL,'14.8',0.8,'IB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,229.345417,-72.67217,0.517,NULL,45000132679,703127073,10986360,14.8),(128511,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128511,36.51,0.57,201,58986,70,NULL,NULL,'2MASX J15172294-1958589',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,229.3455,-19.98311,0.469,NULL,46616314455,728379913,11380936,15.2),(128512,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128512,35.81,0.25,145,58987,74.4,NULL,NULL,'CGCG 049-098',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.00005,NULL,'15.1g',0.51,'E/S0',NULL,NULL,NULL,NULL,1,229.345666667,4.21361,0.037,NULL,56383457559,880991524,13765492,15.1),(128513,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128513,36.02,0.21,160,58987,70,NULL,NULL,'CGCG 049-098',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128514,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128514,36.14,0.11,169,58987,70,NULL,NULL,'CGCG 049-098',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128515,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128515,36.13,0.09,168,58988,70,NULL,NULL,'2MASX J15172338+0716380',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000037,NULL,'16.81',0.2,NULL,'Group member',NULL,NULL,NULL,1,229.347375,7.27719,0.049,NULL,59350208564,927347008,14489797,16.81),(128516,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128516,36.97,0.46,248,58989,70,NULL,NULL,'2MASX J15172412+1053420',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,229.350667,10.89494,0.097,NULL,59356493369,927445208,14491331,17.2),(128517,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128517,37.07,0.33,259,58990,70,NULL,NULL,'2MASX J15172437+3855372',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000179,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.351667,38.92694,0.097,NULL,60103045655,939110088,14673595,17.3),(128518,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128518,37.55,0.46,323,58991,70,NULL,NULL,'SDSS J151725.30+070457.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00014,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.3554583,7.08269,0.049,NULL,59350389760,927349840,14489841,18.1),(128519,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128519,35.57,0.38,130,58992,NULL,NULL,NULL,'AGC 251805',NULL,'2009ApJS..182..474S',2009,1,0.92,NULL,'G',0.000027,NULL,'17.1g',0.11,'Sc',NULL,NULL,NULL,NULL,1,229.374667,8.17758,0.049,NULL,59353595302,927399926,14490623,17.1),(128520,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128520,35.61,0.2,132,58992,74.4,NULL,NULL,'AGC 251805',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128521,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128521,35.92,0.32,153,58992,NULL,NULL,'Malmquist cor.','AGC 251805',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128522,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128522,38.21,0.33,438,58993,70,NULL,NULL,'SDSS J151730.14+324140.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000143,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,229.375583,32.69464,0.009,NULL,60112926590,939264477,14676007,18.3),(128523,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128523,38.05,0.46,407,58994,70,NULL,NULL,'2MASX J15173030+0947080',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.3762917,9.78536,0.045,NULL,59357523969,927461312,14491583,17.6),(128524,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128524,37.49,0.27,314,58995,70,NULL,NULL,'2MASX J15173180+2209509',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.16',0.16,NULL,NULL,NULL,NULL,NULL,1,229.3825,22.16414,0.137,NULL,59423122983,928486296,14507598,18.16),(128525,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128525,38.21,0.33,438,58996,70,NULL,NULL,'2MASX J15173329+3242003',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.388666667,32.70014,0.009,NULL,60112926679,939264479,14676007,17.7),(128526,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128526,38.12,0.46,421,58997,70,NULL,NULL,'2MASX J15173333+2626079',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.388917,26.43558,0.113,NULL,59910241173,936097518,14626523,17.7),(128527,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128527,36.8,0.46,229,58998,70,NULL,NULL,'2MASX J15173328+2652219',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.13',0.21,NULL,NULL,NULL,NULL,NULL,1,229.388917,26.87269,0.065,NULL,59910048513,936094508,14626476,18.13),(128528,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128528,37.47,0.33,312,58999,70,NULL,NULL,'2MASX J15173339+1438446',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,229.3892917,14.64567,0.089,NULL,59575666708,930869792,14544840,16.7),(128529,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128529,37.15,0.46,269,59000,70,NULL,NULL,'2MASX J15173402+3635132',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000169,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,229.39175,36.58697,0.017,NULL,60109026058,939203532,14675055,16.6),(128530,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128530,37.49,0.27,314,59001,70,NULL,NULL,'2MASX J15173496+2217409',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',NULL,NULL,'16.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.3957083,22.29472,0.133,NULL,59424146527,928502289,14507848,16.3),(128531,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128531,36.77,0.46,226,59002,70,NULL,NULL,'2MASX J15173571-0127315',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00014,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.39875,-1.45878,0.189,NULL,45377249152,709019518,11078429,17.7),(128532,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128532,36.21,0.46,175,59003,70,NULL,NULL,'MCG +01-39-014a',NULL,'2015arXiv151105856S',2015,1,0.63,'New entry added to MCG in volume IV of MCG Errata and Addenda.','G',NULL,NULL,'15.7',0.41,NULL,NULL,NULL,NULL,NULL,1,229.3987917,5.05439,0.081,NULL,56380475504,880944929,13764764,15.7),(128533,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128533,36.13,0.09,168,59004,70,NULL,NULL,'2MASX J15173648+0702250',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00005,NULL,'14.7',0.25,'S0','Group member',NULL,NULL,NULL,1,229.4020417,7.04031,0.049,NULL,59350392048,927349875,14489841,14.7),(128534,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128534,37.49,0.27,314,59005,70,NULL,NULL,'2MASX J15173698+2213419',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.88',0.2,NULL,NULL,NULL,NULL,NULL,1,229.404,22.22836,0.137,NULL,59423090372,928485787,14507590,17.88),(128535,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128535,37.89,0.19,378,59006,70,NULL,NULL,'SDSS J151736.98+184051.5',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,229.404083333,18.681,0.113,NULL,59580101117,930939079,14545923,NULL),(128536,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128536,37.89,0.19,378,59007,70,NULL,NULL,'2MASX J15173739+1843269',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,229.40575,18.72406,0.109,NULL,59580103968,930939124,14545923,17.7),(128537,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128537,37.66,0.46,340,59008,70,NULL,NULL,'2MASX J15173805+2228309',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.68',0.15,NULL,NULL,NULL,NULL,NULL,1,229.408583333,22.47531,0.133,NULL,59424335081,928505235,14507894,18.68),(128538,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128538,38.67,0.46,542,59009,70,NULL,NULL,'2MASX J15173820+0224263',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.409167,2.40742,0.077,NULL,56384887723,881013870,13765841,17.8),(128539,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128539,37.48,0.23,314,59010,70,NULL,NULL,'2MASX J15173923+5658065',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000089,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,229.413333,56.96833,0.025,NULL,57588861199,899825956,14059780,17.8),(128540,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128540,36.45,0.46,195,59011,70,NULL,NULL,'2MASX J15173941+0407093',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000099,NULL,'16.9g',0.27,'NLAGN',NULL,NULL,NULL,'Sy 2',1,229.4142083,4.11936,0.037,NULL,56382424103,880975376,13765240,16.9),(128541,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128541,35.3,0.46,115,59012,70,NULL,NULL,'VIII Zw 465',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,229.4147917,9.96494,0.057,NULL,59357348849,927458575,14491540,16.4),(128542,'BL Lac Luminosity','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128542,37.03,NULL,243,59013,NULL,NULL,NULL,'AP Lib',0.049031,'2005ApJ...635..173S',2005,1,0.5,NULL,'G',0.00015,NULL,'15.08',0.4,'N galaxy       BLLAC',NULL,NULL,'radio jet','Flat-Spectrum Radio Source',1,229.424208333,-24.37208,0.645,NULL,46622664221,728479128,11382486,15.08),(128543,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128543,37.46,0.46,310,59014,70,NULL,NULL,'SDSS J151742.18+350646.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000141,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,229.42575,35.11286,0.021,NULL,60107933778,939186465,14674788,18.1),(128544,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128544,37.51,0.21,317,59015,70,NULL,NULL,'SDSS J151742.26+590116.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000158,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,229.426167,59.02111,0.025,NULL,57718309427,901848584,14091384,18.5),(128545,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128545,35.98,0.34,157,59016,NULL,NULL,'Malmquist cor.','2MFGC 12361',NULL,'2009ApJS..182..474S',2009,1,0.64,NULL,'G',0.000027,NULL,'14.88',NULL,'Sbc',NULL,NULL,NULL,NULL,1,229.4289583,8.01606,0.057,NULL,59353358322,927396223,14490565,14.88),(128546,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128546,35.98,0.34,157,59016,NULL,NULL,NULL,'2MFGC 12361',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128547,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128547,35.99,0.49,158,59016,75,NULL,'IR','2MFGC 12361',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128548,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128548,36.02,0.2,160,59016,74.4,NULL,NULL,'2MFGC 12361',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128549,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128549,36.84,0.46,234,59017,70,NULL,NULL,'2MASX J15174398+4919428',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000157,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,229.433375,49.32869,0.033,NULL,59938224613,936534759,14633355,16.7),(128550,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128550,36.14,0.11,169,59018,70,NULL,NULL,'2MASX J15174421+0408598',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000084,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,229.434167,4.14983,0.037,NULL,56382424524,880975383,13765240,16.7),(128551,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128551,36.89,0.46,238,59019,70,NULL,NULL,'2MASX J15174569+1252032',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.440291667,12.86758,0.113,NULL,59573006874,930828232,14544191,17.5),(128552,'IRAS','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128552,34.65,0.8,85,59020,75,NULL,'MAT, I','ESO 387- G 020',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'16.42',0.5,'Sb-c           HII',NULL,NULL,NULL,NULL,1,229.440833,-33.08786,0.641,NULL,47236455137,738069611,11532337,16.42),(128553,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128553,34.43,0.43,77,59020,75,NULL,'MAT, I, raw','ESO 387- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128554,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128554,34.44,0.32,77.4,59020,85,NULL,'I, raw','ESO 387- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128555,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128555,34.48,0.32,78.8,59020,85,NULL,'I, inv','ESO 387- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128556,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128556,34.61,0.43,83.7,59020,75,NULL,'MAT, I, inv','ESO 387- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128557,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128557,34.63,0.43,84.5,59020,75,NULL,'MAT, I, cor','ESO 387- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128558,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128558,34.89,0.2,95.1,59020,74.4,NULL,NULL,'ESO 387- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128559,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128559,38.07,0.33,411,59021,70,NULL,NULL,'2MASX J15174601+0447078',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.441625,4.7855,0.065,NULL,56380604636,880946947,13764796,17.4),(128560,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128560,36.34,0.46,186,59022,70,NULL,NULL,'2MASX J15174707+0510568',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,229.446125,5.1825,0.073,NULL,56380430258,880944222,13764753,17),(128561,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128561,37.07,0.33,259,59023,70,NULL,NULL,'2MASXi J1517471+384653',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,229.4464583,38.78164,0.057,NULL,60102823616,939106619,14673540,17.8),(128562,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128562,36.12,0.46,168,59024,70,NULL,NULL,'2MASX J15174724+0124198',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,229.446667,1.40539,0.109,NULL,56378972023,880921437,13764397,16.5),(128563,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128563,36.99,0.21,250,59025,70,NULL,NULL,'2MASX J15174740+0515228',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,229.447583333,5.25625,0.073,NULL,56380438575,880944352,13764755,16.2),(128564,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128564,36.01,0.46,160,59026,70,NULL,NULL,'2MASX J15174849-0125343',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00015,NULL,'16.3g',0.29,'S0',NULL,NULL,NULL,NULL,1,229.452083,-1.42614,0.189,NULL,45377197097,709018704,11078417,16.3),(128565,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128565,36.21,0.52,175,59026,70,NULL,NULL,'2MASX J15174849-0125343',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128566,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128566,38.33,0.46,464,59027,70,NULL,NULL,'2MASX J15174866+1918310',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,229.452667,19.30867,0.161,NULL,59412540850,928320950,14505014,17.8),(128567,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128567,37.85,0.46,371,59028,70,NULL,NULL,'2MASX J15174942+4144433',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,229.45575,41.74531,0.037,NULL,59971525395,937055084,14641485,17.2),(128568,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128568,33.94,0.48,61.4,59029,70,NULL,NULL,'ESO 274- G 008',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000077,NULL,'15.13',0.2,'S0',NULL,NULL,NULL,NULL,1,229.456083,-43.50158,0.541,NULL,47073641552,735525649,11492588,15.13),(128569,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128569,37.72,0.46,350,59030,70,NULL,NULL,'2MASX J15175000+0621128',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000073,NULL,'17.0R',0.12,NULL,NULL,NULL,NULL,NULL,1,229.458416667,6.35356,0.057,NULL,59349426751,927334792,14489606,17),(128570,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128570,37.93,0.23,385,59031,70,NULL,NULL,'2MASX J15175010+2648029',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'18.10',0.21,NULL,NULL,NULL,NULL,NULL,1,229.4587917,26.80089,0.065,NULL,59910041655,936094400,14626475,18.1),(128571,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128571,35.38,0.4,119,59032,NULL,NULL,NULL,'CGCG 049-108',NULL,'2009ApJS..182..474S',2009,1,0.85,NULL,'G',0.000021,NULL,'15.6g',0.32,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,229.462083,8.22889,0.049,NULL,59353584542,927399758,14490621,15.6),(128572,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128572,35.43,0.2,122,59032,74.4,NULL,NULL,'CGCG 049-108',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128573,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128573,35.6,0.36,132,59032,NULL,NULL,'Malmquist cor.','CGCG 049-108',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128574,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128574,36.48,0.59,198,59033,70,NULL,NULL,'2MASX J15175148-1904076',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,229.4644583,-19.06872,0.493,NULL,46615522123,728367533,11380742,14.8),(128575,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128575,37.93,0.23,385,59034,70,NULL,NULL,'2MASX J15175182+2653359',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.465875,26.89317,0.065,NULL,59910061846,936094716,14626479,17.7),(128576,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128576,38.21,0.46,438,59035,70,NULL,NULL,'2MASX J15175233+2638329',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,229.468041667,26.64253,0.089,NULL,59910033128,936094267,14626472,NULL),(128577,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128577,37.37,0.33,298,59036,70,NULL,NULL,'2MASX J15175250+4841038',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000179,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,229.468875,48.68439,0.033,NULL,59936971642,936515181,14633049,16.6),(128578,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128578,37.29,0.33,287,59037,70,NULL,NULL,'2MASX J15175289+5047358',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00018,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,229.470583333,50.79347,0.033,NULL,59666272773,932285512,14566961,16.4),(128579,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128579,37.8,0.46,362,59038,70,NULL,NULL,'2MASX J15175371+3439223',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000154,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,229.4737917,34.65614,0.013,NULL,60107813598,939184587,14674759,16.9),(128580,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128580,36.18,0.46,172,59039,70,NULL,NULL,'CGCG 021-074',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.000085,NULL,'15.6g',0.4,'E0',NULL,NULL,NULL,NULL,1,229.475083333,0.82867,0.133,NULL,56379607913,880931373,13764552,15.6),(128581,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128581,37.24,0.46,280,59040,70,NULL,NULL,'2MASX J15175426+1816159',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.4760417,18.27122,0.153,NULL,59563552821,930680512,14541883,16.8),(128582,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128582,37.29,0.33,287,59041,70,NULL,NULL,'2MASX J15175432+5048038',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.4762083,50.80114,0.033,NULL,59666243882,932285060,14566954,17.9),(128583,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128583,35.86,0.46,149,59042,70,NULL,NULL,'CGCG 106-030',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.00011,NULL,'15.6',0.39,NULL,NULL,NULL,NULL,NULL,1,229.481417,20.15408,0.181,NULL,59413160939,928330639,14505166,15.6),(128584,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128584,38.07,0.33,411,59043,70,NULL,NULL,'2MASX J15175577+0449408',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.482417,4.82794,0.065,NULL,56380599817,880946872,13764794,17.6),(128585,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128585,37.53,0.33,321,59044,70,NULL,NULL,'2MASX J15175793+2810288',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.4914583,28.17483,0.045,NULL,59911035992,936109937,14626717,17.3),(128586,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128586,36.13,0.09,168,59045,70,NULL,NULL,'CGCG 049-109',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00006,NULL,'15.3',0.5,NULL,'Group member',NULL,NULL,NULL,1,229.4920417,7.23922,0.049,NULL,59350416371,927350255,14489847,15.3),(128587,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128587,35.33,0.43,117,59046,NULL,NULL,NULL,'UGC 09807',NULL,'2009ApJS..182..474S',2009,1,1.18,NULL,'G',0.000033,NULL,'14.9g',0.42,'Sab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,229.494667,10.89569,0.097,NULL,59356360251,927443128,14491298,14.9),(128588,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128588,35.41,0.42,121,59046,NULL,NULL,'Malmquist cor.','UGC 09807',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128589,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128589,35.66,0.2,136,59046,74.4,NULL,NULL,'UGC 09807',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128590,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128590,37.93,0.23,385,59047,70,NULL,NULL,'2MASX J15175925+2652409',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.30',0.32,'BrClG',NULL,NULL,NULL,NULL,1,229.49675,26.87806,0.065,NULL,59910058545,936094664,14626479,17.3),(128591,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128591,37.86,0.21,374,59048,70,NULL,NULL,'2MASX J15180005+2705179',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,229.500125,27.08833,0.077,NULL,59910509023,936101703,14626589,17.4),(128592,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128592,37.34,0.46,294,59049,70,NULL,NULL,'SDSS J151800.27+204327.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.53',0.15,NULL,NULL,NULL,NULL,NULL,1,229.501167,20.72444,0.165,NULL,59416292583,928379571,14505930,18.53),(128593,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128593,37.93,0.23,385,59050,70,NULL,NULL,'2MASX J15180119+2651249',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,'PHOT','16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,229.5050417,26.85703,0.065,NULL,59910052893,936094576,14626477,16.7),(128594,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128594,37.86,0.21,374,59051,70,NULL,NULL,'2MASX J15180245+2702189',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.98',0.18,NULL,NULL,NULL,NULL,NULL,1,229.510291667,27.03858,0.073,NULL,59910001474,936093773,14626465,17.98),(128595,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128595,37.99,0.46,396,59052,70,NULL,NULL,'2MASX J15180371+2332460',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.22',0.16,NULL,NULL,NULL,NULL,NULL,1,229.515333,23.54611,0.145,NULL,59423983406,928499740,14507808,18.22),(128596,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128596,37.37,0.33,298,59053,70,NULL,NULL,'2MASX J15180432+4836039',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00016,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.51775,48.60111,0.045,NULL,59936987233,936515425,14633053,17.6),(128597,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128597,38.18,0.27,432,59054,70,NULL,NULL,'SDSS J151804.89+311905.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,229.520417,31.31817,0.021,NULL,59903486241,935991972,14624874,18.3),(128598,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128598,37.61,0.46,333,59055,70,NULL,NULL,'2MASX J15180566+3000494',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.523916667,30.01381,0.017,NULL,59907059372,936047802,14625746,18.1),(128599,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128599,35.92,0.47,153,59056,NULL,NULL,'H','UGC 09808',NULL,'2007A&A...465...71T',2007,1,1.3,'HOLM 705B is a star.','G',0.00003,NULL,'14.40',1,'SABb',NULL,NULL,NULL,NULL,1,229.5357917,13.82864,0.097,NULL,59573091236,930829550,14544211,14.4),(128600,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128600,36,0.4,159,59056,NULL,NULL,'mean','UGC 09808',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128601,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128601,38.1,0.46,418,59057,70,NULL,NULL,'2MASX J15180872+1525072',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,229.536333,15.41878,0.077,NULL,59575116874,930861201,14544706,17.4),(128602,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128602,35.45,0.42,123,59058,NULL,NULL,NULL,'CGCG 049-111',NULL,'2009ApJS..182..474S',2009,1,0.59,NULL,'G',0.000027,NULL,'15.7g',0.29,'Sc',NULL,NULL,NULL,NULL,1,229.5375417,8.2475,0.049,NULL,59353449370,927397646,14490588,15.7),(128603,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128603,35.49,0.2,125,59058,74.4,NULL,NULL,'CGCG 049-111',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128604,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128604,35.7,0.37,138,59058,NULL,NULL,'Malmquist cor.','CGCG 049-111',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128605,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128605,36.02,0.21,160,59059,70,NULL,NULL,'GIN 394',NULL,'2001MNRAS.321..277C',2001,1,0.56,NULL,'G',0.000067,NULL,'14.35',0.51,'S',NULL,NULL,NULL,NULL,1,229.53825,4.56303,0.065,NULL,56383250306,880988286,13765441,14.35),(128606,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128606,36.14,0.11,169,59059,70,NULL,NULL,'GIN 394',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128607,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128607,38.18,0.27,432,59060,70,NULL,NULL,'2MASX J15180944+3117364',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000175,NULL,'17.1g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,229.539417,31.29342,0.021,NULL,59903487395,935991990,14624874,17.1),(128608,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128608,35.55,0.55,129,59061,70,NULL,NULL,'2MASX J15181047-7209033',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,229.543583,-72.15094,0.601,NULL,44999079522,703110617,10986103,15.1),(128609,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128609,37.86,0.21,374,59062,70,NULL,NULL,'2MASX J15181263+2702329',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,229.552666667,27.0425,0.073,NULL,59910465038,936101016,14626578,NULL),(128610,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128610,38.22,0.09,441,59063,70,NULL,NULL,'2MASX J15181261+0623285',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00009,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,229.5527083,6.39117,0.057,NULL,56409233619,881394275,13771785,17.9),(128611,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128611,36.99,0.21,250,59064,70,NULL,NULL,'2MASX J15181343+0510211',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.5560417,5.17247,0.073,NULL,56426422307,881662848,13775982,17.3),(128612,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128612,38.49,0.46,499,59065,70,NULL,NULL,'SDSS J151813.44+045342.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.556417,4.89517,0.065,NULL,56380376390,880943381,13764740,18.2),(128613,'SBF','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128613,32.31,0.14,29,59066,74.4,NULL,NULL,'NGC 5898',NULL,'2013AJ....146...86T',2013,1,2.2,NULL,'G',0.000014,NULL,'12.49',2,'E0','in a pair',NULL,NULL,NULL,1,229.5565,-24.09794,0.477,NULL,46622825303,728481645,11382525,12.49),(128614,'SBF','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128614,32.32,0.26,29.1,59066,NULL,NULL,'I','NGC 5898',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128615,'SBF','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128615,32.32,0.26,29.1,59066,NULL,NULL,NULL,'NGC 5898',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128616,'SBF','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128616,32.44,0.26,30.7,59066,NULL,NULL,'Malmquist cor.','NGC 5898',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128617,'D-Sigma','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128617,32.08,0.4,26,59066,75,NULL,'Edat, raw','NGC 5898',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128618,'D-Sigma','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128618,32.39,0.4,30.1,59066,75,NULL,'Edat, cor','NGC 5898',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128619,'Faber-Jackson','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128619,31.16,0.63,17.1,59066,95,NULL,'Michard 1979b, c','NGC 5898',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128620,'Faber-Jackson','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128620,31.74,0.37,22.3,59066,95,NULL,'Weighted Mean','NGC 5898',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128621,'Faber-Jackson','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128621,31.98,0.46,24.9,59066,95,NULL,'Michard 1979a','NGC 5898',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128622,'Faber-Jackson','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128622,34.54,0.81,80.9,59066,55,NULL,'Visvanathan & Sandage 1979','NGC 5898',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128623,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128623,32.23,0.41,27.9,59066,NULL,NULL,NULL,'NGC 5898',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128624,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128624,32.48,0.41,31.4,59066,NULL,NULL,'Malmquist cor.','NGC 5898',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128625,'Tully est','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128625,32.57,0.8,32.6,59066,75,NULL,'B','NGC 5898',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128626,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128626,32.65,0.4,33.8,59066,NULL,NULL,'mean','NGC 5898',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128627,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128627,32.77,0.45,35.8,59066,NULL,NULL,'K','NGC 5898',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128628,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128628,37.53,0.33,321,59067,70,NULL,NULL,'2MASX J15181435+2823339',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.24',0.19,NULL,NULL,NULL,NULL,NULL,1,229.5597083,28.39289,0.033,NULL,59911012729,936109573,14626712,18.24),(128629,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128629,36.14,0.11,169,59068,70,NULL,NULL,'2MASX J15181565+0431021',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,229.56525,4.51714,0.065,NULL,56383258470,880988413,13765443,16.7),(128630,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128630,37.94,0.46,387,59069,70,NULL,NULL,'2MASX J15181567+5101381',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000173,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,229.565375,51.02731,0.033,NULL,59666227958,932284811,14566950,17.5),(128631,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128631,35.88,0.58,150,59070,70,NULL,NULL,'ESO 449- G 003',NULL,'2014MNRAS.445.2677S',2014,1,1.79,NULL,'G',0.00015,NULL,'15.8',0.2,'Sc',NULL,NULL,NULL,NULL,1,229.5755,-32.24944,0.545,NULL,47202932249,737545816,11524153,15.8),(128632,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128632,39.02,0.46,635,59071,70,NULL,NULL,'2MASX J15181827+2952503',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,229.5759583,29.8805,0.021,NULL,59907054215,936047722,14625745,18),(128633,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128633,37.19,0.46,274,59072,70,NULL,NULL,'2MASX J15181894+1104575',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,229.579041667,11.08281,0.097,NULL,59356498636,927445291,14491332,17.1),(128634,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128634,37.3,0.46,288,59073,70,NULL,NULL,'2MASX J15182005+5427569',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000149,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.583625,54.46586,0.017,NULL,59662327459,932223866,14565997,17.9),(128635,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128635,37.15,0.46,269,59074,70,NULL,NULL,'2MASX J15182132-0139127',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00015,NULL,'16.8g',0.29,'poss. LINER',NULL,NULL,NULL,NULL,1,229.588875,-1.65356,0.245,NULL,45376871366,709013615,11078337,16.8),(128636,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128636,36.45,0.46,195,59075,70,NULL,NULL,'2MASX J15182235+1425002',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,229.593083,14.41681,0.089,NULL,59575844138,930872564,14544883,16.6),(128637,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128637,38.22,0.09,441,59076,70,NULL,NULL,'2MASX J15182295+0619455',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000093,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,229.595625,6.32931,0.057,NULL,56409238385,881394349,13771786,16.7),(128638,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128638,37.3,0.46,288,59077,70,NULL,NULL,'2MASX J15182345+2211459',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,229.597667,22.19597,0.133,NULL,59424174960,928502733,14507855,17.7),(128639,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128639,36.48,0.46,197,59078,70,NULL,NULL,'LCRS B151547.8-021803',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00012,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,229.598625,-2.48264,0.313,NULL,45376266310,709004161,11078190,16.6),(128640,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128640,38.35,0.46,467,59079,70,NULL,NULL,'2MASX J15182380+1849399',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,229.599125,18.82769,0.129,NULL,59412317732,928317464,14504960,NULL),(128641,'IRAS','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128641,33.94,0.8,61.5,59080,75,NULL,'MAT, I','ESO 328- G 041',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000026,NULL,'14.1b',0.5,'(R\')SB(r)ab',NULL,NULL,NULL,NULL,1,229.599167,-38.50678,0.345,NULL,47191737675,737370901,11521420,14.1),(128642,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128642,33.63,0.43,53.3,59080,75,NULL,'MAT, I, raw','ESO 328- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128643,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128643,33.68,0.49,54.5,59080,75,NULL,'IR','ESO 328- G 041',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128644,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128644,33.75,0.32,56.3,59080,85,NULL,'I, raw','ESO 328- G 041',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128645,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128645,33.8,0.46,57.5,59080,NULL,NULL,'J','ESO 328- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128646,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128646,33.82,0.32,58,59080,85,NULL,'I, inv','ESO 328- G 041',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128647,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128647,33.84,0.47,58.6,59080,NULL,NULL,'H','ESO 328- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128648,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128648,33.9,0.43,60.2,59080,75,NULL,'MAT, I, inv','ESO 328- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128649,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128649,33.95,0.43,61.7,59080,75,NULL,'MAT, I, cor','ESO 328- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128650,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128650,33.96,0.45,61.9,59080,NULL,NULL,'K','ESO 328- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128651,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128651,34,0.4,63.1,59080,NULL,NULL,'mean','ESO 328- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128652,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128652,34.1,0.34,66,59080,NULL,NULL,NULL,'ESO 328- G 041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128653,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128653,34.14,0.2,67.3,59080,74.4,NULL,NULL,'ESO 328- G 041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128654,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128654,34.16,0.33,67.9,59080,NULL,NULL,'Malmquist cor.','ESO 328- G 041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128655,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128655,33.97,0.46,62.3,59081,70,NULL,NULL,'2MASX J15182391+2355279',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'15.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,229.599667,23.92456,0.149,NULL,59422589396,928477959,14507468,15.4),(128656,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128656,37.25,0.16,281,59082,70,NULL,NULL,'2MASX J15182414+4502061',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,229.60075,45.03497,0.033,NULL,59967795714,936996808,14640575,17),(128657,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128657,38.11,0.33,418,59083,70,NULL,NULL,'2MASX J15182441+0512021',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,'PHOT','17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,229.6017083,5.20053,0.065,NULL,56426426291,881662910,13775982,17.1),(128658,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128658,36.94,0.46,244,59084,70,NULL,NULL,'2MASX J15182446+2111469',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.43',0.15,NULL,NULL,NULL,NULL,NULL,1,229.602041667,21.19631,0.161,NULL,59415659449,928369678,14505776,18.43),(128659,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128659,38.44,0.33,488,59085,70,NULL,NULL,'SDSS J151824.61+041025.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000075,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,229.6025417,4.17369,0.037,NULL,56382414622,880975228,13765237,18.6),(128660,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128660,37.48,0.23,314,59086,70,NULL,NULL,'2MASX J15182471+5658329',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00009,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,229.602875,56.97592,0.025,NULL,57588941578,899827212,14059800,17.4),(128661,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128661,35.13,0.47,106,59087,NULL,NULL,'H','CGCG 077-069',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.00004,NULL,'14.9',0.4,'S0a','Group member',NULL,NULL,NULL,1,229.6100417,12.93819,0.121,NULL,59572866826,930826044,14544156,14.9),(128662,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128662,35.35,0.4,117,59087,NULL,NULL,'mean','CGCG 077-069',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128663,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128663,35.35,0.45,118,59087,NULL,NULL,'K','CGCG 077-069',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128664,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128664,35.38,0.46,119,59087,NULL,NULL,'J','CGCG 077-069',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128665,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128665,38.22,0.09,441,59088,70,NULL,NULL,'SDSS J151826.82+062502.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.6117917,6.41733,0.049,NULL,56409229992,881394218,13771784,18.2),(128666,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128666,38.06,0.27,410,59089,70,NULL,NULL,'2MASX J15182695+0439141',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,229.612375,4.65381,0.065,NULL,56380373660,880943338,13764739,16.8),(128667,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128667,36.71,0.17,219,59090,70,NULL,NULL,'2MASX J15182728+0426111',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000089,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,229.613583333,4.43642,0.029,NULL,56382206494,880971976,13765187,17.4),(128668,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128668,38.11,0.33,418,59091,70,NULL,NULL,'2MASX J15182749+0511421',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,229.614458333,5.19514,0.065,NULL,56426425501,881662898,13775982,NULL),(128669,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128669,35.52,0.46,127,59092,70,NULL,NULL,'CGCG 049-113',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000123,NULL,'14.63',0.39,'E/S0',NULL,NULL,NULL,NULL,1,229.6159583,4.67558,0.065,NULL,56380373446,880943335,13764739,14.63),(128670,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128670,36.02,0.21,160,59092,70,NULL,NULL,'CGCG 049-113',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128671,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128671,36.65,0.33,214,59093,70,NULL,NULL,'2MASX J15182783+3312075',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000183,NULL,'16.0g',0.35,'E0',NULL,NULL,NULL,NULL,1,229.615833,33.20206,0.021,NULL,60112881405,939263771,14675996,16),(128672,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128672,38.26,0.46,448,59094,70,NULL,NULL,'2MASX J15182796+0540451',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,229.6165,5.67931,0.065,NULL,56426088742,881657636,13775900,17.6),(128673,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128673,38.09,0.46,415,59095,70,NULL,NULL,'2MASX J15182893+2125519',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.6204583,21.43097,0.149,NULL,59415721629,928370650,14505791,18),(128674,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128674,37.66,0.46,341,59096,70,NULL,NULL,'2MASX J15182978+5509129',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000139,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,229.62425,55.15367,0.013,NULL,57581295751,899707746,14057933,17.2),(128675,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128675,37.55,0.46,323,59097,70,NULL,NULL,'2MASX J15183025+5232551',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,229.625916667,52.54867,0.025,NULL,59661130574,932205165,14565705,16.9),(128676,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128676,36.61,0.46,210,59098,70,NULL,NULL,'2MASX J15183060+2019218',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.87',0.32,NULL,NULL,NULL,NULL,NULL,1,229.627417,20.32289,0.177,NULL,59412647468,928322616,14505040,16.87),(128677,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128677,38.22,0.09,441,59099,70,NULL,NULL,'2MASX J15183060+0619595',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000083,NULL,'16.7g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,229.6275417,6.33303,0.057,NULL,56409239332,881394364,13771786,16.7),(128678,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128678,38,0.27,397,59100,70,NULL,NULL,'SDSS J151831.34+021655.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.630625,2.28222,0.077,NULL,56377643089,880900673,13764073,18.1),(128679,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128679,38.22,0.09,441,59101,70,NULL,NULL,'2MASX J15183220+0623595',NULL,'2015arXiv151105856S',2015,1,0.4,'XBS J151832.3+062357 is identified as a GClstr in 2008A&A...477..735C.','G',0.000047,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,229.634208333,6.39975,0.049,NULL,56409240639,881394384,13771787,17.1),(128680,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128680,37.72,0.46,350,59102,70,NULL,NULL,'2MASX J15183240-0153037',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000175,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.634916667,-1.88436,0.249,NULL,45376887430,709013866,11078341,18),(128681,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128681,35.97,0.46,156,59103,70,NULL,NULL,'2MASX J15183241+0707205',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000047,NULL,'15.8g',0.4,NULL,'Group member',NULL,NULL,NULL,1,229.635125,7.12242,0.061,NULL,59350348159,927349189,14489831,15.8),(128682,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128682,36.67,0.46,216,59104,70,NULL,NULL,'2MASX J15183248+5824519',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000201,NULL,'15.6g',0.5,'E0',NULL,NULL,NULL,NULL,1,229.635375,58.41442,0.013,NULL,57721314592,901895540,14092117,15.6),(128683,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128683,38.44,0.33,488,59105,70,NULL,NULL,'SDSS J151833.13+041217.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000083,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,229.638083,4.20481,0.029,NULL,56382412865,880975201,13765237,18.5),(128684,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128684,35.88,0.46,150,59106,70,NULL,NULL,'2MASX J15183320+5228191',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000157,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,229.6382083,52.47186,0.025,NULL,59675003225,932421925,14569092,16.6),(128685,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128685,38.18,0.27,432,59107,70,NULL,NULL,'2MASX J15183334+3119485',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000146,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.639,31.33011,0.021,NULL,59903492024,935992062,14624875,17.8),(128686,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128686,37.42,0.46,305,59108,70,NULL,NULL,'2MASX J15183441+4802121',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,229.6432083,48.03667,0.045,NULL,59937629257,936525457,14633210,17.2),(128687,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128687,38.22,0.09,441,59109,70,NULL,NULL,'2MASX J15183448+0617265',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00007,NULL,'17.5g',0.19,NULL,'Group member',NULL,NULL,NULL,1,229.643625,6.29069,0.057,NULL,56409243784,881394434,13771788,17.5),(128688,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128688,37.98,0.13,394,59110,70,NULL,NULL,'2MASX J15183498+1946564',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,229.645625,19.78256,0.165,NULL,59413360121,928333751,14505214,18.5),(128689,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128689,35.23,0.58,111,59111,70,NULL,NULL,'LCRS B151558.8-033511',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.000103,NULL,'16.63',NULL,NULL,NULL,NULL,NULL,NULL,1,229.649167,-3.76817,0.329,NULL,45371743998,708933499,11077085,16.63),(128690,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128690,33.11,0.58,41.9,59112,70,NULL,NULL,'ESO 514- G 003',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00006,NULL,'14.6',0.6,'E+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,229.6497917,-24.11994,0.629,NULL,46622830909,728481732,11382527,14.6),(128691,'Tully est','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128691,32.67,0.8,34.2,59112,75,NULL,'B','ESO 514- G 003',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128692,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128692,38.22,0.09,441,59113,70,NULL,NULL,'SDSS J151836.14+062551.9',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00018,NULL,'17.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,229.650708333,6.43119,0.049,NULL,56409409450,881397022,13771828,17.2),(128693,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128693,38.2,0.46,437,59114,70,NULL,NULL,'SDSS J151836.20+452055.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000173,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,229.650875,45.34886,0.037,NULL,59967602505,936993789,14640527,18.3),(128694,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128694,38.22,0.09,441,59115,70,NULL,NULL,'2MASX J15183627+0551231',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000113,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,229.651083,5.8565,0.065,NULL,56426230087,881659845,13775935,18.2),(128695,'SBF','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128695,32.65,0.23,33.9,59116,NULL,NULL,'I','NGC 5903',NULL,'2001ApJ...546..681T',2001,1,2.7,NULL,'G',0.000017,NULL,'12.20',2.1,'E2','in a pair',NULL,NULL,NULL,1,229.6522083,-24.06858,0.477,NULL,46622832058,728481750,11382527,12.2),(128696,'SBF','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128696,32.65,0.23,33.9,59116,NULL,NULL,NULL,'NGC 5903',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128697,'SBF','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128697,32.69,0.23,34.5,59116,NULL,NULL,'Malmquist cor.','NGC 5903',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128698,'SBF','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128698,32.69,0.14,34.5,59116,74.4,NULL,NULL,'NGC 5903',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128699,'D-Sigma','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128699,32.08,0.4,26,59116,75,NULL,'Edat, raw','NGC 5903',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128700,'D-Sigma','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128700,32.39,0.4,30.1,59116,75,NULL,'Edat, cor','NGC 5903',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128701,'Faber-Jackson','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128701,31.96,0.37,24.7,59116,95,NULL,'Weighted Mean','NGC 5903',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128702,'Faber-Jackson','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128702,32.28,0.63,28.6,59116,95,NULL,'Michard 1979b, c','NGC 5903',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128703,'Faber-Jackson','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128703,32.47,0.46,31.2,59116,95,NULL,'Michard 1979a','NGC 5903',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128704,'Faber-Jackson','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128704,33.62,0.81,53,59116,55,NULL,'Visvanathan & Sandage 1979','NGC 5903',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128705,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128705,32.23,0.41,28,59116,NULL,NULL,NULL,'NGC 5903',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128706,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128706,32.49,0.41,31.4,59116,NULL,NULL,'Malmquist cor.','NGC 5903',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128707,'Tully est','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128707,32.78,0.8,35.9,59116,75,NULL,'B','NGC 5903',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128708,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128708,32.61,0.45,33.2,59116,NULL,NULL,'K','NGC 5903',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128709,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128709,32.68,0.4,34.4,59116,NULL,NULL,'mean','NGC 5903',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128710,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128710,36.48,0.46,198,59117,70,NULL,NULL,'2MASX J15183660+4654292',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,229.6525,46.90808,0.057,NULL,59983754051,937246157,14644471,16.9),(128711,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128711,37.28,0.46,285,59118,70,NULL,NULL,'2MASX J15183690+1500512',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',NULL,NULL,'15.8g',0.42,NULL,NULL,NULL,NULL,NULL,1,229.653667,15.01433,0.077,NULL,59575330680,930864541,14544758,15.8),(128712,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128712,37.58,0.46,328,59119,70,NULL,NULL,'2MASX J15183703+3056245',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000175,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,229.654083333,30.94014,0.009,NULL,59903428332,935991067,14624860,16.9),(128713,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128713,37.92,0.46,384,59120,70,NULL,NULL,'2MASX J15183704+3040465',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,229.6545,30.67956,0.005,NULL,59906877658,936044963,14625702,17.1),(128714,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128714,36.93,0.46,243,59121,70,NULL,NULL,'2MASX J15183888+4045005',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000209,NULL,'16.1g',0.42,'Sy1',NULL,NULL,NULL,'Sy 1',1,229.662166667,40.75003,0.033,NULL,59972161511,937065023,14641640,16.1),(128715,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128715,37.51,0.21,317,59122,70,NULL,NULL,'VII Zw 594 NED03',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'16.6g',0.33,'E/SA0^-^',NULL,NULL,NULL,NULL,1,229.662375,59.08225,0.013,NULL,57718319459,901848741,14091386,16.6),(128716,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128716,36.34,0.46,186,59123,70,NULL,NULL,'2MASX J15183937+0347451',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000091,NULL,'15.9g',0.44,'S0^-',NULL,NULL,NULL,NULL,1,229.664167,3.79578,0.033,NULL,56382853544,880982086,13765345,15.9),(128717,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128717,37.32,0.33,291,59124,70,NULL,NULL,'2MASX J15183972+2011574',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.665583,20.19936,0.181,NULL,59413114533,928329914,14505154,17.2),(128718,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128718,37.34,0.46,293,59125,70,NULL,NULL,'2MASX J15184091+5519579',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.670375,55.33269,0.013,NULL,57580833817,899700528,14057820,17.4),(128719,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128719,36.71,0.17,219,59126,70,NULL,NULL,'2MASX J15184096+0425054',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00008,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,229.670583333,4.41817,0.065,NULL,56382205270,880971957,13765186,16.6),(128720,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128720,37.67,0.46,343,59127,70,NULL,NULL,'2MASX J15184208+0449084',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,229.675333333,4.819,0.065,NULL,56426290601,881660790,13775949,17.2),(128721,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128721,36.71,0.17,219,59128,70,NULL,NULL,'2MASX J15184250+0403494',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000071,NULL,'16.1g',0.38,'S0/a',NULL,NULL,NULL,NULL,1,229.677,4.06372,0.029,NULL,56382347922,880974186,13765221,16.1),(128722,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128722,37.32,0.33,291,59129,70,NULL,NULL,'2MASX J15184256+2009354',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,229.677333333,20.15994,0.181,NULL,59413156286,928330566,14505165,16.6),(128723,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128723,38.22,0.09,441,59130,70,NULL,NULL,'SDSS J151842.67+055639.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000153,NULL,'17.5R',0.11,NULL,NULL,NULL,NULL,NULL,1,229.677833,5.94425,0.073,NULL,56426195956,881659311,13775926,17.5),(128724,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128724,36.47,0.1,197,59131,70,NULL,NULL,'2MASX J15184300+2053284',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.93',0.19,NULL,NULL,NULL,NULL,NULL,1,229.67925,20.89128,0.161,NULL,59416483394,928382553,14505977,17.93),(128725,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128725,38.71,0.46,551,59132,70,NULL,NULL,'2MASX J15184412+0342274',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000122,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,229.6837083,3.70761,0.033,NULL,56382860217,880982190,13765346,17.2),(128726,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128726,36.65,0.33,214,59133,70,NULL,NULL,'2MASX J15184440+3314245',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000161,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,229.685166667,33.24008,0.021,NULL,60112875666,939263682,14675995,16.4),(128727,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128727,38.26,0.46,448,59134,70,NULL,NULL,'2MASX J15184489+1442575',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'16.1r',NULL,'BrClG',NULL,NULL,NULL,NULL,1,229.6870417,14.71606,0.081,NULL,59575787860,930871685,14544870,16.1),(128728,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128728,38.22,0.09,441,59135,70,NULL,NULL,'2MASX J15184500+0616264',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.9g',0.29,NULL,'Group member',NULL,NULL,NULL,1,229.687625,6.27406,0.053,NULL,56409435819,881397434,13771834,16.9),(128729,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128729,38.22,0.09,441,59136,70,NULL,NULL,'2MASX J15184574+0613554',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000147,NULL,'16.6g',0.39,'BrClG','Group member',NULL,'NAT',NULL,1,229.690541667,6.23225,0.053,NULL,56409433203,881397393,13771834,16.6),(128730,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128730,38.22,0.09,441,59137,70,NULL,NULL,'2MASX J15184613+0600404',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00012,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.692167,6.01119,0.073,NULL,56426198928,881659358,13775927,18.2),(128731,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128731,36.97,0.27,248,59138,70,NULL,NULL,'2MASX J15184647+3316485',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,229.6937083,33.28025,0.021,NULL,60112868973,939263577,14675993,17.3),(128732,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128732,37.29,0.46,288,59139,70,NULL,NULL,'2MASX J15184652+1222035',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,229.69375,12.36775,0.117,NULL,59561274998,930644921,14541326,17.6),(128733,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128733,38.22,0.09,441,59140,70,NULL,NULL,'2MASX J15184742+0617014',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000063,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,229.697583333,6.28367,0.053,NULL,56409435938,881397436,13771834,18.3),(128734,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128734,38.22,0.09,441,59141,70,NULL,NULL,'2MASX J15184789+0607394',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,229.699625,6.12769,0.053,NULL,56409210898,881393920,13771780,17.1),(128735,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128735,37.51,0.21,317,59142,70,NULL,NULL,'VII Zw 594 NED04',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000181,NULL,'16.1g',0.41,'E',NULL,NULL,NULL,NULL,1,229.704958333,59.06411,0.013,NULL,57718319188,901848737,14091386,16.1),(128736,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128736,37.22,0.46,278,59143,70,NULL,NULL,'2MASX J15185066+4854219',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.711167,48.90611,0.033,NULL,59936896065,936514001,14633031,17.7),(128737,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128737,37.98,0.13,394,59144,70,NULL,NULL,'2MASX J15185105+1944234',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'17.32',0.35,'BrClG',NULL,NULL,NULL,NULL,1,229.7127917,19.73981,0.165,NULL,59413274717,928332417,14505194,17.32),(128738,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128738,38.04,0.46,406,59145,70,NULL,NULL,'2MASX J15185134+2844288',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.60',0.16,'BrClG',NULL,NULL,NULL,NULL,1,229.7139583,28.74131,0.037,NULL,59908828453,936075444,14626178,18.6),(128739,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128739,37.86,0.21,374,59146,70,NULL,NULL,'2MASX J15185162+2709168',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.29',0.22,NULL,NULL,NULL,NULL,NULL,1,229.7149583,27.15467,0.077,NULL,59911320602,936114384,14626787,18.29),(128740,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128740,36.48,0.78,198,59147,70,NULL,NULL,'2MASX J15185164-2007572',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,229.715125,-20.13264,0.485,NULL,46616306544,728379789,11380934,15.2),(128741,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128741,37.91,0.46,382,59148,70,NULL,NULL,'2MASX J15185222+0251154',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000105,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,229.7177083,2.85414,0.049,NULL,56384073180,881001143,13765642,17.2),(128742,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128742,37.14,0.46,268,59149,70,NULL,NULL,'2MASX J15185243+3105115',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,229.718375,31.08647,0.017,NULL,59903408534,935990758,14624855,16.9),(128743,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128743,35.81,0.25,145,59150,74.4,NULL,NULL,'CGCG 049-117',NULL,'2013AJ....146...86T',2013,1,0.76,'1994AJ....107.1629T has 13044 +- 100 km/sec.','G',0.00013,NULL,'14.16',0.64,'Sbc',NULL,NULL,NULL,NULL,1,229.719167,4.86569,0.069,NULL,56426298223,881660909,13775951,14.16),(128744,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128744,36.02,0.21,160,59150,70,NULL,NULL,'CGCG 049-117',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128745,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128745,38.22,0.09,441,59151,70,NULL,NULL,'2MASX J15185271+0621014',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000047,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,229.7197917,6.35039,0.049,NULL,56409443416,881397553,13771836,18.1),(128746,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128746,38.04,0.46,406,59152,70,NULL,NULL,'2MASX J15185304+1144104',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,229.721125,11.73636,0.097,NULL,59355851127,927435173,14491174,16.8),(128747,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128747,38.22,0.09,441,59153,70,NULL,NULL,'2MASX J15185357+0601004',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000057,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,229.723166667,6.01686,0.073,NULL,56426193972,881659280,13775926,17.4),(128748,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128748,36.13,0.09,168,59154,70,NULL,NULL,'2MASX J15185364+0734334',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000158,NULL,'16.4g',0.29,NULL,'Group member',NULL,NULL,NULL,1,229.723583,7.57592,0.061,NULL,59349775199,927340237,14489691,16.4),(128749,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128749,38.22,0.09,441,59155,70,NULL,NULL,'2MASX J15185464+0603164',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000127,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.7277083,6.05456,0.073,NULL,56426121191,881658143,13775908,17.5),(128750,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128750,37.11,0.46,264,59156,70,NULL,NULL,'2MASX J15185503+3006295',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000191,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,229.729125,30.10819,0.041,NULL,59907091149,936048299,14625754,16.5),(128751,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128751,37.27,0.46,285,59157,70,NULL,NULL,'2MASX J15185509+3418135',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000178,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.7295417,34.30381,0.041,NULL,60105122331,939142536,14674102,17),(128752,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128752,38.88,0.46,598,59158,70,NULL,NULL,'2MASX J15185510+1905114',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.7297083,19.08656,0.145,NULL,59412346630,928317916,14504967,17.7),(128753,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128753,37.86,0.21,374,59159,70,NULL,NULL,'2MASX J15185558+2707398',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,229.731625,27.12783,0.077,NULL,59911310258,936114222,14626784,17.9),(128754,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128754,35.95,0.57,155,59160,70,NULL,NULL,'2MASX J15185566-0827238',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.82',0.2,'poss. LINER',NULL,NULL,NULL,NULL,1,229.731833,-8.45678,0.325,NULL,46480300735,726254698,11347729,16.82),(128755,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128755,36.89,0.46,239,59161,70,NULL,NULL,'2MASX J15185576+2127493',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.56',0.22,NULL,NULL,NULL,NULL,NULL,1,229.73225,21.46378,0.149,NULL,59415687439,928370116,14505783,17.56),(128756,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128756,37.75,0.46,355,59162,70,NULL,NULL,'2MASX J15185577+1450475',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,229.732333,14.84672,0.081,NULL,59575303581,930864118,14544751,18),(128757,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128757,38.22,0.46,440,59163,70,NULL,NULL,'2MASX J15185603+5501437',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000145,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,229.7335417,55.02881,0.013,NULL,57581481958,899710655,14057978,18.4),(128758,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128758,37.64,0.15,337,59164,70,NULL,NULL,'SDSS J151856.15+484403.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000178,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.7339583,48.73419,0.033,NULL,59937110667,936517354,14633083,17.6),(128759,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128759,36.47,0.1,197,59165,70,NULL,NULL,'2MASX J15185622+2103313',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,229.734167,21.05875,0.161,NULL,59416335617,928380244,14505941,18),(128760,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128760,36.97,0.27,248,59166,70,NULL,NULL,'SDSS J151856.39+332152.2',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000172,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.7349583,33.36453,0.017,NULL,60112838676,939263104,14675986,16.4),(128761,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128761,37.66,0.46,340,59167,70,NULL,NULL,'2MASX J15185642+5412297',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,229.735083333,54.20825,0.017,NULL,59662818206,932231534,14566117,17.6),(128762,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128762,36.1,0.27,166,59168,70,NULL,NULL,'CGCG 049-121',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.00011,NULL,'15.3',0.44,NULL,NULL,NULL,NULL,NULL,1,229.735833,5.19178,0.085,NULL,56426406832,881662606,13775978,15.3),(128763,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128763,37.98,0.13,394,59169,70,NULL,NULL,'SDSS J151856.97+194200.2',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.3g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.737416667,19.70008,0.165,NULL,59413278102,928332470,14505194,17.3),(128764,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128764,38.22,0.09,441,59170,70,NULL,NULL,'2MASX J15185768+0611514',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000057,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.740291667,6.19775,0.053,NULL,56409425705,881397276,13771832,17.5),(128765,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128765,38.22,0.09,441,59171,70,NULL,NULL,'2MASX J15185826+0557584',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000063,NULL,'16.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,229.743041667,5.96628,0.073,NULL,56426123973,881658187,13775909,16),(128766,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128766,38,0.27,397,59172,70,NULL,NULL,'2MASX J15185843+0216044',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.7435,2.26783,0.109,NULL,56377642977,880900671,13764072,17.6),(128767,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128767,36.14,0.11,169,59173,70,NULL,NULL,'2MASX J15185861+0431454',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,229.7442083,4.52936,0.065,NULL,56427560813,881680637,13776259,16.8),(128768,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128768,38.22,0.09,441,59174,70,NULL,NULL,'2MASX J15185946+0604564',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00006,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,229.7477917,6.08239,0.053,NULL,56426122440,881658163,13775908,16.8),(128769,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128769,36.97,0.27,248,59175,70,NULL,NULL,'2MASX J15185950+3319009',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000185,NULL,'16.0g',0.39,'E0',NULL,NULL,NULL,NULL,1,229.747875,33.31678,0.021,NULL,60112868350,939263567,14675993,16),(128770,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128770,38,0.27,397,59176,70,NULL,NULL,'SDSS J151859.84+021428.6',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.6g',0.3,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.749333,2.24131,0.109,NULL,56377641450,880900647,13764072,16.6),(128771,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128771,37.97,0.46,392,59177,70,NULL,NULL,'2MASX J15190003+0908514',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00014,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,229.7500417,9.14778,0.061,NULL,59350760708,927355636,14489931,18),(128772,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128772,38.24,0.14,444,59178,70,NULL,NULL,'SDSS J151900.01+041038.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000084,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,229.750083,4.17739,0.041,NULL,56382341703,880974089,13765220,18.3),(128773,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128773,37.25,0.16,281,59179,70,NULL,NULL,'2MASX J15190107+4503374',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,229.754417,45.06036,0.033,NULL,59967792311,936996754,14640574,17.1),(128774,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128774,36.71,0.17,219,59180,70,NULL,NULL,'2MASX J15190129+0402594',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000099,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,229.7552917,4.04997,0.029,NULL,56382353390,880974271,13765222,16.9),(128775,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128775,35.81,0.25,145,59181,74.4,NULL,NULL,'CGCG 049-120',NULL,'2013AJ....146...86T',2013,1,0.25,NULL,'G',0.00011,NULL,'13.7',0.2,'E/S0',NULL,NULL,NULL,NULL,1,229.756083,4.52078,0.065,NULL,56427557247,881680581,13776259,13.7),(128776,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128776,36.02,0.21,160,59181,70,NULL,NULL,'CGCG 049-120',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128777,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128777,36.14,0.11,169,59181,70,NULL,NULL,'CGCG 049-120',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128778,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128778,36.03,0.4,161,59181,NULL,NULL,'mean','CGCG 049-120',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128779,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128779,36.06,0.45,163,59181,NULL,NULL,'K','CGCG 049-120',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128780,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128780,36.14,0.11,169,59182,70,NULL,NULL,'2MASX J15190155+0423294',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000083,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.7564583,4.39164,0.065,NULL,56427571506,881680804,13776262,17.5),(128781,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128781,35.16,0.46,108,59183,70,NULL,NULL,'2MASX J15190268+1346465',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'16.11',0.37,NULL,NULL,NULL,NULL,NULL,1,229.7610417,13.7795,0.101,NULL,59573126550,930830102,14544220,16.11),(128782,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128782,37.51,0.21,317,59184,70,NULL,NULL,'VII Zw 594 NED07',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000189,NULL,'16.6g',0.26,'SA:0/a:',NULL,NULL,NULL,NULL,1,229.762583,59.12633,0.013,NULL,57718298139,901848408,14091381,16.6),(128783,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128783,36.16,0.09,171,59185,70,NULL,NULL,'CGCG 049-125',NULL,'2015arXiv151105856S',2015,1,0.96,NULL,'G',0.000107,NULL,'15.5',0.57,NULL,NULL,NULL,NULL,NULL,1,229.764125,8.13872,0.053,NULL,59353163016,927393172,14490518,15.5),(128784,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128784,35.55,0.25,129,59186,74.4,NULL,NULL,'CGCG 049-123',NULL,'2013AJ....146...86T',2013,1,1.03,NULL,'G',0.00009,NULL,'14.6g',0.67,'E/S0',NULL,NULL,NULL,NULL,1,229.764625,4.33364,0.045,NULL,56427574937,881680858,13776263,14.6),(128785,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128785,36.02,0.21,160,59186,70,NULL,NULL,'CGCG 049-123',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128786,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128786,36.71,0.17,219,59186,70,NULL,NULL,'CGCG 049-123',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128787,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128787,37.51,0.46,317,59187,70,NULL,NULL,'2MASX J15190349+4811139',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000183,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.764583,48.18722,0.045,NULL,59937608213,936525128,14633205,17.1),(128788,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128788,37.83,0.46,368,59188,70,NULL,NULL,'2MASX J15190453+0634264',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000067,NULL,'17.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,229.76875,6.574,0.057,NULL,56409347164,881396049,13771813,17.5),(128789,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128789,36.71,0.17,219,59189,70,NULL,NULL,'2MASX J15190503+0415334',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000071,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,229.771125,4.25939,0.041,NULL,56427564763,881680699,13776260,16.7),(128790,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128790,35,0.46,99.9,59190,70,NULL,NULL,'MCG -03-39-005',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000057,NULL,'14.3',0.3,NULL,NULL,NULL,NULL,NULL,1,229.7724583,-15.99619,0.437,NULL,46669123342,729205052,11393828,14.3),(128791,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128791,36.47,0.1,197,59191,70,NULL,NULL,'2MASX J15190560+2053576',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.29',0.17,NULL,NULL,NULL,NULL,NULL,1,229.773417,20.89944,0.181,NULL,59416356368,928380568,14505946,18.29),(128792,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128792,37.25,0.16,281,59192,70,NULL,NULL,'2MASX J15190588+4501554',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000165,NULL,'16.0g',0.46,'BrClG          AGN',NULL,NULL,NULL,NULL,1,229.774375,45.03219,0.033,NULL,59967792694,936996760,14640574,16),(128793,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128793,38.01,0.46,399,59193,70,NULL,NULL,'2MASX J15190588-0053087',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000091,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,229.774625,-0.88575,0.177,NULL,45377468763,709022949,11078483,17.5),(128794,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128794,34.12,NULL,66.6,59194,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09812',NULL,'2010Ap&SS.325..163P',2010,1,0.95,NULL,'G',0.000063,NULL,'15.80',0.12,'Sd','Pair member (points to parent)',NULL,NULL,NULL,1,229.7775,9.79861,0.057,NULL,59357339804,927458434,14491538,15.8),(128795,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128795,34.15,NULL,67.6,59194,NULL,NULL,'Dipole + Quadrupole','UGC 09812',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128796,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128796,34.17,NULL,68.2,59194,NULL,NULL,'Dipole','UGC 09812',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128797,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128797,38.24,0.14,444,59195,70,NULL,NULL,'SDSS J151906.71+042052.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000083,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.778,4.34792,0.045,NULL,56427577019,881680890,13776263,18.3),(128798,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128798,35.93,0.46,154,59196,70,NULL,NULL,'CGCG 021-075',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000085,NULL,'15.8g',0.43,'AGN',NULL,NULL,NULL,NULL,1,229.77825,1.04514,0.129,NULL,56379479294,880929363,13764521,15.8),(128799,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128799,37.14,0.46,268,59197,70,NULL,NULL,'SDSS J151907.47+161930.6',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,229.781125,16.32519,0.069,NULL,59566579915,930727811,14542622,NULL),(128800,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128800,37.08,0.46,260,59198,70,NULL,NULL,'2MASX J15190785-0010597',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000091,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.78275,-0.18342,0.185,NULL,45374424305,708975379,11077740,16.8),(128801,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128801,38.02,0.33,402,59199,70,NULL,NULL,'2MASX J15190843+0725544',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,229.785167,7.43192,0.061,NULL,59349869128,927341705,14489714,18),(128802,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128802,38.22,0.09,441,59200,70,NULL,NULL,'2MASX J15190854+0608344',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,229.785541667,6.14306,0.053,NULL,56409294208,881395222,13771800,16.8),(128803,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128803,38.22,0.09,441,59201,70,NULL,NULL,'2MASX J15190858+0553544',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.0001,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.78575,5.89836,0.073,NULL,56426147766,881658558,13775914,18),(128804,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128804,37.32,0.46,291,59202,70,NULL,NULL,'2MASX J15190952+1151152',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,229.7897083,11.85422,0.097,NULL,59342175477,927221491,14487835,NULL),(128805,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128805,37.06,0.46,258,59203,70,NULL,NULL,'2MASX J15190965+0511412',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.790375,5.19469,0.085,NULL,56426437817,881663090,13775985,18),(128806,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128806,37.51,0.21,317,59204,70,NULL,NULL,'VII Zw 594 NED09',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000185,NULL,'16.7g',0.25,'SB0^0^:',NULL,NULL,NULL,NULL,1,229.7910417,59.11939,0.013,NULL,57718327717,901848870,14091388,16.7),(128807,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128807,37.98,0.33,394,59205,70,NULL,NULL,'2MASX J15191053+1048422',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000147,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,229.793875,10.81175,0.085,NULL,59356381159,927443455,14491303,18),(128808,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128808,38.07,0.33,411,59206,70,NULL,NULL,'2MASX J15191097+0305322',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000091,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,229.79575,3.09225,0.065,NULL,56381968869,880968263,13765129,17.1),(128809,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128809,37.82,0.33,366,59207,70,NULL,NULL,'2MASX J15191093+4030297',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000187,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,229.79575,40.50811,0.025,NULL,59971411446,937053303,14641457,16.4),(128810,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128810,36.8,0.46,229,59208,70,NULL,NULL,'2MASX J15191112+2152406',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,229.796375,21.87789,0.137,NULL,59413639243,928338113,14505283,17.2),(128811,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128811,37.66,0.46,341,59209,70,NULL,NULL,'2MASX J15191119+5712019',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000069,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,229.7965417,57.20067,0.025,NULL,57589055420,899828990,14059827,17.9),(128812,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128812,37.98,0.13,394,59210,70,NULL,NULL,'2MASX J15191142+1938046',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,229.797458333,19.63461,0.173,NULL,59413272396,928332381,14505193,16.7),(128813,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128813,37.74,0.46,353,59211,70,NULL,NULL,'2MASX J15191138+4551044',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000184,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,229.7975,45.85117,0.045,NULL,59983273594,937238649,14644353,16.5),(128814,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128814,36.71,0.17,219,59212,70,NULL,NULL,'2MASX J15191208+0426092',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000089,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,229.80025,4.43586,0.065,NULL,56427607714,881681370,13776271,16.8),(128815,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128815,38.07,0.33,411,59213,70,NULL,NULL,'2MASX J15191257+0300372',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000072,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.802417,3.01033,0.049,NULL,56384089417,881001397,13765646,18),(128816,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128816,37.1,0.46,263,59214,70,NULL,NULL,'2MASX J15191296+4845019',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.803917,48.75053,0.033,NULL,59937111764,936517371,14633083,16.9),(128817,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128817,36.44,0.46,194,59215,70,NULL,NULL,'2MASX J15191313+0607502',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',NULL,NULL,'15.6g',0.44,'BrClG',NULL,NULL,NULL,NULL,1,229.804666667,6.13061,0.053,NULL,56409299160,881395299,13771801,15.6),(128818,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128818,38.22,0.09,441,59216,70,NULL,NULL,'SDSS J151913.38+055640.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'17.6R',0.13,NULL,NULL,NULL,NULL,NULL,1,229.805791667,5.94461,0.073,NULL,56426153752,881658652,13775916,17.6),(128819,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128819,36.98,0.46,249,59217,70,NULL,NULL,'2MASX J15191347+3021390',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000176,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,229.8062083,30.36075,0,NULL,59907001570,936046899,14625732,16.5),(128820,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128820,35.87,0.6,149,59218,70,NULL,NULL,'2MASX J15191372-1947318',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.85',NULL,NULL,NULL,NULL,NULL,NULL,1,229.807167,-19.79222,0.493,NULL,46616390728,728381105,11380954,15.85),(128821,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128821,35.84,0.35,147,59219,NULL,NULL,NULL,'CGCG 049-127',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000027,NULL,'15.7',0.3,'Sbc:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,229.8089583,8.00417,0.053,NULL,59353277713,927394964,14490546,15.7),(128822,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128822,35.92,0.34,153,59219,NULL,NULL,'Malmquist cor.','CGCG 049-127',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128823,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128823,36.17,0.2,171,59219,74.4,NULL,NULL,'CGCG 049-127',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128824,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128824,37.98,0.33,394,59220,70,NULL,NULL,'SDSS J151914.45+105401.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000142,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,229.81025,10.90044,0.081,NULL,59356369556,927443274,14491301,18.5),(128825,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128825,35.81,0.35,145,59221,NULL,NULL,NULL,'CGCG 049-126',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000013,NULL,'15.6',0.3,'Sc',NULL,NULL,NULL,NULL,1,229.811125,7.86547,0.057,NULL,59353326380,927395724,14490558,15.6),(128826,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128826,35.85,0.2,148,59221,74.4,NULL,NULL,'CGCG 049-126',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128827,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128827,35.91,0.34,152,59221,NULL,NULL,'Malmquist cor.','CGCG 049-126',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128828,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128828,37.37,0.46,298,59222,70,NULL,NULL,'2MASX J15191478+2712418',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,229.811625,27.21161,0.081,NULL,59911320076,936114376,14626787,18),(128829,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128829,38.09,0.46,415,59223,70,NULL,NULL,'2MASX J15191486+4142237',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000194,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,229.81175,41.70658,0.037,NULL,59975948441,937124194,14642565,16.7),(128830,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128830,36.9,0.46,240,59224,70,NULL,NULL,'2MASX J15191541+2001096',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,229.81425,20.0195,0.181,NULL,59413136918,928330264,14505160,16.2),(128831,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128831,38.9,0.46,603,59225,70,NULL,NULL,'2MASX J15191567+4146337',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000182,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,229.815541667,41.77606,0.037,NULL,59975949900,937124217,14642565,18.2),(128832,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128832,37.82,0.33,366,59226,70,NULL,NULL,'2MASX J15191602+4032287',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000187,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.816667,40.54136,0.025,NULL,59971410964,937053296,14641457,16.9),(128833,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128833,36.82,0.33,231,59227,70,NULL,NULL,'2MASX J15191603+0401493',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000077,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,229.816833,4.03022,0.029,NULL,56427664342,881682255,13776285,17.6),(128834,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128834,38.22,0.09,441,59228,70,NULL,NULL,'2MASX J15191633+0600063',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000093,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.818,6.00161,0.073,NULL,56426166146,881658846,13775919,17.3),(128835,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128835,38.47,0.46,495,59229,70,NULL,NULL,'2MASX J15191631-0109236',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000105,NULL,'17.6g',0.21,'AGN',NULL,NULL,NULL,NULL,1,229.818083,-1.15644,0.181,NULL,45377596977,709024952,11078514,17.6),(128836,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128836,37.13,0.46,266,59230,70,NULL,NULL,'2MASX J15191664-0020566',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000096,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,229.81925,-0.34894,0.185,NULL,45374407278,708975113,11077736,16.5),(128837,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128837,37.8,0.69,363,59230,70,NULL,NULL,'2MASX J15191664-0020566',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128838,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128838,37.57,0.33,326,59231,70,NULL,NULL,'2MASX J15191672+2623068',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000177,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,229.81975,26.38525,0.113,NULL,59910385173,936099768,14626558,16.5),(128839,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128839,37.04,0.33,256,59232,70,NULL,NULL,'2MASX J15191750+5650109',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000083,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,229.82275,56.83644,0.029,NULL,57593221043,899894078,14060844,17.2),(128840,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128840,36.47,0.1,197,59233,70,NULL,NULL,'2MASX J15191751+2050116',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,229.822917,20.83642,0.181,NULL,59416349580,928380462,14505944,17.4),(128841,'IRAS','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128841,30.88,0.8,15,59234,75,NULL,'MAT, I','ESO 328- G 043',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000019,NULL,'14.5',1.8,'(R\')SB(s)dm',NULL,NULL,NULL,NULL,1,229.8232083,-41.23372,0.565,NULL,47066984523,735421633,11490963,14.5),(128842,'Tully est','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128842,31.4,0.8,19.1,59234,75,NULL,NULL,'ESO 328- G 043',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128843,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128843,30.75,0.32,14.1,59234,85,NULL,'I, inv','ESO 328- G 043',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128844,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128844,30.76,0.32,14.2,59234,85,NULL,'I, raw','ESO 328- G 043',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128845,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128845,31.25,0.43,17.7,59234,75,NULL,'MAT, I, raw','ESO 328- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128846,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128846,31.27,0.43,18,59234,75,NULL,'MAT, I, inv','ESO 328- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128847,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128847,31.52,0.43,20.1,59234,75,NULL,'MAT, I, cor','ESO 328- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128848,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128848,38.63,0.46,532,59235,70,NULL,NULL,'2MASX J15191772+2842128',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,229.823833333,28.70367,0.037,NULL,59910922102,936108157,14626689,18.3),(128849,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128849,37.73,0.33,351,59236,70,NULL,NULL,'2MASX J15191792+0117213',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,229.824583,1.28922,0.125,NULL,56379518213,880929972,13764530,17.3),(128850,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128850,36.1,0.27,166,59237,70,NULL,NULL,'2MASX J15191809+0515093',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,229.825417,5.25269,0.085,NULL,56426445541,881663211,13775987,16.2),(128851,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128851,37.13,0.33,267,59238,70,NULL,NULL,'2MASX J15191818+3033220',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.825833,30.556,0,NULL,59906904751,936045386,14625709,17.6),(128852,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128852,36.64,0.46,213,59239,70,NULL,NULL,'2MASX J15191896+0425553',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000087,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,229.829083,4.43192,0.045,NULL,56427596503,881681195,13776268,16.4),(128853,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128853,37.98,0.33,394,59240,70,NULL,NULL,'SDSS J151919.50+455814.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000145,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,229.831333,45.97069,0.033,NULL,59983324305,937239442,14644366,18.2),(128854,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128854,37.13,0.33,267,59241,70,NULL,NULL,'2MASX J15191950+3042590',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000177,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,229.831416667,30.71653,0,NULL,59906858194,936044659,14625697,16.6),(128855,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128855,37.85,0.46,372,59242,70,NULL,NULL,'2MASX J15191985+0928492',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,229.832667,9.48042,0.061,NULL,59355387077,927427923,14491061,17.2),(128856,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128856,38.11,0.33,418,59243,70,NULL,NULL,'2MASX J15192056+0536243',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,229.835667,5.60675,0.065,NULL,56426962911,881671295,13776113,17.6),(128857,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128857,38.02,0.33,402,59244,70,NULL,NULL,'2MASX J15192069+0723402',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,'Group member',NULL,NULL,NULL,1,229.836291667,7.39447,0.061,NULL,59349915560,927342430,14489725,17.3),(128858,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128858,37.01,0.33,253,59245,70,NULL,NULL,'2MASX J15192305+0333543',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.0001,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,229.845958333,3.56511,0.033,NULL,56382037885,880969341,13765145,16.5),(128859,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128859,36,0.46,159,59246,70,NULL,NULL,'2MASX J15192338+0506173',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',NULL,NULL,'15.5g',0.44,NULL,NULL,NULL,NULL,NULL,1,229.8475417,5.10492,0.085,NULL,56426486561,881663852,13775997,15.5),(128860,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128860,37.92,0.46,383,59247,70,NULL,NULL,'2MASX J15192426+2642338',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.851208333,26.70942,0.065,NULL,59910166369,936096349,14626505,17.6),(128861,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','PTF09dnp',NULL,128861,35.92,0.02,147,59248,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF09dnp',0.037559,'2014MNRAS.438.1391P',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,229.8515417,49.49897,0.025,NULL,59666370579,932287040,14566985,NULL),(128862,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','PTF09dnp',NULL,128862,36.22,0.07,169,59248,70,NULL,'SiFTO+SALT2, SN PTF09dnp','PTF09dnp',0.037559,'2012MNRAS.426.2359M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128863,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128863,35.82,0.25,146,59249,74.4,NULL,NULL,'GIN 388',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000047,NULL,'14.56',0.4,'E/S0',NULL,NULL,NULL,NULL,1,229.852833,4.57972,0.065,NULL,56427581686,881680963,13776265,14.56),(128864,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128864,36.02,0.21,160,59249,70,NULL,NULL,'GIN 388',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128865,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128865,36.14,0.11,169,59249,70,NULL,NULL,'GIN 388',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128866,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128866,38.24,0.14,444,59250,70,NULL,NULL,'2MASX J15192471+0419533',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000096,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,229.853,4.33147,0.045,NULL,56427783865,881684122,13776314,18.5),(128867,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128867,33.42,0.59,48.4,59251,NULL,NULL,'Malmquist cor.','UGC 09814',NULL,'2009ApJS..182..474S',2009,1,1.13,'Multiple SDSS entries describe this object.','G',0.000023,NULL,'14.9g',0.49,'Sdm:',NULL,NULL,NULL,NULL,1,229.854208333,11.05431,0.089,NULL,59356426348,927444161,14491315,14.9),(128868,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128868,33.46,0.2,49.2,59251,74.4,NULL,NULL,'UGC 09814',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128869,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128869,33.49,0.57,50,59251,NULL,NULL,NULL,'UGC 09814',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128870,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128870,37.67,0.46,342,59252,70,NULL,NULL,'2MASX J15192513+0647472',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000016,NULL,'16.8g',0.3,NULL,'Group member',NULL,NULL,NULL,1,229.854667,6.79644,0.057,NULL,56409327505,881395742,13771808,16.8),(128871,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128871,38.08,0.46,414,59253,70,NULL,NULL,'2MASX J15192523+2323535',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000186,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,229.8552083,23.39828,0.161,NULL,59424500945,928507827,14507934,17.5),(128872,'IRAS','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128872,34.23,0.8,70.1,59254,75,NULL,'CF, r','NGC 5918',NULL,'1997ApJS..109..333W',1997,1,2.27,NULL,'G',0.000017,NULL,'13.8g',0.71,'Scd:','Field galaxy',NULL,NULL,NULL,1,229.85525,45.88025,0.045,NULL,59983323768,937239433,14644366,13.8),(128873,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128873,33.84,0.2,58.6,59254,74.4,NULL,NULL,'NGC 5918',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128874,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128874,33.92,0.38,60.7,59254,75,NULL,'CF, r, raw','NGC 5918',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128875,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128875,33.97,0.47,62.2,59254,NULL,NULL,'H','NGC 5918',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128876,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128876,34.04,0.45,64.2,59254,NULL,NULL,'K','NGC 5918',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128877,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128877,34.06,0.46,64.8,59254,NULL,NULL,'J','NGC 5918',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128878,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128878,34.08,0.38,65.4,59254,75,NULL,'CF, r, inv','NGC 5918',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128879,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128879,34.09,0.49,65.8,59254,75,NULL,'IR','NGC 5918',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128880,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128880,34.22,0.38,69.9,59254,75,NULL,'CF, r, cor','NGC 5918',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128881,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128881,34.25,0.4,70.9,59254,NULL,NULL,'mean','NGC 5918',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128882,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128882,35.88,0.46,150,59255,70,NULL,NULL,'2MASX J15192538+4930043',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000191,NULL,'15.8g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,229.855667,49.50131,0.025,NULL,59666370656,932287041,14566985,15.8),(128883,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128883,37.25,0.16,281,59256,70,NULL,NULL,'2MASX J15192545+4509073',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000194,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,229.855833,45.152,0.033,NULL,59967765267,936996332,14640567,16.8),(128884,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128884,36.1,0.27,166,59257,70,NULL,NULL,'2MASX J15192599+0500013',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,229.858333,5.00039,0.069,NULL,56426477396,881663709,13775995,16.6),(128885,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128885,37.43,0.46,306,59258,70,NULL,NULL,'2MASX J15192604+2729528',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.858667,27.49786,0.085,NULL,59911328272,936114504,14626789,17.4),(128886,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128886,38.24,0.14,444,59259,70,NULL,NULL,'SDSS J151926.45+040557.8',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000077,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,229.86025,4.09942,0.041,NULL,56427673824,881682403,13776287,18.1),(128887,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128887,37.57,0.33,326,59260,70,NULL,NULL,'2MASX J15192663+2624487',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000172,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,229.861,26.41353,0.113,NULL,59910352821,936099262,14626550,17.7),(128888,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128888,38.51,0.46,503,59261,70,NULL,NULL,'SDSS J151927.31+331713.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.863833,33.28703,0.045,NULL,60104537606,939133400,14673959,17.8),(128889,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128889,36.02,0.21,160,59262,70,NULL,NULL,'GIN 393',NULL,'2001MNRAS.321..277C',2001,1,0.77,NULL,'G',0.00008,NULL,'14.29',0.5,'E/S0',NULL,NULL,NULL,NULL,1,229.86525,4.09606,0.041,NULL,56427673685,881682401,13776287,14.29),(128890,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128890,36.09,0.25,165,59262,74.4,NULL,NULL,'GIN 393',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128891,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128891,36.82,0.33,231,59262,70,NULL,NULL,'GIN 393',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128892,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128892,36.47,0.1,197,59263,70,NULL,NULL,'2MASX J15192913+2046485',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.32',0.15,NULL,NULL,NULL,NULL,NULL,1,229.87125,20.78011,0.181,NULL,59416346705,928380417,14505944,18.32),(128893,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128893,38.43,0.46,486,59264,70,NULL,NULL,'2MASX J15192917+0832362',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000179,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.871667,8.54347,0.045,NULL,59350792042,927356125,14489939,17.9),(128894,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128894,37.48,0.46,313,59265,70,NULL,NULL,'2MASX J15192939+0301143',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000081,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,229.872417,3.0205,0.065,NULL,56384043297,881000676,13765635,17.1),(128895,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128895,37.32,0.46,291,59266,70,NULL,NULL,'2MASX J15192950+0704482',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00007,NULL,'17.3g',0.27,NULL,'Group member',NULL,NULL,NULL,1,229.872833,7.07997,0.061,NULL,59349849265,927341394,14489709,17.3),(128896,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128896,37.64,0.15,337,59267,70,NULL,NULL,'2MASX J15193007+4851394',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,229.8754583,48.861,0.033,NULL,59936890038,936513906,14633029,17),(128897,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128897,38.06,0.27,410,59268,70,NULL,NULL,'SDSS J151930.31+044217.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.876333,4.70483,0.065,NULL,56429706953,881714171,13776783,18.5),(128898,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128898,38.26,0.46,448,59269,70,NULL,NULL,'2MASX J15193041+1024272',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.8765417,10.40761,0.093,NULL,59356946018,927452281,14491441,17.8),(128899,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128899,37.84,0.27,370,59270,70,NULL,NULL,'2MASX J15193074+0457083',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,229.878125,4.95239,0.069,NULL,56426252091,881660188,13775940,16.5),(128900,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128900,37.73,0.33,351,59271,70,NULL,NULL,'SDSS J151930.76+011908.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.878166667,1.31889,0.125,NULL,56379562985,880930671,13764541,18.3),(128901,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128901,38.61,0.46,528,59272,70,NULL,NULL,'SDSS J151930.89+131436.1',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,229.87875,13.24339,0.105,NULL,59573672337,930838630,14544353,NULL),(128902,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128902,36.47,0.1,197,59273,70,NULL,NULL,'2MASX J15193179+2053005',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00014,NULL,'17.06',0.26,'E2','Compact group member',NULL,NULL,NULL,1,229.882458333,20.88356,0.177,NULL,59416362892,928380670,14505947,17.06),(128903,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128903,37.68,0.46,344,59274,70,NULL,NULL,'2MASX J15193229+0923482',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,229.884583333,9.39675,0.065,NULL,59355416399,927428381,14491068,16.5),(128904,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128904,38.76,0.46,564,59275,70,NULL,NULL,'SDSS J151932.62+313830.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000141,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,229.885958333,31.64183,0.029,NULL,59904005441,936000085,14625001,18.6),(128905,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128905,34.81,0.69,91.5,59276,100,NULL,'mid-IR','CGCG 077-074',NULL,'2013ApJ...771...88L',2013,1,0.95,NULL,'G',0.000016,NULL,'14.7g',0.65,'Sa',NULL,NULL,NULL,NULL,1,229.886083,9.96003,0.069,NULL,59357332445,927458319,14491536,14.7),(128906,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128906,35.96,0.2,156,59276,74.4,NULL,NULL,'CGCG 077-074',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128907,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128907,38.11,0.33,418,59277,70,NULL,NULL,'SDSS J151932.68+053051.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000063,NULL,'17.4R',0.11,NULL,NULL,NULL,NULL,NULL,1,229.886208333,5.51439,0.085,NULL,56426981994,881671593,13776118,17.4),(128908,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128908,37.93,0.46,386,59278,70,NULL,NULL,'2MASX J15193324+2810432',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,229.888458333,28.17886,0.021,NULL,59911116793,936111199,14626737,18.2),(128909,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128909,37.79,0.17,361,59279,70,NULL,NULL,'2MASX J15193354+3247153',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000142,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.889833333,32.78753,0.021,NULL,60112830216,939262972,14675983,17.9),(128910,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128910,38.11,0.46,419,59280,70,NULL,NULL,'SDSS J151933.66+201219.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.8902917,20.20544,0.177,NULL,59412706565,928323540,14505055,18.1),(128911,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128911,35.82,0.25,146,59281,74.4,NULL,NULL,'GIN 392',NULL,'2013AJ....146...86T',2013,1,0.62,'Wegner et al (1999MNRAS.305..259W) have V = 11533 +- 72 km/s.','G',0.000108,NULL,'16.2g',0.37,'BrClG;E',NULL,NULL,NULL,NULL,1,229.890541667,4.33797,0.045,NULL,56427784470,881684132,13776314,16.2),(128912,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128912,36.02,0.21,160,59281,70,NULL,NULL,'GIN 392',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128913,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128913,38.24,0.14,444,59281,70,NULL,NULL,'GIN 392',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128914,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128914,37.16,0.46,271,59282,70,NULL,NULL,'2MASX J15193370+3216103',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.8905,32.26961,0.041,NULL,60083439609,938803743,14668808,17.2),(128915,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128915,38.24,0.14,444,59283,70,NULL,NULL,'2MASX J15193380+0406533',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000086,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,229.89075,4.11475,0.041,NULL,56427660767,881682199,13776284,17.7),(128916,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128916,37.84,0.27,370,59284,70,NULL,NULL,'2MASX J15193381+0457523',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,229.890917,4.96467,0.069,NULL,56426251820,881660184,13775940,17.4),(128917,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128917,37.14,0.46,268,59285,70,NULL,NULL,'LCRS B151658.9-022653',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00015,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,229.8955,-2.62869,0.313,NULL,45376327204,709005112,11078204,17.2),(128918,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128918,37.98,0.13,394,59286,70,NULL,NULL,'2MASX J15193589+1938325',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'17.9O',0.34,'BrClG',NULL,NULL,NULL,NULL,1,229.8995,19.64247,0.165,NULL,59413288797,928332637,14505197,17.9),(128919,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128919,37.21,0.46,276,59287,70,NULL,NULL,'2MASX J15193644+3111243',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000176,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,229.9019583,31.19014,0.037,NULL,59903882719,935998167,14624971,16.9),(128920,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128920,36.97,0.46,248,59288,70,NULL,NULL,'2MASX J15193657+0540333',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,229.9025,5.67581,0.065,NULL,56426965974,881671343,13776114,16.9),(128921,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128921,36.47,0.1,197,59289,70,NULL,NULL,'2MASX J15193678+2050005',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.68',0.22,NULL,NULL,NULL,NULL,NULL,1,229.903333,20.8335,0.181,NULL,59416348433,928380444,14505944,17.68),(128922,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128922,36.02,0.21,160,59290,70,NULL,NULL,'GIN 391',NULL,'2001MNRAS.321..277C',2001,1,0.4,NULL,'G',NULL,NULL,'16.4g',0.38,'S',NULL,NULL,NULL,NULL,1,229.905541667,4.44878,0.045,NULL,56427589269,881681082,13776266,16.4),(128923,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128923,37.69,0.46,345,59291,70,NULL,NULL,'2MASX J15193904+2927333',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.91275,29.45914,0,NULL,59906444077,936038188,14625596,17.7),(128924,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128924,37.77,0.33,358,59292,70,NULL,NULL,'2MASX J15193974+1900565',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,229.915541667,19.01553,0.145,NULL,59441719094,928776860,14512138,17.9),(128925,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128925,35.6,0.46,132,59293,70,NULL,NULL,'2MASX J15194052+2019245',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,229.918875,20.32356,0.177,NULL,59412684470,928323194,14505049,16.6),(128926,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128926,36.51,0.46,201,59294,70,NULL,NULL,'2MASX J15194051+0719528',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,'Group member',NULL,NULL,NULL,1,229.9189583,7.33136,0.061,NULL,59349921398,927342521,14489726,17.3),(128927,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128927,37.16,0.46,270,59295,70,NULL,NULL,'2MASX J15194096+4806145',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00017,NULL,'17.5g',NULL,NULL,NULL,NULL,NULL,NULL,1,229.92075,48.10408,0.045,NULL,59937650517,936525789,14633215,17.5),(128928,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128928,37.81,0.46,365,59296,70,NULL,NULL,'2MASX J15194107+0647468',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.9210417,6.79617,0.057,NULL,56410047518,881406992,13771984,17.6),(128929,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128929,38.24,0.14,444,59297,70,NULL,NULL,'2MASX J15194161+0405368',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000071,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,229.9235,4.09361,0.041,NULL,56427673429,881682397,13776287,17.8),(128930,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128930,38.27,0.46,452,59298,70,NULL,NULL,'2MASX J15194261+1355064',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,229.927667,13.9185,0.097,NULL,59574993417,930859272,14544676,18.2),(128931,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128931,38.24,0.14,444,59299,70,NULL,NULL,'SDSS J151943.09+041519.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000074,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,229.9295417,4.25553,0.045,NULL,56427797870,881684341,13776317,18.7),(128932,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128932,37.98,0.13,394,59300,70,NULL,NULL,'SDSS J151943.24+193950.3',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.6g',NULL,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.930167,19.664,0.165,NULL,59413238820,928331856,14505185,17.6),(128933,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128933,37.88,0.33,377,59301,70,NULL,NULL,'2MASX J15194494+0730238',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,'Group member',NULL,NULL,NULL,1,229.937125,7.50664,0.057,NULL,59349904387,927342256,14489722,18),(128934,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128934,37.64,0.15,337,59302,70,NULL,NULL,'2MASX J15194519+4842205',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000175,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,229.938333,48.70567,0.045,NULL,59937113513,936517398,14633084,17.8),(128935,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128935,37.01,0.33,253,59303,70,NULL,NULL,'2MASX J15194650+0333549',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000434,NULL,'15.9g',0.39,NULL,NULL,NULL,NULL,NULL,1,229.943666667,3.56511,0.069,NULL,56427184049,881674750,13776167,15.9),(128936,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128936,38.24,0.14,444,59304,70,NULL,NULL,'2MASX J15194716+0421099',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000099,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,229.946541667,4.35258,0.045,NULL,56427803961,881684436,13776319,18),(128937,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128937,37.81,0.46,364,59305,70,NULL,NULL,'2MASX J15194718+0135359',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.946667,1.59325,0.117,NULL,56377428442,880897319,13764020,17.5),(128938,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128938,37,0.46,251,59306,70,NULL,NULL,'2MASX J15194729+0745458',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,229.947167,7.76264,0.057,NULL,59353299026,927395297,14490551,16.5),(128939,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128939,37.98,0.13,394,59307,70,NULL,NULL,'SDSS J151948.45+194206.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.951917,19.70192,0.217,NULL,59413293375,928332708,14505198,18.3),(128940,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128940,36.69,0.11,218,59308,70,NULL,NULL,'2MASX J15194857+0738368',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',NULL,NULL,'15.8g',0.36,NULL,'Group member',NULL,NULL,NULL,1,229.9522917,7.6435,0.057,NULL,59349680892,927338763,14489668,15.8),(128941,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128941,38.08,0.46,413,59309,70,NULL,NULL,'SDSS J151948.77+050148.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.953208333,5.03014,0.085,NULL,56426336035,881661500,13775960,18.5),(128942,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128942,35.69,0.49,137,59310,75,NULL,'IR','FGC 1888',NULL,'2011yCatp016004901K',2011,1,0.83,'Star superposed.','G',0.000191,NULL,'16.7',0.1,'Sc',NULL,NULL,NULL,NULL,1,229.953167,48.71731,0.045,NULL,59937113416,936517397,14633084,16.7),(128943,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128943,36.16,NULL,171,59310,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1888',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128944,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128944,36.18,NULL,172,59310,NULL,NULL,'Dipole + Quadrupole','FGC 1888',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128945,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128945,36.18,NULL,172,59310,NULL,NULL,NULL,'FGC 1888',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128946,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128946,36.21,NULL,175,59310,NULL,NULL,'Dipole','FGC 1888',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128947,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128947,37.35,0.46,295,59311,70,NULL,NULL,'SDSS J151949.13+300650.1',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000224,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,229.9547083,30.11392,0.017,NULL,59907233055,936050516,14625789,17.9),(128948,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128948,37.98,0.13,394,59312,70,NULL,NULL,'2MASX J15194990+1934475',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,229.958,19.57983,0.173,NULL,59413243682,928331932,14505186,18.2),(128949,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128949,37.29,0.46,287,59313,70,NULL,NULL,'2MASX J15195017+0334149',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000114,NULL,'16.0g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,229.959125,3.57081,0.069,NULL,56427182574,881674727,13776167,16),(128950,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128950,37.56,0.33,325,59314,70,NULL,NULL,'2MASX J15195034+2202155',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,229.959875,22.03761,0.129,NULL,59421255903,928457123,14507142,17),(128951,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128951,38.35,0.46,467,59315,70,NULL,NULL,'2MASX J15195067+3008583',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000174,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,229.9612917,30.14961,0.017,NULL,59907242444,936050663,14625791,18),(128952,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128952,37.77,0.46,358,59316,70,NULL,NULL,'2MASX J15195130+0834438',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000196,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,229.96375,8.57889,0.073,NULL,59350785274,927356019,14489937,16.7),(128953,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128953,37.69,0.46,345,59317,70,NULL,NULL,'2MASX J15195170+3707106',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000131,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,229.965417,37.11958,0.025,NULL,60108935206,939202112,14675033,17.7),(128954,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128954,37.61,0.46,333,59318,70,NULL,NULL,'2MASX J15195192+3800126',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000164,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,229.966333333,38.00361,0.041,NULL,60112180756,939252824,14675825,17.1),(128955,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128955,37.04,0.33,256,59319,70,NULL,NULL,'2MASX J15195211+5646517',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.00022,NULL,'15.7g',0.46,NULL,NULL,NULL,NULL,NULL,1,229.967458333,56.78103,0.025,NULL,57593206185,899893846,14060841,15.7),(128956,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128956,38.94,0.46,613,59320,70,NULL,NULL,'2MASX J15195249+3747076',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000134,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.9689583,37.78544,0.041,NULL,60112075029,939251172,14675799,18.2),(128957,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128957,37.25,0.16,281,59321,70,NULL,NULL,'2MASX J15195292+4501161',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,229.970417,45.02114,0.033,NULL,59967691782,936995184,14640549,17),(128958,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128958,37.79,0.17,361,59322,70,NULL,NULL,'2MASX J15195297+3244443',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.970583333,32.74553,0.021,NULL,60112777239,939262144,14675971,17.8),(128959,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128959,37.83,0.23,369,59323,70,NULL,NULL,'SDSS J151953.30+512204.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,229.972167,51.36781,0.041,NULL,59675442391,932428787,14569199,18.5),(128960,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128960,38.21,0.46,438,59324,70,NULL,NULL,'SDSS J151953.67+310137.4',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000173,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,229.973667,31.02708,0.033,NULL,59903893121,935998330,14624973,18.6),(128961,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128961,38.28,0.46,453,59325,70,NULL,NULL,'2MASX J15195378+0234209',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.974041667,2.57253,0.081,NULL,56376911805,880889246,13763894,17.8),(128962,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128962,37.88,0.33,377,59326,70,NULL,NULL,'2MASX J15195395+0727348',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,229.9747917,7.45981,0.057,NULL,59349901831,927342216,14489722,16.8),(128963,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128963,37.84,0.27,370,59327,70,NULL,NULL,'2MASX J15195404+0456539',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,229.9752917,4.94836,0.085,NULL,56429858168,881716533,13776820,17.1),(128964,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128964,36.14,0.46,169,59328,70,NULL,NULL,'2MASX J15195563+4909385',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000175,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.981667,49.16067,0.017,NULL,59936868131,936513564,14633024,16.5),(128965,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128965,38.06,0.27,410,59329,70,NULL,NULL,'SDSS J151956.04+043258.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.9835417,4.54953,0.045,NULL,56427580694,881680948,13776264,18.3),(128966,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128966,37.56,0.33,325,59330,70,NULL,NULL,'2MASX J15195704+2220225',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000199,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,229.9877083,22.33969,0.137,NULL,59421445072,928460079,14507188,16.7),(128967,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128967,37.25,0.46,282,59331,70,NULL,NULL,'2MASX J15195744+2712162',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.989167,27.2045,0.093,NULL,59910839919,936106873,14626669,17.6),(128968,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128968,37.83,0.23,369,59332,70,NULL,NULL,'I Zw 108 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00019,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,229.991,51.31931,0.041,NULL,59675439604,932428743,14569199,16.6),(128969,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128969,37.83,0.23,369,59333,70,NULL,NULL,'I Zw 108 NOTES02',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000221,NULL,'15.9g',0.47,'BrClG',NULL,NULL,NULL,NULL,1,229.9914583,51.31311,0.041,NULL,59675439558,932428743,14569199,15.9),(128970,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','PS1 SN 2008051','RN',128970,36.03,0.06,161,59334,NULL,NULL,'MLCS2k2, R(V) = 1.8, SNF20080522-011','PS1 SN 2008051 HOST',NULL,'2015Sci...347.1459K',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128971,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','PS1 SN 2008051','RN',128971,36.08,0.06,164,59334,NULL,NULL,'MLCS2k2, R(V) = 3.1, SNF20080522-011','PS1 SN 2008051 HOST',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128972,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','PS1 SN 2008051','N',128972,36.27,0.2,172,59334,73.8,NULL,'SALT 2 (SNANA)','PS1 SN 2008051 HOST',0.0403,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128973,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128973,37.82,0.46,366,59335,70,NULL,NULL,'2MASX J15195901+2833052',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.49',0.16,NULL,NULL,NULL,NULL,NULL,1,229.995667,28.55142,0.045,NULL,59910952333,936108630,14626697,18.49),(128974,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128974,37.68,0.46,343,59336,70,NULL,NULL,'2MASX J15195902+2349555',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,229.9957917,23.83203,0.149,NULL,59422480450,928476257,14507441,17.2),(128975,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128975,37.23,0.46,279,59337,70,NULL,NULL,'2MASX J15195906+3122133',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000182,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,229.9960417,31.37031,0.037,NULL,59904059515,936000929,14625014,16.5),(128976,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128976,36.47,0.1,197,59338,70,NULL,NULL,'2MASX J15195910+2042475',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.21',0.25,NULL,NULL,NULL,NULL,NULL,1,229.996375,20.71317,0.181,NULL,59416196557,928378071,14505907,17.21),(128977,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128977,37.98,0.13,394,59339,70,NULL,NULL,'2MASX J15195939+1938075',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,229.997625,19.63542,0.217,NULL,59413249476,928332023,14505187,17.5),(128978,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128978,38.24,0.14,444,59340,70,NULL,NULL,'SDSS J151959.48+041437.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000076,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,229.997875,4.24372,0.045,NULL,56427750686,881683604,13776306,18.5),(128979,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128979,31.86,0.2,23.6,59341,74.4,NULL,NULL,'ESO 514- G 007',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.000017,NULL,'14.3R',1.3,'S.../Irr',NULL,NULL,NULL,NULL,1,229.9987917,-23.92508,0.569,NULL,46622248079,728472626,11382384,14.3),(128980,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128980,32.33,0.4,29.2,59341,NULL,NULL,NULL,'ESO 514- G 007',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128981,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128981,37.79,0.17,361,59342,70,NULL,NULL,'2MASX J15200020+3249233',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000187,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,230.000833,32.82319,0.021,NULL,60112822838,939262856,14675982,17.1),(128982,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128982,36.8,0.46,229,59343,70,NULL,NULL,'2MASX J15200026+2803255',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.0010417,28.05719,0.045,NULL,59911093949,936110842,14626731,17.8),(128983,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128983,37.79,0.17,361,59344,70,NULL,NULL,'SDSS J152000.77+324612.6',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000181,NULL,'16.2g',0.42,'BrClG',NULL,NULL,NULL,NULL,1,230.0032083,32.77017,0.021,NULL,60112771034,939262047,14675969,16.2),(128984,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128984,37.82,0.46,366,59345,70,NULL,NULL,'SDSS J152000.82+111034.9',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.6g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.0034583,11.17636,0.073,NULL,59356327815,927442622,14491290,17.6),(128985,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128985,38.24,0.14,444,59346,70,NULL,NULL,'2MASX J15200086+0412069',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00009,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,230.003667,4.20186,0.045,NULL,56427632875,881681763,13776277,17.2),(128986,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128986,36.85,0.46,234,59347,70,NULL,NULL,'2MASX J15200130-0057246',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00007,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.005333,-0.95697,0.177,NULL,45374657670,708979026,11077797,17.6),(128987,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128987,38.19,0.21,434,59348,70,NULL,NULL,'2MASX J15200208+0502479',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,230.008625,5.04667,0.085,NULL,56429791401,881715490,13776804,16.9),(128988,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128988,37.49,0.46,315,59349,70,NULL,NULL,'2MASX J15200206+2852115',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.89',0.13,NULL,NULL,NULL,NULL,NULL,1,230.008625,28.87,0.025,NULL,59907509019,936054828,14625856,18.89),(128989,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128989,37.25,0.16,281,59350,70,NULL,NULL,'2MASX J15200217+4504061',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000159,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,230.008875,45.06847,0.033,NULL,59967699697,936995307,14640551,17.1),(128990,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128990,38.14,0.46,425,59351,70,NULL,NULL,'2MASX J15200275+2001355',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,230.011417,20.02667,0.181,NULL,59412791052,928324860,14505075,17.8),(128991,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128991,37.06,0.46,258,59352,70,NULL,NULL,'2MASX J15200343+1541024',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.014375,15.68408,0.077,NULL,59566177805,930721528,14542523,17.6),(128992,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128992,38.08,0.46,412,59353,70,NULL,NULL,'2MASX J15200371+5821498',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000069,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.015333,58.36381,0.025,NULL,57721469920,901897967,14092155,17.9),(128993,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128993,36.73,0.46,222,59354,70,NULL,NULL,'2MASX J15200377+0728459',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,'Group member',NULL,NULL,NULL,1,230.01575,7.47936,0.057,NULL,59349902221,927342222,14489722,17),(128994,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128994,37.46,0.33,310,59355,70,NULL,NULL,'2MASX J15200412+1535244',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.017208333,15.59025,0.073,NULL,59566165297,930721332,14542520,17.5),(128995,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128995,37.79,0.17,361,59356,70,NULL,NULL,'SDSS J152004.60+324156.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.0192083,32.69897,0.021,NULL,60112781031,939262203,14675971,18.2),(128996,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128996,37.24,0.46,281,59357,70,NULL,NULL,'2MASX J15200486+3645524',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000178,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,230.0202083,36.76456,0.029,NULL,60108855303,939200864,14675013,16.9),(128997,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128997,37.46,0.33,310,59358,70,NULL,NULL,'2MASX J15200543+1533224',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,230.0225417,15.55625,0.073,NULL,59565948993,930717953,14542468,16.7),(128998,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128998,37.49,0.33,314,59359,70,NULL,NULL,'2MASX J15200629+3106251',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,230.02625,31.107,0.037,NULL,59903899820,935998434,14624975,17.3),(128999,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128999,36.17,0.46,172,59360,70,NULL,NULL,'2MASX J15200687+0328348',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.80',0.33,NULL,NULL,NULL,NULL,NULL,1,230.028583,3.47633,0.069,NULL,56427240151,881675627,13776181,16.8),(129000,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129000,37.77,0.33,358,59361,70,NULL,NULL,'2MASX J15200692+1857489',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'17.10',0.2,NULL,NULL,NULL,NULL,NULL,1,230.028875,18.96361,0.145,NULL,59441922962,928780046,14512188,17.1),(129001,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129001,37.37,0.46,298,59362,70,NULL,NULL,'2MASX J15200700+1436144',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,230.02925,14.60397,0.097,NULL,59574924663,930858197,14544659,NULL),(129002,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129002,37.79,0.17,361,59363,70,NULL,NULL,'SDSS J152007.19+324950.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,230.029958333,32.83072,0.021,NULL,60112769446,939262022,14675969,18.2),(129003,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129003,37.41,0.46,304,59364,70,NULL,NULL,'2MASX J15200856+6012597',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000184,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,230.035625,60.21672,0.029,NULL,57776275000,902754296,14105535,16.4),(129004,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129004,37.86,0.46,374,59365,70,NULL,NULL,'2MASX J15200931+3830464',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000145,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,230.038625,38.51286,0.033,NULL,60111037383,939234959,14675546,17.4),(129005,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129005,37.26,0.46,283,59366,70,NULL,NULL,'2MASX J15200931+3019151',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.0001,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,230.0387917,30.32097,0,NULL,59907023739,936047245,14625738,16.4),(129006,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129006,35.75,0.46,141,59367,70,NULL,NULL,'2MASX J15200937+2154169',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000103,NULL,'16.19',0.3,NULL,NULL,NULL,NULL,NULL,1,230.0389583,21.90478,0.129,NULL,59413674646,928338666,14505291,16.19),(129007,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129007,37.83,0.23,369,59368,70,NULL,NULL,'2MASX J15200945+5117148',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.039333,51.28764,0.033,NULL,59675437433,932428709,14569198,17.8),(129008,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129008,37.98,0.13,394,59369,70,NULL,NULL,'2MASX J15200947+1942460',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.039417,19.71278,0.217,NULL,59412721186,928323768,14505058,18.1),(129009,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129009,37.85,0.13,371,59370,70,NULL,NULL,'SDSS J152009.51+331905.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000158,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,230.039625,33.31811,0.045,NULL,60104528753,939133261,14673957,18.6),(129010,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129010,38.05,0.33,407,59371,70,NULL,NULL,'2MASX J15201004+1446174',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,230.041917,14.77156,0.097,NULL,59574124826,930845700,14544464,16.6),(129011,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129011,37.96,0.46,391,59372,70,NULL,NULL,'SDSS J152010.63+201924.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.044291667,20.32344,0.173,NULL,59412677973,928323093,14505048,18.6),(129012,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129012,35.96,0.21,155,59373,70,NULL,NULL,'CGCG 135-047',NULL,'2015arXiv151105856S',2015,1,0.93,NULL,'G',0.000153,NULL,'14.7g',0.64,NULL,'Group member',NULL,NULL,NULL,1,230.045625,25.72203,0.129,NULL,59901102291,935954723,14624292,14.7),(129013,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129013,37.85,0.13,371,59374,70,NULL,NULL,'2MASX J15201115+3322171',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,230.046625,33.37133,0.049,NULL,60104557444,939133710,14673964,16.9),(129014,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129014,37.98,0.33,394,59375,70,NULL,NULL,'2MASX J15201152+4607361',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.048,46.12656,0.033,NULL,59983499067,937242172,14644408,17.8),(129015,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129015,35.96,0.21,155,59376,70,NULL,NULL,'2MASX J15201158+2548285',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.73',0.2,NULL,NULL,NULL,NULL,NULL,1,230.0482083,25.808,0.129,NULL,59909447602,936085118,14626329,17.73),(129016,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129016,37.85,0.13,371,59377,70,NULL,NULL,'SDSS J152012.56+332638.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000167,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,230.052375,33.44414,0.049,NULL,60104551075,939133610,14673962,18.3),(129017,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129017,38.05,0.33,407,59378,70,NULL,NULL,'2MASX J15201315+1446385',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,230.054875,14.77747,0.097,NULL,59574126094,930845720,14544464,17.8),(129018,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129018,37.85,0.13,371,59379,70,NULL,NULL,'2MASX J15201361+3328271',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,230.056708333,33.47431,0.049,NULL,60104552905,939133639,14673963,16.7),(129019,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129019,37.23,0.46,279,59380,70,NULL,NULL,'2MASX J15201365+3200322',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000191,NULL,'16.0g',0.45,'E0',NULL,NULL,NULL,NULL,1,230.0570417,32.00894,0.041,NULL,59903302559,935989102,14624829,16),(129020,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129020,37.25,0.46,282,59381,70,NULL,NULL,'2MASX J15201375+0259332',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,230.0572917,2.99247,0.065,NULL,56432279512,881754367,13777411,16.9),(129021,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129021,37.37,0.46,298,59382,70,NULL,NULL,'2MASX J15201389+2827055',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.0579583,28.45156,0.033,NULL,59910949861,936108591,14626696,17.8),(129022,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129022,38.46,0.46,491,59383,70,NULL,NULL,'SDSS J152014.74+015338.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.0614583,1.89417,0.109,NULL,56377447332,880897614,13764025,18.4),(129023,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129023,37.13,0.46,267,59384,70,NULL,NULL,'2MASX J15201479+4800119',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000173,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,230.061541667,48.00319,0.041,NULL,59937600486,936525007,14633203,16.7),(129024,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129024,36.34,0.46,185,59385,70,NULL,NULL,'2MASX J15201663+0512232',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'16.47',0.39,NULL,NULL,NULL,NULL,NULL,1,230.0692917,5.20642,0.085,NULL,56426352911,881661764,13775965,16.47),(129025,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129025,37.49,0.33,314,59386,70,NULL,NULL,'2MASX J15201665+3103022',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.069541667,31.05069,0.033,NULL,59903898383,935998412,14624975,17.6),(129026,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129026,36.21,0.46,175,59387,70,NULL,NULL,'2MASX J15201684+1143270',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.070125,11.72431,0.097,NULL,59342184672,927221635,14487838,16.9),(129027,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129027,37.62,0.46,333,59388,70,NULL,NULL,'2MASX J15201754+0344312',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000082,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.073167,3.74183,0.057,NULL,56427200240,881675003,13776171,17.4),(129028,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129028,35.96,0.21,155,59389,70,NULL,NULL,'2MASX J15201757+2543384',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000168,NULL,'16.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.0732917,25.72736,0.129,NULL,59901114202,935954909,14624295,16.8),(129029,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129029,38.19,0.21,434,59390,70,NULL,NULL,'2MASX J15201797+0513352',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.6g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,230.074958333,5.22647,0.085,NULL,56426310142,881661095,13775954,16.6),(129030,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129030,33.53,0.47,50.9,59391,NULL,NULL,'H','ESO 449- G 005',NULL,'2007A&A...465...71T',2007,1,2.7,NULL,'G',0.000034,NULL,'15',1.2,'Sa:            HII',NULL,NULL,NULL,NULL,1,230.075041667,-31.43178,0.513,NULL,47132431759,736444246,11506941,15),(129031,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129031,33.66,0.45,53.9,59391,NULL,NULL,'K','ESO 449- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129032,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129032,33.71,0.46,55.1,59391,NULL,NULL,'J','ESO 449- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129033,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129033,34.31,0.4,72.6,59391,NULL,NULL,'mean','ESO 449- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129034,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129034,37.85,0.13,371,59392,70,NULL,NULL,'2MASX J15201865+3323052',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000199,NULL,'16.0g',0.41,'BrClG',NULL,NULL,NULL,NULL,1,230.0777083,33.38481,0.049,NULL,60104549332,939133583,14673962,16),(129035,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129035,37.43,0.46,307,59393,70,NULL,NULL,'2MASX J15201904+3231362',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000162,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,230.079417,32.52672,0.037,NULL,60083418305,938803411,14668803,16.7),(129036,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129036,35.9,0.33,151,59394,NULL,NULL,NULL,'2MASX J15201967+0829180',NULL,'2009ApJS..182..474S',2009,1,0.36,NULL,'G',0.000027,NULL,'17.5g',0.16,'Sc',NULL,NULL,NULL,NULL,1,230.082166667,8.48836,0.073,NULL,59351249655,927363275,14490051,17.5),(129037,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129037,35.94,0.2,154,59394,74.4,NULL,NULL,'2MASX J15201967+0829180',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129038,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129038,36.02,0.32,160,59394,NULL,NULL,'Malmquist cor.','2MASX J15201967+0829180',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129039,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129039,37.21,0.46,276,59395,70,NULL,NULL,'2MASX J15202015+4706012',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.084083,47.10025,0.069,NULL,59983706304,937245411,14644459,17.6),(129040,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129040,37.35,0.46,295,59396,70,NULL,NULL,'2MASX J15202082+3607204',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,230.086667,36.12228,0.045,NULL,60107043478,939172554,14674571,17.3),(129041,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129041,37.16,0.46,270,59397,70,NULL,NULL,'2MASX J15202221+3220322',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.0925,32.34233,0.041,NULL,59903110989,935986109,14624782,17.7),(129042,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129042,36.69,0.11,218,59398,70,NULL,NULL,'2MASX J15202237+0733560',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,230.0932917,7.56558,0.057,NULL,59349692514,927338945,14489671,16.6),(129043,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129043,37.14,0.46,268,59399,70,NULL,NULL,'2MASX J15202236+0951480',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.093375,9.86347,0.073,NULL,59355436978,927428702,14491073,17.6),(129044,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129044,37.37,0.56,298,59400,70,NULL,NULL,'2MASX J15202243-1117184',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.65',NULL,NULL,NULL,NULL,NULL,NULL,1,230.093667,-11.28875,0.525,NULL,46486938072,726358407,11349350,16.65),(129045,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129045,37.85,0.46,372,59401,70,NULL,NULL,'2MASX J15202285+2806384',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0',0.16,NULL,NULL,NULL,NULL,NULL,1,230.095125,28.11072,0.045,NULL,59911109194,936111081,14626735,18),(129046,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129046,37.85,0.13,371,59402,70,NULL,NULL,'2MASX J15202352+3317142',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000174,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.098083333,33.28725,0.045,NULL,60104598067,939134344,14673974,17.8),(129047,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129047,38.19,0.21,434,59403,70,NULL,NULL,'2MASX J15202400+0508252',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,230.1,5.14019,0.085,NULL,56429830950,881716108,13776814,17.3),(129048,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129048,37.85,0.13,371,59404,70,NULL,NULL,'2MASX J15202480+3330042',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000179,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,230.103417,33.50114,0.049,NULL,60104555696,939133682,14673963,17.3),(129049,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129049,37.82,0.46,367,59405,70,NULL,NULL,'2MASX J15202513+5745088',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000093,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.104833,57.75242,0.029,NULL,57589466936,899835420,14059928,17.3),(129050,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129050,37.25,0.16,281,59406,70,NULL,NULL,'2MASX J15202551+4501382',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000187,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.10625,45.02719,0.033,NULL,59967694285,936995223,14640550,17.4),(129051,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129051,37.91,0.46,383,59407,70,NULL,NULL,'SDSS J152025.61+042450.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000082,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,230.1067083,4.41392,0.045,NULL,56427728534,881683258,13776300,18.7),(129052,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129052,37.41,0.46,304,59408,70,NULL,NULL,'2MASXi J1520274+214547',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,230.114333,21.76317,0.185,NULL,59413845676,928341338,14505333,17.9),(129053,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129053,37.79,0.17,361,59409,70,NULL,NULL,'2MASX J15202806+3253442',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000169,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,230.1170417,32.89556,0.025,NULL,60104433288,939131770,14673933,17.9),(129054,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129054,38.19,0.21,434,59410,70,NULL,NULL,'2MASX J15202815+0510352',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.1172917,5.17631,0.085,NULL,56429777264,881715269,13776801,17.4),(129055,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129055,37.59,0.46,330,59411,70,NULL,NULL,'2MASX J15202818+5242460',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,230.117333,52.71294,0.025,NULL,59675515961,932429936,14569217,17.5),(129056,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129056,36.28,0.46,180,59412,70,NULL,NULL,'2MASX J15202870+0817070',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00017,NULL,'16.2g',0.36,'E','Group member',NULL,NULL,NULL,1,230.119583,8.28517,0.045,NULL,59351165614,927361962,14490030,16.2),(129057,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129057,37.25,0.16,281,59413,70,NULL,NULL,'2MASX J15202901+4458153',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000186,NULL,'15.7g',0.43,'AGN',NULL,NULL,NULL,NULL,1,230.120791667,44.97097,0.033,NULL,59967696149,936995252,14640550,15.7),(129058,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129058,37.85,0.13,371,59414,70,NULL,NULL,'2MASX J15202904+3329362',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000178,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.120958333,33.49328,0.049,NULL,60104553931,939133655,14673963,17.2),(129059,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129059,37.64,0.15,337,59415,70,NULL,NULL,'SDSS J152029.18+483908.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.3g',0.1,NULL,NULL,NULL,NULL,NULL,1,230.121583,48.65233,0.045,NULL,59937090043,936517031,14633078,18.3),(129060,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129060,36.47,0.1,197,59416,70,NULL,NULL,'2MASX J15203111+2037231',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.13',0.2,NULL,NULL,NULL,NULL,NULL,1,230.129625,20.62319,0.177,NULL,59416244544,928378821,14505919,17.13),(129061,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129061,34.26,0.2,71.1,59417,74.4,NULL,NULL,'CGCG 077-078',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000123,NULL,'15.2',0.6,NULL,NULL,NULL,NULL,NULL,1,230.135208333,11.99019,0.097,NULL,59342272660,927223010,14487859,15.2),(129062,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129062,37.59,0.46,330,59418,70,NULL,NULL,'2MASX J15203249+5102050',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000171,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,230.135291667,51.03481,0.033,NULL,59666663537,932291617,14567056,16.7),(129063,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129063,35.14,0.45,107,59419,NULL,NULL,'K','MCG -01-39-001',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000073,NULL,'14.49',0.9,'S0- pec:',NULL,NULL,NULL,NULL,1,230.139,-8.52994,0.313,NULL,46480027840,726250435,11347663,14.49),(129064,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129064,35.25,0.4,112,59419,NULL,NULL,'mean','MCG -01-39-001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129065,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129065,37.85,0.13,371,59420,70,NULL,NULL,'SDSS J152033.60+332717.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,230.1400417,33.45483,0.049,NULL,60104549472,939133585,14673962,18.4),(129066,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129066,38.68,0.46,543,59421,70,NULL,NULL,'2MASX J15203419+2804200',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.81',0.15,NULL,NULL,NULL,NULL,NULL,1,230.1425,28.07236,0.061,NULL,59911101443,936110960,14626733,18.81),(129067,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129067,37.9,0.33,379,59422,70,NULL,NULL,'2MASX J15203487+2243542',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.85',0.17,NULL,NULL,NULL,NULL,NULL,1,230.14525,22.73181,0.149,NULL,59424179146,928502799,14507856,17.85),(129068,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129068,35.96,0.21,155,59423,70,NULL,NULL,'CGCG 135-048',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000113,NULL,'15.2g',0.47,NULL,'Group member',NULL,NULL,NULL,1,230.145417,25.73694,0.129,NULL,59901110863,935954857,14624294,15.2),(129069,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129069,37.98,0.13,394,59424,70,NULL,NULL,'SDSS J152035.71+193700.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.6g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.148833,19.61675,0.217,NULL,59412713081,928323641,14505056,18.6),(129070,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129070,38.31,0.33,458,59425,70,NULL,NULL,'2MASX J15203572+0314472',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000089,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,230.148875,3.24633,0.065,NULL,56434414151,881787721,13777933,17),(129071,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129071,38.12,0.27,421,59426,70,NULL,NULL,'2MASX J15203644+1914182',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.151833333,19.23847,0.173,NULL,59441857999,928779031,14512172,17.7),(129072,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129072,37.5,0.33,317,59427,70,NULL,NULL,'2MASX J15203650+2508070',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000171,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,230.1519583,25.13522,0.133,NULL,59417595538,928399930,14506248,17.6),(129073,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129073,37.98,0.13,394,59428,70,NULL,NULL,'2MASX J15203670+1941132',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.3E',NULL,NULL,NULL,NULL,NULL,NULL,1,230.152875,19.68694,0.217,NULL,59412725208,928323831,14505059,16.3),(129074,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129074,37.5,0.33,317,59429,70,NULL,NULL,'2MASX J15203708+2507070',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000184,NULL,'18.18',0.16,NULL,NULL,NULL,NULL,NULL,1,230.154375,25.11853,0.129,NULL,59417595684,928399932,14506248,18.18),(129075,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129075,34.53,0.56,80.4,59430,70,NULL,NULL,'2MASX J15203752-1103024',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000087,NULL,'16.06',NULL,NULL,NULL,NULL,NULL,NULL,1,230.15625,-11.05089,0.501,NULL,46486816887,726356513,11349320,16.06),(129076,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129076,36.47,0.1,197,59431,70,NULL,NULL,'2MASX J15203792+2050372',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.44',0.23,NULL,NULL,NULL,NULL,NULL,1,230.1579583,20.84367,0.177,NULL,59416102202,928376596,14505884,16.44),(129077,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129077,36.69,0.11,218,59432,70,NULL,NULL,'MENeaCS MKW03S_04_14_0 HOST',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.1585417,7.65969,0.057,NULL,59353108711,927392323,14490505,17),(129078,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129078,38.31,0.33,458,59433,70,NULL,NULL,'2MASX J15203916+0315541',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00009,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.163291667,3.265,0.065,NULL,56434397546,881787461,13777929,17.5),(129079,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129079,38.12,0.27,421,59434,70,NULL,NULL,'2MASX J15203940+1915172',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.164125,19.25469,0.173,NULL,59441871733,928779245,14512175,17.7),(129080,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129080,37.05,0.46,257,59435,70,NULL,NULL,'2MASX J15203974+2336352',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000167,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,230.1657917,23.60992,0.157,NULL,59422494160,928476471,14507444,16.3),(129081,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129081,36.58,0.46,207,59436,70,NULL,NULL,'CGCG 021-078',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000197,NULL,'15.4',0.52,NULL,NULL,NULL,NULL,NULL,1,230.169417,1.84675,0.105,NULL,56377445336,880897583,13764024,15.4),(129082,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129082,37.85,0.13,371,59437,70,NULL,NULL,'2MASX J15204105+3321548',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000197,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,230.1710417,33.36536,0.049,NULL,60104580678,939134073,14673969,16.6),(129083,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129083,37.63,0.46,335,59438,70,NULL,NULL,'2MASX J15204124+0552321',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00005,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,230.17175,5.87575,0.049,NULL,56426594054,881665532,13776023,16.8),(129084,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129084,35.96,0.21,155,59439,70,NULL,NULL,'CGCG 135-049',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000192,NULL,'15.3g',0.6,NULL,'Group member',NULL,NULL,NULL,1,230.173708333,25.68081,0.129,NULL,59901105535,935954773,14624293,15.3),(129085,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129085,36.79,0.46,228,59440,70,NULL,NULL,'SDSS J152043.12+124843.4',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.1797083,12.81206,0.113,NULL,59562095762,930657746,14541527,17.4),(129086,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129086,37.55,0.46,324,59441,70,NULL,NULL,'SDSS J152043.23+073049.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00009,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,230.180167,7.51389,0.057,NULL,59349728672,927339510,14489679,18),(129087,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129087,37.89,0.46,379,59442,70,NULL,NULL,'2MASX J15204409+3525409',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000193,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,230.18375,35.42792,0.053,NULL,60108487610,939195118,14674923,17.1),(129088,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129088,36.47,0.1,197,59443,70,NULL,NULL,'2MASX J15204413+2043292',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.57',0.19,NULL,NULL,NULL,NULL,NULL,1,230.183917,20.72472,0.181,NULL,59416220626,928378447,14505913,17.57),(129089,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129089,37.37,0.46,298,59444,70,NULL,NULL,'SDSS J152044.67+062322.2',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,230.186125,6.3895,0.061,NULL,56410139558,881408430,13772006,NULL),(129090,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129090,37.64,0.15,337,59445,70,NULL,NULL,'2MASX J15204499+4839230',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000199,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,230.187667,48.65636,0.037,NULL,59937091416,936517053,14633078,16.9),(129091,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129091,37.53,0.11,321,59446,70,NULL,NULL,'2MASX J15204570+3029418',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000142,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.190417,30.49497,0,NULL,59907019589,936047181,14625737,17.7),(129092,'IRAS','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129092,32.44,0.8,30.7,59447,75,NULL,'MAT, I','ESO 582- G 004',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000013,NULL,'15.5',0.9,'Sc:',NULL,NULL,NULL,NULL,1,230.1915,-18.34889,0.461,NULL,46594726157,728042596,11375665,15.5),(129093,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129093,31.87,0.32,23.7,59447,85,NULL,'I, inv','ESO 582- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129094,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129094,31.89,0.32,23.9,59447,85,NULL,'I, raw','ESO 582- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129095,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129095,32.23,0.43,28,59447,75,NULL,'MAT, I, inv','ESO 582- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129096,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129096,32.24,0.43,28,59447,75,NULL,'MAT, I, raw','ESO 582- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129097,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129097,32.44,0.2,30.8,59447,74.4,NULL,NULL,'ESO 582- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129098,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129098,32.47,0.43,31.1,59447,75,NULL,'MAT, I, cor','ESO 582- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129099,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129099,32.6,0.49,33.1,59447,NULL,NULL,'Malmquist cor.','ESO 582- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129100,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129100,32.66,0.48,34,59447,NULL,NULL,NULL,'ESO 582- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129101,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129101,32.71,0.43,34.8,59447,75,NULL,'3.6 micron, color corrected','ESO 582- G 004',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129102,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129102,32.96,0.43,39.1,59447,75,NULL,'3.6 micron, color + selection bias corrected','ESO 582- G 004',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129103,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129103,37.09,0.46,262,59448,70,NULL,NULL,'2MASX J15204688+2757310',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.0002,NULL,'18.1g',0.19,NULL,'Group member',NULL,NULL,NULL,1,230.195333,27.95861,0.061,NULL,59911053612,936110212,14626722,18.1),(129104,'IRAS','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129104,33.77,0.8,56.6,59449,75,NULL,'MAT, I','ESO 387- G 026',NULL,'1997ApJS..109..333W',1997,1,2.5,'ESO-LV gives v = 3069 +/- 50 km/sec.','G',0.000013,NULL,'13.30',1.3,'SAB(s)c:       HII','Group member, conflicting redshifts',NULL,NULL,NULL,1,230.1952917,-36.93369,0.417,NULL,47193755259,737402425,11521912,13.3),(129105,'Sosies','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129105,33.83,0.11,58.3,59449,NULL,NULL,NULL,'ESO 387- G 026',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129106,'Tully est','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129106,33.1,0.8,41.8,59449,75,NULL,'B','ESO 387- G 026',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129107,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129107,33.56,0.43,51.4,59449,75,NULL,'MAT, I, raw','ESO 387- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129108,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129108,33.64,0.32,53.4,59449,85,NULL,'I, raw','ESO 387- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129109,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129109,33.65,0.2,53.7,59449,74.4,NULL,NULL,'ESO 387- G 026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129110,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129110,33.66,0.46,54,59449,NULL,NULL,'J','ESO 387- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129111,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129111,33.68,0.47,54.4,59449,NULL,NULL,'H','ESO 387- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129112,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129112,33.7,0.43,55,59449,75,NULL,'3.6 micron, color corrected','ESO 387- G 026',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129113,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129113,33.72,0.32,55.4,59449,85,NULL,'I, inv','ESO 387- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129114,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129114,33.73,0.45,55.8,59449,NULL,NULL,'K','ESO 387- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129115,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129115,33.81,0.34,57.9,59449,NULL,NULL,NULL,'ESO 387- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129116,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129116,33.87,0.43,59.4,59449,75,NULL,'3.6 micron, color + selection bias corrected','ESO 387- G 026',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129117,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129117,33.88,0.43,59.6,59449,75,NULL,'MAT, I, inv','ESO 387- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129118,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129118,33.88,0.4,59.6,59449,NULL,NULL,'mean','ESO 387- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129119,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129119,33.9,0.43,60.3,59449,75,NULL,'MAT, I, cor','ESO 387- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129120,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129120,33.98,0.32,62.5,59449,NULL,NULL,'Malmquist cor.','ESO 387- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129121,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129121,36.06,0.46,163,59450,70,NULL,NULL,'I Zw 109 NOTES02',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000175,NULL,'15.8g',0.34,'S0/a',NULL,NULL,NULL,NULL,1,230.199333,49.12756,0.037,NULL,59664505386,932257896,14566529,15.8),(129122,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129122,36.36,0.46,187,59451,70,NULL,NULL,'2MASX J15204841+3644149',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,230.2017917,36.73756,0.053,NULL,60108858559,939200914,14675014,16.2),(129123,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129123,38.19,0.21,434,59452,70,NULL,NULL,'2MASX J15204849+0503351',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.202083,5.05986,0.085,NULL,56429818027,881715906,13776811,17.6),(129124,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129124,36.49,0.46,199,59453,70,NULL,NULL,'2MASX J15204899+1554311',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.204083333,15.90869,0.073,NULL,59566143618,930720994,14542515,17.1),(129125,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129125,37.85,0.13,371,59454,70,NULL,NULL,'2MASX J15204911+3321499',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.0g',0.11,NULL,NULL,NULL,NULL,NULL,1,230.2045417,33.36375,0.049,NULL,60104578971,939134046,14673969,18),(129126,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129126,38.12,0.46,421,59455,70,NULL,NULL,'2MASX J15204985+2850020',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000093,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.20775,28.834,0.025,NULL,59907560071,936055626,14625869,17.9),(129127,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129127,37.01,0.33,252,59456,70,NULL,NULL,'2MASX J15205090+4519153',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000174,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,230.2120417,45.32089,0.025,NULL,59969873723,937029276,14641082,16.4),(129128,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129128,35.96,0.33,156,59457,NULL,NULL,NULL,'SDSS J152051.59+083723.2',NULL,'2009ApJS..182..474S',2009,1,0.52,NULL,'G',0.000027,NULL,'16.7g',0.28,'Sc','Group member',NULL,NULL,NULL,1,230.2149583,8.62311,0.045,NULL,59351280554,927363758,14490058,16.7),(129129,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129129,36,0.2,158,59457,74.4,NULL,NULL,'SDSS J152051.59+083723.2',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129130,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129130,36.04,0.31,162,59457,NULL,NULL,'Malmquist cor.','SDSS J152051.59+083723.2',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129131,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129131,36.02,0.21,160,59458,70,NULL,NULL,'GIN 390',NULL,'2001MNRAS.321..277C',2001,1,0.41,NULL,'G',0.000077,NULL,'16.2g',0.35,'E/S0',NULL,NULL,NULL,NULL,1,230.215583,4.39131,0.045,NULL,56427713466,881683022,13776297,16.2),(129132,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129132,36.65,0.33,213,59458,70,NULL,NULL,'GIN 390',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129133,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129133,37.64,0.15,337,59459,70,NULL,NULL,'MCG +08-28-020',NULL,'2015arXiv151105856S',2015,1,0.87,'Fouque et al. (1992CORV..C...0000F) give z=0.1078.','G',0.000226,NULL,'15.1g',0.54,'BrClG',NULL,NULL,NULL,NULL,1,230.217667,48.66061,0.037,NULL,59937089341,936517020,14633078,15.1),(129134,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129134,38.2,0.46,437,59460,70,NULL,NULL,'SDSS J152052.39+402052.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000162,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,230.218333,40.34792,0.021,NULL,59971250587,937050790,14641418,18.5),(129135,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129135,37.9,0.33,379,59461,70,NULL,NULL,'2MASX J15205258+2243432',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000184,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.2192917,22.72883,0.161,NULL,59421492201,928460815,14507200,17),(129136,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129136,37.94,0.46,387,59462,70,NULL,NULL,'2MASX J15205268+2320102',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,230.219333,23.33606,0.161,NULL,59424622428,928509725,14507964,17.5),(129137,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129137,37.85,0.13,371,59463,70,NULL,NULL,'2MASX J15205262+3340219',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000146,NULL,'16.8g',0.34,NULL,NULL,NULL,NULL,NULL,1,230.2195,33.67269,0.057,NULL,60105362406,939146287,14674160,16.8),(129138,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129138,37.65,0.46,339,59464,70,NULL,NULL,'2MASX J15205280+1318350',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,230.220083,13.30978,0.113,NULL,59561842554,930653789,14541465,17),(129139,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129139,37.14,0.46,267,59465,70,NULL,NULL,'2MASX J15205302+4911083',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000157,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,230.22075,49.18561,0.037,NULL,59664514684,932258041,14566531,16.8),(129140,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129140,37.57,0.27,327,59466,70,NULL,NULL,'SDSS J152053.41+071721.8',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.7g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.222583333,7.28942,0.057,NULL,56409739238,881402175,13771908,17.7),(129141,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129141,37.64,0.15,337,59467,70,NULL,NULL,'SDSS J152053.82+484122.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000172,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,230.224291667,48.68958,0.037,NULL,59937093191,936517081,14633079,18.3),(129142,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129142,37.01,0.33,252,59468,70,NULL,NULL,'2MASX J15205384+4519173',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000171,NULL,'16.4g',0.37,'AGN',NULL,NULL,NULL,NULL,1,230.224375,45.32136,0.025,NULL,59969873216,937029269,14641082,16.4),(129143,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129143,36.05,0.46,162,59469,70,NULL,NULL,'2MASX J15205452+0826381',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000167,NULL,'16.3g',0.3,'S0','Group member',NULL,NULL,NULL,1,230.227125,8.44386,0.073,NULL,59351261958,927363468,14490054,16.3),(129144,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129144,38.13,0.46,423,59470,70,NULL,NULL,'2MASX J15205458+0918241',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000177,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.227375,9.30681,0.061,NULL,59355296760,927426511,14491039,17.6),(129145,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129145,37.42,0.46,305,59471,70,NULL,NULL,'2MASX J15205500+4926193',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00015,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.229167,49.43883,0.021,NULL,59667391043,932302985,14567234,17.1),(129146,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129146,37.95,0.46,390,59472,70,NULL,NULL,'2MASX J15205499+1957242',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,230.2292917,19.95664,0.169,NULL,59412801228,928325019,14505078,16.6),(129147,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129147,32.4,0.4,30.2,59473,NULL,NULL,'mean','NGC 5913',NULL,'2007A&A...465...71T',2007,1,1.76,NULL,'G',0.000037,NULL,'13.8g',0.76,'SB(r)a         HII','Isolated galaxy',NULL,NULL,NULL,1,230.231,-2.57794,0.337,NULL,45421361902,709708779,11089199,13.8),(129148,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129148,32.53,0.45,32,59473,NULL,NULL,'K','NGC 5913',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129149,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129149,32.53,NULL,32,59473,72,NULL,NULL,'NGC 5913',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129150,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129150,32.57,0.47,32.6,59473,NULL,NULL,'H','NGC 5913',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129151,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129151,32.61,0.46,33.2,59473,NULL,NULL,'J','NGC 5913',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129152,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129152,32.69,0.43,34.6,59473,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5913',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129153,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129153,32.8,0.43,36.3,59473,75,NULL,'3.6 micron, color corrected','NGC 5913',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129154,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129154,32.89,0.2,37.8,59473,74.4,NULL,NULL,'NGC 5913',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129155,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129155,37.22,0.46,279,59474,70,NULL,NULL,'2MASX J15205717+4923123',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000174,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,230.238125,49.38681,0.017,NULL,59667392837,932303013,14567234,17),(129156,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129156,37.53,0.11,321,59475,70,NULL,NULL,'SDSS J152057.95+303723.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,230.2415,30.62333,0,NULL,59906528423,936039506,14625617,18.3),(129157,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129157,36.86,0.46,236,59476,70,NULL,NULL,'2MASX J15205876+2442400',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000161,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.2449583,24.71108,0.149,NULL,59417645555,928400711,14506261,17),(129158,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129158,37.19,0.23,274,59477,70,NULL,NULL,'SDSS J152058.82+565720.8',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000074,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,230.245083,56.95578,0.029,NULL,57588910773,899826730,14059792,16.2),(129159,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129159,37.03,0.46,254,59478,70,NULL,NULL,'2MASX J15205885+3021599',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000164,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,230.2452917,30.36675,0,NULL,59907016691,936047135,14625736,16.9),(129160,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129160,37.11,0.46,265,59479,70,NULL,NULL,'2MASX J15205892+3807279',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000154,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,230.245667,38.12456,0.033,NULL,60112164120,939252564,14675821,16.6),(129161,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129161,37.9,0.46,381,59480,70,NULL,NULL,'2MASX J15210012+2808400',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.0002,NULL,'17.7',0.18,NULL,NULL,NULL,NULL,NULL,1,230.2504583,28.14444,0.049,NULL,59911103008,936110984,14626734,17.7),(129162,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129162,37.91,0.46,381,59481,70,NULL,NULL,'2MASX J15210106+0126111',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,230.254417,1.43644,0.117,NULL,56375903333,880873489,13763648,16.9),(129163,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129163,38.03,0.46,403,59482,70,NULL,NULL,'SDSS J152101.10+474939.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.254583,47.82756,0.057,NULL,59936769568,936512024,14633000,18.1),(129164,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129164,37.77,0.46,358,59483,70,NULL,NULL,'2MASX J15210118+5915123',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000192,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.255083,59.25331,0.013,NULL,57772970498,902702664,14104729,17.6),(129165,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129165,38.32,0.46,462,59484,70,NULL,NULL,'2MASX J15210153+0356491',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000123,NULL,'17.2g',0.27,'NLAGN',NULL,NULL,NULL,'Sy 2',1,230.2564583,3.94708,0.065,NULL,56428010326,881687661,13776369,17.2),(129166,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129166,37.81,0.46,365,59485,70,NULL,NULL,'2MASX J15210162+2805040',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,'Group member',NULL,NULL,NULL,1,230.256708333,28.08447,0.061,NULL,59911051159,936110174,14626721,17.7),(129167,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129167,36.47,0.1,197,59486,70,NULL,NULL,'SDSS J152102.44+205423.7',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.4g',0.38,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.260167,20.90658,0.177,NULL,59416105705,928376651,14505885,16.4),(129168,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129168,38.07,0.46,411,59487,70,NULL,NULL,'2MASX J15210386+0215171',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,230.266166667,2.25472,0.081,NULL,56432667737,881760433,13777506,16.8),(129169,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129169,37.67,0.46,342,59488,70,NULL,NULL,'SDSS J152104.32+441856.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,230.2680417,44.31575,0.049,NULL,59967364779,936990074,14640469,18),(129170,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129170,36.53,0.46,202,59489,70,NULL,NULL,'2MASX J15210476+3622269',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000163,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,230.2699583,36.37414,0.041,NULL,60107012929,939172077,14674563,16.9),(129171,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129171,38.26,0.27,449,59490,70,NULL,NULL,'SDSS J152105.01+460712.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000167,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,230.270917,46.12014,0.033,NULL,59966375396,936974615,14640228,18.4),(129172,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129172,37.85,0.46,371,59491,70,NULL,NULL,'2MASX J15210559+0431434',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.273417,4.52864,0.053,NULL,56427692024,881682687,13776291,17.4),(129173,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129173,38.14,0.46,425,59492,70,NULL,NULL,'2MASX J15210579+2744419',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,'Group member',NULL,NULL,NULL,1,230.274208333,27.74514,0.073,NULL,59911184505,936112257,14626754,17.5),(129174,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129174,35.67,0.46,136,59493,70,NULL,NULL,'2MASX J15210798+0503294',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.0g',0.43,NULL,NULL,NULL,NULL,NULL,1,230.283167,5.05811,0.085,NULL,56429922541,881717539,13776836,16),(129175,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129175,37.53,0.11,321,59494,70,NULL,NULL,'2MASX J15210838+3034248',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000117,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,230.284916667,30.57361,0,NULL,59906583764,936040371,14625630,16.2),(129176,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129176,37.29,0.46,287,59495,70,NULL,NULL,'2MASX J15210883+2419380',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.73',0.13,NULL,NULL,NULL,NULL,NULL,1,230.2867083,24.32708,0.145,NULL,59417955736,928405558,14506336,18.73),(129177,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129177,37.53,0.11,321,59496,70,NULL,NULL,'2MASX J15210900+3031348',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.287375,30.52633,0,NULL,59906582133,936040345,14625630,18.1),(129178,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129178,37.08,0.17,261,59497,70.8,NULL,NULL,'[M96b] J152109.75+275508',NULL,'2008MNRAS.389.1577T',2008,1,NULL,'Not associated with ABELL 2065:[PGH88] 356. See Mueller (1996,IAUC,6405,1).','G',NULL,NULL,'20.7g',NULL,'S:',NULL,NULL,NULL,NULL,1,230.287625,27.92258,0.069,NULL,59911191384,936112365,14626755,20.7),(129179,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129179,38.32,0.17,408,59497,74.2,NULL,'SALT 2','[M96b] J152109.75+275508',0.13,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129180,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129180,38.93,0.15,479,59497,65,NULL,'MLCS2k2','[M96b] J152109.75+275508',0.13,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129181,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129181,38.68,0.28,482,59497,72,NULL,NULL,'[M96b] J152109.75+275508',0.13,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129182,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129182,38.85,0.21,522,59497,65,NULL,'MLCS17','[M96b] J152109.75+275508',0.13,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129183,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129183,38.88,0.04,529,59497,72,NULL,NULL,'[M96b] J152109.75+275508',0.13,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129184,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129184,38.89,0.05,529,59497,70,NULL,NULL,'[M96b] J152109.75+275508',0.13,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129185,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129185,38.89,0.29,530,59497,65,NULL,'MLCS31','[M96b] J152109.75+275508',0.13,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129186,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129186,38.9,0.18,533,59497,65,NULL,'MLCS2k2','[M96b] J152109.75+275508',0.13,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129187,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129187,38.95,0.17,546,59497,70,NULL,'SALT','[M96b] J152109.75+275508',0.13,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129188,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129188,38.99,0.11,555,59497,65,NULL,'MLCS2k2','[M96b] J152109.75+275508',0.13,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129189,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129189,39.01,0.13,561,59497,65,NULL,'MLCS','[M96b] J152109.75+275508',0.13,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129190,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129190,38.75,0.14,562,59497,60,NULL,NULL,'[M96b] J152109.75+275508',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129191,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129191,39.03,0.1,567,59497,65,NULL,'SALT2','[M96b] J152109.75+275508',0.13,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129192,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129192,39.04,0.17,570,59497,65,NULL,'SALT2','[M96b] J152109.75+275508',0.13,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129193,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129193,39.1,0.17,585,59497,65,NULL,'Template','[M96b] J152109.75+275508',0.13,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129194,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129194,39.14,0.02,596,59497,65,NULL,'SALT','[M96b] J152109.75+275508',0.13,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129195,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129195,39.15,0.15,599,59497,65,NULL,'SALT','[M96b] J152109.75+275508',0.13,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129196,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129196,38.89,0.08,600,59497,60,NULL,'M(B) = -19.48 mag','[M96b] J152109.75+275508',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129197,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129197,39.16,0.21,601,59497,70,NULL,'SALT 2','[M96b] J152109.75+275508',0.13,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129198,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129198,38.91,0.08,605,59497,60,NULL,'M(V) = -19.47 mag','[M96b] J152109.75+275508',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129199,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129199,39.2,0.22,612,59497,65,NULL,NULL,'[M96b] J152109.75+275508',0.13,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129200,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129200,39.23,0.22,624,59497,73.8,NULL,'SALT 2 (SNANA)','[M96b] J152109.75+275508',0.1242,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129201,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129201,37.45,0.46,309,59498,70,NULL,NULL,'2MASX J15210936+0841544',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000097,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.289125,8.69856,0.045,NULL,59351456620,927366509,14490101,17.4),(129202,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129202,37.53,0.11,321,59499,70,NULL,NULL,'2MASX J15211006+3042433',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00019,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.291833,30.71203,0,NULL,59906534900,936039607,14625618,17.5),(129203,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129203,38.3,0.23,456,59500,70,NULL,NULL,'2MASX J15211124+3202433',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000137,NULL,'18.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.2967083,32.04553,0.037,NULL,59903275322,935988676,14624823,18.1),(129204,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129204,37.53,0.11,321,59501,70,NULL,NULL,'2MASX J15211133+3035023',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000067,NULL,'15.7g',0.42,'E0',NULL,NULL,NULL,NULL,1,230.297083,30.584,0,NULL,59906583054,936040360,14625630,15.7),(129205,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129205,35.78,0.49,143,59502,75,NULL,'IR','CGCG 165-038',NULL,'2011yCatp016004901K',2011,1,1.16,NULL,'G',0.00005,NULL,'15.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.297333333,26.33142,0.113,NULL,59909795985,936090562,14626415,15.7),(129206,'IRAS','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129206,32.92,0.8,38.3,59503,75,NULL,'MAT, I','IC 4538',NULL,'1997ApJS..109..333W',1997,1,2.6,'6dF final data release has z = 0.012832 +- 0.000150.','G',0.000013,NULL,'12.82',2,'SAB(s)c:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,230.298375,-23.65842,0.545,NULL,46622071797,728469871,11382341,12.82),(129207,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129207,32.09,0.32,26.2,59503,85,NULL,'I, raw','IC 4538',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129208,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129208,32.12,0.32,26.6,59503,85,NULL,'I, inv','IC 4538',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129209,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129209,32.15,0.43,27,59503,75,NULL,'MAT, I, raw','IC 4538',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129210,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129210,32.33,0.43,29.2,59503,75,NULL,'MAT, I, inv','IC 4538',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129211,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129211,32.43,0.43,30.6,59503,75,NULL,'MAT, I, cor','IC 4538',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129212,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129212,32.44,NULL,30.8,59503,NULL,NULL,'I','IC 4538',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129213,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129213,32.53,0.45,32,59503,NULL,NULL,'K','IC 4538',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129214,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129214,32.53,0.47,32.1,59503,NULL,NULL,'H','IC 4538',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129215,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129215,32.53,NULL,32.1,59503,NULL,NULL,'B','IC 4538',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129216,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129216,32.54,0.45,32.2,59503,NULL,NULL,'Malmquist cor.','IC 4538',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129217,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129217,32.55,0.46,32.4,59503,NULL,NULL,'J','IC 4538',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129218,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129218,32.56,0.45,32.6,59503,NULL,NULL,NULL,'IC 4538',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129219,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129219,32.6,0.2,33.1,59503,74.4,NULL,NULL,'IC 4538',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129220,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129220,32.93,0.4,38.5,59503,NULL,NULL,'mean','IC 4538',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129221,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129221,38.21,0.46,439,59504,70,NULL,NULL,'2MASX J15211197+2827250',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.0002,NULL,'16.8g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,230.299916667,28.45697,0.049,NULL,59907750472,936058601,14625915,16.8),(129222,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129222,37.53,0.11,321,59505,70,NULL,NULL,'2MASX J15211350+3032193',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000164,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,230.306417,30.53883,0,NULL,59906582432,936040350,14625630,18.1),(129223,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129223,36.86,0.46,235,59506,70,NULL,NULL,'2MASX J15211380+2419570',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.51',0.15,NULL,NULL,NULL,NULL,NULL,1,230.307625,24.3325,0.145,NULL,59417955222,928405550,14506336,18.51),(129224,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129224,37.67,0.46,342,59507,70,NULL,NULL,'2MASX J15211407+0135174',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.3085,1.58808,0.105,NULL,56432528859,881758263,13777472,17.6),(129225,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129225,34.92,0.51,96.5,59508,70,NULL,NULL,'2MFGC 12404',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000077,NULL,'15.55',NULL,NULL,NULL,NULL,NULL,NULL,1,230.308833333,-13.76061,0.505,NULL,46672702012,729260968,11394702,15.55),(129226,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129226,34.7,0.48,87.1,59509,70,NULL,NULL,'2MASX J15211525-2020262',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000087,NULL,'15.21',NULL,NULL,NULL,NULL,NULL,NULL,1,230.3135,-20.34081,0.549,NULL,46616057932,728375905,11380873,15.21),(129227,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129227,37.36,0.46,296,59510,70,NULL,NULL,'2MASX J15211594+0950294',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.316375,9.84167,0.073,NULL,59355475341,927429302,14491082,17.7),(129228,'BCG','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129228,37.59,0.35,306,59511,60,NULL,NULL,'ABELL 2061',0.0782,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III:   [BM]',NULL,NULL,NULL,NULL,1,230.320833,30.64,0,NULL,59906577810,936040278,14625629,NULL),(129229,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129229,35.77,0.46,142,59512,70,NULL,NULL,'2MASX J15211747+5655372',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000085,NULL,'16.1g',0.35,'E0',NULL,NULL,NULL,NULL,1,230.322791667,56.92689,0.025,NULL,57593168795,899893262,14060832,16.1),(129230,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129230,37.53,0.11,321,59513,70,NULL,NULL,'2MASX J15211760+3035314',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000185,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.3232917,30.59211,0,NULL,59906588364,936040443,14625631,17.4),(129231,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129231,37.53,0.11,321,59514,70,NULL,NULL,'2MASX J15211835+3049584',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00007,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,230.3265417,30.83303,0.017,NULL,59903764966,935996327,14624942,16.3),(129232,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129232,35.68,0.46,137,59515,70,NULL,NULL,'2MASX J15211924+3417464',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000164,NULL,'16.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,230.330041667,34.29625,0.037,NULL,60105173988,939143343,14674114,16.3),(129233,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129233,38.12,0.27,421,59516,70,NULL,NULL,'2MASX J15211933+1913372',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.3307083,19.22703,0.173,NULL,59441841248,928778769,14512168,17.2),(129234,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129234,36.98,0.33,248,59517,70,NULL,NULL,'2MASX J15212015+2357170',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.75',0.23,NULL,NULL,NULL,NULL,NULL,1,230.3340417,23.95481,0.165,NULL,59422389283,928474832,14507419,16.75),(129235,'BCG','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129235,37.59,0.35,306,59518,60,NULL,'ABELL 2061, BCG','CGCG 165-041',0.0782,'1980ApJ...241..486H',1980,1,0.79,NULL,'G',0.000077,NULL,'15.3g',0.53,'BrClG','Brightest group member',NULL,NULL,NULL,1,230.33575,30.67094,0,NULL,59906580346,936040317,14625629,15.3),(129236,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129236,37.53,0.11,321,59518,70,NULL,NULL,'CGCG 165-041',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129237,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129237,38.26,0.27,449,59519,70,NULL,NULL,'2MASX J15212060+4606214',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000139,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.3360417,46.10592,0.033,NULL,59966388345,936974817,14640231,17.9),(129238,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129238,37.89,0.46,379,59520,70,NULL,NULL,'2MASX J15212080+0230254',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,230.336583333,2.50708,0.077,NULL,56433221214,881769081,13777641,17.2),(129239,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129239,34.19,0.94,68.8,59521,NULL,NULL,NULL,'ESO 582- G 005',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.98',0.3,'S',NULL,NULL,NULL,NULL,1,230.336625,-19.85642,0.521,NULL,46616131731,728377058,11380891,14.98),(129240,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129240,34.23,0.2,70.2,59521,74.4,NULL,NULL,'ESO 582- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129241,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129241,34.49,0.82,79,59521,NULL,NULL,'Malmquist cor.','ESO 582- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129242,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129242,37.51,0.46,317,59522,70,NULL,NULL,'2MASX J15212090+1706161',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,230.33725,17.10461,0.097,NULL,59566744081,930730376,14542662,16.7),(129243,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129243,37.57,0.27,327,59523,70,NULL,NULL,'2MASX J15212245+0715274',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'16.1g',0.37,NULL,NULL,NULL,NULL,NULL,1,230.343708333,7.25761,0.057,NULL,56409956360,881405568,13771962,16.1),(129244,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129244,36.02,0.21,160,59524,70,NULL,NULL,'CGCG 049-138',NULL,'2001MNRAS.321..277C',2001,1,1.8,NULL,'G',0.00017,NULL,'14.13',0.8,'E/S0',NULL,NULL,'radio jet','Flat-Spectrum Radio Source',1,230.343916667,4.34169,0.045,NULL,56427862761,881685355,13776333,14.13),(129245,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129245,36.09,0.25,165,59524,74.4,NULL,NULL,'CGCG 049-138',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129246,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129246,36.65,0.33,213,59524,70,NULL,NULL,'CGCG 049-138',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129247,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129247,38.49,0.46,500,59525,70,NULL,NULL,'2MASX J15212284+4545104',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.345333,45.753,0.033,NULL,59966249823,936972653,14640197,17.8),(129248,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129248,36.98,0.33,248,59526,70,NULL,NULL,'2MASX J15212292+2355300',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.345375,23.925,0.165,NULL,59422521560,928476899,14507451,17.5),(129249,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129249,35.7,0.52,138,59527,NULL,NULL,NULL,'2MFGC 12406',NULL,'2009ApJS..182..474S',2009,1,0.52,NULL,'G',0.000043,NULL,'17.2g',0.15,'Sc',NULL,NULL,NULL,NULL,1,230.3465,8.25883,0.069,NULL,59351175916,927362123,14490033,17.2),(129250,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129250,35.72,0.49,139,59527,75,NULL,'IR','2MFGC 12406',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129251,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129251,35.74,0.2,141,59527,74.4,NULL,NULL,'2MFGC 12406',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129252,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129252,35.99,0.46,158,59527,NULL,NULL,'Malmquist cor.','2MFGC 12406',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129253,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129253,37.28,0.46,286,59528,70,NULL,NULL,'2MASX J15212361+1406581',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,230.348417,14.11625,0.129,NULL,59574873402,930857396,14544646,17.2),(129254,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129254,38.01,0.46,399,59529,70,NULL,NULL,'2MASX J15212503+3058034',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000083,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,230.354291667,30.96764,0.033,NULL,59903760568,935996258,14624941,17.3),(129255,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129255,35.11,0.25,105,59530,NULL,NULL,NULL,'ESO 582- G 006',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.5',0.5,'Sb:',NULL,NULL,NULL,NULL,1,230.359625,-18.22533,0.461,NULL,46595405821,728053215,11375831,15.5),(129256,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129256,35.1,0.25,105,59530,NULL,NULL,'Malmquist cor.','ESO 582- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129257,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129257,35.15,0.2,107,59530,74.4,NULL,NULL,'ESO 582- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129258,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129258,37.53,0.11,321,59531,70,NULL,NULL,'2MASX J15212674+3042204',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.3614583,30.70578,0,NULL,59906577065,936040266,14625629,17.5),(129259,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129259,38.2,0.46,437,59532,70,NULL,NULL,'2MASX J15212746+0328464',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000089,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.364333,3.47956,0.057,NULL,56434522913,881789420,13777959,17.6),(129260,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129260,34.81,0.2,91.6,59533,74.4,NULL,NULL,'ESO 582- G 007',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000033,NULL,'16',0.5,'S...',NULL,NULL,NULL,NULL,1,230.365083,-18.87289,0.493,NULL,46624077279,728501207,11382831,16),(129261,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129261,34.98,0.21,99.2,59533,NULL,NULL,NULL,'ESO 582- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129262,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129262,35.05,0.2,102,59533,NULL,NULL,'Malmquist cor.','ESO 582- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129263,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129263,37.53,0.11,321,59534,70,NULL,NULL,'2MASX J15212790+3036294',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000173,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.3662083,30.60822,0,NULL,59906587273,936040426,14625631,17.7),(129264,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129264,36.56,0.46,205,59535,70,NULL,NULL,'I Zw 110 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,230.367625,41.92936,0.017,NULL,59976084069,937126313,14642598,17.3),(129265,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129265,35.31,0.5,115,59536,70,NULL,NULL,'2MFGC 12407',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,230.370791667,-10.14578,0.441,NULL,46488294392,726379599,11349681,16.2),(129266,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129266,34.42,0.46,76.6,59537,70,NULL,NULL,'CGCG 106-033',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.00015,NULL,'15.1',0.5,NULL,NULL,NULL,NULL,NULL,1,230.370833,15.13756,0.073,NULL,59574734553,930855227,14544612,15.1),(129267,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129267,38.16,0.23,429,59538,70,NULL,NULL,'2MASXi J1521294+220634',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,230.372791667,22.10936,0.173,NULL,59421347647,928458556,14507164,17.8),(129268,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129268,38.16,0.23,429,59539,70,NULL,NULL,'2MASX J15212949+2211011',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,230.372875,22.18378,0.173,NULL,59421318577,928458102,14507157,18.5),(129269,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129269,37.63,0.46,335,59540,70,NULL,NULL,'2MASX J15212973+3424174',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.373833333,34.40489,0.041,NULL,60104705232,939136019,14674000,17.5),(129270,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129270,37.56,0.46,325,59541,70,NULL,NULL,'2MASX J15212975+4424530',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000187,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.374083333,44.41478,0.049,NULL,59967405442,936990710,14640479,17.2),(129271,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129271,36.88,0.46,238,59542,70,NULL,NULL,'2MASX J15213000+0351214',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000073,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.375125,3.85594,0.065,NULL,56427991961,881687374,13776365,17.1),(129272,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129272,38.3,0.23,456,59543,70,NULL,NULL,'SDSS J152130.45+320630.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000163,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,230.376875,32.10858,0.037,NULL,59903265872,935988529,14624820,18.6),(129273,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129273,37.19,0.23,274,59544,70,NULL,NULL,'2MASX J15213043+5649044',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000113,NULL,'16.2g',0.39,'AGN',NULL,NULL,NULL,NULL,1,230.377,56.818,0.025,NULL,57593901424,899904709,14061011,16.2),(129274,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129274,34.23,0.5,70.1,59545,70,NULL,NULL,'2MASX J15213056-2031262',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.0001,NULL,'15.11',NULL,NULL,NULL,NULL,NULL,NULL,1,230.377833,-20.52389,0.485,NULL,46618953381,728421146,11381580,15.11),(129275,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129275,37.19,0.23,274,59546,70,NULL,NULL,'2MASX J15213151+5651114',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00018,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,230.38125,56.85325,0.025,NULL,57593902357,899904724,14061011,16.3),(129276,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129276,36.69,0.11,218,59547,70,NULL,NULL,'MCG +01-39-020 NED01',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000063,NULL,'15.9g',0.36,'AGN',NULL,NULL,NULL,NULL,1,230.3815,7.7405,0.073,NULL,59350976514,927359008,14489984,15.9),(129277,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129277,37.57,0.27,327,59548,70,NULL,NULL,'2MASX J15213273+0708134',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,230.386541667,7.13711,0.053,NULL,56409942376,881405349,13771958,16.9),(129278,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129278,34.27,0.42,71.4,59549,NULL,NULL,NULL,'UGC 09826',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.00015,NULL,'15.05',0.7,'SBb(r)         Sy1','Isolated galaxy',NULL,NULL,'Sy 1.5',1,230.387416667,39.20075,0.045,NULL,60111624917,939244139,14675689,15.05),(129279,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129279,34.44,0.39,77.3,59549,NULL,NULL,'Malmquist cor.','UGC 09826',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129280,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129280,35.32,0.63,116,59550,70,NULL,NULL,'2MASX J15213303-1006546',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.26',NULL,NULL,NULL,NULL,NULL,NULL,1,230.38775,-10.11511,0.441,NULL,46488296924,726379639,11349681,16.26),(129281,'Tully est','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129281,32.64,0.8,33.7,59551,75,NULL,'B','NGC 5915',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.00001,NULL,'13.03',1.3,'SB(s)ab pec    HII','in an interacting triple',NULL,NULL,NULL,1,230.387833,-13.09175,0.545,NULL,46659433476,729053648,11391463,13.03),(129282,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129282,31.94,0.47,24.4,59551,NULL,NULL,'H','NGC 5915',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129283,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129283,31.94,0.45,24.4,59551,NULL,NULL,'K','NGC 5915',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129284,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129284,31.96,0.46,24.7,59551,NULL,NULL,'J','NGC 5915',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129285,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129285,32.44,0.4,30.8,59551,NULL,NULL,'mean','NGC 5915',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129286,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129286,36.69,0.11,218,59552,70,NULL,NULL,'2MASX J15213321+0738314',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000093,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.388416667,7.64222,0.073,NULL,59349664037,927338500,14489664,17.6),(129287,'SNIa','2016-12-15 15:15:34','2016-12-16 11:20:47','1','SN 2005cf',NULL,129287,31.63,0.34,21,59553,74.2,NULL,'SALT 2','MCG -01-39-003',0.006461,'2010ApJ...716..712A',2010,1,1.4,NULL,'G',NULL,NULL,'14.64',0.7,'S0 pec',NULL,NULL,NULL,NULL,1,230.388708333,-7.44789,0.289,NULL,45391074355,709235536,11081805,14.64),(129288,'SNIa','2016-12-15 15:15:34','2016-12-16 11:20:47','1','SN 2005cf',NULL,129288,32.01,0.17,25.1,59553,72,NULL,NULL,'MCG -01-39-003',0.006461,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129289,'SNIa','2016-12-15 15:15:34','2016-12-16 11:20:47','1','SN 2005cf',NULL,129289,32.13,0.06,26.5,59553,72,NULL,NULL,'MCG -01-39-003',0.006461,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129290,'SNIa','2016-12-15 15:15:34','2016-12-16 11:20:47','1','SN 2005cf',NULL,129290,32.2,0.1,27.4,59553,72,NULL,'NIR','MCG -01-39-003',0.006461,'2009ApJ...697..380W',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129291,'SNIa','2016-12-15 15:15:34','2016-12-16 11:20:47','1','SN 2005cf',NULL,129291,32.21,0.1,27.7,59553,74.4,NULL,NULL,'MCG -01-39-003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129292,'SNIa','2016-12-15 15:15:34','2016-12-16 11:20:47','1','SN 2005cf',NULL,129292,32.23,0.02,27.9,59553,72,NULL,'M(H) = -18.317 mag','MCG -01-39-003',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129293,'SNIa','2016-12-15 15:15:34','2016-12-16 11:20:47','1','SN 2005cf',NULL,129293,32.29,0.12,28.5,59553,72,NULL,NULL,'MCG -01-39-003',0.006461,'2009ApJ...697..380W',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129294,'SNIa','2016-12-15 15:15:34','2016-12-16 11:20:47','1','SN 2005cf',NULL,129294,32.33,0.05,29.1,59553,72,NULL,NULL,'MCG -01-39-003',0.006461,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129295,'SNIa','2016-12-15 15:15:34','2016-12-16 11:20:47','1','SN 2005cf',NULL,129295,32.43,0.13,30.4,59553,72,NULL,'MLCS2k2','MCG -01-39-003',0.006461,'2009ApJ...697..380W',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129296,'SNIa','2016-12-15 15:15:34','2016-12-16 11:20:47','1','SN 2005cf',NULL,129296,32.58,0.1,32.6,59553,72,NULL,'MLCS2k2, R(V) = 3.1','MCG -01-39-003',0.006461,'2010ApJ...721.1608B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129297,'SNIa','2016-12-15 15:15:34','2016-12-16 11:20:47','1','SN 2005cf',NULL,129297,32.58,0.08,32.6,59553,72,NULL,'MLCS2k2, R(V) = 1.7','MCG -01-39-003',0.006461,'2010ApJ...721.1608B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129298,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129298,37.26,0.46,284,59554,70,NULL,NULL,'2MASX J15213375+1018574',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,230.390541667,10.31592,0.077,NULL,59355147432,927424178,14491002,16.9),(129299,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129299,38.16,0.23,429,59555,70,NULL,NULL,'2MASX J15213389+2214191',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,230.391166667,22.23858,0.173,NULL,59421312004,928458000,14507156,17.7),(129300,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129300,34.13,NULL,67,59556,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1889',NULL,'2010Ap&SS.325..163P',2010,1,1,NULL,'G',0.000092,NULL,'17.1g',0.12,'Sd',NULL,NULL,NULL,NULL,1,230.395041667,41.90525,0.017,NULL,59976083691,937126307,14642598,17.1),(129301,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129301,34.15,NULL,67.6,59556,NULL,NULL,'Dipole + Quadrupole','FGC 1889',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129302,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129302,34.17,NULL,68.3,59556,NULL,NULL,'Dipole','FGC 1889',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129303,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129303,34.21,NULL,69.6,59556,NULL,NULL,NULL,'FGC 1889',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129304,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129304,37.49,0.09,315,59557,70,NULL,NULL,'2MASX J15213494+2737319',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00014,NULL,'15.36',0.2,NULL,NULL,NULL,NULL,NULL,1,230.3957083,27.62556,0.073,NULL,59910782132,936105970,14626655,15.36),(129305,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129305,38.17,0.33,431,59558,70,NULL,NULL,'2MASX J15213527+3138374',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000156,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,230.396958333,31.64353,0.029,NULL,59903959440,935999366,14624990,16.9),(129306,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129306,37.53,0.11,321,59559,70,NULL,NULL,'SDSS J152135.33+304057.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000165,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,230.39725,30.68269,0,NULL,59906561762,936040027,14625625,18.2),(129307,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129307,37.97,0.46,393,59560,70,NULL,NULL,'2MASX J15213552+3724125',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000156,NULL,'17.9g',NULL,NULL,NULL,NULL,NULL,NULL,1,230.398125,37.40336,0.029,NULL,60112522383,939258162,14675908,17.9),(129308,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129308,35.32,0.2,116,59561,74.4,NULL,NULL,'CGCG 106-034',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000535,NULL,'15.7',0.2,NULL,NULL,NULL,NULL,NULL,1,230.4002083,14.38447,0.133,NULL,59574547781,930852309,14544567,15.7),(129309,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129309,36.69,0.11,218,59562,70,NULL,NULL,'MCG +01-39-020 NED04',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000113,NULL,'16.78',0.3,'AGN',NULL,NULL,NULL,NULL,1,230.401625,7.73908,0.073,NULL,59350976666,927359010,14489984,16.78),(129310,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129310,36.69,0.11,218,59563,70,NULL,NULL,'NGC 5919',NULL,'2015arXiv151105856S',2015,1,0.84,'UZC has V = 12984 +- 66 km/sec.','G',0.000083,NULL,'14.37',0.54,'SB0',NULL,NULL,NULL,NULL,1,230.403667,7.71931,0.073,NULL,59350977465,927359022,14489984,14.37),(129311,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129311,38.3,0.23,456,59564,70,NULL,NULL,'2MASX J15213769+3212303',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000142,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,230.407167,32.20836,0.041,NULL,59903086188,935985721,14624776,18.4),(129312,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129312,37.88,0.46,377,59565,70,NULL,NULL,'2MASX J15213777+2833479',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.0002,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.40725,28.56336,0.049,NULL,59907753889,936058654,14625916,17.4),(129313,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129313,38.71,0.46,551,59566,70,NULL,NULL,'2MASX J15213802+0519515',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,'PHOT','17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.4085417,5.33086,0.085,NULL,56429941657,881717838,13776841,17.9),(129314,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129314,38.17,0.33,431,59567,70,NULL,NULL,'2MASX J15213911+3140383',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000189,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,230.413125,31.67744,0.029,NULL,59903926484,935998851,14624982,16.7),(129315,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129315,38.11,0.46,419,59568,70,NULL,NULL,'2MASX J15213913+1243460',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,230.413167,12.72961,0.113,NULL,59562203857,930659435,14541553,18.2),(129316,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129316,38.31,0.46,460,59569,70,NULL,NULL,'2MASX J15213951+0432335',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.414625,4.54269,0.053,NULL,56427351175,881677362,13776208,17.8),(129317,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129317,36.89,0.46,239,59570,70,NULL,NULL,'2MASX J15213965+0015595',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000084,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,230.415083,0.26644,0.177,NULL,56375880454,880873132,13763642,16.9),(129318,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129318,36.73,0.46,222,59571,70,NULL,NULL,'2MASX J15214000+2548460',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00011,NULL,'15.6g',0.42,NULL,NULL,NULL,NULL,NULL,1,230.4165417,25.81275,0.109,NULL,59901121369,935955021,14624297,15.6),(129319,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129319,38.26,0.27,449,59572,70,NULL,NULL,'2MASX J15214008+4609241',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.417,46.15661,0.033,NULL,59966379967,936974686,14640229,17.9),(129320,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129320,37.41,0.46,303,59573,70,NULL,NULL,'2MASX J15214015+0752359',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000083,NULL,'16.00',0.31,'E',NULL,NULL,NULL,NULL,1,230.417167,7.8765,0.065,NULL,59351029029,927359828,14489997,16),(129321,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129321,37.12,0.27,265,59574,70,NULL,NULL,'2MASX J15214066+3333323',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000185,NULL,'16.0g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,230.41925,33.559,0.049,NULL,60104467465,939132304,14673942,16),(129322,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129322,37.53,0.11,321,59575,70,NULL,NULL,'2MASX J15214069+3040363',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00014,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.419667,30.67681,0.013,NULL,59906562028,936040031,14625625,17),(129323,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129323,38.16,0.23,429,59576,70,NULL,NULL,'2MASX J15214115+2212494',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.421583,22.21386,0.173,NULL,59421326114,928458220,14507159,17.8),(129324,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129324,36.69,0.11,218,59577,70,NULL,NULL,'CGCG 049-144',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00007,NULL,'15.4B',0.41,NULL,'Group member',NULL,NULL,NULL,1,230.4230417,7.72353,0.073,NULL,59350977307,927359020,14489984,15.4),(129325,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129325,37.53,0.11,321,59578,70,NULL,NULL,'2MASX J15214188+3035087',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000139,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.424375,30.58581,0.013,NULL,59906573996,936040218,14625628,17.6),(129326,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129326,37.19,0.23,274,59579,70,NULL,NULL,'2MASX J15214372+5646505',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.432375,56.78078,0.025,NULL,57593943789,899905371,14061021,17.4),(129327,'G Lens','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129327,41.92,NULL,2420,59580,NULL,NULL,'R(H) = ct','SBS 1520+530 ABS01',NULL,'2014ApJ...788..190W',2014,1,NULL,NULL,'AbLS',0.0009,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,230.436791667,52.9135,0.029,NULL,59673702489,932401601,14568775,NULL),(129328,'G Lens','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129328,41.93,NULL,2440,59580,NULL,NULL,'Standard','SBS 1520+530 ABS01',NULL,'2014ApJ...788..190W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129329,'G Lens','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129329,42.23,0.3,2790,59580,NULL,NULL,NULL,'SBS 1520+530 ABS01',NULL,'2007ApJ...660....1O',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129330,'G Lens','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129330,43.58,0.68,5200,59580,NULL,NULL,NULL,'SBS 1520+530 ABS01',NULL,'2014MNRAS.437..600S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129331,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129331,37.36,0.46,297,59581,70,NULL,NULL,'SDSS J152144.94+241814.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.43725,24.304,0.145,NULL,59417963889,928405685,14506338,18.2),(129332,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129332,38.22,0.46,440,59582,70,NULL,NULL,'2MASX J15214553+1917034',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,230.439625,19.28442,0.173,NULL,59442560271,928790004,14512343,17.5),(129333,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129333,37.27,0.46,284,59583,70,NULL,NULL,'2MASX J15214579+0211355',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,230.4407917,2.19325,0.097,NULL,56432736468,881761507,13777523,16.7),(129334,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129334,37.53,0.11,321,59584,70,NULL,NULL,'2MASX J15214645+3035517',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000067,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,230.443625,30.59758,0.013,NULL,59906566554,936040102,14625626,16.7),(129335,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129335,37.1,0.46,264,59585,70,NULL,NULL,'2MASX J15214666+0830199',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00009,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,230.444375,8.50544,0.045,NULL,59351468586,927366696,14490104,16.7),(129336,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129336,37.98,0.46,394,59586,70,NULL,NULL,'2MASX J15214699+0545425',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,230.445833,5.76183,0.049,NULL,56426712963,881667390,13776052,16.7),(129337,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129337,36.69,0.11,218,59587,70,NULL,NULL,'2MASX J15214777+0731219',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000057,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,230.449125,7.52283,0.073,NULL,56409728899,881402014,13771906,16.8),(129338,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129338,37.15,0.33,269,59588,70,NULL,NULL,'2MASX J15214868+5805155',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000185,NULL,'16.0g',0.39,'E0',NULL,NULL,NULL,NULL,1,230.4529583,58.08761,0.033,NULL,57721227306,901894176,14092096,16),(129339,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129339,37.57,0.46,326,59589,70,NULL,NULL,'2MASX J15214905+1159209',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.454583,11.98931,0.097,NULL,59342964900,927233826,14488028,17.7),(129340,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129340,38.64,0.46,534,59590,70,NULL,NULL,'2MASX J15214932+0221015',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.455417,2.35033,0.077,NULL,56433198381,881768724,13777636,17.8),(129341,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129341,37.67,0.46,341,59591,70,NULL,NULL,'2MASX J15214938+2833370',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.0002,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.455833,28.56019,0.049,NULL,59907767054,936058860,14625919,17.8),(129342,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129342,36.69,0.11,218,59592,70,NULL,NULL,'2MASX J15215039+0744089',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000067,NULL,'17.18',0.5,NULL,NULL,NULL,NULL,NULL,1,230.459917,7.73583,0.065,NULL,59350975785,927358996,14489984,17.18),(129343,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129343,35.93,0.33,154,59593,70,NULL,NULL,'2MASX J15215057+0821519',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000067,NULL,'16.2g',0.33,'S0','Group member',NULL,NULL,NULL,1,230.460666667,8.36442,0.069,NULL,59351174517,927362101,14490032,16.2),(129344,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129344,36.45,0.46,195,59594,70,NULL,NULL,'SDSS J152150.57+280618.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.0002,NULL,'17.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,230.4607083,28.10506,0.049,NULL,59907587505,936056054,14625875,17.6),(129345,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129345,36.69,0.11,218,59595,70,NULL,NULL,'NGC 5920',NULL,'2015arXiv151105856S',2015,1,1.1,'TXS codes: variable(*)','G',0.00008,NULL,'14.68',0.9,'cD;S0:         NLRG','Group member',NULL,NULL,NULL,1,230.4660417,7.70881,0.065,NULL,59350978164,927359033,14489984,14.68),(129346,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129346,37.72,0.33,349,59596,70,NULL,NULL,'2MASX J15215215+2019334',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,230.467375,20.32583,0.205,NULL,59412582992,928321609,14505025,NULL),(129347,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129347,38.19,0.46,435,59597,70,NULL,NULL,'SDSS J152152.76+391558.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000141,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,230.469875,39.26619,0.045,NULL,60110752629,939230509,14675476,18.6),(129348,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129348,36.69,0.46,218,59598,70,NULL,NULL,'2MASX J15215302+2621280',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000191,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,230.471083333,26.35769,0.113,NULL,59909759479,936089991,14626406,16.5),(129349,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129349,37.7,0.46,347,59599,70,NULL,NULL,'SDSS J152153.46+410439.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.4727917,41.07753,0.017,NULL,59975570096,937118282,14642473,17.9),(129350,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129350,35.56,0.23,129,59600,74.4,NULL,NULL,'IC 1116',NULL,'2013AJ....146...86T',2013,1,1.09,NULL,'G',0.000063,NULL,'14.3g',0.75,'cD;E/S0','Group member',NULL,NULL,NULL,1,230.480291667,8.42378,0.081,NULL,59351335005,927364609,14490072,14.3),(129351,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129351,35.68,0.16,137,59600,70,NULL,NULL,'IC 1116',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129352,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129352,35.93,0.33,154,59600,70,NULL,NULL,'IC 1116',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129353,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129353,36.16,0.4,170,59600,NULL,NULL,'mean','IC 1116',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129354,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129354,36.3,0.45,182,59600,NULL,NULL,'K','IC 1116',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129355,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129355,37.12,0.27,265,59601,70,NULL,NULL,'2MASX J15215589+3330548',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000224,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,230.483083333,33.51508,0.041,NULL,60104470466,939132351,14673942,16.6),(129356,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129356,37.36,0.46,296,59602,70,NULL,NULL,'2MASX J15215590+5258316',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000142,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.483083333,52.97556,0.029,NULL,59673697991,932401531,14568773,17.5),(129357,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129357,36.69,0.11,218,59603,70,NULL,NULL,'2MASX J15215644+0740249',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00008,NULL,'17.29',0.28,NULL,NULL,NULL,NULL,NULL,1,230.485166667,7.67353,0.073,NULL,56411557237,881430581,13772352,17.29),(129358,'Ring Diameter','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129358,31.9,0.76,24,59604,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5921',NULL,'1981ApJS...45..541P',1981,1,4.9,NULL,'G',0.000003,NULL,'11.49',4,'SB(r)bc        LINER','Field galaxy',NULL,NULL,NULL,1,230.485666667,5.07053,0.061,NULL,56430164373,881721318,13776895,11.49),(129359,'Ring Diameter','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129359,32.1,0.6,26,59604,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5921',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129360,'SNII optical','2016-12-15 15:15:34','2016-12-16 11:20:47','1','SN 2001X',NULL,129360,31.59,0.11,20.6,59604,NULL,NULL,'SEAM','NGC 5921',0.004937,'2009ApJ...694.1067P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129361,'SNII optical','2016-12-15 15:15:34','2016-12-16 11:20:47','1','SN 2001X',NULL,129361,31.85,0.22,23.4,59604,NULL,NULL,'V, photospheric magnitude method','NGC 5921',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129362,'SNII optical','2016-12-15 15:15:34','2016-12-16 11:20:47','1','SN 2001X',NULL,129362,31.96,0.2,24.7,59604,NULL,NULL,'I, photospheric magnitude method','NGC 5921',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129363,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129363,30.73,0.4,14,59604,NULL,NULL,NULL,'NGC 5921',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129364,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129364,32.01,0.4,25.2,59604,75,NULL,'B','NGC 5921',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129365,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129365,37.33,0.27,292,59605,70,NULL,NULL,'SDSS J152156.66+022039.2',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.4g',0.28,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.486083,2.34422,0.077,NULL,56433198646,881768728,13777636,16.4),(129366,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129366,35.96,0.46,156,59606,70,NULL,NULL,'2MASX J15215683+0444095',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'16.46',0.36,NULL,NULL,NULL,NULL,NULL,1,230.48675,4.73589,0.053,NULL,56429257020,881707140,13776674,16.46),(129367,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129367,38.57,0.46,518,59607,70,NULL,NULL,'2MASX J15215681+0322535',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000085,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.486791667,3.38144,0.057,NULL,56434569954,881790155,13777971,17.9),(129368,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129368,37.43,0.33,306,59608,70,NULL,NULL,'2MASX J15215743+2859180',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000117,NULL,'17.80',0.21,'Sy2',NULL,NULL,NULL,'Sy 2',1,230.48925,28.98839,0.033,NULL,59905903305,936029739,14625464,17.8),(129369,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129369,37.86,0.46,373,59609,70,NULL,NULL,'SDSS J152158.37+183332.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.4932083,18.55903,0.157,NULL,59433472327,928648005,14510125,18.2),(129370,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129370,38.15,0.46,427,59610,70,NULL,NULL,'2MASX J15215861+0337425',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00011,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,230.494333,3.62844,0.065,NULL,56434545713,881789776,13777965,16.9),(129371,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129371,37.71,0.33,348,59611,70,NULL,NULL,'2MASX J15215900+2724410',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,'Group member',NULL,NULL,NULL,1,230.495667,27.41153,0.089,NULL,59910894136,936107720,14626683,17.1),(129372,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129372,37.49,0.09,315,59612,70,NULL,NULL,'2MASX J15215953+2740390',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000217,NULL,'18.33',0.17,NULL,'Group member',NULL,NULL,NULL,1,230.498166667,27.67761,0.073,NULL,59910774539,936105852,14626653,18.33),(129373,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129373,37.72,0.33,349,59613,70,NULL,NULL,'2MASX J15215962+2022364',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,230.49825,20.37678,0.193,NULL,59415998373,928374974,14505858,16.5),(129374,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129374,38.3,0.23,456,59614,70,NULL,NULL,'2MASX J15215987+3217498',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000145,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.499417,32.29717,0.033,NULL,59911470464,936116726,14626823,17.5),(129375,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129375,36.26,0.46,179,59615,70,NULL,NULL,'2MASX J15220012+0533315',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'15.9g',0.32,NULL,NULL,NULL,NULL,NULL,1,230.500583,5.55892,0.049,NULL,56429486750,881710730,13776730,15.9),(129376,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129376,37.49,0.09,315,59616,70,NULL,NULL,'2MASX J15220013+2734450',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,'Group member',NULL,NULL,NULL,1,230.500583,27.57936,0.081,NULL,59910762577,936105665,14626651,17.1),(129377,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129377,37.49,0.09,315,59617,70,NULL,NULL,'2MASX J15220043+2739250',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,'Group member',NULL,NULL,NULL,1,230.501625,27.65706,0.073,NULL,59910774238,936105847,14626653,17.4),(129378,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129378,36.69,0.11,218,59618,70,NULL,NULL,'2MASX J15220101+0735109',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000043,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,230.504291667,7.58636,0.073,NULL,56412617954,881447155,13772611,16.8),(129379,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129379,37.53,0.11,321,59619,70,NULL,NULL,'SDSS J152201.41+304058.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,230.505875,30.68292,0.013,NULL,59906571352,936040177,14625627,18.6),(129380,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129380,37.71,0.33,348,59620,70,NULL,NULL,'2MASX J15220155+2727540',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,'Group member',NULL,NULL,NULL,1,230.5065417,27.46517,0.081,NULL,59910888362,936107630,14626681,18),(129381,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129381,37.63,0.46,336,59621,70,NULL,NULL,'SDSS J152201.69+271114.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.507083,27.18736,0.093,NULL,59910693228,936104581,14626634,18.3),(129382,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129382,37.77,0.46,358,59622,70,NULL,NULL,'2MASX J15220176+3949127',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000178,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.507417,39.82025,0.013,NULL,60110696875,939229638,14675463,17.9),(129383,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129383,37.36,0.27,297,59623,70,NULL,NULL,'2MASX J15220187+4801255',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000171,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,230.5079583,48.02372,0.041,NULL,59936697524,936510898,14632982,16.5),(129384,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129384,36.94,0.46,245,59624,70,NULL,NULL,'2MASX J15220248+1233085',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.510417,12.55239,0.113,NULL,59562196973,930659327,14541551,17.6),(129385,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129385,37.49,0.09,315,59625,70,NULL,NULL,'2MASX J15220270+2748270',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.25,NULL,'Group member',NULL,NULL,NULL,1,230.511333333,27.80761,0.069,NULL,59907905655,936061025,14625953,17.3),(129386,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129386,37.33,0.27,292,59626,70,NULL,NULL,'2MASX J15220346+0224543',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.68',0.38,NULL,NULL,NULL,NULL,NULL,1,230.514458333,2.41517,0.077,NULL,56433276581,881769946,13777655,16.68),(129387,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129387,36.69,0.11,218,59627,70,NULL,NULL,'2MASX J15220466+0736386',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000067,NULL,'16.90',0.3,NULL,NULL,NULL,NULL,NULL,1,230.519541667,7.61086,0.073,NULL,56412616605,881447134,13772611,16.9),(129388,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129388,37.53,0.11,321,59628,70,NULL,NULL,'2MASX J15220596+3029517',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000067,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,230.524875,30.49764,0.013,NULL,59906708470,936042319,14625661,17),(129389,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129389,38,0.46,399,59629,70,NULL,NULL,'2MASX J15220687+0615326',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000143,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,230.5287917,6.25908,0.057,NULL,56409501334,881398458,13771850,17.2),(129390,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129390,37.49,0.09,315,59630,70,NULL,NULL,'2MASX J15220718+2811300',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,230.5297917,28.19161,0.049,NULL,59907632414,936056756,14625886,16.7),(129391,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129391,34.91,0.46,96.1,59631,70,NULL,NULL,'2MASX J15220752+1411215',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'15.84',0.52,NULL,NULL,NULL,NULL,NULL,1,230.53125,14.18931,0.129,NULL,59574385436,930849772,14544527,15.84),(129392,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129392,37.33,0.46,293,59632,70,NULL,NULL,'2MASX J15220763+5739084',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000098,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,230.531583,57.65239,0.045,NULL,57589617861,899837779,14059965,16.3),(129393,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129393,35.67,0.2,136,59633,74.4,NULL,NULL,'CGCG 077-088',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000009,NULL,'15.0',0.6,'S',NULL,NULL,NULL,NULL,1,230.532625,13.92822,0.125,NULL,59574321280,930848770,14544512,15),(129394,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129394,37.81,0.46,364,59634,70,NULL,NULL,'2MASX J15220927+2837321',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.0002,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.5387083,28.62569,0.041,NULL,59907761847,936058778,14625918,17.3),(129395,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129395,38.53,0.46,507,59635,70,NULL,NULL,'2MASX J15220990+4253027',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000151,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.541208333,42.88394,0.081,NULL,59978294103,937160845,14643138,17.7),(129396,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129396,37.88,0.46,376,59636,70,NULL,NULL,'2MASX J15221008+2411001',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.43',0.15,NULL,NULL,NULL,NULL,NULL,1,230.542208333,24.18347,0.153,NULL,59418004691,928406323,14506348,18.43),(129397,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129397,37.29,0.46,287,59637,70,NULL,NULL,'2MASX J15221052+3331007',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000172,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,230.543917,33.51692,0.041,NULL,60104467045,939132297,14673942,17),(129398,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129398,37.15,0.33,269,59638,70,NULL,NULL,'2MASX J15221309+5807212',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000076,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,230.554583,58.12258,0.033,NULL,57721227050,901894172,14092096,16.9),(129399,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129399,37.12,0.27,265,59639,70,NULL,NULL,'2MASX J15221419+3326077',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.5592083,33.43539,0.037,NULL,60104500488,939132820,14673950,17.6),(129400,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129400,37.27,0.46,285,59640,70,NULL,NULL,'2MASX J15221424+0637406',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.55925,6.62803,0.053,NULL,56409586030,881399781,13771871,18),(129401,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129401,37.49,0.09,315,59641,70,NULL,NULL,'2MASX J15221530+2736171',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,'Group member',NULL,NULL,NULL,1,230.563833,27.60467,0.073,NULL,59910757073,936105579,14626649,17.4),(129402,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129402,37.91,0.46,382,59642,70,NULL,NULL,'SDSS J152215.32+190137.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.563875,19.02722,0.169,NULL,59442632146,928791127,14512361,18.5),(129403,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129403,37.55,0.46,324,59643,70,NULL,NULL,'2MASX J15221586+2342040',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.566208333,23.70119,0.149,NULL,59422338427,928474037,14507406,18),(129404,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129404,37.82,0.46,367,59644,70,NULL,NULL,'2MASX J15221634+0824366',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000087,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,230.5680417,8.41028,0.081,NULL,59351058539,927360289,14490004,16.7),(129405,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129405,36.69,0.11,218,59645,70,NULL,NULL,'2MASX J15221641+0802546',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000083,NULL,'16.0g',0.37,'S0','Group member',NULL,NULL,NULL,1,230.568417,8.04844,0.057,NULL,59351213122,927362705,14490042,16),(129406,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129406,37.95,0.46,389,59646,70,NULL,NULL,'SDSS J152216.84+124453.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.570208333,12.74806,0.109,NULL,59562223958,930659749,14541558,18.5),(129407,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129407,37.34,0.33,294,59647,70,NULL,NULL,'2MASX J15221736+3706016',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.77',0.4,NULL,NULL,NULL,NULL,NULL,1,230.5724583,37.10056,0.029,NULL,60112445970,939256968,14675890,16.77),(129408,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129408,35.62,0.25,133,59648,74.4,NULL,NULL,'CGCG 077-089',NULL,'2013AJ....146...86T',2013,1,0.55,NULL,'G',0.000047,NULL,'15.7',0.31,'S0','Group member',NULL,NULL,NULL,1,230.575125,8.57989,0.073,NULL,59351343490,927364742,14490074,15.7),(129409,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129409,37.36,0.46,296,59649,70,NULL,NULL,'2MASX J15221858+2658081',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,230.577333,26.96894,0.093,NULL,59909631985,936087999,14626374,17.2),(129410,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129410,37.67,0.33,341,59650,70,NULL,NULL,'2MASX J15221862+2314210',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'16.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.5775,23.23906,0.189,NULL,59420993418,928453022,14507078,16.9),(129411,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129411,37.49,0.09,315,59651,70,NULL,NULL,'2MASX J15221903+2805371',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.53',0.15,NULL,NULL,NULL,NULL,NULL,1,230.57925,28.09375,0.049,NULL,59908042613,936063165,14625986,18.53),(129412,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129412,38.04,0.46,406,59652,70,NULL,NULL,'2MASX J15221914+2204240',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000174,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.57975,22.07342,0.173,NULL,59421302468,928457851,14507153,17.3),(129413,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129413,37.13,0.46,267,59653,70,NULL,NULL,'SDSS J152219.55+361848.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00014,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,230.5815417,36.31336,0.037,NULL,60105703373,939151615,14674243,18.2),(129414,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129414,37.65,0.27,338,59654,70,NULL,NULL,'SDSS J152220.49+483029.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000174,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,230.585417,48.50828,0.025,NULL,59937002158,936515658,14633057,18.6),(129415,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129415,37.17,0.46,271,59655,70,NULL,NULL,'2MASX J15222065+2449151',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000137,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.5859583,24.82081,0.129,NULL,59418440809,928413137,14506455,17.9),(129416,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129416,37.24,0.46,281,59656,70,NULL,NULL,'SDSS J152221.74+032640.2',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000073,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.590583333,3.4445,0.061,NULL,56434524796,881789449,13777960,17.7),(129417,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129417,38.45,0.46,490,59657,70,NULL,NULL,'2MASX J15222180-0207431',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000178,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,230.590917,-2.12881,0.329,NULL,45421874978,709716796,11089324,18.6),(129418,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129418,36.68,0.46,216,59658,70,NULL,NULL,'2MASX J15222192+0031433',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000098,NULL,'16.0g',0.47,'E0',NULL,NULL,NULL,NULL,1,230.591417,0.52881,0.161,NULL,56430326422,881723850,13776935,16),(129419,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129419,38.23,0.33,443,59659,70,NULL,NULL,'2MASX J15222240+2327560',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.593417,23.46544,0.197,NULL,59424387737,928506058,14507907,17.7),(129420,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129420,37.64,0.46,337,59660,70,NULL,NULL,'2MASX J15222296+2229410',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.62',0.18,NULL,NULL,NULL,NULL,NULL,1,230.595708333,22.49464,0.173,NULL,59421729745,928464527,14507258,18.62),(129421,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129421,37.88,0.46,377,59661,70,NULL,NULL,'SDSS J152223.10+115614.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.59625,11.93733,0.097,NULL,59342955839,927233684,14488026,17.9),(129422,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129422,36.23,0.46,176,59662,70,NULL,NULL,'2MASX J15222368+0817026',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000112,NULL,'16.8g',0.25,'S0','Group member',NULL,NULL,NULL,1,230.5987083,8.28422,0.069,NULL,59351064422,927360381,14490005,16.8),(129423,'BCG','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129423,37.91,0.35,356,59663,60,NULL,'ABELL 2065, BCG','MCG +05-36-020',0.0722,'1980ApJ...241..486H',1980,1,0.4,NULL,'G',0.000167,NULL,'16.30',0.4,'S0?;BrClG','Group member',NULL,NULL,NULL,1,230.600083,27.71436,0.073,NULL,59907957637,936061838,14625966,16.3),(129424,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129424,37.49,0.09,315,59663,70,NULL,NULL,'MCG +05-36-020',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129425,'IRAS','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129425,34.22,0.8,69.9,59664,75,NULL,'MAT, I','ESO 328- G 046',NULL,'1997ApJS..109..333W',1997,1,2.1,'Confused HIPASS source','G',0.000017,NULL,'14.3b',1.3,'SB(rs)cd?',NULL,NULL,NULL,NULL,1,230.602,-38.19942,0.441,NULL,47194113609,737408025,11522000,14.3),(129426,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129426,34.05,0.2,64.6,59664,74.4,NULL,NULL,'ESO 328- G 046',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129427,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129427,34.08,0.43,65.5,59664,NULL,NULL,NULL,'ESO 328- G 046',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129428,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129428,34.15,0.32,67.6,59664,85,NULL,'I, raw','ESO 328- G 046',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129429,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129429,34.17,0.47,68.2,59664,NULL,NULL,'H','ESO 328- G 046',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129430,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129430,34.17,0.46,68.4,59664,NULL,NULL,'J','ESO 328- G 046',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129431,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129431,34.22,0.4,69.7,59664,NULL,NULL,'Malmquist cor.','ESO 328- G 046',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129432,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129432,34.22,0.45,69.8,59664,NULL,NULL,'K','ESO 328- G 046',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129433,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129433,34.22,0.32,69.8,59664,85,NULL,'I, inv','ESO 328- G 046',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129434,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129434,34.29,0.4,72.2,59664,NULL,NULL,'mean','ESO 328- G 046',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129435,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129435,34.6,0.43,83.3,59664,75,NULL,'MAT, I, raw','ESO 328- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129436,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129436,34.85,0.43,93.1,59664,75,NULL,'MAT, I, cor','ESO 328- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129437,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129437,34.95,0.43,97.6,59664,75,NULL,'MAT, I, inv','ESO 328- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129438,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129438,36.28,0.61,180,59665,70,NULL,NULL,'2MASX J15222476-4349122',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,230.60325,-43.82003,0.689,NULL,47071126007,735486343,11491974,15.5),(129439,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129439,37.64,0.15,337,59666,70,NULL,NULL,'SDSS J152224.82+484211.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,230.6034583,48.70328,0.029,NULL,59664613018,932259578,14566555,17.9),(129440,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129440,37.49,0.09,315,59667,70,NULL,NULL,'SDSS J152224.93+274355.0',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'16.2',0.13,NULL,'Group member',NULL,NULL,NULL,1,230.603875,27.73194,0.073,NULL,59907957527,936061836,14625966,16.2),(129441,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129441,37.92,0.46,384,59668,70,NULL,NULL,'2MASX J15222494+0234033',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.27,'AGN',NULL,NULL,NULL,NULL,1,230.604,2.56761,0.085,NULL,56433309864,881770466,13777663,17),(129442,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129442,38.45,0.46,489,59669,70,NULL,NULL,'2MASX J15222503+2623122',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000176,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.6045417,26.38681,0.105,NULL,59901591501,935962367,14624411,17.6),(129443,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129443,36.76,0.33,225,59670,70,NULL,NULL,'2MASX J15222564+0910276',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.606917,9.17439,0.061,NULL,59350524944,927351952,14489874,17.7),(129444,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129444,37.9,0.46,379,59671,70,NULL,NULL,'2MASX J15222614+0222013',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.609083,2.36711,0.093,NULL,56433098435,881767163,13777611,17.3),(129445,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129445,37.43,0.33,306,59672,70,NULL,NULL,'2MASX J15222643+2859521',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00014,NULL,'17.97',0.22,'E',NULL,NULL,NULL,NULL,1,230.610333,28.99772,0.033,NULL,59905778913,936027795,14625434,17.97),(129446,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129446,37.49,0.09,315,59673,70,NULL,NULL,'2MASX J15222696+2751151',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.14,NULL,'Group member',NULL,NULL,NULL,1,230.612167,27.85436,0.069,NULL,59907912099,936061126,14625955,18),(129447,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129447,37.19,0.46,274,59674,70,NULL,NULL,'2MASX J15222739+3618042',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.614167,36.30117,0.037,NULL,60105699660,939151557,14674243,17.3),(129448,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129448,36.69,0.11,218,59675,70,NULL,NULL,'2MASX J15222752+0743096',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00011,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,230.614667,7.71942,0.065,NULL,56411614142,881431470,13772366,16.1),(129449,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129449,37.65,0.27,338,59676,70,NULL,NULL,'SDSS J152227.55+482329.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.614833,48.39161,0.025,NULL,59937012229,936515816,14633059,17.9),(129450,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129450,37.58,0.46,329,59677,70,NULL,NULL,'2MASX J15222805+0036553',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000071,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.61675,0.61528,0.185,NULL,56430360042,881724375,13776943,18),(129451,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129451,37.64,0.15,337,59678,70,NULL,NULL,'2MASX J15222823+4848063',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000182,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,230.6177917,48.80181,0.037,NULL,59664735214,932261487,14566585,16.6),(129452,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129452,37.49,0.09,315,59679,70,NULL,NULL,'MCG +05-36-021',NULL,'2015arXiv151105856S',2015,1,0.1,NULL,'G',0.00025,NULL,'15.28',0.1,'E1','Group member',NULL,NULL,NULL,1,230.6185417,27.68692,0.073,NULL,59907924635,936061322,14625958,15.28),(129453,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129453,36.47,0.1,197,59680,70,NULL,NULL,'2MASX J15222975+2031440',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,230.6240417,20.52892,0.185,NULL,59413897759,928342152,14505346,17.8),(129454,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129454,37.49,0.09,315,59681,70,NULL,NULL,'2MASX J15222998+2745181',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,'Group member',NULL,NULL,NULL,1,230.625,27.75511,0.069,NULL,59907960263,936061879,14625966,17.3),(129455,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129455,37.24,0.46,281,59682,70,NULL,NULL,'2MASX J15222997+4833023',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.625125,48.55053,0.029,NULL,59664573250,932258957,14566546,17.4),(129456,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129456,36.16,0.09,171,59683,70,NULL,NULL,'2MASX J15223022+0840396',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00005,NULL,'16.6g',0.29,'E','Group member',NULL,NULL,NULL,1,230.62575,8.67761,0.073,NULL,59351443104,927366298,14490098,16.6),(129457,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129457,37.34,0.33,294,59684,70,NULL,NULL,'2MASX J15223031+3703152',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000181,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.626166667,37.05406,0.029,NULL,60112475024,939257422,14675897,17.2),(129458,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129458,34.91,0.49,95.8,59685,75,NULL,'IR','UGC 09828',NULL,'2011yCatp016004901K',2011,1,1.79,NULL,'G',0.000007,NULL,'15.67',0.15,'Sc','Isolated galaxy',NULL,NULL,NULL,1,230.629,19.26136,0.177,NULL,59442714525,928792414,14512381,15.67),(129459,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129459,35.11,NULL,105,59685,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09828',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129460,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129460,35.12,NULL,106,59685,NULL,NULL,'Dipole + Quadrupole','UGC 09828',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129461,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129461,35.13,NULL,106,59685,NULL,NULL,'Dipole','UGC 09828',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129462,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129462,35.17,NULL,108,59685,NULL,NULL,NULL,'UGC 09828',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129463,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129463,35.51,0.5,126,59685,NULL,NULL,'Malmquist cor.','UGC 09828',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129464,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129464,35.53,0.2,128,59685,74.4,NULL,NULL,'UGC 09828',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129465,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129465,35.53,0.49,128,59685,NULL,NULL,NULL,'UGC 09828',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129466,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129466,35.76,0.46,142,59686,70,NULL,NULL,'2MASX J15223174+3853432',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000152,NULL,'16.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,230.63225,38.89528,0.041,NULL,60111715327,939245551,14675711,16.1),(129467,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129467,36.16,0.09,171,59687,70,NULL,NULL,'2MASX J15223177+0846426',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000073,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,230.632333333,8.77864,0.065,NULL,59351435051,927366172,14490096,16.6),(129468,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129468,37.49,0.09,315,59688,70,NULL,NULL,'2MASX J15223194+2743091',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.78',0.14,NULL,NULL,NULL,NULL,NULL,1,230.633166667,27.71928,0.073,NULL,59907960363,936061880,14625966,18.78),(129469,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129469,38.15,0.33,426,59689,70,NULL,NULL,'2MASX J15223212+0050484',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000087,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.63375,0.84686,0.165,NULL,56431077470,881735585,13777118,17.6),(129470,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129470,37.97,0.33,392,59690,70,NULL,NULL,'SDSS J152232.10+054833.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.63375,5.80931,0.049,NULL,56429408384,881709506,13776711,18.5),(129471,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129471,37.7,0.33,347,59691,70,NULL,NULL,'SDSS J152233.70+292759.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.9g',0.18,'AGN',NULL,NULL,NULL,NULL,1,230.640458333,29.46658,0.021,NULL,59905840179,936028752,14625449,17.9),(129472,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129472,37.49,0.09,315,59692,70,NULL,NULL,'2MASX J15223389+2738441',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,'Group member',NULL,NULL,NULL,1,230.641083,27.64561,0.073,NULL,59907925349,936061333,14625958,17.4),(129473,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129473,36.68,0.46,216,59693,70,NULL,NULL,'2MASX J15223405+4602508',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000183,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,230.6419583,46.0475,0.041,NULL,59966429563,936975461,14640241,16.4),(129474,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129474,38.07,0.46,412,59694,70,NULL,NULL,'SDSS J152234.17+443711.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000139,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,230.642375,44.61986,0.029,NULL,59969251460,937019554,14640930,18.7),(129475,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129475,36.69,0.11,218,59695,70,NULL,NULL,'2MASX J15223511+0743404',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000073,NULL,'16.70',NULL,NULL,NULL,NULL,NULL,NULL,1,230.646375,7.72775,0.065,NULL,56411614251,881431472,13772366,16.7),(129476,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129476,38.16,0.46,429,59696,70,NULL,NULL,'2MASX J15223549+2959245',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000163,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,230.6477917,29.99022,0.025,NULL,59906595863,936040560,14625633,16.9),(129477,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129477,36.16,0.09,171,59697,70,NULL,NULL,'2MASX J15223661+0834474',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00005,NULL,'16.3g',0.3,'S0','Group member',NULL,NULL,NULL,1,230.652416667,8.57989,0.073,NULL,59351355175,927364924,14490076,16.3),(129478,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129478,37.49,0.09,315,59698,70,NULL,NULL,'2MASX J15223691+2748081',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.7g',0.29,NULL,'Group member',NULL,NULL,NULL,1,230.6537083,27.80219,0.069,NULL,59907958939,936061858,14625966,16.7),(129479,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129479,36.16,0.09,171,59699,70,NULL,NULL,'2MASX J15223709+0828194',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000043,NULL,'16.0',0.4,'S0','Group member',NULL,NULL,NULL,1,230.654667,8.47222,0.081,NULL,59351341014,927364703,14490073,16),(129480,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129480,37.26,0.33,284,59700,70,NULL,NULL,'2MASX J15223726+2958185',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,230.655125,29.97181,0.025,NULL,59906595533,936040555,14625633,16.9),(129481,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129481,37.67,0.33,341,59701,70,NULL,NULL,'2MASX J15223744+2311272',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.6562083,23.19103,0.189,NULL,59420996115,928453064,14507079,17.6),(129482,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129482,37.82,0.19,367,59702,70,NULL,NULL,'2MASX J15223828+2837111',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.57',0.17,NULL,NULL,NULL,NULL,NULL,1,230.659708333,28.61969,0.041,NULL,59907679159,936057486,14625898,18.57),(129483,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129483,38.32,0.46,462,59703,70,NULL,NULL,'2MASX J15223870+1644415',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.6612917,16.745,0.089,NULL,59565711522,930714242,14542410,17.2),(129484,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129484,37.49,0.09,315,59704,70,NULL,NULL,'2MASX J15223893+2738061',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,'Group member',NULL,NULL,NULL,1,230.6622917,27.63511,0.073,NULL,59907929628,936061400,14625959,17.4),(129485,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129485,36.16,0.09,171,59705,70,NULL,NULL,'2MASX J15223924+0832264',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000053,NULL,'17.0g',0.19,'S0','Group member',NULL,NULL,NULL,1,230.663417,8.54075,0.073,NULL,59351353305,927364895,14490076,17),(129486,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129486,37.49,0.09,315,59706,70,NULL,NULL,'2MASX J15223931+2739131',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,'Group member',NULL,NULL,NULL,1,230.66375,27.65369,0.073,NULL,59907926536,936061352,14625958,18.1),(129487,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129487,36.22,0.46,175,59707,70,NULL,NULL,'SDSS J152239.47+094242.9',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.1g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.6644583,9.71192,0.069,NULL,59355604670,927431322,14491114,17.1),(129488,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129488,38.53,0.46,507,59708,70,NULL,NULL,'2MASX J15223946+3240005',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.6644583,32.66678,0.033,NULL,59882108555,935657946,14619655,17.6),(129489,'SNIa','2016-12-15 15:15:34','2016-12-16 11:20:48','1','SN 2010dw',NULL,129489,36.01,0.2,154,59709,73.8,NULL,'SALT 2 (SNANA)','2MASX J15224062-0555214',0.0389,'2014ApJ...795...44R',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,230.66925,-5.92281,0.289,NULL,45428035897,709813060,11090829,16.8),(129490,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129490,38.15,0.33,426,59710,70,NULL,NULL,'2MASX J15224099+0054134',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000122,NULL,'16.8g',0.3,'AGN',NULL,NULL,NULL,NULL,1,230.670625,0.90356,0.165,NULL,56431082903,881735670,13777119,16.8),(129491,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129491,37.7,0.33,347,59711,70,NULL,NULL,'SDSS J152241.74+292935.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.6739583,29.49325,0.021,NULL,59905840810,936028762,14625449,18.2),(129492,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129492,36.05,0.34,162,59712,NULL,NULL,'Malmquist cor.','2MASX J15224215+0822074',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000027,NULL,'17.3g',0.15,'Sb:',NULL,NULL,NULL,NULL,1,230.6754583,8.36886,0.081,NULL,59351068117,927360439,14490006,17.3),(129493,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129493,36.04,0.34,162,59712,NULL,NULL,NULL,'2MASX J15224215+0822074',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129494,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129494,36.08,0.2,164,59712,74.4,NULL,NULL,'2MASX J15224215+0822074',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129495,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129495,37.37,0.46,298,59713,70,NULL,NULL,'2MASX J15224239+5609434',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000167,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.6769583,56.16208,0.021,NULL,57593402635,899896916,14060889,17.1),(129496,'BCG','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129496,37.91,0.35,356,59714,60,NULL,NULL,'ABELL 2065',0.0722,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,230.6775417,27.72264,0.073,NULL,59907958732,936061855,14625966,NULL),(129497,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129497,37.26,0.33,284,59715,70,NULL,NULL,'2MASX J15224272+2956305',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,230.678083,29.94189,0.025,NULL,59906594912,936040545,14625633,17),(129498,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129498,37.95,0.46,389,59716,70,NULL,NULL,'2MASX J15224287+0702484',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.6787083,7.04678,0.053,NULL,56412673351,881448021,13772625,17.5),(129499,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129499,36.74,0.46,223,59717,70,NULL,NULL,'2MASX J15224310+3101405',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00007,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,230.6795417,31.02792,0.025,NULL,59903833863,935997404,14624959,17.3),(129500,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129500,38.27,0.33,452,59718,70,NULL,NULL,'2MASX J15224334+3147205',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.680667,31.78914,0.033,NULL,59911505982,936117280,14626832,17.9),(129501,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129501,37.82,0.46,367,59719,70,NULL,NULL,'2MASX J15224371+4213366',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.682125,42.22681,0.053,NULL,59978113257,937158019,14643094,18.2),(129502,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129502,37.49,0.09,315,59720,70,NULL,NULL,'SDSS J152244.01+274000.5',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.27,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.683416667,27.66683,0.073,NULL,59907928472,936061382,14625959,16.9),(129503,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129503,38.51,0.46,504,59721,70,NULL,NULL,'SDSS J152244.07+401225.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000168,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,230.6837083,40.20722,0.025,NULL,59975402402,937115662,14642432,18.7),(129504,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129504,36.16,0.09,171,59722,70,NULL,NULL,'2MASX J15224423+0830134',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00009,NULL,'17.2g',0.2,NULL,'Group member',NULL,NULL,NULL,1,230.684291667,8.50372,0.073,NULL,59351357631,927364962,14490077,17.2),(129505,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129505,38.14,0.46,424,59723,70,NULL,NULL,'2MASX J15224544+0516044',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.6892917,5.268,0.065,NULL,56430093345,881720208,13776878,17.5),(129506,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129506,38.4,0.46,479,59724,70,NULL,NULL,'2MASX J15224563+1942203',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.6900417,19.70567,0.177,NULL,59442409559,928787649,14512307,17.4),(129507,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129507,37.32,0.33,290,59725,70,NULL,NULL,'2MASX J15224626+3436406',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000138,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.692667,34.61142,0.037,NULL,60108240005,939191250,14674863,17.5),(129508,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129508,37.31,0.46,289,59726,70,NULL,NULL,'2MASX J15224631+0151584',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.61',0.34,NULL,NULL,NULL,NULL,NULL,1,230.693041667,1.86633,0.097,NULL,56433798253,881778097,13777782,16.61),(129509,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129509,38,0.46,399,59727,70,NULL,NULL,'2MASX J15224669+2915250',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.39',0.16,NULL,NULL,NULL,NULL,NULL,1,230.694458333,29.25694,0.029,NULL,59905884022,936029437,14625459,17.39),(129510,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129510,38.14,0.46,425,59728,70,NULL,NULL,'2MASX J15224703+3203185',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.696083333,32.05508,0.033,NULL,59911546963,936117921,14626842,17.6),(129511,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129511,37.36,0.27,297,59729,70,NULL,NULL,'2MASX J15224705+4800343',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000164,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,230.69625,48.00964,0.029,NULL,59936732485,936511445,14632991,16.5),(129512,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129512,37.89,0.46,378,59730,70,NULL,NULL,'2MASX J15224913+0544544',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,230.704625,5.74833,0.049,NULL,56429421005,881709703,13776714,16.9),(129513,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129513,38.27,0.33,452,59731,70,NULL,NULL,'2MASX J15224948+3147577',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.706333333,31.79947,0.033,NULL,59911518088,936117470,14626835,17.4),(129514,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129514,37.2,0.27,275,59732,70,NULL,NULL,'2MASX J15224951+0726174',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00007,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.706375,7.43833,0.057,NULL,56412851669,881450807,13772668,17.3),(129515,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129515,37.36,0.27,297,59733,70,NULL,NULL,'2MASX J15225164+4801132',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.715,48.02036,0.029,NULL,59936735090,936511485,14632991,17.8),(129516,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129516,37.2,0.27,275,59734,70,NULL,NULL,'2MASX J15225254+0720064',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.7190417,7.33497,0.057,NULL,56412855387,881450865,13772669,17.1),(129517,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129517,36.16,0.09,171,59735,70,NULL,NULL,'CGCG 077-093',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000057,NULL,'15.7g',0.39,'S0','Group member',NULL,NULL,NULL,1,230.7199583,8.74494,0.065,NULL,59351322301,927364410,14490068,15.7),(129518,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129518,36.4,0.25,191,59735,74.4,NULL,NULL,'CGCG 077-093',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129519,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129519,38.23,0.33,443,59736,70,NULL,NULL,'SDSS J152252.85+232400.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.7202083,23.40019,0.197,NULL,59420981679,928452838,14507075,18.5),(129520,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129520,37.25,0.46,282,59737,70,NULL,NULL,'2MASX J15225292+0138404',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.62',0.31,NULL,NULL,NULL,NULL,NULL,1,230.7204583,1.64461,0.101,NULL,56433818506,881778414,13777787,16.62),(129521,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129521,37.23,0.46,279,59738,70,NULL,NULL,'2MASX J15225327+4032592',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00016,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,230.721833,40.54983,0.013,NULL,59975454612,937116478,14642444,16.7),(129522,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129522,37.2,0.27,275,59739,70,NULL,NULL,'2MASX J15225341+0721074',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000143,NULL,'15.7g',0.48,NULL,NULL,NULL,NULL,NULL,1,230.722583333,7.35197,0.057,NULL,56412854838,881450856,13772669,15.7),(129523,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129523,38.5,0.46,500,59740,70,NULL,NULL,'2MASX J15225469+2627400',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000178,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.727917,26.46114,0.101,NULL,59901721616,935964400,14624443,17.5),(129524,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129524,35.79,0.25,144,59741,74.4,NULL,NULL,'2MASX J15225515+0824004',NULL,'2013AJ....146...86T',2013,1,0.59,NULL,'G',0.000047,NULL,'16.4g',0.19,'S0','Group member',NULL,NULL,NULL,1,230.729917,8.40025,0.081,NULL,59351097391,927360896,14490014,16.4),(129525,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129525,35.74,0.33,140,59742,70,NULL,NULL,'CGCG 021-081',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00015,NULL,'15.8g',0.42,'E','in a triple',NULL,NULL,NULL,1,230.732375,-1.35644,0.313,NULL,45420495666,709695244,11088988,15.8),(129526,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129526,35.89,0.51,150,59742,70,NULL,NULL,'CGCG 021-081',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129527,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129527,34.53,0.69,80.6,59743,NULL,NULL,NULL,'CGCG 077-095',NULL,'2009ApJS..182..474S',2009,1,0.2,NULL,'G',0.000033,NULL,'15.6',0.2,'Sb','Group member',NULL,NULL,NULL,1,230.732625,8.52128,0.073,NULL,59351367137,927365111,14490079,15.6),(129528,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129528,34.71,0.64,87.3,59743,NULL,NULL,'Malmquist cor.','CGCG 077-095',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129529,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129529,36.76,0.33,225,59744,70,NULL,NULL,'SDSS J152255.92+091157.1',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,230.733,9.19919,0.069,NULL,59354833145,927419267,14490926,17.1),(129530,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129530,36.02,0.25,160,59745,74.4,NULL,NULL,'2MASX J15225650+0839004',NULL,'2013AJ....146...86T',2013,1,0.41,NULL,'G',0.000057,NULL,'16.0g',0.21,'S0','Group member',NULL,NULL,NULL,1,230.735333333,8.65025,0.073,NULL,59351331144,927364549,14490071,16),(129531,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129531,36.16,0.09,171,59745,70,NULL,NULL,'2MASX J15225650+0839004',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129532,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129532,36.57,0.54,206,59746,70,NULL,NULL,'2MASX J15225701-1639494',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,230.737667,-16.66372,0.477,NULL,46667641306,729181895,11393467,15.5),(129533,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129533,37.32,0.33,290,59747,70,NULL,NULL,'2MASX J15225711+3442247',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000161,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,230.7377917,34.70697,0.033,NULL,60108230365,939191099,14674860,16.9),(129534,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129534,35.74,0.33,140,59748,70,NULL,NULL,'CGCG 021-083',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00017,NULL,'15.8g',0.49,'E','in a triple',NULL,NULL,NULL,1,230.7385,-1.38111,0.313,NULL,45420498485,709695288,11088988,15.8),(129535,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129535,35.27,0.5,113,59749,NULL,NULL,NULL,'CGCG 049-153',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000037,NULL,'15.5',0.4,'SD/I','Group member',NULL,NULL,NULL,1,230.740417,8.04028,0.069,NULL,56411702105,881432845,13772388,15.5),(129536,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129536,35.31,0.2,115,59749,74.4,NULL,NULL,'CGCG 049-153',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129537,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129537,35.67,0.42,136,59749,NULL,NULL,'Malmquist cor.','CGCG 049-153',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129538,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129538,38.33,0.46,463,59750,70,NULL,NULL,'SDSS J152300.60+444313.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000183,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,230.7525417,44.72033,0.029,NULL,59969966176,937030721,14641105,18.4),(129539,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129539,37.65,0.27,338,59751,70,NULL,NULL,'SDSS J152300.72+482745.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.7530417,48.46261,0.025,NULL,59664580434,932259069,14566547,17.8),(129540,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129540,32.5,0.2,31.6,59752,74.4,NULL,NULL,'UGC 09830',NULL,'2013AJ....146...86T',2013,1,1.9,NULL,'G',0.000018,NULL,'15.39',0.22,'Sc',NULL,NULL,NULL,NULL,1,230.75375,4.52944,0.069,NULL,56427300546,881676571,13776196,15.39),(129541,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129541,32.8,NULL,36.3,59752,NULL,NULL,'Dipole','UGC 09830',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129542,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129542,32.81,NULL,36.4,59752,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09830',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129543,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129543,32.81,NULL,36.5,59752,NULL,NULL,'Dipole + Quadrupole','UGC 09830',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129544,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129544,32.81,0.56,36.5,59752,NULL,NULL,'Malmquist cor.','UGC 09830',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129545,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129545,32.81,NULL,36.5,59752,72,NULL,NULL,'UGC 09830',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129546,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129546,32.83,0.55,36.7,59752,NULL,NULL,NULL,'UGC 09830',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129547,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129547,32.97,NULL,39.3,59752,NULL,NULL,NULL,'UGC 09830',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129548,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129548,37.2,0.46,275,59753,70,NULL,NULL,'2MASX J15230109+0851004',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00009,NULL,'17.1g',0.22,'S0','Group member',NULL,NULL,NULL,1,230.7545,8.85022,0.065,NULL,59350535730,927352120,14489876,17.1),(129549,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129549,35.3,0.4,115,59754,NULL,NULL,'mean','UGC 09829',NULL,'2007A&A...465...71T',2007,1,2.2,NULL,'G',0.000003,NULL,'14.51',0.9,'Sb pec','in a triple',NULL,NULL,NULL,1,230.756625,-1.34719,0.313,NULL,45420497388,709695271,11088988,14.51),(129550,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129550,35.33,0.47,116,59754,NULL,NULL,'H','UGC 09829',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129551,'BCG','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129551,36.4,0.35,184,59755,60,NULL,NULL,'ABELL 2063',0.0337,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',0.00026,NULL,NULL,NULL,'II:    [BM]',NULL,NULL,NULL,NULL,1,230.75775,8.63942,0.073,NULL,59351329310,927364520,14490070,NULL),(129552,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129552,36.01,0.08,159,59755,70,NULL,NULL,'ABELL 2063',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129553,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129553,37.41,0.16,304,59756,70,NULL,NULL,'SDSS J152301.90+064723.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.7579583,6.78989,0.053,NULL,56413050170,881453908,13772717,18),(129554,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129554,37.53,0.15,320,59757,70,NULL,NULL,'2MASX J15230197+3049237',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.75825,30.82317,0.017,NULL,59903609414,935993897,14624904,17.8),(129555,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129555,37.37,0.33,297,59758,70,NULL,NULL,'2MASX J15230232+1133410',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.759583,11.56133,0.097,NULL,59342905124,927232892,14488013,17.6),(129556,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129556,38.28,0.33,452,59759,70,NULL,NULL,'2MASX J15230329+2821580',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.91',0.15,NULL,NULL,NULL,NULL,NULL,1,230.763583,28.36617,0.049,NULL,59908064252,936063503,14625992,18.91),(129557,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129557,37.37,0.33,297,59760,70,NULL,NULL,'2MASX J15230328+1133060',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,230.763625,11.55181,0.097,NULL,59342902019,927232844,14488013,16.4),(129558,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129558,36.16,0.09,171,59761,70,NULL,NULL,'SDSS J152304.56+083644.1',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000153,NULL,'15.8g',0.46,'S0','Group member',NULL,NULL,NULL,1,230.769041667,8.61225,0.073,NULL,59351329185,927364518,14490070,15.8),(129559,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129559,37.53,0.15,320,59762,70,NULL,NULL,'2MASX J15230453+3052277',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000097,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.769041667,30.87447,0.025,NULL,59903616172,935994002,14624906,17.9),(129560,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129560,37.33,0.27,292,59763,70,NULL,NULL,'2MASX J15230462+0211469',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.769417,2.19625,0.093,NULL,56432600138,881759377,13777490,17),(129561,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129561,38.01,0.46,400,59764,70,NULL,NULL,'SDSS J152304.98+052734.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.77075,5.45947,0.073,NULL,56429574626,881712103,13776751,18.5),(129562,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129562,37.97,0.33,392,59765,70,NULL,NULL,'2MASX J15230505+0558029',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.7712083,5.96747,0.069,NULL,56429391705,881709245,13776706,17.3),(129563,'BCG','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129563,36.4,0.35,184,59766,60,NULL,'ABELL 2063, BCG','CGCG 077-097',0.0337,'1980ApJ...241..486H',1980,1,0.9,NULL,'G',0.00007,NULL,'13.61',0.9,'cD;S','Group member',NULL,NULL,NULL,1,230.772083,8.60922,0.073,NULL,59351329195,927364518,14490070,13.61),(129564,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129564,35.38,0.23,119,59766,74.4,NULL,NULL,'CGCG 077-097',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129565,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129565,35.68,0.16,137,59766,70,NULL,NULL,'CGCG 077-097',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129566,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129566,36.16,0.09,171,59766,70,NULL,NULL,'CGCG 077-097',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129567,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129567,35.59,0.45,131,59766,NULL,NULL,'K','CGCG 077-097',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129568,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129568,35.85,0.4,148,59766,NULL,NULL,'mean','CGCG 077-097',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129569,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129569,36.01,0.08,159,59766,70,NULL,'ABELL 2063, BGC','CGCG 077-097',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129570,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129570,37.45,0.46,308,59767,70,NULL,NULL,'2MASX J15230581+0225009',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,230.7742917,2.41694,0.097,NULL,56433055319,881766489,13777601,18.2),(129571,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129571,38.8,0.46,575,59768,70,NULL,NULL,'SDSS J152306.09+041321.8',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000112,NULL,'17.6g',0.22,'AGN',NULL,NULL,NULL,NULL,1,230.775375,4.22275,0.069,NULL,56427498857,881679669,13776244,17.6),(129572,'SNIa','2016-12-15 15:15:34','2016-12-16 11:20:48','1','SN 2001cw',NULL,129572,43.56,0.97,2640,59769,74.2,NULL,'SALT 2','SCP J152306.31+293931.9',0.953,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,230.776291667,29.65886,0.025,NULL,59905993088,936031142,14625486,NULL),(129573,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129573,36.69,0.46,218,59770,70,NULL,NULL,'2MASX J15230669+3740108',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000165,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,230.777875,37.66975,0.033,NULL,60112599267,939259363,14675927,16.4),(129574,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129574,37.82,0.19,367,59771,70,NULL,NULL,'SDSS J152306.79+283532.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.778333,28.59242,0.041,NULL,59907683113,936057548,14625899,18.2),(129575,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129575,36,0.25,158,59772,74.4,NULL,NULL,'2MASX J15230698+0840350',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000063,NULL,'16.2g',0.26,'S0','Group member',NULL,NULL,NULL,1,230.7790417,8.67647,0.065,NULL,59351331971,927364562,14490071,16.2),(129576,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129576,36.16,0.09,171,59772,70,NULL,NULL,'2MASX J15230698+0840350',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129577,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129577,36.47,0.1,197,59773,70,NULL,NULL,'SDSS J152307.27+203035.9',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.0g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.780333,20.50997,0.185,NULL,59413896924,928342139,14505345,17),(129578,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129578,35.68,0.16,137,59774,70,NULL,NULL,'CGCG 077-100',NULL,'2001MNRAS.321..277C',2001,1,0.5,NULL,'G',0.00006,NULL,'14.48',0.15,'Sb','Group member',NULL,NULL,NULL,1,230.780875,8.52839,0.073,NULL,59351361679,927365026,14490078,14.48),(129579,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129579,35.86,0.23,149,59774,74.4,NULL,NULL,'CGCG 077-100',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129580,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129580,37.53,0.15,320,59775,70,NULL,NULL,'2MASX J15230748+3051417',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00008,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,230.781125,30.86169,0.017,NULL,59903616907,935994014,14624906,16.9),(129581,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129581,37.04,0.46,255,59776,70,NULL,NULL,'2MASX J15230778+1115090',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.8g',0.2,'AGN',NULL,NULL,NULL,NULL,1,230.7825,11.25258,0.089,NULL,59342437842,927225591,14487899,16.8),(129582,'BCG','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129582,38.3,0.35,426,59777,60,NULL,NULL,'ABELL 2067',0.0726,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',0.000247,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,230.782917,30.845,0.017,NULL,59903620990,935994077,14624907,NULL),(129583,'BCG','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129583,38.3,0.35,426,59778,60,NULL,'ABELL 2067, BCG','2MASX J15230842+3052387',0.0726,'1980ApJ...241..486H',1980,1,0.59,NULL,'G',0.000107,NULL,'16.0g',0.44,'cD;BrClG',NULL,NULL,NULL,NULL,1,230.785,30.8775,0.025,NULL,59903617009,935994015,14624906,16),(129584,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129584,37.53,0.15,320,59779,70,NULL,NULL,'SDSS J152308.68+305158.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.00017,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,230.7862083,30.86619,0.017,NULL,59903616953,935994014,14624906,18.7),(129585,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129585,37.49,0.09,315,59780,70,NULL,NULL,'2MASX J15230962+2723270',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.60',0.18,NULL,NULL,NULL,NULL,NULL,1,230.790041667,27.39075,0.097,NULL,59907816175,936059627,14625931,18.6),(129586,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129586,36.47,0.1,197,59781,70,NULL,NULL,'2MASX J15230968+2114395',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.21',0.18,NULL,NULL,NULL,NULL,NULL,1,230.7905,21.24422,0.157,NULL,59414386895,928349795,14505465,17.21),(129587,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129587,35.32,0.23,116,59782,74.4,NULL,NULL,'CGCG 077-099',NULL,'2013AJ....146...86T',2013,1,0.45,NULL,'G',0.00005,NULL,'15.8g',0.4,'S0','Group member',NULL,NULL,NULL,1,230.79325,8.50533,0.073,NULL,59351356416,927364944,14490077,15.8),(129588,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129588,35.68,0.16,137,59782,70,NULL,NULL,'CGCG 077-099',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129589,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129589,36.16,0.09,171,59782,70,NULL,NULL,'CGCG 077-099',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129590,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129590,35.55,0.23,129,59783,74.4,NULL,NULL,'ARK 475',NULL,'2013AJ....146...86T',2013,1,0.2,NULL,'G',0.000053,NULL,'14.48',0.2,'S0','Group member',NULL,NULL,NULL,1,230.795291667,8.63433,0.073,NULL,59351330815,927364543,14490070,14.48),(129591,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129591,35.68,0.16,137,59783,70,NULL,NULL,'ARK 475',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129592,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129592,36.16,0.09,171,59783,70,NULL,NULL,'ARK 475',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129593,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129593,37.53,0.15,320,59784,70,NULL,NULL,'2MASX J15231261+3055157',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00015,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,230.8027083,30.92117,0.025,NULL,59903615444,935993991,14624906,16.8),(129594,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129594,37.42,0.46,305,59785,70,NULL,NULL,'2MASX J15231331+2601292',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000181,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,230.805583,26.02492,0.109,NULL,59901841188,935966268,14624472,17),(129595,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129595,38.38,0.27,475,59786,70,NULL,NULL,'SDSS J152313.74+221354.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000139,NULL,'18.6g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.8072917,22.23169,0.161,NULL,59421578302,928462160,14507221,18.6),(129596,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129596,38.28,0.33,452,59787,70,NULL,NULL,'SDSS J152313.93+282723.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.8080417,28.45647,0.049,NULL,59908178447,936065288,14626020,18.5),(129597,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129597,35.68,0.16,137,59788,70,NULL,NULL,'ARK 476',NULL,'2001MNRAS.321..277C',2001,1,0.55,NULL,'G',0.000053,NULL,'15.5g',0.5,'E','Group member',NULL,NULL,NULL,1,230.808333,8.64544,0.073,NULL,59351330408,927364537,14490070,15.5),(129598,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129598,35.8,0.23,145,59788,74.4,NULL,NULL,'ARK 476',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129599,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129599,36.16,0.09,171,59788,70,NULL,NULL,'ARK 476',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129600,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129600,37.74,0.46,353,59789,70,NULL,NULL,'2MASX J15231469+5302557',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.811125,53.04878,0.029,NULL,59673926984,932405109,14568829,17.9),(129601,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129601,36.16,0.09,171,59790,70,NULL,NULL,'SDSS J152314.84+084944.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.811875,8.829,0.065,NULL,59350650028,927353906,14489904,17.3),(129602,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129602,35.68,0.16,137,59791,70,NULL,NULL,'CGCG 077-103',NULL,'2001MNRAS.321..277C',2001,1,0.65,NULL,'G',0.000057,NULL,'15.3g',0.45,'S0','Group member',NULL,NULL,NULL,1,230.812625,8.57378,0.073,NULL,59351362895,927365045,14490078,15.3),(129603,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129603,35.7,0.23,138,59791,74.4,NULL,NULL,'CGCG 077-103',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129604,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129604,36.16,0.09,171,59791,70,NULL,NULL,'CGCG 077-103',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129605,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129605,36.81,0.25,230,59792,74.4,NULL,NULL,'2MASX J15231528+0839470',NULL,'2013AJ....146...86T',2013,1,0.37,NULL,'G',0.000077,NULL,'16.4g',0.33,'E','Group member',NULL,NULL,NULL,1,230.813583,8.66317,0.065,NULL,59351328368,927364505,14490070,16.4),(129606,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129606,36.47,0.1,197,59793,70,NULL,NULL,'SDSS J152315.54+202629.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.7g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.81475,20.44153,0.185,NULL,59444045808,928813215,14512706,17.7),(129607,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129607,36.16,0.09,171,59794,70,NULL,NULL,'CGCG 077-106',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00006,NULL,'15.7',0.4,'S0','Group member',NULL,NULL,NULL,1,230.8165,8.74844,0.065,NULL,59350617122,927353392,14489896,15.7),(129608,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129608,36.45,0.25,195,59794,74.4,NULL,NULL,'CGCG 077-106',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129609,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129609,37.81,0.46,365,59795,70,NULL,NULL,'2MASX J15231631+0033179',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000084,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,230.818083,0.55492,0.145,NULL,56430419640,881725306,13776957,17.1),(129610,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129610,36.66,0.7,215,59796,70,NULL,NULL,'2MASX J15231656-0933165',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,230.819125,-9.55458,0.445,NULL,46487766687,726371354,11349552,15.6),(129611,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129611,37.65,0.27,339,59797,70,NULL,NULL,'CGCG 165-046',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000147,NULL,'15.7',0.3,'BrClG',NULL,NULL,NULL,NULL,1,230.821625,32.07389,0.033,NULL,59911525914,936117592,14626837,15.7),(129612,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129612,37.65,0.27,339,59798,70,NULL,NULL,'2MASX J15231736+3203367',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,230.822417,32.06008,0.033,NULL,59911555482,936118054,14626844,17.3),(129613,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129613,32.44,0.2,30.8,59799,74.4,NULL,NULL,'ESO 514- G 013',NULL,'2013AJ....146...86T',2013,1,1.7,'Confused HIPASS source','G',0.000032,NULL,'15.89',1.2,'S...',NULL,NULL,NULL,NULL,1,230.827041667,-25.72061,0.597,NULL,47137682133,736526283,11508223,15.89),(129614,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129614,36.69,0.11,218,59800,70,NULL,NULL,'2MASX J15231981+0742320',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00006,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,230.832416667,7.70883,0.069,NULL,56411786824,881434169,13772408,16.6),(129615,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129615,31.38,0.43,18.9,59801,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-39-005',NULL,'2014MNRAS.444..527S',2014,1,1.6,NULL,'G',0.00002,NULL,'13.49',0.9,'SB(r)ab pec:   HII',NULL,NULL,NULL,NULL,1,230.833875,-4.15161,0.345,NULL,45428984264,709827879,11091060,13.49),(129616,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129616,31.59,0.43,20.8,59801,75,NULL,'3.6 micron, color corrected','MCG -01-39-005',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129617,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129617,31.86,0.2,23.6,59801,74.4,NULL,NULL,'MCG -01-39-005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129618,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129618,32.27,0.47,28.5,59801,NULL,NULL,'H','MCG -01-39-005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129619,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129619,32.29,0.57,28.7,59801,NULL,NULL,NULL,'MCG -01-39-005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129620,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129620,32.33,0.46,29.2,59801,NULL,NULL,'J','MCG -01-39-005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129621,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129621,32.34,NULL,29.4,59801,72,NULL,NULL,'MCG -01-39-005',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129622,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129622,32.35,0.56,29.5,59801,NULL,NULL,'Malmquist cor.','MCG -01-39-005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129623,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129623,32.36,0.45,29.7,59801,NULL,NULL,'K','MCG -01-39-005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129624,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129624,32.43,0.4,30.6,59801,NULL,NULL,'mean','MCG -01-39-005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129625,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129625,36.16,0.09,171,59802,70,NULL,NULL,'CGCG 077-107',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000083,NULL,'15.5g',0.39,'S0/a','Group member',NULL,NULL,NULL,1,230.833833,8.61803,0.073,NULL,59351327684,927364495,14490070,15.5),(129626,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129626,35.21,0.25,110,59803,74.4,NULL,NULL,'2MASX J15232040+0824150',NULL,'2013AJ....146...86T',2013,1,0.56,NULL,'G',0.00004,NULL,'16.2g',0.18,'S0','Group member',NULL,NULL,NULL,1,230.8349583,8.40436,0.073,NULL,59351046268,927360097,14490001,16.2),(129627,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129627,37.49,0.09,315,59804,70,NULL,NULL,'2MASX J15232040+2732233',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.25,NULL,'Group member',NULL,NULL,NULL,1,230.835125,27.53983,0.097,NULL,59907997523,936062461,14625975,17.3),(129628,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129628,38.25,0.46,447,59805,70,NULL,NULL,'SDSS J152320.66-003542.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00008,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.836083,-0.59517,0.181,NULL,45420319493,709692492,11088945,18.3),(129629,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129629,38.38,0.27,475,59806,70,NULL,NULL,'2MASX J15232082+2220365',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000133,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.8367917,22.34344,0.161,NULL,59421697852,928464028,14507250,18.2),(129630,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129630,35.82,0.25,146,59807,74.4,NULL,NULL,'2MASX J15232088+0823390',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000047,NULL,'16.83',0.2,'SB0','Group member',NULL,NULL,NULL,1,230.8370417,8.39422,0.081,NULL,59351046305,927360098,14490001,16.83),(129631,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129631,37.01,0.46,252,59808,70,NULL,NULL,'2MASX J15232193+4430187',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000199,NULL,'15.9g',0.37,'E0',NULL,NULL,NULL,NULL,1,230.841417,44.50519,0.033,NULL,59969294115,937020220,14640940,15.9),(129632,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129632,38.38,0.27,475,59809,70,NULL,NULL,'SDSS J152322.13+222312.7',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.8422083,22.38689,0.173,NULL,59421700573,928464071,14507251,18),(129633,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129633,37.41,0.16,304,59810,70,NULL,NULL,'2MASX J15232312+0652280',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,230.846417,6.87444,0.061,NULL,56413034919,881453670,13772713,16.6),(129634,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129634,37.65,0.27,339,59811,70,NULL,NULL,'SDSS J152325.19+320517.1',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000173,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.855,32.08811,0.033,NULL,59911528261,936117629,14626837,17.6),(129635,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129635,37.53,0.15,320,59812,70,NULL,NULL,'2MASX J15232678+3103582',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000067,NULL,'15.9g',0.43,'BrClG',NULL,NULL,NULL,NULL,1,230.861625,31.06628,0.025,NULL,59903812985,935997077,14624954,15.9),(129636,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129636,37.82,0.19,367,59813,70,NULL,NULL,'4C +28.39',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',NULL,NULL,'15.4',0.47,NULL,NULL,NULL,'radio jet',NULL,1,230.86225,28.62544,0.041,NULL,59907677751,936057464,14625897,15.4),(129637,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129637,34.97,0.5,98.6,59814,70,NULL,NULL,'CGCG 021-088',NULL,'2014MNRAS.445.2677S',2014,1,0.81,NULL,'G',0.000086,NULL,'15.2g',0.4,'S0',NULL,NULL,NULL,NULL,1,230.863583333,-1.16558,0.257,NULL,45420947259,709702300,11089098,15.2),(129638,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129638,37.97,0.33,393,59815,70,NULL,NULL,'2MASX J15232769+2843273',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.97',0.13,NULL,NULL,NULL,NULL,NULL,1,230.8652917,28.72422,0.037,NULL,59907691601,936057681,14625901,18.97),(129639,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129639,37.65,0.33,339,59816,70,NULL,NULL,'2MASX J15232778+2545523',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.865666667,25.76458,0.109,NULL,59902000145,935968752,14624511,17.9),(129640,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129640,36.47,0.46,196,59817,70,NULL,NULL,'2MASX J15232817+0444279',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,230.867333,4.741,0.077,NULL,56429159110,881705611,13776650,16.4),(129641,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129641,37.82,0.19,367,59818,70,NULL,NULL,'2MASX J15232830+2831083',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.867833333,28.519,0.049,NULL,59908187362,936065427,14626022,17.9),(129642,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129642,38.54,0.46,510,59819,70,NULL,NULL,'SDSS J152328.63+403136.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,230.869375,40.52672,0.013,NULL,59975430524,937116101,14642439,18.6),(129643,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129643,36.82,0.46,232,59820,70,NULL,NULL,'2MASXi J1523295+161916',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.872917,16.32131,0.085,NULL,59566350414,930724225,14542566,17.8),(129644,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129644,38.47,0.46,494,59821,70,NULL,NULL,'SDSS J152331.17+600701.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000139,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,230.879917,60.117,0.045,NULL,57772629397,902697334,14104645,18.7),(129645,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129645,38.59,0.46,523,59822,70,NULL,NULL,'2MASX J15233146+1910225',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.881125,19.17294,0.177,NULL,59442677239,928791831,14512372,17.6),(129646,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129646,37.77,0.46,358,59823,70,NULL,NULL,'2MASX J15233273+5130018',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.886291667,51.50042,0.037,NULL,59674834648,932419291,14569051,17.2),(129647,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129647,35.68,0.55,137,59824,70,NULL,NULL,'2MASX J15233396-0023456',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.000075,NULL,'16.1g',0.27,'Sb',NULL,NULL,NULL,NULL,1,230.891583333,-0.39594,0.201,NULL,45420331185,709692674,11088948,16.1),(129648,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129648,37.49,0.09,315,59825,70,NULL,NULL,'2MASX J15233402+2745113',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000113,NULL,'17.86',0.4,NULL,'Group member',NULL,NULL,NULL,1,230.891833333,27.75303,0.081,NULL,59907940615,936061572,14625962,17.86),(129649,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129649,38,0.2,398,59826,74.4,NULL,NULL,'CGCG 165-047',NULL,'2013AJ....146...86T',2013,1,0.58,NULL,'G',0.000203,NULL,'15.8g',0.31,'Sab',NULL,NULL,NULL,NULL,1,230.894583,31.6155,0.029,NULL,59911845557,936122586,14626915,15.8),(129650,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129650,35.48,0.25,125,59827,74.4,NULL,NULL,'CGCG 077-110',NULL,'2013AJ....146...86T',2013,1,0.86,NULL,'G',0.000073,NULL,'14.6g',0.71,'E','Pair member (points to parent)',NULL,NULL,NULL,1,230.896875,9.34614,0.077,NULL,59354866101,927419782,14490934,14.6),(129651,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129651,35.59,0.46,132,59827,70,NULL,NULL,'CGCG 077-110',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129652,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129652,35.68,0.16,137,59827,70,NULL,NULL,'CGCG 077-110',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129653,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129653,36.96,0.46,246,59828,70,NULL,NULL,'2MASX J15233570+3512103',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'17.17',0.27,NULL,NULL,NULL,NULL,NULL,1,230.898625,35.20289,0.033,NULL,60108116883,939189326,14674833,17.17),(129654,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129654,37.04,0.46,256,59829,70,NULL,NULL,'2MASX J15233579+2815543',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.55',0.16,NULL,NULL,NULL,NULL,NULL,1,230.899125,28.265,0.057,NULL,59908250861,936066419,14626037,18.55),(129655,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129655,37.82,0.19,367,59830,70,NULL,NULL,'SDSS J152335.89+283949.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.6g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.899583,28.66372,0.049,NULL,59907690947,936057671,14625901,17.6),(129656,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129656,37.51,0.46,317,59831,70,NULL,NULL,'2MASX J15233596+3110213',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000067,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,230.899625,31.17253,0.025,NULL,59903805193,935996956,14624952,16.7),(129657,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129657,37.97,0.33,393,59832,70,NULL,NULL,'2MASX J15233613+2845183',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.900667,28.75517,0.037,NULL,59907649659,936057025,14625891,17.9),(129658,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129658,37.82,0.19,367,59833,70,NULL,NULL,'2MASX J15233673+2838353',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.06',0.25,NULL,NULL,NULL,NULL,NULL,1,230.90325,28.64283,0.049,NULL,59907691355,936057677,14625901,17.06),(129659,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129659,36.16,0.09,171,59834,70,NULL,NULL,'CGCG 077-113',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000182,NULL,'15.7g',0.41,'SB0/a','Group member',NULL,NULL,NULL,1,230.9037917,8.98703,0.057,NULL,59350684035,927354438,14489913,15.7),(129660,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129660,36.31,0.46,182,59835,70,NULL,NULL,'2MASX J15233693+0008086',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00007,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.903916667,0.13567,0.161,NULL,56396633639,881197400,13768709,17.2),(129661,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129661,36.19,0.33,173,59836,70,NULL,NULL,'2MASX J15233860+0604526',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,230.9109583,6.08133,0.057,NULL,56428339745,881692808,13776450,16.6),(129662,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129662,35.49,0.25,125,59837,74.4,NULL,NULL,'CGCG 077-112',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.00005,NULL,'14.27',0.8,'E/S0','Group member',NULL,NULL,NULL,1,230.913291667,8.75908,0.065,NULL,59350625436,927353522,14489898,14.27),(129663,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129663,35.68,0.16,137,59837,70,NULL,NULL,'CGCG 077-112',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129664,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129664,36.16,0.09,171,59837,70,NULL,NULL,'CGCG 077-112',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129665,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129665,36.47,0.1,197,59838,70,NULL,NULL,'2MASX J15233942+2058487',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.70',0.23,NULL,NULL,NULL,NULL,NULL,1,230.91425,20.98011,0.165,NULL,59414006209,928343847,14505372,16.7),(129666,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129666,37.33,0.46,292,59839,70,NULL,NULL,'2MASX J15234209+2118407',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,230.9252917,21.31133,0.145,NULL,59414266405,928347912,14505436,17.2),(129667,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129667,38.07,0.46,412,59840,70,NULL,NULL,'2MASX J15234272+2833372',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,230.927833,28.56028,0.049,NULL,59908190002,936065468,14626022,18.2),(129668,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129668,33.8,NULL,57.7,59841,NULL,NULL,'Dipole + Quadrupole','ESO 514- G 014',NULL,'2010Ap&SS.325..163P',2010,1,1.74,NULL,'G',NULL,NULL,'16.67',0.13,'Sc',NULL,NULL,NULL,NULL,1,230.929583,-25.465,0.577,NULL,47137527690,736523870,11508185,16.67),(129669,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129669,33.8,NULL,57.7,59841,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 514- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129670,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129670,33.81,NULL,57.8,59841,NULL,NULL,'Dipole','ESO 514- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129671,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129671,34.22,0.43,69.8,59841,75,NULL,'3.6 micron, color + selection bias corrected','ESO 514- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129672,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129672,34.32,0.43,73,59841,75,NULL,'3.6 micron, color corrected','ESO 514- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129673,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129673,34.36,0.2,74.5,59841,74.4,NULL,NULL,'ESO 514- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129674,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129674,34.64,0.41,84.8,59841,NULL,NULL,NULL,'ESO 514- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129675,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129675,34.67,0.4,85.9,59841,NULL,NULL,'Malmquist cor.','ESO 514- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129676,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129676,36.83,0.46,232,59842,70,NULL,NULL,'2MASX J15234372+0826144',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000133,NULL,'16.4g',0.24,'S0/S','Group member',NULL,NULL,NULL,1,230.93225,8.43725,0.073,NULL,59351306224,927364159,14490064,16.4),(129677,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129677,35.27,0.2,113,59843,74.4,NULL,NULL,'CGCG 077-116',NULL,'2013AJ....146...86T',2013,1,0.81,NULL,'G',0.000011,NULL,'15.5g',0.45,'Sc','Pair member (points to parent)',NULL,NULL,NULL,1,230.93275,9.37703,0.077,NULL,59354898751,927420292,14490942,15.5),(129678,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129678,38.04,0.46,406,59844,70,NULL,NULL,'2MASX J15234590+2853542',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'18.40',0.17,'E',NULL,NULL,NULL,NULL,1,230.9414583,28.89836,0.033,NULL,59905750857,936027357,14625427,18.4),(129679,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129679,36.47,0.1,197,59845,70,NULL,NULL,'2MASX J15234609+2045048',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.11',0.17,NULL,NULL,NULL,NULL,NULL,1,230.942083,20.75131,0.173,NULL,59414122169,928345658,14505400,18.11),(129680,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129680,36.16,0.09,171,59846,70,NULL,NULL,'2MASX J15234655+0838534',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000043,NULL,'16.5g',0.35,'S0/S','Group member',NULL,NULL,NULL,1,230.943875,8.64811,0.065,NULL,59350637209,927353706,14489901,16.5),(129681,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129681,37.41,0.16,304,59847,70,NULL,NULL,'2MASX J15234668+0656074',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.944458333,6.93539,0.081,NULL,56413144818,881455387,13772740,17.7),(129682,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129682,36.19,0.33,173,59848,70,NULL,NULL,'CGCG 049-154',NULL,'2015arXiv151105856S',2015,1,2,NULL,'G',0.000127,NULL,'15.3',1.2,NULL,NULL,NULL,NULL,NULL,1,230.9452083,5.77519,0.065,NULL,56428575516,881696492,13776507,15.3),(129683,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129683,38.9,0.46,603,59849,70,NULL,NULL,'2MASX J15234696-0026067',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000085,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.9457917,-0.43531,0.201,NULL,45403440853,709428763,11084824,18),(129684,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129684,34.78,0.46,90.4,59850,70,NULL,NULL,'2MASX J15234709-0038227',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000059,NULL,'16.2g',0.35,'SF',NULL,NULL,NULL,NULL,1,230.9462917,-0.63972,0.181,NULL,45420313256,709692394,11088943,16.2),(129685,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129685,36.87,0.2,237,59851,74.4,NULL,NULL,'UGC 09832',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'15.35',0.6,'S?',NULL,NULL,NULL,NULL,1,230.947208333,13.87625,0.117,NULL,59562301626,930660962,14541577,15.35),(129686,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129686,36.69,0.46,218,59852,70,NULL,NULL,'2MASX J15234741+1712167',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'17.38',0.34,NULL,NULL,NULL,NULL,NULL,1,230.9475,17.20464,0.109,NULL,59437016441,928703381,14510990,17.38),(129687,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129687,37.53,0.15,320,59853,70,NULL,NULL,'2MASX J15234742+3111432',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00011,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,230.9475,31.19528,0.025,NULL,59903803869,935996935,14624952,16.7),(129688,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129688,36.16,0.09,171,59854,70,NULL,NULL,'2MASX J15234769+0859114',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00008,NULL,'15.0',0.4,'E/S0','Group member',NULL,NULL,NULL,1,230.948625,8.98644,0.057,NULL,59350685213,927354456,14489913,15),(129689,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129689,37.47,0.46,311,59855,70,NULL,NULL,'2MASX J15234764+3929424',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000185,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,230.948625,39.49517,0.037,NULL,60110820816,939231575,14675493,16.6),(129690,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129690,37.47,0.46,312,59856,70,NULL,NULL,'2MASX J15234813+0113546',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000073,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.9505417,1.23178,0.097,NULL,56431003127,881734423,13777100,17.4),(129691,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129691,37.68,0.46,343,59857,70,NULL,NULL,'2MASX J15234877+2937303',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00014,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,230.953125,29.62497,0.025,NULL,59905984184,936031002,14625484,18.5),(129692,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129692,38.29,0.46,455,59858,70,NULL,NULL,'SDSS J152349.42+050049.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.955916667,5.01367,0.065,NULL,56429218872,881706544,13776664,18.3),(129693,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129693,37.87,0.46,374,59859,70,NULL,NULL,'SDSS J152349.72-015221.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000133,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,230.957208333,-1.87278,0.305,NULL,45424070124,709751095,11089860,18.6),(129694,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129694,37.35,0.46,295,59860,70,NULL,NULL,'2MASX J15235033+2532503',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.959875,25.54722,0.113,NULL,59901901230,935967206,14624487,17.5),(129695,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129695,38.39,0.46,476,59861,70,NULL,NULL,'2MASX J15235086+0441416',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.961833,4.69494,0.077,NULL,56429179743,881705933,13776655,17.7),(129696,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129696,37.99,0.46,397,59862,70,NULL,NULL,'2MASX J15235090+1927488',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.9620417,19.46356,0.177,NULL,59442520436,928789381,14512334,18),(129697,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129697,37.55,0.46,324,59863,70,NULL,NULL,'SDSS J152351.00+063703.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.5g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.9625,6.61756,0.041,NULL,56413100003,881454687,13772729,18.5),(129698,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129698,33.07,0.4,41.2,59864,75,NULL,'B','UGC 09837',NULL,'1988NBGC.C....0000T',1988,1,1.14,NULL,'G',0.000017,NULL,'14.6g',0.95,'SAB(s)c',NULL,NULL,NULL,NULL,1,230.965291667,58.05294,0.017,NULL,57591473871,899866779,14060418,14.6),(129699,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129699,37.13,0.46,267,59865,70,NULL,NULL,'2MASX J15235307+1432397',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,230.97125,14.54444,0.113,NULL,59574395588,930849931,14544530,17),(129700,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129700,38.59,0.46,524,59866,70,NULL,NULL,'2MASX J15235364+4824116',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000174,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,230.973375,48.40331,0.029,NULL,59664839639,932263119,14566611,17.7),(129701,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129701,38.08,0.46,413,59867,70,NULL,NULL,'SDSS J152354.50+050512.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.977125,5.08686,0.065,NULL,56429222837,881706606,13776665,18),(129702,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129702,37.46,0.46,311,59868,70,NULL,NULL,'2MASX J15235474+2139048',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000171,NULL,'18.43',0.16,NULL,NULL,NULL,NULL,NULL,1,230.978167,21.65144,0.145,NULL,59413460703,928335323,14505239,18.43),(129703,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129703,37.58,0.46,328,59869,70,NULL,NULL,'2MASX J15235500+0103496',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000106,NULL,'17.4g',0.24,'NLAGN',NULL,NULL,NULL,'Sy 2',1,230.979375,1.06367,0.097,NULL,56431181456,881737210,13777143,17.4),(129704,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129704,38.76,0.46,565,59870,70,NULL,NULL,'2MASX J15235646+3823413',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000146,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.985333333,38.39475,0.025,NULL,60111374380,939240224,14675628,17.9),(129705,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129705,37.41,0.16,304,59871,70,NULL,NULL,'SDSS J152357.23+065659.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.9885,6.94983,0.081,NULL,56413359948,881458749,13772792,17.8),(129706,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129706,35.75,0.46,141,59872,70,NULL,NULL,'2MASX J15235753+1701337',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.56',0.33,NULL,NULL,NULL,NULL,NULL,1,230.989666667,17.02617,0.109,NULL,59434898440,928670288,14510473,16.56),(129707,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129707,37.53,0.15,320,59873,70,NULL,NULL,'CGCG 165-049',NULL,'2015arXiv151105856S',2015,1,0.97,NULL,'G',0.000077,NULL,'15.1g',0.53,'BrClG',NULL,NULL,NULL,NULL,1,230.9995417,31.21114,0.025,NULL,59911847970,936122624,14626916,15.1),(129708,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129708,36.47,0.1,197,59874,70,NULL,NULL,'2MASX J15240113+2044058',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.80',0.16,NULL,NULL,NULL,NULL,NULL,1,231.0047083,20.73489,0.185,NULL,59413987400,928343553,14505368,17.8),(129709,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129709,37.48,0.46,313,59875,70,NULL,NULL,'2MASX J15240155+0158512',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.006417,1.98081,0.121,NULL,56434314063,881786157,13777908,17.1),(129710,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129710,36.92,0.53,242,59876,NULL,NULL,'Malmquist cor.','2MASX J15240202+0818551',NULL,'2009ApJS..182..474S',2009,1,0.63,'1991A&AS...90..355C has V = 10945 +- 108 km/s.','G',0.00003,NULL,'17.0g',0.15,'Sc','Group member',NULL,NULL,NULL,1,231.008333,8.31531,0.073,NULL,56411687125,881432611,13772384,17),(129711,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129711,37.29,0.45,288,59876,NULL,NULL,NULL,'2MASX J15240202+0818551',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129712,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129712,37.33,0.2,292,59876,74.4,NULL,NULL,'2MASX J15240202+0818551',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129713,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129713,37.08,0.46,261,59877,70,NULL,NULL,'2MASX J15240206+3927353',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.008458333,39.45975,0.045,NULL,60110825673,939231651,14675494,17),(129714,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129714,37.91,0.46,381,59878,70,NULL,NULL,'2MASX J15240349+2950163',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000137,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,231.014417,29.83786,0.025,NULL,59905504879,936023513,14625367,18.3),(129715,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129715,36.99,0.46,250,59879,70,NULL,NULL,'2MASX J15240433+1927468',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,231.017917,19.46314,0.177,NULL,59442470428,928788600,14512321,17.1),(129716,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129716,35.55,0.46,129,59880,70,NULL,NULL,'2MASX J15240552+4045483',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00016,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,231.023125,40.76353,0.037,NULL,59975509413,937117334,14642458,16.3),(129717,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129717,38.03,0.27,404,59881,70,NULL,NULL,'2MASX J15240592+0545502',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.024625,5.76389,0.065,NULL,56428581705,881696589,13776509,17.8),(129718,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129718,37.9,0.46,379,59882,70,NULL,NULL,'2MASX J15240625+4528099',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000187,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,231.025833,45.46942,0.025,NULL,59969776272,937027754,14641058,17.2),(129719,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129719,37.53,0.15,320,59883,70,NULL,NULL,'2MASX J15240635+3105492',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000113,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,231.026333333,31.09689,0.025,NULL,59903593233,935993644,14624900,16.4),(129720,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129720,34.57,0.2,82,59884,74.4,NULL,NULL,'CGCG 077-118',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000123,NULL,'15.4',0.2,NULL,NULL,NULL,NULL,NULL,1,231.033916667,13.59364,0.113,NULL,59562522645,930664416,14541631,15.4),(129721,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129721,36.47,0.1,197,59885,70,NULL,NULL,'2MASX J15240823+2042488',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,231.034416667,20.71344,0.185,NULL,59444249160,928816393,14512756,17.5),(129722,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129722,38.46,0.46,493,59886,70,NULL,NULL,'2MASX J15240865+2239448',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000176,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.035916667,22.66261,0.177,NULL,59421683023,928463797,14507246,18.1),(129723,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129723,37.73,0.33,352,59887,70,NULL,NULL,'SDSS J152408.93+112056.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,231.0372083,11.34911,0.089,NULL,59344302859,927254732,14488355,18.1),(129724,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129724,37.15,0.46,270,59888,70,NULL,NULL,'2MASX J15240938+3251212',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000151,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,231.039,32.85603,0.033,NULL,59882165238,935658831,14619669,17.2),(129725,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129725,38.12,0.46,420,59889,70,NULL,NULL,'2MASX J15241048+5728223',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000139,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.043417,57.47278,0.029,NULL,57589633778,899838027,14059969,17.9),(129726,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129726,34.43,0.55,77.1,59890,NULL,NULL,NULL,'ESO 328- G 048',NULL,'2009ApJS..182..474S',2009,1,1.2,'Confused HIPASS source','G',0.000033,NULL,'16.0b',0.3,'S...',NULL,NULL,NULL,NULL,1,231.0445,-38.46278,0.541,NULL,47191540144,737367814,11521372,16),(129727,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129727,34.45,0.49,77.8,59890,75,NULL,'IR','ESO 328- G 048',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129728,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129728,34.48,0.2,78.7,59890,74.4,NULL,NULL,'ESO 328- G 048',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129729,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129729,34.61,0.51,83.5,59890,NULL,NULL,'Malmquist cor.','ESO 328- G 048',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129730,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129730,37.11,0.46,264,59891,70,NULL,NULL,'2MASX J15241084+5642413',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000167,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,231.045083,56.71147,0.025,NULL,57593768224,899902628,14060978,16.4),(129731,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129731,32.89,NULL,37.8,59892,72,NULL,NULL,'AGC 258405',NULL,'2014Ap.....57..457K',2014,1,NULL,NULL,'RadioS',0.000215,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,231.050833,7.4925,0.065,NULL,56413262363,881457224,13772769,NULL),(129732,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129732,33.29,0.76,45.4,59893,NULL,NULL,'Malmquist cor.','CGCG 077-117',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000041,NULL,'15.6',0.4,'Sab;HII        Sy2','Group member',NULL,NULL,'Sy 2',1,231.052417,8.54481,0.065,NULL,59350588121,927352939,14489889,15.6),(129733,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129733,33.33,0.74,46.4,59893,NULL,NULL,NULL,'CGCG 077-117',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129734,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129734,38.03,0.27,404,59894,70,NULL,NULL,'2MASX J15241289+0544012',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.0537917,5.73378,0.065,NULL,56428417654,881694025,13776469,17.7),(129735,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129735,38.67,0.46,543,59895,70,NULL,NULL,'2MASX J15241332+2323529',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.055417,23.39808,0.185,NULL,59419196831,928424950,14506639,17.9),(129736,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129736,37.13,0.46,267,59896,70,NULL,NULL,'2MASX J15241346+1101142',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000187,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,231.0560417,11.02075,0.089,NULL,59344415357,927256489,14488382,16.5),(129737,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129737,37.7,0.46,347,59897,70,NULL,NULL,'2MASX J15241348+3324013',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000224,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,231.0560417,33.40017,0.037,NULL,59882937376,935670896,14619857,16.2),(129738,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129738,37.49,0.09,315,59898,70,NULL,NULL,'2MASX J15241366+2748363',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.73',0.16,NULL,NULL,NULL,NULL,NULL,1,231.056791667,27.81,0.081,NULL,59907967117,936061986,14625968,18.73),(129739,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129739,39.11,0.46,664,59899,70,NULL,NULL,'SDSS J152414.13+544806.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.058916667,54.80186,0.025,NULL,57580471398,899694865,14057732,18.4),(129740,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129740,36.47,0.1,197,59900,70,NULL,NULL,'2MASX J15241428+2046439',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.24',0.16,NULL,NULL,NULL,NULL,NULL,1,231.059375,20.77886,0.185,NULL,59444186074,928815407,14512740,18.24),(129741,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129741,37.11,0.46,264,59901,70,NULL,NULL,'2MASX J15241490+0742532',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.0g',0.33,NULL,NULL,NULL,NULL,NULL,1,231.0622917,7.71478,0.069,NULL,56411632537,881431758,13772371,16),(129742,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129742,36.32,0.46,184,59902,70,NULL,NULL,'CGCG 049-156',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000089,NULL,'16.1g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,231.069208333,3.64489,0.097,NULL,56435203563,881800055,13778125,16.1),(129743,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129743,38.53,0.46,509,59903,70,NULL,NULL,'2MASX J15241673+4414550',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,231.0699583,44.24864,0.033,NULL,59969327301,937020739,14640949,17.9),(129744,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129744,37.81,0.46,365,59904,70,NULL,NULL,'2MASX J15241699+3359043',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000149,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.070708333,33.98439,0.045,NULL,60104792262,939137379,14674021,17.4),(129745,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129745,34.83,0.47,92.3,59905,NULL,NULL,'H','ESO 328- G 050',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000033,NULL,'12.20',0.6,'Sb             HII',NULL,NULL,NULL,NULL,1,231.077208333,-39.08686,0.413,NULL,47192085580,737376337,11521505,12.2),(129746,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129746,34.86,0.45,93.9,59905,NULL,NULL,'K','ESO 328- G 050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129747,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129747,34.92,0.46,96.3,59905,NULL,NULL,'J','ESO 328- G 050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129748,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129748,35.06,0.4,103,59905,NULL,NULL,'mean','ESO 328- G 050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129749,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129749,36.59,0.46,208,59906,70,NULL,NULL,'2MASX J15242095+3430173',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.087333333,34.50489,0.037,NULL,60108080585,939188759,14674824,17.3),(129750,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129750,37.49,0.09,315,59907,70,NULL,NULL,'2MASX J15242306+2741466',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.63',0.24,NULL,NULL,NULL,NULL,NULL,1,231.09625,27.69617,0.081,NULL,59907973875,936062091,14625970,17.63),(129751,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129751,37.64,0.27,338,59908,70,NULL,NULL,'2MASX J15242332+2909586',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000141,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.0972083,29.16639,0.033,NULL,59906062825,936032231,14625503,17.7),(129752,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129752,37.7,0.33,347,59909,70,NULL,NULL,'SDSS J152423.36+294304.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000115,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.097333,29.71783,0.013,NULL,59905969121,936030767,14625480,17.9),(129753,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129753,38.16,0.46,429,59910,70,NULL,NULL,'2MASX J15242458+4304241',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00018,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,231.10225,43.07344,0.097,NULL,59977962151,937155658,14643057,18),(129754,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129754,36.47,0.1,197,59911,70,NULL,NULL,'CGCG 135-055 NED01',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000153,NULL,'15.90',0.36,NULL,NULL,NULL,NULL,NULL,1,231.10325,20.76169,0.185,NULL,59444198406,928815600,14512743,15.9),(129755,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129755,37.13,0.46,267,59912,70,NULL,NULL,'2MASX J15242576+2912056',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000107,NULL,'16.7g',0.28,'E',NULL,NULL,NULL,NULL,1,231.107125,29.20175,0.045,NULL,59906062962,936032233,14625503,16.7),(129756,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129756,38.05,0.46,408,59913,70,NULL,NULL,'2MASX J15242592+2223459',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.108125,22.39625,0.181,NULL,59420800110,928450001,14507031,17.7),(129757,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129757,37.36,0.46,296,59914,70,NULL,NULL,'SDSS J152426.18+063902.5',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.6g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.109083,6.65069,0.061,NULL,56412970022,881452656,13772697,17.6),(129758,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129758,35.42,0.46,121,59915,70,NULL,NULL,'2MASX J15242716+2855297',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'16.54',0.31,'Sc',NULL,NULL,NULL,NULL,1,231.113083,28.92486,0.033,NULL,59906002747,936031292,14625488,16.54),(129759,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129759,36.48,0.46,198,59916,70,NULL,NULL,'2MASX J15242780+4558361',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000168,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,231.115791667,45.97672,0.045,NULL,59966799567,936981243,14640331,16.4),(129760,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129760,37.63,0.46,335,59917,70,NULL,NULL,'2MASX J15242831+5724123',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000135,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,231.117917,57.40347,0.025,NULL,57589641604,899838150,14059971,17.8),(129761,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129761,37.4,0.46,303,59918,70,NULL,NULL,'2MASX J15242898+2613587',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,231.120958333,26.23292,0.105,NULL,59901660409,935963443,14624428,17.9),(129762,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129762,37.8,0.46,363,59919,70,NULL,NULL,'2MASX J15242925+2130549',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000191,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.121916667,21.51522,0.145,NULL,59413562558,928336914,14505264,17.6),(129763,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129763,35.1,0.69,105,59920,100,NULL,'mid-IR','CGCG 077-119',NULL,'2013ApJ...771...88L',2013,1,0.8,NULL,'G',0.000027,NULL,'15.1g',0.4,'SBb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,231.123083333,8.37322,0.097,NULL,56412221439,881440959,13772514,15.1),(129764,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129764,35.52,0.38,127,59920,NULL,NULL,NULL,'CGCG 077-119',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129765,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129765,35.67,0.35,136,59920,NULL,NULL,'Malmquist cor.','CGCG 077-119',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129766,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129766,35.86,0.2,149,59920,74.4,NULL,NULL,'CGCG 077-119',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129767,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129767,38.02,0.46,402,59921,70,NULL,NULL,'2MASX J15242960+2217359',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000191,NULL,'17.97',0.24,NULL,NULL,NULL,NULL,NULL,1,231.123333,22.29333,0.181,NULL,59420904233,928451628,14507056,17.97),(129768,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129768,37.49,0.09,315,59922,70,NULL,NULL,'2MASX J15243006+2750127',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,231.125083,27.837,0.081,NULL,59907865174,936060393,14625943,17.6),(129769,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129769,37.85,0.46,371,59923,70,NULL,NULL,'2MASX J15243033+2601227',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,231.126333,26.02308,0.145,NULL,59901764461,935965069,14624454,17.1),(129770,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129770,36.47,0.1,197,59924,70,NULL,NULL,'2MASX J15243068+2045279',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.57',0.18,NULL,NULL,NULL,NULL,NULL,1,231.1277917,20.75783,0.185,NULL,59444198028,928815594,14512743,17.57),(129771,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129771,37.54,0.46,322,59925,70,NULL,NULL,'2MASX J15243113+0355291',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000071,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,231.129667,3.92492,0.097,NULL,56435077362,881798083,13778095,17.8),(129772,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129772,36.49,0.46,198,59926,70,NULL,NULL,'2MASX J15243149+0147411',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.26',0.25,NULL,NULL,NULL,NULL,NULL,1,231.131333,1.79472,0.121,NULL,56434156714,881783698,13777870,17.26),(129773,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129773,36.58,0.46,207,59927,70,NULL,NULL,'2MASX J15243192+0410171',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000078,NULL,'16.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,231.1329583,4.17133,0.093,NULL,56435098334,881798411,13778100,16.9),(129774,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129774,37.25,0.33,282,59928,70,NULL,NULL,'2MASX J15243303+0059001',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000085,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,231.137625,0.98342,0.125,NULL,56430596979,881728077,13777001,16.4),(129775,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129775,36.34,0.46,185,59929,70,NULL,NULL,'2MASX J15243339+2540497',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000182,NULL,'15.6g',0.47,NULL,NULL,NULL,NULL,NULL,1,231.139041667,25.68064,0.165,NULL,59901774995,935965234,14624456,15.6),(129776,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129776,36.32,0.46,183,59930,70,NULL,NULL,'2MASX J15243349+0201521',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.139583,2.03106,0.145,NULL,56434360155,881786877,13777919,16.9),(129777,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129777,37.52,0.46,320,59931,70,NULL,NULL,'2MASX J15243409+2004509',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,231.142166667,20.08078,0.193,NULL,59445330306,928833286,14513020,16.7),(129778,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129778,36.87,0.46,237,59932,70,NULL,NULL,'2MASX J15243481+0931488',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,231.145083,9.53022,0.073,NULL,59354889211,927420143,14490939,17.3),(129779,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129779,38.54,0.46,512,59933,70,NULL,NULL,'SDSS J152435.69+054457.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.14875,5.74936,0.065,NULL,56428530014,881695781,13776496,18.6),(129780,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129780,37.61,0.46,332,59934,70,NULL,NULL,'2MASX J15243638+2846297',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.24',0.2,NULL,NULL,NULL,NULL,NULL,1,231.151625,28.77503,0.041,NULL,59907311179,936051737,14625808,18.24),(129781,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129781,37.06,0.46,258,59935,70,NULL,NULL,'2MASX J15243660+3209192',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000202,NULL,'16.0g',0.34,'E0',NULL,NULL,NULL,NULL,1,231.1525417,32.15536,0.033,NULL,59912307023,936129797,14627028,16),(129782,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129782,35.68,0.16,137,59936,70,NULL,NULL,'GIN 434',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'*',NULL,NULL,'12.1g',NULL,NULL,NULL,NULL,NULL,NULL,1,231.155083,8.99017,0.077,NULL,59350499548,927351555,14489868,12.1),(129783,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129783,37.73,0.33,352,59937,70,NULL,NULL,'2MASX J15243800+1117218',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000195,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,231.15825,11.28942,0.089,NULL,59344343199,927255362,14488365,16.7),(129784,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129784,37.43,0.27,306,59938,70,NULL,NULL,'2MASX J15243812+2514007',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.1587083,25.23358,0.133,NULL,59901408314,935959504,14624367,17.7),(129785,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129785,38.27,0.46,452,59939,70,NULL,NULL,'2MASX J15243887+0439161',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,231.1619583,4.65456,0.077,NULL,56436722292,881823785,13778496,18),(129786,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129786,36.83,0.46,232,59940,70,NULL,NULL,'2MASX J15243889+2838237',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.67',0.16,NULL,NULL,NULL,NULL,NULL,1,231.1620417,28.63997,0.049,NULL,59908173297,936065207,14626018,18.67),(129787,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129787,37.27,0.46,285,59941,70,NULL,NULL,'2MASX J15244013+0956429',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000196,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,231.1670417,9.94522,0.085,NULL,59343250473,927238288,14488098,16.6),(129788,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129788,37.25,0.33,282,59942,70,NULL,NULL,'2MASX J15244044+0100051',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000076,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,231.168375,1.00153,0.125,NULL,56430612992,881728328,13777005,17.3),(129789,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129789,36.71,0.46,220,59943,70,NULL,NULL,'SDSS J152442.21+183609.7',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.175917,18.60272,0.153,NULL,59434042394,928656912,14510264,17.5),(129790,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129790,37.44,0.27,307,59944,70,NULL,NULL,'SDSS J152442.58+323617.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000177,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,231.1774583,32.60475,0.033,NULL,59882152839,935658638,14619666,18),(129791,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129791,38.84,0.46,586,59945,70,NULL,NULL,'2MASX J15244278+1910589',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,231.178375,19.18294,0.165,NULL,59442025668,928781651,14512213,18.1),(129792,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129792,38.03,0.27,404,59946,70,NULL,NULL,'SDSS J152442.96+054908.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.1790417,5.819,0.061,NULL,56428528875,881695763,13776496,18),(129793,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129793,37.7,0.33,347,59947,70,NULL,NULL,'SDSS J152443.16+294617.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000135,NULL,'18.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.179875,29.77161,0.013,NULL,59906146543,936033539,14625524,18.5),(129794,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129794,38.86,0.46,592,59948,70,NULL,NULL,'SDSS J152443.61+192849.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.1817917,19.48028,0.177,NULL,59442466497,928788539,14512320,18.6),(129795,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129795,36.6,0.46,209,59949,70,NULL,NULL,'2MASX J15244431-0026293',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000073,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,231.184667,-0.44144,0.201,NULL,45403438240,709428722,11084823,17.4),(129796,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129796,37.5,0.46,317,59950,70,NULL,NULL,'SDSS J152444.53+252829.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000158,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.185583,25.47481,0.145,NULL,59901412400,935959568,14624368,18.6),(129797,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129797,37.41,0.16,304,59951,70,NULL,NULL,'2MASX J15244467+0653589',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',NULL,NULL,'15.5g',0.41,NULL,NULL,NULL,NULL,NULL,1,231.186125,6.89964,0.081,NULL,56413204146,881456314,13772754,15.5),(129798,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129798,34.6,0.47,83,59952,NULL,NULL,'H','NGC 5939',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.00008,NULL,'14.0',0.5,'S?','in a radial-velocity based grouping',NULL,NULL,NULL,1,231.1917917,68.73064,0.033,NULL,57969791789,905777996,14152781,14),(129799,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129799,34.6,0.45,83.2,59952,NULL,NULL,'K','NGC 5939',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129800,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129800,34.64,0.46,84.8,59952,NULL,NULL,'J','NGC 5939',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129801,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129801,34.84,0.4,92.9,59952,NULL,NULL,'mean','NGC 5939',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129802,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129802,36.42,0.46,192,59953,70,NULL,NULL,'2MASX J15244708+0710429',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,231.196166667,7.17858,0.065,NULL,56413210584,881456415,13772756,16.7),(129803,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129803,37.54,0.46,323,59954,70,NULL,NULL,'2MASX J15244727+3028292',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,231.196875,30.47486,0.017,NULL,59905468867,936022951,14625358,17.6),(129804,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129804,37.65,0.33,339,59955,70,NULL,NULL,'2MASX J15244856+2536203',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,231.202333333,25.60564,0.145,NULL,59901300313,935957817,14624340,17.6),(129805,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129805,36.19,0.46,173,59956,70,NULL,NULL,'2MASX J15244937+0306301',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000102,NULL,'15.6g',0.44,'S0^-',NULL,NULL,NULL,NULL,1,231.2057083,3.10839,0.085,NULL,56434661015,881791578,13777993,15.6),(129806,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129806,37.44,0.27,307,59957,70,NULL,NULL,'2MASX J15244933+3236162',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000186,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,231.205833,32.60444,0.033,NULL,59882152249,935658628,14619666,16.2),(129807,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129807,37.44,0.27,307,59958,70,NULL,NULL,'2MASX J15245021+3228472',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000161,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.209167,32.47992,0.029,NULL,59911581702,936118464,14626851,17.6),(129808,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129808,37.92,0.46,384,59959,70,NULL,NULL,'2MASX J15245048+1536591',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.2104583,15.6165,0.109,NULL,59565635835,930713059,14542391,17.6),(129809,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129809,35.46,0.46,123,59960,70,NULL,NULL,'CGCG 077-120',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000143,NULL,'15.2g',0.5,'S0p','Group member',NULL,NULL,NULL,1,231.2130417,8.42514,0.093,NULL,56411382537,881427852,13772310,15.2),(129810,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129810,37.39,0.46,301,59961,70,NULL,NULL,'2MASX J15245129+3034243',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000179,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,231.213625,30.57358,0.021,NULL,59905423791,936022246,14625347,16.8),(129811,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129811,37.43,0.27,306,59962,70,NULL,NULL,'2MASX J15245206+2515053',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.216916667,25.25161,0.133,NULL,59901368073,935958876,14624357,16.7),(129812,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129812,36.04,0.63,161,59963,70,NULL,NULL,'2MASX J15245396-1119071',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.25',NULL,NULL,NULL,NULL,NULL,NULL,1,231.224875,-11.31875,0.585,NULL,46477005497,726203210,11346925,16.25),(129813,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129813,37.41,0.16,304,59964,70,NULL,NULL,'2MASX J15245609+0658199',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.2337083,6.97228,0.065,NULL,56413205321,881456333,13772755,17.6),(129814,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129814,37.43,0.27,306,59965,70,NULL,NULL,'2MASX J15245634+2508453',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000185,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,231.23475,25.14606,0.133,NULL,59901376472,935959007,14624359,17.4),(129815,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129815,37.34,0.33,294,59966,70,NULL,NULL,'2MASX J15245657+5422598',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000185,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,231.235666667,54.38317,0.021,NULL,59661930942,932217670,14565901,16.6),(129816,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129816,37.46,0.46,311,59967,70,NULL,NULL,'2MASX J15245696+3518542',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.2372917,35.315,0.021,NULL,60106093461,939157710,14674339,17.2),(129817,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129817,36.79,0.46,228,59968,70,NULL,NULL,'2MASX J15245755+2831593',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00005,NULL,'16.86',0.32,NULL,NULL,NULL,NULL,NULL,1,231.24,28.53314,0.049,NULL,59908202383,936065662,14626025,16.86),(129818,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129818,37.32,0.46,292,59969,70,NULL,NULL,'2MASX J15245774+2921313',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000097,NULL,'17.0g',0.27,'E',NULL,NULL,NULL,NULL,1,231.240708333,29.35864,0.029,NULL,59906141366,936033458,14625522,17),(129819,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129819,37.86,0.46,372,59970,70,NULL,NULL,'2MASX J15245820+3407402',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000164,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,231.242417,34.12772,0.057,NULL,60104685348,939135708,14673995,18.4),(129820,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129820,36.11,0.46,167,59971,70,NULL,NULL,'2MASX J15245831+3944164',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000166,NULL,'16.0g',0.43,NULL,NULL,NULL,NULL,NULL,1,231.243167,39.73797,0.045,NULL,60097271279,939019863,14672185,16),(129821,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129821,37.52,0.46,320,59972,70,NULL,NULL,'2MASX J15245849+0822289',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000171,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.243625,8.37464,0.093,NULL,56412256664,881441510,13772523,17.3),(129822,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129822,35.08,0.46,104,59973,70,NULL,NULL,'IC 1118',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000167,NULL,'15.2',0.8,NULL,NULL,NULL,NULL,NULL,1,231.2480417,13.44508,0.113,NULL,59562359523,930661867,14541591,15.2),(129823,'GRB','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129823,42.23,0.05,2790,59974,NULL,NULL,'z = 1.18 +/- 0.06','5B 970111',NULL,'2016ApJ...819...79G',2016,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'SAX/WFC',NULL,NULL,NULL,NULL,1,231.25,18.73,0.157,NULL,59442151846,928783622,14512244,NULL),(129824,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129824,37.35,0.46,295,59975,70,NULL,NULL,'2MASX J15250244+0338009',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000089,NULL,'18.1g',0.15,'BLAGN',NULL,NULL,NULL,'Sy 1',1,231.26025,3.6335,0.097,NULL,56434696778,881792137,13778002,18.1),(129825,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129825,36.16,0.09,171,59976,70,NULL,NULL,'CGCG 077-121',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000143,NULL,'15.6g',0.31,'S0','Group member',NULL,NULL,NULL,1,231.2650417,8.71853,0.057,NULL,56411393924,881428030,13772312,15.6),(129826,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129826,37.16,0.46,270,59977,70,NULL,NULL,'2MASX J15250417+3348068',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.2675,33.80197,0.025,NULL,59882713567,935667399,14619803,17.6),(129827,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129827,35,0.46,100,59978,70,NULL,NULL,'CGCG 049-157',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000107,NULL,'15.6',0.6,NULL,'Group member',NULL,NULL,NULL,1,231.268333,4.82983,0.077,NULL,56436758815,881824356,13778505,15.6),(129828,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129828,32.45,0.2,30.9,59979,74.4,NULL,NULL,'UGC 09855',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000017,NULL,'14.84',0.5,'Im:',NULL,NULL,NULL,NULL,1,231.2702083,66.25536,0.073,NULL,57961303010,905645359,14150708,14.84),(129829,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129829,37.54,0.46,322,59980,70,NULL,NULL,'2MASX J15250725-0157516',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.2802083,-1.96444,0.305,NULL,45424199227,709753112,11089892,18.2),(129830,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129830,37.88,0.23,377,59981,70,NULL,NULL,'SDSS J152507.76+213749.9',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000196,NULL,'16.5g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,231.282333333,21.63056,0.145,NULL,59413626682,928337916,14505279,16.5),(129831,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129831,38.65,0.46,536,59982,70,NULL,NULL,'SDSS J152508.45+025553.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000088,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,231.285208333,2.93156,0.085,NULL,56432799740,881762495,13777538,18.5),(129832,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129832,38.1,0.46,417,59983,70,NULL,NULL,'2MASX J15250867+0102379',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000083,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.286083,1.04386,0.125,NULL,56430621735,881728464,13777007,17.6),(129833,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129833,38.63,0.46,531,59984,70,NULL,NULL,'2MASX J15250948+1951259',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.289625,19.85733,0.185,NULL,59445170469,928830788,14512981,18),(129834,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129834,37.94,0.46,387,59985,70,NULL,NULL,'SDSS J152510.59+034230.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000087,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,231.294125,3.70858,0.097,NULL,56438168202,881846378,13778849,18.1),(129835,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129835,37.22,0.23,278,59986,70,NULL,NULL,'2MASX J15251068+3258438',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000158,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,231.294625,32.97886,0.033,NULL,59883043479,935672554,14619883,17.9),(129836,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129836,37.72,0.46,350,59987,70,NULL,NULL,'SDSS J152511.19+064831.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.296667,6.80867,0.081,NULL,56410901668,881420338,13772192,18.4),(129837,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129837,35.44,0.33,122,59988,NULL,NULL,NULL,'UGC 09838',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.00003,NULL,'14.96',0.4,'Sab','Group member, peripheral',NULL,NULL,NULL,1,231.300833,7.15481,0.065,NULL,56412511252,881445488,13772585,14.96),(129838,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129838,35.48,0.2,125,59988,74.4,NULL,NULL,'UGC 09838',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129839,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129839,35.58,0.31,131,59988,NULL,NULL,'Malmquist cor.','UGC 09838',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129840,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129840,35.67,0.49,136,59988,75,NULL,'IR','UGC 09838',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129841,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129841,35.85,0.4,148,59988,NULL,NULL,'mean','UGC 09838',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129842,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129842,35.98,0.47,157,59988,NULL,NULL,'H','UGC 09838',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129843,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129843,35.44,0.6,122,59989,70,NULL,NULL,'UGC 09839',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000115,NULL,'16.1g',0.23,'S',NULL,NULL,NULL,NULL,1,231.3017917,-1.81117,0.305,NULL,45423622186,709744096,11089751,16.1),(129844,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129844,38.36,0.46,471,59990,70,NULL,NULL,'SDSS J152512.55+222400.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000135,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.3022917,22.40019,0.181,NULL,59420822074,928450344,14507036,18.2),(129845,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129845,36.9,0.46,239,59991,70,NULL,NULL,'2MASX J15251278+3033208',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000168,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,231.303333,30.55592,0.021,NULL,59905418528,936022164,14625346,16.2),(129846,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129846,37.64,0.27,338,59992,70,NULL,NULL,'SDSS J152512.82+285828.2',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,231.303417,28.97453,0.033,NULL,59905289082,936020141,14625314,NULL),(129847,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129847,38.13,0.27,422,59993,70,NULL,NULL,'2MASX J15251336+1305139',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,231.305708333,13.08714,0.085,NULL,59563184734,930674761,14541793,18.4),(129848,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129848,37.48,0.46,314,59994,70,NULL,NULL,'SBS 1523+511',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000163,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,231.30725,50.96231,0.045,NULL,59666596978,932290577,14567040,16.9),(129849,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129849,38.05,0.46,408,59995,70,NULL,NULL,'2MASX J15251472+1107104',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,231.3112917,11.11958,0.089,NULL,59345027298,927266051,14488532,17),(129850,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129850,37.04,0.46,256,59996,70,NULL,NULL,'2MASX J15251530+3823294',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000144,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.313625,38.39167,0.025,NULL,60111419457,939240929,14675639,17.3),(129851,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129851,37.88,0.23,377,59997,70,NULL,NULL,'2MASX J15251587+2136118',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,231.316083333,21.60314,0.165,NULL,59413624423,928337881,14505279,16.6),(129852,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129852,33.52,0.2,50.6,59998,74.4,NULL,NULL,'UGC 09849',NULL,'2013AJ....146...86T',2013,1,1.82,NULL,'G',0.000027,NULL,'15.1g',0.39,'Scd(f)',NULL,NULL,NULL,NULL,1,231.3185417,53.407,0.017,NULL,59674452433,932413319,14568958,15.1),(129853,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129853,33.57,0.47,51.9,59998,NULL,NULL,NULL,'UGC 09849',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129854,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129854,33.61,0.46,52.8,59998,NULL,NULL,'Malmquist cor.','UGC 09849',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129855,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129855,37.49,0.33,315,59999,70,NULL,NULL,'2MASX J15251646+4719487',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000175,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,231.318791667,47.33008,0.041,NULL,59982744115,937230376,14644224,16.7),(129856,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129856,38.13,0.27,422,60000,70,NULL,NULL,'SDSS J152516.76+125850.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.319916667,12.98072,0.085,NULL,59562710463,930667350,14541677,18.3),(129857,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129857,37.22,0.23,278,60001,70,NULL,NULL,'2MASX J15251751+3258088',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'16.9g',0.33,NULL,NULL,NULL,NULL,NULL,1,231.323125,32.96911,0.033,NULL,59883044259,935672566,14619883,16.9),(129858,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129858,37.41,0.46,303,60002,70,NULL,NULL,'2MASX J15251757+3045478',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.32325,30.76322,0.005,NULL,59915111907,936173623,14627712,17),(129859,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129859,38.22,0.46,441,60003,70,NULL,NULL,'SDSS J152518.43+102433.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000165,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.3267917,10.40936,0.073,NULL,59343800084,927246876,14488232,18.5),(129860,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129860,38.12,0.46,421,60004,70,NULL,NULL,'2MASX J15251844+0454449',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,231.326916667,4.9125,0.077,NULL,56436753963,881824280,13778504,17.8),(129861,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129861,37.06,0.46,259,60005,70,NULL,NULL,'2MASX J15251854+0339359',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000087,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,231.327333,3.65986,0.097,NULL,56438222156,881847221,13778862,16.8),(129862,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129862,37.4,0.46,302,60006,70,NULL,NULL,'2MASX J15251879+5139432',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.328375,51.66186,0.033,NULL,59675972543,932437070,14569329,17.4),(129863,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129863,38.1,0.46,417,60007,70,NULL,NULL,'SDSS J152518.95+191330.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.329,19.22514,0.161,NULL,59442060164,928782190,14512221,18.4),(129864,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129864,37.94,0.46,387,60008,70,NULL,NULL,'2MASX J15251911+4542407',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,'FoF','17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.3297917,45.71128,0.025,NULL,59966765150,936980705,14640323,17.3),(129865,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129865,37.88,0.23,377,60009,70,NULL,NULL,'2MASX J15252074+2138438',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000184,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,231.336583333,21.64544,0.165,NULL,59413613117,928337704,14505276,17.6),(129866,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129866,37.88,0.23,377,60010,70,NULL,NULL,'SDSS J152520.82+213603.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000165,NULL,'18.5g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.33675,21.60103,0.165,NULL,59413623960,928337874,14505279,18.5),(129867,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129867,36.86,0.46,235,60011,70,NULL,NULL,'2MASX J15252092+2126568',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000166,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,231.3370417,21.44906,0.169,NULL,59413517871,928336216,14505253,16.7),(129868,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129868,36.83,0.46,232,60012,70,NULL,NULL,'2MASX J15252116+2252058',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000167,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,231.3380417,22.86839,0.153,NULL,59419210367,928425161,14506643,17.6),(129869,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129869,37.48,0.23,314,60013,70,NULL,NULL,'2MASX J15252195+3212418',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,231.3414583,32.21164,0.025,NULL,59912311972,936129874,14627029,18.5),(129870,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129870,38.13,0.27,422,60014,70,NULL,NULL,'2MASX J15252233+1255530',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,231.343,12.93144,0.129,NULL,59562721141,930667517,14541679,17.8),(129871,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129871,37.4,0.46,302,60015,70,NULL,NULL,'2MASX J15252233+3140368',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000197,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,231.3430417,31.67697,0.037,NULL,59912372298,936130817,14627044,16.6),(129872,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129872,37.46,0.46,310,60016,70,NULL,NULL,'2MASX J15252240+2925308',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00015,NULL,'16.8g',0.26,'E',NULL,NULL,NULL,NULL,1,231.343125,29.42522,0.029,NULL,59906145162,936033518,14625523,16.8),(129873,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129873,35.98,0.23,157,60017,70,NULL,NULL,'2MASX J15252240+4827532',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000179,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,231.3435417,48.46486,0.033,NULL,59664969258,932265144,14566642,16.7),(129874,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129874,35.83,0.2,147,60018,74.4,NULL,NULL,'CGCG 077-124',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000019,NULL,'15.3',0.3,NULL,NULL,NULL,NULL,NULL,1,231.343791667,9.73119,0.073,NULL,59343265397,927238521,14488101,15.3),(129875,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129875,37.48,0.23,314,60019,70,NULL,NULL,'2MASX J15252289+3208338',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.345333,32.14281,0.025,NULL,59912311485,936129866,14627029,17.2),(129876,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129876,35.98,0.23,157,60020,70,NULL,NULL,'MCG +08-28-029',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000186,NULL,'15.4g',0.55,'E0',NULL,NULL,NULL,NULL,1,231.345917,48.44011,0.033,NULL,59664967278,932265113,14566642,15.4),(129877,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129877,38.01,0.46,401,60021,70,NULL,NULL,'2MASX J15252316+3047288',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00018,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,231.346375,30.79122,0.005,NULL,59915111379,936173615,14627712,17.2),(129878,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129878,38.05,0.46,408,60022,70,NULL,NULL,'2MASX J15252357+3705034',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000176,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,231.348167,37.08422,0.025,NULL,60110463813,939225997,14675406,17.8),(129879,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129879,36.97,0.46,248,60023,70,NULL,NULL,'2MASX J15252504+2844049',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.354291667,28.73467,0.041,NULL,59907364745,936052574,14625821,17.7),(129880,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129880,38.2,0.46,437,60024,70,NULL,NULL,'SDSS J152525.86+274808.1',NULL,'2015arXiv151105856S',2015,1,0.02,NULL,'G',NULL,NULL,'23.3g',0.01,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.35775,27.80228,0.081,NULL,59907893413,936060834,14625950,23.3),(129881,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129881,37.91,0.46,382,60025,70,NULL,NULL,'2MASX J15252618+0642414',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.359167,6.71142,0.081,NULL,56411033781,881422402,13772225,17.5),(129882,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129882,37.64,0.27,338,60026,70,NULL,NULL,'2MASX J15252759+2903019',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.3650417,29.05056,0.033,NULL,59905335168,936020862,14625325,17.6),(129883,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129883,37.05,0.46,258,60027,70,NULL,NULL,'2MASX J15252853+0152432',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,231.36875,1.87853,0.145,NULL,56434046969,881781983,13777843,16.8),(129884,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129884,36.25,0.33,178,60028,70,NULL,NULL,'SDSS J152528.75+045825.8',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'18.5g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.369833333,4.97386,0.081,NULL,56436867129,881826048,13778532,18.5),(129885,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129885,36.84,0.33,234,60029,70,NULL,NULL,'2MASX J15252900+3146378',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,231.370833,31.77717,0.037,NULL,59912453132,936132080,14627063,17),(129886,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129886,36.58,0.46,207,60030,70,NULL,NULL,'2MASX J15252945+1833579',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'17.01',0.27,NULL,NULL,NULL,NULL,NULL,1,231.372625,18.56619,0.157,NULL,59433836448,928653694,14510213,17.01),(129887,'GRB','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129887,44,0.53,1760,60031,73,NULL,'H const./H=100','VLA J152530.3+444559',1.61,'2006astro.ph..9262M',2006,1,NULL,NULL,'G',NULL,NULL,'18.2',NULL,'Irregular',NULL,NULL,NULL,NULL,1,231.3762917,44.76644,0.033,NULL,59970073352,937032396,14641131,18.2),(129888,'GRB','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129888,44.36,0.47,2850,60031,69.7,NULL,'Fiducial','VLA J152530.3+444559',1.61,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129889,'GRB','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129889,44.56,1.61,3130,60031,100,NULL,NULL,'VLA J152530.3+444559',1.61,'2009EPJC...63..139W',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129890,'GRB','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129890,44.66,0.37,3280,60031,69.7,NULL,'Calibrated','VLA J152530.3+444559',1.61,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129891,'GRB','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129891,44.78,0.46,3460,60031,72,NULL,NULL,'VLA J152530.3+444559',1.61,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129892,'GRB','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129892,44.8,1.55,3490,60031,73,NULL,'H const./H=100','VLA J152530.3+444559',1.61,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129893,'GRB','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129893,44.99,0.45,3810,60031,70,NULL,NULL,'VLA J152530.3+444559',1.61,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129894,'GRB','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129894,45.02,0.54,3870,60031,NULL,NULL,NULL,'VLA J152530.3+444559',1.61,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129895,'GRB','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129895,45.5,0.16,12600,60031,NULL,NULL,NULL,'VLA J152530.3+444559',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129896,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129896,38.2,0.46,436,60032,70,NULL,NULL,'2MASX J15253068+2038169',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,231.377958333,20.63797,0.185,NULL,59444245041,928816328,14512755,18),(129897,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129897,36.94,0.46,245,60033,70,NULL,NULL,'2MASX J15253090+2435139',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000167,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,231.378625,24.58733,0.125,NULL,59418277234,928410581,14506415,16.5),(129898,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129898,37.49,0.33,315,60034,70,NULL,NULL,'2MASX J15253127+4719304',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.380333333,47.32511,0.041,NULL,59982744049,937230375,14644224,17.4),(129899,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129899,37.07,0.46,259,60035,70,NULL,NULL,'2MASX J15253149+3406048',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.381333,34.10122,0.057,NULL,59882628170,935666065,14619782,16.8),(129900,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129900,37.87,0.46,374,60036,70,NULL,NULL,'2MASX J15253198+0248352',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00012,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,231.383375,2.80972,0.085,NULL,56433367833,881771372,13777677,16.9),(129901,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129901,38.16,0.46,429,60037,70,NULL,NULL,'2MASX J15253252+5907240',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,231.385625,59.12333,0.009,NULL,57717947320,901842926,14091295,17.1),(129902,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129902,35.62,0.46,133,60038,70,NULL,NULL,'CGCG 165-053 NED01',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.00013,NULL,'15.0g',0.58,NULL,NULL,NULL,NULL,NULL,1,231.387375,26.54761,0.153,NULL,59902237427,935972459,14624569,15),(129903,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129903,37.38,0.46,299,60039,70,NULL,NULL,'2MASX J15253310+4757405',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,231.387917,47.96131,0.037,NULL,59664233506,932253648,14566463,18.2),(129904,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129904,36.05,0.46,163,60040,70,NULL,NULL,'2MASX J15253370+0555082',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000113,NULL,'16.57',0.43,NULL,NULL,NULL,NULL,NULL,1,231.390583,5.919,0.057,NULL,56429046046,881703844,13776622,16.57),(129905,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129905,33.63,0.49,53.3,60041,75,NULL,'IR','UGC 09841',NULL,'2011yCatp016004901K',2011,1,2.82,'UGC Dec (+18 22) is incorrect.','G',0.000015,NULL,'14.33',0.36,'Sbc','Pair member (points to parent)',NULL,NULL,NULL,1,231.392,18.27722,0.145,NULL,59433961377,928655646,14510244,14.33),(129906,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129906,33.99,NULL,62.7,60041,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09841',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129907,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129907,33.99,NULL,62.7,60041,NULL,NULL,'Dipole','UGC 09841',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129908,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129908,33.99,NULL,62.8,60041,NULL,NULL,'Dipole + Quadrupole','UGC 09841',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129909,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129909,34.05,NULL,64.7,60041,NULL,NULL,NULL,'UGC 09841',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129910,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129910,34.06,0.2,64.9,60041,74.4,NULL,NULL,'UGC 09841',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129911,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129911,37.48,0.46,313,60042,70,NULL,NULL,'2MASX J15253466+4527495',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000169,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,231.394375,45.46375,0.025,NULL,59969444453,937022569,14640977,16.5),(129912,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129912,38.23,0.46,442,60043,70,NULL,NULL,'SDSS J152536.86+102301.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00014,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.403625,10.38372,0.073,NULL,59343928372,927248880,14488263,18.5),(129913,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129913,37.5,0.46,316,60044,70,NULL,NULL,'2MASX J15253747+0529533',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,231.4062083,5.49825,0.085,NULL,56428962125,881702533,13776602,16.8),(129914,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129914,38.63,0.46,533,60045,70,NULL,NULL,'2MASX J15253818+4529455',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,231.409333,45.49617,0.025,NULL,59969453954,937022718,14640979,17.9),(129915,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129915,36.84,0.33,234,60046,70,NULL,NULL,'CGCG 165-054',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000183,NULL,'15.0g',0.51,'BrClG',NULL,NULL,NULL,NULL,1,231.413917,29.60356,0.013,NULL,59906116704,936033073,14625516,15),(129916,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129916,38.02,0.46,402,60047,70,NULL,NULL,'2MASX J15253983+3258138',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.415875,32.97047,0.033,NULL,59883039669,935672494,14619882,17.8),(129917,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129917,35.66,0.2,136,60048,74.4,NULL,NULL,'UGC 09843',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000107,NULL,'15.5',0.7,'SB(s)b: pec',NULL,NULL,NULL,NULL,1,231.415917,20.78794,0.181,NULL,59444215103,928815860,14512747,15.5),(129918,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129918,38.37,0.46,472,60049,70,NULL,NULL,'SDSS J152540.46+263901.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00016,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.418625,26.6505,0.137,NULL,59902248066,935972626,14624572,18.3),(129919,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129919,33.84,NULL,58.5,60050,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1903',NULL,'2010Ap&SS.325..163P',2010,1,0.93,NULL,'G',NULL,NULL,'16.42',0.11,'Sdm',NULL,NULL,NULL,NULL,1,231.419583,66.21111,0.073,NULL,57961241054,905644391,14150693,16.42),(129920,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129920,33.86,NULL,59.1,60050,NULL,NULL,'Dipole + Quadrupole','FGC 1903',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129921,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129921,33.87,NULL,59.5,60050,NULL,NULL,'Dipole','FGC 1903',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129922,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129922,33.92,NULL,60.9,60050,NULL,NULL,NULL,'FGC 1903',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129923,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129923,37.22,0.23,278,60051,70,NULL,NULL,'2MASX J15254150+3254268',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000012,NULL,'16.0g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,231.422917,32.90744,0.033,NULL,59883059586,935672806,14619887,16),(129924,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129924,37.65,0.46,339,60052,70,NULL,NULL,'2MASX J15254233+1318210',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.4264583,13.30575,0.097,NULL,59563225042,930675391,14541802,16.8),(129925,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129925,35.44,NULL,122,60053,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1895',NULL,'2010Ap&SS.325..163P',2010,1,0.93,NULL,'G',0.000033,NULL,'16.4',0.12,'Sc             HII',NULL,NULL,NULL,NULL,1,231.4309583,-17.24122,0.505,NULL,46598114005,728095531,11376492,16.4),(129926,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129926,35.46,NULL,123,60053,NULL,NULL,'Dipole + Quadrupole','FGC 1895',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129927,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129927,35.47,NULL,124,60053,NULL,NULL,'Dipole','FGC 1895',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129928,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129928,35.49,NULL,125,60053,NULL,NULL,NULL,'FGC 1895',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129929,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129929,36.84,0.33,234,60054,70,NULL,NULL,'2MASX J15254428+3143518',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,231.4345,31.731,0.037,NULL,59912260508,936129070,14627016,17.6),(129930,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129930,37.41,0.16,304,60055,70,NULL,NULL,'SDSS J152544.58+070107.1',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,231.43575,7.01867,0.065,NULL,56410582676,881415354,13772114,NULL),(129931,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129931,36.84,0.33,234,60056,70,NULL,NULL,'2MASX J15254529+2935079',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000113,NULL,'16.3g',0.29,'E',NULL,NULL,NULL,NULL,1,231.4385417,29.58567,0.013,NULL,59906115037,936033047,14625516,16.3),(129932,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129932,37.32,0.46,291,60057,70,NULL,NULL,'2MASX J15254550+0813089',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,231.4394583,8.21908,0.097,NULL,56412196363,881440568,13772508,16.8),(129933,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129933,37.74,0.46,353,60058,70,NULL,NULL,'2MASX J15254561+1906043',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.44,19.10128,0.161,NULL,59442039145,928781861,14512216,17.3),(129934,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129934,36.99,0.46,250,60059,70,NULL,NULL,'2MASX J15254619+0401343',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000095,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,231.442458333,4.02631,0.093,NULL,56438331028,881848922,13778889,16.6),(129935,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129935,34.86,0.49,93.7,60060,75,NULL,'IR','UGC 09853',NULL,'2011yCatp016004901K',2011,1,2.24,NULL,'G',0.000043,NULL,'14.6g',0.42,'Sb','Isolated galaxy',NULL,NULL,NULL,1,231.444625,52.44472,0.033,NULL,59676423627,932444119,14569439,14.6),(129936,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129936,36.25,0.33,178,60061,70,NULL,NULL,'2MASX J15254671+0452103',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,231.444708333,4.86953,0.081,NULL,56436938164,881827158,13778549,16.9),(129937,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129937,37.48,0.23,314,60062,70,NULL,NULL,'2MASX J15254754+3204339',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000178,NULL,'16.3g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,231.448,32.07614,0.025,NULL,59912461968,936132218,14627065,16.3),(129938,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129938,38.15,0.46,426,60063,70,NULL,NULL,'2MASX J15254828+2345123',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000136,NULL,'18.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.451333,23.75342,0.185,NULL,59419863300,928435364,14506802,18),(129939,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129939,38.5,0.46,502,60064,70,NULL,NULL,'SDSS J152550.21+313205.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000162,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,231.45925,31.53472,0.029,NULL,59911796813,936121825,14626903,18.3),(129940,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129940,38,0.46,398,60065,70,NULL,NULL,'2MASX J15255024+4230285',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,231.4595,42.50808,0.085,NULL,59977596443,937149944,14642967,17.7),(129941,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129941,38.78,0.46,570,60066,70,NULL,NULL,'SDSS J152550.44+055554.6',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,231.460166667,5.93186,0.057,NULL,56428997055,881703078,13776610,NULL),(129942,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129942,37.41,0.16,304,60067,70,NULL,NULL,'2MASX J15255076+0652479',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,231.4614583,6.87983,0.065,NULL,56411037998,881422468,13772226,17.5),(129943,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129943,37.01,0.46,253,60068,70,NULL,NULL,'SDSS J152550.76+082343.5',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000186,NULL,'15.8g',0.5,'S0','Group member',NULL,NULL,NULL,1,231.461541667,8.39542,0.093,NULL,56412170074,881440157,13772502,15.8),(129944,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129944,37.28,0.46,286,60069,70,NULL,NULL,'2MASX J15255148+5916291',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000195,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,231.464417,59.27464,0.037,NULL,57772536853,902695888,14104623,16.2),(129945,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129945,35.25,0.39,112,60070,NULL,NULL,NULL,'UGC 09844',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.00001,NULL,'14.49',0.6,'SB(s)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,231.469125,7.81961,0.081,NULL,56411967725,881436995,13772453,14.49),(129946,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129946,35.42,0.36,121,60070,NULL,NULL,'Malmquist cor.','UGC 09844',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129947,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129947,35.8,0.4,144,60070,NULL,NULL,'mean','UGC 09844',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129948,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129948,35.82,0.2,146,60070,74.4,NULL,NULL,'UGC 09844',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129949,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129949,36.06,0.47,163,60070,NULL,NULL,'H','UGC 09844',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129950,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129950,37.62,0.46,334,60071,70,NULL,NULL,'2MASX J15255381+4844220',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,231.474208333,48.73961,0.029,NULL,59664801825,932262528,14566602,18.2),(129951,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129951,37.13,0.23,266,60072,70,NULL,NULL,'2MASX J15255389+3618573',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'16.22',0.46,NULL,NULL,NULL,NULL,NULL,1,231.4747917,36.31592,0.021,NULL,60105823199,939153487,14674273,16.22),(129952,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129952,35.69,0.46,137,60073,70,NULL,NULL,'2MASX J15255426+1339370',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000067,NULL,'15.64',0.43,NULL,NULL,NULL,NULL,NULL,1,231.476167,13.66039,0.117,NULL,59562431462,930662991,14541609,15.64);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (129953,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129953,37.41,0.46,303,60074,70,NULL,NULL,'2MASX J15255504+2815216',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.19',0.16,NULL,NULL,NULL,NULL,NULL,1,231.47925,28.25603,0.057,NULL,59907414625,936053353,14625833,18.19),(129954,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129954,37.48,0.23,314,60075,70,NULL,NULL,'2MASX J15255580+3200339',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,231.4825,32.00953,0.025,NULL,59912466475,936132288,14627067,17.5),(129955,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129955,37.35,0.23,296,60076,70,NULL,NULL,'SDSS J152555.90+065135.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.4829583,6.86,0.065,NULL,56411037830,881422466,13772226,18.2),(129956,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129956,37.72,0.46,350,60077,70,NULL,NULL,'2MASX J15255739+1914223',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.48925,19.23961,0.161,NULL,59445504514,928836008,14513062,18.3),(129957,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129957,38.42,0.46,482,60078,70,NULL,NULL,'2MASX J15255943+5913541',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000179,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,231.4977083,59.23167,0.009,NULL,57772501650,902695338,14104614,17.4),(129958,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129958,37.98,0.46,395,60079,70,NULL,NULL,'SDSS J152559.46+430604.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.497833333,43.10111,0.097,NULL,59977917359,937154958,14643046,18),(129959,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129959,37.94,0.46,388,60080,70,NULL,NULL,'2MASX J15255961+0102037',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000074,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.498375,1.03428,0.117,NULL,56397372093,881208938,13768889,18),(129960,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129960,36.84,0.46,233,60081,70,NULL,NULL,'2MASX J15255984+0947245',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,231.499333,9.79017,0.073,NULL,59343314041,927239281,14488113,16.9),(129961,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129961,36.92,0.46,242,60082,70,NULL,NULL,'2MASX J15260036+5600041',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,231.5017917,56.00108,0.013,NULL,57596084816,899938825,14061544,17.5),(129962,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129962,37.81,0.33,365,60083,70,NULL,NULL,'2MASX J15260064+3117139',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,231.5027083,31.28725,0.025,NULL,59911944647,936124135,14626939,17.1),(129963,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129963,37.81,0.46,364,60084,70,NULL,NULL,'SDSS J152600.67+103539.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.5027917,10.59436,0.085,NULL,59343902800,927248481,14488257,18.1),(129964,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129964,38.31,0.46,459,60085,70,NULL,NULL,'2MASXi J1526006+375716',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000158,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.502833333,37.95472,0.013,NULL,60111760482,939246257,14675722,17.3),(129965,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129965,37.15,0.33,269,60086,70,NULL,NULL,'2MASX J15260102+2916587',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000107,NULL,'16.8g',0.31,'E',NULL,NULL,NULL,NULL,1,231.504333333,29.283,0.045,NULL,59905346889,936021045,14625328,16.8),(129966,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129966,35.05,0.66,102,60087,70,NULL,NULL,'2MASX J15260190-0123273',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'15.7g',0.42,'E0',NULL,NULL,NULL,NULL,1,231.5077917,-1.391,0.281,NULL,45420706983,709698546,11089039,15.7),(129967,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129967,35.22,0.46,111,60087,70,NULL,NULL,'2MASX J15260190-0123273',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129968,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129968,37.81,0.33,365,60088,70,NULL,NULL,'2MASX J15260189+3117039',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000148,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.5080417,31.28431,0.025,NULL,59911944608,936124134,14626939,17.6),(129969,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129969,37.13,0.23,266,60089,70,NULL,NULL,'2MASX J15260251+3620188',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,231.510625,36.33858,0.021,NULL,60110217481,939222148,14675346,16.5),(129970,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129970,33.87,0.46,59.3,60090,70,NULL,NULL,'NGC 5928',NULL,'2015arXiv151105856S',2015,1,1.6,NULL,'G',0.00006,NULL,'13.3g',1.02,'S0','Possible field galaxy',NULL,NULL,NULL,1,231.512,18.07364,0.141,NULL,59436811363,928700177,14510940,13.3),(129971,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129971,33.97,0.4,62.3,60090,NULL,NULL,'mean','NGC 5928',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129972,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129972,34.14,0.45,67.4,60090,NULL,NULL,'K','NGC 5928',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129973,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129973,37.11,0.46,265,60091,70,NULL,NULL,'2MASX J15260329+5030591',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,231.51375,50.51639,0.037,NULL,59667338050,932302157,14567221,17.8),(129974,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129974,36.28,0.27,181,60092,70,NULL,NULL,'2MASX J15260490+0612445',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,231.520417,6.21242,0.065,NULL,56411096504,881423382,13772240,16.7),(129975,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129975,38.36,0.46,471,60093,70,NULL,NULL,'SDSS J152604.99+285756.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.520833,28.96575,0.033,NULL,59905299547,936020305,14625317,18.3),(129976,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129976,37.35,0.46,295,60094,70,NULL,NULL,'SDSS J152605.17+283122.6',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.0002,NULL,'17.7g',0.13,NULL,'Group member',NULL,NULL,NULL,1,231.521583333,28.52294,0.049,NULL,59907452758,936053949,14625842,17.7),(129977,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129977,32.54,0.2,32.2,60095,74.4,NULL,NULL,'UGC 09845',NULL,'2013AJ....146...86T',2013,1,1.71,NULL,'G',0.000006,NULL,'15.3g',0.31,'Sbc',NULL,NULL,NULL,NULL,1,231.523208333,9.20414,0.073,NULL,59354644771,927416324,14490880,15.3),(129978,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129978,32.57,NULL,32.6,60095,72,NULL,NULL,'UGC 09845',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129979,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129979,32.65,0.4,33.8,60095,75,NULL,NULL,'UGC 09845',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129980,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129980,33,0.43,39.8,60095,75,NULL,'3.6 micron, color corrected','UGC 09845',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129981,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129981,33.13,NULL,42.2,60095,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09845',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129982,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129982,33.14,NULL,42.5,60095,NULL,NULL,'Dipole + Quadrupole','UGC 09845',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129983,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129983,33.15,NULL,42.6,60095,NULL,NULL,'Dipole','UGC 09845',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129984,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129984,33.22,NULL,44.1,60095,NULL,NULL,NULL,'UGC 09845',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129985,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129985,33.31,0.49,45.8,60095,75,NULL,'IR','UGC 09845',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129986,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129986,33.46,0.43,49.1,60095,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09845',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129987,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129987,36.48,0.46,198,60096,70,NULL,NULL,'2MASX J15260596+3039519',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000157,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,231.524833,30.66439,0.021,NULL,59913022739,936140980,14627202,16.3),(129988,'Tully est','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129988,32.93,0.8,38.5,60097,75,NULL,NULL,'NGC 5929',NULL,'1988NBGC.C....0000T',1988,1,1.14,NULL,'G',0.000027,NULL,'13.9g',0.89,'Sab: pec       Sy2','X-ray-faint group member',NULL,NULL,'Sy 2',1,231.525667,41.67067,0.057,NULL,59975924008,937123812,14642559,13.9),(129989,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129989,36.44,0.46,194,60098,70,NULL,NULL,'2MASX J15260623+2232263',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.00018,NULL,'15.8g',0.43,NULL,NULL,NULL,NULL,NULL,1,231.525875,22.54056,0.177,NULL,59418800003,928418750,14506542,15.8),(129990,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129990,37.34,0.33,294,60099,70,NULL,NULL,'2MASX J15260672+5421470',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.527833333,54.363,0.021,NULL,59673422608,932397228,14568706,17.6),(129991,'Tully est','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129991,33.11,0.8,41.9,60100,75,NULL,'B','NGC 5930',NULL,'1988NBGC.C....0000T',1988,1,1.93,NULL,'G',0.000014,NULL,'13.3g',0.84,'SAB(rs)b pec   HII','X-ray-faint group member',NULL,NULL,NULL,1,231.533083333,41.67606,0.057,NULL,59975924216,937123815,14642559,13.3),(129992,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129992,32.49,0.47,31.4,60100,NULL,NULL,'H','NGC 5930',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129993,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129993,32.49,0.45,31.5,60100,NULL,NULL,'K','NGC 5930',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129994,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129994,32.53,0.46,32.1,60100,NULL,NULL,'J','NGC 5930',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129995,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129995,32.89,0.4,37.9,60100,NULL,NULL,'mean','NGC 5930',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129996,'IRAS','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129996,32.47,0.8,31.2,60101,75,NULL,'MAT, I','UGCA 408',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000024,NULL,'13',1.6,'SA(s)c         HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,231.533458333,-22.28247,0.413,NULL,46619902684,728435979,11381812,13),(129997,'Tully est','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129997,32.63,0.8,33.6,60101,75,NULL,NULL,'UGCA 408',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129998,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129998,31.88,0.43,23.8,60101,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 408',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129999,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129999,31.9,0.32,24,60101,85,NULL,'I, raw','UGCA 408',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130000,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130000,31.94,0.43,24.4,60101,75,NULL,'3.6 micron, color corrected','UGCA 408',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130001,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130001,31.94,0.32,24.4,60101,85,NULL,'I, inv','UGCA 408',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130002,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130002,32,0.43,25.2,60101,75,NULL,'MAT, I, raw','UGCA 408',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130003,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130003,32.03,0.2,25.5,60101,74.4,NULL,NULL,'UGCA 408',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130004,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130004,32.17,0.43,27.1,60101,75,NULL,'MAT, I, inv','UGCA 408',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130005,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130005,32.27,0.46,28.4,60101,NULL,NULL,'J','UGCA 408',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130006,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130006,32.27,0.43,28.5,60101,NULL,NULL,NULL,'UGCA 408',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130007,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130007,32.31,0.43,28.9,60101,75,NULL,'MAT, I, cor','UGCA 408',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130008,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130008,32.33,0.42,29.2,60101,NULL,NULL,'Malmquist cor.','UGCA 408',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130009,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130009,32.38,0.45,29.9,60101,NULL,NULL,'K','UGCA 408',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130010,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130010,32.39,0.47,30.1,60101,NULL,NULL,'H','UGCA 408',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130011,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130011,32.57,0.4,32.6,60101,NULL,NULL,'mean','UGCA 408',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130012,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130012,38.03,0.46,404,60102,70,NULL,NULL,'2MASX J15260951+5612370',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.539583,56.21042,0.021,NULL,57596050411,899938287,14061535,18),(130013,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130013,36.66,0.46,215,60103,70,NULL,NULL,'2MASX J15261015+5618510',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.5422917,56.31408,0.025,NULL,57595781186,899934081,14061470,16.6),(130014,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130014,37.8,0.27,363,60104,70,NULL,NULL,'SDSS J152610.29+035458.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000087,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,231.542917,3.91628,0.093,NULL,56438323511,881848804,13778887,18.4),(130015,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130015,36.81,0.46,230,60105,70,NULL,NULL,'2MASX J15261088-0027153',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000113,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,231.545291667,-0.45422,0.233,NULL,45404370688,709443292,11085051,16.7),(130016,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130016,35.75,0.35,141,60106,NULL,NULL,NULL,'CGCG 077-126',NULL,'2009ApJS..182..474S',2009,1,0.7,'This object is described by multiple SDSS entries.','G',0.000011,NULL,'15.7',0.3,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,231.546833,8.90742,0.081,NULL,56411330173,881427033,13772297,15.7),(130017,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130017,35.81,0.34,145,60106,NULL,NULL,'Malmquist cor.','CGCG 077-126',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130018,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130018,35.9,0.2,151,60106,74.4,NULL,NULL,'CGCG 077-126',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130019,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130019,33.77,0.49,56.9,60107,75,NULL,'IR','ESO 449- G 010',NULL,'2011yCatp016004901K',2011,1,1.6,NULL,'G',0.000033,NULL,'13.66',0.3,'S...',NULL,NULL,NULL,NULL,1,231.5537917,-30.20136,0.545,NULL,47163261542,736925961,11514468,13.66),(130020,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130020,37.8,0.27,363,60108,70,NULL,NULL,'2MASX J15261303+0353058',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000122,NULL,'17.1g',0.24,'NLAGN',NULL,NULL,NULL,'Sy 2',1,231.5542917,3.88486,0.093,NULL,56438323950,881848811,13778887,17.1),(130021,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130021,37.11,0.46,264,60109,70,NULL,NULL,'SBS 1525+580A',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000176,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,231.5574583,57.91183,0.017,NULL,57591687782,899870121,14060470,16.4),(130022,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130022,38.75,0.46,561,60110,70,NULL,NULL,'2MASX J15261414+3229180',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,231.559,32.48847,0.029,NULL,59912043507,936125679,14626963,18.3),(130023,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130023,37.94,0.33,387,60111,70,NULL,NULL,'2MASX J15261619+2207371',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000181,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,231.5675,22.12694,0.169,NULL,59420734058,928448969,14507015,17),(130024,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130024,37.95,0.46,389,60112,70,NULL,NULL,'SDSS J152617.47+104257.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.7g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.572791667,10.71586,0.101,NULL,59345076226,927266816,14488544,18.7),(130025,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130025,38.4,0.46,479,60113,70,NULL,NULL,'SDSS J152617.78+115113.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.574125,11.85389,0.105,NULL,59344920718,927264386,14488506,18),(130026,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130026,37.76,0.46,356,60114,70,NULL,NULL,'2MASX J15261816+0018558',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,231.5757917,0.31556,0.149,NULL,56397041221,881203769,13768808,17.6),(130027,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130027,35.94,0.46,154,60115,70,NULL,NULL,'2MASX J15261853+3724199',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000174,NULL,'16.0g',0.34,NULL,NULL,NULL,NULL,NULL,1,231.577208333,37.4055,0.029,NULL,60110009494,939218898,14675295,16),(130028,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130028,38.07,0.46,410,60116,70,NULL,NULL,'2MASX J15261928+0049048',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000086,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.5804583,0.81811,0.137,NULL,56397302104,881207845,13768872,17.5),(130029,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130029,37.13,0.23,266,60117,70,NULL,NULL,'2MASX J15261940+3618359',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000176,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,231.5807083,36.31008,0.021,NULL,60105824391,939153506,14674273,16.8),(130030,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130030,37.68,0.46,343,60118,70,NULL,NULL,'2MASX J15261978+3331170',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000176,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.5825,33.5215,0.029,NULL,59882766758,935668230,14619816,17.4),(130031,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130031,37.11,0.13,265,60119,70,NULL,NULL,'2MASX J15261985+2824158',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000097,NULL,'17.1g',0.25,NULL,'Group member',NULL,NULL,NULL,1,231.582833,28.4045,0.041,NULL,59907448755,936053886,14625841,17.1),(130032,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130032,37.44,0.27,307,60120,70,NULL,NULL,'2MASX J15262006+1017096',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,231.5837083,10.286,0.073,NULL,59344143100,927252235,14488316,17.2),(130033,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130033,37.85,0.46,371,60121,70,NULL,NULL,'2MASX J15262025+0555128',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.5842917,5.92025,0.057,NULL,56428161980,881690030,13776406,17.6),(130034,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130034,36.23,0.46,177,60122,70,NULL,NULL,'2MASX J15262028+5040492',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.5845,50.68047,0.037,NULL,59667175906,932299623,14567181,16.9),(130035,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130035,37.92,0.46,383,60123,70,NULL,NULL,'SDSS J152621.00+581753.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000167,NULL,'18.2g',0.1,NULL,NULL,NULL,NULL,NULL,1,231.587541667,58.29819,0.017,NULL,57588277886,899816841,14059638,18.2),(130036,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130036,37.94,0.33,387,60124,70,NULL,NULL,'2MASX J15262115+2210451',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.588125,22.17931,0.169,NULL,59420736560,928449008,14507015,17.5),(130037,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130037,37.35,0.23,296,60125,70,NULL,NULL,'2MASX J15262119+0642596',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00012,NULL,'15.6g',0.5,NULL,NULL,NULL,NULL,NULL,1,231.5882917,6.71647,0.053,NULL,56411250658,881425791,13772277,15.6),(130038,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130038,37.38,0.46,300,60126,70,NULL,NULL,'2MASX J15262130+3700319',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.5887917,37.00878,0.025,NULL,60110429508,939225461,14675397,17.4),(130039,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130039,37.35,0.23,296,60127,70,NULL,NULL,'2MASX J15262152+0648306',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,231.58975,6.80853,0.081,NULL,56411076384,881423068,13772235,17.7),(130040,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130040,35.58,0.2,131,60128,74.4,NULL,NULL,'CGCG 077-129',NULL,'2013AJ....146...86T',2013,1,0.79,NULL,'G',0.000011,NULL,'15.3g',0.5,NULL,NULL,NULL,NULL,NULL,1,231.5924583,9.39644,0.085,NULL,59343170095,927237032,14488078,15.3),(130041,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130041,37.36,0.46,296,60129,70,NULL,NULL,'2MASX J15262243+4711125',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.5934583,47.18689,0.033,NULL,59965972904,936968326,14640130,17.1),(130042,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130042,35.58,0.46,131,60130,70,NULL,NULL,'2MASX J15262244+0859146',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000153,NULL,'15.3g',0.49,NULL,NULL,NULL,NULL,NULL,1,231.5935,8.98736,0.081,NULL,56419684564,881557571,13774337,15.3),(130043,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130043,37.11,0.13,265,60131,70,NULL,NULL,'2MASX J15262295+2832315',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000117,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,231.59575,28.54203,0.045,NULL,59907495564,936054618,14625853,16.5),(130044,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130044,36.26,0.46,178,60132,70,NULL,NULL,'2MASX J15262426+2040201',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000147,NULL,'16.25',0.22,NULL,NULL,NULL,NULL,NULL,1,231.601083333,20.67214,0.185,NULL,59444593313,928821770,14512840,16.25),(130045,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130045,38.31,0.46,459,60133,70,NULL,NULL,'SDSS J152624.85+293347.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,231.6035417,29.56308,0.013,NULL,59906117709,936033089,14625517,18.1),(130046,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130046,37.24,0.46,281,60134,70,NULL,NULL,'2MASX J15262566+3147120',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000156,NULL,'16.8g',0.32,'AGN',NULL,NULL,NULL,NULL,1,231.606875,31.78656,0.037,NULL,59912275145,936129299,14627020,16.8),(130047,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130047,37.25,0.46,282,60135,70,NULL,NULL,'2MASX J15262597+2326501',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000138,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.608208333,23.44731,0.193,NULL,59419320663,928426885,14506670,17.5),(130048,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130048,37.99,0.46,395,60136,70,NULL,NULL,'2MASX J15262633+3316480',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,231.6097917,33.28017,0.013,NULL,59883102739,935673480,14619898,17.7),(130049,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130049,37.15,0.33,269,60137,70,NULL,NULL,'2MASX J15262729+2922315',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,231.61375,29.3755,0.029,NULL,59905244608,936019447,14625303,17.2),(130050,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130050,37.21,0.33,277,60138,70,NULL,NULL,'2MASX J15262807+1130561',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'16.4E',NULL,NULL,NULL,NULL,NULL,NULL,1,231.616917,11.51556,0.077,NULL,59344847563,927263243,14488488,16.4),(130051,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130051,37.8,0.46,363,60139,70,NULL,NULL,'2MASX J15262898+5326502',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,231.620958333,53.44731,0.025,NULL,59674403828,932412559,14568946,17.5),(130052,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130052,36.16,0.09,171,60140,70,NULL,NULL,'CGCG 077-130',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.0001,NULL,'15.1g',0.64,NULL,NULL,NULL,NULL,NULL,1,231.62275,8.59061,0.077,NULL,56411481610,881429400,13772334,15.1),(130053,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130053,38.56,0.46,514,60141,70,NULL,NULL,'SDSS J152629.62+193306.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000159,NULL,'18.9g',0.08,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.623417,19.55186,0.169,NULL,59445637511,928838086,14513095,18.9),(130054,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130054,37.13,0.23,266,60142,70,NULL,NULL,'2MASX J15262966+3618249',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,231.6235,36.307,0.021,NULL,60105819206,939153425,14674272,17.1),(130055,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130055,32.52,NULL,31.9,60143,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09856',NULL,'2010Ap&SS.325..163P',2010,1,2.79,NULL,'G',0.000013,NULL,'14.9g',0.3,'Sc;WR          HII','X-ray-faint group member',NULL,NULL,NULL,1,231.62625,41.28953,0.037,NULL,59975855744,937122746,14642542,14.9),(130056,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130056,32.53,NULL,32.1,60143,NULL,NULL,'Dipole + Quadrupole','UGC 09856',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130057,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130057,32.54,NULL,32.2,60143,NULL,NULL,'Dipole','UGC 09856',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130058,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130058,32.54,0.53,32.2,60143,NULL,NULL,NULL,'UGC 09856',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130059,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130059,32.66,0.2,34,60143,74.4,NULL,NULL,'UGC 09856',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130060,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130060,32.73,0.49,35.2,60143,NULL,NULL,'Malmquist cor.','UGC 09856',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130061,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130061,32.78,0.4,36,60143,NULL,NULL,NULL,'UGC 09856',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130062,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130062,32.99,0.43,39.5,60143,75,NULL,'3.6 micron, color corrected','UGC 09856',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130063,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130063,33.08,0.43,41.3,60143,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09856',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130064,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130064,37.93,0.46,386,60144,70,NULL,NULL,'SDSS J152631.12+300626.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00014,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,231.6297083,30.10739,0.013,NULL,59913116502,936142445,14627225,18.1),(130065,'Tully est','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130065,32.85,0.8,37.1,60145,75,NULL,NULL,'UGC 09857',NULL,'1988NBGC.C....0000T',1988,1,1.37,NULL,'G',0.000017,NULL,'15.6g',0.38,'IBm','X-ray-faint group member',NULL,NULL,NULL,1,231.6307083,41.72519,0.081,NULL,59975903734,937123495,14642554,15.6),(130066,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130066,36.87,0.46,237,60146,70,NULL,NULL,'2MASX J15263162+4457164',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000149,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,231.6317083,44.95453,0.041,NULL,59970053629,937032087,14641126,16.5),(130067,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130067,37.88,0.46,378,60147,70,NULL,NULL,'2MASX J15263256+1553013',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,231.63575,15.88375,0.105,NULL,59434378923,928662170,14510346,16.4),(130068,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130068,38.87,0.46,595,60148,70,NULL,NULL,'2MASX J15263332+2214541',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000155,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,231.638875,22.24828,0.169,NULL,59418644188,928416315,14506504,17.5),(130069,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130069,37.95,0.46,389,60149,70,NULL,NULL,'SDSS J152633.65+020204.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.4g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.6402083,2.03456,0.125,NULL,56431896504,881748382,13777318,18.4),(130070,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130070,36.4,0.46,191,60150,70,NULL,NULL,'2MASX J15263425+3931139',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,231.642583,39.52056,0.049,NULL,60098001749,939031277,14672363,16.8),(130071,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130071,37.41,0.46,304,60151,70,NULL,NULL,'2MASX J15263463+3513580',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000183,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,231.644417,35.23269,0.021,NULL,60106160465,939158757,14674355,16.4),(130072,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130072,36.96,0.46,246,60152,70,NULL,NULL,'2MASX J15263487+3123160',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.645333,31.38786,0.021,NULL,59911811322,936122051,14626907,17.5),(130073,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130073,36.06,0.46,163,60153,70,NULL,NULL,'2MASX J15263544+3248360',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000162,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,231.647625,32.80986,0.033,NULL,59882524893,935664451,14619757,16.4),(130074,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130074,37.44,0.27,307,60154,70,NULL,NULL,'2MASX J15263636+1004501',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000174,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,231.6514583,10.08067,0.073,NULL,59344099601,927251556,14488305,16.9),(130075,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130075,37.35,0.23,296,60155,70,NULL,NULL,'2MASX J15263877+0649141',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,231.6615,6.82042,0.081,NULL,56411246548,881425727,13772276,16.2),(130076,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130076,38.07,0.46,412,60156,70,NULL,NULL,'2MASX J15263936+0214287',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.6640417,2.24144,0.109,NULL,56431880705,881748136,13777314,16.9),(130077,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130077,37.15,0.46,269,60157,70,NULL,NULL,'SDSS J152639.38+043807.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.664083,4.63556,0.093,NULL,56436796705,881824948,13778514,18.3),(130078,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130078,37.26,0.46,283,60158,70,NULL,NULL,'2MASX J15263943+5848106',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000184,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,231.664125,58.80294,0.021,NULL,57718004289,901843817,14091309,17.2),(130079,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130079,37.51,0.46,318,60159,70,NULL,NULL,'2MASX J15263982+1748075',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.666083,17.80211,0.133,NULL,59437266902,928707295,14511051,17.4),(130080,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130080,37.11,0.46,264,60160,70,NULL,NULL,'2MASX J15263999+3841151',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.6665417,38.68769,0.041,NULL,60097332075,939020813,14672200,17.2),(130081,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130081,36.15,0.33,170,60161,70,NULL,NULL,'2MASX J15264039+0442527',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,231.668125,4.71472,0.097,NULL,56436846951,881825733,13778527,16.6),(130082,'IRAS','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130082,33,0.8,39.9,60162,75,NULL,'A82, H','UGC 09858',NULL,'1997ApJS..109..333W',1997,1,3.36,NULL,'G',0.000007,NULL,'13.5g',0.72,'SABbc','X-ray-faint group member',NULL,NULL,NULL,1,231.6727917,40.5645,0.033,NULL,59964065486,936938523,14639664,13.5),(130083,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130083,32.28,0.4,28.6,60162,75,NULL,NULL,'UGC 09858',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130084,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130084,32.31,0.4,29,60162,NULL,NULL,'Virgo cluster at 15.6 Mpc','UGC 09858',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130085,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130085,32.6,0.38,33.1,60162,NULL,NULL,NULL,'UGC 09858',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130086,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130086,32.73,0.47,35.1,60162,75,NULL,'A82, H, raw','UGC 09858',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130087,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130087,32.83,0.47,36.8,60162,75,NULL,'A82, H, inv','UGC 09858',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130088,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130088,32.97,0.2,39.3,60162,74.4,NULL,NULL,'UGC 09858',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130089,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130089,32.98,0.47,39.4,60162,75,NULL,'A82, H, cor','UGC 09858',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130090,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130090,33.01,0.4,40,60162,NULL,NULL,'mean','UGC 09858',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130091,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130091,33.04,0.4,40.6,60162,75,NULL,'B','UGC 09858',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130092,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130092,33.05,0.43,40.8,60162,75,NULL,'3.6 micron, color corrected','UGC 09858',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130093,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130093,33.11,0.49,42,60162,75,NULL,'IR','UGC 09858',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130094,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130094,33.21,0.46,43.8,60162,NULL,NULL,'J','UGC 09858',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130095,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130095,33.23,0.43,44.2,60162,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09858',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130096,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130096,33.31,0.47,45.9,60162,NULL,NULL,'H','UGC 09858',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130097,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130097,33.38,0.45,47.5,60162,NULL,NULL,'K','UGC 09858',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130098,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130098,37.69,0.33,345,60163,70,NULL,NULL,'2MASX J15264206+0438557',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.6752917,4.64869,0.093,NULL,56436796368,881824943,13778514,17.2),(130099,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130099,36.1,0.46,166,60164,70,NULL,NULL,'2MASX J15264211+2615117',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.89',0.15,NULL,NULL,NULL,NULL,NULL,1,231.6755,26.25342,0.141,NULL,59902972651,935983947,14624749,17.89),(130100,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130100,37.69,0.33,345,60165,70,NULL,NULL,'2MASX J15264346+0439417',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,231.6810417,4.66161,0.093,NULL,56436795487,881824929,13778514,16.8),(130101,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130101,37.92,0.46,385,60166,70,NULL,NULL,'2MASX J15264439+1854263',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000177,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.6849583,18.90733,0.181,NULL,59445400172,928834377,14513037,17.9),(130102,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130102,37.05,0.33,257,60167,70,NULL,NULL,'2MASX J15264524+1844323',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'17.22',0.43,NULL,NULL,NULL,NULL,NULL,1,231.6885,18.74225,0.177,NULL,59441953531,928780523,14512195,17.22),(130103,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130103,37.22,0.23,278,60168,70,NULL,NULL,'2MASX J15264523+3309233',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000204,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,231.688625,33.1565,0.021,NULL,59883092413,935673318,14619895,16.8),(130104,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130104,36.71,0.46,220,60169,70,NULL,NULL,'2MASX J15264605-0106082',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000077,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,231.6919583,-1.10222,0.249,NULL,45403846363,709435099,11084923,17.9),(130105,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130105,34.87,NULL,94.3,60170,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1899',NULL,'2010Ap&SS.325..163P',2010,1,0.88,NULL,'G',0.000017,NULL,'16.8',0.09,'Sd',NULL,NULL,NULL,NULL,1,231.695,-13.96667,0.529,NULL,46660324180,729067565,11391680,16.8),(130106,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130106,34.88,NULL,94.5,60170,NULL,NULL,NULL,'FGC 1899',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130107,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130107,34.88,NULL,94.5,60170,NULL,NULL,'Dipole + Quadrupole','FGC 1899',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130108,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130108,34.89,NULL,95.1,60170,NULL,NULL,'Dipole','FGC 1899',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130109,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130109,35.32,0.46,116,60171,70,NULL,NULL,'CGCG 106-045',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000203,NULL,'15.4',0.49,NULL,NULL,NULL,NULL,NULL,1,231.6962083,16.55775,0.085,NULL,59435383225,928677862,14510591,15.4),(130110,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130110,36.84,0.46,234,60172,70,NULL,NULL,'2MASX J15264768+3731291',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000172,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,231.6985417,37.52481,0.037,NULL,60110114866,939220544,14675321,16.5),(130111,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130111,35.98,0.23,157,60173,70,NULL,NULL,'NGC 5932',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.000183,NULL,'14.5g',0.82,'E0',NULL,NULL,NULL,NULL,1,231.700875,48.61497,0.033,NULL,59664987341,932265427,14566647,14.5),(130112,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130112,36.88,0.46,238,60174,70,NULL,NULL,'2MASX J15264903+0820501',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.7042917,8.34739,0.077,NULL,56411884894,881435701,13772432,17.6),(130113,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130113,37.21,0.33,277,60175,70,NULL,NULL,'2MASX J15264950+1126351',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,231.706166667,11.44322,0.077,NULL,59344975351,927265239,14488519,17.3),(130114,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130114,37.73,0.46,352,60176,70,NULL,NULL,'2MASX J15265110+0207147',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,231.713,2.12069,0.109,NULL,56431921989,881748781,13777324,NULL),(130115,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130115,36.45,0.46,195,60177,70,NULL,NULL,'2MASX J15265161+0338270',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000077,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,231.715167,3.64075,0.093,NULL,56438146898,881846045,13778844,16.6),(130116,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130116,37.05,0.33,257,60178,70,NULL,NULL,'2MASX J15265178+1844163',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000188,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.715667,18.73803,0.177,NULL,59441940371,928780318,14512192,17.3),(130117,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130117,37.39,0.46,300,60179,70,NULL,NULL,'2MASX J15265181+3539493',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.71575,35.66375,0.037,NULL,60106472242,939163628,14674431,17.2),(130118,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130118,37.86,0.46,373,60180,70,NULL,NULL,'2MASX J15265318+3020153',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,231.7214583,30.3375,0.017,NULL,59913253312,936144583,14627259,17.8),(130119,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130119,35.01,0.47,101,60181,70,NULL,NULL,'2MASX J15265337-2005411',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.39',NULL,NULL,NULL,NULL,NULL,NULL,1,231.7225417,-20.09494,0.473,NULL,46627890155,728560783,11383762,15.39),(130120,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130120,37.31,0.23,289,60182,70,NULL,NULL,'2MASX J15265357+2549277',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.723125,25.82431,0.161,NULL,59902457800,935975903,14624623,17.3),(130121,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130121,37.35,0.46,295,60183,70,NULL,NULL,'2MASX J15265374+4224569',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000141,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,231.7239583,42.41586,0.089,NULL,59977608869,937150138,14642970,17.8),(130122,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130122,38.54,0.46,510,60184,70,NULL,NULL,'2MASX J15265460+0235240',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000087,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,231.7275,2.59008,0.113,NULL,56431574569,881743352,13777239,17.8),(130123,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130123,37.87,0.33,375,60185,70,NULL,NULL,'2MASX J15265571+0311270',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000079,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.732041667,3.19072,0.093,NULL,56435956014,881811812,13778309,17.3),(130124,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130124,38,0.46,397,60186,70,NULL,NULL,'2MASX J15265611+1907343',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,231.7339583,19.12631,0.161,NULL,59445565185,928836956,14513077,18.2),(130125,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130125,37.95,0.46,388,60187,70,NULL,NULL,'2MASX J15265642+3010303',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000178,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.73525,30.17503,0.013,NULL,59913120288,936142504,14627226,17.4),(130126,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130126,38.36,0.46,470,60188,70,NULL,NULL,'SDSS J152656.96+235450.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.737333,23.91394,0.173,NULL,59420640717,928447511,14506992,18.3),(130127,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130127,36.89,0.46,239,60189,70,NULL,NULL,'2MASX J15265874+0815435',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'17.11',0.34,NULL,NULL,NULL,NULL,NULL,1,231.744833,8.26203,0.117,NULL,56420080910,881563764,13774433,17.11),(130128,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130128,35.89,0.46,151,60190,70,NULL,NULL,'2MASX J15265899+0425150',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,231.74575,4.42078,0.093,NULL,56438436673,881850573,13778915,16.1),(130129,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130129,37.01,0.46,252,60191,70,NULL,NULL,'2MASX J15265901+0827015',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000188,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,231.7457917,8.45031,0.077,NULL,56419746048,881558532,13774352,16.5),(130130,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130130,37.23,0.46,280,60192,70,NULL,NULL,'2MASX J15265959+1524446',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,231.7482917,15.41231,0.097,NULL,59560168443,930627631,14541056,17.7),(130131,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130131,37.36,0.33,296,60193,70,NULL,NULL,'2MASX J15265984+0706585',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,231.74925,7.11633,0.073,NULL,56410763537,881418180,13772159,17),(130132,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130132,37.33,0.46,292,60194,70,NULL,NULL,'2MASX J15270034+3620022',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00014,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.7514583,36.33386,0.021,NULL,60110209278,939222019,14675344,18),(130133,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130133,35.23,0.48,111,60195,70,NULL,NULL,'2MASX J15270061-1258519',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00005,NULL,'15.66',1,NULL,NULL,NULL,NULL,NULL,1,231.7525417,-12.98136,0.517,NULL,46661287522,729082617,11391915,15.66),(130134,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130134,35.98,0.23,157,60196,70,NULL,NULL,'NGC 5933',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.0002,NULL,'15.4g',0.47,'E0',NULL,NULL,NULL,NULL,1,231.7565417,48.61331,0.033,NULL,59664909485,932264210,14566628,15.4),(130135,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130135,37.36,0.33,296,60197,70,NULL,NULL,'2MASX J15270213+0710155',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,231.758917,7.17097,0.073,NULL,56410753584,881418024,13772156,17.2),(130136,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130136,35.38,0.33,119,60198,70,NULL,NULL,'UGC 09859',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000167,NULL,'14.86',0.7,'I?',NULL,NULL,NULL,NULL,1,231.7589583,26.70517,0.137,NULL,59902176046,935971500,14624554,14.86),(130137,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130137,37.03,0.46,255,60199,70,NULL,NULL,'2MASX J15270309+5611186',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'17.00',0.29,NULL,NULL,NULL,NULL,NULL,1,231.763166667,56.18842,0.021,NULL,57596028525,899937945,14061530,17),(130138,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130138,36.53,0.46,202,60200,70,NULL,NULL,'2MASX J15270376+3900232',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000172,NULL,'15.9g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,231.76575,39.0065,0.037,NULL,60097480416,939023131,14672236,15.9),(130139,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130139,37.94,0.46,387,60201,70,NULL,NULL,'2MASX J15270432+2545583',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000169,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.767917,25.76622,0.157,NULL,59902416666,935975260,14624613,17.2),(130140,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130140,36.31,0.23,183,60202,70,NULL,NULL,'2MASX J15270627+0947465',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000178,NULL,'15.9g',0.4,NULL,NULL,NULL,NULL,NULL,1,231.7762083,9.79619,0.065,NULL,59343227563,927237930,14488092,15.9),(130141,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130141,37.8,0.27,363,60203,70,NULL,NULL,'2MASX J15270629+0405221',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000087,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,231.776417,4.08939,0.093,NULL,56438499122,881851548,13778930,16.7),(130142,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130142,38.55,0.46,514,60204,70,NULL,NULL,'SDSS J152707.78-014734.6',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000179,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,231.782417,-1.79297,0.305,NULL,45422540105,709727189,11089487,18.8),(130143,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130143,36.56,0.46,205,60205,70,NULL,NULL,'2MASX J15270797+0752445',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000182,NULL,'16.4g',0.43,NULL,NULL,NULL,NULL,NULL,1,231.783333,7.87911,0.069,NULL,56411843636,881435056,13772422,16.4),(130144,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130144,37.61,0.46,333,60206,70,NULL,NULL,'2MASX J15270866+5710488',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000178,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.786083,57.18017,0.029,NULL,57591087508,899860742,14060324,17.5),(130145,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130145,38.26,0.46,449,60207,70,NULL,NULL,'2MASX J15270910+2004502',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.787833,20.08072,0.197,NULL,59445745482,928839773,14513121,17.5),(130146,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130146,36.28,0.27,181,60208,70,NULL,NULL,'2MASX J15271113+0624145',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,231.7965,6.40414,0.053,NULL,56410454082,881413345,13772083,16.1),(130147,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130147,37.19,0.46,274,60209,70,NULL,NULL,'2MASX J15271200+2103324',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.39',0.13,NULL,NULL,NULL,NULL,NULL,1,231.8000417,21.05917,0.181,NULL,59444724534,928823820,14512872,18.39),(130148,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130148,37.11,0.13,265,60210,70,NULL,NULL,'2MASX J15271256+2843313',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000067,NULL,'14.9R',0.24,NULL,NULL,NULL,NULL,NULL,1,231.802417,28.72533,0.041,NULL,59907275689,936051182,14625799,14.9),(130149,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130149,37.06,0.33,258,60211,70,NULL,NULL,'SDSS J152712.74+453616.3',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000175,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,231.803125,45.60453,0.025,NULL,59966650091,936978907,14640295,16.5),(130150,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130150,36.95,0.33,245,60212,70,NULL,NULL,'2MASX J15271343+2734503',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.805833,27.58061,0.081,NULL,59900847981,935950749,14624230,18.2),(130151,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130151,38.31,0.46,460,60213,70,NULL,NULL,'2MASX J15271349+3806439',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,231.806,38.11211,0.029,NULL,60111729871,939245779,14675715,17.3),(130152,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130152,36.95,0.33,245,60214,70,NULL,NULL,'SDSS J152714.62+273612.5',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.0g',0.41,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.810916667,27.6035,0.061,NULL,59900849735,935950777,14624230,16),(130153,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130153,35.96,0.46,155,60215,70,NULL,NULL,'IC 4547',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000067,NULL,'15.1g',0.59,'E',NULL,NULL,NULL,NULL,1,231.8127917,28.78897,0.041,NULL,59907263231,936050987,14625796,15.1),(130154,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130154,37.57,0.46,327,60216,70,NULL,NULL,'2MASX J15271590+2200414',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.816083333,22.01167,0.169,NULL,59418617275,928415894,14506498,17.4),(130155,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130155,38.02,0.23,403,60217,70,NULL,NULL,'SDSS J152715.91+025200.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000083,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.816333,2.86683,0.113,NULL,56431657061,881744641,13777260,18.4),(130156,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130156,38.18,0.46,432,60218,70,NULL,NULL,'2MASX J15271639+1823194',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,231.818375,18.38867,0.173,NULL,59436760020,928699375,14510927,18.3),(130157,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130157,37.48,0.46,314,60219,70,NULL,NULL,'2MASX J15271650+0650525',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,231.818833333,6.84794,0.077,NULL,56411185822,881424778,13772262,16.8),(130158,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130158,35.38,0.33,119,60220,70,NULL,NULL,'2MASX J15271824+2640283',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000087,NULL,'16.34',0.22,NULL,NULL,NULL,NULL,NULL,1,231.8260417,26.6745,0.137,NULL,59902178031,935971531,14624555,16.34),(130159,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130159,35.31,0.2,115,60221,74.4,NULL,NULL,'UGC 09860',NULL,'2013AJ....146...86T',2013,1,1.22,NULL,'G',0.000033,NULL,'15.8g',0.29,'Scd:',NULL,NULL,NULL,NULL,1,231.8277917,30.98258,0.029,NULL,59915357606,936177462,14627772,15.8),(130160,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130160,35.39,0.49,119,60221,75,NULL,'IR','UGC 09860',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130161,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130161,37.46,0.46,311,60222,70,NULL,NULL,'2MASX J15272017+1618003',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.834167,16.30017,0.113,NULL,59435288554,928676383,14510568,17),(130162,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130162,37.74,0.46,353,60223,70,NULL,NULL,'2MASX J15272222+3214378',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000143,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.84275,32.24383,0.025,NULL,59912169460,936127647,14626994,18.1),(130163,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130163,36.87,0.46,237,60224,70,NULL,NULL,'2MASX J15272259+1242313',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.84425,12.70864,0.105,NULL,59562757689,930668088,14541688,17.5),(130164,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130164,38.1,0.46,417,60225,70,NULL,NULL,'2MASX J15272460+4227308',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,231.852667,42.45858,0.089,NULL,59977612412,937150193,14642971,18.5),(130165,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130165,38.02,0.46,402,60226,70,NULL,NULL,'SDSS J152724.67+060444.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.852833,6.07889,0.057,NULL,56428088878,881688888,13776388,18.5),(130166,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130166,37.87,0.33,375,60227,70,NULL,NULL,'SDSS J152724.88+031401.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00008,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,231.8537083,3.23386,0.093,NULL,56436170462,881815163,13778361,18),(130167,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130167,37.25,0.46,281,60228,70,NULL,NULL,'2MASX J15272600+0301188',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000086,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,231.858417,3.02189,0.109,NULL,56431633874,881744279,13777254,16.9),(130168,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130168,38.02,0.23,403,60229,70,NULL,NULL,'2MASX J15272607+0302358',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000095,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,231.85875,3.04319,0.109,NULL,56431633494,881744273,13777254,16.5),(130169,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130169,37.61,0.12,333,60230,70,NULL,NULL,'2MASX J15272704+5247219',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000172,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.8622083,52.78961,0.029,NULL,59674125098,932408204,14568878,17),(130170,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130170,38.02,0.23,403,60231,70,NULL,NULL,'SDSS J152726.93+025943.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000073,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,231.86225,2.99556,0.113,NULL,56431635040,881744297,13777254,18.5),(130171,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130171,36.28,0.27,181,60232,70,NULL,NULL,'2MASX J15272711+0606338',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,231.8629583,6.10925,0.057,NULL,56428085961,881688843,13776388,16.6),(130172,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130172,37.11,0.13,265,60233,70,NULL,NULL,'2MASX J15272785+2842016',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000087,NULL,'15.7g',0.41,NULL,NULL,NULL,NULL,NULL,1,231.866125,28.70056,0.041,NULL,59907265968,936051030,14625797,15.7),(130173,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130173,37.35,0.33,295,60234,70,NULL,NULL,'2MASX J15272868+4921059',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000192,NULL,'16.1g',0.33,'E0',NULL,NULL,NULL,NULL,1,231.86975,49.35189,0.053,NULL,59667826654,932309791,14567340,16.1),(130174,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130174,38.07,0.46,410,60235,70,NULL,NULL,'2MASX J15272885+1045329',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,231.87025,10.759,0.085,NULL,59344612912,927259576,14488430,17.7),(130175,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130175,36.56,0.46,205,60236,70,NULL,NULL,'2MASX J15272933+3046419',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000164,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,231.8722083,30.77833,0.041,NULL,59915341189,936177206,14627768,16.6),(130176,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130176,35.86,0.33,149,60237,70,NULL,NULL,'2MASX J15272935+2131245',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.17',0.25,NULL,NULL,NULL,NULL,NULL,1,231.872417,21.52353,0.165,NULL,59443823075,928809735,14512652,17.17),(130177,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130177,38.24,0.46,444,60238,70,NULL,NULL,'2MASX J15273107+1848135',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000186,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,231.879583,18.80386,0.181,NULL,59445352910,928833639,14513025,17.3),(130178,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130178,37.11,0.13,265,60239,70,NULL,NULL,'2MASX J15273131+2852456',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.0g',0.25,'E',NULL,NULL,NULL,NULL,1,231.880375,28.87944,0.041,NULL,59905194270,936018660,14625291,17),(130179,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130179,38.02,0.23,403,60240,70,NULL,NULL,'SDSS J152731.79+030258.9',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000075,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,231.8825,3.04972,0.109,NULL,56431634160,881744283,13777254,18.8),(130180,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130180,37.11,0.13,265,60241,70,NULL,NULL,'CGCG 165-060',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'15.7',0.5,NULL,NULL,NULL,NULL,NULL,1,231.883125,28.39528,0.041,NULL,59907461062,936054079,14625844,15.7),(130181,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130181,38.06,0.46,409,60242,70,NULL,NULL,'2MASX J15273314-0137445',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00018,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,231.888083,-1.62906,0.265,NULL,45404975132,709452736,11085199,17.9),(130182,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130182,38.1,0.46,416,60243,70,NULL,NULL,'2MASX J15273429-0211405',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,231.893,-2.19472,0.349,NULL,45422687490,709729492,11089523,18.2),(130183,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130183,36.31,0.23,183,60244,70,NULL,NULL,'2MASX J15273443+0933409',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000184,NULL,'16.1g',0.39,NULL,NULL,NULL,NULL,NULL,1,231.8935417,9.56142,0.069,NULL,56406198041,881346844,13771044,16.1),(130184,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130184,37.58,0.46,327,60245,70,NULL,NULL,'2MASX J15273527+3223370',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.896958333,32.39353,0.057,NULL,59912069773,936126090,14626970,17.4),(130185,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130185,36.55,0.46,204,60246,70,NULL,NULL,'2MASX J15273564+1834205',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,231.898625,18.57239,0.177,NULL,59435662235,928682222,14510659,17.4),(130186,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130186,36.83,0.46,232,60247,70,NULL,NULL,'VII Zw 604',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000162,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,231.898667,57.85725,0,NULL,57591639028,899869359,14060458,16.7),(130187,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130187,37.28,0.46,286,60248,70,NULL,NULL,'2MASX J15273705+1129299',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,231.9045,11.49167,0.077,NULL,59344822609,927262853,14488482,17.1),(130188,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130188,37.31,0.23,289,60249,70,NULL,NULL,'2MASX J15273777+2550057',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000177,NULL,'16.0g',0.43,NULL,NULL,NULL,NULL,NULL,1,231.907333,25.83492,0.157,NULL,59902464518,935976008,14624625,16),(130189,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130189,37.11,0.13,265,60250,70,NULL,NULL,'2MASX J15273947+2846527',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.0001,NULL,'18.75',0.15,NULL,NULL,NULL,NULL,NULL,1,231.9145417,28.78117,0.041,NULL,59907272531,936051133,14625798,18.75),(130190,'Tully est','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130190,32.87,0.8,37.5,60251,75,NULL,NULL,'ESO 042- G 007',NULL,'1988NBGC.C....0000T',1988,1,2.6,NULL,'G',0.000013,NULL,'13.8b',2.5,'SB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,231.915667,-73.94444,0.501,NULL,44110962199,689233784,10769277,13.8),(130191,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130191,36.96,0.46,247,60252,70,NULL,NULL,'SDSS J152741.60+064812.7',NULL,'2015arXiv151105856S',2015,1,0.11,NULL,'G',NULL,NULL,'18.2g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.923333,6.80356,0.077,NULL,56411176652,881424635,13772259,18.2),(130192,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130192,35.86,0.33,149,60253,70,NULL,NULL,'2MASX J15274168+2132434',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,231.9235417,21.54533,0.165,NULL,59443817389,928809646,14512650,16.7),(130193,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130193,37.31,0.23,289,60254,70,NULL,NULL,'2MASX J15274325+2551527',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.930291667,25.86464,0.177,NULL,59902466433,935976038,14624625,17.8),(130194,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130194,37.89,0.23,379,60255,70,NULL,NULL,'SDSS J152743.64+033807.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000068,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,231.931875,3.63531,0.093,NULL,56436075397,881813678,13778338,18.5),(130195,'BCG','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130195,37.34,0.35,276,60256,60,NULL,'ABELL 2079, BCG','UGC 09861 NED02',0.0657,'1980ApJ...241..486H',1980,1,0.15,NULL,'G',0.000067,NULL,'13.3R',0.15,'E','Pair member (points to parent)',NULL,NULL,NULL,1,231.938167,28.92889,0.041,NULL,59905184831,936018512,14625289,13.3),(130196,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130196,37.98,0.46,395,60257,70,NULL,NULL,'SDSS J152745.21+191202.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000149,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.938417,19.20069,0.173,NULL,59445583842,928837247,14513081,18.5),(130197,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130197,37.26,0.23,284,60258,70,NULL,NULL,'2MASX J15274583+0253508',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000062,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.9410417,2.8975,0.113,NULL,56431665141,881744767,13777261,17),(130198,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130198,38.27,0.46,450,60259,70,NULL,NULL,'2MASX J15274682+1857157',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,231.945083,18.95444,0.153,NULL,59445372185,928833940,14513030,18.2),(130199,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130199,37.29,0.46,288,60260,70,NULL,NULL,'2MASX J15274783+0647029',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,231.949167,6.78417,0.077,NULL,56411169902,881424529,13772258,16.4),(130200,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130200,36.92,0.33,242,60261,70,NULL,NULL,'2MASX J15274864+1759129',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.952625,17.98708,0.153,NULL,59436870550,928701102,14510954,17.5),(130201,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130201,36.31,0.23,183,60262,70,NULL,NULL,'2MASX J15274870+0945539',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,231.952875,9.76511,0.065,NULL,59343184453,927237257,14488082,16.9),(130202,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130202,37.9,0.17,380,60263,70,NULL,NULL,'SDSS J152748.86+045455.5',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.953625,4.91542,0.093,NULL,56437275930,881832436,13778631,18),(130203,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130203,37.89,0.23,379,60264,70,NULL,NULL,'2MASX J15274899+0331328',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000091,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,231.954083333,3.52581,0.093,NULL,56436109918,881814217,13778347,18.1),(130204,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130204,36.15,0.33,170,60265,70,NULL,NULL,'CGCG 049-167',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000083,NULL,'15.7',0.43,'AGN',NULL,NULL,NULL,NULL,1,231.954917,4.85678,0.093,NULL,56437271797,881832371,13778630,15.7),(130205,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130205,36.92,0.33,242,60266,70,NULL,NULL,'2MASX J15274930+1800177',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,231.955458333,18.005,0.153,NULL,59436869934,928701092,14510954,17.1),(130206,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130206,37.69,0.23,346,60267,70,NULL,NULL,'2MASX J15274946+0124448',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,231.956166667,1.41239,0.073,NULL,56400063691,881250995,13769546,NULL),(130207,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130207,37.44,0.46,308,60268,70,NULL,NULL,'2MASX J15274966+0338568',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000092,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,231.956833,3.64917,0.093,NULL,56436075980,881813687,13778338,16.8),(130208,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130208,37.44,0.27,307,60269,70,NULL,NULL,'2MASX J15275007+1009029',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000189,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,231.9585417,10.15078,0.073,NULL,59343540814,927242825,14488169,16.5),(130209,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130209,37.31,0.23,289,60270,70,NULL,NULL,'2MASX J15275051+2540317',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000183,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,231.960333333,25.67544,0.157,NULL,59902523296,935976926,14624639,16.9),(130210,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130210,37.53,0.21,320,60271,70,NULL,NULL,'2MASX J15275177+3030391',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.965833,30.511,0.045,NULL,59913236200,936144315,14627254,17.4),(130211,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130211,37.29,0.46,288,60272,70,NULL,NULL,'2MASX J15275215+5027209',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000194,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,231.96725,50.45569,0.037,NULL,59665386232,932271659,14566744,16.3),(130212,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130212,37.9,0.17,380,60273,70,NULL,NULL,'2MASX J15275240+0453408',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,231.968375,4.89469,0.093,NULL,56437276247,881832441,13778631,NULL),(130213,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130213,37.45,0.33,310,60274,70,NULL,NULL,'SDSS J152752.40+075236.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'18.1g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.968375,7.87694,0.069,NULL,56420002961,881562546,13774414,18.1),(130214,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130214,37.79,0.46,361,60275,70,NULL,NULL,'SDSS J152754.34+263302.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.7g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.9764583,26.55064,0.157,NULL,59902882355,935982536,14624727,17.7),(130215,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130215,37.46,0.46,311,60276,70,NULL,NULL,'2MASX J15275572+0203408',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,231.982417,2.06133,0.077,NULL,56431849211,881747643,13777306,17.4),(130216,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130216,37.38,0.33,300,60277,70,NULL,NULL,'2MASX J15275619+4657368',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000181,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,231.984291667,46.96028,0.013,NULL,59685191045,932581110,14571579,16.9),(130217,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130217,37.9,0.17,380,60278,70,NULL,NULL,'SDSS J152756.84+050052.9',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'16.0g',0.4,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.986833,5.01469,0.101,NULL,56437487249,881835738,13778683,16),(130218,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130218,37.89,0.23,379,60279,70,NULL,NULL,'2MASX J15275707+0322268',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000101,NULL,'15.9g',0.44,'BrClG',NULL,NULL,NULL,NULL,1,231.987625,3.37414,0.093,NULL,56436132281,881814566,13778352,15.9),(130219,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130219,37.89,0.23,379,60280,70,NULL,NULL,'2MASX J15275720+0326518',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000107,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,231.98825,3.44761,0.093,NULL,56436099345,881814052,13778344,16.4),(130220,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130220,37.9,0.17,380,60281,70,NULL,NULL,'2MASX J15275735+0450398',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,231.9890417,4.84447,0.093,NULL,56437152644,881830510,13778601,18.4),(130221,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130221,37.9,0.17,380,60282,70,NULL,NULL,'2MASX J15275809+0508398',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,231.991916667,5.14453,0.101,NULL,56437497497,881835898,13778685,18),(130222,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130222,37.9,0.17,380,60283,70,NULL,NULL,'SDSS J152758.99+050349.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'17.9g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.995833,5.06386,0.101,NULL,56437486190,881835721,13778683,17.9),(130223,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130223,34.1,0.56,66,60284,NULL,NULL,NULL,'ESO 329- G 004',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000033,NULL,'13.19',0.6,'Sb',NULL,NULL,NULL,NULL,1,232.0009583,-40.3535,0.381,NULL,47062049593,735344524,11489758,13.19),(130224,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130224,34.14,0.2,67.3,60284,74.4,NULL,NULL,'ESO 329- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130225,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130225,34.3,0.51,72.4,60284,NULL,NULL,'Malmquist cor.','ESO 329- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130226,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130226,37.45,0.33,310,60285,70,NULL,NULL,'2MASX J15280053+0752488',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00014,NULL,'15.6g',0.45,NULL,NULL,NULL,NULL,NULL,1,232.00225,7.88033,0.069,NULL,56419970304,881562036,13774406,15.6),(130227,'IRAS','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130227,30.3,0.8,11.5,60286,75,NULL,'A82, H','NGC 5949',NULL,'1997ApJS..109..333W',1997,1,2.27,'The 2MASS position is 5 arcsec northwest of the center of the optical bulge.','G',0.000003,NULL,'12.5g',0.94,'SA(r)bc?','Isolated galaxy',NULL,NULL,NULL,1,232.0027917,64.76319,0.065,NULL,57958441009,905600640,14150010,12.5),(130228,'IRAS','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130228,30.41,0.8,12.1,60286,75,NULL,'CF, r','NGC 5949',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130229,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130229,30.09,0.43,10.4,60286,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5949',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130230,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130230,30.13,0.39,10.6,60286,73,NULL,'opt','NGC 5949',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130231,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130231,30.19,0.4,10.9,60286,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5949',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130232,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130232,30.24,0.4,11.2,60286,75,NULL,'B','NGC 5949',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130233,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130233,30.28,0.43,11.4,60286,75,NULL,'3.6 micron, color corrected','NGC 5949',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130234,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130234,30.46,0.47,12.4,60286,75,NULL,'A82, H, inv','NGC 5949',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130235,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130235,30.48,0.2,12.5,60286,74.4,NULL,NULL,'NGC 5949',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130236,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130236,30.56,0.47,12.9,60286,75,NULL,'A82, H, raw','NGC 5949',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130237,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130237,30.77,0.36,14.3,60286,NULL,NULL,NULL,'NGC 5949',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130238,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130238,30.81,0.34,14.5,60286,NULL,NULL,NULL,'NGC 5949',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130239,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130239,30.83,0.47,14.7,60286,75,NULL,'A82, H, cor','NGC 5949',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130240,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130240,30.89,0.33,15.1,60286,NULL,NULL,'Malmquist cor.','NGC 5949',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130241,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130241,31.27,0.38,18,60286,75,NULL,'CF, r, raw','NGC 5949',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130242,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130242,31.28,0.38,18.1,60286,75,NULL,'CF, r, inv','NGC 5949',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130243,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130243,31.46,0.38,19.6,60286,75,NULL,'CF, r, cor','NGC 5949',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130244,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130244,37.11,0.13,265,60287,70,NULL,NULL,'SDSS J152801.26+285649.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.0052917,28.94719,0.037,NULL,59905210643,936018916,14625295,18.1),(130245,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130245,37.69,0.23,346,60288,70,NULL,NULL,'2MASX J15280126+0129338',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'16.52',0.4,NULL,NULL,NULL,NULL,NULL,1,232.005375,1.49264,0.073,NULL,56400053729,881250839,13769544,16.52),(130246,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130246,37.35,0.33,295,60289,70,NULL,NULL,'2MASX J15280166+4922172',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000173,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,232.006875,49.37136,0.053,NULL,59667845126,932310080,14567345,16.7),(130247,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130247,34.57,0.58,81.9,60290,NULL,NULL,NULL,'ESO 514- G 019',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'16.41',0.3,'S...',NULL,NULL,NULL,NULL,1,232.010417,-26.50189,0.465,NULL,47139696327,736557755,11508714,16.41),(130248,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130248,34.59,0.58,82.6,60290,NULL,NULL,'Malmquist cor.','ESO 514- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130249,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130249,34.61,0.2,83.6,60290,74.4,NULL,NULL,'ESO 514- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130250,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130250,37.11,0.13,265,60291,70,NULL,NULL,'2MASX J15280254+2856386',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000067,NULL,'16.3g',0.32,'E',NULL,NULL,NULL,NULL,1,232.0107083,28.94411,0.037,NULL,59905211687,936018932,14625295,16.3),(130251,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130251,38.15,0.46,427,60292,70,NULL,NULL,'2MASX J15280333+4248493',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000207,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,232.013916667,42.81364,0.085,NULL,59977114539,937142414,14642850,16.6),(130252,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130252,37.06,0.33,258,60293,70,NULL,NULL,'2MASX J15280448+4538283',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.018667,45.64128,0,NULL,59966704750,936979761,14640308,17.1),(130253,'BCG','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130253,37.34,0.35,276,60294,60,NULL,NULL,'ABELL 2079',0.0657,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',0.000731,NULL,NULL,NULL,'II-III:[BM]',NULL,NULL,NULL,NULL,1,232.0197083,28.87772,0.041,NULL,59905203867,936018810,14625293,NULL),(130254,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130254,35.97,0.46,156,60295,70,NULL,NULL,'2MASX J15280499+0544278',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',NULL,NULL,'15.6g',0.43,NULL,NULL,NULL,NULL,NULL,1,232.020625,5.74117,0.065,NULL,56436480087,881820001,13778437,15.6),(130255,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130255,37.26,0.23,284,60296,70,NULL,NULL,'2MASX J15280514+0254038',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000088,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,232.0215417,2.90089,0.109,NULL,56432139723,881752183,13777377,16.8),(130256,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130256,37.38,0.33,300,60297,70,NULL,NULL,'2MASX J15280625+4656413',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000147,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,232.026083333,46.94486,0.013,NULL,59685181990,932580968,14571577,17.6),(130257,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130257,37.17,0.46,271,60298,70,NULL,NULL,'2MASX J15280663+2921386',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.027583,29.36086,0.045,NULL,59912636769,936134949,14627108,17.7),(130258,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130258,37.33,0.46,293,60299,70,NULL,NULL,'2MASX J15280798+5508408',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000172,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,232.033375,55.14456,0.037,NULL,57595056778,899922762,14061293,16.9),(130259,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130259,36.31,0.23,183,60300,70,NULL,NULL,'2MASX J15281016+0952198',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000185,NULL,'15.9g',0.39,NULL,NULL,NULL,NULL,NULL,1,232.042375,9.87228,0.097,NULL,59343178548,927237164,14488080,15.9),(130260,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130260,38.03,0.46,404,60301,70,NULL,NULL,'2MASX J15281042+0551108',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.043417,5.85303,0.065,NULL,56436485187,881820081,13778438,17.6),(130261,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130261,37.26,0.23,284,60302,70,NULL,NULL,'2MASX J15281109+0256578',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00008,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.046291667,2.94939,0.109,NULL,56432138287,881752160,13777377,17.8),(130262,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130262,37.73,0.46,352,60303,70,NULL,NULL,'2MASX J15281118+0350488',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000089,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,232.0464583,3.84697,0.097,NULL,56435751803,881808621,13778259,17.3),(130263,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130263,38.27,0.46,452,60304,70,NULL,NULL,'SDSS J152812.82-000929.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00007,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.0534583,-0.15822,0.225,NULL,45406754265,709480535,11085633,18),(130264,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130264,35.65,0.46,135,60305,70,NULL,NULL,'MRK 0855',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'15.5',0.3,'Compact',NULL,NULL,NULL,NULL,1,232.075166667,15.38503,0.097,NULL,59427041483,928547523,14508555,15.5),(130265,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130265,35.09,NULL,104,60306,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1906',NULL,'2010Ap&SS.325..163P',2010,1,0.95,NULL,'G',0.000017,NULL,'16.9g',0.11,'Sd',NULL,NULL,NULL,NULL,1,232.078625,49.121,0.045,NULL,59664338542,932255289,14566488,16.9),(130266,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130266,35.11,NULL,105,60306,NULL,NULL,'Dipole + Quadrupole','FGC 1906',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130267,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130267,35.12,NULL,106,60306,NULL,NULL,'Dipole','FGC 1906',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130268,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130268,35.13,NULL,106,60306,NULL,NULL,NULL,'FGC 1906',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130269,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130269,37.11,0.13,265,60307,70,NULL,NULL,'2MASX J15281930+2858126',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.080375,28.97031,0.037,NULL,59905207142,936018861,14625294,17.4),(130270,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130270,37.26,0.23,284,60308,70,NULL,NULL,'2MASX J15282113+0300109',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000081,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.088125,3.00303,0.109,NULL,56432135723,881752120,13777376,16.8),(130271,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130271,38.13,0.27,423,60309,70,NULL,NULL,'2MASX J15282375+3030276',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.098916667,30.50781,0.045,NULL,59913194566,936143665,14627244,18),(130272,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130272,37.22,0.46,278,60310,70,NULL,NULL,'2MASX J15282402+5450149',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,232.100166667,54.83756,0.041,NULL,57585845626,899778837,14059044,17.4),(130273,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130273,37.61,0.12,333,60311,70,NULL,NULL,'2MASX J15282541+5249342',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000195,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,232.1060417,52.82617,0.029,NULL,59674098629,932407791,14568871,16.4),(130274,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130274,37.09,0.46,262,60312,70,NULL,NULL,'2MASX J15282586+3215366',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000167,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.10775,32.26025,0.061,NULL,59912211143,936128299,14627004,16.8),(130275,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130275,38.13,0.27,423,60313,70,NULL,NULL,'2MASX J15282592+3031147',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000167,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,232.1080417,30.52081,0.045,NULL,59913194156,936143658,14627244,17.1),(130276,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130276,37.11,0.13,265,60314,70,NULL,NULL,'2MASX J15282650+2841096',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000123,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.110583333,28.68589,0.041,NULL,59907254877,936050857,14625794,17.5),(130277,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130277,37.53,0.21,320,60315,70,NULL,NULL,'2MASX J15282737+3034174',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,232.113833,30.57164,0.045,NULL,59913200667,936143760,14627246,17.3),(130278,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130278,36.68,0.46,216,60316,70,NULL,NULL,'2MASX J15283001+1428150',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,232.125041667,14.47097,0.125,NULL,59560812685,930637698,14541214,17.1),(130279,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130279,37.53,0.21,320,60317,70,NULL,NULL,'2MASX J15283008+3021185',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000188,NULL,'16.0g',0.47,NULL,NULL,NULL,NULL,NULL,1,232.12525,30.35511,0.045,NULL,59913189161,936143580,14627243,16),(130280,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130280,37.17,0.46,272,60318,70,NULL,NULL,'2MASX J15283034+3056035',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00014,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.126417,30.93417,0.029,NULL,59915194863,936174919,14627733,17.1),(130281,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130281,38.1,0.46,417,60319,70,NULL,NULL,'2MASX J15283063+0558399',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.1277083,5.97783,0.057,NULL,56436464191,881819752,13778433,17.9),(130282,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130282,38.13,0.27,423,60320,70,NULL,NULL,'2MASX J15283125+3032355',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,232.130083333,30.54331,0.045,NULL,59913205689,936143838,14627247,18.2),(130283,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130283,37.89,0.46,379,60321,70,NULL,NULL,'2MASX J15283145+1705280',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,232.131208333,17.09119,0.117,NULL,59436590537,928696727,14510886,17),(130284,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130284,37.88,0.46,377,60322,70,NULL,NULL,'2MASX J15283155+5850379',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000199,NULL,'16.0g',0.43,'S0',NULL,NULL,NULL,NULL,1,232.1314583,58.84394,0.021,NULL,57717968857,901843263,14091300,16),(130285,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130285,37.47,0.23,312,60323,70,NULL,NULL,'2MASX J15283216+2818174',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.48',0.17,NULL,NULL,NULL,NULL,NULL,1,232.1340417,28.30492,0.041,NULL,59900142998,935939734,14624058,18.48),(130286,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130286,37.11,0.13,265,60324,70,NULL,NULL,'2MASX J15283150+2900165',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000153,NULL,'15.7g',0.4,NULL,NULL,NULL,NULL,NULL,1,232.137,29.0025,0.037,NULL,59905204969,936018827,14625294,15.7),(130287,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130287,37.61,0.12,333,60325,70,NULL,NULL,'SDSS J152832.99+525139.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,232.1375,52.86103,0.029,NULL,59674158234,932408722,14568886,18.4),(130288,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130288,37.38,0.33,299,60326,70,NULL,NULL,'2MASX J15283335+0710269',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,232.139125,7.17408,0.101,NULL,56418224335,881534755,13773980,16.3),(130289,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130289,37.38,0.33,299,60327,70,NULL,NULL,'2MASX J15283369+0713269',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,232.140375,7.22428,0.101,NULL,56418193873,881534279,13773973,17.2),(130290,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130290,37.48,0.33,313,60328,70,NULL,NULL,'2MASX J15283529+3433446',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,232.146917,34.56242,0.049,NULL,59884460852,935694700,14620229,17),(130291,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130291,36.44,0.46,195,60329,70,NULL,NULL,'2MASX J15283524+0440349',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,232.147,4.67636,0.093,NULL,56437196976,881831202,13778612,16.3),(130292,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130292,37.54,0.46,323,60330,70,NULL,NULL,'2MASX J15283541+5059072',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000156,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,232.147583333,50.98531,0.041,NULL,59672905254,932389144,14568580,17.3),(130293,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130293,38.01,0.33,401,60331,70,NULL,NULL,'2MASX J15283565+0007079',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000079,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,232.148667,0.11894,0.225,NULL,56398195875,881221810,13769090,18.2),(130294,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130294,37.47,0.23,312,60332,70,NULL,NULL,'2MASX J15283799+2819594',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'18.03',0.18,NULL,NULL,NULL,NULL,NULL,1,232.158375,28.33328,0.041,NULL,59900143307,935939739,14624058,18.03),(130295,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130295,37.75,0.19,354,60333,70,NULL,NULL,'2MASX J15283867+0145019',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,232.161125,1.75042,0.077,NULL,56399223441,881237866,13769341,18.1),(130296,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130296,38.08,0.46,413,60334,70,NULL,NULL,'2MASX J15283903+0300529',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000082,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.1627083,3.01464,0.109,NULL,56431283432,881738803,13777168,18.4),(130297,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130297,37.87,0.15,376,60335,70,NULL,NULL,'2MASX J15284000-0008074',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000093,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.166583333,-0.13539,0.217,NULL,45405708017,709464187,11085377,17.4),(130298,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130298,36.63,0.46,212,60336,70,NULL,NULL,'2MASX J15284174+0510549',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.174041667,5.18206,0.109,NULL,56437366210,881833847,13778653,17.2),(130299,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130299,37.69,0.46,345,60337,70,NULL,NULL,'2MASX J15284232+0015409',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,'FoF','17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,232.176333,0.26139,0.225,NULL,56400309632,881254838,13769606,17.4),(130300,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130300,38.81,0.46,578,60338,70,NULL,NULL,'SDSS J152843.08+062603.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.6g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.1795417,6.43425,0.073,NULL,56417632173,881525502,13773835,18.6),(130301,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130301,36.21,0.47,175,60339,NULL,NULL,'H','CGCG 049-171 NED01',NULL,'2007A&A...465...71T',2007,1,1.05,NULL,'G',0.000011,NULL,'15.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,232.1832917,7.38797,0.097,NULL,56418365934,881536967,13774015,15.1),(130302,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130302,36.29,0.4,181,60339,NULL,NULL,'mean','CGCG 049-171 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130303,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130303,38.04,0.23,405,60340,70,NULL,NULL,'2MASX J15284491+3044546',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.18725,30.74842,0.041,NULL,59915230589,936175477,14627741,17.9),(130304,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130304,37.35,0.46,295,60341,70,NULL,NULL,'VII Zw 605',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.188875,57.60239,0.005,NULL,57591978342,899874661,14060541,17.2),(130305,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130305,36.94,0.33,245,60342,70,NULL,NULL,'2MASX J15284605+4549245',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,232.1919583,45.8235,0,NULL,59966735935,936980248,14640316,17.6),(130306,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130306,36.16,0.2,171,60343,74.4,NULL,NULL,'CGCG 135-059',NULL,'2013AJ....146...86T',2013,1,0.99,NULL,'G',0.000178,NULL,'15.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,232.197,25.74781,0.157,NULL,59902370801,935974543,14624602,15.7),(130307,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130307,37.53,0.21,320,60344,70,NULL,NULL,'2MASX J15284787+3010017',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000179,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,232.199625,30.16703,0.045,NULL,59913506506,936148539,14627320,16.7),(130308,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130308,37.48,0.33,313,60345,70,NULL,NULL,'2MASX J15284823+3437577',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.0002,NULL,'16.1g',0.29,'S0^-',NULL,NULL,NULL,NULL,1,232.201167,34.63278,0.049,NULL,59884678635,935698103,14620282,16.1),(130309,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130309,37.66,0.46,341,60346,70,NULL,NULL,'2MASX J15284866+2213063',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000167,NULL,'18.52',0.14,NULL,NULL,NULL,NULL,NULL,1,232.202791667,22.21853,0.157,NULL,59451330091,928927032,14514484,18.52),(130310,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130310,34.95,0.47,97.7,60347,70,NULL,NULL,'2MASX J15284955-2112248',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000107,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,232.2064583,-21.20694,0.473,NULL,46625052302,728516442,11383069,14),(130311,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130311,37.61,0.12,333,60348,70,NULL,NULL,'2MASX J15284976+5251589',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00018,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,232.207083,52.86631,0.029,NULL,59674162860,932408794,14568887,17.2),(130312,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130312,37.9,0.17,380,60349,70,NULL,NULL,'2MASX J15285006+0513296',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,232.2085417,5.22489,0.109,NULL,56437320180,881833127,13778642,17),(130313,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130313,35.95,0.46,155,60350,70,NULL,NULL,'CGCG 021-101',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000108,NULL,'15.4g',0.54,'E0',NULL,NULL,NULL,NULL,1,232.209291667,0.77722,0.113,NULL,56400561125,881258767,13769668,15.4),(130314,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130314,37.53,0.21,320,60351,70,NULL,NULL,'2MASX J15285033+3012447',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000181,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.209708333,30.21233,0.045,NULL,59913503291,936148488,14627320,17.2),(130315,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130315,37.24,0.46,281,60352,70,NULL,NULL,'2MASX J15285103+0312556',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.21275,3.21531,0.105,NULL,56436268407,881816693,13778385,16.8),(130316,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130316,38.01,0.33,401,60353,70,NULL,NULL,'2MASX J15285299+0009326',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.22,'BrClG',NULL,NULL,NULL,NULL,1,232.2207083,0.15911,0.225,NULL,56398240415,881222506,13769101,17.3),(130317,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130317,38.04,0.23,405,60354,70,NULL,NULL,'2MASX J15285304+3050367',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000151,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.221,30.84353,0.029,NULL,59915239074,936175610,14627743,17.7),(130318,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130318,36.95,0.46,246,60355,70,NULL,NULL,'2MASX J15285322-0209211',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.2217083,-2.15589,0.305,NULL,45404995090,709453048,11085203,17.3),(130319,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130319,36.94,0.33,245,60356,70,NULL,NULL,'2MASX J15285351+4548216',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,232.2230417,45.80611,0,NULL,59966726885,936980107,14640314,17.2),(130320,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130320,37.01,0.46,253,60357,70,NULL,NULL,'2MASX J15285375+1458061',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,232.224,14.96828,0.101,NULL,59427125886,928548841,14508575,NULL),(130321,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130321,36.96,0.46,247,60358,70,NULL,NULL,'2MASX J15285377+5910119',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000196,NULL,'16.0g',0.4,'E0',NULL,NULL,NULL,NULL,1,232.224,59.16994,0.017,NULL,57772380858,902693450,14104585,16),(130322,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130322,37.87,0.15,376,60359,70,NULL,NULL,'2MASX J15285396-0018221',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000081,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.224666667,-0.30617,0.253,NULL,45406796657,709481197,11085643,18.1),(130323,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130323,37.69,0.23,346,60360,70,NULL,NULL,'SDSS J152853.94+013203.4',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.2247917,1.53431,0.093,NULL,56399073878,881235529,13769305,18),(130324,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130324,37.83,0.46,368,60361,70,NULL,NULL,'2MASX J15285403+1412071',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.2252083,14.20206,0.121,NULL,59560943578,930639743,14541245,17.1),(130325,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130325,37.69,0.23,346,60362,70,NULL,NULL,'2MASX J15285452+0127516',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,232.22725,1.46447,0.093,NULL,56400211551,881253305,13769582,16.9),(130326,'Tully est','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130326,31.4,0.8,19.1,60363,75,NULL,NULL,'ESO 274- G 016',NULL,'1988NBGC.C....0000T',1988,1,1.8,NULL,'G',0.000013,NULL,'15.06',0.9,'IB(s)m',NULL,NULL,NULL,NULL,1,232.230167,-42.78217,0.617,NULL,47074080633,735532509,11492695,15.06),(130327,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130327,37.62,0.33,335,60364,70,NULL,NULL,'2MASX J15285562+0625466',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.231875,6.42956,0.073,NULL,56417627050,881525422,13773834,17.4),(130328,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130328,38.04,0.23,405,60365,70,NULL,NULL,'2MASX J15285615+3045527',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000124,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,232.233833,30.76475,0.041,NULL,59915228843,936175450,14627741,18.7),(130329,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130329,37.62,0.33,335,60366,70,NULL,NULL,'2MASX J15285615+0627066',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.234083,6.45175,0.073,NULL,56417628035,881525438,13773834,16.3),(130330,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130330,37.47,0.23,312,60367,70,NULL,NULL,'SDSS J152856.42+281722.4',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.5g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.235125,28.28956,0.065,NULL,59900150263,935939847,14624060,16.5),(130331,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130331,37.47,0.23,312,60368,70,NULL,NULL,'2MASX J15285639+2817223',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.97',0.18,NULL,NULL,NULL,NULL,NULL,1,232.241916667,28.28794,0.065,NULL,59900150101,935939845,14624060,17.97),(130332,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130332,37.75,0.19,354,60369,70,NULL,NULL,'SDSS J152858.53+013048.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.243875,1.51342,0.093,NULL,56400208099,881253251,13769582,18.1),(130333,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130333,37.53,0.63,321,60370,70,NULL,NULL,'2MASX J15285858-1335558',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.10',NULL,NULL,NULL,NULL,NULL,NULL,1,232.2440417,-13.59878,0.577,NULL,46661092818,729079575,11391868,16.1),(130334,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130334,38.51,0.46,503,60371,70,NULL,NULL,'2MASX J15285900+3721292',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.2457917,37.35803,0.045,NULL,60110066767,939219793,14675309,18),(130335,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130335,37.34,0.46,294,60372,70,NULL,NULL,'2MASX J15285913+5313070',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000175,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,232.24625,53.21853,0.033,NULL,59674051239,932407050,14568860,16.7),(130336,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130336,37.75,0.19,354,60373,70,NULL,NULL,'2MASX J15285992+0140286',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.249583,1.67453,0.077,NULL,56399088823,881235762,13769308,16.5),(130337,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130337,37.75,0.19,354,60374,70,NULL,NULL,'2MASX J15290032+0156336',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,232.2512083,1.94283,0.081,NULL,56399144407,881236631,13769322,16.8),(130338,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130338,37.61,0.12,333,60375,70,NULL,NULL,'2MASX J15290047+5252450',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000157,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,232.2520417,52.87917,0.029,NULL,59674165029,932408828,14568887,16.8),(130339,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130339,37.69,0.46,344,60376,70,NULL,NULL,'SDSS J152900.64+171530.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.2527083,17.2585,0.129,NULL,59436688946,928698264,14510910,18.3),(130340,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130340,37.75,0.19,354,60377,70,NULL,NULL,'2MASX J15290112+0149156',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.254583,1.82111,0.077,NULL,56399181513,881237211,13769331,17.6),(130341,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130341,38.04,0.23,405,60378,70,NULL,NULL,'2MASX J15290137+3046204',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00021,NULL,'16.1g',0.38,'BrClG',NULL,NULL,NULL,NULL,1,232.255625,30.77236,0.041,NULL,59915228993,936175453,14627741,16.1),(130342,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130342,37.72,0.46,349,60379,70,NULL,NULL,'SDSS J152901.69+032740.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000071,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.257041667,3.46122,0.105,NULL,56436403848,881818810,13778418,18.1),(130343,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130343,37.61,0.12,333,60380,70,NULL,NULL,'2MASX J15290195+5243130',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000172,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.258333,52.72022,0.029,NULL,59676049444,932438272,14569348,17.8),(130344,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130344,37.58,0.46,328,60381,70,NULL,NULL,'2MASX J15290289+2453295',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,232.261958333,24.8915,0.141,NULL,59416824433,928387881,14506060,17.5),(130345,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130345,37.45,0.46,309,60382,70,NULL,NULL,'2MASX J15290311+3039354',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000181,NULL,'16.4g',0.4,NULL,NULL,NULL,NULL,NULL,1,232.2627917,30.65981,0.041,NULL,59913149940,936142967,14627233,16.4),(130346,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130346,35.39,0.46,119,60383,70,NULL,NULL,'2MASX J15290323+1715521',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.91',0.26,NULL,NULL,NULL,NULL,NULL,1,232.263416667,17.26442,0.129,NULL,59436689102,928698267,14510910,16.91),(130347,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130347,35.85,0.2,148,60384,74.4,NULL,NULL,'CGCG 135-060',NULL,'2013AJ....146...86T',2013,1,1.05,NULL,'G',0.000027,NULL,'14.8g',0.65,'SB?',NULL,NULL,NULL,NULL,1,232.265875,25.45822,0.157,NULL,59899416259,935928379,14623880,14.8),(130348,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130348,37.2,0.27,275,60385,70,NULL,NULL,'SDSS J152906.86+294039.8',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000197,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,232.278583,29.67772,0.057,NULL,59912664332,936135380,14627115,16.5),(130349,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130349,37.2,0.27,275,60386,70,NULL,NULL,'2MASX J15290757+2940115',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'17.1g',0.22,'E',NULL,NULL,NULL,NULL,1,232.281667,29.66986,0.057,NULL,59912664361,936135380,14627115,17.1),(130350,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130350,37.87,0.15,376,60387,70,NULL,NULL,'2MASX J15290763-0021301',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000089,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,232.2817083,-0.35836,0.253,NULL,45406782361,709480974,11085640,18),(130351,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130351,37.61,0.12,333,60388,70,NULL,NULL,'SDSS J152908.13+524534.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,232.283916667,52.75947,0.029,NULL,59673969379,932405771,14568840,18.3),(130352,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130352,37.45,0.46,308,60389,70,NULL,NULL,'2MASX J15290839+0100036',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00009,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,232.2850417,1.00108,0.105,NULL,56400804504,881262570,13769727,17.1),(130353,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130353,37.68,0.46,343,60390,70,NULL,NULL,'SDSS J152909.58+284204.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.289917,28.70131,0.041,NULL,59899907115,935936048,14624000,18),(130354,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130354,36.99,0.46,251,60391,70,NULL,NULL,'2MASX J15290960+3601262',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000176,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.2899583,36.02389,0.041,NULL,60105675667,939151182,14674237,16.5),(130355,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130355,37.75,0.19,354,60392,70,NULL,NULL,'2MASX J15291012+0143516',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.292208333,1.73106,0.077,NULL,56399058005,881235281,13769301,17.6),(130356,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130356,37.87,0.15,376,60393,70,NULL,NULL,'2MASX J15291103-0012201',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000093,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,232.296,-0.20558,0.237,NULL,45405722268,709464410,11085381,16.8),(130357,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130357,37.61,0.12,333,60394,70,NULL,NULL,'SDSS J152911.19+523914.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000155,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,232.296625,52.65411,0.029,NULL,59676264756,932441636,14569400,18.2),(130358,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130358,36.64,0.46,213,60395,70,NULL,NULL,'2MASX J15291199+3831082',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000179,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,232.300125,38.519,0.049,NULL,60099181773,939049715,14672651,16.2),(130359,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130359,37.2,0.27,275,60396,70,NULL,NULL,'CGCG 165-063',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000173,NULL,'15.5g',0.48,'E',NULL,NULL,NULL,NULL,1,232.301333,29.63953,0.057,NULL,59912664160,936135377,14627115,15.5),(130360,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130360,37.87,0.15,376,60397,70,NULL,NULL,'2MASX J15291276-0015081',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000103,NULL,'16.2g',0.41,'BrClG',NULL,NULL,NULL,NULL,1,232.303083,-0.25222,0.237,NULL,45405723247,709464425,11085381,16.2),(130361,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130361,34.96,0.49,98.3,60398,75,NULL,'IR','FGC 1905',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.000099,NULL,'16.6g',0.19,'Sc             HII',NULL,NULL,NULL,NULL,1,232.30925,-1.15908,0.293,NULL,45407380473,709490319,11085786,16.6),(130362,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130362,35.73,NULL,140,60398,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1905',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130363,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130363,35.76,NULL,142,60398,NULL,NULL,'Dipole + Quadrupole','FGC 1905',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130364,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130364,35.78,NULL,143,60398,NULL,NULL,'Dipole','FGC 1905',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130365,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130365,35.81,0.2,145,60399,74.4,NULL,NULL,'IC 4549',NULL,'2013AJ....146...86T',2013,1,0.76,NULL,'G',0.000098,NULL,'15.3g',0.36,'Sbc',NULL,NULL,NULL,NULL,1,232.3107083,32.82556,0.053,NULL,59882361499,935661898,14619717,15.3),(130366,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130366,35.58,0.46,131,60400,70,NULL,NULL,'CGCG 049-175',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000093,NULL,'15.2',0.5,NULL,'Group member',NULL,NULL,NULL,1,232.313458333,5.06003,0.109,NULL,56437097533,881829648,13778588,15.2),(130367,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130367,38.88,0.46,597,60401,70,NULL,NULL,'SDSS J152915.55+120412.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.314833,12.07008,0.105,NULL,59341456367,927210255,14487660,18.2),(130368,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130368,36.71,0.21,220,60402,70,NULL,NULL,'2MASX J15291576+0734556',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,232.3157917,7.58219,0.097,NULL,56418270971,881535483,13773991,17.3),(130369,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130369,37.94,0.46,387,60403,70,NULL,NULL,'SDSS J152916.39+103953.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.318333333,10.66483,0.085,NULL,59343400819,927240637,14488134,17.8),(130370,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130370,37.16,0.46,270,60404,70,NULL,NULL,'2MASX J15291809+5606470',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,232.325333,56.11319,0.037,NULL,57595975734,899937120,14061517,NULL),(130371,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130371,37.61,0.12,333,60405,70,NULL,NULL,'2MASX J15291948+5259451',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000186,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,232.331291667,52.99592,0.033,NULL,59674184857,932409138,14568892,16.8),(130372,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130372,37.61,0.12,333,60406,70,NULL,NULL,'2MASX J15291958+5253521',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000214,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.3314583,52.89783,0.033,NULL,59674156224,932408691,14568885,16.7),(130373,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130373,34.65,0.53,85,60407,70,NULL,NULL,'2MASX J15291996-2111260',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.81',NULL,NULL,NULL,NULL,NULL,NULL,1,232.333125,-21.19056,0.529,NULL,46638700881,728729701,11386401,15.81),(130374,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130374,37.7,0.33,347,60408,70,NULL,NULL,'2MASX J15291994+0155104',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.333208333,1.91969,0.081,NULL,56399135575,881236493,13769320,16.8),(130375,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130375,36.2,NULL,174,60409,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1908',NULL,'2010Ap&SS.325..163P',2010,1,0.83,NULL,'G',NULL,NULL,'17.51',0.1,'Scd',NULL,NULL,NULL,NULL,1,232.3335,62.4105,0.041,NULL,57746636044,902291188,14098299,17.51),(130376,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130376,36.23,NULL,176,60409,NULL,NULL,'Dipole + Quadrupole','FGC 1908',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130377,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130377,36.23,NULL,177,60409,NULL,NULL,NULL,'FGC 1908',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130378,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130378,36.25,0.49,178,60409,75,NULL,'IR','FGC 1908',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130379,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130379,36.26,NULL,178,60409,NULL,NULL,'Dipole','FGC 1908',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130380,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130380,37.7,0.33,347,60410,70,NULL,NULL,'2MASX J15292001+0154094',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.333417,1.90247,0.081,NULL,56399167602,881236993,13769328,17.5),(130381,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130381,37.53,0.46,320,60411,70,NULL,NULL,'2MASX J15292021+2526004',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000179,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,232.33425,25.43361,0.157,NULL,59899593861,935931154,14623924,16.5),(130382,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130382,37.61,0.12,333,60412,70,NULL,NULL,'SDSS J152920.27+525659.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.3345,52.94978,0.033,NULL,59674183967,932409124,14568892,17.7),(130383,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130383,35.99,0.31,158,60413,NULL,NULL,'Malmquist cor.','CGCG 077-135',NULL,'2009ApJS..182..474S',2009,1,0.89,NULL,'G',0.000009,NULL,'15.7g',0.29,'Sb','Isolated galaxy',NULL,NULL,NULL,1,232.341541667,9.091,0.113,NULL,56420285791,881566965,13774483,15.7),(130384,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130384,36.11,0.29,167,60413,NULL,NULL,NULL,'CGCG 077-135',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130385,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130385,36.13,0.2,168,60413,74.4,NULL,NULL,'CGCG 077-135',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130386,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130386,37.17,0.46,272,60414,70,NULL,NULL,'2MASX J15292238+4756012',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000168,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,232.34325,47.93356,0.041,NULL,59718672164,933104252,14579753,16.6),(130387,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130387,38.08,0.33,413,60415,70,NULL,NULL,'2MASX J15292250+3621423',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000042,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,232.34375,36.36175,0.057,NULL,60109768112,939215126,14675236,16.7),(130388,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130388,38.18,0.46,432,60416,70,NULL,NULL,'2MASX J15292277-0122003',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,232.344916667,-1.36675,0.325,NULL,45407350724,709489855,11085778,17.8),(130389,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130389,38.17,0.46,430,60417,70,NULL,NULL,'2MASX J15292287+1914259',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.3452083,19.24064,0.169,NULL,59443439714,928803745,14512558,18),(130390,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130390,37.6,0.46,330,60418,70,NULL,NULL,'2MASX J15292314+0312584',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000087,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,232.346375,3.21631,0.105,NULL,56435604043,881806313,13778223,17.2),(130391,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130391,33.34,0.49,46.6,60419,75,NULL,'IR','FGC 228A',NULL,'2011yCatp016004901K',2011,1,1.48,'The 2MASX position is for the southwestern arm near the companion galaxy.','G',0.000017,NULL,'15.1R',0.25,'SBcd? sp',NULL,NULL,NULL,NULL,1,232.346667,-12.2465,0.513,NULL,46657857034,729029016,11391078,15.1),(130392,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130392,37.42,0.46,304,60420,70,NULL,NULL,'2MASX J15292343+4636142',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000186,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.347625,46.60397,0.017,NULL,59685872155,932591752,14571746,16.8),(130393,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130393,37.85,0.46,372,60421,70,NULL,NULL,'2MASX J15292381+0345224',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000134,NULL,'17.2g',0.21,'NLAGN',NULL,NULL,NULL,'Sy 2',1,232.3492083,3.75622,0.113,NULL,56436344246,881817878,13778404,17.2),(130394,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130394,37.87,0.46,376,60422,70,NULL,NULL,'2MASX J15292454+3103266',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.352167,31.05733,0.029,NULL,59915483929,936179436,14627803,18.2),(130395,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130395,37.27,0.46,284,60423,70,NULL,NULL,'2MASX J15292486+0810318',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000151,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.353667,8.17547,0.069,NULL,56421183955,881580999,13774703,17.6),(130396,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130396,38.31,0.46,459,60424,70,NULL,NULL,'2MASX J15292508+3016266',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.3545,30.27408,0.045,NULL,59913295152,936145236,14627269,17.8),(130397,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130397,37.54,0.46,322,60425,70,NULL,NULL,'2MASX J15292514+2216189',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000167,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.3547083,22.27214,0.157,NULL,59451267445,928926053,14514469,18.1),(130398,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130398,35.76,0.46,142,60426,70,NULL,NULL,'CGCG 049-177 NED01',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000099,NULL,'15.8g',0.26,'S0',NULL,NULL,NULL,NULL,1,232.355417,2.74297,0.081,NULL,56431417155,881740893,13777201,15.8),(130399,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130399,37.58,0.46,328,60427,70,NULL,NULL,'2MASX J15292549+2051179',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,232.356375,20.855,0.185,NULL,59444369096,928818267,14512785,17.2),(130400,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130400,37,0.46,252,60428,70,NULL,NULL,'2MASX J15292681+3545086',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000153,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.3617917,35.75253,0.041,NULL,60105605380,939150084,14674220,16.5),(130401,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130401,36.02,0.23,160,60429,70,NULL,NULL,'2MASX J15292695+0328514',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000094,NULL,'16.1g',0.29,'S0',NULL,NULL,NULL,NULL,1,232.36225,3.48111,0.113,NULL,56436395644,881818681,13778416,16.1),(130402,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130402,36.71,0.21,220,60430,70,NULL,NULL,'2MASX J15292793+0711539',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.36625,7.19814,0.097,NULL,56418613904,881540842,13774075,17),(130403,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130403,36.71,0.21,220,60431,70,NULL,NULL,'NGC 5931',NULL,'2015arXiv151105856S',2015,1,1.26,'1994AJ....107.1629T has V = 11137 +- 100 km/sec.','G',0.00011,NULL,'14.3g',0.74,'S0',NULL,NULL,NULL,NULL,1,232.3734583,7.57325,0.097,NULL,56418297523,881535898,13773998,14.3),(130404,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130404,38.08,0.33,413,60432,70,NULL,NULL,'2MASX J15292979+3613133',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.374333,36.22028,0.049,NULL,60105525741,939148839,14674200,17.8),(130405,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130405,36.02,0.23,160,60433,70,NULL,NULL,'CGCG 049-178',NULL,'2015arXiv151105856S',2015,1,1.05,'1994AJ....107.1629T has V = 11669 +- 100 km/sec.','G',0.000121,NULL,'14.6g',0.72,'S0','Group member',NULL,NULL,NULL,1,232.3764583,3.46764,0.113,NULL,56436392444,881818631,13778416,14.6),(130406,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130406,37.69,0.46,346,60434,70,NULL,NULL,'SDSS J152931.41+600516.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000143,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,232.380875,60.08789,0.025,NULL,57739510893,902179857,14096560,18.7),(130407,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130407,36.02,0.23,160,60435,70,NULL,NULL,'2MASX J15293256+0323054',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00009,NULL,'16.2g',0.3,'S0',NULL,NULL,NULL,NULL,1,232.385583333,3.38494,0.105,NULL,56435576171,881805877,13778216,16.2),(130408,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130408,37.67,0.17,342,60436,70,NULL,NULL,'2MASX J15293296+0332314',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00011,NULL,'16.5g',0.36,'BLAGN',NULL,NULL,NULL,'Sy 1',1,232.387416667,3.54197,0.113,NULL,56436372685,881818323,13778411,16.5),(130409,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130409,38.78,0.46,569,60437,70,NULL,NULL,'SDSS J152935.56+063821.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.3982083,6.63939,0.069,NULL,56417820171,881528440,13773881,18.2),(130410,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130410,35.99,0.2,158,60438,74.4,NULL,NULL,'CGCG 077-136',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000465,NULL,'15.7',0.27,'Sm','Isolated galaxy',NULL,NULL,NULL,1,232.3994583,12.25567,0.105,NULL,59559743583,930620993,14540953,15.7),(130411,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130411,37.15,0.23,269,60439,70,NULL,NULL,'2MASX J15293747+1133399',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,232.40625,11.56103,0.101,NULL,59341859330,927216552,14487758,16.2),(130412,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130412,37.87,0.15,376,60440,70,NULL,NULL,'2MASX J15293762-0016503',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000087,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,232.406833,-0.28069,0.237,NULL,45405939769,709467808,11085434,17),(130413,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130413,37.55,0.46,324,60441,70,NULL,NULL,'2MASX J15293787+0733409',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,232.407833,7.56125,0.097,NULL,56418298856,881535919,13773998,17.2),(130414,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130414,36.65,0.46,214,60442,70,NULL,NULL,'2MASX J15293929+0635269',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,232.41375,6.59086,0.069,NULL,56417827106,881528548,13773883,16.5),(130415,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130415,38.15,0.46,427,60443,70,NULL,NULL,'2MASX J15294029+3253064',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.418083,32.88522,0.053,NULL,59882372113,935662064,14619719,17.7),(130416,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130416,38.72,0.46,556,60444,70,NULL,NULL,'SDSS J152941.45+532933.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,232.42275,53.49272,0.033,NULL,59669617278,932337769,14567777,18.3),(130417,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130417,37.79,0.46,361,60445,70,NULL,NULL,'2MASX J15294168+4449493',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,232.423833,44.83042,0,NULL,59968438544,937006852,14640732,17.4),(130418,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130418,37.08,0.46,260,60446,70,NULL,NULL,'2MASX J15294243+5832205',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000176,NULL,'16.8g',0.35,NULL,NULL,NULL,NULL,NULL,1,232.427,58.53903,0.033,NULL,57588745683,899824151,14059752,16.8),(130419,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130419,37.48,0.46,313,60447,70,NULL,NULL,'2MASX J15294340+4415283',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000182,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,232.4309583,44.25797,0.025,NULL,59969093373,937017083,14640891,16.5),(130420,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130420,38.03,0.27,403,60448,70,NULL,NULL,'2MASX J15294348+1805189',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.431166667,18.0885,0.133,NULL,59435773447,928683960,14510686,17.8),(130421,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130421,34.83,NULL,92.6,60449,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 514- G 020',NULL,'2010Ap&SS.325..163P',2010,1,1.69,NULL,'G',0.000053,NULL,'17.44',0.1,'Scd',NULL,NULL,NULL,NULL,1,232.4325,-26.19833,0.453,NULL,47139577162,736555893,11508685,17.44),(130422,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130422,34.83,NULL,92.6,60449,NULL,NULL,'Dipole + Quadrupole','ESO 514- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130423,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130423,34.84,NULL,92.7,60449,NULL,NULL,'Dipole','ESO 514- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130424,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130424,36.8,0.46,229,60450,70,NULL,NULL,'2MASX J15294424+3527465',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,232.43425,35.46294,0.049,NULL,60105570550,939149539,14674211,17.3),(130425,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130425,33.89,0.47,59.9,60451,NULL,NULL,'H','NGC 5945',NULL,'2007A&A...465...71T',2007,1,1.36,NULL,'G',0.00002,NULL,'13.6g',1.29,'SB(rs)ab       LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,232.437583333,42.91867,0.101,NULL,59977479431,937148116,14642939,13.6),(130426,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130426,33.9,0.46,60.2,60451,NULL,NULL,'J','NGC 5945',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130427,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130427,33.9,0.45,60.3,60451,NULL,NULL,'K','NGC 5945',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130428,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130428,34.48,0.4,78.8,60451,NULL,NULL,'mean','NGC 5945',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130429,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130429,37.24,0.46,281,60452,70,NULL,NULL,'2MASX J15294580+0642389',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'16.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,232.440917,6.71078,0.081,NULL,56417669188,881526081,13773845,16.2),(130430,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130430,37.64,0.46,338,60453,70,NULL,NULL,'2MASX J15294628+1607015',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,232.442917,16.11706,0.101,NULL,59439388318,928740442,14511569,17.7),(130431,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130431,37.87,0.46,375,60454,70,NULL,NULL,'2MASX J15294639-0046147',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000076,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.4432083,-0.77081,0.253,NULL,45407408855,709490763,11085793,17.8),(130432,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130432,37.15,0.23,269,60455,70,NULL,NULL,'2MASX J15294687+1136569',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,232.4454583,11.61567,0.101,NULL,59341849861,927216404,14487756,16.8),(130433,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130433,37.08,0.46,261,60456,70,NULL,NULL,'2MASX J15294705+3143315',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,232.4459583,31.72561,0.045,NULL,59914940985,936170952,14627671,17.6),(130434,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130434,37.44,0.33,308,60457,70,NULL,NULL,'2MASX J15294736+4848149',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000193,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,232.4475,48.80431,0.041,NULL,59664278617,932254353,14566474,17.3),(130435,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130435,38.75,0.46,562,60458,70,NULL,NULL,'2MASX J15294859-0113567',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000087,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,232.4525417,-1.23242,0.293,NULL,45407368907,709490139,11085783,18.5),(130436,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130436,38.03,0.27,403,60459,70,NULL,NULL,'2MASX J15294868+1759086',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,232.452791667,17.98578,0.133,NULL,59436183250,928690363,14510786,17.9),(130437,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130437,36.71,0.21,220,60460,70,NULL,NULL,'2MASX J15294876+0731599',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,232.453125,7.53317,0.097,NULL,56418249296,881535145,13773986,NULL),(130438,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130438,36.02,0.23,160,60461,70,NULL,NULL,'CGCG 049-183',NULL,'2015arXiv151105856S',2015,1,1.05,NULL,'G',0.000123,NULL,'14.3g',0.83,'E0','Group member',NULL,NULL,NULL,1,232.457625,3.51089,0.113,NULL,56435493036,881804578,13778196,14.3),(130439,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130439,34.03,0.2,64,60462,74.4,NULL,NULL,'UGC 09873',NULL,'2013AJ....146...86T',2013,1,1.43,NULL,'G',0.000017,NULL,'15.2g',0.34,'Sc','Group member',NULL,NULL,NULL,1,232.4610417,42.62894,0.101,NULL,59977182216,937143472,14642866,15.2),(130440,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130440,34.06,0.52,64.9,60462,NULL,NULL,NULL,'UGC 09873',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130441,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130441,34.24,0.49,70.4,60462,75,NULL,'IR','UGC 09873',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130442,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130442,34.28,0.47,71.7,60462,NULL,NULL,'Malmquist cor.','UGC 09873',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130443,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130443,38.03,0.46,404,60463,70,NULL,NULL,'SDSS J152951.04+111359.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.4627083,11.23328,0.089,NULL,59341691987,927213937,14487717,18.5),(130444,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130444,37.58,0.46,328,60464,70,NULL,NULL,'2MASX J15295162+1035563',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,232.4652083,10.59883,0.089,NULL,59343384584,927240384,14488131,16.8),(130445,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130445,38.46,0.46,492,60465,70,NULL,NULL,'SDSS J152952.30+025328.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000088,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.467958333,2.89125,0.089,NULL,56431456178,881741502,13777210,18.6),(130446,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130446,37.59,0.46,329,60466,70,NULL,NULL,'2MASX J15295234+1839325',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000151,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.4682917,18.65911,0.101,NULL,59443348866,928802326,14512536,17.4),(130447,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130447,38.44,0.46,488,60467,70,NULL,NULL,'SDSS J152952.53+283323.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.468875,28.55639,0.041,NULL,59917755211,936214925,14628358,18.5),(130448,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130448,36.81,0.46,231,60468,70,NULL,NULL,'2MASX J15295389+4243283',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000156,NULL,'16.9g',0.32,NULL,NULL,NULL,NULL,NULL,1,232.474583,42.72447,0.101,NULL,59977173393,937143334,14642864,16.9),(130449,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130449,34.55,0.46,81.2,60469,NULL,NULL,'Malmquist cor.','ESO 514- G 021',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.99',0.3,'S...',NULL,NULL,NULL,NULL,1,232.477,-26.5965,0.441,NULL,47139199052,736549985,11508593,15.99),(130450,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130450,34.55,0.46,81.2,60469,NULL,NULL,NULL,'ESO 514- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130451,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130451,34.59,0.2,82.8,60469,74.4,NULL,NULL,'ESO 514- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130452,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130452,37.45,0.46,309,60470,70,NULL,NULL,'2MASX J15295451+2139585',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.47725,21.66636,0.169,NULL,59455531334,928992677,14515510,16.7),(130453,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130453,36.22,0.46,175,60471,70,NULL,NULL,'2MASX J15295502+0820273',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000165,NULL,'17.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,232.479375,8.34108,0.093,NULL,56421661424,881588459,13774819,17.1),(130454,'IRAS','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130454,34.84,0.8,93.1,60472,75,NULL,'MAT, I','ESO 582- G 013',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000027,NULL,'14.5',1,'SAB(rs)bc      HII',NULL,NULL,NULL,NULL,1,232.480667,-18.61958,0.405,NULL,46596208848,728065763,11376027,14.5),(130455,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130455,34.22,0.69,69.9,60472,100,NULL,'mid-IR','ESO 582- G 013',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130456,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130456,34.41,0.43,76.2,60472,75,NULL,'MAT, I, raw','ESO 582- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130457,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130457,34.44,0.32,77.2,60472,85,NULL,'I, raw','ESO 582- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130458,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130458,34.51,0.32,79.8,60472,85,NULL,'I, inv','ESO 582- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130459,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130459,34.72,0.43,87.7,60472,75,NULL,'MAT, I, inv','ESO 582- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130460,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130460,34.78,0.43,90.4,60472,75,NULL,'MAT, I, cor','ESO 582- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130461,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130461,35.03,0.47,101,60472,NULL,NULL,'H','ESO 582- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130462,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130462,35.04,0.4,102,60472,NULL,NULL,'mean','ESO 582- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130463,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130463,35.09,0.46,104,60472,NULL,NULL,'J','ESO 582- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130464,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130464,35.13,0.45,106,60472,NULL,NULL,'K','ESO 582- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130465,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130465,35.14,0.28,107,60472,NULL,NULL,'Malmquist cor.','ESO 582- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130466,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130466,35.29,0.2,114,60472,74.4,NULL,NULL,'ESO 582- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130467,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130467,35.34,0.26,117,60472,NULL,NULL,NULL,'ESO 582- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130468,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130468,37.49,0.46,315,60473,70,NULL,NULL,'2MASX J15295614+3028405',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,232.484041667,30.47778,0.041,NULL,59913286621,936145103,14627267,17.1),(130469,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130469,38.25,0.46,447,60474,70,NULL,NULL,'2MASX J15295625-0008107',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000087,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.484291667,-0.13625,0.229,NULL,45405854012,709466468,11085413,18.1),(130470,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130470,37.44,0.33,308,60475,70,NULL,NULL,'2MASX J15295639+4907569',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000165,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,232.485,49.13261,0.037,NULL,59667682096,932307532,14567305,16.7),(130471,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130471,37.15,0.23,269,60476,70,NULL,NULL,'SDSS J152956.42+113220.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.5g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.485125,11.53894,0.101,NULL,59341826231,927216034,14487750,17.5),(130472,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130472,37.41,0.46,303,60477,70,NULL,NULL,'2MASX J15295656+1630525',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.48575,16.51458,0.101,NULL,59439160219,928736878,14511513,17.5),(130473,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130473,37.85,0.46,371,60478,70,NULL,NULL,'2MASX J15295720+0029541',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000091,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.48825,0.49828,0.181,NULL,56398378861,881224669,13769135,17.1),(130474,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130474,37.54,0.46,322,60479,70,NULL,NULL,'2MASX J15295749+5417246',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000176,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,232.4895417,54.29019,0.029,NULL,59669397538,932334336,14567724,16.9),(130475,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130475,37.37,0.46,298,60480,70,NULL,NULL,'2MASX J15295759+2516137',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000168,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.49,25.27047,0.149,NULL,59899619822,935931559,14623930,16.8),(130476,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130476,37.58,0.46,328,60481,70,NULL,NULL,'2MASX J15295839+0816503',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000177,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,232.4932917,8.28075,0.097,NULL,56421654341,881588349,13774817,17.1),(130477,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130477,37.68,0.46,343,60482,70,NULL,NULL,'2MASX J15295892+0007211',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000083,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.495667,0.1225,0.201,NULL,56398294901,881223357,13769114,17.7),(130478,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130478,37.67,0.17,342,60483,70,NULL,NULL,'SDSS J153000.07+033005.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000069,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,232.5002917,3.5015,0.113,NULL,56435506987,881804796,13778199,18.7),(130479,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130479,38.35,0.46,468,60484,70,NULL,NULL,'SDSS J153000.61+002101.5',NULL,'2015arXiv151105856S',2015,1,0.11,NULL,'G',0.000077,NULL,'18.9g',0.1,NULL,NULL,NULL,NULL,NULL,1,232.5025417,0.35042,0.201,NULL,56398385511,881224773,13769137,18.9),(130480,'Ring Diameter','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130480,33.5,0.84,50,60485,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5936',NULL,'1981ApJS...45..541P',1981,1,1.4,NULL,'G',0.00002,NULL,'13.11',1.3,'SB(rs)b;LIRG   HII','Field galaxy',NULL,NULL,NULL,1,232.5034583,12.98933,0.093,NULL,59559941883,930624091,14541001,13.11),(130481,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130481,37.15,0.23,269,60486,70,NULL,NULL,'2MASX J15300137+1144063',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.505791667,11.73497,0.101,NULL,59342019518,927219054,14487797,16.7),(130482,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130482,35.94,0.46,154,60487,70,NULL,NULL,'2MASX J15300164+1228065',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,232.506833333,12.46842,0.101,NULL,59559735095,930620860,14540950,16.5),(130483,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130483,38.15,0.46,426,60488,70,NULL,NULL,'2MASX J15300176+3538115',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000152,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,232.5072917,35.63661,0.041,NULL,60105582890,939149732,14674214,17.6),(130484,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130484,37.4,0.33,303,60489,70,NULL,NULL,'2MASX J15300179-0046417',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000075,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,232.5074583,-0.77825,0.253,NULL,45407405182,709490705,11085792,17.4),(130485,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130485,38.26,0.46,448,60490,70,NULL,NULL,'2MASX J15300355+5810036',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.514708333,58.16783,0.021,NULL,57588645627,899822587,14059727,17.7),(130486,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130486,38.3,0.46,458,60491,70,NULL,NULL,'2MASX J15300403+1016223',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000159,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.516667,10.27294,0.085,NULL,56406814679,881356479,13771194,18.1),(130487,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130487,37.72,0.27,350,60492,70,NULL,NULL,'2MASX J15300481+2316234',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,232.5202917,23.27319,0.153,NULL,59419110031,928423594,14506618,18.3),(130488,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130488,37.11,0.46,264,60493,70,NULL,NULL,'2MASX J15300584+0333251',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000084,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,232.524333,3.55692,0.113,NULL,56435501390,881804709,13778198,17.1),(130489,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130489,36.89,0.46,239,60494,70,NULL,NULL,'2MASX J15300741+0651003',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.530875,6.85025,0.097,NULL,56417673914,881526154,13773846,17),(130490,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130490,37.46,0.46,311,60495,70,NULL,NULL,'2MASX J15300752-0033597',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000078,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,232.531333,-0.56656,0.253,NULL,45405827079,709466048,11085407,17.6),(130491,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130491,37.72,0.27,350,60496,70,NULL,NULL,'B2 1527+23',NULL,'2015arXiv151105856S',2015,1,0.44,'TXS codes: confusion(C);lobes(W)','G',0.000202,NULL,'16.3g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,232.5332083,23.27111,0.153,NULL,59419111300,928423614,14506618,16.3),(130492,'IRAS','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130492,31.13,0.8,16.9,60497,75,NULL,'MAT, I','ESO 329- G 007',NULL,'1997ApJS..109..333W',1997,1,1.8,'1996ApJS...107...97M gives V = 1439 +- 10 km/sec.','G',0.000013,NULL,'13.9b',0.5,'SA(rs)b:',NULL,NULL,NULL,NULL,1,232.5347083,-38.65181,0.517,NULL,47180785481,737199773,11518746,13.9),(130493,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130493,33.81,0.43,57.7,60497,75,NULL,'MAT, I, raw','ESO 329- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130494,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130494,33.81,0.32,57.9,60497,85,NULL,'I, raw','ESO 329- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130495,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130495,33.89,0.32,59.9,60497,85,NULL,'I, inv','ESO 329- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130496,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130496,34,0.43,63,60497,75,NULL,'3.6 micron, color + selection bias corrected','ESO 329- G 007',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130497,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130497,34,0.43,63.1,60497,75,NULL,'3.6 micron, color corrected','ESO 329- G 007',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130498,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130498,34.07,0.43,65.1,60497,75,NULL,'MAT, I, cor','ESO 329- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130499,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130499,34.07,0.2,65.2,60497,74.4,NULL,NULL,'ESO 329- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130500,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130500,34.12,0.43,66.7,60497,75,NULL,'MAT, I, inv','ESO 329- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130501,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130501,34.41,0.49,76.2,60497,75,NULL,'IR','ESO 329- G 007',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130502,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130502,37.4,0.33,303,60498,70,NULL,NULL,'2MASX J15300932-0052257',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000081,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.5387083,-0.87392,0.301,NULL,45407414061,709490844,11085794,17.4),(130503,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130503,36.49,NULL,198,60499,NULL,NULL,NULL,'FGC 1909',NULL,'2000BSAO...50....5K',2000,1,0.78,NULL,'G',0.000181,NULL,'17.0g',0.15,'Sd',NULL,NULL,NULL,NULL,1,232.540083333,49.02478,0.037,NULL,59664297902,932254654,14566478,17),(130504,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130504,37.8,0.46,364,60500,70,NULL,NULL,'2MASX J15301025+2112304',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,232.542791667,21.20847,0.169,NULL,59456234372,929003662,14515682,17.6),(130505,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130505,36.74,0.46,223,60501,70,NULL,NULL,'2MASX J15301065-0003067',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000091,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,232.544291667,-0.05186,0.229,NULL,45405858111,709466532,11085414,16.8),(130506,'SNIa','2016-12-15 15:15:35','2016-12-16 11:20:49','1','SN 1996cm',NULL,130506,41.55,0.6,1410,60502,74.2,NULL,'SALT 2','H-ZSNS J153011.25+055527.0',0.45,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,232.546875,5.92417,0.113,NULL,56423080200,881610628,13775166,NULL),(130507,'SNIa','2016-12-15 15:15:35','2016-12-16 11:20:49','1','SN 1996cm','R',130507,41.89,NULL,1650,60502,65,NULL,'SALT','H-ZSNS J153011.25+055527.0',0.45,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130508,'SNIa','2016-12-15 15:15:35','2016-12-16 11:20:49','1','SN 1996cm',NULL,130508,42.28,0.42,1970,60502,70,NULL,'SALT','H-ZSNS J153011.25+055527.0',0.45,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130509,'SNIa','2016-12-15 15:15:35','2016-12-16 11:20:49','1','SN 1996cm',NULL,130509,42.41,0.4,2090,60502,65,NULL,'SALT','H-ZSNS J153011.25+055527.0',0.45,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130510,'SNIa','2016-12-15 15:15:35','2016-12-16 11:20:49','1','SN 1996cm',NULL,130510,42.58,0.19,2260,60502,65,NULL,NULL,'H-ZSNS J153011.25+055527.0',0.45,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130511,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130511,37.87,0.15,376,60503,70,NULL,NULL,'SDSS J153011.81-001801.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000091,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.5492083,-0.30042,0.237,NULL,45405912562,709467383,11085427,18.5),(130512,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130512,37.6,0.46,331,60504,70,NULL,NULL,'2MASX J15301191+2313103',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.549667,23.21958,0.153,NULL,59419119384,928423740,14506620,18.1),(130513,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130513,38.03,0.27,403,60505,70,NULL,NULL,'2MASX J15301223+1759089',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,232.551,17.98572,0.133,NULL,59436227740,928691058,14510797,17.1),(130514,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130514,37.07,0.33,259,60506,70,NULL,NULL,'2MASX J15301236+0113581',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000107,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,232.5515,1.23275,0.093,NULL,56399841191,881247518,13769492,16.3),(130515,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130515,37.67,0.17,342,60507,70,NULL,NULL,'SDSS J153013.04+034216.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000072,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.554333,3.70469,0.113,NULL,56436337849,881817778,13778402,18.4),(130516,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130516,37.23,0.46,279,60508,70,NULL,NULL,'2MASXi J1530131+323502',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.55475,32.58386,0.057,NULL,59882354651,935661791,14619715,17.7),(130517,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130517,37.07,0.33,259,60509,70,NULL,NULL,'2MASX J15301352+0116322',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,232.5562917,1.27578,0.093,NULL,56399854050,881247719,13769495,16.5),(130518,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130518,37.35,0.33,296,60510,70,NULL,NULL,'2MASX J15301455+0808093',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,232.5607083,8.13589,0.097,NULL,56421678045,881588719,13774823,17.8),(130519,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130519,37.72,0.27,350,60511,70,NULL,NULL,'2MASX J15301491+2318503',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000169,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.562083,23.31383,0.153,NULL,59419108940,928423577,14506618,16.8),(130520,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130520,36.13,0.46,169,60512,70,NULL,NULL,'CGCG 297-013',NULL,'2015arXiv151105856S',2015,1,0.6,'GSC 3872-1180 (mag. 13) superposed 20 arcsec south of nucleus.','G',0.0005,NULL,'15.7',0.5,'E','Isolated galaxy',NULL,NULL,NULL,1,232.563375,56.83222,0,NULL,57590440793,899850637,14060166,15.7),(130521,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130521,38.63,0.46,533,60513,70,NULL,NULL,'SDSS J153015.31+060735.6',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.563833,6.12658,0.101,NULL,56415584462,881493507,13773336,17.5),(130522,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130522,38.88,0.46,596,60514,70,NULL,NULL,'SDSS J153016.06+202953.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.5669583,20.49831,0.217,NULL,59444537041,928820891,14512826,18.6),(130523,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130523,36.17,0.46,172,60515,70,NULL,NULL,'CGCG 166-005',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00016,NULL,'14.92',0.6,NULL,NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,232.567291667,27.09753,0.157,NULL,59900580207,935946565,14624165,14.92),(130524,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130524,37.9,0.46,380,60516,70,NULL,NULL,'2MASX J15301639+3206463',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000144,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,232.568375,32.11286,0.065,NULL,59914870698,936169854,14627653,17.2),(130525,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130525,37.15,0.46,269,60517,70,NULL,NULL,'2MASX J15301835+2906045',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.576625,29.10133,0.069,NULL,59926157909,936346217,14630409,17.3),(130526,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130526,38.21,0.21,439,60518,70,NULL,NULL,'2MASX J15301858+0134562',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,232.5775417,1.58233,0.077,NULL,56399369894,881240154,13769377,17.2),(130527,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130527,36.11,0.56,167,60519,70,NULL,NULL,'2MASX J15301875-1312150',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.4,NULL,NULL,NULL,NULL,NULL,1,232.578083333,-13.20414,0.553,NULL,46658134770,729033355,11391146,14.4),(130528,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130528,37.35,0.33,296,60520,70,NULL,NULL,'2MASX J15301968+0813573',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,232.5820417,8.23269,0.097,NULL,56421698412,881589037,13774828,17.1),(130529,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130529,36.62,0.46,211,60521,70,NULL,NULL,'2MASX J15301983-0145569',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,232.582625,-1.76592,0.337,NULL,45405216072,709456501,11085257,16.8),(130530,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130530,37.44,0.46,307,60522,70,NULL,NULL,'2MASX J15302075+3546454',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00019,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,232.5865417,35.77919,0.061,NULL,60105573491,939149585,14674212,16.7),(130531,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130531,37.13,0.46,267,60523,70,NULL,NULL,'2MASX J15302106+1213510',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,232.587666667,12.23092,0.105,NULL,59341407368,927209490,14487648,16.8),(130532,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130532,36.71,0.21,220,60524,70,NULL,NULL,'2MASX J15302187+0742174',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000176,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,232.591125,7.70469,0.097,NULL,56421518724,881586230,13774784,16.8),(130533,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130533,37.89,0.46,379,60525,70,NULL,NULL,'2MASX J15302283+1036554',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.595083,10.61531,0.081,NULL,59343375187,927240237,14488128,17),(130534,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130534,37.95,0.46,389,60526,70,NULL,NULL,'2MASX J15302385-0020198',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000096,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.599333,-0.33897,0.237,NULL,45405899956,709467186,11085424,16.9),(130535,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130535,36.38,0.46,189,60527,70,NULL,NULL,'2MASX J15302471+0550142',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,232.602917,5.83742,0.113,NULL,56423028766,881609824,13775153,16.3),(130536,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130536,36.12,0.46,167,60528,70,NULL,NULL,'2MASX J15302501+1608280',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.604375,16.14111,0.089,NULL,59439446115,928741345,14511583,16.8),(130537,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130537,37.67,0.17,342,60529,70,NULL,NULL,'2MASX J15302522-0130258',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'16.8g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,232.6052083,-1.50728,0.325,NULL,45406675061,709479297,11085614,16.8),(130538,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130538,37.61,0.12,333,60530,70,NULL,NULL,'2MASX J15302640+5306444',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000166,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,232.6102083,53.11244,0.029,NULL,59674165876,932408841,14568888,16.7),(130539,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130539,37.87,0.15,376,60531,70,NULL,NULL,'2MASX J15302718-0014238',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000071,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.61325,-0.24006,0.229,NULL,45405879967,709466874,11085419,18.2),(130540,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130540,38.07,0.46,412,60532,70,NULL,NULL,'SDSS J153027.27+391300.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000125,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,232.613666667,39.21681,0.053,NULL,60097837213,939028706,14672323,18.4),(130541,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130541,35.06,0.62,103,60533,70,NULL,NULL,'2MASX J15302747-2011467',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.78',0.4,NULL,NULL,NULL,NULL,NULL,1,232.6142083,-20.19667,0.481,NULL,46627069610,728547962,11383561,15.78),(130542,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130542,38.21,0.21,439,60534,70,NULL,NULL,'SDSS J153027.97+013313.5',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',NULL,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.616583,1.55375,0.077,NULL,56399422396,881240974,13769390,18.6),(130543,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130543,37.67,0.17,342,60535,70,NULL,NULL,'2MASX J15303029-0124228',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,232.62625,-1.40636,0.293,NULL,45406669696,709479214,11085612,18.4),(130544,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130544,36.81,0.33,230,60536,70,NULL,NULL,'2MASX J15303033+4514531',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000173,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,232.6262917,45.24803,0.033,NULL,59968381285,937005957,14640718,16.1),(130545,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130545,37.67,0.17,342,60537,70,NULL,NULL,'2MASX J15303076-0132558',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000182,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.62825,-1.54892,0.325,NULL,45404754847,709449294,11085145,17.6),(130546,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130546,36.51,0.46,201,60538,70,NULL,NULL,'2MASX J15303081+3832276',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000165,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.62825,38.54092,0.049,NULL,60099388797,939052949,14672702,16.6),(130547,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130547,34.24,0.52,70.6,60539,70,NULL,NULL,'CGCG 021-104 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.22,NULL,'G',0.00015,NULL,'16.42',0.19,NULL,NULL,NULL,NULL,NULL,1,232.628667,-2.27594,0.353,NULL,45405339794,709458434,11085288,16.42),(130548,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130548,37.37,0.46,298,60540,70,NULL,NULL,'2MASX J15303155+2413566',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000142,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.6315,24.23244,0.145,NULL,59417168092,928393251,14506144,17.9),(130549,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130549,37.68,0.46,343,60541,70,NULL,NULL,'2MASX J15303179+3026163',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000196,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.63225,30.43775,0.041,NULL,59912818712,936137792,14627153,17),(130550,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130550,38.21,0.21,439,60542,70,NULL,NULL,'2MASX J15303299+0135192',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,232.637375,1.58886,0.077,NULL,56399423186,881240987,13769390,17.1),(130551,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130551,37.51,0.33,318,60543,70,NULL,NULL,'2MASX J15303333-0048338',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00012,NULL,'15.9g',0.47,'E0',NULL,NULL,NULL,NULL,1,232.63875,-0.80933,0.313,NULL,45406096514,709470258,11085472,15.9),(130552,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130552,37.34,0.46,294,60544,70,NULL,NULL,'2MASX J15303388-0114228',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000095,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,232.64125,-1.23978,0.293,NULL,45406695553,709479618,11085619,16.2),(130553,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130553,36.26,0.46,178,60545,70,NULL,NULL,'VIII Zw 474',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000184,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,232.642833,8.49144,0.109,NULL,56420853211,881575831,13774622,16.3),(130554,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130554,38.39,0.46,476,60546,70,NULL,NULL,'2MASX J15303438+2313291',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.6432083,23.22483,0.153,NULL,59418911694,928420495,14506570,17.6),(130555,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130555,37.67,0.17,342,60547,70,NULL,NULL,'SDSS J153034.48-012707.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000178,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,232.6437083,-1.45222,0.325,NULL,45406647226,709478862,11085607,18.8),(130556,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130556,35.13,0.2,106,60548,74.4,NULL,NULL,'ESO 449- G 012',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'15.08',0.4,'Sb-c',NULL,NULL,NULL,NULL,1,232.646791667,-32.42878,0.437,NULL,47164426379,736944162,11514752,15.08),(130557,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130557,37.69,0.33,346,60549,70,NULL,NULL,'2MASX J15303538+0239062',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000093,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,232.647417,2.65183,0.081,NULL,56398948277,881233566,13769274,16.7),(130558,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130558,37.51,0.33,318,60550,70,NULL,NULL,'2MASX J15303547-0047558',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00015,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.6477083,-0.79894,0.313,NULL,45406096489,709470257,11085472,16.7),(130559,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130559,35.43,0.46,122,60551,70,NULL,NULL,'2MASX J15303690+2728556',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,232.65375,27.48214,0.093,NULL,59900523484,935945679,14624151,NULL),(130560,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130560,36.81,0.33,230,60552,70,NULL,NULL,'2MASX J15303698+4519288',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.653916667,45.32469,0.029,NULL,59968331213,937005175,14640705,17.4),(130561,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130561,35.85,0.53,148,60553,70,NULL,NULL,'2MASX J15303730-4100154',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,232.6555,-41.00436,0.545,NULL,47061475289,735335551,11489617,15.5),(130562,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130562,37.67,0.17,342,60554,70,NULL,NULL,'2MASX J15303905+0329382',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000106,NULL,'15.7g',0.48,'BrClG;E        AGN',NULL,NULL,NULL,NULL,1,232.66275,3.49403,0.113,NULL,56435523276,881805051,13778203,15.7),(130563,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130563,38.21,0.21,439,60555,70,NULL,NULL,'2MASX J15303959+0133502',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.665083,1.564,0.077,NULL,56399391951,881240499,13769382,16.8),(130564,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130564,37.24,0.46,281,60556,70,NULL,NULL,'2MASX J15303993+0150132',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,232.6665,1.83717,0.085,NULL,56399398564,881240602,13769384,17.1),(130565,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130565,37.51,0.46,318,60557,70,NULL,NULL,'2MASX J15303997+4234089',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.6667083,42.56914,0.101,NULL,59977089305,937142020,14642844,17.4),(130566,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130566,37.62,0.46,334,60558,70,NULL,NULL,'2MASX J15304027+4023535',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.667833,40.39831,0.057,NULL,59964331270,936942676,14639729,17.3),(130567,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130567,37.26,0.46,283,60559,70,NULL,NULL,'2MASX J15304074+4748479',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,232.669875,47.81325,0.045,NULL,59719498955,933117171,14579955,16.8),(130568,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130568,37.67,0.17,342,60560,70,NULL,NULL,'2MASX J15304078+0327582',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000075,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.6699583,3.46628,0.113,NULL,56435521436,881805022,13778203,17.5),(130569,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130569,37.2,0.33,276,60561,70,NULL,NULL,'SDSS J153041.38+075003.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000176,NULL,'17.8g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.6724583,7.83419,0.097,NULL,56421575125,881587111,13774798,17.8),(130570,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130570,37.65,0.46,339,60562,70,NULL,NULL,'2MASX J15304290+2928122',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.678833333,29.47017,0.061,NULL,59912597753,936134339,14627099,17.4),(130571,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130571,38.21,0.33,439,60563,70,NULL,NULL,'2MASX J15304291+3042187',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,232.678833333,30.70536,0.073,NULL,59914729879,936167654,14627619,17.6),(130572,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130572,37.24,0.46,280,60564,70,NULL,NULL,'2MASX J15304300+5947442',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,232.679167,59.79556,0.041,NULL,57739662826,902182231,14096597,17.8),(130573,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130573,37.04,0.46,255,60565,70,NULL,NULL,'2MASX J15304310+2814492',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,232.679625,28.24714,0.065,NULL,59917843701,936216307,14628379,16.9),(130574,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130574,38.02,0.46,402,60566,70,NULL,NULL,'2MASX J15304333+0059298',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000071,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.680667,0.99167,0.185,NULL,56399949650,881249213,13769518,18.2),(130575,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130575,36.94,0.46,244,60567,70,NULL,NULL,'2MASX J15304348+4437379',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00016,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,232.6810417,44.62719,0.025,NULL,59968520283,937008129,14640752,16.5),(130576,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130576,36.66,0.46,215,60568,70,NULL,NULL,'2MASX J15304400+5321023',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.6835,53.35083,0.033,NULL,59669632082,932338001,14567781,17.4),(130577,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130577,38.16,0.46,429,60569,70,NULL,NULL,'2MASX J15304406+0344018',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00009,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,232.683625,3.73364,0.117,NULL,56435476499,881804320,13778192,17.1),(130578,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130578,37.09,0.46,261,60570,70,NULL,NULL,'2MASX J15304491-0205553',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00015,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,232.687083,-2.09869,0.353,NULL,45405327744,709458246,11085285,17.2),(130579,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130579,37.55,0.11,323,60571,70,NULL,NULL,'2MASX J15304490+2750473',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.6872917,27.84658,0.089,NULL,59900757132,935949330,14624208,17.3),(130580,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130580,37.67,0.17,342,60572,70,NULL,NULL,'2MASX J15304549-0128163',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000172,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,232.689583,-1.47125,0.293,NULL,45406649585,709478899,11085607,18.1),(130581,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130581,32.21,0.69,27.6,60573,100,NULL,'mid-IR','NGC 5937',NULL,'2013ApJ...771...88L',2013,1,1.9,NULL,'G',0.00002,NULL,'13.35',1.1,'(R\')SAB(rs)b pec HII',NULL,NULL,NULL,NULL,1,232.6922083,-2.8295,0.385,NULL,45404426649,709444166,11085065,13.35),(130582,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130582,32.75,0.43,35.6,60573,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5937',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130583,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130583,32.89,0.45,37.8,60573,NULL,NULL,'K','NGC 5937',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130584,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130584,32.92,0.47,38.4,60573,NULL,NULL,'H','NGC 5937',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130585,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130585,32.93,0.43,38.5,60573,75,NULL,'3.6 micron, color corrected','NGC 5937',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130586,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130586,32.94,0.46,38.7,60573,NULL,NULL,'J','NGC 5937',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130587,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130587,33.03,0.4,40.4,60573,NULL,NULL,'mean','NGC 5937',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130588,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130588,33.11,0.2,41.9,60573,74.4,NULL,NULL,'NGC 5937',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130589,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130589,38.21,0.33,439,60574,70,NULL,NULL,'2MASX J15304647+3042337',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000201,NULL,'17.4g',0.19,'BrClG',NULL,NULL,NULL,NULL,1,232.6935417,30.70953,0.073,NULL,59914721842,936167528,14627617,17.4),(130590,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130590,37.58,0.46,328,60575,70,NULL,NULL,'2MASX J15304784+5745192',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.699208333,57.75533,0.025,NULL,57591292929,899863952,14060374,17.3),(130591,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130591,37.03,0.46,254,60576,70,NULL,NULL,'2MASX J15304783+3225137',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,232.699291667,32.42058,0.061,NULL,59914859828,936169684,14627651,17.3),(130592,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130592,36.46,0.46,196,60577,70,NULL,NULL,'2MASX J15304806+2832443',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,232.7002083,28.54572,0.041,NULL,59917750399,936214849,14628357,16.6),(130593,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130593,37.61,0.12,333,60578,70,NULL,NULL,'2MASX J15304904+5303433',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,232.704083333,53.06208,0.033,NULL,59673954746,932405542,14568836,17.5),(130594,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130594,38.21,0.21,439,60579,70,NULL,NULL,'2MASX J15304927+0130298',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.705375,1.50831,0.077,NULL,56399857584,881247774,13769496,17.4),(130595,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130595,37.64,0.46,337,60580,70,NULL,NULL,'SDSS J153049.84+115136.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.7077083,11.86006,0.105,NULL,59341971626,927218306,14487786,18.3),(130596,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130596,37.87,0.15,376,60581,70,NULL,NULL,'SDSS J153050.08-001939.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000072,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,232.7087083,-0.32767,0.229,NULL,45406385461,709474772,11085543,18.6),(130597,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130597,37.67,0.17,342,60582,70,NULL,NULL,'2MASX J15305102-0125113',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,232.712667,-1.41978,0.293,NULL,45406708752,709479824,11085622,18.5),(130598,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130598,37.24,0.27,281,60583,70,NULL,NULL,'2MASX J15305123+0650456',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,232.7135417,6.84614,0.097,NULL,56417649400,881525771,13773840,16.5),(130599,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130599,38.21,0.46,439,60584,70,NULL,NULL,'2MASX J15305130-0146173',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.71375,-1.77156,0.329,NULL,45404740388,709449068,11085141,17.9),(130600,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130600,37.33,0.46,292,60585,70,NULL,NULL,'2MASX J15305333-0052393',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000071,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.72225,-0.87772,0.313,NULL,45406099431,709470303,11085473,18.3),(130601,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130601,37.48,0.46,314,60586,70,NULL,NULL,'2MASX J15305349+4548490',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000183,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,232.723125,45.81375,0.025,NULL,59685263534,932582242,14571597,16.4),(130602,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130602,38.32,0.46,462,60587,70,NULL,NULL,'2MASX J15305622+1909342',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000152,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.734333,19.15942,0.145,NULL,59443534291,928805223,14512581,17.5),(130603,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130603,36.13,0.14,168,60588,70,NULL,NULL,'2MASX J15305642+0411428',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000119,NULL,'16.1g',0.31,'S0/a',NULL,NULL,NULL,NULL,1,232.7350417,4.19517,0.125,NULL,56424505770,881632902,13775514,16.1),(130604,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130604,37.67,0.17,342,60589,70,NULL,NULL,'2MASX J15305795+0325338',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000078,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.7414583,3.42603,0.113,NULL,56435425301,881803520,13778180,18),(130605,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130605,37.25,0.46,282,60590,70,NULL,NULL,'SDSS J153058.94+064007.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.745625,6.66886,0.081,NULL,56415670647,881494853,13773357,17.9),(130606,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130606,37.2,0.33,276,60591,70,NULL,NULL,'2MASX J15305914+0752136',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000172,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.746417,7.87042,0.097,NULL,56421540340,881586567,13774790,17.6),(130607,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130607,37.67,0.17,342,60592,70,NULL,NULL,'SDSS J153100.23-013032.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.751,-1.50906,0.293,NULL,45406634992,709478671,11085604,18.5),(130608,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130608,38.1,0.46,416,60593,70,NULL,NULL,'2MASX J15310252+3252578',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.760625,32.88261,0.057,NULL,59885811091,935715798,14620559,17.9),(130609,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130609,37.88,0.33,376,60594,70,NULL,NULL,'2MASX J15310337+3741183',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,232.76425,37.68833,0.061,NULL,60098808044,939043875,14672560,17.7),(130610,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130610,38.11,0.46,419,60595,70,NULL,NULL,'2MASX J15310352+1844511',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,232.764875,18.74756,0.137,NULL,59443322708,928801917,14512529,18),(130611,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130611,37.24,0.27,281,60596,70,NULL,NULL,'SDSS J153104.94+064535.7',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.770583333,6.75992,0.097,NULL,56416344130,881505377,13773521,17.2),(130612,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130612,37.65,0.46,338,60597,70,NULL,NULL,'2MASX J15310543+3558163',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000183,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.772666667,35.97125,0.049,NULL,60105470718,939147979,14674187,16.7),(130613,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130613,37.76,0.23,356,60598,70,NULL,NULL,'SDSS J153105.61-000612.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000064,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.773417,-0.10353,0.217,NULL,45406369274,709474519,11085539,18.3),(130614,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130614,32.47,NULL,31.2,60599,72,NULL,NULL,'AGC 252522',NULL,'2014Ap.....57..457K',2014,1,1.3,NULL,'G',0.000007,NULL,'16.5',0.9,'Sm',NULL,NULL,NULL,NULL,1,232.775625,3.82983,0.117,NULL,56424733600,881636462,13775569,16.5),(130615,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130615,36.21,0.46,174,60600,70,NULL,NULL,'2MASX J15310617+0344157',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000102,NULL,'15.8g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,232.77575,3.73767,0.117,NULL,56424016093,881625251,13775394,15.8),(130616,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130616,37.01,0.46,252,60601,70,NULL,NULL,'2MASX J15310619+3314438',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,'FoF','16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,232.775917,33.24542,0.065,NULL,59885957163,935718080,14620595,16.4),(130617,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130617,37.3,0.46,289,60602,70,NULL,NULL,'2MASX J15310688-0114462',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000075,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.7785417,-1.24631,0.301,NULL,45406726770,709480105,11085626,17.5),(130618,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130618,37.34,0.46,294,60603,70,NULL,NULL,'2MASX J15310738+2423473',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.7807917,24.39667,0.141,NULL,59417360838,928396263,14506191,17.5),(130619,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130619,37.14,0.46,269,60604,70,NULL,NULL,'2MASX J15310799+0019248',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000077,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,232.783375,0.32353,0.201,NULL,56398555599,881227431,13769178,17.5),(130620,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130620,37.56,0.46,324,60605,70,NULL,NULL,'2MASX J15310910+0253037',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000084,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.787875,2.88433,0.081,NULL,56398721100,881230017,13769219,16.8),(130621,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130621,38.1,0.46,417,60606,70,NULL,NULL,'2MASX J15311054+5106338',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.7939583,51.10947,0.041,NULL,59673223200,932394112,14568658,17.8),(130622,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130622,36.66,0.46,215,60607,70,NULL,NULL,'2MASX J15311111+5137477',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000191,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.796416667,51.63003,0.033,NULL,59673194257,932393660,14568650,16.5),(130623,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130623,37.76,0.46,357,60608,70,NULL,NULL,'2MASX J15311129+3314178',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'16.2r',NULL,NULL,NULL,NULL,NULL,NULL,1,232.7970417,33.23825,0.065,NULL,59885955326,935718051,14620594,16.2),(130624,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130624,37.74,0.46,353,60609,70,NULL,NULL,'SDSS J153114.23+221301.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.3g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.809333,22.217,0.157,NULL,59452066273,928938535,14514664,18.3),(130625,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130625,37.79,0.46,362,60610,70,NULL,NULL,'SDSS J153114.89+080834.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.812041667,8.14303,0.109,NULL,56421752755,881589886,13774841,18.3),(130626,'SNIa','2016-12-15 15:15:35','2016-12-16 11:20:49','1','PTF11atu','N',130626,37.75,0.1,329,60611,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF11atu',0.0774,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130627,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130627,38.44,0.46,488,60612,70,NULL,NULL,'2MASX J15311533+3049494',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000178,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,232.814041667,30.83044,0.073,NULL,59914780091,936168438,14627631,17.5),(130628,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130628,37.51,0.46,318,60613,70,NULL,NULL,'2MASX J15311557+5016488',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.814666667,50.28014,0.041,NULL,59666057688,932282151,14566908,18.1),(130629,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130629,37.09,0.46,262,60614,70,NULL,NULL,'SDSS J153115.55+385247.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000142,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,232.814833,38.88,0.057,NULL,60099273672,939051151,14672674,18),(130630,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130630,37.69,0.33,346,60615,70,NULL,NULL,'2MASX J15311564+0226338',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.815083333,2.44278,0.081,NULL,56398891553,881232680,13769260,17.2),(130631,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130631,38.11,0.46,420,60616,70,NULL,NULL,'SDSS J153115.99+151325.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.816667,15.22372,0.097,NULL,59427902694,928560979,14508765,18.2),(130632,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130632,36.7,0.46,219,60617,70,NULL,NULL,'2MASX J15311623+1009036',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000143,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,232.817458333,10.15078,0.085,NULL,56408789525,881387336,13771677,17.2),(130633,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130633,36.25,0.46,178,60618,70,NULL,NULL,'2MASX J15311659+1226247',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.819083,12.44019,0.121,NULL,59560026310,930625411,14541022,16.9),(130634,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130634,38.02,0.46,402,60619,70,NULL,NULL,'2MASX J15311661+2205551',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.8192917,22.0985,0.137,NULL,59452070331,928938598,14514665,16.5),(130635,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130635,37.63,0.33,336,60620,70,NULL,NULL,'SDSS J153117.00+235814.1',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.820875,23.97061,0.149,NULL,59417196845,928393700,14506151,17.1),(130636,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130636,37.55,0.11,323,60621,70,NULL,NULL,'2MASX J15311707+2755520',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00009,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,232.8212083,27.93108,0.089,NULL,59917798567,936215602,14628368,16.4),(130637,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130637,36.75,0.46,224,60622,70,NULL,NULL,'2MASX J15311716+4531063',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,232.821667,45.51839,0.029,NULL,59688616824,932634637,14572416,17.8),(130638,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130638,37.54,0.46,322,60623,70,NULL,NULL,'2MASX J15311732+3246284',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000178,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,232.822,32.77464,0.057,NULL,59885806295,935715723,14620558,16.6),(130639,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130639,36.97,0.46,248,60624,70,NULL,NULL,'2MASXi J1531175+152624',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.823125,15.44022,0.117,NULL,59438924016,928733187,14511456,17.6),(130640,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130640,37.63,0.33,336,60625,70,NULL,NULL,'2MASX J15311801+2404550',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.825125,24.08206,0.145,NULL,59417216262,928394004,14506156,16.9),(130641,'GRB','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130641,46.03,1.57,3820,60626,100,NULL,NULL,'GRB 060526',3.21,'2009EPJC...63..139W',2009,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,232.8265,0.28469,0.201,NULL,56398574981,881227734,13769183,NULL),(130642,'GRB','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130642,46.1,1.51,3930,60626,100,NULL,NULL,'GRB 060526',3.21,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130643,'GRB','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130643,47.17,0.41,6450,60626,69.7,NULL,'Calibrated','GRB 060526',3.21,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130644,'GRB','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130644,47.29,0.47,6820,60626,72,NULL,NULL,'GRB 060526',3.21,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130645,'GRB','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130645,47.35,0.46,7010,60626,70,NULL,NULL,'GRB 060526',3.21,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130646,'GRB','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130646,47.53,0.53,7620,60626,NULL,NULL,NULL,'GRB 060526',3.21,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130647,'GRB','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130647,47.56,0.43,7720,60626,69.7,NULL,'Fiducial','GRB 060526',3.21,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130648,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130648,37.88,0.33,376,60627,70,NULL,NULL,'2MASX J15311870+3736444',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000145,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.827875,37.61214,0.049,NULL,60098693496,939042085,14672532,17.9),(130649,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130649,35.14,0.46,107,60628,70,NULL,NULL,'2MASX J15311870+3604483',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000154,NULL,'15.9g',0.37,'SAB0',NULL,NULL,NULL,NULL,1,232.8280417,36.08006,0.049,NULL,60105479529,939148117,14674189,15.9),(130650,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130650,37.61,0.12,333,60629,70,NULL,NULL,'2MASX J15311889+5303208',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,232.8285417,53.05567,0.033,NULL,59669528496,932336382,14567755,17.6),(130651,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130651,36.67,0.46,215,60630,70,NULL,NULL,'2MASX J15312008+3427084',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000143,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.8337917,34.45244,0.073,NULL,59884504713,935695386,14620240,17.3),(130652,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130652,36.79,0.46,228,60631,70,NULL,NULL,'2MASX J15312047+1443147',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'15.2r',NULL,NULL,NULL,NULL,NULL,NULL,1,232.835417,14.72081,0.117,NULL,59427996836,928562450,14508788,15.2),(130653,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130653,37.24,0.27,281,60632,70,NULL,NULL,'SDSS J153120.65+065003.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.836083,6.83442,0.097,NULL,56416351957,881505499,13773523,17.9),(130654,'Tully est','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130654,32.22,0.8,27.8,60633,75,NULL,NULL,'ESO 008- G 008',NULL,'1988NBGC.C....0000T',1988,1,2.5,'-12h error in A-M RA.','G',0.000022,NULL,'14.0',0.6,'Im',NULL,NULL,NULL,NULL,1,232.842666667,-87.43783,0.437,NULL,44040074045,688126156,10751971,14),(130655,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130655,37.21,0.46,277,60634,70,NULL,NULL,'2MASX J15312226+1443147',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,232.84275,14.72092,0.117,NULL,59427996827,928562450,14508788,16.2),(130656,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130656,37.55,0.11,323,60635,70,NULL,NULL,'2MASX J15312280+2805340',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,232.844916667,28.09294,0.089,NULL,59917854877,936216482,14628382,16.1),(130657,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130657,38.46,0.46,493,60636,70,NULL,NULL,'2MASX J15312421+5703008',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000144,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,232.8507917,57.05022,0,NULL,57590644271,899853816,14060215,17.8),(130658,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130658,39.09,0.46,658,60637,70,NULL,NULL,'SDSS J153124.71+382311.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000143,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,232.853,38.38658,0.041,NULL,60099248960,939050765,14672668,18.7),(130659,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130659,37.58,0.46,329,60638,70,NULL,NULL,'2MASX J15312590+2819200',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000143,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,232.8577083,28.32219,0.065,NULL,59917979668,936218432,14628413,17.4),(130660,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130660,37.83,0.33,368,60639,70,NULL,NULL,'2MASX J15312626+0922017',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.859416667,9.36714,0.073,NULL,56406339837,881349059,13771079,16.7),(130661,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130661,37.62,0.46,334,60640,70,NULL,NULL,'2MASX J15312679+0142448',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,232.861667,1.71247,0.085,NULL,56399451883,881241435,13769397,17.2),(130662,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130662,37.55,0.11,323,60641,70,NULL,NULL,'2MASX J15312688+2814360',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000173,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,232.861917,28.24336,0.065,NULL,59917847912,936216373,14628380,16.9),(130663,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130663,37.21,0.46,277,60642,70,NULL,NULL,'2MASX J15312889+5833568',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000182,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.870125,58.56572,0.033,NULL,57587972529,899812070,14059563,16.8),(130664,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130664,37.01,0.46,253,60643,70,NULL,NULL,'2MASX J15312974+5212467',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,232.873916667,52.21311,0.045,NULL,59672864428,932388506,14568570,17.3),(130665,'IRAS','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130665,33,0.8,39.8,60644,75,NULL,'CF, r','NGC 5950',NULL,'1997ApJS..109..333W',1997,1,1.39,NULL,'G',0.00002,NULL,'14.2g',0.69,'Sb',NULL,NULL,NULL,NULL,1,232.878291667,40.43003,0.053,NULL,59964382611,936943478,14639741,14.2),(130666,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130666,32.44,0.43,30.7,60644,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5950',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130667,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130667,32.85,0.38,37.1,60644,75,NULL,'CF, r, raw','NGC 5950',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130668,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130668,32.86,0.38,37.4,60644,75,NULL,'CF, r, inv','NGC 5950',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130669,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130669,32.97,0.38,39.2,60644,75,NULL,'CF, r, cor','NGC 5950',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130670,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130670,37.17,0.46,272,60645,70,NULL,NULL,'2MASX J15313114+3000455',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000135,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.879833,30.01264,0.069,NULL,59912920444,936139381,14627177,17.7),(130671,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130671,38.11,0.33,418,60646,70,NULL,NULL,'2MASX J15313215+2900560',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.884,29.01561,0.057,NULL,59926365823,936349465,14630460,17.7),(130672,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130672,36.96,0.46,247,60647,70,NULL,NULL,'2MASX J15313232+0511548',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.8847917,5.19869,0.101,NULL,56423210148,881612658,13775197,16.8),(130673,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130673,35.78,0.46,143,60648,70,NULL,NULL,'2MASX J15313247+4539275',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000178,NULL,'15.6g',0.47,'E0',NULL,NULL,NULL,NULL,1,232.885166667,45.65758,0.029,NULL,59685214529,932581477,14571585,15.6),(130674,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130674,36.22,0.46,176,60649,70,NULL,NULL,'2MASX J15313254+5934599',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000161,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,232.8857917,59.58333,0.029,NULL,57738998624,902171853,14096435,16.6),(130675,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130675,36.13,0.14,168,60650,70,NULL,NULL,'2MASX J15313265+0433168',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,232.885958333,4.55478,0.109,NULL,56424546632,881633541,13775524,16.2),(130676,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130676,37.83,0.33,368,60651,70,NULL,NULL,'2MASX J15313328+0922247',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,232.88875,9.37358,0.073,NULL,56406338330,881349036,13771078,17.4),(130677,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130677,36.41,0.46,192,60652,70,NULL,NULL,'2MASX J15313443+4751094',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00018,NULL,'16.1g',0.43,NULL,NULL,NULL,NULL,NULL,1,232.8935,47.85278,0.045,NULL,59719546462,933117913,14579967,16.1),(130678,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130678,36.13,0.14,168,60653,70,NULL,NULL,'2MASX J15313446+0434008',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.893583,4.56689,0.109,NULL,56424547003,881633546,13775524,16.3),(130679,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130679,37.52,0.46,320,60654,70,NULL,NULL,'2MASX J15313566+0025348',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00007,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,232.898625,0.42614,0.213,NULL,56398654694,881228979,13769202,17.6),(130680,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130680,36.88,0.46,238,60655,70,NULL,NULL,'SDSS J153136.46+332359.1',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.7g',0.29,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.901917,33.39978,0.069,NULL,59885831448,935716116,14620564,16.7),(130681,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130681,37.28,0.46,285,60656,70,NULL,NULL,'2MASX J15313802+0726087',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.908375,7.43569,0.089,NULL,56418092192,881532690,13773948,16.6),(130682,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130682,38.11,0.33,418,60657,70,NULL,NULL,'2MASX J15313853+2853150',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.0002,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,232.910583,28.88753,0.057,NULL,59926350389,936349224,14630456,17.5),(130683,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130683,37.66,0.46,341,60658,70,NULL,NULL,'2MASX J15313874+0640457',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00017,NULL,'16.0g',0.43,NULL,NULL,NULL,NULL,NULL,1,232.9115,6.67933,0.105,NULL,56416359973,881505624,13773525,16),(130684,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130684,35.58,0.33,131,60659,70,NULL,NULL,'NGC 5941',NULL,'2015arXiv151105856S',2015,1,0.68,'NGC identification is not certain.','G',0.0001,NULL,'14.91',0.55,'E2','Compact group member',NULL,NULL,NULL,1,232.917667,7.339,0.089,NULL,56418070627,881532353,13773943,14.91),(130685,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130685,37.76,0.23,356,60660,70,NULL,NULL,'2MASX J15314123-0017474',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000078,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.921791667,-0.2965,0.229,NULL,45406403507,709475054,11085547,18),(130686,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130686,37.67,0.17,342,60661,70,NULL,NULL,'2MASX J15314199+0318540',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00007,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,232.9249583,3.31503,0.089,NULL,56423933312,881623958,13775374,17.7),(130687,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130687,35.58,0.33,131,60662,70,NULL,NULL,'CGCG 050-010',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000097,NULL,'15.83',0.49,'E?','Group member',NULL,NULL,NULL,1,232.925917,7.28739,0.105,NULL,56418067868,881532310,13773942,15.83),(130688,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130688,37.12,0.46,266,60663,70,NULL,NULL,'2MASX J15314271+5736049',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,232.927833,57.60133,0.045,NULL,57591380927,899865326,14060395,16.7),(130689,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130689,36.67,0.46,216,60664,70,NULL,NULL,'2MASX J15314376+3417045',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000147,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,232.9324583,34.28475,0.057,NULL,59886144500,935721007,14620640,17.3),(130690,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130690,34.8,0.4,91.4,60665,NULL,NULL,'mean','UGC 09896',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000033,NULL,'14.21',1.1,'Scd:           HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,232.93825,67.55636,0.057,NULL,57970015018,905781484,14152835,14.21),(130691,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130691,34.91,0.47,96,60665,NULL,NULL,'H','UGC 09896',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130692,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130692,35.11,0.46,105,60665,NULL,NULL,'J','UGC 09896',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130693,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130693,35.32,0.44,116,60665,NULL,NULL,'Malmquist cor.','UGC 09896',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130694,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130694,35.38,0.43,119,60665,NULL,NULL,NULL,'UGC 09896',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130695,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130695,35.42,0.2,121,60665,74.4,NULL,NULL,'UGC 09896',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130696,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130696,37.55,0.11,323,60666,70,NULL,NULL,'2MASX J15314675+2807189',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,232.944833,28.12189,0.085,NULL,59917852932,936216452,14628382,NULL),(130697,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130697,37.53,0.27,321,60667,70,NULL,NULL,'2MASX J15314698+5908209',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000192,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,232.945667,59.13906,0.005,NULL,57617157311,900268082,14066688,16.6),(130698,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130698,36.13,0.14,168,60668,70,NULL,NULL,'2MASX J15314719+0424310',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,232.946583,4.40878,0.109,NULL,56424582805,881634106,13775532,16.1),(130699,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130699,37.45,0.46,309,60669,70,NULL,NULL,'2MASX J15315000+3107129',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000157,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.958333,31.12044,0.089,NULL,59914667630,936166681,14627604,17.1),(130700,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130700,38.66,0.46,539,60670,70,NULL,NULL,'2MASX J15315239+2412589',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000198,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.968416667,24.21633,0.141,NULL,59417200511,928393757,14506152,17.7),(130701,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130701,35.45,0.56,123,60671,70,NULL,NULL,'2MASX J15315346-3110159',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,232.972666667,-31.17111,0.453,NULL,47164066875,736938544,11514664,15.7),(130702,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130702,37.97,0.33,394,60672,70,NULL,NULL,'2MASX J15315488+3121380',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,232.978625,31.36056,0.037,NULL,59915555571,936180555,14627821,18.4),(130703,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130703,37.76,0.23,356,60673,70,NULL,NULL,'SDSS J153155.35-001707.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000076,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,232.980667,-0.28536,0.217,NULL,45405533449,709461460,11085335,18.5),(130704,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130704,37.09,0.46,262,60674,70,NULL,NULL,'2MASX J15315644+1229565',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,232.985375,12.49914,0.121,NULL,59559296854,930614013,14540843,16.8),(130705,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130705,38.22,0.46,440,60675,70,NULL,NULL,'SDSS J153156.74+090103.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000163,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.9864583,9.01778,0.093,NULL,56420740248,881574066,13774594,18.6),(130706,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130706,33.85,0.49,58.8,60676,75,NULL,'IR','ESO 514- G 022',NULL,'2011yCatp016004901K',2011,1,1.66,NULL,'G',0.000027,NULL,'15.5',0.2,'Sc',NULL,NULL,NULL,NULL,1,232.989375,-24.77264,0.405,NULL,46612207872,728315748,11379933,15.5),(130707,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130707,34,0.55,63.1,60676,NULL,NULL,NULL,'ESO 514- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130708,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130708,34.05,0.2,64.6,60676,74.4,NULL,NULL,'ESO 514- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130709,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130709,34.11,0.52,66.4,60676,NULL,NULL,'Malmquist cor.','ESO 514- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130710,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130710,34.12,0.43,66.8,60676,75,NULL,'3.6 micron, color + selection bias corrected','ESO 514- G 022',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130711,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130711,34.16,0.43,67.8,60676,75,NULL,'3.6 micron, color corrected','ESO 514- G 022',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130712,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130712,34.25,NULL,70.7,60676,NULL,NULL,NULL,'ESO 514- G 022',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130713,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130713,34.58,NULL,82.2,60676,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 514- G 022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130714,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130714,34.59,NULL,82.7,60676,NULL,NULL,'Dipole + Quadrupole','ESO 514- G 022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130715,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130715,34.59,NULL,82.9,60676,NULL,NULL,'Dipole','ESO 514- G 022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130716,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130716,36.08,0.46,164,60677,70,NULL,NULL,'2MASX J15315805+2514138',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00017,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,232.9919583,25.23717,0.145,NULL,59899449498,935928898,14623889,16.5),(130717,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130717,37.17,0.46,272,60678,70,NULL,NULL,'2MASX J15315947+3455530',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000179,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.997625,34.93144,0.049,NULL,59885209253,935706394,14620412,16.5),(130718,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130718,37.53,0.27,321,60679,70,NULL,NULL,'SDSS J153159.43+585438.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.997625,58.91058,0.009,NULL,57587833653,899809900,14059529,18.3),(130719,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130719,36.04,0.46,162,60680,70,NULL,NULL,'2MASX J15315971+3351270',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000176,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.999083,33.85736,0.045,NULL,59886222735,935722230,14620659,16.4),(130720,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130720,37.33,0.46,293,60681,70,NULL,NULL,'2MASX J15320008+1727555',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,233.0002917,17.46547,0.117,NULL,59436154489,928689913,14510779,16.9),(130721,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130721,37.55,0.11,323,60682,70,NULL,NULL,'2MASXi J1532007+280522',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.003,28.08956,0.085,NULL,59918684299,936229442,14628585,17.6),(130722,'SNIa','2016-12-15 15:15:35','2016-12-16 11:20:49','1','SN 2003K',NULL,130722,33.56,0.19,50.4,60683,74.2,NULL,'SALT 2','IC 1129',0.0219,'2010ApJ...716..712A',2010,1,1.1,NULL,'G',0.000033,NULL,'13.81',0.9,'Scd:','in a radial-velocity based grouping',NULL,NULL,NULL,1,233.003416667,68.24633,0.057,NULL,57970509181,905789205,14152956,13.81),(130723,'SNIa','2016-12-15 15:15:35','2016-12-16 11:20:49','1','SN 2003K',NULL,130723,34.14,0.1,67.3,60683,74.4,NULL,NULL,'IC 1129',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130724,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130724,35.63,0.46,134,60684,70,NULL,NULL,'CGCG 136-007',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000176,NULL,'15.5g',0.49,NULL,NULL,NULL,NULL,NULL,1,233.004833,25.57167,0.161,NULL,59899887451,935935741,14623995,15.5),(130725,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130725,37.28,0.46,286,60685,70,NULL,NULL,'2MASX J15320158+1138453',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,233.006625,11.64592,0.101,NULL,59341891998,927217062,14487766,16.9),(130726,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130726,37.78,0.33,360,60686,70,NULL,NULL,'2MASX J15320168+0149370',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.007041667,1.827,0.097,NULL,56399251394,881238303,13769348,17.5),(130727,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130727,35.58,0.46,131,60687,70,NULL,NULL,'2MASX J15320183+0451070',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,233.0077083,4.85194,0.101,NULL,56425130632,881642666,13775666,16.3),(130728,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130728,36.92,0.46,242,60688,70,NULL,NULL,'2MASX J15320208+0015140',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000077,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,233.008833,0.25389,0.213,NULL,56397833661,881216150,13769002,17.2),(130729,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130729,36.54,0.46,203,60689,70,NULL,NULL,'2MASX J15320226+3016290',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.8',0.37,'candidate      BLLAC',NULL,NULL,NULL,'BL Lac ?',1,233.009333,30.27472,0.08,NULL,59913005156,936140705,14627198,16.8),(130730,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130730,37.37,0.33,297,60690,70,NULL,NULL,'2MASX J15320294+3053270',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000173,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.01225,30.891,0.073,NULL,59914838102,936169345,14627646,17.2),(130731,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130731,37.3,0.33,289,60691,70,NULL,NULL,'SDSS J153204.30+485058.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,233.017958333,48.84961,0.045,NULL,59719033409,933109897,14579842,18.2),(130732,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130732,37.78,0.33,360,60692,70,NULL,NULL,'2MASX J15320621+0144560',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,233.0260417,1.74903,0.097,NULL,56399262106,881238470,13769351,17.5),(130733,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130733,37.97,0.33,394,60693,70,NULL,NULL,'2MASX J15320730+3131410',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,233.030458333,31.52817,0.053,NULL,59915516217,936179940,14627811,17.9),(130734,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130734,38.36,0.46,470,60694,70,NULL,NULL,'SDSS J153207.87+242534.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000148,NULL,'18.8g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.032833,24.42636,0.141,NULL,59417544423,928399131,14506236,18.8),(130735,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130735,37.8,0.33,363,60695,70,NULL,NULL,'2MASX J15320866+1126123',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,233.0360417,11.43681,0.097,NULL,59341609454,927212647,14487697,17.8),(130736,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130736,37.76,0.23,356,60696,70,NULL,NULL,'2MASX J15320897-0017388',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000092,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,233.037416667,-0.29403,0.277,NULL,45405647894,709463248,11085363,17.2),(130737,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130737,37.53,0.27,321,60697,70,NULL,NULL,'2MASX J15320963+5854187',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000222,NULL,'15.7g',0.51,'Elliptical     Sy2',NULL,NULL,NULL,NULL,1,233.040375,58.90508,0.009,NULL,57587832954,899809889,14059529,15.7),(130738,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130738,36.26,0.46,179,60698,70,NULL,NULL,'2MASX J15320995+3741386',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',NULL,NULL,'16.52',0.5,NULL,NULL,NULL,NULL,NULL,1,233.041583333,37.69397,0.061,NULL,60098889041,939045141,14672580,16.52),(130739,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130739,37.92,0.46,384,60699,70,NULL,NULL,'2MASX J15321048+5216063',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000195,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,233.043583,52.26847,0.045,NULL,59672666628,932385416,14568522,17.1),(130740,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130740,37.55,0.11,323,60700,70,NULL,NULL,'2MASX J15321063+2806127',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000067,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,233.044417,28.10342,0.085,NULL,59918687576,936229493,14628585,16.4),(130741,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130741,36.26,0.46,178,60701,70,NULL,NULL,'2MASX J15321198+4726308',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000164,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,233.05,47.44194,0.045,NULL,59718902487,933107851,14579810,16.3),(130742,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130742,37.27,0.46,284,60702,70,NULL,NULL,'2MASX J15321402+5136543',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000142,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,233.0585,51.61517,0.033,NULL,59673372563,932396446,14568694,17.7),(130743,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130743,37.64,0.46,337,60703,70,NULL,NULL,'2MASX J15321414+2555054',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000153,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,233.059,25.91833,0.161,NULL,59899689833,935932653,14623947,17.3),(130744,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130744,36.08,0.46,164,60704,70,NULL,NULL,'CGCG 078-005',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000127,NULL,'15.1g',0.56,NULL,NULL,NULL,NULL,NULL,1,233.0654583,9.46556,0.053,NULL,56408198348,881378099,13771532,15.1),(130745,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130745,37.18,0.46,273,60705,70,NULL,NULL,'2MASX J15321567+2032338',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,233.0654583,20.54292,0.189,NULL,59455599345,928993739,14515527,17.5),(130746,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130746,37.91,0.33,382,60706,70,NULL,NULL,'2MASX J15321576+2334238',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000186,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,233.06575,23.57328,0.153,NULL,59417047728,928391370,14506115,17.9),(130747,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130747,37.45,0.46,309,60707,70,NULL,NULL,'2MASX J15321636+0037566',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000085,NULL,'16.7g',NULL,NULL,NULL,NULL,NULL,NULL,1,233.068166667,0.63231,0.201,NULL,56398642336,881228786,13769199,16.7),(130748,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130748,37.8,0.33,363,60708,70,NULL,NULL,'2MASX J15321675+1122183',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,233.0699583,11.37161,0.085,NULL,59341615881,927212748,14487699,16.8),(130749,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130749,37.8,0.46,363,60709,70,NULL,NULL,'SDSS J153217.07+114458.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.071167,11.7495,0.105,NULL,59341192080,927206126,14487595,18.1),(130750,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130750,37.32,0.46,291,60710,70,NULL,NULL,'2MASX J15321730+1912148',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,233.072083,19.20394,0.161,NULL,59443691577,928807680,14512620,17),(130751,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130751,34.32,0.75,73.1,60711,NULL,NULL,NULL,'ESO 582- G 018',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.73',0.5,'S...',NULL,NULL,NULL,NULL,1,233.074833333,-20.47353,0.589,NULL,46639126173,728736346,11386505,14.73),(130752,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130752,34.59,0.2,82.8,60711,74.4,NULL,NULL,'ESO 582- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130753,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130753,34.76,0.61,89.6,60711,NULL,NULL,'Malmquist cor.','ESO 582- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130754,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130754,34.11,0.69,66.2,60712,100,NULL,'mid-IR','CGCG 022-008',NULL,'2013ApJ...771...88L',2013,1,1.4,NULL,'G',0.00015,NULL,'14.7',0.9,'SA(s)m?',NULL,NULL,NULL,NULL,1,233.076833,-2.82236,0.377,NULL,45411978329,709562161,11086908,14.7),(130755,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130755,37.55,0.11,323,60713,70,NULL,NULL,'2MASX J15321851+2802444',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000097,NULL,'16.34',0.1,NULL,NULL,NULL,NULL,NULL,1,233.077041667,28.04564,0.085,NULL,59918702941,936229733,14628589,16.34),(130756,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130756,37.51,0.46,318,60714,70,NULL,NULL,'2MASX J15321917+2200095',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,233.07975,22.00256,0.137,NULL,59452038697,928938104,14514657,16.4),(130757,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130757,37.35,0.46,295,60715,70,NULL,NULL,'2MASX J15321948+2922574',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'16.71',0.21,NULL,NULL,NULL,NULL,NULL,1,233.081167,29.38264,0.061,NULL,59926287961,936348249,14630441,16.71),(130758,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130758,36.91,0.46,241,60716,70,NULL,NULL,'2MASX J15321963+0011356',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000097,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,233.0817083,0.19325,0.213,NULL,56397914577,881217415,13769022,16.6),(130759,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130759,37.44,0.33,308,60717,70,NULL,NULL,'2MASX J15321991-0030108',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000087,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.082875,-0.50294,0.277,NULL,45406316461,709473694,11085526,17.4),(130760,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130760,36.13,0.14,168,60718,70,NULL,NULL,'2MASX J15321997+0503056',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'15.6g',0.47,NULL,NULL,NULL,NULL,NULL,1,233.083125,5.05144,0.101,NULL,56425101814,881642215,13775659,15.6),(130761,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130761,37.21,0.46,276,60719,70,NULL,NULL,'2MASX J15322150+0030216',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000074,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,233.089541667,0.50597,0.201,NULL,56398617523,881228398,13769193,17),(130762,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130762,36.04,0.46,161,60720,70,NULL,NULL,'2MASX J15322256+0100096',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000081,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,233.094,1.00278,0.169,NULL,56398147280,881221051,13769078,16.3),(130763,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130763,35.14,0.53,107,60721,70,NULL,NULL,'2MASX J15322312-0645528',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000027,NULL,'16.55',0.8,NULL,NULL,NULL,NULL,NULL,1,233.096333,-6.76478,0.397,NULL,45388626940,709197295,11081207,16.55),(130764,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130764,37.55,0.11,323,60722,70,NULL,NULL,'2MASX J15322320+2757184',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00008,NULL,'15.3R',0.37,NULL,NULL,NULL,NULL,NULL,1,233.096625,27.95522,0.085,NULL,59918709242,936229831,14628591,15.3),(130765,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130765,37.34,0.14,294,60723,70,NULL,NULL,'2MASX J15322384+3104169',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.0992083,31.07153,0.069,NULL,59914792284,936168629,14627634,17.9),(130766,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130766,35.2,0.49,110,60724,70,NULL,NULL,'2MASX J15322417-1223547',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.03',NULL,NULL,NULL,NULL,NULL,NULL,1,233.1007917,-12.39864,0.533,NULL,46657544322,729024130,11391002,16.03),(130767,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130767,37.89,0.46,378,60725,70,NULL,NULL,'2MASX J15322450+1058256',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000148,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,233.102167,10.97372,0.077,NULL,56405519368,881336240,13770878,17.7),(130768,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130768,36.81,0.46,230,60726,70,NULL,NULL,'2MASX J15322470+2205235',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,233.102917,22.08992,0.137,NULL,59452058508,928938414,14514662,16.9),(130769,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130769,37.28,0.46,285,60727,70,NULL,NULL,'2MASX J15322526+5805188',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000155,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.1054583,58.08872,0.025,NULL,57588498539,899820289,14059692,17.2),(130770,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130770,37.89,0.33,379,60728,70,NULL,NULL,'2MASX J15322531+2121205',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,233.105583,21.35581,0.161,NULL,59456339243,929005300,14515707,16.2),(130771,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130771,37.3,0.33,289,60729,70,NULL,NULL,'2MASX J15322581+4849594',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.0002,NULL,'15.6g',0.45,'E0',NULL,NULL,NULL,NULL,1,233.107458333,48.83325,0.045,NULL,59721933637,933155213,14580550,15.6),(130772,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130772,37.54,0.27,322,60730,70,NULL,NULL,'2MASX J15322580+1045386',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000177,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,233.107625,10.76072,0.069,NULL,56405374884,881333982,13770843,16.6),(130773,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130773,37.75,0.46,355,60731,70,NULL,NULL,'2MASX J15322668+1429078',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,233.111167,14.48553,0.117,NULL,59427378627,928552791,14508637,NULL),(130774,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130774,36.13,0.14,168,60732,70,NULL,NULL,'2MASX J15322820+0440516',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'17.04',0.3,NULL,NULL,NULL,NULL,NULL,1,233.117583333,4.68108,0.109,NULL,56424993820,881640528,13775633,17.04),(130775,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130775,38.42,0.46,483,60733,70,NULL,NULL,'2MASX J15322902+2218215',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,233.120833,22.306,0.145,NULL,59452126021,928939469,14514679,17.6),(130776,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130776,37.44,0.33,308,60734,70,NULL,NULL,'SDSS J153229.11-002755.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000066,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,233.121333,-0.46556,0.277,NULL,45405617430,709462772,11085355,18.2),(130777,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130777,37.54,0.27,322,60735,70,NULL,NULL,'2MASX J15322919+1046236',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,233.1215417,10.77322,0.069,NULL,56405374532,881333977,13770843,18.3),(130778,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130778,37.55,0.11,323,60736,70,NULL,NULL,'2MASX J15322916+2759104',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000083,NULL,'16.35',0.1,NULL,NULL,NULL,NULL,NULL,1,233.121667,27.98633,0.085,NULL,59918712824,936229887,14628591,16.35),(130779,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130779,37.25,0.46,282,60737,70,NULL,NULL,'SDSS J153230.75-011436.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000079,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,233.128166667,-1.24358,0.317,NULL,45405989500,709468585,11085446,18.1),(130780,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130780,37.91,0.33,382,60738,70,NULL,NULL,'2MASX J15323104+2334405',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,233.1295,23.57814,0.153,NULL,59417042909,928391295,14506113,17.7),(130781,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130781,37.74,0.46,354,60739,70,NULL,NULL,'2MASX J15323187+2441564',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000138,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,233.132833,24.699,0.145,NULL,59417479157,928398111,14506220,17.7),(130782,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130782,36.13,0.14,168,60740,70,NULL,NULL,'UGC 09886',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.00012,NULL,'15.1',1,'S0-:;BrClG','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,233.133416667,4.681,0.109,NULL,56424994689,881640542,13775633,15.1),(130783,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130783,37.37,0.33,297,60741,70,NULL,NULL,'2MASX J15323220+3050120',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000183,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,233.134166667,30.83664,0.073,NULL,59914810367,936168911,14627639,17.2),(130784,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130784,38,0.19,398,60742,70,NULL,NULL,'2MASX J15323224+0148116',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,233.134208333,1.80328,0.149,NULL,56401106847,881267294,13769801,18.1),(130785,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130785,37.65,0.46,338,60743,70,NULL,NULL,'2MASX J15323239+5341254',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000177,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,233.1347083,53.69053,0.041,NULL,59670231150,932347361,14567927,17.6),(130786,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130786,37.22,0.46,278,60744,70,NULL,NULL,'2MASX J15323262+0635116',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,233.135958333,6.58647,0.105,NULL,56416500105,881507814,13773559,16.6),(130787,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130787,39.29,0.46,722,60745,70,NULL,NULL,'SDSS J153233.09+241226.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.137875,24.20733,0.141,NULL,59417117226,928392456,14506132,18.1),(130788,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130788,37.37,0.46,298,60746,70,NULL,NULL,'2MASX J15323396+3101220',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000137,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,233.141541667,31.02275,0.069,NULL,59914837838,936169341,14627645,18.5),(130789,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130789,35.82,0.46,146,60747,70,NULL,NULL,'2MASX J15323457+3854585',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000178,NULL,'15.6g',0.37,'S0',NULL,NULL,NULL,NULL,1,233.1440417,38.91622,0.053,NULL,60100036180,939063065,14672860,15.6),(130790,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130790,36.13,0.14,168,60748,70,NULL,NULL,'2MASX J15323489+0441316',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,233.145333,4.69214,0.109,NULL,56424994133,881640533,13775633,17.2),(130791,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130791,35.21,0.46,110,60749,70,NULL,NULL,'CGCG 078-006',NULL,'2015arXiv151105856S',2015,1,0.84,'Position in 1991AJ....102.1581B is incorrect.','G',0.0001,NULL,'14.9g',0.52,NULL,NULL,NULL,NULL,NULL,1,233.1455417,10.31906,0.061,NULL,56408949116,881389829,13771716,14.9),(130792,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130792,38,0.19,398,60750,70,NULL,NULL,'2MASX J15323537+0147176',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,233.147375,1.78825,0.149,NULL,56401124233,881267566,13769805,17.5),(130793,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130793,36.13,0.14,168,60751,70,NULL,NULL,'2MASX J15323576+0444326',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'15.9g',0.4,NULL,NULL,NULL,NULL,NULL,1,233.149041667,4.74244,0.109,NULL,56425046780,881641355,13775646,15.9),(130794,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130794,37.55,0.11,323,60752,70,NULL,NULL,'2MASX J15323687+2802104',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00013,NULL,'16.51',0.2,'dE5?;cand. dwarf','Dwarf, within FOV of cluster',NULL,NULL,NULL,1,233.1537083,28.03614,0.085,NULL,59918698422,936229662,14628588,16.51),(130795,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130795,37.65,0.46,339,60753,70,NULL,NULL,'2MASX J15323706-0108297',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000103,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.154416667,-1.14147,0.317,NULL,45406193961,709471780,11085496,17),(130796,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130796,37.54,0.27,322,60754,70,NULL,NULL,'2MASX J15323720+1044466',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.1550417,10.74619,0.069,NULL,56405373689,881333963,13770843,17.5),(130797,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130797,38.32,0.46,462,60755,70,NULL,NULL,'SDSS J153237.44+062825.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.1560417,6.47386,0.105,NULL,56416420714,881506573,13773540,18),(130798,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130798,37.97,0.46,392,60756,70,NULL,NULL,'2MASX J15323772+2028295',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,233.157125,20.47506,0.189,NULL,59457444751,929022574,14515977,17.8),(130799,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130799,37.13,0.46,267,60757,70,NULL,NULL,'SDSS J153238.00+310715.0',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,233.158333,31.12083,0.089,NULL,59914670098,936166720,14627605,17.2),(130800,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130800,38,0.19,398,60758,70,NULL,NULL,'2MASX J15323953+0148139',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,233.1647917,1.80394,0.149,NULL,56401131549,881267680,13769807,17.2),(130801,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130801,37.58,0.46,329,60759,70,NULL,NULL,'2MASX J15324097+3859394',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000178,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,233.170833,38.99431,0.053,NULL,60100031060,939062985,14672859,16.4),(130802,'BCG','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130802,37.7,0.35,323,60760,60,NULL,NULL,'ABELL 2089',0.0743,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',0.000337,NULL,NULL,NULL,'II     [BM]',NULL,NULL,NULL,NULL,1,233.172167,28.01547,0.085,NULL,59918699664,936229682,14628588,NULL),(130803,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130803,36.63,0.46,212,60761,70,NULL,NULL,'2MASX J15324418+3506140',NULL,'2015arXiv151105856S',2015,1,0.36,'The FIRST source is 7.6 arcsec to the southeast.','G',0.000161,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,233.184083,35.10375,0.061,NULL,59885077193,935704331,14620380,16.9),(130804,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130804,37.55,0.11,323,60762,70,NULL,NULL,'B2 1530+28',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'15.5',0.2,'AGN',NULL,NULL,NULL,NULL,1,233.186417,28.06314,0.085,NULL,59918690783,936229543,14628586,15.5),(130805,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130805,37.29,0.46,288,60763,70,NULL,NULL,'2MASX J15324590+3634225',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,233.191167,36.57292,0.045,NULL,60098148278,939033566,14672399,17),(130806,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130806,37.45,0.46,309,60764,70,NULL,NULL,'2MASX J15324612+5602108',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000145,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,233.1922083,56.03636,0.009,NULL,57592665507,899885398,14060709,16.9),(130807,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130807,36.79,0.46,228,60765,70,NULL,NULL,'2MASX J15324637+0418299',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.0g',0.32,NULL,NULL,NULL,NULL,NULL,1,233.1932083,4.30836,0.109,NULL,56424716523,881636195,13775565,16),(130808,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130808,36.72,0.46,220,60766,70,NULL,NULL,'2MASX J15324666+3625164',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000175,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,233.194333,36.42119,0.045,NULL,60098092208,939032690,14672385,16.6),(130809,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130809,36.07,0.46,164,60767,70,NULL,NULL,'CGCG 136-009',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000157,NULL,'15.4',0.53,NULL,NULL,NULL,NULL,NULL,1,233.194667,23.18481,0.129,NULL,59451675460,928932429,14514569,15.4),(130810,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130810,38,0.19,398,60768,70,NULL,NULL,'2MASX J15324820+0207379',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,233.200875,2.12731,0.113,NULL,56401241031,881269391,13769834,17.3),(130811,'BCG','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130811,37.7,0.35,323,60769,60,NULL,'ABELL 2089, BCG','2MASX J15324982+2802224',0.0743,'1980ApJ...241..486H',1980,1,1.1,NULL,'G',0.000067,NULL,'14.5R',0.4,'cD','Brightest group member',NULL,NULL,NULL,1,233.207625,28.0395,0.085,NULL,59918700255,936229691,14628588,14.5),(130812,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130812,37.55,0.11,323,60769,70,NULL,NULL,'2MASX J15324982+2802224',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130813,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130813,37.89,0.33,379,60770,70,NULL,NULL,'2MASX J15325009+2127280',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.208583333,21.45767,0.173,NULL,59456194236,929003034,14515672,18.2),(130814,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130814,37.61,0.46,333,60771,70,NULL,NULL,'2MASX J15325025+2151410',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,233.209458333,21.86144,0.141,NULL,59451512184,928929877,14514529,17.2),(130815,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130815,35.56,0.58,129,60772,70,NULL,NULL,'2MASX J15325210-0650082',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.0001,NULL,'16.71',0.5,NULL,NULL,NULL,NULL,NULL,1,233.2169583,-6.83569,0.397,NULL,45388438727,709194355,11081161,16.71),(130816,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130816,36.66,0.46,215,60773,70,NULL,NULL,'SDSS J153252.71+302532.5',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000177,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,233.219625,30.42572,0.061,NULL,59912986695,936140417,14627194,16.2),(130817,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130817,37.14,0.46,268,60774,70,NULL,NULL,'2MASX J15325397+1307034',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.224916667,13.11767,0.113,NULL,59425491170,928523299,14508176,17.4),(130818,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130818,36.42,0.46,192,60775,70,NULL,NULL,'2MASX J15325447+3324120',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000135,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,233.227,33.40331,0.069,NULL,59885820633,935715947,14620561,17),(130819,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130819,37.44,0.46,307,60776,70,NULL,NULL,'SDSS J153254.75-012537.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000153,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,233.228167,-1.42719,0.317,NULL,45414098985,709595296,11087426,18.6),(130820,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130820,36.61,0.46,210,60777,70,NULL,NULL,'2MASX J15325566+4204186',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000186,NULL,'16.1g',0.31,'S0^-',NULL,NULL,NULL,NULL,1,233.2317917,42.07175,0.069,NULL,59963330782,936927043,14639485,16.1),(130821,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130821,37.41,0.46,304,60778,70,NULL,NULL,'2MASX J15325701+0150319',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,233.237625,1.84225,0.149,NULL,56401119684,881267495,13769804,16.9),(130822,'Tully est','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130822,30.87,0.8,15,60779,75,NULL,'B','UGC 09893',NULL,'1988NBGC.C....0000T',1988,1,1.39,NULL,'G',0.00002,NULL,'14.9g',0.48,'Pec','Isolated galaxy',NULL,NULL,NULL,1,233.238667,46.45264,0.025,NULL,59685742691,932589729,14571714,14.9),(130823,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130823,37.35,0.27,296,60780,70,NULL,NULL,'SDSS J153257.95+453345.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.2415,45.56275,0.017,NULL,59688644812,932635075,14572423,18),(130824,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130824,36.19,0.27,173,60781,70,NULL,NULL,'CGCG 022-010',NULL,'2015arXiv151105856S',2015,1,0.95,NULL,'G',0.00006,NULL,'14.8g',0.64,'E0','Group member',NULL,NULL,NULL,1,233.2417917,0.44072,0.201,NULL,56397769517,881215148,13768986,14.8),(130825,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130825,35.96,0.46,155,60782,70,NULL,NULL,'CGCG 022-011',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000084,NULL,'15.9g',0.26,'S0',NULL,NULL,NULL,NULL,1,233.2419583,0.71069,0.189,NULL,56398580019,881227812,13769184,15.9),(130826,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130826,36.5,0.46,199,60783,70,NULL,NULL,'2MASX J15325908+0742550',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000178,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,233.24625,7.71536,0.073,NULL,56421267833,881582309,13774723,16.5),(130827,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130827,37.55,0.11,323,60784,70,NULL,NULL,'2MASX J15325912+2753405',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000073,NULL,'15.4R',0.7,NULL,NULL,NULL,NULL,NULL,1,233.2465,27.89472,0.089,NULL,59918679721,936229370,14628583,15.4),(130828,'SNIa','2016-12-15 15:15:35','2016-12-16 11:20:49','1','SN CLN12Did','N',130828,43.28,0.09,2450,60785,71.6,NULL,'MLCS2k2','SN CLN12Did',0.851,'2014ApJ...786....9P',2013,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130829,'SNIa','2016-12-15 15:15:35','2016-12-16 11:20:49','1','SN CLN12Did','N',130829,43.33,0.15,2500,60785,71.6,NULL,'SALT 2','SN CLN12Did',0.851,'2014ApJ...786....9P',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130830,'SNIa','2016-12-15 15:15:35','2016-12-16 11:20:49','1','SN CLN12Did','N',130830,43.43,0.09,2620,60785,71.6,NULL,'MLCS2k2 + G Lens = 0.15 mag','SN CLN12Did',0.851,'2014ApJ...786....9P',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130831,'SNIa','2016-12-15 15:15:35','2016-12-16 11:20:49','1','SN CLN12Did','N',130831,43.57,0.15,2800,60785,71.6,NULL,'SALT 2 + G Lens = 0.24 mag','SN CLN12Did',0.851,'2014ApJ...786....9P',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130832,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130832,36.5,0.33,200,60786,70,NULL,NULL,'2MASX J15325995+0058089',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000097,NULL,'15.9g',0.43,NULL,NULL,NULL,NULL,NULL,1,233.249875,0.96917,0.181,NULL,56402481407,881288771,13770137,15.9),(130833,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130833,35.36,0.2,118,60787,74.4,NULL,NULL,'CGCG 136-010',NULL,'2013AJ....146...86T',2013,1,0.68,NULL,'G',0.000088,NULL,'15.7g',0.42,'Sa',NULL,NULL,NULL,NULL,1,233.252,25.56867,0.157,NULL,59899850818,935935169,14623987,15.7),(130834,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130834,36.2,0.46,173,60788,70,NULL,NULL,'SDSS J153300.86+171625.7',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.253625,17.27381,0.101,NULL,59437964085,928718188,14511221,17.2),(130835,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130835,37.97,0.46,393,60789,70,NULL,NULL,'2MASX J15330162+0017019',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,'PHOT','17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,233.256667,0.28383,0.213,NULL,56397899053,881217172,13769018,17.3),(130836,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130836,36.19,0.27,173,60790,70,NULL,NULL,'2MASX J15330228+0025119',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.2g',0.32,NULL,NULL,NULL,NULL,NULL,1,233.259625,0.41994,0.201,NULL,56397767957,881215124,13768986,16.2),(130837,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130837,37.83,0.46,368,60791,70,NULL,NULL,'2MASX J15330365+3336069',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000176,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,233.2652917,33.60186,0.053,NULL,59886083600,935720056,14620625,17.1),(130838,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130838,38,0.19,398,60792,70,NULL,NULL,'SDSS J153303.75+015714.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.265625,1.95411,0.149,NULL,56401308929,881270452,13769850,18.3),(130839,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130839,37.51,0.46,318,60793,70,NULL,NULL,'2MASX J15330525+3129219',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,233.2719583,31.48936,0.065,NULL,59914192713,936159261,14627488,18.2),(130840,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130840,32.2,0.69,27.6,60794,100,NULL,'mid-IR','IC 1125',NULL,'2013ApJ...771...88L',2013,1,1.4,'Noted possibly interacting in MCG/UGC, coalescent pair in VV.  Star superposed.','G',0.00002,NULL,'14.2g',0.69,'S-Irr          HII','Pair member (points to parent)',NULL,NULL,NULL,1,233.273375,-1.62825,0.317,NULL,45415142492,709611601,11087681,14.2),(130841,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130841,32.26,0.43,28.3,60794,75,NULL,'3.6 micron, color + selection bias corrected','IC 1125',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130842,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130842,32.39,0.43,30,60794,75,NULL,'3.6 micron, color corrected','IC 1125',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130843,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130843,32.5,0.2,31.6,60794,74.4,NULL,NULL,'IC 1125',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130844,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130844,32.65,0.49,33.9,60794,75,NULL,'IR','IC 1125',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130845,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130845,32.72,0.6,35,60794,NULL,NULL,'Malmquist cor.','IC 1125',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130846,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130846,32.74,0.59,35.3,60794,NULL,NULL,NULL,'IC 1125',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130847,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130847,37.9,0.46,380,60795,70,NULL,NULL,'SDSS J153305.62+005430.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000073,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,233.273417,0.90858,0.181,NULL,56402456181,881288377,13770130,18.5),(130848,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130848,37.83,0.46,368,60796,70,NULL,NULL,'2MASX J15330706+0327393',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000081,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.27925,3.46078,0.085,NULL,56393646940,881150733,13767980,17.3),(130849,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130849,37.22,0.46,278,60797,70,NULL,NULL,'2MASX J15330723+0707120',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,233.2800417,7.11986,0.105,NULL,56416232987,881503640,13773494,16.7),(130850,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130850,36.13,0.14,168,60798,70,NULL,NULL,'2MASX J15330725+0445203',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'16.93',0.39,NULL,NULL,NULL,NULL,NULL,1,233.2802083,4.75564,0.109,NULL,56425846698,881653854,13775841,16.93),(130851,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130851,38.63,0.46,532,60799,70,NULL,NULL,'SDSS J153307.49+195744.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000142,NULL,'18.6g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.28125,19.96228,0.229,NULL,59456905028,929014141,14515845,18.6),(130852,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130852,37.97,0.46,392,60800,70,NULL,NULL,'2MASX J15330797+0649510',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,233.283167,6.83069,0.097,NULL,56416330282,881505160,13773518,17.4),(130853,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130853,37.55,0.11,323,60801,70,NULL,NULL,'SDSS J153308.81+275823.3',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,233.2867083,27.97314,0.085,NULL,59918671287,936229238,14628581,NULL),(130854,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130854,37.35,0.27,296,60802,70,NULL,NULL,'2MASX J15330906+4533516',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,233.287667,45.56433,0.017,NULL,59688645171,932635080,14572423,16.5),(130855,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130855,35.73,0.57,140,60803,70,NULL,NULL,'2MASX J15330950-0151579',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.000103,NULL,'15.6g',0.3,'E0',NULL,NULL,NULL,NULL,1,233.2897083,-1.86603,0.337,NULL,45412300347,709567192,11086987,15.6),(130856,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130856,35.97,0.46,156,60803,70,NULL,NULL,'2MASX J15330950-0151579',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130857,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130857,37.26,0.33,283,60804,70,NULL,NULL,'2MASX J15331002+2729204',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.8g',0.19,'AGN',NULL,NULL,NULL,NULL,1,233.2917917,27.48897,0.105,NULL,59918247114,936222611,14628478,16.8),(130858,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130858,36.19,0.27,173,60805,70,NULL,NULL,'2MASX J15331041+0029263',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000097,NULL,'16.2g',0.41,'E0',NULL,NULL,NULL,NULL,1,233.2934583,0.49075,0.201,NULL,56397763951,881215061,13768985,16.2),(130859,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130859,37.75,0.33,354,60806,70,NULL,NULL,'2MASX J15331066+2207451',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.294417,22.12928,0.145,NULL,59451543491,928930367,14514536,17.9),(130860,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130860,38.7,0.46,548,60807,70,NULL,NULL,'2MASX J15331163+5223411',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00017,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.2982917,52.39481,0.045,NULL,59670818719,932356542,14568070,18.5),(130861,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130861,38,0.19,398,60808,70,NULL,NULL,'2MASX J15331201+0148403',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,233.300083333,1.81117,0.149,NULL,56401093925,881267092,13769798,17.5),(130862,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130862,37.31,0.46,290,60809,70,NULL,NULL,'2MASX J15331219+2852004',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000135,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.30075,28.86681,0.061,NULL,59926196231,936346816,14630419,17.4),(130863,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130863,34.41,0.46,76.3,60810,70,NULL,NULL,'CGCG 222-025',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000147,NULL,'14.6g',0.64,'E0',NULL,NULL,NULL,NULL,1,233.304833,41.07661,0.061,NULL,59965898581,936967165,14640111,14.6),(130864,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130864,37.34,0.14,294,60811,70,NULL,NULL,'SDSS J153315.10+310357.1',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000192,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,233.312958333,31.06589,0.069,NULL,59914828743,936169199,14627643,17.4),(130865,'BCG','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130865,38.03,0.35,378,60812,60,NULL,'ABELL 2092, BCG','2MASX J15331536+3108430',0.0669,'1980ApJ...241..486H',1980,1,NULL,NULL,'GPair',0.00015,NULL,NULL,NULL,NULL,'Brightest group member',NULL,NULL,NULL,1,233.3132083,31.14483,0.069,NULL,59914696275,936167129,14627611,NULL),(130866,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130866,38.55,0.46,514,60813,70,NULL,NULL,'SDSS J153315.47+305440.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000177,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.3145,30.91111,0.069,NULL,59914822086,936169095,14627642,18),(130867,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130867,38.05,0.46,408,60814,70,NULL,NULL,'2MASX J15331591+0927186',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000149,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,233.3162917,9.45525,0.073,NULL,56407849376,881372646,13771447,17.1),(130868,'BCG','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130868,38.03,0.35,378,60815,60,NULL,NULL,'ABELL 2092',0.0669,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III [BM]',NULL,NULL,NULL,NULL,1,233.320833,31.14861,0.069,NULL,59914696479,936167132,14627611,NULL),(130869,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130869,38.3,0.46,456,60816,70,NULL,NULL,'2MASX J15331774+0046013',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000093,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,233.323875,0.76708,0.189,NULL,56402706751,881292292,13770192,17.7),(130870,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130870,37.35,0.27,296,60817,70,NULL,NULL,'SDSS J153319.27+453116.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000179,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.330333333,45.52125,0.017,NULL,59688647698,932635120,14572423,18.1),(130871,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130871,37.38,0.46,299,60818,70,NULL,NULL,'2MASX J15331991+2040232',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,233.332917,20.67317,0.189,NULL,59457565771,929024465,14516007,18),(130872,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130872,37.55,0.11,323,60819,70,NULL,NULL,'2MASX J15332081+2804017',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000113,NULL,'15.97',0.23,NULL,NULL,NULL,NULL,NULL,1,233.3367083,28.06708,0.085,NULL,59918770546,936230789,14628606,15.97),(130873,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130873,37.86,0.46,373,60820,70,NULL,NULL,'SDSS J153321.19+265546.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.3382917,26.92969,0.137,NULL,59919041080,936235016,14628672,18.4),(130874,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130874,36.13,0.14,168,60821,70,NULL,NULL,'CGCG 050-024',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00008,NULL,'15.6',0.4,NULL,NULL,NULL,NULL,NULL,1,233.340417,4.47275,0.109,NULL,56424264640,881629135,13775455,15.6),(130875,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130875,36.5,0.33,200,60822,70,NULL,NULL,'2MASX J15332181+0046433',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000093,NULL,'16.1g',0.37,'E0',NULL,NULL,NULL,NULL,1,233.340791667,0.77864,0.189,NULL,56402708123,881292314,13770192,16.1),(130876,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130876,38.58,0.46,520,60823,70,NULL,NULL,'2MASX J15332206+3113440',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00017,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,233.341875,31.22878,0.069,NULL,59914689565,936167024,14627609,18.1),(130877,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130877,37.18,0.46,273,60824,70,NULL,NULL,'2MASX J15332396+5313012',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000179,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.349833333,53.21708,0.045,NULL,59669591283,932337363,14567771,17.1),(130878,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130878,37.56,0.46,326,60825,70,NULL,NULL,'2MASX J15332526+4823102',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000158,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.355333333,48.38628,0.041,NULL,59719181293,933112207,14579878,17.1),(130879,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130879,35.15,0.52,107,60826,70,NULL,NULL,'2MASX J15332594-0505469',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00005,NULL,'15.1',NULL,NULL,NULL,NULL,NULL,NULL,1,233.358166667,-5.09639,0.377,NULL,45420117187,709689331,11088895,15.1),(130880,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130880,37.72,0.46,350,60827,70,NULL,NULL,'2MASX J15332610+0959097',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.3589583,9.98606,0.077,NULL,56409119172,881392487,13771757,17.6),(130881,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130881,36.59,0.69,208,60828,70,NULL,NULL,'2MASX J15332709-3224091',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.4,NULL,NULL,NULL,NULL,NULL,1,233.3629583,-32.40261,0.481,NULL,47162558371,736914974,11514296,14.2),(130882,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130882,30.85,0.4,14.8,60829,75,NULL,'B','NGC 5963',NULL,'1988NBGC.C....0000T',1988,1,3.3,NULL,'G',0.000033,NULL,'13.1g',2.6,'S pec','Pair member (points to parent)',NULL,NULL,NULL,1,233.366083,56.55969,0,NULL,57592429404,899881709,14060651,13.1),(130883,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130883,32.26,0.6,28.3,60829,NULL,NULL,NULL,'NGC 5963',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130884,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130884,32.3,0.2,28.8,60829,74.4,NULL,NULL,'NGC 5963',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130885,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130885,32.39,0.57,30.1,60829,NULL,NULL,'Malmquist cor.','NGC 5963',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130886,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130886,32.65,0.4,33.9,60829,NULL,NULL,NULL,'NGC 5963',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130887,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130887,36.27,0.46,180,60830,70,NULL,NULL,'2MASX J15332894+1014307',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000174,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,233.370833,10.24194,0.061,NULL,56409160902,881393139,13771767,16.3),(130888,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130888,37.81,0.46,365,60831,70,NULL,NULL,'2MASX J15333070+5905045',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000183,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,233.3777917,59.08453,0.009,NULL,57633970460,900530788,14070793,17.1),(130889,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130889,37.53,0.46,321,60832,70,NULL,NULL,'2MASX J15333155+3014104',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000109,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,233.381375,30.23642,0.069,NULL,59912785894,936137279,14627144,18.1),(130890,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130890,37.85,0.46,371,60833,70,NULL,NULL,'2MASX J15333209+2227492',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,233.383667,22.46378,0.149,NULL,59451955053,928936797,14514637,16.8),(130891,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130891,37.34,0.14,294,60834,70,NULL,NULL,'2MASX J15333376+3111394',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00013,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,233.390541667,31.19422,0.069,NULL,59914696890,936167138,14627611,16.7),(130892,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130892,37.75,0.33,354,60835,70,NULL,NULL,'2MASX J15333404+2213303',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'16.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,233.3920417,22.22508,0.145,NULL,59451458890,928929045,14514516,16.4),(130893,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130893,36.64,0.46,213,60836,70,NULL,NULL,'2MASX J15333432+3341584',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000067,NULL,'16.25',0.4,NULL,NULL,NULL,NULL,NULL,1,233.393083,33.69961,0.061,NULL,59885412202,935709565,14620461,16.25),(130894,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130894,37.47,0.46,312,60837,70,NULL,NULL,'2MASX J15333528+1827523',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000175,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,233.397125,18.46458,0.133,NULL,59435620498,928681570,14510649,16.5),(130895,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130895,36.56,0.46,205,60838,70,NULL,NULL,'2MASX J15333556+0710507',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,233.398125,7.18083,0.105,NULL,56416633994,881509906,13773592,16.8),(130896,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130896,38.04,0.46,406,60839,70,NULL,NULL,'SDSS J153336.94-004051.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000079,NULL,'18.9g',0.1,NULL,NULL,NULL,NULL,NULL,1,233.403916667,-0.68089,0.277,NULL,45413951593,709592993,11087390,18.9),(130897,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130897,37.26,0.33,283,60840,70,NULL,NULL,'2MASX J15333718+2731206',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,233.4050417,27.52233,0.105,NULL,59918250497,936222664,14628479,17.9),(130898,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130898,38.49,0.46,498,60841,70,NULL,NULL,'2MASX J15333977+3836012',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000173,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,233.415667,38.60036,0.049,NULL,60100141399,939064709,14672886,18),(130899,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130899,35.65,0.46,135,60842,70,NULL,NULL,'CGCG 136-012',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000167,NULL,'15.1g',0.68,NULL,NULL,NULL,NULL,NULL,1,233.416583333,24.40469,0.141,NULL,59417389502,928396710,14506198,15.1),(130900,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130900,37.86,0.46,373,60843,70,NULL,NULL,'2MASX J15334194+0947547',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,233.4247083,9.79842,0.061,NULL,56408223682,881378495,13771538,17.9),(130901,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130901,37.72,0.46,350,60844,70,NULL,NULL,'2MASX J15334256+0753137',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,233.427375,7.88714,0.081,NULL,56419214958,881550233,13774222,17.7),(130902,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130902,37.34,0.14,294,60845,70,NULL,NULL,'2MASX J15334274+3036185',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000193,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,233.4279583,30.60525,0.065,NULL,59912806554,936137602,14627150,16.2),(130903,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130903,37.86,0.46,373,60846,70,NULL,NULL,'2MASX J15334296-0105401',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000101,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,233.428916667,-1.09464,0.313,NULL,45414263340,709597864,11087466,16.9),(130904,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130904,38.53,0.46,508,60847,70,NULL,NULL,'2MASX J15334293+0026371',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000091,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,233.428916667,0.44386,0.201,NULL,56402070109,881282345,13770036,18.1),(130905,'IRAS','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130905,32.3,0.8,28.9,60848,75,NULL,'A82, H','NGC 5951',NULL,'1997ApJS..109..333W',1997,1,3.5,'HOLM 713B is a star.','G',0.000003,NULL,'13.36',0.8,'SBc: sp','in a triple',NULL,NULL,NULL,1,233.429416667,15.00728,0.097,NULL,59427743487,928558491,14508726,13.36),(130906,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130906,31.55,0.4,20.4,60848,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5951',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130907,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130907,31.66,0.4,21.5,60848,75,NULL,NULL,'NGC 5951',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130908,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130908,31.94,0.47,24.5,60848,75,NULL,'A82, H, inv','NGC 5951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130909,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130909,31.97,0.47,24.7,60848,75,NULL,'A82, H, raw','NGC 5951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130910,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130910,31.99,0.2,25,60848,74.4,NULL,NULL,'NGC 5951',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130911,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130911,32.07,0.36,25.9,60848,NULL,NULL,NULL,'NGC 5951',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130912,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130912,32.07,0.43,25.9,60848,75,NULL,'3.6 micron, color corrected','NGC 5951',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130913,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130913,32.17,0.4,27.1,60848,NULL,NULL,'mean','NGC 5951',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130914,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130914,32.16,0.43,27.1,60848,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5951',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130915,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130915,32.17,0.49,27.2,60848,75,NULL,'IR','NGC 5951',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130916,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130916,32.25,0.47,28.2,60848,75,NULL,'A82, H, cor','NGC 5951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130917,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130917,32.35,0.4,29.5,60848,75,NULL,'B','NGC 5951',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130918,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130918,32.45,0.46,30.9,60848,NULL,NULL,'J','NGC 5951',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130919,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130919,32.57,0.47,32.6,60848,NULL,NULL,'H','NGC 5951',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130920,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130920,32.62,0.45,33.5,60848,NULL,NULL,'K','NGC 5951',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130921,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130921,38.24,0.46,444,60849,70,NULL,NULL,'2MASX J15334340+0900467',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,233.430875,9.013,0.089,NULL,56419077534,881548086,13774188,17.5),(130922,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130922,37.89,0.46,379,60850,70,NULL,NULL,'2MASX J15334379+0529111',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,233.4324583,5.48631,0.113,NULL,56425659911,881650936,13775795,17.7),(130923,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130923,37.63,0.46,336,60851,70,NULL,NULL,'2MASX J15334388+5633384',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000166,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,233.432875,56.56078,0,NULL,57592420452,899881569,14060649,16.9),(130924,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130924,37.58,0.46,328,60852,70,NULL,NULL,'SDSS J153344.27+292034.2',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000179,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.4345,29.34283,0.061,NULL,59927112236,936361128,14630642,17.1),(130925,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130925,35.27,0.46,113,60853,70,NULL,NULL,'2MASX J15334448+3913422',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00015,NULL,'15.7g',0.37,'S0             HII',NULL,NULL,NULL,NULL,1,233.4352083,39.22833,0.053,NULL,60099870152,939060471,14672819,15.7),(130926,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130926,37.24,0.46,281,60854,70,NULL,NULL,'2MASX J15334512+1821182',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.4379583,18.35517,0.121,NULL,59435644994,928681953,14510655,18.2),(130927,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130927,37.3,0.46,289,60855,70,NULL,NULL,'SDSS J153345.28+384728.1',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,233.4387083,38.79114,0.053,NULL,60100169280,939065145,14672892,17.3),(130928,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130928,34.46,0.46,77.8,60856,70,NULL,NULL,'CGCG 136-013',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000083,NULL,'15.2',0.48,'E?','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,233.439417,21.01061,0.169,NULL,59456097055,929001516,14515648,15.2),(130929,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130929,37.63,0.33,336,60857,70,NULL,NULL,'2MASX J15334592+3140325',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00011,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,233.44125,31.67567,0.065,NULL,59914334312,936161473,14627523,15.6),(130930,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130930,36.92,0.46,242,60858,70,NULL,NULL,'2MASX J15334596+3618472',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,233.4415417,36.31308,0.049,NULL,59878993004,935609265,14618894,17.1),(130931,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130931,34.7,0.52,87.3,60859,70,NULL,NULL,'MCG -01-40-003',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.5',0.4,NULL,NULL,NULL,NULL,NULL,1,233.442833,-8.77722,0.473,NULL,45398065229,709344769,11083512,15.5),(130932,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130932,36.65,0.33,213,60860,70,NULL,NULL,'2MASX J15334776+0656155',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,233.449167,6.93769,0.085,NULL,56416602516,881509414,13773584,16.5),(130933,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130933,37.63,0.33,336,60861,70,NULL,NULL,'2MASX J15334788+3141335',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00014,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,233.449417,31.69261,0.065,NULL,59914332406,936161443,14627522,16.8),(130934,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130934,37.28,0.46,286,60862,70,NULL,NULL,'2MASX J15334934+4034440',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000141,NULL,'17.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,233.455667,40.57897,0.041,NULL,59965401227,936959394,14639990,17.1),(130935,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130935,36.54,0.46,204,60863,70,NULL,NULL,'SDSS J153350.29+092851.4',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'17.1g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.4595417,9.48097,0.073,NULL,56407824099,881372251,13771441,17.1),(130936,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130936,37.34,0.14,294,60864,70,NULL,NULL,'2MASX J15335075+3113024',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,233.4615,31.21739,0.069,NULL,59914220979,936159702,14627495,18.1),(130937,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130937,36.79,0.46,228,60865,70,NULL,NULL,'2MASXi J1533517+232924',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000181,NULL,'15.9g',0.35,NULL,NULL,NULL,NULL,NULL,1,233.465541667,23.49008,0.149,NULL,59450356459,928911819,14514247,15.9),(130938,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130938,37.55,0.46,323,60866,70,NULL,NULL,'2MASX J15335191+3107594',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,233.466167,31.13319,0.069,NULL,59914207833,936159497,14627492,17.5),(130939,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130939,37.53,0.46,321,60867,70,NULL,NULL,'2MASX J15335258+5809588',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00014,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.4692083,58.16625,0.009,NULL,57588553327,899821145,14059705,18),(130940,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130940,37.34,0.14,294,60868,70,NULL,NULL,'2MASX J15335432+3106264',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.4764583,31.10747,0.069,NULL,59914207252,936159488,14627492,18),(130941,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130941,36.43,0.46,193,60869,70,NULL,NULL,'2MASX J15335474+3249334',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,233.478167,32.82603,0.065,NULL,59883858836,935685294,14620082,17.2),(130942,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130942,37.34,0.14,294,60870,70,NULL,NULL,'2MASX J15335503+3108504',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000097,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,233.479333,31.14736,0.069,NULL,59914208014,936159500,14627492,16.8),(130943,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130943,37.55,0.11,323,60871,70,NULL,NULL,'SDSS J153355.28+275402.6',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000107,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,233.4805,27.90069,0.085,NULL,59918551154,936227361,14628552,NULL),(130944,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130944,37.13,0.46,266,60872,70,NULL,NULL,'2MASX J15335542+5250292',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000177,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,233.480916667,52.84144,0.049,NULL,59671365308,932365082,14568204,16.7),(130945,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130945,38.45,0.27,490,60873,70,NULL,NULL,'2MASX J15335548+0715295',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.23,'BrClG',NULL,NULL,NULL,NULL,1,233.4809583,7.25806,0.113,NULL,56416770287,881512035,13773625,17.2),(130946,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130946,37.15,0.46,269,60874,70,NULL,NULL,'2MASX J15335578-0135551',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.482417,-1.59867,0.337,NULL,45415352082,709614876,11087732,17.8),(130947,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130947,36.88,0.46,238,60875,70,NULL,NULL,'2MASX J15335704+0649255',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'17.32',0.31,NULL,NULL,NULL,NULL,NULL,1,233.4877083,6.82372,0.085,NULL,56416929410,881514522,13773664,17.32),(130948,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130948,38.45,0.27,490,60876,70,NULL,NULL,'2MASX J15335742+0718025',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,233.489083,7.30067,0.113,NULL,56416778598,881512165,13773627,17.5),(130949,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130949,37.34,0.14,294,60877,70,NULL,NULL,'2MASX J15335750+3023134',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000163,NULL,'16.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,233.489666667,30.38697,0.061,NULL,59912786323,936137286,14627145,16.4),(130950,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130950,38.45,0.27,490,60878,70,NULL,NULL,'2MASX J15335971+0718325',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,233.498875,7.30889,0.113,NULL,56416779543,881512180,13773627,17.4),(130951,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130951,38.42,0.46,482,60879,70,NULL,NULL,'2MASX J15340006+2246201',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.5002083,22.77225,0.153,NULL,59453809456,928965772,14515090,18.3),(130952,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130952,36.65,0.33,213,60880,70,NULL,NULL,'2MASX J15340025+0654015',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000127,NULL,'15.6g',0.45,NULL,NULL,NULL,NULL,NULL,1,233.501,6.90033,0.085,NULL,56417455881,881522748,13773792,15.6),(130953,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130953,34.23,0.59,70.2,60881,70,NULL,NULL,'2MASX J15340046-1555172',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.0001,NULL,'15.61',NULL,NULL,NULL,NULL,NULL,NULL,1,233.501833,-15.92167,0.365,NULL,46605692831,728213950,11378342,15.61),(130954,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130954,38.26,0.46,449,60882,70,NULL,NULL,'2MASX J15340050-0107171',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000075,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,233.5022917,-1.12136,0.313,NULL,45414256009,709597750,11087464,18.4),(130955,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130955,37.72,0.33,351,60883,70,NULL,NULL,'2MASX J15340132+0724185',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,233.505583,7.40525,0.113,NULL,56416772902,881512076,13773626,17.1),(130956,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130956,36.72,0.46,220,60884,70,NULL,NULL,'SDSS J153401.88+385338.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.507875,38.89403,0.053,NULL,60099942873,939061607,14672837,17.7),(130957,'SNII optical','2016-12-15 15:15:35','2016-12-16 11:20:49','1','SN 2001cm',NULL,130957,33.18,0.1,42.3,60885,NULL,NULL,'SEAM','NGC 5965',0.011381,'2009ApJ...694.1067P',2009,1,6.16,NULL,'G',0.000017,NULL,'11.5B',0.84,'Sb','Pair member (points to parent)',NULL,NULL,NULL,1,233.51025,56.68561,0,NULL,57592392514,899881133,14060642,11.5),(130958,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130958,33.21,NULL,43.8,60885,NULL,NULL,'Dipole','NGC 5965',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130959,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130959,33.22,NULL,44,60885,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 5965',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130960,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130960,33.22,NULL,44,60885,NULL,NULL,'Dipole + Quadrupole','NGC 5965',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130961,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130961,33.27,NULL,45.2,60885,NULL,NULL,NULL,'NGC 5965',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130962,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130962,33.35,0.46,46.8,60885,NULL,NULL,'J','NGC 5965',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130963,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130963,33.41,0.47,48,60885,NULL,NULL,'H','NGC 5965',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130964,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130964,33.43,0.49,48.4,60885,75,NULL,'IR','NGC 5965',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130965,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130965,33.47,0.4,49.4,60885,NULL,NULL,'mean','NGC 5965',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130966,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130966,33.48,0.37,49.7,60885,NULL,NULL,'Malmquist cor.','NGC 5965',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130967,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130967,33.51,0.45,50.3,60885,NULL,NULL,'K','NGC 5965',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130968,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130968,33.58,0.2,52,60885,74.4,NULL,NULL,'NGC 5965',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130969,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130969,33.6,0.35,52.4,60885,NULL,NULL,NULL,'NGC 5965',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130970,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130970,34.3,0.2,72.4,60886,74.4,NULL,NULL,'CGCG 136-016',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.000127,NULL,'14.6',0.4,NULL,NULL,NULL,NULL,NULL,1,233.517083333,22.93425,0.157,NULL,59453844221,928966315,14515098,14.6),(130971,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130971,37.17,0.46,272,60887,70,NULL,NULL,'2MASX J15340597+5601589',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000192,NULL,'16.0g',0.44,NULL,NULL,NULL,NULL,NULL,1,233.524958333,56.03308,0.009,NULL,57592714372,899886162,14060721,16),(130972,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130972,37.52,0.46,319,60888,70,NULL,NULL,'2MASX J15340674-0108006',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000089,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,233.5280417,-1.13347,0.313,NULL,45414253251,709597707,11087464,17.1),(130973,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130973,34.64,0.46,84.8,60889,70,NULL,NULL,'CGCG 107-005',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000169,NULL,'15.7g',0.35,NULL,NULL,NULL,NULL,NULL,1,233.5289583,18.64922,0.137,NULL,59442759774,928793121,14512392,15.7),(130974,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130974,35.67,NULL,136,60890,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1913',NULL,'2010Ap&SS.325..163P',2010,1,0.95,NULL,'G',0.000014,NULL,'16.6',0.1,'Scd',NULL,NULL,NULL,NULL,1,233.52925,11.65975,0.105,NULL,56405107063,881329797,13770778,16.6),(130975,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130975,35.69,NULL,137,60890,NULL,NULL,'Dipole + Quadrupole','FGC 1913',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130976,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130976,35.71,NULL,139,60890,NULL,NULL,'Dipole','FGC 1913',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130977,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130977,35.71,NULL,139,60890,NULL,NULL,NULL,'FGC 1913',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130978,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130978,36.49,0.2,199,60890,74.4,NULL,NULL,'FGC 1913',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130979,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130979,37.26,0.46,284,60891,70,NULL,NULL,'2MASX J15340721+5703339',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000181,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,233.5302083,57.05939,0.021,NULL,57590907871,899857935,14060280,16.7),(130980,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130980,37.82,0.46,366,60892,70,NULL,NULL,'2MASX J15340832+2226131',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,233.534625,22.43706,0.149,NULL,59451448419,928928881,14514513,17.5),(130981,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130981,37.72,0.33,351,60893,70,NULL,NULL,'SDSS J153409.47+072124.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.5394583,7.35689,0.113,NULL,56416781366,881512208,13773628,17.9),(130982,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130982,37.34,0.14,294,60894,70,NULL,NULL,'2MASX J15340950+3113529',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00015,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,233.539583,31.23131,0.069,NULL,59914222527,936159726,14627495,17.3),(130983,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130983,37.35,0.23,296,60895,70,NULL,NULL,'2MASX J15341075+2708105',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.12',0.33,NULL,NULL,NULL,NULL,NULL,1,233.544833,27.13633,0.129,NULL,59919081264,936235644,14628681,17.12),(130984,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130984,38.25,0.46,446,60896,70,NULL,NULL,'2MASX J15341147+0627475',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.18,'BrClG',NULL,NULL,NULL,NULL,1,233.5479583,6.46331,0.125,NULL,56416829864,881512966,13773640,17.6),(130985,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130985,37.74,0.46,354,60897,70,NULL,NULL,'SDSS J153412.05-012948.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000161,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,233.55025,-1.49686,0.317,NULL,45414201928,709596905,11087451,18.2),(130986,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130986,37.55,0.11,323,60898,70,NULL,NULL,'SDSS J153412.41+280327.6',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000178,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,233.5517083,28.05767,0.093,NULL,59918762921,936230670,14628604,16.5),(130987,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130987,34.86,0.49,93.8,60899,70,NULL,NULL,'2MASX J15341393-2111527',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.0001,NULL,'15.47',NULL,NULL,NULL,NULL,NULL,NULL,1,233.558083,-21.19803,0.529,NULL,46638952594,728733634,11386463,15.47),(130988,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130988,37.35,0.23,296,60900,70,NULL,NULL,'2MASX J15341454+2657475',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,233.5607083,26.96328,0.133,NULL,59919100841,936235950,14628686,16.4),(130989,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130989,38.19,0.46,435,60901,70,NULL,NULL,'2MASX J15341470+0810565',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,233.5612917,8.18219,0.117,NULL,56419263270,881550988,13774234,18),(130990,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130990,37.45,0.19,309,60902,70,NULL,NULL,'2MASXi J1534149+551658',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,233.562375,55.28286,0.053,NULL,57586448966,899788265,14059191,17.8),(130991,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130991,35.9,0.33,152,60903,70,NULL,NULL,'2MASX J15341542+2409125',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000168,NULL,'16.87',0.4,NULL,NULL,NULL,NULL,NULL,1,233.564375,24.1535,0.141,NULL,59417103522,928392242,14506128,16.87),(130992,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130992,38.13,0.46,422,60904,70,NULL,NULL,'2MASX J15341761-0137436',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,233.5734583,-1.62894,0.341,NULL,45415291736,709613933,11087717,18),(130993,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130993,37.4,0.33,302,60905,70,NULL,NULL,'2MASX J15341801+0017365',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000096,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,233.575041667,0.29347,0.241,NULL,56401883228,881279425,13769991,16.7),(130994,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130994,37.99,0.46,396,60906,70,NULL,NULL,'2MASX J15341920+5225522',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.5802917,52.43106,0.045,NULL,59670831296,932356739,14568074,17.5),(130995,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130995,35.16,0.46,108,60907,70,NULL,NULL,'2MASX J15341928+5447139',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000166,NULL,'15.7g',0.45,'E/S0',NULL,NULL,NULL,NULL,1,233.580375,54.78731,0.053,NULL,57586518561,899789352,14059208,15.7),(130996,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130996,38.42,0.46,483,60908,70,NULL,NULL,'2MASX J15341940+5220542',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000186,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,233.5807917,52.34856,0.045,NULL,59671028353,932359818,14568122,17.5),(130997,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130997,36.98,0.46,249,60909,70,NULL,NULL,'2MASX J15342119+2523434',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.00021,NULL,'16.0g',0.33,NULL,NULL,NULL,NULL,NULL,1,233.58825,25.39542,0.157,NULL,59899068027,935922937,14623795,16),(130998,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130998,36.67,0.46,215,60910,70,NULL,NULL,'2MASX J15342315+0155305',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,233.5965,1.92519,0.169,NULL,56404648120,881322626,13770666,NULL),(130999,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130999,37.35,0.23,296,60911,70,NULL,NULL,'2MASX J15342336+2700414',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,233.597417,27.01142,0.129,NULL,59919105806,936236028,14628687,17.2),(131000,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131000,37.17,0.91,271,60912,70,NULL,NULL,'2MASX J15342434-1329382',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,233.6014583,-13.494,0.637,NULL,46590675834,727979309,11374676,15.6),(131001,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131001,37.18,0.46,273,60913,70,NULL,NULL,'2MASX J15342594+1155301',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,233.60825,11.92492,0.105,NULL,56405026714,881328542,13770758,17.2),(131002,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131002,38.1,0.46,416,60914,70,NULL,NULL,'2MASX J15342682+5823529',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000134,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,233.611917,58.39814,0.009,NULL,57588393596,899818649,14059666,18.3),(131003,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131003,33.5,0.49,50.2,60915,75,NULL,'IR','UGC 09901',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000003,NULL,'15.06',0.2,'Sbc',NULL,NULL,NULL,NULL,1,233.61225,12.271,0.101,NULL,59559127663,930611369,14540802,15.06),(131004,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131004,33.53,0.2,50.8,60915,74.4,NULL,NULL,'UGC 09901',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131005,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131005,33.7,0.47,55,60915,NULL,NULL,NULL,'UGC 09901',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131006,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131006,33.85,0.44,58.8,60915,NULL,NULL,'Malmquist cor.','UGC 09901',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131007,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131007,35.95,0.19,155,60916,70,NULL,NULL,'2MASX J15342763+2509174',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000174,NULL,'16.7g',0.35,'AGN',NULL,NULL,NULL,NULL,1,233.6150417,25.15483,0.145,NULL,59899078343,935923099,14623798,16.7),(131008,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131008,37.35,0.46,295,60917,70,NULL,NULL,'2MASX J15342813+4457245',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000196,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,233.617375,44.95689,0.017,NULL,59686615230,932603362,14571927,16.5),(131009,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131009,37.35,0.23,296,60918,70,NULL,NULL,'2MASX J15342912+2659164',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'16.71',0.33,NULL,NULL,NULL,NULL,NULL,1,233.6212917,26.98778,0.129,NULL,59919103528,936235992,14628687,16.71),(131010,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131010,36.28,0.82,180,60919,70,NULL,NULL,'2MASX J15342946-0448213',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'17.12',0.3,NULL,NULL,NULL,NULL,NULL,1,233.622583,-4.80597,0.401,NULL,45419854253,709685222,11088831,17.12),(131011,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131011,35.47,NULL,124,60920,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1917',NULL,'2010Ap&SS.325..163P',2010,1,0.93,NULL,'G',0.000098,NULL,'17.3g',0.11,'Sd',NULL,NULL,NULL,NULL,1,233.625833,33.99092,0.053,NULL,59885450095,935710157,14620471,17.3),(131012,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131012,35.49,NULL,125,60920,NULL,NULL,'Dipole + Quadrupole','FGC 1917',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131013,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131013,35.51,NULL,126,60920,NULL,NULL,'Dipole','FGC 1917',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131014,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131014,35.52,NULL,127,60920,NULL,NULL,NULL,'FGC 1917',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131015,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131015,37.01,0.46,253,60921,70,NULL,NULL,'2MASX J15343043+3031159',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,233.626958333,30.52114,0.061,NULL,59912751291,936136738,14627136,16.9),(131016,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131016,35.95,0.19,155,60922,70,NULL,NULL,'2MASX J15343095+2510264',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000194,NULL,'16.3g',0.34,'AGN',NULL,NULL,NULL,NULL,1,233.629,25.17406,0.153,NULL,59899080574,935923133,14623798,16.3),(131017,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131017,37.34,0.14,294,60923,70,NULL,NULL,'2MASX J15343112+3137039',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,233.6297083,31.61775,0.065,NULL,59914349206,936161706,14627526,17.4),(131018,'Tully est','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131018,32.59,0.8,33,60924,75,NULL,'B','NGC 5953',NULL,'1988NBGC.C....0000T',1988,1,1.35,NULL,'G',0.00002,NULL,'13.0g',1.16,'SAa: pec;LINER;Sy2','Pair member, near/close',NULL,NULL,'Sy 2',1,233.634916667,15.19378,0.093,NULL,59427576022,928555875,14508685,13),(131019,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131019,31.8,0.45,22.9,60924,NULL,NULL,'K','NGC 5953',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131020,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131020,31.84,0.47,23.4,60924,NULL,NULL,'H','NGC 5953',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131021,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131021,31.94,0.46,24.5,60924,NULL,NULL,'J','NGC 5953',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131022,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131022,32.49,0.4,31.5,60924,NULL,NULL,'mean','NGC 5953',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131023,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131023,36.72,0.46,220,60925,70,NULL,NULL,'2MASX J15343282+1118491',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,233.636875,11.31358,0.089,NULL,56405876150,881341814,13770965,17),(131024,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131024,37.66,0.27,341,60926,70,NULL,NULL,'2MASX J15343350+2326513',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,233.6395417,23.44753,0.149,NULL,59450560201,928915003,14514296,18.2),(131025,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131025,36.05,0.46,162,60927,70,NULL,NULL,'CGCG 078-012',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000185,NULL,'15.6g',0.5,NULL,NULL,NULL,NULL,NULL,1,233.64025,8.35083,0.125,NULL,56419249470,881550772,13774230,15.6),(131026,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131026,36.74,0.46,223,60928,70,NULL,NULL,'2MASX J15343412+0408116',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000099,NULL,'16.0g',0.39,'E0',NULL,NULL,NULL,NULL,1,233.642125,4.13661,0.109,NULL,56394091936,881157686,13768088,16),(131027,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131027,37.97,0.33,393,60929,70,NULL,NULL,'2MASX J15343425+1138211',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,233.642667,11.63911,0.105,NULL,56405258302,881332160,13770815,17),(131028,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131028,32.53,0.4,32.1,60930,75,NULL,'B','NGC 5954',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.00001,NULL,'13.7',0.6,'SAB(rs)cd: pec Sy2','Pair member, near/close',NULL,NULL,NULL,1,233.645916667,15.20008,0.093,NULL,59427575974,928555874,14508685,13.7),(131029,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131029,37.74,0.33,353,60931,70,NULL,NULL,'2MASX J15343806+3142064',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000147,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,233.658416667,31.70181,0.065,NULL,59914344031,936161625,14627525,16.6),(131030,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131030,37.97,0.33,393,60932,70,NULL,NULL,'2MASX J15343806+1137491',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,233.6585417,11.63025,0.105,NULL,56405202052,881331282,13770801,16.9),(131031,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131031,37.78,0.46,360,60933,70,NULL,NULL,'2MASX J15343856+3414184',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000148,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.660625,34.23861,0.057,NULL,59885255101,935707110,14620423,17.7),(131032,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131032,37.34,0.14,294,60934,70,NULL,NULL,'2MASX J15343934+3135454',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.0001,NULL,'15.6g',0.5,'E0',NULL,NULL,NULL,NULL,1,233.663875,31.59594,0.065,NULL,59914352226,936161753,14627527,15.6),(131033,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131033,37.56,0.46,325,60935,70,NULL,NULL,'2MASX J15343990+2341353',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,233.6664583,23.69308,0.153,NULL,59450583909,928915373,14514302,17.2),(131034,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131034,37.88,0.46,377,60936,70,NULL,NULL,'VII Zw 612 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000195,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,233.669667,57.62817,0.025,NULL,57591234579,899863040,14060360,17),(131035,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131035,34.73,0.48,88.5,60937,70,NULL,NULL,'2MASX J15344078-1504192',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000133,NULL,'15.56',NULL,NULL,NULL,NULL,NULL,NULL,1,233.6699583,-15.07222,0.433,NULL,46591658228,727994659,11374916,15.56),(131036,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131036,37.45,0.19,309,60938,70,NULL,NULL,'2MASX J15344256+5508279',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000176,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.6775,55.14106,0.053,NULL,57586403504,899787554,14059180,17.8),(131037,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131037,34.43,0.49,76.9,60939,75,NULL,'IR','UGC 09905',NULL,'2011yCatp016004901K',2011,1,0.87,'SDSS DR6 has z = 0.019653 +- 0.000235.','G',0.000117,NULL,'16.4g',0.18,'Scd',NULL,NULL,NULL,NULL,1,233.67875,8.33411,0.125,NULL,56419282334,881551286,13774238,16.4),(131038,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131038,34.91,NULL,96,60939,NULL,NULL,'Dipole','UGC 09905',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131039,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131039,34.91,NULL,96.2,60939,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09905',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131040,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131040,34.92,NULL,96.3,60939,NULL,NULL,'Dipole + Quadrupole','UGC 09905',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131041,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131041,35.21,0.2,110,60939,74.4,NULL,NULL,'UGC 09905',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131042,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131042,35.58,0.44,131,60939,NULL,NULL,NULL,'UGC 09905',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131043,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131043,35.83,0.39,146,60939,NULL,NULL,'Malmquist cor.','UGC 09905',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131044,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131044,36.74,0.46,223,60940,70,NULL,NULL,'2MASX J15344362+1122472',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,233.681917,11.37986,0.081,NULL,56405881184,881341893,13770967,16.8),(131045,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131045,37.4,0.33,302,60941,70,NULL,NULL,'SDSS J153444.10+001834.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000103,NULL,'18.5g',0.12,'NLAGN',NULL,NULL,NULL,NULL,1,233.68375,0.30964,0.229,NULL,56390356096,881099314,13767176,18.5),(131046,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131046,37.45,0.19,309,60942,70,NULL,NULL,'2MASX J15344442+5509249',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000238,NULL,'15.8g',0.51,NULL,NULL,NULL,NULL,NULL,1,233.685,55.15697,0.053,NULL,57586373878,899787091,14059173,15.8),(131047,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131047,36.81,0.33,230,60943,70,NULL,NULL,'2MASX J15344549+2119182',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'17.17',0.36,NULL,NULL,NULL,NULL,NULL,1,233.6895417,21.32181,0.157,NULL,59455995273,928999926,14515623,17.17),(131048,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131048,37.66,0.27,341,60944,70,NULL,NULL,'2MASX J15344724+2329122',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.9g',0.2,'ALG',NULL,NULL,NULL,NULL,1,233.696833,23.48664,0.149,NULL,59450562570,928915040,14514297,17.9),(131049,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131049,38.1,0.33,418,60945,70,NULL,NULL,'SDSS J153448.16+195009.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000148,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.700667,19.83603,0.193,NULL,59457079224,929016862,14515888,18.5),(131050,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131050,38.04,0.33,406,60946,70,NULL,NULL,'2MASX J15344863+0054486',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000085,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.7027083,0.9135,0.213,NULL,56402844716,881294448,13770225,17.3),(131051,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131051,38.47,0.46,495,60947,70,NULL,NULL,'SDSS J153449.64+545219.9',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.00017,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,233.706875,54.87219,0.053,NULL,57586539961,899789686,14059213,18.7),(131052,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131052,35.59,0.46,131,60948,70,NULL,NULL,'NGC 5969',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000083,NULL,'14.8g',0.63,'E/S0',NULL,NULL,NULL,NULL,1,233.712583333,56.45108,0.013,NULL,57592975384,899890240,14060785,14.8),(131053,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131053,36.81,0.33,230,60949,70,NULL,NULL,'2MASX J15345157+2116162',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,233.714875,21.27122,0.157,NULL,59455989148,928999830,14515622,17.7),(131054,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131054,38.41,0.46,482,60950,70,NULL,NULL,'SDSS J153452.15+005300.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000069,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.7172917,0.88356,0.213,NULL,56402844596,881294446,13770225,18.4),(131055,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131055,37.66,0.27,341,60951,70,NULL,NULL,'2MASX J15345267+2328477',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.0001,NULL,'17.5g',0.22,'E',NULL,NULL,NULL,NULL,1,233.7195,23.48003,0.149,NULL,59450438802,928913106,14514267,17.5),(131056,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131056,34.42,0.49,76.7,60952,70,NULL,NULL,'2MASX J15345311-1814534',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,233.7212917,-18.24817,0.413,NULL,46595591377,728056115,11375876,14.9),(131057,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131057,35.22,0.49,111,60953,75,NULL,'IR','UGC 09907',NULL,'2011yCatp016004901K',2011,1,1.13,NULL,'G',0.000102,NULL,'15.6g',0.26,'Sb',NULL,NULL,NULL,NULL,1,233.721833,9.58292,0.061,NULL,56408128133,881377002,13771515,15.6),(131058,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131058,35.36,NULL,118,60953,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09907',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131059,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131059,35.39,NULL,119,60953,NULL,NULL,'Dipole + Quadrupole','UGC 09907',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131060,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131060,35.43,NULL,122,60953,NULL,NULL,'Dipole','UGC 09907',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131061,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131061,37.36,0.46,296,60954,70,NULL,NULL,'2MASX J15345325+3957035',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00014,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,233.721958333,39.95108,0.053,NULL,60096259531,939004055,14671938,18.2),(131062,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131062,38.04,0.33,406,60955,70,NULL,NULL,'2MASX J15345463+0052346',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000083,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,233.727625,0.87636,0.213,NULL,56402814834,881293981,13770218,17.6),(131063,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131063,35.9,0.33,152,60956,70,NULL,NULL,'CGCG 136-018',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00006,NULL,'15.6g',0.43,NULL,NULL,NULL,NULL,NULL,1,233.734625,24.13658,0.141,NULL,59450985620,928921650,14514400,15.6),(131064,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131064,35.9,0.46,152,60957,70,NULL,NULL,'NGC 5952',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000183,NULL,'15.5',0.17,'S0',NULL,NULL,NULL,NULL,1,233.735166667,4.95883,0.117,NULL,56425421193,881647206,13775737,15.5),(131065,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131065,37.74,0.33,353,60958,70,NULL,NULL,'2MASX J15345749+3138124',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000139,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,233.739583,31.63678,0.065,NULL,59914353510,936161773,14627527,18.3),(131066,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131066,37.94,0.19,387,60959,70,NULL,NULL,'2MASX J15345889+3040574',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.745583333,30.68286,0.065,NULL,59914063440,936157241,14627456,17.8),(131067,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131067,37.45,0.19,309,60960,70,NULL,NULL,'2MASX J15345970+5507120',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000187,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,233.748667,55.11997,0.053,NULL,57586410995,899787671,14059182,16.2),(131068,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131068,37.92,0.46,384,60961,70,NULL,NULL,'2MASX J15345984+0035167',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000082,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.749333,0.58794,0.201,NULL,56401971113,881280798,13770012,17.4),(131069,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131069,38.1,0.33,418,60962,70,NULL,NULL,'2MASX J15350001+1949267',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000191,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.75,19.82406,0.193,NULL,59457046812,929016356,14515880,17),(131070,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131070,36.9,0.46,240,60963,70,NULL,NULL,'2MASX J15350111+2320357',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00014,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.754833,23.34328,0.149,NULL,59453896594,928967134,14515111,17.8),(131071,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131071,37.94,0.19,387,60964,70,NULL,NULL,'2MASX J15350122+3047214',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000134,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.755,30.7895,0.065,NULL,59914072757,936157386,14627459,17.9),(131072,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131072,37.53,0.46,321,60965,70,NULL,NULL,'2MASX J15350179+3826343',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,233.757541667,38.44286,0.045,NULL,60099561526,939055648,14672744,18),(131073,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131073,36.2,0.86,174,60966,70,NULL,NULL,'2MASX J15350290-1208392',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,233.762125,-12.14419,0.517,NULL,45382372655,709099572,11079680,15.1),(131074,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131074,37.53,0.46,321,60967,70,NULL,NULL,'2MASX J15350395+0712493',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,233.766583,7.21381,0.113,NULL,56417521234,881523769,13773808,16.8),(131075,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131075,36.66,NULL,215,60968,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1923',NULL,'2010Ap&SS.325..163P',2010,1,0.9,NULL,'G',0.00009,NULL,'17.0g',0.15,'Sc             Sbrst',NULL,NULL,NULL,NULL,1,233.76775,43.14039,0.093,NULL,59963061372,936922833,14639419,17),(131076,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131076,36.67,NULL,215,60968,NULL,NULL,NULL,'FGC 1923',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131077,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131077,36.69,NULL,218,60968,NULL,NULL,'Dipole + Quadrupole','FGC 1923',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131078,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131078,36.74,NULL,223,60968,NULL,NULL,'Dipole','FGC 1923',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131079,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131079,37.08,0.49,260,60968,75,NULL,'IR','FGC 1923',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131080,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131080,37.59,0.46,329,60969,70,NULL,NULL,'2MASX J15350639+1237086',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,233.776667,12.61908,0.105,NULL,59425117078,928517454,14508085,17.4),(131081,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131081,37.94,0.19,387,60970,70,NULL,NULL,'2MASX J15350650+3044424',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.777041667,30.74517,0.065,NULL,59914075112,936157423,14627459,17.9),(131082,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131082,37.1,0.46,263,60971,70,NULL,NULL,'2MASX J15350773+2132527',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.782167,21.54808,0.169,NULL,59455876535,928998070,14515594,17.5),(131083,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131083,35.25,0.2,112,60972,74.4,NULL,NULL,'UGC 09916',NULL,'2013AJ....146...86T',2013,1,1.03,NULL,'G',0.000033,NULL,'16.1g',0.24,'S?',NULL,NULL,NULL,NULL,1,233.7840417,24.10069,0.141,NULL,59450998198,928921846,14514403,16.1),(131084,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131084,35.54,0.49,128,60973,75,NULL,'IR','UGC 09916',NULL,'2011yCatp016004901K',2011,1,1.03,NULL,'G',0.000033,NULL,'16.1g',0.24,'S?',NULL,NULL,NULL,NULL,1,233.7840417,24.10069,0.141,NULL,59450998198,928921846,14514403,16.1),(131085,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131085,36.11,0.46,167,60974,70,NULL,NULL,'2MASX J15350974-0039501',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000107,NULL,'16.2g',0.41,'NLAGN',NULL,NULL,NULL,'Sy 2',1,233.7904583,-0.66389,0.293,NULL,45414019594,709594056,11087407,16.2),(131086,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131086,31.47,0.4,19.7,60975,75,NULL,'B','UGC 09912',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000017,NULL,'14.0',1.7,'SBdm',NULL,NULL,NULL,NULL,1,233.79375,16.54944,0.093,NULL,59441645720,928775714,14512120,14),(131087,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131087,37.48,0.33,313,60976,70,NULL,NULL,'2MASX J15351112+5224247',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00018,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.7965417,52.40675,0.049,NULL,59671013567,932359586,14568118,17),(131088,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131088,36.71,0.46,220,60977,70,NULL,NULL,'2MASX J15351125+3402426',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000154,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,233.796833,34.04508,0.057,NULL,59885272637,935707384,14620427,17),(131089,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131089,36.25,0.46,178,60978,70,NULL,NULL,'2MASX J15351323+0429573',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,233.805291667,4.49919,0.117,NULL,56424149338,881627333,13775427,16.6),(131090,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131090,37.46,0.46,310,60979,70,NULL,NULL,'2MASX J15351341-0220041',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000196,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,233.8059583,-2.33436,0.429,NULL,45415541769,709617840,11087778,17.7),(131091,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131091,37.48,0.33,313,60980,70,NULL,NULL,'2MASX J15351372+5220117',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000203,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,233.807125,52.33644,0.041,NULL,59671049787,932360152,14568127,16.6),(131092,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131092,37.66,0.46,340,60981,70,NULL,NULL,'2MASX J15351557+3408567',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000142,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,233.814833,34.14922,0.057,NULL,59885288044,935707625,14620431,16.8),(131093,'Tully est','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131093,32.28,0.8,28.5,60982,75,NULL,'B','NGC 5961',NULL,'1988NBGC.C....0000T',1988,1,0.8,'HOLM 715C is a star. Multiple SDSS entries describe this object.','G',0.000067,NULL,'14.5',0.3,'Sb','Possible field galaxy',NULL,NULL,NULL,1,233.818,30.86417,0.069,NULL,59914119497,936158117,14627470,14.5),(131094,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131094,32.89,0.2,37.8,60982,74.4,NULL,NULL,'NGC 5961',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131095,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131095,35.14,0.49,107,60983,75,NULL,'IR','UGC 09920',NULL,'2011yCatp016004901K',2011,1,2.18,NULL,'G',0.00001,NULL,'15.0g',0.26,'Sbc',NULL,NULL,NULL,NULL,1,233.823875,30.80328,0.065,NULL,59914067940,936157311,14627457,15),(131096,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131096,35.33,NULL,117,60983,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09920',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131097,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131097,35.35,NULL,117,60983,NULL,NULL,'Dipole + Quadrupole','UGC 09920',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131098,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131098,35.35,NULL,118,60983,NULL,NULL,'Dipole','UGC 09920',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131099,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131099,35.38,NULL,119,60983,NULL,NULL,NULL,'UGC 09920',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131100,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131100,35.56,0.2,129,60983,74.4,NULL,NULL,'UGC 09920',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131101,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131101,33.03,0.2,40.4,60984,74.4,NULL,NULL,'UGC 09917',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000027,NULL,'14.96',0.5,'SB?',NULL,NULL,NULL,NULL,1,233.8295417,20.84239,0.173,NULL,59458321804,929036278,14516191,14.96),(131102,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131102,37.94,0.19,387,60985,70,NULL,NULL,'2MASX J15351958+3041027',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.831667,30.68403,0.065,NULL,59925334652,936333353,14630208,17.2),(131103,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131103,38.43,0.46,484,60986,70,NULL,NULL,'SDSS J153520.09-005930.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000081,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,233.83375,-0.99167,0.309,NULL,45414722723,709605042,11087578,18.5),(131104,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131104,36.07,0.23,163,60987,70,NULL,NULL,'2MASX J15352060+2722594',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,233.83575,27.38325,0.121,NULL,59919203588,936237556,14628711,16.2),(131105,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131105,37.61,0.46,332,60988,70,NULL,NULL,'2MASX J15352121+4150264',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.838416667,41.84056,0.061,NULL,59963477492,936929335,14639520,17),(131106,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131106,37.94,0.19,387,60989,70,NULL,NULL,'2MASX J15352167+3041487',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000194,NULL,'16.8g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,233.84025,30.69681,0.065,NULL,59925346229,936333534,14630211,16.8),(131107,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131107,35.95,0.19,155,60990,70,NULL,NULL,'IC 4556',NULL,'2015arXiv151105856S',2015,1,0.94,NULL,'G',0.00021,NULL,'14.3g',0.85,NULL,'Group member',NULL,NULL,NULL,1,233.8435417,25.29714,0.149,NULL,59899096448,935923382,14623802,14.3),(131108,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131108,37.85,0.46,371,60991,70,NULL,NULL,'2MASX J15352259+3300057',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.84425,33.00167,0.065,NULL,59884157598,935689962,14620155,18.2),(131109,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131109,38.13,0.33,423,60992,70,NULL,NULL,'2MASX J15352340+0942210',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000145,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.8475417,9.70594,0.049,NULL,56408142934,881377233,13771519,17.7),(131110,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131110,37.94,0.19,387,60993,70,NULL,NULL,'2MASX J15352663+3041317',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000198,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,233.861167,30.69208,0.065,NULL,59925346100,936333532,14630211,17),(131111,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131111,38.13,0.33,423,60994,70,NULL,NULL,'2MASX J15352732+0950010',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,233.86375,9.83347,0.049,NULL,56408098705,881376542,13771508,17.4),(131112,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131112,35.95,0.46,155,60995,70,NULL,NULL,'2MASX J15352738+5423023',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000184,NULL,'15.5g',0.48,NULL,NULL,NULL,NULL,NULL,1,233.8642917,54.38394,0.045,NULL,59669971022,932343297,14567864,15.5),(131113,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131113,36.84,0.61,233,60996,70,NULL,NULL,'2MASX J15352824-3307053',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,233.86775,-33.11822,0.553,NULL,47155469641,736804213,11512565,14.2),(131114,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131114,36.38,0.46,189,60997,70,NULL,NULL,'2MASX J15353061-0107101',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000086,NULL,'16.4g',0.28,'S0^-',NULL,NULL,NULL,NULL,1,233.877583,-1.11939,0.337,NULL,45414842744,709606917,11087608,16.4),(131115,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131115,38.45,0.33,491,60998,70,NULL,NULL,'2MASX J15353103+4618083',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.87925,46.30222,0.025,NULL,59688443969,932631937,14572374,17.8),(131116,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131116,37.63,0.46,336,60999,70,NULL,NULL,'SDSS J153531.03+112008.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.879333333,11.33578,0.081,NULL,56405596223,881337440,13770897,18),(131117,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131117,38.58,0.46,520,61000,70,NULL,NULL,'2MASX J15353125+1831076',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,233.880041667,18.51875,0.109,NULL,59435400136,928678127,14510595,18.2),(131118,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131118,37.35,0.46,295,61001,70,NULL,NULL,'2MASX J15353233+3412137',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000144,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,233.884625,34.20383,0.057,NULL,59885286393,935707599,14620431,18.1),(131119,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131119,37.5,0.46,316,61002,70,NULL,NULL,'SDSS J153532.36+015230.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.884875,1.87525,0.157,NULL,56404848597,881325759,13770714,17.9),(131120,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131120,38.02,0.33,401,61003,70,NULL,NULL,'2MASX J15353359+2013566',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000169,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.889917,20.23231,0.189,NULL,59457483654,929023182,14515987,18),(131121,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131121,37.21,0.46,276,61004,70,NULL,NULL,'SDSS J153533.64+402135.6',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.3g',0.4,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.8902083,40.35992,0.041,NULL,59962330869,936911419,14639240,16.3),(131122,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131122,37.27,0.46,284,61005,70,NULL,NULL,'2MASX J15353361+3045127',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000181,NULL,'16.1g',0.38,'E0',NULL,NULL,NULL,NULL,1,233.8902917,30.75347,0.065,NULL,59925344114,936333501,14630210,16.1),(131123,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131123,37.45,0.19,309,61006,70,NULL,NULL,'2MASX J15353438+5514134',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,233.893375,55.23711,0.005,NULL,57586858558,899794664,14059291,16.8),(131124,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131124,36.5,0.33,199,61007,70,NULL,NULL,'SDSS J153535.32+134840.3',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'15.5g',0.46,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.897208333,13.81122,0.125,NULL,59428703604,928573493,14508960,15.5),(131125,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131125,36.82,0.46,231,61008,70,NULL,NULL,'2MASX J15353585-0050017',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000095,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.899417,-0.83381,0.293,NULL,45414691489,709604554,11087571,17.3),(131126,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131126,35.53,0.2,128,61009,74.4,NULL,NULL,'CGCG 136-022',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000077,NULL,'15.7',0.4,'Sc',NULL,NULL,NULL,NULL,1,233.904416667,21.50394,0.169,NULL,59455871662,928997994,14515593,15.7),(131127,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131127,36.03,0.67,161,61010,70,NULL,NULL,'2MASX J15353708-1617416',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.80',NULL,NULL,NULL,NULL,NULL,NULL,1,233.9045,-16.29508,0.341,NULL,46607055333,728235239,11378675,15.8),(131128,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131128,37.3,0.21,288,61011,70,NULL,NULL,'2MASX J15353749+4652333',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,233.906125,46.87589,0.037,NULL,59685518314,932586223,14571659,17.3),(131129,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131129,38.22,0.46,441,61012,70,NULL,NULL,'2MASX J15353772+2107186',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,233.907,21.12203,0.169,NULL,59458047392,929031990,14516124,17.6),(131130,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131130,36.22,0.46,176,61013,70,NULL,NULL,'2MASX J15353902+0852180',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000179,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,233.9125417,8.87178,0.101,NULL,56418839141,881544361,13774130,16.2),(131131,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131131,33.39,0.49,47.7,61014,75,NULL,'IR','UGC 09919',NULL,'2011yCatp016004901K',2011,1,1.58,NULL,'G',0.000006,NULL,'15.30',0.21,'Sc',NULL,NULL,NULL,NULL,1,233.915291667,12.60639,0.105,NULL,59425138603,928517790,14508090,15.3),(131132,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131132,33.48,0.2,49.7,61014,74.4,NULL,NULL,'UGC 09919',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131133,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131133,33.6,NULL,52.5,61014,NULL,NULL,NULL,'UGC 09919',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131134,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131134,33.6,NULL,52.6,61014,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09919',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131135,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131135,33.62,NULL,53,61014,NULL,NULL,'Dipole + Quadrupole','UGC 09919',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131136,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131136,33.65,NULL,53.7,61014,NULL,NULL,'Dipole','UGC 09919',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131137,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131137,33.66,0.44,53.9,61014,NULL,NULL,NULL,'UGC 09919',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131138,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131138,33.81,0.41,57.8,61014,NULL,NULL,'Malmquist cor.','UGC 09919',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131139,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131139,38.29,0.46,454,61015,70,NULL,NULL,'SDSS J153539.97-021152.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000144,NULL,'18.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,233.916583333,-2.19783,0.389,NULL,45415690813,709620168,11087815,18.8),(131140,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131140,38.1,0.46,417,61016,70,NULL,NULL,'2MASX J15354004+0907510',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000159,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,233.917083,9.13075,0.093,NULL,56418737958,881542780,13774105,16.9),(131141,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131141,37.41,0.46,304,61017,70,NULL,NULL,'2MASX J15354100+5237397',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00018,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.92075,52.62758,0.049,NULL,59671414570,932365852,14568216,17.3),(131142,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131142,35.93,0.46,154,61018,70,NULL,NULL,'2MASX J15354109+3328347',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000112,NULL,'15.9g',0.39,'E0',NULL,NULL,NULL,NULL,1,233.9214583,33.47625,0.065,NULL,59883487068,935679485,14619991,15.9),(131143,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131143,37.1,0.46,263,61019,70,NULL,NULL,'2MASX J15354170+2541209',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000146,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,233.923833,25.68914,0.165,NULL,59915821224,936184706,14627886,17.9),(131144,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131144,36.07,0.23,163,61020,70,NULL,NULL,'CGCG 166-017',NULL,'2015arXiv151105856S',2015,1,1.3,NULL,'G',0.000127,NULL,'15.6',0.5,NULL,NULL,NULL,NULL,NULL,1,233.927166667,27.11842,0.121,NULL,59919301595,936239087,14628735,15.6),(131145,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131145,38.02,0.33,401,61021,70,NULL,NULL,'2MASX J15354376+2018236',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,233.932208333,20.30661,0.189,NULL,59457474935,929023045,14515985,17.8),(131146,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131146,38.87,0.46,593,61022,70,NULL,NULL,'SDSS J153543.96+100905.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.9332083,10.15156,0.061,NULL,56407612514,881368945,13771389,18.1),(131147,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131147,37.45,0.19,309,61023,70,NULL,NULL,'2MASX J15354397+5513074',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000184,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.933416667,55.21878,0.005,NULL,57586859463,899794679,14059291,17.6),(131148,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131148,34.56,0.58,81.8,61024,70,NULL,NULL,'2MASX J15354403-1646566',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000043,NULL,'15.65',NULL,NULL,NULL,NULL,NULL,NULL,1,233.9335,-16.78258,0.365,NULL,46606854723,728232105,11378626,15.65),(131149,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131149,38.15,0.46,426,61025,70,NULL,NULL,'2MASX J15354449+5401364',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000175,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,233.935417,54.02686,0.033,NULL,59669965235,932343206,14567862,17.5),(131150,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131150,37.69,0.46,345,61026,70,NULL,NULL,'2MASX J15354474+3945431',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000176,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,233.936333,39.76206,0.057,NULL,60096302401,939004725,14671948,16.7),(131151,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131151,37.78,0.46,360,61027,70,NULL,NULL,'2MASX J15354594+2107016',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,233.9414583,21.11703,0.169,NULL,59458015526,929031492,14516117,18.1),(131152,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131152,36.44,0.09,194,61028,70,NULL,NULL,'2MASX J15354597+2149466',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,233.9415,21.82964,0.177,NULL,59451386489,928927913,14514498,16.1),(131153,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131153,35.72,0.46,139,61029,70,NULL,NULL,'CGCG 050-036',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.0001,NULL,'15.3g',0.47,'E',NULL,NULL,NULL,NULL,1,233.9432083,7.94186,0.093,NULL,56414783905,881480998,13773140,15.3),(131154,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131154,36.35,0.33,186,61030,70,NULL,NULL,'2MASX J15354704+0322590',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,'FoF','16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,233.9459583,3.38292,0.117,NULL,56393979407,881155928,13768061,16.8),(131155,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131155,35.95,0.19,155,61031,70,NULL,NULL,'2MASX J15354774+2514499',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'16.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,233.948917,25.24706,0.149,NULL,59898879124,935919986,14623749,16.1),(131156,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131156,36.35,0.33,186,61032,70,NULL,NULL,'2MASX J15354818+0322400',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.0001,NULL,'15.9g',0.43,'S0',NULL,NULL,NULL,NULL,1,233.95075,3.37792,0.117,NULL,56393981470,881155960,13768061,15.9),(131157,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131157,36.84,0.46,233,61033,70,NULL,NULL,'2MASX J15354896+5600385',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,233.954083333,56.01069,0.005,NULL,57592628429,899884819,14060700,17.4),(131158,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131158,38.41,0.46,481,61034,70,NULL,NULL,'SDSS J153549.41+014627.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.955875,1.77436,0.173,NULL,56404862710,881325979,13770718,18.4),(131159,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131159,38.14,0.46,424,61035,70,NULL,NULL,'SDSS J153549.65+120327.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.956875,12.05769,0.093,NULL,56589612295,884212692,13815823,18),(131160,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131160,36.44,0.09,194,61036,70,NULL,NULL,'2MASX J15354967+2122376',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,233.957,21.37717,0.169,NULL,59457946712,929030417,14516100,16.6),(131161,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131161,36.07,0.46,164,61037,70,NULL,NULL,'2MASX J15355092+3756252',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000169,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,233.9620417,37.94047,0.045,NULL,60098591274,939040488,14672507,16.6),(131162,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131162,37.5,0.46,316,61038,70,NULL,NULL,'SDSS J153551.81+070230.0',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.965917,7.04167,0.121,NULL,56417371070,881521422,13773772,17.3),(131163,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131163,38.51,0.46,503,61039,70,NULL,NULL,'2MASX J15355187+0022490',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000074,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,233.966083,0.38025,0.201,NULL,56390522896,881101920,13767217,18.1),(131164,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131164,36.45,0.46,195,61040,70,NULL,NULL,'2MASX J15355196+3413376',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,233.9664583,34.22706,0.057,NULL,59885237174,935706830,14620419,17),(131165,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131165,33.9,0.45,60.3,61041,NULL,NULL,'K','NGC 5966',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000047,NULL,'13.5g',1.1,'E','Isolated galaxy (6 Mpc isolation)',NULL,NULL,NULL,1,233.96725,39.76894,0.057,NULL,60096299512,939004679,14671948,13.5),(131166,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131166,34.09,0.4,65.8,61041,NULL,NULL,'mean','NGC 5966',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131167,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131167,37.68,0.46,343,61042,70,NULL,NULL,'2MASX J15355240+1125182',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.968416667,11.42161,0.073,NULL,56589943803,884217871,13815904,17.6),(131168,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131168,37.95,0.46,389,61043,70,NULL,NULL,'SDSS J153553.01+312745.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000127,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,233.970916667,31.46256,0.077,NULL,59914157250,936158707,14627479,18.6),(131169,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131169,35.95,0.19,155,61044,70,NULL,NULL,'IC 4559',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000133,NULL,'15.1g',0.59,'AGN','Group member',NULL,NULL,NULL,1,233.973,25.34114,0.149,NULL,59898873844,935919903,14623748,15.1),(131170,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131170,36.64,0.46,213,61045,70,NULL,NULL,'2MASX J15355414+2246004',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'17.02',0.38,NULL,NULL,NULL,NULL,NULL,1,233.975583,22.76675,0.165,NULL,59454104301,928970379,14515162,17.02),(131171,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131171,37.5,0.46,317,61046,70,NULL,NULL,'SDSS J153554.23-010933.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000077,NULL,'18.9g',0.1,NULL,NULL,NULL,NULL,NULL,1,233.975958333,-1.15931,0.337,NULL,45414550305,709602348,11087536,18.9),(131172,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131172,38.32,0.46,462,61047,70,NULL,NULL,'2MASX J15355508+1611332',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,233.979416667,16.19269,0.085,NULL,59441581423,928774709,14512104,18.2),(131173,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131173,36.26,0.46,178,61048,70,NULL,NULL,'2MASX J15355641+2056464',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'16.59',0.38,NULL,NULL,NULL,NULL,NULL,1,233.984917,20.94608,0.173,NULL,59458290885,929035795,14516184,16.59),(131174,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131174,36.05,0.49,162,61049,75,NULL,'IR','UGC 09921 NOTES02',NULL,'2011yCatp016004901K',2011,1,0.84,NULL,'G',0.000207,NULL,'17.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,233.990083,26.37019,0.133,NULL,59916239884,936191248,14627988,17),(131175,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131175,36.89,0.46,238,61050,70,NULL,NULL,'SDSS J153557.63+091309.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000166,NULL,'17.6g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.990125,9.21939,0.093,NULL,56407261177,881363455,13771303,17.6),(131176,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131176,37.29,0.46,287,61051,70,NULL,NULL,'VII Zw 613',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000203,NULL,'16.1g',0.39,NULL,NULL,NULL,NULL,NULL,1,233.991,58.79781,0.013,NULL,57634129446,900533272,14070832,16.1),(131177,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131177,35.91,0.46,152,61052,70,NULL,NULL,'2MASX J15355831+3615062',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000173,NULL,'15.8g',0.41,'S0',NULL,NULL,NULL,NULL,1,233.992791667,36.25169,0.053,NULL,59879036217,935609940,14618905,15.8),(131178,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131178,37.62,0.46,334,61053,70,NULL,NULL,'SDSS J153559.82+454433.3',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000168,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,233.999291667,45.74258,0.017,NULL,59688989403,932640459,14572507,18.4),(131179,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131179,36.13,0.46,168,61054,70,NULL,NULL,'2MASX J15360049+4140512',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00015,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,234.002166667,41.68083,0.077,NULL,59965518059,936961219,14640019,16.6),(131180,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131180,37.33,0.46,293,61055,70,NULL,NULL,'2MASX J15360119+0239258',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000087,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,234.0050417,2.65725,0.169,NULL,56404446610,881319478,13770616,17.1),(131181,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131181,36.14,0.66,169,61056,70,NULL,NULL,'2MASX J15360214-0529123',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,234.008917,-5.48672,0.425,NULL,45416762368,709636912,11088076,15.6),(131182,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131182,36.44,0.09,194,61057,70,NULL,NULL,'2MASX J15360275+2134555',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,234.011417,21.58211,0.173,NULL,59457934153,929030221,14516097,NULL),(131183,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131183,34.48,0.33,78.6,61058,70,NULL,NULL,'I Zw 118 NOTES02',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000063,NULL,'15.3g',0.2,'E0','Pair member, contact system',NULL,NULL,NULL,1,234.011625,43.50347,0.089,NULL,59962821776,936919090,14639360,15.3),(131184,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131184,36.64,0.46,213,61059,70,NULL,NULL,'2MASX J15360407+0218588',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,234.017,2.31622,0.177,NULL,56404296028,881317125,13770580,17.2),(131185,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131185,36.5,0.33,199,61060,70,NULL,NULL,'2MASX J15360450+1357033',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,234.018708333,13.95094,0.117,NULL,59428754352,928574286,14508973,16.7),(131186,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131186,35.76,0.46,142,61061,70,NULL,NULL,'2MASX J15360629+3011216',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000178,NULL,'15.9g',0.43,'S0/a',NULL,NULL,NULL,NULL,1,234.026333333,30.18933,0.065,NULL,59927184900,936362264,14630660,15.9),(131187,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131187,35.79,0.46,144,61062,70,NULL,NULL,'2MASX J15360707+3957381',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000184,NULL,'15.7g',0.33,'S0^-',NULL,NULL,NULL,NULL,1,234.0295417,39.96069,0.053,NULL,60096296963,939004640,14671947,15.7),(131188,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131188,37.54,0.46,322,61063,70,NULL,NULL,'SDSS J153607.59+062640.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.031667,6.44464,0.113,NULL,56414137610,881470900,13772982,18.2),(131189,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131189,38.41,0.33,481,61064,70,NULL,NULL,'2MASX J15360794+1352203',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,234.033041667,13.8725,0.117,NULL,59428710556,928573602,14508962,18),(131190,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131190,36.21,0.46,174,61065,70,NULL,NULL,'2MASX J15360826+0633562',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'17.23',0.37,NULL,NULL,NULL,NULL,NULL,1,234.034375,6.56558,0.113,NULL,56414072972,881469890,13772967,17.23),(131191,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131191,36.67,0.46,215,61066,70,NULL,NULL,'2MASX J15360882+2045525',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'16.67',0.45,NULL,NULL,NULL,NULL,NULL,1,234.0367083,20.7645,0.173,NULL,59458428512,929037945,14516217,16.67),(131192,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131192,38.41,0.33,481,61067,70,NULL,NULL,'2MASX J15360918+1352413',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.0382917,13.87822,0.117,NULL,59428710655,928573603,14508962,17.7),(131193,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131193,37.36,0.46,296,61068,70,NULL,NULL,'2MASX J15360918+3051286',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000133,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.038417,30.858,0.073,NULL,59925370248,936333910,14630217,17.2),(131194,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131194,37.3,0.21,288,61069,70,NULL,NULL,'CGPG 1534.5+4709',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000206,NULL,'16.1g',0.41,'E0',NULL,NULL,NULL,NULL,1,234.0457917,47.01192,0.037,NULL,59685479168,932585612,14571650,16.1),(131195,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131195,38.24,0.46,445,61070,70,NULL,NULL,'2MASX J15361163+4731253',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,234.048333,47.52378,0.037,NULL,59722217949,933159655,14580619,17.4),(131196,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131196,36.78,0.46,227,61071,70,NULL,NULL,'2MASX J15361219+1826494',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'17.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,234.050958333,18.44706,0.109,NULL,59437484888,928710701,14511104,17.6),(131197,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131197,38.48,0.46,496,61072,70,NULL,NULL,'2MASX J15361446+0353468',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00009,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.0602083,3.89614,0.129,NULL,56394122460,881158163,13768096,17.9),(131198,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131198,38.52,0.46,506,61073,70,NULL,NULL,'2MASX J15361483+2531407',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000189,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,234.061833,25.52806,0.173,NULL,59915781932,936184092,14627876,17.4),(131199,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131199,36.07,0.23,163,61074,70,NULL,NULL,'CGCG 166-018',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00016,NULL,'15.4',0.3,NULL,NULL,NULL,NULL,NULL,1,234.0632083,27.30453,0.121,NULL,59919243337,936238177,14628721,15.4),(131200,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131200,37.47,0.46,311,61075,70,NULL,NULL,'SDSS J153615.18+195921.8',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000141,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.0632917,19.98942,0.189,NULL,59457155764,929018058,14515907,18.7),(131201,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131201,36.61,0.46,210,61076,70,NULL,NULL,'2MASX J15361586-0117313',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000155,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,234.066125,-1.29208,0.337,NULL,45414608189,709603252,11087550,17.4),(131202,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131202,37.99,0.46,397,61077,70,NULL,NULL,'2MASX J15361592+3002296',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000181,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,234.066208333,30.04164,0.065,NULL,59927266747,936363542,14630680,17),(131203,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131203,37.47,0.33,311,61078,70,NULL,NULL,'2MASX J15361603+3434156',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000185,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,234.066708333,34.57083,0.049,NULL,59892879574,935826243,14622285,16.8),(131204,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131204,36.88,0.46,237,61079,70,NULL,NULL,'2MASX J15361711+5755272',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000176,NULL,'16.0g',0.4,'S0/a',NULL,NULL,NULL,NULL,1,234.071333,57.92408,0.013,NULL,57588319735,899817495,14059648,16),(131205,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131205,36.98,0.46,249,61080,70,NULL,NULL,'SDSS J153619.27+502940.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000166,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,234.080333333,50.49447,0.041,NULL,59665070353,932266724,14566667,17.5),(131206,'Tully est','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131206,32.27,0.8,28.5,61081,75,NULL,'B','MRK 0689',NULL,'1988NBGC.C....0000T',1988,1,0.7,NULL,'G',0.000007,NULL,'15.1g',0.43,'dwarf','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,234.081,30.68231,0.069,NULL,59925391341,936334239,14630222,15.1),(131207,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131207,36.6,0.49,209,61082,75,NULL,'IR','CGCG 078-026',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.000697,NULL,'15.7',0.2,NULL,NULL,NULL,NULL,NULL,1,234.095625,12.12756,0.065,NULL,56589584589,884212259,13815816,15.7),(131208,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131208,37.9,0.33,380,61083,70,NULL,NULL,'2MASX J15362328+5252239',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,234.09675,52.87342,0.057,NULL,59671403143,932365674,14568213,17.6),(131209,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131209,38.46,0.46,492,61084,70,NULL,NULL,'2MASX J15362338+1358414',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,234.097375,13.97822,0.125,NULL,59428739021,928574047,14508969,17.5),(131210,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131210,37.47,0.33,311,61085,70,NULL,NULL,'2MASX J15362369+3435006',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000222,NULL,'16.1g',0.43,NULL,NULL,NULL,NULL,NULL,1,234.098625,34.58347,0.053,NULL,59892880150,935826252,14622285,16.1),(131211,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131211,37.74,0.27,353,61086,70,NULL,NULL,'2MASX J15362493+2552216',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,234.1039583,25.87275,0.157,NULL,59915801522,936184398,14627881,17.2),(131212,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131212,38.86,0.46,591,61087,70,NULL,NULL,'SDSS J153626.00+271120.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.108375,27.18894,0.121,NULL,59919251062,936238297,14628723,18.3),(131213,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131213,36.5,0.46,199,61088,70,NULL,NULL,'2MASX J15362626+4131296',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000186,NULL,'15.8g',0.38,'E0',NULL,NULL,NULL,NULL,1,234.109375,41.52475,0.077,NULL,59965527119,936961361,14640021,15.8),(131214,'Sosies','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131214,32.2,0.57,27.5,61089,NULL,NULL,NULL,'NGC 5938',NULL,'2002A&A...393...57T',2002,1,2.8,NULL,'G',0.000019,NULL,'12.4',2.5,'SB(s)bc',NULL,NULL,NULL,NULL,1,234.1094583,-66.85975,NULL,NULL,45059291353,704051427,11000803,12.4),(131215,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131215,32.07,0.46,26,61089,NULL,NULL,'J','NGC 5938',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131216,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131216,32.07,0.47,26,61089,NULL,NULL,'H','NGC 5938',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131217,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131217,32.16,0.45,27,61089,NULL,NULL,'K','NGC 5938',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131218,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131218,33.05,0.4,40.8,61089,NULL,NULL,'mean','NGC 5938',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131219,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131219,34.81,0.4,91.4,61090,NULL,NULL,'mean','IC 4564',NULL,'2007A&A...465...71T',2007,1,1.28,'UZC has V = 6104 +- 46 km/sec.','G',0.000047,NULL,'14.1g',0.53,'S?             Sbrst','in a radial-velocity based grouping',NULL,NULL,NULL,1,234.11275,43.51878,0.089,NULL,59678656492,932479007,14569984,14.1),(131220,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131220,35.28,0.46,114,61090,NULL,NULL,'J','IC 4564',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131221,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131221,35.3,0.47,115,61090,NULL,NULL,'H','IC 4564',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131222,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131222,35.34,0.45,117,61090,NULL,NULL,'K','IC 4564',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131223,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131223,38.11,0.46,419,61091,70,NULL,NULL,'SDSS J153627.76+143822.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.115666667,14.63947,0.113,NULL,59428232154,928566127,14508845,17.9),(131224,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131224,37.88,0.33,377,61092,70,NULL,NULL,'SDSS J153628.09+311209.9',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000141,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,234.117083,31.20275,0.077,NULL,59914173563,936158961,14627483,18.7),(131225,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131225,36.44,0.09,194,61093,70,NULL,NULL,'2MASX J15362900+2122301',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'16.50',0.32,NULL,NULL,NULL,NULL,NULL,1,234.120791667,21.37519,0.169,NULL,59457979328,929030927,14516108,16.5),(131226,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131226,37.23,0.46,279,61094,70,NULL,NULL,'2MASXi J1536301+295232',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.125333,29.87572,0.065,NULL,59927240880,936363138,14630674,17.5),(131227,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131227,31.52,0.69,20.1,61095,100,NULL,'mid-IR','NGC 5962',NULL,'2013ApJ...771...88L',2013,1,2.47,'HOLM 716B is a star.','G',0.000007,NULL,'12.2g',1.49,'SA(r)c         HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,234.132,16.60778,0.097,NULL,59441448350,928772630,14512072,12.2),(131228,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131228,32.4,0.4,30.2,61095,NULL,NULL,NULL,'NGC 5962',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131229,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131229,32.48,0.4,31.3,61095,NULL,NULL,'mean','NGC 5962',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131230,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131230,32.51,0.4,31.8,61095,75,NULL,'B','NGC 5962',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131231,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131231,32.56,0.45,32.5,61095,NULL,NULL,'K','NGC 5962',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131232,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131232,32.56,0.47,32.6,61095,NULL,NULL,'H','NGC 5962',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131233,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131233,32.59,0.46,32.9,61095,NULL,NULL,'J','NGC 5962',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131234,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131234,32.61,0.43,33.3,61095,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5962',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131235,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131235,32.67,0.43,34.2,61095,75,NULL,'3.6 micron, color corrected','NGC 5962',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131236,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131236,32.85,0.2,37.2,61095,74.4,NULL,NULL,'NGC 5962',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131237,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131237,32.97,0.51,39.3,61095,NULL,NULL,'Malmquist cor.','NGC 5962',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131238,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131238,33.11,0.48,41.8,61095,NULL,NULL,NULL,'NGC 5962',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131239,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131239,33.18,0.2,43.3,61096,74.4,NULL,NULL,'UGC 09925',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000023,NULL,'14.70',0.8,'Scd:',NULL,NULL,NULL,NULL,1,234.133333,16.43972,0.093,NULL,59441636584,928775571,14512118,14.7),(131240,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131240,33.39,0.5,47.7,61096,NULL,NULL,NULL,'UGC 09925',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131241,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131241,33.74,0.43,55.9,61096,NULL,NULL,'Malmquist cor.','UGC 09925',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131242,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131242,38.45,0.33,491,61097,70,NULL,NULL,'SDSS J153632.47+462309.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000162,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,234.135333333,46.38589,0.025,NULL,59688552588,932633634,14572400,18.3),(131243,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131243,37.85,0.46,371,61098,70,NULL,NULL,'2MASX J15363315+2503083',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000201,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,234.138167,25.05236,0.145,NULL,59898871224,935919862,14623747,17.4),(131244,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131244,36.66,0.46,215,61099,70,NULL,NULL,'2MASX J15363522+1944492',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000187,NULL,'15.9g',0.4,NULL,NULL,NULL,NULL,NULL,1,234.146833,19.74708,0.173,NULL,59457185533,929018523,14515914,15.9),(131245,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131245,37.64,0.46,337,61100,70,NULL,NULL,'2MASX J15363535+1317152',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,234.147125,13.28744,0.109,NULL,59425835959,928528686,14508260,17.4),(131246,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131246,35.98,0.46,157,61101,70,NULL,NULL,'2MASX J15363727+5503273',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000173,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,234.155541667,55.05772,0.021,NULL,57586826173,899794158,14059283,16.4),(131247,'IRAS','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131247,34.63,0.8,84.2,61102,75,NULL,'MAT, I','ESO 582- G 021',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'15',0.7,'(R\')SA:(r)b    HII',NULL,NULL,NULL,NULL,1,234.158583333,-18.78633,0.449,NULL,46637555340,728711802,11386121,15),(131248,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131248,34.43,0.43,76.8,61102,75,NULL,'MAT, I, raw','ESO 582- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131249,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131249,34.51,0.47,79.7,61102,NULL,NULL,'H','ESO 582- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131250,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131250,34.53,0.32,80.5,61102,85,NULL,'I, raw','ESO 582- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131251,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131251,34.6,0.32,83,61102,85,NULL,'I, inv','ESO 582- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131252,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131252,34.6,0.45,83,61102,NULL,NULL,'K','ESO 582- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131253,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131253,34.63,0.2,84.3,61102,74.4,NULL,NULL,'ESO 582- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131254,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131254,34.68,0.46,86.4,61102,NULL,NULL,'J','ESO 582- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131255,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131255,34.71,0.43,87.5,61102,75,NULL,'MAT, I, inv','ESO 582- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131256,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131256,34.79,0.43,90.6,61102,75,NULL,'MAT, I, cor','ESO 582- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131257,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131257,34.83,0.22,92.3,61102,NULL,NULL,NULL,'ESO 582- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131258,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131258,34.84,0.4,92.8,61102,NULL,NULL,'mean','ESO 582- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131259,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131259,35.01,0.2,100,61102,NULL,NULL,'Malmquist cor.','ESO 582- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131260,'Black Hole','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131260,36.43,0.66,193,61103,NULL,NULL,NULL,'MRK 0486',NULL,'2014ApJ...793..108W',2014,1,0.5,NULL,'G',0.000093,NULL,'15.0V',NULL,'SBb?           Sy1',NULL,NULL,NULL,'Sy 1.0',1,234.159833,54.55922,0.045,NULL,57586196913,899784326,14059130,15),(131261,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131261,37.74,0.27,353,61104,70,NULL,NULL,'2MASX J15363897+2554244',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.2g',0.38,'BrClG',NULL,NULL,NULL,NULL,1,234.1622917,25.90681,0.157,NULL,59916510928,936195483,14628054,16.2),(131262,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131262,36.81,0.46,231,61105,70,NULL,NULL,'2MASX J15363899-0221267',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000177,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,234.1625,-2.35758,0.389,NULL,45415494093,709617095,11087767,17.5),(131263,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131263,36.07,0.23,163,61106,70,NULL,NULL,'2MASX J15363923+2709174',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,234.163625,27.15483,0.121,NULL,59919128714,936236386,14628693,16.2),(131264,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131264,38.82,0.46,582,61107,70,NULL,NULL,'SDSS J153639.74+202407.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.165583,20.40208,0.185,NULL,59458381507,929037211,14516206,18.5),(131265,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131265,36.44,0.09,194,61108,70,NULL,NULL,'2MASX J15364132+2159222',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,234.172208333,21.98961,0.169,NULL,59453272366,928957380,14514959,16.2),(131266,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131266,37.69,0.33,346,61109,70,NULL,NULL,'2MASX J15364186+1204322',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,234.174417,12.07561,0.065,NULL,56589772773,884215199,13815862,16.8),(131267,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131267,35.7,0.2,138,61110,74.4,NULL,NULL,'CGCG 078-028 NED01',NULL,'2013AJ....146...86T',2013,1,0.79,NULL,'G',0.000093,NULL,'15.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,234.176291667,9.02528,0.093,NULL,56418683502,881541929,13774092,15.4),(131268,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131268,37.69,0.33,346,61111,70,NULL,NULL,'SDSS J153642.85+121053.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.178583,12.18142,0.061,NULL,56589698003,884214031,13815844,18.3),(131269,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131269,37.47,0.46,312,61112,70,NULL,NULL,'SDSS J153643.40+103918.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000162,NULL,'18.2g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.180875,10.65503,0.081,NULL,56591125326,884236333,13816192,18.2),(131270,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131270,37.68,0.46,343,61113,70,NULL,NULL,'SDSS J153643.43+094546.1',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,234.1809583,9.76281,0.085,NULL,56407170981,881362046,13771281,NULL),(131271,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131271,33.05,0.4,40.7,61114,75,NULL,'B','UGC 09936',NULL,'1988NBGC.C....0000T',1988,1,1,NULL,'G',0.000013,NULL,'15.6g',0.52,'Sm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,234.1874583,44.23683,0.017,NULL,59686245163,932597580,14571837,15.6),(131272,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131272,35.71,0.6,139,61115,70,NULL,NULL,'2MASX J15364521-0049317',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00009,NULL,'16.3g',0.33,'S0',NULL,NULL,NULL,NULL,1,234.188375,-0.82556,0.321,NULL,45400645030,709385078,11084141,16.3),(131273,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131273,36.16,0.46,171,61115,70,NULL,NULL,'2MASX J15364521-0049317',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131274,'BL Lac Luminosity','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131274,41.1,NULL,1270,61116,NULL,NULL,NULL,'RBS 1517',0.312,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.003,NULL,'18.70',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,234.1947917,1.63336,0.173,NULL,56404178904,881315295,13770551,18.7),(131275,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131275,35.95,0.19,155,61117,70,NULL,NULL,'IC 4561',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000157,NULL,'14.9g',0.55,NULL,NULL,NULL,NULL,NULL,1,234.196125,25.41681,0.149,NULL,59915674814,936182418,14627850,14.9),(131276,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131276,37.8,0.46,362,61118,70,NULL,NULL,'2MASX J15364749+2001082',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,234.197875,20.01914,0.173,NULL,59456690840,929010794,14515793,17.7),(131277,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131277,38.22,0.46,441,61119,70,NULL,NULL,'2MASX J15364860+2057212',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.202583,20.95589,0.169,NULL,59458094867,929032732,14516136,17.5),(131278,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131278,37.74,0.27,353,61120,70,NULL,NULL,'2MASX J15364868+2552464',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000188,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,234.202917,25.87956,0.157,NULL,59915802874,936184419,14627881,17.3),(131279,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131279,37.99,0.33,397,61121,70,NULL,NULL,'2MASX J15364976+1959371',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,234.207417,19.99364,0.173,NULL,59456692023,929010812,14515793,NULL),(131280,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131280,37.88,0.33,377,61122,70,NULL,NULL,'SDSS J153649.86+311635.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000145,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,234.2077917,31.27653,0.077,NULL,59914162669,936158791,14627481,18.5),(131281,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131281,37.69,0.46,346,61123,70,NULL,NULL,'2MASX J15365022-0050437',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000079,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.2092083,-0.84542,0.321,NULL,45400644555,709385071,11084141,17.7),(131282,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131282,37.5,0.46,316,61124,70,NULL,NULL,'2MASX J15365057+4058405',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000174,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,234.210583,40.97783,0.061,NULL,59965709031,936964203,14640065,17.5),(131283,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131283,35.83,0.46,146,61125,70,NULL,NULL,'2MASX J15365091+2634494',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000188,NULL,'15.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,234.212125,26.58025,0.121,NULL,59916326599,936192603,14628009,15.7),(131284,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131284,37.33,0.46,292,61126,70,NULL,NULL,'2MASX J15365178+3717245',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,234.215833,37.29025,0.041,NULL,59879586290,935618535,14619039,17.5),(131285,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131285,38.63,0.46,532,61127,70,NULL,NULL,'2MASX J15365188+4106374',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00019,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,234.2162083,41.11039,0.061,NULL,59965608060,936962625,14640041,17.4),(131286,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131286,36.4,0.46,190,61128,70,NULL,NULL,'2MASX J15365206-0222227',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,234.2169583,-2.37317,0.389,NULL,45415523776,709617559,11087774,16.7),(131287,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131287,36.64,0.33,213,61129,70,NULL,NULL,'CGCG 050-043',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000103,NULL,'15.5',0.5,NULL,NULL,NULL,NULL,NULL,1,234.221583,4.75797,0.125,NULL,56392729507,881136398,13767756,15.5),(131288,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,NULL,131288,34.79,NULL,90.7,61130,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1926',NULL,'2010Ap&SS.325..163P',2010,1,1,NULL,'G',0.000199,NULL,'16.5g',0.18,'Scd(f)',NULL,NULL,NULL,NULL,1,234.22275,51.28864,0.037,NULL,59670481414,932351272,14567988,16.5),(131289,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,NULL,131289,34.81,NULL,91.4,61130,NULL,NULL,'Dipole + Quadrupole','FGC 1926',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131290,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,NULL,131290,34.81,NULL,91.8,61130,NULL,NULL,'Dipole','FGC 1926',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131291,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,NULL,131291,34.85,NULL,93.4,61130,NULL,NULL,NULL,'FGC 1926',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131292,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131292,36.22,0.46,176,61131,70,NULL,NULL,'2MASX J15365442+1142213',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,234.226875,11.70603,0.093,NULL,56590513970,884226780,13816043,16.5),(131293,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131293,37.54,0.46,322,61132,70,NULL,NULL,'SDSS J153655.38+325844.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,234.2307917,32.97914,0.069,NULL,59884113110,935689267,14620144,18),(131294,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131294,38.69,0.46,547,61133,70,NULL,NULL,'SDSS J153655.60-011039.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000077,NULL,'19.1g',0.1,NULL,NULL,NULL,NULL,NULL,1,234.231667,-1.17758,0.325,NULL,45414584284,709602879,11087544,19.1),(131295,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131295,37.68,0.27,344,61134,70,NULL,NULL,'2MASX J15365640+1802123',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000167,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,234.235083333,18.03692,0.089,NULL,59437630552,928712977,14511140,16.7),(131296,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131296,38.29,0.33,455,61135,70,NULL,NULL,'2MASX J15365911+2036593',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,234.2462083,20.61664,0.177,NULL,59458420103,929037814,14516215,18.1),(131297,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131297,38.13,0.46,422,61136,70,NULL,NULL,'2MASX J15365990+3953395',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,234.2495417,39.89436,0.053,NULL,60096397592,939006212,14671972,17.6),(131298,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131298,35.84,0.46,147,61137,70,NULL,NULL,'2MASX J15370020+1211482',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'17.17',0.31,'BrClG',NULL,NULL,NULL,NULL,1,234.2507917,12.19661,0.061,NULL,56589710395,884214224,13815847,17.17),(131299,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131299,37.18,0.46,273,61138,70,NULL,NULL,'2MASX J15370021+1122173',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,234.250917,11.3715,0.073,NULL,56589978463,884218413,13815912,16.5),(131300,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131300,38.24,0.46,446,61139,70,NULL,NULL,'2MASX J15370051+3108417',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000161,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,234.252083,31.14503,0.077,NULL,59925495380,936335865,14630247,18.2),(131301,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131301,38.37,0.46,473,61140,70,NULL,NULL,'2MASX J15370115+2603156',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000198,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,234.254875,26.05428,0.145,NULL,59916508502,936195445,14628053,17.8),(131302,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131302,38.29,0.33,455,61141,70,NULL,NULL,'2MASX J15370175+2037473',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.0g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,234.257167,20.62992,0.177,NULL,59458419112,929037798,14516215,17),(131303,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131303,36.03,0.46,161,61142,70,NULL,NULL,'2MASX J15370240+2404517',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,234.260125,24.08114,0.137,NULL,59451050487,928922663,14514416,17.2),(131304,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131304,33.46,0.49,49.3,61143,75,NULL,'IR','2MFGC 12578',NULL,'2011yCatp016004901K',2011,1,0.79,NULL,'G',0.000103,NULL,'15.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,234.2615,20.12883,0.185,NULL,59456693873,929010841,14515794,15.6),(131305,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131305,38.02,0.46,401,61144,70,NULL,NULL,'2MASX J15370355+1446542',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,234.264875,14.78186,0.129,NULL,59428200914,928565639,14508838,18.3),(131306,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131306,36.64,0.33,213,61145,70,NULL,NULL,'2MASX J15370377+0443074',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,234.26575,4.71878,0.125,NULL,56392918687,881139354,13767802,NULL),(131307,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,NULL,131307,36.56,0.2,205,61146,74.4,NULL,NULL,'CGCG 136-031',NULL,'2013AJ....146...86T',2013,1,0.78,NULL,'G',0.000104,NULL,'15.1g',0.47,'SBb',NULL,NULL,NULL,NULL,1,234.266,25.56533,0.173,NULL,59915888550,936185758,14627902,15.1),(131308,'Tully est','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,NULL,131308,30.88,0.8,15,61147,75,NULL,'B','UGCA 410',NULL,'1988NBGC.C....0000T',1988,1,0.45,'The SDSS position applies to a knot or superposed companion 2.2 arcsec north.','G',0.000023,NULL,'15.2g',0.36,'BCDG           HII','Group member',NULL,NULL,NULL,1,234.267458333,55.26342,0.021,NULL,57586953962,899796155,14059314,15.2),(131309,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131309,34.94,0.46,97.2,61148,70,NULL,NULL,'CGCG 1535.0+2930 NED02',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000147,NULL,'15.13',0.3,NULL,NULL,NULL,NULL,NULL,1,234.272583,29.33772,0.065,NULL,59926501722,936351589,14630493,15.13),(131310,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131310,36.86,0.46,235,61149,70,NULL,NULL,'2MASX J15370536+5655426',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000062,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.272666667,56.92853,0.013,NULL,57590056405,899844631,14060072,17.6),(131311,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131311,37.68,0.27,344,61150,70,NULL,NULL,'2MASX J15370601+1759143',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,234.275125,17.98747,0.089,NULL,59437645618,928713212,14511143,18.1),(131312,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131312,38.77,0.46,567,61151,70,NULL,NULL,'SDSS J153706.15+040419.6',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000084,NULL,'18.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,234.275667,4.07214,0.101,NULL,56396454845,881194606,13768665,18.8),(131313,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131313,37.94,0.46,388,61152,70,NULL,NULL,'2MASX J15370822+4545363',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000171,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,234.284333333,45.76022,0.013,NULL,59688974599,932640228,14572503,17.7),(131314,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131314,37.3,0.21,288,61153,70,NULL,NULL,'2MASX J15370839+4702546',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,234.285167,47.04836,0.037,NULL,59688356048,932630563,14572352,17.9),(131315,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131315,38.38,0.46,475,61154,70,NULL,NULL,'2MASX J15370887+2050333',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,234.287125,20.84247,0.173,NULL,59458220204,929034690,14516167,18.1),(131316,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131316,37.98,0.46,395,61155,70,NULL,NULL,'2MASX J15370985+4507493',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.3R',0.2,NULL,NULL,NULL,NULL,NULL,1,234.29125,45.13036,0.013,NULL,59686817825,932606528,14571977,16.3),(131317,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131317,37.37,0.46,297,61156,70,NULL,NULL,'2MASX J15370999+3446217',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000179,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,234.291833,34.77269,0.053,NULL,59892847189,935825737,14622277,17),(131318,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131318,36.92,0.46,243,61157,70,NULL,NULL,'2MASX J15371196+4104184',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000156,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,234.299667,41.07169,0.061,NULL,59965581594,936962212,14640034,16.6),(131319,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131319,37.69,0.46,345,61158,70,NULL,NULL,'2MASX J15371202-0101442',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000081,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,234.3000417,-1.02897,0.321,NULL,45400680431,709385631,11084150,18.3),(131320,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,NULL,131320,34.52,0.57,80.2,61159,70,NULL,NULL,'2MASX J15371268-0519572',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'16.3R',NULL,'HII',NULL,NULL,NULL,NULL,1,234.302917,-5.33256,0.461,NULL,45416370233,709630784,11087981,16.3),(131321,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,NULL,131321,33.94,0.43,61.4,61160,75,NULL,'3.6 micron, color + selection bias corrected','IC 4567',NULL,'2014MNRAS.444..527S',2014,1,1.16,NULL,'G',0.00002,NULL,'13.6g',0.8,'Scd?           Sbrst','in a radial-velocity based grouping',NULL,NULL,NULL,1,234.305291667,43.29831,0.093,NULL,59678681609,932479400,14569990,13.6),(131322,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,NULL,131322,34.05,0.43,64.6,61160,75,NULL,'3.6 micron, color corrected','IC 4567',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131323,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,NULL,131323,34.25,0.2,70.8,61160,74.4,NULL,NULL,'IC 4567',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131324,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,NULL,131324,34.38,0.47,75.3,61160,NULL,NULL,'H','IC 4567',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131325,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,NULL,131325,34.39,0.45,75.4,61160,NULL,NULL,'K','IC 4567',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131326,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,NULL,131326,34.45,0.46,77.7,61160,NULL,NULL,'J','IC 4567',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131327,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,NULL,131327,34.66,0.4,85.6,61160,NULL,NULL,'mean','IC 4567',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131328,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131328,38.31,0.46,459,61161,70,NULL,NULL,'SDSS J153714.70+293236.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00018,NULL,'18.0g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.3112917,29.54353,0.065,NULL,59927574665,936368354,14630755,18),(131329,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131329,37.99,0.33,397,61162,70,NULL,NULL,'2MASX J15371483+2000003',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,234.311875,20.00025,0.173,NULL,59456745899,929011654,14515807,17.4),(131330,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131330,37.2,0.27,275,61163,70,NULL,NULL,'2MASX J15371549+4158544',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.314666667,41.98181,0.121,NULL,59963523303,936930051,14639532,17.6),(131331,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131331,36.9,0.46,240,61164,70,NULL,NULL,'2MASX J15371633+1831063',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,234.31825,18.51839,0.085,NULL,59430179005,928596546,14509321,16.9),(131332,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131332,37.68,0.27,344,61165,70,NULL,NULL,'2MASX J15371638+1800313',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000199,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,234.318375,18.00886,0.089,NULL,59437643613,928713181,14511143,16.5),(131333,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131333,37.97,0.46,393,61166,70,NULL,NULL,'2MASX J15371643+5711306',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00018,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,234.3185,57.19197,0.021,NULL,57590871434,899857366,14060271,17.5),(131334,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131334,38.36,0.46,471,61167,70,NULL,NULL,'SDSS J153717.72+304054.3',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.323833333,30.68175,0.069,NULL,59925563986,936336937,14630264,17.7),(131335,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131335,37.2,0.27,275,61168,70,NULL,NULL,'SDSS J153718.42+415301.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000166,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,234.3267917,41.88364,0.121,NULL,59963497522,936929648,14639525,18.3),(131336,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131336,38.12,0.46,422,61169,70,NULL,NULL,'2MASX J15372013+2540097',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.333875,25.66947,0.165,NULL,59915841691,936185026,14627891,17.7),(131337,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131337,38.14,0.46,425,61170,70,NULL,NULL,'2MASX J15372248+0628496',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,234.343791667,6.48044,0.149,NULL,56414282992,881473171,13773018,18.2),(131338,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131338,36.76,0.46,225,61171,70,NULL,NULL,'2MASX J15372273+0307474',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000122,NULL,'15.8g',0.44,'S0^-',NULL,NULL,NULL,NULL,1,234.3447083,3.12978,0.141,NULL,56395054788,881172731,13768323,15.8),(131339,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131339,35.85,0.25,148,61172,74.4,NULL,NULL,'CGCG 136-033',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000087,NULL,'14.37',0.7,'S',NULL,NULL,NULL,NULL,1,234.3587083,21.74381,0.169,NULL,59452690986,928948296,14514817,14.37),(131340,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131340,36.04,0.27,161,61172,70,NULL,NULL,'CGCG 136-033',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131341,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131341,35.98,0.2,157,61173,74.4,NULL,NULL,'CGCG 078-030',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000489,NULL,'15.6',0.2,NULL,NULL,NULL,NULL,NULL,1,234.3592917,10.62786,0.081,NULL,56591170961,884237046,13816203,15.6),(131342,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131342,37.75,0.46,354,61174,70,NULL,NULL,'2MASX J15372865+1923125',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00019,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.3694583,19.38689,0.149,NULL,59457328865,929020763,14515949,17.3),(131343,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131343,37.81,0.46,365,61175,70,NULL,NULL,'2MASX J15372871+2357035',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00017,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,234.369666667,23.95089,0.137,NULL,59450937371,928920896,14514389,17.6),(131344,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131344,37.07,0.46,260,61176,70,NULL,NULL,'MCG +06-34-023',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00019,NULL,'15.6g',0.52,'E0',NULL,NULL,NULL,NULL,1,234.371125,36.24378,0.057,NULL,59878999664,935609369,14618896,15.6),(131345,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131345,38.03,0.46,404,61177,70,NULL,NULL,'2MASX J15373162+2619006',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,234.3817083,26.31683,0.125,NULL,59916657327,936197770,14628090,16.8),(131346,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131346,37.9,0.33,380,61178,70,NULL,NULL,'2MASX J15373254+5247385',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,234.385375,52.79403,0.057,NULL,59672285243,932379456,14568429,17.7),(131347,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131347,37.2,0.27,275,61179,70,NULL,NULL,'2MASX J15373259+4149084',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,234.385958333,41.81903,0.077,NULL,59963491830,936929559,14639524,17.6),(131348,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131348,37.56,0.46,325,61180,70,NULL,NULL,'2MASX J15373349+1342524',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,234.389666667,13.71458,0.125,NULL,59425391615,928521743,14508152,16.5),(131349,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131349,36.19,0.33,173,61181,70,NULL,NULL,'2MASX J15373355+3513512',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,234.389833333,35.23108,0.053,NULL,59892910362,935826724,14622292,16.5),(131350,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131350,36.66,0.33,215,61182,70,NULL,NULL,'2MASX J15373383+4533195',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000181,NULL,'16.1g',0.29,'E0',NULL,NULL,NULL,NULL,1,234.3912083,45.55556,0.009,NULL,59688279490,932629367,14572333,16.1),(131351,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131351,37.47,0.46,312,61183,70,NULL,NULL,'2MASX J15373413+5326365',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,234.392,53.44339,0.049,NULL,59672205443,932378210,14568409,17.4),(131352,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131352,37.13,0.46,267,61184,70,NULL,NULL,'2MASX J15373515+3753514',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.396375,37.89772,0.045,NULL,60098401513,939037523,14672461,17.6),(131353,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131353,35.74,0.46,140,61185,70,NULL,NULL,'2MASX J15373628+0416578',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'16.43',0.42,NULL,NULL,NULL,NULL,NULL,1,234.4012083,4.28275,0.117,NULL,56396253106,881191454,13768616,16.43),(131354,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131354,31.96,0.4,24.7,61186,75,NULL,'B','NGC 5964',NULL,'1988NBGC.C....0000T',1988,1,4.2,'2MASS position is for a southern hot-spot.','G',0.000004,NULL,'12.6',3.2,'SB(rs)d        AGN?','Isolated galaxy',NULL,NULL,NULL,1,234.400917,5.97403,0.145,NULL,56421848616,881591384,13774865,12.6),(131355,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131355,32.18,0.68,27.3,61186,NULL,NULL,NULL,'NGC 5964',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131356,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131356,32.18,NULL,27.3,61186,72,NULL,NULL,'NGC 5964',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131357,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131357,32.21,0.67,27.7,61186,NULL,NULL,'Malmquist cor.','NGC 5964',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131358,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131358,32.22,0.2,27.8,61186,74.4,NULL,NULL,'NGC 5964',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131359,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131359,36.8,0.23,229,61187,70,NULL,NULL,'2MASX J15373644+1423264',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,234.401917,14.39075,0.097,NULL,59428647581,928572618,14508947,16.7),(131360,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131360,35.19,0.4,109,61188,NULL,NULL,'mean','MCG -01-40-004',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000037,NULL,'15.25',0.5,'Sb',NULL,NULL,NULL,NULL,1,234.4052083,-8.72119,0.461,NULL,45388905617,709201650,11081275,15.25),(131361,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131361,35.32,0.47,116,61188,NULL,NULL,'H','MCG -01-40-004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131362,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131362,38.13,0.46,422,61189,70,NULL,NULL,'2MASX J15373782+1703424',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,234.407625,17.06189,0.073,NULL,59438160354,928721255,14511269,18),(131363,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131363,35.26,0.46,113,61190,70,NULL,NULL,'CGCG 078-032',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000153,NULL,'15.5',0.38,NULL,NULL,NULL,NULL,NULL,1,234.4077083,9.31486,0.097,NULL,56590610062,884228282,13816066,15.5),(131364,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131364,37.74,0.33,352,61191,70,NULL,NULL,'SDSS J153738.50-015544.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000158,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,234.4104583,-1.92911,0.369,NULL,45415024394,709609756,11087652,18.7),(131365,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131365,37.53,0.46,321,61192,70,NULL,NULL,'2MASX J15373849+5147195',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000178,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,234.4104583,51.78883,0.049,NULL,59671258128,932363408,14568178,17.2),(131366,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131366,37.93,0.46,385,61193,70,NULL,NULL,'2MASX J15373903+2037146',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,234.41275,20.62083,0.141,NULL,59458226059,929034782,14516168,17.2),(131367,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131367,37.47,0.46,312,61194,70,NULL,NULL,'2MASX J15373978+2915107',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,234.415708333,29.25303,0.065,NULL,59926480062,936351250,14630488,17.5),(131368,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131368,36.34,0.46,185,61195,70,NULL,NULL,'2MASX J15373986+3930424',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000172,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,234.415958333,39.51167,0.053,NULL,60096450374,939007037,14671984,16.3),(131369,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131369,36.48,0.46,197,61196,70,NULL,NULL,'2MASX J15374062+3131572',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000172,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,234.419333,31.5325,0.077,NULL,59914388436,936162319,14627536,16.7),(131370,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131370,36.19,0.33,173,61197,70,NULL,NULL,'2MASX J15374106+3512452',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000171,NULL,'16.0g',0.39,'E0',NULL,NULL,NULL,NULL,1,234.4212083,35.21269,0.053,NULL,59892911086,935826735,14622292,16),(131371,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131371,38.05,0.46,408,61198,70,NULL,NULL,'SDSS J153741.25+574139.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,234.421917,57.69439,0.025,NULL,57635529028,900555141,14071174,17.9),(131372,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131372,36.8,0.23,229,61199,70,NULL,NULL,'2MASX J15374126+1421154',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.00008,NULL,'16.55',0.39,NULL,NULL,NULL,NULL,NULL,1,234.421958333,14.35422,0.097,NULL,59428647008,928572609,14508947,16.55),(131373,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131373,36.85,0.46,235,61200,70,NULL,NULL,'2MASX J15374429+0002024',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000085,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,234.434375,0.03403,0.249,NULL,56390732522,881105195,13767268,16.8),(131374,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131374,37.3,0.21,288,61201,70,NULL,NULL,'2MASX J15374579+4659409',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.0002,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,234.440875,46.99467,0.037,NULL,59687311078,932614235,14572097,16.4),(131375,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131375,37.37,0.46,298,61202,70,NULL,NULL,'2MASX J15374606+2754157',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000198,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,234.4419583,27.90444,0.093,NULL,59918866107,936232282,14628629,16.3),(131376,'Tully est','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131376,32.33,0.8,29.2,61203,75,NULL,'B','NGC 5981',NULL,'1988NBGC.C....0000T',1988,1,2.8,'1983Afz....19..613K has V_sun = 2611 +- 27 km sec^-1.','G',0.000153,NULL,'13.93',0.5,'Sc? sp','Isolated galaxy (6 Mpc isolation)',NULL,NULL,NULL,1,234.4727083,59.39175,0.013,NULL,57618147295,900283551,14066930,13.93),(131377,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131377,33.43,0.2,48.5,61203,74.4,NULL,NULL,'NGC 5981',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131378,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131378,33.48,0.4,49.8,61203,75,NULL,NULL,'NGC 5981',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131379,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131379,33.53,0.43,50.9,61203,75,NULL,'3.6 micron, color corrected','NGC 5981',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131380,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131380,33.63,0.43,53.2,61203,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5981',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131381,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131381,33.73,0.49,55.6,61203,75,NULL,'IR','NGC 5981',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131382,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131382,34.16,0.46,67.9,61204,70,NULL,NULL,'UGC 09939',NULL,'2015arXiv151105856S',2015,1,1.02,NULL,'G',0.000107,NULL,'14.7g',0.76,'S0:',NULL,NULL,NULL,NULL,1,234.4704583,-1.73528,0.373,NULL,45414915768,709608058,11087625,14.7),(131383,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131383,37.05,0.46,257,61205,70,NULL,NULL,'2MASX J15375371-0041224',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00008,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.473708333,-0.68958,0.341,NULL,45401037713,709391214,11084237,17.5),(131384,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131384,36.67,0.46,215,61206,70,NULL,NULL,'2MASX J15375388+1314234',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,234.474583,13.23994,0.109,NULL,59425319754,928520621,14508134,17.1),(131385,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131385,36.96,0.46,247,61207,70,NULL,NULL,'SDSS J153754.21+463204.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,234.475875,46.53469,0.025,NULL,59688508139,932632939,14572389,18),(131386,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131386,37.47,0.46,312,61208,70,NULL,NULL,'2MASX J15375778+1103557',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.490625,11.06533,0.105,NULL,56593381381,884271584,13816743,17.2),(131387,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131387,36.69,0.46,218,61209,70,NULL,NULL,'2MASX J15375869+2306467',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,234.494417,23.11292,0.153,NULL,59453559930,928961873,14515029,17),(131388,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131388,37.25,0.46,282,61210,70,NULL,NULL,'SDSS J153758.76+484812.6',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000169,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.494875,48.8035,0.045,NULL,59721719746,933151871,14580497,17.6),(131389,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131389,37.74,0.33,352,61211,70,NULL,NULL,'2MASX J15375888-0156317',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000178,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,234.49525,-1.942,0.369,NULL,45413270000,709582343,11087224,17.5),(131390,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131390,36.89,0.73,239,61212,70,NULL,NULL,'2MASX J15375907-2800389',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,234.496083333,-28.01078,0.425,NULL,47172509826,737070466,11516726,15.9),(131391,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131391,36.2,0.46,174,61213,70,NULL,NULL,'2MASX J15380169+0737207',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'17.41',0.4,NULL,NULL,NULL,NULL,NULL,1,234.507041667,7.62228,0.093,NULL,56417086984,881516984,13773702,17.41),(131392,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131392,38.1,0.46,416,61214,70,NULL,NULL,'SDSS J153802.05+513152.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000154,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,234.508541667,51.53128,0.045,NULL,59670476238,932351191,14567987,18.1),(131393,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131393,36.52,0.46,201,61215,70,NULL,NULL,'2MASX J15380259+2939437',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000163,NULL,'16.5g',0.27,'E',NULL,NULL,NULL,NULL,1,234.5107083,29.66214,0.065,NULL,59928142436,936377225,14630894,16.5),(131394,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131394,36.66,0.33,215,61216,70,NULL,NULL,'2MASX J15380268+4533480',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,234.51125,45.56319,0.009,NULL,59688273079,932629266,14572332,16.8),(131395,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131395,37.13,0.46,267,61217,70,NULL,NULL,'2MASX J15380308+4701340',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00015,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,234.5129583,47.02628,0.037,NULL,59687359560,932614993,14572109,17.1),(131396,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131396,37.02,0.46,253,61218,70,NULL,NULL,'2MASX J15380329+1624057',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.2g',0.32,NULL,NULL,NULL,NULL,NULL,1,234.513666667,16.4015,0.097,NULL,59441084212,928766940,14511983,16.2),(131397,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131397,35.83,0.33,146,61219,70,NULL,NULL,'CGCG 136-035',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000117,NULL,'15.6g',0.46,NULL,'Group member',NULL,NULL,NULL,1,234.51775,26.26122,0.133,NULL,59916644966,936197577,14628087,15.6),(131398,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131398,35.83,0.33,146,61220,70,NULL,NULL,'CGCG 136-036',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000093,NULL,'15.4g',0.51,NULL,'Group member',NULL,NULL,NULL,1,234.518583,26.28153,0.133,NULL,59916639270,936197488,14628085,15.4),(131399,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131399,37.6,0.46,331,61221,70,NULL,NULL,'SDSS J153805.81+030508.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000073,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,234.524208333,3.08567,0.141,NULL,56395057763,881172777,13768324,18.2),(131400,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131400,37.87,0.46,374,61222,70,NULL,NULL,'2MASX J15380641+3233430',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000146,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,234.526625,32.562,0.077,NULL,59883353147,935677392,14619959,17.5),(131401,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131401,37.59,0.46,329,61223,70,NULL,NULL,'2MASX J15380654+3316070',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000188,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.527,33.26864,0.069,NULL,59884060211,935688440,14620131,17.4),(131402,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131402,37.66,0.33,340,61224,70,NULL,NULL,'2MASX J15380652+2835384',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000159,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,234.527125,28.59394,0.089,NULL,59918267143,936222924,14628483,17.9),(131403,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131403,37.55,0.46,323,61225,70,NULL,NULL,'2MASX J15380706+0634477',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,234.529375,6.57989,0.161,NULL,56414384659,881474760,13773043,17.4),(131404,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131404,36.71,0.46,220,61226,70,NULL,NULL,'2MASX J15380715+3114300',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000179,NULL,'16.1g',0.34,'E0',NULL,NULL,NULL,NULL,1,234.5297083,31.24183,0.077,NULL,59925517061,936336204,14630253,16.1),(131405,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131405,37.65,0.46,340,61227,70,NULL,NULL,'2MASX J15380849+2048097',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,234.535541667,20.80261,0.169,NULL,59458202777,929034418,14516162,16.7),(131406,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131406,38.37,0.46,473,61228,70,NULL,NULL,'SDSS J153809.80+120656.4',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,234.540875,12.11569,0.061,NULL,56590403796,884225059,13816016,NULL),(131407,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131407,37.5,0.46,316,61229,70,NULL,NULL,'SDSS J153810.15+222020.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.542333,22.33897,0.161,NULL,59453330192,928958284,14514973,18.4),(131408,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131408,36.45,0.46,195,61230,70,NULL,NULL,'2MASX J15381085+0337585',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,234.545291667,3.633,0.161,NULL,56395678894,881182482,13768476,17.1),(131409,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131409,37.63,0.33,336,61231,70,NULL,NULL,'2MASX J15381157+0301405',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000078,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.548125,3.02786,0.141,NULL,56403198592,881299978,13770312,17.5),(131410,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131410,38.55,0.46,514,61232,70,NULL,NULL,'SDSS J153812.67+055833.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.5527917,5.97597,0.145,NULL,56421887889,881591998,13774874,18.4),(131411,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131411,36.8,0.23,229,61233,70,NULL,NULL,'2MASX J15381415+1416317',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.5590417,14.27547,0.117,NULL,59428674900,928573045,14508953,17.4),(131412,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131412,38.19,0.15,434,61234,70,NULL,NULL,'2MASX J15381497+3048460',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000204,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,234.5625,30.81278,0.073,NULL,59925418951,936334671,14630229,16.5),(131413,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131413,35.38,0.56,119,61235,70,NULL,NULL,'2MASX J15381532-0654071',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.57',0.5,NULL,NULL,NULL,NULL,NULL,1,234.563917,-6.90214,0.457,NULL,45387170064,709174532,11080852,16.57),(131414,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131414,37.86,0.46,373,61236,70,NULL,NULL,'SDSS J153815.88+173844.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.566208333,17.64558,0.097,NULL,59438074337,928719911,14511248,18.2),(131415,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131415,37.66,0.33,340,61237,70,NULL,NULL,'2MASX J15381593+2839414',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000172,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,234.5664583,28.66153,0.077,NULL,59918268635,936222947,14628483,17.6),(131416,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131416,37.63,0.33,336,61238,70,NULL,NULL,'2MASX J15381658+0300475',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,234.569,3.01322,0.141,NULL,56403378633,881302791,13770356,16.9),(131417,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131417,36.44,0.09,194,61239,70,NULL,NULL,'2MASX J15381905+2151587',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00025,NULL,'16.56',0.2,NULL,NULL,NULL,NULL,NULL,1,234.5794583,21.86636,0.169,NULL,59452710256,928948597,14514821,16.56),(131418,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131418,36.11,0.46,167,61240,70,NULL,NULL,'2MASX J15382011+4708520',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000167,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,234.584,47.14792,0.037,NULL,59720130657,933127041,14580110,16.3),(131419,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131419,37.84,0.46,369,61241,70,NULL,NULL,'SDSS J153820.27+082630.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.5845,8.44194,0.073,NULL,56595910009,884311093,13817360,18.4),(131420,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131420,38.19,0.15,434,61242,70,NULL,NULL,'2MASX J15382056+3046030',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.5857917,30.76758,0.069,NULL,59925450055,936335157,14630236,17.9),(131421,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131421,37.16,0.46,270,61243,70,NULL,NULL,'2MASX J15382108+1746497',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000177,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,234.5879583,17.78058,0.089,NULL,59430209146,928597017,14509328,16.7),(131422,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131422,37.51,0.46,318,61244,70,NULL,NULL,'2MASX J15382197+3519210',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.591541667,35.32261,0.053,NULL,59893406640,935834478,14622413,17.6),(131423,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131423,32.41,0.4,30.3,61245,75,NULL,'B','UGC 09941',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.000017,NULL,'14.3',1.5,'Im:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,234.592083,12.96083,0.125,NULL,56523058697,883172792,13799574,14.3),(131424,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131424,35.67,0.59,136,61246,70,NULL,NULL,'CGCG 022-019',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000073,NULL,'15.9g',0.25,'Sa',NULL,NULL,NULL,NULL,1,234.5930417,-0.46211,0.305,NULL,45400901596,709389087,11084204,15.9),(131425,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131425,35.94,0.68,154,61247,70,NULL,NULL,'2MASX J15382438-0853511',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.17',0.3,NULL,NULL,NULL,NULL,NULL,1,234.601875,-8.89764,0.513,NULL,45610129918,712658279,11135285,16.17),(131426,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131426,36.93,0.46,243,61248,70,NULL,NULL,'2MASX J15382452+3053250',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000181,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,234.602083,30.89025,0.073,NULL,59925420133,936334689,14630229,16.2),(131427,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131427,38.3,0.46,458,61249,70,NULL,NULL,'2MASXi J1538254+375901',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,234.6057917,37.98375,0.045,NULL,60098347648,939036682,14672448,17.8),(131428,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131428,37.36,0.46,296,61250,70,NULL,NULL,'SDSS J153825.54+064026.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.606416667,6.67406,0.161,NULL,56414347791,881474184,13773034,18.5),(131429,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131429,37.97,0.46,392,61251,70,NULL,NULL,'2MASX J15382629+3033100',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.609583,30.55281,0.041,NULL,59927323532,936364430,14630694,17.6),(131430,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131430,37.68,0.46,344,61252,70,NULL,NULL,'2MASX J15382730+1943425',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,234.613625,19.7285,0.173,NULL,59456872626,929013634,14515838,16.9),(131431,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131431,36.96,0.33,246,61253,70,NULL,NULL,'2MASX J15382758+0623333',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'17.11',0.42,NULL,NULL,NULL,NULL,NULL,1,234.614875,6.39256,0.149,NULL,56413554733,881461792,13772840,17.11),(131432,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131432,38.07,0.46,412,61254,70,NULL,NULL,'2MASX J15382763+1918555',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000218,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,234.6150417,19.31525,0.125,NULL,59448557613,928883712,14513808,16.7),(131433,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131433,37.99,0.46,396,61255,70,NULL,NULL,'2MASX J15382789+0040301',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000098,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,234.616167,0.67492,0.253,NULL,56391120104,881111251,13767363,17.3),(131434,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131434,37.63,0.46,336,61256,70,NULL,NULL,'SDSS J153828.57+022209.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.6190417,2.36922,0.149,NULL,56403748025,881308562,13770446,17.9),(131435,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131435,38.08,0.46,414,61257,70,NULL,NULL,'SDSS J153829.29+472907.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000162,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,234.622083,47.48547,0.033,NULL,59720108825,933126700,14580104,18.4),(131436,'Ring Diameter','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131436,31.5,0.76,20,61258,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5970',NULL,'1981ApJS...45..541P',1981,1,2.9,NULL,'G',0.000017,NULL,'12.24',1.9,'SB(r)c;  HII   LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,234.624875,12.18661,0.069,NULL,56590152839,884221138,13815955,12.24),(131437,'Ring Diameter','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131437,31.9,0.6,24,61258,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5970',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131438,'Sosies','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131438,32.35,0.23,29.5,61258,NULL,NULL,NULL,'NGC 5970',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131439,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131439,31.51,0.69,20,61258,100,NULL,'mid-IR','NGC 5970',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131440,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131440,32.08,0.4,26.1,61258,NULL,NULL,NULL,'NGC 5970',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131441,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131441,32.24,0.43,28.1,61258,75,NULL,'3.6 micron, color corrected','NGC 5970',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131442,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131442,32.25,0.2,28.2,61258,74.4,NULL,NULL,'NGC 5970',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131443,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131443,32.28,0.43,28.6,61258,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5970',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131444,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131444,32.35,0.45,29.5,61258,NULL,NULL,'Malmquist cor.','NGC 5970',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131445,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131445,32.36,0.4,29.6,61258,NULL,NULL,'mean','NGC 5970',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131446,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131446,32.36,0.45,29.7,61258,NULL,NULL,NULL,'NGC 5970',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131447,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131447,32.5,0.4,31.6,61258,75,NULL,'B','NGC 5970',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131448,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131448,32.63,0.46,33.6,61258,NULL,NULL,'J','NGC 5970',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131449,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131449,32.64,0.47,33.7,61258,NULL,NULL,'H','NGC 5970',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131450,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131450,32.66,0.45,34,61258,NULL,NULL,'K','NGC 5970',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131451,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131451,37.42,0.46,305,61259,70,NULL,NULL,'2MASX J15382996+4618245',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,234.624625,46.30667,0.025,NULL,59688495739,932632745,14572386,17.5),(131452,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131452,37.88,0.46,377,61260,70,NULL,NULL,'2MASX J15383023+2648504',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000202,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,234.625916667,26.81417,0.129,NULL,59919448097,936241376,14628771,16.8),(131453,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131453,36.8,0.23,229,61261,70,NULL,NULL,'2MASX J15383025+1420397',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.6259583,14.34444,0.117,NULL,59426664044,928541625,14508462,17.1),(131454,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131454,37.3,0.21,288,61262,70,NULL,NULL,'2MASX J15383032+4703035',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000178,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,234.62625,47.05097,0.037,NULL,59687343716,932614745,14572105,16.7),(131455,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131455,37.91,0.46,382,61263,70,NULL,NULL,'SDSS J153830.32+262824.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000173,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,234.626333,26.4735,0.161,NULL,59916458967,936194671,14628041,18.7),(131456,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131456,37.93,0.46,385,61264,70,NULL,NULL,'2MASX J15383030+4339095',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,234.6265,43.65275,0.045,NULL,59690431513,932662992,14572859,17.9),(131457,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131457,36.6,0.27,209,61265,70,NULL,NULL,'2MASX J15383234+0642343',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000455,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,234.63475,6.70958,0.161,NULL,56414356833,881474325,13773036,16.3),(131458,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131458,36.95,0.27,245,61266,70,NULL,NULL,'2MASX J15383242+3812418',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,234.634916667,38.2115,0.057,NULL,60096523383,939008177,14672002,17.2),(131459,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131459,38.34,0.46,466,61267,70,NULL,NULL,'SDSS J153832.63+234902.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00021,NULL,'18.2g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.635958333,23.81744,0.149,NULL,59450684968,928916952,14514327,18.2),(131460,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131460,38.3,0.46,457,61268,70,NULL,NULL,'2MASX J15383334+3114367',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000165,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,234.639,31.24361,0.077,NULL,59926012595,936343946,14630374,17.3),(131461,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131461,36.14,0.46,169,61269,70,NULL,NULL,'2MASX J15383353+1320423',NULL,'2015arXiv151105856S',2015,1,0.88,NULL,'G',0.00006,NULL,'15.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,234.639583,13.34522,0.105,NULL,59425374224,928521472,14508148,15.4),(131462,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131462,36.6,0.27,209,61270,70,NULL,NULL,'2MASX J15383368+0639123',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000295,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.640375,6.65347,0.161,NULL,56414351439,881474241,13773035,17),(131463,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131463,37.49,0.33,315,61271,70,NULL,NULL,'SDSS J153834.31-002623.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00007,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,234.642958333,-0.43981,0.297,NULL,45400872653,709388635,11084197,18.2),(131464,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131464,38.19,0.15,434,61272,70,NULL,NULL,'2MASX J15383592+3051338',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,234.6497917,30.85953,0.065,NULL,59925428537,936334820,14630231,17.9),(131465,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131465,36.85,0.46,234,61273,70,NULL,NULL,'2MASX J15383718+4906215',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000167,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,234.65475,49.10592,0.049,NULL,59721316668,933145572,14580399,17.8),(131466,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131466,36.8,0.46,229,61274,70,NULL,NULL,'2MASX J15383750+1434363',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,234.6562083,14.57661,0.113,NULL,59426739719,928542808,14508481,16.8),(131467,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131467,36.93,0.46,243,61275,70,NULL,NULL,'2MASX J15383815+4209426',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000151,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,234.659041667,42.16178,0.089,NULL,59963579829,936930934,14639545,16.9),(131468,'SBF','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131468,32.91,0.15,38.2,61276,NULL,NULL,'BV A01','NGC 5982',NULL,'2007ApJ...668..130C',2007,1,2.26,NULL,'G',0.000031,NULL,'12.1g',1.39,'E3             LINER','in a triple',NULL,NULL,NULL,1,234.665958333,59.35583,0.013,NULL,57618197415,900284334,14066942,12.1),(131469,'SBF','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131469,33.03,0.14,40.4,61276,74.4,NULL,NULL,'NGC 5982',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131470,'SBF','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131470,33.09,0.1,41.5,61276,NULL,NULL,'J03','NGC 5982',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131471,'SBF','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131471,33.09,0.1,41.5,61276,NULL,NULL,'M06','NGC 5982',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131472,'SBF','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131472,33.2,0.66,43.7,61276,NULL,NULL,NULL,'NGC 5982',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131473,'SBF','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131473,33.25,0.1,44.7,61276,NULL,NULL,'T01','NGC 5982',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131474,'SBF','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131474,33.57,0.66,51.7,61276,NULL,NULL,'Malmquist cor.','NGC 5982',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131475,'D-Sigma','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131475,32.66,0.4,34,61276,75,NULL,'Edat, raw','NGC 5982',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131476,'D-Sigma','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131476,32.99,0.4,39.7,61276,75,NULL,'Edat, cor','NGC 5982',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131477,'Faber-Jackson','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131477,31.72,0.27,22.1,61276,95,NULL,'Weighted Mean','NGC 5982',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131478,'Faber-Jackson','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131478,31.79,0.63,22.8,61276,95,NULL,'Michard 1979b, c','NGC 5982',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131479,'Faber-Jackson','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131479,31.99,0.46,25,61276,95,NULL,'Michard 1979a','NGC 5982',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131480,'Faber-Jackson','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131480,32.09,0.4,26.2,61276,95,NULL,'de Vaucouleurs','NGC 5982',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131481,'Faber-Jackson','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131481,32.16,0.81,27,61276,55,NULL,'Visvanathan & Sandage 1979','NGC 5982',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131482,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131482,32.87,0.41,37.4,61276,NULL,NULL,NULL,'NGC 5982',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131483,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131483,33.06,0.41,41,61276,NULL,NULL,'Malmquist cor.','NGC 5982',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131484,'Tertiary','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131484,32.2,0.29,27.5,61276,95,NULL,NULL,'NGC 5982',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131485,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131485,32.91,0.45,38.1,61276,NULL,NULL,'K','NGC 5982',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131486,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131486,33.17,0.4,43.1,61276,NULL,NULL,'mean','NGC 5982',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131487,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131487,36.44,0.09,194,61277,70,NULL,NULL,'2MASX J15384018+2159546',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00006,NULL,'16.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,234.667458333,21.99839,0.169,NULL,59452946340,928952286,14514879,16.2),(131488,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131488,36.93,0.46,243,61278,70,NULL,NULL,'2MASX J15384313+0845408',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,234.679583,8.76139,0.081,NULL,56595955756,884311808,13817372,16.6),(131489,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131489,35.69,0.2,137,61279,74.4,NULL,NULL,'CGCG 166-023',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00005,NULL,'14.1',0.4,'Sc',NULL,NULL,NULL,NULL,1,234.6810417,29.41408,0.057,NULL,59927630408,936369225,14630769,14.1),(131490,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131490,37.4,0.46,302,61280,70,NULL,NULL,'2MASX J15384374+3102218',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000151,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,234.68225,31.03939,0.077,NULL,59925495888,936335873,14630248,17.3),(131491,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131491,37.83,0.46,367,61281,70,NULL,NULL,'2MASX J15384468+5808127',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,234.686,58.13703,0.005,NULL,57634423673,900537869,14070904,17.2),(131492,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131492,38.33,0.46,464,61282,70,NULL,NULL,'2MASX J15384714+0311331',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000085,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,234.696375,3.19253,0.181,NULL,56395148854,881174200,13768346,17.6),(131493,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131493,38.19,0.15,434,61283,70,NULL,NULL,'2MASX J15384881+3052209',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000175,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,234.7032917,30.87258,0.065,NULL,59925430093,936334845,14630231,17.3),(131494,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131494,35.41,0.46,121,61284,70,NULL,NULL,'2MASX J15384896+4934065',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000169,NULL,'15.9g',0.4,'S0',NULL,NULL,NULL,NULL,1,234.703833333,49.56833,0.053,NULL,59721494951,933148358,14580443,15.9),(131495,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131495,37.43,0.27,307,61285,70,NULL,NULL,'2MASX J15385006+3607599',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,234.7087917,36.13342,0.057,NULL,59893163002,935830671,14622354,17.1),(131496,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131496,38,0.46,397,61286,70,NULL,NULL,'2MASX J15385152+2536522',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,234.7147917,25.6145,0.157,NULL,59915735321,936183364,14627865,17.8),(131497,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131497,38.07,0.46,410,61287,70,NULL,NULL,'2MASX J15385172-0208247',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.7155,-2.14025,0.365,NULL,45413249584,709582024,11087219,17.9),(131498,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131498,36.18,0.46,172,61288,70,NULL,NULL,'2MASX J15385234+0737168',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000169,NULL,'16.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,234.71825,7.62139,0.093,NULL,56417059051,881516547,13773696,16.1),(131499,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131499,36.69,0.46,218,61289,70,NULL,NULL,'2MASX J15385312+5302444',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000143,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,234.721,53.04567,0.049,NULL,59672325127,932380080,14568438,17.3),(131500,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131500,36.6,0.27,209,61290,70,NULL,NULL,'2MASX J15385479+0639519',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.0002,NULL,'15.8g',0.49,'E0',NULL,NULL,NULL,NULL,1,234.728333,6.66444,0.161,NULL,56414343365,881474115,13773033,15.8),(131501,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131501,36.85,0.46,234,61291,70,NULL,NULL,'2MASX J15385641+4213577',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000183,NULL,'16.0g',0.34,'E0',NULL,NULL,NULL,NULL,1,234.734875,42.23283,0.077,NULL,59963455154,936928986,14639515,16),(131502,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131502,37.17,0.46,271,61292,70,NULL,NULL,'2MASX J15385686+4017549',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,234.73675,40.29872,0.061,NULL,59962656051,936916500,14639320,17.5),(131503,'IRAS','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131503,34.38,0.8,75.2,61293,75,NULL,'MAT, I','ESO 515- G 003',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.5',1,'SB(rs)c',NULL,NULL,NULL,NULL,1,234.7375417,-22.66347,0.549,NULL,46631828809,728622325,11384723,14.5),(131504,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131504,34.28,0.43,71.8,61293,75,NULL,'MAT, I, raw','ESO 515- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131505,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131505,34.44,0.47,77.4,61293,NULL,NULL,'H','ESO 515- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131506,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131506,34.47,0.46,78.5,61293,NULL,NULL,'J','ESO 515- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131507,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131507,34.52,0.45,80,61293,NULL,NULL,'K','ESO 515- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131508,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131508,34.53,0.4,80.5,61293,NULL,NULL,'mean','ESO 515- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131509,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131509,34.57,0.43,81.9,61293,75,NULL,'MAT, I, cor','ESO 515- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131510,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131510,34.59,0.43,82.6,61293,75,NULL,'MAT, I, inv','ESO 515- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131511,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131511,34.59,0.32,82.9,61293,85,NULL,'I, raw','ESO 515- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131512,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131512,34.62,0.2,84,61293,74.4,NULL,NULL,'ESO 515- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131513,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131513,34.67,0.32,86,61293,85,NULL,'I, inv','ESO 515- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131514,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131514,34.74,0.34,88.5,61293,NULL,NULL,NULL,'ESO 515- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131515,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131515,34.79,0.33,91,61293,NULL,NULL,'Malmquist cor.','ESO 515- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131516,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131516,36.44,0.09,194,61294,70,NULL,NULL,'2MASX J15385812+2148178',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000067,NULL,'17.47',0.2,NULL,NULL,NULL,NULL,NULL,1,234.742125,21.80486,0.181,NULL,59452917690,928951838,14514872,17.47),(131517,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131517,37.12,0.46,266,61295,70,NULL,NULL,'2MASX J15385818+0256119',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000076,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.742458333,2.93656,0.173,NULL,56403358025,881302469,13770351,17.3),(131518,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131518,36.82,0.2,231,61296,74.4,NULL,NULL,'CGCG 136-039',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00007,NULL,'15.5',0.3,'S0',NULL,NULL,NULL,NULL,1,234.743,23.78078,0.149,NULL,59450676834,928916825,14514325,15.5),(131519,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131519,37.49,0.33,315,61297,70,NULL,NULL,'2MASX J15385905-0025298',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000091,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,234.746083333,-0.42489,0.297,NULL,45400870367,709388599,11084196,16.8),(131520,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131520,36.09,0.46,165,61298,70,NULL,NULL,'CGCG 050-057',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000187,NULL,'15.5g',0.51,NULL,NULL,NULL,NULL,NULL,1,234.747333,8.09033,0.081,NULL,56596330467,884317663,13817463,15.5),(131521,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131521,36.96,0.33,246,61299,70,NULL,NULL,'2MASX J15385990+0625049',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000156,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,234.7494583,6.41794,0.161,NULL,56413640376,881463130,13772861,16.7),(131522,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131522,37.86,0.33,374,61300,70,NULL,NULL,'2MASX J15390169+3530459',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000237,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,234.756917,35.51281,0.053,NULL,59893376697,935834010,14622406,17.1),(131523,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131523,36.34,0.46,185,61301,70,NULL,NULL,'2MASX J15390216+3304479',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000168,NULL,'16.0g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,234.758917,33.08014,0.069,NULL,59883249098,935675767,14619933,16),(131524,'Tully est','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131524,32.34,0.8,29.4,61302,75,NULL,'B','NGC 5974',NULL,'1988NBGC.C....0000T',1988,1,0.87,NULL,'G',0.000097,NULL,'14.1g',0.53,'Sd/Irr','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,234.760083,31.75992,0.093,NULL,59925173588,936330837,14630169,14.1),(131525,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131525,37.86,0.33,374,61303,70,NULL,NULL,'SDSS J153902.56+353142.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000139,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,234.7607083,35.52856,0.053,NULL,59893376870,935834013,14622406,18.4),(131526,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131526,37.54,0.46,322,61304,70,NULL,NULL,'2MASX J15390364+0712329',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,234.7652083,7.20903,0.109,NULL,56413867494,881466679,13772916,17),(131527,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131527,37.17,0.33,271,61305,70,NULL,NULL,'2MASX J15390366+3205219',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.765333,32.08961,0.085,NULL,59913577513,936149648,14627338,17.1),(131528,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131528,37.48,0.46,313,61306,70,NULL,NULL,'2MASX J15390418+0231299',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000082,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,234.7675,2.52489,0.133,NULL,56403938529,881311539,13770492,17.3),(131529,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131529,37.44,0.46,308,61307,70,NULL,NULL,'SDSS J153904.53+332740.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000134,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,234.768875,33.46117,0.069,NULL,59891057863,935797779,14621840,18.5),(131530,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131530,37.17,0.33,271,61308,70,NULL,NULL,'2MASX J15390462+3212199',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.7692917,32.20544,0.085,NULL,59913585135,936149767,14627340,17.6),(131531,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131531,38.02,0.33,402,61309,70,NULL,NULL,'2MASX J15390472+1256404',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,'PHOT','16.6g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,234.7697917,12.94453,0.125,NULL,56523247086,883175735,13799620,16.6),(131532,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131532,38.02,0.33,402,61310,70,NULL,NULL,'2MASX J15390526+1255044',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,234.771875,12.91786,0.125,NULL,56523246764,883175730,13799620,18.2),(131533,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131533,36.94,0.33,244,61311,70,NULL,NULL,'2MASX J15390562+2845411',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00009,NULL,'15.5g',0.54,NULL,NULL,NULL,NULL,NULL,1,234.773417,28.76133,0.077,NULL,59927431039,936366109,14630720,15.5),(131534,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131534,36.94,0.33,244,61312,70,NULL,NULL,'2MASX J15390685+2851031',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00019,NULL,'17.1g',0.23,'E',NULL,NULL,NULL,NULL,1,234.778667,28.85094,0.065,NULL,59927434500,936366164,14630721,17.1),(131535,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131535,37.18,0.46,273,61313,70,NULL,NULL,'2MASX J15390692+5159429',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000173,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,234.778916667,51.99522,0.049,NULL,59671267466,932363554,14568180,16.7),(131536,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131536,37.43,0.27,307,61314,70,NULL,NULL,'2MASX J15390762+3602238',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,234.781667,36.04003,0.065,NULL,59893209947,935831405,14622365,17.4),(131537,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131537,37.19,0.46,274,61315,70,NULL,NULL,'2MASX J15390927+3731098',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000138,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,234.78875,37.51933,0.049,NULL,59879670887,935619857,14619060,17.3),(131538,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131538,37.43,0.27,307,61316,70,NULL,NULL,'SDSS J153909.38+360525.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000175,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,234.789083333,36.0905,0.065,NULL,59893194255,935831160,14622361,18.1),(131539,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131539,38.62,0.46,530,61317,70,NULL,NULL,'SDSS J153909.52+315656.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000138,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,234.789666667,31.94894,0.089,NULL,59913683900,936151310,14627364,18.8),(131540,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131540,35.51,0.64,126,61318,70,NULL,NULL,'2MASX J15391002-1411478',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.10',NULL,NULL,NULL,NULL,NULL,NULL,1,234.791833,-14.19653,0.517,NULL,46592932670,728014572,11375227,16.1),(131541,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131541,38.11,0.46,419,61319,70,NULL,NULL,'2MASX J15391124+3207202',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.796917,32.12217,0.085,NULL,59913577941,936149655,14627338,17.7),(131542,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131542,36.69,0.46,218,61320,70,NULL,NULL,'2MASX J15391225+4321410',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,234.801,43.36144,0.061,NULL,59678808376,932481380,14570021,16.9),(131543,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131543,37.97,0.46,392,61321,70,NULL,NULL,'2MASX J15391273+0303479',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000071,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,234.8029583,3.06333,0.177,NULL,56395112929,881173639,13768338,17.9),(131544,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131544,38.19,0.46,435,61322,70,NULL,NULL,'SDSS J153912.87+254710.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000147,NULL,'18.8g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.803666667,25.78633,0.157,NULL,59915714492,936183038,14627859,18.8),(131545,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131545,37.28,0.46,286,61323,70,NULL,NULL,'2MASX J15391333+0301589',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000087,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.805666667,3.03317,0.177,NULL,56403303848,881301622,13770337,17.6),(131546,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131546,34.28,NULL,71.8,61324,NULL,NULL,NULL,'UGC 09949',NULL,'2000BSAO...50....5K',2000,1,1.15,NULL,'G',0.000012,NULL,'16.0',0.11,'Sc','Group member',NULL,NULL,NULL,1,234.805833,14.17706,0.117,NULL,59426700483,928542195,14508471,16),(131547,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131547,34.3,NULL,72.4,61324,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09949',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131548,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131548,34.33,NULL,73.6,61324,NULL,NULL,'Dipole + Quadrupole','UGC 09949',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131549,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131549,34.35,NULL,74.2,61324,NULL,NULL,'Dipole','UGC 09949',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131550,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131550,34.53,0.49,80.5,61324,75,NULL,'IR','UGC 09949',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131551,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131551,34.61,0.2,83.6,61324,74.4,NULL,NULL,'UGC 09949',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131552,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131552,37.24,0.46,281,61325,70,NULL,NULL,'2MASX J15391347+3343262',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,234.8062083,33.72394,0.065,NULL,59891107967,935798561,14621852,17.4),(131553,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131553,37.85,0.46,371,61326,70,NULL,NULL,'2MASX J15391358+0042039',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000082,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,234.8065417,0.70111,0.245,NULL,56391773162,881121455,13767522,17.4),(131554,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131554,35.41,0.46,121,61327,70,NULL,NULL,'2MASX J15391412+0111419',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000063,NULL,'16.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,234.80875,1.19489,0.249,NULL,56391622284,881119098,13767485,16.2),(131555,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131555,39.28,0.46,718,61328,70,NULL,NULL,'SDSS J153914.21-014418.8',NULL,'2015arXiv151105856S',2015,1,0.11,NULL,'G',0.000157,NULL,'19.2g',0.09,NULL,NULL,NULL,NULL,NULL,1,234.8092083,-1.73858,0.365,NULL,45401792069,709403001,11084421,19.2),(131556,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131556,37.47,0.46,312,61329,70,NULL,NULL,'2MASX J15391458+4522250',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000179,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.810916667,45.37378,0.017,NULL,59688308411,932629818,14572340,17.1),(131557,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131557,34.78,0.55,90.2,61330,70,NULL,NULL,'2MASX J15391472-1138232',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.89',NULL,NULL,NULL,NULL,NULL,NULL,1,234.8112917,-11.63992,0.589,NULL,45600854084,712513345,11133021,15.89),(131558,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131558,35.74,0.49,140,61331,75,NULL,'IR','UGC 09957',NULL,'2011yCatp016004901K',2011,1,1.41,NULL,'G',0.000173,NULL,'16.3g',0.17,'Sd',NULL,NULL,NULL,NULL,1,234.813125,40.14525,0.061,NULL,59962676213,936916815,14639325,16.3),(131559,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131559,36,NULL,158,61331,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09957',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131560,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131560,36.02,NULL,160,61331,NULL,NULL,'Dipole + Quadrupole','UGC 09957',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131561,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131561,36.02,NULL,160,61331,NULL,NULL,NULL,'UGC 09957',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131562,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131562,36.04,NULL,161,61331,NULL,NULL,'Dipole','UGC 09957',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131563,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131563,34.92,NULL,96.4,61332,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1931',NULL,'2010Ap&SS.325..163P',2010,1,0.72,NULL,'G',0.00009,NULL,'17.0g',0.14,'Sd',NULL,NULL,NULL,NULL,1,234.814875,46.83617,0.029,NULL,59687554936,932618045,14572156,17),(131564,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131564,34.93,NULL,97,61332,NULL,NULL,'Dipole + Quadrupole','FGC 1931',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131565,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131565,34.96,NULL,98.4,61332,NULL,NULL,'Dipole','FGC 1931',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131566,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131566,35.19,NULL,109,61332,NULL,NULL,NULL,'FGC 1931',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131567,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131567,35.81,0.2,145,61333,74.4,NULL,NULL,'UGC 09954',NULL,'2013AJ....146...86T',2013,1,1.05,NULL,'G',0.000033,NULL,'14.9g',0.41,'Sab',NULL,NULL,NULL,NULL,1,234.819541667,24.45508,0.125,NULL,59395657535,928057148,14500892,14.9),(131568,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131568,35.87,0.4,149,61333,NULL,NULL,'mean','UGC 09954',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131569,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131569,35.91,0.47,152,61333,NULL,NULL,'H','UGC 09954',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131570,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131570,35.95,0.45,155,61333,NULL,NULL,'K','UGC 09954',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131571,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131571,36.1,0.46,166,61333,NULL,NULL,'J','UGC 09954',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131572,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131572,36.44,0.09,194,61334,70,NULL,NULL,'2MASX J15391714+2144319',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000063,NULL,'17.13',0.2,NULL,NULL,NULL,NULL,NULL,1,234.8214583,21.74206,0.181,NULL,59452799587,928949993,14514843,17.13),(131573,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131573,36.78,0.46,227,61335,70,NULL,NULL,'2MASX J15391877+0444399',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,234.828125,4.74436,0.129,NULL,56393128728,881142636,13767853,16.5),(131574,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131574,37.36,0.46,297,61336,70,NULL,NULL,'2MASX J15391944+1922529',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000185,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.830917,19.38131,0.137,NULL,59448617199,928884643,14513822,17),(131575,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131575,35.27,0.46,113,61337,70,NULL,NULL,'2MASX J15391964+0452069',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,234.831875,4.86878,0.117,NULL,56393233626,881144275,13767879,16),(131576,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131576,36.44,0.09,194,61338,70,NULL,NULL,'2MASX J15391980+2152329',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00025,NULL,'17.71',0.2,NULL,NULL,NULL,NULL,NULL,1,234.832416667,21.87575,0.189,NULL,59452793223,928949894,14514842,17.71),(131577,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131577,33.87,0.54,59.6,61339,NULL,NULL,NULL,'ESO 450- G 004',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.70',0.2,'S...',NULL,NULL,NULL,NULL,1,234.8325,-29.99681,0.533,NULL,47177471590,737147993,11517937,16.7),(131578,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131578,33.92,0.2,60.8,61339,74.4,NULL,NULL,'ESO 450- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131579,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131579,34.14,0.48,67.2,61339,NULL,NULL,'Malmquist cor.','ESO 450- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131580,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131580,34.37,0.49,74.8,61339,75,NULL,'IR','ESO 450- G 004',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131581,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131581,35.85,0.25,148,61340,74.4,NULL,NULL,'CGCG 136-041',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.00007,NULL,'14.24',0.7,'E/S0','Group member',NULL,NULL,NULL,1,234.8452917,21.73925,0.181,NULL,59452799985,928949999,14514843,14.24),(131582,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131582,36.04,0.27,161,61340,70,NULL,NULL,'CGCG 136-041',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131583,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131583,36.44,0.09,194,61340,70,NULL,NULL,'CGCG 136-041',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131584,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131584,36.44,0.09,194,61341,70,NULL,NULL,'2MASX J15392453+2140139',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000063,NULL,'16.81',0.3,NULL,NULL,NULL,NULL,NULL,1,234.852375,21.67036,0.173,NULL,59454682991,928979421,14515303,16.81),(131585,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131585,38,0.46,399,61342,70,NULL,NULL,'2MASX J15392486+1207035',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,234.85375,12.11761,0.101,NULL,56590304695,884223510,13815992,17),(131586,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131586,37.97,0.14,393,61343,70,NULL,NULL,'2MASX J15392535+1738025',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,234.8557083,17.63406,0.097,NULL,59430573595,928602712,14509417,17.9),(131587,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131587,37.04,0.46,256,61344,70,NULL,NULL,'2MASX J15392567+1618425',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,234.8569583,16.31178,0.105,NULL,59439948560,928749196,14511706,NULL),(131588,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131588,38.97,0.46,621,61345,70,NULL,NULL,'SDSS J153926.15+115444.4',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,234.8589583,11.91233,0.109,NULL,56590297114,884223392,13815990,NULL),(131589,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131589,36.26,0.46,178,61346,70,NULL,NULL,'2MASX J15392629+0019457',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000079,NULL,'17.6g',0.17,'NLAGN',NULL,NULL,NULL,'Sy 2',1,234.8597083,0.32928,0.253,NULL,56391679541,881119992,13767499,17.6),(131590,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131590,38.5,0.46,502,61347,70,NULL,NULL,'SDSS J153926.34+044607.6',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,234.8597917,4.76881,0.129,NULL,56393110531,881142352,13767849,NULL),(131591,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131591,37.55,0.33,324,61348,70,NULL,NULL,'2MASX J15392642+2319419',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.860083,23.32842,0.153,NULL,59450623623,928915994,14514312,17.2),(131592,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131592,36.74,0.46,223,61349,70,NULL,NULL,'2MASX J15392690+1706255',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,234.8619583,17.10697,0.077,NULL,59438034388,928719287,14511238,16.9),(131593,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131593,37.86,0.46,373,61350,70,NULL,NULL,'2MASX J15392693+1919239',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,234.8622917,19.32333,0.137,NULL,59448615527,928884617,14513822,17.3),(131594,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131594,37.73,0.33,352,61351,70,NULL,NULL,'2MASX J15392715+1056130',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.863167,10.93694,0.089,NULL,56593603524,884275055,13816797,17.7),(131595,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131595,36.95,0.27,245,61352,70,NULL,NULL,'2MASX J15392719+3808218',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000163,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,234.863416667,38.13944,0.057,NULL,59878157406,935596209,14618690,16.8),(131596,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131596,37.55,0.33,324,61353,70,NULL,NULL,'2MASX J15392747+2320378',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000181,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.864416667,23.34378,0.153,NULL,59450625173,928916018,14514312,17.5),(131597,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131597,38.19,0.15,434,61354,70,NULL,NULL,'SDSS J153927.96+304424.7',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.27,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.8665,30.74022,0.073,NULL,59925864949,936341639,14630338,17),(131598,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131598,36.55,0.46,204,61355,70,NULL,NULL,'SDSS J153927.98+103705.9',NULL,'2015arXiv151105856S',2015,1,0.07,NULL,'G',NULL,NULL,'20.6g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.866625,10.61833,0.085,NULL,56590927852,884233247,13816144,20.6),(131599,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131599,36.42,0.46,192,61356,70,NULL,NULL,'2MASX J15392880+1817419',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000172,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,234.870125,18.29511,0.073,NULL,59430329254,928598894,14509357,16.3),(131600,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131600,38.19,0.15,434,61357,70,NULL,NULL,'2MASX J15392882+3044002',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000139,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,234.8702917,30.73333,0.073,NULL,59925864930,936341639,14630338,18.5),(131601,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131601,38.41,0.46,482,61358,70,NULL,NULL,'2MASX J15392887+0502267',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,234.870375,5.04086,0.117,NULL,56393448385,881147631,13767931,17.9),(131602,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131602,37.91,0.46,383,61359,70,NULL,NULL,'2MASX J15393008+5635147',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000075,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,234.87525,56.58733,0.041,NULL,57592010119,899875158,14060549,18),(131603,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131603,37.69,0.46,344,61360,70,NULL,NULL,'2MASX J15393049+0051107',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000087,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,234.877125,0.85286,0.249,NULL,56392346224,881130409,13767662,17.1),(131604,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131604,37.97,0.14,393,61361,70,NULL,NULL,'2MASXi J1539306+174652',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,234.877958333,17.78119,0.073,NULL,59431117864,928611216,14509550,18.1),(131605,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131605,37.73,0.46,352,61362,70,NULL,NULL,'SDSS J153931.71-013118.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000134,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,234.882125,-1.52172,0.385,NULL,45402308649,709411072,11084548,18.8),(131606,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131606,37.94,0.46,387,61363,70,NULL,NULL,'SDSS J153931.72+303745.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000142,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,234.8822083,30.62919,0.073,NULL,59925399463,936334366,14630224,18.3),(131607,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131607,36.95,0.27,245,61364,70,NULL,NULL,'2MASX J15393202+3809488',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000205,NULL,'15.6g',0.48,NULL,NULL,NULL,NULL,NULL,1,234.883375,38.16392,0.057,NULL,59878157797,935596215,14618690,15.6),(131608,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131608,36.6,0.46,209,61365,70,NULL,NULL,'2MASX J15393209+4804229',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00017,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,234.883833333,48.07311,0.045,NULL,59722499878,933164060,14580688,17.5),(131609,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131609,37.68,0.46,343,61366,70,NULL,NULL,'SDSS J153932.23+104841.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.884333,10.81147,0.077,NULL,56593563042,884274422,13816787,18.2),(131610,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131610,35.24,0.5,112,61367,70,NULL,NULL,'2MASX J15393276-1134262',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00014,NULL,'15.79',NULL,NULL,NULL,NULL,NULL,NULL,1,234.886625,-11.574,0.589,NULL,45604336099,712567751,11133871,15.79),(131611,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131611,36.76,0.46,225,61368,70,NULL,NULL,'2MASX J15393305+3205382',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000187,NULL,'15.8g',0.48,'E0',NULL,NULL,NULL,NULL,1,234.887833,32.09397,0.085,NULL,59913583581,936149743,14627339,15.8),(131612,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131612,36.6,0.46,209,61369,70,NULL,NULL,'2MASX J15393349+0331577',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000095,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.889416667,3.53286,0.141,NULL,56395332623,881177072,13768391,17.1),(131613,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131613,36.44,0.09,194,61370,70,NULL,NULL,'2MASX J15393532+2144259',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000073,NULL,'16.84',0.3,NULL,NULL,NULL,NULL,NULL,1,234.897375,21.74053,0.181,NULL,59452792037,928949875,14514841,16.84),(131614,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131614,36.67,0.33,216,61371,70,NULL,NULL,'2MASX J15393556+5530162',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000108,NULL,'16.2g',0.4,'AGN',NULL,NULL,NULL,NULL,1,234.898333,55.50442,0.037,NULL,57584978096,899765282,14058832,16.2),(131615,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131615,36.28,0.33,181,61372,70,NULL,NULL,'2MASX J15393652+4601500',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000205,NULL,'15.9g',0.4,'E0',NULL,NULL,NULL,NULL,1,234.901917,46.03067,0.021,NULL,59688168491,932627632,14572306,15.9),(131616,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131616,36.64,0.46,213,61373,70,NULL,NULL,'2MASX J15393700+1109255',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'15.7g',0.47,NULL,NULL,NULL,NULL,NULL,1,234.90425,11.157,0.101,NULL,56593723456,884276929,13816827,15.7),(131617,'Ring Diameter','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131617,32.1,0.84,26,61374,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5985',NULL,'1981ApJS...45..541P',1981,1,5.5,NULL,'G',0.000013,NULL,'11.87',3,'SAB(r)b;LINER  Sy1','in a triple',NULL,NULL,'Sy',1,234.9045417,59.33194,NULL,NULL,57618166191,900283846,14066935,11.87),(131618,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131618,32.1,0.69,26.4,61374,100,NULL,'mid-IR','NGC 5985',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131619,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131619,32.94,0.4,38.8,61374,NULL,NULL,'mean','NGC 5985',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131620,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131620,32.97,0.4,39.2,61374,75,NULL,'B','NGC 5985',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131621,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131621,33.03,0.46,40.4,61374,NULL,NULL,'J','NGC 5985',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131622,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131622,33.07,0.41,41.2,61374,NULL,NULL,'Malmquist cor.','NGC 5985',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131623,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131623,33.09,0.41,41.5,61374,NULL,NULL,NULL,'NGC 5985',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131624,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131624,33.12,0.45,42,61374,NULL,NULL,'K','NGC 5985',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131625,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131625,33.51,0.2,50.4,61374,74.4,NULL,NULL,'NGC 5985',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131626,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131626,33.61,0.36,52.7,61374,NULL,NULL,NULL,'NGC 5985',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131627,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131627,33.78,0.43,56.9,61374,75,NULL,'3.6 micron, color corrected','NGC 5985',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131628,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131628,33.93,0.43,61.1,61374,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5985',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131629,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131629,36.85,0.46,235,61375,70,NULL,NULL,'2MASX J15393757+2355119',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000149,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,234.906583333,23.92006,0.145,NULL,59450663924,928916623,14514322,16.8),(131630,'SZ effect','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131630,39.03,0.63,640,61376,NULL,NULL,'Hydrost. Eq.','ABELL 2111',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III [BM]',NULL,NULL,NULL,NULL,1,234.93375,34.41556,0.061,NULL,59894110308,935845473,14622585,NULL),(131631,'SZ effect','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131631,39.29,0.97,720,61376,NULL,NULL,'Isotherm., r < 100 kpc','ABELL 2111',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131632,'SZ effect','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131632,39.29,1,720,61376,NULL,NULL,'Isotherm.','ABELL 2111',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131633,'SZ effect','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131633,39.75,NULL,893,61376,NULL,NULL,'4.2 (black) calibration','ABELL 2111',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131634,'SZ effect','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131634,39.78,NULL,903,61376,NULL,NULL,'3.1 (red) calibration','ABELL 2111',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131635,'SZ effect','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131635,39.82,NULL,921,61376,NULL,NULL,'4.1 (blue) calibration','ABELL 2111',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131636,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131636,36.34,0.6,185,61377,70,NULL,NULL,'2MASX J15393825-2356332',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,234.909417,-23.94264,0.541,NULL,46628475627,728569931,11383905,14.6),(131637,'BCG','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131637,36.47,0.35,189,61378,60,NULL,NULL,'ABELL 2107',0.0421,'1980ApJ...241..486H',1980,1,NULL,'The adopted position is for UGC 09958, the brightest cluster member.','GClstr',0.000287,NULL,NULL,NULL,'I      [BM]',NULL,NULL,NULL,NULL,1,234.91,21.78889,0.181,NULL,59452796960,928949952,14514843,NULL),(131638,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131638,36.67,0.33,216,61379,70,NULL,NULL,'2MASX J15393847+5519382',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000178,NULL,'16.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,234.91025,55.32742,0.025,NULL,57587658541,899807164,14059486,16.6),(131639,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131639,35.46,0.49,124,61380,75,NULL,'IR','UGC 09956',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000033,NULL,'15.60',0.2,'SBb',NULL,NULL,NULL,NULL,1,234.912375,10.21994,0.105,NULL,56591534875,884242732,13816292,15.6),(131640,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131640,35.93,0.2,153,61380,74.4,NULL,NULL,'UGC 09956',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131641,'BCG','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131641,36.47,0.35,189,61381,60,NULL,'ABELL 2107, BCG','UGC 09958',0.0421,'1980ApJ...241..486H',1980,1,1.3,'May be associated with the extended X-ray source EXSS 1537.4+2156.','G',0.000083,NULL,'14.33',1.1,'E;S0-:         BrClG','Group member',NULL,NULL,NULL,1,234.912667,21.78272,0.181,NULL,59452789867,928949841,14514841,14.33),(131642,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131642,35.85,0.25,148,61381,74.4,NULL,NULL,'UGC 09958',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131643,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131643,36.04,0.27,161,61381,70,NULL,NULL,'UGC 09958',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131644,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131644,36.44,0.09,194,61381,70,NULL,NULL,'UGC 09958',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131645,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131645,36.15,0.45,170,61381,NULL,NULL,'K','UGC 09958',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131646,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131646,36.24,0.4,177,61381,NULL,NULL,'mean','UGC 09958',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131647,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131647,38.3,0.46,458,61382,70,NULL,NULL,'2MASX J15393978+3042276',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000163,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,234.915917,30.70775,0.073,NULL,59925865972,936341655,14630338,18.5),(131648,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131648,36.9,0.2,240,61383,74.4,NULL,NULL,'CGCG 136-045',NULL,'2013AJ....146...86T',2013,1,0.82,NULL,'G',0.00006,NULL,'15.4g',0.37,'Sc',NULL,NULL,NULL,NULL,1,234.918375,25.73983,0.157,NULL,59869627810,935462934,14616608,15.4),(131649,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131649,37.04,0.46,256,61384,70,NULL,NULL,'2MASX J15394092+1532419',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,234.920583333,15.54511,0.093,NULL,59440487891,928757623,14511837,18),(131650,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131650,37.66,0.46,340,61385,70,NULL,NULL,'2MASX J15394088+2338079',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,234.920667,23.63553,0.149,NULL,59450834750,928919292,14514363,18),(131651,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131651,37.07,0.46,260,61386,70,NULL,NULL,'2MASX J15394162+3548556',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000178,NULL,'15.8g',0.51,'E0',NULL,NULL,NULL,NULL,1,234.9232917,35.81539,0.053,NULL,59893296010,935832750,14622386,15.8),(131652,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131652,36.44,0.09,194,61387,70,NULL,NULL,'2MASX J15394162+2151149',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.00007,NULL,'16.17',0.32,NULL,NULL,NULL,NULL,NULL,1,234.9235,21.85411,0.189,NULL,59452804940,928950077,14514844,16.17),(131653,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131653,37.78,0.33,360,61388,70,NULL,NULL,'2MASX J15394218+0325087',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000086,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,234.925667,3.419,0.161,NULL,56395402235,881178159,13768408,17.3),(131654,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131654,36.99,0.46,250,61389,70,NULL,NULL,'2MASX J15394357+0309477',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000083,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,234.931625,3.16328,0.177,NULL,56395375718,881177745,13768402,16.5),(131655,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131655,38.86,0.46,593,61390,70,NULL,NULL,'SBS 1538+580',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,234.932375,57.85586,0.025,NULL,57637620780,900587824,14071684,18.3),(131656,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131656,35.12,NULL,106,61391,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1932',NULL,'2010Ap&SS.325..163P',2010,1,0.84,NULL,'G',0.000101,NULL,'17.5g',0.09,'Sdm',NULL,NULL,NULL,NULL,1,234.9415,41.87339,0.069,NULL,59963402965,936928171,14639502,17.5),(131657,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131657,35.15,NULL,107,61391,NULL,NULL,'Dipole + Quadrupole','FGC 1932',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131658,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131658,35.17,NULL,108,61391,NULL,NULL,'Dipole','FGC 1932',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131659,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131659,35.33,NULL,116,61391,NULL,NULL,NULL,'FGC 1932',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131660,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131660,37.66,0.46,341,61392,70,NULL,NULL,'2MASX J15394598+3238277',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000153,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.9417083,32.641,0.105,NULL,59883185405,935674771,14619918,17.4),(131661,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131661,38.13,0.46,423,61393,70,NULL,NULL,'2MASX J15394635-0156266',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,234.943167,-1.94061,0.337,NULL,45401877663,709404338,11084442,18.4),(131662,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131662,37.97,0.14,393,61394,70,NULL,NULL,'2MASX J15394645+1750079',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000176,NULL,'16.3g',0.39,'BrClG',NULL,NULL,NULL,NULL,1,234.943625,17.8355,0.073,NULL,59431080419,928610631,14509541,16.3),(131663,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131663,34.97,0.49,98.7,61395,70,NULL,NULL,'2MASX J15394745-1323422',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,234.94775,-13.39508,0.553,NULL,45466549409,710414834,11100231,14.8),(131664,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131664,37.78,0.33,360,61396,70,NULL,NULL,'2MASX J15394758+0325137',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000118,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,234.948166667,3.42042,0.161,NULL,56395412720,881178323,13768411,16.4),(131665,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131665,37.38,0.46,299,61397,70,NULL,NULL,'2MASX J15394777+3114217',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000141,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,234.949083,31.23939,0.089,NULL,59926110945,936345483,14630398,17.2),(131666,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131666,38.48,0.46,498,61398,70,NULL,NULL,'2MASX J15394804+1412059',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.9502083,14.20172,0.117,NULL,59426720265,928542504,14508476,17.9),(131667,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131667,37.55,0.21,324,61399,70,NULL,NULL,'2MASX J15394812+0311067',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000081,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.950625,3.18522,0.169,NULL,56395380252,881177816,13768403,17.5),(131668,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131668,36.44,0.09,194,61400,70,NULL,NULL,'2MASX J15394873+2147270',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000073,NULL,'16.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,234.953083,21.79086,0.181,NULL,59452808059,928950125,14514845,16.4),(131669,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131669,37.85,0.46,371,61401,70,NULL,NULL,'2MASX J15394962+4710268',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,234.956875,47.17406,0.045,NULL,59720304296,933129754,14580152,17.3),(131670,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131670,37.73,0.33,352,61402,70,NULL,NULL,'2MASX J15394985+1057405',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,234.957625,10.96122,0.089,NULL,56593609777,884275152,13816799,17.9),(131671,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131671,37.37,0.33,298,61403,70,NULL,NULL,'2MASX J15395045+4436218',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000171,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,234.960125,44.60614,0.029,NULL,59690832853,932669263,14572957,18),(131672,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131672,37.43,0.46,307,61404,70,NULL,NULL,'2MASX J15395059+3348197',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000186,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,234.96075,33.80544,0.065,NULL,59891074891,935798045,14621844,16.3),(131673,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131673,36.44,0.09,194,61405,70,NULL,NULL,'2MASX J15395067+2158070',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000057,NULL,'17.59',0.2,NULL,NULL,NULL,NULL,NULL,1,234.961125,21.96869,0.189,NULL,59452783046,928949735,14514839,17.59),(131674,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131674,38.19,0.15,434,61406,70,NULL,NULL,'2MASX J15395079+3043037',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000222,NULL,'16.0g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,234.961583,30.71778,0.073,NULL,59925869030,936341703,14630339,16),(131675,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131675,36.04,0.27,161,61407,70,NULL,NULL,'GIN 442',NULL,'2001MNRAS.321..277C',2001,1,0.41,NULL,'G',NULL,NULL,'16.4g',0.36,'S',NULL,NULL,NULL,NULL,1,234.963667,21.70419,0.181,NULL,59452788905,928949826,14514841,16.4),(131676,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131676,37.97,0.14,393,61408,70,NULL,NULL,'2MASX J15395261+1757329',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00019,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,234.9692917,17.95906,0.069,NULL,59431132333,928611442,14509553,16.8),(131677,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131677,37.97,0.14,393,61409,70,NULL,NULL,'2MASX J15395282+1751309',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,234.970375,17.85858,0.069,NULL,59431080119,928610626,14509541,17.8),(131678,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131678,37.64,0.46,338,61410,70,NULL,NULL,'SDSS J153953.43+244603.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.972625,24.76769,0.141,NULL,59395694550,928057727,14500901,18.2),(131679,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131679,36.44,0.09,194,61411,70,NULL,NULL,'CGCG 136-048',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00009,NULL,'14.9V',0.5,NULL,'Group member',NULL,NULL,NULL,1,234.983375,21.86681,0.189,NULL,59452815290,928950238,14514847,14.9),(131680,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131680,35.86,0.25,149,61412,74.4,NULL,NULL,'CGCG 136-047 NED02',NULL,'2013AJ....146...86T',2013,1,0.55,NULL,'G',0.000077,NULL,'14.47',0.47,'E/S0',NULL,NULL,NULL,NULL,1,234.9865,21.82422,0.181,NULL,59452817301,928950270,14514847,14.47),(131681,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131681,36.04,0.27,161,61412,70,NULL,NULL,'CGCG 136-047 NED02',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131682,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131682,36.44,0.09,194,61412,70,NULL,NULL,'CGCG 136-047 NED02',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131683,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131683,33.31,0.46,46,61413,NULL,NULL,'J','NGC 5987',NULL,'2007A&A...465...71T',2007,1,4.2,NULL,'G',0.00002,NULL,'12.72',1.3,'Sb','in a radial-velocity based grouping',NULL,NULL,NULL,1,234.9890417,58.07953,0.025,NULL,57637823777,900590996,14071734,12.72),(131684,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131684,33.32,0.4,46.1,61413,NULL,NULL,'mean','NGC 5987',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131685,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131685,33.34,0.47,46.6,61413,NULL,NULL,'H','NGC 5987',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131686,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131686,33.42,0.45,48.3,61413,NULL,NULL,'K','NGC 5987',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131687,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131687,33.42,0.34,48.3,61413,NULL,NULL,'Malmquist cor.','NGC 5987',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131688,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131688,33.47,0.33,49.5,61413,NULL,NULL,NULL,'NGC 5987',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131689,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131689,33.48,0.2,49.7,61413,74.4,NULL,NULL,'NGC 5987',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131690,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131690,38.19,0.15,434,61414,70,NULL,NULL,'2MASX J15395770+3041087',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000143,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.990625,30.68569,0.073,NULL,59925872518,936341758,14630339,18),(131691,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131691,33.49,0.47,50,61415,NULL,NULL,'H','NGC 5975',NULL,'2007A&A...465...71T',2007,1,1,'HOLM 718B does not exist (it is probably a plate defect).','G',0.000007,NULL,'15.10',0.3,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,234.9915417,21.47081,0.173,NULL,59454697614,928979650,14515307,15.1),(131692,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131692,33.53,0.45,50.8,61415,NULL,NULL,'K','NGC 5975',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131693,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131693,33.58,0.46,52.1,61415,NULL,NULL,'J','NGC 5975',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131694,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131694,33.67,0.43,54.1,61415,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5975',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131695,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131695,33.84,0.43,58.6,61415,75,NULL,'3.6 micron, color corrected','NGC 5975',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131696,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131696,33.92,0.4,60.7,61415,NULL,NULL,'mean','NGC 5975',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131697,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131697,34.07,0.2,65.2,61415,74.4,NULL,NULL,'NGC 5975',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131698,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131698,37.97,0.14,393,61416,70,NULL,NULL,'2MASX J15395899+1758339',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,234.9957917,17.97594,0.069,NULL,59431130506,928611414,14509553,17.8),(131699,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131699,37.5,0.27,317,61417,70,NULL,NULL,'2MASX J15395954+3543207',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000176,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,234.998083,35.72233,0.049,NULL,59893342934,935833483,14622398,18.3),(131700,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131700,37.89,0.46,379,61418,70,NULL,NULL,'2MASX J15395981+3801471',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000139,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,234.999167,38.02975,0.041,NULL,59878203997,935596937,14618702,17.9),(131701,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131701,37.29,0.27,287,61419,70,NULL,NULL,'2MASX J15400006+4835409',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.000375,48.59481,0.037,NULL,59721908023,933154812,14580543,17.7),(131702,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131702,38.32,0.46,461,61420,70,NULL,NULL,'2MASX J15400341+1224432',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,235.014208333,12.41192,0.093,NULL,56522949401,883171084,13799548,17.7),(131703,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131703,32.89,0.2,37.8,61421,74.4,NULL,NULL,'UGC 09962',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000013,NULL,'15.70',0.1,'Im:','Group member',NULL,NULL,NULL,1,235.0142917,13.97603,0.109,NULL,59426531153,928539549,14508430,15.7),(131704,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131704,37.5,0.27,317,61422,70,NULL,NULL,'2MASX J15400398+3543507',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000178,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,235.0167083,35.73075,0.049,NULL,59893345607,935833525,14622398,16.5),(131705,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131705,36.44,0.27,194,61423,70,NULL,NULL,'2MASX J15400439+0607263',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,235.018333,6.12386,0.109,NULL,56413389603,881459212,13772800,16.2),(131706,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131706,36.28,0.33,181,61424,70,NULL,NULL,'2MASX J15400447+4606209',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000187,NULL,'15.5g',0.47,'E0',NULL,NULL,NULL,NULL,1,235.01875,46.10594,0.021,NULL,59687714240,932620535,14572195,15.5),(131707,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131707,36.09,0.4,165,61425,NULL,NULL,'mean','UGC 09960',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000033,NULL,'14.80',0.5,'Sa','Isolated galaxy',NULL,NULL,NULL,1,235.023875,1.93364,0.217,NULL,56389706415,881089162,13767018,14.8),(131708,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131708,36.37,0.47,188,61425,NULL,NULL,'H','UGC 09960',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131709,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131709,38.01,0.33,399,61426,70,NULL,NULL,'SDSS J154006.13+232544.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.025583,23.42917,0.157,NULL,59450653428,928916459,14514319,18.5),(131710,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131710,37.55,0.21,324,61427,70,NULL,NULL,'2MASX J15400662+0309503',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000067,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.027667,3.16386,0.169,NULL,56394655576,881166493,13768226,17.7),(131711,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131711,37.5,0.27,317,61428,70,NULL,NULL,'2MASX J15400677+3544447',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000176,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,235.028125,35.74583,0.049,NULL,59893346276,935833535,14622398,17.3),(131712,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131712,37.63,0.46,335,61429,70,NULL,NULL,'2MASX J15400722+0055153',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000084,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.0302083,0.921,0.249,NULL,56392380093,881130938,13767670,17.5),(131713,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131713,37.72,0.46,350,61430,70,NULL,NULL,'2MASXi J1540072+515428',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000188,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,235.030333,51.90764,0.049,NULL,59670698479,932354663,14568041,17.4),(131714,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131714,38.29,0.46,454,61431,70,NULL,NULL,'SDSS J154007.60+452906.6',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000158,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,235.0317083,45.48517,0.017,NULL,59688141130,932627205,14572300,18.4),(131715,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131715,37.08,0.46,260,61432,70,NULL,NULL,'SDSS J154008.23+091422.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.034333333,9.23958,0.077,NULL,56604305436,884442272,13819410,17.8),(131716,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131716,36.4,0.46,191,61433,70,NULL,NULL,'MCG +03-40-021',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000067,NULL,'15.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,235.037167,16.05361,0.101,NULL,59440579438,928759053,14511860,15.3),(131717,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131717,38.37,0.27,472,61434,70,NULL,NULL,'SDSS J154009.61+072026.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000137,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,235.040083333,7.34078,0.097,NULL,56594519113,884289361,13817021,18.8),(131718,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131718,37.02,0.46,254,61435,70,NULL,NULL,'2MASX J15401006+2032120',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000146,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.0419583,20.53658,0.137,NULL,59455010050,928984532,14515383,17.4),(131719,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131719,37.76,0.46,356,61436,70,NULL,NULL,'2MASX J15401121+2501167',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,235.0465417,25.02131,0.153,NULL,59869603991,935462562,14616602,17.8),(131720,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131720,37.32,0.46,291,61437,70,NULL,NULL,'2MASXi J1540118+361127',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.049125,36.19083,0.073,NULL,59879410945,935615796,14618996,17.8),(131721,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131721,36.46,0.33,196,61438,70,NULL,NULL,'2MASX J15401274+0722434',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000192,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,235.053125,7.37869,0.097,NULL,56594524691,884289448,13817022,16.2),(131722,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131722,36.88,0.46,238,61439,70,NULL,NULL,'2MASX J15401420+3431588',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000143,NULL,'15.9g',0.4,'E0',NULL,NULL,NULL,NULL,1,235.059083,34.53294,0.061,NULL,59893961408,935843147,14622549,15.9),(131723,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131723,37.15,0.46,269,61440,70,NULL,NULL,'2MASX J15401435+1841030',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.059916667,18.68414,0.065,NULL,59448942115,928889720,14513901,17.6),(131724,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131724,37.29,0.27,287,61441,70,NULL,NULL,'2MASX J15401437+4835299',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000172,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,235.059958333,48.59153,0.049,NULL,59721905660,933154775,14580543,16.4),(131725,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131725,37.11,0.46,264,61442,70,NULL,NULL,'2MASX J15401593+0812224',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',NULL,NULL,'16.77',0.32,NULL,NULL,NULL,NULL,NULL,1,235.066375,8.20628,0.073,NULL,56596218904,884315920,13817436,16.77),(131726,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131726,37.55,0.21,324,61443,70,NULL,NULL,'2MASX J15401623+0301573',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000091,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,235.0677083,3.03264,0.177,NULL,56402980551,881296571,13770258,17.7),(131727,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131727,38.19,0.15,434,61444,70,NULL,NULL,'2MASX J15401650+3042169',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.068833333,30.70472,0.073,NULL,59925862766,936341605,14630337,17.9),(131728,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131728,37.55,0.21,324,61445,70,NULL,NULL,'2MASX J15401676+0311243',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,235.0697917,3.19019,0.169,NULL,56394657149,881166517,13768226,17.3),(131729,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131729,37.38,0.33,299,61446,70,NULL,NULL,'2MASX J15401703+0243343',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00009,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,235.0710417,2.72631,0.173,NULL,56403102502,881298476,13770288,16.7),(131730,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131730,36.44,0.09,194,61447,70,NULL,NULL,'2MASX J15401716+2124291',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000067,NULL,'16.71',0.2,NULL,NULL,NULL,NULL,NULL,1,235.0715,21.40797,0.181,NULL,59455203199,928987549,14515430,16.71),(131731,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131731,35.85,0.25,148,61448,74.4,NULL,NULL,'GIN 440',NULL,'2013AJ....146...86T',2013,1,0.48,NULL,'G',0.00006,NULL,'15.18',0.44,'S',NULL,NULL,NULL,NULL,1,235.071875,21.91503,0.189,NULL,59452780334,928949692,14514838,15.18),(131732,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131732,36.04,0.27,161,61448,70,NULL,NULL,'GIN 440',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131733,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131733,37.97,0.14,393,61449,70,NULL,NULL,'2MASX J15401797+1753042',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000179,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,235.074958333,17.88453,0.069,NULL,59431183521,928612242,14509566,16.8),(131734,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131734,37.77,0.46,358,61450,70,NULL,NULL,'2MASXi J1540183+491847',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000151,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,235.07625,49.31289,0.053,NULL,59721372540,933146445,14580413,17.8),(131735,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131735,37.55,0.21,324,61451,70,NULL,NULL,'2MASX J15401830+0303423',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000083,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,235.0762917,3.06172,0.177,NULL,56394652956,881166452,13768225,17),(131736,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131736,37.38,0.46,299,61452,70,NULL,NULL,'2MASX J15401831+0423173',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,235.076333,4.38803,0.157,NULL,56395875899,881185560,13768524,17.4),(131737,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131737,36.56,0.46,205,61453,70,NULL,NULL,'SDSS J154018.95+161822.4',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.0789583,16.30625,0.105,NULL,59440098075,928751532,14511742,17.1),(131738,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131738,37.97,0.14,393,61454,70,NULL,NULL,'SDSS J154019.03+175123.3',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000188,NULL,'16.1g',0.36,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.079291667,17.85647,0.069,NULL,59431151780,928611746,14509558,16.1),(131739,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131739,37.6,0.46,331,61455,70,NULL,NULL,'2MASX J15401903+3134529',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000117,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.0795,31.58142,0.085,NULL,59925269015,936332328,14630192,17.4),(131740,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131740,36.08,0.77,165,61456,70,NULL,NULL,'2MASX J15402019-0658573',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.4,NULL,NULL,NULL,NULL,NULL,1,235.084125,-6.98253,0.449,NULL,45609841411,712653772,11135215,14.3),(131741,'IRAS','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131741,34.83,0.8,92.6,61457,75,NULL,'MAT, I','ESO 583- G 002',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'15.5',1,'SB(rs)bc;Sy1   HII',NULL,NULL,NULL,NULL,1,235.085417,-18.44261,0.445,NULL,46600880476,728138757,11377168,15.5),(131742,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131742,34.3,0.43,72.4,61457,75,NULL,'MAT, I, raw','ESO 583- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131743,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131743,34.31,0.32,72.7,61457,85,NULL,'I, raw','ESO 583- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131744,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131744,34.35,0.32,74.3,61457,85,NULL,'I, inv','ESO 583- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131745,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131745,34.51,0.43,79.9,61457,75,NULL,'MAT, I, inv','ESO 583- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131746,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131746,34.69,0.43,86.8,61457,75,NULL,'MAT, I, cor','ESO 583- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131747,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131747,34.88,0.25,94.7,61457,NULL,NULL,NULL,'ESO 583- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131748,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131748,34.92,0.2,96.4,61457,74.4,NULL,NULL,'ESO 583- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131749,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131749,35.03,0.4,101,61457,NULL,NULL,'mean','ESO 583- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131750,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131750,35.04,0.23,102,61457,NULL,NULL,'Malmquist cor.','ESO 583- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131751,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131751,35.21,0.47,110,61457,NULL,NULL,'H','ESO 583- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131752,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131752,37.35,0.46,296,61458,70,NULL,NULL,'2MASX J15402052+1411092',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.085583333,14.18592,0.089,NULL,59426716956,928542452,14508475,17.1),(131753,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131753,38.01,0.33,399,61459,70,NULL,NULL,'2MASX J15402073+2324191',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000157,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,235.086375,23.40522,0.157,NULL,59450651342,928916427,14514319,17.5),(131754,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131754,37.07,0.46,260,61460,70,NULL,NULL,'2MASX J15402088+1323292',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,235.0870417,13.39139,0.105,NULL,56526080719,883220011,13800312,17),(131755,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131755,37.57,0.46,327,61461,70,NULL,NULL,'2MASX J15402088+2314351',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000183,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,235.087125,23.24322,0.153,NULL,59453530633,928961416,14515022,17),(131756,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131756,36.5,0.7,200,61462,70,NULL,NULL,'2MASX J15402114-1508178',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.85',NULL,NULL,NULL,NULL,NULL,NULL,1,235.0880417,-15.13858,0.385,NULL,46593284358,728020068,11375313,15.85),(131757,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131757,37.97,0.14,393,61463,70,NULL,NULL,'2MASX J15402217+1754332',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,235.092375,17.90931,0.069,NULL,59431188051,928612313,14509567,17),(131758,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131758,36.05,0.65,162,61464,70,NULL,NULL,'2MASX J15402307-0511341',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.55',NULL,NULL,NULL,NULL,NULL,NULL,1,235.096375,-5.193,0.449,NULL,45407940201,709499065,11085922,16.55),(131759,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131759,36.19,0.46,173,61465,70,NULL,NULL,'2MASX J15402482-0154121',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.103333,-1.90347,0.353,NULL,45401966985,709405734,11084464,16.8),(131760,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131760,37.82,0.46,367,61466,70,NULL,NULL,'2MASX J15402487+0601170',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000188,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.103625,6.02147,0.109,NULL,56614731257,884605175,13821955,17.2),(131761,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131761,33.9,0.53,60.3,61467,NULL,NULL,NULL,'ESO 450- G 006',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000033,NULL,'16.10',0.5,'Sb:',NULL,NULL,NULL,NULL,1,235.108333,-29.1065,0.457,NULL,47173829543,737091086,11517048,16.1),(131762,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131762,33.94,0.2,61.4,61467,74.4,NULL,NULL,'ESO 450- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131763,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131763,34.1,0.49,66.1,61467,NULL,NULL,'Malmquist cor.','ESO 450- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131764,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131764,36.44,0.09,194,61468,70,NULL,NULL,'2MASX J15402733+2133510',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000063,NULL,'17.70',0.1,NULL,NULL,NULL,NULL,NULL,1,235.114,21.56422,0.173,NULL,59454663807,928979121,14515298,17.7),(131765,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131765,37.05,0.46,257,61469,70,NULL,NULL,'2MASX J15402750+4745017',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000183,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,235.11475,47.75053,0.037,NULL,59720257768,933129027,14580141,16.7),(131766,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131766,36.43,0.46,193,61470,70,NULL,NULL,'2MASX J15402752+1527582',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,235.114833,15.46622,0.073,NULL,59440436060,928756813,14511825,16.9),(131767,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131767,37.71,0.46,349,61471,70,NULL,NULL,'2MASX J15402809+2651418',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000189,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,235.117125,26.8615,0.121,NULL,59919517501,936242460,14628788,16.9),(131768,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131768,37.03,0.46,255,61472,70,NULL,NULL,'2MASX J15402841+5627220',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000101,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,235.118333,56.45619,0.017,NULL,57592027514,899875429,14060553,16.5),(131769,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131769,38.37,0.27,472,61473,70,NULL,NULL,'2MASX J15402887+0713544',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000184,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,235.1202083,7.23172,0.097,NULL,56594353906,884286779,13816980,16.9),(131770,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131770,36.88,0.46,238,61474,70,NULL,NULL,'2MASX J15402943+3328220',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000158,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.1225417,33.47286,0.073,NULL,59891370092,935802657,14621916,17.4),(131771,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131771,35.54,0.46,128,61475,70,NULL,NULL,'2MASX J15402996+2821568',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000077,NULL,'15.9g',0.34,NULL,NULL,NULL,NULL,NULL,1,235.125,28.36572,0.093,NULL,59917181730,936205964,14628218,15.9),(131772,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131772,37.97,0.14,393,61476,70,NULL,NULL,'2MASX J15403057+1750241',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,235.127375,17.84008,0.069,NULL,59431146930,928611670,14509557,17.7),(131773,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131773,38.05,0.27,407,61477,70,NULL,NULL,'2MASX J15403083+0331340',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000082,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,235.128291667,3.52622,0.165,NULL,56395509901,881179842,13768435,16.9),(131774,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131774,36.46,0.33,196,61478,70,NULL,NULL,'CGCG 050-066',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000212,NULL,'16.1g',0.32,'AGN',NULL,NULL,NULL,NULL,1,235.132416667,7.45797,0.085,NULL,56594419877,884287810,13816997,16.1),(131775,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131775,37.97,0.14,393,61479,70,NULL,NULL,'2MASX J15403212+1751426',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.133917,17.86192,0.069,NULL,59431147385,928611677,14509557,18.2),(131776,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131776,37.38,0.33,299,61480,70,NULL,NULL,'2MASX J15403214+0246240',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000083,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.1340417,2.77328,0.177,NULL,56403110939,881298608,13770290,17.4),(131777,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131777,38.19,0.15,434,61481,70,NULL,NULL,'2MASX J15403231+3044380',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'18.2g',0.1,NULL,NULL,NULL,NULL,NULL,1,235.1347917,30.74386,0.073,NULL,59925733611,936339587,14630306,18.2),(131778,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131778,38.17,0.46,431,61482,70,NULL,NULL,'2MASX J15403498+5758590',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.146,57.98325,0.029,NULL,57637861722,900591589,14071743,17.5),(131779,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131779,37.79,0.46,361,61483,70,NULL,NULL,'2MASX J15403629+2303357',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000172,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.151125,23.05989,0.157,NULL,59453510319,928961098,14515017,17.3),(131780,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131780,35.39,0.2,120,61484,74.4,NULL,NULL,'CGCG 136-052',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.00005,NULL,'15.34',0.3,'S?',NULL,NULL,NULL,NULL,1,235.155291667,20.56233,0.137,NULL,59455001810,928984403,14515381,15.34),(131781,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131781,37.37,0.46,298,61485,70,NULL,NULL,'2MASX J15403856-0000231',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000071,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.160666667,-0.0065,0.265,NULL,45399441684,709366276,11083848,18.3),(131782,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131782,36.44,0.09,194,61486,70,NULL,NULL,'2MASX J15403858+2156577',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00006,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.16075,21.94942,0.189,NULL,59453054565,928953977,14514905,17.3),(131783,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131783,36.44,0.09,194,61487,70,NULL,NULL,'2MASX J15403857+2118377',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.160833,21.31067,0.181,NULL,59455199876,928987498,14515429,17.5),(131784,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131784,36.65,0.46,213,61488,70,NULL,NULL,'CGCG 166-033',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00013,NULL,'15.6g',0.47,'E0',NULL,NULL,NULL,NULL,1,235.16975,32.00175,0.089,NULL,59925122815,936330043,14630156,15.6),(131785,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131785,38.12,0.46,420,61489,70,NULL,NULL,'SDSS J154041.03+284136.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.171,28.69361,0.069,NULL,59924576007,936321500,14630023,18.3),(131786,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131786,37.3,0.46,288,61490,70,NULL,NULL,'2MASX J15404205-0045501',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000071,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.175375,-0.76386,0.349,NULL,45403104768,709423512,11084742,17.8),(131787,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131787,34.48,0.33,78.6,61491,70,NULL,NULL,'CGCG 222-040',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000158,NULL,'15.2g',0.47,'S0',NULL,NULL,NULL,NULL,1,235.176667,43.75125,0.041,NULL,59691143873,932674123,14573033,15.2),(131788,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131788,38.82,0.33,579,61492,70,NULL,NULL,'SDSS J154043.40+535014.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.180833,53.83736,0.021,NULL,59668532191,932320815,14567512,18.1),(131789,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131789,37.37,0.33,298,61493,70,NULL,NULL,'2MASX J15404356+4435126',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000194,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,235.181667,44.58683,0.029,NULL,59690828140,932669189,14572956,16.3),(131790,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131790,36.95,0.46,246,61494,70,NULL,NULL,'SDSS J154044.23+242021.2',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.5g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.184333,24.33925,0.141,NULL,59396499096,928070298,14501098,17.5),(131791,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131791,38.2,0.46,437,61495,70,NULL,NULL,'2MASX J15404524+3023470',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,235.188375,30.39647,0.053,NULL,59927818489,936372163,14630815,17.5),(131792,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131792,37.65,0.46,338,61496,70,NULL,NULL,'2MASX J15404528-0129161',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.188625,-1.48778,0.353,NULL,45402361685,709411901,11084560,18.1),(131793,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131793,35.86,0.25,149,61497,74.4,NULL,NULL,'GIN 441',NULL,'2013AJ....146...86T',2013,1,0.37,NULL,'G',0.000063,NULL,'15.46',0.33,'E',NULL,NULL,NULL,NULL,1,235.19425,21.77253,0.181,NULL,59452766255,928949472,14514835,15.46),(131794,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131794,36.04,0.27,161,61497,70,NULL,NULL,'GIN 441',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131795,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131795,36.44,0.09,194,61497,70,NULL,NULL,'GIN 441',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131796,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131796,37.86,0.46,373,61498,70,NULL,NULL,'2MASXi J1540473+230622',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.197375,23.10611,0.157,NULL,59453481046,928960641,14515010,17.9),(131797,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131797,38.1,0.46,418,61499,70,NULL,NULL,'2MASX J15404754-0111001',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000087,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,235.198083,-1.18336,0.373,NULL,45403234175,709425533,11084773,18.2),(131798,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131798,37.43,0.23,306,61500,70,NULL,NULL,'2MASX J15404757+5556590',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000086,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,235.1982917,55.94967,0.009,NULL,57585645849,899775716,14058995,16.6),(131799,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131799,36.44,0.09,194,61501,70,NULL,NULL,'2MASX J15404887+2124567',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00009,NULL,'16.87',0.3,NULL,NULL,NULL,NULL,NULL,1,235.203875,21.41589,0.173,NULL,59455235524,928988055,14515438,16.87),(131800,'BL Lac Luminosity','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131800,42.79,NULL,2250,61502,NULL,NULL,NULL,'[HB89] 1538+149',0.605,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',NULL,NULL,'18.5g',NULL,'Opt.var.;FSRQ  BLLAC',NULL,NULL,NULL,'HP QSO',1,235.2062083,14.79608,0.109,NULL,59426817184,928544018,14508500,18.5),(131801,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131801,37.25,0.46,282,61503,70,NULL,NULL,'2MASX J15404953+0709197',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,235.206333333,7.15553,0.097,NULL,56594774141,884293345,13817083,17.6),(131802,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131802,38.05,0.27,407,61504,70,NULL,NULL,'2MASX J15404968+0335090',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000089,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.207041667,3.58581,0.161,NULL,56395476563,881179321,13768426,17.3),(131803,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131803,37.43,0.23,306,61505,70,NULL,NULL,'2MASX J15404970+5550080',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000097,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,235.207125,55.83553,0.009,NULL,57585695245,899776488,14059007,16.3),(131804,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131804,36.44,0.27,194,61506,70,NULL,NULL,'2MASX J15405020+0555250',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000184,NULL,'15.9g',0.34,'E0',NULL,NULL,NULL,NULL,1,235.2092083,5.92342,0.109,NULL,56614768080,884605751,13821964,15.9),(131805,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131805,36.29,0.46,181,61507,70,NULL,NULL,'2MASX J15405067+5501110',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000158,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,235.211,55.01961,0.041,NULL,57587584367,899806005,14059468,16.3),(131806,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131806,37.34,0.46,294,61508,70,NULL,NULL,'2MASX J15405089+5645590',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000069,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.2120417,56.76653,0.005,NULL,57589952107,899843001,14060046,18),(131807,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131807,38.37,0.27,472,61509,70,NULL,NULL,'2MASX J15405140+0713277',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,235.214083,7.22436,0.097,NULL,56594763191,884293174,13817080,18.1),(131808,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131808,37.07,0.73,260,61510,70,NULL,NULL,'2MASX J15405222-0700385',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,235.2175417,-7.01075,0.517,NULL,45609849345,712653896,11135217,14.5),(131809,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131809,37.43,0.23,306,61511,70,NULL,NULL,'2MASX J15405292+5555360',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000098,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,235.2207083,55.92669,0.009,NULL,57585644415,899775693,14058995,16.8),(131810,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131810,38.6,0.46,524,61512,70,NULL,NULL,'2MASX J15405392+0837007',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,235.22475,8.61667,0.077,NULL,56596656067,884322751,13817542,17.9),(131811,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131811,35.47,0.46,124,61513,70,NULL,NULL,'CGCG 050-068',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000113,NULL,'15.5',0.4,NULL,NULL,NULL,NULL,NULL,1,235.22575,5.14253,0.105,NULL,56393043978,881141312,13767833,15.5),(131812,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131812,37.93,0.46,385,61514,70,NULL,NULL,'2MASX J15405425+5301139',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000131,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,235.2260417,53.02039,0.049,NULL,59671671393,932369865,14568279,17.8),(131813,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131813,38.05,0.46,407,61515,70,NULL,NULL,'2MASX J15405545+0453040',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,235.231,4.88439,0.109,NULL,56392959756,881139996,13767812,18.5),(131814,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131814,36.74,0.46,223,61516,70,NULL,NULL,'2MASX J15405554+4448435',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000171,NULL,'16.1g',0.43,NULL,NULL,NULL,NULL,NULL,1,235.231333333,44.812,0.025,NULL,59690944595,932671009,14572984,16.1),(131815,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131815,36.44,0.27,194,61517,70,NULL,NULL,'2MASX J15405576+0556000',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'16.81',0.5,NULL,NULL,NULL,NULL,NULL,1,235.232333,5.93319,0.109,NULL,56614765323,884605708,13821964,16.81),(131816,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131816,36.92,0.46,242,61518,70,NULL,NULL,'2MASX J15405804+1200130',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.241625,12.00356,0.101,NULL,56593012401,884265818,13816653,17.2),(131817,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131817,37.66,0.46,340,61519,70,NULL,NULL,'2MASX J15405977+2613364',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000183,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,235.249,26.22694,0.165,NULL,59916044780,936188199,14627940,16.7),(131818,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131818,36.37,0.46,188,61520,70,NULL,NULL,'CGCG 194-016',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000117,NULL,'15.3g',0.56,'E0',NULL,NULL,NULL,NULL,1,235.2499583,32.66675,0.105,NULL,59890529173,935789518,14621711,15.3),(131819,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131819,36.45,0.46,195,61521,70,NULL,NULL,'2MASX J15410095+0417520',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000123,NULL,'15.5g',0.45,NULL,NULL,NULL,NULL,NULL,1,235.254125,4.29772,0.157,NULL,56394839492,881169367,13768271,15.5),(131820,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131820,37.19,0.33,274,61522,70,NULL,NULL,'2MASX J15410112+4734255',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000202,NULL,'16.0g',0.41,'E0',NULL,NULL,NULL,NULL,1,235.2547917,47.57378,0.033,NULL,59720352258,933130504,14580164,16),(131821,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131821,36.9,0.46,239,61523,70,NULL,NULL,'2MASX J15410256+0723347',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000184,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,235.260583,7.39308,0.085,NULL,56594439615,884288118,13817001,16.7),(131822,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131822,38.05,0.46,407,61524,70,NULL,NULL,'2MASX J15410290+2106327',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,235.2622917,21.10917,0.137,NULL,59455306160,928989158,14515455,18),(131823,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131823,37.73,0.46,352,61525,70,NULL,NULL,'2MASX J15410295+5251438',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.2625,52.86217,0.041,NULL,59671784373,932371630,14568306,17.3),(131824,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131824,38.38,0.46,473,61526,70,NULL,NULL,'2MASX J15410336+0434491',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,235.264125,4.58031,0.157,NULL,56392943853,881139747,13767808,17.5),(131825,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131825,37.52,0.46,319,61527,70,NULL,NULL,'2MASX J15410416+3406276',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000161,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,235.267291667,34.10775,0.057,NULL,59891134348,935798974,14621858,17.1),(131826,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131826,37,0.46,251,61528,70,NULL,NULL,'2MASXi J1541042+460649',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.267458333,46.11367,0.021,NULL,59687738949,932620921,14572201,17.2),(131827,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131827,36.97,0.46,248,61529,70,NULL,NULL,'2MASX J15410438-0116135',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,235.268375,-1.2705,0.377,NULL,45403238248,709425597,11084774,16.8),(131828,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131828,37.76,0.33,357,61530,70,NULL,NULL,'2MASX J15410449+3011206',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,235.268708333,30.18906,0.069,NULL,59927788469,936371694,14630807,17.4),(131829,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131829,34.94,0.51,97.1,61531,70,NULL,NULL,'2MASX J15410476-0509255',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000073,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,235.269917,-5.15711,0.481,NULL,45588533793,712320840,11130013,14.5),(131830,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131830,36.44,0.09,194,61532,70,NULL,NULL,'2MASX J15410775+2207337',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00025,NULL,'17.03',0.3,NULL,NULL,NULL,NULL,NULL,1,235.2824583,22.12611,0.181,NULL,59453201780,928956277,14514941,17.03),(131831,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131831,37.81,0.33,365,61533,70,NULL,NULL,'2MASX J15410866+2224067',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,235.286083,22.40189,0.165,NULL,59453165120,928955705,14514932,16.9),(131832,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131832,35.04,0.54,102,61534,70,NULL,NULL,'2MASX J15410898-0505075',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.42',NULL,NULL,NULL,NULL,NULL,NULL,1,235.287333,-5.08558,0.481,NULL,45588528540,712320758,11130011,16.42),(131833,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131833,37.81,0.33,365,61535,70,NULL,NULL,'2MASX J15410938+2220168',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.289041667,22.33814,0.165,NULL,59453177281,928955895,14514935,18.4),(131834,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131834,35.28,0.58,114,61536,70,NULL,NULL,'UGC 09968',NULL,'2014MNRAS.445.2677S',2014,1,1.04,NULL,'G',0.000123,NULL,'14.9g',0.75,'SAB(rs)b',NULL,NULL,NULL,NULL,1,235.291083333,-1.70619,0.353,NULL,45402042419,709406912,11084483,14.9),(131835,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131835,36.54,0.2,203,61536,74.4,NULL,NULL,'UGC 09968',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131836,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131836,37.54,0.46,322,61537,70,NULL,NULL,'2MASX J15410994+0637180',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,235.2912917,6.62164,0.065,NULL,56593979653,884280932,13816889,16.5),(131837,'IRAS','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131837,33.7,0.8,55.1,61538,75,NULL,'CF, r','IC 1133',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.00003,NULL,'14.80',0.4,'Scd:',NULL,NULL,NULL,NULL,1,235.2999583,15.57342,0.073,NULL,59439745761,928746027,14511656,14.8),(131838,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131838,32.93,0.38,38.6,61538,75,NULL,'CF, r, inv','IC 1133',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131839,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131839,32.95,0.38,39,61538,75,NULL,'CF, r, raw','IC 1133',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131840,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131840,33.29,0.38,45.5,61538,75,NULL,'CF, r, cor','IC 1133',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131841,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131841,33.56,0.2,51.5,61538,74.4,NULL,NULL,'IC 1133',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131842,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131842,36.61,0.46,210,61539,70,NULL,NULL,'2MASX J15411369+0019441',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000099,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,235.3070417,0.32883,0.269,NULL,56388949560,881077336,13766833,16.6),(131843,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131843,38.05,0.27,407,61540,70,NULL,NULL,'2MASX J15411560+0336321',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000084,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,235.314875,3.60894,0.161,NULL,56395469167,881179205,13768425,18.4),(131844,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131844,38.01,0.46,399,61541,70,NULL,NULL,'2MASX J15411653+0822060',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,235.318917,8.36836,0.081,NULL,56597808080,884340751,13817824,17.3),(131845,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131845,37.76,0.33,357,61542,70,NULL,NULL,'2MASX J15411668+3010396',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000179,NULL,'16.3g',0.43,NULL,NULL,NULL,NULL,NULL,1,235.3194583,30.17775,0.069,NULL,59927897262,936373394,14630834,16.3),(131846,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131846,38.23,0.33,442,61543,70,NULL,NULL,'2MASX J15411805+0104591',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000083,NULL,'18.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,235.325375,1.08294,0.245,NULL,56392174067,881127719,13767620,18.4),(131847,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131847,37.5,0.33,316,61544,70,NULL,NULL,'SDSS J154118.14+284957.4',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000142,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.325625,28.83261,0.069,NULL,59924787597,936324806,14630075,18),(131848,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131848,37.2,0.46,276,61545,70,NULL,NULL,'2MASX J15411866+0650011',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000192,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,235.327625,6.83369,0.057,NULL,56593840124,884278751,13816855,16.4),(131849,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131849,37.1,0.46,264,61546,70,NULL,NULL,'2MASX J15411875+2753012',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.328,27.88364,0.085,NULL,59917013718,936203339,14628177,17.6),(131850,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131850,38.23,0.33,442,61547,70,NULL,NULL,'2MASX J15411891+0106131',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000076,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.328875,1.10367,0.245,NULL,56392057124,881125892,13767592,17.5),(131851,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131851,38.38,0.46,475,61548,70,NULL,NULL,'SDSS J154119.55+035309.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000073,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.3315,3.88603,0.153,NULL,56394964059,881171313,13768301,18.2),(131852,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131852,38.82,0.33,579,61549,70,NULL,NULL,'2MASX J15411952+5347280',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,235.331583,53.79094,0.033,NULL,59668541324,932320958,14567514,18),(131853,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131853,38.12,0.46,421,61550,70,NULL,NULL,'SDSS J154120.58+001842.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000089,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,235.3357917,0.31181,0.269,NULL,56388956741,881077449,13766835,18.6),(131854,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131854,37.5,0.33,316,61551,70,NULL,NULL,'2MASX J15412074+2850532',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000148,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.336291667,28.84822,0.069,NULL,59924787299,936324801,14630075,17.3),(131855,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131855,38.53,0.33,509,61552,70,NULL,NULL,'2MASX J15412093+0450301',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,235.337125,4.84164,0.161,NULL,56615016201,884609628,13822025,18.4),(131856,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131856,37.58,0.33,329,61553,70,NULL,NULL,'2MASX J15412167+0722531',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000175,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.34025,7.38144,0.085,NULL,56594589466,884290460,13817038,17.4),(131857,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131857,33.61,1.01,52.8,61554,NULL,NULL,NULL,'IC 4570',NULL,'2009ApJS..182..474S',2009,1,0.81,NULL,'G',0.000033,NULL,'14.8g',0.77,'SABcd:','Group member',NULL,NULL,NULL,1,235.344125,28.22975,0.093,NULL,59917151002,936205484,14628210,14.8),(131858,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131858,34.04,0.83,64.1,61554,NULL,NULL,'Malmquist cor.','IC 4570',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131859,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131859,37.51,0.27,318,61555,70,NULL,NULL,'2MASX J15412271+0030521',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00009,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,235.3445417,0.51456,0.277,NULL,56388943327,881077239,13766831,17.1),(131860,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131860,37.69,0.46,346,61556,70,NULL,NULL,'2MASX J15412379+0541401',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,235.34925,5.69456,0.117,NULL,56614804104,884606314,13821973,17.8),(131861,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131861,37.13,0.46,266,61557,70,NULL,NULL,'2MASX J15412501+3735389',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.354417,37.59408,0.049,NULL,59881760834,935652513,14619570,17.3),(131862,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131862,38.53,0.33,509,61558,70,NULL,NULL,'2MASX J15412648+0443551',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000023,NULL,'16.9g',0.28,'S0;BrClG',NULL,NULL,NULL,NULL,1,235.360458333,4.732,0.161,NULL,56614988503,884609195,13822018,16.9),(131863,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131863,36.66,0.46,215,61559,70,NULL,NULL,'2MASX J15412663+0309281',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000072,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.360875,3.15783,0.165,NULL,56394733602,881167712,13768245,17.5),(131864,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131864,37.58,0.33,329,61560,70,NULL,NULL,'SDSS J154126.79+072129.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.8g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.361667,7.35808,0.085,NULL,56594593751,884290527,13817039,17.8),(131865,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131865,36.39,0.46,190,61561,70,NULL,NULL,'2MASX J15412704+2249398',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,235.362625,22.82761,0.161,NULL,59452641543,928947524,14514805,16.7),(131866,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131866,37.84,0.46,370,61562,70,NULL,NULL,'2MASX J15412733+3349437',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000179,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.3639583,33.82886,0.057,NULL,59891274196,935801159,14621893,17.1),(131867,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131867,36.59,0.46,208,61563,70,NULL,NULL,'SDSS J154127.85+462906.4',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000154,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,235.366083,46.48514,0.021,NULL,59688049393,932625771,14572277,18.4),(131868,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131868,38.99,0.46,628,61564,70,NULL,NULL,'SDSS J154127.93+030728.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000082,NULL,'18.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,235.366375,3.12447,0.169,NULL,56394560579,881165009,13768203,18.8),(131869,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131869,37.79,0.46,362,61565,70,NULL,NULL,'SDSS J154128.76+091230.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.369833333,9.20861,0.069,NULL,56604681788,884448152,13819502,17.9),(131870,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131870,37.11,0.46,264,61566,70,NULL,NULL,'2MASX J15412930+4439258',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00013,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.371916667,44.65722,0.029,NULL,59690973660,932671463,14572991,17.6),(131871,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131871,37.31,0.46,290,61567,70,NULL,NULL,'2MASX J15412927+1630206',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,235.372,16.50564,0.089,NULL,59431947733,928624183,14509752,16.6),(131872,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131872,38.88,0.46,597,61568,70,NULL,NULL,'2MASX J15412973+5801051',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000146,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,235.37375,58.01808,0.029,NULL,57637814001,900590843,14071731,18.2),(131873,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131873,33.34,0.47,46.5,61569,NULL,NULL,'H','NGC 5980',NULL,'2007A&A...465...71T',2007,1,1.9,'HOLM 720B is a star.','G',0.000017,NULL,'12.3B',0.7,'S','Possible field galaxy',NULL,NULL,NULL,1,235.376667,15.78767,0.061,NULL,59439670403,928744850,14511638,12.3),(131874,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131874,33.35,0.46,46.7,61569,NULL,NULL,'J','NGC 5980',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131875,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131875,33.37,0.45,47.3,61569,NULL,NULL,'K','NGC 5980',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131876,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131876,33.5,0.43,50.2,61569,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5980',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131877,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131877,33.69,0.4,54.7,61569,NULL,NULL,'mean','NGC 5980',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131878,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131878,38.86,0.46,591,61570,70,NULL,NULL,'2MASX J15413056+0527011',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,235.377375,5.45033,0.113,NULL,56615695351,884620239,13822191,18.4),(131879,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131879,37.35,0.46,295,61571,70,NULL,NULL,'2MASX J15413246+4253148',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,235.385125,42.8875,0.065,NULL,59679680749,932495011,14570234,17),(131880,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131880,37.33,0.46,293,61572,70,NULL,NULL,'2MASX J15413262+2744113',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.3860417,27.73644,0.089,NULL,59917474330,936210536,14628289,17.3),(131881,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131881,38,0.46,399,61573,70,NULL,NULL,'2MASX J15413368+2826473',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000204,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,235.390458333,28.44647,0.081,NULL,59917168150,936205752,14628214,16.7),(131882,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131882,36.55,0.46,204,61574,70,NULL,NULL,'2MASX J15413383+2146585',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00025,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.390917,21.78294,0.189,NULL,59452303151,928942236,14514722,17.2),(131883,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131883,39.23,0.46,701,61575,70,NULL,NULL,'2MASX J15413424+0517391',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,235.392625,5.29414,0.113,NULL,56615149295,884611707,13822057,17.8),(131884,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131884,36.65,0.46,214,61576,70,NULL,NULL,'2MASX J15413466+3407488',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000178,NULL,'15.8g',0.36,'Sa',NULL,NULL,NULL,NULL,1,235.394375,34.13019,0.057,NULL,59891267771,935801058,14621891,15.8),(131885,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131885,37.29,0.46,287,61577,70,NULL,NULL,'2MASX J15413663+1349571',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.4024583,13.83253,0.097,NULL,56524908124,883201689,13800026,17.1),(131886,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131886,35.84,0.2,147,61578,74.4,NULL,NULL,'CGCG 136-055',NULL,'2013AJ....146...86T',2013,1,0.74,NULL,'G',0.000073,NULL,'15.8g',0.24,'Sb',NULL,NULL,NULL,NULL,1,235.4072917,25.1115,0.153,NULL,59870467649,935476057,14616813,15.8),(131887,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131887,38.66,0.46,540,61579,70,NULL,NULL,'2MASX J15413826-0006029',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000089,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.409458333,-0.10094,0.265,NULL,45399601626,709368775,11083887,18.3),(131888,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131888,37.43,0.23,306,61580,70,NULL,NULL,'2MASX J15413925+5556251',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000087,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,235.413667,55.94042,0.009,NULL,57585523071,899773797,14058965,17.5),(131889,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131889,37.51,0.27,318,61581,70,NULL,NULL,'2MASX J15413945+0033261',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000072,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,235.414375,0.55719,0.277,NULL,56388932434,881077069,13766829,17.8),(131890,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131890,36.2,0.46,173,61582,70,NULL,NULL,'2MASX J15413977+4547447',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000192,NULL,'15.6g',0.44,'E0',NULL,NULL,NULL,NULL,1,235.4154583,45.79567,0.017,NULL,59687785701,932621651,14572213,15.6),(131891,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131891,37.51,0.27,318,61583,70,NULL,NULL,'2MASX J15414018+0029261',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000104,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,235.4175417,0.49047,0.277,NULL,56388918371,881076849,13766825,17.2),(131892,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131892,37.69,0.23,345,61584,70,NULL,NULL,'SDSS J154140.67+251708.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00018,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.419458333,25.28581,0.153,NULL,59870457135,935475892,14616810,18.1),(131893,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131893,37.41,0.33,304,61585,70,NULL,NULL,'2MASX J15414165+0230431',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000073,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,235.423583,2.51192,0.233,NULL,56389505452,881086022,13766969,18.3),(131894,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131894,37.47,0.46,312,61586,70,NULL,NULL,'2MASX J15414165+0301031',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000109,NULL,'16.3g',0.34,'AGN',NULL,NULL,NULL,NULL,1,235.423667,3.01742,0.169,NULL,56402931039,881295797,13770246,16.3),(131895,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131895,37.41,0.46,304,61587,70,NULL,NULL,'2MASX J15414294+4228445',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'17.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,235.4287917,42.47906,0.065,NULL,59679014698,932484604,14570071,17.1),(131896,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131896,37.19,0.33,274,61588,70,NULL,NULL,'2MASX J15414319+4736385',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000175,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,235.430083,47.61061,0.033,NULL,59720578882,933134045,14580219,16.9),(131897,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131897,36.85,0.2,234,61589,74.4,NULL,NULL,'CGCG 136-056',NULL,'2013AJ....146...86T',2013,1,0.66,NULL,'G',0.000093,NULL,'15.6g',0.43,'Irr',NULL,NULL,NULL,NULL,1,235.4307083,23.20369,0.161,NULL,59397113265,928079894,14501248,15.6),(131898,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131898,37.59,0.46,329,61590,70,NULL,NULL,'2MASX J15414378+0829170',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.17,'AGN',NULL,NULL,NULL,NULL,1,235.4325,8.48817,0.073,NULL,56596966112,884327595,13817618,17.4),(131899,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131899,35.74,NULL,141,61591,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG +08-29-002',NULL,'2010Ap&SS.325..163P',2010,1,0.99,NULL,'G',0.000082,NULL,'16.4g',0.17,'Scd',NULL,NULL,NULL,NULL,1,235.4355,45.58081,0.013,NULL,59687631030,932619234,14572175,16.4),(131900,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131900,35.76,NULL,142,61591,NULL,NULL,'Dipole + Quadrupole','MCG +08-29-002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131901,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131901,35.78,NULL,143,61591,NULL,NULL,NULL,'MCG +08-29-002',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131902,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131902,35.79,NULL,144,61591,NULL,NULL,'Dipole','MCG +08-29-002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131903,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131903,36.88,0.46,237,61592,70,NULL,NULL,'2MASX J15414479-0012039',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000086,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,235.436541667,-0.201,0.301,NULL,45399577802,709368403,11083881,17),(131904,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131904,37.73,0.46,352,61593,70,NULL,NULL,'2MASX J15414549+2213016',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,235.439625,22.21708,0.173,NULL,59453149953,928955468,14514929,17.5),(131905,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131905,37.37,0.46,297,61594,70,NULL,NULL,'2MASX J15414583+2957578',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,235.440875,29.96617,0.077,NULL,59927865842,936372903,14630826,17.4),(131906,'TRGB','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131906,30.26,0.1,11.3,61595,74.4,NULL,NULL,'UGC 09992',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.000017,NULL,'15.2',1,'Im','Isolated galaxy',NULL,NULL,NULL,1,235.449375,67.25425,0.081,NULL,57956633457,905572397,14149568,15.2),(131907,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131907,29.32,NULL,7.31,61595,NULL,NULL,NULL,'UGC 09992',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131908,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131908,30.24,0.4,11.2,61595,75,NULL,'B','UGC 09992',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131909,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131909,36.29,0.46,181,61596,70,NULL,NULL,'2MASX J15414818+5511341',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000164,NULL,'16.2g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,235.450875,55.19292,0.029,NULL,57587469577,899804212,14059440,16.2),(131910,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131910,37.94,0.33,387,61597,70,NULL,NULL,'2MASX J15414834+0126416',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.451291667,1.44492,0.237,NULL,56392003740,881125058,13767579,17.8),(131911,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131911,37.69,0.23,345,61598,70,NULL,NULL,'2MASX J15415135+2519596',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,'PRED','16.71',0.37,NULL,NULL,NULL,NULL,NULL,1,235.464125,25.33317,0.153,NULL,59870453811,935475840,14616810,16.71),(131912,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131912,37.48,0.46,313,61599,70,NULL,NULL,'2MASX J15415167+1551371',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,235.46525,15.8605,0.061,NULL,59439649666,928744526,14511633,17.3),(131913,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131913,37.53,0.46,321,61600,70,NULL,NULL,'2MASX J15415201+4728166',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000136,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.466667,47.47142,0.037,NULL,59720447145,933131986,14580187,17.4),(131914,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131914,37.64,0.46,337,61601,70,NULL,NULL,'2MASX J15415227+2005436',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000182,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,235.467875,20.0955,0.157,NULL,59447239336,928863114,14513486,17.1),(131915,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131915,36.2,0.46,174,61602,70,NULL,NULL,'2MASX J15415258+4831191',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000169,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,235.469167,48.52194,0.045,NULL,59719836712,933122448,14580038,16.7),(131916,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131916,37.69,0.23,345,61603,70,NULL,NULL,'2MASX J15415290+2520087',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000215,NULL,'16.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,235.470375,25.33569,0.153,NULL,59870453772,935475840,14616810,16.1),(131917,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131917,36.44,0.09,194,61604,70,NULL,NULL,'2MASX J15415299+2157036',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,235.471,21.95106,0.153,NULL,59453039699,928953745,14514902,16.6),(131918,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131918,35.49,0.47,126,61605,NULL,NULL,'H','IC 4572',NULL,'2007A&A...465...71T',2007,1,1.12,NULL,'G',0.00014,NULL,'14.4g',0.71,NULL,NULL,NULL,NULL,NULL,1,235.475791667,28.134,0.081,NULL,59917029098,936203579,14628180,14.4),(131919,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131919,35.69,0.46,137,61605,NULL,NULL,'J','IC 4572',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131920,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131920,35.76,0.45,142,61605,NULL,NULL,'K','IC 4572',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131921,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131921,35.81,0.4,145,61605,NULL,NULL,'mean','IC 4572',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131922,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131922,37.41,0.33,304,61606,70,NULL,NULL,'2MASX J15415479+0227076',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000097,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,235.4782917,2.45203,0.233,NULL,56389481350,881085646,13766963,16.7),(131923,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131923,37.94,0.33,387,61607,70,NULL,NULL,'2MASX J15415514+0125176',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,235.479875,1.4215,0.237,NULL,56392002621,881125040,13767578,16.3),(131924,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131924,38.59,0.46,521,61608,70,NULL,NULL,'2MASX J15415556+0439196',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.481583333,4.65533,0.161,NULL,56618398558,884662477,13822851,17.5),(131925,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131925,37.01,0.46,253,61609,70,NULL,NULL,'2MASX J15415605+3134399',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,235.4835417,31.57769,0.077,NULL,59925260530,936332195,14630190,17.2),(131926,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131926,32.16,NULL,27,61610,72,NULL,NULL,'SDSS J154157.11+043444.9',NULL,'2014Ap.....57..457K',2014,1,0.28,NULL,'G',0.000088,NULL,'17.8g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.488,4.57917,0.157,NULL,56618390249,884662347,13822849,17.8),(131927,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131927,36.03,0.46,161,61611,70,NULL,NULL,'2MASX J15415827+0746360',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000073,NULL,'15.4g',0.47,NULL,NULL,NULL,NULL,NULL,1,235.492833,7.77664,0.069,NULL,56597688699,884338885,13817795,15.4),(131928,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131928,37.15,0.46,269,61612,70,NULL,NULL,'2MASX J15415872+4716316',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000164,NULL,'17.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,235.494708333,47.27533,0.045,NULL,59720455064,933132110,14580189,17.1),(131929,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131929,37.29,0.46,287,61613,70,NULL,NULL,'SDSS J154158.74+062407.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,235.49475,6.40214,0.077,NULL,56623360694,884740010,13824062,18.3),(131930,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131930,35.41,0.2,121,61614,74.4,NULL,NULL,'IC 4574',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00005,NULL,'15.9g',0.36,'S0',NULL,NULL,NULL,NULL,1,235.496833,28.24033,0.093,NULL,59917141167,936205330,14628208,15.9),(131931,'IRAS','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131931,32.34,0.8,29.4,61615,75,NULL,'A82, H','UGC 09977',NULL,'1997ApJS..109..333W',1997,1,4.26,NULL,'G',0.00001,NULL,'13.90',0.4,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,235.498083,0.71281,0.293,NULL,56389020215,881078440,13766850,13.9),(131932,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131932,31.47,0.4,19.7,61615,75,NULL,NULL,'UGC 09977',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131933,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131933,32.01,NULL,25.3,61615,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09977',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131934,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131934,32.02,NULL,25.3,61615,NULL,NULL,'Dipole','UGC 09977',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131935,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131935,32.02,NULL,25.3,61615,NULL,NULL,'Dipole + Quadrupole','UGC 09977',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131936,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131936,32.06,NULL,25.9,61615,NULL,NULL,NULL,'UGC 09977',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131937,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131937,32.1,0.49,26.3,61615,75,NULL,'IR','UGC 09977',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131938,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131938,32.13,0.4,26.7,61615,NULL,NULL,'Virgo cluster at 15.6 Mpc','UGC 09977',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131939,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131939,32.15,0.2,26.9,61615,74.4,NULL,NULL,'UGC 09977',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131940,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131940,32.21,0.43,27.7,61615,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09977',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131941,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131941,32.22,0.43,27.8,61615,75,NULL,'3.6 micron, color corrected','UGC 09977',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131942,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131942,32.31,0.51,28.9,61615,NULL,NULL,NULL,'UGC 09977',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131943,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131943,32.3,NULL,28.9,61615,72,NULL,NULL,'UGC 09977',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131944,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131944,32.31,0.5,29,61615,NULL,NULL,'Malmquist cor.','UGC 09977',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131945,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131945,32.4,0.4,30.2,61615,75,NULL,'B','UGC 09977',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131946,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131946,32.48,0.36,31.3,61615,NULL,NULL,NULL,'UGC 09977',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131947,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131947,32.55,0.47,32.3,61615,75,NULL,'A82, H, raw','UGC 09977',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131948,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131948,32.55,0.47,32.3,61615,75,NULL,'A82, H, inv','UGC 09977',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131949,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131949,32.68,0.47,34.3,61615,75,NULL,'A82, H, cor','UGC 09977',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131950,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131950,38.08,0.46,412,61616,70,NULL,NULL,'2MASX J15420148+3552119',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000199,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,235.5062083,35.86997,0.053,NULL,59893141656,935830338,14622349,16.9),(131951,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131951,37.92,0.46,384,61617,70,NULL,NULL,'2MASX J15420396+3621145',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000172,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,235.516625,36.35397,0.061,NULL,59879222679,935612854,14618950,17.3),(131952,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131952,36.27,0.46,179,61618,70,NULL,NULL,'2MASX J15420402+2817477',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000152,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,235.5167083,28.29678,0.093,NULL,59917117315,936204958,14628202,16.9),(131953,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131953,36.82,0.46,231,61619,70,NULL,NULL,'2MASX J15420598+4755222',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000158,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.525167,47.92297,0.041,NULL,59720370087,933130782,14580168,17.1),(131954,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131954,37.29,0.27,287,61620,70,NULL,NULL,'2MASX J15420626+4835142',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000181,NULL,'16.1g',0.39,'E0',NULL,NULL,NULL,NULL,1,235.526167,48.58731,0.049,NULL,59719836044,933122438,14580038,16.1),(131955,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131955,37.27,0.46,284,61621,70,NULL,NULL,'2MASX J15420676+3714565',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000178,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,235.528125,37.24897,0.021,NULL,59881937813,935655278,14619613,17),(131956,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131956,37.94,0.46,388,61622,70,NULL,NULL,'2MASX J15420754+1312436',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.5315,13.21219,0.089,NULL,56526634847,883228669,13800447,17.6),(131957,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131957,39,0.46,632,61623,70,NULL,NULL,'2MASX J15420884+0640397',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,235.536875,6.67769,0.057,NULL,56623240329,884738130,13824033,18),(131958,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131958,36.37,0.46,188,61624,70,NULL,NULL,'2MASX J15420887+0413356',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.537083,4.22642,0.157,NULL,56616524517,884633195,13822393,16.8),(131959,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131959,36.79,0.46,228,61625,70,NULL,NULL,'2MASX J15420922+1200206',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,235.538375,12.00569,0.097,NULL,56592157037,884252453,13816444,17.3),(131960,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131960,37.36,0.33,296,61626,70,NULL,NULL,'2MASX J15420960+3348570',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.540083333,33.81592,0.041,NULL,59891299947,935801561,14621899,17.1),(131961,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131961,36.29,0.46,181,61627,70,NULL,NULL,'2MASX J15420984+3046150',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,235.541125,30.77081,0.093,NULL,59925851995,936341437,14630334,NULL),(131962,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131962,36.44,0.09,194,61628,70,NULL,NULL,'2MASX J15420998+2157565',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000143,NULL,'15.9',0.35,NULL,NULL,NULL,NULL,NULL,1,235.541625,21.96567,0.153,NULL,59452327343,928942614,14514728,15.9),(131963,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131963,38.74,0.46,559,61629,70,NULL,NULL,'2MASX J15421020+3926117',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000154,NULL,'18.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,235.5425417,39.4365,0.033,NULL,60096245650,939003838,14671934,18.8),(131964,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131964,37.69,0.23,345,61630,70,NULL,NULL,'SDSS J154210.31+252624.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.5g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.543,25.44014,0.153,NULL,59870536956,935477139,14616830,18.5),(131965,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131965,36.76,0.46,225,61631,70,NULL,NULL,'2MASX J15421198+2613277',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.549875,26.22444,0.157,NULL,59870260706,935472823,14616762,17.6),(131966,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131966,37.36,0.33,296,61632,70,NULL,NULL,'2MASX J15421241+3349220',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000142,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,235.551625,33.82275,0.041,NULL,59891300010,935801562,14621899,18.1),(131967,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131967,36.83,0.46,232,61633,70,NULL,NULL,'SDSS J154212.77+560446.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000063,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,235.55325,56.07947,0.005,NULL,57584825119,899762892,14058795,17.8),(131968,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131968,36.13,0.46,168,61634,70,NULL,NULL,'CGCG 250-004',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000192,NULL,'15.2g',0.59,'E0',NULL,NULL,NULL,NULL,1,235.5747917,48.21567,0.053,NULL,59720064319,933126004,14580093,15.2),(131969,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131969,37.64,0.33,337,61635,70,NULL,NULL,'2MASX J15421917+1103088',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,'PHOT','16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.579833,11.05236,0.105,NULL,56592217315,884253395,13816459,16.9),(131970,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131970,31.75,NULL,22.4,61636,72,NULL,NULL,'UGC 09979',NULL,'2014Ap.....57..457K',2014,1,1.4,NULL,'G',0.00001,NULL,'14.6B',0.7,'Irr(sa)        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,235.5817917,0.47378,0.277,NULL,56389252621,881082072,13766907,14.6),(131971,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131971,32.45,0.4,31,61636,75,NULL,'B','UGC 09979',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131972,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131972,35.94,0.2,154,61637,74.4,NULL,NULL,'IC 4575',NULL,'2013AJ....146...86T',2013,1,0.86,NULL,'G',0.00007,NULL,'15.3g',0.47,'Sb','Group member',NULL,NULL,NULL,1,235.581875,23.80764,0.153,NULL,59395909377,928061084,14500954,15.3),(131973,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131973,36.63,0.46,212,61638,70,NULL,NULL,'2MASX J15421978+3247370',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000161,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,235.5822917,32.7935,0.089,NULL,59888403229,935756300,14621192,16.8),(131974,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131974,38.5,0.46,502,61639,70,NULL,NULL,'SDSS J154220.75+525942.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000141,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,235.5865,52.99522,0.009,NULL,59671689916,932370154,14568283,18.7),(131975,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131975,37.64,0.33,337,61640,70,NULL,NULL,'2MASX J15422209+1103418',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,'PHOT','16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,235.592,11.06144,0.105,NULL,56592213052,884253328,13816458,16.6),(131976,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131976,37.33,0.46,292,61641,70,NULL,NULL,'2MASX J15422207+4200185',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.592,42.00497,0.069,NULL,59680000927,932500014,14570312,17.4),(131977,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131977,36,0.46,159,61642,70,NULL,NULL,'2MASX J15422357-0116301',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00015,NULL,'16.1g',0.33,'E0',NULL,NULL,NULL,NULL,1,235.598333,-1.27497,0.317,NULL,45402794473,709418663,11084666,16.1),(131978,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131978,36.28,0.6,181,61642,70,NULL,NULL,'2MASX J15422357-0116301',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131979,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131979,36.9,0.46,240,61643,70,NULL,NULL,'2MASX J15422381+3238479',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.5992917,32.64678,0.081,NULL,59888413401,935756459,14621194,17.9),(131980,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131980,37.05,0.46,257,61644,70,NULL,NULL,'2MASX J15422414+1837465',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000171,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,235.6007083,18.62953,0.065,NULL,59448451815,928882059,14513782,16.4),(131981,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131981,34.6,NULL,83.2,61645,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09988',NULL,'2010Ap&SS.325..163P',2010,1,1.18,NULL,'G',0.000202,NULL,'16.4g',0.19,'Scd',NULL,NULL,NULL,NULL,1,235.600833,41.62347,0.077,NULL,59677122045,932455031,14569609,16.4),(131982,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131982,34.62,NULL,83.8,61645,NULL,NULL,'Dipole + Quadrupole','UGC 09988',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131983,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131983,34.63,NULL,84.3,61645,NULL,NULL,'Dipole','UGC 09988',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131984,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131984,34.67,NULL,86.1,61645,NULL,NULL,NULL,'UGC 09988',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131985,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131985,34.73,0.49,88.3,61645,75,NULL,'IR','UGC 09988',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131986,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131986,37.49,0.46,314,61646,70,NULL,NULL,'2MASX J15422451+2339205',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,235.602083,23.65561,0.153,NULL,59395817913,928059654,14500932,17.3),(131987,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131987,38.53,0.46,508,61647,70,NULL,NULL,'2MASX J15422529+3229169',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,235.6055,32.48819,0.077,NULL,59888428047,935756688,14621198,18.1),(131988,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131988,37.86,0.46,373,61648,70,NULL,NULL,'2MASX J15422540+1357236',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,235.6059583,13.95667,0.089,NULL,56524891933,883201436,13800022,16.4),(131989,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131989,37.8,0.46,363,61649,70,NULL,NULL,'2MASX J15422548+4117069',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000155,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,235.606083333,41.28519,0.065,NULL,59677325227,932458206,14569659,16.9),(131990,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131990,38.67,0.46,542,61650,70,NULL,NULL,'2MASX J15422607+2115155',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.608625,21.25425,0.149,NULL,59454459396,928975928,14515248,17.6),(131991,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131991,38.12,0.46,420,61651,70,NULL,NULL,'2MASX J15422665-0139101',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000142,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.6112083,-1.65289,0.349,NULL,45401749865,709402341,11084411,18.5),(131992,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131992,36.44,0.09,194,61652,70,NULL,NULL,'2MASX J15422665+2146205',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'16.87',0.37,NULL,NULL,NULL,NULL,NULL,1,235.61125,21.77247,0.157,NULL,59452355662,928943057,14514735,16.87),(131993,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131993,37.24,0.33,281,61653,70,NULL,NULL,'2MASX J15422832+5259501',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00021,NULL,'16.0g',0.48,'AGN',NULL,NULL,NULL,NULL,1,235.618167,52.99744,0.009,NULL,59671690061,932370157,14568283,16),(131994,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131994,37.96,0.46,391,61654,70,NULL,NULL,'SDSS J154228.43+281136.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,235.6185,28.19358,0.093,NULL,59917618652,936212791,14628324,18.7),(131995,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131995,37.46,0.46,310,61655,70,NULL,NULL,'2MASX J15422850+3915529',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000136,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.618833,39.26467,0.037,NULL,60096141250,939002207,14671909,17.4),(131996,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131996,38.26,0.46,449,61656,70,NULL,NULL,'2MASX J15422895+5313561',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,235.620625,53.23228,0.009,NULL,59668830205,932325471,14567585,18),(131997,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131997,35.93,0.2,153,61657,74.4,NULL,NULL,'CGCG 078-050',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000535,NULL,'15.7',0.2,NULL,NULL,NULL,NULL,NULL,1,235.6212917,12.29683,0.105,NULL,56524245235,883191331,13799864,15.7),(131998,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131998,37.54,0.46,322,61658,70,NULL,NULL,'SDSS J154232.29+054557.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.3g',0.09,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.634583333,5.76603,0.113,NULL,56615589522,884618586,13822165,18.3),(131999,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131999,37.16,0.46,270,61659,70,NULL,NULL,'2MASX J15423306+3829349',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000181,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,235.637917,38.49292,0.033,NULL,59878324983,935598827,14618731,16.2),(132000,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132000,36.13,0.46,169,61660,70,NULL,NULL,'2MASX J15423423+4611236',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000183,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,235.642458333,46.19006,0.021,NULL,59687930610,932623915,14572248,16.5),(132001,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132001,37.24,0.33,281,61661,70,NULL,NULL,'2MASX J15423438+5300199',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,235.643375,53.00556,0.009,NULL,59671676143,932369939,14568280,17.3),(132002,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132002,35.57,0.46,130,61662,70,NULL,NULL,'2MASX J15423494+1000369',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',NULL,NULL,'16.18',0.38,NULL,NULL,NULL,NULL,NULL,1,235.6455417,10.01039,0.093,NULL,56604897899,884451529,13819555,16.18),(132003,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132003,34.74,0.27,88.6,61663,70,NULL,NULL,'IC 4576',NULL,'2015arXiv151105856S',2015,1,1.11,NULL,'G',0.000063,NULL,'14.4g',0.72,'S?','Pair member, S + S',NULL,NULL,NULL,1,235.647917,23.67006,0.153,NULL,59395899634,928060931,14500952,14.4),(132004,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132004,33.45,0.47,48.9,61664,70,NULL,NULL,'ESO 329- G 015',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.00015,NULL,'13.5R',0.3,'SBab? sp',NULL,NULL,NULL,NULL,1,235.6537917,-38.70089,0.657,NULL,47144837669,736638088,11509970,13.5),(132005,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132005,37.53,0.27,321,61665,70,NULL,NULL,'2MASX J15423950+0646439',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.66475,6.77897,0.057,NULL,56623970807,884749543,13824211,17.3),(132006,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132006,38.61,0.46,527,61666,70,NULL,NULL,'2MASX J15424052+2523037',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.668666667,25.3845,0.153,NULL,59870496001,935476500,14616820,17.7),(132007,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132007,38.32,0.12,461,61667,70,NULL,NULL,'SDSS J154241.97+054210.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000159,NULL,'19.0g',0.09,NULL,NULL,NULL,NULL,NULL,1,235.674916667,5.70294,0.113,NULL,56615736309,884620879,13822201,19),(132008,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132008,37.68,0.46,343,61668,70,NULL,NULL,'2MASX J15424213+3031251',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.675625,30.52353,0.089,NULL,59925628279,936337941,14630280,17.3),(132009,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132009,37.95,0.46,389,61669,70,NULL,NULL,'2MASX J15424255+1456551',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,235.6772917,14.94867,0.073,NULL,59426167323,928533864,14508341,18),(132010,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132010,36.89,0.46,238,61670,70,NULL,NULL,'SDSS J154244.99+570234.2',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000082,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,235.6875,57.04283,0,NULL,57635186856,900549794,14071090,16.5),(132011,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132011,34.74,0.27,88.6,61671,70,NULL,NULL,'IC 4577',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000063,NULL,'14.9g',0.64,'S?','Pair member, S + S',NULL,NULL,NULL,1,235.689833333,23.79264,0.157,NULL,59395914046,928061156,14500955,14.9),(132012,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132012,36.33,0.21,184,61672,70,NULL,NULL,'NGC 5983',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.000107,NULL,'14.6g',0.82,'E',NULL,NULL,NULL,NULL,1,235.690125,8.24111,0.097,NULL,56597881115,884341892,13817842,14.6),(132013,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132013,34.77,0.46,89.8,61673,70,NULL,NULL,'CGCG 136-062',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.00017,NULL,'15.1',0.4,NULL,NULL,NULL,NULL,NULL,1,235.691167,24.98608,0.153,NULL,59869950864,935467982,14616687,15.1),(132014,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132014,38.32,0.12,461,61674,70,NULL,NULL,'2MASX J15424636+0545470',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.693167,5.76314,0.113,NULL,56615608835,884618888,13822170,17.2),(132015,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132015,37.42,0.33,305,61675,70,NULL,NULL,'SDSS J154247.34+331209.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.6972917,33.20269,0.061,NULL,59890591860,935790497,14621726,18),(132016,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132016,38.17,0.46,430,61676,70,NULL,NULL,'2MASX J15424961+3214081',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.70675,32.23569,0.081,NULL,59920917697,936264339,14629130,17.5),(132017,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132017,37.71,0.46,348,61677,70,NULL,NULL,'2MASX J15425022+4025282',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,235.70925,40.42444,0.041,NULL,59961901000,936904703,14639135,17),(132018,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132018,38.02,0.33,401,61678,70,NULL,NULL,'2MASX J15425076+0001570',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000075,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.711625,0.03258,0.293,NULL,56388358618,881068103,13766689,17.9),(132019,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132019,34.74,0.27,88.6,61679,70,NULL,NULL,'IC 4579',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000067,NULL,'15.2g',0.52,NULL,'Group member',NULL,NULL,NULL,1,235.714625,23.77317,0.153,NULL,59395905719,928061026,14500953,15.2),(132020,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132020,38.02,0.33,401,61680,70,NULL,NULL,'SDSS J154251.79+000135.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00008,NULL,'18.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.7157917,0.02661,0.293,NULL,56388358540,881068102,13766689,18),(132021,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132021,37.53,0.27,321,61681,70,NULL,NULL,'2MASX J15425306+0642129',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000197,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.721125,6.70364,0.057,NULL,56624014820,884750231,13824222,17),(132022,'IRAS','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132022,31.5,0.8,19.9,61682,75,NULL,'A82, H','NGC 5984',NULL,'1997ApJS..109..333W',1997,1,2.9,NULL,'G',0.000017,NULL,'13.08',0.8,'SB(rs)d:','Possible field galaxy',NULL,NULL,NULL,1,235.721541667,14.23147,0.073,NULL,56525545806,883211653,13800182,13.08),(132023,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132023,30.73,0.4,14,61682,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5984',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132024,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132024,31.03,0.47,16.1,61682,75,NULL,'A82, H, inv','NGC 5984',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132025,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132025,31.11,0.47,16.7,61682,75,NULL,'A82, H, raw','NGC 5984',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132026,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132026,31.27,0.4,18,61682,NULL,NULL,'mean','NGC 5984',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132027,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132027,31.37,0.43,18.8,61682,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5984',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132028,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132028,31.39,0.43,19,61682,75,NULL,'3.6 micron, color corrected','NGC 5984',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132029,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132029,31.45,0.2,19.5,61682,74.4,NULL,NULL,'NGC 5984',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132030,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132030,31.5,0.36,20,61682,NULL,NULL,NULL,'NGC 5984',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132031,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132031,31.53,0.47,20.2,61682,75,NULL,'A82, H, cor','NGC 5984',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132032,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132032,31.54,0.4,20.3,61682,75,NULL,NULL,'NGC 5984',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132033,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132033,31.58,0.4,20.7,61682,75,NULL,'B','NGC 5984',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132034,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132034,31.7,0.46,21.9,61682,NULL,NULL,'J','NGC 5984',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132035,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132035,31.75,0.51,22.4,61682,NULL,NULL,NULL,'NGC 5984',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132036,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132036,31.77,0.5,22.6,61682,NULL,NULL,'Malmquist cor.','NGC 5984',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132037,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132037,31.8,0.47,22.9,61682,NULL,NULL,'H','NGC 5984',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132038,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132038,31.83,0.49,23.2,61682,75,NULL,'IR','NGC 5984',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132039,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132039,31.92,0.45,24.2,61682,NULL,NULL,'K','NGC 5984',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132040,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132040,37.02,0.46,254,61683,70,NULL,NULL,'2MASX J15425397+4652305',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000182,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.724916667,46.87531,0.005,NULL,59687115097,932611173,14572049,17.4),(132041,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132041,36.36,0.81,187,61684,70,NULL,NULL,'2MASX J15425541-0425027',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.90',NULL,NULL,NULL,NULL,NULL,NULL,1,235.730833,-4.41744,0.461,NULL,45590483695,712351307,11130489,16.9),(132042,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132042,36.33,0.21,184,61685,70,NULL,NULL,'2MASX J15425550+0813409',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,235.731375,8.228,0.097,NULL,56597791317,884340489,13817820,16.6),(132043,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132043,34.91,0.2,95.9,61686,74.4,NULL,NULL,'CGCG 166-040',NULL,'2013AJ....146...86T',2013,1,0.73,NULL,'G',0.000027,NULL,'16.1g',0.29,'Sc',NULL,NULL,NULL,NULL,1,235.7317083,28.92461,0.073,NULL,59924637614,936322462,14630038,16.1),(132044,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132044,35.42,0.48,121,61687,NULL,NULL,'Malmquist cor.','ESO 583- G 005',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.04',0.3,'SB(rs)bc',NULL,NULL,NULL,NULL,1,235.7372083,-18.39739,0.477,NULL,46601113349,728142396,11377224,14.04),(132045,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132045,35.5,0.46,126,61687,NULL,NULL,NULL,'ESO 583- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132046,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132046,35.54,0.2,128,61687,74.4,NULL,NULL,'ESO 583- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132047,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132047,38.32,0.12,461,61688,70,NULL,NULL,'SDSS J154257.02+054805.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000156,NULL,'18.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.737625,5.80164,0.105,NULL,56615612660,884618947,13822171,18.6),(132048,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132048,35.41,0.54,121,61689,70,NULL,NULL,'2MASX J15425760-0227277',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.91',NULL,NULL,NULL,NULL,NULL,NULL,1,235.740125,-2.45761,0.381,NULL,45401363341,709396302,11084317,16.91),(132049,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132049,37.96,0.33,391,61690,70,NULL,NULL,'2MASX J15425796+0032250',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000123,NULL,'16.2g',0.38,'E0',NULL,NULL,NULL,NULL,1,235.741416667,0.54019,0.293,NULL,56389266778,881082293,13766910,16.2),(132050,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132050,36.59,0.46,208,61691,70,NULL,NULL,'2MASX J15425946+3356081',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000124,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.7477917,33.93564,0.065,NULL,59890823815,935794122,14621783,17.5),(132051,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132051,35.45,NULL,123,61692,NULL,NULL,NULL,'FGC 1939',NULL,'2000BSAO...50....5K',2000,1,0.78,'6dF DR2 has z = 0.023778.','G',0.0001,NULL,'16.8',0.09,'Sd',NULL,NULL,NULL,NULL,1,235.7495417,-13.95669,0.505,NULL,45468155341,710439927,11100623,16.8),(132052,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132052,35.53,NULL,128,61692,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1939',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132053,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132053,35.55,NULL,129,61692,NULL,NULL,'Dipole + Quadrupole','FGC 1939',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132054,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132054,35.57,NULL,130,61692,NULL,NULL,'Dipole','FGC 1939',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132055,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132055,38.21,0.46,439,61693,70,NULL,NULL,'2MASX J15430080-0211207',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.753375,-2.18908,0.385,NULL,45401650623,709400790,11084387,17.5),(132056,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132056,37.96,0.33,391,61694,70,NULL,NULL,'SDSS J154301.27+003327.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000074,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,235.755333,0.55767,0.293,NULL,56389264337,881082255,13766910,18.5),(132057,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132057,37.42,0.33,305,61695,70,NULL,NULL,'2MASX J15430172+3321081',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.757041667,33.35239,0.057,NULL,59891395104,935803048,14621922,17.5),(132058,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132058,37.01,0.46,252,61696,70,NULL,NULL,'2MASX J15430181+3515401',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.757625,35.26103,0.057,NULL,59893790423,935840475,14622507,17),(132059,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132059,38.32,0.12,461,61697,70,NULL,NULL,'2MASX J15430184+0532510',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.757667,5.54744,0.133,NULL,56615523969,884617562,13822149,17.1),(132060,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132060,36.86,0.27,235,61698,70,NULL,NULL,'2MASX J15430217+3912293',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.7592083,39.20811,0.037,NULL,60096144589,939002259,14671910,17.3),(132061,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132061,39.08,0.46,655,61699,70,NULL,NULL,'SDSS J154304.29+400054.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,235.767917,40.01511,0.017,NULL,59961987867,936906060,14639157,18.1),(132062,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132062,37.63,0.46,336,61700,70,NULL,NULL,'2MASX J15430526+5213440',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000097,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,235.771916667,52.22903,0.049,NULL,59670584603,932352884,14568013,16.6),(132063,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132063,36.28,0.46,180,61701,70,NULL,NULL,'2MASX J15430561+4407001',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000188,NULL,'15.9g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,235.77325,44.11675,0.041,NULL,59691031949,932672374,14573005,15.9),(132064,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132064,36.6,0.46,209,61702,70,NULL,NULL,'2MASX J15430567+3059151',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.773625,30.98756,0.101,NULL,59925706309,936339161,14630299,17.5),(132065,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132065,36.86,0.27,235,61703,70,NULL,NULL,'2MASX J15430699+3909053',NULL,'2015arXiv151105856S',2015,1,0.52,'Hernandez-Toledo et al. (2010AJ....139.2525H) give z = 0.176.','G',0.000334,NULL,'16.80',0.45,'E/S0;BrClG',NULL,NULL,NULL,NULL,1,235.779167,39.15131,0.037,NULL,59877990332,935593598,14618649,16.8),(132066,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132066,38.41,0.27,481,61704,70,NULL,NULL,'2MASX J15430800+4212001',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000164,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.78325,42.20006,0.073,NULL,59680122998,932501921,14570342,18),(132067,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132067,38,0.46,399,61705,70,NULL,NULL,'2MASX J15430897+4034583',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000138,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.7872917,40.58281,0.041,NULL,59961849824,936903903,14639123,18.1),(132068,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132068,38.41,0.27,481,61706,70,NULL,NULL,'SDSS J154309.00+420959.6',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,'PRED','17.4g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.7875,42.16656,0.073,NULL,59680125072,932501954,14570343,17.4),(132069,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132069,38.32,0.12,461,61707,70,NULL,NULL,'SDSS J154309.66+052828.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.79025,5.47464,0.129,NULL,56615566901,884618232,13822159,18.5),(132070,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132070,36.62,0.46,211,61708,70,NULL,NULL,'2MASX J15431034+2215062',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00015,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,235.793208333,22.25175,0.165,NULL,59452235305,928941176,14514705,16.6),(132071,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132071,34.12,0.53,66.8,61709,70,NULL,NULL,'MCG -02-40-003',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.0001,NULL,'15.39',0.7,'HII',NULL,NULL,NULL,NULL,1,235.794,-12.57428,0.629,NULL,45468821155,710450330,11100786,15.39),(132072,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132072,36.86,0.27,235,61710,70,NULL,NULL,'2MASX J15431130+3914193',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000176,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,235.7970417,39.23878,0.037,NULL,60096137416,939002147,14671908,16.5),(132073,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132073,37.63,0.46,335,61711,70,NULL,NULL,'2MASX J15431139+0422200',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,235.7975417,4.37236,0.161,NULL,56616462793,884632231,13822378,17.4),(132074,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132074,38.32,0.12,461,61712,70,NULL,NULL,'SDSS J154311.44+055505.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,235.797667,5.91817,0.105,NULL,56615575776,884618371,13822162,18.1),(132075,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132075,36.29,0.46,181,61713,70,NULL,NULL,'2MASX J15431172+2151312',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.77',0.4,NULL,NULL,NULL,NULL,NULL,1,235.7989583,21.85858,0.153,NULL,59452417799,928944028,14514750,16.77),(132076,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132076,37.9,0.46,380,61714,70,NULL,NULL,'2MASX J15431183+4515241',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000132,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.7992917,45.25664,0.029,NULL,59689460542,932647820,14572622,18.3),(132077,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132077,37.99,0.46,396,61715,70,NULL,NULL,'2MASX J15431192+4731091',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000171,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,235.7997917,47.51925,0.037,NULL,59720547943,933133561,14580211,17.2),(132078,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132078,38.69,0.46,547,61716,70,NULL,NULL,'SDSS J154312.21+051400.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.800917,5.23353,0.129,NULL,56615052570,884610196,13822034,18.2),(132079,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132079,37.38,0.09,299,61717,70,NULL,NULL,'2MASX J15431230+3624373',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,'FoF','16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,235.801417,36.41036,0.053,NULL,59881092476,935642069,14619407,16.5),(132080,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132080,37.42,0.46,304,61718,70,NULL,NULL,'2MASX J15431367+2427228',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000187,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,235.807083,24.45642,0.153,NULL,59396261067,928066579,14501040,16.8),(132081,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132081,36.92,0.46,242,61719,70,NULL,NULL,'2MASX J15431550+3211252',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000199,NULL,'16.0g',0.37,'E0',NULL,NULL,NULL,NULL,1,235.814625,32.19036,0.081,NULL,59921104561,936267258,14629175,16),(132082,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132082,34.37,0.4,74.8,61720,NULL,NULL,'mean','UGC 09989',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.00019,NULL,'15.40',0.2,'S?',NULL,NULL,NULL,NULL,1,235.816791667,9.72397,0.093,NULL,56605698346,884464036,13819750,15.4),(132083,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132083,34.7,0.47,87.2,61720,NULL,NULL,'H','UGC 09989',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132084,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132084,37.08,0.46,261,61721,70,NULL,NULL,'2MASX J15431597+1729188',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000185,NULL,'16.6g',0.34,'AGN',NULL,NULL,NULL,NULL,1,235.816708333,17.48867,0.073,NULL,59433096942,928642139,14510033,16.6),(132085,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132085,37.53,0.27,321,61722,70,NULL,NULL,'2MASX J15431792+0651251',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000178,NULL,'16.7g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,235.8247083,6.85694,0.049,NULL,56623993584,884749899,13824217,16.7),(132086,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132086,38.32,0.12,461,61723,70,NULL,NULL,'2MASX J15431840+0553010',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,235.8265417,5.8835,0.105,NULL,56615330562,884614540,13822102,18),(132087,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132087,37.73,0.46,351,61724,70,NULL,NULL,'2MASX J15431980+2320552',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000172,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,235.832625,23.34892,0.169,NULL,59399231729,928112995,14501765,18.4),(132088,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132088,37.89,0.46,378,61725,70,NULL,NULL,'2MASX J15431993+4056133',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000175,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,235.833166667,40.93708,0.053,NULL,59677152894,932455513,14569617,17.1),(132089,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132089,38.32,0.12,461,61726,70,NULL,NULL,'SDSS J154320.28+055211.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,235.834541667,5.86992,0.105,NULL,56615333738,884614589,13822102,18.5),(132090,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132090,37.89,0.33,378,61727,70,NULL,NULL,'2MASX J15432081-0011359',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00009,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,235.8367083,-0.19319,0.293,NULL,45399232911,709363014,11083797,16.9),(132091,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132091,37.41,0.46,303,61728,70,NULL,NULL,'2MASX J15432177+4313481',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,235.8405417,43.23017,0.061,NULL,59679412797,932490824,14570169,18.1),(132092,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132092,37.68,0.46,343,61729,70,NULL,NULL,'2MASX J15432188+0604420',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,235.841333,6.0785,0.101,NULL,56615318647,884614353,13822099,17.7),(132093,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132093,37.67,0.46,341,61730,70,NULL,NULL,'2MASX J15432203+2249042',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,235.841708333,22.81797,0.165,NULL,59397218636,928081541,14501274,18),(132094,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132094,37.89,0.33,378,61731,70,NULL,NULL,'SDSS J154322.09-001136.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000077,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.8420417,-0.19339,0.293,NULL,45399232591,709363009,11083797,18.4),(132095,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132095,37.22,0.46,278,61732,70,NULL,NULL,'2MASX J15432278+2806057',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.844916667,28.1015,0.077,NULL,59917721714,936214401,14628350,17.9),(132096,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132096,38.41,0.46,481,61733,70,NULL,NULL,'SDSS J154323.04+142703.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.846,14.45086,0.069,NULL,56525488466,883210757,13800168,18.4),(132097,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132097,38.02,0.33,402,61734,70,NULL,NULL,'2MASX J15432302+0647331',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000178,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,235.846083,6.79261,0.057,NULL,56624001672,884750026,13824219,16.9),(132098,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132098,36.69,0.46,217,61735,70,NULL,NULL,'2MASX J15432320+1530488',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,235.846667,15.51342,0.033,NULL,59439609210,928743893,14511623,16.3),(132099,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132099,38.02,0.33,402,61736,70,NULL,NULL,'2MASX J15432336+0649181',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.84725,6.82186,0.057,NULL,56623995404,884749928,13824217,17.6),(132100,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132100,37.92,0.46,384,61737,70,NULL,NULL,'2MASX J15432332+1053001',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,235.847333,10.88344,0.105,NULL,56603486693,884429479,13819210,17.3),(132101,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132101,35.16,0.46,108,61738,70,NULL,NULL,'2MASX J15432371+3859230',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000151,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,235.848625,38.98972,0.037,NULL,59878012455,935593944,14618655,16.3),(132102,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132102,35.6,0.7,132,61739,70,NULL,NULL,'2MASX J15432396-0240559',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,235.849875,-2.68214,0.445,NULL,45584967317,712265114,11129142,14.8),(132103,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132103,32.74,0.2,35.3,61740,74.4,NULL,NULL,'UGC 09991',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.000017,NULL,'14.66',0.5,'Scd:',NULL,NULL,NULL,NULL,1,235.849875,14.43581,0.069,NULL,56525488844,883210763,13800168,14.66),(132104,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132104,32.97,0.43,39.3,61740,75,NULL,'3.6 micron, color corrected','UGC 09991',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132105,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132105,33.21,0.43,43.8,61740,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09991',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132106,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132106,35.75,0.2,141,61741,74.4,NULL,NULL,'CGCG 078-055',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000183,NULL,'15.5',0.2,NULL,NULL,NULL,NULL,NULL,1,235.852,11.52103,0.113,NULL,56592533698,884258339,13816536,15.5),(132107,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132107,37.91,0.46,383,61742,70,NULL,NULL,'2MASX J15432500+2551116',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000174,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,235.854167,25.85331,0.161,NULL,59870207689,935471995,14616749,16.9),(132108,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132108,36.72,0.46,221,61743,70,NULL,NULL,'2MASX J15432525+1742188',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000184,NULL,'16.0g',0.41,NULL,NULL,NULL,NULL,NULL,1,235.855166667,17.70528,0.073,NULL,59432834283,928638035,14509969,16),(132109,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132109,37.21,0.46,277,61744,70,NULL,NULL,'2MASX J15432559+3649180',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000213,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,235.8564583,36.82164,0.037,NULL,59881238978,935644359,14619443,16.5),(132110,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132110,36.92,0.46,243,61745,70,NULL,NULL,'2MASX J15432746+2414016',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.864375,24.23375,0.149,NULL,59396203095,928065673,14501026,17.9),(132111,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132111,37.71,0.46,349,61746,70,NULL,NULL,'2MASX J15432885+1419358',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,235.870333,14.32661,0.069,NULL,56525530428,883211412,13800178,16.9),(132112,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132112,34.97,0.2,98.6,61747,74.4,NULL,NULL,'UGC 09990',NULL,'2013AJ....146...86T',2013,1,1.3,'Haynes, et al. (1999AJ....117.2039H) give v = 6436 km/sec.','G',0.000334,NULL,'15.04',0.3,'Scd:','in a triple',NULL,NULL,NULL,1,235.8745417,4.79444,0.161,NULL,56618472043,884663625,13822869,15.04),(132113,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132113,35.03,0.49,101,61747,NULL,NULL,NULL,'UGC 09990',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132114,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132114,35.28,0.44,114,61747,NULL,NULL,'Malmquist cor.','UGC 09990',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132115,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132115,38.57,0.46,518,61748,70,NULL,NULL,'SDSS J154330.69+305214.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000164,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,235.877875,30.87072,0.093,NULL,59925825950,936341030,14630328,18.7),(132116,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132116,38.32,0.12,461,61749,70,NULL,NULL,'2MASX J15433153+0543060',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000182,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,235.8814583,5.71844,0.137,NULL,56615436556,884616196,13822128,16.8),(132117,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132117,38.13,0.46,422,61750,70,NULL,NULL,'2MASX J15433302+5607187',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000083,NULL,'17.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,235.8877917,56.12181,0.005,NULL,57584837286,899763082,14058798,17.2),(132118,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132118,37.38,0.09,299,61751,70,NULL,NULL,'2MASX J15433308+3545351',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,235.8879583,35.75986,0.029,NULL,59893651907,935838311,14622473,17.5),(132119,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132119,37.56,0.46,324,61752,70,NULL,NULL,'SDSS J154333.32+252452.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.888875,25.4145,0.149,NULL,59869853553,935466461,14616663,18.4),(132120,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132120,37.05,0.46,258,61753,70,NULL,NULL,'SDSS J154333.97+091427.3',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.7g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.891583333,9.24094,0.109,NULL,56605543163,884461611,13819712,17.7),(132121,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132121,36.33,0.21,184,61754,70,NULL,NULL,'2MASX J15433480+0822066',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000189,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,235.8949583,8.36864,0.073,NULL,56597749131,884339830,13817809,16.2),(132122,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132122,38.32,0.12,461,61755,70,NULL,NULL,'2MASX J15433589+0533160',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,235.8994583,5.55447,0.133,NULL,56615424584,884616009,13822125,18),(132123,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132123,35.84,0.46,147,61756,70,NULL,NULL,'CGCG 222-043',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000184,NULL,'15.3g',0.5,'E0','Group member',NULL,NULL,NULL,1,235.9015417,43.91328,0.041,NULL,59690538292,932664660,14572885,15.3),(132124,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132124,38.77,0.46,567,61757,70,NULL,NULL,'2MASX J15433646+1611129',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,235.901917,16.18681,0.049,NULL,59432094864,928626482,14509788,18.2),(132125,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132125,38.04,0.46,405,61758,70,NULL,NULL,'2MASX J15433676+2151295',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.903041667,21.85814,0.153,NULL,59452410945,928943921,14514748,17.2),(132126,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132126,38.32,0.12,461,61759,70,NULL,NULL,'2MASX J15433723+0546200',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.90525,5.77217,0.137,NULL,56615439022,884616234,13822128,17.9),(132127,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132127,35.85,0.46,148,61760,70,NULL,NULL,'2MASX J15433766+3929301',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000096,NULL,'16.4g',0.3,'HII',NULL,NULL,NULL,NULL,1,235.907083,39.49172,0.029,NULL,60096036513,939000570,14671883,16.4),(132128,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132128,38.63,0.46,532,61761,70,NULL,NULL,'2MASX J15433938+2655276',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,235.914,26.92422,0.117,NULL,59871911368,935498615,14617165,18.2),(132129,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132129,36.9,0.46,239,61762,70,NULL,NULL,'2MASX J15434246+1105167',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.926917,11.08786,0.117,NULL,56603592451,884431132,13819236,17.3),(132130,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132130,38.24,0.21,444,61763,70,NULL,NULL,'2MASX J15434313-0211204',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,235.92975,-2.18903,0.385,NULL,45585396109,712271814,11129247,18.2),(132131,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132131,36.15,0.27,170,61764,70,NULL,NULL,'2MASX J15434321+0415139',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'15.8g',0.42,NULL,NULL,NULL,NULL,NULL,1,235.9300417,4.25381,0.161,NULL,56616572895,884633951,13822405,15.8),(132132,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132132,38.41,0.27,481,61765,70,NULL,NULL,'2MASX J15434325+4230128',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,235.930167,42.5035,0.069,NULL,59679768684,932496385,14570256,17.7),(132133,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132133,37.26,0.33,283,61766,70,NULL,NULL,'2MASX J15434358+4826327',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000171,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,235.931375,48.4425,0.045,NULL,59719858966,933122796,14580043,16.9),(132134,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132134,36.11,0.46,167,61767,70,NULL,NULL,'2MASX J15434579-0145124',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000067,NULL,'16.0g',0.39,'E',NULL,NULL,NULL,NULL,1,235.9407917,-1.75333,0.357,NULL,45585326378,712270724,11129230,16),(132135,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132135,36.45,0.46,195,61768,70,NULL,NULL,'2MASX J15434637+5217407',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000065,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.943167,52.29478,0.049,NULL,59670537400,932352146,14568002,17.1),(132136,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132136,35.38,0.49,119,61769,75,NULL,'IR','UGC 09994',NULL,'2011yCatp016004901K',2011,1,0.5,NULL,'G',0.000015,NULL,'16.1g',0.19,'Sbc',NULL,NULL,NULL,NULL,1,235.947,33.30589,0.057,NULL,59891384398,935802881,14621920,16.1),(132137,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132137,35.42,NULL,121,61769,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09994',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132138,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132138,35.43,NULL,122,61769,NULL,NULL,'Dipole + Quadrupole','UGC 09994',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132139,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132139,35.45,NULL,123,61769,NULL,NULL,'Dipole','UGC 09994',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132140,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132140,35.47,NULL,124,61769,NULL,NULL,NULL,'UGC 09994',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132141,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132141,35.87,0.2,149,61769,74.4,NULL,NULL,'UGC 09994',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132142,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132142,36.15,0.27,170,61770,70,NULL,NULL,'SDSS J154348.88+044330.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.9537083,4.72517,0.177,NULL,56618509597,884664212,13822878,17),(132143,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132143,38.32,0.12,461,61771,70,NULL,NULL,'2MASX J15435074+0538319',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.961541667,5.64211,0.137,NULL,56615413882,884615841,13822122,17.9),(132144,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132144,38.17,0.46,431,61772,70,NULL,NULL,'SDSS J154351.72+095423.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.965541667,9.9065,0.097,NULL,56605710686,884464229,13819753,17.7),(132145,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132145,37.38,0.09,299,61773,70,NULL,NULL,'2MASX J15435179+3633371',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000162,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,235.965917,36.56044,0.041,NULL,59881272518,935644883,14619451,18.1),(132146,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132146,37.91,0.46,382,61774,70,NULL,NULL,'2MASX J15435253+0026489',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000077,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.968917,0.44694,0.277,NULL,56388310960,881067358,13766677,17.9),(132147,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132147,38.46,0.46,492,61775,70,NULL,NULL,'2MASX J15435314+3937241',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00018,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.971417,39.62333,0.029,NULL,60096052539,939000820,14671887,17.2),(132148,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132148,37.13,0.46,267,61776,70,NULL,NULL,'2MASX J15435382+1520190',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.974333,15.33864,0.033,NULL,59439585971,928743530,14511617,17.3),(132149,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132149,37.55,0.19,324,61777,70,NULL,NULL,'MCG +06-34-029',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000212,NULL,'15.8g',0.48,'BrClG',NULL,NULL,NULL,NULL,1,235.978875,34.48206,0.061,NULL,59894338540,935849039,14622641,15.8),(132150,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132150,36.19,0.46,173,61778,70,NULL,NULL,'2MASX J15435526+0145539',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.980291667,1.76503,0.245,NULL,56608742099,884511595,13820493,16.6),(132151,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132151,38.07,0.33,411,61779,70,NULL,NULL,'SDSS J154355.52+052425.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.981375,5.40717,0.133,NULL,56618191008,884659234,13822800,18.4),(132152,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132152,35.18,0.46,109,61780,70,NULL,NULL,'CGCG 050-086',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000153,NULL,'15.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,235.9815,7.85467,0.037,NULL,56597651885,884338310,13817786,15.2),(132153,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132153,32.04,0.4,25.6,61781,75,NULL,'B','UGC 10054',NULL,'1988NBGC.C....0000T',1988,1,2.6,NULL,'G',0.000013,NULL,'13.7',1.1,'SBdm',NULL,NULL,NULL,NULL,1,235.982,81.80961,0.177,NULL,57131156857,892674325,13948036,13.7),(132154,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132154,32.86,0.49,37.3,61781,75,NULL,'IR','UGC 10054',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132155,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132155,38.26,0.46,449,61782,70,NULL,NULL,'2MASX J15435581+3743351',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000209,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.982625,37.72636,0.041,NULL,59881829312,935653583,14619587,17.3),(132156,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132156,36.86,0.46,236,61783,70,NULL,NULL,'2MASX J15435596+2215205',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.983083333,22.25567,0.165,NULL,59452236209,928941190,14514706,17.6),(132157,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132157,37.02,0.46,253,61784,70,NULL,NULL,'2MASX J15435641+3217042',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000195,NULL,'15.9g',0.42,'E/S0',NULL,NULL,NULL,NULL,1,235.985083333,32.28433,0.081,NULL,59921038975,936266233,14629159,15.9),(132158,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132158,38.32,0.12,461,61785,70,NULL,NULL,'2MASX J15435664+0555099',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,235.985917,5.91944,0.129,NULL,56615346388,884614787,13822106,17.7),(132159,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132159,36.39,0.46,190,61786,70,NULL,NULL,'2MASX J15435856+4458179',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000213,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,235.994125,44.97169,0.037,NULL,59693027754,932703558,14573493,16.4),(132160,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132160,35.09,0.46,104,61787,70,NULL,NULL,'CGCG 107-031',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000153,NULL,'15.1g',0.61,NULL,NULL,NULL,NULL,NULL,1,235.995417,19.21153,0.109,NULL,59449937921,928905280,14514145,15.1),(132161,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132161,35.66,0.46,136,61788,70,NULL,NULL,'CGCG 050-088',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000198,NULL,'15.9g',0.38,NULL,NULL,NULL,NULL,NULL,1,236.0022917,8.28839,0.073,NULL,56597494847,884335856,13817747,15.9),(132162,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132162,38.24,0.21,444,61789,70,NULL,NULL,'SDSS J154401.04-015731.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000164,NULL,'18.9g',0.1,NULL,NULL,NULL,NULL,NULL,1,236.004333333,-1.95883,0.369,NULL,45585508921,712273576,11129274,18.9),(132163,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132163,38.32,0.12,461,61790,70,NULL,NULL,'2MASX J15440120+0536259',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.0050417,5.60728,0.137,NULL,56615433566,884616149,13822127,17.3),(132164,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132164,38.02,0.46,402,61791,70,NULL,NULL,'2MASX J15440188+2612329',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,236.007917,26.20908,0.181,NULL,59873004388,935515693,14617432,17.1),(132165,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132165,38.32,0.12,461,61792,70,NULL,NULL,'2MASX J15440220+0528169',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,236.0092917,5.47156,0.133,NULL,56615377398,884615271,13822113,18.6),(132166,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132166,38.24,0.21,444,61793,70,NULL,NULL,'SDSS J154402.73-020426.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000133,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,236.011375,-2.07397,0.369,NULL,45585502303,712273473,11129273,18.6),(132167,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132167,37.38,0.09,299,61794,70,NULL,NULL,'2MASX J15440307+3635500',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000168,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,236.012625,36.59731,0.041,NULL,59881273864,935644904,14619451,16.5),(132168,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132168,37.57,0.46,327,61795,70,NULL,NULL,'2MASX J15440344+1812106',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,236.0142917,18.20294,0.065,NULL,59430704655,928604760,14509449,17.7),(132169,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132169,35.29,0.48,114,61796,70,NULL,NULL,'2MASX J15440361-2047165',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,236.0150417,-20.78794,0.609,NULL,46635228990,728675452,11385553,14.9),(132170,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132170,37.57,0.46,327,61797,70,NULL,NULL,'2MASX J15440400+0406299',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,236.01675,4.10833,0.161,NULL,56616776020,884637125,13822455,NULL),(132171,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132171,37.38,0.09,299,61798,70,NULL,NULL,'2MASX J15440445+3620510',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.3g',0.26,NULL,'Group member',NULL,NULL,NULL,1,236.018333,36.3475,0.061,NULL,59880546226,935633534,14619273,17.3),(132172,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132172,37.63,0.46,335,61799,70,NULL,NULL,'2MASX J15440477+2734229',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000173,NULL,'17.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.02,27.57308,0.085,NULL,59917298125,936207783,14628246,17.3),(132173,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132173,33.51,0.2,50.4,61800,74.4,NULL,NULL,'ESO 329- G 016',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.00015,NULL,'15.5',0.7,'SB(rs)bc:',NULL,NULL,NULL,NULL,1,236.0220417,-41.24794,0.845,NULL,46339142905,724049107,11313267,15.5),(132174,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132174,33.81,0.47,57.9,61800,NULL,NULL,'H','ESO 329- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132175,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132175,33.85,0.46,59,61800,NULL,NULL,'J','ESO 329- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132176,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132176,33.92,0.45,60.7,61800,NULL,NULL,'K','ESO 329- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132177,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132177,34.04,0.4,64.4,61800,NULL,NULL,'mean','ESO 329- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132178,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132178,37.22,0.46,278,61801,70,NULL,NULL,'2MASX J15440537+2854239',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00015,NULL,'16.4g',0.38,'Sc',NULL,NULL,NULL,NULL,1,236.022375,28.90653,0.073,NULL,59924931651,936327057,14630110,16.4),(132179,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132179,37.38,0.46,299,61802,70,NULL,NULL,'2MASX J15440628+0948504',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.02625,9.81383,0.097,NULL,56605751525,884464867,13819763,18.1),(132180,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132180,34.81,NULL,91.4,61803,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10004',NULL,'2010Ap&SS.325..163P',2010,1,1.34,NULL,'G',0.000053,NULL,'16.6g',0.13,'Sd',NULL,NULL,NULL,NULL,1,236.029583,47.29464,0.037,NULL,59719726657,933120729,14580011,16.6),(132181,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132181,34.82,NULL,92.2,61803,NULL,NULL,'Dipole + Quadrupole','UGC 10004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132182,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132182,34.84,NULL,92.8,61803,NULL,NULL,'Dipole','UGC 10004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132183,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132183,34.87,NULL,94,61803,NULL,NULL,NULL,'UGC 10004',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132184,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132184,37.48,0.46,313,61804,70,NULL,NULL,'2MASX J15440732+4324369',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000144,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,236.030667,43.41019,0.057,NULL,59690484533,932663820,14572872,17.2),(132185,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132185,38.24,0.21,444,61805,70,NULL,NULL,'2MASX J15440740-0154283',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00015,NULL,'16.8g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,236.030958333,-1.90783,0.369,NULL,45585507203,712273550,11129274,16.8),(132186,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132186,35.21,0.46,110,61806,70,NULL,NULL,'2MASX J15440769+2244136',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000163,NULL,'15.6g',0.4,NULL,NULL,NULL,NULL,NULL,1,236.0319583,22.73722,0.165,NULL,59397209815,928081403,14501271,15.6),(132187,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132187,36.98,0.46,249,61807,70,NULL,NULL,'2MASX J15440874+4226039',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000186,NULL,'15.9g',0.41,'E/S0',NULL,NULL,NULL,NULL,1,236.0365,42.43444,0.073,NULL,59680634129,932509908,14570467,15.9),(132188,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132188,37.75,0.46,355,61808,70,NULL,NULL,'2MASX J15441018+2417488',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00014,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,236.042417,24.29689,0.153,NULL,59396253555,928066461,14501038,17.5),(132189,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132189,37.37,0.46,298,61809,70,NULL,NULL,'2MASX J15441037+2038196',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.043208333,20.63881,0.105,NULL,59447895960,928873374,14513646,17.9),(132190,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132190,38.24,0.21,444,61810,70,NULL,NULL,'SDSS J154411.19-015015.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000147,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.046667,-1.83761,0.357,NULL,45585321549,712270649,11129228,18.5),(132191,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132191,37.27,0.33,284,61811,70,NULL,NULL,'2MASX J15441136+1416025',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,236.0475,14.26731,0.069,NULL,56525428473,883209819,13800153,17.2),(132192,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132192,37.66,0.46,341,61812,70,NULL,NULL,'2MASX J15441166+4013420',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.048625,40.22853,0.049,NULL,59961786512,936902914,14639108,18),(132193,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132193,37.38,0.09,299,61813,70,NULL,NULL,'2MASX J15441341+3606400',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000093,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,236.056083,36.11119,0.053,NULL,59880563363,935633802,14619278,17),(132194,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132194,37.6,0.46,332,61814,70,NULL,NULL,'SDSS J154414.52+080945.4',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.0605417,8.16261,0.065,NULL,56597517084,884336204,13817753,17.4),(132195,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132195,36.54,0.46,204,61815,70,NULL,NULL,'2MASX J15441517+3947450',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000164,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.063041667,39.79592,0.041,NULL,59961779753,936902808,14639106,16.9),(132196,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132196,37.99,0.33,397,61816,70,NULL,NULL,'2MASX J15441566+4240038',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000204,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,236.06525,42.66772,0.069,NULL,59679777187,932496518,14570258,16.9),(132197,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132197,38.07,0.33,411,61817,70,NULL,NULL,'2MASX J15441594+0528401',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.066333,5.47769,0.133,NULL,56618197506,884659336,13822802,17.6),(132198,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132198,37.38,0.09,299,61818,70,NULL,NULL,'2MASX J15441622+3553500',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000097,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,236.0675,35.89717,0.041,NULL,59891842104,935810032,14622031,16.9),(132199,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132199,37.64,0.46,337,61819,70,NULL,NULL,'2MASX J15441702-0029218',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000093,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,236.070875,-0.48942,0.257,NULL,45399336176,709364627,11083822,16.6),(132200,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132200,35.51,0.46,127,61820,70,NULL,NULL,'2MASX J15441720+0206421',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'16.0g',0.36,NULL,NULL,NULL,NULL,NULL,1,236.071708333,2.11186,0.253,NULL,56608890470,884513913,13820529,16),(132201,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132201,37,0.46,251,61821,70,NULL,NULL,'2MASX J15441754+1549585',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.073083333,15.83292,0.077,NULL,59431393085,928615516,14509617,17.8),(132202,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132202,37.55,0.19,324,61822,70,NULL,NULL,'2MASX J15441775+3449307',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000163,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,236.073875,34.82514,0.041,NULL,59894229491,935847335,14622614,16.8),(132203,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132203,37.55,0.19,324,61823,70,NULL,NULL,'MCG +06-35-001',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000117,NULL,'15.6g',0.45,'E0',NULL,NULL,NULL,NULL,1,236.0745,34.69628,0.069,NULL,59894225664,935847276,14622613,15.6),(132204,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132204,37.35,0.46,294,61824,70,NULL,NULL,'SDSS J154418.54+105259.9',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.0772917,10.88333,0.105,NULL,56603693292,884432707,13819261,17.1),(132205,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132205,37.55,0.19,324,61825,70,NULL,NULL,'2MASXi J1544192+344139',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,'FoF','17.3g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.08025,34.69433,0.069,NULL,59894226319,935847286,14622613,17.3),(132206,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132206,36.74,0.46,223,61826,70,NULL,NULL,'SDSS J154419.88+400948.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.082875,40.1635,0.049,NULL,59961788828,936902950,14639108,17.8),(132207,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132207,37.9,0.46,381,61827,70,NULL,NULL,'2MASX J15442189+1258435',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,236.091167,12.97883,0.073,NULL,56523843349,883185052,13799766,NULL),(132208,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132208,38.16,0.33,428,61828,70,NULL,NULL,'2MASX J15442247+2947138',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.0935,29.78711,0.077,NULL,59924542385,936320974,14630015,18),(132209,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132209,37.96,0.46,391,61829,70,NULL,NULL,'2MASX J15442288+1155195',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,236.095333,11.92211,0.129,NULL,56591731228,884245800,13816340,17.1),(132210,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132210,35.33,0.46,117,61830,70,NULL,NULL,'UGC 09999',NULL,'2015arXiv151105856S',2015,1,1.15,NULL,'G',0.000173,NULL,'14.1g',0.83,'S0',NULL,NULL,NULL,NULL,1,236.095625,25.32753,0.149,NULL,59869864655,935466635,14616666,14.1),(132211,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132211,37.87,0.46,374,61831,70,NULL,NULL,'2MASX J15442383+1351485',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.0992917,13.86356,0.077,NULL,56525288172,883207627,13800119,17.7),(132212,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132212,37.55,0.19,324,61832,70,NULL,NULL,'2MASX J15442393+3442407',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,'FoF','16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,236.099667,34.71131,0.069,NULL,59894226795,935847293,14622613,16.7),(132213,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132213,37.26,0.33,283,61833,70,NULL,NULL,'2MASX J15442392+4829345',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000164,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,236.09975,48.49303,0.097,NULL,59724299739,933192183,14581127,16.7),(132214,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132214,37.77,0.33,357,61834,70,NULL,NULL,'2MASX J15442413+1703455',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.1007083,17.06261,0.049,NULL,59433212709,928643948,14510061,17.8),(132215,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132215,37.82,0.33,366,61835,70,NULL,NULL,'2MASX J15442459+2203444',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000195,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,236.102375,22.0625,0.161,NULL,59452263989,928941624,14514712,16.5),(132216,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132216,38.07,0.46,411,61836,70,NULL,NULL,'2MASX J15442516+4152040',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000145,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,236.10475,41.86786,0.069,NULL,59680053938,932500842,14570325,17.2),(132217,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132217,37.74,0.46,354,61837,70,NULL,NULL,'SDSS J154425.91+114355.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.108,11.73203,0.133,NULL,56591816849,884247138,13816361,18.5),(132218,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132218,37.82,0.33,366,61838,70,NULL,NULL,'2MASX J15442618+2204394',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,236.109125,22.07769,0.161,NULL,59396737328,928074020,14501156,18.3),(132219,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132219,37.43,0.46,307,61839,70,NULL,NULL,'2MASXi J1544267+470659',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.111667,47.11653,0.045,NULL,59719704390,933120381,14580005,17.5),(132220,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132220,35.94,0.46,154,61840,70,NULL,NULL,'CGCG 250-006',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.000183,NULL,'14.6g',0.65,'E0',NULL,NULL,NULL,NULL,1,236.1122083,47.00672,0.053,NULL,59719710550,933120477,14580007,14.6),(132221,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132221,37.77,0.33,357,61841,70,NULL,NULL,'SDSS J154427.24+170236.7',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'15.9g',0.43,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.1135417,17.04356,0.049,NULL,59433213009,928643953,14510061,15.9),(132222,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132222,36.33,0.21,184,61842,70,NULL,NULL,'2MASX J15442848+0824296',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,'PHOT','16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,236.118791667,8.40814,0.069,NULL,56595580006,884305937,13817280,16.5),(132223,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132223,37.93,0.46,386,61843,70,NULL,NULL,'2MASX J15442857+1319474',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,236.1192083,13.32972,0.081,NULL,56525733926,883214592,13800228,17.3),(132224,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132224,37.55,0.19,324,61844,70,NULL,NULL,'2MASX J15442896+3446307',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.120791667,34.77525,0.041,NULL,59894253619,935847712,14622620,17.5),(132225,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132225,37.27,0.33,284,61845,70,NULL,NULL,'2MASX J15442918+1418534',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'17.32',0.28,NULL,NULL,NULL,NULL,NULL,1,236.121583,14.31478,0.069,NULL,56525398830,883209356,13800146,17.32),(132226,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132226,35.85,0.49,148,61846,75,NULL,'IR','UGC 09996',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.00001,NULL,'15.38',0.19,'Sb',NULL,NULL,NULL,NULL,1,236.121583,11.54953,0.109,NULL,56592505028,884257891,13816529,15.38),(132227,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132227,36.04,NULL,161,61846,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09996',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132228,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132228,36.05,NULL,162,61846,NULL,NULL,'Dipole + Quadrupole','UGC 09996',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132229,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132229,36.06,NULL,163,61846,NULL,NULL,NULL,'UGC 09996',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132230,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132230,36.07,NULL,164,61846,NULL,NULL,'Dipole','UGC 09996',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132231,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132231,36.68,0.2,217,61846,74.4,NULL,NULL,'UGC 09996',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132232,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132232,38.2,0.46,436,61847,70,NULL,NULL,'2MASX J15442946+5346175',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,236.1227083,53.77142,0.017,NULL,59669107202,932329800,14567653,16.9),(132233,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132233,36.89,0.46,238,61848,70,NULL,NULL,'2MASX J15442970+2101224',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.1g',0.31,NULL,NULL,NULL,NULL,NULL,1,236.123875,21.02286,0.121,NULL,59447028676,928859823,14513434,16.1),(132234,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132234,37.57,0.33,326,61849,70,NULL,NULL,'SDSS J154429.97+242026.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000149,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.124917,24.34064,0.153,NULL,59396224644,928066010,14501031,18.6),(132235,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132235,36.15,0.27,170,61850,70,NULL,NULL,'2MASX J15443125+0413531',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,236.130083333,4.23133,0.169,NULL,56616583482,884634116,13822408,16.3),(132236,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132236,34.7,0.47,87,61851,70,NULL,NULL,'2MASX J15443216-1525087',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000047,NULL,'15.08',NULL,NULL,NULL,NULL,NULL,NULL,1,236.1339583,-15.41917,0.381,NULL,46599821174,728122205,11376909,15.08),(132237,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132237,36.83,0.46,232,61852,70,NULL,NULL,'2MASX J15443238+3205317',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.134916667,32.09228,0.089,NULL,59921044655,936266322,14629161,17.4),(132238,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132238,34.85,0.2,93.3,61853,74.4,NULL,NULL,'ESO 515- G 005',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000033,NULL,'13.90',0.6,'S...',NULL,NULL,NULL,NULL,1,236.136291667,-25.37478,0.821,NULL,47115294665,736176479,11502757,13.9),(132239,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132239,34.89,0.46,94.9,61853,NULL,NULL,'Malmquist cor.','ESO 515- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132240,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132240,35.13,0.41,106,61853,NULL,NULL,NULL,'ESO 515- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132241,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132241,38.03,0.46,404,61854,70,NULL,NULL,'2MASX J15443283+4143570',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.136917,41.73242,0.069,NULL,59680095337,932501489,14570335,17.4),(132242,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132242,37.99,0.33,397,61855,70,NULL,NULL,'2MASX J15443369+4238080',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000153,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,236.1402917,42.63564,0.069,NULL,59679823556,932497243,14570269,17.6),(132243,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132243,36.56,0.2,205,61856,74.4,NULL,NULL,'NGC 5988',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000033,NULL,'14.50',1,'Scd:',NULL,NULL,NULL,NULL,1,236.141083,10.29314,0.105,NULL,56606271189,884472987,13819890,14.5),(132244,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132244,37.38,0.09,299,61857,70,NULL,NULL,'2MASX J15443385+3628390',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00007,NULL,'16.8g',0.3,NULL,'Group member',NULL,NULL,NULL,1,236.1412083,36.47739,0.053,NULL,59880538869,935633419,14619272,16.8),(132245,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132245,37.61,0.46,333,61858,70,NULL,NULL,'SDSS J154434.35+261742.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.143125,26.29506,0.197,NULL,59873138419,935517787,14617465,18.1),(132246,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132246,37.38,0.09,299,61859,70,NULL,NULL,'2MASX J15443516+3626263',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000093,NULL,'17.3g',0.18,NULL,'Group member',NULL,NULL,NULL,1,236.146333,36.44075,0.053,NULL,59880540540,935633445,14619272,17.3),(132247,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132247,37.42,0.46,305,61860,70,NULL,NULL,'2MASX J15443580+0957176',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.149125,9.95497,0.097,NULL,56606101417,884470334,13819848,17.5),(132248,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132248,37.23,0.46,279,61861,70,NULL,NULL,'2MASX J15443860+4221001',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.160917,42.34992,0.073,NULL,59680682146,932510658,14570479,17.5),(132249,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132249,38.16,0.33,428,61862,70,NULL,NULL,'2MASX J15443897+2940368',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000176,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.1622917,29.67678,0.077,NULL,59924486607,936320103,14630001,17.6),(132250,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132250,37.44,0.46,308,61863,70,NULL,NULL,'SDSS J154438.97+382615.9',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000147,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.162416667,38.43775,0.045,NULL,59878911378,935607990,14618874,17.7),(132251,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132251,38.45,0.46,489,61864,70,NULL,NULL,'SDSS J154439.58-014021.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000141,NULL,'19.0g',0.11,NULL,NULL,NULL,NULL,NULL,1,236.164916667,-1.6725,0.357,NULL,45587429029,712303578,11129743,19),(132252,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132252,35.74,0.57,141,61865,70,NULL,NULL,'2MASX J15443973-3003281',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,236.165625,-30.05781,0.477,NULL,47173913047,737092391,11517068,14),(132253,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132253,37.73,0.46,351,61866,70,NULL,NULL,'2MASX J15444014+0759276',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000176,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,236.167375,7.99094,0.065,NULL,56595352340,884302380,13817224,17.9),(132254,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132254,37.85,0.46,372,61867,70,NULL,NULL,'2MASX J15444035+3047166',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00021,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,236.168167,30.78794,0.081,NULL,59921201260,936268769,14629199,16.7),(132255,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132255,38.71,0.46,553,61868,70,NULL,NULL,'2MASX J15444048+3327232',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000161,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.168583,33.45658,0.049,NULL,59888968306,935765129,14621330,18.4),(132256,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132256,36.44,0.46,194,61869,70,NULL,NULL,'2MASX J15444108+0931046',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',NULL,NULL,'16.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,236.171083333,9.518,0.105,NULL,56602689668,884417026,13819016,16.1),(132257,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132257,37.33,0.23,293,61870,70,NULL,NULL,'2MASX J15444118+5246544',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000102,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,236.1715,52.78178,0.037,NULL,59668744602,932324134,14567564,16.3),(132258,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132258,37.33,0.23,293,61871,70,NULL,NULL,'SBS 1543+528',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.00011,NULL,'15.1g',0.56,'BrClG',NULL,NULL,NULL,NULL,1,236.1765417,52.68733,0.037,NULL,59668753553,932324274,14567566,15.1),(132259,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132259,35.18,0.49,109,61872,75,NULL,'IR','UGC 10006',NULL,'2011yCatp016004901K',2011,1,1.05,NULL,'G',0.000088,NULL,'15.8g',0.26,'Sbc',NULL,NULL,NULL,NULL,1,236.17925,32.40375,0.073,NULL,59888492051,935757688,14621213,15.8),(132260,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132260,35.58,0.2,131,61872,74.4,NULL,NULL,'UGC 10006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132261,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132261,35.66,0.36,136,61872,NULL,NULL,'Malmquist cor.','UGC 10006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132262,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132262,35.72,0.35,139,61872,NULL,NULL,NULL,'UGC 10006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132263,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132263,37.33,0.23,293,61873,70,NULL,NULL,'SDSS J154444.39+524839.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000068,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.185,52.81089,0.013,NULL,59668717309,932323707,14567557,18.2),(132264,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132264,37.38,0.09,299,61874,70,NULL,NULL,'2MASX J15444471+3607474',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000083,NULL,'16.7g',0.27,NULL,'Group member',NULL,NULL,NULL,1,236.1864583,36.12986,0.053,NULL,59880534481,935633351,14619271,16.7),(132265,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132265,37.33,0.23,293,61875,70,NULL,NULL,'2MASX J15444501+5251094',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000107,NULL,'16.0g',0.37,'E0',NULL,NULL,NULL,NULL,1,236.187625,52.85269,0.013,NULL,59668714214,932323659,14567557,16),(132266,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132266,37.38,0.09,299,61876,70,NULL,NULL,'2MASX J15444538+3604324',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'15.8',0.2,NULL,'Group member',NULL,NULL,NULL,1,236.1889583,36.07558,0.053,NULL,59880531911,935633311,14619270,15.8),(132267,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132267,38.27,0.46,450,61877,70,NULL,NULL,'2MASX J15444546+0452343',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,236.189375,4.87608,0.145,NULL,56618734779,884667730,13822933,17),(132268,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132268,36.13,0.2,168,61878,74.4,NULL,NULL,'CGCG 078-059',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000137,NULL,'15.5',0.3,NULL,NULL,NULL,NULL,NULL,1,236.1904583,8.99725,0.093,NULL,56595280476,884301257,13817207,15.5),(132269,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132269,37.1,0.46,263,61879,70,NULL,NULL,'2MASX J15444658+4102274',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000176,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,236.1940417,41.04103,0.053,NULL,59677575050,932462110,14569720,16.3),(132270,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132270,37.85,0.46,372,61880,70,NULL,NULL,'2MASX J15444721+0815586',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.19675,8.26619,0.069,NULL,56595511956,884304874,13817263,18.1),(132271,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132271,36.43,0.33,193,61881,70,NULL,NULL,'2MASX J15444807+3532253',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000167,NULL,'16.4g',NULL,NULL,NULL,NULL,NULL,NULL,1,236.200375,35.54022,0.037,NULL,59891887344,935810739,14622042,16.4),(132272,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132272,35.45,0.48,123,61882,70,NULL,NULL,'2MASX J15444821-1922215',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.19',NULL,NULL,NULL,NULL,NULL,NULL,1,236.200791667,-19.37258,0.517,NULL,46636441217,728694394,11385849,15.19),(132273,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132273,38.02,0.46,401,61883,70,NULL,NULL,'2MASX J15444858+5654486',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000081,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.202375,56.91367,0.017,NULL,57642480821,900663762,14072871,17.8),(132274,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132274,37.81,0.46,365,61884,70,NULL,NULL,'2MASX J15444864+1823168',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,236.20275,18.38817,0.069,NULL,59430666307,928604161,14509440,17.7),(132275,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132275,33.46,NULL,49.2,61885,NULL,NULL,'Dipole','UGC 10000',NULL,'2010Ap&SS.325..163P',2010,1,1.97,NULL,'G',0.000005,NULL,'15.90',0.2,'Scd',NULL,NULL,NULL,NULL,1,236.206083,3.95633,0.217,NULL,56616169073,884627641,13822306,15.9),(132276,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132276,33.47,NULL,49.4,61885,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10000',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132277,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132277,33.47,NULL,49.5,61885,NULL,NULL,'Dipole + Quadrupole','UGC 10000',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132278,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132278,33.56,NULL,51.6,61885,NULL,NULL,NULL,'UGC 10000',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132279,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132279,34.55,0.2,81.3,61885,74.4,NULL,NULL,'UGC 10000',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132280,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132280,34.77,0.74,89.9,61885,NULL,NULL,NULL,'UGC 10000',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132281,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132281,34.93,0.69,96.7,61885,NULL,NULL,'Malmquist cor.','UGC 10000',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132282,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132282,38.18,0.46,432,61886,70,NULL,NULL,'2MASX J15444988+0604383',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000196,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.208,6.07742,0.117,NULL,56615269489,884613585,13822087,18.2),(132283,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132283,37.57,0.33,326,61887,70,NULL,NULL,'2MASX J15445108+2424378',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000185,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,236.2129583,24.41039,0.153,NULL,59396211135,928065798,14501028,16.3),(132284,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132284,35.19,0.46,109,61888,70,NULL,NULL,'CGCG 222-050',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.00015,NULL,'14.5g',0.65,'E0',NULL,NULL,NULL,NULL,1,236.2135,43.51406,0.049,NULL,59690501720,932664089,14572876,14.5),(132285,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132285,37.9,0.33,380,61889,70,NULL,NULL,'2MASX J15445149+3646484',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000181,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,236.2145417,36.78017,0.037,NULL,59881151250,935642988,14619421,17.1),(132286,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132286,37.38,0.09,299,61890,70,NULL,NULL,'2MASX J15445181+3609594',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000127,NULL,'17.3g',0.18,NULL,'Group member',NULL,NULL,NULL,1,236.215875,36.16664,0.053,NULL,59880534758,935633355,14619271,17.3),(132287,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132287,36.88,0.46,237,61891,70,NULL,NULL,'2MASX J15445194+4216140',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000152,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,236.216625,42.27056,0.073,NULL,59680683912,932510686,14570479,16.3),(132288,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132288,34.4,0.57,75.8,61892,NULL,NULL,'Malmquist cor.','UGC 10022',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000044,NULL,'15.9r',0.4,'Sc(f)',NULL,NULL,NULL,NULL,1,236.221625,57.36153,0.033,NULL,57635916845,900561200,14071268,15.9),(132289,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132289,34.53,0.54,80.5,61892,NULL,NULL,NULL,'UGC 10022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132290,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132290,34.57,0.2,82,61892,74.4,NULL,NULL,'UGC 10022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132291,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132291,35.97,0.46,157,61893,70,NULL,NULL,'2MASX J15445321+0024153',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000071,NULL,'16.2g',0.37,'S0',NULL,NULL,NULL,NULL,1,236.221791667,0.40431,0.277,NULL,56606543527,884477242,13819956,16.2),(132292,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132292,36.43,0.33,193,61894,70,NULL,NULL,'2MASX J15445372+3531434',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000186,NULL,'16.0g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,236.2239583,35.52881,0.037,NULL,59891886400,935810725,14622042,16),(132293,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132293,37.38,0.09,299,61895,70,NULL,NULL,'SDSS J154455.61+360534.0',NULL,'2015arXiv151105856S',2015,1,0.11,NULL,'G',0.000162,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,236.2317083,36.09281,0.053,NULL,59880536026,935633375,14619271,18.6),(132294,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132294,37.38,0.09,299,61896,70,NULL,NULL,'2MASX J15445586+3608184',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.6g',0.16,NULL,'Group member',NULL,NULL,NULL,1,236.23275,36.1385,0.053,NULL,59880537890,935633404,14619271,17.6),(132295,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132295,37.44,0.46,308,61897,70,NULL,NULL,'2MASX J15445698+0630266',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000182,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,236.2375417,6.50731,0.057,NULL,56623481800,884741903,13824092,16.9),(132296,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132296,37.61,0.46,333,61898,70,NULL,NULL,'2MASX J15445788+2715083',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000174,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.2412083,27.25244,0.085,NULL,59872014474,935500226,14617191,17.5),(132297,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132297,37.38,0.09,299,61899,70,NULL,NULL,'2MASX J15445791+3604074',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00011,NULL,'16.7g',0.31,NULL,'Group member',NULL,NULL,NULL,1,236.241416667,36.06883,0.053,NULL,59880523927,935633186,14619268,16.7),(132298,'BCG','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132298,37.47,0.35,292,61900,60,NULL,'ABELL 2124, BCG','UGC 10012',0.0671,'1980ApJ...241..486H',1980,1,0.92,NULL,'G',0.0001,NULL,'14.9g',0.67,'cD;E           BrClG','Group member',NULL,NULL,NULL,1,236.2459583,36.10947,0.053,NULL,59880535406,935633365,14619271,14.9),(132299,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132299,37.38,0.09,299,61900,70,NULL,NULL,'UGC 10012',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132300,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132300,38.15,0.46,427,61901,70,NULL,NULL,'2MASX J15445937-0120047',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.247333,-1.33458,0.349,NULL,45584197649,712253088,11128954,18.2),(132301,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132301,35.13,0.49,106,61902,75,NULL,'IR','ESO 515- G 006',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'14.40',0.2,'S...',NULL,NULL,NULL,NULL,1,236.2480417,-25.26003,0.813,NULL,47115356485,736177445,11502772,14.4),(132302,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132302,35.55,0.6,129,61902,NULL,NULL,'Malmquist cor.','ESO 515- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132303,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132303,35.62,0.58,133,61902,NULL,NULL,NULL,'ESO 515- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132304,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132304,35.66,0.2,136,61902,74.4,NULL,NULL,'ESO 515- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132305,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132305,37.38,0.09,299,61903,70,NULL,NULL,'2MASX J15445972+3559174',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000146,NULL,'18.3g',0.14,NULL,'Group member',NULL,NULL,NULL,1,236.248917,35.98814,0.041,NULL,59891823876,935809748,14622027,18.3),(132306,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132306,36.58,0.46,207,61904,70,NULL,NULL,'SDSS J154459.98+535016.9',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,236.2499583,53.83803,0.017,NULL,59669139022,932330297,14567660,17.5),(132307,'BCG','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132307,37.47,0.35,292,61905,60,NULL,NULL,'ABELL 2124',0.0671,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',0.000387,NULL,NULL,NULL,'I      [BM]',NULL,NULL,NULL,NULL,1,236.25,36.06611,0.053,NULL,59880523969,935633187,14619268,NULL),(132308,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132308,35.48,0.61,125,61906,70,NULL,NULL,'2MASX J15450006-1530175',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,236.250333,-15.50494,0.449,NULL,46599813418,728122084,11376907,15.3),(132309,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132309,36.3,0.46,182,61907,70,NULL,NULL,'2MASX J15450153+3558174',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00006,NULL,'17.0g',0.22,NULL,'Group member',NULL,NULL,NULL,1,236.256333,35.97158,0.041,NULL,59891824048,935809750,14622027,17),(132310,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132310,37.55,0.46,324,61908,70,NULL,NULL,'SDSS J154502.32+041328.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.6g',0.09,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.2597083,4.22453,0.169,NULL,56616229472,884628585,13822321,18.6),(132311,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132311,36.47,0.46,197,61909,70,NULL,NULL,'2MASX J15450264+3920394',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.260833,39.34425,0.045,NULL,59877933480,935592710,14618636,17.2),(132312,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132312,37.38,0.09,299,61910,70,NULL,NULL,'2MASX J15450338+3610564',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00009,NULL,'17.0g',0.24,NULL,'Group member',NULL,NULL,NULL,1,236.264041667,36.18225,0.053,NULL,59880528552,935633258,14619269,17),(132313,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132313,37.38,0.09,299,61911,70,NULL,NULL,'2MASX J15450346+3610034',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'15.21',0.3,NULL,'Group member',NULL,NULL,NULL,1,236.264583,36.16753,0.053,NULL,59880528481,935633257,14619269,15.21),(132314,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132314,36.9,0.33,240,61912,70,NULL,NULL,'2MASX J15450413+1658510',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.267083333,16.98083,0.049,NULL,59433161619,928643150,14510049,17.7),(132315,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132315,38.34,0.46,465,61913,70,NULL,NULL,'SDSS J154505.15+054901.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,236.2715,5.81703,0.129,NULL,56615286813,884613856,13822091,18.4),(132316,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132316,37.38,0.09,299,61914,70,NULL,NULL,'SDSS J154505.68+360655.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000097,NULL,'18.1g',0.14,NULL,'Group member',NULL,NULL,NULL,1,236.273666667,36.11547,0.053,NULL,59880536581,935633384,14619271,18.1),(132317,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132317,36.37,0.46,188,61915,70,NULL,NULL,'2MASX J15450639+5315285',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000169,NULL,'16.0g',0.44,'E0',NULL,NULL,NULL,NULL,1,236.2767083,53.25797,0.009,NULL,59668778179,932324659,14567572,16),(132318,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132318,37.38,0.09,299,61916,70,NULL,NULL,'2MASX J15450724+3605273',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000113,NULL,'17.3g',0.21,NULL,'Group member',NULL,NULL,NULL,1,236.2802917,36.09078,0.053,NULL,59880524434,935633194,14619268,17.3),(132319,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132319,36.13,0.66,168,61917,70,NULL,NULL,'2MASX J15450789-1631515',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.09',0.2,NULL,NULL,NULL,NULL,NULL,1,236.282833,-16.53125,0.365,NULL,46600580905,728134076,11377094,16.09),(132320,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132320,37.69,0.33,345,61918,70,NULL,NULL,'2MASX J15450929+4817094',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000179,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.2887917,48.28594,0.089,NULL,59724375364,933193365,14581146,17.7),(132321,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132321,34.91,0.46,96,61919,70,NULL,NULL,'CGCG 166-049',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000167,NULL,'14.9g',0.65,'AGN',NULL,NULL,NULL,NULL,1,236.290083333,26.50611,0.149,NULL,59873127613,935517618,14617462,14.9),(132322,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132322,37.69,0.33,345,61920,70,NULL,NULL,'2MASX J15451060+4818284',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,236.294125,48.30794,0.097,NULL,59724375664,933193369,14581146,17.7),(132323,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132323,33.01,NULL,39.9,61921,NULL,NULL,'Dipole','ESO 099- G 008',NULL,'2010Ap&SS.325..163P',2010,1,2.8,'Star superposed.','G',0.000027,NULL,'15.5',0.21,'Scd;high incl',NULL,NULL,NULL,NULL,1,236.297167,-66.29214,NULL,NULL,45056775886,704012123,11000189,15.5),(132324,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132324,33.01,NULL,39.9,61921,NULL,NULL,'Dipole + Quadrupole','ESO 099- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132325,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132325,33.01,NULL,40,61921,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 099- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132326,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132326,37.48,0.46,314,61922,70,NULL,NULL,'2MASX J15451188+5212304',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00008,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,236.2995,52.20847,0.029,NULL,59718034143,933094283,14579598,16.5),(132327,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132327,36.42,0.58,192,61923,70,NULL,NULL,'2MASX J15451412-1736485',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,236.308791667,-17.61342,0.429,NULL,46602209884,728159529,11377492,14.9),(132328,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132328,36.61,0.46,210,61924,70,NULL,NULL,'2MASX J15451433+3541519',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000097,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,236.309583,35.69783,0.045,NULL,59892030048,935812969,14622077,16.3),(132329,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132329,37.38,0.09,299,61925,70,NULL,NULL,'SDSS J154514.78+362423.9',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000158,NULL,'18.6g',0.12,NULL,'Group member',NULL,NULL,NULL,1,236.311667,36.40664,0.049,NULL,59880731494,935636429,14619319,18.6),(132330,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132330,37.53,0.46,321,61926,70,NULL,NULL,'2MASX J15451484+0053542',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000062,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,236.311875,0.89844,0.293,NULL,56607243697,884488182,13820127,18.1),(132331,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132331,37.95,0.46,389,61927,70,NULL,NULL,'2MASX J15451507+4849234',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000182,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,236.312833,48.82331,0.089,NULL,59726396454,933224944,14581639,17.5),(132332,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132332,38.15,0.33,428,61928,70,NULL,NULL,'2MASX J15451517+0609584',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.3132917,6.16617,0.117,NULL,56623421766,884740965,13824077,17.7),(132333,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132333,37.38,0.09,299,61929,70,NULL,NULL,'SDSS J154515.64+360101.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000093,NULL,'18.2g',0.11,NULL,'Group member',NULL,NULL,NULL,1,236.3152083,36.01717,0.053,NULL,59891814145,935809596,14622024,18.2),(132334,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132334,38.15,0.33,428,61930,70,NULL,NULL,'2MASX J15451577+0603294',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00017,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.315833,6.05808,0.117,NULL,56615297552,884614024,13822094,18),(132335,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132335,38.25,0.46,446,61931,70,NULL,NULL,'2MASX J15451648+0955354',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,236.318791667,9.92653,0.133,NULL,56606076455,884469944,13819842,17.2),(132336,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132336,37.95,0.46,390,61932,70,NULL,NULL,'SDSS J154520.02+075103.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.333417,7.85094,0.065,NULL,56595342326,884302223,13817222,18.3),(132337,'IRAS','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132337,35.68,0.8,137,61933,75,NULL,'CF, r','UGC 10011',NULL,'1997ApJS..109..333W',1997,1,1.07,NULL,'G',0.000033,NULL,'15.4g',0.39,'Sbc',NULL,NULL,NULL,NULL,1,236.34,25.44369,0.157,NULL,59873328666,935520760,14617511,15.4),(132338,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132338,35.53,0.38,128,61933,75,NULL,'CF, r, raw','UGC 10011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132339,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132339,35.69,0.38,138,61933,75,NULL,'CF, r, inv','UGC 10011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132340,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132340,35.75,0.38,141,61933,75,NULL,'CF, r, cor','UGC 10011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132341,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132341,36,0.2,158,61933,74.4,NULL,NULL,'UGC 10011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132342,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132342,37.12,0.46,265,61934,70,NULL,NULL,'2MASX J15452221+0654164',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000186,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,236.3424583,6.90456,0.057,NULL,56626578110,884790282,13824848,16.7),(132343,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132343,38.27,0.46,450,61935,70,NULL,NULL,'2MASX J15452289+0734194',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000179,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,236.345417,7.57208,0.049,NULL,56626568870,884790138,13824845,17.1),(132344,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132344,36.38,0.46,189,61936,70,NULL,NULL,'2MASX J15452304+1322020',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',NULL,NULL,'16.97',0.43,NULL,NULL,NULL,NULL,NULL,1,236.345875,13.36714,0.081,NULL,56523793044,883184266,13799754,16.97),(132345,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132345,35.12,0.2,106,61937,74.4,NULL,NULL,'CGCG 136-068',NULL,'2013AJ....146...86T',2013,1,0.76,NULL,'G',0.000067,NULL,'15.3g',0.46,'SBb',NULL,NULL,NULL,NULL,1,236.347,24.50678,0.157,NULL,59398972447,928108944,14501702,15.3),(132346,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132346,36.33,0.21,184,61938,70,NULL,NULL,'2MASX J15452337+0836094',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000113,NULL,'16.44',0.39,NULL,NULL,NULL,NULL,NULL,1,236.3472917,8.60272,0.057,NULL,56595620789,884306574,13817290,16.44),(132347,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132347,37.88,0.46,377,61939,70,NULL,NULL,'2MASX J15452377+0017392',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000094,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,236.349167,0.29436,0.277,NULL,56606378578,884474665,13819916,17.2),(132348,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132348,37.58,0.46,327,61940,70,NULL,NULL,'2MASX J15452411+4725010',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000188,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,236.349958333,47.41767,0.037,NULL,59719655603,933119618,14579994,16.7),(132349,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132349,38.02,0.46,401,61941,70,NULL,NULL,'2MASX J15452515+2236589',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,236.354917,22.61631,0.169,NULL,59397624619,928087884,14501373,18.3),(132350,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132350,38.18,0.46,433,61942,70,NULL,NULL,'2MASX J15452677+3200060',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000178,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.3615,32.00175,0.081,NULL,59921790551,936277977,14629343,17.8),(132351,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132351,38.22,0.46,441,61943,70,NULL,NULL,'2MASX J15452684+1434590',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.3619583,14.58308,0.089,NULL,56536999563,883390618,13802978,17.5),(132352,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132352,37.33,0.46,293,61944,70,NULL,NULL,'2MASX J15452716+0012542',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000068,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.363167,0.21511,0.277,NULL,56606387983,884474812,13819918,18.2),(132353,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132353,36.34,0.78,185,61945,70,NULL,NULL,'2MASX J15452741-2224556',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,236.3642083,-22.41547,0.729,NULL,46584991340,727890489,11373288,16.1),(132354,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132354,36.69,0.46,217,61946,70,NULL,NULL,'2MASX J15452762+0806478',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000182,NULL,'16.0g',0.4,NULL,NULL,NULL,NULL,NULL,1,236.364917,8.11342,0.065,NULL,56595568666,884305760,13817277,16),(132355,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132355,37.02,0.46,253,61947,70,NULL,NULL,'2MASX J15452865+3505550',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,236.369333,35.09844,0.057,NULL,59892173728,935815214,14622112,17.3),(132356,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132356,36.9,0.33,240,61948,70,NULL,NULL,'2MASX J15453091+1657170',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,236.378917,16.95472,0.061,NULL,59432689558,928635774,14509933,16.2),(132357,'L(H{beta})-{sigma}','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132357,46.03,NULL,1608,61949,74.3,NULL,NULL,'WISP 138_0173',2.158,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,236.379291667,9.55833,0.105,NULL,56602829795,884419215,13819050,NULL),(132358,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132358,38.23,0.46,443,61950,70,NULL,NULL,'SDSS J154531.17-000909.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000074,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,236.379875,-0.15256,0.261,NULL,45516591902,711196748,11112449,18.7),(132359,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132359,37.99,0.46,396,61951,70,NULL,NULL,'2MASX J15453136+2543213',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.3807083,25.72256,0.161,NULL,59873305437,935520397,14617506,18.1),(132360,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132360,38.35,0.46,467,61952,70,NULL,NULL,'2MASX J15453141+2800493',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,236.3809583,28.01375,0.073,NULL,59916855747,936200871,14628138,17.5),(132361,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132361,37.38,0.09,299,61953,70,NULL,NULL,'2MASX J15453171+3613041',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00008,NULL,'17.0g',0.25,NULL,'Group member',NULL,NULL,NULL,1,236.382125,36.21761,0.053,NULL,59880747320,935636676,14619323,17),(132362,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132362,38.02,0.46,402,61954,70,NULL,NULL,'2MASX J15453218+1401120',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.384,14.01997,0.097,NULL,56536382144,883380971,13802827,17.7),(132363,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132363,38.38,0.46,474,61955,70,NULL,NULL,'2MASX J15453238+3946571',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00019,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.384833,39.78269,0.041,NULL,59794001694,934281276,14598144,18),(132364,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132364,36.08,0.2,164,61956,74.4,NULL,NULL,'UGC 10019',NULL,'2013AJ....146...86T',2013,1,1.12,NULL,'G',0.000033,NULL,'15.2g',0.36,'Sb','Group member',NULL,NULL,NULL,1,236.389708333,30.14742,0.077,NULL,59922476254,936288691,14629510,15.2),(132365,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132365,36.9,0.46,239,61957,70,NULL,NULL,'2MASX J15453492+4426099',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000233,NULL,'15.8g',0.45,'E0',NULL,NULL,NULL,NULL,1,236.395583333,44.43606,0.029,NULL,59693202377,932706287,14573535,15.8),(132366,'L(H{beta})-{sigma}','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132366,46.15,NULL,1595,61958,74.3,NULL,NULL,'WISP 138_0160',2.264,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,236.4012083,9.57408,0.105,NULL,56602832288,884419254,13819050,NULL),(132367,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132367,37.54,0.46,322,61959,70,NULL,NULL,'2MASX J15453688+0257168',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000073,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,236.403875,2.95467,0.257,NULL,56609028200,884516065,13820563,18),(132368,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132368,37.36,0.46,297,61960,70,NULL,NULL,'2MASX J15453743+2400403',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,236.4060417,24.01119,0.153,NULL,59399030979,928109859,14501716,17.8),(132369,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132369,35.98,0.6,157,61961,70,NULL,NULL,'2MASX J15453750-1654207',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.06',0.3,NULL,NULL,NULL,NULL,NULL,1,236.40625,-16.90594,0.389,NULL,46602515344,728164302,11377567,16.06),(132370,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132370,38.05,0.33,408,61962,70,NULL,NULL,'2MASX J15453794+1830594',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000167,NULL,'17.0g',0.31,NULL,NULL,NULL,NULL,NULL,1,236.408083333,18.51639,0.077,NULL,59446406446,928850100,14513282,17),(132371,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132371,37.14,0.46,267,61963,70,NULL,NULL,'SDSS J154538.83+245257.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.411791667,24.88256,0.153,NULL,59869773444,935465210,14616643,17.9),(132372,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132372,34.62,0.2,84,61964,74.4,NULL,NULL,'UGC 10015',NULL,'2013AJ....146...86T',2013,1,0.86,NULL,'G',0.000017,NULL,'16.2g',0.33,'Sdm:',NULL,NULL,NULL,NULL,1,236.413458333,21.01953,0.121,NULL,59447175856,928862122,14513470,16.2),(132373,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132373,36.12,0.51,168,61965,70,NULL,NULL,'2MASX J15453931-1701517',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000093,NULL,'15.64',NULL,NULL,NULL,NULL,NULL,NULL,1,236.413833,-17.031,0.433,NULL,46602485248,728163832,11377559,15.64),(132374,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132374,32.86,0.4,37.3,61966,75,NULL,NULL,'IC 4582',NULL,'2008Ap.....51..336K',2008,1,1.3,'Multiple SDSS entries describe this object.','G',0.00003,NULL,'13.7B',0.3,'S?',NULL,NULL,NULL,NULL,1,236.414375,28.08867,0.073,NULL,59916882763,936201293,14628145,13.7),(132375,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132375,33.06,0.4,41,61966,NULL,NULL,'mean','IC 4582',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132376,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132376,33.38,0.47,47.5,61966,NULL,NULL,'H','IC 4582',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132377,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132377,33.42,0.45,48.2,61966,NULL,NULL,'K','IC 4582',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132378,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132378,33.49,0.46,49.9,61966,NULL,NULL,'J','IC 4582',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132379,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132379,33.69,0.49,54.7,61966,75,NULL,'IR','IC 4582',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132380,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132380,38.3,0.46,457,61967,70,NULL,NULL,'SDSS J154539.51+222308.0',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000166,NULL,'18.7g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.414625,22.38558,0.177,NULL,59396751451,928074241,14501160,18.7),(132381,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132381,36.43,0.46,193,61968,70,NULL,NULL,'2MASX J15453978+2037534',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000161,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.41575,20.63158,0.145,NULL,59447913655,928873650,14513650,17),(132382,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132382,36.54,0.46,203,61969,70,NULL,NULL,'2MASX J15453996+1503590',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'16.4r',0.2,NULL,NULL,NULL,NULL,NULL,1,236.416625,15.06642,0.093,NULL,56536298265,883379660,13802807,16.4),(132383,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132383,38.05,0.33,408,61970,70,NULL,NULL,'2MASX J15454041+1829204',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,236.4184583,18.48892,0.077,NULL,59446406095,928850095,14513282,17.8),(132384,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132384,36.55,0.46,205,61971,70,NULL,NULL,'2MASX J15454072+3329080',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,236.419541667,33.48561,0.065,NULL,59889001072,935765641,14621338,17.5),(132385,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132385,36.65,0.46,214,61972,70,NULL,NULL,'2MASX J15454092+1453040',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,236.4204583,14.88458,0.097,NULL,56536280181,883379377,13802802,16.7),(132386,'GRB','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132386,45,0.51,4020,61973,69.7,NULL,'Calibrated','HG 060418',1.49,'2009MNRAS.400..775C',2009,1,NULL,NULL,'G',NULL,NULL,'20.2R',NULL,'Swift',NULL,NULL,NULL,NULL,1,236.428333,-3.64058,0.477,NULL,45599343435,712489741,11132652,20.2),(132387,'GRB','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132387,45.09,0.47,4190,61973,69.7,NULL,'Fiducial','HG 060418',1.49,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132388,'GRB','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132388,45.33,0.54,4680,61973,72,NULL,NULL,'HG 060418',1.49,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132389,'GRB','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132389,45.43,1.6,4900,61973,100,NULL,NULL,'HG 060418',1.49,'2009EPJC...63..139W',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132390,'GRB','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132390,45.45,0.56,4940,61973,70,NULL,NULL,'HG 060418',1.49,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132391,'GRB','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132391,45.45,0.63,4940,61973,NULL,NULL,NULL,'HG 060418',1.49,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132392,'GRB','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132392,45.6,1.54,5290,61973,69.7,NULL,'Calibrated','HG 060418',1.49,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132393,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132393,36.32,NULL,184,61974,NULL,NULL,'B, Hubble-type-TF','CGCG 136-071',NULL,'2005Ap&SS.298..577R',2005,1,0.55,NULL,'G',0.000063,NULL,'15.3g',0.46,'Irr            HII',NULL,NULL,NULL,NULL,1,236.42975,22.87847,0.161,NULL,59397426122,928084783,14501324,15.3),(132394,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132394,37.41,0.46,304,61975,70,NULL,NULL,'2MASX J15454385+3611491',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000103,NULL,'16.4g',0.32,NULL,'Group member',NULL,NULL,NULL,1,236.43275,36.19692,0.053,NULL,59880750487,935636726,14619323,16.4),(132395,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132395,37.38,0.09,299,61976,70,NULL,NULL,'2MASX J15454384+3607491',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000077,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.432833,36.13017,0.053,NULL,59880736533,935636508,14619320,16.7),(132396,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132396,31.58,0.4,20.7,61977,75,NULL,'B','UGC 10014',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000013,NULL,'14.5',1.2,'Im',NULL,NULL,NULL,NULL,1,236.4332083,12.51058,0.137,NULL,56523740977,883183452,13799741,14.5),(132397,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132397,32.95,0.4,38.9,61977,NULL,NULL,NULL,'UGC 10014',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132398,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132398,32.62,0.4,33.4,61978,75,NULL,'B','UGC 10020',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.000013,NULL,'14.8g',2.1,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,236.4354583,20.56042,0.145,NULL,59447959168,928874362,14513661,14.8),(132399,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132399,35.44,0.52,122,61979,70,NULL,NULL,'CGCG 022-035',NULL,'2014MNRAS.445.2677S',2014,1,0.79,NULL,'G',0.00015,NULL,'15.6g',0.31,'S0/a',NULL,NULL,NULL,NULL,1,236.4372083,-2.10469,0.417,NULL,45587442148,712303783,11129746,15.6),(132400,'Tully est','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132400,31.3,0.8,18.2,61980,75,NULL,NULL,'UGC 10031',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.000017,NULL,'17.',1.4,'Sm:','Group member',NULL,NULL,NULL,1,236.439167,61.55583,0.033,NULL,57744118983,902251859,14097685,17),(132401,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132401,36.81,0.46,231,61981,70,NULL,NULL,'SDSS J154545.75+143657.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.440667,14.61606,0.089,NULL,56537046211,883391347,13802989,17.9),(132402,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132402,35.68,0.49,137,61982,75,NULL,'IR','CGCG 078-062',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000193,NULL,'15.4',0.2,NULL,NULL,NULL,NULL,NULL,1,236.440875,9.07975,0.109,NULL,56595190918,884299858,13817185,15.4),(132403,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132403,34.16,0.49,68,61983,75,NULL,'IR','CGCG 050-093',NULL,'2011yCatp016004901K',2011,1,1.12,NULL,'G',0.000014,NULL,'15.1g',0.29,'S              LLIRG','Group member',NULL,NULL,NULL,1,236.4412917,2.40983,0.257,NULL,56609216246,884519003,13820609,15.1),(132404,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132404,37.53,0.46,321,61984,70,NULL,NULL,'SDSS J154546.39+000358.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000075,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,236.4432917,0.06636,0.261,NULL,56472170439,882377663,13787150,18.6),(132405,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132405,37.65,0.46,339,61985,70,NULL,NULL,'SDSS J154546.46+294037.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000125,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.443583,29.67717,0.077,NULL,59924474966,936319921,14629998,18.5),(132406,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132406,36.99,0.46,250,61986,70,NULL,NULL,'SDSS J154547.03+052113.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.446,5.35375,0.109,NULL,56618292127,884660814,13822825,17.7),(132407,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132407,38.74,0.46,560,61987,70,NULL,NULL,'2MASX J15454706+2510243',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000137,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.44625,25.17361,0.153,NULL,59873213235,935518956,14617483,17.3),(132408,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132408,36.76,0.46,225,61988,70,NULL,NULL,'2MASX J15454716+3343500',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00018,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,236.446541667,33.73056,0.061,NULL,59888912024,935764250,14621316,16.6),(132409,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132409,37.51,0.46,318,61989,70,NULL,NULL,'2MASX J15454734+3912142',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000177,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,236.447333,39.204,0.045,NULL,59878110602,935595478,14618679,17),(132410,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132410,37.38,0.09,299,61990,70,NULL,NULL,'2MASX J15454873+3557157',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000097,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.4529583,35.95442,0.049,NULL,59891926989,935811359,14622052,17.7),(132411,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132411,38.04,0.46,405,61991,70,NULL,NULL,'2MASX J15454892+4252130',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,236.453833333,42.87036,0.061,NULL,59679942604,932499103,14570298,17.8),(132412,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132412,38.06,0.46,409,61992,70,NULL,NULL,'2MASX J15454938+2759573',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.45575,27.99936,0.073,NULL,59916865432,936201022,14628140,17.8),(132413,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132413,38.5,0.46,500,61993,70,NULL,NULL,'2MASX J15454968+1611470',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,236.45725,16.19656,0.061,NULL,59432134997,928627109,14509798,17.6),(132414,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132414,38.54,0.27,512,61994,70,NULL,NULL,'SDSS J154551.37+323221.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.464083,32.53936,0.073,NULL,59889297639,935770275,14621410,18.4),(132415,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132415,37.52,0.46,320,61995,70,NULL,NULL,'2MASX J15455141+2744073',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,236.46425,27.73533,0.061,NULL,59916826867,936200419,14628131,17.2),(132416,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132416,37.24,0.46,281,61996,70,NULL,NULL,'2MASX J15455205+4622130',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000175,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,236.466833,46.37033,0.037,NULL,59687199970,932612499,14572070,17),(132417,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132417,38,0.46,398,61997,70,NULL,NULL,'2MASX J15455427+0619339',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000142,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.476125,6.32606,0.125,NULL,56626811379,884793927,13824905,18),(132418,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132418,38.54,0.27,512,61998,70,NULL,NULL,'SDSS J154554.71+323259.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000173,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.4779583,32.54994,0.073,NULL,59889341501,935770960,14621421,18.4),(132419,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132419,37.48,0.46,314,61999,70,NULL,NULL,'2MASX J15455481+1741320',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,236.478375,17.69233,0.069,NULL,59432959429,928639991,14509999,17.1),(132420,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132420,38.87,0.46,594,62000,70,NULL,NULL,'SDSS J154554.90+442740.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000145,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.4787917,44.46136,0.029,NULL,59693182209,932705972,14573530,18.4),(132421,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132421,37.24,0.46,280,62001,70,NULL,NULL,'2MASX J15455638+4302520',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,236.4847917,43.04783,0.049,NULL,59679761982,932496280,14570254,16.9),(132422,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132422,36.35,0.46,186,62002,70,NULL,NULL,'2MASX J15455643+4543290',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',NULL,NULL,'16.48',0.51,NULL,NULL,NULL,NULL,NULL,1,236.4850417,45.72469,0.033,NULL,59690088077,932657626,14572775,16.48),(132423,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132423,37.39,0.46,300,62003,70,NULL,NULL,'2MASX J15455688+0558428',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.4870417,5.97858,0.117,NULL,56618137471,884658397,13822787,18),(132424,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132424,33.96,0.56,62.1,62004,70,NULL,NULL,'ESO 042- G 008',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00007,NULL,'15.1b',0.8,'SB0',NULL,NULL,NULL,NULL,1,236.4939583,-77.10633,0.349,NULL,44233917498,691154960,10799296,15.1),(132425,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132425,35.97,0.46,156,62005,70,NULL,NULL,'2MASX J15455874+1917435',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000162,NULL,'16.94',0.3,NULL,NULL,NULL,NULL,NULL,1,236.494875,19.29539,0.117,NULL,59449853022,928903953,14514124,16.94),(132426,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132426,37.6,0.46,331,62006,70,NULL,NULL,'2MASX J15455963+5206481',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00008,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,236.4985417,52.11331,0.021,NULL,59717999749,933093746,14579589,16.9),(132427,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132427,36.94,0.46,244,62007,70,NULL,NULL,'2MASX J15455979+2419593',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.499333,24.33314,0.153,NULL,59399194141,928112408,14501756,17.1),(132428,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132428,37.52,0.46,320,62008,70,NULL,NULL,'2MASXi J1546008+363402',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.5035,36.56742,0.045,NULL,59880687150,935635736,14619308,17.7),(132429,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132429,37.41,0.46,303,62009,70,NULL,NULL,'2MASX J15460101+2832340',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00019,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,236.5042083,28.54289,0.077,NULL,59916779550,936199680,14628120,16.4),(132430,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132430,37.87,0.46,375,62010,70,NULL,NULL,'2MASX J15460301+1221588',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,236.5125417,12.36631,0.157,NULL,56523530842,883180169,13799690,17.3),(132431,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132431,37.66,0.46,341,62011,70,NULL,NULL,'2MASX J15460321+3217058',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,236.513416667,32.28492,0.077,NULL,59921468791,936272949,14629264,17.6),(132432,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132432,37.38,0.09,299,62012,70,NULL,NULL,'2MASX J15460361+3556563',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000087,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,236.5152083,35.94894,0.049,NULL,59891940417,935811569,14622055,17.5),(132433,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132433,37.9,0.33,380,62013,70,NULL,NULL,'2MASX J15460597+3658343',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.525,36.97608,0.037,NULL,59881423056,935647235,14619488,17.5),(132434,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132434,37.95,0.46,388,62014,70,NULL,NULL,'2MASX J15460671+1827057',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,236.528083333,18.45153,0.077,NULL,59446453603,928850837,14513294,17.3),(132435,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132435,37.62,0.46,334,62015,70,NULL,NULL,'2MASX J15460703+3027158',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00014,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.529208333,30.45456,0.077,NULL,59922998112,936296845,14629638,17.9),(132436,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132436,37.35,0.23,295,62016,70,NULL,NULL,'2MASX J15460758+0830247',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000172,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,236.531625,8.50681,0.057,NULL,56595688198,884307628,13817306,16.7),(132437,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132437,35.95,0.67,155,62017,70,NULL,NULL,'2MASX J15460848-1817513',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.67',NULL,NULL,NULL,NULL,NULL,NULL,1,236.535417,-18.29767,0.497,NULL,46599300767,728114074,11376782,15.67),(132438,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132438,32.31,NULL,29,62018,72,NULL,NULL,'UGC 10023',NULL,'2014Ap.....57..457K',2014,1,1.05,NULL,'G',0.000017,NULL,'15.5g',0.52,'Im',NULL,NULL,NULL,NULL,1,236.5405,6.89847,0.057,NULL,56627094010,884798343,13824974,15.5),(132439,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132439,32.36,0.2,29.7,62019,74.4,NULL,NULL,'UGC 10023',NULL,'2013AJ....146...86T',2013,1,1.05,NULL,'G',0.000017,NULL,'15.5g',0.52,'Im',NULL,NULL,NULL,NULL,1,236.5405,6.89847,0.057,NULL,56627094010,884798343,13824974,15.5),(132440,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132440,36.92,0.33,242,62020,70,NULL,NULL,'2MASX J15461019+0846017',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,236.542417,8.76719,0.037,NULL,56595780132,884309064,13817329,17.2),(132441,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132441,37.35,0.23,295,62021,70,NULL,NULL,'2MASX J15461034+0826457',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000175,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,236.543125,8.44594,0.057,NULL,56595682648,884307541,13817305,16.6),(132442,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132442,35.59,0.46,131,62022,70,NULL,NULL,'CGCG 136-072',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.00018,NULL,'15.3g',0.44,NULL,NULL,NULL,NULL,NULL,1,236.544583,21.06636,0.137,NULL,59447142352,928861599,14513462,15.3),(132443,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132443,37.32,0.46,291,62023,70,NULL,NULL,'2MASX J15461207+1131007',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,236.550167,11.51678,0.113,NULL,56603381570,884427837,13819184,17),(132444,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132444,38.56,0.46,516,62024,70,NULL,NULL,'SDSS J154612.09+124844.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.550417,12.81247,0.117,NULL,56523567401,883180740,13799699,18.3),(132445,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132445,37.05,0.46,257,62025,70,NULL,NULL,'2MASX J15461569+3239458',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,236.5654583,32.66267,0.073,NULL,59889338621,935770915,14621420,17.1),(132446,'Sosies','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132446,33.42,0.13,48.3,62026,NULL,NULL,NULL,'NGC 5990',NULL,'2002A&A...393...57T',2002,1,1.5,NULL,'G',0.000017,NULL,'13.30',0.9,'(R\')Sa pec?;Sy2LIRG','Group member',NULL,NULL,'Sy 2',1,236.568166667,2.41542,0.293,NULL,56609095162,884517111,13820579,13.3),(132447,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132447,33.02,0.45,40.2,62026,NULL,NULL,'K','NGC 5990',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132448,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132448,33.16,0.47,42.8,62026,NULL,NULL,'H','NGC 5990',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132449,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132449,33.25,0.46,44.6,62026,NULL,NULL,'J','NGC 5990',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132450,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132450,33.47,0.4,49.3,62026,NULL,NULL,'mean','NGC 5990',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132451,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132451,37.45,0.46,310,62027,70,NULL,NULL,'SDSS J154617.65+010224.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000065,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,236.5735417,1.04008,0.277,NULL,56607372527,884490195,13820159,18.2),(132452,'IRAS','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132452,34.34,0.8,73.9,62028,75,NULL,'CF, r','UGC 10026',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'15.15',0.4,'Scd:',NULL,NULL,NULL,NULL,1,236.573667,10.75853,0.113,NULL,56603866045,884435406,13819303,15.15),(132453,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132453,34.12,0.2,66.7,62028,74.4,NULL,NULL,'UGC 10026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132454,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132454,34.26,0.38,71.2,62028,75,NULL,'CF, r, raw','UGC 10026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132455,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132455,34.29,0.38,72.2,62028,75,NULL,'CF, r, inv','UGC 10026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132456,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132456,34.4,0.38,75.7,62028,75,NULL,'CF, r, cor','UGC 10026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132457,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132457,37.35,0.23,295,62029,70,NULL,NULL,'2MASX J15461770+0816237',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000161,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.573916667,8.27322,0.069,NULL,56595444555,884303821,13817247,17.3),(132458,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132458,38.1,0.23,418,62030,70,NULL,NULL,'SDSS J154617.74+292449.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000132,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.573916667,29.41378,0.081,NULL,59924941620,936327212,14630112,18.5),(132459,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132459,37.87,0.33,375,62031,70,NULL,NULL,'2MASX J15461802+1423328',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,236.575166667,14.39244,0.049,NULL,56536532855,883383325,13802864,17.2),(132460,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132460,37.03,0.46,255,62032,70,NULL,NULL,'SDSS J154618.67+370849.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000146,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,236.5777917,37.14694,0.033,NULL,59881435742,935647433,14619491,18.2),(132461,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132461,37.01,0.46,253,62033,70,NULL,NULL,'2MASX J15461983+0146538',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.5825417,1.78158,0.281,NULL,56609830566,884528602,13820759,17.5),(132462,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132462,37,0.46,251,62034,70,NULL,NULL,'2MASX J15462223-0212331',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00018,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,236.592625,-2.20914,0.417,NULL,45587709603,712307962,11129811,17.2),(132463,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132463,36.87,0.46,237,62035,70,NULL,NULL,'2MASX J15462241+0808537',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000186,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,236.5935417,8.14825,0.069,NULL,56625622707,884775354,13824614,16.6),(132464,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132464,38.23,0.46,442,62036,70,NULL,NULL,'2MASX J15462287+0554068',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000171,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.59525,5.90194,0.117,NULL,56617101696,884642214,13822534,18),(132465,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132465,38.42,0.19,483,62037,70,NULL,NULL,'SDSS J154622.86+032515.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000089,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,236.5952917,3.42094,0.249,NULL,56620893802,884701465,13823460,18.6),(132466,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132466,37.82,0.46,366,62038,70,NULL,NULL,'2MASX J15462288+1845327',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000166,NULL,'16.9g',0.29,'E',NULL,NULL,NULL,NULL,1,236.595417,18.75897,0.093,NULL,59446608442,928853256,14513332,16.9),(132467,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132467,38.54,0.27,512,62039,70,NULL,NULL,'2MASX J15462296+3235454',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,236.595625,32.59578,0.073,NULL,59889346257,935771035,14621422,16.7),(132468,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132468,35.59,0.46,131,62040,70,NULL,NULL,'2MASX J15462324+0221338',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000079,NULL,'16.3g',0.34,'S0',NULL,NULL,NULL,NULL,1,236.596833333,2.35956,0.293,NULL,56609551476,884524241,13820691,16.3),(132469,'IRAS','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132469,34.12,0.8,66.8,62041,75,NULL,'HMCL, I','ESO 136- G 002',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000024,NULL,'15.0',0.4,'S;flaring disk?',NULL,NULL,NULL,NULL,1,236.598,-62.18997,NULL,NULL,44863832580,700997384,10953084,15),(132470,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132470,33.16,0.4,42.9,62041,75,NULL,'HMCL, I, raw','ESO 136- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132471,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132471,33.25,0.4,44.7,62041,75,NULL,'HMCL, I, inv','ESO 136- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132472,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132472,33.42,0.4,48.3,62041,75,NULL,'HMCL, I, cor','ESO 136- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132473,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132473,34.04,0.49,64.2,62041,75,NULL,'IR','ESO 136- G 002',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132474,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132474,36.35,0.46,186,62042,70,NULL,NULL,'2MASX J15462363+4402157',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000178,NULL,'15.9g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,236.5985,44.03772,0.013,NULL,59692490654,932695166,14573361,15.9),(132475,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132475,32.06,0.2,25.8,62043,74.4,NULL,NULL,'UGC 10025',NULL,'2013AJ....146...86T',2013,1,1.15,NULL,'G',0.000007,NULL,'17.',0.12,'Sdm',NULL,NULL,NULL,NULL,1,236.6009583,2.84422,0.265,NULL,56609198278,884518723,13820605,17),(132476,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132476,32.59,NULL,32.9,62043,72,NULL,NULL,'UGC 10025',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132477,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132477,32.84,NULL,36.9,62043,NULL,NULL,NULL,'UGC 10025',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132478,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132478,32.86,NULL,37.3,62043,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132479,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132479,32.88,NULL,37.7,62043,NULL,NULL,'Dipole + Quadrupole','UGC 10025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132480,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132480,32.88,NULL,37.8,62043,NULL,NULL,'Dipole','UGC 10025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132481,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132481,38.42,0.19,483,62044,70,NULL,NULL,'2MASX J15462459+0325008',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,'FoF','17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.602333,3.41686,0.249,NULL,56620893737,884701464,13823460,17.5),(132482,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132482,35.73,0.33,140,62045,70,NULL,NULL,'CGCG 166-054 NED01',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.5g',0.17,'S0^-',NULL,NULL,NULL,NULL,1,236.602417,30.267,0.077,NULL,59922492808,936288950,14629514,17.5),(132483,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132483,37.75,0.46,354,62046,70,NULL,NULL,'2MASX J15462513+0414398',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.1,NULL,NULL,NULL,NULL,NULL,1,236.6047917,4.24447,0.185,NULL,56620514385,884695537,13823367,18.3),(132484,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132484,33.7,NULL,55.1,62047,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10027',NULL,'2010Ap&SS.325..163P',2010,1,1.22,NULL,'G',0.000238,NULL,'16.0',0.11,'Scd',NULL,NULL,NULL,NULL,1,236.6065,4.42764,0.185,NULL,56616080865,884626263,13822285,16),(132485,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132485,33.73,NULL,55.6,62047,NULL,NULL,'Dipole + Quadrupole','UGC 10027',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132486,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132486,33.73,NULL,55.8,62047,NULL,NULL,'Dipole','UGC 10027',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132487,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132487,38.1,0.23,418,62048,70,NULL,NULL,'2MASX J15462595+2929340',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000142,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.608208333,29.493,0.081,NULL,59924415171,936318987,14629984,18.1),(132488,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132488,37.87,0.33,375,62049,70,NULL,NULL,'2MASX J15462663+1425047',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,236.6110417,14.41806,0.049,NULL,56536531712,883383308,13802864,NULL),(132489,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132489,37.22,0.46,278,62050,70,NULL,NULL,'2MASX J15462700+0815299',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.612666667,8.25811,0.069,NULL,56595393825,884303028,13817234,17.6),(132490,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132490,38.38,0.46,475,62051,70,NULL,NULL,'SDSS J154628.54+314505.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000167,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.6189583,31.75153,0.073,NULL,59921893799,936279590,14629368,18.1),(132491,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132491,37.58,0.33,328,62052,70,NULL,NULL,'2MASX J15462944+3547295',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000127,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,236.622625,35.79142,0.045,NULL,59891952056,935811750,14622058,17.1),(132492,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132492,35.54,0.2,128,62053,74.4,NULL,NULL,'CGCG 078-066',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000397,NULL,'15.7',0.3,NULL,NULL,NULL,NULL,NULL,1,236.6235,12.35178,0.137,NULL,56523549714,883180464,13799694,15.7),(132493,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132493,35.79,0.4,144,62054,NULL,NULL,'mean','CGCG 166-055',NULL,'2007A&A...465...71T',2007,1,0.99,NULL,'G',0.000063,NULL,'14.9g',0.45,'SBb',NULL,NULL,NULL,NULL,1,236.624958333,32.11728,0.081,NULL,59921526020,936273844,14629278,14.9),(132494,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132494,36.2,0.45,173,62054,NULL,NULL,'K','CGCG 166-055',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132495,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132495,36.2,0.47,173,62054,NULL,NULL,'H','CGCG 166-055',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132496,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132496,36.21,0.2,175,62054,74.4,NULL,NULL,'CGCG 166-055',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132497,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132497,35.73,0.33,140,62055,70,NULL,NULL,'2MASX J15463020+3018465',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000161,NULL,'16.1g',0.4,'S0',NULL,NULL,NULL,NULL,1,236.626,30.31281,0.077,NULL,59922497074,936289016,14629515,16.1),(132498,'Tully est','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132498,33.15,0.8,42.7,62056,75,NULL,'B','MRK 0490',NULL,'1988NBGC.C....0000T',1988,1,0.39,NULL,'G',0.000009,NULL,'15.2g',0.35,'NELG','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,236.627958333,45.99828,0.029,NULL,59690098137,932657783,14572777,15.2),(132499,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132499,37.67,0.46,341,62057,70,NULL,NULL,'2MASX J15463192+1016079',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.633208333,10.26883,0.113,NULL,56605964698,884468198,13819815,18.2),(132500,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132500,37.35,0.23,295,62058,70,NULL,NULL,'2MASX J15463212+0831369',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000201,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,236.6337917,8.52689,0.037,NULL,56595709478,884307960,13817311,16.7),(132501,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132501,37.82,0.33,367,62059,70,NULL,NULL,'2MASX J15463366+1737487',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000121,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.640375,17.63036,0.085,NULL,59432909503,928639210,14509987,17.8),(132502,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132502,38.06,0.46,410,62060,70,NULL,NULL,'2MASX J15463386+3439175',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000178,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,236.6412083,34.65497,0.061,NULL,59892267138,935816674,14622135,17.3),(132503,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132503,37.37,0.46,298,62061,70,NULL,NULL,'2MASX J15463396+2012147',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000137,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.641416667,20.20397,0.141,NULL,59447618274,928869035,14513578,17.8),(132504,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132504,37.6,0.33,331,62062,70,NULL,NULL,'2MASX J15463410+2924008',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'17.1g',0.22,'E',NULL,NULL,NULL,NULL,1,236.642125,29.40019,0.081,NULL,59924090858,936313919,14629904,17.1),(132505,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132505,37.82,0.33,367,62063,70,NULL,NULL,'2MASX J15463457+1738497',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,236.6442083,17.64731,0.085,NULL,59432909713,928639214,14509987,17.3),(132506,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132506,34.91,NULL,95.9,62064,NULL,NULL,'Dipole + Quadrupole','FGCE 1224',NULL,'2010Ap&SS.325..163P',2010,1,1.29,NULL,'G',0.000053,NULL,'16.8',0.1,'Scd',NULL,NULL,NULL,NULL,1,236.650417,-21.13194,0.693,NULL,46634468033,728663563,11385368,16.8),(132507,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132507,34.91,NULL,95.9,62064,NULL,NULL,'Dipole + Quadrupole + Octopole','FGCE 1224',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132508,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132508,34.92,NULL,96.5,62064,NULL,NULL,'Dipole','FGCE 1224',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132509,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132509,34.98,NULL,99.2,62064,NULL,NULL,NULL,'FGCE 1224',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132510,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132510,37.14,0.33,268,62065,70,NULL,NULL,'2MASX J15463669+4631587',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000202,NULL,'15.7g',0.5,'E0',NULL,NULL,NULL,NULL,1,236.652833,46.53303,0.037,NULL,59689159160,932643111,14572548,15.7),(132511,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132511,37.29,0.46,287,62066,70,NULL,NULL,'2MASX J15463693+0628399',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,236.65375,6.47775,0.133,NULL,56627013345,884797083,13824954,17.3),(132512,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132512,36.68,0.53,217,62067,70,NULL,NULL,'2MASX J15463693-0434251',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.97',NULL,NULL,NULL,NULL,NULL,NULL,1,236.6540417,-4.57364,0.529,NULL,45591040564,712360008,11130625,16.97),(132513,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132513,38.14,0.33,425,62068,70,NULL,NULL,'SDSS J154637.03+034131.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.2g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.654333,3.69217,0.217,NULL,56620766984,884699484,13823429,18.2),(132514,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132514,37.37,0.46,298,62069,70,NULL,NULL,'2MASX J15463763+3509255',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000182,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,236.656667,35.15722,0.057,NULL,59892329274,935817644,14622150,16.9),(132515,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132515,37.51,0.46,318,62070,70,NULL,NULL,'2MASX J15463765-0013141',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00009,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.656917,-0.22067,0.261,NULL,45516846518,711200726,11112511,17.2),(132516,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132516,37.58,0.33,328,62071,70,NULL,NULL,'2MASX J15463807+3547015',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00011,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,236.658833,35.78375,0.045,NULL,59891951636,935811744,14622058,17.7),(132517,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132517,38.42,0.19,483,62072,70,NULL,NULL,'2MASX J15463897+0325546',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000089,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.6622917,3.43167,0.249,NULL,56620302372,884692224,13823316,17.5),(132518,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132518,38.49,0.33,500,62073,70,NULL,NULL,'2MASX J15463908+5455296',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.663,54.92492,0,NULL,57584119578,899751868,14058622,17.8),(132519,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132519,37.93,0.46,386,62074,70,NULL,NULL,'2MASX J15463932+0815309',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.663875,8.25867,0.057,NULL,56625600986,884775015,13824609,17.1),(132520,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132520,38.42,0.19,483,62075,70,NULL,NULL,'SDSS J154641.31+031529.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000076,NULL,'18.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,236.672125,3.25831,0.261,NULL,56620392772,884693637,13823338,18.9),(132521,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132521,38.37,0.33,473,62076,70,NULL,NULL,'SDSS J154641.82+052407.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.67425,5.40217,0.109,NULL,56617142019,884642844,13822544,17.9),(132522,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132522,37.25,0.46,282,62077,70,NULL,NULL,'2MASX J15464193+1248247',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,236.674666667,12.807,0.125,NULL,56537313231,883395519,13803054,18.1),(132523,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132523,36.92,0.33,242,62078,70,NULL,NULL,'2MASX J15464264+0846339',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000184,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,236.677583,8.77611,0.049,NULL,56595742782,884308480,13817320,16.2),(132524,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132524,38.14,0.33,425,62079,70,NULL,NULL,'2MASX J15464431+0341556',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000094,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,236.684625,3.69889,0.249,NULL,56620795934,884699936,13823436,17.2),(132525,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132525,38.12,0.46,422,62080,70,NULL,NULL,'2MASX J15464466+5559096',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000088,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,236.6860417,55.98606,0.049,NULL,57641169090,900643267,14072551,17.3),(132526,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132526,36.97,0.46,247,62081,70,NULL,NULL,'2MASX J15464498+0953159',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.687416667,9.88786,0.133,NULL,56602958971,884421233,13819081,16.8),(132527,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132527,38.51,0.46,504,62082,70,NULL,NULL,'SDSS J154645.16+443323.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000156,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,236.688167,44.55639,0.041,NULL,59693320103,932708126,14573564,18.6),(132528,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132528,37.7,0.16,347,62083,70,NULL,NULL,'2MASX J15464576+2758098',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000195,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,236.690875,27.96944,0.073,NULL,59871692666,935495197,14617112,17),(132529,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132529,37.44,0.46,308,62084,70,NULL,NULL,'2MASX J15464588+2601468',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000159,NULL,'17.2g',0.23,'BrClG',NULL,NULL,NULL,NULL,1,236.6910417,26.02975,0.157,NULL,59873675903,935526185,14617596,17.2),(132530,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132530,37.23,0.46,279,62085,70,NULL,NULL,'2MASX J15464982+4702147',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000196,NULL,'16.1g',0.41,'E0',NULL,NULL,NULL,NULL,1,236.707583,47.03747,0.065,NULL,59719610479,933118913,14579983,16.1),(132531,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132531,35.97,0.66,156,62086,70,NULL,NULL,'2MASX J15465092-0237251',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,236.71225,-2.62361,0.441,NULL,45585118547,712267477,11129179,15.2),(132532,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132532,37.14,0.33,268,62087,70,NULL,NULL,'2MASX J15465113+4630357',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000181,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,236.713167,46.51003,0.037,NULL,59689157889,932643092,14572548,17),(132533,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132533,36.57,0.46,206,62088,70,NULL,NULL,'2MASX J15465227+1836171',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00017,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,236.717667,18.60481,0.085,NULL,59446643169,928853799,14513340,16.6),(132534,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132534,37.74,0.46,353,62089,70,NULL,NULL,'2MASX J15465227-0043111',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000088,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.7177083,-0.71967,0.293,NULL,45583841042,712247516,11128867,17.8),(132535,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132535,36.41,0.58,192,62090,70,NULL,NULL,'2MASX J15465302-0333291',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.70',NULL,NULL,NULL,NULL,NULL,NULL,1,236.721083333,-3.55808,0.501,NULL,45599188270,712487316,11132614,16.7),(132536,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132536,38.49,0.33,500,62091,70,NULL,NULL,'2MASX J15465348+5457065',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000601,NULL,'17.7g',0.17,'AGN2',NULL,NULL,NULL,'Sy 2',1,236.7230417,54.95186,0,NULL,57584085814,899751340,14058614,17.7),(132537,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132537,37.7,0.16,347,62092,70,NULL,NULL,'2MASX J15465406+2756598',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.72525,27.94986,0.073,NULL,59871692055,935495188,14617112,17.7),(132538,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132538,38.06,0.33,409,62093,70,NULL,NULL,'2MASX J15465434+0232136',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000073,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.726375,2.53722,0.309,NULL,56609577927,884524655,13820697,18.3),(132539,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132539,38.61,0.33,527,62094,70,NULL,NULL,'SDSS J154654.65+115442.6',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.9g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.72775,11.91183,0.109,NULL,56603226784,884425418,13819147,17.9),(132540,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132540,38.37,0.33,473,62095,70,NULL,NULL,'2MASX J15465521+0517586',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,236.730167,5.29964,0.109,NULL,56617482085,884648157,13822627,17.7),(132541,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132541,37.98,0.46,395,62096,70,NULL,NULL,'2MASX J15465810+3035108',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.742167,30.58639,0.073,NULL,59923214144,936300221,14629690,17.5),(132542,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132542,38.06,0.33,409,62097,70,NULL,NULL,'2MASX J15465841+0235386',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000103,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.743333,2.59406,0.309,NULL,56609098701,884517167,13820580,17.6),(132543,'IRAS','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132543,32.66,0.8,34.1,62098,75,NULL,'MAT, I','NGC 5967A',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000033,NULL,'12.61',1.3,'SB(rs+)bc:','in a pair',NULL,NULL,NULL,1,236.744667,-75.78744,0.281,NULL,44114580972,689290327,10770161,12.61),(132544,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132544,32.21,0.32,27.7,62098,85,NULL,'I, raw','NGC 5967A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132545,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132545,32.21,0.32,27.7,62098,85,NULL,'I, inv','NGC 5967A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132546,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132546,32.7,0.43,34.7,62098,75,NULL,'MAT, I, raw','NGC 5967A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132547,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132547,32.77,0.43,35.8,62098,75,NULL,'MAT, I, inv','NGC 5967A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132548,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132548,32.91,0.43,38.1,62098,75,NULL,'MAT, I, cor','NGC 5967A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132549,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132549,37.7,0.16,347,62099,70,NULL,NULL,'2MASX J15465889+2748448',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.745333,27.81258,0.073,NULL,59871708334,935495442,14617116,17.2),(132550,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132550,32.54,0.69,32.2,62100,100,NULL,'mid-IR','NGC 5996',NULL,'2013ApJ...771...88L',2013,1,1.58,'Incorrectly called NGC 5994 in 1976ApJS...31..187D.','G',0.000007,NULL,'13.4g',0.69,'SBc;WR?;HII    Sbrst','Possible field galaxy',NULL,NULL,'Starburst',1,236.745333,17.88419,0.057,NULL,59429473893,928585529,14509148,13.4),(132551,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132551,32.99,0.47,39.6,62100,NULL,NULL,'H','NGC 5996',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132552,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132552,33.09,0.46,41.5,62100,NULL,NULL,'J','NGC 5996',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132553,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132553,33.12,0.45,42.1,62100,NULL,NULL,'K','NGC 5996',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132554,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132554,33.26,0.4,44.8,62100,NULL,NULL,'mean','NGC 5996',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132555,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132555,38.75,0.46,561,62101,70,NULL,NULL,'2MASX J15465922+1748292',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.74675,17.80825,0.057,NULL,59429486071,928585719,14509151,18.2),(132556,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2002ck',NULL,132556,34.9,0.17,92.7,62102,74.2,NULL,'SALT 2','UGC 10030',0.029864,'2010ApJ...716..712A',2010,1,1.6,NULL,'G',0.000023,NULL,'15.03',1,'SB(s)b pec:    HII',NULL,NULL,NULL,NULL,1,236.75175,-0.98514,0.301,NULL,45584588693,712259198,11129049,15.03),(132557,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2002ck',NULL,132557,35.36,0.2,115,62102,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','UGC 10030',0.029864,'2011A&A...526A..81B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132558,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2002ck',NULL,132558,35.46,0.04,120,62102,72,NULL,'SALT','UGC 10030',0.029864,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132559,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2002ck',NULL,132559,35.53,0.16,124,62102,70,NULL,'SALT 2','UGC 10030',0.029864,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132560,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2002ck',NULL,132560,35.47,0.09,124,62102,74.4,NULL,NULL,'UGC 10030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132561,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2002ck',NULL,132561,35.66,0.17,132,62102,65,NULL,'SALT','UGC 10030',0.029864,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132562,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2002ck',NULL,132562,35.75,0.17,137,62102,65,NULL,'MLCS17','UGC 10030',0.029864,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132563,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2002ck',NULL,132563,35.76,0.19,138,62102,65,NULL,'SALT2','UGC 10030',0.029864,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132564,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2002ck',NULL,132564,35.77,0.17,138,62102,65,NULL,'MLCS31','UGC 10030',0.029864,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132565,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132565,35.04,0.47,102,62102,NULL,NULL,'H','UGC 10030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132566,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132566,35.24,0.45,112,62102,NULL,NULL,'K','UGC 10030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132567,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132567,35.25,0.46,112,62102,NULL,NULL,'J','UGC 10030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132568,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132568,35.46,0.4,124,62102,NULL,NULL,'mean','UGC 10030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132569,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132569,38.1,0.23,418,62103,70,NULL,NULL,'2MASX J15470112+2930208',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000157,NULL,'16.4g',0.4,'BrClG;E',NULL,NULL,NULL,NULL,1,236.75475,29.50567,0.085,NULL,59922779327,936293426,14629584,16.4),(132570,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132570,39.69,0.46,867,62104,70,NULL,NULL,'2MASX J15470110+0515252',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000199,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,236.7547917,5.25692,0.109,NULL,56617478318,884648098,13822626,18.3),(132571,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132571,38.11,0.46,418,62105,70,NULL,NULL,'2MASX J15470162+2010071',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.756667,20.16867,0.141,NULL,59447644178,928869440,14513585,18.1),(132572,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132572,38.53,0.46,508,62106,70,NULL,NULL,'SDSS J154701.68+140240.5',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,236.757,14.04461,0.069,NULL,56538385468,883412272,13803316,NULL),(132573,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132573,38.14,0.46,425,62107,70,NULL,NULL,'2MASX J15470191+1441063',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.758083333,14.68506,0.057,NULL,56537104863,883392263,13803004,17.7),(132574,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132574,37.84,0.33,369,62108,70,NULL,NULL,'SDSS J154702.83+060027.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000142,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,236.761833333,6.00753,0.101,NULL,56617121648,884642525,13822539,18.7),(132575,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132575,37.84,0.33,369,62109,70,NULL,NULL,'2MASX J15470291+0603316',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000187,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,236.762083,6.05892,0.125,NULL,56617122397,884642537,13822539,16.8),(132576,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132576,38.36,0.46,470,62110,70,NULL,NULL,'2MASX J15470329+2943228',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000171,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.7637083,29.72303,0.093,NULL,59922574808,936290231,14629534,17.9),(132577,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132577,37.7,0.16,347,62111,70,NULL,NULL,'2MASX J15470365+2759198',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000176,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,236.765375,27.98889,0.073,NULL,59871694320,935495223,14617112,16.7),(132578,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132578,38.21,0.33,438,62112,70,NULL,NULL,'2MASX J15470396+1212223',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,236.7664583,12.20633,0.157,NULL,56598987371,884359177,13818112,16.7),(132579,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132579,38.21,0.33,438,62113,70,NULL,NULL,'2MASX J15470423+1213203',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,236.767667,12.22244,0.157,NULL,56528733136,883261455,13800960,17.9),(132580,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132580,38.27,0.46,450,62114,70,NULL,NULL,'2MASX J15470499+0609276',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000168,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.770667,6.15767,0.133,NULL,56624709258,884761082,13824391,17.8),(132581,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132581,37.22,0.46,279,62115,70,NULL,NULL,'2MASX J15470533+1429433',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,236.7722917,14.4955,0.049,NULL,56536899583,883389055,13802953,17.2),(132582,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132582,38.61,0.33,527,62116,70,NULL,NULL,'2MASX J15470656+1151436',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.777333333,11.86203,0.109,NULL,56603217893,884425279,13819144,18.3),(132583,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132583,38.1,0.23,418,62117,70,NULL,NULL,'2MASX J15470719+2930101',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000167,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.7800417,29.50281,0.085,NULL,59922777492,936293398,14629584,18.1),(132584,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132584,37.31,0.46,289,62118,70,NULL,NULL,'SDSS J154707.73+040435.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.1g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.7822083,4.07656,0.185,NULL,56620704917,884698514,13823414,18.1),(132585,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132585,38.1,0.46,416,62119,70,NULL,NULL,'2MASX J15470812+3210229',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.784,32.173,0.077,NULL,59921521474,936273773,14629277,17.9),(132586,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132586,37.06,0.46,258,62120,70,NULL,NULL,'2MASX J15470874+2027183',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000164,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,236.786333,20.45514,0.145,NULL,59447538065,928867782,14513559,16.4),(132587,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132587,37.6,0.33,331,62121,70,NULL,NULL,'2MASX J15470883+2915302',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,236.786875,29.25839,0.077,NULL,59922059332,936282177,14629409,17.3),(132588,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132588,37.52,0.46,319,62122,70,NULL,NULL,'MCG +06-35-006',NULL,'2015arXiv151105856S',2015,1,0.67,'One of two 6cm sources associated with [WB92] 1545+3541','G',0.000097,NULL,'15.7g',0.4,'E0',NULL,NULL,NULL,NULL,1,236.788417,35.64617,0.045,NULL,59892463278,935819738,14622183,15.7),(132589,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132589,37.2,0.46,276,62123,70,NULL,NULL,'2MASX J15470984+2611222',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.790917,26.18956,0.161,NULL,59873599738,935524995,14617578,17.2),(132590,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132590,38.48,0.46,496,62124,70,NULL,NULL,'2MASX J15470988+1024206',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,236.791125,10.40578,0.117,NULL,56605850319,884466411,13819787,18.3),(132591,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132591,37.44,0.46,307,62125,70,NULL,NULL,'2MASX J15471068+0517562',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000168,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,236.794625,5.29911,0.109,NULL,56617476836,884648075,13822626,17.1),(132592,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132592,38.08,0.46,414,62126,70,NULL,NULL,'2MASX J15471092+1745194',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000171,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.795625,17.75544,0.085,NULL,59429481405,928585646,14509150,17.8),(132593,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132593,32.07,NULL,25.9,62127,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 450- G 014',NULL,'2010Ap&SS.325..163P',2010,1,1.48,NULL,'G',0.000017,NULL,'16.31',0.2,'Sd',NULL,NULL,NULL,NULL,1,236.800417,-28.77389,0.597,NULL,47173380464,737084069,11516938,16.31),(132594,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132594,32.1,NULL,26.3,62127,NULL,NULL,'Dipole + Quadrupole','ESO 450- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132595,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132595,32.12,NULL,26.6,62127,NULL,NULL,'Dipole','ESO 450- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132596,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132596,37.17,0.46,271,62128,70,NULL,NULL,'2MASX J15471329+1217034',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,236.805291667,12.28442,0.137,NULL,56528734377,883261474,13800960,17.1),(132597,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132597,37.41,0.46,303,62129,70,NULL,NULL,'SDSS J154713.61+180211.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000158,NULL,'18.0g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.80675,18.03644,0.041,NULL,59429607353,928587614,14509181,18),(132598,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132598,37.63,0.46,335,62130,70,NULL,NULL,'2MASX J15471422+4306545',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000167,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,236.809375,43.11517,0.049,NULL,59677928729,932467636,14569806,17.2),(132599,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132599,36.93,0.46,244,62131,70,NULL,NULL,'2MASX J15471428+4852352',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000145,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.809417,48.87639,0.089,NULL,59726494936,933226483,14581663,17.5),(132600,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132600,37.85,0.46,371,62132,70,NULL,NULL,'SDSS J154715.02+372929.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000142,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,236.812625,37.49147,0.037,NULL,59881519746,935648746,14619511,18.6),(132601,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132601,38.42,0.19,483,62133,70,NULL,NULL,'2MASX J15471612+0310222',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000077,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,236.817,3.17297,0.261,NULL,56620440354,884694380,13823349,18.5),(132602,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132602,35.29,0.6,114,62134,70,NULL,NULL,'2MASX J15471612-7314560',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,236.817333,-73.24889,0.369,NULL,44997764213,703090065,10985782,16.6),(132603,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132603,35.51,0.46,126,62135,70,NULL,NULL,'CGCG 050-103',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000097,NULL,'15.4g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,236.824917,2.95683,0.261,NULL,56608977759,884515277,13820551,15.4),(132604,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132604,38.38,0.46,475,62136,70,NULL,NULL,'SDSS J154718.61+493125.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000183,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,236.827583,49.52381,0.049,NULL,59726681277,933229394,14581709,18.4),(132605,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132605,37.74,0.27,353,62137,70,NULL,NULL,'2MASX J15471886+1201405',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,236.828625,12.02781,0.113,NULL,56599045677,884360088,13818126,16.9),(132606,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132606,37.33,0.46,292,62138,70,NULL,NULL,'2MASX J15471916+1727095',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00018,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,236.829917,17.45264,0.073,NULL,59429763313,928590051,14509219,16.9),(132607,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132607,36.5,0.2,200,62139,74.4,NULL,NULL,'CGCG 136-077',NULL,'2013AJ....146...86T',2013,1,0.71,NULL,'G',0.000076,NULL,'15.5g',0.44,'S',NULL,NULL,NULL,NULL,1,236.8315,21.53111,0.129,NULL,59401878360,928154349,14502411,15.5),(132608,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132608,37.05,0.46,257,62140,70,NULL,NULL,'2MASX J15471960+1647235',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',NULL,NULL,'16.96',0.35,NULL,NULL,NULL,NULL,NULL,1,236.831875,16.78986,0.061,NULL,59432549118,928633579,14509899,16.96),(132609,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132609,37.48,0.46,314,62141,70,NULL,NULL,'2MASX J15471966+1718165',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000175,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.832083,17.30456,0.057,NULL,59432623391,928634740,14509917,17.5),(132610,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132610,38.42,0.19,483,62142,70,NULL,NULL,'SDSS J154720.92+031038.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000083,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,236.8372083,3.17747,0.261,NULL,56620262970,884691608,13823306,18.8),(132611,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132611,36.87,0.46,237,62143,70,NULL,NULL,'2MASX J15472104+2955132',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00016,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,236.83775,29.92019,0.085,NULL,59922537406,936289646,14629525,16.9),(132612,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132612,37.7,0.16,347,62144,70,NULL,NULL,'2MASX J15472215+2755462',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000193,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,236.8424583,27.92958,0.073,NULL,59871828109,935497314,14617145,17),(132613,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132613,37.06,0.46,258,62145,70,NULL,NULL,'2MASX J15472232+0823275',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,236.843,8.39089,0.041,NULL,56625267750,884769808,13824528,16.8),(132614,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132614,38.69,0.46,546,62146,70,NULL,NULL,'2MASX J15472310+1257235',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,236.846417,12.95664,0.121,NULL,56537290814,883395168,13803049,17.6),(132615,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132615,37.69,0.46,345,62147,70,NULL,NULL,'2MASX J15472375+3300579',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000228,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.849,33.01614,0.069,NULL,59889206717,935768854,14621388,17.4),(132616,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132616,37.97,0.46,394,62148,70,NULL,NULL,'2MASX J15472391+2050493',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000155,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,236.8497917,20.847,0.141,NULL,59447064620,928860384,14513443,17.2),(132617,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132617,36.02,0.46,160,62149,70,NULL,NULL,'CGCG 078-072',NULL,'2015arXiv151105856S',2015,1,0.7,'Star 20\\\" to the northwest.','G',0.00007,NULL,'15.6',0.23,'Sa','Isolated galaxy',NULL,NULL,NULL,1,236.859583,10.28272,0.113,NULL,56602634224,884416159,13819002,15.6),(132618,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132618,38.1,0.33,416,62150,70,NULL,NULL,'2MASX J15472629+2745022',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00018,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.8597917,27.75069,0.061,NULL,59871681862,935495029,14617109,17.3),(132619,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132619,38.09,0.46,414,62151,70,NULL,NULL,'2MASX J15472642+0604582',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.860125,6.08283,0.101,NULL,56617222379,884644099,13822564,17.8),(132620,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132620,37.52,0.46,319,62152,70,NULL,NULL,'2MASX J15472684+3250419',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000148,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,236.861875,32.84506,0.069,NULL,59889192093,935768626,14621384,17.2),(132621,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132621,38.25,0.33,446,62153,70,NULL,NULL,'2MASX J15472742+0839537',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000156,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,236.864458333,8.66494,0.049,NULL,56594986144,884296658,13817135,18.7),(132622,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132622,36.2,0.46,174,62154,70,NULL,NULL,'NGC 5997',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000113,NULL,'15.3g',0.57,'E0',NULL,NULL,NULL,NULL,1,236.8652917,8.32119,0.049,NULL,56626129475,884783273,13824738,15.3),(132623,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132623,36.86,0.2,236,62155,74.4,NULL,NULL,'CGCG 166-057',NULL,'2013AJ....146...86T',2013,1,0.79,NULL,'G',0.000171,NULL,'15.6g',0.41,NULL,NULL,NULL,NULL,NULL,1,236.871833333,32.01517,0.077,NULL,59921605543,936275086,14629298,15.6),(132624,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132624,37.03,0.46,255,62156,70,NULL,NULL,'2MASX J15472958+1456568',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,236.8732917,14.94917,0.089,NULL,56536964075,883390063,13802969,16.5),(132625,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132625,37.83,0.46,368,62157,70,NULL,NULL,'SDSS J154729.69+231844.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000169,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.87375,23.31242,0.157,NULL,59398868277,928107316,14501676,18.2),(132626,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132626,37.7,0.16,347,62158,70,NULL,NULL,'2MASX J15473143+2801512',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000234,NULL,'16.2g',0.42,'BrClG',NULL,NULL,NULL,NULL,1,236.8810417,28.03072,0.073,NULL,59871824020,935497250,14617144,16.2),(132627,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132627,37.17,0.46,272,62159,70,NULL,NULL,'SDSS J154732.40+063055.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000139,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.8850417,6.51539,0.113,NULL,56624839002,884763109,13824423,18.1),(132628,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132628,37.95,0.33,389,62160,70,NULL,NULL,'2MASX J15473347+1840233',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00017,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,236.889333333,18.67308,0.093,NULL,59446597030,928853078,14513329,17.7),(132629,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132629,36.87,0.46,236,62161,70,NULL,NULL,'2MASX J15473357+2948342',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000158,NULL,'16.6g',0.3,'S0',NULL,NULL,NULL,NULL,1,236.8899583,29.8095,0.093,NULL,59922544201,936289753,14629527,16.6),(132630,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132630,34.94,0.65,97.4,62162,70,NULL,NULL,'2MASX J15473422-3050416',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,236.892625,-30.84494,0.565,NULL,47168299880,737004685,11515698,14.6),(132631,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132631,35.45,0.48,123,62163,70,NULL,NULL,'IC 1136',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000067,NULL,'15.4',0.6,NULL,NULL,NULL,NULL,NULL,1,236.8932917,-1.54528,0.397,NULL,45587209862,712300154,11129689,15.4),(132632,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132632,38.5,0.46,502,62164,70,NULL,NULL,'SDSS J154734.41+543951.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000138,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,236.893416667,54.66428,0.009,NULL,57584577111,899759017,14058734,18.1),(132633,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132633,38.1,0.46,417,62165,70,NULL,NULL,'SDSS J154734.64+041951.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.7g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.894375,4.331,0.221,NULL,56622608671,884728260,13823879,18.7),(132634,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132634,37.7,0.16,347,62166,70,NULL,NULL,'2MASX J15473504+2748262',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000179,NULL,'16.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,236.8962083,27.80731,0.073,NULL,59871797388,935496834,14617138,16.1),(132635,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132635,37.26,0.46,283,62167,70,NULL,NULL,'2MASX J15473533+5548382',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000077,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.897583333,55.81086,0.041,NULL,57640696915,900635889,14072435,17.3),(132636,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132636,35.73,0.2,140,62168,74.4,NULL,NULL,'UGC 10035',NULL,'2013AJ....146...86T',2013,1,0.79,NULL,'G',0.000033,NULL,'14.6g',0.58,'S?             HII',NULL,NULL,NULL,NULL,1,236.901375,26.06378,0.161,NULL,59873639957,935525624,14617587,14.6),(132637,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132637,37.79,0.46,361,62169,70,NULL,NULL,'2MASX J15473677+1311479',NULL,'2015arXiv151105856S',2015,1,0.19,'TXS codes: lobes(W)','G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.90325,13.19669,0.121,NULL,56538144027,883408500,13803257,18),(132638,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132638,37.48,0.46,313,62170,70,NULL,NULL,'2MASX J15473785+1949357',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000135,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.907667,19.82678,0.129,NULL,59449784310,928902879,14514107,17.7),(132639,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132639,38.25,0.33,446,62171,70,NULL,NULL,'SDSS J154740.51+084205.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00013,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.9187917,8.70147,0.049,NULL,56594952868,884296138,13817127,18.3),(132640,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132640,36.48,0.46,198,62172,70,NULL,NULL,'2MASX J15474122+3538233',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000156,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,236.921583,35.63986,0.049,NULL,59892484301,935820067,14622188,16.6),(132641,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132641,37.34,0.46,293,62173,70,NULL,NULL,'2MASX J15474138+5237021',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00008,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,236.9224583,52.61719,0.021,NULL,59714819341,933044052,14578813,16.8),(132642,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132642,37.45,0.46,309,62174,70,NULL,NULL,'SDSS J154741.59+414950.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000132,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.923333,41.83078,0.065,NULL,59680439191,932506862,14570419,17.8),(132643,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132643,36.55,0.23,205,62175,70,NULL,NULL,'2MASX J15474214+1212189',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.9254583,12.20517,0.093,NULL,56599023666,884359744,13818121,17),(132644,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132644,36.87,0.46,236,62176,70,NULL,NULL,'2MASX J15474248+1133316',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,236.9269583,11.55889,0.105,NULL,56599067751,884360433,13818131,16.8),(132645,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132645,36.59,0.46,208,62177,70,NULL,NULL,'2MASX J15474248+4536511',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,236.927,45.61436,0.033,NULL,59690167122,932658861,14572794,16.9),(132646,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132646,38.55,0.46,512,62178,70,NULL,NULL,'2MASX J15474245+1317169',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,236.9270417,13.28797,0.121,NULL,56538151991,883408624,13803259,18.1),(132647,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132647,37.15,0.46,269,62179,70,NULL,NULL,'2MASX J15474450+0901046',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000199,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,236.9352917,9.01794,0.065,NULL,56595038010,884297468,13817147,16.6),(132648,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132648,37.92,0.46,384,62180,70,NULL,NULL,'2MASX J15474499+5441111',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,236.9372917,54.68656,0.013,NULL,57584522772,899758168,14058721,17.3),(132649,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132649,38.07,0.33,412,62181,70,NULL,NULL,'2MASX J15474627+0258592',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.2g',0.38,'BrClG',NULL,NULL,NULL,NULL,1,236.942833,2.98317,0.317,NULL,56608954163,884514908,13820545,16.2),(132650,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132650,36.55,0.23,205,62182,70,NULL,NULL,'2MASX J15474686+1150146',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000093,NULL,'17.26',0.45,'AGN',NULL,NULL,NULL,NULL,1,236.945167,11.83747,0.109,NULL,56599222765,884362855,13818169,17.26),(132651,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132651,37.38,0.46,300,62183,70,NULL,NULL,'2MASX J15474752+1854468',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.947875,18.91311,0.093,NULL,59446562892,928852545,14513321,17.4),(132652,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132652,37.74,0.27,353,62184,70,NULL,NULL,'2MASX J15474780+1210109',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,236.949291667,12.16975,0.093,NULL,56599027295,884359801,13818121,17.6),(132653,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132653,37.32,0.46,291,62185,70,NULL,NULL,'2MASX J15474870+3331353',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00014,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.9529583,33.52642,0.073,NULL,59889056857,935766513,14621351,17.5),(132654,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132654,36.71,0.46,220,62186,70,NULL,NULL,'2MASX J15474890+3701359',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000172,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,236.9537083,37.02672,0.037,NULL,59880335465,935630241,14619222,16.4),(132655,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132655,38.28,0.46,453,62187,70,NULL,NULL,'SDSS J154750.28+533752.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000077,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.9595,53.63117,0.013,NULL,59668349209,932317956,14567468,18.3),(132656,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132656,38.15,0.46,427,62188,70,NULL,NULL,'2MASX J15475061+0603362',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.9610417,6.06011,0.109,NULL,56617231860,884644247,13822566,18.1),(132657,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132657,36.55,0.23,205,62189,70,NULL,NULL,'2MASX J15475066+1220510',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,236.96125,12.3475,0.093,NULL,56528796742,883262449,13800975,16.2),(132658,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132658,37.62,0.46,335,62190,70,NULL,NULL,'2MASX J15475094+0812196',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,236.9622083,8.20547,0.049,NULL,56626168664,884783885,13824748,17.2),(132659,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132659,37.74,0.27,353,62191,70,NULL,NULL,'2MASX J15475217+1211270',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,236.9675417,12.19092,0.093,NULL,56599027131,884359798,13818121,17.4),(132660,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132660,37.19,0.46,274,62192,70,NULL,NULL,'2MASX J15475318+2357426',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000191,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.9715,23.96181,0.149,NULL,59399080190,928110627,14501728,17.9),(132661,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132661,36.56,0.2,205,62193,74.4,NULL,NULL,'CGCG 136-080',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000172,NULL,'15.5g',0.3,'S',NULL,NULL,NULL,NULL,1,236.9752917,25.72956,0.161,NULL,59873546827,935524169,14617565,15.5),(132662,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132662,37.58,0.46,328,62194,70,NULL,NULL,'2MASX J15475455+5319302',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000079,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.9772917,53.32506,0.033,NULL,59668301180,932317205,14567456,17.5),(132663,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132663,37.93,0.33,385,62195,70,NULL,NULL,'2MASX J15475484+0542322',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000176,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.978333,5.70903,0.105,NULL,56617814281,884653348,13822708,17.8),(132664,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132664,38.1,0.33,416,62196,70,NULL,NULL,'2MASX J15475552+2754556',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,236.981375,27.91544,0.081,NULL,59871852723,935497698,14617151,17.7),(132665,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132665,36.56,0.46,205,62197,70,NULL,NULL,'2MASX J15475582+1621580',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.34',0.24,NULL,NULL,NULL,NULL,NULL,1,236.982541667,16.36614,0.093,NULL,59431485826,928616966,14509640,17.34),(132666,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132666,37.24,0.46,281,62198,70,NULL,NULL,'2MASX J15475615+0235102',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000073,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.983875,2.58614,0.325,NULL,56609721100,884526892,13820732,18),(132667,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132667,36.98,0.46,249,62199,70,NULL,NULL,'2MASX J15475666+1752158',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000174,NULL,'17.44',0.25,NULL,NULL,NULL,NULL,NULL,1,236.9862917,17.87114,0.057,NULL,59429439951,928584999,14509140,17.44),(132668,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132668,37.95,0.33,389,62200,70,NULL,NULL,'2MASX J15475752+1843208',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000154,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,236.989916667,18.72233,0.093,NULL,59446593382,928853021,14513328,16.9),(132669,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132669,36.49,0.33,199,62201,70,NULL,NULL,'CGCG 250-012 NED02',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,'FoF','16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,236.999208333,45.00631,0.053,NULL,59692624414,932697256,14573394,16.6),(132670,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132670,36.49,0.33,199,62202,70,NULL,NULL,'CGCG 250-012 NED01',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000197,NULL,'15.4g',0.51,'E0',NULL,NULL,NULL,NULL,1,237.0077917,45.00183,0.053,NULL,59692624628,932697259,14573394,15.4),(132671,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132671,38.07,0.33,412,62203,70,NULL,NULL,'2MASX J15480197+0255426',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000098,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,237.0082083,2.92844,0.317,NULL,56608957627,884514962,13820546,18),(132672,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132672,37.45,0.46,308,62204,70,NULL,NULL,'2MASX J15480312+2214247',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,237.013083,22.24011,0.189,NULL,59404072243,928188628,14502947,17.2),(132673,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132673,37.14,0.46,267,62205,70,NULL,NULL,'2MASX J15480458+0840280',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000171,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,237.0192083,8.67439,0.049,NULL,56625314306,884770536,13824539,16.8),(132674,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132674,37.7,0.16,347,62206,70,NULL,NULL,'2MASX J15480594+2757446',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000177,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,237.024708333,27.96236,0.081,NULL,59871841986,935497531,14617148,16.7),(132675,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132675,38.66,0.46,540,62207,70,NULL,NULL,'2MASX J15480635+5301292',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000092,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,237.026583,53.02486,0,NULL,59714710909,933042357,14578786,17.4),(132676,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132676,37.87,0.46,376,62208,70,NULL,NULL,'2MASX J15480811-0026261',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000081,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.033791667,-0.44061,0.289,NULL,45517581165,711212205,11112690,17.9),(132677,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132677,36.97,0.46,248,62209,70,NULL,NULL,'2MASX J15481037+0751490',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.043125,7.86375,0.053,NULL,56626046474,884781976,13824718,17.8),(132678,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132678,37.5,0.46,317,62210,70,NULL,NULL,'2MASX J15481103+2655425',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,237.046083,26.92839,0.109,NULL,59872407291,935506363,14617286,16.7),(132679,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132679,36.22,0.46,176,62211,70,NULL,NULL,'2MASX J15481174+0904250',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000172,NULL,'16.1g',0.27,'E0',NULL,NULL,NULL,NULL,1,237.048917,9.0735,0.057,NULL,56594821785,884294090,13817095,16.1),(132680,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132680,37.99,0.46,396,62212,70,NULL,NULL,'2MASX J15481253+5321302',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000082,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,237.0520417,53.35856,0.033,NULL,59668306168,932317283,14567457,17.7),(132681,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132681,37.93,0.33,385,62213,70,NULL,NULL,'2MASX J15481271+0543346',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,237.053125,5.72622,0.101,NULL,56617753386,884652396,13822693,18.3),(132682,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132682,37.87,0.46,374,62214,70,NULL,NULL,'2MASX J15481365+2954536',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000181,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,237.056833333,29.915,0.085,NULL,59922727031,936292609,14629572,16.5),(132683,'IRAS','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132683,32.55,0.8,32.4,62215,75,NULL,'MAT, I','IC 4555',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000022,NULL,'13.53',0.5,'SB(s)cd: sp',NULL,NULL,NULL,NULL,1,237.0617083,-78.17886,0.425,NULL,44282755340,691918052,10811219,13.53),(132684,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132684,31.91,0.32,24.1,62215,85,NULL,'I, raw','IC 4555',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132685,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132685,31.92,0.32,24.2,62215,85,NULL,'I, inv','IC 4555',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132686,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132686,31.97,0.4,24.8,62215,73,NULL,'opt','IC 4555',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132687,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132687,32.03,0.2,25.5,62215,74.4,NULL,NULL,'IC 4555',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132688,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132688,32.04,0.43,25.6,62215,75,NULL,'3.6 micron, color + selection bias corrected','IC 4555',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132689,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132689,32.06,0.58,25.8,62215,NULL,NULL,'Malmquist cor.','IC 4555',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132690,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132690,32.07,0.43,25.9,62215,75,NULL,'3.6 micron, color corrected','IC 4555',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132691,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132691,32.1,0.43,26.3,62215,75,NULL,'MAT, I, raw','IC 4555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132692,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132692,32.11,0.57,26.4,62215,NULL,NULL,NULL,'IC 4555',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132693,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132693,32.17,0.43,27.1,62215,75,NULL,'MAT, I, inv','IC 4555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132694,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132694,32.43,0.49,30.7,62215,75,NULL,'IR','IC 4555',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132695,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132695,32.44,0.43,30.8,62215,75,NULL,'MAT, I, cor','IC 4555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132696,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132696,32.91,0.4,38.3,62215,NULL,NULL,'mean','IC 4555',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132697,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132697,32.95,0.47,38.9,62215,NULL,NULL,'H','IC 4555',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132698,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132698,33.05,0.46,40.7,62215,NULL,NULL,'J','IC 4555',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132699,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132699,33.21,0.45,43.8,62215,NULL,NULL,'K','IC 4555',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132700,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132700,37.32,0.46,291,62216,70,NULL,NULL,'SDSS J154814.90+055456.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,237.062083,5.91564,0.101,NULL,56617259943,884644686,13822573,18.3),(132701,'IRAS','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132701,32.74,0.8,35.2,62217,75,NULL,'MAT, I','NGC 5967',NULL,'1997ApJS..109..333W',1997,1,2.9,'Confused HIPASS source','G',0.000019,NULL,'12.6b',1.7,'SAB(rs)c','in a pair',NULL,NULL,NULL,1,237.066375,-75.67294,0.293,NULL,44114494114,689288970,10770140,12.6),(132702,'Sosies','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132702,32.72,0.16,35,62217,NULL,NULL,NULL,'NGC 5967',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132703,'Tully est','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132703,32.81,0.8,36.6,62217,75,NULL,'B','NGC 5967',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132704,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132704,32.46,0.47,31,62217,NULL,NULL,'H','NGC 5967',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132705,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132705,32.47,0.4,31.2,62217,NULL,NULL,NULL,'NGC 5967',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132706,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132706,32.59,0.45,33,62217,NULL,NULL,'K','NGC 5967',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132707,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132707,32.59,0.43,33,62217,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5967',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132708,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132708,32.63,0.46,33.6,62217,NULL,NULL,'J','NGC 5967',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132709,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132709,32.64,0.32,33.7,62217,85,NULL,'I, raw','NGC 5967',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132710,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132710,32.68,0.43,34.4,62217,75,NULL,'3.6 micron, color corrected','NGC 5967',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132711,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132711,32.69,0.43,34.5,62217,75,NULL,'MAT, I, raw','NGC 5967',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132712,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132712,32.7,0.32,34.6,62217,85,NULL,'I, inv','NGC 5967',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132713,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132713,32.89,0.2,37.8,62217,74.4,NULL,NULL,'NGC 5967',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132714,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132714,32.9,0.43,38,62217,75,NULL,'MAT, I, cor','NGC 5967',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132715,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132715,32.92,0.43,38.4,62217,75,NULL,'MAT, I, inv','NGC 5967',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132716,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132716,32.93,0.4,38.6,62217,NULL,NULL,'mean','NGC 5967',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132717,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132717,33.11,0.48,41.9,62217,NULL,NULL,'Malmquist cor.','NGC 5967',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132718,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132718,33.22,0.46,44,62217,NULL,NULL,NULL,'NGC 5967',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132719,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132719,36.38,0.33,188,62218,70,NULL,NULL,'2MASX J15481608+4255527',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000194,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,237.066708333,42.93133,0.037,NULL,59678108732,932470448,14569850,16.2),(132720,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132720,37.27,0.46,284,62219,70,NULL,NULL,'2MASX J15481831+5735490',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000102,NULL,'16.1g',0.33,'S',NULL,NULL,NULL,NULL,1,237.076166667,57.59706,0,NULL,57635269219,900551081,14071110,16.1),(132721,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132721,37.99,0.46,395,62220,70,NULL,NULL,'2MASX J15481925+3018106',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.080333333,30.30303,0.065,NULL,59922640870,936291263,14629550,17.6),(132722,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132722,37.64,0.33,337,62221,70,NULL,NULL,'SDSS J154819.72+032330.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000077,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,237.0822083,3.39186,0.249,NULL,56622090836,884720169,13823752,18.4),(132723,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132723,37.41,0.15,304,62222,70,NULL,NULL,'SDSS J154820.35+254128.6',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000176,NULL,'17.1g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,237.0847917,25.69131,0.161,NULL,59873502951,935523483,14617554,17.1),(132724,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132724,38.27,0.46,452,62223,70,NULL,NULL,'2MASX J15482066+3451056',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,237.086083,34.8515,0.081,NULL,59892158134,935814970,14622108,17.6),(132725,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132725,37.46,0.46,310,62224,70,NULL,NULL,'2MASX J15482196+3311026',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,237.091333,33.18408,0.073,NULL,59889157318,935768083,14621376,16.7),(132726,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132726,37.31,0.46,289,62225,70,NULL,NULL,'2MASX J15482224+2539196',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000182,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,237.09275,25.65547,0.161,NULL,59873237667,935519338,14617489,16.7),(132727,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132727,38.41,0.46,480,62226,70,NULL,NULL,'2MASX J15482328+4322267',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000177,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,237.096833333,43.37417,0.033,NULL,59691783466,932684116,14573189,17.7),(132728,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132728,37.64,0.33,337,62227,70,NULL,NULL,'2MASX J15482367+0326426',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000085,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,237.0984583,3.44503,0.249,NULL,56622269863,884722966,13823796,18.2),(132729,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132729,36.13,0.46,168,62228,70,NULL,NULL,'2MASX J15482631+0909519',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000171,NULL,'15.8g',0.36,'E0',NULL,NULL,NULL,NULL,1,237.109583,9.16456,0.057,NULL,56602172717,884408948,13818889,15.8),(132730,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132730,37.79,0.46,361,62229,70,NULL,NULL,'2MASX J15482690+2548316',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.112083,25.80878,0.161,NULL,59873498200,935523409,14617553,17.4),(132731,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132731,36.38,0.33,188,62230,70,NULL,NULL,'2MASX J15482839+4242048',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000206,NULL,'15.9g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,237.1184583,42.70147,0.049,NULL,59677976614,932468384,14569818,15.9),(132732,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132732,37.58,0.46,328,62231,70,NULL,NULL,'2MASX J15482915-0112254',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000081,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,237.121625,-1.20706,0.361,NULL,45584239757,712253746,11128964,17.7),(132733,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132733,37.43,0.46,306,62232,70,NULL,NULL,'2MASX J15483209+3722557',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000189,NULL,'16.8g',NULL,NULL,NULL,NULL,NULL,NULL,1,237.133625,37.38206,0.041,NULL,59880265831,935629153,14619205,16.8),(132734,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132734,35.79,0.49,144,62233,75,NULL,'IR','UGC 10039',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.40',0.2,'S?',NULL,NULL,NULL,NULL,1,237.145,11.64742,0.109,NULL,56599947456,884374179,13818346,15.4),(132735,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132735,37.47,0.46,312,62234,70,NULL,NULL,'2MASX J15483657+3822567',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000166,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,237.1525,38.38239,0.025,NULL,59760854652,933763353,14590052,17.1),(132736,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132736,38.36,0.33,470,62235,70,NULL,NULL,'SDSS J154836.79+523826.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000077,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,237.153333,52.64064,0.021,NULL,59714774070,933043344,14578802,18.6),(132737,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132737,37.44,0.46,307,62236,70,NULL,NULL,'2MASX J15483711+0806329',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000183,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,237.1547083,8.10919,0.049,NULL,56626223710,884784745,13824761,16.9),(132738,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132738,37.29,0.46,287,62237,70,NULL,NULL,'2MASX J15483772+2356056',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000182,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,237.157333,23.93503,0.149,NULL,59398292029,928098312,14501536,16.2),(132739,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132739,37.41,0.21,304,62238,70,NULL,NULL,'2MASX J15483785+0841599',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000183,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,237.157875,8.69989,0.057,NULL,56625441606,884772525,13824570,17.2),(132740,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132740,36.31,0.33,183,62239,70,NULL,NULL,'CGCG 136-085',NULL,'2015arXiv151105856S',2015,1,0.86,'Companion galaxy superposed 13 arcsec south of nucleus.','G',0.00024,NULL,'15.1g',0.56,NULL,NULL,NULL,NULL,NULL,1,237.159583,25.40417,0.161,NULL,59871260433,935488444,14617006,15.1),(132741,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132741,38,0.33,397,62240,70,NULL,NULL,'2MASX J15483911+3432462',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000193,NULL,'16.6g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,237.1629583,34.54611,0.077,NULL,59887796698,935746823,14621044,16.6),(132742,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132742,37.41,0.15,304,62241,70,NULL,NULL,'2MASX J15483982+2525325',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000159,NULL,'17.5g',NULL,NULL,NULL,NULL,NULL,NULL,1,237.165958333,25.42581,0.161,NULL,59871260133,935488439,14617006,17.5),(132743,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132743,32.72,0.4,35,62242,75,NULL,NULL,'UGC 10043',NULL,'2008Ap.....51..336K',2008,1,2.69,NULL,'G',0.000004,NULL,'14.80',0.35,'Sbc',NULL,NULL,NULL,NULL,1,237.1717083,21.86939,0.181,NULL,59404126946,928189483,14502960,14.8),(132744,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132744,33,0.43,39.9,62242,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10043',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132745,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132745,33.04,0.4,40.5,62242,NULL,NULL,'mean','UGC 10043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132746,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132746,33.39,0.43,47.7,62242,75,NULL,'3.6 micron, color corrected','UGC 10043',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132747,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132747,33.4,0.45,47.8,62242,NULL,NULL,'K','UGC 10043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132748,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132748,33.43,0.47,48.4,62242,NULL,NULL,'H','UGC 10043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132749,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132749,33.49,NULL,50,62242,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10043',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132750,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132750,33.5,NULL,50,62242,NULL,NULL,'Dipole','UGC 10043',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132751,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132751,33.5,NULL,50.1,62242,NULL,NULL,'Dipole + Quadrupole','UGC 10043',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132752,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132752,33.56,NULL,51.5,62242,NULL,NULL,NULL,'UGC 10043',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132753,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132753,33.63,0.46,53.2,62242,NULL,NULL,'J','UGC 10043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132754,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132754,33.7,0.49,55.1,62242,75,NULL,'IR','UGC 10043',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132755,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132755,33.78,0.2,57,62242,74.4,NULL,NULL,'UGC 10043',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132756,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132756,38.18,0.46,433,62243,70,NULL,NULL,'SDSS J154843.53+055522.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000097,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,237.181375,5.92306,0.109,NULL,56617743235,884652238,13822691,18.4),(132757,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132757,37.97,0.23,393,62244,70,NULL,NULL,'2MASX J15484366-0014484',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00008,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.181875,-0.24686,0.269,NULL,45517207085,711206360,11112599,18),(132758,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132758,35.58,0.2,131,62245,74.4,NULL,NULL,'UGC 10040',NULL,'2013AJ....146...86T',2013,1,1.11,NULL,'G',0.000033,NULL,'15.2g',0.34,'S?',NULL,NULL,NULL,NULL,1,237.182917,17.86272,0.041,NULL,59430108994,928595453,14509303,15.2),(132759,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132759,36.55,0.23,205,62246,70,NULL,NULL,'2MASX J15484398+1139529',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,237.1832083,11.66481,0.109,NULL,56599949107,884374204,13818346,16.2),(132760,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132760,35.98,0.46,157,62247,70,NULL,NULL,'CGCG 275-007',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000106,NULL,'15.2g',0.53,'SABb',NULL,NULL,NULL,NULL,1,237.183833,52.34294,0.021,NULL,59714671069,933041735,14578777,15.2),(132761,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132761,38.31,0.46,458,62248,70,NULL,NULL,'SDSS J154845.62+024122.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000092,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.190125,2.68953,0.325,NULL,56607654334,884494598,13820228,18),(132762,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132762,38.1,0.46,416,62249,70,NULL,NULL,'2MASX J15484641+3341052',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,237.1934583,33.68472,0.073,NULL,59889654437,935775850,14621497,17.8),(132763,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132763,37.97,0.23,393,62250,70,NULL,NULL,'2MASX J15484645+0001155',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000083,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.193583,0.02106,0.273,NULL,56472528652,882383260,13787238,18.2),(132764,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132764,36.31,0.33,183,62251,70,NULL,NULL,'SDSS J154846.56+252840.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.4g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,237.194,25.47792,0.161,NULL,59871206539,935487602,14616993,17.4),(132765,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132765,37.46,0.46,310,62252,70,NULL,NULL,'2MASX J15484712+1559552',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,237.196417,15.99867,0.085,NULL,56532574196,883321471,13801897,17.2),(132766,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132766,37.12,0.46,266,62253,70,NULL,NULL,'SDSS J154847.61+111253.8',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,237.198417,11.21494,0.113,NULL,56599507653,884367307,13818239,NULL),(132767,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132767,37.97,0.23,393,62254,70,NULL,NULL,'2MASX J15484825-0004024',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000097,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.201083,-0.06731,0.273,NULL,45517215623,711206494,11112601,17.8),(132768,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132768,37.97,0.23,393,62255,70,NULL,NULL,'2MASX J15484852-0000014',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000102,NULL,'17.0g',NULL,'BrClG',NULL,NULL,NULL,NULL,1,237.2022083,-0.00044,0.273,NULL,45517215846,711206497,11112601,17),(132769,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132769,37.84,0.33,370,62256,70,NULL,NULL,'2MASX J15484876+0743019',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000193,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,237.203041667,7.71717,0.093,NULL,56625885714,884779464,13824679,17.1),(132770,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132770,37.57,0.46,326,62257,70,NULL,NULL,'2MASX J15484884+0441510',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,237.2035417,4.69761,0.185,NULL,56619417082,884678391,13823099,17.3),(132771,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132771,38.14,0.46,424,62258,70,NULL,NULL,'2MASX J15484936+0258310',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000105,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,237.205583,2.97525,0.297,NULL,56607648345,884494505,13820226,17.6),(132772,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132772,37.4,0.46,302,62259,70,NULL,NULL,'2MASX J15484963+3029352',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00017,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,237.20675,30.49317,0.073,NULL,59923043351,936297552,14629649,16.9),(132773,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132773,37.75,0.46,355,62260,70,NULL,NULL,'2MASX J15485229+1923298',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,237.217875,19.39161,0.137,NULL,59446368642,928849510,14513273,17.6),(132774,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132774,36.34,0.46,186,62261,70,NULL,NULL,'2MASX J15485321+4557357',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00022,NULL,'15.4g',0.43,'E0',NULL,NULL,NULL,NULL,1,237.2215,45.95992,0.053,NULL,59689324560,932645696,14572589,15.4),(132775,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132775,38.59,0.46,522,62262,70,NULL,NULL,'2MASX J15485368+3421392',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.223583,34.36092,0.073,NULL,59887625042,935744141,14621002,17.8),(132776,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132776,37.48,0.46,313,62263,70,NULL,NULL,'2MASX J15485405+3926400',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000183,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,237.225125,39.44444,0.057,NULL,59760638289,933759973,14589999,16.6),(132777,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132777,36.35,0.46,187,62264,70,NULL,NULL,'SDSS J154855.66+000540.0',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000083,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,237.231958333,0.09447,0.273,NULL,56472531553,882383305,13787239,17.3),(132778,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132778,37.38,0.46,299,62265,70,NULL,NULL,'2MASX J15485667+4720497',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000182,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,237.236083,47.34719,0.069,NULL,59723975230,933187112,14581048,16.5),(132779,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132779,33.75,0.49,56.1,62266,75,NULL,'IR','UGC 10042',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000017,NULL,'14.88',0.2,'Scd:',NULL,NULL,NULL,NULL,1,237.2379583,7.22231,0.073,NULL,56626404299,884787567,13824805,14.88),(132780,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132780,33.92,0.2,60.8,62266,74.4,NULL,NULL,'UGC 10042',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132781,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132781,33.98,0.4,62.6,62266,NULL,NULL,'mean','UGC 10042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132782,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132782,34.02,0.47,63.5,62266,NULL,NULL,'H','UGC 10042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132783,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132783,34.13,0.24,66.9,62266,NULL,NULL,'Malmquist cor.','UGC 10042',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132784,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132784,34.16,0.45,68,62266,NULL,NULL,'K','UGC 10042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132785,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132785,34.17,0.46,68.1,62266,NULL,NULL,'J','UGC 10042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132786,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132786,34.24,0.23,70.4,62266,NULL,NULL,NULL,'UGC 10042',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132787,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132787,33.83,NULL,58.4,62267,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10044',NULL,'2010Ap&SS.325..163P',2010,1,1.29,NULL,'G',0.000009,NULL,'16.0',0.11,'Scd',NULL,NULL,NULL,NULL,1,237.24325,18.10319,0.025,NULL,59430068980,928594827,14509294,16),(132788,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132788,33.85,NULL,58.8,62267,NULL,NULL,'Dipole + Quadrupole','UGC 10044',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132789,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132789,33.86,NULL,59.2,62267,NULL,NULL,'Dipole','UGC 10044',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132790,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132790,33.91,NULL,60.6,62267,NULL,NULL,NULL,'UGC 10044',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132791,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132791,38.53,0.33,508,62268,70,NULL,NULL,'2MASX J15485944+1231314',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,237.247583333,12.52553,0.101,NULL,56528934317,883264598,13801009,17.7),(132792,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132792,37.41,0.21,304,62269,70,NULL,NULL,'2MASX J15485949+0902112',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,237.2477917,9.03647,0.069,NULL,56594801795,884293778,13817090,16.3),(132793,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132793,37.41,0.21,304,62270,70,NULL,NULL,'2MASX J15485949+0854362',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000227,NULL,'15.9g',0.46,'E0',NULL,NULL,NULL,NULL,1,237.2479583,8.90992,0.069,NULL,56625264137,884769752,13824527,15.9),(132794,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132794,37.97,0.46,393,62271,70,NULL,NULL,'2MASX J15485979+1303494',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,237.249083,13.06375,0.105,NULL,56538045487,883406960,13803233,NULL),(132795,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132795,36.77,0.46,226,62272,70,NULL,NULL,'2MASX J15490022+5048297',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000179,NULL,'16.1g',0.31,'E0',NULL,NULL,NULL,NULL,1,237.251,50.80825,0.037,NULL,59717490148,933085783,14579465,16.1),(132796,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132796,37.02,0.46,254,62273,70,NULL,NULL,'2MASX J15490082+2740328',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,237.253583,27.67569,0.081,NULL,59871787958,935496686,14617135,17.1),(132797,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132797,37.35,0.46,295,62274,70,NULL,NULL,'2MASX J15490124+0824452',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000158,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,237.255333,8.41247,0.049,NULL,56625371779,884771434,13824553,17.4),(132798,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132798,32.3,0.2,28.8,62275,74.4,NULL,NULL,'UGC 10041',NULL,'2013AJ....146...86T',2013,1,3,NULL,'G',0.000007,NULL,'13.5',1.7,'SABdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,237.255833,5.18861,0.181,NULL,56617414201,884647096,13822610,13.5),(132799,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132799,32.41,0.43,30.3,62275,75,NULL,'3.6 micron, color corrected','UGC 10041',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132800,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132800,32.5,0.43,31.6,62275,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10041',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132801,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132801,32.63,0.4,33.6,62275,75,NULL,'B','UGC 10041',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132802,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132802,32.77,0.37,35.8,62275,NULL,NULL,NULL,'UGC 10041',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132803,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132803,34.04,0.2,64.3,62276,74.4,NULL,NULL,'CGCG 166-060',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000083,NULL,'15.2',0.4,NULL,NULL,NULL,NULL,NULL,1,237.257125,27.60997,0.081,NULL,59871780122,935496564,14617133,15.2),(132804,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132804,38,0.33,397,62277,70,NULL,NULL,'2MASX J15490387+3433082',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000143,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,237.2662083,34.55228,0.077,NULL,59887799110,935746861,14621044,17.4),(132805,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132805,37.41,0.15,304,62278,70,NULL,NULL,'2MASX J15490610+2540268',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,237.275375,25.67397,0.165,NULL,59873492997,935523328,14617552,18.1),(132806,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132806,38.18,0.46,433,62279,70,NULL,NULL,'2MASX J15490617+0846162',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.275625,8.77111,0.057,NULL,56625242371,884769412,13824522,17.9),(132807,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132807,38.36,0.33,470,62280,70,NULL,NULL,'2MASX J15490767+5241027',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000086,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,237.281667,52.68428,0.021,NULL,59714653555,933041461,14578772,17.4),(132808,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132808,35.93,0.46,154,62281,70,NULL,NULL,'CGCG 250-013',NULL,'2015arXiv151105856S',2015,1,0.95,NULL,'G',0.000167,NULL,'14.8g',0.59,'E0',NULL,NULL,NULL,NULL,1,237.282333333,44.6995,0.041,NULL,59692755529,932699305,14573426,14.8),(132809,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132809,38.53,0.33,508,62282,70,NULL,NULL,'SDSS J154908.42+123010.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,237.285125,12.50283,0.101,NULL,56528942736,883264730,13801011,18.2),(132810,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132810,37.52,0.46,319,62283,70,NULL,NULL,'2MASX J15491114+3511342',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,237.2962083,35.19269,0.073,NULL,59892427335,935819177,14622174,17.6),(132811,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132811,33.6,0.49,52.4,62284,75,NULL,'IR','ESO 450- G 017',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',NULL,NULL,'17.15',0.2,'S0:',NULL,NULL,NULL,NULL,1,237.3042917,-28.92272,0.597,NULL,47166039961,736969374,11515146,17.15),(132812,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132812,37.87,0.46,374,62285,70,NULL,NULL,'2MASX J15491318+0443340',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.3050417,4.72622,0.185,NULL,56619286918,884676358,13823068,17.7),(132813,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132813,37.41,0.15,304,62286,70,NULL,NULL,'2MASX J15491502+2531153',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,237.312667,25.52092,0.161,NULL,59871212672,935487698,14616995,18),(132814,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132814,36.97,0.46,247,62287,70,NULL,NULL,'2MASX J15491525+2811123',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000146,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,237.3135,28.18681,0.077,NULL,59873715553,935526805,14617606,17.2),(132815,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132815,37.82,0.23,367,62288,70,NULL,NULL,'2MASX J15491609+2843163',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,237.3170417,28.72128,0.097,NULL,59866386481,935412288,14615817,17.9),(132816,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132816,37.52,0.46,319,62289,70,NULL,NULL,'2MASX J15491640+2807133',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000166,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,237.3184583,28.12033,0.077,NULL,59873708199,935526690,14617604,17.5),(132817,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132817,38,0.46,398,62290,70,NULL,NULL,'2MASX J15491716+3913420',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,237.321625,39.22831,0.037,NULL,59761327318,933770739,14590167,17.6),(132818,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132818,37.41,0.15,304,62291,70,NULL,NULL,'2MASX J15491731+2534543',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000182,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,237.3222917,25.58175,0.165,NULL,59871331905,935489561,14617024,17.6),(132819,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132819,37.41,0.15,304,62292,70,NULL,NULL,'2MASX J15491833+2539163',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000198,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,237.326583,25.65439,0.165,NULL,59871331010,935489547,14617024,16.7),(132820,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132820,37.65,0.46,339,62293,70,NULL,NULL,'2MASX J15491873+0043200',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000067,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,237.327958333,0.72225,0.253,NULL,56472953239,882389894,13787342,18.3),(132821,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132821,37.65,0.46,338,62294,70,NULL,NULL,'2MASX J15491890+2513513',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,237.3287917,25.23094,0.161,NULL,59871241642,935488150,14617002,17.5),(132822,'IRAS','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132822,33.59,0.8,52.2,62295,75,NULL,'MAT, I','ESO 450- G 018',NULL,'1997ApJS..109..333W',1997,1,5,NULL,'G',0.00002,NULL,'15.62',0.9,'I0:            HII',NULL,NULL,NULL,NULL,1,237.3329583,-28.90367,0.597,NULL,47166043924,736969436,11515147,15.62),(132823,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132823,31.1,0.32,16.6,62295,85,NULL,'I, inv','ESO 450- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132824,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132824,31.11,0.32,16.7,62295,85,NULL,'I, raw','ESO 450- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132825,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132825,31.45,0.43,19.5,62295,75,NULL,'MAT, I, raw','ESO 450- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132826,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132826,31.45,0.43,19.5,62295,75,NULL,'MAT, I, inv','ESO 450- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132827,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132827,31.76,0.43,22.5,62295,75,NULL,'MAT, I, cor','ESO 450- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132828,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132828,33.17,0.47,43.1,62295,NULL,NULL,'H','ESO 450- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132829,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132829,33.32,0.46,46.1,62295,NULL,NULL,'J','ESO 450- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132830,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132830,33.33,0.45,46.3,62295,NULL,NULL,'K','ESO 450- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132831,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132831,33.63,0.4,53.3,62295,NULL,NULL,'mean','ESO 450- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132832,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132832,37.21,0.46,277,62296,70,NULL,NULL,'2MASX J15492139+1056118',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,237.33925,10.93661,0.141,NULL,56601126908,884392607,13818634,16.9),(132833,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132833,37.14,0.46,268,62297,70,NULL,NULL,'2MASX J15492165+1437205',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,237.340375,14.62233,0.097,NULL,56538898859,883420294,13803442,17.8),(132834,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132834,36.5,NULL,200,62298,NULL,NULL,NULL,'FGC 1959',NULL,'2000BSAO...50....5K',2000,1,0.91,NULL,'G',0.000088,NULL,'17.6g',0.09,'Scd',NULL,NULL,NULL,NULL,1,237.343167,33.64258,0.073,NULL,59889623439,935775366,14621490,17.6),(132835,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132835,37.35,0.46,295,62299,70,NULL,NULL,'2MASX J15492240+1151028',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,237.3434583,11.85081,0.081,NULL,56599859545,884372805,13818325,16.7),(132836,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132836,38.55,0.46,514,62300,70,NULL,NULL,'2MASX J15492242+2625543',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000142,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,237.3435417,26.43164,0.141,NULL,59872877278,935513707,14617401,18.4),(132837,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132837,37.52,0.46,319,62301,70,NULL,NULL,'2MASX J15492248+2737063',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.343875,27.61844,0.081,NULL,59871734181,935495846,14617122,17.5),(132838,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132838,37.13,0.46,266,62302,70,NULL,NULL,'2MASX J15492260+3617040',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,237.3442083,36.28433,0.057,NULL,59880151935,935627373,14619177,16.9),(132839,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132839,37.41,0.21,304,62303,70,NULL,NULL,'2MASX J15492286+0854088',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000175,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,237.345167,8.90228,0.069,NULL,56625241838,884769403,13824521,17.5),(132840,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132840,37.25,0.33,282,62304,70,NULL,NULL,'2MASX J15492295+0438300',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,237.345708333,4.64178,0.205,NULL,56619293349,884676458,13823069,17.3),(132841,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132841,37.98,0.46,395,62305,70,NULL,NULL,'SDSS J154923.25+385741.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.346875,38.96161,0.061,NULL,59761484661,933773197,14590206,18.1),(132842,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132842,37.84,0.33,370,62306,70,NULL,NULL,'2MASX J15492541+0746128',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000155,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,237.3557917,7.77011,0.093,NULL,56625945844,884780403,13824693,17),(132843,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132843,36.69,0.33,218,62307,70,NULL,NULL,'2MASX J15492536+2059531',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000186,NULL,'16.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,237.3557917,20.99814,0.121,NULL,59402820841,928169075,14502641,16.4),(132844,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132844,33.59,0.46,52.3,62308,70,NULL,NULL,'NGC 6003',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.00004,NULL,'14.30',0.9,'S0?','in a radial-velocity based grouping',NULL,NULL,NULL,1,237.356833,19.03208,0.041,NULL,59446871724,928857370,14513396,14.3),(132845,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132845,36,0.2,158,62309,74.4,NULL,NULL,'CGCG 136-088',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.000083,NULL,'14.8g',0.51,'Sa',NULL,NULL,NULL,NULL,1,237.3674583,21.03411,0.121,NULL,59402829146,928169205,14502643,14.8),(132846,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132846,38.5,0.46,500,62310,70,NULL,NULL,'2MASX J15493076+2617343',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.8g',0.19,'BrClG',NULL,NULL,NULL,NULL,1,237.378291667,26.29278,0.153,NULL,59872903083,935514110,14617407,17.8),(132847,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132847,33.4,0.2,47.9,62311,74.4,NULL,NULL,'CGCG 136-089',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',NULL,NULL,'15.00',0.8,'S(B)b',NULL,NULL,NULL,NULL,1,237.385625,20.64514,0.117,NULL,59402259043,928160297,14502504,15),(132848,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132848,37.87,0.17,375,62312,70,NULL,NULL,'2MASX J15493317+1902181',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,237.388291667,19.03844,0.041,NULL,59446874071,928857407,14513396,17.7),(132849,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132849,37.41,0.21,304,62313,70,NULL,NULL,'2MASX J15493367+0901008',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000181,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,237.390125,9.01692,0.069,NULL,56636743478,884949116,13827329,17.1),(132850,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132850,36.85,0.46,235,62314,70,NULL,NULL,'2MASX J15493433+1359577',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'17.15',NULL,NULL,NULL,NULL,NULL,NULL,1,237.392958333,13.99931,0.097,NULL,56538596437,883415569,13803368,17.15),(132851,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132851,37.87,0.17,375,62315,70,NULL,NULL,'2MASX J15493621+1905321',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.400791667,19.09208,0.057,NULL,59446804713,928856323,14513380,17.9),(132852,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132852,36.42,0.46,192,62316,70,NULL,NULL,'2MASX J15493623+3342084',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000163,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,237.401083,33.70225,0.073,NULL,59889625771,935775402,14621490,16.6),(132853,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132853,33.15,0.69,42.7,62317,100,NULL,'mid-IR','ESO 329- G 022',NULL,'2013ApJ...771...88L',2013,1,1.5,NULL,'G',0.000021,NULL,'16.1R',0.7,'SB(s)cd:',NULL,NULL,NULL,NULL,1,237.405083,-40.32672,0.549,NULL,46373192230,724581128,11321580,16.1),(132854,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132854,33.46,0.2,49.2,62317,74.4,NULL,NULL,'ESO 329- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132855,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132855,33.7,0.33,55,62317,NULL,NULL,NULL,'ESO 329- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132856,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132856,33.95,0.3,61.6,62317,NULL,NULL,'Malmquist cor.','ESO 329- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132857,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132857,34.03,0.4,64,62317,NULL,NULL,'mean','ESO 329- G 022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132858,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132858,34.2,0.47,69.3,62317,NULL,NULL,'H','ESO 329- G 022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132859,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132859,35.85,0.33,148,62318,70,NULL,NULL,'CGCG 222-052',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.00019,NULL,'14.3g',0.77,'E','Group member',NULL,NULL,NULL,1,237.409375,42.03422,0.049,NULL,59678287109,932473236,14569894,14.3),(132860,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132860,38.47,0.33,493,62319,70,NULL,NULL,'SDSS J154939.21+325330.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'18.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,237.413375,32.89189,0.069,NULL,59889839976,935778749,14621542,18.1),(132861,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132861,37.82,0.23,367,62320,70,NULL,NULL,'2MASX J15494199+2831363',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,'PHOT','15.7g',0.45,'BrClG',NULL,NULL,NULL,NULL,1,237.425,28.52675,0.089,NULL,59866407694,935412620,14615822,15.7),(132862,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132862,38.21,0.27,438,62321,70,NULL,NULL,'2MASX J15494214+2910223',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000168,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,237.4255,29.17294,0.093,NULL,59922031212,936281737,14629402,18.6),(132863,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132863,36.72,0.64,221,62322,70,NULL,NULL,'2MASX J15494297-0519237',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,237.429125,-5.32328,0.525,NULL,45597132388,712455193,11132112,14.6),(132864,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132864,38.28,0.46,452,62323,70,NULL,NULL,'2MASX J15494523+2636023',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,237.438375,26.60067,0.117,NULL,59872149527,935502336,14617224,18.5),(132865,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132865,37.88,0.33,377,62324,70,NULL,NULL,'2MASX J15494738+4018304',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000174,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,237.447375,40.30853,0.053,NULL,59794891722,934295183,14598362,16.9),(132866,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132866,37.87,0.17,375,62325,70,NULL,NULL,'2MASX J15494752+1906276',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,237.448083,19.10778,0.057,NULL,59446297069,928848391,14513256,16.5),(132867,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132867,36.99,0.27,250,62326,70,NULL,NULL,'2MASX J15494784+5121029',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000084,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,237.449417,51.35078,0.017,NULL,59717616466,933087757,14579496,16.6),(132868,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132868,35.85,0.33,148,62327,70,NULL,NULL,'CGCG 222-053',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000107,NULL,'15.4g',0.5,'E0','Group member',NULL,NULL,NULL,1,237.450833,41.98636,0.049,NULL,59678293041,932473328,14569895,15.4),(132869,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132869,36.12,0.46,167,62328,70,NULL,NULL,'2MASX J15494836+3800104',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00018,NULL,'16.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,237.451417,38.00292,0.061,NULL,59760713500,933761148,14590017,16.2),(132870,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132870,37.25,0.33,282,62329,70,NULL,NULL,'2MASX J15494920+0443590',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,237.454875,4.73297,0.197,NULL,56619295719,884676495,13823070,16.7),(132871,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132871,36.71,0.46,220,62330,70,NULL,NULL,'2MASX J15494933+0814497',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,237.455583,8.24722,0.085,NULL,56625807031,884778234,13824659,17.9),(132872,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132872,36.99,0.27,250,62331,70,NULL,NULL,'2MASX J15494942+5123549',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000106,NULL,'15.9g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,237.455833,51.39875,0.021,NULL,59718320572,933098758,14579668,15.9),(132873,'Sosies','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132873,32.73,0.62,35.2,62332,NULL,NULL,NULL,'NGC 6000',NULL,'2002A&A...393...57T',2002,1,1.9,NULL,'G',0.000003,NULL,'13.01',1.6,'SB(s)bc:;HII   Sbrst','Group member, radial-velocity confirmed',NULL,NULL,'H II',1,237.4564583,-29.38683,0.669,NULL,47166167845,736971372,11515177,13.01),(132874,'Tully est','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132874,32.39,0.8,30.1,62332,75,NULL,NULL,'NGC 6000',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132875,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132875,31.8,0.45,22.9,62332,NULL,NULL,'K','NGC 6000',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132876,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132876,31.87,0.47,23.7,62332,NULL,NULL,'H','NGC 6000',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132877,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132877,31.93,0.46,24.3,62332,NULL,NULL,'J','NGC 6000',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132878,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132878,32.24,0.4,28.1,62332,NULL,NULL,'mean','NGC 6000',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132879,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132879,36.99,0.27,250,62333,70,NULL,NULL,'2MASX J15495019+5119599',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000104,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,237.459333,51.3335,0.017,NULL,59717648781,933088262,14579504,16.2),(132880,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132880,37.41,0.15,304,62334,70,NULL,NULL,'2MASX J15495087+2536028',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,237.461875,25.60078,0.165,NULL,59871341631,935489712,14617026,17.5),(132881,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132881,34.25,0.46,70.9,62335,70,NULL,NULL,'MCG -01-40-007',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.000093,NULL,'16',0.25,NULL,NULL,NULL,NULL,NULL,1,237.4650417,-7.48006,0.505,NULL,45620456199,712819628,11137806,16),(132882,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132882,37.86,0.46,374,62336,70,NULL,NULL,'2MASX J15495255+0507140',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,237.468875,5.12064,0.181,NULL,56619854811,884685231,13823206,17.8),(132883,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132883,37.04,0.46,255,62337,70,NULL,NULL,'2MASX J15495297+0837301',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,237.47075,8.62511,0.057,NULL,56636841604,884950650,13827353,17.1),(132884,'IRAS','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132884,34.92,0.8,96.2,62338,75,NULL,'MAT, I','ESO 583- G 007',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00002,NULL,'15',1,'SB(rs)c',NULL,NULL,NULL,NULL,1,237.476833333,-21.04936,0.705,NULL,46579838267,727809972,11372030,15),(132885,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132885,34.91,0.47,95.8,62338,NULL,NULL,'H','ESO 583- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132886,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132886,34.93,0.46,96.9,62338,NULL,NULL,'J','ESO 583- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132887,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132887,34.95,0.43,97.7,62338,75,NULL,'MAT, I, raw','ESO 583- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132888,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132888,34.97,0.45,98.5,62338,NULL,NULL,'K','ESO 583- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132889,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132889,35.03,0.32,101,62338,85,NULL,'I, raw','ESO 583- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132890,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132890,35.06,0.4,103,62338,NULL,NULL,'mean','ESO 583- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132891,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132891,35.11,0.32,105,62338,85,NULL,'I, inv','ESO 583- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132892,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132892,35.21,0.4,110,62338,NULL,NULL,'Malmquist cor.','ESO 583- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132893,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132893,35.25,0.43,112,62338,75,NULL,'MAT, I, cor','ESO 583- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132894,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132894,35.29,0.43,115,62338,75,NULL,'MAT, I, inv','ESO 583- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132895,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132895,35.51,0.35,127,62338,NULL,NULL,NULL,'ESO 583- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132896,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132896,35.56,0.2,129,62338,74.4,NULL,NULL,'ESO 583- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132897,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132897,37.06,0.46,259,62339,70,NULL,NULL,'2MASX J15495560+5523455',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000096,NULL,'16.3g',0.37,'AGN',NULL,NULL,NULL,NULL,1,237.4815417,55.39606,0.005,NULL,57641774545,900652727,14072698,16.3),(132898,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132898,37.82,0.23,367,62340,70,NULL,NULL,'SDSS J154956.22+283049.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000148,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,237.484291667,28.51369,0.089,NULL,59866377674,935412151,14615814,18.6),(132899,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132899,36.36,0.46,187,62341,70,NULL,NULL,'2MASX J15495738+2223476',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000153,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,237.4892083,22.39658,0.189,NULL,59404548348,928196067,14503063,16.7),(132900,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132900,32.2,NULL,27.5,62342,72,NULL,NULL,'AGC 258343',NULL,'2014Ap.....57..457K',2014,1,NULL,NULL,'RadioS',0.000097,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,237.4925,5.51472,0.157,NULL,56617001094,884640642,13822510,NULL),(132901,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132901,37.65,0.46,339,62343,70,NULL,NULL,'2MASX J15495926+2733498',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.4970417,27.56383,0.081,NULL,59871727579,935495743,14617120,17.7),(132902,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132902,34.42,0.59,76.6,62344,70,NULL,NULL,'2MASX J15495933-3954432',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,237.497333,-39.91203,0.453,NULL,46373135387,724580240,11321566,15.5),(132903,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132903,36.43,0.46,193,62345,70,NULL,NULL,'2MASX J15495952+0426114',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,237.4979583,4.43653,0.205,NULL,56622857800,884732153,13823939,16.4),(132904,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132904,35.5,0.46,126,62346,70,NULL,NULL,'2MASX J15495976+2111226',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000098,NULL,'16.0g',0.29,'AGN+SF',NULL,NULL,NULL,NULL,1,237.499083,21.18964,0.121,NULL,59402734289,928167723,14502620,16),(132905,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132905,37.13,0.33,267,62347,70,NULL,NULL,'2MASX J15495989+2705598',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000186,NULL,'15.9g',0.42,NULL,NULL,NULL,NULL,NULL,1,237.4995417,27.10006,0.105,NULL,59872232433,935503631,14617244,15.9),(132906,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132906,36.39,0.58,189,62348,70,NULL,NULL,'2MASX J15500012-0535597',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,237.5005,-5.59983,0.513,NULL,45589042394,712328787,11130137,15.8),(132907,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132907,35.92,0.46,153,62349,70,NULL,NULL,'2MASX J15500130+1054221',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,237.505541667,10.90625,0.093,NULL,56601336926,884395889,13818685,16.7),(132908,'IRAS','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132908,35.24,0.8,112,62350,75,NULL,'MAT, I','CGCG 022-042',NULL,'1997ApJS..109..333W',1997,1,1.79,NULL,'G',0.000017,NULL,'15.24',0.24,'Sc             HII','Isolated galaxy',NULL,NULL,NULL,1,237.509333,-2.82331,0.505,NULL,45586404207,712287565,11129493,15.24),(132909,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132909,34.63,0.49,84.3,62350,75,NULL,'IR','CGCG 022-042',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132910,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132910,34.69,0.43,86.8,62350,75,NULL,'MAT, I, raw','CGCG 022-042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132911,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132911,34.86,0.32,93.8,62350,85,NULL,'I, raw','CGCG 022-042',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132912,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132912,34.87,0.2,94.2,62350,74.4,NULL,NULL,'CGCG 022-042',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132913,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132913,34.91,0.32,96.1,62350,85,NULL,'I, inv','CGCG 022-042',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132914,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132914,34.93,0.43,96.8,62350,75,NULL,'MAT, I, inv','CGCG 022-042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132915,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132915,34.98,NULL,99.2,62350,NULL,NULL,'Dipole','CGCG 022-042',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132916,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132916,34.99,NULL,99.5,62350,NULL,NULL,'Dipole + Quadrupole','CGCG 022-042',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132917,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132917,34.99,NULL,99.6,62350,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 022-042',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132918,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132918,35,0.48,100,62350,NULL,NULL,NULL,'CGCG 022-042',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132919,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132919,35.03,0.47,102,62350,NULL,NULL,'Malmquist cor.','CGCG 022-042',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132920,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132920,35.1,0.43,104,62350,75,NULL,'MAT, I, cor','CGCG 022-042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132921,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132921,37.01,0.46,252,62351,70,NULL,NULL,'2MASX J15500313+5258470',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000094,NULL,'16.6g',0.28,'Cand.grav.lens',NULL,NULL,NULL,NULL,1,237.513,52.97958,0.025,NULL,59715265463,933051022,14578922,16.6),(132922,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132922,36.69,0.33,218,62352,70,NULL,NULL,'2MASX J15500482+2057216',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,237.520125,20.95614,0.121,NULL,59402878185,928169971,14502655,16.9),(132923,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132923,34.39,0.43,75.6,62353,75,NULL,'3.6 micron, color + selection bias corrected','ESO 515- G 010',NULL,'2014MNRAS.444..527S',2014,1,1.4,NULL,'G',0.00003,NULL,'10.6K',0.6,'Sb:            HII',NULL,NULL,NULL,NULL,1,237.5207083,-23.63886,0.681,NULL,46583488356,727867005,11372921,10.6),(132924,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132924,37.95,0.46,389,62354,70,NULL,NULL,'2MASX J15500554+4413235',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,237.522958333,44.22306,0.033,NULL,59691574532,932680852,14573138,17.5),(132925,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132925,37.79,0.11,362,62355,70,NULL,NULL,'2MASX J15500558+2754209',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000189,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,237.5234583,27.90589,0.081,NULL,59873801115,935528142,14617627,16.3),(132926,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132926,37.87,0.17,375,62356,70,NULL,NULL,'2MASX J15500656+1857506',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'16.1g',0.4,'BrClG',NULL,NULL,NULL,NULL,1,237.527375,18.964,0.041,NULL,59446812505,928856445,14513381,16.1),(132927,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132927,37.82,0.23,367,62357,70,NULL,NULL,'SDSS J155007.96+283719.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000081,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,237.5332083,28.622,0.089,NULL,59866401194,935412518,14615820,18.5),(132928,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132928,38.47,0.33,493,62358,70,NULL,NULL,'2MASX J15500895+3253554',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.537167,32.89861,0.069,NULL,59889833762,935778652,14621541,17.8),(132929,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132929,37.41,0.46,304,62359,70,NULL,NULL,'2MASX J15501028-0100007',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000121,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,237.543,-1.00028,0.365,NULL,45520447229,711256987,11113390,16.3),(132930,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132930,37.67,0.46,342,62360,70,NULL,NULL,'2MASX J15501058+1238270',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,237.544208333,12.64092,0.101,NULL,56529721122,883276892,13801201,17),(132931,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132931,37.9,0.46,380,62361,70,NULL,NULL,'2MASX J15501092+2738078',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000182,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,237.545375,27.6355,0.081,NULL,59873758023,935527469,14617616,17.8),(132932,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132932,36.81,0.46,230,62362,70,NULL,NULL,'2MASX J15501325+3628114',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000145,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.555333,36.46989,0.045,NULL,59880066283,935626035,14619156,17.8),(132933,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132933,37.87,0.17,375,62363,70,NULL,NULL,'2MASX J15501416+1857367',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000176,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,237.558916667,18.96011,0.041,NULL,59446810193,928856409,14513381,17.7),(132934,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132934,37.51,0.46,318,62364,70,NULL,NULL,'2MASX J15501428+4701196',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000188,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,237.559417,47.02219,0.069,NULL,59712447181,933006987,14578234,16.9),(132935,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132935,37.39,0.46,301,62365,70,NULL,NULL,'SDSS J155015.64+082355.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000158,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,237.5652083,8.39875,0.089,NULL,56637654991,884963359,13827552,18.4),(132936,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132936,38.21,0.27,438,62366,70,NULL,NULL,'SDSS J155015.82+291215.3',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000175,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,237.565917,29.20425,0.093,NULL,59922045671,936281963,14629405,18.5),(132937,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132937,37.13,0.33,267,62367,70,NULL,NULL,'2MASX J15501716+2716042',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'17.42',0.47,NULL,NULL,NULL,NULL,NULL,1,237.5715417,27.26783,0.073,NULL,59872237334,935503708,14617245,17.42),(132938,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132938,37.41,0.15,304,62368,70,NULL,NULL,'2MASX J15501803+2538252',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,237.575083,25.64028,0.165,NULL,59871367173,935490112,14617033,16.9),(132939,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132939,37.65,0.33,339,62369,70,NULL,NULL,'2MASX J15501852+1943237',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,237.57725,19.72319,0.101,NULL,59400262553,928129102,14502017,17.4),(132940,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132940,37.87,0.17,375,62370,70,NULL,NULL,'2MASX J15501875+1854267',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,237.578166667,18.9075,0.041,NULL,59446841013,928856890,14513388,17.6),(132941,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132941,37.15,0.46,269,62371,70,NULL,NULL,'2MASX J15501960+3822445',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000164,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,237.581583,38.37908,0.025,NULL,59760942474,933764726,14590073,16.7),(132942,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132942,37.16,0.46,271,62372,70,NULL,NULL,'2MASX J15501959+4407467',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000158,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.5817917,44.12969,0.025,NULL,59691572294,932680817,14573137,17.8),(132943,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132943,37.56,0.46,326,62373,70,NULL,NULL,'2MASX J15502081+3602335',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000189,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,237.5867917,36.04267,0.049,NULL,59880143720,935627245,14619175,16.7),(132944,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132944,37.88,0.33,377,62374,70,NULL,NULL,'2MASX J15502114+4021475',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000186,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,237.58825,40.36319,0.045,NULL,59795028589,934297321,14598395,16.3),(132945,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132945,37.95,0.46,389,62375,70,NULL,NULL,'SDSS J155021.55+281247.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.589833,28.21319,0.077,NULL,59873936094,935530251,14617660,18.1),(132946,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132946,37.22,0.27,278,62376,70,NULL,NULL,'2MASX J15502179+2818473',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,237.59075,28.313,0.085,NULL,59873732468,935527069,14617610,16.9),(132947,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132947,32.97,0.64,39.3,62377,NULL,NULL,'Malmquist cor.','NGC 6004',NULL,'2009ApJS..182..474S',2009,1,1.9,NULL,'G',0.000023,NULL,'13.11',1.7,'SAB(rs)bc','in a radial-velocity based grouping',NULL,NULL,NULL,1,237.594666667,18.93928,0.041,NULL,59446839944,928856874,14513388,13.11),(132948,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132948,33.05,0.61,40.8,62377,NULL,NULL,NULL,'NGC 6004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132949,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132949,33.09,0.2,41.5,62377,74.4,NULL,NULL,'NGC 6004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132950,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132950,35.61,0.46,133,62378,70,NULL,NULL,'2MASX J15502410+3023464',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000177,NULL,'15.8g',0.35,NULL,NULL,NULL,NULL,NULL,1,237.600417,30.39617,0.077,NULL,59923380483,936302820,14629731,15.8),(132951,'Tully est','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132951,32.68,0.8,34.4,62379,75,NULL,NULL,'UGC 10058',NULL,'1988NBGC.C....0000T',1988,1,1.1,NULL,'G',0.000013,NULL,'17.',0.8,'SB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,237.6007917,25.92247,0.165,NULL,59870917314,935483083,14616923,17),(132952,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132952,34.21,0.4,69.5,62379,NULL,NULL,NULL,'UGC 10058',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132953,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132953,37.72,0.46,351,62380,70,NULL,NULL,'2MASX J15502427+0022349',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000106,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,237.601083333,0.37633,0.309,NULL,56475812049,882434563,13788040,17.3),(132954,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132954,37.22,0.27,278,62381,70,NULL,NULL,'2MASX J15502444+2819513',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000183,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,237.602,28.33094,0.085,NULL,59873731836,935527059,14617610,16.3),(132955,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132955,38.21,0.27,438,62382,70,NULL,NULL,'SDSS J155024.70+285931.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,237.602917,28.99214,0.097,NULL,59866499634,935414056,14615844,18.5),(132956,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132956,38,0.46,399,62383,70,NULL,NULL,'SDSS J155025.40+071810.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000174,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,237.605833,7.30289,0.069,NULL,56624458623,884757165,13824330,17.6),(132957,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132957,37.07,0.33,259,62384,70,NULL,NULL,'2MASX J15502601+3029524',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000157,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,237.608375,30.49803,0.077,NULL,59923377552,936302774,14629730,17),(132958,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132958,37.87,0.17,375,62385,70,NULL,NULL,'2MASX J15502734+1857207',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000186,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,237.6139583,18.95572,0.041,NULL,59446850954,928857046,14513391,16.9),(132959,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132959,37.07,0.33,259,62386,70,NULL,NULL,'2MASX J15502756+3028474',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000194,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,237.6147917,30.47975,0.077,NULL,59923377118,936302767,14629730,16.4),(132960,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132960,37.6,0.46,331,62387,70,NULL,NULL,'2MASX J15503362+0348069',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.640125,3.80183,0.277,NULL,56622973544,884733961,13823968,18),(132961,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132961,37.64,0.46,338,62388,70,NULL,NULL,'2MASX J15503559+2858173',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00017,NULL,'16.4g',0.33,'E',NULL,NULL,NULL,NULL,1,237.6482083,28.9715,0.097,NULL,59866512191,935414252,14615847,16.4),(132962,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132962,37.79,0.11,362,62389,70,NULL,NULL,'2MASX J15503570+2753243',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000184,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,237.648833,27.89006,0.081,NULL,59873806984,935528234,14617628,17.3),(132963,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132963,37.96,0.46,391,62390,70,NULL,NULL,'2MASX J15503663+3548464',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000181,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,237.6524583,35.813,0.049,NULL,59891759761,935808746,14622011,16.6),(132964,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132964,37.65,0.33,339,62391,70,NULL,NULL,'2MASX J15503765+1945587',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000172,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,237.656958333,19.76639,0.101,NULL,59400319103,928129985,14502031,17.1),(132965,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132965,37.42,0.46,305,62392,70,NULL,NULL,'2MASX J15504088+1132572',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,237.670333,11.54936,0.097,NULL,56599657315,884369645,13818275,17.5),(132966,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132966,37.1,0.46,263,62393,70,NULL,NULL,'2MASX J15504104+4238196',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000181,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,237.6710417,42.63875,0.057,NULL,59678621086,932478454,14569975,16.5),(132967,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132967,36.24,0.46,177,62394,70,NULL,NULL,'2MASX J15504156+1211194',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'16.66',0.44,NULL,NULL,NULL,NULL,NULL,1,237.673083,12.18883,0.077,NULL,56599614426,884368975,13818265,16.66),(132968,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132968,34.56,0.46,81.7,62395,70,NULL,NULL,'MCG -01-40-008',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000033,NULL,'14.9',0.3,NULL,NULL,NULL,NULL,NULL,1,237.6822917,-7.56056,0.505,NULL,45631146748,712986667,11140416,14.9),(132969,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132969,35.31,0.4,115,62395,NULL,NULL,'mean','MCG -01-40-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132970,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132970,35.42,0.45,121,62395,NULL,NULL,'K','MCG -01-40-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132971,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132971,37.41,0.15,304,62396,70,NULL,NULL,'2MASX J15504444+2544142',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,237.68525,25.73739,0.165,NULL,59870901152,935482830,14616919,16.1),(132972,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132972,38.06,0.46,408,62397,70,NULL,NULL,'2MASX J15504602+0620011',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,237.69175,6.33375,0.117,NULL,56624400161,884756252,13824316,17.7),(132973,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132973,37.51,0.46,318,62398,70,NULL,NULL,'2MASX J15504748+2027201',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000185,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.697875,20.45572,0.069,NULL,59402201728,928159402,14502490,17.8),(132974,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132974,37.71,0.27,348,62399,70,NULL,NULL,'2MASX J15504752+5328039',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000095,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,237.698166667,53.46792,0.017,NULL,59714566537,933040102,14578751,17),(132975,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132975,38.04,0.46,405,62400,70,NULL,NULL,'SDSS J155047.75+275646.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000139,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,237.699,27.94619,0.065,NULL,59873779514,935527804,14617621,18.3),(132976,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132976,36.72,0.68,221,62401,70,NULL,NULL,'2MASX J15504903-1511382',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,237.704333,-15.194,0.561,NULL,45479369034,710615141,11103361,15.6),(132977,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132977,35.67,0.27,136,62402,70,NULL,NULL,'CGCG 078-082',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',NULL,NULL,'15.6',0.3,NULL,NULL,NULL,NULL,NULL,1,237.706833,13.28864,0.101,NULL,56529499649,883273432,13801147,15.6),(132978,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132978,35.28,0.62,114,62403,70,NULL,NULL,'MCG -01-40-009',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000133,NULL,'16',0.4,NULL,NULL,NULL,NULL,NULL,1,237.706875,-7.66628,0.505,NULL,45632980340,713015317,11140864,16),(132979,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132979,37.73,0.27,352,62404,70,NULL,NULL,'2MASX J15505038+2832503',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000143,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.7099583,28.54728,0.089,NULL,59866581686,935415338,14615864,17.6),(132980,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132980,35.15,0.2,107,62405,74.4,NULL,NULL,'UGC 10059',NULL,'2013AJ....146...86T',2013,1,0.97,NULL,'G',0.000033,NULL,'15.5g',0.57,'Scd:',NULL,NULL,NULL,NULL,1,237.7110417,22.23869,0.165,NULL,59404744461,928199132,14503111,15.5),(132981,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132981,37.22,0.27,278,62406,70,NULL,NULL,'2MASX J15505087+2815523',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.0002,NULL,'15.5g',0.49,'E0',NULL,NULL,NULL,NULL,1,237.711917,28.26453,0.085,NULL,59873915179,935529924,14617655,15.5),(132982,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132982,38.32,0.46,461,62407,70,NULL,NULL,'2MASX J15505115+3200219',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,237.713167,32.00614,0.073,NULL,59923507972,936304812,14629762,18.2),(132983,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132983,37.73,0.27,352,62408,70,NULL,NULL,'SDSS J155052.71+281433.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,237.719625,28.24264,0.081,NULL,59873913696,935529901,14617654,18.7),(132984,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132984,37.29,0.46,287,62409,70,NULL,NULL,'2MASX J15505414+0806299',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000187,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,237.72575,8.10817,0.085,NULL,56637220962,884956577,13827446,16.4),(132985,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132985,37.01,0.46,253,62410,70,NULL,NULL,'2MASX J15505493+1729264',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.728875,17.49075,0.061,NULL,59429947576,928592930,14509264,17.5),(132986,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132986,37.36,0.46,296,62411,70,NULL,NULL,'2MASX J15505703+3256149',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00017,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,237.7375417,32.93758,0.073,NULL,59889884835,935779450,14621553,16.6),(132987,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132987,37.87,0.27,376,62412,70,NULL,NULL,'2MASX J15505768+1230485',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,237.74025,12.51336,0.109,NULL,56529162077,883268157,13801064,18.3),(132988,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132988,37.57,0.46,326,62413,70,NULL,NULL,'2MASX J15510101+1916422',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,237.754167,19.27833,0.073,NULL,59446288904,928848264,14513254,17.6),(132989,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132989,34.8,0.46,91.2,62414,70,NULL,NULL,'CGCG 136-095',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000073,NULL,'15.1g',0.64,NULL,NULL,NULL,NULL,NULL,1,237.7557083,23.01578,0.173,NULL,59407351771,928239871,14503747,15.1),(132990,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132990,34.56,0.2,81.7,62415,74.4,NULL,NULL,'CGCG 078-083 NED01',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000344,NULL,'16.2g',0.1,NULL,NULL,NULL,NULL,NULL,1,237.756625,10.03056,0.085,NULL,56601016654,884390885,13818607,16.2),(132991,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132991,34.64,0.2,84.7,62416,74.4,NULL,NULL,'KUG 1548+241',NULL,'2013AJ....146...86T',2013,1,0.77,NULL,'G',0.000073,NULL,'15.4g',0.43,'Spiral',NULL,NULL,NULL,NULL,1,237.757583,23.96011,0.157,NULL,59398523721,928101933,14501592,15.4),(132992,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132992,36.87,0.46,237,62417,70,NULL,NULL,'2MASX J15510304+0848189',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000153,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,237.7627083,8.80525,0.121,NULL,56636935726,884952120,13827376,16.9),(132993,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132993,35.63,0.46,133,62418,70,NULL,NULL,'2MASX J15510394+4241236',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000188,NULL,'15.6g',0.47,'E0',NULL,NULL,NULL,NULL,1,237.766333,42.68981,0.049,NULL,59678617571,932478399,14569974,15.6),(132994,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132994,37.36,0.27,296,62419,70,NULL,NULL,'2MASX J15510438+3432050',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000172,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,237.76825,34.53481,0.065,NULL,59887779853,935746560,14621040,16.5),(132995,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132995,35.24,0.65,112,62420,70,NULL,NULL,'2MASX J15510443-0726340',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00012,NULL,'16.84',NULL,NULL,NULL,NULL,NULL,NULL,1,237.768458333,-7.44292,0.493,NULL,45631207540,712987617,11140431,16.84),(132996,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132996,37.39,0.46,300,62421,70,NULL,NULL,'2MASX J15510564+2118512',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000187,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,237.773417,21.31414,0.129,NULL,59402483216,928163800,14502559,16.6),(132997,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132997,36.38,0.46,189,62422,70,NULL,NULL,'SDSS J155105.78+201415.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000173,NULL,'17.4g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,237.774125,20.23756,0.081,NULL,59403354603,928177415,14502772,17.4),(132998,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132998,36.43,0.49,193,62423,75,NULL,'IR','2MFGC 12731',NULL,'2011yCatp016004901K',2011,1,0.95,NULL,'G',0.000175,NULL,'16.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,237.775083,50.37528,0.033,NULL,59725091109,933204548,14581321,16.7),(132999,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132999,37.27,0.27,284,62424,70,NULL,NULL,'2MASX J15510641+5250449',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000107,NULL,'16.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,237.7764583,52.84583,0.013,NULL,59715345395,933052271,14578941,16.6),(133000,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133000,37.45,0.46,309,62425,70,NULL,NULL,'2MASX J15510677+0707349',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,237.7782917,7.12633,0.069,NULL,56638413847,884975216,13827737,17.2),(133001,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133001,37.71,0.27,348,62426,70,NULL,NULL,'2MASX J15510688+5324430',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000081,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,237.778625,53.41186,0.017,NULL,59714564534,933040070,14578751,17.3),(133002,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133002,37.79,0.11,362,62427,70,NULL,NULL,'2MASX J15510684+2751234',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000177,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,237.7787083,27.8565,0.065,NULL,59873781000,935527828,14617622,17.1),(133003,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133003,37.93,0.46,386,62428,70,NULL,NULL,'2MASX J15510715+0839439',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00017,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,237.779916667,8.66225,0.121,NULL,56637699167,884964049,13827563,18.3),(133004,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133004,36.52,NULL,202,62429,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1962',NULL,'2010Ap&SS.325..163P',2010,1,0.77,NULL,'G',NULL,NULL,'16.8',0.09,'Sc',NULL,NULL,NULL,NULL,1,237.78,50.375,0.033,NULL,59725091122,933204548,14581321,16.8),(133005,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133005,36.53,NULL,202,62429,NULL,NULL,NULL,'FGC 1962',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133006,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133006,36.55,NULL,204,62429,NULL,NULL,'Dipole + Quadrupole','FGC 1962',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133007,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133007,36.59,NULL,208,62429,NULL,NULL,'Dipole','FGC 1962',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133008,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133008,37.27,0.27,284,62430,70,NULL,NULL,'2MASX J15510960+5247449',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000083,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.790041667,52.79583,0.013,NULL,59715334385,933052099,14578939,17.3),(133009,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133009,36.4,0.46,191,62431,70,NULL,NULL,'2MASX J15510971+4510106',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000176,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,237.7904583,45.16961,0.049,NULL,59689727908,932651998,14572687,16.4),(133010,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133010,36.69,0.46,218,62432,70,NULL,NULL,'SDSS J155109.79+501245.6',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000138,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,237.790833,50.21269,0.037,NULL,59725106587,933204790,14581324,17.3),(133011,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133011,37.4,0.46,302,62433,70,NULL,NULL,'2MASX J15511038+0829409',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000179,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,237.793208333,8.49472,0.093,NULL,56637676763,884963699,13827557,16.9),(133012,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133012,36.5,0.46,200,62434,70,NULL,NULL,'2MASX J15511146+0953169',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000176,NULL,'16.2g',0.38,'E0',NULL,NULL,NULL,NULL,1,237.7977083,9.88808,0.085,NULL,56600107714,884376683,13818385,16.2),(133013,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133013,37.71,0.27,348,62435,70,NULL,NULL,'SDSS J155111.56+532957.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000076,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,237.7982083,53.49925,0.017,NULL,59714554566,933039915,14578748,18.3),(133014,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133014,38.06,0.46,409,62436,70,NULL,NULL,'2MASX J15511157+0019109',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.0001,NULL,'16.9g',0.26,'AGN',NULL,NULL,NULL,NULL,1,237.7982917,0.31961,0.301,NULL,56475801379,882434396,13788037,16.9),(133015,'IRAS','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133015,35.09,0.8,104,62437,75,NULL,'CF, r','UGC 10062',NULL,'1997ApJS..109..333W',1997,1,1.28,NULL,'G',0.000033,NULL,'14.9g',0.62,'Scd:',NULL,NULL,NULL,NULL,1,237.799375,21.94264,0.161,NULL,59404749305,928199207,14503112,14.9),(133016,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133016,34.46,0.38,77.9,62437,75,NULL,'CF, r, raw','UGC 10062',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133017,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133017,34.54,0.38,81,62437,75,NULL,'CF, r, inv','UGC 10062',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133018,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133018,34.61,0.38,83.4,62437,75,NULL,'CF, r, cor','UGC 10062',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133019,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133019,34.68,0.2,86.3,62437,74.4,NULL,NULL,'UGC 10062',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133020,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133020,33.99,0.49,62.8,62438,70,NULL,NULL,'ESO 042- G 012',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00012,NULL,'14.3b',0.8,'S0-a',NULL,NULL,NULL,NULL,1,237.80125,-74.70256,0.365,NULL,44123135527,689423992,10772249,14.3),(133021,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133021,37.66,0.46,340,62439,70,NULL,NULL,'2MASX J15511438+3722392',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000173,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.809916667,37.37744,0.037,NULL,59762251218,933785175,14590393,17.8),(133022,'Tully est','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133022,32.61,0.8,33.2,62440,75,NULL,NULL,'UGC 10061',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.000013,NULL,'14.0',1.8,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,237.812875,16.32956,0.065,NULL,56535000092,883359376,13802490,14),(133023,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133023,37.42,0.46,305,62441,70,NULL,NULL,'2MASX J15511597+2217580',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000183,NULL,'17.9g',0.11,NULL,NULL,NULL,NULL,NULL,1,237.816625,22.29936,0.165,NULL,59404620588,928197196,14503081,17.9),(133024,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133024,37.82,0.46,366,62442,70,NULL,NULL,'2MASX J15511598+0231039',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000084,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,237.816667,2.51767,0.333,NULL,56608250534,884503914,13820373,18.5),(133025,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133025,37.88,0.46,377,62443,70,NULL,NULL,'2MASX J15511939+2847231',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.83075,28.78981,0.133,NULL,59866607634,935415744,14615871,17.7),(133026,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133026,35.97,0.46,157,62444,70,NULL,NULL,'2MASX J15511952+0642162',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000163,NULL,'16.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,237.831291667,6.70464,0.085,NULL,56637919779,884967496,13827617,16.3),(133027,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133027,36.84,0.46,233,62445,70,NULL,NULL,'2MASX J15512177+0538569',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000176,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,237.840666667,5.64925,0.141,NULL,56619158846,884674356,13823036,16.9),(133028,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133028,37.51,0.46,318,62446,70,NULL,NULL,'2MASX J15512203+4703275',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000181,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,237.84175,47.05761,0.053,NULL,59712417143,933006517,14578226,16.7),(133029,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133029,39.22,0.46,700,62447,70,NULL,NULL,'SDSS J155122.85+181832.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,237.84525,18.30908,0.037,NULL,59446021731,928844089,14513188,18.2),(133030,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133030,37.19,0.46,274,62448,70,NULL,NULL,'2MASX J15512360+4003202',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000175,NULL,'15.8g',0.46,'E0',NULL,NULL,NULL,NULL,1,237.848167,40.05556,0.033,NULL,59794819487,934294054,14598344,15.8),(133031,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133031,37.99,0.46,397,62449,70,NULL,NULL,'2MASX J15512395+3647142',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000148,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.8497917,36.78739,0.041,NULL,59880050003,935625781,14619152,17.8),(133032,'HII region diameter','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133032,31.96,NULL,24.7,62450,NULL,NULL,NULL,'NGC 6015',NULL,'1988ApL&C..27...41S',1988,1,5.4,NULL,'G',0.000003,NULL,'11.69',2.1,'SA(s)cd        HII','Isolated galaxy',NULL,NULL,NULL,1,237.855125,62.31003,0.029,NULL,57734465978,902101030,14095328,11.69),(133033,'IRAS','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133033,31.17,0.8,17.1,62450,75,NULL,'A82, H','NGC 6015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133034,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133034,30.09,0.69,10.4,62450,100,NULL,'mid-IR','NGC 6015',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133035,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133035,30.91,0.35,15.2,62450,NULL,NULL,NULL,'NGC 6015',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133036,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133036,30.92,0.4,15.3,62450,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 6015',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133037,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133037,30.94,0.34,15.4,62450,NULL,NULL,'Malmquist cor.','NGC 6015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133038,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133038,31,0.47,15.9,62450,75,NULL,'A82, H, raw','NGC 6015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133039,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133039,31.06,0.47,16.3,62450,75,NULL,'A82, H, inv','NGC 6015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133040,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133040,31.22,0.4,17.5,62450,75,NULL,'B','NGC 6015',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133041,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133041,31.27,0.47,17.9,62450,75,NULL,'A82, H, cor','NGC 6015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133042,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133042,31.37,0.43,18.8,62450,75,NULL,'3.6 micron, color corrected','NGC 6015',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133043,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133043,31.39,0.43,18.9,62450,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6015',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133044,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133044,31.39,0.2,19,62450,74.4,NULL,NULL,'NGC 6015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133045,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133045,31.53,0.26,20.2,62450,NULL,NULL,NULL,'NGC 6015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133046,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133046,37.62,0.46,335,62451,70,NULL,NULL,'2MASX J15512703+3316209',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000164,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.862666667,33.27253,0.073,NULL,59890433157,935788018,14621687,17.1),(133047,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133047,37.49,0.33,315,62452,70,NULL,NULL,'2MASX J15512715+0907462',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,237.863125,9.12936,0.081,NULL,56636892019,884951437,13827366,17.2),(133048,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133048,37.18,0.46,273,62453,70,NULL,NULL,'2MASX J15512748+2237111',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000179,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,237.864625,22.61981,0.153,NULL,59404603029,928196922,14503076,16.3),(133049,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133049,38.21,0.46,439,62454,70,NULL,NULL,'SDSS J155128.16+024627.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000088,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,237.867333,2.77419,0.325,NULL,56608332223,884505190,13820393,18.6),(133050,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133050,37.69,0.46,346,62455,70,NULL,NULL,'2MASX J15512822+2436492',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000185,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,237.867583333,24.61378,0.145,NULL,59397717668,928089338,14501395,16.8),(133051,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133051,37.69,0.46,345,62456,70,NULL,NULL,'SDSS J155128.26+090352.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000138,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,237.8677917,9.06458,0.105,NULL,56636926993,884951984,13827374,18.2),(133052,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133052,37.49,0.33,315,62457,70,NULL,NULL,'2MASX J15512971+0857482',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00017,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,237.87375,8.96325,0.113,NULL,56636922132,884951908,13827373,17.4),(133053,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133053,35.61,0.2,132,62458,74.4,NULL,NULL,'KUG 1549+245',NULL,'2013AJ....146...86T',2013,1,0.87,NULL,'G',0.00005,NULL,'15.7g',0.35,'S?',NULL,NULL,NULL,NULL,1,237.873875,24.435,0.161,NULL,59398590983,928102984,14501609,15.7),(133054,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133054,38.02,0.46,401,62459,70,NULL,NULL,'2MASX J15513191+1939101',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.882875,19.65269,0.101,NULL,59400504174,928132877,14502076,17.7),(133055,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133055,35.98,0.46,157,62460,70,NULL,NULL,'2MASX J15513315+3817573',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000178,NULL,'15.8g',0.37,'S0',NULL,NULL,NULL,NULL,1,237.888167,38.29942,0.025,NULL,59764271731,933816745,14590886,15.8),(133056,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133056,37.27,0.27,284,62461,70,NULL,NULL,'2MASX J15513338+5247510',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000092,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,237.888917,52.7975,0.013,NULL,59715328529,933052008,14578937,16.6),(133057,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133057,37.87,0.27,376,62462,70,NULL,NULL,'2MASX J15513355+1228362',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,237.889791667,12.47669,0.109,NULL,56529253201,883269581,13801087,16.9),(133058,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133058,37.73,0.27,352,62463,70,NULL,NULL,'2MASX J15513524+2817322',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,237.896958333,28.29228,0.081,NULL,59873842319,935528786,14617637,17.2),(133059,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133059,37.43,0.46,306,62464,70,NULL,NULL,'2MASXi J1551355+334630',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000174,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,237.8982917,33.77511,0.069,NULL,59890330772,935786418,14621662,17.7),(133060,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133060,35.67,0.27,136,62465,70,NULL,NULL,'CGCG 078-089',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000103,NULL,'15.6',0.61,NULL,NULL,NULL,NULL,NULL,1,237.8994583,13.18808,0.101,NULL,56529411311,883272051,13801125,15.6),(133061,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133061,38.55,0.46,513,62466,70,NULL,NULL,'SDSS J155136.21+183344.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000158,NULL,'18.7g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,237.900917,18.56244,0.033,NULL,59446121940,928845655,14513213,18.7),(133062,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133062,36.9,0.46,240,62467,70,NULL,NULL,'2MASX J15513633+0911132',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000181,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,237.901333,9.187,0.081,NULL,56632660782,884885324,13826333,16.8),(133063,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133063,36.44,0.2,194,62468,74.4,NULL,NULL,'UGC 10066',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000033,NULL,'15.90',0.1,'S?',NULL,NULL,NULL,NULL,1,237.9037083,23.79017,0.157,NULL,59398285137,928098205,14501534,15.9),(133064,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133064,35.87,0.49,149,62469,75,NULL,'IR','UGC 10066',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'15.90',0.1,'S?',NULL,NULL,NULL,NULL,1,237.9037083,23.79017,0.157,NULL,59398285137,928098205,14501534,15.9),(133065,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133065,37.4,0.33,302,62470,70,NULL,NULL,'2MASX J15513765+2849282',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000155,NULL,'16.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,237.906875,28.82456,0.117,NULL,59866561918,935415029,14615859,16.7),(133066,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133066,37.79,0.11,362,62471,70,NULL,NULL,'2MASX J15514189+2753472',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000175,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,237.924583,27.89642,0.065,NULL,59874643716,935541308,14617832,16.7),(133067,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133067,37.7,0.46,347,62472,70,NULL,NULL,'SDSS J155142.90+204656.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000126,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,237.92875,20.78228,0.085,NULL,59402623625,928165994,14502593,18.5),(133068,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133068,35.98,0.46,157,62473,70,NULL,NULL,'2MASX J15514378+0946082',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000176,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,237.932375,9.76894,0.085,NULL,56632684142,884885689,13826338,16.3),(133069,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133069,34.29,0.2,72.1,62474,74.4,NULL,NULL,'KUG 1549+128',NULL,'2013AJ....146...86T',2013,1,0.9,'Tarenghi, et al. (1994,AJ,107,1629) give v = 13107 +/- 99 km/sec.','G',0.000009,NULL,'15.1',0.4,'Spiral',NULL,NULL,NULL,NULL,1,237.936375,12.74236,0.121,NULL,56529121030,883267516,13801054,15.1),(133070,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133070,38.14,0.46,425,62475,70,NULL,NULL,'2MASX J15514515+2121107',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.938125,21.35292,0.129,NULL,59402464283,928163504,14502554,17.9),(133071,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133071,37,0.46,251,62476,70,NULL,NULL,'2MASX J15514590+3745462',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,237.941125,37.76292,0.041,NULL,59764343669,933817869,14590904,17.5),(133072,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133072,36.47,0.46,197,62477,70,NULL,NULL,'2MASX J15514592+1808047',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000165,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,237.9412083,18.13469,0.045,NULL,59429336255,928583378,14509115,16.5),(133073,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133073,36.1,0.46,166,62478,70,NULL,NULL,'2MASX J15514686-0006190',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000093,NULL,'15.9g',0.46,'E0',NULL,NULL,NULL,NULL,1,237.945125,-0.10517,0.353,NULL,45518989856,711234216,11113034,15.9),(133074,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133074,37.4,0.33,302,62479,70,NULL,NULL,'2MASX J15514709+2851382',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,237.9462083,28.86064,0.117,NULL,59866561380,935415021,14615859,17.4),(133075,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133075,37.87,0.27,376,62480,70,NULL,NULL,'2MASX J15514748+1228311',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,237.947875,12.47519,0.109,NULL,56529254573,883269602,13801087,17.2),(133076,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133076,38.23,0.33,442,62481,70,NULL,NULL,'2MASX J15514918+1225371',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.955,12.42689,0.109,NULL,56529243922,883269436,13801084,17.8),(133077,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133077,37.79,0.11,362,62482,70,NULL,NULL,'SDSS J155154.21+280117.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,237.975917,28.02158,0.057,NULL,59873857087,935529016,14617640,18.1),(133078,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133078,37.52,0.27,319,62483,70,NULL,NULL,'2MASX J15515728+2226037',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000202,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,237.988667,22.43444,0.153,NULL,59404640834,928197513,14503086,16.8),(133079,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133079,36.73,0.46,222,62484,70,NULL,NULL,'2MASX J15515793+5353561',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000085,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,237.99125,53.89892,0.013,NULL,59697535768,932773996,14574593,16.4),(133080,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133080,37.06,0.46,258,62485,70,NULL,NULL,'2MASX J15515798+0313212',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.991625,3.22244,0.305,NULL,56621175172,884705862,13823529,17.5),(133081,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133081,37.47,0.46,312,62486,70,NULL,NULL,'2MASX J15515881+0011122',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000075,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,237.995,0.18678,0.369,NULL,56473919629,882404994,13787578,17.4),(133082,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133082,38.23,0.33,442,62487,70,NULL,NULL,'2MASX J15520044+1224399',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.001667,12.41117,0.109,NULL,56529014924,883265858,13801029,17.4),(133083,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133083,37.22,0.46,278,62488,70,NULL,NULL,'2MASX J15520151+2312377',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000173,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,238.0062083,23.21056,0.149,NULL,59406338325,928224036,14503500,16.3),(133084,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133084,37,0.46,251,62489,70,NULL,NULL,'2MASX J15520176+3240137',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,238.007333,32.67061,0.065,NULL,59889913308,935779895,14621560,16.6),(133085,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133085,37.79,0.11,362,62490,70,NULL,NULL,'2MASX J15520258+2744245',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000188,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.010791667,27.74014,0.073,NULL,59874649066,935541391,14617834,17.1),(133086,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133086,37.79,0.11,362,62491,70,NULL,NULL,'2MASX J15520354+2757365',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000182,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.01475,27.96017,0.065,NULL,59874561542,935540024,14617812,17.8),(133087,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133087,37.79,0.11,362,62492,70,NULL,NULL,'2MASX J15520363+2751595',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000207,NULL,'16.0g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,238.01525,27.86658,0.065,NULL,59874673728,935541777,14617840,16),(133088,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133088,35.67,0.27,136,62493,70,NULL,NULL,'UGC 10068',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000157,NULL,'14.50',0.8,'S0',NULL,NULL,NULL,NULL,1,238.0152917,12.89869,0.117,NULL,56529061419,883266584,13801040,14.5),(133089,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133089,37.3,0.46,288,62494,70,NULL,NULL,'2MASX J15520682+2733315',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000178,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,238.028333,27.55872,0.097,NULL,59874639811,935541247,14617831,16.7),(133090,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133090,37.86,0.46,373,62495,70,NULL,NULL,'2MASX J15520840+3322187',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00016,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,238.034875,33.37192,0.069,NULL,59890450506,935788289,14621692,18.3),(133091,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133091,37.88,0.33,376,62496,70,NULL,NULL,'2MASX J15520913+2005477',NULL,'2015arXiv151105856S',2015,1,0.48,'Probable core of 3C 326. See 1990MNRAS.246P..21R','G',0.001,NULL,'16.8g',0.26,'LIG',NULL,NULL,NULL,NULL,1,238.038,20.09658,0.093,NULL,59403401484,928178148,14502783,16.8),(133092,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133092,37.96,0.46,390,62497,70,NULL,NULL,'2MASX J15520977+2718386',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,238.040875,27.31061,0.085,NULL,59874154857,935533669,14617713,17.4),(133093,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133093,38.37,0.46,472,62498,70,NULL,NULL,'2MASX J15521070+5646089',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00008,NULL,'17.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,238.0445417,56.76911,0,NULL,57642706657,900667291,14072926,17.4),(133094,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133094,36.7,0.46,219,62499,70,NULL,NULL,'MCG +06-35-012',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000214,NULL,'15.3g',0.63,'E0',NULL,NULL,NULL,NULL,1,238.044833,34.08428,0.069,NULL,59887977063,935749641,14621088,15.3),(133095,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133095,37.57,0.33,326,62500,70,NULL,NULL,'2MASX J15521082+5513319',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00007,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,238.045167,55.22558,0.009,NULL,57641611215,900650175,14072658,17.5),(133096,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133096,37.18,0.23,273,62501,70,NULL,NULL,'2MASX J15521126+0432112',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,238.047,4.53653,0.237,NULL,56622342287,884724098,13823814,17.1),(133097,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133097,37.65,0.46,339,62502,70,NULL,NULL,'2MASX J15521224+4817192',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000167,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.051167,48.2885,0.041,NULL,59724046602,933188228,14581066,17.4),(133098,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133098,37.99,0.46,397,62503,70,NULL,NULL,'2MASX J15521275+0640237',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000188,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,238.0529583,6.67336,0.097,NULL,56637985148,884968517,13827633,17.4),(133099,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133099,37.61,0.33,333,62504,70,NULL,NULL,'2MASX J15521437+1021307',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.9g',0.27,'AGN',NULL,NULL,NULL,NULL,1,238.059916667,10.35858,0.089,NULL,56600555111,884383673,13818494,16.9),(133100,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133100,37.27,0.46,284,62505,70,NULL,NULL,'2MASX J15521435+2618416',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,238.059958333,26.31169,0.125,NULL,59870814957,935481483,14616898,16.9),(133101,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133101,38.59,0.46,522,62506,70,NULL,NULL,'SDSS J155214.40+545420.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00007,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,238.06,54.90578,0.017,NULL,57638934915,900608358,14072005,18.6),(133102,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133102,37.29,0.46,287,62507,70,NULL,NULL,'SDSS J155214.73+513538.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.061417,51.59394,0.017,NULL,59717885435,933091959,14579561,18.2),(133103,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133103,37,0.46,251,62508,70,NULL,NULL,'2MASX J15521590+3333327',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000176,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,238.066208333,33.55903,0.069,NULL,59890440380,935788130,14621689,16.5),(133104,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133104,37.29,0.46,286,62509,70,NULL,NULL,'2MASX J15521635+1210590',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,238.0680417,12.18308,0.101,NULL,56599518629,884367478,13818241,17.8),(133105,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133105,37.98,0.46,395,62510,70,NULL,NULL,'2MASX J15521722+3454498',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000134,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.071583,34.91394,0.061,NULL,59888274111,935754282,14621160,18.2),(133106,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133106,37.48,0.46,314,62511,70,NULL,NULL,'2MASX J15521843+3011368',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000191,NULL,'15.9g',0.39,NULL,NULL,NULL,NULL,NULL,1,238.077,30.19356,0.089,NULL,59922203881,936284435,14629444,15.9),(133107,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133107,37.9,0.46,380,62512,70,NULL,NULL,'2MASX J15521854+1015355',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,238.077208333,10.25969,0.089,NULL,56600452205,884382065,13818469,17.1),(133108,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133108,36.84,0.46,233,62513,70,NULL,NULL,'2MASX J15521853+2914006',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000117,NULL,'17.0g',0.26,'S0',NULL,NULL,NULL,NULL,1,238.0772917,29.23333,0.109,NULL,59867263034,935425984,14616031,17),(133109,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133109,37.18,0.23,273,62514,70,NULL,NULL,'2MASX J15521869+0430402',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,238.077833,4.51108,0.237,NULL,56622325260,884723832,13823809,16.3),(133110,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133110,37.26,0.46,283,62515,70,NULL,NULL,'2MASX J15522133+2345015',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.089,23.75033,0.145,NULL,59398237247,928097456,14501522,17.6),(133111,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133111,37.57,0.33,326,62516,70,NULL,NULL,'2MASX J15522146+5515310',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000076,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.089625,55.2585,0.009,NULL,57641611347,900650177,14072659,17.5),(133112,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133112,36.89,0.46,239,62517,70,NULL,NULL,'2MASX J15522211+1619270',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,238.0922917,16.32425,0.057,NULL,56534908963,883357952,13802468,17.2),(133113,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133113,37.52,0.27,319,62518,70,NULL,NULL,'2MASX J15522239+2233115',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000207,NULL,'15.7g',0.54,NULL,NULL,NULL,NULL,NULL,1,238.093167,22.55333,0.153,NULL,59407451143,928241424,14503772,15.7),(133114,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133114,38.1,0.33,416,62519,70,NULL,NULL,'2MASX J15522312+2820336',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000157,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,238.0962917,28.34264,0.081,NULL,59873826199,935528534,14617633,18.6),(133115,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133115,37.18,0.23,273,62520,70,NULL,NULL,'SDSS J155223.88+042928.2',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,238.0995417,4.49117,0.237,NULL,56622323108,884723798,13823809,17),(133116,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133116,37.48,0.46,314,62521,70,NULL,NULL,'2MASX J15522418+2422085',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.10075,24.36886,0.161,NULL,59397842351,928091286,14501426,17.6),(133117,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133117,37.52,0.27,319,62522,70,NULL,NULL,'SDSS J155225.63+223417.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000169,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,238.106833,22.57158,0.153,NULL,59407451275,928241426,14503772,18.2),(133118,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133118,36.76,0.46,225,62523,70,NULL,NULL,'2MASX J15522848+2534096',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000188,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,238.11875,25.56933,0.129,NULL,59871486792,935491981,14617062,16.2),(133119,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133119,36.32,0.46,184,62524,70,NULL,NULL,'2MASX J15522856+1331130',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,238.118833,13.52028,0.101,NULL,56529829903,883278592,13801228,16.3),(133120,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133120,37.79,0.11,362,62525,70,NULL,NULL,'2MASX J15522867+2741166',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000184,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,238.1195417,27.68775,0.073,NULL,59874700743,935542199,14617846,17.3),(133121,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133121,37.98,0.46,395,62526,70,NULL,NULL,'SDSS J155229.50-002821.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000082,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,238.122958333,-0.47256,0.353,NULL,45519062082,711235345,11113052,18.4),(133122,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133122,37.79,0.11,362,62527,70,NULL,NULL,'2MASX J15522955+2705086',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,238.12325,27.08589,0.073,NULL,59874199189,935534362,14617724,17),(133123,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133123,37.35,0.46,296,62528,70,NULL,NULL,'2MASX J15522998+0704285',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,238.125041667,7.07458,0.069,NULL,56638804640,884981322,13827833,17.2),(133124,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133124,37.83,0.33,369,62529,70,NULL,NULL,'2MASX J15523040+1253160',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,238.126583,12.88792,0.117,NULL,56530190289,883284223,13801315,17.1),(133125,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133125,37.4,0.46,302,62530,70,NULL,NULL,'2MASX J15523086+5528159',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000074,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,238.1287083,55.47103,0.005,NULL,57642093924,900657717,14072776,17.6),(133126,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133126,37.48,0.46,313,62531,70,NULL,NULL,'2MASX J15523234+0817085',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,238.134833,8.28569,0.069,NULL,56637076636,884954322,13827411,17.6),(133127,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133127,37.59,0.46,329,62532,70,NULL,NULL,'SDSS J155233.12+253620.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000167,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.138,25.60567,0.129,NULL,59870973972,935483968,14616937,18.1),(133128,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133128,38.07,0.46,410,62533,70,NULL,NULL,'2MASX J15523564+2550406',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000187,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.148583,25.84469,0.133,NULL,59870959465,935483741,14616933,17.7),(133129,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133129,37.18,0.23,273,62534,70,NULL,NULL,'2MASX J15523748+0431065',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.156083,4.51847,0.181,NULL,56622332660,884723947,13823811,17.2),(133130,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133130,37.61,0.33,333,62535,70,NULL,NULL,'SDSS J155239.29+102629.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,238.16375,10.44144,0.077,NULL,56600515211,884383050,13818485,18.2),(133131,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133131,37.69,0.46,345,62536,70,NULL,NULL,'2MASX J15523972+3544068',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000152,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,238.1655,35.73522,0.053,NULL,59891527418,935805115,14621954,18.5),(133132,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133132,37.88,0.33,376,62537,70,NULL,NULL,'SDSS J155240.43+200825.3',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,238.1685,20.14039,0.081,NULL,59403351777,928177371,14502771,NULL),(133133,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133133,37.37,0.46,299,62538,70,NULL,NULL,'SDSS J155240.78+051612.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.1699583,5.27022,0.157,NULL,56611976525,884562133,13821283,18.2),(133134,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133134,37.57,0.46,327,62539,70,NULL,NULL,'2MASX J15524125+4618101',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,238.172208333,46.30269,0.045,NULL,59682676110,932541814,14570965,17.3),(133135,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133135,36.39,0.46,190,62540,70,NULL,NULL,'2MASX J15524206+1028015',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.1754583,10.46719,0.077,NULL,56600514712,884383042,13818485,16.5),(133136,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133136,37.7,0.46,346,62541,70,NULL,NULL,'2MASX J15524319+2900536',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000152,NULL,'17.1g',0.22,'S0',NULL,NULL,NULL,NULL,1,238.179958333,29.01483,0.101,NULL,59867224281,935425379,14616021,17.1),(133137,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133137,37.97,0.46,392,62542,70,NULL,NULL,'2MASX J15524370+1355241',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,238.18225,13.92339,0.105,NULL,56527989848,883249841,13800778,17.1),(133138,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133138,37.36,0.27,296,62543,70,NULL,NULL,'2MASX J15524421+3438248',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00018,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,238.1842083,34.64042,0.065,NULL,59888359609,935755618,14621181,16.6),(133139,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133139,37.83,0.33,369,62544,70,NULL,NULL,'2MASX J15524449+1258201',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,238.185417,12.97233,0.125,NULL,56530704757,883292261,13801441,16.8),(133140,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133140,37.47,0.46,311,62545,70,NULL,NULL,'2MASX J15524494+1855248',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00016,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,238.187166667,18.92353,0.049,NULL,59399926638,928123853,14501935,16.7),(133141,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133141,37.27,0.33,285,62546,70,NULL,NULL,'SDSS J155245.30-003329.9',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000092,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,238.18875,-0.55833,0.385,NULL,45519071314,711235489,11113054,17.2),(133142,'SGRB','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133142,40.71,NULL,1390,62547,70,NULL,'Amati relation, minimum D','GRB 060923B',NULL,'2012A&A...545A..77R',2012,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,238.194583,-30.90381,0.641,NULL,47168808102,737012626,11515822,NULL),(133143,'SGRB','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133143,42.46,NULL,3100,62547,70,NULL,'Photometric Distance, Host A, M(R) = -20 mag and spectral slope Beta = 1.0 ','GRB 060923B',NULL,'2012A&A...545A..77R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133144,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133144,37.27,0.33,285,62548,70,NULL,NULL,'2MASX J15524712-0030061',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000109,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.1962917,-0.50175,0.385,NULL,45519071144,711235486,11113054,17.5),(133145,'CMD','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'N',133145,16.9,0.3,0.02,62549,NULL,NULL,NULL,'Draco II/Laevens 4',NULL,'2015ApJ...813...44L',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133146,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133146,35.27,0.2,113,62550,74.4,NULL,NULL,'UGC 10074',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'14.98',0.6,'Scd:',NULL,NULL,NULL,NULL,1,238.199417,24.39022,0.137,NULL,59397887764,928091996,14501437,14.98),(133147,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133147,38.26,0.46,450,62551,70,NULL,NULL,'2MASX J15524793+1647261',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.1997083,16.79061,0.073,NULL,56531545076,883305391,13801646,17.9),(133148,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133148,37.36,0.27,296,62552,70,NULL,NULL,'2MASX J15524916+3436568',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'16.55',0.48,'BrClG',NULL,NULL,NULL,NULL,1,238.204667,34.61586,0.065,NULL,59888349223,935755456,14621179,16.55),(133149,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133149,35.78,0.57,143,62553,70,NULL,NULL,'2MASX J15524972-1444256',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.18',0.4,NULL,NULL,NULL,NULL,NULL,1,238.2072917,-14.74072,0.589,NULL,45479875999,710623062,11103485,16.18),(133150,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133150,37.35,0.33,295,62554,70,NULL,NULL,'2MASX J15525004+2811235',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,238.208333,28.18986,0.081,NULL,59874549473,935539835,14617809,17.3),(133151,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133151,37.67,0.46,342,62555,70,NULL,NULL,'2MASX J15525024+1204311',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,238.20925,12.07525,0.073,NULL,56601617825,884400278,13818754,17.7),(133152,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133152,38.05,0.46,408,62556,70,NULL,NULL,'SDSS J155252.04+174128.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000154,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,238.216875,17.69136,0.065,NULL,56531063070,883297860,13801529,18.3),(133153,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133153,33.91,0.2,60.5,62557,74.4,NULL,NULL,'NGC 6013',NULL,'2013AJ....146...86T',2013,1,1.41,NULL,'G',0.000417,NULL,'14.0g',0.73,'SBb','Field galaxy',NULL,NULL,NULL,1,238.220167,40.64672,0.045,NULL,59797525857,934336341,14599005,14),(133154,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133154,34.27,0.4,71.5,62557,NULL,NULL,'mean','NGC 6013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133155,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133155,34.49,0.47,79.2,62557,NULL,NULL,'H','NGC 6013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133156,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133156,34.58,0.45,82.6,62557,NULL,NULL,'K','NGC 6013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133157,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133157,34.59,0.46,82.8,62557,NULL,NULL,'J','NGC 6013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133158,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133158,36.88,0.46,238,62558,70,NULL,NULL,'2MASX J15525291+2556585',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00018,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,238.2204583,25.94942,0.133,NULL,59870956272,935483691,14616932,16.6),(133159,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133159,36.26,0.46,179,62559,70,NULL,NULL,'2MASX J15525544+0043044',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000084,NULL,'16.4g',0.28,'E0',NULL,NULL,NULL,NULL,1,238.2309583,0.71803,0.325,NULL,56473813758,882403339,13787552,16.4),(133160,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133160,35.4,0.22,116,62560,74.2,NULL,'SALT 2','MCG +11-19-025',0.036,'2010ApJ...716..712A',2010,1,0.65,NULL,'G',0.000066,NULL,'17',0.13,NULL,NULL,NULL,NULL,NULL,1,238.232208333,65.93558,0.045,NULL,57954959340,905546239,14149159,17),(133161,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133161,35.95,0.2,149,62560,72,NULL,NULL,'MCG +11-19-025',0.036,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133162,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133162,35.95,0.17,155,62560,70.8,NULL,NULL,'MCG +11-19-025',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133163,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133163,36.03,0.08,161,62560,74.4,NULL,NULL,'MCG +11-19-025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133164,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133164,36.11,0.27,161,62560,70,NULL,'SALT','MCG +11-19-025',0.036,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133165,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133165,36.11,0.07,161,62560,70,NULL,NULL,'MCG +11-19-025',0.036,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133166,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133166,36.13,0.15,162,62560,70,NULL,'SALT 2','MCG +11-19-025',0.036,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133167,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133167,36.16,0.08,165,62560,65,NULL,'SALT2','MCG +11-19-025',0.036,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133168,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133168,36.17,0.15,165,62560,73.8,NULL,'SALT 2 (SNANA)','MCG +11-19-025',0.0369,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133169,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133169,36.21,0.03,168,62560,72,NULL,NULL,'MCG +11-19-025',0.036,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133170,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133170,36.28,0.27,174,62560,65,NULL,'SALT','MCG +11-19-025',0.036,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133171,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133171,36.21,0.17,175,62560,72,NULL,NULL,'MCG +11-19-025',NULL,'2006AJ....131.1639K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133172,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133172,36.38,0.1,176,62560,65,NULL,'MLCS2k2','MCG +11-19-025',0.036,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133173,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133173,36.3,0.03,176,62560,70,NULL,'SALT 2','MCG +11-19-025',0.036,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133174,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133174,36.32,0.15,177,62560,65,NULL,'MLCS17','MCG +11-19-025',0.036,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133175,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133175,36.33,0.16,178,62560,65,NULL,'MLCS31','MCG +11-19-025',0.036,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133176,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133176,36.33,0.18,178,62560,65,NULL,'SALT2','MCG +11-19-025',0.036,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133177,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133177,36.36,0.06,180,62560,65,NULL,'MLCS2k2','MCG +11-19-025',0.036,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133178,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133178,36.36,0.11,181,62560,65,NULL,'MLCS2k2','MCG +11-19-025',0.036,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133179,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133179,36.39,0.18,183,62560,65,NULL,NULL,'MCG +11-19-025',0.036,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133180,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133180,36.44,0.03,188,62560,65,NULL,'SALT','MCG +11-19-025',0.036,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133181,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133181,36.42,0.14,192,62560,60,NULL,NULL,'MCG +11-19-025',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133182,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133182,37.44,0.33,307,62561,70,NULL,NULL,'2MASX J15525583+4747360',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,238.232625,47.79322,0.049,NULL,59712850429,933013287,14578332,17.4),(133183,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133183,38.39,0.46,477,62562,70,NULL,NULL,'2MASX J15525664+0028354',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000076,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.2360417,0.47653,0.369,NULL,56473852942,882403952,13787561,18.3),(133184,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133184,38.1,0.33,416,62563,70,NULL,NULL,'2MASX J15525713+2811584',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000183,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,238.237917,28.19956,0.081,NULL,59874547488,935539804,14617809,17.3),(133185,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133185,37.79,0.11,362,62564,70,NULL,NULL,'2MASX J15525730+2739474',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00011,NULL,'15.9g',0.52,NULL,NULL,NULL,NULL,NULL,1,238.238667,27.66331,0.073,NULL,59874694500,935542101,14617845,15.9),(133186,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133186,37.35,0.33,295,62565,70,NULL,NULL,'2MASX J15525868+2759025',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00015,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.244541667,27.98406,0.057,NULL,59874591542,935540492,14617820,17.3),(133187,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133187,37.26,0.33,283,62566,70,NULL,NULL,'SDSS J155259.39+243055.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,238.2475,24.51539,0.141,NULL,59397880311,928091879,14501435,18.1),(133188,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133188,35.25,0.48,112,62567,70,NULL,NULL,'ESO 515- G 013',NULL,'2014MNRAS.445.2677S',2014,1,2,NULL,'G',0.000033,NULL,'12.48',0.7,'SA(rs)b',NULL,NULL,NULL,NULL,1,238.251875,-27.29208,0.809,NULL,47123705388,736307896,11504810,12.48),(133189,'IRAS','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133189,35.35,0.8,118,62567,75,NULL,'MAT, I','ESO 515- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133190,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133190,35.27,0.43,113,62567,75,NULL,'MAT, I, raw','ESO 515- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133191,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133191,35.63,0.43,134,62567,75,NULL,'MAT, I, cor','ESO 515- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133192,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133192,35.67,0.43,136,62567,75,NULL,'MAT, I, inv','ESO 515- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133193,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133193,35.74,0.32,140,62567,85,NULL,'I, raw','ESO 515- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133194,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133194,35.84,0.32,147,62567,85,NULL,'I, inv','ESO 515- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133195,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133195,35.88,0.4,150,62567,NULL,NULL,'Malmquist cor.','ESO 515- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133196,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133196,35.91,0.39,152,62567,NULL,NULL,NULL,'ESO 515- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133197,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133197,35.95,0.2,155,62567,74.4,NULL,NULL,'ESO 515- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133198,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133198,38.12,0.46,421,62568,70,NULL,NULL,'2MASX J15530147+3926194',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.256125,39.43875,0.033,NULL,59760986912,933765420,14590084,17.8),(133199,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133199,36.69,0.46,218,62569,70,NULL,NULL,'2MASX J15530150+2302286',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,238.256167,23.04119,0.149,NULL,59406385410,928224772,14503512,16.3),(133200,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133200,37.54,0.33,322,62570,70,NULL,NULL,'2MASX J15530255+3402388',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000175,NULL,'16.3g',0.41,'BrClG',NULL,NULL,NULL,NULL,1,238.2607083,34.04408,0.069,NULL,59887984096,935749751,14621089,16.3),(133201,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133201,38.06,0.46,409,62571,70,NULL,NULL,'2MASX J15530376+0224504',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000089,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.2657917,2.41403,0.289,NULL,56474292706,882410823,13787669,17.7),(133202,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133202,38.53,0.46,508,62572,70,NULL,NULL,'2MASX J15530387+1213161',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.26625,12.22108,0.073,NULL,56527162980,883236921,13800576,17.7),(133203,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133203,34.17,0.51,68.2,62573,NULL,NULL,NULL,'ESO 515- G 014',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.58',0.3,'S...',NULL,NULL,NULL,NULL,1,238.2697917,-24.63594,0.637,NULL,46583136501,727861507,11372836,14.58),(133204,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133204,34.21,0.2,69.5,62573,74.4,NULL,NULL,'ESO 515- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133205,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133205,34.38,0.47,75.2,62573,NULL,NULL,'Malmquist cor.','ESO 515- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133206,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133206,37.46,0.46,311,62574,70,NULL,NULL,'SDSS J155305.69+494312.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000126,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,238.273708333,49.72019,0.037,NULL,59725618526,933212789,14581449,18.5),(133207,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133207,34.58,0.46,82.3,62575,70,NULL,NULL,'NGC 6008B',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000153,NULL,'14.9g',0.48,'E','in a pair',NULL,NULL,NULL,1,238.2845417,21.07464,0.085,NULL,59402571386,928165177,14502580,14.9),(133208,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133208,38.04,0.46,405,62576,70,NULL,NULL,'2MASX J15530871+1914005',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,238.286375,19.23344,0.049,NULL,59400628732,928134823,14502106,16.7),(133209,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133209,37.79,0.11,362,62577,70,NULL,NULL,'SDSS J155309.37+273955.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000159,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,238.289083333,27.66542,0.073,NULL,59874693771,935542090,14617845,18.7),(133210,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133210,37.84,0.23,370,62578,70,NULL,NULL,'2MASX J15531040+2734475',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,238.293333,27.57992,0.109,NULL,59874518406,935539350,14617802,17.6),(133211,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133211,37.17,0.46,272,62579,70,NULL,NULL,'SDSS J155311.12-001007.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000069,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,238.296333333,-0.16878,0.365,NULL,45519131435,711236428,11113069,18.7),(133212,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133212,38.47,0.46,494,62580,70,NULL,NULL,'SDSS J155311.76+062646.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.299041667,6.44639,0.101,NULL,56629611509,884837679,13825588,18.2),(133213,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133213,37.79,0.11,362,62581,70,NULL,NULL,'2MASX J15531213+2726255',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000127,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,238.300583333,27.44028,0.097,NULL,59874047228,935531987,14617687,18),(133214,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133214,37.18,0.46,273,62582,70,NULL,NULL,'2MASX J15531354+3124453',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000179,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,238.3065417,31.41258,0.077,NULL,59920159453,936252491,14628945,16.3),(133215,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133215,36.53,0.46,202,62583,70,NULL,NULL,'2MASX J15531390+3654356',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000173,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,238.308,36.90994,0.041,NULL,59762367738,933786995,14590421,16.5),(133216,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133216,38.18,0.33,433,62584,70,NULL,NULL,'2MASX J15531438+0926427',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.7g',0.18,'BrClG',NULL,NULL,NULL,NULL,1,238.309875,9.44514,0.109,NULL,56632969043,884890141,13826408,17.7),(133217,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133217,37.9,0.23,380,62585,70,NULL,NULL,'2MASX J15531341+3650206',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,238.311125,36.83722,0.041,NULL,59762375865,933787122,14590423,18.1),(133218,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133218,37.3,0.46,288,62586,70,NULL,NULL,'2MASX J15531531+0947577',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000195,NULL,'15.9g',0.48,'E0',NULL,NULL,NULL,NULL,1,238.3137917,9.79956,0.089,NULL,56633350229,884896097,13826501,15.9),(133219,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133219,37.41,0.46,303,62587,70,NULL,NULL,'2MASX J15531531+2522255',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000184,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,238.313875,25.37386,0.157,NULL,59870613825,935478341,14616849,16.9),(133220,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133220,37.44,0.33,307,62588,70,NULL,NULL,'2MASX J15531558+4748320',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000168,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,238.3147917,47.80903,0.049,NULL,59712819806,933012809,14578325,16.9),(133221,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133221,39,0.46,631,62589,70,NULL,NULL,'SDSS J155317.95+270136.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,238.324833333,27.02678,0.109,NULL,59874184885,935534138,14617720,18.4),(133222,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133222,38.18,0.33,433,62590,70,NULL,NULL,'2MASX J15531904+0925187',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.329333333,9.42206,0.109,NULL,56632982557,884890352,13826411,17.8),(133223,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133223,37.04,0.46,256,62591,70,NULL,NULL,'2MASX J15531921+2156098',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.33,21.936,0.121,NULL,59407754295,928246160,14503846,17.7),(133224,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133224,38.02,0.33,401,62592,70,NULL,NULL,'2MASX J15531925+1256561',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,238.33025,12.94906,0.125,NULL,56530221064,883284704,13801323,16.7),(133225,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133225,35.97,0.46,156,62593,70,NULL,NULL,'CGCG 275-013',NULL,'2015arXiv151105856S',2015,1,0.58,'GSC 3870-0287 (mag. 14) superposed 16 arcsec northwest of nucleus.','G',0.000102,NULL,'15.3g',0.52,'S0^-',NULL,NULL,NULL,NULL,1,238.333833,54.70814,0.021,NULL,57639084973,900610702,14072042,15.3),(133226,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133226,35.11,0.2,105,62594,74.4,NULL,NULL,'NGC 6007',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.000017,NULL,'13.82',1.2,'SABbc:         HII',NULL,NULL,NULL,NULL,1,238.346583,11.95919,0.073,NULL,56598231304,884347364,13817927,13.82),(133227,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133227,35.81,0.47,145,62594,NULL,NULL,'H','NGC 6007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133228,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133228,35.96,0.4,155,62594,NULL,NULL,'mean','NGC 6007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133229,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133229,35.96,0.46,156,62594,NULL,NULL,'J','NGC 6007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133230,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133230,36,0.45,159,62594,NULL,NULL,'K','NGC 6007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133231,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133231,36.88,0.2,238,62595,74.4,NULL,NULL,'NGC 6009',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000123,NULL,'15.4',0.3,NULL,NULL,NULL,NULL,NULL,1,238.350333,12.05867,0.073,NULL,56598263552,884347868,13817935,15.4),(133232,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133232,38.33,0.33,463,62596,70,NULL,NULL,'2MASX J15532449+3242024',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000173,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.352167,32.70067,0.077,NULL,59886950011,935733593,14620837,18.1),(133233,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133233,36.35,0.46,186,62597,70,NULL,NULL,'SDSS J155324.69+040457.1',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,238.352875,4.08256,0.245,NULL,56613255414,884582115,13821595,NULL),(133234,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133234,36.46,0.46,196,62598,70,NULL,NULL,'B2 1551+36B',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00017,NULL,'16.1g',0.37,'S0^-',NULL,NULL,NULL,'USS',1,238.354417,36.71619,0.041,NULL,59761658955,933775921,14590248,16.1),(133235,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133235,37.9,0.23,380,62599,70,NULL,NULL,'2MASX J15532508+3651326',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,238.3544583,36.85894,0.041,NULL,59762375495,933787117,14590423,17.6),(133236,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133236,37.59,0.46,330,62600,70,NULL,NULL,'2MASX J15532534+1115307',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.3557083,11.2585,0.089,NULL,56601420496,884397195,13818706,17.8),(133237,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133237,37.79,0.11,362,62601,70,NULL,NULL,'2MASX J15532569+2749085',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000149,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,238.357083,27.81914,0.109,NULL,59874717970,935542468,14617851,17.7),(133238,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133238,37.73,0.46,352,62602,70,NULL,NULL,'2MASX J15532771+4142236',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.3655,41.7065,0.041,NULL,59796611146,934322049,14598782,17.4),(133239,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133239,35.53,0.25,128,62603,74.4,NULL,NULL,'CGCG 223-010',NULL,'2013AJ....146...86T',2013,1,0.78,NULL,'G',0.000143,NULL,'14.7g',0.62,'E','Field galaxy',NULL,NULL,NULL,1,238.370417,41.5805,0.041,NULL,59796619028,934322172,14598783,14.7),(133240,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133240,35.74,0.35,140,62603,70,NULL,NULL,'CGCG 223-010',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133241,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133241,35.78,0.19,143,62603,70,NULL,NULL,'CGCG 223-010',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133242,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133242,36.84,0.46,233,62604,70,NULL,NULL,'2MASX J15532897-0039343',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000094,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.37075,-0.6595,0.385,NULL,45519532342,711242692,11113167,17.2),(133243,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133243,36.92,0.46,243,62605,70,NULL,NULL,'2MASX J15532943+4651075',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00019,NULL,'16.0g',0.37,'E0',NULL,NULL,NULL,NULL,1,238.372583,46.85197,0.033,NULL,59713141108,933017829,14578403,16),(133244,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133244,37.39,0.17,300,62606,70,NULL,NULL,'2MASX J15532959+3531494',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000183,NULL,'16.9g',0.31,'Candidate      BLAGN',NULL,NULL,NULL,NULL,1,238.3732083,35.53056,0.057,NULL,59887366189,935740096,14620939,16.9),(133245,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133245,37.9,0.23,380,62607,70,NULL,NULL,'2MASX J15532966+3647196',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,238.373667,36.78867,0.041,NULL,59762363848,933786935,14590420,17.1),(133246,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133246,38.04,0.27,406,62608,70,NULL,NULL,'2MASX J15532985+1154357',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.3742917,11.90986,0.061,NULL,56598443896,884350685,13817979,17.6),(133247,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133247,35.7,0.46,138,62609,70,NULL,NULL,'GIN 534',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000073,NULL,'15.5g',0.54,'E/S0',NULL,NULL,NULL,NULL,1,238.378667,18.358,0.053,NULL,59399743147,928120986,14501890,15.5),(133248,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133248,36.44,0.18,194,62609,70,NULL,NULL,'GIN 534',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133249,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133249,36.52,0.25,201,62609,74.4,NULL,NULL,'GIN 534',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133250,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133250,38.46,0.46,492,62610,70,NULL,NULL,'2MASX J15533110+3750166',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,238.3797083,37.83783,0.041,NULL,59764237013,933816203,14590878,18),(133251,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133251,37.5,0.46,316,62611,70,NULL,NULL,'2MASX J15533153+2912347',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.381208333,29.20978,0.109,NULL,59867379766,935427808,14616059,17.9),(133252,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133252,37.31,0.46,290,62612,70,NULL,NULL,'2MASX J15533217+1718107',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000188,NULL,'17.0g',0.24,'AGN',NULL,NULL,NULL,NULL,1,238.384083,17.30303,0.065,NULL,56531745201,883308518,13801695,17),(133253,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133253,37.9,0.23,380,62613,70,NULL,NULL,'2MASX J15533307+3648146',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000183,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,238.387708333,36.80392,0.041,NULL,59762364076,933786938,14590420,18),(133254,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133254,36.92,0.46,242,62614,70,NULL,NULL,'2MASX J15533316+3429074',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000167,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,238.388333333,34.48542,0.065,NULL,59888337041,935755266,14621176,16.8),(133255,'BL Lac Luminosity','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133255,40.08,NULL,1040,62615,NULL,NULL,'Min. z = 0.28','6dF J1553336-311830',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'VisS',NULL,NULL,'15.5R',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,238.3900417,-31.30836,0.633,NULL,47165747321,736964801,11515075,15.5),(133256,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133256,38.33,0.33,463,62616,70,NULL,NULL,'2MASX J15533408+3242523',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000143,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,238.3920417,32.71464,0.077,NULL,59886979748,935734058,14620844,17.8),(133257,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133257,38.45,0.46,489,62617,70,NULL,NULL,'2MASX J15533451+1232407',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,238.393917,12.54461,0.077,NULL,56530074591,883282415,13801287,18.1),(133258,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133258,38.2,0.46,436,62618,70,NULL,NULL,'SDSS J155334.61+220740.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,238.3942083,22.12789,0.121,NULL,59407783318,928246614,14503853,18.3),(133259,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133259,37.79,0.11,362,62619,70,NULL,NULL,'2MASX J15533475+2715077',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,238.394708333,27.252,0.089,NULL,59874067898,935532310,14617692,17.1),(133260,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133260,37.39,0.33,301,62620,70,NULL,NULL,'2MASX J15533499+3941596',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000139,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,238.395625,39.69978,0.033,NULL,59794283869,934285685,14598213,17.3),(133261,'IRAS','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133261,33.84,0.8,58.6,62621,75,NULL,'HMCL, I','ESO 136- G 006',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000053,NULL,'14.8',0.3,'Sc;LSB disk    Sy2',NULL,NULL,NULL,NULL,1,238.397,-61.68289,NULL,NULL,44864188517,701002945,10953171,14.8),(133262,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133262,33.21,0.4,43.8,62621,75,NULL,'HMCL, I, raw','ESO 136- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133263,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133263,33.41,0.4,48,62621,75,NULL,'HMCL, I, inv','ESO 136- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133264,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133264,33.47,0.4,49.5,62621,75,NULL,'HMCL, I, cor','ESO 136- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133265,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133265,33.61,0.46,52.7,62621,NULL,NULL,'J','ESO 136- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133266,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133266,33.62,0.47,52.9,62621,NULL,NULL,'H','ESO 136- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133267,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133267,33.7,0.49,55.1,62621,75,NULL,'IR','ESO 136- G 006',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133268,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133268,33.71,0.45,55.3,62621,NULL,NULL,'K','ESO 136- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133269,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133269,33.73,0.4,55.8,62621,NULL,NULL,'mean','ESO 136- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133270,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133270,37.01,0.46,252,62622,70,NULL,NULL,'2MASX J15533640+2426447',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000144,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.4017917,24.44583,0.141,NULL,59397873864,928091779,14501434,17.5),(133271,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133271,38.1,0.46,416,62623,70,NULL,NULL,'2MASX J15533768+0038039',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000087,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,238.407041667,0.63433,0.365,NULL,56473995194,882406174,13787596,17.4),(133272,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133272,37.84,0.23,370,62624,70,NULL,NULL,'2MASX J15533782+2737248',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000175,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,238.407667,27.62361,0.109,NULL,59874526989,935539484,14617804,17.3),(133273,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133273,36.31,0.46,183,62625,70,NULL,NULL,'2MASX J15533999+1928209',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'15.8g',0.33,NULL,NULL,NULL,NULL,NULL,1,238.416625,19.47239,0.057,NULL,59400551698,928133620,14502087,15.8),(133274,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133274,38,0.33,398,62626,70,NULL,NULL,'2MASX J15534002+1747387',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,238.416875,17.794,0.061,NULL,56531056991,883297765,13801527,18.4),(133275,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133275,36.74,0.46,223,62627,70,NULL,NULL,'2MASX J15534099+3539512',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,238.420667,35.66419,0.053,NULL,59887330302,935739535,14620930,16.6),(133276,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133276,37.7,0.33,347,62628,70,NULL,NULL,'2MASX J15534122+2026559',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,238.4217083,20.44897,0.085,NULL,59403846038,928185094,14502892,18.3),(133277,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133277,37.29,0.46,288,62629,70,NULL,NULL,'2MASX J15534153+4029067',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00014,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,238.423083,40.48508,0.053,NULL,59797941317,934342833,14599106,17.1),(133278,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133278,35.4,NULL,120,62630,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1966',NULL,'2010Ap&SS.325..163P',2010,1,1.04,NULL,'G',0.000063,NULL,'16.6',0.09,'Sd',NULL,NULL,NULL,NULL,1,238.424167,45.40694,0.053,NULL,59682293414,932535834,14570872,16.6),(133279,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133279,35.42,NULL,121,62630,NULL,NULL,'Dipole + Quadrupole','FGC 1966',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133280,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133280,35.43,NULL,122,62630,NULL,NULL,'Dipole','FGC 1966',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133281,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133281,35.45,NULL,123,62630,NULL,NULL,NULL,'FGC 1966',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133282,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133282,37.26,0.46,284,62631,70,NULL,NULL,'2MASX J15534227+1738597',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000165,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,238.426333,17.64997,0.061,NULL,56530984459,883296632,13801509,16.7),(133283,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133283,38,0.33,398,62632,70,NULL,NULL,'2MASX J15534275+1748587',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.428333,17.81625,0.061,NULL,56531056885,883297763,13801527,17.5),(133284,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133284,37.39,0.17,300,62633,70,NULL,NULL,'2MASX J15534480+3528552',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000162,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,238.436708333,35.48203,0.057,NULL,59887370066,935740157,14620939,16.6),(133285,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133285,34.93,0.57,96.9,62634,70,NULL,NULL,'2MASX J15534487-0242203',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,238.436917,-2.70564,0.517,NULL,45517688558,711213883,11112716,15.5),(133286,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133286,35.55,0.25,129,62635,74.4,NULL,NULL,'GIN 449',NULL,'2013AJ....146...86T',2013,1,0.52,NULL,'G',0.00009,NULL,'16.0g',0.33,'S','Field galaxy',NULL,NULL,NULL,1,238.439417,41.39036,0.029,NULL,59796464787,934319762,14598746,16),(133287,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133287,35.74,0.35,140,62635,70,NULL,NULL,'GIN 449',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133288,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133288,37.7,0.33,347,62636,70,NULL,NULL,'2MASX J15534557+2025284',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,238.439833333,20.42453,0.085,NULL,59403845648,928185088,14502892,NULL),(133289,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133289,37.39,0.17,300,62637,70,NULL,NULL,'2MASX J15534768+3521573',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,238.448625,35.36603,0.057,NULL,59887535400,935742740,14620980,18.3),(133290,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133290,38.02,0.33,401,62638,70,NULL,NULL,'2MASX J15534781+1253377',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.449333,12.89389,0.125,NULL,56530126825,883283231,13801300,17.7),(133291,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133291,36.19,0.46,173,62639,70,NULL,NULL,'GIN 533',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00008,NULL,'15.5g',0.52,'SB0',NULL,NULL,NULL,NULL,1,238.45825,18.34133,0.053,NULL,59399749618,928121087,14501891,15.5),(133292,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133292,36.25,0.25,178,62639,74.4,NULL,NULL,'GIN 533',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133293,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133293,36.44,0.18,194,62639,70,NULL,NULL,'GIN 533',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133294,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133294,38.05,0.46,407,62640,70,NULL,NULL,'2MASX J15535116+1309517',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,238.46325,13.16442,0.133,NULL,56530822566,883294102,13801470,17.1),(133295,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133295,37.61,0.21,332,62641,70,NULL,NULL,'2MASX J15535119+2852247',NULL,'2015arXiv151105856S',2015,1,0.25,'2001AJ....122.2893W has z = +- 0.095466 +- 0.000183.','G',0.000156,NULL,'17.2g',0.25,'E',NULL,NULL,NULL,NULL,1,238.463291667,28.87356,0.117,NULL,59867361017,935427515,14616054,17.2),(133296,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133296,36.92,0.98,242,62642,70,NULL,NULL,'2MASX J15535222-0538260',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,238.467583,-5.64064,0.525,NULL,45595180484,712424695,11131635,15.1),(133297,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133297,35.54,0.25,128,62643,74.4,NULL,NULL,'GIN 452',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000147,NULL,'16.1g',0.35,'S','Field galaxy',NULL,NULL,NULL,1,238.470083,41.49767,0.029,NULL,59796607843,934321997,14598781,16.1),(133298,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133298,35.74,0.35,140,62643,70,NULL,NULL,'GIN 452',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133299,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133299,35.78,0.19,143,62643,70,NULL,NULL,'GIN 452',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133300,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133300,37.81,0.46,364,62644,70,NULL,NULL,'2MASX J15535303+2932357',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000174,NULL,'17.6g',0.14,'AGN',NULL,NULL,NULL,NULL,1,238.4709583,29.54319,0.097,NULL,59867081635,935423150,14615986,17.6),(133301,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133301,37.51,0.46,318,62645,70,NULL,NULL,'SDSS J155353.17+393040.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,238.471583,39.51128,0.041,NULL,59794316536,934286195,14598221,18),(133302,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133302,37.54,0.33,322,62646,70,NULL,NULL,'SDSS J155353.19+335744.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,238.471667,33.96244,0.065,NULL,59890055513,935782117,14621595,18.3),(133303,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133303,37.69,0.46,345,62647,70,NULL,NULL,'2MASX J15535663+2736417',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000182,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,238.486083,27.61142,0.109,NULL,59874541145,935539705,14617807,16.9),(133304,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133304,37.77,0.46,357,62648,70,NULL,NULL,'2MASX J15535672+3558157',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'17.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,238.486333,35.971,0.065,NULL,59775132967,933986452,14593538,17.6),(133305,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133305,37.22,0.46,278,62649,70,NULL,NULL,'2MASX J15535678+2119024',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00016,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,238.486583,21.31733,0.133,NULL,59402367481,928161991,14502531,16.9),(133306,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133306,38.85,0.46,588,62650,70,NULL,NULL,'2MASX J15535812+3317313',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.492125,33.29206,0.073,NULL,59890084001,935782562,14621602,17.7),(133307,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133307,36.04,0.46,161,62651,70,NULL,NULL,'2MASX J15535882+1953154',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,238.4952083,19.88761,0.053,NULL,59403207865,928175122,14502736,16.7),(133308,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133308,38.15,0.46,426,62652,70,NULL,NULL,'2MASX J15540085+2810174',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,238.503667,28.17161,0.109,NULL,59874340439,935536569,14617758,17.4),(133309,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133309,37.26,0.33,283,62653,70,NULL,NULL,'2MASX J15540100+2422514',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000182,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,238.504167,24.38092,0.141,NULL,59397680379,928088755,14501386,17),(133310,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133310,37.79,0.11,362,62654,70,NULL,NULL,'2MASX J15540105+2728084',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000181,NULL,'16.4g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,238.504291667,27.46889,0.097,NULL,59874485050,935538828,14617794,16.4),(133311,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133311,36.18,0.46,172,62655,70,NULL,NULL,'2MASX J15540203+0356420',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'17.09',0.37,NULL,NULL,NULL,NULL,NULL,1,238.508625,3.94506,0.297,NULL,56613212907,884581451,13821585,17.09),(133312,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133312,36.3,0.46,182,62656,70,NULL,NULL,'MCG +06-35-013',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000192,NULL,'15.4g',0.47,'S0',NULL,NULL,NULL,NULL,1,238.50875,37.17147,0.025,NULL,59762495601,933788993,14590453,15.4),(133313,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133313,36.37,0.46,188,62657,70,NULL,NULL,'2MASX J15540265+4229556',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000178,NULL,'15.8g',0.37,'S0^-','Field galaxy',NULL,NULL,NULL,1,238.510916667,42.49894,0.061,NULL,59677800372,932465630,14569775,15.8),(133314,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133314,38.04,0.27,406,62658,70,NULL,NULL,'2MASX J15540266+1147461',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,238.5112083,11.79628,0.061,NULL,56598289800,884348278,13817941,17.8),(133315,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133315,38.04,0.27,406,62659,70,NULL,NULL,'SDSS J155402.80+114619.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,238.511667,11.77217,0.061,NULL,56598289454,884348272,13817941,18.2),(133316,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133316,35.37,0.46,119,62660,70,NULL,NULL,'2MASX J15540325+1712384',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00018,NULL,'17.27',0.32,NULL,NULL,NULL,NULL,NULL,1,238.513583,17.21081,0.053,NULL,56531482153,883304408,13801631,17.27),(133317,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133317,37.7,0.46,346,62661,70,NULL,NULL,'2MASX J15540376+2954543',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000188,NULL,'16.3g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,238.5155417,29.91511,0.093,NULL,59866936514,935420883,14615951,16.3),(133318,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133318,38.33,0.46,463,62662,70,NULL,NULL,'2MASX J15540433+5528329',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000088,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.5182083,55.47592,NULL,NULL,57642303753,900660996,14072828,17.5),(133319,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133319,37.79,0.11,362,62663,70,NULL,NULL,'2MASX J15540466+2722404',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.519583,27.37797,0.097,NULL,59874022727,935531605,14617681,17.8),(133320,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133320,36.49,0.33,198,62664,70,NULL,NULL,'2MASX J15540516+0835161',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000161,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,238.521417,8.58797,0.065,NULL,56639464078,884991626,13827994,17.8),(133321,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133321,36.33,0.69,185,62665,70,NULL,NULL,'2MASX J15540529-0424270',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,238.522125,-4.40742,0.597,NULL,45593636416,712400569,11131258,16.1),(133322,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133322,37.03,0.46,254,62666,70,NULL,NULL,'2MASX J15540557+1013041',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,238.523166667,10.21778,0.125,NULL,56633214080,884893970,13826468,17.1),(133323,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133323,37.01,0.33,253,62667,70,NULL,NULL,'2MASX J15540585+2649044',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000186,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,238.524417,26.81794,0.117,NULL,59877578429,935587162,14618549,16.5),(133324,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133324,36.25,0.25,178,62668,74.4,NULL,NULL,'CGCG 107-053',NULL,'2013AJ....146...86T',2013,1,0.95,NULL,'G',0.000167,NULL,'15.2g',0.55,'SAb:','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,238.524917,18.64767,0.053,NULL,59399974185,928124596,14501946,15.2),(133325,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133325,36.44,0.18,194,62669,70,NULL,NULL,'GIN 531',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.000077,NULL,'14.43',NULL,'S',NULL,NULL,NULL,NULL,1,238.525291667,18.6475,0.053,NULL,59399974185,928124596,14501946,14.43),(133326,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133326,36.04,0.46,161,62670,70,NULL,NULL,'2MASX J15540712+4743151',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000142,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,238.5297083,47.72078,0.049,NULL,59712944357,933014755,14578355,16.8),(133327,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133327,37.16,0.46,270,62671,70,NULL,NULL,'2MASX J15540777+0633371',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00018,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,238.532375,6.56033,0.129,NULL,56629564676,884836948,13825577,16.9),(133328,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133328,38.02,0.46,402,62672,70,NULL,NULL,'2MASX J15540793+3802167',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,238.533,38.03803,0.041,NULL,59764485924,933820092,14590938,17.8),(133329,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133329,37.15,0.46,269,62673,70,NULL,NULL,'2MASX J15540837+3925437',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000156,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,238.5347083,39.42892,0.025,NULL,59794271943,934285499,14598210,16.7),(133330,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133330,36.49,0.33,198,62674,70,NULL,NULL,'2MASX J15540853+0835281',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00018,NULL,'15.8g',0.39,NULL,NULL,NULL,NULL,NULL,1,238.535625,8.59122,0.065,NULL,56639463840,884991622,13827994,15.8),(133331,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133331,38.65,0.46,537,62675,70,NULL,NULL,'2MASX J15540886+1916064',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,238.537,19.26847,0.049,NULL,59400781412,928137209,14502143,17.5),(133332,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133332,36.98,0.46,249,62676,70,NULL,NULL,'2MASX J15540977+2321234',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000133,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.54075,23.35653,0.153,NULL,59406845666,928231963,14503624,17),(133333,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133333,37.84,0.23,370,62677,70,NULL,NULL,'2MASX J15540976+2730094',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000204,NULL,'16.5g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,238.540833,27.50261,0.097,NULL,59874486923,935538858,14617794,16.5),(133334,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133334,37.94,0.33,387,62678,70,NULL,NULL,'2MASX J15540999+1229234',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,238.541667,12.48997,0.077,NULL,56527387575,883240430,13800631,17.5),(133335,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133335,38.47,0.19,494,62679,70,NULL,NULL,'SDSS J155410.35+331000.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,238.543166667,33.16672,0.073,NULL,59890075476,935782429,14621600,18.5),(133336,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133336,37.79,0.11,362,62680,70,NULL,NULL,'SDSS J155410.83+272524.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000172,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,238.545167,27.42356,0.097,NULL,59874023766,935531621,14617681,18.3),(133337,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133337,37.3,0.46,288,62681,70,NULL,NULL,'2MASX J15541128+2051284',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000147,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,238.547125,20.85775,0.073,NULL,59403131662,928173932,14502717,17.8),(133338,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133338,35.32,0.46,116,62682,70,NULL,NULL,'CGCG 166-067',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000083,NULL,'15.3g',0.41,'E0',NULL,NULL,NULL,NULL,1,238.5479583,30.15586,0.089,NULL,59866875066,935419922,14615936,15.3),(133339,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133339,37.78,0.46,359,62683,70,NULL,NULL,'2MASX J15541164+0224090',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000083,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.548583,2.40253,0.245,NULL,56474402554,882412539,13787695,17.7),(133340,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133340,35.22,0.49,111,62684,75,NULL,'IR','2MFGC 12763',NULL,'2011yCatp016004901K',2011,1,0.48,NULL,'G',0.000033,NULL,'16.3g',0.45,'S',NULL,NULL,NULL,NULL,1,238.548625,21.56806,0.141,NULL,59407606048,928243844,14503810,16.3),(133341,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133341,34.41,0.2,76.2,62685,74.4,NULL,NULL,'CGCG 078-098',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000279,NULL,'15.7',0.5,NULL,NULL,NULL,NULL,NULL,1,238.5512917,11.86461,0.073,NULL,56598410762,884350168,13817971,15.7),(133342,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133342,38.4,0.46,479,62686,70,NULL,NULL,'SDSS J155413.84+265105.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.557667,26.85156,0.117,NULL,59877585104,935587267,14618551,18.2),(133343,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133343,31.52,0.45,20.1,62687,NULL,NULL,'K','NGC 6012',NULL,'2007A&A...465...71T',2007,1,2.1,NULL,'G',0.000013,NULL,'12.69',1.5,'(R)SB(r)ab:   LINER:','Supercluster foreground object',NULL,NULL,NULL,1,238.558083,14.60125,0.101,NULL,56535162096,883361907,13802529,12.69),(133344,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133344,31.52,0.47,20.2,62687,NULL,NULL,'H','NGC 6012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133345,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133345,31.59,0.46,20.8,62687,NULL,NULL,'J','NGC 6012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133346,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133346,32.1,0.4,26.3,62687,NULL,NULL,'mean','NGC 6012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133347,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133347,38.47,0.19,494,62688,70,NULL,NULL,'2MASX J15541406+3308161',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,238.5587083,33.13792,0.081,NULL,59886602582,935728165,14620752,17.5),(133348,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133348,35.54,0.25,128,62689,74.4,NULL,NULL,'GIN 448',NULL,'2013AJ....146...86T',2013,1,0.46,NULL,'G',0.000078,NULL,'16.0g',0.34,'S','Field galaxy',NULL,NULL,NULL,1,238.559125,41.41517,0.029,NULL,59796475451,934319928,14598748,16),(133349,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133349,35.74,0.35,140,62689,70,NULL,NULL,'GIN 448',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133350,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133350,37.39,0.33,301,62690,70,NULL,NULL,'2MASX J15541460+3945522',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000189,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,238.5607917,39.7645,0.033,NULL,59797701778,934339090,14599048,16.1),(133351,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133351,37.26,0.46,283,62691,70,NULL,NULL,'2MASX J15541483+3840571',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000177,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,238.561916667,38.68256,0.013,NULL,59764056321,933813380,14590834,16.9),(133352,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133352,35.4,NULL,120,62692,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1965',NULL,'2010Ap&SS.325..163P',2010,1,0.64,NULL,'G',0.000016,NULL,'16.9',0.09,'Scd',NULL,NULL,NULL,NULL,1,238.5637917,10.96944,0.101,NULL,56598513585,884351774,13817996,16.9),(133353,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133353,35.42,NULL,121,62692,NULL,NULL,'Dipole + Quadrupole','FGC 1965',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133354,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133354,35.44,NULL,123,62692,NULL,NULL,'Dipole','FGC 1965',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133355,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133355,36.04,0.2,161,62692,74.4,NULL,NULL,'FGC 1965',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133356,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133356,37.01,0.33,253,62693,70,NULL,NULL,'2MASX J15541661+2650454',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000183,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,238.56925,26.84606,0.117,NULL,59877577738,935587152,14618549,16.7),(133357,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133357,38.2,0.33,437,62694,70,NULL,NULL,'2MASX J15541720+3746492',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000165,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,238.5717917,37.78031,0.061,NULL,59764456795,933819637,14590931,17),(133358,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133358,37.43,0.46,306,62695,70,NULL,NULL,'2MASX J15541740+3435451',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000179,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,238.572333,34.59594,0.065,NULL,59887937013,935749015,14621078,16.8),(133359,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133359,37.94,0.33,387,62696,70,NULL,NULL,'SDSS J155417.59+122505.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,238.573333,12.41822,0.077,NULL,56527405717,883240714,13800636,18.3),(133360,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133360,38.47,0.19,494,62697,70,NULL,NULL,'2MASX J15541820+3308191',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000147,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.575875,33.13867,0.081,NULL,59886603039,935728172,14620752,17.1),(133361,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133361,38,0.46,399,62698,70,NULL,NULL,'2MASX J15541854+3123151',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00018,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.577375,31.38744,0.077,NULL,59920666572,936260415,14629068,17.4),(133362,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133362,31.62,0.2,21.1,62699,74.4,NULL,NULL,'NGC 6010',NULL,'2013AJ....146...86T',2013,1,1.9,NULL,'G',0.000017,NULL,'13.60',0.5,'S0/a: sp',NULL,NULL,NULL,NULL,1,238.5797917,0.54306,0.365,NULL,56474198692,882409354,13787646,13.6),(133363,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133363,31.63,0.36,21.2,62699,NULL,NULL,NULL,'NGC 6010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133364,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133364,31.67,NULL,21.6,62699,72,NULL,NULL,'NGC 6010',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133365,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133365,31.71,0.35,22,62699,NULL,NULL,'Malmquist cor.','NGC 6010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133366,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133366,32.18,0.49,27.3,62699,75,NULL,'IR','NGC 6010',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133367,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133367,32.34,0.4,29.3,62699,75,NULL,NULL,'NGC 6010',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133368,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133368,37.84,0.23,370,62700,70,NULL,NULL,'2MASX J15542006+2727474',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,238.583625,27.46317,0.097,NULL,59874486146,935538846,14617794,NULL),(133369,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133369,37.24,0.46,281,62701,70,NULL,NULL,'2MASX J15542016+0357599',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,238.5840417,3.96667,0.257,NULL,56613527006,884586359,13821661,17.2),(133370,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133370,37.11,0.46,264,62702,70,NULL,NULL,'2MASX J15542042+1021345',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,238.585167,10.35953,0.125,NULL,56635181378,884924709,13826948,17),(133371,'IRAS','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133371,33.79,0.8,57.2,62703,75,NULL,'HMCL, I','ESO 136- G 008',NULL,'1997ApJS..109..333W',1997,1,1.2,'Confused HIPASS source','G',0.000023,NULL,'14.5',0.3,'S?;cl.to v.br.*',NULL,NULL,NULL,NULL,1,238.596417,-61.34,NULL,NULL,44377951689,693405495,10834460,14.5),(133372,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133372,32.87,0.47,37.4,62703,NULL,NULL,'H','ESO 136- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133373,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133373,32.88,0.46,37.7,62703,NULL,NULL,'J','ESO 136- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133374,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133374,32.9,0.45,38,62703,NULL,NULL,'K','ESO 136- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133375,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133375,32.99,0.4,39.7,62703,75,NULL,'HMCL, I, raw','ESO 136- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133376,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133376,33.17,0.4,43.1,62703,75,NULL,'HMCL, I, inv','ESO 136- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133377,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133377,33.28,0.4,45.3,62703,75,NULL,'HMCL, I, cor','ESO 136- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133378,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133378,33.7,0.4,55,62703,NULL,NULL,'mean','ESO 136- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133379,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133379,37.47,0.11,313,62704,70,NULL,NULL,'SDSS J155423.21+282503.1',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,238.59675,28.41756,0.101,NULL,59866800752,935418761,14615918,17.7),(133380,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133380,36.09,0.46,165,62705,70,NULL,NULL,'UGC 10084',NULL,'2015arXiv151105856S',2015,1,1.4,NULL,'G',0.0001,NULL,'14.35',0.8,'S0+?','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,238.601,18.652,0.057,NULL,59399978741,928124667,14501947,14.35),(133381,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133381,36.25,0.25,178,62705,74.4,NULL,NULL,'UGC 10084',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133382,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133382,36.44,0.18,194,62705,70,NULL,NULL,'UGC 10084',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133383,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133383,36.97,0.46,248,62706,70,NULL,NULL,'2MASX J15542618+1153025',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,238.609167,11.88417,0.073,NULL,56598398394,884349974,13817968,18),(133384,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133384,38.12,0.46,420,62707,70,NULL,NULL,'2MASX J15542661+1355357',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,238.610875,13.92664,0.141,NULL,56528507691,883257932,13800905,17.9),(133385,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133385,38.21,0.46,438,62708,70,NULL,NULL,'2MASX J15542672+3915572',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,238.61125,39.26594,0.037,NULL,59760977260,933765269,14590082,17.9),(133386,'IRAS','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133386,35.58,0.8,131,62709,75,NULL,'W91CL, r','UGC 10085',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000023,NULL,'14.86',0.7,'SAcd:','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,238.611875,18.5255,0.053,NULL,59399765963,928121343,14501895,14.86),(133387,'IRAS','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133387,35.59,0.8,131,62709,75,NULL,'HMCL, I','UGC 10085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133388,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133388,34.94,0.4,97.5,62709,75,NULL,'HMCL, I, raw','UGC 10085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133389,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133389,35.09,0.38,104,62709,75,NULL,'W91CL, r, raw','UGC 10085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133390,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133390,35.12,0.4,106,62709,75,NULL,'HMCL, I, inv','UGC 10085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133391,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133391,35.24,0.38,112,62709,75,NULL,'W91CL, r, inv','UGC 10085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133392,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133392,35.33,0.4,117,62709,75,NULL,'HMCL, I, cor','UGC 10085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133393,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133393,35.49,0.38,125,62709,75,NULL,'W91CL, r, cor','UGC 10085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133394,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133394,36.3,0.33,182,62710,70,NULL,NULL,'2MASX J15542717+4154132',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'16.15',NULL,NULL,'Field galaxy',NULL,NULL,NULL,1,238.61325,41.90367,0.073,NULL,59797037731,934328714,14598886,16.15),(133395,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133395,35.03,0.59,101,62711,70,NULL,NULL,'2MASX J15542731-0751126',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.16',NULL,NULL,NULL,NULL,NULL,NULL,1,238.6139583,-7.8535,0.549,NULL,45633601273,713025019,11141015,17.16),(133396,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133396,36.4,0.46,191,62712,70,NULL,NULL,'2MASX J15542783+2459174',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000181,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,238.6159583,24.98819,0.153,NULL,59870561659,935477525,14616836,16.3),(133397,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133397,36.44,0.46,194,62713,70,NULL,NULL,'2MASX J15542830+2525094',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.618,25.41939,0.161,NULL,59874874517,935544914,14617889,17.5),(133398,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133398,38.08,0.46,413,62714,70,NULL,NULL,'2MASX J15542920-0041324',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000077,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.62175,-0.69228,0.385,NULL,45519582619,711243478,11113179,17.7),(133399,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133399,38.41,0.46,480,62715,70,NULL,NULL,'2MASX J15542989+0719175',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000178,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,238.62475,7.3215,0.105,NULL,56638304355,884973505,13827711,17.2),(133400,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133400,37.33,0.46,292,62716,70,NULL,NULL,'2MASX J15543205+2310059',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,238.633625,23.16825,0.137,NULL,59406357152,928224330,14503505,17),(133401,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133401,37.47,0.11,313,62717,70,NULL,NULL,'2MASX J15543232+2827380',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000192,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,238.634541667,28.46058,0.101,NULL,59866803338,935418802,14615918,16.7),(133402,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133402,36.3,0.33,182,62718,70,NULL,NULL,'2MASX J15543235+4207512',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000188,NULL,'16.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.634667,42.13092,0.041,NULL,59797022688,934328479,14598882,16.6),(133403,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133403,37.45,0.46,309,62719,70,NULL,NULL,'2MASX J15543299+0954345',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,238.637291667,9.90961,0.117,NULL,56633196735,884893698,13826464,17.6);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (133404,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133404,37.36,0.23,297,62720,70,NULL,NULL,'2MASX J15543435+1054545',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,238.64325,10.91542,0.101,NULL,56598490379,884351412,13817990,16.3),(133405,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133405,38.43,0.46,486,62721,70,NULL,NULL,'2MASX J15543453+3317062',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,238.64375,33.28522,0.073,NULL,59890078630,935782478,14621601,17.9),(133406,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133406,36.91,0.46,241,62722,70,NULL,NULL,'2MASX J15543448+5336465',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00009,NULL,'15.9g',0.36,'E0',NULL,NULL,NULL,NULL,1,238.643917,53.61292,0.013,NULL,59697779819,932777809,14574653,15.9),(133407,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133407,39.43,0.46,770,62723,70,NULL,NULL,'SDSS J155434.86+353357.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000132,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,238.64525,35.56589,0.057,NULL,59766758432,933855600,14591493,18.7),(133408,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133408,38.22,0.33,441,62724,70,NULL,NULL,'2MASX J15543532+2437541',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,238.647125,24.63181,0.145,NULL,59870555867,935477435,14616834,17.2),(133409,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133409,38.7,0.46,551,62725,70,NULL,NULL,'SDSS J155435.94+093823.6',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000174,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.64975,9.63989,0.089,NULL,56632907542,884889180,13826393,17.7),(133410,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133410,35.79,0.27,144,62726,70,NULL,NULL,'MCG +07-33-008',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.00017,NULL,'15.2g',0.62,'E0',NULL,NULL,NULL,NULL,1,238.655083,39.76158,0.033,NULL,59797716783,934339324,14599051,15.2),(133411,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133411,36.46,0.33,196,62727,70,NULL,NULL,'2MASX J15543893+1916369',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.662333,19.27703,0.045,NULL,59400743968,928136624,14502134,17),(133412,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133412,38.22,0.33,441,62728,70,NULL,NULL,'SDSS J155439.47+243448.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,238.6645,24.58014,0.145,NULL,59397643340,928088177,14501377,18.5),(133413,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133413,37.48,0.46,314,62729,70,NULL,NULL,'2MASX J15543982+4449221',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000178,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,238.6660417,44.82269,0.045,NULL,59683409789,932553277,14571144,17.2),(133414,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133414,37.36,0.23,297,62730,70,NULL,NULL,'2MASX J15544052+1101556',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,238.668833333,11.03222,0.101,NULL,56598485819,884351340,13817989,16.5),(133415,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133415,37.47,0.11,313,62731,70,NULL,NULL,'2MASX J15544100+2811301',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.1g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,238.670833,28.19164,0.109,NULL,59874330256,935536410,14617756,16.1),(133416,'Tully est','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133416,32.77,0.8,35.9,62732,75,NULL,'B','UGC 10086',NULL,'1988NBGC.C....0000T',1988,1,0.6,NULL,'G',0.000103,NULL,'15.3',0.2,'S0/a?          HII','Supercluster foreground object',NULL,NULL,NULL,1,238.671875,16.61719,0.061,NULL,56534250663,883347666,13802307,15.3),(133417,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133417,37.61,0.21,332,62733,70,NULL,NULL,'2MASX J15544175+2903161',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000149,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.674083,29.05458,0.117,NULL,59867179347,935424677,14616010,17.9),(133418,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133418,37.39,0.17,300,62734,70,NULL,NULL,'2MASX J15544310+3521171',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00016,NULL,'16.6g',0.26,'BrClG',NULL,NULL,NULL,NULL,1,238.6797083,35.35475,0.057,NULL,59766835999,933856812,14591512,16.6),(133419,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133419,35.84,0.49,147,62735,75,NULL,'IR','FGC 1967',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000009,NULL,'16.4',0.11,'Scd',NULL,NULL,NULL,NULL,1,238.68125,4.51697,0.213,NULL,56613303717,884582870,13821607,16.4),(133420,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133420,35.91,NULL,152,62735,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1967',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133421,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133421,35.93,NULL,154,62735,NULL,NULL,'Dipole + Quadrupole','FGC 1967',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133422,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133422,35.95,NULL,155,62735,NULL,NULL,NULL,'FGC 1967',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133423,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133423,35.95,NULL,155,62735,NULL,NULL,'Dipole','FGC 1967',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133424,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133424,37.36,0.23,297,62736,70,NULL,NULL,'2MASX J15544391+1100091',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,238.683,11.00253,0.101,NULL,56598494655,884351478,13817991,17.4),(133425,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133425,38.47,0.19,494,62737,70,NULL,NULL,'2MASX J15544390+3256471',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000142,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.6830417,32.94639,0.085,NULL,59887071274,935735488,14620867,18.1),(133426,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133426,37.56,0.46,324,62738,70,NULL,NULL,'2MASX J15544411+5508417',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000067,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.6837083,55.14481,NULL,NULL,57641931562,900655180,14072737,17.8),(133427,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133427,36.7,0.46,219,62739,70,NULL,NULL,'I Zw 128 NOTES03',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00008,NULL,'15.5',0.35,NULL,NULL,NULL,NULL,NULL,1,238.687,45.33828,0.053,NULL,59684051530,932563305,14571301,15.5),(133428,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133428,38.2,0.33,437,62740,70,NULL,NULL,'2MASX J15544605+3746132',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000168,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.6917083,37.77039,0.061,NULL,59763728668,933808260,14590754,17.9),(133429,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133429,36.19,0.46,173,62741,70,NULL,NULL,'2MASX J15544667+3237041',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000176,NULL,'15.8g',0.43,'S0',NULL,NULL,NULL,NULL,1,238.694583,32.61772,0.077,NULL,59886961538,935733774,14620840,15.8),(133430,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133430,34.78,0.4,90.4,62742,NULL,NULL,'mean','ESO 389- G 003',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000037,NULL,'13.6R',0.7,'S...',NULL,NULL,NULL,NULL,1,238.696875,-37.58236,1.053,NULL,46257551589,722774243,11293347,13.6),(133431,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133431,34.92,0.47,96.5,62742,NULL,NULL,'H','ESO 389- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133432,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133432,34.99,0.45,99.4,62742,NULL,NULL,'K','ESO 389- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133433,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133433,34.99,0.46,99.7,62742,NULL,NULL,'J','ESO 389- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133434,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133434,38.47,0.19,494,62743,70,NULL,NULL,'2MASX J15544888+3303311',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.7037083,33.05881,0.081,NULL,59886606629,935728228,14620753,17.7),(133435,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133435,37.97,0.46,393,62744,70,NULL,NULL,'SDSS J155450.65+260423.1',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000151,NULL,'18.8g',0.09,NULL,NULL,NULL,NULL,NULL,1,238.711083,26.07308,0.165,NULL,59875462157,935554096,14618032,18.8),(133436,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133436,37.88,0.46,377,62745,70,NULL,NULL,'2MASX J15545063+5546447',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000081,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.711125,55.779,0,NULL,57641437206,900647456,14072616,17.7),(133437,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133437,37.87,0.46,375,62746,70,NULL,NULL,'2MASX J15545098+2749431',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000187,NULL,'16.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,238.7125,27.82878,0.109,NULL,59874388541,935537320,14617770,16.4),(133438,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133438,37.97,0.46,392,62747,70,NULL,NULL,'2MASX J15545195+5601507',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000093,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,238.716333333,56.03078,0,NULL,57641321328,900645645,14072588,16.9),(133439,'IRAS','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133439,34.35,0.8,74.2,62748,75,NULL,'HMCL, I','UGC 10089',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000027,NULL,'15.52',0.2,'Scd:',NULL,NULL,NULL,NULL,1,238.717083,21.11669,0.081,NULL,59402935183,928170862,14502669,15.52),(133440,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133440,34.07,0.2,65.2,62748,74.4,NULL,NULL,'UGC 10089',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133441,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133441,34.3,0.4,72.4,62748,75,NULL,'HMCL, I, raw','UGC 10089',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133442,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133442,34.39,0.4,75.5,62748,75,NULL,'HMCL, I, inv','UGC 10089',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133443,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133443,34.4,0.4,75.9,62748,75,NULL,'HMCL, I, cor','UGC 10089',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133444,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133444,37.08,0.46,260,62749,70,NULL,NULL,'2MASX J15545298+3610088',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000158,NULL,'16.7g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,238.720833,36.16925,0.065,NULL,59775159206,933986862,14593544,16.7),(133445,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133445,37.53,0.46,321,62750,70,NULL,NULL,'SDSS J155455.97+234129.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,238.7332083,23.69167,0.153,NULL,59407013942,928234592,14503665,18.4),(133446,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133446,37.61,0.46,333,62751,70,NULL,NULL,'2MASX J15545663+4831541',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,238.735875,48.53158,0.041,NULL,59711437531,932991211,14577987,17.4),(133447,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133447,38.47,0.19,494,62752,70,NULL,NULL,'SDSS J155456.62+330022.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,238.735917,33.00622,0.081,NULL,59887070494,935735476,14620866,18.1),(133448,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133448,37.47,0.46,312,62753,70,NULL,NULL,'2MASX J15545791+4753003',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000146,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,238.7414583,47.88342,0.049,NULL,59712886876,933013857,14578341,18.1),(133449,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133449,37.51,0.46,317,62754,70,NULL,NULL,'2MASX J15545908+2701581',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.74625,27.03278,0.109,NULL,59877534653,935586478,14618538,17.5),(133450,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133450,37.36,0.23,297,62755,70,NULL,NULL,'2MASX J15550034+1052561',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.5g',0.4,NULL,NULL,NULL,NULL,NULL,1,238.7515,10.88236,0.101,NULL,56631799933,884871873,13826123,16.5),(133451,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133451,36.78,0.2,227,62756,74.4,NULL,NULL,'CGCG 079-005',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.0005,NULL,'15.6',0.2,NULL,'Group member',NULL,NULL,NULL,1,238.752917,11.07411,0.097,NULL,56598695337,884354614,13818040,15.6),(133452,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133452,35.53,0.25,128,62757,74.4,NULL,NULL,'CGCG 223-012',NULL,'2013AJ....146...86T',2013,1,1.12,NULL,'G',0.000087,NULL,'14.2g',0.81,'cD;S?','Field galaxy',NULL,NULL,NULL,1,238.758,41.57833,0.029,NULL,59796915380,934326802,14598856,14.2),(133453,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133453,35.74,0.35,140,62757,70,NULL,NULL,'CGCG 223-012',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133454,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133454,35.78,0.19,143,62757,70,NULL,NULL,'CGCG 223-012',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133455,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133455,37.39,0.17,300,62758,70,NULL,NULL,'2MASX J15550211+3514062',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.758875,35.23508,0.053,NULL,59766838452,933856850,14591513,17.8),(133456,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133456,35.88,NULL,150,62759,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 079-004 NED01',NULL,'2010Ap&SS.325..163P',2010,1,0.88,NULL,'G',0.000131,NULL,'16.5',0.11,'Sbc',NULL,NULL,NULL,NULL,1,238.760958333,10.937,0.101,NULL,56631803085,884871923,13826123,16.5),(133457,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133457,35.89,NULL,151,62759,NULL,NULL,'Dipole + Quadrupole','CGCG 079-004 NED01',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133458,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133458,35.92,NULL,153,62759,NULL,NULL,'Dipole','CGCG 079-004 NED01',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133459,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133459,36.5,0.49,199,62759,75,NULL,'IR','CGCG 079-004 NED01',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133460,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133460,36.56,0.46,205,62760,70,NULL,NULL,'2MASX J15550504+5058062',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000178,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,238.7710417,50.96836,0.017,NULL,59717435498,933084929,14579452,16.8),(133461,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133461,37.74,0.46,353,62761,70,NULL,NULL,'SDSS J155506.15+285430.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000141,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,238.775625,28.90842,0.117,NULL,59866696650,935417135,14615892,18.1),(133462,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133462,35.75,0.46,141,62762,70,NULL,NULL,'2MASX J15550693+3446562',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00018,NULL,'15.4g',0.49,'E',NULL,NULL,NULL,NULL,1,238.778875,34.78228,0.065,NULL,59887925907,935748842,14621075,15.4),(133463,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133463,35.79,0.27,144,62763,70,NULL,NULL,'MCG +07-33-010',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.5',0.4,NULL,NULL,NULL,NULL,NULL,1,238.78325,39.75008,0.033,NULL,59797720683,934339385,14599052,16.5),(133464,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133464,37.28,0.33,286,62764,70,NULL,NULL,'MCG +06-35-014',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000188,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,238.787625,36.22214,0.057,NULL,59775339280,933989676,14593588,16.3),(133465,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133465,35.53,0.25,128,62765,74.4,NULL,NULL,'GIN 451',NULL,'2013AJ....146...86T',2013,1,0.41,NULL,'G',0.000141,NULL,'16.1g',0.37,'S','Field galaxy',NULL,NULL,NULL,1,238.78925,41.4485,0.029,NULL,59796448236,934319503,14598742,16.1),(133466,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133466,35.74,0.35,140,62765,70,NULL,NULL,'GIN 451',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133467,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133467,37.47,0.11,313,62766,70,NULL,NULL,'2MASX J15550959+2834456',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000174,NULL,'15.7g',0.52,'E0',NULL,NULL,NULL,NULL,1,238.790083333,28.57944,0.113,NULL,59866763292,935418176,14615909,15.7),(133468,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133468,37.36,0.46,297,62767,70,NULL,NULL,'2MASX J15551156+3934239',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000162,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,238.798167,39.57342,0.041,NULL,59797673070,934338641,14599041,16.2),(133469,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133469,38.33,0.33,463,62768,70,NULL,NULL,'2MASX J15551194+2803136',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000177,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.799916667,28.05369,0.109,NULL,59874465267,935538519,14617789,17.4),(133470,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133470,37.39,0.17,300,62769,70,NULL,NULL,'2MASX J15551369+3510052',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.807208333,35.16817,0.053,NULL,59766855115,933857111,14591517,17.9),(133471,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133471,35.53,0.25,128,62770,74.4,NULL,NULL,'GIN 444',NULL,'2013AJ....146...86T',2013,1,0.43,NULL,'G',0.000073,NULL,'15.9g',0.32,'S','Field galaxy',NULL,NULL,NULL,1,238.807625,41.58178,0.029,NULL,59796929279,934327019,14598859,15.9),(133472,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133472,35.74,0.35,140,62770,70,NULL,NULL,'GIN 444',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133473,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133473,35.78,0.19,143,62770,70,NULL,NULL,'GIN 444',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133474,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133474,35.53,0.25,128,62771,74.4,NULL,NULL,'GIN 450',NULL,'2013AJ....146...86T',2013,1,0.39,NULL,'G',0.000142,NULL,'16.5g',0.27,'S',NULL,NULL,NULL,NULL,1,238.808875,41.46722,0.029,NULL,59796918886,934326857,14598857,16.5),(133475,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133475,35.74,0.35,140,62771,70,NULL,NULL,'GIN 450',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133476,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133476,35.78,0.19,143,62771,70,NULL,NULL,'GIN 450',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133477,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133477,37.67,0.46,342,62772,70,NULL,NULL,'2MASX J15551589+1719535',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000137,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.816166667,17.33169,0.069,NULL,56564828020,883825437,13809772,18.3),(133478,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133478,37.48,0.46,314,62773,70,NULL,NULL,'SDSS J155516.19+132445.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,238.8175,13.41261,0.081,NULL,56530515656,883289307,13801395,18.6),(133479,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133479,38.33,0.33,463,62774,70,NULL,NULL,'SDSS J155516.64+281028.6',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000146,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.819333333,28.17464,0.109,NULL,59874450658,935538291,14617785,17.7),(133480,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133480,37.89,0.33,378,62775,70,NULL,NULL,'2MASX J15551666+1926097',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,238.8195,19.43597,0.033,NULL,59400081097,928126267,14501972,17.3),(133481,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133481,37.31,0.46,290,62776,70,NULL,NULL,'2MASX J15551697+5348272',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000091,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,238.8205417,53.8075,0.013,NULL,59697681774,932776277,14574629,16.6),(133482,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133482,38.31,0.46,460,62777,70,NULL,NULL,'2MASX J15551844+3249552',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000157,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,238.8267917,32.83194,0.085,NULL,59887111574,935736118,14620876,17.4),(133483,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133483,37.84,0.46,369,62778,70,NULL,NULL,'2MASX J15551876+3834069',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000172,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,238.828,38.56856,0.013,NULL,59764027678,933812932,14590827,17.4),(133484,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133484,36.23,0.46,176,62779,70,NULL,NULL,'2MASX J15551914+5303512',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000086,NULL,'16.1g',0.36,'E0',NULL,NULL,NULL,NULL,1,238.8297083,53.06439,0.013,NULL,59698450919,932788295,14574817,16.1),(133485,'Tully est','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133485,32.46,0.8,31.1,62780,75,NULL,NULL,'UGC 10095',NULL,'1988NBGC.C....0000T',1988,1,1.2,'Multiple SDSS entries describe this source.','G',0.000023,NULL,'16.5',0.6,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,238.8314583,45.42775,0.053,NULL,59684093785,932563965,14571311,16.5),(133486,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133486,32.47,0.4,31.2,62780,NULL,NULL,NULL,'UGC 10095',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133487,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133487,37.41,0.46,303,62781,70,NULL,NULL,'2MASX J15551983+3314530',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000179,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,238.832833,33.24817,0.073,NULL,59886664528,935729133,14620767,17.1),(133488,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133488,37.61,0.21,332,62782,70,NULL,NULL,'2MASX J15552056+2903446',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000191,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.8357083,29.06267,0.105,NULL,59867190088,935424845,14616013,17.8),(133489,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133489,38.51,0.33,503,62783,70,NULL,NULL,'2MASX J15552074+0000522',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000077,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.836416667,0.01447,0.405,NULL,56473196913,882393701,13787401,18.3),(133490,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133490,37.61,0.21,332,62784,70,NULL,NULL,'2MASX J15552095+2900507',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'17.4g',0.2,'BrClG',NULL,NULL,NULL,NULL,1,238.837167,29.01419,0.117,NULL,59867173601,935424587,14616009,17.4),(133491,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133491,37.5,0.33,317,62785,70,NULL,NULL,'2MASX J15552200+4531013',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00018,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,238.841708333,45.51692,0.053,NULL,59684033593,932563024,14571297,16.9),(133492,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133492,38.31,0.46,459,62786,70,NULL,NULL,'2MASX J15552217+0513028',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.842333,5.21736,0.165,NULL,56614533122,884602080,13821907,17.8),(133493,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133493,37.65,0.27,340,62787,70,NULL,NULL,'2MASX J15552234+2714097',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000175,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,238.843125,27.23608,0.089,NULL,59877626401,935587912,14618561,16.9),(133494,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133494,37.09,0.33,262,62788,70,NULL,NULL,'2MASX J15552239+5313442',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000103,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,238.843417,53.22889,0,NULL,59698502411,932789100,14574829,16.2),(133495,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133495,37.28,0.33,286,62789,70,NULL,NULL,'2MASX J15552461+3612562',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,238.8524583,36.21575,0.057,NULL,59775346615,933989790,14593590,16.9),(133496,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133496,37.86,0.46,373,62790,70,NULL,NULL,'2MASX J15552464+3426031',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00018,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,238.8527917,34.43431,0.057,NULL,59888081844,935751278,14621113,17.3),(133497,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133497,37.65,0.27,340,62791,70,NULL,NULL,'SDSS J155524.85+271436.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000135,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,238.8535417,27.24358,0.089,NULL,59877629268,935587957,14618561,17.7),(133498,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133498,38.51,0.33,503,62792,70,NULL,NULL,'2MASX J15552514+0000212',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000089,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,238.854625,0.00586,0.405,NULL,56473195242,882393675,13787401,18.6),(133499,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133499,36.16,0.46,170,62793,70,NULL,NULL,'2MASX J15552554+0346548',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.8564583,3.78186,0.257,NULL,56612709417,884573584,13821462,17.7),(133500,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133500,38.29,0.46,455,62794,70,NULL,NULL,'2MASX J15552593+3632342',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000176,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.8579583,36.54292,0.049,NULL,59761569700,933774526,14590226,17.6),(133501,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133501,34.25,0.4,70.9,62795,NULL,NULL,'mean','NGC 6068',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000037,NULL,'13.60',0.7,'SBbc?','Pair member (points to parent)',NULL,NULL,NULL,1,238.858291667,78.99678,0.137,NULL,57137304931,892770389,13949537,13.6),(133502,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133502,35.04,0.46,102,62795,NULL,NULL,'J','NGC 6068',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133503,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133503,35.07,0.47,103,62795,NULL,NULL,'H','NGC 6068',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133504,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133504,35.12,0.45,105,62795,NULL,NULL,'K','NGC 6068',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133505,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133505,35.53,0.25,128,62796,74.4,NULL,NULL,'GIN 447',NULL,'2013AJ....146...86T',2013,1,0.48,NULL,'G',0.00012,NULL,'15.9g',0.38,'E/S0','Field galaxy',NULL,NULL,NULL,1,238.8627083,41.55828,0.029,NULL,59796927110,934326986,14598859,15.9),(133506,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133506,35.74,0.35,140,62796,70,NULL,NULL,'GIN 447',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133507,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133507,37.16,0.33,271,62797,70,NULL,NULL,'2MASX J15552725+4047332',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,238.863708333,40.7925,0.045,NULL,59798083284,934345051,14599141,17.8),(133508,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133508,38.4,0.46,478,62798,70,NULL,NULL,'2MASX J15552942+2019567',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,238.872583,20.33233,0.085,NULL,59403776675,928184010,14502875,18.1),(133509,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133509,35.16,0.72,108,62799,70,NULL,NULL,'2MASX J15553033-0513527',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,238.876333,-5.23122,0.581,NULL,45596161700,712440026,11131875,15.6),(133510,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133510,37.52,0.46,320,62800,70,NULL,NULL,'2MASX J15553053+4022243',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00014,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,238.877041667,40.37336,0.037,NULL,59798162468,934346288,14599160,17.3),(133511,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133511,38.13,0.46,424,62801,70,NULL,NULL,'2MASX J15553054+4019353',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000137,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.877167,40.3265,0.037,NULL,59798163128,934346298,14599160,17.7),(133512,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133512,36.05,0.46,163,62802,70,NULL,NULL,'2MASX J15553116+1917567',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'16.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,238.87975,19.29897,0.045,NULL,59400160648,928127510,14501992,16.1),(133513,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133513,37.49,0.14,315,62803,70,NULL,NULL,'SDSS J155531.75+253946.5',NULL,'2015arXiv151105856S',2015,1,0.11,NULL,'G',0.000164,NULL,'18.8g',0.09,NULL,NULL,NULL,NULL,NULL,1,238.882333333,25.66292,0.177,NULL,59875612013,935556437,14618069,18.8),(133514,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133514,37.65,0.27,340,62804,70,NULL,NULL,'2MASX J15553223+2709217',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,238.88425,27.15603,0.117,NULL,59877647308,935588239,14618566,17.2),(133515,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133515,37.09,0.33,262,62805,70,NULL,NULL,'MCG +09-26-029',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000114,NULL,'15.6g',0.44,'E0',NULL,NULL,NULL,NULL,1,238.892208333,53.03333,0.013,NULL,59698503696,932789120,14574830,15.6),(133516,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133516,37.8,0.46,363,62806,70,NULL,NULL,'2MASX J15553499+3955223',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000146,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,238.8959583,39.92292,0.021,NULL,59797927941,934342624,14599103,17),(133517,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133517,37.89,0.33,378,62807,70,NULL,NULL,'2MASX J15553582+1930107',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,238.899208333,19.50289,0.033,NULL,59400083861,928126310,14501973,17.7),(133518,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133518,36.46,0.33,196,62808,70,NULL,NULL,'2MASX J15553610+1911157',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'17.52',0.36,NULL,NULL,NULL,NULL,NULL,1,238.900333333,19.18764,0.049,NULL,59400676274,928135566,14502118,17.52),(133519,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133519,37.39,0.17,300,62809,70,NULL,NULL,'2MASX J15553633+3511031',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000134,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,238.901417,35.18414,0.053,NULL,59766859226,933857175,14591518,16.6),(133520,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133520,37.81,0.46,365,62810,70,NULL,NULL,'2MASX J15553710+4938146',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000181,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,238.9044583,49.63733,0.037,NULL,59725783910,933215373,14581490,17),(133521,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133521,37.5,0.33,317,62811,70,NULL,NULL,'2MASX J15553781+4535134',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000185,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,238.9075,45.58717,0.033,NULL,59684042606,932563165,14571299,16.5),(133522,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133522,37.49,0.14,315,62812,70,NULL,NULL,'2MASX J15553830+2532406',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000185,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.909667,25.54472,0.153,NULL,59875609548,935556399,14618068,17.2),(133523,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133523,37.37,0.46,298,62813,70,NULL,NULL,'2MASX J15553934+3520071',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.72',0.43,NULL,NULL,NULL,NULL,NULL,1,238.914,35.33542,0.057,NULL,59766821495,933856585,14591509,16.72),(133524,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133524,37.5,0.27,316,62814,70,NULL,NULL,'2MASX J15553977+0309158',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000093,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.915667,3.15436,0.265,NULL,56481789663,882527963,13789499,17.5),(133525,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133525,37.61,0.21,332,62815,70,NULL,NULL,'2MASX J15553981+2848006',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000175,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.915875,28.80036,0.129,NULL,59866820128,935419064,14615922,17.4),(133526,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133526,35.74,0.35,140,62816,70,NULL,NULL,'GIN 445',NULL,'2001MNRAS.321..277C',2001,1,0.56,NULL,'G',0.000107,NULL,'15.7g',0.32,'S','Field galaxy',NULL,NULL,NULL,1,238.917375,41.50483,0.017,NULL,59796936951,934327139,14598861,15.7),(133527,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133527,36.14,0.46,169,62817,70,NULL,NULL,'2MASX J15554054+2521006',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000164,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,238.918833333,25.35031,0.161,NULL,59874941568,935545962,14617905,16.5),(133528,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133528,36.85,0.46,235,62818,70,NULL,NULL,'2MASX J15554115+0358536',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,238.9215,3.98144,0.257,NULL,56613556314,884586817,13821669,17.5),(133529,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133529,37.06,0.46,258,62819,70,NULL,NULL,'2MASX J15554205+1048223',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,238.9252083,10.80606,0.141,NULL,56631999784,884874996,13826171,17),(133530,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133530,38.07,0.46,412,62820,70,NULL,NULL,'2MASX J15554238+1902147',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000181,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,238.9264583,19.03733,0.049,NULL,59400667064,928135422,14502115,17.1),(133531,'BL Lac Luminosity','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133531,37.84,NULL,370,62821,70,NULL,'nucleus-to-host flux ratio, z > 0.09','[HB89] 1553+113',NULL,'2006AJ....132....1S',2006,1,NULL,'Literature z~0.36 considered erroneous. See 2010ApJ...720..976D.','QSO',NULL,NULL,'14.1V',NULL,'Opt.var.       BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,238.929333,11.19011,0.097,NULL,56631913796,884873653,13826150,14.1),(133532,'BL Lac Luminosity','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133532,40,NULL,1000,62821,NULL,NULL,NULL,'[HB89] 1553+113',NULL,'2007A&A...473L..17T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133533,'BL Lac Luminosity','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133533,40.21,NULL,1100,62821,70,NULL,'z > 0.30','[HB89] 1553+113',NULL,'2014A&A...570A.126L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133534,'BL Lac Luminosity','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133534,40.8,NULL,1440,62821,NULL,NULL,'very high energy spectrum absorption, z < 0.42','[HB89] 1553+113',NULL,'2007ApJ...655L..13M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133535,'BL Lac Luminosity','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133535,41.03,0.27,1610,62821,70,NULL,'z = 0.485 +/- 0.09 = mean of z0.53-0.62 max. + z0.395 min.','[HB89] 1553+113',NULL,'2015ApJ...799....7A',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133536,'BL Lac Luminosity','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133536,41.07,0.24,1640,62821,NULL,NULL,'intervening absorbers, z = 0.497 +/- 0.083','[HB89] 1553+113',NULL,'2010ApJ...720..976D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133537,'BL Lac Luminosity','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133537,41.11,0.34,1670,62821,70,NULL,'z = 0.51 +/- 0.11','[HB89] 1553+113',NULL,'2015arXiv150203012A',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133538,'BL Lac Luminosity','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133538,41.55,NULL,2040,62821,NULL,NULL,'very high energy, z < 0.68. mean of z < 0.67, 0.80, 0.58','[HB89] 1553+113',NULL,'2009arXiv0907.0157P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133539,'BL Lac Luminosity','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133539,41.57,NULL,2060,62821,NULL,NULL,'very high energy spectrum absorption, z < 0.69','[HB89] 1553+113',NULL,'2007ApJ...655L..13M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133540,'BL Lac Luminosity','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133540,41.57,NULL,2060,62821,NULL,NULL,'very high energy absorption z < 0.69','[HB89] 1553+113',NULL,'2008A&A...477..481A',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133541,'BL Lac Luminosity','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133541,41.67,NULL,2160,62821,NULL,NULL,'very high energy absorption z < 0.74','[HB89] 1553+113',NULL,'2006A&A...448L..19A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133542,'BL Lac Luminosity','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133542,41.67,NULL,2160,62821,NULL,NULL,'very high energy spectrum z > 0.74','[HB89] 1553+113',NULL,'2007ApJ...654L.119A',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133543,'GeV TeV ratio','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133543,40.36,NULL,1180,62821,72,NULL,NULL,'[HB89] 1553+113',NULL,'2010MNRAS.405L..76P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133544,'GeV TeV ratio','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133544,41.05,0.13,1620,62821,70,NULL,'z = 0.49 +/- 0.04','[HB89] 1553+113',NULL,'2015arXiv150202920S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133545,'GeV TeV ratio','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133545,41.62,0.12,2110,62821,72,NULL,NULL,'[HB89] 1553+113',NULL,'2011arXiv1111.0913P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133546,'IRAS','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133546,34.25,0.8,70.9,62822,75,NULL,'HMCL, I','UGC 10092',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.00002,NULL,'14.90',0.3,'SA(s)d:','Supercluster foreground object',NULL,NULL,NULL,1,238.929416667,18.28269,0.077,NULL,56509970206,882968284,13796379,14.9),(133547,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133547,33.25,0.4,44.8,62822,75,NULL,'HMCL, I, raw','UGC 10092',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133548,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133548,33.26,0.4,44.9,62822,75,NULL,'HMCL, I, inv','UGC 10092',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133549,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133549,33.65,0.4,53.6,62822,75,NULL,'HMCL, I, cor','UGC 10092',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133550,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133550,38.2,0.46,437,62823,70,NULL,NULL,'2MASX J15554311+3318491',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000141,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.9297083,33.31372,0.073,NULL,59886645091,935728829,14620762,18.2),(133551,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133551,34.91,0.4,95.8,62824,NULL,NULL,'mean','UGC 10097',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000073,NULL,'13.92',1.1,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,238.9302083,47.86728,0.049,NULL,59712890077,933013907,14578342,13.92),(133552,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133552,35.12,0.45,106,62824,NULL,NULL,'K','UGC 10097',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133553,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133553,38.75,0.46,562,62825,70,NULL,NULL,'2MASX J15554346+0947273',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.931166667,9.79083,0.117,NULL,56634811574,884918930,13826858,17.8),(133554,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133554,37.87,0.46,375,62826,70,NULL,NULL,'2MASX J15554514+2550446',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000176,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,238.938,25.84575,0.177,NULL,59875761991,935558781,14618105,17.4),(133555,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133555,35.39,0.49,119,62827,75,NULL,'IR','UGC 10094',NULL,'2011yCatp016004901K',2011,1,1.57,NULL,'G',0.000019,NULL,'15.7g',0.18,'Sc','Pair member (points to parent)',NULL,NULL,NULL,1,238.938875,24.49389,0.185,NULL,59392407597,928006368,14500099,15.7),(133556,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133556,35.8,0.31,144,62827,NULL,NULL,'Malmquist cor.','UGC 10094',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133557,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133557,35.92,0.29,153,62827,NULL,NULL,NULL,'UGC 10094',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133558,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133558,36.04,0.2,161,62827,74.4,NULL,NULL,'UGC 10094',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133559,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133559,36.06,NULL,163,62827,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10094',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133560,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133560,36.08,NULL,164,62827,NULL,NULL,'Dipole + Quadrupole','UGC 10094',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133561,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133561,36.09,NULL,165,62827,NULL,NULL,NULL,'UGC 10094',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133562,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133562,36.1,NULL,166,62827,NULL,NULL,'Dipole','UGC 10094',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133563,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133563,37.5,0.27,316,62828,70,NULL,NULL,'2MASX J15554690+0309046',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000087,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,238.9454583,3.15142,0.265,NULL,56481791420,882527990,13789499,18),(133564,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133564,38.04,0.46,406,62829,70,NULL,NULL,'SDSS J155547.56+505254.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000047,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,238.9482083,50.88192,0.017,NULL,59717451407,933085178,14579455,18.4),(133565,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133565,36.83,0.46,233,62830,70,NULL,NULL,'SDSS J155548.39+112433.8',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.8g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,238.951625,11.40939,0.097,NULL,56598536070,884352126,13818001,17.8),(133566,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133566,36.8,0.33,229,62831,70,NULL,NULL,'2MASX J15554944+2429117',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.001185,NULL,'17.6g',0.16,'AGN',NULL,NULL,NULL,NULL,1,238.9560417,24.48653,0.185,NULL,59392407676,928006369,14500099,17.6),(133567,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133567,38.24,0.46,445,62832,70,NULL,NULL,'SDSS J155550.62+345937.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,238.9609583,34.99378,0.065,NULL,59767666203,933869784,14591715,18.2),(133568,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133568,35.79,0.27,144,62833,70,NULL,NULL,'CGCG 223-014',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000157,NULL,'15.4',0.4,NULL,NULL,NULL,NULL,NULL,1,238.965291667,39.76708,0.033,NULL,59797698753,934339043,14599047,15.4),(133569,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133569,37.51,0.46,317,62834,70,NULL,NULL,'2MASX J15555356+3129341',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000197,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,238.9732083,31.49278,0.049,NULL,59920820887,936262826,14629106,16.4),(133570,'IRAS','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133570,34.68,0.8,86.3,62835,75,NULL,'CF, r','NGC 6016',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000027,NULL,'14.7g',0.5,'Scd:',NULL,NULL,NULL,NULL,1,238.978625,26.9665,0.121,NULL,59877639097,935588110,14618564,14.7),(133571,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133571,34.4,0.38,75.9,62835,75,NULL,'CF, r, raw','NGC 6016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133572,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133572,34.5,0.38,79.6,62835,75,NULL,'CF, r, inv','NGC 6016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133573,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133573,34.67,0.38,85.8,62835,75,NULL,'CF, r, cor','NGC 6016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133574,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133574,34.68,0.2,86.3,62835,74.4,NULL,NULL,'NGC 6016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133575,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133575,36.71,0.46,220,62836,70,NULL,NULL,'2MASX J15555571+4842326',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000159,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,238.982,48.70903,0.061,NULL,59711467919,932991686,14577995,16.9),(133576,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133576,37.84,0.27,370,62837,70,NULL,NULL,'2MASX J15555748+3723163',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000124,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.989583,37.38797,0.045,NULL,59761864410,933779131,14590298,17.6),(133577,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133577,37.62,0.46,335,62838,70,NULL,NULL,'2MASX J15555808+2413307',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,238.9919583,24.22511,0.165,NULL,59406071166,928219861,14503435,17.5),(133578,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133578,37.91,0.46,381,62839,70,NULL,NULL,'2MASX J15555872+2143181',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,238.9947917,21.72178,0.117,NULL,59405713720,928214276,14503348,18),(133579,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133579,37.5,0.27,316,62840,70,NULL,NULL,'2MASX J15555886+0303436',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000095,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,238.995375,3.06211,0.265,NULL,56481659668,882525932,13789467,16.9),(133580,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133580,35.83,0.46,147,62841,70,NULL,NULL,'2MASX J15555924+0619444',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000105,NULL,'16.0g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,238.996875,6.32931,0.129,NULL,56629860808,884841575,13825649,16),(133581,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133581,37.89,0.46,378,62842,70,NULL,NULL,'2MASX J15555976+2655057',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000103,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,238.999125,26.91839,0.121,NULL,59877720950,935589389,14618584,17.2),(133582,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133582,37.83,0.46,367,62843,70,NULL,NULL,'2MASX J15560129+2346111',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000171,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,239.005375,23.76989,0.153,NULL,59406903020,928232859,14503638,17.3),(133583,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133583,37.61,0.46,333,62844,70,NULL,NULL,'2MASX J15560166+3339432',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.007041667,33.66192,0.069,NULL,59889981942,935780967,14621577,17.4),(133584,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133584,38.03,0.05,403,62845,70,NULL,NULL,'2MASX J15560202+2706377',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000174,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,239.0085,27.11053,0.117,NULL,59877651160,935588299,14618567,17.8),(133585,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133585,37.06,0.46,258,62846,70,NULL,NULL,'2MASX J15560209+3951473',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000157,NULL,'16.6g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,239.008708333,39.86306,0.033,NULL,59797912312,934342379,14599099,16.6),(133586,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133586,37.67,0.46,342,62847,70,NULL,NULL,'SDSS J155602.82+272559.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.0117917,27.43317,0.105,NULL,59877167557,935580743,14618449,18.4),(133587,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133587,37.84,0.27,370,62848,70,NULL,NULL,'2MASX J15560334+3720503',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000175,NULL,'17.2g',0.2,'BrClG',NULL,NULL,NULL,NULL,1,239.014041667,37.34728,0.025,NULL,59761988408,933781068,14590329,17.2),(133588,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133588,36.3,0.46,182,62849,70,NULL,NULL,'CGCG 137-003',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.000077,NULL,'15.0g',0.57,'E?','Pair member (points to parent)',NULL,'radio jet',NULL,1,239.0162083,24.44806,0.185,NULL,59392400975,928006265,14500097,15),(133589,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133589,37.1,0.46,262,62850,70,NULL,NULL,'2MASX J15560492+0641134',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000184,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,239.0204583,6.68706,0.121,NULL,56630246058,884847594,13825743,16.1),(133590,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133590,37.49,0.14,315,62851,70,NULL,NULL,'SDSS J155604.92+255816.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00018,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,239.020541667,25.97139,0.165,NULL,59875765992,935558843,14618106,18.4),(133591,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133591,37.7,0.46,346,62852,70,NULL,NULL,'2MASX J15560524+5202496',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000159,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,239.021875,52.04731,0.013,NULL,59717717919,933089342,14579520,17),(133592,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133592,36.3,0.46,182,62853,70,NULL,NULL,'2MASX J15560561-0021001',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000086,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,239.023375,-0.35,0.393,NULL,45530238279,711409973,11115780,16.8),(133593,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133593,36.52,0.46,202,62854,70,NULL,NULL,'2MASX J15560610+1023064',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,239.025417,10.38519,0.129,NULL,56635450423,884928912,13827014,16.9),(133594,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133594,38.18,0.46,432,62855,70,NULL,NULL,'2MASX J15560617+4832366',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,239.0255417,48.54347,0.041,NULL,59711449128,932991392,14577990,17.7),(133595,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133595,37.16,0.33,271,62856,70,NULL,NULL,'2MASX J15560624+4045504',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000135,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.026167,40.76408,0.073,NULL,59798104639,934345384,14599146,17.4),(133596,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133596,38.03,0.05,403,62857,70,NULL,NULL,'2MASX J15560723+2735336',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000147,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.030125,27.59269,0.105,NULL,59877218965,935581546,14618461,18.1),(133597,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133597,34.44,0.49,77.3,62858,70,NULL,NULL,'2MASX J15560742-0832442',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000127,NULL,'16.05',NULL,NULL,NULL,NULL,NULL,NULL,1,239.030917,-8.54572,0.593,NULL,45630499625,712976556,11140258,16.05),(133598,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133598,37.67,0.46,342,62859,70,NULL,NULL,'2MASX J15560742+3348312',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.030917,33.80861,0.069,NULL,59889997641,935781213,14621581,17.6),(133599,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133599,36.83,0.46,232,62860,70,NULL,NULL,'2MASX J15560750+5115106',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000174,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,239.031583,51.25286,0.009,NULL,59716863720,933075995,14579312,16.5),(133600,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133600,35,0.21,100,62861,70,NULL,NULL,'CGCG 250-023',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000107,NULL,'14.6g',0.59,'E0','Group member',NULL,NULL,NULL,1,239.032125,48.09325,0.069,NULL,59713500721,933023448,14578491,14.6),(133601,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133601,36.89,0.15,238,62862,70,NULL,NULL,'2MASX J15560782+1958200',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,239.0327083,19.97211,0.077,NULL,59403657599,928182149,14502846,16.7),(133602,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133602,38.57,0.46,518,62863,70,NULL,NULL,'SDSS J155608.24+034658.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.034375,3.78278,0.261,NULL,56612684808,884573200,13821456,18.4),(133603,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133603,37.58,0.21,328,62864,70,NULL,NULL,'2MASX J15560876+2643308',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000145,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.036541667,26.72525,0.121,NULL,59877450187,935585159,14618518,18),(133604,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133604,38.53,0.46,508,62865,70,NULL,NULL,'2MASX J15560992+2700098',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.041208333,27.00258,0.121,NULL,59877854102,935591470,14618616,17.8),(133605,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133605,37.66,0.46,341,62866,70,NULL,NULL,'SDSS J155610.64+380859.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.044375,38.14975,0.025,NULL,59763682855,933807544,14590742,18.1),(133606,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133606,37.84,0.27,370,62867,70,NULL,NULL,'SDSS J155610.77+371907.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000138,NULL,'18.7g',0.09,NULL,NULL,NULL,NULL,NULL,1,239.044917,37.31864,0.025,NULL,59761989132,933781080,14590329,18.7),(133607,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133607,37.22,0.46,277,62868,70,NULL,NULL,'2MASX J15561078+3305212',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000181,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,239.045,33.08928,0.081,NULL,59886618372,935728412,14620756,16.7),(133608,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133608,37.34,0.46,294,62869,70,NULL,NULL,'2MASX J15561118+2426058',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,239.0465,24.43497,0.185,NULL,59392453087,928007079,14500110,17),(133609,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133609,36.6,0.46,209,62870,70,NULL,NULL,'2MASX J15561134+1250086',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,239.047167,12.83558,0.081,NULL,56527463749,883241621,13800650,16.6),(133610,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133610,36.8,0.33,229,62871,70,NULL,NULL,'2MASX J15561146+2433348',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.047875,24.55958,0.185,NULL,59392403426,928006303,14500098,17.8),(133611,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133611,37.58,0.21,328,62872,70,NULL,NULL,'2MASX J15561152+2646118',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000165,NULL,'16.3g',0.4,NULL,NULL,NULL,NULL,NULL,1,239.047917,26.77006,0.121,NULL,59877726666,935589479,14618585,16.3),(133612,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133612,38.24,0.46,445,62873,70,NULL,NULL,'SDSS J155611.56+451229.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000141,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.0482083,45.20811,0.037,NULL,59684097110,932564017,14571312,18),(133613,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133613,37.22,0.46,278,62874,70,NULL,NULL,'2MASX J15561215+5612122',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000076,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,239.050583333,56.20342,0.037,NULL,57639449277,900616394,14072131,17.2),(133614,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133614,36.91,0.46,241,62875,70,NULL,NULL,'2MASX J15561309+4743362',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000176,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,239.054583,47.72689,0.041,NULL,59713331840,933020810,14578450,16.9),(133615,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133615,34.51,0.49,79.6,62876,75,NULL,'IR','ESO 450- G 023',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.00006,NULL,'15.8b',0.2,'Sa-b',NULL,NULL,NULL,NULL,1,239.061125,-31.52031,0.661,NULL,47165932646,736967697,11515120,15.8),(133616,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133616,37.77,0.46,357,62877,70,NULL,NULL,'SDSS J155615.51+290421.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.064666667,29.07256,0.105,NULL,59866688244,935417003,14615890,18),(133617,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133617,37.66,0.46,341,62878,70,NULL,NULL,'SDSS J155616.82+080657.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.070125,8.11608,0.105,NULL,56636374995,884943359,13827239,18.1),(133618,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133618,37.43,0.33,307,62879,70,NULL,NULL,'2MASX J15561691+2406268',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,239.0704583,24.10761,0.149,NULL,59406240145,928222502,14503476,16.8),(133619,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133619,37.56,0.46,326,62880,70,NULL,NULL,'SDSS J155617.81+165330.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.07425,16.89189,0.049,NULL,56568095356,883876489,13810570,17.9),(133620,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133620,35.59,0.2,131,62881,74.4,NULL,NULL,'CGCG 079-010',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000315,NULL,'15.7',0.4,NULL,NULL,NULL,NULL,NULL,1,239.075333,9.76419,0.065,NULL,56634728250,884917628,13826837,15.7),(133621,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133621,38.03,0.05,403,62882,70,NULL,NULL,'2MASX J15561872+2742278',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.077875,27.70769,0.105,NULL,59877211530,935581430,14618459,17.7),(133622,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133622,37.33,0.46,293,62883,70,NULL,NULL,'2MASX J15561892+2458218',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.078875,24.97264,0.153,NULL,59874770854,935543294,14617863,18),(133623,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133623,38.33,0.46,462,62884,70,NULL,NULL,'SDSS J155618.93+225128.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.8g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.078917,22.85794,0.141,NULL,59407202419,928237537,14503711,18.8),(133624,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133624,37.49,0.14,315,62885,70,NULL,NULL,'2MASX J15561925+2553188',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000168,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.080083333,25.8885,0.165,NULL,59875773646,935558963,14618108,17.9),(133625,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133625,36.2,0.46,174,62886,70,NULL,NULL,'2MASX J15561929+0948551',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.00001,NULL,'15.7g',0.43,'AGN',NULL,NULL,NULL,NULL,1,239.080417,9.81544,0.065,NULL,56634735087,884917735,13826839,15.7),(133626,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133626,38.67,0.46,542,62887,70,NULL,NULL,'2MASX J15561944+1912461',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.081125,19.21297,0.045,NULL,59400191581,928127993,14501999,17.5),(133627,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133627,37.73,0.46,352,62888,70,NULL,NULL,'2MASX J15561985+1343506',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,239.082875,13.73075,0.077,NULL,56528242158,883253783,13800840,17.1),(133628,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133628,38.64,0.33,534,62889,70,NULL,NULL,'SDSS J155621.47+485658.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00014,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.0895,48.94967,0.073,NULL,59711572621,932993322,14578020,18),(133629,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133629,38.3,0.46,457,62890,70,NULL,NULL,'2MASX J15562151+3259071',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000136,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.089833,32.98525,0.081,NULL,59887272891,935738638,14620916,18.2),(133630,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133630,38.13,0.46,422,62891,70,NULL,NULL,'SDSS J155623.55+280842.7',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000153,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,239.098125,28.14522,0.101,NULL,59874267061,935535422,14617740,18.6),(133631,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2007ap',NULL,133631,33.64,0.21,52.6,62892,74.2,NULL,'SALT 2','CGCG 108-012',0.015818,'2010ApJ...716..712A',2010,1,1.2,NULL,'G',0.00007,NULL,'14.28',1,'SA0+','Supercluster foreground object',NULL,NULL,NULL,1,239.0982917,16.52331,0.053,NULL,56566180058,883846563,13810102,14.28),(133632,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2007ap',NULL,133632,34.24,0.04,69.4,62892,72,NULL,'MLCS17','CGCG 108-012',0.015818,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133633,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2007ap',NULL,133633,34.22,0.09,69.8,62892,74.4,NULL,NULL,'CGCG 108-012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133634,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2007ap',NULL,133634,34.45,0.2,76.4,62892,70,NULL,'SALT 2','CGCG 108-012',0.015818,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133635,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2007ap',NULL,133635,34.5,0.23,78,62892,65,NULL,'MLCS17','CGCG 108-012',0.015818,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133636,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2007ap',NULL,133636,34.57,0.22,80.9,62892,65,NULL,'MLCS31','CGCG 108-012',0.015818,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133637,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2007ap',NULL,133637,34.68,0.25,85.1,62892,65,NULL,'SALT2','CGCG 108-012',0.015818,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133638,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133638,33.94,0.25,61.3,62892,70,NULL,NULL,'CGCG 108-012',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133639,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133639,34.22,0.09,69.8,62892,74.4,NULL,NULL,'CGCG 108-012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133640,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133640,36.43,0.33,193,62893,70,NULL,NULL,'2MASX J15562435+0855541',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000181,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,239.101375,8.93169,0.077,NULL,56636197060,884940579,13827196,16.5),(133641,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133641,37.49,0.14,315,62894,70,NULL,NULL,'2MASX J15562458+2552328',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000213,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,239.1024583,25.87572,0.165,NULL,59875773121,935558955,14618108,16.3),(133642,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133642,36.62,0.46,211,62895,70,NULL,NULL,'2MASX J15562480+1227102',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,239.1034583,12.45294,0.121,NULL,56527515572,883242430,13800662,16.5),(133643,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133643,36.65,0.46,214,62896,70,NULL,NULL,'2MASX J15562495+4619282',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000183,NULL,'16.0g',0.4,'E0',NULL,NULL,NULL,NULL,1,239.10375,46.32439,0.033,NULL,59682541853,932539716,14570933,16),(133644,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133644,36.43,0.33,193,62897,70,NULL,NULL,'2MASX J15562489+0856361',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000175,NULL,'15.9g',0.44,'E0',NULL,NULL,NULL,NULL,1,239.1037917,8.9435,0.077,NULL,56636196963,884940577,13827196,15.9),(133645,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133645,37.42,0.46,305,62898,70,NULL,NULL,'2MASX J15562525+2617588',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000194,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,239.105333333,26.29967,0.129,NULL,59875539380,935555302,14618051,16.3),(133646,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133646,36.3,0.46,182,62899,70,NULL,NULL,'2MASX J15562649+4611092',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,239.110583333,46.186,0.033,NULL,59682551756,932539871,14570935,16.9),(133647,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133647,37.62,0.46,335,62900,70,NULL,NULL,'2MASXi J1556265+193805',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.110625,19.63506,0.053,NULL,59400238574,928128727,14502011,17.5),(133648,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133648,36.18,0.46,172,62901,70,NULL,NULL,'CGCG 223-015',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000093,NULL,'15.1g',0.57,'E','Field galaxy',NULL,NULL,NULL,1,239.1135417,42.10117,0.041,NULL,59796259496,934316554,14598696,15.1),(133649,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133649,35,0.21,100,62902,70,NULL,NULL,'2MASX J15562738+4757302',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000163,NULL,'15.7g',0.34,'E',NULL,NULL,NULL,NULL,1,239.11425,47.95842,0.085,NULL,59713367764,933021371,14578458,15.7),(133650,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133650,35.73,0.46,140,62903,70,NULL,NULL,'2MASX J15562753+0003333',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00008,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,239.11475,0.05925,0.409,NULL,56478402985,882475046,13788672,17.1),(133651,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133651,38.54,0.46,511,62904,70,NULL,NULL,'2MASX J15562822+1709542',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000184,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,239.117625,17.16522,0.053,NULL,56564745336,883824145,13809752,17.5),(133652,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133652,36.88,0.46,237,62905,70,NULL,NULL,'2MASX J15562841+2905088',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000137,NULL,'16.9g',0.29,'E',NULL,NULL,NULL,NULL,1,239.1185417,29.08586,0.105,NULL,59866689142,935417017,14615890,16.9),(133653,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133653,33.9,0.49,60.3,62906,75,NULL,'IR','ESO 389- G 004',NULL,'2011yCatp016004901K',2011,1,1.6,NULL,'G',0.000033,NULL,'13.86',0.2,'Sb-c',NULL,NULL,NULL,NULL,1,239.118916667,-36.89964,1.041,NULL,46257528004,722773875,11293341,13.86),(133654,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133654,34.26,0.2,71.1,62906,74.4,NULL,NULL,'ESO 389- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133655,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133655,34.42,0.5,76.5,62906,NULL,NULL,'Malmquist cor.','ESO 389- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133656,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133656,34.44,0.49,77.4,62906,NULL,NULL,NULL,'ESO 389- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133657,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133657,37.55,0.46,324,62907,70,NULL,NULL,'2MASX J15562894+0254572',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,239.1205,2.91589,0.289,NULL,56485882522,882591914,13790498,17.9),(133658,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133658,37.47,0.11,313,62908,70,NULL,NULL,'2MASX J15562908+2838508',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.121167,28.64747,0.129,NULL,59866853198,935419581,14615930,18.3),(133659,'GRB','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133659,48.6,0.93,8900,62909,69.7,NULL,'Calibrated','GRB 060510B',4.9,'2009MNRAS.400..775C',2009,1,NULL,NULL,'VisS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,239.122958333,78.57017,0.145,NULL,57169991281,893281113,13957517,NULL),(133660,'GRB','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133660,48.66,0.94,9140,62909,69.7,NULL,'Fiducial','GRB 060510B',4.9,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133661,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133661,36.89,0.15,238,62910,70,NULL,NULL,'2MASX J15562931+2000242',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,239.122125,20.00675,0.085,NULL,59403665267,928182269,14502847,NULL),(133662,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133662,38.03,0.05,403,62911,70,NULL,NULL,'2MASX J15562941+2734368',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000157,NULL,'16.9g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,239.122625,27.57683,0.105,NULL,59877215442,935581491,14618460,16.9),(133663,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133663,38.05,0.33,408,62912,70,NULL,NULL,'2MASX J15562992+5527563',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000073,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.1247917,55.46558,NULL,NULL,57641889675,900654526,14072726,17.8),(133664,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133664,36.46,0.46,196,62913,70,NULL,NULL,'2MASX J15563147+2351582',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000175,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.131167,23.86622,0.153,NULL,59406217802,928222153,14503471,17.1),(133665,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133665,38.24,0.46,445,62914,70,NULL,NULL,'SDSS J155631.63+280246.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.131833,28.04628,0.101,NULL,59874259417,935535303,14617739,18),(133666,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2006bt',NULL,133666,35.07,0.16,100,62915,74.2,NULL,'SALT 2','CGCG 108-013',0.032156,'2010ApJ...716..712A',2010,1,0.9,NULL,'G',0.000233,NULL,'14.73',0.7,'SA0/a','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,239.140333,20.05236,0.085,NULL,59403655923,928182123,14502845,14.73),(133667,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2006bt',NULL,133667,35.64,0.09,134,62915,74.4,NULL,NULL,'CGCG 108-013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133668,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2006bt',NULL,133668,35.74,0.15,136,62915,73.8,NULL,'SALT 2 (SNANA)','CGCG 108-013',0.0315,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133669,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2006bt',NULL,133669,35.78,0.16,139,62915,65,NULL,'MLCS31','CGCG 108-013',0.032156,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133670,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2006bt',NULL,133670,35.83,NULL,142,62915,65,NULL,'intrinsic extinction A(V) = 0.428 mag','CGCG 108-013',0.032156,'2010ApJ...708.1748F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133671,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2006bt',NULL,133671,35.94,0.18,150,62915,65,NULL,'SALT2','CGCG 108-013',0.032156,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133672,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2006bt',NULL,133672,35.98,0.16,152,62915,65,NULL,'SALT','CGCG 108-013',0.032156,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133673,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2006bt',NULL,133673,35.99,0.14,153,62915,65,NULL,'MLCS17','CGCG 108-013',0.032156,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133674,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2006bt',NULL,133674,36.52,NULL,195,62915,65,NULL,'intrinsic extinction A(V) = 0.0 mag','CGCG 108-013',0.032156,'2010ApJ...708.1748F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133675,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2006bt',NULL,133675,36.58,0.02,200,62915,70,NULL,'SALT 2','CGCG 108-013',0.032156,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133676,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133676,34.91,0.46,96,62915,70,NULL,NULL,'CGCG 108-013',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133677,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133677,33.29,0.46,45.6,62916,70,NULL,NULL,'CGCG 137-004',NULL,'2015arXiv151105856S',2015,1,1.01,NULL,'G',0.00016,NULL,'14.0g',0.8,NULL,NULL,NULL,NULL,NULL,1,239.140416667,21.28908,0.109,NULL,59401079594,928141868,14502216,14),(133678,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133678,37.47,0.11,313,62917,70,NULL,NULL,'2MASX J15563410+2840018',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,239.142,28.66706,0.129,NULL,59866850726,935419542,14615930,17.8),(133679,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133679,36.83,0.46,232,62918,70,NULL,NULL,'2MASX J15563486+0832331',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,239.145167,8.54247,0.085,NULL,56636530071,884945782,13827277,17.1),(133680,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133680,38.13,0.46,422,62919,70,NULL,NULL,'2MASX J15563491+1113011',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,239.145417,11.21706,0.153,NULL,56632435489,884881804,13826278,16.7),(133681,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133681,37.68,0.46,344,62920,70,NULL,NULL,'2MASX J15563607+0004533',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000093,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.15025,0.08144,0.409,NULL,56478414797,882475231,13788675,17.7),(133682,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133682,36.77,0.46,225,62921,70,NULL,NULL,'2MASX J15563646+3254447',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.152,32.91253,0.085,NULL,59887274089,935738657,14620916,17.8),(133683,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133683,37.58,0.21,328,62922,70,NULL,NULL,'2MASX J15563664+2701598',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000075,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,239.152625,27.03331,0.117,NULL,59877861999,935591593,14618618,17),(133684,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133684,36.87,0.77,237,62923,70,NULL,NULL,'2MASX J15563674-1405325',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,239.153083,-14.09239,0.661,NULL,45477155589,710580556,11102821,15.6),(133685,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133685,32.54,NULL,32.2,62924,72,NULL,NULL,'SDSS J155636.84+061138.6',NULL,'2014Ap.....57..457K',2014,1,0.66,NULL,'G',0.000014,NULL,'16.9g',0.4,NULL,NULL,NULL,NULL,NULL,1,239.1535,6.19406,0.173,NULL,56629702516,884839101,13825610,16.9),(133686,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133686,36.89,0.15,238,62925,70,NULL,NULL,'2MASX J15563710+1938092',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.154583,19.63592,0.053,NULL,59400238120,928128720,14502011,17.1),(133687,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133687,37.58,0.21,328,62926,70,NULL,NULL,'2MASX J15563710+2708178',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000092,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,239.154667,27.13817,0.117,NULL,59877867549,935591680,14618620,17.5),(133688,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133688,32.35,NULL,29.5,62927,72,NULL,NULL,'AGC 258349',NULL,'2014Ap.....57..457K',2014,1,NULL,NULL,'RadioS',0.000122,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,239.155,5.97306,0.137,NULL,56612156451,884564944,13821327,NULL),(133689,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133689,36.81,0.46,230,62928,70,NULL,NULL,'2MASX J15563806+1842012',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000166,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,239.1585,18.70036,0.053,NULL,56510742137,882980345,13796567,16.6),(133690,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133690,37.87,0.21,375,62929,70,NULL,NULL,'2MASX J15563812+2820086',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.15875,28.33586,0.109,NULL,59866649170,935416393,14615881,18.2),(133691,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133691,36.96,0.46,246,62930,70,NULL,NULL,'2MASX J15563921+0918023',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,239.163375,9.30069,0.081,NULL,56634355469,884911804,13826746,17.1),(133692,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133692,36.89,0.15,238,62931,70,NULL,NULL,'SDSS J155639.27+201024.0',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.163667,20.17336,0.085,NULL,59403510356,928179849,14502810,18.2),(133693,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133693,38.04,0.33,406,62932,70,NULL,NULL,'2MASX J15563949+4532271',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000188,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,239.1645417,45.54081,0.033,NULL,59684814491,932575226,14571487,16.8),(133694,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133694,38.03,0.05,403,62933,70,NULL,NULL,'2MASX J15563986+2733108',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,239.1660417,27.55311,0.105,NULL,59877214484,935581476,14618460,18.3),(133695,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133695,37.22,0.46,278,62934,70,NULL,NULL,'2MASXi J1556399+402939',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00014,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.166375,40.49428,0.025,NULL,59798017317,934344020,14599125,17.7),(133696,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133696,37.49,0.14,315,62935,70,NULL,NULL,'2MASX J15564049+2538176',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000192,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,239.1687917,25.63836,0.177,NULL,59875698033,935557781,14618090,16.8),(133697,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133697,38.43,0.46,485,62936,70,NULL,NULL,'SDSS J155640.79+050445.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.17,5.07942,0.169,NULL,56614702993,884604734,13821948,18.5),(133698,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133698,37.92,0.46,383,62937,70,NULL,NULL,'SDSS J155640.88+255235.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000185,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,239.170375,25.87642,0.165,NULL,59875750074,935558594,14618103,18.4),(133699,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133699,37.11,0.46,264,62938,70,NULL,NULL,'2MASX J15564116+3121427',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,239.171583,31.36194,0.045,NULL,59920737885,936261529,14629086,17.1),(133700,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133700,36.89,0.15,238,62939,70,NULL,NULL,'2MASX J15564131+2010172',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000073,NULL,'15.9g',0.36,NULL,NULL,NULL,NULL,NULL,1,239.17225,20.17158,0.085,NULL,59403510443,928179850,14502810,15.9),(133701,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133701,38.05,0.33,408,62940,70,NULL,NULL,'SDSS J155641.72+552729.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000067,NULL,'18.2g',0.16,'NLAGN',NULL,NULL,NULL,NULL,1,239.173875,55.45808,NULL,NULL,57641888645,900654510,14072726,18.2),(133702,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133702,36.86,0.27,236,62941,70,NULL,NULL,'2MASX J15564213+0859503',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000174,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,239.175625,8.99728,0.077,NULL,56636172084,884940188,13827190,16.6),(133703,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133703,38.64,0.33,534,62942,70,NULL,NULL,'SDSS J155642.27+485259.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000125,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.176167,48.88308,0.073,NULL,59711576127,932993376,14578021,18.4),(133704,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133704,37.49,0.14,315,62943,70,NULL,NULL,'2MASX J15564238+2550106',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,239.176667,25.83628,0.165,NULL,59875748814,935558575,14618102,16.9),(133705,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133705,37.58,0.33,328,62944,70,NULL,NULL,'2MASX J15564261+2703216',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000071,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.1774583,27.05597,0.117,NULL,59877862298,935591598,14618618,18),(133706,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133706,38.03,0.05,403,62945,70,NULL,NULL,'2MASX J15564294+2741086',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.178916667,27.68592,0.105,NULL,59877205702,935581339,14618458,18),(133707,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133707,38.03,0.05,403,62946,70,NULL,NULL,'2MASX J15564296+2733246',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,239.1789583,27.55681,0.105,NULL,59877214467,935581476,14618460,17),(133708,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133708,36.86,0.27,236,62947,70,NULL,NULL,'2MASX J15564321+0857553',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000172,NULL,'15.9g',0.41,NULL,NULL,NULL,NULL,NULL,1,239.18,8.96547,0.077,NULL,56636170880,884940170,13827190,15.9),(133709,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133709,35,0.21,100,62948,70,NULL,NULL,'IC 1152',NULL,'2015arXiv151105856S',2015,1,1.07,NULL,'G',0.000073,NULL,'13.9g',0.98,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,239.1805,48.095,0.069,NULL,59713518555,933023727,14578495,13.9),(133710,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133710,37.49,0.14,315,62949,70,NULL,NULL,'2MASX J15564396+2540266',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.18325,25.67397,0.177,NULL,59875700410,935557818,14618090,17.7),(133711,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133711,37.58,0.21,328,62950,70,NULL,NULL,'2MASX J15564412+2657566',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000077,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,239.1837083,26.96564,0.121,NULL,59877858492,935591538,14618617,17),(133712,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133712,37.49,0.14,315,62951,70,NULL,NULL,'2MASX J15564430+2551456',NULL,'2015arXiv151105856S',2015,1,0.1,NULL,'G',0.000183,NULL,'18.0g',0.09,NULL,NULL,NULL,NULL,NULL,1,239.184625,25.86261,0.165,NULL,59875750839,935558606,14618103,18),(133713,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133713,37.95,0.46,389,62952,70,NULL,NULL,'SDSS J155644.45+554538.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000077,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.1852083,55.76064,0.013,NULL,57641408225,900647003,14072609,18.3),(133714,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133714,38.04,0.33,406,62953,70,NULL,NULL,'2MASX J15564453+4533183',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.185417,45.55517,0.033,NULL,59684814187,932575221,14571487,17.6),(133715,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133715,37.49,0.14,315,62954,70,NULL,NULL,'2MASX J15564482+2553076',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000181,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,239.186667,25.88558,0.165,NULL,59875750495,935558601,14618103,16.9),(133716,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133716,36.86,0.46,236,62955,70,NULL,NULL,'2MASX J15564510+3709530',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.188083,37.16483,0.029,NULL,59761979620,933780931,14590327,17.6),(133717,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133717,36.89,0.15,238,62956,70,NULL,NULL,'2MASX J15564528+2009001',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,239.1885417,20.15014,0.085,NULL,59403510250,928179847,14502810,16.3),(133718,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133718,37.47,0.11,313,62957,70,NULL,NULL,'SDSS J155646.21+284011.9',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.1925417,28.66997,0.097,NULL,59866642447,935416288,14615879,17.9),(133719,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133719,38.03,0.05,403,62958,70,NULL,NULL,'2MASX J15564695+2731136',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,239.1957083,27.52056,0.105,NULL,59877184842,935581013,14618453,17.6),(133720,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133720,36.05,0.33,162,62959,70,NULL,NULL,'2MASX J15564753+2533486',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,239.198166667,25.56367,0.149,NULL,59875704113,935557876,14618091,16.9),(133721,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133721,36.3,0.46,182,62960,70,NULL,NULL,'2MASX J15564766+4217514',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000196,NULL,'15.9g',0.37,'S0^-','Field galaxy',NULL,NULL,NULL,1,239.19875,42.29769,0.053,NULL,59796349602,934317962,14598718,15.9),(133722,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133722,37.53,0.46,321,62961,70,NULL,NULL,'2MASX J15564768+2946286',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00019,NULL,'16.3g',0.43,'Sa',NULL,NULL,NULL,NULL,1,239.198917,29.77447,0.093,NULL,59869179161,935455924,14616498,16.3),(133723,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133723,37.49,0.14,315,62962,70,NULL,NULL,'2MASX J15564816+2550446',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000181,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.200667,25.84575,0.165,NULL,59875748583,935558571,14618102,17.9),(133724,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133724,36.89,0.15,238,62963,70,NULL,NULL,'2MASX J15564838+2014432',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,239.201583,20.24547,0.073,NULL,59403532347,928180192,14502815,17.2),(133725,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133725,38.21,0.46,439,62964,70,NULL,NULL,'2MASX J15564911+4442274',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00019,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.20475,44.70767,0.041,NULL,59683517148,932554955,14571171,17.5),(133726,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133726,38.12,0.46,420,62965,70,NULL,NULL,'2MASX J15564947+3438017',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000194,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,239.2059583,34.63378,0.057,NULL,59767177317,933862145,14591596,17.3),(133727,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133727,35.78,0.19,143,62966,70,NULL,NULL,'2MASX J15565009+4144161',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000176,NULL,'15.7g',0.44,'E','Field galaxy',NULL,NULL,NULL,1,239.208875,41.73781,0.045,NULL,59797118350,934329974,14598905,15.7),(133728,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133728,37.57,0.27,327,62967,70,NULL,NULL,'SDSS J155650.64+345337.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000153,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,239.211,34.89369,0.057,NULL,59767679499,933869992,14591718,18.5),(133729,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133729,33.11,0.69,41.9,62968,100,NULL,'mid-IR','ESO 330-G 006',NULL,'2013ApJ...771...88L',2013,1,1,NULL,'G',0.000017,NULL,'10.6K',0.6,'Sb-c',NULL,NULL,NULL,NULL,1,239.213167,-38.76875,0.977,NULL,46256510391,722757974,11293093,10.6),(133730,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133730,38.46,0.46,492,62969,70,NULL,NULL,'2MASX J15565124+3133417',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000176,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.213375,31.56169,0.069,NULL,59919994527,936249914,14628904,18.1),(133731,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133731,36.05,0.33,162,62970,70,NULL,NULL,'2MASX J15565277+2534067',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000083,NULL,'15.5g',0.49,NULL,NULL,NULL,NULL,NULL,1,239.2197917,25.56858,0.149,NULL,59875693859,935557716,14618089,15.5),(133732,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133732,37.78,0.46,359,62971,70,NULL,NULL,'2MASX J15565318+0025408',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00007,NULL,'17.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,239.221583,0.42806,0.413,NULL,56487029218,882609831,13790778,17.6),(133733,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133733,38.03,0.05,403,62972,70,NULL,NULL,'SDSS J155653.78+272609.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000089,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,239.224083,27.43608,0.105,NULL,59877192984,935581140,14618455,18.3),(133734,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133734,35.87,0.46,150,62973,70,NULL,NULL,'CGCG 079-013',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000163,NULL,'15.3',0.6,NULL,NULL,NULL,NULL,NULL,1,239.22475,14.1275,0.089,NULL,56528322430,883255037,13800859,15.3),(133735,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133735,37.57,0.27,327,62974,70,NULL,NULL,'2MASX J15565491+3447167',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000211,NULL,'15.6g',0.52,'BrClG',NULL,NULL,NULL,NULL,1,239.228667,34.78797,0.045,NULL,59767175625,933862119,14591595,15.6),(133736,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133736,36.47,0.55,197,62975,70,NULL,NULL,'2MASX J15565520-1413422',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,239.230083,-14.22839,0.745,NULL,45477192182,710581127,11102830,15.3),(133737,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133737,38.03,0.05,403,62976,70,NULL,NULL,'2MASX J15565537+2733447',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000183,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,239.23075,27.56256,0.105,NULL,59877184173,935581002,14618453,17.1),(133738,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133738,37.47,0.11,313,62977,70,NULL,NULL,'2MASX J15565612+2842197',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000161,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,239.233917,28.7055,0.097,NULL,59866629883,935416091,14615876,17.6),(133739,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133739,37.58,0.33,328,62978,70,NULL,NULL,'2MASX J15565698+2702587',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000067,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,239.237416667,27.04967,0.117,NULL,59877882732,935591917,14618623,16.8),(133740,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133740,36.36,0.46,187,62979,70,NULL,NULL,'2MASX J15565864+3154347',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000173,NULL,'15.6g',0.51,'E',NULL,NULL,NULL,NULL,1,239.244417,31.90969,0.061,NULL,59919957222,936249331,14628895,15.6),(133741,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133741,37.66,0.46,341,62980,70,NULL,NULL,'2MASX J15565865+3947431',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000132,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,239.244417,39.79528,0.017,NULL,59795732996,934308328,14598567,17.3),(133742,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133742,38.33,0.46,463,62981,70,NULL,NULL,'2MASX J15565977+0532458',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000174,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.249083,5.54606,0.157,NULL,56614452559,884600821,13821887,18),(133743,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133743,39.11,0.46,664,62982,70,NULL,NULL,'SDSS J155700.35+335614.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000179,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.2515,33.93725,0.073,NULL,59889942628,935780353,14621568,18.4),(133744,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133744,36.98,0.46,249,62983,70,NULL,NULL,'2MASX J15570199+4921593',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000183,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,239.258125,49.3665,0.049,NULL,59725657517,933213398,14581459,16.9),(133745,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133745,35.15,0.69,107,62984,70,NULL,NULL,'MCG -01-41-002',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00011,NULL,'17',0.4,NULL,NULL,NULL,NULL,NULL,1,239.25825,-6.15517,0.525,NULL,45627271774,712926121,11139470,17),(133746,'SBF','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133746,31.28,0.21,18,62985,NULL,NULL,'I','IC 1153',NULL,'2001ApJ...546..681T',2001,1,1.14,'RC3 gives v = 744 km/sec.','G',0.000067,NULL,'13.6g',0.98,'S0','Group member',NULL,NULL,NULL,1,239.2625417,48.16839,0.069,NULL,59713512642,933023635,14578494,13.6),(133747,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133747,35,0.21,100,62985,70,NULL,NULL,'IC 1153',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133748,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133748,36.86,0.27,236,62986,70,NULL,NULL,'2MASX J15570400+0854033',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000196,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,239.266583,8.901,0.109,NULL,56636123707,884939432,13827178,16.4),(133749,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133749,38.03,0.05,403,62987,70,NULL,NULL,'SDSS J155704.02+272516.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000076,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.2667917,27.42119,0.105,NULL,59877183322,935580989,14618452,18.4),(133750,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133750,36.44,0.18,194,62988,70,NULL,NULL,'GIN 535',NULL,'2001MNRAS.321..277C',2001,1,0.56,NULL,'G',0.0001,NULL,'15.7g',0.52,'S',NULL,NULL,NULL,NULL,1,239.2682917,17.62556,0.089,NULL,56565229203,883831706,13809870,15.7),(133751,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133751,37.47,0.11,313,62989,70,NULL,NULL,'SDSS J155704.49+284223.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000167,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.26875,28.70658,0.097,NULL,59866632179,935416127,14615876,18.2),(133752,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133752,37.13,0.33,267,62990,70,NULL,NULL,'2MASX J15570529+0941513',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,239.272166667,9.69753,0.065,NULL,56634303180,884910987,13826734,16.6),(133753,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133753,37.11,0.46,265,62991,70,NULL,NULL,'SDSS J155706.55+025440.8',NULL,'2015arXiv151105856S',2015,1,0.11,NULL,'G',0.000077,NULL,'19.1g',0.08,NULL,NULL,NULL,NULL,NULL,1,239.277333333,2.91133,0.289,NULL,56486337469,882599022,13790609,19.1),(133754,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133754,37.47,0.11,313,62992,70,NULL,NULL,'2MASX J15570699+2837347',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,239.2790417,28.62631,0.097,NULL,59866644068,935416313,14615879,17.4),(133755,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133755,37.87,0.21,375,62993,70,NULL,NULL,'2MASX J15570713+2818197',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.279625,28.30558,0.109,NULL,59874220292,935534692,14617729,18.3),(133756,'D-Sigma','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133756,33.91,0.4,60.6,62994,75,NULL,'Edat, raw','NGC 6020',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000053,NULL,'13.75',1,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,239.283916667,22.40458,0.113,NULL,59407269847,928238591,14503727,13.75),(133757,'D-Sigma','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133757,34.25,0.4,70.7,62994,75,NULL,'Edat, cor','NGC 6020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133758,'Faber-Jackson','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133758,32.65,0.7,33.9,62994,95,NULL,'Weighted Mean','NGC 6020',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133759,'Faber-Jackson','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133759,32.65,0.7,33.9,62994,95,NULL,'de Vaucouleurs','NGC 6020',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133760,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133760,34.02,0.46,63.7,62994,70,NULL,NULL,'NGC 6020',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133761,'Tertiary','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133761,33.37,0.5,47.2,62994,95,NULL,NULL,'NGC 6020',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133762,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133762,33.98,0.4,62.4,62994,NULL,NULL,'mean','NGC 6020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133763,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133763,34.36,0.45,74.3,62994,NULL,NULL,'K','NGC 6020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133764,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133764,36.92,0.46,243,62995,70,NULL,NULL,'2MASX J15570832-0017252',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000071,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.28475,-0.29033,0.409,NULL,45526042650,711344416,11114756,17.6),(133765,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133765,37.87,0.21,375,62996,70,NULL,NULL,'2MASX J15570849+2822217',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.285458333,28.37278,0.109,NULL,59866622722,935415980,14615874,17.9),(133766,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133766,38.03,0.05,403,62997,70,NULL,NULL,'2MASX J15570890+2723147',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000062,NULL,'17.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,239.286958333,27.38753,0.105,NULL,59877180073,935580938,14618452,17.7),(133767,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133767,37.53,0.46,320,62998,70,NULL,NULL,'2MASX J15570956+2931597',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.289875,29.53322,0.089,NULL,59869061419,935454084,14616470,17.7),(133768,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133768,37.67,0.23,341,62999,70,NULL,NULL,'SDSS J155710.08+120259.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.292,12.04997,0.105,NULL,56598178304,884346536,13817914,18.2),(133769,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133769,37.71,0.33,349,63000,70,NULL,NULL,'2MASX J15571042+2145583',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,239.2935,21.76617,0.113,NULL,59405675851,928213685,14503338,17.3),(133770,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133770,38.41,0.46,481,63001,70,NULL,NULL,'SDSS J155710.52+093607.8',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000144,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,239.293833333,9.60219,0.065,NULL,56634297081,884910891,13826732,18.7),(133771,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133771,37.87,0.21,375,63002,70,NULL,NULL,'2MASX J15571133+2818146',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000194,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,239.297125,28.30403,0.109,NULL,59874220504,935534695,14617729,17.1),(133772,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133772,37.3,0.46,289,63003,70,NULL,NULL,'2MASX J15571274+3151071',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000186,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,239.303,31.85194,0.061,NULL,59919945060,936249141,14628892,16.7),(133773,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133773,38.03,0.05,403,63004,70,NULL,NULL,'SDSS J155713.24+272858.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00017,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.3052083,27.48281,0.105,NULL,59877296277,935582754,14618480,18.6),(133774,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133774,37.45,0.46,308,63005,70,NULL,NULL,'2MASX J15571328+2134503',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000193,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,239.3055,21.5805,0.117,NULL,59405753925,928214905,14503357,16.3),(133775,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133775,37.87,0.21,375,63006,70,NULL,NULL,'2MASX J15571383+2817127',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000178,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,239.307583,28.28686,0.109,NULL,59874221034,935534703,14617729,16.8),(133776,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133776,38.07,0.46,410,63007,70,NULL,NULL,'SDSS J155714.42+030138.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000074,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.310083,3.02733,0.277,NULL,56481941095,882530329,13789536,18.7),(133777,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133777,37.1,0.46,262,63008,70,NULL,NULL,'2MASX J15571487+0317151',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000096,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,239.312125,3.28767,0.281,NULL,56482528010,882539500,13789679,17.3),(133778,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133778,37.43,0.33,307,63009,70,NULL,NULL,'2MASX J15571539+2415007',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000184,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,239.314,24.25017,0.165,NULL,59392632972,928009890,14500154,16.6),(133779,'SBF','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133779,32.37,0.31,29.8,63010,NULL,NULL,'I','NGC 6017',NULL,'2001ApJ...546..681T',2001,1,0.8,NULL,'G',0.000017,NULL,'14.10',0.7,'S?','in a pair',NULL,NULL,NULL,1,239.314333,5.99839,0.173,NULL,56612107695,884564182,13821315,14.1),(133780,'SBF','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133780,32.41,0.14,30.3,63010,74.4,NULL,NULL,'NGC 6017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133781,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133781,38.03,0.05,403,63011,70,NULL,NULL,'2MASX J15571633+2740407',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.318166667,27.67803,0.105,NULL,59877350379,935583599,14618493,17.9),(133782,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133782,37.74,0.46,352,63012,70,NULL,NULL,'2MASX J15571717+5235014',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000064,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.32175,52.58375,0.005,NULL,59698031209,932781737,14574714,18),(133783,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133783,38.1,0.46,417,63013,70,NULL,NULL,'2MASX J15571787+2012103',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00019,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,239.324417,20.20297,0.073,NULL,59403516738,928179949,14502811,17.3),(133784,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133784,37.22,0.46,278,63014,70,NULL,NULL,'2MASX J15571832+3510241',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000143,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.326417,35.17342,0.041,NULL,59767731166,933870799,14591731,18.2),(133785,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133785,37.43,0.33,306,63015,70,NULL,NULL,'2MASX J15571865+3400551',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00017,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.327625,34.01522,0.073,NULL,59766999013,933859359,14591552,17.9),(133786,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133786,37.67,0.23,341,63016,70,NULL,NULL,'2MASX J15571868+1215270',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'15.8g',0.48,NULL,NULL,NULL,NULL,NULL,1,239.32775,12.25742,0.121,NULL,56526852091,883232063,13800500,15.8),(133787,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133787,38.03,0.05,403,63017,70,NULL,NULL,'2MASX J15571918+2742027',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000173,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.330125,27.70092,0.105,NULL,59877349533,935583586,14618493,17.5),(133788,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133788,36.57,0.46,206,63018,70,NULL,NULL,'2MASX J15572003+0626401',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000178,NULL,'15.7g',0.45,'E0',NULL,NULL,NULL,NULL,1,239.333583,6.44461,0.145,NULL,56630739159,884855299,13825864,15.7),(133789,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133789,35,0.21,100,63019,70,NULL,NULL,'2MASX J15572018+4812264',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00018,NULL,'15.7g',0.37,'E0',NULL,NULL,NULL,NULL,1,239.334125,48.20725,0.069,NULL,59713482536,933023164,14578486,15.7),(133790,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133790,37.64,0.46,338,63020,70,NULL,NULL,'SDSS J155720.52+241443.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000145,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,239.335541667,24.24544,0.165,NULL,59392634884,928009920,14500155,18.5),(133791,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133791,37.57,0.27,327,63021,70,NULL,NULL,'2MASX J15572087+3451041',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,239.336833,34.85122,0.045,NULL,59767672487,933869882,14591716,17.9),(133792,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133792,33.75,0.69,56.2,63022,100,NULL,'mid-IR','UGC 10109',NULL,'2013ApJ...771...88L',2013,1,1.4,NULL,'G',0.000187,NULL,'14.67',0.7,'SAB(r)b',NULL,NULL,NULL,NULL,1,239.337375,47.16647,0.053,NULL,59713676484,933026195,14578534,14.67),(133793,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133793,34.25,0.2,70.8,63022,74.4,NULL,NULL,'UGC 10109',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133794,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133794,34.69,0.4,86.7,63022,NULL,NULL,'mean','UGC 10109',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133795,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133795,34.86,0.47,93.7,63022,NULL,NULL,'H','UGC 10109',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133796,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133796,36.21,0.33,175,63023,70,NULL,NULL,'CGCG 275-016',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.00009,NULL,'14.9g',0.66,'BrClG          PEG',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,239.339167,54.67111,NULL,NULL,57605208836,900081388,14063771,14.9),(133797,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133797,36.23,0.46,176,63024,70,NULL,NULL,'2MASX J15572244+4157502',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000161,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.343667,41.96397,0.061,NULL,59797007931,934328248,14598878,17.5),(133798,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133798,37.96,0.46,391,63025,70,NULL,NULL,'SDSS J155722.70+251131.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000125,NULL,'18.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.344625,25.19194,0.169,NULL,59874842977,935544421,14617881,18.4),(133799,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133799,34.67,0.52,85.7,63026,70,NULL,NULL,'2MFGC 12799',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.0001,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,239.347791667,-15.64394,0.701,NULL,45489539153,710774049,11105844,14.9),(133800,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133800,37.09,0.46,262,63027,70,NULL,NULL,'2MASX J15572394+1512243',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',NULL,NULL,'15.9g',0.41,NULL,NULL,NULL,NULL,NULL,1,239.349667,15.20686,0.085,NULL,56569652451,883900819,13810950,15.9),(133801,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133801,38.9,0.46,601,63028,70,NULL,NULL,'SDSS J155724.58+185815.3',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,239.352417,18.97092,0.057,NULL,56510477380,882976209,13796503,NULL),(133802,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133802,36.33,0.46,184,63029,70,NULL,NULL,'2MASX J15572462+0841071',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000164,NULL,'16.1g',0.34,NULL,NULL,NULL,NULL,NULL,1,239.352583,8.68531,0.097,NULL,56636697214,884948393,13827318,16.1),(133803,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133803,37.58,0.46,328,63030,70,NULL,NULL,'2MASX J15572469+2728177',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000143,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.352875,27.47158,0.105,NULL,59877297202,935582768,14618480,17.9),(133804,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133804,37.71,0.33,349,63031,70,NULL,NULL,'2MASX J15572487+2149448',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000145,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,239.353583,21.82925,0.113,NULL,59405677121,928213705,14503339,17.1),(133805,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133805,37.44,0.46,308,63032,70,NULL,NULL,'SDSS J155725.18+481924.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,239.3549583,48.32356,0.053,NULL,59713406878,933021982,14578468,18.1),(133806,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133806,35.23,0.73,111,63033,70,NULL,NULL,'2MASX J15572524-2159475',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,239.35525,-21.99656,0.733,NULL,46589027939,727953561,11374274,15.1),(133807,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133807,37.49,0.46,314,63034,70,NULL,NULL,'2MASX J15572566+2000158',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,239.356875,20.00447,0.085,NULL,59403434934,928178670,14502791,16.5),(133808,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133808,37.8,0.46,363,63035,70,NULL,NULL,'2MASX J15572906+1328293',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.3712083,13.47478,0.085,NULL,56526953842,883233653,13800525,17.7),(133809,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133809,38.17,0.46,431,63036,70,NULL,NULL,'SDSS J155729.34+262447.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000172,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.3722917,26.41325,0.125,NULL,59875075829,935548059,14617938,18.3),(133810,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133810,38.23,0.33,442,63037,70,NULL,NULL,'2MASX J15572949+3724282',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,239.373,37.40786,0.025,NULL,59761781168,933777830,14590278,17.5),(133811,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133811,34.51,0.4,79.9,63038,NULL,NULL,'mean','NGC 6018',NULL,'2007A&A...465...71T',2007,1,1.4,'This may also be IC 1150.','G',0.000083,NULL,'14.34',0.7,'(R)SAB(s)0+:','Supercluster foreground object',NULL,NULL,NULL,1,239.3740417,15.87261,0.049,NULL,56565529973,883836405,13809943,14.34),(133812,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133812,34.64,0.45,84.5,63038,NULL,NULL,'K','NGC 6018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133813,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133813,38.03,0.05,403,63039,70,NULL,NULL,'2MASX J15573010+2718557',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000066,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,239.3755,27.31547,0.105,NULL,59877772834,935590200,14618596,17.7),(133814,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133814,33.73,0.25,55.7,63040,74.4,NULL,NULL,'NGC 6021',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.00007,NULL,'14.15',0.8,'E+','Supercluster foreground object',NULL,NULL,NULL,1,239.377875,15.95606,0.053,NULL,56566383820,883849747,13810152,14.15),(133815,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133815,33.94,0.25,61.3,63040,70,NULL,NULL,'NGC 6021',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133816,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133816,34.54,0.33,80.7,63040,70,NULL,NULL,'NGC 6021',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133817,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133817,34.3,0.4,72.5,63040,NULL,NULL,'mean','NGC 6021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133818,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133818,34.66,0.45,85.6,63040,NULL,NULL,'K','NGC 6021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133819,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133819,37.93,0.46,385,63041,70,NULL,NULL,'2MASX J15573108+2706087',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000106,NULL,'17.7g',0.2,'BrClG',NULL,NULL,NULL,NULL,1,239.3794583,27.10244,0.117,NULL,59877879430,935591866,14618622,17.7),(133820,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133820,36.83,0.46,233,63042,70,NULL,NULL,'2MASX J15573116+1836588',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,239.379875,18.61636,0.053,NULL,56510868872,882982326,13796598,16.6),(133821,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133821,36.63,0.46,212,63043,70,NULL,NULL,'2MASX J15573163+0744591',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000194,NULL,'15.8g',0.42,NULL,NULL,NULL,NULL,NULL,1,239.381917,7.74961,0.125,NULL,56628661675,884822838,13825356,15.8),(133822,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133822,36.18,0.46,172,63044,70,NULL,NULL,'2MASX J15573257+0358462',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'16.88',0.22,NULL,NULL,NULL,NULL,NULL,1,239.3857083,3.97939,0.257,NULL,56482179525,882534055,13789594,16.88),(133823,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133823,38.23,0.33,442,63045,70,NULL,NULL,'SDSS J155732.67+372105.6',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.386125,37.35156,0.029,NULL,59761817448,933778397,14590287,17.3),(133824,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133824,36.71,0.46,220,63046,70,NULL,NULL,'2MASX J15573283+1737443',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000174,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,239.386875,17.62906,0.061,NULL,56565049799,883828903,13809826,16.5),(133825,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133825,37.42,0.46,305,63047,70,NULL,NULL,'2MASX J15573290+2356048',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,239.387125,23.93483,0.149,NULL,59392469045,928007328,14500114,17.4),(133826,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133826,36.84,0.46,233,63048,70,NULL,NULL,'SDSS J155733.32+085222.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000149,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.388833,8.87297,0.109,NULL,56636631414,884947365,13827302,18.1),(133827,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133827,38.66,0.46,539,63049,70,NULL,NULL,'2MASX J15573366+3510341',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.390458333,35.17619,0.041,NULL,59767728530,933870758,14591730,18),(133828,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133828,37.77,0.46,358,63050,70,NULL,NULL,'2MASX J15573403+3031301',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000171,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,239.391667,30.525,0.065,NULL,59865770173,935402658,14615666,16.9),(133829,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133829,37.16,0.46,270,63051,70,NULL,NULL,'2MASX J15573445+0513432',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000149,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.393666667,5.22886,0.177,NULL,56614458455,884600913,13821889,17.7),(133830,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133830,35.4,0.52,120,63052,NULL,NULL,NULL,'KUG 1555+181',NULL,'2009ApJS..182..474S',2009,1,0.58,NULL,'G',0.000015,NULL,'15.4g',0.34,'Sb:','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,239.3967083,18.02817,0.077,NULL,56565026303,883828535,13809820,15.4),(133831,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133831,35.49,0.2,125,63052,74.4,NULL,NULL,'KUG 1555+181',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133832,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133832,35.5,0.5,126,63052,NULL,NULL,'Malmquist cor.','KUG 1555+181',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133833,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133833,37.69,0.46,346,63053,70,NULL,NULL,'SDSS J155735.44+100546.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.3977083,10.09633,0.085,NULL,56635088421,884923256,13826925,18.1),(133834,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133834,37.06,0.46,258,63054,70,NULL,NULL,'2MASX J15573658+2851537',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.4024583,28.86494,0.093,NULL,59868673962,935448030,14616375,17.8),(133835,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133835,38.03,0.05,403,63055,70,NULL,NULL,'2MASX J15573746+2720377',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.405916667,27.34383,0.105,NULL,59877772784,935590199,14618596,17.9),(133836,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133836,35.75,0.7,141,63056,70,NULL,NULL,'2MASX J15573750-0253301',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,239.406375,-2.89169,0.577,NULL,45531723035,711433172,11116143,15.6),(133837,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133837,36.62,0.77,211,63057,70,NULL,NULL,'2MASX J15573754-1320426',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,239.4064583,-13.34519,0.693,NULL,45475188556,710549821,11102340,15.6),(133838,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133838,35.01,0.46,100,63058,70,NULL,NULL,'2MASX J15573901+2517507',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000152,NULL,'16.0g',0.31,NULL,NULL,NULL,NULL,NULL,1,239.4124583,25.29742,0.169,NULL,59874812606,935543946,14617874,16),(133839,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133839,36.21,0.33,175,63059,70,NULL,NULL,'2MASX J15573968+5439132',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000088,NULL,'16.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,239.415083,54.65361,NULL,NULL,57605207749,900081371,14063771,16.2),(133840,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133840,38.03,0.05,403,63060,70,NULL,NULL,'2MASX J15573968+2748227',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.415291667,27.80619,0.093,NULL,59877343431,935583491,14618492,17.9),(133841,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133841,37.43,0.33,306,63061,70,NULL,NULL,'2MASX J15573974+3403252',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000197,NULL,'16.6g',0.26,'BrClG',NULL,NULL,NULL,NULL,1,239.4155,34.057,0.073,NULL,59768055449,933875866,14591810,16.6),(133842,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133842,38.03,0.05,403,63062,70,NULL,NULL,'2MASX J15573994+2722497',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.4g',0.23,'BrClG',NULL,NULL,NULL,NULL,1,239.41625,27.38031,0.105,NULL,59877265140,935582267,14618472,17.4),(133843,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133843,38.26,0.46,449,63063,70,NULL,NULL,'2MASX J15573997+1401553',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.416416667,14.03203,0.089,NULL,56558398687,883724979,13808202,17.9),(133844,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133844,37.47,0.11,313,63064,70,NULL,NULL,'2MASX J15574008+2852487',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000167,NULL,'16.3g',0.36,'Sa',NULL,NULL,NULL,NULL,1,239.417,28.88028,0.093,NULL,59868673865,935448029,14616375,16.3),(133845,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133845,37.13,0.33,267,63065,70,NULL,NULL,'2MASX J15574036+0947117',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,239.418041667,9.78647,0.073,NULL,56634382429,884912225,13826753,17.1),(133846,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133846,34.54,0.33,80.7,63066,70,NULL,NULL,'2MASX J15574052+1552283',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'15.5g',0.43,NULL,NULL,NULL,NULL,NULL,1,239.418875,15.87458,0.049,NULL,56565524570,883836321,13809942,15.5),(133847,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133847,37.67,0.23,341,63067,70,NULL,NULL,'2MASX J15574133+1217403',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.422417,12.29461,0.121,NULL,56526677489,883229335,13800458,17.5),(133848,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133848,38.03,0.05,403,63068,70,NULL,NULL,'2MASX J15574152+2724327',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000153,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.4229583,27.40906,0.105,NULL,59877265316,935582270,14618472,17.7),(133849,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133849,38.03,0.05,403,63069,70,NULL,NULL,'2MASX J15574203+2719467',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000066,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.425083333,27.32953,0.105,NULL,59877772035,935590188,14618596,18.3),(133850,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133850,33.94,0.25,61.3,63070,70,NULL,NULL,'SDSS J155742.59+161304.9',NULL,'2001MNRAS.321..277C',2001,1,0.83,NULL,'G',NULL,NULL,'15.0g',0.64,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.4275,16.21806,0.085,NULL,56566473761,883851152,13810174,15),(133851,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133851,35.74,0.25,141,63071,74.4,NULL,NULL,'CGCG 108-019',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.00008,NULL,'15.14',0.8,'SA0^0^','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,239.4287917,16.2175,0.085,NULL,56566442000,883850656,13810166,15.14),(133852,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133852,38.03,0.05,403,63072,70,NULL,NULL,'2MASX J15574360+2716370',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000067,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.4317083,27.27692,0.105,NULL,59877784309,935590379,14618599,18.2),(133853,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133853,37.47,0.11,313,63073,70,NULL,NULL,'2MASX J15574363+2839347',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,239.4317083,28.65958,0.097,NULL,59868492543,935445195,14616331,17.8),(133854,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133854,36.89,0.15,238,63074,70,NULL,NULL,'SDSS J155744.07+201201.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'18.0g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.433625,20.20028,0.073,NULL,59401454973,928147733,14502308,18),(133855,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133855,37.8,0.46,364,63075,70,NULL,NULL,'2MASX J15574603+3147582',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.4417917,31.79953,0.061,NULL,59920080351,936251255,14628925,17.5),(133856,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133856,37.63,0.46,336,63076,70,NULL,NULL,'SDSS J155746.40+064541.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000174,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.443333,6.76142,0.149,NULL,56630892939,884857702,13825901,17.6),(133857,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133857,35.98,0.35,157,63077,NULL,NULL,'Malmquist cor.','KUG 1555+165',NULL,'2009ApJS..182..474S',2009,1,0.52,NULL,'G',0.000029,NULL,'16.2g',0.23,'Sbc:',NULL,NULL,NULL,NULL,1,239.44375,16.37344,0.069,NULL,56566269451,883847960,13810124,16.2),(133858,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133858,36,0.35,158,63077,NULL,NULL,NULL,'KUG 1555+165',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133859,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133859,36.04,0.2,161,63077,74.4,NULL,NULL,'KUG 1555+165',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133860,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133860,38.03,0.05,403,63078,70,NULL,NULL,'2MASX J15574757+2744290',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000146,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,239.4482917,27.74142,0.105,NULL,59877345719,935583526,14618492,17.1),(133861,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133861,35.19,0.81,109,63079,NULL,NULL,'Malmquist cor.','NGC 6022',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.00002,NULL,'15.33',0.5,'(R\')SB(s)bc','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,239.449041667,16.28231,0.085,NULL,56566439081,883850610,13810165,15.33),(133862,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133862,35.22,0.8,111,63079,NULL,NULL,NULL,'NGC 6022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133863,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133863,35.27,0.2,113,63079,74.4,NULL,NULL,'NGC 6022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133864,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133864,37.47,0.11,313,63080,70,NULL,NULL,'2MASX J15574822+2844160',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.450833,28.73797,0.097,NULL,59868489615,935445150,14616330,17.4),(133865,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133865,38.01,0.46,400,63081,70,NULL,NULL,'2MASX J15574848+0745197',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,239.451917,7.75553,0.125,NULL,56628850322,884825786,13825402,17.3),(133866,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133866,37.27,0.33,284,63082,70,NULL,NULL,'2MASX J15574893+0219292',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000092,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.453875,2.32481,0.313,NULL,56488430313,882631723,13791120,18),(133867,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 1969I',NULL,133867,35.22,0.29,111,63083,NULL,NULL,'Avg. of 8 SN host galaxies','[TB93] 1555.6+1937',NULL,'1985ApJ...297...23D',1985,1,NULL,NULL,'G',NULL,NULL,'18.0',NULL,NULL,NULL,NULL,NULL,NULL,1,239.455875,19.47406,0.065,NULL,59400035814,928125559,14501961,18),(133868,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133868,33.94,0.25,61.3,63084,70,NULL,NULL,'NGC 6023',NULL,'2001MNRAS.321..277C',2001,1,1.4,NULL,'G',0.000083,NULL,'14.22',1,'E','Supercluster (RV-confirmed) member',NULL,NULL,'Flat-Spectrum Radio Source',1,239.45675,16.31019,0.085,NULL,56566438368,883850599,13810165,14.22),(133869,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133869,35.75,0.25,141,63084,74.4,NULL,NULL,'NGC 6023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133870,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133870,35.85,0.46,148,63084,70,NULL,NULL,'NGC 6023',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133871,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133871,36.03,0.4,161,63084,NULL,NULL,'mean','NGC 6023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133872,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133872,36.2,0.45,173,63084,NULL,NULL,'K','NGC 6023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133873,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133873,38.03,0.05,403,63085,70,NULL,NULL,'2MASX J15574958+2726120',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000073,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.456667,27.43653,0.105,NULL,59877275076,935582423,14618475,17.6),(133874,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133874,38.03,0.05,403,63086,70,NULL,NULL,'SDSS J155749.68+271812.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000065,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.457,27.3035,0.105,NULL,59877783013,935590359,14618599,18.4),(133875,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133875,35.39,0.64,119,63087,70,NULL,NULL,'2MASX J15574995-1949419',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,239.458167,-19.82825,0.621,NULL,46581208305,727831379,11372365,15.2),(133876,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133876,38.03,0.05,403,63088,70,NULL,NULL,'SDSS J155750.24+271428.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000068,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,239.459375,27.24122,0.105,NULL,59877783814,935590372,14618599,18.7),(133877,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133877,35.19,0.49,109,63089,75,NULL,'IR','ESO 583- G 008',NULL,'2011yCatp016004901K',2011,1,1.97,NULL,'G',0.000037,NULL,'15.8',0.21,'Sbc',NULL,NULL,NULL,NULL,1,239.460083333,-22.49422,0.725,NULL,46589381238,727959081,11374360,15.8),(133878,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133878,35.32,NULL,116,63089,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 583- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133879,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133879,35.34,NULL,117,63089,NULL,NULL,'Dipole + Quadrupole','ESO 583- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133880,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133880,35.34,NULL,117,63089,NULL,NULL,'Dipole','ESO 583- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133881,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133881,35.65,0.43,135,63089,75,NULL,'3.6 micron, color + selection bias corrected','ESO 583- G 008',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133882,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133882,36.15,0.36,170,63090,NULL,NULL,'Malmquist cor.','CGCG 108-023',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000027,NULL,'15.43',0.9,'SA(s)c','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,239.464,16.36231,0.069,NULL,56566263736,883847870,13810122,15.43),(133883,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133883,36.34,0.33,186,63090,NULL,NULL,NULL,'CGCG 108-023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133884,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133884,36.38,0.2,189,63090,74.4,NULL,NULL,'CGCG 108-023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133885,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133885,38.03,0.05,403,63091,70,NULL,NULL,'SDSS J155751.66+271605.8',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000065,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.465291667,27.26828,0.105,NULL,59877785489,935590398,14618599,17.8),(133886,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133886,37.67,0.23,341,63092,70,NULL,NULL,'2MASX J15575198+1222003',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,239.46675,12.36681,0.081,NULL,56526684247,883229441,13800460,16.9),(133887,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133887,36.55,0.46,205,63093,70,NULL,NULL,'SDSS J155752.04+423504.8',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00017,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.466875,42.58467,0.053,NULL,59807660575,934494696,14601479,17.1),(133888,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133888,37.98,0.33,394,63094,70,NULL,NULL,'2MASX J15575273+0232132',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000079,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.469625,2.53714,0.293,NULL,56486458751,882600917,13790639,17.7),(133889,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133889,37.98,0.33,394,63095,70,NULL,NULL,'2MASX J15575313+0234252',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000078,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.471333,2.57364,0.289,NULL,56486448214,882600753,13790636,17.5),(133890,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133890,37.87,0.46,375,63096,70,NULL,NULL,'2MASX J15575392+2539101',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000153,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.47475,25.65267,0.125,NULL,59875660149,935557189,14618081,17.8),(133891,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133891,36.64,0.14,212,63097,70,NULL,NULL,'2MASX J15575424+1811281',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,239.475917,18.19119,0.077,NULL,56565012575,883828321,13809817,16.6),(133892,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133892,35.25,0.46,112,63098,70,NULL,NULL,'CGCG 079-014',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000093,NULL,'15.2g',0.55,NULL,NULL,NULL,NULL,NULL,1,239.477375,9.40994,0.105,NULL,56634205211,884909456,13826710,15.2),(133893,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133893,37.87,0.46,374,63099,70,NULL,NULL,'2MASX J15575471+5311033',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.001217,NULL,'17.9g',0.16,'BLAGN',NULL,NULL,NULL,'Sy 1',1,239.478041667,53.18419,0.013,NULL,59698561052,932790016,14574844,17.9),(133894,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133894,38.03,0.05,403,63100,70,NULL,NULL,'SDSS J155754.92+271151.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000082,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.478833333,27.19756,0.105,NULL,59877776996,935590265,14618597,18.2),(133895,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133895,37.27,0.33,284,63101,70,NULL,NULL,'2MASX J15575514+0220362',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000103,NULL,'16.5g',0.27,'S0^-',NULL,NULL,NULL,NULL,1,239.479625,2.3435,0.313,NULL,56488441478,882631898,13791123,16.5),(133896,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133896,37.82,0.46,367,63102,70,NULL,NULL,'2MASX J15575611+0610527',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.4837083,6.18142,0.141,NULL,56630712444,884854881,13825857,17.6),(133897,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133897,37.47,0.11,313,63103,70,NULL,NULL,'UGC 10110',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000127,NULL,'15.2g',0.61,'S0?;BrClG',NULL,NULL,NULL,NULL,1,239.4849583,28.79561,0.093,NULL,59868666556,935447914,14616373,15.2),(133898,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133898,38.03,0.05,403,63104,70,NULL,NULL,'2MASX J15575649+2723521',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000065,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.485333333,27.39786,0.105,NULL,59877276433,935582444,14618475,18),(133899,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133899,35.96,0.65,155,63105,70,NULL,NULL,'2MASX J15575679-0550458',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,239.486708333,-5.84611,0.533,NULL,45592648839,712385138,11131017,15.7),(133900,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133900,38.03,0.05,403,63106,70,NULL,NULL,'2MASX J15575853+2710431',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000069,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.4939583,27.17872,0.105,NULL,59877804301,935590692,14618604,18.1),(133901,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133901,35.09,0.46,104,63107,70,NULL,NULL,'2MASX J15575983+3508082',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000169,NULL,'15.2g',0.51,'S0/a',NULL,NULL,NULL,NULL,1,239.49925,35.13569,0.041,NULL,59767755927,933871186,14591737,15.2),(133902,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133902,38.03,0.05,403,63108,70,NULL,NULL,'2MASX J15580025+2718021',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000069,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.501125,27.30061,0.105,NULL,59877783061,935590360,14618599,17.5),(133903,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133903,37.53,0.46,321,63109,70,NULL,NULL,'2MASX J15580094+3446332',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00015,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.503917,34.77589,0.045,NULL,59767081083,933860641,14591572,18.3),(133904,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133904,38.5,0.33,502,63110,70,NULL,NULL,'2MASX J15580121+4223530',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000166,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,239.5050417,42.39817,0.053,NULL,59807729289,934495770,14601496,18.4),(133905,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133905,38.03,0.05,403,63111,70,NULL,NULL,'2MASX J15580130+2715021',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000074,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.5052917,27.25072,0.105,NULL,59877782476,935590351,14618599,17.8),(133906,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133906,37.81,0.46,365,63112,70,NULL,NULL,'2MASX J15580239+2807481',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,239.509875,28.13,0.101,NULL,59877111531,935579867,14618435,17.3),(133907,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133907,36.7,0.46,218,63113,70,NULL,NULL,'2MASX J15580351+5259384',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000105,NULL,'16.0g',0.31,'E0',NULL,NULL,NULL,NULL,1,239.5145417,52.99392,0.013,NULL,59698355256,932786800,14574793,16),(133908,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133908,38.5,0.33,502,63114,70,NULL,NULL,'2MASX J15580365+4222301',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.514958333,42.37486,0.053,NULL,59807729590,934495774,14601496,18),(133909,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133909,38.27,0.46,450,63115,70,NULL,NULL,'2MASX J15580370+2726521',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000089,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.515417,27.44781,0.105,NULL,59877273974,935582405,14618475,17.8),(133910,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133910,37.66,0.46,340,63116,70,NULL,NULL,'SDSS J155804.97-003505.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000132,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.52075,-0.585,0.409,NULL,45526098906,711345295,11114770,18.6),(133911,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133911,38.03,0.05,403,63117,70,NULL,NULL,'2MASX J15580506+2705311',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000081,NULL,'17.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,239.520917,27.09203,0.117,NULL,59877797298,935590582,14618602,17.8),(133912,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133912,37.41,0.46,303,63118,70,NULL,NULL,'2MASX J15580603+0226436',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000073,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.525167,2.44536,0.313,NULL,56488435856,882631810,13791122,17.8),(133913,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133913,37.47,0.11,313,63119,70,NULL,NULL,'2MASX J15580647+2858001',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000186,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.5269583,28.96678,0.077,NULL,59868704073,935448501,14616382,17.7),(133914,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133914,38.03,0.05,403,63120,70,NULL,NULL,'2MASX J15580685+2718591',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000143,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,239.5284583,27.31628,0.105,NULL,59877778765,935590293,14618598,18.6),(133915,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133915,36.3,0.33,182,63121,70,NULL,NULL,'GIN 470',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'16.9g',0.27,'E',NULL,NULL,NULL,NULL,1,239.528667,22.66481,0.101,NULL,59407115633,928236181,14503690,16.9),(133916,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133916,38.03,0.05,403,63122,70,NULL,NULL,'2MASX J15580745+2714431',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000069,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.5310417,27.2455,0.105,NULL,59877779664,935590307,14618598,18.2),(133917,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133917,34.08,0.47,65.6,63123,NULL,NULL,'H','IC 1149',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.00002,NULL,'14.1P',1,'Sbc',NULL,NULL,NULL,NULL,1,239.53325,12.07028,0.145,NULL,56597948793,884342949,13817858,14.1),(133918,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133918,34.2,0.45,69.2,63123,NULL,NULL,'K','IC 1149',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133919,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133919,34.22,0.46,69.9,63123,NULL,NULL,'J','IC 1149',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133920,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133920,34.25,0.4,70.8,63123,NULL,NULL,'mean','IC 1149',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133921,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133921,36.89,0.15,238,63124,70,NULL,NULL,'2MASX J15580834+2003011',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000177,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,239.5347917,20.05044,0.065,NULL,59401354417,928146162,14502283,16.7),(133922,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133922,38.03,0.05,403,63125,70,NULL,NULL,'SDSS J155808.92+271022.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000072,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.5372083,27.17303,0.105,NULL,59877804699,935590698,14618604,18.3),(133923,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133923,37.29,0.46,286,63126,70,NULL,NULL,'2MASX J15581007+2356381',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,239.541875,23.94394,0.157,NULL,59392483528,928007555,14500118,17.3),(133924,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133924,38.03,0.05,403,63127,70,NULL,NULL,'2MASX J15581023+2719031',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000079,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.542667,27.31753,0.105,NULL,59877781348,935590333,14618598,17.6),(133925,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133925,37.77,0.46,358,63128,70,NULL,NULL,'SDSS J155811.38+263643.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,239.547416667,26.61208,0.153,NULL,59877017380,935578396,14618412,18.8),(133926,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133926,37.82,0.09,366,63129,70,NULL,NULL,'2MASX J15581192+2631201',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000156,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,239.549625,26.52222,0.165,NULL,59877024795,935578512,14618414,16.8),(133927,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133927,38.13,0.33,422,63130,70,NULL,NULL,'2MASX J15581231+2229211',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,239.5512917,22.48925,0.109,NULL,59407221316,928237833,14503716,16.9),(133928,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133928,38.08,0.25,413,63131,74.4,NULL,NULL,'GIN 471',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000247,NULL,'15.62',NULL,'E/S0',NULL,NULL,NULL,NULL,1,239.5520417,22.48872,0.109,NULL,59407221317,928237833,14503716,15.62),(133929,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133929,37.82,0.46,366,63132,70,NULL,NULL,'2MASX J15581259+2221271',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000184,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,239.552625,22.35753,0.113,NULL,59405349624,928208587,14503259,16.9),(133930,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133930,37.34,0.13,294,63133,70,NULL,NULL,'2MASX J15581276+5352513',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000109,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,239.553333,53.881,NULL,NULL,57604967465,900077616,14063712,16.1),(133931,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133931,37.97,0.33,394,63134,70,NULL,NULL,'2MASX J15581305+5337383',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000073,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,239.55425,53.62761,NULL,NULL,59698389053,932787328,14574802,18),(133932,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133932,35.34,NULL,117,63135,NULL,NULL,'Dipole','UGC 10111',NULL,'2010Ap&SS.325..163P',2010,1,2.07,'UGC declination of +13d27m should be +13d18m.','G',0.000009,NULL,'16.0',0.19,'Sc',NULL,NULL,NULL,NULL,1,239.554875,13.16883,0.105,NULL,56556641375,883697521,13807773,16),(133933,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133933,35.35,NULL,118,63135,NULL,NULL,'Dipole + Quadrupole','UGC 10111',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133934,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133934,35.36,NULL,118,63135,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10111',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133935,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133935,35.54,NULL,128,63135,NULL,NULL,NULL,'UGC 10111',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133936,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133936,36.7,0.2,219,63135,74.4,NULL,NULL,'UGC 10111',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133937,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133937,38.03,0.05,403,63136,70,NULL,NULL,'2MASX J15581330+2714531',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000064,NULL,'16.3g',0.42,NULL,NULL,NULL,NULL,NULL,1,239.555375,27.24814,0.105,NULL,59877811385,935590802,14618606,16.3),(133938,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133938,37.47,0.11,313,63137,70,NULL,NULL,'SDSS J155813.73+284632.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,239.557208333,28.77572,0.093,NULL,59868664748,935447886,14616373,18.2),(133939,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133939,38.03,0.05,403,63138,70,NULL,NULL,'B2 1556+27',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.5g',0.22,'Radio galaxy',NULL,NULL,'NAT',NULL,1,239.559625,27.27211,0.105,NULL,59877779910,935590311,14618598,17.5),(133940,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133940,36.87,0.46,236,63139,70,NULL,NULL,'2MASX J15581526+0336247',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000093,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,239.563625,3.60692,0.257,NULL,56482383509,882537242,13789644,16.9),(133941,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133941,38.03,0.05,403,63140,70,NULL,NULL,'SDSS J155815.42+271627.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000061,NULL,'18.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,239.5642917,27.27431,0.105,NULL,59877779961,935590311,14618598,18.9),(133942,'SZ effect','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133942,37.6,NULL,331,63141,NULL,NULL,NULL,'ABELL 2142',NULL,'2001ApJ...555L..11M',2001,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II     [BM]',NULL,NULL,NULL,NULL,1,239.585833,27.22694,0.117,NULL,59877811609,935590806,14618606,NULL),(133943,'SZ effect','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133943,37.63,NULL,335,63141,NULL,NULL,NULL,'ABELL 2142',NULL,'2005ApJ...625..108D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133944,'BCG','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133944,38.56,0.35,472,63141,60,NULL,NULL,'ABELL 2142',0.0911,'1980ApJ...241..486H',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133945,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133945,38.03,0.05,403,63142,70,NULL,NULL,'2MASX J15581671+2720540',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000073,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.569625,27.34831,0.105,NULL,59877265941,935582280,14618473,18.1),(133946,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133946,37.11,0.33,264,63143,70,NULL,NULL,'2MASX J15581687+3529256',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000151,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,239.5702917,35.49039,0.065,NULL,59767598690,933868729,14591698,17.1),(133947,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133947,35.95,0.25,155,63144,74.4,NULL,NULL,'CGCG 137-007',NULL,'2013AJ....146...86T',2013,1,0.59,NULL,'G',0.000073,NULL,'15.4g',0.53,'E/S0',NULL,NULL,NULL,NULL,1,239.5727083,22.67478,0.101,NULL,59407118843,928236231,14503691,15.4),(133948,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133948,36.3,0.33,182,63144,70,NULL,NULL,'CGCG 137-007',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133949,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133949,38.03,0.05,403,63145,70,NULL,NULL,'SDSS J155818.43+270325.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000066,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,239.5767917,27.05711,0.117,NULL,59877798664,935590604,14618603,18.6),(133950,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133950,38.03,0.05,403,63146,70,NULL,NULL,'2MASX J15581875+2714210',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000105,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,239.5780417,27.23911,0.105,NULL,59877812119,935590814,14618606,17.8),(133951,'BCG','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133951,38.56,0.35,472,63147,60,NULL,'ABELL 2142, BCG','2MASX J15582002+2714000',0.0911,'1980ApJ...241..486H',1980,1,0.67,'VCV (mis?)identifies this as the X-ray source 2E 1556+2725.','G',0.000167,NULL,'16.2g',0.35,'BrClG          Sy1',NULL,NULL,NULL,NULL,1,239.583333,27.23342,0.117,NULL,59877811628,935590806,14618606,16.2),(133952,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133952,38.03,0.05,403,63147,70,NULL,NULL,'2MASX J15582002+2714000',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133953,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133953,36.24,0.25,177,63148,74.4,NULL,NULL,'CGCG 108-025',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000083,NULL,'14.10',0.65,'E','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,239.5860417,18.08086,0.061,NULL,56565151560,883830493,13809851,14.1),(133954,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133954,36.44,0.18,194,63148,70,NULL,NULL,'CGCG 108-025',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133955,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133955,36.64,0.14,212,63148,70,NULL,NULL,'CGCG 108-025',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133956,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133956,38.03,0.05,403,63149,70,NULL,NULL,'2MASX J15582073+2656460',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000065,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,239.586416667,26.94614,0.117,NULL,59877789280,935590457,14618600,17),(133957,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133957,38.03,0.05,403,63150,70,NULL,NULL,'2MASX J15582091+2720010',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000081,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,239.587,27.33375,0.105,NULL,59877778328,935590286,14618598,16.6),(133958,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133958,37.82,0.46,366,63151,70,NULL,NULL,'2MASX J15582092+2213002',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000164,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.5872083,22.21661,0.133,NULL,59405366872,928208857,14503263,17.4),(133959,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133959,38.03,0.05,403,63152,70,NULL,NULL,'2MASX J15582102+2705260',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000068,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,239.587625,27.09069,0.117,NULL,59877798130,935590595,14618603,17.3),(133960,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133960,37.27,0.46,285,63153,70,NULL,NULL,'2MASX J15582125+2659230',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000172,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,239.588666667,26.98983,0.117,NULL,59877787024,935590422,14618600,17.7),(133961,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133961,36.12,0.35,167,63154,NULL,NULL,'Malmquist cor.','2MASX J15582240+1606100',NULL,'2009ApJS..182..474S',2009,1,0.58,NULL,'G',0.000027,NULL,'16.9g',0.13,'Sc',NULL,NULL,NULL,NULL,1,239.593375,16.10258,0.085,NULL,56566407835,883850122,13810158,16.9),(133962,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133962,36.2,0.34,174,63154,NULL,NULL,NULL,'2MASX J15582240+1606100',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133963,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133963,36.24,0.2,177,63154,74.4,NULL,NULL,'2MASX J15582240+1606100',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133964,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133964,36.87,0.46,237,63155,70,NULL,NULL,'2MASX J15582245+2254152',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000177,NULL,'17.3g',NULL,NULL,NULL,NULL,NULL,NULL,1,239.5934583,22.90428,0.129,NULL,59407098078,928235907,14503686,17.3),(133965,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133965,36.89,0.15,238,63156,70,NULL,NULL,'2MASX J15582309+2004272',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',NULL,NULL,'16.73',0.3,NULL,NULL,NULL,NULL,NULL,1,239.596125,20.07419,0.061,NULL,59401348417,928146069,14502282,16.73),(133966,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133966,38.03,0.05,403,63157,70,NULL,NULL,'2MASX J15582318+2712260',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00018,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.5965,27.20717,0.117,NULL,59877817953,935590905,14618607,18.2),(133967,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133967,38.03,0.05,403,63158,70,NULL,NULL,'SDSS J155824.50+271125.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000071,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,239.602083,27.19044,0.117,NULL,59877818350,935590911,14618607,18),(133968,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133968,37.42,0.33,305,63159,70,NULL,NULL,'2MASX J15582494+2951090',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00013,NULL,'16.7g',0.3,'Sb;BrClG',NULL,NULL,NULL,NULL,1,239.604041667,29.85267,0.085,NULL,59869261548,935457211,14616518,16.7),(133969,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133969,37.34,0.13,294,63160,70,NULL,NULL,'2MASX J15582512+5357013',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000077,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,239.6047917,53.95056,NULL,NULL,57604974091,900077720,14063714,17.2),(133970,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133970,36.44,0.46,194,63161,70,NULL,NULL,'2MASX J15582551+3509076',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000166,NULL,'16.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.606291667,35.15206,0.041,NULL,59767765550,933871336,14591739,16.6),(133971,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133971,36.23,0.49,176,63162,75,NULL,'IR','CGCG 108-027',NULL,'2011yCatp016004901K',2011,1,1.04,NULL,'G',0.00013,NULL,'15.3g',0.28,'S..','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,239.61,18.03964,0.061,NULL,56565145963,883830405,13809850,15.3),(133972,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133972,37.82,0.09,366,63163,70,NULL,NULL,'SDSS J155826.60+262021.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,239.610875,26.33928,0.165,NULL,59875114101,935548657,14617947,18.3),(133973,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133973,38.03,0.05,403,63164,70,NULL,NULL,'2MASX J15582661+2719120',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000064,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.611,27.31992,0.117,NULL,59877777595,935590274,14618598,18.1),(133974,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133974,36.45,0.33,195,63165,70,NULL,NULL,'2MASX J15582666+2448440',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000182,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,239.611083,24.81211,0.153,NULL,59863409363,935365771,14615090,16.8),(133975,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133975,37.82,0.09,366,63166,70,NULL,NULL,'2MASX J15582667+2638431',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00019,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,239.611167,26.64517,0.153,NULL,59877007965,935578249,14618410,16.6),(133976,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133976,37.56,0.46,325,63167,70,NULL,NULL,'2MASX J15582723+2904130',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000137,NULL,'17.1g',0.25,'E',NULL,NULL,NULL,NULL,1,239.6135,29.0705,0.077,NULL,59868657998,935447781,14616371,17.1),(133977,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133977,37.34,0.13,294,63168,70,NULL,NULL,'2MASX J15582816+5350000',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000097,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,239.617417,53.83333,NULL,NULL,59698127895,932783248,14574738,17.2),(133978,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133978,36.52,0.46,201,63169,70,NULL,NULL,'2MASX J15582851+5213270',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000159,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,239.6185417,52.22411,0.017,NULL,59701251834,932832059,14575500,16.4),(133979,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133979,37.97,0.33,394,63170,70,NULL,NULL,'SDSS J155828.48+533917.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000077,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,239.618708333,53.65497,NULL,NULL,59698176752,932784011,14574750,18.2),(133980,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133980,37.16,0.46,270,63171,70,NULL,NULL,'2MASX J15582858+1951453',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,239.619083,19.86264,0.065,NULL,59401317490,928145585,14502274,18.3),(133981,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133981,37.57,0.46,327,63172,70,NULL,NULL,'SDSS J155829.05+281356.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.6210417,28.23225,0.109,NULL,59876062714,935563479,14618179,18.2),(133982,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133982,35.59,0.33,131,63173,70,NULL,NULL,'2MASX J15582911+1421365',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000422,NULL,'15.5g',0.53,NULL,NULL,NULL,NULL,NULL,1,239.621167,14.36017,0.101,NULL,56558437588,883725587,13808212,15.5),(133983,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133983,38.03,0.05,403,63174,70,NULL,NULL,'2MASX J15582938+2727341',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000069,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.62225,27.45958,0.105,NULL,59877292474,935582694,14618479,17.6),(133984,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133984,38.03,0.05,403,63175,70,NULL,NULL,'2MASX J15582955+2706550',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.623333,27.11533,0.117,NULL,59877809068,935590766,14618605,17.8),(133985,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133985,38.13,0.33,422,63176,70,NULL,NULL,'2MASX J15582989+2225293',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000191,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.624583,22.42483,0.109,NULL,59405338751,928208417,14503256,17.8),(133986,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133986,35.85,0.46,148,63177,70,NULL,NULL,'2MASX J15583083+1925453',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'15.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,239.6285417,19.42922,0.065,NULL,56510437621,882975587,13796493,15.8),(133987,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133987,38.03,0.05,403,63178,70,NULL,NULL,'2MASX J15583149+2721441',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000064,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.631333,27.36214,0.113,NULL,59877281991,935582531,14618477,17.3),(133988,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133988,36.45,0.46,195,63179,70,NULL,NULL,'2MASX J15583151+1355005',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,239.631416667,13.91672,0.089,NULL,56559448881,883741388,13808459,17.2),(133989,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133989,38.03,0.05,403,63180,70,NULL,NULL,'SDSS J155831.65+272310.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000068,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.631917,27.38614,0.113,NULL,59877282589,935582540,14618477,17.9),(133990,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133990,36.25,0.46,178,63181,70,NULL,NULL,'2MASX J15583199+2813331',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000177,NULL,'16.0g',0.39,'E0',NULL,NULL,NULL,NULL,1,239.633375,28.22592,0.109,NULL,59876062532,935563477,14618179,16),(133991,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 1991M',NULL,133991,32.96,0.11,38.9,63182,65,NULL,'MLCS','IC 1151',0.007235,'1996ApJ...473..588R',1996,1,2.5,NULL,'G',0.000004,NULL,'13.49',0.8,'SB(rs)c','Supercluster foreground object',NULL,NULL,NULL,1,239.63475,17.44147,0.061,NULL,56568355047,883880547,13810633,13.49),(133992,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 1991M',NULL,133992,32.95,0.09,38.9,63182,74.4,NULL,NULL,'IC 1151',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133993,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 1991M',NULL,133993,32.96,0.1,39.1,63182,65,NULL,'Snapshot','IC 1151',NULL,'1996ApJ...473...88R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133994,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 1991M',NULL,133994,33.1,0.47,41,63182,67,NULL,NULL,'IC 1151',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133995,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 1991M',NULL,133995,33.11,0.17,41.9,63182,65,NULL,'LCS','IC 1151',NULL,'1995ApJ...445L..91R',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133996,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 1991M',NULL,133996,33.52,0.18,49.8,63182,65,NULL,'MLCS2k2','IC 1151',0.007235,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133997,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133997,31.92,0.36,24.2,63182,NULL,NULL,NULL,'IC 1151',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133998,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133998,32.06,0.43,25.8,63182,75,NULL,'3.6 micron, color + selection bias corrected','IC 1151',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133999,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133999,32.1,0.43,26.3,63182,75,NULL,'3.6 micron, color corrected','IC 1151',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134000,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134000,32.12,0.4,26.5,63182,75,NULL,'HOSTS SN 1991M','IC 1151',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134001,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134001,32.13,0.4,26.7,63182,75,NULL,'HOSTS SN 1991M','IC 1151',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134002,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134002,32.18,0.42,27.3,63182,NULL,18.48,'3.6 micron','IC 1151',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134003,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134003,32.78,0.4,35.9,63182,NULL,NULL,'mean','IC 1151',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134004,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134004,32.85,0.47,37.1,63182,NULL,NULL,'H','IC 1151',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134005,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134005,32.88,0.46,37.7,63182,NULL,NULL,'J','IC 1151',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134006,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134006,32.95,0.09,38.9,63182,74.4,NULL,NULL,'IC 1151',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134007,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134007,33,0.45,39.9,63182,NULL,NULL,'K','IC 1151',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134008,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134008,36.25,0.25,178,63183,74.4,NULL,NULL,'GIN 529',NULL,'2013AJ....146...86T',2013,1,0.61,NULL,'G',0.00008,NULL,'15.7g',0.39,'E/S0',NULL,NULL,NULL,NULL,1,239.634875,17.87147,0.061,NULL,56565122818,883830044,13809844,15.7),(134009,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134009,36.44,0.18,194,63183,70,NULL,NULL,'GIN 529',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134010,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134010,36.64,0.14,212,63183,70,NULL,NULL,'GIN 529',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134011,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134011,39.7,0.46,870,63184,70,NULL,NULL,'SDSS J155832.71+101438.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.9g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.636333333,10.24411,0.101,NULL,56635051354,884922677,13826916,18.9),(134012,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134012,37.81,0.33,364,63185,70,NULL,NULL,'SDSS J155833.99+194223.3',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,239.641625,19.7065,0.069,NULL,59403403464,928178179,14502784,NULL),(134013,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134013,38.03,0.05,403,63186,70,NULL,NULL,'SDSS J155834.29+270718.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000063,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,239.642875,27.12183,0.117,NULL,59877808475,935590757,14618605,18.6),(134014,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134014,37.42,0.33,305,63187,70,NULL,NULL,'2MASX J15583424+2946501',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000149,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.642958333,29.78053,0.085,NULL,59869262634,935457228,14616519,17.4),(134015,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134015,35.73,0.27,140,63188,70,NULL,NULL,'CGCG 167-008',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000133,NULL,'14.8g',0.62,'E0',NULL,NULL,NULL,NULL,1,239.645,27.61825,0.105,NULL,59877250347,935582036,14618469,14.8),(134016,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134016,36.74,0.46,223,63189,70,NULL,NULL,'2MASX J15583501+2317353',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000164,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,239.645875,23.29325,0.149,NULL,59406565531,928227586,14503556,17.7),(134017,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134017,38.24,0.46,444,63190,70,NULL,NULL,'SDSS J155835.30+500538.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000143,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.647125,50.094,0.009,NULL,59724809317,933200145,14581252,18.4),(134018,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134018,36.56,0.46,205,63191,70,NULL,NULL,'2MASX J15583625+3220516',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000166,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,239.651083,32.34764,0.061,NULL,59886533291,935727082,14620735,16.8),(134019,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134019,37.11,0.33,264,63192,70,NULL,NULL,'2MASX J15583652+3517586',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000139,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.652333333,35.29956,0.021,NULL,59767634121,933869283,14591707,17.6),(134020,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134020,36.64,0.14,212,63193,70,NULL,NULL,'2MASX J15583701+1802323',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000195,NULL,'15.9g',0.32,NULL,NULL,NULL,NULL,NULL,1,239.654375,18.04236,0.061,NULL,56564928927,883827014,13809797,15.9),(134021,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134021,37.81,0.33,364,63194,70,NULL,NULL,'SDSS J155838.93+194245.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.66225,19.71275,0.069,NULL,59401306313,928145411,14502272,18.3),(134022,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134022,38.01,0.46,399,63195,70,NULL,NULL,'SDSS J155839.06+362009.2',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000142,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.66275,36.33592,0.029,NULL,59776150946,934002358,14593786,18),(134023,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134023,36.19,0.46,173,63196,70,NULL,NULL,'2MASX J15583932+0515578',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000146,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,239.663917,5.26617,0.189,NULL,56611187883,884549810,13821090,16.9),(134024,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134024,35.73,0.27,140,63197,70,NULL,NULL,'2MASX J15584005+2734581',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.00019,NULL,'15.9g',0.25,'S0/a',NULL,NULL,NULL,NULL,1,239.6669583,27.58289,0.125,NULL,59877257249,935582144,14618471,15.9),(134025,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134025,36.5,0.46,200,63198,70,NULL,NULL,'2MASX J15584012+3524196',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000188,NULL,'16.1g',0.24,'Sa',NULL,NULL,NULL,NULL,1,239.667333,35.40539,0.021,NULL,59767349966,933864843,14591638,16.1),(134026,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134026,36.92,0.46,243,63199,70,NULL,NULL,'2MASX J15584103+5425024',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000091,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,239.670916667,54.41725,NULL,NULL,57605586993,900087296,14063864,16.3),(134027,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134027,37.61,0.46,333,63200,70,NULL,NULL,'SDSS J155841.83+273737.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000085,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.674291667,27.62711,0.125,NULL,59877257863,935582154,14618471,18.5),(134028,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134028,38.03,0.05,403,63201,70,NULL,NULL,'2MASX J15584357+2720070',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00006,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,239.681625,27.33528,0.113,NULL,59877237149,935581830,14618466,17.7),(134029,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134029,37.89,0.46,378,63202,70,NULL,NULL,'2MASX J15584431+2005003',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.684708333,20.08356,0.061,NULL,59401355323,928146176,14502284,17.5),(134030,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134030,37.71,0.46,348,63203,70,NULL,NULL,'SDSS J155845.12+170929.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000129,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.688,17.15814,0.061,NULL,56568566898,883883857,13810685,18.3),(134031,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134031,38.03,0.05,403,63204,70,NULL,NULL,'2MASX J15584536+2711520',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000075,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,239.688833,27.19781,0.117,NULL,59877807251,935590738,14618605,16.8),(134032,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134032,37.82,0.09,366,63205,70,NULL,NULL,'2MASX J15584546+2638510',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,'PHOT','16.3g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,239.68925,26.64767,0.153,NULL,59877090251,935579535,14618430,16.3),(134033,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134033,37.38,0.33,299,63206,70,NULL,NULL,'2MASX J15584717+0349298',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,239.6965,3.82489,0.245,NULL,56482213337,882534583,13789602,17.1),(134034,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134034,35.72,0.46,139,63207,70,NULL,NULL,'2MASX J15584737+1911423',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000103,NULL,'16.53',0.42,'S',NULL,NULL,NULL,NULL,1,239.6972917,19.19497,0.065,NULL,56510545812,882977278,13796519,16.53),(134035,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134035,35.59,0.33,131,63208,70,NULL,NULL,'CGCG 079-016',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000153,NULL,'15.4',0.45,NULL,NULL,NULL,NULL,NULL,1,239.698708333,14.20375,0.101,NULL,56558468662,883726072,13808219,15.4),(134036,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134036,37.85,0.46,372,63209,70,NULL,NULL,'2MASX J15584776+5331212',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000103,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,239.69875,53.52264,NULL,NULL,59698149062,932783579,14574743,16.9),(134037,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134037,36.64,0.14,212,63210,70,NULL,NULL,'2MASX J15584781+1759153',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000199,NULL,'16.5g',0.32,'E',NULL,NULL,NULL,NULL,1,239.699333,17.98756,0.061,NULL,56564951926,883827373,13809802,16.5),(134038,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134038,37.82,0.09,366,63211,70,NULL,NULL,'SDSS J155848.28+262626.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.7012083,26.44081,0.165,NULL,59876986459,935577913,14618404,18.2),(134039,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134039,37.38,0.33,299,63212,70,NULL,NULL,'2MASX J15584897+0357278',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000202,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.704125,3.95764,0.249,NULL,56482264286,882535379,13789615,17.9),(134040,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134040,36.55,0.46,204,63213,70,NULL,NULL,'2MASX J15584897+1234205',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.704125,12.57236,0.069,NULL,56556214319,883690848,13807669,17.3),(134041,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134041,38.55,0.46,513,63214,70,NULL,NULL,'2MASX J15584917+3230072',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000185,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,239.7047083,32.50208,0.061,NULL,59886379513,935724679,14620698,17.4),(134042,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134042,38.84,0.46,585,63215,70,NULL,NULL,'2MASX J15585141+3734533',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.71425,37.58147,0.025,NULL,59763074310,933798036,14590594,18),(134043,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134043,37.83,0.27,368,63216,70,NULL,NULL,'SDSS J155852.13+200745.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.7172083,20.12936,0.061,NULL,59401552174,928149252,14502332,18.3),(134044,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134044,37.82,0.09,366,63217,70,NULL,NULL,'2MASX J15585266+2626183',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000198,NULL,'15.8g',0.48,NULL,NULL,NULL,NULL,NULL,1,239.719417,26.43861,0.165,NULL,59876986409,935577912,14618404,15.8),(134045,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134045,35.45,0.49,123,63218,75,NULL,'IR','CGCG 108-031',NULL,'2011yCatp016004901K',2011,1,0.6,NULL,'G',0.00001,NULL,'15.6',0.15,'S..','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,239.7254583,14.9815,0.097,NULL,56559003968,883734437,13808350,15.6),(134046,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134046,35.95,0.32,155,63218,NULL,NULL,'Malmquist cor.','CGCG 108-031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134047,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134047,36.04,0.31,161,63218,NULL,NULL,NULL,'CGCG 108-031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134048,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134048,36.08,0.2,164,63218,74.4,NULL,NULL,'CGCG 108-031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134049,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134049,37.83,0.27,368,63219,70,NULL,NULL,'2MASX J15585474+2005111',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000198,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,239.728,20.08636,0.061,NULL,59401327177,928145737,14502277,16.7),(134050,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134050,36.24,0.46,177,63220,70,NULL,NULL,'2MASX J15585557+2046372',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.731625,20.77697,0.097,NULL,59401829918,928153592,14502399,17.3),(134051,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134051,36.45,0.33,195,63221,70,NULL,NULL,'2MASX J15585564+2505213',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000183,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,239.731958333,25.08928,0.169,NULL,59863382245,935365347,14615083,16.7),(134052,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134052,38.03,0.05,403,63222,70,NULL,NULL,'2MASX J15585573+2716403',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000062,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,239.732167,27.27786,0.117,NULL,59877759546,935589992,14618593,17.7),(134053,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134053,38.03,0.05,403,63223,70,NULL,NULL,'2MASX J15585639+2733433',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000088,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.735083333,27.562,0.125,NULL,59877287480,935582616,14618478,18.1),(134054,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134054,35.96,0.33,156,63224,70,NULL,NULL,'CGCG 250-031',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000147,NULL,'15.3g',0.42,'E0',NULL,NULL,NULL,NULL,1,239.736708333,44.76439,0.041,NULL,59684351345,932567989,14571374,15.3),(134055,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134055,37.19,0.46,274,63225,70,NULL,NULL,'2MASX J15585696+0619550',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.73725,6.33186,0.145,NULL,56628042426,884813162,13825205,17.8),(134056,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134056,37.82,0.09,366,63226,70,NULL,NULL,'SDSS J155900.47+263017.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,239.752,26.50475,0.153,NULL,59877062072,935579094,14618423,18.7),(134057,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134057,36.47,0.46,197,63227,70,NULL,NULL,'CGCG 250-032',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000087,NULL,'15.1g',0.51,'E0',NULL,NULL,NULL,NULL,1,239.754291667,46.02336,0.041,NULL,59684649383,932572646,14571447,15.1),(134058,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134058,36.55,0.46,205,63228,70,NULL,NULL,'2MASX J15590200+0223038',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00008,NULL,'17.1g',0.19,'NLAGN',NULL,NULL,NULL,NULL,1,239.758375,2.38431,0.297,NULL,56488574085,882633970,13791155,17.1),(134059,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134059,36.87,0.46,236,63229,70,NULL,NULL,'2MASX J15590264+1109240',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,239.760958333,11.15656,0.113,NULL,56632147017,884877297,13826207,16.2),(134060,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134060,36.86,0.46,236,63230,70,NULL,NULL,'2MASX J15590324+2751173',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000147,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,239.7634583,27.85497,0.097,NULL,59876280577,935566884,14618232,17),(134061,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134061,37.83,0.27,368,63231,70,NULL,NULL,'2MASX J15590340+2003102',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000146,NULL,'18.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,239.764208333,20.05281,0.061,NULL,59401330622,928145790,14502277,18.1),(134062,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134062,37.53,0.46,321,63232,70,NULL,NULL,'SDSS J155903.74+450113.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.765625,45.0205,0.037,NULL,59684338366,932567786,14571371,18.5),(134063,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134063,38.03,0.05,403,63233,70,NULL,NULL,'SDSS J155904.42+271606.8',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000072,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,239.768417,27.26856,0.117,NULL,59877767937,935590124,14618595,17.2),(134064,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134064,36.64,0.14,212,63234,70,NULL,NULL,'2MASX J15590469+1759513',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,239.769625,17.99764,0.061,NULL,56564948522,883827320,13809801,17.2),(134065,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134065,37.75,0.46,354,63235,70,NULL,NULL,'2MASX J15590777+2931433',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000137,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.782541667,29.52883,0.089,NULL,59869488201,935460753,14616574,18.3),(134066,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134066,36.69,0.46,218,63236,70,NULL,NULL,'2MASX J15590901+2437373',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000139,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.7875,24.62689,0.173,NULL,59863330999,935364546,14615071,17.5),(134067,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134067,38.03,0.05,403,63237,70,NULL,NULL,'2MASX J15590944+2655093',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000077,NULL,'17.3g',0.21,'BrClG',NULL,NULL,NULL,NULL,1,239.789417,26.91942,0.117,NULL,59876923050,935576922,14618389,17.3),(134068,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134068,36.83,0.27,232,63238,70,NULL,NULL,'2MASX J15590949+0247590',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000104,NULL,'15.5g',0.58,'S0^-',NULL,NULL,NULL,NULL,1,239.7897083,2.79958,0.285,NULL,56488387067,882631047,13791110,15.5),(134069,'Ring Diameter','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134069,33.3,0.84,46,63239,NULL,NULL,'Published at H = 100 km/s/Mpc','UGC 10120',NULL,'1981ApJS...45..541P',1981,1,0.81,NULL,'G',0.000117,NULL,'14.5g',0.67,'SB(r)b         Sy1','Isolated galaxy',NULL,NULL,'Sy 1',1,239.790125,35.02986,0.057,NULL,59767547842,933867935,14591686,14.5),(134070,'Black Hole','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134070,33.96,1.51,62,63239,NULL,NULL,NULL,'UGC 10120',NULL,'2014ApJ...793..108W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134071,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134071,35.21,0.65,110,63240,70,NULL,NULL,'2MFGC 12821',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'17.34',0.3,NULL,NULL,NULL,NULL,NULL,1,239.791417,-7.67194,0.533,NULL,45628405675,712943838,11139747,17.34),(134072,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134072,36.83,0.27,232,63241,70,NULL,NULL,'2MASX J15591010+0248570',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00009,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,239.792166667,2.81583,0.285,NULL,56486302542,882598477,13790601,16.9),(134073,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134073,36.37,0.46,188,63242,70,NULL,NULL,'2MASX J15591081+0710310',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000172,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,239.795125,7.17522,0.153,NULL,56631474600,884866790,13826043,16.6),(134074,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134074,37.34,0.46,294,63243,70,NULL,NULL,'SDSS J155912.03+205822.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'18.0g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.800167,20.97303,0.101,NULL,59401749708,928152339,14502380,18),(134075,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134075,38.03,0.05,403,63244,70,NULL,NULL,'2MASX J15591244+2705593',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000089,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,239.8017917,27.09969,0.117,NULL,59876905232,935576644,14618385,17.1),(134076,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134076,35.19,0.73,109,63245,70,NULL,NULL,'2MASX J15591328-3040067',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.000083,NULL,'15.85',0.3,'Sa',NULL,NULL,NULL,NULL,1,239.80525,-30.66856,0.713,NULL,47119842875,736247544,11503867,15.85),(134077,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134077,36.83,0.27,232,63246,70,NULL,NULL,'SDSS J155914.11+024715.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000084,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,239.808833333,2.78761,0.285,NULL,56488389905,882631092,13791110,18.5),(134078,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134078,38.03,0.05,403,63247,70,NULL,NULL,'2MASX J15591464+2717243',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000065,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,239.811167,27.29,0.117,NULL,59877754195,935589909,14618592,17.1),(134079,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134079,38.67,0.46,541,63248,70,NULL,NULL,'2MASX J15591486+3944131',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.811916667,39.73692,0.017,NULL,59796064363,934313505,14598648,18),(134080,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134080,36.82,0.46,231,63249,70,NULL,NULL,'2MASX J15591539+0513200',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000171,NULL,'16.1g',0.36,'BrClG',NULL,NULL,NULL,NULL,1,239.814041667,5.22211,0.165,NULL,56611223355,884550364,13821099,16.1),(134081,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134081,35.59,0.46,131,63250,70,NULL,NULL,'CGCG 108-034',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000233,NULL,'15.2',0.6,'E:','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,239.815833,15.1765,0.081,NULL,56558944495,883733507,13808336,15.2),(134082,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134082,37.33,0.46,292,63251,70,NULL,NULL,'2MASX J15591650+4007581',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000135,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.818625,40.13286,0.025,NULL,59795399291,934303113,14598486,17.7),(134083,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134083,36.97,0.46,247,63252,70,NULL,NULL,'2MASX J15591766+4645368',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,239.823667,46.76017,0.029,NULL,59713577730,933024652,14578510,17.2),(134084,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134084,37.58,0.46,329,63253,70,NULL,NULL,'2MASX J15591773+3619591',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00018,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,239.823791667,36.33297,0.029,NULL,59775962231,933999409,14593740,17.7),(134085,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134085,38.03,0.05,403,63254,70,NULL,NULL,'2MASX J15591875+2720029',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000074,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,239.8280417,27.33414,0.113,NULL,59877230929,935581733,14618464,17.2),(134086,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134086,37.92,0.46,384,63255,70,NULL,NULL,'2MASX J15591981+0334550',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000091,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.8327083,3.58189,0.257,NULL,56481928112,882530126,13789533,17.7),(134087,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134087,37.84,0.33,370,63256,70,NULL,NULL,'2MASX J15592051+3000504',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,239.8355,30.01389,0.081,NULL,59869246869,935456982,14616515,17.2),(134088,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134088,37.19,0.46,274,63257,70,NULL,NULL,'2MASX J15592099+2907009',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000178,NULL,'16.8g',0.29,'E',NULL,NULL,NULL,NULL,1,239.837375,29.117,0.077,NULL,59868541434,935445959,14616343,16.8),(134089,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134089,35.95,0.2,155,63258,74.4,NULL,NULL,'SDSS J155921.15+150821.4',NULL,'2013AJ....146...86T',2013,1,0.42,NULL,'G',0.000028,NULL,'16.89',0.27,'Sd',NULL,NULL,NULL,NULL,1,239.838125,15.13928,0.081,NULL,56558683710,883729432,13808272,16.89),(134090,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134090,35.98,0.34,157,63258,NULL,NULL,NULL,'SDSS J155921.15+150821.4',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134091,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134091,36.05,0.33,162,63258,NULL,NULL,'Malmquist cor.','SDSS J155921.15+150821.4',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134092,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134092,38.03,0.05,403,63259,70,NULL,NULL,'2MASX J15592139+2711479',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00007,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.83925,27.19653,0.117,NULL,59876915262,935576800,14618387,17.6),(134093,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134093,38.75,0.46,563,63260,70,NULL,NULL,'2MASX J15592286+1526557',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.84525,15.44886,0.069,NULL,56570599494,883915617,13811181,17.5),(134094,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134094,38.03,0.05,403,63261,70,NULL,NULL,'2MASX J15592287+2720479',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000064,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.8452917,27.34667,0.113,NULL,59877232008,935581750,14618464,18.5),(134095,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134095,35.31,0.46,115,63262,70,NULL,NULL,'2MASX J15592314+2901019',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000113,NULL,'15.9g',0.3,'S0',NULL,NULL,NULL,NULL,1,239.846375,29.01708,0.077,NULL,59868564921,935446326,14616348,15.9),(134096,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134096,35.73,0.56,140,63263,NULL,NULL,'Malmquist cor.','ESO 515- G 018',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.48',0.3,'S              HII',NULL,NULL,NULL,NULL,1,239.849375,-25.343,0.433,NULL,47112448651,736132010,11502062,14.48),(134097,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134097,35.74,0.55,141,63263,NULL,NULL,NULL,'ESO 515- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134098,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134098,35.78,0.2,143,63263,74.4,NULL,NULL,'ESO 515- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134099,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134099,38.03,0.05,403,63264,70,NULL,NULL,'2MASX J15592393+2715169',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000076,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.849667,27.25478,0.117,NULL,59877755262,935589925,14618592,17.5),(134100,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134100,35.38,0.46,119,63265,70,NULL,NULL,'2MASX J15592462+0332200',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000097,NULL,'15.9g',0.33,'S0^-',NULL,NULL,NULL,NULL,1,239.8525,3.53903,0.257,NULL,56481914358,882529911,13789529,15.9),(134101,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134101,37.15,0.46,269,63266,70,NULL,NULL,'SDSS J155924.72+171657.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000168,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.8530417,17.28253,0.049,NULL,56568497482,883882773,13810668,18),(134102,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134102,36.51,0.46,200,63267,70,NULL,NULL,'2MASX J15592559+4215488',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000196,NULL,'15.5g',0.49,'E','Field galaxy',NULL,NULL,NULL,1,239.8565,42.26347,0.029,NULL,59807722491,934495663,14601494,15.5),(134103,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134103,37.11,0.33,264,63268,70,NULL,NULL,'2MASX J15592734+3753251',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000163,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,239.864,37.89025,0.009,NULL,59763304806,933801637,14590650,16.9),(134104,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134104,37.82,0.09,366,63269,70,NULL,NULL,'2MASX J15592802+2639320',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.866791667,26.65894,0.153,NULL,59877084357,935579443,14618428,17.4),(134105,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134105,37.57,0.33,326,63270,70,NULL,NULL,'2MASX J15592872+1951496',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000174,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,239.869625,19.86383,0.065,NULL,56512272727,883004261,13796941,16.8),(134106,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134106,36.9,0.33,240,63271,70,NULL,NULL,'2MASX J15592919+3314324',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,239.871625,33.24242,0.073,NULL,59765255089,933832110,14591126,17.2),(134107,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134107,36.64,0.27,212,63272,70,NULL,NULL,'2MASX J15592961+2744080',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000193,NULL,'16.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,239.8735417,27.73547,0.097,NULL,59876161256,935565019,14618203,16.4),(134108,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134108,38.56,0.46,516,63273,70,NULL,NULL,'2MASX J15593070+2646160',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.878,26.77117,0.137,NULL,59877070561,935579227,14618425,17.8),(134109,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134109,37.73,0.33,351,63274,70,NULL,NULL,'2MASX J15593160+2101106',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000197,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,239.881583,21.01961,0.113,NULL,59401739924,928152186,14502377,16.6),(134110,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134110,38,0.46,398,63275,70,NULL,NULL,'SDSS J155933.51+201923.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.889625,20.32331,0.077,NULL,59401423161,928147236,14502300,18.4),(134111,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134111,37.49,0.46,315,63276,70,NULL,NULL,'2MASX J15593453+3915272',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,239.893833333,39.25736,0.013,NULL,59795650697,934307042,14598547,17.8),(134112,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134112,36.64,0.14,212,63277,70,NULL,NULL,'2MASX J15593490+1759516',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000205,NULL,'16.0g',0.33,NULL,NULL,NULL,NULL,NULL,1,239.8955417,17.99764,0.061,NULL,56567851209,883872675,13810510,16),(134113,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134113,38.2,0.46,436,63278,70,NULL,NULL,'2MASX J15593502+0639076',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.896083333,6.65211,0.113,NULL,56627959484,884811866,13825185,17.8),(134114,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134114,37.82,0.09,366,63279,70,NULL,NULL,'2MASX J15593525+2634290',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,239.896958333,26.57486,0.153,NULL,59877053093,935578954,14618421,18.2),(134115,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134115,36.29,0.33,181,63280,70,NULL,NULL,'2MASX J15593525+2459190',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000163,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,239.8970417,24.98872,0.149,NULL,59864190530,935377977,14615280,16.5),(134116,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134116,37.11,0.33,264,63281,70,NULL,NULL,'2MASX J15593630+3747044',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000183,NULL,'16.1g',0.38,'E0',NULL,NULL,NULL,NULL,1,239.901333,37.78464,0.009,NULL,59763087892,933798248,14590597,16.1),(134117,'IRAS','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134117,32.48,0.8,31.3,63282,75,NULL,'MAT, I','ESO 009- G 001',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'13.20',0.6,'SAB(s)b:',NULL,NULL,NULL,NULL,1,239.902833,-82.91581,0.381,NULL,44046130647,688220791,10753449,13.2),(134118,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134118,32.51,0.32,31.7,63282,85,NULL,'I, inv','ESO 009- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134119,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134119,32.51,0.32,31.8,63282,85,NULL,'I, raw','ESO 009- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134120,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134120,32.54,0.4,32.2,63282,NULL,NULL,NULL,'ESO 009- G 001',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134121,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134121,32.54,0.39,32.2,63282,73,NULL,'opt','ESO 009- G 001',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134122,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134122,32.91,0.43,38.2,63282,75,NULL,'MAT, I, raw','ESO 009- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134123,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134123,32.95,0.43,39,63282,75,NULL,'MAT, I, inv','ESO 009- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134124,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134124,33.08,0.43,41.3,63282,75,NULL,'MAT, I, cor','ESO 009- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134125,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134125,37.06,0.46,258,63283,70,NULL,NULL,'2MASX J15593959+3110004',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000179,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,239.915083,31.16689,0.049,NULL,59865398211,935396847,14615575,16.7),(134126,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134126,37.82,0.09,366,63284,70,NULL,NULL,'2MASX J15594010+2632560',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000196,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,239.917125,26.54894,0.153,NULL,59876876770,935576199,14618378,17.4),(134127,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134127,37.84,0.46,370,63285,70,NULL,NULL,'2MASX J15594057+5450512',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000072,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,239.919417,54.84744,0.005,NULL,57605106513,900079789,14063746,17.3),(134128,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134128,37.89,0.46,379,63286,70,NULL,NULL,'SDSS J155941.01+070658.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.920875,7.11625,0.153,NULL,56631248949,884863264,13825988,18.2),(134129,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134129,37.82,0.09,366,63287,70,NULL,NULL,'2MASX J15594166+2629580',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.0g',0.41,'BrClG',NULL,NULL,NULL,NULL,1,239.923708333,26.4995,0.153,NULL,59876879407,935576240,14618378,16),(134130,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134130,37.84,0.33,370,63288,70,NULL,NULL,'2MASX J15594176+3001314',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.924041667,30.0255,0.081,NULL,59868789703,935449839,14616403,17.6),(134131,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134131,36.29,0.33,181,63289,70,NULL,NULL,'SDSS J155942.00+250239.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.9250417,25.04425,0.149,NULL,59864200641,935378135,14615283,17.9),(134132,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134132,37.73,0.33,351,63290,70,NULL,NULL,'2MASX J15594203+2101587',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000159,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.925083333,21.03308,0.129,NULL,59400872401,928138631,14502166,17.8),(134133,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134133,37.57,0.33,326,63291,70,NULL,NULL,'SDSS J155942.69+195102.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000137,NULL,'17.7g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.927875,19.85058,0.065,NULL,56512267615,883004181,13796940,17.7),(134134,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134134,38.54,0.46,510,63292,70,NULL,NULL,'2MASX J15594321+3521474',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000151,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,239.9302083,35.36314,0.021,NULL,59767509143,933867330,14591677,17.4),(134135,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134135,36.64,0.27,212,63293,70,NULL,NULL,'2MASX J15594391+2742299',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000217,NULL,'16.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,239.9330417,27.70825,0.097,NULL,59876157890,935564967,14618202,16.4),(134136,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134136,38.05,0.46,408,63294,70,NULL,NULL,'SDSS J155944.69+271919.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000099,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.93625,27.322,0.113,NULL,59876573216,935571456,14618304,18.5),(134137,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134137,34.58,0.69,82.3,63295,100,NULL,'mid-IR','UGC 10121',NULL,'2013ApJ...771...88L',2013,1,1.1,NULL,'G',0.000027,NULL,'14.50',0.6,'SAB(rs)bc','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,239.940833,18.80108,0.061,NULL,56513718784,883026856,13797294,14.5),(134138,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134138,35.54,0.2,128,63295,74.4,NULL,NULL,'UGC 10121',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134139,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134139,35.64,0.4,134,63295,NULL,NULL,'mean','UGC 10121',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134140,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134140,35.79,0.47,144,63295,NULL,NULL,'H','UGC 10121',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134141,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134141,35.89,0.3,151,63295,NULL,NULL,'Malmquist cor.','UGC 10121',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134142,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134142,36.22,0.26,175,63295,NULL,NULL,NULL,'UGC 10121',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134143,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134143,35.59,0.27,131,63296,70,NULL,NULL,'CGCG 051-016',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.000126,NULL,'14.4g',0.8,'S0',NULL,NULL,NULL,NULL,1,239.9457083,2.71275,0.285,NULL,56488410930,882631420,13791115,14.4),(134144,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134144,37.82,0.09,366,63297,70,NULL,NULL,'2MASX J15594755+2633339',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000172,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,239.9482083,26.55953,0.153,NULL,59876877152,935576205,14618378,17.1),(134145,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134145,36.64,0.14,212,63298,70,NULL,NULL,'2MASX J15594829+1805147',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.951083,18.08756,0.061,NULL,56567805296,883871957,13810499,17.1),(134146,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134146,38.03,0.05,403,63299,70,NULL,NULL,'2MASX J15594933+2722463',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000072,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.955583,27.37942,0.113,NULL,59876118260,935564347,14618192,17.6),(134147,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134147,35.59,0.27,131,63300,70,NULL,NULL,'CGCG 051-017',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000114,NULL,'15.3g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,239.957041667,2.66722,0.285,NULL,56488397675,882631213,13791112,15.3),(134148,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134148,36.43,0.46,193,63301,70,NULL,NULL,'IC 4587',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000143,NULL,'15.5g',0.51,'E',NULL,NULL,NULL,NULL,1,239.9650417,25.94064,0.125,NULL,59875033795,935547403,14617928,15.5),(134149,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134149,38.19,0.27,435,63302,70,NULL,NULL,'2MASX J15595389+2021326',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000153,NULL,'17.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,239.974625,20.359,0.077,NULL,59401434645,928147416,14502303,17.1),(134150,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134150,35.96,0.33,156,63303,70,NULL,NULL,'B3 1558+448',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000189,NULL,'15.4g',0.5,'E0',NULL,NULL,NULL,NULL,1,239.9749583,44.709,0.041,NULL,59684310111,932567345,14571364,15.4),(134151,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134151,32.21,NULL,27.7,63304,72,NULL,NULL,'SDSS J155955.46+065302.7',NULL,'2014Ap.....57..457K',2014,1,0.32,NULL,'G',0.000067,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.981083,6.88408,0.153,NULL,56631102931,884860983,13825952,18),(134152,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134152,37.04,0.46,256,63305,70,NULL,NULL,'2MASX J15595691+2624283',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000092,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,239.987,26.40786,0.165,NULL,59876876136,935576189,14618377,16.7),(134153,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134153,37.88,0.46,376,63306,70,NULL,NULL,'2MASX J15595766+2618503',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000177,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,239.990375,26.31408,0.165,NULL,59875028465,935547319,14617926,16.9),(134154,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134154,35.84,0.4,147,63307,NULL,NULL,'mean','CGCG 108-037',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000023,NULL,'15.55',0.3,'SAb pec sp','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,239.994417,15.59136,0.057,NULL,56570638195,883916221,13811190,15.55),(134155,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134155,35.95,0.31,155,63307,NULL,NULL,'Malmquist cor.','CGCG 108-037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134156,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134156,36.06,0.47,163,63307,NULL,NULL,'H','CGCG 108-037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134157,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134157,36.08,0.45,164,63307,NULL,NULL,'K','CGCG 108-037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134158,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134158,36.19,0.49,173,63307,75,NULL,'IR','CGCG 108-037',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134159,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134159,36.32,0.2,184,63307,74.4,NULL,NULL,'CGCG 108-037',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134160,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134160,36.32,0.26,184,63307,NULL,NULL,NULL,'CGCG 108-037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134161,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134161,36.64,0.27,212,63308,70,NULL,NULL,'2MASX J15595938+2740563',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000153,NULL,'16.2g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,239.997375,27.68219,0.097,NULL,59876166748,935565105,14618204,16.2),(134162,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134162,37.59,0.46,330,63309,70,NULL,NULL,'2MASX J16000055+5301572',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000083,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.0024583,53.0325,NULL,NULL,59698198269,932784347,14574755,17.8),(134163,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134163,38.08,0.46,412,63310,70,NULL,NULL,'2MASX J16000087+3434048',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000169,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,240.0035,34.56803,0.053,NULL,59768190186,933877971,14591843,16.6),(134164,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134164,38.13,0.17,423,63311,70,NULL,NULL,'SDSS J160003.05+332829.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000143,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.0127083,33.47486,0.057,NULL,59765335250,933833363,14591146,18.1),(134165,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134165,38.8,0.46,576,63312,70,NULL,NULL,'2MASX J16000342+5347582',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00009,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,240.014333,53.79964,NULL,NULL,57604983004,900077859,14063716,18.1),(134166,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134166,38.03,0.05,403,63313,70,NULL,NULL,'2MASX J16000368+2712323',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000093,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.015417,27.20903,0.117,NULL,59876457325,935569645,14618275,17.2),(134167,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134167,37.98,0.46,394,63314,70,NULL,NULL,'2MASX J16000430+4559091',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000181,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.018083,45.986,0.041,NULL,59681116146,932517439,14570584,17.2),(134168,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134168,36.42,0.46,192,63315,70,NULL,NULL,'2MASX J16000506+0336067',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.021,3.60189,0.245,NULL,56483823779,882559746,13789996,17.2),(134169,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134169,37.77,0.46,358,63316,70,NULL,NULL,'SDSS J160005.38+340522.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00014,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,240.022417,34.08969,0.061,NULL,59768254356,933878974,14591858,18.2),(134170,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134170,37.3,0.46,289,63317,70,NULL,NULL,'2MASX J16000562+4236181',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000146,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.023208333,42.60514,0.013,NULL,59807809806,934497028,14601516,17.6),(134171,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134171,37.68,0.46,343,63318,70,NULL,NULL,'2MASX J16000672+0327577',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000075,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,240.027917,3.46586,0.257,NULL,56483861914,882560342,13790005,18.1),(134172,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134172,35.59,0.43,131,63319,NULL,NULL,NULL,'2MASX J16000693+1501109',NULL,'2009ApJS..182..474S',2009,1,1.07,NULL,'G',0.000014,NULL,'16.0g',0.2,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,240.028833,15.01981,0.081,NULL,56558732077,883730188,13808284,16),(134173,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134173,35.64,0.2,134,63319,74.4,NULL,NULL,'2MASX J16000693+1501109',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134174,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134174,35.76,0.4,142,63319,NULL,NULL,'Malmquist cor.','2MASX J16000693+1501109',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134175,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134175,38.19,0.27,435,63320,70,NULL,NULL,'SDSS J160006.91+201936.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000158,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.028833,20.32678,0.077,NULL,59401433726,928147401,14502303,18.7),(134176,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134176,36.24,0.46,177,63321,70,NULL,NULL,'2MASX J16000799+1819006',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000103,NULL,'15.8g',0.36,'S',NULL,NULL,NULL,NULL,1,240.0332083,18.31683,0.061,NULL,56513542655,883024103,13797251,15.8),(134177,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134177,36.56,0.46,205,63322,70,NULL,NULL,'2MASX J16000841+0420507',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.035125,4.34753,0.221,NULL,56484423182,882569112,13790142,17.3),(134178,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134178,36.76,0.33,225,63323,70,NULL,NULL,'2MASX J16000916+0555327',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,240.0382083,5.92567,0.177,NULL,56611445074,884553829,13821153,16.7),(134179,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134179,37.82,0.09,366,63324,70,NULL,NULL,'SDSS J160009.23+264919.9',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,240.0385,26.82219,0.137,NULL,59877066468,935579163,14618424,17.9),(134180,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134180,36.83,0.46,232,63325,70,NULL,NULL,'SDSS J160009.63+182302.3',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000176,NULL,'16.0g',0.38,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.040125,18.38397,0.057,NULL,56513587435,883024803,13797262,16),(134181,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134181,37.82,0.09,366,63326,70,NULL,NULL,'SDSS J160010.04+263319.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,240.041833,26.55553,0.153,NULL,59876887189,935576362,14618380,18.4),(134182,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134182,37.82,0.09,366,63327,70,NULL,NULL,'2MASX J16001121+2629283',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000131,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,240.046583,26.49114,0.153,NULL,59876899619,935576556,14618383,18.2),(134183,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134183,37.82,0.09,366,63328,70,NULL,NULL,'SDSS J160012.03+260634.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000164,NULL,'18.3g',0.1,NULL,NULL,NULL,NULL,NULL,1,240.050125,26.10953,0.141,NULL,59875039086,935547485,14617929,18.3),(134184,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134184,38.28,0.33,454,63329,70,NULL,NULL,'2MASX J16001217+0952478',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,240.050625,9.88003,0.101,NULL,56634509146,884914205,13826784,16.8),(134185,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134185,36.04,0.46,162,63330,70,NULL,NULL,'2MASX J16001313+2924563',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000168,NULL,'16.1g',0.34,'S0',NULL,NULL,NULL,NULL,1,240.05475,29.41564,0.081,NULL,59869391293,935459238,14616550,16.1),(134186,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134186,36.76,0.46,225,63331,70,NULL,NULL,'2MASXi J1600131+462638',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.055167,46.44411,0.025,NULL,59681051431,932516428,14570569,17),(134187,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134187,34.94,0.54,97.2,63332,70,NULL,NULL,'2MASX J16001409-0655056',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00006,NULL,'15.6',NULL,NULL,NULL,NULL,NULL,NULL,1,240.05875,-6.91819,0.537,NULL,45626308665,712911072,11139235,15.6),(134188,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134188,36.44,0.18,194,63333,70,NULL,NULL,'VV 156 NED02',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.0001,NULL,'14.87',NULL,'E/S0',NULL,NULL,NULL,NULL,1,240.0622083,18.37572,0.057,NULL,56513533678,883023963,13797249,14.87),(134189,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134189,37.55,0.25,324,63333,74.4,NULL,NULL,'VV 156 NED02',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134190,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134190,36,0.46,158,63334,70,NULL,NULL,'2MASX J16001493+4306341',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000175,NULL,'15.6g',0.48,'E','Field galaxy',NULL,NULL,NULL,1,240.0622083,43.10958,0.025,NULL,59803524405,934430068,14600469,15.6),(134191,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134191,36.96,0.76,246,63335,70,NULL,NULL,'2MASX J16001534-0108090',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.8I',0.2,NULL,NULL,NULL,NULL,NULL,1,240.063917,-1.13589,0.437,NULL,45526327606,711348868,11114826,14.8),(134192,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134192,38.28,0.33,454,63336,70,NULL,NULL,'SDSS J160015.94+095403.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.0664583,9.90106,0.101,NULL,56633985362,884906021,13826656,18),(134193,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134193,36.76,0.33,225,63337,70,NULL,NULL,'2MASX J16001607+0557337',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000185,NULL,'16.1g',0.35,'E0',NULL,NULL,NULL,NULL,1,240.066875,5.95933,0.177,NULL,56611453079,884553954,13821155,16.1),(134194,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134194,38.24,0.46,444,63338,70,NULL,NULL,'2MASX J16001631+2204186',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.068,22.07181,0.133,NULL,59405406914,928209483,14503273,17.6),(134195,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134195,38.19,0.27,435,63339,70,NULL,NULL,'2MASX J16001665+2019577',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000181,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,240.069541667,20.33281,0.077,NULL,59401381960,928146593,14502290,16.8),(134196,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134196,35.73,0.27,140,63340,70,NULL,NULL,'2MASX J16001706+2735563',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000158,NULL,'16.2g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,240.0712083,27.59908,0.125,NULL,59876173566,935565211,14618206,16.2),(134197,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134197,37.32,0.46,291,63341,70,NULL,NULL,'2MASX J16001712+1019118',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.071333,10.32008,0.137,NULL,56578559642,884039994,13813124,17.5),(134198,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134198,37.82,0.09,366,63342,70,NULL,NULL,'2MASX J16001717+2632403',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.071417,26.54453,0.153,NULL,59876898254,935576535,14618383,17.7),(134199,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134199,37.94,0.46,387,63343,70,NULL,NULL,'2MASX J16001857+4159081',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000172,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.07725,41.98544,0.033,NULL,59808605764,934509465,14601710,17.8),(134200,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134200,37.86,0.46,373,63344,70,NULL,NULL,'2MASX J16001880+3418028',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.078291667,34.30072,0.061,NULL,59768224887,933878513,14591851,18),(134201,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134201,38.13,0.17,423,63345,70,NULL,NULL,'2MASXi J1600195+331953',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.081625,33.33147,0.065,NULL,59765653559,933838336,14591224,18.1),(134202,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134202,37.34,0.13,294,63346,70,NULL,NULL,'2MASX J16002272+5350563',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.0001,NULL,'15.8g',0.41,'E0',NULL,NULL,NULL,NULL,1,240.0945417,53.84906,NULL,NULL,57604995324,900078051,14063719,15.8),(134203,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134203,38.13,0.17,423,63347,70,NULL,NULL,'2MASX J16002272+3313186',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',NULL,NULL,'16.7',0.39,'BrClG',NULL,NULL,NULL,NULL,1,240.0947917,33.22167,0.073,NULL,59765525313,933836333,14591192,16.7),(134204,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134204,35.59,0.27,131,63348,70,NULL,NULL,'2MASX J16002360+0244167',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000089,NULL,'16.4g',0.23,'Sa',NULL,NULL,NULL,NULL,1,240.098375,2.73786,0.281,NULL,56485196843,882581200,13790331,16.4),(134205,'IRAS','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134205,34.08,0.8,65.6,63349,75,NULL,'HMCL, I','UGC 10127',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00003,NULL,'14.09',0.7,'Sb','Supercluster foreground object',NULL,NULL,NULL,1,240.0997917,20.84908,0.113,NULL,59400947978,928139812,14502184,14.09),(134206,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134206,33.63,0.4,53.2,63349,75,NULL,'HMCL, I, raw','UGC 10127',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134207,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134207,33.83,0.4,58.3,63349,75,NULL,'HMCL, I, inv','UGC 10127',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134208,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134208,33.88,0.4,59.6,63349,75,NULL,'HMCL, I, cor','UGC 10127',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134209,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134209,34.02,0.47,63.7,63349,NULL,NULL,'H','UGC 10127',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134210,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134210,34.03,0.46,63.9,63349,NULL,NULL,'J','UGC 10127',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134211,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134211,34.04,0.45,64.3,63349,NULL,NULL,'K','UGC 10127',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134212,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134212,34.33,0.4,73.3,63349,NULL,NULL,'mean','UGC 10127',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134213,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134213,36.15,0.46,170,63350,70,NULL,NULL,'2MASX J16002501+0313357',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000071,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.104333333,3.22647,0.269,NULL,56483668201,882557315,13789958,17.4),(134214,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134214,38.13,0.17,423,63351,70,NULL,NULL,'SDSS J160025.13+331758.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000146,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,240.10475,33.29972,0.065,NULL,59765653952,933838343,14591224,18.5),(134215,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134215,37.06,0.46,258,63352,70,NULL,NULL,'2MASX J16002550+3716077',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000169,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.106291667,37.26886,0.017,NULL,59776210845,934003294,14593801,16.9),(134216,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134216,36.9,0.33,240,63353,70,NULL,NULL,'2MASX J16002557+3318576',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000187,NULL,'15.6g',0.43,'E0',NULL,NULL,NULL,NULL,1,240.1065,33.31606,0.065,NULL,59765654384,933838349,14591224,15.6),(134217,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134217,36.19,0.46,173,63354,70,NULL,NULL,'2MASX J16002581+2719529',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,240.107583,27.33136,0.113,NULL,59876579945,935571561,14618305,17.5),(134218,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134218,38.13,0.17,423,63355,70,NULL,NULL,'SDSS J160026.03+331336.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000167,NULL,'18.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.108458333,33.22675,0.073,NULL,59765524677,933836323,14591192,18.5),(134219,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134219,35.01,0.6,101,63356,70,NULL,NULL,'2MASX J16002742-0807336',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.97',0.4,NULL,NULL,NULL,NULL,NULL,1,240.1142083,-8.12619,0.517,NULL,45628677583,712948087,11139813,16.97),(134220,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134220,38.33,0.46,463,63357,70,NULL,NULL,'SDSS J160027.94+153602.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.1164583,15.60069,0.057,NULL,56570446367,883913224,13811144,18.2),(134221,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134221,36.29,0.46,181,63358,70,NULL,NULL,'2MASX J16002901+0802098',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000156,NULL,'16.0g',0.42,NULL,NULL,NULL,NULL,NULL,1,240.120917,8.03619,0.149,NULL,56629234175,884831783,13825496,16),(134222,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134222,36.17,0.62,171,63359,70,NULL,NULL,'2MASX J16003120-0559336',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'14.3I',1.1,'Sd?',NULL,NULL,NULL,NULL,1,240.129833,-5.99267,0.541,NULL,45592938234,712389659,11131088,14.3),(134223,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134223,36.6,0.33,209,63360,70,NULL,NULL,'2MASX J16003170+4524411',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000178,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.132083,45.4115,0.061,NULL,59684240280,932566254,14571347,16.8),(134224,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134224,38.13,0.17,423,63361,70,NULL,NULL,'2MASX J16003245+3307116',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,240.135083,33.11983,0.073,NULL,59765531317,933836426,14591194,18),(134225,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134225,37.45,0.46,308,63362,70,NULL,NULL,'2MASX J16003244+3400326',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.135417,34.00906,0.065,NULL,59768133549,933877086,14591829,17.4),(134226,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134226,38.28,0.46,452,63363,70,NULL,NULL,'2MASX J16003304+0423306',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,240.137666667,4.39203,0.201,NULL,56484351369,882567990,13790124,17.8),(134227,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134227,38.03,0.05,403,63364,70,NULL,NULL,'2MASX J16003335+2658359',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000155,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,240.138917,26.97664,0.117,NULL,59876474478,935569913,14618279,18.4),(134228,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134228,38.95,0.46,616,63365,70,NULL,NULL,'SDSS J160033.45+170949.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000213,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.139416667,17.16372,0.049,NULL,56567634486,883869288,13810457,18.3),(134229,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134229,38.25,0.46,447,63366,70,NULL,NULL,'2MASX J16003348+2838269',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000159,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.139625,28.64097,0.101,NULL,59868176664,935440260,14616254,18.1),(134230,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134230,36.78,0.46,227,63367,70,NULL,NULL,'2MASX J16003520+2010560',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000176,NULL,'16.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,240.14675,20.18225,0.077,NULL,56512407498,883006367,13796974,16.6),(134231,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134231,38.02,0.46,402,63368,70,NULL,NULL,'2MASX J16003529+2657489',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000142,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,240.1470417,26.96356,0.117,NULL,59876473993,935569906,14618279,18.4),(134232,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134232,37.34,0.13,294,63369,70,NULL,NULL,'2MASX J16003543+5415297',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000105,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.147833333,54.25811,0.017,NULL,57605412403,900084568,14063821,17.2),(134233,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134233,35.3,0.16,115,63370,74.4,NULL,NULL,'IC 1155',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000007,NULL,'14.88',0.7,'SAB(rs)bc','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.149,15.68564,0.049,NULL,56570461820,883913465,13811147,14.88),(134234,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134234,35.95,0.18,155,63370,70,NULL,NULL,'IC 1155',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134235,'IRAS','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134235,35.79,0.8,144,63370,75,NULL,'HMCL, I','IC 1155',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134236,'Sosies','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134236,35.27,0.15,113,63370,NULL,NULL,'Avg. of 7 galaxies','IC 1155',NULL,'1985ApJ...297...23D',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134237,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134237,34.86,0.97,93.9,63370,NULL,NULL,'Malmquist cor.','IC 1155',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134238,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134238,34.97,0.92,98.8,63370,NULL,NULL,NULL,'IC 1155',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134239,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134239,34.98,0.4,99.2,63370,75,NULL,'HMCL, I, raw','IC 1155',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134240,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134240,35.15,0.4,107,63370,75,NULL,'HMCL, I, inv','IC 1155',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134241,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134241,35.3,0.16,115,63370,74.4,NULL,NULL,'IC 1155',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134242,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134242,35.38,0.4,119,63370,75,NULL,'HMCL, I, cor','IC 1155',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134243,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134243,38.02,0.46,401,63371,70,NULL,NULL,'2MASX J16003715+3300526',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,240.154833,33.01464,0.081,NULL,59765513794,933836153,14591189,17.6),(134244,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134244,35.1,0.46,105,63372,70,NULL,NULL,'IC 1156',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.00003,NULL,'14.7g',0.75,'E','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.155667,19.72322,0.069,NULL,56512330529,883005164,13796955,14.7),(134245,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134245,36.82,0.46,231,63373,70,NULL,NULL,'2MASX J16003749+2402479',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000182,NULL,'15.8g',0.46,NULL,NULL,NULL,NULL,NULL,1,240.1562083,24.04681,0.197,NULL,59393411071,928022047,14500344,15.8),(134246,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134246,36.2,0.2,174,63374,74.4,NULL,NULL,'MCG +03-41-024',NULL,'2013AJ....146...86T',2013,1,0.78,NULL,'G',0.000027,NULL,'16.0g',0.24,'S',NULL,NULL,NULL,NULL,1,240.157125,16.67053,0.061,NULL,56565701497,883839085,13809985,16),(134247,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134247,37.27,0.64,285,63375,70,NULL,NULL,'2MASX J16003813-0106425',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00011,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,240.1587917,-1.11192,0.437,NULL,45526525731,711351964,11114874,16.6),(134248,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134248,38.03,0.05,403,63376,70,NULL,NULL,'SDSS J160039.50+265922.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000164,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.164625,26.98958,0.117,NULL,59876474627,935569916,14618279,18.1),(134249,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134249,36.1,0.46,166,63377,70,NULL,NULL,'SDSS J160040.46+125541.3',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.28,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.168625,12.92817,0.121,NULL,56556066836,883688544,13807633,17.1),(134250,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134250,39,0.46,632,63378,70,NULL,NULL,'2MASX J16004045+2859319',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000171,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.1687917,28.99228,0.097,NULL,59868060316,935438442,14616225,18),(134251,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134251,36.64,0.14,212,63379,70,NULL,NULL,'2MASX J16004095+1801210',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.17075,18.0225,0.057,NULL,56566792845,883856138,13810252,17.3),(134252,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134252,38.59,0.33,522,63380,70,NULL,NULL,'SDSS J160041.70+265632.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,240.1737917,26.94225,0.117,NULL,59876473597,935569899,14618279,18.7),(134253,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134253,38.9,0.46,603,63381,70,NULL,NULL,'SDSS J160042.30+200731.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000159,NULL,'18.7g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.17625,20.12553,0.077,NULL,56512401350,883006271,13796972,18.7),(134254,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134254,35.21,0.71,110,63382,NULL,NULL,'Malmquist cor.','KUG 1558+168',NULL,'2009ApJS..182..474S',2009,1,0.67,NULL,'G',0.000013,NULL,'15.6g',0.41,'SAa pec','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.179833,16.71628,0.061,NULL,56567543668,883867869,13810435,15.6),(134255,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134255,35.22,0.71,111,63382,NULL,NULL,NULL,'KUG 1558+168',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134256,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134256,35.26,0.2,113,63382,74.4,NULL,NULL,'KUG 1558+168',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134257,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134257,38.59,0.33,522,63383,70,NULL,NULL,'2MASX J16004419+2656309',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.184167,26.94189,0.117,NULL,59876473438,935569897,14618279,18.4),(134258,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134258,38.92,0.46,608,63384,70,NULL,NULL,'SDSS J160044.45+531255.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00007,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,240.1852083,53.21556,NULL,NULL,59698205932,932784467,14574757,18.6),(134259,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134259,36.14,0.05,169,63385,70,NULL,NULL,'2MASX J16004661+1614230',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,240.194375,16.23972,0.029,NULL,56570369103,883912017,13811125,16.5),(134260,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134260,35.96,0.46,156,63386,70,NULL,NULL,'2MASX J16004669+2354529',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000169,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,240.194583,23.91475,0.169,NULL,59393202864,928018794,14500293,16.1),(134261,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134261,37.82,0.09,366,63387,70,NULL,NULL,'2MASX J16004799+2612339',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.2000417,26.20933,0.141,NULL,59875009984,935547031,14617922,17.8),(134262,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134262,37.34,0.13,294,63388,70,NULL,NULL,'2MASX J16004889+5353450',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000105,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.2035,53.89592,NULL,NULL,57605057113,900079017,14063734,16.5),(134263,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134263,38.68,0.46,546,63389,70,NULL,NULL,'2MASX J16005022+2912099',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000211,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.2092083,29.20281,0.109,NULL,59869367981,935458874,14616544,17.7),(134264,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:53','1','SN 1958A',NULL,134264,35.22,0.29,111,63390,NULL,NULL,'Avg. of 8 SN host galaxies','MCG +03-41-027',NULL,'1985ApJ...297...23D',1985,1,0.41,NULL,'G',0.000174,NULL,'16.5g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.209708333,19.71164,0.069,NULL,56512319821,883004997,13796953,16.5),(134265,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134265,37.65,0.46,339,63391,70,NULL,NULL,'2MASX J16005046+2916489',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.2102083,29.28031,0.081,NULL,59868849155,935450768,14616418,17.6),(134266,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134266,36.47,0.46,196,63392,70,NULL,NULL,'2MASX J16005062+1324550',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,240.210875,13.41528,0.137,NULL,56556353489,883693023,13807703,16.8),(134267,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134267,36.95,0.46,246,63393,70,NULL,NULL,'2MASX J16005090+3918038',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.211917,39.30119,0.013,NULL,59795234492,934300538,14598445,17.6),(134268,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134268,37.87,0.46,375,63394,70,NULL,NULL,'2MASX J16005089+0433266',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000179,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,240.212125,4.55744,0.197,NULL,56480863126,882513486,13789273,17),(134269,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134269,37.82,0.09,366,63395,70,NULL,NULL,'2MASX J16005125+2611129',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000173,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,240.2135,26.18692,0.141,NULL,59875010161,935547033,14617922,16.8),(134270,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134270,37.4,0.46,302,63396,70,NULL,NULL,'SDSS J160051.37+065811.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.2140417,6.96972,0.181,NULL,56627690201,884807659,13825119,18.4),(134271,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134271,35.97,0.31,157,63397,NULL,NULL,'Malmquist cor.','CGCG 108-049',NULL,'2009ApJS..182..474S',2009,1,0.74,NULL,'G',0.000042,NULL,'15.2g',0.48,'S0^0^','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.217958333,17.54578,0.069,NULL,56567276719,883863698,13810370,15.2),(134272,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134272,36.3,0.27,182,63397,NULL,NULL,NULL,'CGCG 108-049',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134273,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134273,36.83,0.2,232,63397,74.4,NULL,NULL,'CGCG 108-049',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134274,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134274,37.82,0.09,366,63398,70,NULL,NULL,'2MASX J16005276+2606336',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000164,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,240.219875,26.10933,0.141,NULL,59863732543,935370820,14615169,18.6),(134275,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134275,38.03,0.05,403,63399,70,NULL,NULL,'SDSS J160052.83+270834.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000149,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,240.220167,27.14283,0.117,NULL,59876506415,935570412,14618287,18.6),(134276,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134276,36.34,0.46,185,63400,70,NULL,NULL,'2MASX J16005412+0557306',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000175,NULL,'16.2g',0.41,NULL,NULL,NULL,NULL,NULL,1,240.225375,5.95861,0.177,NULL,56610591774,884540496,13820945,16.2),(134277,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134277,37.15,0.46,269,63401,70,NULL,NULL,'2MASX J16005434+1643485',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000142,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.226417,16.73003,0.041,NULL,56567532758,883867699,13810432,17.4),(134278,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134278,34.4,0.2,75.9,63402,74.4,NULL,NULL,'KUG 1558+128',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000027,NULL,'14.8',0.4,'Sa',NULL,NULL,NULL,NULL,1,240.230458333,12.68039,0.117,NULL,56547793532,883559273,13805613,14.8),(134279,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134279,37.21,0.27,277,63403,70,NULL,NULL,'SDSS J160055.69+100620.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.232041667,10.10564,0.137,NULL,56578666460,884041663,13813150,18),(134280,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134280,36.63,0.46,211,63404,70,NULL,NULL,'2MASX J16005583+1617595',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00008,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,240.2327083,16.29992,0.037,NULL,56570370976,883912046,13811125,16.7),(134281,'IRAS','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134281,34.46,0.8,78.1,63405,75,NULL,'MAT, I','ESO 389- G 006',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00003,NULL,'16',0.5,'SA(r)c:',NULL,NULL,NULL,NULL,1,240.2337917,-35.69864,0.841,NULL,46268964192,722952565,11296133,16),(134282,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134282,33.84,0.69,58.7,63405,100,NULL,'mid-IR','ESO 389- G 006',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134283,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134283,34.04,0.2,64.3,63405,74.4,NULL,NULL,'ESO 389- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134284,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134284,34.27,0.32,71.4,63405,85,NULL,'I, raw','ESO 389- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134285,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134285,34.32,0.32,73.2,63405,85,NULL,'I, inv','ESO 389- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134286,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134286,34.4,0.43,75.8,63405,75,NULL,'MAT, I, raw','ESO 389- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134287,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134287,34.59,0.47,82.8,63405,NULL,NULL,'H','ESO 389- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134288,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134288,34.65,0.43,84.9,63405,75,NULL,'MAT, I, inv','ESO 389- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134289,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134289,34.65,0.43,85.1,63405,75,NULL,'MAT, I, cor','ESO 389- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134290,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134290,34.67,0.4,86.1,63405,NULL,NULL,'mean','ESO 389- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134291,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134291,34.74,0.45,88.8,63405,NULL,NULL,'K','ESO 389- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134292,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134292,34.78,0.46,90.4,63405,NULL,NULL,'J','ESO 389- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134293,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134293,34.9,0.83,95.5,63406,NULL,NULL,'Malmquist cor.','IC 1157',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000347,NULL,'15.7',0.3,'Sc','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.234417,15.52644,0.057,NULL,56570095073,883907735,13811058,15.7),(134294,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134294,35.05,0.78,103,63406,NULL,NULL,NULL,'IC 1157',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134295,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134295,35.09,0.2,104,63406,74.4,NULL,NULL,'IC 1157',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134296,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134296,37.91,0.12,382,63407,70,NULL,NULL,'2MASX J16005652+2546506',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000176,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.235417,25.78069,0.129,NULL,59863977819,935374653,14615228,17.2),(134297,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134297,36.6,0.33,209,63408,70,NULL,NULL,'CGCG 250-036',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.00017,NULL,'15.2g',0.58,'E0',NULL,NULL,NULL,NULL,1,240.236791667,45.41767,0.061,NULL,59684238463,932566225,14571347,15.2),(134298,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134298,35.39,0.46,120,63409,70,NULL,NULL,'CGCG 108-052',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000127,NULL,'15.4g',0.44,'E','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.2372083,18.61469,0.061,NULL,56513758589,883027477,13797304,15.4),(134299,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134299,37.91,0.12,382,63410,70,NULL,NULL,'2MASX J16005761+2555596',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000164,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,240.24,25.93325,0.125,NULL,59863780660,935371572,14615180,18.3),(134300,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134300,36.2,0.46,173,63411,70,NULL,NULL,'2MASX J16005858+1922093',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'15.9g',0.36,NULL,NULL,NULL,NULL,NULL,1,240.244125,19.36933,0.061,NULL,56513953225,883030519,13797351,15.9),(134301,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134301,36.6,0.46,209,63412,70,NULL,NULL,'2MASX J16005896+2126463',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000179,NULL,'16.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.2455,21.44614,0.149,NULL,59405231035,928206734,14503230,16.7),(134302,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134302,38.21,0.46,439,63413,70,NULL,NULL,'2MASX J16005901+5301431',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000105,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.2457083,53.02875,NULL,NULL,59701011257,932828300,14575442,17.4),(134303,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134303,37.71,0.46,349,63414,70,NULL,NULL,'2MASX J16005930+3837408',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00009,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,240.246917,38.62808,0.017,NULL,59762705309,933792270,14590504,16.3),(134304,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134304,37.03,0.46,254,63415,70,NULL,NULL,'2MASX J16010105+0029177',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000096,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,240.2544583,0.48817,0.377,NULL,56478792857,882481138,13788767,16.5),(134305,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134305,35.92,0.46,153,63416,70,NULL,NULL,'KUG 1558+190',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.25775,18.87997,0.057,NULL,56513624609,883025384,13797271,17),(134306,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134306,35.5,0.39,126,63417,NULL,NULL,NULL,'UGC 10136',NULL,'2009ApJS..182..474S',2009,1,0.98,NULL,'G',0.000154,NULL,'15.3g',0.35,'S?',NULL,NULL,NULL,NULL,1,240.258083333,36.59106,0.025,NULL,59776250373,934003912,14593811,15.3),(134307,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134307,35.57,0.2,130,63417,74.4,NULL,NULL,'UGC 10136',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134308,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134308,35.58,0.37,131,63417,NULL,NULL,'Malmquist cor.','UGC 10136',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134309,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134309,38.39,0.21,477,63418,70,NULL,NULL,'2MASX J16010427+5356541',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000113,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,240.267875,53.94847,NULL,NULL,57605095240,900079613,14063743,18.1),(134310,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134310,37.82,0.09,366,63419,70,NULL,NULL,'SDSS J160105.18+262027.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,240.271625,26.341,0.133,NULL,59876838661,935575604,14618368,18.6),(134311,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134311,37.91,0.12,382,63420,70,NULL,NULL,'2MASX J16010547+2552457',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.27275,25.87919,0.125,NULL,59863769233,935371394,14615178,17.3),(134312,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134312,36.89,0.46,238,63421,70,NULL,NULL,'2MASX J16010562+3609109',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.27325,36.15294,0.041,NULL,59775505110,933992267,14593629,17.3),(134313,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134313,37.91,0.12,382,63422,70,NULL,NULL,'2MASX J16010591+2550567',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000133,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,240.274708333,25.84911,0.125,NULL,59863945300,935374145,14615221,18.1),(134314,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134314,37.6,0.46,331,63423,70,NULL,NULL,'2MASX J16010635+2028303',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000173,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.2765417,20.47514,0.093,NULL,59400913724,928139276,14502176,17.4),(134315,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134315,36.37,0.46,188,63424,70,NULL,NULL,'2MASX J16010650+1411595',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,240.2772917,14.19986,0.097,NULL,56560186115,883752908,13808639,16.9),(134316,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134316,37.26,0.46,283,63425,70,NULL,NULL,'2MASX J16010682+2516377',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000186,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.278667,25.27722,0.153,NULL,59864021395,935375334,14615239,17.1),(134317,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134317,36.57,0.46,206,63426,70,NULL,NULL,'CGCG 079-020',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000137,NULL,'15.7',0.49,NULL,NULL,NULL,NULL,NULL,1,240.278916667,11.94544,0.113,NULL,56577879561,884029368,13812958,15.7),(134318,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134318,34.23,0.46,70.2,63427,70,NULL,NULL,'CGCG 108-053',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000233,NULL,'14.74',0.8,'SAB0-','Supercluster foreground object',NULL,NULL,NULL,1,240.279375,19.44858,0.061,NULL,56513948940,883030452,13797350,14.74),(134319,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134319,36.9,0.46,240,63428,70,NULL,NULL,'2MASX J16010795+1036112',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,240.283041667,10.60311,0.141,NULL,56578576256,884040254,13813128,16.4),(134320,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134320,36.62,0.46,211,63429,70,NULL,NULL,'2MASX J16010919+2812257',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.288417,28.20706,0.101,NULL,59876206192,935565721,14618214,17.5),(134321,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134321,38.5,0.46,502,63430,70,NULL,NULL,'2MASX J16010963+2148053',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000141,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,240.2902917,21.80142,0.145,NULL,59405102762,928204730,14503198,18.3),(134322,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134322,36.95,0.46,245,63431,70,NULL,NULL,'2MASX J16011003+3509557',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,240.2919583,35.16553,0.041,NULL,59767294952,933863983,14591624,17.1),(134323,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134323,38.13,0.46,422,63432,70,NULL,NULL,'SDSS J160110.92+253425.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000152,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,240.2955417,25.57375,0.133,NULL,59863932379,935373943,14615217,18.8),(134324,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134324,37.14,0.46,268,63433,70,NULL,NULL,'2MASX J16011121+1009372',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,240.296791667,10.16042,0.137,NULL,56578632749,884041136,13813142,16.7),(134325,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134325,37.77,0.46,357,63434,70,NULL,NULL,'2MASX J16011146+3256417',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000177,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.2977917,32.94492,0.081,NULL,59765623330,933837864,14591216,17.4),(134326,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134326,38.07,0.46,412,63435,70,NULL,NULL,'SDSS J160111.55+041813.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.298125,4.30383,0.201,NULL,56484490391,882570162,13790158,18.2),(134327,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134327,37.26,0.46,283,63436,70,NULL,NULL,'2MASX J16011155+3152077',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000189,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,240.298125,31.86878,0.073,NULL,59735293348,933363958,14583811,16.6),(134328,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134328,35.86,0.49,149,63437,75,NULL,'IR','2MFGC 12848',NULL,'2011yCatp016004901K',2011,1,0.76,NULL,'G',0.000018,NULL,'16.5g',0.18,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,240.3015,15.75603,0.049,NULL,56569959324,883905614,13811025,16.5),(134329,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134329,35.92,0.33,153,63437,NULL,NULL,'Malmquist cor.','2MFGC 12848',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134330,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134330,36.01,0.32,159,63437,NULL,NULL,NULL,'2MFGC 12848',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134331,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134331,36.18,0.2,172,63437,74.4,NULL,NULL,'2MFGC 12848',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134332,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134332,36.93,0.46,243,63438,70,NULL,NULL,'2MASX J16011289+2230173',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000179,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.303666667,22.50489,0.141,NULL,59394211164,928034549,14500539,17.2),(134333,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134333,35.49,0.2,125,63439,74.4,NULL,NULL,'2MASX J16011331+2428537',NULL,'2013AJ....146...86T',2013,1,0.47,NULL,'G',0.000091,NULL,'16.1g',0.31,NULL,NULL,NULL,NULL,NULL,1,240.305417,24.48167,0.197,NULL,59863655342,935369614,14615150,16.1),(134334,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134334,36.53,0.46,202,63440,70,NULL,NULL,'2MASX J16011374+3438087',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000144,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,240.307125,34.63564,0.049,NULL,59767874046,933873031,14591766,17.6),(134335,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134335,37.21,0.27,277,63441,70,NULL,NULL,'2MASX J16011385+1008552',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,240.3077083,10.14858,0.137,NULL,56578631480,884041116,13813142,16.3),(134336,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134336,36.23,0.49,176,63442,75,NULL,'IR','2MFGC 12849',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.000037,NULL,'14.8',0.2,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,240.308916667,15.68883,0.049,NULL,56570013008,883906453,13811038,14.8),(134337,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134337,35.62,0.49,133,63443,75,NULL,'IR','UGC 10131',NULL,'2011yCatp016004901K',2011,1,1.25,NULL,'G',0.00002,NULL,'16.0',0.11,'Sc','Group non-member, background',NULL,NULL,NULL,1,240.3095,14.07878,0.101,NULL,56560166689,883752604,13808634,16),(134338,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134338,35.9,NULL,152,63443,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10131',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134339,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134339,35.9,NULL,152,63443,NULL,NULL,'Dipole + Quadrupole','UGC 10131',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134340,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134340,35.91,NULL,152,63443,NULL,NULL,'Dipole','UGC 10131',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134341,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134341,36.05,NULL,162,63443,NULL,NULL,NULL,'UGC 10131',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134342,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134342,36.19,0.38,173,63443,NULL,NULL,'Malmquist cor.','UGC 10131',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134343,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134343,36.43,0.34,193,63443,NULL,NULL,NULL,'UGC 10131',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134344,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134344,36.48,0.2,198,63443,74.4,NULL,NULL,'UGC 10131',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134345,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134345,37.91,0.33,382,63444,70,NULL,NULL,'SDSS J160114.48+245354.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,240.310375,24.89858,0.149,NULL,59864141463,935377210,14615268,18.4),(134346,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134346,38.13,0.17,423,63445,70,NULL,NULL,'2MASX J16011463+3300307',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.3110417,33.00844,0.081,NULL,59765636742,933838074,14591219,17.3),(134347,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134347,38.78,0.46,570,63446,70,NULL,NULL,'2MASX J16011514+1006582',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.3132917,10.11631,0.137,NULL,56578907632,884045431,13813209,17.9),(134348,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134348,37.81,0.46,364,63447,70,NULL,NULL,'2MASX J16011588+0512027',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,240.31625,5.20072,0.141,NULL,56481429900,882522342,13789411,17.5),(134349,'Sosies','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134349,35.27,0.15,113,63448,NULL,NULL,'Avg. of 7 galaxies','IC 1162',NULL,'1985ApJ...297...23D',1985,1,0.7,NULL,'G',0.00003,NULL,'15.4g',0.53,'SAB(s)bc','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.3180417,17.67783,0.061,NULL,56567306532,883864164,13810377,15.4),(134350,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134350,38.14,0.46,424,63449,70,NULL,NULL,'SDSS J160116.50+054638.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000137,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,240.318791667,5.77725,0.169,NULL,56610729014,884542640,13820978,18.4),(134351,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134351,35.75,0.25,141,63450,74.4,NULL,NULL,'IC 1161',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.00008,NULL,'14.82',0.8,'E','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.320083,15.64542,0.049,NULL,56570006101,883906345,13811036,14.82),(134352,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134352,35.95,0.18,155,63450,70,NULL,NULL,'IC 1161',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134353,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134353,36.14,0.05,169,63450,70,NULL,NULL,'IC 1161',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134354,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134354,37.22,0.46,278,63451,70,NULL,NULL,'2MASX J16011726+2059493',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000183,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,240.321833333,20.99703,0.129,NULL,59401042795,928141293,14502207,16.7),(134355,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134355,36.14,0.05,169,63452,70,NULL,NULL,'2MASX J16011808+1644535',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000198,NULL,'16.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.32525,16.74822,0.029,NULL,56568842651,883888166,13810752,16.6),(134356,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134356,37.99,0.46,396,63453,70,NULL,NULL,'2MASX J16011833+2921467',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.326417,29.36314,0.081,NULL,59868845991,935450718,14616417,18.1),(134357,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134357,35.65,0.45,135,63454,NULL,NULL,NULL,'AGC 251511',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000021,NULL,'14.9I',0.3,NULL,NULL,NULL,NULL,NULL,1,240.327417,15.59239,0.049,NULL,56570003872,883906310,13811036,14.9),(134358,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134358,35.66,0.2,136,63454,74.4,NULL,NULL,'AGC 251511',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134359,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134359,35.86,0.41,149,63454,NULL,NULL,'Malmquist cor.','AGC 251511',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134360,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134360,37.34,0.13,294,63455,70,NULL,NULL,'2MASX J16011900+5400314',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000072,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.3289583,54.00858,0.021,NULL,57605086688,900079479,14063741,18),(134361,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134361,36.14,0.05,169,63456,70,NULL,NULL,'2MASX J16011934+1655515',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000163,NULL,'15.8g',0.27,'S',NULL,NULL,NULL,NULL,1,240.330667,16.93083,0.049,NULL,56567069984,883860468,13810319,15.8),(134362,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134362,38.36,0.46,470,63457,70,NULL,NULL,'2MASX J16011967+3618139',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.332166667,36.30375,0.033,NULL,59776580901,934009076,14593891,17.7),(134363,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134363,37.82,0.09,366,63458,70,NULL,NULL,'2MASX J16012016+2604397',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000182,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.334125,26.07756,0.141,NULL,59863783396,935371615,14615181,17.4),(134364,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134364,35.73,0.25,140,63459,74.4,NULL,NULL,'CGCG 108-059',NULL,'2013AJ....146...86T',2013,1,0.71,NULL,'G',0.00007,NULL,'14.9g',0.68,'E','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.338416667,16.67661,0.029,NULL,56572251037,883941422,13811584,14.9),(134365,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134365,35.95,0.18,155,63459,70,NULL,NULL,'CGCG 108-059',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134366,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134366,36.14,0.05,169,63459,70,NULL,NULL,'CGCG 108-059',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134367,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134367,36.52,0.33,201,63460,70,NULL,NULL,'2MASX J16012207+2028382',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,240.342,20.47722,0.109,NULL,56512023668,883000369,13796880,16.2),(134368,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134368,36.54,0.46,203,63461,70,NULL,NULL,'2MASX J16012247+2056102',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.343583333,20.93611,0.129,NULL,59401041772,928141277,14502207,16.8),(134369,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134369,38.39,0.21,477,63462,70,NULL,NULL,'MCG +09-26-045',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000109,NULL,'16.1g',0.44,NULL,NULL,NULL,NULL,NULL,1,240.345708333,53.86642,NULL,NULL,57605053862,900078966,14063733,16.1),(134370,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134370,37.82,0.09,366,63463,70,NULL,NULL,'2MASX J16012364+2606577',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,240.348583,26.11617,0.141,NULL,59863739197,935370924,14615170,16.8),(134371,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134371,37.93,0.46,385,63464,70,NULL,NULL,'2MASX J16012472+2035405',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.353,20.59475,0.109,NULL,59400921062,928139391,14502177,17.9),(134372,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134372,38.39,0.21,477,63465,70,NULL,NULL,'2MASX J16012490+5402374',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000087,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,240.3537917,54.04364,0.021,NULL,57604939878,900077185,14063706,18.2),(134373,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134373,38.17,0.46,431,63466,70,NULL,NULL,'2MASX J16012501+4017537',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.354083,40.29831,0.013,NULL,59795462523,934304101,14598501,17.6),(134374,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134374,36.14,0.05,169,63467,70,NULL,NULL,'2MASX J16012700+1632056',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000164,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,240.362417,16.53497,0.029,NULL,56572308929,883942327,13811598,16.6),(134375,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134375,37.82,0.09,366,63468,70,NULL,NULL,'2MASX J16012784+2603251',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000149,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.3662083,26.05703,0.141,NULL,59863785441,935371647,14615181,17.2),(134376,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134376,37.38,0.46,299,63469,70,NULL,NULL,'2MASX J16012794+3324497',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000189,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,240.366375,33.41367,0.065,NULL,59765488805,933835762,14591183,16.7),(134377,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134377,37.34,0.13,294,63470,70,NULL,NULL,'SBS 1600+540A',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000136,NULL,'15.3g',0.56,'E              BrClG',NULL,NULL,NULL,NULL,1,240.367,53.94739,0.021,NULL,57605081004,900079390,14063740,15.3),(134378,'Faber-Jackson','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134378,34.1,0.44,66.1,63471,95,NULL,'Weighted Mean','NGC 6028',NULL,'1984ApJS...56...91D',1984,1,1.3,NULL,'G',0.00003,NULL,'14.35',1.2,'(R)SA0+:','Supercluster foreground object',NULL,NULL,NULL,1,240.370666667,19.35989,0.061,NULL,56513964415,883030693,13797354,14.35),(134379,'Faber-Jackson','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134379,34.55,0.46,81.3,63471,95,NULL,'Michard 1979a','NGC 6028',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134380,'Faber-Jackson','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134380,34.84,0.63,92.9,63471,95,NULL,'Michard 1979b, c','NGC 6028',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134381,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134381,36.22,0.2,175,63472,74.4,NULL,NULL,'CGCG 108-061',NULL,'2013AJ....146...86T',2013,1,0.52,NULL,'G',0.000023,NULL,'15.4g',0.42,'Sc','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.3752917,16.75564,0.029,NULL,56568854274,883888348,13810755,15.4),(134382,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134382,35.74,0.25,141,63473,74.4,NULL,NULL,'IC 1163',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00016,NULL,'14.90',0.7,'E','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.3772917,15.50392,0.049,NULL,56570134009,883908343,13811067,14.9),(134383,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134383,35.95,0.18,155,63473,70,NULL,NULL,'IC 1163',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134384,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134384,36.14,0.05,169,63473,70,NULL,NULL,'IC 1163',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134385,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134385,37.82,0.46,367,63474,70,NULL,NULL,'2MASX J16013056+2820321',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,240.3775,28.34217,0.101,NULL,59868052466,935438319,14616223,17.3),(134386,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134386,36.87,0.27,236,63475,70,NULL,NULL,'2MASX J16013076+1015395',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.378333,10.26117,0.125,NULL,56578621911,884040967,13813140,17.2),(134387,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134387,37.34,0.13,294,63476,70,NULL,NULL,'2MASX J16013134+5354373',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000073,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,240.38075,53.91047,0.021,NULL,57605082432,900079413,14063740,17.4),(134388,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134388,37.21,0.27,277,63477,70,NULL,NULL,'SDSS J160131.65+101015.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.381875,10.17106,0.137,NULL,56578901287,884045332,13813208,17.8),(134389,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134389,36.55,0.46,204,63478,70,NULL,NULL,'2MASX J16013172+0408261',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,240.3822083,4.14056,0.221,NULL,56484657284,882572770,13790199,16.9),(134390,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134390,36.14,0.05,169,63479,70,NULL,NULL,'2MASX J16013196+1549506',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000057,NULL,'15.8g',0.29,'E',NULL,NULL,NULL,NULL,1,240.383166667,15.83072,0.021,NULL,56569969365,883905771,13811027,15.8),(134391,'Tully est','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134391,32.41,0.8,30.3,63480,75,NULL,'B','IC 1158',NULL,'1988NBGC.C....0000T',1988,1,2.5,NULL,'G',0.00002,NULL,'12.8B',1.7,'SAB(r)c:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,240.392,1.70783,0.321,NULL,56477651453,882463303,13788489,12.8),(134392,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134392,31.46,0.69,19.6,63480,100,NULL,'mid-IR','IC 1158',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134393,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134393,31.95,0.4,24.5,63480,NULL,NULL,NULL,'IC 1158',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134394,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134394,32.25,0.43,28.1,63480,75,NULL,'3.6 micron, color + selection bias corrected','IC 1158',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134395,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134395,32.25,0.2,28.2,63480,74.4,NULL,NULL,'IC 1158',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134396,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134396,32.26,0.43,28.3,63480,75,NULL,'3.6 micron, color corrected','IC 1158',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134397,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134397,32.36,0.49,29.7,63480,NULL,NULL,'Malmquist cor.','IC 1158',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134398,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134398,32.42,0.48,30.5,63480,NULL,NULL,NULL,'IC 1158',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134399,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134399,32.42,NULL,30.5,63480,72,NULL,NULL,'IC 1158',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134400,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134400,32.74,0.4,35.3,63480,NULL,NULL,'mean','IC 1158',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134401,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134401,33.19,0.47,43.5,63480,NULL,NULL,'H','IC 1158',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134402,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134402,33.23,0.46,44.3,63480,NULL,NULL,'J','IC 1158',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134403,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134403,33.23,0.45,44.3,63480,NULL,NULL,'K','IC 1158',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134404,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134404,38.39,0.21,477,63481,70,NULL,NULL,'2MASX J16013485+5349101',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000077,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.3952917,53.81939,0.005,NULL,57604875561,900076180,14063690,18),(134405,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134405,36.13,0.2,168,63482,74.4,NULL,NULL,'SDSS J160135.07+152804.4',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000018,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,240.396125,15.46789,0.061,NULL,56570132089,883908313,13811067,18.4),(134406,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134406,37.77,0.33,359,63483,70,NULL,NULL,'2MASX J16013586+0334411',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,240.3995,3.57797,0.257,NULL,56483308449,882551694,13789870,18.4),(134407,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134407,37.09,0.46,261,63484,70,NULL,NULL,'2MASX J16013598+3107548',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.399875,31.13206,0.037,NULL,59865486348,935398224,14615597,17.2),(134408,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134408,37.62,0.46,334,63485,70,NULL,NULL,'2MASX J16013722-0019037',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000107,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.4050417,-0.31761,0.413,NULL,45526582995,711352859,11114888,17.7),(134409,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134409,37.65,0.33,338,63486,70,NULL,NULL,'2MASX J16013773+3333268',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.4072917,33.55747,0.057,NULL,59765440204,933835003,14591171,17.4),(134410,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134410,36.87,0.27,236,63487,70,NULL,NULL,'2MASX J16013787+1021115',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,240.4077083,10.35325,0.125,NULL,56578705658,884042275,13813160,16.2),(134411,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134411,36.14,0.05,169,63488,70,NULL,NULL,'2MASX J16013923+1600516',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00005,NULL,'15.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,240.413333,16.0145,0.029,NULL,56572315732,883942433,13811600,15.9),(134412,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134412,36.26,0.2,179,63489,74.4,NULL,NULL,'SDSS J160139.37+161837.9',NULL,'2013AJ....146...86T',2013,1,0.71,NULL,'G',0.000014,NULL,'16.0g',0.21,'S',NULL,NULL,NULL,NULL,1,240.414083,16.31053,0.037,NULL,56572479095,883944985,13811640,16),(134413,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134413,38.01,0.33,400,63490,70,NULL,NULL,'2MASX J16013939+2629061',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000132,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,240.41425,26.48517,0.125,NULL,59876325670,935567588,14618243,18),(134414,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134414,38.39,0.21,477,63491,70,NULL,NULL,'2MASX J16013983+5347031',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000083,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,240.416083,53.78419,0.005,NULL,57604881870,900076279,14063691,18.1),(134415,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134415,34.72,0.69,87.7,63492,100,NULL,'mid-IR','UGC 10138',NULL,'2013ApJ...771...88L',2013,1,1.3,NULL,'G',0.000033,NULL,'14.4g',0.6,'Sa','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.417625,21.35294,0.149,NULL,59405196248,928206191,14503221,14.4),(134416,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134416,35.66,0.45,135,63492,NULL,NULL,'K','UGC 10138',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134417,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134417,35.68,0.47,136,63492,NULL,NULL,'H','UGC 10138',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134418,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134418,35.75,0.46,141,63492,NULL,NULL,'J','UGC 10138',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134419,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134419,35.76,0.4,142,63492,NULL,NULL,'mean','UGC 10138',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134420,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134420,36.44,0.2,194,63492,74.4,NULL,NULL,'UGC 10138',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134421,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134421,36.14,0.05,169,63493,70,NULL,NULL,'2MASX J16014021+1642466',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000171,NULL,'16.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,240.41775,16.71297,0.029,NULL,56568848310,883888254,13810753,16.1),(134422,'G Lens','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134422,40.74,NULL,1400,63494,NULL,NULL,'Standard','87GB[BWE91] 1600+4325 ABS01',NULL,'2014ApJ...788..190W',2014,1,NULL,NULL,'AbLS',0.0003,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,240.41875,43.27889,0.009,NULL,59804425253,934444144,14600689,NULL),(134423,'G Lens','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134423,40.78,NULL,1440,63494,NULL,NULL,'R(H) = ct','87GB[BWE91] 1600+4325 ABS01',NULL,'2014ApJ...788..190W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134424,'G Lens','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134424,40.93,0.37,1540,63494,NULL,NULL,NULL,'87GB[BWE91] 1600+4325 ABS01',NULL,'2007ApJ...660....1O',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134425,'G Lens','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134425,41.42,0.54,1920,63494,NULL,NULL,NULL,'87GB[BWE91] 1600+4325 ABS01',NULL,'2000ApJ...544..117B',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134426,'G Lens','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134426,42.75,0.81,3550,63494,NULL,NULL,NULL,'87GB[BWE91] 1600+4325 ABS01',NULL,'2014MNRAS.437..600S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134427,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134427,37.91,0.33,382,63495,70,NULL,NULL,'2MASX J16014052+2457471',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,240.418917,24.963,0.185,NULL,59864023306,935375364,14615240,17.4),(134428,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134428,38.23,0.46,443,63496,70,NULL,NULL,'2MASX J16014075+5137061',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000172,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.420083,51.61847,0.009,NULL,59699422724,932803480,14575054,17.2),(134429,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134429,36.7,0.46,219,63497,70,NULL,NULL,'2MASX J16014141+0547401',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000203,NULL,'16.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,240.4225,5.79467,0.185,NULL,56610783100,884543485,13820991,16.2),(134430,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134430,37.82,0.09,366,63498,70,NULL,NULL,'SDSS J160141.78+260532.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000141,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,240.424083,26.09233,0.141,NULL,59863736516,935370883,14615170,18.8),(134431,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134431,36.87,0.27,236,63499,70,NULL,NULL,'2MASX J16014187+1023425',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,240.424583,10.39508,0.125,NULL,56578717283,884042457,13813163,16.3),(134432,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134432,37.67,0.46,341,63500,70,NULL,NULL,'2MASX J16014194+2216476',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.4247917,22.28006,0.137,NULL,59394096818,928032762,14500511,17.9),(134433,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134433,37.65,0.33,338,63501,70,NULL,NULL,'2MASX J16014245+3331418',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.426875,33.52842,0.057,NULL,59765435092,933834923,14591170,17.6),(134434,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134434,36.42,0.46,192,63502,70,NULL,NULL,'2MASX J16014303+3534398',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,240.4294583,35.57786,0.045,NULL,59775440712,933991261,14593613,16.9),(134435,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134435,38.01,0.33,400,63503,70,NULL,NULL,'2MASX J16014341+2630302',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.430833,26.50839,0.125,NULL,59876318456,935567475,14618241,17.5),(134436,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134436,36.52,0.33,201,63504,70,NULL,NULL,'CGCG 137-016',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.00017,NULL,'15.3g',0.54,NULL,'Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.432208333,20.42275,0.085,NULL,56512881067,883013766,13797090,15.3),(134437,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134437,37.24,0.46,281,63505,70,NULL,NULL,'2MASX J16014396+0550481',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,240.4332083,5.84683,0.185,NULL,56610781402,884543459,13820991,17.4),(134438,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134438,38.35,0.46,467,63506,70,NULL,NULL,'2MASX J16014472+3431418',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000174,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.436208333,34.52817,0.053,NULL,59768736371,933886505,14591976,17.8),(134439,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134439,37.27,0.46,284,63507,70,NULL,NULL,'2MASX J16014495+4052208',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000093,NULL,'16.3g',0.31,NULL,'Field galaxy',NULL,NULL,NULL,1,240.437333,40.87256,0.037,NULL,59809214460,934518975,14601858,16.3),(134440,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134440,37.34,0.13,294,63508,70,NULL,NULL,'2MASX J16014512+5350321',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000086,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.438167,53.84219,0.005,NULL,57604877659,900076213,14063690,17.1),(134441,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134441,36.64,0.14,212,63509,70,NULL,NULL,'SDSS J160145.49+180109.7',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.0g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.4395417,18.01939,0.085,NULL,56566927020,883858234,13810284,17),(134442,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134442,37.84,0.33,370,63510,70,NULL,NULL,'2MASX J16014632+3956098',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,240.443041667,39.93614,0.033,NULL,59795971633,934312056,14598625,17),(134443,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134443,37.15,0.46,270,63511,70,NULL,NULL,'2MASX J16014639+2834192',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000218,NULL,'15.8g',0.4,NULL,NULL,NULL,NULL,NULL,1,240.44325,28.57214,0.101,NULL,59868007576,935437618,14616212,15.8),(134444,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134444,37.82,0.09,366,63512,70,NULL,NULL,'2MASX J16014743+2608322',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000171,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.447583333,26.14214,0.141,NULL,59864259959,935379061,14615297,17.6),(134445,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134445,36,0.46,159,63513,70,NULL,NULL,'CGCG 250-037',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000183,NULL,'15.1g',0.6,'E0',NULL,NULL,NULL,NULL,1,240.4524583,47.38803,0.029,NULL,59714045487,933031960,14578624,15.1),(134446,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134446,36.14,0.05,169,63514,70,NULL,NULL,'2MASX J16014923+1609496',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00006,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,240.455083,16.16372,0.029,NULL,56572370026,883943281,13811613,16.3),(134447,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134447,36.63,0.46,212,63515,70,NULL,NULL,'2MASX J16014924+4303593',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.455167,43.06636,0.009,NULL,59804416452,934444007,14600687,17.1),(134448,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134448,36.96,0.33,246,63516,70,NULL,NULL,'2MASX J16014937+1846016',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.455625,18.76706,0.065,NULL,56511566697,882993229,13796769,17.4),(134449,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134449,37.34,0.13,294,63517,70,NULL,NULL,'2MASX J16014964+5353068',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000087,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,240.456958333,53.88511,0.005,NULL,57604853770,900075840,14063685,18),(134450,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134450,34.18,0.28,68.7,63518,NULL,NULL,'Malmquist cor.','UGC 10137',NULL,'2009ApJS..182..474S',2009,1,1.27,NULL,'G',0.00003,NULL,'15.0g',0.66,'Sc',NULL,NULL,NULL,NULL,1,240.457167,8.14828,0.169,NULL,56583676128,884119939,13814374,15),(134451,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134451,34.22,0.2,69.8,63518,74.4,NULL,NULL,'UGC 10137',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134452,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134452,34.39,0.26,75.7,63518,NULL,NULL,NULL,'UGC 10137',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134453,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134453,36.62,0.83,211,63519,70,NULL,NULL,'2MASX J16015034-0438517',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,240.45975,-4.64769,0.553,NULL,45521582071,711274719,11113667,15.7),(134454,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134454,37.97,0.46,392,63520,70,NULL,NULL,'2MASX J16015080+3654218',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00013,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.461583,36.90619,0.033,NULL,59776383689,934005995,14593843,17.9),(134455,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134455,37.34,0.13,294,63521,70,NULL,NULL,'2MASX J16015123+5407438',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000114,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,240.463417,54.12881,0.021,NULL,57604955121,900077423,14063709,16.7),(134456,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134456,33.81,0.46,57.8,63522,70,NULL,NULL,'NGC 6030',NULL,'2015arXiv151105856S',2015,1,1.22,NULL,'G',0.000063,NULL,'13.6g',0.86,'S0^0^','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.46425,17.9575,0.057,NULL,56566919508,883858117,13810283,13.6),(134457,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134457,36.14,0.05,169,63523,70,NULL,NULL,'2MASXi J1601517+161618',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.465625,16.27183,0.037,NULL,56572357849,883943091,13811610,17.3),(134458,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134458,37.57,0.46,326,63524,70,NULL,NULL,'2MASX J16015243+2756521',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,240.468625,27.94781,0.093,NULL,59876217031,935565891,14618217,17.7),(134459,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134459,37.91,0.12,382,63525,70,NULL,NULL,'2MASX J16015254+2545041',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000196,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,240.4690417,25.75114,0.125,NULL,59863943292,935374113,14615220,17),(134460,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134460,38.15,0.46,427,63526,70,NULL,NULL,'2MASX J16015264+0707285',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000175,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,240.46925,7.12472,0.145,NULL,56627778744,884809042,13825141,17.3),(134461,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134461,36.96,0.33,246,63527,70,NULL,NULL,'2MASX J16015274+1842046',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.46975,18.70125,0.065,NULL,56511622298,882994098,13796782,17.3),(134462,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134462,37.91,0.12,382,63528,70,NULL,NULL,'SDSS J160153.24+253334.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.471875,25.55961,0.129,NULL,59863921961,935373780,14615215,18.3),(134463,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134463,37.19,0.46,274,63529,70,NULL,NULL,'SDSS J160153.74+513326.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000146,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,240.4739583,51.55742,0.009,NULL,59699415251,932803363,14575052,18.1),(134464,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134464,37.77,0.33,359,63530,70,NULL,NULL,'2MASX J16015450+0334421',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000144,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.477083,3.57842,0.261,NULL,56483311763,882551746,13789871,18),(134465,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134465,35.74,0.25,141,63531,74.4,NULL,NULL,'GIN 466',NULL,'2013AJ....146...86T',2013,1,0.56,NULL,'G',0.000007,NULL,'15.5g',0.47,'S',NULL,NULL,NULL,NULL,1,240.478417,16.45458,0.029,NULL,56572486132,883945095,13811642,15.5),(134466,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134466,35.95,0.18,155,63531,70,NULL,NULL,'GIN 466',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134467,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134467,36.14,0.05,169,63531,70,NULL,NULL,'GIN 466',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134468,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134468,37.15,0.46,269,63532,70,NULL,NULL,'2MASX J16015557+2439581',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.481583333,24.66622,0.189,NULL,59863687168,935370112,14615158,17.9),(134469,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134469,36.04,0.42,161,63533,NULL,NULL,'Malmquist cor.','KUG 1559+135',NULL,'2009ApJS..182..474S',2009,1,0.6,'The position in 1985AnTok..202.237T is 22 arcsec south of the nucleus.','G',0.000157,NULL,'15.5',0.1,'Spiral',NULL,NULL,NULL,NULL,1,240.484167,13.40644,0.141,NULL,56556476339,883694942,13807733,15.5),(134470,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134470,36.39,0.35,189,63533,NULL,NULL,NULL,'KUG 1559+135',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134471,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134471,36.49,0.2,199,63533,74.4,NULL,NULL,'KUG 1559+135',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134472,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134472,36.9,0.46,240,63534,70,NULL,NULL,'2MASX J16015750+3707498',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000177,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,240.48975,37.13064,0.041,NULL,59776325395,934005084,14593829,16.6),(134473,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134473,38.26,0.46,448,63535,70,NULL,NULL,'2MASX J16015820+1452441',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.492583,14.87906,0.069,NULL,56559191371,883737365,13808396,18),(134474,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134474,36.11,0.33,166,63536,70,NULL,NULL,'NGC 6029',NULL,'2015arXiv151105856S',2015,1,0.68,'Star superposed 5\\\" to the north of the nucleus.','G',0.000012,NULL,'15.7g',0.47,'Compact',NULL,NULL,NULL,NULL,1,240.4952917,12.57403,0.109,NULL,56548597068,883571829,13805809,15.7),(134475,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134475,38.21,0.46,439,63537,70,NULL,NULL,'SDSS J160159.50+500458.2',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000144,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.498,50.08283,0.041,NULL,59705924515,932905070,14576641,18.1),(134476,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134476,37.02,0.46,254,63538,70,NULL,NULL,'2MASX J16020024+4920461',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000116,NULL,'15.9g',0.38,'S0',NULL,NULL,NULL,NULL,1,240.5007917,49.34625,0.037,NULL,59711354775,932989918,14577967,15.9),(134477,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134477,35.97,0.46,156,63539,70,NULL,NULL,'2MASX J16020022+4752549',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000161,NULL,'16.0g',0.31,'AGN+SF',NULL,NULL,NULL,NULL,1,240.5009583,47.88189,0.053,NULL,59713990691,933031104,14578611,16),(134478,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134478,38.33,0.46,464,63540,70,NULL,NULL,'2MASX J16020130+0022064',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000089,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,240.5052917,0.36842,0.381,NULL,56479753409,882496147,13789002,18.6),(134479,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134479,36.06,0.46,163,63541,70,NULL,NULL,'CGCG 250-040',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000173,NULL,'15.0g',0.46,'E0',NULL,NULL,NULL,NULL,1,240.506333,48.66375,0.037,NULL,59711883914,932998186,14578096,15),(134480,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134480,36.14,0.05,169,63542,70,NULL,NULL,'2MASX J16020214+1610081',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000083,NULL,'16.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,240.5087917,16.16889,0.037,NULL,56572378846,883943419,13811615,16.2),(134481,'Tully est','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134481,32.94,0.8,38.7,63543,75,NULL,'B','UGCA 411',NULL,'1988NBGC.C....0000T',1988,1,0.8,NULL,'G',0.000043,NULL,'15.1',0.5,'Pec','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.509125,18.81656,0.065,NULL,56511576128,882993377,13796771,15.1),(134482,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134482,37.53,0.46,320,63544,70,NULL,NULL,'2MASX J16020251+3247447',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000158,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,240.510375,32.79564,0.077,NULL,59764728123,933823876,14590998,16.8),(134483,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134483,37.68,0.46,344,63545,70,NULL,NULL,'2MASX J16020299+1519471',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,240.512417,15.32969,0.061,NULL,56569893371,883904583,13811009,NULL),(134484,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134484,37.17,0.46,272,63546,70,NULL,NULL,'2MASX J16020326+1048524',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,240.513625,10.81447,0.145,NULL,56580752130,884074252,13813660,16.5),(134485,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134485,38.24,0.46,445,63547,70,NULL,NULL,'SDSS J160203.64+331301.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.5152083,33.21703,0.073,NULL,59765638539,933838102,14591220,18.4),(134486,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134486,37.06,0.46,259,63548,70,NULL,NULL,'2MASX J16020402+5154451',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000179,NULL,'16.8g',NULL,NULL,NULL,NULL,NULL,NULL,1,240.516958333,51.91253,NULL,NULL,59701267952,932832311,14575504,16.8),(134487,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134487,36.14,0.05,169,63549,70,NULL,NULL,'CGCG 108-068',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.000053,NULL,'14.6g',0.63,'E','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.5177917,17.07586,0.049,NULL,56567237430,883863084,13810360,14.6),(134488,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134488,38.27,0.46,451,63550,70,NULL,NULL,'2MASX J16020516+1501452',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,240.5215,15.02922,0.065,NULL,56559153826,883736778,13808387,18.3),(134489,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134489,35.95,0.18,155,63551,70,NULL,NULL,'IC 1165 NED01',NULL,'2001MNRAS.321..277C',2001,1,0.7,'RC3 has z = 0.04969 +- 0.00032.','G',0.000197,NULL,'14.8g',0.63,'SA0- pec','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.533458333,15.69656,0.053,NULL,56571883879,883935685,13811495,14.8),(134490,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134490,35.74,0.25,141,63552,74.4,NULL,NULL,'IC 1165',NULL,'2013AJ....146...86T',2013,1,NULL,'VV misprints dec as +15d54\'.','GPair',NULL,NULL,NULL,NULL,NULL,'Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.534166667,15.69389,0.053,NULL,56571887291,883935738,13811495,NULL),(134491,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 2001bp',NULL,134491,38.43,0.3,444,63553,70,NULL,'SALT 2','SDSS J160208.91+364313.8',0.094859,'2013MNRAS.433.2240G',2013,1,0.23,NULL,'G',0.00006,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.537333,36.72056,0.025,NULL,59777125532,934017586,14594024,17.7),(134492,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134492,37.12,0.46,266,63554,70,NULL,NULL,'2MASX J16020943+5323179',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000074,NULL,'18.1g',0.15,'NLAGN',NULL,NULL,NULL,'Sy 2',1,240.5389583,53.38836,NULL,NULL,59698100820,932782825,14574731,18.1),(134493,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134493,36.14,0.05,169,63555,70,NULL,NULL,'2MASX J16021028+1556392',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000093,NULL,'17.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.542833,15.94425,0.029,NULL,56572582863,883946607,13811665,17.2),(134494,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134494,37.91,0.12,382,63556,70,NULL,NULL,'SDSS J160211.33+253629.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.54725,25.60811,0.129,NULL,59863886260,935373222,14615206,18.3),(134495,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134495,36.66,0.46,215,63557,70,NULL,NULL,'2MASX J16021152+3033468',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000168,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,240.548167,30.56297,0.073,NULL,59865931904,935405186,14615706,16.4),(134496,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134496,37.57,0.46,327,63558,70,NULL,NULL,'2MASX J16021220+2043155',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000151,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.5507917,20.72089,0.105,NULL,56512056464,883000882,13796888,17.2),(134497,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134497,35.74,0.25,141,63559,74.4,NULL,NULL,'UGC 10143 NOTES02',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.00007,NULL,'15.22',0.5,'E3','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.553375,15.90758,0.029,NULL,56571866715,883935417,13811490,15.22),(134498,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134498,35.95,0.18,155,63559,70,NULL,NULL,'UGC 10143 NOTES02',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134499,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134499,36.14,0.05,169,63559,70,NULL,NULL,'UGC 10143 NOTES02',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134500,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134500,38.53,0.46,508,63560,70,NULL,NULL,'SDSS J160212.92+080803.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000159,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.553875,8.13436,0.169,NULL,56583673735,884119902,13814373,18.5),(134501,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134501,35.67,0.46,136,63561,70,NULL,NULL,'2MASX J16021329+3605512',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000171,NULL,'15.9g',0.39,'S0',NULL,NULL,NULL,NULL,1,240.555291667,36.09747,0.041,NULL,59776589154,934009205,14593893,15.9),(134502,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134502,36.39,0.46,189,63562,70,NULL,NULL,'2MASX J16021377+5219059',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000161,NULL,'15.9g',0.39,'E0',NULL,NULL,NULL,NULL,1,240.55725,52.31825,NULL,NULL,59701568891,932837013,14575578,15.9),(134503,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134503,36.59,0.46,208,63563,70,NULL,NULL,'2MASX J16021426+3020188',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.5595,30.3385,0.093,NULL,59866075077,935407423,14615740,17.1),(134504,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134504,37.2,0.33,275,63564,70,NULL,NULL,'2MASX J16021499+2053075',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000141,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.562416667,20.88553,0.117,NULL,59400817436,928137772,14502152,18.1),(134505,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134505,36.11,0.33,166,63565,70,NULL,NULL,'2MASX J16021500+1237142',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.562583333,12.62072,0.097,NULL,56548648591,883572634,13805822,16.2),(134506,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134506,37.34,0.13,294,63566,70,NULL,NULL,'SDSS J160215.16+541449.0',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000077,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,240.5632083,54.24697,0.017,NULL,57608387408,900131053,14064547,17.6),(134507,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134507,37.18,0.46,273,63567,70,NULL,NULL,'2MASX J16021630+0033424',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000092,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.567917,0.56172,0.369,NULL,56479966023,882499469,13789054,17.4),(134508,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134508,37.42,0.46,305,63568,70,NULL,NULL,'2MASX J16021645+4300459',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.5685,43.01275,0.009,NULL,59804413789,934443965,14600686,17.5),(134509,'BCG','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134509,36.5,0.35,192,63569,60,NULL,'ABELL 2147, BCG','UGC 10143',0.0377,'1980ApJ...241..486H',1980,1,1.23,NULL,'G',0.000077,NULL,'14.4g',0.73,'cD;E+;BrClG','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.570958333,15.97467,0.029,NULL,56572583066,883946610,13811665,14.4),(134510,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134510,35.74,0.25,141,63569,74.4,NULL,NULL,'UGC 10143',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134511,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134511,35.95,0.18,155,63569,70,NULL,NULL,'UGC 10143',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134512,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134512,36.14,0.05,169,63569,70,NULL,NULL,'UGC 10143',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134513,'Magnitude','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134513,36.11,NULL,167,63569,NULL,NULL,'ABELL 2147 cluster','UGC 10143',NULL,'1995A&A...302...21G',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134514,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134514,35.93,0.4,153,63569,NULL,NULL,'mean','UGC 10143',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134515,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134515,35.95,0.08,155,63569,70,NULL,'ABELL 2147, BGC','UGC 10143',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134516,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134516,36.21,0.45,174,63569,NULL,NULL,'K','UGC 10143',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134517,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134517,37.2,0.33,275,63570,70,NULL,NULL,'2MASX J16021699+2056165',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000156,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.570875,20.93783,0.117,NULL,59400830575,928137977,14502155,17.1),(134518,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134518,36.14,0.05,169,63571,70,NULL,NULL,'2MASX J16021755+1600102',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00006,NULL,'16.5g',0.24,'E',NULL,NULL,NULL,NULL,1,240.5732917,16.00294,0.029,NULL,56572588878,883946701,13811667,16.5),(134519,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134519,35.76,0.25,142,63572,74.4,NULL,NULL,'ARK 495',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000093,NULL,'15.3B',0.6,'S?','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.575083,16.36622,0.029,NULL,56572499666,883945307,13811645,15.3),(134520,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134520,35.95,0.18,155,63572,70,NULL,NULL,'ARK 495',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134521,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134521,36.14,0.05,169,63572,70,NULL,NULL,'ARK 495',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134522,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134522,37.96,0.46,391,63573,70,NULL,NULL,'2MASX J16021862+2307045',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000145,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.5777083,23.11786,0.165,NULL,59394699388,928042177,14500659,18),(134523,'BCG','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134523,36.5,0.35,192,63574,60,NULL,NULL,'ABELL 2147',0.0377,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.577917,16.02,0.029,NULL,56572588137,883946689,13811667,NULL),(134524,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134524,35.95,0.08,155,63574,70,NULL,NULL,'ABELL 2147',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134525,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134525,37.15,0.46,269,63575,70,NULL,NULL,'2MASX J16021944+3238408',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000164,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.5809583,32.64481,0.077,NULL,59764765365,933824458,14591007,17.3),(134526,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134526,36.14,0.05,169,63576,70,NULL,NULL,'2MASX J16021949+1618062',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000177,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,240.581291667,16.30164,0.037,NULL,56572334601,883942728,13811605,17.2),(134527,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134527,35.76,0.25,142,63577,74.4,NULL,NULL,'UGC 10144',NULL,'2013AJ....146...86T',2013,1,1.16,NULL,'G',0.000093,NULL,'14.2g',0.9,'E;BrClG','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.5827083,16.34603,0.037,NULL,56572456432,883944631,13811634,14.2),(134528,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134528,35.95,0.18,155,63577,70,NULL,NULL,'UGC 10144',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134529,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134529,36.14,0.05,169,63577,70,NULL,NULL,'UGC 10144',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134530,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134530,35.78,0.45,144,63577,NULL,NULL,'K','UGC 10144',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134531,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134531,36.12,0.4,168,63577,NULL,NULL,'mean','UGC 10144',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134532,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134532,37.59,0.46,329,63578,70,NULL,NULL,'2MASX J16021997+4513199',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000147,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.583333,45.22233,0.065,NULL,59681431358,932522364,14570661,18),(134533,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134533,38.32,0.46,461,63579,70,NULL,NULL,'2MASX J16022018+2038455',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.584125,20.646,0.105,NULL,56512065514,883001023,13796890,17.9),(134534,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134534,37.65,0.46,340,63580,70,NULL,NULL,'2MASX J16022052+3433398',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000138,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,240.585458333,34.561,0.053,NULL,59768652533,933885195,14591956,18),(134535,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134535,37.15,0.46,269,63581,70,NULL,NULL,'2MASX J16022074+1925345',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.586416667,19.42636,0.061,NULL,56513092439,883017069,13797141,17.4),(134536,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134536,37.86,0.46,374,63582,70,NULL,NULL,'SDSS J160221.26+121546.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.588625,12.26303,0.113,NULL,56548059377,883563427,13805678,18.4),(134537,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134537,36.5,0.46,199,63583,70,NULL,NULL,'2MASX J16022160+1359512',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,240.589917,13.99747,0.117,NULL,56559918907,883748732,13808573,16.2),(134538,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134538,37.91,0.12,382,63584,70,NULL,NULL,'2MASX J16022251+2532576',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000188,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.5939583,25.54928,0.137,NULL,59863920098,935373751,14615214,18.1),(134539,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134539,36.14,0.05,169,63585,70,NULL,NULL,'SDSS J160223.00+155622.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000186,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.595875,15.93964,0.049,NULL,56572580691,883946573,13811665,17.6),(134540,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134540,36.14,0.05,169,63586,70,NULL,NULL,'2MASX J16022333+1559469',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000057,NULL,'16.7g',NULL,NULL,NULL,NULL,NULL,NULL,1,240.5972083,15.99644,0.029,NULL,56572581455,883946585,13811665,16.7),(134541,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134541,35.77,0.46,142,63587,70,NULL,NULL,'CGCG 195-007',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000117,NULL,'14.8g',0.58,'E0',NULL,NULL,NULL,NULL,1,240.5982917,36.10989,0.041,NULL,59776655468,934010241,14593910,14.8),(134542,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134542,36.64,0.14,212,63588,70,NULL,NULL,'2MASX J16022454+1815585',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00015,NULL,'15.5g',0.48,'S0/E3','Group member',NULL,NULL,NULL,1,240.602333,18.26633,0.081,NULL,56511550660,882992979,13796765,15.5),(134543,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134543,38.96,0.46,619,63589,70,NULL,NULL,'SDSS J160224.74+063735.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.603125,6.62647,0.165,NULL,56627368244,884802628,13825041,18.5),(134544,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134544,38.21,0.46,439,63590,70,NULL,NULL,'2MASX J16022497+3331358',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,240.604083,33.52661,0.085,NULL,59765025787,933828527,14591070,18.1),(134545,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134545,36.14,0.05,169,63591,70,NULL,NULL,'2MASX J16022500+1556449',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00006,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.604125,15.94589,0.049,NULL,56572579963,883946561,13811665,17.3),(134546,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134546,36.14,0.05,169,63592,70,NULL,NULL,'SDSS J160225.69+162113.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000145,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.6070417,16.35383,0.029,NULL,56572455578,883944618,13811634,17.5),(134547,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134547,38.58,0.46,521,63593,70,NULL,NULL,'SDSS J160225.88+360317.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000161,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,240.607833,36.05497,0.041,NULL,59776659345,934010302,14593910,18.7),(134548,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134548,37.36,0.46,296,63594,70,NULL,NULL,'2MASX J16022885+3002178',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000179,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,240.6202917,30.03828,0.093,NULL,59868735487,935448991,14616390,17),(134549,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134549,37.84,0.46,369,63595,70,NULL,NULL,'2MASX J16022908+4835481',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,240.621125,48.59686,0.037,NULL,59711892046,932998313,14578098,18.1),(134550,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134550,38.37,0.46,473,63596,70,NULL,NULL,'2MASX J16022955+1043228',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.623041667,10.72306,0.145,NULL,56580715291,884073676,13813651,18.4),(134551,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134551,37.11,0.66,264,63597,70,NULL,NULL,'2MASX J16022986-0413353',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,240.624375,-4.22656,0.549,NULL,45524659109,711322798,11114418,15.8),(134552,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134552,37.46,0.42,310,63598,70,NULL,NULL,'GIN 482',NULL,'2001MNRAS.321..277C',2001,1,0.29,NULL,'G',0.000091,NULL,'16.9g',0.23,'S',NULL,NULL,NULL,NULL,1,240.626166667,25.60161,0.137,NULL,59863883947,935373186,14615206,16.9),(134553,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134553,34.09,0.46,65.7,63599,70,NULL,NULL,'CGCG 137-019',NULL,'2015arXiv151105856S',2015,1,0.96,NULL,'G',0.00008,NULL,'14.2g',0.83,'E','Supercluster foreground object',NULL,NULL,NULL,1,240.627,21.12072,0.129,NULL,59400841985,928138156,14502158,14.2),(134554,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134554,38.13,0.46,423,63600,70,NULL,NULL,'2MASX J16023047+2010355',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000147,NULL,'16.6g',0.32,'S',NULL,NULL,NULL,NULL,1,240.627041667,20.17647,0.085,NULL,56512994276,883015535,13797117,16.6),(134555,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134555,36.74,0.46,222,63601,70,NULL,NULL,'2MASX J16023169+3534168',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000177,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.6320417,35.57122,0.045,NULL,59776447609,934006993,14593859,16.6),(134556,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134556,36.14,0.05,169,63602,70,NULL,NULL,'CGCG 108-077',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000093,NULL,'15.7',0.4,'S0','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.636375,14.55494,0.077,NULL,56559331728,883739558,13808430,15.7),(134557,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134557,34.45,0.59,77.6,63603,NULL,NULL,'Malmquist cor.','ESO 516- G 002',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.00002,NULL,'16',0.7,'Sb',NULL,NULL,NULL,NULL,1,240.643041667,-25.80669,0.477,NULL,47113717533,736151836,11502372,16),(134558,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134558,34.58,0.56,82.5,63603,NULL,NULL,NULL,'ESO 516- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134559,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134559,34.62,0.2,84,63603,74.4,NULL,NULL,'ESO 516- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134560,'IRAS','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134560,33.76,0.8,56.5,63604,75,NULL,'HMCL, I','ESO 136- G 012',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000017,NULL,'16.1',1,'SB(s)c:;tidal feat.',NULL,NULL,NULL,NULL,1,240.647875,-61.77453,NULL,NULL,44379364979,693427577,10834805,16.1),(134561,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134561,32.29,0.4,28.7,63604,75,NULL,'HMCL, I, raw','ESO 136- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134562,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134562,32.39,0.4,30,63604,75,NULL,'HMCL, I, inv','ESO 136- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134563,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134563,32.63,0.4,33.6,63604,75,NULL,'HMCL, I, cor','ESO 136- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134564,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134564,36.14,0.05,169,63605,70,NULL,NULL,'2MASX J16023573+1420079',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.649,14.33558,0.105,NULL,56559731721,883745808,13808528,16.6),(134565,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134565,36.14,0.05,169,63606,70,NULL,NULL,'2MASX J16023619+1628509',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000157,NULL,'16.1g',0.42,'E',NULL,NULL,NULL,NULL,1,240.651,16.48078,0.029,NULL,56572502472,883945351,13811646,16.1),(134566,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134566,37.26,0.33,283,63607,70,NULL,NULL,'SDSS J160236.88-000906.9',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000118,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,240.653667,-0.15192,0.397,NULL,45525298383,711332787,11114574,16.8),(134567,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134567,36.85,0.46,234,63608,70,NULL,NULL,'2MASX J16023811+0830138',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000138,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.658833,8.50381,0.157,NULL,56584239726,884128745,13814511,17.7),(134568,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134568,37.26,0.33,283,63609,70,NULL,NULL,'2MASX J16023973-0005113',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000088,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.6654583,-0.08653,0.397,NULL,45525292317,711332692,11114573,17.5),(134569,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134569,35.75,0.25,141,63610,74.4,NULL,NULL,'GIN 464',NULL,'2013AJ....146...86T',2013,1,0.14,NULL,'G',0.000073,NULL,'16.8g',0.12,'S0',NULL,NULL,NULL,NULL,1,240.668167,15.756,0.053,NULL,56571924647,883936322,13811505,16.8),(134570,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134570,35.95,0.18,155,63610,70,NULL,NULL,'GIN 464',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134571,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134571,33.11,0.2,40.5,63611,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','NGC 6038',0.03133,'2011A&A...526A..81B',2011,1,1.16,NULL,'G',0.000077,NULL,'13.9g',0.99,'Sc',NULL,NULL,NULL,NULL,1,240.6689583,37.3595,0.017,NULL,59774464592,933976009,14593375,13.9),(134572,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134572,34.99,0.22,96.5,63611,74.2,NULL,'SALT 2','NGC 6038',0.03133,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134573,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134573,35.58,0.2,127,63611,72,NULL,NULL,'NGC 6038',0.03133,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134574,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134574,35.55,0.08,129,63611,74.4,NULL,NULL,'NGC 6038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134575,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc','R',134575,35.56,0.12,129,63611,NULL,NULL,'MLCS2k2, R(V) = 1.8','NGC 6038',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134576,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134576,35.64,0.16,130,63611,70,NULL,'SALT 2','NGC 6038',0.03133,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134577,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc','R',134577,35.58,0.12,131,63611,NULL,NULL,'MLCS2k2, R(V) = 3.1','NGC 6038',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134578,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134578,35.68,0.07,132,63611,65,NULL,'SALT2','NGC 6038',0.03133,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134579,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134579,35.69,0.16,133,63611,73.8,NULL,'SALT 2 (SNANA)','NGC 6038',0.0318,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134580,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134580,35.72,0.04,135,63611,72,NULL,NULL,'NGC 6038',0.03133,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134581,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134581,35.65,0.17,135,63611,72,NULL,NULL,'NGC 6038',NULL,'2006AJ....131.1639K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134582,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134582,35.66,0.17,136,63611,70.8,NULL,NULL,'NGC 6038',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134583,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134583,35.73,0.27,136,63611,70,NULL,'SALT','NGC 6038',0.03133,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134584,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134584,35.86,0.09,140,63611,65,NULL,'MLCS2k2','NGC 6038',0.03133,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134585,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134585,35.79,0.07,140,63611,70,NULL,NULL,'NGC 6038',0.03133,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134586,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134586,35.81,0.15,141,63611,65,NULL,'MLCS31','NGC 6038',0.03133,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134587,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134587,35.82,0.09,142,63611,65,NULL,'MLCS2k2','NGC 6038',0.03133,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134588,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134588,35.83,0.15,142,63611,65,NULL,'MLCS17','NGC 6038',0.03133,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134589,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134589,35.85,0.19,143,63611,65,NULL,NULL,'NGC 6038',0.03133,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134590,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134590,35.86,0.19,144,63611,65,NULL,'SALT2','NGC 6038',0.03133,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134591,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134591,35.87,0.27,144,63611,65,NULL,'SALT','NGC 6038',0.03133,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134592,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134592,35.88,0.05,145,63611,65,NULL,'MLCS2k2','NGC 6038',0.03133,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134593,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134593,35.98,0.01,152,63611,65,NULL,'SALT','NGC 6038',0.03133,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134594,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134594,36.09,0.14,165,63611,60,NULL,NULL,'NGC 6038',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134595,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134595,36.3,0.02,177,63611,70,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','NGC 6038',0.03133,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134596,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134596,35.91,0.46,152,63612,70,NULL,NULL,'2MASX J16024099+2712269',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',NULL,NULL,'17.06',0.39,NULL,NULL,NULL,NULL,NULL,1,240.67075,27.20742,0.101,NULL,59876402242,935568785,14618262,17.06),(134597,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134597,37.25,0.46,282,63613,70,NULL,NULL,'2MASX J16024116+3318033',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.671375,33.30094,0.097,NULL,59764983564,933827868,14591060,17.2),(134598,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134598,38.33,0.46,464,63614,70,NULL,NULL,'2MASX J16024111+3959179',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.6715,39.98819,0.013,NULL,59795440105,934303751,14598496,17.3),(134599,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134599,37.94,0.46,388,63615,70,NULL,NULL,'SDSS J160241.74+382413.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.6739583,38.40378,0.017,NULL,59762696453,933792132,14590502,17.8),(134600,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134600,37.39,0.46,301,63616,70,NULL,NULL,'2MASX J16024268+3755089',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00015,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,240.678,37.91922,0.021,NULL,59775051746,933985183,14593518,16.9),(134601,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134601,36.14,0.05,169,63617,70,NULL,NULL,'2MASX J16024513+1614539',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000067,NULL,'15.7g',0.43,'E',NULL,NULL,NULL,NULL,1,240.6879583,16.24819,0.037,NULL,56572610085,883947032,13811672,15.7),(134602,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134602,37.84,0.33,370,63618,70,NULL,NULL,'SDSS J160246.38+395054.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000135,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.69325,39.84856,0.025,NULL,59795115205,934298675,14598416,17.9),(134603,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134603,35.95,0.46,155,63619,70,NULL,NULL,'CGCG 108-080',NULL,'2015arXiv151105856S',2015,1,0.7,'2011ApJ...735..125S gives z=0.0386968.','G',0.000627,NULL,'15.34',0.5,'E','Supercluster foreground object',NULL,NULL,NULL,1,240.69775,19.78725,0.073,NULL,56512661655,883010338,13797036,15.34),(134604,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134604,37.34,0.25,294,63620,74.4,NULL,NULL,'GIN 486',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000177,NULL,'17.4g',0.21,'E/S0',NULL,NULL,NULL,NULL,1,240.698917,25.50919,0.137,NULL,59864328035,935380125,14615314,17.4),(134605,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134605,37.46,0.42,310,63620,70,NULL,NULL,'GIN 486',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134606,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134606,37.91,0.12,382,63620,70,NULL,NULL,'GIN 486',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134607,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134607,36.14,0.05,169,63621,70,NULL,NULL,'2MASX J16024803+1643228',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000133,NULL,'16.0g',0.36,'E',NULL,NULL,NULL,NULL,1,240.700167,16.723,0.029,NULL,56568942047,883889719,13810776,16),(134608,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134608,36.14,0.05,169,63622,70,NULL,NULL,'CGCG 108-078',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000073,NULL,'15.2g',0.45,'(R)SAB0+','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.702625,16.11936,0.041,NULL,56572619159,883947174,13811674,15.2),(134609,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134609,36.14,0.05,169,63623,70,NULL,NULL,'2MASX J16024920+1710028',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00009,NULL,'15.5g',0.38,'S0','Group member',NULL,NULL,NULL,1,240.705083,17.16742,0.049,NULL,56568999116,883890611,13810790,15.5),(134610,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134610,35.91,0.49,152,63624,75,NULL,'IR','2MFGC 12872',NULL,'2011yCatp016004901K',2011,1,0.69,NULL,'G',0.000027,NULL,'16.6g',0.18,'S/I','Group member',NULL,NULL,NULL,1,240.706917,18.44561,0.077,NULL,56511797946,882996842,13796825,16.6),(134611,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134611,37.02,0.46,253,63625,70,NULL,NULL,'2MASX J16025188+3350405',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,240.716125,33.84467,0.061,NULL,59768503204,933882862,14591919,16.2),(134612,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134612,35.79,0.46,144,63626,70,NULL,NULL,'2MASX J16025193+1531485',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000093,NULL,'15.8g',0.34,'E',NULL,NULL,NULL,NULL,1,240.7164583,15.53008,0.057,NULL,56571747650,883933557,13811461,15.8),(134613,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134613,36.34,0.46,185,63627,70,NULL,NULL,'2MASX J16025250+3418275',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000177,NULL,'16.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.7187083,34.30753,0.037,NULL,59768679723,933885620,14591962,16.2),(134614,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134614,36.69,0.27,218,63628,70,NULL,NULL,'2MASX J16025271+1856315',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.719625,18.94214,0.057,NULL,56511240557,882988133,13796689,16.9),(134615,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134615,37.56,0.46,325,63629,70,NULL,NULL,'2MASX J16025270+3728109',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00012,NULL,'16.2g',0.34,'E0',NULL,NULL,NULL,NULL,1,240.719708333,37.46961,0.013,NULL,59774430648,933975478,14593366,16.2),(134616,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134616,36.13,0.46,169,63630,70,NULL,NULL,'2MASX J16025280+2356079',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000161,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,240.7199583,23.93558,0.197,NULL,59393078728,928016855,14500263,16.5),(134617,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134617,36.48,0.33,197,63631,70,NULL,NULL,'ARK 496',NULL,'2015arXiv151105856S',2015,1,0.75,'1992ApJS...79..157F has V = 8586 +- 100 km/s.','G',0.00022,NULL,'15.3g',0.53,'S0',NULL,NULL,NULL,NULL,1,240.725083333,33.13464,0.085,NULL,59765078547,933829352,14591083,15.3),(134618,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134618,35.29,0.49,114,63632,70,NULL,NULL,'2MASX J16025491-3328177',NULL,'2014MNRAS.445.2677S',2014,1,0.69,NULL,'G',0.000103,NULL,'15.05',0.56,'E',NULL,NULL,NULL,NULL,1,240.728833333,-33.47164,0.901,NULL,46263880906,722873139,11294892,15.05),(134619,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134619,37.76,0.46,357,63633,70,NULL,NULL,'2MASX J16025756+1835344',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000181,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,240.739833333,18.59281,0.065,NULL,56511923507,882998804,13796856,17.6),(134620,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134620,36.74,0.46,223,63634,70,NULL,NULL,'SDSS J160257.84+400416.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,240.7410417,40.07111,0.013,NULL,59809283147,934520049,14601875,17.9),(134621,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134621,37.46,0.33,310,63635,70,NULL,NULL,'2MASX J16025842+2220034',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000155,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,240.7435,22.33425,0.161,NULL,59394459161,928038424,14500600,17.3),(134622,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134622,36.48,0.33,197,63636,70,NULL,NULL,'2MASX J16025866+3309185',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000183,NULL,'15.7g',0.45,'E0',NULL,NULL,NULL,NULL,1,240.744417,33.15519,0.085,NULL,59765077283,933829332,14591083,15.7),(134623,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134623,36.14,0.05,169,63637,70,NULL,NULL,'CGCG 108-081',NULL,'2015arXiv151105856S',2015,1,0.91,NULL,'G',0.00006,NULL,'14.9g',0.5,'(R\')SB(s)0/a','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.744917,15.84283,0.049,NULL,56571921491,883936273,13811504,14.9),(134624,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134624,38.3,0.33,457,63638,70,NULL,NULL,'2MASX J16025884+3330245',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000146,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,240.745041667,33.50678,0.085,NULL,59765015634,933828369,14591068,18.5),(134625,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134625,33.95,0.49,61.5,63639,75,NULL,'IR','UGC 10212',NULL,'2011yCatp016004901K',2011,1,1.66,NULL,'G',0.000053,NULL,'16.0',0.19,'Sbc',NULL,NULL,NULL,NULL,1,240.752625,77.60639,0.189,NULL,57168574337,893258974,13957171,16),(134626,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134626,34.1,0.2,66.1,63639,74.4,NULL,NULL,'UGC 10212',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134627,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134627,34.11,NULL,66.5,63639,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10212',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134628,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134628,34.13,NULL,66.9,63639,NULL,NULL,'Dipole + Quadrupole','UGC 10212',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134629,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134629,34.13,NULL,66.9,63639,NULL,NULL,'Dipole','UGC 10212',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134630,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134630,34.17,0.53,68.2,63639,NULL,NULL,NULL,'UGC 10212',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134631,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134631,34.24,0.51,70.4,63639,NULL,NULL,'Malmquist cor.','UGC 10212',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134632,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134632,34.7,NULL,87.2,63639,NULL,NULL,NULL,'UGC 10212',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134633,'IRAS','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134633,33.81,0.8,57.9,63640,75,NULL,'HMCL, I','NGC 6032',NULL,'1997ApJS..109..333W',1997,1,1.63,NULL,'G',0.000027,NULL,'14.3g',0.77,'SB(rs)b:','Supercluster foreground object',NULL,NULL,NULL,1,240.754667,20.95594,0.117,NULL,56512012744,883000199,13796878,14.3),(134634,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134634,32.73,0.4,35.2,63640,75,NULL,'HMCL, I, raw','NGC 6032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134635,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134635,32.83,0.4,36.8,63640,75,NULL,'HMCL, I, inv','NGC 6032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134636,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134636,33.09,0.4,41.5,63640,75,NULL,'HMCL, I, cor','NGC 6032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134637,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134637,33.25,0.49,44.7,63640,75,NULL,'IR','NGC 6032',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134638,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134638,33.97,0.4,62.3,63640,NULL,NULL,'mean','NGC 6032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134639,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134639,34.09,0.47,65.7,63640,NULL,NULL,'H','NGC 6032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134640,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134640,34.17,0.46,68.3,63640,NULL,NULL,'J','NGC 6032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134641,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134641,34.21,0.45,69.5,63640,NULL,NULL,'K','NGC 6032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134642,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134642,38.35,0.46,468,63641,70,NULL,NULL,'2MASX J16030161+5314232',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000081,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,240.756708333,53.23989,0.009,NULL,59700959532,932827492,14575429,17.2),(134643,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134643,38.65,0.46,537,63642,70,NULL,NULL,'2MASX J16030269+2703432',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000184,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.761167,27.062,0.121,NULL,59876441286,935569395,14618271,17.9),(134644,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134644,36.98,0.46,248,63643,70,NULL,NULL,'2MASX J16030310+0517322',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000192,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.7629583,5.29217,0.173,NULL,56480666113,882510408,13789225,17.1),(134645,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134645,37.32,0.25,291,63644,74.4,NULL,NULL,'GIN 479',NULL,'2013AJ....146...86T',2013,1,0.37,NULL,'G',0.000097,NULL,'16.7g',0.31,'E/S0',NULL,NULL,NULL,NULL,1,240.764083333,25.45303,0.157,NULL,59864320549,935380008,14615312,16.7),(134646,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134646,37.46,0.42,310,63644,70,NULL,NULL,'GIN 479',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134647,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134647,37.91,0.12,382,63644,70,NULL,NULL,'GIN 479',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134648,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134648,37.46,0.46,311,63645,70,NULL,NULL,'2MASX J16030346+0301382',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000064,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,240.764333,3.02719,0.257,NULL,56482732133,882542689,13789729,18.1),(134649,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134649,37.77,0.46,358,63646,70,NULL,NULL,'2MASX J16030395+4039109',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.766375,40.65308,0,NULL,59809420749,934522199,14601909,17.8),(134650,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134650,36.69,0.27,218,63647,70,NULL,NULL,'2MASX J16030414+1910565',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000093,NULL,'17.11',0.35,'S',NULL,NULL,NULL,NULL,1,240.767208333,19.18239,0.057,NULL,56513162829,883018169,13797158,17.11),(134651,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134651,36.14,0.05,169,63648,70,NULL,NULL,'2MASX J16030532+1616015',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000097,NULL,'16.4g',0.23,'S',NULL,NULL,NULL,NULL,1,240.7722917,16.26694,0.041,NULL,56572742742,883949105,13811704,16.4),(134652,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1968K',NULL,134652,35.22,0.29,111,63649,NULL,NULL,'Avg. of 8 SN host galaxies','SDSS J160305.72+171020.3',NULL,'1985ApJ...297...23D',1985,1,0.49,NULL,'G',0.000013,NULL,'17.1g',0.16,'Sd/I','Group member',NULL,NULL,NULL,1,240.773875,17.17233,0.049,NULL,56569034331,883891161,13810799,17.1),(134653,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134653,38.3,0.33,457,63650,70,NULL,NULL,'2MASX J16030691+3337336',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000185,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,240.778625,33.62614,0.073,NULL,59765004783,933828199,14591065,17.1),(134654,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134654,38.24,0.33,445,63651,70,NULL,NULL,'2MASX J16030774+1251125',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.7822083,12.85358,0.093,NULL,56548452003,883569562,13805774,16.8),(134655,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134655,37.59,0.33,330,63652,70,NULL,NULL,'2MASX J16030833+0258252',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000081,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.7847917,2.97361,0.257,NULL,56484768106,882574501,13790226,17.3),(134656,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134656,38.24,0.33,445,63653,70,NULL,NULL,'2MASX J16030836+1247105',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,240.784833333,12.78628,0.093,NULL,56548458374,883569662,13805775,18.4),(134657,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134657,38.62,0.46,530,63654,70,NULL,NULL,'2MASX J16030916+3812119',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000155,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,240.788041667,38.20328,0.009,NULL,59774199240,933971863,14593310,17.5),(134658,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134658,37.91,0.12,382,63655,70,NULL,NULL,'2MASX J16030947+2519102',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,240.7895417,25.31969,0.157,NULL,59864646423,935385100,14615392,18.2),(134659,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134659,37.83,0.46,368,63656,70,NULL,NULL,'2MASX J16031058+3555508',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000143,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.794291667,35.93069,0.061,NULL,59776674133,934010533,14593914,17.4),(134660,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134660,36.14,0.05,169,63657,70,NULL,NULL,'2MASX J16031074+1548265',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00006,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.794708333,15.80739,0.049,NULL,56571934276,883936473,13811507,16.9),(134661,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134661,37.27,0.46,284,63658,70,NULL,NULL,'2MASX J16031112+2804292',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.796375,28.07472,0.085,NULL,59875867264,935560426,14618131,17.2),(134662,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134662,37.08,0.46,261,63659,70,NULL,NULL,'SDSS J160311.43+201329.3',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.0g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.797667,20.22481,0.085,NULL,56512844898,883013201,13797081,17),(134663,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134663,37.46,0.33,310,63660,70,NULL,NULL,'2MASX J16031276+2217115',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,240.80325,22.28664,0.161,NULL,59394472003,928038625,14500603,17.4),(134664,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134664,37.46,0.46,311,63661,70,NULL,NULL,'2MASX J16031281+4712587',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000188,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,240.803333,47.21628,0.029,NULL,59710955055,932983672,14577869,16.5),(134665,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134665,36.14,0.05,169,63662,70,NULL,NULL,'2MASX J16031352+1453395',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000103,NULL,'16.0g',0.31,'E',NULL,NULL,NULL,NULL,1,240.806333333,14.89436,0.109,NULL,56557545506,883711648,13807994,16),(134666,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134666,38.41,0.46,481,63663,70,NULL,NULL,'SDSS J160313.95+245248.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000173,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.808167,24.88003,0.185,NULL,59863577644,935368400,14615131,17.9),(134667,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134667,37.98,0.46,394,63664,70,NULL,NULL,'SDSS J160314.17+120954.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.809083,12.16525,0.113,NULL,56577507934,884023561,13812868,18.3),(134668,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134668,35.75,0.25,141,63665,74.4,NULL,NULL,'CGCG 108-082',NULL,'2013AJ....146...86T',2013,1,0.85,NULL,'G',0.00007,NULL,'14.9g',0.59,'E+','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.811417,16.40283,0.029,NULL,56572535849,883945872,13811654,14.9),(134669,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134669,35.95,0.18,155,63665,70,NULL,NULL,'CGCG 108-082',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134670,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134670,36.14,0.05,169,63665,70,NULL,NULL,'CGCG 108-082',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134671,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134671,37.22,0.46,278,63666,70,NULL,NULL,'2MASX J16031483+0816375',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000167,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.811875,8.277,0.157,NULL,56583604147,884118814,13814356,17),(134672,'IRAS','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134672,34.29,0.8,72.1,63667,75,NULL,'MAT, I','ESO 584- G 004',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00002,NULL,'15',1.2,'Sb             HII',NULL,NULL,NULL,NULL,1,240.812333,-22.32278,0.529,NULL,46575613214,727743956,11370999,15),(134673,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134673,34.05,0.32,64.6,63667,85,NULL,'I, raw','ESO 584- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134674,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134674,34.06,0.43,64.9,63667,75,NULL,'MAT, I, raw','ESO 584- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134675,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134675,34.1,0.32,66.2,63667,85,NULL,'I, inv','ESO 584- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134676,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134676,34.29,0.43,72.2,63667,75,NULL,'MAT, I, inv','ESO 584- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134677,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134677,34.32,0.43,73.2,63667,75,NULL,'MAT, I, cor','ESO 584- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134678,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134678,34.46,0.2,78,63667,74.4,NULL,NULL,'ESO 584- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134679,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134679,34.47,0.48,78.4,63667,NULL,NULL,NULL,'ESO 584- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134680,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134680,34.64,0.45,84.6,63667,NULL,NULL,'Malmquist cor.','ESO 584- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134681,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134681,36.98,0.46,249,63668,70,NULL,NULL,'2MASX J16031521+1844215',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00015,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,240.813333,18.73925,0.065,NULL,56511938571,882999040,13796860,16.9),(134682,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134682,37.91,0.12,382,63669,70,NULL,NULL,'2MASX J16031581+2520342',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000174,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.815833,25.34294,0.157,NULL,59865170239,935393284,14615520,18),(134683,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134683,36.69,0.27,218,63670,70,NULL,NULL,'2MASX J16031593+1905035',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000153,NULL,'15.4',0.31,'S',NULL,NULL,NULL,NULL,1,240.816417,19.08419,0.057,NULL,56511298452,882989038,13796703,15.4),(134684,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134684,39.01,0.33,633,63671,70,NULL,NULL,'SDSS J160316.07+335201.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,240.8169583,33.86717,0.061,NULL,59768480472,933882507,14591914,18.7),(134685,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134685,37.43,0.33,306,63672,70,NULL,NULL,'2MASX J16031669+2655562',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.819541667,26.93247,0.121,NULL,59876416603,935569009,14618265,18),(134686,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134686,35.89,0.46,151,63673,70,NULL,NULL,'2MASX J16031694+0300442',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000081,NULL,'16.3g',0.31,'S0',NULL,NULL,NULL,NULL,1,240.8205,3.01219,0.257,NULL,56484765867,882574466,13790226,16.3),(134687,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134687,37.59,0.33,330,63674,70,NULL,NULL,'SDSS J160317.04+025156.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000072,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,240.8210417,2.86564,0.257,NULL,56484809847,882575153,13790236,18.3),(134688,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134688,36.69,0.46,218,63675,70,NULL,NULL,'2MASX J16031792+0731325',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000189,NULL,'16.0g',0.4,NULL,NULL,NULL,NULL,NULL,1,240.8247083,7.52575,0.153,NULL,56581733499,884089585,13813899,16),(134689,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134689,37.06,0.46,258,63676,70,NULL,NULL,'2MASXi J1603185+373511',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.827208333,37.58664,0.013,NULL,59774910332,933982973,14593483,17.4),(134690,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134690,37.05,0.46,257,63677,70,NULL,NULL,'2MASX J16031890+2820052',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,240.8287083,28.33492,0.077,NULL,59867537664,935430276,14616098,17.6),(134691,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134691,37.34,0.25,294,63678,74.4,NULL,NULL,'GIN 478',NULL,'2013AJ....146...86T',2013,1,0.62,NULL,'G',0.000113,NULL,'16.1g',0.37,'cD;BrClG',NULL,NULL,NULL,NULL,1,240.832667,25.45372,0.157,NULL,59864332326,935380192,14615315,16.1),(134692,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134692,37.46,0.42,310,63678,70,NULL,NULL,'GIN 478',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134693,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134693,37.91,0.12,382,63678,70,NULL,NULL,'GIN 478',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134694,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134694,37.33,0.25,292,63679,74.4,NULL,NULL,'GIN 485',NULL,'2013AJ....146...86T',2013,1,0.38,NULL,'G',0.000159,NULL,'16.7g',0.32,'E/S0',NULL,NULL,NULL,NULL,1,240.836583333,25.30925,0.157,NULL,59864648003,935385125,14615392,16.7),(134695,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134695,37.46,0.42,310,63679,70,NULL,NULL,'GIN 485',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134696,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134696,37.91,0.12,382,63679,70,NULL,NULL,'GIN 485',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134697,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134697,35.61,0.2,132,63680,74.4,NULL,NULL,'SDSS J160321.00+174325.8',NULL,'2013AJ....146...86T',2013,1,0.53,NULL,'G',0.000025,NULL,'18.1g',0.09,NULL,NULL,NULL,NULL,NULL,1,240.837541667,17.72386,0.041,NULL,56566659229,883854050,13810219,18.1),(134698,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134698,37.65,0.46,339,63681,70,NULL,NULL,'2MASX J16032208+4114029',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000184,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.842083,41.23406,0.005,NULL,59809949991,934530468,14602038,17.2),(134699,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134699,37.33,0.25,292,63682,74.4,NULL,NULL,'GIN 484',NULL,'2013AJ....146...86T',2013,1,0.37,NULL,'G',0.000186,NULL,'17.0g',0.27,'S',NULL,NULL,NULL,NULL,1,240.842375,25.37267,0.157,NULL,59865173848,935393341,14615520,17),(134700,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134700,37.46,0.42,310,63682,70,NULL,NULL,'GIN 484',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134701,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134701,36.14,0.05,169,63683,70,NULL,NULL,'2MASX J16032323+1431286',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000407,NULL,'15.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.846875,14.52456,0.093,NULL,56557841465,883716272,13808066,15.9),(134702,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134702,38.07,0.46,411,63684,70,NULL,NULL,'2MASX J16032325+2438222',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.847,24.63947,0.185,NULL,59863490073,935367032,14615109,18.2),(134703,'Tully est','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134703,32.73,0.8,35.1,63685,75,NULL,'B','NGC 6035',NULL,'1988NBGC.C....0000T',1988,1,1.02,'Freudling, et al. (1992, ApJS, 79, 157) give v=4757 km/sec.','G',0.000097,NULL,'14.1g',0.97,'SAB(rs)c','Supercluster foreground object',NULL,NULL,NULL,1,240.85075,20.89125,0.117,NULL,56512018445,883000288,13796879,14.1),(134704,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134704,36.02,0.2,160,63686,74.4,NULL,NULL,'SDSS J160325.85+153848.2',NULL,'2013AJ....146...86T',2013,1,0.69,NULL,'G',0.000013,NULL,'16.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,240.85775,15.64675,0.053,NULL,56571831310,883934864,13811482,16.9),(134705,'IRAS','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134705,34.01,0.8,63.5,63687,75,NULL,'HMCL, I','MRK 0296',NULL,'1997ApJS..109..333W',1997,1,0.75,NULL,'G',0.000027,NULL,'16.0g',0.23,'Im pec?','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.860625,19.16269,0.057,NULL,56511282732,882988792,13796699,16),(134706,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134706,33.1,0.4,41.8,63687,75,NULL,'HMCL, I, inv','MRK 0296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134707,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134707,33.15,0.4,42.6,63687,75,NULL,'HMCL, I, raw','MRK 0296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134708,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134708,33.57,0.4,51.9,63687,75,NULL,'HMCL, I, cor','MRK 0296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134709,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134709,33.92,0.49,60.7,63687,75,NULL,'IR','MRK 0296',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134710,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134710,36.14,0.05,169,63688,70,NULL,NULL,'2MASX J16032752+1531066',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.86475,15.51861,0.057,NULL,56571233274,883925519,13811336,17.4),(134711,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134711,35.77,0.33,142,63689,70,NULL,NULL,'CGCG 108-086',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',NULL,NULL,'15.24',0.38,'S0/a:','Supercluster apparent member',NULL,NULL,NULL,1,240.866708333,20.29219,0.085,NULL,56512861889,883013467,13797085,15.24),(134712,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134712,35.78,NULL,143,63690,NULL,NULL,NULL,'FGC 1988',NULL,'2000BSAO...50....5K',2000,1,0.77,NULL,'G',NULL,NULL,'17.3',0.06,'Scd',NULL,NULL,NULL,NULL,1,240.873583,77.52603,0.189,NULL,57168565994,893258843,13957169,17.3),(134713,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134713,35.9,0.67,152,63691,70,NULL,NULL,'2MASX J16032995-0616155',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,240.874833333,-6.27092,0.537,NULL,45571174342,712049599,11125774,14.3),(134714,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134714,36.7,0.46,219,63692,70,NULL,NULL,'2MASX J16033015+0537015',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000173,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.8755417,5.61697,0.177,NULL,56480713015,882511140,13789236,17),(134715,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134715,36.63,0.78,212,63693,70,NULL,NULL,'2MASX J16033138-3016561',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'15.48',0.42,'Sa',NULL,NULL,NULL,NULL,1,240.8807917,-30.28222,0.681,NULL,47119110512,736236101,11503689,15.48),(134716,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134716,36.15,0.2,170,63694,74.4,NULL,NULL,'KUG 1601+140',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000052,NULL,'15.3',0.2,'Spiral',NULL,NULL,NULL,NULL,1,240.882,13.94411,0.101,NULL,56557606838,883712606,13808009,15.3),(134717,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134717,36.14,0.05,169,63695,70,NULL,NULL,'NGC 6034',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000097,NULL,'14.5g',0.73,'E+','Supercluster (RV-confirmed) member',NULL,'head-tail','Flat-Spectrum Radio Source',1,240.883667,17.19869,0.049,NULL,56569025080,883891016,13810797,14.5),(134718,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134718,36.31,0.46,183,63696,70,NULL,NULL,'2MASX J16033238+5025089',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000088,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.88475,50.41903,0.061,NULL,59706144071,932908501,14576695,16.7),(134719,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134719,37.68,0.46,343,63697,70,NULL,NULL,'2MASX J16033244+1729386',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000113,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.885291667,17.49406,0.045,NULL,56566614389,883853349,13810208,17.8),(134720,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134720,36.14,0.05,169,63698,70,NULL,NULL,'2MASX J16033287+1512556',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.886875,15.2155,0.061,NULL,56571229450,883925460,13811335,17.3),(134721,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134721,37.4,0.46,302,63699,70,NULL,NULL,'2MASX J16033489+2428175',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00018,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,240.8952917,24.47164,0.189,NULL,59863523146,935367549,14615117,17.4),(134722,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134722,37.97,0.46,394,63700,70,NULL,NULL,'2MASX J16033482+5506014',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00008,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,240.895375,55.10044,0,NULL,57607186809,900112293,14064254,16.8),(134723,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134723,38.25,0.46,447,63701,70,NULL,NULL,'2MASX J16033665+1945044',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,240.9027083,19.75119,0.097,NULL,56512526251,883008222,13797003,NULL),(134724,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134724,38.1,0.33,417,63702,70,NULL,NULL,'SDSS J160337.68+292222.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000137,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,240.907041667,29.37303,0.081,NULL,59867919014,935436234,14616191,18.8),(134725,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134725,35.95,0.18,155,63703,70,NULL,NULL,'GIN 463',NULL,'2001MNRAS.321..277C',2001,1,0.48,NULL,'G',0.00013,NULL,'16.6g',0.34,'E/S0;FSRQ      Sy',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,240.908583333,15.90067,0.049,NULL,56571815826,883934622,13811478,16.6),(134726,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134726,38.14,0.46,425,63704,70,NULL,NULL,'2MASX J16033889+1854054',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.912166667,18.90167,0.057,NULL,56511729435,882995772,13796808,17.6),(134727,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134727,36.14,0.05,169,63705,70,NULL,NULL,'2MASX J16033924+1711057',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.0g',0.21,'E','Group member',NULL,NULL,NULL,1,240.913625,17.18486,0.049,NULL,56569011710,883890807,13810793,17),(134728,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134728,37.44,0.46,308,63706,70,NULL,NULL,'2MASX J16034119+0425575',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.92175,4.43269,0.225,NULL,56483967899,882561998,13790031,17.8),(134729,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134729,37.43,0.33,306,63707,70,NULL,NULL,'2MASX J16034162+2652405',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000149,NULL,'16.9g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,240.92325,26.87797,0.125,NULL,59862575912,935352748,14614886,16.9),(134730,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134730,37.98,0.46,395,63708,70,NULL,NULL,'SDSS J160341.63+292449.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.9235,29.41389,0.081,NULL,59867921601,935436275,14616191,18.1),(134731,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134731,35.12,0.25,106,63709,74.4,NULL,NULL,'GIN 490',NULL,'2013AJ....146...86T',2013,1,0.53,NULL,'G',0.000053,NULL,'15.7g',0.52,'S',NULL,NULL,NULL,NULL,1,240.924417,24.09511,0.165,NULL,59395040288,928047504,14500742,15.7),(134732,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134732,35.31,0.29,115,63709,70,NULL,NULL,'GIN 490',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134733,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134733,38.3,0.46,456,63710,70,NULL,NULL,'2MASX J16034238+5318581',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000084,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.926667,53.31622,0.009,NULL,59700987794,932827934,14575436,17.6),(134734,'GRB','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134734,44.6,0.75,3310,63711,NULL,NULL,NULL,'GRB 060502A',1.51,'2008AIPC.1065..367L',2008,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,240.9269583,66.60072,0.069,NULL,57824069479,903501085,14117204,NULL),(134735,'GRB','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134735,44.65,0.67,3390,63711,72,NULL,NULL,'GRB 060502A',1.51,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134736,'GRB','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134736,44.71,0.66,3490,63711,70,NULL,NULL,'GRB 060502A',1.51,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134737,'GRB','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134737,44.9,0.62,3800,63711,69.7,NULL,'Calibrated','GRB 060502A',1.51,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134738,'GRB','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134738,45.37,0.65,4720,63711,69.7,NULL,'Fiducial','GRB 060502A',1.51,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134739,'GRB','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134739,46.06,1.36,6490,63711,69.7,NULL,'Fiducial','GRB 060502A',1.51,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134740,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134740,38.43,0.33,486,63712,70,NULL,NULL,'2MASX J16034279+1557167',NULL,'2015arXiv151105856S',2015,1,0.27,'1998AJ....115....6B: z = 0.039811 +- 0.000083; 2004AJ....128.1558S, 0.10759.','G',0.000183,NULL,'17.1g',0.27,'BrClG;E',NULL,NULL,NULL,NULL,1,240.928375,15.95461,0.049,NULL,56572680957,883948139,13811689,17.1),(134741,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134741,38.1,0.33,417,63713,70,NULL,NULL,'2MASX J16034289+2922545',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000167,NULL,'16.6g',0.34,'BrClG;E',NULL,NULL,NULL,NULL,1,240.928916667,29.38197,0.081,NULL,59867922073,935436282,14616191,16.6),(134742,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134742,37.66,0.46,340,63714,70,NULL,NULL,'2MASX J16034312+1448317',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.9297917,14.80886,0.109,NULL,56557515991,883711187,13807987,17.7),(134743,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134743,38.51,0.46,503,63715,70,NULL,NULL,'SDSS J160343.75+113455.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.932333,11.58214,0.145,NULL,56580582897,884071607,13813618,18.4),(134744,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134744,35.74,0.25,141,63716,74.4,NULL,NULL,'CGCG 108-087',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000083,NULL,'14.26',0.4,'S0','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.932417,16.32728,0.029,NULL,56572560260,883946254,13811660,14.26),(134745,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134745,35.95,0.18,155,63716,70,NULL,NULL,'CGCG 108-087',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134746,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134746,35.95,0.18,155,63717,70,NULL,NULL,'CGCG 108-087 NED02',NULL,'2001MNRAS.321..277C',2001,1,0.38,NULL,'G',0.00007,NULL,'16.1g',0.37,'S','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.9410417,16.33833,0.029,NULL,56572559831,883946247,13811660,16.1),(134747,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134747,36.14,0.05,169,63717,70,NULL,NULL,'CGCG 108-087 NED02',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134748,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134748,35.89,0.46,151,63718,70,NULL,NULL,'2MASX J16034618+1357047',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'15.7g',0.37,NULL,NULL,NULL,NULL,NULL,1,240.942583,13.95136,0.101,NULL,56557618464,883712788,13808012,15.7),(134749,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134749,37.5,0.46,316,63719,70,NULL,NULL,'2MASX J16034641+3312352',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,240.9434583,33.20986,0.097,NULL,59765154281,933830535,14591102,17.2),(134750,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134750,36.14,0.05,169,63720,70,NULL,NULL,'2MASX J16034754+1745047',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000053,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,240.948125,17.75142,0.041,NULL,56566655255,883853988,13810218,16.8),(134751,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134751,36.95,0.46,246,63721,70,NULL,NULL,'2MASX J16034771+2629106',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,240.948583,26.48639,0.129,NULL,59862657242,935354019,14614906,17),(134752,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134752,35.96,0.53,156,63722,70,NULL,NULL,'2MASX J16034839-0149487',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000133,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,240.951583,-1.83014,0.569,NULL,45527881107,711373142,11115205,14.9),(134753,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134753,36.56,0.33,205,63723,70,NULL,NULL,'2MASX J16034875+2628166',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000185,NULL,'16.2g',0.34,'E0',NULL,NULL,NULL,NULL,1,240.9532917,26.47117,0.133,NULL,59862659192,935354049,14614907,16.2),(134754,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134754,38.13,0.46,423,63724,70,NULL,NULL,'2MASX J16034884+2106064',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000174,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.953458333,21.10192,0.129,NULL,56520358535,883130602,13798915,17.6),(134755,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134755,37.92,0.13,384,63725,70,NULL,NULL,'SDSS J160348.94+244222.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000168,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.953916667,24.70631,0.185,NULL,59863496472,935367132,14615111,18),(134756,'IRAS','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134756,34.32,0.8,73.1,63726,75,NULL,'HMCL, I','ESO 136- G 016',NULL,'1997ApJS..109..333W',1997,1,3.47,'Star superposed.','G',0.00002,NULL,'15.2',0.26,'SB(s)c:sp;flar.disk?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,240.955583,-60.97781,NULL,NULL,44378405709,693412589,10834571,15.2),(134757,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134757,33.19,0.49,43.5,63726,75,NULL,'IR','ESO 136- G 016',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134758,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134758,33.51,0.4,50.2,63726,75,NULL,'HMCL, I, raw','ESO 136- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134759,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134759,33.74,0.4,55.9,63726,75,NULL,'HMCL, I, cor','ESO 136- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134760,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134760,33.75,0.4,56.1,63726,75,NULL,'HMCL, I, inv','ESO 136- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134761,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134761,34.11,NULL,66.3,63726,NULL,NULL,'Dipole','ESO 136- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134762,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134762,34.12,NULL,66.8,63726,NULL,NULL,'Dipole + Quadrupole','ESO 136- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134763,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134763,34.13,NULL,67,63726,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 136- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134764,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134764,34.2,NULL,69.3,63726,NULL,NULL,NULL,'ESO 136- G 016',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134765,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134765,37.89,0.46,379,63727,70,NULL,NULL,'2MASX J16034953+2947526',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000155,NULL,'17.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.956333333,29.79817,0.073,NULL,59867666294,935432285,14616129,17.9),(134766,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134766,36.56,0.33,205,63728,70,NULL,NULL,'CGCG 167-019',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00011,NULL,'15.3g',0.59,'E0',NULL,NULL,NULL,NULL,1,240.95725,26.54208,0.129,NULL,59862678100,935354345,14614911,15.3),(134767,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134767,36.14,0.05,169,63729,70,NULL,NULL,'2MASX J16035014+1556447',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000157,NULL,'15.5g',0.39,'E',NULL,NULL,NULL,NULL,1,240.95875,15.94569,0.049,NULL,56572681539,883948149,13811689,15.5),(134768,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134768,37.59,0.46,329,63730,70,NULL,NULL,'2MASX J16035148+1643521',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.964417,16.73117,0.033,NULL,56568921335,883889395,13810771,17.7),(134769,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134769,35.4,0.54,120,63731,NULL,NULL,'Malmquist cor.','UGC 10166',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000417,NULL,'12.51',0.6,'SBb','Group member, peripheral',NULL,NULL,NULL,1,240.967333,39.98444,0.013,NULL,59809589367,934524833,14601950,12.51),(134770,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134770,35.53,0.51,127,63731,NULL,NULL,NULL,'UGC 10166',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134771,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134771,35.57,0.2,130,63731,74.4,NULL,NULL,'UGC 10166',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134772,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134772,37.25,0.46,282,63732,70,NULL,NULL,'2MASX J16035219+2817416',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000183,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,240.9675417,28.29497,0.077,NULL,59867591254,935431113,14616111,16.5),(134773,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134773,37.46,0.42,310,63733,70,NULL,NULL,'GIN 480',NULL,'2001MNRAS.321..277C',2001,1,0.53,NULL,'G',0.000077,NULL,'16.3g',0.42,'S',NULL,NULL,NULL,NULL,1,240.9682917,25.44694,0.137,NULL,59865180356,935393443,14615522,16.3),(134774,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134774,36.14,0.05,169,63734,70,NULL,NULL,'IC 1167',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000113,NULL,'14.7',0.5,'E',NULL,NULL,NULL,NULL,1,240.97025,14.94644,0.109,NULL,56557507373,883711052,13807985,14.7),(134775,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134775,37.64,0.46,337,63735,70,NULL,NULL,'PKS 1601-00',NULL,'2015arXiv151105856S',2015,1,0.3,'Identified as 4C -00.63 in PKSCAT90 (version 1.01).','G',0.000094,NULL,'17.1g',0.23,'N galaxy',NULL,NULL,NULL,NULL,1,240.970916667,-0.497,0.453,NULL,45525368665,711333885,11114591,17.1),(134776,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134776,38.43,0.33,486,63736,70,NULL,NULL,'SDSS J160354.71+155029.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.978,15.84158,0.049,NULL,56571849391,883935146,13811486,18.1),(134777,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134777,37.54,0.46,323,63737,70,NULL,NULL,'2MASX J16035515+3051413',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.9797917,30.86136,0.045,NULL,59735708929,933370452,14583913,17.6),(134778,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134778,35.98,0.46,157,63738,70,NULL,NULL,'UGC 10158',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.000163,NULL,'14.61',0.7,'S0',NULL,NULL,NULL,NULL,1,240.980667,11.72867,0.141,NULL,56580614944,884072108,13813626,14.61),(134779,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134779,37.55,0.27,323,63739,70,NULL,NULL,'2MASX J16035560+2757226',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000137,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.981583333,27.95628,0.085,NULL,59875904063,935561000,14618140,17.6),(134780,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134780,37.4,0.46,302,63740,70,NULL,NULL,'2MASX J16035635+2835246',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000143,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.98475,28.59033,0.077,NULL,59868270184,935441721,14616276,18),(134781,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134781,36.14,0.05,169,63741,70,NULL,NULL,'2MASX J16035650+1620511',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000067,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,240.9854583,16.34753,0.029,NULL,56572553884,883946154,13811658,16.9),(134782,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134782,36.14,0.05,169,63742,70,NULL,NULL,'2MASX J16035656+1625251',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000178,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.9855,16.42367,0.029,NULL,56572566119,883946345,13811661,17),(134783,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134783,36.14,0.05,169,63743,70,NULL,NULL,'2MASX J16035667+1718182',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000057,NULL,'16.1g',0.35,'Ep','Group member',NULL,NULL,NULL,1,240.986083,17.30511,0.049,NULL,56569555907,883899311,13810926,16.1),(134784,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134784,38.02,0.33,401,63744,70,NULL,NULL,'2MASX J16035758+1608522',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000123,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.9900417,16.14781,0.041,NULL,56572662318,883947848,13811685,17.4),(134785,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134785,36.99,0.46,250,63745,70,NULL,NULL,'2MASX J16035765+4557543',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000176,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,240.990125,45.96511,0.029,NULL,59681720086,932526876,14570732,16.8),(134786,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134786,38.01,0.27,401,63746,70,NULL,NULL,'SDSS J160357.65-003717.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000082,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.9902083,-0.62167,0.465,NULL,45525319401,711333115,11114579,18.1),(134787,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134787,37.08,0.46,260,63747,70,NULL,NULL,'2MASX J16035823+3125423',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,240.99275,31.42836,0.045,NULL,59735442984,933366296,14583848,17.3),(134788,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134788,39.01,0.33,633,63748,70,NULL,NULL,'2MASX J16035919+3400523',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000138,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.9967083,34.01444,0.065,NULL,59768513306,933883020,14591922,17.7),(134789,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134789,37.86,0.46,374,63749,70,NULL,NULL,'2MASX J16035943+3814082',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000165,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,240.99775,38.23583,0.009,NULL,59774283333,933973177,14593330,17),(134790,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134790,37.69,0.33,345,63750,70,NULL,NULL,'2MASX J16040027+2119465',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,241.001083333,21.3295,0.141,NULL,59393446588,928022602,14500353,17.6),(134791,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134791,36.14,0.05,169,63751,70,NULL,NULL,'CGCG 108-093',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000093,NULL,'15.3g',0.46,'E/S0','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.0115,17.28239,0.049,NULL,56569558575,883899352,13810927,15.3),(134792,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134792,37.27,0.25,284,63752,74.4,NULL,NULL,'GIN 483',NULL,'2013AJ....146...86T',2013,1,0.42,NULL,'G',0.000135,NULL,'16.7g',0.4,'S',NULL,NULL,NULL,NULL,1,241.0125,25.49706,0.137,NULL,59865226389,935394162,14615533,16.7),(134793,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134793,37.46,0.42,310,63752,70,NULL,NULL,'GIN 483',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134794,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134794,38.01,0.27,401,63753,70,NULL,NULL,'2MASX J16040354-0040454',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000099,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,241.014833,-0.67922,0.465,NULL,45525306484,711332913,11114576,18.5),(134795,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134795,38.27,0.46,450,63754,70,NULL,NULL,'2MASX J16040421+2705496',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.017583,27.09706,0.101,NULL,59862549650,935352338,14614880,17.6),(134796,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134796,32.06,NULL,25.8,63755,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10194',NULL,'2010Ap&SS.325..163P',2010,1,1.9,NULL,'G',0.000017,NULL,'16.0',0.17,'Sd',NULL,NULL,NULL,NULL,1,241.018333,63.71306,0,NULL,57949441617,905460025,14147812,16),(134797,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134797,32.07,NULL,25.9,63755,NULL,NULL,'Dipole + Quadrupole','UGC 10194',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134798,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134798,32.08,NULL,26,63755,NULL,NULL,'Dipole','UGC 10194',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134799,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134799,32.42,0.43,30.4,63755,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10194',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134800,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134800,37.46,0.42,310,63756,70,NULL,NULL,'KUG 1601+256',NULL,'2001MNRAS.321..277C',2001,1,0.44,NULL,'G',0.00007,NULL,'15.9g',0.32,'Compact',NULL,NULL,NULL,NULL,1,241.018917,25.56269,0.137,NULL,59865210397,935393912,14615529,15.9),(134801,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134801,38.01,0.27,401,63757,70,NULL,NULL,'2MASX J16040453-0039314',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00011,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.0189583,-0.65875,0.465,NULL,45525318156,711333096,11114579,17.6),(134802,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134802,36.01,0.16,159,63758,70,NULL,NULL,'2MASX J16040526+2411386',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000067,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,241.0220417,24.19414,0.173,NULL,59395019647,928047181,14500737,16.4),(134803,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134803,36.26,0.46,179,63759,70,NULL,NULL,'2MASX J16040737+4034162',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000097,NULL,'16.0g',0.36,'E0','Field galaxy',NULL,NULL,NULL,1,241.0307083,40.57111,0,NULL,59809382658,934521604,14601900,16),(134804,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134804,38.88,0.46,597,63760,70,NULL,NULL,'2MASX J16040763+5205112',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000152,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,241.031917,52.08639,NULL,NULL,59700851625,932825806,14575403,17.6),(134805,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134805,37.55,0.27,323,63761,70,NULL,NULL,'2MASX J16040788+2758593',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000171,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,241.03275,27.98306,0.085,NULL,59875903345,935560989,14618140,16.9),(134806,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134806,37.1,0.46,263,63762,70,NULL,NULL,'2MASX J16040835+5458125',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000099,NULL,'16.8g',0.25,'Sbrst',NULL,NULL,NULL,NULL,1,241.034583333,54.97033,0,NULL,57607046022,900110094,14064220,16.8),(134807,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134807,38.46,0.33,492,63763,70,NULL,NULL,'2MASX J16040833+1507162',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.034875,15.12122,0.097,NULL,56557469287,883710457,13807975,17.8),(134808,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134808,37.92,0.13,384,63764,70,NULL,NULL,'2MASX J16040887+2438463',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000156,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.036916667,24.64625,0.181,NULL,59863490968,935367046,14615110,17.2),(134809,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134809,35.89,NULL,151,63765,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10171',NULL,'2010Ap&SS.325..163P',2010,1,1.7,NULL,'G',0.000169,NULL,'15.8g',0.16,'Scd','Field galaxy',NULL,NULL,NULL,1,241.0382083,42.88925,0,NULL,59803951408,934436740,14600574,15.8),(134810,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134810,35.9,NULL,152,63765,NULL,NULL,'Dipole + Quadrupole','UGC 10171',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134811,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134811,35.92,NULL,153,63765,NULL,NULL,NULL,'UGC 10171',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134812,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134812,35.93,NULL,153,63765,NULL,NULL,'Dipole','UGC 10171',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134813,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134813,36.31,0.46,183,63766,70,NULL,NULL,'2MASX J16040945+5353122',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00009,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,241.0394583,53.88669,0.005,NULL,57608291785,900129559,14064524,17.1),(134814,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134814,36.14,0.05,169,63767,70,NULL,NULL,'2MASX J16041022+1758505',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00006,NULL,'16.39',0.31,'SB0','Group member',NULL,NULL,NULL,1,241.04275,17.98075,0.061,NULL,56566733012,883855203,13810237,16.39),(134815,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134815,37.55,0.27,323,63768,70,NULL,NULL,'2MASX J16041029+2758564',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00015,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,241.0430417,27.98217,0.085,NULL,59875903052,935560985,14618140,17.1),(134816,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134816,35.74,0.25,141,63769,74.4,NULL,NULL,'GIN 527',NULL,'2013AJ....146...86T',2013,1,0.57,NULL,'G',0.000057,NULL,'15.7g',0.5,'S',NULL,NULL,NULL,NULL,1,241.043583,16.08753,0.041,NULL,56572703909,883948498,13811695,15.7),(134817,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134817,35.79,0.18,144,63769,70,NULL,NULL,'GIN 527',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134818,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134818,38.07,0.46,411,63770,70,NULL,NULL,'2MASX J16041174+3749563',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000162,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,241.049125,37.83222,0,NULL,59775068234,933985441,14593522,16.9),(134819,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134819,36.96,0.33,247,63771,70,NULL,NULL,'2MASX J16041208+1109088',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.18',0.23,NULL,NULL,NULL,NULL,NULL,1,241.050417,11.15233,0.153,NULL,56581078468,884079351,13813739,17.18),(134820,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134820,36.66,0.46,215,63772,70,NULL,NULL,'2MASX J16041251+1210373',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,241.0520417,12.17697,0.137,NULL,56547878121,883560595,13805634,17),(134821,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134821,36.93,0.27,243,63773,70,NULL,NULL,'2MASX J16041371+0003131',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000122,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,241.057083,0.05353,0.377,NULL,56476904250,882451628,13788306,16.6),(134822,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134822,36.87,0.46,236,63774,70,NULL,NULL,'2MASX J16041519+3131523',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.063125,31.53122,0.041,NULL,59735448906,933366389,14583849,16.9),(134823,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134823,36.18,0.39,172,63775,NULL,NULL,'Malmquist cor.','2MASX J16041594+1627373',NULL,'2009ApJS..182..474S',2009,1,0.65,NULL,'G',0.000033,NULL,'16.2g',0.21,'Sc',NULL,NULL,NULL,NULL,1,241.0665,16.46019,0.029,NULL,56572547911,883946061,13811657,16.2),(134824,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134824,36.43,0.35,193,63775,NULL,NULL,NULL,'2MASX J16041594+1627373',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134825,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134825,36.47,0.2,197,63775,74.4,NULL,NULL,'2MASX J16041594+1627373',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134826,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134826,37.67,0.33,342,63776,70,NULL,NULL,'2MASX J16041615+2849024',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000146,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.067458333,28.81725,0.073,NULL,59868359636,935443119,14616298,17.7),(134827,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134827,37.11,0.21,264,63777,70,NULL,NULL,'2MASX J16041649+0537271',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000167,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.06875,5.62411,0.177,NULL,56489001233,882640644,13791260,17.6),(134828,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134828,36.98,0.13,249,63778,70,NULL,NULL,'2MASX J16041653+3344023',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00019,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,241.068917,33.73408,0.073,NULL,59768527637,933883244,14591925,16.3),(134829,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134829,37.58,0.33,327,63779,70,NULL,NULL,'2MASX J16041688+2724364',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000168,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,241.070333,27.40997,0.105,NULL,59875929567,935561399,14618146,16.6),(134830,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134830,37.67,0.33,342,63780,70,NULL,NULL,'2MASX J16041752+2851094',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.0732083,28.85256,0.073,NULL,59868366817,935443231,14616300,17.5),(134831,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134831,37.44,0.33,308,63781,70,NULL,NULL,'2MASX J16041821+1806115',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,241.075916667,18.10306,0.057,NULL,56566712079,883854876,13810232,17.5),(134832,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134832,37.48,0.46,313,63782,70,NULL,NULL,'2MASX J16041884+2317365',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000165,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,241.0785417,23.29358,0.141,NULL,59395538084,928055282,14500863,17),(134833,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134833,36.14,0.05,169,63783,70,NULL,NULL,'2MASX J16041958+1710493',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00015,NULL,'15.5g',0.46,'S0','Group member',NULL,NULL,NULL,1,241.0815,17.18039,0.049,NULL,56569589447,883899835,13810934,15.5),(134834,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134834,38.32,0.46,461,63784,70,NULL,NULL,'2MASX J16041980+2900584',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,241.082667,29.01622,0.069,NULL,59868343743,935442870,14616294,17.5),(134835,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134835,37.06,0.46,258,63785,70,NULL,NULL,'SDSS J160419.95+351124.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000143,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,241.083125,35.19025,0.029,NULL,59765989862,933843591,14591306,17.9),(134836,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134836,36.05,0.46,162,63786,70,NULL,NULL,'2MASX J16041996+1247433',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.10',0.34,NULL,NULL,NULL,NULL,NULL,1,241.08325,12.79533,0.093,NULL,56551413424,883615834,13806497,17.1),(134837,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134837,36.14,0.05,169,63787,70,NULL,NULL,'2MASX J16042031+1639483',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.00014,NULL,'16.2g',0.3,'E',NULL,NULL,NULL,NULL,1,241.084541667,16.6635,0.033,NULL,56572054014,883938343,13811536,16.2),(134838,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134838,38.34,0.46,466,63788,70,NULL,NULL,'2MASX J16042178+0951428',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.090875,9.86203,0.141,NULL,56586246654,884160103,13815001,17.8),(134839,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134839,38.26,0.46,449,63789,70,NULL,NULL,'2MASX J16042180+2301315',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.090875,23.02547,0.165,NULL,59395466649,928054166,14500846,17.6),(134840,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134840,36.9,0.46,240,63790,70,NULL,NULL,'2MASX J16042257+2647054',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,241.093875,26.78492,0.125,NULL,59862592266,935353004,14614890,16.9),(134841,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134841,37.22,0.46,278,63791,70,NULL,NULL,'2MASX J16042280+1927525',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,241.094916667,19.46456,0.081,NULL,56511228236,882987941,13796686,17.8),(134842,'IRAS','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134842,35.5,0.8,126,63792,75,NULL,'W91CL, r','CGCG 108-095',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000023,NULL,'15.70',0.2,'SA(s)b','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.0955417,16.69833,0.033,NULL,56569236621,883894322,13810848,15.7),(134843,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134843,35.4,0.38,120,63792,75,NULL,'W91CL, r, raw','CGCG 108-095',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134844,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134844,35.51,0.38,126,63792,75,NULL,'W91CL, r, inv','CGCG 108-095',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134845,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134845,35.72,0.38,140,63792,75,NULL,'W91CL, r, cor','CGCG 108-095',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134846,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134846,37.11,0.21,264,63793,70,NULL,NULL,'CGCG 051-029',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.0002,NULL,'15.4g',0.49,'BrClG',NULL,NULL,NULL,NULL,1,241.096625,5.62044,0.177,NULL,56489004347,882640692,13791260,15.4),(134847,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134847,37.83,0.46,367,63794,70,NULL,NULL,'2MASX J16042371+0424059',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.098875,4.40161,0.225,NULL,56482866473,882544788,13789762,18),(134848,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134848,36.98,0.13,249,63795,70,NULL,NULL,'2MASX J16042376+3344255',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000173,NULL,'17.3g',NULL,NULL,NULL,NULL,NULL,NULL,1,241.0990417,33.74039,0.073,NULL,59768528164,933883252,14591925,17.3),(134849,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134849,37.01,0.46,252,63796,70,NULL,NULL,'2MASX J16042415+3550055',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.1007083,35.83481,0.061,NULL,59773701960,933964093,14593188,17.6),(134850,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134850,36.96,0.33,247,63797,70,NULL,NULL,'2MASX J16042499+1111458',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.6g',0.37,NULL,NULL,NULL,NULL,NULL,1,241.104125,11.19611,0.153,NULL,56581070482,884079226,13813737,16.6),(134851,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134851,37.35,0.46,295,63798,70,NULL,NULL,'2MASX J16042500+0834388',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000146,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,241.10425,8.57736,0.145,NULL,56583950856,884124232,13814441,17.2),(134852,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134852,37.4,0.46,301,63799,70,NULL,NULL,'2MASX J16042521+1243041',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,241.105125,12.71778,0.093,NULL,56551435219,883616175,13806502,17.2),(134853,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134853,39.5,0.46,796,63800,70,NULL,NULL,'2MASX J16042591+1725431',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000087,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,241.108125,17.42864,0.045,NULL,56568668629,883885447,13810710,18.7),(134854,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134854,37.41,0.46,303,63801,70,NULL,NULL,'2MASX J16042594+3809061',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00011,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,241.108125,38.15183,0,NULL,59774272577,933973009,14593328,16.6),(134855,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134855,38.02,0.46,402,63802,70,NULL,NULL,'SDSS J160426.25+405950.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000171,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,241.109416667,40.99744,0.013,NULL,59809844632,934528822,14602012,17.9),(134856,'Ring Diameter','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134856,32.8,0.84,37,63803,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 6040B',NULL,'1981ApJS...45..541P',1981,1,0.16,'Component \'a)\' in UGC notes.','G',0.00012,NULL,'16.5g',0.15,'SA0+ pec','Supercluster (RV-confirmed) member',NULL,NULL,'Flat-Spectrum Radio Source',1,241.110458333,17.74197,0.041,NULL,56566631114,883853611,13810212,16.5),(134857,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134857,35.29,0.52,114,63804,70,NULL,NULL,'NGC 6033',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000083,NULL,'14.50',1,'SA(s)bc?',NULL,NULL,NULL,NULL,1,241.116583,-2.12097,0.577,NULL,45528068612,711376072,11115251,14.5),(134858,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134858,35.31,0.46,115,63805,70,NULL,NULL,'UGC 10164',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.000163,NULL,'14.70',0.9,'S0-:','Supercluster foreground object',NULL,NULL,NULL,1,241.117417,14.78242,0.109,NULL,56558052371,883719568,13808118,14.7),(134859,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134859,37.11,0.21,264,63806,70,NULL,NULL,'2MASX J16042823+0538249',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000167,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,241.1177083,5.64025,0.173,NULL,56488976004,882640250,13791253,16.8),(134860,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134860,37.11,0.21,264,63807,70,NULL,NULL,'2MASX J16042823+0539479',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000183,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.1177083,5.66328,0.173,NULL,56488973172,882640205,13791253,17.4),(134861,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134861,37.4,0.46,302,63808,70,NULL,NULL,'2MASX J16042845+0813588',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000215,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,241.1185417,8.23292,0.145,NULL,56584715310,884136176,13814627,16.5),(134862,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134862,38.02,0.33,401,63809,70,NULL,NULL,'2MASXi J1604284+160039',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,241.118708333,16.01094,0.041,NULL,56572655916,883947748,13811683,18),(134863,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134863,36.14,0.05,169,63810,70,NULL,NULL,'2MASX J16042883+1738551',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000067,NULL,'16.5g',0.28,'S0','Group member',NULL,NULL,NULL,1,241.120125,17.64872,0.041,NULL,56568681774,883885652,13810713,16.5),(134864,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134864,38.05,0.46,408,63811,70,NULL,NULL,'2MASX J16042889+2139562',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,241.120417,21.66564,0.157,NULL,59393678247,928026222,14500409,18.5),(134865,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134865,37.22,0.46,277,63812,70,NULL,NULL,'SDSS J160429.25+313550.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000136,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.121916667,31.59739,0.049,NULL,59735417628,933365900,14583842,18.3),(134866,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134866,36.94,0.46,245,63813,70,NULL,NULL,'2MASX J16042929+2324502',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.122,23.414,0.141,NULL,59395515696,928054932,14500858,17.8),(134867,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134867,37.73,0.46,351,63814,70,NULL,NULL,'2MASX J16042939+3331296',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000187,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,241.122625,33.52483,0.085,NULL,59764930320,933827036,14591047,17.2),(134868,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134868,35.77,0.46,143,63815,70,NULL,NULL,'CGCG 079-034',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000183,NULL,'15.4',0.7,NULL,NULL,NULL,NULL,NULL,1,241.1275417,11.21467,0.153,NULL,56581083974,884079437,13813741,15.4),(134869,'IRAS','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134869,36.04,0.8,161,63816,75,NULL,'W91CL, r','KUG 1602+176',NULL,'1997ApJS..109..333W',1997,1,0.7,NULL,'G',0.000014,NULL,'16.02',0.4,'SAB(s)c','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.128,17.46861,0.045,NULL,56568671623,883885494,13810710,16.02),(134870,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134870,35.65,0.5,135,63816,NULL,NULL,NULL,'KUG 1602+176',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134871,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134871,35.71,0.2,139,63816,74.4,NULL,NULL,'KUG 1602+176',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134872,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134872,35.75,0.38,141,63816,75,NULL,'W91CL, r, raw','KUG 1602+176',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134873,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134873,35.78,0.47,143,63816,NULL,NULL,'Malmquist cor.','KUG 1602+176',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134874,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134874,35.86,0.38,148,63816,75,NULL,'W91CL, r, inv','KUG 1602+176',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134875,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134875,36.01,0.38,159,63816,75,NULL,'W91CL, r, cor','KUG 1602+176',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134876,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134876,37.92,0.13,384,63817,70,NULL,NULL,'SDSS J160430.94+243829.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000162,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,241.128917,24.64142,0.181,NULL,59864571869,935383935,14615373,18.4),(134877,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134877,36.81,0.46,230,63818,70,NULL,NULL,'2MASX J16043113+2130023',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000175,NULL,'17.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.129583,21.50058,0.149,NULL,59393462154,928022846,14500356,17.1),(134878,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134878,35.53,0.46,127,63819,70,NULL,NULL,'CGCG 195-010',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00007,NULL,'15.2g',0.44,'E0',NULL,NULL,NULL,NULL,1,241.1299583,37.15953,0.045,NULL,59774736737,933980261,14593441,15.2),(134879,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134879,37.51,0.46,318,63820,70,NULL,NULL,'2MASX J16043170+3340176',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,241.1322083,33.67169,0.073,NULL,59768356358,933880568,14591883,17.7),(134880,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134880,38.08,0.46,412,63821,70,NULL,NULL,'2MASX J16043200+1430342',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,241.133333,14.50933,0.101,NULL,56558060835,883719700,13808120,17.7),(134881,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134881,37.11,0.21,264,63822,70,NULL,NULL,'2MASX J16043232+0536539',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,241.134583333,5.61494,0.177,NULL,56488973823,882640215,13791253,17.4),(134882,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134882,36.42,0.46,192,63823,70,NULL,NULL,'2MASX J16043247+3827242',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00008,NULL,'16.1g',0.32,NULL,NULL,NULL,NULL,NULL,1,241.13525,38.45689,0,NULL,59774292864,933973326,14593333,16.1),(134883,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134883,37.92,0.13,384,63824,70,NULL,NULL,'SDSS J160433.85+243726.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,241.1410417,24.624,0.181,NULL,59864571461,935383929,14615373,18.5),(134884,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134884,36.18,0.46,172,63825,70,NULL,NULL,'CGCG 079-038',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000247,NULL,'15.4',0.6,NULL,'Group member',NULL,NULL,NULL,1,241.142125,12.24603,0.137,NULL,56551278681,883613729,13806464,15.4),(134885,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134885,36.13,0.2,168,63826,74.4,NULL,NULL,'CGCG 079-037',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000123,NULL,'15.2',0.2,NULL,'Group member',NULL,NULL,NULL,1,241.143333,12.18139,0.137,NULL,56547868778,883560449,13805632,15.2),(134886,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134886,37.95,0.46,390,63827,70,NULL,NULL,'2MASX J16043457+0950268',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,241.1439583,9.84067,0.141,NULL,56586241483,884160023,13815000,16.9),(134887,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134887,36.07,0.46,163,63828,70,NULL,NULL,'2MASX J16043469+1402482',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.10',0.29,NULL,NULL,NULL,NULL,NULL,1,241.144541667,14.04667,0.077,NULL,56557798216,883715597,13808056,17.1),(134888,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134888,38.46,0.33,492,63829,70,NULL,NULL,'SDSS J160435.00+150757.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.145875,15.13267,0.097,NULL,56557441494,883710023,13807969,18.1),(134889,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134889,35.7,0.6,138,63830,70,NULL,NULL,'2MASX J16043511-0205473',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.79',0.3,NULL,NULL,NULL,NULL,NULL,1,241.1462917,-2.09664,0.569,NULL,45528060282,711375941,11115249,16.79),(134890,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134890,36.01,0.16,159,63831,70,NULL,NULL,'2MASX J16043518+2322363',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000147,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,241.146541667,23.37681,0.141,NULL,59395517782,928054965,14500858,16.5),(134891,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134891,35.57,0.25,130,63832,74.4,NULL,NULL,'NGC 6041',NULL,'2013AJ....146...86T',2013,1,NULL,'Part of the GTrpl CGCG 1602.3+1751.','GPair',0.00009,NULL,NULL,NULL,'E','Group member',NULL,NULL,NULL,1,241.147,17.71925,0.041,NULL,56568677723,883885589,13810712,NULL),(134892,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134892,35.37,0.45,119,63832,NULL,NULL,'K','NGC 6041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134893,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134893,35.89,0.4,151,63832,NULL,NULL,'mean','NGC 6041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134894,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134894,36.98,0.13,249,63833,70,NULL,NULL,'MCG +06-35-028',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.00019,NULL,'15.3g',0.52,'BrClG',NULL,NULL,NULL,NULL,1,241.14725,33.32642,0.097,NULL,59764941520,933827211,14591050,15.3),(134895,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134895,36.46,0.2,196,63834,74.4,NULL,NULL,'CGCG 137-028',NULL,'2013AJ....146...86T',2013,1,0.92,NULL,'G',0.000097,NULL,'15.1g',0.41,'Sa',NULL,NULL,NULL,NULL,1,241.148333,25.18992,0.125,NULL,59864690987,935385796,14615403,15.1),(134896,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134896,35.53,0.33,127,63835,70,NULL,NULL,'CGCG 108-100',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000117,NULL,'14.7g',0.63,'E','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.148417,16.903,0.057,NULL,56569425730,883897277,13810894,14.7),(134897,'BCG','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134897,36.43,0.35,186,63836,60,NULL,'ABELL 2151, BCG','NGC 6041A',0.036,'1980ApJ...241..486H',1980,1,1.13,'Component \'a)\' in UGC notes.','G',0.000077,NULL,'14.5g',0.82,'cD;SA0^-^','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.149167,17.72156,0.041,NULL,56568677752,883885589,13810712,14.5),(134898,'Faber-Jackson','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134898,35.97,0.44,156,63836,95,NULL,'Weighted Mean','NGC 6041A',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134899,'Faber-Jackson','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134899,36.24,0.46,177,63836,95,NULL,'Michard 1979a','NGC 6041A',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134900,'Faber-Jackson','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134900,37.55,0.63,324,63836,95,NULL,'Michard 1979b, c','NGC 6041A',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134901,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134901,35.77,0.25,143,63836,70,NULL,NULL,'NGC 6041A',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134902,'Magnitude','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134902,35.98,NULL,157,63836,NULL,NULL,'Hurcules Cluster, ABELL 2151','NGC 6041A',NULL,'1995A&A...302...21G',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134903,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134903,35.88,0.16,150,63836,70,NULL,'ABELL 2151 Cluster','NGC 6041A',NULL,'1992ApJ...396..453H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134904,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134904,36.06,0.08,163,63836,70,NULL,'ABELL 2151, BGC','NGC 6041A',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134905,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134905,36.98,0.13,249,63837,70,NULL,NULL,'SDSS J160435.89+331850.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000169,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,241.149583,33.31394,0.097,NULL,59764944213,933827253,14591050,18.6),(134906,'GRB','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134906,42.81,NULL,3650,63838,70,NULL,'Pseudo z = 2.53','GRB 030519',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,241.15,-33.46667,0.901,NULL,46263743313,722870989,11294859,NULL),(134907,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134907,37.46,0.46,311,63839,70,NULL,NULL,'2MASX J16043640+3550496',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000157,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,241.1517083,35.84731,0.061,NULL,59773713046,933964266,14593191,17.2),(134908,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134908,34.49,0.2,79.1,63840,74.4,NULL,NULL,'MRK 0868',NULL,'2013AJ....146...86T',2013,1,0.5,'Multiple SDSS entries describe this object.','G',0.000335,NULL,'15.7',0.3,'Rejected QSO cand.',NULL,NULL,NULL,NULL,1,241.1545417,9.95333,0.141,NULL,56585977302,884155895,13814935,15.7),(134909,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134909,36.98,0.13,249,63841,70,NULL,NULL,'2MASX J16043843+3331586',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000196,NULL,'16.0g',0.36,'E0',NULL,NULL,NULL,NULL,1,241.160166667,33.53311,0.085,NULL,59764926260,933826972,14591046,16),(134910,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134910,36.14,0.05,169,63842,70,NULL,NULL,'2MASX J16043855+1635572',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000172,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.1607083,16.59917,0.033,NULL,56572105856,883939154,13811549,17),(134911,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134911,37.56,0.46,325,63843,70,NULL,NULL,'2MASX J16043904+1713302',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.16275,17.22503,0.053,NULL,56569620982,883900327,13810942,17.4),(134912,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134912,35.57,0.25,130,63844,74.4,NULL,NULL,'NGC 6039',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000053,NULL,'14.9g',0.7,'SA0-','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.164875,17.70086,0.041,NULL,56568689964,883885780,13810715,14.9),(134913,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134913,35.77,0.25,143,63844,70,NULL,NULL,'NGC 6039',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134914,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134914,36.14,0.05,169,63844,70,NULL,NULL,'NGC 6039',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134915,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134915,36.23,0.46,176,63845,70,NULL,NULL,'2MASX J16044005+1300462',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,241.16675,13.01292,0.089,NULL,56551548962,883617952,13806530,16.2),(134916,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134916,37.92,0.13,384,63846,70,NULL,NULL,'2MASX J16044022+2418532',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.0001,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,241.167667,24.31489,0.173,NULL,59395015388,928047115,14500736,17.4),(134917,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134917,38.16,0.46,429,63847,70,NULL,NULL,'SDSS J160440.24+262859.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000175,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,241.1677083,26.48331,0.129,NULL,59862503929,935351623,14614869,18.6),(134918,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134918,35.59,0.25,131,63848,74.4,NULL,NULL,'CGCG 108-102',NULL,'2013AJ....146...86T',2013,1,0.57,NULL,'G',0.000089,NULL,'15.3g',0.47,'S0','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.1712917,16.42989,0.029,NULL,56572074500,883938664,13811541,15.3),(134919,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134919,35.79,0.18,144,63848,70,NULL,NULL,'CGCG 108-102',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134920,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134920,35.63,0.25,134,63849,74.4,NULL,NULL,'GIN 525',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000087,NULL,'15.05',NULL,'E',NULL,NULL,NULL,NULL,1,241.172583333,16.64975,0.033,NULL,56572063365,883938490,13811538,15.05),(134921,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134921,35.79,0.18,144,63850,70,NULL,NULL,'SDSS J160441.49+163858.4',NULL,'2001MNRAS.321..277C',2001,1,0.54,NULL,'G',0.000186,NULL,'16.1g',0.37,NULL,NULL,NULL,NULL,NULL,1,241.172875,16.64956,0.033,NULL,56572063372,883938490,13811538,16.1),(134922,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134922,36.14,0.05,169,63850,70,NULL,NULL,'SDSS J160441.49+163858.4',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134923,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134923,37.92,0.13,384,63851,70,NULL,NULL,'2MASX J16044163+2437542',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000179,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,241.173583,24.63181,0.181,NULL,59864569236,935383894,14615373,17.6),(134924,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134924,36.14,0.05,169,63852,70,NULL,NULL,'SDSS J160442.09+163040.2',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00009,NULL,'16.0g',0.26,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.175375,16.51119,0.029,NULL,56572114877,883939294,13811551,16),(134925,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134925,36.95,0.46,246,63853,70,NULL,NULL,'2MASX J16044248+2052103',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000185,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,241.177166667,20.86947,0.133,NULL,56520596124,883134314,13798973,16.8),(134926,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134926,36.14,0.05,169,63854,70,NULL,NULL,'2MASX J16044282+1738191',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000047,NULL,'16.4g',0.37,'SB0/a','Group member',NULL,NULL,NULL,1,241.1785,17.63867,0.041,NULL,56568688566,883885758,13810714,16.4),(134927,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134927,35.77,0.33,142,63855,70,NULL,NULL,'2MASX J16044349+2019253',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.0001,NULL,'16.55',0.4,NULL,NULL,NULL,NULL,NULL,1,241.181333333,20.32378,0.073,NULL,56520791117,883137361,13799021,16.55),(134928,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134928,35.64,0.25,134,63856,74.4,NULL,NULL,'KUG 1602+166B',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000073,NULL,'14.86',0.3,'E?','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.182083,16.52247,0.029,NULL,56572114376,883939287,13811551,14.86),(134929,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134929,35.79,0.18,144,63856,70,NULL,NULL,'KUG 1602+166B',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134930,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134930,37.58,0.33,327,63857,70,NULL,NULL,'SDSS J160444.46+272446.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,241.1852917,27.41294,0.105,NULL,59875923531,935561305,14618145,18.1),(134931,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134931,37.92,0.13,384,63858,70,NULL,NULL,'2MASX J16044530+2437242',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000237,NULL,'16.5g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,241.188875,24.62347,0.181,NULL,59864576847,935384013,14615375,16.5),(134932,'IRAS','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134932,35.79,0.8,144,63859,75,NULL,'W91CL, r','KUG 1602+175',NULL,'1997ApJS..109..333W',1997,1,0.7,NULL,'G',0.000009,NULL,'15.50',0.5,'SA(s)c           AGN','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.1892083,17.44839,0.045,NULL,56568662602,883885353,13810708,15.5),(134933,'IRAS','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134933,35.79,0.8,144,63859,75,NULL,'HMCL, I','KUG 1602+175',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134934,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134934,35.15,0.74,107,63859,NULL,NULL,'Malmquist cor.','KUG 1602+175',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134935,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134935,35.2,0.73,109,63859,NULL,NULL,NULL,'KUG 1602+175',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134936,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134936,35.24,0.38,112,63859,75,NULL,'W91CL, r, raw','KUG 1602+175',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134937,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134937,35.31,0.2,115,63859,74.4,NULL,NULL,'KUG 1602+175',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134938,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134938,35.33,0.38,117,63859,75,NULL,'W91CL, r, inv','KUG 1602+175',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134939,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134939,35.44,0.4,122,63859,75,NULL,'HMCL, I, raw','KUG 1602+175',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134940,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134940,35.59,0.4,131,63859,75,NULL,'HMCL, I, inv','KUG 1602+175',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134941,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134941,35.6,0.38,132,63859,75,NULL,'W91CL, r, cor','KUG 1602+175',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134942,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134942,35.78,0.4,143,63859,75,NULL,'HMCL, I, cor','KUG 1602+175',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134943,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134943,37.79,0.33,362,63860,70,NULL,NULL,'SDSS J160445.65+530834.1',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000096,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,241.190291667,53.14281,0.009,NULL,59701150407,932830475,14575476,16.4),(134944,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134944,37.75,0.46,354,63861,70,NULL,NULL,'SDSS J160446.77+152956.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000134,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.194875,15.49894,0.061,NULL,56571399612,883928118,13811376,18.6),(134945,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134945,35.12,0.25,106,63862,74.4,NULL,NULL,'GIN 491',NULL,'2013AJ....146...86T',2013,1,0.48,NULL,'G',0.000077,NULL,'14.49',0.44,'E',NULL,NULL,NULL,NULL,1,241.195125,24.27883,0.173,NULL,59395017612,928047150,14500736,14.49),(134946,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134946,35.31,0.29,115,63862,70,NULL,NULL,'GIN 491',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134947,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134947,37.43,0.46,306,63863,70,NULL,NULL,'2MASX J16044712+4136054',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,241.196333,41.60147,0.029,NULL,59810588773,934540449,14602194,17.1),(134948,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134948,33.76,0.49,56.4,63864,75,NULL,'IR','UGC 10172',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000017,NULL,'15.40',0.2,'Sbc',NULL,NULL,NULL,NULL,1,241.197625,14.28717,0.093,NULL,56557685739,883713839,13808028,15.4),(134949,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134949,34.04,0.2,64.3,63864,74.4,NULL,NULL,'UGC 10172',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134950,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134950,37.92,0.13,384,63865,70,NULL,NULL,'SDSS J160447.63+243626.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.1985,24.60731,0.181,NULL,59864576215,935384003,14615375,18),(134951,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134951,35.58,0.46,131,63866,70,NULL,NULL,'CGCG 079-040',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000009,NULL,'15.2',0.2,NULL,NULL,NULL,NULL,NULL,1,241.200417,14.12886,0.077,NULL,56557667645,883713556,13808024,15.2),(134952,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134952,37.91,0.46,381,63867,70,NULL,NULL,'2MASX J16044862+2816082',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000155,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.202667,28.26919,0.085,NULL,59867552181,935430502,14616101,18),(134953,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134953,36.14,0.05,169,63868,70,NULL,NULL,'2MASX J16044876+1616081',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000176,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.203208333,16.26886,0.029,NULL,56572159363,883939990,13811562,17.2),(134954,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134954,35.53,0.33,127,63869,70,NULL,NULL,'CGCG 108-106',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000233,NULL,'14.15',0.8,'E','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.20825,16.58361,0.033,NULL,56572107350,883939177,13811549,14.15),(134955,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134955,35.58,0.25,131,63869,74.4,NULL,NULL,'CGCG 108-106',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134956,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134956,35.79,0.18,144,63869,70,NULL,NULL,'CGCG 108-106',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134957,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134957,38.62,0.46,530,63870,70,NULL,NULL,'SDSS J160450.00+242731.4',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.208333,24.45875,0.177,NULL,59864516528,935383070,14615360,18.2),(134958,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134958,36.69,0.46,218,63871,70,NULL,NULL,'2MASX J16045006+3430496',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000196,NULL,'16.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,241.208625,34.51378,0.013,NULL,59766475371,933851177,14591424,16.5),(134959,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134959,37.69,0.33,345,63872,70,NULL,NULL,'2MASX J16045040+2122443',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000195,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,241.210166667,21.37908,0.149,NULL,56506756921,882918076,13795594,16.7),(134960,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134960,35.12,0.25,106,63873,74.4,NULL,NULL,'GIN 489',NULL,'2013AJ....146...86T',2013,1,0.46,NULL,'G',0.00006,NULL,'16.0g',0.33,'E',NULL,NULL,NULL,NULL,1,241.210666667,23.97489,0.165,NULL,59395057283,928047770,14500746,16),(134961,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134961,35.31,0.29,115,63873,70,NULL,NULL,'GIN 489',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134962,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134962,36.01,0.16,159,63873,70,NULL,NULL,'GIN 489',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134963,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134963,36.98,0.13,249,63874,70,NULL,NULL,'2MASX J16045113+3320406',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00019,NULL,'16.8g',NULL,NULL,NULL,NULL,NULL,NULL,1,241.213125,33.34464,0.097,NULL,59764950138,933827345,14591052,16.8),(134964,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134964,37.59,0.46,330,63875,70,NULL,NULL,'2MASX J16045126+3854514',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00011,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,241.213625,38.91417,0.017,NULL,59769880730,933904386,14592256,16.7),(134965,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134965,36.14,0.05,169,63876,70,NULL,NULL,'2MASX J16045137+1741058',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00006,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,241.214167,17.68492,0.041,NULL,56568814516,883887726,13810745,17.4),(134966,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134966,36.82,0.46,231,63877,70,NULL,NULL,'2MASX J16045153+2039483',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,241.214875,20.66353,0.133,NULL,56520437714,883131839,13798934,18.1),(134967,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134967,35.75,0.25,141,63878,74.4,NULL,NULL,'CGCG 108-105',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000053,NULL,'15.0g',0.66,'SB(s)a','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.215583,15.72314,0.061,NULL,56571486235,883929472,13811398,15),(134968,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134968,35.79,0.18,144,63878,70,NULL,NULL,'CGCG 108-105',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134969,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134969,37.82,0.33,366,63879,70,NULL,NULL,'2MASX J16045271+1911343',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,241.219583,19.19289,0.057,NULL,56511330905,882989545,13796711,17.3),(134970,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134970,36.14,0.05,169,63880,70,NULL,NULL,'2MASX J16045292+1612198',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000181,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,241.220417,16.20558,0.029,NULL,56572160056,883940000,13811562,16.4),(134971,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134971,37.27,0.46,284,63881,70,NULL,NULL,'2MASX J16045338-0002509',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000109,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.2225,-0.04747,0.377,NULL,45525042841,711328794,11114512,17.2),(134972,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134972,37.69,0.46,345,63882,70,NULL,NULL,'2MASX J16045352+3355458',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000188,NULL,'16.9g',0.28,'Cand.grav.lens',NULL,NULL,NULL,NULL,1,241.222917,33.9295,0.061,NULL,59768539668,933883432,14591928,16.9),(134973,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134973,35.49,0.65,125,63883,70,NULL,NULL,'2MASX J16045497-0224439',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.3,NULL,NULL,NULL,NULL,NULL,1,241.229125,-2.41225,0.505,NULL,45527281217,711363769,11115058,14.1),(134974,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134974,37.44,0.33,308,63884,70,NULL,NULL,'2MASX J16045542+1805423',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000063,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.2309583,18.09506,0.057,NULL,56566507770,883851683,13810182,17.9),(134975,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134975,37.92,0.13,384,63885,70,NULL,NULL,'2MASX J16045608+2430383',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000158,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,241.233625,24.51056,0.177,NULL,59864521324,935383145,14615361,17.4),(134976,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','PS1 SN PS11uw','N',134976,41.05,0.13,1250,63886,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11uw HOST',0.3001,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134977,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134977,36.01,0.16,159,63887,70,NULL,NULL,'2MASX J16045634+2345283',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000063,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,241.234625,23.75778,0.149,NULL,59395268845,928051075,14500798,17),(134978,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134978,37.23,0.33,279,63888,70,NULL,NULL,'2MASX J16045656+4121264',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000182,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,241.235583,41.35722,0.005,NULL,59810610402,934540787,14602199,16.5),(134979,'D-Sigma','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134979,35.09,0.4,104,63889,75,NULL,'Edat, raw','NGC 6051',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000057,NULL,'14.23',0.9,'cD;E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,241.236125,23.93269,0.165,NULL,59395234653,928050541,14500789,14.23),(134980,'D-Sigma','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134980,35.43,0.4,122,63889,75,NULL,'Edat, cor','NGC 6051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134981,'Faber-Jackson','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134981,34.83,0.44,92.5,63889,95,NULL,'Weighted Mean','NGC 6051',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134982,'Faber-Jackson','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134982,35.28,0.46,114,63889,95,NULL,'Michard 1979a','NGC 6051',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134983,'Faber-Jackson','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134983,35.78,0.63,143,63889,95,NULL,'Michard 1979b, c','NGC 6051',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134984,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134984,35.12,0.25,106,63889,74.4,NULL,NULL,'NGC 6051',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134985,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134985,35.31,0.29,115,63889,70,NULL,NULL,'NGC 6051',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134986,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134986,35.59,0.45,131,63889,NULL,NULL,'K','NGC 6051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134987,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134987,35.75,0.4,141,63889,NULL,NULL,'mean','NGC 6051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134988,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134988,36.14,0.05,169,63890,70,NULL,NULL,'SDSS J160457.02+163407.8',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000176,NULL,'16.2g',0.28,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.237583333,16.56883,0.033,NULL,56572101684,883939088,13811548,16.2),(134989,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134989,37.92,0.13,384,63891,70,NULL,NULL,'SDSS J160457.12+241705.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,241.2380417,24.28494,0.173,NULL,59391608253,927993878,14499904,18.3),(134990,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134990,35.75,0.2,141,63892,74.4,NULL,NULL,'KUG 1602+142',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000016,NULL,'15.4',0.3,'Spiral',NULL,NULL,NULL,NULL,1,241.241333333,14.13758,0.077,NULL,56557680644,883713760,13808027,15.4),(134991,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134991,37.92,0.13,384,63893,70,NULL,NULL,'2MASX J16045828+2435103',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000182,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,241.242833,24.58608,0.181,NULL,59864520292,935383129,14615361,18.2),(134992,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134992,35.82,0.49,146,63894,75,NULL,'IR','2MFGC 12909',NULL,'2011yCatp016004901K',2011,1,0.59,NULL,'G',0.000027,NULL,'17.0g',0.14,'S','Group member',NULL,NULL,NULL,1,241.2435417,18.18683,0.053,NULL,56510946086,882983532,13796617,17),(134993,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134993,38.06,0.46,409,63895,70,NULL,NULL,'2MASX J16045867+3610364',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000178,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,241.244417,36.17681,0.053,NULL,59776514588,934008040,14593875,17),(134994,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134994,36.32,0.49,184,63896,75,NULL,'IR','2MFGC 12910',NULL,'2011yCatp016004901K',2011,1,0.67,NULL,'G',0.000039,NULL,'16.2g',0.19,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,241.2445,16.80983,0.057,NULL,56569297176,883895268,13810863,16.2),(134995,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134995,36.35,0.45,186,63896,NULL,NULL,'Malmquist cor.','2MFGC 12910',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134996,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134996,36.7,0.38,219,63896,NULL,NULL,NULL,'2MFGC 12910',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134997,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134997,36.87,0.2,237,63896,74.4,NULL,NULL,'2MFGC 12910',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134998,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134998,35.7,0.51,138,63897,70,NULL,NULL,'2MASX J16045942-0144519',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'13.3I',0.6,NULL,NULL,NULL,NULL,NULL,1,241.247583333,-1.74781,0.497,NULL,45527540041,711367813,11115122,13.3),(134999,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134999,35.56,0.25,129,63898,74.4,NULL,NULL,'NGC 6044',NULL,'2013AJ....146...86T',2013,1,0.62,NULL,'G',0.000067,NULL,'14.9g',0.58,'SA0^0^','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.248667,17.87036,0.061,NULL,56568596554,883884321,13810692,14.9),(135000,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135000,35.77,0.25,143,63898,70,NULL,NULL,'NGC 6044',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135001,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135001,36.14,0.05,169,63898,70,NULL,NULL,'NGC 6044',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135002,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135002,36.99,0.46,250,63899,70,NULL,NULL,'2MASX J16050053+0729524',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000167,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,241.25225,7.49783,0.149,NULL,56581949188,884092956,13813952,16.4),(135003,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135003,37.23,0.33,279,63900,70,NULL,NULL,'2MASX J16050061+4123304',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000202,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,241.252375,41.39169,0.009,NULL,59810610662,934540791,14602199,16.6),(135004,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135004,37.47,0.46,312,63901,70,NULL,NULL,'2MASX J16050056+0825374',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.3g',0.24,'AGN',NULL,NULL,NULL,NULL,1,241.252417,8.42714,0.149,NULL,56584386281,884131035,13814547,17.3),(135005,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135005,36.11,0.46,167,63902,70,NULL,NULL,'2MASX J16050074+2644473',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000164,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,241.253125,26.74647,0.125,NULL,59862585030,935352891,14614888,16.5),(135006,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135006,35.56,0.25,129,63903,74.4,NULL,NULL,'NGC 6043',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'GPair',0.00003,NULL,NULL,NULL,'S0','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.255,17.77389,0.061,NULL,56568810341,883887661,13810744,NULL),(135007,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135007,35.77,0.25,143,63904,70,NULL,NULL,'NGC 6043A',NULL,'2001MNRAS.321..277C',2001,1,0.66,NULL,'G',0.00008,NULL,'15.2g',0.51,'SAB0^-^        AGN','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.2557083,17.77569,0.061,NULL,56568810353,883887661,13810744,15.2),(135008,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135008,37.31,0.46,290,63905,70,NULL,NULL,'2MASX J16050141+2820343',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000175,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,241.255916667,28.343,0.073,NULL,59867621694,935431588,14616118,17),(135009,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135009,36.37,0.69,188,63906,70,NULL,NULL,'2MASX J16050172-0845141',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.0I',0.5,NULL,NULL,NULL,NULL,NULL,1,241.257167,-8.75403,0.613,NULL,45572673954,712073030,11126141,14),(135010,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135010,34.09,0.2,65.8,63907,74.4,NULL,NULL,'UGC 10176',NULL,'2013AJ....146...86T',2013,1,1.76,NULL,'G',0.000016,NULL,'15.28',0.17,'Sbc',NULL,NULL,NULL,NULL,1,241.258167,13.70122,0.077,NULL,56550195663,883596807,13806200,15.28),(135011,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135011,34.1,0.49,66,63907,75,NULL,'IR','UGC 10176',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135012,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135012,34.1,NULL,66,63907,NULL,NULL,NULL,'UGC 10176',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135013,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135013,34.19,NULL,68.8,63907,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10176',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135014,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135014,34.21,NULL,69.6,63907,NULL,NULL,'Dipole + Quadrupole','UGC 10176',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135015,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135015,34.23,NULL,70.1,63907,NULL,NULL,'Dipole','UGC 10176',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135016,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135016,36.73,0.46,222,63908,70,NULL,NULL,'2MASX J16050260-0025359',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000109,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,241.260875,-0.42664,0.433,NULL,45525985639,711343525,11114742,16.3),(135017,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135017,37.24,0.46,281,63909,70,NULL,NULL,'SDSS J160504.01+170644.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.26675,17.11233,0.053,NULL,56569610170,883900158,13810939,18.1),(135018,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1962C',NULL,135018,35.22,0.29,111,63910,NULL,NULL,'Avg. of 8 SN host galaxies','MCG +03-41-085',NULL,'1985ApJ...297...23D',1985,1,0.59,NULL,'G',0.00008,NULL,'17.4g',0.13,'S',NULL,NULL,NULL,NULL,1,241.267625,17.58044,0.041,NULL,56568786877,883887294,13810738,17.4),(135019,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135019,36.28,0.46,180,63911,70,NULL,NULL,'IC 4588',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00009,NULL,'15.8g',0.45,NULL,NULL,NULL,NULL,NULL,1,241.2677083,23.91714,0.165,NULL,59395242877,928050669,14500791,15.8),(135020,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135020,39.48,0.46,787,63912,70,NULL,NULL,'SDSS J160504.31+504700.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000175,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,241.268,50.78342,NULL,NULL,59706784583,932918509,14576851,18.7),(135021,'Horizontal Branch','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'N',135021,18.49,NULL,0.05,63913,NULL,NULL,NULL,'Hercules Moving Group',NULL,'2010MNRAS.405.1796H',2010,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135022,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135022,37.82,0.33,366,63914,70,NULL,NULL,'2MASX J16050488+1911375',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,241.27025,19.19369,0.045,NULL,56511329394,882989521,13796711,18),(135023,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135023,37.9,0.46,380,63915,70,NULL,NULL,'2MASX J16050491+1923065',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,241.270625,19.38528,0.081,NULL,56518789255,883106082,13798532,17.1),(135024,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135024,36.75,0.46,224,63916,70,NULL,NULL,'2MASX J16050543+1156598',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'16.71',0.45,NULL,NULL,NULL,NULL,NULL,1,241.272583,11.95006,0.121,NULL,56579354785,884052418,13813319,16.71),(135025,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135025,35.13,0.25,106,63917,74.4,NULL,NULL,'GIN 494',NULL,'2013AJ....146...86T',2013,1,0.38,NULL,'G',0.000053,NULL,'16.5g',0.33,'E',NULL,NULL,NULL,NULL,1,241.27675,23.86497,0.149,NULL,59395241609,928050650,14500791,16.5),(135026,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135026,35.31,0.29,115,63917,70,NULL,NULL,'GIN 494',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135027,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135027,36.01,0.16,159,63917,70,NULL,NULL,'GIN 494',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135028,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135028,36.71,0.46,220,63918,70,NULL,NULL,'2MASX J16050670+4250278',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,241.277917,42.841,0,NULL,59803942949,934436608,14600572,17),(135029,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135029,37.72,0.46,350,63919,70,NULL,NULL,'2MASX J16050685+0753205',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00016,NULL,'17.6g',NULL,NULL,NULL,NULL,NULL,NULL,1,241.278583,7.88906,0.173,NULL,56585141375,884142833,13814731,17.6),(135030,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135030,36.24,0.46,177,63920,70,NULL,NULL,'2MASX J16050685+0959325',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,241.278667,9.99219,0.149,NULL,56586090949,884157671,13814963,17.1),(135031,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135031,37.38,0.33,299,63921,70,NULL,NULL,'SDSS J160507.62+272145.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000143,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,241.28175,27.36275,0.105,NULL,59862230003,935347343,14614802,18),(135032,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135032,35.59,0.47,131,63922,NULL,NULL,'H','NGC 6045',NULL,'2007A&A...465...71T',2007,1,1.17,NULL,'G',0.000033,NULL,'14.9g',0.28,'SB(s)c','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.282875,17.75767,0.061,NULL,56568821477,883887835,13810747,14.9),(135033,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135033,35.69,0.45,137,63922,NULL,NULL,'K','NGC 6045',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135034,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135034,35.76,0.31,142,63922,NULL,NULL,'Malmquist cor.','NGC 6045',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135035,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135035,35.79,0.46,144,63922,NULL,NULL,'J','NGC 6045',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135036,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135036,35.85,0.4,148,63922,NULL,NULL,'mean','NGC 6045',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135037,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135037,35.87,0.29,149,63922,NULL,NULL,NULL,'NGC 6045',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135038,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135038,35.91,0.2,152,63922,74.4,NULL,NULL,'NGC 6045',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135039,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135039,37.79,0.33,362,63923,70,NULL,NULL,'2MASX J16050810+5304379',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00009,NULL,'17.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,241.2839583,53.07714,0.009,NULL,59701087122,932829486,14575460,17.2),(135040,'Faber-Jackson','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135040,34.71,0.44,87.5,63924,95,NULL,'Weighted Mean','NGC 6047',NULL,'1984ApJS...56...91D',1984,1,1.1,NULL,'G',0.00006,NULL,'14.55',0.8,'E+','Supercluster (RV-confirmed) member',NULL,'radio jet',NULL,1,241.2874583,17.72989,0.061,NULL,56568820136,883887814,13810747,14.55),(135041,'Faber-Jackson','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135041,35.17,0.46,108,63924,95,NULL,'Michard 1979a','NGC 6047',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135042,'Faber-Jackson','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135042,35.6,0.63,132,63924,95,NULL,'Michard 1979b, c','NGC 6047',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135043,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135043,35.56,0.25,129,63924,74.4,NULL,NULL,'NGC 6047',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135044,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135044,35.77,0.25,143,63924,70,NULL,NULL,'NGC 6047',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135045,'Magnitude','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135045,35.98,NULL,157,63924,NULL,NULL,'Hurcules Cluster, ABELL 2151','NGC 6047',NULL,'1995A&A...302...21G',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135046,'Sosies','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135046,35.25,0.3,112,63924,NULL,NULL,'Hurcules Cluster, ABELL 2151, vs. Messier 031 m-M = 24.07 mag','NGC 6047',NULL,'1986ApJ...308..487D',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135047,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135047,35.72,0.4,140,63924,NULL,NULL,'mean','NGC 6047',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135048,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135048,35.88,0.16,150,63924,70,NULL,'ABELL 2151 Cluster','NGC 6047',NULL,'1992ApJ...396..453H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135049,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135049,36.17,0.45,172,63924,NULL,NULL,'K','NGC 6047',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135050,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135050,37.16,0.27,270,63925,70,NULL,NULL,'2MASX J16050901+3711195',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00012,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,241.287625,37.18883,0.029,NULL,59774757817,933980590,14593446,16.7),(135051,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135051,36.25,0.27,178,63926,70,NULL,NULL,'2MASX J16051015+2724027',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000187,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,241.2925,27.40086,0.105,NULL,59862274062,935348032,14614813,16.5),(135052,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135052,37.95,0.46,390,63927,70,NULL,NULL,'2MASX J16051051+1344069',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,241.29375,13.73522,0.089,NULL,56550197059,883596829,13806200,17.9),(135053,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135053,36.84,0.46,234,63928,70,NULL,NULL,'2MASX J16051184+2114236',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000014,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,241.2992917,21.23983,0.137,NULL,56506944623,882921009,13795640,16.1),(135054,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135054,35.09,0.58,104,63929,70,NULL,NULL,'2MASX J16051251-0212528',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.4,NULL,NULL,NULL,NULL,NULL,1,241.3022083,-2.21472,0.577,NULL,45528047418,711375740,11115245,14.2),(135055,'IRAS','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135055,35.75,0.8,141,63930,75,NULL,'W91CL, r','IC 1173',NULL,'1997ApJS..109..333W',1997,1,0.95,NULL,'G',0.000023,NULL,'15.2g',0.5,'SAB(rs)c','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.302333,17.42286,0.049,NULL,56568742206,883886596,13810728,15.2),(135056,'IRAS','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135056,35.75,0.8,141,63930,75,NULL,'HMCL, I','IC 1173',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135057,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135057,35.42,0.56,122,63930,NULL,NULL,NULL,'IC 1173',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135058,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135058,35.46,0.2,124,63930,74.4,NULL,NULL,'IC 1173',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135059,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135059,35.5,0.54,126,63930,NULL,NULL,'Malmquist cor.','IC 1173',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135060,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135060,35.64,0.4,134,63930,75,NULL,'HMCL, I, raw','IC 1173',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135061,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135061,35.83,0.38,147,63930,75,NULL,'W91CL, r, raw','IC 1173',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135062,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135062,35.86,0.4,149,63930,75,NULL,'HMCL, I, inv','IC 1173',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135063,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135063,35.94,0.4,154,63930,75,NULL,'HMCL, I, cor','IC 1173',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135064,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135064,36.02,0.38,160,63930,75,NULL,'W91CL, r, inv','IC 1173',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135065,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135065,36.09,0.38,165,63930,75,NULL,'W91CL, r, cor','IC 1173',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135066,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135066,34.27,0.4,71.4,63931,NULL,NULL,'mean','NGC 6052',NULL,'2007A&A...465...71T',2007,1,NULL,'One of two 6cm sources associated with [WB92] 1603+2037','GPair',0.000003,NULL,NULL,NULL,'Sc+Sc          LIRG','Supercluster foreground object',NULL,NULL,NULL,1,241.304125,20.54236,0.101,NULL,56521323990,883145687,13799151,NULL),(135067,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135067,35.7,0.46,138,63931,NULL,NULL,'J','NGC 6052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135068,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135068,35.72,0.47,140,63931,NULL,NULL,'H','NGC 6052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135069,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135069,35.73,0.45,140,63931,NULL,NULL,'K','NGC 6052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135070,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135070,36.14,0.05,169,63932,70,NULL,NULL,'2MASX J16051341+1639178',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.306,16.65511,0.033,NULL,56572098797,883939043,13811547,17.4),(135071,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135071,38.15,0.46,427,63933,70,NULL,NULL,'SDSS J160514.31+263053.9',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.309667,26.515,0.129,NULL,59862510599,935351728,14614870,18),(135072,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135072,38.18,0.46,433,63934,70,NULL,NULL,'SDSS J160514.65+175442.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.311083,17.91169,0.057,NULL,56568605832,883884466,13810694,17.9),(135073,'BCG','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135073,36.43,0.35,186,63935,60,NULL,NULL,'ABELL 2151',0.036,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.3124583,17.74853,0.061,NULL,56568818754,883887793,13810746,NULL),(135074,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135074,36.06,0.08,163,63935,70,NULL,NULL,'ABELL 2151',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135075,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135075,35.63,0.25,134,63936,74.4,NULL,NULL,'GIN 516',NULL,'2013AJ....146...86T',2013,1,0.74,NULL,'G',0.000177,NULL,'15.5g',0.48,'E',NULL,NULL,NULL,NULL,1,241.312958333,15.92608,0.061,NULL,56571009505,883922023,13811281,15.5),(135076,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135076,35.79,0.18,144,63936,70,NULL,NULL,'GIN 516',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135077,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135077,36.14,0.05,169,63936,70,NULL,NULL,'GIN 516',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135078,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135078,35.9,0.49,151,63937,75,NULL,'IR','2MFGC 12915',NULL,'2011yCatp016004901K',2011,1,0.6,NULL,'G',0.000014,NULL,'14.76',0.3,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,241.314125,17.53969,0.061,NULL,56568789372,883887333,13810739,14.76),(135079,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135079,35.96,0.33,156,63937,NULL,NULL,'Malmquist cor.','2MFGC 12915',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135080,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135080,35.96,0.34,156,63937,NULL,NULL,NULL,'2MFGC 12915',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135081,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135081,36.11,0.2,167,63937,74.4,NULL,NULL,'2MFGC 12915',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135082,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135082,36.93,0.27,243,63938,70,NULL,NULL,'2MASX J16051568+0008167',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000116,NULL,'16.6g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,241.31525,0.13808,0.377,NULL,56476445973,882444468,13788194,16.6),(135083,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135083,36.14,0.05,169,63939,70,NULL,NULL,'2MASX J16051599+1821586',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'16.63',0.25,'Ep','Group member',NULL,NULL,NULL,1,241.316833,18.36625,0.041,NULL,56510930482,882983288,13796613,16.63),(135084,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135084,36.81,0.46,230,63940,70,NULL,NULL,'2MASX J16051631+4431288',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000201,NULL,'16.0g',0.3,'E0',NULL,NULL,NULL,NULL,1,241.318166667,44.52475,0.017,NULL,59802666587,934416665,14600260,16),(135085,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135085,36.66,0.46,215,63941,70,NULL,NULL,'2MASX J16051655+2008146',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,241.318875,20.13758,0.093,NULL,56520865675,883138526,13799039,16.3),(135086,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135086,35.11,0.25,105,63942,74.4,NULL,NULL,'CGCG 137-034',NULL,'2013AJ....146...86T',2013,1,0.53,NULL,'G',0.000063,NULL,'15.4g',0.47,'S',NULL,NULL,NULL,NULL,1,241.323417,23.75567,0.149,NULL,59395170020,928049531,14500773,15.4),(135087,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135087,35.31,0.29,115,63942,70,NULL,NULL,'CGCG 137-034',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135088,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135088,36.01,0.16,159,63942,70,NULL,NULL,'CGCG 137-034',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135089,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135089,36.93,0.27,243,63943,70,NULL,NULL,'2MASX J16051910+0007512',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000093,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,241.3295417,0.131,0.377,NULL,56476489446,882445147,13788205,17.2),(135090,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135090,35.42,0.73,121,63944,70,NULL,NULL,'2MASX J16051968-0223247',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000127,NULL,'13.9I',0.4,NULL,NULL,NULL,NULL,NULL,1,241.3320417,-2.39025,0.505,NULL,45527201229,711362519,11115039,13.9),(135091,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135091,36.53,0.33,203,63945,70,NULL,NULL,'SDSS J160520.10+441332.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000163,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,241.33375,44.22561,0.021,NULL,59806281774,934473152,14601143,17.9),(135092,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135092,37.45,0.46,309,63946,70,NULL,NULL,'2MASX J16052012+1033075',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,241.3339583,10.55214,0.149,NULL,56578291354,884035802,13813059,17),(135093,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135093,37.92,0.13,384,63947,70,NULL,NULL,'2MASX J16052026+2419258',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00008,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.334625,24.32383,0.177,NULL,59391617003,927994015,14499906,17.7),(135094,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135094,37.99,0.46,397,63948,70,NULL,NULL,'2MASX J16052035+1822466',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000206,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,241.3349583,18.37953,0.041,NULL,56510928653,882983260,13796613,17.1),(135095,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135095,36.21,0.43,175,63949,NULL,NULL,'Malmquist cor.','2MFGC 12917',NULL,'2009ApJS..182..474S',2009,1,0.54,NULL,'G',0.000023,NULL,'15.34',NULL,'Sc',NULL,NULL,NULL,NULL,1,241.335667,14.73933,0.109,NULL,56558029121,883719205,13808112,15.34),(135096,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135096,36.45,0.49,195,63949,75,NULL,'IR','2MFGC 12917',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135097,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135097,36.47,0.39,197,63949,NULL,NULL,NULL,'2MFGC 12917',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135098,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135098,36.51,0.2,200,63949,74.4,NULL,NULL,'2MFGC 12917',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135099,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135099,36.76,0.46,225,63950,70,NULL,NULL,'2MASX J16052247+2321316',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000149,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.343625,23.35894,0.153,NULL,59395341126,928052205,14500815,17),(135100,'IRAS','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135100,35.55,0.8,129,63951,75,NULL,'W91CL, r','UGC 10186',NULL,'1997ApJS..109..333W',1997,1,NULL,'Delta V > 1000 km/sec; probably an optical pair.','GPair',0.000073,NULL,NULL,NULL,'DBL SYS','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.344916667,17.75506,0.061,NULL,56568824102,883887876,13810748,NULL),(135101,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135101,35.42,0.38,121,63951,75,NULL,'W91CL, r, raw','UGC 10186',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135102,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135102,35.57,0.38,130,63951,75,NULL,'W91CL, r, inv','UGC 10186',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135103,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135103,35.74,0.38,140,63951,75,NULL,'W91CL, r, cor','UGC 10186',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135104,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135104,38,0.46,397,63952,70,NULL,NULL,'2MASX J16052297+2841039',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.345666667,28.68447,0.081,NULL,59867515016,935429922,14616092,18),(135105,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135105,35.87,0.46,149,63953,70,NULL,NULL,'2MASX J16052340+2230276',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000174,NULL,'15.6g',0.43,NULL,NULL,NULL,NULL,NULL,1,241.3474583,22.50775,0.173,NULL,59393793662,928028025,14500437,15.6),(135106,'IRAS','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135106,35.55,0.8,129,63954,75,NULL,'HMCL, I','NGC 6050',NULL,'1997ApJS..109..333W',1997,1,0.93,'Component \'b)\' in UGC notes.','G',0.000104,NULL,'15.2g',0.58,'SA(s)c           AGN','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.347375,17.75717,0.065,NULL,56568824099,883887876,13810748,15.2),(135107,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135107,35.85,0.4,148,63954,75,NULL,'HMCL, I, raw','NGC 6050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135108,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135108,36.04,0.4,161,63954,75,NULL,'HMCL, I, inv','NGC 6050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135109,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135109,36.13,0.4,168,63954,75,NULL,'HMCL, I, cor','NGC 6050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135110,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135110,36.06,0.46,163,63955,70,NULL,NULL,'CGCG 108-115',NULL,'2015arXiv151105856S',2015,1,1.3,NULL,'G',0.000233,NULL,'14.30',1.3,'E+','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.349375,14.64767,0.109,NULL,56557927753,883717621,13808087,14.3),(135111,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135111,36.51,0.46,201,63956,70,NULL,NULL,'2MASX J16052516+0409350',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000187,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,241.354875,4.15961,0.241,NULL,56490663951,882666624,13791666,16.4),(135112,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135112,37.44,0.46,308,63957,70,NULL,NULL,'2MASX J16052545+2755419',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000198,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,241.356083333,27.92831,0.085,NULL,59875810562,935559540,14618117,16.8),(135113,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135113,35.64,0.25,134,63958,74.4,NULL,NULL,'UGC 10187 NED01',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.000053,NULL,'15.3g',0.5,'E','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.360125,16.44275,0.029,NULL,56572233001,883941140,13811580,15.3),(135114,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135114,35.79,0.18,144,63958,70,NULL,NULL,'UGC 10187 NED01',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135115,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135115,36.14,0.05,169,63958,70,NULL,NULL,'UGC 10187 NED01',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135116,'IRAS','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135116,35.88,0.8,150,63959,75,NULL,'HMCL, I','UGC 10190',NULL,'1997ApJS..109..333W',1997,1,0.85,NULL,'G',0.000007,NULL,'16.6g',0.18,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,241.359583,17.69683,0.065,NULL,56568837586,883888087,13810751,16.6),(135117,'IRAS','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135117,35.88,0.8,150,63959,75,NULL,'W91CL, r','UGC 10190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135118,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135118,35.55,0.4,129,63959,75,NULL,'HMCL, I, raw','UGC 10190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135119,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135119,35.65,0.4,135,63959,75,NULL,'HMCL, I, inv','UGC 10190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135120,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135120,35.71,0.38,138,63959,75,NULL,'W91CL, r, raw','UGC 10190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135121,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135121,35.76,0.38,142,63959,75,NULL,'W91CL, r, inv','UGC 10190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135122,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135122,35.87,0.4,149,63959,75,NULL,'HMCL, I, cor','UGC 10190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135123,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135123,35.92,0.34,153,63959,NULL,NULL,NULL,'UGC 10190',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135124,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135124,35.97,0.38,157,63959,75,NULL,'W91CL, r, cor','UGC 10190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135125,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135125,36,0.33,159,63959,NULL,NULL,'Malmquist cor.','UGC 10190',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135126,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135126,36.01,0.2,159,63959,74.4,NULL,NULL,'UGC 10190',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135127,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135127,35.66,0.5,136,63960,70,NULL,NULL,'2MASX J16052668-0156187',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.0001,NULL,'15.91',0.7,NULL,NULL,NULL,NULL,NULL,1,241.361083,-1.93864,0.497,NULL,45527509347,711367333,11115114,15.91),(135128,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:54','1','SN 2000cp',NULL,135128,35.98,0.17,152,63961,70,NULL,'SALT 2','2MFGC 12921',0.034204,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'GPair',0.00015,NULL,NULL,NULL,'S','Group member',NULL,NULL,NULL,1,241.363625,17.83097,0.061,NULL,56568598834,883884356,13810693,NULL),(135129,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135129,37.16,0.27,270,63962,70,NULL,NULL,'2MASX J16052743+3716365',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000173,NULL,'15.8g',0.43,'E0',NULL,NULL,NULL,NULL,1,241.364458333,37.27683,0.029,NULL,59774751197,933980487,14593445,15.8),(135130,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135130,37.16,0.27,270,63963,70,NULL,NULL,'2MASX J16052793+3717225',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,'FoF','17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.3662917,37.28964,0.029,NULL,59774779983,933980937,14593452,17.3),(135131,'BCG','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135131,36.97,0.35,237,63964,60,NULL,'ABELL 2152, BCG','UGC 10187 NED02',0.0444,'1980ApJ...241..486H',1980,1,1.3,NULL,'G',0.000043,NULL,'13.86',1.3,'E','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.371583,16.43586,0.029,NULL,56572234988,883941171,13811580,13.86),(135132,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135132,35.63,0.25,134,63964,74.4,NULL,NULL,'UGC 10187 NED02',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135133,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135133,35.79,0.18,144,63964,70,NULL,NULL,'UGC 10187 NED02',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135134,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135134,37.38,0.33,299,63965,70,NULL,NULL,'2MASX J16052990+2724499',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000152,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,241.3747083,27.41389,0.105,NULL,59862261357,935347833,14614809,17.1),(135135,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135135,35.53,0.67,127,63966,NULL,NULL,NULL,'KUG 1603+179A',NULL,'2009ApJS..182..474S',2009,1,0.67,'Often incorrectly identified as NGC 6054.','G',0.000023,NULL,'15.9g',0.41,'(R\')SAB(s)b','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.377625,17.76867,0.065,NULL,56568824654,883887885,13810748,15.9),(135136,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135136,35.53,0.67,128,63966,NULL,NULL,'Malmquist cor.','KUG 1603+179A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135137,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135137,36.32,0.46,184,63967,70,NULL,NULL,'2MASX J16053064-0015597',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000071,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.37775,-0.26647,0.417,NULL,45525066901,711329170,11114518,17.2),(135138,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135138,37.81,0.46,366,63968,70,NULL,NULL,'SDSS J160530.68+100827.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.377875,10.14111,0.149,NULL,56586103492,884157867,13814966,18.2),(135139,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135139,37.79,0.46,362,63969,70,NULL,NULL,'2MASX J16053093+0953175',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,241.378875,9.88833,0.141,NULL,56586048267,884157004,13814953,16.9),(135140,'BCG','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135140,36.97,0.35,237,63970,60,NULL,NULL,'ABELL 2152',0.0444,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.384166667,16.44194,0.029,NULL,56572235691,883941182,13811580,NULL),(135141,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135141,37.66,0.46,340,63971,70,NULL,NULL,'2MASX J16053230+2439559',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000178,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,241.3847083,24.66558,0.181,NULL,59864540990,935383452,14615366,17.5),(135142,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135142,35.58,0.25,131,63972,74.4,NULL,NULL,'NGC 6055',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000083,NULL,'14.7g',0.6,'(R)SAB0+','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.385666667,18.15958,0.053,NULL,56566487260,883851363,13810177,14.7),(135143,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135143,35.77,0.25,143,63972,70,NULL,NULL,'NGC 6055',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135144,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135144,35.85,0.4,148,63973,NULL,NULL,'mean','IC 1178',NULL,'2007A&A...465...71T',2007,1,1.13,NULL,'G',0.000033,NULL,'14.9g',0.6,'S0- pec?','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.388,17.60144,0.061,NULL,56568779663,883887182,13810737,14.9),(135145,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135145,36.1,0.45,166,63973,NULL,NULL,'K','IC 1178',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135146,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135146,37.96,0.46,391,63974,70,NULL,NULL,'2MASX J16053313+3326457',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.388083,33.44606,0.037,NULL,59764916123,933826814,14591043,17.6),(135147,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135147,37.71,0.46,349,63975,70,NULL,NULL,'2MASX J16053412+2949059',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000146,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.3922917,29.81822,0.073,NULL,59736893576,933388962,14584202,17.7),(135148,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135148,36.59,0.46,208,63976,70,NULL,NULL,'2MASX J16053432+0542100',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000168,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,241.393125,5.70289,0.173,NULL,56489761521,882652523,13791445,16.3),(135149,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135149,37.73,0.46,352,63977,70,NULL,NULL,'2MASX J16053494+5256441',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000115,NULL,'17.1g',0.28,'NLAGN',NULL,NULL,NULL,NULL,1,241.395667,52.94561,0.009,NULL,59699990691,932812354,14575193,17.1),(135150,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135150,36.53,0.33,203,63978,70,NULL,NULL,'CGCG 223-039',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.000196,NULL,'14.8g',0.65,'E              AGN:',NULL,NULL,NULL,NULL,1,241.398166667,44.20614,0.021,NULL,59806280157,934473127,14601142,14.8),(135151,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135151,37.71,0.46,348,63979,70,NULL,NULL,'2MASX J16053577+5331001',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000079,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,241.399041667,53.51675,0.025,NULL,59699943490,932811617,14575181,17.4),(135152,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135152,35.58,0.25,131,63980,74.4,NULL,NULL,'CGCG 108-127',NULL,'2013AJ....146...86T',2013,1,0.66,NULL,'G',0.000023,NULL,'15.4g',0.45,'SB(r)b','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.40225,18.273,0.053,NULL,56510912419,882983006,13796609,15.4),(135153,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135153,35.77,0.25,143,63980,70,NULL,NULL,'CGCG 108-127',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135154,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135154,35.87,0.33,149,63981,NULL,NULL,'Malmquist cor.','IC 1182',NULL,'2009ApJS..182..474S',2009,1,0.76,NULL,'G',0.000027,NULL,'15.0g',0.6,'SA0+ pec       HII','Supercluster (RV-confirmed) member',NULL,NULL,'Sy 2',1,241.403333,17.80214,0.065,NULL,56568619954,883884686,13810698,15),(135155,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135155,36.24,0.28,177,63981,NULL,NULL,NULL,'IC 1182',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135156,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135156,36.28,0.2,180,63981,74.4,NULL,NULL,'IC 1182',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135157,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135157,35.32,0.52,116,63982,NULL,NULL,NULL,'LSBC F584-01',NULL,'2009ApJS..182..474S',2009,1,0.86,NULL,'G',0.000184,NULL,'15.4g',0.61,'S?',NULL,NULL,NULL,NULL,1,241.403333,22.18639,0.161,NULL,59393875959,928029311,14500457,15.4),(135158,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135158,35.42,0.5,122,63982,NULL,NULL,'Malmquist cor.','LSBC F584-01',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135159,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135159,35.55,0.2,129,63982,74.4,NULL,NULL,'LSBC F584-01',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135160,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135160,36.95,0.46,245,63983,70,NULL,NULL,'2MASX J16053696+4904001',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000112,NULL,'15.9g',0.46,'E0',NULL,NULL,NULL,NULL,1,241.404167,49.06658,0.045,NULL,59704756799,932886824,14576356,15.9),(135161,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135161,38.1,0.23,416,63984,70,NULL,NULL,'2MASX J16053806+2256258',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000178,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.4084583,22.94042,0.165,NULL,59394925241,928045706,14500714,17.3),(135162,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135162,36.41,0.2,191,63985,74.4,NULL,NULL,'CGCG 079-045',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000147,NULL,'15.0',0.4,'Sbc',NULL,NULL,NULL,NULL,1,241.408666667,10.03542,0.149,NULL,56586063274,884157238,13814956,15),(135163,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135163,36.14,0.05,169,63986,70,NULL,NULL,'NGC 6054',NULL,'2015arXiv151105856S',2015,1,0.86,'Misidentified as IC 1184 in CGCG and in several papers referring to it.','G',0.000103,NULL,'15.1g',0.47,'SAB0-','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.4089583,17.76789,0.065,NULL,56568798987,883887484,13810741,15.1),(135164,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135164,35.57,0.2,130,63986,74.4,NULL,NULL,'NGC 6054',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135165,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135165,38.1,0.23,416,63987,70,NULL,NULL,'2MASX J16053921+2257538',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00021,NULL,'16.2g',0.42,NULL,NULL,NULL,NULL,NULL,1,241.413333,22.96506,0.165,NULL,59394928383,928045755,14500714,16.2),(135166,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135166,35.57,0.25,130,63988,74.4,NULL,NULL,'NGC 6053',NULL,'2013AJ....146...86T',2013,1,0.59,NULL,'G',0.000053,NULL,'15.3g',0.56,'E','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.4152083,18.16436,0.053,NULL,56566482108,883851282,13810176,15.3),(135167,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135167,35.77,0.25,143,63988,70,NULL,NULL,'NGC 6053',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135168,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135168,37.89,0.46,378,63989,70,NULL,NULL,'2MASX J16054008+3814020',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000148,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,241.416875,38.23394,0.009,NULL,59774233208,933972393,14593318,17.5),(135169,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135169,36.14,0.05,169,63990,70,NULL,NULL,'2MASX J16054022+1535308',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000171,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,241.417667,15.592,0.061,NULL,56571696890,883932763,13811449,16.3),(135170,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135170,32.71,NULL,34.9,63991,72,NULL,NULL,'HIPASS J1605-04',NULL,'2014Ap.....57..457K',2014,1,1.3,NULL,'G',0.000003,NULL,'18.2',1,'Ir',NULL,NULL,NULL,NULL,1,241.418333,-4.57225,0.561,NULL,45553585371,711774771,11121480,18.2),(135171,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135171,36.14,0.05,169,63992,70,NULL,NULL,'2MASX J16054083+1806268',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000057,NULL,'16.0g',0.39,'E2','Group member',NULL,NULL,NULL,1,241.420167,18.10753,0.053,NULL,56566483811,883851309,13810176,16),(135172,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135172,35.19,0.81,109,63993,NULL,NULL,'Malmquist cor.','AGC 261206',NULL,'2009ApJS..182..474S',2009,1,0.78,NULL,'G',0.000027,NULL,'14.8',NULL,'SBa',NULL,NULL,NULL,NULL,1,241.420625,14.79906,0.109,NULL,56557241294,883706895,13807920,14.8),(135173,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135173,35.23,0.79,111,63993,NULL,NULL,NULL,'AGC 261206',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135174,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135174,35.27,0.2,113,63993,74.4,NULL,NULL,'AGC 261206',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135175,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135175,38.1,0.46,416,63994,70,NULL,NULL,'2MASX J16054114+2837190',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000151,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,241.4212917,28.62194,0.081,NULL,59867507979,935429812,14616090,17.3),(135176,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135176,35.4,0.46,120,63995,70,NULL,NULL,'2MASX J16054145+1326378',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.4227083,13.44381,0.077,NULL,56551183064,883612235,13806441,16.6),(135177,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135177,35.73,0.46,140,63996,70,NULL,NULL,'2MASX J16054218+5239590',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000084,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,241.425583,52.66653,0.009,NULL,59701595757,932837433,14575584,17.1),(135178,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135178,36.14,0.05,169,63997,70,NULL,NULL,'2MASX J16054228+1626258',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.426291667,16.44047,0.029,NULL,56572203344,883940677,13811573,17.1),(135179,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135179,38.06,0.46,409,63998,70,NULL,NULL,'2MASX J16054235+2211258',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'18.0g',0.11,NULL,NULL,NULL,NULL,NULL,1,241.426417,22.19047,0.161,NULL,59393873588,928029274,14500457,18),(135180,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135180,34.22,NULL,69.8,63999,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1986',NULL,'2010Ap&SS.325..163P',2010,1,0.93,NULL,'G',0.000011,NULL,'16.5g',0.18,'Sc',NULL,NULL,NULL,NULL,1,241.427833,22.45658,0.173,NULL,59393912621,928029884,14500466,16.5),(135181,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135181,34.23,NULL,70.2,63999,NULL,NULL,'Dipole + Quadrupole','FGC 1986',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135182,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135182,34.25,NULL,70.7,63999,NULL,NULL,'Dipole','FGC 1986',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135183,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135183,34.29,NULL,72.1,63999,NULL,NULL,NULL,'FGC 1986',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135184,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135184,36.14,0.05,169,64000,70,NULL,NULL,'2MASX J16054299+1548528',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,241.429167,15.81458,0.061,NULL,56571505676,883929776,13811402,16.8),(135185,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135185,36.59,0.46,208,64001,70,NULL,NULL,'2MASX J16054346+1659348',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000097,NULL,'16.1g',0.33,'E',NULL,NULL,NULL,NULL,1,241.431,16.99308,0.053,NULL,56569314840,883895544,13810867,16.1),(135186,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135186,36.14,0.05,169,64002,70,NULL,NULL,'SDSS J160544.02+161534.5',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',NULL,NULL,'15.6g',0.42,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.4334583,16.25958,0.073,NULL,56572136772,883939637,13811556,15.6),(135187,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135187,35.96,0.4,156,64003,NULL,NULL,'Malmquist cor.','IC 1186',NULL,'2009ApJS..182..474S',2009,1,0.78,NULL,'G',0.000033,NULL,'15.2g',0.5,'SB(r)b         AGN','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.43425,17.36217,0.049,NULL,56569491255,883898300,13810910,15.2),(135188,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135188,36.44,0.32,194,64003,NULL,NULL,NULL,'IC 1186',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135189,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135189,36.48,0.2,198,64003,74.4,NULL,NULL,'IC 1186',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135190,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135190,36.25,0.27,178,64004,70,NULL,NULL,'2MASX J16054449+2726188',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000185,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,241.4352917,27.43869,0.105,NULL,59862266538,935347914,14614811,16.3),(135191,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135191,36.29,0.49,181,64005,75,NULL,'IR','UGC 10193 NED01',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000014,NULL,'15.7',0.2,'Sbc','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.435833,16.20336,0.069,NULL,56571037102,883922454,13811288,15.7),(135192,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135192,35.57,0.25,130,64006,74.4,NULL,NULL,'IC 1185',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000093,NULL,'14.89',0.5,'SA(rs)ab:','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.436208333,17.71703,0.065,NULL,56568803660,883887557,13810743,14.89),(135193,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135193,35.77,0.25,143,64006,70,NULL,NULL,'IC 1185',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135194,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135194,35.44,0.47,122,64006,NULL,NULL,'H','IC 1185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135195,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135195,35.62,0.46,133,64006,NULL,NULL,'J','IC 1185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135196,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135196,35.67,0.45,136,64006,NULL,NULL,'K','IC 1185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135197,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135197,35.89,0.4,151,64006,NULL,NULL,'mean','IC 1185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135198,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','PS1 SN PS10kd','N',135198,41.4,0.2,1430,64007,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10kd HOST',0.3311,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135199,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135199,37.5,0.46,316,64008,70,NULL,NULL,'SDSS J160544.90+282945.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00017,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,241.437125,28.49592,0.081,NULL,59867632981,935431765,14616121,17.9),(135200,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135200,37.07,0.33,259,64009,70,NULL,NULL,'2MASX J16054585+1140155',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'15.7g',0.43,NULL,NULL,NULL,NULL,NULL,1,241.441083,11.67092,0.141,NULL,56579419081,884053423,13813334,15.7),(135201,'Tully est','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135201,32.53,0.8,32.1,64010,75,NULL,'B','UGC 10200',NULL,'1988NBGC.C....0000T',1988,1,0.71,NULL,'G',0.000006,NULL,'13.6g',0.67,'Sab            HII','Pair member (points to parent)',NULL,NULL,NULL,1,241.44125,41.34475,0,NULL,59810764387,934543193,14602237,13.6),(135202,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135202,35.59,0.25,131,64011,74.4,NULL,NULL,'CGCG 108-135',NULL,'2013AJ....146...86T',2013,1,0.55,NULL,'G',0.00007,NULL,'15.7g',0.46,'SB(rs)b','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.442917,18.01681,0.057,NULL,56568591135,883884236,13810691,15.7),(135203,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135203,35.77,0.25,143,64011,70,NULL,NULL,'CGCG 108-135',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135204,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135204,37.49,0.46,315,64012,70,NULL,NULL,'SDSS J160546.85+375855.6',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,'PRED','17.1g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.4452083,37.98211,0,NULL,59774215909,933972123,14593314,17.1),(135205,'Tully est','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135205,32.6,0.8,33.2,64013,75,NULL,'B','CGCG 223-037',NULL,'1988NBGC.C....0000T',1988,1,0.7,'Kirshner, et al. (1978,AJ,83,1549) give v_hel_=14110 km/sec.','G',0.000053,NULL,'15.2g',0.4,'S?','Pair member (points to parent)',NULL,NULL,NULL,1,241.4459583,41.31825,0,NULL,59810719851,934542497,14602226,15.2),(135206,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135206,35.62,0.25,133,64014,74.4,NULL,NULL,'CGCG 108-131',NULL,'2013AJ....146...86T',2013,1,0.89,NULL,'G',0.000057,NULL,'14.7g',0.76,'E+','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.446333,15.79097,0.061,NULL,56571504329,883929755,13811402,14.7),(135207,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135207,35.79,0.18,144,64014,70,NULL,NULL,'CGCG 108-131',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135208,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135208,36.14,0.05,169,64014,70,NULL,NULL,'CGCG 108-131',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135209,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135209,37.23,0.46,279,64015,70,NULL,NULL,'2MASX J16054757+1020125',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,241.448125,10.33683,0.153,NULL,56585927991,884155124,13814923,17.3),(135210,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135210,38.1,0.23,416,64016,70,NULL,NULL,'SDSS J160548.78+230708.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000172,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,241.4532917,23.11894,0.153,NULL,59394951268,928046113,14500720,18.6),(135211,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135211,37.19,0.46,274,64017,70,NULL,NULL,'2MASX J16054932+1803439',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000113,NULL,'17.0g',0.23,'E3','Group member',NULL,NULL,NULL,1,241.455625,18.06233,0.057,NULL,56568593427,883884272,13810691,17),(135212,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135212,35.12,0.25,106,64018,74.4,NULL,NULL,'GIN 492',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.00007,NULL,'16.5g',0.35,'E/S0',NULL,NULL,NULL,NULL,1,241.456583333,24.17592,0.173,NULL,59391669510,927994836,14499919,16.5),(135213,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135213,35.31,0.29,115,64018,70,NULL,NULL,'GIN 492',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135214,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135214,36.01,0.16,159,64018,70,NULL,NULL,'GIN 492',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135215,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135215,38.42,0.46,483,64019,70,NULL,NULL,'SDSS J160551.54+181422.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,241.4647917,18.23958,0.053,NULL,56510907487,882982929,13796608,18.5),(135216,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135216,33.92,0.8,60.9,64020,75,NULL,'CF, r','NGC 6060',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.00002,NULL,'13.80',1.1,'SAB(rs)c','Supercluster foreground object',NULL,NULL,NULL,1,241.466583333,21.48497,0.193,NULL,56506924321,882920692,13795635,13.8),(135217,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135217,33.95,0.8,61.7,64020,75,NULL,'HMCL, I','NGC 6060',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135218,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135218,33.55,0.4,51.3,64020,75,NULL,'HMCL, I, raw','NGC 6060',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135219,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135219,33.61,0.38,52.8,64020,75,NULL,'CF, r, raw','NGC 6060',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135220,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135220,33.77,0.4,56.8,64020,75,NULL,'HMCL, I, inv','NGC 6060',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135221,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135221,33.8,0.38,57.6,64020,75,NULL,'CF, r, inv','NGC 6060',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135222,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135222,33.84,0.4,58.6,64020,75,NULL,'HMCL, I, cor','NGC 6060',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135223,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135223,33.86,0.38,59.2,64020,75,NULL,'CF, r, cor','NGC 6060',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135224,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135224,33.95,0.2,61.7,64020,74.4,NULL,NULL,'NGC 6060',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135225,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135225,33.99,0.47,62.9,64020,NULL,NULL,'H','NGC 6060',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135226,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135226,34,0.45,63,64020,NULL,NULL,'K','NGC 6060',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135227,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135227,34.01,0.46,63.3,64020,NULL,NULL,'J','NGC 6060',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135228,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135228,34.15,0.4,67.6,64020,NULL,NULL,'mean','NGC 6060',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135229,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135229,38.01,0.46,400,64021,70,NULL,NULL,'2MASX J16055204+2919159',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000198,NULL,'16.9g',0.27,'E',NULL,NULL,NULL,NULL,1,241.466875,29.32117,0.081,NULL,59736979945,933390311,14584223,16.9),(135230,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135230,35.81,0.8,145,64022,75,NULL,'HMCL, I','IC 1190',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.00002,NULL,'15.61',0.4,'(R\')SAB(s)b','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.468375,18.22053,0.053,NULL,56510908076,882982938,13796608,15.61),(135231,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135231,35.81,0.8,145,64022,75,NULL,'W91CL, r','IC 1190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135232,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135232,35.91,0.38,152,64022,75,NULL,'W91CL, r, raw','IC 1190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135233,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135233,35.93,0.4,154,64022,75,NULL,'HMCL, I, raw','IC 1190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135234,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135234,35.95,0.3,155,64022,NULL,NULL,'Malmquist cor.','IC 1190',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135235,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135235,36.13,0.38,168,64022,75,NULL,'W91CL, r, inv','IC 1190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135236,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135236,36.15,0.38,170,64022,75,NULL,'W91CL, r, cor','IC 1190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135237,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135237,36.19,0.4,173,64022,75,NULL,'HMCL, I, inv','IC 1190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135238,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135238,36.21,0.4,175,64022,75,NULL,'HMCL, I, cor','IC 1190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135239,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135239,36.22,0.26,176,64022,NULL,NULL,NULL,'IC 1190',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135240,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135240,36.26,0.2,179,64022,74.4,NULL,NULL,'IC 1190',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135241,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135241,36.14,0.05,169,64023,70,NULL,NULL,'SDSS J160553.52+154231.7',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000113,NULL,'15.6g',0.37,'S',NULL,NULL,NULL,NULL,1,241.473,15.70881,0.061,NULL,56571710303,883932973,13811452,15.6),(135242,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135242,37.36,0.46,297,64024,70,NULL,NULL,'2MASX J16055363+3641371',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000177,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.473708333,36.69356,0.005,NULL,59776954082,934014907,14593982,17.3),(135243,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135243,36.47,0.46,197,64025,70,NULL,NULL,'2MASX J16055381-0033016',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000089,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.47425,-0.55044,0.433,NULL,45525851751,711341433,11114709,17.1),(135244,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135244,35.71,0.52,139,64026,70,NULL,NULL,'2MASX J16055385-0834146',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,241.474375,-8.57078,0.613,NULL,45574483488,712101304,11126582,15.5),(135245,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','PS1 SN PS10acx','N',135245,41.29,0.11,1340,64027,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10acx HOST',0.3501,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135246,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135246,38.21,0.46,439,64028,70,NULL,NULL,'2MASX J16055483+4046161',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000164,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,241.478458333,40.77128,0.017,NULL,59810644333,934541317,14602208,17.6),(135247,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135247,37.69,0.46,345,64029,70,NULL,NULL,'SDSS J160555.29+281722.0',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,241.480375,28.28947,0.073,NULL,59867439695,935428745,14616074,17.7),(135248,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135248,36.25,0.27,178,64030,70,NULL,NULL,'2MASX J16055534+2716279',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'16.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,241.480667,27.27456,0.105,NULL,59862283293,935348176,14614815,16.9),(135249,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135249,38.42,0.46,484,64031,70,NULL,NULL,'SDSS J160555.49+065848.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.3g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.48125,6.98019,0.189,NULL,56581566481,884086976,13813859,18.3),(135250,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135250,36.65,0.33,214,64032,70,NULL,NULL,'2MASX J16055606+4814033',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000094,NULL,'16.0g',0.42,NULL,NULL,NULL,NULL,NULL,1,241.4837083,48.23433,0,NULL,59704089475,932876398,14576193,16),(135251,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135251,38.07,0.46,410,64033,70,NULL,NULL,'2MASX J16055657+1440091',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.485875,14.66925,0.061,NULL,56557213519,883706461,13807913,17.8),(135252,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135252,37.51,0.46,318,64034,70,NULL,NULL,'2MASX J16055690+4218127',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000182,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,241.487125,42.30364,0.013,NULL,59808191153,934502986,14601609,16.9),(135253,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135253,37.92,0.46,384,64035,70,NULL,NULL,'SDSS J160557.04+480816.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000145,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,241.487667,48.13797,0,NULL,59705132347,932892692,14576448,18.1),(135254,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135254,37.57,0.46,327,64036,70,NULL,NULL,'2MASX J16055729+3507397',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.488625,35.12764,0.025,NULL,59766144174,933846002,14591343,17.2),(135255,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135255,36.14,0.05,169,64037,70,NULL,NULL,'2MASX J16055744+1543331',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000117,NULL,'15.9g',0.38,'S',NULL,NULL,NULL,NULL,1,241.489333333,15.72597,0.061,NULL,56571679798,883932496,13811445,15.9),(135256,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135256,36.42,0.55,192,64038,NULL,NULL,'Malmquist cor.','AGC 260959',NULL,'2009ApJS..182..474S',2009,1,0.73,NULL,'G',0.000016,NULL,'17.7g',0.1,'Scd',NULL,NULL,NULL,NULL,1,241.492125,16.46447,0.085,NULL,56572030243,883937972,13811530,17.7),(135257,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135257,36.88,0.45,238,64038,NULL,NULL,NULL,'AGC 260959',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135258,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135258,37.1,0.2,263,64038,74.4,NULL,NULL,'AGC 260959',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135259,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135259,38.1,0.23,416,64039,70,NULL,NULL,'SDSS J160558.28+225444.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000146,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,241.492875,22.91247,0.165,NULL,59394973838,928046466,14500726,18.8),(135260,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135260,37.74,0.46,354,64040,70,NULL,NULL,'2MASX J16055884+0620129',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.495167,6.33703,0.169,NULL,56459611004,882181421,13784084,17.5),(135261,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135261,36.83,0.46,232,64041,70,NULL,NULL,'2MASXi J1605590+534816',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00009,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,241.496083333,53.80467,0,NULL,57606191047,900096735,14064011,16.7),(135262,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135262,36.14,0.05,169,64042,70,NULL,NULL,'2MASX J16060013+1804512',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00015,NULL,'16.4g',0.35,'E/S0','Group member',NULL,NULL,NULL,1,241.5005,18.08103,0.081,NULL,56568580346,883884067,13810688,16.4),(135263,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135263,36.02,0.4,160,64043,NULL,NULL,'Malmquist cor.','CGCG 108-139',NULL,'2009ApJS..182..474S',2009,1,1.08,NULL,'G',0.00003,NULL,'15.2g',0.46,'SAB(rs)bc','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.500708333,18.19594,0.053,NULL,56518247415,883097615,13798400,15.2),(135264,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135264,36.52,0.32,201,64043,NULL,NULL,NULL,'CGCG 108-139',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135265,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135265,36.56,0.2,205,64043,74.4,NULL,NULL,'CGCG 108-139',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135266,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135266,36.65,0.33,214,64044,70,NULL,NULL,'2MASX J16060038+4810354',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000182,NULL,'16.1g',0.36,'E0',NULL,NULL,NULL,NULL,1,241.501667,48.17647,0,NULL,59705145133,932892892,14576451,16.1),(135267,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135267,32.89,NULL,37.8,64045,72,NULL,NULL,'CGCG 079-046',NULL,'2014Ap.....57..457K',2014,1,0.84,NULL,'G',0.000044,NULL,'15.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,241.509125,8.50675,0.145,NULL,56584514925,884133045,13814578,15.8),(135268,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135268,35.98,0.8,157,64046,75,NULL,'HMCL, I','CGCG 108-140',NULL,'1997ApJS..109..333W',1997,1,0.8,NULL,'G',0.000019,NULL,'16.0',0.4,'SB(s)a','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.509,18.67003,0.045,NULL,56518400811,883100012,13798437,16),(135269,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135269,35.98,0.8,157,64046,75,NULL,'W91CL, r','CGCG 108-140',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135270,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135270,35.7,0.4,138,64046,75,NULL,'HMCL, I, raw','CGCG 108-140',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135271,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135271,35.82,0.3,146,64046,NULL,NULL,'Malmquist cor.','CGCG 108-140',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135272,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135272,35.89,0.29,151,64046,NULL,NULL,NULL,'CGCG 108-140',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135273,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135273,35.96,0.4,156,64046,75,NULL,'HMCL, I, inv','CGCG 108-140',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135274,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135274,36.01,0.4,159,64046,75,NULL,'HMCL, I, cor','CGCG 108-140',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135275,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135275,36.19,0.2,173,64046,74.4,NULL,NULL,'CGCG 108-140',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135276,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135276,36.31,0.38,183,64046,75,NULL,'W91CL, r, raw','CGCG 108-140',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135277,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135277,36.52,0.38,202,64046,75,NULL,'W91CL, r, inv','CGCG 108-140',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135278,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135278,36.54,0.38,204,64046,75,NULL,'W91CL, r, cor','CGCG 108-140',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135279,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135279,36.82,0.46,231,64047,70,NULL,NULL,'2MASX J16060258+1237322',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'15.8g',0.43,NULL,NULL,NULL,NULL,NULL,1,241.5107083,12.62575,0.129,NULL,56551376109,883615251,13806488,15.8),(135280,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135280,36.14,0.05,169,64048,70,NULL,NULL,'2MASX J16060304+1742062',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000077,NULL,'16.81',0.2,'E','Group member',NULL,NULL,NULL,1,241.512583,17.70167,0.065,NULL,56568727432,883886366,13810724,16.81),(135281,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135281,35.59,0.25,131,64049,74.4,NULL,NULL,'GIN 523',NULL,'2013AJ....146...86T',2013,1,0.48,NULL,'G',0.000133,NULL,'16.1g',0.35,'S',NULL,NULL,NULL,NULL,1,241.514667,16.17575,0.069,NULL,56571173880,883924591,13811321,16.1),(135282,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135282,35.79,0.18,144,64049,70,NULL,NULL,'GIN 523',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135283,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135283,36.88,0.46,238,64050,70,NULL,NULL,'2MASX J16060361+3039004',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000184,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,241.515083333,30.65022,0.049,NULL,59735615963,933368999,14583890,16.5),(135284,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135284,37.07,0.33,259,64051,70,NULL,NULL,'SDSS J160603.70+114212.8',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,241.515417,11.70358,0.141,NULL,56579410101,884053282,13813332,NULL),(135285,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135285,37.66,0.46,341,64052,70,NULL,NULL,'2MASX J16060399+4807014',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.0002,NULL,'17.2g',0.25,'AGN',NULL,NULL,NULL,NULL,1,241.516625,48.11717,0.009,NULL,59705146229,932892909,14576451,17.2),(135286,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135286,36.4,0.46,191,64053,70,NULL,NULL,'2MASX J16060518+4519207',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000148,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,241.5217083,45.32253,0.021,NULL,59802779693,934418432,14600288,17.2),(135287,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135287,38.53,0.46,509,64054,70,NULL,NULL,'SDSS J160605.39+140011.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.6g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.5224583,14.00325,0.077,NULL,56550048671,883594510,13806164,18.6),(135288,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135288,36.98,0.13,249,64055,70,NULL,NULL,'2MASX J16060553+3325004',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000198,NULL,'15.9g',0.43,'E0',NULL,NULL,NULL,NULL,1,241.522958333,33.41678,0.037,NULL,59781942957,934092858,14595200,15.9),(135289,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135289,35.58,0.25,131,64056,74.4,NULL,NULL,'CGCG 108-141',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000077,NULL,'15.37',0.5,'SB0','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.5255,18.60689,0.045,NULL,56518475598,883101181,13798455,15.37),(135290,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135290,35.77,0.25,143,64056,70,NULL,NULL,'CGCG 108-141',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135291,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135291,36.14,0.05,169,64056,70,NULL,NULL,'CGCG 108-141',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135292,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135292,36.76,0.46,225,64057,70,NULL,NULL,'2MASX J16060691+4933224',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000106,NULL,'15.9g',0.37,'E0',NULL,NULL,NULL,NULL,1,241.5287917,49.55636,NULL,NULL,59704701086,932885954,14576343,15.9),(135293,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 1964C',NULL,135293,35.22,0.29,111,64058,NULL,NULL,'Avg. of 8 SN host galaxies','IC 1188A',NULL,'1985ApJ...297...23D',1985,1,0.68,NULL,'G',0.00015,NULL,'15.4g',0.51,'SAB(s)a','Group member',NULL,NULL,NULL,1,241.530417,17.46081,0.061,NULL,56568720388,883886256,13810722,15.4),(135294,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135294,37.02,0.46,253,64059,70,NULL,NULL,'2MASX J16060778+1515272',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000137,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.532333333,15.25764,0.061,NULL,56570868016,883919812,13811247,17.4),(135295,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135295,36.99,0.27,250,64060,70,NULL,NULL,'2MASX J16060826+0000493',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000082,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,241.5342917,0.01372,0.401,NULL,56476336274,882442754,13788168,17),(135296,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135296,37.3,0.46,288,64061,70,NULL,NULL,'2MASX J16060848+0435342',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000166,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.535291667,4.59267,0.205,NULL,56492657354,882697771,13792152,17.7),(135297,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135297,38.34,0.46,466,64062,70,NULL,NULL,'2MASX J16060917+1839042',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,241.538333,18.65125,0.045,NULL,56518468938,883101077,13798454,17.4),(135298,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135298,37.92,0.13,384,64063,70,NULL,NULL,'2MASX J16061004+2432560',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.541917,24.54883,0.181,NULL,59861681685,935338776,14614668,17.9),(135299,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135299,36.99,0.27,250,64064,70,NULL,NULL,'2MASX J16061082+0005052',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000086,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,241.545167,0.08481,0.401,NULL,56476519453,882445616,13788212,18),(135300,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 1967G',NULL,135300,35.22,0.29,111,64065,NULL,NULL,'Avg. of 8 SN host galaxies','2MFGC 12933',NULL,'1985ApJ...297...23D',1985,1,0.75,NULL,'G',0.000078,NULL,'16.4g',0.15,'S','Group member',NULL,NULL,NULL,1,241.5482083,18.32911,0.041,NULL,56518258854,883097794,13798403,16.4),(135301,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135301,36.42,0.49,192,64065,75,NULL,'IR','2MFGC 12933',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135302,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135302,36.09,0.46,165,64066,70,NULL,NULL,'MCG +07-33-041',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.0001,NULL,'15.2g',0.55,'S0','Field galaxy',NULL,NULL,NULL,1,241.5487083,40.41228,0.013,NULL,59809504915,934523514,14601929,15.2),(135303,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135303,35.61,0.58,132,64067,NULL,NULL,NULL,'AGC 260212',NULL,'2009ApJS..182..474S',2009,1,0.71,NULL,'G',0.000033,NULL,'15.8g',0.27,'SB(r)b','Group member',NULL,NULL,NULL,1,241.550458333,17.30208,0.049,NULL,56569174134,883893345,13810833,15.8),(135304,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135304,35.65,0.2,135,64067,74.4,NULL,NULL,'AGC 260212',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135305,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135305,35.65,0.57,135,64067,NULL,NULL,'Malmquist cor.','AGC 260212',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135306,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135306,38.01,0.46,399,64068,70,NULL,NULL,'2MASX J16061297+1750352',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000143,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,241.554167,17.84322,0.073,NULL,56568612378,883884568,13810696,18.3),(135307,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135307,35.96,0.36,156,64069,NULL,NULL,'Malmquist cor.','CGCG 108-146',NULL,'2009ApJS..182..474S',2009,1,0.69,NULL,'G',0.00003,NULL,'15.5g',0.48,'SAB(rs)bc','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.559417,18.41444,0.041,NULL,56518311359,883098614,13798415,15.5),(135308,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135308,36.12,0.33,168,64069,NULL,NULL,NULL,'CGCG 108-146',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135309,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135309,36.17,0.2,171,64069,74.4,NULL,NULL,'CGCG 108-146',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135310,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135310,38.55,0.46,513,64070,70,NULL,NULL,'2MASX J16061453+2406330',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000147,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,241.560583,24.10925,0.169,NULL,59391627272,927994176,14499909,18.7),(135311,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135311,37.38,0.46,300,64071,70,NULL,NULL,'2MASX J16061514+3448584',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.5632083,34.81625,0.021,NULL,59766621760,933853465,14591460,17.1),(135312,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135312,37.06,0.46,258,64072,70,NULL,NULL,'2MASX J16061524+1524532',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000187,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.563458333,15.41478,0.061,NULL,56570853794,883919590,13811243,17.4),(135313,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135313,35.58,0.25,131,64073,74.4,NULL,NULL,'NGC 6061',NULL,'2013AJ....146...86T',2013,1,0.98,'UZC has V = 11844 +- 50 km/sec.','G',0.00009,NULL,'14.4g',0.81,'SA0-','Supercluster (RV-confirmed) member',NULL,'head-tail','Flat-Spectrum Radio Source',1,241.566791667,18.24994,0.081,NULL,56516151357,883064864,13797888,14.4),(135314,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135314,35.77,0.25,143,64073,70,NULL,NULL,'NGC 6061',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135315,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135315,36.14,0.05,169,64073,70,NULL,NULL,'NGC 6061',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135316,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135316,36.04,0.4,161,64073,NULL,NULL,'mean','NGC 6061',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135317,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135317,36.58,0.45,207,64073,NULL,NULL,'K','NGC 6061',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135318,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135318,33.89,0.46,59.9,64074,NULL,NULL,'J','ESO 451- G 008',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000023,NULL,'14.04',0.3,'(R\')SB(s)b:',NULL,NULL,NULL,NULL,1,241.5675417,-29.28167,0.785,NULL,46244748687,722574198,11290221,14.04),(135319,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135319,33.9,0.47,60.4,64074,NULL,NULL,'H','ESO 451- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135320,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135320,34.08,0.45,65.4,64074,NULL,NULL,'K','ESO 451- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135321,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135321,34.1,0.4,66,64074,NULL,NULL,'mean','ESO 451- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135322,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135322,34.11,0.49,66.4,64074,75,NULL,'IR','ESO 451- G 008',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135323,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135323,34.58,0.43,82.3,64074,75,NULL,'3.6 micron, color + selection bias corrected','ESO 451- G 008',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135324,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135324,35.63,0.25,134,64075,74.4,NULL,NULL,'GIN 524',NULL,'2013AJ....146...86T',2013,1,0.57,NULL,'G',0.000063,NULL,'15.8g',0.39,'E/S0',NULL,NULL,NULL,NULL,1,241.56875,16.03919,0.069,NULL,56571147796,883924184,13811315,15.8),(135325,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135325,35.79,0.18,144,64075,70,NULL,NULL,'GIN 524',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135326,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135326,36.14,0.05,169,64075,70,NULL,NULL,'GIN 524',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135327,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135327,38.23,0.33,442,64076,70,NULL,NULL,'2MASX J16061767+2858237',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00026,NULL,'17.1g',0.27,'E',NULL,NULL,NULL,NULL,1,241.573583,28.97319,0.073,NULL,59736471438,933382366,14584099,17.1),(135328,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135328,36.23,0.46,176,64077,70,NULL,NULL,'2MASX J16061784+4956484',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000175,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,241.5742917,49.94689,NULL,NULL,59705985767,932906027,14576656,16.2),(135329,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135329,37.99,0.46,396,64078,70,NULL,NULL,'2MASX J16061815+3359484',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00018,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,241.575583,33.99686,0.013,NULL,59766458813,933850918,14591420,17.1),(135330,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135330,36.99,0.27,250,64079,70,NULL,NULL,'2MASX J16061880-0002095',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000096,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,241.5782083,-0.03592,0.409,NULL,45524995952,711328061,11114500,18.1),(135331,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135331,37.78,0.33,360,64080,70,NULL,NULL,'2MASX J16061900+2915378',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000171,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.579167,29.26047,0.077,NULL,59736977082,933390266,14584222,17.6),(135332,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135332,35.74,0.25,141,64081,74.4,NULL,NULL,'CGCG 108-142',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000063,NULL,'14.20',0.7,'E','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.581375,16.43142,0.085,NULL,56572026260,883937910,13811529,14.2),(135333,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135333,35.79,0.18,144,64081,70,NULL,NULL,'CGCG 108-142',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135334,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135334,36.36,0.46,187,64082,70,NULL,NULL,'2MASX J16061981+2250522',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000176,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.582583,22.84775,0.165,NULL,59394981595,928046587,14500727,17.2),(135335,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135335,36.14,0.05,169,64083,70,NULL,NULL,'2MASX J16062008+1843542',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.1g',0.33,NULL,NULL,NULL,NULL,NULL,1,241.583875,18.73167,0.045,NULL,56518447316,883100739,13798449,16.1),(135336,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135336,37.01,0.46,253,64084,70,NULL,NULL,'2MASX J16062102+5056124',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.5877083,50.93681,NULL,NULL,59706566028,932915094,14576798,17.5),(135337,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135337,33.62,0.48,52.9,64085,70,NULL,NULL,'ESO 068-IG 016 NED01',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000117,NULL,'13.2R',0.9,'(R\'_1)SB(r)0/a',NULL,NULL,NULL,NULL,1,241.5884583,-67.72336,0.413,NULL,44985516194,702898690,10982792,13.2),(135338,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135338,36.87,0.46,236,64086,70,NULL,NULL,'2MASX J16062214+2821018',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000184,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,241.592417,28.35047,0.073,NULL,59867420123,935428439,14616069,16.7),(135339,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135339,35.31,0.29,115,64087,70,NULL,NULL,'GIN 493',NULL,'2001MNRAS.321..277C',2001,1,0.4,NULL,'G',0.00008,NULL,'16.8g',0.29,'E/S0',NULL,NULL,NULL,NULL,1,241.5962917,24.22353,0.169,NULL,59391653574,927994587,14499915,16.8),(135340,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135340,36.65,0.46,213,64087,70,NULL,NULL,'GIN 493',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135341,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135341,36.98,0.13,249,64088,70,NULL,NULL,'2MASX J16062399+3324534',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000183,NULL,'16.2g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,241.600041667,33.41469,0.037,NULL,59784826437,934137913,14595904,16.2),(135342,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135342,37.47,0.46,312,64089,70,NULL,NULL,'SDSS J160624.62+271223.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00014,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,241.602583,27.2065,0.105,NULL,59862238681,935347479,14614804,18.2),(135343,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135343,35.61,0.25,132,64090,74.4,NULL,NULL,'UGC 10201 NED01',NULL,'2013AJ....146...86T',2013,1,1.3,'Component \'a)\' in UGC notes.','G',0.000067,NULL,'14.3',1.3,'E+0','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.606083333,15.68581,0.061,NULL,56571633937,883931780,13811434,14.3),(135344,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135344,35.79,0.18,144,64090,70,NULL,NULL,'UGC 10201 NED01',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135345,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135345,36.27,0.4,180,64090,NULL,NULL,'mean','UGC 10201 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135346,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135346,36.44,0.45,194,64090,NULL,NULL,'K','UGC 10201 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135347,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135347,35.63,0.25,134,64091,74.4,NULL,NULL,'UGC 10201 NED02',NULL,'2013AJ....146...86T',2013,1,0.59,'Component \'b)\' in UGC notes.','G',0.000077,NULL,'15.2g',0.53,'E','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.6075,15.69381,0.061,NULL,56571634007,883931781,13811434,15.2),(135348,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135348,35.79,0.18,144,64091,70,NULL,NULL,'UGC 10201 NED02',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135349,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135349,38.41,0.46,481,64092,70,NULL,NULL,'SDSS J160625.83+495928.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000174,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.607667,49.99131,NULL,NULL,59705998147,932906221,14576659,18.3),(135350,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135350,36.14,0.05,169,64093,70,NULL,NULL,'2MASX J16062600+1633361',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000176,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,241.608375,16.55992,0.085,NULL,56572047396,883938240,13811535,17.5),(135351,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135351,35.76,0.23,142,64094,70,NULL,NULL,'2MASX J16062684+1420571',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,241.611875,14.34925,0.061,NULL,56550675991,883604312,13806317,16.2),(135352,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','PS1 SN PS11zu','N',135352,41.31,0.16,1340,64095,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11zu HOST',0.3601,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135353,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135353,37.78,0.33,360,64096,70,NULL,NULL,'2MASX J16062848+2917238',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.618667,29.28994,0.081,NULL,59736944054,933389750,14584214,17.7),(135354,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135354,36.01,0.16,159,64097,70,NULL,NULL,'2MASX J16062886+2354148',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00005,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,241.62025,23.90417,0.165,NULL,59391713537,927995524,14499930,16.9),(135355,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135355,38.05,0.33,408,64098,70,NULL,NULL,'2MASX J16063203+3150243',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,241.633541667,31.84014,0.057,NULL,59781860399,934091568,14595180,18.2),(135356,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135356,35.59,0.25,131,64099,74.4,NULL,NULL,'IC 1193',NULL,'2013AJ....146...86T',2013,1,0.63,NULL,'G',0.0001,NULL,'15.4g',0.53,'SAB(s)0+       AGN','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.634166667,17.71386,0.065,NULL,56561352106,883771126,13808923,15.4),(135357,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135357,35.77,0.25,143,64099,70,NULL,NULL,'IC 1193',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135358,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135358,36.14,0.05,169,64099,70,NULL,NULL,'IC 1193',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135359,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135359,38.05,0.33,408,64100,70,NULL,NULL,'2MASX J16063273+3151013',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000162,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,241.636417,31.85042,0.057,NULL,59781858661,934091541,14595180,18.1),(135360,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135360,36.09,0.36,166,64101,NULL,NULL,'Malmquist cor.','IC 1192',NULL,'2009ApJS..182..474S',2009,1,0.89,NULL,'G',0.000043,NULL,'15.7g',0.31,'Sb             AGN','in a triple',NULL,NULL,NULL,1,241.638041667,17.77564,0.065,NULL,56561339329,883770927,13808920,15.7),(135361,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135361,36.52,0.3,202,64101,NULL,NULL,NULL,'IC 1192',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135362,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135362,36.56,0.2,205,64101,74.4,NULL,NULL,'IC 1192',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135363,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135363,37.33,0.46,293,64102,70,NULL,NULL,'2MASX J16063440+1717501',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.00015,NULL,'16.1g',0.34,'S0','Group member',NULL,NULL,NULL,1,241.643333,17.29725,0.049,NULL,56569177162,883893393,13810834,16.1),(135364,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135364,36.94,0.46,245,64103,70,NULL,NULL,'2MASX J16063496+4903289',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00007,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,241.645625,49.058,NULL,NULL,59704642171,932885033,14576328,17.2),(135365,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135365,35.63,0.79,134,64104,70,NULL,NULL,'2MASX J16063542-0111475',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.000107,NULL,'16.1g',0.38,NULL,NULL,NULL,NULL,NULL,1,241.647583333,-1.19653,0.473,NULL,45525518975,711336233,11114628,16.1),(135366,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135366,37.93,0.46,385,64105,70,NULL,NULL,'2MASX J16063593+2125162',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000182,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,241.6497917,21.42125,0.193,NULL,56507669601,882932337,13795817,17.6),(135367,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135367,36.14,0.05,169,64106,70,NULL,NULL,'SDSS J160636.32+174747.2',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.8g',0.26,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.651333,17.79647,0.073,NULL,56561468661,883772947,13808952,16.8),(135368,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135368,36.1,0.46,166,64107,70,NULL,NULL,'2MASX J16063636+1656531',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000182,NULL,'16.1g',0.31,NULL,NULL,NULL,NULL,NULL,1,241.651375,16.94822,0.053,NULL,56569119991,883892499,13810820,16.1),(135369,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135369,37.23,0.46,279,64108,70,NULL,NULL,'2MASX J16063645+2306112',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00014,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,241.651875,23.10311,0.153,NULL,59394859076,928044673,14500698,18.2),(135370,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135370,38.23,0.46,442,64109,70,NULL,NULL,'2MASX J16063826+1438531',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,241.6595417,14.64814,0.061,NULL,56557200959,883706264,13807910,18.1),(135371,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135371,37.47,0.46,311,64110,70,NULL,NULL,'2MASX J16063894+1658401',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000155,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.662375,16.97781,0.053,NULL,56569334237,883895847,13810872,17.4),(135372,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135372,35.59,0.25,131,64111,74.4,NULL,NULL,'IC 1194',NULL,'2013AJ....146...86T',2013,1,0.65,NULL,'G',0.000077,NULL,'15.0g',0.47,'SA(s)0+ pec    AGN','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.6639583,17.76119,0.065,NULL,56561350466,883771101,13808923,15),(135373,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135373,35.77,0.25,143,64111,70,NULL,NULL,'IC 1194',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135374,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135374,36.14,0.05,169,64111,70,NULL,NULL,'IC 1194',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135375,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135375,35.87,0.43,150,64112,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10205',NULL,'2014MNRAS.444..527S',2014,1,1.56,NULL,'G',0.000047,NULL,'13.9g',0.83,'Sa','Isolated galaxy (6 Mpc isolation)',NULL,NULL,NULL,1,241.667417,30.09908,0.053,NULL,59739199953,933424999,14584765,13.9),(135376,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 1963Q',NULL,135376,35.22,0.29,111,64113,NULL,NULL,'Avg. of 8 SN host galaxies','IC 1195',NULL,'1985ApJ...297...23D',1985,1,0.63,NULL,'G',0.000033,NULL,'15.2g',0.43,'SB(r)bc','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.670333,17.19181,0.049,NULL,56569205609,883893837,13810841,15.2),(135377,'Sosies','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135377,35.27,0.15,113,64113,NULL,NULL,'Avg. of 7 galaxies','IC 1195',NULL,'1985ApJ...297...23D',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135378,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135378,37.81,0.46,365,64114,70,NULL,NULL,'2MASX J16064101+2316162',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.6707917,23.27111,0.153,NULL,59394872736,928044886,14500701,17.8),(135379,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135379,31.55,NULL,20.4,64115,72,NULL,NULL,'CGCG 051-043',NULL,'2014Ap.....57..457K',2014,1,0.63,NULL,'G',0.00008,NULL,'15.2g',0.45,NULL,NULL,NULL,NULL,NULL,1,241.670833,6.58094,0.169,NULL,56460566183,882196346,13784317,15.2),(135380,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135380,37.14,0.46,268,64116,70,NULL,NULL,'2MASX J16064106+4505022',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000178,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.671,45.08408,0.021,NULL,59803361509,934427523,14600430,17),(135381,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135381,38.01,0.46,400,64117,70,NULL,NULL,'2MASX J16064174-0019135',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000123,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,241.673917,-0.32042,0.409,NULL,45525199607,711331243,11114550,17.7),(135382,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135382,36.14,0.05,169,64118,70,NULL,NULL,'2MASX J16064241+1540361',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000184,NULL,'16.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.6767917,15.67675,0.061,NULL,56571638461,883931850,13811435,16.7),(135383,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135383,35.98,0.33,157,64119,NULL,NULL,'Malmquist cor.','AGC 261203',NULL,'2009ApJS..182..474S',2009,1,0.69,NULL,'G',0.00003,NULL,'14.58',NULL,'Sa',NULL,NULL,NULL,NULL,1,241.677625,15.59283,0.061,NULL,56570759580,883918118,13811220,14.58),(135384,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135384,35.99,0.33,158,64119,NULL,NULL,NULL,'AGC 261203',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135385,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135385,36.03,0.2,161,64119,74.4,NULL,NULL,'AGC 261203',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135386,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135386,37.84,0.46,371,64120,70,NULL,NULL,'2MASX J16064261+2425008',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000217,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,241.677583,24.41683,0.173,NULL,59861862414,935341600,14614712,17),(135387,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135387,37.52,0.46,320,64121,70,NULL,NULL,'SDSS J160642.94+095746.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.678916667,9.963,0.149,NULL,56589296729,884207761,13815746,18.4),(135388,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135388,38.23,0.33,442,64122,70,NULL,NULL,'2MASX J16064357+2855068',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000148,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,241.681625,28.91847,0.073,NULL,59736512007,933383000,14584109,18.4),(135389,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135389,34.97,0.5,98.8,64123,70,NULL,NULL,'ESO 584- G 005',NULL,'2014MNRAS.445.2677S',2014,1,1.9,NULL,'G',0.00005,NULL,'14.1B',1.1,'SB(s)0^0^: pec',NULL,NULL,NULL,NULL,1,241.682541667,-18.21328,0.817,NULL,45438000689,709968760,11093261,14.1),(135390,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135390,35.13,0.4,106,64123,NULL,NULL,'mean','ESO 584- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135391,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135391,35.84,0.45,148,64123,NULL,NULL,'K','ESO 584- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135392,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135392,37.85,0.46,371,64124,70,NULL,NULL,'SDSS J160643.89+001545.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000096,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,241.682917,0.26253,0.381,NULL,56476544122,882446001,13788218,18.8),(135393,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135393,36.08,0.4,165,64125,NULL,NULL,'Malmquist cor.','SDSS J160644.61+181443.9',NULL,'2009ApJS..182..474S',2009,1,0.56,NULL,'G',0.00003,NULL,'17.66',0.12,'Sc',NULL,NULL,NULL,NULL,1,241.685875,18.24553,0.057,NULL,56516209520,883065773,13797902,17.66),(135394,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135394,36.11,0.39,167,64125,NULL,NULL,NULL,'SDSS J160644.61+181443.9',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135395,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135395,36.15,0.2,170,64125,74.4,NULL,NULL,'SDSS J160644.61+181443.9',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135396,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135396,34.26,0.2,71.1,64126,74.4,NULL,NULL,'CGCG 079-047',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000093,NULL,'15.2',0.2,NULL,NULL,NULL,NULL,NULL,1,241.687667,11.88806,0.145,NULL,56580007764,884062621,13813478,15.2),(135397,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135397,38.61,0.33,527,64127,70,NULL,NULL,'SDSS J160645.15+270034.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,241.688167,27.00964,0.105,NULL,59863140982,935361577,14615024,18.5),(135398,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135398,38.61,0.33,527,64128,70,NULL,NULL,'2MASX J16064546+2656437',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000128,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.689375,26.94539,0.097,NULL,59863149582,935361712,14615026,18.2),(135399,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135399,37.64,0.46,337,64129,70,NULL,NULL,'SDSS J160645.84+271039.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000165,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,241.691,27.17767,0.109,NULL,59862352647,935349260,14614832,18.5),(135400,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135400,37.56,0.46,325,64130,70,NULL,NULL,'SDSS J160646.15+240959.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000142,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,241.692333,24.16658,0.169,NULL,59391835546,927997430,14499959,18.7),(135401,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135401,35.76,0.23,142,64131,70,NULL,NULL,'2MASX J16064638+1410221',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,241.693375,14.17286,0.069,NULL,56550711818,883604872,13806326,16.2),(135402,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135402,36.14,0.05,169,64132,70,NULL,NULL,'SDSS J160647.61+174723.7',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.7g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.698417,17.78994,0.073,NULL,56561474014,883773031,13808953,16.7),(135403,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135403,35.38,0.73,119,64133,NULL,NULL,NULL,'2MFGC 12939',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000027,NULL,'16.4g',0.2,'S/I','Group member',NULL,NULL,NULL,1,241.700875,17.64767,0.065,NULL,56561368546,883771383,13808927,16.4),(135404,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135404,35.42,0.2,121,64133,74.4,NULL,NULL,'2MFGC 12939',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135405,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135405,35.45,0.7,123,64133,NULL,NULL,'Malmquist cor.','2MFGC 12939',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135406,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135406,35.68,0.49,137,64133,75,NULL,'IR','2MFGC 12939',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135407,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','PS1 SN PS10jz','N',135407,42.52,0.21,2060,64134,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10jz HOST',0.5501,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135408,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135408,38.05,0.46,407,64135,70,NULL,NULL,'2MASX J16065039+3822333',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.709875,38.37592,0.017,NULL,59770114109,933908032,14592313,17.8),(135409,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135409,37.67,0.46,342,64136,70,NULL,NULL,'2MASX J16065159+4021193',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000149,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.71475,40.35553,0.013,NULL,59809038274,934516223,14601815,17.6),(135410,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135410,37,0.46,251,64137,70,NULL,NULL,'2MASX J16065259+1108483',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,241.719125,11.14683,0.153,NULL,56579696276,884057754,13813402,17.8),(135411,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135411,36.14,0.05,169,64138,70,NULL,NULL,'2MASX J16065292+1813222',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00015,NULL,'15.8g',0.38,'S07','Group member',NULL,NULL,NULL,1,241.7204583,18.22289,0.057,NULL,56516208286,883065754,13797902,15.8),(135412,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135412,34.06,0.46,65,64139,70,NULL,NULL,'UGC 10203',NULL,'2015arXiv151105856S',2015,1,0.94,NULL,'G',0.000165,NULL,'14.9g',0.34,'S0',NULL,NULL,NULL,NULL,1,241.723333,3.7935,0.257,NULL,56490892691,882670198,13791721,14.9),(135413,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135413,36.98,0.13,249,64140,70,NULL,NULL,'2MASX J16065377+3310374',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000192,NULL,'16.0g',0.4,'E0',NULL,NULL,NULL,NULL,1,241.724167,33.17694,0.033,NULL,59784851373,934138302,14595910,16),(135414,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135414,36.91,0.46,240,64141,70,NULL,NULL,'2MASX J16065388+2546267',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,241.7244583,25.77403,0.153,NULL,59864862391,935388474,14615444,17.4),(135415,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135415,35.95,0.46,155,64142,70,NULL,NULL,'2MASX J16065389+0327246',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.0g',0.41,NULL,NULL,NULL,NULL,NULL,1,241.724625,3.45675,0.253,NULL,56503716551,882870571,13794852,16),(135416,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135416,38.09,0.46,414,64143,70,NULL,NULL,'2MASX J16065450+1407171',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,241.727083,14.12139,0.069,NULL,56550738050,883605282,13806332,NULL),(135417,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135417,37.06,0.46,258,64144,70,NULL,NULL,'2MASX J16065451+1356391',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,241.72725,13.94431,0.073,NULL,56550541481,883602210,13806284,17),(135418,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135418,37.55,0.46,323,64145,70,NULL,NULL,'2MASX J16065471+4118373',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,241.727833,41.31036,0,NULL,59810730537,934542664,14602229,18),(135419,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135419,37.71,0.46,348,64146,70,NULL,NULL,'2MASX J16065619+2327362',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,241.734125,23.46,0.153,NULL,59392004023,928000062,14500000,18.2),(135420,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135420,35.8,0.49,144,64147,75,NULL,'IR','MCG +10-23-020',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',NULL,NULL,'16',0.09,'Sd',NULL,NULL,NULL,NULL,1,241.7369583,62.53742,0.017,NULL,57613080265,900204379,14065693,16),(135421,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135421,36.19,NULL,173,64147,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG +10-23-020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135422,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135422,36.22,NULL,175,64147,NULL,NULL,'Dipole + Quadrupole','MCG +10-23-020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135423,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135423,36.22,NULL,176,64147,NULL,NULL,NULL,'MCG +10-23-020',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135424,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135424,36.24,NULL,177,64147,NULL,NULL,'Dipole','MCG +10-23-020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135425,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135425,35.61,0.48,132,64148,NULL,NULL,NULL,'2MASX J16065705+1751251',NULL,'2009ApJS..182..474S',2009,1,0.67,NULL,'G',0.000027,NULL,'16.7g',0.19,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,241.7375,17.85692,0.073,NULL,56561472648,883773010,13808953,16.7),(135426,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135426,35.65,0.2,135,64148,74.4,NULL,NULL,'2MASX J16065705+1751251',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135427,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135427,35.88,0.42,150,64148,NULL,NULL,'Malmquist cor.','2MASX J16065705+1751251',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135428,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135428,39.05,0.46,646,64149,70,NULL,NULL,'SDSS J160658.06+300012.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.7419583,30.00336,0.073,NULL,59739058171,933422783,14584730,18.3),(135429,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135429,35.62,0.25,133,64150,74.4,NULL,NULL,'GIN 526',NULL,'2013AJ....146...86T',2013,1,0.49,NULL,'G',0.000107,NULL,'15.7g',0.45,'S',NULL,NULL,NULL,NULL,1,241.7427083,16.16225,0.073,NULL,56571160245,883924378,13811318,15.7),(135430,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135430,35.79,0.18,144,64150,70,NULL,NULL,'GIN 526',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135431,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135431,36.14,0.05,169,64150,70,NULL,NULL,'GIN 526',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135432,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135432,35.8,0.33,144,64151,NULL,NULL,NULL,'2MASX J16070160+1801205',NULL,'2009ApJS..182..474S',2009,1,0.81,NULL,'G',0.00002,NULL,'15.7g',0.36,'SB(rs)a','Group member',NULL,NULL,NULL,1,241.756667,18.0225,0.081,NULL,56561282574,883770040,13808906,15.7),(135433,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135433,35.83,0.33,147,64151,NULL,NULL,'Malmquist cor.','2MASX J16070160+1801205',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135434,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135434,36,0.2,158,64151,74.4,NULL,NULL,'2MASX J16070160+1801205',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135435,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135435,37.46,0.46,311,64152,70,NULL,NULL,'SDSS J160701.66+175106.6',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.9g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.756958333,17.85186,0.073,NULL,56561490261,883773285,13808957,16.9),(135436,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135436,37.72,0.33,350,64153,70,NULL,NULL,'2MASX J16070169+2650528',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000133,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,241.757167,26.848,0.097,NULL,59863175558,935362118,14615033,18.2),(135437,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135437,37.37,0.46,298,64154,70,NULL,NULL,'2MASX J16070242+2207276',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000181,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,241.7599583,22.12431,0.161,NULL,56507340093,882927188,13795737,18),(135438,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135438,38,0.46,398,64155,70,NULL,NULL,'SDSS J160703.07+153621.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000158,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.762833,15.60589,0.061,NULL,56570770224,883918284,13811223,18.3),(135439,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135439,36.22,0.2,175,64156,74.4,NULL,NULL,'KUG 1604+157',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.00003,NULL,'15.12',0.5,'Sc','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.76325,15.59317,0.061,NULL,56570770165,883918283,13811223,15.12),(135440,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135440,37.27,0.46,285,64157,70,NULL,NULL,'2MASX J16070321+3645184',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00012,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,241.7632917,36.75522,0.025,NULL,59776742388,934011599,14593931,16.7),(135441,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135441,37.59,0.46,330,64158,70,NULL,NULL,'2MASX J16070327+3017004',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000141,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,241.763666667,30.2835,0.061,NULL,59739150532,933424227,14584753,17.5),(135442,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135442,35.47,0.58,124,64159,70,NULL,NULL,'2MASX J16070369-0149288',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000033,NULL,'15.9',0.4,NULL,NULL,NULL,NULL,NULL,1,241.765333,-1.82472,0.529,NULL,45560146789,711877293,11123082,15.9),(135443,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135443,37.12,0.46,266,64160,70,NULL,NULL,'2MASX J16070406+1218101',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,241.767,12.30297,0.141,NULL,56549303604,883582868,13805982,16.3),(135444,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135444,36.98,0.13,249,64161,70,NULL,NULL,'2MASX J16070476+3309464',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.769833333,33.16294,0.033,NULL,59784851880,934138310,14595911,17.3),(135445,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135445,36.97,0.46,248,64162,70,NULL,NULL,'2MASX J16070543+2606478',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000143,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,241.772666667,26.11328,0.133,NULL,59864899257,935389050,14615453,17.8),(135446,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135446,38.02,0.46,402,64163,70,NULL,NULL,'2MASX J16070570+3821324',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000175,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.773666667,38.35903,0.017,NULL,59770085840,933907591,14592306,17),(135447,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135447,36.14,0.05,169,64164,70,NULL,NULL,'SDSS J160705.92+175057.3',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'15.7g',0.38,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.774708333,17.84925,0.073,NULL,56561491908,883773311,13808957,15.7),(135448,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135448,36.38,0.46,189,64165,70,NULL,NULL,'2MASX J16070687+2758438',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,241.778625,27.97878,0.085,NULL,59875789810,935559215,14618112,17.2),(135449,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135449,33.85,0.8,58.8,64166,75,NULL,'HMCL, I','UGC 10211',NULL,'1997ApJS..109..333W',1997,1,1.29,NULL,'G',0.000033,NULL,'14.3g',0.44,'Sab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,241.77925,22.06056,0.161,NULL,56507352449,882927382,13795740,14.3),(135450,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135450,33.78,0.4,57.1,64166,75,NULL,'HMCL, I, raw','UGC 10211',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135451,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135451,33.84,0.47,58.7,64166,NULL,NULL,'H','UGC 10211',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135452,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135452,33.88,0.45,59.7,64166,NULL,NULL,'K','UGC 10211',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135453,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135453,33.94,0.4,61.4,64166,75,NULL,'HMCL, I, inv','UGC 10211',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135454,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135454,33.95,0.4,61.8,64166,75,NULL,'HMCL, I, cor','UGC 10211',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135455,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135455,33.96,0.2,61.9,64166,74.4,NULL,NULL,'UGC 10211',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135456,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135456,33.96,0.46,62,64166,NULL,NULL,'J','UGC 10211',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135457,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135457,34.01,0.4,63.5,64166,NULL,NULL,'mean','UGC 10211',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135458,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135458,38.48,0.46,497,64167,70,NULL,NULL,'2MASX J16070770+3644234',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.782167,36.73986,0.025,NULL,59776742123,934011595,14593931,17.3),(135459,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135459,35.59,0.25,131,64168,74.4,NULL,NULL,'MCG +03-41-132',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.00008,NULL,'14.20',0.5,'E/S0',NULL,NULL,NULL,NULL,1,241.791166667,18.64128,0.057,NULL,56518354158,883099283,13798426,14.2),(135460,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135460,35.77,0.25,143,64168,70,NULL,NULL,'MCG +03-41-132',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135461,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135461,36.14,0.05,169,64168,70,NULL,NULL,'MCG +03-41-132',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135462,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135462,36.14,0.05,169,64169,70,NULL,NULL,'2MASX J16071062+1839356',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,241.79425,18.65981,0.057,NULL,56518354901,883099295,13798426,16.5),(135463,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135463,37.14,0.33,268,64170,70,NULL,NULL,'2MASX J16071113+3403538',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000157,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.7964583,34.06508,0.013,NULL,59766444611,933850697,14591417,17),(135464,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135464,36.14,0.05,169,64171,70,NULL,NULL,'2MASX J16071182+1836366',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.0g',0.35,NULL,NULL,NULL,NULL,NULL,1,241.799333,18.61011,0.057,NULL,56518347771,883099183,13798424,16),(135465,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135465,35.87,0.46,149,64172,70,NULL,NULL,'2MASX J16071198+2738558',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000192,NULL,'15.6g',0.41,'Sa',NULL,NULL,NULL,NULL,1,241.799916667,27.64894,0.101,NULL,59862208176,935347002,14614796,15.6),(135466,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135466,37.47,0.46,312,64173,70,NULL,NULL,'2MASX J16071283+1032074',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.8034583,10.53531,0.169,NULL,56588979071,884202797,13815668,17.5),(135467,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 1999ac',NULL,135467,32.45,0.24,30.6,64174,74.2,NULL,'SALT 2','NGC 6063',0.0095,'2010ApJ...716..712A',2010,1,1.72,NULL,'G',0.000017,NULL,'13.7g',0.84,'Scd:',NULL,NULL,NULL,NULL,1,241.804125,7.979,0.125,NULL,56584941038,884139703,13814682,13.7),(135468,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 1999ac',NULL,135468,32.71,0.25,34.5,64174,72,NULL,NULL,'NGC 6063',0.0095,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135469,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 1999ac',NULL,135469,33.03,0.08,40.4,64174,74.4,NULL,NULL,'NGC 6063',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135470,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 1999ac',NULL,135470,33.09,0.03,41.1,64174,72,NULL,NULL,'NGC 6063',0.0095,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135471,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 1999ac',NULL,135471,33.1,0.17,41.7,64174,70.8,NULL,NULL,'NGC 6063',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135472,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 1999ac',NULL,135472,33.17,0.23,42.6,64174,70,NULL,'SALT','NGC 6063',0.0095,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135473,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 1999ac',NULL,135473,33.33,0.08,45.6,64174,65,NULL,'MLCS2k2','NGC 6063',0.0095,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135474,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 1999ac',NULL,135474,33.53,0.03,50.4,64174,70,NULL,'SALT 2','NGC 6063',0.0095,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135475,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 1999ac',NULL,135475,33.53,0.3,50.8,64174,60,NULL,NULL,'NGC 6063',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135476,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135476,33.08,0.8,41.3,64174,75,NULL,'CF, r','NGC 6063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135477,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135477,32.29,0.69,28.7,64174,100,NULL,'mid-IR','NGC 6063',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135478,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135478,32.87,0.4,37.5,64174,NULL,NULL,NULL,'NGC 6063',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135479,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135479,33.03,0.08,40.4,64174,74.4,NULL,NULL,'NGC 6063',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135480,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135480,33.15,0.4,42.7,64174,75,NULL,'HOSTS SN 1999ac','NGC 6063',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135481,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135481,33.16,0.4,42.9,64174,75,NULL,'HOSTS SN 1999ac','NGC 6063',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135482,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135482,33.27,0.42,45.1,64174,NULL,18.48,'3.6 micron','NGC 6063',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135483,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135483,33.29,0.43,45.5,64174,75,NULL,'3.6 micron, color corrected','NGC 6063',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135484,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135484,33.34,0.43,46.5,64174,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6063',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135485,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135485,33.35,0.4,46.9,64174,NULL,NULL,'mean','NGC 6063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135486,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135486,33.35,0.66,46.9,64174,NULL,NULL,NULL,'NGC 6063',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135487,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135487,33.51,0.61,50.3,64174,NULL,NULL,'Malmquist cor.','NGC 6063',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135488,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135488,33.51,0.38,50.3,64174,75,NULL,'CF, r, raw','NGC 6063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135489,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135489,33.54,0.47,51.1,64174,NULL,NULL,'H','NGC 6063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135490,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135490,33.6,0.46,52.6,64174,NULL,NULL,'J','NGC 6063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135491,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135491,33.61,0.38,52.8,64174,75,NULL,'CF, r, inv','NGC 6063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135492,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135492,33.72,0.45,55.4,64174,NULL,NULL,'K','NGC 6063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135493,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135493,33.83,0.38,58.5,64174,75,NULL,'CF, r, cor','NGC 6063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135494,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135494,35.98,0.46,157,64175,70,NULL,NULL,'2MASX J16071357-0004436',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000116,NULL,'15.7g',0.35,NULL,NULL,NULL,NULL,NULL,1,241.8065,-0.07878,0.401,NULL,45524991638,711327994,11114499,15.7),(135495,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135495,36.75,0.46,223,64176,70,NULL,NULL,'2MASX J16071398+1951296',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',NULL,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,241.808333,19.85828,0.073,NULL,56521742103,883152220,13799253,16.6),(135496,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135496,36.2,0.46,173,64177,70,NULL,NULL,'2MASX J16071688+2616278',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000187,NULL,'16.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.820208333,26.27442,0.133,NULL,59862871086,935357360,14614958,16.4),(135497,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135497,36.14,0.05,169,64178,70,NULL,NULL,'2MASX J16071693+1741451',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00015,NULL,'16.2g',0.19,'S0','Group member',NULL,NULL,NULL,1,241.820416667,17.696,0.065,NULL,56561332504,883770820,13808919,16.2),(135498,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135498,37.61,0.33,333,64179,70,NULL,NULL,'2MASX J16071795+3654374',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.824875,36.91036,0.021,NULL,59776756729,934011823,14593934,17.6),(135499,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135499,37.72,0.33,350,64180,70,NULL,NULL,'2MASX J16071839+2649173',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000141,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,241.82675,26.82139,0.097,NULL,59863052011,935360187,14615002,17.6),(135500,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135500,35.64,0.46,134,64181,70,NULL,NULL,'2MASX J16071867+0710514',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000165,NULL,'16.4g',0.32,'AGN+SF',NULL,NULL,NULL,NULL,1,241.827875,7.18092,0.165,NULL,56460073065,882188641,13784197,16.4),(135501,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135501,35.61,0.25,132,64182,74.4,NULL,NULL,'GIN 515',NULL,'2013AJ....146...86T',2013,1,0.53,NULL,'G',0.00008,NULL,'15.9g',0.49,'S',NULL,NULL,NULL,NULL,1,241.831375,15.84994,0.061,NULL,56571608307,883931379,13811427,15.9),(135502,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135502,35.79,0.18,144,64182,70,NULL,NULL,'GIN 515',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135503,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135503,37.61,0.33,333,64183,70,NULL,NULL,'2MASX J16072072+3701274',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000139,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,241.8362083,37.02403,0.013,NULL,59774608234,933978253,14593410,17.6),(135504,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135504,35.04,0.2,102,64184,74.4,NULL,NULL,'CGCG 079-049',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.0002,NULL,'15.6',0.1,'S0','Pair member (points to parent)',NULL,NULL,NULL,1,241.841375,10.36614,0.149,NULL,56588966250,884202597,13815665,15.6),(135505,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135505,38.22,0.46,440,64185,70,NULL,NULL,'2MASX J16072265+2353006',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000148,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,241.8447083,23.88344,0.165,NULL,59391805468,927996960,14499952,17.8),(135506,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135506,35.76,0.23,142,64186,70,NULL,NULL,'NGC 6065',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00014,NULL,'15.0',0.6,'S0','Group member',NULL,NULL,NULL,1,241.845666667,13.88792,0.073,NULL,56550407438,883600116,13806251,15),(135507,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135507,36.14,0.05,169,64187,70,NULL,NULL,'2MASX J16072510+1814396',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00015,NULL,'16.6g',0.31,'E0','Group member',NULL,NULL,NULL,1,241.8547083,18.24425,0.057,NULL,56516166710,883065104,13797892,16.6),(135508,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135508,37.25,0.46,282,64188,70,NULL,NULL,'2MASX J16072563+3051339',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.857,30.85936,0.061,NULL,59738762377,933418162,14584658,17.7),(135509,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135509,35.3,0.2,115,64189,74.4,NULL,NULL,'UGC 10215',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000011,NULL,'15.59',0.4,'Sbc?','Supercluster foreground object',NULL,NULL,NULL,1,241.8572083,19.54964,0.053,NULL,56518911895,883107998,13798562,15.59),(135510,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135510,38.36,0.46,471,64190,70,NULL,NULL,'2MASX J16072609+4401366',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.85875,44.02689,0,NULL,59806346134,934474158,14601158,17.7),(135511,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135511,36.56,0.21,205,64191,70,NULL,NULL,'2MASX J16072651+2829483',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.860458333,28.49672,0.081,NULL,59736545542,933383524,14584117,17.3),(135512,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135512,37.14,0.33,268,64192,70,NULL,NULL,'2MASX J16072650+3404309',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000177,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,241.8605,34.07517,0.013,NULL,59766319417,933848740,14591386,17),(135513,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135513,36.55,0.46,204,64193,70,NULL,NULL,'2MASX J16072764+4438426',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000191,NULL,'15.7g',0.43,'E0',NULL,NULL,NULL,NULL,1,241.865333,44.64517,0.021,NULL,59802740251,934417816,14600278,15.7),(135514,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135514,36.97,0.33,248,64194,70,NULL,NULL,'2MASX J16072860+2731503',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000133,NULL,'15.5g',0.45,'E0',NULL,NULL,NULL,NULL,1,241.8692083,27.53081,0.113,NULL,59862374947,935349608,14614837,15.5),(135515,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135515,38.35,0.46,469,64195,70,NULL,NULL,'2MASX J16072877+2348166',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000166,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,241.8700417,23.8045,0.165,NULL,59391702455,927995350,14499927,17),(135516,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135516,37.34,0.46,293,64196,70,NULL,NULL,'SDSS J160729.46+375439.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000148,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,241.87275,37.91094,0,NULL,59770805701,933918839,14592481,18.3),(135517,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135517,37.74,0.21,353,64197,70,NULL,NULL,'SDSS J160730.64+231418.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00017,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,241.8777083,23.23842,0.153,NULL,59392027353,928000427,14500006,18.4),(135518,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135518,36.56,0.21,205,64198,70,NULL,NULL,'2MASX J16073106+2821164',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000175,NULL,'17.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,241.879417,28.35458,0.073,NULL,59736390615,933381103,14584079,17.2),(135519,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135519,37.74,0.21,353,64199,70,NULL,NULL,'2MASX J16073134+2313184',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000178,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,241.880583,23.22181,0.153,NULL,59392025856,928000404,14500006,16.6),(135520,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135520,36.85,0.46,235,64200,70,NULL,NULL,'2MASX J16073142+1731387',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000043,NULL,'17.9g',0.13,'Sy',NULL,NULL,NULL,NULL,1,241.880875,17.52736,0.065,NULL,56562218313,883784661,13809135,17.9),(135521,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135521,37.76,0.46,357,64201,70,NULL,NULL,'2MASX J16073251+1433257',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.885583333,14.55706,0.061,NULL,56549913562,883592399,13806131,17.8),(135522,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135522,37.35,0.46,295,64202,70,NULL,NULL,'2MASX J16073358+1747237',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000137,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,241.889833333,17.78992,0.073,NULL,56561437182,883772455,13808944,17.9),(135523,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135523,37.74,0.21,353,64203,70,NULL,NULL,'2MASX J16073368+2305064',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.890167,23.08503,0.141,NULL,59394850924,928044545,14500696,17.8),(135524,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135524,37.74,0.21,353,64204,70,NULL,NULL,'2MASX J16073402+2312344',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,241.891833333,23.20969,0.153,NULL,59392032483,928000507,14500007,17.8),(135525,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135525,37.71,0.46,349,64205,70,NULL,NULL,'2MASX J16073423+2656194',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000182,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.892583,26.93878,0.105,NULL,59863059175,935360299,14615004,17.6),(135526,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135526,37,0.46,251,64206,70,NULL,NULL,'SDSS J160734.28+040046.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'17.6g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.892875,4.01281,0.229,NULL,56490880617,882670009,13791718,17.6),(135527,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135527,37.55,0.46,323,64207,70,NULL,NULL,'2MASX J16073442+0521450',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000176,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,241.8934583,5.36236,0.189,NULL,56492420957,882694077,13792094,17.5),(135528,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135528,35.76,0.23,142,64208,70,NULL,NULL,'NGC 6066',NULL,'2015arXiv151105856S',2015,1,0.99,NULL,'G',0.000153,NULL,'15.2',0.75,NULL,'Group member',NULL,NULL,NULL,1,241.8972917,13.94372,0.093,NULL,56550394566,883599915,13806248,15.2),(135529,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135529,37.74,0.21,353,64209,70,NULL,NULL,'2MASX J16073534+2308494',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.897333,23.14722,0.153,NULL,59392019535,928000305,14500004,17.8),(135530,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135530,36.98,0.13,249,64210,70,NULL,NULL,'2MASX J16073537+3301179',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000202,NULL,'16.1g',0.3,'S0^-',NULL,NULL,NULL,NULL,1,241.897333,33.02169,0.037,NULL,59785067713,934141683,14595963,16.1),(135531,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135531,39.06,0.46,647,64211,70,NULL,NULL,'2MASXi J1607369+333400',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000239,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.903833333,33.56658,0.025,NULL,59783826067,934122282,14595660,17.9),(135532,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135532,35.58,0.25,131,64212,74.4,NULL,NULL,'GIN 510',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000073,NULL,'14.47',0.4,'S03','Group member',NULL,NULL,NULL,1,241.9105,18.48011,0.057,NULL,56516373054,883068328,13797942,14.47),(135533,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135533,35.77,0.25,143,64212,70,NULL,NULL,'GIN 510',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135534,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135534,37.56,0.46,326,64213,70,NULL,NULL,'2MASX J16073851+3629567',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000151,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,241.910417,36.49897,0.029,NULL,59773527542,933961367,14593146,17),(135535,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135535,37.07,0.46,260,64214,70,NULL,NULL,'2MASX J16073867+3507379',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000175,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,241.911083,35.12725,0.025,NULL,59765766667,933840104,14591251,16.6),(135536,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135536,38.54,0.46,509,64215,70,NULL,NULL,'2MASX J16073878+5134526',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.911833,51.58131,0.037,NULL,59698853451,932794585,14574915,17.8),(135537,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135537,38.03,0.46,404,64216,70,NULL,NULL,'2MASX J16073892-0026076',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000081,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.9122917,-0.43558,0.445,NULL,45558774944,711855858,11122747,18),(135538,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135538,36.98,0.13,249,64217,70,NULL,NULL,'2MASX J16073943+3303499',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,241.914333333,33.06383,0.037,NULL,59785063426,934141616,14595962,17.3),(135539,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135539,38.05,0.46,407,64218,70,NULL,NULL,'2MASX J16073964+2721573',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000185,NULL,'17.0g',0.31,NULL,NULL,NULL,NULL,NULL,1,241.9150417,27.36594,0.113,NULL,59862307410,935348553,14614821,17),(135540,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135540,35.9,0.33,151,64219,70,NULL,NULL,'2MASX J16073971+3857387',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000087,NULL,'16.1g',0.26,'S0/a',NULL,NULL,NULL,NULL,1,241.915333,38.96078,0.009,NULL,59800526315,934383223,14599737,16.1),(135541,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135541,37.79,0.46,362,64220,70,NULL,NULL,'2MASX J16073976+1511017',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,241.915583,15.18381,0.053,NULL,56570684143,883916939,13811202,17),(135542,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135542,36.97,0.33,248,64221,70,NULL,NULL,'2MASX J16074033+2731463',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,241.917875,27.52956,0.113,NULL,59862383589,935349743,14614839,18),(135543,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135543,36.98,0.13,249,64222,70,NULL,NULL,'2MASX J16074162+3304512',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000195,NULL,'15.7g',0.42,'E0',NULL,NULL,NULL,NULL,1,241.923375,33.08081,0.037,NULL,59785063508,934141617,14595962,15.7),(135544,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135544,35.9,0.33,151,64223,70,NULL,NULL,'NGC 6069',NULL,'2015arXiv151105856S',2015,1,0.88,NULL,'G',0.00009,NULL,'14.6g',0.75,'E0',NULL,NULL,NULL,NULL,1,241.9235,38.93075,0.009,NULL,59800397566,934381211,14599706,14.6),(135545,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135545,37.79,0.46,361,64224,70,NULL,NULL,'2MASX J16074315+3402362',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,241.929875,34.0435,0.013,NULL,59766321343,933848770,14591387,17.1),(135546,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135546,36.14,0.46,169,64225,70,NULL,NULL,'2MASX J16074315+2529333',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000171,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,241.929917,25.49256,0.149,NULL,59864962451,935390038,14615469,16.2),(135547,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135547,36.89,0.46,239,64226,70,NULL,NULL,'2MASX J16074379+2344005',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000176,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.932375,23.73367,0.165,NULL,59392178658,928002791,14500043,17.2),(135548,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135548,37.78,0.46,360,64227,70,NULL,NULL,'2MASX J16074391+4148227',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,241.9332083,41.80631,0.025,NULL,59810410653,934537666,14602151,17.3),(135549,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135549,37.13,0.23,266,64228,70,NULL,NULL,'2MASX J16074419+4915006',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000064,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,241.934167,49.25,NULL,NULL,59704639392,932884990,14576327,17.9),(135550,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135550,37.41,0.46,303,64229,70,NULL,NULL,'2MASX J16074567+3121053',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,241.940375,31.35142,0.065,NULL,59736019172,933375299,14583989,17.5),(135551,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135551,36.77,0.33,226,64230,70,NULL,NULL,'2MASX J16074582+4836246',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000101,NULL,'16.0g',0.39,'E0',NULL,NULL,NULL,NULL,1,241.941,48.60692,NULL,NULL,59705288666,932895135,14576486,16),(135552,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135552,37.26,0.46,283,64231,70,NULL,NULL,'2MASX J16074652+5341506',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000108,NULL,'16.1g',0.39,'S0',NULL,NULL,NULL,NULL,1,241.943666667,53.69742,0,NULL,57606394233,900099909,14064061,16.1),(135553,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135553,36.14,0.55,169,64232,70,NULL,NULL,'2MASX J16074757-0242175',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00012,NULL,'16.71',NULL,NULL,NULL,NULL,NULL,NULL,1,241.948166667,-2.70481,0.485,NULL,45560539550,711883430,11123178,16.71),(135554,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135554,37.07,0.46,260,64233,70,NULL,NULL,'2MASX J16074840+1310363',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,241.9517083,13.17681,0.081,NULL,56550909049,883607953,13806374,16.9),(135555,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135555,35.78,0.46,143,64234,70,NULL,NULL,'SDSS J160748.81+123952.6',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'15.9g',0.37,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.953417,12.66461,0.121,NULL,56549682511,883588789,13806074,15.9),(135556,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135556,36.3,0.46,182,64235,70,NULL,NULL,'2MASX J16074901+1354103',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,241.954125,13.90275,0.093,NULL,56550432136,883600502,13806257,16.7),(135557,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135557,37.59,0.46,329,64236,70,NULL,NULL,'2MASX J16074923+2615123',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.95525,26.25347,0.133,NULL,59862842853,935356919,14614951,17.5),(135558,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135558,36.46,0.46,196,64237,70,NULL,NULL,'2MASX J16075252+1104338',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,241.96875,11.07617,0.173,NULL,56587896650,884185885,13815404,16.4),(135559,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135559,36.52,0.46,201,64238,70,NULL,NULL,'2MASX J16075254+4232395',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000097,NULL,'16.0g',0.38,'E0','Field galaxy',NULL,NULL,NULL,1,241.969,42.54431,0.013,NULL,59805013451,934453335,14600833,16),(135560,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135560,37.75,0.46,355,64239,70,NULL,NULL,'SDSS J160753.41+525852.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000069,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,241.972583333,52.98136,0,NULL,59700449103,932819517,14575304,18.3),(135561,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135561,36.2,0.46,174,64240,70,NULL,NULL,'2MASX J16075367+3106503',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000166,NULL,'16.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,241.9734583,31.11397,0.065,NULL,59735952985,933374265,14583972,16.4),(135562,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135562,37.66,0.46,341,64241,70,NULL,NULL,'SDSS J160753.80+214539.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00014,NULL,'18.5g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.974208333,21.76092,0.177,NULL,56507522809,882930043,13795781,18.5),(135563,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135563,37.87,0.46,375,64242,70,NULL,NULL,'2MASX J16075397+5219461',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000074,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,241.974666667,52.32933,0.025,NULL,59700305378,932817271,14575269,17.9),(135564,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135564,37.87,0.46,374,64243,70,NULL,NULL,'2MASX J16075510+1847065',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.979625,18.78517,0.057,NULL,56518324050,883098813,13798418,17.7),(135565,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135565,36.95,0.46,246,64244,70,NULL,NULL,'2MASX J16075598+1418503',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.98325,14.31403,0.093,NULL,56550614470,883603351,13806302,17),(135566,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135566,35.98,0.46,157,64245,70,NULL,NULL,'2MASX J16075617+4403005',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000174,NULL,'15.9g',0.44,'Sbrst',NULL,NULL,NULL,NULL,1,241.983833,44.05028,0,NULL,59806380840,934474700,14601167,15.9),(135567,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135567,37.99,0.46,397,64246,70,NULL,NULL,'2MASX J16075632+5311032',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000105,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,241.984583,53.18433,0,NULL,59700066187,932813534,14575211,17.6),(135568,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135568,38.27,0.46,451,64247,70,NULL,NULL,'SDSS J160757.72+193025.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.9905,19.50719,0.053,NULL,56519041294,883110020,13798594,18.4),(135569,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135569,37.72,0.27,350,64248,70,NULL,NULL,'2MASX J16075790+4301245',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.9912083,43.02361,0.025,NULL,59805777332,934465270,14601019,17.6),(135570,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135570,37.95,0.46,390,64249,70,NULL,NULL,'2MASX J16075802+1534004',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,241.991667,15.56692,0.057,NULL,56570773771,883918340,13811224,17.6),(135571,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135571,33.37,0.69,47.2,64250,100,NULL,'mid-IR','IC 1196',NULL,'2013ApJ...771...88L',2013,1,1.1,NULL,'G',0.000033,NULL,'14.56',0.6,'Sa',NULL,NULL,NULL,NULL,1,241.9932083,10.77964,0.185,NULL,56587833284,884184895,13815388,14.56),(135572,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135572,34.18,0.25,68.5,64250,NULL,NULL,'Malmquist cor.','IC 1196',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135573,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135573,34.2,0.25,69.1,64250,NULL,NULL,NULL,'IC 1196',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135574,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135574,34.4,0.4,75.7,64250,NULL,NULL,'mean','IC 1196',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135575,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135575,34.42,0.2,76.6,64250,74.4,NULL,NULL,'IC 1196',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135576,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135576,34.66,0.47,85.4,64250,NULL,NULL,'H','IC 1196',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135577,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135577,37.8,0.46,363,64251,70,NULL,NULL,'2MASX J16075875+1358594',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,241.99475,13.98328,0.093,NULL,56550438590,883600602,13806259,16.8),(135578,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135578,37.93,0.46,385,64252,70,NULL,NULL,'2MASX J16075912+1129178',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,241.996375,11.48831,0.169,NULL,56579922091,884061282,13813457,17.9),(135579,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135579,36.57,0.46,206,64253,70,NULL,NULL,'2MASX J16075967+1134518',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,241.99875,11.581,0.169,NULL,56579248188,884050752,13813293,16.4),(135580,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135580,37.6,0.27,331,64254,70,NULL,NULL,'2MASX J16080004+3408464',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,242.000167,34.14628,0.009,NULL,59766330478,933848913,14591389,17.2),(135581,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135581,38.09,0.27,416,64255,70,NULL,NULL,'2MASX J16080044+3742413',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,242.001833,37.71136,0,NULL,59770324834,933911325,14592364,17.5),(135582,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135582,36.56,0.21,205,64256,70,NULL,NULL,'2MASX J16080048+2837463',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000163,NULL,'16.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,242.0020417,28.62964,0.085,NULL,59736579102,933384048,14584125,16.5),(135583,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135583,37.87,0.46,376,64257,70,NULL,NULL,'2MASX J16080283+3130384',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000188,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,242.011833333,31.51067,0.057,NULL,59735829010,933372328,14583942,16.5),(135584,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135584,36.43,0.46,193,64258,70,NULL,NULL,'2MASX J16080349+1831037',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,242.014583,18.51769,0.057,NULL,56516350829,883067981,13797937,16.7),(135585,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135585,33.73,0.2,55.7,64259,74.4,NULL,NULL,'UGC 10220',NULL,'2013AJ....146...86T',2013,1,0.91,NULL,'G',0.000224,NULL,'15.7g',0.48,'SBc',NULL,NULL,NULL,NULL,1,242.016625,20.19878,0.077,NULL,56522331097,883161423,13799397,15.7),(135586,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135586,37.65,0.46,340,64260,70,NULL,NULL,'2MASX J16080445+3854263',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,242.01875,38.9075,0.009,NULL,59800405580,934381337,14599708,17.2),(135587,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135587,37.72,0.27,350,64261,70,NULL,NULL,'2MASX J16080453+4309486',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.0001,NULL,'16.1g',0.38,'E0','Field galaxy',NULL,NULL,NULL,1,242.018875,43.16347,0.009,NULL,59805646877,934463232,14600988,16.1),(135588,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135588,36.92,0.46,242,64262,70,NULL,NULL,'SDSS J160805.80+163944.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000176,NULL,'17.4g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,242.024208333,16.66225,0.081,NULL,56563363376,883802552,13809414,17.4),(135589,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135589,37.96,0.46,391,64263,70,NULL,NULL,'SDSS J160806.54+363032.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,242.02725,36.50894,0.029,NULL,59773505548,933961024,14593141,18.4),(135590,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135590,37.13,0.23,266,64264,70,NULL,NULL,'2MASX J16080697+4913093',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000074,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.029208333,49.21919,NULL,NULL,59704633107,932884892,14576326,17.7),(135591,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135591,37.72,0.27,350,64265,70,NULL,NULL,'2MASX J16080754+4310476',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,242.0314583,43.18,0.009,NULL,59805647012,934463234,14600988,17.9),(135592,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135592,37.13,0.23,266,64266,70,NULL,NULL,'2MASX J16080820+4912033',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000113,NULL,'15.8g',0.47,'AGN',NULL,NULL,NULL,NULL,1,242.0340417,49.20097,NULL,NULL,59704634985,932884921,14576326,15.8),(135593,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135593,37.6,0.27,331,64267,70,NULL,NULL,'2MASXi J1608085+340639',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000146,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,242.035417,34.11089,0.013,NULL,59766286630,933848228,14591378,17),(135594,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135594,38.3,0.46,456,64268,70,NULL,NULL,'2MASX J16080894+0855538',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000173,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,242.0372917,8.93153,0.109,NULL,56582697719,884104651,13814135,18),(135595,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135595,36.8,0.46,229,64269,70,NULL,NULL,'2MASX J16080948+1156058',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,242.0395,11.93506,0.141,NULL,56579151616,884049244,13813269,16.4),(135596,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135596,36.19,0.2,173,64270,74.4,NULL,NULL,'CGCG 108-157',NULL,'2013AJ....146...86T',2013,1,0.82,NULL,'G',0.000021,NULL,'15.4g',0.39,'S..','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,242.045083,16.77278,0.093,NULL,56563386955,883802921,13809420,15.4),(135597,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135597,36.77,0.33,226,64271,70,NULL,NULL,'2MASX J16081088+4836013',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000092,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,242.0455,48.60039,NULL,NULL,59705289603,932895150,14576486,16.9),(135598,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135598,37.13,0.23,266,64272,70,NULL,NULL,'2MASX J16081147+4910293',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.0001,NULL,'15.9g',0.47,'E0',NULL,NULL,NULL,NULL,1,242.0479583,49.17472,NULL,NULL,59704631641,932884869,14576326,15.9),(135599,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135599,37.45,0.46,308,64273,70,NULL,NULL,'2MASX J16081256+1407004',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.1g',0.38,NULL,NULL,NULL,NULL,NULL,1,242.052333,14.11672,0.093,NULL,56550322563,883598790,13806231,16.1),(135600,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135600,36.2,0.46,174,64274,70,NULL,NULL,'2MASX J16081287+2734163',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000155,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,242.0535,27.57114,0.101,NULL,59862188144,935346689,14614792,16.5),(135601,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135601,36.15,0.46,170,64275,70,NULL,NULL,'2MASX J16081401+3338567',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000157,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,242.0584583,33.64919,0.017,NULL,59784022289,934125348,14595708,16.5),(135602,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135602,37.6,0.27,331,64276,70,NULL,NULL,'2MASX J16081439+3406457',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,242.06,34.11281,0.017,NULL,59766287805,933848246,14591378,17.6),(135603,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135603,36.37,0.46,188,64277,70,NULL,NULL,'KUGX 1606+343',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000098,NULL,'17.0g',0.19,'Compact',NULL,NULL,NULL,NULL,1,242.065541667,34.23478,0.009,NULL,59766283118,933848173,14591377,17),(135604,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135604,37.31,0.46,290,64278,70,NULL,NULL,'2MASX J16081603+1626274',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.0669583,16.44081,0.085,NULL,56563059514,883797804,13809340,17.7),(135605,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135605,37.79,0.33,362,64279,70,NULL,NULL,'2MASX J16081617+2343557',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000176,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,242.067291667,23.73225,0.165,NULL,59392351134,928005486,14500085,17.6),(135606,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135606,36.37,0.46,188,64280,70,NULL,NULL,'2MASX J16081619+0357385',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000177,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,242.067375,3.96083,0.229,NULL,56490333119,882661454,13791585,16.2),(135607,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135607,38.09,0.27,416,64281,70,NULL,NULL,'2MASX J16081636+3737434',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000117,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,242.068,37.62867,0,NULL,59770343474,933911616,14592369,17.1),(135608,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135608,36.06,0.46,163,64282,70,NULL,NULL,'CGCG 195-016',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000087,NULL,'15.0g',0.56,'E0',NULL,NULL,NULL,NULL,1,242.0684583,36.09336,0.029,NULL,59773453781,933960215,14593128,15),(135609,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135609,31.6,0.43,20.9,64283,75,NULL,'3.6 micron, color + selection bias corrected','IC 1197',NULL,'2014MNRAS.444..527S',2014,1,3.02,NULL,'G',0.000006,NULL,'14.1g',0.51,'Sd',NULL,NULL,NULL,NULL,1,242.0719583,7.5385,0.149,NULL,56462936879,882233388,13784896,14.1),(135610,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135610,31.7,0.4,21.9,64283,75,NULL,NULL,'IC 1197',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135611,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135611,31.72,0.43,22.1,64283,75,NULL,'3.6 micron, color corrected','IC 1197',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135612,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135612,31.8,NULL,22.9,64283,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 1197',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135613,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135613,31.83,NULL,23.2,64283,NULL,NULL,'Dipole','IC 1197',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135614,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135614,31.83,NULL,23.2,64283,NULL,NULL,'Dipole + Quadrupole','IC 1197',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135615,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135615,31.83,0.2,23.2,64283,74.4,NULL,NULL,'IC 1197',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135616,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135616,31.89,0.4,23.9,64283,NULL,NULL,NULL,'IC 1197',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135617,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135617,31.9,0.49,24,64283,75,NULL,'IR','IC 1197',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135618,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135618,31.95,NULL,24.6,64283,NULL,NULL,NULL,'IC 1197',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135619,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135619,31.98,0.4,24.9,64283,NULL,NULL,'mean','IC 1197',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135620,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135620,32.02,NULL,25.3,64283,72,NULL,NULL,'IC 1197',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135621,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135621,32.08,0.52,26.1,64283,NULL,NULL,NULL,'IC 1197',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135622,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135622,32.16,0.5,27.1,64283,NULL,NULL,'Malmquist cor.','IC 1197',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135623,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135623,32.53,0.47,32.1,64283,NULL,NULL,'H','IC 1197',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135624,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135624,36.14,0.46,169,64284,70,NULL,NULL,'2MASX J16081759+1724364',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000103,NULL,'15.9g',0.39,'E',NULL,NULL,NULL,NULL,1,242.073125,17.41006,0.117,NULL,56562058798,883782168,13809096,15.9),(135625,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135625,38.3,0.46,458,64285,70,NULL,NULL,'SDSS J160817.94+190358.0',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.0747917,19.06611,0.061,NULL,56519168138,883112002,13798625,18.2),(135626,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135626,38.09,0.27,416,64286,70,NULL,NULL,'2MASX J16081822+3743354',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00011,NULL,'16.6g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,242.075833,37.72647,0,NULL,59770317876,933911216,14592362,16.6),(135627,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','PS1 SN PS10jt','N',135627,41.01,0.14,1190,64287,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10jt HOST',0.3361,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135628,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135628,37.81,0.46,364,64288,70,NULL,NULL,'2MASX J16081839+1453567',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.07675,14.89917,0.057,NULL,56549744243,883589753,13806089,17.4),(135629,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135629,36.56,0.21,205,64289,70,NULL,NULL,'SDSS J160821.14+282843.2',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',NULL,NULL,'15.4g',0.48,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,242.088083,28.47869,0.093,NULL,59736569266,933383894,14584123,15.4),(135630,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135630,37.81,0.46,366,64290,70,NULL,NULL,'2MASX J16082344+1140324',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.097625,11.67572,0.161,NULL,56579245489,884050710,13813292,17.6),(135631,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135631,37.38,0.46,300,64291,70,NULL,NULL,'2MASX J16082464+2653046',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000143,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,242.102583,26.88469,0.097,NULL,59863015859,935359622,14614994,17.1),(135632,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135632,36.87,0.46,237,64292,70,NULL,NULL,'2MASX J16082554+4513016',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.1065417,45.21708,0.021,NULL,59803340321,934427192,14600424,17.4),(135633,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135633,33.93,0.49,61.2,64293,75,NULL,'IR','ESO 451- G 009',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.00002,NULL,'15.13',0.3,'Sb-c',NULL,NULL,NULL,NULL,1,242.110125,-32.55494,0.869,NULL,46300674551,723448039,11303875,15.13),(135634,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135634,36.97,0.46,248,64294,70,NULL,NULL,'2MASX J16082655+3624293',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00011,NULL,'17.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.110667,36.40806,0.029,NULL,59773514597,933961165,14593143,17),(135635,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135635,38.25,0.46,447,64295,70,NULL,NULL,'2MASX J16082685+3817563',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,242.1120417,38.29903,0.017,NULL,59770750714,933917979,14592468,17.6),(135636,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135636,36.65,0.46,213,64296,70,NULL,NULL,'SDSS J160828.04+165123.7',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000153,NULL,'15.8g',0.38,'E',NULL,NULL,NULL,NULL,1,242.116833333,16.85661,0.093,NULL,56563377034,883802766,13809418,15.8),(135637,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135637,37.85,0.46,372,64297,70,NULL,NULL,'2MASX J16082857+2859146',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000173,NULL,'17.6g',0.18,'E',NULL,NULL,NULL,NULL,1,242.118875,28.98739,0.081,NULL,59737290357,933395161,14584299,17.6),(135638,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135638,37.81,0.33,365,64298,70,NULL,NULL,'2MASX J16082937+2626096',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,242.1222917,26.43594,0.129,NULL,59862941419,935358459,14614975,17.4),(135639,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135639,37.81,0.33,365,64299,70,NULL,NULL,'SDSS J160830.20+263113.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00015,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,242.125833,26.52031,0.129,NULL,59862931117,935358298,14614973,18.6),(135640,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135640,36.56,0.21,205,64300,70,NULL,NULL,'2MASX J16083026+2826046',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.1259583,28.43464,0.093,NULL,59736557829,933383716,14584120,17.1),(135641,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135641,38.22,0.46,440,64301,70,NULL,NULL,'2MASX J16083138+2640086',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.130875,26.66914,0.129,NULL,59862767321,935355739,14614933,17.7),(135642,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135642,34.94,0.46,97.1,64302,70,NULL,NULL,'CGCG 079-057',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00017,NULL,'14.9',0.6,'E','Isolated galaxy',NULL,NULL,NULL,1,242.1365,9.60672,0.149,NULL,56587087420,884173240,13815206,14.9),(135643,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135643,38.44,0.46,487,64303,70,NULL,NULL,'SDSS J160832.83+471324.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000133,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.1367917,47.22339,NULL,NULL,59702630166,932853596,14575837,18.3),(135644,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135644,38.21,0.46,438,64304,70,NULL,NULL,'2MASX J16083366+3424459',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,242.140458333,34.41292,0.017,NULL,59766545774,933852277,14591441,17.9),(135645,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135645,34.86,0.8,93.7,64305,75,NULL,'MAT, I','ESO 516- G 008',NULL,'1997ApJS..109..333W',1997,1,2.07,NULL,'G',0.000033,NULL,'14.18',0.25,'Sbc',NULL,NULL,NULL,NULL,1,242.141667,-25.0195,0.465,NULL,47111273945,736113655,11501775,14.18),(135646,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135646,34.3,NULL,72.6,64305,NULL,NULL,NULL,'ESO 516- G 008',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135647,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135647,34.34,0.32,73.9,64305,85,NULL,'I, raw','ESO 516- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135648,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135648,34.36,0.32,74.6,64305,85,NULL,'I, inv','ESO 516- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135649,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135649,34.61,0.43,83.5,64305,75,NULL,'MAT, I, raw','ESO 516- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135650,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135650,34.63,NULL,84.2,64305,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 516- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135651,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135651,34.63,NULL,84.4,64305,NULL,NULL,'Dipole','ESO 516- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135652,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135652,34.64,NULL,84.8,64305,NULL,NULL,'Dipole + Quadrupole','ESO 516- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135653,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135653,34.74,0.43,88.9,64305,75,NULL,'MAT, I, inv','ESO 516- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135654,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135654,34.82,0.48,92.1,64305,NULL,NULL,'Malmquist cor.','ESO 516- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135655,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135655,34.91,0.46,95.8,64305,NULL,NULL,NULL,'ESO 516- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135656,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135656,34.95,0.43,97.8,64305,75,NULL,'3.6 micron, color + selection bias corrected','ESO 516- G 008',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135657,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135657,34.96,0.43,98.2,64305,75,NULL,'MAT, I, cor','ESO 516- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135658,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135658,35.03,0.43,101,64305,75,NULL,'3.6 micron, color corrected','ESO 516- G 008',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135659,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135659,35.03,0.2,101,64305,74.4,NULL,NULL,'ESO 516- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135660,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135660,35.1,0.49,105,64305,75,NULL,'IR','ESO 516- G 008',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135661,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135661,36.18,0.46,172,64306,70,NULL,NULL,'2MASX J16083539+2457096',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'17.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,242.147666667,24.95256,0.169,NULL,59861914625,935342416,14614725,17),(135662,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135662,38.41,0.46,481,64307,70,NULL,NULL,'SDSS J160835.48+341353.4',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000183,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.147917,34.2315,0.017,NULL,59766277838,933848091,14591376,17.7),(135663,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135663,38.06,0.46,410,64308,70,NULL,NULL,'2MASX J16083574+3855169',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.149083,38.92139,0.009,NULL,59800413585,934381462,14599710,17.5),(135664,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135664,35.89,0.4,151,64309,NULL,NULL,'mean','IC 1198',NULL,'2007A&A...465...71T',2007,1,0.6,'1992A&AS...96..389d has V = 9683 +- 90 km/sec.','G',0.00013,NULL,'15.20',0.3,'SB0            Sy1.5',NULL,NULL,NULL,'Sy 1.5',1,242.1515417,12.33094,0.129,NULL,56548836932,883575577,13805868,15.2),(135665,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135665,36.15,0.45,170,64309,NULL,NULL,'K','IC 1198',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135666,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135666,36.16,0.47,171,64309,NULL,NULL,'H','IC 1198',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135667,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135667,37.74,0.46,353,64310,70,NULL,NULL,'2MASX J16083713+2655506',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000152,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.1547083,26.93089,0.105,NULL,59862751307,935355489,14614929,17.3),(135668,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135668,35.58,0.42,131,64311,NULL,NULL,NULL,'AGC 260963',NULL,'2009ApJS..182..474S',2009,1,0.68,NULL,'G',0.000021,NULL,'17.8g',0.1,'Scd',NULL,NULL,NULL,NULL,1,242.155417,15.87692,0.049,NULL,56562457943,883788405,13809193,17.8),(135669,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135669,35.65,0.2,135,64311,74.4,NULL,NULL,'AGC 260963',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135670,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135670,35.84,0.38,147,64311,NULL,NULL,'Malmquist cor.','AGC 260963',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135671,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135671,36.11,0.53,166,64312,70,NULL,NULL,'2MASX J16083767-0801407',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000087,NULL,'13.7I',0.5,NULL,NULL,NULL,NULL,NULL,1,242.157,-8.02806,0.625,NULL,45573720581,712089384,11126396,13.7),(135672,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135672,34.48,0.2,78.7,64313,74.4,NULL,NULL,'CGCG 079-058',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.00016,NULL,'15.5',0.2,NULL,NULL,NULL,NULL,NULL,1,242.164875,12.01069,0.133,NULL,56579300151,884051564,13813305,15.5),(135673,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135673,34.4,0.49,76,64314,75,NULL,'IR','CGCG 079-058',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.00016,NULL,'15.5',0.2,NULL,NULL,NULL,NULL,NULL,1,242.164875,12.01069,0.133,NULL,56579300151,884051564,13813305,15.5),(135674,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135674,37.35,0.46,294,64315,70,NULL,NULL,'2MASX J16083988+2341544',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000182,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.166375,23.69861,0.181,NULL,59392379257,928005925,14500092,17.5),(135675,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135675,37.4,0.46,301,64316,70,NULL,NULL,'SDSS J160841.68+442329.7',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000144,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,242.173708333,44.39161,0.013,NULL,59803056102,934422751,14600355,18.6),(135676,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135676,38.09,0.46,416,64317,70,NULL,NULL,'2MASX J16084229+2702256',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000152,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.17625,27.04036,0.105,NULL,59863011149,935359549,14614992,17.6),(135677,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135677,38.24,0.27,444,64318,70,NULL,NULL,'2MASX J16084389+3716099',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.182875,37.26953,0,NULL,59770194761,933909293,14592332,17.5),(135678,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135678,36.53,0.46,202,64319,70,NULL,NULL,'2MASX J16084428+3053220',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000191,NULL,'16.2g',0.29,'S0^-',NULL,NULL,NULL,NULL,1,242.184625,30.88947,0.065,NULL,59738936149,933420877,14584701,16.2),(135679,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135679,35.78,0.8,143,64320,75,NULL,'HMCL, I','CGCG 108-158',NULL,'1997ApJS..109..333W',1997,1,1.11,NULL,'G',0.00001,NULL,'15.3g',0.33,'(R\')SB(s)ab','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,242.18875,16.75922,0.093,NULL,56563580036,883805938,13809467,15.3),(135680,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135680,35.79,0.8,144,64320,75,NULL,'W91CL, r','CGCG 108-158',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135681,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135681,35.64,0.4,134,64320,75,NULL,'HMCL, I, raw','CGCG 108-158',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135682,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135682,35.72,0.2,139,64320,74.4,NULL,NULL,'CGCG 108-158',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135683,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135683,35.77,0.38,143,64320,75,NULL,'W91CL, r, raw','CGCG 108-158',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135684,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135684,35.81,0.29,145,64320,NULL,NULL,NULL,'CGCG 108-158',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135685,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135685,35.8,0.29,145,64320,NULL,NULL,'Malmquist cor.','CGCG 108-158',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135686,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135686,35.87,0.4,149,64320,75,NULL,'HMCL, I, inv','CGCG 108-158',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135687,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135687,35.93,0.4,153,64320,75,NULL,'HMCL, I, cor','CGCG 108-158',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135688,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135688,35.98,0.38,157,64320,75,NULL,'W91CL, r, inv','CGCG 108-158',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135689,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135689,36.03,0.38,161,64320,75,NULL,'W91CL, r, cor','CGCG 108-158',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135690,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135690,37.1,0.46,264,64321,70,NULL,NULL,'SDSS J160846.48+501018.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000087,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,242.1937083,50.17167,0.041,NULL,59706345566,932911649,14576744,17.6),(135691,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135691,36.02,0.46,160,64322,70,NULL,NULL,'2MASX J16084751+1558377',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000173,NULL,'16.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,242.198083,15.97725,0.053,NULL,56563167330,883799489,13809367,16.1),(135692,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135692,38.11,0.46,418,64323,70,NULL,NULL,'2MASX J16084772+3456593',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000174,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.199,34.94994,0,NULL,59765793487,933840523,14591258,17.6),(135693,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135693,37.5,0.46,317,64324,70,NULL,NULL,'2MASX J16084891+2715246',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000161,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.203916667,27.25686,0.109,NULL,59729060192,933266565,14582290,18.4),(135694,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135694,35.51,0.8,126,64325,75,NULL,'CF, r','UGC 10224',NULL,'1997ApJS..109..333W',1997,1,1.02,NULL,'G',0.000033,NULL,'15.1g',0.47,'Sbc',NULL,NULL,NULL,NULL,1,242.209375,22.04264,0.161,NULL,56507428178,882928565,13795758,15.1),(135695,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135695,35.53,0.38,128,64325,75,NULL,'CF, r, raw','UGC 10224',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135696,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135696,35.57,0.2,130,64325,74.4,NULL,NULL,'UGC 10224',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135697,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135697,35.7,0.38,138,64325,75,NULL,'CF, r, inv','UGC 10224',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135698,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135698,35.81,0.38,145,64325,75,NULL,'CF, r, cor','UGC 10224',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135699,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135699,37.67,0.46,342,64326,70,NULL,NULL,'SDSS J160850.65+090629.5',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,242.211083,9.10822,0.113,NULL,56587033180,884172393,13815193,NULL),(135700,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135700,36.77,0.46,226,64327,70,NULL,NULL,'2MASX J16085091-0029290',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000072,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.21225,-0.49136,0.445,NULL,45558691142,711854549,11122727,17.5),(135701,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135701,37.78,0.46,359,64328,70,NULL,NULL,'2MASX J16085204+0746560',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,242.216916667,7.78228,0.153,NULL,56461926331,882217598,13784649,18.3),(135702,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','PS1 SN PS10jk','N',135702,42.11,0.16,1850,64329,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10jk HOST',0.4301,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135703,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135703,37.74,0.46,353,64330,70,NULL,NULL,'2MASX J16085552+3038484',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,242.231375,30.64669,0.061,NULL,59738768221,933418253,14584660,17),(135704,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135704,35.52,0.61,127,64331,70,NULL,NULL,'2MASX J16085638-1147185',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.5,NULL,NULL,NULL,NULL,NULL,1,242.235,-11.78847,1.113,NULL,45576600487,712134382,11127099,14),(135705,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135705,37.79,0.33,362,64332,70,NULL,NULL,'2MASX J16085750+2351414',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000203,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,242.2395,23.86161,0.181,NULL,59392283021,928004422,14500069,16.7),(135706,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135706,35.43,0.46,122,64333,70,NULL,NULL,'2MASX J16085749+2221424',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00016,NULL,'16.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,242.239666667,22.36175,0.185,NULL,56509363626,882958806,13796231,16.2),(135707,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135707,37.95,0.46,390,64334,70,NULL,NULL,'SDSS J160857.91+080504.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,242.241333333,8.08453,0.161,NULL,56582984217,884109128,13814205,18),(135708,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135708,38.24,0.27,444,64335,70,NULL,NULL,'SDSS J160858.23+371437.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,242.242667,37.24375,0,NULL,59770169592,933908899,14592326,18.1),(135709,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135709,35.27,NULL,113,64336,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10227',NULL,'2010Ap&SS.325..163P',2010,1,2.02,NULL,'G',0.000016,NULL,'15.0g',0.31,'SBcd?','Isolated galaxy',NULL,NULL,NULL,1,242.242917,36.61089,0.029,NULL,59773327750,933958246,14593097,15),(135710,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135710,35.27,NULL,113,64336,NULL,NULL,'Dipole + Quadrupole','UGC 10227',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135711,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135711,35.28,NULL,114,64336,NULL,NULL,'Dipole','UGC 10227',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135712,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135712,35.31,NULL,116,64336,NULL,NULL,NULL,'UGC 10227',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135713,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135713,35.43,0.49,122,64336,75,NULL,'IR','UGC 10227',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135714,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135714,35.64,0.4,134,64336,NULL,NULL,'mean','UGC 10227',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135715,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135715,35.74,0.47,141,64336,NULL,NULL,'H','UGC 10227',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135716,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135716,35.78,0.45,143,64336,NULL,NULL,'K','UGC 10227',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135717,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135717,35.93,0.46,153,64336,NULL,NULL,'J','UGC 10227',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135718,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135718,38.05,0.46,407,64337,70,NULL,NULL,'SDSS J160858.46+245103.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,242.243583,24.85103,0.169,NULL,59862132543,935345820,14614778,18.6),(135719,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135719,38.24,0.27,444,64338,70,NULL,NULL,'2MASX J16085939+3714539',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,242.247417,37.24847,0,NULL,59770169498,933908898,14592326,17.3),(135720,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135720,35.43,0.8,122,64339,75,NULL,'CF, r','UGC 10226',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.00001,NULL,'15.0g',0.47,'Sb','Isolated galaxy',NULL,NULL,NULL,1,242.252625,35.79364,0.017,NULL,59773999514,933968742,14593261,15),(135721,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135721,35.55,0.33,129,64339,NULL,NULL,NULL,'UGC 10226',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135722,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135722,35.6,0.32,132,64339,NULL,NULL,'Malmquist cor.','UGC 10226',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135723,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135723,35.61,0.2,132,64339,74.4,NULL,NULL,'UGC 10226',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135724,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135724,35.73,0.38,140,64339,75,NULL,'CF, r, raw','UGC 10226',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135725,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135725,35.89,0.38,151,64339,75,NULL,'CF, r, inv','UGC 10226',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135726,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135726,35.92,0.38,153,64339,75,NULL,'CF, r, cor','UGC 10226',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135727,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135727,37.32,0.33,291,64340,70,NULL,NULL,'2MASX J16090211+5344363',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000082,NULL,'16.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,242.258666667,53.74347,0,NULL,57606226591,900097290,14064020,16.3),(135728,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135728,38.38,0.46,474,64341,70,NULL,NULL,'SDSS J160902.29+222317.1',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000152,NULL,'19.0g',0.11,NULL,NULL,NULL,NULL,NULL,1,242.2595417,22.38811,0.185,NULL,56509366112,882958845,13796231,19),(135729,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135729,37.21,0.27,277,64342,70,NULL,NULL,'SDSS J160902.44+091933.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,242.260167,9.32606,0.117,NULL,56587136679,884174010,13815218,18.1),(135730,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135730,37.43,0.33,306,64343,70,NULL,NULL,'2MASX J16090502+3242135',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,242.270917,32.70369,0,NULL,59785395506,934146804,14596043,16.9),(135731,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135731,35.33,0.46,117,64344,70,NULL,NULL,'2MASX J16090555+2753340',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00019,NULL,'15.5g',0.46,'Sy2',NULL,NULL,NULL,'Sy 2',1,242.273,27.89272,0.085,NULL,59729034339,933266161,14582283,15.5),(135732,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135732,36.19,0.46,173,64345,70,NULL,NULL,'CGCG 250-047',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000097,NULL,'15.2g',0.61,'S0',NULL,NULL,NULL,NULL,1,242.2764583,46.67119,NULL,NULL,59701952121,932843001,14575671,15.2),(135733,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135733,35.88,0.2,150,64346,74.4,NULL,NULL,'CGCG 137-045',NULL,'2013AJ....146...86T',2013,1,0.58,NULL,'G',0.000103,NULL,'15.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,242.277041667,24.87042,0.169,NULL,59862134577,935345852,14614778,15.6),(135734,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135734,37.48,0.46,313,64347,70,NULL,NULL,'2MASX J16090662+2249247',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000148,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.2775,22.82367,0.145,NULL,59391873090,927998017,14499969,17.7),(135735,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135735,36.72,0.46,220,64348,70,NULL,NULL,'2MASX J16090787+2631010',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000185,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,242.2827917,26.51683,0.105,NULL,59862924770,935358199,14614971,16.6),(135736,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135736,36.47,0.46,197,64349,70,NULL,NULL,'CGCG 079-062',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000197,NULL,'15.2',0.5,NULL,NULL,NULL,NULL,NULL,1,242.285625,12.085,0.145,NULL,56579082192,884048159,13813252,15.2),(135737,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135737,37.36,0.15,297,64350,70,NULL,NULL,'2MASX J16090862+5302123',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00008,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,242.2860417,53.03681,0,NULL,59700567454,932821366,14575333,17),(135738,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135738,37.43,0.33,306,64351,70,NULL,NULL,'2MASX J16090914+3239565',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000164,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,242.288125,32.66556,0.045,NULL,59785392290,934146754,14596043,17.2),(135739,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135739,37.21,0.27,277,64352,70,NULL,NULL,'2MASX J16091264+0922260',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,242.302583333,9.374,0.117,NULL,56587138299,884174035,13815219,16.7),(135740,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135740,37.33,0.46,293,64353,70,NULL,NULL,'2MASX J16091279+1453477',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,242.3032917,14.89664,0.089,NULL,56552040739,883625636,13806650,16.4),(135741,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135741,37.36,0.15,297,64354,70,NULL,NULL,'2MASX J16091372+5303353',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000065,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,242.307375,53.06003,0,NULL,59700567919,932821373,14575333,17.7),(135742,'G Lens','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135742,40.77,NULL,1420,64355,NULL,NULL,'WMAP-7 cosmology','WN B1608+6540:[KTF2003] G1',NULL,'2015JCAP...11..033J',2014,1,NULL,NULL,'G',NULL,NULL,'18.23',NULL,NULL,NULL,NULL,NULL,NULL,1,242.307875,65.54108,0.041,NULL,57828320628,903567509,14118242,18.23),(135743,'G Lens','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135743,40.86,NULL,1490,64355,NULL,NULL,NULL,'WN B1608+6540:[KTF2003] G1',NULL,'2015JCAP...11..033J',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135744,'G Lens','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135744,40.92,0.7,1530,64355,NULL,NULL,NULL,'WN B1608+6540:[KTF2003] G1',NULL,'2007ApJ...660....1O',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135745,'G Lens','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135745,43.59,0.08,5230,64355,NULL,NULL,NULL,'WN B1608+6540:[KTF2003] G1',NULL,'2010ApJ...711..201S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135746,'G Lens','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135746,44,0.46,6300,64355,NULL,NULL,NULL,'WN B1608+6540:[KTF2003] G1',NULL,'2014MNRAS.437..600S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135747,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135747,36.46,0.46,196,64356,70,NULL,NULL,'2MASX J16091509+4612477',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00018,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,242.312875,46.21319,NULL,NULL,59701726125,932839470,14575616,16.2),(135748,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135748,37.43,0.46,307,64357,70,NULL,NULL,'2MASX J16091623+5032083',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000164,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,242.31775,50.53547,0.033,NULL,59706760810,932918137,14576845,16.9),(135749,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135749,34.81,0.46,91.8,64358,70,NULL,NULL,'I Zw 134',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000063,NULL,'14.9g',0.5,'S0','Field galaxy',NULL,NULL,NULL,1,242.318625,41.74572,0.021,NULL,59806968909,934483889,14601310,14.9),(135750,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135750,36.55,0.46,204,64359,70,NULL,NULL,'2MASX J16091771+0402378',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000168,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,242.323667,4.04392,0.229,NULL,56504325259,882880082,13795001,16.3),(135751,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135751,36.01,0.46,160,64360,70,NULL,NULL,'2MASX J16091787+1415502',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.0g',0.36,NULL,NULL,NULL,NULL,NULL,1,242.3245417,14.26403,0.101,NULL,56552254061,883628969,13806702,16),(135752,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135752,36.39,0.46,190,64361,70,NULL,NULL,'2MASX J16091995+2355177',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00017,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,242.333291667,23.92144,0.181,NULL,59392312330,928004880,14500076,16.5),(135753,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135753,37.5,0.46,317,64362,70,NULL,NULL,'SDSS J160921.26+321522.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000139,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,242.338625,32.25611,0.049,NULL,59785259348,934144677,14596010,18.5),(135754,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135754,37.24,0.46,281,64363,70,NULL,NULL,'SDSS J160923.20+352240.4',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',NULL,NULL,'15.8g',0.42,'E0',NULL,NULL,NULL,NULL,1,242.346667,35.37792,0.005,NULL,59773283736,933957558,14593086,15.8),(135755,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135755,37.49,0.46,315,64364,70,NULL,NULL,'2MASX J16092333+3109523',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000148,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.3472083,31.16439,0.065,NULL,59738735887,933417748,14584652,17),(135756,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135756,38.27,0.46,451,64365,70,NULL,NULL,'SDSS J160923.37+472619.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.347417,47.43881,NULL,NULL,59702742620,932855353,14575864,17.9),(135757,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135757,36.62,0.27,211,64366,70,NULL,NULL,'2MASX J16092439+2541025',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.3517917,25.68419,0.145,NULL,59861388737,935334199,14614596,18),(135758,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135758,38.78,0.46,570,64367,70,NULL,NULL,'2MASX J16092538+3703148',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.3557083,37.05419,0,NULL,59772032487,933938007,14592781,18.2),(135759,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135759,36.14,0.05,169,64368,70,NULL,NULL,'2MASX J16092565+1812577',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'AGN',NULL,NULL,NULL,NULL,1,242.3569583,18.21603,0.133,NULL,56516556097,883071189,13797987,NULL),(135760,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135760,37.2,0.46,275,64369,70,NULL,NULL,'SDSS J160926.01+045213.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000174,NULL,'17.8g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,242.358417,4.8705,0.189,NULL,56492276095,882691813,13792059,17.8),(135761,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135761,37.83,0.46,368,64370,70,NULL,NULL,'SDSS J160926.09+082731.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,242.35875,8.45867,0.129,NULL,56583102945,884110983,13814234,18.2),(135762,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135762,35.85,0.59,148,64371,70,NULL,NULL,'2MASX J16092617-0726305',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,242.3590417,-7.44186,0.601,NULL,45545667540,711651055,11119547,15.5),(135763,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135763,37.61,0.46,333,64372,70,NULL,NULL,'2MASX J16092630+4340138',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00017,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,242.3595,43.67069,0.017,NULL,59805964511,934468195,14601065,17.2),(135764,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135764,37.21,0.27,277,64373,70,NULL,NULL,'2MASX J16092705+0924039',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,242.362625,9.40125,0.117,NULL,56587013712,884172089,13815188,16.1),(135765,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135765,38.22,0.46,440,64374,70,NULL,NULL,'2MASX J16092871+3641578',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.369625,36.69925,0.029,NULL,59771516324,933929942,14592655,17.8),(135766,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135766,33.64,0.49,53.5,64375,75,NULL,'IR','ESO 451- G 011',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.000028,NULL,'14.14',0.2,'Sc             HII',NULL,NULL,NULL,NULL,1,242.373667,-29.00133,0.841,NULL,46245207731,722581370,11290333,14.14),(135767,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','PTF10qny','N',135767,35.79,0.05,139,64376,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10qny',0.0333,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135768,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135768,37.89,0.46,378,64377,70,NULL,NULL,'2MASX J16093098+1520052',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000188,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,242.37925,15.33475,0.061,NULL,56544502517,883507851,13804810,16.9),(135769,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135769,37.09,0.46,262,64378,70,NULL,NULL,'2MASX J16093234+1327452',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,242.384625,13.46244,0.097,NULL,56553377855,883646528,13806977,18.2),(135770,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135770,38.09,0.46,415,64379,70,NULL,NULL,'2MASX J16093292+0837129',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,242.387333333,8.62022,0.129,NULL,56583205749,884112589,13814259,17.2),(135771,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135771,37.45,0.46,308,64380,70,NULL,NULL,'2MASX J16093372+2400476',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,242.390583,24.01322,0.181,NULL,59392315513,928004929,14500077,17.8),(135772,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135772,34.89,0.64,95.2,64381,70,NULL,NULL,'2MASX J16093451-0234036',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,242.393875,-2.56764,0.525,NULL,45559953732,711874277,11123035,15.4),(135773,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135773,36.85,0.65,235,64382,70,NULL,NULL,'FAIRALL 1412',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'16.6b',0.42,NULL,NULL,NULL,NULL,NULL,1,242.40125,-77.49919,0.329,NULL,44279300735,691864073,10810376,16.6),(135774,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135774,36.56,0.46,205,64383,70,NULL,NULL,'2MASX J16093662+2219523',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.4025,22.33119,0.173,NULL,56509568186,882962002,13796281,17.9),(135775,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135775,30.15,0.39,10.7,64384,73,NULL,'opt','MCG -01-41-006',NULL,'2011A&A...532A.104N',2011,1,0.6,NULL,'G',0.00002,NULL,'15.5',0.3,NULL,NULL,NULL,NULL,NULL,1,242.4035,-4.62017,0.533,NULL,45553347410,711771053,11121422,15.5),(135776,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135776,30.15,NULL,10.7,64384,72,NULL,NULL,'MCG -01-41-006',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135777,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135777,37.36,0.15,297,64385,70,NULL,NULL,'2MASX J16093700+5302282',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000118,NULL,'15.3g',0.59,'BrClG',NULL,NULL,NULL,NULL,1,242.403916667,53.04125,0,NULL,59700593618,932821775,14575340,15.3),(135778,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135778,37.32,0.33,291,64386,70,NULL,NULL,'2MASX J16093718+5344232',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000099,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,242.404958333,53.73969,0,NULL,57606507380,900101677,14064088,16.7),(135779,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135779,37.72,0.46,350,64387,70,NULL,NULL,'SDSS J160937.58+524941.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000083,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,242.406625,52.82828,0,NULL,59700663608,932822868,14575357,18.5),(135780,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135780,37.97,0.46,393,64388,70,NULL,NULL,'2MASX J16093798+3656427',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.408333,36.94531,0.013,NULL,59772038825,933938106,14592782,18.2),(135781,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135781,36.6,0.46,209,64389,70,NULL,NULL,'2MASX J16094001+3707077',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.0001,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,242.416875,37.11881,0,NULL,59772022931,933937858,14592779,16.5),(135782,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135782,36.94,0.46,245,64390,70,NULL,NULL,'2MASX J16094022+2151373',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000207,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,242.417458333,21.86047,0.177,NULL,56508950311,882952348,13796130,16.3),(135783,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135783,37.85,0.33,372,64391,70,NULL,NULL,'2MASX J16094135+1938103',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.422208333,19.63628,0.069,NULL,56518527046,883101985,13798468,17.6),(135784,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135784,37.54,0.46,323,64392,70,NULL,NULL,'2MASX J16094136+4744117',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000083,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,242.42225,47.7365,NULL,NULL,59702435793,932850559,14575789,16.8),(135785,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135785,37.85,0.33,372,64393,70,NULL,NULL,'2MASX J16094205+1939073',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,242.42525,19.652,0.069,NULL,56521951176,883155487,13799304,17.5),(135786,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135786,36.26,0.46,179,64394,70,NULL,NULL,'KUGX 1607+325',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000165,NULL,'15.8g',0.38,'Compact',NULL,NULL,NULL,NULL,1,242.4255417,32.46528,0.049,NULL,59785378447,934146538,14596039,15.8),(135787,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135787,34.97,0.2,98.6,64395,74.4,NULL,NULL,'2MASX J16094265+3040533',NULL,'2013AJ....146...86T',2013,1,0.79,NULL,'G',0.000009,NULL,'16.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,242.427583,30.68164,0.073,NULL,59738861946,933419717,14584683,16.3),(135788,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135788,37.91,0.46,381,64396,70,NULL,NULL,'2MASX J16094275+1849423',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.4282917,18.82831,0.029,NULL,56517036951,883078702,13798104,17.1),(135789,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135789,37.27,0.33,284,64397,70,NULL,NULL,'2MASX J16094338+2200573',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.9g',0.22,'BrClG',NULL,NULL,NULL,NULL,1,242.430875,22.01592,0.177,NULL,56509673131,882963642,13796306,17.9),(135790,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135790,38.2,0.46,437,64398,70,NULL,NULL,'2MASX J16094423+3225573',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.434333,32.43256,0.049,NULL,59785366031,934146344,14596036,18),(135791,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135791,37.19,0.46,274,64399,70,NULL,NULL,'2MASX J16094516+4226237',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00009,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,242.438083,42.43997,0.029,NULL,59805109725,934454839,14600856,16.5),(135792,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135792,34.16,0.49,67.8,64400,75,NULL,'IR','ESO 451- G 014',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'13.43',0.2,'Sa             HII',NULL,NULL,NULL,NULL,1,242.439833333,-29.00708,0.841,NULL,46244892825,722576450,11290257,13.43),(135793,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135793,34.32,0.46,73.2,64400,NULL,NULL,'Malmquist cor.','ESO 451- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135794,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135794,34.37,0.45,74.7,64400,NULL,NULL,NULL,'ESO 451- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135795,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135795,34.41,0.2,76.2,64400,74.4,NULL,NULL,'ESO 451- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135796,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135796,36.64,0.8,213,64401,70,NULL,NULL,'2MASX J16094617-1135485',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,242.442417,-11.59689,1.041,NULL,45580806769,712200105,11128126,15.8),(135797,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135797,38.23,0.33,442,64402,70,NULL,NULL,'SDSS J160946.16+510425.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.442417,51.07381,0.041,NULL,59709425077,932959766,14577496,18.2),(135798,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135798,36.43,0.49,194,64403,75,NULL,'IR','CGCG 079-065',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.000046,NULL,'15.5',0.2,NULL,NULL,NULL,NULL,NULL,1,242.442417,13.44864,0.097,NULL,56553400725,883646886,13806982,15.5),(135799,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135799,38.4,0.46,478,64404,70,NULL,NULL,'2MASX J16094661+0508175',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,242.444125,5.13811,0.189,NULL,56491643668,882681932,13791905,17.7),(135800,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135800,37.88,0.33,376,64405,70,NULL,NULL,'SDSS J160947.11-000503.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000076,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,242.446333,-0.08433,0.397,NULL,45504195425,711003053,11109422,18.2),(135801,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135801,37.36,0.15,297,64406,70,NULL,NULL,'2MASX J16094743+5302102',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000104,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,242.4475,53.03611,0,NULL,59700585174,932821643,14575338,17.1),(135802,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135802,35.42,0.46,121,64407,70,NULL,NULL,'CGCG 167-032',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000168,NULL,'15.4g',0.46,'E0',NULL,NULL,NULL,NULL,1,242.449833,30.14311,0.089,NULL,59739406550,933428227,14584816,15.4),(135803,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135803,36.68,0.46,216,64408,70,NULL,NULL,'2MASX J16094876+3137343',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000162,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,242.453125,31.62611,0.057,NULL,59785099769,934142183,14595971,16.4),(135804,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135804,35.91,0.8,152,64409,70,NULL,NULL,'2MASX J16094888-0411334',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,242.45375,-4.19256,0.525,NULL,45564059280,711938426,11124037,14.2),(135805,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135805,36.62,0.27,211,64410,70,NULL,NULL,'2MASX J16094901+2529186',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000182,NULL,'16.0g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,242.454375,25.48853,0.149,NULL,59861603519,935337554,14614649,16),(135806,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135806,38.23,0.33,442,64411,70,NULL,NULL,'2MASX J16094930+5104582',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000114,NULL,'17.8g',0.18,'NLAGN',NULL,NULL,NULL,'Sy 2',1,242.455667,51.08283,0.041,NULL,59709424937,932959764,14577496,17.8),(135807,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135807,37.27,0.33,284,64412,70,NULL,NULL,'2MASX J16094957+2200263',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000205,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,242.4565,22.00719,0.177,NULL,56509671785,882963621,13796306,17.1),(135808,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135808,34.76,0.46,89.7,64413,70,NULL,NULL,'2MASX J16094972+1740432',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00007,NULL,'15.6g',0.43,'E',NULL,NULL,NULL,NULL,1,242.45725,17.67867,0.113,NULL,56561943677,883780369,13809068,15.6),(135809,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135809,38.48,0.27,497,64414,70,NULL,NULL,'2MASX J16094996+3722581',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000181,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,242.458167,37.38292,0.009,NULL,59770244552,933910071,14592344,17.8),(135810,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135810,37.54,0.33,322,64415,70,NULL,NULL,'2MASX J16095020+2626316',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000183,NULL,'16.3g',0.34,'E0',NULL,NULL,NULL,NULL,1,242.459125,26.44225,0.105,NULL,59862709717,935354839,14614919,16.3),(135811,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135811,33.22,0.49,44.1,64416,75,NULL,'IR','UGC 10232',NULL,'2011yCatp016004901K',2011,1,1.79,'Multiple SDSS entries describe this object.','G',0.000007,NULL,'15.81',0.17,'Sd',NULL,NULL,NULL,NULL,1,242.461208333,20.17775,0.093,NULL,56522039936,883156874,13799326,15.81),(135812,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135812,33.36,NULL,46.9,64416,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10232',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135813,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135813,33.37,NULL,47.1,64416,NULL,NULL,'Dipole + Quadrupole','UGC 10232',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135814,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135814,33.37,NULL,47.3,64416,NULL,NULL,'Dipole','UGC 10232',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135815,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135815,33.4,0.2,47.9,64416,74.4,NULL,NULL,'UGC 10232',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135816,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135816,33.49,0.48,49.8,64416,NULL,NULL,NULL,'UGC 10232',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135817,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135817,33.87,0.4,59.5,64416,NULL,NULL,'Malmquist cor.','UGC 10232',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135818,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135818,38.11,0.46,418,64417,70,NULL,NULL,'SDSS J160950.79+235547.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000138,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,242.461667,23.92989,0.181,NULL,59392301124,928004705,14500073,18.7),(135819,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135819,35.01,NULL,101,64418,NULL,NULL,NULL,'UGC 10233',NULL,'2000BSAO...50....5K',2000,1,2.06,NULL,'G',0.000027,NULL,'15.7g',0.21,'Scd',NULL,NULL,NULL,NULL,1,242.4640417,22.61525,0.165,NULL,56509368311,882958879,13796232,15.7),(135820,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135820,35.13,NULL,106,64418,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10233',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135821,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135821,35.14,NULL,106,64418,NULL,NULL,'Dipole + Quadrupole','UGC 10233',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135822,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135822,35.14,NULL,107,64418,NULL,NULL,'Dipole','UGC 10233',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135823,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135823,35.52,0.41,127,64418,NULL,NULL,NULL,'UGC 10233',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135824,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135824,35.61,0.39,132,64418,NULL,NULL,'Malmquist cor.','UGC 10233',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135825,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135825,35.62,0.2,133,64418,74.4,NULL,NULL,'UGC 10233',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135826,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135826,36.62,0.27,211,64419,70,NULL,NULL,'2MASX J16095184+2541116',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.0001,NULL,'15.2g',0.6,'E0',NULL,NULL,NULL,NULL,1,242.465875,25.68658,0.145,NULL,59861400887,935334388,14614599,15.2),(135827,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135827,37.36,0.15,297,64420,70,NULL,NULL,'2MASX J16095253+5304472',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000083,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,242.468666667,53.07994,0,NULL,59700594549,932821789,14575340,16.9),(135828,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135828,36.8,0.2,229,64421,74.4,NULL,NULL,'KUG 1607+136B',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000821,NULL,'15.6',0.1,'Spiral',NULL,NULL,NULL,NULL,1,242.4722917,13.52914,0.097,NULL,56553436072,883647438,13806991,15.6),(135829,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135829,36.02,0.49,160,64422,75,NULL,'IR','KUG 1607+136B',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.000821,NULL,'15.6',0.1,'Spiral',NULL,NULL,NULL,NULL,1,242.4722917,13.52914,0.097,NULL,56553436072,883647438,13806991,15.6),(135830,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 2006cc',NULL,135830,35.35,0.16,114,64423,74.2,NULL,'SALT 2','UGC 10244',0.032529,'2010ApJ...716..712A',2010,1,1.1,NULL,'G',0.000107,NULL,'15.4g',0.24,'S?             LINER','Field galaxy',NULL,NULL,'LINER',1,242.480916667,43.12919,0.009,NULL,59805151899,934455498,14600867,15.4),(135831,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 2006cc',NULL,135831,35.76,0.04,137,64423,72,NULL,'MLCS31','UGC 10244',0.032529,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135832,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 2006cc',NULL,135832,35.78,0.16,139,64423,65,NULL,'MLCS31','UGC 10244',0.032529,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135833,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 2006cc',NULL,135833,35.84,0.15,143,64423,70,NULL,'SALT 2','UGC 10244',0.032529,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135834,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 2006cc',NULL,135834,35.92,0.09,153,64423,74.4,NULL,NULL,'UGC 10244',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135835,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 2006cc',NULL,135835,36.19,0.14,168,64423,65,NULL,'MLCS17','UGC 10244',0.032529,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135836,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 2006cc',NULL,135836,36.21,0.16,169,64423,65,NULL,'SALT','UGC 10244',0.032529,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135837,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 2006cc',NULL,135837,36.23,0.18,170,64423,65,NULL,'SALT2','UGC 10244',0.032529,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135838,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135838,37.53,0.46,320,64424,70,NULL,NULL,'2MASX J16095646+3157144',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000173,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,242.485166667,31.95389,0.049,NULL,59785331077,934145798,14596028,16.9),(135839,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135839,37.4,0.46,302,64425,70,NULL,NULL,'2MASX J16095644+4004292',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.4852917,40.07486,0.009,NULL,59800836276,934388066,14599813,17.6),(135840,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135840,37.49,0.46,315,64426,70,NULL,NULL,'SDSS J160957.50+043726.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,242.489625,4.62403,0.229,NULL,56492047242,882688238,13792003,18),(135841,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135841,34.11,NULL,66.3,64427,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1997',NULL,'2010Ap&SS.325..163P',2010,1,0.72,NULL,'G',NULL,NULL,'16.7',0.1,'Sdm',NULL,NULL,NULL,NULL,1,242.49,22.73611,0.161,NULL,56505948828,882905450,13795397,16.7),(135842,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135842,34.13,NULL,67,64427,NULL,NULL,'Dipole + Quadrupole','FGC 1997',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135843,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135843,34.15,NULL,67.7,64427,NULL,NULL,'Dipole','FGC 1997',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135844,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135844,34.2,NULL,69.1,64427,NULL,NULL,NULL,'FGC 1997',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135845,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135845,37.54,0.33,322,64428,70,NULL,NULL,'2MASX J16095815+2636473',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,'FoF','16.3r',NULL,NULL,NULL,NULL,NULL,NULL,1,242.49225,26.61322,0.097,NULL,59729396194,933271815,14582372,16.3),(135846,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135846,32.41,0.8,30.3,64429,75,NULL,'A82, H','NGC 6070',NULL,'1997ApJS..109..333W',1997,1,3.5,NULL,'G',0.000019,NULL,'12.45',1.9,'SA(s)cd','Parent (of companion) galaxy',NULL,NULL,NULL,1,242.494541667,0.70931,0.361,NULL,56447798431,881996850,13781200,12.45),(135847,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135847,32.45,0.8,30.9,64429,75,NULL,'CF, r','NGC 6070',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135848,'Sosies','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135848,32.14,0.11,26.8,64429,NULL,NULL,NULL,'NGC 6070',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135849,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135849,31.56,0.69,20.5,64429,100,NULL,'mid-IR','NGC 6070',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135850,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135850,32.13,0.38,26.7,64429,75,NULL,'CF, r, raw','NGC 6070',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135851,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135851,32.22,0.38,27.8,64429,NULL,NULL,NULL,'NGC 6070',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135852,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135852,32.25,0.38,28.2,64429,75,NULL,'CF, r, cor','NGC 6070',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135853,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135853,32.27,0.38,28.5,64429,75,NULL,'CF, r, inv','NGC 6070',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135854,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135854,32.33,0.4,29.3,64429,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 6070',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135855,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135855,32.47,0.4,31.2,64429,75,NULL,'B','NGC 6070',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135856,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135856,32.48,NULL,31.3,64429,72,NULL,NULL,'NGC 6070',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135857,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135857,32.49,0.43,31.5,64429,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6070',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135858,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135858,32.56,0.46,32.6,64429,NULL,NULL,'J','NGC 6070',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135859,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135859,32.62,0.47,33.3,64429,NULL,NULL,'H','NGC 6070',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135860,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135860,32.65,0.4,33.9,64429,NULL,NULL,'mean','NGC 6070',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135861,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135861,32.65,0.47,33.9,64429,75,NULL,'A82, H, raw','NGC 6070',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135862,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135862,32.67,0.45,34.2,64429,NULL,NULL,'K','NGC 6070',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135863,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135863,32.83,0.47,36.9,64429,75,NULL,'A82, H, cor','NGC 6070',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135864,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135864,32.84,0.47,37,64429,75,NULL,'A82, H, inv','NGC 6070',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135865,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135865,38.06,0.33,410,64430,70,NULL,NULL,'2MASX J16095900+1636082',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000173,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,242.495833,16.60236,0.089,NULL,56562945518,883796023,13809312,16.9),(135866,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135866,36.95,0.33,245,64431,70,NULL,NULL,'2MASX J16095926+1133342',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,242.496958333,11.55956,0.161,NULL,56587656757,884182136,13815345,16.4),(135867,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135867,38.12,0.33,421,64432,70,NULL,NULL,'2MASX J16100068+5231251',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000087,NULL,'18.1g',0.16,'NLAGN',NULL,NULL,NULL,'Sy 2',1,242.5025417,52.52356,0,NULL,59700241563,932816274,14575254,18.1),(135868,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135868,38.48,0.46,497,64433,70,NULL,NULL,'SDSS J161001.11+111218.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,242.504667,11.205,0.185,NULL,56588355374,884193052,13815516,18.5),(135869,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135869,38.48,0.27,497,64434,70,NULL,NULL,'2MASX J16100121+3718482',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.3g',0.24,'BrClG',NULL,NULL,NULL,NULL,1,242.5052083,37.31344,0,NULL,59772125621,933939462,14592804,17.3),(135870,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135870,38.14,0.46,424,64435,70,NULL,NULL,'2MASX J16100160+0443485',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000179,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.50675,4.73003,0.229,NULL,56491561008,882680640,13791885,17.6),(135871,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135871,37.92,0.46,384,64436,70,NULL,NULL,'2MASX J16100325+0826082',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000143,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.513666667,8.43556,0.145,NULL,56583121339,884111270,13814238,18.1),(135872,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135872,35.32,0.66,116,64437,70,NULL,NULL,'2MASX J16100375-3205042',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'15.50',0.47,'E',NULL,NULL,NULL,NULL,1,242.515667,-32.0845,0.885,NULL,46300393786,723443652,11303807,15.5),(135873,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135873,37.29,0.46,287,64438,70,NULL,NULL,'2MASX J16100400+1701362',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000141,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.5167917,17.02686,0.109,NULL,56564322014,883817531,13809648,17.7),(135874,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135874,37.32,0.46,291,64439,70,NULL,NULL,'2MASX J16100444+0555575',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,242.518458333,5.93261,0.177,NULL,56491287886,882676373,13791818,17.4),(135875,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135875,36.68,0.46,217,64440,70,NULL,NULL,'2MASX J16100452+4913251',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000084,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,242.518708333,49.22358,0.017,NULL,59704505842,932882903,14576295,16.8),(135876,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135876,38.06,0.33,410,64441,70,NULL,NULL,'2MASX J16100491+1635162',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00014,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,242.5205,16.58781,0.089,NULL,56563076746,883798074,13809344,18.3),(135877,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135877,35.44,NULL,122,64442,NULL,NULL,NULL,'UGC 10236',NULL,'2000BSAO...50....5K',2000,1,1.49,NULL,'G',0.000033,NULL,'15.4g',0.27,'Sbc',NULL,NULL,NULL,NULL,1,242.521125,22.65022,0.165,NULL,56505942822,882905356,13795396,15.4),(135878,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135878,35.46,NULL,124,64442,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10236',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135879,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135879,35.47,NULL,124,64442,NULL,NULL,'Dipole + Quadrupole','UGC 10236',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135880,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135880,35.48,NULL,125,64442,NULL,NULL,'Dipole','UGC 10236',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135881,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135881,35.57,0.49,130,64442,75,NULL,'IR','UGC 10236',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135882,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135882,35.97,0.34,156,64442,NULL,NULL,'Malmquist cor.','UGC 10236',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135883,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135883,36.12,0.2,167,64442,74.4,NULL,NULL,'UGC 10236',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135884,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135884,36.34,0.29,185,64442,NULL,NULL,NULL,'UGC 10236',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135885,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135885,37.8,0.46,362,64443,70,NULL,NULL,'SDSS J161006.47+301922.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000142,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.5269583,30.32278,0.073,NULL,59739379705,933427807,14584809,18.4),(135886,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135886,37.05,0.46,258,64444,70,NULL,NULL,'2MASX J16100687+2453053',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,242.5285,24.88475,0.185,NULL,59862147868,935346060,14614782,17.2),(135887,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135887,37.41,0.46,303,64445,70,NULL,NULL,'2MASX J16100732+1039082',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,242.530583,10.65219,0.189,NULL,56588190222,884190472,13815476,17.4),(135888,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135888,37.75,0.46,354,64446,70,NULL,NULL,'2MASX J16100836+5340316',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000083,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.53475,53.67542,0,NULL,57606522010,900101906,14064092,17.2),(135889,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135889,38.27,0.46,451,64447,70,NULL,NULL,'2MASX J16101012+1616312',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,242.54225,16.27536,0.077,NULL,56563108805,883798575,13809352,17.3),(135890,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135890,38.12,0.46,421,64448,70,NULL,NULL,'2MASX J16101048+3831232',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,242.54375,38.52331,0.021,NULL,59770475971,933913687,14592401,17.9),(135891,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135891,37.88,0.33,376,64449,70,NULL,NULL,'2MASX J16101065-0010372',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000104,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,242.5444583,-0.17694,0.397,NULL,45504143380,711002240,11109410,17.4),(135892,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135892,33.96,0.8,61.8,64450,75,NULL,'HMCL, I','NGC 6073',NULL,'1997ApJS..109..333W',1997,1,1.29,'HOLM 731B is a star.','G',0.00002,NULL,'14.1g',0.63,'Sc:','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,242.5452083,16.69961,0.089,NULL,56564256154,883816502,13809632,14.1),(135893,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135893,34,0.8,63.2,64450,75,NULL,'CF, r','NGC 6073',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135894,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135894,33.74,0.4,55.9,64450,75,NULL,'HMCL, I, raw','NGC 6073',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135895,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135895,33.85,0.38,59,64450,75,NULL,'CF, r, raw','NGC 6073',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135896,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135896,33.88,0.4,59.8,64450,75,NULL,'HMCL, I, inv','NGC 6073',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135897,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135897,33.94,0.4,61.3,64450,75,NULL,'HMCL, I, cor','NGC 6073',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135898,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135898,33.96,0.38,62.1,64450,75,NULL,'CF, r, inv','NGC 6073',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135899,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135899,33.99,0.38,62.8,64450,75,NULL,'CF, r, cor','NGC 6073',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135900,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135900,34.07,0.2,65.2,64450,74.4,NULL,NULL,'NGC 6073',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135901,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135901,34.18,0.47,68.6,64450,NULL,NULL,'H','NGC 6073',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135902,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135902,34.28,0.46,71.8,64450,NULL,NULL,'J','NGC 6073',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135903,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135903,34.29,0.4,72.1,64450,NULL,NULL,'mean','NGC 6073',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135904,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135904,34.29,0.45,72.1,64450,NULL,NULL,'K','NGC 6073',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135905,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135905,37.1,0.46,264,64451,70,NULL,NULL,'2MASX J16101093+2600382',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.5454583,26.01064,0.129,NULL,59864790495,935387351,14615427,17.8),(135906,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135906,37.77,0.46,358,64452,70,NULL,NULL,'SDSS J161011.09+363219.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000142,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,242.546291667,36.53883,0.041,NULL,59771700406,933932818,14592700,18),(135907,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135907,38.21,0.46,438,64453,70,NULL,NULL,'2MASX J16101123+1957431',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,242.546958333,19.96203,0.089,NULL,56522161551,883158774,13799355,17.7),(135908,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135908,36.45,0.62,195,64454,70,NULL,NULL,'2MASX J16101134-0226472',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,242.5472917,-2.44658,0.513,NULL,45561877401,711904334,11123505,15.7),(135909,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 1992bi',NULL,135909,42.54,0.24,2210,64455,70,NULL,'SALT','[PPG92] 160828.27+395457.2',0.458,'2008ApJ...686..749K',2008,1,NULL,NULL,'G',0.001,NULL,'21.3',NULL,'Sm/Irr',NULL,NULL,NULL,NULL,1,242.5532917,39.78681,0.009,NULL,59801020603,934390946,14599858,21.3),(135910,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135910,38.12,0.33,421,64456,70,NULL,NULL,'SDSS J161013.38+522933.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000076,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,242.555791667,52.49261,0,NULL,59700244169,932816315,14575254,18.2),(135911,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135911,38.04,0.46,406,64457,70,NULL,NULL,'2MASX J16101433-0033382',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000101,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.5595417,-0.56072,0.413,NULL,45504959636,711014994,11109609,17.8),(135912,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135912,37.33,0.46,292,64458,70,NULL,NULL,'2MASX J16101449+4812217',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000074,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,242.5605,48.206,NULL,NULL,59705694472,932901476,14576585,17.6),(135913,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135913,38.48,0.27,497,64459,70,NULL,NULL,'SDSS J161014.57+372247.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000163,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.56075,37.37986,0.009,NULL,59772128078,933939501,14592804,18.4),(135914,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135914,37.04,0.46,256,64460,70,NULL,NULL,'2MASX J16101740+0445161',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,242.5725417,4.75439,0.229,NULL,56491562492,882680663,13791885,17.4),(135915,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135915,37.36,0.11,296,64461,70,NULL,NULL,'SDSS J161018.58+364343.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00017,NULL,'18.6g',0.09,NULL,NULL,NULL,NULL,NULL,1,242.5774583,36.72875,0.029,NULL,59771495483,933929616,14592650,18.6),(135916,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135916,37.85,0.46,371,64462,70,NULL,NULL,'2MASX J16101917+3901042',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.579875,39.01783,0,NULL,59801239168,934394362,14599911,17.5),(135917,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135917,38,0.46,398,64463,70,NULL,NULL,'2MASX J16101926+4754477',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000099,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,242.580417,47.91319,NULL,NULL,59705198716,932893729,14576464,16.9),(135918,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135918,36.18,0.46,172,64464,70,NULL,NULL,'SDSS J161019.84+212008.4',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.3g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,242.5827083,21.33569,0.161,NULL,56508867570,882951055,13796110,17.3),(135919,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135919,35.45,0.46,123,64465,70,NULL,NULL,'2MASX J16101998+2253561',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000155,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,242.58325,22.89889,0.161,NULL,56506173500,882908960,13795452,16.3),(135920,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135920,37.3,0.46,289,64466,70,NULL,NULL,'2MASX J16102046+1136464',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,242.585291667,11.61283,0.161,NULL,56587606279,884181348,13815333,16.4),(135921,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135921,37.94,0.46,388,64467,70,NULL,NULL,'2MASX J16102156+0356381',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000205,NULL,'17.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.589708333,3.944,0.233,NULL,56504279832,882879372,13794990,17.4),(135922,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135922,37.36,0.33,297,64468,70,NULL,NULL,'2MASX J16102262+1011154',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.5942917,10.18769,0.173,NULL,56586765200,884168206,13815128,17.9),(135923,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135923,37.31,0.46,290,64469,70,NULL,NULL,'2MASX J16102287+2648112',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.5954583,26.80325,0.097,NULL,59729432109,933272376,14582380,17.6),(135924,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135924,36.96,0.46,247,64470,70,NULL,NULL,'KUGX 1608+349',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000175,NULL,'16.2g',0.34,'Spiral',NULL,NULL,NULL,NULL,1,242.596833333,34.85711,0,NULL,59765736813,933839637,14591244,16.2),(135925,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135925,37.74,0.46,353,64471,70,NULL,NULL,'2MASX J16102331+1648354',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000167,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.5972917,16.80992,0.093,NULL,56564265181,883816643,13809635,18.1),(135926,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135926,37.56,0.33,325,64472,70,NULL,NULL,'2MASX J16102430+4858588',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000082,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.601417,48.98292,0.017,NULL,59704999848,932890622,14576415,17.4),(135927,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135927,36.92,0.46,242,64473,70,NULL,NULL,'2MASX J16102530+1521144',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000175,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,242.605333333,15.35403,0.053,NULL,56544666597,883510415,13804850,16.6),(135928,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','PS1 SN PS11zw','N',135928,42.27,0.42,1990,64474,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11zw HOST',0.4231,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135929,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135929,35.68,0.2,137,64475,74.4,NULL,NULL,'UGC 10238',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000033,NULL,'14.40',0.7,'(R\')SB(s)b',NULL,NULL,NULL,NULL,1,242.610625,12.30569,0.137,NULL,56552858426,883638412,13806850,14.4),(135930,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135930,35.91,0.4,152,64475,NULL,NULL,'mean','UGC 10238',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135931,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135931,36.1,0.47,166,64475,NULL,NULL,'H','UGC 10238',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135932,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135932,37.83,0.46,367,64476,70,NULL,NULL,'2MASX J16102682+5333108',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000085,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,242.6117917,53.55294,0,NULL,57606477161,900101205,14064081,17),(135933,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135933,37.94,0.46,387,64477,70,NULL,NULL,'2MASX J16102765+1834581',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,242.6152917,18.58286,0.121,NULL,56516970104,883077657,13798088,NULL),(135934,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135934,38.46,0.46,492,64478,70,NULL,NULL,'SDSS J161027.98+212111.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000159,NULL,'19.0g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,242.616583,21.35319,0.169,NULL,56508834601,882950540,13796102,19),(135935,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135935,37.89,0.46,378,64479,70,NULL,NULL,'SDSS J161030.09+212358.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000139,NULL,'18.3g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,242.625375,21.3995,0.169,NULL,56508836881,882950576,13796102,18.3),(135936,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135936,36.24,0.25,177,64480,70,NULL,NULL,'GIN 477',NULL,'2001MNRAS.321..277C',2001,1,0.41,NULL,'G',0.000237,NULL,'17.0g',0.32,'S',NULL,NULL,NULL,NULL,1,242.627167,24.05461,0.177,NULL,59391460770,927991574,14499868,17),(135937,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135937,36.26,0.2,179,64481,74.4,NULL,NULL,'UGC 10246',NULL,'2013AJ....146...86T',2013,1,0.89,NULL,'G',0.000027,NULL,'15.6g',0.42,'Sab',NULL,NULL,NULL,NULL,1,242.629291667,27.49969,0.097,NULL,59729151617,933267994,14582312,15.6),(135938,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135938,37.56,0.33,325,64482,70,NULL,NULL,'2MASX J16103172+4858118',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000076,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,242.632458333,48.96986,0.017,NULL,59704997233,932890581,14576415,17.4),(135939,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135939,36.93,0.46,243,64483,70,NULL,NULL,'2MASX J16103204+4300028',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00014,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,242.633583333,43.00092,0.025,NULL,59805176790,934455887,14600873,16.6),(135940,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135940,37.47,0.46,311,64484,70,NULL,NULL,'2MASX J16103269+1728054',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000158,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,242.63625,17.46811,0.121,NULL,56563984324,883812255,13809566,17.3),(135941,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135941,37.01,0.91,252,64485,70,NULL,NULL,'2MASX J16103294-1119247',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,242.637291667,-11.32353,0.989,NULL,45581481485,712210648,11128291,15.6),(135942,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135942,36.57,0.46,206,64486,70,NULL,NULL,'2MASX J16103298+0844234',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.637625,8.73972,0.141,NULL,56582421897,884100342,13814067,17),(135943,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135943,37.58,0.46,328,64487,70,NULL,NULL,'SDSS J161033.18+293555.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000124,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.638291667,29.59881,0.085,NULL,59736818152,933387783,14584184,18.5),(135944,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135944,37.36,0.33,297,64488,70,NULL,NULL,'SDSS J161033.22+101015.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,242.638458333,10.17089,0.161,NULL,56586897037,884170266,13815160,18),(135945,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135945,36.11,0.2,167,64489,74.4,NULL,NULL,'CGCG 079-071',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000622,NULL,'15.6',0.2,NULL,NULL,NULL,NULL,NULL,1,242.639791667,13.69464,0.101,NULL,56555503584,883679743,13807495,15.6),(135946,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135946,35.78,0.49,143,64490,75,NULL,'IR','CGCG 079-071',NULL,'2011yCatp016004901K',2011,1,0.7,NULL,'G',0.000622,NULL,'15.6',0.2,NULL,NULL,NULL,NULL,NULL,1,242.639791667,13.69464,0.101,NULL,56555503584,883679743,13807495,15.6),(135947,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135947,35.15,0.47,107,64491,70,NULL,NULL,'2MASX J16103449-1151317',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000057,NULL,'16.37',NULL,NULL,NULL,NULL,NULL,NULL,1,242.6437917,-11.85892,1.041,NULL,45580576204,712196503,11128070,16.37),(135948,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135948,36.12,0.46,168,64492,70,NULL,NULL,'CGCG 051-059',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000167,NULL,'15.4g',0.5,'AGN',NULL,NULL,NULL,NULL,1,242.6452917,4.75467,0.221,NULL,56491568924,882680764,13791886,15.4),(135949,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135949,38.03,0.46,403,64493,70,NULL,NULL,'2MASX J16103505+1446115',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.64625,14.77006,0.089,NULL,56552675815,883635559,13806805,18.4),(135950,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135950,37.36,0.15,297,64494,70,NULL,NULL,'2MASX J16103526+5248028',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000093,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,242.646958333,52.80072,0,NULL,59700501190,932820331,14575317,16.7),(135951,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135951,35.58,0.49,131,64495,75,NULL,'IR','UGC 10248',NULL,'2011yCatp016004901K',2011,1,0.94,NULL,'G',0.000017,NULL,'16.8g',0.14,'Sb',NULL,NULL,NULL,NULL,1,242.6540417,29.51322,0.097,NULL,59736833173,933388018,14584187,16.8),(135952,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135952,36.06,0.2,163,64495,74.4,NULL,NULL,'UGC 10248',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135953,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135953,37.51,0.33,317,64496,70,NULL,NULL,'2MASX J16103779+5324208',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00012,NULL,'15.8g',0.5,'AGN',NULL,NULL,NULL,NULL,1,242.657375,53.40586,0,NULL,59699693717,932807714,14575120,15.8),(135954,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135954,37.54,0.46,323,64497,70,NULL,NULL,'2MASX J16103809+1245495',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,242.65875,12.76386,0.133,NULL,56553044595,883641321,13806895,17.1),(135955,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 1965F',NULL,135955,35.22,0.29,111,64498,NULL,NULL,'Avg. of 8 SN host galaxies','KUG 1608+191',NULL,'1985ApJ...297...23D',1985,1,0.62,NULL,'G',0.00013,NULL,'15.7g',0.35,'Sc',NULL,NULL,NULL,NULL,1,242.661417,19.0575,0.105,NULL,56516854701,883075854,13798060,15.7),(135956,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135956,36.38,0.46,189,64499,70,NULL,NULL,'2MASX J16103907+0017445',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000108,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,242.662875,0.29569,0.377,NULL,56447913104,881998642,13781228,17),(135957,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135957,37.48,0.46,313,64500,70,NULL,NULL,'2MASX J16103931+3429268',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,242.663833,34.49078,0.017,NULL,59783742591,934120977,14595640,17),(135958,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135958,37.77,0.27,358,64501,70,NULL,NULL,'2MASX J16104020+4739599',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000074,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,242.6675,47.66653,NULL,NULL,59702521858,932851904,14575811,17.2),(135959,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135959,36.35,0.46,187,64502,70,NULL,NULL,'2MASX J16104077+3015188',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000187,NULL,'16.0g',0.34,'E0',NULL,NULL,NULL,NULL,1,242.6697917,30.25514,0.073,NULL,59738549787,933414840,14584606,16),(135960,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135960,37.17,0.46,272,64503,70,NULL,NULL,'2MASX J16104089+2341042',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000137,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.6705417,23.68458,0.181,NULL,59391523081,927992548,14499883,17.5),(135961,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135961,37.48,0.46,313,64504,70,NULL,NULL,'SDSS J161041.37+523703.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000945,NULL,'18.0g',0.15,'Candidate      BLAGN',NULL,NULL,NULL,NULL,1,242.6724583,52.61756,0.005,NULL,59700541759,932820964,14575327,18),(135962,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135962,37.77,0.27,358,64505,70,NULL,NULL,'2MASX J16104348+4732219',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000096,NULL,'16.5g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,242.681417,47.53953,NULL,NULL,59702560644,932852510,14575820,16.5),(135963,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135963,38.36,0.23,470,64506,70,NULL,NULL,'2MASX J16104393+1649495',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,242.683125,16.83028,0.093,NULL,56564310268,883817347,13809646,17.7),(135964,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135964,37.64,0.46,337,64507,70,NULL,NULL,'2MASX J16104507+0005235',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000097,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,242.68775,0.08981,0.357,NULL,56447350334,881989848,13781091,17.4),(135965,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135965,35.79,0.46,144,64508,70,NULL,NULL,'2MASX J16104517+1459595',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,242.688291667,14.99986,0.073,NULL,56551943852,883624122,13806626,16.7),(135966,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135966,38.49,0.46,499,64509,70,NULL,NULL,'SDSS J161045.44-000700.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000097,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.689333333,-0.11675,0.357,NULL,45504600835,711009388,11109521,18.5),(135967,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135967,37.87,0.46,376,64510,70,NULL,NULL,'2MASX J16104552+2611496',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,242.6897083,26.19717,0.121,NULL,59729263723,933269745,14582339,18),(135968,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135968,37.91,0.46,382,64511,70,NULL,NULL,'2MASX J16104633+1721075',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.692875,17.35225,0.113,NULL,56564221397,883815959,13809624,17.9),(135969,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135969,37.36,0.11,296,64512,70,NULL,NULL,'2MASX J16104666+3707112',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000103,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,242.694458333,37.11978,0,NULL,59772237303,933941207,14592831,16.5),(135970,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135970,37.42,0.46,305,64513,70,NULL,NULL,'2MASX J16104718+5214507',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000084,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,242.696667,52.24744,0.017,NULL,59700256476,932816507,14575257,17.1),(135971,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135971,36.95,0.33,245,64514,70,NULL,NULL,'2MASX J16104770+1131194',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,242.698875,11.52211,0.209,NULL,56587587885,884181060,13815329,16.3),(135972,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135972,37.36,0.15,297,64515,70,NULL,NULL,'2MASX J16104791+5226427',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000079,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,242.6994583,52.44536,0,NULL,59700223527,932815992,14575249,16.9),(135973,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135973,38.87,0.46,595,64516,70,NULL,NULL,'2MASX J16104845+0723134',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000166,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.701875,7.38719,0.193,NULL,56463600610,882243759,13785058,18.6),(135974,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135974,38.01,0.46,400,64517,70,NULL,NULL,'2MASX J16104857+3309058',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.7g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,242.7024583,33.15164,0.021,NULL,59784627728,934134808,14595856,16.7),(135975,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135975,37.88,0.46,377,64518,70,NULL,NULL,'2MASX J16104947+0018465',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000107,NULL,'17.3g',0.22,'AGN',NULL,NULL,NULL,NULL,1,242.7062083,0.31286,0.377,NULL,56447882876,881998169,13781221,17.3),(135976,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135976,37.95,0.33,390,64519,70,NULL,NULL,'SDSS J161050.47+134339.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,242.710333333,13.72758,0.101,NULL,56555702305,883682848,13807544,18.4),(135977,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135977,35.75,0.2,141,64520,74.4,NULL,NULL,'KUG 1608+171',NULL,'2013AJ....146...86T',2013,1,0.83,NULL,'G',0.00001,NULL,'14.7g',0.43,'Sb','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,242.713125,17.05742,0.109,NULL,56564345189,883817893,13809654,14.7),(135978,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135978,35.9,0.31,151,64520,NULL,NULL,'Malmquist cor.','KUG 1608+171',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135979,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135979,35.95,0.3,155,64520,NULL,NULL,NULL,'KUG 1608+171',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135980,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135980,35.4,0.55,120,64521,70,NULL,NULL,'2MASX J16105184-2458266',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,242.715958333,-24.974,0.725,NULL,47111339074,736114673,11501791,14.8),(135981,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135981,37.09,0.46,262,64522,70,NULL,NULL,'2MASX J16105217+0357146',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00016,NULL,'17.6g',NULL,NULL,NULL,NULL,NULL,NULL,1,242.717375,3.95392,0.233,NULL,56504685679,882885713,13795089,17.6),(135982,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135982,35.37,0.46,118,64523,70,NULL,NULL,'CGCG 223-049',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000199,NULL,'14.3g',0.74,'S?','Field galaxy',NULL,NULL,NULL,1,242.717583,41.88583,0,NULL,59807516442,934492444,14601444,14.3),(135983,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135983,37.14,0.46,267,64524,70,NULL,NULL,'SDSS J161053.89-000215.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00009,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.7245417,-0.03758,0.357,NULL,45504606109,711009470,11109522,18.4),(135984,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135984,37.74,0.46,354,64525,70,NULL,NULL,'LCSB S2219P',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000164,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,242.727125,20.14317,0.093,NULL,56519982351,883124724,13798823,16.8),(135985,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135985,37.95,0.33,390,64526,70,NULL,NULL,'SDSS J161054.75+133826.5',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,242.728167,13.64072,0.101,NULL,56555569195,883680768,13807512,NULL),(135986,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135986,37.77,0.27,358,64527,70,NULL,NULL,'2MASX J16105611+4728319',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000086,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,242.7337083,47.47556,NULL,NULL,59702553705,932852401,14575818,17),(135987,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135987,37.05,0.46,256,64528,70,NULL,NULL,'2MASX J16105690+2436415',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000176,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,242.737166667,24.61153,0.177,NULL,59861307388,935332927,14614576,16.6),(135988,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135988,38.33,0.46,464,64529,70,NULL,NULL,'2MASX J16105726+3518168',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.7387083,35.30458,0,NULL,59773058796,933954043,14593031,17.3),(135989,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135989,37.98,0.46,394,64530,70,NULL,NULL,'2MASX J16105890+1736391',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000165,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.7455417,17.61086,0.121,NULL,56564093609,883813962,13809593,17.2),(135990,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135990,37.36,0.11,296,64531,70,NULL,NULL,'SDSS J161058.92+365539.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,242.7455417,36.92775,0.013,NULL,59772221610,933940962,14592827,18.1),(135991,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135991,38.52,0.46,507,64532,70,NULL,NULL,'2MASX J16105977+1756501',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.7489583,17.94739,0.133,NULL,56561805414,883778209,13809034,17.8),(135992,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135992,37.36,0.11,296,64533,70,NULL,NULL,'2MASX J16110003+3650518',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000123,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,242.7502917,36.84769,0.013,NULL,59772080080,933938751,14592792,16.7),(135993,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135993,37.14,0.33,268,64534,70,NULL,NULL,'2MASX J16110019+0652243',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000176,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,242.7507917,6.87331,0.181,NULL,56463534245,882242722,13785042,16.5),(135994,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135994,37.53,0.46,320,64535,70,NULL,NULL,'2MASX J16110023+3834418',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.751,38.57822,0.021,NULL,59770510682,933914229,14592409,17.6),(135995,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135995,33.07,0.49,41.2,64536,75,NULL,'IR','ESO 451- G 015',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000027,NULL,'14.85',0.2,'Sb',NULL,NULL,NULL,NULL,1,242.751167,-32.34575,0.881,NULL,46300819241,723450300,11303910,14.85),(135996,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135996,37.36,0.15,297,64537,70,NULL,NULL,'2MASX J16110032+5227216',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00008,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,242.751583,52.45611,0,NULL,59700223899,932815998,14575249,17.6),(135997,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135997,38.36,0.46,469,64538,70,NULL,NULL,'SDSS J161101.87+380615.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000129,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,242.7577917,38.10442,0.009,NULL,59770582711,933915354,14592427,18.5),(135998,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135998,35.27,0.42,113,64539,70,NULL,NULL,'GIN 554',NULL,'2001MNRAS.321..277C',2001,1,0.49,NULL,'G',0.000133,NULL,'15.8g',0.47,'E/S0',NULL,NULL,NULL,NULL,1,242.758333,29.52467,0.085,NULL,59736619998,933384687,14584135,15.8),(135999,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135999,36.84,0.16,233,64539,70,NULL,NULL,'GIN 554',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136000,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136000,36.23,0.46,176,64540,70,NULL,NULL,'2MASX J16110248+2509564',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000178,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,242.7602083,25.16581,0.169,NULL,59861553868,935336779,14614637,16.6),(136001,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 2008cl',NULL,136001,37.45,0.19,290,64541,70,NULL,'SALT 2','UGC 10261',0.063434,'2013MNRAS.433.2240G',2013,1,1.1,NULL,'G',NULL,NULL,'15.20',0.8,'S0-:;BrClG','Group member',NULL,NULL,NULL,1,242.766958333,52.45033,0,NULL,59700223053,932815985,14575249,15.2),(136002,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136002,37.79,0.27,362,64542,70,NULL,NULL,'2MASX J16110578+3621218',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000145,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.7742917,36.35611,0.041,NULL,59771652209,933932065,14592688,17.6),(136003,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136003,37.38,0.46,300,64543,70,NULL,NULL,'SDSS J161105.89-003927.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000061,NULL,'18.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.7745417,-0.65775,0.413,NULL,45505017100,711015892,11109623,18.3),(136004,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136004,37.9,0.16,381,64544,70,NULL,NULL,'2MASX J16110702+3056021',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000153,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.779375,30.93381,0.069,NULL,59737745176,933402268,14584410,18.4),(136005,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,136005,33.38,0.2,47.4,64545,74.4,NULL,NULL,'UGC 10257',NULL,'2013AJ....146...86T',2013,1,1.9,'Position in Kiso list (1984AnTok..192.595T) is incorrect.','G',0.000017,NULL,'14.81',0.4,'Sbc',NULL,NULL,NULL,NULL,1,242.781333,38.25131,0,NULL,59770617383,933915896,14592435,14.81),(136006,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136006,33.71,0.49,55.2,64545,75,NULL,'IR','UGC 10257',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136007,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,136007,33.97,0.4,62.2,64545,NULL,NULL,'mean','UGC 10257',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136008,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,136008,34.19,0.47,69,64545,NULL,NULL,'H','UGC 10257',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136009,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136009,37.36,0.11,296,64546,70,NULL,NULL,'SDSS J161108.23+365923.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000161,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,242.7842917,36.98972,0,NULL,59772215274,933940863,14592825,18.6),(136010,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136010,37.85,0.46,371,64547,70,NULL,NULL,'2MASX J16110960+2437495',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00013,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.789875,24.63047,0.177,NULL,59861305537,935332899,14614576,18),(136011,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,136011,35.53,0.45,128,64548,NULL,NULL,'K','NGC 6095',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000103,NULL,'13.62',1.6,'S0-:',NULL,NULL,NULL,NULL,1,242.7957083,61.26797,0,NULL,57616503702,900257870,14066529,13.62),(136012,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,136012,35.57,0.4,130,64548,NULL,NULL,'mean','NGC 6095',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136013,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136013,38.22,0.46,440,64549,70,NULL,NULL,'SDSS J161112.38+384124.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000152,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,242.801583333,38.69003,0.009,NULL,59800711256,934386113,14599783,18.8),(136014,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136014,37.36,0.11,296,64550,70,NULL,NULL,'KUGX 1609+371A',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000133,NULL,'15.5g',0.58,'Compact;BrClG',NULL,NULL,NULL,NULL,1,242.807667,36.97339,0,NULL,59772214558,933940852,14592825,15.5),(136015,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136015,37.82,0.46,366,64551,70,NULL,NULL,'SDSS J161114.00+331207.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000138,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,242.808375,33.20206,0.021,NULL,59784181771,934127840,14595747,18.3),(136016,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136016,35.37,0.46,118,64552,70,NULL,NULL,'NGC 6077',NULL,'2015arXiv151105856S',2015,1,0.87,NULL,'G',0.000073,NULL,'14.4g',0.78,'E',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,242.808833333,26.92342,0.097,NULL,59729330219,933270784,14582356,14.4),(136017,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136017,37.81,0.19,365,64553,70,NULL,NULL,'2MASX J16111417+1659032',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,242.8092083,16.98428,0.109,NULL,56564269882,883816716,13809636,17.2),(136018,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136018,38.36,0.23,470,64554,70,NULL,NULL,'2MASX J16111550+1701042',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,242.8147083,17.01786,0.109,NULL,56564335280,883817738,13809652,16.9),(136019,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136019,37.36,0.11,296,64555,70,NULL,NULL,'KUG 1609+372',NULL,'2015arXiv151105856S',2015,1,0.1,NULL,'G',NULL,NULL,'16.8g',0.1,'Compact',NULL,NULL,NULL,NULL,1,242.8155,37.14269,0,NULL,59772179486,933940304,14592817,16.8),(136020,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,136020,35.76,0.2,142,64556,74.4,NULL,NULL,'UGC 10249',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'14.93',0.5,'SBab',NULL,NULL,NULL,NULL,1,242.820916667,13.86614,0.097,NULL,56555722040,883683156,13807549,14.93),(136021,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136021,37.46,0.46,311,64557,70,NULL,NULL,'2MASX J16111754+1156064',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.823083333,11.93506,0.201,NULL,56573841492,883966273,13811973,17.5),(136022,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136022,37.44,0.46,308,64558,70,NULL,NULL,'2MASX J16111863+0012502',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000102,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,242.827667,0.21411,0.377,NULL,56447382415,881990350,13781099,17.1),(136023,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136023,37.36,0.11,296,64559,70,NULL,NULL,'2MASX J16111869+3657469',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000195,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,242.827875,36.96314,0,NULL,59772084530,933938820,14592794,17.6),(136024,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136024,38.36,0.23,470,64560,70,NULL,NULL,'SDSS J161118.77+165601.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,242.82825,16.93375,0.109,NULL,56563764315,883808817,13809512,18.4),(136025,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,136025,36.24,0.25,177,64561,70,NULL,NULL,'GIN 475',NULL,'2001MNRAS.321..277C',2001,1,0.38,NULL,'G',0.000199,NULL,'16.7g',0.31,'S',NULL,NULL,NULL,NULL,1,242.828417,24.182,0.169,NULL,59861255021,935332109,14614564,16.7),(136026,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136026,38.02,0.46,402,64561,70,NULL,NULL,'GIN 475',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136027,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136027,37.02,0.46,253,64562,70,NULL,NULL,'2MASX J16111904-0005396',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000095,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,242.829333333,-0.09439,0.425,NULL,45504636941,711009952,11109530,16.8),(136028,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136028,37.97,0.15,393,64563,70,NULL,NULL,'2MASX J16111906+2103573',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000179,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.829417,21.06606,0.141,NULL,56519773585,883121462,13798772,17.5),(136029,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136029,37.51,0.33,317,64564,70,NULL,NULL,'2MASX J16111953+5329536',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000064,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.831625,53.49817,0,NULL,57605805864,900090716,14063917,17.9),(136030,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136030,37.36,0.11,296,64565,70,NULL,NULL,'2MASX J16112010+3702479',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00017,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.8339583,37.04669,0,NULL,59772228038,933941063,14592829,17.6),(136031,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136031,35.63,0.46,134,64566,70,NULL,NULL,'CGCG 137-054',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000113,NULL,'15.2g',0.53,NULL,NULL,NULL,NULL,NULL,1,242.837458333,22.37522,0.173,NULL,56509660898,882963451,13796303,15.2),(136032,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136032,38.36,0.23,470,64567,70,NULL,NULL,'2MASX J16112116+1656568',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000152,NULL,'16.6g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,242.838083,16.94922,0.109,NULL,56563764684,883808823,13809512,16.6),(136033,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136033,36,0.25,158,64568,74.4,NULL,NULL,'NGC 6075',NULL,'2013AJ....146...86T',2013,1,0.94,NULL,'G',0.00005,NULL,'14.5g',0.74,'E/S0',NULL,NULL,NULL,NULL,1,242.844125,23.965,0.137,NULL,59391596547,927993696,14499901,14.5),(136034,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136034,36.24,0.25,177,64568,70,NULL,NULL,'NGC 6075',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136035,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136035,38.72,0.46,554,64569,70,NULL,NULL,'2MASX J16112256+2215483',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000182,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.84425,22.26333,0.173,NULL,56509637396,882963084,13796298,18.5),(136036,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136036,38.11,0.46,419,64570,70,NULL,NULL,'2MASX J16112316+3201181',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00018,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,242.8465,32.02181,0.057,NULL,59785191201,934143612,14595993,16.9),(136037,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136037,37.9,0.16,381,64571,70,NULL,NULL,'2MASX J16112326+3100041',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.846916667,31.00103,0.069,NULL,59737889032,933404516,14584445,18.2),(136038,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136038,34.85,0.46,93.5,64572,70,NULL,NULL,'CGCG 275-028',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000073,NULL,'15.3g',0.41,'E0','Group member',NULL,NULL,NULL,1,242.8482917,52.45478,0,NULL,59700230355,932816099,14575251,15.3),(136039,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136039,37.97,0.15,393,64573,70,NULL,NULL,'2MASX J16112421+2103113',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000179,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.851,21.05319,0.141,NULL,56519705736,883120402,13798756,18),(136040,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136040,37.79,0.27,362,64574,70,NULL,NULL,'SDSS J161124.48+360329.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000131,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.852,36.05831,0.021,NULL,59771845258,933935082,14592735,18.3),(136041,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136041,37.36,0.11,296,64575,70,NULL,NULL,'2MASX J16112470+3703569',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000176,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,242.852917,37.06583,0,NULL,59772185872,933940404,14592818,17.1),(136042,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136042,37.81,0.19,365,64576,70,NULL,NULL,'2MASX J16112515+1653249',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000138,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.8547083,16.89014,0.109,NULL,56563770462,883808913,13809514,17.9),(136043,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136043,37.52,0.46,320,64577,70,NULL,NULL,'2MASX J16112515+1400239',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.854833,14.00656,0.097,NULL,56555642955,883681921,13807530,16.9),(136044,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136044,37.93,0.33,385,64578,70,NULL,NULL,'2MASX J16112534+1810493',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.855583,18.18039,0.129,NULL,56516468263,883069816,13797965,17.9),(136045,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136045,37.75,0.46,355,64579,70,NULL,NULL,'SDSS J161125.56+220129.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000152,NULL,'19.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,242.8565417,22.02475,0.177,NULL,56509776338,882965255,13796332,19),(136046,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136046,37.95,0.19,389,64580,70,NULL,NULL,'SDSS J161126.13+293416.8',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000152,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,242.858875,29.57136,0.073,NULL,59736616573,933384633,14584134,18.7),(136047,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136047,36.62,0.46,211,64581,70,NULL,NULL,'2MASX J16112689+2757445',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,242.861875,27.96228,0.101,NULL,59740592419,933446756,14585105,16.7),(136048,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136048,36.84,0.16,233,64582,70,NULL,NULL,'2MASX J16112726+2947385',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000162,NULL,'16.6g',0.3,'S0',NULL,NULL,NULL,NULL,1,242.8635,29.79411,0.073,NULL,59738473366,933413646,14584588,16.6),(136049,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136049,37.36,0.11,296,64583,70,NULL,NULL,'KUGX 1609+370A',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000117,NULL,'16.7g',0.31,'Compact',NULL,NULL,NULL,NULL,1,242.868417,36.91911,0.013,NULL,59772087041,933938860,14592794,16.7),(136050,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136050,35.09,0.25,104,64584,74.4,NULL,NULL,'GIN 553',NULL,'2013AJ....146...86T',2013,1,0.45,NULL,'G',0.00015,NULL,'16.0g',0.38,'Sc',NULL,NULL,NULL,NULL,1,242.873125,29.45014,0.081,NULL,59736651191,933385174,14584143,16),(136051,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136051,35.27,0.42,113,64584,70,NULL,NULL,'GIN 553',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136052,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136052,37.21,0.33,277,64585,70,NULL,NULL,'2MASX J16112960+2613345',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000193,NULL,'16.1g',0.41,'E0',NULL,NULL,NULL,NULL,1,242.873417,26.22633,0.121,NULL,59730350782,933286730,14582605,16.1),(136053,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136053,37.98,0.27,394,64586,70,NULL,NULL,'2MASX J16112964+2044163',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.8734583,20.73775,0.101,NULL,56519639958,883119374,13798740,17.7),(136054,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136054,37.36,0.11,296,64587,70,NULL,NULL,'2MASX J16112987+3700008',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,242.8745,37.00025,0,NULL,59772092459,933938944,14592796,17.6),(136055,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136055,37.14,0.33,268,64588,70,NULL,NULL,'2MASX J16113069+0643555',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000175,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.877833,6.73197,0.197,NULL,56461363034,882208797,13784512,17.5),(136056,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136056,35.77,0.4,143,64589,NULL,NULL,'mean','UGC 10256',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000033,NULL,'15.4B',0.2,'Sb',NULL,NULL,NULL,NULL,1,242.87825,23.81161,0.137,NULL,59391568155,927993252,14499894,15.4),(136057,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136057,35.81,0.47,145,64589,NULL,NULL,'H','UGC 10256',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136058,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136058,35.89,0.45,151,64589,NULL,NULL,'K','UGC 10256',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136059,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136059,36.75,0.46,224,64590,70,NULL,NULL,'2MASX J16113152+0518362',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.2g',0.32,NULL,NULL,NULL,NULL,NULL,1,242.881208333,5.31025,0.209,NULL,56491875125,882685548,13791961,16.2),(136060,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136060,37.93,0.33,385,64591,70,NULL,NULL,'2MASX J16113165+1803503',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,242.881917,18.06403,0.089,NULL,56561775244,883777738,13809027,17.4),(136061,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136061,38.69,0.46,546,64592,70,NULL,NULL,'SDSS J161133.05+475129.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000106,NULL,'18.4g',0.09,NULL,NULL,NULL,NULL,NULL,1,242.887708333,47.85808,0.013,NULL,59705538561,932899040,14576547,18.4),(136062,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136062,37.49,0.46,315,64593,70,NULL,NULL,'2MASX J16113339+2634496',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000176,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,242.889167,26.58036,0.069,NULL,59729484339,933273192,14582393,16.8),(136063,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136063,37.21,0.33,277,64594,70,NULL,NULL,'2MASX J16113484+2621146',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000167,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,242.895125,26.35411,0.069,NULL,59729278174,933269971,14582343,16.6),(136064,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136064,35.29,0.46,114,64595,70,NULL,NULL,'2MASX J16113508+1637580',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000093,NULL,'15.4g',0.45,NULL,NULL,NULL,NULL,NULL,1,242.896125,16.63278,0.093,NULL,56563745607,883808525,13809508,15.4),(136065,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136065,37.95,0.19,389,64596,70,NULL,NULL,'SDSS J161135.63+293318.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.8984583,29.55514,0.073,NULL,59736613571,933384587,14584134,18.3),(136066,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136066,35.27,0.42,113,64597,70,NULL,NULL,'GIN 556',NULL,'2001MNRAS.321..277C',2001,1,0.31,NULL,'G',0.000127,NULL,'17.0g',0.26,'E',NULL,NULL,NULL,NULL,1,242.900875,29.49233,0.081,NULL,59736647003,933385109,14584142,17),(136067,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136067,37.95,0.19,389,64597,70,NULL,NULL,'GIN 556',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136068,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136068,36.21,0.46,175,64598,70,NULL,NULL,'2MASX J16113617+5013529',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.00011,NULL,'15.6g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,242.900833,50.2315,0.041,NULL,59709738581,932964665,14577572,15.6),(136069,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:55','1','PS1 SN PS11zv','N',136069,41.29,0.18,1340,64599,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11zv HOST',0.3501,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136070,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136070,37.95,0.19,389,64600,70,NULL,NULL,'2MASX J16113752+2934556',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,242.906125,29.58217,0.073,NULL,59736612943,933384577,14584134,17.5),(136071,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136071,37.95,0.19,389,64601,70,NULL,NULL,'2MASX J16113751+2936136',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00014,NULL,'16.2g',0.41,'E;BrClG',NULL,NULL,NULL,NULL,1,242.90625,29.60383,0.073,NULL,59738461181,933413455,14584585,16.2),(136072,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136072,37.36,0.11,296,64602,70,NULL,NULL,'2MASX J16113807+3657047',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000087,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.908583333,36.95122,0,NULL,59772096253,933939003,14592796,16.7),(136073,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136073,37.14,0.46,267,64603,70,NULL,NULL,'2MASX J16113817+0534264',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,242.909125,5.57408,0.193,NULL,56491976832,882687138,13791986,17.1),(136074,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136074,38.22,0.33,441,64604,70,NULL,NULL,'2MASX J16113827+0851574',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,242.9095,8.86608,0.141,NULL,56582253035,884097703,13814026,18),(136075,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136075,37.36,0.11,296,64605,70,NULL,NULL,'2MASX J16113841+3655447',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000103,NULL,'17.08',0.37,NULL,NULL,NULL,NULL,NULL,1,242.9100417,36.92908,0.013,NULL,59772094159,933938971,14592796,17.08),(136076,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136076,36.72,0.46,221,64606,70,NULL,NULL,'2MASX J16113871+2746276',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,242.911417,27.77439,0.097,NULL,59729117324,933267458,14582304,17.2),(136077,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136077,37.7,0.46,347,64607,70,NULL,NULL,'2MASX J16113911+0933244',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,242.913125,9.55683,0.133,NULL,56586496099,884164001,13815062,17.9),(136078,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136078,37.04,0.46,256,64608,70,NULL,NULL,'2MASX J16113926+3812417',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000117,NULL,'15.9g',0.41,NULL,NULL,NULL,NULL,NULL,1,242.9135417,38.21158,0,NULL,59770662006,933916593,14592446,15.9),(136079,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136079,37.9,0.16,381,64609,70,NULL,NULL,'B2 1609+31',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000166,NULL,'17.0g',0.3,'S',NULL,NULL,'radio jet',NULL,1,242.917667,31.05033,0.069,NULL,59737895585,933404618,14584447,17),(136080,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136080,37.81,0.19,365,64610,70,NULL,NULL,'2MASX J16114040+1653410',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.91825,16.89472,0.109,NULL,56563799409,883809365,13809521,17.4),(136081,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136081,37.9,0.16,381,64611,70,NULL,NULL,'2MASX J16114072+3118145',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.919708333,31.30386,0.069,NULL,59737853691,933403963,14584436,17.8),(136082,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136082,37.11,0.46,264,64612,70,NULL,NULL,'2MASX J16114079+0019334',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00009,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,242.919917,0.32597,0.397,NULL,56447416845,881990888,13781107,16.7),(136083,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136083,36.66,0.46,214,64613,70,NULL,NULL,'2MASX J16114093+4156547',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000127,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,242.920417,41.94842,0,NULL,59807561211,934493143,14601455,16.2),(136084,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136084,37.68,0.33,343,64614,70,NULL,NULL,'2MASX J16114161+1747090',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000184,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,242.9235,17.78594,0.097,NULL,56563901033,883810953,13809546,17.5),(136085,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136085,37.81,0.19,365,64615,70,NULL,NULL,'2MASX J16114284+1655110',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000176,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,242.928375,16.91975,0.109,NULL,56563806919,883809483,13809523,17),(136086,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136086,36.52,0.46,201,64616,70,NULL,NULL,'2MASX J16114380+1414231',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,242.932583,14.23967,0.089,NULL,56555615746,883681496,13807523,16.1),(136087,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136087,37.9,0.16,381,64617,70,NULL,NULL,'2MASX J16114383+3123585',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00018,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,242.932667,31.39969,0.061,NULL,59783217740,934112777,14595512,17),(136088,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136088,37.97,0.15,393,64618,70,NULL,NULL,'2MASX J16114388+2059364',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00018,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,242.932875,20.99339,0.117,NULL,56519740382,883120943,13798764,16.8),(136089,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136089,37.36,0.15,297,64619,70,NULL,NULL,'2MASX J16114692+5216190',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000088,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.9455417,52.272,0.017,NULL,59708413223,932943956,14577249,17.9),(136090,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136090,37.83,0.46,368,64620,70,NULL,NULL,'2MASX J16114751+4344485',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000103,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,242.9480417,43.74686,0,NULL,59805830817,934466106,14601032,16.7),(136091,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136091,37.79,0.27,362,64621,70,NULL,NULL,'2MASX J16114857+3608077',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.952333333,36.13558,0.021,NULL,59771825909,933934779,14592730,17.9),(136092,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136092,37.68,0.33,343,64622,70,NULL,NULL,'2MASX J16114893+1748117',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000134,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.9537083,17.80342,0.097,NULL,56563902796,883810981,13809546,18.3),(136093,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136093,37.97,0.15,393,64623,70,NULL,NULL,'2MASX J16115059+2101134',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000179,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.9607917,21.02036,0.141,NULL,56519750824,883121106,13798767,17.5),(136094,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136094,36.74,0.33,223,64624,70,NULL,NULL,'2MASX J16115103+3002045',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.962667,30.03456,0.061,NULL,59738522287,933414410,14584600,17.2),(136095,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136095,37.97,0.15,393,64625,70,NULL,NULL,'2MASX J16115237+2058044',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000176,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.9682917,20.96781,0.117,NULL,56519752275,883121129,13798767,17.6),(136096,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136096,37.22,0.46,278,64626,70,NULL,NULL,'2MASXi J1611525+140000',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,242.968833333,14.00033,0.097,NULL,56555669051,883682328,13807536,18.1),(136097,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136097,34.62,0.52,83.8,64627,70,NULL,NULL,'2MASX J16115452-1628297',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,242.977083,-16.47497,0.953,NULL,45493035749,710828683,11106698,15),(136098,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136098,37.42,0.46,305,64628,70,NULL,NULL,'2MASX J16115496+2705586',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000175,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,242.978916667,27.09969,0.097,NULL,59729821946,933278467,14582476,17.5),(136099,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136099,35.27,0.42,113,64629,70,NULL,NULL,'UGC 10262 NOTES01',NULL,'2001MNRAS.321..277C',2001,1,0.46,NULL,'G',0.00006,NULL,'15.9g',0.38,'SBab',NULL,NULL,NULL,NULL,1,242.98025,29.82969,0.065,NULL,59738452949,933413327,14584583,15.9),(136100,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136100,36.84,0.16,233,64629,70,NULL,NULL,'UGC 10262 NOTES01',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136101,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136101,36.89,0.25,239,64629,74.4,NULL,NULL,'UGC 10262 NOTES01',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136102,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136102,38.22,0.33,441,64630,70,NULL,NULL,'2MASX J16115535+0852049',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.98075,8.86806,0.149,NULL,56582248166,884097627,13814025,18.5),(136103,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136103,37.95,0.19,389,64631,70,NULL,NULL,'2MASX J16115583+2929256',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000152,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.982625,29.49039,0.073,NULL,59736594277,933384285,14584129,17.8),(136104,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136104,38.65,0.33,538,64632,70,NULL,NULL,'2MASX J16115607+4151567',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.9835417,41.86597,0.009,NULL,59807542570,934492852,14601450,18.1),(136105,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136105,35.08,0.25,104,64633,74.4,NULL,NULL,'GIN 551',NULL,'2013AJ....146...86T',2013,1,0.54,NULL,'G',0.000167,NULL,'15.7g',0.42,'Sb',NULL,NULL,NULL,NULL,1,242.985833,29.45456,0.081,NULL,59736647680,933385120,14584142,15.7),(136106,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136106,35.27,0.42,113,64633,70,NULL,NULL,'GIN 551',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136107,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136107,38.65,0.33,538,64634,70,NULL,NULL,'2MASX J16115661+4155567',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000173,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.986,41.93236,0,NULL,59807561867,934493154,14601455,18.2),(136108,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136108,36.37,0.46,188,64635,70,NULL,NULL,'2MASX J16115668+3944237',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,242.9862917,39.74006,0.009,NULL,59800970034,934390156,14599846,17.2),(136109,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136109,37.97,0.15,393,64636,70,NULL,NULL,'2MASX J16115680+2057004',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000208,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,242.986625,20.95025,0.117,NULL,56519744344,883121005,13798765,16.3),(136110,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136110,37.9,0.16,381,64637,70,NULL,NULL,'2MASX J16115695+3118416',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,242.987166667,31.31164,0.069,NULL,59737788055,933402938,14584420,17.7),(136111,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136111,37.9,0.16,381,64638,70,NULL,NULL,'2MASX J16115726+3106036',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000164,NULL,'16.8g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,242.9887083,31.101,0.069,NULL,59737894528,933404602,14584446,16.8),(136112,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136112,37.81,0.19,365,64639,70,NULL,NULL,'2MASX J16115730+1701177',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.988917,17.02164,0.109,NULL,56563686838,883807606,13809493,17.7),(136113,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136113,37.9,0.16,381,64640,70,NULL,NULL,'2MASX J16115773+3100316',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000148,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.990667,31.00883,0.069,NULL,59737846651,933403853,14584435,17.8),(136114,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136114,37.81,0.19,365,64641,70,NULL,NULL,'2MASX J16115793+1658587',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000172,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,242.991375,16.98289,0.109,NULL,56563805828,883809466,13809522,16.7),(136115,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136115,37.97,0.15,393,64642,70,NULL,NULL,'SDSS J161157.94+205634.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000161,NULL,'18.6g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,242.9914583,20.94303,0.117,NULL,56519744426,883121006,13798765,18.6),(136116,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136116,36.89,0.25,239,64643,74.4,NULL,NULL,'UGC 10262',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000087,NULL,'13.48',0.9,'S0;BrClG',NULL,NULL,NULL,NULL,1,242.99225,29.83856,0.065,NULL,59738452331,933413317,14584583,13.48),(136117,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136117,35.27,0.42,113,64644,70,NULL,NULL,'SDSS J161158.62+295021.8',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'*',NULL,NULL,'25.1g',NULL,'Point Src [SDSS]',NULL,NULL,NULL,NULL,1,242.99425,29.83942,0.065,NULL,59738452322,933413317,14584583,25.1),(136118,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136118,37.97,0.15,393,64645,70,NULL,NULL,'2MASX J16115909+2100124',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000179,NULL,'17.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,242.996166667,21.00344,0.141,NULL,56519753353,883121146,13798767,17.8),(136119,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136119,38.19,0.33,435,64646,70,NULL,NULL,'SDSS J161159.90-000806.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000095,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,242.999583,-0.13508,0.425,NULL,45504767275,711011988,11109562,18.7),(136120,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136120,35.95,0.46,155,64647,70,NULL,NULL,'2MASX J16120028+2033154',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000184,NULL,'15.9g',0.42,NULL,NULL,NULL,NULL,NULL,1,243.0010417,20.55422,0.101,NULL,56520321430,883130022,13798906,15.9),(136121,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136121,37.48,0.46,313,64648,70,NULL,NULL,'2MASX J16120090+3018456',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.0039583,30.31264,0.049,NULL,59738090051,933407657,14584494,17.4),(136122,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136122,36.84,0.16,233,64649,70,NULL,NULL,'2MASX J16120166+2933196',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000185,NULL,'16.5g',0.32,'E',NULL,NULL,NULL,NULL,1,243.006958333,29.55528,0.073,NULL,59736594695,933384292,14584129,16.5),(136123,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136123,37.47,0.46,312,64650,70,NULL,NULL,'2MASX J16120190+3833237',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,243.0079583,38.55653,0.021,NULL,59800584423,934384131,14599752,17.8),(136124,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136124,37.9,0.33,380,64651,70,NULL,NULL,'2MASX J16120195+2515176',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,243.0082083,25.25492,0.157,NULL,59727488824,933242012,14581906,NULL),(136125,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136125,38.07,0.46,412,64652,70,NULL,NULL,'2MASX J16120220+2953236',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000199,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,243.009,29.88981,0.065,NULL,59738453399,933413334,14584583,16.9),(136126,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136126,38.15,0.33,427,64653,70,NULL,NULL,'2MASX J16120461+4014037',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00016,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,243.019333,40.23422,0,NULL,59801388306,934396692,14599948,16.8),(136127,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136127,37.95,0.46,389,64654,70,NULL,NULL,'2MASX J16120491+0033268',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000074,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.020417,0.55739,0.341,NULL,56447328490,881989507,13781086,17.9),(136128,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136128,37.9,0.33,380,64655,70,NULL,NULL,'2MASX J16120500+2517296',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000203,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.020875,25.29164,0.157,NULL,59727490473,933242038,14581906,17.3),(136129,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136129,36.84,0.16,233,64656,70,NULL,NULL,'2MASX J16120536+2932496',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'16.9g',0.26,'E',NULL,NULL,NULL,NULL,1,243.022375,29.54703,0.073,NULL,59736594885,933384295,14584129,16.9),(136130,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136130,38.15,0.33,427,64657,70,NULL,NULL,'2MASX J16120572+4008247',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000174,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,243.023708333,40.14033,0,NULL,59801362407,934396287,14599941,17.7),(136131,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136131,36,0.25,158,64658,74.4,NULL,NULL,'GIN 473',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000057,NULL,'15.11',NULL,'S',NULL,NULL,NULL,NULL,1,243.0247917,23.84133,0.137,NULL,59391572071,927993313,14499895,15.11),(136132,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136132,36.24,0.25,177,64658,70,NULL,NULL,'GIN 473',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136133,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136133,36,0.25,158,64659,74.4,NULL,NULL,'GIN 474',NULL,'2013AJ....146...86T',2013,1,0.49,NULL,'G',0.000057,NULL,'15.9g',0.41,'E/S0',NULL,NULL,NULL,NULL,1,243.032083,23.71814,0.137,NULL,59391495772,927992121,14499876,15.9),(136134,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136134,36.24,0.25,177,64659,70,NULL,NULL,'GIN 474',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136135,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136135,37.02,0.46,253,64660,70,NULL,NULL,'2MASX J16120926+0003328',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000116,NULL,'16.4g',0.34,'AGN',NULL,NULL,NULL,NULL,1,243.0387083,0.05922,0.433,NULL,56447254482,881988351,13781067,16.4),(136136,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136136,36.98,0.27,249,64661,70,NULL,NULL,'2MASX J16120946+3206565',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,243.039375,32.11578,0.057,NULL,59783133776,934111465,14595491,17.8),(136137,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136137,38.12,0.46,421,64662,70,NULL,NULL,'2MASX J16120971+0650559',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00017,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,243.040417,6.84883,0.209,NULL,56460963297,882202551,13784414,17.6),(136138,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136138,37.63,0.46,336,64663,70,NULL,NULL,'2MASX J16121056+4754236',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000099,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,243.044,47.90642,0.009,NULL,59705583972,932899749,14576558,16.3),(136139,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136139,35.27,0.42,113,64664,70,NULL,NULL,'CGCG 167-042',NULL,'2001MNRAS.321..277C',2001,1,0.7,NULL,'G',0.000047,NULL,'14.50',0.7,'Sb',NULL,NULL,NULL,NULL,1,243.046917,29.57411,0.073,NULL,59738433429,933413022,14584578,14.5),(136140,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136140,36.91,0.25,241,64664,74.4,NULL,NULL,'CGCG 167-042',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136141,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136141,36.71,0.46,220,64665,70,NULL,NULL,'2MASX J16121219+1249457',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,243.050875,12.82947,0.133,NULL,56552920585,883639384,13806865,16.5),(136142,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136142,38.05,0.46,407,64666,70,NULL,NULL,'SDSS J161212.21+430953.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,243.050917,43.16483,0,NULL,59805304628,934457884,14600904,17.8),(136143,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136143,36.98,0.27,249,64667,70,NULL,NULL,'2MASX J16121249+3209263',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000168,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.052125,32.15728,0.057,NULL,59783120526,934111258,14595488,16.9),(136144,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136144,36.48,0.46,197,64668,70,NULL,NULL,'2MASX J16121274+1058469',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,243.053083,10.97964,0.173,NULL,56574320930,883973764,13812090,16.4),(136145,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136145,37.55,0.46,323,64669,70,NULL,NULL,'2MASX J16121281+4213096',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00013,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.053208333,42.21925,NULL,NULL,59806650052,934478907,14601232,17.3),(136146,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136146,37.54,0.33,322,64670,70,NULL,NULL,'2MASX J16121352+4015481',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000107,NULL,'16.0g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,243.056375,40.26331,0,NULL,59801388181,934396690,14599948,16),(136147,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136147,37.97,0.15,393,64671,70,NULL,NULL,'2MASX J16121363+2105309',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.05675,21.09192,0.141,NULL,56519696142,883120252,13798753,17.3),(136148,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136148,37.23,0.33,279,64672,70,NULL,NULL,'2MASX J16121365+2412536',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.0570417,24.21494,0.153,NULL,59861152468,935330507,14614539,17.1),(136149,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136149,37.59,0.46,329,64673,70,NULL,NULL,'2MASX J16121385+1713116',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,243.057875,17.21981,0.113,NULL,56563671035,883807359,13809489,17.4),(136150,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136150,36.83,0.56,232,64674,70,NULL,NULL,'2MASX J16121465-0059356',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000104,NULL,'15.8g',0.49,NULL,NULL,NULL,NULL,NULL,1,243.060958333,-0.99317,0.445,NULL,45504380284,711005941,11109467,15.8),(136151,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136151,36.76,0.46,225,64675,70,NULL,NULL,'2MASX J16121470+4831379',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000113,NULL,'15.7g',0.41,'E0',NULL,NULL,NULL,NULL,1,243.0612917,48.52719,0,NULL,59705770188,932902659,14576604,15.7),(136152,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136152,37.56,0.46,326,64676,70,NULL,NULL,'2MASX J16121522+0554278',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,243.063375,5.90781,0.181,NULL,56491108638,882673572,13791774,17.2),(136153,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136153,38.23,0.46,442,64677,70,NULL,NULL,'2MASX J16121537+5234034',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000098,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,243.063875,52.56767,0,NULL,59699772651,932808947,14575139,17.5),(136154,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136154,37.33,0.46,293,64678,70,NULL,NULL,'2MASX J16121555+1722276',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000178,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.064917,17.37428,0.121,NULL,56564122632,883814416,13809600,16.9),(136155,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136155,35.27,0.42,113,64679,70,NULL,NULL,'GIN 549',NULL,'2001MNRAS.321..277C',2001,1,0.36,NULL,'G',0.00006,NULL,'16.4g',0.34,'S              Sy2',NULL,NULL,NULL,'Sy 2',1,243.069666667,29.57306,0.073,NULL,59738437467,933413085,14584579,16.4),(136156,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136156,36.91,0.25,241,64679,74.4,NULL,NULL,'GIN 549',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136157,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136157,37.62,0.46,334,64680,70,NULL,NULL,'2MASX J16121716+3911112',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.071417,39.18636,0,NULL,59800678869,934385607,14599775,17.3),(136158,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136158,37.36,0.11,296,64681,70,NULL,NULL,'2MASXi J1612173+370743',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000165,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,243.0722917,37.12886,0.017,NULL,59772062976,933938484,14592788,17.4),(136159,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136159,37.73,0.46,352,64682,70,NULL,NULL,'2MASX J16121746+2133080',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000147,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.072833,21.55233,0.137,NULL,56508465141,882944767,13796011,17.7),(136160,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136160,36.18,0.46,172,64683,70,NULL,NULL,'2MASX J16121762+2825466',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.0002,NULL,'15.4g',0.56,'E/(S0)',NULL,NULL,NULL,NULL,1,243.0734583,28.42958,0.089,NULL,59741546885,933461670,14585338,15.4),(136161,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136161,35.94,0.23,154,64684,70,NULL,NULL,'MRK 0697',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000117,NULL,'15.5g',0.45,'E',NULL,NULL,NULL,NULL,1,243.075625,29.07933,0.085,NULL,59741286034,933457594,14585274,15.5),(136162,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136162,36.84,0.16,233,64685,70,NULL,NULL,'2MASX J16121839+2932507',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000147,NULL,'16.8g',0.31,'E',NULL,NULL,NULL,NULL,1,243.0765,29.54733,0.073,NULL,59738425355,933412896,14584576,16.8),(136163,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136163,38.19,0.33,435,64686,70,NULL,NULL,'SDSS J161220.14-000925.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000095,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,243.083917,-0.15719,0.425,NULL,45504578278,711009035,11109516,18.7),(136164,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136164,31.86,NULL,23.5,64687,72,NULL,NULL,'AGC 268216',NULL,'2014Ap.....57..457K',2014,1,NULL,NULL,'RadioS',0.000077,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,243.085417,6.53833,0.197,NULL,56461608118,882212626,13784572,NULL),(136165,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136165,37.01,0.46,253,64688,70,NULL,NULL,'2MASX J16122077+0325078',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,243.0865417,3.41883,0.233,NULL,56504975484,882890241,13795160,17),(136166,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136166,35.94,0.23,154,64689,70,NULL,NULL,'2MASX J16122114+2938507',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.0g',0.21,'E',NULL,NULL,NULL,NULL,1,243.088125,29.64744,0.073,NULL,59738438927,933413108,14584579,17),(136167,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136167,37.87,0.27,374,64690,70,NULL,NULL,'2MASX J16122177+1048312',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,243.090583333,10.80872,0.177,NULL,56575955726,883999308,13812489,17.6),(136168,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136168,36.84,0.16,233,64691,70,NULL,NULL,'2MASX J16122183+2952487',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000172,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,243.091125,29.88025,0.065,NULL,59737947023,933405422,14584459,16.4),(136169,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136169,36.24,0.25,177,64692,70,NULL,NULL,'GIN 476',NULL,'2001MNRAS.321..277C',2001,1,0.29,NULL,'G',0.000107,NULL,'17.1g',0.27,'E',NULL,NULL,NULL,NULL,1,243.092583333,24.20722,0.153,NULL,59861145393,935330396,14614537,17.1),(136170,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136170,37.23,0.33,279,64692,70,NULL,NULL,'GIN 476',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136171,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136171,38.35,0.46,468,64693,70,NULL,NULL,'2MASX J16122250+1833560',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.09375,18.56561,0.113,NULL,56517685835,883088841,13798263,17.6),(136172,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136172,36.03,0.46,160,64694,70,NULL,NULL,'2MASX J16122266+5258275',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000093,NULL,'16.0g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,243.09425,52.97442,0,NULL,59699882375,932810662,14575166,16),(136173,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136173,36.98,0.27,249,64695,70,NULL,NULL,'2MASX J16122384+3204154',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00019,NULL,'15.8g',0.48,'E0',NULL,NULL,NULL,NULL,1,243.0992917,32.07103,0.057,NULL,59783132702,934111448,14595491,15.8),(136174,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136174,38.04,0.46,406,64696,70,NULL,NULL,'2MASX J16122570+4033202',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00017,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,243.107166667,40.55561,0,NULL,59799554395,934368037,14599500,17),(136175,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136175,38.22,0.46,441,64697,70,NULL,NULL,'SDSS J161226.17+501923.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000081,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,243.1090417,50.32331,0.021,NULL,59709808768,932965762,14577590,18.3),(136176,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136176,33.79,NULL,57.3,64698,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10274',NULL,'2010Ap&SS.325..163P',2010,1,1.61,NULL,'G',0.000041,NULL,'15.8g',0.21,'Scd',NULL,NULL,NULL,NULL,1,243.111291667,38.24292,0.009,NULL,59770625341,933916020,14592437,15.8),(136177,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136177,33.8,NULL,57.7,64698,NULL,NULL,'Dipole + Quadrupole','UGC 10274',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136178,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136178,33.81,NULL,57.7,64698,NULL,NULL,'Dipole','UGC 10274',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136179,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136179,33.88,NULL,59.6,64698,NULL,NULL,NULL,'UGC 10274',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136180,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136180,34.18,0.2,68.6,64698,74.4,NULL,NULL,'UGC 10274',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136181,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136181,37.5,0.46,316,64699,70,NULL,NULL,'SDSS J161226.87+414015.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000133,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,243.1120417,41.67097,0.009,NULL,59807577247,934493394,14601459,18.2),(136182,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136182,36.36,0.46,187,64700,70,NULL,NULL,'2MASX J16122736+1251381',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,243.114167,12.86053,0.133,NULL,56552921265,883639394,13806865,16.3),(136183,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136183,35.98,0.46,157,64701,70,NULL,NULL,'2MASX J16122767+0605402',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000184,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,243.115375,6.09467,0.189,NULL,56460711175,882198612,13784353,16.2),(136184,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136184,37.54,0.33,322,64702,70,NULL,NULL,'2MASX J16122960+4008313',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.1234583,40.14186,0,NULL,59801583862,934399747,14599996,17.4),(136185,'BCG','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136185,36.17,0.35,166,64703,60,NULL,NULL,'ABELL 2162',0.0318,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III [BM]',NULL,NULL,NULL,NULL,1,243.124958333,29.53978,0.073,NULL,59738425842,933412903,14584576,NULL),(136186,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136186,37.69,0.46,345,64704,70,NULL,NULL,'2MASX J16123046+1919050',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,243.127167,19.31806,0.129,NULL,56517409538,883084524,13798195,17.3),(136187,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136187,37.28,0.46,286,64705,70,NULL,NULL,'2MASX J16123049+2801137',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000174,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.127167,28.02053,0.097,NULL,59741462813,933460356,14585318,17.8),(136188,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136188,38.23,0.46,442,64706,70,NULL,NULL,'2MASX J16123164+0809032',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,243.132,8.15106,0.181,NULL,56462532556,882227071,13784797,18),(136189,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136189,37.45,0.46,309,64707,70,NULL,NULL,'SDSS J161232.38+220317.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,243.134916667,22.05492,0.117,NULL,56509256754,882957136,13796205,17.6),(136190,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136190,37.87,0.27,374,64708,70,NULL,NULL,'2MASX J16123257+1100152',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,243.1357083,11.00422,0.173,NULL,56574315123,883973673,13812088,17.2),(136191,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136191,37.97,0.15,393,64709,70,NULL,NULL,'SDSS J161233.83+205833.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'18.0g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,243.1409583,20.97603,0.141,NULL,56520219182,883128424,13798881,18),(136192,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136192,37.5,0.46,316,64710,70,NULL,NULL,'2MASX J16123500+3806413',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000148,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,243.145625,38.11164,0.009,NULL,59770621712,933915964,14592436,17.5),(136193,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136193,35.64,0.47,134,64711,NULL,NULL,'H','NGC 6085',NULL,'2007A&A...465...71T',2007,1,1.49,NULL,'G',0.000077,NULL,'13.9g',1.04,'Sa','Group member',NULL,NULL,NULL,1,243.14675,29.36508,0.081,NULL,59741059338,933454052,14585219,13.9),(136194,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136194,35.71,0.45,139,64711,NULL,NULL,'K','NGC 6085',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136195,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136195,35.75,0.46,141,64711,NULL,NULL,'J','NGC 6085',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136196,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136196,35.79,0.4,144,64711,NULL,NULL,'mean','NGC 6085',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136197,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136197,37.31,0.46,289,64712,70,NULL,NULL,'2MASX J16123544+1138372',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,243.147666667,11.64356,0.201,NULL,56574809164,883981393,13812209,16.8),(136198,'BCG','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136198,36.17,0.35,166,64713,60,NULL,'ABELL 2162, BCG','NGC 6086',0.0318,'1980ApJ...241..486H',1980,1,1.7,NULL,'G',0.000083,NULL,'13.79',1.2,'cD;E','Group member',NULL,NULL,NULL,1,243.1480417,29.48478,0.073,NULL,59736591700,933384245,14584128,13.79),(136199,'D-Sigma','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136199,35.49,0.4,126,64713,75,NULL,'Edat, raw','NGC 6086',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136200,'D-Sigma','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136200,35.83,0.4,147,64713,75,NULL,'Edat, cor','NGC 6086',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136201,'Faber-Jackson','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136201,35.13,0.55,106,64713,95,NULL,'Weighted Mean','NGC 6086',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136202,'Faber-Jackson','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136202,35.13,0.55,106,64713,95,NULL,'de Vaucouleurs','NGC 6086',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136203,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136203,35.08,0.25,104,64713,74.4,NULL,NULL,'NGC 6086',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136204,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136204,35.27,0.42,113,64713,70,NULL,NULL,'NGC 6086',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136205,'Tertiary','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136205,34.9,0.5,95.5,64713,95,NULL,NULL,'NGC 6086',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136206,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136206,35.75,0.4,141,64713,NULL,NULL,'mean','NGC 6086',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136207,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136207,35.94,0.45,154,64713,NULL,NULL,'K','NGC 6086',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136208,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136208,37.36,0.11,296,64714,70,NULL,NULL,'2MASX J16123622+3654083',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000178,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,243.151083,36.90239,0.009,NULL,59772048150,933938252,14592785,17),(136209,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136209,37.98,0.27,394,64715,70,NULL,NULL,'2MASX J16123674+2046317',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000141,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,243.1529583,20.77542,0.117,NULL,56520257490,883129023,13798890,18.1),(136210,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136210,37.35,0.46,295,64716,70,NULL,NULL,'2MASX J16123707+2008267',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000179,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.154375,20.14067,0.129,NULL,56519925247,883123831,13798809,16.9),(136211,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136211,34.95,0.46,97.8,64717,70,NULL,NULL,'2MASX J16123720+3925083',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.00008,NULL,'15.5g',0.48,'S0/a',NULL,NULL,NULL,NULL,1,243.1550417,39.41903,0.005,NULL,59800617536,934384649,14599760,15.5),(136212,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136212,37.11,0.46,265,64718,70,NULL,NULL,'2MASX J16123868+1340181',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.161125,13.67175,0.097,NULL,56555080337,883673130,13807392,17.4),(136213,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136213,35.08,0.25,104,64719,74.4,NULL,NULL,'CGCG 167-046',NULL,'2013AJ....146...86T',2013,1,0.78,NULL,'G',0.00013,NULL,'15.1g',0.46,'S0/a',NULL,NULL,NULL,NULL,1,243.161875,29.64361,0.073,NULL,59737908251,933404816,14584450,15.1),(136214,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136214,35.27,0.42,113,64719,70,NULL,NULL,'CGCG 167-046',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136215,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136215,35.94,0.23,154,64719,70,NULL,NULL,'CGCG 167-046',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136216,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136216,39.15,0.46,676,64720,70,NULL,NULL,'SDSS J161239.27+370835.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000165,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,243.163667,37.14317,0.017,NULL,59772930938,933952045,14593000,18.6),(136217,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136217,36.38,0.46,189,64721,70,NULL,NULL,'2MASX J16124183+0438531',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,243.17425,4.64794,0.213,NULL,56502850895,882857045,13794641,16.8),(136218,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136218,37.87,0.27,374,64722,70,NULL,NULL,'2MASX J16124238+1053436',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,243.176625,10.89542,0.173,NULL,56575954172,883999283,13812488,NULL),(136219,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136219,36.74,0.33,223,64723,70,NULL,NULL,'SDSS J161242.69+295404.7',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',NULL,NULL,'15.6g',0.48,'E0',NULL,NULL,NULL,NULL,1,243.177917,29.90133,0.061,NULL,59737942763,933405355,14584458,15.6),(136220,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136220,35.59,0.46,131,64724,70,NULL,NULL,'2MASX J16124302+0844396',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,243.1792083,8.74431,0.149,NULL,56461672433,882213631,13784587,16.2),(136221,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136221,37.93,0.46,385,64725,70,NULL,NULL,'2MASX J16124354+2911505',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.181583333,29.19753,0.085,NULL,59741109008,933454828,14585231,17.7),(136222,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136222,37.37,0.46,298,64726,70,NULL,NULL,'2MASX J16124501+4937495',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000081,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.187583333,49.63033,0.009,NULL,59703037280,932859957,14575936,17.1),(136223,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136223,37.13,0.13,267,64727,70,NULL,NULL,'2MASX J16124609+4905536',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000098,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,243.192125,49.09828,0.017,NULL,59705095489,932892117,14576439,16.2),(136224,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136224,38.07,0.46,410,64728,70,NULL,NULL,'2MASX J16124682+2656125',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.19525,26.93675,0.069,NULL,59729785556,933277899,14582467,17.6),(136225,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136225,34.86,0.46,93.9,64729,70,NULL,NULL,'UGC 10275',NULL,'2015arXiv151105856S',2015,1,1.12,'NGC 6092 is a double star.','G',0.000103,NULL,'14.3g',0.83,'E',NULL,NULL,NULL,NULL,1,243.1955417,27.98733,0.113,NULL,59740951919,933452373,14585193,14.3),(136226,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136226,37.36,0.11,296,64730,70,NULL,NULL,'2MASX J16124761+3653496',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000107,NULL,'16.98',0.4,NULL,NULL,NULL,NULL,NULL,1,243.198333,36.89711,0.009,NULL,59772907163,933951674,14592994,16.98),(136227,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136227,37.91,0.33,381,64731,70,NULL,NULL,'2MASX J16124798+1625411',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000181,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,243.199833,16.42822,0.145,NULL,56545044894,883516326,13804942,16.9),(136228,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136228,37.32,0.46,291,64732,70,NULL,NULL,'2MASX J16124796+1339121',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,'PHOT','16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,243.199875,13.65342,0.097,NULL,56555092391,883673318,13807395,16.8),(136229,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136229,36.76,0.46,225,64733,70,NULL,NULL,'2MASX J16124884+2551525',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000198,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,243.2035417,25.86464,0.137,NULL,59727628774,933244199,14581940,16.4),(136230,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136230,37.98,0.27,394,64734,70,NULL,NULL,'2MASX J16124893+2038117',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,243.20375,20.63658,0.137,NULL,56520287265,883129488,13798898,18.1),(136231,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136231,34.82,NULL,92,64735,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10276',NULL,'2010Ap&SS.325..163P',2010,1,1.4,NULL,'G',0.000009,NULL,'15.5g',0.27,'Sbc',NULL,NULL,NULL,NULL,1,243.2044583,31.99314,0.057,NULL,59783307422,934114178,14595534,15.5),(136232,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136232,34.82,NULL,92.2,64735,NULL,NULL,'Dipole + Quadrupole','UGC 10276',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136233,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136233,34.84,NULL,93,64735,NULL,NULL,'Dipole','UGC 10276',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136234,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136234,34.87,NULL,94.1,64735,NULL,NULL,NULL,'UGC 10276',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136235,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136235,35.03,0.49,102,64735,75,NULL,'IR','UGC 10276',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136236,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136236,37.91,0.33,381,64736,70,NULL,NULL,'2MASX J16124923+1626321',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,243.205167,16.44219,0.145,NULL,56544990918,883515483,13804929,18.6),(136237,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136237,37.75,0.46,354,64737,70,NULL,NULL,'2MASX J16124961+1244431',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,243.206667,12.74547,0.153,NULL,56541460211,883460315,13804067,18.2),(136238,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136238,35.96,0.33,156,64738,70,NULL,NULL,'CGCG 079-077',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.00015,NULL,'15.3',0.57,NULL,NULL,NULL,NULL,NULL,1,243.208083333,11.15981,0.169,NULL,56574192901,883971764,13812058,15.3),(136239,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136239,36.35,0.33,186,64739,70,NULL,NULL,'2MASXi J1612505+375832',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000178,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,243.2105417,37.9755,0.009,NULL,59772602701,933946917,14592920,17.3),(136240,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136240,36.76,0.46,225,64740,70,NULL,NULL,'2MASX J16125083+1653092',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000171,NULL,'15.8g',0.32,'E',NULL,NULL,NULL,NULL,1,243.211875,16.88597,0.137,NULL,56563627996,883806687,13809479,15.8),(136241,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136241,35.62,0.46,133,64741,70,NULL,NULL,'CGCG 051-065 NED01',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000167,NULL,'16.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,243.2130417,6.0625,0.145,NULL,56460734207,882198971,13784358,16),(136242,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136242,38.87,0.46,594,64742,70,NULL,NULL,'2MASX J16125281+2223087',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000191,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.220041667,22.38583,0.125,NULL,56509324386,882958193,13796221,18),(136243,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2007ai',NULL,136243,35.09,0.19,101,64743,74.2,NULL,'SALT 2','ESO 584- G 007',0.031662,'2010ApJ...716..712A',2010,1,1.7,NULL,'G',0.000137,NULL,'15',1.6,'Sc             HII',NULL,NULL,NULL,NULL,1,243.222333,-21.62333,0.629,NULL,45434578186,709915284,11092426,15),(136244,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2007ai',NULL,136244,35.37,0.08,111,64743,72,NULL,NULL,'ESO 584- G 007',0.03201,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136245,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2007ai',NULL,136245,35.4,0.04,120,64743,72,NULL,'M(H) = -18.317 mag','ESO 584- G 007',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136246,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2007ai',NULL,136246,35.65,0.17,131,64743,70,NULL,'SALT 2','ESO 584- G 007',0.031662,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136247,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2007ai',NULL,136247,35.65,0.04,131,64743,72,NULL,'SALT2','ESO 584- G 007',0.031662,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136248,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2007ai',NULL,136248,35.63,0.09,134,64743,74.4,NULL,NULL,'ESO 584- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136249,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2007ai',NULL,136249,35.71,0.24,134,64743,73.8,NULL,'SALT 2 (SNANA)','ESO 584- G 007',0.0324,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136250,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2007ai',NULL,136250,35.9,0.22,146,64743,73.8,NULL,'SALT 2 (SNANA)','ESO 584- G 007',0.0324,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136251,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2007ai',NULL,136251,35.91,0.2,148,64743,65,NULL,'SALT2','ESO 584- G 007',0.031662,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136252,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2007ai',NULL,136252,35.96,0.2,151,64743,65,NULL,'MLCS31','ESO 584- G 007',0.031662,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136253,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2007ai',NULL,136253,35.99,0.18,153,64743,65,NULL,'MLCS17','ESO 584- G 007',0.031662,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136254,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2007ai',NULL,136254,36.01,0.17,154,64743,65,NULL,'SALT','ESO 584- G 007',0.031662,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136255,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136255,35.94,0.23,154,64744,70,NULL,NULL,'2MASX J16125369+2919105',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000143,NULL,'16.9g',0.22,'E',NULL,NULL,NULL,NULL,1,243.223667,29.31978,0.081,NULL,59741056116,933454001,14585218,16.9),(136256,'SNII optical','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2009kf',NULL,136256,40.63,0.5,1340,64745,NULL,NULL,NULL,'SDSS J161254.19+553814.4',NULL,'2010ApJ...717L..52B',2010,1,0.09,NULL,'G',NULL,NULL,'20.3g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,243.225791667,55.63733,0,NULL,57608959210,900139987,14064687,20.3),(136257,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136257,35.96,0.33,156,64746,70,NULL,NULL,'2MASX J16125501+1104576',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.3g',0.4,NULL,NULL,NULL,NULL,NULL,1,243.22925,11.08264,0.169,NULL,56574196958,883971827,13812059,16.3),(136258,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136258,37.7,0.46,347,64747,70,NULL,NULL,'2MASX J16125615+1219552',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,243.234125,12.332,0.145,NULL,56541409455,883459522,13804055,17.7),(136259,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136259,34.67,0.73,85.8,64748,70,NULL,NULL,'UGC 10264',NULL,'2014MNRAS.445.2677S',2014,1,1.27,NULL,'G',0.000089,NULL,'14.6g',0.69,'SAB(s)cd:      HII','Group member',NULL,NULL,NULL,1,243.236791667,-0.09625,0.433,NULL,45504538015,711008406,11109506,14.6),(136260,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136260,35.71,0.4,139,64748,NULL,NULL,'mean','UGC 10264',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136261,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136261,35.72,0.47,140,64748,NULL,NULL,'H','UGC 10264',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136262,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136262,35.87,0.45,149,64748,NULL,NULL,'K','UGC 10264',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136263,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136263,35.94,0.46,155,64748,NULL,NULL,'J','UGC 10264',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136264,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136264,36.32,0.25,184,64749,70,NULL,NULL,'GIN 545',NULL,'2001MNRAS.321..277C',2001,1,0.57,NULL,'G',0.00009,NULL,'14.30',0.44,'E/S0',NULL,NULL,NULL,NULL,1,243.237333,30.77072,0.053,NULL,59738389244,933412331,14584567,14.3),(136265,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136265,36.93,0.19,243,64749,70,NULL,NULL,'GIN 545',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136266,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136266,34.5,0.2,79.4,64750,74.4,NULL,NULL,'UGC 10282',NULL,'2013AJ....146...86T',2013,1,0.99,'Listed in CGCG special map in vol III, p 87 (SM1-003).','G',0.000013,NULL,'15.0g',0.63,'SA(s)c',NULL,NULL,NULL,NULL,1,243.2399583,32.51244,0.037,NULL,59784719357,934136239,14595878,15),(136267,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136267,34.5,0.61,79.5,64750,NULL,NULL,'Malmquist cor.','UGC 10282',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136268,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136268,34.52,0.61,80.1,64750,NULL,NULL,NULL,'UGC 10282',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136269,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136269,37.66,0.46,340,64751,70,NULL,NULL,'2MASX J16125818+1416172',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,243.242375,14.27153,0.081,NULL,56555775030,883683984,13807562,17.6),(136270,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136270,36.93,0.46,243,64752,70,NULL,NULL,'2MASX J16125874+0649296',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000171,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,243.244708333,6.82478,0.209,NULL,56461001409,882203147,13784424,16.7),(136271,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136271,36.84,0.16,233,64753,70,NULL,NULL,'SDSS J161259.02+294253.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000167,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,243.245916667,29.71475,0.065,NULL,59737911329,933404864,14584451,17.7),(136272,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136272,34.83,0.2,92.5,64754,74.4,NULL,NULL,'SDSS J161259.92+305022.0',NULL,'2013AJ....146...86T',2013,1,0.55,NULL,'G',0.000011,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.249666667,30.83944,0.053,NULL,59738377101,933412142,14584564,16.8),(136273,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136273,36.37,0.46,188,64755,70,NULL,NULL,'2MASX J16130101+4421358',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00018,NULL,'15.8g',0.38,'SABa',NULL,NULL,NULL,NULL,1,243.254083,44.36,NULL,NULL,59848823075,935137860,14611529,15.8),(136274,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136274,37.6,0.46,332,64756,70,NULL,NULL,'2MASX J16130113+5057494',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000076,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.2547917,50.96386,0.013,NULL,59710076571,932969946,14577655,17.2),(136275,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136275,36.93,0.19,243,64757,70,NULL,NULL,'SDSS J161303.11+305459.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000169,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,243.263,30.91661,0.053,NULL,59738322421,933411287,14584551,17.8),(136276,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136276,36.93,0.19,243,64758,70,NULL,NULL,'2MASX J16130327+3103560',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.2637917,31.06544,0.057,NULL,59737821727,933403464,14584429,16.7),(136277,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136277,36.32,0.25,184,64759,70,NULL,NULL,'GIN 542',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.000067,NULL,'14.10',NULL,'E/S0',NULL,NULL,NULL,NULL,1,243.267375,30.90011,0.053,NULL,59738324030,933411312,14584551,14.1),(136278,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136278,37.06,0.33,258,64760,70,NULL,NULL,'2MASX J16130436+2957119',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000168,NULL,'16.8g',0.23,'AGN',NULL,NULL,NULL,NULL,1,243.268083,29.95344,0.061,NULL,59738116118,933408064,14584501,16.8),(136279,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136279,37.06,0.33,258,64761,70,NULL,NULL,'2MASX J16130482+2957339',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,'PHOT','17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.270333,29.9595,0.061,NULL,59738144912,933408514,14584508,17.3),(136280,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136280,36.15,0.25,170,64762,74.4,NULL,NULL,'CGCG 167-050 NED01',NULL,'2013AJ....146...86T',2013,1,0.84,NULL,'G',0.000093,NULL,'14.8g',0.58,'E/S0',NULL,NULL,NULL,NULL,1,243.270625,30.90169,0.053,NULL,59738324011,933411312,14584551,14.8),(136281,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136281,36.32,0.25,184,64762,70,NULL,NULL,'CGCG 167-050 NED01',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136282,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136282,37.01,0.46,252,64763,70,NULL,NULL,'2MASX J16130560+3606307',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00009,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,243.27325,36.10856,0.021,NULL,59771939632,933936556,14592758,17),(136283,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136283,36.84,0.46,233,64764,70,NULL,NULL,'2MASX J16130589+4950175',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000097,NULL,'16.0g',0.35,'S0',NULL,NULL,NULL,NULL,1,243.274417,49.83814,0.009,NULL,59709591878,932962373,14577537,16),(136284,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136284,38.13,0.46,423,64765,70,NULL,NULL,'2MASX J16130655+2203577',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000176,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,243.2772083,22.06611,0.121,NULL,56508125964,882939468,13795929,18.1),(136285,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136285,37.9,0.46,380,64766,70,NULL,NULL,'SDSS J161307.16+424642.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000137,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,243.279875,42.77858,NULL,NULL,59805481341,934460645,14600947,18.2),(136286,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136286,37.53,0.27,320,64767,70,NULL,NULL,'SDSS J161307.24+311632.7',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.7g',0.31,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,243.2802083,31.27578,0.053,NULL,59737772580,933402696,14584417,16.7),(136287,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136287,36.15,0.25,170,64768,74.4,NULL,NULL,'UGC 10283',NULL,'2013AJ....146...86T',2013,1,1.01,NULL,'G',0.000103,NULL,'14.9g',0.56,'E/S0','Group member',NULL,NULL,NULL,1,243.287,30.82703,0.053,NULL,59738387492,933412304,14584567,14.9),(136288,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136288,36.32,0.25,184,64768,70,NULL,NULL,'UGC 10283',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136289,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136289,36.58,0.46,207,64769,70,NULL,NULL,'2MASX J16130926+1516153',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00007,NULL,'16.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.2885417,15.27097,0.089,NULL,56544944089,883514751,13804917,16.6),(136290,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136290,36.68,0.33,217,64770,70,NULL,NULL,'2MASX J16130951+2851403',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,243.289666667,28.86114,0.085,NULL,59741199724,933456245,14585253,16.9),(136291,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136291,37.57,0.46,327,64771,70,NULL,NULL,'2MASX J16131056+2310097',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000183,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,243.294125,23.16947,0.169,NULL,56506566479,882915101,13795548,17.2),(136292,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136292,38.85,0.46,588,64772,70,NULL,NULL,'SDSS J161310.62+122548.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,243.294291667,12.43011,0.145,NULL,56541399464,883459366,13804052,17.9),(136293,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136293,36.2,0.46,173,64773,70,NULL,NULL,'2MASX J16131101+2053447',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000189,NULL,'16.1g',0.29,'AGN',NULL,NULL,NULL,NULL,1,243.295916667,20.89567,0.141,NULL,56519389147,883115455,13798678,16.1),(136294,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136294,37.52,0.46,318,64774,70,NULL,NULL,'2MASX J16131120+2106167',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,243.296667,21.10461,0.145,NULL,56519362650,883115041,13798672,17.8),(136295,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136295,36.14,0.46,169,64775,70,NULL,NULL,'2MASX J16131174+1820508',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000117,NULL,'15.0',NULL,'E',NULL,NULL,NULL,NULL,1,243.298875,18.3475,0.105,NULL,56514619908,883040936,13797514,15),(136296,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136296,37.88,0.33,377,64776,70,NULL,NULL,'2MASX J16131201+3128309',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,243.3000417,31.47525,0.053,NULL,59783112000,934111125,14595486,17.5),(136297,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136297,36.68,0.33,217,64777,70,NULL,NULL,'2MASX J16131234+2845523',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,243.301417,28.76442,0.089,NULL,59741228165,933456690,14585260,16.7),(136298,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136298,38.36,0.46,471,64778,70,NULL,NULL,'2MASX J16131359+3224299',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000199,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,243.306583,32.40828,0.037,NULL,59782828466,934106694,14595417,17.3),(136299,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136299,36.15,0.25,170,64779,74.4,NULL,NULL,'UGC 10285',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000073,NULL,'14.35',0.7,'E/S0','Group member',NULL,NULL,NULL,1,243.31175,30.90253,0.053,NULL,59738324349,933411317,14584551,14.35),(136300,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136300,36.32,0.25,184,64779,70,NULL,NULL,'UGC 10285',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136301,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136301,36.93,0.19,243,64780,70,NULL,NULL,'2MASX J16131508+3058369',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000144,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,243.31275,30.97689,0.057,NULL,59738320859,933411263,14584550,17.3),(136302,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136302,35.28,0.49,114,64781,75,NULL,'IR','UGC 10289',NULL,'2011yCatp016004901K',2011,1,0.93,'Springob et al. (2005ApJS..160..149S) give v= 5918 km/sec.','G',0.000081,NULL,'16.3g',0.25,'Sb(f)',NULL,NULL,NULL,NULL,1,243.314,48.23497,0.005,NULL,59705591862,932899872,14576560,16.3),(136303,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136303,37.35,0.46,295,64782,70,NULL,NULL,'2MASX J16131668+1801048',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,243.319417,18.01808,0.089,NULL,56560678938,883760608,13808759,16.8),(136304,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136304,35.15,0.53,107,64783,70,NULL,NULL,'2MASX J16131698-7728487',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,243.3204583,-77.48022,0.473,NULL,44262731607,691605181,10806330,16),(136305,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136305,37.3,0.46,289,64784,70,NULL,NULL,'SDSS J161317.46+495746.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000086,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,243.32275,49.96292,0.017,NULL,59709614917,932962733,14577542,17.7),(136306,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136306,37.37,0.46,298,64785,70,NULL,NULL,'2MASX J16131784+2833003',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,243.32425,28.55,0.097,NULL,59741365213,933458831,14585294,17.3),(136307,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136307,36.54,0.56,204,64786,70,NULL,NULL,'2MASX J16131902-0112563',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.0001,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,243.329291667,-1.21569,0.465,NULL,45507930305,711061411,11110334,16.3),(136308,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136308,38.39,0.46,477,64787,70,NULL,NULL,'SDSS J161320.06+462951.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000158,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,243.333625,46.49758,0.013,NULL,59831925657,934873838,14607403,18.6),(136309,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136309,37.13,0.13,267,64788,70,NULL,NULL,'2MASX J16132091+4908176',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000067,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.337083,49.13814,0,NULL,59705082040,932891906,14576436,17.6),(136310,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136310,37.55,0.46,324,64789,70,NULL,NULL,'2MASX J16132089+4137276',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000148,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.337167,41.62456,NULL,NULL,59806759311,934480614,14601259,17.6),(136311,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136311,37.53,0.27,320,64790,70,NULL,NULL,'2MASX J16132096+3116265',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000145,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,243.337458333,31.27408,0.053,NULL,59783062745,934110355,14595474,16.8),(136312,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136312,37.53,0.27,320,64791,70,NULL,NULL,'2MASX J16132213+3117405',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.3422917,31.29453,0.053,NULL,59783062592,934110353,14595474,17.4),(136313,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136313,36.74,0.54,223,64792,70,NULL,NULL,'2MASX J16132255-0112322',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.68',NULL,NULL,NULL,NULL,NULL,NULL,1,243.343875,-1.20917,0.445,NULL,45507876084,711060563,11110321,16.68),(136314,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136314,38.51,0.46,503,64793,70,NULL,NULL,'2MASX J16132264+5037576',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000086,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.344125,50.63272,0.021,NULL,59710082129,932970033,14577656,17.7),(136315,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136315,37.36,0.11,296,64794,70,NULL,NULL,'2MASX J16132295+3729499',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,243.345583,37.49719,0.009,NULL,59772865415,933951022,14592984,17.9),(136316,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136316,36.43,0.46,193,64795,70,NULL,NULL,'2MASX J16132364+4827566',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000092,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,243.348333,48.46583,0,NULL,59705774233,932902722,14576605,16.4),(136317,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136317,37.06,0.33,259,64796,70,NULL,NULL,'SDSS J161324.10+273510.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,243.350417,27.58617,0.101,NULL,59729622874,933275357,14582427,18.1),(136318,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136318,38.09,0.46,415,64797,70,NULL,NULL,'2MASX J16132410+5319306',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000094,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,243.35075,53.32528,0.005,NULL,57605656277,900088379,14063880,17.4),(136319,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136319,37.54,0.46,323,64798,70,NULL,NULL,'2MASX J16132454+3825260',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000182,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,243.352208333,38.42397,0.009,NULL,59770412169,933912690,14592385,17.4),(136320,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136320,36.32,0.25,184,64799,70,NULL,NULL,'KUG 1611+307',NULL,'2001MNRAS.321..277C',2001,1,0.48,NULL,'G',0.000161,NULL,'16.0g',0.39,'S',NULL,NULL,NULL,NULL,1,243.353291667,30.59972,0.053,NULL,59738408774,933412637,14584572,16),(136321,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136321,35.16,0.51,108,64800,NULL,NULL,NULL,'UGC 10286',NULL,'2009ApJS..182..474S',2009,1,1.23,'Listed in CGCG special map in vol III, p 87 (SM1-004).','G',0.000033,NULL,'15.8g',0.25,'Scd:',NULL,NULL,NULL,NULL,1,243.35625,32.28581,0.045,NULL,59782853054,934107078,14595423,15.8),(136322,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136322,35.17,0.2,108,64800,74.4,NULL,NULL,'UGC 10286',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136323,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136323,35.47,0.44,124,64800,NULL,NULL,'Malmquist cor.','UGC 10286',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136324,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136324,34.72,0.46,88,64801,70,NULL,NULL,'CGCG 137-063',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.000097,NULL,'15.0g',0.37,NULL,NULL,NULL,NULL,NULL,1,243.356583,21.90942,0.117,NULL,56508115479,882939304,13795926,15),(136325,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136325,37.84,0.46,370,64802,70,NULL,NULL,'SDSS J161326.79+174216.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,243.361625,17.70456,0.113,NULL,56560548626,883758572,13808727,18.3),(136326,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136326,37.22,0.46,278,64803,70,NULL,NULL,'2MASX J16132688+3119196',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.361917,31.32225,0.053,NULL,59783069262,934110457,14595475,17.1),(136327,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136327,36.2,0.46,173,64804,70,NULL,NULL,'2MASX J16132722+4425429',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000147,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,243.363625,44.42858,0,NULL,59848837119,935138079,14611532,16.8),(136328,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136328,36.93,0.19,243,64805,70,NULL,NULL,'2MASX J16132809+3105146',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,243.3669583,31.08733,0.057,NULL,59738299672,933410932,14584545,17.2),(136329,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136329,36.84,0.46,234,64806,70,NULL,NULL,'2MASX J16132833+2304088',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000189,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,243.368125,23.06919,0.169,NULL,56506283622,882910681,13795479,16.2),(136330,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136330,37.06,0.33,259,64807,70,NULL,NULL,'2MASX J16132937+2726153',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000159,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,243.372417,27.43758,0.101,NULL,59729762634,933277541,14582461,16.8),(136331,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136331,37.64,0.46,337,64808,70,NULL,NULL,'2MASX J16133007+2908363',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.0002,NULL,'16.2g',0.31,'BrClG;Sa',NULL,NULL,NULL,NULL,1,243.3752917,29.14339,0.085,NULL,59743171830,933487059,14585735,16.2),(136332,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136332,37.88,0.33,377,64809,70,NULL,NULL,'2MASX J16133162+3130116',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,243.38175,31.50319,0.053,NULL,59783077991,934110593,14595478,17.5),(136333,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136333,35.58,0.61,130,64810,70,NULL,NULL,'2MASX J16133441-1503253',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,243.393375,-15.05706,0.917,NULL,45462333872,710348966,11099202,15.1),(136334,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136334,37.56,0.46,325,64811,70,NULL,NULL,'2MASX J16133466+3238276',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000189,NULL,'16.3g',0.41,NULL,NULL,NULL,NULL,NULL,1,243.394541667,32.64092,0.029,NULL,59784773962,934137093,14595892,16.3),(136335,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136335,37.13,0.13,267,64812,70,NULL,NULL,'SDSS J161334.99+490723.8',NULL,'2015arXiv151105856S',2015,1,0.11,NULL,'G',0.0001,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,243.395833,49.12328,0,NULL,59703133138,932861455,14575960,18.6),(136336,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136336,37.13,0.46,267,64813,70,NULL,NULL,'2MASX J16133499-0015256',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000071,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,243.395875,-0.25703,0.433,NULL,45507468108,711054189,11110221,18),(136337,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136337,36.74,0.46,223,64814,70,NULL,NULL,'2MASX J16133526+5041055',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000087,NULL,'16.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,243.397083,50.68472,0.021,NULL,59710093683,932970213,14577659,16.5),(136338,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136338,37.92,0.46,385,64815,70,NULL,NULL,'2MASX J16133566+2142298',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,243.39875,21.70822,0.133,NULL,56508772888,882949576,13796087,18),(136339,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136339,36.93,0.19,243,64816,70,NULL,NULL,'2MASX J16133744+3053276',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000179,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,243.4060417,30.89092,0.053,NULL,59738344231,933411628,14584556,17.2),(136340,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136340,37.13,0.13,267,64817,70,NULL,NULL,'2MASX J16133790+4904095',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00009,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,243.40775,49.06942,0,NULL,59703133820,932861465,14575960,16.7),(136341,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136341,36.7,0.33,219,64818,70,NULL,NULL,'SDSS J161338.09+134924.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,243.40875,13.82347,0.089,NULL,56555119583,883673743,13807402,17.7),(136342,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136342,38.21,0.46,439,64819,70,NULL,NULL,'2MASX J16133827+2930403',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,243.409375,29.51128,0.073,NULL,59739741349,933433458,14584897,18),(136343,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136343,36.7,0.33,219,64820,70,NULL,NULL,'2MASX J16133832+1348244',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,243.4097917,13.80672,0.089,NULL,56555118777,883673730,13807402,16.2),(136344,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136344,37.01,0.62,252,64821,70,NULL,NULL,'2MASX J16133895-2052182',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,243.41225,-20.87175,0.765,NULL,45447585038,710118516,11095601,15.8),(136345,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136345,36.37,0.2,188,64822,74.4,NULL,NULL,'KUG 1611+344',NULL,'2013AJ....146...86T',2013,1,0.72,NULL,'G',0.000043,NULL,'15.5g',0.29,'Spiral',NULL,NULL,NULL,NULL,1,243.413167,34.28603,0.005,NULL,59792030458,934250475,14597663,15.5),(136346,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136346,37.48,0.33,313,64823,70,NULL,NULL,'2MASX J16133916+2650073',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000164,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,243.413291667,26.83528,0.069,NULL,59730102928,933282858,14582544,17),(136347,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136347,37.75,0.46,355,64824,70,NULL,NULL,'2MASX J16133979+0850459',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,243.415875,8.84625,0.177,NULL,56470258465,882347788,13786684,16.8),(136348,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136348,37.49,0.46,315,64825,70,NULL,NULL,'SDSS J161341.35+245045.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000143,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,243.422333,24.84603,0.181,NULL,59727065033,933235391,14581802,18.5),(136349,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136349,36.3,NULL,182,64826,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2005',NULL,'2010Ap&SS.325..163P',2010,1,0.73,NULL,'G',NULL,NULL,'16.9',0.09,'Sd',NULL,NULL,NULL,NULL,1,243.422833333,52.87386,0.037,NULL,59699842965,932810046,14575156,16.9),(136350,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136350,36.31,NULL,183,64826,NULL,NULL,NULL,'FGC 2005',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136351,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136351,36.34,NULL,185,64826,NULL,NULL,'Dipole + Quadrupole','FGC 2005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136352,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136352,36.37,NULL,188,64826,NULL,NULL,'Dipole','FGC 2005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136353,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136353,37.19,0.46,274,64827,70,NULL,NULL,'2MASX J16134201+4853575',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000078,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,243.425167,48.89925,0,NULL,59705058192,932891534,14576430,16.5),(136354,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136354,36.74,0.46,223,64828,70,NULL,NULL,'2MASX J16134220+0038534',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.0001,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,243.425791667,0.64831,0.353,NULL,56450786521,882043539,13781930,16.8),(136355,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136355,37.31,0.46,290,64829,70,NULL,NULL,'2MASX J16134283+2629283',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000189,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,243.4285,26.49119,0.069,NULL,59730468333,933288567,14582633,16.8),(136356,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136356,35.89,0.46,151,64830,70,NULL,NULL,'2MASX J16134297+2544253',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000183,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,243.429,25.74042,0.125,NULL,59727609617,933243900,14581935,16.4),(136357,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136357,36.13,0.46,168,64831,70,NULL,NULL,'SDSS J161344.00+130508.1',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',NULL,NULL,'15.2g',0.55,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,243.433333,13.08561,0.145,NULL,56541945803,883467903,13804185,15.2),(136358,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136358,37.35,0.46,295,64832,70,NULL,NULL,'2MASX J16134556+1651083',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000152,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,243.439833333,16.85219,0.137,NULL,56560740661,883761572,13808774,17.1),(136359,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136359,38.19,0.46,434,64833,70,NULL,NULL,'2MASX J16134620+2324289',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000148,NULL,'19.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,243.4425417,23.40811,0.153,NULL,56505805217,882903206,13795362,19),(136360,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136360,35.67,0.59,136,64834,70,NULL,NULL,'2MASX J16134736-2100542',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.4,'(R\')SAB(s)0^+',NULL,NULL,NULL,NULL,1,243.4472917,-21.01514,0.789,NULL,45447540894,710117826,11095591,14.2),(136361,'TRGB','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136361,26.35,0.14,1.86,64835,NULL,NULL,NULL,'ELAIS06S(R) J161347.7+542218',NULL,'2001A&A...379..407K',2001,1,1.1,NULL,'G',0.000001,NULL,'17.0',0.65,'Ir',NULL,NULL,NULL,NULL,1,243.4497917,54.37117,0,1,57610401230,900162519,14065039,17),(136362,'TRGB','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136362,26.4,0.07,1.91,64835,NULL,NULL,'I','ELAIS06S(R) J161347.7+542218',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136363,'TRGB','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136363,26.43,0.05,1.93,64835,NULL,NULL,'I','ELAIS06S(R) J161347.7+542218',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136364,'TRGB','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136364,26.42,0.07,1.93,64835,NULL,NULL,'I','ELAIS06S(R) J161347.7+542218',NULL,'2012MNRAS.425..709M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136365,'TRGB','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136365,26.65,0.15,2.14,64835,NULL,NULL,NULL,'ELAIS06S(R) J161347.7+542218',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136366,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','PS1 SN PS10jw','N',136366,41.48,0.14,1450,64836,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10jw HOST',0.36,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136367,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136367,37.36,0.46,297,64837,70,NULL,NULL,'SDSS J161348.56+262418.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,243.452375,26.40528,0.069,NULL,59730462605,933288478,14582632,18.4),(136368,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136368,36.35,0.33,186,64838,70,NULL,NULL,'CGCG 196-008',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000103,NULL,'14.8g',0.61,'E0',NULL,NULL,NULL,NULL,1,243.455,38.15194,0.009,NULL,59772561400,933946271,14592910,14.8),(136369,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136369,37.96,0.46,391,64839,70,NULL,NULL,'2MASX J16134950+2059149',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,243.4562083,20.98767,0.145,NULL,56519403846,883115685,13798682,18.3),(136370,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136370,37.16,0.46,271,64840,70,NULL,NULL,'2MASX J16135003+2714113',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000174,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,243.458583333,27.2365,0.097,NULL,59729735364,933277115,14582454,16.4),(136371,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136371,38.14,0.46,425,64841,70,NULL,NULL,'SDSS J161351.07+191325.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,243.4627917,19.22383,0.113,NULL,56518219920,883097186,13798393,18.5),(136372,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136372,37.87,0.27,374,64842,70,NULL,NULL,'2MASX J16135165+2814444',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.465125,28.24556,0.109,NULL,59740875654,933451182,14585174,17.8),(136373,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136373,37.48,0.33,313,64843,70,NULL,NULL,'2MASX J16135188+2649334',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000141,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,243.4662917,26.82589,0.069,NULL,59730116486,933283070,14582547,17.7),(136374,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136374,36.92,0.46,242,64844,70,NULL,NULL,'2MASX J16135563+0621042',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,243.4817083,6.35131,0.173,NULL,56460809305,882200145,13784377,16.9),(136375,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136375,38.02,0.46,401,64845,70,NULL,NULL,'2MASX J16135692+2235539',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.487333,22.59825,0.189,NULL,56509096338,882954630,13796166,17.5),(136376,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136376,37.13,0.13,267,64846,70,NULL,NULL,'2MASX J16135804+4911228',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000103,NULL,'15.9g',0.42,'E              BrClG',NULL,NULL,NULL,NULL,1,243.492,49.18961,0,NULL,59703266360,932863536,14575992,15.9),(136377,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136377,37.21,0.46,277,64847,70,NULL,NULL,'2MASX J16140016+0811502',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,243.500667,8.19733,0.185,NULL,56470455395,882350865,13786732,16.8),(136378,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136378,37.3,0.33,289,64848,70,NULL,NULL,'2MASX J16140082+5049488',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00013,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,243.503167,50.83017,0.017,NULL,59710101365,932970333,14577661,16.4),(136379,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136379,35.52,0.67,127,64849,70,NULL,NULL,'2MASX J16140113-6512213',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'15.5R',0.41,'E?',NULL,NULL,NULL,NULL,1,243.5045,-65.20594,0.893,NULL,44981077009,702829328,10981708,15.5),(136380,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136380,37.33,0.46,292,64850,70,NULL,NULL,'2MASX J16140276+2423304',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00017,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,243.511583333,24.39172,0.169,NULL,59726952407,933233631,14581775,17.9),(136381,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136381,36.68,0.46,217,64851,70,NULL,NULL,'2MASX J16140288-0032347',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000093,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,243.5120417,-0.54317,0.389,NULL,45507666720,711057292,11110270,16.9),(136382,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136382,35.21,0.47,110,64852,NULL,NULL,'H','UGC 10287',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000013,NULL,'14.13',1,'SBb','Group non-member, foreground',NULL,NULL,NULL,1,243.5137083,14.28211,0.089,NULL,56555924416,883686319,13807598,14.13),(136383,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136383,35.3,0.45,115,64852,NULL,NULL,'K','UGC 10287',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136384,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136384,35.36,0.46,118,64852,NULL,NULL,'J','UGC 10287',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136385,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136385,35.35,0.9,118,64852,NULL,NULL,'Malmquist cor.','UGC 10287',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136386,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136386,35.65,0.4,135,64852,NULL,NULL,'mean','UGC 10287',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136387,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136387,36,0.67,158,64852,NULL,NULL,NULL,'UGC 10287',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136388,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136388,36.04,0.2,161,64852,74.4,NULL,NULL,'UGC 10287',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136389,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136389,37.83,0.46,368,64853,70,NULL,NULL,'2MASX J16140445+2401254',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000209,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,243.518583,24.02375,0.153,NULL,56639896953,884998389,13828099,16.8),(136390,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136390,37.13,0.13,267,64854,70,NULL,NULL,'2MASX J16140681+4911238',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000083,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,243.528625,49.18989,0,NULL,59703278823,932863731,14575995,16.9),(136391,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136391,36.79,0.46,228,64855,70,NULL,NULL,'2MASX J16140714+2218359',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000137,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,243.52975,22.30981,0.125,NULL,56508051743,882938308,13795911,18.2),(136392,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136392,37.98,0.46,394,64856,70,NULL,NULL,'2MASX J16140717+5016108',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.5300417,50.26969,0.017,NULL,59709697309,932964020,14577562,17.1),(136393,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136393,38.08,0.46,413,64857,70,NULL,NULL,'2MASXi J1614084+460431',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,243.535333,46.07539,0.009,NULL,59831816491,934872132,14607377,17.8),(136394,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136394,38.32,0.46,462,64858,70,NULL,NULL,'2MASXi J1614094+495800',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,243.539666667,49.96692,0.017,NULL,59707527031,932930109,14577032,18),(136395,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136395,37.37,0.46,297,64859,70,NULL,NULL,'2MASX J16140977+4859218',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000077,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,243.540667,48.98933,0,NULL,59703138263,932861535,14575961,16.9),(136396,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136396,35.28,0.46,114,64860,70,NULL,NULL,'CGCG 167-055',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00011,NULL,'15.2g',0.53,'E',NULL,NULL,NULL,NULL,1,243.545125,29.85169,0.061,NULL,59739766946,933433858,14584904,15.2),(136397,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136397,35.95,0.33,155,64861,70,NULL,NULL,'CGCG 051-070',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00013,NULL,'15.5',0.4,'E','Pair member (points to parent)',NULL,NULL,NULL,1,243.5482917,6.15103,0.173,NULL,56460639533,882197492,13784335,15.5),(136398,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136398,37.78,0.33,361,64862,70,NULL,NULL,'2MASX J16141178+1949575',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000204,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,243.549167,19.83256,0.105,NULL,56515941689,883061588,13797837,16.3),(136399,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136399,37.23,0.46,279,64863,70,NULL,NULL,'2MASX J16141183+0009220',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000078,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,243.549375,0.15619,0.361,NULL,56448569341,882008895,13781388,17.6),(136400,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136400,37.13,0.13,267,64864,70,NULL,NULL,'2MASX J16141190+4907128',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000103,NULL,'15.9g',0.43,'E0',NULL,NULL,NULL,NULL,1,243.5497083,49.12028,0,NULL,59703141423,932861584,14575962,15.9),(136401,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136401,36.88,0.46,238,64865,70,NULL,NULL,'2MASX J16141204+1609274',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000177,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,243.5502083,16.15764,0.129,NULL,56547199992,883549999,13805468,16.3),(136402,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136402,38.48,0.46,496,64866,70,NULL,NULL,'2MASX J16141219+2807543',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,243.5507917,28.13183,0.109,NULL,59740897737,933451527,14585180,18.1),(136403,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136403,34.92,0.46,96.5,64867,70,NULL,NULL,'2MASX J16141241-2940198',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00012,NULL,'14.59',0.63,'E',NULL,NULL,NULL,NULL,1,243.551667,-29.67217,0.853,NULL,46251137008,722674015,11291781,14.59),(136404,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136404,35.53,0.46,127,64868,70,NULL,NULL,'2MASX J16141242+3129255',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000158,NULL,'16.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,243.551917,31.49042,0.053,NULL,59783377397,934115271,14595551,16.2),(136405,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136405,37.92,0.46,384,64869,70,NULL,NULL,'2MASX J16141268+2122456',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,243.552666667,21.37914,0.165,NULL,56507937801,882936528,13795883,17.9),(136406,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136406,38.41,0.46,481,64870,70,NULL,NULL,'SDSS J161413.51+262252.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000159,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,243.556333333,26.38117,0.093,NULL,59730970395,933296412,14582756,18.6),(136407,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136407,37.32,0.46,291,64871,70,NULL,NULL,'2MASXi J1614136+205619',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000163,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,243.556625,20.93897,0.145,NULL,56519537569,883117774,13798715,18.2),(136408,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136408,37.24,0.46,280,64872,70,NULL,NULL,'2MASX J16141386-0015347',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000079,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.55775,-0.25964,0.397,NULL,45506394912,711037420,11109959,17.2),(136409,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136409,37.78,0.33,361,64873,70,NULL,NULL,'2MASX J16141447+1948396',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000151,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,243.560333333,19.81114,0.105,NULL,56515948729,883061698,13797839,18.6),(136410,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136410,35.09,0.25,104,64874,74.4,NULL,NULL,'GIN 555',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000107,NULL,'16.4g',0.36,'E/S0',NULL,NULL,NULL,NULL,1,243.562041667,29.29239,0.089,NULL,59743185712,933487276,14585738,16.4),(136411,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136411,35.27,0.42,113,64874,70,NULL,NULL,'GIN 555',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136412,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136412,36.32,0.46,184,64874,70,NULL,NULL,'GIN 555',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136413,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136413,33.54,0.4,51,64875,NULL,NULL,'mean','IC 1205',NULL,'2007A&A...465...71T',2007,1,0.6,NULL,'G',0.000004,NULL,'14.6',0.4,'Sa',NULL,NULL,NULL,NULL,1,243.566333,9.53719,0.153,NULL,56456537311,882133395,13783334,14.6),(136414,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136414,33.61,0.47,52.8,64875,NULL,NULL,'H','IC 1205',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136415,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136415,34.63,0.69,84.2,64876,100,NULL,'mid-IR','NGC 6084',NULL,'2013ApJ...771...88L',2013,1,1,NULL,'G',0.000033,NULL,'14.9',0.5,'Sa',NULL,NULL,NULL,NULL,1,243.569666667,17.75744,0.113,NULL,56561137755,883767777,13808871,14.9),(136416,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136416,35.69,0.4,137,64876,NULL,NULL,'mean','NGC 6084',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136417,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136417,36.21,0.47,175,64876,NULL,NULL,'H','NGC 6084',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136418,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136418,36.22,0.45,175,64876,NULL,NULL,'K','NGC 6084',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136419,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136419,36.25,0.46,178,64876,NULL,NULL,'J','NGC 6084',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136420,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136420,35.95,0.33,155,64877,70,NULL,NULL,'CGCG 051-072',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000166,NULL,'15.6g',0.42,'E              AGN','Pair member (points to parent)',NULL,NULL,NULL,1,243.5715,6.15944,0.173,NULL,56460636990,882197452,13784335,15.6),(136421,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136421,36.86,0.46,236,64878,70,NULL,NULL,'2MASX J16141844+1411592',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.576916667,14.19989,0.089,NULL,56555016897,883672139,13807377,17.1),(136422,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136422,38.25,0.46,447,64879,70,NULL,NULL,'2MASX J16141986+2110476',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000167,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,243.582833,21.17992,0.165,NULL,56507909349,882936083,13795876,17.3),(136423,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136423,35.54,0.46,128,64880,70,NULL,NULL,'2MASX J16141998-0001536',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000071,NULL,'16.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,243.583208333,-0.03156,0.385,NULL,45506397542,711037461,11109960,16.4),(136424,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136424,35.89,0.74,151,64880,70,NULL,NULL,'2MASX J16141998-0001536',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136425,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136425,37.36,0.46,297,64881,70,NULL,NULL,'2MASX J16142058+3426255',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000143,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,243.585875,34.44036,0.009,NULL,59792113369,934251771,14597683,17.5),(136426,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136426,37,0.46,252,64882,70,NULL,NULL,'2MASX J16142115+0026471',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000096,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,243.588125,0.44639,0.353,NULL,56450715572,882042430,13781912,16.8),(136427,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136427,37.21,0.46,277,64883,70,NULL,NULL,'2MASX J16142212+2545184',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000139,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,243.5922083,25.75511,0.125,NULL,59727558439,933243100,14581923,18.2),(136428,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136428,38.11,0.46,420,64884,70,NULL,NULL,'2MASX J16142308+1520272',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000148,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,243.596125,15.34083,0.089,NULL,56546614399,883540849,13805325,17.4),(136429,'IRAS','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136429,32.44,0.8,30.8,64885,75,NULL,'A82, H','UGC 10288',NULL,'1997ApJS..109..333W',1997,1,5.71,NULL,'G',0.000005,NULL,'14.24',0.58,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,243.603333,-0.20753,0.397,NULL,45506601073,711040641,11110010,14.24),(136430,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136430,32.02,0.4,25.4,64885,75,NULL,NULL,'UGC 10288',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136431,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136431,32.11,NULL,26.4,64885,NULL,NULL,NULL,'UGC 10288',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136432,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136432,32.23,0.4,27.9,64885,NULL,NULL,'Virgo cluster at 15.6 Mpc','UGC 10288',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136433,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136433,32.23,NULL,27.9,64885,NULL,NULL,'Dipole','UGC 10288',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136434,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136434,32.23,NULL,28,64885,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10288',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136435,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136435,32.24,NULL,28,64885,NULL,NULL,'Dipole + Quadrupole','UGC 10288',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136436,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136436,32.45,0.4,30.9,64885,NULL,NULL,'mean','UGC 10288',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136437,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136437,32.49,0.4,31.5,64885,75,NULL,'B','UGC 10288',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136438,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136438,32.51,0.47,31.8,64885,75,NULL,'A82, H, raw','UGC 10288',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136439,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136439,32.53,0.46,32.1,64885,NULL,NULL,'J','UGC 10288',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136440,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136440,32.54,0.47,32.2,64885,NULL,NULL,'H','UGC 10288',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136441,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136441,32.59,0.36,33,64885,NULL,NULL,NULL,'UGC 10288',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136442,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136442,32.61,0.47,33.2,64885,75,NULL,'A82, H, inv','UGC 10288',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136443,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136443,32.65,0.45,33.9,64885,NULL,NULL,'K','UGC 10288',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136444,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136444,32.66,0.47,34,64885,75,NULL,'A82, H, cor','UGC 10288',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136445,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136445,32.66,0.49,34,64885,75,NULL,'IR','UGC 10288',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136446,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136446,32.68,0.2,34.4,64885,74.4,NULL,NULL,'UGC 10288',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136447,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136447,32.71,0.43,34.8,64885,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10288',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136448,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136448,32.75,0.43,35.5,64885,75,NULL,'3.6 micron, color corrected','UGC 10288',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136449,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136449,37.88,0.46,376,64886,70,NULL,NULL,'2MASX J16142566+5207287',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000091,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,243.607125,52.12467,0.057,NULL,59709002224,932953159,14577393,17.3),(136450,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136450,35.93,0.1,153,64887,70,NULL,NULL,'NGC 6097',NULL,'2015arXiv151105856S',2015,1,1.12,NULL,'G',0.000087,NULL,'14.3g',0.59,NULL,NULL,NULL,NULL,NULL,1,243.6090417,35.10917,0.009,NULL,59778527788,934039496,14594367,14.3),(136451,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136451,37.12,0.46,266,64888,70,NULL,NULL,'2MASX J16142639+5106330',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000087,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,243.6100417,51.10931,0.013,NULL,59710019241,932969050,14577641,17),(136452,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136452,37.87,0.27,374,64889,70,NULL,NULL,'2MASX J16142716+2817164',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,243.613167,28.28792,0.109,NULL,59740903140,933451611,14585181,17.8),(136453,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136453,35.95,0.39,155,64890,NULL,NULL,'Malmquist cor.','CGCG 167-056',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000113,NULL,'15.06',0.6,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,243.61575,29.97386,0.037,NULL,59738011859,933406435,14584475,15.06),(136454,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136454,36.31,0.33,183,64890,NULL,NULL,NULL,'CGCG 167-056',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136455,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136455,36.33,0.2,185,64890,74.4,NULL,NULL,'CGCG 167-056',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136456,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','PS1 SN PS11aea','N',136456,41.14,0.11,1300,64891,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11aea HOST',0.3001,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136457,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136457,37.87,0.27,374,64892,70,NULL,NULL,'B2 1612+28',NULL,'2015arXiv151105856S',2015,1,0.33,'TXS codes: lobes(C)','G',0.0002,NULL,'15.1',0.25,'BrClG          WLAGN',NULL,NULL,NULL,NULL,1,243.618333,28.29194,0.109,NULL,59740902928,933451608,14585181,15.1),(136458,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136458,38.77,0.46,567,64893,70,NULL,NULL,'SDSS J161428.66+483533.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000086,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,243.6194583,48.59253,0,NULL,59705459252,932897800,14576528,18.3),(136459,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','PS1 SN PS10ji','N',136459,40.12,0.14,856,64894,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10ji HOST',0.2311,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136460,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136460,38.1,0.46,417,64895,70,NULL,NULL,'2MASX J16142908+1750522',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,243.621333,17.84792,0.113,NULL,56561134486,883767726,13808870,18.4),(136461,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136461,33.31,0.4,46,64896,NULL,NULL,'mean','IC 1210',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000103,NULL,'14.00',0.5,'Sab','Field galaxy',NULL,NULL,NULL,1,243.625625,62.53669,0,NULL,57646722387,900730037,14073906,14),(136462,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136462,33.54,0.47,50.9,64896,NULL,NULL,'H','IC 1210',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136463,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136463,33.61,0.45,52.7,64896,NULL,NULL,'K','IC 1210',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136464,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136464,33.62,0.46,53.1,64896,NULL,NULL,'J','IC 1210',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136465,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136465,37.3,0.33,289,64897,70,NULL,NULL,'2MASX J16143088+5048460',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000087,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,243.6284583,50.81281,0.017,NULL,59710056018,932969625,14577650,16.8),(136466,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136466,38.31,0.46,460,64898,70,NULL,NULL,'2MASX J16143194+4825471',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000081,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,243.633,48.42986,0,NULL,59705470422,932897975,14576530,18.1),(136467,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136467,37.36,0.46,297,64899,70,NULL,NULL,'2MASX J16143198+4931131',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000089,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,243.633166667,49.52039,0,NULL,59703081752,932860652,14575947,16.6),(136468,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136468,32.44,0.4,30.8,64900,75,NULL,'B','UGC 10290',NULL,'1988NBGC.C....0000T',1988,1,1.8,NULL,'G',0.000013,NULL,'13.8',1.7,'SB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,243.637291667,0.82156,0.337,NULL,56450986673,882046666,13781979,13.8),(136469,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136469,37.04,0.46,256,64901,70,NULL,NULL,'2MASX J16143308+3749548',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00018,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,243.638,37.83186,0.017,NULL,59772724581,933948821,14592950,16.9),(136470,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136470,37.39,0.46,301,64902,70,NULL,NULL,'SDSS J161434.06+265629.3',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000165,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,243.6419583,26.9415,0.085,NULL,59730150556,933283602,14582556,18.6),(136471,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136471,36.54,0.46,203,64903,70,NULL,NULL,'2MASX J16143476+2534374',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000179,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,243.644875,25.57694,0.125,NULL,59727735652,933245869,14581966,16.7),(136472,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136472,35.47,0.33,124,64904,70,NULL,NULL,'KUGX 1612+343',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.00009,NULL,'14.9g',0.57,'Compact',NULL,NULL,NULL,NULL,1,243.647083,34.22253,0.013,NULL,59792857304,934263395,14597865,14.9),(136473,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136473,37.11,0.46,264,64905,70,NULL,NULL,'2MASX J16143549+1642062',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000152,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.648083,16.70172,0.141,NULL,56543696949,883495264,13804613,16.6),(136474,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136474,37.78,0.46,360,64906,70,NULL,NULL,'2MASX J16143566+3952049',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.648417,39.86792,0,NULL,59802221056,934409704,14600151,17.6),(136475,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136475,36.89,0.46,239,64907,70,NULL,NULL,'2MASX J16143719+0541175',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.655,5.68814,0.225,NULL,56502560721,882852511,13794570,17.2),(136476,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136476,34.88,0.46,94.6,64908,70,NULL,NULL,'2MASX J16143829+5225221',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000064,NULL,'16.0g',0.34,'S0/a',NULL,NULL,NULL,NULL,1,243.659458333,52.42294,0.065,NULL,59708111446,932939241,14577175,16),(136477,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136477,38.85,0.46,589,64909,70,NULL,NULL,'2MASX J16143850+2852173',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000181,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.660375,28.87153,0.105,NULL,59743260611,933488447,14585756,17.8),(136478,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136478,36.34,0.46,185,64910,70,NULL,NULL,'2MASX J16143906+0702424',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,243.662667,7.04511,0.205,NULL,56468567584,882321368,13786271,17.1),(136479,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136479,37.02,0.46,253,64911,70,NULL,NULL,'2MASX J16144079+1137524',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,243.670041667,11.63128,0.201,NULL,56574503438,883976616,13812134,17.3),(136480,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136480,38.16,0.46,428,64912,70,NULL,NULL,'2MASX J16144231+1646372',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000168,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.676417,16.77694,0.141,NULL,56543915510,883498679,13804666,17),(136481,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136481,34.96,0.49,98.1,64913,75,NULL,'IR','FGC 2006',NULL,'2011yCatp016004901K',2011,1,1.35,NULL,'G',0.000009,NULL,'16.6g',0.14,'Sd',NULL,NULL,NULL,NULL,1,243.686417,27.86139,0.117,NULL,59740806471,933450101,14585157,16.6),(136482,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136482,34.99,NULL,99.3,64913,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136483,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136483,35,NULL,100,64913,NULL,NULL,'Dipole + Quadrupole','FGC 2006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136484,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136484,35.02,NULL,101,64913,NULL,NULL,'Dipole','FGC 2006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136485,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136485,36.68,0.46,217,64914,70,NULL,NULL,'2MASX J16144647+2253378',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000176,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,243.6937083,22.894,0.169,NULL,56640191345,885002989,13828171,16.6),(136486,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136486,37.34,0.46,294,64915,70,NULL,NULL,'2MASX J16144690+2010298',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000153,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.6954583,20.17494,0.109,NULL,56516094096,883063970,13797874,17.2),(136487,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136487,36,0.46,159,64916,70,NULL,NULL,'2MASX J16144772+1953018',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000186,NULL,'16.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,243.6989583,19.88386,0.105,NULL,56515917331,883061208,13797831,16.6),(136488,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136488,36.73,0.46,222,64917,70,NULL,NULL,'2MASX J16144805+2918014',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'16.8g',0.27,'Sa',NULL,NULL,NULL,NULL,1,243.700417,29.30036,0.089,NULL,59743356912,933489951,14585780,16.8),(136489,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136489,35.51,0.2,126,64918,74.4,NULL,NULL,'UGC 10296',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000133,NULL,'15.35',0.6,'Scd:',NULL,NULL,NULL,NULL,1,243.706375,39.51439,0.005,NULL,59802348708,934411698,14600182,15.35),(136490,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136490,35.75,0.08,142,64918,NULL,NULL,NULL,'UGC 10296',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136491,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136491,36.09,0.59,165,64919,70,NULL,NULL,'2MASX J16145014-0054561',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.000086,NULL,'15.8g',0.36,NULL,NULL,NULL,NULL,NULL,1,243.708875,-0.91567,0.457,NULL,45508117887,711064341,11110380,15.8),(136492,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136492,36.32,0.46,184,64920,70,NULL,NULL,'2MASX J16145017+3655420',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.708917,36.92844,0.017,NULL,59772442802,933944418,14592881,17),(136493,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136493,37.99,0.46,396,64921,70,NULL,NULL,'2MASX J16145267+4112260',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000148,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,243.719458333,41.20731,0,NULL,59799311044,934364235,14599441,17.6),(136494,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136494,36.45,0.33,195,64922,70,NULL,NULL,'2MASX J16145283+4953452',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,243.720167,49.89581,0.009,NULL,59707710479,932932976,14577077,17.5),(136495,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136495,37.71,0.75,349,64923,70,NULL,NULL,'2MASX J16145298-6623478',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,243.7205,-66.39669,0.737,NULL,44995948154,703061689,10985338,15.8),(136496,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136496,37.64,0.46,337,64924,70,NULL,NULL,'2MASX J16145525+0624024',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,243.730125,6.40061,0.185,NULL,56467957645,882311838,13786122,17.1),(136497,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136497,35.4,0.46,120,64925,70,NULL,NULL,'KUGX 1613+331A',NULL,'2015arXiv151105856S',2015,1,0.65,'Listed in CGCG special map in vol III, p 87 (SM1-006).','G',0.00017,NULL,'15.4g',0.57,'Compact',NULL,NULL,NULL,NULL,1,243.734125,33.06267,0.025,NULL,59784038225,934125597,14595712,15.4),(136498,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136498,37.74,0.46,353,64926,70,NULL,NULL,'2MASX J16145701+3045143',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000188,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,243.7374583,30.75406,0.053,NULL,59737572006,933399562,14584368,16.9),(136499,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136499,37.39,0.46,300,64927,70,NULL,NULL,'2MASX J16145761+0020015',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000094,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,243.74,0.33367,0.353,NULL,56448770751,882012042,13781438,17.9),(136500,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136500,37.66,0.46,341,64928,70,NULL,NULL,'2MASX J16145805+1703380',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000152,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,243.7419583,17.06061,0.117,NULL,56543835027,883497422,13804647,17),(136501,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136501,37.01,0.46,253,64929,70,NULL,NULL,'2MASXi J1614594+371111',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000169,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,243.747625,37.18656,0.009,NULL,59772803511,933950054,14592969,17.5),(136502,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136502,36.43,0.23,193,64930,70,NULL,NULL,'2MASX J16145941+5020282',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000093,NULL,'15.95',NULL,NULL,NULL,NULL,NULL,NULL,1,243.747666667,50.34108,0.021,NULL,59709707485,932964179,14577565,15.95),(136503,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136503,37.58,0.46,328,64931,70,NULL,NULL,'SDSS J161500.31+213953.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,243.7512917,21.66494,0.161,NULL,56507833884,882934904,13795857,18.5),(136504,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136504,38.12,0.33,420,64932,70,NULL,NULL,'2MASX J16150054+4932472',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000092,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,243.752375,49.54653,0,NULL,59703067027,932860422,14575944,17.4),(136505,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136505,36.39,0.46,189,64933,70,NULL,NULL,'2MASX J16150160+3901110',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.0001,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,243.756875,39.01983,0,NULL,59801852588,934403946,14600061,16.4),(136506,'D-Sigma','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136506,32.93,0.4,38.5,64934,75,NULL,'Edat, raw','ESO 137- G 006',NULL,'1997ApJS..109..333W',1997,1,1.5,'abs(b) < 10 degrees.','G',0.000117,NULL,'13.5B',1.1,'E1;cD','Group member, radial-velocity confirmed',NULL,'WAT',NULL,1,243.766,-60.90717,NULL,NULL,44377688002,693401375,10834396,13.5),(136507,'D-Sigma','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136507,33.25,0.4,44.7,64934,75,NULL,'Edat, cor','ESO 137- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136508,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136508,37.74,0.46,353,64935,70,NULL,NULL,'2MASX J16150418+0854264',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.767583,8.90736,0.165,NULL,56470151997,882346124,13786658,17.4),(136509,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136509,34.73,0.49,88.5,64936,75,NULL,'IR','FGC 2008',NULL,'2011yCatp016004901K',2011,1,0.83,NULL,'G',0.000058,NULL,'16.6g',0.19,'Sdm',NULL,NULL,NULL,NULL,1,243.768417,31.46308,0.053,NULL,59782634093,934103657,14595369,16.6),(136510,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136510,35.03,NULL,101,64936,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136511,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136511,35.06,NULL,103,64936,NULL,NULL,'Dipole + Quadrupole','FGC 2008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136512,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136512,35.08,NULL,104,64936,NULL,NULL,'Dipole','FGC 2008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136513,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136513,35.46,NULL,124,64936,NULL,NULL,NULL,'FGC 2008',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136514,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136514,36.6,0.46,209,64937,70,NULL,NULL,'2MASX J16150461+4335441',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000093,NULL,'15.4g',0.55,'E0',NULL,NULL,NULL,NULL,1,243.769375,43.59553,0.009,NULL,59850341711,935161589,14611899,15.4),(136515,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136515,37.07,0.64,259,64938,70,NULL,NULL,'2MASX J16150566-1505270',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.0I',0.3,NULL,NULL,NULL,NULL,NULL,1,243.7735417,-15.09081,0.857,NULL,45463659309,710369676,11099526,15),(136516,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136516,37.88,0.46,378,64939,70,NULL,NULL,'2MASX J16150614+0905124',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,243.775667,9.08669,0.157,NULL,56456458196,882132159,13783314,17.7),(136517,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136517,38.45,0.46,491,64940,70,NULL,NULL,'2MASX J16150631+3809260',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000136,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,243.7764583,38.15708,0.009,NULL,59769121057,933892516,14592070,18.6),(136518,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136518,37.06,0.46,258,64941,70,NULL,NULL,'2MASX J16150777+3430164',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000171,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,243.782417,34.50447,0.009,NULL,59792077516,934251211,14597675,16.8),(136519,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136519,37.79,0.46,361,64942,70,NULL,NULL,'2MASX J16150856+1637280',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000182,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,243.785541667,16.62453,0.141,NULL,56543779663,883496557,13804633,17.2),(136520,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136520,36.77,0.46,226,64943,70,NULL,NULL,'2MASX J16150870+5228511',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000088,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.7862917,52.48089,0.065,NULL,59708227308,932941051,14577203,16.8),(136521,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136521,38.12,0.33,420,64944,70,NULL,NULL,'2MASX J16150924+4927481',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000073,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,243.7882917,49.46333,0.005,NULL,59703250795,932863293,14575988,18.2),(136522,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136522,37.59,0.46,330,64945,70,NULL,NULL,'2MASX J16151199+1431160',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000194,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,243.799875,14.52108,0.097,NULL,56554233519,883659898,13807185,16.7),(136523,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136523,36.45,0.33,195,64946,70,NULL,NULL,'2MASX J16151252+5006444',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.802125,50.11225,0.017,NULL,59707650520,932932039,14577063,17.1),(136524,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136524,34.87,0.69,94.3,64947,100,NULL,'mid-IR','IC 1206',NULL,'2013ApJ...771...88L',2013,1,1.2,NULL,'G',0.000033,NULL,'14.6g',0.69,'Sab','Pair member (points to parent)',NULL,NULL,NULL,1,243.8044583,11.29739,0.197,NULL,56576806798,884012606,13812696,14.6),(136525,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136525,35.83,0.47,146,64947,NULL,NULL,'H','IC 1206',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136526,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136526,35.9,0.4,152,64947,NULL,NULL,'mean','IC 1206',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136527,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136527,36.01,0.45,159,64947,NULL,NULL,'K','IC 1206',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136528,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136528,36.04,0.46,161,64947,NULL,NULL,'J','IC 1206',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136529,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136529,37.7,0.46,346,64948,70,NULL,NULL,'2MASX J16151534+2644118',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000177,NULL,'17.4g',NULL,NULL,NULL,NULL,NULL,NULL,1,243.814041667,26.73681,0.093,NULL,59730118188,933283096,14582548,17.4),(136530,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136530,37.13,0.13,267,64949,70,NULL,NULL,'2MASX J16151564+4935365',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000105,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,243.815375,49.59358,0,NULL,59707720347,932933130,14577080,16.3),(136531,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136531,36.76,0.46,225,64950,70,NULL,NULL,'2MASX J16151688+0009455',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000081,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,243.8204583,0.16264,0.377,NULL,56448634810,882009918,13781404,17.5),(136532,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136532,36.82,0.46,231,64951,70,NULL,NULL,'2MASX J16151959+3042534',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.8315,30.71483,0.057,NULL,59737585712,933399776,14584371,17),(136533,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136533,37.77,0.46,359,64952,70,NULL,NULL,'2MASX J16152183+1623390',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000198,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,243.8409583,16.39419,0.133,NULL,56547253930,883550842,13805481,16.9),(136534,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136534,37.59,0.46,329,64953,70,NULL,NULL,'2MASX J16152301+2047434',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000157,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,243.845833,20.79533,0.113,NULL,56515122420,883048787,13797637,18.5),(136535,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136535,37.4,0.46,302,64954,70,NULL,NULL,'2MASX J16152302+3823038',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000174,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.845917,38.3845,0,NULL,59798721483,934355023,14599297,17.2),(136536,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136536,37.24,0.46,281,64955,70,NULL,NULL,'2MASX J16152333+4801335',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000071,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.847083,48.02606,0,NULL,59705423241,932897238,14576519,17.5),(136537,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136537,35.48,0.46,124,64956,70,NULL,NULL,'CGCG 167-059 NED02',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000165,NULL,'15.4g',0.32,'S0','Pair member (points to parent)',NULL,NULL,NULL,1,243.8475,26.618,0.093,NULL,59731018421,933297162,14582768,15.4),(136538,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136538,35.47,0.33,124,64957,70,NULL,NULL,'KUGX 1613+343',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000053,NULL,'15.7g',0.41,'Compact',NULL,NULL,NULL,NULL,1,243.858375,34.22453,0.009,NULL,59792899996,934264062,14597875,15.7),(136539,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136539,37.6,0.46,332,64958,70,NULL,NULL,'2MASX J16152638+1031436',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,243.8600417,10.52883,0.177,NULL,56575237269,883988082,13812313,16.5),(136540,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136540,38.11,0.46,419,64959,70,NULL,NULL,'SDSS J161528.71+431718.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,243.869666667,43.28844,0.021,NULL,59850223686,935159745,14611871,18),(136541,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136541,32.62,0.4,33.5,64960,75,NULL,NULL,'UGC 10297',NULL,'2008Ap.....51..336K',2008,1,2.24,NULL,'G',0.000013,NULL,'14.96',0.29,'Sc',NULL,NULL,NULL,NULL,1,243.870083,18.90486,0.109,NULL,56514438705,883038104,13797470,14.96),(136542,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136542,32.76,0.4,35.6,64960,NULL,NULL,NULL,'UGC 10297',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136543,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136543,32.87,0.43,37.5,64960,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10297',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136544,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136544,32.89,0.2,37.8,64960,74.4,NULL,NULL,'UGC 10297',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136545,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136545,32.89,0.43,37.9,64960,75,NULL,'3.6 micron, color corrected','UGC 10297',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136546,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136546,32.9,NULL,38,64960,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10297',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136547,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136547,32.91,NULL,38.2,64960,NULL,NULL,'Dipole + Quadrupole','UGC 10297',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136548,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136548,32.91,NULL,38.2,64960,NULL,NULL,'Dipole','UGC 10297',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136549,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136549,32.98,NULL,39.5,64960,NULL,NULL,NULL,'UGC 10297',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136550,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136550,33.04,0.5,40.5,64960,NULL,NULL,NULL,'UGC 10297',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136551,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136551,33.06,0.49,40.9,64960,75,NULL,'IR','UGC 10297',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136552,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136552,33.09,0.49,41.5,64960,NULL,NULL,'Malmquist cor.','UGC 10297',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136553,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136553,38.59,0.46,521,64961,70,NULL,NULL,'2MASX J16152913+0814386',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000154,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,243.871375,8.24411,0.189,NULL,56470345299,882349145,13786705,18.6),(136554,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136554,36.66,0.46,215,64962,70,NULL,NULL,'2MASX J16153082+3030136',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000186,NULL,'16.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,243.87825,30.50378,0.037,NULL,59737562276,933399410,14584365,16.3),(136555,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136555,36.26,0.73,179,64963,70,NULL,NULL,'2MASX J16153116-1444420',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,243.879875,-14.74506,1.325,NULL,45463837052,710372453,11099569,15.2),(136556,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136556,36.2,0.56,174,64964,70,NULL,NULL,'2MASX J16153172-7318038',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,243.8822917,-73.30111,0.329,NULL,44117526304,689336348,10770880,15.4),(136557,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136557,37.41,0.46,304,64965,70,NULL,NULL,'2MASX J16153195+0031233',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000086,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,243.88325,0.52328,0.337,NULL,56448684680,882010698,13781417,16.7),(136558,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136558,36.12,0.61,167,64966,70,NULL,NULL,'2MASX J16153251-8257177',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,'E int',NULL,NULL,NULL,NULL,1,243.8847917,-82.95492,0.381,NULL,44046382709,688224729,10753511,16.4),(136559,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136559,38.34,0.46,466,64967,70,NULL,NULL,'2MASX J16153258+2434117',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000176,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.8857083,24.56986,0.141,NULL,56170276623,877660572,13713446,17.8),(136560,'SZ effect','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136560,36.96,NULL,247,64968,NULL,NULL,'3.1 (red) calibration, NH = 12.1 _ 10e20 cm_2','ABELL 2163',NULL,'2010ApJ...721..653R',2010,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,243.892208333,-6.12397,0.741,NULL,45538661729,711541589,11117837,NULL),(136561,'SZ effect','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136561,37.85,NULL,372,64968,NULL,NULL,'4.2 (black) calibration, NH = 12.1 _ 10e20 cm_2','ABELL 2163',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136562,'SZ effect','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136562,38.12,0.38,420,64968,NULL,NULL,'Isotherm.','ABELL 2163',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136563,'SZ effect','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136563,38.43,NULL,485,64968,NULL,NULL,'4.1 (blue) calibration, NH = 12.1 _ 10e20 cm_2','ABELL 2163',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136564,'SZ effect','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136564,38.58,0.19,520,64968,NULL,NULL,'Hydrost. Eq.','ABELL 2163',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136565,'SZ effect','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136565,39.03,NULL,641,64968,NULL,NULL,'3.1 (red) calibration, NH = 18.7 _ 10e20 cm_2','ABELL 2163',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136566,'SZ effect','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136566,39.23,1.24,702,64968,NULL,NULL,NULL,'ABELL 2163',NULL,'1997ApJ...480..449H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136567,'SZ effect','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136567,39.32,0.74,730,64968,NULL,NULL,'Isotherm., r < 100 kpc','ABELL 2163',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136568,'SZ effect','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136568,39.39,NULL,755,64968,NULL,NULL,'4.2 (black) calibration, NH = 18.7 _ 10e20 cm_2','ABELL 2163',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136569,'SZ effect','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136569,39.44,1.1,772,64968,NULL,NULL,NULL,'ABELL 2163',NULL,'1998ApJ...507L...5L',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136570,'SZ effect','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136570,39.49,0.04,790,64968,70,NULL,NULL,'ABELL 2163',NULL,'1997ApJ...481...35H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136571,'SZ effect','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136571,39.53,NULL,806,64968,NULL,NULL,NULL,'ABELL 2163',NULL,'2005ApJ...625..108D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136572,'SZ effect','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136572,39.59,NULL,828,64968,NULL,NULL,NULL,'ABELL 2163',NULL,'2002ApJ...581...53R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136573,'SZ effect','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136573,39.73,NULL,884,64968,NULL,NULL,'4.1 (blue) calibration, NH = 18.7 _ 10e20 cm_2','ABELL 2163',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136574,'SZ effect','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136574,39.8,1.11,913,64968,NULL,NULL,NULL,'ABELL 2163',NULL,'1997ApJ...480..449H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136575,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136575,37.13,0.13,267,64969,70,NULL,NULL,'2MASX J16153415+4936436',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,243.892375,49.61208,0,NULL,59707721546,932933149,14577080,17.1),(136576,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136576,37.76,0.46,357,64970,70,NULL,NULL,'2MASX J16153422+2806337',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000113,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,243.892667,28.10944,0.109,NULL,59742843948,933481936,14585655,16.9),(136577,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136577,37.59,0.46,330,64971,70,NULL,NULL,'2MASX J16153421+5129066',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000082,NULL,'17.8g',0.19,'NLAGN',NULL,NULL,NULL,'Sy 2',1,243.89275,51.48514,0.041,NULL,59708730187,932948909,14577326,17.8),(136578,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136578,35.26,0.4,113,64972,NULL,NULL,'mean','IC 1215',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.0001,NULL,'14.10',0.7,'SBc            HII',NULL,NULL,NULL,NULL,1,243.896375,68.39767,0.129,NULL,57832459025,903632172,14119252,14.1),(136579,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136579,35.35,0.47,118,64972,NULL,NULL,'H','IC 1215',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136580,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136580,35.84,0.4,147,64973,NULL,NULL,'mean','NGC 6099',NULL,'2007A&A...465...71T',2007,1,0.18,NULL,'G',0.000033,NULL,'15.9g',0.17,'E+','Pair member (points to parent)',NULL,NULL,NULL,1,243.898166667,19.45339,0.105,NULL,56517963281,883093176,13798330,15.9),(136581,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136581,37.14,0.45,268,64973,NULL,NULL,'K','NGC 6099',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136582,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136582,35.31,0.2,115,64974,74.4,NULL,NULL,'UGC 10301',NULL,'2013AJ....146...86T',2013,1,0.59,NULL,'G',0.000007,NULL,'16.0g',0.23,'SBb:',NULL,NULL,NULL,NULL,1,243.907375,31.32131,0.077,NULL,59782644331,934103817,14595372,16),(136583,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136583,36.57,0.46,206,64975,70,NULL,NULL,'2MASX J16153898+3047217',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000175,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,243.9124583,30.78947,0.057,NULL,59737576455,933399632,14584369,16.2),(136584,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136584,36.99,0.27,250,64976,70,NULL,NULL,'2MASX J16153969+2241253',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00019,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,243.915417,22.69042,0.173,NULL,56643612696,885056448,13829007,17.2),(136585,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136585,36.99,0.27,250,64977,70,NULL,NULL,'2MASX J16154147+2241230',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,243.92275,22.68967,0.173,NULL,56643610770,885056418,13829006,17.6),(136586,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136586,37.33,0.46,292,64978,70,NULL,NULL,'2MASX J16154195+4523012',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000176,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.9247917,45.38375,0.009,NULL,59849130562,935142665,14611604,16.9),(136587,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136587,36.4,0.46,191,64979,70,NULL,NULL,'2MASX J16154340+1531279',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,243.9309583,15.52442,0.113,NULL,56546183489,883534117,13805220,17),(136588,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136588,38.69,0.46,546,64980,70,NULL,NULL,'SDSS J161543.60+223606.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,243.9317083,22.60178,0.173,NULL,56643575863,885055872,13828998,18.9),(136589,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136589,36.99,0.27,250,64981,70,NULL,NULL,'2MASX J16154464+2243330',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00021,NULL,'16.1g',0.41,NULL,NULL,NULL,NULL,NULL,1,243.9360417,22.72589,0.173,NULL,56643605910,885056342,13829005,16.1),(136590,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136590,37.43,0.46,306,64982,70,NULL,NULL,'2MASX J16154519+3149187',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000178,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,243.938125,31.82183,0.061,NULL,59783436644,934116197,14595565,16.6),(136591,'D-Sigma','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136591,32.93,0.4,38.5,64983,75,NULL,'Edat, raw','ESO 137- G 008',NULL,'1997ApJS..109..333W',1997,1,1.6,'abs(b) < 10 degrees.','G',0.000127,NULL,'13.1B',1.4,'S0-:;cD','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,243.942,-60.91872,NULL,NULL,44377691463,693401429,10834397,13.1),(136592,'D-Sigma','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136592,33.25,0.4,44.7,64983,75,NULL,'Edat, cor','ESO 137- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136593,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136593,34.27,0.07,71.3,64983,NULL,NULL,'Norma Cluster, ABELL 3627, n = 121 early-type galaxies','ESO 137- G 008',NULL,'2014MNRAS.439.3666M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136594,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136594,33.46,0.45,49.2,64983,NULL,NULL,'K','ESO 137- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136595,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136595,33.52,0.4,50.6,64983,NULL,NULL,'mean','ESO 137- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136596,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136596,37.81,0.46,365,64984,70,NULL,NULL,'2MASX J16154806+3826208',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000167,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.950125,38.43908,0,NULL,59798774924,934355858,14599310,17),(136597,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136597,37.19,0.46,274,64985,70,NULL,NULL,'2MASX J16154852+1219467',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,243.9522917,12.32964,0.161,NULL,56541599003,883462484,13804101,16.8),(136598,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136598,38.14,0.46,424,64986,70,NULL,NULL,'2MASX J16154868+1049463',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,243.9529583,10.82953,0.185,NULL,56576353868,884005529,13812586,17.8),(136599,'D-Sigma','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136599,32.93,0.4,38.5,64987,75,NULL,'Edat, raw','ESO 137- G 010',NULL,'1997ApJS..109..333W',1997,1,2.5,'abs(b) < 10 degrees.','G',0.000107,NULL,'12.46',1.5,'(R\')SAB(s)0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,243.959,-60.80306,NULL,NULL,44377665512,693401023,10834390,12.46),(136600,'D-Sigma','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136600,33.25,0.4,44.7,64987,75,NULL,'Edat, cor','ESO 137- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136601,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136601,33.2,0.45,43.7,64987,NULL,NULL,'K','ESO 137- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136602,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136602,33.27,0.4,45,64987,NULL,NULL,'mean','ESO 137- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136603,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136603,38.07,0.33,411,64988,70,NULL,NULL,'2MASX J16155059+2125480',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000148,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,243.9607083,21.43014,0.161,NULL,56640966626,885015103,13828360,17.9),(136604,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136604,38.07,0.33,411,64989,70,NULL,NULL,'2MASX J16155145+2121450',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,243.9645417,21.36247,0.165,NULL,56640969560,885015149,13828361,18.2),(136605,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','PS1 SN PS11xc','N',136605,41.32,0.28,1380,64990,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11xc HOST',0.3281,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136606,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136606,37.81,0.46,364,64991,70,NULL,NULL,'SDSS J161552.11+360911.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,243.967167,36.15328,0.013,NULL,59771405788,933928215,14592628,18.2),(136607,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136607,34.93,0.46,96.6,64992,70,NULL,NULL,'ARK 498',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000143,NULL,'15.0g',0.67,'Compact',NULL,NULL,NULL,NULL,1,243.9695,36.99747,0.013,NULL,59772346798,933942918,14592858,15),(136608,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136608,38.08,0.46,413,64993,70,NULL,NULL,'2MASX J16155303+4202493',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000177,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.9710417,42.04714,0.021,NULL,59806585789,934477902,14601217,17.6),(136609,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136609,37.69,0.46,346,64994,70,NULL,NULL,'2MASX J16155411+2752183',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000178,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,243.9754583,27.87189,0.097,NULL,59742662663,933479104,14585611,17.2),(136610,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136610,36.57,0.46,206,64995,70,NULL,NULL,'2MASX J16155429+1827300',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,243.976291667,18.45847,0.117,NULL,56514926768,883045730,13797589,17.5),(136611,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136611,35.35,0.2,117,64996,74.4,NULL,NULL,'UGC 10305',NULL,'2013AJ....146...86T',2013,1,0.96,NULL,'G',0.000014,NULL,'15.8g',0.32,'S?',NULL,NULL,NULL,NULL,1,243.978875,31.69078,0.061,NULL,59782555084,934102423,14595350,15.8),(136612,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136612,35.74,NULL,141,64997,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2010',NULL,'2010Ap&SS.325..163P',2010,1,0.97,NULL,'G',0.000011,NULL,'16.5',0.11,'Sbc',NULL,NULL,NULL,NULL,1,243.9810417,16.78419,0.141,NULL,56543797659,883496838,13804638,16.5),(136613,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136613,35.75,0.49,141,64997,75,NULL,'IR','FGC 2010',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136614,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136614,35.76,NULL,142,64997,NULL,NULL,'Dipole + Quadrupole','FGC 2010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136615,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136615,35.78,NULL,143,64997,NULL,NULL,'Dipole','FGC 2010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136616,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136616,35.78,NULL,144,64997,NULL,NULL,NULL,'FGC 2010',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136617,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136617,36.35,0.2,186,64997,74.4,NULL,NULL,'FGC 2010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136618,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136618,37.22,0.46,278,64998,70,NULL,NULL,'2MASX J16155567+2348490',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000187,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,243.982083,23.81372,0.153,NULL,56640047017,885000734,13828136,17.2),(136619,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136619,37.23,0.33,280,64999,70,NULL,NULL,'2MASX J16155711+1224118',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,243.9880417,12.40328,0.161,NULL,56541595401,883462428,13804100,16.2),(136620,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136620,36.74,0.46,223,65000,70,NULL,NULL,'2MASX J16155934+1346208',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.1g',0.37,NULL,NULL,NULL,NULL,NULL,1,243.997333,13.77253,0.125,NULL,56540582855,883446607,13803853,16.1),(136621,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136621,37.79,0.46,361,65001,70,NULL,NULL,'2MASX J16155955+1328478',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,243.9980417,13.48003,0.137,NULL,56542427846,883475435,13804303,17.4),(136622,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136622,36.48,0.46,198,65002,70,NULL,NULL,'2MASX J16160054+3709200',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,244.00225,37.15558,0.009,NULL,59772361779,933943152,14592861,16.9),(136623,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136623,37.13,0.13,267,65003,70,NULL,NULL,'2MASX J16160155+4921267',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000079,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,244.006375,49.35753,0.005,NULL,59703187035,932862297,14575973,17.2),(136624,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136624,36.57,NULL,206,65004,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2011',NULL,'2010Ap&SS.325..163P',2010,1,0.75,NULL,'G',0.000019,NULL,'17.1',0.09,'Sc',NULL,NULL,NULL,NULL,1,244.014083333,11.48092,0.201,NULL,56576614967,884009608,13812650,17.1),(136625,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136625,36.58,NULL,207,65004,NULL,NULL,'Dipole + Quadrupole','FGC 2011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136626,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136626,36.6,NULL,209,65004,NULL,NULL,'Dipole','FGC 2011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136627,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136627,36.68,NULL,217,65004,NULL,NULL,NULL,'FGC 2011',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136628,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136628,36.98,0.2,249,65004,74.4,NULL,NULL,'FGC 2011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136629,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136629,34.67,0.52,85.8,65005,70,NULL,NULL,'IC 4596',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000123,NULL,'15.5',0.5,'(R\')SB(r)ab',NULL,NULL,NULL,NULL,1,244.0150417,-22.62539,0.645,NULL,45905910358,717279849,11207497,15.5),(136630,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136630,35.83,0.43,147,65005,75,NULL,'3.6 micron, color + selection bias corrected','IC 4596',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136631,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136631,37.67,0.46,343,65006,70,NULL,NULL,'2MASX J16160446+4829247',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00008,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,244.018791667,48.49031,0,NULL,59703465908,932866654,14576041,17),(136632,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136632,36.98,0.46,249,65007,70,NULL,NULL,'2MASX J16160506+2430193',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000161,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,244.0212083,24.50544,0.149,NULL,56170294573,877660852,13713450,16.3),(136633,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136633,35,0.46,100,65008,70,NULL,NULL,'2MASX J16160538+3740130',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.00009,NULL,'15.4g',0.45,'S0',NULL,NULL,NULL,NULL,1,244.0225,37.67036,0.005,NULL,59769214893,933893982,14592093,15.4),(136634,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136634,36.13,0.46,168,65009,70,NULL,NULL,'I Zw 138',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.00011,NULL,'15.5g',0.56,'E0',NULL,NULL,NULL,NULL,1,244.024833,50.91544,0.041,NULL,59709266913,932957295,14577457,15.5),(136635,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136635,37.13,0.13,267,65010,70,NULL,NULL,'2MASX J16160719+4917347',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000106,NULL,'15.6g',0.39,NULL,NULL,NULL,NULL,NULL,1,244.030125,49.29292,0,NULL,59703217750,932862777,14575980,15.6),(136636,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136636,37.81,0.46,365,65011,70,NULL,NULL,'2MASX J16160810+0850491',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,244.033875,8.84711,0.161,NULL,56470624138,882353502,13786773,17.4),(136637,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136637,37.99,0.46,397,65012,70,NULL,NULL,'2MASX J16161009+4751387',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,244.0419583,47.86086,0,NULL,59703307678,932864182,14576002,18.1),(136638,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136638,37.66,0.46,340,65013,70,NULL,NULL,'SDSS J161611.80+325742.4',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',NULL,'PHOT','16.2g',0.43,'BrClG',NULL,NULL,NULL,NULL,1,244.0492083,32.96178,0.025,NULL,59793272070,934269876,14597966,16.2),(136639,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136639,37.75,0.46,355,65014,70,NULL,NULL,'2MASX J16161193+0922401',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,244.049667,9.37775,0.145,NULL,56457320244,882145628,13783525,NULL),(136640,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136640,37.78,0.46,360,65015,70,NULL,NULL,'2MASX J16161378+1031251',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,244.057375,10.52347,0.177,NULL,56575150607,883986728,13812292,17.4),(136641,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136641,37.68,0.27,343,65016,70,NULL,NULL,'2MASX J16161554+3455451',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,244.064666667,34.92931,0.009,NULL,59779198213,934049972,14594530,17),(136642,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136642,37.68,0.27,343,65017,70,NULL,NULL,'2MASX J16161587+3453371',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000143,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,244.06625,34.89369,0.009,NULL,59779198915,934049983,14594530,17.7),(136643,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136643,31,0.4,15.8,65018,75,NULL,'B','UGC 10310',NULL,'1988NBGC.C....0000T',1988,1,2.8,NULL,'G',0.000004,NULL,'13.58',2.2,'SB(s)m',NULL,NULL,NULL,NULL,1,244.0764583,47.04642,0,NULL,59832495077,934882735,14607542,13.58),(136644,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136644,36.01,0.46,159,65019,70,NULL,NULL,'2MASX J16162041+1157191',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.0849583,11.95533,0.185,NULL,56576453789,884007090,13812610,16.3),(136645,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136645,38.5,0.46,502,65020,70,NULL,NULL,'2MASX J16162076+4839498',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000093,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,244.086625,48.66375,0,NULL,59703587779,932868559,14576071,17.9),(136646,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136646,37.26,0.46,283,65021,70,NULL,NULL,'2MASX J16162187+2248022',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,244.091125,22.80058,0.185,NULL,56643592422,885056131,13829002,17.7),(136647,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136647,37.44,0.46,307,65022,70,NULL,NULL,'2MASX J16162297+1321121',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.095833,13.35344,0.137,NULL,56542624286,883478504,13804351,17.1),(136648,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136648,37.2,0.46,275,65023,70,NULL,NULL,'2MASX J16162454+1538111',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000153,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,244.102125,15.63631,0.113,NULL,56546226255,883534785,13805231,16.8),(136649,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136649,37.62,0.46,334,65024,70,NULL,NULL,'2MASX J16162592+0009547',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000091,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,244.107875,0.16511,0.349,NULL,56448848713,882013261,13781457,17.9),(136650,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136650,37.06,0.46,258,65025,70,NULL,NULL,'2MASX J16162645+2824434',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,244.110333,28.41217,0.081,NULL,59743486919,933491983,14585812,17.6),(136651,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136651,37.25,0.46,281,65026,70,NULL,NULL,'2MASX J16162748+5212177',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000111,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,244.114541667,52.20483,0.057,NULL,59708927643,932951994,14577374,16.3),(136652,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136652,36.89,0.46,239,65027,70,NULL,NULL,'2MASX J16162832+2834494',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000184,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,244.118167,28.58047,0.069,NULL,59743612021,933493937,14585842,16.6),(136653,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136653,35.85,0.46,148,65028,70,NULL,NULL,'2MASX J16162994+2115052',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000178,NULL,'16.0g',0.32,NULL,NULL,NULL,NULL,NULL,1,244.124875,21.25142,0.157,NULL,56640934590,885014602,13828353,16),(136654,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2002de',NULL,136654,34.78,0.17,87.9,65029,74.2,NULL,'SALT 2','NGC 6104',0.028116,'2010ApJ...716..712A',2010,1,0.95,NULL,'G',0.0001,NULL,'14.2g',0.78,'S(R)pec/Pec    Sy1.5',NULL,NULL,NULL,'Sy 1.5',1,244.127875,35.70806,0.005,NULL,59778888207,934045128,14594455,14.2),(136655,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2002de',NULL,136655,35.35,0.09,117,65029,74.4,NULL,NULL,'NGC 6104',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136656,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2002de',NULL,136656,35.46,0.15,120,65029,70,NULL,'SALT 2','NGC 6104',0.028116,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136657,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2002de',NULL,136657,35.49,0.16,122,65029,73.8,NULL,'SALT 2 (SNANA)','NGC 6104',0.0277,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136658,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2002de','R',136658,35.45,0.05,123,65029,NULL,NULL,'MLCS2k2, R(V) = 3.1','NGC 6104',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136659,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2002de','R',136659,35.51,0.04,126,65029,NULL,NULL,'MLCS2k2, R(V) = 1.8','NGC 6104',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136660,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2002de',NULL,136660,35.63,0.19,130,65029,65,NULL,'MLCS31','NGC 6104',0.028116,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136661,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2002de',NULL,136661,35.66,0.2,132,65029,65,NULL,'SALT2','NGC 6104',0.028116,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136662,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2002de',NULL,136662,35.68,0.17,133,65029,65,NULL,'SALT','NGC 6104',0.028116,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136663,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2002de',NULL,136663,35.71,0.16,135,65029,65,NULL,'MLCS17','NGC 6104',0.028116,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136664,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2002de',NULL,136664,36.26,0.02,174,65029,70,NULL,'SALT 2','NGC 6104',0.028116,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136665,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136665,36.92,0.33,242,65030,70,NULL,NULL,'2MASX J16163080+1449062',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,244.128291667,14.81839,0.089,NULL,56554843142,883669424,13807334,17.7),(136666,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136666,36.49,0.46,199,65031,70,NULL,NULL,'2MASX J16163144+4122478',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00008,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,244.1309583,41.38003,0.005,NULL,59799499754,934367183,14599487,16.4),(136667,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136667,34.51,0.47,79.9,65032,70,NULL,NULL,'ESO 100- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'12.4R',0.9,'(R\'_1)SB(r)ab',NULL,NULL,NULL,NULL,1,244.136167,-65.65242,0.833,NULL,44995555304,703055551,10985242,12.4),(136668,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136668,37.42,0.46,305,65033,70,NULL,NULL,'2MASX J16163329+1726072',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,244.138875,17.43536,0.141,NULL,56543540761,883492824,13804575,17.2),(136669,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136669,36.92,0.33,242,65034,70,NULL,NULL,'2MASX J16163384+1447412',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00018,NULL,'16.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,244.141,14.79467,0.089,NULL,56554845161,883669455,13807335,16.9),(136670,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136670,37.46,0.46,310,65035,70,NULL,NULL,'2MASX J16163422+3246251',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000937,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,244.142625,32.77367,0.049,NULL,59790372970,934224577,14597259,18.1),(136671,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136671,37.21,0.46,277,65036,70,NULL,NULL,'2MASX J16163531+2119022',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,244.1472917,21.31739,0.157,NULL,56640990754,885015480,13828366,18.1),(136672,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136672,37.74,0.33,353,65037,70,NULL,NULL,'2MASX J16163551+5209367',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000092,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,244.147875,52.16042,0.057,NULL,59708926630,932951978,14577374,16.6),(136673,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136673,37.23,0.33,280,65038,70,NULL,NULL,'SDSS J161637.09+123654.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,244.154583,12.615,0.173,NULL,56542847343,883481989,13804406,18),(136674,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136674,35.12,NULL,106,65039,NULL,NULL,'Dipole','FGC 2013',NULL,'2010Ap&SS.325..163P',2010,1,1.18,NULL,'G',0.000009,NULL,'16.6',0.11,'Sc',NULL,NULL,NULL,NULL,1,244.17,14.65,0.137,NULL,56554942374,883670974,13807358,16.6),(136675,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136675,35.13,NULL,106,65039,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2013',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136676,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136676,35.13,NULL,106,65039,NULL,NULL,'Dipole + Quadrupole','FGC 2013',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136677,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136677,35.27,NULL,113,65039,NULL,NULL,NULL,'FGC 2013',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136678,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136678,35.41,0.2,121,65039,74.4,NULL,NULL,'FGC 2013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136679,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136679,37.22,0.46,278,65040,70,NULL,NULL,'2MASX J16164175+1407222',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,244.173917,14.12292,0.149,NULL,56554533289,883664582,13807259,17.4),(136680,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136680,38.02,0.21,401,65041,70,NULL,NULL,'2MASX J16164219+2700035',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.175708333,27.00106,0.101,NULL,59730183110,933284111,14582564,17.5),(136681,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136681,38.12,0.27,420,65042,70,NULL,NULL,'2MASX J16164222+1302442',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,244.176,13.04561,0.169,NULL,56543319721,883489370,13804521,16.4),(136682,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136682,37.18,0.46,273,65043,70,NULL,NULL,'2MASX J16164259+3400468',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000153,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,244.1775,34.01311,0.013,NULL,59792708082,934261063,14597829,17),(136683,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136683,38.12,0.27,420,65044,70,NULL,NULL,'2MASX J16164331+1256112',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,244.180458333,12.93644,0.169,NULL,56543339825,883489684,13804526,18),(136684,'IRAS','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136684,35.48,0.8,125,65045,75,NULL,'CF, r','UGC 10306',NULL,'1997ApJS..109..333W',1997,1,1.47,NULL,'G',0.00002,NULL,'14.8g',0.57,'(R\')SAB(s)b:','Group member',NULL,NULL,NULL,1,244.1815,0.24647,0.349,NULL,56448162247,882002535,13781289,14.8),(136685,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136685,35.17,0.38,108,65045,75,NULL,'CF, r, raw','UGC 10306',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136686,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136686,35.41,0.38,121,65045,75,NULL,'CF, r, inv','UGC 10306',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136687,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136687,35.41,0.38,121,65045,75,NULL,'CF, r, cor','UGC 10306',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136688,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136688,35.42,0.28,121,65045,NULL,NULL,'Malmquist cor.','UGC 10306',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136689,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136689,35.46,0.28,124,65045,NULL,NULL,NULL,'UGC 10306',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136690,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136690,35.51,0.2,126,65045,74.4,NULL,NULL,'UGC 10306',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136691,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136691,35.66,0.47,136,65045,NULL,NULL,'H','UGC 10306',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136692,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136692,35.72,0.4,139,65045,NULL,NULL,'mean','UGC 10306',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136693,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136693,35.84,0.46,147,65045,NULL,NULL,'J','UGC 10306',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136694,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136694,35.88,0.45,150,65045,NULL,NULL,'K','UGC 10306',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136695,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136695,36.58,0.46,207,65046,70,NULL,NULL,'2MASX J16164540+2851475',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000179,NULL,'16.1g',0.45,'SB0',NULL,NULL,NULL,NULL,1,244.18925,28.86333,0.065,NULL,59743424979,933491015,14585797,16.1),(136696,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136696,38.61,0.46,527,65047,70,NULL,NULL,'2MASX J16164992+2254589',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,244.208125,22.9165,0.197,NULL,56643774906,885058982,13829046,18),(136697,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136697,37.77,0.33,358,65048,70,NULL,NULL,'2MASX J16165007+1354115',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.20875,13.90319,0.149,NULL,56540757803,883449340,13803895,17.5),(136698,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136698,34.61,0.4,83.5,65049,NULL,NULL,'mean','IC 1211',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000063,NULL,'13.72',1,'E','Isolated galaxy',NULL,NULL,NULL,1,244.216583333,53.00603,0.021,NULL,59694442803,932725668,14573838,13.72),(136699,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136699,34.78,0.45,90.5,65049,NULL,NULL,'K','IC 1211',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136700,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136700,37.18,0.33,273,65050,70,NULL,NULL,'2MASX J16165216+3440139',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.0001,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,244.217417,34.67058,0.005,NULL,59792492650,934257697,14597776,16.7),(136701,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136701,36.08,0.46,164,65051,70,NULL,NULL,'2MASX J16165257+1433236',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00016,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,244.219167,14.55664,0.137,NULL,56554889793,883670153,13807346,16.3),(136702,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136702,38.02,0.21,401,65052,70,NULL,NULL,'2MASX J16165352+2656357',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000167,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,244.223,26.94333,0.101,NULL,59728299588,933254681,14582104,18.3),(136703,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136703,35.93,0.1,153,65053,70,NULL,NULL,'2MASX J16165400+3457159',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,244.224916667,34.95453,0.009,NULL,59779247689,934050745,14594542,16.9),(136704,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136704,37.4,0.46,302,65054,70,NULL,NULL,'SDSS J161654.82+403909.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,244.228458333,40.65258,0,NULL,59800260568,934379071,14599672,18.4),(136705,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136705,37.21,0.46,277,65055,70,NULL,NULL,'2MASX J16165564+1457546',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000163,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,244.231875,14.96514,0.125,NULL,56554822231,883669097,13807329,16.6),(136706,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136706,37.51,0.16,318,65056,70,NULL,NULL,'2MASX J16165626+2433007',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000179,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,244.234333,24.55025,0.141,NULL,56170989495,877671710,13713620,17.7),(136707,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136707,35.96,0.46,155,65057,70,NULL,NULL,'2MASX J16165621+1956289',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,244.234417,19.94131,0.137,NULL,56646468228,885101066,13829704,16.6),(136708,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136708,37.68,0.27,343,65058,70,NULL,NULL,'2MASX J16165653+3452279',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,244.235666667,34.87456,0.009,NULL,59779191600,934049868,14594529,17.9),(136709,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136709,38.02,0.21,401,65059,70,NULL,NULL,'2MASX J16165659+2657037',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000199,NULL,'17.3g',0.24,'BrClG',NULL,NULL,NULL,NULL,1,244.235917,26.95106,0.101,NULL,59728299804,933254684,14582104,17.3),(136710,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136710,37.77,0.46,358,65060,70,NULL,NULL,'2MASX J16165704+0639049',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,244.237625,6.65153,0.209,NULL,56465961609,882280650,13785635,17.4),(136711,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136711,38.02,0.21,401,65061,70,NULL,NULL,'2MASX J16165763+2657067',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000158,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,244.24025,26.95192,0.101,NULL,59728299831,933254684,14582104,18.3),(136712,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136712,37.54,0.46,322,65062,70,NULL,NULL,'2MASX J16165796-0018347',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000092,NULL,'16.7g',0.38,'BrClG',NULL,NULL,NULL,NULL,1,244.241375,-0.30983,0.369,NULL,45506185545,711034149,11109908,16.7),(136713,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136713,38.02,0.21,401,65063,70,NULL,NULL,'2MASX J16165845+2658037',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000166,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,244.243375,26.96789,0.101,NULL,59728301947,933254717,14582104,18.2),(136714,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136714,37.22,0.46,278,65064,70,NULL,NULL,'2MASX J16165853+1908049',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,244.244,19.13464,0.109,NULL,56514541502,883039710,13797495,17.9),(136715,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136715,37.77,0.46,357,65065,70,NULL,NULL,'2MASX J16165923+4014414',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00011,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,244.246917,40.24492,0,NULL,59799954790,934374293,14599598,16.9),(136716,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136716,38.12,0.27,420,65066,70,NULL,NULL,'2MASX J16170006+1308306',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,244.2502083,13.14194,0.161,NULL,56543316667,883489322,13804520,18.1),(136717,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136717,37.77,0.33,358,65067,70,NULL,NULL,'2MASX J16170168+1356236',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,244.256958333,13.93981,0.149,NULL,56540753787,883449277,13803894,16.7),(136718,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136718,38.92,0.46,608,65068,70,NULL,NULL,'2MASX J16170232+2202169',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000169,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,244.259583,22.03808,0.177,NULL,56641966147,885030721,13828605,18.4),(136719,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136719,37.38,0.46,300,65069,70,NULL,NULL,'2MASX J16170292+2603058',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000175,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,244.262,26.05153,0.081,NULL,59730810404,933293912,14582717,17.3),(136720,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136720,37.9,0.46,381,65070,70,NULL,NULL,'2MASX J16170358+1036059',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,244.2650417,10.60161,0.181,NULL,56576189759,884002964,13812546,17),(136721,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136721,37.52,0.46,319,65071,70,NULL,NULL,'2MASX J16170521+2428488',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.2717917,24.48022,0.141,NULL,56171103433,877673491,13713648,17.3),(136722,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136722,37.57,0.46,327,65072,70,NULL,NULL,'2MASX J16170809+2757308',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000172,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.283916667,27.95858,0.097,NULL,59742848669,933482010,14585656,17.1),(136723,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136723,37.51,0.46,318,65073,70,NULL,NULL,'2MASX J16170836-0027197',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000091,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,244.284916667,-0.4555,0.369,NULL,45506970971,711046421,11110100,16.9),(136724,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136724,38.1,0.46,416,65074,70,NULL,NULL,'2MASX J16170870+2729358',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000144,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,244.286333,27.49328,0.097,NULL,59742118496,933470601,14585478,18.2),(136725,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136725,35.44,NULL,123,65075,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2014',NULL,'2010Ap&SS.325..163P',2010,1,1.23,NULL,'G',0.00001,NULL,'16.4',0.11,'Scd',NULL,NULL,NULL,NULL,1,244.286833,19.99469,0.137,NULL,56646649323,885103895,13829748,16.4),(136726,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136726,35.46,NULL,124,65075,NULL,NULL,'Dipole + Quadrupole','FGC 2014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136727,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136727,35.47,NULL,124,65075,NULL,NULL,'Dipole','FGC 2014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136728,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136728,35.49,NULL,125,65075,NULL,NULL,NULL,'FGC 2014',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136729,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136729,35.67,0.49,136,65075,75,NULL,'IR','FGC 2014',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136730,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136730,35.55,0.25,129,65076,74.4,NULL,NULL,'NGC 6105',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000063,NULL,'15.29',0.5,'S0','Group member',NULL,NULL,NULL,1,244.2887917,34.87889,0.009,NULL,59778715711,934042432,14594413,15.29),(136731,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136731,35.77,0.32,143,65076,70,NULL,NULL,'NGC 6105',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136732,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136732,37.91,0.33,383,65077,70,NULL,NULL,'SDSS J161710.16+231338.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000153,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,244.292375,23.22742,0.161,NULL,56643688924,885057639,13829025,18.8),(136733,'IRAS','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136733,32.48,0.8,31.3,65078,75,NULL,'HMCL, I','ESO 137- G 014',NULL,'1997ApJS..109..333W',1997,1,1,'abs(b) < 10 degrees.','G',0.000053,NULL,'14.81',0.3,'S?;dusty patches','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,244.2950417,-58.31253,NULL,NULL,44380306845,693442294,10835035,14.81),(136734,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136734,31.91,0.4,24.1,65078,75,NULL,'HMCL, I, raw','ESO 137- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136735,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136735,31.98,0.4,24.9,65078,75,NULL,'HMCL, I, inv','ESO 137- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136736,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136736,32.27,0.4,28.5,65078,75,NULL,'HMCL, I, cor','ESO 137- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136737,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136737,37.51,0.16,318,65079,70,NULL,NULL,'2MASX J16171085+2429078',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000188,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,244.295125,24.48553,0.141,NULL,56171116650,877673697,13713651,16.6),(136738,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136738,35.93,0.1,153,65080,70,NULL,NULL,'2MASX J16171106+3530363',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000133,NULL,'16.2g',0.32,NULL,NULL,NULL,NULL,NULL,1,244.296291667,35.51014,0,NULL,59779075627,934048056,14594500,16.2),(136739,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136739,36.7,0.46,219,65081,70,NULL,NULL,'2MASX J16171159+3803366',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,244.2985,38.06025,0.005,NULL,59769274553,933894914,14592108,17.3),(136740,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136740,35.93,0.1,153,65082,70,NULL,NULL,'2MASX J16171197+3452583',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000133,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,244.3,34.88289,0.009,NULL,59778699491,934042179,14594409,NULL),(136741,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136741,37.91,0.33,383,65083,70,NULL,NULL,'2MASX J16171216+2320309',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000129,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,244.300583333,23.34211,0.185,NULL,56640223428,885003491,13828179,17.7),(136742,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136742,38.07,0.46,411,65084,70,NULL,NULL,'2MASXi J1617128+224138',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000168,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,244.303375,22.69397,0.185,NULL,56643661928,885057217,13829019,18.4),(136743,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136743,37.73,0.33,352,65085,70,NULL,NULL,'SDSS J161712.83+301939.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000142,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,244.3035,30.32767,0.029,NULL,59739587185,933431049,14584860,18.5),(136744,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136744,37.18,0.33,273,65086,70,NULL,NULL,'KUGX 1615+349A',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000133,NULL,'15.8g',0.44,'Compact',NULL,NULL,NULL,NULL,1,244.3092083,34.79906,0.005,NULL,59778673073,934041766,14594402,15.8),(136745,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136745,36.62,0.46,211,65087,70,NULL,NULL,'2MASX J16171505+2941268',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000113,NULL,'16.9g',0.29,'S0',NULL,NULL,NULL,NULL,1,244.312875,29.69081,0.057,NULL,59740476012,933444937,14585077,16.9),(136746,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136746,29.93,0.69,9.67,65088,100,NULL,'mid-IR','MCG -02-41-001',NULL,'2013ApJ...771...88L',2013,1,2.4,'Extended HIPASS source','G',0.000003,NULL,'15',1.7,'SAB(r)b?',NULL,NULL,NULL,NULL,1,244.31575,-11.73192,0.981,NULL,45567664451,711994757,11124918,15),(136747,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136747,30.76,0.4,14.2,65088,NULL,NULL,'mean','MCG -02-41-001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136748,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136748,31.48,0.45,19.8,65088,NULL,NULL,'K','MCG -02-41-001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136749,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136749,31.51,0.47,20,65088,NULL,NULL,'H','MCG -02-41-001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136750,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136750,31.56,0.46,20.5,65088,NULL,NULL,'J','MCG -02-41-001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136751,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','PS1 SN PS11aij','N',136751,42.21,0.15,1830,65089,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11aij HOST',0.51,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136752,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136752,37.51,0.46,318,65090,70,NULL,NULL,'2MASX J16171728+1649401',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000162,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,244.321875,16.82775,0.141,NULL,56544116473,883501819,13804715,16.7),(136753,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136753,36.94,0.46,245,65091,70,NULL,NULL,'KUGX 1615+332',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000169,NULL,'16.0g',0.44,'Compact',NULL,NULL,NULL,NULL,1,244.3287917,33.08317,0.045,NULL,59793460847,934272825,14598012,16),(136754,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136754,37.02,0.46,253,65092,70,NULL,NULL,'KUGX 1615+360',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000127,NULL,'16.1g',0.28,'Spiral',NULL,NULL,NULL,NULL,1,244.3289583,35.95111,0.013,NULL,59779040015,934047500,14594492,16.1),(136755,'D-Sigma','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136755,35.07,0.4,103,65093,75,NULL,'Edat, raw','NGC 6107',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000053,NULL,'14.89',0.7,'cD;E:','Group member',NULL,NULL,NULL,1,244.333875,34.90194,0.013,NULL,59778699913,934042186,14594409,14.89),(136756,'D-Sigma','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136756,35.41,0.4,121,65093,75,NULL,'Edat, cor','NGC 6107',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136757,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136757,35.56,0.25,129,65093,74.4,NULL,NULL,'NGC 6107',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136758,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136758,35.77,0.32,143,65093,70,NULL,NULL,'NGC 6107',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136759,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136759,32.92,0.49,38.4,65094,75,NULL,'IR','UGC 10331',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.00004,NULL,'14.79',0.3,'S pec          Sbrst',NULL,NULL,NULL,NULL,1,244.3380417,59.32011,0,NULL,57623243278,900363176,14068174,14.79),(136760,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136760,37.97,0.46,392,65095,70,NULL,NULL,'SDSS J161723.32+212559.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,244.3472083,21.43317,0.153,NULL,56654774590,885230852,13831732,18.2),(136761,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136761,35.93,0.1,153,65096,70,NULL,NULL,'2MASX J16172391+3458164',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000133,NULL,'16.1g',0.32,'S0^-',NULL,NULL,NULL,NULL,1,244.3497917,34.97133,0.013,NULL,59779212492,934050195,14594534,16.1),(136762,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136762,36.43,0.23,193,65097,70,NULL,NULL,'2MASX J16172531+5038396',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.35525,50.64444,0.045,NULL,59707334091,932927095,14576985,16.8),(136763,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136763,37.66,0.46,341,65098,70,NULL,NULL,'2MASX J16172545+2606539',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000176,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,244.356083333,26.11514,0.081,NULL,59730665801,933291653,14582682,17.3),(136764,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136764,36.43,0.23,193,65099,70,NULL,NULL,'2MASX J16172879+5037216',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,244.369833333,50.62258,0.053,NULL,59707334337,932927099,14576985,16.3),(136765,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136765,36.76,0.23,225,65100,70,NULL,NULL,'2MASX J16172932+5018396',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'15.8g',0.42,NULL,NULL,NULL,NULL,NULL,1,244.372083,50.31119,0.041,NULL,59707806074,932934469,14577101,15.8),(136766,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136766,37.68,0.33,343,65101,70,NULL,NULL,'2MASX J16172932+0707229',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000171,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.3722083,7.12306,0.221,NULL,56468360736,882318136,13786220,17.5),(136767,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136767,35.93,0.1,153,65102,70,NULL,NULL,'KUGX 1615+349B',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000067,NULL,'15.7g',0.37,'Compact',NULL,NULL,NULL,NULL,1,244.3735,34.82286,0.013,NULL,59778718419,934042475,14594413,15.7),(136768,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136768,37.74,0.33,353,65103,70,NULL,NULL,'2MASX J16173099+5217226',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000095,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.378917,52.28953,0.037,NULL,59708161251,932940019,14577187,17.4),(136769,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136769,37.23,0.46,279,65104,70,NULL,NULL,'2MASX J16173125+2908230',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000185,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,244.380125,29.13958,0.053,NULL,59742960264,933483754,14585683,17.1),(136770,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136770,35.93,0.1,153,65105,70,NULL,NULL,'2MASX J16173164+3456244',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.381917,34.94019,0.013,NULL,59778701895,934042217,14594409,17.3),(136771,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136771,35.93,0.1,153,65106,70,NULL,NULL,'2MASX J16173188+3456454',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000073,NULL,'16.77',0.33,NULL,NULL,NULL,NULL,NULL,1,244.382875,34.94594,0.013,NULL,59778701442,934042210,14594409,16.77),(136772,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136772,38.26,0.33,450,65107,70,NULL,NULL,'2MASX J16173202+2343598',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,244.3835,23.73325,0.161,NULL,56640569893,885008904,13828264,17.6),(136773,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136773,34.87,0.46,94.1,65108,70,NULL,NULL,'2MASX J16173377+4141186',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.0001,NULL,'15.8g',0.3,'S0/a',NULL,NULL,NULL,NULL,1,244.390541667,41.68856,0.005,NULL,59799280908,934363764,14599433,15.8),(136774,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136774,37.68,0.33,343,65109,70,NULL,NULL,'2MASX J16173436+0706099',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000165,NULL,'16.7g',0.35,NULL,NULL,NULL,NULL,NULL,1,244.393333,7.10283,0.209,NULL,56468359493,882318117,13786220,16.7),(136775,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136775,38.19,0.46,434,65110,70,NULL,NULL,'2MASX J16173488+0853009',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,244.3954583,8.88353,0.161,NULL,56470599781,882353121,13786767,17),(136776,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136776,35.39,0.46,120,65111,70,NULL,NULL,'CGCG 079-089',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000036,NULL,'15.2',0.6,NULL,NULL,NULL,NULL,NULL,1,244.39675,13.49203,0.137,NULL,56542556171,883477440,13804335,15.2),(136777,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136777,35.93,0.1,153,65112,70,NULL,NULL,'KUGX 1615+352B',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000067,NULL,'15.5g',0.27,'S0',NULL,NULL,NULL,NULL,1,244.3982917,35.13411,0.005,NULL,59779272516,934051133,14594548,15.5),(136778,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136778,37.13,0.13,267,65113,70,NULL,NULL,'2MASX J16173680+4956447',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,244.403208333,49.94578,0.033,NULL,59707985136,932937267,14577144,17.7),(136779,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136779,37.31,0.46,290,65114,70,NULL,NULL,'2MASX J16173860+5147037',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000079,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,244.411083,51.78436,0.029,NULL,59708654525,932947726,14577308,16.9),(136780,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136780,37.73,0.33,352,65115,70,NULL,NULL,'2MASX J16173867+3019364',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,244.41125,30.32669,0.029,NULL,59739679007,933432484,14584882,18.2),(136781,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136781,35.93,0.1,153,65116,70,NULL,NULL,'KUGX 1615+351B',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000133,NULL,'15.8g',0.25,'Compact',NULL,NULL,NULL,NULL,1,244.4115,35.06,0.005,NULL,59779203416,934050053,14594532,15.8),(136782,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136782,32.24,0.49,28.1,65117,70,NULL,NULL,'IC 4597',NULL,'2014MNRAS.445.2677S',2014,1,1.5,'This may also be NGC 6082.','G',0.000024,NULL,'16.4',1.2,'S        poss. LINER',NULL,NULL,NULL,NULL,1,244.415541667,-34.36594,1.057,NULL,46302408469,723475132,11304298,16.4),(136783,'D-Sigma','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136783,35.07,0.4,103,65118,75,NULL,'Edat, raw','NGC 6109',NULL,'1997ApJS..109..333W',1997,1,1.06,NULL,'G',0.00005,NULL,'14.2g',1,'E/S0;BrClG;LERGLINER','Group member',NULL,'FR I',NULL,1,244.418833333,35.00428,0.013,NULL,59778696922,934042139,14594408,14.2),(136784,'D-Sigma','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136784,35.41,0.4,121,65118,75,NULL,'Edat, cor','NGC 6109',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136785,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136785,35.55,0.25,129,65118,74.4,NULL,NULL,'NGC 6109',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136786,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136786,35.77,0.32,143,65118,70,NULL,NULL,'NGC 6109',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136787,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136787,35.93,0.1,153,65118,70,NULL,NULL,'NGC 6109',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136788,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136788,37.79,0.46,361,65119,70,NULL,NULL,'SDSS J161740.62+242259.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,244.41925,24.38311,0.185,NULL,56171063332,877672864,13713638,18.2),(136789,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136789,37.69,0.46,344,65120,70,NULL,NULL,'2MASX J16174100+1234221',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000185,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,244.4207917,12.57292,0.169,NULL,56542737761,883480277,13804379,17.1),(136790,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136790,35.93,0.1,153,65121,70,NULL,NULL,'2MASX J16174311+3502284',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000168,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,244.4295417,35.04111,0.005,NULL,59779203697,934050057,14594532,16.6),(136791,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136791,37.6,0.33,330,65122,70,NULL,NULL,'SDSS J161743.51+192655.2',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000166,NULL,'18.7g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,244.431333333,19.44869,0.133,NULL,56644664539,885072883,13829263,18.7),(136792,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136792,37.6,0.33,330,65123,70,NULL,NULL,'2MASX J16174365+1927579',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,244.431833,19.46597,0.133,NULL,56644665242,885072894,13829263,17.1),(136793,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136793,35.93,0.1,153,65124,70,NULL,NULL,'2MASX J16174481+3510485',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000133,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,244.43675,35.18006,0.005,NULL,59779090602,934048290,14594504,16.5),(136794,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136794,35.93,0.1,153,65125,70,NULL,NULL,'2MASX J16174565+3449445',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000133,NULL,'16.0g',0.4,'E0',NULL,NULL,NULL,NULL,1,244.440417,34.829,0.013,NULL,59778712697,934042385,14594412,16),(136795,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136795,37.86,0.46,373,65126,70,NULL,NULL,'2MASX J16174705+2838080',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000143,NULL,'17.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,244.446,28.6355,0.065,NULL,59743566377,933493224,14585831,17.6),(136796,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136796,37.6,0.33,331,65127,70,NULL,NULL,'2MASX J16174739+1512098',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000171,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,244.4475,15.20286,0.129,NULL,56545651782,883525809,13805090,17.1),(136797,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','PS1 SN PS10jv','N',136797,41.29,0.12,1330,65128,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10jv HOST',0.36,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136798,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136798,36.13,0.46,169,65129,70,NULL,NULL,'2MASX J16174776+4115300',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,244.448917,41.25828,0,NULL,59799430380,934366099,14599470,16.7),(136799,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136799,37.04,0.46,256,65130,70,NULL,NULL,'2MASX J16174786+1427038',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000184,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,244.4495,14.45094,0.137,NULL,56554043244,883656925,13807139,17.1),(136800,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136800,36.43,0.23,193,65131,70,NULL,NULL,'2MASX J16174905+5019497',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',NULL,NULL,'15.8g',0.46,NULL,NULL,NULL,NULL,NULL,1,244.454375,50.33042,0.041,NULL,59707790015,932934218,14577097,15.8),(136801,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136801,37.77,0.46,358,65132,70,NULL,NULL,'2MASX J16174920+4805337',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000139,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,244.455291667,48.09272,0,NULL,59703527067,932867610,14576056,17.7),(136802,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136802,35.56,0.2,129,65133,74.4,NULL,NULL,'CGCG 109-001',NULL,'2013AJ....146...86T',2013,1,0.91,NULL,'G',0.00006,NULL,'15.5g',0.49,'SBc',NULL,NULL,NULL,NULL,1,244.456,20.69131,0.113,NULL,56647123903,885111310,13829864,15.5),(136803,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136803,35.46,0.46,123,65134,70,NULL,NULL,'2MASX J16174983+1552218',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000087,NULL,'15.4g',0.49,NULL,NULL,NULL,NULL,NULL,1,244.4574583,15.87281,0.113,NULL,56545867505,883529179,13805143,15.4),(136804,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136804,37.35,0.46,295,65135,70,NULL,NULL,'2MASX J16175003+3834350',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000166,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,244.458666667,38.57647,0,NULL,59798804495,934356320,14599317,17),(136805,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136805,37.13,0.13,267,65136,70,NULL,NULL,'2MASX J16175045+4944477',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,244.4602083,49.74667,0.029,NULL,59707856874,932935263,14577113,NULL),(136806,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136806,37.73,0.46,351,65137,70,NULL,NULL,'2MASX J16175067+1652328',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,244.461083,16.87589,0.149,NULL,56544145506,883502273,13804723,17.6),(136807,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136807,37.34,0.46,293,65138,70,NULL,NULL,'2MASX J16175134+2955376',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,244.4640417,29.92711,0.061,NULL,59740466363,933444786,14585074,17.4),(136808,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136808,38.1,0.46,416,65139,70,NULL,NULL,'2MASX J16175212+2408100',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000187,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,244.4672083,24.13628,0.173,NULL,56170517431,877664334,13713505,17.2),(136809,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136809,35.93,0.1,153,65140,70,NULL,NULL,'2MASX J16175279+3514496',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000133,NULL,'16.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,244.4699583,35.24708,0,NULL,59779100962,934048452,14594507,16.4),(136810,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136810,38.26,0.33,450,65141,70,NULL,NULL,'2MASX J16175356+2339449',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000186,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,244.4732917,23.66244,0.161,NULL,56640579695,885009057,13828266,18.1),(136811,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136811,38.27,0.46,451,65142,70,NULL,NULL,'2MASX J16175444+2226259',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000182,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,244.477,22.44069,0.153,NULL,56641728695,885027010,13828547,17.4),(136812,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136812,37.16,0.46,271,65143,70,NULL,NULL,'2MASX J16175453+2421398',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000166,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,244.47725,24.36125,0.185,NULL,56171062951,877672858,13713638,16.8),(136813,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136813,36.64,0.46,213,65144,70,NULL,NULL,'2MASX J16175702-0022530',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00008,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,244.487667,-0.38144,0.369,NULL,45506253335,711035208,11109925,17.2),(136814,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136814,38.02,0.46,402,65145,70,NULL,NULL,'2MASX J16175704+3808280',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,244.4877083,38.14108,0.005,NULL,59769284947,933895077,14592110,17.3),(136815,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136815,37.6,0.33,331,65146,70,NULL,NULL,'2MASX J16175872+1510168',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000161,NULL,'16.7g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,244.494583,15.17125,0.129,NULL,56545700012,883526562,13805102,16.7),(136816,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136816,38.02,0.33,401,65147,70,NULL,NULL,'2MASX J16175994+3001077',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,244.49975,30.01872,0.061,NULL,59740341667,933442838,14585044,17.2),(136817,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136817,36.75,0.27,223,65148,70,NULL,NULL,'2MASX J16180044+4123320',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.00013,NULL,'15.6g',0.48,'BrClG',NULL,NULL,NULL,NULL,1,244.50175,41.39219,0.005,NULL,59799391178,934365487,14599460,15.6),(136818,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136818,35.56,0.25,129,65149,74.4,NULL,NULL,'NGC 6112',NULL,'2013AJ....146...86T',2013,1,0.88,NULL,'G',0.000063,NULL,'14.5g',0.82,'E/S0','Group member',NULL,NULL,NULL,1,244.502333,35.11028,0.005,NULL,59779088693,934048260,14594504,14.5),(136819,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136819,35.77,0.32,143,65149,70,NULL,NULL,'NGC 6112',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136820,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136820,35.93,0.1,153,65149,70,NULL,NULL,'NGC 6112',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136821,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136821,38.24,0.46,445,65150,70,NULL,NULL,'2MASX J16180175+1647058',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000132,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,244.507417,16.78503,0.149,NULL,56544185288,883502895,13804732,17.8),(136822,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136822,38.72,0.46,555,65151,70,NULL,NULL,'SDSS J161802.85-002604.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000095,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,244.511917,-0.43456,0.369,NULL,45506254640,711035228,11109925,18.5),(136823,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136823,37.93,0.46,385,65152,70,NULL,NULL,'SDSS J161804.83+082722.2',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,244.520167,8.45619,0.201,NULL,56471233426,882363022,13786922,NULL),(136824,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136824,35.52,0.2,127,65153,74.4,NULL,NULL,'UGC 10320',NULL,'2013AJ....146...86T',2013,1,0.93,NULL,'G',0.000033,NULL,'15.2g',0.35,'Sab',NULL,NULL,NULL,NULL,1,244.5307083,21.06644,0.157,NULL,56646331547,885098930,13829670,15.2),(136825,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136825,35.78,0.4,143,65153,NULL,NULL,'mean','UGC 10320',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136826,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136826,35.95,0.47,155,65153,NULL,NULL,'H','UGC 10320',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136827,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136827,36.05,0.45,162,65153,NULL,NULL,'K','UGC 10320',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136828,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136828,33.95,0.49,61.7,65154,75,NULL,'IR','UGC 10322',NULL,'2011yCatp016004901K',2011,1,1.41,'Multiple SDSS entries describe this object.','G',0.000013,NULL,'14.4g',0.38,'S',NULL,NULL,NULL,NULL,1,244.53275,22.22572,0.153,NULL,56641931077,885030173,13828596,14.4),(136829,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136829,33.99,0.47,62.7,65154,NULL,NULL,'H','UGC 10322',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136830,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136830,34.07,0.45,65.1,65154,NULL,NULL,'K','UGC 10322',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136831,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136831,34.08,0.4,65.6,65154,NULL,NULL,'mean','UGC 10322',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136832,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136832,34.15,0.46,67.7,65154,NULL,NULL,'J','UGC 10322',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136833,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136833,38.06,0.33,409,65155,70,NULL,NULL,'SDSS J161808.40+123139.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,244.535,12.52772,0.185,NULL,56539902591,883435977,13803687,18.1),(136834,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136834,37.54,0.46,323,65156,70,NULL,NULL,'2MASX J16180900+4215334',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000188,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,244.537375,42.25939,0.005,NULL,59856951748,935264871,14613513,16.9),(136835,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136835,36.84,0.46,233,65157,70,NULL,NULL,'2MASX J16181082+2233109',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,244.5452083,22.553,0.153,NULL,56641718546,885026852,13828544,17),(136836,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136836,36.75,0.27,223,65158,70,NULL,NULL,'2MASX J16181233+4128290',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000087,NULL,'16.25',0.47,NULL,NULL,NULL,NULL,NULL,1,244.5514583,41.47486,0,NULL,59854914056,935233032,14613016,16.25),(136837,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136837,38.77,0.46,568,65159,70,NULL,NULL,'SDSS J161812.67+100944.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,244.5527917,10.16244,0.169,NULL,56459112053,882173625,13783962,18.3),(136838,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136838,37.5,0.62,316,65160,70,NULL,NULL,'2MASX J16181280-1616082',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.8I',0.3,NULL,NULL,NULL,NULL,NULL,1,244.5532917,-16.26889,0.857,NULL,45459474428,710304287,11098504,14.8),(136839,'IRAS','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136839,33.32,0.8,46.2,65161,75,NULL,'MAT, I','IC 4598',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.00002,NULL,'13.07',0.6,'Sb:            HII',NULL,NULL,NULL,NULL,1,244.5554583,-31.44289,1.073,NULL,46301161390,723455646,11303994,13.07),(136840,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136840,32.97,0.32,39.3,65161,85,NULL,'I, raw','IC 4598',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136841,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136841,32.99,0.32,39.6,65161,85,NULL,'I, inv','IC 4598',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136842,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136842,33.12,0.2,42.1,65161,74.4,NULL,NULL,'IC 4598',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136843,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136843,33.15,0.43,42.7,65161,75,NULL,'MAT, I, raw','IC 4598',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136844,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136844,33.27,0.43,45.1,65161,75,NULL,'MAT, I, inv','IC 4598',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136845,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136845,33.69,0.43,54.7,65161,75,NULL,'MAT, I, cor','IC 4598',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136846,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136846,36.15,0.46,170,65162,70,NULL,NULL,'CGCG 079-093',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000163,NULL,'15.4g',0.53,NULL,NULL,NULL,NULL,NULL,1,244.5560417,12.71603,0.185,NULL,56542702979,883479734,13804370,15.4),(136847,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136847,37.94,0.46,388,65163,70,NULL,NULL,'2MASX J16181527+5224281',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000076,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,244.563583,52.40786,0.037,NULL,59694460953,932725952,14573843,17.8),(136848,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','PS1 SN PS10ju','N',136848,41.16,0.15,1290,65164,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10ju HOST',0.323,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136849,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136849,37.81,0.46,364,65165,70,NULL,NULL,'2MASX J16181616+3617310',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.001162,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,244.5672083,36.29197,0.025,NULL,59780903528,934076617,14594947,17.8),(136850,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136850,38.01,0.46,401,65166,70,NULL,NULL,'2MASX J16181616+1649123',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,244.567291667,16.81994,0.149,NULL,56544176436,883502756,13804730,17.6),(136851,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136851,37.9,0.46,381,65167,70,NULL,NULL,'2MASX J16181654+1237293',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,244.569,12.62478,0.185,NULL,56539931401,883436428,13803694,17.2),(136852,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136852,35.54,0.65,128,65168,70,NULL,NULL,'2MASX J16181677-2201195',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,244.5699583,-22.02214,0.669,NULL,45905468172,717272940,11207389,15.7),(136853,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136853,35.93,0.46,153,65169,70,NULL,NULL,'2MASX J16181763+3818410',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000087,NULL,'15.5g',0.44,'E0',NULL,NULL,NULL,NULL,1,244.5735417,38.31133,0.005,NULL,59798794270,934356160,14599315,15.5),(136854,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136854,36.02,0.46,160,65170,70,NULL,NULL,'KUGX 1616+342',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000133,NULL,'15.8g',0.42,'Compact',NULL,NULL,NULL,NULL,1,244.5777917,34.11114,0.025,NULL,59792605279,934259457,14597804,15.8),(136855,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136855,38.16,0.46,428,65171,70,NULL,NULL,'2MASX J16182068+3820411',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000158,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.5862083,38.34478,0.005,NULL,59798841410,934356897,14599326,17.4),(136856,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136856,37.6,0.46,332,65172,70,NULL,NULL,'SDSS J161821.39+002649.9',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000091,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,244.589125,0.44722,0.361,NULL,56448105031,882001641,13781275,17.1),(136857,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136857,35.93,0.1,153,65173,70,NULL,NULL,'2MASX J16182160+3459507',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000162,NULL,'16.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,244.589833,34.99758,0.013,NULL,59778742162,934042846,14594419,16.5),(136858,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136858,37.51,0.16,318,65174,70,NULL,NULL,'2MASX J16182337+2405230',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000174,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,244.597333,24.08983,0.173,NULL,56640505341,885007895,13828248,17.7),(136859,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136859,35.55,0.25,129,65175,74.4,NULL,NULL,'NGC 6114',NULL,'2013AJ....146...86T',2013,1,0.93,NULL,'G',0.000063,NULL,'14.8g',0.65,'S0a','Group member',NULL,NULL,NULL,1,244.5984583,35.17431,0.005,NULL,59778623249,934040988,14594390,14.8),(136860,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136860,35.77,0.32,143,65175,70,NULL,NULL,'NGC 6114',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136861,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136861,35.93,0.1,153,65176,70,NULL,NULL,'2MASX J16182423+3519357',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000067,NULL,'15.5g',0.39,'S0',NULL,NULL,NULL,NULL,1,244.6009583,35.3265,0,NULL,59779110596,934048603,14594509,15.5),(136862,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136862,38.06,0.33,409,65177,70,NULL,NULL,'2MASX J16182468+1228113',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000184,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,244.602917,12.46983,0.185,NULL,56539915178,883436174,13803690,17.5),(136863,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136863,36.99,0.46,250,65178,70,NULL,NULL,'KUG 1616+338A',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000187,NULL,'16.8g',0.24,'Compact',NULL,NULL,NULL,NULL,1,244.612,33.71461,0,NULL,59793016289,934265879,14597904,16.8),(136864,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136864,38.02,0.33,401,65179,70,NULL,NULL,'2MASX J16182930+3005517',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000143,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,244.622125,30.09786,0.029,NULL,59739642991,933431921,14584873,18.2),(136865,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136865,35.93,0.1,153,65180,70,NULL,NULL,'2MASX J16182971+3518367',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000113,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,244.623583,35.31006,0,NULL,59779064321,934047880,14594498,16.7),(136866,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136866,33.9,0.49,60.4,65181,75,NULL,'IR','UGC 10327',NULL,'2011yCatp016004901K',2011,1,1.37,NULL,'G',0.00001,NULL,'15.7g',0.25,'Sc',NULL,NULL,NULL,NULL,1,244.624958333,22.16314,0.153,NULL,56641866112,885029158,13828580,15.7),(136867,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136867,33.93,0.2,61.1,65181,74.4,NULL,NULL,'UGC 10327',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (136868,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136868,34.25,NULL,70.8,65181,NULL,NULL,NULL,'UGC 10327',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136869,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136869,34.26,NULL,71.3,65181,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10327',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136870,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136870,34.29,NULL,72.3,65181,NULL,NULL,'Dipole + Quadrupole','UGC 10327',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136871,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136871,34.31,NULL,72.8,65181,NULL,NULL,'Dipole','UGC 10327',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136872,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136872,38.26,0.27,449,65182,70,NULL,NULL,'2MASX J16183037+1956479',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,244.626583,19.94661,0.137,NULL,56647697193,885120268,13830004,17),(136873,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136873,38.27,0.46,452,65183,70,NULL,NULL,'2MASX J16183131+3434097',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,244.630667,34.5695,0,NULL,59792524165,934258190,14597784,17.5),(136874,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136874,38.26,0.27,449,65184,70,NULL,NULL,'2MASX J16183307+1957389',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000171,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,244.6377917,19.96089,0.137,NULL,56647696980,885120265,13830004,17.5),(136875,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136875,38.31,0.46,458,65185,70,NULL,NULL,'2MASX J16183309+5126351',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000086,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,244.638041667,51.443,0.021,NULL,59708590798,932946731,14577292,17.7),(136876,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136876,34.14,0.66,67.1,65186,70,NULL,NULL,'2MASX J16183451-1517392',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,244.6437917,-15.29425,1.149,NULL,45459001931,710296905,11098389,14.5),(136877,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136877,38.53,0.46,509,65187,70,NULL,NULL,'2MASX J16183474+4840031',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.644833,48.66756,0,NULL,59703675775,932869933,14576092,17.6),(136878,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136878,37.23,0.33,279,65188,70,NULL,NULL,'UGC 10332 NED01',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00015,NULL,'16.5g',0.36,'E;BrClG',NULL,NULL,NULL,NULL,1,244.6465,29.81731,0.061,NULL,59740367098,933443235,14585050,16.5),(136879,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136879,38.32,0.46,461,65189,70,NULL,NULL,'2MASX J16183536+1109376',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,244.647208333,11.16036,0.209,NULL,56573383072,883959110,13811861,17.8),(136880,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136880,37.76,0.46,357,65190,70,NULL,NULL,'2MASX J16183643+5147161',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000081,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,244.6515417,51.78789,0.029,NULL,59708652158,932947689,14577307,17.7),(136881,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136881,37.23,0.33,279,65191,70,NULL,NULL,'UGC 10332 NED02',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000165,NULL,'16.9g',0.3,'Sc',NULL,NULL,NULL,NULL,1,244.6567917,29.81358,0.061,NULL,59740368914,933443264,14585051,16.9),(136882,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136882,37.58,0.33,328,65192,70,NULL,NULL,'2MASX J16183824+2356333',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000183,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,244.659291667,23.94258,0.173,NULL,56640645621,885010087,13828282,16.4),(136883,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136883,38.13,0.27,423,65193,70,NULL,NULL,'2MASX J16184093+1948088',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,244.670583333,19.80247,0.137,NULL,56647729746,885120777,13830012,17.1),(136884,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136884,36.71,0.55,220,65194,70,NULL,NULL,'2MASX J16184123-1542122',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,244.671833,-15.70333,1.061,NULL,45459831527,710309867,11098591,15.4),(136885,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136885,35.92,0.46,153,65195,70,NULL,NULL,'2MASX J16184119+3037417',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000156,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,244.671833,30.62836,0.037,NULL,59739512008,933429875,14584841,16.4),(136886,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136886,36.75,0.27,223,65196,70,NULL,NULL,'2MASX J16184161+4129581',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000097,NULL,'16.1g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,244.6735,41.49953,0,NULL,59855059408,935235303,14613051,16.1),(136887,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136887,38.26,0.27,449,65197,70,NULL,NULL,'2MASX J16184200+1957128',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.6750417,19.95353,0.137,NULL,56647699420,885120303,13830004,17.5),(136888,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136888,38.13,0.27,423,65198,70,NULL,NULL,'SDSS J161842.39+194927.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000136,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,244.676625,19.82428,0.137,NULL,56647700741,885120324,13830005,18.5),(136889,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136889,36.73,0.46,222,65199,70,NULL,NULL,'2MASX J16184303+1433104',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000176,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,244.67925,14.55292,0.133,NULL,56540370211,883443284,13803801,16.2),(136890,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136890,37.51,0.16,318,65200,70,NULL,NULL,'2MASX J16184413+2419554',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,244.683833,24.33211,0.185,NULL,56170635998,877666187,13713534,17.1),(136891,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136891,37.14,0.46,268,65201,70,NULL,NULL,'2MASX J16184478+4147531',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,244.686791667,41.79817,0,NULL,59854858991,935232171,14613002,17.3),(136892,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136892,35.54,0.46,128,65202,70,NULL,NULL,'CGCG 223-056',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.000107,NULL,'15.0g',0.54,'S0','Isolated galaxy',NULL,NULL,NULL,1,244.6907917,39.33444,0.017,NULL,59798583342,934352864,14599263,15),(136893,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136893,37.58,0.33,328,65203,70,NULL,NULL,'2MASX J16184663+2354544',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000151,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,244.694541667,23.91525,0.173,NULL,56640652147,885010189,13828284,17),(136894,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136894,37.94,0.19,387,65204,70,NULL,NULL,'SDSS J161847.15+105842.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,244.6965,10.97844,0.193,NULL,56573395205,883959300,13811864,18.3),(136895,'IRAS','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136895,31.88,0.8,23.7,65205,75,NULL,'A82, H','NGC 6106',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000019,NULL,'12.84',1.4,'SA(s)c','Line-of-sight pair member',NULL,NULL,NULL,1,244.696541667,7.41089,0.213,NULL,56468231994,882316124,13786189,12.84),(136896,'IRAS','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136896,31.94,0.8,24.5,65205,75,NULL,'CF, r','NGC 6106',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136897,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136897,30.97,0.69,15.6,65205,100,NULL,'mid-IR','NGC 6106',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136898,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136898,31.11,0.4,16.7,65205,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 6106',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136899,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136899,31.6,0.47,20.9,65205,75,NULL,'A82, H, raw','NGC 6106',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136900,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136900,31.61,0.47,21,65205,75,NULL,'A82, H, inv','NGC 6106',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136901,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136901,31.8,0.43,22.9,65205,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6106',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136902,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136902,31.85,0.43,23.4,65205,75,NULL,'3.6 micron, color corrected','NGC 6106',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136903,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136903,31.93,0.2,24.3,65205,74.4,NULL,NULL,'NGC 6106',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136904,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136904,31.94,0.4,24.4,65205,NULL,NULL,'mean','NGC 6106',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136905,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136905,31.94,0.4,24.5,65205,75,NULL,'B','NGC 6106',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136906,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136906,31.95,0.47,24.5,65205,75,NULL,'A82, H, cor','NGC 6106',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136907,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136907,31.95,NULL,24.6,65205,72,NULL,NULL,'NGC 6106',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136908,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136908,31.96,0.36,24.7,65205,NULL,NULL,NULL,'NGC 6106',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136909,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136909,32.01,0.38,25.3,65205,75,NULL,'CF, r, raw','NGC 6106',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136910,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136910,32.07,0.38,26,65205,75,NULL,'CF, r, inv','NGC 6106',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136911,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136911,32.13,0.45,26.7,65205,NULL,NULL,'Malmquist cor.','NGC 6106',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136912,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136912,32.14,0.46,26.7,65205,NULL,NULL,'J','NGC 6106',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136913,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136913,32.15,0.47,26.9,65205,NULL,NULL,'H','NGC 6106',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136914,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136914,32.16,0.44,27,65205,NULL,NULL,NULL,'NGC 6106',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136915,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136915,32.19,0.38,27.4,65205,75,NULL,'CF, r, cor','NGC 6106',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136916,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136916,32.2,0.45,27.6,65205,NULL,NULL,'K','NGC 6106',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136917,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136917,38.13,0.27,423,65206,70,NULL,NULL,'2MASX J16184768+1950057',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,244.6987917,19.83475,0.137,NULL,56647731708,885120807,13830012,18),(136918,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136918,36.52,0.46,201,65207,70,NULL,NULL,'2MASX J16184795+2218147',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000181,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,244.7000417,22.304,0.153,NULL,56641391425,885021741,13828464,16.7),(136919,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136919,37.67,0.46,342,65208,70,NULL,NULL,'2MASX J16185049+4753540',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,244.7102083,47.89825,0.005,NULL,59834331475,934911429,14607991,17.2),(136920,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','PS1 SN PS10kc','N',136920,41.14,0.15,1260,65209,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10kc HOST',0.347,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136921,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136921,37.3,0.46,288,65210,70,NULL,NULL,'2MASX J16185475+4510384',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,244.728083,45.17719,0,NULL,59852164008,935190062,14612344,17.2),(136922,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136922,37.94,0.19,387,65211,70,NULL,NULL,'2MASX J16185520+1050226',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,244.730083,10.83969,0.185,NULL,56455819783,882122184,13783159,16.9),(136923,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136923,37.94,0.19,387,65212,70,NULL,NULL,'2MASX J16185547+1055246',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,244.7312917,10.92356,0.193,NULL,56455809964,882122030,13783156,17),(136924,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136924,36.95,0.33,245,65213,70,NULL,NULL,'2MASX J16185620+4629024',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,244.734041667,46.48406,0,NULL,59835560699,934930635,14608291,16.8),(136925,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136925,38.38,0.46,474,65214,70,NULL,NULL,'2MASX J16185790+5206116',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000097,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,244.740917,52.10317,0.033,NULL,59694787646,932731056,14573922,17.7),(136926,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136926,37.69,0.46,345,65215,70,NULL,NULL,'2MASX J16185866+1203420',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,244.7442917,12.0615,0.181,NULL,56573167550,883955742,13811808,17.2),(136927,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136927,37.2,0.46,275,65216,70,NULL,NULL,'2MASX J16190060+1506430',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000163,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.7525417,15.112,0.129,NULL,56545545432,883524147,13805064,16.9),(136928,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136928,37.94,0.19,387,65217,70,NULL,NULL,'2MASX J16190063+1056356',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.752667,10.94339,0.193,NULL,56455742480,882120976,13783140,17.4),(136929,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136929,38.35,0.21,469,65218,70,NULL,NULL,'SDSS J161901.72+081910.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.7g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,244.7572083,8.3195,0.201,NULL,56469291133,882332673,13786448,18.7),(136930,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136930,35.75,NULL,142,65219,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2020',NULL,'2010Ap&SS.325..163P',2010,1,1,NULL,'G',0.000008,NULL,'16.5',0.1,'Sd',NULL,NULL,NULL,NULL,1,244.75775,15.76394,0.137,NULL,56546432605,883538009,13805281,16.5),(136931,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136931,35.77,NULL,143,65219,NULL,NULL,'Dipole + Quadrupole','FGC 2020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136932,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136932,35.79,NULL,144,65219,NULL,NULL,NULL,'FGC 2020',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136933,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136933,35.79,NULL,144,65219,NULL,NULL,'Dipole','FGC 2020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136934,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136934,35.93,0.49,154,65219,75,NULL,'IR','FGC 2020',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136935,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136935,37.29,0.46,287,65220,70,NULL,NULL,'2MASX J16190201+1244460',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000164,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,244.758333,12.74614,0.177,NULL,56540020003,883437812,13803715,17),(136936,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136936,38.43,0.46,485,65221,70,NULL,NULL,'SDSS J161902.14+233214.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000154,NULL,'19.0g',0.09,NULL,NULL,NULL,NULL,NULL,1,244.758917,23.53742,0.141,NULL,56643404649,885053197,13828956,19),(136937,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136937,37.23,0.33,280,65222,70,NULL,NULL,'2MASX J16190219+2605588',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00019,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,244.75925,26.09961,0.081,NULL,59728685264,933260707,14582198,16.9),(136938,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136938,37.23,0.33,280,65223,70,NULL,NULL,'2MASX J16190323+2606418',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000181,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,244.7635417,26.11169,0.081,NULL,59728685160,933260705,14582198,16.4),(136939,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136939,38.35,0.21,469,65224,70,NULL,NULL,'2MASX J16190521+0819045',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00018,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,244.771583333,8.31808,0.201,NULL,56469750635,882339853,13786560,17.1),(136940,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136940,38.4,0.33,479,65225,70,NULL,NULL,'2MASX J16190690+2645258',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000189,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,244.778667,26.75731,0.073,NULL,59728943276,933264738,14582261,16.5),(136941,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136941,37.47,0.46,312,65226,70,NULL,NULL,'2MASX J16190703+4354155',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,244.7792917,43.90422,0,NULL,59851810721,935184542,14612258,17.7),(136942,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136942,38.13,0.46,422,65227,70,NULL,NULL,'2MASX J16190936+2944348',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000178,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,244.789,29.74303,0.061,NULL,59740087092,933438860,14584982,17.9),(136943,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136943,35.54,0.46,128,65228,70,NULL,NULL,'CGCG 080-003',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000157,NULL,'15.2g',0.5,NULL,NULL,NULL,NULL,NULL,1,244.793917,14.07422,0.137,NULL,56541288049,883457625,13804025,15.2),(136944,'D-Sigma','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136944,33.45,0.4,49.1,65229,75,NULL,'Edat, raw','NGC 6125',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000022,NULL,'13.0',1.4,'E','in a pair',NULL,NULL,NULL,1,244.798125,57.98422,0,NULL,57622003534,900343805,14067871,13),(136945,'D-Sigma','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136945,33.79,0.4,57.2,65229,75,NULL,'Edat, cor','NGC 6125',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136946,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136946,34.12,0.4,66.6,65229,NULL,NULL,'mean','NGC 6125',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136947,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136947,34.36,0.45,74.4,65229,NULL,NULL,'K','NGC 6125',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136948,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136948,35.35,NULL,117,65230,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2022',NULL,'2010Ap&SS.325..163P',2010,1,1.24,NULL,'G',0.000088,NULL,'16.6g',0.13,'Sd',NULL,NULL,NULL,NULL,1,244.798875,39.74464,0.009,NULL,59801900323,934404692,14600073,16.6),(136949,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136949,35.36,NULL,118,65230,NULL,NULL,'Dipole + Quadrupole','FGC 2022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136950,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136950,35.38,NULL,119,65230,NULL,NULL,'Dipole','FGC 2022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136951,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136951,35.4,NULL,120,65230,NULL,NULL,NULL,'FGC 2022',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136952,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136952,37.74,0.46,353,65231,70,NULL,NULL,'2MASX J16191238+2838128',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000151,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,244.8017083,28.63686,0.065,NULL,59743035182,933484924,14585701,17.3),(136953,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136953,37.84,0.46,370,65232,70,NULL,NULL,'2MASX J16191342+2417268',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,244.805875,24.29092,0.185,NULL,56170598754,877665605,13713525,17.9),(136954,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136954,37.03,0.46,255,65233,70,NULL,NULL,'2MASX J16191399+4646285',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,'PRED','16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,244.8082083,46.77469,0.005,NULL,59835732404,934933318,14608333,16.6),(136955,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136955,37.17,0.46,272,65234,70,NULL,NULL,'2MASX J16191496+2508409',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000166,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,244.812416667,25.14472,0.153,NULL,56170791267,877668613,13713572,16.7),(136956,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136956,36.78,0.46,227,65235,70,NULL,NULL,'2MASX J16191595+3729120',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000093,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,244.816625,37.48672,0,NULL,59769705413,933901647,14592213,16.5),(136957,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136957,37.84,0.46,370,65236,70,NULL,NULL,'2MASX J16191625+1039586',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,244.81775,10.66614,0.185,NULL,56455701693,882120338,13783130,16.8),(136958,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136958,36.68,0.46,217,65237,70,NULL,NULL,'2MASX J16191690+1541413',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000169,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,244.820416667,15.69481,0.137,NULL,56545581456,883524710,13805073,16.5),(136959,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136959,37.21,0.46,277,65238,70,NULL,NULL,'2MASX J16191710+3409318',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000161,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,244.821375,34.15894,0.009,NULL,59792639865,934259997,14597812,17.1),(136960,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136960,36.98,0.46,248,65239,70,NULL,NULL,'2MASX J16191775+1201593',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000143,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,244.8239583,12.03303,0.181,NULL,56573690577,883963915,13811936,18.2),(136961,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136961,32.38,NULL,29.9,65240,72,NULL,NULL,'CGCG 024-001',NULL,'2014Ap.....57..457K',2014,1,NULL,NULL,'G',0.000023,NULL,'15.4',NULL,NULL,NULL,NULL,NULL,NULL,1,244.824833333,1.70364,0.285,NULL,56455055095,882110235,13782972,15.4),(136962,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136962,37.32,0.23,291,65241,70,NULL,NULL,'2MASX J16191797+2432269',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000178,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,244.824958333,24.54092,0.173,NULL,56170500016,877664062,13713500,17.4),(136963,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136963,38.35,0.21,469,65242,70,NULL,NULL,'SDSS J161918.77+081540.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000162,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,244.8282083,8.26131,0.201,NULL,56469632786,882338012,13786531,18.4),(136964,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136964,37.51,0.16,318,65243,70,NULL,NULL,'2MASX J16191883+2413108',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000187,NULL,'15.5g',0.48,'BrClG',NULL,NULL,NULL,NULL,1,244.8284583,24.21969,0.185,NULL,56170424868,877662888,13713482,15.5),(136965,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136965,37.51,0.16,318,65244,70,NULL,NULL,'SDSS J161918.86+235935.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000163,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,244.828625,23.99331,0.173,NULL,56640470051,885007344,13828239,18.6),(136966,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136966,37.41,0.46,304,65245,70,NULL,NULL,'2MASX J16192002+3656410',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000179,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,244.833458333,36.94467,0.033,NULL,59769470288,933897973,14592155,17.3),(136967,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136967,38.4,0.33,479,65246,70,NULL,NULL,'SDSS J161921.00+265415.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000178,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,244.837541667,26.90422,0.085,NULL,59728886464,933263851,14582247,18.7),(136968,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136968,37.85,0.21,371,65247,70,NULL,NULL,'SDSS J161921.34+244806.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000143,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,244.838917,24.80189,0.157,NULL,56170907120,877670423,13713600,18.6),(136969,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136969,38,0.1,398,65248,70,NULL,NULL,'2MASX J16192151+3013407',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,244.839625,30.22792,0.029,NULL,59739628105,933431689,14584870,17.2),(136970,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136970,36.44,0.46,194,65249,70,NULL,NULL,'2MASX J16192170+4105240',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000113,NULL,'15.6g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,244.84025,41.08989,0,NULL,59855742951,935245983,14613218,15.6),(136971,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136971,37.94,0.19,387,65250,70,NULL,NULL,'2MASX J16192175+1051576',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,244.840625,10.86603,0.193,NULL,56455850367,882122661,13783166,NULL),(136972,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136972,34.22,0.46,69.7,65251,70,NULL,NULL,'CGCG 137-079',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000097,NULL,'15.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,244.842625,22.14686,0.153,NULL,56641351740,885021120,13828455,15.2),(136973,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136973,37.25,0.46,282,65252,70,NULL,NULL,'2MASX J16192609+4911036',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,244.8585,49.18433,0.017,NULL,59702901297,932857832,14575903,17.8),(136974,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136974,37.51,0.16,318,65253,70,NULL,NULL,'SDSS J161926.06+241503.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000185,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,244.858625,24.25086,0.185,NULL,56170424602,877662884,13713482,18),(136975,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136975,38,0.1,398,65254,70,NULL,NULL,'2MASX J16192808+3006155',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000162,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,244.867083,30.10428,0.029,NULL,59739617598,933431524,14584867,18.2),(136976,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136976,35.28,0.49,114,65255,75,NULL,'IR','UGC 10340',NULL,'2011yCatp016004901K',2011,1,1.18,'RC3 has V = 5047 +- 11 km/s.','G',0.000172,NULL,'15.5g',0.24,'S?',NULL,NULL,NULL,NULL,1,244.867583333,36.29433,0.025,NULL,59780938316,934077161,14594955,15.5),(136977,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136977,35.55,0.2,129,65256,74.4,NULL,NULL,'UGC 10340',NULL,'2013AJ....146...86T',2013,1,1.18,'RC3 has V = 5047 +- 11 km/s.','G',0.000172,NULL,'15.5g',0.24,'S?',NULL,NULL,NULL,NULL,1,244.867583333,36.29433,0.025,NULL,59780938316,934077161,14594955,15.5),(136978,'IRAS','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136978,35.36,0.8,118,65257,75,NULL,'CF, r','UGC 10337',NULL,'1997ApJS..109..333W',1997,1,1.56,NULL,'G',0.00005,NULL,'14.6g',0.42,'Sb','Line-of-sight pair member',NULL,NULL,NULL,1,244.869167,7.27875,0.201,NULL,56466380150,882287189,13785737,14.6),(136979,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136979,35.37,0.38,118,65257,75,NULL,'CF, r, raw','UGC 10337',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136980,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136980,35.57,0.4,130,65257,NULL,NULL,'mean','UGC 10337',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136981,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136981,35.57,0.2,130,65257,74.4,NULL,NULL,'UGC 10337',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136982,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136982,35.59,0.38,131,65257,75,NULL,'CF, r, inv','UGC 10337',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136983,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136983,35.6,0.38,132,65257,75,NULL,'CF, r, cor','UGC 10337',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136984,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136984,35.62,0.47,133,65257,NULL,NULL,'H','UGC 10337',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136985,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136985,35.7,0.46,138,65257,NULL,NULL,'J','UGC 10337',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136986,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136986,35.71,0.45,139,65257,NULL,NULL,'K','UGC 10337',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136987,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136987,35.48,0.46,125,65258,70,NULL,NULL,'2MASX J16192964+1827521',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.22',0.38,NULL,NULL,NULL,NULL,NULL,1,244.873417,18.46442,0.129,NULL,56644173830,885065216,13829144,16.22),(136988,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136988,38.35,0.21,469,65259,70,NULL,NULL,'2MASX J16193006+0819055',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,244.875166667,8.31822,0.201,NULL,56469756238,882339941,13786561,17.3),(136989,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136989,38.38,0.46,474,65260,70,NULL,NULL,'2MASX J16193143+2144271',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.880875,21.74086,0.125,NULL,56655463808,885241622,13831900,17.5),(136990,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136990,36.95,0.33,245,65261,70,NULL,NULL,'2MASX J16193245+4637375',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,'FoF','16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,244.885291667,46.62717,0.005,NULL,59835739425,934933428,14608334,16.4),(136991,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136991,34.27,0.4,71.6,65262,NULL,NULL,'mean','NGC 6130',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.00016,NULL,'14.26',0.7,'SBbc:','in a pair',NULL,NULL,NULL,1,244.889333333,57.61497,0,NULL,57630676903,900479326,14069989,14.26),(136992,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136992,34.48,0.47,78.9,65262,NULL,NULL,'H','NGC 6130',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136993,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136993,34.56,0.46,81.5,65262,NULL,NULL,'J','NGC 6130',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136994,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,136994,34.6,0.45,83.1,65262,NULL,NULL,'K','NGC 6130',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136995,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',136995,37.28,0.46,286,65263,70,NULL,NULL,'2MASX J16193444+4023192',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,244.8934583,40.38867,0,NULL,59799785419,934371647,14599556,18),(136996,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',136996,38,0.23,398,65264,70,NULL,NULL,'2MASX J16193524+1014402',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,244.896958333,10.24442,0.193,NULL,56459296624,882176509,13784007,17.4),(136997,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',136997,37.74,0.46,353,65265,70,NULL,NULL,'2MASX J16193577+1952181',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,244.89925,19.87156,0.169,NULL,56647690117,885120158,13830002,17.4),(136998,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',136998,38,0.1,398,65266,70,NULL,NULL,'2MASX J16193640+3011346',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000145,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,244.901417,30.19308,0.029,NULL,59732206505,933315726,14583058,18.3),(136999,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',136999,37.86,0.33,374,65267,70,NULL,NULL,'2MASX J16193660+4657014',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000174,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,244.90225,46.95044,0,NULL,59835239229,934925612,14608212,17.2),(137000,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137000,35.94,0.46,154,65268,70,NULL,NULL,'CGCG 109-004',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000177,NULL,'15.0g',0.58,NULL,NULL,NULL,NULL,NULL,1,244.903667,15.27831,0.137,NULL,56545531655,883523932,13805061,15),(137001,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137001,37.86,0.33,374,65269,70,NULL,NULL,'2MASX J16193729+4655564',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000136,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,244.90525,46.93242,0,NULL,59835239342,934925614,14608212,17.7),(137002,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137002,36.76,0.23,225,65270,70,NULL,NULL,'2MASX J16193735+5034469',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,244.905541667,50.57967,0.021,NULL,59707484058,932929438,14577022,17.6),(137003,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137003,35.43,0.46,122,65271,70,NULL,NULL,'CGCG 196-038',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000087,NULL,'15.2g',0.59,NULL,NULL,NULL,NULL,NULL,1,244.9082917,34.32294,0.009,NULL,59792489313,934257645,14597775,15.2),(137004,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137004,36.73,0.46,221,65272,70,NULL,NULL,'2MASX J16193867+4052352',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000107,NULL,'15.2g',0.52,'E0',NULL,NULL,NULL,NULL,1,244.911375,40.87631,0,NULL,59855219785,935237809,14613090,15.2),(137005,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137005,37.84,0.46,369,65273,70,NULL,NULL,'2MASX J16193997+1617165',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000184,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,244.9164583,16.28806,0.185,NULL,56666637709,885416214,13834628,17.1),(137006,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137006,38,0.1,398,65274,70,NULL,NULL,'2MASX J16194003+3004096',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000157,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,244.916833,30.06922,0.029,NULL,59739604061,933431313,14584864,17.3),(137007,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137007,36.76,0.23,225,65275,70,NULL,NULL,'2MASX J16194030+5033150',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00011,NULL,'15.59',0.62,NULL,NULL,NULL,NULL,NULL,1,244.917833,50.554,0.021,NULL,59707485775,932929465,14577022,15.59),(137008,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137008,37.32,0.23,291,65276,70,NULL,NULL,'2MASX J16194092+2434203',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00018,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,244.920375,24.57233,0.165,NULL,56170485133,877663830,13713497,16.8),(137009,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137009,37.32,0.23,291,65277,70,NULL,NULL,'2MASX J16194121+2438103',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,244.921791667,24.63619,0.165,NULL,56170503942,877664124,13713501,17.2),(137010,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137010,35.93,0.1,153,65278,70,NULL,NULL,'2MASX J16194129+3509066',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00009,NULL,'16.0g',0.27,'E0',NULL,NULL,NULL,NULL,1,244.922125,35.15169,0.005,NULL,59778634673,934041166,14594393,16),(137011,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137011,37.69,0.46,345,65279,70,NULL,NULL,'2MASX J16194218-0027216',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000106,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,244.925583,-0.45583,0.365,NULL,45514716861,711167450,11111991,17.9),(137012,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137012,38.35,0.21,469,65280,70,NULL,NULL,'2MASX J16194304+0819252',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,244.929167,8.32378,0.201,NULL,56469807962,882340749,13786574,18),(137013,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137013,37.94,0.19,387,65281,70,NULL,NULL,'2MASX J16194586+1102172',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,244.941125,11.03808,0.209,NULL,56455763904,882121311,13783145,17.5),(137014,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137014,37.84,0.46,369,65282,70,NULL,NULL,'2MASX J16194624+3857202',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,244.942667,38.95553,0,NULL,59799194289,934362410,14599412,17.2),(137015,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137015,36.54,0.46,203,65283,70,NULL,NULL,'2MASX J16194816+1313148',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000169,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,244.950708333,13.22064,0.157,NULL,56543103745,883485996,13804468,16.7),(137016,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137016,37.65,0.46,339,65284,70,NULL,NULL,'2MASX J16194842+2618133',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,244.951917,26.30383,0.093,NULL,59728545705,933258526,14582164,17.3),(137017,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137017,38,0.1,398,65285,70,NULL,NULL,'2MASX J16194957+3000505',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,244.956667,30.01411,0.061,NULL,59739603344,933431302,14584864,18),(137018,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137018,38,0.23,398,65286,70,NULL,NULL,'2MASX J16194981+1005012',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,244.957583,10.08367,0.165,NULL,56459523515,882180054,13784063,17.3),(137019,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137019,38.04,0.46,406,65287,70,NULL,NULL,'2MASX J16195052+4114492',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000168,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,244.960625,41.247,0,NULL,59854907235,935232925,14613014,17.2),(137020,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137020,37.32,0.23,291,65288,70,NULL,NULL,'2MASX J16195140+2434473',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000208,NULL,'15.9g',0.45,'BrClG',NULL,NULL,NULL,NULL,1,244.9642083,24.57978,0.165,NULL,56170486466,877663851,13713497,15.9),(137021,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137021,37.85,0.21,371,65289,70,NULL,NULL,'2MASX J16195661+2444403',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,244.9857083,24.7445,0.157,NULL,56173927019,877717609,13714337,17),(137022,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137022,37.76,0.46,356,65290,70,NULL,NULL,'2MASX J16195660+1600268',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,244.985917,16.00758,0.177,NULL,56666695704,885417120,13834642,17.8),(137023,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137023,38.3,0.46,458,65291,70,NULL,NULL,'SDSS J162001.34+092220.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,245.005625,9.37225,0.137,NULL,56458182187,882159096,13783735,18.6),(137024,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137024,37.37,0.46,298,65292,70,NULL,NULL,'2MASX J16200178+4650504',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000139,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.007167,46.84742,0,NULL,59835725489,934933210,14608331,17.2),(137025,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137025,37.28,0.46,286,65293,70,NULL,NULL,'2MASX J16200237+4547494',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000168,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,245.009833,45.79731,0.009,NULL,59835428783,934928574,14608258,16.6),(137026,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137026,37.85,0.21,371,65294,70,NULL,NULL,'SDSS J162003.45+244328.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,245.014375,24.72444,0.165,NULL,56173926069,877717594,13714337,18.5),(137027,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137027,38.22,0.46,440,65295,70,NULL,NULL,'2MASX J16200382+3445479',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,245.0157917,34.76331,0.013,NULL,59778560364,934040005,14594375,17.7),(137028,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137028,37.01,0.46,252,65296,70,NULL,NULL,'2MASX J16200555+1451488',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000166,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,245.023083,14.86375,0.129,NULL,56540321468,883442522,13803789,16.7),(137029,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137029,35.81,NULL,145,65297,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2025',NULL,'2010Ap&SS.325..163P',2010,1,0.87,NULL,'G',0.000095,NULL,'17.0g',0.12,'Sd',NULL,NULL,NULL,NULL,1,245.0279583,40.95167,0,NULL,59855790496,935246726,14613230,17),(137030,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137030,35.84,NULL,147,65297,NULL,NULL,'Dipole + Quadrupole','FGC 2025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137031,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137031,35.84,NULL,147,65297,NULL,NULL,NULL,'FGC 2025',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137032,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137032,35.86,NULL,149,65297,NULL,NULL,'Dipole','FGC 2025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137033,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137033,36.72,0.46,221,65298,70,NULL,NULL,'2MASXi J1620070+302610',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000149,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,245.029625,30.43606,0.033,NULL,59732365745,933318214,14583097,17),(137034,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137034,38.68,0.46,543,65299,70,NULL,NULL,'2MASX J16200735+1556438',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000171,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.030667,15.94553,0.177,NULL,56666692023,885417062,13834641,17.9),(137035,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137035,38,0.23,398,65300,70,NULL,NULL,'2MASX J16200892+1007155',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.6g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,245.037167,10.12086,0.165,NULL,56459492768,882179574,13784055,16.6),(137036,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137036,37.85,0.21,371,65301,70,NULL,NULL,'2MASX J16201020+2446376',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000175,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,245.0425417,24.77728,0.157,NULL,56173933016,877717703,13714339,17.8),(137037,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137037,38.42,0.46,483,65302,70,NULL,NULL,'2MASX J16201049+2302487',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000182,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.043833333,23.04678,0.137,NULL,56643114250,885048660,13828885,18),(137038,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137038,38,0.1,398,65303,70,NULL,NULL,'2MASX J16201090+3003020',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.0455417,30.05056,0.009,NULL,59732198621,933315603,14583056,17.4),(137039,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137039,37.85,0.21,371,65304,70,NULL,NULL,'SDSS J162012.06+245022.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,245.05025,24.83953,0.157,NULL,56174057583,877719649,13714369,18.5),(137040,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137040,38.24,0.46,444,65305,70,NULL,NULL,'SDSS J162012.26+113312.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000155,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,245.051083,11.55347,0.217,NULL,56572968684,883952635,13811759,18.6),(137041,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137041,38,0.1,398,65306,70,NULL,NULL,'2MASX J16201315+2956230',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000164,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,245.054875,29.93986,0.021,NULL,59732527603,933320743,14583136,18.3),(137042,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137042,38,0.1,398,65307,70,NULL,NULL,'2MASX J16201337+3002070',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.055666667,30.03522,0.009,NULL,59733051586,933328931,14583264,18.1),(137043,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137043,37.32,0.46,291,65308,70,NULL,NULL,'2MASX J16201429+4512573',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,245.05975,45.21594,0.009,NULL,59851976781,935187137,14612299,18),(137044,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137044,38.45,0.46,491,65309,70,NULL,NULL,'2MASX J16201644+3539490',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000148,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,245.0685,35.66353,0.005,NULL,59780982278,934077848,14594966,18.6),(137045,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137045,36.32,0.46,184,65310,70,NULL,NULL,'2MASX J16201675+1804176',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.1g',0.32,NULL,NULL,NULL,NULL,NULL,1,245.069708333,18.07172,0.141,NULL,56665204422,885393819,13834278,16.1),(137046,'GRB','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137046,46.3,0.4,4380,65311,73,NULL,'H const./H=100','GRB 000301C',2.0335,'2006astro.ph..9262M',2006,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'ASM/Ulysses',NULL,NULL,NULL,NULL,1,245.077083,29.44306,0.033,NULL,59740228712,933441073,14585016,NULL),(137047,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137047,35.35,0.46,117,65312,70,NULL,NULL,'CGCG 109-007',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000254,NULL,'15.5',0.4,NULL,NULL,NULL,NULL,NULL,1,245.077625,18.46461,0.141,NULL,56698773516,885918336,13842474,15.5),(137048,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137048,36.96,0.46,247,65313,70,NULL,NULL,'2MASX J16201980+4304377',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.0827083,43.07714,0,NULL,59850021574,935156587,14611821,17.2),(137049,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137049,37.51,0.16,318,65314,70,NULL,NULL,'2MASX J16202001+2406486',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000194,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,245.083417,24.11358,0.125,NULL,56640405671,885006338,13828224,16.7),(137050,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137050,37.77,0.33,359,65315,70,NULL,NULL,'2MASX J16202247+2439366',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,245.093791667,24.66008,0.125,NULL,56173941917,877717842,13714341,17.8),(137051,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137051,38,0.1,398,65316,70,NULL,NULL,'2MASX J16202284+3000340',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000177,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,245.095375,30.00956,0.021,NULL,59733063008,933329109,14583267,17),(137052,'BCG','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137052,38.44,0.35,444,65317,60,NULL,NULL,'ABELL 2175',0.0978,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II     [BM]',NULL,NULL,NULL,NULL,1,245.095417,29.91503,0.021,NULL,59732538492,933320913,14583139,NULL),(137053,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137053,37.24,0.46,280,65318,70,NULL,NULL,'2MASX J16202335+1936446',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.09',0.24,NULL,NULL,NULL,NULL,NULL,1,245.097417,19.61253,0.165,NULL,56647876799,885123074,13830048,17.09),(137054,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137054,38,0.1,398,65319,70,NULL,NULL,'2MASX J16202480+2954077',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000123,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,245.103291667,29.90206,0.021,NULL,59732539340,933320927,14583139,17.2),(137055,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137055,37.77,0.33,359,65320,70,NULL,NULL,'2MASX J16202504+2434097',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00014,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.10425,24.56931,0.125,NULL,56174015546,877718992,13714359,17.8),(137056,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137056,37.96,0.46,391,65321,70,NULL,NULL,'2MASX J16202511+2945117',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000137,NULL,'17.1g',0.22,'E',NULL,NULL,NULL,NULL,1,245.1047083,29.75314,0.025,NULL,59732583139,933321611,14583150,17.1),(137057,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137057,38.52,0.46,505,65322,70,NULL,NULL,'SDSS J162025.21+094246.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,245.105083333,9.71283,0.145,NULL,56458557163,882164955,13783827,18.5),(137058,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137058,36.6,0.46,209,65323,70,NULL,NULL,'2MASX J16202738+2529497',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,245.11425,25.49717,0.121,NULL,56173562358,877711911,13714248,17.1),(137059,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137059,37.94,0.46,388,65324,70,NULL,NULL,'2MASX J16202824+1753404',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.11775,17.89447,0.137,NULL,56665216518,885394008,13834281,17.1),(137060,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137060,37.1,0.33,263,65325,70,NULL,NULL,'2MASX J16202839+1422194',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',NULL,NULL,'16.78',0.37,NULL,NULL,NULL,NULL,NULL,1,245.11825,14.37211,0.117,NULL,56540413173,883443955,13803811,16.78),(137061,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137061,38.03,0.46,404,65326,70,NULL,NULL,'2MASX J16202934+2049166',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,245.122,20.82136,0.173,NULL,56646952204,885108628,13829822,17.8),(137062,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137062,38.78,0.27,570,65327,70,NULL,NULL,'SDSS J162029.81+210711.2',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000158,NULL,'18.9g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,245.12425,21.11981,0.145,NULL,56654984407,885234131,13831783,18.9),(137063,'BCG','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137063,38.44,0.35,444,65328,60,NULL,'ABELL 2175, BCG','2MASX J16203111+2953276',0.0978,'1980ApJ...241..486H',1980,1,0.61,NULL,'G',0.000117,NULL,'16.2g',0.37,'cD;BrClG','Brightest group member',NULL,NULL,NULL,1,245.129667,29.89103,0.021,NULL,59732534678,933320854,14583138,16.2),(137064,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137064,38,0.1,398,65328,70,NULL,NULL,'2MASX J16203111+2953276',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137065,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137065,38,0.1,398,65329,70,NULL,NULL,'2MASX J16203126+2951277',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,245.130125,29.85764,0.021,NULL,59732537840,933320903,14583139,17.9),(137066,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137066,37.1,0.33,263,65330,70,NULL,NULL,'2MASX J16203197+1410594',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000169,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,245.133333,14.18314,0.137,NULL,56540872031,883451125,13803923,17.3),(137067,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137067,38,0.23,398,65331,70,NULL,NULL,'2MASX J16203374+1009586',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,245.140708333,10.16633,0.193,NULL,56459477200,882179331,13784052,17.7),(137068,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137068,38.29,0.46,455,65332,70,NULL,NULL,'2MASX J16203381+2519174',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000186,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,245.140833333,25.32144,0.149,NULL,56173783734,877715370,13714302,17.4),(137069,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137069,37.96,0.46,391,65333,70,NULL,NULL,'2MASX J16203480+2126557',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000158,NULL,'17.8g',NULL,NULL,NULL,NULL,NULL,NULL,1,245.1449583,21.44883,0.137,NULL,56654988080,885234188,13831784,17.8),(137070,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137070,37.67,0.46,342,65334,70,NULL,NULL,'2MASX J16203641-0030201',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000089,NULL,'18.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,245.151625,-0.50547,0.365,NULL,45500980203,710952815,11108637,18.1),(137071,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137071,36.18,0.46,172,65335,70,NULL,NULL,'2MASX J16203815+2740474',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000173,NULL,'16.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.158917,27.67997,0.101,NULL,59742560649,933477510,14585586,16.5),(137072,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137072,37.11,0.46,264,65336,70,NULL,NULL,'2MASX J16204133+1833367',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,245.172083,18.56036,0.141,NULL,56698770530,885918289,13842473,16.2),(137073,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137073,38,0.1,398,65337,70,NULL,NULL,'2MASX J16204138+2947284',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000143,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,245.172333,29.79122,0.025,NULL,59732586580,933321665,14583151,17.2),(137074,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137074,38.14,0.27,424,65338,70,NULL,NULL,'2MASX J16204153+3417064',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,245.1730417,34.28511,0,NULL,59792963897,934265060,14597891,17.9),(137075,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137075,38.23,0.46,443,65339,70,NULL,NULL,'2MASX J16204162+2521424',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000165,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,245.1735,25.36172,0.149,NULL,56173781495,877715335,13714302,18.3),(137076,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137076,37.56,0.46,325,65340,70,NULL,NULL,'2MASX J16204361+1107196',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,245.1817083,11.12211,0.229,NULL,56456319039,882129984,13783281,17.5),(137077,'IRAS','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137077,33.1,0.8,41.7,65341,75,NULL,'MAT, I','IC 4595',NULL,'1997ApJS..109..333W',1997,1,2.7,NULL,'G',0.000025,NULL,'11.51',0.5,'Sc: sp',NULL,NULL,NULL,NULL,1,245.185166667,-70.14261,0.189,NULL,45019700696,703432823,10991137,11.51),(137078,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137078,32.73,0.43,35.1,65341,75,NULL,'3.6 micron, color + selection bias corrected','IC 4595',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137079,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137079,32.76,0.47,35.7,65341,NULL,NULL,'H','IC 4595',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137080,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137080,32.8,0.46,36.4,65341,NULL,NULL,'J','IC 4595',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137081,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137081,32.82,0.45,36.6,65341,NULL,NULL,'K','IC 4595',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137082,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137082,32.97,0.43,39.3,65341,75,NULL,'3.6 micron, color corrected','IC 4595',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137083,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137083,33.05,0.49,40.7,65341,75,NULL,'IR','IC 4595',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137084,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137084,33.09,0.4,41.6,65341,NULL,NULL,'mean','IC 4595',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137085,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137085,33.21,0.2,43.9,65341,74.4,NULL,NULL,'IC 4595',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137086,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137086,33.22,0.43,44,65341,75,NULL,'MAT, I, raw','IC 4595',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137087,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137087,33.23,0.32,44.3,65341,85,NULL,'I, raw','IC 4595',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137088,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137088,33.3,0.32,45.7,65341,85,NULL,'I, inv','IC 4595',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137089,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137089,33.45,0.43,49,65341,75,NULL,'MAT, I, cor','IC 4595',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137090,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137090,33.5,0.43,50,65341,75,NULL,'MAT, I, inv','IC 4595',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137091,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137091,38,0.1,398,65342,70,NULL,NULL,'2MASX J16204545+2949474',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00018,NULL,'17.2g',0.25,'E',NULL,NULL,NULL,NULL,1,245.18925,29.82997,0.021,NULL,59732579929,933321561,14583149,17.2),(137092,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137092,38.05,0.46,407,65343,70,NULL,NULL,'2MASX J16204636+2954285',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.193083,29.90783,0.021,NULL,59732533727,933320839,14583138,17.9),(137093,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137093,36.83,0.33,232,65344,70,NULL,NULL,'2MASX J16204638+2401425',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000171,NULL,'17.5g',NULL,NULL,NULL,NULL,NULL,NULL,1,245.193167,24.02856,0.125,NULL,56642246054,885035094,13828673,17.5),(137094,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137094,37.43,0.46,306,65345,70,NULL,NULL,'2MASX J16204677+0013459',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000099,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,245.19475,0.22942,0.341,NULL,56440857368,881888396,13779506,16.8),(137095,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137095,35.21,0.46,110,65346,70,NULL,NULL,'2MASX J16204693+3418454',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000087,NULL,'15.8g',0.39,'S0',NULL,NULL,NULL,NULL,1,245.1957083,34.31272,0,NULL,59792964312,934265067,14597891,15.8),(137096,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137096,36.83,0.33,232,65347,70,NULL,NULL,'2MASX J16204703+2400505',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000188,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,245.1960417,24.01419,0.125,NULL,56642246510,885035101,13828673,16.5),(137097,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137097,37.75,0.46,355,65348,70,NULL,NULL,'2MASX J16204861+3816266',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000123,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,245.202625,38.27406,0.005,NULL,59798373165,934349580,14599212,17.1),(137098,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137098,38.55,0.27,512,65349,70,NULL,NULL,'SDSS J162049.45+155117.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000146,NULL,'18.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,245.206083,15.85475,0.177,NULL,56666973538,885421461,13834710,18.4),(137099,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137099,36.88,0.46,238,65350,70,NULL,NULL,'2MASX J16204947+3848026',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,245.206333333,38.80083,0,NULL,59799174106,934362095,14599407,17.1),(137100,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137100,36.85,0.46,235,65351,70,NULL,NULL,'SDSS J162050.21+143924.5',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'15.9g',0.4,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,245.2092083,14.65683,0.125,NULL,56658868194,885294815,13832731,15.9),(137101,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137101,38.78,0.27,570,65352,70,NULL,NULL,'SDSS J162050.24+210654.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000187,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,245.209375,21.11514,0.145,NULL,56654971048,885233922,13831780,18.4),(137102,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137102,34.19,NULL,68.9,65353,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2028',NULL,'2010Ap&SS.325..163P',2010,1,1.01,NULL,'G',0.00011,'?','16.9',0.08,'Sd',NULL,NULL,NULL,NULL,1,245.21,63.12111,0,NULL,57529882683,898904416,14045381,16.9),(137103,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137103,34.2,NULL,69.2,65353,NULL,NULL,'Dipole + Quadrupole','FGC 2028',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137104,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137104,34.21,NULL,69.4,65353,NULL,NULL,NULL,'FGC 2028',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137105,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137105,34.21,NULL,69.4,65353,NULL,NULL,'Dipole','FGC 2028',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137106,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137106,38.61,0.46,528,65354,70,NULL,NULL,'SDSS J162052.28+201416.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000163,NULL,'18.6g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,245.217833,20.23803,0.169,NULL,56648182965,885127858,13830122,18.6),(137107,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137107,38,0.1,398,65355,70,NULL,NULL,'2MASX J16205244+2950445',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000137,NULL,'17.2g',0.25,'E',NULL,NULL,NULL,NULL,1,245.218625,29.84569,0.021,NULL,59732582105,933321595,14583149,17.2),(137108,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137108,38,0.1,398,65356,70,NULL,NULL,'2MASX J16205397+2956495',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,245.2249583,29.94711,0.021,NULL,59733053728,933328964,14583265,17.6),(137109,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137109,38.8,0.46,575,65357,70,NULL,NULL,'SDSS J162054.54+250631.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00018,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,245.2272917,25.10875,0.089,NULL,56174085388,877720084,13714376,18.6),(137110,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137110,38.55,0.27,512,65358,70,NULL,NULL,'2MASX J16205520+1551277',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000168,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,245.229875,15.85778,0.177,NULL,56666977987,885421531,13834711,16.9),(137111,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137111,37.74,0.46,353,65359,70,NULL,NULL,'2MASX J16205516+2605254',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00016,NULL,'17.2g',0.22,'AGN',NULL,NULL,NULL,NULL,1,245.229958333,26.0905,0.093,NULL,59728580757,933259074,14582173,17.2),(137112,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137112,37.44,0.46,307,65360,70,NULL,NULL,'SDSS J162055.72+113930.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000141,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,245.232167,11.65844,0.217,NULL,56572920675,883951885,13811748,18.5),(137113,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137113,38,0.1,398,65361,70,NULL,NULL,'2MASX J16205574+2949034',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000107,NULL,'16.9g',0.27,'E',NULL,NULL,NULL,NULL,1,245.23225,29.8175,0.021,NULL,59732581469,933321585,14583149,16.9),(137114,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137114,35.7,0.33,138,65362,70,NULL,NULL,'2MASX J16205672+2119563',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00018,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,245.2364583,21.33231,0.137,NULL,56655080800,885235637,13831806,16.7),(137115,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137115,31.34,0.4,18.6,65363,75,NULL,'B','NGC 6140',NULL,'1988NBGC.C....0000T',1988,1,6.3,NULL,'G',0.000013,NULL,'11.81',4.6,'SB(s)cd pec','Isolated galaxy (6 Mpc isolation)',NULL,NULL,NULL,1,245.242333,65.39056,0.045,NULL,57829639663,903588119,14118564,11.81),(137116,'TRGB','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137116,28.04,0.05,4.06,65364,NULL,NULL,'I','ESO 137- G 018',NULL,'2009AJ....138..332J',2009,1,3.2,'abs(b) < 10 degrees.','G',0.00001,NULL,'12.24',1.1,'SA(s)c:',NULL,NULL,NULL,NULL,1,245.2432917,-60.49103,NULL,NULL,44495318562,695239352,10863114,12.24),(137117,'TRGB','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137117,28.84,0.1,5.86,65364,74.4,NULL,NULL,'ESO 137- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137118,'TRGB','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137118,28.95,0.1,6.17,65364,NULL,NULL,NULL,'ESO 137- G 018',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137119,'TRGB','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137119,29.01,NULL,6.34,65364,NULL,NULL,NULL,'ESO 137- G 018',NULL,'2007AJ....133..504K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137120,'Tully est','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137120,29.29,0.8,7.2,65364,75,NULL,NULL,'ESO 137- G 018',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137121,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137121,35.61,0.33,132,65365,70,NULL,NULL,'I Zw 143',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000083,NULL,'15.6g',0.43,'E0',NULL,NULL,NULL,NULL,1,245.250875,34.76411,0.013,NULL,59780429981,934069218,14594831,15.6),(137122,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137122,38.1,0.46,417,65366,70,NULL,NULL,'SDSS J162100.44+512309.7',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000066,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,245.251875,51.38603,0.017,NULL,59694669935,932729217,14573894,17.8),(137123,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137123,38.55,0.27,512,65367,70,NULL,NULL,'2MASX J16210047+1550077',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000167,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.252083,15.83561,0.177,NULL,56666966991,885421359,13834708,17.8),(137124,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137124,37.96,0.33,390,65368,70,NULL,NULL,'2MASX J16210104+2440294',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000155,NULL,'17.3g',0.26,'BrClG',NULL,NULL,NULL,NULL,1,245.254333333,24.67483,0.125,NULL,56173991622,877718619,13714353,17.3),(137125,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137125,38,0.1,398,65369,70,NULL,NULL,'2MASX J16210128+2954105',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,245.255333,29.90286,0.021,NULL,59733073971,933329280,14583270,17.8),(137126,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137126,38,0.1,398,65370,70,NULL,NULL,'2MASX J16210272+2944214',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00014,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,245.261333333,29.73944,0.025,NULL,59732575699,933321495,14583148,17.5),(137127,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137127,35.92,0.49,152,65371,70,NULL,NULL,'2MASX J16210398-1650212',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00014,NULL,'14.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,245.266667,-16.83917,0.929,NULL,45943880687,717873135,11216767,14.1),(137128,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137128,38.05,0.46,408,65372,70,NULL,NULL,'2MASXi J1621041+301623',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.26725,30.27328,0.029,NULL,59732216272,933315879,14583060,17.9),(137129,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137129,35.7,0.33,138,65373,70,NULL,NULL,'CGCG 137-081',NULL,'2015arXiv151105856S',2015,1,0.7,'GSC 1517-0497 (mag. 15) superposed 10 arcsec southeast of nucleus.','G',0.00017,NULL,'15.2g',0.59,'AGN',NULL,NULL,NULL,NULL,1,245.267583,21.34053,0.137,NULL,56655080552,885235633,13831806,15.2),(137130,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137130,38.29,0.46,455,65374,70,NULL,NULL,'SDSS J162104.38+250109.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000147,NULL,'18.9g',0.11,NULL,NULL,NULL,NULL,NULL,1,245.2682917,25.01942,0.089,NULL,56174092897,877720201,13714378,18.9),(137131,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137131,38,0.1,398,65375,70,NULL,NULL,'2MASX J16210592+2954263',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,245.2745417,29.90736,0.021,NULL,59733074881,933329295,14583270,17.9),(137132,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137132,37.62,0.46,334,65376,70,NULL,NULL,'SDSS J162107.32+172844.0',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,245.2805,17.47892,0.189,NULL,56665885867,885404466,13834444,NULL),(137133,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137133,37.43,0.46,306,65377,70,NULL,NULL,'2MASX J16210845+2913333',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000131,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.285208333,29.22594,0.029,NULL,59732447437,933319491,14583117,18.1),(137134,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137134,35.54,0.21,128,65378,70,NULL,NULL,'2MASX J16210880+3802006',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000127,NULL,'15.7g',0.43,'S0/a',NULL,NULL,NULL,NULL,1,245.2865,38.03336,0,NULL,59768930617,933889540,14592024,15.7),(137135,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137135,35.61,0.33,132,65379,70,NULL,NULL,'KUGX 1619+348B',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000087,NULL,'14.9g',0.62,'Compact',NULL,NULL,NULL,NULL,1,245.29,34.75911,0.013,NULL,59780416822,934069012,14594828,14.9),(137136,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137136,37.64,0.46,337,65380,70,NULL,NULL,'2MASX J16211057+0018470',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000086,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.294083,0.31317,0.325,NULL,56440735388,881886490,13779476,17.3),(137137,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137137,38.78,0.27,570,65381,70,NULL,NULL,'2MASX J16211253+2113293',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,245.30225,21.22481,0.137,NULL,56655051657,885235182,13831799,17.8),(137138,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137138,37.96,0.33,390,65382,70,NULL,NULL,'2MASX J16211406+2437283',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000159,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,245.308583,24.62444,0.125,NULL,56174042163,877719408,13714365,18.2),(137139,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137139,36.88,0.33,238,65383,70,NULL,NULL,'2MASX J16211480+1203526',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000175,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,245.3117917,12.06458,0.213,NULL,56539257221,883425894,13803529,17.4),(137140,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137140,38.3,0.46,458,65384,70,NULL,NULL,'2MASX J16211627+0849426',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,245.3177083,8.82842,0.177,NULL,56469938134,882342783,13786605,17.4),(137141,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137141,37.34,0.46,294,65385,70,NULL,NULL,'2MASX J16211684+4906573',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000196,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.320416667,49.116,0.005,NULL,59702795331,932856177,14575877,17),(137142,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137142,36.6,0.46,209,65386,70,NULL,NULL,'2MASX J16211739+0627246',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000155,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,245.3225417,6.45692,0.201,NULL,56467371569,882302680,13785979,17),(137143,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137143,35.45,0.33,123,65387,70,NULL,NULL,'2MASX J16211956+2440003',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000156,NULL,'15.9g',0.35,NULL,NULL,NULL,NULL,NULL,1,245.331416667,24.66664,0.109,NULL,56173996335,877718692,13714354,15.9),(137144,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137144,38.14,0.27,424,65388,70,NULL,NULL,'2MASX J16211959+3412001',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.33175,34.20017,0,NULL,59791118485,934236226,14597441,18.2),(137145,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137145,36.76,0.46,224,65389,70,NULL,NULL,'2MASX J16212011+1345277',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,245.33375,13.75778,0.149,NULL,56659074585,885298040,13832781,17.1),(137146,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137146,38,0.1,398,65390,70,NULL,NULL,'2MASX J16212183+2937573',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000143,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.341167,29.63256,0.025,NULL,59732615385,933322115,14583158,17.5),(137147,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137147,38.62,0.46,530,65391,70,NULL,NULL,'2MASX J16212188+1047516',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.3412917,10.79778,0.209,NULL,56456036129,882125564,13783211,17.7),(137148,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137148,37.94,0.46,387,65392,70,NULL,NULL,'2MASX J16212215+3856033',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,245.342375,38.93428,0,NULL,59799116562,934361196,14599393,17.2),(137149,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137149,38.14,0.27,424,65393,70,NULL,NULL,'2MASX J16212314+3410241',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,245.346375,34.17353,0,NULL,59791138853,934236544,14597446,17.4),(137150,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137150,37.86,0.46,374,65394,70,NULL,NULL,'2MASX J16212430+0609056',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00019,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,245.351375,6.15167,0.229,NULL,56464308010,882254812,13785231,17.7),(137151,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137151,36.88,0.33,238,65395,70,NULL,NULL,'2MASX J16212539+1204277',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'17.00',0.38,NULL,NULL,NULL,NULL,NULL,1,245.355667,12.07431,0.213,NULL,56539255783,883425871,13803529,17),(137152,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137152,35.43,0.46,122,65396,70,NULL,NULL,'CGCG 080-009',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.00016,NULL,'14.8g',0.55,NULL,NULL,NULL,NULL,NULL,1,245.3572083,14.53153,0.125,NULL,56658846667,885294479,13832726,14.8),(137153,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137153,37.99,0.46,396,65397,70,NULL,NULL,'2MASX J16212618-0023193',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000102,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,245.3590417,-0.38869,0.349,NULL,45501842401,710966287,11108848,17.1),(137154,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137154,35.88,0.59,150,65398,70,NULL,NULL,'2MASX J16212722-6531465',NULL,'2014MNRAS.445.2677S',2014,1,0.28,NULL,'G',0.00015,NULL,'15.5R',0.28,NULL,NULL,NULL,NULL,NULL,1,245.363375,-65.52967,0.669,NULL,44995633905,703056779,10985262,15.5),(137155,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137155,37.65,0.46,339,65399,70,NULL,NULL,'2MASX J16212815+0938036',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'17.43',0.34,NULL,NULL,NULL,NULL,NULL,1,245.3672083,9.63447,0.145,NULL,56458267417,882160428,13783756,17.43),(137156,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137156,37.79,0.33,361,65400,70,NULL,NULL,'2MASX J16212822+0036111',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000077,NULL,'16.8g',0.36,NULL,NULL,NULL,NULL,NULL,1,245.3675,0.60325,0.289,NULL,56441564409,881899443,13779678,16.8),(137157,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137157,29.5,0.49,7.95,65401,75,NULL,'IR','UGC 10351',NULL,'2011yCatp016004901K',2011,1,1.07,'The 2MASX position refers to a knot in the southwestern end.','G',0.000003,NULL,'14.8g',0.57,'Sdm:',NULL,NULL,NULL,NULL,1,245.36775,28.64019,0.065,NULL,59741886520,933466976,14585421,14.8),(137158,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137158,38,0.1,398,65402,70,NULL,NULL,'2MASX J16212935+2941593',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,245.372333,29.69986,0.025,NULL,59732569639,933321400,14583146,18.4),(137159,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137159,35.45,0.33,123,65403,70,NULL,NULL,'2MASX J16213162+2459523',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00009,NULL,'16.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.381833,24.99789,0.089,NULL,56174291812,877723309,13714426,16.5),(137160,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137160,37.26,0.46,283,65404,70,NULL,NULL,'2MASX J16213251+0000376',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.0001,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,245.385541667,0.01033,0.341,NULL,56440717550,881886211,13779472,16.5),(137161,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137161,36.53,0.65,202,65405,70,NULL,NULL,'2MFGC 13131',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,245.3865,-16.75447,0.929,NULL,45943800724,717871886,11216748,15.7),(137162,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137162,37.79,0.33,361,65406,70,NULL,NULL,'2MASX J16213295+0036281',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000086,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,245.387333333,0.60789,0.289,NULL,56441566760,881899480,13779679,17),(137163,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137163,38.33,0.46,464,65407,70,NULL,NULL,'2MASX J16213351+4541268',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,245.38975,45.69064,0.005,NULL,59833384445,934896631,14607759,17.4),(137164,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137164,38.43,0.27,485,65408,70,NULL,NULL,'SDSS J162135.03+253703.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,245.3959583,25.61758,0.085,NULL,56172601218,877696894,13714013,18.2),(137165,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137165,37.64,0.46,337,65409,70,NULL,NULL,'2MASX J16213729+2117429',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,245.405541667,21.29536,0.157,NULL,56654872791,885232387,13831756,17.8),(137166,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137166,36.74,0.46,223,65410,70,NULL,NULL,'2MASX J16213788+4355008',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,245.4077917,43.91694,0,NULL,59851918461,935186225,14612284,17.2),(137167,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137167,37.16,0.46,270,65411,70,NULL,NULL,'2MASX J16214097+2151399',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,245.420833,21.86128,0.113,NULL,56655349624,885239837,13831872,16.7),(137168,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137168,36.69,0.46,217,65412,70,NULL,NULL,'2MASX J16214104+1325457',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,245.4209583,13.42922,0.153,NULL,56657242869,885269419,13832334,17),(137169,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137169,35.54,0.21,128,65413,70,NULL,NULL,'NGC 6129',NULL,'2015arXiv151105856S',2015,1,0.98,'HOLM 741C is a star.','G',0.000083,NULL,'14.2g',0.89,'E0',NULL,NULL,NULL,NULL,1,245.430291667,37.99603,0.005,NULL,59768851750,933888308,14592004,14.2),(137170,'SGRB','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'N',137170,29.52,2.72,8,65414,NULL,NULL,NULL,'GRB 031214',NULL,'2006ApJ...640..849N',2006,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137171,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137171,38.43,0.27,485,65415,70,NULL,NULL,'2MASX J16214520+2535488',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.438458333,25.597,0.085,NULL,56172554720,877696167,13714002,18),(137172,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137172,37.78,0.46,360,65416,70,NULL,NULL,'SDSS J162145.61+112537.5',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,245.440083,11.42708,0.237,NULL,56455507530,882117305,13783082,NULL),(137173,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137173,36.69,0.21,217,65417,70,NULL,NULL,'CGCG 138-001',NULL,'2015arXiv151105856S',2015,1,1.08,NULL,'G',0.000189,NULL,'15.2g',0.5,NULL,NULL,NULL,NULL,NULL,1,245.4419583,25.82069,0.081,NULL,56172561516,877696273,13714004,15.2),(137174,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137174,37.41,0.27,303,65418,70,NULL,NULL,'2MASX J16214814+3930576',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.0001,NULL,'16.0g',0.38,'E0',NULL,NULL,NULL,NULL,1,245.4505,39.51594,0,NULL,59853485305,935210707,14612667,16),(137175,'IRAS','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137175,31.93,0.8,24.4,65419,75,NULL,'MAT, I','NGC 6118',NULL,'1997ApJS..109..333W',1997,1,4.7,NULL,'G',0.000005,NULL,'11.0B',2,'SA(s)cd        HII','Isolated galaxy',NULL,NULL,NULL,1,245.452583,-2.28344,0.453,NULL,45516147682,711189807,11112340,11),(137176,'IRAS','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137176,31.94,0.8,24.4,65419,75,NULL,'A82, H','NGC 6118',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137177,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137177,31.08,0.69,16.4,65419,100,NULL,'mid-IR','NGC 6118',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137178,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137178,31.38,0.4,18.9,65419,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 6118',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137179,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137179,31.42,0.32,19.2,65419,85,NULL,'I, raw','NGC 6118',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137180,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137180,31.46,0.32,19.6,65419,85,NULL,'I, inv','NGC 6118',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137181,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137181,31.5,0.43,19.9,65419,75,NULL,'MAT, I, raw','NGC 6118',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137182,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137182,31.58,0.43,20.7,65419,75,NULL,'3.6 micron, color corrected','NGC 6118',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137183,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137183,31.59,0.43,20.8,65419,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6118',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137184,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137184,31.59,0.2,20.8,65419,74.4,NULL,NULL,'NGC 6118',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137185,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137185,31.61,0.36,21,65419,NULL,NULL,NULL,'NGC 6118',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137186,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137186,31.7,0.43,21.9,65419,75,NULL,'MAT, I, inv','NGC 6118',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137187,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137187,31.75,NULL,22.4,65419,NULL,NULL,'B','NGC 6118',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137188,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137188,31.76,0.47,22.5,65419,75,NULL,'A82, H, raw','NGC 6118',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137189,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137189,31.8,0.43,22.9,65419,75,NULL,'MAT, I, cor','NGC 6118',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137190,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137190,31.82,0.29,23.1,65419,NULL,NULL,NULL,'NGC 6118',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137191,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137191,31.85,NULL,23.4,65419,72,NULL,NULL,'NGC 6118',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137192,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137192,31.87,0.47,23.6,65419,75,NULL,'A82, H, inv','NGC 6118',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137193,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137193,31.88,0.28,23.8,65419,NULL,NULL,'Malmquist cor.','NGC 6118',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137194,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137194,31.97,0.4,24.8,65419,NULL,NULL,'mean','NGC 6118',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137195,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137195,31.98,0.46,24.9,65419,NULL,NULL,'J','NGC 6118',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137196,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137196,32.02,0.47,25.3,65419,75,NULL,'A82, H, cor','NGC 6118',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137197,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137197,32.02,0.4,25.4,65419,75,NULL,'B','NGC 6118',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137198,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137198,32.04,0.47,25.6,65419,NULL,NULL,'H','NGC 6118',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137199,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137199,32.07,0.45,25.9,65419,NULL,NULL,'K','NGC 6118',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137200,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137200,37.51,0.46,317,65420,70,NULL,NULL,'2MASX J16214897+0709147',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00019,NULL,'16.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,245.4540417,7.15403,0.221,NULL,56467857624,882310275,13786098,16.9),(137201,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137201,38.05,0.46,408,65421,70,NULL,NULL,'2MASX J16214937+1857407',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,245.45575,18.96128,0.157,NULL,56699256414,885925881,13842591,17.7),(137202,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137202,33.07,NULL,41.2,65422,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10369',NULL,'2010Ap&SS.325..163P',2010,1,1.24,'Matthews (2000A&AS..143..421M) detects another feature at v=8433 km/sec.','G',0.000023,NULL,'16.5',0.17,'Sdm',NULL,NULL,NULL,NULL,1,245.462667,67.29308,0.117,NULL,57826887825,903545122,14117892,16.5),(137203,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137203,33.09,NULL,41.5,65422,NULL,NULL,'Dipole + Quadrupole','UGC 10369',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137204,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137204,33.11,NULL,41.8,65422,NULL,NULL,'Dipole','UGC 10369',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137205,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137205,33.18,NULL,43.2,65422,NULL,NULL,NULL,'UGC 10369',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137206,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137206,38.33,0.27,463,65423,70,NULL,NULL,'SDSS J162151.86+212023.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,245.466125,21.33981,0.157,NULL,56654847065,885231985,13831749,18.6),(137207,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137207,37.5,0.59,317,65424,70,NULL,NULL,'2MASX J16215327-0050233',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.54',0.4,NULL,NULL,NULL,NULL,NULL,1,245.472125,-0.84003,0.397,NULL,45501307966,710957936,11108717,16.54),(137208,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137208,36.23,0.2,176,65425,74.4,NULL,NULL,'CGCG 138-002',NULL,'2013AJ....146...86T',2013,1,0.71,NULL,'G',0.000073,NULL,'15.4g',0.55,'E',NULL,NULL,NULL,NULL,1,245.477667,25.62553,0.085,NULL,56172556408,877696193,13714003,15.4),(137209,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137209,37.9,0.46,380,65426,70,NULL,NULL,'2MASX J16215575+1313449',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000188,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,245.482333,13.22914,0.181,NULL,56657427084,885272298,13832379,17.8),(137210,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137210,37.55,0.46,324,65427,70,NULL,NULL,'2MASX J16215590+2418398',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,245.4829583,24.31097,0.141,NULL,56171929615,877686400,13713850,17.6),(137211,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137211,37.78,0.46,360,65428,70,NULL,NULL,'2MASX J16215661+5022448',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.48575,50.37914,0.013,NULL,59696031950,932750499,14574226,18),(137212,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137212,38,0.1,398,65429,70,NULL,NULL,'SDSS J162157.37+294725.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,245.4890417,29.79044,0.021,NULL,59732591100,933321735,14583152,18.3),(137213,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137213,37.25,0.46,281,65430,70,NULL,NULL,'2MASX J16215826+2330547',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,245.4927083,23.51525,0.149,NULL,56642829733,885044214,13828815,17.3),(137214,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137214,37.87,0.46,375,65431,70,NULL,NULL,'2MASX J16215836+1419409',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,245.493125,14.32792,0.137,NULL,56659691678,885307682,13832932,17.6),(137215,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137215,37.46,0.46,311,65432,70,NULL,NULL,'2MASX J16215984+0014375',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000101,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.499375,0.24389,0.325,NULL,56441628156,881900439,13779694,17.5),(137216,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137216,36.91,0.46,241,65433,70,NULL,NULL,'2MASX J16220027+3859417',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000117,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,245.501125,38.995,0,NULL,59798587113,934352923,14599264,16.2),(137217,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137217,37.72,0.46,349,65434,70,NULL,NULL,'2MASX J16220260+0900587',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,245.510916667,9.01628,0.169,NULL,56469082984,882329421,13786397,17),(137218,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137218,37.58,0.46,328,65435,70,NULL,NULL,'SDSS J162206.75+003259.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000073,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,245.528125,0.54978,0.325,NULL,56441690489,881901413,13779709,18.6),(137219,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137219,37.68,0.46,344,65436,70,NULL,NULL,'2MASX J16220790+3139037',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000144,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.532833,31.65106,0.029,NULL,59788301291,934192207,14596753,17.8),(137220,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137220,37.98,0.27,394,65437,70,NULL,NULL,'2MASX J16220870+2720544',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000193,NULL,'16.4g',0.36,'E0',NULL,NULL,NULL,NULL,1,245.5362917,27.34844,0.081,NULL,59741790779,933465480,14585398,16.4),(137221,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:56','1','SN 2007bj',NULL,137221,34.46,0.19,76.7,65438,70,NULL,'SALT 2','NGC 6172',0.016708,'2013MNRAS.433.2240G',2013,1,1,NULL,'G',0.000027,NULL,'13.83',1,'E+:',NULL,NULL,NULL,NULL,1,245.542917,-1.51486,0.457,NULL,45515555365,711180552,11112196,13.83),(137222,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137222,38.26,0.46,448,65439,70,NULL,NULL,'2MASX J16221154+2359084',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,245.547917,23.98581,0.125,NULL,56642461989,885038468,13828726,17.9),(137223,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137223,37.57,0.46,327,65440,70,NULL,NULL,'2MASX J16221173+3216097',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.5487917,32.26947,0.005,NULL,59790283763,934223183,14597237,17.3),(137224,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137224,37.15,0.46,269,65441,70,NULL,NULL,'2MASX J16221302+2419154',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,245.554375,24.32097,0.141,NULL,56171939422,877686553,13713852,17.3),(137225,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137225,38.15,0.46,426,65442,70,NULL,NULL,'2MASX J16221323+3611588',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.555291667,36.19975,0,NULL,59777548760,934024199,14594128,17.8),(137226,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137226,37.34,0.46,293,65443,70,NULL,NULL,'2MASX J16221503+2115528',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.562625,21.26489,0.157,NULL,56654881301,885232520,13831758,17.6),(137227,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137227,37.32,0.46,291,65444,70,NULL,NULL,'2MASX J16221601+2700594',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,245.566708333,27.01667,0.085,NULL,59728169692,933252651,14582072,17.2),(137228,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137228,36.5,0.46,200,65445,70,NULL,NULL,'2MASX J16221650+4017128',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,245.568583,40.28694,0,NULL,59856339323,935255301,14613364,17.3),(137229,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137229,38.71,0.46,552,65446,70,NULL,NULL,'2MASX J16221745+2526154',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000171,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,245.572875,25.43775,0.089,NULL,56174196409,877721818,13714403,17.7),(137230,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137230,37.14,0.67,268,65447,70,NULL,NULL,'2MASX J16221766-0121551',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,245.573625,-1.36536,0.417,NULL,45515066936,711172920,11112076,15.6),(137231,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137231,37.98,0.27,394,65448,70,NULL,NULL,'2MASX J16221801+2720214',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.575041667,27.33933,0.081,NULL,59741792643,933465510,14585398,17.5),(137232,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137232,37.98,0.27,394,65449,70,NULL,NULL,'2MASX J16221973+2722194',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000176,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,245.58225,27.37211,0.081,NULL,59741824461,933466007,14585406,17),(137233,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137233,36.69,0.46,218,65450,70,NULL,NULL,'2MASX J16222006+4658233',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',NULL,NULL,'16.02',0.42,NULL,NULL,NULL,NULL,NULL,1,245.583417,46.97325,0,NULL,59835857902,934935279,14608363,16.02),(137234,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137234,35.85,NULL,148,65451,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10355',NULL,'2010Ap&SS.325..163P',2010,1,0.52,NULL,'G',0.000033,NULL,'16.3g',0.17,'Sc',NULL,NULL,NULL,NULL,1,245.5895,13.85383,0.145,NULL,56660101021,885314078,13833032,16.3),(137235,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137235,35.86,NULL,148,65451,NULL,NULL,'Dipole + Quadrupole','UGC 10355',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137236,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137236,35.86,0.49,149,65451,75,NULL,'IR','UGC 10355',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137237,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137237,35.86,NULL,149,65451,NULL,NULL,'Dipole','UGC 10355',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137238,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137238,35.91,NULL,152,65451,NULL,NULL,NULL,'UGC 10355',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137239,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137239,36.22,0.2,175,65451,74.4,NULL,NULL,'UGC 10355',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137240,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137240,36.81,0.33,230,65452,70,NULL,NULL,'2MASX J16222166+1441037',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,245.590333,14.68453,0.137,NULL,56659741607,885308462,13832944,17.7),(137241,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137241,38.64,0.46,534,65453,70,NULL,NULL,'2MASX J16222172+3456403',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000166,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.5905417,34.9445,0.013,NULL,59780478570,934069977,14594843,18),(137242,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137242,38.43,0.27,485,65454,70,NULL,NULL,'2MASX J16222349+2536554',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000142,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.598,25.61539,0.085,NULL,56173005175,877703205,13714112,18),(137243,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137243,37.62,0.27,335,65455,70,NULL,NULL,'2MASX J16222504+1948281',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000166,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.604208333,19.80789,0.193,NULL,56647994782,885124918,13830076,18.2),(137244,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137244,37.99,0.46,397,65456,70,NULL,NULL,'2MASX J16222522+4447083',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000123,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.6049583,44.78564,0.037,NULL,59851008455,935172007,14612062,16.8),(137245,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137245,38.23,0.46,444,65457,70,NULL,NULL,'2MASX J16222614+1117427',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,245.6089583,11.29531,0.237,NULL,56456185004,882127890,13783248,17.3),(137246,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137246,37.82,0.46,367,65458,70,NULL,NULL,'2MASX J16222633+3257303',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000148,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,245.609917,32.95847,0.025,NULL,59793710579,934276727,14598073,17.6),(137247,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137247,37.47,0.46,312,65459,70,NULL,NULL,'2MASX J16222648+3513203',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,245.610417,35.22244,0.005,NULL,59780460136,934069689,14594838,17.3),(137248,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137248,37.92,0.46,383,65460,70,NULL,NULL,'2MASX J16222695+0002538',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000075,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.612167,0.04833,0.325,NULL,56441071890,881891748,13779558,17.8),(137249,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137249,36.27,0.33,179,65461,70,NULL,NULL,'2MASX J16222802+1726177',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000087,NULL,'16.29',0.45,NULL,NULL,NULL,NULL,NULL,1,245.61675,17.43836,0.189,NULL,56668531410,885445803,13835090,16.29),(137250,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137250,36.27,0.33,179,65462,70,NULL,NULL,'SDSS J162228.06+172420.9',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.1g',0.37,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,245.6169583,17.40581,0.189,NULL,56668533530,885445836,13835091,16.1),(137251,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137251,36.55,0.46,204,65463,70,NULL,NULL,'2MASX J16222834+4010039',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,245.618083,40.16783,0,NULL,59856345876,935255404,14613365,16.5),(137252,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137252,35.62,0.46,133,65464,70,NULL,NULL,'CGCG 080-015',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000087,NULL,'15.7',0.6,NULL,NULL,NULL,NULL,NULL,1,245.619625,10.50483,0.185,NULL,56458797755,882168714,13783886,15.7),(137253,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137253,35.09,0.46,104,65465,70,NULL,NULL,'KUGX 1620+357',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000127,NULL,'15.1g',0.51,'Compact',NULL,NULL,NULL,NULL,1,245.622375,35.65583,0,NULL,59781381014,934084078,14595063,15.1),(137254,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137254,38.07,0.46,411,65466,70,NULL,NULL,'SDSS J162229.88+214618.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000149,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,245.6245,21.77183,0.133,NULL,56656064519,885251008,13832047,18.7),(137255,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137255,36.82,0.52,231,65467,70,NULL,NULL,'2MASX J16223020-0039131',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00012,NULL,'16.03',NULL,NULL,NULL,NULL,NULL,NULL,1,245.625833,-0.65364,0.365,NULL,45501872340,710966755,11108855,16.03),(137256,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137256,37.41,0.27,303,65468,70,NULL,NULL,'2MASX J16223109+3937299',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000181,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,245.629417,39.62506,0,NULL,59853463113,935210361,14612661,17.1),(137257,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137257,37.94,0.46,388,65469,70,NULL,NULL,'2MASX J16223255+4950438',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000177,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.635666667,49.84539,0.017,NULL,59695591243,932743613,14574118,17.5),(137258,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137258,37.43,0.46,306,65470,70,NULL,NULL,'2MASX J16223476+1517027',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.644875,15.28417,0.089,NULL,56670376524,885474633,13835541,17.9),(137259,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137259,36.69,0.21,217,65471,70,NULL,NULL,'2MASX J16223511+2549014',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000175,NULL,'16.0g',0.47,NULL,NULL,NULL,NULL,NULL,1,245.646541667,25.81708,0.081,NULL,56173066463,877704163,13714127,16),(137260,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137260,37.56,0.46,325,65472,70,NULL,NULL,'2MASX J16223583+2520314',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000163,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,245.649291667,25.34208,0.089,NULL,56173355311,877708676,13714198,17.2),(137261,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137261,36.52,0.46,201,65473,70,NULL,NULL,'2MASX J16223659+5008379',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,245.652833,50.14386,0.013,NULL,59696289941,932754530,14574289,16.6),(137262,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137262,37.07,0.33,260,65474,70,NULL,NULL,'2MASX J16223772+2603354',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000184,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,245.657167,26.05986,0.093,NULL,56173224891,877706638,13714166,16.2),(137263,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137263,36.74,0.46,223,65475,70,NULL,NULL,'2MASXi J1622384+443157',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,245.660166667,44.53253,0.021,NULL,59851421702,935178464,14612163,17.9),(137264,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137264,35.87,0.46,149,65476,70,NULL,NULL,'CGCG 224-007',NULL,'2015arXiv151105856S',2015,1,0.93,NULL,'G',0.0001,NULL,'14.5g',0.68,'E0',NULL,NULL,NULL,NULL,1,245.661917,43.46467,0,NULL,59849888781,935154512,14611789,14.5),(137265,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137265,37.17,0.46,271,65477,70,NULL,NULL,'2MASX J16223905+4709383',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000179,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,245.662625,47.16078,0.005,NULL,59835017596,934922149,14608158,16.6),(137266,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137266,37.83,0.46,368,65478,70,NULL,NULL,'2MASXi J1622404+461618',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,245.668333,46.27175,0,NULL,59835492525,934929570,14608274,17.8),(137267,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137267,37.41,0.27,303,65479,70,NULL,NULL,'SDSS J162240.74+393936.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,245.6697917,39.66014,0,NULL,59853471022,935210484,14612663,18.4),(137268,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137268,38.27,0.46,450,65480,70,NULL,NULL,'2MASX J16224119+3414353',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000164,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,245.671625,34.24311,0,NULL,59791160702,934236885,14597451,17.2),(137269,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137269,36.88,0.17,237,65481,70,NULL,NULL,'2MASX J16224432+2357151',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000201,NULL,'16.2g',0.44,NULL,NULL,NULL,NULL,NULL,1,245.684583,23.95417,0.153,NULL,56642427003,885037921,13828717,16.2),(137270,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137270,37.07,0.33,260,65482,70,NULL,NULL,'2MASX J16224550+2605529',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,245.689583,26.098,0.093,NULL,56173203606,877706306,13714161,17.8),(137271,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137271,36.79,0.46,228,65483,70,NULL,NULL,'2MASX J16224660+2024581',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000148,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,245.694375,20.41617,0.181,NULL,56647367926,885115123,13829923,17.5),(137272,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137272,36.88,0.17,237,65484,70,NULL,NULL,'2MASX J16224665+2347031',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.694375,23.78436,0.137,NULL,56642927430,885045741,13828839,17.2),(137273,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137273,36.36,0.33,187,65485,70,NULL,NULL,'2MASX J16224707+5126249',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00011,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,245.6962083,51.44031,0.017,NULL,59696705938,932761030,14574391,16.8),(137274,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137274,37.37,0.46,297,65486,70,NULL,NULL,'2MASX J16224818+2043491',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000182,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,245.700917,20.73025,0.177,NULL,56645484570,885085696,13829464,16.6),(137275,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137275,36.87,0.46,236,65487,70,NULL,NULL,'2MASX J16224830+0016388',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000072,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.7012083,0.27753,0.325,NULL,56441116733,881892448,13779569,17.6),(137276,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137276,36.88,0.17,237,65488,70,NULL,NULL,'2MASX J16224869+2352589',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.703041667,23.88322,0.153,NULL,56642410887,885037670,13828713,17.8),(137277,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137277,37.09,0.46,262,65489,70,NULL,NULL,'2MASX J16224869+4946049',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000175,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,245.703167,49.76806,0.017,NULL,59695592706,932743636,14574119,16.7),(137278,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137278,36.76,0.23,225,65490,70,NULL,NULL,'2MASX J16225052+5028049',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,245.710417,50.468,0.013,NULL,59696050476,932750788,14574231,16.5),(137279,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137279,37.97,0.46,392,65491,70,NULL,NULL,'2MASX J16225117+1738167',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'16.5g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,245.713291667,17.63806,0.177,NULL,56665733048,885402078,13834407,16.5),(137280,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137280,36.36,0.33,187,65492,70,NULL,NULL,'2MASX J16225124+5104539',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,245.713667,51.08161,0.013,NULL,59696710487,932761101,14574392,16.9),(137281,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137281,34.56,0.46,81.6,65493,70,NULL,NULL,'CGCG 080-016',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000107,NULL,'15.6',0.8,NULL,NULL,NULL,NULL,NULL,1,245.716875,11.371,0.237,NULL,56740613956,886572093,13852688,15.6),(137282,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137282,35.4,0.46,120,65494,70,NULL,NULL,'2MASX J16225229+2118191',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000172,NULL,'16.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,245.717791667,21.30533,0.157,NULL,56655931491,885248929,13832014,16.1),(137283,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137283,38.68,0.33,544,65495,70,NULL,NULL,'SDSS J162252.99+305722.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00017,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,245.7207917,30.95617,0.041,NULL,59788685965,934198218,14596847,18.5),(137284,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137284,38.68,0.33,544,65496,70,NULL,NULL,'2MASXi J1622530+305308',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000174,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,245.721166667,30.88575,0.041,NULL,59788636306,934197442,14596835,17.8),(137285,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137285,38.13,0.46,422,65497,70,NULL,NULL,'SDSS J162253.53+400727.1',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000188,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,245.723083,40.12419,0,NULL,59856374771,935255855,14613372,17.3),(137286,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137286,35.7,0.4,138,65498,NULL,NULL,'mean','UGC 10362',NULL,'2007A&A...465...71T',2007,1,1.17,NULL,'G',0.00002,NULL,'14.5g',0.61,'SB(r)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,245.73125,39.79164,0,NULL,59853455609,935210243,14612660,14.5),(137287,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137287,35.76,0.07,142,65498,NULL,NULL,NULL,'UGC 10362',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137288,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137288,35.83,0.2,147,65498,74.4,NULL,NULL,'UGC 10362',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137289,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137289,35.96,0.47,156,65498,NULL,NULL,'H','UGC 10362',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137290,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137290,37.62,0.27,335,65499,70,NULL,NULL,'2MASX J16225582+1951331',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,245.732417,19.85911,0.193,NULL,56647769032,885121391,13830021,16.8),(137291,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137291,35.54,0.21,128,65500,70,NULL,NULL,'2MASX J16225650+3758581',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000067,NULL,'15.9g',0.28,'S0/a',NULL,NULL,NULL,NULL,1,245.735375,37.98286,0.005,NULL,59798203480,934346929,14599170,15.9),(137292,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137292,36.88,0.17,237,65501,70,NULL,NULL,'2MASX J16225730+2353359',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00018,NULL,'15.8g',0.45,'BrClG',NULL,NULL,NULL,NULL,1,245.7387083,23.89333,0.153,NULL,56642924193,885045690,13828838,15.8),(137293,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137293,36.81,0.33,230,65502,70,NULL,NULL,'2MASX J16225767+1440357',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000179,NULL,'15.8g',0.44,NULL,NULL,NULL,NULL,NULL,1,245.740417,14.67667,0.137,NULL,56659776283,885309004,13832953,15.8),(137294,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137294,35.51,0.46,127,65503,70,NULL,NULL,'2MASX J16225835+2007401',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000163,NULL,'16.3g',0.42,NULL,NULL,NULL,NULL,NULL,1,245.743041667,20.12792,0.209,NULL,56647867691,885122932,13830045,16.3),(137295,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137295,37.32,0.46,291,65504,70,NULL,NULL,'2MASX J16225885+4015074',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000177,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.745333,40.25219,0,NULL,59856350805,935255481,14613366,17.1),(137296,'Cepheids','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'RN',137296,19.06,0.34,0.065,65505,NULL,NULL,'1,K, Cepheid 1','NORMA DWARF B',NULL,'2016arXiv160103381C',2016,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137297,'Cepheids','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'RN',137297,19.13,0.19,0.067,65505,NULL,NULL,'1, I, Cepheid 1','NORMA DWARF B',NULL,'2016arXiv160103381C',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137298,'Cepheids','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'RN',137298,19.32,0.53,0.073,65505,NULL,NULL,'1, I, Cepheid 2','NORMA DWARF B',NULL,'2016arXiv160103381C',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137299,'Cepheids','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'RN',137299,19.46,0.19,0.078,65505,NULL,NULL,'1,K, Cepheid 3','NORMA DWARF B',NULL,'2016arXiv160103381C',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137300,'Cepheids','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'RN',137300,19.46,0.16,0.078,65505,NULL,NULL,'1, I, Cepheid 3','NORMA DWARF B',NULL,'2016arXiv160103381C',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137301,'Type II Cepheids','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'RN',137301,17.39,NULL,0.03,65505,NULL,NULL,'3, I','NORMA DWARF B',NULL,'2016arXiv160103381C',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137302,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137302,38.33,0.27,463,65506,70,NULL,NULL,'2MASX J16225965+2133202',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,245.748583,21.55558,0.133,NULL,56656091109,885251423,13832053,17.4),(137303,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137303,37.97,0.46,393,65507,70,NULL,NULL,'2MASX J16225983+2246192',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,245.7494583,22.77186,0.161,NULL,56653796049,885215563,13831493,18.4),(137304,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137304,36.54,0.46,203,65508,70,NULL,NULL,'2MASX J16230000+2156122',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.0002,NULL,'16.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,245.75,21.93667,0.133,NULL,56656586424,885259162,13832174,16.1),(137305,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137305,37.08,0.33,261,65509,70,NULL,NULL,'2MASX J16230069+2301382',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,245.7530417,23.02731,0.133,NULL,56653923170,885217549,13831524,18.1),(137306,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137306,37.08,0.33,261,65510,70,NULL,NULL,'2MASX J16230105+2301122',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'17.00',0.37,NULL,NULL,NULL,NULL,NULL,1,245.754333333,23.02,0.133,NULL,56653923292,885217551,13831524,17),(137307,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137307,36.88,0.17,237,65511,70,NULL,NULL,'2MASX J16230168+2356512',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.757125,23.94767,0.153,NULL,56642408474,885037632,13828713,17.2),(137308,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137308,38.33,0.27,463,65512,70,NULL,NULL,'SDSS J162301.99+213553.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000155,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,245.758333,21.59822,0.133,NULL,56656127021,885251984,13832062,18.6),(137309,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137309,37.95,0.33,389,65513,70,NULL,NULL,'SDSS J162302.40+102833.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,245.760041667,10.47594,0.185,NULL,56457693036,882151453,13783616,17.9),(137310,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137310,36.86,0.21,236,65514,70,NULL,NULL,'2MASX J16230269+1420477',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000199,NULL,'15.9g',0.41,NULL,NULL,NULL,NULL,NULL,1,245.76125,14.3465,0.137,NULL,56659579383,885305927,13832905,15.9),(137311,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137311,35.2,0.45,110,65515,NULL,NULL,'K','NGC 6137',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000047,NULL,'13.40',1.2,'E','in a radial-velocity based grouping',NULL,'radio jet',NULL,1,245.762917,37.92236,0.005,NULL,59768838261,933888097,14592001,13.4),(137312,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137312,35.66,0.4,136,65515,NULL,NULL,'mean','NGC 6137',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137313,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137313,36.88,0.17,237,65516,70,NULL,NULL,'2MASX J16230343+2403569',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,245.7642917,24.06586,0.153,NULL,56642376827,885037137,13828705,17.4),(137314,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137314,36.23,0.46,176,65517,70,NULL,NULL,'2MASX J16230431+3945245',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000137,NULL,'15.7g',0.37,'S0',NULL,NULL,NULL,NULL,1,245.767833,39.75686,0,NULL,59853390099,935209220,14612644,15.7),(137315,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137315,38.3,0.46,457,65518,70,NULL,NULL,'2MASX J16230446+0922061',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,245.7685,9.36839,0.161,NULL,56457636145,882150564,13783602,17.1),(137316,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137316,35.55,0.75,129,65519,70,NULL,NULL,'2MASX J16230457-3021476',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,245.769041667,-30.36317,0.977,NULL,46249438841,722647481,11291366,16.1),(137317,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137317,37.62,0.27,335,65520,70,NULL,NULL,'2MASX J16230552+1956152',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,245.7730417,19.93747,0.209,NULL,56647978274,885124660,13830072,17.3),(137318,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137318,37.32,0.46,291,65521,70,NULL,NULL,'2MASX J16230762+2154412',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.781875,21.91147,0.133,NULL,56656555103,885258673,13832166,17.3),(137319,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137319,38.06,0.46,409,65522,70,NULL,NULL,'2MASX J16230771+0709081',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,245.782083,7.15236,0.277,NULL,56467562768,882305668,13786026,17.2),(137320,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137320,37.95,0.33,389,65523,70,NULL,NULL,'2MASX J16230827+1028581',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.7842917,10.48281,0.185,NULL,56457695088,882151485,13783616,17.9),(137321,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137321,36.69,0.21,217,65524,70,NULL,NULL,'2MASX J16230834+2549279',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000194,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,245.78475,25.82428,0.081,NULL,56173031727,877703620,13714119,16.4),(137322,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137322,37.55,0.46,324,65525,70,NULL,NULL,'2MASX J16230848+2546399',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.785208333,25.77772,0.081,NULL,56173027684,877703557,13714118,17.3),(137323,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137323,38.4,0.46,479,65526,70,NULL,NULL,'2MASX J16230860+1045561',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.785833,10.76553,0.185,NULL,56740844488,886575695,13852745,17.9),(137324,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137324,37.72,0.46,351,65527,70,NULL,NULL,'SDSS J162309.50+080501.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000147,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,245.789625,8.08381,0.297,NULL,56465806982,882278234,13785597,18.7),(137325,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137325,34.98,0.46,99.2,65528,70,NULL,NULL,'UGC 10360',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.00015,NULL,'14.44',1.1,'S0',NULL,NULL,NULL,NULL,1,245.797125,16.93261,0.181,NULL,56669067942,885454186,13835221,14.44),(137326,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137326,36.33,0.46,184,65529,70,NULL,NULL,'2MASX J16231377+2628457',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000173,NULL,'15.9g',0.41,NULL,NULL,NULL,NULL,NULL,1,245.8074583,26.47928,0.085,NULL,56172450470,877694538,13713977,15.9),(137327,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137327,38.07,0.46,411,65530,70,NULL,NULL,'2MASX J16232012+3854415',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00013,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,245.8339583,38.91142,0,NULL,59853630950,935212983,14612702,16.5),(137328,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137328,37.43,0.46,306,65531,70,NULL,NULL,'2MASX J16232031+3529194',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000137,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,245.834541667,35.48869,0.005,NULL,59781310045,934082969,14595046,17.6),(137329,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137329,38.43,0.46,486,65532,70,NULL,NULL,'2MASX J16232037+1434524',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,245.834833,14.58114,0.137,NULL,56659572812,885305825,13832903,18),(137330,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137330,36.53,0.23,203,65533,70,NULL,NULL,'2MASX J16232189+0855511',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,245.841125,8.93092,0.169,NULL,56469028551,882328571,13786383,16.5),(137331,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137331,37.34,0.46,293,65534,70,NULL,NULL,'2MASX J16232227+2451067',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000166,NULL,'17.1g',0.21,'AGN',NULL,NULL,NULL,NULL,1,245.8427917,24.85178,0.125,NULL,56171497087,877679641,13713744,17.1),(137332,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137332,35.62,0.09,133,65535,NULL,NULL,NULL,'KUG 1621+417',NULL,'2009ApJS..182..474S',2009,1,0.87,NULL,'G',0.000047,NULL,'14.9g',0.45,'Sb',NULL,NULL,NULL,NULL,1,245.8452083,41.65122,0,NULL,59855442167,935241283,14613145,14.9),(137333,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137333,36.53,0.23,203,65536,70,NULL,NULL,'2MASX J16232364+0856071',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.8484583,8.93547,0.169,NULL,56469025121,882328517,13786383,16.9),(137334,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137334,37.03,0.33,255,65537,70,NULL,NULL,'2MASX J16232486+2113546',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.67',0.31,NULL,NULL,NULL,NULL,NULL,1,245.8537083,21.23181,0.157,NULL,56653050722,885203917,13831311,16.67),(137335,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137335,36.53,0.23,203,65538,70,NULL,NULL,'2MASX J16232702+0901488',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,245.862625,9.03031,0.153,NULL,56468988063,882327938,13786374,16.7),(137336,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137336,37.5,0.46,317,65539,70,NULL,NULL,'2MASX J16232739+1121028',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,245.86425,11.35072,0.237,NULL,56741467899,886585435,13852897,17.9),(137337,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137337,35.54,0.21,128,65540,70,NULL,NULL,'2MASX J16232792+3749515',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000073,NULL,'15.9g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,245.8662083,37.83106,0,NULL,59768834502,933888039,14592000,15.9),(137338,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137338,35.45,0.25,123,65541,74.4,NULL,NULL,'KUG 1621+393',NULL,'2013AJ....146...86T',2013,1,0.62,'Position in Kiso list (1984AnTok..192.595T) is incorrect.','G',0.000137,NULL,'15.5g',0.62,'S',NULL,NULL,NULL,NULL,1,245.866917,39.19142,0,NULL,59853617287,935212770,14612699,15.5),(137339,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137339,35.66,0.16,135,65541,70,NULL,NULL,'KUG 1621+393',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137340,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137340,36.88,0.17,237,65542,70,NULL,NULL,'2MASX J16232869+2353477',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000176,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,245.8697083,23.89653,0.153,NULL,56642960687,885046260,13828847,17.1),(137341,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137341,36.59,0.33,208,65543,70,NULL,NULL,'2MASX J16233009+2407247',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000164,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,245.875375,24.12344,0.113,NULL,56642375271,885037113,13828704,16.6),(137342,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137342,37.22,0.2,278,65544,74.4,NULL,NULL,'CGCG 168-003',NULL,'2013AJ....146...86T',2013,1,0.97,NULL,'G',0.000025,NULL,'15.8g',0.25,'Irr',NULL,NULL,NULL,NULL,1,245.882166667,30.68725,0.041,NULL,59788106893,934189170,14596705,15.8),(137343,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137343,35.54,0.46,128,65545,70,NULL,NULL,'CGCG 052-011',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000195,NULL,'15.0g',0.53,NULL,NULL,NULL,NULL,NULL,1,245.883833333,7.85119,0.281,NULL,56465459706,882272807,13785512,15),(137344,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137344,38.1,0.46,416,65546,70,NULL,NULL,'SDSS J162332.39+341218.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.00017,NULL,'18.8g',0.09,NULL,NULL,NULL,NULL,NULL,1,245.885,34.20517,0.029,NULL,59791263025,934238484,14597476,18.8),(137345,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137345,35.76,0.06,142,65547,70,NULL,NULL,'2MASX J16233242+3913005',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000133,NULL,'16.0g',0.29,'S0^-',NULL,NULL,NULL,NULL,1,245.885,39.21672,0,NULL,59853604637,935212572,14612696,16),(137346,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137346,36.85,0.46,234,65548,70,NULL,NULL,'2MASX J16233331+1521004',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,245.888875,15.35028,0.133,NULL,56671245549,885488211,13835753,17.4),(137347,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137347,37.03,0.33,255,65549,70,NULL,NULL,'SDSS J162333.76+211850.2',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.3g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,245.890667,21.31394,0.145,NULL,56653026470,885203538,13831305,17.3),(137348,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137348,37.53,0.46,320,65550,70,NULL,NULL,'2MASX J16233385+2145176',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,245.8910417,21.755,0.133,NULL,56656082712,885251292,13832051,17.6),(137349,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137349,37.69,0.46,345,65551,70,NULL,NULL,'2MASX J16233396+2854556',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,245.8915,28.9155,0.089,NULL,59734461510,933350961,14583608,17.2),(137350,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137350,36.53,0.23,203,65552,70,NULL,NULL,'2MASX J16233425+0851068',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.1g',0.21,'AGN',NULL,NULL,NULL,NULL,1,245.892875,8.85181,0.169,NULL,56469000430,882328131,13786377,17.1),(137351,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137351,38.21,0.46,439,65553,70,NULL,NULL,'SDSS J162334.83-002733.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000068,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,245.895125,-0.45922,0.329,NULL,45501565608,710961962,11108780,18.7),(137352,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137352,37.65,0.46,339,65554,70,NULL,NULL,'2MASX J16233612+4011246',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000186,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,245.9005417,40.19028,0,NULL,59856330618,935255165,14613361,16.7),(137353,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137353,37.88,0.33,376,65555,70,NULL,NULL,'SDSS J162336.21+232506.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00019,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,245.900875,23.41833,0.149,NULL,56642839281,885044363,13828818,18.2),(137354,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137354,36.86,0.21,236,65556,70,NULL,NULL,'2MASX J16233842+1441544',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000168,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.91025,14.69853,0.133,NULL,56659640379,885306880,13832920,17.9),(137355,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137355,35.51,0.46,127,65557,70,NULL,NULL,'KUGX 1621+351',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000127,NULL,'14.9g',0.62,'Compact',NULL,NULL,NULL,NULL,1,245.910917,35.01128,0.037,NULL,59779987763,934062308,14594723,14.9),(137356,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137356,34.29,0.2,72.1,65558,74.4,NULL,NULL,'NGC 6132',NULL,'2013AJ....146...86T',2013,1,1.62,NULL,'G',0.000033,NULL,'14.3g',0.45,'Sab',NULL,NULL,NULL,NULL,1,245.911833,11.78625,0.237,NULL,56740800674,886575010,13852734,14.3),(137357,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137357,34.46,0.4,77.9,65558,NULL,NULL,'mean','NGC 6132',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137358,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137358,34.64,0.47,84.7,65558,NULL,NULL,'H','NGC 6132',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137359,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137359,36.15,0.46,170,65559,70,NULL,NULL,'CGCG 138-004',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000167,NULL,'15.3g',0.56,NULL,NULL,NULL,NULL,NULL,1,245.917,24.47419,0.121,NULL,56172055309,877688364,13713880,15.3),(137360,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137360,38.22,0.23,441,65560,70,NULL,NULL,'SDSS J162340.22+233932.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00017,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,245.917625,23.659,0.137,NULL,56642852908,885044576,13828821,18.4),(137361,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137361,37.09,0.46,262,65561,70,NULL,NULL,'2MASX J16234027+4144407',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,245.917958333,41.74467,0,NULL,59857332332,935270817,14613606,17.9),(137362,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137362,37.88,0.33,376,65562,70,NULL,NULL,'SDSS J162340.43+230903.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,245.9185,23.15103,0.165,NULL,56653966946,885218233,13831534,18.4),(137363,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137363,35.83,0.46,147,65563,70,NULL,NULL,'CGCG 080-019',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000163,NULL,'15.2',0.55,NULL,'Group member',NULL,NULL,NULL,1,245.923625,9.74492,0.185,NULL,56457497962,882148405,13783568,15.2),(137364,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137364,36.59,0.33,208,65564,70,NULL,NULL,'2MASX J16234171+2410186',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.0002,NULL,'15.5g',0.38,NULL,NULL,NULL,NULL,NULL,1,245.924,24.17181,0.113,NULL,56171758063,877683719,13713808,15.5),(137365,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137365,36.92,0.46,242,65565,70,NULL,NULL,'2MASX J16234201+1804426',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,245.9250417,18.0785,0.189,NULL,56665595985,885399937,13834374,16.6),(137366,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137366,37.82,0.27,367,65566,70,NULL,NULL,'2MASX J16234227+0021380',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00009,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,245.9262083,0.36044,0.325,NULL,56441150299,881892973,13779577,16.5),(137367,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137367,37.97,0.46,393,65567,70,NULL,NULL,'2MASX J16234295+3925037',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.929083333,39.41769,0,NULL,59853419915,935209686,14612651,17.6),(137368,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137368,38.27,0.46,451,65568,70,NULL,NULL,'2MASX J16234372+4619187',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,245.932083,46.32175,0,NULL,59833581684,934899713,14607808,18),(137369,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137369,37.95,0.46,390,65569,70,NULL,NULL,'SDSS J162343.86+205247.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000136,NULL,'18.8g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,245.9327917,20.87992,0.169,NULL,56645647369,885088240,13829503,18.8),(137370,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137370,37.34,0.46,294,65570,70,NULL,NULL,'2MASX J16234600+2357166',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.941625,23.95447,0.153,NULL,56642904694,885045385,13828834,17.5),(137371,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137371,37.82,0.27,367,65571,70,NULL,NULL,'SDSS J162350.85+002912.3',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000072,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,245.961875,0.48675,0.309,NULL,56441018153,881890908,13779545,17.6),(137372,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137372,35.76,0.06,142,65572,70,NULL,NULL,'2MASX J16235131+4007508',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000073,NULL,'15.2g',0.49,'E0',NULL,NULL,NULL,NULL,1,245.963667,40.13089,0,NULL,59856338682,935255291,14613363,15.2),(137373,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137373,37.42,0.46,304,65573,70,NULL,NULL,'SDSS J162351.33+242831.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000141,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,245.963875,24.47553,0.121,NULL,56172065935,877688530,13713883,17.9),(137374,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137374,38.22,0.23,441,65574,70,NULL,NULL,'2MASX J16235162+2338049',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,245.9650417,23.63481,0.137,NULL,56642862944,885044733,13828823,17.3),(137375,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137375,37.82,0.27,367,65575,70,NULL,NULL,'2MASX J16235213+0027130',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000116,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,245.967125,0.45372,0.309,NULL,56441028084,881891063,13779547,17.1),(137376,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137376,38.38,0.33,473,65576,70,NULL,NULL,'SDSS J162352.67+210935.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000133,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,245.9695,21.15994,0.157,NULL,56653018604,885203415,13831303,18.6),(137377,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137377,35.05,NULL,102,65577,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2034',NULL,'2010Ap&SS.325..163P',2010,1,0.84,NULL,'G',NULL,NULL,'16.6',0.1,'Scd',NULL,NULL,NULL,NULL,1,245.973833,69.08217,0.149,NULL,57846946160,903858533,14122789,16.6),(137378,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137378,35.06,NULL,103,65577,NULL,NULL,'Dipole + Quadrupole','FGC 2034',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137379,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137379,35.08,NULL,104,65577,NULL,NULL,'Dipole','FGC 2034',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137380,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137380,35.09,NULL,104,65577,NULL,NULL,NULL,'FGC 2034',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137381,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137381,36.79,0.46,228,65578,70,NULL,NULL,'2MASX J16235426+2213419',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00019,NULL,'16.0g',0.4,NULL,NULL,NULL,NULL,NULL,1,245.9760417,22.22844,0.133,NULL,56656602916,885259420,13832178,16),(137382,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137382,38.37,0.46,472,65579,70,NULL,NULL,'2MASX J16235443+1535232',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000192,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.9769583,15.58969,0.133,NULL,56671327890,885489498,13835773,17.8),(137383,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137383,38.28,0.33,452,65580,70,NULL,NULL,'SDSS J162355.66+390837.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000179,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.981958333,39.14381,0,NULL,59853612277,935212691,14612698,18.2),(137384,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137384,36.86,0.21,236,65581,70,NULL,NULL,'2MASX J16235573+1407262',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000161,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,245.9822917,14.12392,0.161,NULL,56660250692,885316417,13833069,16.6),(137385,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137385,37.75,0.46,354,65582,70,NULL,NULL,'2MASX J16235579+3609178',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,245.9824583,36.15486,0.013,NULL,59777904735,934029761,14594215,17.4),(137386,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137386,39.18,0.46,685,65583,70,NULL,NULL,'2MASX J16235648+2632074',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000147,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,245.9854583,26.5355,0.085,NULL,56172464188,877694752,13713980,18.6),(137387,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137387,38.19,0.46,435,65584,70,NULL,NULL,'SDSS J162357.65+215028.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000162,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,245.99025,21.84128,0.133,NULL,56655967642,885249494,13832023,18.3),(137388,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137388,38.2,0.27,436,65585,70,NULL,NULL,'2MASX J16235820+2039199',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.992417,20.65558,0.185,NULL,56645482067,885085657,13829463,17.8),(137389,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137389,36.69,0.21,217,65586,70,NULL,NULL,'2MASX J16235851+2542374',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000194,NULL,'16.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,245.993833333,25.71031,0.081,NULL,56172962249,877702535,13714102,16.2),(137390,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137390,38.28,0.33,452,65587,70,NULL,NULL,'2MASX J16235875+3916188',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00017,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,245.994833,39.27194,0,NULL,59853734640,935214603,14612728,17.1),(137391,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137391,37.81,0.46,365,65588,70,NULL,NULL,'2MASX J16235888+1520022',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000142,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,245.9955,15.33386,0.133,NULL,56671265998,885488531,13835758,18.5),(137392,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137392,36.86,0.21,236,65589,70,NULL,NULL,'2MASX J16235913+1437182',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000178,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,245.996333,14.62167,0.137,NULL,56659459394,885304053,13832875,16.8),(137393,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137393,37.22,0.27,278,65590,70,NULL,NULL,'2MASX J16235986+4548067',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,245.999625,45.80194,0,NULL,59833531450,934898928,14607795,17.3),(137394,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137394,38.2,0.27,436,65591,70,NULL,NULL,'2MASX J16240112+2040179',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000169,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,246.004625,20.67178,0.185,NULL,56645481921,885085655,13829463,17.6),(137395,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137395,37.98,0.27,394,65592,70,NULL,NULL,'SDSS J162401.46+273138.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000144,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,246.006125,27.52731,0.097,NULL,59733396091,933334313,14583348,18.4),(137396,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137396,36.86,0.21,236,65593,70,NULL,NULL,'2MASX J16240238+1427082',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000183,NULL,'16.0g',0.33,NULL,NULL,NULL,NULL,NULL,1,246.0097917,14.45244,0.137,NULL,56659427056,885303547,13832867,16),(137397,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137397,38.38,0.33,473,65594,70,NULL,NULL,'2MASX J16240460+2109009',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,246.0192083,21.15031,0.157,NULL,56653008538,885203258,13831300,17.9),(137398,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137398,37.54,0.46,322,65595,70,NULL,NULL,'2MASX J16240610+1226552',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000189,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,246.0255417,12.44872,0.209,NULL,56874916631,888670572,13885477,17.1),(137399,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137399,37.69,0.46,345,65596,70,NULL,NULL,'SDSS J162406.17+231301.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,246.02575,23.21703,0.145,NULL,56653917052,885217453,13831522,18.3),(137400,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137400,38.2,0.46,436,65597,70,NULL,NULL,'2MASX J16240624+0747393',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000207,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,246.026125,7.79411,0.297,NULL,56465555354,882274302,13785535,17.9),(137401,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137401,36.53,0.46,202,65598,70,NULL,NULL,'2MASX J16240730+5045343',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,246.030417,50.75969,0.017,NULL,59696142448,932752225,14574253,16.2),(137402,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137402,38.59,0.46,524,65599,70,NULL,NULL,'SDSS J162409.80+214548.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,246.040875,21.76344,0.133,NULL,56656000127,885250001,13832031,18.4),(137403,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137403,38.55,0.46,512,65600,70,NULL,NULL,'2MASX J16241132+0918363',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,246.047125,9.31011,0.161,NULL,56741633123,886588017,13852937,18),(137404,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137404,36.69,0.2,218,65601,74.4,NULL,NULL,'UGC 10372',NULL,'2013AJ....146...86T',2013,1,0.99,NULL,'G',0.000007,NULL,'15.2g',0.59,'SAB(rs)b:',NULL,NULL,NULL,NULL,1,246.05075,30.16225,0.053,NULL,59732859215,933325925,14583217,15.2),(137405,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137405,38.13,0.33,422,65602,70,NULL,NULL,'2MASX J16241232+2053489',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000154,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,246.0515,20.89689,0.169,NULL,56645587372,885087302,13829489,17.3),(137406,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137406,37.22,0.27,278,65603,70,NULL,NULL,'2MASX J16241306+4544523',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.0002,NULL,'16.1g',0.27,'S0',NULL,NULL,NULL,NULL,1,246.054417,45.74783,0,NULL,59833402578,934896915,14607764,16.1),(137407,'Cepheids','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137407,19.26,0.4,0.071,65604,NULL,NULL,'1, K, Unidentified Dwarf Galaxy, center 30 arcmin from ESO 226-SC 006','ESO 226-SC 006',NULL,'2015ApJ...802L...4C',2015,1,NULL,NULL,'*Cl',NULL,NULL,NULL,NULL,'Class III2',NULL,NULL,NULL,NULL,1,246.0590417,-51.15181,NULL,0,46325221951,723831592,11309868,NULL),(137408,'Cepheids','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137408,19.77,0.27,0.09,65604,NULL,NULL,'4, K, Mean of 4 Cepheids, Unidentified Dwarf Gxy, 30 arcmin from ESO 226-SC 006','ESO 226-SC 006',NULL,'2015ApJ...802L...4C',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137409,'Cepheids','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137409,19.82,0.4,0.092,65604,NULL,NULL,'1, K, Unidentified Dwarf Galaxy, center 30 arcmin from ESO 226-SC 006','ESO 226-SC 006',NULL,'2015ApJ...802L...4C',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137410,'Cepheids','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137410,19.84,0.4,0.093,65604,NULL,NULL,'1, K, Unidentified Dwarf Galaxy, center 30 arcmin from ESO 226-SC 006','ESO 226-SC 006',NULL,'2015ApJ...802L...4C',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137411,'Cepheids','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137411,20,0.4,0.1,65604,NULL,NULL,'1, K, Unidentified Dwarf Galaxy, center 30 arcmin from ESO 226-SC 006','ESO 226-SC 006',NULL,'2015ApJ...802L...4C',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137412,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137412,37.47,0.46,311,65605,70,NULL,NULL,'2MASX J16241468+1059493',NULL,'2015arXiv151105856S',2015,1,0.11,NULL,'G',NULL,NULL,'17.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,246.06125,10.99689,0.197,NULL,56741049011,886578890,13852795,17.7),(137413,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137413,38.08,0.46,414,65606,70,NULL,NULL,'2MASX J16241494+2558214',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000144,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,246.0622083,25.97258,0.093,NULL,56172838870,877700607,13714071,17.7),(137414,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137414,35.54,0.23,128,65607,74.4,NULL,NULL,'CGCG 224-015',NULL,'2013AJ....146...86T',2013,1,0.84,NULL,'G',0.000073,NULL,'14.9g',0.65,'E/S0',NULL,NULL,NULL,NULL,1,246.0734583,39.21103,0,NULL,59853748020,935214812,14612731,14.9),(137415,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137415,35.66,0.16,135,65607,70,NULL,NULL,'CGCG 224-015',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137416,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137416,35.76,0.06,142,65607,70,NULL,NULL,'CGCG 224-015',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137417,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137417,38.29,0.46,454,65608,70,NULL,NULL,'2MASX J16241900+2256209',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000155,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,246.07925,22.93925,0.141,NULL,56653858397,885216537,13831508,18.2),(137418,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137418,37.98,0.27,394,65609,70,NULL,NULL,'2MASX J16241933+2729225',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,246.0805,27.48956,0.097,NULL,59733409077,933334516,14583351,18.1),(137419,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137419,37.31,0.46,289,65610,70,NULL,NULL,'2MASX J16241992+1527478',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000176,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,246.083125,15.46339,0.133,NULL,56671298662,885489041,13835766,16.2),(137420,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137420,37.18,0.46,273,65611,70,NULL,NULL,'2MASXi J1624201+465043',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000171,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,246.083833,46.84519,0.005,NULL,59835147812,934924184,14608190,17.5),(137421,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137421,38.13,0.33,422,65612,70,NULL,NULL,'2MASX J16242017+2057049',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,246.0840417,20.95128,0.169,NULL,56645537873,885086529,13829477,18.1),(137422,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137422,34.32,NULL,73.1,65613,NULL,NULL,NULL,'FGC 2032',NULL,'2000BSAO...50....5K',2000,1,0.78,NULL,'G',NULL,NULL,'17.3g',0.12,'Scd',NULL,NULL,NULL,NULL,1,246.0842917,40.865,0.005,NULL,59855475358,935241802,14613153,17.3),(137423,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137423,37.76,0.46,357,65614,70,NULL,NULL,'2MASX J16242036+4606383',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000192,NULL,'16.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,246.084833,46.11067,0.005,NULL,59833639617,934900619,14607822,16.4),(137424,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137424,37.01,0.46,252,65615,70,NULL,NULL,'2MASX J16242199+0001486',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00007,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,246.091625,0.03022,0.333,NULL,56441963125,881905673,13779776,17.6),(137425,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137425,38.22,0.23,441,65616,70,NULL,NULL,'2MASX J16242202+2335082',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000179,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,246.091708333,23.58553,0.137,NULL,56642166319,885033848,13828653,17.1),(137426,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137426,37.8,0.46,363,65617,70,NULL,NULL,'2MASX J16242357+2507486',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000176,NULL,'16.9g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,246.098125,25.13011,0.105,NULL,56171531025,877680172,13713752,16.9),(137427,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137427,36.63,0.46,212,65618,70,NULL,NULL,'2MASX J16242445+4831423',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000222,NULL,'15.5g',0.52,'AGN',NULL,NULL,NULL,NULL,1,246.102125,48.52844,0,NULL,59833994249,934906160,14607908,15.5),(137428,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137428,38.22,0.46,441,65619,70,NULL,NULL,'SDSS J162424.70+290936.8',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,246.102917,29.16025,0.073,NULL,59734441204,933350643,14583603,17.4),(137429,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137429,37.22,0.27,278,65620,70,NULL,NULL,'2MASX J16242471+4546543',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000154,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,246.103166667,45.78189,0,NULL,59833404964,934896952,14607764,17),(137430,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137430,37.58,0.46,329,65621,70,NULL,NULL,'2MASX J16242481+0020378',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000072,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,246.103333,0.34392,0.321,NULL,56442009007,881906390,13779787,18.3),(137431,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137431,36.9,0.46,240,65622,70,NULL,NULL,'2MASX J16242820-0019243',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000088,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,246.1175,-0.32339,0.321,NULL,45503512051,710992375,11109255,17.3),(137432,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137432,37.73,0.46,352,65623,70,NULL,NULL,'2MASX J16242838+2642076',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,246.11825,26.70208,0.077,NULL,56172263925,877691623,13713931,17.5),(137433,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137433,37.98,0.27,394,65624,70,NULL,NULL,'2MASX J16242902+2735096',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,246.120917,27.58592,0.097,NULL,59733435938,933334936,14583358,18),(137434,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137434,36.91,0.46,241,65625,70,NULL,NULL,'2MASX J16242971+3255094',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000132,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,246.123916667,32.91928,0.025,NULL,59791626094,934244157,14597564,17.5),(137435,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137435,38.08,0.46,412,65626,70,NULL,NULL,'2MASX J16243074+2059513',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000207,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,246.128291667,20.99758,0.157,NULL,56645539414,885086553,13829477,17),(137436,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137436,37.75,0.46,355,65627,70,NULL,NULL,'2MASX J16243163+2331463',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,246.131833,23.52961,0.141,NULL,56642122424,885033162,13828643,18.1),(137437,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137437,38.22,0.23,441,65628,70,NULL,NULL,'2MASX J16243192+2332093',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000186,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,246.133083,23.53603,0.141,NULL,56642122407,885033162,13828643,16.7),(137438,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137438,36.66,0.46,214,65629,70,NULL,NULL,'2MASX J16243517+2352423',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000161,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,246.146583,23.87853,0.153,NULL,56642186427,885034162,13828658,17.1),(137439,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137439,37.5,0.46,316,65630,70,NULL,NULL,'SDSS J162436.14+305455.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000138,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,246.150625,30.91536,0.041,NULL,59788180754,934190324,14596723,18.6),(137440,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137440,37.64,0.46,337,65631,70,NULL,NULL,'SDSS J162436.84+000912.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000072,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,246.1535417,0.1535,0.333,NULL,56441975401,881905865,13779779,18),(137441,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137441,38.2,0.27,436,65632,70,NULL,NULL,'2MASX J16243776+2038133',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,246.1575,20.63706,0.185,NULL,56646130425,885095787,13829621,17.5),(137442,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137442,38.29,0.46,456,65633,70,NULL,NULL,'2MASX J16243940+1859393',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,246.164125,18.99419,0.189,NULL,56702542185,885977221,13843394,17),(137443,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137443,36.79,0.46,228,65634,70,NULL,NULL,'CGCG 168-007',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000213,NULL,'15.6g',0.43,'E0',NULL,NULL,NULL,NULL,1,246.175667,30.76439,0.041,NULL,59788193135,934190517,14596726,15.6),(137444,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137444,34.72,0.68,88,65635,NULL,NULL,'Malmquist cor.','UGC 10373',NULL,'2009ApJS..182..474S',2009,1,1.31,'CGCG declination is 7 arcmin too large (B. Skiff).','G',0.00007,NULL,'15.6g',0.23,'Scd:',NULL,NULL,NULL,NULL,1,246.176375,7.18256,0.237,NULL,56464003968,882250062,13785157,15.6),(137445,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137445,34.87,0.63,94.1,65635,NULL,NULL,NULL,'UGC 10373',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137446,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137446,34.88,0.2,94.6,65635,74.4,NULL,NULL,'UGC 10373',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137447,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137447,38.58,0.46,520,65636,70,NULL,NULL,'SDSS J162443.35+460832.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000119,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,246.180667,46.14233,0.005,NULL,59833643459,934900679,14607823,18.5),(137448,'SGRB','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137448,38.73,NULL,557,65637,71,NULL,NULL,'CXO J162444.3-273227',NULL,'2010ApJ...709..664R',2010,1,NULL,NULL,'G',0.0004,NULL,'18.6I',NULL,'Early-type',NULL,NULL,NULL,NULL,1,246.184917,-27.54097,1.065,NULL,46247705667,722620401,11290943,18.6),(137449,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137449,37.92,0.46,383,65638,70,NULL,NULL,'2MASX J16244452+1446037',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,246.185417,14.76775,0.153,NULL,56659503198,885304737,13832886,17.1),(137450,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137450,37.75,0.46,355,65639,70,NULL,NULL,'SDSS J162445.97+391051.1',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000185,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,246.1915417,39.18086,0.005,NULL,59853742599,935214728,14612730,16.8),(137451,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137451,38.07,0.33,411,65640,70,NULL,NULL,'2MASX J16244856+0952214',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,246.202333333,9.87272,0.185,NULL,56742503633,886601619,13853150,17.3),(137452,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137452,35.78,0.33,143,65641,70,NULL,NULL,'CGCG 080-024',NULL,'2015arXiv151105856S',2015,1,1.2,NULL,'G',0.000117,NULL,'15.3',0.9,'E','Pair member (points to parent)',NULL,NULL,NULL,1,246.204833,9.57589,0.165,NULL,56741851033,886591422,13852990,15.3),(137453,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137453,37.59,0.46,329,65642,70,NULL,NULL,'2MASX J16244931+2934030',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,246.205625,29.56744,0.049,NULL,59735093675,933360838,14583763,17.1),(137454,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137454,35.84,0.2,147,65643,74.4,NULL,NULL,'UGC 10375',NULL,'2013AJ....146...86T',2013,1,1.23,NULL,'G',0.000013,NULL,'15.43',0.15,'Sbc','Pair member (points to parent)',NULL,NULL,NULL,1,246.2085417,9.60708,0.185,NULL,56741794072,886590532,13852977,15.43),(137455,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137455,35.89,NULL,150,65643,NULL,NULL,'Dipole + Quadrupole','UGC 10375',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137456,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137456,35.89,NULL,151,65643,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10375',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137457,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137457,35.9,NULL,151,65643,NULL,NULL,'Dipole','UGC 10375',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137458,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137458,36.05,NULL,162,65643,NULL,NULL,NULL,'UGC 10375',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137459,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137459,35.66,0.46,135,65644,70,NULL,NULL,'CGCG 138-010',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000166,NULL,'15.4g',0.49,NULL,NULL,NULL,NULL,NULL,1,246.21,21.61386,0.125,NULL,56653182725,885205980,13831343,15.4),(137460,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137460,37.77,0.46,357,65645,70,NULL,NULL,'2MASX J16245061+0720294',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,246.2109583,7.3415,0.237,NULL,56464042405,882250662,13785166,17.7),(137461,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137461,35.76,0.2,142,65646,74.4,NULL,NULL,'CGCG 080-026',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000094,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,246.2114583,13.68508,0.161,NULL,56660469375,885319833,13833122,16.5),(137462,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137462,36.36,0.46,187,65647,70,NULL,NULL,'SDSS J162450.92+174413.7',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.2g',0.32,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,246.2122083,17.73714,0.177,NULL,56667423557,885428493,13834820,16.2),(137463,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137463,36.34,0.46,185,65648,70,NULL,NULL,'2MASX J16245379+3122306',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000158,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,246.224291667,31.37519,0.021,NULL,59788508964,934195452,14596803,16.5),(137464,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137464,35.67,0.1,136,65649,NULL,NULL,NULL,'NGC 6138',NULL,'2009ApJS..182..474S',2009,1,1.2,'Identification as N6138 is uncertain; N6138 may be CGCG 224-009.','G',0.000077,NULL,'15.4g',0.25,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,246.225708333,41.05078,0.005,NULL,59855490106,935242032,14613156,15.4),(137465,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137465,36.38,0.46,189,65650,70,NULL,NULL,'2MASX J16245589+4729184',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000167,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,246.23275,47.48853,0.009,NULL,59834627487,934916054,14608063,16.4),(137466,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137466,38.29,0.46,454,65651,70,NULL,NULL,'2MASX J16245830+3011425',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000182,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,246.242875,30.19508,0.053,NULL,59732881598,933326274,14583223,17.5),(137467,'SNIa','2016-12-15 15:15:42','2016-12-16 11:20:56','1','PTF10gmg','N',137467,37.38,0.03,282,65652,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10gmg',0.0628,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137468,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137468,35.78,0.33,143,65653,70,NULL,NULL,'2MASX J16250045+0944285',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'15.7g',0.37,NULL,NULL,NULL,NULL,NULL,1,246.251833,9.74122,0.185,NULL,56741760110,886590001,13852968,15.7),(137469,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137469,36.06,0.46,163,65654,70,NULL,NULL,'2MASX J16250140+2415471',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000891,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,246.256,24.26317,0.121,NULL,56171350444,877677350,13713708,16.6),(137470,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137470,35.73,0.06,140,65655,NULL,NULL,NULL,'NGC 6145',NULL,'2009ApJS..182..474S',2009,1,0.98,NULL,'G',0.00011,NULL,'14.5g',0.5,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,246.259833,40.94664,0.005,NULL,59855976839,935249638,14613275,14.5),(137471,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137471,38.07,0.33,411,65656,70,NULL,NULL,'2MASX J16250294+0954375',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,246.2622917,9.91047,0.185,NULL,56742469242,886601081,13853141,17.7),(137472,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137472,37.35,0.33,295,65657,70,NULL,NULL,'2MASX J16250543+2347555',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,246.2727083,23.79875,0.133,NULL,56642203425,885034428,13828662,17.1),(137473,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137473,37.52,0.59,320,65658,70,NULL,NULL,'2MASX J16250671-6454099',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,246.277833333,-64.90281,0.797,NULL,44993742648,703027228,10984800,16),(137474,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137474,36.65,0.46,214,65659,70,NULL,NULL,'2MASX J16250741+3236169',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,246.281083,32.60467,0.029,NULL,59786960713,934171261,14596425,17.3),(137475,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137475,36.34,0.46,185,65660,70,NULL,NULL,'2MASX J16250750+5015327',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000102,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,246.281375,50.25922,0,NULL,59696474934,932757420,14574334,16.9),(137476,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137476,34.3,0.4,72.4,65661,75,NULL,'Edat, raw','NGC 6146',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000053,NULL,'13.51',1,'E/S0           PEG','in a radial-velocity based grouping',NULL,'radio jet',NULL,1,246.293166667,40.89286,0.005,NULL,59855975274,935249613,14613275,13.51),(137477,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137477,34.63,0.4,84.2,65661,75,NULL,'Edat, cor','NGC 6146',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137478,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137478,34.7,0.22,87.1,65661,74.4,NULL,NULL,'NGC 6146',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137479,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137479,35.29,0.22,114,65661,70,NULL,NULL,'NGC 6146',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137480,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137480,35.37,0.45,119,65661,NULL,NULL,'K','NGC 6146',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137481,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137481,35.49,0.4,125,65661,NULL,NULL,'mean','NGC 6146',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137482,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137482,36.57,0.46,206,65662,70,NULL,NULL,'SDSS J162511.07+375829.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000186,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,246.296167,37.97475,0,NULL,59819227685,934675432,14604303,16.9),(137483,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137483,36.67,0.46,216,65663,70,NULL,NULL,'2MASX J16251271+3648568',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000084,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,246.302875,36.81597,0.013,NULL,59777814114,934028345,14594192,17.1),(137484,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137484,37.39,0.33,300,65664,70,NULL,NULL,'2MASX J16251519+4145568',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,246.313458333,41.76581,0.009,NULL,59857392502,935271757,14613621,17.2),(137485,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137485,38.38,0.46,474,65665,70,NULL,NULL,'SDSS J162516.47+182654.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,246.318625,18.44844,0.173,NULL,56702292614,885973322,13843333,18.5),(137486,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137486,36.76,0.46,225,65666,70,NULL,NULL,'2MASX J16251703+0814505',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.00012,NULL,'16.75',0.43,NULL,NULL,NULL,NULL,NULL,1,246.321167,8.24747,0.221,NULL,56747240911,886675639,13854306,16.75),(137487,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137487,37.35,0.33,295,65667,70,NULL,NULL,'2MASX J16251710+2359551',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000185,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,246.321417,23.99872,0.125,NULL,56642220309,885034692,13828667,16.6),(137488,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137488,36.46,0.33,196,65668,70,NULL,NULL,'2MASX J16251751+1332319',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000187,NULL,'15.9g',0.43,NULL,NULL,NULL,NULL,NULL,1,246.323083333,13.54222,0.165,NULL,56657023759,885265996,13832281,15.9),(137489,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137489,38.71,0.46,552,65669,70,NULL,NULL,'SDSS J162517.70+085244.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,246.323791667,8.87892,0.205,NULL,56747053789,886672715,13854261,18.4),(137490,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137490,38.37,0.33,472,65670,70,NULL,NULL,'2MASX J16252001+3507220',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,246.3335417,35.12281,0.013,NULL,59779672428,934057381,14594646,17.7),(137491,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137491,38.37,0.33,472,65671,70,NULL,NULL,'2MASX J16252001+3509370',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,246.333625,35.16028,0.013,NULL,59779703978,934057874,14594654,17.5),(137492,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137492,37.39,0.33,300,65672,70,NULL,NULL,'2MASX J16252175+4156365',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000189,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,246.340417,41.94353,0.009,NULL,59857416934,935272139,14613627,17.2),(137493,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137493,37.13,0.46,267,65673,70,NULL,NULL,'2MASX J16252254+1311289',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00018,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,246.3439583,13.19147,0.189,NULL,56657121459,885267522,13832305,17.1),(137494,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137494,36.43,0.46,194,65674,70,NULL,NULL,'2MASX J16252268+3910393',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000077,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,246.3445,39.17758,0.005,NULL,59853724658,935214447,14612725,16.6),(137495,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137495,37.1,0.46,263,65675,70,NULL,NULL,'2MASX J16252365+3151420',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000176,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,246.3485,31.86169,0.037,NULL,59788862694,934200979,14596890,16.5),(137496,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137496,37.13,0.46,267,65676,70,NULL,NULL,'2MASX J16252389+2044447',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,246.34975,20.74567,0.169,NULL,56646083027,885095047,13829610,17.6),(137497,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137497,37.61,0.46,333,65677,70,NULL,NULL,'2MASX J16252549+1750459',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,246.356416667,17.84608,0.169,NULL,56667647654,885431994,13834874,17.6),(137498,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137498,35.79,0.46,144,65678,70,NULL,NULL,'2MASX J16252668+2303467',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00017,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,246.361333333,23.06297,0.145,NULL,56654548747,885227324,13831676,16.3),(137499,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137499,35.86,0.58,148,65679,70,NULL,NULL,'FAIRALL 1420',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'17.1b',0.2,NULL,NULL,NULL,NULL,NULL,1,246.367917,-76.87781,0.397,NULL,44140983161,689702861,10776607,17.1),(137500,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137500,35.93,0.46,154,65680,70,NULL,NULL,'2MASX J16252835+3751523',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000087,NULL,'15.6g',0.45,'E0',NULL,NULL,NULL,NULL,1,246.3680417,37.86469,0.009,NULL,59819192697,934674885,14604295,15.6),(137501,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137501,37.62,0.46,335,65681,70,NULL,NULL,'2MASX J16252928+1734349',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,246.3719583,17.57636,0.177,NULL,56667537112,885430267,13834847,17.2),(137502,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137502,37.28,0.46,286,65682,70,NULL,NULL,'SDSS J162530.09+070657.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,246.375375,7.11597,0.237,NULL,56745365041,886646328,13853848,17.8),(137503,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137503,37.03,0.46,255,65683,70,NULL,NULL,'2MASX J16253335+0719302',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'17.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,246.389041667,7.32517,0.241,NULL,56745290556,886645164,13853830,17.4),(137504,'L(H{beta})-{sigma}','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137504,46.05,NULL,1605,65684,74.3,NULL,NULL,'PKS 1623+26:[ESS2006] BX0215',2.1814,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,'24.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,246.390833333,26.89742,0.085,NULL,56183799323,877871864,13716747,24.4),(137505,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137505,35.76,0.06,142,65685,70,NULL,NULL,'2MASX J16253400+3840344',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000093,NULL,'15.5g',0.5,'S0^-',NULL,NULL,NULL,NULL,1,246.391541667,38.67617,0.013,NULL,59852808949,935200139,14612502,15.5),(137506,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137506,35.76,0.06,142,65686,70,NULL,NULL,'2MASX J16253423+3855594',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000143,NULL,'15.3g',0.53,'S0',NULL,NULL,NULL,NULL,1,246.392833,38.93331,0.009,NULL,59853685399,935213834,14612716,15.3),(137507,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137507,38.35,0.46,468,65687,70,NULL,NULL,'2MASX J16253481+3450280',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000139,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,246.395125,34.84117,0.021,NULL,59780322292,934067535,14594805,18.3),(137508,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137508,35.84,0.46,147,65688,70,NULL,NULL,'2MASX J16253488+2032397',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000187,NULL,'15.7g',0.49,NULL,NULL,NULL,NULL,NULL,1,246.3952083,20.54436,0.185,NULL,56646027539,885094180,13829596,15.7),(137509,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137509,37.1,0.65,263,65689,70,NULL,NULL,'2MASX J16253621-0310394',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,246.400875,-3.17769,0.645,NULL,45510175809,711096497,11110882,14.4),(137510,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137510,37.18,0.46,274,65690,70,NULL,NULL,'2MASX J16253741+1452199',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000161,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,246.405916667,14.87219,0.153,NULL,56659318352,885301849,13832841,17.3),(137511,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137511,35.83,0.46,147,65691,70,NULL,NULL,'KUGX 1623+360',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.00009,NULL,'15.1g',0.44,'Spiral',NULL,NULL,NULL,NULL,1,246.4062917,35.97764,0.013,NULL,59777782590,934027852,14594185,15.1),(137512,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137512,34.97,0.46,98.5,65692,70,NULL,NULL,'ARK 502',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.00011,NULL,'14.5g',0.65,'E',NULL,NULL,NULL,NULL,1,246.4087083,16.45503,0.173,NULL,56670824302,885481629,13835650,14.5),(137513,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137513,36.46,0.33,196,65693,70,NULL,NULL,'2MASX J16253856+1332510',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000093,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,246.410666667,13.54739,0.165,NULL,56657020841,885265950,13832280,16.6),(137514,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137514,35.76,0.06,142,65694,70,NULL,NULL,'2MASX J16253934+3932464',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000073,NULL,'16.0g',0.31,'E0',NULL,NULL,NULL,NULL,1,246.414125,39.54611,0.005,NULL,59853060295,935204067,14612563,16),(137515,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137515,38.49,0.46,499,65695,70,NULL,NULL,'SDSS J162541.57+113432.8',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,246.42325,11.57581,0.229,NULL,56741349462,886583585,13852868,NULL),(137516,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137516,35.6,0.25,132,65696,74.4,NULL,NULL,'CGCG 224-020',NULL,'2013AJ....146...86T',2013,1,0.81,NULL,'G',0.000097,NULL,'14.7g',0.6,'S0',NULL,NULL,NULL,NULL,1,246.424333,39.60008,0.005,NULL,59853049079,935203891,14612560,14.7),(137517,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137517,35.76,0.06,142,65696,70,NULL,NULL,'CGCG 224-020',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137518,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137518,36.69,0.21,217,65697,70,NULL,NULL,'2MASX J16254249+2543571',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000117,NULL,'15.7g',0.48,NULL,NULL,NULL,NULL,NULL,1,246.427083,25.73261,0.081,NULL,56184021595,877875337,13716802,15.7),(137519,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137519,36.62,0.46,211,65698,70,NULL,NULL,'2MASX J16254360+4918515',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000194,NULL,'15.6g',0.46,'S0^-',NULL,NULL,NULL,NULL,1,246.43175,49.31422,0,NULL,59828645554,934822586,14606602,15.6),(137520,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137520,36.44,0.46,194,65699,70,NULL,NULL,'2MASX J16254564+1733072',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'17.07',0.42,NULL,NULL,NULL,NULL,NULL,1,246.440291667,17.55208,0.177,NULL,56667497035,885429641,13834838,17.07),(137521,'HII LF','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137521,45.45,3.07,2750,65700,71,NULL,NULL,'PKS 1623+26:[ESS2003] BX0432',2.1817,'2005MNRAS.356.1117S',2005,1,NULL,NULL,'G',NULL,NULL,'24.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,246.453083,26.77972,0.085,NULL,56184010576,877875165,13716799,24.5),(137522,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137522,35.07,0.49,103,65701,75,NULL,'IR','UGC 10380',NULL,'2011yCatp016004901K',2011,1,1.62,NULL,'G',0.000033,NULL,'15.1g',0.32,'Sb',NULL,NULL,NULL,NULL,1,246.4579583,16.57606,0.185,NULL,56672913877,885514279,13836160,15.1),(137523,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137523,35.38,0.2,119,65701,74.4,NULL,NULL,'UGC 10380',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137524,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137524,35.55,0.47,129,65701,NULL,NULL,'H','UGC 10380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137525,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137525,35.6,0.4,132,65701,NULL,NULL,'mean','UGC 10380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137526,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137526,35.7,0.45,138,65701,NULL,NULL,'K','UGC 10380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137527,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137527,35.77,0.46,142,65701,NULL,NULL,'J','UGC 10380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137528,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137528,35.76,0.06,142,65702,70,NULL,NULL,'NGC 6150',NULL,'2015arXiv151105856S',2015,1,1.28,NULL,'G',0.000093,NULL,'14.0g',0.67,'E?','Group member, radial-velocity confirmed',NULL,'NAT',NULL,1,246.4584583,40.48856,0.013,NULL,59856816242,935262753,14613480,14),(137529,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137529,37.72,0.46,349,65703,70,NULL,NULL,'2MASX J16255076+1659483',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,246.4614583,16.99661,0.197,NULL,56667896316,885435879,13834935,17.1),(137530,'L(H{beta})-{sigma}','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137530,46.05,NULL,1604,65704,74.3,NULL,NULL,'PKS 1623+26:[SSP2004] BX0453',2.1816,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,'23.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,246.461833,26.82539,0.085,NULL,56183976824,877874637,13716791,23.3),(137531,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137531,37.63,0.46,335,65705,70,NULL,NULL,'2MASX J16255106+1426023',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,246.4627083,14.43406,0.153,NULL,56660007072,885312610,13833009,17.3),(137532,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137532,35.54,0.21,128,65706,70,NULL,NULL,'KUGX 1624+374',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00008,NULL,'15.3g',0.43,'Compact',NULL,NULL,NULL,NULL,1,246.465375,37.36208,0.009,NULL,59748113961,933564280,14586941,15.3),(137533,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137533,35.05,0.51,102,65707,70,NULL,NULL,'2MASX J16255356-6526472',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,246.4730417,-65.44658,0.757,NULL,44994161465,703033772,10984902,15.2),(137534,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137534,37.02,0.46,254,65708,70,NULL,NULL,'2MASX J16255370+3036027',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000145,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,246.47375,30.60067,0.041,NULL,59788032959,934188014,14596687,16.9),(137535,'HII LF','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'N',137535,44.82,1.58,1850,65709,71,NULL,NULL,'[HB89] 1623+269:MD107',2.5373,'2005MNRAS.356.1117S',2005,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137536,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137536,37.1,0.46,262,65710,70,NULL,NULL,'2MASX J16255439+5006465',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000184,NULL,'16.5g',0.34,'AGN',NULL,NULL,NULL,NULL,1,246.47675,50.11294,0.017,NULL,59696399746,932756246,14574316,16.5),(137537,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137537,38.49,0.46,498,65711,70,NULL,NULL,'SDSS J162555.89+255650.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,246.482917,25.94744,0.089,NULL,56184240556,877878758,13716855,18.6),(137538,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137538,37.94,0.46,388,65712,70,NULL,NULL,'2MASX J16260061+3348107',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,246.502417,33.80294,0.037,NULL,59790944074,934233501,14597398,17.3),(137539,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137539,38.1,0.46,417,65713,70,NULL,NULL,'2MASX J16260070+2042529',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,246.502958333,20.71456,0.169,NULL,56645993466,885093647,13829588,18.1),(137540,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137540,36.18,0.46,172,65714,70,NULL,NULL,'2MASX J16260081+0923503',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00009,NULL,'16.20',0.52,NULL,NULL,NULL,NULL,NULL,1,246.5035,9.39728,0.153,NULL,56755446956,886803858,13856310,16.2),(137541,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137541,38.04,0.46,405,65715,70,NULL,NULL,'2MASX J16260104+2105429',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,246.504291667,21.09511,0.153,NULL,56645193609,885081150,13829392,17.6),(137542,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137542,37,0.46,251,65716,70,NULL,NULL,'2MASX J16260492+1720423',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00011,NULL,'11.2K',NULL,NULL,NULL,NULL,NULL,NULL,1,246.520541667,17.34503,0.177,NULL,56667955682,885436807,13834950,11.2),(137543,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137543,36.34,0.5,185,65717,70,NULL,NULL,'2MASX J16260655-0040457',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.24',0.4,NULL,NULL,NULL,NULL,NULL,1,246.527167,-0.67939,0.321,NULL,45503621310,710994082,11109282,16.24),(137544,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137544,37.52,0.46,319,65718,70,NULL,NULL,'2MASX J16260663+0715223',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,246.527667,7.25614,0.241,NULL,56745502926,886648483,13853882,NULL),(137545,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137545,37.89,0.21,378,65719,70,NULL,NULL,'2MASX J16260790+1337133',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,246.5329583,13.62036,0.165,NULL,56660545041,885321016,13833140,17.2),(137546,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137546,31.85,0.43,23.4,65720,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6155',NULL,'2014MNRAS.444..527S',2014,1,1.68,NULL,'G',0.00009,NULL,'13.2g',0.99,'SBcd','Field galaxy',NULL,NULL,NULL,1,246.53475,48.36681,0,NULL,59842358873,935036857,14609950,13.2),(137547,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137547,32.03,0.43,25.4,65720,75,NULL,'3.6 micron, color corrected','NGC 6155',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137548,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137548,32.22,0.2,27.8,65720,74.4,NULL,NULL,'NGC 6155',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137549,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137549,35.42,0.46,122,65721,70,NULL,NULL,'KUGX 1624+328',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.0001,NULL,'15.3g',0.44,'Compact',NULL,NULL,NULL,NULL,1,246.538333,32.75231,0.041,NULL,59787073706,934173026,14596453,15.3),(137550,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137550,36.66,0.46,215,65722,70,NULL,NULL,'2MASX J16260958+4620189',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,246.5397917,46.3385,0,NULL,59833263164,934894736,14607730,16.7),(137551,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137551,37.89,0.21,378,65723,70,NULL,NULL,'2MASX J16260994+1331335',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00018,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,246.541333,13.52606,0.165,NULL,56656940234,885264691,13832260,16.8),(137552,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137552,35.67,0.69,136,65724,70,NULL,NULL,'2MASX J16261019-0208117',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.3,NULL,NULL,NULL,NULL,NULL,1,246.5425417,-2.13661,0.545,NULL,45502813626,710981462,11109085,14.1),(137553,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137553,35.76,0.06,142,65725,70,NULL,NULL,'2MASX J16261097+3914137',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000103,NULL,'16.1g',0.28,'S0',NULL,NULL,NULL,NULL,1,246.545875,39.237,0,NULL,59853065286,935204145,14612564,16.1),(137554,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137554,37.89,0.21,378,65726,70,NULL,NULL,'2MASX J16261105+1324255',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000143,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,246.5460417,13.407,0.165,NULL,56656941479,885264710,13832261,18.3),(137555,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137555,38.24,0.46,444,65727,70,NULL,NULL,'SDSS J162611.15+341120.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000134,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,246.5465,34.18897,0.029,NULL,59779461898,934054092,14594595,17.7),(137556,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137556,36.66,0.55,215,65728,70,NULL,NULL,'2MASX J16261289-0039337',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.8I',0.5,NULL,NULL,NULL,NULL,NULL,1,246.553666667,-0.65931,0.321,NULL,45503616292,710994004,11109281,13.8),(137557,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137557,36.66,0.46,215,65729,70,NULL,NULL,'2MASX J16261379+4610540',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000157,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,246.557375,46.18153,0.005,NULL,59833615176,934900237,14607816,17.1),(137558,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137558,35.46,0.25,124,65730,74.4,NULL,NULL,'KUG 1624+400',NULL,'2013AJ....146...86T',2013,1,0.62,NULL,'G',0.000092,NULL,'14.8g',0.51,'S',NULL,NULL,NULL,NULL,1,246.55925,39.96717,0,NULL,59856677400,935260584,14613446,14.8),(137559,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137559,35.66,0.16,135,65730,70,NULL,NULL,'KUG 1624+400',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137560,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137560,37.32,0.46,291,65731,70,NULL,NULL,'2MASX J16262088+2807087',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000174,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,246.587,28.11922,0.125,NULL,59734118385,933345599,14583524,16.6),(137561,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137561,37.89,0.21,378,65732,70,NULL,NULL,'2MASX J16262153+1336165',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000175,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,246.589625,13.60456,0.165,NULL,56660376090,885318376,13833099,17.6),(137562,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137562,37.55,0.46,323,65733,70,NULL,NULL,'2MASX J16262389+3919247',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000147,NULL,'16.7g',0.28,'S0',NULL,NULL,NULL,NULL,1,246.5995,39.32344,0,NULL,59853075191,935204299,14612567,16.7),(137563,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137563,35.76,0.06,142,65734,70,NULL,NULL,'2MASX J16262604+3917217',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000077,NULL,'16.1g',0.39,'E',NULL,NULL,NULL,NULL,1,246.608667,39.28936,0,NULL,59853076982,935204327,14612567,16.1),(137564,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137564,37.27,0.46,285,65735,70,NULL,NULL,'2MASX J16262674+3714007',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00011,NULL,'16.0g',0.47,'E0',NULL,NULL,NULL,NULL,1,246.611416667,37.23347,0.005,NULL,59747943775,933561621,14586900,16),(137565,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137565,37.85,0.46,372,65736,70,NULL,NULL,'2MASX J16262761+2728409',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000175,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,246.615125,27.47806,0.085,NULL,56179712610,877808009,13715750,17.6),(137566,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137566,37.64,0.46,338,65737,70,NULL,NULL,'2MASX J16262913+1432306',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000145,NULL,'18.7g',0.08,NULL,NULL,NULL,NULL,NULL,1,246.6212917,14.54194,0.153,NULL,56659957008,885311828,13832997,18.7),(137567,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137567,35.76,0.06,142,65738,70,NULL,NULL,'2MASX J16262938+3904557',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000073,NULL,'15.4g',0.43,'E',NULL,NULL,NULL,NULL,1,246.6222917,39.08219,0.005,NULL,59853147383,935205427,14612584,15.4),(137568,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137568,37.89,0.21,378,65739,70,NULL,NULL,'2MASX J16263236+1341486',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,246.635,13.697,0.177,NULL,56660373165,885318330,13833098,17.6),(137569,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137569,36.17,0.46,171,65740,70,NULL,NULL,'2MASX J16263270+2252282',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,246.636167,22.87442,0.141,NULL,56654293269,885223332,13831614,16.8),(137570,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137570,37.17,0.46,272,65741,70,NULL,NULL,'2MASX J16263313+0946006',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,246.638083,9.76692,0.201,NULL,56741659854,886588435,13852944,17.1),(137571,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137571,36.66,0.33,215,65742,70,NULL,NULL,'2MASX J16263333+2552569',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000185,NULL,'16.1g',0.35,'AGN',NULL,NULL,NULL,NULL,1,246.639,25.88239,0.089,NULL,56184035869,877875560,13716805,16.1),(137572,'IRAS','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137572,33.35,0.8,46.8,65743,75,NULL,'HMCL, I','ESO 100- G 023',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000017,NULL,'16.1',1.1,'SAB(s)c',NULL,NULL,NULL,NULL,1,246.648625,-63.19617,NULL,NULL,44463580838,694743450,10855366,16.1),(137573,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137573,31.71,0.4,22,65743,75,NULL,'HMCL, I, raw','ESO 100- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137574,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137574,31.86,0.4,23.5,65743,75,NULL,'HMCL, I, inv','ESO 100- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137575,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137575,32.08,0.4,26.1,65743,75,NULL,'HMCL, I, cor','ESO 100- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137576,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137576,33.23,0.46,44.3,65743,NULL,NULL,'J','ESO 100- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137577,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137577,33.24,0.47,44.4,65743,NULL,NULL,'H','ESO 100- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137578,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137578,33.26,0.45,45,65743,NULL,NULL,'K','ESO 100- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137579,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137579,33.47,0.4,49.5,65743,NULL,NULL,'mean','ESO 100- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137580,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137580,35.76,0.06,142,65744,70,NULL,NULL,'2MASX J16263702+3910516',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00007,NULL,'16.1g',0.39,'S0',NULL,NULL,NULL,NULL,1,246.6542917,39.18111,0,NULL,59853179428,935205928,14612592,16.1),(137581,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137581,35.64,0.08,135,65745,NULL,NULL,NULL,'UGC 10389',NULL,'2009ApJS..182..474S',2009,1,0.74,NULL,'G',0.000046,NULL,'15.8g',0.3,'SBb            HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,246.6545,39.12753,0.005,NULL,59853178693,935205917,14612592,15.8),(137582,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137582,36.14,0.46,169,65746,70,NULL,NULL,'KUG 1624+336A',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000172,NULL,'15.6g',0.48,'Compact',NULL,NULL,NULL,NULL,1,246.656166667,33.52108,0.045,NULL,59791030649,934234853,14597419,15.6),(137583,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137583,38.4,0.46,478,65747,70,NULL,NULL,'SDSS J162639.12+180730.9',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,246.6630417,18.12525,0.161,NULL,56700287766,885941996,13842843,NULL),(137584,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137584,35.11,0.25,105,65748,74.4,NULL,NULL,'CGCG 224-025',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000137,NULL,'14.3g',0.84,'SB?',NULL,NULL,NULL,NULL,1,246.6660417,40.47808,0.013,NULL,59856745751,935261652,14613463,14.3),(137585,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137585,35.29,0.22,114,65748,70,NULL,NULL,'CGCG 224-025',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137586,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137586,37.84,0.46,370,65749,70,NULL,NULL,'2MASX J16263999+4931101',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,246.666875,49.51942,0.005,NULL,59828754074,934824282,14606629,17.8),(137587,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137587,37.54,0.46,322,65750,70,NULL,NULL,'2MASX J16264075+2746389',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,246.6699583,27.77753,0.109,NULL,59734113435,933345522,14583523,17),(137588,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137588,32.05,0.49,25.8,65751,75,NULL,'IR','ESO 137- G 027',NULL,'2011yCatp016004901K',2011,1,2.6,NULL,'G',0.000025,NULL,'13.96',0.5,'SB(s)dm:;ext.LSB dsk',NULL,NULL,NULL,NULL,1,246.673333,-59.95658,NULL,NULL,44502683180,695354424,10864912,13.96),(137589,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137589,37.73,0.33,351,65752,70,NULL,NULL,'2MASX J16264481+4852310',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000178,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,246.686625,48.87517,0.005,NULL,59842394349,935037411,14609959,16.3),(137590,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137590,37.81,0.46,364,65753,70,NULL,NULL,'2MASX J16264512+1428417',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000155,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,246.6879583,14.47842,0.153,NULL,56659996425,885312444,13833006,17.3),(137591,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137591,35.76,0.06,142,65754,70,NULL,NULL,'III Zw 078',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000133,NULL,'15.4g',0.53,'S0','Group member',NULL,NULL,NULL,1,246.688083,40.68422,0.005,NULL,59856037486,935250585,14613290,15.4),(137592,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137592,37.26,0.46,283,65755,70,NULL,NULL,'2MASX J16264546+2021072',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000195,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,246.689417,20.35214,0.225,NULL,56701625434,885962897,13843170,16.2),(137593,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137593,38,0.46,398,65756,70,NULL,NULL,'2MASX J16264549+0754276',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,246.6895417,7.90778,0.241,NULL,56748297746,886692152,13854564,17.7),(137594,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137594,36.61,0.46,209,65757,70,NULL,NULL,'2MASX J16264558+2240412',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000178,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,246.68975,22.678,0.137,NULL,56654072945,885219889,13831560,16.4),(137595,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137595,34.46,0.47,77.8,65758,NULL,NULL,'H','UGC 10384',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000017,NULL,'15.00',0.3,'S?',NULL,NULL,NULL,NULL,1,246.6945,11.58028,0.253,NULL,56741232481,886581757,13852839,15),(137596,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137596,34.48,0.4,78.7,65758,NULL,NULL,'mean','UGC 10384',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137597,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137597,34.49,0.49,79.1,65758,75,NULL,'IR','UGC 10384',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137598,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137598,34.56,0.45,81.5,65758,NULL,NULL,'K','UGC 10384',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137599,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137599,34.56,0.2,81.7,65758,74.4,NULL,NULL,'UGC 10384',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137600,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137600,34.71,0.46,87.7,65758,NULL,NULL,'J','UGC 10384',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137601,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137601,37.47,0.46,312,65759,70,NULL,NULL,'2MASX J16264676+1324028',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,246.6949583,13.40081,0.165,NULL,56656977539,885265274,13832269,17.9),(137602,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137602,35.98,0.46,157,65760,70,NULL,NULL,'2MASX J16264811+2318342',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000164,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,246.7005,23.30939,0.141,NULL,56654424158,885225377,13831646,16.6),(137603,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137603,37.47,0.27,312,65761,70,NULL,NULL,'2MASX J16264946+4836042',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000195,NULL,'16.5g',0.33,'AGN',NULL,NULL,NULL,NULL,1,246.706,48.60122,0,NULL,59842444354,935038193,14609971,16.5),(137604,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137604,37.27,0.46,284,65762,70,NULL,NULL,'SDSS J162650.05+164405.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'18.2g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,246.708583333,16.73475,0.189,NULL,56669556690,885461823,13835340,18.2),(137605,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137605,38.06,0.46,410,65763,70,NULL,NULL,'2MASX J16265127+2716219',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,246.713583,27.27264,0.077,NULL,56179765928,877808842,13715763,18.5),(137606,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137606,36.41,0.59,191,65764,70,NULL,NULL,'2MASX J16265145-6438317',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,246.7142917,-64.64211,0.817,NULL,44981984938,702843514,10981929,15.1),(137607,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137607,36.66,0.33,215,65765,70,NULL,NULL,'2MASX J16265342+2557529',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00021,NULL,'16.1g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,246.7225417,25.96467,0.085,NULL,56184243514,877878804,13716856,16.1),(137608,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137608,38.26,0.46,448,65766,70,NULL,NULL,'SDSS J162653.45+093202.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.5g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,246.72275,9.534,0.241,NULL,56755396316,886803067,13856297,18.5),(137609,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137609,37.73,0.33,351,65767,70,NULL,NULL,'2MASX J16265426+4850003',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000162,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,246.7260417,48.83333,0.005,NULL,59842387842,935037310,14609957,18.7),(137610,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137610,38.22,0.46,440,65768,70,NULL,NULL,'2MASX J16265588+2607169',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000169,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,246.732917,26.12133,0.085,NULL,56184099405,877876553,13716821,18),(137611,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137611,37.11,0.73,264,65769,70,NULL,NULL,'6dF J1626560-031513',NULL,'2014MNRAS.445.2677S',2014,1,0.23,NULL,'G',0.00015,NULL,'16.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,246.733416667,-3.2535,0.649,NULL,45509508569,711086071,11110719,16.2),(137612,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137612,38.21,0.46,438,65770,70,NULL,NULL,'2MASX J16265652+1746208',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,246.7357083,17.77253,0.169,NULL,56668094404,885438975,13834983,16.9),(137613,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137613,36.87,0.19,236,65771,70,NULL,NULL,'2MASX J16265692+1348099',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000191,NULL,'15.7g',0.48,NULL,NULL,NULL,NULL,NULL,1,246.737083,13.80272,0.177,NULL,56660351677,885317994,13833093,15.7),(137614,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137614,37.87,0.46,376,65772,70,NULL,NULL,'2MASX J16265717+1931332',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,246.738291667,19.52594,0.245,NULL,56701827248,885966050,13843219,17.8),(137615,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137615,35.12,0.47,106,65773,70,NULL,NULL,'2MASX J16265853-6635276',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.17',0.74,NULL,NULL,NULL,NULL,NULL,1,246.7435417,-66.59083,0.613,NULL,44992697847,703010903,10984545,15.17),(137616,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137616,35.2,0.25,110,65774,74.4,NULL,NULL,'2MASX J16265971+3919129',NULL,'2013AJ....146...86T',2013,1,0.78,NULL,'G',0.000053,NULL,'15.6g',0.21,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,246.749,39.32011,0,NULL,59853230304,935206723,14612605,15.6),(137617,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137617,35.76,0.06,142,65775,70,NULL,NULL,'2MASX J16270075+4048379',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00015,NULL,'15.7g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,246.753291667,40.81053,0.005,NULL,59856088550,935251383,14613302,15.7),(137618,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137618,37.47,0.27,312,65776,70,NULL,NULL,'2MASX J16270090+4829074',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,246.753667,48.48536,0,NULL,59842317973,935036218,14609940,17.2),(137619,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137619,34.26,0.33,71.1,65777,NULL,NULL,'Malmquist cor.','UGC 10388',NULL,'2009ApJS..182..474S',2009,1,1.55,NULL,'G',0.000033,NULL,'14.3g',0.49,'Sa',NULL,NULL,NULL,NULL,1,246.762375,16.38222,0.185,NULL,56673167098,885518235,13836222,14.3),(137620,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137620,34.37,0.4,75,65777,NULL,NULL,'mean','UGC 10388',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137621,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137621,34.47,0.3,78.4,65777,NULL,NULL,NULL,'UGC 10388',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137622,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137622,34.51,0.2,79.8,65777,74.4,NULL,NULL,'UGC 10388',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137623,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137623,34.66,0.47,85.5,65777,NULL,NULL,'H','UGC 10388',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137624,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137624,34.72,0.46,87.8,65777,NULL,NULL,'J','UGC 10388',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137625,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137625,34.8,0.45,91.1,65777,NULL,NULL,'K','UGC 10388',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137626,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137626,38.13,0.46,424,65778,70,NULL,NULL,'2MASX J16270333+1916472',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,246.764041667,19.27986,0.189,NULL,56701832459,885966132,13843220,17.8),(137627,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137627,35.16,0.23,108,65779,74.4,NULL,NULL,'CGCG 224-027',NULL,'2013AJ....146...86T',2013,1,0.84,NULL,'G',0.000022,NULL,'14.7g',0.64,'E',NULL,NULL,NULL,NULL,1,246.765083333,39.52736,0.005,NULL,59853093306,935204582,14612571,14.7),(137628,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137628,35.66,0.16,135,65779,70,NULL,NULL,'CGCG 224-027',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137629,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137629,35.76,0.06,142,65779,70,NULL,NULL,'CGCG 224-027',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137630,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137630,38.47,0.46,494,65780,70,NULL,NULL,'2MASX J16270449+0953324',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,246.768708333,9.89228,0.241,NULL,56742002625,886593791,13853027,17.8),(137631,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137631,36.87,0.19,236,65781,70,NULL,NULL,'2MASX J16270467+1351469',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000175,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,246.769625,13.86303,0.169,NULL,56660346714,885317917,13833092,16.9),(137632,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137632,38.11,0.46,419,65782,70,NULL,NULL,'SDSS J162706.07+161657.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,246.775333,16.28275,0.173,NULL,56673120950,885517514,13836211,18.3),(137633,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137633,36.87,0.19,236,65783,70,NULL,NULL,'2MASX J16270713+1356299',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000178,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,246.7797917,13.9415,0.169,NULL,56660430080,885319220,13833112,16.1),(137634,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137634,38.13,0.46,423,65784,70,NULL,NULL,'SDSS J162707.92+210711.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,246.783041667,21.11992,0.189,NULL,56645224270,885081629,13829400,18.5),(137635,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137635,37.47,0.27,312,65785,70,NULL,NULL,'SDSS J162709.15+483600.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000139,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,246.788167,48.60025,0,NULL,59842398307,935037473,14609960,18.6),(137636,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137636,35.61,0.25,132,65786,74.4,NULL,NULL,'2MASX J16271098+3918186',NULL,'2013AJ....146...86T',2013,1,0.47,NULL,'G',0.000067,NULL,'16.1g',0.29,'S0',NULL,NULL,NULL,NULL,1,246.7957083,39.30508,0,NULL,59853230741,935206730,14612605,16.1),(137637,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137637,35.84,0.46,147,65786,70,NULL,NULL,'2MASX J16271098+3918186',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137638,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137638,35.54,0.46,128,65787,70,NULL,NULL,'2MASX J16271202+4841105',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000198,NULL,'14.9g',0.69,'E0',NULL,NULL,NULL,NULL,1,246.800083333,48.68617,0,NULL,59842408276,935037629,14609962,14.9),(137639,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137639,37.13,0.46,267,65788,70,NULL,NULL,'2MASX J16271258+3046411',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000163,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,246.802375,30.77819,0.013,NULL,59789069853,934204216,14596940,16.9),(137640,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137640,37.64,0.46,338,65789,70,NULL,NULL,'2MASX J16271354+2407037',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,246.806375,24.11783,0.125,NULL,56649322124,885145658,13830400,17.7),(137641,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137641,36.87,0.19,236,65790,70,NULL,NULL,'2MASX J16271375+1418392',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,246.807333,14.31086,0.165,NULL,56658362920,885286920,13832608,16.9),(137642,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137642,34.8,0.2,91.2,65791,74.4,NULL,NULL,'UGC 10387',NULL,'2013AJ....146...86T',2013,1,0.86,NULL,'G',0.000033,NULL,'15.6g',0.49,'SBcd:',NULL,NULL,NULL,NULL,1,246.807375,12.97956,0.205,NULL,56875466919,888679170,13885612,15.6),(137643,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137643,36.87,0.19,236,65792,70,NULL,NULL,'CGCG 080-035',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000183,NULL,'14.9g',0.75,NULL,NULL,NULL,NULL,NULL,1,246.809916667,14.33953,0.165,NULL,56658494222,885288972,13832640,14.9),(137644,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137644,37.7,0.46,346,65793,70,NULL,NULL,'2MASX J16271441+1434562',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00017,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,246.8102083,14.58236,0.161,NULL,56658090090,885282657,13832541,17),(137645,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137645,35.65,0.46,135,65794,70,NULL,NULL,'2MASX J16271477+1343532',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000183,NULL,'15.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,246.811625,13.73164,0.177,NULL,56660389509,885318586,13833102,15.9),(137646,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137646,35.76,0.06,142,65795,70,NULL,NULL,'2MASX J16271784+3908357',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000087,NULL,'16.0g',0.35,'S',NULL,NULL,NULL,NULL,1,246.8242917,39.14311,0.005,NULL,59853237564,935206836,14612606,16),(137647,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137647,37.11,0.46,264,65796,70,NULL,NULL,'2MASX J16271813+2059572',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000158,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,246.825667,20.99919,0.189,NULL,56645369464,885083897,13829435,17),(137648,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137648,38.17,0.46,431,65797,70,NULL,NULL,'2MASX J16271846+0812462',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,246.826958333,8.21292,0.233,NULL,56747176481,886674632,13854291,17.9),(137649,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137649,35.42,0.2,121,65798,74.4,NULL,NULL,'CGCG 109-020',NULL,'2013AJ....146...86T',2013,1,0.85,NULL,'G',0.00008,NULL,'15.7g',0.29,'Sc','Isolated galaxy',NULL,NULL,NULL,1,246.8319583,15.99789,0.181,NULL,56673292004,885520187,13836252,15.7),(137650,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137650,35.28,0.49,114,65799,75,NULL,'IR','UGC 10386',NULL,'2011yCatp016004901K',2011,1,1.37,NULL,'G',0.000067,NULL,'15.33',0.18,'Sc',NULL,NULL,NULL,NULL,1,246.833,1.92086,0.237,NULL,56440622624,881884728,13779448,15.33),(137651,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137651,35.53,NULL,127,65799,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10386',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137652,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137652,35.55,NULL,129,65799,NULL,NULL,'Dipole + Quadrupole','UGC 10386',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137653,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137653,35.58,NULL,131,65799,NULL,NULL,'Dipole','UGC 10386',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137654,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137654,36.04,0.2,161,65800,74.4,NULL,NULL,'CGCG 138-013',NULL,'2013AJ....146...86T',2013,1,0.76,NULL,'G',0.000157,NULL,'15.3g',0.52,NULL,NULL,NULL,NULL,NULL,1,246.833208333,22.07206,0.129,NULL,56652982341,885202849,13831294,15.3),(137655,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137655,36.64,0.46,212,65801,70,NULL,NULL,'2MASX J16272040+4551140',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000149,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,246.834917,45.85394,0,NULL,59833761489,934902523,14607851,16.8),(137656,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137656,37.74,0.46,353,65802,70,NULL,NULL,'SDSS J162720.74+214322.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000135,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,246.836416667,21.72289,0.097,NULL,56653434825,885209919,13831404,18.2),(137657,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137657,37.58,0.46,328,65803,70,NULL,NULL,'2MASX J16272140+1512413',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000181,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,246.8392083,15.21139,0.149,NULL,56671917720,885498714,13835917,17),(137658,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137658,37.65,0.46,340,65804,70,NULL,NULL,'2MASX J16272170+1336323',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,246.840375,13.60911,0.177,NULL,56660331559,885317680,13833088,17.1),(137659,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137659,35.46,0.25,124,65805,74.4,NULL,NULL,'KUG 1625+392A',NULL,'2013AJ....146...86T',2013,1,0.83,NULL,'G',0.00007,NULL,'14.4g',0.67,'Sa','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,246.842083,39.10964,0.005,NULL,59853235031,935206797,14612606,14.4),(137660,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137660,35.66,0.16,135,65805,70,NULL,NULL,'KUG 1625+392A',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137661,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137661,35.78,0.05,144,65805,NULL,NULL,NULL,'KUG 1625+392A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137662,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137662,36.93,0.68,244,65806,70,NULL,NULL,'2MASX J16272295-6424497',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,246.845708333,-64.41386,0.841,NULL,44981897466,702842147,10981908,15.7),(137663,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137663,35.81,0.27,145,65807,70,NULL,NULL,'NGC 6159',NULL,'2015arXiv151105856S',2015,1,1.08,NULL,'G',0.000153,NULL,'14.3g',0.81,'S0-:           Sy2',NULL,NULL,NULL,'Sy 2',1,246.855125,42.67972,0.009,NULL,59861063973,935329124,14614517,14.3),(137664,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137664,34.44,NULL,77.2,65808,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2036',NULL,'2010Ap&SS.325..163P',2010,1,0.89,NULL,'G',0.00017,NULL,'16.6g',0.15,'Sd(f)',NULL,NULL,NULL,NULL,1,246.883917,48.71531,0,NULL,59842413607,935037712,14609964,16.6),(137665,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137665,34.46,NULL,78,65808,NULL,NULL,'Dipole + Quadrupole','FGC 2036',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137666,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137666,34.47,NULL,78.3,65808,NULL,NULL,'Dipole','FGC 2036',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137667,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137667,34.53,NULL,80.6,65808,NULL,NULL,NULL,'FGC 2036',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137668,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137668,34.88,0.25,94.6,65809,74.4,NULL,NULL,'2MASX J16273232+3934148',NULL,'2013AJ....146...86T',2013,1,0.32,NULL,'G',0.000063,NULL,'15.83',0.32,'S0',NULL,NULL,NULL,NULL,1,246.884541667,39.57067,0.005,NULL,59856539441,935258428,14613412,15.83),(137669,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137669,35.76,0.06,142,65809,70,NULL,NULL,'2MASX J16273232+3934148',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137670,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137670,38.29,0.46,456,65810,70,NULL,NULL,'2MASX J16273291+2055254',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,246.887083,20.92358,0.197,NULL,56645341204,885083456,13829429,18.3),(137671,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137671,36.87,0.19,236,65811,70,NULL,NULL,'2MASX J16273302+1356033',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,246.8875417,13.93422,0.169,NULL,56658266581,885285415,13832584,17.1),(137672,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137672,38.67,0.46,541,65812,70,NULL,NULL,'SDSS J162734.13+135111.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,246.89225,13.85331,0.169,NULL,56658278681,885285604,13832587,18.3),(137673,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137673,37.28,0.46,286,65813,70,NULL,NULL,'2MASX J16273447+4821230',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000126,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,246.8937917,48.35628,0,NULL,59843191821,935049872,14610154,17.6),(137674,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137674,37.56,0.46,325,65814,70,NULL,NULL,'2MASX J16273460+3325139',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000145,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,246.8942917,33.42047,0.045,NULL,59791009918,934234529,14597414,17.1),(137675,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137675,37.01,0.46,252,65815,70,NULL,NULL,'2MASX J16273481+1313153',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,246.895125,13.22097,0.197,NULL,56875321862,888676904,13885576,18.1),(137676,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137676,35.57,0.09,130,65816,NULL,NULL,NULL,'2MASX J16273674+3916098',NULL,'2009ApJS..182..474S',2009,1,0.71,NULL,'G',0.000081,NULL,'16.0g',0.36,'SBc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,246.902875,39.26964,0,NULL,59853227074,935206673,14612604,16),(137677,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137677,35.81,0.27,145,65817,70,NULL,NULL,'CGCG 224-033',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000163,NULL,'15.0g',0.56,'BrClG',NULL,NULL,NULL,NULL,1,246.907083,42.63822,0,NULL,59861062055,935329094,14614517,15),(137678,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137678,35.88,0.4,150,65818,75,NULL,'Edat, raw','NGC 6158',NULL,'1997ApJS..109..333W',1997,1,0.3,NULL,'G',0.000022,NULL,'14.68',0.25,'E/S0','Group member',NULL,NULL,NULL,1,246.920375,39.383,0,NULL,59853225142,935206642,14612603,14.68),(137679,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137679,35.9,0.4,152,65818,75,NULL,'Edat, cor','NGC 6158',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137680,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137680,35.02,0.22,101,65818,74.4,NULL,NULL,'NGC 6158',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137681,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137681,35.66,0.16,135,65818,70,NULL,NULL,'NGC 6158',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137682,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137682,35.56,0.4,130,65818,NULL,NULL,'mean','NGC 6158',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137683,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137683,35.83,0.45,147,65818,NULL,NULL,'K','NGC 6158',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137684,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137684,34.3,0.4,72.4,65819,75,NULL,'Edat, raw','NGC 6160',NULL,'1997ApJS..109..333W',1997,1,1.58,NULL,'G',0.00007,NULL,'14.0g',0.83,'cD;E','Group member, 2nd ranked galaxy',NULL,NULL,NULL,1,246.921375,40.927,0.005,NULL,59856077816,935251215,14613300,14),(137685,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137685,34.63,0.4,84.2,65819,75,NULL,'Edat, cor','NGC 6160',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137686,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137686,35.23,0.22,111,65819,74.4,NULL,NULL,'NGC 6160',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137687,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137687,35.29,0.22,114,65819,70,NULL,NULL,'NGC 6160',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137688,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137688,35.76,0.06,142,65819,70,NULL,NULL,'NGC 6160',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137689,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137689,35.04,0.45,102,65819,NULL,NULL,'K','NGC 6160',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137690,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137690,35.65,0.4,135,65819,NULL,NULL,'mean','NGC 6160',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137691,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137691,35.76,0.06,142,65820,70,NULL,NULL,'2MASX J16274399+3932348',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000067,NULL,'15.87',0.2,'S0',NULL,NULL,NULL,NULL,1,246.933416667,39.543,0,NULL,59856535653,935258369,14613412,15.87),(137692,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137692,37.2,0.46,276,65821,70,NULL,NULL,'2MASX J16274458+3031339',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000174,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,246.9357917,30.52617,0.049,NULL,59786142353,934158474,14596226,17.1),(137693,'CMD','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'N',137693,20,NULL,0.1,65822,NULL,NULL,NULL,'Her X',NULL,'2009AJ....137..450W',2009,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137694,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137694,35.57,0.46,130,65823,70,NULL,NULL,'2MASX J16274621+2003145',NULL,'2015arXiv151105856S',2015,1,0.35,'RC3 has V = 3720 +- 60 km/s.','G',0.000158,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,246.94275,20.05403,0.233,NULL,56701727147,885964486,13843195,17.1),(137695,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137695,37.29,0.46,287,65824,70,NULL,NULL,'SDSS J162749.83+364921.4',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,246.957625,36.82261,0.013,NULL,59748861387,933575959,14587124,17.7),(137696,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137696,34.53,0.2,80.5,65825,74.4,NULL,NULL,'UGC 10394',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.0001,NULL,'14.70',0.5,'SA(s)d:',NULL,NULL,NULL,NULL,1,246.959583,-1.76364,0.445,NULL,45502427770,710975433,11108991,14.7),(137697,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137697,34.6,0.48,83.3,65825,NULL,NULL,NULL,'UGC 10394',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137698,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137698,34.68,0.46,86.2,65825,NULL,NULL,'Malmquist cor.','UGC 10394',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137699,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137699,35.76,0.06,142,65826,70,NULL,NULL,'2MASX J16275030+4056149',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00007,NULL,'15.6g',0.34,'S0',NULL,NULL,NULL,NULL,1,246.959625,40.93747,0,NULL,59855896583,935248384,14613256,15.6),(137700,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137700,35.76,0.06,142,65827,70,NULL,NULL,'2MASX J16275494+4036219',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000047,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,246.97875,40.60606,0,NULL,59856055178,935250862,14613294,16.3),(137701,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137701,34.75,0.6,89.2,65828,70,NULL,NULL,'2MASX J16275487-6454388',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.84',0.36,NULL,NULL,NULL,NULL,NULL,1,246.979375,-64.91047,0.741,NULL,44993474375,703023037,10984734,16.84),(137702,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137702,35.88,0.4,150,65829,75,NULL,'Edat, raw','CGCG 224-034 NED02',NULL,'1997ApJS..109..333W',1997,1,0.91,NULL,'G',0.000067,NULL,'14.7g',0.63,'E',NULL,NULL,NULL,NULL,1,246.980167,39.25883,0,NULL,59853226353,935206661,14612604,14.7),(137703,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137703,35.9,0.4,152,65829,75,NULL,'Edat, cor','CGCG 224-034 NED02',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137704,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137704,35.66,0.16,135,65829,70,NULL,NULL,'CGCG 224-034 NED02',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137705,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137705,35.76,0.06,142,65829,70,NULL,NULL,'CGCG 224-034 NED02',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137706,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137706,36.91,0.46,241,65830,70,NULL,NULL,'2MASX J16275527+4356540',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000099,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,246.980291667,43.94828,0,NULL,59859954865,935311794,14614246,16.3),(137707,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137707,35.88,0.4,150,65831,75,NULL,'Edat, raw','MCG +07-34-044',NULL,'1997ApJS..109..333W',1997,1,0.48,NULL,'G',0.000067,NULL,'15.5g',0.47,'S?',NULL,NULL,NULL,NULL,1,246.983375,39.28139,0,NULL,59853218537,935206539,14612602,15.5),(137708,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137708,35.9,0.4,152,65831,75,NULL,'Edat, cor','MCG +07-34-044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137709,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137709,35.76,0.06,142,65831,70,NULL,NULL,'MCG +07-34-044',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137710,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137710,35.07,0.25,103,65832,74.4,NULL,NULL,'2MASX J16275604+3934059',NULL,'2013AJ....146...86T',2013,1,0.64,NULL,'G',0.00006,NULL,'15.5g',0.42,'E',NULL,NULL,NULL,NULL,1,246.983333,39.56825,0,NULL,59856601370,935259396,14613428,15.5),(137711,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137711,35.76,0.06,142,65832,70,NULL,NULL,'2MASX J16275604+3934059',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137712,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137712,35.48,0.23,125,65833,74.4,NULL,NULL,'CGCG 224-034',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'GPair',0.00007,NULL,NULL,NULL,'E/S0',NULL,NULL,NULL,NULL,1,246.985,39.25583,0,NULL,59853226331,935206661,14612604,NULL),(137713,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137713,35.85,0.25,148,65834,74.4,NULL,NULL,'CGCG 224-034 NED01',NULL,'2013AJ....146...86T',2013,1,0.52,NULL,'G',0.000067,NULL,'15.6g',0.3,'S0',NULL,NULL,NULL,NULL,1,246.989666667,39.25286,0,NULL,59853226789,935206668,14612604,15.6),(137714,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137714,35.4,0.25,120,65835,74.4,NULL,NULL,'CGCG 224-034 NED01',NULL,'2013AJ....146...86T',2013,1,0.52,NULL,'G',0.000067,NULL,'15.6g',0.3,'S0',NULL,NULL,NULL,NULL,1,246.989666667,39.25286,0,NULL,59853226789,935206668,14612604,15.6),(137715,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137715,37.72,0.46,349,65836,70,NULL,NULL,'2MASX J16275786+2657588',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,246.9912917,26.9665,0.073,NULL,56184343911,877880373,13716880,17.3),(137716,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137716,35.43,0.25,122,65837,74.4,NULL,NULL,'GIN 581',NULL,'2013AJ....146...86T',2013,1,0.54,NULL,'G',0.000063,NULL,'15.4g',0.46,'S0/a',NULL,NULL,NULL,NULL,1,246.9945,39.60394,0,NULL,59856602942,935259420,14613428,15.4),(137717,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137717,35.66,0.16,135,65837,70,NULL,NULL,'GIN 581',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137718,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137718,35.76,0.06,142,65837,70,NULL,NULL,'GIN 581',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137719,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137719,35.73,0.1,140,65838,NULL,NULL,NULL,'2MASX J16275925+4029499',NULL,'2009ApJS..182..474S',2009,1,1.01,NULL,'G',0.000093,NULL,'15.3g',0.25,'Sab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,246.99675,40.49728,0,NULL,59856008935,935250139,14613283,15.3),(137720,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137720,36.89,0.46,239,65839,70,NULL,NULL,'2MASX J16280147+1932450',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.00625,19.54592,0.225,NULL,56701859171,885966549,13843227,17.8),(137721,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137721,37.75,0.33,355,65840,70,NULL,NULL,'2MASX J16280239+1149167',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,247.0099583,11.82136,0.241,NULL,56744010614,886625165,13853518,17.8),(137722,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137722,37.36,0.46,297,65841,70,NULL,NULL,'2MASX J16280256+2256330',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000178,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,247.010625,22.94253,0.141,NULL,56649628516,885150445,13830475,17.1),(137723,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137723,37.54,0.46,322,65842,70,NULL,NULL,'2MASX J16280310+4355459',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,'FoF','17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,247.012875,43.92936,0,NULL,59859959303,935311864,14614247,17.3),(137724,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137724,38.32,0.46,461,65843,70,NULL,NULL,'2MASX J16280323+2115260',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000179,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,247.0135,21.25714,0.173,NULL,56652508989,885195452,13831178,17.9),(137725,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137725,37.52,0.46,320,65844,70,NULL,NULL,'2MASX J16280505+3417520',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.020917,34.29781,0.017,NULL,59779578667,934055916,14594623,17.6),(137726,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137726,34.36,0.2,74.5,65845,74.4,NULL,NULL,'CGCG 138-015',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00006,NULL,'15.5g',0.34,'Sa',NULL,NULL,NULL,NULL,1,247.021667,21.65583,0.129,NULL,56652590161,885196721,13831198,15.5),(137727,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137727,37.75,0.33,355,65846,70,NULL,NULL,'2MASX J16280715+1146487',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.029875,11.78006,0.241,NULL,56744011232,886625175,13853518,17.5),(137728,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137728,35.76,0.06,142,65847,70,NULL,NULL,'SDSS J162807.73+393123.2',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00019,NULL,'16.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,247.0322083,39.52314,0,NULL,59856424563,935256633,14613384,16.4),(137729,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137729,36.52,0.25,201,65848,74.4,NULL,NULL,'2MASX J16280771+3931229',NULL,'2013AJ....146...86T',2013,1,0.2,NULL,'G',0.000087,NULL,'16.80',0.14,'S0',NULL,NULL,NULL,NULL,1,247.0324583,39.52325,0,NULL,59856424563,935256633,14613384,16.8),(137730,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137730,36.92,0.46,242,65849,70,NULL,NULL,'2MASX J16280801+4216599',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00009,NULL,'15.6g',0.51,'E0',NULL,NULL,NULL,NULL,1,247.033417,42.28322,0,NULL,59860668149,935322939,14614420,15.6),(137731,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137731,34.08,0.4,65.4,65850,NULL,NULL,'mean','ESO 452- G 003',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000023,NULL,'14.4R',0.3,'S...',NULL,NULL,NULL,NULL,1,247.036333,-29.09675,1.057,NULL,46250261199,722660331,11291567,14.4),(137732,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137732,34.12,0.47,66.8,65850,NULL,NULL,'H','ESO 452- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137733,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137733,34.16,0.46,68,65850,NULL,NULL,'J','ESO 452- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137734,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137734,34.25,0.45,70.9,65850,NULL,NULL,'K','ESO 452- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137735,'BCG','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137735,35.5,0.35,122,65851,60,NULL,NULL,'ABELL 2197',0.0303,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,247.043583,40.90719,0,NULL,59854129412,935220772,14612824,NULL),(137736,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137736,37.08,0.46,261,65852,70,NULL,NULL,'2MASX J16281067+1706484',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,247.0445417,17.11336,0.205,NULL,56669691898,885463935,13835373,16.3),(137737,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137737,37.67,0.46,341,65853,70,NULL,NULL,'2MASX J16281074+3933389',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.0001,NULL,'16.83',0.22,NULL,NULL,NULL,NULL,NULL,1,247.044625,39.56075,0,NULL,59856423615,935256618,14613384,16.83),(137738,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137738,38.41,0.46,481,65854,70,NULL,NULL,'2MASX J16281104+1235434',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,247.046,12.59528,0.209,NULL,56875098147,888673408,13885522,17.4),(137739,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137739,37.05,0.46,257,65855,70,NULL,NULL,'2MASX J16281218+1856291',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,247.0507083,18.94133,0.185,NULL,56700037733,885938089,13842782,17.7),(137740,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137740,35.56,0.04,130,65856,NULL,NULL,NULL,'CGCG 224-036',NULL,'2009ApJS..182..474S',2009,1,0.76,NULL,'G',0.000083,NULL,'15.0g',0.69,'SB','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,247.058375,40.31386,0,NULL,59856459785,935257184,14613393,15),(137741,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137741,35.63,0.25,134,65857,74.4,NULL,NULL,'2MASX J16281419+3932439',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000067,NULL,'16.8g',0.21,'E',NULL,NULL,NULL,NULL,1,247.059333,39.54558,0,NULL,59856423985,935256624,14613384,16.8),(137742,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137742,37.32,0.46,291,65858,70,NULL,NULL,'2MASX J16281642+0739017',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.0685417,7.6505,0.241,NULL,56748680714,886698136,13854658,17.6),(137743,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137743,35.76,0.06,142,65859,70,NULL,NULL,'2MASX J16281766+4058009',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000083,NULL,'15.7g',0.43,'S0/a','Brightest group member',NULL,NULL,NULL,1,247.0735417,40.96703,0,NULL,59854260947,935222827,14612856,15.7),(137744,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137744,34.42,0.47,76.4,65860,NULL,NULL,'H','UGC 10447',NULL,'2007A&A...465...71T',2007,1,2,NULL,'G',0.000203,NULL,'15.20',0.5,'Sb',NULL,NULL,NULL,NULL,1,247.079417,80.35464,0.209,NULL,57141469914,892835467,13950554,15.2),(137745,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137745,34.52,0.45,80.1,65860,NULL,NULL,'K','UGC 10447',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137746,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137746,34.68,0.46,86.4,65860,NULL,NULL,'J','UGC 10447',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137747,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137747,34.8,0.4,91.3,65860,NULL,NULL,'mean','UGC 10447',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137748,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137748,35.14,0.25,107,65861,74.4,NULL,NULL,'2MASX J16281973+3957329',NULL,'2013AJ....146...86T',2013,1,0.39,NULL,'G',0.000067,NULL,'16.0g',0.31,'E/S0',NULL,NULL,NULL,NULL,1,247.082333333,39.95914,0.005,NULL,59856621700,935259714,14613433,16),(137749,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137749,35.76,0.06,142,65861,70,NULL,NULL,'2MASX J16281973+3957329',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137750,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137750,37.76,0.33,356,65862,70,NULL,NULL,'2MASX J16282024+2545562',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000187,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,247.08425,25.76556,0.085,NULL,56185937666,877905276,13717269,16.6),(137751,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137751,37.98,0.33,395,65863,70,NULL,NULL,'2MASX J16282092+2207251',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000153,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,247.087125,22.12358,0.125,NULL,56652883767,885201308,13831270,18.1),(137752,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137752,37.94,0.46,387,65864,70,NULL,NULL,'2MASX J16282141+4313461',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000151,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,247.089125,43.22958,0,NULL,59860452720,935319573,14614368,17.5),(137753,'BCG','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137753,35.5,0.35,122,65865,60,NULL,'ABELL 2197, BCG','GIN 575',0.0303,'1980ApJ...241..486H',1980,1,0.63,NULL,'G',0.000133,NULL,'15.7g',0.37,'S',NULL,NULL,NULL,NULL,1,247.089833,40.90681,0,NULL,59854259391,935222802,14612856,15.7),(137754,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137754,35.11,0.25,105,65865,74.4,NULL,NULL,'GIN 575',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137755,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137755,35.29,0.22,114,65865,70,NULL,NULL,'GIN 575',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137756,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137756,37.32,0.46,291,65866,70,NULL,NULL,'2MASX J16282190+1707194',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.091333,17.12208,0.205,NULL,56669672331,885463630,13835369,17.9),(137757,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137757,37.98,0.33,395,65867,70,NULL,NULL,'2MASX J16282251+2208221',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,247.093875,22.13958,0.125,NULL,56652883872,885201310,13831270,17.3),(137758,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137758,37.58,0.46,329,65868,70,NULL,NULL,'2MASX J16282306+4655341',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00017,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,247.0960417,46.92628,0.017,NULL,59840714664,935011166,14609549,16.9),(137759,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137759,37.76,0.33,356,65869,70,NULL,NULL,'SDSS J162823.12+254445.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,247.096375,25.74597,0.085,NULL,56185935410,877905240,13717269,18.6),(137760,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137760,35.88,0.4,150,65870,75,NULL,'Edat, raw','NGC 6166C',NULL,'1997ApJS..109..333W',1997,1,0.67,NULL,'G',0.000033,NULL,'15.1g',0.62,'E',NULL,NULL,NULL,NULL,1,247.097125,39.57031,0,NULL,59856436355,935256818,14613387,15.1),(137761,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137761,35.9,0.4,152,65870,75,NULL,'Edat, cor','NGC 6166C',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137762,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137762,35.5,0.22,126,65870,74.4,NULL,NULL,'NGC 6166C',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137763,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137763,35.66,0.16,135,65870,70,NULL,NULL,'NGC 6166C',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137764,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137764,35.76,0.06,142,65870,70,NULL,NULL,'NGC 6166C',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137765,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137765,36.38,0.25,189,65871,74.4,NULL,NULL,'MCG +07-34-049',NULL,'2013AJ....146...86T',2013,1,0.25,NULL,'G',0.000067,NULL,'15.74',0.15,'E/S0',NULL,NULL,NULL,NULL,1,247.0982917,39.60539,0,NULL,59856430485,935256726,14613386,15.74),(137766,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137766,35.23,0.25,111,65872,74.4,NULL,NULL,'2MASX J16282464+3944278',NULL,'2013AJ....146...86T',2013,1,0.53,NULL,'G',0.000067,NULL,'15.8g',0.25,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,247.1027917,39.74106,0,NULL,59856634680,935259916,14613436,15.8),(137767,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137767,35.76,0.06,142,65873,70,NULL,NULL,'2MASX J16282511+4051298',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00008,NULL,'15.4g',0.33,'S0',NULL,NULL,NULL,NULL,1,247.1047083,40.85822,0,NULL,59854141402,935220959,14612827,15.4),(137768,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137768,36.64,0.33,213,65874,70,NULL,NULL,'2MASX J16282525+1140561',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,247.105125,11.68239,0.241,NULL,56743996425,886624944,13853514,17.2),(137769,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137769,38.22,0.46,441,65875,70,NULL,NULL,'2MASX J16282657+4922151',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,247.110583333,49.37094,0,NULL,59829583981,934837249,14606832,18.2),(137770,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137770,37.38,0.46,299,65876,70,NULL,NULL,'2MASX J16282696+2242317',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,247.112458333,22.70889,0.141,NULL,56651417765,885178402,13830912,17.7),(137771,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137771,35.1,0.25,105,65877,74.4,NULL,NULL,'CGCG 224-037 NED02',NULL,'2013AJ....146...86T',2013,1,0.61,NULL,'G',0.000083,NULL,'15.2g',0.5,'S0',NULL,NULL,NULL,NULL,1,247.114833,41.161,0,NULL,59854081801,935220028,14612812,15.2),(137772,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137772,35.29,0.22,114,65877,70,NULL,NULL,'CGCG 224-037 NED02',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137773,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137773,36.57,0.46,206,65878,70,NULL,NULL,'2MASX J16282976+1310004',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000175,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,247.123916667,13.16689,0.177,NULL,56878277053,888723078,13886298,16.2),(137774,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137774,36.19,0.25,173,65879,74.4,NULL,NULL,'NGC 6166A NED01',NULL,'2013AJ....146...86T',2013,1,0.48,NULL,'G',0.000067,NULL,'15.30',0.19,'S0',NULL,NULL,NULL,NULL,1,247.1294583,39.52111,0,NULL,59856435677,935256807,14613387,15.3),(137775,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137775,36.19,0.25,173,65880,74.4,NULL,NULL,'2MASX J16283115+3943409',NULL,'2013AJ....146...86T',2013,1,0.66,NULL,'G',0.000067,NULL,'16.2g',0.23,'S0',NULL,NULL,NULL,NULL,1,247.129917,39.72797,0,NULL,59856633950,935259905,14613436,16.2),(137776,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137776,38.27,0.46,451,65881,70,NULL,NULL,'2MASX J16283228+0800531',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,247.134625,8.01486,0.269,NULL,56748825031,886700391,13854693,18.2),(137777,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137777,35.88,0.4,150,65882,75,NULL,'Edat, raw','MCG +07-34-054',NULL,'1997ApJS..109..333W',1997,1,0.31,NULL,'G',0.000053,NULL,'16.6g',0.19,'E',NULL,NULL,NULL,NULL,1,247.141458333,39.54889,0,NULL,59856433811,935256778,14613387,16.6),(137778,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137778,35.9,0.4,152,65882,75,NULL,'Edat, cor','MCG +07-34-054',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137779,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137779,35.6,0.25,132,65882,74.4,NULL,NULL,'MCG +07-34-054',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137780,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137780,35.76,0.06,142,65883,70,NULL,NULL,'2MASX J16283508+3929349',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000177,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,247.146166667,39.49303,0,NULL,59856427818,935256684,14613385,17),(137781,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137781,35.88,0.4,150,65884,75,NULL,'Edat, raw','PGC 058257',NULL,'1997ApJS..109..333W',1997,1,0.28,NULL,'G',0.000143,NULL,'17.56',0.21,'E',NULL,NULL,NULL,NULL,1,247.149375,39.55358,0,NULL,59856433863,935256779,14613387,17.56),(137782,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137782,35.9,0.4,152,65884,75,NULL,'Edat, cor','PGC 058257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137783,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137783,35.84,0.25,147,65884,74.4,NULL,NULL,'PGC 058257',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137784,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137784,35.88,0.4,150,65885,75,NULL,'Edat, raw','MCG +07-34-055',NULL,'1997ApJS..109..333W',1997,1,0.33,NULL,'G',0.00011,NULL,'15.9g',0.31,'E',NULL,NULL,NULL,NULL,1,247.15025,39.53375,0,NULL,59856426249,935256660,14613385,15.9),(137785,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137785,35.9,0.4,152,65885,75,NULL,'Edat, cor','MCG +07-34-055',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137786,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137786,36.17,0.23,171,65885,74.4,NULL,NULL,'MCG +07-34-055',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137787,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137787,37.12,0.46,266,65886,70,NULL,NULL,'2MASX J16283615+4041079',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00008,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,247.150708333,40.6855,0,NULL,59854151529,935221117,14612829,16.5),(137788,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137788,36.52,0.33,201,65887,70,NULL,NULL,'2MASX J16283693+1637124',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000093,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,247.1540417,16.62011,0.225,NULL,56669572347,885462067,13835344,17.2),(137789,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137789,36.72,0.46,221,65888,70,NULL,NULL,'2MASX J16283713+1625144',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,247.154833,16.42072,0.205,NULL,56673186181,885518534,13836227,17.4),(137790,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137790,35.09,0.25,104,65889,74.4,NULL,NULL,'ARK 505',NULL,'2013AJ....146...86T',2013,1,0.57,NULL,'G',0.000043,NULL,'15.4g',0.51,'E/S0',NULL,NULL,NULL,NULL,1,247.158,41.16394,0,NULL,59854070381,935219849,14612810,15.4),(137791,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137791,35.29,0.22,114,65889,70,NULL,NULL,'ARK 505',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137792,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137792,35.76,0.06,142,65889,70,NULL,NULL,'ARK 505',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137793,'BCG','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137793,35.42,0.35,118,65890,60,NULL,NULL,'ABELL 2199',0.0312,'1980ApJ...241..486H',1980,1,NULL,'Position for NGC 6166 adopted for ABELL 2199.','GClstr',0.00023,NULL,NULL,NULL,'I      [BM]',NULL,NULL,NULL,NULL,1,247.158333,39.54861,0,NULL,59856433771,935256777,14613387,NULL),(137794,'BCG','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137794,35.42,0.35,118,65891,60,NULL,'ABELL 2199, BCG','NGC 6166',0.0312,'1980ApJ...241..486H',1980,1,1.9,NULL,'G',0.00003,NULL,'12.78',1.4,'cD;E;NLRG      LEG','Possible field galaxy',NULL,'FR I','USS',1,247.160333333,39.55156,0,NULL,59856433789,935256777,14613387,12.78),(137795,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137795,35.5,0.12,126,65891,72,NULL,'ABELL 2199, 13 galaxies','NGC 6166',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137796,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137796,35.57,0.08,130,65891,70,NULL,'ABELL 2199','NGC 6166',NULL,'1997MNRAS.287..899L',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137797,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137797,35.88,0.4,150,65891,75,NULL,'Edat, raw','NGC 6166',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137798,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137798,35.9,0.4,152,65891,75,NULL,'Edat, cor','NGC 6166',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137799,'Faber-Jackson','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137799,33.96,0.34,61.9,65891,95,NULL,'Weighted Mean','NGC 6166',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137800,'Faber-Jackson','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137800,34.12,0.55,66.7,65891,95,NULL,'de Vaucouleurs','NGC 6166',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137801,'Faber-Jackson','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137801,34.2,0.46,69.2,65891,95,NULL,'Michard 1979a','NGC 6166',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137802,'Faber-Jackson','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137802,34.71,0.63,87.5,65891,95,NULL,'Michard 1979b, c','NGC 6166',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137803,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137803,35.47,0.07,124,65891,75,NULL,'ABELL 2199, 36 galaxies','NGC 6166',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137804,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137804,35.47,0.07,124,65891,75,NULL,'ABELL 2199 Cluster, 36 galaxies','NGC 6166',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137805,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137805,35.48,0.23,125,65891,74.4,NULL,NULL,'NGC 6166',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137806,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137806,35.65,0.07,135,65891,75,NULL,'ABELL 2199 Cluster, 35 galaxies','NGC 6166',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137807,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137807,35.66,0.16,135,65891,70,NULL,NULL,'NGC 6166',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137808,'Tertiary','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137808,34.77,0.5,89.9,65891,95,NULL,NULL,'NGC 6166',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137809,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137809,35.12,0.45,106,65891,NULL,NULL,'K','NGC 6166',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137810,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137810,35.55,0.4,129,65891,NULL,NULL,'mean','NGC 6166',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137811,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137811,35.76,0.06,142,65892,70,NULL,NULL,'NGC 6166 NED03',NULL,'2015arXiv151105856S',2015,1,1.23,'Designation as \\\"Component B\\\" from 1961AJ.....66..558M.','G',0.00008,NULL,'14.5',0.84,'E0','Triplet member at center of cluster',NULL,NULL,NULL,1,247.163083,39.55283,0,NULL,59856433786,935256777,14613387,14.5),(137812,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137812,35.76,0.06,142,65893,70,NULL,NULL,'CGCG 224-042',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.000077,NULL,'15.2g',0.39,'E','Group member',NULL,NULL,NULL,1,247.164916667,41.11106,0,NULL,59854266392,935222912,14612858,15.2),(137813,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137813,36.83,0.46,233,65894,70,NULL,NULL,'2MASX J16284057+3105347',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000187,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,247.16925,31.09292,0.005,NULL,59789141291,934205332,14596958,16.3),(137814,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137814,37.8,0.46,363,65895,70,NULL,NULL,'2MASX J16284090+2329398',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,247.1705,23.4945,0.129,NULL,56650298975,885160921,13830639,17.3),(137815,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137815,37.06,0.46,258,65896,70,NULL,NULL,'2MASX J16284165+1509597',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,247.173625,15.16664,0.141,NULL,56671970570,885499540,13835930,17.2),(137816,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137816,35.1,0.25,105,65897,74.4,NULL,NULL,'CGCG 224-043',NULL,'2013AJ....146...86T',2013,1,0.63,NULL,'G',0.000067,NULL,'15.1g',0.51,'E','Group member',NULL,NULL,NULL,1,247.173583,41.137,0,NULL,59854069978,935219843,14612810,15.1),(137817,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137817,35.29,0.22,114,65897,70,NULL,NULL,'CGCG 224-043',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137818,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137818,35.76,0.06,142,65897,70,NULL,NULL,'CGCG 224-043',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137819,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137819,37.55,0.33,324,65898,70,NULL,NULL,'2MASX J16284192+2446279',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000185,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,247.174625,24.77439,0.097,NULL,56184923383,877889427,13717022,16.8),(137820,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137820,36.43,0.33,193,65899,70,NULL,NULL,'2MASX J16284203+1537467',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000172,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,247.175167,15.62969,0.173,NULL,56672052085,885500813,13835950,16.2),(137821,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137821,36.62,0.46,211,65900,70,NULL,NULL,'2MASX J16284271+1452047',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000161,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,247.177833,14.86808,0.153,NULL,56658138223,885283409,13832553,17),(137822,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137822,36.3,0.19,182,65901,70,NULL,NULL,'CGCG 138-018 NED01',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000179,NULL,'16.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,247.180167,25.49747,0.085,NULL,56185468718,877897948,13717155,16.4),(137823,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137823,37.6,0.46,332,65902,70,NULL,NULL,'SDSS J162844.44+312844.2',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,247.185166667,31.47894,0.005,NULL,59789565324,934211958,14597061,17.1),(137824,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137824,35.33,0.25,116,65903,74.4,NULL,NULL,'MCG +07-34-065',NULL,'2013AJ....146...86T',2013,1,0.39,NULL,'G',0.00007,NULL,'16.6g',0.21,'S0',NULL,NULL,NULL,NULL,1,247.185375,39.48458,0,NULL,59856428406,935256693,14613385,16.6),(137825,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137825,35.88,0.4,150,65904,75,NULL,'Edat, raw','I Zw 153 NOTES01',NULL,'1997ApJS..109..333W',1997,1,0.35,NULL,'G',0.000067,NULL,'15.9g',0.3,'E',NULL,NULL,NULL,NULL,1,247.18525,39.5155,0,NULL,59856428875,935256701,14613385,15.9),(137826,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137826,35.9,0.4,152,65904,75,NULL,'Edat, cor','I Zw 153 NOTES01',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137827,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137827,35.76,0.06,142,65904,70,NULL,NULL,'I Zw 153 NOTES01',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137828,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137828,36.41,0.25,191,65904,74.4,NULL,NULL,'I Zw 153 NOTES01',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137829,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137829,36.05,0.25,162,65905,74.4,NULL,NULL,'MCG +07-34-068',NULL,'2013AJ....146...86T',2013,1,0.15,NULL,'G',NULL,NULL,'16.5',0.15,NULL,NULL,NULL,NULL,NULL,1,247.1855,39.63892,0,NULL,59856438822,935256856,14613388,16.5),(137830,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137830,35.76,0.06,142,65906,70,NULL,NULL,'MCG +07-34-067',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000067,NULL,'15.6g',0.41,'S0',NULL,NULL,NULL,NULL,1,247.1877917,39.43708,0,NULL,59853005579,935203212,14612550,15.6),(137831,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137831,36.03,0.25,161,65906,74.4,NULL,NULL,'MCG +07-34-067',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137832,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137832,35.88,0.4,150,65907,75,NULL,'Edat, raw','I Zw 153 NOTES02',NULL,'1997ApJS..109..333W',1997,1,0.3,NULL,'G',0.000057,NULL,'16.3g',0.27,'E',NULL,NULL,NULL,NULL,1,247.1902083,39.52767,0,NULL,59856426808,935256668,14613385,16.3),(137833,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137833,35.9,0.4,152,65907,75,NULL,'Edat, cor','I Zw 153 NOTES02',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137834,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137834,35.76,0.06,142,65907,70,NULL,NULL,'I Zw 153 NOTES02',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137835,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137835,35.79,0.23,144,65907,74.4,NULL,NULL,'I Zw 153 NOTES02',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137836,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137836,35.76,0.06,142,65908,70,NULL,NULL,'MCG +07-34-071',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000057,NULL,'16.4g',0.27,'E',NULL,NULL,NULL,NULL,1,247.191333333,39.60978,0,NULL,59856439118,935256861,14613388,16.4),(137837,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137837,36.3,0.19,182,65909,70,NULL,NULL,'CGCG 138-018 NED02',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000113,NULL,'15.2g',0.63,NULL,NULL,NULL,NULL,NULL,1,247.1922083,25.49469,0.085,NULL,56185468810,877897950,13717155,15.2),(137838,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137838,35.49,0.46,126,65910,70,NULL,NULL,'2MASX J16284853+0850267',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,247.202166667,8.84094,0.217,NULL,56747600749,886681261,13854394,16.2),(137839,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137839,35.76,0.06,142,65911,70,NULL,NULL,'MCG +07-34-074',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000028,NULL,'16.3g',0.22,'E',NULL,NULL,NULL,NULL,1,247.2057917,39.61578,0,NULL,59856439281,935256863,14613388,16.3),(137840,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137840,35.94,0.23,154,65911,74.4,NULL,NULL,'MCG +07-34-074',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137841,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137841,38.24,0.46,444,65912,70,NULL,NULL,'2MASX J16284984+4657259',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000182,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,247.207667,46.95722,0.017,NULL,59840699938,935010936,14609545,17.4),(137842,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137842,35.47,0.25,124,65913,74.4,NULL,NULL,'KUG 1627+399',NULL,'2013AJ....146...86T',2013,1,0.67,NULL,'G',0.00007,NULL,'14.9g',0.56,'S?',NULL,NULL,NULL,NULL,1,247.209125,39.83508,0.005,NULL,59856631612,935259868,14613435,14.9),(137843,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137843,35.66,0.16,135,65913,70,NULL,NULL,'KUG 1627+399',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137844,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137844,37.28,0.46,286,65914,70,NULL,NULL,'2MASX J16285027+2923129',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,247.209583,29.38683,0.029,NULL,59731871426,933310491,14582976,17.2),(137845,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137845,37.1,0.46,263,65915,70,NULL,NULL,'2MASX J16285048+2712279',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,247.2105,27.20769,0.105,NULL,56179989207,877812331,13715817,17.2),(137846,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137846,37.91,0.46,381,65916,70,NULL,NULL,'2MASX J16285057+4650329',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,247.210625,46.84239,0.017,NULL,59840710420,935011100,14609548,18),(137847,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137847,38.26,0.46,448,65917,70,NULL,NULL,'2MASX J16285199+3747489',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,247.216583333,37.79686,0,NULL,59820086807,934688856,14604513,17.8),(137848,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137848,36.3,0.19,182,65918,70,NULL,NULL,'2MASX J16285225+2535519',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000167,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,247.21775,25.59781,0.085,NULL,56185916137,877904939,13717264,16.3),(137849,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137849,37.02,0.46,254,65919,70,NULL,NULL,'2MASX J16285246+2343259',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.218625,23.72375,0.125,NULL,56650268935,885160452,13830632,17.9),(137850,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137850,35.09,0.25,104,65920,74.4,NULL,NULL,'III Zw 079',NULL,'2013AJ....146...86T',2013,1,0.66,NULL,'G',0.000053,NULL,'15.4g',0.56,'S',NULL,NULL,NULL,NULL,1,247.225625,40.86661,0,NULL,59854135685,935220870,14612826,15.4),(137851,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137851,35.29,0.22,114,65920,70,NULL,NULL,'III Zw 079',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137852,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137852,35.76,0.06,142,65920,70,NULL,NULL,'III Zw 079',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137853,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137853,37.55,0.33,324,65921,70,NULL,NULL,'SDSS J162854.70+244050.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000169,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,247.2279583,24.68078,0.097,NULL,56184920333,877889380,13717021,18.3),(137854,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137854,34.51,0.49,79.9,65922,75,NULL,'IR','UGC 10425',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.000043,NULL,'15.27',0.3,'Sb',NULL,NULL,NULL,NULL,1,247.234417,64.20694,0.009,NULL,57815472886,903366763,14115105,15.27),(137855,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137855,36.14,0.67,169,65923,70,NULL,NULL,'2MASX J16285641-1813167',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,247.235,-18.22125,0.969,NULL,45959215647,718112744,11220511,16.5),(137856,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137856,35.88,0.4,150,65924,75,NULL,'Edat, raw','2MASX J16285724+3942299',NULL,'1997ApJS..109..333W',1997,1,0.37,NULL,'G',0.000073,NULL,'15.9g',0.34,'E',NULL,NULL,NULL,NULL,1,247.2385417,39.70828,0,NULL,59856412273,935256441,14613381,15.9),(137857,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137857,35.9,0.4,152,65924,75,NULL,'Edat, cor','2MASX J16285724+3942299',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137858,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137858,35.73,0.23,140,65924,74.4,NULL,NULL,'2MASX J16285724+3942299',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137859,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137859,35.76,0.06,142,65924,70,NULL,NULL,'2MASX J16285724+3942299',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137860,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137860,37.52,0.33,319,65925,70,NULL,NULL,'2MASX J16285802+1439047',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000146,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.241875,14.65119,0.153,NULL,56658718132,885292470,13832694,17.7),(137861,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137861,35.81,0.27,145,65926,70,NULL,NULL,'III Zw 081',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000087,NULL,'16.2g',0.28,'AGN',NULL,NULL,NULL,NULL,1,247.243333,42.82811,0,NULL,59861024291,935328504,14614507,16.2),(137862,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137862,35.77,NULL,143,65927,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2039',NULL,'2010Ap&SS.325..163P',2010,1,1.05,NULL,'G',0.00004,NULL,'16.4g',0.17,'Sb(f)',NULL,NULL,NULL,NULL,1,247.2454583,42.41967,0,NULL,59860960406,935327506,14614492,16.4),(137863,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137863,35.79,NULL,144,65927,NULL,NULL,'Dipole + Quadrupole','FGC 2039',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137864,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137864,35.81,NULL,145,65927,NULL,NULL,NULL,'FGC 2039',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137865,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137865,35.81,NULL,145,65927,NULL,NULL,'Dipole','FGC 2039',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137866,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137866,36.06,0.49,163,65927,75,NULL,'IR','FGC 2039',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137867,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137867,36.52,0.33,201,65928,70,NULL,NULL,'2MASX J16285955+1635017',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,247.2482083,16.58369,0.225,NULL,56669896967,885467140,13835424,17.2),(137868,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137868,35.88,0.4,150,65929,75,NULL,'Edat, raw','2MASX J16285980+3941015',NULL,'1997ApJS..109..333W',1997,1,0.5,NULL,'G',0.000053,NULL,'15.9g',0.29,'E',NULL,NULL,NULL,NULL,1,247.249041667,39.68386,0,NULL,59856410222,935256409,14613381,15.9),(137869,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137869,35.9,0.4,152,65929,75,NULL,'Edat, cor','2MASX J16285980+3941015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137870,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137870,35.75,0.25,141,65929,74.4,NULL,NULL,'2MASX J16285980+3941015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137871,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137871,35.76,0.06,142,65929,70,NULL,NULL,'2MASX J16285980+3941015',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137872,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137872,36.23,0.46,176,65930,70,NULL,NULL,'2MASX J16290206+2942188',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000178,NULL,'16.1g',0.4,'S0',NULL,NULL,NULL,NULL,1,247.258541667,29.70511,0.037,NULL,59731439679,933303744,14582871,16.1),(137873,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137873,39.32,0.46,731,65931,70,NULL,NULL,'SDSS J162902.24+101254.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,247.259375,10.21508,0.265,NULL,56755800913,886809389,13856396,18.5),(137874,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137874,37.94,0.46,387,65932,70,NULL,NULL,'2MASX J16290267+1150317',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,247.2610417,11.84206,0.221,NULL,56742962997,886608796,13853262,17.6),(137875,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137875,38.21,0.46,439,65933,70,NULL,NULL,'2MASX J16290266+4351190',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000096,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,247.2612917,43.85542,0,NULL,59860051556,935313305,14614270,17),(137876,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137876,38.59,0.46,522,65934,70,NULL,NULL,'2MASX J16290338+2357593',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.264125,23.96658,0.129,NULL,56649499051,885148422,13830444,18.1),(137877,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137877,36.3,0.19,182,65935,70,NULL,NULL,'UGC 10410',NULL,'2015arXiv151105856S',2015,1,0.87,NULL,'G',0.000167,NULL,'15.0g',0.56,'E:',NULL,NULL,NULL,NULL,1,247.264708333,25.71339,0.085,NULL,56186774007,877918343,13717474,15),(137878,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137878,38.15,0.46,426,65936,70,NULL,NULL,'2MASX J16290557+2632341',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000176,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,247.27325,26.54286,0.089,NULL,56184427534,877881680,13716901,17.3),(137879,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137879,37.78,0.46,359,65937,70,NULL,NULL,'2MASX J16290627+1350527',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000178,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,247.276083333,13.84806,0.165,NULL,56877349290,888708582,13886071,17.1),(137880,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137880,34.79,0.25,90.8,65938,74.4,NULL,NULL,'MCG +07-34-079',NULL,'2013AJ....146...86T',2013,1,0.47,NULL,'G',0.000053,NULL,'15.9g',0.43,'Elliptical',NULL,NULL,NULL,NULL,1,247.279958333,39.49572,0,NULL,59856441617,935256900,14613389,15.9),(137881,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137881,35.76,0.06,142,65938,70,NULL,NULL,'MCG +07-34-079',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137882,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137882,35.67,0.07,136,65939,NULL,NULL,NULL,'2MASX J16290785+4039536',NULL,'2009ApJS..182..474S',2009,1,0.71,NULL,'G',0.000107,NULL,'15.7g',0.36,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,247.282625,40.66503,0,NULL,59854154998,935221171,14612830,15.7),(137883,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137883,36.64,0.33,213,65940,70,NULL,NULL,'2MASX J16290893+1144477',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',NULL,NULL,'16.82',0.56,'AGN',NULL,NULL,NULL,NULL,1,247.28725,11.74661,0.221,NULL,56742935474,886608366,13853255,16.82),(137884,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137884,37.91,0.46,382,65941,70,NULL,NULL,'2MASX J16290897+4325450',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000093,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,247.287667,43.42933,0,NULL,59859801999,935309406,14614209,16.7),(137885,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137885,36.43,0.33,193,65942,70,NULL,NULL,'2MASX J16290912+1547283',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,247.2877917,15.79119,0.193,NULL,56672453358,885507083,13836048,17.2),(137886,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137886,37.95,0.46,389,65943,70,NULL,NULL,'2MASX J16290921+2552141',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,247.288375,25.87058,0.085,NULL,56186813623,877918962,13717483,17.1),(137887,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137887,35.11,0.25,105,65944,74.4,NULL,NULL,'GIN 578',NULL,'2013AJ....146...86T',2013,1,0.72,NULL,'G',0.00008,NULL,'15.2g',0.66,'E/S0',NULL,NULL,NULL,NULL,1,247.2889583,40.98761,0,NULL,59854289250,935223269,14612863,15.2),(137888,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137888,35.29,0.22,114,65944,70,NULL,NULL,'GIN 578',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137889,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137889,35.76,0.06,142,65944,70,NULL,NULL,'GIN 578',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137890,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137890,38.58,0.46,520,65945,70,NULL,NULL,'2MASX J16291071+1248023',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000193,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,247.294667,12.80067,0.189,NULL,56878720774,888730012,13886406,17.2),(137891,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137891,35.72,0.08,140,65946,NULL,NULL,NULL,'MCG +07-34-081',NULL,'2009ApJS..182..474S',2009,1,1.05,NULL,'G',0.00017,NULL,'15.3g',0.37,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,247.296167,40.85742,0,NULL,59854233704,935222401,14612850,15.3),(137892,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137892,36.42,0.71,193,65947,70,NULL,NULL,'2MASX J16291180-1806279',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,247.299125,-18.10778,1.013,NULL,45959186180,718112284,11220504,15),(137893,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137893,38.08,0.46,413,65948,70,NULL,NULL,'2MASX J16291267+2616582',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,247.302875,26.28289,0.085,NULL,56186442434,877913163,13717393,17.9),(137894,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137894,37.85,0.46,371,65949,70,NULL,NULL,'2MASX J16291292+2852131',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000162,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,247.3040417,28.87031,0.037,NULL,59734507657,933351682,14583620,17.1),(137895,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137895,36.78,0.59,227,65950,70,NULL,NULL,'FAIRALL 1423',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'14.2R',0.42,NULL,NULL,NULL,NULL,NULL,1,247.3055417,-67.42886,0.505,NULL,45022926532,703483227,10991925,14.2),(137896,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137896,37.82,0.46,367,65951,70,NULL,NULL,'2MASX J16291368+0952577',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,247.3069583,9.88269,0.241,NULL,56755930706,886811417,13856428,17),(137897,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137897,37.94,0.46,388,65952,70,NULL,NULL,'2MASX J16291380+4207070',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000156,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,247.307417,42.11861,0,NULL,59860709977,935323593,14614431,17.2),(137898,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137898,35.8,0.49,145,65953,75,NULL,'IR','UGC 10406',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000043,NULL,'15.10',0.4,'Sbc',NULL,NULL,NULL,NULL,1,247.319166667,3.11553,0.257,NULL,56720643206,886260050,13847813,15.1),(137899,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137899,35.8,0.38,145,65953,NULL,NULL,'Malmquist cor.','UGC 10406',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137900,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137900,35.93,0.4,154,65953,NULL,NULL,'mean','UGC 10406',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137901,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137901,35.97,0.47,156,65953,NULL,NULL,'H','UGC 10406',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137902,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137902,35.99,0.45,158,65953,NULL,NULL,'K','UGC 10406',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137903,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137903,36.2,0.46,174,65953,NULL,NULL,'J','UGC 10406',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137904,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137904,36.21,0.2,175,65953,74.4,NULL,NULL,'UGC 10406',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137905,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137905,36.25,0.31,178,65953,NULL,NULL,NULL,'UGC 10406',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137906,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137906,36.13,0.46,168,65954,70,NULL,NULL,'2MASX J16291775+2528282',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.323875,25.47458,0.085,NULL,56185133214,877892706,13717073,17.2),(137907,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137907,37.76,0.46,356,65955,70,NULL,NULL,'2MASX J16291827+2758002',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,247.326375,27.96672,0.121,NULL,56180329110,877817642,13715900,18.3),(137908,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137908,37.6,0.33,331,65956,70,NULL,NULL,'2MASX J16291846+1944593',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,247.327,19.74997,0.209,NULL,56701275289,885957426,13843084,17.4),(137909,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137909,38.44,0.46,488,65957,70,NULL,NULL,'2MASX J16291947+3500344',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,247.33125,35.00947,0.013,NULL,59749815263,933590863,14587357,18.4),(137910,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137910,36.52,0.46,201,65958,70,NULL,NULL,'2MASX J16291968+4351480',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000104,NULL,'15.3g',0.54,'E0',NULL,NULL,NULL,NULL,1,247.331875,43.86339,0,NULL,59860052482,935313320,14614270,15.3),(137911,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137911,37.6,0.33,331,65959,70,NULL,NULL,'2MASX J16292017+1948213',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,247.3340417,19.80594,0.209,NULL,56701243666,885956932,13843077,17.3),(137912,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137912,37.52,0.33,319,65960,70,NULL,NULL,'2MASX J16292019+1442593',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00019,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,247.334125,14.71658,0.153,NULL,56658666066,885291657,13832682,17.1),(137913,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137913,37.85,0.46,372,65961,70,NULL,NULL,'2MASX J16292047+2632122',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000179,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,247.335333,26.53667,0.089,NULL,56184431913,877881748,13716902,18.3),(137914,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137914,35.08,0.25,104,65962,74.4,NULL,NULL,'III Zw 082',NULL,'2013AJ....146...86T',2013,1,0.74,NULL,'G',0.00008,NULL,'15.0g',0.62,'E/S0','Group member',NULL,NULL,NULL,1,247.349125,40.87494,0,NULL,59854237491,935222460,14612850,15),(137915,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137915,35.29,0.22,114,65962,70,NULL,NULL,'III Zw 082',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137916,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137916,35.76,0.06,142,65962,70,NULL,NULL,'III Zw 082',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137917,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137917,36.43,0.57,193,65963,70,NULL,NULL,'2MASX J16292425-6719321',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,247.351,-67.32564,0.505,NULL,45022924722,703483198,10991924,15.3),(137918,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137918,37.21,0.46,277,65964,70,NULL,NULL,'2MASX J16292467+2452082',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000169,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,247.352875,24.86894,0.109,NULL,56185730280,877902035,13717219,17.1),(137919,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137919,37.55,0.57,323,65965,70,NULL,NULL,'2MASX J16292570-6435418',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,247.357,-64.59497,0.777,NULL,44982035772,702844308,10981942,16),(137920,'IRAS','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137920,33.16,0.8,42.9,65966,75,NULL,'CF, r','UGC 10413',NULL,'1997ApJS..109..333W',1997,1,2.04,NULL,'G',0.000003,NULL,'14.6g',0.61,'Scd:',NULL,NULL,NULL,NULL,1,247.3630417,21.33658,0.137,NULL,56650428483,885162945,13830671,14.6),(137921,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137921,32.99,0.38,39.7,65966,75,NULL,'CF, r, raw','UGC 10413',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137922,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137922,33.02,0.38,40.3,65966,75,NULL,'CF, r, inv','UGC 10413',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137923,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137923,33.3,0.38,45.7,65966,75,NULL,'CF, r, cor','UGC 10413',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137924,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137924,33.3,0.2,45.7,65966,74.4,NULL,NULL,'UGC 10413',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137925,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137925,33.34,0.5,46.5,65966,NULL,NULL,'Malmquist cor.','UGC 10413',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137926,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137926,33.38,0.43,47.5,65966,75,NULL,'3.6 micron, color corrected','UGC 10413',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137927,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137927,33.43,0.48,48.5,65966,NULL,NULL,NULL,'UGC 10413',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137928,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137928,33.48,0.43,49.6,65966,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10413',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137929,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137929,36.72,0.46,221,65967,70,NULL,NULL,'2MASX J16292793+2635552',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000169,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,247.3662917,26.59867,0.089,NULL,56184423839,877881622,13716900,16.6),(137930,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137930,37.6,0.46,331,65968,70,NULL,NULL,'SDSS J162928.76+320434.6',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00017,NULL,'17.8g',NULL,NULL,NULL,NULL,NULL,NULL,1,247.369875,32.07628,0.029,NULL,59787317340,934176833,14596513,17.8),(137931,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137931,35.76,0.06,142,65969,70,NULL,NULL,'2MASX J16292913+3848438',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000117,NULL,'16.1g',0.36,'SB',NULL,NULL,NULL,NULL,1,247.3714583,38.81217,0,NULL,59819948909,934686701,14604479,16.1),(137932,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137932,38.22,0.46,441,65970,70,NULL,NULL,'SDSS J162929.65+400328.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000181,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,247.3735417,40.05778,0.005,NULL,59854454485,935225851,14612903,17.9),(137933,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137933,36.29,0.46,181,65971,70,NULL,NULL,'2MASX J16293053+1305003',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000183,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,247.377375,13.08342,0.177,NULL,56878908667,888732947,13886452,16.1),(137934,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137934,38.98,0.46,626,65972,70,NULL,NULL,'2MASX J16293067+1940434',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00018,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,247.37775,19.67875,0.209,NULL,56701278029,885957469,13843085,18.2),(137935,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137935,36.95,0.46,246,65973,70,NULL,NULL,'2MASX J16293121+1314383',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000167,NULL,'16.8g',NULL,NULL,NULL,NULL,NULL,NULL,1,247.380166667,13.24417,0.177,NULL,56878337133,888724017,13886312,16.8),(137936,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137936,37.07,0.46,260,65974,70,NULL,NULL,'2MASX J16293145+2021004',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000137,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,247.3809583,20.35022,0.197,NULL,56701550745,885961730,13843152,17.6),(137937,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137937,37.16,0.62,270,65975,70,NULL,NULL,'2MASX J16293189-6423367',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,247.382875,-64.3935,0.841,NULL,44982047344,702844489,10981945,14.5),(137938,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137938,35.76,0.06,142,65976,70,NULL,NULL,'2MASX J16293306+3954108',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00005,NULL,'16.1g',0.25,'E',NULL,NULL,NULL,NULL,1,247.387833,39.90294,0.005,NULL,59854504799,935226637,14612916,16.1),(137939,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137939,33.53,0.47,50.8,65977,NULL,NULL,'H','NGC 6182',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000033,NULL,'14.44',0.6,'Sa',NULL,NULL,NULL,NULL,1,247.391667,55.51778,0,NULL,57603415518,900053367,14063333,14.44),(137940,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137940,33.69,0.46,54.8,65977,NULL,NULL,'J','NGC 6182',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137941,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137941,33.7,0.45,54.9,65977,NULL,NULL,'K','NGC 6182',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137942,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137942,34.24,0.4,70.4,65977,NULL,NULL,'mean','NGC 6182',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137943,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137943,36.75,0.46,224,65978,70,NULL,NULL,'2MASX J16293615+1327163',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000177,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,247.4005417,13.45456,0.181,NULL,56878329900,888723904,13886311,16.5),(137944,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137944,36.71,0.46,220,65979,70,NULL,NULL,'2MASX J16293758+2318105',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,247.406583333,23.30278,0.117,NULL,56649675379,885151177,13830487,16.9),(137945,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137945,36.48,0.46,198,65980,70,NULL,NULL,'2MASX J16293963+2408563',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000175,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,247.4149583,24.14889,0.141,NULL,56176484377,877757568,13714962,17.3),(137946,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137946,37.3,0.46,288,65981,70,NULL,NULL,'2MASX J16293960+1239522',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,247.415167,12.6645,0.197,NULL,56878643038,888728797,13886387,18),(137947,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137947,37.81,0.46,365,65982,70,NULL,NULL,'2MASX J16294037+2406213',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000142,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.418041667,24.10586,0.129,NULL,56649457160,885147768,13830433,17.9),(137948,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137948,35.62,0.13,133,65983,NULL,NULL,NULL,'UGC 10417',NULL,'2009ApJS..182..474S',2009,1,0.94,NULL,'G',0.0001,NULL,'16.0g',0.24,'Sb(f)','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,247.419917,40.68694,0,NULL,59854120272,935220629,14612822,16),(137949,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137949,36.73,0.46,222,65984,70,NULL,NULL,'2MASX J16294134+2935323',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000175,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,247.422167,29.59247,0.037,NULL,59731915482,933311179,14582987,17.3),(137950,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137950,37.99,0.46,396,65985,70,NULL,NULL,'SDSS J162942.00+245404.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,247.425,24.90131,0.109,NULL,56185718425,877901850,13717216,17.8),(137951,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137951,37.47,0.33,312,65986,70,NULL,NULL,'2MASX J16294215+2655094',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,247.42575,26.91917,0.093,NULL,56184292750,877879574,13716868,17.3),(137952,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137952,35.88,0.46,150,65987,70,NULL,NULL,'2MASX J16294368+1516372',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000159,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,247.432167,15.27694,0.177,NULL,56672243851,885503810,13835997,16.5),(137953,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137953,34.73,0.49,88.3,65988,70,NULL,NULL,'FAIRALL 1425',NULL,'2014MNRAS.445.2677S',2014,1,1.17,NULL,'G',0.00015,NULL,'14.5R',1,NULL,NULL,NULL,NULL,NULL,1,247.4322917,-68.00339,0.417,NULL,45027808323,703559505,10993117,14.5),(137954,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137954,33.99,0.2,62.8,65989,74.4,NULL,NULL,'CGCG 080-042',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.00001,NULL,'15.6',0.15,'Sbc',NULL,NULL,NULL,NULL,1,247.4337917,11.84711,0.221,NULL,56743124351,886611317,13853301,15.6),(137955,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137955,34.11,NULL,66.2,65989,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 080-042',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137956,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137956,34.12,NULL,66.6,65989,NULL,NULL,'Dipole + Quadrupole','CGCG 080-042',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137957,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137957,34.13,NULL,67.1,65989,NULL,NULL,'Dipole','CGCG 080-042',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137958,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137958,34.18,NULL,68.6,65989,NULL,NULL,NULL,'CGCG 080-042',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137959,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137959,34.24,0.49,70.5,65989,75,NULL,'IR','CGCG 080-042',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137960,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137960,37.47,0.33,312,65990,70,NULL,NULL,'2MASX J16294440+2651234',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00018,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,247.435166667,26.8565,0.093,NULL,56184298844,877879669,13716869,16.6),(137961,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137961,34.3,0.4,72.4,65991,75,NULL,'Edat, raw','NGC 6173',NULL,'1997ApJS..109..333W',1997,1,1.9,'HOLM 753B is a double star.','G',0.00005,NULL,'13.1B',1.4,'cD;E           AGN','in a radial-velocity based grouping',NULL,NULL,NULL,1,247.437083,40.81161,0,NULL,59854111787,935220496,14612820,13.1),(137962,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137962,34.63,0.4,84.2,65991,75,NULL,'Edat, cor','NGC 6173',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137963,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137963,34.88,0.22,94.6,65991,74.4,NULL,NULL,'NGC 6173',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137964,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137964,35.29,0.22,114,65991,70,NULL,NULL,'NGC 6173',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137965,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137965,35.76,0.06,142,65991,70,NULL,NULL,'NGC 6173',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137966,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137966,34.89,0.45,94.9,65991,NULL,NULL,'K','NGC 6173',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137967,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137967,35.47,0.4,124,65991,NULL,NULL,'mean','NGC 6173',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137968,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137968,35.56,0.3,129,65991,NULL,NULL,'ABELL 2197, 3 galaxies','NGC 6173',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137969,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137969,37.69,0.46,345,65992,70,NULL,NULL,'SDSS J162945.10+302218.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,247.4379583,30.37181,0.021,NULL,59786243688,934160057,14596250,18.3),(137970,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137970,35.76,0.06,142,65993,70,NULL,NULL,'2MASX J16294513+3948381',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000067,NULL,'15.6g',0.41,'Elliptical',NULL,NULL,NULL,NULL,1,247.438,39.81056,0.005,NULL,59854325009,935223828,14612872,15.6),(137971,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137971,37.35,0.46,296,65994,70,NULL,NULL,'2MASX J16294578+2245476',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.440833,22.76317,0.165,NULL,56651655130,885182111,13830970,17.7),(137972,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137972,36.99,0.16,250,65995,70,NULL,NULL,'2MASX J16294712+2434194',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000174,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,247.44625,24.57206,0.121,NULL,56176590204,877759221,13714987,16.3),(137973,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137973,38.59,0.46,523,65996,70,NULL,NULL,'SDSS J162947.11+221642.5',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,247.4462917,22.2785,0.141,NULL,56651090249,885173285,13830832,18.2),(137974,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137974,37.71,0.46,348,65997,70,NULL,NULL,'SDSS J162947.27+385350.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000136,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.447,38.89725,0,NULL,59819905089,934686017,14604469,18.1),(137975,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137975,37.67,0.46,341,65998,70,NULL,NULL,'2MASX J16295013+1224333',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,247.459041667,12.40925,0.209,NULL,56878662285,888729098,13886392,17.4),(137976,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137976,36.43,0.46,193,65999,70,NULL,NULL,'2MASX J16295039+2046076',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000139,NULL,'17.5g',NULL,NULL,NULL,NULL,NULL,NULL,1,247.4597917,20.76886,0.209,NULL,56703031872,885984873,13843513,17.5),(137977,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137977,35.69,0.08,138,66000,NULL,NULL,NULL,'UGC 10420',NULL,'2009ApJS..182..474S',2009,1,1.24,NULL,'G',0.00006,NULL,'14.8g',0.75,'SB(r)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,247.462667,39.7665,0,NULL,59854338429,935224037,14612875,14.8),(137978,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137978,37.44,0.46,307,66001,70,NULL,NULL,'2MASX J16295154+2209396',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,247.4647083,22.16108,0.125,NULL,56651267085,885176048,13830875,17.3),(137979,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137979,37.86,0.46,373,66002,70,NULL,NULL,'2MASX J16295276+2939434',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,247.469917,29.66206,0.037,NULL,59731905212,933311018,14582984,18.1),(137980,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137980,35.45,0.46,123,66003,70,NULL,NULL,'CGCG 109-025',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000186,NULL,'15.0g',0.6,NULL,NULL,NULL,NULL,NULL,1,247.472417,20.23256,0.193,NULL,56703194666,885987416,13843553,15),(137981,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137981,35.71,0.08,139,66004,NULL,NULL,NULL,'UGC 10423',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000063,NULL,'16.0',0.5,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,247.476625,41.60453,0,NULL,59858747139,935292924,14613951,16),(137982,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137982,35.66,0.16,135,66005,70,NULL,NULL,'GIN 596',NULL,'2001MNRAS.321..277C',2001,1,0.37,NULL,'G',0.000093,NULL,'14.52',0.33,'E/S0',NULL,NULL,NULL,NULL,1,247.4857917,39.94372,0.005,NULL,59854517702,935226839,14612919,14.52),(137983,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137983,36.65,0.25,214,66005,74.4,NULL,NULL,'GIN 596',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137984,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137984,36.74,0.46,223,66005,70,NULL,NULL,'GIN 596',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137985,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137985,38.42,0.46,484,66006,70,NULL,NULL,'SDSS J162957.17+460459.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000143,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,247.48825,46.08314,0.009,NULL,59841000155,935015627,14609619,18.5),(137986,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137986,35.78,0.46,143,66007,70,NULL,NULL,'2MASX J16300278+4349297',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000093,NULL,'15.3g',0.5,'S0',NULL,NULL,NULL,NULL,1,247.511375,43.82492,0,NULL,59860029931,935312967,14614265,15.3),(137987,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137987,35.95,0.46,155,66008,70,NULL,NULL,'CGCG 138-024',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.00012,NULL,'15.0g',0.57,NULL,NULL,NULL,NULL,NULL,1,247.511417,23.35442,0.117,NULL,56649704241,885151628,13830494,15),(137988,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137988,37.77,0.46,359,66009,70,NULL,NULL,'2MASX J16300582+2005131',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,247.524333,20.08714,0.193,NULL,56703220568,885987821,13843559,17.6),(137989,'Tully est','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137989,33.02,0.8,40.1,66010,75,NULL,NULL,'UGC 10419',NULL,'1988NBGC.C....0000T',1988,1,0.41,NULL,'G',0.000011,NULL,'17.2g',0.14,'Im:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,247.525417,27.69931,0.117,NULL,56180221173,877815955,13715874,17.2),(137990,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137990,37.16,0.33,270,66011,70,NULL,NULL,'KUGX 1628+363',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.0001,NULL,'15.5g',0.48,'Compact',NULL,NULL,NULL,NULL,1,247.528583,36.22019,0,NULL,59751707491,933620429,14587819,15.5),(137991,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137991,35.92,0.46,152,66012,70,NULL,NULL,'2MASX J16300809+1454127',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000093,NULL,'15.3g',0.54,NULL,NULL,NULL,NULL,NULL,1,247.5337083,14.90347,0.141,NULL,56657833561,885278649,13832478,15.3),(137992,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137992,38.6,0.46,525,66013,70,NULL,NULL,'SDSS J163008.89+270943.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,247.537041667,27.16211,0.105,NULL,56180064412,877813506,13715836,18.4),(137993,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137993,36.98,0.46,249,66014,70,NULL,NULL,'SDSS J163010.26+092305.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'17.9g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,247.542791667,9.38494,0.221,NULL,56755585684,886806026,13856344,17.9),(137994,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137994,35.63,0.49,134,66015,75,NULL,'IR','CGCG 138-026',NULL,'2011yCatp016004901K',2011,1,1.06,NULL,'G',0.000057,NULL,'15.1g',0.31,'S',NULL,NULL,NULL,NULL,1,247.5555,23.06972,0.165,NULL,56651568950,885180764,13830949,15.1),(137995,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137995,35.83,0.4,147,66015,NULL,NULL,'mean','CGCG 138-026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137996,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137996,35.97,0.47,156,66015,NULL,NULL,'H','CGCG 138-026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137997,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137997,36.04,0.2,161,66015,74.4,NULL,NULL,'CGCG 138-026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137998,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137998,36.06,0.45,163,66015,NULL,NULL,'K','CGCG 138-026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137999,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137999,36.99,0.16,250,66016,70,NULL,NULL,'2MASX J16301543+2442443',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,247.5642917,24.71225,0.097,NULL,56177323856,877770685,13715166,17.7),(138000,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138000,37.16,0.33,270,66017,70,NULL,NULL,'2MASX J16301555+3616260',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.5647917,36.27392,0,NULL,59751702199,933620346,14587817,17.8),(138001,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138001,36.67,0.46,216,66018,70,NULL,NULL,'2MASX J16301589+2507393',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00017,NULL,'17.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,247.566166667,25.12756,0.081,NULL,56185244391,877894443,13717100,17.2),(138002,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138002,35.76,0.06,142,66019,70,NULL,NULL,'2MASX J16301736+3953220',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000057,NULL,'15.4g',0.41,'S0',NULL,NULL,NULL,NULL,1,247.572375,39.88942,0.005,NULL,59854511347,935226739,14612917,15.4),(138003,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138003,35.09,0.25,104,66020,74.4,NULL,NULL,'KUG 1628+407',NULL,'2013AJ....146...86T',2013,1,0.64,NULL,'G',0.000053,NULL,'15.3g',0.57,'S','Group member',NULL,NULL,NULL,1,247.5740417,40.59861,0,NULL,59854596663,935228072,14612938,15.3),(138004,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138004,35.29,0.22,114,66020,70,NULL,NULL,'KUG 1628+407',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138005,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138005,37.66,0.46,341,66021,70,NULL,NULL,'2MASX J16301852+1930171',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,247.577167,19.50472,0.237,NULL,56704375333,886005864,13843841,18.3),(138006,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138006,36.27,0.46,179,66022,70,NULL,NULL,'2MASX J16301888+4254538',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00006,NULL,'15.8g',0.4,'E0',NULL,NULL,NULL,NULL,1,247.5787917,42.91486,0,NULL,59860173415,935315209,14614300,15.8),(138007,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138007,37.02,0.46,253,66023,70,NULL,NULL,'2MASX J16301913+0011064',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000073,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,247.57975,0.185,0.293,NULL,56707049491,886047648,13844494,17.5),(138008,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138008,36.68,0.33,217,66024,70,NULL,NULL,'2MASX J16301981+2452344',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.0002,NULL,'16.1g',0.31,'S0^-',NULL,NULL,NULL,NULL,1,247.582583,24.87625,0.109,NULL,56177007436,877765741,13715089,16.1),(138009,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138009,35.66,0.16,135,66025,70,NULL,NULL,'GIN 595',NULL,'2001MNRAS.321..277C',2001,1,0.59,NULL,'G',0.000063,NULL,'15.5g',0.46,'S0',NULL,NULL,NULL,NULL,1,247.583875,39.80431,0,NULL,59854335800,935223996,14612874,15.5),(138010,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138010,35.76,0.06,142,66025,70,NULL,NULL,'GIN 595',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138011,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138011,36.98,0.46,249,66026,70,NULL,NULL,'2MASX J16302025+2544024',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00018,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,247.584333333,25.73417,0.081,NULL,56186292057,877910813,13717356,16.5),(138012,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138012,38.2,0.46,437,66027,70,NULL,NULL,'SDSS J163020.35+093247.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,247.584833,9.5465,0.237,NULL,56756694368,886823349,13856614,18.3),(138013,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138013,35.41,1.14,121,66028,NULL,NULL,'Malmquist cor.','UGC 10416',NULL,'2009ApJS..182..474S',2009,1,1,'Springob et al. (2005ApJS..160..149S) give v= 6214 km/sec.','G',0.00018,NULL,'14.60',0.8,'SAB(s)bc',NULL,NULL,NULL,NULL,1,247.584833,8.62881,0.253,NULL,56747926727,886686355,13854474,14.6),(138014,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138014,36.15,0.81,170,66028,NULL,NULL,NULL,'UGC 10416',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138015,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138015,36.47,0.46,197,66029,70,NULL,NULL,'2MASX J16302054+2147591',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000181,NULL,'15.7g',0.38,NULL,NULL,NULL,NULL,NULL,1,247.585667,21.79981,0.145,NULL,56650450158,885163283,13830676,15.7),(138016,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138016,36.9,0.46,240,66030,70,NULL,NULL,'2MASX J16302064+3902361',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00016,NULL,'16.9g',0.27,'S',NULL,NULL,NULL,NULL,1,247.586167,39.04322,0,NULL,59819726504,934683226,14604425,16.9),(138017,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138017,36.54,0.46,203,66031,70,NULL,NULL,'SDSS J163022.07+114935.9',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.7g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,247.592,11.82667,0.221,NULL,56743055589,886610243,13853285,16.7),(138018,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138018,37.86,0.46,373,66032,70,NULL,NULL,'2MASX J16302229+3101447',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000177,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.593125,31.02908,0.045,NULL,59786411142,934162674,14596291,17.7),(138019,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138019,35.76,0.06,142,66033,70,NULL,NULL,'CGCG 224-052',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000073,NULL,'15.1g',0.52,'E','Group member',NULL,NULL,NULL,1,247.5997083,40.66569,0,NULL,59854588081,935227938,14612936,15.1),(138020,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138020,37.94,0.33,387,66034,70,NULL,NULL,'2MASX J16302564+1639278',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000181,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,247.6069583,16.65792,0.237,NULL,56669981676,885468463,13835444,18.2),(138021,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138021,36.99,0.16,250,66035,70,NULL,NULL,'2MASX J16302666+2436404',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,247.6110417,24.61119,0.097,NULL,56177294210,877770222,13715159,17.1),(138022,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138022,35.09,0.25,104,66036,74.4,NULL,NULL,'UGC 10430',NULL,'2013AJ....146...86T',2013,1,0.97,NULL,'G',0.000026,NULL,'14.6g',0.82,'SB(rs)bc',NULL,NULL,NULL,NULL,1,247.611833,41.48397,0.005,NULL,59858571280,935290176,14613909,14.6),(138023,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138023,35.29,0.22,114,66036,70,NULL,NULL,'UGC 10430',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138024,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138024,36.3,0.46,182,66037,70,NULL,NULL,'2MASX J16302675+2603364',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000187,NULL,'15.7g',0.47,'S0^-',NULL,NULL,NULL,NULL,1,247.611667,26.06003,0.089,NULL,56186678999,877916859,13717450,15.7),(138025,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138025,35.8,0.07,145,66038,NULL,NULL,NULL,'CGCG 224-055',NULL,'2009ApJS..182..474S',2009,1,1.14,NULL,'G',0.000067,NULL,'14.6g',0.41,'Sa','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,247.62,39.62606,0,NULL,59854353341,935224270,14612879,14.6),(138026,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138026,36.99,0.16,250,66039,70,NULL,NULL,'2MASX J16302886+2433164',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,247.620125,24.55453,0.097,NULL,56177396465,877771819,13715184,18),(138027,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138027,37.51,0.46,318,66040,70,NULL,NULL,'2MASX J16302939+3040278',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,247.62275,30.67428,0.049,NULL,59786300938,934160952,14596264,17),(138028,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138028,38.41,0.23,481,66041,70,NULL,NULL,'2MASX J16303188+2116532',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000184,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,247.6327917,21.2815,0.157,NULL,56695477149,885866830,13841669,17.6),(138029,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138029,37.05,0.46,257,66042,70,NULL,NULL,'2MASX J16303210+1353128',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,247.633625,13.887,0.165,NULL,56877203993,888706312,13886036,17.1),(138030,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138030,35.09,0.25,104,66043,74.4,NULL,NULL,'NGC 6180',NULL,'2013AJ....146...86T',2013,1,0.87,NULL,'G',0.000043,NULL,'14.5g',0.67,'S0','Group member',NULL,NULL,NULL,1,247.641333,40.53944,0,NULL,59854594939,935228045,14612938,14.5),(138031,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138031,35.29,0.22,114,66043,70,NULL,NULL,'NGC 6180',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138032,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138032,35.76,0.06,142,66043,70,NULL,NULL,'NGC 6180',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138033,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138033,37.49,0.46,315,66044,70,NULL,NULL,'2MASX J16303428+0947509',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,247.642791667,9.79736,0.241,NULL,56757206448,886831350,13856739,17),(138034,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138034,37.17,0.27,271,66045,70,NULL,NULL,'2MASX J16303455+2848034',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000153,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,247.644,28.80097,0.057,NULL,59731630544,933306727,14582917,16.8),(138035,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138035,36.99,0.16,250,66046,70,NULL,NULL,'2MASX J16303509+2435324',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,247.6462083,24.59231,0.097,NULL,56177403267,877771926,13715186,17.7),(138036,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138036,38.05,0.46,408,66047,70,NULL,NULL,'2MASX J16303775+2246363',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000215,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,247.657541667,22.77681,0.165,NULL,56651531636,885180181,13830940,18.4),(138037,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138037,38.23,0.33,443,66048,70,NULL,NULL,'2MASX J16303787+2944576',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000173,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,247.657667,29.74936,0.037,NULL,59732024553,933312883,14583013,16.9),(138038,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138038,37.14,0.2,268,66049,74.4,NULL,NULL,'CGCG 168-017',NULL,'2013AJ....146...86T',2013,1,0.57,NULL,'G',0.000105,NULL,'15.7g',0.43,'SBbc',NULL,NULL,NULL,NULL,1,247.658167,27.46228,0.109,NULL,56179924651,877811322,13715801,15.7),(138039,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138039,36.99,0.16,250,66050,70,NULL,NULL,'2MASX J16303890+2430594',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'17.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,247.6620417,24.51644,0.121,NULL,56177400658,877771885,13715185,17.9),(138040,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138040,35.34,0.2,117,66051,74.4,NULL,NULL,'NGC 6177',NULL,'2013AJ....146...86T',2013,1,1.44,NULL,'G',0.00003,NULL,'14.4g',0.89,'(R\')SB(s)b',NULL,NULL,NULL,NULL,1,247.662,35.05644,0.013,NULL,59749930015,933592656,14587385,14.4),(138041,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138041,35.73,0.4,140,66051,NULL,NULL,'mean','NGC 6177',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138042,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138042,35.74,0.47,141,66051,NULL,NULL,'H','NGC 6177',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138043,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138043,35.87,0.46,149,66051,NULL,NULL,'J','NGC 6177',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138044,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138044,35.88,0.45,150,66051,NULL,NULL,'K','NGC 6177',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138045,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138045,36.3,0.19,182,66052,70,NULL,NULL,'2MASX J16303911+2536336',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000201,NULL,'15.5g',0.54,NULL,NULL,NULL,NULL,NULL,1,247.6627917,25.60944,0.077,NULL,56186258784,877910293,13717348,15.5),(138046,'SNIa','2016-12-15 15:15:42','2016-12-16 11:20:57','1','SN 1998cs',NULL,138046,36.08,0.19,159,66053,65,NULL,NULL,'UGC 10432',0.03256,'2004ApJ...607..665R',2004,1,1.7,NULL,'G',0.000143,NULL,'15.5g',0.3,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,247.663375,41.21067,0,NULL,59854184587,935221634,14612838,15.5),(138047,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138047,35.64,0.11,135,66053,NULL,NULL,NULL,'UGC 10432',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138048,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138048,37.17,0.27,271,66054,70,NULL,NULL,'2MASX J16303969+2845246',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.665333,28.75683,0.057,NULL,59731638685,933306854,14582919,18),(138049,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138049,36.99,0.16,250,66055,70,NULL,NULL,'2MASX J16303981+2434546',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,247.6660417,24.582,0.097,NULL,56177409557,877772024,13715187,17.1),(138050,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138050,37,0.46,251,66056,70,NULL,NULL,'2MASX J16303992+3938071',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000073,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,247.66625,39.63542,0,NULL,59854351407,935224240,14612878,17.1),(138051,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138051,35.09,0.25,104,66057,74.4,NULL,NULL,'KUG 1629+406A',NULL,'2013AJ....146...86T',2013,1,0.62,NULL,'G',0.000053,NULL,'15.5g',0.56,'S',NULL,NULL,NULL,NULL,1,247.6745,40.52942,0,NULL,59854770186,935230784,14612981,15.5),(138052,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138052,35.29,0.22,114,66057,70,NULL,NULL,'KUG 1629+406A',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138053,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138053,35.29,0.22,114,66057,70,NULL,NULL,'KUG 1629+406A',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138054,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138054,37.94,0.33,387,66058,70,NULL,NULL,'2MASX J16304317+1639104',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000178,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,247.67975,16.653,0.265,NULL,56669800647,885465635,13835400,16.7),(138055,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138055,36.31,0.46,182,66059,70,NULL,NULL,'2MASX J16304436+2354043',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000151,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,247.685,23.90114,0.145,NULL,56649934278,885155223,13830550,16.7),(138056,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138056,36.65,0.46,214,66060,70,NULL,NULL,'2MASX J16304463+1503354',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000157,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,247.685875,15.05992,0.193,NULL,56657812797,885278324,13832473,16.9),(138057,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138057,38.62,0.46,529,66061,70,NULL,NULL,'2MASX J16304489+1519294',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000171,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,247.6870417,15.32486,0.193,NULL,56671509329,885492333,13835817,17.9),(138058,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138058,35.45,0.25,123,66062,74.4,NULL,NULL,'MCG +07-34-099',NULL,'2013AJ....146...86T',2013,1,0.72,NULL,'G',0.00008,NULL,'15.5g',0.47,'E/S0',NULL,NULL,NULL,NULL,1,247.6887083,39.19525,0,NULL,59822577470,934727772,14605121,15.5),(138059,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138059,35.66,0.16,135,66062,70,NULL,NULL,'MCG +07-34-099',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138060,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138060,35.76,0.06,142,66062,70,NULL,NULL,'MCG +07-34-099',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138061,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138061,38.23,0.33,443,66063,70,NULL,NULL,'2MASX J16304571+2943006',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000207,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,247.6904583,29.71675,0.037,NULL,59732021895,933312842,14583013,17.5),(138062,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138062,36.98,0.46,248,66064,70,NULL,NULL,'2MASX J16304818+2604116',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000174,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,247.700667,26.06981,0.089,NULL,56186679880,877916873,13717451,16.9),(138063,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138063,37.33,0.46,293,66065,70,NULL,NULL,'2MASX J16304884+4223319',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,247.703667,42.39231,0,NULL,59860195317,935315551,14614305,17.4),(138064,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138064,35.61,0.2,132,66066,74.4,NULL,NULL,'UGC 10426',NULL,'2013AJ....146...86T',2013,1,1.03,NULL,'G',0.000033,NULL,'15.1g',0.35,'S?',NULL,NULL,NULL,NULL,1,247.708917,16.25075,0.249,NULL,56671619338,885494052,13835844,15.1),(138065,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138065,37.25,0.46,282,66067,70,NULL,NULL,'2MASX J16305035+4840266',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00017,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,247.7097917,48.67408,0,NULL,59842877543,935044961,14610077,16.5),(138066,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138066,38.41,0.23,481,66068,70,NULL,NULL,'2MASX J16305228+2122083',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,247.717791667,21.36889,0.157,NULL,56695703902,885870373,13841724,18.5),(138067,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138067,36.99,0.16,250,66069,70,NULL,NULL,'CGCG 138-030',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000083,NULL,'15.5g',0.51,'BrClG',NULL,NULL,NULL,NULL,1,247.724333,24.56211,0.097,NULL,56177399419,877771865,13715185,15.5),(138068,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138068,36.55,0.46,204,66070,70,NULL,NULL,'2MASX J16305545+2552006',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,247.7312083,25.86689,0.081,NULL,56186322685,877911291,13717363,17),(138069,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138069,36.68,0.33,217,66071,70,NULL,NULL,'2MASX J16305579+2446476',NULL,'2015arXiv151105856S',2015,1,0.39,'1999ApJS..122..415A has z = 0.026 +- 0.004.','G',0.000173,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,247.732625,24.77989,0.109,NULL,56177308000,877770437,13715163,16.5),(138070,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138070,37.66,0.46,340,66072,70,NULL,NULL,'2MASX J16305646+3001506',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,247.7352083,30.03075,0.041,NULL,59731478567,933304352,14582880,17.6),(138071,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138071,35.55,0.5,129,66073,70,NULL,NULL,'2MASX J16305650-6825553',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,247.735417,-68.43203,0.417,NULL,45027617838,703556528,10993070,14),(138072,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138072,36.77,0.46,226,66074,70,NULL,NULL,'2MASX J16305671+2107073',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00013,NULL,'17.6g',NULL,NULL,NULL,NULL,NULL,NULL,1,247.736375,21.11883,0.177,NULL,56702945543,885983524,13843492,17.6),(138073,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138073,37.96,0.46,390,66075,70,NULL,NULL,'2MASX J16305685+3739353',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,247.7369583,37.65992,0,NULL,59819651130,934682048,14604407,17.6),(138074,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138074,35.1,0.25,105,66076,74.4,NULL,NULL,'CGCG 224-063',NULL,'2013AJ....146...86T',2013,1,0.61,NULL,'G',0.000073,NULL,'15.1g',0.53,'S0','Group member',NULL,NULL,NULL,1,247.744833,40.93056,0,NULL,59854197266,935221832,14612841,15.1),(138075,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138075,35.29,0.22,114,66076,70,NULL,NULL,'CGCG 224-063',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138076,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138076,35.76,0.06,142,66076,70,NULL,NULL,'CGCG 224-063',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138077,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138077,36.47,0.46,197,66077,70,NULL,NULL,'2MASX J16305991-0006538',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000088,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,247.7495,-0.11489,0.293,NULL,45164329566,705692649,11026447,16.7),(138078,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138078,36.81,0.75,230,66077,70,NULL,NULL,'2MASX J16305991-0006538',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138079,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138079,35.76,0.06,142,66078,70,NULL,NULL,'2MASX J16310015+4014514',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000087,NULL,'15.9g',0.36,'S0',NULL,NULL,NULL,NULL,1,247.750583,40.24767,0,NULL,59854454939,935225858,14612904,15.9),(138080,'CMD','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138080,20.4,0.2,0.12,66079,NULL,NULL,NULL,'HERCULES SATELLITE',NULL,'2008AJ....135.1361D',2008,1,NULL,NULL,'G',NULL,NULL,'14.7V',NULL,'dSph',NULL,NULL,NULL,NULL,1,247.758333,12.79167,0.189,1,56878762689,888730667,13886416,14.7),(138081,'CMD','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138081,20.58,0.1,0.13,66079,NULL,NULL,'Girardi','HERCULES SATELLITE',NULL,'2009ApJ...704..898S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138082,'CMD','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138082,20.6,0.19,0.132,66079,NULL,NULL,NULL,'HERCULES SATELLITE',NULL,'2007ApJ...668L..43C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138083,'CMD','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138083,20.6,0.05,0.132,66079,NULL,NULL,'Dotter','HERCULES SATELLITE',NULL,'2009ApJ...704..898S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138084,'CMD','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138084,20.62,0.1,0.133,66079,NULL,NULL,'Empirical','HERCULES SATELLITE',NULL,'2009ApJ...704..898S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138085,'CMD','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138085,20.9,NULL,0.135,66079,NULL,NULL,NULL,'HERCULES SATELLITE',NULL,'2013ApJ...771...29G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138086,'CMD','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138086,20.7,NULL,0.138,66079,NULL,NULL,NULL,'HERCULES SATELLITE',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138087,'CMD','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138087,20.7,0.2,0.14,66079,NULL,NULL,NULL,'HERCULES SATELLITE',NULL,'2008AJ....135.1361D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138088,'CMD','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138088,20.7,0.2,0.14,66079,NULL,NULL,NULL,'HERCULES SATELLITE',NULL,'2007ApJ...654..897B',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138089,'CMD','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138089,20.92,0.06,0.153,66079,NULL,NULL,NULL,'HERCULES SATELLITE',NULL,'2012ApJ...753L..21B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138090,'Horizontal Branch','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138090,20.84,0.11,0.147,66079,NULL,NULL,NULL,'HERCULES SATELLITE',NULL,'2009A&A...506.1147A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138091,'RR Lyrae','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138091,20.6,0.1,0.132,66079,NULL,NULL,'7, V','HERCULES SATELLITE',NULL,'2012ApJ...756..121M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138092,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138092,36.74,0.33,223,66080,70,NULL,NULL,'2MASX J16310202+4225059',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000053,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,247.758333,42.41833,0,NULL,59860250100,935316407,14614318,16.8),(138093,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138093,35.66,0.16,135,66081,70,NULL,NULL,'CGCG 224-064 NED01',NULL,'2001MNRAS.321..277C',2001,1,0.89,NULL,'G',0.000103,NULL,'14.3g',0.84,'E',NULL,NULL,NULL,NULL,1,247.761333333,39.7925,0,NULL,59854530164,935227033,14612922,14.3),(138094,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138094,35.76,0.06,142,66081,70,NULL,NULL,'CGCG 224-064 NED01',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138095,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138095,35.44,0.25,122,66082,74.4,NULL,NULL,'CGCG 224-064',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'GPair',0.000047,NULL,NULL,NULL,'E/S0','Group member',NULL,NULL,NULL,1,247.76375,39.79306,0,NULL,59854530122,935227033,14612922,NULL),(138096,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138096,35.45,0.25,123,66083,74.4,NULL,NULL,'CGCG 224-065',NULL,'2013AJ....146...86T',2013,1,0.96,NULL,'G',0.00007,NULL,'14.8g',0.65,'E','Group member',NULL,NULL,NULL,1,247.764208333,39.83847,0,NULL,59854531837,935227059,14612922,14.8),(138097,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138097,35.66,0.16,135,66083,70,NULL,NULL,'CGCG 224-065',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138098,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138098,37.63,0.33,335,66084,70,NULL,NULL,'SDSS J163104.62+245719.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000175,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,247.76925,24.95553,0.109,NULL,56177022145,877765971,13715093,18),(138099,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138099,37.41,0.33,303,66085,70,NULL,NULL,'2MASX J16310613+2715246',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.775417,27.25692,0.105,NULL,56181701551,877839086,13716235,17.6),(138100,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138100,38,0.33,399,66086,70,NULL,NULL,'2MASX J16310648+1221054',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.7769583,12.35147,0.197,NULL,56876547014,888696047,13885875,17.8),(138101,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138101,37.17,0.27,271,66087,70,NULL,NULL,'SDSS J163106.65+284749.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,247.77775,28.79697,0.057,NULL,59731840773,933310012,14582968,17.6),(138102,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138102,37.28,0.45,285,66088,NULL,NULL,'Malmquist cor.','FGC 2041',NULL,'2009ApJS..182..474S',2009,1,0.51,NULL,'G',0.000196,NULL,'17.7g',0.13,'Sc','Group non-member, background',NULL,NULL,NULL,1,247.7784583,39.43044,0,NULL,59821535456,934711491,14604867,17.7),(138103,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138103,37.43,0.42,306,66088,NULL,NULL,NULL,'FGC 2041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138104,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138104,37.47,0.2,312,66088,74.4,NULL,NULL,'FGC 2041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138105,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138105,35.76,0.06,142,66089,70,NULL,NULL,'III Zw 085',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00007,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,247.7784583,40.93306,0,NULL,59854709708,935229839,14612966,16.6),(138106,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138106,35.43,0.25,122,66090,74.4,NULL,NULL,'GIN 587',NULL,'2013AJ....146...86T',2013,1,0.56,NULL,'G',0.000097,NULL,'16.1g',0.48,'S',NULL,NULL,NULL,NULL,1,247.7792917,39.20531,0,NULL,59822626750,934728542,14605133,16.1),(138107,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138107,35.66,0.16,135,66090,70,NULL,NULL,'GIN 587',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138108,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138108,38,0.33,399,66091,70,NULL,NULL,'2MASX J16310961+1222025',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,247.79,12.36747,0.197,NULL,56876532752,888695824,13885872,17.7),(138109,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138109,35.92,0.46,152,66092,70,NULL,NULL,'2MASX J16310965+3725204',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000156,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,247.790417,37.42239,0,NULL,59819460166,934679065,14604360,16.7),(138110,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138110,38.12,0.46,421,66093,70,NULL,NULL,'SDSS J163109.73+123647.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.6g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,247.790583,12.61325,0.189,NULL,56876478759,888694980,13885859,18.6),(138111,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138111,36.3,0.19,182,66094,70,NULL,NULL,'2MASX J16311030+2536146',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000173,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,247.7929583,25.60408,0.077,NULL,56186146026,877908531,13717320,17),(138112,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138112,36.52,0.46,202,66095,70,NULL,NULL,'2MASX J16311207+1546025',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00016,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,247.800333,15.76736,0.201,NULL,56672288639,885504509,13836007,16.7),(138113,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138113,37.96,0.46,391,66096,70,NULL,NULL,'SDSS J163113.74+490856.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000155,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,247.8072917,49.149,0,NULL,59829030176,934828596,14606696,18.3),(138114,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138114,35.76,0.06,142,66097,70,NULL,NULL,'2MASX J16311634+3952334',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000113,NULL,'15.8g',0.43,'S',NULL,NULL,NULL,NULL,1,247.8180417,39.87597,0,NULL,59854533273,935227082,14612923,15.8),(138115,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138115,37.1,0.33,263,66098,70,NULL,NULL,'2MASX J16311707+2351167',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,247.821083333,23.85461,0.145,NULL,56650052066,885157063,13830579,17.3),(138116,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138116,37.79,0.46,361,66099,70,NULL,NULL,'2MASX J16311749+4033113',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,247.823125,40.55314,0,NULL,59854814462,935231475,14612991,17.7),(138117,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138117,35.53,0.72,128,66100,70,NULL,NULL,'2MASX J16311764-7717448',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,247.8235,-77.29586,0.429,NULL,44133475506,689585554,10774774,16.8),(138118,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138118,35.66,0.16,135,66101,70,NULL,NULL,'CGCG 224-067',NULL,'2001MNRAS.321..277C',2001,1,0.6,NULL,'G',0.000077,NULL,'15.1g',0.56,'E',NULL,NULL,NULL,NULL,1,247.83,39.15081,0,NULL,59822635661,934728682,14605135,15.1),(138119,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138119,35.7,0.23,138,66101,74.4,NULL,NULL,'CGCG 224-067',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138120,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138120,35.76,0.06,142,66101,70,NULL,NULL,'CGCG 224-067',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138121,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138121,35.76,0.06,142,66102,70,NULL,NULL,'2MASX J16311927+3944383',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000117,NULL,'15.5g',0.45,'E',NULL,NULL,NULL,NULL,1,247.8302917,39.74414,0,NULL,59854309272,935223582,14612868,15.5),(138122,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138122,37.5,0.46,316,66103,70,NULL,NULL,'2MASX J16311975+3353537',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000135,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,247.832375,33.89831,0.029,NULL,59756312476,933692382,14588943,17.1),(138123,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138123,38.15,0.33,426,66104,70,NULL,NULL,'SDSS J163120.41+252509.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000137,NULL,'18.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,247.835083,25.41942,0.077,NULL,56185113747,877892402,13717068,18.5),(138124,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138124,38.17,0.46,431,66105,70,NULL,NULL,'2MASX J16312063+2501372',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000134,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,247.8360417,25.02706,0.081,NULL,56177139739,877767808,13715122,18.2),(138125,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138125,36.16,0.46,170,66106,70,NULL,NULL,'2MASX J16312103+2652552',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000172,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,247.83775,26.88189,0.125,NULL,56182970475,877858913,13716545,16.5),(138126,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138126,32.14,0.4,26.8,66107,75,NULL,NULL,'NGC 6168',NULL,'2008Ap.....51..336K',2008,1,0.9,'Position is for SDSS J163121.30+201105.8.','G',0.000013,NULL,'14.7g',0.45,'Sdm:',NULL,NULL,NULL,NULL,1,247.83875,20.18494,0.221,NULL,56703143979,885986624,13843541,14.7),(138127,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138127,32.38,0.43,29.9,66107,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6168',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138128,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138128,32.49,0.43,31.5,66107,75,NULL,'3.6 micron, color corrected','NGC 6168',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138129,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138129,32.6,0.2,33.1,66107,74.4,NULL,NULL,'NGC 6168',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138130,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138130,32.98,0.49,39.5,66107,75,NULL,'IR','NGC 6168',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138131,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138131,35.75,0.25,141,66108,74.4,NULL,NULL,'MCG +07-34-108',NULL,'2013AJ....146...86T',2013,1,0.71,NULL,'G',0.0001,NULL,'15.5g',0.26,'S0',NULL,NULL,NULL,NULL,1,247.844083,39.16783,0,NULL,59822635929,934728686,14605135,15.5),(138132,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138132,38.15,0.33,426,66109,70,NULL,NULL,'2MASX J16312281+2523502',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000185,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,247.845,25.39719,0.077,NULL,56185111757,877892371,13717068,17.5),(138133,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138133,37.82,0.46,367,66110,70,NULL,NULL,'2MASX J16312448+2638122',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000148,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,247.852208333,26.63672,0.097,NULL,56186405599,877912587,13717384,17.6),(138134,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138134,37.63,0.33,335,66111,70,NULL,NULL,'2MASX J16312468+2503102',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000187,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,247.852875,25.05272,0.081,NULL,56177184897,877768514,13715133,16.2),(138135,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138135,35.4,0.46,120,66112,70,NULL,NULL,'MCG +08-30-020',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00017,NULL,'15.0g',0.67,'E0',NULL,NULL,NULL,NULL,1,247.856416667,46.32414,0,NULL,59841166504,935018226,14609659,15),(138136,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138136,37.39,0.46,301,66113,70,NULL,NULL,'2MASX J16312732-0001536',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000093,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,247.863833,-0.03144,0.309,NULL,45164479445,705694991,11026484,17.6),(138137,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138137,37.41,0.33,303,66114,70,NULL,NULL,'2MASX J16312827+2712102',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'18.27',0.37,NULL,NULL,NULL,NULL,NULL,1,247.867917,27.20289,0.129,NULL,56181715458,877839304,13716239,18.27),(138138,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138138,38.88,0.46,597,66115,70,NULL,NULL,'SDSS J163128.60+413202.6',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000132,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,247.869167,41.53408,0,NULL,59858851883,935294560,14613977,18),(138139,'GRB','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138139,45.75,1.59,3620,66116,100,NULL,NULL,'GRB 050401',2.8992,'2009EPJC...63..139W',2009,1,NULL,NULL,'G',0.0004,NULL,'16.8',NULL,'Swift',NULL,NULL,NULL,NULL,1,247.870167,2.18736,0.241,NULL,56709418389,886084662,13845072,16.8),(138140,'GRB','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138140,45.9,1.53,3880,66116,100,NULL,NULL,'GRB 050401',2.8992,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138141,'GRB','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138141,45.94,0.55,3950,66116,69.7,NULL,'Calibrated','GRB 050401',2.8992,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138142,'GRB','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138142,46.15,0.53,4360,66116,69.7,NULL,'Fiducial','GRB 050401',2.8992,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138143,'GRB','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138143,46.52,0.59,5160,66116,72,NULL,NULL,'GRB 050401',2.8992,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138144,'GRB','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138144,46.67,0.59,5530,66116,70,NULL,NULL,'GRB 050401',2.8992,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138145,'GRB','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138145,47.37,0.7,7640,66116,NULL,NULL,NULL,'GRB 050401',2.8992,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138146,'GRB','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138146,46.5,0.42,20000,66116,NULL,NULL,NULL,'GRB 050401',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138147,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138147,35.76,0.06,142,66117,70,NULL,NULL,'CGCG 224-069',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.00008,NULL,'15.1g',0.42,'E','Group member',NULL,NULL,NULL,1,247.882083,39.89767,0,NULL,59854527429,935226991,14612921,15.1),(138148,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138148,38.41,0.23,481,66118,70,NULL,NULL,'2MASX J16313235+2131366',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000183,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,247.884625,21.52692,0.137,NULL,56695631642,885869244,13841706,16.6),(138149,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138149,36.94,0.14,244,66119,70,NULL,NULL,'2MASX J16313244+1339495',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000178,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,247.885291667,13.66383,0.185,NULL,56877570031,888712031,13886125,17.1),(138150,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138150,38.41,0.23,481,66120,70,NULL,NULL,'SDSS J163133.45+212959.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000165,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,247.889375,21.49992,0.137,NULL,56695658787,885869668,13841713,18.3),(138151,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138151,35.81,0.06,146,66121,NULL,NULL,NULL,'NGC 6184',NULL,'2009ApJS..182..474S',2009,1,0.92,'Pos in 1984AnTok..192.595T is wrong.  1997AJ....113...22G has V = 9279 km/s.','G',0.000113,NULL,'14.5g',0.55,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,247.893875,40.56561,0,NULL,59854812105,935231439,14612991,14.5),(138152,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138152,34.43,0.57,76.9,66122,NULL,NULL,'Malmquist cor.','ESO 069- G 005',NULL,'2009ApJS..182..474S',2009,1,1.37,NULL,'G',0.000033,NULL,'14.65',0.16,'Sc',NULL,NULL,NULL,NULL,1,247.89725,-67.86794,0.449,NULL,45027492600,703554571,10993040,14.65),(138153,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138153,34.43,0.49,77.1,66122,75,NULL,'IR','ESO 069- G 005',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138154,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138154,34.57,NULL,82,66122,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 069- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138155,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138155,34.58,NULL,82.6,66122,NULL,NULL,'Dipole + Quadrupole','ESO 069- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138156,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138156,34.59,NULL,82.7,66122,NULL,NULL,'Dipole','ESO 069- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138157,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138157,34.6,0.53,83.2,66122,NULL,NULL,NULL,'ESO 069- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138158,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138158,34.64,0.2,84.7,66122,74.4,NULL,NULL,'ESO 069- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138159,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138159,34.15,0.2,67.6,66123,74.4,NULL,NULL,'CGCG 080-043 NED01',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000081,NULL,'15.9g',0.22,'WR?            HII',NULL,NULL,NULL,NULL,1,247.899125,13.63714,0.185,NULL,56877576285,888712129,13886127,15.9),(138160,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138160,37.1,0.33,263,66124,70,NULL,NULL,'2MASX J16313729+2356076',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000176,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,247.905375,23.93553,0.145,NULL,56650096009,885157750,13830589,17.1),(138161,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138161,38.04,0.46,405,66125,70,NULL,NULL,'2MASX J16313853+3530297',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000175,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,247.91075,35.50828,0,NULL,59749240425,933581881,14587216,17.1),(138162,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138162,37.12,0.46,265,66126,70,NULL,NULL,'2MASX J16313980-0009418',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00007,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,247.91575,-0.16169,0.309,NULL,45164490938,705695170,11026487,17.6),(138163,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138163,36.74,0.33,223,66127,70,NULL,NULL,'2MASX J16314057+4226555',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00012,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,247.9190417,42.44875,0,NULL,59858327675,935286369,14613849,16.4),(138164,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138164,34.53,0.39,80.5,66128,NULL,NULL,'Malmquist cor.','NGC 6189',NULL,'2009ApJS..182..474S',2009,1,1.9,NULL,'G',0.000017,NULL,'13.36',0.9,'Scd:','Field galaxy',NULL,NULL,NULL,1,247.920417,59.62611,0,NULL,57653373277,900833957,14075530,13.36),(138165,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138165,34.56,0.2,81.7,66128,74.4,NULL,NULL,'NGC 6189',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138166,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138166,34.63,0.37,84.5,66128,NULL,NULL,NULL,'NGC 6189',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138167,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138167,36.37,0.25,188,66129,74.4,NULL,NULL,'GIN 606',NULL,'2013AJ....146...86T',2013,1,0.58,NULL,'G',0.00008,NULL,'14.50',0.41,'S',NULL,NULL,NULL,NULL,1,247.927,50.16775,0,NULL,59829160562,934830633,14606728,14.5),(138168,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138168,36.58,0.21,207,66129,70,NULL,NULL,'GIN 606',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138169,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138169,34.76,0.2,89.5,66130,74.4,NULL,NULL,'CGCG 109-029',NULL,'2013AJ....146...86T',2013,1,0.45,NULL,'G',0.0001,NULL,'15.7',0.4,'Sd',NULL,NULL,NULL,NULL,1,247.9272083,18.65064,0.253,NULL,56704100615,886001572,13843774,15.7),(138170,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138170,38.09,0.46,415,66131,70,NULL,NULL,'2MASX J16314259+2942132',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,247.9274583,29.70378,0.045,NULL,59732048492,933313257,14583019,17.7),(138171,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138171,36.94,0.14,244,66132,70,NULL,NULL,'2MASX J16314268+1338078',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,247.927833,13.63556,0.185,NULL,56877579831,888712184,13886127,17),(138172,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138172,36.58,0.21,207,66133,70,NULL,NULL,'2MASX J16314270+5014128',NULL,'2001MNRAS.321..277C',2001,1,0.56,NULL,'G',NULL,NULL,'15.7g',0.55,NULL,NULL,NULL,NULL,NULL,1,247.927791667,50.23669,0,NULL,59829172710,934830823,14606731,15.7),(138173,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138173,37.14,0.23,268,66134,70,NULL,NULL,'2MASX J16314282+2533102',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000175,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,247.928417,25.55283,0.077,NULL,56185065570,877891649,13717057,17.2),(138174,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138174,36.94,0.14,244,66135,70,NULL,NULL,'2MASX J16314489+1322338',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00015,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,247.9369583,13.37594,0.185,NULL,56878015255,888718988,13886234,17.1),(138175,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138175,36.94,0.14,244,66136,70,NULL,NULL,'2MASX J16314487+1340548',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000153,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,247.937083,13.68189,0.185,NULL,56877578608,888712165,13886127,17.4),(138176,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138176,38.49,0.46,500,66137,70,NULL,NULL,'2MASX J16314528+2621011',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000171,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,247.938625,26.35033,0.097,NULL,56186517654,877914338,13717411,17.8),(138177,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138177,37.93,0.19,386,66138,70,NULL,NULL,'2MASX J16314628+1303198',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00017,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,247.943,13.05542,0.185,NULL,56878090836,888720169,13886252,18),(138178,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138178,37.14,0.23,268,66139,70,NULL,NULL,'2MASX J16314664+2535441',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00019,NULL,'16.3g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,247.944417,25.59558,0.077,NULL,56186163631,877908806,13717325,16.3),(138179,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138179,37.93,0.19,386,66140,70,NULL,NULL,'SDSS J163147.26+130305.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'17.8g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,247.946917,13.0515,0.185,NULL,56878090828,888720169,13886252,17.8),(138180,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138180,36.98,0.46,249,66141,70,NULL,NULL,'2MASX J16314887+4547315',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00015,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,247.9535,45.79203,0,NULL,59840333985,935005218,14609456,17.1),(138181,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138181,38.31,0.46,460,66142,70,NULL,NULL,'SDSS J163149.98+124406.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000132,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,247.95825,12.73522,0.185,NULL,56876609144,888697017,13885890,18.7),(138182,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138182,37.14,0.23,268,66143,70,NULL,NULL,'2MASX J16315057+2526511',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000189,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,247.960666667,25.4475,0.077,NULL,56185072117,877891751,13717058,17),(138183,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138183,37.14,0.23,268,66144,70,NULL,NULL,'2MASX J16315234+2526271',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,'FoF','17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.968083,25.44081,0.077,NULL,56185073114,877891767,13717058,17.3),(138184,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138184,37.15,0.46,269,66145,70,NULL,NULL,'2MASX J16315260+3027586',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000142,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,247.9692917,30.46625,0.037,NULL,59786483333,934163802,14596309,17.6),(138185,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138185,37.26,0.46,283,66146,70,NULL,NULL,'2MASX J16315429+2140486',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000146,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,247.976125,21.68014,0.145,NULL,56695641004,885869390,13841709,17.3),(138186,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138186,38.47,0.46,494,66147,70,NULL,NULL,'SDSS J163155.68+233236.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000134,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,247.982041667,23.5435,0.129,NULL,56652069153,885188580,13831071,18.5),(138187,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138187,36.73,0.17,221,66148,70,NULL,NULL,'2MASX J16315669+1128588',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,247.9862917,11.48306,0.221,NULL,56743524062,886617563,13853399,17),(138188,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138188,37.35,0.46,295,66149,70,NULL,NULL,'2MASXi J1631581+144026',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000168,NULL,'16.8g',0.29,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,247.991916667,14.67397,0.193,NULL,56877102317,888704723,13886011,16.8),(138189,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138189,37,0.46,251,66150,70,NULL,NULL,'2MASX J16315966+2428552',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000182,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,247.998708333,24.48206,0.113,NULL,56176872897,877763639,13715056,16.8),(138190,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138190,34.11,0.2,66.4,66151,74.4,NULL,NULL,'ESO 452- G 006',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000023,NULL,'13.61',0.3,'S              HII',NULL,NULL,NULL,NULL,1,248.001917,-29.55467,0.961,NULL,46247346559,722614789,11290856,13.61),(138191,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138191,34.22,0.49,69.7,66151,75,NULL,'IR','ESO 452- G 006',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138192,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138192,34.49,0.48,79,66151,NULL,NULL,'Malmquist cor.','ESO 452- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138193,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138193,34.53,0.4,80.5,66151,NULL,NULL,'mean','ESO 452- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138194,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138194,34.56,0.47,81.5,66151,NULL,NULL,NULL,'ESO 452- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138195,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138195,34.72,0.47,87.7,66151,NULL,NULL,'H','ESO 452- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138196,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138196,38.1,0.46,416,66152,70,NULL,NULL,'SDSS J163202.25+430600.5',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000088,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,248.009417,43.10014,0.009,NULL,59859581630,935305962,14614155,17.6),(138197,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138197,36.94,0.14,244,66153,70,NULL,NULL,'2MASXi J1632023+133552',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000161,NULL,'17.9g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,248.0097917,13.59808,0.185,NULL,56877547269,888711676,13886119,17.9),(138198,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138198,38.57,0.46,517,66154,70,NULL,NULL,'SDSS J163202.41+365613.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,248.010083,36.93708,0,NULL,59751299913,933614061,14587719,18.1),(138199,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138199,37.93,0.19,386,66155,70,NULL,NULL,'2MASX J16320346+1243328',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,248.0142917,12.72592,0.185,NULL,56876651508,888697679,13885901,17.6),(138200,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138200,37.8,0.46,363,66156,70,NULL,NULL,'2MASX J16320380+2226429',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000137,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,248.01575,22.44533,0.149,NULL,56650716749,885167449,13830741,18.3),(138201,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138201,37.2,0.46,275,66157,70,NULL,NULL,'2MASX J16320426+2929172',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,248.0177917,29.48797,0.045,NULL,59731964994,933311953,14582999,17.5),(138202,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138202,36.42,0.46,192,66158,70,NULL,NULL,'2MASX J16320442+4745531',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,248.01825,47.76478,0,NULL,59844206851,935065732,14610402,16.6),(138203,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138203,37.92,0.46,383,66159,70,NULL,NULL,'2MASX J16320467+2150479',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000182,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,248.0195,21.84656,0.149,NULL,56696311713,885879870,13841872,16.9),(138204,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138204,36.94,0.14,244,66160,70,NULL,NULL,'CGCG 080-045',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000173,NULL,'15.2g',NULL,NULL,NULL,NULL,NULL,NULL,1,248.021875,13.64725,0.185,NULL,56877536577,888711509,13886117,15.2),(138205,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138205,36.58,0.21,207,66161,70,NULL,NULL,'GIN 603',NULL,'2001MNRAS.321..277C',2001,1,0.57,NULL,'G',NULL,NULL,'15.5g',0.46,'S',NULL,NULL,NULL,NULL,1,248.023583,50.37956,0,NULL,59831283010,934863797,14607246,15.5),(138206,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138206,37.38,0.46,300,66162,70,NULL,NULL,'2MASX J16320771+4910416',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000183,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,248.032083,49.17814,0,NULL,59828951475,934827366,14606677,16.3),(138207,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138207,37.53,0.46,320,66163,70,NULL,NULL,'I Zw 155',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000087,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,248.0362083,37.98111,0,NULL,59822990916,934734233,14605222,16.8),(138208,'IRAS','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138208,33.57,0.8,51.7,66164,75,NULL,'MAT, I','ESO 452- G 007',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.000017,NULL,'11.46',1,'(R\'_1)SAB(s)a',NULL,NULL,NULL,NULL,1,248.049667,-28.09192,1.081,NULL,45776406228,715256347,11175880,11.46),(138209,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138209,33.21,0.2,43.9,66164,74.4,NULL,NULL,'ESO 452- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138210,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138210,33.87,0.43,59.5,66164,75,NULL,'MAT, I, raw','ESO 452- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138211,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138211,34.07,0.32,65.1,66164,85,NULL,'I, raw','ESO 452- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138212,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138212,34.16,0.32,68,66164,85,NULL,'I, inv','ESO 452- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138213,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138213,34.22,0.43,69.9,66164,75,NULL,'MAT, I, cor','ESO 452- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138214,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138214,34.25,0.43,70.7,66164,75,NULL,'MAT, I, inv','ESO 452- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138215,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138215,36.7,0.46,219,66165,70,NULL,NULL,'2MASX J16321209-0018141',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000089,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,248.0505,-0.30406,0.309,NULL,45164474644,705694916,11026483,16.8),(138216,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138216,37.93,0.19,386,66166,70,NULL,NULL,'2MASX J16321325+1243407',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000205,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,248.055291667,12.72792,0.181,NULL,56876638010,888697468,13885897,16.7),(138217,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138217,36.94,0.14,244,66167,70,NULL,NULL,'2MASX J16321384+1351527',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000165,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,248.0575,13.86469,0.189,NULL,56877581959,888712218,13886128,17),(138218,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138218,36.89,0.46,239,66168,70,NULL,NULL,'2MASX J16321639+2715451',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,248.068333333,27.26242,0.129,NULL,56181672090,877838626,13716228,17.5),(138219,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138219,36.38,0.25,189,66169,74.4,NULL,NULL,'MCG +08-30-023',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00007,NULL,'14.33',0.4,'S',NULL,NULL,NULL,NULL,1,248.069208333,50.18936,0,NULL,59831242637,934863166,14607236,14.33),(138220,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138220,36.58,0.21,207,66169,70,NULL,NULL,'MCG +08-30-023',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138221,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138221,36.94,0.14,244,66170,70,NULL,NULL,'2MASX J16321736+1335427',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000191,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,248.0725,13.59533,0.185,NULL,56877533042,888711453,13886116,16.5),(138222,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138222,37.04,0.46,256,66171,70,NULL,NULL,'2MASX J16321761+3150227',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000154,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,248.073375,31.83967,0.029,NULL,59789293704,934207714,14596995,16.9),(138223,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138223,35.76,0.06,142,66172,70,NULL,NULL,'2MASX J16321980+4034304',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000077,NULL,'15.2g',0.34,'S0',NULL,NULL,NULL,NULL,1,248.082458333,40.57506,0,NULL,59854752630,935230509,14612976,15.2),(138224,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138224,36.94,0.14,244,66173,70,NULL,NULL,'2MASX J16322003+1340577',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,248.083625,13.68264,0.185,NULL,56877608665,888712635,13886134,17),(138225,'IRAS','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138225,32.75,0.8,35.5,66174,75,NULL,'A82, H','NGC 6181',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000013,NULL,'12.49',1.1,'SA(rs)c        HII','Isolated galaxy (6 Mpc isolation)',NULL,NULL,NULL,1,248.087333333,19.82656,0.229,NULL,56706716139,886042439,13844413,12.49),(138226,'IRAS','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138226,32.75,0.8,35.5,66174,75,NULL,'CF, r','NGC 6181',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138227,'Sosies','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138227,32.72,0.08,35,66174,NULL,NULL,NULL,'NGC 6181',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138228,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138228,31.7,0.4,21.9,66174,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 6181',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138229,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138229,31.94,0.69,24.5,66174,100,NULL,'mid-IR','NGC 6181',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138230,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138230,32.06,0.47,25.8,66174,75,NULL,'A82, H, raw','NGC 6181',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138231,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138231,32.2,0.47,27.6,66174,75,NULL,'A82, H, inv','NGC 6181',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138232,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138232,32.46,0.43,31.1,66174,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6181',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138233,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138233,32.5,0.47,31.6,66174,75,NULL,'A82, H, cor','NGC 6181',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138234,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138234,32.53,0.43,32.1,66174,75,NULL,'3.6 micron, color corrected','NGC 6181',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138235,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138235,32.57,0.46,32.6,66174,NULL,NULL,'J','NGC 6181',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138236,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138236,32.59,0.47,33,66174,NULL,NULL,'H','NGC 6181',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138237,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138237,32.62,0.45,33.4,66174,NULL,NULL,'K','NGC 6181',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138238,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138238,32.62,0.4,33.4,66174,NULL,NULL,'mean','NGC 6181',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138239,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138239,32.63,0.36,33.6,66174,NULL,NULL,NULL,'NGC 6181',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138240,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138240,32.64,0.38,33.7,66174,75,NULL,'CF, r, raw','NGC 6181',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138241,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138241,32.76,0.2,35.7,66174,74.4,NULL,NULL,'NGC 6181',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138242,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138242,32.8,0.68,36.2,66174,NULL,NULL,'Malmquist cor.','NGC 6181',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138243,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138243,32.81,0.38,36.4,66174,75,NULL,'CF, r, inv','NGC 6181',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138244,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138244,32.82,0.4,36.7,66174,75,NULL,'B','NGC 6181',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138245,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138245,32.88,0.38,37.7,66174,75,NULL,'CF, r, cor','NGC 6181',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138246,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138246,33.1,0.59,41.7,66174,NULL,NULL,NULL,'NGC 6181',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138247,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138247,37.33,0.46,292,66175,70,NULL,NULL,'2MASX J16322371+2630541',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000182,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,248.098791667,26.51511,0.097,NULL,56183092807,877860825,13716575,17.7),(138248,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138248,37.16,0.46,271,66176,70,NULL,NULL,'2MASX J16322473+2411132',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000191,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,248.103,24.18717,0.121,NULL,56176708676,877761073,13715016,16.9),(138249,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138249,37.88,0.46,377,66177,70,NULL,NULL,'SDSS J163224.99+321047.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,248.104167,32.17989,0.041,NULL,59754453973,933663343,14588489,18.3),(138250,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138250,38.35,0.46,467,66178,70,NULL,NULL,'2MASX J16322504+2648482',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,248.104333333,26.81342,0.125,NULL,56183181775,877862215,13716597,18.2),(138251,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138251,37.69,0.46,345,66179,70,NULL,NULL,'SDSS J163226.15+250706.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000125,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,248.1089583,25.11844,0.109,NULL,56177157238,877768081,13715126,18),(138252,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138252,38.01,0.46,399,66180,70,NULL,NULL,'2MASX J16322666+2719212',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,248.111125,27.32247,0.129,NULL,56181670251,877838597,13716228,17.6),(138253,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138253,36.64,0.46,213,66181,70,NULL,NULL,'2MASX J16323009-0005131',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000081,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,248.125375,-0.087,0.313,NULL,45164408958,705693889,11026467,16.8),(138254,'SZ effect','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138254,38.8,NULL,575,66182,NULL,NULL,NULL,'ABELL 2205',NULL,'2012ApJ...748..113H',2012,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,248.1315417,12.87833,0.181,NULL,56876190086,888690470,13885788,NULL),(138255,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138255,34.95,0.4,97.6,66183,NULL,NULL,'mean','NGC 6251',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000073,NULL,'8.0 R',1.5,'E;LERG         Sy2','Pair member, radial velocity confirmed',NULL,'FR I','unobscured Seyfert 2',1,248.133208333,82.53789,0.297,NULL,56954771155,889918299,13904973,8),(138256,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138256,34.97,0.45,98.8,66183,NULL,NULL,'K','NGC 6251',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138257,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138257,37.93,0.19,386,66184,70,NULL,NULL,'2MASX J16323287+1252438',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000175,NULL,'17.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,248.136917,12.87886,0.181,NULL,56876160625,888690009,13885781,17.5),(138258,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138258,36.94,0.2,244,66185,74.4,NULL,NULL,'CGCG 138-036',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.000133,NULL,'15.5g',0.32,'Sa',NULL,NULL,NULL,NULL,1,248.140833333,26.38069,0.097,NULL,56183499574,877867180,13716674,15.5),(138259,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138259,34.91,NULL,96.1,66186,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10452',NULL,'2010Ap&SS.325..163P',2010,1,1.12,NULL,'G',NULL,NULL,'16.5',0.12,'Sbc',NULL,NULL,NULL,NULL,1,248.142125,67.74669,0.173,NULL,57838223069,903722235,14120659,16.5),(138260,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138260,34.93,NULL,96.8,66186,NULL,NULL,'Dipole + Quadrupole','UGC 10452',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138261,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138261,34.94,NULL,97.2,66186,NULL,NULL,'Dipole','UGC 10452',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138262,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138262,34.97,NULL,98.8,66186,NULL,NULL,NULL,'UGC 10452',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138263,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138263,37.28,0.46,286,66187,70,NULL,NULL,'2MASX J16323549+0941309',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,248.1479583,9.692,0.245,NULL,56756608852,886822013,13856593,17.5),(138264,'IRAS','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138264,33.93,0.8,61,66188,75,NULL,'MAT, I','ESO 452- G 008',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'13.62',0.3,'Sd? sp',NULL,NULL,NULL,NULL,1,248.1514583,-29.38494,0.965,NULL,46246522623,722601915,11290654,13.62),(138265,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138265,33.19,0.32,43.5,66188,85,NULL,'I, raw','ESO 452- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138266,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138266,33.2,0.32,43.7,66188,85,NULL,'I, inv','ESO 452- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138267,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138267,33.21,0.2,43.9,66188,74.4,NULL,NULL,'ESO 452- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138268,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138268,33.25,0.43,44.7,66188,75,NULL,'MAT, I, raw','ESO 452- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138269,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138269,33.35,0.43,46.7,66188,75,NULL,'MAT, I, inv','ESO 452- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138270,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138270,33.76,0.49,56.4,66188,75,NULL,'IR','ESO 452- G 008',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138271,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138271,33.81,0.43,57.8,66188,75,NULL,'MAT, I, cor','ESO 452- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138272,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138272,38.28,0.46,452,66189,70,NULL,NULL,'2MASX J16323642+2122170',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,248.151833333,21.37131,0.169,NULL,56696429170,885881705,13841901,17.8),(138273,'GRB','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138273,41.29,NULL,1810,66190,70,NULL,'Pseudo z = 0.57','GRB 010629A',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,248.16,-18.72,0.957,NULL,45967656895,718244638,11222572,NULL),(138274,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138274,31.74,NULL,22.3,66191,65.2,NULL,'CO','NGC 6217',NULL,'1997A&A...326..915T',1997,1,3,NULL,'G',0.000013,NULL,'11.79',2.5,'(R)SB(rs)bc;HIISy2','Group member',NULL,NULL,'H II',1,248.163333,78.19817,0.137,NULL,57138579630,892790306,13949848,11.79),(138275,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138275,31.89,0.4,23.9,66191,75,NULL,'B','NGC 6217',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138276,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138276,32.73,NULL,35.2,66191,54,NULL,'HI','NGC 6217',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138277,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138277,37.22,0.46,278,66192,70,NULL,NULL,'2MASX J16324065+1453285',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,248.169541667,14.89128,0.193,NULL,56876871829,888701122,13885955,17.5),(138278,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138278,38.13,0.46,423,66193,70,NULL,NULL,'2MASX J16324179+3107101',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,248.174208333,31.1195,0.033,NULL,59786043786,934156934,14596202,17.7),(138279,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138279,35.1,0.54,105,66194,70,NULL,NULL,'2MASX J16324321-0228467',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000107,NULL,'16.12',NULL,NULL,NULL,NULL,NULL,NULL,1,248.1800417,-2.47978,0.573,NULL,46039987332,719374802,11240231,16.12),(138280,'SZ effect','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138280,38.31,0.48,460,66195,NULL,NULL,'Isotherm., r < 100 kpc','ABELL 2204',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',0.000307,NULL,NULL,NULL,'II     [BM]',NULL,NULL,NULL,NULL,1,248.19375,5.57056,0.333,NULL,56717837275,886216207,13847128,NULL),(138281,'SZ effect','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138281,38.7,NULL,550,66195,NULL,NULL,NULL,'ABELL 2204',NULL,'2011A&A...532A..14C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138282,'SZ effect','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138282,38.93,0.23,610,66195,NULL,NULL,'Hydrost. Eq.','ABELL 2204',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138283,'SZ effect','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138283,40.17,0.43,1080,66195,NULL,NULL,'Isotherm.','ABELL 2204',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138284,'SZ effect','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138284,40.43,NULL,1220,66195,NULL,NULL,'3.1 (red) calibration','ABELL 2204',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138285,'SZ effect','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138285,41.01,NULL,1590,66195,NULL,NULL,'4.2 (black) calibration','ABELL 2204',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138286,'SZ effect','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138286,41.23,NULL,1760,66195,NULL,NULL,'4.1 (blue) calibration','ABELL 2204',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138287,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138287,38.45,0.46,489,66196,70,NULL,NULL,'2MASX J16324578+4122483',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,248.190625,41.38,0,NULL,59858870678,935294854,14613982,17.5),(138288,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138288,36.73,0.17,221,66197,70,NULL,NULL,'2MASX J16324743+1153466',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,248.19775,11.89639,0.213,NULL,56742753174,886605518,13853211,17.5),(138289,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138289,36.73,0.17,221,66198,70,NULL,NULL,'2MASX J16325063+1152036',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'16.77',0.37,NULL,NULL,NULL,NULL,NULL,1,248.211125,11.86772,0.189,NULL,56742751482,886605491,13853210,16.77),(138290,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138290,37.31,0.46,289,66199,70,NULL,NULL,'2MASX J16325087+1236475',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000147,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,248.2119583,12.61319,0.185,NULL,56876819966,888700311,13885942,17.4),(138291,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138291,37.94,0.46,387,66200,70,NULL,NULL,'2MASX J16325114+1223595',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,248.213291667,12.39975,0.185,NULL,56876807575,888700118,13885939,17.5),(138292,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138292,37.02,0.33,253,66201,70,NULL,NULL,'2MASX J16325305+4310331',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000069,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,248.221125,43.17594,0.009,NULL,59859596987,935306202,14614159,17.6),(138293,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138293,36.73,0.17,221,66202,70,NULL,NULL,'2MASX J16325526+1142386',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'17.16',0.36,NULL,NULL,NULL,NULL,NULL,1,248.230291667,11.71069,0.201,NULL,56742900689,886607823,13853247,17.16),(138294,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138294,37.02,0.33,253,66203,70,NULL,NULL,'2MASX J16325588+4315401',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000078,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,248.23275,43.26103,0.009,NULL,59859563344,935305677,14614151,16.9),(138295,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138295,35.84,0.46,147,66204,70,NULL,NULL,'2MASX J16325590+2356448',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.00011,NULL,'15.4g',0.49,'E0',NULL,NULL,NULL,NULL,1,248.233,23.94589,0.121,NULL,56649879888,885154373,13830537,15.4),(138296,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138296,36.58,0.21,207,66205,70,NULL,NULL,'VV 667 NED05',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.00007,NULL,'13.43',NULL,'E/S0',NULL,NULL,NULL,NULL,1,248.23825,50.4015,0,NULL,59831272546,934863633,14607244,13.43),(138297,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138297,36.72,0.46,220,66206,70,NULL,NULL,'2MASX J16325783+4231281',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.0001,NULL,'16.1g',0.32,'E0',NULL,NULL,NULL,NULL,1,248.2412083,42.52467,0,NULL,59858246581,935285102,14613829,16.1),(138298,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138298,37.97,0.46,393,66207,70,NULL,NULL,'2MASX J16325810+3541288',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000136,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,248.242125,35.69125,0.021,NULL,59751188054,933612313,14587692,17.7),(138299,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138299,36.18,0.2,172,66208,74.4,NULL,NULL,'CGCG 080-046',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000137,NULL,'15.2',0.3,'BrClG',NULL,NULL,NULL,NULL,1,248.2432083,11.72158,0.201,NULL,56742903107,886607861,13853247,15.2),(138300,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138300,36.38,0.25,189,66209,74.4,NULL,NULL,'VV 667 NED01',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'GPair',0.000223,NULL,NULL,NULL,'S?','Group member',NULL,NULL,NULL,1,248.244583,50.39861,0,NULL,59831272677,934863635,14607244,NULL),(138301,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138301,35.46,0.46,124,66210,70,NULL,NULL,'2MASX J16325894+2311510',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000103,NULL,'15.0g',0.51,NULL,NULL,NULL,NULL,NULL,1,248.245583333,23.19739,0.145,NULL,56652245465,885191335,13831114,15),(138302,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138302,36.88,0.27,237,66211,70,NULL,NULL,'2MASX J16330064+2613408',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000182,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,248.2527917,26.22808,0.093,NULL,56183404814,877865700,13716651,16.6),(138303,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138303,36.37,0.25,188,66212,74.4,NULL,NULL,'VV 667 NED06',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000073,NULL,'14.79',NULL,'E/S0',NULL,NULL,NULL,NULL,1,248.2537083,50.39506,0,NULL,59831272664,934863635,14607244,14.79),(138304,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138304,36.58,0.21,207,66212,70,NULL,NULL,'VV 667 NED06',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138305,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138305,35.61,0.46,133,66213,70,NULL,NULL,'IC 4609',NULL,'2015arXiv151105856S',2015,1,0.87,NULL,'G',0.000187,NULL,'14.6g',0.8,'E/S0',NULL,NULL,NULL,NULL,1,248.25675,22.79739,0.153,NULL,56651899230,885185925,13831030,14.6),(138306,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138306,37.91,0.46,382,66214,70,NULL,NULL,'2MASX J16330271+3101419',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000187,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,248.26125,31.02819,0.037,NULL,59786066116,934157283,14596207,17.4),(138307,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138307,37.29,0.12,287,66215,70,NULL,NULL,'2MASX J16330324+2647428',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,248.2635,26.79508,0.125,NULL,56183218429,877862787,13716606,17.9),(138308,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138308,36.79,0.55,228,66216,70,NULL,NULL,'2MASX J16330405-0056366',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.000111,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,248.266958333,-0.94367,0.393,NULL,46037332508,719333320,11239583,16.3),(138309,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138309,38.22,0.23,440,66217,70,NULL,NULL,'2MASX J16330563+2701518',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00018,NULL,'16.6g',0.38,'BrClG',NULL,NULL,NULL,NULL,1,248.2735,27.03106,0.129,NULL,56181362408,877833787,13716152,16.6),(138310,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138310,38.22,0.23,440,66218,70,NULL,NULL,'2MASX J16330578+2701398',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,248.274125,27.02778,0.129,NULL,56181362218,877833784,13716152,18.5),(138311,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138311,36.37,0.25,188,66219,74.4,NULL,NULL,'GIN 607',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000077,NULL,'16.1g',0.35,'S',NULL,NULL,NULL,NULL,1,248.275041667,50.53597,0,NULL,59827839280,934809988,14606406,16.1),(138312,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138312,36.58,0.21,207,66219,70,NULL,NULL,'GIN 607',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138313,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138313,37.93,0.19,386,66220,70,NULL,NULL,'2MASX J16330618+1257253',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,248.27575,12.95694,0.193,NULL,56876324777,888692574,13885821,18),(138314,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138314,37.71,0.46,348,66221,70,NULL,NULL,'2MASX J16330744+2448598',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,248.280958333,24.81658,0.093,NULL,56176739131,877761548,13715024,17.6),(138315,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138315,36.88,0.27,237,66222,70,NULL,NULL,'2MASX J16330948+2610318',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,248.289666667,26.17539,0.077,NULL,56183399519,877865617,13716650,17.6),(138316,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138316,36.58,0.21,207,66223,70,NULL,NULL,'GIN 608',NULL,'2001MNRAS.321..277C',2001,1,0.55,NULL,'G',0.000077,NULL,'15.8g',0.48,NULL,NULL,NULL,NULL,NULL,1,248.292375,50.30617,0,NULL,59831271536,934863617,14607244,15.8),(138317,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138317,38.22,0.23,440,66224,70,NULL,NULL,'2MASX J16331072+2701108',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,248.294833,27.01975,0.129,NULL,56181231067,877831735,13716120,17.8),(138318,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138318,37.29,0.12,287,66225,70,NULL,NULL,'2MASX J16331192+2700008',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00016,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,248.299875,27.00019,0.129,NULL,56181231299,877831739,13716120,17.3),(138319,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138319,37.38,0.46,300,66226,70,NULL,NULL,'2MASX J16331349+4615411',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00017,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,248.30625,46.26153,0,NULL,59841138351,935017786,14609652,17),(138320,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138320,36.36,0.25,187,66227,74.4,NULL,NULL,'VV 667 NED02',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.00011,NULL,'13.88',0.8,'BrClG;E/S0','Group member',NULL,NULL,NULL,1,248.30775,50.39847,0,NULL,59831265917,934863529,14607242,13.88),(138321,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138321,36.58,0.21,207,66227,70,NULL,NULL,'VV 667 NED02',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138322,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138322,37.29,0.12,287,66228,70,NULL,NULL,'2MASX J16331428+2642368',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000179,NULL,'16.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,248.309375,26.71033,0.097,NULL,56183130326,877861411,13716584,16.4),(138323,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138323,37.8,0.46,363,66229,70,NULL,NULL,'SDSS J163314.79+370205.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000134,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,248.311667,37.03486,0.025,NULL,59751322588,933614415,14587725,18.4),(138324,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138324,38.06,0.33,410,66230,70,NULL,NULL,'2MASX J16331494+2458248',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,248.312167,24.97353,0.109,NULL,56177538802,877774043,13715219,17.1),(138325,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138325,37.29,0.12,287,66231,70,NULL,NULL,'2MASX J16331757+2642218',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000201,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,248.3232083,26.706,0.097,NULL,56183131006,877861421,13716584,16.3),(138326,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138326,36.94,0.14,244,66232,70,NULL,NULL,'2MASX J16331761+1350283',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00016,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,248.3232917,13.84108,0.189,NULL,56877628572,888712946,13886139,17.1),(138327,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138327,37.31,0.46,290,66233,70,NULL,NULL,'2MASX J16331905+1357083',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000161,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,248.329291667,13.95239,0.209,NULL,56877497880,888710904,13886107,17.3),(138328,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138328,38.06,0.33,410,66234,70,NULL,NULL,'2MASX J16331995+2458048',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000143,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,248.333125,24.96794,0.109,NULL,56177540950,877774077,13715219,18.8),(138329,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138329,38.22,0.23,440,66235,70,NULL,NULL,'2MASX J16331997+2705099',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000165,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,248.333208333,27.08608,0.129,NULL,56181364937,877833827,13716153,18.7),(138330,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138330,36.05,0.46,163,66236,70,NULL,NULL,'2MASX J16332149+2248504',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000187,NULL,'16.1g',0.38,'S0',NULL,NULL,NULL,NULL,1,248.339541667,22.81422,0.153,NULL,56651903025,885185984,13831031,16.1),(138331,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138331,36.73,0.17,221,66237,70,NULL,NULL,'2MASX J16332209+1139102',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.48',0.33,NULL,NULL,NULL,NULL,NULL,1,248.342125,11.65278,0.201,NULL,56742870265,886607347,13853239,17.48),(138332,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138332,37.95,0.46,390,66238,70,NULL,NULL,'SDSS J163322.93+294743.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,248.3455417,29.79544,0.041,NULL,59731328721,933302011,14582843,18.7),(138333,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138333,36.88,0.27,237,66239,70,NULL,NULL,'2MASX J16332377+2558449',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,248.34925,25.97928,0.081,NULL,56183466877,877866669,13716666,17.5),(138334,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138334,37.44,0.46,308,66240,70,NULL,NULL,'2MASX J16332604+2703149',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00021,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,248.358458333,27.05433,0.129,NULL,56181241516,877831898,13716123,16.6),(138335,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138335,38.27,0.46,452,66241,70,NULL,NULL,'2MASX J16332817+3727109',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00015,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,248.367417,37.45297,0.017,NULL,59822840918,934731889,14605185,17.5),(138336,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138336,37.86,0.46,373,66242,70,NULL,NULL,'2MASX J16333022+2136354',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000051,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,248.375916667,21.60969,0.165,NULL,56696460660,885882197,13841909,16.8),(138337,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138337,37.7,0.46,347,66243,70,NULL,NULL,'2MASX J16333035+2738559',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,248.3767083,27.64886,0.129,NULL,56181733717,877839589,13716243,17.3),(138338,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138338,37.19,0.46,274,66244,70,NULL,NULL,'2MASX J16333345+3326392',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000143,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,248.389416667,33.44439,0.041,NULL,59754293535,933660836,14588450,17.3),(138339,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138339,36.73,0.17,221,66245,70,NULL,NULL,'2MASX J16333742+1152561',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,248.4059583,11.88225,0.189,NULL,56742672854,886604263,13853191,NULL),(138340,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138340,36.82,0.46,231,66246,70,NULL,NULL,'2MASX J16333858+2043485',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000182,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,248.4107083,20.73003,0.209,NULL,56703474981,885991796,13843621,16.4),(138341,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138341,36.94,0.14,244,66247,70,NULL,NULL,'2MASX J16333859+1358197',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00017,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,248.4107917,13.97233,0.209,NULL,56877483867,888710685,13886104,16.5),(138342,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138342,35.45,0.25,123,66248,74.4,NULL,NULL,'IC 4610',NULL,'2013AJ....146...86T',2013,1,0.81,NULL,'G',0.0001,NULL,'16.0g',0.23,'Sa(f)          AGN',NULL,NULL,NULL,NULL,1,248.413167,39.25764,0,NULL,59821643982,934713187,14604893,16),(138343,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138343,36.58,0.21,207,66249,70,NULL,NULL,'VV 667 NED04',NULL,'2001MNRAS.321..277C',2001,1,0.7,NULL,'G',NULL,'?','14.65',0.6,'S',NULL,NULL,NULL,NULL,1,248.4209583,50.37517,0,NULL,59831264317,934863504,14607242,14.65),(138344,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138344,35.76,0.06,142,66250,70,NULL,NULL,'2MASX J16334253+3935519',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.0001,NULL,'15.4g',0.49,'E0',NULL,NULL,NULL,NULL,1,248.427125,39.59781,0,NULL,59821721526,934714398,14604912,15.4),(138345,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138345,35.76,0.06,142,66251,70,NULL,NULL,'2MASX J16334254+4009109',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000156,NULL,'15.8g',0.33,'S0',NULL,NULL,NULL,NULL,1,248.427333333,40.15311,0,NULL,59821326848,934708232,14604816,15.8),(138346,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138346,37.82,0.46,367,66252,70,NULL,NULL,'2MASX J16334421+3235083',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00013,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,248.434333,32.58556,0.041,NULL,59754497178,933664018,14588500,18),(138347,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138347,37.53,0.46,321,66253,70,NULL,NULL,'2MASX J16334463+1131113',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,248.435917,11.51983,0.201,NULL,56754406506,886787601,13856056,17.9),(138348,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138348,37.29,0.12,287,66254,70,NULL,NULL,'2MASX J16334654+2650219',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,248.4437917,26.83936,0.125,NULL,56183151812,877861747,13716589,17.6),(138349,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138349,38.23,0.46,442,66255,70,NULL,NULL,'2MASX J16334738+3739448',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,248.447417,37.66247,0.021,NULL,59822857372,934732146,14605189,17.6),(138350,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138350,35.81,0.33,145,66256,70,NULL,NULL,'2MASX J16334747+2536239',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000178,NULL,'15.6g',0.41,'E0',NULL,NULL,NULL,NULL,1,248.447875,25.60661,0.073,NULL,56175656452,877744632,13714759,15.6),(138351,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138351,31.23,0.4,17.6,66257,NULL,NULL,NULL,'UGC 10445',NULL,'2009AJ....138..323T',2009,1,1.35,NULL,'G',0.00001,NULL,'14.4g',0.97,'SBc            Sbrst','Isolated galaxy',NULL,NULL,NULL,1,248.448417,28.98478,0.049,NULL,56179469754,877804214,13715690,14.4),(138352,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138352,32.46,0.47,31.1,66257,NULL,NULL,NULL,'UGC 10445',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138353,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138353,32.5,0.2,31.6,66257,74.4,NULL,NULL,'UGC 10445',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138354,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138354,32.86,0.39,37.4,66257,NULL,NULL,'Malmquist cor.','UGC 10445',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138355,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138355,36.89,0.46,239,66258,70,NULL,NULL,'2MASX J16334869+1234238',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000149,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,248.452917,12.57336,0.181,NULL,56876736642,888699010,13885922,17.1),(138356,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138356,35.66,0.16,135,66259,70,NULL,NULL,'IC 4612',NULL,'2001MNRAS.321..277C',2001,1,0.75,'This is often incorrectly called IC 4610.','G',0.000053,NULL,'14.4g',0.74,'E/S0           AGN',NULL,NULL,NULL,NULL,1,248.45675,39.26319,0.013,NULL,59821652287,934713316,14604895,14.4),(138357,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138357,36.45,0.46,195,66260,70,NULL,NULL,'2MASX J16335192+2122325',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000178,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,248.46625,21.37578,0.169,NULL,56695921025,885873766,13841777,16.4),(138358,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138358,35.53,0.46,128,66261,70,NULL,NULL,'2MASX J16335213+2052595',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'15.6g',0.37,NULL,NULL,NULL,NULL,NULL,1,248.467333,20.88308,0.201,NULL,56703569794,885993278,13843644,15.6),(138359,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138359,37.72,0.46,350,66262,70,NULL,NULL,'2MASX J16335343+1737279',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00017,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,248.472666667,17.62444,0.241,NULL,56662930429,885358287,13833723,17.6),(138360,'GRB','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138360,41.52,0.66,1180,66263,72,NULL,NULL,'GRB 991208',0.7063,'2008JCAP...07..004M',2008,1,NULL,NULL,'G',0.0017,NULL,'19.5',NULL,'Ulysses/KO/NE',NULL,NULL,NULL,NULL,1,248.4730417,46.45583,0.009,NULL,59840485251,935007582,14609493,19.5),(138361,'GRB','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138361,41.65,0.65,1250,66263,69.7,NULL,'Calibrated','GRB 991208',0.7063,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138362,'GRB','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138362,41.69,0.67,1280,66263,70,NULL,NULL,'GRB 991208',0.7063,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138363,'GRB','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138363,41.87,0.66,1390,66263,69.7,NULL,'Fiducial','GRB 991208',0.7063,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138364,'GRB','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138364,43.35,0.86,2000,66263,73,NULL,'H const./H=100','GRB 991208',0.7063,'2006astro.ph..9262M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138365,'GRB','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138365,43.43,0.29,2840,66263,72,NULL,NULL,'GRB 991208',0.7063,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138366,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138366,38.08,0.46,414,66264,70,NULL,NULL,'2MASX J16335406+2550118',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,248.4752083,25.83661,0.081,NULL,56175659889,877744685,13714760,17.6),(138367,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138367,36.66,0.46,215,66265,70,NULL,NULL,'2MASX J16335576+4725381',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,248.482208333,47.42725,0,NULL,59844272671,935066760,14610418,17),(138368,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138368,35.81,0.33,145,66266,70,NULL,NULL,'2MASX J16335631+2536548',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000168,NULL,'15.7g',0.39,'S0',NULL,NULL,NULL,NULL,1,248.484708333,25.61517,0.073,NULL,56175656181,877744627,13714759,15.7),(138369,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138369,38.09,0.46,416,66267,70,NULL,NULL,'SDSS J163356.50+440816.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000078,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,248.4854583,44.13794,0,NULL,59846340838,935099075,14610923,18.3),(138370,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138370,37.6,0.46,331,66268,70,NULL,NULL,'2MASX J16335651+3200302',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,248.4855,32.00831,0.037,NULL,59755500871,933679701,14588745,18.2),(138371,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138371,35.15,0.63,107,66269,70,NULL,NULL,'2MASX J16335693-1021419',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.8I',0.4,NULL,NULL,NULL,NULL,NULL,1,248.48725,-10.36169,0.829,NULL,46069602408,719837537,11247461,13.8),(138372,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138372,38.19,0.46,435,66270,70,NULL,NULL,'2MASX J16335831+2241495',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000192,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,248.492791667,22.69708,0.153,NULL,56651734938,885183358,13830989,16.9),(138373,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138373,37.29,0.12,287,66271,70,NULL,NULL,'2MASX J16335911+2653528',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000178,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,248.4962917,26.89797,0.133,NULL,56183107677,877861057,13716579,16.8),(138374,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138374,36.05,0.46,162,66272,70,NULL,NULL,'2MASX J16340035+2007565',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,248.5015417,20.13231,0.261,NULL,56706976996,886046515,13844476,17.1),(138375,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138375,35.59,0.46,131,66273,70,NULL,NULL,'KUGX 1632+363',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00008,NULL,'16.0g',0.41,'Compact',NULL,NULL,NULL,NULL,1,248.502333,36.29267,0.009,NULL,59751924805,933623825,14587872,16),(138376,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138376,35.17,0.49,108,66274,75,NULL,'IR','UGC 10450',NULL,'2011yCatp016004901K',2011,1,0.86,NULL,'G',0.000117,NULL,'16.5g',0.2,'Scd:','Group member, peripheral',NULL,NULL,NULL,1,248.503416667,36.19069,0.017,NULL,59751933017,933623953,14587874,16.5),(138377,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138377,35.76,0.1,142,66274,NULL,NULL,NULL,'UGC 10450',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138378,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138378,36.18,0.2,172,66274,74.4,NULL,NULL,'UGC 10450',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138379,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138379,37.78,0.46,360,66275,70,NULL,NULL,'2MASX J16340134+3508534',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,248.505625,35.14808,0.049,NULL,59749388415,933584193,14587253,17.8),(138380,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138380,38.44,0.46,487,66276,70,NULL,NULL,'2MASX J16340204+1420290',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,248.508625,14.34147,0.205,NULL,56889324078,888895688,13888995,17.9),(138381,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138381,37.68,0.46,344,66277,70,NULL,NULL,'SDSS J163404.33+172259.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.7g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,248.518083,17.38328,0.269,NULL,56662744778,885355387,13833677,17.7),(138382,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138382,35.92,0.46,153,66278,70,NULL,NULL,'2MASX J16340730+2336499',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,248.5305417,23.614,0.165,NULL,56652095778,885188996,13831078,17),(138383,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138383,35.34,0.46,117,66279,70,NULL,NULL,'2MASX J16340790+3428324',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000087,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,248.533125,34.47581,0.029,NULL,59757138074,933705282,14589145,16.5),(138384,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138384,36.38,0.46,189,66280,70,NULL,NULL,'2MASX J16340893+2609369',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,248.5372917,26.16028,0.077,NULL,56183355323,877864926,13716639,17.4),(138385,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138385,37.66,0.46,341,66281,70,NULL,NULL,'2MASX J16341412+2102479',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000155,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,248.55875,21.04669,0.185,NULL,56703351459,885989866,13843591,17),(138386,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138386,37.92,0.46,384,66282,70,NULL,NULL,'2MASX J16341446+3116015',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,248.56025,31.26719,0.033,NULL,59752687208,933635737,14588058,17.9),(138387,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138387,37.54,0.46,322,66283,70,NULL,NULL,'SDSS J163414.72+371931.1',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,248.561375,37.32533,0.009,NULL,59820796648,934699947,14604686,17.5),(138388,'IRAS','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138388,35.38,0.8,119,66284,75,NULL,'CF, r','UGC 10456',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000047,NULL,'14.70',1,'Sb',NULL,NULL,NULL,NULL,1,248.5622917,52.94108,0.045,NULL,57597008513,899953258,14061769,14.7),(138389,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138389,35.1,0.38,105,66284,75,NULL,'CF, r, raw','UGC 10456',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138390,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138390,35.28,0.38,114,66284,75,NULL,'CF, r, inv','UGC 10456',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138391,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138391,35.35,0.38,118,66284,75,NULL,'CF, r, cor','UGC 10456',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138392,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138392,35.6,0.4,132,66284,NULL,NULL,'mean','UGC 10456',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138393,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138393,35.8,0.47,144,66284,NULL,NULL,'H','UGC 10456',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138394,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138394,38.12,0.46,420,66285,70,NULL,NULL,'2MASX J16341530+1255174',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000174,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,248.563875,12.92167,0.193,NULL,56876262314,888691598,13885806,18.1),(138395,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138395,36.99,0.46,251,66286,70,NULL,NULL,'2MASX J16341548+2708179',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,248.564417,27.13822,0.161,NULL,56181255880,877832123,13716126,17.6),(138396,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138396,36.96,0.46,246,66287,70,NULL,NULL,'2MASX J16341557+4448433',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00008,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,248.564833,44.81214,0,NULL,59845535251,935086488,14610726,16.8),(138397,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138397,36.1,0.49,166,66288,70,NULL,NULL,'2MASX J16341729-0004121',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000109,NULL,'15.5g',0.48,NULL,NULL,NULL,NULL,NULL,1,248.5719583,-0.07006,0.365,NULL,45165020941,705703452,11026616,15.5),(138398,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138398,36.1,0.46,166,66288,70,NULL,NULL,'2MASX J16341729-0004121',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138399,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138399,35.39,0.46,120,66289,70,NULL,NULL,'2MASX J16342016+1710004',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000172,NULL,'15.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,248.5840417,17.16686,0.265,NULL,56664137563,885377149,13834017,15.6),(138400,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138400,37.73,0.46,351,66290,70,NULL,NULL,'2MASX J16342064+2813449',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,248.5859583,28.22914,0.085,NULL,56182031266,877844238,13716316,17.1),(138401,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138401,37.66,0.46,341,66291,70,NULL,NULL,'2MASX J16342124+2434239',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000151,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,248.5885417,24.57314,0.109,NULL,56177969942,877780780,13715324,17.3),(138402,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138402,37.56,0.63,325,66292,70,NULL,NULL,'2MASX J16342180-6521302',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,248.590666667,-65.35833,0.729,NULL,44990097380,702970271,10983910,15.9),(138403,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138403,36.56,0.46,205,66293,70,NULL,NULL,'2MASX J16342265+4803428',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000185,NULL,'15.7g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,248.5945417,48.062,0.013,NULL,59843527393,935055115,14610236,15.7),(138404,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138404,36.73,0.17,221,66294,70,NULL,NULL,'2MASX J16342534+1136489',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,248.605583,11.61358,0.201,NULL,56754225280,886784770,13856012,16.7),(138405,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:57','1','SN 2001az',NULL,138405,35.64,0.16,129,66295,74.2,NULL,'SALT 2','UGC 10483',0.040695,'2010ApJ...716..712A',2010,1,1.2,NULL,'G',NULL,NULL,'16.0',0.5,'S',NULL,NULL,NULL,NULL,1,248.620167,76.02972,0.137,NULL,57096704394,892136006,13939625,16),(138406,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:57','1','SN 2001az',NULL,138406,35.89,0.05,145,66295,70,NULL,'SALT 2','UGC 10483',0.040695,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138407,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:57','1','SN 2001az',NULL,138407,36.2,0.04,167,66295,72,NULL,'SALT','UGC 10483',0.040695,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138408,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:57','1','SN 2001az',NULL,138408,36.2,0.09,174,66295,74.4,NULL,NULL,'UGC 10483',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138409,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:57','1','SN 2001az',NULL,138409,36.36,0.18,179,66295,65,NULL,'SALT','UGC 10483',0.040695,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138410,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:57','1','SN 2001az',NULL,138410,36.39,0.15,182,66295,65,NULL,'MLCS17','UGC 10483',0.040695,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138411,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:57','1','SN 2001az',NULL,138411,36.42,0.16,185,66295,70,NULL,'SALT 2','UGC 10483',0.040695,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138412,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:57','1','SN 2001az',NULL,138412,36.45,0.16,188,66295,73.8,NULL,'SALT 2 (SNANA)','UGC 10483',0.0403,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138413,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:57','1','SN 2001az',NULL,138413,36.47,0.15,189,66295,65,NULL,'MLCS31','UGC 10483',0.040695,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138414,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:57','1','SN 2001az',NULL,138414,36.49,0.18,191,66295,65,NULL,'SALT2','UGC 10483',0.040695,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138415,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138415,38.17,0.46,431,66296,70,NULL,NULL,'2MASX J16342922+4707303',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,248.621708333,47.12519,0,NULL,59844084290,935063817,14610372,17.2),(138416,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138416,37.3,0.46,288,66297,70,NULL,NULL,'2MASX J16343043+3104555',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000145,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,248.626667,31.08203,0.033,NULL,59752706401,933636037,14588063,18.3),(138417,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138417,37.38,0.46,299,66298,70,NULL,NULL,'2MASX J16343085+3741434',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000043,NULL,'16.6g',0.29,'Sy2',NULL,NULL,NULL,'Sy 2',1,248.628667,37.69544,0.021,NULL,59823063870,934735372,14605240,16.6),(138418,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138418,37.37,0.46,298,66299,70,NULL,NULL,'2MASX J16343243+4505003',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000075,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,248.635,45.08339,0,NULL,59838127408,934970740,14608917,17),(138419,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138419,36.12,NULL,167,66300,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2047',NULL,'2010Ap&SS.325..163P',2010,1,0.87,NULL,'G',0.000099,NULL,'17.1g',0.13,'Sb(f)',NULL,NULL,NULL,NULL,1,248.639458333,43.92203,0.005,NULL,59846326889,935098857,14610919,17.1),(138420,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138420,36.14,NULL,169,66300,NULL,NULL,'Dipole + Quadrupole','FGC 2047',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138421,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138421,36.15,NULL,170,66300,NULL,NULL,NULL,'FGC 2047',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138422,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138422,36.17,NULL,172,66300,NULL,NULL,'Dipole','FGC 2047',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138423,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138423,37.81,0.46,365,66301,70,NULL,NULL,'2MASX J16343439+2009173',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,248.643167,20.15481,0.261,NULL,56706982032,886046594,13844478,18.1),(138424,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138424,34.62,0.49,83.8,66302,75,NULL,'IR','UGC 10460',NULL,'2011yCatp016004901K',2011,1,1.21,NULL,'G',0.00005,NULL,'16.0',0.17,'Sc',NULL,NULL,NULL,NULL,1,248.643583,57.31939,0,NULL,57706166751,901658855,14088419,16),(138425,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138425,38.23,0.46,443,66303,70,NULL,NULL,'SDSS J163434.81+123459.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000164,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,248.645041667,12.58311,0.189,NULL,56875884854,888685700,13885714,18.2),(138426,'IRAS','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138426,33.79,0.8,57.2,66304,75,NULL,'HMCL, I','ESO 137- G 032',NULL,'1997ApJS..109..333W',1997,1,1.96,'Star superposed.','G',0.000334,NULL,'15.24',0.17,'Sc;sm.comp.near,warp',NULL,NULL,NULL,NULL,1,248.645417,-62.04622,NULL,NULL,44495078519,695235601,10863056,15.24),(138427,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138427,32.83,0.4,36.8,66304,75,NULL,'HMCL, I, raw','ESO 137- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138428,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138428,32.86,0.4,37.4,66304,75,NULL,'HMCL, I, inv','ESO 137- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138429,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138429,33.12,0.4,42,66304,75,NULL,'HMCL, I, cor','ESO 137- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138430,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138430,33.18,NULL,43.3,66304,NULL,NULL,'Dipole + Quadrupole','ESO 137- G 032',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138431,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138431,33.19,NULL,43.4,66304,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 137- G 032',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138432,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138432,33.19,NULL,43.5,66304,NULL,NULL,'Dipole','ESO 137- G 032',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138433,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138433,37.25,0.46,282,66305,70,NULL,NULL,'2MASX J16343949+3604094',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,248.664666667,36.06944,0.017,NULL,59751083384,933610677,14587666,17.4),(138434,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138434,37.95,0.46,390,66306,70,NULL,NULL,'2MASX J16344021+2247133',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000173,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,248.6675417,22.78689,0.169,NULL,56648802795,885137543,13830274,16.8),(138435,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138435,35.57,0.21,130,66307,70,NULL,NULL,'2MASX J16344105+4430319',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000083,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,248.671166667,44.50894,0.005,NULL,59845550077,935086719,14610729,16.3),(138436,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138436,38.53,0.46,509,66308,70,NULL,NULL,'SDSS J163441.25+174437.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000129,NULL,'18.6g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,248.671917,17.74369,0.269,NULL,56662622728,885353480,13833648,18.6),(138437,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138437,38.1,0.46,417,66309,70,NULL,NULL,'2MASX J16344539+2158273',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'16.9g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,248.689167,21.97428,0.173,NULL,56696116276,885876816,13841825,16.9),(138438,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138438,35.89,0.33,151,66310,70,NULL,NULL,'2MASX J16344610+2339503',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000174,NULL,'15.9g',0.51,'S0/a',NULL,NULL,NULL,NULL,1,248.692167,23.66383,0.165,NULL,56648660423,885135319,13830239,15.9),(138439,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138439,36.85,0.46,234,66311,70,NULL,NULL,'2MASX J16344711+2823107',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,248.696417,28.38639,0.069,NULL,56182015861,877843997,13716312,17.5),(138440,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138440,36.35,0.46,186,66312,70,NULL,NULL,'2MASX J16344820+2457177',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,248.700875,24.95481,0.101,NULL,56178468094,877788563,13715446,16.6),(138441,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138441,36.28,0.27,180,66313,70,NULL,NULL,'2MASX J16344888+2616147',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00017,NULL,'16.6g',NULL,NULL,NULL,NULL,NULL,NULL,1,248.7037917,26.27083,0.101,NULL,56183563414,877868178,13716690,16.6),(138442,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138442,37.54,0.46,323,66314,70,NULL,NULL,'SDSS J163449.15+305438.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,248.704833,30.91058,0.037,NULL,59752918203,933639346,14588114,18.2),(138443,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138443,37.29,0.12,287,66315,70,NULL,NULL,'2MASX J16344941+2639077',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000164,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,248.7060417,26.65208,0.133,NULL,56183656433,877869631,13716712,18),(138444,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138444,36.28,0.27,180,66316,70,NULL,NULL,'2MASX J16344977+2616567',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,248.707333,26.28233,0.101,NULL,56183563355,877868177,13716690,16.9),(138445,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138445,37.29,0.12,287,66317,70,NULL,NULL,'2MASX J16345307+2640217',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000174,NULL,'16.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,248.721,26.67264,0.133,NULL,56183654056,877869594,13716712,16.4),(138446,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138446,36.52,0.46,201,66318,70,NULL,NULL,'2MASX J16345390+3243507',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000154,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,248.7247083,32.73069,0.045,NULL,59755000597,933671884,14588623,16.8),(138447,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138447,36.28,0.27,180,66319,70,NULL,NULL,'CGCG 138-041',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.00017,NULL,'15.2g',0.46,'E0',NULL,NULL,NULL,NULL,1,248.7267083,26.27478,0.101,NULL,56183556134,877868064,13716688,15.2),(138448,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138448,34.11,0.49,66.4,66320,75,NULL,'IR','UGC 10453',NULL,'2011yCatp016004901K',2011,1,1.75,NULL,'G',0.000005,NULL,'15.8g',0.22,'Sd',NULL,NULL,NULL,NULL,1,248.7307083,20.57881,0.245,NULL,56706460259,886038441,13844350,15.8),(138449,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138449,34.16,NULL,67.8,66320,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10453',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138450,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138450,34.17,NULL,68.2,66320,NULL,NULL,'Dipole + Quadrupole','UGC 10453',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138451,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138451,34.17,NULL,68.3,66320,NULL,NULL,'Dipole','UGC 10453',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138452,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138452,34.22,NULL,69.9,66320,NULL,NULL,NULL,'UGC 10453',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138453,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138453,34.44,0.2,77.3,66320,74.4,NULL,NULL,'UGC 10453',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138454,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138454,36.58,0.27,207,66321,70,NULL,NULL,'2MASX J16345675+2557318',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000168,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,248.736375,25.95881,0.077,NULL,56175798531,877746852,13714794,16.3),(138455,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138455,37.29,0.12,287,66322,70,NULL,NULL,'2MASX J16345865+2625548',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,248.744333,26.432,0.125,NULL,56183611743,877868933,13716702,17.4),(138456,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138456,36.75,0.6,224,66323,70,NULL,NULL,'2MASX J16350063-6530265',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,'SAB(r)0^+',NULL,NULL,NULL,NULL,1,248.7525,-65.50761,0.729,NULL,44989614097,702962720,10983792,15.4),(138457,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138457,37.29,0.12,287,66324,70,NULL,NULL,'2MASX J16350267+2632338',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000188,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,248.7610417,26.54267,0.125,NULL,56183572706,877868323,13716692,16.6),(138458,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138458,35.89,0.33,151,66325,70,NULL,NULL,'2MASX J16350305+2336422',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000176,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,248.7627917,23.61183,0.165,NULL,56648622889,885134732,13830230,16.4),(138459,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138459,38.03,0.46,404,66326,70,NULL,NULL,'2MASX J16350358+2458589',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,248.764833,24.98303,0.089,NULL,56178474307,877788661,13715447,17.8),(138460,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138460,37.82,0.46,366,66327,70,NULL,NULL,'2MASX J16350355+3655184',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,248.764958333,36.92192,0.025,NULL,59750467838,933601059,14587516,17.5),(138461,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138461,37.31,0.27,290,66328,70,NULL,NULL,'2MASX J16350394+2727268',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,248.766333,27.45731,0.169,NULL,56181632308,877838004,13716218,17.8),(138462,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138462,37.56,0.46,325,66329,70,NULL,NULL,'2MASX J16350545+2856388',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000174,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,248.772625,28.94422,0.049,NULL,56179424082,877803501,13715679,17),(138463,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138463,37.65,0.46,339,66330,70,NULL,NULL,'2MASX J16350636+4416010',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000082,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,248.776625,44.26692,0,NULL,59846373082,935099579,14610930,17.4),(138464,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138464,35.38,NULL,119,66331,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10459',NULL,'2010Ap&SS.325..163P',2010,1,1.83,NULL,'G',0.000034,NULL,'15.6g',0.22,'Sd(f)','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,248.7827917,40.99136,0,NULL,59858008983,935281390,14613771,15.6),(138465,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138465,35.39,NULL,120,66331,NULL,NULL,'Dipole + Quadrupole','UGC 10459',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138466,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138466,35.4,NULL,120,66331,NULL,NULL,'Dipole','UGC 10459',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138467,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138467,35.71,NULL,139,66331,NULL,NULL,NULL,'UGC 10459',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138468,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138468,35.81,0.2,145,66331,74.4,NULL,NULL,'UGC 10459',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138469,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138469,37.54,0.46,321,66332,70,NULL,NULL,'2MASX J16350890+2935538',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,248.7872083,29.59833,0.049,NULL,56178567916,877790123,13715470,17.6),(138470,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138470,35.62,0.4,133,66333,NULL,NULL,'mean','IC 1222',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000033,NULL,'14.16',1.3,'SAB(s)c','Parent (of companion) galaxy',NULL,NULL,NULL,1,248.788333,46.21392,0.009,NULL,59840619166,935009674,14609526,14.16),(138471,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138471,35.73,0.47,140,66333,NULL,NULL,'H','IC 1222',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138472,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138472,37.31,0.27,290,66334,70,NULL,NULL,'2MASX J16350942+2725208',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'17.76',0.32,NULL,NULL,NULL,NULL,NULL,1,248.7892917,27.42239,0.169,NULL,56181651511,877838304,13716223,17.76),(138473,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138473,37.05,0.46,257,66335,70,NULL,NULL,'2MASX J16351072-0007038',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000091,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,248.794583,-0.11767,0.353,NULL,45164854600,705700853,11026575,17.2),(138474,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138474,36.13,0.57,168,66336,70,NULL,NULL,'2MASX J16351097-7310098',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,248.7957083,-73.16947,0.261,NULL,44116252781,689316449,10770569,15),(138475,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138475,36.28,0.66,180,66337,70,NULL,NULL,'2MASX J16351168-6343304',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,248.7987083,-63.72517,0.877,NULL,44461117837,694704966,10854765,15.2),(138476,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138476,37.29,0.12,287,66338,70,NULL,NULL,'2MASX J16351252+2637488',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000185,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,248.802083,26.63039,0.133,NULL,56182902321,877857848,13716528,17.2),(138477,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138477,37.8,0.46,362,66339,70,NULL,NULL,'2MASX J16351255+4542139',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,248.802333,45.70397,0,NULL,59838634895,934978670,14609041,17.9),(138478,'IRAS','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138478,32.47,0.8,31.1,66340,75,NULL,'HMCL, I','ESO 137- G 034',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000022,NULL,'12.21',1.1,'SAB(s)0/a?     Sy2','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,248.808791667,-58.08003,NULL,NULL,44548181449,696065335,10876020,12.21),(138479,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138479,32.46,0.4,31,66340,75,NULL,'HMCL, I, raw','ESO 137- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138480,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138480,32.67,0.4,34.1,66340,75,NULL,'HMCL, I, inv','ESO 137- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138481,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138481,32.75,0.4,35.6,66340,75,NULL,'HMCL, I, cor','ESO 137- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138482,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138482,36.82,0.46,231,66341,70,NULL,NULL,'2MASX J16351473+3104070',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000147,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,248.8115,31.06856,0.029,NULL,59752670354,933635474,14588054,16.8),(138483,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138483,38.21,0.46,439,66342,70,NULL,NULL,'2MASX J16351545+2144197',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000176,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,248.814333,21.73892,0.165,NULL,56695793398,885871771,13841746,17.4),(138484,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138484,37.31,0.27,290,66343,70,NULL,NULL,'2MASX J16351768+2726578',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,248.823833333,27.44956,0.169,NULL,56181652188,877838315,13716223,16.3),(138485,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138485,37.29,0.12,287,66344,70,NULL,NULL,'2MASX J16351841+2637018',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000195,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,248.82675,26.61722,0.133,NULL,56182868873,877857326,13716520,16.6),(138486,'Tully est','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138486,33.07,0.8,41,66345,75,NULL,'B','UGCA 412',NULL,'1988NBGC.C....0000T',1988,1,0.3,NULL,'G',0.000013,NULL,'16.0',0.2,'BlueCG         Sbrst','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,248.8375,52.21453,0.017,NULL,59693455867,932710247,14573597,16),(138487,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138487,37.43,0.46,306,66346,70,NULL,NULL,'SDSS J163522.35+113759.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,248.843167,11.63328,0.165,NULL,56750001704,886718776,13854980,18.1),(138488,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138488,35.88,0.46,150,66347,70,NULL,NULL,'2MASX J16352321+1451222',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,248.846667,14.85608,0.205,NULL,56888578681,888884041,13888813,16.6),(138489,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138489,36.65,0.46,213,66348,70,NULL,NULL,'2MASX J16352425+4144554',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000093,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,248.8510417,41.74883,0,NULL,59858040623,935281884,14613779,16.3),(138490,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138490,37.39,0.46,300,66349,70,NULL,NULL,'2MASX J16352585+2254528',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,248.857583,22.91481,0.165,NULL,56648822803,885137856,13830279,17.4),(138491,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138491,37.53,0.46,321,66350,70,NULL,NULL,'2MASX J16352631+1456442',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,248.8597917,14.94556,0.205,NULL,56888535040,888883360,13888802,17.8),(138492,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138492,36.58,0.27,207,66351,70,NULL,NULL,'2MASX J16352672+2555452',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00019,NULL,'16.0g',0.35,'E0',NULL,NULL,NULL,NULL,1,248.861291667,25.92911,0.077,NULL,56175791464,877746741,13714792,16),(138493,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138493,36.45,0.46,195,66352,70,NULL,NULL,'2MASX J16352751+3636004',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00007,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,248.864667,36.60011,0.005,NULL,59750318029,933598719,14587479,16.5),(138494,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138494,36.9,0.46,240,66353,70,NULL,NULL,'2MASX J16353201+2615242',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'15.9g',0.32,NULL,NULL,NULL,NULL,NULL,1,248.883416667,26.25683,0.101,NULL,56176282082,877754407,13714912,15.9),(138495,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138495,36.35,0.46,186,66354,70,NULL,NULL,'2MASX J16353332+2552102',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000107,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,248.8889583,25.86961,0.089,NULL,56175706754,877745418,13714772,16.3),(138496,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138496,37.11,0.46,264,66355,70,NULL,NULL,'2MASX J16353618+3749142',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00009,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,248.900708333,37.82064,0.009,NULL,59820925783,934701965,14604718,16.8),(138497,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138497,37.29,0.12,287,66356,70,NULL,NULL,'2MASX J16353682+2630172',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000171,NULL,'16.3g',0.36,'E0',NULL,NULL,NULL,NULL,1,248.903583,26.50489,0.125,NULL,56182898058,877857782,13716527,16.3),(138498,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138498,37.76,0.46,357,66357,70,NULL,NULL,'2MASX J16353712+1202133',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,248.9047083,12.03711,0.185,NULL,56881066949,888766671,13886979,17.4),(138499,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138499,35.25,0.33,112,66358,70,NULL,NULL,'2MASX J16353863+0018425',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000076,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,248.910917,0.31181,0.333,NULL,55972497165,874570268,13665160,16.5),(138500,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138500,35.25,0.33,112,66359,70,NULL,NULL,'CGCG 024-018',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000111,NULL,'14.4g',0.78,NULL,NULL,NULL,NULL,NULL,1,248.920083,0.33139,0.333,NULL,55972499451,874570303,13665160,14.4),(138501,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138501,37.31,0.46,289,66360,70,NULL,NULL,'2MASX J16354156+4036252',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,248.923333,40.60717,0.005,NULL,59853805906,935215717,14612745,17.4),(138502,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138502,37.29,0.12,287,66361,70,NULL,NULL,'2MASX J16354233+2649472',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'16.0r',NULL,NULL,NULL,NULL,NULL,NULL,1,248.926417,26.82981,0.161,NULL,56182809440,877856397,13716506,16),(138503,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138503,37.99,0.46,397,66362,70,NULL,NULL,'2MASX J16354366+2708423',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.3g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,248.931875,27.14514,0.173,NULL,56180791543,877824867,13716013,17.3),(138504,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138504,38.16,0.33,428,66363,70,NULL,NULL,'2MASX J16354434+3117037',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,248.934625,31.28447,0.041,NULL,59752756537,933636820,14588075,17.9),(138505,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138505,35.87,0.46,149,66364,70,NULL,NULL,'2MASX J16354443+2613433',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000133,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,248.93525,26.22861,0.101,NULL,56176293398,877754584,13714915,16.7),(138506,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138506,34.93,NULL,96.7,66365,NULL,NULL,'Dipole','UGC 10478',NULL,'2010Ap&SS.325..163P',2010,1,1.79,NULL,'G',0.000023,NULL,'16.0',0.24,'Sc',NULL,NULL,NULL,NULL,1,248.935375,68.42828,0.173,NULL,57847105102,903861017,14122828,16),(138507,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138507,34.93,NULL,96.9,66365,NULL,NULL,'Dipole + Quadrupole','UGC 10478',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138508,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138508,34.93,NULL,97,66365,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10478',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138509,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138509,35.18,0.49,108,66365,75,NULL,'IR','UGC 10478',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138510,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138510,35.41,0.37,121,66365,NULL,NULL,'Malmquist cor.','UGC 10478',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138511,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138511,35.56,0.34,129,66365,NULL,NULL,NULL,'UGC 10478',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138512,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138512,35.6,0.2,132,66365,74.4,NULL,NULL,'UGC 10478',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138513,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138513,36.15,0.62,170,66366,70,NULL,NULL,'2MASX J16354720-7747230',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,248.9462917,-77.78969,0.517,NULL,44263016034,691609625,10806400,16.9),(138514,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138514,38.47,0.46,494,66367,70,NULL,NULL,'SDSS J163547.41+140920.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,248.9475417,14.15561,0.257,NULL,56888783654,888887244,13888863,18.4),(138515,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138515,38.39,0.46,476,66368,70,NULL,NULL,'2MASX J16354820+2442123',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,248.95075,24.70328,0.101,NULL,56177840604,877778759,13715293,17.9),(138516,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138516,36.73,0.46,222,66369,70,NULL,NULL,'2MASX J16355021+4717374',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,248.959333,47.29386,0,NULL,59843931503,935061429,14610334,16.4),(138517,'SZ effect','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138517,39.1,0.42,660,66370,NULL,NULL,'Hydrost. Eq.','ABELL 2218',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II:    [BM]',NULL,NULL,NULL,NULL,1,248.968333,66.21444,0.077,NULL,57821767898,903465123,14116642,NULL),(138518,'SZ effect','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138518,39.35,0.71,740,66370,NULL,NULL,NULL,'ABELL 2218',NULL,'1994ApJ...420...33B',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138519,'SZ effect','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138519,39.54,NULL,809,66370,NULL,NULL,NULL,'ABELL 2218',NULL,'2005ApJ...625..108D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138520,'SZ effect','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138520,39.75,1.44,890,66370,NULL,NULL,NULL,'ABELL 2218',NULL,'1998PASJ...50..169T',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138521,'SZ effect','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138521,40.06,NULL,1030,66370,NULL,NULL,NULL,'ABELL 2218',NULL,'2002ApJ...581...53R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138522,'SZ effect','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138522,40.13,NULL,1060,66370,75,NULL,NULL,'ABELL 2218',NULL,'1982ApJ...257..473B',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138523,'SZ effect','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138523,40.15,0.41,1070,66370,NULL,NULL,'Isotherm.','ABELL 2218',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138524,'SZ effect','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138524,40.36,0.41,1180,66370,NULL,NULL,'Isotherm., r < 100 kpc','ABELL 2218',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138525,'SZ effect','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138525,40.91,NULL,1520,66370,NULL,NULL,'3.1 (red) calibration','ABELL 2218',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138526,'SZ effect','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138526,41.02,NULL,1600,66370,NULL,NULL,'4.2 (black) calibration','ABELL 2218',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138527,'SZ effect','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138527,41.22,NULL,1750,66370,NULL,NULL,'4.1 (blue) calibration','ABELL 2218',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138528,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138528,39.12,0.14,667,66370,NULL,NULL,'ABELL 2218 cluster, avg. of 8 spiral galaxies','ABELL 2218',NULL,'2003AJ....126..675D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138529,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138529,36.87,0.46,236,66371,70,NULL,NULL,'2MASX J16355553+3815482',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,248.981333333,38.26342,0.005,NULL,59823165641,934736963,14605265,17.3),(138530,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138530,38.06,0.46,410,66372,70,NULL,NULL,'2MASX J16355613+3819382',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,248.983875,38.32722,0.005,NULL,59822477945,934726217,14605097,17.4),(138531,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138531,37.68,0.46,344,66373,70,NULL,NULL,'2MASX J16355947+4343069',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000084,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,248.997917,43.7185,0,NULL,59845731015,935089547,14610774,16.9),(138532,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138532,36.64,0.56,213,66374,70,NULL,NULL,'2MASX J16355975-6613014',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,248.999083,-66.21714,0.573,NULL,44991322033,702989406,10984209,15.3),(138533,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138533,38.16,0.33,428,66375,70,NULL,NULL,'SDSS J163559.99+312721.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,249,31.45594,0.053,NULL,59752774979,933637109,14588079,18.3),(138534,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138534,37.72,0.46,350,66376,70,NULL,NULL,'2MASX J16360183+3311458',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000142,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,249.007667,33.19611,0.041,NULL,59754926613,933670728,14588605,17.7),(138535,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138535,38.01,0.46,400,66377,70,NULL,NULL,'SDSS J163602.20+120511.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,249.009167,12.08653,0.177,NULL,56881118458,888767475,13886991,18.3),(138536,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138536,36.88,0.33,237,66378,70,NULL,NULL,'SDSS J163603.54+263145.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,249.0147917,26.52928,0.125,NULL,56182860391,877857193,13716518,17.9),(138537,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138537,36.06,0.65,163,66379,70,NULL,NULL,'2MASX J16360409-6403032',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,249.017166667,-64.05094,0.797,NULL,44474461369,694913458,10858022,15.8),(138538,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138538,38.1,0.46,418,66380,70,NULL,NULL,'2MASX J16360549+3239308',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000197,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,249.0227917,32.65861,0.045,NULL,59754814026,933668969,14588577,16.8),(138539,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138539,36.88,0.33,237,66381,70,NULL,NULL,'2MASX J16360777+2630594',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000187,NULL,'15.7g',0.59,'E0',NULL,NULL,NULL,NULL,1,249.032333333,26.51658,0.125,NULL,56182861017,877857203,13716518,15.7),(138540,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138540,37.34,0.46,294,66382,70,NULL,NULL,'2MASX J16360875+2245345',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000144,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,249.0365,22.75953,0.165,NULL,56694693583,885854587,13841477,17.7),(138541,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138541,35.57,0.21,130,66383,70,NULL,NULL,'2MASX J16361142+4406540',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000079,NULL,'15.9g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,249.04775,44.11497,0.013,NULL,59846407254,935100113,14610939,15.9),(138542,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138542,37.98,0.46,394,66384,70,NULL,NULL,'2MASX J16361224+2649264',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,249.051125,26.82403,0.161,NULL,56182944181,877858502,13716539,18.6),(138543,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138543,36.58,0.27,207,66385,70,NULL,NULL,'CGCG 138-043',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.00012,NULL,'15.4g',0.51,'E0',NULL,NULL,NULL,NULL,1,249.053083,25.93125,0.097,NULL,56176368399,877755756,13714933,15.4),(138544,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138544,37,0.46,252,66386,70,NULL,NULL,'2MASX J16361302+2923324',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,249.05425,29.39244,0.049,NULL,56224759713,878511870,13726747,18),(138545,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138545,37.64,0.33,337,66387,70,NULL,NULL,'2MASX J16361347+1220352',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000142,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,249.056,12.34303,0.189,NULL,56889672278,888901129,13889080,18.2),(138546,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138546,37.56,0.33,325,66388,70,NULL,NULL,'2MASX J16361561+2802394',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,249.064917,28.04431,0.129,NULL,56180887796,877826371,13716037,17.1),(138547,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138547,37.81,0.33,364,66389,70,NULL,NULL,'2MASX J16361627+4027097',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,249.06775,40.45269,0.005,NULL,59821281563,934707524,14604805,17.2),(138548,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138548,37.77,0.46,358,66390,70,NULL,NULL,'2MASX J16361674+3140093',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,249.0697917,31.66936,0.045,NULL,59755583341,933680989,14588765,17.9),(138549,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138549,37.56,0.33,325,66391,70,NULL,NULL,'2MASX J16361885+2757314',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,249.0785417,27.95875,0.145,NULL,56181115841,877829935,13716092,17.1),(138550,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138550,38.27,0.46,451,66392,70,NULL,NULL,'2MASX J16362122+2435243',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,249.088333,24.59,0.109,NULL,56175024182,877734752,13714605,17.9),(138551,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138551,35.57,0.21,130,66393,70,NULL,NULL,'2MASX J16362472+4416480',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000076,NULL,'15.8g',0.33,'E0',NULL,NULL,NULL,NULL,1,249.103166667,44.28011,0,NULL,59846264233,935097878,14610904,15.8),(138552,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138552,37.99,0.46,396,66394,70,NULL,NULL,'2MASX J16362493+3922437',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,249.1037917,39.379,0.013,NULL,59821952575,934718008,14604968,17.4),(138553,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138553,38.11,0.33,418,66395,70,NULL,NULL,'2MASX J16362625+2919493',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000174,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,249.109416667,29.33025,0.057,NULL,56224766572,878511977,13726749,17.7),(138554,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138554,37.35,0.46,295,66396,70,NULL,NULL,'2MASX J16362652+1055105',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,249.110625,10.91967,0.237,NULL,56750498827,886726544,13855102,16.3),(138555,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138555,36.24,0.75,177,66397,70,NULL,NULL,'2MASX J16362810-6748136',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,'SB(r)0/a:',NULL,NULL,NULL,NULL,1,249.116708333,-67.80389,0.445,NULL,45023171725,703487058,10991985,15.2),(138556,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138556,37.64,0.33,337,66398,70,NULL,NULL,'2MASX J16362835+1220012',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,249.118125,12.33361,0.189,NULL,56881201560,888768774,13887012,17.1),(138557,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138557,38.11,0.33,418,66399,70,NULL,NULL,'2MASX J16363123+2925283',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,249.130166667,29.42456,0.065,NULL,56224755682,878511807,13726746,18.2),(138558,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138558,35.67,0.2,136,66400,74.4,NULL,NULL,'NGC 6195',NULL,'2013AJ....146...86T',2013,1,1.48,NULL,'G',0.000034,NULL,'14.0g',0.83,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,249.1357083,39.02789,0.005,NULL,59821943538,934717867,14604966,14),(138559,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138559,35.71,0.43,139,66400,75,NULL,'3.6 micron, color corrected','NGC 6195',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138560,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138560,35.96,0.43,155,66400,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6195',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138561,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138561,38.15,0.46,427,66401,70,NULL,NULL,'2MASX J16363380+1430152',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000145,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,249.141,14.50422,0.217,NULL,56889089307,888892020,13888937,17.5),(138562,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138562,36.97,0.46,248,66402,70,NULL,NULL,'2MASX J16363383+2341167',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,249.141083,23.68808,0.153,NULL,56649313165,885145518,13830398,16.8),(138563,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138563,37.55,0.46,323,66403,70,NULL,NULL,'2MASX J16363392+2134337',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,249.141333,21.57606,0.209,NULL,56697799922,885903123,13842236,17.1),(138564,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138564,36.55,0.46,204,66404,70,NULL,NULL,'2MASX J16363434+2321517',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,249.143041667,23.36447,0.161,NULL,56648884559,885138821,13830294,17.1),(138565,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138565,37.6,0.46,331,66405,70,NULL,NULL,'2MASX J16363515+3554014',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000189,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,249.1464583,35.90031,0.025,NULL,59750740007,933605312,14587583,16.9),(138566,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138566,33.96,0.43,62,66406,NULL,NULL,NULL,'ESO 101- G 001',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.75',0.6,'Sb',NULL,NULL,NULL,NULL,1,249.146958333,-66.00675,0.569,NULL,44991450010,702991406,10984240,14.75),(138567,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138567,34,0.2,63.1,66406,74.4,NULL,NULL,'ESO 101- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138568,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138568,34.12,0.4,66.8,66406,NULL,NULL,'Malmquist cor.','ESO 101- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138569,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138569,38.95,0.46,616,66407,70,NULL,NULL,'2MASX J16363697+3222274',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,249.154,32.37439,0.041,NULL,59756173260,933690207,14588909,18.1),(138570,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138570,34.82,0.33,92.2,66408,70,NULL,NULL,'NGC 6194',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000087,NULL,'14.1g',0.8,'Compact',NULL,NULL,NULL,NULL,1,249.1547917,36.20044,0.017,NULL,59750762200,933605659,14587588,14.1),(138571,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138571,36.9,0.27,240,66409,70,NULL,NULL,'2MASX J16363729+2512483',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'16.69',0.36,NULL,NULL,NULL,NULL,NULL,1,249.155541667,25.21353,0.077,NULL,56178181224,877784081,13715376,16.69),(138572,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138572,36.5,0.53,200,66410,70,NULL,NULL,'2MASX J16363969-6548557',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,249.1655,-65.81556,0.569,NULL,44991445703,702991339,10984239,15.4),(138573,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138573,37.61,0.33,333,66411,70,NULL,NULL,'2MASX J16364090+3434314',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,249.17025,34.57528,0.029,NULL,59756932127,933702064,14589094,17.8),(138574,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138574,37.07,0.33,259,66412,70,NULL,NULL,'2MASX J16364092+4418271',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000086,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,249.170583333,44.30744,0,NULL,59845997632,935093713,14610839,16.9),(138575,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138575,37.45,0.33,309,66413,70,NULL,NULL,'2MASX J16364146+4146347',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000077,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,249.172875,41.77639,0,NULL,59846611084,935103298,14610989,18.4),(138576,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138576,38.18,0.33,433,66414,70,NULL,NULL,'2MASX J16364243+2846313',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000201,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,249.1767083,28.77533,0.069,NULL,56225120811,878517512,13726836,17.4),(138577,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138577,36.44,0.71,194,66415,70,NULL,NULL,'2MASX J16364352-1940160',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,249.181417,-19.67114,1.085,NULL,45966691570,718229555,11222336,15.7),(138578,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138578,38.18,0.33,433,66416,70,NULL,NULL,'2MASX J16364372+2847523',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,249.182083,28.79786,0.069,NULL,56225056469,878516507,13726820,17.7),(138579,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138579,38.42,0.46,482,66417,70,NULL,NULL,'SDSS J163644.18+193322.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000146,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,249.184083,19.55628,0.289,NULL,56693362659,885833791,13841152,18.2),(138580,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138580,37.57,0.46,327,66418,70,NULL,NULL,'2MASX J16364463+2928553',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000178,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,249.186208333,29.48214,0.065,NULL,56224878880,878513732,13726777,17.3),(138581,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138581,35.77,0.46,142,66419,70,NULL,NULL,'2MASX J16364525+1309529',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000171,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,249.1885,13.16472,0.205,NULL,56890281826,888910653,13889228,16.2),(138582,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138582,37.45,0.33,309,66420,70,NULL,NULL,'2MASX J16364668+4153151',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000096,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,249.194708333,41.88769,0,NULL,59847339858,935114685,14611166,16.7),(138583,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138583,37.62,0.46,334,66421,70,NULL,NULL,'2MASX J16364845+1705039',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,249.2020417,17.08439,0.273,NULL,56664830594,885387978,13834187,17.1),(138584,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138584,36.35,0.46,186,66422,70,NULL,NULL,'2MASX J16365089+3115091',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.73',0.42,NULL,NULL,NULL,NULL,NULL,1,249.2120417,31.25256,0.041,NULL,59752906392,933639162,14588111,16.73),(138585,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138585,37.03,0.46,255,66423,70,NULL,NULL,'2MASX J16365439+2900533',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000215,NULL,'15.7g',0.47,NULL,NULL,NULL,NULL,NULL,1,249.226667,29.01483,0.049,NULL,56225093068,878517079,13726829,15.7),(138586,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138586,37.04,0.46,256,66424,70,NULL,NULL,'2MASX J16365489+4400571',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000095,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,249.2287917,44.01586,0.013,NULL,59846190951,935096733,14610886,16.7),(138587,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138587,37.73,0.46,352,66425,70,NULL,NULL,'2MASX J16365687+2338346',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,249.237125,23.64281,0.161,NULL,56649144408,885142881,13830357,17.4),(138588,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138588,37.99,0.46,396,66426,70,NULL,NULL,'2MASX J16365835+3734593',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000147,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,249.243125,37.58333,0.021,NULL,59821018553,934703414,14604740,17.4),(138589,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138589,38.09,0.46,414,66427,70,NULL,NULL,'2MASX J16365893+2618143',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,249.245417,26.30386,0.125,NULL,56175559228,877743112,13714736,17.3),(138590,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138590,37.61,0.33,333,66428,70,NULL,NULL,'2MASX J16370138+3431472',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000117,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,249.255833,34.52978,0.029,NULL,59759759532,933746242,14589785,16.8),(138591,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138591,35.57,0.21,130,66429,70,NULL,NULL,'2MASX J16370198+4420081',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000087,NULL,'15.5g',0.5,'E0',NULL,NULL,NULL,NULL,1,249.2582083,44.33561,0,NULL,59845999910,935093748,14610839,15.5),(138592,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138592,37.61,0.46,333,66430,70,NULL,NULL,'2MASX J16370228+1242219',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000196,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,249.259583,12.70622,0.193,NULL,56889512691,888898635,13889041,17.6),(138593,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138593,37.81,0.33,364,66431,70,NULL,NULL,'2MASX J16370247+4030093',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000127,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,249.2602083,40.50278,0.005,NULL,59821299336,934707802,14604809,16.6),(138594,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138594,37.62,0.46,334,66432,70,NULL,NULL,'2MASX J16370322+0023558',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,249.263583,0.39872,0.333,NULL,55972561236,874571269,13665176,18),(138595,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138595,35.19,0.46,109,66433,70,NULL,NULL,'CGCG 138-046',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000157,NULL,'15.1g',0.62,'E0',NULL,NULL,NULL,NULL,1,249.2637083,21.05533,0.217,NULL,56705190265,886018597,13844040,15.1),(138596,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138596,37.11,0.46,264,66434,70,NULL,NULL,'2MASX J16370518-0022244',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000092,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,249.2717083,-0.37336,0.409,NULL,45166723857,705730060,11027032,17.2),(138597,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138597,37.02,0.46,253,66435,70,NULL,NULL,'2MASX J16370524+2216186',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000187,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,249.2717083,22.27178,0.201,NULL,56698371009,885912047,13842375,16.3),(138598,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138598,37.07,0.33,259,66436,70,NULL,NULL,'2MASX J16370588+4416111',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000087,NULL,'15.8g',0.47,'E0',NULL,NULL,NULL,NULL,1,249.274625,44.26975,0,NULL,59845985503,935093523,14610836,15.8),(138599,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138599,36.33,0.46,184,66437,70,NULL,NULL,'2MASX J16370732+1411302',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000189,NULL,'15.5g',0.43,NULL,NULL,NULL,NULL,NULL,1,249.2805,14.19181,0.245,NULL,56891355550,888927430,13889491,15.5),(138600,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138600,38.54,0.46,511,66438,70,NULL,NULL,'SDSS J163709.86+275249.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.7g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,249.291125,27.88047,0.145,NULL,56181026602,877828540,13716070,18.7),(138601,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138601,36.84,0.46,233,66439,70,NULL,NULL,'2MASX J16371100+2617092',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000179,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,249.2957083,26.28597,0.125,NULL,56175526540,877742602,13714728,16.6),(138602,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138602,37.75,0.46,355,66440,70,NULL,NULL,'2MASX J16371342+3705164',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00018,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,249.305917,37.08781,0.017,NULL,59820817514,934700273,14604691,17.1),(138603,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138603,36.87,0.55,236,66441,70,NULL,NULL,'2MASX J16371406-6422036',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,249.3084583,-64.36778,0.797,NULL,44474332775,694911449,10857991,15.8),(138604,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138604,38.7,0.46,550,66442,70,NULL,NULL,'2MASX J16371463+2733092',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,249.311083,27.55253,0.165,NULL,56180686283,877823223,13715987,18.2),(138605,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138605,37.15,0.46,269,66443,70,NULL,NULL,'SDSS J163715.56+104935.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,249.314875,10.82639,0.237,NULL,56750473328,886726145,13855096,18.3),(138606,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138606,37.61,0.46,333,66444,70,NULL,NULL,'2MASX J16371732+4740528',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,249.322167,47.68139,0,NULL,59841516543,935023695,14609745,17.3),(138607,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138607,38.19,0.46,434,66445,70,NULL,NULL,'SDSS J163718.84+272331.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,249.3285,27.39217,0.153,NULL,56180716429,877823694,13715995,18.6),(138608,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138608,34.26,0.49,71,66446,75,NULL,'IR','UGC 10489',NULL,'2011yCatp016004901K',2011,1,1.57,'The 2MASS position is 8 arcsec northeast of the center of the bulge.','G',NULL,NULL,'16.5',0.11,'Sd',NULL,NULL,NULL,NULL,1,249.333583,62.74072,0.021,NULL,57530588777,898915449,14045553,16.5),(138609,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138609,34.66,NULL,85.6,66446,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10489',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138610,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138610,34.67,NULL,86.1,66446,NULL,NULL,'Dipole + Quadrupole','UGC 10489',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138611,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138611,34.68,NULL,86.4,66446,NULL,NULL,'Dipole','UGC 10489',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138612,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138612,34.73,NULL,88.4,66446,NULL,NULL,NULL,'UGC 10489',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138613,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138613,35.62,0.46,133,66447,70,NULL,NULL,'2MASXi J1637205+411120',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000077,NULL,'15.4g',0.5,'S0^-',NULL,NULL,NULL,NULL,1,249.335458333,41.18897,0,NULL,59846478964,935101233,14610956,15.4),(138614,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138614,36.9,0.27,240,66448,70,NULL,NULL,'2MASX J16372555+2518283',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000189,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,249.356625,25.30797,0.085,NULL,56178231479,877784866,13715388,16.6),(138615,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:57','1','SN 2002aw',NULL,138615,35.15,0.16,104,66449,70,NULL,'SALT 2','2MFGC 13321',0.026145,'2013MNRAS.433.2240G',2013,1,0.95,NULL,'G',0.000107,NULL,'15.8g',0.21,'Sb(f)          Sbrst',NULL,NULL,NULL,NULL,1,249.3719583,40.87997,0,NULL,59816033432,934625522,14603523,15.8),(138616,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:57','1','SN 2002aw','R',138616,35.09,0.09,104,66449,NULL,NULL,'MLCS2k2, R(V) = 3.1','2MFGC 13321',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138617,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:57','1','SN 2002aw','R',138617,35.16,0.07,108,66449,NULL,NULL,'MLCS2k2, R(V) = 1.8','2MFGC 13321',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138618,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138618,35.06,0.2,103,66450,74.4,NULL,NULL,'CGCG 109-035',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000067,NULL,'15.5',0.3,'Irr',NULL,NULL,NULL,NULL,1,249.372875,17.93239,0.237,NULL,56664532738,885383324,13834114,15.5),(138619,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138619,35.57,0.21,130,66451,70,NULL,NULL,'UGC 10480',NULL,'2015arXiv151105856S',2015,1,1.24,NULL,'G',0.000116,NULL,'14.1g',0.73,'E?',NULL,NULL,NULL,NULL,1,249.375667,44.14447,0,NULL,59846105176,935095393,14610865,14.1),(138620,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138620,34.05,0.25,64.6,66452,74.4,NULL,NULL,'UGC 10486',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000053,NULL,'13.90',0.8,'S0-:','Field galaxy',NULL,NULL,NULL,1,249.393083,50.3455,0,NULL,59828210434,934815788,14606496,13.9),(138621,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138621,36.58,0.21,207,66452,70,NULL,NULL,'UGC 10486',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138622,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138622,34.92,0.4,96.4,66452,NULL,NULL,'mean','UGC 10486',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138623,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138623,35.25,0.45,112,66452,NULL,NULL,'K','UGC 10486',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138624,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138624,37.07,0.33,259,66453,70,NULL,NULL,'2MASX J16373432+1238218',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000165,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,249.393125,12.63928,0.185,NULL,56881188733,888768573,13887008,17),(138625,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138625,36.25,0.46,177,66454,70,NULL,NULL,'2MASX J16373481+2550168',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,249.395083,25.83814,0.097,NULL,56176097602,877751525,13714867,17),(138626,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138626,38.05,0.46,408,66455,70,NULL,NULL,'2MASX J16373601+2348387',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000162,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,249.400125,23.81075,0.153,NULL,56648468968,885132327,13830192,17.2),(138627,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138627,38.61,0.46,528,66456,70,NULL,NULL,'2MASX J16373637+2742268',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,249.401625,27.70736,0.141,NULL,56226546273,878539785,13727184,17.3),(138628,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138628,36.25,0.46,178,66457,70,NULL,NULL,'2MASX J16373744+4427029',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000094,NULL,'15.7g',0.43,'S0',NULL,NULL,NULL,NULL,1,249.405833,44.45086,0,NULL,59846012292,935093942,14610842,15.7),(138629,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138629,37.41,0.46,304,66458,70,NULL,NULL,'2MASX J16373781+3707013',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,249.4077917,37.11714,0.017,NULL,59821078520,934704351,14604755,16.9),(138630,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138630,37.94,0.33,387,66459,70,NULL,NULL,'2MASX J16373944+1601078',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000188,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,249.414375,16.01872,0.257,NULL,56884982183,888827846,13887935,17.2),(138631,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138631,38.02,0.61,401,66460,70,NULL,NULL,'2MASX J16374049-6643401',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,249.4187917,-66.72786,0.585,NULL,44990725826,702980091,10984063,15.9),(138632,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138632,37.57,0.46,326,66461,70,NULL,NULL,'2MASX J16374115+2922259',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000152,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,249.421583,29.37381,0.065,NULL,56225598373,878524974,13726952,17.2),(138633,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138633,37.13,0.33,266,66462,70,NULL,NULL,'2MASX J16374143+3041471',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00018,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,249.4227917,30.69639,0.057,NULL,59753034668,933641166,14588143,16.7),(138634,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138634,38.01,0.17,399,66463,70,NULL,NULL,'SDSS J163741.69+274837.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,249.42375,27.81033,0.141,NULL,56226296451,878535882,13727123,18.2),(138635,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138635,38.02,0.33,401,66464,70,NULL,NULL,'2MASX J16374255+4418509',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000094,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,249.4272917,44.31425,0,NULL,59846152494,935096132,14610877,17.1),(138636,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138636,38.05,0.46,407,66465,70,NULL,NULL,'SDSS J163745.13+340539.7',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.6g',0.27,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,249.438083,34.09439,0.037,NULL,59760057049,933750891,14589857,16.6),(138637,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138637,37.73,0.46,352,66466,70,NULL,NULL,'2MASX J16374765+4747428',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,249.4487917,47.79531,0,NULL,59841541961,935024093,14609751,17.9),(138638,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138638,37.38,0.27,300,66467,70,NULL,NULL,'2MASX J16375022+1136570',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,249.459167,11.61594,0.205,NULL,56750877137,886732455,13855194,17),(138639,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138639,34.67,0.53,85.7,66468,70,NULL,NULL,'UGC 10474',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.1',0.7,'S',NULL,NULL,NULL,NULL,1,249.459833,-1.36625,0.477,NULL,45168002297,705750035,11027344,15.1),(138640,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138640,37.2,0.46,275,66469,70,NULL,NULL,'2MASX J16375062+2733219',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,249.4609583,27.55603,0.177,NULL,56225830639,878528603,13727009,17.3),(138641,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138641,37.13,0.33,266,66470,70,NULL,NULL,'2MASX J16375189+3039551',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,249.4662083,30.66544,0.053,NULL,59752977516,933640273,14588129,17.1),(138642,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138642,37.38,0.27,300,66471,70,NULL,NULL,'2MASX J16375246+1139210',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,249.468625,11.65581,0.205,NULL,56750897289,886732770,13855199,16.2),(138643,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138643,34.85,NULL,93.3,66472,NULL,NULL,'Dipole','ESO 101- G 003',NULL,'2010Ap&SS.325..163P',2010,1,2.58,'Star superposed.','G',0.000233,NULL,'14.61',0.22,'Sb',NULL,NULL,NULL,NULL,1,249.4702083,-64.81297,0.725,NULL,44989305965,702957905,10983717,14.61),(138644,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138644,34.86,NULL,93.7,66472,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 101- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138645,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138645,34.89,NULL,94.9,66472,NULL,NULL,'Dipole + Quadrupole','ESO 101- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138646,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138646,37.13,0.46,267,66473,70,NULL,NULL,'2MASX J16375291+2155022',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,249.470583333,21.91719,0.201,NULL,56698525243,885914456,13842413,17.7),(138647,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138647,36.19,0.46,173,66474,70,NULL,NULL,'2MASX J16375293+2615409',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000179,NULL,'15.7g',0.4,'E0',NULL,NULL,NULL,NULL,1,249.470625,26.26142,0.125,NULL,56175501371,877742208,13714722,15.7),(138648,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138648,35.8,0.46,144,66475,70,NULL,NULL,'2MASX J16375334+4304181',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000079,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,249.472083,43.07153,0,NULL,59847674241,935119910,14611248,17),(138649,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138649,35.55,0.34,129,66476,NULL,NULL,NULL,'UGC 10475',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000625,NULL,'15.82',0.1,'Sbc',NULL,NULL,NULL,NULL,1,249.473375,7.56256,0.369,NULL,56772275235,887066800,13860418,15.82),(138650,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138650,35.57,0.34,130,66476,NULL,NULL,'Malmquist cor.','UGC 10475',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138651,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138651,35.63,0.2,134,66476,74.4,NULL,NULL,'UGC 10475',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138652,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138652,35.7,0.12,138,66477,NULL,NULL,NULL,'UGC 10485',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000107,NULL,'16.0',0.1,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,249.473333,39.24972,0.009,NULL,59822037068,934719329,14604989,16),(138653,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138653,34.82,0.33,92.2,66478,70,NULL,NULL,'NGC 6196',NULL,'2015arXiv151105856S',2015,1,1.31,NULL,'G',0.000093,NULL,'13.8g',0.75,'SAB0-: pec','Group member',NULL,NULL,NULL,1,249.474666667,36.07306,0.021,NULL,59750862986,933607234,14587613,13.8),(138654,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138654,35.75,0.4,141,66478,NULL,NULL,'mean','NGC 6196',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138655,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138655,36.42,0.45,192,66478,NULL,NULL,'K','NGC 6196',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138656,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138656,36.17,0.78,171,66479,70,NULL,NULL,'2MASX J16375395-6704531',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,249.474666667,-67.0815,0.593,NULL,45023338728,703489667,10992026,15.9),(138657,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138657,37.66,0.33,341,66480,70,NULL,NULL,'SDSS J163754.22+414639.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00007,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,249.475958333,41.77758,0,NULL,59847410352,935115786,14611184,18.2),(138658,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138658,36.9,0.27,240,66481,70,NULL,NULL,'2MASX J16375645+2518429',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,249.48525,25.312,0.105,NULL,56178025862,877781654,13715338,17.8),(138659,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138659,37.64,0.46,338,66482,70,NULL,NULL,'2MASX J16375742+3912582',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.2g',0.23,'AGN',NULL,NULL,NULL,NULL,1,249.489083,39.21633,0.009,NULL,59822024711,934719136,14604986,17.2),(138660,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138660,37.53,0.46,320,66483,70,NULL,NULL,'SDSS J163758.03+342340.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000137,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,249.491833,34.39472,0.009,NULL,59759727340,933745739,14589777,18.5),(138661,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138661,35.58,0.46,131,66484,70,NULL,NULL,'CGCG 168-026',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000113,NULL,'15.1g',0.55,'E0',NULL,NULL,NULL,NULL,1,249.492667,32.87242,0.049,NULL,59755223764,933675371,14588677,15.1),(138662,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138662,37.07,0.33,259,66485,70,NULL,NULL,'2MASX J16380090+1236068',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000159,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,249.503833,12.60175,0.185,NULL,56881911211,888779862,13887185,16.9),(138663,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138663,35.36,0.46,118,66486,70,NULL,NULL,'CGCG 138-047',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000163,NULL,'15.3g',0.55,'S0/a',NULL,NULL,NULL,NULL,1,249.514125,25.30272,0.105,NULL,56178031794,877781746,13715339,15.3),(138664,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138664,37.31,0.46,289,66487,70,NULL,NULL,'2MASX J16380339+2307242',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000197,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,249.514208333,23.12328,0.177,NULL,56695357368,885864958,13841639,16.9),(138665,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138665,38.02,0.33,401,66488,70,NULL,NULL,'2MASX J16380451+4417272',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000078,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,249.518833,44.29075,0,NULL,59846154777,935096168,14610877,17.3),(138666,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138666,37.43,0.46,306,66489,70,NULL,NULL,'2MASX J16380486+3805219',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00011,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,249.52025,38.08944,0.013,NULL,59820589578,934696712,14604636,16.5),(138667,'GRB','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'N',138667,37.14,NULL,268,66490,65,NULL,'L = 10e57 photons/s','GRB 790113',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138668,'GRB','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'N',138668,40.24,NULL,1120,66490,65,NULL,'L = 2 x 10e58 photons/s','GRB 790113',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138669,'GRB','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'RN',138669,43.66,NULL,5400,66490,NULL,NULL,NULL,'GRB 790113',NULL,'1992grbo.book..107S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138670,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138670,37.97,0.33,393,66491,70,NULL,NULL,'2MASX J16380573+2856137',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000141,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,249.5239583,28.93708,0.049,NULL,56225112457,878517382,13726834,18.4),(138671,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138671,37.93,0.46,385,66492,70,NULL,NULL,'2MASX J16380828-0011449',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.0001,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,249.534375,-0.19583,0.393,NULL,45166794663,705731166,11027049,17),(138672,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138672,37.38,0.27,300,66493,70,NULL,NULL,'2MASX J16380829+1131321',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,249.534416667,11.52561,0.205,NULL,56751000740,886734386,13855224,16.7),(138673,'IRAS','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138673,31.92,0.8,24.2,66494,75,NULL,'MAT, I','MCG -01-42-003',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000017,NULL,'15.5',0.5,'Sc',NULL,NULL,NULL,NULL,1,249.535833,-4.82333,0.773,NULL,46049693273,719526457,11242600,15.5),(138674,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138674,31.63,0.2,21.2,66494,74.4,NULL,NULL,'MCG -01-42-003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138675,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138675,31.8,0.35,22.9,66494,NULL,NULL,NULL,'MCG -01-42-003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138676,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138676,31.89,0.32,23.9,66494,85,NULL,'I, inv','MCG -01-42-003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138677,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138677,31.92,0.32,24.2,66494,85,NULL,'I, raw','MCG -01-42-003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138678,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138678,32.1,0.3,26.3,66494,NULL,NULL,'Malmquist cor.','MCG -01-42-003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138679,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138679,32.12,NULL,26.5,66494,72,NULL,NULL,'MCG -01-42-003',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138680,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138680,32.21,0.43,27.6,66494,75,NULL,'MAT, I, inv','MCG -01-42-003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138681,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138681,32.26,0.43,28.3,66494,75,NULL,'MAT, I, raw','MCG -01-42-003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138682,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138682,32.34,0.43,29.4,66494,75,NULL,'MAT, I, cor','MCG -01-42-003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138683,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138683,35.78,0.07,144,66495,NULL,NULL,NULL,'UGC 10488',NULL,'2009ApJS..182..474S',2009,1,1.17,NULL,'G',0.000172,NULL,'14.5g',0.49,'Sab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,249.5377083,39.91783,0,NULL,59823425578,934741024,14605328,14.5),(138684,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138684,38.71,0.46,552,66496,70,NULL,NULL,'2MASX J16380957+2102121',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,249.5397917,21.03667,0.245,NULL,56705345962,886021030,13844078,18),(138685,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138685,37.6,0.46,331,66497,70,NULL,NULL,'2MASX J16381036+4714052',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,249.541583333,47.23461,0,NULL,59841891841,935029560,14609836,17.4),(138686,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138686,38.81,0.46,577,66498,70,NULL,NULL,'2MASX J16381004+4136229',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000097,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,249.5417917,41.60625,0,NULL,59846523029,935101922,14610967,17.8),(138687,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138687,38.29,0.46,455,66499,70,NULL,NULL,'2MASX J16381251+1556270',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000138,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,249.552125,15.94075,0.257,NULL,56884906532,888826664,13887916,18.2),(138688,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138688,37.13,0.46,266,66500,70,NULL,NULL,'2MASX J16381273+2758227',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'17.78',0.35,NULL,NULL,NULL,NULL,NULL,1,249.553167,27.97308,0.125,NULL,56226305451,878536022,13727125,17.78),(138689,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138689,37.78,0.46,360,66501,70,NULL,NULL,'2MASX J16381283+4028289',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,249.553333,40.47456,0.005,NULL,59823379100,934740298,14605317,17.5),(138690,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138690,36.65,0.46,214,66502,70,NULL,NULL,'MCG +07-34-126',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000107,NULL,'16.0g',0.37,'E0',NULL,NULL,NULL,NULL,1,249.553666667,40.17347,0,NULL,59823469548,934741711,14605339,16),(138691,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138691,36.73,0.46,222,66503,70,NULL,NULL,'2MASX J16381365+2632007',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,249.556791667,26.53364,0.157,NULL,56175511031,877742359,13714724,16.9),(138692,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138692,37.66,0.33,341,66504,70,NULL,NULL,'2MASX J16381456+4147519',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000084,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,249.560583,41.79778,0,NULL,59847410823,935115794,14611184,16.6),(138693,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138693,38.01,0.17,399,66505,70,NULL,NULL,'2MASX J16381500+2754117',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,249.5625417,27.90317,0.125,NULL,56226311513,878536117,13727126,17.5),(138694,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138694,37.95,0.46,389,66506,70,NULL,NULL,'SDSS J163815.35+393725.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000136,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,249.564,39.62375,0.005,NULL,59821860104,934716564,14604946,18.1),(138695,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138695,37.97,0.33,393,66507,70,NULL,NULL,'2MASX J16381556+2859327',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,249.56475,28.9925,0.049,NULL,56224996403,878515568,13726805,17.6),(138696,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138696,37.94,0.33,387,66508,70,NULL,NULL,'2MASX J16381730+1559020',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000167,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,249.5722083,15.98397,0.257,NULL,56884877134,888826205,13887909,17.1),(138697,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138697,36.68,0.46,217,66509,70,NULL,NULL,'2MASX J16381818+1316150',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,249.575833,13.27094,0.209,NULL,56889957682,888905588,13889149,17.2),(138698,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138698,38.65,0.46,537,66510,70,NULL,NULL,'SDSS J163818.73+294808.7',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,249.578083333,29.80242,0.081,NULL,56207941758,878249089,13722642,17.7),(138699,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138699,37.91,0.46,382,66511,70,NULL,NULL,'2MASX J16381938+2244551',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,249.580625,22.74856,0.193,NULL,56695209372,885862646,13841603,17.8),(138700,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138700,36.82,0.46,231,66512,70,NULL,NULL,'2MASX J16382594+3105018',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,249.6079583,31.08389,0.061,NULL,59752524811,933633200,14588018,16.7),(138701,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138701,36.34,0.33,185,66513,70,NULL,NULL,'2MASX J16382636+3242028',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000182,NULL,'16.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,249.609875,32.70086,0.045,NULL,59755448411,933678881,14588732,16.5),(138702,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138702,36.84,0.46,233,66514,70,NULL,NULL,'2MASX J16382850+3209158',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,249.618583333,32.15433,0.045,NULL,59756104987,933689140,14588892,17.1),(138703,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138703,36.59,0.46,208,66515,70,NULL,NULL,'2MASX J16383021+2135080',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.1g',NULL,NULL,NULL,NULL,NULL,NULL,1,249.6257917,21.58547,0.201,NULL,56697199644,885893744,13842089,17.1),(138704,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138704,38.01,0.17,399,66516,70,NULL,NULL,'2MASX J16383023+2746277',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,249.6259583,27.77428,0.141,NULL,56226610928,878540795,13727199,18.4),(138705,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138705,37.72,0.46,350,66517,70,NULL,NULL,'2MASX J16383199+2804437',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,249.633291667,28.07872,0.125,NULL,56226430555,878537977,13727155,17),(138706,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138706,38.01,0.17,399,66518,70,NULL,NULL,'2MASX J16383203+2744437',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,249.6335,27.74539,0.141,NULL,56226604854,878540700,13727198,17.4),(138707,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138707,37.18,0.46,273,66519,70,NULL,NULL,'2MASX J16383216+4614352',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,'FoF','16.1g',0.38,NULL,NULL,NULL,NULL,NULL,1,249.6339583,46.243,0,NULL,59839091658,934985807,14609153,16.1),(138708,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138708,38.01,0.17,399,66520,70,NULL,NULL,'2MASX J16383550+2747337',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,249.648083,27.79258,0.141,NULL,56226610354,878540786,13727199,17),(138709,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138709,37.71,0.46,348,66521,70,NULL,NULL,'2MASX J16383565+3244528',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,249.648708333,32.74789,0.049,NULL,59755421608,933678462,14588725,17.7),(138710,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138710,38.01,0.17,399,66522,70,NULL,NULL,'2MASX J16383614+2748354',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,249.650417,27.80967,0.141,NULL,56226609815,878540778,13727199,17.8),(138711,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138711,36.34,0.33,185,66523,70,NULL,NULL,'CGCG 168-027',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000097,NULL,'15.5g',0.51,'E0',NULL,NULL,NULL,NULL,1,249.667791667,32.54558,0.045,NULL,59755372559,933677696,14588714,15.5),(138712,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138712,38.01,0.17,399,66524,70,NULL,NULL,'2MASX J16384110+2754595',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00018,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,249.6712917,27.91644,0.125,NULL,56226594690,878540542,13727195,17.1),(138713,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138713,37.47,0.46,312,66525,70,NULL,NULL,'2MASX J16384333+2504445',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00018,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,249.680625,25.07897,0.105,NULL,56174835301,877731801,13714559,16.5),(138714,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138714,36.51,0.46,200,66526,70,NULL,NULL,'2MASX J16384623+2840465',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000171,NULL,'15.8g',0.41,NULL,NULL,NULL,NULL,NULL,1,249.6925,28.67944,0.097,NULL,56228540880,878570951,13727671,15.8),(138715,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138715,36.32,0.46,184,66527,70,NULL,NULL,'2MASX J16384734+1218461',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000181,NULL,'15.9g',0.35,'AGN',NULL,NULL,NULL,NULL,1,249.697375,12.31297,0.185,NULL,56882061539,888782211,13887222,15.9),(138716,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138716,37.68,0.46,343,66528,70,NULL,NULL,'2MASX J16384992+2801385',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,249.70825,28.02736,0.125,NULL,56226414745,878537730,13727152,17.4),(138717,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138717,37.96,0.46,391,66529,70,NULL,NULL,'2MASX J16385055+2737585',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,249.71075,27.63289,0.141,NULL,56225860663,878529072,13727016,17.2),(138718,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138718,38.04,0.33,406,66530,70,NULL,NULL,'2MASX J16385065+2716475',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,249.711125,27.28014,0.153,NULL,56225717416,878526834,13726981,18.6),(138719,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138719,38,0.46,398,66531,70,NULL,NULL,'2MASX J16385078+3100159',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,249.711625,31.00442,0.061,NULL,59752574353,933633974,14588030,18),(138720,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138720,37.17,0.67,272,66532,70,NULL,NULL,'2MASX J16385090-6507389',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,249.7122917,-65.12756,0.725,NULL,44990048936,702969514,10983898,16.2),(138721,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138721,36.23,0.53,176,66533,70,NULL,NULL,'2MASX J16385109-6334469',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,249.7127083,-63.57969,0.809,NULL,44474933483,694920835,10858138,15.3),(138722,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138722,38.13,0.46,422,66534,70,NULL,NULL,'2MASX J16385197+3004379',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000193,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,249.7165417,30.07706,0.069,NULL,56208819354,878262802,13722856,17.5),(138723,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138723,37.36,0.46,296,66535,70,NULL,NULL,'2MASX J16385208+3835090',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,249.7170417,38.58581,0.017,NULL,59820478651,934694978,14604609,17.3),(138724,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138724,37.49,0.46,314,66536,70,NULL,NULL,'2MASX J16385655+3427179',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,249.7354583,34.45489,0.009,NULL,59760228213,933753565,14589899,17.7),(138725,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138725,37.12,0.46,265,66537,70,NULL,NULL,'2MASX J16385759+3223489',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00014,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,249.74,32.397,0.041,NULL,59755387893,933677935,14588717,16.6),(138726,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138726,38.54,0.46,509,66538,70,NULL,NULL,'2MASX J16390000+1122076',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,249.750125,11.36867,0.189,NULL,56750696693,886729635,13855150,17.7),(138727,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138727,38.04,0.33,406,66539,70,NULL,NULL,'2MASX J16390078+2724205',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'17.1g',0.33,NULL,NULL,NULL,NULL,NULL,1,249.753333,27.40558,0.177,NULL,56225935363,878530240,13727035,17.1),(138728,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138728,37.21,0.46,276,66540,70,NULL,NULL,'2MASX J16390183+2909275',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000163,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,249.757625,29.15764,0.081,NULL,56225486603,878523228,13726925,17),(138729,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138729,38.15,0.46,426,66541,70,NULL,NULL,'2MASX J16390192+2249278',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000191,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,249.7580417,22.82447,0.189,NULL,56695103089,885860985,13841577,16.9),(138730,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138730,38.1,0.23,416,66542,70,NULL,NULL,'2MASX J16390245+2613395',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000182,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,249.760167,26.22772,0.141,NULL,56231343541,878614742,13728355,17),(138731,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138731,37.14,0.23,269,66543,70,NULL,NULL,'2MASX J16390516+2942235',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000147,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,249.771417,29.70656,0.081,NULL,56225510466,878523601,13726931,16.6),(138732,'IRAS','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138732,34.72,0.8,87.8,66544,75,NULL,'MAT, I','ESO 101- G 005',NULL,'1997ApJS..109..333W',1997,1,1.5,'Marginal HIPASS detection.','G',0.000032,NULL,'15.16',0.3,'SB(s)c: sp',NULL,NULL,NULL,NULL,1,249.775167,-66.90914,0.585,NULL,45023252163,703488315,10992004,15.16),(138733,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138733,34.58,0.43,82.4,66544,75,NULL,'MAT, I, raw','ESO 101- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138734,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138734,34.62,0.53,84.1,66544,NULL,NULL,'Malmquist cor.','ESO 101- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138735,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138735,34.64,0.32,84.8,66544,85,NULL,'I, raw','ESO 101- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138736,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138736,34.69,0.32,86.6,66544,85,NULL,'I, inv','ESO 101- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138737,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138737,34.78,0.49,90.2,66544,75,NULL,'IR','ESO 101- G 005',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138738,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138738,34.79,0.43,90.8,66544,75,NULL,'MAT, I, inv','ESO 101- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138739,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138739,34.81,0.43,91.6,66544,75,NULL,'MAT, I, cor','ESO 101- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138740,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138740,35.04,0.44,102,66544,NULL,NULL,NULL,'ESO 101- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138741,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138741,35.08,0.2,104,66544,74.4,NULL,NULL,'ESO 101- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138742,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138742,37.9,0.46,381,66545,70,NULL,NULL,'SDSS J163906.32+222738.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000139,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,249.776333333,22.46075,0.189,NULL,56697921969,885905030,13842266,18.5),(138743,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138743,37.42,0.46,305,66546,70,NULL,NULL,'2MASX J16390859+3415447',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000167,NULL,'16.4g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,249.785875,34.26236,0.005,NULL,59760204973,933753202,14589893,16.4),(138744,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138744,37.14,0.23,269,66547,70,NULL,NULL,'2MASX J16390906+2937018',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,249.78775,29.61728,0.049,NULL,56225551235,878524238,13726941,17.3),(138745,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138745,37.85,0.46,372,66548,70,NULL,NULL,'2MASX J16390917+4723017',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000138,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,249.788333,47.38394,NULL,NULL,59841986996,935031046,14609860,17),(138746,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138746,37.24,0.46,280,66549,70,NULL,NULL,'2MASX J16390960+1139276',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,249.790041667,11.65764,0.205,NULL,56750757013,886730578,13855165,16.8),(138747,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138747,38.52,0.46,505,66550,70,NULL,NULL,'SDSS J163909.71+244604.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000154,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,249.7905,24.76797,0.113,NULL,56175236300,877738067,13714657,18.6),(138748,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138748,37.14,0.23,269,66551,70,NULL,NULL,'2MASX J16391452+2954477',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000194,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,249.8104583,29.91317,0.081,NULL,56208801406,878262521,13722851,17.2),(138749,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138749,38.27,0.46,452,66552,70,NULL,NULL,'2MASX J16391688+3905577',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000159,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,249.820375,39.0995,0.009,NULL,59823659333,934744677,14605385,17.2),(138750,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138750,37.14,0.23,269,66553,70,NULL,NULL,'2MASX J16391845+2953168',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,249.827125,29.88808,0.081,NULL,56208800491,878262507,13722851,17.8),(138751,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138751,37.33,0.46,292,66554,70,NULL,NULL,'SDSS J163918.85+334937.6',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000144,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,249.8285417,33.82711,0.017,NULL,59760177931,933752780,14589887,18.4),(138752,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138752,34.79,0.46,90.7,66555,70,NULL,NULL,'CGCG 224-084',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000053,NULL,'15.3g',0.3,'S0^-',NULL,NULL,NULL,NULL,1,249.829875,42.18414,0,NULL,59847247251,935113238,14611144,15.3),(138753,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138753,37.13,0.27,266,66556,70,NULL,NULL,'2MASX J16391952+2044394',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000187,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,249.831291667,20.74422,0.265,NULL,56705090141,886017033,13844016,16.7),(138754,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138754,38.09,0.46,414,66557,70,NULL,NULL,'2MASX J16392018+1054036',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,249.834083,10.90111,0.205,NULL,56753072122,886766751,13855730,16.7),(138755,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138755,35.86,NULL,149,66558,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10498',NULL,'2010Ap&SS.325..163P',2010,1,0.94,NULL,'G',0.000015,NULL,'17.2g',0.13,'Sc',NULL,NULL,NULL,NULL,1,249.839708333,29.36978,0.065,NULL,56225450629,878522666,13726916,17.2),(138756,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138756,35.87,NULL,149,66558,NULL,NULL,'Dipole + Quadrupole','UGC 10498',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138757,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138757,35.87,NULL,149,66558,NULL,NULL,'Dipole','UGC 10498',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138758,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138758,35.98,NULL,157,66558,NULL,NULL,NULL,'UGC 10498',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138759,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138759,37.08,0.2,261,66558,74.4,NULL,NULL,'UGC 10498',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138760,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138760,36.73,0.52,221,66559,70,NULL,NULL,'2MASX J16392187-6515453',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'16.83',0.3,NULL,NULL,NULL,NULL,NULL,1,249.84,-65.26269,0.621,NULL,44989956772,702968074,10983876,16.83),(138761,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138761,36.84,0.58,233,66560,70,NULL,NULL,'2MASX J16392192-6405533',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'12.74',0.34,NULL,NULL,NULL,NULL,NULL,1,249.841333,-64.09819,0.797,NULL,44474390673,694912354,10858005,12.74),(138762,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138762,34.72,0.47,87.8,66561,70,NULL,NULL,'UGC 10492',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000117,NULL,'14.70',0.9,'SA(s)a:','Isolated galaxy',NULL,NULL,NULL,1,249.847875,-2.40653,0.477,NULL,45165536961,705711515,11026742,14.7),(138763,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138763,38.1,0.23,416,66562,70,NULL,NULL,'2MASX J16392403+2614359',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,249.850125,26.24339,0.141,NULL,56231338434,878614663,13728354,NULL),(138764,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138764,38,0.46,398,66563,70,NULL,NULL,'2MASX J16392492+2336095',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,249.853833,23.60281,0.157,NULL,56694661016,885854078,13841469,17.7),(138765,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138765,36.45,0.46,195,66564,70,NULL,NULL,'2MASX J16392550+2636359',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.88',0.34,NULL,NULL,NULL,NULL,NULL,1,249.856291667,26.60986,0.157,NULL,56231141843,878611591,13728306,16.88),(138766,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138766,37.72,0.46,350,66565,70,NULL,NULL,'2MASX J16392611+1113396',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,249.8587083,11.22772,0.189,NULL,56752728560,886761383,13855646,17.4),(138767,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138767,34.58,0.2,82.4,66566,74.4,NULL,NULL,'CGCG 080-051',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.00011,NULL,'15.1',0.25,'Sb',NULL,NULL,NULL,NULL,1,249.859917,11.2105,0.189,NULL,56752726579,886761352,13855646,15.1),(138768,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138768,38.54,0.46,510,66567,70,NULL,NULL,'SDSS J163929.14+302726.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000158,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,249.871417,30.45747,0.053,NULL,56208760438,878261881,13722841,18.4),(138769,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138769,38.11,0.46,418,66568,70,NULL,NULL,'SDSS J163929.22+285111.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,249.87175,28.85319,0.089,NULL,56228510160,878570471,13727663,18.6),(138770,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138770,37.13,0.27,266,66569,70,NULL,NULL,'2MASX J16392937+2039125',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000179,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,249.872375,20.65353,0.265,NULL,56705073092,886016767,13844011,16.6),(138771,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138771,36.69,0.46,218,66570,70,NULL,NULL,'2MASX J16393025-0017546',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000082,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,249.876166667,-0.29867,0.413,NULL,45167314794,705739293,11027176,17.2),(138772,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138772,36.78,0.46,227,66571,70,NULL,NULL,'2MASX J16393099+1331563',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000161,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,249.879083,13.53228,0.233,NULL,56890791773,888918621,13889353,17),(138773,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138773,36.78,0.66,227,66572,70,NULL,NULL,'2MASX J16393117-6342184',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,249.879875,-63.70506,0.797,NULL,44474910773,694920480,10858132,14.5),(138774,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138774,36.64,0.58,213,66573,70,NULL,NULL,'2MASX J16393126-6546264',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,249.88025,-65.77394,0.577,NULL,44992166384,703002599,10984415,15.7),(138775,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138775,35.64,0.46,134,66574,70,NULL,NULL,'2MASX J16393494+3556047',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000057,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,249.895667,35.93458,0.025,NULL,59758412828,933725200,14589456,16.2),(138776,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138776,37.44,0.46,308,66575,70,NULL,NULL,'2MASX J16393968+2848015',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000145,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,249.915333,28.80044,0.089,NULL,56228494669,878570229,13727659,17.3),(138777,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138777,37.27,0.46,284,66576,70,NULL,NULL,'2MASX J16393977+2945356',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00014,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,249.915625,29.75981,0.049,NULL,56225246456,878519475,13726866,17.9),(138778,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138778,37.3,0.57,288,66577,70,NULL,NULL,'2MASX J16394428-6334325',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,249.934458333,-63.57578,0.809,NULL,44475034269,694922410,10858162,16),(138779,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138779,37.63,0.46,336,66578,70,NULL,NULL,'2MASX J16394520+3009182',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000155,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,249.938458333,30.15506,0.057,NULL,56208875770,878263683,13722870,17),(138780,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138780,37.63,0.46,335,66579,70,NULL,NULL,'2MASX J16394547+2348174',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000174,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,249.939333333,23.80481,0.157,NULL,56694429498,885850460,13841413,16.5),(138781,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138781,38.1,0.23,416,66580,70,NULL,NULL,'2MASX J16394583+2611396',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000182,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,249.9410417,26.19419,0.141,NULL,56231375471,878615241,13728363,17.7),(138782,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138782,37.91,0.46,382,66581,70,NULL,NULL,'2MASX J16394718+3634161',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,249.946541667,36.57103,0.017,NULL,59750204837,933596950,14587452,17.3),(138783,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138783,36.38,0.46,189,66582,70,NULL,NULL,'2MASX J16394974+3654331',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000083,NULL,'15.6g',0.43,'E0',NULL,NULL,NULL,NULL,1,249.9574583,36.90928,0.037,NULL,59820427671,934694182,14604596,15.6),(138784,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138784,36.95,0.55,245,66583,70,NULL,NULL,'2MASX J16395239-6448565',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,249.968375,-64.81572,0.729,NULL,44989285382,702957584,10983712,15.5),(138785,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138785,37.13,0.27,266,66584,70,NULL,NULL,'2MASX J16395390+2029554',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,249.97475,20.49878,0.245,NULL,56705031986,886016124,13844001,17.6),(138786,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138786,38.1,0.23,416,66585,70,NULL,NULL,'2MASX J16395445+2610106',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,249.976917,26.16964,0.141,NULL,56231376625,878615259,13728363,17.5),(138787,'Tully est','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138787,32.48,0.8,31.3,66586,75,NULL,'B','ARK 507',NULL,'1988NBGC.C....0000T',1988,1,0.76,'1994AJ....107.1629T has V = 2100 +- 100 km/s.','G',0.000185,NULL,'15.2g',0.33,'Spiral','Group non-member, background',NULL,NULL,NULL,1,249.978375,37.18008,0.017,NULL,59820414054,934693969,14604593,15.2),(138788,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138788,37.13,0.46,267,66587,70,NULL,NULL,'2MASX J16395810+1146129',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,249.992083,11.77031,0.217,NULL,56750526790,886726981,13855109,NULL),(138789,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138789,37.21,0.46,276,66588,70,NULL,NULL,'2MASX J16395829+3843582',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000103,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,249.992791667,38.73264,0.041,NULL,59827029524,934797336,14606208,16.6),(138790,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138790,37.19,0.46,274,66589,70,NULL,NULL,'2MASX J16395857+2959003',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00015,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,249.994167,29.98336,0.053,NULL,56208298994,878254671,13722729,17.2),(138791,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:57','1','PTF10qjl',NULL,138791,37.21,0.03,262,66590,70,NULL,'SiFTO+SALT2, SN PTF10qjl','PTF10qjl',0.0579,'2012MNRAS.426.2359M',2012,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,249.997208333,12.10708,0.213,NULL,56881570971,888774546,13887102,NULL),(138792,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:57','1','PTF10qjl',NULL,138792,37.33,0.02,276,66590,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10qjl',0.0579,'2014MNRAS.438.1391P',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138793,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138793,37.77,0.46,358,66591,70,NULL,NULL,'2MASX J16395937+3114343',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,249.9972917,31.24286,0.053,NULL,59752344255,933630378,14587974,17.8),(138794,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138794,37.77,0.46,358,66592,70,NULL,NULL,'2MASX J16395939+2711566',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,249.9974583,27.19889,0.169,NULL,56233282504,878645039,13728828,16.8),(138795,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138795,35.97,0.66,156,66593,70,NULL,NULL,'2MASX J16395943-1614076',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,249.997666667,-16.23544,0.941,NULL,46128381688,720755963,11261811,15.9),(138796,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138796,37.47,0.46,312,66594,70,NULL,NULL,'SDSS J164000.02+371454.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00018,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,250.000083,37.24858,0.025,NULL,59820420313,934694067,14604594,18.3),(138797,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138797,36.72,0.46,221,66595,70,NULL,NULL,'2MASX J16400010+2929286',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000181,NULL,'15.9g',0.42,NULL,NULL,NULL,NULL,NULL,1,250.000541667,29.49125,0.081,NULL,56225381886,878521591,13726899,15.9),(138798,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138798,37.26,0.46,283,66596,70,NULL,NULL,'2MASX J16400248+3008463',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.2g',0.29,'AGN',NULL,NULL,NULL,NULL,1,250.010417,30.14622,0.057,NULL,56208876728,878263698,13722870,17.2),(138799,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138799,38.38,0.33,475,66597,70,NULL,NULL,'2MASX J16400286+3641102',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,250.012083,36.68608,0.017,NULL,59750200353,933596880,14587451,18.1),(138800,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138800,38.08,0.27,413,66598,70,NULL,NULL,'2MASX J16400629+3927232',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000143,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,250.026291667,39.45661,0.005,NULL,59823824580,934747259,14605425,16.8),(138801,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138801,35.77,0.46,143,66599,70,NULL,NULL,'2MASX J16401129+4616549',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000165,NULL,'15.9g',0.37,'S0',NULL,NULL,NULL,NULL,1,250.04725,46.28194,0,NULL,59839134210,934986472,14609163,15.9),(138802,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138802,35.71,0.48,139,66600,70,NULL,NULL,'2MASX J16401184-6216143',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000143,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.049167,-62.27064,0.929,NULL,44461877494,694716835,10854950,15.7),(138803,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138803,39.36,0.46,745,66601,70,NULL,NULL,'2MASX J16401207+2742291',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,250.0502917,27.70811,0.141,NULL,56226664937,878541639,13727213,18.5),(138804,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138804,36.82,0.58,231,66602,70,NULL,NULL,'2MASX J16401372-6512215',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.0570417,-65.20594,0.661,NULL,44989876541,702966820,10983856,14.2),(138805,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138805,38.17,0.46,431,66603,70,NULL,NULL,'2MASX J16401421+2731472',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,250.059167,27.52972,0.153,NULL,56225768156,878527627,13726994,18.2),(138806,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138806,37.23,0.46,280,66604,70,NULL,NULL,'2MASX J16401458+1134139',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,250.060667,11.57064,0.217,NULL,56752623571,886759743,13855620,16.6),(138807,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138807,38.42,0.46,483,66605,70,NULL,NULL,'2MASX J16401712+2643532',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,250.0712917,26.73144,0.161,NULL,56231116459,878611194,13728299,17.7),(138808,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138808,36.7,0.53,219,66606,70,NULL,NULL,'2MASX J16401807-8432591',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,250.07475,-84.54975,0.341,NULL,44085908588,688842321,10763161,16.6),(138809,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138809,38.08,0.27,413,66607,70,NULL,NULL,'2MASX J16402036+3929102',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,250.084875,39.48625,0.005,NULL,59823831321,934747364,14605427,18),(138810,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138810,38.08,0.27,413,66608,70,NULL,NULL,'2MASX J16402038+3934432',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000113,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,250.084917,39.57856,0,NULL,59823786417,934746662,14605416,16.8),(138811,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138811,36.86,0.54,235,66609,70,NULL,NULL,'2MASX J16402107-6426115',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.08775,-64.43647,0.737,NULL,44466086834,694782606,10855978,15.5),(138812,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138812,37.77,0.46,358,66610,70,NULL,NULL,'2MASX J16402135+4045192',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000082,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,250.088917,40.75525,0,NULL,59816133805,934627090,14603548,17.2),(138813,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138813,35.3,0.27,115,66611,NULL,NULL,NULL,'UGC 10504',NULL,'2009ApJS..182..474S',2009,1,1.07,NULL,'G',0.000015,NULL,'14.5g',0.52,'Sab','Field galaxy',NULL,NULL,NULL,1,250.0945417,33.67975,0.045,NULL,59760018744,933750292,14589848,14.5),(138814,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138814,35.5,0.25,126,66611,NULL,NULL,'Malmquist cor.','UGC 10504',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138815,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138815,35.64,0.2,134,66611,74.4,NULL,NULL,'UGC 10504',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138816,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138816,35.76,0.4,142,66611,NULL,NULL,'mean','UGC 10504',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138817,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138817,35.89,0.47,151,66611,NULL,NULL,'H','UGC 10504',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138818,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138818,36.02,0.46,160,66611,NULL,NULL,'J','UGC 10504',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138819,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138819,37.36,0.46,296,66612,70,NULL,NULL,'2MASX J16402360+2857362',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,250.0982083,28.96,0.081,NULL,56228642671,878572541,13727695,17.6),(138820,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138820,35.92,0.55,153,66613,70,NULL,NULL,'2MASX J16402378-6416455',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.0992917,-64.27925,0.737,NULL,44466070434,694782350,10855974,14.2),(138821,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138821,34.93,0.46,97,66614,70,NULL,NULL,'MRK 0887',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.00019,NULL,'14.3g',0.67,'Compact',NULL,NULL,NULL,NULL,1,250.11675,39.32014,0.005,NULL,59823880615,934748134,14605439,14.3),(138822,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138822,38.38,0.33,475,66615,70,NULL,NULL,'2MASX J16402854+3650501',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000155,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,250.119,36.84725,0.037,NULL,59820260589,934691571,14604555,17),(138823,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138823,36.15,0.46,170,66616,70,NULL,NULL,'2MASX J16403495+4632409',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000157,NULL,'15.8g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,250.145417,46.54464,0,NULL,59837489755,934960777,14608762,15.8),(138824,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138824,36.28,0.46,180,66617,70,NULL,NULL,'CGCG 197-004',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000191,NULL,'15.5g',0.42,'S0',NULL,NULL,NULL,NULL,1,250.1599583,33.93114,0.041,NULL,59760046013,933750718,14589854,15.5),(138825,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138825,37.54,0.46,322,66618,70,NULL,NULL,'2MASX J16404166+1939440',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,250.1734583,19.66236,0.265,NULL,56691976358,885812130,13840814,17.4),(138826,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138826,37.85,0.46,371,66619,70,NULL,NULL,'2MASX J16404252+1126105',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,250.177083,11.43642,0.201,NULL,56752862496,886763476,13855679,16.5),(138827,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138827,36.52,0.46,201,66620,70,NULL,NULL,'2MASX J16404328+2713202',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.66',NULL,NULL,NULL,NULL,NULL,NULL,1,250.180125,27.22236,0.169,NULL,56233244176,878644440,13728819,17.66),(138828,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138828,36.12,0.46,167,66621,70,NULL,NULL,'2MASX J16404559+4316560',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000097,NULL,'16.5g',0.28,'BLAGN',NULL,NULL,NULL,'Sy 1',1,250.190083,43.28244,0,NULL,59848313651,935129900,14611404,16.5),(138829,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138829,36,0.55,159,66622,70,NULL,NULL,'2MASX J16404809-7243286',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.200167,-72.72453,0.237,NULL,44116291180,689317049,10770578,15),(138830,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138830,37.34,0.46,294,66623,70,NULL,NULL,'2MASX J16405223+2540584',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000156,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,250.2177083,25.68294,0.145,NULL,56232268518,878629195,13728581,16.6),(138831,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138831,38.07,0.46,411,66624,70,NULL,NULL,'SDSS J164054.04+342035.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,250.225167,34.34308,0.041,NULL,59760264630,933754134,14589908,18.2),(138832,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138832,36.46,0.21,196,66625,70,NULL,NULL,'2MASX J16405922+2650044',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,250.24675,26.83453,0.169,NULL,56231079533,878610617,13728290,17),(138833,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138833,36.8,0.46,229,66626,70,NULL,NULL,'SDSS J164101.14+250035.9',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,250.25475,25.01,0.141,NULL,56229729281,878589520,13727961,16.8),(138834,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138834,36.57,0.46,206,66627,70,NULL,NULL,'2MASX J16410217+3049387',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000171,NULL,'16.1g',0.33,'E0',NULL,NULL,NULL,NULL,1,250.258875,30.82736,0.057,NULL,56208612779,878259574,13722805,16.1),(138835,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138835,37.12,0.46,265,66628,70,NULL,NULL,'2MASX J16410358+3215527',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000143,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,250.264917,32.26472,0.045,NULL,59753951272,933655488,14588367,17.7),(138836,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138836,36.46,0.46,196,66629,70,NULL,NULL,'2MASX J16410775+4234061',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000097,NULL,'16.07',0.4,NULL,NULL,NULL,NULL,NULL,1,250.2822917,42.56842,0,NULL,59847899310,935123426,14611303,16.07),(138837,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138837,36.12,0.82,167,66630,70,NULL,NULL,'2MASX J16410820-1636132',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.28425,-16.60369,1.073,NULL,46125421704,720709714,11261089,15.9),(138838,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138838,35.12,0.46,106,66631,70,NULL,NULL,'MCG +07-34-132',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.0001,NULL,'14.6g',0.45,'S0',NULL,NULL,NULL,NULL,1,250.290875,39.75686,0,NULL,59824364442,934755694,14605557,14.6),(138839,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138839,37.18,0.33,272,66632,70,NULL,NULL,'2MASX J16411051+2903023',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.92',0.39,NULL,NULL,NULL,NULL,NULL,1,250.293917,29.05081,0.081,NULL,56228613284,878572082,13727688,16.92),(138840,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138840,37.63,0.46,336,66633,70,NULL,NULL,'2MASX J16411556+2958253',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000146,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,250.314833,29.97356,0.053,NULL,56208377939,878255905,13722748,17.6),(138841,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138841,37.3,0.46,288,66634,70,NULL,NULL,'2MASX J16411595+2332074',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000156,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,250.3164583,23.53539,0.153,NULL,56677700684,885589073,13837329,17),(138842,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138842,37.48,0.46,313,66635,70,NULL,NULL,'2MASX J16411672+3724398',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000123,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,250.319666667,37.41111,0.025,NULL,59820315200,934692425,14604569,17.4),(138843,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138843,36.65,0.27,214,66636,70,NULL,NULL,'CGCG 080-054',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.00022,NULL,'15.0g',0.62,'BrClG',NULL,NULL,NULL,NULL,1,250.319833333,13.39178,0.237,NULL,56882140894,888783451,13887241,15),(138844,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138844,38.36,0.46,470,66637,70,NULL,NULL,'SDSS J164118.21+340852.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,250.325916667,34.14794,0.033,NULL,59760251168,933753924,14589905,18.3),(138845,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138845,37.18,0.33,272,66638,70,NULL,NULL,'2MASX J16411835+2903305',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,250.3265417,29.05856,0.081,NULL,56228610821,878572044,13727688,17.2),(138846,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138846,35.66,0.46,136,66639,70,NULL,NULL,'CGCG 138-057',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000073,NULL,'15.3g',0.4,'E0',NULL,NULL,NULL,NULL,1,250.32875,22.27875,0.221,NULL,56696814740,885887730,13841995,15.3),(138847,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138847,37.41,0.46,304,66640,70,NULL,NULL,'2MASX J16412059+3159264',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,250.3357083,31.99072,0.041,NULL,59753809105,933653267,14588332,17.4),(138848,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138848,36.65,0.27,214,66641,70,NULL,NULL,'2MASX J16412066+1325573',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000209,NULL,'15.5g',0.54,NULL,NULL,NULL,NULL,NULL,1,250.3360417,13.43253,0.237,NULL,56882139899,888783435,13887241,15.5),(138849,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138849,35.85,NULL,148,66642,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2065',NULL,'2010Ap&SS.325..163P',2010,1,0.66,NULL,'G',NULL,NULL,'17.1',0.08,'Sd',NULL,NULL,NULL,NULL,1,250.336333333,77.19625,0.145,NULL,57066982465,891671601,13932368,17.1),(138850,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138850,35.87,NULL,149,66642,NULL,NULL,NULL,'FGC 2065',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138851,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138851,35.88,NULL,150,66642,NULL,NULL,'Dipole + Quadrupole','FGC 2065',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138852,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138852,35.9,NULL,151,66642,NULL,NULL,'Dipole','FGC 2065',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138853,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138853,38.11,0.12,418,66643,70,NULL,NULL,'2MASX J16412258+2719425',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,250.3442083,27.3285,0.169,NULL,56234017634,878656525,13729008,17.5),(138854,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138854,36.65,0.27,214,66644,70,NULL,NULL,'SDSS J164122.73+132722.4',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,250.3447083,13.45622,0.237,NULL,56880292211,888754565,13886790,17.1),(138855,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138855,37.08,0.81,261,66645,70,NULL,NULL,'2MFGC 13361',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.356167,-63.60178,0.809,NULL,44475005743,694921964,10858155,16),(138856,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138856,35.54,0.46,128,66646,70,NULL,NULL,'2MASX J16413032+2214555',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000167,NULL,'16.0g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,250.3765,22.24889,0.221,NULL,56696800011,885887500,13841992,16),(138857,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138857,38.25,0.46,447,66647,70,NULL,NULL,'SDSS J164131.49+285906.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000167,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,250.38125,28.98511,0.081,NULL,56228803646,878575056,13727735,18.4),(138858,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138858,37.44,0.46,308,66648,70,NULL,NULL,'2MASX J16413253+2345515',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000141,NULL,'17.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,250.3854583,23.76425,0.161,NULL,56677879937,885591874,13837373,17.6),(138859,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138859,37.55,0.33,324,66649,70,NULL,NULL,'2MASX J16413257+3715588',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000097,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,250.385541667,37.26639,0.025,NULL,59824556406,934758693,14605604,16.8),(138860,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138860,36.51,0.71,200,66650,70,NULL,NULL,'2MASX J16413529-6311256',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.397083,-63.19044,0.849,NULL,44475371850,694927685,10858245,15.8),(138861,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138861,38.01,0.46,400,66651,70,NULL,NULL,'2MASX J16413559+3033525',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00018,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,250.3984583,30.56447,0.077,NULL,56208536575,878258383,13722787,17),(138862,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138862,34.48,NULL,78.8,66652,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 080-057',NULL,'2010Ap&SS.325..163P',2010,1,0.97,NULL,'G',0.000009,NULL,'15.6',0.12,'Sbc',NULL,NULL,NULL,NULL,1,250.398708333,9.43211,0.321,NULL,56759199874,886862498,13857226,15.6),(138863,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138863,34.5,NULL,79.3,66652,NULL,NULL,'Dipole + Quadrupole','CGCG 080-057',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138864,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138864,34.51,NULL,79.9,66652,NULL,NULL,'Dipole','CGCG 080-057',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138865,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138865,34.56,NULL,81.6,66652,NULL,NULL,NULL,'CGCG 080-057',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138866,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138866,38.38,0.46,474,66653,70,NULL,NULL,'2MASX J16413581+3049275',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000185,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,250.399417,30.82425,0.057,NULL,56208606060,878259469,13722804,17.6),(138867,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138867,37.54,0.46,322,66654,70,NULL,NULL,'SDSS J164136.81+435319.0',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,'FoF','16.9g',0.29,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,250.403417,43.88861,0,NULL,59848032939,935125514,14611336,16.9),(138868,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138868,36.04,0.27,162,66655,70,NULL,NULL,'CGCG 224-090',NULL,'2015arXiv151105856S',2015,1,1.23,NULL,'G',0.00009,NULL,'14.5g',0.47,'S0',NULL,NULL,NULL,NULL,1,250.4057083,40.1635,0,NULL,59824254989,934753984,14605531,14.5),(138869,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138869,37.48,0.46,313,66656,70,NULL,NULL,'2MASX J16414109+2542535',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,250.421083333,25.71481,0.145,NULL,56232497189,878632768,13728637,17.3),(138870,'CMD','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138870,14.7,NULL,0.0087,66657,NULL,NULL,NULL,'MESSIER 013',NULL,'2008A&A...477..139L',2008,1,NULL,NULL,'*Cl',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,250.4234583,36.46131,0.009,0,59758405895,933725092,14589454,NULL),(138871,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138871,38.11,0.12,418,66658,70,NULL,NULL,'2MASX J16414263+2730265',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000138,NULL,'18.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,250.427833,27.50739,0.153,NULL,56233937551,878655274,13728988,18.4),(138872,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138872,38.79,0.46,574,66659,70,NULL,NULL,'SDSS J164142.68+232859.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,250.427875,23.48319,0.153,NULL,56678602562,885603165,13837549,18.7),(138873,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138873,35.73,0.4,140,66660,NULL,NULL,'mean','CGCG 224-092',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'GPair',0.000223,NULL,NULL,NULL,'14.247',NULL,NULL,NULL,NULL,1,250.449167,39.98722,0,NULL,59824388852,934756075,14605563,NULL),(138874,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138874,35.81,0.45,145,66660,NULL,NULL,'K','CGCG 224-092',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138875,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138875,37.55,0.33,324,66661,70,NULL,NULL,'2MASX J16414938+3718335',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000187,NULL,'16.5g',0.37,'AGN',NULL,NULL,NULL,NULL,1,250.455667,37.30928,0.025,NULL,59824569150,934758892,14605607,16.5),(138876,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138876,34.66,0.49,85.7,66662,75,NULL,'IR','ESO 517- G 013',NULL,'2011yCatp016004901K',2011,1,1.08,NULL,'G',0.000027,NULL,'16.9',0.11,'Scd',NULL,NULL,NULL,NULL,1,250.4752917,-24.94564,0.981,NULL,45823768294,715996379,11187443,16.9),(138877,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138877,35.76,0.43,142,66662,75,NULL,'3.6 micron, color + selection bias corrected','ESO 517- G 013',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138878,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138878,38.8,0.46,576,66663,70,NULL,NULL,'2MASX J16415445+2558423',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,250.476833333,25.97828,0.157,NULL,56232441869,878631904,13728623,18.4),(138879,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138879,36.75,0.46,224,66664,70,NULL,NULL,'2MASX J16420164+2731454',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000162,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,250.5067917,27.52928,0.153,NULL,56233930505,878655164,13728986,16.9),(138880,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138880,38.15,0.46,427,66665,70,NULL,NULL,'2MASX J16420190+1949596',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,250.507917,19.83322,0.289,NULL,56692046718,885813229,13840831,17.4),(138881,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138881,36.62,0.46,211,66666,70,NULL,NULL,'2MASX J16420205+3731046',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000113,NULL,'16.0g',0.34,'S0',NULL,NULL,NULL,NULL,1,250.508583333,37.51786,0.029,NULL,59824593653,934759275,14605613,16),(138882,'IRAS','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138882,31.9,0.8,24,66667,75,NULL,'MAT, I','MCG -01-42-004',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000004,NULL,'15',1.4,'SAB(rs)bc:',NULL,NULL,NULL,NULL,1,250.51325,-5.03269,0.749,NULL,46047836192,719497440,11242147,15),(138883,'Sosies','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138883,31.77,0.23,22.6,66667,NULL,NULL,NULL,'MCG -01-42-004',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138884,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138884,31.5,0.4,20,66667,NULL,NULL,NULL,'MCG -01-42-004',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138885,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138885,31.58,0.43,20.7,66667,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-42-004',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138886,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138886,31.67,0.2,21.6,66667,74.4,NULL,NULL,'MCG -01-42-004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138887,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138887,31.69,0.43,21.8,66667,75,NULL,'3.6 micron, color corrected','MCG -01-42-004',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138888,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138888,31.92,0.32,24.2,66667,NULL,NULL,NULL,'MCG -01-42-004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138889,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138889,31.98,0.47,24.9,66667,NULL,NULL,'H','MCG -01-42-004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138890,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138890,31.98,0.4,24.9,66667,NULL,NULL,'mean','MCG -01-42-004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138891,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138891,32.02,NULL,25.3,66667,72,NULL,NULL,'MCG -01-42-004',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138892,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138892,32.03,0.46,25.5,66667,NULL,NULL,'J','MCG -01-42-004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138893,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138893,32.09,0.45,26.2,66667,NULL,NULL,'K','MCG -01-42-004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138894,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138894,32.09,0.32,26.2,66667,85,NULL,'I, raw','MCG -01-42-004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138895,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138895,32.12,0.32,26.5,66667,85,NULL,'I, inv','MCG -01-42-004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138896,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138896,32.13,0.29,26.6,66667,NULL,NULL,'Malmquist cor.','MCG -01-42-004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138897,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138897,32.17,0.43,27.2,66667,75,NULL,'MAT, I, raw','MCG -01-42-004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138898,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138898,32.26,0.43,28.3,66667,75,NULL,'MAT, I, cor','MCG -01-42-004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138899,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138899,32.31,0.43,29,66667,75,NULL,'MAT, I, inv','MCG -01-42-004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138900,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138900,36.33,0.46,185,66668,70,NULL,NULL,'2MASX J16420354+3232385',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000099,NULL,'16.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,250.514875,32.54422,0.045,NULL,59754038361,933656849,14588388,16.7),(138901,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138901,38.49,0.46,498,66669,70,NULL,NULL,'2MASX J16420614+2743124',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000171,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,250.5255417,27.72025,0.141,NULL,56233651123,878650798,13728918,18.1),(138902,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138902,37.27,0.46,285,66670,70,NULL,NULL,'2MASX J16420641+1928576',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,250.526833333,19.48267,0.329,NULL,56693941701,885842839,13841294,17.3),(138903,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138903,37.11,0.46,264,66671,70,NULL,NULL,'2MASX J16420922+3809525',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00009,NULL,'16.1g',0.4,'E0',NULL,NULL,NULL,NULL,1,250.538458333,38.16475,0.029,NULL,59825143035,934767859,14605747,16.1),(138904,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138904,36.27,0.55,179,66672,70,NULL,NULL,'2MASX J16421059-1958560',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.544083,-19.98217,0.821,NULL,45955334739,718052105,11219564,15.4),(138905,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138905,36.15,0.46,170,66673,70,NULL,NULL,'2MASX J16421264+3842285',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000113,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,250.552917,38.70794,0.041,NULL,59827272466,934801132,14606267,16.5),(138906,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138906,38.05,0.46,407,66674,70,NULL,NULL,'2MASXi J1642133+300130',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,250.555583,30.02511,0.053,NULL,56208160386,878252506,13722695,18),(138907,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138907,36.04,0.27,162,66675,70,NULL,NULL,'2MASX J16421465+3950265',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000087,NULL,'16.1g',0.23,'S0',NULL,NULL,NULL,NULL,1,250.560916667,39.84078,0,NULL,59824176735,934752761,14605511,16.1),(138908,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138908,35.92,0.2,153,66676,74.4,NULL,NULL,'CGCG 109-039',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',NULL,NULL,'15.7',0.4,NULL,NULL,NULL,NULL,NULL,1,250.565917,19.15161,0.337,NULL,56690716567,885792446,13840506,15.7),(138909,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138909,38.11,0.12,418,66677,70,NULL,NULL,'2MASX J16421698+2723274',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,250.570916667,27.39092,0.169,NULL,56234075430,878657428,13729022,17.1),(138910,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138910,34.42,NULL,76.7,66678,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2059',NULL,'2010Ap&SS.325..163P',2010,1,0.74,NULL,'G',NULL,NULL,'16.8',0.09,'Sdm',NULL,NULL,NULL,NULL,1,250.575833,48.46056,0,NULL,59829827031,934841047,14606891,16.8),(138911,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138911,34.45,NULL,77.6,66678,NULL,NULL,'Dipole + Quadrupole','FGC 2059',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138912,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138912,34.47,NULL,78.3,66678,NULL,NULL,'Dipole','FGC 2059',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138913,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138913,34.7,NULL,87.3,66678,NULL,NULL,NULL,'FGC 2059',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138914,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138914,36.36,0.46,187,66679,70,NULL,NULL,'2MASX J16421858+1305156',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,250.577417,13.08758,0.213,NULL,56882266943,888785420,13887272,17.3),(138915,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138915,35.06,0.74,103,66680,70,NULL,NULL,'2MASX J16422094-1532001',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.58725,-15.53336,1.065,NULL,46126633958,720728655,11261385,15.4),(138916,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138916,35.89,0.49,151,66681,75,NULL,'IR','FGC 2058',NULL,'2011yCatp016004901K',2011,1,0.98,NULL,'G',0.000025,NULL,'17.1g',0.13,'Scd',NULL,NULL,NULL,NULL,1,250.6,20.01322,0.289,NULL,56691895247,885810863,13840794,17.1),(138917,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138917,36.02,NULL,160,66681,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2058',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138918,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138918,36.03,NULL,161,66681,NULL,NULL,'Dipole + Quadrupole','FGC 2058',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138919,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138919,36.04,NULL,161,66681,NULL,NULL,'Dipole','FGC 2058',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138920,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138920,35.79,0.55,144,66682,70,NULL,NULL,'2MASX J16422432-0021486',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.65',NULL,NULL,NULL,NULL,NULL,NULL,1,250.60125,-0.36367,0.365,NULL,45178111499,705907992,11029812,15.65),(138921,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138921,37.9,0.46,381,66683,70,NULL,NULL,'2MASX J16422543+2857193',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,250.6060417,28.95528,0.089,NULL,56228763225,878574425,13727725,17.5),(138922,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138922,33.91,0.51,60.4,66684,70,NULL,NULL,'FAIRALL 0165',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3b',NULL,'Elliptical',NULL,NULL,NULL,NULL,1,250.606291667,-68.90142,0.369,NULL,45026897895,703545279,10992894,15.3),(138923,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138923,38.11,0.12,418,66685,70,NULL,NULL,'SDSS J164230.39+272600.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000146,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,250.626667,27.43358,0.153,NULL,56234068664,878657322,13729020,18.7),(138924,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138924,38.02,0.46,402,66686,70,NULL,NULL,'2MASX J16423355+3410297',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,250.639875,34.17486,0.033,NULL,59759553974,933743030,14589734,17.3),(138925,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138925,38.11,0.12,418,66687,70,NULL,NULL,'2MASX J16423407+2730354',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00016,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,250.6419583,27.50972,0.153,NULL,56234060498,878657195,13729018,18.6),(138926,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138926,37.53,0.46,321,66688,70,NULL,NULL,'2MASX J16423624+2907584',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000178,NULL,'18.9g',0.09,NULL,NULL,NULL,NULL,NULL,1,250.650917,29.133,0.081,NULL,56228238951,878566233,13727597,18.9),(138927,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138927,36.14,0.56,169,66689,70,NULL,NULL,'2MASX J16423809-6539427',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.6587083,-65.66197,0.549,NULL,44991987201,702999800,10984371,15.5),(138928,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138928,38.11,0.12,418,66690,70,NULL,NULL,'2MASX J16423866+2726374',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000201,NULL,'16.5g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,250.6610417,27.44372,0.153,NULL,56234066479,878657288,13729020,16.5),(138929,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138929,38.33,0.46,463,66691,70,NULL,NULL,'2MASX J16423947+3943216',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,250.664417,39.72256,0,NULL,59824148511,934752320,14605505,17.1),(138930,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138930,37.83,0.46,369,66692,70,NULL,NULL,'2MASX J16424226+3534217',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00018,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,250.67625,35.57283,0.025,NULL,59759209310,933737645,14589650,17.3),(138931,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138931,37.04,0.46,256,66693,70,NULL,NULL,'2MASX J16424521+3557037',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000137,NULL,'17.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,250.68825,35.95111,0.053,NULL,59758504775,933726637,14589478,17.6),(138932,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138932,36.42,0.52,193,66694,70,NULL,NULL,'2MASX J16424551-6450297',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.689583,-64.84158,0.673,NULL,44466362301,694786910,10856045,14.8),(138933,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138933,38.11,0.12,418,66695,70,NULL,NULL,'SDSS J164245.85+272759.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.8g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,250.691125,27.46667,0.153,NULL,56234066065,878657282,13729020,18.8),(138934,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138934,37.86,0.69,373,66696,70,NULL,NULL,'2MASX J16424816-6637200',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.700708333,-66.62217,0.545,NULL,44991528032,702992625,10984259,15.8),(138935,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138935,38.11,0.12,418,66697,70,NULL,NULL,'2MASX J16424896+2726514',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000161,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,250.703875,27.4475,0.185,NULL,56234037851,878656841,13729013,18.5),(138936,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138936,37.38,0.46,300,66698,70,NULL,NULL,'2MASX J16425081+4625112',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000162,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,250.71175,46.41983,0.009,NULL,59837342295,934958473,14608726,17.1),(138937,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138937,37.82,0.46,367,66699,70,NULL,NULL,'2MASX J16425236+2937039',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,250.7182917,29.61792,0.077,NULL,56227061951,878547842,13727310,18.2),(138938,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138938,38.43,0.46,486,66700,70,NULL,NULL,'2MASX J16425377+2752379',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000173,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,250.7239583,27.87728,0.125,NULL,56233810468,878653288,13728957,18.4),(138939,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138939,37.2,0.46,276,66701,70,NULL,NULL,'2MASX J16425482+3543327',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000149,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,250.728375,35.72572,0.041,NULL,59758486929,933726358,14589474,17.4),(138940,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138940,37.94,0.46,387,66702,70,NULL,NULL,'2MASX J16425518+2715139',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000134,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,250.73,27.25389,0.193,NULL,56233463159,878647861,13728872,18.5),(138941,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138941,38.11,0.12,418,66703,70,NULL,NULL,'2MASX J16425540+2724359',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,250.73075,27.41003,0.185,NULL,56233862305,878654098,13728970,18),(138942,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138942,36.04,0.27,162,66704,70,NULL,NULL,'2MASX J16425732+4007487',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000088,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,250.738833,40.13025,0,NULL,59823970591,934749540,14605461,16.7),(138943,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138943,37.56,0.46,326,66705,70,NULL,NULL,'2MASX J16425821+4122267',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000088,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,250.742625,41.37411,0,NULL,59816821329,934637833,14603716,16.7),(138944,'Brightest Stars','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138944,31.65,NULL,21.4,66706,NULL,NULL,'BS','NGC 6207',NULL,'2006MNRAS.369.1303H',2006,1,3,NULL,'G',0.000005,NULL,'12.16',1.3,'SA(s)c         HII','Isolated galaxy',NULL,NULL,NULL,1,250.765625,36.83242,0.049,NULL,59812925487,934576960,14602765,12.16),(138945,'Brightest Stars','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138945,32,NULL,25.1,66706,NULL,NULL,'BS','NGC 6207',NULL,'2006MNRAS.369.1303H',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138946,'SNII optical','2016-12-15 15:15:43','2016-12-16 11:20:58','1','SN 2004A',NULL,138946,31.46,0.1,19.6,66706,NULL,NULL,'SCM','NGC 6207',NULL,'2015ApJ...799..215P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138947,'SNII optical','2016-12-15 15:15:43','2016-12-16 11:20:58','1','SN 2004A','R',138947,31.52,0.35,20.2,66706,NULL,NULL,'SCM, V','NGC 6207',NULL,'2008BASI...36...79G',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138948,'SNII optical','2016-12-15 15:15:43','2016-12-16 11:20:58','1','SN 2004A',NULL,138948,31.54,0.22,20.3,66706,NULL,NULL,'V, photospheric magnitude method','NGC 6207',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138949,'SNII optical','2016-12-15 15:15:43','2016-12-16 11:20:58','1','SN 2004A','R',138949,31.56,0.12,20.5,66706,NULL,NULL,'SCM, Nugent et al. 06','NGC 6207',NULL,'2008BASI...36...79G',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138950,'SNII optical','2016-12-15 15:15:43','2016-12-16 11:20:58','1','SN 2004A','R',138950,31.56,0.28,20.5,66706,NULL,NULL,'SCM, I','NGC 6207',NULL,'2008BASI...36...79G',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138951,'SNII optical','2016-12-15 15:15:43','2016-12-16 11:20:58','1','SN 2004A',NULL,138951,31.61,NULL,21,66706,NULL,NULL,'SCM','NGC 6207',NULL,'2006MNRAS.369.1303H',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138952,'SNII optical','2016-12-15 15:15:43','2016-12-16 11:20:58','1','SN 2004A',NULL,138952,31.66,0.17,21.5,66706,NULL,NULL,'I, photospheric magnitude method','NGC 6207',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138953,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138953,30.62,0.4,13.3,66706,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 3 galaxy group','NGC 6207',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138954,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138954,30.73,0.43,14,66706,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6207',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138955,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138955,30.87,0.43,14.9,66706,75,NULL,'3.6 micron, color corrected','NGC 6207',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138956,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138956,31.07,0.36,16.4,66706,NULL,NULL,NULL,'NGC 6207',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138957,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138957,31.08,0.2,16.4,66706,74.4,NULL,NULL,'NGC 6207',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138958,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138958,31.21,0.4,17.4,66706,75,NULL,'B','NGC 6207',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138959,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138959,31.42,0.82,19.2,66706,NULL,NULL,NULL,'NGC 6207',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138960,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138960,31.47,0.8,19.6,66706,NULL,NULL,'Malmquist cor.','NGC 6207',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138961,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138961,38.11,0.12,418,66707,70,NULL,NULL,'SDSS J164306.17+272847.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000133,NULL,'19.0g',0.11,NULL,NULL,NULL,NULL,NULL,1,250.77575,27.47989,0.185,NULL,56233871078,878654235,13728972,19),(138962,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138962,37.58,0.46,328,66708,70,NULL,NULL,'2MASX J16430747+2302298',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,250.781167,23.04153,0.165,NULL,56681450436,885647663,13838244,17.7),(138963,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138963,37.32,0.46,291,66709,70,NULL,NULL,'2MASX J16430814+3546321',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00015,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,250.783791667,35.77544,0.041,NULL,59758492136,933726439,14589475,16.8),(138964,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138964,37.83,0.46,368,66710,70,NULL,NULL,'2MASX J16430834+3024331',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,250.7847917,30.40911,0.077,NULL,56211715036,878308047,13723563,17.6),(138965,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138965,36.87,0.46,237,66711,70,NULL,NULL,'2MASX J16430901+2406140',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000182,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,250.787583333,24.10372,0.161,NULL,56677765855,885590091,13837345,16.4),(138966,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138966,34.07,0.46,65.1,66712,70,NULL,NULL,'CGCG 251-041',NULL,'2015arXiv151105856S',2015,1,0.95,NULL,'G',0.000083,NULL,'14.8g',0.41,'NLAGN',NULL,NULL,NULL,'Sy 2',1,250.7895,45.84575,0.005,NULL,59840003375,935000052,14609375,14.8),(138967,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138967,36.49,0.56,198,66713,70,NULL,NULL,'2MASX J16431143-6310125',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.7975417,-63.17014,0.865,NULL,44475612519,694931445,10858303,15.8),(138968,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138968,37.74,0.46,354,66714,70,NULL,NULL,'2MASXi J1643122+351258',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,250.800917,35.21622,0.053,NULL,59758977219,933734019,14589594,17.7),(138969,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:58','1','SN 2010dt',NULL,138969,36.96,0.21,234,66715,73.8,NULL,'SALT 2 (SNANA)','CGCG 168-029',0.0529,'2014ApJ...795...44R',2014,1,0.83,NULL,'G',0.000174,NULL,'15.9g',0.25,'Sb',NULL,NULL,NULL,NULL,1,250.8052083,32.67792,0.073,NULL,59754029788,933656715,14588386,15.9),(138970,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:58','1','SN 2010dt','R',138970,36.94,0.21,244,66715,NULL,NULL,'MLCS2k2, R(V) = 1.8','CGCG 168-029',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138971,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:58','1','SN 2010dt','R',138971,36.98,0.22,249,66715,NULL,NULL,'MLCS2k2, R(V) = 3.1','CGCG 168-029',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138972,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138972,36.1,0.46,166,66716,70,NULL,NULL,'2MASX J16431341+2520219',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000148,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,250.8060417,25.33956,0.137,NULL,56229193938,878581155,13727830,16.8),(138973,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138973,37.82,0.46,366,66717,70,NULL,NULL,'SDSS J164317.58+303718.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00013,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,250.8232917,30.62178,0.077,NULL,56211852332,878310192,13723596,18.5),(138974,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138974,37.69,0.46,346,66718,70,NULL,NULL,'2MASX J16431784+1326397',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000146,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,250.8245,13.44431,0.265,NULL,56880334978,888755234,13886800,17.9),(138975,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138975,36.85,0.33,235,66719,70,NULL,NULL,'2MASX J16431882+2646529',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000167,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,250.8285,26.78136,0.201,NULL,56231699440,878620303,13728442,17.8),(138976,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138976,36.85,0.33,235,66720,70,NULL,NULL,'2MASX J16432000+2637409',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000198,NULL,'16.2g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,250.83325,26.62794,0.205,NULL,56231676968,878619952,13728436,16.2),(138977,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138977,31.23,1.1,17.7,66721,NULL,NULL,NULL,'NGC 6232',NULL,'2009ApJS..182..474S',2009,1,1.6,'MCG misprints name as \'NGC 6237\'; corrected in MCG errata.','G',NULL,NULL,'13.40',1.6,'(R\')SB(s)a','Group member',NULL,NULL,NULL,1,250.834333333,70.63253,0.197,NULL,57842962193,903796284,14121816,13.4),(138978,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138978,31.28,1.08,18,66721,NULL,NULL,'Malmquist cor.','NGC 6232',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138979,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138979,34.8,0.46,91.2,66722,70,NULL,NULL,'NGC 6212',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.00008,NULL,'14.7g',0.62,'Sb             Sy1',NULL,NULL,NULL,'Sy 1',1,250.846417,39.80644,0,NULL,59824063799,934750996,14605484,14.7),(138980,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138980,34.17,0.47,68.4,66723,NULL,NULL,'H','NGC 6202',NULL,'2007A&A...465...71T',2007,1,0.8,'Identification as NGC 6202 is very uncertain.','G',0.000043,NULL,'13.8',0.4,'PECULR',NULL,NULL,NULL,NULL,1,250.8467917,61.98394,0.009,NULL,57543775272,899121488,14048773,13.8),(138981,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138981,34.24,0.45,70.4,66723,NULL,NULL,'K','NGC 6202',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138982,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138982,34.33,0.46,73.3,66723,NULL,NULL,'J','NGC 6202',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138983,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138983,34.49,0.4,78.9,66723,NULL,NULL,'mean','NGC 6202',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138984,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138984,38.11,0.12,418,66724,70,NULL,NULL,'2MASX J16432464+2728588',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,250.8527917,27.48294,0.185,NULL,56233875905,878654311,13728973,NULL),(138985,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138985,38.45,0.46,490,66725,70,NULL,NULL,'SDSS J164325.15+323031.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,250.854833,32.50864,0.045,NULL,59754068752,933657324,14588395,18.3),(138986,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138986,38.11,0.12,418,66726,70,NULL,NULL,'2MASX J16432726+2734598',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000175,NULL,'17.9g',0.18,'BrClG',NULL,NULL,NULL,NULL,1,250.863666667,27.58325,0.185,NULL,56233880666,878654385,13728974,17.9),(138987,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138987,37.68,0.33,343,66727,70,NULL,NULL,'SDSS J164330.03+241951.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000164,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,250.875125,24.33106,0.157,NULL,56195378211,878052784,13719574,18.3),(138988,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138988,36.75,0.33,224,66728,70,NULL,NULL,'2MASX J16433224+2542068',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.00011,NULL,'16.70',0.56,NULL,NULL,NULL,NULL,NULL,1,250.884375,25.70183,0.149,NULL,56232694349,878635849,13728685,16.7),(138989,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138989,38.11,0.12,418,66729,70,NULL,NULL,'SDSS J164332.25+273332.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000151,NULL,'18.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,250.884375,27.55897,0.185,NULL,56233881706,878654401,13728975,18.9),(138990,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138990,34.39,0.51,75.5,66730,70,NULL,NULL,'FAIRALL 0167',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00009,NULL,'14.9b',1,'SA0-',NULL,NULL,NULL,NULL,1,250.8875417,-68.9785,0.369,NULL,45026849999,703544531,10992883,14.9),(138991,'BL Lac Luminosity','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138991,38.42,NULL,483,66731,NULL,NULL,'Min. z = 0.12','1FGL J1643.5-0646',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,250.889,-6.78,0.757,NULL,46092722887,720198795,11253106,NULL),(138992,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138992,36.46,0.21,196,66732,70,NULL,NULL,'2MASX J16433596+2638508',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,250.8997917,26.64758,0.201,NULL,56231497141,878617142,13728392,17.5),(138993,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138993,35.25,0.49,112,66733,75,NULL,'IR','CGCG 110-004',NULL,'2011yCatp016004901K',2011,1,0.84,NULL,'G',0.000083,NULL,'16.0g',0.24,'Scd',NULL,NULL,NULL,NULL,1,250.900708333,20.23169,0.297,NULL,56684359721,885693120,13838955,16),(138994,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138994,35.89,0.62,151,66734,70,NULL,NULL,'2MASX J16433871-6417046',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.91125,-64.28458,0.745,NULL,44466777352,694793396,10856146,15.2),(138995,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138995,37.22,0.65,279,66735,70,NULL,NULL,'2MASX J16433990-0039091',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.24',NULL,NULL,NULL,NULL,NULL,NULL,1,250.91625,-0.6525,0.377,NULL,45178029891,705906717,11029792,16.24),(138996,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138996,37.92,0.27,384,66736,70,NULL,NULL,'2MASX J16434047+3227316',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,250.9185417,32.45875,0.045,NULL,59753185795,933643528,14588180,17.1),(138997,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138997,37.68,0.33,343,66737,70,NULL,NULL,'2MASX J16434122+2418289',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,250.9217083,24.30811,0.157,NULL,56196239491,878066242,13719785,17.6),(138998,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138998,38.59,0.46,523,66738,70,NULL,NULL,'2MASX J16434263+3703145',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000171,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,250.927583,37.05392,0.065,NULL,59824636719,934759948,14605624,18.1),(138999,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138999,38.07,0.46,411,66739,70,NULL,NULL,'2MASX J16434420+2914358',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,250.934291667,29.24319,0.081,NULL,56227075585,878548056,13727313,18.1),(139000,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139000,38.14,0.46,424,66740,70,NULL,NULL,'2MASX J16434453+1927497',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,250.9355,19.46381,0.345,NULL,56682410525,885662664,13838479,16.6),(139001,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139001,38.11,0.12,418,66741,70,NULL,NULL,'2MASX J16434471+2729259',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.7g',0.2,'BrClG',NULL,NULL,NULL,NULL,1,250.936375,27.49053,0.185,NULL,56233828479,878653569,13728962,17.7),(139002,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139002,37.92,0.27,384,66742,70,NULL,NULL,'2MASX J16434616+3225287',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000196,NULL,'17.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,250.942375,32.42453,0.045,NULL,59753186131,933643533,14588180,17.3),(139003,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139003,37.78,0.46,359,66743,70,NULL,NULL,'2MASX J16434718+2720098',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,250.9467083,27.33608,0.185,NULL,56233382158,878646596,13728853,17.7),(139004,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139004,36.89,0.63,238,66744,70,NULL,NULL,'2MASX J16435522-6528495',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.980167,-65.48042,0.565,NULL,44992015986,703000249,10984378,15.8),(139005,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139005,37.92,0.27,384,66745,70,NULL,NULL,'2MASX J16435579+3222337',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000156,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,250.982625,32.376,0.045,NULL,59753267940,933644811,14588200,17.1),(139006,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139006,36.75,0.33,224,66746,70,NULL,NULL,'2MASX J16435623+2541426',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000192,NULL,'16.0g',0.35,'E0',NULL,NULL,NULL,NULL,1,250.984458333,25.69517,0.149,NULL,56232691525,878635805,13728684,16),(139007,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139007,33.98,0.47,62.5,66747,70,NULL,NULL,'2MASX J16440203-6156345',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'13.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,251.008708333,-61.94292,0.945,NULL,44473293380,694895209,10857737,13.2),(139008,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139008,38.8,0.46,575,66748,70,NULL,NULL,'2MASX J16440478+4038547',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.0001,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,251.02,40.64867,0,NULL,59816537494,934633398,14603646,17.7),(139009,'IRAS','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139009,34.4,0.8,75.7,66749,75,NULL,'CF, r','UGC 10536',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.00004,NULL,'14.6',0.9,'Sb',NULL,NULL,NULL,NULL,1,251.0252083,62.08733,0.009,NULL,57543996286,899124941,14048827,14.6),(139010,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139010,34.82,0.38,92,66749,75,NULL,'CF, r, raw','UGC 10536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139011,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139011,34.96,0.38,98,66749,75,NULL,'CF, r, inv','UGC 10536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139012,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139012,35.05,0.38,102,66749,75,NULL,'CF, r, cor','UGC 10536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139013,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139013,36.89,0.46,238,66750,70,NULL,NULL,'2MASX J16440680+4236135',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000084,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,251.028416667,42.60369,0,NULL,59844918185,935076846,14610575,16.7),(139014,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139014,37.15,0.46,269,66751,70,NULL,NULL,'2MASX J16440951+3708468',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000152,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,251.039833,37.14631,0.065,NULL,59824519586,934758118,14605595,17.2),(139015,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139015,36.71,0.46,219,66752,70,NULL,NULL,'2MASX J16441142+2758106',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,251.0475,27.96964,0.165,NULL,56236540399,878695943,13729624,17.7),(139016,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139016,36.46,0.21,196,66753,70,NULL,NULL,'2MASX J16441234+2644046',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,251.051583333,26.73478,0.201,NULL,56232010673,878625166,13728518,17),(139017,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139017,37.04,0.46,255,66754,70,NULL,NULL,'2MASX J16441390+2528286',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000221,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,251.057875,25.47456,0.141,NULL,56229332483,878583320,13727864,16.6),(139018,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139018,34.38,NULL,75.2,66755,NULL,NULL,'Dipole','ESO 179- G 012',NULL,'2010Ap&SS.325..163P',2010,1,2.46,'Star superposed.','G',0.000025,NULL,'15.7',0.22,'Sd',NULL,NULL,NULL,NULL,1,251.0892083,-55.49367,NULL,NULL,44539847735,695935120,10873986,15.7),(139019,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139019,34.4,NULL,75.8,66755,NULL,NULL,'Dipole + Quadrupole','ESO 179- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139020,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139020,34.4,NULL,75.8,66755,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 179- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139021,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139021,37.26,0.46,283,66756,70,NULL,NULL,'2MASX J16442163+3726188',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000097,NULL,'16.1g',0.4,'E0',NULL,NULL,NULL,NULL,1,251.090083,37.43869,0.061,NULL,59824529627,934758275,14605598,16.1),(139022,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139022,34.83,NULL,92.5,66757,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10534',NULL,'2010Ap&SS.325..163P',2010,1,1,NULL,'G',NULL,NULL,'17.',0.08,'Sd',NULL,NULL,NULL,NULL,1,251.097625,58.84253,0,NULL,57651917161,900811205,14075175,17),(139023,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139023,34.84,NULL,93.1,66757,NULL,NULL,'Dipole + Quadrupole','UGC 10534',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139024,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139024,34.87,NULL,94,66757,NULL,NULL,'Dipole','UGC 10534',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139025,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139025,34.9,NULL,95.7,66757,NULL,NULL,NULL,'UGC 10534',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139026,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139026,36.57,0.46,206,66758,70,NULL,NULL,'2MASX J16442354+2444136',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000182,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,251.097958333,24.73708,0.153,NULL,56196182369,878065349,13719771,16.3),(139027,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139027,36.46,0.21,196,66759,70,NULL,NULL,'2MASX J16442500+2636355',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00017,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,251.10425,26.60989,0.201,NULL,56232035172,878625549,13728524,16.6),(139028,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139028,38.09,0.46,416,66760,70,NULL,NULL,'2MASX J16442704+1327119',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,251.112625,13.45336,0.213,NULL,56880718513,888761226,13886894,17.3),(139029,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139029,38.13,0.46,423,66761,70,NULL,NULL,'SDSS J164427.92+435130.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000083,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,251.116375,43.85853,0.005,NULL,59844771375,935074552,14610539,18.1),(139030,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139030,38.11,0.12,418,66762,70,NULL,NULL,'2MASX J16442869+2720158',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000171,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,251.119583,27.33767,0.185,NULL,56233395517,878646804,13728856,18.2),(139031,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139031,36.79,0.78,228,66763,70,NULL,NULL,'2MASX J16443025-6338313',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,251.125916667,-63.64208,0.745,NULL,44474638067,694916219,10858065,16),(139032,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139032,34.6,0.46,83.1,66764,70,NULL,NULL,'MRK 0888',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000106,NULL,'15.1g',0.53,'E/S0','Isolated galaxy',NULL,NULL,NULL,1,251.128166667,19.94075,0.333,NULL,56684412951,885693952,13838968,15.1),(139033,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139033,36.46,0.21,196,66765,70,NULL,NULL,'CGCG 138-066',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000183,NULL,'15.4',0.51,NULL,NULL,NULL,NULL,NULL,1,251.133875,26.68275,0.201,NULL,56232047983,878625749,13728527,15.4),(139034,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139034,38.22,0.46,440,66766,70,NULL,NULL,'SDSS J164432.18+272149.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,251.134083,27.36389,0.185,NULL,56233408677,878647010,13728859,18.3),(139035,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139035,37.85,0.46,372,66767,70,NULL,NULL,'SDSS J164434.43+280258.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,251.1434583,28.04964,0.161,NULL,56236686579,878698227,13729659,18.2),(139036,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139036,31.61,0.4,21,66768,NULL,NULL,NULL,'NGC 6236',NULL,'2009AJ....138..323T',2009,1,2.9,NULL,'G',0.00002,NULL,'12.63',1.7,'SAB(s)cd','Group member',NULL,NULL,NULL,1,251.144375,70.78022,0.197,NULL,57840231598,903753618,14121150,12.63),(139037,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139037,31.83,0.4,23.3,66768,75,NULL,'B','NGC 6236',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139038,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139038,31.87,0.2,23.7,66768,74.4,NULL,NULL,'NGC 6236',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139039,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139039,31.91,0.43,24,66768,75,NULL,'3.6 micron, color corrected','NGC 6236',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139040,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139040,31.95,0.43,24.6,66768,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6236',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139041,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139041,32.12,0.55,26.5,66768,NULL,NULL,NULL,'NGC 6236',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139042,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139042,32.3,0.51,28.9,66768,NULL,NULL,'Malmquist cor.','NGC 6236',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139043,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139043,38.33,0.46,464,66769,70,NULL,NULL,'2MASX J16443654+3618376',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000143,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,251.152125,36.31042,0.065,NULL,59744937625,933514650,14586166,16.9),(139044,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139044,35.64,0.59,134,66770,70,NULL,NULL,'2MASX J16444001-1540553',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.6I',0.4,NULL,NULL,NULL,NULL,NULL,1,251.16675,-15.68206,1.113,NULL,46126673182,720729268,11261394,14.6),(139045,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139045,38.26,0.46,448,66771,70,NULL,NULL,'2MASX J16444051+2745419',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,251.16875,27.7615,0.173,NULL,56236521830,878695653,13729619,17.7),(139046,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139046,37.45,0.46,309,66772,70,NULL,NULL,'2MASXi J1644418+411853',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00007,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,251.1745,41.31486,0,NULL,59816686931,934635733,14603683,17.6),(139047,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139047,37.53,0.46,321,66773,70,NULL,NULL,'2MASX J16444298+2704059',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,251.1792083,27.06836,0.193,NULL,56233300448,878645319,13728833,17.3),(139048,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139048,35.84,0.61,147,66774,70,NULL,NULL,'2MASX J16444520-2056572',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,251.188417,-20.94917,0.965,NULL,45924608951,717572014,11212062,15.7),(139049,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139049,37.63,0.27,336,66775,70,NULL,NULL,'2MASX J16444570+3413121',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,251.190417,34.22017,0.061,NULL,59757603917,933712561,14589258,17.1),(139050,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139050,36.02,0.56,160,66776,70,NULL,NULL,'2MASX J16444633-6506322',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,251.1932083,-65.109,0.673,NULL,44989705403,702964146,10983814,15.6),(139051,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139051,38.07,0.46,410,66777,70,NULL,NULL,'2MASX J16445119+3040151',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000205,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,251.213167,30.67092,0.077,NULL,56211889742,878310777,13723605,17.2),(139052,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139052,37.34,0.46,294,66778,70,NULL,NULL,'2MASX J16445206+3245481',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00016,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,251.2170417,32.76325,0.069,NULL,59753203320,933643801,14588184,17.1),(139053,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139053,37.63,0.27,336,66779,70,NULL,NULL,'2MASX J16445287+3412511',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000203,NULL,'16.3g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,251.2202917,34.21422,0.061,NULL,59757603329,933712552,14589258,16.3),(139054,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139054,37.33,0.46,293,66780,70,NULL,NULL,'2MASX J16445350+3427121',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000139,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,251.2229583,34.45333,0.073,NULL,59757569502,933712023,14589250,17.5),(139055,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139055,37.08,0.46,261,66781,70,NULL,NULL,'2MASX J16445461+3131592',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000178,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,251.227583,31.53314,0.073,NULL,56210964750,878296324,13723380,16.9),(139056,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139056,37.63,0.27,336,66782,70,NULL,NULL,'2MASX J16445497+3411112',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,251.228916667,34.18644,0.061,NULL,59757602180,933712534,14589258,18),(139057,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139057,37.44,0.46,307,66783,70,NULL,NULL,'2MASX J16450114+2754233',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000054,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,251.254833,27.90653,0.165,NULL,56236569625,878696400,13729631,17.7),(139058,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139058,38.73,0.46,556,66784,70,NULL,NULL,'2MASX J16450188+4008167',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000101,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,251.25775,40.13778,0.005,NULL,59823945474,934749148,14605455,17.5),(139059,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139059,37.79,0.46,361,66785,70,NULL,NULL,'2MASX J16450236+3631587',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,251.25975,36.533,0.069,NULL,59812985994,934577906,14602779,18.1),(139060,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139060,37,0.46,252,66786,70,NULL,NULL,'2MASX J16450397+3838407',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00009,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,251.2664583,38.64475,0.025,NULL,59827413404,934803334,14606302,16.2),(139061,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139061,37.52,0.46,319,66787,70,NULL,NULL,'2MASX J16450581+3454402',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000184,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,251.274167,34.91122,0.049,NULL,59745041797,933516278,14586191,17.4),(139062,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139062,37.06,0.33,259,66788,70,NULL,NULL,'2MASX J16450708+4208249',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000113,NULL,'16.3g',0.34,'NLAGN',NULL,NULL,NULL,'Sy 2',1,251.279583,42.14022,0,NULL,59818693271,934667082,14604173,16.3),(139063,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139063,34.44,0.49,77.2,66789,75,NULL,'IR','UGC 10542',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',NULL,NULL,'15.60',0.2,'Sc',NULL,NULL,NULL,NULL,1,251.2814583,61.84025,0.033,NULL,57535409479,898990773,14046730,15.6),(139064,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139064,34.66,0.47,85.6,66789,NULL,NULL,'H','UGC 10542',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139065,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139065,34.67,0.4,86,66789,NULL,NULL,'mean','UGC 10542',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139066,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139066,34.72,0.45,88,66789,NULL,NULL,'K','UGC 10542',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139067,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139067,34.78,0.2,90.4,66789,74.4,NULL,NULL,'UGC 10542',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139068,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139068,34.83,0.48,92.5,66789,NULL,NULL,'Malmquist cor.','UGC 10542',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139069,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139069,34.9,0.47,95.6,66789,NULL,NULL,NULL,'UGC 10542',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139070,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139070,34.96,0.46,98.1,66789,NULL,NULL,'J','UGC 10542',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139071,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139071,34.52,0.51,80.1,66790,70,NULL,NULL,'ESO 101- G 011',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000147,NULL,'14.45',0.9,'SA(r)0/a:',NULL,NULL,NULL,NULL,1,251.283,-66.61681,0.545,NULL,45021929554,703467649,10991682,14.45),(139072,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139072,37.53,0.46,321,66791,70,NULL,NULL,'2MASX J16451012+3649398',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000107,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,251.29225,36.82789,0.073,NULL,59813074014,934579281,14602801,16.7),(139073,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139073,36.5,0.46,200,66792,70,NULL,NULL,'2MASX J16451067+4253289',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00008,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,251.2945417,42.89156,0.021,NULL,59845104626,935079759,14610621,16.3),(139074,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139074,35.09,0.49,104,66793,75,NULL,'IR','CGCG 168-032',NULL,'2011yCatp016004901K',2011,1,0.86,NULL,'G',0.000094,NULL,'15.7g',0.28,'Sc',NULL,NULL,NULL,NULL,1,251.296667,31.30364,0.065,NULL,56210767542,878293242,13723331,15.7),(139075,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139075,35.41,0.2,121,66794,74.4,NULL,NULL,'CGCG 168-032',NULL,'2013AJ....146...86T',2013,1,0.86,NULL,'G',0.000094,NULL,'15.7g',0.28,'Sc',NULL,NULL,NULL,NULL,1,251.296667,31.30364,0.065,NULL,56210767542,878293242,13723331,15.7),(139076,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139076,37.16,0.46,271,66795,70,NULL,NULL,'2MASX J16451300+2654573',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000137,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,251.3042917,26.91589,0.229,NULL,56230152551,878596133,13728064,17.5),(139077,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139077,38.65,0.46,536,66796,70,NULL,NULL,'2MASX J16451441+1311005',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,251.31,13.18356,0.213,NULL,56882872899,888794889,13887420,17.8),(139078,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139078,35.97,0.46,156,66797,70,NULL,NULL,'SDSS J164515.55+431711.3',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00008,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,251.3147917,43.2865,0.013,NULL,59845360283,935083754,14610683,16.3),(139079,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139079,35.97,0.46,156,66798,70,NULL,NULL,'2MASX J16451764+2412234',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00017,NULL,'16.1g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,251.3235,24.20639,0.169,NULL,56195701876,878057841,13719653,16.1),(139080,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139080,39.05,0.46,644,66799,70,NULL,NULL,'2MASX J16451852+3837358',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,'FoF','17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,251.327167,38.62658,0.025,NULL,59826672372,934791755,14606121,17.6),(139081,'GRB','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139081,46.8,1.59,5730,66800,NULL,NULL,NULL,'GRB 090715B',3,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,251.339875,44.83889,0,NULL,59836785655,934949775,14608590,NULL),(139082,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139082,37.06,0.33,259,66801,70,NULL,NULL,'2MASX J16452713+4204450',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000089,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,251.362917,42.07936,0,NULL,59818685292,934666957,14604171,16.6),(139083,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139083,38.17,0.23,430,66802,70,NULL,NULL,'B2 1643+27',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000189,NULL,'16.4g',0.37,'BrClG',NULL,NULL,'radio jet',NULL,1,251.365333,27.33497,0.193,NULL,56236922539,878701914,13729717,16.4),(139084,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139084,37.55,0.27,323,66803,70,NULL,NULL,'2MASX J16452982+3105322',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000177,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,251.3744583,31.09231,0.065,NULL,56211091477,878298304,13723411,16.9),(139085,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139085,34.06,0.47,64.9,66804,70,NULL,NULL,'2MASX J16453066-6254412',NULL,'2014MNRAS.445.2677S',2014,1,0.88,NULL,'G',0.00015,NULL,'15.03',0.48,NULL,NULL,NULL,NULL,NULL,1,251.377625,-62.91089,0.777,NULL,44475498470,694929663,10858275,15.03),(139086,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139086,36.89,0.46,239,66805,70,NULL,NULL,'2MASX J16453592+3134172',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.00018,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,251.39975,31.57136,0.073,NULL,56211000605,878296884,13723388,16.2),(139087,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139087,37.98,0.46,394,66806,70,NULL,NULL,'SDSS J164536.44+302731.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,251.401875,30.45875,0.077,NULL,56209703139,878276611,13723072,18.3),(139088,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139088,35.63,0.46,134,66807,70,NULL,NULL,'CGCG 168-033',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000171,NULL,'15.5g',0.4,NULL,NULL,NULL,NULL,NULL,1,251.40525,26.98103,0.229,NULL,56234619421,878665928,13729155,15.5),(139089,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139089,38.22,0.46,440,66808,70,NULL,NULL,'2MASX J16453871+3952248',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000101,NULL,'17.3g',0.21,'NLAGN',NULL,NULL,NULL,'Sy 2',1,251.41125,39.87353,0,NULL,59826794590,934793665,14606151,17.3),(139090,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139090,37.86,0.46,374,66809,70,NULL,NULL,'2MASX J16454250+2833342',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,251.427,28.55942,0.149,NULL,56235642814,878681918,13729404,18),(139091,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139091,36.53,0.46,202,66810,70,NULL,NULL,'2MASX J16454280+1302246',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,251.42825,13.04011,0.193,NULL,56879239027,888738109,13886532,17.7),(139092,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139092,35.24,0.56,112,66811,70,NULL,NULL,'2MASX J16455059-8434065',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,251.460917,-84.5685,0.401,NULL,44086038793,688844356,10763193,16.7),(139093,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139093,35.76,0.46,142,66812,70,NULL,NULL,'I Zw 164',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000105,NULL,'15.3g',0.49,'E/S0',NULL,NULL,NULL,NULL,1,251.4662083,44.63719,0,NULL,59836745550,934949149,14608580,15.3),(139094,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139094,37.22,0.46,278,66813,70,NULL,NULL,'SDSS J164553.54+212005.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,251.473125,21.33489,0.249,NULL,56687000416,885734381,13839599,17.9),(139095,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139095,38.17,0.23,430,66814,70,NULL,NULL,'2MASX J16455479+2718063',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,251.478333,27.30192,0.193,NULL,56236943139,878702236,13729722,17.5),(139096,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139096,34.78,0.49,90.5,66815,75,NULL,'IR','ESO 023- G 002',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.03',0.3,'S...',NULL,NULL,NULL,NULL,1,251.4809583,-81.45822,0.393,NULL,44054982379,688359099,10755610,15.03),(139097,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139097,35.07,0.54,103,66815,NULL,NULL,NULL,'ESO 023- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139098,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139098,35.11,0.2,105,66815,74.4,NULL,NULL,'ESO 023- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139099,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139099,35.23,0.5,111,66815,NULL,NULL,'Malmquist cor.','ESO 023- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139100,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139100,37.29,0.46,287,66816,70,NULL,NULL,'2MASX J16455556+3759023',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000141,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,251.481625,37.98392,0.061,NULL,59824920551,934764383,14605693,17.1),(139101,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139101,35.9,0.46,151,66817,70,NULL,NULL,'2MASX J16455569+2715193',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000177,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,251.481917,27.25539,0.193,NULL,56236735422,878698990,13729671,16.1),(139102,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139102,35.11,NULL,105,66818,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2067',NULL,'2010Ap&SS.325..163P',2010,1,1.46,NULL,'G',0.000033,NULL,'16.2g',0.17,'Sd(f)',NULL,NULL,NULL,NULL,1,251.4889583,39.98583,0,NULL,59826771477,934793304,14606145,16.2),(139103,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139103,35.12,NULL,106,66818,NULL,NULL,'Dipole + Quadrupole','FGC 2067',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139104,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139104,35.14,NULL,107,66818,NULL,NULL,'Dipole','FGC 2067',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139105,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139105,35.16,NULL,108,66818,NULL,NULL,NULL,'FGC 2067',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139106,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139106,37.89,0.46,379,66819,70,NULL,NULL,'SDSS J164557.59+301912.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000138,NULL,'18.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,251.49,30.32019,0.113,NULL,56209763705,878277557,13723086,18.6),(139107,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139107,37.97,0.46,392,66820,70,NULL,NULL,'SDSS J164559.77+251938.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,251.499083,25.32739,0.165,NULL,56195864113,878060376,13719693,18.1),(139108,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139108,38.29,0.33,455,66821,70,NULL,NULL,'SDSS J164600.56+634127.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000083,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,251.502417,63.691,0.053,NULL,57543382445,899115350,14048677,18.3),(139109,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139109,38.07,0.46,411,66822,70,NULL,NULL,'2MASX J16460094+3812524',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,251.503917,38.21447,0.057,NULL,59824780616,934762197,14605659,17.8),(139110,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139110,35.36,0.4,118,66823,NULL,NULL,'mean','UGC 10535',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',NULL,NULL,'15.40',0.2,'Sab',NULL,NULL,NULL,NULL,1,251.506375,6.46253,0.301,NULL,56769330378,887020787,13859699,15.4),(139111,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139111,35.46,0.49,123,66823,75,NULL,'IR','UGC 10535',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139112,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139112,35.54,0.47,128,66823,NULL,NULL,'H','UGC 10535',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139113,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139113,35.57,0.45,130,66823,NULL,NULL,'K','UGC 10535',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139114,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139114,35.64,0.46,134,66823,NULL,NULL,'J','UGC 10535',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139115,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139115,37.55,0.27,323,66824,70,NULL,NULL,'2MASX J16460201+3108530',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000152,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,251.508417,31.14803,0.065,NULL,56211119885,878298748,13723417,17),(139116,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139116,36.62,0.46,211,66825,70,NULL,NULL,'2MASX J16460398+2855513',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000166,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,251.516625,28.93092,0.129,NULL,56227343778,878552246,13727378,16.6),(139117,'GRB','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139117,44.16,0.57,3580,66826,NULL,NULL,NULL,'GRB 091003',0.8969,'2010JCAP...08..020W',2010,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,251.519625,36.62514,0.069,NULL,59812964844,934577575,14602774,NULL),(139118,'GRB','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139118,43.82,0.09,5810,66826,NULL,NULL,NULL,'GRB 091003',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139119,'GRB','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139119,45.97,0.28,15600,66826,NULL,NULL,NULL,'GRB 091003',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139120,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139120,37.82,0.33,367,66827,70,NULL,NULL,'2MASX J16460731+3439080',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000141,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,251.5305,34.65225,0.069,NULL,59746877155,933544955,14586639,18.1),(139121,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139121,38.17,0.23,430,66828,70,NULL,NULL,'2MASX J16461091+2724593',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000149,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,251.545333333,27.41636,0.193,NULL,56236937587,878702149,13729721,17.6),(139122,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139122,37.77,0.46,358,66829,70,NULL,NULL,'SDSS J164611.95+314251.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000178,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,251.549833,31.71428,0.073,NULL,56210956988,878296202,13723378,18.3),(139123,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139123,37.73,0.46,351,66830,70,NULL,NULL,'2MASX J16461246+2832533',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000172,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,251.551917,28.54817,0.149,NULL,56235643244,878681925,13729405,17.4),(139124,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139124,36.05,0.46,162,66831,70,NULL,NULL,'2MASX J16461302+2215021',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,251.5544583,22.25064,0.217,NULL,56679169867,885612029,13837687,17.2),(139125,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139125,37.82,0.33,367,66832,70,NULL,NULL,'2MASX J16461517+3438200',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000152,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,251.56325,34.63886,0.069,NULL,59746875218,933544925,14586639,17),(139126,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139126,37.47,0.46,312,66833,70,NULL,NULL,'2MASX J16461873+2657253',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000176,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,251.578291667,26.95689,0.209,NULL,56234637073,878666204,13729159,16.9),(139127,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139127,36.5,0.46,200,66834,70,NULL,NULL,'2MASX J16462020+2415093',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00016,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,251.58425,24.25269,0.169,NULL,56195596943,878056202,13719628,16.7),(139128,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139128,31.63,0.4,21.2,66835,75,NULL,'B','NGC 6248',NULL,'1988NBGC.C....0000T',1988,1,3.2,NULL,'G',0.00002,NULL,'13.70',1.2,'SBd','Group member',NULL,NULL,NULL,1,251.591625,70.35881,0.193,NULL,57842898925,903795295,14121801,13.7),(139129,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139129,31.81,0.43,23,66835,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6248',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139130,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139130,31.84,0.43,23.4,66835,75,NULL,'3.6 micron, color corrected','NGC 6248',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139131,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139131,31.88,0.2,23.8,66835,74.4,NULL,NULL,'NGC 6248',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139132,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139132,32.16,0.51,27,66835,NULL,NULL,NULL,'NGC 6248',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139133,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139133,32.34,0.47,29.4,66835,NULL,NULL,'Malmquist cor.','NGC 6248',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139134,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139134,35.55,0.33,129,66836,70,NULL,NULL,'2MASX J16462241+3943505',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000057,NULL,'15.7g',0.42,'E0',NULL,NULL,NULL,NULL,1,251.5932083,39.73081,0.041,NULL,59826808812,934793887,14606154,15.7),(139135,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139135,38.96,0.46,619,66837,70,NULL,NULL,'2MASX J16462280+2936163',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000174,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,251.5950417,29.60472,0.121,NULL,56226812836,878543950,13727249,18.2),(139136,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139136,37.13,0.46,266,66838,70,NULL,NULL,'SDSS J164625.30+252517.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000173,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,251.605417,25.42147,0.165,NULL,56198705724,878104776,13720387,18),(139137,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139137,37.64,0.23,337,66839,70,NULL,NULL,'2MASX J16462578+2007029',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,251.607333333,20.11744,0.321,NULL,56685946097,885717907,13839342,18.2),(139138,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139138,37.58,0.46,328,66840,70,NULL,NULL,'2MASX J16462670+2747443',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00014,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,251.611333333,27.79578,0.173,NULL,56237200481,878706257,13729785,18.4),(139139,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139139,36.08,0.46,165,66841,70,NULL,NULL,'2MASX J16462724+2759113',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000176,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,251.6135417,27.98653,0.181,NULL,56237119776,878704996,13729765,16.7),(139140,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139140,38.2,0.46,436,66842,70,NULL,NULL,'2MASX J16462838+3831156',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.7g',0.16,'AGN',NULL,NULL,NULL,NULL,1,251.618417,38.52111,0.065,NULL,59826758623,934793103,14606142,17.7),(139141,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139141,36.2,0.33,174,66843,70,NULL,NULL,'CGCG 168-036',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000147,NULL,'15.1g',0.65,NULL,NULL,NULL,NULL,NULL,1,251.637083,27.31825,0.193,NULL,56236802530,878700039,13729688,15.1),(139142,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139142,38.29,0.33,455,66844,70,NULL,NULL,'2MASX J16463312+6339297',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000108,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,251.6382083,63.65814,0.053,NULL,57543390984,899115484,14048679,16.4),(139143,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139143,36.15,0.46,170,66845,70,NULL,NULL,'2MASX J16463413+2441083',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000172,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,251.642166667,24.68556,0.165,NULL,56195626703,878056667,13719635,16.4),(139144,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139144,37.81,0.46,365,66846,70,NULL,NULL,'2MASX J16463432+3556016',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000159,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,251.643,35.93375,0.057,NULL,59745610499,933525164,14586330,18.4),(139145,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139145,37.91,0.46,382,66847,70,NULL,NULL,'2MASX J16463484+3050167',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,251.645125,30.83806,0.101,NULL,56211236263,878300566,13723446,17.6),(139146,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139146,34.69,0.54,86.6,66848,NULL,NULL,'Malmquist cor.','ESO 453- G 003',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'13.61',0.5,'Sb:',NULL,NULL,NULL,NULL,1,251.647625,-31.58933,NULL,NULL,45795396785,715553074,11180516,13.61),(139147,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139147,34.75,0.52,89.1,66848,NULL,NULL,NULL,'ESO 453- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139148,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139148,34.79,0.2,90.8,66848,74.4,NULL,NULL,'ESO 453- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139149,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139149,34.98,0.4,99.3,66848,NULL,NULL,'mean','ESO 453- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139150,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139150,35.1,0.47,105,66848,NULL,NULL,'H','ESO 453- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139151,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139151,34.27,NULL,71.6,66849,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10561',NULL,'2010Ap&SS.325..163P',2010,1,3.09,NULL,'G',0.000027,NULL,'15.05',0.31,'Sb',NULL,NULL,NULL,NULL,1,251.65,62.82269,0.029,NULL,57545196328,899143692,14049120,15.05),(139152,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139152,34.28,NULL,71.7,66849,NULL,NULL,'Dipole + Quadrupole','UGC 10561',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139153,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139153,34.28,NULL,71.7,66849,NULL,NULL,'Dipole','UGC 10561',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139154,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139154,34.36,0.47,74.6,66849,NULL,NULL,'H','UGC 10561',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139155,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139155,34.42,0.45,76.4,66849,NULL,NULL,'K','UGC 10561',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139156,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139156,34.43,0.49,76.8,66849,75,NULL,'IR','UGC 10561',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139157,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139157,34.51,0.4,79.9,66849,NULL,NULL,'mean','UGC 10561',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139158,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139158,34.52,0.46,80.1,66849,NULL,NULL,'J','UGC 10561',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139159,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139159,35.87,NULL,149,66850,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2071',NULL,'2010Ap&SS.325..163P',2010,1,0.8,NULL,'G',0.0001,NULL,'16.5',0.1,'Sc',NULL,NULL,NULL,NULL,1,251.65175,69.34542,0.189,NULL,57841736564,903777133,14121517,16.5),(139160,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139160,35.89,NULL,151,66850,NULL,NULL,'Dipole + Quadrupole','FGC 2071',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139161,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139161,35.9,NULL,151,66850,NULL,NULL,NULL,'FGC 2071',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139162,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139162,35.92,NULL,153,66850,NULL,NULL,'Dipole','FGC 2071',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139163,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139163,38.3,0.33,458,66851,70,NULL,NULL,'SDSS J164638.25+384819.8',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000087,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,251.659417,38.80553,0.061,NULL,59826601901,934790654,14606103,17.3),(139164,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139164,35.77,0.46,143,66852,70,NULL,NULL,'2MASX J16464059+4045297',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000073,NULL,'16.0g',0.4,'E0',NULL,NULL,NULL,NULL,1,251.66925,40.75833,0,NULL,59818340814,934661575,14604087,16),(139165,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139165,38.17,0.23,430,66853,70,NULL,NULL,'2MASX J16464187+2716303',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000159,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,251.674417,27.27511,0.193,NULL,56234822032,878669094,13729204,17.3),(139166,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139166,37.44,0.46,307,66854,70,NULL,NULL,'2MASX J16464205+3327057',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000184,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,251.675375,33.45167,0.057,NULL,59745907360,933529802,14586403,17),(139167,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139167,36.2,0.33,174,66855,70,NULL,NULL,'2MASX J16464277+2715423',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,251.678417,27.26169,0.193,NULL,56234822620,878669103,13729204,17.1),(139168,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139168,37.55,0.27,323,66856,70,NULL,NULL,'2MASX J16464323+3114418',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000151,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,251.6800417,31.24506,0.089,NULL,56210637859,878291216,13723300,16.8),(139169,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139169,36.84,0.46,233,66857,70,NULL,NULL,'2MASX J16464761+2609263',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,251.6985,26.15722,0.233,NULL,56230591684,878602995,13728171,17.1),(139170,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139170,35.91,0.46,152,66858,70,NULL,NULL,'CGCG 138-072',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000182,NULL,'15.3g',0.57,'E','Isolated galaxy',NULL,NULL,NULL,1,251.704833,22.90508,0.213,NULL,56681029158,885641080,13838141,15.3),(139171,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139171,38.16,0.46,428,66859,70,NULL,NULL,'2MASX J16465059+3954317',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000083,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,251.7107083,39.90881,0.041,NULL,59825742065,934777219,14605894,17.5),(139172,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139172,37.95,0.46,388,66860,70,NULL,NULL,'2MASX J16465227+3732067',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,251.718041667,37.53511,0.049,NULL,59813500026,934585937,14602905,17.8),(139173,'IRAS','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139173,35.49,0.8,126,66861,75,NULL,'CF, r','UGC 10545',NULL,'1997ApJS..109..333W',1997,1,1.43,NULL,'G',0.000033,NULL,'14.8g',0.45,'Sbc',NULL,NULL,NULL,NULL,1,251.7207083,34.41003,0.061,NULL,59746320902,933536264,14586504,14.8),(139174,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139174,34.93,0.38,96.8,66861,75,NULL,'CF, r, raw','UGC 10545',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139175,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139175,35.07,0.38,103,66861,75,NULL,'CF, r, inv','UGC 10545',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139176,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139176,35.21,0.2,110,66861,74.4,NULL,NULL,'UGC 10545',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139177,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139177,35.29,0.38,114,66861,75,NULL,'CF, r, cor','UGC 10545',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139178,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139178,34.23,NULL,70.2,66862,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2068',NULL,'2010Ap&SS.325..163P',2010,1,0.04,NULL,'G',0.000013,NULL,'21.5g',0.03,'Sd',NULL,NULL,NULL,NULL,1,251.7277083,31.8855,0.073,NULL,56210136548,878283383,13723177,21.5),(139179,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139179,34.24,NULL,70.4,66862,NULL,NULL,'Dipole + Quadrupole','FGC 2068',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139180,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139180,34.24,NULL,70.5,66862,NULL,NULL,'Dipole','FGC 2068',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139181,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139181,34.27,NULL,71.3,66862,NULL,NULL,NULL,'FGC 2068',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139182,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139182,34.7,0.2,87.1,66862,74.4,NULL,NULL,'FGC 2068',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139183,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139183,37.37,0.46,298,66863,70,NULL,NULL,'2MASX J16465469+4005217',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000083,NULL,'17.1g',0.2,'NLAGN',NULL,NULL,NULL,NULL,1,251.7279583,40.08944,0.041,NULL,59825732649,934777072,14605891,17.1),(139184,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139184,36.08,0.46,165,66864,70,NULL,NULL,'CGCG 138-073',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000087,NULL,'15.5g',0.45,'E0',NULL,NULL,NULL,NULL,1,251.7287083,22.52136,0.217,NULL,56678967658,885608869,13837638,15.5),(139185,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139185,37.68,0.46,344,66865,70,NULL,NULL,'2MASX J16465653+3716197',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,251.735583,37.27217,0.069,NULL,59813490177,934585784,14602902,17.3),(139186,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139186,34.62,0.69,83.8,66866,100,NULL,'mid-IR','UGC 10547',NULL,'2013ApJ...771...88L',2013,1,1.3,NULL,'G',0.000033,NULL,'14.53',0.7,'SB(s)b',NULL,NULL,NULL,NULL,1,251.7364583,34.15556,0.057,NULL,59746544355,933539755,14586558,14.53),(139187,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139187,36.23,0.2,176,66866,74.4,NULL,NULL,'UGC 10547',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139188,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139188,35.91,0.58,152,66867,70,NULL,NULL,'ESO 043- G 005',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.7R',0.5,'S...',NULL,NULL,NULL,NULL,1,251.7419583,-72.74539,0.297,NULL,44150064834,689844763,10778824,14.7),(139189,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139189,38.3,0.33,458,66868,70,NULL,NULL,'2MASX J16465844+3855423',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000074,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,251.743583,38.92853,0.061,NULL,59826627582,934791055,14606110,17.5),(139190,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139190,37.64,0.23,337,66869,70,NULL,NULL,'2MASX J16465871+2004231',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000177,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,251.744667,20.07314,0.313,NULL,56686014124,885718970,13839358,17.2),(139191,'IRAS','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139191,34.27,0.8,71.4,66870,75,NULL,'CF, r','IC 1231',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000017,NULL,'13.59',1,'Scd:           AGN?','Isolated galaxy',NULL,NULL,NULL,1,251.745916667,58.42317,0,NULL,57708216143,901690877,14088919,13.59),(139192,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139192,33.88,0.38,59.7,66870,75,NULL,'CF, r, raw','IC 1231',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139193,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139193,34.02,0.38,63.8,66870,75,NULL,'CF, r, inv','IC 1231',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139194,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139194,34.17,0.38,68.1,66870,75,NULL,'CF, r, cor','IC 1231',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139195,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139195,34.22,0.47,70,66870,NULL,NULL,'H','IC 1231',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139196,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139196,34.27,0.4,71.3,66870,NULL,NULL,'mean','IC 1231',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139197,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139197,34.3,0.46,72.4,66870,NULL,NULL,'J','IC 1231',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139198,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139198,34.33,0.2,73.5,66870,74.4,NULL,NULL,'IC 1231',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139199,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139199,34.35,0.45,74.1,66870,NULL,NULL,'K','IC 1231',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139200,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139200,34.37,0.37,74.9,66870,NULL,NULL,'Malmquist cor.','IC 1231',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139201,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139201,34.39,0.37,75.3,66870,NULL,NULL,NULL,'IC 1231',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139202,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139202,35.53,0.46,127,66871,70,NULL,NULL,'2MASX J16470020+3407078',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000176,NULL,'16.2g',0.41,NULL,NULL,NULL,NULL,NULL,1,251.750833,34.11897,0.057,NULL,59746543665,933539744,14586558,16.2),(139203,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139203,34.89,0.49,94.9,66872,75,NULL,'IR','UGC 10550',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.00007,NULL,'16.0',0.2,'Sb(f)','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,251.760541667,40.14392,0.041,NULL,59825719300,934776864,14605888,16),(139204,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139204,35.04,0.2,102,66872,74.4,NULL,NULL,'UGC 10550',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139205,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139205,35.58,0.12,131,66872,NULL,NULL,NULL,'UGC 10550',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139206,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139206,37.28,0.46,286,66873,70,NULL,NULL,'2MASX J16470301+6345570',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000088,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,251.7625417,63.76592,0.053,NULL,57543457205,899116518,14048695,17.4),(139207,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139207,37.64,0.23,337,66874,70,NULL,NULL,'2MASX J16470325+2006241',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,251.763625,20.10661,0.313,NULL,56685957387,885718084,13839345,17.3),(139208,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139208,36.26,0.46,179,66875,70,NULL,NULL,'2MASX J16470342+3412058',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000172,NULL,'15.7g',0.43,'E0',NULL,NULL,NULL,NULL,1,251.764083333,34.20172,0.057,NULL,59746545251,933539769,14586558,15.7),(139209,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139209,34.04,0.49,64.2,66876,75,NULL,'IR','ESO 453- G 004',NULL,'2011yCatp016004901K',2011,1,1.79,NULL,'G',0.000033,NULL,'15.9',0.21,'Sd',NULL,NULL,NULL,NULL,1,251.767208333,-29.09064,1.241,NULL,45832340852,716130325,11189536,15.9),(139210,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139210,34.99,NULL,99.4,66876,NULL,NULL,'Dipole','ESO 453- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139211,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139211,34.99,NULL,99.5,66876,NULL,NULL,'Dipole + Quadrupole','ESO 453- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139212,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139212,34.99,NULL,99.5,66876,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 453- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139213,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139213,38.33,0.27,464,66877,70,NULL,NULL,'SDSS J164704.75+342922.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000175,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,251.769875,34.48969,0.061,NULL,59747042275,933547535,14586680,18.3),(139214,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139214,37.64,0.23,337,66878,70,NULL,NULL,'2MASX J16470588+2003271',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000162,NULL,'16.8g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,251.774583,20.05753,0.313,NULL,56686018048,885719032,13839359,16.8),(139215,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139215,38.07,0.33,411,66879,70,NULL,NULL,'2MASX J16470693+2813196',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,251.779,28.22211,0.173,NULL,56237113286,878704895,13729763,18),(139216,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139216,38.36,0.46,471,66880,70,NULL,NULL,'SDSS J164708.15+291103.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,251.784,29.18431,0.121,NULL,56226880755,878545011,13727265,18.5),(139217,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139217,37.11,0.46,264,66881,70,NULL,NULL,'2MASX J16470906+2036311',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,251.787833,20.60853,0.337,NULL,56685069928,885704217,13839128,17.7),(139218,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139218,36.87,0.46,236,66882,70,NULL,NULL,'2MASX J16471067+2652577',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000172,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,251.794417,26.88275,0.229,NULL,56230307115,878598548,13728102,16.6),(139219,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139219,37.83,0.46,369,66883,70,NULL,NULL,'2MASX J16471075+3407308',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,251.794917,34.12542,0.057,NULL,59746490029,933538906,14586545,17.6),(139220,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139220,38.07,0.33,411,66884,70,NULL,NULL,'2MASX J16471089+2805137',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'17.2g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,251.795375,28.08725,0.181,NULL,56237134987,878705234,13729769,17.2),(139221,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139221,38.33,0.27,464,66885,70,NULL,NULL,'2MASX J16471269+3433388',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,251.80275,34.56083,0.061,NULL,59747056164,933547752,14586683,16.4),(139222,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139222,37.03,0.33,255,66886,70,NULL,NULL,'2MASX J16471365+3356118',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,251.807,33.93669,0.049,NULL,59746370967,933537046,14586516,17.7),(139223,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:58','1','SN 2007is',NULL,139223,35.39,0.21,116,66887,73.8,NULL,'SALT 2 (SNANA)','UGC 10553',0.0301,'2014ApJ...795...44R',2014,1,1.21,NULL,'G',0.000107,NULL,'14.5g',0.52,'SBab:          NLAGN',NULL,NULL,NULL,NULL,1,251.811583,40.24508,0.041,NULL,59817603391,934650052,14603907,14.5),(139224,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:58','1','SN 2007is','R',139224,35.54,0.1,128,66887,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 10553',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139225,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:58','1','SN 2007is','R',139225,35.57,0.13,130,66887,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 10553',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139226,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139226,38.27,0.33,451,66888,70,NULL,NULL,'2MASX J16471567+2931007',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000193,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,251.81525,29.51686,0.121,NULL,56226993790,878546777,13727293,17.4),(139227,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139227,37.03,0.33,255,66889,70,NULL,NULL,'2MASX J16471566+3355568',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000117,NULL,'15.99',0.46,NULL,NULL,NULL,NULL,NULL,1,251.815375,33.93242,0.049,NULL,59746371062,933537047,14586516,15.99),(139228,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139228,38.27,0.33,451,66890,70,NULL,NULL,'SDSS J164716.17+293242.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,251.817417,29.54519,0.121,NULL,56226992613,878546759,13727293,18.3),(139229,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139229,38.33,0.27,464,66891,70,NULL,NULL,'SDSS J164716.66+343352.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000177,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,251.8194583,34.56458,0.061,NULL,59747056300,933547754,14586683,18.3),(139230,'Tully est','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139230,30.2,0.8,10.9,66892,75,NULL,NULL,'ESO 179-IG 013',NULL,'1988NBGC.C....0000T',1988,1,3,NULL,'G',0.000013,NULL,'15.0',1.7,'SB(s)dm',NULL,NULL,NULL,NULL,1,251.8335417,-57.44017,NULL,NULL,44550962672,696108791,10876699,15),(139231,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139231,36.51,0.46,200,66893,70,NULL,NULL,'2MASX J16472078+2416358',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000172,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,251.8365,24.27675,0.173,NULL,56199009953,878109530,13720461,16.8),(139232,'IRAS','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139232,34.65,0.8,85.3,66894,75,NULL,'MAT, I','ESO 586- G 002',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00003,NULL,'14.28',0.5,'S',NULL,NULL,NULL,NULL,1,251.851833,-20.14172,1.013,NULL,45927576086,717618376,11212787,14.28),(139233,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139233,33.52,0.2,50.6,66894,74.4,NULL,NULL,'ESO 586- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139234,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139234,33.78,0.89,57,66894,NULL,NULL,NULL,'ESO 586- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139235,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139235,33.87,0.32,59.5,66894,85,NULL,'I, raw','ESO 586- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139236,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139236,33.88,0.32,59.7,66894,85,NULL,'I, inv','ESO 586- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139237,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139237,34.01,0.43,63.5,66894,75,NULL,'MAT, I, raw','ESO 586- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139238,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139238,34.1,0.43,66,66894,75,NULL,'MAT, I, inv','ESO 586- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139239,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139239,34.13,0.75,67.1,66894,NULL,NULL,'Malmquist cor.','ESO 586- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139240,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139240,34.41,0.43,76.1,66894,75,NULL,'MAT, I, cor','ESO 586- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139241,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139241,37.34,0.46,294,66895,70,NULL,NULL,'2MASX J16472796+4322374',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00009,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,251.866541667,43.37717,0.025,NULL,59844506248,935070410,14610475,16.4),(139242,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139242,37.49,0.33,315,66896,70,NULL,NULL,'2MASX J16472821+3112073',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00014,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,251.8677083,31.20222,0.089,NULL,56210529502,878289523,13723273,17.7),(139243,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139243,37.63,0.46,335,66897,70,NULL,NULL,'2MASX J16473013+3117303',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,251.875583,31.29172,0.089,NULL,56210533743,878289589,13723274,17.2),(139244,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139244,35.83,0.46,147,66898,70,NULL,NULL,'2MASX J16473361+2507078',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000103,NULL,'16.1g',0.37,'HII',NULL,NULL,NULL,NULL,1,251.890167,25.11883,0.137,NULL,56198790020,878106094,13720407,16.1),(139245,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139245,37.11,0.33,265,66899,70,NULL,NULL,'2MASX J16473443+3256523',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000185,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,251.8935417,32.94792,0.065,NULL,59745806754,933528230,14586378,17.1),(139246,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139246,34.49,0.48,78.9,66900,70,NULL,NULL,'CGCG 025-005',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00008,NULL,'15.6',0.4,NULL,NULL,NULL,NULL,NULL,1,251.9017917,-1.41942,0.417,NULL,45175829666,705872338,11029255,15.6),(139247,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139247,35.3,0.49,115,66901,75,NULL,'IR','CGCG 053-008',NULL,'2011yCatp016004901K',2011,1,0.99,NULL,'G',0.000008,NULL,'15.7',0.18,NULL,NULL,NULL,NULL,NULL,1,251.9019583,8.75294,0.341,NULL,56771065264,887047894,13860123,15.7),(139248,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139248,38.03,0.33,403,66902,70,NULL,NULL,'2MASX J16473904+2943284',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00017,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,251.912667,29.7245,0.121,NULL,56226844542,878544445,13727256,17.5),(139249,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139249,37.64,0.46,338,66903,70,NULL,NULL,'2MASX J16473916+2552324',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000138,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,251.913167,25.87572,0.177,NULL,56197792378,878090505,13720164,17.9),(139250,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139250,37.66,0.46,341,66904,70,NULL,NULL,'2MASX J16473918+3923195',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000074,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,251.913208333,39.38864,0.045,NULL,59825836523,934778695,14605917,17.7),(139251,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139251,38.62,0.46,530,66905,70,NULL,NULL,'SDSS J164740.11+353544.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,251.917167,35.59572,0.057,NULL,59745407845,933521997,14586281,18),(139252,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139252,33.17,0.47,43,66906,NULL,NULL,'H','ESO 137- G 042',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000013,NULL,'13.65',0.8,'SAB(s)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,251.919625,-60.149,NULL,NULL,44498919558,695295618,10863994,13.65),(139253,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139253,33.21,0.46,43.9,66906,NULL,NULL,'J','ESO 137- G 042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139254,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139254,33.22,0.45,44.1,66906,NULL,NULL,'K','ESO 137- G 042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139255,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139255,33.3,0.4,45.7,66906,NULL,NULL,'mean','ESO 137- G 042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139256,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139256,38.33,0.33,462,66907,70,NULL,NULL,'2MASX J16474406+2956314',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000087,NULL,'16.0g',0.49,'BrClG;cD',NULL,NULL,NULL,NULL,1,251.9335417,29.94192,0.113,NULL,56209089448,878267022,13722922,16),(139257,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139257,38.03,0.33,403,66908,70,NULL,NULL,'SDSS J164746.76+294459.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000155,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,251.944875,29.74989,0.121,NULL,56209064544,878266633,13722916,18.6),(139258,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139258,36.73,0.46,222,66909,70,NULL,NULL,'2MASX J16474754+4505423',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000116,NULL,'15.4g',0.46,'E0',NULL,NULL,NULL,NULL,1,251.947917,45.09519,0,NULL,59836405181,934943830,14608497,15.4),(139259,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139259,37.76,0.33,357,66910,70,NULL,NULL,'2MASX J16474846+3903166',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,251.952083,39.05461,0.053,NULL,59826112019,934783000,14605984,17.3),(139260,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139260,37.11,0.33,265,66911,70,NULL,NULL,'2MASX J16475278+3254164',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,251.9699583,32.90467,0.065,NULL,59745815357,933528364,14586380,17.5),(139261,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139261,37.49,0.33,315,66912,70,NULL,NULL,'2MASX J16475331+3117054',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000143,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,251.9722917,31.28506,0.089,NULL,56210554692,878289917,13723279,17.7),(139262,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139262,37.99,0.46,396,66913,70,NULL,NULL,'2MASX J16475343+2245330',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000155,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,251.972833333,22.759,0.213,NULL,56680800262,885637504,13838086,18),(139263,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139263,37.35,0.46,295,66914,70,NULL,NULL,'2MASX J16475357+2908485',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00017,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,251.973333,29.14692,0.125,NULL,56235259697,878675932,13729311,17.3),(139264,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139264,38.09,0.46,415,66915,70,NULL,NULL,'2MASX J16475363+3208484',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000207,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,251.973625,32.14675,0.081,NULL,56218467194,878413549,13725211,16.4),(139265,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139265,36.98,0.46,249,66916,70,NULL,NULL,'2MASX J16475488+4433454',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000104,NULL,'17.0g',0.22,'NLAGN',NULL,NULL,NULL,NULL,1,251.9787917,44.5625,0,NULL,59836901228,934951581,14608618,17),(139266,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139266,38.33,0.33,462,66917,70,NULL,NULL,'SDSS J164755.07+295200.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000165,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,251.9795417,29.86683,0.113,NULL,56209139697,878267807,13722934,18.4),(139267,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139267,37.63,0.46,335,66918,70,NULL,NULL,'SDSS J164756.35+332916.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,251.984833,33.48778,0.057,NULL,59746634334,933541161,14586580,18.1),(139268,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139268,35.55,0.33,129,66919,70,NULL,NULL,'2MASX J16475755+3958186',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000083,NULL,'16.3g',0.26,'NLAGN',NULL,NULL,NULL,NULL,1,251.98975,39.97186,0.041,NULL,59825763235,934777550,14605899,16.3),(139269,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139269,35.85,0.46,148,66920,70,NULL,NULL,'2MASX J16475838+2908295',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000185,NULL,'15.6g',0.31,'S0/a',NULL,NULL,NULL,NULL,1,251.993167,29.14153,0.125,NULL,56235258981,878675921,13729311,15.6),(139270,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139270,36.61,0.33,209,66921,70,NULL,NULL,'2MASX J16475913+3155104',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000169,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,251.996333,31.91967,0.081,NULL,56218421746,878412839,13725200,16.6),(139271,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139271,37.9,0.23,380,66922,70,NULL,NULL,'2MASX J16480145+2739325',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,252.0062083,27.65914,0.173,NULL,56236310838,878692356,13729568,17.7),(139272,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139272,37.76,0.33,357,66923,70,NULL,NULL,'2MASX J16480151+3908226',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000086,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,252.0062917,39.13958,0.053,NULL,59826245282,934785082,14606016,17.5),(139273,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139273,37.87,0.46,374,66924,70,NULL,NULL,'2MASX J16480172+2340331',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,252.0072917,23.67594,0.181,NULL,56680096389,885626506,13837914,17.5),(139274,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139274,37.9,0.23,380,66925,70,NULL,NULL,'2MASX J16480235+2737495',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,252.0097083,27.63047,0.173,NULL,56234410445,878662663,13729104,17.6),(139275,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139275,36.1,0.2,166,66926,74.4,NULL,NULL,'NGC 6228',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000006,NULL,'14.90',0.6,'S?',NULL,NULL,NULL,NULL,1,252.011083333,26.21356,0.209,NULL,56230777794,878605903,13728217,14.9),(139276,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139276,32.49,0.47,31.5,66927,NULL,NULL,'H','NGC 6244',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',NULL,NULL,'14.43',0.3,'SBa:',NULL,NULL,NULL,NULL,1,252.016291667,62.20044,0.029,NULL,57544149685,899127338,14048864,14.43),(139277,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139277,32.68,0.45,34.3,66927,NULL,NULL,'K','NGC 6244',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139278,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139278,32.74,0.46,35.3,66927,NULL,NULL,'J','NGC 6244',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139279,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139279,33.47,0.4,49.5,66927,NULL,NULL,'mean','NGC 6244',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139280,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139280,35.91,0.46,152,66928,70,NULL,NULL,'CGCG 169-003',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000063,NULL,'15.7g',0.34,'S0/a',NULL,NULL,NULL,NULL,1,252.02125,30.08517,0.113,NULL,56209126618,878267603,13722931,15.7),(139281,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139281,37.8,0.33,363,66929,70,NULL,NULL,'2MASX J16481117+4038588',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000091,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,252.046416667,40.64964,0,NULL,59818215587,934659618,14604056,17.1),(139282,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139282,36.14,0.27,169,66930,70,NULL,NULL,'2MASX J16481206+2409077',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00013,NULL,'15.9g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,252.0502083,24.15214,0.173,NULL,56196917046,878076828,13719950,15.9),(139283,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139283,37.72,0.46,350,66931,70,NULL,NULL,'2MASX J16481207+4425123',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000072,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,252.050375,44.42028,0,NULL,59836891526,934951430,14608616,16.9),(139284,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139284,37.9,0.23,380,66932,70,NULL,NULL,'2MASX J16481360+2737457',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000155,NULL,'17.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,252.0565417,27.62933,0.173,NULL,56234411862,878662685,13729104,17.2),(139285,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139285,36.14,0.27,169,66933,70,NULL,NULL,'2MASX J16481637+2408427',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00009,NULL,'15.5g',0.48,'E0',NULL,NULL,NULL,NULL,1,252.068333333,24.14514,0.173,NULL,56196884867,878076326,13719942,15.5),(139286,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139286,35.55,0.33,129,66934,70,NULL,NULL,'CGCG 197-013',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000123,NULL,'14.8g',0.7,'E0','Group member',NULL,NULL,NULL,1,252.073083333,35.90014,0.061,NULL,59745490526,933523289,14586301,14.8),(139287,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139287,37.82,0.23,367,66935,70,NULL,NULL,'2MASX J16481882+2721527',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000184,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,252.078583,27.36472,0.209,NULL,56234900722,878670323,13729223,17.8),(139288,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139288,37.23,0.93,280,66936,70,NULL,NULL,'2MASX J16481938-6209305',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,252.0807917,-62.15847,0.809,NULL,44469453119,694835204,10856800,14.4),(139289,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139289,32.53,NULL,32,66937,72,NULL,NULL,'UGC 10554',NULL,'2014Ap.....57..457K',2014,1,1.5,NULL,'G',0.000027,NULL,'14.90',0.5,'Scd: sp',NULL,NULL,NULL,NULL,1,252.088917,-1.61919,0.409,NULL,45175498768,705867168,11029174,14.9),(139290,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139290,35.76,0.2,142,66938,74.4,NULL,NULL,'CGCG 139-004',NULL,'2013AJ....146...86T',2013,1,0.78,NULL,'G',0.000009,NULL,'15.4g',0.42,'SABbc(r)',NULL,NULL,NULL,NULL,1,252.0907083,23.61469,0.181,NULL,56680083538,885626305,13837911,15.4),(139291,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139291,38.04,0.46,406,66939,70,NULL,NULL,'SDSS J164822.29+325255.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000158,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,252.092875,32.88197,0.081,NULL,59745795933,933528061,14586375,18.5),(139292,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139292,34.65,0.49,84.9,66940,70,NULL,NULL,'2MASX J16482393-0616193',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00009,NULL,'12.9I',0.6,NULL,NULL,NULL,NULL,NULL,1,252.0997917,-6.27214,0.801,NULL,46092212478,720190819,11252981,12.9),(139293,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139293,37.9,0.23,380,66941,70,NULL,NULL,'2MASX J16482406+2737018',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,252.1002917,27.61722,0.173,NULL,56234416205,878662753,13729105,17.2),(139294,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139294,37.82,0.23,367,66942,70,NULL,NULL,'2MASX J16482498+2721128',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000194,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,252.104,27.35356,0.209,NULL,56234899586,878670306,13729223,16.9),(139295,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139295,34.72,0.46,87.9,66943,70,NULL,NULL,'CGCG 224-103',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000083,NULL,'15.1g',0.47,'E0',NULL,NULL,NULL,NULL,1,252.110458333,41.95311,0,NULL,59818772001,934668312,14604192,15.1),(139296,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139296,36.14,0.27,169,66944,70,NULL,NULL,'2MASX J16482725+2421128',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00017,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,252.11375,24.3535,0.181,NULL,56196893745,878076464,13719944,16.6),(139297,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139297,37.2,0.46,275,66945,70,NULL,NULL,'2MASX J16482905+3608450',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,252.120917,36.14594,0.057,NULL,59745338647,933520916,14586264,16.9),(139298,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139298,37.8,0.33,363,66946,70,NULL,NULL,'SDSS J164829.32+404226.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000111,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,252.1222083,40.70742,0,NULL,59818226356,934659786,14604059,18.5),(139299,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139299,37.29,0.46,287,66947,70,NULL,NULL,'2MASX J16483009+2712398',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000193,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,252.1255,27.21111,0.197,NULL,56234983285,878671613,13729243,16.9),(139300,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139300,36.25,0.51,178,66948,70,NULL,NULL,'2MASX J16483268-7222323',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,252.136333333,-72.37569,0.477,NULL,44150114944,689845546,10778836,14.7),(139301,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139301,36.61,0.33,209,66949,70,NULL,NULL,'2MASX J16483278+3152553',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000188,NULL,'16.2g',0.25,'S0/a',NULL,NULL,NULL,NULL,1,252.136583333,31.88217,0.089,NULL,56219286401,878426350,13725411,16.2),(139302,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139302,37.49,0.46,314,66950,70,NULL,NULL,'2MASX J16483384+2842028',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,252.141083,28.70067,0.157,NULL,56236150155,878689846,13729528,17.3),(139303,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139303,38.52,0.46,507,66951,70,NULL,NULL,'2MASX J16483417+4056590',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000083,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,252.142417,40.94972,0,NULL,59818208737,934659511,14604054,17.8),(139304,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139304,38.39,0.46,476,66952,70,NULL,NULL,'SDSS J164834.55+250307.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00013,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,252.144,25.05206,0.173,NULL,56199472133,878116752,13720574,18.7),(139305,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139305,35.08,0.6,104,66953,70,NULL,NULL,'2MASX J16483531-0105143',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.02',0.4,NULL,NULL,NULL,NULL,NULL,1,252.147125,-1.08747,0.389,NULL,45176759855,705886872,11029482,16.02),(139306,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139306,36.93,0.46,243,66954,70,NULL,NULL,'2MASX J16483551+3154080',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000152,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,252.147833333,31.90231,0.081,NULL,56219286816,878426356,13725411,17.1),(139307,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139307,37.75,0.33,356,66955,70,NULL,NULL,'2MASX J16483728+2918278',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000182,NULL,'16.5g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,252.155291667,29.30767,0.125,NULL,56235373413,878677709,13729339,16.5),(139308,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139308,36.82,0.27,231,66956,70,NULL,NULL,'2MASX J16483765+2652318',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,252.156917,26.87544,0.185,NULL,56229956701,878593073,13728016,17.7),(139309,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139309,33.75,0.4,56.3,66957,NULL,NULL,NULL,'ESO 069- G 010',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'13.29',0.3,'SA(s)b:',NULL,NULL,NULL,NULL,1,252.1702917,-69.49372,0.305,NULL,45018678750,703416855,10990888,13.29),(139310,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139310,33.79,0.2,57.3,66957,74.4,NULL,NULL,'ESO 069- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139311,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139311,33.94,0.37,61.4,66957,NULL,NULL,'Malmquist cor.','ESO 069- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139312,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139312,36.66,0.46,215,66958,70,NULL,NULL,'2MASX J16484093+6328447',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000078,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,252.17075,63.47919,0.045,NULL,57545578183,899149659,14049213,17.1),(139313,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139313,38.23,0.46,442,66959,70,NULL,NULL,'2MASX J16484267+4125400',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000099,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,252.177833,41.42775,0.009,NULL,59819129784,934673902,14604279,17.3),(139314,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139314,36.82,0.27,231,66960,70,NULL,NULL,'2MASX J16484350+2657129',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00018,NULL,'16.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,252.18125,26.95347,0.185,NULL,56234216198,878659628,13729056,16.6),(139315,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139315,38.43,0.46,484,66961,70,NULL,NULL,'SDSS J164844.45+310803.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,252.18525,31.13425,0.089,NULL,56216784246,878387253,13724800,18.6),(139316,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139316,35.81,0.25,145,66962,74.4,NULL,NULL,'CGCG 367-018',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.00008,NULL,'14.16',NULL,'E','Group member',NULL,NULL,NULL,1,252.1869583,81.61083,0.269,NULL,56956384812,889943512,13905367,14.16),(139317,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139317,36.01,0.28,159,66962,70,NULL,NULL,'CGCG 367-018',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139318,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139318,36.06,0.72,163,66963,70,NULL,NULL,'2MASX J16484519-6803384',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,252.188291667,-68.06067,0.425,NULL,45024564927,703508826,10992325,14.9),(139319,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139319,36.82,0.27,231,66964,70,NULL,NULL,'2MASX J16484663+2700380',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000185,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,252.194333,27.01053,0.185,NULL,56234940600,878670946,13729233,17),(139320,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139320,37.3,0.33,288,66965,70,NULL,NULL,'2MASX J16485270+4440133',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000082,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,252.219708333,44.67039,0,NULL,59836912783,934951762,14608621,16.8),(139321,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139321,37.4,0.46,302,66966,70,NULL,NULL,'2MASX J16485437+1949521',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,252.2265417,19.83119,0.313,NULL,56685739879,885714685,13839291,17.8),(139322,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139322,37.82,0.23,367,66967,70,NULL,NULL,'2MASX J16485597+2717540',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,252.233125,27.29825,0.209,NULL,56235105815,878673528,13729273,17.8),(139323,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139323,37.82,0.23,367,66968,70,NULL,NULL,'2MASX J16485703+2711420',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,252.2377917,27.19508,0.197,NULL,56234987398,878671678,13729244,17.6),(139324,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139324,37.72,0.46,351,66969,70,NULL,NULL,'2MASX J16490059+3430090',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,252.252417,34.50264,0.061,NULL,59747738501,933558414,14586850,17.2),(139325,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139325,35.28,0.59,114,66970,70,NULL,NULL,'2MASX J16490082-1612433',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,252.2535,-16.21208,1.325,NULL,46156944108,721202251,11268785,15.7),(139326,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139326,36.18,0.52,173,66971,70,NULL,NULL,'2MASX J16490214-1945242',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.000113,NULL,'14.8R',NULL,'E',NULL,NULL,NULL,NULL,1,252.2589583,-19.75675,0.977,NULL,45926886446,717607600,11212618,14.8),(139327,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139327,37.01,0.21,252,66972,70,NULL,NULL,'2MASX J16490501+2617300',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,252.271,26.29158,0.209,NULL,56230032886,878594263,13728035,17.3),(139328,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139328,37.01,0.21,252,66973,70,NULL,NULL,'2MASX J16491077+2636270',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00018,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,252.2949583,26.60742,0.253,NULL,56230100151,878595314,13728051,17.1),(139329,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139329,38.22,0.46,441,66974,70,NULL,NULL,'SDSS J164912.46+291838.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000152,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,252.3019583,29.31075,0.125,NULL,56235349236,878677331,13729333,18.6),(139330,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139330,36.84,0.6,234,66975,70,NULL,NULL,'2MASX J16491562-6423124',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,252.315,-64.38681,0.705,NULL,44466576647,694790260,10856097,15.1),(139331,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139331,38.24,0.46,445,66976,70,NULL,NULL,'2MASX J16491632+2336101',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000142,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,252.3180417,23.60283,0.185,NULL,56680741161,885636580,13838071,18.3),(139332,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139332,36.98,0.46,248,66977,70,NULL,NULL,'2MASX J16491760+3001516',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000179,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,252.323333,30.03114,0.125,NULL,56208936814,878264637,13722884,16.3),(139333,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139333,37.51,0.46,318,66978,70,NULL,NULL,'2MASX J16491963+3035566',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000203,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,252.3317083,30.59906,0.109,NULL,56216857457,878388397,13724818,17),(139334,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139334,37.01,0.21,252,66979,70,NULL,NULL,'2MASX J16492220+2647104',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000115,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,252.342583333,26.78628,0.185,NULL,56230004301,878593817,13728028,16.9),(139335,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139335,36.67,0.55,216,66980,70,NULL,NULL,'2MASX J16492348-6426515',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,252.347667,-64.44767,0.705,NULL,44467030620,694797353,10856208,15.7),(139336,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139336,37.6,0.33,331,66981,70,NULL,NULL,'2MASX J16492490+3308166',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00017,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,252.354,33.13786,0.073,NULL,59745885249,933529457,14586397,16.9),(139337,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139337,37.01,0.21,252,66982,70,NULL,NULL,'SDSS J164925.13+263652.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000174,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,252.3547083,26.61444,0.253,NULL,56230089802,878595153,13728049,18.4),(139338,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139338,35.55,0.33,129,66983,70,NULL,NULL,'CGCG 197-016',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000093,NULL,'15.1g',0.55,'E0',NULL,NULL,NULL,NULL,1,252.357917,36.05586,0.057,NULL,59745271630,933519869,14586247,15.1),(139339,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139339,37.3,0.33,288,66984,70,NULL,NULL,'2MASX J16492698+4441525',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000091,NULL,'16.5g',0.31,'NLAGN',NULL,NULL,NULL,NULL,1,252.362333333,44.69792,0,NULL,59836861029,934950953,14608608,16.5),(139340,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139340,35.53,0.72,128,66985,70,NULL,NULL,'2MASX J16492750-1657122',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,252.364583,-16.95342,1.181,NULL,46158261862,721222841,11269106,16.3),(139341,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139341,37.01,0.21,252,66986,70,NULL,NULL,'2MASX J16492901+2636205',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00018,NULL,'16.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,252.370958333,26.60583,0.253,NULL,56230090568,878595165,13728049,16.6),(139342,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139342,37.98,0.46,394,66987,70,NULL,NULL,'2MASXi J1649312+382025',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000077,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,252.3802083,38.34044,0.049,NULL,59826038090,934781845,14605966,18),(139343,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139343,37.6,0.33,331,66988,70,NULL,NULL,'2MASX J16493231+3315116',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,252.384833,33.25333,0.073,NULL,59745834610,933528665,14586385,17.4),(139344,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139344,38.34,0.46,465,66989,70,NULL,NULL,'2MASX J16493422+3803299',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.0001,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,252.3925417,38.05836,0.053,NULL,59812092038,934563938,14602561,17.6),(139345,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139345,37.36,0.46,296,66990,70,NULL,NULL,'2MASX J16493443+2723005',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,252.3935417,27.38336,0.209,NULL,56235073034,878673016,13729265,17.1),(139346,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139346,37.61,0.46,333,66991,70,NULL,NULL,'2MASX J16493537+2825175',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000185,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,252.3975417,28.42153,0.189,NULL,56235697957,878682780,13729418,17.2),(139347,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139347,37.75,0.33,356,66992,70,NULL,NULL,'SDSS J164935.88+292015.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,252.3995,29.33758,0.125,NULL,56235346949,878677296,13729332,18.3),(139348,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139348,37.73,0.46,352,66993,70,NULL,NULL,'2MASX J16493765+2939385',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,252.407041667,29.66064,0.137,NULL,56235133625,878673962,13729280,17.6),(139349,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139349,37.17,0.33,272,66994,70,NULL,NULL,'2MASX J16493789+2424085',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000175,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,252.4079583,24.40233,0.181,NULL,56197062027,878079094,13719985,17.4),(139350,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139350,38.21,0.46,438,66995,70,NULL,NULL,'2MASX J16493974+3210426',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,252.415541667,32.17853,0.081,NULL,56219340545,878427196,13725424,17.4),(139351,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139351,38.15,0.27,426,66996,70,NULL,NULL,'2MASX J16493999+2729485',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,252.4165417,27.49678,0.201,NULL,56235091124,878673298,13729270,17.6),(139352,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139352,36.7,0.46,219,66997,70,NULL,NULL,'2MASX J16494120+2450105',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000173,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,252.4217083,24.83636,0.173,NULL,56199299069,878114047,13720531,16.6),(139353,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139353,37.17,0.33,272,66998,70,NULL,NULL,'2MASX J16494163+2421525',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000165,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,252.423583,24.3645,0.181,NULL,56197070206,878079221,13719987,17),(139354,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139354,38.15,0.27,426,66999,70,NULL,NULL,'2MASX J16494298+2722105',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,252.4292083,27.36956,0.209,NULL,56235071846,878672997,13729265,18.5),(139355,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139355,36.9,0.33,240,67000,70,NULL,NULL,'2MASX J16494326+3852219',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000117,NULL,'15.7g',0.38,'E0',NULL,NULL,NULL,NULL,1,252.430375,38.87269,0.045,NULL,59826177138,934784017,14606000,15.7),(139356,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139356,37.93,0.46,386,67001,70,NULL,NULL,'2MASX J16494401+4004299',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000082,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,252.433333,40.07508,0.029,NULL,59817700171,934651565,14603930,17.8),(139357,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139357,37.45,0.33,310,67002,70,NULL,NULL,'SDSS J164950.79+351211.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000137,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,252.461708333,35.20325,0.053,NULL,59747420715,933553448,14586772,18.6),(139358,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139358,37.59,0.46,330,67003,70,NULL,NULL,'SDSS J164951.04+213740.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,252.4627083,21.62778,0.257,NULL,56689896010,885779625,13840306,18.5),(139359,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1994Q',NULL,139359,34.62,0.18,81.5,67004,74.2,NULL,'SALT 2','CGCG 224-104',0.02956,'2010ApJ...716..712A',2010,1,0.55,NULL,'G',0.000053,NULL,'15.9g',0.31,'S0',NULL,NULL,NULL,NULL,1,252.463208333,40.43342,0.021,NULL,59817764435,934652569,14603946,15.9),(139360,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1994Q',NULL,139360,35.29,0.09,114,67004,74.4,NULL,NULL,'CGCG 224-104',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139361,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1994Q',NULL,139361,35.41,0.04,117,67004,72,NULL,NULL,'CGCG 224-104',0.02956,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139362,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1994Q',NULL,139362,35.41,0.17,117,67004,70,NULL,'SALT 2','CGCG 224-104',0.02956,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139363,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1994Q',NULL,139363,35.47,0.12,124,67004,70.8,NULL,NULL,'CGCG 224-104',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139364,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1994Q',NULL,139364,35.58,0.08,127,67004,70,NULL,'SALT','CGCG 224-104',0.02956,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139365,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1994Q',NULL,139365,35.76,0.14,134,67004,65,NULL,'MLCS2k2','CGCG 224-104',0.02956,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139366,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1994Q',NULL,139366,35.7,0.19,134,67004,65,NULL,NULL,'CGCG 224-104',0.02956,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139367,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1994Q',NULL,139367,35.72,0.2,139,67004,60,NULL,'M(V) = -19.47 mag','CGCG 224-104',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139368,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1994Q',NULL,139368,35.73,0.19,140,67004,60,NULL,'M(B) = -19.48 mag','CGCG 224-104',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139369,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1994Q',NULL,139369,35.73,0.14,140,67004,60,NULL,'M(I) = -19.19 mag','CGCG 224-104',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139370,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1994Q',NULL,139370,35.86,0.13,149,67004,65,NULL,'Snapshot','CGCG 224-104',NULL,'1996ApJ...473...88R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139371,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1994Q',NULL,139371,35.9,0.14,151,67004,60,NULL,NULL,'CGCG 224-104',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139372,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1994Q',NULL,139372,36.12,0.14,162,67004,65,NULL,'MLCS','CGCG 224-104',0.02956,'1996ApJ...473..588R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139373,'IRAS','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139373,34.21,0.8,69.4,67005,75,NULL,'MAT, I','ESO 069- G 011',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'12.78',0.5,'SAB(rs)c',NULL,NULL,NULL,NULL,1,252.4755,-71.20222,0.541,NULL,44972240055,702691250,10979550,12.78),(139374,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139374,33.86,0.32,59.1,67005,85,NULL,'I, raw','ESO 069- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139375,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139375,33.9,0.32,60.3,67005,85,NULL,'I, inv','ESO 069- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139376,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139376,33.92,0.43,60.7,67005,75,NULL,'MAT, I, raw','ESO 069- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139377,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139377,34.12,0.43,66.7,67005,75,NULL,'MAT, I, inv','ESO 069- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139378,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139378,34.14,0.43,67.3,67005,75,NULL,'MAT, I, cor','ESO 069- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139379,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139379,34.16,0.37,67.9,67005,NULL,NULL,'Malmquist cor.','ESO 069- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139380,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139380,34.24,0.36,70.4,67005,NULL,NULL,NULL,'ESO 069- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139381,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139381,34.28,0.2,71.8,67005,74.4,NULL,NULL,'ESO 069- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139382,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139382,34.37,0.4,74.8,67005,NULL,NULL,'mean','ESO 069- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139383,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139383,34.54,0.47,80.9,67005,NULL,NULL,'H','ESO 069- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139384,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139384,34.67,0.46,85.9,67005,NULL,NULL,'J','ESO 069- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139385,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139385,37.45,0.33,310,67006,70,NULL,NULL,'2MASX J16495634+3512430',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000187,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,252.485,35.21211,0.053,NULL,59747419503,933553429,14586772,16.4),(139386,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139386,37.5,0.46,316,67007,70,NULL,NULL,'2MASX J16495731+2830259',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,252.4887083,28.50719,0.177,NULL,56235676458,878682444,13729413,17.5),(139387,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139387,37.72,0.46,351,67008,70,NULL,NULL,'2MASX J16495932+3015210',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000156,NULL,'17.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,252.497333,30.25589,0.125,NULL,56216408360,878381380,13724709,17.5),(139388,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139388,35.51,NULL,126,67009,NULL,NULL,'Dipole','UGC 10569',NULL,'2010Ap&SS.325..163P',2010,1,1.93,NULL,'G',0.00001,NULL,'15.27',0.24,'Sc',NULL,NULL,NULL,NULL,1,252.5,9.43583,0.389,NULL,56729184368,886393505,13849898,15.27),(139389,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139389,35.51,NULL,126,67009,NULL,NULL,'Dipole + Quadrupole','UGC 10569',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139390,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139390,35.51,NULL,127,67009,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10569',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139391,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139391,35.61,NULL,133,67009,NULL,NULL,NULL,'UGC 10569',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139392,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139392,35.98,0.15,157,67010,70,NULL,NULL,'2MASX J16500190+2341424',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000178,NULL,'15.8g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,252.508,23.69514,0.185,NULL,56680685993,885635718,13838058,15.8),(139393,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139393,37.4,0.46,302,67011,70,NULL,NULL,'2MASX J16500253+2625419',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,252.510583,26.42819,0.229,NULL,56197487480,878085741,13720089,17.5),(139394,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139394,38.15,0.27,426,67012,70,NULL,NULL,'SDSS J165003.03+274021.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000126,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,252.512667,27.67272,0.201,NULL,56234522590,878664415,13729131,18.4),(139395,'Tully est','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139395,31.39,0.8,18.9,67013,75,NULL,'B','NGC 6239',NULL,'1988NBGC.C....0000T',1988,1,1.99,NULL,'G',0.000009,NULL,'12.9g',0.98,'SB(s)b pec?    HII',NULL,NULL,NULL,NULL,1,252.52075,42.73969,0.013,NULL,59815954727,934624292,14603504,12.9),(139396,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139396,31.76,0.46,22.4,67013,NULL,NULL,NULL,'NGC 6239',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139397,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139397,31.84,0.2,23.3,67013,74.4,NULL,NULL,'NGC 6239',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139398,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139398,31.91,0.43,24.1,67013,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6239',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139399,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139399,31.94,0.43,24.4,67013,75,NULL,'3.6 micron, color corrected','NGC 6239',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139400,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139400,32.04,0.41,25.6,67013,NULL,NULL,'Malmquist cor.','NGC 6239',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139401,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139401,36.89,0.46,239,67014,70,NULL,NULL,'2MASX J16500647+3526400',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000175,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,252.526875,35.44456,0.057,NULL,59747571443,933555803,14586809,16.3),(139402,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139402,37.25,0.46,282,67015,70,NULL,NULL,'2MASX J16500810+2713109',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000204,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,252.5337083,27.21961,0.209,NULL,56234281620,878660650,13729072,16.8),(139403,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139403,35.98,0.15,157,67016,70,NULL,NULL,'2MASX J16501092+2312444',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000193,NULL,'16.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,252.5454583,23.21242,0.261,NULL,56680329440,885630147,13837971,16.4),(139404,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139404,37.74,0.46,353,67017,70,NULL,NULL,'2MASX J16501152+2917359',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000191,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,252.5482083,29.29339,0.125,NULL,56221612454,878462694,13725979,16.6),(139405,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139405,37.66,0.46,340,67018,70,NULL,NULL,'2MASX J16501178+3639051',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,252.549167,36.65131,0.061,NULL,59813248293,934582004,14602843,17.6),(139406,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139406,37.78,0.46,359,67019,70,NULL,NULL,'2MASX J16501401+4244454',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000085,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,252.558125,42.74581,0.013,NULL,59815841610,934622525,14603476,17.3),(139407,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139407,35.98,0.15,157,67020,70,NULL,NULL,'NGC 6233',NULL,'2015arXiv151105856S',2015,1,1.32,NULL,'G',0.000177,NULL,'14.2g',0.8,'S0',NULL,NULL,NULL,NULL,1,252.565417,23.57983,0.185,NULL,56680719553,885636243,13838066,14.2),(139408,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139408,37.99,0.46,397,67021,70,NULL,NULL,'2MASX J16501834+2651029',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,252.576417,26.85094,0.185,NULL,56229907595,878592306,13728004,17.4),(139409,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139409,38.54,0.46,512,67022,70,NULL,NULL,'2MASX J16501973+3039120',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,252.582083,30.65325,0.125,NULL,56217154059,878393032,13724891,17.5),(139410,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139410,35.98,0.15,157,67023,70,NULL,NULL,'2MASX J16501980+2334254',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000181,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,252.582416667,23.57386,0.185,NULL,56680601816,885634403,13838037,16.6),(139411,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139411,37.9,0.46,380,67024,70,NULL,NULL,'2MASX J16502404+3320570',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000138,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,252.600333,33.34908,0.077,NULL,59746159493,933533742,14586464,17.9),(139412,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139412,36.4,0.56,191,67025,70,NULL,NULL,'2MASX J16502677-6347264',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,252.611583333,-63.79064,0.729,NULL,44475617206,694931518,10858304,15.5),(139413,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139413,37.28,0.46,285,67026,70,NULL,NULL,'2MASX J16502881+2653578',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000186,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,252.619958333,26.89939,0.185,NULL,56234116977,878658077,13729032,17.3),(139414,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139414,35.11,NULL,105,67027,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2074',NULL,'2010Ap&SS.325..163P',2010,1,0.88,NULL,'G',0.000049,NULL,'16.5g',0.16,'Sd(f)          NLAGN',NULL,NULL,NULL,NULL,1,252.6214583,40.78736,0,NULL,59817868459,934654194,14603971,16.5),(139415,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139415,35.13,NULL,106,67027,NULL,NULL,'Dipole + Quadrupole','FGC 2074',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139416,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139416,35.14,NULL,107,67027,NULL,NULL,'Dipole','FGC 2074',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139417,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139417,35.17,NULL,108,67027,NULL,NULL,NULL,'FGC 2074',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139418,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139418,37.11,0.33,265,67028,70,NULL,NULL,'2MASX J16502958+2718068',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000155,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,252.623125,27.30194,0.209,NULL,56234177234,878659019,13729047,17.6),(139419,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139419,33.83,0.5,58.4,67029,70,NULL,NULL,'2MASX J16503068-6149194',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'12.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,252.627833,-61.82211,0.761,NULL,44470103001,694845359,10856958,12.2),(139420,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139420,36.88,0.61,237,67030,70,NULL,NULL,'2MASX J16503194-6838226',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,252.6330417,-68.63972,0.437,NULL,45023983073,703499735,10992183,15.7),(139421,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139421,37.16,0.46,270,67031,70,NULL,NULL,'2MASX J16503231+3207350',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,252.634625,32.12647,0.089,NULL,56219374786,878427731,13725433,18),(139422,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','PTF10nlg',NULL,139422,36.97,0.04,248,67032,72,NULL,'M(H) = -18.317 mag','PTF10nlg',NULL,'2014ApJ...784..105W',2013,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,252.64375,60.27639,0,NULL,57658164868,900908826,14076700,NULL),(139423,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','PTF10nlg',NULL,139423,36.99,0.02,250,67032,NULL,NULL,'H','PTF10nlg',NULL,'2012MNRAS.425.1007B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139424,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','PTF10nlg',NULL,139424,37.11,0.03,264,67032,NULL,NULL,'J','PTF10nlg',NULL,'2012MNRAS.425.1007B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139425,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','PTF10nlg',NULL,139425,37.3,0.03,274,67032,70,NULL,'SiFTO+SALT2, SN PTF10nlg','PTF10nlg',0.056,'2012MNRAS.426.2359M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139426,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','PTF10nlg',NULL,139426,37.45,0.03,293,67032,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10nlg',0.056,'2014MNRAS.438.1391P',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139427,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139427,38.73,0.46,557,67033,70,NULL,NULL,'2MASX J16503932+3341420',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000191,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,252.663833,33.69489,0.069,NULL,59746199079,933534360,14586474,17.8),(139428,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139428,35.98,0.15,157,67034,70,NULL,NULL,'2MASX J16503940+2327451',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000165,NULL,'15.5g',0.29,'S0^-',NULL,NULL,NULL,NULL,1,252.6642083,23.46258,0.185,NULL,56680637178,885634955,13838046,15.5),(139429,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139429,36.11,0.37,167,67035,NULL,NULL,'Malmquist cor.','2MASX J16503970+7839062',NULL,'2009ApJS..182..474S',2009,1,0.92,NULL,'G',0.000027,NULL,'13.69',NULL,'Sa',NULL,NULL,NULL,NULL,1,252.665167,78.65172,0.145,NULL,57140208382,892815755,13950246,13.69),(139430,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139430,36.32,0.34,184,67035,NULL,NULL,NULL,'2MASX J16503970+7839062',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139431,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139431,36.36,0.2,187,67035,74.4,NULL,NULL,'2MASX J16503970+7839062',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139432,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139432,37.96,0.46,392,67036,70,NULL,NULL,'2MASX J16504119+2811179',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000146,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,252.671541667,28.18825,0.189,NULL,56234358422,878661850,13729091,17.9),(139433,'G Lens','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139433,41.59,NULL,2080,67037,NULL,NULL,'Standard','SDSS J1650+4251',NULL,'2014ApJ...788..190W',2014,1,NULL,'This QSO is lensed by a foreground z=0.577 galaxy.','QSO',0.000457,NULL,'17.5g',NULL,'BAL',NULL,NULL,NULL,'QSO',1,252.6810417,42.86369,0,NULL,59815149303,934611707,14603307,17.5),(139434,'G Lens','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139434,41.61,NULL,2100,67037,NULL,NULL,'R(H) = ct','SDSS J1650+4251',NULL,'2014ApJ...788..190W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139435,'G Lens','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139435,41.91,0.38,2410,67037,NULL,NULL,NULL,'SDSS J1650+4251',NULL,'2007ApJ...660....1O',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139436,'G Lens','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139436,43.74,0.72,5600,67037,NULL,NULL,NULL,'SDSS J1650+4251',NULL,'2014MNRAS.437..600S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139437,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139437,35.17,0.49,108,67038,70,NULL,NULL,'2MASX J16504398-6242504',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,252.6835,-62.71428,0.729,NULL,44476118610,694939353,10858427,14.4),(139438,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139438,38.05,0.46,408,67039,70,NULL,NULL,'2MASX J16504542+2746519',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,252.689375,27.78111,0.201,NULL,56234497051,878664016,13729125,18.3),(139439,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139439,38.89,0.46,600,67040,70,NULL,NULL,'SDSS J165047.16+301111.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000168,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,252.6965,30.18664,0.125,NULL,56216491840,878382685,13724729,18.6),(139440,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139440,38.48,0.46,496,67041,70,NULL,NULL,'2MASX J16504731+3137587',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000169,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,252.697167,31.63308,0.109,NULL,56219821020,878434703,13725542,18.1),(139441,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139441,37.55,0.21,324,67042,70,NULL,NULL,'SDSS J165048.83+325027.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00016,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,252.7035,32.84106,0.081,NULL,56204806544,878200102,13721876,18.5),(139442,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139442,37.14,0.46,268,67043,70,NULL,NULL,'2MASX J16504910+2114531',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,252.704667,21.24822,0.257,NULL,56687852328,885747692,13839807,17),(139443,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139443,37.5,0.46,317,67044,70,NULL,NULL,'2MASX J16504985+4002175',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000076,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,252.70775,40.03825,0.029,NULL,59817664318,934651004,14603921,17.6),(139444,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139444,37.55,0.21,324,67045,70,NULL,NULL,'2MASX J16505076+3248547',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,252.711541667,32.81517,0.081,NULL,56205673524,878213648,13722088,17),(139445,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139445,37.11,0.33,265,67046,70,NULL,NULL,'2MASX J16505100+2719419',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000184,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,252.712416667,27.32831,0.209,NULL,56234199578,878659368,13729052,16.9),(139446,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139446,35.13,NULL,106,67047,NULL,NULL,NULL,'FGC 2075',NULL,'2000BSAO...50....5K',2000,1,1.2,NULL,'G',0.000056,NULL,'16.7g',0.15,'Sd(f)',NULL,NULL,NULL,NULL,1,252.713,39.36794,0.041,NULL,59826442896,934788170,14606065,16.7),(139447,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139447,35.51,0.46,126,67048,70,NULL,NULL,'CGCG 225-003',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000077,NULL,'15.3g',0.5,'E0',NULL,NULL,NULL,NULL,1,252.713167,39.59828,0.037,NULL,59826434140,934788033,14606063,15.3),(139448,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139448,35.39,NULL,120,67049,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG +08-31-009',NULL,'2010Ap&SS.325..163P',2010,1,0.96,NULL,'G',NULL,NULL,'16.8g',0.11,'Sd',NULL,NULL,NULL,NULL,1,252.72375,47.21783,0.005,NULL,59616648014,931510125,14554845,16.8),(139449,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139449,35.41,NULL,121,67049,NULL,NULL,'Dipole + Quadrupole','MCG +08-31-009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139450,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139450,35.43,NULL,122,67049,NULL,NULL,'Dipole','MCG +08-31-009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139451,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139451,35.43,NULL,122,67049,NULL,NULL,NULL,'MCG +08-31-009',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139452,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139452,36.6,0.33,209,67050,70,NULL,NULL,'2MASX J16505413+2031220',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000167,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,252.7255,20.52294,0.305,NULL,56683880000,885685625,13838837,16.5),(139453,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139453,33.88,0.48,59.7,67051,70,NULL,NULL,'ESO 137-IG 044 NED01',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000087,NULL,'15.32',0.5,'SB(s)0+:','Pair member (points to parent)',NULL,NULL,NULL,1,252.727583,-61.81264,0.761,NULL,44470107678,694845432,10856959,15.32),(139454,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139454,37.6,0.46,332,67052,70,NULL,NULL,'2MASX J16505526+2759579',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000183,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,252.730167,27.99942,0.201,NULL,56234378564,878662165,13729096,17.5),(139455,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139455,35.53,0.46,128,67053,70,NULL,NULL,'2MASX J16505636+2844289',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,252.734833,28.74133,0.181,NULL,56221988093,878468563,13726071,16.3),(139456,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139456,37.55,0.21,324,67054,70,NULL,NULL,'2MASX J16505750+3249377',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000215,NULL,'16.4g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,252.739625,32.82719,0.081,NULL,56205687669,878213869,13722091,16.4),(139457,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139457,35.81,0.25,145,67055,74.4,NULL,NULL,'UGC 10638 NED05',NULL,'2013AJ....146...86T',2013,1,0.2,NULL,'G',0.000073,NULL,'14.16',NULL,'E/S0','Group member, 2nd ranked galaxy',NULL,NULL,NULL,1,252.744667,81.57481,0.269,NULL,56956372663,889943322,13905364,14.16),(139458,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139458,36.01,0.28,159,67055,70,NULL,NULL,'UGC 10638 NED05',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139459,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139459,37.55,0.21,324,67056,70,NULL,NULL,'2MASX J16505989+3247467',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,252.7497083,32.7965,0.097,NULL,56205679252,878213738,13722089,17.9),(139460,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139460,37.21,0.46,277,67057,70,NULL,NULL,'2MASX J16510002+2232073',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,252.7500417,22.53539,0.261,NULL,56689559108,885774361,13840224,17.5),(139461,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139461,37.88,0.46,377,67058,70,NULL,NULL,'2MASXi J1651014+412337',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000081,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,252.7559583,41.39394,0,NULL,59818600649,934665635,14604150,17.8),(139462,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139462,32.66,0.48,34.1,67059,70,NULL,NULL,'ESO 137- G 045',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000107,NULL,'13.25',1.2,'E:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,252.761417,-60.80869,1.133,NULL,44499799575,695309368,10864208,13.25),(139463,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139463,36.6,0.33,209,67060,70,NULL,NULL,'2MASX J16510394+2018014',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000196,NULL,'16.1g',0.42,'E0',NULL,NULL,NULL,NULL,1,252.7665,20.30044,0.297,NULL,56683761094,885683767,13838808,16.1),(139464,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139464,35.87,0.49,149,67061,75,NULL,'IR','2MFGC 13495',NULL,'2011yCatp016004901K',2011,1,0.62,NULL,'G',0.000086,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,252.769041667,22.54442,0.261,NULL,56688445747,885756964,13839952,16.7),(139465,'Tully est','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139465,31.55,0.8,20.5,67062,75,NULL,'B','NGC 6215',NULL,'1988NBGC.C....0000T',1988,1,2.1,'Confused HIPASS source','G',0.000013,NULL,'12.0B',1.8,'SA(s)c pec','in a pair',NULL,NULL,NULL,1,252.778375,-58.99347,NULL,NULL,44554038627,696156853,10877450,12),(139466,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139466,38.03,0.46,405,67063,70,NULL,NULL,'SDSS J165106.88+294848.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,252.778667,29.81339,0.181,NULL,56214181298,878346582,13724165,18.3),(139467,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139467,35.81,0.25,145,67064,74.4,NULL,NULL,'UGC 10638 NED02',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000073,NULL,'14.90',NULL,'E/S0',NULL,NULL,NULL,NULL,1,252.782833,81.58225,0.269,NULL,56956372862,889943325,13905364,14.9),(139468,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139468,36.01,0.28,159,67064,70,NULL,NULL,'UGC 10638 NED02',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139469,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139469,37.31,0.46,290,67065,70,NULL,NULL,'2MASX J16510868+3240357',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000196,NULL,'16.2g',0.42,NULL,NULL,NULL,NULL,NULL,1,252.7862083,32.67667,0.097,NULL,56205650988,878213296,13722082,16.2),(139470,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139470,35.94,0.32,154,67066,NULL,NULL,'Malmquist cor.','UGC 10582',NULL,'2009ApJS..182..474S',2009,1,1.05,NULL,'G',0.000033,NULL,'15.7g',0.27,'Sbc',NULL,NULL,NULL,NULL,1,252.795083,23.94714,0.201,NULL,56679857625,885622775,13837855,15.7),(139471,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139471,35.96,0.2,156,67066,74.4,NULL,NULL,'UGC 10582',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139472,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139472,36.07,0.3,164,67066,NULL,NULL,NULL,'UGC 10582',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139473,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139473,37.69,0.33,346,67067,70,NULL,NULL,'2MASX J16511165+3217167',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000154,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,252.7985,32.288,0.097,NULL,56219245395,878425709,13725401,17.1),(139474,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139474,37.5,0.46,316,67068,70,NULL,NULL,'2MASX J16511223+2555309',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,252.800875,25.92542,0.209,NULL,56198282230,878098159,13720283,17.1),(139475,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139475,37.3,0.46,288,67069,70,NULL,NULL,'2MASX J16511465+4358238',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000095,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,252.81125,43.97331,0,NULL,59613700051,931464063,14554125,16.9),(139476,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139476,36.1,0.46,166,67070,70,NULL,NULL,'2MASX J16511671+2806519',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000095,NULL,'15.9g',NULL,'SF',NULL,NULL,NULL,NULL,1,252.8195,28.11458,0.201,NULL,56223099074,878485923,13726342,15.9),(139477,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139477,36.74,0.46,222,67071,70,NULL,NULL,'2MASX J16511784+3205187',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000176,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,252.824375,32.08844,0.089,NULL,56219170752,878424543,13725383,16.5),(139478,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139478,36.55,0.64,204,67072,70,NULL,NULL,'2MASX J16511789-0016258',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,252.824583,-0.27386,0.385,NULL,45172863370,705825990,11028531,15.6),(139479,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139479,35.65,0.56,135,67073,70,NULL,NULL,'2MASX J16512015-1444385',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.4,NULL,NULL,NULL,NULL,NULL,1,252.833917,-14.74406,1.449,NULL,46163885124,721310705,11270479,14.4),(139480,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139480,37.69,0.33,346,67074,70,NULL,NULL,'2MASX J16512066+3222146',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000178,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,252.8362083,32.37078,0.097,NULL,56219001255,878421894,13725342,17.1),(139481,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139481,36.64,0.46,213,67075,70,NULL,NULL,'2MASX J16512071+4052267',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000074,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,252.83625,40.874,0,NULL,59817455467,934647741,14603870,16.5),(139482,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139482,37.92,0.46,385,67076,70,NULL,NULL,'2MASX J16512182+3111537',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,252.841167,31.19811,0.101,NULL,56219786361,878434161,13725533,17.9),(139483,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139483,37.55,0.21,324,67077,70,NULL,NULL,'2MASX J16512421+3247437',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000183,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,252.851,32.79558,0.097,NULL,56205704049,878214125,13722095,16.8),(139484,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139484,37.24,0.46,281,67078,70,NULL,NULL,'2MASX J16512622+2219294',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,252.859125,22.32478,0.253,NULL,56689255301,885769614,13840150,17.8),(139485,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139485,36.9,0.33,240,67079,70,NULL,NULL,'2MASX J16513224+3848067',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000097,NULL,'15.8g',0.44,'E0',NULL,NULL,NULL,NULL,1,252.884375,38.80178,0.045,NULL,59826052115,934782064,14605969,15.8),(139486,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139486,34.91,0.45,95.9,67080,NULL,NULL,'K','UGCA 414',NULL,'2007A&A...465...71T',2007,1,2,NULL,'G',0.000043,NULL,'13',1.7,'SB(rs)bc       HII',NULL,NULL,NULL,NULL,1,252.884667,-3.09667,0.605,NULL,45169551929,705774248,11027722,13),(139487,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139487,34.94,0.46,97.2,67080,NULL,NULL,'J','UGCA 414',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139488,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139488,34.94,0.47,97.4,67080,NULL,NULL,'H','UGCA 414',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139489,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139489,35.01,0.4,101,67080,NULL,NULL,'mean','UGCA 414',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139490,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139490,38.54,0.46,510,67081,70,NULL,NULL,'2MASX J16513420+4050377',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00009,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,252.89275,40.84375,0,NULL,59817421176,934647205,14603862,17.4),(139491,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139491,37.33,0.46,293,67082,70,NULL,NULL,'2MASX J16513485+2534490',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,252.895125,25.58039,0.189,NULL,56198126541,878095727,13720245,17.6),(139492,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139492,36.51,0.46,200,67083,70,NULL,NULL,'2MASX J16513525+1818540',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,252.896875,18.315,0.309,NULL,56865867145,888529174,13883268,17.3),(139493,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139493,37.77,0.46,358,67084,70,NULL,NULL,'2MASX J16514196+2638300',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000165,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,252.9249583,26.64158,0.209,NULL,56197438357,878084974,13720077,18),(139494,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139494,37.28,0.46,286,67085,70,NULL,NULL,'2MASX J16514251+3914086',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000107,NULL,'16.87',0.32,NULL,NULL,NULL,NULL,NULL,1,252.927166667,39.23581,0.041,NULL,59826327472,934786366,14606036,16.87),(139495,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139495,35.98,0.15,157,67086,70,NULL,NULL,'2MASX J16514444+2342400',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00019,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,252.935166667,23.71108,0.197,NULL,56679951635,885624244,13837878,16.4),(139496,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139496,35.82,0.25,146,67087,74.4,NULL,NULL,'UGC 10638 NED06',NULL,'2013AJ....146...86T',2013,1,0.13,NULL,'G',0.000073,NULL,'14.29',NULL,'E/S0',NULL,NULL,NULL,NULL,1,252.9374583,81.592,0.269,NULL,56956499060,889945297,13905395,14.29),(139497,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139497,36.01,0.28,159,67087,70,NULL,NULL,'UGC 10638 NED06',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139498,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139498,38.03,0.46,403,67088,70,NULL,NULL,'2MASX J16514731+2619500',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,252.947208333,26.33061,0.229,NULL,56197575884,878087123,13720111,18.1),(139499,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139499,33.82,0.49,58,67089,70,NULL,NULL,'2MASX J16514761-6133582',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.37',0.46,NULL,NULL,NULL,NULL,NULL,1,252.948917,-61.56692,0.789,NULL,44469675124,694838673,10856854,15.37),(139500,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139500,34.14,NULL,67.3,67090,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2089',NULL,'2010Ap&SS.325..163P',2010,1,0.63,NULL,'G',0.000027,NULL,'16.09',0.09,'Scd',NULL,NULL,NULL,NULL,1,252.951667,78.75361,0.145,NULL,57140227033,892816047,13950250,16.09),(139501,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139501,34.17,NULL,68.1,67090,NULL,NULL,'Dipole + Quadrupole','FGC 2089',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139502,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139502,34.19,NULL,69,67090,NULL,NULL,'Dipole','FGC 2089',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139503,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139503,34.4,0.69,75.9,67090,NULL,NULL,NULL,'FGC 2089',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139504,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139504,34.44,0.2,77.3,67090,74.4,NULL,NULL,'FGC 2089',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139505,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139505,34.68,0.6,86.1,67090,NULL,NULL,'Malmquist cor.','FGC 2089',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139506,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139506,38.33,0.46,464,67091,70,NULL,NULL,'2MASX J16514858+3541348',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000148,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,252.9525,35.69311,0.069,NULL,59743955412,933499303,14585926,17.5),(139507,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139507,36.19,0.46,173,67092,70,NULL,NULL,'2MASX J16514927+2006100',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000162,NULL,'16.2g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,252.9552083,20.10278,0.297,NULL,56683471663,885679244,13838738,16.2),(139508,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139508,35.37,0.46,119,67093,70,NULL,NULL,'2MASX J16514954+3711109',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00008,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,252.956375,37.18633,0.069,NULL,59814883183,934607549,14603242,16.3),(139509,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139509,35.74,0.46,141,67094,70,NULL,NULL,'2MASX J16515086+1749385',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'17.23',0.32,NULL,NULL,NULL,NULL,NULL,1,252.9619583,17.82731,0.273,NULL,56894118471,888970601,13890165,17.23),(139510,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139510,35.47,0.56,124,67095,70,NULL,NULL,'2MASX J16515408-8001482',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,252.975167,-80.03008,0.485,NULL,44272404152,691756314,10808692,16.1),(139511,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139511,35.81,0.25,145,67096,74.4,NULL,NULL,'GIN 616',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000057,NULL,'14.94',NULL,'S',NULL,NULL,NULL,NULL,1,252.994667,81.51172,0.269,NULL,56955584538,889931008,13905172,14.94),(139512,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139512,36.01,0.28,159,67096,70,NULL,NULL,'GIN 616',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139513,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139513,37.92,0.46,383,67097,70,NULL,NULL,'2MASX J16520091+2726417',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,253.003875,27.44481,0.209,NULL,56222742015,878480343,13726255,18.5),(139514,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139514,37.91,0.33,382,67098,70,NULL,NULL,'2MASX J16520187+2853467',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,253.007833,28.89631,0.141,NULL,56221967447,878468241,13726066,17.4),(139515,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139515,37.91,0.33,382,67099,70,NULL,NULL,'2MASX J16520240+2853207',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000145,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,253.01,28.88897,0.141,NULL,56221968214,878468253,13726066,18.5),(139516,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139516,36.93,0.46,243,67100,70,NULL,NULL,'2MASX J16520295+4045089',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00008,NULL,'16.2g',0.32,'E0',NULL,NULL,NULL,NULL,1,253.0122083,40.75239,0,NULL,59817413110,934647079,14603860,16.2),(139517,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139517,37.07,0.46,259,67101,70,NULL,NULL,'2MASX J16520686+3244350',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000196,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,253.028583,32.74303,0.097,NULL,56205156272,878205566,13721961,16.2),(139518,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139518,36.88,0.46,238,67102,70,NULL,NULL,'2MASX J16520701+2334516',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,253.029375,23.581,0.229,NULL,56688215988,885753374,13839896,17.1),(139519,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139519,35.11,0.52,105,67103,70,NULL,NULL,'2MASX J16520774-1703135',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.2R',NULL,'HII?',NULL,NULL,NULL,NULL,1,253.03225,-17.05375,1.105,NULL,46155520380,721180005,11268437,14.2),(139520,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139520,37.63,0.46,336,67104,70,NULL,NULL,'2MASX J16521118+3050410',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,253.0464583,30.84478,0.113,NULL,56217090389,878392037,13724875,17.6),(139521,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139521,35.58,0.63,131,67105,70,NULL,NULL,'2MASX J16521197-0203452',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,253.05,-2.06253,0.473,NULL,45220439466,706569366,11040146,15.6),(139522,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139522,36.91,0.46,241,67106,70,NULL,NULL,'2MASX J16521228+2115166',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000173,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,253.051167,21.25458,0.249,NULL,56687974700,885749604,13839837,16.3),(139523,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139523,35.82,0.25,146,67107,74.4,NULL,NULL,'UGC 10638 NED09',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000073,NULL,'14.48',NULL,'E/S0',NULL,NULL,NULL,NULL,1,253.0539583,81.62019,0.269,NULL,56956496949,889945264,13905394,14.48),(139524,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139524,36.01,0.28,159,67107,70,NULL,NULL,'UGC 10638 NED09',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139525,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139525,38.73,0.46,558,67108,70,NULL,NULL,'SDSS J165213.62+294045.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,253.05675,29.67928,0.181,NULL,56221688223,878463878,13725998,18.2),(139526,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139526,37.94,0.46,388,67109,70,NULL,NULL,'2MASX J16521363+2614177',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000162,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,253.0569583,26.23817,0.229,NULL,56197527692,878086370,13720099,18.1),(139527,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139527,36.11,0.66,166,67110,70,NULL,NULL,'2MASX J16521414-6048123',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,253.0590417,-60.80336,1.133,NULL,44500918198,695326846,10864481,15.9),(139528,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139528,35.98,0.15,157,67111,70,NULL,NULL,'2MASX J16521489+2349096',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000168,NULL,'16.1g',0.34,'E0',NULL,NULL,NULL,NULL,1,253.062041667,23.81942,0.213,NULL,56679944877,885624138,13837877,16.1),(139529,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139529,37.92,0.23,383,67112,70,NULL,NULL,'2MASX J16521603+2744477',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000093,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,253.066833,27.74644,0.213,NULL,56223456754,878491511,13726429,17.7),(139530,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139530,36.67,0.46,216,67113,70,NULL,NULL,'2MASX J16521630+6219274',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000079,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,253.067791667,62.32431,0.037,NULL,57535916759,898998699,14046854,17.3),(139531,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139531,35.98,0.15,157,67114,70,NULL,NULL,'CGCG 139-011',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000186,NULL,'16.0g',0.41,'E0','Group member',NULL,NULL,NULL,1,253.072,23.30039,0.249,NULL,56688200667,885753135,13839892,16),(139532,'D-Sigma','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139532,32.53,0.4,32,67115,75,NULL,'Edat, raw','ESO 069- G 014',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00015,NULL,'12.67',1,'SB0^0^: pec',NULL,NULL,NULL,NULL,1,253.076375,-69.12514,0.449,NULL,45018552167,703414877,10990857,12.67),(139533,'D-Sigma','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139533,32.86,0.4,37.4,67115,75,NULL,'Edat, cor','ESO 069- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139534,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139534,33.26,0.47,44.8,67115,70,NULL,NULL,'ESO 069- G 014',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139535,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139535,33.44,0.45,48.6,67115,NULL,NULL,'K','ESO 069- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139536,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139536,34.01,0.4,63.3,67115,NULL,NULL,'mean','ESO 069- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139537,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139537,35.98,0.15,157,67116,70,NULL,NULL,'2MASX J16522146+2323365',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000161,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,253.089458333,23.39344,0.229,NULL,56688204816,885753200,13839893,16.9),(139538,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139538,35.87,0.46,149,67117,70,NULL,NULL,'CGCG 169-009 NED01',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000133,NULL,'15.1g',0.52,'S0',NULL,NULL,NULL,NULL,1,253.0944583,30.71103,0.105,NULL,56217193901,878393654,13724900,15.1),(139539,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139539,36.84,0.33,233,67118,70,NULL,NULL,'2MASXi J1652242+235302',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000179,NULL,'16.3g',0.27,'S0^-',NULL,NULL,NULL,NULL,1,253.101083333,23.88394,0.213,NULL,56679776892,885621513,13837836,16.3),(139540,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139540,36.95,0.63,246,67119,70,NULL,NULL,'WKK 7630',NULL,'2014MNRAS.445.2677S',2014,1,0.28,NULL,'G',0.00015,NULL,'17.1',0.25,'w.comp.',NULL,NULL,NULL,NULL,1,253.110625,-59.98125,0.905,NULL,44499220631,695300322,10864067,17.1),(139541,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139541,38.11,0.46,418,67120,70,NULL,NULL,'2MASX J16522656+3814120',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000081,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,253.1109583,38.23656,0.069,NULL,59812284936,934566952,14602608,17.9),(139542,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139542,37.56,0.6,325,67121,70,NULL,NULL,'2MASX J16522685-6008363',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,253.11175,-60.1435,0.913,NULL,44501383301,695334114,10864595,16.3),(139543,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139543,35.62,0.46,133,67122,70,NULL,NULL,'CGCG 225-005',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00008,NULL,'15.7g',0.37,'S0/a',NULL,NULL,NULL,NULL,1,253.12125,40.31194,0.021,NULL,59818065705,934657276,14604019,15.7),(139544,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139544,37.49,0.46,315,67123,70,NULL,NULL,'2MASX J16522921+2433177',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000129,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,253.121708333,24.55489,0.233,NULL,56197288760,878082636,13720041,18),(139545,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139545,37.92,0.23,383,67124,70,NULL,NULL,'2MASX J16523411+2743247',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000147,NULL,'17.2g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,253.142208333,27.72342,0.213,NULL,56223450385,878491412,13726428,17.2),(139546,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139546,37.17,0.59,271,67125,70,NULL,NULL,'2MASX J16523428-7941120',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,253.142667,-79.68669,0.473,NULL,44274039100,691781860,10809091,16.5),(139547,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139547,37.51,0.46,317,67126,70,NULL,NULL,'2MASX J16523544+2827177',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000197,NULL,'16.2g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,253.147583333,28.45478,0.213,NULL,56223837666,878497463,13726522,16.2),(139548,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139548,38.32,0.46,461,67127,70,NULL,NULL,'2MASX J16523654+3202394',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,253.15225,32.04439,0.089,NULL,56219506971,878429796,13725465,18),(139549,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139549,36.29,0.46,181,67128,70,NULL,NULL,'2MASX J16523792+3851171',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000071,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,253.1580417,38.85489,0.065,NULL,59825587805,934774809,14605856,17.4),(139550,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139550,36.37,0.82,188,67129,70,NULL,NULL,'WKK 7642',NULL,'2014MNRAS.445.2677S',2014,1,0.32,NULL,'G',0.00015,NULL,'17.1',0.27,'s.p.* near blg',NULL,NULL,NULL,NULL,1,253.1595417,-59.95744,0.905,NULL,44499084417,695298194,10864034,17.1),(139551,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139551,36.26,0.46,178,67130,70,NULL,NULL,'2MASX J16523888+2419367',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000164,NULL,'16.3g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,253.1619583,24.32689,0.233,NULL,56196586692,878071667,13719869,16.3),(139552,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139552,37.85,0.46,372,67131,70,NULL,NULL,'2MASX J16523894+4042501',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000101,NULL,'17.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,253.162333,40.71383,0,NULL,59817492851,934648325,14603880,17.3),(139553,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139553,38.07,0.46,410,67132,70,NULL,NULL,'2MASX J16524177+2612507',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,253.174125,26.21417,0.257,NULL,56200399532,878131242,13720800,18.2),(139554,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139554,36.32,0.61,184,67133,70,NULL,NULL,'2MASX J16524201-0836043',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,253.175083333,-8.60125,0.949,NULL,46076403624,719943806,11249121,15.8),(139555,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139555,38.08,0.46,412,67134,70,NULL,NULL,'SDSS J165242.18+183922.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,253.17575,18.65631,0.313,NULL,56865920376,888530005,13883281,18.5),(139556,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139556,37.92,0.23,383,67135,70,NULL,NULL,'2MASX J16524293+2745167',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'18.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,253.179083333,27.75461,0.213,NULL,56223452672,878491448,13726428,18.1),(139557,'Sosies','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139557,29.12,0.32,6.67,67136,NULL,NULL,NULL,'NGC 6221',NULL,'2002A&A...393...57T',2002,1,3.5,'Confused HIPASS source','G',0.000017,NULL,'11.2B',2.5,'SB(s)bc pec;Sy1Sy2','in a pair',NULL,NULL,'unobscured Seyfert 2',1,253.192,-59.21861,NULL,NULL,44554115794,696158059,10877469,11.2),(139558,'Tully est','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139558,31.44,0.8,19.4,67136,75,NULL,'B','NGC 6221',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139559,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139559,30,0.43,10,67136,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6221',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139560,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139560,30.12,0.47,10.6,67136,NULL,NULL,'H','NGC 6221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139561,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139561,30.13,0.46,10.6,67136,NULL,NULL,'J','NGC 6221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139562,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139562,30.15,0.45,10.7,67136,NULL,NULL,'K','NGC 6221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139563,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139563,30.16,NULL,10.8,67136,NULL,NULL,'LEDA [April 2006]','NGC 6221',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139564,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139564,30.24,0.43,11.2,67136,75,NULL,'3.6 micron, color corrected','NGC 6221',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139565,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139565,30.31,0.36,11.5,67136,NULL,NULL,NULL,'NGC 6221',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139566,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139566,30.3,0.4,11.5,67136,73,NULL,'opt','NGC 6221',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139567,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139567,30.46,0.2,12.4,67136,74.4,NULL,NULL,'NGC 6221',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139568,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139568,31.14,0.4,16.9,67136,NULL,NULL,'mean','NGC 6221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139569,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139569,35.98,0.15,157,67137,70,NULL,NULL,'ARK 510',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000184,NULL,'14.9g',0.63,'E0','Group member',NULL,NULL,NULL,1,253.195625,23.24306,0.249,NULL,56688987159,885765424,13840084,14.9),(139570,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139570,35.81,0.25,145,67138,74.4,NULL,NULL,'UGC 10638 NED07',NULL,'2013AJ....146...86T',2013,1,0.25,NULL,'G',0.000073,NULL,'13.91',NULL,'E/S0;BrClG','Brightest group member',NULL,NULL,NULL,1,253.198917,81.63294,0.269,NULL,56956496832,889945263,13905394,13.91),(139571,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139571,36.01,0.28,159,67138,70,NULL,NULL,'UGC 10638 NED07',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139572,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139572,35.3,0.56,115,67139,70,NULL,NULL,'ESO 023- G 006',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000133,NULL,'15.5b',0.4,'S...',NULL,NULL,NULL,NULL,1,253.2005417,-79.83981,0.461,NULL,44272243890,691753810,10808653,15.5),(139573,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','PTF10fxl','N',139573,35.61,0.02,129,67140,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10fxl',0.0296,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139574,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139574,38.1,0.33,416,67141,70,NULL,NULL,'SDSS J165249.93+320029.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,253.208083333,32.00806,0.089,NULL,56219512866,878429888,13725467,18.3),(139575,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139575,36.31,0.33,183,67142,70,NULL,NULL,'2MASX J16525214+3951080',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000076,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,253.2172083,39.85219,0.057,NULL,59817248993,934644515,14603820,16.9),(139576,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139576,37.68,0.46,343,67143,70,NULL,NULL,'2MASX J16525423+2159530',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000211,NULL,'16.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,253.225958333,21.99792,0.253,NULL,56687440641,885741260,13839707,16.4),(139577,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139577,36.84,0.33,233,67144,70,NULL,NULL,'2MASX J16525467+2350070',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,253.227667,23.83528,0.213,NULL,56679767707,885621370,13837833,17.1),(139578,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139578,37.78,0.46,360,67145,70,NULL,NULL,'2MASX J16525486+2757457',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,253.22875,27.96261,0.209,NULL,56223236531,878488070,13726376,18),(139579,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139579,37.62,0.23,334,67146,70,NULL,NULL,'2MASX J16525715+3301595',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000176,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,253.238291667,33.03331,0.097,NULL,56205547407,878211678,13722057,17.2),(139580,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139580,37.62,0.23,334,67147,70,NULL,NULL,'2MASX J16525897+3257204',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000161,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,253.245583333,32.95567,0.097,NULL,56205068333,878204192,13721940,16.8),(139581,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1997ck',NULL,139581,42.08,0.82,1320,67148,74.2,NULL,'SALT 2','H-ZSNS J165300.27+350346.4',0.97,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,253.251125,35.06289,0.069,NULL,59744462553,933507227,14586050,NULL),(139582,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1997ck',NULL,139582,44.06,0.27,1670,67148,65,NULL,'H96','H-ZSNS J165300.27+350346.4',0.97,'1998ApJ...493L..53G',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139583,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1997ck',NULL,139583,44.15,0.45,1740,67148,65,NULL,'RPK','H-ZSNS J165300.27+350346.4',0.97,'1998ApJ...493L..53G',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139584,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1997ck','R',139584,43.04,NULL,2060,67148,65,NULL,'SALT','H-ZSNS J165300.27+350346.4',0.97,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139585,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1997ck',NULL,139585,43.08,0.74,2100,67148,70,NULL,'SALT','H-ZSNS J165300.27+350346.4',0.97,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139586,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1997ck',NULL,139586,43.13,0.74,2150,67148,65,NULL,'SALT','H-ZSNS J165300.27+350346.4',0.97,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139587,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1997ck',NULL,139587,44.13,0.38,3400,67148,65,NULL,NULL,'H-ZSNS J165300.27+350346.4',0.97,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139588,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1997ck',NULL,139588,44.3,0.19,3680,67148,65,NULL,'Template','H-ZSNS J165300.27+350346.4',0.97,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139589,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1997ck',NULL,139589,44.39,0.3,3830,67148,65,NULL,'MLCS','H-ZSNS J165300.27+350346.4',0.97,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139590,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139590,37.88,0.46,376,67149,70,NULL,NULL,'2MASX J16530181+4221456',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000078,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,253.25775,42.36253,0,NULL,59635065112,931797892,14559342,17.8),(139591,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139591,37.47,0.46,313,67150,70,NULL,NULL,'2MASX J16530287+3156274',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000177,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,253.262,31.94086,0.101,NULL,56219489808,878429528,13725461,17.1),(139592,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139592,35.9,0.27,151,67151,70,NULL,NULL,'2MASX J16530366+2512531',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000164,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,253.265375,25.21478,0.213,NULL,56201078603,878141853,13720966,16.2),(139593,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139593,37.25,0.46,282,67152,70,NULL,NULL,'2MASX J16530431+1959152',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000181,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,253.267833,19.98772,0.329,NULL,56865217119,888519017,13883109,17.3),(139594,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139594,38.3,0.46,457,67153,70,NULL,NULL,'2MASX J16530560+3018134',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,253.2732917,30.30386,0.101,NULL,56215017300,878359645,13724369,17.2),(139595,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139595,37.4,0.46,302,67154,70,NULL,NULL,'2MASX J16530665+4459487',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,253.2777917,44.99686,0,NULL,59614470388,931476099,14554314,17),(139596,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139596,37.92,0.23,383,67155,70,NULL,NULL,'2MASX J16530730+2743121',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,253.280375,27.71997,0.213,NULL,56223543202,878492862,13726450,18),(139597,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139597,37.82,0.46,367,67156,70,NULL,NULL,'2MASX J16530805+2747171',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000136,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,253.283541667,27.78806,0.209,NULL,56223587615,878493556,13726461,17.8),(139598,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139598,38.1,0.46,417,67157,70,NULL,NULL,'SDSS J165308.77+185408.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,253.286583,18.90239,0.349,NULL,56866202224,888534409,13883350,18.4),(139599,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139599,36.08,0.46,164,67158,70,NULL,NULL,'2MASX J16531222+4257087',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000076,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,253.300958333,42.95244,0,NULL,59634701363,931792208,14559253,17.2),(139600,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139600,37.19,0.19,274,67159,70,NULL,NULL,'2MASX J16531275+2327282',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000176,NULL,'17.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,253.3032917,23.45789,0.229,NULL,56688316608,885754947,13839921,17.4),(139601,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139601,38.1,0.33,416,67160,70,NULL,NULL,'2MASX J16531771+3200174',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000177,NULL,'17.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,253.323833333,32.005,0.045,NULL,56219635926,878431811,13725497,17.4),(139602,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139602,36.57,0.46,206,67161,70,NULL,NULL,'2MASX J16531979+1752494',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,253.3325417,17.88033,0.289,NULL,56894045630,888969462,13890147,17),(139603,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139603,37.04,0.23,256,67162,70,NULL,NULL,'2MASX J16532033+2940331',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000168,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,253.334917,29.67592,0.181,NULL,56222089548,878470149,13726096,16.5),(139604,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139604,37.86,0.46,373,67163,70,NULL,NULL,'2MASX J16532096+3024384',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,253.337375,30.41072,0.101,NULL,56214755605,878355556,13724305,17.2),(139605,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139605,36.54,0.46,203,67164,70,NULL,NULL,'2MASX J16532310+4326427',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000079,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,253.346,43.44522,0,NULL,59634829055,931794203,14559284,16.2),(139606,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139606,38.3,0.46,456,67165,70,NULL,NULL,'2MASX J16532412+2801181',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000204,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,253.3505,28.02172,0.225,NULL,56223362111,878490032,13726406,17.1),(139607,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139607,36.25,0.46,178,67166,70,NULL,NULL,'2MASX J16532414+2605411',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,253.350583,26.09483,0.257,NULL,56199918197,878123721,13720683,17.1),(139608,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139608,35.43,0.69,122,67167,70,NULL,NULL,'2MASX J16532514-1620582',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,253.3547917,-16.34947,1.309,NULL,46169963214,721405675,11271963,16.3),(139609,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139609,37.44,0.46,307,67168,70,NULL,NULL,'2MASX J16532553+3029174',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000177,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,253.356208333,30.48797,0.105,NULL,56214761540,878355649,13724307,17.4),(139610,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139610,37.58,0.46,328,67169,70,NULL,NULL,'2MASX J16532575+6320151',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000111,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,253.357583,63.33756,0.033,NULL,57542036128,899094314,14048348,18),(139611,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139611,38.43,0.46,485,67170,70,NULL,NULL,'2MASX J16532627+2329420',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000178,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,253.359667,23.49517,0.213,NULL,56688267890,885754185,13839909,17.7),(139612,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139612,37.25,0.46,282,67171,70,NULL,NULL,'2MASX J16532782+3255374',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000189,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,253.3660417,32.92697,0.097,NULL,56205072099,878204251,13721941,16.2),(139613,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139613,37.62,0.23,334,67172,70,NULL,NULL,'2MASX J16532807+3303024',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000142,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,253.367125,33.05083,0.097,NULL,56205054069,878203969,13721937,18.2),(139614,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139614,36.81,0.46,230,67173,70,NULL,NULL,'2MASX J16532867+3341504',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000177,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,253.3694583,33.69719,0.049,NULL,56205302167,878207846,13721997,17),(139615,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139615,33.87,NULL,59.5,67174,NULL,NULL,'Dipole + Quadrupole','UGC 10632',NULL,'2010Ap&SS.325..163P',2010,1,1.57,NULL,'G',0.000027,NULL,'15.47',0.22,'Sd',NULL,NULL,NULL,NULL,1,253.369583,79.06917,0.149,NULL,57141032092,892828626,13950447,15.47),(139616,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139616,33.88,NULL,59.6,67174,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10632',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139617,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139617,33.88,NULL,59.7,67174,NULL,NULL,'Dipole','UGC 10632',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139618,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139618,34.46,0.2,78,67174,74.4,NULL,NULL,'UGC 10632',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139619,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139619,34.56,0.53,81.6,67174,NULL,NULL,NULL,'UGC 10632',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139620,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139620,34.81,0.47,91.7,67174,NULL,NULL,'Malmquist cor.','UGC 10632',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139621,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139621,37.04,0.23,256,67175,70,NULL,NULL,'2MASX J16532884+2937310',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000207,NULL,'16.1g',0.4,'BrClG',NULL,NULL,NULL,NULL,1,253.370167,29.62525,0.181,NULL,56222103899,878470373,13726099,16.1),(139622,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139622,37.04,0.23,256,67176,70,NULL,NULL,'2MASX J16532957+2939212',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000194,NULL,'16.1g',0.41,'E0',NULL,NULL,NULL,NULL,1,253.3732917,29.65594,0.181,NULL,56222091777,878470184,13726096,16.1),(139623,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139623,37.04,0.23,256,67177,70,NULL,NULL,'2MASX J16533455+2945142',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000183,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,253.394125,29.75378,0.129,NULL,56214555616,878352431,13724256,16.6),(139624,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139624,37.19,0.19,274,67178,70,NULL,NULL,'2MASX J16533524+2325398',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000176,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,253.396958333,23.42767,0.229,NULL,56688309538,885754836,13839919,18),(139625,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139625,36.54,0.81,203,67179,70,NULL,NULL,'2MASX J16533523-7948181',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,253.39725,-79.80511,0.461,NULL,44272202038,691753156,10808643,16.9),(139626,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139626,37.62,0.23,334,67180,70,NULL,NULL,'2MASX J16533546+3303054',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,253.397875,33.05147,0.097,NULL,56205054266,878203972,13721937,17.5),(139627,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139627,37.63,0.46,336,67181,70,NULL,NULL,'2MASX J16533705+2654102',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,253.404333,26.90272,0.221,NULL,56192369341,878005770,13718840,17.6),(139628,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139628,38.23,0.19,443,67182,70,NULL,NULL,'2MASX J16533714+3132234',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,253.404875,31.53981,0.053,NULL,56220419119,878444048,13725688,18),(139629,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139629,37.76,0.46,356,67183,70,NULL,NULL,'2MASX J16533847+3110155',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,253.410125,31.17108,0.065,NULL,56220090268,878438910,13725607,18.1),(139630,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139630,36.81,0.46,230,67184,70,NULL,NULL,'2MASX J16534097+1943278',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000206,NULL,'15.9g',0.39,'E0',NULL,NULL,NULL,NULL,1,253.4207917,19.7245,0.333,NULL,56865089908,888517029,13883078,15.9),(139631,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139631,36.19,0.46,173,67185,70,NULL,NULL,'2MASX J16534249+2058158',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00017,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,253.427166667,20.97117,0.285,NULL,56683103047,885673485,13838648,17.3),(139632,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139632,37.29,0.46,287,67186,70,NULL,NULL,'2MASX J16534260+6225120',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000088,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,253.427416667,62.42003,0.041,NULL,57535893331,898998333,14046848,16.5),(139633,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139633,36.92,0.33,242,67187,70,NULL,NULL,'2MASX J16534554+3312226',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000185,NULL,'15.6g',0.41,'E0',NULL,NULL,NULL,NULL,1,253.4397917,33.20619,0.093,NULL,56205510570,878211102,13722048,15.6),(139634,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139634,35.9,0.27,151,67188,70,NULL,NULL,'2MASX J16534584+2428023',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,253.440917,24.46731,0.217,NULL,56200678438,878135600,13720868,16.8),(139635,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139635,36.75,0.33,224,67189,70,NULL,NULL,'2MASX J16534592+2350248',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,253.441375,23.84008,0.213,NULL,56688169278,885752644,13839885,16.9),(139636,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139636,37.96,0.46,391,67190,70,NULL,NULL,'2MASX J16534625+2726232',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000173,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,253.442917,27.43983,0.209,NULL,56222678514,878479351,13726239,16.9),(139637,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139637,36.75,0.33,224,67191,70,NULL,NULL,'2MASX J16535051+2344078',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00019,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,253.460666667,23.73542,0.213,NULL,56688163152,885752549,13839883,16.5),(139638,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139638,36.02,0.23,160,67192,70,NULL,NULL,'2MASX J16535111+2658222',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000205,NULL,'15.8g',0.38,NULL,NULL,NULL,NULL,NULL,1,253.462917,26.97286,0.221,NULL,56192383359,878005989,13718843,15.8),(139639,'GeV TeV ratio','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139639,35.38,NULL,119,67193,72,NULL,NULL,'MRK 0501',NULL,'2010MNRAS.405L..76P',2010,1,NULL,'Additional radio sources may contribute to the WMAP flux.','QSO',0.000073,NULL,'14.15',NULL,'E?             BLLAC',NULL,NULL,'radio jet','Flat-Spectrum Radio Source',1,253.467583,39.76017,0.057,NULL,59817293958,934645218,14603831,14.15),(139640,'GeV TeV ratio','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139640,37.53,0.46,320,67193,72,NULL,NULL,'MRK 0501',NULL,'2011arXiv1111.0913P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139641,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139641,35.17,0.46,108,67194,70,NULL,NULL,'2MASX J16535612+3515186',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000169,NULL,'15.5g',0.42,'E/S0',NULL,NULL,NULL,NULL,1,253.4837083,35.25531,0.069,NULL,59744486366,933507599,14586056,15.5),(139642,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139642,36.31,0.33,183,67195,70,NULL,NULL,'2MASX J16535637+3948459',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000067,NULL,'15.9g',0.26,'S0/a',NULL,NULL,NULL,NULL,1,253.484708333,39.81261,0.057,NULL,59817286157,934645096,14603829,15.9),(139643,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139643,36.19,0.5,173,67196,70,NULL,NULL,'2MASX J16535767-6706464',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000117,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,253.49025,-67.11289,0.437,NULL,45022398512,703474976,10991796,14),(139644,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139644,37.18,0.46,273,67197,70,NULL,NULL,'2MASX J16535813+2615262',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,253.4922917,26.25717,0.197,NULL,56200420276,878131566,13720805,17.6),(139645,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139645,37.71,0.46,348,67198,70,NULL,NULL,'2MASX J16540145+3850149',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000075,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,253.506,38.83744,0.065,NULL,59811941122,934561580,14602524,17.9),(139646,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139646,37.58,0.46,329,67199,70,NULL,NULL,'2MASX J16540196+3928348',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000088,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,253.50825,39.47642,0.061,NULL,59825477378,934773084,14605829,16.7),(139647,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139647,37.9,0.46,379,67200,70,NULL,NULL,'SDSS J165404.66+243607.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,253.5194583,24.60208,0.209,NULL,56200721666,878136276,13720879,18.5),(139648,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139648,38.23,0.19,443,67201,70,NULL,NULL,'2MASX J16540741+3123145',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00018,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,253.530833,31.38761,0.109,NULL,56220136227,878439628,13725619,17.2),(139649,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139649,37.45,0.46,309,67202,70,NULL,NULL,'SDSS J165408.10+341843.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000158,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,253.533791667,34.31208,0.057,NULL,59744240246,933503753,14585996,18.3),(139650,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139650,36.92,0.33,242,67203,70,NULL,NULL,'2MASX J16540905+3314035',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00019,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,253.5377917,33.23425,0.093,NULL,56207409306,878240770,13722512,16.3),(139651,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139651,35.32,0.2,116,67204,74.4,NULL,NULL,'UGC 10598',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.000027,NULL,'15.5g',0.41,'S?',NULL,NULL,NULL,NULL,1,253.542667,27.17308,0.193,NULL,56192393980,878006155,13718846,15.5),(139652,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139652,37.18,0.14,273,67205,70,NULL,NULL,'2MASXi J1654117+392017',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000072,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,253.548875,39.33822,0.061,NULL,59825498806,934773418,14605834,17.5),(139653,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139653,38.23,0.19,443,67206,70,NULL,NULL,'2MASX J16541329+3127298',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000149,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,253.555375,31.45839,0.053,NULL,56220014707,878437729,13725589,17.6),(139654,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139654,35.54,0.44,128,67207,NULL,NULL,'Malmquist cor.','UGC 10596',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.0',0.8,'SB?',NULL,NULL,NULL,NULL,1,253.567958333,10.44931,0.253,NULL,56731128135,886423877,13850373,16),(139655,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139655,35.64,0.43,134,67207,NULL,NULL,NULL,'UGC 10596',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139656,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139656,35.76,0.2,142,67207,74.4,NULL,NULL,'UGC 10596',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139657,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139657,34,0.62,63.1,67208,70,NULL,NULL,'2MASX J16541664-6047304',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,253.56925,-60.79189,1.109,NULL,44501000470,695328132,10864502,15.1),(139658,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139658,35.32,0.7,116,67209,70,NULL,NULL,'2MASX J16541750-0559292',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,253.572917,-5.9915,0.821,NULL,45190311725,706098620,11032790,15),(139659,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139659,37.53,0.46,320,67210,70,NULL,NULL,'2MASX J16541911+4239418',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000078,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,253.579417,42.66161,0.005,NULL,59635555871,931805560,14559461,17.5),(139660,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139660,35.84,0.2,147,67211,74.4,NULL,NULL,'UGC 10600',NULL,'2013AJ....146...86T',2013,1,1.07,NULL,'G',0.00007,NULL,'15.4g',0.26,'Scd(f)         AGN',NULL,NULL,NULL,NULL,1,253.5865,36.01364,0.061,NULL,59811504549,934554758,14602418,15.4),(139661,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139661,34.98,0.49,99.2,67212,75,NULL,'IR','UGC 10600',NULL,'2011yCatp016004901K',2011,1,1.07,NULL,'G',0.00007,NULL,'15.4g',0.26,'Scd(f)         AGN',NULL,NULL,NULL,NULL,1,253.5865,36.01364,0.061,NULL,59811504549,934554758,14602418,15.4),(139662,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139662,31.61,0.4,21,67213,75,NULL,'B','UGC 10608',NULL,'1988NBGC.C....0000T',1988,1,1.2,NULL,'G',0.00002,NULL,'15.2',0.9,'SBdm',NULL,NULL,NULL,NULL,1,253.589583,53.11306,0.073,NULL,57480915495,898139304,14033426,15.2),(139663,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139663,38.33,0.46,464,67214,70,NULL,NULL,'2MASX J16542430+2757550',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000188,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,253.601375,27.96536,0.225,NULL,56223369013,878490140,13726408,17.4),(139664,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139664,35.31,0.58,116,67215,70,NULL,NULL,'2MASX J16542435-0541441',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,253.601583,-5.69564,0.829,NULL,45223392612,706615509,11040867,15),(139665,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139665,37.8,0.46,362,67216,70,NULL,NULL,'2MASX J16542583+3719030',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00009,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,253.607833,37.31761,0.085,NULL,59814533275,934602082,14603157,17.3),(139666,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139666,36.05,0.46,163,67217,70,NULL,NULL,'2MASX J16542878+3922190',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000086,NULL,'15.9g',0.47,'E0',NULL,NULL,NULL,NULL,1,253.62,39.37197,0.061,NULL,59825518710,934773729,14605839,15.9),(139667,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139667,37.17,0.46,272,67218,70,NULL,NULL,'2MASX J16543043+2456450',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000177,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,253.626833,24.94578,0.209,NULL,56201425642,878147275,13721051,16.9),(139668,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139668,35.83,0.46,147,67219,70,NULL,NULL,'2MASX J16543073+1946158',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.00001,NULL,'15.6g',0.42,'E0',NULL,NULL,NULL,NULL,1,253.6280417,19.77097,0.297,NULL,56864998793,888515606,13883056,15.6),(139669,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139669,36.95,0.46,245,67220,70,NULL,NULL,'SDSS J165430.86+231539.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000144,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,253.628583,23.26111,0.257,NULL,56674879926,885544998,13836640,18.2),(139670,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139670,36.96,0.33,247,67221,70,NULL,NULL,'2MASX J16543187+3737531',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000092,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,253.6327917,37.63142,0.069,NULL,59814518939,934601858,14603154,16.5),(139671,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139671,38.23,0.19,443,67222,70,NULL,NULL,'SDSS J165432.30+313354.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000168,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,253.634625,31.56525,0.053,NULL,56220051326,878438301,13725598,18.1),(139672,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139672,37.18,0.14,273,67223,70,NULL,NULL,'2MASX J16543480+3906460',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000074,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,253.645083,39.11281,0.061,NULL,59811841886,934560029,14602500,16.8),(139673,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139673,37.1,0.46,263,67224,70,NULL,NULL,'2MASX J16543514+6339436',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000063,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,253.64675,63.66203,0.053,NULL,57540100325,899064067,14047876,17.5),(139674,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139674,35.83,0.46,146,67225,70,NULL,NULL,'CGCG 139-018',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.00019,NULL,'15.1g',0.57,'E0',NULL,NULL,NULL,NULL,1,253.65075,24.06364,0.209,NULL,56189001457,877953147,13718017,15.1),(139675,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139675,37.22,0.46,278,67226,70,NULL,NULL,'2MASX J16543945+3914380',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00009,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,253.664375,39.24403,0.061,NULL,59825494080,934773345,14605833,17.7),(139676,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139676,37.79,0.46,362,67227,70,NULL,NULL,'2MASX J16543946+3259568',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000164,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,253.6645,32.99911,0.069,NULL,56206979419,878234053,13722407,17.1),(139677,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139677,36.92,0.46,242,67228,70,NULL,NULL,'2MASX J16543955+3525039',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000172,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,253.6647917,35.41781,0.073,NULL,59744608534,933509508,14586086,17.5),(139678,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139678,37.22,0.46,278,67229,70,NULL,NULL,'2MASX J16544371+2955433',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,253.682083,29.92858,0.145,NULL,56214594630,878353041,13724266,17.6),(139679,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139679,35.9,0.27,151,67230,70,NULL,NULL,'2MASX J16544393+2449063',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000186,NULL,'15.7g',0.57,NULL,NULL,NULL,NULL,NULL,1,253.6830417,24.81856,0.209,NULL,56201409042,878147016,13721047,15.7),(139680,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139680,37.49,0.33,314,67231,70,NULL,NULL,'2MASX J16544663+1748599',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,253.694333,17.81683,0.289,NULL,56893745363,888964771,13890074,17),(139681,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139681,36.01,0.46,159,67232,70,NULL,NULL,'2MASX J16544710+4108521',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000093,NULL,'16.65',0.24,NULL,NULL,NULL,NULL,NULL,1,253.696417,41.14767,0.017,NULL,59636426671,931819166,14559674,16.65),(139682,'IRAS','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139682,31.33,0.8,18.5,67233,75,NULL,'A82, H','NGC 6255',NULL,'1997ApJS..109..333W',1997,1,3.6,NULL,'G',0.000007,NULL,'13.4',1.5,'SBcd:','Isolated galaxy',NULL,NULL,NULL,1,253.6997917,36.50111,0.053,NULL,59811568103,934555751,14602433,13.4),(139683,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139683,31.19,0.4,17.3,67233,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 6255',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139684,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139684,31.24,0.2,17.7,67233,74.4,NULL,NULL,'NGC 6255',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139685,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139685,31.32,0.4,18.3,67233,75,NULL,'B','NGC 6255',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139686,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139686,31.34,0.43,18.6,67233,75,NULL,'3.6 micron, color corrected','NGC 6255',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139687,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139687,31.49,0.43,19.9,67233,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6255',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139688,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139688,31.59,0.72,20.8,67233,NULL,NULL,NULL,'NGC 6255',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139689,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139689,31.6,0.38,20.9,67233,NULL,NULL,NULL,'NGC 6255',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139690,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139690,31.77,0.66,22.6,67233,NULL,NULL,'Malmquist cor.','NGC 6255',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139691,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139691,32.12,0.47,26.5,67233,75,NULL,'A82, H, inv','NGC 6255',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139692,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139692,32.19,0.47,27.4,67233,75,NULL,'A82, H, raw','NGC 6255',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139693,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139693,32.53,0.47,32,67233,75,NULL,'A82, H, cor','NGC 6255',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139694,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139694,37.7,0.46,347,67234,70,NULL,NULL,'2MASX J16544845+2618413',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000192,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,253.701833333,26.31147,0.197,NULL,56200314898,878129920,13720780,16.8),(139695,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139695,37.76,0.33,357,67235,70,NULL,NULL,'2MASX J16544927+3208275',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,253.7052083,32.141,0.085,NULL,56219616218,878431503,13725492,17.3),(139696,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139696,37.79,0.46,362,67236,70,NULL,NULL,'2MASX J16544969+2726283',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000182,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,253.706917,27.44122,0.257,NULL,56192280435,878004381,13718818,17.1),(139697,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139697,37.03,0.46,255,67237,70,NULL,NULL,'2MASX J16544993+1950388',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,253.7080417,19.84403,0.305,NULL,56864889054,888513891,13883029,17.2),(139698,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139698,36.15,0.33,170,67238,70,NULL,NULL,'2MASX J16545006+3443385',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000164,NULL,'16.0g',0.37,'E0',NULL,NULL,NULL,NULL,1,253.708666667,34.72722,0.069,NULL,59744276435,933504319,14586004,16),(139699,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139699,37.49,0.33,314,67239,70,NULL,NULL,'2MASX J16545489+1747499',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,253.7287083,17.79736,0.289,NULL,56893746372,888964787,13890074,17.3),(139700,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139700,36.15,0.33,170,67240,70,NULL,NULL,'2MASX J16545533+3443105',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000185,NULL,'15.7g',0.4,'E0',NULL,NULL,NULL,NULL,1,253.730583,34.71953,0.069,NULL,59744275084,933504298,14586004,15.7),(139701,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139701,36.36,0.46,187,67241,70,NULL,NULL,'2MASX J16545544+3845192',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000077,NULL,'17.1g',NULL,NULL,NULL,NULL,NULL,NULL,1,253.730833,38.75542,0.065,NULL,59812036033,934563063,14602547,17.1),(139702,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139702,37.5,0.59,316,67242,70,NULL,NULL,'2MASX J16545599-6236314',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,253.7335,-62.60872,0.705,NULL,44472523317,694883176,10857549,15.9),(139703,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139703,37.69,0.46,345,67243,70,NULL,NULL,'VII Zw 666',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000084,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,253.73925,63.46903,0.041,NULL,57542119539,899095617,14048369,17.6),(139704,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139704,33.89,0.48,60.1,67244,70,NULL,NULL,'NGC 6209',NULL,'2014MNRAS.445.2677S',2014,1,2,NULL,'G',0.000033,NULL,'11.41',1.6,'(R\')SAB(rs)b',NULL,NULL,NULL,NULL,1,253.74025,-72.58664,0.257,NULL,44149990970,689843608,10778806,11.41),(139705,'IRAS','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139705,34.49,0.8,79,67244,75,NULL,'MAT, I','NGC 6209',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139706,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139706,34.29,0.43,72.3,67244,75,NULL,'MAT, I, raw','NGC 6209',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139707,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139707,34.32,0.45,73.2,67244,NULL,NULL,'K','NGC 6209',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139708,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139708,34.33,0.47,73.5,67244,NULL,NULL,'H','NGC 6209',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139709,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139709,34.35,0.46,74.3,67244,NULL,NULL,'J','NGC 6209',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139710,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139710,34.39,0.34,75.3,67244,NULL,NULL,'Malmquist cor.','NGC 6209',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139711,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139711,34.44,0.43,77.1,67244,75,NULL,'MAT, I, cor','NGC 6209',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139712,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139712,34.46,0.33,78.1,67244,NULL,NULL,NULL,'NGC 6209',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139713,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139713,34.47,0.32,78.3,67244,85,NULL,'I, raw','NGC 6209',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139714,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139714,34.49,0.4,79.1,67244,NULL,NULL,'mean','NGC 6209',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139715,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139715,34.5,0.2,79.4,67244,74.4,NULL,NULL,'NGC 6209',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139716,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139716,34.56,0.32,81.8,67244,85,NULL,'I, inv','NGC 6209',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139717,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139717,34.67,0.43,85.7,67244,75,NULL,'MAT, I, inv','NGC 6209',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139718,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139718,35.7,NULL,138,67245,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10603',NULL,'2010Ap&SS.325..163P',2010,1,1.37,NULL,'G',0.000023,NULL,'15.8g',0.22,'Sc',NULL,NULL,NULL,NULL,1,253.742583,22.14844,0.241,NULL,56676287159,885566986,13836984,15.8),(139719,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139719,35.7,NULL,138,67245,NULL,NULL,'Dipole + Quadrupole','UGC 10603',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139720,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139720,35.71,NULL,138,67245,NULL,NULL,'Dipole','UGC 10603',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139721,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139721,35.79,NULL,144,67245,NULL,NULL,NULL,'UGC 10603',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139722,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139722,35.9,0.2,151,67245,74.4,NULL,NULL,'UGC 10603',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139723,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139723,37.71,0.46,349,67246,70,NULL,NULL,'2MASX J16545867+1939153',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000155,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,253.7445,19.65433,0.297,NULL,56865048746,888516386,13883068,17.5),(139724,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139724,36.02,0.23,160,67247,70,NULL,NULL,'2MASX J16550437+2710292',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000171,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,253.768,27.17469,0.193,NULL,56193089978,878017030,13719016,16.3),(139725,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139725,37.9,0.46,380,67248,70,NULL,NULL,'2MASX J16550493+3139325',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000176,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,253.7705,31.65908,0.049,NULL,56220002874,878437544,13725586,16.8),(139726,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139726,36.54,0.46,203,67249,70,NULL,NULL,'2MASX J16550662+2235074',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,253.777583,22.58558,0.229,NULL,56676595397,885571803,13837059,17.1),(139727,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139727,37.19,0.19,274,67250,70,NULL,NULL,'2MASX J16551094+2325475',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,253.795625,23.42992,0.197,NULL,56675458437,885554038,13836781,17),(139728,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139728,36.77,0.46,226,67251,70,NULL,NULL,'2MASX J16551107+2711243',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,253.7960417,27.19017,0.221,NULL,56193090299,878017035,13719016,17.8),(139729,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139729,38.28,0.46,453,67252,70,NULL,NULL,'2MASX J16551217+2749563',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,253.80075,27.83225,0.277,NULL,56222992166,878484252,13726316,17.8),(139730,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139730,35.97,0.46,156,67253,70,NULL,NULL,'2MASX J16551394+2512193',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000183,NULL,'15.8g',0.39,NULL,NULL,NULL,NULL,NULL,1,253.808083,25.2055,0.213,NULL,56201222972,878144108,13721001,15.8),(139731,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139731,36.63,0.46,212,67254,70,NULL,NULL,'2MASX J16551621+3030435',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000187,NULL,'16.2g',0.33,'E0',NULL,NULL,NULL,NULL,1,253.817417,30.51217,0.125,NULL,56214857995,878357156,13724330,16.2),(139732,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139732,37.13,0.46,267,67255,70,NULL,NULL,'2MASX J16551869+3300306',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,253.828083333,33.00864,0.069,NULL,56207074100,878235532,13722430,16.7),(139733,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139733,36.77,0.73,226,67256,70,NULL,NULL,'2MASX J16551929-6356425',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,253.830417,-63.94519,0.693,NULL,44465237122,694769330,10855770,16),(139734,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139734,37.76,0.33,357,67257,70,NULL,NULL,'2MASX J16552135+3216176',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,253.8387917,32.27175,0.085,NULL,56217590526,878399851,13724997,17.8),(139735,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139735,33.6,NULL,52.4,67258,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10616',NULL,'2010Ap&SS.325..163P',2010,1,1.08,'UGC dec. of +58d47\' in error.','G',0.00013,NULL,'17.',0.09,'Sd',NULL,NULL,NULL,NULL,1,253.8420417,58.66014,0,NULL,57702482738,901601292,14087520,17),(139736,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139736,33.62,NULL,52.9,67258,NULL,NULL,'Dipole + Quadrupole','UGC 10616',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139737,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139737,33.63,NULL,53.3,67258,NULL,NULL,'Dipole','UGC 10616',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139738,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139738,33.7,NULL,55,67258,NULL,NULL,NULL,'UGC 10616',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139739,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139739,34.2,0.57,69.1,67259,70,NULL,NULL,'2MASX J16552449-0715255',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00013,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,253.852125,-7.25711,0.869,NULL,46077855278,719966488,11249476,15.2),(139740,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139740,38.19,0.33,434,67260,70,NULL,NULL,'2MASX J16552478+2806123',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00017,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,253.853417,28.10333,0.297,NULL,56223044449,878485069,13726329,16.9),(139741,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139741,38.23,0.19,443,67261,70,NULL,NULL,'2MASX J16552554+3124347',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000199,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,253.8565,31.40969,0.053,NULL,56219943922,878436623,13725572,16.8),(139742,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139742,38.19,0.33,434,67262,70,NULL,NULL,'2MASX J16552659+2800083',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,253.8607083,28.00239,0.297,NULL,56223069088,878485454,13726335,17.5),(139743,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139743,37.84,0.33,370,67263,70,NULL,NULL,'2MASX J16553398+3206387',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000143,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,253.891458333,32.11086,0.085,NULL,56217677741,878401214,13725018,18.2),(139744,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139744,37.53,0.46,321,67264,70,NULL,NULL,'2MASX J16553601+4446530',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,253.900167,44.7815,0,NULL,59614057451,931469647,14554213,17.2),(139745,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139745,36.02,0.23,160,67265,70,NULL,NULL,'2MASX J16553854+2638307',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00018,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,253.9105,26.64197,0.221,NULL,56200096387,878126506,13720726,16.2),(139746,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139746,37.19,0.19,274,67266,70,NULL,NULL,'2MASX J16553911+2317356',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000181,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,253.913083,23.29322,0.257,NULL,56675420721,885553448,13836772,17.1),(139747,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139747,37.54,0.46,323,67267,70,NULL,NULL,'2MASX J16554012+3203508',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000136,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,253.9172917,32.06425,0.045,NULL,56217683446,878401303,13725020,17.9),(139748,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139748,37.49,0.46,315,67268,70,NULL,NULL,'2MASXi J1655416+380038',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000076,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,253.923708333,38.01067,0.089,NULL,59812558773,934571230,14602675,18),(139749,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139749,37.96,0.46,391,67269,70,NULL,NULL,'2MASX J16554262+3304268',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000182,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,253.9275417,33.07408,0.069,NULL,56207031656,878234869,13722419,17.4),(139750,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139750,37.59,0.46,330,67270,70,NULL,NULL,'SDSS J165543.54+320232.8',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.7g',0.3,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,253.9314583,32.04247,0.045,NULL,56217695599,878401493,13725023,16.7),(139751,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139751,37.89,0.46,378,67271,70,NULL,NULL,'2MASX J16554546+2608528',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000212,NULL,'16.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,253.9392917,26.14814,0.209,NULL,56200265831,878129153,13720768,16.4),(139752,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139752,37.74,0.46,353,67272,70,NULL,NULL,'2MASX J16554543+2334586',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00018,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,253.9395,23.58281,0.197,NULL,56675468862,885554200,13836784,17.4),(139753,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139753,37.84,0.46,369,67273,70,NULL,NULL,'SDSS J165545.60+323316.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000142,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,253.94,32.55458,0.081,NULL,56206356089,878224313,13722254,18),(139754,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139754,38.77,0.46,568,67274,70,NULL,NULL,'SDSS J165545.77+175803.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.0001,NULL,'18.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,253.94075,17.96778,0.369,NULL,56863263112,888488486,13882632,18.4),(139755,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139755,38.23,0.19,443,67275,70,NULL,NULL,'2MASX J16554585+3122048',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000176,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,253.9412083,31.36794,0.089,NULL,56217877894,878404342,13725067,17),(139756,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139756,36.96,0.33,247,67276,70,NULL,NULL,'2MASX J16554896+3759232',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'16.91',0.4,NULL,NULL,NULL,NULL,NULL,1,253.95425,37.98989,0.089,NULL,59812558435,934571225,14602675,16.91),(139757,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139757,37.84,0.33,370,67277,70,NULL,NULL,'2MASX J16555027+3210378',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000147,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,253.959333,32.17714,0.085,NULL,56217800993,878403140,13725049,17.3),(139758,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139758,35.91,0.46,152,67278,70,NULL,NULL,'2MASX J16555032+2726298',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000188,NULL,'15.6g',0.48,NULL,NULL,NULL,NULL,NULL,1,253.9595417,27.44158,0.257,NULL,56193034932,878016170,13719002,15.6),(139759,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139759,34.37,0.2,74.8,67279,74.4,NULL,NULL,'UGC 10619',NULL,'2013AJ....146...86T',2013,1,1.36,NULL,'G',NULL,NULL,'16.5',0.22,'Sd',NULL,NULL,NULL,NULL,1,253.972583333,54.39753,0.009,NULL,57678395800,901224934,14081639,16.5),(139760,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139760,34.38,0.51,75.3,67279,NULL,NULL,NULL,'UGC 10619',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139761,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139761,34.52,0.48,80.3,67279,NULL,NULL,'Malmquist cor.','UGC 10619',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139762,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139762,36.92,0.46,242,67280,70,NULL,NULL,'2MASX J16555462+2250496',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00019,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,253.977583,22.84708,0.281,NULL,56674763446,885543178,13836612,17),(139763,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139763,37.45,0.84,309,67281,70,NULL,NULL,'2MASX J16555479-6430124',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,'E',NULL,NULL,NULL,NULL,1,253.97825,-64.50344,0.685,NULL,44467978858,694812169,10856440,15.6),(139764,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139764,37.93,0.46,385,67282,70,NULL,NULL,'2MASX J16555567+3849052',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000074,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,253.982041667,38.81825,0.069,NULL,59811977867,934562154,14602533,17.7),(139765,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139765,36.94,0.46,245,67283,70,NULL,NULL,'2MASX J16555727+3840152',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000108,NULL,'16.2g',0.32,NULL,NULL,NULL,NULL,NULL,1,253.988667,38.67094,0.069,NULL,59812019292,934562801,14602543,16.2),(139766,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139766,35.59,0.52,131,67284,70,NULL,NULL,'2MASX J16560292-6308385',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.0122083,-63.14394,0.725,NULL,44473238401,694894350,10857724,15.3),(139767,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139767,36,0.69,159,67285,70,NULL,NULL,'2MASX J16560506-6254415',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.021,-62.9115,0.725,NULL,44472667279,694885426,10857584,15.5),(139768,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139768,37.19,0.19,274,67286,70,NULL,NULL,'2MASX J16560527+2311439',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000161,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,254.0217917,23.19569,0.257,NULL,56674829612,885544212,13836628,16.8),(139769,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139769,37.18,0.14,273,67287,70,NULL,NULL,'2MASX J16560862+3925583',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000091,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,254.0357083,39.43283,0.069,NULL,59628326317,931692598,14557696,16.6),(139770,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139770,37.7,0.33,347,67288,70,NULL,NULL,'2MASX J16560944+2548152',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000191,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,254.0394583,25.80422,0.221,NULL,56203641588,878181899,13721592,16.6),(139771,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139771,37.18,0.14,273,67289,70,NULL,NULL,'2MASX J16560978+3916593',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000091,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,254.040833,39.28308,0.069,NULL,59628330478,931692663,14557697,17.3),(139772,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139772,35.44,0.6,122,67290,70,NULL,NULL,'2MASX J16560989-0037126',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00009,NULL,'16.68',NULL,NULL,NULL,NULL,NULL,NULL,1,254.0410417,-0.62014,0.485,NULL,45202955133,706296173,11035877,16.68),(139773,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139773,38.27,0.46,451,67291,70,NULL,NULL,'SDSS J165609.93+182044.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000161,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,254.041417,18.34561,0.357,NULL,56863346584,888489790,13882652,18.4),(139774,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139774,35.98,0.2,157,67292,74.4,NULL,NULL,'UGC 10615',NULL,'2013AJ....146...86T',2013,1,1.12,NULL,'G',0.000033,NULL,'15.3g',0.38,'SBcd:',NULL,NULL,NULL,NULL,1,254.044125,34.8365,0.045,NULL,59744579479,933509054,14586078,15.3),(139775,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139775,37.58,0.46,328,67293,70,NULL,NULL,'2MASX J16561283+4317541',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,254.053417,43.29847,0,NULL,59635204716,931800073,14559376,17),(139776,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139776,37.03,0.46,255,67294,70,NULL,NULL,'2MASX J16561305+3335258',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000184,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,254.054375,33.59058,0.033,NULL,56207637151,878244330,13722567,16.6),(139777,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139777,37.83,0.27,369,67295,70,NULL,NULL,'2MASX J16561306+1829079',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,254.054583,18.48547,0.357,NULL,56863301361,888489083,13882641,17.1),(139778,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139778,37.19,0.19,274,67296,70,NULL,NULL,'2MASX J16561484+2305339',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,254.061833,23.09281,0.257,NULL,56674865115,885544767,13836636,17.1),(139779,'IRAS','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139779,35.35,0.8,118,67297,75,NULL,'CF, r','IC 1237',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000133,NULL,'14.30',1,'SB(s)c:',NULL,NULL,NULL,NULL,1,254.066875,55.02647,0,NULL,57668859941,901075936,14079311,14.3),(139780,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139780,35.55,0.4,129,67297,NULL,NULL,'mean','IC 1237',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139781,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139781,35.62,0.47,133,67297,NULL,NULL,'H','IC 1237',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139782,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139782,35.65,0.45,135,67297,NULL,NULL,'K','IC 1237',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139783,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139783,35.66,0.46,135,67297,NULL,NULL,'J','IC 1237',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139784,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139784,35.79,0.38,144,67297,75,NULL,'CF, r, raw','IC 1237',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139785,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139785,35.97,0.38,156,67297,75,NULL,'CF, r, cor','IC 1237',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139786,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139786,36.06,0.38,163,67297,75,NULL,'CF, r, inv','IC 1237',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139787,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139787,37.12,0.27,266,67298,70,NULL,NULL,'2MASX J16561947+1836329',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000181,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,254.081125,18.60928,0.341,NULL,56864147975,888502312,13882848,16.4),(139788,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139788,37.7,0.33,347,67299,70,NULL,NULL,'2MASX J16562025+2546422',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000132,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,254.08425,25.77847,0.221,NULL,56203642700,878181917,13721592,18.4),(139789,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139789,36.12,0.46,168,67300,70,NULL,NULL,'2MASX J16562035+3210278',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000184,NULL,'15.6g',0.47,'AGN+SF',NULL,NULL,NULL,NULL,1,254.0847083,32.17428,0.093,NULL,56217777915,878402779,13725043,15.6),(139790,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139790,37.18,0.14,273,67301,70,NULL,NULL,'MCG +07-35-008',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000116,NULL,'15.3g',0.55,'BrClG',NULL,NULL,NULL,NULL,1,254.087875,39.27517,0.069,NULL,59628328481,931692632,14557697,15.3),(139791,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139791,35.33,0.52,117,67302,70,NULL,NULL,'2MASX J16562225-6235575',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.092583333,-62.59931,0.705,NULL,44472502126,694882845,10857544,15.2),(139792,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139792,37.89,0.46,379,67303,70,NULL,NULL,'2MASX J16562251+1931489',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,254.093791667,19.53019,0.297,NULL,56872941012,888639703,13884995,17.6),(139793,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139793,36.38,0.46,189,67304,70,NULL,NULL,'2MASX J16562575+4058444',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000076,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,254.1075,40.97892,0.069,NULL,59636353115,931818017,14559656,16.6),(139794,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139794,37.18,0.14,273,67305,70,NULL,NULL,'2MASX J16562623+3916293',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000083,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,254.1092917,39.27481,0.069,NULL,59628382617,931693478,14557710,18.2),(139795,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139795,38.09,0.46,416,67306,70,NULL,NULL,'SDSS J165628.07+313240.3',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.29,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,254.1169583,31.54456,0.089,NULL,56218089044,878407641,13725119,16.9),(139796,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139796,37.83,0.27,369,67307,70,NULL,NULL,'2MASX J16562888+1830418',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000189,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,254.120333,18.51172,0.357,NULL,56863306055,888489157,13882643,17.1),(139797,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139797,37.69,0.46,345,67308,70,NULL,NULL,'2MASX J16562970+3303458',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000204,NULL,'16.0g',0.45,'E0',NULL,NULL,NULL,NULL,1,254.123791667,33.06267,0.069,NULL,56206936785,878233387,13722396,16),(139798,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139798,38.38,0.46,475,67309,70,NULL,NULL,'2MASX J16563044+4418573',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,254.126958333,44.31586,0,NULL,59643620089,931931563,14561430,17),(139799,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 2007hu',NULL,139799,35.97,0.26,151,67310,73.8,NULL,'SALT 2 (SNANA)','NGC 6261',0.0356,'2014ApJ...795...44R',2014,1,1.21,NULL,'G',0.000103,NULL,'14.5g',0.57,'S0/a',NULL,NULL,NULL,NULL,1,254.127167,27.9775,0.297,NULL,56222844293,878481942,13726280,14.5),(139800,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139800,36.63,0.46,212,67311,70,NULL,NULL,'2MASX J16563061+4153503',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000073,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,254.1277083,41.89742,0,NULL,59638467898,931851060,14560172,16.8),(139801,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139801,37.12,0.27,266,67312,70,NULL,NULL,'SDSS J165631.62+183538.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000172,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,254.1317917,18.59403,0.341,NULL,56863295131,888488986,13882640,17.7),(139802,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139802,36.88,0.46,237,67313,70,NULL,NULL,'2MASX J16563453+3413518',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000128,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,254.143833333,34.23114,0.049,NULL,56204146877,878189794,13721715,17.6),(139803,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139803,37.18,0.14,273,67314,70,NULL,NULL,'2MASX J16563495+3921097',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000091,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,254.1455417,39.35275,0.069,NULL,59628333765,931692715,14557698,17.3),(139804,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139804,37.18,0.14,273,67315,70,NULL,NULL,'2MASX J16563668+3919377',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000093,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,254.152917,39.32708,0.069,NULL,59628333250,931692707,14557698,16.3),(139805,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139805,35.77,NULL,143,67316,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2092',NULL,'2010Ap&SS.325..163P',2010,1,0.76,NULL,'G',NULL,NULL,'17.15',0.08,'Scd',NULL,NULL,NULL,NULL,1,254.159167,59.82472,0.029,NULL,57657280698,900895010,14076484,17.15),(139806,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139806,35.8,NULL,145,67316,NULL,NULL,'Dipole + Quadrupole','FGC 2092',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139807,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139807,35.81,NULL,145,67316,NULL,NULL,NULL,'FGC 2092',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139808,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139808,35.82,NULL,146,67316,NULL,NULL,'Dipole','FGC 2092',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139809,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139809,32.44,NULL,30.7,67317,72,NULL,NULL,'HIPASS J1656+08',NULL,'2014Ap.....57..457K',2014,1,1.1,NULL,'G',0.000007,NULL,'17.0',0.85,'Sm?',NULL,NULL,NULL,NULL,1,254.1605,7.99872,0.417,NULL,56733993651,886468650,13851072,17),(139810,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139810,37.45,0.46,309,67318,70,NULL,NULL,'2MASX J16563965+3248088',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000151,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,254.165375,32.80239,0.069,NULL,56206522141,878226908,13722295,17.1),(139811,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139811,37.83,0.27,369,67319,70,NULL,NULL,'2MASX J16564153+1830492',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,'PRED','17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,254.173166667,18.51367,0.357,NULL,56863303297,888489114,13882642,17.5),(139812,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139812,35.64,0.46,134,67320,70,NULL,NULL,'CGCG 139-023',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.00011,NULL,'15.1g',0.51,NULL,NULL,NULL,NULL,NULL,1,254.174375,26.83847,0.197,NULL,56192551865,878008622,13718884,15.1),(139813,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139813,36.72,0.6,221,67321,70,NULL,NULL,'2MASX J16564214-6057233',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.175625,-60.95653,1.029,NULL,44500784796,695324762,10864449,15.6),(139814,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139814,35.36,0.25,118,67322,74.4,NULL,NULL,'NGC 6263',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000087,NULL,'14.66',0.9,'E',NULL,NULL,NULL,NULL,1,254.18,27.82208,0.277,NULL,56192906168,878014158,13718971,14.66),(139815,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139815,35.55,0.16,129,67322,70,NULL,NULL,'NGC 6263',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139816,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139816,35.86,0.4,148,67322,NULL,NULL,'mean','NGC 6263',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139817,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139817,36.39,0.45,190,67322,NULL,NULL,'K','NGC 6263',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139818,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139818,37.18,0.14,273,67323,70,NULL,NULL,'2MASX J16564504+3920358',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000079,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,254.187667,39.34328,0.069,NULL,59628333375,931692708,14557698,17.1),(139819,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139819,35.39,0.72,120,67324,70,NULL,NULL,'2MASX J16564648-0157432',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.193625,-1.962,0.505,NULL,45222882252,706607535,11040742,15),(139820,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139820,37.95,0.46,389,67325,70,NULL,NULL,'2MASX J16564676+3502538',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000188,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,254.194917,35.04806,0.057,NULL,59743839340,933497489,14585898,16.8),(139821,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139821,37.74,0.33,353,67326,70,NULL,NULL,'2MASX J16564813+3242408',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000133,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,254.2004583,32.71147,0.081,NULL,56206554407,878227412,13722303,17.1),(139822,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139822,37.9,0.46,381,67327,70,NULL,NULL,'2MASX J16564822+3612178',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,254.2010417,36.20511,0.065,NULL,59811818802,934559668,14602494,17.5),(139823,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139823,37.65,0.33,338,67328,70,NULL,NULL,'2MASX J16565049+6227160',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000074,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,254.210417,62.45453,0.029,NULL,57534631588,898978618,14046540,17.2),(139824,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139824,36.29,0.33,181,67329,70,NULL,NULL,'2MASX J16565288+2726379',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000171,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,254.220333,27.444,0.225,NULL,56192947597,878014806,13718981,16.6),(139825,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139825,37.18,0.14,273,67330,70,NULL,NULL,'2MASXi J1656545+391720',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000075,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,254.227125,39.28908,0.069,NULL,59628378656,931693416,14557709,17.4),(139826,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139826,37.05,0.46,257,67331,70,NULL,NULL,'2MASX J16565530+3152558',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000134,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,254.23025,31.88208,0.085,NULL,56218114996,878408046,13725125,18),(139827,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139827,38.22,0.27,441,67332,70,NULL,NULL,'2MASX J16565634+3233008',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,254.234917,32.55025,0.081,NULL,56206407564,878225118,13722267,18.1),(139828,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139828,37.74,0.33,353,67333,70,NULL,NULL,'2MASX J16565820+3244428',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000161,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,254.2425,32.74531,0.081,NULL,56206554680,878227416,13722303,18),(139829,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139829,33.57,0.48,51.8,67334,70,NULL,NULL,'ESO 101- G 018',NULL,'2014MNRAS.445.2677S',2014,1,2,NULL,'G',0.00015,NULL,'13.27',1,'SB(rs)0/a',NULL,NULL,NULL,NULL,1,254.248625,-65.95292,0.497,NULL,44988151552,702939868,10983435,13.27),(139830,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139830,37.8,0.46,364,67335,70,NULL,NULL,'2MASX J16565988+6244001',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000081,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,254.249625,62.73331,0.037,NULL,57542290585,899098290,14048410,18.2),(139831,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139831,35.4,0.75,120,67336,70,NULL,NULL,'2MASX J16570093-0650580',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.6I',0.2,NULL,NULL,NULL,NULL,NULL,1,254.2539583,-6.84947,0.877,NULL,45193314949,706145546,11033524,14.6),(139832,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139832,38.27,0.21,450,67337,70,NULL,NULL,'SDSS J165701.20+625026.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000075,NULL,'18.7g',0.12,'NLAGN',NULL,NULL,NULL,'Sy 2',1,254.2550417,62.84056,0.037,NULL,57542268329,899097942,14048405,18.7),(139833,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139833,37.33,0.2,292,67338,74.4,NULL,NULL,'UGC 10620',NULL,'2013AJ....146...86T',2013,1,0.84,NULL,'G',0.000164,NULL,'16.2g',0.32,'S?',NULL,NULL,NULL,NULL,1,254.255541667,31.25333,0.101,NULL,56213416178,878334627,13723978,16.2),(139834,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139834,38,0.46,397,67339,70,NULL,NULL,'2MASX J16570271+2224077',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000133,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,254.261333333,22.40208,0.249,NULL,56676248552,885566383,13836974,18.2),(139835,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139835,34.59,NULL,82.9,67340,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2098',NULL,'2010Ap&SS.325..163P',2010,1,0.8,NULL,'G',NULL,NULL,'17.0',0.08,'Sd',NULL,NULL,NULL,NULL,1,254.27,77.14111,0.145,NULL,57066739221,891667800,13932309,17),(139836,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139836,34.62,NULL,84,67340,NULL,NULL,'Dipole + Quadrupole','FGC 2098',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139837,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139837,34.63,NULL,84.4,67340,NULL,NULL,'Dipole','FGC 2098',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139838,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139838,34.67,NULL,86,67340,NULL,NULL,NULL,'FGC 2098',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139839,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139839,36.27,0.5,180,67341,70,NULL,NULL,'2MASX J16570509-7137479',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.271375,-71.62992,0.533,NULL,44095633685,688994276,10765535,13.9),(139840,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139840,36.25,0.56,178,67342,70,NULL,NULL,'2MASX J16570559-5951145',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.2734583,-59.85411,0.873,NULL,44501073412,695329272,10864519,15.9),(139841,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139841,36.13,0.54,168,67343,70,NULL,NULL,'2MASX J16570573-7552586',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,254.273875,-75.88292,0.189,NULL,44142799480,689731241,10777050,16.3),(139842,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139842,37.3,0.46,288,67344,70,NULL,NULL,'2MASX J16570843+2401099',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000174,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,254.285083,24.01964,0.221,NULL,56189059997,877954062,13718032,17.6),(139843,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139843,37.18,0.14,273,67345,70,NULL,NULL,'2MASX J16570855+3910588',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000098,NULL,'16.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,254.285541667,39.18303,0.069,NULL,59628375774,931693371,14557708,16.7),(139844,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139844,36.51,0.86,200,67346,70,NULL,NULL,'2MASX J16570887-0142268',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.286916667,-1.70744,0.509,NULL,45222424629,706600384,11040631,15.7),(139845,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139845,36.63,0.6,212,67347,70,NULL,NULL,'2MASX J16571044-5928405',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.293333,-59.47794,0.801,NULL,44554471384,696163615,10877556,15.7),(139846,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139846,36.29,0.33,181,67348,70,NULL,NULL,'2MASX J16571205+2730409',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000164,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,254.300167,27.5115,0.225,NULL,56192951098,878014860,13718982,16.3),(139847,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139847,38.71,0.46,552,67349,70,NULL,NULL,'SDSS J165713.36+255656.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000161,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,254.305708333,25.94903,0.225,NULL,56203634901,878181795,13721590,18.4),(139848,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139848,34.95,0.52,97.7,67350,70,NULL,NULL,'2MASX J16571426-0613510',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.309458333,-6.23086,0.925,NULL,45192953414,706139897,11033435,14),(139849,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139849,36.02,0.23,160,67351,70,NULL,NULL,'2MASX J16571499+2650107',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000171,NULL,'16.0g',0.33,NULL,NULL,NULL,NULL,NULL,1,254.312375,26.83633,0.197,NULL,56192437986,878006843,13718856,16),(139850,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139850,36.84,0.46,233,67352,70,NULL,NULL,'2MASX J16571515+3648346',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000167,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,254.313041667,36.80975,0.061,NULL,59811298450,934551538,14602367,16.8),(139851,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139851,34.55,0.49,81.2,67353,75,NULL,'IR','UGC 10627',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.00004,NULL,'15.41',0.3,'Scd:           AGN?','Isolated galaxy',NULL,NULL,NULL,1,254.314333,46.87461,0.037,NULL,59615005559,931484461,14554444,15.41),(139852,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139852,35.11,0.4,105,67353,NULL,NULL,'mean','UGC 10627',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139853,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139853,35.13,0.47,106,67353,NULL,NULL,'H','UGC 10627',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139854,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139854,35.2,0.45,110,67353,NULL,NULL,'K','UGC 10627',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139855,'Maser','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139855,35.79,0.27,144,67354,NULL,NULL,NULL,'NGC 6264',NULL,'2013ApJ...767..155K',2013,1,0.81,'HOLM 763B is a star.','G',0.000093,NULL,'15.2g',0.58,'Sb             Sy2','Group member',NULL,NULL,'Sy 2',1,254.3172083,27.84961,0.261,NULL,56192884579,878013821,13718965,15.2),(139856,'Maser','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139856,35.89,0.43,151,67354,NULL,NULL,NULL,'NGC 6264',NULL,'2011PhDT.......205K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139857,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139857,37.12,0.27,266,67355,70,NULL,NULL,'2MASX J16571884+1839047',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00019,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,254.328625,18.65133,0.341,NULL,56871426309,888616036,13884625,18.1),(139858,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139858,38.22,0.27,441,67356,70,NULL,NULL,'2MASX J16571921+3227274',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,254.3302083,32.45761,0.093,NULL,56217723713,878401933,13725030,17.6),(139859,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139859,36.42,0.81,192,67357,70,NULL,NULL,'2MASX J16572087-6017565',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.337083,-60.29908,0.897,NULL,44501183561,695330993,10864546,15.9),(139860,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139860,38.99,0.46,629,67358,70,NULL,NULL,'2MASX J16572245+2609227',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000158,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,254.343625,26.15633,0.209,NULL,56202972903,878171451,13721428,18),(139861,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139861,31.99,NULL,25,67359,NULL,NULL,NULL,'UGC 10625',NULL,'2000BSAO...50....5K',2000,1,1.7,NULL,'G',0.000023,NULL,'16.5',0.22,'Sdm',NULL,NULL,NULL,NULL,1,254.347417,38.67119,0.069,NULL,59628448359,931694505,14557726,16.5),(139862,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139862,32.06,NULL,25.8,67359,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10625',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139863,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139863,32.08,NULL,26.1,67359,NULL,NULL,'Dipole + Quadrupole','UGC 10625',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139864,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139864,32.09,NULL,26.2,67359,NULL,NULL,'Dipole','UGC 10625',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139865,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139865,33.23,0.2,44.3,67359,74.4,NULL,NULL,'UGC 10625',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139866,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139866,35.97,0.57,156,67360,70,NULL,NULL,'2MASX J16572382-0147498',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.3492083,-1.79719,0.509,NULL,45222353013,706599265,11040613,14.9),(139867,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139867,36.06,0.33,163,67361,70,NULL,NULL,'2MASX J16572463+2743337',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.0001,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,254.352625,27.72597,0.233,NULL,56192815903,878012748,13718949,16.5),(139868,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139868,35.85,0.46,148,67362,70,NULL,NULL,'2MASX J16572567+2441007',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000103,NULL,'16.1g',0.39,NULL,NULL,NULL,NULL,NULL,1,254.356917,24.68347,0.201,NULL,56189854701,877966479,13718226,16.1),(139869,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139869,36.27,0.46,179,67363,70,NULL,NULL,'2MASX J16572738+4042347',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000067,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,254.364125,40.70956,0.073,NULL,59636698696,931823417,14559740,16.8),(139870,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139870,37.2,0.46,275,67364,70,NULL,NULL,'2MASX J16572875+6355040',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000114,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,254.3697917,63.91789,0.025,NULL,57540254145,899066471,14047913,16.8),(139871,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139871,35.35,0.25,117,67365,74.4,NULL,NULL,'NGC 6265',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.00007,NULL,'15.22',0.5,'S0','Group member',NULL,NULL,NULL,1,254.37125,27.84422,0.261,NULL,56192891687,878013932,13718967,15.22),(139872,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139872,35.55,0.16,129,67365,70,NULL,NULL,'NGC 6265',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139873,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139873,38.27,0.21,450,67366,70,NULL,NULL,'SDSS J165730.17+625225.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000077,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,254.37575,62.87372,0.037,NULL,57542274910,899098045,14048406,18),(139874,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139874,37.4,0.72,302,67367,70,NULL,NULL,'2MASX J16573228-6249464',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.38475,-62.82956,0.725,NULL,44472654029,694885219,10857581,16),(139875,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139875,37.8,0.46,363,67368,70,NULL,NULL,'2MASX J16573279+3214347',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000181,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,254.386583333,32.24303,0.093,NULL,56218249709,878410151,13725158,17.3),(139876,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139876,37.23,0.23,279,67369,70,NULL,NULL,'2MASX J16573310+3239297',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,254.3877917,32.65842,0.081,NULL,56206384665,878224760,13722261,17),(139877,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139877,37.97,0.46,393,67370,70,NULL,NULL,'SDSS J165734.38+274442.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000139,NULL,'19.0g',0.1,NULL,NULL,NULL,NULL,NULL,1,254.3932917,27.74517,0.233,NULL,56192818294,878012785,13718949,19),(139878,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139878,38.27,0.21,450,67371,70,NULL,NULL,'2MASX J16573491+6252210',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000084,NULL,'17.2g',0.26,'BrClG',NULL,NULL,NULL,NULL,1,254.395375,62.8725,0.037,NULL,57542275051,899098047,14048406,17.2),(139879,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139879,37.99,0.46,396,67372,70,NULL,NULL,'2MASX J16573491+3450147',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00017,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,254.3954583,34.83739,0.045,NULL,59743825371,933497271,14585894,17.5),(139880,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139880,38,0.46,398,67373,70,NULL,NULL,'2MASX J16573511+1734049',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,254.39625,17.56819,0.301,NULL,56900995057,889078047,13891844,17.7),(139881,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139881,36.89,0.46,239,67374,70,NULL,NULL,'2MASX J16573600+3222597',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000137,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,254.399916667,32.38325,0.093,NULL,56217709385,878401709,13725026,17.2),(139882,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139882,36.97,0.46,247,67375,70,NULL,NULL,'2MASX J16573638+3158257',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000158,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,254.4017083,31.97381,0.085,NULL,56218345387,878411646,13725181,17),(139883,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139883,37.74,0.46,354,67376,70,NULL,NULL,'SDSS J165738.00+260536.8',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,254.408333,26.09361,0.209,NULL,56203562332,878180661,13721572,17.5),(139884,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139884,38.02,0.46,402,67377,70,NULL,NULL,'2MASX J16573803+2540027',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00017,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,254.408583333,25.66756,0.253,NULL,56202802613,878168790,13721387,17.5),(139885,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139885,38.22,0.27,441,67378,70,NULL,NULL,'2MASX J16574040+3232048',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,254.4184583,32.53475,0.081,NULL,56206415473,878225241,13722269,17.2),(139886,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139886,37.79,0.17,361,67379,70,NULL,NULL,'2MASX J16574053+3124338',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,'FoF','16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,254.418875,31.40939,0.089,NULL,56213588208,878337315,13724020,16.6),(139887,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139887,35.26,0.33,113,67380,70,NULL,NULL,'CGCG 225-017',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000093,NULL,'14.8g',0.61,'E','in a triple',NULL,NULL,NULL,1,254.419667,40.72236,0.073,NULL,59636695575,931823368,14559740,14.8),(139888,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139888,37.26,0.46,283,67381,70,NULL,NULL,'2MASX J16574192+3138218',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000161,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,254.4245417,31.63933,0.089,NULL,56217960327,878405630,13725087,17.1),(139889,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139889,35.36,0.25,118,67382,74.4,NULL,NULL,'GIN 632',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.00007,NULL,'16.2g',0.35,'E',NULL,NULL,NULL,NULL,1,254.428583,27.65925,0.233,NULL,56192857603,878013400,13718959,16.2),(139890,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139890,35.55,0.16,129,67382,70,NULL,NULL,'GIN 632',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139891,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139891,36.06,0.33,163,67382,70,NULL,NULL,'GIN 632',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139892,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139892,37.79,0.17,361,67383,70,NULL,NULL,'2MASX J16574654+3124348',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000135,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,254.444,31.40969,0.089,NULL,56213595350,878337427,13724022,18),(139893,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139893,38.27,0.21,450,67384,70,NULL,NULL,'SDSS J165748.20+624733.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000081,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,254.450917,62.79275,0.037,NULL,57542311592,899098618,14048415,18.5),(139894,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139894,35.94,0.33,154,67385,70,NULL,NULL,'CGCG 225-018',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000069,NULL,'15.6g',0.44,'S0^-',NULL,NULL,NULL,NULL,1,254.45675,39.21689,0.069,NULL,59628537685,931695901,14557748,15.6),(139895,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139895,37.79,0.17,361,67386,70,NULL,NULL,'2MASX J16575178+3128058',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000191,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,254.465708333,31.46814,0.089,NULL,56213536080,878336501,13724007,17.5),(139896,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139896,35.36,0.25,118,67387,74.4,NULL,NULL,'MRK 1113',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000047,NULL,'14.04',0.7,'E/S0',NULL,NULL,NULL,NULL,1,254.470667,28.12811,0.261,NULL,56194767809,878043247,13719425,14.04),(139897,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139897,35.55,0.16,129,67387,70,NULL,NULL,'MRK 1113',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139898,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139898,35.37,0.25,119,67388,74.4,NULL,NULL,'GIN 631',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000093,NULL,'15.26',0.4,'S',NULL,NULL,NULL,NULL,1,254.480375,27.69908,0.233,NULL,56192852235,878013316,13718958,15.26),(139899,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139899,35.55,0.16,129,67388,70,NULL,NULL,'GIN 631',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139900,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139900,35.94,0.33,154,67389,70,NULL,NULL,'CGCG 225-019',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00012,NULL,'15.4g',0.43,'S0',NULL,NULL,NULL,NULL,1,254.487333,39.25533,0.069,NULL,59628536110,931695876,14557748,15.4),(139901,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139901,35.37,0.25,119,67390,74.4,NULL,NULL,'NGC 6269',NULL,'2013AJ....146...86T',2013,1,2,NULL,'G',0.000043,NULL,'13.32',1.6,'cD;E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,254.4920417,27.85433,0.261,NULL,56192811169,878012674,13718948,13.32),(139902,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139902,35.55,0.16,129,67390,70,NULL,NULL,'NGC 6269',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139903,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139903,35.09,0.45,104,67390,NULL,NULL,'K','NGC 6269',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139904,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139904,35.87,0.4,149,67390,NULL,NULL,'mean','NGC 6269',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139905,'IRAS','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139905,34.48,0.8,78.7,67391,75,NULL,'MAT, I','ESO 101- G 020',NULL,'1997ApJS..109..333W',1997,1,1.9,'6dF DR2 has z = 0.016743.','G',0.000033,NULL,'13.44',0.9,'SAB(rs)bc',NULL,NULL,NULL,NULL,1,254.4942083,-62.72597,0.705,NULL,44472657470,694885272,10857582,13.44),(139906,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139906,33.12,0.43,42.1,67391,75,NULL,'MAT, I, raw','ESO 101- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139907,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139907,33.12,0.32,42.1,67391,85,NULL,'I, raw','ESO 101- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139908,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139908,33.17,0.32,43.1,67391,85,NULL,'I, inv','ESO 101- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139909,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139909,33.35,0.43,46.8,67391,75,NULL,'MAT, I, inv','ESO 101- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139910,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139910,33.44,0.43,48.7,67391,75,NULL,'MAT, I, cor','ESO 101- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139911,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139911,36.91,0.46,241,67392,70,NULL,NULL,'2MASX J16580025+6137033',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000063,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,254.5009583,61.61756,0.029,NULL,57536854465,899013351,14047083,17.3),(139912,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139912,37.79,0.17,361,67393,70,NULL,NULL,'2MASX J16580030+3128158',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000181,NULL,'16.6g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,254.501125,31.47106,0.089,NULL,56213525947,878336342,13724005,16.6),(139913,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139913,37.65,0.33,338,67394,70,NULL,NULL,'2MASX J16580049+6222403',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000088,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,254.501833,62.37778,0.029,NULL,57534820834,898981575,14046587,17.6),(139914,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139914,37.79,0.17,361,67395,70,NULL,NULL,'2MASX J16580110+3136578',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000197,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,254.504667,31.61617,0.089,NULL,56217948566,878405446,13725085,16.1),(139915,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139915,36.21,0.46,175,67396,70,NULL,NULL,'2MASX J16580262+2209371',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000166,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,254.51075,22.16022,0.229,NULL,56676353161,885568018,13837000,16.4),(139916,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139916,37.76,0.46,357,67397,70,NULL,NULL,'SDSS J165804.15+342316.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,254.517333333,34.38783,0.049,NULL,56204717493,878198710,13721854,18.2),(139917,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139917,37.19,0.46,274,67398,70,NULL,NULL,'2MASX J16580504+3219047',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000147,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,254.520833,32.31789,0.093,NULL,56218235834,878409934,13725155,17.7),(139918,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139918,37.2,0.46,276,67399,70,NULL,NULL,'2MASX J16580635+6446244',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000098,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,254.5265417,64.77336,0.045,NULL,57538176166,899034002,14047406,16.5),(139919,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139919,34.28,NULL,71.8,67400,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10641',NULL,'2010Ap&SS.325..163P',2010,1,1.44,NULL,'G',0.000063,NULL,'16.5',0.1,'Sd',NULL,NULL,NULL,NULL,1,254.5269583,58.88564,0.017,NULL,57702922767,901608168,14087627,16.5),(139920,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139920,34.29,NULL,72.2,67400,NULL,NULL,'Dipole + Quadrupole','UGC 10641',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139921,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139921,34.3,NULL,72.6,67400,NULL,NULL,'Dipole','UGC 10641',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139922,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139922,34.35,NULL,74.2,67400,NULL,NULL,NULL,'UGC 10641',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139923,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139923,34.58,0.67,82.3,67400,NULL,NULL,NULL,'UGC 10641',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139924,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139924,34.62,0.2,84,67400,74.4,NULL,NULL,'UGC 10641',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139925,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139925,34.7,0.63,87.3,67400,NULL,NULL,'Malmquist cor.','UGC 10641',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139926,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139926,38.73,0.46,557,67401,70,NULL,NULL,'2MASX J16580677+4035244',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000094,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,254.528416667,40.59008,0.073,NULL,59636672269,931823004,14559734,17.6),(139927,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139927,37.79,0.17,361,67402,70,NULL,NULL,'2MASX J16580785+3135429',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,254.53275,31.59536,0.089,NULL,56213508347,878336067,13724001,17.2),(139928,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139928,36.39,0.46,190,67403,70,NULL,NULL,'2MASX J16580813+3758124',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000094,NULL,'16.1g',0.29,'S0',NULL,NULL,NULL,NULL,1,254.533916667,37.97008,0.077,NULL,59628807473,931700116,14557814,16.1),(139929,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139929,36.69,0.46,217,67404,70,NULL,NULL,'2MASX J16580847+2253432',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000169,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,254.535167,22.89539,0.273,NULL,56677579782,885587184,13837299,16.9),(139930,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139930,38.05,0.46,408,67405,70,NULL,NULL,'2MASX J16580852+3252419',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,254.535583,32.87819,0.077,NULL,56206577070,878227766,13722308,17.6),(139931,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139931,35.26,0.33,113,67406,70,NULL,NULL,'2MASX J16580851+4053445',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.00009,NULL,'15.7g',0.42,'S0/a',NULL,NULL,NULL,NULL,1,254.535625,40.89569,0.069,NULL,59636505562,931820399,14559693,15.7),(139932,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139932,33.39,0.4,47.7,67407,NULL,NULL,'mean','NGC 6267',NULL,'2007A&A...465...71T',2007,1,1.3,'HOLM 764B is a star.','G',0.000007,NULL,'13.92',1,'SB(r)bc','in a pair',NULL,NULL,NULL,1,254.536083,22.98511,0.273,NULL,56677456563,885585258,13837269,13.92),(139933,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139933,33.74,0.46,55.9,67407,NULL,NULL,'J','NGC 6267',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139934,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139934,33.75,0.47,56.1,67407,NULL,NULL,'H','NGC 6267',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139935,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139935,33.75,0.45,56.1,67407,NULL,NULL,'K','NGC 6267',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139936,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139936,36.64,0.58,213,67408,70,NULL,NULL,'2MASX J16581133-6111214',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.547375,-61.18931,1.029,NULL,44471735134,694870861,10857357,16),(139937,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139937,38.49,0.33,500,67409,70,NULL,NULL,'2MASX J16581462+3151329',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,254.5612083,31.85925,0.085,NULL,56218219347,878409677,13725151,18.1),(139938,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139938,37.5,0.46,316,67410,70,NULL,NULL,'2MASX J16581535+3324489',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,254.563833,33.41353,0.061,NULL,56207277990,878238718,13722479,17.3),(139939,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139939,36.14,0.46,169,67411,70,NULL,NULL,'2MASX J16581783+2512340',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000171,NULL,'16.0g',0.35,NULL,NULL,NULL,NULL,NULL,1,254.574417,25.20953,0.225,NULL,56200833386,878138021,13720906,16),(139940,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139940,36.24,0.93,177,67412,70,NULL,NULL,'2MASX J16582281-0032033',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.6I',0.4,NULL,NULL,NULL,NULL,NULL,1,254.5950417,-0.53431,0.501,NULL,45205532687,706336448,11036507,14.6),(139941,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139941,37.79,0.17,361,67413,70,NULL,NULL,'2MASX J16582436+3138480',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000159,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,254.601583,31.64664,0.089,NULL,56213510993,878336109,13724001,17.9),(139942,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139942,35.98,0.33,157,67414,70,NULL,NULL,'CGCG 197-021',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000186,NULL,'15.3g',0.46,'E0',NULL,NULL,NULL,NULL,1,254.609375,33.03758,0.069,NULL,56206622304,878228473,13722319,15.3),(139943,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139943,38.38,0.46,474,67415,70,NULL,NULL,'2MASX J16582757+3206190',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,254.615,32.10536,0.093,NULL,56218289077,878410766,13725168,17.9),(139944,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139944,37.35,0.46,296,67416,70,NULL,NULL,'2MASX J16582954+2713391',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,254.623167,27.22753,0.225,NULL,56194386268,878037285,13719332,18),(139945,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139945,37.42,0.46,305,67417,70,NULL,NULL,'2MASX J16582978+3539440',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000155,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,254.62425,35.66233,0.049,NULL,59811021571,934547212,14602300,17.2),(139946,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139946,36.01,0.46,160,67418,70,NULL,NULL,'CGCG 139-026',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.0001,NULL,'15.2g',0.54,'S0',NULL,NULL,NULL,NULL,1,254.6252083,25.39025,0.225,NULL,56200816328,878137755,13720902,15.2),(139947,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139947,34.7,0.47,86.9,67419,NULL,NULL,'H','ESO 453- G 013',NULL,'2007A&A...465...71T',2007,1,1.3,'abs(b) < 10 degrees.','G',0.000033,NULL,'9.86K',0.7,'(R\')SB(s)bc:',NULL,NULL,NULL,NULL,1,254.626166667,-28.48572,NULL,NULL,45818877037,715919953,11186249,9.86),(139948,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139948,34.71,0.46,87.3,67419,NULL,NULL,'J','ESO 453- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139949,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139949,34.76,0.4,89.6,67419,NULL,NULL,'mean','ESO 453- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139950,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139950,34.77,0.45,89.8,67419,NULL,NULL,'K','ESO 453- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139951,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139951,38.49,0.33,500,67420,70,NULL,NULL,'2MASX J16583095+3157100',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000199,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,254.628875,31.95272,0.093,NULL,56218185167,878409143,13725142,17),(139952,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139952,34.73,0.4,88.3,67421,NULL,NULL,'mean','UGC 10648',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000037,NULL,'15.10',0.7,'SB(s)b',NULL,NULL,NULL,NULL,1,254.637583333,59.75472,0.045,NULL,57658324826,900911325,14076739,15.1),(139953,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139953,34.99,0.47,99.5,67421,NULL,NULL,'H','UGC 10648',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139954,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139954,36.92,0.33,242,67422,70,NULL,NULL,'2MASX J16583382+2515201',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,254.6409583,25.25553,0.225,NULL,56200853849,878138341,13720911,17.6),(139955,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139955,37.81,0.46,365,67423,70,NULL,NULL,'SDSS J165834.16+213208.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000147,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,254.642333,21.53569,0.281,NULL,56859943553,888436618,13881822,18.7),(139956,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139956,34.25,NULL,70.8,67424,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 069- G 016',NULL,'2010Ap&SS.325..163P',2010,1,1.68,NULL,'G',0.000033,NULL,'16.5b',0.22,'Sc',NULL,NULL,NULL,NULL,1,254.6452917,-71.46,0.497,NULL,44095370230,688990159,10765471,16.5),(139957,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139957,34.26,NULL,71.1,67424,NULL,NULL,'Dipole + Quadrupole','ESO 069- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139958,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139958,34.27,NULL,71.4,67424,NULL,NULL,'Dipole','ESO 069- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139959,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139959,34.32,NULL,73,67424,NULL,NULL,NULL,'ESO 069- G 016',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139960,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139960,34.37,0.47,74.8,67424,NULL,NULL,'Malmquist cor.','ESO 069- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139961,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139961,34.54,0.43,81.1,67424,NULL,NULL,NULL,'ESO 069- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139962,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139962,34.58,0.2,82.4,67424,74.4,NULL,NULL,'ESO 069- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139963,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139963,35.98,0.33,157,67425,70,NULL,NULL,'2MASX J16583592+3305049',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000158,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,254.649583,33.08467,0.069,NULL,56206613044,878228328,13722317,16.8),(139964,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139964,37.96,0.46,390,67426,70,NULL,NULL,'2MASX J16583720+1930379',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,254.654875,19.51069,0.377,NULL,56874085362,888657583,13885274,17.9),(139965,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139965,36.73,0.46,222,67427,70,NULL,NULL,'UGC 10637',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000171,NULL,'16.2g',0.31,'S',NULL,NULL,NULL,NULL,1,254.66325,31.97406,0.093,NULL,56218185228,878409144,13725142,16.2),(139966,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139966,37.31,0.46,290,67428,70,NULL,NULL,'2MASX J16583958+4021014',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000078,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,254.665,40.35042,0.073,NULL,59636639972,931822499,14559726,17.2),(139967,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139967,35.04,0.56,102,67429,70,NULL,NULL,'2MASX J16584191-8159529',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,254.674833,-81.99808,0.337,NULL,44056841971,688388155,10756064,16.5),(139968,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139968,35.32,0.53,116,67430,70,NULL,NULL,'2MASX J16584401-0139597',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.3,NULL,NULL,NULL,NULL,NULL,1,254.683333,-1.66653,0.517,NULL,45221189945,706581092,11040329,13.9),(139969,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139969,35.35,0.25,117,67431,74.4,NULL,NULL,'NGC 6270',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00008,NULL,'14.32',0.4,'E/S0',NULL,NULL,NULL,NULL,1,254.6835417,27.85911,0.261,NULL,56194868157,878044814,13719450,14.32),(139970,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139970,35.55,0.16,129,67431,70,NULL,NULL,'NGC 6270',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139971,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139971,35.26,0.46,112,67432,70,NULL,NULL,'2MASX J16584448+3946585',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000081,NULL,'15.7g',0.48,'E',NULL,NULL,NULL,NULL,1,254.685375,39.78294,0.077,NULL,59640040812,931875637,14560556,15.7),(139972,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139972,36.71,0.45,220,67433,NULL,NULL,'Malmquist cor.','2MASX J16584688+7825211',NULL,'2009ApJS..182..474S',2009,1,0.83,NULL,'G',0.000023,NULL,'15.5V',NULL,'Sc             AGN',NULL,NULL,NULL,NULL,1,254.6952083,78.42267,0.161,NULL,57140105412,892814147,13950221,15.5),(139973,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139973,36.92,0.41,242,67433,NULL,NULL,NULL,'2MASX J16584688+7825211',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139974,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139974,36.96,0.2,247,67433,74.4,NULL,NULL,'2MASX J16584688+7825211',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139975,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139975,38.27,0.21,450,67434,70,NULL,NULL,'2MASX J16584721+6256245',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000077,NULL,'17.5g',0.23,'E              AGN',NULL,NULL,NULL,NULL,1,254.6965,62.94017,0.017,NULL,57542570454,899102663,14048479,17.5),(139976,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139976,37.23,0.23,279,67435,70,NULL,NULL,'2MASX J16584966+3231032',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,254.706958333,32.51758,0.081,NULL,56205917369,878217458,13722147,17.2),(139977,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139977,35,0.46,99.9,67436,70,NULL,NULL,'CGCG 225-021',NULL,'2015arXiv151105856S',2015,1,0.86,NULL,'G',0.000097,NULL,'14.5g',0.81,'E0',NULL,NULL,NULL,NULL,1,254.7112917,40.12119,0.065,NULL,59635731181,931808299,14559504,14.5),(139978,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139978,35.37,0.25,119,67437,74.4,NULL,NULL,'NGC 6271',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000067,NULL,'14.98',0.7,'E/S0',NULL,NULL,NULL,NULL,1,254.711541667,27.96464,0.261,NULL,56195007504,878046992,13719484,14.98),(139979,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139979,35.55,0.16,129,67437,70,NULL,NULL,'NGC 6271',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139980,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139980,36.92,0.33,242,67438,70,NULL,NULL,'2MASX J16585247+2516002',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,254.7185,25.26664,0.225,NULL,56200800551,878137508,13720898,17.4),(139981,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139981,38.39,0.46,477,67439,70,NULL,NULL,'2MASX J16585366+2509212',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,254.7235,25.15603,0.201,NULL,56189544935,877961639,13718150,17.7),(139982,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139982,36.9,0.46,240,67440,70,NULL,NULL,'2MASX J16585404+6306486',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00007,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,254.725167,63.11336,0.021,NULL,57542640315,899103754,14048496,17.7),(139983,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139983,35.21,0.53,110,67441,70,NULL,NULL,'2MASX J16585495-0150057',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000113,NULL,'16.16',0.4,NULL,NULL,NULL,NULL,NULL,1,254.728875,-1.83511,0.517,NULL,45221378409,706584037,11040375,16.16),(139984,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139984,38.3,0.46,457,67442,70,NULL,NULL,'SDSS J165859.84+325347.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000159,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,254.749375,32.89658,0.077,NULL,56206809247,878231394,13722365,18.5),(139985,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139985,37,0.46,251,67443,70,NULL,NULL,'2MASX J16590045+6353266',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000096,NULL,'16.5g',0.32,'Sab',NULL,NULL,NULL,NULL,1,254.751875,63.89089,0.025,NULL,57540366838,899068231,14047941,16.5),(139986,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139986,37.23,0.23,279,67444,70,NULL,NULL,'2MASXi J1659009+323009',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000178,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,254.754083,32.5025,0.081,NULL,56205907227,878217300,13722145,17.8),(139987,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139987,37.23,0.23,279,67445,70,NULL,NULL,'4C +32.52A',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.0002,NULL,'16.1g',0.33,'E',NULL,NULL,NULL,NULL,1,254.754167,32.49425,0.081,NULL,56205909233,878217331,13722145,16.1),(139988,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139988,38.23,0.46,442,67446,70,NULL,NULL,'2MASX J16590153+3347273',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000138,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,254.7565,33.79083,0.057,NULL,56207314147,878239283,13722488,17.8),(139989,'Tully est','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139989,30.84,0.8,14.7,67447,75,NULL,NULL,'ESO 138- G 010',NULL,'1988NBGC.C....0000T',1988,1,5.6,'Extended HIPASS source','G',0.000007,NULL,'11.59',4.1,'SA(s)cd',NULL,NULL,NULL,NULL,1,254.7622917,-60.21603,0.873,NULL,44497755992,695277437,10863709,11.59),(139990,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139990,37.36,0.46,297,67448,70,NULL,NULL,'SDSS J165903.23+433002.9',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,254.7634583,43.50081,0.077,NULL,59643515452,931929928,14561405,17.2),(139991,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139991,37.03,0.46,254,67449,70,NULL,NULL,'2MASX J16590525+3420112',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000174,NULL,'16.1g',0.42,'E0',NULL,NULL,NULL,NULL,1,254.771875,34.33647,0.057,NULL,56204574574,878196477,13721819,16.1),(139992,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139992,35.53,0.53,128,67450,70,NULL,NULL,'2MASX J16590588-0154501',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.774583,-1.91389,0.517,NULL,45221375990,706583999,11040374,15.2),(139993,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139993,34.73,0.56,88.2,67451,70,NULL,NULL,'2MASX J16590728-0544311',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000147,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.780333,-5.74197,0.825,NULL,45224661106,706635329,11041177,14.4),(139994,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139994,35.83,0.4,146,67452,NULL,NULL,'mean','UGC 10639',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000107,NULL,'15.15',0.5,'SBb; HII       Sy2',NULL,NULL,NULL,'H II',1,254.7857083,28.99194,0.237,NULL,56221469869,878460466,13725944,15.15),(139995,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139995,35.97,0.47,156,67452,NULL,NULL,'H','UGC 10639',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139996,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139996,36.74,0.67,223,67453,70,NULL,NULL,'2MASX J16590978-6204041',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.790875,-62.06786,0.697,NULL,44471285313,694863833,10857247,15.9),(139997,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139997,36.86,0.46,236,67454,70,NULL,NULL,'2MASX J16591479+2200451',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000172,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,254.811667,22.01256,0.241,NULL,56675958610,885561853,13836903,16.7),(139998,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139998,36.72,0.33,221,67455,70,NULL,NULL,'2MASX J16591551+2451332',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000157,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,254.8147083,24.85922,0.237,NULL,56189669765,877963590,13718181,16.7),(139999,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139999,36.56,0.46,205,67456,70,NULL,NULL,'2MASX J16591797+2323071',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,254.824958333,23.38519,0.229,NULL,56677313996,885583031,13837234,16.8),(140000,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140000,37.54,0.46,323,67457,70,NULL,NULL,'2MASX J16591798+2107031',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000206,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,254.825083,21.11761,0.261,NULL,56860009071,888437641,13881838,17),(140001,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140001,37.52,0.46,319,67458,70,NULL,NULL,'SDSS J165918.18+184816.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'17.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,254.8257917,18.8045,0.317,NULL,56871536917,888617764,13884652,17.9),(140002,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140002,38.04,0.17,406,67459,70,NULL,NULL,'2MASX J16592044+3246179',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000127,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,254.835125,32.77158,0.077,NULL,56206653889,878228967,13722327,18),(140003,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140003,38.38,0.46,473,67460,70,NULL,NULL,'2MASX J16592050+3219589',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000141,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,254.835375,32.33286,0.129,NULL,56217414110,878397095,13724954,18.4),(140004,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140004,35.34,0.65,117,67461,70,NULL,NULL,'2MASX J16592167-0533311',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.8402917,-5.55861,0.833,NULL,45224943252,706639738,11041245,15.7),(140005,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140005,36.72,0.33,221,67462,70,NULL,NULL,'2MASX J16592245+2456463',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00018,NULL,'16.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,254.8434583,24.94622,0.261,NULL,56189744714,877964761,13718199,16.6),(140006,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140006,38.04,0.17,406,67463,70,NULL,NULL,'2MASX J16592592+3233050',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000168,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,254.858083,32.55131,0.081,NULL,56205967081,878218235,13722159,18.2),(140007,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140007,38.01,0.46,399,67464,70,NULL,NULL,'2MASX J16592744+2503183',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000161,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,254.8642917,25.05503,0.261,NULL,56189564763,877961949,13718155,17.2),(140008,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140008,38.04,0.17,406,67465,70,NULL,NULL,'SDSS J165929.17+323827.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,254.8715417,32.64089,0.081,NULL,56205940725,878217823,13722153,18.2),(140009,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140009,36.81,0.46,230,67466,70,NULL,NULL,'2MASX J16593427+2340391',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,254.892875,23.67742,0.213,NULL,56677135913,885580248,13837191,18),(140010,'IRAS','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140010,35.33,0.8,117,67467,75,NULL,'CF, r','UGC 10655',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000147,NULL,'15.24',0.4,'Sbc',NULL,NULL,NULL,NULL,1,254.900375,56.06936,0.013,NULL,57699900091,901560938,14086889,15.24),(140011,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140011,34.91,0.38,95.8,67467,75,NULL,'CF, r, raw','UGC 10655',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140012,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140012,35.01,0.38,101,67467,75,NULL,'CF, r, inv','UGC 10655',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140013,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140013,35.19,0.38,109,67467,75,NULL,'CF, r, cor','UGC 10655',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140014,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140014,37.72,0.46,351,67468,70,NULL,NULL,'2MASX J16593633+3203260',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000197,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,254.901375,32.05728,0.113,NULL,56217460338,878397817,13724965,16.3),(140015,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140015,37.07,0.46,259,67469,70,NULL,NULL,'SDSS J165940.59+311642.0',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000145,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,254.919125,31.27836,0.097,NULL,56213961050,878343141,13724111,18.7),(140016,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140016,36.06,0.51,163,67470,70,NULL,NULL,'2MASX J16594376-0134025',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000087,NULL,'16.12',NULL,NULL,NULL,NULL,NULL,NULL,1,254.9322917,-1.56747,0.497,NULL,45203809977,706309530,11036086,16.12),(140017,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140017,38.04,0.17,406,67471,70,NULL,NULL,'4C +32.52C',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.00067,NULL,'16.5',0.43,'BrClG',NULL,NULL,NULL,NULL,1,254.933083333,32.61528,0.077,NULL,56205952732,878218011,13722156,16.5),(140018,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140018,36.21,0.46,175,67472,70,NULL,NULL,'2MASX J16594673+2307347',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,254.944667,23.12642,0.201,NULL,56677427138,885584799,13837262,17),(140019,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140019,35.37,0.25,119,67473,74.4,NULL,NULL,'GIN 622',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000073,NULL,'14.38',NULL,'S',NULL,NULL,NULL,NULL,1,254.9457083,27.76697,0.261,NULL,56195253248,878050832,13719544,14.38),(140020,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140020,36.08,0.41,164,67473,70,NULL,NULL,'GIN 622',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140021,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140021,36.91,0.46,242,67474,70,NULL,NULL,'2MASX J16595476+4155078',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,254.978375,41.91886,0.069,NULL,59638709509,931854836,14560231,17.1),(140022,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140022,37.18,0.46,272,67475,70,NULL,NULL,'2MASX J16595895+1932137',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000163,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,254.9955417,19.53719,0.349,NULL,56874507416,888664178,13885377,17.2),(140023,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140023,38.05,0.46,408,67476,70,NULL,NULL,'2MASX J16595966+3244100',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,254.998625,32.73594,0.069,NULL,56205969264,878218269,13722160,17.2),(140024,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140024,37.37,0.46,298,67477,70,NULL,NULL,'2MASX J17000039+3236550',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,255.0017917,32.61522,0.077,NULL,56205922309,878217536,13722149,17.5),(140025,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140025,36.08,0.41,164,67478,70,NULL,NULL,'GIN 625',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',NULL,NULL,'15.30',NULL,'S',NULL,NULL,NULL,NULL,1,255.013666667,28.42789,0.245,NULL,56191604193,877993815,13718653,15.3),(140026,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140026,37.15,0.46,270,67479,70,NULL,NULL,'2MASX J17000487+3954358',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000084,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,255.0202917,39.90994,0.061,NULL,59640770822,931887044,14560735,17.2),(140027,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140027,38.54,0.46,510,67480,70,NULL,NULL,'SDSS J170005.87+173824.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000191,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,255.0245,17.64014,0.313,NULL,56901888062,889092000,13892062,18.7),(140028,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140028,36.95,0.46,245,67481,70,NULL,NULL,'2MASX J17000740+3749088',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,255.0307083,37.81903,0.077,NULL,59628690368,931698287,14557785,16.5),(140029,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140029,36.79,0.46,228,67482,70,NULL,NULL,'2MASX J17001047+1819322',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000162,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,255.043625,18.32572,0.325,NULL,56869348391,888583568,13884118,16.6),(140030,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140030,38.04,0.17,406,67483,70,NULL,NULL,'4C +32.52E',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000169,NULL,'16.8g',0.29,'E              AGN',NULL,NULL,'NAT',NULL,1,255.04675,32.58744,0.077,NULL,56205996022,878218687,13722166,16.8),(140031,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140031,36.08,0.41,164,67484,70,NULL,NULL,'GIN 623',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.000157,NULL,'14.32',NULL,'E',NULL,NULL,NULL,NULL,1,255.047667,28.2795,0.253,NULL,56191464384,877991631,13718619,14.32),(140032,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140032,37.31,0.46,290,67485,70,NULL,NULL,'2MASX J17001330+3250230',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000184,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,255.055375,32.83969,0.069,NULL,56205855362,878216490,13722132,16.4),(140033,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140033,38.04,0.17,406,67486,70,NULL,NULL,'2MASX J17001392+3232010',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000168,NULL,'16.8g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,255.058083,32.53367,0.077,NULL,56205997502,878218710,13722167,16.8),(140034,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140034,38.04,0.17,406,67487,70,NULL,NULL,'2MASX J17001432+3239430',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000146,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,255.059667,32.662,0.069,NULL,56206027014,878219172,13722174,18.8),(140035,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140035,36.47,0.57,197,67488,70,NULL,NULL,'2MASX J17001694-6313006',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,255.070791667,-63.21692,0.689,NULL,44472379689,694880932,10857514,14.3),(140036,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140036,35.5,0.64,126,67489,70,NULL,NULL,'2MASX J17001772-6618306',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,255.0739583,-66.3085,0.457,NULL,44967244429,702613194,10978331,15.3),(140037,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140037,37.07,0.46,259,67490,70,NULL,NULL,'SDSS J170021.52+262257.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.3g',0.09,NULL,NULL,NULL,NULL,NULL,1,255.089708333,26.3825,0.185,NULL,56201923366,878155052,13721172,18.3),(140038,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140038,35.63,0.48,134,67491,70,NULL,NULL,'2MASX J17002302-0219322',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000103,NULL,'16.44',0.7,'poss. LINER',NULL,NULL,NULL,NULL,1,255.096,-2.32567,0.569,NULL,45221859883,706591560,11040493,16.44),(140039,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140039,37.2,0.33,276,67492,70,NULL,NULL,'2MASX J17002430+3320438',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,255.10125,33.34561,0.077,NULL,56206287294,878223238,13722238,17.1),(140040,'Tully est','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140040,30.33,0.8,11.6,67493,75,NULL,NULL,'UGC 10669',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000013,NULL,'17.',1.3,'Im?',NULL,NULL,NULL,NULL,1,255.105417,70.29,0.141,NULL,57789094767,902954605,14108665,17),(140041,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140041,30.13,NULL,10.6,67493,NULL,NULL,NULL,'UGC 10669',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140042,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140042,36.71,0.46,220,67494,70,NULL,NULL,'2MASX J17002726+2034321',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00019,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,255.113708333,20.57561,0.313,NULL,56873403762,888646933,13885108,16.3),(140043,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140043,36.65,0.27,213,67495,70,NULL,NULL,'2MASX J17003272+2523590',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000171,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,255.136208333,25.39969,0.221,NULL,56188265367,877941646,13717838,16.5),(140044,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140044,36.79,0.46,228,67496,70,NULL,NULL,'2MASX J17003301+3923524',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000102,NULL,'15.9g',0.38,'E0',NULL,NULL,NULL,NULL,1,255.1375,39.39797,0.065,NULL,59640830572,931887977,14560749,15.9),(140045,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140045,37.3,0.46,289,67497,70,NULL,NULL,'2MASX J17003362+3842394',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000091,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,255.1400417,38.71089,0.057,NULL,59629222284,931706598,14557915,16.7),(140046,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140046,36.65,0.27,213,67498,70,NULL,NULL,'2MASX J17003487+2522360',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,255.1452917,25.37658,0.221,NULL,56188232584,877941134,13717830,17.4),(140047,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140047,36.21,0.46,174,67499,70,NULL,NULL,'2MASX J17003550+3213548',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000188,NULL,'15.9g',0.33,'S0',NULL,NULL,NULL,NULL,1,255.1477917,32.23181,0.129,NULL,56217348711,878396073,13724938,15.9),(140048,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140048,38.63,0.46,531,67500,70,NULL,NULL,'2MASX J17003742+3407438',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000182,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,255.156,34.12889,0.057,NULL,56204217545,878190899,13721732,18),(140049,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140049,36.06,0.46,163,67501,70,NULL,NULL,'2MASX J17003815+2426200',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000176,NULL,'15.7g',0.43,NULL,NULL,NULL,NULL,NULL,1,255.159083,24.43886,0.205,NULL,56190466316,877976036,13718375,15.7),(140050,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140050,37.14,0.46,267,67502,70,NULL,NULL,'2MASX J17003912+2603150',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000184,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,255.163083,26.05417,0.165,NULL,56202268423,878160444,13721256,17.3),(140051,'GRB','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140051,41.59,NULL,2080,67503,70,NULL,'Pseudo z = 0.7','GRB 010613',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE/Ulysses',NULL,NULL,NULL,NULL,1,255.166667,14.26667,0.321,NULL,56854743205,888355362,13880552,NULL),(140052,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140052,36.65,0.27,213,67504,70,NULL,NULL,'2MASX J17004143+2533280',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000198,NULL,'15.9g',0.4,NULL,NULL,NULL,NULL,NULL,1,255.1727083,25.55775,0.193,NULL,56188245990,877941343,13717833,15.9),(140053,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140053,36.21,0.46,175,67505,70,NULL,NULL,'SDSS J170042.16+393139.5',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000081,NULL,'16.0g',0.37,'E0',NULL,NULL,NULL,NULL,1,255.175667,39.52767,0.065,NULL,59640815973,931887749,14560746,16),(140054,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140054,35.96,0.25,156,67506,74.4,NULL,NULL,'UGC 10658 NOTES01',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.00008,NULL,'14.44',0.7,'E:',NULL,NULL,NULL,NULL,1,255.181833,28.02583,0.253,NULL,56195028522,878047320,13719489,14.44),(140055,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140055,36.08,0.41,164,67506,70,NULL,NULL,'UGC 10658 NOTES01',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140056,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140056,38.16,0.46,428,67507,70,NULL,NULL,'2MASX J17004573+3205399',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,255.190708333,32.09439,0.113,NULL,56213129164,878330143,13723908,17.6),(140057,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140057,35.95,0.25,155,67508,74.4,NULL,NULL,'MCG +05-40-023',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.00008,NULL,'14.81',0.4,'S',NULL,NULL,NULL,NULL,1,255.1955417,27.84917,0.253,NULL,56195064087,878047876,13719498,14.81),(140058,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140058,36.08,0.41,164,67508,70,NULL,NULL,'MCG +05-40-023',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140059,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140059,38.17,0.13,430,67509,70,NULL,NULL,'2MASX J17004788+3359388',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,255.1995417,33.99397,0.061,NULL,56204202943,878190670,13721729,17.3),(140060,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140060,37.36,0.46,296,67510,70,NULL,NULL,'SDSS J170048.05+311712.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,255.2002083,31.28678,0.097,NULL,56213812614,878340822,13724075,18),(140061,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140061,36.79,0.66,228,67511,70,NULL,NULL,'2MASX J17004953-6018205',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,255.20625,-60.30561,0.825,NULL,44498203443,695284428,10863819,15.9),(140062,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140062,37.13,0.46,266,67512,70,NULL,NULL,'2MASX J17004970+2029004',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,255.207041667,20.48344,0.313,NULL,56873946222,888655409,13885240,17.4),(140063,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140063,32.7,0.45,34.7,67513,NULL,NULL,'K','NGC 6278',NULL,'2007A&A...465...71T',2007,1,1.93,'HOLM 765C is a double star.','G',0.000017,NULL,'13.1g',0.88,'S0','in a pair',NULL,NULL,NULL,1,255.209708333,23.01103,0.201,NULL,56676917852,885576841,13837138,13.1),(140064,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140064,33.2,0.4,43.6,67513,NULL,NULL,'mean','NGC 6278',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140065,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140065,38.09,0.46,415,67514,70,NULL,NULL,'SDSS J170050.69+343409.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000148,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,255.211208333,34.56942,0.057,NULL,56338810625,880293916,13754592,18.7),(140066,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140066,37.29,0.46,287,67515,70,NULL,NULL,'2MASX J17005280+3853420',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000073,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,255.220125,38.89514,0.057,NULL,59628918392,931701849,14557841,17.5),(140067,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140067,35.36,0.25,118,67516,74.4,NULL,NULL,'MCG +05-40-024',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000047,NULL,'14.28',0.4,'SB0',NULL,NULL,NULL,NULL,1,255.223166667,27.72458,0.237,NULL,56195245717,878050714,13719542,14.28),(140068,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140068,36.08,0.41,164,67516,70,NULL,NULL,'MCG +05-40-024',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140069,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140069,37.23,0.46,280,67517,70,NULL,NULL,'2MASX J17005378+3306157',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000154,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,255.224,33.10428,0.057,NULL,56206703065,878229735,13722339,17.4),(140070,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140070,38.17,0.13,430,67518,70,NULL,NULL,'2MASX J17005627+3358187',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000149,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,255.234667,33.97194,0.061,NULL,56338163244,880283800,13754434,18.2),(140071,'HII LF','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'N',140071,46.64,1.58,4400,67519,71,NULL,NULL,'HS 1700+6416:BX717',2.4353,'2005MNRAS.356.1117S',2005,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140072,'HII LF','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140072,46.72,1.8,4730,67520,71,NULL,NULL,'HS 1700+6416:[SSE2005] MD0103',2.315,'2005MNRAS.356.1117S',2005,1,NULL,NULL,'G',NULL,NULL,'24.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,255.250875,64.19878,0.025,NULL,57540066756,899063543,14047867,24.2),(140073,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140073,36.3,0.46,182,67521,70,NULL,NULL,'2MASX J17010097+2450478',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000157,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,255.254,24.84658,0.261,NULL,56191000096,877984376,13718505,17.2),(140074,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140074,37.65,0.46,339,67522,70,NULL,NULL,'2MASX J17010184+2118054',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000165,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,255.257667,21.30167,0.293,NULL,56859410602,888428290,13881692,18.3),(140075,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140075,35.36,0.48,118,67523,70,NULL,NULL,'2MASX J17010646-6656591',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,255.277041667,-66.94975,0.437,NULL,44967655728,702619620,10978431,14.8),(140076,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140076,37.53,0.46,321,67524,70,NULL,NULL,'2MASX J17010687+1901594',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,255.2787917,19.03317,0.337,NULL,56871059026,888610297,13884535,17.9),(140077,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140077,37.71,0.46,348,67525,70,NULL,NULL,'2MASX J17010776+1843014',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,255.282333333,18.71703,0.333,NULL,56869123432,888580053,13884063,18.5),(140078,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140078,36.15,0.66,170,67526,70,NULL,NULL,'2MASX J17010790-0247456',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,255.283,-2.79594,0.541,NULL,45221078877,706579357,11040302,15.3),(140079,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140079,38.01,0.46,399,67527,70,NULL,NULL,'2MASX J17010960+2638329',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,255.290125,26.64258,0.181,NULL,56202026044,878156656,13721197,18.1),(140080,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140080,37.74,0.46,352,67528,70,NULL,NULL,'2MASX J17011019+3909591',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000085,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,255.292333,39.16653,0.037,NULL,59640261432,931879084,14560610,17.1),(140081,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140081,36.27,0.46,179,67529,70,NULL,NULL,'IC 4638',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000191,NULL,'15.5g',0.43,'E0',NULL,NULL,NULL,NULL,1,255.307083,33.51319,0.077,NULL,56339481204,880304393,13754756,15.5),(140082,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140082,36.69,0.75,218,67530,70,NULL,NULL,'2MASX J17011593-6212065',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.54',0.32,NULL,NULL,NULL,NULL,NULL,1,255.3165,-62.20208,0.617,NULL,44470901222,694857831,10857153,16.54),(140083,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140083,38.11,0.46,420,67531,70,NULL,NULL,'SDSS J170116.47+231252.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00013,NULL,'18.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,255.318666667,23.2145,0.229,NULL,56674223489,885534742,13836480,18.8),(140084,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140084,37.07,0.46,259,67532,70,NULL,NULL,'ZwCl 1700.5+3322 04',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000191,NULL,'16.3g',0.37,'Fuzzy red spherical',NULL,NULL,NULL,NULL,1,255.3387917,32.78561,0.069,NULL,56205871305,878216739,13722136,16.3),(140085,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140085,38.37,0.46,471,67533,70,NULL,NULL,'SDSS J170122.35+245150.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000178,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,255.343167,24.86414,0.261,NULL,56191003363,877984427,13718506,18.6),(140086,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140086,36.76,0.46,225,67534,70,NULL,NULL,'2MASX J17012249+2018249',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'16.94',0.33,NULL,NULL,NULL,NULL,NULL,1,255.343708333,20.30681,0.317,NULL,56873914870,888654919,13885233,16.94),(140087,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140087,37.66,0.46,341,67535,70,NULL,NULL,'SDSS J170123.36+350706.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.0002,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,255.347333,35.11844,0.069,NULL,56338110786,880282981,13754421,18.3),(140088,'Black Hole','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140088,40.66,0.28,1360,67536,NULL,NULL,NULL,'[HB89] 1700+518',NULL,'2014ApJ...793..108W',2014,1,NULL,NULL,'QSO',NULL,NULL,'15.1V',NULL,'BAL;Sy1        Sbrst',NULL,NULL,NULL,'Sy 1.0',1,255.353333,51.82222,0.017,NULL,57493997526,898343711,14036620,15.1),(140089,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140089,38.17,0.13,430,67537,70,NULL,NULL,'2MASX J17012658+3400478',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,255.36075,34.01322,0.061,NULL,56338212937,880284577,13754446,NULL),(140090,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140090,37.74,0.46,354,67538,70,NULL,NULL,'SDSS J170127.29+631751.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00006,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,255.36375,63.29756,0.021,NULL,57541769393,899090146,14048283,18.2),(140091,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140091,36.47,0.46,197,67539,70,NULL,NULL,'2MASX J17012841+3136192',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000176,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,255.3682917,31.60547,0.129,NULL,56214024779,878344137,13724127,16.4),(140092,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140092,35.78,0.46,143,67540,70,NULL,NULL,'ZwCl 1700.5+3322 07',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000142,NULL,'16.0g',0.38,'Spherical compact',NULL,NULL,NULL,NULL,1,255.3857083,33.05222,0.057,NULL,56339072211,880298003,13754656,16),(140093,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140093,37.2,0.33,276,67541,70,NULL,NULL,'WISEPC J170132.94+331901.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000053,NULL,'18.3g',0.1,'AGN',NULL,NULL,NULL,NULL,1,255.387167,33.31697,0.077,NULL,56339583318,880305989,13754781,18.3),(140094,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140094,38.46,0.27,493,67542,70,NULL,NULL,'SDSS J170135.77+351122.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00014,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,255.399041667,35.18972,0.069,NULL,56337926565,880280102,13754376,18.4),(140095,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140095,38.15,0.46,426,67543,70,NULL,NULL,'2MASX J17013814+2138335',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,255.408875,21.64267,0.281,NULL,56859361502,888427523,13881680,17.4),(140096,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140096,38.46,0.27,493,67544,70,NULL,NULL,'2MASX J17013909+3508503',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000137,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,255.412917,35.14753,0.069,NULL,56338119319,880283114,13754423,18.3),(140097,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140097,35.05,0.48,102,67545,70,NULL,NULL,'2MFGC 13615',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00011,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,255.4155,-62.75297,0.705,NULL,44470249506,694847648,10856994,14.6),(140098,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140098,35.82,0.25,146,67546,74.4,NULL,NULL,'GIN 615',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000107,NULL,'14.80',NULL,'E/S0',NULL,NULL,NULL,NULL,1,255.4252083,81.91292,0.337,NULL,56957745335,889964770,13905699,14.8),(140099,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140099,36.01,0.28,159,67546,70,NULL,NULL,'GIN 615',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140100,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140100,35.07,0.49,103,67547,75,NULL,'IR','UGC 10664',NULL,'2011yCatp016004901K',2011,1,1.44,'Star superposed.','G',0.000177,':','15.37',0.18,'Sc',NULL,NULL,NULL,NULL,1,255.4255417,41.22936,0.033,NULL,59637782995,931840359,14560005,15.37),(140101,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140101,35.1,NULL,105,67547,NULL,NULL,NULL,'UGC 10664',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140102,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140102,35.25,NULL,112,67547,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10664',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140103,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140103,35.27,NULL,113,67547,NULL,NULL,'Dipole + Quadrupole','UGC 10664',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140104,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140104,35.3,NULL,115,67547,NULL,NULL,'Dipole','UGC 10664',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140105,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140105,37.79,0.33,362,67548,70,NULL,NULL,'ZwCl 1700.5+3322 11',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00018,NULL,'16.5g',0.35,'Red sph. compact',NULL,NULL,NULL,NULL,1,255.436625,32.97217,0.065,NULL,56339128921,880298889,13754670,16.5),(140106,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140106,38.17,0.13,430,67549,70,NULL,NULL,'2MASX J17014602+3400164',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000173,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,255.4417083,34.00456,0.061,NULL,56338157617,880283712,13754433,17.8),(140107,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:59','1','SN 2007ae',NULL,140107,36.44,0.16,182,67550,74.2,NULL,'SALT 2','UGC 10704',0.064387,'2010ApJ...716..712A',2010,1,1,NULL,'G',0.000199,NULL,'15.6',0.7,'S              LINER',NULL,NULL,NULL,NULL,1,255.455125,79.03769,0.177,NULL,57129115033,892642422,13947537,15.6),(140108,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:59','1','SN 2007ae',NULL,140108,36.77,0.05,212,67550,70,NULL,'SALT 2','UGC 10704',0.064387,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140109,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:59','1','SN 2007ae',NULL,140109,37.05,0.03,241,67550,72,NULL,'SALT','UGC 10704',0.064387,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140110,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:59','1','SN 2007ae',NULL,140110,36.97,0.09,248,67550,74.4,NULL,NULL,'UGC 10704',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140111,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:59','1','SN 2007ae',NULL,140111,37.16,0.16,254,67550,70,NULL,'SALT 2','UGC 10704',0.064387,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140112,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:59','1','SN 2007ae','R',140112,37.03,0.08,255,67550,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 10704',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140113,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:59','1','SN 2007ae','R',140113,37.08,0.08,261,67550,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 10704',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140114,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:59','1','SN 2007ae',NULL,140114,37.23,0.16,263,67550,65,NULL,'SALT','UGC 10704',0.064387,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140115,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:59','1','SN 2007ae',NULL,140115,37.24,0.18,263,67550,65,NULL,'SALT2','UGC 10704',0.064387,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140116,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:59','1','SN 2007ae',NULL,140116,37.27,0.15,267,67550,65,NULL,'MLCS17','UGC 10704',0.064387,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140117,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:59','1','SN 2007ae',NULL,140117,37.34,0.14,275,67550,65,NULL,'MLCS31','UGC 10704',0.064387,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140118,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140118,34.62,0.49,83.8,67551,70,NULL,NULL,'CGCG 025-018',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000083,NULL,'15.6',0.26,'Sb','Isolated galaxy',NULL,NULL,NULL,1,255.463458333,-1.89908,0.561,NULL,45204073572,706313649,11036150,15.6),(140119,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140119,38.02,0.46,402,67552,70,NULL,NULL,'2MASX J17015268+6113100',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000075,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,255.469625,61.21944,0.025,NULL,57533988059,898968563,14046383,17.4),(140120,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140120,37.79,0.33,362,67553,70,NULL,NULL,'ZwCl 1700.5+3322 17',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000163,NULL,'17.0g',0.21,'Red fuzzy ell.comp.',NULL,NULL,NULL,NULL,1,255.47575,33.05881,0.057,NULL,56339083588,880298181,13754659,17),(140121,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140121,35.37,0.25,119,67554,74.4,NULL,NULL,'CGCG 169-033',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000047,NULL,'13.83',0.2,'E/S0',NULL,NULL,NULL,NULL,1,255.479,28.41772,0.281,NULL,56191936122,877999001,13718734,13.83),(140122,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140122,36.08,0.41,164,67554,70,NULL,NULL,'CGCG 169-033',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140123,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140123,37.77,0.46,358,67555,70,NULL,NULL,'SDSS J170155.31+592334.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000055,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,255.4805,59.39292,0.029,NULL,57704930918,901639545,14088117,18.6),(140124,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140124,35.37,0.25,119,67556,74.4,NULL,NULL,'CGCG 169-032',NULL,'2013AJ....146...86T',2013,1,0.2,NULL,'G',0.000077,NULL,'14.39',0.2,'E/S0',NULL,NULL,NULL,NULL,1,255.483666667,28.38803,0.281,NULL,56191934941,877998983,13718734,14.39),(140125,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140125,36.08,0.41,164,67556,70,NULL,NULL,'CGCG 169-032',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140126,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140126,37.42,0.46,305,67557,70,NULL,NULL,'2MASX J17015692+6138210',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000064,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,255.4869583,61.63933,0.013,NULL,57537230561,899019227,14047175,17.3),(140127,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140127,38.46,0.27,493,67558,70,NULL,NULL,'SDSS J170157.89+351027.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,255.4912083,35.17439,0.073,NULL,56338039994,880281874,13754404,18.5),(140128,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140128,34.8,0.46,91.3,67559,70,NULL,NULL,'2MASX J17015796-6318419',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00011,NULL,'13.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,255.4915417,-63.31167,0.689,NULL,44464967512,694765117,10855704,13.3),(140129,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140129,36.96,0.46,247,67560,70,NULL,NULL,'2MASX J17015952+2433401',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,255.498125,24.56111,0.197,NULL,56190400812,877975012,13718359,16.9),(140130,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140130,35.12,0.49,106,67561,70,NULL,NULL,'2MASX J17020094-7833333',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000097,NULL,'15.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,255.503583,-78.55919,0.421,NULL,44259362954,691552546,10805508,15.6),(140131,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140131,34.98,0.51,99.1,67562,70,NULL,NULL,'2MASX J17020261-0251011',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.0001,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,255.510875,-2.85036,0.617,NULL,45220923009,706576922,11040264,14.9),(140132,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140132,37.8,0.1,363,67563,70,NULL,NULL,'ZwCl 1700.5+3322 18',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000178,NULL,'17.4g',0.21,'Fuzzy red ell.comp.',NULL,NULL,NULL,NULL,1,255.514125,33.50525,0.077,NULL,56339701434,880307834,13754809,17.4),(140133,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140133,38.03,0.46,404,67564,70,NULL,NULL,'SDSS J170206.17+381938.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000078,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,255.52575,38.32747,0.089,NULL,59629004851,931703200,14557862,18.4),(140134,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140134,36.71,0.43,220,67565,NULL,NULL,'Malmquist cor.','2MASX J17020727+7817300',NULL,'2009ApJS..182..474S',2009,1,0.59,NULL,'G',0.00003,NULL,'15.55',NULL,'Sbc',NULL,NULL,NULL,NULL,1,255.530333,78.29164,0.161,NULL,57135858359,892747786,13949184,15.55),(140135,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140135,36.91,0.39,241,67565,NULL,NULL,NULL,'2MASX J17020727+7817300',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140136,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140136,36.95,0.2,245,67565,74.4,NULL,NULL,'2MASX J17020727+7817300',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140137,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140137,37.13,0.46,267,67566,70,NULL,NULL,'VII Zw 674',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000097,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,255.534416667,60.96356,0.017,NULL,57533879182,898966862,14046357,16.3),(140138,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140138,38.32,0.46,462,67567,70,NULL,NULL,'2MASX J17020878+3311283',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000183,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,255.5367083,33.19133,0.057,NULL,56339804937,880309452,13754835,17.7),(140139,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140139,37.86,0.33,372,67568,70,NULL,NULL,'2MASX J17021092+3521493',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000133,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,255.5454583,35.36364,0.089,NULL,56120032717,876875511,13701179,18.1),(140140,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140140,36.08,0.41,164,67569,70,NULL,NULL,'GIN 624',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',NULL,NULL,'15.28',NULL,'SB',NULL,NULL,NULL,NULL,1,255.557,28.12886,0.261,NULL,56194602308,878040661,13719385,15.28),(140141,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140141,37.8,0.1,363,67570,70,NULL,NULL,'ZwCl 1700.5+3322 22a',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.2g',0.13,'Red sph.comp.20\\\"SW b',NULL,NULL,NULL,NULL,1,255.561333,33.561,0.057,NULL,56339716682,880308073,13754813,18.2),(140142,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140142,37.15,0.33,269,67571,70,NULL,NULL,'2MASX J17021551+1912449',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000183,NULL,'16.2g',0.36,'E0',NULL,NULL,NULL,NULL,1,255.564666667,19.21247,0.353,NULL,56870842269,888606910,13884482,16.2),(140143,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140143,37.8,0.1,363,67572,70,NULL,NULL,'ZwCl 1700.5+3322 22b',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000158,NULL,'17.1g',0.25,'V.red sph.comp.',NULL,NULL,NULL,NULL,1,255.5675417,33.56383,0.057,NULL,56339724699,880308198,13754815,17.1),(140144,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140144,35.98,0.56,157,67573,70,NULL,NULL,'2MASX J17021655-0437111',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,255.568917,-4.61983,0.905,NULL,45228714494,706698663,11042166,15.8),(140145,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140145,36.97,0.46,248,67574,70,NULL,NULL,'ZwCl 1700.5+3322 24',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000154,NULL,'17.0g',0.31,'Red spherical comp.',NULL,NULL,NULL,NULL,1,255.569875,34.502,0.053,NULL,56338350509,880286726,13754480,17),(140146,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140146,37.8,0.1,363,67575,70,NULL,NULL,'ZwCl 1700.5+3322 23',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000176,NULL,'17.1g',0.23,'Fuzzy red sph.comp.',NULL,NULL,NULL,NULL,1,255.571417,33.491,0.077,NULL,56339669883,880307341,13754802,17.1),(140147,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140147,38.19,0.46,434,67576,70,NULL,NULL,'2MASX J17021729+3133193',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,255.572,31.55533,0.129,NULL,56213711541,878339242,13724050,17.8),(140148,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140148,37.43,0.46,307,67577,70,NULL,NULL,'2MASX J17022007+2927031',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,255.583583,29.45086,0.257,NULL,56220500538,878445320,13725708,17),(140149,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140149,37.15,0.33,269,67578,70,NULL,NULL,'2MASX J17022017+1914529',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000174,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,255.583917,19.24803,0.353,NULL,56870842630,888606916,13884483,17.3),(140150,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140150,37.8,0.1,363,67579,70,NULL,NULL,'SDSS J170223.56+332249.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000162,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,255.5982083,33.38031,0.077,NULL,56339557095,880305579,13754774,18.4),(140151,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140151,37.8,0.1,363,67580,70,NULL,NULL,'ZwCl 1700.5+3322 a',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000155,NULL,'17.4g',0.21,'Red ellipt. fuzzy',NULL,NULL,NULL,NULL,1,255.598791667,33.49703,0.077,NULL,56339672387,880307381,13754802,17.4),(140152,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140152,37.8,0.1,363,67581,70,NULL,NULL,'ZwCl 1700.5+3322 b',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000186,NULL,'16.5g',0.35,'Red ellipt. fuzzy',NULL,NULL,NULL,NULL,1,255.6024583,33.50311,0.077,NULL,56339672434,880307381,13754802,16.5),(140153,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140153,37.8,0.1,363,67582,70,NULL,NULL,'ZwCl 1700.5+3322 29',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000212,NULL,'16.6g',0.32,'Red,fuzzy ell.comp.',NULL,NULL,NULL,NULL,1,255.604833,33.37989,0.077,NULL,56339556915,880305576,13754774,16.6),(140154,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140154,38.17,0.13,430,67583,70,NULL,NULL,'2MASX J17022571+3359543',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000107,NULL,'17.5g',0.19,'S0',NULL,NULL,NULL,NULL,1,255.607125,33.99828,0.065,NULL,56341612144,880337689,13755276,17.5),(140155,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140155,37.61,0.46,333,67584,70,NULL,NULL,'2MASX J17022700+3827052',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000081,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,255.612583,38.45131,0.097,NULL,59629070222,931704222,14557878,17.4),(140156,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140156,38.13,0.33,422,67585,70,NULL,NULL,'2MASX J17022710+3519473',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'17.1g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,255.6130417,35.33,0.089,NULL,56119895435,876873366,13701146,17.1),(140157,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140157,37.36,0.46,297,67586,70,NULL,NULL,'2MASX J17022789+2105549',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,255.616333,21.09847,0.289,NULL,56861193115,888456142,13882127,16.7),(140158,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140158,37.39,0.46,301,67587,70,NULL,NULL,'2MASX J17022911+2357379',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000172,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,255.621333,23.96044,0.185,NULL,56187522939,877930045,13717656,17.1),(140159,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140159,37.86,0.33,372,67588,70,NULL,NULL,'2MASX J17022946+3516303',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000178,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,255.6227083,35.27517,0.089,NULL,56119900619,876873447,13701147,17.2),(140160,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140160,38.17,0.13,430,67589,70,NULL,NULL,'ZwCl 1700.5+3322 26',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000194,NULL,'16.7g',0.36,'Red fuzzy sph.comp.',NULL,NULL,NULL,NULL,1,255.632875,33.89597,0.061,NULL,56341593547,880337399,13755271,16.7),(140161,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140161,37.8,0.1,363,67590,70,NULL,NULL,'ZwCl 1700.5+3322 31',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000178,NULL,'17.5g',0.18,'Red sph. compact',NULL,NULL,NULL,NULL,1,255.634375,33.42997,0.077,NULL,56339560773,880305637,13754775,17.5),(140162,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140162,38.17,0.13,430,67591,70,NULL,NULL,'2MASX J17023247+3401163',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000172,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,255.635417,34.02119,0.065,NULL,56341605805,880337590,13755274,18),(140163,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140163,34.67,0.51,85.9,67592,70,NULL,NULL,'ESO 070- G 003',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'16.1b',0.2,'S...',NULL,NULL,NULL,NULL,1,255.6367917,-69.29356,0.329,NULL,44974025522,702719148,10979986,16.1),(140164,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140164,37.8,0.1,363,67593,70,NULL,NULL,'ZwCl 1700.5+3322 d',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000213,NULL,'15.5g',0.57,'BrClG',NULL,NULL,NULL,NULL,1,255.638083,33.51672,0.057,NULL,56339671763,880307371,13754802,15.5),(140165,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140165,37.8,0.1,363,67594,70,NULL,NULL,'ZwCl 1700.5+3322 e',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.4g',0.2,'Red spher. compact',NULL,NULL,NULL,NULL,1,255.64175,33.48656,0.077,NULL,56339670980,880307359,13754802,17.4),(140166,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140166,37.8,0.1,363,67595,70,NULL,NULL,'ZwCl 1700.5+3322 32',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000164,NULL,'17.4g',0.24,'Red sph. compact',NULL,NULL,NULL,NULL,1,255.6457917,33.44628,0.077,NULL,56339561378,880305646,13754775,17.4),(140167,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140167,37.8,0.1,363,67596,70,NULL,NULL,'SDSS J170236.48+332305.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,255.6520417,33.38486,0.077,NULL,56339559612,880305618,13754775,18.3),(140168,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140168,37.8,0.1,363,67597,70,NULL,NULL,'ZwCl 1700.5+3322 g',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00039,NULL,'16.7g',0.21,'Red ell.fuzzy comp.',NULL,NULL,NULL,NULL,1,255.663833,33.51408,0.057,NULL,56339676690,880307448,13754803,16.7),(140169,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140169,37.14,0.66,268,67598,70,NULL,NULL,'2MASX J17024014-6452410',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,255.667167,-64.87806,0.561,NULL,44481222714,695019104,10859673,15.8),(140170,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140170,37.91,0.46,381,67599,70,NULL,NULL,'SDSS J170240.30+374129.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000089,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,255.667958333,37.69164,0.093,NULL,59630330064,931723907,14558186,18),(140171,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140171,38.17,0.13,430,67600,70,NULL,NULL,'2MASX J17024278+3405533',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000169,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,255.678208333,34.09817,0.065,NULL,56341775380,880340240,13755316,18.5),(140172,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140172,37.72,0.46,351,67601,70,NULL,NULL,'2MASX J17024393+3028343',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,255.683,30.47628,0.177,NULL,56212477120,878319955,13723749,17.5),(140173,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140173,37.8,0.1,363,67602,70,NULL,NULL,'ZwCl 1700.5+3322 35',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'17.3g',0.23,'Neutral sph. compact',NULL,NULL,NULL,NULL,1,255.687166667,33.58236,0.057,NULL,56339666638,880307291,13754801,17.3),(140174,'IRAS','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140174,34.12,0.8,66.6,67603,75,NULL,'MAT, I','ESO 001- G 007',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'15.85',0.7,'Sb-c',NULL,NULL,NULL,NULL,1,255.688083,-88.91722,0.569,NULL,44023919674,687873744,10748027,15.85),(140175,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140175,33.66,0.32,53.9,67603,85,NULL,'I, raw','ESO 001- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140176,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140176,33.67,0.32,54.3,67603,85,NULL,'I, inv','ESO 001- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140177,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140177,33.81,0.43,57.9,67603,75,NULL,'MAT, I, raw','ESO 001- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140178,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140178,33.93,0.43,61,67603,75,NULL,'MAT, I, inv','ESO 001- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140179,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140179,33.95,0.41,61.7,67603,NULL,NULL,NULL,'ESO 001- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140180,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140180,33.99,0.2,62.8,67603,74.4,NULL,NULL,'ESO 001- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140181,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140181,34.01,0.43,63.4,67603,75,NULL,'MAT, I, cor','ESO 001- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140182,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140182,34.16,0.38,67.8,67603,NULL,NULL,'Malmquist cor.','ESO 001- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140183,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140183,37.8,0.1,363,67604,70,NULL,NULL,'ZwCl 1700.5+3322 i',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000174,NULL,'16.6g',0.28,'Red fuzzy ell.comp.',NULL,NULL,NULL,NULL,1,255.688125,33.50703,0.057,NULL,56339674452,880307413,13754803,16.6),(140184,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140184,37.37,0.46,298,67605,70,NULL,NULL,'2MASX J17024671+2402468',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,255.6947917,24.04633,0.185,NULL,56187531108,877930173,13717658,17.9),(140185,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140185,38.38,0.46,475,67606,70,NULL,NULL,'2MASX J17024727+3258334',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,255.697125,32.97589,0.109,NULL,56339144132,880299127,13754673,18.1),(140186,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140186,38.19,0.46,435,67607,70,NULL,NULL,'2MASX J17024897+3544373',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,255.704083333,35.74386,0.109,NULL,56119978835,876874669,13701166,17.1),(140187,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140187,38.17,0.13,430,67608,70,NULL,NULL,'2MASX J17025054+3349134',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000138,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,255.7105417,33.82047,0.061,NULL,56339496967,880304640,13754760,17.8),(140188,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140188,37.8,0.1,363,67609,70,NULL,NULL,'ZwCl 1700.5+3322 k',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.3g',0.26,'Red fuzzy sph.comp.',NULL,NULL,NULL,NULL,1,255.716125,33.51319,0.057,NULL,56339662085,880307220,13754800,17.3),(140189,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140189,34.86,0.57,93.6,67610,70,NULL,NULL,'2MASX J17025363-0114110',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'16.24',NULL,NULL,NULL,NULL,NULL,NULL,1,255.7234583,-1.23656,0.521,NULL,45204689903,706323279,11036301,16.24),(140190,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140190,38.13,0.33,422,67611,70,NULL,NULL,'2MASX J17025416+3520414',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,255.725708333,35.34492,0.089,NULL,56119917133,876873705,13701151,18.3),(140191,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140191,38.17,0.13,430,67612,70,NULL,NULL,'2MASX J17025462+3412274',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000128,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,255.7275,34.20772,0.065,NULL,56341712785,880339262,13755300,17.6),(140192,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140192,36.92,0.27,242,67613,70,NULL,NULL,'2MASX J17025470+2301559',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000176,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,255.728041667,23.03225,0.229,NULL,56674077500,885532460,13836444,17.6),(140193,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140193,36.79,0.53,228,67614,70,NULL,NULL,'2MASX J17025477-6514442',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,255.728125,-65.24556,0.553,NULL,44480735343,695011489,10859554,15.6),(140194,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140194,36.92,0.27,242,67615,70,NULL,NULL,'IC 4639',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000174,NULL,'15.5g',0.53,NULL,NULL,NULL,NULL,NULL,1,255.728125,22.93003,0.229,NULL,56674074264,885532410,13836443,15.5),(140195,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140195,37.46,0.46,310,67616,70,NULL,NULL,'2MASX J17025477+6117051',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000095,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,255.728458333,61.28472,0.025,NULL,57533932672,898967698,14046370,16.5),(140196,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140196,36.11,0.46,167,67617,70,NULL,NULL,'2MASX J17025608+2531488',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000184,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,255.7337917,25.53031,0.169,NULL,56188768495,877949507,13717961,16.3),(140197,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140197,36.78,0.46,227,67618,70,NULL,NULL,'2MASX J17025615+2311559',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,255.734041667,23.19894,0.225,NULL,56674335335,885536489,13836507,17.4),(140198,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:59','1','PTF11khk','N',140198,35.27,0.06,110,67619,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF11khk',0.0306,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140199,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140199,38.17,0.13,430,67620,70,NULL,NULL,'SDSS J170259.53+340657.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000134,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,255.7480417,34.11586,0.065,NULL,56341790693,880340479,13755319,18.7),(140200,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140200,36.21,0.55,175,67621,70,NULL,NULL,'2MASX J17030103-7858093',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,255.7545417,-78.96919,0.377,NULL,44260267913,691566686,10805729,16.4),(140201,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140201,36.33,0.46,185,67622,70,NULL,NULL,'ZwCl 1700.5+3322 55',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000176,NULL,'15.6g',0.49,'S0; compact core',NULL,NULL,NULL,NULL,1,255.755625,34.47122,0.053,NULL,56338246083,880285095,13754454,15.6),(140202,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140202,33.73,0.2,55.7,67623,74.4,NULL,NULL,'NGC 6292',NULL,'2013AJ....146...86T',2013,1,1.44,NULL,'G',0.00002,NULL,'14.1g',0.71,'Sbc',NULL,NULL,NULL,NULL,1,255.764458333,61.04389,0.017,NULL,57533989536,898968586,14046384,14.1),(140203,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140203,33.88,0.42,59.7,67623,NULL,NULL,NULL,'NGC 6292',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140204,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140204,34.09,0.38,65.9,67623,NULL,NULL,'Malmquist cor.','NGC 6292',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140205,'IRAS','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140205,32.44,0.8,30.7,67624,75,NULL,'MAT, I','ESO 138- G 013',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.00001,NULL,'14.24',1.5,'Sc',NULL,NULL,NULL,NULL,1,255.76525,-61.76811,0.557,NULL,44471622485,694869101,10857329,14.24),(140206,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140206,31.75,0.32,22.4,67624,85,NULL,'I, inv','ESO 138- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140207,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140207,31.76,0.32,22.5,67624,85,NULL,'I, raw','ESO 138- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140208,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140208,31.79,0.4,22.8,67624,NULL,NULL,NULL,'ESO 138- G 013',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140209,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140209,32.18,0.43,27.3,67624,75,NULL,'MAT, I, raw','ESO 138- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140210,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140210,32.19,0.43,27.4,67624,75,NULL,'MAT, I, inv','ESO 138- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140211,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140211,32.57,0.43,32.7,67624,75,NULL,'MAT, I, cor','ESO 138- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140212,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140212,35.95,0.46,155,67625,70,NULL,NULL,'ZwCl 1700.5+3322 54',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000157,NULL,'16.3g',0.31,'Fuzzy sph. compact',NULL,NULL,NULL,NULL,1,255.7779583,34.63797,0.053,NULL,56338722742,880292542,13754570,16.3),(140213,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140213,37.49,0.46,314,67626,70,NULL,NULL,'2MASXi J1703068+384012',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000075,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,255.778333,38.67003,0.089,NULL,59628898666,931701541,14557836,17),(140214,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140214,37.78,0.46,360,67627,70,NULL,NULL,'2MASX J17030721+6025371',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000111,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,255.780083,60.42692,0,NULL,57655890671,900873291,14076145,17.3),(140215,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140215,38.17,0.13,430,67628,70,NULL,NULL,'SDSS J170307.59+335828.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000161,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,255.781667,33.97469,0.065,NULL,56341803074,880340673,13755323,18.7),(140216,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140216,37.91,0.46,382,67629,70,NULL,NULL,'2MASX J17030799+6000380',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000093,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,255.783125,60.0105,0.009,NULL,57655554819,900868044,14076063,16.8),(140217,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140217,35.48,0.48,125,67630,70,NULL,NULL,'2MASX J17030866-0237020',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00008,NULL,'16.59',NULL,NULL,NULL,NULL,NULL,NULL,1,255.7860417,-2.61714,0.613,NULL,45203090548,706298289,11035910,16.59),(140218,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140218,38.17,0.33,430,67631,70,NULL,NULL,'2MASX J17030906+3435548',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,255.7875417,34.59861,0.053,NULL,56338723678,880292557,13754571,17.4),(140219,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140219,37.8,0.1,363,67632,70,NULL,NULL,'2MASXi J1703095+333431',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000188,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,255.789583,33.57522,0.057,NULL,56339641921,880306905,13754795,17.6),(140220,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140220,36.5,0.46,200,67633,70,NULL,NULL,'2MASX J17030997+5939369',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000089,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,255.791333,59.66022,0.021,NULL,57701551359,901586739,14087292,16.5),(140221,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140221,37.8,0.1,363,67634,70,NULL,NULL,'ZwCl 1700.5+3322 41',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000195,NULL,'16.9g',0.26,'Red spherical comp.',NULL,NULL,NULL,NULL,1,255.792375,33.49992,0.057,NULL,56339628861,880306700,13754792,16.9),(140222,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140222,38.17,0.13,430,67635,70,NULL,NULL,'ZwCl 1700.5+3322 46',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.8g',0.19,'Neutral sph. compact',NULL,NULL,NULL,NULL,1,255.7930417,33.87961,0.061,NULL,56341662089,880338470,13755288,17.8),(140223,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140223,37.12,0.46,265,67636,70,NULL,NULL,'ZwCl 1700.5+3322 50',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000181,NULL,'16.5g',0.32,'Red sph.compact,halo',NULL,NULL,NULL,NULL,1,255.80325,33.54431,0.057,NULL,56339630805,880306731,13754792,16.5),(140224,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140224,38.38,0.46,474,67637,70,NULL,NULL,'2MASX J17031387+6332300',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000104,NULL,'16.5g',0.39,'BrClG',NULL,NULL,NULL,NULL,1,255.807833333,63.54181,0.057,NULL,57539649011,899057015,14047765,16.5),(140225,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140225,38.15,0.33,427,67638,70,NULL,NULL,'2MASX J17031592+6304180',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000087,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,255.816625,63.07156,0.017,NULL,57541709361,899089208,14048268,17.6),(140226,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140226,38.15,0.33,427,67639,70,NULL,NULL,'SDSS J170318.16+630431.7',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000081,NULL,'18.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,255.8257083,63.07547,0.017,NULL,57541709567,899089211,14048268,18),(140227,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140227,37.85,0.46,371,67640,70,NULL,NULL,'2MASX J17031824+6204580',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00008,NULL,'17.9g',0.18,'NLAGN',NULL,NULL,NULL,NULL,1,255.826417,62.08292,0.009,NULL,57535026610,898984790,14046637,17.9),(140228,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140228,36.57,0.7,206,67641,70,NULL,NULL,'2MASX J17031859-7109173',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,255.8275,-71.15486,0.441,NULL,44971627168,702681674,10979401,16.4),(140229,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140229,36.99,0.46,250,67642,70,NULL,NULL,'2MASX J17031864+5925409',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000109,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,255.827625,59.42817,0.021,NULL,57704860374,901638443,14088100,16.3),(140230,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140230,38.17,0.33,430,67643,70,NULL,NULL,'SDSS J170319.04+343613.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000136,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,255.829375,34.60364,0.053,NULL,56338733308,880292707,13754573,18.7),(140231,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140231,36.92,0.27,242,67644,70,NULL,NULL,'2MASX J17031921+2254430',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000174,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,255.83,22.91211,0.229,NULL,56858406882,888412607,13881446,16.9),(140232,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140232,38.06,0.33,410,67645,70,NULL,NULL,'2MASX J17031974+3503580',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000141,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,255.832375,35.06614,0.073,NULL,56338749201,880292956,13754577,18),(140233,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140233,37.8,0.1,363,67646,70,NULL,NULL,'ZwCl 1700.5+3322 42',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.0g',0.24,'Blue sph. compact',NULL,NULL,NULL,NULL,1,255.832875,33.48206,0.097,NULL,56339746447,880308538,13754820,17),(140234,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140234,37.8,0.1,363,67647,70,NULL,NULL,'2MASX J17032217+3329460',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000155,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,255.8422917,33.49603,0.097,NULL,56339746243,880308535,13754820,18.3),(140235,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140235,36.98,0.49,249,67648,NULL,NULL,'Malmquist cor.','2MASX J17032243+7846557',NULL,'2009ApJS..182..474S',2009,1,0.52,NULL,'G',0.000027,NULL,'16.9V',NULL,'S/I','Group member',NULL,NULL,NULL,1,255.842875,78.78211,0.177,NULL,57128713291,892636145,13947439,16.9),(140236,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140236,37.23,0.44,279,67648,NULL,NULL,NULL,'2MASX J17032243+7846557',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140237,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140237,37.27,0.2,284,67648,74.4,NULL,NULL,'2MASX J17032243+7846557',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140238,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140238,36.75,0.27,224,67649,70,NULL,NULL,'2MASX J17032528+2435304',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000185,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,255.8554583,24.59164,0.197,NULL,56187552508,877930507,13717664,16.7),(140239,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140239,35.47,0.32,124,67650,NULL,NULL,'Malmquist cor.','ESO 587- G 003',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000003,NULL,'14.37',0.2,'S...',NULL,NULL,NULL,NULL,1,255.8697917,-19.17339,1.017,NULL,46144747898,721011685,11265807,14.37),(140240,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140240,35.53,0.49,128,67650,75,NULL,'IR','ESO 587- G 003',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140241,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140241,35.64,0.3,134,67650,NULL,NULL,NULL,'ESO 587- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140242,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140242,35.68,0.2,137,67650,74.4,NULL,NULL,'ESO 587- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140243,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140243,38.27,0.46,452,67651,70,NULL,NULL,'2MASX J17032899+5928480',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000099,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,255.870958333,59.48014,0.021,NULL,57701403857,901584435,14087256,17.1),(140244,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140244,38.06,0.33,410,67652,70,NULL,NULL,'2MASX J17033106+3506150',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,255.8795417,35.10431,0.073,NULL,56338759106,880293111,13754579,17.4),(140245,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140245,37.65,0.46,339,67653,70,NULL,NULL,'2MASX J17033141+2503504',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000155,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,255.8807083,25.06417,0.193,NULL,56190649574,877978899,13718420,17.8),(140246,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140246,34.68,NULL,86.2,67654,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2102',NULL,'2010Ap&SS.325..163P',2010,1,0.92,NULL,'G',NULL,NULL,'15.68',0.11,'Sd',NULL,NULL,NULL,NULL,1,255.887083,43.98889,0.013,NULL,59647032623,931984884,14562263,15.68),(140247,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140247,34.7,NULL,86.9,67654,NULL,NULL,'Dipole + Quadrupole','FGC 2102',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140248,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140248,34.71,NULL,87.5,67654,NULL,NULL,'Dipole','FGC 2102',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140249,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140249,34.73,NULL,88.5,67654,NULL,NULL,NULL,'FGC 2102',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140250,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140250,35.36,0.49,118,67655,75,NULL,'IR','UGC 10681',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.00002,NULL,'15.60',0.2,'Scd:',NULL,NULL,NULL,NULL,1,255.8870417,45.45975,0.037,NULL,59646068162,931969815,14562028,15.6),(140251,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140251,35.67,0.31,136,67655,NULL,NULL,'Malmquist cor.','UGC 10681',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140252,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140252,36.08,0.26,165,67655,NULL,NULL,NULL,'UGC 10681',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140253,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140253,36.12,0.2,167,67655,74.4,NULL,NULL,'UGC 10681',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140254,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140254,37.8,0.1,363,67656,70,NULL,NULL,'ZwCl 1700.5+3322 51',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000174,NULL,'17.0g',0.23,'Red spherical compac',NULL,NULL,NULL,NULL,1,255.8879583,33.53694,0.097,NULL,56339756232,880308691,13754823,17),(140255,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140255,36.22,0.46,175,67657,70,NULL,NULL,'2MASX J17033419+1922280',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000184,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,255.892583,19.37444,0.353,NULL,56867689974,888557655,13883713,16.6),(140256,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140256,38.11,0.46,419,67658,70,NULL,NULL,'2MASX J17033434+3035500',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,255.893167,30.59717,0.181,NULL,56342722279,880355035,13755547,17.4),(140257,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140257,37.53,0.33,321,67659,70,NULL,NULL,'2MASX J17033458+5855030',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000111,NULL,'16.0g',0.37,'E0',NULL,NULL,NULL,NULL,1,255.8942917,58.91756,0.017,NULL,57705061737,901641589,14088149,16),(140258,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140258,36.57,0.46,206,67660,70,NULL,NULL,'2MASX J17033507+3558300',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000185,NULL,'15.8g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,255.8962917,35.97494,0.105,NULL,56120379843,876880935,13701264,15.8),(140259,'BCG','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140259,36.61,0.35,199,67661,60,NULL,'ABELL 2256, BCG','NGC 6331',0.055,'1980ApJ...241..486H',1980,1,NULL,NULL,'G',0.00015,NULL,'16.1V',NULL,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,255.899875,78.629,0.177,NULL,57128744717,892636636,13947447,16.1),(140260,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140260,37.02,0.12,253,67661,70,NULL,'ABELL 2256, BGC','NGC 6331',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140261,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140261,37.53,0.33,321,67662,70,NULL,NULL,'SDSS J170336.14+585336.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000077,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,255.900625,58.8935,0.017,NULL,57705061360,901641583,14088149,18.4),(140262,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140262,33.73,0.46,55.6,67663,70,NULL,NULL,'NGC 6297',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000073,NULL,'14.2g',0.67,'S0',NULL,NULL,NULL,NULL,1,255.9022917,62.02561,0.009,NULL,57535030651,898984853,14046638,14.2),(140263,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140263,37.99,0.46,396,67664,70,NULL,NULL,'2MASX J17033707+2051206',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000196,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,255.9045,20.85578,0.293,NULL,56871911812,888623622,13884744,18),(140264,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140264,38.67,0.46,541,67665,70,NULL,NULL,'2MASX J17033805+3030560',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,255.908666667,30.51567,0.181,NULL,56342731333,880355177,13755549,17.7),(140265,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140265,38.27,0.46,450,67666,70,NULL,NULL,'SDSS J170338.82+253943.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000149,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,255.911791667,25.662,0.157,NULL,56188781120,877949705,13717964,18.7),(140266,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140266,37.84,0.33,370,67667,70,NULL,NULL,'2MASX J17034080+6533543',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000092,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,255.9197917,65.56522,0.089,NULL,57571236299,899550567,14055477,16.5),(140267,'SZ effect','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140267,36.92,NULL,242,67668,NULL,NULL,NULL,'ABELL 2256',NULL,'2005ApJ...625..108D',2005,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III:[BM]',NULL,NULL,NULL,NULL,1,255.931375,78.71739,0.177,NULL,57128669441,892635460,13947429,NULL),(140268,'SZ effect','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140268,37.03,NULL,255,67668,NULL,NULL,NULL,'ABELL 2256',NULL,'2001ApJ...555L..11M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140269,'BCG','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140269,36.61,0.35,199,67668,60,NULL,NULL,'ABELL 2256',0.055,'1980ApJ...241..486H',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140270,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140270,37.02,0.12,253,67668,70,NULL,NULL,'ABELL 2256',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140271,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140271,37.13,0.46,267,67669,70,NULL,NULL,'2MASXi J1703432+352627',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'15.87',0.42,NULL,NULL,NULL,NULL,NULL,1,255.930333,35.44097,0.105,NULL,56120742555,876886602,13701353,15.87),(140272,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140272,35.83,0.49,147,67670,70,NULL,NULL,'2MASX J17034507-6348586',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,255.937667,-63.81625,0.593,NULL,44465461319,694772833,10855825,14.9),(140273,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140273,38.08,0.46,413,67671,70,NULL,NULL,'2MASX J17034859+2547130',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000215,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,255.9525,25.78711,0.157,NULL,56188992760,877953011,13718015,16.7),(140274,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140274,36.93,0.46,243,67672,70,NULL,NULL,'2MASX J17034989+3856555',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,255.958,38.94872,0.073,NULL,59640183888,931877873,14560591,16.6),(140275,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2010ag','R',140275,35.59,0.1,131,67673,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 10679',NULL,'2015Sci...347.1459K',2015,1,1.29,NULL,'G',0.000176,NULL,'15.4g',0.28,'Sb(f)',NULL,NULL,NULL,NULL,1,255.9709583,31.49911,0.129,NULL,56344703211,880385987,13756031,15.4),(140276,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2010ag','R',140276,35.66,0.08,136,67673,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 10679',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140277,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2010ag',NULL,140277,35.75,0.2,137,67673,73.8,NULL,'SALT 2 (SNANA)','UGC 10679',0.034,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140278,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140278,36.75,0.27,224,67674,70,NULL,NULL,'2MASX J17035307+2443360',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000172,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,255.97125,24.72678,0.197,NULL,56187233420,877925522,13717586,17.1),(140279,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140279,36,0.23,158,67675,70,NULL,NULL,'2MASX J17035365+2501410',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,255.973667,25.02803,0.193,NULL,56190768635,877980759,13718449,16.7),(140280,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140280,36.37,0.59,188,67676,70,NULL,NULL,'2MASX J17035400-7117311',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,255.974916667,-71.29189,0.441,NULL,44095283766,688988808,10765450,17.1),(140281,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140281,36.75,0.27,224,67677,70,NULL,NULL,'2MASX J17035556+2446480',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000198,NULL,'15.6g',0.47,NULL,NULL,NULL,NULL,NULL,1,255.9815,24.78003,0.197,NULL,56190705356,877979771,13718433,15.6),(140282,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140282,37.36,0.46,297,67678,70,NULL,NULL,'2MASX J17035572+3221107',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000139,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,255.982208333,32.35306,0.125,NULL,56344333948,880380217,13755940,17.9),(140283,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140283,37.06,0.46,258,67679,70,NULL,NULL,'2MASX J17035811+3757436',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000081,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,255.992083,37.96206,0.093,NULL,59629575009,931712109,14558001,16.8),(140284,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140284,35.64,0.46,134,67680,70,NULL,NULL,'UGC 10678',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000027,NULL,'14.4g',0.79,'S0',NULL,NULL,NULL,NULL,1,255.99375,24.17767,0.165,NULL,56187786653,877934166,13717721,14.4),(140285,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140285,36.16,0.54,170,67681,70,NULL,NULL,'FAIRALL 1459',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5R',0.5,NULL,NULL,NULL,NULL,NULL,1,255.993917,-71.29608,0.441,NULL,44095286758,688988855,10765450,14.5),(140286,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140286,38.25,0.46,446,67682,70,NULL,NULL,'SDSS J170359.63+311844.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,255.9985,31.3125,0.161,NULL,56344475810,880382434,13755975,18.5),(140287,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140287,36,0.23,158,67683,70,NULL,NULL,'CGCG 139-032',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.000177,NULL,'14.8g',0.61,NULL,NULL,NULL,NULL,NULL,1,256.0052917,25.05408,0.193,NULL,56190822431,877981600,13718462,14.8),(140288,'GRB','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140288,40.53,NULL,1280,67684,70,NULL,'Pseudo z = 0.36','GRB 030528',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,256.008333,-22.64972,1.285,NULL,46138041408,720906897,11264170,NULL),(140289,'GRB','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140289,43.61,0.17,2960,67684,72,NULL,NULL,'GRB 030528',0.78,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140290,'GRB','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140290,44.19,0.62,3870,67684,72,NULL,NULL,'GRB 030528',0.78,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140291,'GRB','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140291,44.3,0.59,4070,67684,70,NULL,NULL,'GRB 030528',0.78,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140292,'GRB','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140292,44.31,0.54,4090,67684,69.7,NULL,'Calibrated','GRB 030528',0.78,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140293,'GRB','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140293,45.12,0.58,5940,67684,69.7,NULL,'Fiducial','GRB 030528',0.78,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140294,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140294,37.24,0.46,280,67685,70,NULL,NULL,'2MASX J17040205+2107247',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,256.008666667,21.12353,0.277,NULL,56860865642,888451025,13882047,17.4),(140295,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140295,37.59,0.27,330,67686,70,NULL,NULL,'ZwCl 1700.5+3322 61',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000158,NULL,'17.0g',0.25,'Fuzzy red ell.comp.',NULL,NULL,NULL,NULL,1,256.012375,33.59103,0.097,NULL,56339787387,880309177,13754830,17),(140296,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140296,37.89,0.46,379,67687,70,NULL,NULL,'ZwCl 1700.5+3322 56',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.4g',0.22,'Patchy oval compact',NULL,NULL,NULL,NULL,1,256.016833,34.25811,0.093,NULL,56341730511,880339539,13755305,17.4),(140297,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140297,37.04,0.46,256,67688,70,NULL,NULL,'ZwCl 1700.5+3322 62',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000151,NULL,'17.2g',0.25,'Red spherical comp.',NULL,NULL,NULL,NULL,1,256.0212917,33.53131,0.097,NULL,56339778413,880309037,13754828,17.2),(140298,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140298,36.28,0.46,180,67689,70,NULL,NULL,'2MASX J17040781+3852036',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000112,NULL,'15.8g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,256.032583333,38.86764,0.073,NULL,59640131816,931877059,14560579,15.8),(140299,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140299,35.05,0.46,102,67690,70,NULL,NULL,'CGCG 169-038',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000095,NULL,'15.4g',0.48,'HII',NULL,NULL,NULL,NULL,1,256.036333,31.484,0.129,NULL,56344698626,880385916,13756029,15.4),(140300,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140300,36.95,0.46,245,67691,70,NULL,NULL,'2MASX J17040936+6114114',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000065,NULL,'17.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,256.039083333,61.2365,0.025,NULL,57534108972,898970452,14046413,17.7),(140301,'GRB','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140301,44.38,1.53,2480,67692,100,NULL,NULL,'GRB 000926',2.0375,'2009EPJC...63..139W',2009,1,NULL,NULL,'G',0.0007,NULL,'22.9R',NULL,'Ulysses/Ko/NE',NULL,NULL,NULL,NULL,1,256.0402083,51.78611,0.017,NULL,57494591981,898352999,14036765,22.9),(140302,'GRB','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140302,44.51,1.47,2630,67692,100,NULL,NULL,'GRB 000926',2.0375,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140303,'GRB','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140303,45.09,0.68,3430,67692,69.7,NULL,'Calibrated','GRB 000926',2.0375,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140304,'GRB','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140304,45.93,0.92,3690,67692,73,NULL,'H const./H=100','GRB 000926',2.0375,'2006astro.ph..9262M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140305,'GRB','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140305,45.39,0.69,3940,67692,69.7,NULL,'Fiducial','GRB 000926',2.0375,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140306,'GRB','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140306,45.49,0.69,4130,67692,72,NULL,NULL,'GRB 000926',2.0375,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140307,'GRB','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140307,45.62,0.69,4340,67692,70,NULL,NULL,'GRB 000926',2.0375,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140308,'GRB','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140308,45.8,0.84,4770,67692,NULL,NULL,NULL,'GRB 000926',2.0375,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140309,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140309,37.59,0.27,330,67693,70,NULL,NULL,'ZwCl 1700.5+3322 63',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000189,NULL,'16.0g',0.43,'Red elliptical',NULL,NULL,NULL,NULL,1,256.048375,33.46072,0.097,NULL,56339767713,880308870,13754826,16),(140310,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140310,37.55,0.46,323,67694,70,NULL,NULL,'SDSS J170413.88+361546.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000176,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,256.057875,36.26292,0.097,NULL,59626649919,931666404,14557287,18.2),(140311,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140311,37.78,0.46,360,67695,70,NULL,NULL,'2MASX J17041704+2958055',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,256.071083333,29.96825,0.221,NULL,56342304213,880348503,13755445,17.8),(140312,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140312,37.76,0.46,357,67696,70,NULL,NULL,'2MASX J17041760+3023457',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,256.073417,30.39594,0.201,NULL,56342992218,880359253,13755613,17.1),(140313,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140313,37.87,0.46,375,67697,70,NULL,NULL,'SDSS J170417.84+334254.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000141,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,256.074375,33.71508,0.097,NULL,56339604536,880306320,13754786,18.4),(140314,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140314,38.16,0.46,429,67698,70,NULL,NULL,'2MASX J17041984+2934475',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,256.082833,29.57986,0.253,NULL,56358877257,880607457,13759491,17.4),(140315,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140315,27.41,0.49,3.04,67699,75,NULL,'IR','FGCE 1267',NULL,'2011yCatp016004901K',2011,1,1.1,'Huchtmeier et al. (2005A&A...435..459H) v=257 is for a weak line.','G',0.00001,NULL,'16.8',0.11,'Scd',NULL,NULL,NULL,NULL,1,256.088875,-27.19119,NULL,NULL,45811406678,715803229,11184425,16.8),(140316,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140316,37,0.95,251,67700,70,NULL,NULL,'2MASX J17042135-7136509',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,256.08875,-71.61417,0.477,NULL,44095380071,688990313,10765473,16.1),(140317,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140317,37.85,0.33,372,67701,70,NULL,NULL,'2MASX J17042168+6123492',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000104,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,256.0907083,61.39717,0.025,NULL,57533650759,898963293,14046301,17.2),(140318,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140318,36.14,0.67,169,67702,70,NULL,NULL,'2MASX J17042863-0150499',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,256.119333,-1.84731,0.597,NULL,45211145723,706424151,11037877,15.7),(140319,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140319,37.17,0.46,272,67703,70,NULL,NULL,'2MASX J17043107+3404208',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000146,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,256.1295,34.07244,0.093,NULL,56341645554,880338211,13755284,16.9),(140320,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140320,37.38,0.46,299,67704,70,NULL,NULL,'2MASX J17043175+3327348',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,256.13225,33.45956,0.097,NULL,56339772651,880308947,13754827,17.1),(140321,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140321,31.93,0.4,24.3,67705,NULL,NULL,'mean','UGC 10713',NULL,'2007A&A...465...71T',2007,1,2.03,NULL,'G',0.000013,NULL,'14.0g',0.46,'Sb             HII','Group member, radial-velocity confirmed',NULL,NULL,'H II',1,256.14175,72.44664,0.185,NULL,57098637319,892166208,13940097,14),(140322,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140322,32.35,0.43,29.5,67705,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10713',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140323,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140323,32.57,0.46,32.7,67705,NULL,NULL,'J','UGC 10713',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140324,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140324,32.6,0.47,33.2,67705,NULL,NULL,'H','UGC 10713',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140325,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140325,32.63,0.45,33.6,67705,NULL,NULL,'K','UGC 10713',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140326,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140326,32.72,0.43,35,67705,75,NULL,'3.6 micron, color corrected','UGC 10713',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140327,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140327,33.08,0.2,41.3,67705,74.4,NULL,NULL,'UGC 10713',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140328,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140328,37.6,0.46,332,67706,70,NULL,NULL,'2MASX J17043500+3424508',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000146,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,256.145916667,34.41419,0.081,NULL,56341828921,880341076,13755329,17.9),(140329,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140329,37.61,0.46,332,67707,70,NULL,NULL,'2MASX J17043788+2117104',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000136,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,256.1579583,21.28611,0.277,NULL,56860780956,888449702,13882026,18.5),(140330,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140330,37.85,0.33,372,67708,70,NULL,NULL,'2MASX J17043838+6127186',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000123,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,256.159875,61.45506,0.017,NULL,57533636283,898963066,14046297,17.5),(140331,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140331,38.33,0.46,464,67709,70,NULL,NULL,'2MASX J17044580+3406358',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.6g',0.16,'S0',NULL,NULL,NULL,NULL,1,256.190917,34.10994,0.093,NULL,56341924865,880342576,13755352,17.6),(140332,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140332,36.97,0.46,248,67710,70,NULL,NULL,'2MASX J17044713+6102476',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00007,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,256.196541667,61.04656,0.017,NULL,57534294854,898973357,14046458,17.5),(140333,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140333,37.84,0.33,370,67711,70,NULL,NULL,'2MASX J17044850+6531517',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00007,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,256.201875,65.531,0.113,NULL,57571243164,899550674,14055479,17.4),(140334,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140334,36.25,0.46,178,67712,70,NULL,NULL,'2MASX J17044847+3855447',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000092,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,256.2020417,38.92922,0.133,NULL,59641964856,931905700,14561026,16.3),(140335,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140335,37.18,0.46,273,67713,70,NULL,NULL,'2MASX J17045047+3800377',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,256.2102917,38.01036,0.137,NULL,59629524285,931711316,14557989,16.8),(140336,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140336,35.03,NULL,101,67714,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10694',NULL,'2010Ap&SS.325..163P',2010,1,1.15,NULL,'G',NULL,NULL,'17.',0.08,'Sd',NULL,NULL,NULL,NULL,1,256.234458333,43.24178,0,NULL,59644863980,931950999,14561734,17);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (140337,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140337,35.05,NULL,102,67714,NULL,NULL,'Dipole + Quadrupole','UGC 10694',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140338,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140338,35.06,0.49,103,67714,75,NULL,'IR','UGC 10694',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140339,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140339,35.06,NULL,103,67714,NULL,NULL,'Dipole','UGC 10694',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140340,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140340,35.09,NULL,104,67714,NULL,NULL,NULL,'UGC 10694',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140341,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140341,36.18,0.46,172,67715,70,NULL,NULL,'2MASX J17045631+2100219',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000186,NULL,'15.4g',0.53,'E0',NULL,NULL,NULL,NULL,1,256.23475,21.00617,0.293,NULL,56860731274,888448926,13882014,15.4),(140342,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140342,34.86,0.57,93.8,67716,70,NULL,NULL,'UGC 10683 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.4I',0.2,'SB             BLSy1',NULL,NULL,NULL,NULL,1,256.2369583,-1.53044,0.581,NULL,45214038036,706469344,11038583,14.4),(140343,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140343,34.39,0.51,75.5,67717,70,NULL,NULL,'2MASX J17045714-0250187',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.74',0.3,NULL,NULL,NULL,NULL,NULL,1,256.238,-2.83856,0.661,NULL,45210516057,706414313,11037723,16.74),(140344,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140344,35.96,0.46,156,67718,70,NULL,NULL,'2MASX J17045827+3838183',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000108,NULL,'16.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,256.242917,38.63839,0.137,NULL,59627540467,931680319,14557504,16.2),(140345,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140345,38.26,0.46,450,67719,70,NULL,NULL,'2MASX J17050068+6034237',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000075,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,256.25325,60.57339,0,NULL,57654978783,900859043,14075922,18),(140346,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140346,36.34,0.46,185,67720,70,NULL,NULL,'2MASX J17050251+2521397',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,256.260417,25.36108,0.169,NULL,56188504796,877945387,13717896,16.5),(140347,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140347,35.58,0.49,131,67721,75,NULL,'IR','UGC 10701',NULL,'2011yCatp016004901K',2011,1,1.15,NULL,'G',NULL,NULL,'16.0',0.13,'Sbc',NULL,NULL,NULL,NULL,1,256.278625,52.70617,0.037,NULL,57493104076,898329751,14036402,16),(140348,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140348,35.85,NULL,148,67721,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10701',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140349,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140349,35.86,NULL,148,67721,NULL,NULL,'Dipole + Quadrupole','UGC 10701',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140350,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140350,35.88,NULL,150,67721,NULL,NULL,'Dipole','UGC 10701',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140351,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140351,35.88,NULL,150,67721,NULL,NULL,NULL,'UGC 10701',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140352,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140352,37.18,0.46,273,67722,70,NULL,NULL,'2MASX J17050973+2122250',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000099,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,256.290541667,21.37372,0.289,NULL,56860893658,888451463,13882054,17.9),(140353,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140353,37.89,0.46,379,67723,70,NULL,NULL,'2MASX J17051105+3051021',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,256.296083,30.8505,0.185,NULL,56342793045,880356141,13755564,18),(140354,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140354,38.03,0.46,404,67724,70,NULL,NULL,'2MASX J17051244+2809391',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,256.3017083,28.16097,0.325,NULL,56316410810,879943918,13749123,17.7),(140355,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140355,37.59,0.46,330,67725,70,NULL,NULL,'2MASX J17051357+2353282',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000157,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,256.3065417,23.89108,0.169,NULL,56673535611,885523993,13836312,18.7),(140356,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140356,38.06,0.46,410,67726,70,NULL,NULL,'ZwCl 1700.5+3322 69',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00018,NULL,'17.1g',0.24,'Red fuzzy sph.comp.',NULL,NULL,NULL,NULL,1,256.307333,33.81194,0.097,NULL,56341182633,880330978,13755171,17.1),(140357,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140357,36.95,0.46,246,67727,70,NULL,NULL,'2MASX J17051493+2127295',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000177,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,256.3122917,21.45825,0.289,NULL,56860876436,888451194,13882049,16.5),(140358,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140358,37.18,0.46,273,67728,70,NULL,NULL,'2MASX J17051511+3217511',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,256.313167,32.29767,0.165,NULL,56344315953,880379936,13755936,17.7),(140359,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140359,37.59,0.27,330,67729,70,NULL,NULL,'ZwCl 1700.5+3322 65',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000171,NULL,'17.3g',0.21,'Red spherical comp.',NULL,NULL,NULL,NULL,1,256.319,33.51497,0.097,NULL,56339285165,880301330,13754708,17.3),(140360,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140360,36.57,0.46,206,67730,70,NULL,NULL,'2MASX J17052006+2428132',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,256.33375,24.47031,0.177,NULL,56187838108,877934970,13717733,16.6),(140361,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140361,37.44,0.46,308,67731,70,NULL,NULL,'2MASX J17052124+3829374',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000096,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,256.3385417,38.49383,0.129,NULL,59627595899,931681185,14557518,16.8),(140362,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140362,37.16,0.46,271,67732,70,NULL,NULL,'2MASX J17052410+2103155',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000171,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,256.3505417,21.05439,0.277,NULL,56860971987,888452687,13882073,16.9),(140363,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140363,36.38,0.46,189,67733,70,NULL,NULL,'2MASX J17052510+2051135',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000175,NULL,'16.1g',0.38,'E/S0',NULL,NULL,NULL,NULL,1,256.354625,20.85392,0.293,NULL,56860934735,888452105,13882064,16.1),(140364,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140364,35.62,0.41,133,67734,NULL,NULL,NULL,'UGC 10692',NULL,'2009ApJS..182..474S',2009,1,1.66,NULL,'G',0.00002,NULL,'14.8g',0.37,'Sb',NULL,NULL,NULL,NULL,1,256.367083,23.15319,0.217,NULL,56858081094,888407517,13881367,14.8),(140365,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140365,35.63,0.4,134,67734,NULL,NULL,'Malmquist cor.','UGC 10692',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140366,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140366,35.65,0.47,135,67734,NULL,NULL,'H','UGC 10692',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140367,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140367,35.71,0.4,138,67734,NULL,NULL,'mean','UGC 10692',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140368,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140368,35.7,0.2,138,67734,74.4,NULL,NULL,'UGC 10692',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140369,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140369,35.71,0.45,139,67734,NULL,NULL,'K','UGC 10692',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140370,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140370,35.92,0.46,153,67734,NULL,NULL,'J','UGC 10692',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140371,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140371,35.69,0.46,137,67735,70,NULL,NULL,'CGCG 197-032',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000195,NULL,'15.2g',0.5,'E/S0',NULL,NULL,NULL,NULL,1,256.369666667,35.63467,0.121,NULL,56120608906,876884514,13701320,15.2),(140372,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140372,36.15,0.27,170,67736,70,NULL,NULL,'B2 1703+22',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.00008,NULL,'15.1g',0.59,'E;LINER  cand. BLLAC',NULL,NULL,NULL,NULL,1,256.3722083,22.26878,0.277,NULL,56861513786,888461152,13882205,15.1),(140373,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140373,37.63,0.27,337,67737,70,NULL,NULL,'2MASX J17053196+3345163',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000144,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,256.38325,33.75439,0.097,NULL,56339321306,880301895,13754717,17.6),(140374,'BL Lac Luminosity','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140374,40.74,NULL,1100,67738,NULL,NULL,NULL,'[HB89] 1704+607',0.28,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.003,NULL,'19.4',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,256.395083,60.70439,0,NULL,57533453450,898960210,14046253,19.4),(140375,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140375,37.76,0.46,357,67739,70,NULL,NULL,'SDSS J170535.98+585630.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000097,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,256.3999583,58.94186,0.009,NULL,57705201416,901643772,14088183,17.7),(140376,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140376,36.46,0.46,196,67740,70,NULL,NULL,'ZwCl 1700.5+3322 70',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000181,NULL,'16.6g',0.21,'Neutral patchy ell.',NULL,NULL,NULL,NULL,1,256.413333,32.96378,0.101,NULL,56353483770,880523183,13758174,16.6),(140377,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140377,37.82,0.46,367,67741,70,NULL,NULL,'2MASX J17054169+2906592',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,256.4237917,29.11642,0.289,NULL,56313678961,879901233,13748456,17.4),(140378,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140378,38.62,0.46,529,67742,70,NULL,NULL,'2MASX J17054332+6217518',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000089,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,256.430167,62.29794,0.049,NULL,57535206230,898987597,14046681,17.8),(140379,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140379,36.15,0.27,170,67743,70,NULL,NULL,'2MASX J17054435+2214502',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000097,NULL,'15.2g',0.53,'E0',NULL,NULL,NULL,NULL,1,256.434833,22.24722,0.277,NULL,56861500778,888460949,13882202,15.2),(140380,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140380,36.19,0.46,173,67744,70,NULL,NULL,'2MASX J17054464+2438564',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,256.436,24.64903,0.177,NULL,56187335199,877927112,13717611,17.3),(140381,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140381,37.38,0.46,299,67745,70,NULL,NULL,'2MASX J17054561+5915407',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000096,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,256.4399583,59.26142,0.013,NULL,57704973843,901640216,14088128,17),(140382,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140382,36.84,0.46,234,67746,70,NULL,NULL,'2MASX J17054720+3538323',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000167,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,256.446583,35.64239,0.121,NULL,56120621230,876884706,13701323,16.7),(140383,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140383,37.78,0.46,360,67747,70,NULL,NULL,'SDSS J170547.75+340338.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000164,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,256.449,34.06081,0.093,NULL,56341919453,880342491,13755351,18.5),(140384,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140384,36.15,0.27,170,67748,70,NULL,NULL,'2MASX J17054954+2213572',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000172,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,256.456417,22.23261,0.277,NULL,56861628801,888462950,13882233,16.4),(140385,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140385,37.63,0.27,337,67749,70,NULL,NULL,'ZwCl 1700.5+3322 74',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.1g',0.24,'Red spherical comp.',NULL,NULL,NULL,NULL,1,256.4604583,33.61036,0.097,NULL,56339435746,880303683,13754745,17.1),(140386,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140386,34.77,0.47,89.9,67750,70,NULL,NULL,'ESO 101-IG 021 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.17,NULL,'G',0.000143,NULL,'15.15',NULL,'E M','Pair member (points to parent)',NULL,NULL,NULL,1,256.4717083,-63.45692,0.605,NULL,44482792681,695043635,10860056,15.15),(140387,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140387,36.68,0.8,217,67751,70,NULL,NULL,'2MASX J17055495-8020252',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,256.4790417,-80.34044,0.437,NULL,44261334416,691583350,10805989,16.2),(140388,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140388,37.83,0.46,369,67752,70,NULL,NULL,'2MASX J17060208+2041332',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,256.5085,20.69269,0.293,NULL,56871747390,888621052,13884703,17),(140389,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140389,37.23,0.46,279,67753,70,NULL,NULL,'SDSS J170602.31+585513.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000088,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,256.509667,58.92053,0.009,NULL,57705187934,901643561,14088180,17.8),(140390,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140390,37.98,0.46,395,67754,70,NULL,NULL,'2MASX J17060747+6318258',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000085,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,256.530875,63.30714,0.053,NULL,57572112844,899564263,14055691,17.2),(140391,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140391,37.72,0.46,349,67755,70,NULL,NULL,'ZwCl 1700.5+3322 75',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000195,NULL,'16.3g',0.35,'BrClG          AGN',NULL,NULL,NULL,NULL,1,256.5317917,33.48283,0.097,NULL,56339457556,880304024,13754750,16.3),(140392,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140392,38.12,0.19,420,67756,70,NULL,NULL,'SDSS J170608.58+312719.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,256.53575,31.45533,0.137,NULL,56345662412,880400975,13756265,18.2),(140393,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140393,38.12,0.19,420,67757,70,NULL,NULL,'2MASX J17060990+3127308',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000176,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,256.54125,31.45847,0.137,NULL,56345662301,880400973,13756265,17.3),(140394,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140394,37.04,0.46,255,67758,70,NULL,NULL,'2MASX J17061067+4004088',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,256.5445417,40.06908,0.113,NULL,59642772443,931918319,14561223,17),(140395,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140395,37.48,0.33,314,67759,70,NULL,NULL,'2MASX J17061440+3014158',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000179,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,256.56025,30.23767,0.217,NULL,56342155830,880346184,13755409,16.6),(140396,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140396,36.79,0.58,228,67760,70,NULL,NULL,'2MASX J17061481-6311428',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,256.561667,-63.19519,0.689,NULL,44482699012,695042172,10860033,14.6),(140397,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140397,36.04,0.58,161,67761,70,NULL,NULL,'2MASX J17061816-2402182',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,256.57575,-24.03842,1.437,NULL,45801849727,715653901,11182092,16.5),(140398,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140398,37.48,0.33,314,67762,70,NULL,NULL,'2MASX J17061996+3014018',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,256.583125,30.23383,0.217,NULL,56342157766,880346215,13755409,17.9),(140399,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140399,37.96,0.46,390,67763,70,NULL,NULL,'2MASX J17062160+3349048',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,256.589875,33.81797,0.097,NULL,56341187641,880331056,13755172,17.7),(140400,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140400,38.12,0.19,420,67764,70,NULL,NULL,'SDSS J170623.24+312847.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000177,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,256.596875,31.47981,0.137,NULL,56346206501,880409476,13756398,18.5),(140401,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140401,38.04,0.46,405,67765,70,NULL,NULL,'2MASX J17062499+6339144',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000094,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,256.604125,63.65408,0.057,NULL,57572208256,899565754,14055714,17.7),(140402,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140402,38.21,0.46,439,67766,70,NULL,NULL,'2MASX J17062542+2023086',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000145,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,256.6060417,20.38583,0.289,NULL,56871797409,888621834,13884716,17.8),(140403,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140403,36.85,0.46,234,67767,70,NULL,NULL,'2MASX J17062667+2324096',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,256.61125,23.40278,0.209,NULL,56858233453,888409897,13881404,17.2),(140404,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140404,35.8,0.27,144,67768,70,NULL,NULL,'SDSS J170627.25+343011.7',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000171,NULL,'15.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,256.6135417,34.50325,0.081,NULL,56341466738,880335417,13755240,15.6),(140405,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140405,38.12,0.19,420,67769,70,NULL,NULL,'2MASX J17062733+3126148',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000164,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,256.613875,31.43753,0.137,NULL,56346176012,880409000,13756390,17.7),(140406,'IRAS','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140406,35.19,0.8,109,67770,75,NULL,'CF, r','UGC 10706',NULL,'1997ApJS..109..333W',1997,1,1.21,NULL,'G',0.000081,NULL,'14.7g',0.55,'Sbc',NULL,NULL,NULL,NULL,1,256.618791667,38.3635,0.129,NULL,59627756197,931683690,14557557,14.7),(140407,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140407,34.9,0.38,95.4,67770,75,NULL,'CF, r, raw','UGC 10706',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140408,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140408,35.06,0.38,103,67770,75,NULL,'CF, r, inv','UGC 10706',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140409,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140409,35.26,0.38,113,67770,75,NULL,'CF, r, cor','UGC 10706',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140410,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140410,37.63,0.27,337,67771,70,NULL,NULL,'2MASX J17062994+3347558',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000179,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,256.6245417,33.79883,0.089,NULL,56341184836,880331013,13755172,18.2),(140411,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140411,37.69,0.33,345,67772,70,NULL,NULL,'2MASX J17063086+6240444',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000082,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,256.628875,62.67897,0.057,NULL,57534467656,898976057,14046500,16.8),(140412,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140412,37.96,0.46,391,67773,70,NULL,NULL,'SDSS J170632.13+644314.4',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000089,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,256.634,64.72069,0.109,NULL,57571512874,899554888,14055545,17.5),(140413,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140413,38.12,0.19,420,67774,70,NULL,NULL,'2MASX J17063297+3124479',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00017,NULL,'16.0g',0.45,'BrClG',NULL,NULL,NULL,NULL,1,256.637333333,31.41336,0.137,NULL,56346181553,880409086,13756391,16),(140414,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140414,37.74,0.46,353,67775,70,NULL,NULL,'2MASX J17063342+3411089',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,256.6392917,34.18575,0.093,NULL,56341991016,880343609,13755368,17.2),(140415,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140415,36,0.23,158,67776,70,NULL,NULL,'UGC 10702',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.000163,NULL,'14.7g',0.6,'Disturbed',NULL,NULL,NULL,NULL,1,256.652125,24.775,0.185,NULL,56187315197,877926799,13717606,14.7),(140416,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140416,36,0.23,158,67777,70,NULL,NULL,'2MASX J17063903+2441155',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000195,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,256.66275,24.68753,0.185,NULL,56187296724,877926511,13717601,16.2),(140417,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140417,37.69,0.33,345,67778,70,NULL,NULL,'2MASX J17064364+6241035',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000097,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,256.682041667,62.68436,0.057,NULL,57534464769,898976012,14046500,17.6),(140418,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140418,36.16,0.65,170,67779,70,NULL,NULL,'2MASX J17064475-6118133',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,256.6862917,-61.30378,0.737,NULL,44468744324,694824130,10856627,15.3),(140419,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140419,37.92,0.46,383,67780,70,NULL,NULL,'2MASX J17064530+3522439',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,256.688791667,35.37889,0.109,NULL,56120073860,876876154,13701189,18.3),(140420,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140420,36.76,0.46,224,67781,70,NULL,NULL,'2MASX J17064532+3110209',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,256.688917,31.17244,0.165,NULL,56346073887,880407404,13756365,18.1),(140421,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140421,37.92,0.46,383,67782,70,NULL,NULL,'2MASX J17064771+5912297',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000086,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,256.698583,59.20811,0.009,NULL,57704527202,901633237,14088019,17.3),(140422,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140422,37.77,0.46,357,67783,70,NULL,NULL,'2MASX J17065165+3919346',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,256.715125,39.32636,0.121,NULL,59642082944,931907546,14561055,17.6),(140423,'SNII optical','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2000bs',NULL,140423,34.71,0.31,82.8,67784,NULL,NULL,'SEAM','UGC 10710',0.027976,'2009ApJ...694.1067P',2009,1,1.5,NULL,'G',0.0001,NULL,'15.03',0.4,'Sb','Group member',NULL,NULL,NULL,1,256.718833333,43.12219,0,NULL,59645092701,931954573,14561790,15.03),(140424,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140424,35.05,0.49,102,67784,75,NULL,'IR','UGC 10710',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140425,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140425,35.25,0.47,112,67784,NULL,NULL,'H','UGC 10710',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140426,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140426,35.35,0.2,117,67784,74.4,NULL,NULL,'UGC 10710',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140427,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140427,35.4,0.4,120,67784,NULL,NULL,'mean','UGC 10710',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140428,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140428,35.41,0.45,121,67784,NULL,NULL,'K','UGC 10710',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140429,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140429,35.45,0.46,123,67784,NULL,NULL,'J','UGC 10710',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140430,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140430,36.52,0.46,201,67785,70,NULL,NULL,'2MASX J17065329+2009591',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000175,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,256.722,20.16653,0.293,NULL,56867553203,888555518,13883679,16.6),(140431,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140431,36.92,0.46,242,67786,70,NULL,NULL,'2MASX J17065562+2047451',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'17.01',0.31,NULL,NULL,NULL,NULL,NULL,1,256.7317083,20.79597,0.293,NULL,56871715112,888620548,13884696,17.01),(140432,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140432,36.47,0.61,197,67787,70,NULL,NULL,'2MASX J17065784-6524463',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,256.740917,-65.41289,0.373,NULL,44480719784,695011246,10859550,15.6),(140433,'IRAS','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140433,31.12,0.8,16.7,67788,75,NULL,'MAT, I','ESO 138- G 014',NULL,'1997ApJS..109..333W',1997,1,6.16,'The 2MASX position is strongly weighted by a superposed star.','G',0.00001,NULL,'13.20',0.56,'SB(s)d: sp',NULL,NULL,NULL,NULL,1,256.74675,-62.08286,0.557,NULL,44470592647,694853010,10857078,13.2),(140434,'IRAS','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140434,31.12,0.8,16.7,67788,75,NULL,'A82, H','ESO 138- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140435,'Tully est','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140435,31.45,0.8,19.5,67788,75,NULL,NULL,'ESO 138- G 014',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140436,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140436,30.98,0.39,15.7,67788,73,NULL,'IR','ESO 138- G 014',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140437,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140437,30.98,0.4,15.7,67788,75,NULL,NULL,'ESO 138- G 014',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140438,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140438,31.01,0.47,15.9,67788,75,NULL,'A82, H, inv','ESO 138- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140439,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140439,31.09,0.47,16.5,67788,75,NULL,'A82, H, raw','ESO 138- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140440,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140440,31.21,NULL,17.5,67788,NULL,NULL,'Dipole','ESO 138- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140441,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140441,31.21,NULL,17.5,67788,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 138- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140442,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140442,31.22,NULL,17.5,67788,NULL,NULL,'Dipole + Quadrupole','ESO 138- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140443,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140443,31.29,NULL,18.1,67788,NULL,NULL,NULL,'ESO 138- G 014',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140444,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140444,31.52,0.47,20.1,67788,75,NULL,'A82, H, cor','ESO 138- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140445,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140445,31.54,0.43,20.3,67788,75,NULL,'3.6 micron, color + selection bias corrected','ESO 138- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140446,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140446,31.55,0.35,20.4,67788,NULL,NULL,NULL,'ESO 138- G 014',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140447,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140447,31.69,0.4,21.8,67788,NULL,NULL,'mean','ESO 138- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140448,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140448,31.77,0.49,22.6,67788,75,NULL,'IR','ESO 138- G 014',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140449,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140449,31.94,0.43,24.5,67788,75,NULL,'3.6 micron, color corrected','ESO 138- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140450,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140450,32.22,0.2,27.8,67788,74.4,NULL,NULL,'ESO 138- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140451,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140451,32.25,0.46,28.2,67788,NULL,NULL,'J','ESO 138- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140452,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140452,32.32,0.47,29.2,67788,NULL,NULL,'H','ESO 138- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140453,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140453,32.53,0.45,32.1,67788,NULL,NULL,'K','ESO 138- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140454,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140454,33.23,0.32,44.2,67788,85,NULL,'I, inv','ESO 138- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140455,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140455,33.23,0.32,44.3,67788,85,NULL,'I, raw','ESO 138- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140456,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140456,33.41,0.43,48,67788,75,NULL,'MAT, I, raw','ESO 138- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140457,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140457,33.45,0.43,49,67788,75,NULL,'MAT, I, inv','ESO 138- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140458,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140458,33.72,0.43,55.5,67788,75,NULL,'MAT, I, cor','ESO 138- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140459,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140459,38.12,0.19,420,67789,70,NULL,NULL,'2MASX J17070007+3120019',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,256.750333,31.33389,0.145,NULL,56346238166,880409971,13756405,18.3),(140460,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140460,37.99,0.46,396,67790,70,NULL,NULL,'2MASX J17070028+3453049',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,256.7512917,34.88475,0.093,NULL,56341352221,880333628,13755212,17.2),(140461,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140461,35.82,0.46,146,67791,70,NULL,NULL,'2MASX J17070158+6111525',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000074,NULL,'15.8g',0.51,NULL,NULL,NULL,NULL,NULL,1,256.756875,61.19806,0.037,NULL,57533696602,898964009,14046312,15.8),(140462,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140462,37.27,0.46,284,67792,70,NULL,NULL,'2MASX J17070588+3457111',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,256.7744583,34.95325,0.093,NULL,56341364387,880333818,13755215,16.8),(140463,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140463,35.8,0.27,144,67793,70,NULL,NULL,'CGCG 197-038',NULL,'2015arXiv151105856S',2015,1,0.93,NULL,'G',0.000172,NULL,'15.1g',0.6,'E0',NULL,NULL,NULL,NULL,1,256.777041667,34.23469,0.113,NULL,56341131191,880330174,13755158,15.1),(140464,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140464,35.96,0.49,155,67794,75,NULL,'IR','FGC 2109',NULL,'2011yCatp016004901K',2011,1,1.46,NULL,'G',0.000017,NULL,'16.4',0.11,'Sc',NULL,NULL,NULL,NULL,1,256.779875,8.92686,0.301,NULL,56003910928,875061108,13672829,16.4),(140465,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140465,36.01,NULL,160,67794,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2109',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140466,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140466,36.02,NULL,160,67794,NULL,NULL,'Dipole + Quadrupole','FGC 2109',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140467,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140467,36.02,NULL,160,67794,NULL,NULL,'Dipole','FGC 2109',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140468,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140468,36.13,NULL,168,67794,NULL,NULL,NULL,'FGC 2109',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140469,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140469,36.62,0.43,211,67794,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2109',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140470,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140470,35.8,0.27,144,67795,70,NULL,NULL,'CGCG 197-039',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000147,NULL,'15.4',0.4,'E, with compact core',NULL,NULL,NULL,NULL,1,256.7919583,34.26978,0.113,NULL,56341128164,880330127,13755158,15.4),(140471,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','PTF10qjq',NULL,140471,34.97,0.02,95.9,67796,70,NULL,'SiFTO+SALT2, SN PTF10qjq','PTF10qjq',0.0288,'2012MNRAS.426.2359M',2012,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,256.801625,35.50981,0.109,NULL,56120279917,876879373,13701240,NULL),(140472,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','PTF10qjq',NULL,140472,35.53,0.03,124,67796,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10qjq',0.0288,'2014MNRAS.438.1391P',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140473,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140473,38.82,0.46,580,67797,70,NULL,NULL,'SDSS J170714.05+314404.4',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000161,NULL,'18.7g',0.09,NULL,NULL,NULL,NULL,NULL,1,256.808583,31.73458,0.145,NULL,56345360111,880396251,13756191,18.7),(140474,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140474,36.88,0.46,237,67798,70,NULL,NULL,'ZwCl 1700.5+3322 77',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.2g',0.23,'Red spherical comp.',NULL,NULL,NULL,NULL,1,256.815667,33.27281,0.129,NULL,56353348699,880521073,13758141,17.2),(140475,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140475,35.79,0.46,144,67799,70,NULL,NULL,'ZwCl 1700.5+3322 78',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000174,NULL,'16.4g',0.27,'Neutral patchy comp.',NULL,NULL,NULL,NULL,1,256.820083,33.29539,0.129,NULL,56353348603,880521071,13758141,16.4),(140476,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140476,37.49,0.46,314,67800,70,NULL,NULL,'2MASX J17071750+2751334',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,256.822833,27.85944,0.213,NULL,56314588327,879915442,13748678,17.4),(140477,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140477,37.99,0.33,396,67801,70,NULL,NULL,'2MASX J17071831+3344052',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,256.82625,33.73483,0.089,NULL,56339230065,880300469,13754694,17.7),(140478,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140478,38.06,0.33,409,67802,70,NULL,NULL,'2MASX J17071987+3323193',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,256.83275,33.38867,0.125,NULL,56353334708,880520854,13758138,17.6),(140479,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140479,36.94,0.46,245,67803,70,NULL,NULL,'2MASX J17072125+5941582',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000111,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,256.8384583,59.69969,0.017,NULL,57702027711,901594182,14087409,16.2),(140480,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140480,37.99,0.33,396,67804,70,NULL,NULL,'ZwCl 1700.5+3322 87',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000183,NULL,'17.1g',0.23,'Red spherical comp.',NULL,NULL,NULL,NULL,1,256.839541667,33.68883,0.089,NULL,56339262672,880300979,13754702,17.1),(140481,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140481,37.52,0.46,319,67805,70,NULL,NULL,'ZwCl 1700.5+3322 85',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000161,NULL,'16.9g',0.26,'Red spherical comp.',NULL,NULL,NULL,NULL,1,256.8400417,33.97056,0.113,NULL,56341283319,880332551,13755196,16.9),(140482,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140482,38.06,0.33,409,67806,70,NULL,NULL,'2MASX J17072291+3324483',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,256.845625,33.41347,0.125,NULL,56353118326,880517473,13758085,17.9),(140483,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140483,37.57,0.46,327,67807,70,NULL,NULL,'2MASX J17072431+5805102',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000086,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,256.851208333,58.08611,0,NULL,57703754675,901621166,14087830,17),(140484,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140484,35.12,NULL,106,67808,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10714',NULL,'2010Ap&SS.325..163P',2010,1,1.74,NULL,'G',0.000011,NULL,'15.3g',0.26,'Sb(f)',NULL,NULL,NULL,NULL,1,256.855166667,30.225,0.217,NULL,56359724043,880620688,13759698,15.3),(140485,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140485,35.13,NULL,106,67808,NULL,NULL,'Dipole + Quadrupole','UGC 10714',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140486,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140486,35.14,NULL,107,67808,NULL,NULL,'Dipole','UGC 10714',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140487,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140487,35.19,NULL,109,67808,NULL,NULL,NULL,'UGC 10714',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140488,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140488,35.57,0.2,130,67808,74.4,NULL,NULL,'UGC 10714',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140489,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140489,37.08,0.33,260,67809,70,NULL,NULL,'2MASX J17072546+2155197',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000198,NULL,'16.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,256.85625,21.92225,0.301,NULL,56860562221,888446284,13881973,16.7),(140490,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140490,37.54,0.33,322,67810,70,NULL,NULL,'2MASX J17072866+3050153',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000171,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,256.8694583,30.83753,0.185,NULL,56342463540,880350992,13755484,17.8),(140491,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140491,37.89,0.33,379,67811,70,NULL,NULL,'2MASX J17072902+6323071',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000085,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,256.87075,63.38528,0.053,NULL,57572324588,899567571,14055743,18),(140492,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140492,38.29,0.46,455,67812,70,NULL,NULL,'2MASX J17073851+6049141',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000076,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,256.9107917,60.8205,0.037,NULL,57533351366,898958615,14046228,17.9),(140493,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140493,37.6,0.46,331,67813,70,NULL,NULL,'SDSS J170740.40+612158.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000069,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,256.918416667,61.36622,0.041,NULL,57533749107,898964829,14046325,18.3),(140494,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140494,37.54,0.46,322,67814,70,NULL,NULL,'SDSS J170741.30+653439.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000074,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,256.922125,65.57764,0.113,NULL,57516616270,898697129,14042142,17.9),(140495,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140495,38.11,0.46,419,67815,70,NULL,NULL,'2MASX J17074261+6526572',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000089,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,256.927583,65.44917,0.113,NULL,57571163027,899549422,14055459,17.7),(140496,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140496,35.43,NULL,122,67816,NULL,NULL,'Dipole','UGC 10716',NULL,'2010Ap&SS.325..163P',2010,1,1.3,NULL,'G',0.000018,NULL,'16.0g',0.22,'Sb(f)','Field galaxy',NULL,NULL,NULL,1,256.9355,30.32642,0.177,NULL,56359463857,880616622,13759634,16),(140497,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140497,35.43,NULL,122,67816,NULL,NULL,'Dipole + Quadrupole','UGC 10716',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140498,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140498,35.43,NULL,122,67816,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10716',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140499,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140499,35.53,0.49,128,67816,75,NULL,'IR','UGC 10716',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140500,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140500,35.63,NULL,134,67816,NULL,NULL,NULL,'UGC 10716',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140501,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140501,35.92,0.39,153,67816,NULL,NULL,'Malmquist cor.','UGC 10716',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140502,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140502,35.94,0.2,154,67816,74.4,NULL,NULL,'UGC 10716',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140503,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140503,36.13,0.35,168,67816,NULL,NULL,NULL,'UGC 10716',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140504,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140504,37.58,0.33,329,67817,70,NULL,NULL,'SDSS J170745.22+643631.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000074,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,256.938458333,64.60878,0.085,NULL,57574847721,899606995,14056359,18.1),(140505,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140505,37.53,0.23,321,67818,70,NULL,NULL,'2MASX J17074532+2941233',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00017,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,256.93875,29.68981,0.265,NULL,56359839804,880622496,13759726,17.5),(140506,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140506,38.07,0.46,411,67819,70,NULL,NULL,'2MASX J17074641+3332081',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000141,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,256.943333,33.53572,0.089,NULL,56353154701,880518042,13758094,18),(140507,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 1997ce',NULL,140507,41.83,0.18,1120,67820,65,NULL,'RPK','H-ZSNS J170748.26+440126.2',0.44,'1998ApJ...493L..53G',1998,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,256.951083,44.02394,0,NULL,59644375191,931943362,14561615,NULL),(140508,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 1997ce',NULL,140508,42.06,0.19,1250,67820,65,NULL,'H96','H-ZSNS J170748.26+440126.2',0.44,'1998ApJ...493L..53G',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140509,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 1997ce','R',140509,41.32,NULL,1280,67820,65,NULL,'SALT','H-ZSNS J170748.26+440126.2',0.44,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140510,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 1997ce',NULL,140510,41.34,0.33,1290,67820,74.2,NULL,'SALT 2','H-ZSNS J170748.26+440126.2',0.44,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140511,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 1997ce',NULL,140511,41.95,0.17,1700,67820,65,NULL,'MLCS','H-ZSNS J170748.26+440126.2',0.44,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140512,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 1997ce',NULL,140512,42.02,0.29,1760,67820,70,NULL,'SALT','H-ZSNS J170748.26+440126.2',0.44,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140513,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 1997ce',NULL,140513,42.08,0.19,1810,67820,65,NULL,NULL,'H-ZSNS J170748.26+440126.2',0.44,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140514,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 1997ce',NULL,140514,42.2,0.28,1910,67820,65,NULL,'SALT','H-ZSNS J170748.26+440126.2',0.44,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140515,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 1997ce',NULL,140515,42.26,0.16,1970,67820,65,NULL,'Template','H-ZSNS J170748.26+440126.2',0.44,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140516,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140516,37.29,0.46,287,67821,70,NULL,NULL,'2MASX J17075014+2958582',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000154,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,256.958833,29.98292,0.233,NULL,56359858156,880622783,13759730,17.4),(140517,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140517,37.53,0.23,321,67822,70,NULL,NULL,'2MASX J17075185+2945436',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000198,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,256.9662083,29.76211,0.233,NULL,56359845097,880622579,13759727,16.3),(140518,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140518,37.39,0.46,300,67823,70,NULL,NULL,'2MASX J17075227+3017032',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000174,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,256.967917,30.28422,0.177,NULL,56359512400,880617381,13759646,16.9),(140519,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140519,37.54,0.33,322,67824,70,NULL,NULL,'2MASX J17075252+3052002',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,256.96875,30.86686,0.185,NULL,56342459900,880350935,13755483,17.6),(140520,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140520,37.53,0.23,321,67825,70,NULL,NULL,'2MASX J17075638+2944036',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,256.9849583,29.73444,0.193,NULL,56359843386,880622552,13759727,17.3),(140521,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140521,37.53,0.23,321,67826,70,NULL,NULL,'2MASX J17075677+2947036',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000168,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,256.986667,29.78431,0.233,NULL,56359832672,880622385,13759724,16.6),(140522,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140522,37.25,0.46,282,67827,70,NULL,NULL,'2MASX J17075742+6249481',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000083,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,256.989417,62.82997,0.057,NULL,57564778383,899449662,14053900,17.4),(140523,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140523,33.75,0.49,56.2,67828,75,NULL,'IR','NGC 6310',NULL,'2011yCatp016004901K',2011,1,1.99,NULL,'G',0.000067,NULL,'13.6g',0.55,'Sb: sp',NULL,NULL,NULL,NULL,1,256.9894583,60.99017,0.037,NULL,57534247550,898972617,14046447,13.6),(140524,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140524,37.89,0.33,379,67829,70,NULL,NULL,'2MASX J17075893+6321411',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000099,NULL,'16.2g',0.41,'BrClG',NULL,NULL,NULL,NULL,1,256.995667,63.36131,0.053,NULL,57572326140,899567595,14055743,16.2),(140525,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140525,37.81,0.33,364,67830,70,NULL,NULL,'2MASX J17080230+5825597',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,257.00975,58.43325,0,NULL,57703929082,901623891,14087873,17.8),(140526,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140526,36.01,0.46,159,67831,70,NULL,NULL,'2MASX J17080280+2207212',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000174,NULL,'15.7g',0.36,NULL,NULL,NULL,NULL,NULL,1,257.011833333,22.12256,0.289,NULL,56860397598,888443712,13881933,15.7),(140527,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140527,30.44,0.4,12.2,67832,75,NULL,'B','UGC 10736',NULL,'1988NBGC.C....0000T',1988,1,3.1,NULL,'G',0.00002,NULL,'14.5',0.9,'SABdm',NULL,NULL,NULL,NULL,1,257.020833,69.46389,0.165,NULL,57786250848,902910169,14107971,14.5),(140528,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140528,33.33,0.56,46.4,67833,70,NULL,NULL,'2MASX J17080654-6327194',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000029,NULL,'13.5R',NULL,'Sap',NULL,NULL,NULL,NULL,1,257.02725,-63.45536,0.573,NULL,44482900434,695045319,10860083,13.5),(140529,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140529,36.03,0.55,161,67834,70,NULL,NULL,'2MASX J17080770-0130526',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00011,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,257.032167,-1.51461,0.665,NULL,45213579347,706462177,11038471,15.3),(140530,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140530,36.59,0.46,208,67835,70,NULL,NULL,'2MASX J17080886+2136202',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000191,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,257.036958333,21.60567,0.269,NULL,56860490768,888445168,13881955,16.8),(140531,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140531,38.63,0.46,533,67836,70,NULL,NULL,'2MASX J17080919+6310031',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000093,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,257.038458333,63.16747,0.057,NULL,57572093762,899563965,14055686,17.9),(140532,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140532,36.1,0.46,166,67837,70,NULL,NULL,'2MASX J17081862+3024099',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000178,NULL,'16.1g',0.4,'E/S0',NULL,NULL,NULL,NULL,1,257.077667,30.40278,0.177,NULL,56359496529,880617133,13759642,16.1),(140533,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140533,37.81,0.33,364,67838,70,NULL,NULL,'2MASX J17082154+5831558',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00009,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,257.089917,58.53208,0,NULL,57703471848,901616747,14087761,17.3),(140534,'IRAS','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140534,33.11,0.8,41.9,67839,75,NULL,'CF, r','UGC 10721',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000017,NULL,'14.45',0.5,'Scd?',NULL,NULL,NULL,NULL,1,257.1064583,25.51739,0.173,NULL,56308004053,879812563,13747071,14.45),(140535,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140535,32.38,0.69,29.9,67839,100,NULL,'mid-IR','UGC 10721',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140536,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140536,33.29,0.43,45.4,67839,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10721',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140537,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140537,33.3,0.38,45.8,67839,75,NULL,'CF, r, raw','UGC 10721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140538,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140538,33.33,0.4,46.3,67839,NULL,NULL,'mean','UGC 10721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140539,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140539,33.38,0.38,47.5,67839,75,NULL,'CF, r, inv','UGC 10721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140540,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140540,33.53,0.38,50.8,67839,75,NULL,'CF, r, cor','UGC 10721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140541,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140541,33.57,0.47,51.7,67839,NULL,NULL,'H','UGC 10721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140542,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140542,33.6,0.46,52.5,67839,NULL,NULL,'J','UGC 10721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140543,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140543,33.64,0.45,53.5,67839,NULL,NULL,'K','UGC 10721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140544,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140544,36.72,0.46,221,67840,70,NULL,NULL,'2MASX J17082742+6204483',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000065,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,257.114416667,62.07992,0.049,NULL,57565149754,899455464,14053991,17.4),(140545,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140545,34.43,0.69,76.9,67841,100,NULL,'mid-IR','NGC 6301',NULL,'2013ApJ...771...88L',2013,1,1.78,NULL,'G',0.000033,NULL,'14.0g',0.87,'Scd:',NULL,NULL,NULL,NULL,1,257.136417,42.33911,0.037,NULL,59644097274,931939019,14561547,14),(140546,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140546,34.94,0.2,97.3,67841,74.4,NULL,NULL,'NGC 6301',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140547,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140547,35.41,0.4,121,67841,NULL,NULL,'mean','NGC 6301',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140548,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140548,35.45,0.47,123,67841,NULL,NULL,'H','NGC 6301',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140549,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140549,35.5,0.46,126,67841,NULL,NULL,'J','NGC 6301',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140550,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140550,35.6,0.45,132,67841,NULL,NULL,'K','NGC 6301',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140551,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140551,37.8,0.13,363,67842,70,NULL,NULL,'2MASX J17083480+3415310',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,257.145125,34.25869,0.109,NULL,56340672705,880323011,13755047,17.9),(140552,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140552,37.08,0.33,260,67843,70,NULL,NULL,'2MASX J17083647+2146536',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000166,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,257.152,21.7815,0.269,NULL,56792570553,887383914,13865373,16.5),(140553,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140553,37.82,0.46,367,67844,70,NULL,NULL,'2MASX J17083661+3953556',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,257.1525,39.89886,0.109,NULL,59642426210,931912909,14561139,17.1),(140554,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140554,37.58,0.33,329,67845,70,NULL,NULL,'VII Zw 682',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000083,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,257.1625,64.60339,0.085,NULL,57574876698,899607448,14056366,16.9),(140555,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140555,37.91,0.46,382,67846,70,NULL,NULL,'2MASX J17083941+3425370',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000137,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,257.1642083,34.42706,0.109,NULL,56340655993,880322749,13755042,18.2),(140556,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140556,36.15,0.46,170,67847,70,NULL,NULL,'2MASX J17084165+6011124',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000066,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,257.173417,60.18683,0.037,NULL,57654949919,900858592,14075915,17.5),(140557,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140557,38.09,0.27,415,67848,70,NULL,NULL,'2MASX J17084174+3327040',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,257.173917,33.451,0.125,NULL,56353638902,880525607,13758212,17.5),(140558,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140558,38.09,0.27,415,67849,70,NULL,NULL,'2MASX J17084254+3327290',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,257.177333333,33.458,0.125,NULL,56353638736,880525605,13758212,17.8),(140559,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140559,37.8,0.13,363,67850,70,NULL,NULL,'2MASX J17084272+3424210',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00016,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,257.178208333,34.40592,0.109,NULL,56340654569,880322727,13755042,17.6),(140560,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140560,37.8,0.13,363,67851,70,NULL,NULL,'2MASX J17084396+3413552',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,257.183333,34.23192,0.113,NULL,56340667064,880322922,13755045,17.3),(140561,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140561,35.02,0.4,101,67852,NULL,NULL,'mean','NGC 6296',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000013,NULL,'14.20',0.8,'SAB(s)bc:',NULL,NULL,NULL,NULL,1,257.1852917,3.89408,0.333,NULL,55991486730,874866980,13669796,14.2),(140562,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140562,35.18,0.45,108,67852,NULL,NULL,'K','NGC 6296',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140563,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140563,35.2,0.47,110,67852,NULL,NULL,'H','NGC 6296',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140564,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140564,35.3,0.46,115,67852,NULL,NULL,'J','NGC 6296',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140565,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140565,36.77,0.73,226,67853,70,NULL,NULL,'2MASX J17084515-7808566',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,257.188,-78.14914,0.461,NULL,44126215381,689472115,10773001,16.4),(140566,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140566,37.8,0.13,363,67854,70,NULL,NULL,'2MASX J17084929+3411352',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000155,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,257.2052083,34.19325,0.113,NULL,56340735396,880323990,13755062,17.3),(140567,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140567,38.09,0.27,415,67855,70,NULL,NULL,'2MASX J17085575+3331303',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,257.2322917,33.52519,0.089,NULL,56353649022,880525765,13758215,17.6),(140568,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140568,37.4,0.46,302,67856,70,NULL,NULL,'2MASX J17085825+3949077',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,257.24275,39.81889,0.109,NULL,59642471215,931913612,14561150,17),(140569,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140569,36.08,0.46,164,67857,70,NULL,NULL,'KAZ 452',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000086,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,257.247417,60.82311,0.037,NULL,57533398882,898959357,14046239,16.6),(140570,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140570,36.69,0.46,217,67858,70,NULL,NULL,'KUG 1707+280',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',NULL,NULL,'15.7g',0.42,'Spiral',NULL,NULL,NULL,NULL,1,257.254833,27.97214,0.153,NULL,56314166268,879908847,13748575,15.7),(140571,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140571,37.59,0.46,330,67859,70,NULL,NULL,'2MASX J17090129+5937252',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000094,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,257.255333,59.62369,0.041,NULL,57701912977,901592390,14087381,16.9),(140572,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140572,37.16,0.46,271,67860,70,NULL,NULL,'2MASX J17090580+3944237',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,257.274167,39.73983,0.109,NULL,59642368665,931912010,14561125,NULL),(140573,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140573,36.28,0.47,180,67861,NULL,NULL,'Malmquist cor.','2MASX J17090975+7852317',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.00003,NULL,'15.9V',NULL,'SF','Group member',NULL,NULL,NULL,1,257.291208333,78.87547,0.177,NULL,57129555742,892649308,13947645,15.9),(140574,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140574,36.34,0.45,186,67861,NULL,NULL,NULL,'2MASX J17090975+7852317',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140575,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140575,36.38,0.2,189,67861,74.4,NULL,NULL,'2MASX J17090975+7852317',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140576,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140576,37.8,0.13,363,67862,70,NULL,NULL,'2MASX J17091362+3434332',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000171,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,257.30675,34.57603,0.101,NULL,56340839861,880325622,13755087,16.6),(140577,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140577,35.23,0.2,111,67863,74.4,NULL,NULL,'UGC 10729',NULL,'2013AJ....146...86T',2013,1,0.79,NULL,'G',0.000005,NULL,'15.6g',0.34,'Sdm:           HII',NULL,NULL,NULL,NULL,1,257.3210417,31.6165,0.149,NULL,56345375759,880396496,13756195,15.6),(140578,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140578,36.84,0.46,233,67864,70,NULL,NULL,'2MASX J17091809+6026552',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000081,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,257.325333,60.44875,0.029,NULL,57533324036,898958188,14046221,16.8),(140579,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140579,37.8,0.13,363,67865,70,NULL,NULL,'2MASX J17091903+3430439',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000187,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,257.329417,34.51217,0.101,NULL,56340801607,880325025,13755078,17.4),(140580,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140580,37.92,0.33,383,67866,70,NULL,NULL,'SDSS J170919.35+565833.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000075,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,257.330667,56.97594,0,NULL,57698341103,901536579,14086509,18.4),(140581,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140581,37.92,0.33,383,67867,70,NULL,NULL,'2MASX J17092071+5700022',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000079,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,257.336375,57.00061,0,NULL,57698296234,901535878,14086498,17.9),(140582,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140582,37.8,0.13,363,67868,70,NULL,NULL,'2MASX J17092101+3423089',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000193,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,257.337666667,34.38589,0.109,NULL,56340692937,880323327,13755051,16.4),(140583,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','PTF10iyc','N',140583,37.13,0.01,252,67869,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10iyc',0.0594,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140584,'IRAS','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140584,34.22,0.8,70,67870,75,NULL,'MAT, I','ESO 044- G 001',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000025,NULL,'12.91',0.9,'SAB(s)c',NULL,NULL,NULL,NULL,1,257.344,-73.32092,0.193,NULL,44153834778,689903668,10779744,12.91),(140585,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140585,33.54,0.32,51.1,67870,85,NULL,'I, raw','ESO 044- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140586,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140586,33.57,0.32,51.8,67870,85,NULL,'I, inv','ESO 044- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140587,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140587,33.68,0.43,54.4,67870,75,NULL,'MAT, I, raw','ESO 044- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140588,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140588,33.84,0.43,58.6,67870,75,NULL,'MAT, I, inv','ESO 044- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140589,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140589,33.97,0.43,62.3,67870,75,NULL,'MAT, I, cor','ESO 044- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140590,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140590,34.42,0.44,76.5,67870,NULL,NULL,NULL,'ESO 044- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140591,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140591,34.46,0.2,78,67870,74.4,NULL,NULL,'ESO 044- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140592,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140592,34.48,0.43,78.7,67870,NULL,NULL,'Malmquist cor.','ESO 044- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140593,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140593,37.14,0.46,268,67871,70,NULL,NULL,'2MASX J17092260+3814342',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,257.344167,38.24289,0.157,NULL,59627343320,931677239,14557456,17.1),(140594,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140594,37.8,0.13,363,67872,70,NULL,NULL,'SDSS J170924.93+343146.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,257.353917,34.52953,0.101,NULL,56340803594,880325056,13755079,18.4),(140595,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140595,38.29,0.46,456,67873,70,NULL,NULL,'2MASX J17092603+2755321',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,257.35825,27.92553,0.153,NULL,56314273271,879910519,13748601,17.7),(140596,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140596,36.87,0.46,236,67874,70,NULL,NULL,'2MASX J17093032+2336244',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000157,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,257.376417,23.60675,0.221,NULL,56791048030,887360125,13865001,17.2),(140597,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140597,37.8,0.13,363,67875,70,NULL,NULL,'2MASX J17093126+3424189',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000201,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,257.3802083,34.40517,0.109,NULL,56340679727,880323120,13755048,16.5),(140598,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140598,37.8,0.13,363,67876,70,NULL,NULL,'2MASX J17093207+3426230',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,'FoF','17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,257.3837083,34.43958,0.109,NULL,56340677819,880323090,13755048,17.1),(140599,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140599,37.13,0.33,266,67877,70,NULL,NULL,'SDSS J170934.93+320022.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000163,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,257.395583333,32.00633,0.165,NULL,56343413400,880365834,13755716,18.5),(140600,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140600,35.99,0.61,158,67878,70,NULL,NULL,'2MASX J17093512-7055263',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,257.396375,-70.92403,0.433,NULL,44097132892,689017701,10765901,15.2),(140601,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140601,37.92,0.46,384,67879,70,NULL,NULL,'2MASX J17093599+3159300',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00015,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,257.4,31.99161,0.165,NULL,56343413723,880365839,13755716,17.4),(140602,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140602,37.8,0.13,363,67880,70,NULL,NULL,'2MASXi J1709365+342502',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000169,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,257.402583,34.41742,0.109,NULL,56340680564,880323133,13755048,18.1),(140603,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140603,37.67,0.46,342,67881,70,NULL,NULL,'2MASX J17093809+5747513',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000073,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,257.4085,57.79753,0,NULL,57703276221,901613690,14087713,17.3),(140604,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140604,38.43,0.46,485,67882,70,NULL,NULL,'2MASX J17093832+3314460',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,257.409667,33.24622,0.141,NULL,56353744592,880527259,13758238,17.9),(140605,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140605,36.77,0.44,226,67883,NULL,NULL,'Malmquist cor.','2MASX J17093986+7833067',NULL,'2009ApJS..182..474S',2009,1,0.56,NULL,'G',0.000023,NULL,'15.73',NULL,'S','Group member',NULL,NULL,NULL,1,257.414583,78.55219,0.197,NULL,57128633292,892634895,13947420,15.73),(140606,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140606,37,0.4,251,67883,NULL,NULL,NULL,'2MASX J17093986+7833067',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140607,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140607,37.04,0.2,256,67883,74.4,NULL,NULL,'2MASX J17093986+7833067',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140608,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140608,33.95,0.2,61.7,67884,74.4,NULL,NULL,'UGC 10732',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000073,NULL,'15.16',0.7,'Scd:',NULL,NULL,NULL,NULL,1,257.42725,36.41481,0.185,NULL,56123338534,876927164,13701986,15.16),(140609,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140609,36.75,0.33,224,67885,70,NULL,NULL,'2MASX J17094311+3040590',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,257.429625,30.68297,0.149,NULL,56359449404,880616396,13759631,17.2),(140610,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140610,38.17,0.46,430,67886,70,NULL,NULL,'2MASX J17094354+2925191',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000159,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,257.4315417,29.42192,0.185,NULL,56313277214,879894956,13748358,18.5),(140611,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140611,37.8,0.13,363,67887,70,NULL,NULL,'2MASX J17094371+3424260',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000207,NULL,'16.2g',0.41,'BrClG',NULL,NULL,NULL,NULL,1,257.432333,34.40708,0.109,NULL,56340677335,880323083,13755048,16.2),(140612,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140612,37.45,0.46,309,67888,70,NULL,NULL,'2MASX J17094527+3044030',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000144,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,257.4387083,30.73428,0.149,NULL,56359392341,880615505,13759617,17.4),(140613,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140613,38.24,0.46,445,67889,70,NULL,NULL,'SDSS J170948.50+653003.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000071,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,257.452125,65.50094,0.113,NULL,57517413739,898709589,14042337,18.3),(140614,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140614,36.16,0.46,171,67890,70,NULL,NULL,'2MASX J17095391+6243192',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000066,NULL,'16.2g',0.32,NULL,NULL,NULL,NULL,NULL,1,257.4744583,62.72208,0.073,NULL,57564950422,899452350,14053942,16.2),(140615,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140615,37.8,0.13,363,67891,70,NULL,NULL,'2MASX J17095548+3418157',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000173,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,257.481166667,34.30436,0.109,NULL,56340719257,880323738,13755058,16.8),(140616,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140616,36.8,0.82,229,67892,70,NULL,NULL,'2MASX J17095629-8214119',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,257.484167,-82.23661,0.321,NULL,44056836111,688388064,10756063,17),(140617,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140617,37.85,0.46,372,67893,70,NULL,NULL,'2MASX J17095632+3931026',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,257.484625,39.51736,0.117,NULL,59641280105,931895001,14560859,17.3),(140618,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140618,38.43,0.46,486,67894,70,NULL,NULL,'2MASX J17100263+3252567',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000161,NULL,'18.3g',0.09,NULL,NULL,NULL,NULL,NULL,1,257.510833,32.88258,0.193,NULL,56354054519,880532101,13758314,18.3),(140619,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140619,38.63,0.46,531,67895,70,NULL,NULL,'2MASX J17100518+5641464',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000086,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,257.5217917,56.69625,0,NULL,57698728284,901542629,14086603,18.3),(140620,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140620,35.39,0.46,120,67896,70,NULL,NULL,'UGC 10733',NULL,'2015arXiv151105856S',2015,1,0.98,NULL,'G',0.00013,NULL,'14.5g',0.64,'E',NULL,NULL,NULL,NULL,1,257.5227083,32.49992,0.177,NULL,56353939545,880530305,13758286,14.5),(140621,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140621,38.09,0.46,415,67897,70,NULL,NULL,'2MASX J17100563+2650012',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,257.5235417,26.83364,0.165,NULL,56318400152,879975002,13749609,17.5),(140622,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140622,37.13,0.33,266,67898,70,NULL,NULL,'2MASX J17100646+3159487',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,257.526917,31.997,0.165,NULL,56343640421,880369381,13755771,16.8),(140623,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140623,35.49,0.49,125,67899,75,NULL,'IR','UGC 10735',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',NULL,NULL,'16.5',0.2,'Scd(f)',NULL,NULL,NULL,NULL,1,257.532917,32.29419,0.169,NULL,56343405394,880365709,13755714,16.5),(140624,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140624,37.61,0.46,333,67900,70,NULL,NULL,'2MASX J17100823+6403101',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000086,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,257.5339583,64.05292,0.057,NULL,57572736499,899574007,14055843,17.3),(140625,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140625,36.75,0.33,224,67901,70,NULL,NULL,'2MASX J17100828+3049528',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000185,NULL,'15.8g',0.4,'E0',NULL,NULL,NULL,NULL,1,257.5345,30.83142,0.149,NULL,56359389690,880615463,13759616,15.8),(140626,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140626,33.47,0.43,49.5,67902,75,NULL,'3.6 micron, color corrected','IC 1251',NULL,'2014MNRAS.444..527S',2014,1,1.4,NULL,'G',0.000007,NULL,'14.23',1,'Scd:','is a companion galaxy',NULL,NULL,NULL,1,257.55375,72.4105,0.185,NULL,57053465747,891460402,13929068,14.23),(140627,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140627,33.56,0.43,51.4,67902,75,NULL,'3.6 micron, color + selection bias corrected','IC 1251',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140628,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140628,36.07,0.46,163,67903,70,NULL,NULL,'CGCG 169-053',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.0002,NULL,'15.5g',0.49,'E0',NULL,NULL,NULL,NULL,1,257.567917,32.24011,0.169,NULL,56343452035,880366438,13755725,15.5),(140629,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140629,31.71,0.4,22,67904,75,NULL,'B','NGC 6340',NULL,'1988NBGC.C....0000T',1988,1,3.2,NULL,'G',0.00002,NULL,'11.87',3,'SA(s)0/a       LINER','Parent (of companion) galaxy',NULL,NULL,NULL,1,257.6035417,72.30444,0.197,NULL,57053486322,891460723,13929073,11.87),(140630,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140630,38.11,0.46,419,67905,70,NULL,NULL,'2MASX J17102570+4105086',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,257.6072083,41.08578,0.057,NULL,59639662509,931869726,14560464,17.1),(140631,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140631,38.35,0.46,468,67906,70,NULL,NULL,'SDSS J171026.20+565430.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000064,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,257.609167,56.90842,0,NULL,57698864004,901544750,14086636,18.4),(140632,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140632,37.75,0.33,355,67907,70,NULL,NULL,'2MASX J17103027+3052286',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,257.626166667,30.87456,0.109,NULL,56362272937,880660514,13760320,17.7),(140633,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140633,38.03,0.33,404,67908,70,NULL,NULL,'2MASX J17103079+2747576',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,257.628333,27.79939,0.153,NULL,56314084267,879907566,13748555,NULL),(140634,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140634,35.95,0.57,155,67909,70,NULL,NULL,'2MASX J17103094-2338399',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,257.628917,-23.64433,NULL,NULL,46004048652,718813260,11231457,15.8),(140635,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140635,36.75,0.47,224,67910,NULL,NULL,'Malmquist cor.','2MASX J17103123+7829094',NULL,'2009ApJS..182..474S',2009,1,0.41,NULL,'G',0.000027,NULL,'16.54',NULL,'Sbc',NULL,NULL,NULL,NULL,1,257.63,78.48619,0.197,NULL,57128626786,892634793,13947418,16.54),(140636,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140636,36.97,0.43,248,67910,NULL,NULL,NULL,'2MASX J17103123+7829094',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140637,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140637,37.01,0.2,252,67910,74.4,NULL,NULL,'2MASX J17103123+7829094',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140638,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140638,38.21,0.33,439,67911,70,NULL,NULL,'SDSS J171031.57+332924.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000137,NULL,'18.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,257.6315417,33.49019,0.121,NULL,56353793735,880528027,13758250,18),(140639,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140639,38.21,0.33,439,67912,70,NULL,NULL,'2MASX J17103221+3329066',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,257.634083,33.48525,0.121,NULL,56353794019,880528031,13758250,17.1),(140640,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140640,37.69,0.07,345,67913,70,NULL,NULL,'2MASX J17103314+6357425',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000087,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,257.638041667,63.96172,0.085,NULL,57572858516,899575914,14055873,16.6),(140641,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140641,37.75,0.33,355,67914,70,NULL,NULL,'2MASX J17103462+3050246',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,257.644333,30.84036,0.149,NULL,56362286610,880660728,13760323,17.8),(140642,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140642,37.45,0.46,310,67915,70,NULL,NULL,'2MASX J17103643+3139446',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000167,NULL,'16.7g',0.35,NULL,NULL,NULL,NULL,NULL,1,257.651917,31.6625,0.133,NULL,56343980105,880374689,13755854,16.7),(140643,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140643,38.44,0.46,488,67916,70,NULL,NULL,'2MASX J17103685+5933242',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000088,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,257.6535,59.55675,0.041,NULL,57701903434,901592241,14087378,17.9),(140644,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140644,34.81,0.69,91.8,67917,70,NULL,NULL,'2MASX J17103933-0026464',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000117,NULL,'13.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,257.663917,-0.44617,0.565,NULL,45201716382,706276818,11035575,13.6),(140645,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140645,38.03,0.33,404,67918,70,NULL,NULL,'2MASX J17103817+2746226',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,257.6687083,27.77556,0.153,NULL,56318523212,879976925,13749639,17.5),(140646,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140646,37.42,0.33,304,67919,70,NULL,NULL,'2MASX J17104538+3942387',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,257.68925,39.71089,0.109,NULL,59641197031,931893703,14560839,17.4),(140647,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140647,37.69,0.07,345,67920,70,NULL,NULL,'2MASX J17104548+6345485',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000075,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,257.6897083,63.76364,0.085,NULL,57572894396,899576474,14055882,17),(140648,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140648,37.4,0.27,301,67921,70,NULL,NULL,'2MASX J17104615+3009387',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000148,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,257.692458333,30.16092,0.193,NULL,56362667313,880666676,13760416,17.2),(140649,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140649,35.43,0.63,122,67922,70,NULL,NULL,'2MASX J17104740-0021203',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,257.697583333,-0.35567,0.565,NULL,45198311541,706223617,11034744,15),(140650,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140650,36.82,0.46,232,67923,70,NULL,NULL,'2MASX J17104780+4409411',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,257.69925,44.16153,0.009,NULL,59658975978,932171499,14565179,16.9),(140651,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140651,35.5,0.46,126,67924,70,NULL,NULL,'2MASX J17104921+3108187',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000182,NULL,'15.7g',0.33,'E0',NULL,NULL,NULL,NULL,1,257.705083,31.13844,0.121,NULL,56343721210,880370643,13755791,15.7),(140652,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140652,35.2,0.49,110,67925,75,NULL,'IR','UGC 10746',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.00009,NULL,'16.5',0.12,'Sc',NULL,NULL,NULL,NULL,1,257.707333,45.85419,0.013,NULL,59657501784,932148465,14564819,16.5),(140653,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140653,35.68,NULL,137,67925,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10746',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140654,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140654,35.7,NULL,138,67925,NULL,NULL,'Dipole + Quadrupole','UGC 10746',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140655,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140655,35.71,NULL,139,67925,NULL,NULL,'Dipole','UGC 10746',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140656,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140656,35.72,NULL,140,67925,NULL,NULL,NULL,'UGC 10746',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140657,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140657,35.57,0.46,130,67926,70,NULL,NULL,'2MASX J17105085+6119295',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000082,NULL,'15.8g',0.39,NULL,NULL,NULL,NULL,NULL,1,257.712125,61.32494,0.041,NULL,57563392117,899428001,14053562,15.8),(140658,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140658,37.69,0.07,345,67927,70,NULL,NULL,'VII Zw 685',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000073,NULL,'17.3g',0.22,'LINER',NULL,NULL,NULL,'Sy 2',1,257.718833333,63.65478,0.081,NULL,57573074896,899579295,14055926,17.3),(140659,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140659,37.69,0.07,345,67928,70,NULL,NULL,'2MASX J17105351+6403045',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000079,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,257.7230417,64.05133,0.057,NULL,57572722212,899573784,14055840,17.4),(140660,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140660,37.39,0.46,300,67929,70,NULL,NULL,'2MASX J17105622+2141472',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000183,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,257.734167,21.69639,0.285,NULL,56792863039,887388484,13865445,18),(140661,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140661,37.4,0.27,301,67930,70,NULL,NULL,'2MASX J17105718+3005137',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00019,NULL,'15.9g',0.47,'E0',NULL,NULL,NULL,NULL,1,257.738125,30.08725,0.193,NULL,56362677103,880666829,13760419,15.9),(140662,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140662,37.6,0.46,331,67931,70,NULL,NULL,'2MASX J17105737+2716445',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,257.7390417,27.27906,0.173,NULL,56318782243,879980972,13749702,17.3),(140663,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140663,37.69,0.07,345,67932,70,NULL,NULL,'ZwCl 1710.4+6401 02',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000058,NULL,'17.4g',0.22,'Red fuzzy',NULL,NULL,NULL,NULL,1,257.741833,63.85906,0.085,NULL,57572908269,899576691,14055885,17.4),(140664,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','PTF10jtp','N',140664,37.36,0.03,278,67933,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10jtp',0.067,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140665,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140665,37.4,0.27,301,67934,70,NULL,NULL,'2MASX J17105877+3001492',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,257.7449583,30.03039,0.205,NULL,56362724431,880667569,13760430,18.2),(140666,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140666,37.36,0.46,297,67935,70,NULL,NULL,'2MASX J17110103+2603165',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,257.754291667,26.05464,0.161,NULL,56307569334,879805770,13746965,16.9),(140667,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140667,36.47,0.46,197,67936,70,NULL,NULL,'2MASX J17110157+2243592',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000162,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,257.756583333,22.733,0.189,NULL,56794711293,887417363,13865896,16.6),(140668,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140668,37.72,0.46,350,67937,70,NULL,NULL,'VII Zw 687',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00009,NULL,'16.8g',0.3,'Very red       AGN',NULL,NULL,NULL,NULL,1,257.757167,64.02614,0.057,NULL,57572721343,899573770,14055840,16.8),(140669,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2001cp',NULL,140669,34.23,0.23,68.6,67938,74.2,NULL,'SALT 2','UGC 10738',0.022402,'2010ApJ...716..712A',2010,1,1.97,NULL,'G',0.000011,NULL,'15.05',0.24,'Sbc',NULL,NULL,NULL,NULL,1,257.774375,5.85225,0.293,NULL,56011333499,875177085,13674641,15.05),(140670,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2001cp',NULL,140670,34.95,0.17,95.4,67938,70,NULL,'SALT 2','UGC 10738',0.022402,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140671,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2001cp','R',140671,34.94,0.05,97.3,67938,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 10738',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140672,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2001cp',NULL,140672,35,0.24,97.7,67938,65,NULL,'MLCS17','UGC 10738',0.022402,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140673,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2001cp',NULL,140673,35,0.24,97.9,67938,65,NULL,'MLCS31','UGC 10738',0.022402,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140674,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2001cp','R',140674,34.96,0.06,98.2,67938,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 10738',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140675,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2001cp',NULL,140675,34.98,0.08,99.1,67938,74.4,NULL,NULL,'UGC 10738',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140676,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2001cp',NULL,140676,35.2,0.39,107,67938,65,NULL,'SALT2','UGC 10738',0.022402,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140677,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2001cp',NULL,140677,35.45,0.19,120,67938,65,NULL,'SALT','UGC 10738',0.022402,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140678,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140678,34.82,0.49,92.1,67938,75,NULL,'IR','UGC 10738',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140679,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140679,34.93,0.47,96.9,67938,NULL,NULL,'H','UGC 10738',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140680,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140680,34.98,0.08,99.1,67938,74.4,NULL,NULL,'UGC 10738',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140681,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140681,35.01,0.4,100,67938,NULL,NULL,'mean','UGC 10738',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140682,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140682,35.01,0.45,101,67938,NULL,NULL,'K','UGC 10738',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140683,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140683,35.07,0.46,103,67938,NULL,NULL,'J','UGC 10738',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140684,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140684,35.19,NULL,109,67938,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10738',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140685,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140685,35.2,NULL,110,67938,NULL,NULL,'Dipole + Quadrupole','UGC 10738',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140686,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140686,35.21,NULL,110,67938,NULL,NULL,NULL,'UGC 10738',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140687,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140687,35.21,NULL,110,67938,NULL,NULL,'Dipole','UGC 10738',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140688,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140688,35.4,0.37,120,67938,NULL,NULL,'Malmquist cor.','UGC 10738',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140689,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140689,35.44,0.4,122,67938,75,NULL,'HOSTS SN 2001cp','UGC 10738',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140690,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140690,35.51,0.42,126,67938,NULL,18.48,'3.6 micron','UGC 10738',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140691,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140691,35.58,0.43,131,67938,75,NULL,'3.6 micron, color corrected','UGC 10738',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140692,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140692,35.7,0.32,138,67938,NULL,NULL,NULL,'UGC 10738',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140693,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140693,35.71,0.43,139,67938,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10738',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140694,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140694,37.69,0.07,345,67939,70,NULL,NULL,'ZwCl 1710.4+6401 05',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000087,NULL,'17.6g',0.21,'Very red',NULL,NULL,NULL,NULL,1,257.7805,63.98381,0.085,NULL,57572854967,899575858,14055872,17.6),(140695,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140695,38.21,0.46,438,67940,70,NULL,NULL,'2MASX J17110815+3037223',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,257.783833333,30.62281,0.149,NULL,56362511302,880664239,13760378,17.8),(140696,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140696,37.69,0.07,345,67941,70,NULL,NULL,'SDSS J171109.16+633915.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000071,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,257.7882083,63.65431,0.081,NULL,57573078064,899579344,14055927,18.2),(140697,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140697,37.56,0.46,325,67942,70,NULL,NULL,'2MASX J17111133+2927558',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000165,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,257.797083,29.46556,0.169,NULL,56360439455,880631866,13759872,17.8),(140698,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140698,37.89,0.46,378,67943,70,NULL,NULL,'2MASX J17111270+2827558',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000167,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,257.8029583,28.46547,0.145,NULL,56315982485,879937226,13749019,16.9),(140699,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140699,37.69,0.07,345,67944,70,NULL,NULL,'VII Zw 688',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000077,NULL,'17.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,257.8052083,63.63756,0.081,NULL,57573005345,899578208,14055909,17.6),(140700,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140700,37.42,0.33,304,67945,70,NULL,NULL,'2MASX J17111724+3943558',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,257.821875,39.73217,0.109,NULL,59641233113,931894267,14560847,17.2),(140701,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140701,37.73,0.46,352,67946,70,NULL,NULL,'SDSS J171117.90+581417.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000075,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,257.824625,58.23833,0.041,NULL,57704084307,901626317,14087911,18.2),(140702,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140702,37.49,0.46,315,67947,70,NULL,NULL,'2MASX J17112046+5611062',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000076,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,257.835167,56.185,0.029,NULL,57700603479,901571929,14087061,17.2),(140703,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140703,35.48,0.5,125,67948,70,NULL,NULL,'2MASX J17112444-6544320',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,257.852,-65.74222,0.321,NULL,44435492253,694304566,10848508,14.8),(140704,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140704,37.7,0.46,347,67949,70,NULL,NULL,'2MASX J17112814+3715428',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,257.867333,37.26192,0.137,NULL,56121979361,876905927,13701655,17.4),(140705,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140705,37.08,0.46,261,67950,70,NULL,NULL,'ZwCl 1710.4+6401 08',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000081,NULL,'17.2g',0.17,'Very red oval',NULL,NULL,NULL,NULL,1,257.8735417,63.86606,0.085,NULL,57572905024,899576641,14055885,17.2),(140706,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2002er',NULL,140706,32.51,0.09,31.8,67951,74.4,NULL,NULL,'UGC 10743',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000023,NULL,'13.4B',0.4,'Sa?','Isolated galaxy',NULL,NULL,NULL,1,257.878083333,7.99461,0.293,NULL,56011860620,875185322,13674770,13.4),(140707,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2002er',NULL,140707,32.72,0.24,34.7,67951,72,NULL,NULL,'UGC 10743',0.00857,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140708,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2002er',NULL,140708,33.03,0.09,39.8,67951,65,NULL,'MLCS2k2','UGC 10743',0.00857,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140709,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2002er',NULL,140709,33.22,0.14,44.1,67951,60,NULL,NULL,'UGC 10743',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140710,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140710,31.48,0.42,19.8,67951,NULL,18.48,'3.6 micron','UGC 10743',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140711,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140711,31.58,0.4,20.7,67951,75,NULL,'HOSTS SN 2002er','UGC 10743',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140712,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140712,31.58,0.4,20.7,67951,75,NULL,'HOSTS SN 2002er','UGC 10743',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140713,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140713,31.64,0.43,21.3,67951,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10743',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140714,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140714,31.89,0.43,23.8,67951,75,NULL,'3.6 micron, color corrected','UGC 10743',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140715,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140715,32.02,0.4,25.4,67951,75,NULL,NULL,'UGC 10743',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140716,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140716,32.41,0.49,30.3,67951,75,NULL,'IR','UGC 10743',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140717,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140717,32.51,0.09,31.8,67951,74.4,NULL,NULL,'UGC 10743',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140718,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140718,32.59,0.47,32.9,67951,NULL,NULL,'H','UGC 10743',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140719,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140719,32.7,0.45,34.7,67951,NULL,NULL,'K','UGC 10743',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140720,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140720,32.71,0.46,34.8,67951,NULL,NULL,'J','UGC 10743',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140721,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140721,32.75,0.4,35.5,67951,NULL,NULL,'mean','UGC 10743',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140722,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140722,38.07,0.46,412,67952,70,NULL,NULL,'2MASX J17113356+2756250',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,257.889833333,27.94022,0.161,NULL,56318507534,879976680,13749635,17.6),(140723,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140723,37.69,0.07,345,67953,70,NULL,NULL,'2MASX J17113603+6339059',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000071,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,257.8999583,63.65164,0.081,NULL,57573000921,899578139,14055908,16.9),(140724,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140724,38.15,0.46,427,67954,70,NULL,NULL,'2MASX J17113614+6400599',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000093,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,257.900791667,64.01667,0.057,NULL,57572393115,899568642,14055760,17.8),(140725,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140725,37.69,0.07,345,67955,70,NULL,NULL,'ZwCl 1710.4+6401 10',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000096,NULL,'17.6g',0.2,'Very red',NULL,NULL,NULL,NULL,1,257.908083333,64.04625,0.057,NULL,57575014848,899609607,14056400,17.6),(140726,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140726,38.21,0.46,439,67956,70,NULL,NULL,'2MASX J17113919+3732186',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,257.913125,37.53858,0.133,NULL,56121983200,876905987,13701656,17.5),(140727,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140727,37.85,0.46,371,67957,70,NULL,NULL,'2MASX J17113952+2933331',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000163,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,257.91475,29.55917,0.145,NULL,56360447892,880631998,13759874,18.3),(140728,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140728,37.98,0.46,395,67958,70,NULL,NULL,'2MASX J17114196+2906581',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,257.924833,29.11617,0.169,NULL,56315329435,879927022,13748859,17.7),(140729,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140729,36.14,0.67,169,67959,70,NULL,NULL,'2MASX J17114259-0104523',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.6I',0.4,NULL,NULL,NULL,NULL,NULL,1,257.9275417,-1.08117,0.645,NULL,45201900564,706279696,11035620,14.6),(140730,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140730,38.39,0.46,477,67960,70,NULL,NULL,'2MASX J17114408+2736241',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,257.933666667,27.60669,0.169,NULL,56318641800,879978778,13749668,17.7),(140731,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140731,33.32,0.49,46.1,67961,75,NULL,'IR','ESO 519- G?009',NULL,'2011yCatp016004901K',2011,1,1.21,NULL,'G',0.00005,NULL,'15.6',0.13,'Sc',NULL,NULL,NULL,NULL,1,257.9377083,-25.74736,NULL,NULL,45839479980,716241874,11191279,15.6),(140732,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140732,35.36,NULL,118,67961,NULL,NULL,'Dipole + Quadrupole','ESO 519- G?009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140733,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140733,35.36,NULL,118,67961,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 519- G?009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140734,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140734,35.36,NULL,118,67961,NULL,NULL,'Dipole','ESO 519- G?009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140735,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140735,38.1,0.46,416,67962,70,NULL,NULL,'2MASX J17114513+2211367',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000188,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,257.9379583,22.19358,0.225,NULL,56792263283,887379113,13865298,16.7),(140736,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140736,37.69,0.07,345,67963,70,NULL,NULL,'VII Zw 692',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000053,NULL,'16.6g',0.34,'Very red       AGN',NULL,NULL,NULL,NULL,1,257.9415,64.35892,0.061,NULL,57575193147,899612392,14056443,16.6),(140737,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140737,36.15,0.46,170,67964,70,NULL,NULL,'2MASX J17114609+2854311',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000175,NULL,'16.0g',0.32,'E0',NULL,NULL,NULL,NULL,1,257.942,28.90861,0.165,NULL,56315155603,879924306,13748817,16),(140738,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140738,37.84,0.46,370,67965,70,NULL,NULL,'2MASX J17114834+2808061',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000147,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,257.951333,28.13514,0.145,NULL,56315361091,879927517,13748867,18.6),(140739,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140739,35.07,0.49,103,67966,75,NULL,'IR','FGC 2115',NULL,'2011yCatp016004901K',2011,1,0.85,NULL,'G',NULL,NULL,'16.7',0.1,'Scd',NULL,NULL,NULL,NULL,1,257.9535417,47.66014,0.029,NULL,59620434102,931569282,14555770,16.7),(140740,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140740,35.33,NULL,117,67966,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2115',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140741,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140741,35.35,NULL,118,67966,NULL,NULL,'Dipole + Quadrupole','FGC 2115',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140742,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140742,35.37,NULL,119,67966,NULL,NULL,'Dipole','FGC 2115',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140743,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140743,35.39,NULL,120,67966,NULL,NULL,NULL,'FGC 2115',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140744,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140744,37.61,0.46,333,67967,70,NULL,NULL,'2MASX J17114908+3303131',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,257.954625,33.05381,0.161,NULL,56354463582,880538493,13758413,18.3),(140745,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140745,37.69,0.07,345,67968,70,NULL,NULL,'VII Zw 691',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000088,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,257.954958333,63.61544,0.081,NULL,57573001965,899578155,14055908,16.8),(140746,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140746,35.4,0.19,120,67969,70,NULL,NULL,'CGCG 299-058',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000077,NULL,'14.6g',0.71,'E0',NULL,NULL,NULL,NULL,1,257.9575,57.5895,0.029,NULL,57711545579,901742899,14089732,14.6),(140747,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140747,37.68,0.46,343,67970,70,NULL,NULL,'2MASX J17115156+2931101',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,257.964875,29.51944,0.145,NULL,56360495301,880632739,13759886,18.1),(140748,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','PTF10qkv','N',140748,37.92,0.03,362,67971,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10qkv',0.0611,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140749,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140749,36.4,0.33,191,67972,70,NULL,NULL,'2MASX J17115337+2152463',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,257.972375,21.87961,0.237,NULL,56792397869,887381216,13865331,16.9),(140750,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140750,36.64,0.46,213,67973,70,NULL,NULL,'2MASX J17115618+3803307',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,257.984083,38.0585,0.153,NULL,59640953270,931889894,14560779,17),(140751,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140751,37.48,0.46,313,67974,70,NULL,NULL,'2MASX J17115762+6045378',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000075,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,257.9902083,60.76058,0.037,NULL,57562802850,899418794,14053418,17.5),(140752,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140752,36.05,0.69,162,67975,70,NULL,NULL,'2MASX J17115766-2342073',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'18.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,257.990375,-23.70211,NULL,NULL,46003604063,718806313,11231348,18.1),(140753,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140753,37.69,0.07,345,67976,70,NULL,NULL,'ZwCl 1710.4+6401 12',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000083,NULL,'17.6g',0.19,'Very red       AGN',NULL,NULL,NULL,NULL,1,257.9904583,64.05569,0.057,NULL,57575016029,899609625,14056400,17.6),(140754,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2006mp',NULL,140754,34.46,0.18,76.2,67977,74.2,NULL,'SALT 2','UGC 10754 NOTES01',0.0233,'2010ApJ...716..712A',2010,1,0.6,NULL,'G',NULL,NULL,'16',0.4,NULL,NULL,NULL,NULL,NULL,1,257.9962083,46.55678,0.053,NULL,59653485319,932085708,14563839,16),(140755,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2006mp',NULL,140755,35.05,0.03,83.2,67977,72,NULL,'MLCS17','UGC 10754 NOTES01',0.23,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140756,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2006mp',NULL,140756,34.99,0.09,99.5,67977,74.4,NULL,NULL,'UGC 10754 NOTES01',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140757,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2006mp',NULL,140757,35.19,0.17,106,67977,70,NULL,'SALT 2','UGC 10754 NOTES01',0.0233,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140758,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2006mp','R',140758,35.14,0.1,107,67977,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 10754 NOTES01',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140759,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2006mp',NULL,140759,35.2,0.16,107,67977,73.8,NULL,'SALT 2 (SNANA)','UGC 10754 NOTES01',0.023,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140760,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2006mp',NULL,140760,35.2,0.02,107,67977,70,NULL,'SALT 2','UGC 10754 NOTES01',0.0233,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140761,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2006mp','R',140761,35.16,0.08,108,67977,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 10754 NOTES01',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140762,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2006mp',NULL,140762,35.26,0.18,113,67977,65,NULL,'MLCS17','UGC 10754 NOTES01',NULL,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140763,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2006mp',NULL,140763,35.26,0.2,113,67977,65,NULL,'MLCS31','UGC 10754 NOTES01',NULL,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140764,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140764,37.93,0.46,386,67978,70,NULL,NULL,'2MASX J17120085+5547549',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000098,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,258.0037083,55.79861,0.053,NULL,57700651833,901572684,14087073,16.6),(140765,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140765,37.69,0.07,345,67979,70,NULL,NULL,'2MASX J17120095+6402168',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000074,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,258.004083,64.03786,0.057,NULL,57574295912,899598373,14056224,17.6),(140766,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140766,36.56,0.46,205,67980,70,NULL,NULL,'2MASX J17120405+3014202',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000194,NULL,'15.5g',0.48,'S0',NULL,NULL,NULL,NULL,1,258.016958333,30.23894,0.089,NULL,56362816826,880669012,13760453,15.5),(140767,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140767,37.69,0.07,345,67981,70,NULL,NULL,'SDSS J171204.79+640842.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00008,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,258.02,64.14522,0.057,NULL,57575026694,899609792,14056403,17.9),(140768,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140768,35.4,0.19,120,67982,70,NULL,NULL,'2MASX J17120667+5730139',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000066,NULL,'15.8g',0.31,'E0',NULL,NULL,NULL,NULL,1,258.027625,57.504,0.029,NULL,57711548261,901742941,14089733,15.8),(140769,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140769,36.4,0.33,191,67983,70,NULL,NULL,'2MASX J17121240+2147522',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'16.0g',0.34,NULL,NULL,NULL,NULL,NULL,1,258.051667,21.79781,0.237,NULL,56792371095,887380798,13865324,16),(140770,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140770,38.07,0.46,411,67984,70,NULL,NULL,'2MASX J17121296+2729487',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,258.054125,27.49706,0.169,NULL,56320709065,880011079,13750173,17.4),(140771,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140771,34.38,0.2,75.2,67985,74.4,NULL,NULL,'UGC 10749',NULL,'2013AJ....146...86T',2013,1,0.94,NULL,'G',0.000016,NULL,'15.1g',0.46,'SBb',NULL,NULL,NULL,NULL,1,258.056875,30.16783,0.089,NULL,56362815233,880668988,13760452,15.1),(140772,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140772,37.65,0.46,340,67986,70,NULL,NULL,'2MASX J17121498+3301292',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,258.0624583,33.02483,0.161,NULL,56354420042,880537813,13758403,17.5),(140773,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140773,37.69,0.07,345,67987,70,NULL,NULL,'SDSS J171218.49+640029.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000074,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,258.077041667,64.00806,0.085,NULL,57574294998,899598359,14056224,18.4),(140774,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140774,38.39,0.33,476,67988,70,NULL,NULL,'SDSS J171219.25+583624.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000086,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,258.08025,58.60672,0.033,NULL,57703443486,901616304,14087754,18.6),(140775,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140775,38.03,0.46,404,67989,70,NULL,NULL,'SDSS J171221.10+570229.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000071,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,258.087917,57.04158,0.033,NULL,57698101181,901532830,14086450,18.5),(140776,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140776,36.84,0.46,233,67990,70,NULL,NULL,'SDSS J171221.80+562516.2',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000072,NULL,'17.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,258.090833,56.42119,0.029,NULL,57698600319,901540629,14086572,17.7),(140777,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140777,37.03,0.46,255,67991,70,NULL,NULL,'2MASX J17122487+3223582',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000174,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,258.1037083,32.3995,0.137,NULL,56351129139,880486392,13757599,16.6),(140778,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140778,37.18,0.46,272,67992,70,NULL,NULL,'2MASX J17122515+5744470',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000077,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,258.1047083,57.74658,0.029,NULL,57703383553,901615368,14087740,16.7),(140779,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140779,37.69,0.07,345,67993,70,NULL,NULL,'ZwCl 1710.4+6401 18',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000091,NULL,'16.6g',0.31,'Very red, patchy',NULL,NULL,NULL,NULL,1,258.1070417,64.32936,0.061,NULL,57575183740,899612245,14056441,16.6),(140780,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140780,37.69,0.07,345,67994,70,NULL,NULL,'ZwCl 1710.4+6401 20',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000082,NULL,'17.9g',0.15,'Red',NULL,NULL,NULL,NULL,1,258.110083,64.38964,0.061,NULL,57575188854,899612325,14056442,17.9),(140781,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140781,37.69,0.07,345,67995,70,NULL,NULL,'ZwCl 1710.4+6401 19',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000085,NULL,'17.7g',0.18,'Very red',NULL,NULL,NULL,NULL,1,258.117666667,64.03108,0.057,NULL,57574307626,899598556,14056227,17.7),(140782,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140782,37.69,0.07,345,67996,70,NULL,NULL,'SDSS J171228.48+635749.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00007,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,258.118667,63.96369,0.085,NULL,57572402408,899568787,14055762,18.4),(140783,'BCG','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140783,37.67,0.35,318,67997,60,NULL,'ABELL 2255, BCG','ZwCl 1710.4+6401 A',0.0747,'1980ApJ...241..486H',1980,1,0.67,NULL,'G',0.000102,NULL,'15.5g',0.58,'E0;red;BrClG','Brightest group member',NULL,NULL,NULL,1,258.119958333,64.06075,0.057,NULL,57574303577,899598493,14056226,15.5),(140784,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140784,37.69,0.07,345,67997,70,NULL,NULL,'ZwCl 1710.4+6401 A',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140785,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140785,37.69,0.07,345,67998,70,NULL,NULL,'2MASX J17123044+6400595',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000083,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,258.126958333,64.01658,0.085,NULL,57574309060,899598579,14056227,17.8),(140786,'BCG','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140786,37.67,0.35,318,67999,60,NULL,NULL,'ABELL 2255',0.0747,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III:[BM]',NULL,NULL,NULL,NULL,1,258.129375,64.09258,0.057,NULL,57575021985,899609718,14056401,NULL),(140787,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140787,37.69,0.07,345,68000,70,NULL,NULL,'SDSS J171231.73+635950.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000074,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,258.1322083,63.99733,0.085,NULL,57574308658,899598572,14056227,18.3),(140788,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140788,37.69,0.07,345,68001,70,NULL,NULL,'2MASX J17123243+6400095',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00008,NULL,'16.7g',0.36,NULL,NULL,NULL,NULL,NULL,1,258.135166667,64.00278,0.085,NULL,57574308493,899598570,14056227,16.7),(140789,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140789,34.42,0.2,76.6,68002,74.4,NULL,NULL,'UGC 10753',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000012,NULL,'15.48',0.3,'Scd:',NULL,NULL,NULL,NULL,1,258.146875,34.69253,0.109,NULL,56340141677,880314713,13754917,15.48),(140790,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140790,33.86,0.47,59.3,68003,NULL,NULL,'H','NGC 6314',NULL,'2007A&A...465...71T',2007,1,1.61,NULL,'G',0.000013,NULL,'13.8g',0.78,'SA(s)a: sp','Isolated galaxy (6 Mpc isolation)',NULL,NULL,NULL,1,258.161333,23.27008,0.213,NULL,56794519175,887414362,13865849,13.8),(140791,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140791,33.93,0.45,61.1,68003,NULL,NULL,'K','NGC 6314',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140792,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140792,34.04,0.46,64.3,68003,NULL,NULL,'J','NGC 6314',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140793,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140793,34.06,0.69,64.8,68003,100,NULL,'mid-IR','NGC 6314',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140794,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140794,34.5,0.34,79.5,68003,NULL,NULL,NULL,'NGC 6314',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140795,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140795,34.54,0.2,80.9,68003,74.4,NULL,NULL,'NGC 6314',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140796,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140796,34.64,0.4,84.7,68003,NULL,NULL,'mean','NGC 6314',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140797,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140797,34.75,0.3,89.2,68003,NULL,NULL,'Malmquist cor.','NGC 6314',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140798,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140798,38.35,0.46,469,68004,70,NULL,NULL,'2MASX J17124062+6213055',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000115,NULL,'17.6g',0.23,'AGN',NULL,NULL,NULL,NULL,1,258.1692917,62.21817,0.085,NULL,57565552698,899461760,14054090,17.6),(140799,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140799,37.56,0.46,325,68005,70,NULL,NULL,'2MASX J17124132+3204221',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000167,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,258.172125,32.07289,0.157,NULL,56344106929,880376670,13755885,18.1),(140800,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140800,38.07,0.46,411,68006,70,NULL,NULL,'2MASX J17124493+4229496',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,258.187125,42.49717,0.037,NULL,59649452666,932022697,14562854,17.5),(140801,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140801,37.81,0.46,365,68007,70,NULL,NULL,'2MASX J17124571+2732533',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',NULL,NULL,'18.1g',0.1,NULL,NULL,NULL,NULL,NULL,1,258.190625,27.54811,0.169,NULL,56320718713,880011229,13750175,18.1),(140802,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140802,38.54,0.46,511,68008,70,NULL,NULL,'2MASX J17124711+2917343',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00014,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,258.19625,29.29297,0.169,NULL,56315307734,879926683,13748854,18.1),(140803,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140803,37.69,0.07,345,68009,70,NULL,NULL,'2MASX J17125008+6403105',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000089,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,258.208375,64.05294,0.057,NULL,57574305780,899598527,14056226,16.9),(140804,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140804,38.39,0.33,476,68010,70,NULL,NULL,'2MASX J17125158+5832407',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000085,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,258.214833333,58.54461,0.033,NULL,57703434593,901616165,14087752,17.7),(140805,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140805,37.43,0.33,306,68011,70,NULL,NULL,'2MASX J17125273+3207002',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000172,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,258.219625,32.11675,0.157,NULL,56344063066,880375985,13755874,16.5),(140806,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140806,37.89,0.46,379,68012,70,NULL,NULL,'SDSS J171253.70+585128.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000079,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,258.2237917,58.858,0.029,NULL,57687932985,901373952,14083968,18.5),(140807,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140807,37.69,0.07,345,68013,70,NULL,NULL,'2MASX J17125447+6359325',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000085,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,258.2267917,63.99239,0.085,NULL,57574298915,899598420,14056225,16.3),(140808,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140808,38.8,0.46,575,68014,70,NULL,NULL,'2MASX J17125474+3313242',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,258.228167,33.22356,0.153,NULL,56354330782,880536418,13758381,18.3),(140809,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140809,37.43,0.33,306,68015,70,NULL,NULL,'2MASX J17125477+3209192',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000184,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,258.22825,32.15536,0.157,NULL,56344065918,880376029,13755875,16.7),(140810,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140810,37.13,0.46,267,68016,70,NULL,NULL,'2MASX J17125700+2315265',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000194,NULL,'17.2g',0.17,'Sa       Cand. BLAGN',NULL,NULL,NULL,NULL,1,258.237583333,23.25744,0.213,NULL,56794545571,887414774,13865855,17.2),(140811,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140811,36.95,0.46,246,68017,70,NULL,NULL,'2MASX J17125915+2219315',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000181,NULL,'16.2g',0.39,'E0',NULL,NULL,NULL,NULL,1,258.246541667,22.32544,0.205,NULL,56794237769,887409965,13865780,16.2),(140812,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140812,37.85,0.46,371,68018,70,NULL,NULL,'2MASX J17125969+5931228',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000088,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,258.2487917,59.52286,0.045,NULL,57685187154,901331049,14083297,17.3),(140813,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140813,37.41,0.46,304,68019,70,NULL,NULL,'2MASX J17130221+6026554',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000066,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,258.259125,60.44883,0.061,NULL,57562646406,899416350,14053380,17.3),(140814,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140814,37.69,0.07,345,68020,70,NULL,NULL,'ZwCl 1710.4+6401 24',NULL,'2015arXiv151105856S',2015,1,0.39,'One of two 6cm sources associated with [WB92] 1712+6405','G',0.000063,NULL,'16.6g',0.28,'Radio galaxy',NULL,NULL,NULL,NULL,1,258.26575,64.11714,0.093,NULL,57575039567,899609993,14056406,16.6),(140815,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140815,36.45,0.53,195,68021,70,NULL,NULL,'2MASX J17130591-6026042',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,258.274625,-60.43458,0.553,NULL,44476435166,694944299,10858504,15.5),(140816,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140816,36.49,0.46,199,68022,70,NULL,NULL,'2MASX J17130709+2957462',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,258.279625,29.96292,0.089,NULL,56362654062,880666469,13760413,17.4),(140817,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140817,38.37,0.46,472,68023,70,NULL,NULL,'2MASX J17130717+2848333',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000174,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,258.279958333,28.80931,0.165,NULL,56315847914,879935123,13748986,17.3),(140818,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140818,37.69,0.07,345,68024,70,NULL,NULL,'ZwCl 1710.4+6401 26',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000083,NULL,'17.8g',0.2,'Red',NULL,NULL,NULL,NULL,1,258.292625,63.98514,0.085,NULL,57574299507,899598429,14056225,17.8),(140819,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140819,38.65,0.46,537,68025,70,NULL,NULL,'2MASX J17131542+3238288',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,258.314375,32.64142,0.149,NULL,56351505014,880492265,13757691,18.4),(140820,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140820,37.69,0.07,345,68026,70,NULL,NULL,'2MASX J17131603+6347378',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00005,NULL,'15.8g',0.46,'Radio galaxy',NULL,NULL,'radio jet',NULL,1,258.316708333,63.79375,0.085,NULL,57572446149,899569471,14055772,15.8),(140821,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140821,37.69,0.07,345,68027,70,NULL,NULL,'ZwCl 1710.4+6401 33',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000081,NULL,'17.3g',0.23,'Very red',NULL,NULL,NULL,NULL,1,258.3195,64.05569,0.093,NULL,57574347118,899599173,14056237,17.3),(140822,'Maser','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140822,35,NULL,100,68028,NULL,NULL,NULL,'NGC 6323',NULL,'2009astro2010S..23B',2009,1,1.1,NULL,'G',0.000117,NULL,'14.85',0.4,'Sab            Sy2',NULL,NULL,NULL,NULL,1,258.325333,43.78244,0.029,NULL,59658013669,932156463,14564944,14.85),(140823,'Maser','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140823,35.15,0.72,107,68028,73,NULL,NULL,'NGC 6323',NULL,'2015ApJ...800...26K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140824,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140824,37.69,0.07,345,68029,70,NULL,NULL,'ZwCl 1710.4+6401 35',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000084,NULL,'16.2g',0.39,'BrClG;red, fuzzy',NULL,NULL,NULL,NULL,1,258.329333333,64.07686,0.093,NULL,57574347597,899599181,14056237,16.2),(140825,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140825,37.69,0.07,345,68030,70,NULL,NULL,'ZwCl 1710.4+6401 34',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000083,NULL,'18.0g',0.17,'Very red',NULL,NULL,NULL,NULL,1,258.33325,64.05681,0.093,NULL,57574347081,899599173,14056237,18),(140826,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140826,37.69,0.07,345,68031,70,NULL,NULL,'2MASX J17132039+6348349',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000062,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,258.335,63.80964,0.085,NULL,57572443942,899569436,14055772,17.8),(140827,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140827,37.69,0.07,345,68032,70,NULL,NULL,'2MASX J17132170+6404089',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000096,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,258.3405417,64.06908,0.093,NULL,57574347458,899599179,14056237,16.7),(140828,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140828,35.82,0.56,146,68033,70,NULL,NULL,'2MASX J17132357-6451185',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,258.348125,-64.85511,0.325,NULL,44480954462,695014913,10859608,15.3),(140829,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140829,35.72,0.82,139,68034,70,NULL,NULL,'2MFGC 13742',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,258.363,-79.55461,0.429,NULL,44262395356,691599927,10806248,17.3),(140830,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140830,35.8,0.67,144,68035,70,NULL,NULL,'2MASX J17132887-0919476',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,258.370333,-9.33,1.161,NULL,45182682111,705979407,11030928,15.9),(140831,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140831,37.69,0.07,345,68036,70,NULL,NULL,'2MASX J17132903+6402489',NULL,'2015arXiv151105856S',2015,1,0.6,'One of two 6cm sources associated with [WB92] 1712+6405','G',0.000063,NULL,'16.0g',0.41,'Radio galaxy   AGN',NULL,NULL,NULL,NULL,1,258.3712917,64.04686,0.093,NULL,57574350811,899599231,14056237,16),(140832,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140832,37.69,0.07,345,68037,70,NULL,NULL,'2MASX J17133155+6412210',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000092,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,258.381291667,64.20592,0.093,NULL,57575037518,899609961,14056405,17.6),(140833,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140833,37,0.46,252,68038,70,NULL,NULL,'2MASX J17133157+2136162',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'17.06',0.41,NULL,NULL,NULL,NULL,NULL,1,258.381416667,21.60458,0.265,NULL,56806289785,887598277,13868723,17.06),(140834,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140834,37.69,0.07,345,68039,70,NULL,NULL,'2MASX J17133391+6400480',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00008,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,258.391333,64.01339,0.121,NULL,57574355702,899599307,14056239,16.7),(140835,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140835,38.12,0.46,420,68040,70,NULL,NULL,'2MASX J17133614+5628478',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000086,NULL,'18.4g',0.14,'NLAGN',NULL,NULL,NULL,NULL,1,258.400667,56.48008,0.029,NULL,57698626050,901541032,14086578,18.4),(140836,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140836,37.69,0.07,345,68041,70,NULL,NULL,'ZwCl 1710.4+6401 39',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000066,NULL,'17.9g',0.21,'Fuzzy, red',NULL,NULL,NULL,NULL,1,258.411833,64.15892,0.093,NULL,57575044865,899610076,14056407,17.9),(140837,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140837,37.69,0.07,345,68042,70,NULL,NULL,'ZwCl 1710.4+6401 38',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000078,NULL,'18.2g',0.16,'Red',NULL,NULL,NULL,NULL,1,258.4127917,64.13347,0.093,NULL,57575040950,899610014,14056406,18.2),(140838,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140838,37.45,0.46,309,68043,70,NULL,NULL,'2MASX J17134528+2838215',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000169,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,258.438625,28.63933,0.165,NULL,56315439516,879928742,13748886,16.9),(140839,'IRAS','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140839,32.76,0.8,35.7,68044,75,NULL,'MAT, I','IC 4633',NULL,'1997ApJS..109..333W',1997,1,4,'Fairall (1984,MNRAS,210,69) gives v = 5200 +/- 200 km/sec.','G',0.00003,NULL,'12.8',3,'SAB(r)d','in a triple',NULL,NULL,NULL,1,258.446,-77.53619,0.433,NULL,44138701525,689667211,10776050,12.8),(140840,'Tully est','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140840,32.82,0.8,36.6,68044,75,NULL,NULL,'IC 4633',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140841,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140841,32.2,0.43,27.6,68044,75,NULL,'3.6 micron, color + selection bias corrected','IC 4633',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140842,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140842,32.34,0.43,29.3,68044,75,NULL,'3.6 micron, color corrected','IC 4633',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140843,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140843,32.41,0.46,30.3,68044,NULL,NULL,'J','IC 4633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140844,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140844,32.42,0.47,30.5,68044,NULL,NULL,'H','IC 4633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140845,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140845,32.42,0.45,30.5,68044,NULL,NULL,'K','IC 4633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140846,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140846,32.45,0.2,30.9,68044,74.4,NULL,NULL,'IC 4633',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140847,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140847,32.76,0.32,35.6,68044,85,NULL,'I, raw','IC 4633',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140848,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140848,32.82,0.32,36.7,68044,85,NULL,'I, inv','IC 4633',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140849,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140849,32.88,0.4,37.6,68044,NULL,NULL,'mean','IC 4633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140850,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140850,33.13,0.43,42.3,68044,75,NULL,'MAT, I, raw','IC 4633',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140851,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140851,33.43,0.43,48.6,68044,75,NULL,'MAT, I, cor','IC 4633',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140852,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140852,33.45,0.43,49.1,68044,75,NULL,'MAT, I, inv','IC 4633',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140853,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140853,37.69,0.07,345,68045,70,NULL,NULL,'ZwCl 1710.4+6401 41',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00008,NULL,'17.7g',0.2,'Red',NULL,NULL,NULL,NULL,1,258.450791667,64.02036,0.121,NULL,57574357500,899599335,14056239,17.7),(140854,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140854,38.08,0.46,412,68046,70,NULL,NULL,'SDSS J171348.22+640850.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00008,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,258.450958333,64.14725,0.093,NULL,57575045046,899610078,14056407,18.4),(140855,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140855,36.09,0.6,165,68047,70,NULL,NULL,'2MASX J17134957-0909434',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,258.456583333,-9.16208,1.161,NULL,45300703164,707823486,11059741,16.1),(140856,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140856,34.2,0.34,69.1,68048,NULL,NULL,'Malmquist cor.','ESO 138- G 018',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.96',0.4,'S0+?',NULL,NULL,NULL,NULL,1,258.475,-60.81011,0.553,NULL,44477396092,694959313,10858739,14.96),(140857,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140857,34.3,0.33,72.3,68048,NULL,NULL,NULL,'ESO 138- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140858,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140858,34.34,0.2,73.8,68048,74.4,NULL,NULL,'ESO 138- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140859,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140859,38.32,0.46,461,68049,70,NULL,NULL,'2MASX J17135464+3158454',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,258.4777083,31.97942,0.165,NULL,56343343544,880364742,13755699,18.1),(140860,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140860,38.49,0.46,499,68050,70,NULL,NULL,'2MASX J17135849+5515327',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000098,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,258.493625,55.25897,0.045,NULL,57697843473,901528804,14086387,17.5),(140861,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140861,38.36,0.46,470,68051,70,NULL,NULL,'2MASX J17135911+2912105',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,258.49625,29.20297,0.157,NULL,56315799886,879934373,13748974,17.6),(140862,'Tully est','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140862,31.75,0.8,22.4,68052,75,NULL,NULL,'UGC 10792',NULL,'1988NBGC.C....0000T',1988,1,1.8,NULL,'G',0.000017,NULL,'17.',1.8,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,258.506667,75.20361,0.161,NULL,57106714241,892292410,13942068,17),(140863,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140863,36.24,0.52,177,68053,70,NULL,NULL,'2MASX J17140369-6412504',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,258.51525,-64.21394,0.429,NULL,44484724638,695073822,10860528,15),(140864,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140864,37.14,0.46,268,68054,70,NULL,NULL,'2MASX J17140618+4144070',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,258.525875,41.73519,0.057,NULL,59631601499,931743773,14558496,16.9),(140865,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140865,37.68,0.46,344,68055,70,NULL,NULL,'2MASX J17140722+3134264',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,258.530125,31.57417,0.177,NULL,56361032895,880641138,13760017,18),(140866,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140866,37.69,0.07,345,68056,70,NULL,NULL,'ZwCl 1710.4+6401 43',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000088,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,258.539583,64.22011,0.093,NULL,57575148246,899611691,14056432,17.4),(140867,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140867,37.51,0.27,317,68057,70,NULL,NULL,'2MASX J17141115+3200284',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000174,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,258.546416667,32.00781,0.165,NULL,56343385495,880365398,13755709,17.5),(140868,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140868,37.89,0.46,379,68058,70,NULL,NULL,'2MASX J17141279+3636001',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,258.553375,36.6,0.185,NULL,56122413622,876912712,13701761,17.3),(140869,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140869,34.61,0.49,83.7,68059,75,NULL,'IR','CGCG 140-002',NULL,'2011yCatp016004901K',2011,1,NULL,NULL,'G',0.000274,NULL,'15.5',NULL,NULL,NULL,NULL,NULL,NULL,1,258.587333333,23.07158,0.225,NULL,56793303612,887395368,13865552,15.5),(140870,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140870,38.09,0.46,415,68060,70,NULL,NULL,'2MASX J17142124+2810136',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000174,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,258.5884583,28.17031,0.153,NULL,56317386864,879959169,13749362,18.4),(140871,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140871,36.27,0.85,179,68061,70,NULL,NULL,'2MASX J17142124-0956499',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,258.5885417,-9.94719,1.257,NULL,45300874500,707826164,11059783,16.5),(140872,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140872,38.21,0.46,438,68062,70,NULL,NULL,'2MASX J17142211+2904446',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,258.5922917,29.079,0.161,NULL,56315787017,879934172,13748971,18.4),(140873,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140873,35.18,NULL,109,68063,NULL,NULL,'Dipole','ESO 101- G 022',NULL,'2010Ap&SS.325..163P',2010,1,1.85,NULL,'G',0.000044,NULL,'15.51',0.19,'Sbc',NULL,NULL,NULL,NULL,1,258.594333,-65.93664,0.321,NULL,44434827978,694294187,10848346,15.51),(140874,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140874,35.2,NULL,109,68063,NULL,NULL,'Dipole + Quadrupole','ESO 101- G 022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140875,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140875,35.2,NULL,109,68063,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 101- G 022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140876,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140876,37.79,0.46,361,68064,70,NULL,NULL,'2MASX J17142696+5825215',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000092,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,258.612167,58.42261,0.045,NULL,57685943820,901342872,14083482,17.5),(140877,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140877,37.67,0.21,343,68065,70,NULL,NULL,'2MASX J17143060+6517227',NULL,'2015arXiv151105856S',2015,1,0.46,'One of two 6cm sources associated with [WB92] 1714+6513','G',0.00009,NULL,'16.5g',0.36,'E;BrClG',NULL,NULL,NULL,NULL,1,258.6275417,65.28972,0.113,NULL,57516999670,898703119,14042236,16.5),(140878,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140878,37.99,0.46,395,68066,70,NULL,NULL,'2MASX J17143064+3709520',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,258.627625,37.16433,0.161,NULL,56134343615,877099118,13704673,17.3),(140879,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140879,37.67,0.21,343,68067,70,NULL,NULL,'2MASX J17143282+6519338',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00006,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,258.636375,65.32586,0.129,NULL,57517000279,898703129,14042236,18.2),(140880,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140880,37.51,0.27,317,68068,70,NULL,NULL,'2MASX J17143454+3149511',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,258.6437917,31.83097,0.165,NULL,56343295242,880363988,13755687,17.6),(140881,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140881,35.4,0.19,120,68069,70,NULL,NULL,'CGCG 299-063',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000067,NULL,'15.4g',0.41,'E/S0','Group member',NULL,NULL,NULL,1,258.656875,57.30544,0.029,NULL,57697906281,901529785,14086402,15.4),(140882,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140882,35.46,0.25,124,68069,74.4,NULL,NULL,'CGCG 299-063',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140883,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140883,35.68,0.25,137,68069,70,NULL,NULL,'CGCG 299-063',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140884,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140884,36.06,0.46,163,68070,70,NULL,NULL,'2MASX J17143791+2931137',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000174,NULL,'15.9g',0.38,'E0',NULL,NULL,NULL,NULL,1,258.658125,29.52058,0.145,NULL,56360774800,880637106,13759954,15.9),(140885,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140885,37.11,0.46,264,68071,70,NULL,NULL,'SDSS J171438.66+630225.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000084,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,258.661125,63.04028,0.113,NULL,57577250922,899644545,14056946,17.9),(140886,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140886,32.63,0.2,33.6,68072,74.4,NULL,NULL,'UGC 10791',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.00001,NULL,'15.1g',0.78,'Sm:',NULL,NULL,NULL,NULL,1,258.66125,72.39861,0.165,NULL,57053976263,891468379,13929193,15.1),(140887,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140887,32.71,0.43,34.8,68072,75,NULL,'3.6 micron, color corrected','UGC 10791',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140888,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140888,32.76,0.43,35.7,68072,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10791',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140889,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140889,37.51,0.27,317,68073,70,NULL,NULL,'2MASX J17144254+3149521',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00018,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,258.677333333,31.83106,0.165,NULL,56343284044,880363813,13755684,17.3),(140890,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140890,36.31,0.56,182,68074,70,NULL,NULL,'FAIRALL 1466',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.0b',0.42,NULL,NULL,NULL,NULL,NULL,1,258.6919583,-74.81283,0.293,NULL,44155930803,689936418,10780256,16),(140891,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140891,38.31,0.46,460,68075,70,NULL,NULL,'2MASX J17144925+3849491',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,258.70525,38.83022,0.181,NULL,59633503077,931773485,14558960,17.4),(140892,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140892,38.5,0.46,501,68076,70,NULL,NULL,'2MASX J17145055+2846067',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,258.71075,28.76839,0.165,NULL,56315680818,879932512,13748945,18.5),(140893,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140893,37.69,0.07,345,68077,70,NULL,NULL,'VII Zw 701',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000079,NULL,'17.3g',0.23,'Red',NULL,NULL,NULL,NULL,1,258.712166667,64.01017,0.121,NULL,57574335455,899598991,14056234,17.3),(140894,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140894,35.4,0.19,120,68078,70,NULL,NULL,'GIN 638',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000067,NULL,'15.5g',0.51,'E/S0',NULL,NULL,NULL,NULL,1,258.7235417,57.67336,0.081,NULL,57685357352,901333708,14083339,15.5),(140895,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140895,35.45,0.25,123,68078,74.4,NULL,NULL,'GIN 638',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140896,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140896,35.68,0.25,137,68078,70,NULL,NULL,'GIN 638',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140897,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140897,37.67,0.21,343,68079,70,NULL,NULL,'2MASX J17145408+6521238',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000069,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,258.7254583,65.35669,0.129,NULL,57516995266,898703051,14042235,17.6),(140898,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140898,37.67,0.46,341,68080,70,NULL,NULL,'2MASX J17145860+2933517',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000167,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,258.744167,29.56425,0.145,NULL,56360822868,880637857,13759966,16.8),(140899,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140899,37.56,0.64,325,68081,70,NULL,NULL,'2MASX J17150233-6846085',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,258.7597083,-68.76906,0.401,NULL,44979685846,702807591,10981368,15.4),(140900,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140900,36.27,0.46,180,68082,70,NULL,NULL,'2MASX J17150569+5925309',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00001,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,258.773666667,59.42522,0.061,NULL,57685198662,901331229,14083300,16.9),(140901,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140901,35.95,0.46,155,68083,70,NULL,NULL,'2MASX J17150626+3008392',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000187,NULL,'15.7g',0.39,'S0',NULL,NULL,NULL,NULL,1,258.7760417,30.14417,0.137,NULL,56360299995,880629687,13759838,15.7),(140902,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140902,37.9,0.46,380,68084,70,NULL,NULL,'2MASX J17150636+3728511',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,258.776417,37.48067,0.165,NULL,56133515513,877086179,13704471,17.7),(140903,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140903,35.49,NULL,125,68085,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2122',NULL,'2010Ap&SS.325..163P',2010,1,1.12,NULL,'G',0.000052,NULL,'16.3g',0.15,'Sd(f)',NULL,NULL,NULL,NULL,1,258.7800417,58.2405,0.057,NULL,57685926468,901342601,14083478,16.3),(140904,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140904,35.51,NULL,127,68085,NULL,NULL,'Dipole + Quadrupole','FGC 2122',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140905,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140905,35.52,NULL,127,68085,NULL,NULL,'Dipole','FGC 2122',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140906,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140906,35.54,NULL,128,68085,NULL,NULL,NULL,'FGC 2122',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140907,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140907,36.9,0.46,240,68086,70,NULL,NULL,'2MASX J17150860+6003196',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000073,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,258.785916667,60.05533,0.053,NULL,57554352648,899286760,14051355,17.5),(140908,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140908,34.83,NULL,92.4,68087,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2120',NULL,'2010Ap&SS.325..163P',2010,1,1.03,NULL,'G',0.000014,NULL,'16.5',0.13,'Sc',NULL,NULL,NULL,NULL,1,258.7930417,6.99142,0.321,NULL,56040843544,875638180,13681846,16.5),(140909,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140909,34.83,NULL,92.5,68087,NULL,NULL,'Dipole','FGC 2120',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140910,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140910,34.83,NULL,92.6,68087,NULL,NULL,'Dipole + Quadrupole','FGC 2120',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140911,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140911,34.9,0.43,95.5,68087,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2120',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140912,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140912,34.96,NULL,98.3,68087,NULL,NULL,NULL,'FGC 2120',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140913,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140913,37.7,0.46,346,68088,70,NULL,NULL,'2MASX J17151076+3815408',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,258.794917,38.26128,0.185,NULL,59632618799,931759668,14558744,17.5),(140914,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140914,38.21,0.46,439,68089,70,NULL,NULL,'2MASX J17151235+6419079',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,258.8017083,64.31908,0.093,NULL,57575132308,899611442,14056428,18),(140915,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140915,36.79,0.46,228,68090,70,NULL,NULL,'2MASX J17151768+6208240',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000079,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,258.823625,62.14014,0.085,NULL,57565444100,899460064,14054063,16.6),(140916,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140916,35.45,0.25,123,68091,74.4,NULL,NULL,'NGC 6338',NULL,'2013AJ....146...86T',2013,1,1.56,NULL,'G',0.00008,NULL,'13.6g',1,'cD;S0;PEG     blazar','Group member',NULL,NULL,NULL,1,258.845791667,57.41119,0.073,NULL,57692666609,901447915,14085123,13.6),(140917,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140917,35.68,0.25,137,68091,70,NULL,NULL,'NGC 6338',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140918,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140918,35.43,0.4,122,68091,NULL,NULL,'mean','NGC 6338',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140919,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140919,35.62,0.45,133,68091,NULL,NULL,'K','NGC 6338',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140920,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140920,35.46,0.25,124,68092,74.4,NULL,NULL,'NGC 6346',NULL,'2013AJ....146...86T',2013,1,0.93,NULL,'G',0.000063,NULL,'14.7g',0.63,'E','in a pair',NULL,NULL,NULL,1,258.852041667,57.32253,0.061,NULL,57690567135,901415111,14084611,14.7),(140921,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140921,35.68,0.25,137,68092,70,NULL,NULL,'NGC 6346',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140922,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140922,37.89,0.27,379,68093,70,NULL,NULL,'2MASX J17152917+6546501',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000097,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,258.871833333,65.78061,0.129,NULL,57517153147,898705517,14042273,16.6),(140923,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140923,37.62,0.19,334,68094,70,NULL,NULL,'2MASX J17153003+6439511',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000133,NULL,'15.8g',0.44,'E;BrClG        AGN',NULL,NULL,NULL,NULL,1,258.875125,64.66433,0.109,NULL,57574683738,899604433,14056319,15.8),(140924,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140924,36.03,0.49,161,68095,70,NULL,NULL,'2MASX J17153186-8641168',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,258.882,-86.688,0.181,NULL,44030510985,687976734,10749636,16),(140925,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140925,35.4,0.19,120,68096,70,NULL,NULL,'2MASX J17153166+5730085',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000072,NULL,'16.1g',0.28,'S0',NULL,NULL,NULL,NULL,1,258.882125,57.50247,0.073,NULL,57685319007,901333109,14083329,16.1),(140926,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140926,37.19,0.46,274,68097,70,NULL,NULL,'2MASX J17153282+5527525',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000114,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,258.886708333,55.46456,0.045,NULL,57697295357,901520239,14086253,16.2),(140927,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140927,37.79,0.33,361,68098,70,NULL,NULL,'2MASX J17153360+6539571',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000084,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,258.8902083,65.66578,0.129,NULL,57516818841,898700294,14042192,17.4),(140928,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140928,38.07,0.46,410,68099,70,NULL,NULL,'2MASX J17153431+2620330',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,258.893083,26.3425,0.137,NULL,56306362549,879786914,13746670,17.4),(140929,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140929,34.82,0.17,89.3,68100,74.2,NULL,'SALT 2','CGCG 111-016',0.03066,'2010ApJ...716..712A',2010,1,0.8,NULL,'G',0.000097,NULL,'15.1',0.8,'SBa',NULL,NULL,NULL,NULL,1,258.89325,16.32486,0.369,NULL,56819354273,887802410,13871912,15.1),(140930,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140930,35.35,0.04,114,68100,70,NULL,'SALT 2','CGCG 111-016',0.03066,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140931,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140931,35.43,0.2,118,68100,72,NULL,NULL,'CGCG 111-016',0.03066,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140932,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140932,35.36,0.1,118,68100,60,NULL,'M(B) = -19.48 mag','CGCG 111-016',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140933,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140933,35.38,0.08,119,68100,60,NULL,'M(V) = -19.47 mag','CGCG 111-016',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140934,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140934,35.41,0.08,121,68100,74.4,NULL,NULL,'CGCG 111-016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140935,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140935,35.52,0.16,123,68100,70,NULL,'SALT 2','CGCG 111-016',0.03066,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140936,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140936,35.54,0.03,124,68100,72,NULL,NULL,'CGCG 111-016',0.03066,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140937,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140937,35.53,0.09,124,68100,70,NULL,NULL,'CGCG 111-016',0.03066,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140938,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140938,35.54,0.16,124,68100,70,NULL,'SALT','CGCG 111-016',0.03066,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140939,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140939,35.57,0.11,126,68100,65,NULL,'SALT2','CGCG 111-016',0.03066,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140940,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140940,35.59,0.17,127,68100,73.8,NULL,'SALT 2 (SNANA)','CGCG 111-016',0.0309,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140941,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140941,35.53,0.09,128,68100,60,NULL,'M(I) = -19.19 mag','CGCG 111-016',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140942,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140942,35.6,0.17,132,68100,70.8,NULL,NULL,'CGCG 111-016',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140943,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140943,35.68,0.19,133,68100,65,NULL,'SALT2','CGCG 111-016',0.03066,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140944,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140944,35.71,0.16,135,68100,65,NULL,'SALT','CGCG 111-016',0.03066,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140945,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140945,35.81,0.1,137,68100,65,NULL,'MLCS2k2','CGCG 111-016',0.03066,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140946,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140946,35.79,0.16,140,68100,65,NULL,'MLCS17','CGCG 111-016',0.03066,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140947,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140947,35.79,0.16,140,68100,65,NULL,'MLCS31','CGCG 111-016',0.03066,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140948,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140948,35.81,0.1,141,68100,65,NULL,'MLCS2k2','CGCG 111-016',0.03066,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140949,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140949,35.81,0.05,141,68100,65,NULL,'SALT','CGCG 111-016',0.03066,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140950,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140950,35.81,0.1,141,68100,65,NULL,'MLCS2k2','CGCG 111-016',0.03066,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140951,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140951,35.9,0.2,147,68100,65,NULL,NULL,'CGCG 111-016',0.03066,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140952,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140952,35.93,0.14,153,68100,60,NULL,NULL,'CGCG 111-016',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140953,'IRAS','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140953,32.77,0.8,35.8,68101,75,NULL,'MAT, I','IC 4635',NULL,'1997ApJS..109..333W',1997,1,3,'Allen, et al. (1991, MNRAS, 248, 528) give z=0.014 +/- 0.001.','G',0.000033,NULL,'11.81',0.7,'SAB(s)b: sp','in a triple',NULL,NULL,NULL,1,258.913291667,-77.48953,0.433,NULL,44138758090,689668095,10776063,11.81),(140954,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140954,32.21,0.49,27.7,68101,75,NULL,'IR','IC 4635',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140955,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140955,32.35,0.43,29.5,68101,75,NULL,'MAT, I, raw','IC 4635',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140956,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140956,32.36,0.32,29.7,68101,85,NULL,'I, raw','IC 4635',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140957,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140957,32.39,0.32,30.1,68101,85,NULL,'I, inv','IC 4635',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140958,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140958,32.51,0.43,31.8,68101,75,NULL,'MAT, I, inv','IC 4635',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140959,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140959,32.64,0.43,33.7,68101,75,NULL,'MAT, I, cor','IC 4635',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140960,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140960,35.4,0.19,120,68102,70,NULL,NULL,'2MASX J17154083+5732066',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000086,NULL,'16.3g',0.21,'S0^-',NULL,NULL,NULL,NULL,1,258.9202083,57.53528,0.073,NULL,57685369496,901333898,14083342,16.3),(140961,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140961,37.92,0.33,384,68103,70,NULL,NULL,'SDSS J171541.69+271112.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000128,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,258.923708333,27.18667,0.161,NULL,56319805158,879996955,13749952,18.8),(140962,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140962,37.89,0.46,378,68104,70,NULL,NULL,'SDSS J171541.91+631902.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000076,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,258.924666667,63.3175,0.109,NULL,57576893725,899638964,14056858,18.2),(140963,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140963,37.89,0.27,379,68105,70,NULL,NULL,'2MASX J17154250+6545411',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000085,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,258.927125,65.76131,0.129,NULL,57519966209,898749472,14042960,17.7),(140964,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140964,37.86,0.46,373,68106,70,NULL,NULL,'2MASX J17154429+2828350',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000173,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,258.934708333,28.47636,0.129,NULL,56317858226,879966534,13749477,17.2),(140965,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140965,35.03,0.49,101,68107,75,NULL,'IR','NGC 6330',NULL,'2011yCatp016004901K',2011,1,0.93,NULL,'G',0.000033,NULL,'14.8g',0.55,'SBb',NULL,NULL,NULL,NULL,1,258.935083333,29.40431,0.145,NULL,56360071050,880626110,13759782,14.8),(140966,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140966,35.4,0.2,120,68107,74.4,NULL,NULL,'NGC 6330',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140967,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140967,35.6,0.4,132,68107,NULL,NULL,'mean','NGC 6330',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140968,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140968,35.67,0.47,136,68107,NULL,NULL,'H','NGC 6330',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140969,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140969,35.8,0.45,145,68107,NULL,NULL,'K','NGC 6330',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140970,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140970,37.62,0.19,334,68108,70,NULL,NULL,'2MASX J17154826+6439531',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000069,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,258.950791667,64.66481,0.109,NULL,57574642927,899603795,14056309,17.9),(140971,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140971,37.92,0.33,384,68109,70,NULL,NULL,'2MASX J17155032+2715405',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,258.959583,27.26125,0.161,NULL,56319345289,879989770,13749840,16.8),(140972,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140972,38.45,0.46,491,68110,70,NULL,NULL,'2MASX J17155274+3656070',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,258.9697917,36.93539,0.209,NULL,56133915598,877092431,13704569,17.2),(140973,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140973,37.62,0.19,334,68111,70,NULL,NULL,'2MASX J17155373+6441121',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00008,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,258.974,64.68672,0.109,NULL,57574643008,899603797,14056309,18),(140974,'GRB','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140974,46.94,1.63,8270,68112,100,NULL,NULL,'GRB 080319C',1.95,'2009EPJC...63..139W',2009,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,258.981083,55.39206,0.101,NULL,57697251100,901519548,14086242,NULL),(140975,'GRB','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140975,47.14,1.57,9080,68112,100,NULL,NULL,'GRB 080319C',1.95,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140976,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140976,37.79,0.33,361,68113,70,NULL,NULL,'2MASX J17155478+6537281',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000084,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,258.9785417,65.62447,0.129,NULL,57516820781,898700324,14042192,17.6),(140977,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140977,37.67,0.21,343,68114,70,NULL,NULL,'SDSS J171557.24+652130.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000078,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,258.9885417,65.35858,0.129,NULL,57516854542,898700852,14042200,18.3),(140978,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140978,37.67,0.46,342,68115,70,NULL,NULL,'2MASX J17155833+2949194',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00014,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,258.993083,29.82194,0.133,NULL,56360901300,880639082,13759985,17.9),(140979,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140979,38.2,0.46,436,68116,70,NULL,NULL,'2MASX J17155889+3038275',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,258.9954583,30.64094,0.133,NULL,56362061739,880657214,13760268,17.6),(140980,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140980,35.89,0.53,151,68117,70,NULL,NULL,'2MASX J17160021-1615393',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,259.0009583,-16.26094,1.609,NULL,45993940760,718655324,11228989,15.1),(140981,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140981,37.18,0.46,273,68118,70,NULL,NULL,'2MASX J17160336+2959192',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000139,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,259.014083333,29.98883,0.133,NULL,56360859691,880638432,13759975,17.9),(140982,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140982,38.46,0.27,493,68119,70,NULL,NULL,'2MASX J17160643+3046593',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000173,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,259.026875,30.78331,0.133,NULL,56361523297,880648801,13760137,18.2),(140983,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140983,37.69,0.07,345,68120,70,NULL,NULL,'ZwCl 1710.4+6401 47',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000107,NULL,'17.3g',0.21,'Red',NULL,NULL,NULL,NULL,1,259.027417,64.0455,0.121,NULL,57574370730,899599542,14056242,17.3),(140984,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140984,38.14,0.46,425,68121,70,NULL,NULL,'2MASX J17160901+2623224',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,259.0377083,26.38964,0.153,NULL,56305455803,879772746,13746449,17.4),(140985,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140985,38.4,0.33,478,68122,70,NULL,NULL,'2MASX J17161008+3844260',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,259.042166667,38.74056,0.181,NULL,59633496399,931773381,14558959,17.8),(140986,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140986,38.46,0.27,493,68123,70,NULL,NULL,'2MASX J17161031+3047383',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.4g',0.2,'BrClG',NULL,NULL,NULL,NULL,1,259.0430417,30.794,0.133,NULL,56361524165,880648815,13760137,17.4),(140987,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140987,33.99,0.49,62.7,68124,70,NULL,NULL,'FAIRALL 1469',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.000073,NULL,'13.8R',0.5,NULL,NULL,NULL,NULL,NULL,1,259.0464583,-73.38539,0.213,NULL,44153609104,689900142,10779689,13.8),(140988,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140988,37.62,0.19,334,68125,70,NULL,NULL,'2MASX J17161256+6454172',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000069,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,259.052375,64.90489,0.109,NULL,57574429967,899600468,14056257,17.9),(140989,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140989,37.69,0.07,345,68126,70,NULL,NULL,'2MASX J17161489+6356402',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000098,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,259.061667,63.94467,0.121,NULL,57574422009,899600343,14056255,16.4),(140990,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140990,38.4,0.33,478,68127,70,NULL,NULL,'2MASX J17161735+3844360',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,259.07225,38.74328,0.181,NULL,59633494766,931773355,14558958,17.7),(140991,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140991,37.69,0.07,345,68128,70,NULL,NULL,'VII Zw 702',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000093,NULL,'16.6g',0.35,'Red',NULL,NULL,NULL,NULL,1,259.07675,64.13272,0.093,NULL,57574257528,899597773,14056215,16.6),(140992,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140992,38.44,0.46,487,68129,70,NULL,NULL,'2MASX J17162014+4051390',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,259.08375,40.86083,0.057,NULL,59632151892,931752373,14558630,17.1),(140993,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140993,38.54,0.46,509,68130,70,NULL,NULL,'2MASX J17162035+2800200',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,259.084833,28.00561,0.157,NULL,56317635724,879963058,13749422,17.6),(140994,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140994,37.89,0.27,379,68131,70,NULL,NULL,'2MASX J17162152+6545543',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000082,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,259.09,65.76511,0.113,NULL,57519980175,898749690,14042963,17.5),(140995,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140995,35.46,0.25,124,68132,74.4,NULL,NULL,'GIN 637',NULL,'2013AJ....146...86T',2013,1,0.49,NULL,'G',0.000076,NULL,'15.9g',0.46,'S',NULL,NULL,NULL,NULL,1,259.099958333,57.42272,0.073,NULL,57692716312,901448692,14085135,15.9),(140996,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140996,35.68,0.25,137,68133,70,NULL,NULL,'SDSS J171624.48+572517.9',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'*',NULL,NULL,'15.5g',NULL,'Point Src [SDSS]',NULL,NULL,NULL,NULL,1,259.102,57.42167,0.073,NULL,57692716315,901448692,14085135,15.5),(140997,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140997,37.78,0.33,359,68134,70,NULL,NULL,'2MASX J17162718+2820591',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000161,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,259.1132917,28.34967,0.129,NULL,56317948272,879967941,13749499,17.3),(140998,'IRAS','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140998,34.84,0.8,92.9,68135,75,NULL,'CF, r','UGC 10779',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000027,NULL,'14.10',0.8,'Sb',NULL,NULL,NULL,NULL,1,259.127375,6.43197,0.333,NULL,56040175835,875627747,13681683,14.1),(140999,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140999,34.45,0.38,77.5,68135,75,NULL,'CF, r, raw','UGC 10779',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141000,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141000,34.63,0.38,84.3,68135,75,NULL,'CF, r, inv','UGC 10779',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141001,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141001,34.69,0.47,86.9,68135,NULL,NULL,'H','UGC 10779',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141002,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141002,34.73,0.38,88.5,68135,75,NULL,'CF, r, cor','UGC 10779',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141003,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141003,34.77,0.45,90.1,68135,NULL,NULL,'K','UGC 10779',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141004,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141004,34.86,0.46,93.7,68135,NULL,NULL,'J','UGC 10779',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141005,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141005,35.05,0.4,102,68135,NULL,NULL,'mean','UGC 10779',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141006,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141006,34.75,0.49,89.2,68136,75,NULL,'IR','UGC 10780',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',NULL,NULL,'16.5',0.1,'Scd',NULL,NULL,NULL,NULL,1,259.142917,7.32617,0.353,NULL,56043626852,875681669,13682526,16.5),(141007,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141007,34.9,0.43,95.4,68136,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10780',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141008,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141008,35.07,0.43,104,68136,75,NULL,'3.6 micron, color corrected','UGC 10780',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141009,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141009,35.17,0.37,108,68136,NULL,NULL,'Malmquist cor.','UGC 10780',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141010,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141010,35.22,0.36,111,68136,NULL,NULL,NULL,'UGC 10780',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141011,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141011,35.23,0.2,111,68136,74.4,NULL,NULL,'UGC 10780',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141012,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141012,35.46,NULL,124,68136,NULL,NULL,'Dipole + Quadrupole','UGC 10780',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141013,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141013,35.47,NULL,124,68136,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10780',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141014,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141014,35.48,NULL,125,68136,NULL,NULL,'Dipole','UGC 10780',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141015,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141015,37.62,0.19,334,68137,70,NULL,NULL,'2MASX J17163493+6436573',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000062,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,259.145333,64.61603,0.109,NULL,57574651079,899603923,14056311,18.1),(141016,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141016,37.29,0.46,287,68138,70,NULL,NULL,'2MASX J17163697+6003144',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00002,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,259.154416667,60.05408,0.053,NULL,57554368076,899287001,14051359,16.9),(141017,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141017,38.46,0.27,493,68139,70,NULL,NULL,'2MASX J17163941+3045143',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000147,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,259.164125,30.75403,0.133,NULL,56362016113,880656501,13760257,17.4),(141018,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141018,37.78,0.33,359,68140,70,NULL,NULL,'2MASX J17164567+2826191',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000152,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,259.1902083,28.43875,0.161,NULL,56317939895,879967810,13749497,17),(141019,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141019,36.55,0.46,204,68141,70,NULL,NULL,'2MASX J17164585+6305524',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000099,NULL,'15.8g',0.43,'E0',NULL,NULL,NULL,NULL,1,259.190833,63.09794,0.113,NULL,57576948075,899639813,14056872,15.8),(141020,'SZ effect','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141020,40.09,0.98,1040,68142,NULL,NULL,'Hydrost. Eq.','RX J1716.4+6708',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,259.206667,67.14167,0.149,NULL,57790999205,902984362,14109130,NULL),(141021,'SZ effect','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141021,40.59,1.15,1310,68142,NULL,NULL,'Isotherm.','RX J1716.4+6708',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141022,'SZ effect','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141022,41.6,1.02,2090,68142,NULL,NULL,'Isotherm., r < 100 kpc','RX J1716.4+6708',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141023,'SZ effect','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141023,41.72,NULL,2210,68142,NULL,NULL,'4.2 (black) calibration','RX J1716.4+6708',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141024,'SZ effect','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141024,41.73,NULL,2220,68142,NULL,NULL,'3.1 (red) calibration','RX J1716.4+6708',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141025,'SZ effect','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141025,41.79,NULL,2280,68142,NULL,NULL,'4.1 (blue) calibration','RX J1716.4+6708',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141026,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141026,37.67,0.21,343,68143,70,NULL,NULL,'2MASX J17165000+6529203',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000084,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,259.207917,65.48911,0.117,NULL,57520353149,898755517,14043054,16.6),(141027,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141027,35.44,0.46,123,68144,70,NULL,NULL,'CGCG 170-011',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000157,NULL,'15.2g',0.52,'E0',NULL,NULL,NULL,NULL,1,259.217417,31.58414,0.145,NULL,56361098011,880642156,13760033,15.2),(141028,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141028,36.38,0.46,189,68145,70,NULL,NULL,'2MASX J17165264+5727490',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000086,NULL,'16.2g',0.38,'E0',NULL,NULL,NULL,NULL,1,259.21925,57.46372,0.073,NULL,57692697491,901448398,14085131,16.2),(141029,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141029,38.44,0.46,487,68146,70,NULL,NULL,'2MASX J17165614+6229193',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000102,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,259.234375,62.48869,0.089,NULL,57576684051,899635688,14056807,16.9),(141030,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141030,38.4,0.27,479,68147,70,NULL,NULL,'2MASX J17165630+2831185',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,259.234625,28.52172,0.161,NULL,56317796164,879965565,13749461,18.2),(141031,'Ring Diameter','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141031,30.6,0.76,13,68148,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 6300',NULL,'1981ApJS...45..541P',1981,1,4.5,'Extended HIPASS source','G',0.00001,NULL,'10.98',3,'SB(rs)b        Sy2','Group member',NULL,NULL,'Sy 2',1,259.2477917,-62.82056,0.485,NULL,44491884324,695185692,10862276,10.98),(141032,'Ring Diameter','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141032,30.7,0.6,14,68148,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 6300',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141033,'Sosies','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141033,30.22,0.08,11.1,68148,NULL,NULL,NULL,'NGC 6300',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141034,'Tully est','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141034,30.78,0.8,14.3,68148,75,NULL,'B','NGC 6300',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141035,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141035,30.24,0.43,11.2,68148,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6300',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141036,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141036,30.4,0.43,12,68148,75,NULL,'3.6 micron, color corrected','NGC 6300',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141037,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141037,30.59,0.36,13.1,68148,NULL,NULL,NULL,'NGC 6300',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141038,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141038,30.59,0.39,13.1,68148,73,NULL,'opt','NGC 6300',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141039,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141039,30.73,0.2,14,68148,74.4,NULL,NULL,'NGC 6300',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141040,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141040,31.16,NULL,17.1,68148,NULL,NULL,'LEDA [April 2006]','NGC 6300',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141041,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141041,31.24,0.41,17.7,68148,NULL,NULL,NULL,'NGC 6300',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141042,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141042,31.4,0.38,19.1,68148,NULL,NULL,'Malmquist cor.','NGC 6300',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141043,'IRAS','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141043,32.59,0.8,32.9,68149,75,NULL,'A82, H','NGC 6339',NULL,'1997ApJS..109..333W',1997,1,2.9,NULL,'G',0.000013,NULL,'13.30',1.7,'SBd','Isolated galaxy (6 Mpc isolation)',NULL,NULL,NULL,1,259.277083,40.84497,0.057,NULL,59634191078,931784235,14559128,13.3),(141044,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141044,31.96,0.38,24.7,68149,NULL,NULL,NULL,'NGC 6339',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141045,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141045,31.99,0.43,25,68149,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6339',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141046,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141046,32.04,0.2,25.6,68149,74.4,NULL,NULL,'NGC 6339',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141047,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141047,32.04,0.43,25.6,68149,75,NULL,'3.6 micron, color corrected','NGC 6339',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141048,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141048,32.07,0.41,25.9,68149,NULL,NULL,NULL,'NGC 6339',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141049,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141049,32.41,0.47,30.3,68149,75,NULL,'A82, H, raw','NGC 6339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141050,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141050,32.42,0.47,30.4,68149,75,NULL,'A82, H, inv','NGC 6339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141051,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141051,32.45,0.35,30.8,68149,NULL,NULL,'Malmquist cor.','NGC 6339',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141052,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141052,32.64,0.4,33.7,68149,75,NULL,'B','NGC 6339',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141053,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141053,32.76,0.47,35.6,68149,75,NULL,'A82, H, cor','NGC 6339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141054,'CMD','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141054,14.9,NULL,0.0095,68150,NULL,NULL,NULL,'MESSIER 092',NULL,'2008A&A...477..139L',2008,1,NULL,NULL,'*Cl',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,259.2802917,43.13653,0.057,0,59649883496,932029429,14562959,NULL),(141055,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141055,37.45,0.46,310,68151,70,NULL,NULL,'2MASX J17170916+2950327',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000172,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,259.288167,29.8425,0.137,NULL,56360038308,880625598,13759774,16.8),(141056,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141056,36.42,0.33,193,68152,70,NULL,NULL,'VII Zw 703',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000088,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,259.32225,64.27,0.093,NULL,57575082150,899610658,14056416,16.8),(141057,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141057,36.86,0.46,236,68153,70,NULL,NULL,'2MASX J17171798+3015133',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,259.324917,30.25369,0.121,NULL,56360334230,880630222,13759847,17.3),(141058,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141058,37.87,0.46,374,68154,70,NULL,NULL,'2MASX J17171999+2814587',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,259.333166667,28.24958,0.129,NULL,56317650818,879963294,13749426,17.4),(141059,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141059,38.1,0.33,417,68155,70,NULL,NULL,'2MASX J17172058+3734249',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,259.33575,37.57369,0.197,NULL,56134311923,877098623,13704665,17.4),(141060,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141060,38.1,0.33,417,68156,70,NULL,NULL,'2MASX J17172099+3732159',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,259.3375,37.53772,0.197,NULL,56134318513,877098726,13704667,NULL),(141061,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141061,37.75,0.46,354,68157,70,NULL,NULL,'2MASX J17172203+2821387',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00018,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,259.3419583,28.36092,0.129,NULL,56317535302,879961489,13749398,16.8),(141062,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141062,36.42,0.33,193,68158,70,NULL,NULL,'2MASX J17172381+6417235',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000083,NULL,'16.1g',0.42,'LINER',NULL,NULL,NULL,'Sy 1',1,259.3492917,64.28992,0.093,NULL,57575083097,899610673,14056416,16.1),(141063,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141063,38.37,0.46,473,68159,70,NULL,NULL,'2MASX J17172387+3041383',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000209,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,259.349417,30.69386,0.133,NULL,56360176040,880627750,13759808,18.1),(141064,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141064,37.55,0.46,324,68160,70,NULL,NULL,'2MASX J17172733+4022258',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,259.364,40.37383,0.085,NULL,59634581863,931790341,14559224,17),(141065,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141065,35.43,0.46,122,68161,70,NULL,NULL,'2MASX J17172814+6609344',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000061,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,259.367541667,66.15958,0.121,NULL,57519947427,898749178,14042955,16.5),(141066,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141066,35.7,0.61,138,68162,70,NULL,NULL,'2MASX J17172872-7128054',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,259.369916667,-71.46814,0.385,NULL,44098124286,689033191,10766143,16.1),(141067,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141067,38.4,0.27,479,68163,70,NULL,NULL,'2MASX J17173038+2840156',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000202,NULL,'17.0g',0.26,'BrClG',NULL,NULL,NULL,NULL,1,259.3765417,28.67108,0.165,NULL,56317089529,879954523,13749289,17),(141068,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141068,38.22,0.46,440,68164,70,NULL,NULL,'2MASX J17173035+4110108',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,259.376625,41.16978,0.081,NULL,59632035871,931750560,14558602,17.6),(141069,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141069,37.73,0.46,352,68165,70,NULL,NULL,'SDSS J171730.90+635633.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000075,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,259.3787917,63.94269,0.121,NULL,57574407301,899600114,14056251,18.3),(141070,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141070,37.38,0.46,299,68166,70,NULL,NULL,'2MASX J17173243+6047235',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000076,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,259.385166667,60.78978,0.077,NULL,57563066169,899422908,14053482,17.2),(141071,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141071,37.55,0.46,324,68167,70,NULL,NULL,'2MASX J17173365+3056513',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,259.390167,30.94756,0.137,NULL,56369667834,880776059,13762125,17.2),(141072,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141072,34.79,0.62,91,68168,70,NULL,NULL,'2MASX J17173526-0432306',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,259.396917,-4.54186,1.001,NULL,45340358504,708443101,11069423,17.2),(141073,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141073,37.83,0.46,367,68169,70,NULL,NULL,'VII Zw 704',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000094,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,259.41075,61.14544,0.113,NULL,57566487465,899476366,14054318,17.2),(141074,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141074,37.84,0.46,369,68170,70,NULL,NULL,'2MASX J17174058+2442466',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,259.4192083,24.71292,0.281,NULL,56274080094,879282501,13738789,17.2),(141075,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141075,38.4,0.27,479,68171,70,NULL,NULL,'2MASX J17174185+2837436',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,259.4245417,28.62878,0.161,NULL,56317060038,879954063,13749282,17.7),(141076,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141076,36.59,0.63,208,68172,70,NULL,NULL,'2MASX J17174316-6612071',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,259.4300417,-66.202,0.261,NULL,44438152196,694346128,10849158,15.7),(141077,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141077,37.54,0.27,322,68173,70,NULL,NULL,'2MASX J17174612+2916486',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000201,NULL,'15.7g',0.51,'AGN',NULL,NULL,NULL,NULL,1,259.44225,29.28028,0.145,NULL,56314825828,879919153,13748736,15.7),(141078,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141078,36.17,0.57,172,68174,70,NULL,NULL,'2MASX J17174883-6448252',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,259.453417,-64.80706,0.293,NULL,44482223789,695034746,10859917,15.6),(141079,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 2010gn',NULL,141079,35.6,0.01,132,68175,NULL,NULL,'J, SN 2010gn','SDSS J171750.05+405252.5',NULL,'2012MNRAS.425.1007B',2012,1,0.35,NULL,'G',0,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,259.458583333,40.88128,0.057,NULL,59634328745,931786386,14559162,18.2),(141080,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 2010gn',NULL,141080,35.73,0.07,140,68175,72,NULL,'M(H) = -18.317 mag','SDSS J171750.05+405252.5',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141081,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 2010gn',NULL,141081,35.73,0.01,140,68175,NULL,NULL,'H, SN 2010gn','SDSS J171750.05+405252.5',NULL,'2012MNRAS.425.1007B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141082,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 2010gn',NULL,141082,35.82,0.04,141,68175,70,NULL,'SN 2010gn, SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','SDSS J171750.05+405252.5',0.0312,'2014MNRAS.438.1391P',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141083,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 2010gn',NULL,141083,35.83,0.04,142,68175,70,NULL,'SiFTO+SALT2, SN PTF10mwb, SN 2010gn','SDSS J171750.05+405252.5',0.0365,'2012MNRAS.426.2359M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141084,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141084,37.6,0.46,331,68176,70,NULL,NULL,'2MASX J17175031+6210025',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000078,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,259.4595417,62.16742,0.073,NULL,57565292481,899457695,14054026,17.7),(141085,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141085,35.37,0.62,118,68177,70,NULL,NULL,'2MASX J17175138-7033102',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,259.4639583,-70.55289,0.221,NULL,44097742648,689027228,10766050,16.2),(141086,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141086,37.97,0.46,393,68178,70,NULL,NULL,'2MASX J17175490+2748056',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,259.4787083,27.80158,0.133,NULL,56320382049,880005969,13750093,17.4),(141087,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141087,37.54,0.27,322,68179,70,NULL,NULL,'SDSS J171755.18+291337.0',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000176,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,259.479958333,29.22697,0.145,NULL,56316935180,879952112,13749251,17.2),(141088,'D-Sigma','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141088,32,0.4,25.1,68180,75,NULL,'Edat, raw','NGC 6305',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.00015,NULL,'13.24',1.1,'SB0^-',NULL,NULL,NULL,NULL,1,259.503833,-59.17208,0.501,NULL,44519130865,695611419,10868928,13.24),(141089,'D-Sigma','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141089,32.33,0.4,29.3,68180,75,NULL,'Edat, cor','NGC 6305',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141090,'Tully est','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141090,32.77,0.8,35.8,68180,75,NULL,NULL,'NGC 6305',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141091,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141091,32.74,0.45,35.4,68180,NULL,NULL,'K','NGC 6305',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141092,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141092,32.99,0.4,39.7,68180,NULL,NULL,'mean','NGC 6305',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141093,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141093,38.81,0.46,578,68181,70,NULL,NULL,'SDSS J171801.45+553343.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00008,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,259.506083,55.56219,0.081,NULL,57689215415,901393990,14084281,18.2),(141094,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141094,38.35,0.46,467,68182,70,NULL,NULL,'2MASX J17180363+2630380',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,259.515167,26.51067,0.165,NULL,56319052936,879985202,13749768,17.9),(141095,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141095,37.54,0.27,322,68183,70,NULL,NULL,'SDSS J171804.43+291850.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,259.518458333,29.31389,0.145,NULL,56314822717,879919104,13748736,18.3),(141096,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141096,37.87,0.46,374,68184,70,NULL,NULL,'SDSS J171805.55+303335.4',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000149,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,259.523166667,30.55986,0.129,NULL,56367797990,880746843,13761669,17.1),(141097,'Tully est','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141097,30.78,0.8,14.3,68185,75,NULL,NULL,'UKS 1713-578',NULL,'1988NBGC.C....0000T',1988,1,2.8,NULL,'G',0.000007,NULL,'13.7',1.2,'IB(s)m',NULL,NULL,NULL,NULL,1,259.530417,-57.86028,0.653,NULL,44521320027,695645625,10869462,13.7),(141098,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141098,37.83,0.46,367,68186,70,NULL,NULL,'2MASX J17180867+3746451',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,259.536167,37.77906,0.157,NULL,56134017483,877094023,13704594,17.1),(141099,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141099,36.57,0.51,206,68187,70,NULL,NULL,'2MASX J17181917-6430190',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,259.58,-64.50531,0.429,NULL,44482325107,695036329,10859942,15.1),(141100,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141100,36.73,0.6,222,68188,70,NULL,NULL,'2MASX J17182004-6901042',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,259.583625,-69.01786,0.401,NULL,44977228985,702769202,10980768,15.3),(141101,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141101,37.51,0.46,318,68189,70,NULL,NULL,'2MASX J17182381+2935331',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000147,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,259.5992083,29.59242,0.129,NULL,56367296637,880739009,13761547,17.8),(141102,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141102,36.26,0.46,178,68190,70,NULL,NULL,'2MASX J17182411+2942211',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000188,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,259.600417,29.70578,0.137,NULL,56367479509,880741867,13761591,16.5),(141103,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141103,37.84,0.46,370,68191,70,NULL,NULL,'2MASX J17182887+6556071',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00008,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,259.620083,65.93528,0.117,NULL,57520101292,898751582,14042993,16.9),(141104,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141104,38.36,0.46,469,68192,70,NULL,NULL,'2MASX J17183032+2440416',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,259.626417,24.67833,0.301,NULL,56272326175,879255096,13738360,17.4),(141105,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141105,37.57,0.27,326,68193,70,NULL,NULL,'2MASX J17183116+6425052',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000093,NULL,'16.8g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,259.629875,64.41811,0.089,NULL,57573496386,899585881,14056029,16.8),(141106,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141106,35.99,NULL,158,68194,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2126',NULL,'2010Ap&SS.325..163P',2010,1,0.95,NULL,'G',NULL,NULL,'16.5',0.11,'Sc',NULL,NULL,NULL,NULL,1,259.633875,41.66844,0.053,NULL,59649586953,932024796,14562887,16.5),(141107,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141107,36.01,NULL,159,68194,NULL,NULL,'Dipole + Quadrupole','FGC 2126',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141108,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141108,36.01,NULL,159,68194,NULL,NULL,NULL,'FGC 2126',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141109,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141109,36.03,NULL,161,68194,NULL,NULL,'Dipole','FGC 2126',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141110,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141110,36.12,0.49,168,68194,75,NULL,'IR','FGC 2126',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141111,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141111,37.57,0.27,326,68195,70,NULL,NULL,'SDSS J171833.75+642559.7',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000114,NULL,'17.4g',0.23,'NLAGN',NULL,NULL,NULL,NULL,1,259.640625,64.43331,0.089,NULL,57573496631,899585884,14056029,17.4),(141112,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141112,38.05,0.46,408,68196,70,NULL,NULL,'2MASX J17183560+3805292',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,259.648417,38.09139,0.173,NULL,56130173636,877033963,13703655,17.6),(141113,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141113,37.62,0.19,334,68197,70,NULL,NULL,'2MASX J17183688+6440342',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000098,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,259.653833333,64.67619,0.101,NULL,57573398923,899584358,14056005,17.2),(141114,'IRAS','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141114,33.67,0.8,54.1,68198,75,NULL,'CF, r','NGC 6361',NULL,'1997ApJS..109..333W',1997,1,1.51,NULL,'G',0.000037,NULL,'13.6g',0.69,'SAb: sp        NLAGN',NULL,NULL,NULL,NULL,1,259.6712083,60.60817,0.093,NULL,57554869751,899294839,14051481,13.6),(141115,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141115,33.6,0.38,52.6,68198,75,NULL,'CF, r, raw','NGC 6361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141116,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141116,33.73,0.49,55.7,68198,75,NULL,'IR','NGC 6361',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141117,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141117,33.74,0.2,56,68198,74.4,NULL,NULL,'NGC 6361',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141118,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141118,33.78,0.38,57.1,68198,75,NULL,'CF, r, inv','NGC 6361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141119,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141119,33.88,0.38,59.6,68198,75,NULL,'CF, r, cor','NGC 6361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141120,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141120,37.62,0.46,335,68199,70,NULL,NULL,'2MASX J17184135+6426482',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000091,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,259.672167,64.44697,0.089,NULL,57573497870,899585904,14056029,17.8),(141121,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141121,38.17,0.46,430,68200,70,NULL,NULL,'2MASX J17184219+5432555',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000089,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,259.675791667,54.54883,0.093,NULL,57466174975,897908983,14029827,17.3),(141122,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141122,36.43,0.46,193,68201,70,NULL,NULL,'2MASX J17184742+3055548',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,259.697625,30.93197,0.141,NULL,56370702923,880792233,13762378,17.1),(141123,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141123,36.99,0.33,250,68202,70,NULL,NULL,'2MASX J17184853+5749526',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00008,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,259.702416667,57.83111,0.081,NULL,57686282499,901348164,14083565,17.2),(141124,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141124,34.36,0.49,74.3,68203,75,NULL,'IR','UGC 10798',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.67',0.2,'Sbc','Isolated galaxy',NULL,NULL,NULL,1,259.712583333,19.52792,0.209,NULL,56826960428,887921256,13873769,15.67),(141125,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141125,38.08,0.33,414,68204,70,NULL,NULL,'2MASX J17185114+2703156',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000179,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,259.713167,27.05444,0.189,NULL,56319098288,879985910,13749779,17.5),(141126,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141126,31.37,0.4,18.8,68205,75,NULL,'B','UGC 10806',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.00001,NULL,'13.73',0.9,'SB(s)dm',NULL,NULL,NULL,NULL,1,259.714125,49.88419,0.069,NULL,57483769747,898183902,14034123,13.73),(141127,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141127,34.47,NULL,78.3,68206,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10817',NULL,'2010Ap&SS.325..163P',2010,1,1.05,NULL,'G',0.000124,NULL,'16.4g',0.17,'Sc(f)',NULL,NULL,NULL,NULL,1,259.7140417,61.22461,0.113,NULL,57566470520,899476101,14054314,16.4),(141128,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141128,34.49,NULL,79,68206,NULL,NULL,'Dipole + Quadrupole','UGC 10817',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141129,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141129,34.49,NULL,79,68206,NULL,NULL,'Dipole','UGC 10817',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141130,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141130,34.55,NULL,81.1,68206,NULL,NULL,NULL,'UGC 10817',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141131,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141131,37.57,0.27,326,68207,70,NULL,NULL,'2MASX J17185294+6426401',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000091,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,259.721083333,64.44458,0.089,NULL,57573506554,899586039,14056031,16.9),(141132,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141132,35.01,0.49,101,68208,75,NULL,'IR','UGC 10799',NULL,'2011yCatp016004901K',2011,1,1.23,NULL,'G',NULL,NULL,'16.00',0.13,'Scd',NULL,NULL,NULL,NULL,1,259.726917,29.85611,0.137,NULL,56367452947,880741452,13761585,16),(141133,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141133,35.27,NULL,113,68208,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10799',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141134,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141134,35.29,NULL,114,68208,NULL,NULL,'Dipole + Quadrupole','UGC 10799',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141135,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141135,35.3,NULL,115,68208,NULL,NULL,'Dipole','UGC 10799',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141136,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141136,36.99,0.33,250,68209,70,NULL,NULL,'2MASX J17185529+5749136',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000072,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,259.730417,57.82053,0.081,NULL,57686240729,901347511,14083554,17.3),(141137,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141137,38.08,0.33,414,68210,70,NULL,NULL,'2MASX J17185653+2701067',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,259.735625,27.01858,0.189,NULL,56319093330,879985833,13749778,17.4),(141138,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141138,38.02,0.46,403,68211,70,NULL,NULL,'2MASX J17185879+2817121',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,259.744917,28.28667,0.129,NULL,56310057638,879844650,13747572,17.6),(141139,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141139,34.05,0.2,64.6,68212,74.4,NULL,NULL,'UGC 10801',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',NULL,NULL,'16.1g',0.6,'Sd',NULL,NULL,NULL,NULL,1,259.760083,32.26986,0.149,NULL,56355953064,880561766,13758777,16.1),(141140,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141140,35.66,0.61,136,68213,70,NULL,NULL,'2MASX J17190403-6322261',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5b',NULL,'SAB:(r)0/a',NULL,NULL,NULL,NULL,1,259.7667083,-63.374,0.425,NULL,44491370457,695177663,10862150,15.5),(141141,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141141,37.77,0.46,358,68214,70,NULL,NULL,'2MASX J17190591+5513036',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000072,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,259.774583,55.21756,0.113,NULL,57689360422,901396256,14084316,17.7),(141142,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141142,35.71,0.77,139,68215,70,NULL,NULL,'2MASX J17190821-1856194',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000183,NULL,'18.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,259.784166667,-18.93867,1.429,NULL,46023902687,719123479,11236304,18.3),(141143,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141143,36.4,0.46,191,68216,70,NULL,NULL,'2MASX J17190864+6327301',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000088,NULL,'16.1g',0.38,'E0',NULL,NULL,NULL,NULL,1,259.786,63.45814,0.105,NULL,57576795882,899637435,14056834,16.1),(141144,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141144,37.09,0.46,262,68217,70,NULL,NULL,'2MASX J17191037+2821292',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000171,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,259.793333,28.35808,0.137,NULL,56309996019,879843687,13747557,16.2),(141145,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141145,36.78,0.46,227,68218,70,NULL,NULL,'2MASX J17191456+5817245',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000081,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,259.810375,58.29008,0.089,NULL,57686109785,901345465,14083522,16.3),(141146,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141146,38.26,0.46,449,68219,70,NULL,NULL,'2MASX J17191540+2428372',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,259.814041667,24.47689,0.301,NULL,56272269091,879254204,13738346,17.7),(141147,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141147,38.85,0.46,589,68220,70,NULL,NULL,'2MASX J17191820+5959231',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000102,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,259.8257083,59.98975,0.097,NULL,57555186654,899299791,14051559,17.2),(141148,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141148,35.53,0.62,128,68221,70,NULL,NULL,'2MASX J17191995-0147135',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,259.833083,-1.78703,0.665,NULL,45335612318,708368942,11068264,15.9),(141149,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141149,36.07,0.64,163,68222,70,NULL,NULL,'2MASX J17193279-6651295',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,259.88675,-66.85817,0.293,NULL,44970169453,702658897,10979045,14.4),(141150,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141150,37.42,0.46,305,68223,70,NULL,NULL,'2MASX J17193408+5842387',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00002,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,259.8920417,58.71078,0.081,NULL,57688306805,901379793,14084059,17.7),(141151,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141151,35.63,0.23,134,68224,70,NULL,NULL,'CGCG 277-035',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000097,NULL,'15.1g',0.49,'BrClG',NULL,NULL,NULL,NULL,1,259.895,56.63006,0.077,NULL,57691588575,901431071,14084860,15.1),(141152,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141152,38.1,0.46,417,68225,70,NULL,NULL,'2MASX J17193531+2655236',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,259.897208333,26.92322,0.189,NULL,56310792089,879856126,13747751,17.4),(141153,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141153,38.8,0.46,576,68226,70,NULL,NULL,'SDSS J171941.74+655525.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00009,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,259.9239583,65.92383,0.117,NULL,57520073480,898751148,14042986,18.4),(141154,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141154,38.52,0.46,505,68227,70,NULL,NULL,'2MASX J17194396+5627368',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000075,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,259.933125,56.46022,0.077,NULL,57691379598,901427806,14084809,18.2),(141155,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141155,37.55,0.33,323,68228,70,NULL,NULL,'2MASX J17194583+6611509',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000078,NULL,'17.2g',0.17,'BrClG',NULL,NULL,NULL,NULL,1,259.94075,66.19753,0.121,NULL,57519086462,898735725,14042745,17.2),(141156,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141156,37.79,0.33,361,68229,70,NULL,NULL,'2MASX J17194747+6330461',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000111,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,259.948083,63.51283,0.097,NULL,57578894790,899670231,14057347,16.9),(141157,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','PTF10ndc',NULL,141157,37.84,0.02,341,68230,70,NULL,'SiFTO+SALT2, SN PTF10ndc','PTF10ndc',0.0817,'2012MNRAS.426.2359M',2012,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,259.959167,28.53264,0.149,NULL,56310007064,879843860,13747560,NULL),(141158,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','PTF10ndc',NULL,141158,37.69,0.13,345,68230,NULL,NULL,'H','PTF10ndc',NULL,'2012MNRAS.425.1007B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141159,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','PTF10ndc',NULL,141159,37.72,0.04,350,68230,72,NULL,'M(H) = -18.317 mag','PTF10ndc',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141160,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','PTF10ndc',NULL,141160,37.73,0.05,351,68230,NULL,NULL,'J','PTF10ndc',NULL,'2012MNRAS.425.1007B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141161,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141161,32.05,0.4,25.7,68231,75,NULL,'B','UGC 10805',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000013,NULL,'15.3',1.5,'SBm','Isolated galaxy',NULL,NULL,NULL,1,259.9624583,14.40019,0.461,NULL,56822956526,887858695,13872792,15.3),(141162,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141162,33.88,0.69,59.7,68232,100,NULL,'mid-IR','NGC 6347',NULL,'2013ApJ...771...88L',2013,1,1.2,NULL,'G',0.000009,NULL,'14.47',0.7,'SBb','Isolated galaxy',NULL,NULL,NULL,1,259.977791667,16.66069,0.369,NULL,56818730257,887792660,13871760,14.47),(141163,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141163,34.71,0.47,87.4,68232,NULL,NULL,'H','NGC 6347',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141164,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141164,34.76,0.46,89.6,68232,NULL,NULL,'J','NGC 6347',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141165,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141165,34.76,0.4,89.7,68232,NULL,NULL,'mean','NGC 6347',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141166,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141166,34.81,0.45,91.5,68232,NULL,NULL,'K','NGC 6347',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141167,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141167,37.55,0.33,323,68233,70,NULL,NULL,'2MASX J17195792+6614058',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000105,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,259.9915,66.23494,0.121,NULL,57519085270,898735707,14042745,17.5),(141168,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141168,35.43,0.49,122,68234,70,NULL,NULL,'2MASX J17195854-0135185',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00012,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,259.993917,-1.58844,0.661,NULL,45335498297,708367160,11068236,14.6),(141169,'IRAS','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141169,33.78,0.8,57.1,68235,75,NULL,'MAT, I','ESO 138- G 021',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'14.02',1,'S...',NULL,NULL,NULL,NULL,1,260.0345417,-60.157,0.405,NULL,44448072527,694501133,10851580,14.02),(141170,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141170,34.09,0.32,65.7,68235,85,NULL,'I, raw','ESO 138- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141171,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141171,34.14,0.32,67.4,68235,85,NULL,'I, inv','ESO 138- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141172,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141172,34.15,0.43,67.5,68235,75,NULL,'MAT, I, raw','ESO 138- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141173,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141173,34.32,0.43,73.1,68235,75,NULL,'MAT, I, cor','ESO 138- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141174,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141174,34.4,0.43,75.8,68235,75,NULL,'MAT, I, inv','ESO 138- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141175,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141175,37.58,0.46,327,68236,70,NULL,NULL,'SDSS J172009.17+301758.1',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,260.03825,30.2995,0.133,NULL,56368284013,880754437,13761788,17.3),(141176,'SZ effect','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141176,38.54,1.45,510,68237,NULL,NULL,'Isotherm., r < 100 kpc','ABELL 2259',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'Compact [Zw]',NULL,NULL,NULL,NULL,1,260.037083,27.67028,0.169,NULL,56311400690,879865635,13747900,NULL),(141177,'SZ effect','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141177,38.58,1.65,520,68237,NULL,NULL,'Isotherm.','ABELL 2259',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141178,'SZ effect','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141178,38.82,1,580,68237,NULL,NULL,'Hydrost. Eq.','ABELL 2259',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141179,'SZ effect','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141179,38.99,NULL,629,68237,NULL,NULL,'3.1 (red) calibration','ABELL 2259',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141180,'SZ effect','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141180,39.01,NULL,634,68237,NULL,NULL,'4.2 (black) calibration','ABELL 2259',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141181,'SZ effect','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141181,39.22,NULL,698,68237,NULL,NULL,'4.1 (blue) calibration','ABELL 2259',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141182,'CMD','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141182,19.4,0.3,0.076,68238,NULL,NULL,'PHOTOELECTRIC','Draco Dwarf',NULL,'1979AJ.....84.1149S',1979,1,35.5,NULL,'G',0.00007,NULL,'10.9',24.5,'E pec','Isolated galaxy',NULL,NULL,NULL,1,260.051625,57.91536,0.081,1,57685743242,901339738,14083433,10.9),(141183,'CMD','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141183,19.49,0.11,0.0791,68238,NULL,NULL,NULL,'Draco Dwarf',NULL,'2002MNRAS.332...91D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141184,'CMD','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141184,19.54,NULL,0.0809,68238,NULL,NULL,NULL,'Draco Dwarf',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141185,'Horizontal Branch','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141185,19.28,0.09,0.072,68238,NULL,NULL,NULL,'Draco Dwarf',NULL,'1995MNRAS.277.1354I',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141186,'Horizontal Branch','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141186,19.38,NULL,0.075,68238,NULL,NULL,NULL,'Draco Dwarf',NULL,'1985IAUS..113..541W',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141187,'Horizontal Branch','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141187,19.48,NULL,0.0787,68238,NULL,NULL,NULL,'Draco Dwarf',NULL,'1998AJ....115..144G',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141188,'Horizontal Branch','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141188,19.5,0.2,0.0807,68238,NULL,NULL,NULL,'Draco Dwarf',NULL,'2001AJ....122.2524A',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141189,'Horizontal Branch','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141189,19.6,0.18,0.0832,68238,NULL,NULL,NULL,'Draco Dwarf',NULL,'2002MNRAS.332...91D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141190,'RR Lyrae','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141190,19.4,0.02,0.076,68238,NULL,NULL,'94','Draco Dwarf',NULL,'2004AJ....127..861B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141191,'RR Lyrae','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141191,19.51,NULL,0.0798,68238,NULL,NULL,'Z, Fe/H = -1.74','Draco Dwarf',NULL,'2008AJ....136.1921K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141192,'RR Lyrae','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141192,19.55,NULL,0.0812,68238,NULL,NULL,'Z, Fe/H = -2.00','Draco Dwarf',NULL,'2008AJ....136.1921K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141193,'RR Lyrae','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141193,19.58,0.15,0.0824,68238,NULL,NULL,NULL,'Draco Dwarf',NULL,'2008AJ....136.1921K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141194,'RR Lyrae','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141194,19.59,NULL,0.0828,68238,NULL,NULL,NULL,'Draco Dwarf',NULL,'2008ApJ...679...52T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141195,'RR Lyrae','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141195,19.62,0.29,0.084,68238,NULL,NULL,'Photographic, 10, RRd','Draco Dwarf',NULL,'1985AJ.....90..204N',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141196,'TRGB','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141196,19.49,0.06,0.0791,68238,NULL,NULL,'Syst. +/- 0.15 mag','Draco Dwarf',NULL,'2005A&A...442..165C',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141197,'TRGB','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141197,19.5,NULL,0.08,68238,NULL,NULL,NULL,'Draco Dwarf',NULL,'2000glg..book.....V',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141198,'TRGB','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141198,19.49,0.14,0.08,68238,74.4,NULL,NULL,'Draco Dwarf',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141199,'TRGB','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141199,19.84,0.14,0.093,68238,NULL,NULL,'I','Draco Dwarf',NULL,'2002AJ....124.3222B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141200,'Tully est','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141200,20,0.8,0.1,68238,75,NULL,'B','Draco Dwarf',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141201,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141201,37.93,0.46,386,68239,70,NULL,NULL,'SDSS J172013.83+644541.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000066,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,260.057625,64.76158,0.101,NULL,57573411967,899584561,14056008,18.1),(141202,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141202,38.44,0.46,487,68240,70,NULL,NULL,'SDSS J172014.59+645007.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000085,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,260.0607917,64.83539,0.101,NULL,57518093679,898720213,14042503,17.8),(141203,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141203,37.35,0.46,295,68241,70,NULL,NULL,'2MASX J17201519+2806347',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,260.063333,28.10958,0.149,NULL,56311723510,879870679,13747979,17.2),(141204,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141204,37.43,0.46,306,68242,70,NULL,NULL,'2MASX J17201528+6544335',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00009,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,260.063833,65.74275,0.113,NULL,57520638165,898759971,14043124,16.4),(141205,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141205,37.44,0.46,307,68243,70,NULL,NULL,'SDSS J172017.71+540556.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000058,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,260.073791667,54.09892,0.117,NULL,57495731819,898370809,14037043,18.4),(141206,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141206,37.67,0.46,342,68244,70,NULL,NULL,'2MASX J17201993+3010329',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000169,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,260.083166667,30.17594,0.133,NULL,56368291928,880754561,13761790,17.9),(141207,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN CLO12Car','N',141207,43.71,0.16,2420,68245,71.6,NULL,'MLCS2k2','SN CLO12Car',1.28,'2014ApJ...786....9P',2013,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141208,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN CLO12Car','N',141208,43.83,0.24,2560,68245,71.6,NULL,'SALT 2','SN CLO12Car',1.28,'2014ApJ...786....9P',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141209,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN CLO12Car','N',141209,44.74,0.24,3890,68245,71.6,NULL,'SALT 2 + G Lens mag = 0.91 mag','SN CLO12Car',1.28,'2014ApJ...786....9P',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141210,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN CLO12Car','N',141210,44.77,0.16,3950,68245,71.6,NULL,'MLCS2k2 + G Lens = 1.06 mag','SN CLO12Car',1.28,'2014ApJ...786....9P',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141211,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141211,35.21,0.56,110,68246,70,NULL,NULL,'2MASX J17202900-0038301',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000073,NULL,'14.0I',0.3,NULL,NULL,NULL,NULL,NULL,1,260.120791667,-0.64175,0.565,NULL,45114593144,704915517,11014304,14),(141212,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141212,36.57,0.84,206,68247,70,NULL,NULL,'2MASX J17202942-0126011',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,260.122625,-1.43369,0.609,NULL,45335446505,708366351,11068224,16.1),(141213,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141213,37.59,0.46,330,68248,70,NULL,NULL,'2MASX J17203033+3404161',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,260.126417,34.07117,0.125,NULL,56350462560,880475977,13757437,NULL),(141214,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141214,36.8,0.57,229,68249,70,NULL,NULL,'2MASX J17203147-8018443',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,260.131083333,-80.31231,0.325,NULL,44041796036,688153063,10752391,16.7),(141215,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141215,36.5,0.46,199,68250,70,NULL,NULL,'2MASX J17203205+2806028',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000173,NULL,'16.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,260.133458333,28.10083,0.149,NULL,56311897060,879873391,13748021,16.6),(141216,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141216,34.75,0.7,88.9,68251,70,NULL,NULL,'2MFGC 13812',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000127,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,260.1487917,-1.67561,0.685,NULL,45334423450,708350366,11067974,14.7),(141217,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141217,36.78,0.33,227,68252,70,NULL,NULL,'2MASX J17204393+2842295',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000178,NULL,'16.7g',0.28,'AGN',NULL,NULL,NULL,NULL,1,260.183125,28.70819,0.149,NULL,56310586956,879852921,13747701,16.7),(141218,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141218,37.79,0.33,361,68253,70,NULL,NULL,'SDSS J172045.56+632812.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000077,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,260.189875,63.47008,0.097,NULL,57578889383,899670146,14057346,17.8),(141219,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141219,38.45,0.46,489,68254,70,NULL,NULL,'2MASX J17204639+2735305',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,260.19325,27.59178,0.169,NULL,56311329925,879864530,13747883,17.9),(141220,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141220,36.12,0.68,167,68255,70,NULL,NULL,'2MASX J17204757-0154203',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,260.198166667,-1.90569,0.729,NULL,45334511312,708351739,11067995,14.5),(141221,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141221,37.87,0.27,375,68256,70,NULL,NULL,'2MASX J17205280+2721186',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000172,NULL,'16.8g',0.27,'AGN',NULL,NULL,NULL,NULL,1,260.220041667,27.35528,0.169,NULL,56311651697,879869557,13747961,16.8),(141222,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141222,37.87,0.27,375,68257,70,NULL,NULL,'2MASX J17205408+2722336',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,260.225417,27.37608,0.169,NULL,56311650958,879869546,13747961,17.4),(141223,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141223,37.87,0.27,375,68258,70,NULL,NULL,'2MASX J17205543+2720016',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,260.230875,27.33383,0.169,NULL,56311648693,879869510,13747961,17.8),(141224,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141224,36.96,0.46,247,68259,70,NULL,NULL,'2MASX J17205696+5512282',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000114,NULL,'16.0g',0.45,'E0',NULL,NULL,NULL,NULL,1,260.237333,55.20778,0.109,NULL,57689499011,901398422,14084350,16),(141225,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141225,35.65,NULL,135,68260,NULL,NULL,'Dipole','UGC 10820',NULL,'2010Ap&SS.325..163P',2010,1,1.79,NULL,'G',0.000123,NULL,'16.5',0.24,'Sbc',NULL,NULL,NULL,NULL,1,260.23925,42.15556,0.061,NULL,59651164938,932049452,14563272,16.5),(141226,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141226,35.66,NULL,135,68260,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10820',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141227,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141227,35.66,NULL,135,68260,NULL,NULL,'Dipole + Quadrupole','UGC 10820',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141228,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141228,35.87,0.49,149,68260,75,NULL,'IR','UGC 10820',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141229,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141229,35.99,0.58,158,68261,70,NULL,NULL,'2MASX J17205855-6512030',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,260.244,-65.20092,0.285,NULL,44438024976,694344140,10849127,14.4),(141230,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141230,36.78,0.33,227,68262,70,NULL,NULL,'2MASX J17210438+2842266',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000185,NULL,'16.1g',0.35,'E0',NULL,NULL,NULL,NULL,1,260.268083,28.70728,0.129,NULL,56310415452,879850241,13747660,16.1),(141231,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141231,37.34,0.33,294,68263,70,NULL,NULL,'2MASX J17210555+6130058',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000076,NULL,'16.1g',0.39,'E0',NULL,NULL,NULL,NULL,1,260.273208333,61.50175,0.105,NULL,57566628900,899478576,14054352,16.1),(141232,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141232,37.93,0.46,386,68264,70,NULL,NULL,'2MASX J17210726+2734508',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000178,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,260.2802083,27.58089,0.169,NULL,56311330926,879864545,13747883,17.6),(141233,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141233,37.31,0.46,290,68265,70,NULL,NULL,'2MASX J17210788+6555308',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000087,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,260.282625,65.92522,0.113,NULL,57520040879,898750638,14042978,16.8),(141234,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141234,37.95,0.46,389,68266,70,NULL,NULL,'2MASX J17211342+5315327',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000075,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,260.306,53.25908,0.117,NULL,57499223400,898425365,14037896,17.8),(141235,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141235,35.69,0.61,137,68267,70,NULL,NULL,'2MASX J17211410-0101219',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000143,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,260.308875,-1.02275,0.609,NULL,45117784564,704965383,11015084,14.1),(141236,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141236,36.03,0.51,161,68268,70,NULL,NULL,'2MASX J17211811-6322441',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,260.325375,-63.37894,0.393,NULL,44492419923,695194061,10862407,16),(141237,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141237,37.35,0.46,295,68269,70,NULL,NULL,'2MASX J17213008+5943255',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00001,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,260.3755,59.72378,0.057,NULL,57554727886,899292623,14051447,17.1),(141238,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141238,38.45,0.33,490,68270,70,NULL,NULL,'2MASX J17213019+3320160',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,260.375625,33.33769,0.165,NULL,56348885118,880451329,13757052,17.7),(141239,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141239,36.35,0.59,186,68271,70,NULL,NULL,'2MASX J17213314-6604383',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,260.3879583,-66.07725,0.237,NULL,44436222022,694315969,10848687,15.2),(141240,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141240,37.89,0.46,378,68272,70,NULL,NULL,'2MASX J17213421+2756178',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,260.392667,27.93825,0.149,NULL,56311806668,879871979,13747999,17.5),(141241,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141241,37.34,0.33,294,68273,70,NULL,NULL,'2MASX J17213419+6131119',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000068,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,260.392833,61.52,0.089,NULL,57565905592,899467274,14054176,17.9),(141242,'IRAS','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141242,33.74,0.8,56,68274,75,NULL,'MAT, I','ESO 102- G 002',NULL,'1997ApJS..109..333W',1997,1,1.7,'Confused HIPASS source','G',0.000022,NULL,'14.06',1.3,'SA(s)c',NULL,NULL,NULL,NULL,1,260.41225,-65.17428,0.289,NULL,44438023547,694344117,10849126,14.06),(141243,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141243,33.29,0.32,45.4,68274,85,NULL,'I, raw','ESO 102- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141244,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141244,33.29,0.32,45.6,68274,85,NULL,'I, inv','ESO 102- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141245,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141245,33.78,0.43,56.9,68274,75,NULL,'MAT, I, raw','ESO 102- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141246,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141246,33.91,0.43,60.5,68274,75,NULL,'MAT, I, inv','ESO 102- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141247,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141247,34.02,0.43,63.6,68274,75,NULL,'MAT, I, cor','ESO 102- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141248,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141248,38.45,0.33,490,68275,70,NULL,NULL,'2MASX J17214022+3320575',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,260.417791667,33.34942,0.165,NULL,56348688535,880448258,13757004,17.8),(141249,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141249,37.18,0.46,274,68276,70,NULL,NULL,'2MASX J17214208+5411014',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.0001,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,260.425625,54.18383,0.117,NULL,57495713316,898370520,14037039,16.8),(141250,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141250,30.04,0.43,10.2,68277,75,NULL,'3.6 micron, color + selection bias corrected','IC 4660',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.000013,NULL,'14.50',0.3,'S','in a pair',NULL,NULL,NULL,1,260.43825,75.8485,0.157,NULL,57072866126,891763533,13933805,14.5),(141251,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141251,30.63,0.4,13.4,68277,75,NULL,NULL,'IC 4660',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141252,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141252,31.29,0.49,18.1,68277,75,NULL,'IR','IC 4660',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141253,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141253,38.7,0.46,549,68278,70,NULL,NULL,'2MASX J17215104+2741207',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000148,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,260.462833333,27.689,0.157,NULL,56311421754,879865964,13747905,18.3),(141254,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141254,37.77,0.46,357,68279,70,NULL,NULL,'2MASX J17215144+2715527',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000183,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,260.4645,27.26469,0.169,NULL,56311598430,879868725,13747948,17.1),(141255,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141255,37.55,0.46,323,68280,70,NULL,NULL,'SDSS J172152.83+581834.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000059,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,260.470125,58.30961,0.089,NULL,57687568919,901368264,14083879,18.3),(141256,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141256,38.12,0.46,420,68281,70,NULL,NULL,'2MASX J17215341+2652587',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000171,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,260.472583333,26.88292,0.181,NULL,56280409654,879381400,13740334,17.7),(141257,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141257,36.12,0.46,168,68282,70,NULL,NULL,'2MASX J17215688+5913573',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00001,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,260.487125,59.23258,0.057,NULL,57687688896,901370139,14083908,17.4),(141258,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141258,37.47,0.46,313,68283,70,NULL,NULL,'2MASX J17215893+5442423',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000118,NULL,'17.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,260.49575,54.71172,0.081,NULL,57466350278,897911723,14029870,17.5),(141259,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141259,35.37,0.56,118,68284,70,NULL,NULL,'2MASX J17215901-0050484',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,260.495833,-0.84681,0.565,NULL,45117907237,704967300,11015114,14.8),(141260,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141260,37.89,0.33,378,68285,70,NULL,NULL,'2MASX J17220388+5257288',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000087,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,260.516125,52.958,0.081,NULL,57499288159,898426377,14037912,16.7),(141261,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141261,37.96,0.46,391,68286,70,NULL,NULL,'2MASX J17220750+2723037',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,260.531208333,27.3845,0.165,NULL,56311630028,879869219,13747956,17.2),(141262,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141262,37.72,0.46,351,68287,70,NULL,NULL,'2MASX J17221103+2727387',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000141,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,260.5457917,27.46075,0.165,NULL,56311450520,879866414,13747912,17.5),(141263,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141263,37.88,0.46,376,68288,70,NULL,NULL,'2MASX J17221123+3310440',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,260.546875,33.17897,0.165,NULL,56356273126,880566767,13758855,17.2),(141264,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141264,37.89,0.33,378,68289,70,NULL,NULL,'2MASX J17221250+5305189',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000084,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,260.5522083,53.08872,0.097,NULL,57499436608,898428697,14037948,17.6),(141265,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141265,37.56,0.46,326,68290,70,NULL,NULL,'2MASX J17221483+5945374',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000069,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,260.561625,59.76031,0.057,NULL,57554748644,899292947,14051452,17.8),(141266,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141266,35.71,0.4,139,68291,NULL,NULL,'mean','UGC 10824',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000057,NULL,'15.1',0.4,'Sbc pec:',NULL,NULL,NULL,NULL,1,260.582083,2.01842,0.457,NULL,56054380500,875849695,13685151,15.1),(141267,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141267,35.89,0.47,150,68291,NULL,NULL,'H','UGC 10824',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141268,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141268,38.14,0.46,424,68292,70,NULL,NULL,'SDSS J172221.73+542045.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000084,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,260.590625,54.34603,0.089,NULL,57466287594,897910743,14029855,18.7),(141269,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141269,37.09,0.46,262,68293,70,NULL,NULL,'2MASX J17222265+5326479',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000084,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,260.594417,53.44667,0.117,NULL,57495911739,898373620,14037087,17.1),(141270,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141270,36.02,0.49,160,68294,75,NULL,'IR','UGC 10824 NOTES01',NULL,'2011yCatp016004901K',2011,1,0.55,'The 2MASX position is for the southeastern part of the galaxy.','G',NULL,NULL,'16',0.15,'Sb? pec sp',NULL,NULL,NULL,NULL,1,260.597958333,2.00672,0.457,NULL,56054382579,875849727,13685151,16),(141271,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141271,38.23,0.46,443,68295,70,NULL,NULL,'2MASX J17222486+2800277',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000164,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,260.6035,28.00781,0.149,NULL,56312648389,879885131,13748205,18.3),(141272,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141272,35.69,0.46,137,68296,70,NULL,NULL,'2MASX J17222789+5709503',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000069,NULL,'15.8g',0.35,'E0',NULL,NULL,NULL,NULL,1,260.616333,57.16406,0.061,NULL,57693592151,901462377,14085349,15.8),(141273,'SZ effect','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141273,39.32,0.55,730,68297,NULL,NULL,'Hydrost. Eq.','ABELL 2261',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,260.612917,32.13389,0.129,NULL,56356193893,880565529,13758836,NULL),(141274,'SZ effect','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141274,39.35,NULL,740,68297,NULL,NULL,NULL,'ABELL 2261',NULL,'2011A&A...532A..14C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141275,'SZ effect','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141275,39.42,NULL,765,68297,NULL,NULL,'3.1 (red) calibration','ABELL 2261',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141276,'SZ effect','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141276,39.61,NULL,835,68297,NULL,NULL,'4.2 (black) calibration','ABELL 2261',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141277,'SZ effect','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141277,39.86,NULL,938,68297,NULL,NULL,'4.1 (blue) calibration','ABELL 2261',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141278,'SZ effect','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141278,39.89,0.63,950,68297,NULL,NULL,'Isotherm., r < 100 kpc','ABELL 2261',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141279,'SZ effect','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141279,39.98,0.51,990,68297,NULL,NULL,'Isotherm.','ABELL 2261',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141280,'SZ effect','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141280,40.11,NULL,1050,68297,NULL,NULL,NULL,'ABELL 2261',NULL,'2002ApJ...581...53R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141281,'SZ effect','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141281,40.24,NULL,1120,68297,NULL,NULL,NULL,'ABELL 2261',NULL,'2005ApJ...625..108D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141282,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141282,37.66,0.46,341,68298,70,NULL,NULL,'2MASX J17223222+2916377',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000149,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,260.634375,29.27714,0.129,NULL,56365553262,880711769,13761121,17.4),(141283,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141283,37.17,0.33,271,68299,70,NULL,NULL,'2MASX J17223896+5836212',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000084,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,260.66225,58.60572,0.085,NULL,57688374231,901380847,14084075,17.2),(141284,'Ring Diameter','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141284,34.5,0.84,79,68300,NULL,NULL,'Published at H = 100 km/s/Mpc','MRK 0506',NULL,'1981ApJS...45..541P',1981,1,0.8,NULL,'G',0.00004,NULL,'15.12',0.5,'SAB(r)a        Sy1.5','Pair member (points to parent)',NULL,NULL,'Sy 1.5',1,260.66625,30.88139,0.145,NULL,56371095400,880798365,13762474,15.12),(141285,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141285,36.31,0.45,183,68300,NULL,NULL,'K','MRK 0506',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141286,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141286,36.31,0.4,183,68300,NULL,NULL,'mean','MRK 0506',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141287,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141287,36.33,0.47,184,68300,NULL,NULL,'H','MRK 0506',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141288,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2003U',NULL,141288,31.87,0.2,23.1,68301,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','NGC 6365A',0.028341,'2011A&A...526A..81B',2011,1,1.17,'NED does NOT follow RC3 in assigning lower velocity to UGC 10832.','G',0.00009,NULL,'14.7g',0.83,'Sc-IRR         AGN','Pair member (points to parent)',NULL,NULL,'Sy 1',1,260.682541667,62.16608,0.093,NULL,57577886948,899654483,14057101,14.7),(141289,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2003U',NULL,141289,34.63,0.19,82,68301,74.2,NULL,'SALT 2','NGC 6365A',0.028341,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141290,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2003U',NULL,141290,35.27,0.04,110,68301,72,NULL,'MLCS17','NGC 6365A',0.028341,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141291,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2003U',NULL,141291,35.23,0.09,111,68301,74.4,NULL,NULL,'NGC 6365A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141292,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2003U',NULL,141292,35.36,0.18,115,68301,70,NULL,'SALT 2','NGC 6365A',0.028341,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141293,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2003U','R',141293,35.34,0.1,117,68301,NULL,NULL,'MLCS2k2, R(V) = 1.8','NGC 6365A',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141294,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2003U',NULL,141294,35.4,0.17,117,68301,73.8,NULL,'SALT 2 (SNANA)','NGC 6365A',0.0282,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141295,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2003U','R',141295,35.37,0.1,119,68301,NULL,NULL,'MLCS2k2, R(V) = 3.1','NGC 6365A',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141296,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2003U',NULL,141296,35.46,0.16,120,68301,65,NULL,'MLCS17','NGC 6365A',0.028341,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141297,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2003U',NULL,141297,35.46,0.17,121,68301,65,NULL,'SALT','NGC 6365A',0.028341,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141298,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2003U',NULL,141298,35.53,0.16,124,68301,65,NULL,'MLCS31','NGC 6365A',0.028341,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141299,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2003U',NULL,141299,35.55,0.22,125,68301,65,NULL,'SALT2','NGC 6365A',0.028341,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141300,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2003U',NULL,141300,36.03,0.04,156,68301,70,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','NGC 6365A',0.028341,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141301,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141301,38.06,0.46,409,68302,70,NULL,NULL,'2MASX J17224513+5345029',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00009,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,260.6880417,53.75092,0.101,NULL,57496546929,898383545,14037242,17.5),(141302,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141302,38.29,0.46,454,68303,70,NULL,NULL,'2MASX J17224628+2708458',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000154,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,260.692791667,27.14619,0.169,NULL,56311025653,879859775,13747808,18.1),(141303,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141303,36.83,0.46,233,68304,70,NULL,NULL,'2MASX J17224850+5323090',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000087,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,260.701917,53.38569,0.117,NULL,57495855269,898372738,14037074,16.9),(141304,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141304,38.69,0.46,546,68305,70,NULL,NULL,'2MASX J17225153+2828439',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,260.7147083,28.47878,0.125,NULL,56312583003,879884109,13748189,18.1),(141305,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141305,37.91,0.33,383,68306,70,NULL,NULL,'2MASX J17225244+6458230',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000072,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,260.71875,64.97303,0.113,NULL,57518236014,898722437,14042538,17.3),(141306,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141306,37.91,0.33,383,68307,70,NULL,NULL,'2MASX J17225552+6454310',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000104,NULL,'17.6g',0.2,'NLAGN',NULL,NULL,NULL,NULL,1,260.731667,64.9085,0.101,NULL,57518273064,898723016,14042547,17.6),(141307,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141307,35.01,0.46,101,68308,70,NULL,NULL,'2MASX J17225921+6033331',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000078,NULL,'15.6g',0.32,'E0',NULL,NULL,NULL,NULL,1,260.7467083,60.55931,0.081,NULL,57557673502,899338648,14052166,15.6),(141308,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141308,37.62,0.46,334,68309,70,NULL,NULL,'2MASX J17230039+3320418',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,260.7515417,33.34497,0.145,NULL,56356254460,880566475,13758851,NULL),(141309,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141309,37.57,0.46,326,68310,70,NULL,NULL,'2MASX J17230145+5936051',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000075,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,260.756167,59.6015,0.081,NULL,57554564460,899290069,14051407,17.4),(141310,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141310,37.94,0.33,387,68311,70,NULL,NULL,'2MASX J17230255+2654269',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,260.76075,26.9075,0.181,NULL,56281130127,879392658,13740510,17.4),(141311,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141311,34.76,0.54,89.4,68312,70,NULL,NULL,'2MASX J17230438-0125530',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,260.7682917,-1.43147,0.645,NULL,45115652250,704932066,11014563,14.9),(141312,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141312,34.83,0.69,92.3,68313,100,NULL,'mid-IR','IC 1255',NULL,'2013ApJ...771...88L',2013,1,1.1,NULL,'G',0.000008,NULL,'14.2',0.5,'Sb','Field galaxy',NULL,NULL,NULL,1,260.7724583,12.69544,0.561,NULL,55921844833,873778825,13652794,14.2),(141313,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141313,35.03,0.34,101,68313,NULL,NULL,'Malmquist cor.','IC 1255',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141314,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141314,35.24,0.47,112,68313,NULL,NULL,'H','IC 1255',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141315,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141315,35.27,0.45,113,68313,NULL,NULL,'K','IC 1255',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141316,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141316,35.32,0.46,116,68313,NULL,NULL,'J','IC 1255',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141317,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141317,35.39,0.29,120,68313,NULL,NULL,NULL,'IC 1255',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141318,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141318,35.44,0.4,122,68313,NULL,NULL,'mean','IC 1255',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141319,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141319,35.65,0.2,135,68313,74.4,NULL,NULL,'IC 1255',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141320,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141320,37.81,0.46,365,68314,70,NULL,NULL,'2MASX J17230982+5345030',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000093,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,260.791083333,53.75081,0.101,NULL,57496323135,898380048,14037188,17.6),(141321,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141321,35.08,0.48,104,68315,70,NULL,NULL,'2MASX J17230987-6153190',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'15.8b',0.5,NULL,NULL,NULL,NULL,NULL,1,260.792625,-61.88856,0.357,NULL,44479258798,694988418,10859194,15.8),(141322,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141322,36.66,0.46,215,68316,70,NULL,NULL,'2MASX J17231100+5644492',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000086,NULL,'16.0g',0.42,NULL,NULL,NULL,NULL,NULL,1,260.796,56.74694,0.065,NULL,57691179603,901424681,14084760,16),(141323,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141323,37.14,0.46,268,68317,70,NULL,NULL,'SDSS J172313.89+272407.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000139,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,260.807875,27.40208,0.165,NULL,56311063159,879860361,13747818,18.6),(141324,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141324,38.24,0.46,444,68318,70,NULL,NULL,'2MASX J17231654+6121143',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000094,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,260.8190417,61.35375,0.081,NULL,57564385596,899443524,14053805,16.9),(141325,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141325,36.35,0.6,186,68319,70,NULL,NULL,'2MASX J17232478-1448439',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,260.853291667,-14.81214,1.725,NULL,46000167296,718752614,11230509,16.1),(141326,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141326,37.94,0.33,387,68320,70,NULL,NULL,'2MASX J17233099+2656505',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,260.879333333,26.94731,0.169,NULL,56281122540,879392539,13740508,17.2),(141327,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141327,37.64,0.46,338,68321,70,NULL,NULL,'2MASX J17233453+3759354',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,260.894,37.99311,0.149,NULL,56131020068,877047188,13703862,17.2),(141328,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141328,37.86,0.46,374,68322,70,NULL,NULL,'2MASX J17233586+2718525',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000154,NULL,'17.6g',NULL,NULL,NULL,NULL,NULL,NULL,1,260.899333,27.31461,0.165,NULL,56311049384,879860146,13747814,17.6),(141329,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141329,36.97,0.46,248,68323,70,NULL,NULL,'2MASX J17233647+2722295',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,260.901917,27.37475,0.165,NULL,56311053570,879860212,13747815,16.8),(141330,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141330,37.49,0.46,315,68324,70,NULL,NULL,'2MASX J17233699+6255253',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000085,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,260.90425,62.92367,0.061,NULL,57579387468,899677929,14057467,16.8),(141331,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2009jb',NULL,141331,35.13,0.02,104,68325,70,NULL,'SiFTO+SALT2, SN PTF09dnl, SN 2009jb','CRTS J172341.69+302950.9',0.019,'2012MNRAS.426.2359M',2012,1,NULL,NULL,'G',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,260.923708333,30.49747,0.113,NULL,56367568863,880743263,13761613,NULL),(141332,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2009jb',NULL,141332,35.2,0.02,108,68325,70,NULL,'SN 2009jb, SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','CRTS J172341.69+302950.9',0.019,'2014MNRAS.438.1391P',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141333,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141333,38.02,0.46,401,68326,70,NULL,NULL,'2MASXi J1723440+335346',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,260.9335,33.89639,0.137,NULL,56347031336,880422364,13756599,17.5),(141334,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141334,33.38,0.69,47.4,68327,100,NULL,'mid-IR','IC 1256',NULL,'2013ApJ...771...88L',2013,1,1.6,NULL,'G',0.000033,NULL,'14.00',1.1,'Sb','Isolated galaxy',NULL,NULL,NULL,1,260.947125,26.48653,0.225,NULL,56280667948,879385436,13740397,14),(141335,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141335,34.24,0.2,70.5,68327,74.4,NULL,NULL,'IC 1256',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141336,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141336,34.3,0.4,72.4,68327,NULL,NULL,'mean','IC 1256',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141337,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141337,34.7,0.47,87.1,68327,NULL,NULL,'H','IC 1256',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141338,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141338,34.78,0.46,90.5,68327,NULL,NULL,'J','IC 1256',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141339,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141339,34.78,0.45,90.5,68327,NULL,NULL,'K','IC 1256',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141340,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141340,32.83,0.8,36.8,68328,75,NULL,'MAT, I','IC 4646',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.000017,NULL,'12.65',2,'SAB(rs)bc',NULL,NULL,NULL,NULL,1,260.971625,-59.99939,0.393,NULL,44450527011,694539484,10852179,12.65),(141341,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141341,32.05,0.43,25.7,68328,75,NULL,'MAT, I, raw','IC 4646',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141342,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141342,32.09,0.32,26.2,68328,85,NULL,'I, raw','IC 4646',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141343,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141343,32.13,0.32,26.7,68328,85,NULL,'I, inv','IC 4646',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141344,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141344,32.23,0.43,27.9,68328,75,NULL,'MAT, I, inv','IC 4646',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141345,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141345,32.45,0.43,30.9,68328,75,NULL,'MAT, I, cor','IC 4646',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141346,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141346,32.79,0.47,36.2,68328,NULL,NULL,'H','IC 4646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141347,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141347,32.81,0.46,36.5,68328,NULL,NULL,'J','IC 4646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141348,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141348,32.82,0.45,36.6,68328,NULL,NULL,'K','IC 4646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141349,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141349,33.2,0.4,43.7,68328,NULL,NULL,'mean','IC 4646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141350,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141350,37.8,0.46,364,68329,70,NULL,NULL,'2MASX J17235397+2840585',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000188,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,260.974875,28.68289,0.173,NULL,56312451736,879882058,13748157,16.6),(141351,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141351,37.17,0.33,271,68330,70,NULL,NULL,'2MASX J17235579+5823446',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000073,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,260.9827917,58.39569,0.085,NULL,57687642756,901369418,14083897,17.1),(141352,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141352,37.44,0.46,308,68331,70,NULL,NULL,'2MASX J17235676+5541186',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000067,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,260.986708333,55.68847,0.097,NULL,57692421268,901444082,14085063,17.5),(141353,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141353,34.82,0.4,92.2,68332,NULL,NULL,'mean','CGCG 140-018',NULL,'2007A&A...465...71T',2007,1,0.8,NULL,'G',0.000103,NULL,'15.6',0.23,'Sb','Isolated galaxy',NULL,NULL,NULL,1,260.9995,21.13706,0.281,NULL,56801437951,887522467,13867538,15.6),(141354,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141354,35.08,0.47,104,68332,NULL,NULL,'H','CGCG 140-018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141355,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141355,35.09,0.45,104,68332,NULL,NULL,'K','CGCG 140-018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141356,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141356,38.83,0.46,584,68333,70,NULL,NULL,'2MASX J17240393+2703125',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,261.016375,27.0535,0.169,NULL,56281106148,879392283,13740504,17.6),(141357,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141357,34.34,0.56,73.9,68334,70,NULL,NULL,'2MASX J17240569-0304214',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,261.023833,-3.07264,0.905,NULL,45346625888,708541029,11070953,14.6),(141358,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141358,32.57,0.8,32.7,68335,75,NULL,'MAT, I','ESO 138- G 024',NULL,'1997ApJS..109..333W',1997,1,2.4,NULL,'G',0.000026,NULL,'13.83',0.6,'SB(s)c:',NULL,NULL,NULL,NULL,1,261.027333333,-59.38217,0.441,NULL,44522012812,695656450,10869632,13.83),(141359,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141359,31.53,0.39,20.2,68335,73,NULL,'IR','ESO 138- G 024',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141360,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141360,31.53,0.4,20.2,68335,75,NULL,NULL,'ESO 138- G 024',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141361,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141361,31.65,0.32,21.4,68335,85,NULL,'I, inv','ESO 138- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141362,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141362,31.66,0.32,21.5,68335,85,NULL,'I, raw','ESO 138- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141363,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141363,31.95,0.43,24.6,68335,75,NULL,'MAT, I, raw','ESO 138- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141364,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141364,31.96,0.4,24.7,68335,NULL,NULL,NULL,'ESO 138- G 024',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141365,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141365,32,0.43,25.1,68335,75,NULL,'MAT, I, inv','ESO 138- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141366,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141366,32.36,0.43,29.6,68335,75,NULL,'MAT, I, cor','ESO 138- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141367,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141367,32.4,0.49,30.2,68335,75,NULL,'IR','ESO 138- G 024',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141368,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141368,33.06,0.4,40.9,68335,NULL,NULL,'mean','ESO 138- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141369,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141369,33.11,0.47,41.8,68335,NULL,NULL,'H','ESO 138- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141370,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141370,33.28,0.45,45.3,68335,NULL,NULL,'K','ESO 138- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141371,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141371,33.3,0.46,45.8,68335,NULL,NULL,'J','ESO 138- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141372,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141372,35.02,0.46,101,68336,70,NULL,NULL,'CGCG 277-041 NED01',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.000083,NULL,'14.8g',0.59,'E0',NULL,NULL,NULL,NULL,1,261.0364583,53.467,0.109,NULL,57496177991,898377781,14037152,14.8),(141373,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141373,36.61,0.99,210,68337,70,NULL,NULL,'2MASX J17241523-8026055',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,261.064,-80.43483,0.325,NULL,44041980341,688155942,10752436,17.1),(141374,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141374,36.53,0.65,202,68338,70,NULL,NULL,'2MASX J17241877-7149426',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,261.078375,-71.82858,0.361,NULL,44103760879,689121263,10767519,16.4),(141375,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141375,37.17,0.46,271,68339,70,NULL,NULL,'2MASX J17242162+2728413',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000174,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,261.0902083,27.47819,0.161,NULL,56310926432,879858225,13747784,16.5),(141376,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141376,38.09,0.23,415,68340,70,NULL,NULL,'2MASX J17242240+6421503',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000088,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,261.093167,64.36411,0.085,NULL,57574088568,899595133,14056173,18.1),(141377,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141377,38,0.46,399,68341,70,NULL,NULL,'SDSS J172424.32+314919.6',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,261.101375,31.82211,0.133,NULL,56368589413,880759209,13761862,17.3),(141378,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141378,35.67,0.49,136,68342,75,NULL,'IR','UGC 10831',NULL,'2011yCatp016004901K',2011,1,1.1,'RC3 gives a HI-line velocity of 8149 km/sec. Stars superposed.','G',0.000037,NULL,'14.60',1,'Sd','Pair member (points to parent)',NULL,NULL,NULL,1,261.118125,24.97172,0.337,NULL,56286932849,879483325,13741926,14.6),(141379,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141379,38.04,0.46,405,68343,70,NULL,NULL,'2MASXi J1724302+631129',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000082,NULL,'17.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,261.1260417,63.19136,0.085,NULL,57579073415,899673022,14057390,17.9),(141380,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141380,36.27,0.89,180,68344,70,NULL,NULL,'2MASX J17243064-6628246',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,261.1274583,-66.47353,0.253,NULL,44435676444,694307444,10848553,15.5),(141381,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141381,37.71,0.46,349,68345,70,NULL,NULL,'2MASX J17243142+6455453',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000108,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,261.13125,64.92919,0.105,NULL,57518344870,898724138,14042564,16.6),(141382,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141382,34.97,0.63,98.7,68346,70,NULL,NULL,'ESO 070-IG 009',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00015,NULL,'14.9b',0.5,'SAab?',NULL,NULL,NULL,NULL,1,261.141667,-70.47133,0.093,NULL,44096972871,689015201,10765862,14.9),(141383,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141383,37.99,0.46,397,68347,70,NULL,NULL,'2MASX J17243403+2705474',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,261.141791667,27.09656,0.197,NULL,56280942085,879389720,13740464,17.6),(141384,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141384,38.09,0.23,415,68348,70,NULL,NULL,'2MASX J17243453+6412013',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000059,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,261.144,64.20047,0.077,NULL,57574098596,899595290,14056176,18),(141385,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141385,33.6,NULL,52.4,68349,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 4644',NULL,'2010Ap&SS.325..163P',2010,1,1.8,NULL,'G',0.000024,NULL,'15.5',0.22,'Spec',NULL,NULL,NULL,NULL,1,261.15375,-73.94011,0.389,NULL,44148424406,689819131,10778423,15.5),(141386,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141386,33.62,NULL,53,68349,NULL,NULL,'Dipole + Quadrupole','IC 4644',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141387,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141387,33.66,NULL,54.1,68349,NULL,NULL,'Dipole','IC 4644',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141388,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141388,38.29,0.46,456,68350,70,NULL,NULL,'SDSS J172438.00+605538.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000073,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,261.158375,60.92733,0.085,NULL,57564233631,899441150,14053767,18.3),(141389,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141389,37.18,0.46,273,68351,70,NULL,NULL,'2MASX J17244280+5351182',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000107,NULL,'16.0g',0.31,'E0',NULL,NULL,NULL,NULL,1,261.1785,53.85517,0.113,NULL,57496130342,898377036,14037141,16),(141390,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141390,35.64,0.79,134,68352,70,NULL,NULL,'2MASX J17244425-0130562',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,261.184375,-1.51553,0.705,NULL,45115352237,704927378,11014490,16),(141391,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141391,35.34,0.2,117,68353,74.4,NULL,NULL,'UGC 10837',NULL,'2013AJ....146...86T',2013,1,1.17,NULL,'G',0.000047,NULL,'14.5g',0.64,'SBbc','Pair member (points to parent)',NULL,NULL,NULL,1,261.189083,24.97136,0.337,NULL,56286923363,879483177,13741924,14.5),(141392,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141392,33.38,0.2,47.4,68354,74.4,NULL,NULL,'UGC 10854',NULL,'2013AJ....146...86T',2013,1,0.98,NULL,'G',0.000061,NULL,'15.6g',0.45,'Scd:',NULL,NULL,NULL,NULL,1,261.193416667,58.20572,0.089,NULL,57687438261,901366222,14083847,15.6),(141393,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141393,33.45,0.43,48.9,68354,75,NULL,'3.6 micron, color corrected','UGC 10854',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141394,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141394,33.49,0.43,49.8,68354,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10854',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141395,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141395,38.09,0.23,415,68355,70,NULL,NULL,'2MASX J17245137+6421401',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000073,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,261.213791667,64.36128,0.085,NULL,57574039692,899594370,14056162,18),(141396,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141396,34.98,0.67,98.9,68356,70,NULL,NULL,'2MASX J17245375-0119131',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000133,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,261.224041667,-1.32031,0.665,NULL,45117122041,704955031,11014922,15.2),(141397,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141397,38.09,0.23,415,68357,70,NULL,NULL,'2MASX J17245668+6426327',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000092,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,261.236083,64.4425,0.085,NULL,57573180463,899580944,14055952,17.5),(141398,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141398,38.87,0.46,595,68358,70,NULL,NULL,'SDSS J172501.60+611237.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000094,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,261.256667,61.21047,0.081,NULL,57564400807,899443762,14053808,18.3),(141399,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141399,35.35,0.27,118,68359,70,NULL,NULL,'2MASX J17250213+5817569',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000083,NULL,'16.0g',0.32,'E0',NULL,NULL,NULL,NULL,1,261.258666667,58.29917,0.085,NULL,57687425428,901366022,14083844,16),(141400,'BL Lac Luminosity','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141400,39.13,NULL,670,68360,70,NULL,'nucleus-to-host flux ratio, z > 0.17','2MASS J17250434+1152155',NULL,'2006AJ....132....1S',2006,1,NULL,'Wurtz, et al. (1996,ApJS,103,109) give z=0.159.','G',NULL,NULL,'15.77',NULL,'BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,261.268083,11.87097,0.601,NULL,55933290074,873957657,13655588,15.77),(141401,'BL Lac Luminosity','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141401,40.48,NULL,1250,68360,70,NULL,'z > 0.35','2MASS J17250434+1152155',NULL,'2014A&A...570A.126L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141402,'GeV TeV ratio','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141402,40.43,1,1220,68360,70,NULL,'z = 0.34 +/- 0.15','2MASS J17250434+1152155',NULL,'2016MNRAS.459.3271A',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141403,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141403,37.02,0.46,253,68361,70,NULL,NULL,'2MASX J17250764+5748269',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000077,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,261.2817083,57.80736,0.089,NULL,57693231083,901456735,14085261,16.9),(141404,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141404,37.46,0.21,310,68362,70,NULL,NULL,'SDSS J172510.39+525855.4',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000081,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,261.293333,52.98206,0.093,NULL,57499561125,898430642,14037978,17.2),(141405,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141405,36.93,0.46,243,68363,70,NULL,NULL,'2MASX J17251089+5812522',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000075,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,261.29525,58.21458,0.089,NULL,57687434305,901366161,14083846,18.1),(141406,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141406,36.68,0.61,217,68364,70,NULL,NULL,'2MASX J17251483-6604017',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,261.3117917,-66.06714,0.237,NULL,44436338366,694317786,10848715,15.8),(141407,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141407,37.46,0.21,310,68365,70,NULL,NULL,'2MASX J17252031+5255012',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000113,NULL,'16.1g',0.39,'AGN',NULL,NULL,NULL,NULL,1,261.334667,52.91706,0.093,NULL,57499567574,898430743,14037980,16.1),(141408,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141408,37.46,0.21,310,68366,70,NULL,NULL,'2MASX J17252154+5258262',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000068,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,261.3397917,52.97389,0.093,NULL,57499558656,898430604,14037978,17.3),(141409,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141409,37.46,0.21,310,68367,70,NULL,NULL,'2MASX J17252618+5257132',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000098,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,261.359,52.95369,0.093,NULL,57499566381,898430724,14037980,17.4),(141410,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141410,38.25,0.46,447,68368,70,NULL,NULL,'2MASX J17252970+2806158',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,261.37375,28.10436,0.185,NULL,56312040879,879875638,13748056,18),(141411,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141411,36.3,0.88,182,68369,70,NULL,NULL,'2MASX J17253418-7937343',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,261.3922917,-79.62619,0.329,NULL,44261814051,691590844,10806106,16.7),(141412,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141412,36.94,0.33,244,68370,70,NULL,NULL,'2MASX J17253760+5659573',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000072,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,261.4065417,56.99914,0.101,NULL,57693023073,901453485,14085210,16.8),(141413,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141413,34.31,NULL,72.7,68371,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10858',NULL,'2010Ap&SS.325..163P',2010,1,1.11,NULL,'G',0.00001,NULL,'16.2g',0.18,'Scd(f)         HII',NULL,NULL,NULL,NULL,1,261.4100417,59.44678,0.073,NULL,57557913608,899342400,14052225,16.2),(141414,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141414,34.33,NULL,73.3,68371,NULL,NULL,'Dipole','UGC 10858',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141415,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141415,34.33,NULL,73.5,68371,NULL,NULL,'Dipole + Quadrupole','UGC 10858',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141416,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141416,34.65,0.2,85.1,68371,74.4,NULL,NULL,'UGC 10858',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141417,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141417,34.71,0.43,87.7,68371,75,NULL,'3.6 micron, color corrected','UGC 10858',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141418,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141418,34.79,0.43,90.7,68371,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10858',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141419,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141419,37.64,0.46,338,68372,70,NULL,NULL,'SDSS J172543.42+641653.2',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000073,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,261.4309583,64.28144,0.085,NULL,57573206645,899581353,14055958,17.8),(141420,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141420,38.25,0.46,446,68373,70,NULL,NULL,'2MASX J17254374+2700248',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,261.4324583,27.00692,0.197,NULL,56281007895,879390748,13740480,17.5),(141421,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141421,37.46,0.21,310,68374,70,NULL,NULL,'2MASX J17254838+5307158',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000078,NULL,'16.8g',0.33,NULL,NULL,NULL,NULL,NULL,1,261.451833333,53.12122,0.101,NULL,57499697683,898432776,14038012,16.8),(141422,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141422,36.94,0.33,244,68375,70,NULL,NULL,'SDSS J172548.75+565914.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000074,NULL,'18.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,261.453167,56.9875,0.101,NULL,57693024618,901453509,14085211,18.1),(141423,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141423,38.49,0.33,498,68376,70,NULL,NULL,'2MASX J17255197+3134227',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,261.4667917,31.57306,0.117,NULL,56369123278,880767551,13761992,18.2),(141424,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141424,35.63,0.23,134,68377,70,NULL,NULL,'CGCG 277-043',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000093,NULL,'15.5g',0.46,'E0',NULL,NULL,NULL,NULL,1,261.4922917,56.63683,0.077,NULL,57692924530,901451945,14085186,15.5),(141425,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141425,38.51,0.46,504,68378,70,NULL,NULL,'2MASX J17255910+3138526',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,261.4964583,31.648,0.109,NULL,56368758886,880761857,13761904,17.5),(141426,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141426,37.6,0.46,331,68379,70,NULL,NULL,'2MASX J17260233+6334134',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000078,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,261.5099583,63.57028,0.093,NULL,57576154308,899627411,14056678,17.1),(141427,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141427,32.82,0.43,36.7,68380,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10887',NULL,'2014MNRAS.444..527S',2014,1,1.32,NULL,'G',0.000017,NULL,'15.48',0.17,'Sc',NULL,NULL,NULL,NULL,1,261.529167,77.70361,0.153,NULL,57060794820,891574919,13930858,15.48),(141428,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141428,33.05,NULL,40.8,68380,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10887',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141429,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141429,33.07,NULL,41.2,68380,NULL,NULL,'Dipole + Quadrupole','UGC 10887',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141430,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141430,33.08,NULL,41.3,68380,NULL,NULL,'Dipole','UGC 10887',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141431,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141431,38.49,0.33,498,68381,70,NULL,NULL,'SDSS J172610.69+312926.2',NULL,'2015arXiv151105856S',2015,1,0.04,NULL,'G',NULL,NULL,'23.4g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,261.5445417,31.49061,0.117,NULL,56369303931,880770373,13762037,23.4),(141432,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141432,32.56,0.43,32.5,68382,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10852',NULL,'2014MNRAS.444..527S',2014,1,1.33,NULL,'G',0.000005,NULL,'16.00',0.13,'Sd',NULL,NULL,NULL,NULL,1,261.572,11.31706,0.605,NULL,56045561152,875711893,13682998,16),(141433,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141433,33.07,NULL,41,68382,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10852',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141434,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141434,33.08,NULL,41.2,68382,NULL,NULL,'Dipole + Quadrupole','UGC 10852',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141435,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141435,33.08,NULL,41.3,68382,NULL,NULL,'Dipole','UGC 10852',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141436,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141436,33.1,NULL,41.7,68382,NULL,NULL,NULL,'UGC 10852',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141437,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141437,38.16,0.46,430,68383,70,NULL,NULL,'2MASX J17261999+2711590',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,261.583417,27.19989,0.193,NULL,56282961685,879421276,13740957,17.4),(141438,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141438,37.12,0.46,266,68384,70,NULL,NULL,'2MASX J17262244+5358019',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000091,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,261.593333,53.96711,0.113,NULL,57466636975,897916202,14029940,17.7),(141439,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141439,38.46,0.46,492,68385,70,NULL,NULL,'SDSS J172625.39+273614.1',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000147,NULL,'18.9g',0.1,NULL,NULL,NULL,NULL,NULL,1,261.6057917,27.60394,0.197,NULL,56282903228,879420362,13740943,18.9),(141440,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141440,31.61,0.8,21,68386,75,NULL,'A82, H','NGC 6395',NULL,'1997ApJS..109..333W',1997,1,2.4,NULL,'G',0.00002,NULL,'13.00',0.7,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,261.6302917,71.09628,0.133,NULL,57056740890,891511576,13929868,13),(141441,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141441,30.97,0.4,15.6,68386,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 6395',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141442,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141442,31.43,0.2,19.3,68386,74.4,NULL,NULL,'NGC 6395',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141443,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141443,31.47,0.38,19.7,68386,NULL,NULL,NULL,'NGC 6395',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141444,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141444,31.53,0.43,20.2,68386,75,NULL,'3.6 micron, color corrected','NGC 6395',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141445,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141445,31.61,0.43,21,68386,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6395',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141446,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141446,31.63,0.8,21.2,68386,NULL,NULL,NULL,'NGC 6395',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141447,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141447,31.66,0.47,21.5,68386,75,NULL,'A82, H, inv','NGC 6395',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141448,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141448,31.68,0.4,21.6,68386,75,NULL,'B','NGC 6395',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141449,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141449,31.67,0.79,21.6,68386,NULL,NULL,'Malmquist cor.','NGC 6395',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141450,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141450,31.75,0.47,22.4,68386,75,NULL,'A82, H, raw','NGC 6395',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141451,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141451,31.87,0.4,23.6,68386,NULL,NULL,'mean','NGC 6395',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141452,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141452,32.04,0.47,25.6,68386,75,NULL,'A82, H, cor','NGC 6395',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141453,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141453,32.71,0.47,34.8,68386,NULL,NULL,'H','NGC 6395',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141454,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141454,38.2,0.46,436,68387,70,NULL,NULL,'SDSS J172632.95+585551.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000059,NULL,'18.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,261.637333333,58.93103,0.081,NULL,57686873602,901357400,14083709,18.6),(141455,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141455,36.56,0.7,205,68388,70,NULL,NULL,'2MASX J17263889-7120492',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,261.662,-71.34708,0.353,NULL,44106575469,689165241,10768206,17.2),(141456,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141456,36.46,0.69,196,68389,70,NULL,NULL,'2MASX J17265159-0034144',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,261.714916667,-0.57081,0.725,NULL,45127683506,705120054,11017500,16.1),(141457,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141457,35.63,0.44,134,68390,NULL,NULL,'Malmquist cor.','ESO 102- G 004',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'15.01',0.2,'Sc',NULL,NULL,NULL,NULL,1,261.7249583,-64.89353,0.313,NULL,44437580780,694337199,10849018,15.01),(141458,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141458,35.88,0.39,150,68390,NULL,NULL,NULL,'ESO 102- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141459,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141459,35.92,0.2,153,68390,74.4,NULL,NULL,'ESO 102- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141460,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141460,37.17,0.46,272,68391,70,NULL,NULL,'2MASX J17265436+2714154',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,261.7265417,27.23769,0.197,NULL,56282934062,879420844,13740950,17.3),(141461,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141461,38.45,0.46,489,68392,70,NULL,NULL,'2MASX J17265605+2657024',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,261.7334583,26.95072,0.193,NULL,56282486274,879413848,13740841,17.8),(141462,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141462,35.63,0.23,134,68393,70,NULL,NULL,'2MASX J17270150+5653078',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000079,NULL,'16.2g',0.3,'E0',NULL,NULL,NULL,NULL,1,261.7564583,56.88558,0.073,NULL,57696537376,901508396,14086068,16.2),(141463,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141463,32.95,0.8,39,68394,75,NULL,'A82, H','NGC 6368',NULL,'1997ApJS..109..333W',1997,1,3.8,NULL,'G',0.000017,NULL,'13.10',1,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,261.798083,11.54361,0.577,NULL,55924882363,873826286,13653535,13.1),(141464,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141464,31.89,0.4,23.9,68394,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 6368',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141465,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141465,32.17,0.47,27.1,68394,75,NULL,'A82, H, raw','NGC 6368',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141466,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141466,32.3,0.47,28.8,68394,75,NULL,'A82, H, inv','NGC 6368',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141467,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141467,32.42,0.36,30.5,68394,NULL,NULL,NULL,'NGC 6368',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141468,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141468,32.56,0.47,32.5,68394,75,NULL,'A82, H, cor','NGC 6368',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141469,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141469,32.57,0.2,32.7,68394,74.4,NULL,NULL,'NGC 6368',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141470,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141470,32.67,0.46,34.2,68394,NULL,NULL,'J','NGC 6368',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141471,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141471,32.71,0.43,34.9,68394,75,NULL,'3.6 micron, color corrected','NGC 6368',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141472,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141472,32.73,0.47,35.1,68394,NULL,NULL,'H','NGC 6368',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141473,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141473,32.78,0.45,36,68394,NULL,NULL,'K','NGC 6368',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141474,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141474,32.88,0.4,37.7,68394,NULL,NULL,'mean','NGC 6368',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141475,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141475,32.9,0.43,38.1,68394,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6368',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141476,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141476,33.06,0.4,40.9,68394,75,NULL,'B','NGC 6368',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141477,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141477,34.69,0.66,86.6,68395,70,NULL,NULL,'2MASX J17271483-0130214',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,261.8117917,-1.50603,0.737,NULL,45129705478,705151648,11017994,14.7),(141478,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141478,32.18,NULL,27.2,68396,NULL,NULL,NULL,'UGC 10872',NULL,'2000BSAO...50....5K',2000,1,1.46,NULL,'G',0.000017,NULL,'16.7g',0.14,'Sd(f)',NULL,NULL,NULL,NULL,1,261.826583,61.17775,0.129,NULL,57564585159,899446643,14053853,16.7),(141479,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141479,33.44,NULL,48.8,68396,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10872',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141480,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141480,33.46,NULL,49.3,68396,NULL,NULL,'Dipole + Quadrupole','UGC 10872',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141481,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141481,33.47,NULL,49.3,68396,NULL,NULL,'Dipole','UGC 10872',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141482,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141482,35.41,NULL,121,68397,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2135',NULL,'2010Ap&SS.325..163P',2010,1,0.88,NULL,'G',0.00001,NULL,'17.2',0.08,'Scd',NULL,NULL,NULL,NULL,1,261.847083,13.6625,0.481,NULL,55932885877,873951341,13655489,17.2),(141483,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141483,35.42,NULL,122,68397,NULL,NULL,'Dipole','FGC 2135',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141484,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141484,35.43,NULL,122,68397,NULL,NULL,'Dipole + Quadrupole','FGC 2135',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141485,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141485,35.48,0.43,125,68397,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2135',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141486,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141486,35.49,NULL,125,68397,NULL,NULL,NULL,'FGC 2135',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141487,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141487,33.92,0.47,60.9,68398,70,NULL,NULL,'2MASX J17272793-6200368',NULL,'2014MNRAS.445.2677S',2014,1,0.98,NULL,'G',0.00015,NULL,'14.66',0.74,NULL,NULL,NULL,NULL,NULL,1,261.866875,-62.00956,0.305,NULL,44490458495,695163413,10861928,14.66),(141488,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141488,35.35,0.27,118,68399,70,NULL,NULL,'IC 1260',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000094,NULL,'15.7g',0.57,'S0/a','Group member',NULL,NULL,NULL,1,261.882166667,58.47586,0.085,NULL,57687049800,901360153,14083752,15.7),(141489,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141489,33.01,0.43,39.9,68400,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6372',NULL,'2014MNRAS.444..527S',2014,1,1.7,NULL,'G',0.000023,NULL,'13.66',1.1,'Sb? pec',NULL,NULL,NULL,NULL,1,261.8827083,26.47514,0.217,NULL,56281837741,879403714,13740683,13.66),(141490,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141490,33.11,0.43,41.8,68400,75,NULL,'3.6 micron, color corrected','NGC 6372',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141491,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141491,33.25,0.2,44.7,68400,74.4,NULL,NULL,'NGC 6372',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141492,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141492,33.97,0.47,62.3,68400,NULL,NULL,'H','NGC 6372',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141493,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141493,34.1,0.45,66.1,68400,NULL,NULL,'K','NGC 6372',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141494,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141494,34.1,0.46,66.2,68400,NULL,NULL,'J','NGC 6372',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141495,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141495,34.31,0.4,72.8,68400,NULL,NULL,'mean','NGC 6372',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141496,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141496,37.44,0.33,308,68401,70,NULL,NULL,'2MASX J17273348+5405448',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000088,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,261.8895417,54.09581,0.117,NULL,57466658496,897916539,14029945,17.2),(141497,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141497,35.81,0.57,145,68402,70,NULL,NULL,'2MASX J17273736-6645574',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,261.9057083,-66.76592,0.285,NULL,44435558468,694305601,10848525,14.7),(141498,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141498,37.44,0.33,308,68403,70,NULL,NULL,'2MASX J17274262+5403086',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000097,NULL,'16.7g',0.25,'NLAGN',NULL,NULL,NULL,NULL,1,261.927875,54.05236,0.117,NULL,57466663707,897916620,14029947,16.7),(141499,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141499,34.89,0.52,95.1,68404,NULL,NULL,'Malmquist cor.','ESO 102- G 005',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.66',0.4,'Sb - c',NULL,NULL,NULL,NULL,1,261.942833,-64.56164,0.333,NULL,44436651200,694322675,10848791,14.66),(141500,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141500,34.93,0.47,97,68404,NULL,NULL,'H','ESO 102- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141501,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141501,35.03,0.45,101,68404,NULL,NULL,'K','ESO 102- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141502,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141502,35.05,0.46,102,68404,NULL,NULL,'J','ESO 102- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141503,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141503,35.06,0.4,103,68404,NULL,NULL,'mean','ESO 102- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141504,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141504,35.25,0.44,112,68404,NULL,NULL,NULL,'ESO 102- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141505,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141505,35.29,0.2,114,68404,74.4,NULL,NULL,'ESO 102- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141506,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141506,35.82,0.46,146,68405,70,NULL,NULL,'CGCG 300-036',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000107,NULL,'15.0g',0.59,'E0','Group member',NULL,NULL,NULL,1,261.968917,60.09728,0.117,NULL,57558393728,899349902,14052342,15),(141507,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141507,36.88,0.7,237,68406,70,NULL,NULL,'2MASX J17280878-6814233',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,262.036417,-68.23981,0.277,NULL,44964258152,702566533,10977602,15),(141508,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141508,32.12,NULL,26.6,68407,72,NULL,NULL,'UGC 10862',NULL,'2014Ap.....57..457K',2014,1,2.8,NULL,'G',0.000007,NULL,'13.4',2.5,'SB(rs)c','Isolated galaxy',NULL,NULL,NULL,1,262.03725,7.42242,0.281,NULL,56102569733,876602652,13696916,13.4),(141509,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141509,32.15,0.4,26.9,68407,75,NULL,'B','UGC 10862',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141510,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141510,37.23,0.33,279,68408,70,NULL,NULL,'2MASX J17280969+5553588',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000117,NULL,'15.8g',0.44,'E0',NULL,NULL,NULL,NULL,1,262.0404583,55.89983,0.113,NULL,57689839426,901403741,14084433,15.8),(141511,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141511,36.69,0.56,218,68409,70,NULL,NULL,'2MASX J17281348-6651522',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,262.056,-66.8645,0.285,NULL,44969243930,702644436,10978819,15.1),(141512,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141512,37.23,0.33,279,68410,70,NULL,NULL,'2MASX J17281777+5554168',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000095,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,262.074375,55.90481,0.133,NULL,57689893242,901404581,14084446,17),(141513,'BL Lac Luminosity','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141513,37,NULL,238,68411,NULL,NULL,NULL,'I Zw 187',0.055405,'2005ApJ...635..173S',2005,1,NULL,'Mislabeled as I Zw 186 in Craine\'s Handbook of QSOs.','G',0.0002,NULL,'15.15',NULL,'BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,262.077583,50.21958,0.085,NULL,57503898327,898498411,14039037,15.15),(141514,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141514,33.21,0.49,43.8,68412,75,NULL,'IR','NGC 6390',NULL,'2011yCatp016004901K',2011,1,0.58,'The 2MASXi position is 9 arcsec south-southwest of the nucleus.','G',0.000041,NULL,'14.7g',0.46,'Sbc','Group member',NULL,NULL,NULL,1,262.1170417,60.09417,0.117,NULL,57558347021,899349172,14052330,14.7),(141515,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141515,33.44,0.2,48.8,68412,74.4,NULL,NULL,'NGC 6390',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141516,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141516,33.49,0.5,49.9,68412,NULL,NULL,NULL,'NGC 6390',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141517,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141517,33.74,0.45,55.9,68412,NULL,NULL,'Malmquist cor.','NGC 6390',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141518,'GRB','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141518,45.49,1.47,4750,68413,NULL,NULL,NULL,'GRB 080605',1.6398,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,262.1252083,4.01567,0.405,NULL,56059812710,875934573,13686477,NULL),(141519,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141519,38.27,0.33,450,68414,70,NULL,NULL,'2MASX J17283011+5315104',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000086,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,262.1254583,53.253,0.121,NULL,57499082591,898423165,14037861,17.4),(141520,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141520,38.27,0.33,450,68415,70,NULL,NULL,'2MASX J17283040+5320374',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000093,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,262.1267917,53.34367,0.121,NULL,57499155685,898424307,14037879,17.6),(141521,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141521,38.13,0.46,423,68416,70,NULL,NULL,'2MASX J17283997+6042167',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000087,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,262.166625,60.70467,0.129,NULL,57556766102,899324470,14051944,18.2),(141522,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141522,37.71,0.46,348,68417,70,NULL,NULL,'2MASX J17284852+2638010',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,262.202166667,26.63378,0.193,NULL,56281973538,879405836,13740716,17.6),(141523,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141523,35.35,0.27,118,68418,70,NULL,NULL,'NGC 6391',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.000104,NULL,'14.6g',0.68,'E0',NULL,NULL,NULL,NULL,1,262.204125,58.85089,0.097,NULL,57686793699,901356151,14083689,14.6),(141524,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141524,35.78,0.86,143,68419,70,NULL,NULL,'2MASX J17285058-0325215',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,262.21075,-3.42267,1.025,NULL,45120297814,705004653,11015697,14.6),(141525,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141525,37.6,0.46,332,68420,70,NULL,NULL,'2MASX J17285083+5914192',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000086,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,262.2120417,59.23864,0.089,NULL,57556062613,899313478,14051773,17.2),(141526,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141526,34.14,NULL,67.4,68421,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10874',NULL,'2010Ap&SS.325..163P',2010,1,1.47,NULL,'G',0.000005,NULL,'16.0',0.16,'Scd',NULL,NULL,NULL,NULL,1,262.239333333,29.30747,0.169,NULL,56363947802,880686684,13760729,16),(141527,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141527,34.16,NULL,67.8,68421,NULL,NULL,'Dipole','UGC 10874',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141528,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141528,34.16,NULL,67.8,68421,NULL,NULL,'Dipole + Quadrupole','UGC 10874',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141529,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141529,34.22,NULL,69.7,68421,NULL,NULL,NULL,'UGC 10874',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141530,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141530,35.24,0.2,112,68421,74.4,NULL,NULL,'UGC 10874',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141531,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141531,35.32,0.54,116,68421,NULL,NULL,'Malmquist cor.','UGC 10874',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141532,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141532,35.35,0.53,117,68421,NULL,NULL,NULL,'UGC 10874',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141533,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141533,35.42,0.43,122,68421,75,NULL,'3.6 micron, color corrected','UGC 10874',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141534,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141534,35.69,0.43,137,68421,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10874',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141535,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141535,35.6,0.5,132,68422,70,NULL,NULL,'2MASX J17285917-6647476',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,262.2464583,-66.79653,0.285,NULL,44435509189,694304831,10848512,14.6),(141536,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141536,35.11,0.49,105,68423,75,NULL,'IR','CGCG 054-031',NULL,'2011yCatp016004901K',2011,1,1.16,'Star superposed.','G',0.000012,NULL,'15.6',0.15,'Sbc',NULL,NULL,NULL,NULL,1,262.250833,8.83314,0.353,NULL,56092420855,876444075,13694438,15.6),(141537,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141537,35.34,NULL,117,68423,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 054-031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141538,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141538,35.36,NULL,118,68423,NULL,NULL,'Dipole + Quadrupole','CGCG 054-031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141539,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141539,35.37,NULL,118,68423,NULL,NULL,'Dipole','CGCG 054-031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141540,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141540,35.4,NULL,120,68423,NULL,NULL,NULL,'CGCG 054-031',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141541,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141541,35.42,0.43,122,68423,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 054-031',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141542,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141542,32.85,NULL,37.1,68424,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10892',NULL,'2010Ap&SS.325..163P',2010,1,1.84,NULL,'G',0.000013,NULL,'16.0',0.15,'Sd',NULL,NULL,NULL,NULL,1,262.27125,74.25611,0.133,NULL,57104991935,892265498,13941648,16),(141543,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141543,32.86,NULL,37.4,68424,NULL,NULL,'Dipole + Quadrupole','UGC 10892',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141544,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141544,32.87,NULL,37.5,68424,NULL,NULL,'Dipole','UGC 10892',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141545,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141545,32.96,NULL,39.1,68424,NULL,NULL,NULL,'UGC 10892',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141546,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141546,36.35,0.51,186,68425,70,NULL,NULL,'2MASX J17290651-6523141',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,262.277083,-65.38719,0.257,NULL,44437659654,694338432,10849038,14.6),(141547,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141547,37.85,0.46,371,68426,70,NULL,NULL,'SDSS J172908.05+255830.7',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,262.283583,25.97522,0.289,NULL,56284333361,879442708,13741292,17.5),(141548,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141548,36.06,0.7,163,68427,70,NULL,NULL,'2MASX J17290875-6522481',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,262.2865,-65.37997,0.257,NULL,44437114884,694329920,10848905,15.4),(141549,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141549,33.7,0.47,54.9,68428,70,NULL,NULL,'ESO 138-IG 029',NULL,'2014MNRAS.445.2677S',2014,1,2.5,NULL,'G',0.000077,NULL,'12.75',1.4,'Rings','Pair member (points to parent)',NULL,NULL,NULL,1,262.289875,-62.44561,0.317,NULL,44490744315,695167879,10861998,12.75),(141550,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141550,38,0.27,399,68429,70,NULL,NULL,'2MASX J17291081+3057512',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.2,'BrClG',NULL,NULL,NULL,NULL,1,262.2949583,30.96419,0.189,NULL,56365151791,880705496,13761023,17.3),(141551,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141551,34.22,0.49,69.9,68430,75,NULL,'IR','UGC 10873',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000033,NULL,'15.26',0.2,'SB?','Pair member (points to parent)',NULL,NULL,NULL,1,262.31525,16.15761,0.465,NULL,56815374217,887740222,13870940,15.26),(141552,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141552,37.42,0.46,304,68431,70,NULL,NULL,'2MASX J17292126+5415259',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000095,NULL,'16.5g',0.29,'BrClG          AGN',NULL,NULL,NULL,NULL,1,262.3382917,54.25725,0.133,NULL,57469971231,897968300,14030754,16.5),(141553,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141553,36.7,0.57,219,68432,70,NULL,NULL,'2MASX J17292831-6634333',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,262.3677917,-66.57597,0.277,NULL,44435534888,694305232,10848519,15.6),(141554,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141554,34.12,0.8,66.7,68433,75,NULL,'MAT, I','ESO 102- G 007',NULL,'1997ApJS..109..333W',1997,1,1.3,'SGC and ESO-LV catalogs both have two entries for this galaxy.','G',0.000013,NULL,'13.38',1,'SAB(rs)c:',NULL,NULL,NULL,NULL,1,262.3815417,-64.02286,0.349,NULL,44481671867,695026122,10859783,13.38),(141555,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141555,34.42,0.32,76.6,68433,85,NULL,'I, raw','ESO 102- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141556,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141556,34.43,0.43,77,68433,75,NULL,'MAT, I, raw','ESO 102- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141557,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141557,34.49,0.32,79,68433,85,NULL,'I, inv','ESO 102- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141558,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141558,34.51,0.52,80,68433,NULL,NULL,'Malmquist cor.','ESO 102- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141559,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141559,34.58,0.43,82.4,68433,75,NULL,'MAT, I, cor','ESO 102- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141560,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141560,34.72,0.43,87.9,68433,75,NULL,'MAT, I, inv','ESO 102- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141561,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141561,34.95,0.42,97.8,68433,NULL,NULL,NULL,'ESO 102- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141562,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141562,34.99,0.2,99.5,68433,74.4,NULL,NULL,'ESO 102- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141563,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141563,37.57,0.46,327,68434,70,NULL,NULL,'2MASX J17293735+5725141',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000092,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,262.405667,57.42056,0.109,NULL,57696229919,901503592,14085993,17.8),(141564,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141564,31.86,0.4,23.5,68435,75,NULL,'B','NGC 6412',NULL,'1988NBGC.C....0000T',1988,1,2.5,NULL,'G',0.000003,NULL,'12.28',2.2,'SA(s)c','Isolated galaxy',NULL,NULL,NULL,1,262.4062917,75.70442,0.181,NULL,57070434642,891725541,13933211,12.28),(141565,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141565,35.12,0.62,106,68436,70,NULL,NULL,'2MASX J17293946-1105308',NULL,'2014MNRAS.445.2677S',2014,1,0.18,NULL,'G',0.00015,NULL,'15.2R',NULL,'E',NULL,NULL,NULL,NULL,1,262.414333333,-11.09194,1.733,NULL,45306120397,707908131,11061064,15.2),(141566,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141566,35.92,0.5,153,68437,70,NULL,NULL,'2MASX J17294037-7013217',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,262.418333,-70.22272,0.061,NULL,44105458349,689147786,10767934,16),(141567,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141567,36.64,0.46,213,68438,70,NULL,NULL,'2MASX J17294546+5342092',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000104,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,262.4394583,53.70253,0.117,NULL,57467741413,897933459,14030210,16.3),(141568,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141568,38.28,0.46,453,68439,70,NULL,NULL,'2MASX J17294595+5356052',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000099,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,262.4412917,53.93494,0.117,NULL,57469873685,897966776,14030730,16.8),(141569,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141569,38,0.27,399,68440,70,NULL,NULL,'2MASX J17294662+3056029',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,262.44425,30.93408,0.169,NULL,56365128459,880705132,13761017,17.2),(141570,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141570,35.28,0.77,114,68441,70,NULL,NULL,'2MASX J17295053-0307415',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'15.9R',0.1,NULL,NULL,NULL,NULL,NULL,1,262.4605417,-3.12811,0.977,NULL,45121126080,705017595,11015899,15.9),(141571,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141571,37.5,0.46,317,68442,70,NULL,NULL,'SDSS J172951.16+624914.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000074,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,262.463167,62.82075,0.077,NULL,57578850850,899669544,14057336,18),(141572,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141572,35.4,0.72,120,68443,70,NULL,NULL,'2MASX J17295205-1135478',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,262.466833,-11.59664,1.317,NULL,45275128784,707423887,11053498,14.5),(141573,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141573,38,0.27,399,68444,70,NULL,NULL,'2MASX J17295548+3101329',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,262.4812917,31.02581,0.169,NULL,56364979120,880702798,13760981,17.2),(141574,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141574,36.7,0.46,219,68445,70,NULL,NULL,'LCSB S2339P',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000076,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,262.4837917,53.47739,0.121,NULL,57497943671,898405369,14037583,16.6),(141575,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141575,35.17,0.56,108,68446,70,NULL,NULL,'2MASX J17300306-6325349',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,262.512583,-63.42642,0.333,NULL,44489943538,695155367,10861802,16.5),(141576,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141576,37.62,0.46,335,68447,70,NULL,NULL,'2MASX J17300332+5720331',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000083,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,262.513916667,57.34256,0.109,NULL,57696743916,901511623,14086119,17.6),(141577,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141577,37.5,0.46,316,68448,70,NULL,NULL,'2MASX J17301557+5345135',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000089,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,262.564917,53.75375,0.117,NULL,57469886539,897966977,14030734,16.6),(141578,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141578,38.02,0.46,402,68449,70,NULL,NULL,'2MASX J17301751+3118401',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,262.573083333,31.31106,0.169,NULL,56364309584,880692337,13760817,17.3),(141579,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141579,38.1,0.23,417,68450,70,NULL,NULL,'2MASX J17302589+5441555',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.0001,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,262.608125,54.69886,0.145,NULL,57469822634,897965978,14030718,18.1),(141580,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141580,34.29,0.46,72.2,68451,70,NULL,NULL,'ESO 139- G 001',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'14.25',0.8,'S0?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,262.616125,-62.02864,0.305,NULL,44491069757,695172964,10862077,14.25),(141581,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141581,37.7,0.46,348,68452,70,NULL,NULL,'2MASX J17302805+6008295',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000079,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,262.6169583,60.14164,0.117,NULL,57557513064,899336141,14052127,17.7),(141582,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141582,37.26,0.46,283,68453,70,NULL,NULL,'2MASX J17302917+5609505',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000075,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,262.621708333,56.16406,0.129,NULL,57689927964,901405124,14084455,17.1),(141583,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141583,35.3,0.55,115,68454,70,NULL,NULL,'2MASX J17303146-1048034',NULL,'2014MNRAS.445.2677S',2014,1,0.17,NULL,'G',0.00015,NULL,'17.5R',NULL,'S?',NULL,NULL,NULL,NULL,1,262.631083333,-10.80094,1.769,NULL,45306164139,707908814,11061075,17.5),(141584,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141584,38.1,0.23,417,68455,70,NULL,NULL,'2MASX J17303558+5442455',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000115,NULL,'16.3g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,262.6484583,54.71286,0.145,NULL,57469791666,897965494,14030710,16.3),(141585,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141585,36.38,0.59,189,68456,70,NULL,NULL,'2MASX J17304000-6558438',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,262.666667,-65.97878,0.237,NULL,44440298028,694379656,10849682,15.4),(141586,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141586,35,0.4,100,68457,NULL,NULL,'mean','NGC 6378',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00003,NULL,'14.40',0.9,'S?',NULL,NULL,NULL,NULL,1,262.674916667,6.28228,0.337,NULL,56089127317,876392614,13693634,14.4),(141587,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141587,35.38,0.46,119,68457,NULL,NULL,'J','NGC 6378',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141588,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141588,35.39,0.47,119,68457,NULL,NULL,'H','NGC 6378',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141589,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141589,35.4,0.45,120,68457,NULL,NULL,'K','NGC 6378',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141590,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141590,35.63,0.23,134,68458,70,NULL,NULL,'CGCG 277-046',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000073,NULL,'15.0g',0.52,'S0',NULL,NULL,NULL,NULL,1,262.676375,56.63936,0.109,NULL,57694382723,901474730,14085542,15),(141591,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141591,35,0.46,100,68459,70,NULL,NULL,'CGCG 278-007',NULL,'2015arXiv151105856S',2015,1,1.03,NULL,'G',0.000086,NULL,'14.8g',0.41,'S0',NULL,NULL,NULL,NULL,1,262.686875,56.35197,0.101,NULL,57694458336,901475911,14085561,14.8),(141592,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141592,34.08,0.8,65.6,68460,75,NULL,'MAT, I','ESO 044- G 013',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'17.3b',0.3,'Sc? sp',NULL,NULL,NULL,NULL,1,262.688917,-74.45914,0.333,NULL,44147516033,689804938,10778202,17.3),(141593,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141593,34.27,0.4,71.5,68460,NULL,NULL,'mean','ESO 044- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141594,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141594,34.4,0.45,76,68460,NULL,NULL,'K','ESO 044- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141595,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141595,34.41,0.43,76.2,68460,75,NULL,'MAT, I, raw','ESO 044- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141596,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141596,34.42,0.47,76.5,68460,NULL,NULL,'H','ESO 044- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141597,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141597,34.47,0.32,78.3,68460,85,NULL,'I, raw','ESO 044- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141598,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141598,34.51,0.43,79.8,68460,75,NULL,'MAT, I, cor','ESO 044- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141599,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141599,34.51,0.49,79.8,68460,75,NULL,'IR','ESO 044- G 013',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141600,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141600,34.52,0.32,80.2,68460,85,NULL,'I, inv','ESO 044- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141601,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141601,34.57,0.46,82.1,68460,NULL,NULL,'J','ESO 044- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141602,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141602,34.65,0.43,85,68460,75,NULL,'MAT, I, inv','ESO 044- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141603,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141603,34.79,0.46,90.7,68460,NULL,NULL,'Malmquist cor.','ESO 044- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141604,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141604,34.9,0.43,95.7,68460,NULL,NULL,NULL,'ESO 044- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141605,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141605,34.94,0.2,97.3,68460,74.4,NULL,NULL,'ESO 044- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141606,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141606,36.18,0.59,172,68461,70,NULL,NULL,'2MASX J17304572-6633346',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,262.6905,-66.55972,0.277,NULL,44439743562,694370993,10849546,15.5),(141607,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141607,39.15,0.46,677,68462,70,NULL,NULL,'2MASX J17304891+6204308',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000099,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,262.703458333,62.07525,0.117,NULL,57578317045,899661203,14057206,18.2),(141608,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141608,36.87,0.6,236,68463,70,NULL,NULL,'2MASX J17305353-6647127',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,262.7230417,-66.78683,0.285,NULL,44428175895,694190248,10846722,15.5),(141609,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141609,38.1,0.23,417,68464,70,NULL,NULL,'2MASX J17305879+5443401',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000056,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,262.744917,54.72792,0.145,NULL,57469721379,897964396,14030693,18.3),(141610,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141610,38.1,0.23,417,68465,70,NULL,NULL,'2MASX J17310817+5439392',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000082,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,262.784166667,54.66097,0.145,NULL,57469748147,897964814,14030700,17.6),(141611,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141611,37.9,0.33,380,68466,70,NULL,NULL,'2MASX J17311384+5456273',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000097,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,262.807625,54.94081,0.133,NULL,57468760402,897949381,14030459,17.1),(141612,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141612,37.9,0.33,380,68467,70,NULL,NULL,'2MASX J17311883+5457493',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000079,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,262.828583,54.96375,0.133,NULL,57468758037,897949344,14030458,18.1),(141613,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141613,35.78,0.35,143,68468,70,NULL,NULL,'GIN 644',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.000077,NULL,'14.29',NULL,'S',NULL,NULL,NULL,NULL,1,262.836833,43.61603,0.069,NULL,59603882299,931310660,14551729,14.29),(141614,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141614,37.22,0.46,278,68469,70,NULL,NULL,'2MASX J17312567+5819503',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000078,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,262.857083,58.33081,0.089,NULL,57686502867,901351607,14083618,17.5),(141615,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141615,35.63,0.52,134,68470,70,NULL,NULL,'2MASX J17312967-0215442',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00009,NULL,'13.8R',0.1,'near *',NULL,NULL,NULL,NULL,1,262.873625,-2.26225,0.957,NULL,45130046668,705156979,11018077,13.8),(141616,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141616,33.94,NULL,61.3,68471,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10890',NULL,'2010Ap&SS.325..163P',2010,1,1.88,'Bright star superposed.','G',0.000011,NULL,'15.71',0.1,'Sd','Isolated galaxy',NULL,NULL,NULL,1,262.9190417,32.23153,0.153,NULL,56326584957,880102889,13751607,15.71),(141617,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141617,33.95,NULL,61.6,68471,NULL,NULL,'Dipole + Quadrupole','UGC 10890',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141618,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141618,33.95,NULL,61.7,68471,NULL,NULL,'Dipole','UGC 10890',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141619,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141619,34.02,NULL,63.6,68471,NULL,NULL,NULL,'UGC 10890',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141620,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141620,38.05,0.46,408,68472,70,NULL,NULL,'SDSS J173156.98+535616.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000073,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,262.987416667,53.93783,0.117,NULL,57469945623,897967900,14030748,18.6),(141621,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141621,35.83,0.33,146,68473,70,NULL,NULL,'VII Zw 720',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000094,NULL,'16.2g',0.38,'BLAGN',NULL,NULL,NULL,'Sy 1',1,262.99675,59.97167,0.113,NULL,57557619787,899337809,14052153,16.2),(141622,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141622,38.35,0.46,468,68474,70,NULL,NULL,'2MASX J17320236+5313470',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000089,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,263.009916667,53.22989,0.121,NULL,57498050893,898407045,14037610,17.8),(141623,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141623,36.95,NULL,246,68475,NULL,NULL,NULL,'2MASX J17320995+2007424',NULL,'1996PASJ...48..657S',1996,1,0.4,NULL,'G',NULL,NULL,'16',0.2,'Sc',NULL,NULL,NULL,NULL,1,263.0415417,20.12842,0.325,NULL,56837144445,888080381,13876255,16),(141624,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141624,35.83,0.33,146,68476,70,NULL,NULL,'VII Zw 721',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000078,NULL,'15.7g',0.4,'E0',NULL,NULL,NULL,NULL,1,263.060417,59.87086,0.145,NULL,57557603470,899337554,14052149,15.7),(141625,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141625,37.43,0.46,306,68477,70,NULL,NULL,'2MASX J17322375+5524527',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000098,NULL,'16.1g',0.41,'Sy?',NULL,NULL,NULL,'Sy ?',1,263.098916667,55.41464,0.141,NULL,57690367246,901411988,14084562,16.1),(141626,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 1971L',NULL,141626,31.39,0.25,19,68478,60,NULL,'M(V) = -19.47 mag','NGC 6384',NULL,'2000ApJ...540..634P',2000,1,6.2,NULL,'G',0.000004,NULL,'11.14',4.1,'SAB(r)bc       LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,263.10125,7.06028,0.409,NULL,56089414163,876397096,13693704,11.14),(141627,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 1971L',NULL,141627,31.55,0.25,20.4,68478,60,NULL,'M(B) = -19.48 mag','NGC 6384',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141628,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 1971L','R',141628,32.34,NULL,29.4,68478,NULL,NULL,'Photographic','NGC 6384',NULL,'1988SSRv...48....1R',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141629,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141629,32.05,0.8,25.7,68478,75,NULL,'A82, H','NGC 6384',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141630,'Sosies','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141630,31.12,0.31,16.7,68478,NULL,NULL,NULL,'NGC 6384',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141631,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141631,31.36,0.69,18.7,68478,100,NULL,'mid-IR','NGC 6384',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141632,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141632,31.48,0.4,19.8,68478,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 6384',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141633,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141633,31.53,NULL,20.2,68478,NULL,NULL,'LEDA [April 2006]','NGC 6384',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141634,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141634,31.58,0.43,20.7,68478,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6384',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141635,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141635,31.89,NULL,23.9,68478,72,NULL,NULL,'NGC 6384',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141636,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141636,31.96,0.43,24.6,68478,75,NULL,'3.6 micron, color corrected','NGC 6384',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141637,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141637,32,0.3,25.1,68478,NULL,18.45,'SN 1971L host','NGC 6384',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141638,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141638,32.03,0.47,25.4,68478,75,NULL,'A82, H, raw','NGC 6384',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141639,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141639,32.07,0.35,25.9,68478,NULL,NULL,NULL,'NGC 6384',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141640,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141640,32.12,0.4,26.6,68478,75,NULL,'B','NGC 6384',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141641,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141641,32.25,0.47,28.1,68478,75,NULL,'A82, H, inv','NGC 6384',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141642,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141642,32.36,0.2,29.7,68478,74.4,NULL,NULL,'NGC 6384',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141643,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141643,32.39,0.47,30.1,68478,75,NULL,'A82, H, cor','NGC 6384',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141644,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141644,34.99,0.68,99.6,68479,70,NULL,NULL,'2MASX J17322969-7141184',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,263.1235,-71.68847,0.277,NULL,44103459252,689116550,10767446,15.8),(141645,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141645,35.58,0.25,131,68480,74.4,NULL,NULL,'GIN 643',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000047,NULL,'14.96',NULL,'E/S0',NULL,NULL,NULL,NULL,1,263.1462917,43.85264,0.077,NULL,59603712699,931308010,14551687,14.96),(141646,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141646,35.78,0.35,143,68480,70,NULL,NULL,'GIN 643',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141647,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141647,34.76,0.52,89.7,68481,70,NULL,NULL,'2MASX J17323741-5347263',NULL,'2014MNRAS.445.2677S',2014,1,0.11,NULL,'G',0.00015,NULL,'14.4R',NULL,'E?',NULL,NULL,NULL,NULL,1,263.1559583,-53.79069,0.805,NULL,44336256503,692754007,10824281,14.4),(141648,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141648,32.52,0.69,32,68482,100,NULL,'mid-IR','NGC 6389',NULL,'2013ApJ...771...88L',2013,1,2.8,NULL,'G',0.000013,NULL,'12.82',1.9,'Sbc','Isolated galaxy',NULL,NULL,NULL,1,263.165708333,16.40178,0.397,NULL,56812713086,887698641,13870291,12.82),(141649,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141649,33.63,0.4,53.2,68482,NULL,NULL,'mean','NGC 6389',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141650,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141650,34.01,0.46,63.5,68482,NULL,NULL,'J','NGC 6389',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141651,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141651,34.03,0.45,64,68482,NULL,NULL,'K','NGC 6389',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141652,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141652,34.03,0.47,64.1,68482,NULL,NULL,'H','NGC 6389',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141653,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141653,36.68,0.46,217,68483,70,NULL,NULL,'2MASX J17324152+5607012',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000096,NULL,'15.8g',0.44,'E0',NULL,NULL,NULL,NULL,1,263.173125,56.117,0.133,NULL,57694565437,901477584,14085587,15.8),(141654,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141654,38.34,0.46,466,68484,70,NULL,NULL,'2MASX J17325904+5832454',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000097,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,263.245916667,58.546,0.129,NULL,57686612117,901353314,14083645,17.8),(141655,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141655,35.94,0.56,154,68485,70,NULL,NULL,'2MASX J17330150-6646391',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,263.2564583,-66.77758,0.265,NULL,44428185724,694190401,10846725,15.3),(141656,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141656,35.57,0.25,130,68486,74.4,NULL,NULL,'IC 1262',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000077,NULL,'14.73',0.6,'cD;E','Group member',NULL,NULL,NULL,1,263.258417,43.75961,0.069,NULL,59603744587,931308509,14551695,14.73),(141657,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141657,35.78,0.35,143,68486,70,NULL,NULL,'IC 1262',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141658,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141658,35.76,0.45,142,68486,NULL,NULL,'K','IC 1262',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141659,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141659,35.78,0.4,143,68486,NULL,NULL,'mean','IC 1262',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141660,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141660,35.58,0.25,131,68487,74.4,NULL,NULL,'GIN 640',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000053,NULL,'14.77',NULL,'E/S0',NULL,NULL,NULL,NULL,1,263.286625,43.70961,0.069,NULL,59603746141,931308533,14551695,14.77),(141661,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141661,35.78,0.35,143,68487,70,NULL,NULL,'GIN 640',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141662,'SNII optical','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2013eq','R',141662,35.89,0.24,145,68488,NULL,NULL,'EPM, Hamuy et al. (2001)','2MASX J17331525+3628178',0.042,'2016arXiv160304730G',2016,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,263.3135,36.47167,0.125,NULL,56156928844,877452013,13710187,NULL),(141663,'SNII optical','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2013eq','R',141663,35.98,0.42,151,68488,NULL,NULL,'SCM, rise time Dessart & Hillier (2005)','2MASX J17331525+3628178',0.042,'2016arXiv160304730G',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141664,'SNII optical','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2013eq','R',141664,36.03,0.43,154,68488,NULL,NULL,'SCM, rise time Hamuy et al. (2001)','2MASX J17331525+3628178',0.042,'2016arXiv160304730G',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141665,'SNII optical','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2013eq','R',141665,36.07,0.25,157,68488,NULL,NULL,'EPM, Dessart & Hillier (2005)','2MASX J17331525+3628178',0.042,'2016arXiv160304730G',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141666,'SNII optical','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2013eq','R',141666,36.13,0.2,161,68488,NULL,NULL,'SCM, rise time Gall et al. (2015)','2MASX J17331525+3628178',0.042,'2016arXiv160304730G',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141667,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141667,35.78,0.35,143,68489,70,NULL,NULL,'IC 1264',NULL,'2001MNRAS.321..277C',2001,1,1.5,NULL,'G',0.00005,NULL,'14.45',1.1,'E/S0','Group member',NULL,NULL,NULL,1,263.320167,43.62922,0.069,NULL,59603738089,931308407,14551693,14.45),(141668,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141668,35.94,0.4,154,68489,NULL,NULL,'mean','IC 1264',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141669,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141669,36.08,0.45,164,68489,NULL,NULL,'K','IC 1264',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141670,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141670,35.59,0.25,131,68490,74.4,NULL,NULL,'CGCG 226-028',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000167,':','14.36',0.5,'S','Group member',NULL,NULL,NULL,1,263.335083,43.91347,0.077,NULL,59605553459,931336772,14552137,14.36),(141671,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141671,35.78,0.35,143,68490,70,NULL,NULL,'CGCG 226-028',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141672,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141672,34.36,0.46,74.5,68491,70,NULL,NULL,'ESO 139- G 004',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.61',0.6,'SAB(s)0^0^',NULL,NULL,NULL,NULL,1,263.33775,-60.77619,0.349,NULL,44448178003,694502781,10851605,14.61),(141673,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141673,35.58,0.25,131,68492,74.4,NULL,NULL,'UGC 10904 NOTES01',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000047,NULL,'15.5',0.3,'E/S0',NULL,NULL,NULL,NULL,1,263.339541667,43.63472,0.069,NULL,59603735168,931308362,14551693,15.5),(141674,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141674,37.89,0.46,378,68493,70,NULL,NULL,'SDSS J173324.42+552724.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000097,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,263.35175,55.45678,0.141,NULL,57689647363,901400740,14084386,18.7),(141675,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141675,35.91,0.53,152,68494,70,NULL,NULL,'2MASX J17333637-0323119',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'14.4R',0.2,NULL,NULL,NULL,NULL,NULL,1,263.401625,-3.38664,1.329,NULL,45121463707,705022870,11015982,14.4),(141676,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141676,39.03,0.46,640,68495,70,NULL,NULL,'SDSS J173340.91+535243.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000095,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,263.4205,53.87878,0.121,NULL,57467864769,897935387,14030240,18.7),(141677,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141677,34.32,0.5,73.2,68496,70,NULL,NULL,'CGCG 027-002',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000077,NULL,'15.6',0.5,NULL,NULL,NULL,NULL,NULL,1,263.451167,-0.597,0.765,NULL,45126185736,705096652,11017135,15.6),(141678,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141678,33.7,0.5,54.9,68497,70,NULL,NULL,'2MASX J17335042-6221353',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000073,NULL,'14.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,263.4602083,-62.35978,0.257,NULL,44490573867,695165216,10861956,14.4),(141679,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141679,36.39,0.5,190,68498,70,NULL,NULL,'2MASX J17335397-8211311',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,263.474417,-82.19194,0.361,NULL,44054712423,688354881,10755545,15.9),(141680,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141680,37.76,0.33,357,68499,70,NULL,NULL,'2MASX J17340591+5448009',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000104,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,263.525,54.80028,0.133,NULL,57469098234,897954659,14030541,17.9),(141681,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141681,37.19,0.46,274,68500,70,NULL,NULL,'2MASX J17340610+5527009',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000079,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,263.5257083,55.45025,0.141,NULL,57689700054,901401563,14084399,16.8),(141682,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141682,37.76,0.33,357,68501,70,NULL,NULL,'2MASX J17343293+5451598',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00009,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,263.6374583,54.86656,0.133,NULL,57469260541,897957195,14030581,17),(141683,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141683,35.04,0.8,102,68502,75,NULL,'CF, r','UGC 10909',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',NULL,NULL,'15.00',0.6,'Scd:',NULL,NULL,NULL,NULL,1,263.658125,25.5685,0.261,NULL,56294821399,879606584,13743852,15),(141684,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141684,34.31,0.38,72.8,68502,75,NULL,'CF, r, raw','UGC 10909',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141685,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141685,34.38,0.38,75,68502,75,NULL,'CF, r, inv','UGC 10909',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141686,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141686,34.5,0.38,79.3,68502,75,NULL,'CF, r, cor','UGC 10909',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141687,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141687,38.22,0.46,440,68503,70,NULL,NULL,'2MASX J17344206+5324465',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000103,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,263.675083333,53.41292,0.129,NULL,57468098185,897939034,14030297,17.7),(141688,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141688,35.92,0.46,153,68504,70,NULL,NULL,'CGCG 300-050',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000091,NULL,'15.3g',0.51,'E0',NULL,NULL,NULL,NULL,1,263.690833,58.93756,0.133,NULL,57555378128,899302783,14051605,15.3),(141689,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141689,38.42,0.46,484,68505,70,NULL,NULL,'2MASX J17345410+5414007',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000093,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,263.7252083,54.23364,0.133,NULL,57469514543,897961164,14030643,18.2),(141690,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141690,38.8,0.46,576,68506,70,NULL,NULL,'2MASX J17345736+5333221',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000095,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,263.739167,53.55617,0.125,NULL,57468237238,897941206,14030331,18.1),(141691,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141691,35.06,0.58,103,68507,70,NULL,NULL,'2MASX J17351281-6253301',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,263.8035,-62.89161,0.265,NULL,44487659152,695119674,10861244,15.9),(141692,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141692,37.48,0.33,314,68508,70,NULL,NULL,'2MASX J17351382+5527399',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000098,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,263.8075,55.46094,0.141,NULL,57689655158,901400861,14084388,16.6),(141693,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141693,37.48,0.33,314,68509,70,NULL,NULL,'2MASX J17352287+5528319',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000082,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,263.8452917,55.47564,0.141,NULL,57689721606,901401900,14084404,17.4),(141694,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 1999da',NULL,141694,33.58,0.09,52,68510,74.4,NULL,NULL,'NGC 6411',NULL,'2013AJ....146...86T',2013,1,1.73,'MCG misprints dec as +60d20; corrected in MCG errata.','G',0.000028,NULL,'12.9g',1.19,'E',NULL,NULL,NULL,NULL,1,263.886875,60.81339,0.141,NULL,57558534785,899352106,14052376,12.9),(141695,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 1999da',NULL,141695,33.71,0.28,54.5,68510,72,NULL,NULL,'NGC 6411',0.01269,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141696,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 1999da',NULL,141696,33.91,0.1,58.9,68510,65,NULL,'MLCS2k2','NGC 6411',0.01269,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141697,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 1999da',NULL,141697,33.91,0.25,59.9,68510,65,NULL,'MLCS31','NGC 6411',0.01269,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141698,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 1999da',NULL,141698,33.93,0.25,60.2,68510,65,NULL,'MLCS17','NGC 6411',0.01269,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141699,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 1999da',NULL,141699,34.05,0.32,63.8,68510,65,NULL,NULL,'NGC 6411',0.01269,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141700,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 1999da',NULL,141700,34.28,0.21,70.9,68510,70,NULL,'SALT','NGC 6411',0.01269,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141701,'SBF','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141701,32.33,0.35,29.2,68510,NULL,NULL,NULL,'NGC 6411',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141702,'SBF','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141702,32.93,0.35,38.5,68510,NULL,NULL,'Malmquist cor.','NGC 6411',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141703,'D-Sigma','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141703,32.41,0.4,30.3,68510,75,NULL,'Edat, raw','NGC 6411',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141704,'D-Sigma','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141704,32.74,0.4,35.4,68510,75,NULL,'Edat, cor','NGC 6411',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141705,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141705,32.89,0.41,37.9,68510,NULL,NULL,NULL,'NGC 6411',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141706,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141706,33.38,0.41,47.5,68510,NULL,NULL,'Malmquist cor.','NGC 6411',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141707,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141707,37.51,0.46,318,68511,70,NULL,NULL,'2MASX J17353604+5529369',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000101,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,263.900375,55.49364,0.141,NULL,57689720724,901401886,14084404,16.9),(141708,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141708,37.64,0.46,337,68512,70,NULL,NULL,'2MASX J17353678+5324460',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000073,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,263.903375,53.41278,0.129,NULL,57468109641,897939213,14030300,17.3),(141709,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141709,34.98,0.46,99.2,68513,70,NULL,NULL,'2MASX J17354349-5642341',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00009,NULL,'13.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,263.931333333,-56.70956,0.397,NULL,44525376512,695709008,10870453,13.3),(141710,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141710,36.52,0.99,202,68514,70,NULL,NULL,'2MFGC 13932',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,263.966,-67.52261,0.301,NULL,44964805270,702575082,10977735,15.7),(141711,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141711,34.34,0.52,73.8,68515,NULL,NULL,NULL,'ESO 024- G 007',NULL,'2009ApJS..182..474S',2009,1,1.01,NULL,'G',0.000033,NULL,'15.24',0.12,'Scd',NULL,NULL,NULL,NULL,1,264.099167,-77.53667,0.461,NULL,44127458948,689491546,10773305,15.24),(141712,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141712,34.38,0.2,75.2,68515,74.4,NULL,NULL,'ESO 024- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141713,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141713,34.44,NULL,77.4,68515,NULL,NULL,'Dipole + Quadrupole','ESO 024- G 007',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141714,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141714,34.45,NULL,77.5,68515,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 024- G 007',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141715,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141715,34.47,NULL,78.4,68515,NULL,NULL,'Dipole','ESO 024- G 007',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141716,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141716,34.52,0.48,80.2,68515,NULL,NULL,'Malmquist cor.','ESO 024- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141717,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141717,34.53,NULL,80.4,68515,NULL,NULL,NULL,'ESO 024- G 007',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141718,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141718,32.98,0.43,39.4,68516,75,NULL,'3.6 micron, color + selection bias corrected','IC 1265',NULL,'2014MNRAS.444..527S',2014,1,2,NULL,'G',0.00003,NULL,'12.31',0.9,'Sab',NULL,NULL,NULL,NULL,1,264.1642917,42.08842,0.121,NULL,59602892929,931295202,14551487,12.31),(141719,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141719,33.01,0.43,39.9,68516,75,NULL,'3.6 micron, color corrected','IC 1265',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141720,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141720,33.06,0.2,40.9,68516,74.4,NULL,NULL,'IC 1265',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141721,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141721,34.95,0.49,97.8,68517,75,NULL,'IR','CGCG 083-006',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',NULL,NULL,'15.6',0.3,NULL,NULL,NULL,NULL,NULL,1,264.192375,13.16183,0.433,NULL,55954416715,874287761,13660746,15.6),(141722,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141722,32.14,0.69,26.8,68518,100,NULL,'mid-IR','NGC 6434',NULL,'2013ApJ...771...88L',2013,1,2.3,NULL,'G',0.000033,NULL,'13.21',1,'SBbc:          HII',NULL,NULL,NULL,'H II',1,264.203417,72.08897,0.125,NULL,57048240938,891378764,13927793,13.21),(141723,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141723,32.57,0.33,32.7,68518,NULL,NULL,'Malmquist cor.','NGC 6434',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141724,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141724,32.94,0.4,38.8,68518,NULL,NULL,'mean','NGC 6434',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141725,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141725,33,0.2,39.8,68518,74.4,NULL,NULL,'NGC 6434',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141726,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141726,33.01,0.4,40,68518,NULL,NULL,NULL,'NGC 6434',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141727,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141727,33.02,0.27,40.2,68518,NULL,NULL,NULL,'NGC 6434',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141728,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141728,33.08,0.43,41.3,68518,75,NULL,'3.6 micron, color corrected','NGC 6434',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141729,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141729,33.15,0.47,42.7,68518,NULL,NULL,'H','NGC 6434',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141730,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141730,33.15,0.46,42.7,68518,NULL,NULL,'J','NGC 6434',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141731,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141731,33.15,0.43,42.7,68518,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6434',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141732,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141732,33.19,0.45,43.4,68518,NULL,NULL,'K','NGC 6434',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141733,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141733,37.3,0.33,288,68519,70,NULL,NULL,'2MASX J17365398+5458358',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000093,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,264.224833,54.97667,0.149,NULL,57469134526,897955226,14030550,17.3),(141734,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141734,37.3,0.33,288,68520,70,NULL,NULL,'SDSS J173654.72+550201.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000066,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,264.228,55.03389,0.149,NULL,57468435890,897944310,14030379,18.2),(141735,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141735,38.3,0.46,457,68521,70,NULL,NULL,'2MASX J17370061+5837299',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000092,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,264.252958333,58.62514,0.161,NULL,57559523185,899367549,14052617,17.1),(141736,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141736,33.64,0.5,53.4,68522,70,NULL,NULL,'IC 4654',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.00015,NULL,'11.92',1.1,'SAB(r)c',NULL,NULL,NULL,NULL,1,264.282875,-74.38144,0.333,NULL,44148467536,689819805,10778434,11.92),(141737,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141737,38.61,0.46,527,68523,70,NULL,NULL,'2MASX J17371614+5728218',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000086,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,264.317375,57.47258,0.161,NULL,57695378932,901490295,14085785,18),(141738,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141738,36.2,0.51,174,68524,70,NULL,NULL,'2MASX J17371913-6733112',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,264.33,-67.55317,0.301,NULL,44964680950,702573139,10977705,13.9),(141739,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141739,34.78,NULL,90.4,68525,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10931',NULL,'2010Ap&SS.325..163P',2010,1,1.12,NULL,'G',NULL,NULL,'16.5',0.11,'Sc',NULL,NULL,NULL,NULL,1,264.334541667,60.42728,0.185,NULL,57559412559,899365821,14052590,16.5),(141740,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141740,34.8,NULL,91.2,68525,NULL,NULL,'Dipole + Quadrupole','UGC 10931',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141741,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141741,34.81,NULL,91.4,68525,NULL,NULL,'Dipole','UGC 10931',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141742,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141742,35.14,0.58,107,68525,NULL,NULL,'Malmquist cor.','UGC 10931',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141743,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141743,35.2,0.2,110,68525,74.4,NULL,NULL,'UGC 10931',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141744,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141744,35.26,0.55,113,68525,NULL,NULL,NULL,'UGC 10931',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141745,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141745,35.42,NULL,121,68525,NULL,NULL,NULL,'UGC 10931',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141746,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141746,36.27,0.53,180,68526,70,NULL,NULL,'2MASX J17373825-6749321',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,264.409458333,-67.82564,0.309,NULL,44966681158,702604393,10978193,15.2),(141747,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141747,37.07,0.58,260,68527,70,NULL,NULL,'2MASX J17373975-8707342',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,264.4157917,-87.12614,0.381,NULL,44029741756,687964714,10749448,16.8),(141748,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141748,33.93,0.8,61.2,68528,75,NULL,'MAT, I','IC 4656',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.000033,NULL,'13.72',0.6,'SA(s)c:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,264.4327917,-63.72967,0.317,NULL,44431469486,694241710,10847526,13.72),(141749,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141749,33.25,0.43,44.7,68528,75,NULL,'MAT, I, raw','IC 4656',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141750,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141750,33.31,0.32,46,68528,85,NULL,'I, raw','IC 4656',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141751,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141751,33.37,0.32,47.1,68528,85,NULL,'I, inv','IC 4656',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141752,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141752,33.48,0.43,49.7,68528,75,NULL,'MAT, I, inv','IC 4656',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141753,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141753,33.49,0.49,49.9,68528,75,NULL,'IR','IC 4656',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141754,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141754,33.56,0.47,51.4,68528,NULL,NULL,'H','IC 4656',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141755,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141755,33.58,0.43,52,68528,75,NULL,'MAT, I, cor','IC 4656',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141756,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141756,33.6,0.46,52.4,68528,NULL,NULL,'J','IC 4656',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141757,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141757,33.66,0.45,54.1,68528,NULL,NULL,'K','IC 4656',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141758,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141758,33.9,0.4,60.3,68528,NULL,NULL,'mean','IC 4656',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141759,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141759,34.16,0.09,68.1,68528,NULL,NULL,NULL,'IC 4656',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141760,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141760,36.08,0.61,164,68529,70,NULL,NULL,'2MASX J17375184-6501376',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,264.465917,-65.02711,0.249,NULL,44442467725,694413558,10850211,15.9),(141761,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141761,34.6,0.46,83,68530,70,NULL,NULL,'ESO 181- G 002',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000033,NULL,'11.82',0.7,'SAB(s)bc:',NULL,NULL,NULL,NULL,1,264.477083,-55.51819,0.529,NULL,44516247520,695566367,10868224,11.82),(141762,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141762,34.84,0.8,92.9,68530,75,NULL,'MAT, I','ESO 181- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141763,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141763,34.5,0.32,79.3,68530,85,NULL,'I, raw','ESO 181- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141764,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141764,34.58,0.32,82.6,68530,85,NULL,'I, inv','ESO 181- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141765,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141765,34.62,0.47,83.8,68530,NULL,NULL,'Malmquist cor.','ESO 181- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141766,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141766,34.73,0.43,88.2,68530,75,NULL,'MAT, I, raw','ESO 181- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141767,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141767,34.93,0.43,97,68530,75,NULL,'MAT, I, cor','ESO 181- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141768,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141768,35.04,0.39,102,68530,NULL,NULL,NULL,'ESO 181- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141769,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141769,35.08,0.2,104,68530,74.4,NULL,NULL,'ESO 181- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141770,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141770,35.11,0.43,105,68530,75,NULL,'MAT, I, inv','ESO 181- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141771,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141771,35.94,0.55,154,68531,70,NULL,NULL,'2MASX J17375658-7816331',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,264.48575,-78.27592,0.465,NULL,44127718475,689495601,10773368,16),(141772,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141772,37.88,0.46,376,68532,70,NULL,NULL,'2MASX J17375675+5538587',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000079,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,264.486625,55.64975,0.177,NULL,57693712945,901464264,14085379,17.7),(141773,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141773,34.67,0.46,85.7,68533,70,NULL,NULL,'MCG +10-25-073',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000099,NULL,'15.4g',0.41,'HII',NULL,NULL,NULL,NULL,1,264.5224583,57.11819,0.141,NULL,57681434283,901272410,14082381,15.4),(141774,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141774,35.11,0.4,105,68534,NULL,NULL,'mean','UGC 10928',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000057,NULL,'14.70',0.6,'Sb',NULL,NULL,NULL,NULL,1,264.675083333,21.67511,0.505,NULL,56781597914,887212467,13862694,14.7),(141775,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141775,35.22,0.47,111,68534,NULL,NULL,'H','UGC 10928',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141776,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141776,35.33,0.46,116,68534,NULL,NULL,'J','UGC 10928',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141777,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141777,35.33,0.45,116,68534,NULL,NULL,'K','UGC 10928',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141778,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141778,37.79,0.33,362,68535,70,NULL,NULL,'SDSS J173855.05+565520.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000068,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,264.729416667,56.92233,0.149,NULL,57683219851,901300310,14082817,18.4),(141779,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141779,38.52,0.46,506,68536,70,NULL,NULL,'SDSS J173857.58+574635.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000068,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,264.7399583,57.77664,0.149,NULL,57681210975,901268921,14082326,18.4),(141780,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141780,37.79,0.33,362,68537,70,NULL,NULL,'2MASX J17392025+5659458',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00008,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,264.834416667,56.99603,0.141,NULL,57683268127,901301064,14082829,17.1),(141781,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141781,36.4,0.64,190,68538,70,NULL,NULL,'2MASX J17392780-6655406',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,264.865875,-66.92789,0.269,NULL,44428614070,694197094,10846829,15.8),(141782,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141782,32.37,0.8,29.7,68539,75,NULL,'MAT, I','ESO 009- G 010',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000033,NULL,'11.11',1.6,'SA(s)c','in a triple',NULL,NULL,NULL,1,264.881583,-85.31042,0.181,NULL,44028630864,687947357,10749177,11.11),(141783,'Sosies','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141783,32.24,0.11,28.1,68539,NULL,NULL,NULL,'ESO 009- G 010',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141784,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141784,32.57,0.32,32.6,68539,85,NULL,'I, raw','ESO 009- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141785,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141785,32.6,0.4,33.1,68539,NULL,NULL,NULL,'ESO 009- G 010',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141786,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141786,32.6,0.39,33.1,68539,73,NULL,'opt','ESO 009- G 010',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141787,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141787,32.61,0.32,33.3,68539,85,NULL,'I, inv','ESO 009- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141788,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141788,32.66,0.4,34,68539,73,NULL,'opt','ESO 009- G 010',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141789,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141789,32.69,0.43,34.5,68539,75,NULL,'MAT, I, raw','ESO 009- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141790,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141790,32.7,0.53,34.7,68539,NULL,NULL,'Malmquist cor.','ESO 009- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141791,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141791,32.75,0.47,35.5,68539,NULL,NULL,'H','ESO 009- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141792,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141792,32.76,0.4,35.6,68539,NULL,NULL,'mean','ESO 009- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141793,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141793,32.76,0.45,35.6,68539,NULL,NULL,'K','ESO 009- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141794,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141794,32.77,0.46,35.8,68539,NULL,NULL,'J','ESO 009- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141795,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141795,32.78,0.51,35.9,68539,NULL,NULL,NULL,'ESO 009- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141796,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141796,32.82,0.2,36.6,68539,74.4,NULL,NULL,'ESO 009- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141797,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141797,32.88,0.43,37.6,68539,75,NULL,'MAT, I, cor','ESO 009- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141798,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141798,32.91,0.43,38.2,68539,75,NULL,'MAT, I, inv','ESO 009- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141799,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141799,35.12,0.47,105,68540,70,NULL,NULL,'2MASX J17394294-0138228',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.0001,NULL,'13.1I',0.6,NULL,NULL,NULL,NULL,NULL,1,264.928875,-1.63964,1.049,NULL,45159751125,705621111,11025329,13.1),(141800,'GRB','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141800,45.46,1.46,4380,68541,NULL,NULL,NULL,'GRB 090902B',1.822,'2010JCAP...08..020W',2010,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,264.938583,27.32447,0.201,NULL,56303289662,879738900,13745920,NULL),(141801,'GRB','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141801,45.91,0.15,15200,68541,NULL,NULL,NULL,'GRB 090902B',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141802,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141802,37.8,0.46,363,68542,70,NULL,NULL,'2MASX J17394650+5525598',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000102,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,264.944083333,55.43333,0.173,NULL,57463017904,897859654,14029057,16.9),(141803,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141803,35.25,0.52,112,68543,70,NULL,NULL,'2MASX J17395214-0330348',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'13.8I',0.2,NULL,NULL,NULL,NULL,NULL,1,264.9672917,-3.50964,1.637,NULL,45149719128,705464361,11022880,13.8),(141804,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141804,38.18,0.33,432,68544,70,NULL,NULL,'2MASX J17395564+5419447',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000092,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,264.981958333,54.32903,0.161,NULL,57476957802,898077465,14032460,17.8),(141805,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141805,36.2,0.46,174,68545,70,NULL,NULL,'2MASX J17395671+5345016',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000091,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,264.986333,53.75058,0.117,NULL,57475302660,898051604,14032056,16.3),(141806,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141806,37.73,0.46,351,68546,70,NULL,NULL,'SDSS J174003.97+551615.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000083,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,265.016541667,55.27103,0.173,NULL,57476689816,898073278,14032394,18.5),(141807,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141807,35.08,0.5,104,68547,70,NULL,NULL,'2MASX J17400574-6726235',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,265.024125,-67.43997,0.277,NULL,44964739779,702574059,10977719,15.3),(141808,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141808,37.39,0.46,301,68548,70,NULL,NULL,'SDSS J174005.92+573435.1',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000089,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,265.024667,57.57642,0.177,NULL,57682058518,901282164,14082533,17),(141809,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141809,38.04,0.46,405,68549,70,NULL,NULL,'2MASX J17401396+5510524',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00009,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,265.058167,55.18117,0.149,NULL,57476894122,898076470,14032444,17.9),(141810,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141810,38.18,0.33,432,68550,70,NULL,NULL,'2MASX J17401428+5420184',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000083,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,265.059458333,54.33836,0.161,NULL,57476956251,898077441,14032460,16.8),(141811,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141811,34.37,0.46,74.7,68551,70,NULL,NULL,'ESO 044- G 018',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000057,NULL,'14.3b',1,'E0-1:',NULL,NULL,NULL,NULL,1,265.076125,-74.98672,0.297,NULL,44132279083,689566860,10774482,14.3),(141812,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141812,33.54,0.49,51,68552,70,NULL,NULL,'UKS 1736-633',NULL,'2014MNRAS.445.2677S',2014,1,1.8,'Marginal HIPASS detection.','G',0.000035,NULL,'14.7b',1.2,'SA(l)0^0',NULL,NULL,NULL,NULL,1,265.2947917,-63.39086,0.297,NULL,44487336550,695114633,10861166,14.7),(141813,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141813,34.24,0.2,70.5,68553,74.4,NULL,NULL,'NGC 6436',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.00003,NULL,'14.68',0.8,'Scd:',NULL,NULL,NULL,NULL,1,265.305167,60.44969,0.185,NULL,57559333563,899364586,14052571,14.68),(141814,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141814,34.45,0.51,77.5,68553,NULL,NULL,NULL,'NGC 6436',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141815,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141815,34.48,0.51,78.7,68553,NULL,NULL,'Malmquist cor.','NGC 6436',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141816,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141816,36.97,0.46,247,68554,70,NULL,NULL,'2MASX J17412156+5524037',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000091,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,265.3397917,55.40103,0.145,NULL,57463254885,897863357,14029114,16.6),(141817,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141817,37.9,0.46,380,68555,70,NULL,NULL,'2MASX J17412243+5341380',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000093,NULL,'18.1g',0.17,'NLAGN',NULL,NULL,NULL,NULL,1,265.343583333,53.69389,0.145,NULL,57475328873,898052013,14032062,18.1),(141818,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141818,33.69,0.47,54.8,68556,NULL,NULL,NULL,'ESO 139- G 016',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'15.75',0.6,'S...',NULL,NULL,NULL,NULL,1,265.4362917,-61.70303,0.309,NULL,44486571218,695102675,10860979,15.75),(141819,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141819,33.73,0.2,55.7,68556,74.4,NULL,NULL,'ESO 139- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141820,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141820,33.97,0.41,62.2,68556,NULL,NULL,'Malmquist cor.','ESO 139- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141821,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141821,34.1,0.37,66.1,68557,NULL,NULL,NULL,'ESO 009- G 009',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.29',0.4,'SBcd:',NULL,NULL,NULL,NULL,1,265.443625,-86.71472,0.497,NULL,44030663494,687979117,10749673,14.29),(141822,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141822,34.14,0.2,67.3,68557,74.4,NULL,NULL,'ESO 009- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141823,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141823,34.18,0.36,68.7,68557,NULL,NULL,'Malmquist cor.','ESO 009- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141824,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141824,33.21,0.47,43.9,68558,NULL,NULL,'H','NGC 6417',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000023,NULL,'13.90',1.2,'SB(r)b:',NULL,NULL,NULL,NULL,1,265.44925,23.67219,0.509,NULL,56249493263,878898332,13732786,13.9),(141825,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141825,33.28,0.45,45.4,68558,NULL,NULL,'K','NGC 6417',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141826,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141826,33.35,0.46,46.8,68558,NULL,NULL,'J','NGC 6417',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141827,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141827,33.47,0.4,49.5,68558,NULL,NULL,'mean','NGC 6417',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141828,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141828,38.38,0.27,474,68559,70,NULL,NULL,'2MASX J17415413+5543025',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000096,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,265.475417,55.71739,0.165,NULL,57682269901,901285467,14082585,17.8),(141829,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141829,38.38,0.27,474,68560,70,NULL,NULL,'SDSS J174155.59+553710.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000108,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,265.481625,55.61961,0.145,NULL,57463174797,897862106,14029095,18.2),(141830,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141830,38.38,0.27,474,68561,70,NULL,NULL,'2MASX J17415677+5532155',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000099,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,265.486791667,55.53778,0.145,NULL,57463236383,897863068,14029110,17.9),(141831,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141831,34.62,0.68,83.9,68562,70,NULL,NULL,'2MASX J17415870-0334020',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000123,NULL,'15.0R',0.3,NULL,NULL,NULL,NULL,NULL,1,265.494583,-3.56725,1.649,NULL,45161477417,705648084,11025751,15),(141832,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141832,34.58,0.47,82.6,68563,NULL,NULL,'H','UGC 10943',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000008,NULL,'14.80',0.6,'S?',NULL,NULL,NULL,NULL,1,265.552083,3.199,0.625,NULL,55899938595,873436540,13647445,14.8),(141833,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141833,34.76,0.45,89.7,68563,NULL,NULL,'K','UGC 10943',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141834,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141834,34.84,0.46,92.7,68563,NULL,NULL,'J','UGC 10943',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141835,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141835,34.87,0.4,94,68563,NULL,NULL,'mean','UGC 10943',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141836,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141836,37.51,0.46,318,68564,70,NULL,NULL,'2MASX J17421555+5514135',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000106,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,265.564625,55.23706,0.145,NULL,57463127314,897861364,14029083,16.6),(141837,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141837,36.8,0.46,229,68565,70,NULL,NULL,'SDSS J174220.31+540324.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000074,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,265.584667,54.05667,0.125,NULL,57478204364,898096943,14032764,18.1),(141838,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141838,34.31,0.49,72.8,68566,75,NULL,'IR','UGC 10948',NULL,'2011yCatp016004901K',2011,1,2.58,NULL,'G',NULL,NULL,'15.1',0.43,'Sb',NULL,NULL,NULL,NULL,1,265.63325,0.21681,1.033,NULL,55843463531,872554117,13633658,15.1),(141839,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141839,35.38,0.61,119,68567,70,NULL,NULL,'2MASX J17423441-6536024',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,265.643333,-65.60078,0.245,NULL,44442022486,694406601,10850103,15.1),(141840,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141840,36.66,0.5,215,68568,70,NULL,NULL,'2MASX J17423779-8701480',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,265.6575,-87.03006,0.445,NULL,44029926724,687967605,10749493,15.1),(141841,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141841,35.99,0.56,158,68569,70,NULL,NULL,'2MASX J17425028-6331085',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,265.709417,-63.51906,0.301,NULL,44431923833,694248809,10847637,16.3),(141842,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141842,38.12,0.33,422,68570,70,NULL,NULL,'2MASX J17430048+5415377',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000079,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,265.752166667,54.26047,0.125,NULL,57478144110,898096001,14032750,17.5),(141843,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141843,36.17,0.7,171,68571,70,NULL,NULL,'2MASX J17430648-0113069',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,265.777041667,-1.21858,1.045,NULL,45101637729,704713089,11011142,15.3),(141844,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141844,38.12,0.33,422,68572,70,NULL,NULL,'2MASX J17430947+5405327',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00011,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,265.7892917,54.09247,0.125,NULL,57478127842,898095747,14032746,17.4),(141845,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141845,33.97,0.48,62.3,68573,70,NULL,NULL,'NGC 6403',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'14.29',0.9,'SA(rs)0^0^:',NULL,NULL,NULL,NULL,1,265.848167,-61.68211,0.309,NULL,44486608249,695103253,10860988,14.29),(141846,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141846,37.83,0.46,368,68574,70,NULL,NULL,'SDSS J174348.90+540317.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000068,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,265.95375,54.05494,0.125,NULL,57478133616,898095837,14032747,18.5),(141847,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141847,34.7,0.47,87,68575,NULL,NULL,'H','NGC 6433',NULL,'2007A&A...465...71T',2007,1,2,NULL,'G',0.000014,NULL,'14.06',0.5,'Sb',NULL,NULL,NULL,NULL,1,265.9842083,36.80011,0.133,NULL,56147092423,877298319,13707786,14.06),(141848,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141848,34.71,0.46,87.6,68575,NULL,NULL,'J','NGC 6433',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141849,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141849,34.78,0.45,90.2,68575,NULL,NULL,'K','NGC 6433',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141850,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141850,34.83,0.49,92.6,68575,75,NULL,'IR','NGC 6433',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141851,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141851,35.04,0.4,102,68575,NULL,NULL,'mean','NGC 6433',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141852,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141852,32.7,0.69,34.7,68576,100,NULL,'mid-IR','NGC 6429',NULL,'2013ApJ...771...88L',2013,1,1.9,NULL,'G',0.000077,NULL,'14.01',0.8,'SBa',NULL,NULL,NULL,NULL,1,266.0222917,25.35072,0.289,NULL,56292994793,879578043,13743406,14.01),(141853,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141853,33.25,0.47,44.6,68576,NULL,NULL,'H','NGC 6429',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141854,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141854,33.27,0.45,45.1,68576,NULL,NULL,'K','NGC 6429',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141855,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141855,33.31,0.46,46,68576,NULL,NULL,'J','NGC 6429',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141856,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141856,33.44,0.4,48.7,68576,NULL,NULL,'mean','NGC 6429',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141857,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2003fa',NULL,141857,35.25,0.4,112,68577,74.2,NULL,'SALT 2','ARK 527',0.006004,'2010ApJ...716..712A',2010,1,0.5,'RC3 gives v = 1800 +/- 190 km/sec.','G',0.000117,NULL,'15.20',0.3,'S?',NULL,NULL,NULL,NULL,1,266.035833,40.86731,0.117,NULL,56116238809,876816231,13700253,15.2),(141858,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2003fa',NULL,141858,35.73,0.03,139,68577,70,NULL,'SALT 2','ARK 527',0.006004,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141859,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2003fa',NULL,141859,36.12,0.14,161,68577,73.8,NULL,'SALT 2 (SNANA)','ARK 527',0.0392,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141860,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2003fa',NULL,141860,36.06,0.03,162,68577,72,NULL,'SALT','ARK 527',0.006004,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141861,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2003fa',NULL,141861,36.09,0.15,164,68577,70,NULL,'SALT 2','ARK 527',0.006004,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141862,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2003fa',NULL,141862,36.21,0.16,174,68577,65,NULL,'SALT','ARK 527',0.006004,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141863,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2003fa',NULL,141863,36.22,0.18,174,68577,65,NULL,'SALT2','ARK 527',0.006004,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141864,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2003fa',NULL,141864,36.35,0.13,185,68577,65,NULL,'MLCS17','ARK 527',0.006004,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141865,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2003fa',NULL,141865,36.37,0.12,187,68577,65,NULL,'MLCS31','ARK 527',0.006004,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141866,'Tully est','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141866,32.12,0.8,26.6,68577,75,NULL,'B','ARK 527',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141867,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141867,34.58,0.49,82.5,68578,75,NULL,'IR','NGC 6471 NED01',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000143,NULL,'15.4',0.2,'Scd:','Group member',NULL,NULL,NULL,1,266.054333,67.59306,0.153,NULL,57784156352,902877443,14107460,15.4),(141868,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141868,35.32,0.73,116,68579,70,NULL,NULL,'2MASX J17442277-6528341',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,266.094875,-65.47614,0.245,NULL,44442040964,694406890,10850107,14.7),(141869,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2005ao',NULL,141869,36.11,0.09,161,68580,72,NULL,NULL,'NGC 6462',0.038407,'2008ApJ...689..377W',2008,1,0.4,NULL,'G',0.000417,NULL,'14.9',0.4,'SABbc','Isolated galaxy',NULL,NULL,NULL,1,266.203583,61.91058,0.133,NULL,57570449965,899538280,14055285,14.9),(141870,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2005ao',NULL,141870,36.2,0.1,167,68580,72,NULL,NULL,'NGC 6462',0.038407,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141871,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2005ao',NULL,141871,36.12,0.08,168,68580,72,NULL,'M(H) = -18.317 mag','NGC 6462',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141872,'D-Sigma','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141872,33.77,0.4,56.8,68581,75,NULL,'Edat, raw','NGC 6407',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000107,NULL,'12.34',1.6,'SA0^0^? pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,266.240375,-60.73981,0.345,NULL,44454053685,694594588,10853040,12.34),(141873,'D-Sigma','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141873,34.12,0.4,66.7,68581,75,NULL,'Edat, cor','NGC 6407',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141874,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141874,34.01,0.4,63.4,68581,NULL,NULL,'mean','NGC 6407',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141875,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141875,34.31,0.45,72.8,68581,NULL,NULL,'K','NGC 6407',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141876,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141876,35.48,0.6,125,68582,70,NULL,NULL,'2MASX J17451158-5533084',NULL,'2014MNRAS.445.2677S',2014,1,0.14,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,266.298333,-55.55231,0.385,NULL,44328446265,692631972,10822374,15.1),(141877,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141877,35.97,0.62,156,68583,70,NULL,NULL,'2MASX J17455962-7725081',NULL,'2014MNRAS.445.2677S',2014,1,NULL,'1991MNRAS.248..528A has z = 0.1150 +- 0.0004.','G',0.00015,NULL,'16.4b',NULL,'Sbrst',NULL,NULL,NULL,NULL,1,266.498667,-77.41894,0.457,NULL,44128091655,689501432,10773459,16.4),(141878,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141878,35.65,0.49,135,68584,75,NULL,'IR','UGC 10982',NULL,'2011yCatp016004901K',2011,1,1.42,NULL,'G',0.00004,NULL,'16.0',0.19,'Sbc',NULL,NULL,NULL,NULL,1,266.5094583,59.32311,0.169,NULL,57561667800,899401059,14053141,16),(141879,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141879,35.15,0.56,107,68585,70,NULL,NULL,'2MASX J17461029-6041410',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,266.5427083,-60.69472,0.345,NULL,44454035959,694594311,10853036,16.5),(141880,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141880,35.29,0.49,114,68586,70,NULL,NULL,'ESO 181- GA004',NULL,'2014MNRAS.445.2677S',2014,1,2.8,NULL,'G',0.00015,NULL,'13.3R',1.9,'SB(r)a',NULL,NULL,NULL,NULL,1,266.5632917,-55.18417,0.525,NULL,44328518997,692633109,10822392,13.3),(141881,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141881,34.48,0.47,78.6,68587,NULL,NULL,'H','NGC 6447',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.00005,NULL,'13.74',0.9,'SBb','Pair member (points to parent)',NULL,NULL,NULL,1,266.5717917,35.57197,0.089,NULL,56150762618,877355665,13708682,13.74),(141882,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141882,34.62,0.46,84,68587,NULL,NULL,'J','NGC 6447',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141883,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141883,34.63,0.45,84.5,68587,NULL,NULL,'K','NGC 6447',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141884,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141884,34.74,0.4,88.9,68587,NULL,NULL,'mean','NGC 6447',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141885,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141885,33.87,0.49,59.5,68588,75,NULL,'IR','UGC 10972',NULL,'2011yCatp016004901K',2011,1,2.5,'UZC position refers to a knot on the southwest arm.','G',0.000017,NULL,'14.00',0.7,'Scd:','Isolated galaxy',NULL,NULL,NULL,1,266.5912083,26.54375,0.269,NULL,56300551140,879696111,13745251,14),(141886,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141886,34,0.2,63.1,68588,74.4,NULL,NULL,'UGC 10972',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141887,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141887,34.2,0.35,69.1,68588,NULL,NULL,NULL,'UGC 10972',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141888,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141888,34.21,0.35,69.4,68588,NULL,NULL,'Malmquist cor.','UGC 10972',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141889,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141889,34.21,0.47,69.5,68588,NULL,NULL,'H','UGC 10972',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141890,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141890,34.23,0.4,70.1,68588,NULL,NULL,'mean','UGC 10972',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141891,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141891,34.29,0.46,72,68588,NULL,NULL,'J','UGC 10972',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141892,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141892,34.38,0.45,75.2,68588,NULL,NULL,'K','UGC 10972',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141893,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141893,34.28,0.4,71.8,68589,NULL,NULL,'mean','UGC 10976',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000067,NULL,'14.4',0.5,'SB','Pair member (points to parent)',NULL,NULL,NULL,1,266.616125,30.70475,0.253,NULL,56269609101,879212642,13737697,14.4),(141894,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141894,34.92,0.47,96.4,68589,NULL,NULL,'H','UGC 10976',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141895,'Tully est','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141895,32.02,0.8,25.3,68590,75,NULL,NULL,'UGC 10991',NULL,'1988NBGC.C....0000T',1988,1,1,NULL,'G',0.000013,NULL,'17.',0.9,'Im',NULL,NULL,NULL,NULL,1,266.620417,67.33806,0.169,NULL,57781282965,902832546,14106758,17),(141896,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141896,33.39,0.8,47.7,68591,75,NULL,'MAT, I','ESO 070- G 013',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000029,NULL,'14.9',1.1,'SAB(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,266.634,-68.26208,0.353,NULL,44963720566,702558133,10977470,14.9),(141897,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141897,32.87,0.32,37.5,68591,85,NULL,'I, inv','ESO 070- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141898,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141898,32.88,0.32,37.7,68591,85,NULL,'I, raw','ESO 070- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141899,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141899,32.97,0.43,39.3,68591,75,NULL,'MAT, I, inv','ESO 070- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141900,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141900,32.98,0.43,39.5,68591,75,NULL,'MAT, I, raw','ESO 070- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141901,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141901,33.31,0.43,46,68591,75,NULL,'MAT, I, cor','ESO 070- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141902,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141902,34.88,0.4,94.8,68592,NULL,NULL,'mean','UGC 10984',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00005,NULL,'14.86',0.6,'SBab:',NULL,NULL,NULL,NULL,1,266.664833333,51.28136,0.137,NULL,57507950702,898561729,14040027,14.86),(141903,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141903,35.22,0.47,111,68592,NULL,NULL,'H','UGC 10984',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141904,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141904,36.37,0.74,188,68593,70,NULL,NULL,'2MASX J17464380-7808327',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,266.682417,-78.1425,0.469,NULL,44124922387,689451912,10772686,16.9),(141905,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141905,33.94,0.55,61.3,68594,70,NULL,NULL,'ESO 139- G 026',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'13.99',0.9,'SB(s)0^0^: pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,266.711708333,-59.25839,0.393,NULL,44458725498,694667585,10854181,13.99),(141906,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141906,34.67,0.49,86,68595,75,NULL,'IR','UGC 10986',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',NULL,NULL,'17.',0.1,'Scd',NULL,NULL,NULL,NULL,1,266.718375,57.06761,0.157,NULL,57684000196,901312503,14083007,17),(141907,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141907,34.68,NULL,86.5,68595,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10986',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141908,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141908,34.7,NULL,87,68595,NULL,NULL,'Dipole + Quadrupole','UGC 10986',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141909,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141909,34.71,NULL,87.4,68595,NULL,NULL,'Dipole','UGC 10986',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141910,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141910,34.75,NULL,89,68595,NULL,NULL,NULL,'UGC 10986',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141911,'Brightest Stars','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141911,26.8,NULL,2.3,68596,NULL,NULL,NULL,'IC 4662',NULL,'1990A&A...234...99H',1990,1,2.8,'The 2MASS positions apply to HII regions northeast of the center.','G',0.00001,NULL,'11.7B',1.6,'IBm','Field galaxy',NULL,NULL,NULL,1,266.786958333,-64.64175,0.265,0,44441034186,694391159,10849861,11.7),(141912,'CMD','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141912,26.75,0.04,2.24,68596,NULL,NULL,'LSB','IC 4662',NULL,'2010ApJ...721..297M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141913,'CMD','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141913,26.8,0.04,2.29,68596,NULL,NULL,NULL,'IC 4662',NULL,'2009ApJ...695..561M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141914,'CMD','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141914,26.8,0.04,2.29,68596,NULL,NULL,'HSB','IC 4662',NULL,'2010ApJ...721..297M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141915,'TRGB','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141915,26.82,0.1,2.31,68596,NULL,NULL,NULL,'IC 4662',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141916,'TRGB','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141916,26.94,NULL,2.44,68596,NULL,NULL,NULL,'IC 4662',NULL,'2006AJ....131.1361K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141917,'TRGB','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141917,27,0.02,2.51,68596,NULL,NULL,'I','IC 4662',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141918,'TRGB','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141918,27.03,0.1,2.55,68596,74.4,NULL,NULL,'IC 4662',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141919,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141919,27.38,0.4,3,68596,75,NULL,'B','IC 4662',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141920,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141920,35.62,0.34,133,68597,NULL,NULL,'Malmquist cor.','UGC 10981',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000007,NULL,'14.98',0.5,'Sbc','Isolated galaxy',NULL,NULL,NULL,1,266.914125,9.54714,0.629,NULL,56083587148,876306049,13692282,14.98),(141921,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141921,35.92,0.2,153,68597,74.4,NULL,NULL,'UGC 10981',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141922,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141922,35.95,0.29,155,68597,NULL,NULL,NULL,'UGC 10981',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141923,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141923,35.82,0.53,146,68598,70,NULL,NULL,'2MASX J17474656-6517445',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,266.944167,-65.29569,0.257,NULL,44441473597,694398024,10849969,14.3),(141924,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141924,34.78,0.49,90.6,68599,75,NULL,'IR','FGC 2156',NULL,'2011yCatp016004901K',2011,1,1.23,NULL,'G',0.000007,NULL,'16.2',0.12,'Sbc',NULL,NULL,NULL,NULL,1,266.956333333,5.80694,0.585,NULL,55856812885,872762701,13636917,16.2),(141925,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141925,35.78,NULL,143,68599,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2156',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141926,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141926,35.78,NULL,144,68599,NULL,NULL,'Dipole + Quadrupole','FGC 2156',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141927,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141927,35.81,NULL,145,68599,NULL,NULL,'Dipole','FGC 2156',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141928,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141928,35.81,NULL,145,68599,NULL,NULL,NULL,'FGC 2156',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141929,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141929,31.07,0.4,16.4,68600,75,NULL,NULL,'UGC 10985',NULL,'2008Ap.....51..336K',2008,1,1.3,NULL,'G',0.000017,NULL,'13.78',0.9,'SB(s)dm',NULL,NULL,NULL,NULL,1,267.0185417,14.74147,0.333,NULL,55966770838,874480794,13663762,13.78),(141930,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141930,31.89,0.49,23.9,68600,75,NULL,'IR','UGC 10985',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141931,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141931,34.9,0.49,95.5,68601,75,NULL,'IR','FGC 2161',NULL,'2011yCatp016004901K',2011,1,0.95,NULL,'G',NULL,NULL,'16.5',0.1,'Scd',NULL,NULL,NULL,NULL,1,267.048,53.15242,0.141,NULL,57474874749,898044917,14031951,16.5),(141932,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141932,34.95,NULL,97.6,68601,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2161',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141933,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141933,34.96,NULL,98.3,68601,NULL,NULL,'Dipole + Quadrupole','FGC 2161',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141934,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141934,34.98,NULL,99,68601,NULL,NULL,'Dipole','FGC 2161',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141935,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141935,35.01,NULL,100,68601,NULL,NULL,NULL,'FGC 2161',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141936,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141936,37.35,0.81,295,68602,70,NULL,NULL,'2MASX J17483432-6429202',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,267.142875,-64.48906,0.265,NULL,44441057860,694391529,10849867,14.1),(141937,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141937,37,0.61,251,68603,70,NULL,NULL,'2MASX J17483481-6807311',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,267.14525,-68.12533,0.397,NULL,44963549010,702555453,10977428,15.6),(141938,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141938,36.27,0.81,180,68604,70,NULL,NULL,'2MASX J17483658-6625421',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,267.1525,-66.42833,0.269,NULL,44430151934,694221123,10847205,15.3),(141939,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141939,34.78,0.8,90.3,68605,75,NULL,'CF, r','NGC 6478',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'13.99',0.7,'SAc:',NULL,NULL,NULL,NULL,1,267.1597917,51.15725,0.173,NULL,57507866346,898560411,14040006,13.99),(141940,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141940,34.09,0.47,65.9,68605,NULL,NULL,'H','NGC 6478',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141941,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141941,34.13,0.46,67.1,68605,NULL,NULL,'J','NGC 6478',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141942,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141942,34.19,0.45,69,68605,NULL,NULL,'K','NGC 6478',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141943,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141943,34.38,0.38,75.2,68605,75,NULL,'CF, r, raw','NGC 6478',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141944,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141944,34.61,0.38,83.5,68605,75,NULL,'CF, r, inv','NGC 6478',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141945,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141945,34.65,0.2,85.1,68605,74.4,NULL,NULL,'NGC 6478',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141946,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141946,34.66,0.38,85.3,68605,75,NULL,'CF, r, cor','NGC 6478',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141947,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141947,34.68,0.42,86.5,68605,NULL,NULL,'Malmquist cor.','NGC 6478',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141948,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141948,34.69,0.4,86.7,68605,NULL,NULL,'mean','NGC 6478',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141949,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141949,34.77,0.4,89.9,68605,NULL,NULL,NULL,'NGC 6478',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141950,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141950,35.8,0.49,144,68606,70,NULL,NULL,'2MASX J17485422-6243302',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000073,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,267.225875,-62.72506,0.341,NULL,44485335711,695083370,10860677,16.1),(141951,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141951,35.21,NULL,110,68607,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2165',NULL,'2010Ap&SS.325..163P',2010,1,0.72,NULL,'G',NULL,NULL,'16.9',0.09,'Sd',NULL,NULL,NULL,NULL,1,267.237083,66.71733,0.153,NULL,57516141990,898689718,14042026,16.9),(141952,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141952,35.23,NULL,111,68607,NULL,NULL,'Dipole + Quadrupole','FGC 2165',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141953,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141953,35.25,NULL,112,68607,NULL,NULL,'Dipole','FGC 2165',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141954,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141954,35.26,NULL,113,68607,NULL,NULL,NULL,'FGC 2165',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141955,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141955,34.12,0.8,66.7,68608,75,NULL,'MAT, I','IC 4664',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000027,NULL,'13.64',1,'(R\')SAB(r)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,267.244125,-63.25453,0.329,NULL,44434192321,694284255,10848191,13.64),(141956,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141956,33.04,0.32,40.6,68608,85,NULL,'I, raw','IC 4664',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141957,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141957,33.09,0.32,41.4,68608,85,NULL,'I, inv','IC 4664',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141958,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141958,33.09,0.47,41.5,68608,NULL,NULL,'H','IC 4664',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141959,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141959,33.22,0.45,44.1,68608,NULL,NULL,'K','IC 4664',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141960,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141960,33.26,0.46,44.8,68608,NULL,NULL,'J','IC 4664',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141961,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141961,33.3,0.43,45.8,68608,75,NULL,'MAT, I, raw','IC 4664',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141962,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141962,33.34,0.61,46.5,68608,NULL,NULL,NULL,'IC 4664',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141963,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141963,33.38,0.2,47.4,68608,74.4,NULL,NULL,'IC 4664',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141964,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141964,33.53,0.43,50.9,68608,75,NULL,'MAT, I, inv','IC 4664',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141965,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141965,33.63,0.43,53.3,68608,75,NULL,'MAT, I, cor','IC 4664',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141966,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141966,33.73,0.51,55.7,68608,NULL,NULL,'Malmquist cor.','IC 4664',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141967,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141967,33.96,0.4,62.1,68608,NULL,NULL,'mean','IC 4664',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141968,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141968,36.8,0.77,229,68609,70,NULL,NULL,'2MASX J17492336-6603570',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,267.347333,-66.06589,0.249,NULL,44429397534,694209336,10847020,15.2),(141969,'Brightest Stars','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141969,28.57,NULL,5.2,68610,NULL,NULL,'blue','NGC 6503',NULL,'1997A&A...324..457K',1997,1,7.1,NULL,'G',0.000003,NULL,'10.91',2.4,'SA(s)cd    HII/LINER','Possible group member',NULL,NULL,NULL,1,267.360125,70.14436,0.137,NULL,57044027496,891312929,13926764,10.91),(141970,'Brightest Stars','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141970,28.7,0.2,5.5,68610,NULL,NULL,'red','NGC 6503',NULL,'1997A&A...324..457K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141971,'TRGB','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141971,28.61,0.23,5.27,68610,NULL,NULL,NULL,'NGC 6503',NULL,'2003A&A...398..479K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141972,'TRGB','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141972,28.98,0.1,6.25,68610,74.4,NULL,NULL,'NGC 6503',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141973,'TRGB','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141973,29,0.03,6.3,68610,NULL,NULL,NULL,'NGC 6503',NULL,'2014AstL...40..537T',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141974,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141974,28.85,NULL,5.89,68610,NULL,NULL,'LEDA [April 2006]','NGC 6503',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141975,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141975,28.92,0.4,6.1,68610,75,NULL,'B','NGC 6503',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141976,'Tully est','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141976,30.8,0.8,14.5,68611,75,NULL,'B','UGC 11000',NULL,'1988NBGC.C....0000T',1988,1,0.7,NULL,'G',0.000007,NULL,'14.4',0.4,'S?',NULL,NULL,NULL,NULL,1,267.3610417,36.14522,0.129,NULL,56153143899,877392873,13709263,14.4),(141977,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141977,32.22,0.2,27.8,68611,74.4,NULL,NULL,'UGC 11000',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141978,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141978,33.3,0.8,45.8,68612,75,NULL,'CF, r','NGC 6460',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000023,NULL,'13.80',1.1,'Scd:','Pair member (points to parent)',NULL,NULL,NULL,1,267.3765,20.76367,0.477,NULL,56777241116,887144392,13861631,13.8),(141979,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141979,32.65,0.69,33.8,68612,100,NULL,'mid-IR','NGC 6460',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141980,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141980,33.23,0.43,44.2,68612,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6460',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141981,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141981,33.26,0.43,44.8,68612,75,NULL,'3.6 micron, color corrected','NGC 6460',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141982,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141982,33.32,0.2,46.1,68612,74.4,NULL,NULL,'NGC 6460',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141983,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141983,33.58,0.38,52.1,68612,75,NULL,'CF, r, raw','NGC 6460',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141984,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141984,33.71,0.38,55.3,68612,75,NULL,'CF, r, inv','NGC 6460',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141985,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141985,33.72,0.4,55.4,68612,NULL,NULL,'mean','NGC 6460',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141986,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141986,33.84,0.38,58.6,68612,75,NULL,'CF, r, cor','NGC 6460',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141987,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141987,34.21,0.47,69.5,68612,NULL,NULL,'H','NGC 6460',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141988,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141988,34.23,0.45,70.2,68612,NULL,NULL,'K','NGC 6460',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141989,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141989,34.23,0.46,70.3,68612,NULL,NULL,'J','NGC 6460',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141990,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141990,33.11,0.49,42,68613,75,NULL,'IR','ESO 139- G 030',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'16.0b',0.2,'S...',NULL,NULL,NULL,NULL,1,267.383875,-62.4995,0.361,NULL,44485522388,695086287,10860723,16),(141991,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141991,34.23,0.11,70.3,68613,NULL,NULL,NULL,'ESO 139- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141992,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141992,37.09,0.53,262,68614,70,NULL,NULL,'2MASX J17495711-6527221',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.8I',0.4,NULL,NULL,NULL,NULL,NULL,1,267.487833333,-65.45608,0.257,NULL,44441385044,694396641,10849947,13.8),(141993,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141993,37.52,0.74,319,68615,70,NULL,NULL,'2MASX J17500047-5452378',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,267.502,-54.87725,0.541,NULL,44328781041,692637203,10822456,15.8),(141994,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141994,34.22,0.45,69.9,68616,NULL,NULL,'K','NGC 6491',NULL,'2007A&A...465...71T',2007,1,1.2,'UZC has V = 6212 +- 53 km/sec.','G',0.000057,NULL,'14.53',0.5,'Sab','in a pair',NULL,NULL,NULL,1,267.502917,61.53178,0.149,NULL,57550350806,899224231,14050378,14.53),(141995,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141995,34.23,0.47,70.1,68616,NULL,NULL,'H','NGC 6491',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141996,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141996,34.31,0.46,72.9,68616,NULL,NULL,'J','NGC 6491',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141997,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141997,34.32,0.4,73.2,68616,NULL,NULL,'mean','NGC 6491',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141998,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141998,33.78,0.43,57.1,68617,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11001',NULL,'2014MNRAS.444..527S',2014,1,1.3,'HOLM 771B is a star.','G',0.000023,NULL,'14.39',0.5,'Sdm:',NULL,NULL,NULL,NULL,1,267.556833333,14.28756,0.357,NULL,55940587822,874071684,13657370,14.39),(141999,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141999,33.72,0.47,55.4,68618,NULL,NULL,'H','KUG 1748+144',NULL,'2007A&A...465...71T',2007,1,0.6,NULL,'G',0.000043,NULL,'14.7',0.2,'Sc',NULL,NULL,NULL,NULL,1,267.6204583,14.39447,0.345,NULL,55940688571,874073258,13657394,14.7),(142000,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142000,33.75,0.45,56.3,68618,NULL,NULL,'K','KUG 1748+144',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142001,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142001,33.83,0.4,58.3,68618,NULL,NULL,'mean','KUG 1748+144',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142002,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142002,33.84,0.46,58.7,68618,NULL,NULL,'J','KUG 1748+144',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142003,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142003,32.47,0.69,31.1,68619,100,NULL,'mid-IR','NGC 6467',NULL,'2013ApJ...771...88L',2013,1,2.6,'HOLM 772B does not exist (it is probably a plate defect).','G',0.000004,NULL,'13.5',1.7,'S','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,267.667333,17.53778,0.337,NULL,55912313210,873629893,13650467,13.5),(142004,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142004,33.26,0.43,44.9,68619,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6467',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142005,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142005,33.15,0.43,42.7,68620,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11003',NULL,'2014MNRAS.444..527S',2014,1,1.29,NULL,'G',0.00001,NULL,'15.40',0.17,'Sbc',NULL,NULL,NULL,NULL,1,267.674375,14.82175,0.301,NULL,55958387573,874349805,13661715,15.4),(142006,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142006,33.45,0.49,49,68620,75,NULL,'IR','UGC 11003',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142007,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142007,34.36,NULL,74.3,68620,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142008,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142008,34.36,NULL,74.6,68620,NULL,NULL,'Dipole + Quadrupole','UGC 11003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142009,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142009,34.38,NULL,75,68620,NULL,NULL,'Dipole','UGC 11003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142010,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142010,34.41,NULL,76.4,68620,NULL,NULL,NULL,'UGC 11003',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142011,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142011,36.34,0.57,185,68621,70,NULL,NULL,'2MASX J17505621-6922590',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,267.734375,-69.383,0.173,NULL,44094645427,688978834,10765294,15.7),(142012,'BL Lac Luminosity','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142012,41.49,NULL,1510,68622,NULL,NULL,NULL,'[HB89] 1749+096',0.322,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',NULL,NULL,'16.78',NULL,'Opt.var.;HPQ   BLLAC',NULL,NULL,'radio jet','Flat-Spectrum Radio Source',1,267.88675,9.65019,0.613,NULL,56071913016,876123640,13689431,16.78),(142013,'Sosies','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142013,33.98,0.79,62.5,68623,NULL,NULL,NULL,'NGC 6484',NULL,'2002A&A...393...57T',2002,1,1.9,NULL,'G',0.00002,NULL,'13.11',1.9,'SBbc','in a triple',NULL,NULL,NULL,1,267.94575,24.48347,0.353,NULL,56253155324,878955551,13733680,13.11),(142014,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142014,33.48,0.43,49.6,68623,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6484',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142015,'Faber-Jackson','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142015,34.61,1.31,83.6,68624,95,NULL,'Weighted Mean','NGC 6482',NULL,'1984ApJS...56...91D',1984,1,2,NULL,'G',0.000058,NULL,'12.35',1.7,'E:             LINER','in a pair',NULL,NULL,NULL,1,267.953375,23.07194,0.425,NULL,56239785792,878746653,13730416,12.35),(142016,'Faber-Jackson','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142016,36.67,1.61,216,68624,55,NULL,'Visvanathan & Sandage 1979','NGC 6482',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142017,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142017,33.8,0.45,57.6,68624,NULL,NULL,'K','NGC 6482',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142018,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142018,33.83,0.4,58.4,68624,NULL,NULL,'mean','NGC 6482',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142019,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142019,34.45,0.47,77.8,68625,NULL,NULL,'H','IC 1269',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.00002,NULL,'13.40',1.3,'SA(sr)c pec I','Isolated galaxy',NULL,NULL,NULL,1,268.025,21.56964,0.533,NULL,56777671405,887151115,13861736,13.4),(142020,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142020,34.59,0.46,82.8,68625,NULL,NULL,'J','IC 1269',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142021,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142021,34.64,0.45,84.9,68625,NULL,NULL,'K','IC 1269',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142022,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142022,34.69,0.4,86.8,68625,NULL,NULL,'mean','IC 1269',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142023,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142023,34.48,0.2,78.7,68626,74.4,NULL,NULL,'UGC 11016',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',NULL,NULL,'15.43',0.3,'Scd:',NULL,NULL,NULL,NULL,1,268.0279583,28.90528,0.253,NULL,56264843649,879138182,13736534,15.43),(142024,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142024,34.51,0.45,79.6,68626,NULL,NULL,NULL,'UGC 11016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142025,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142025,34.52,0.45,80.2,68626,NULL,NULL,'Malmquist cor.','UGC 11016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142026,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142026,36.19,0.92,173,68627,70,NULL,NULL,'2MFGC 14085',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,268.046333333,-80.62172,0.557,NULL,44042788556,688168571,10752633,16.8),(142027,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142027,36.41,0.56,191,68628,70,NULL,NULL,'2MASX J17522165-6529472',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,268.0902083,-65.49647,0.261,NULL,44427549858,694180466,10846569,15),(142028,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142028,34.45,0.4,77.5,68629,NULL,NULL,'mean','UGC 11021',NULL,'2007A&A...465...71T',2007,1,1.46,NULL,'G',0.000012,NULL,'15.74',0.19,'Sb',NULL,NULL,NULL,NULL,1,268.1644583,29.059,0.273,NULL,56265278905,879144982,13736640,15.74),(142029,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142029,34.5,0.43,79.4,68629,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11021',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142030,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142030,34.69,0.43,86.7,68629,75,NULL,'3.6 micron, color corrected','UGC 11021',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142031,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142031,34.71,0.47,87.6,68629,NULL,NULL,'H','UGC 11021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142032,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142032,34.75,0.45,89.3,68629,NULL,NULL,'K','UGC 11021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142033,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142033,34.8,0.49,91.3,68629,75,NULL,'IR','UGC 11021',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142034,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142034,34.9,0.39,95.7,68629,NULL,NULL,'Malmquist cor.','UGC 11021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142035,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142035,34.96,0.2,98.2,68629,74.4,NULL,NULL,'UGC 11021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142036,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142036,35.01,NULL,101,68629,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11021',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142037,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142037,35.03,NULL,101,68629,NULL,NULL,'Dipole','UGC 11021',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142038,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142038,35.03,NULL,101,68629,NULL,NULL,'Dipole + Quadrupole','UGC 11021',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142039,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142039,35.06,0.36,103,68629,NULL,NULL,NULL,'UGC 11021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142040,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142040,35.08,NULL,104,68629,NULL,NULL,NULL,'UGC 11021',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142041,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142041,35.36,0.4,118,68630,NULL,NULL,'mean','NGC 6487',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.00009,NULL,'12.9',1.7,'E','Group member',NULL,NULL,NULL,1,268.174375,29.83864,0.249,NULL,56270274141,879223033,13737859,12.9),(142042,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142042,35.43,0.45,122,68630,NULL,NULL,'K','NGC 6487',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142043,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142043,36.58,0.69,207,68631,70,NULL,NULL,'2MASX J17525261-6523492',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,268.21925,-65.39708,0.261,NULL,44428038806,694188106,10846689,15.8),(142044,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142044,33.58,0.49,51.9,68632,75,NULL,'IR','UGC 11024',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.000193,NULL,'15.0',0.35,'S?',NULL,NULL,NULL,NULL,1,268.2270417,23.21106,0.485,NULL,56239718283,878745598,13730399,15),(142045,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142045,36.7,0.56,219,68633,70,NULL,NULL,'2MASX J17525463-7141414',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,268.227333333,-71.69481,0.381,NULL,44102656148,689104002,10767250,15),(142046,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142046,33.84,0.2,58.6,68634,74.4,NULL,NULL,'UGC 11036',NULL,'2013AJ....146...86T',2013,1,1.79,'Multiple SDSS entries describe this object.','G',0.000023,NULL,'16.5',0.1,'Sd',NULL,NULL,NULL,NULL,1,268.403167,58.35017,0.165,NULL,57547240403,899175631,14049619,16.5),(142047,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142047,33.92,NULL,60.9,68634,NULL,NULL,NULL,'UGC 11036',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142048,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142048,34.11,NULL,66.5,68634,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11036',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142049,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142049,34.13,NULL,66.8,68634,NULL,NULL,'Dipole','UGC 11036',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142050,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142050,34.13,NULL,66.9,68634,NULL,NULL,'Dipole + Quadrupole','UGC 11036',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142051,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142051,34.39,0.49,75.4,68634,75,NULL,'IR','UGC 11036',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142052,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142052,31.52,NULL,20.1,68635,72,NULL,NULL,'UGC 11030',NULL,'2014Ap.....57..457K',2014,1,1.7,NULL,'G',0.000013,NULL,'14.3',0.4,'Sc:',NULL,NULL,NULL,NULL,1,268.639833333,2.87919,0.845,NULL,55841916581,872529946,13633280,14.3),(142053,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142053,32.22,0.4,27.8,68635,75,NULL,NULL,'UGC 11030',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142054,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142054,32.37,0.49,29.9,68635,75,NULL,'IR','UGC 11030',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142055,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142055,36.33,0.82,185,68636,70,NULL,NULL,'2MASX J17544249-6911080',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,268.6769583,-69.18564,0.273,NULL,44094155853,688971185,10765174,17.1),(142056,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142056,34.77,0.25,90,68637,74.4,NULL,NULL,'NGC 6512',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.00007,NULL,'14.9',0.25,'E/S0','Group member',NULL,NULL,NULL,1,268.709625,62.64508,0.177,NULL,57521586601,898774790,14043356,14.9),(142057,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142057,34.96,0.32,98.1,68637,70,NULL,NULL,'NGC 6512',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142058,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142058,35.25,0.4,112,68637,NULL,NULL,'mean','NGC 6512',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142059,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142059,35.43,0.45,122,68637,NULL,NULL,'K','NGC 6512',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142060,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 1998bp',NULL,142060,32.93,0.09,38.6,68638,74.4,NULL,NULL,'NGC 6495',NULL,'2013AJ....146...86T',2013,1,2,NULL,'G',0.00006,NULL,'13.16',1.8,'E','Group member',NULL,NULL,NULL,1,268.7115,18.32692,0.369,NULL,55913258270,873644660,13650697,13.16),(142061,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 1998bp',NULL,142061,33.1,0.05,41.2,68638,72,NULL,NULL,'NGC 6495',0.01043,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142062,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 1998bp',NULL,142062,33.17,0.2,42.6,68638,72,NULL,NULL,'NGC 6495',0.01043,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142063,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 1998bp',NULL,142063,33.18,0.29,42.7,68638,65,NULL,'MLCS17','NGC 6495',0.01043,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142064,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 1998bp',NULL,142064,33.21,0.32,43.2,68638,65,NULL,NULL,'NGC 6495',0.01043,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142065,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 1998bp',NULL,142065,33.27,0.29,44.6,68638,65,NULL,'MLCS31','NGC 6495',0.01043,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142066,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 1998bp',NULL,142066,33.3,0.08,44.9,68638,65,NULL,'MLCS2k2','NGC 6495',0.01043,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142067,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 1998bp',NULL,142067,33.36,0.26,46.6,68638,70,NULL,'SALT 2','NGC 6495',0.01043,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142068,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 1998bp',NULL,142068,33.45,0.23,48.5,68638,73.8,NULL,'SALT 2 (SNANA)','NGC 6495',0.0106,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142069,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 1998bp',NULL,142069,33.51,0.34,49.8,68638,70,NULL,'SALT','NGC 6495',0.01043,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142070,'SBF','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142070,33.16,0.15,42.9,68638,NULL,NULL,'I','NGC 6495',NULL,'2001ApJ...559..584A',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142071,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142071,33.44,0.69,48.8,68639,100,NULL,'mid-IR','UGC 11041',NULL,'2013ApJ...771...88L',2013,1,1.1,NULL,'G',0.000067,NULL,'14.1',0.7,'Sab        HII;LIRG',NULL,NULL,NULL,NULL,1,268.715917,34.77622,0.157,NULL,56140724692,877198823,13706231,14.1),(142072,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142072,34.06,0.43,64.8,68639,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11041',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142073,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142073,34.34,0.43,73.8,68639,75,NULL,'3.6 micron, color corrected','UGC 11041',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142074,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142074,34.35,0.4,74.2,68639,NULL,NULL,'mean','UGC 11041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142075,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142075,34.41,0.45,76.3,68639,NULL,NULL,'K','UGC 11041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142076,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142076,34.5,0.47,79.4,68639,NULL,NULL,'H','UGC 11041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142077,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142077,34.61,0.46,83.5,68639,NULL,NULL,'J','UGC 11041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142078,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142078,34.7,0.2,87.1,68639,74.4,NULL,NULL,'UGC 11041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142079,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142079,35.97,0.51,157,68640,70,NULL,NULL,'2MASX J17550541-6905592',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,268.7724583,-69.09972,0.297,NULL,44094179987,688971562,10765180,14.7),(142080,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142080,34.64,0.49,84.9,68641,75,NULL,'IR','ESO 181- G 007',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000033,NULL,'13.90',0.2,'Sbc',NULL,NULL,NULL,NULL,1,268.818791667,-55.90314,0.425,NULL,44326318823,692598731,10821855,13.9),(142081,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142081,34.8,0.58,91,68641,NULL,NULL,'Malmquist cor.','ESO 181- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142082,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142082,35.04,0.52,102,68641,NULL,NULL,NULL,'ESO 181- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142083,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142083,35.08,0.2,104,68641,74.4,NULL,NULL,'ESO 181- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142084,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142084,34.76,0.25,89.5,68642,74.4,NULL,NULL,'GIN 647',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.00006,NULL,'15.20',NULL,'S',NULL,NULL,NULL,NULL,1,268.845625,62.65828,0.177,NULL,57521677028,898776203,14043378,15.2),(142085,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142085,34.96,0.32,98.1,68642,70,NULL,NULL,'GIN 647',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142086,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142086,34.14,0.49,67.4,68643,75,NULL,'IR','UGC 11050',NULL,'2011yCatp016004901K',2011,1,1.57,NULL,'G',NULL,NULL,'15.57',0.22,'Sbc',NULL,NULL,NULL,NULL,1,268.929917,34.58656,0.205,NULL,56140053287,877188332,13706067,15.57),(142087,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142087,34.22,0.2,69.8,68643,74.4,NULL,NULL,'UGC 11050',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142088,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142088,34.22,NULL,69.9,68643,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11050',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142089,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142089,34.23,NULL,70.2,68643,NULL,NULL,'Dipole','UGC 11050',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142090,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142090,34.23,NULL,70.3,68643,NULL,NULL,'Dipole + Quadrupole','UGC 11050',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142091,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142091,34.24,0.43,70.4,68643,75,NULL,'3.6 micron, color corrected','UGC 11050',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142092,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142092,34.32,0.43,73,68643,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11050',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142093,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142093,34.33,0.45,73.5,68643,NULL,NULL,NULL,'UGC 11050',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142094,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142094,34.45,0.42,77.6,68643,NULL,NULL,'Malmquist cor.','UGC 11050',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142095,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142095,34.77,0.25,90,68644,74.4,NULL,NULL,'NGC 6521',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.000077,NULL,'13.95',1.3,'cD;E;LINER     Sy1.9','Group member',NULL,NULL,'Flat-Spectrum Radio Source',1,268.951833333,62.61225,0.177,NULL,57521678231,898776222,14043378,13.95),(142096,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142096,34.96,0.32,98.1,68644,70,NULL,NULL,'NGC 6521',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142097,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142097,34.68,0.45,86.2,68644,NULL,NULL,'K','NGC 6521',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142098,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142098,35.24,0.4,112,68644,NULL,NULL,'mean','NGC 6521',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142099,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142099,36.52,0.47,202,68645,NULL,NULL,'Malmquist cor.','2MASX J17555279+6903017',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000023,NULL,'15.51',NULL,'Sc',NULL,NULL,NULL,NULL,1,268.969917,69.05044,0.165,NULL,57046421701,891350339,13927349,15.51),(142100,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142100,36.71,0.43,220,68645,NULL,NULL,NULL,'2MASX J17555279+6903017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142101,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142101,36.75,0.2,224,68645,74.4,NULL,NULL,'2MASX J17555279+6903017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142102,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142102,33.61,0.4,52.7,68646,NULL,NULL,'mean','NGC 6500',NULL,'2007A&A...465...71T',2007,1,2.2,NULL,'G',0.000017,NULL,'13.05',1.6,'SAab:          LINER','Pair member (points to parent)',NULL,NULL,'Flat-Spectrum Radio Source',1,268.999083,18.33825,0.369,NULL,55911487858,873616997,13650265,13.05),(142103,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142103,34.12,0.47,66.8,68646,NULL,NULL,'H','NGC 6500',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142104,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142104,34.14,0.46,67.4,68646,NULL,NULL,'J','NGC 6500',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142105,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142105,34.16,0.45,67.8,68646,NULL,NULL,'K','NGC 6500',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142106,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142106,33.5,0.4,50.1,68647,NULL,NULL,'mean','NGC 6501',NULL,'2007A&A...465...71T',2007,1,2,NULL,'G',0.000037,NULL,'13.03',1.8,'SA0+:','Pair member (points to parent)',NULL,NULL,NULL,1,269.015583,18.37308,0.389,NULL,55911486740,873616980,13650265,13.03),(142107,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142107,33.8,0.45,57.5,68647,NULL,NULL,'K','NGC 6501',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142108,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142108,37.34,0.85,293,68648,NULL,NULL,'Malmquist cor.','AGC 270370',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000033,NULL,'16.85',NULL,'Sc',NULL,NULL,NULL,NULL,1,269.0675417,69.04986,0.165,NULL,57046254540,891347727,13927308,16.85),(142109,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142109,37.63,0.74,336,68648,NULL,NULL,NULL,'AGC 270370',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142110,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142110,37.68,0.2,344,68648,74.4,NULL,NULL,'AGC 270370',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142111,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142111,34.6,0.54,83.2,68649,70,NULL,NULL,'2MASX J17562452-5755125',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,269.10225,-57.92017,0.377,NULL,44446475324,694476176,10851190,14.5),(142112,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142112,34.31,0.4,72.8,68650,NULL,NULL,'mean','UGC 11058',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000017,NULL,'13.29',1.1,'SB(s)b','Isolated galaxy',NULL,NULL,NULL,1,269.2292917,32.63661,0.205,NULL,56254851286,878982051,13734094,13.29),(142113,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142113,34.35,0.47,74.3,68650,NULL,NULL,'H','UGC 11058',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142114,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142114,34.45,0.45,77.6,68650,NULL,NULL,'K','UGC 11058',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142115,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142115,34.47,0.46,78.4,68650,NULL,NULL,'J','UGC 11058',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142116,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142116,32.93,0.43,38.5,68651,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11055',NULL,'2014MNRAS.444..527S',2014,1,0.9,NULL,'G',0.000067,NULL,'14.37',0.7,'SB?;HSB','Pair member (points to parent)',NULL,NULL,NULL,1,269.269583,12.23983,0.573,NULL,55939078204,874048096,13657001,14.37),(142117,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142117,33.14,0.4,42.6,68651,NULL,NULL,'mean','UGC 11055',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142118,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142118,33.43,0.47,48.5,68651,NULL,NULL,'H','UGC 11055',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142119,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142119,33.52,0.45,50.5,68651,NULL,NULL,'K','UGC 11055',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142120,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142120,33.54,0.46,51.2,68651,NULL,NULL,'J','UGC 11055',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142121,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142121,34.08,0.43,65.6,68652,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11060',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.000097,NULL,'14.89',0.4,'Sa',NULL,NULL,NULL,NULL,1,269.294333333,27.96139,0.257,NULL,56296158749,879627480,13744179,14.89),(142122,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142122,34.14,0.43,67.3,68652,75,NULL,'3.6 micron, color corrected','UGC 11060',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142123,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142123,34.29,0.2,72.1,68652,74.4,NULL,NULL,'UGC 11060',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142124,'BL Lac Luminosity','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142124,41.7,NULL,1560,68653,NULL,NULL,NULL,'NEP 3580',0.407,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.003,NULL,'18.27',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,269.304167,70.56044,0.157,NULL,57048865301,891388520,13927945,18.27),(142125,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142125,31.85,0.2,23.4,68654,74.4,NULL,NULL,'UGC 11057',NULL,'2013AJ....146...86T',2013,1,2,NULL,'G',0.00001,NULL,'13.56',0.8,'Scd:','Pair member (points to parent)',NULL,NULL,NULL,1,269.3122083,12.17947,0.613,NULL,55939093126,874048330,13657005,13.56),(142126,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142126,32.38,0.69,29.9,68654,100,NULL,'mid-IR','UGC 11057',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142127,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142127,32.68,0.46,34.4,68654,NULL,NULL,'J','UGC 11057',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142128,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142128,32.72,0.47,35.1,68654,NULL,NULL,'H','UGC 11057',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142129,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142129,32.76,0.45,35.6,68654,NULL,NULL,'K','UGC 11057',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142130,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142130,33.02,0.4,40.2,68654,NULL,NULL,'mean','UGC 11057',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142131,'GRB','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142131,47.58,1.54,12600,68655,NULL,NULL,NULL,'GRB 090418A',1.608,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,269.3132083,33.40592,0.209,NULL,56321307659,880020432,13750319,NULL),(142132,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142132,32.84,NULL,37,68656,NULL,NULL,NULL,'UGC 11059',NULL,'2000BSAO...50....5K',2000,1,1.34,NULL,'G',0.000013,NULL,'15.7',0.19,'Sb',NULL,NULL,NULL,NULL,1,269.380833,11.73253,0.613,NULL,55936263297,874004114,13656314,15.7),(142133,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142133,32.96,NULL,39.2,68656,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11059',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142134,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142134,32.98,NULL,39.5,68656,NULL,NULL,'Dipole + Quadrupole','UGC 11059',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142135,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142135,32.99,NULL,39.6,68656,NULL,NULL,'Dipole','UGC 11059',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142136,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142136,35.53,0.6,128,68657,70,NULL,NULL,'2MASX J17573784-8111006',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,269.407625,-81.18344,0.593,NULL,44042397114,688162454,10752538,16.7),(142137,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142137,34.35,0.23,72.4,68658,74.2,NULL,'SALT 2','UGC 11064',0.02349,'2010ApJ...716..712A',2010,1,1.9,NULL,'G',0.000033,NULL,'13.6',1.9,'Scd:',NULL,NULL,NULL,NULL,1,269.420916667,27.83472,0.257,NULL,56296102712,879626604,13744165,13.6),(142138,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142138,34.91,0.22,93.7,68658,72,NULL,NULL,'UGC 11064',0.02349,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142139,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142139,34.89,0.08,95.1,68658,74.4,NULL,NULL,'UGC 11064',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142140,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142140,35.02,0.04,98.7,68658,72,NULL,NULL,'UGC 11064',0.02349,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142141,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142141,34.98,0.17,99.1,68658,70.8,NULL,NULL,'UGC 11064',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142142,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142142,35.05,0.17,99.8,68658,73.8,NULL,'SALT 2 (SNANA)','UGC 11064',0.0236,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142143,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142143,35.06,0.17,100,68658,65,NULL,'MLCS17','UGC 11064',0.02349,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142144,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142144,35.06,0.17,100,68658,70,NULL,'SALT 2','UGC 11064',0.02349,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142145,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142145,35.08,0.11,101,68658,65,NULL,'SALT2','UGC 11064',0.02349,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142146,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142146,35.1,0.17,102,68658,65,NULL,'MLCS31','UGC 11064',0.02349,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142147,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142147,35.15,0.09,103,68658,65,NULL,'MLCS2k2','UGC 11064',0.02349,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142148,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142148,35.12,0.09,103,68658,65,NULL,'MLCS2k2','UGC 11064',0.02349,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142149,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142149,35.12,0.28,103,68658,70,NULL,'SALT','UGC 11064',0.02349,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142150,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142150,35.14,0.21,104,68658,65,NULL,NULL,'UGC 11064',0.02349,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142151,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142151,35.15,0.05,105,68658,65,NULL,'MLCS2k2','UGC 11064',0.02349,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142152,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142152,35.15,0.09,105,68658,70,NULL,NULL,'UGC 11064',0.02349,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142153,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142153,35.22,0.29,108,68658,65,NULL,'SALT','UGC 11064',0.02349,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142154,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142154,35.28,0.21,111,68658,65,NULL,'SALT2','UGC 11064',0.02349,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142155,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142155,35.44,0.01,119,68658,65,NULL,'SALT','UGC 11064',0.02349,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142156,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142156,35.66,0.14,136,68658,60,NULL,NULL,'UGC 11064',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142157,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142157,36.47,0.03,192,68658,70,NULL,'SALT 2','UGC 11064',0.02349,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142158,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142158,35.42,0.68,122,68659,70,NULL,NULL,'2MASX J17574806-6255575',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,269.4502917,-62.93258,0.305,NULL,44430993761,694234277,10847410,14.8),(142159,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142159,37.19,0.58,274,68660,NULL,NULL,'Malmquist cor.','2MASX J17580251+6904262',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000023,NULL,'15.92',NULL,'Sb',NULL,NULL,NULL,NULL,1,269.510541667,69.07397,0.185,NULL,57044160571,891315008,13926797,15.92),(142160,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142160,37.39,0.52,301,68660,NULL,NULL,NULL,'2MASX J17580251+6904262',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142161,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142161,37.44,0.2,308,68660,74.4,NULL,NULL,'2MASX J17580251+6904262',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142162,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142162,36.43,0.8,193,68661,NULL,NULL,'Malmquist cor.','CGCG 340-028',NULL,'2009ApJS..182..474S',2009,1,0.42,NULL,'G',0.000023,NULL,'15.4',0.2,'Irregular',NULL,NULL,NULL,NULL,1,269.512333,69.2915,0.173,NULL,57044348199,891317940,13926842,15.4),(142163,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142163,36.98,0.62,249,68661,NULL,NULL,NULL,'CGCG 340-028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142164,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142164,37.02,0.2,254,68661,74.4,NULL,NULL,'CGCG 340-028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142165,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142165,37.11,0.18,265,68661,70,NULL,'ABELL 2295b, BGC','CGCG 340-028',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142166,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142166,36.28,0.59,181,68662,70,NULL,NULL,'2MASX J17580320-5202355',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,269.513375,-52.04325,0.601,NULL,44333036487,692703695,10823495,17.7),(142167,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142167,36.18,0.2,172,68663,74.4,NULL,NULL,'CGCG 340-029',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'GPair',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,269.572917,69.60667,0.157,NULL,57044443605,891319431,13926866,NULL),(142168,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142168,35.76,0.73,142,68664,NULL,NULL,'Malmquist cor.','CGCG 340-029 NED02',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',NULL,NULL,'13.6I',NULL,NULL,NULL,NULL,NULL,NULL,1,269.591625,69.61136,0.157,NULL,57044446765,891319480,13926866,13.6),(142169,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142169,36.14,0.61,169,68664,NULL,NULL,NULL,'CGCG 340-029 NED02',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142170,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142170,37.11,0.18,265,68665,70,NULL,NULL,'ABELL 2295b',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',0.000274,NULL,NULL,NULL,'Medium compact [Zw]',NULL,NULL,NULL,NULL,1,269.6555,69.26522,0.173,NULL,57044346858,891317919,13926842,NULL),(142171,'D-Sigma','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142171,33.77,0.4,56.8,68666,75,NULL,'Edat, raw','ESO 139- G 045',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00015,NULL,'14.00',0.7,'SB(s)0^0^',NULL,NULL,NULL,NULL,1,269.6647917,-58.37161,0.381,NULL,44445867619,694466681,10851041,14),(142172,'D-Sigma','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142172,34.12,0.4,66.7,68666,75,NULL,'Edat, cor','ESO 139- G 045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142173,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142173,33.98,0.53,62.5,68666,70,NULL,NULL,'ESO 139- G 045',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142174,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142174,34.09,0.4,65.6,68666,NULL,NULL,'mean','ESO 139- G 045',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142175,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142175,34.54,0.45,81,68666,NULL,NULL,'K','ESO 139- G 045',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142176,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142176,37.24,0.61,280,68667,NULL,NULL,'Malmquist cor.','AGC 270378',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000023,NULL,'16.48',NULL,'Sc',NULL,NULL,NULL,NULL,1,269.705,69.09461,0.173,NULL,57044168895,891315138,13926799,16.48),(142177,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142177,37.45,0.56,309,68667,NULL,NULL,NULL,'AGC 270378',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142178,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142178,37.49,0.2,315,68667,74.4,NULL,NULL,'AGC 270378',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142179,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142179,35.04,0.8,102,68668,75,NULL,'CF, r','UGC 11076',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000113,NULL,'14.73',0.5,'Sbc',NULL,NULL,NULL,NULL,1,269.715708333,34.00592,0.241,NULL,56136813793,877137715,13705276,14.73),(142180,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142180,34.95,0.38,97.7,68668,75,NULL,'CF, r, raw','UGC 11076',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142181,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142181,35.1,0.38,105,68668,75,NULL,'CF, r, cor','UGC 11076',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142182,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142182,35.15,0.38,107,68668,75,NULL,'CF, r, inv','UGC 11076',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142183,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142183,35.18,0.4,109,68668,NULL,NULL,'mean','UGC 11076',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142184,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142184,35.35,0.47,117,68668,NULL,NULL,'H','UGC 11076',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142185,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142185,35.39,0.46,119,68668,NULL,NULL,'J','UGC 11076',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142186,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142186,35.43,0.45,122,68668,NULL,NULL,'K','UGC 11076',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142187,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142187,34.12,0.69,66.6,68669,100,NULL,'mid-IR','UGC 11073',NULL,'2013ApJ...771...88L',2013,1,1.2,NULL,'G',0.000033,NULL,'14.4',0.7,'Sbc',NULL,NULL,NULL,NULL,1,269.747333,10.53914,0.581,NULL,55852230504,872691101,13635798,14.4),(142188,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142188,34.65,0.2,85.1,68669,74.4,NULL,NULL,'UGC 11073',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142189,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142189,34.67,0.37,86.1,68669,NULL,NULL,'Malmquist cor.','UGC 11073',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142190,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142190,34.71,0.4,87.4,68669,NULL,NULL,'mean','UGC 11073',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142191,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142191,34.72,0.36,87.8,68669,NULL,NULL,NULL,'UGC 11073',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142192,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142192,34.96,0.47,98.2,68669,NULL,NULL,'H','UGC 11073',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142193,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142193,37.99,0.51,396,68670,NULL,NULL,'Malmquist cor.','AGC 270379',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000023,NULL,'16.75',NULL,'Sc',NULL,NULL,NULL,NULL,1,269.751667,69.02844,0.185,NULL,57044121095,891314392,13926787,16.75),(142194,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142194,38.01,0.51,400,68670,NULL,NULL,NULL,'AGC 270379',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142195,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142195,38.05,0.2,407,68670,74.4,NULL,NULL,'AGC 270379',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142196,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142196,35.68,0.5,137,68671,70,NULL,NULL,'2MASX J17590736-6519572',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,269.78075,-65.33258,0.265,NULL,44427261453,694175960,10846499,14.7),(142197,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142197,32.05,0.4,25.7,68672,NULL,NULL,NULL,'UGC 11074',NULL,'2009AJ....138..323T',2009,1,2.3,NULL,'G',0.000007,NULL,'13.9',1.1,'Sd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,269.780833,7.14139,0.817,NULL,55861357706,872833714,13638026,13.9),(142198,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142198,32.05,NULL,25.7,68672,72,NULL,NULL,'UGC 11074',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142199,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142199,32.33,0.4,29.3,68672,75,NULL,'B','UGC 11074',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142200,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142200,34.07,0.12,65.3,68673,NULL,NULL,NULL,'ESO 071- G 001',NULL,'2009ApJS..182..474S',2009,1,2.1,NULL,'G',0.000033,NULL,'16.56',1.1,'Sb: sp',NULL,NULL,NULL,NULL,1,269.7935,-67.93811,0.425,NULL,44090685590,688916962,10764327,16.56),(142201,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142201,34.79,0.49,90.9,68673,75,NULL,'IR','ESO 071- G 001',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142202,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142202,36.08,0.25,164,68674,74.4,NULL,NULL,'GIN 651',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000237,NULL,'15.58',NULL,'S',NULL,NULL,NULL,NULL,1,269.798,42.59153,0.093,NULL,56105214724,876643980,13697562,15.58),(142203,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142203,36.24,0.31,177,68674,70,NULL,NULL,'GIN 651',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142204,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142204,34.37,0.8,74.7,68675,75,NULL,'CF, r','NGC 6532',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.00003,NULL,'14.60',0.9,'SAc',NULL,NULL,NULL,NULL,1,269.808125,56.23178,0.105,NULL,57680077865,901251216,14082050,14.6),(142205,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142205,34.02,0.38,63.6,68675,75,NULL,'CF, r, raw','NGC 6532',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142206,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142206,34.12,0.38,66.8,68675,75,NULL,'CF, r, inv','NGC 6532',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142207,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142207,34.25,0.2,70.8,68675,74.4,NULL,NULL,'NGC 6532',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142208,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142208,34.29,0.38,72.1,68675,75,NULL,'CF, r, cor','NGC 6532',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142209,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142209,34.38,0.44,75.3,68675,NULL,NULL,NULL,'NGC 6532',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142210,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142210,34.41,0.44,76.1,68675,NULL,NULL,'Malmquist cor.','NGC 6532',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142211,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142211,32.53,0.8,32.1,68676,75,NULL,'MAT, I','ESO 139- G 046',NULL,'1997ApJS..109..333W',1997,1,1.7,'Confused HIPASS source','G',0.000023,NULL,'15.00',0.3,'SB(s)cd: sp',NULL,NULL,NULL,NULL,1,269.820416667,-59.50731,0.349,NULL,44452445070,694569454,10852647,15),(142212,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142212,31.96,0.32,24.7,68676,85,NULL,'I, inv','ESO 139- G 046',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142213,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142213,31.99,0.32,25,68676,85,NULL,'I, raw','ESO 139- G 046',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142214,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142214,32.1,0.4,26.3,68676,NULL,NULL,NULL,'ESO 139- G 046',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142215,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142215,32.1,0.4,26.3,68676,73,NULL,'opt','ESO 139- G 046',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142216,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142216,32.33,0.43,29.3,68676,75,NULL,'MAT, I, inv','ESO 139- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142217,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142217,32.37,0.43,29.7,68676,75,NULL,'MAT, I, raw','ESO 139- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142218,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142218,32.74,0.43,35.3,68676,75,NULL,'MAT, I, cor','ESO 139- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142219,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142219,33.55,0.49,51.3,68677,75,NULL,'IR','ESO 102- G 019',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000033,NULL,'15.77',0.2,'Scd: sp',NULL,NULL,NULL,NULL,1,269.8475,-63.45833,0.309,NULL,44432676527,694260570,10847821,15.77),(142220,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142220,34.24,0.13,70.6,68677,NULL,NULL,NULL,'ESO 102- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142221,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142221,32.25,0.4,28.2,68678,75,NULL,'B','NGC 6509',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.000001,NULL,'13.1',1.2,'SBcd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,269.8552917,6.28703,0.737,NULL,55860665489,872822898,13637857,13.1),(142222,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142222,32.7,NULL,34.6,68678,72,NULL,NULL,'NGC 6509',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142223,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142223,36.08,0.25,164,68679,74.4,NULL,NULL,'CGCG 227-009 NED01',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000067,NULL,'14.14',NULL,'E/S0',NULL,NULL,NULL,NULL,1,269.8757083,42.51528,0.093,NULL,56105339910,876645936,13697592,14.14),(142224,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142224,36.24,0.31,177,68679,70,NULL,NULL,'CGCG 227-009 NED01',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142225,'SBF','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142225,33.34,0.48,46.6,68680,NULL,NULL,NULL,'NGC 6483',NULL,'2001MNRAS.327.1004B',2001,1,1.5,NULL,'G',0.000067,NULL,'12.97',0.9,'E4','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,269.878375,-63.66872,0.309,NULL,44432836888,694263076,10847860,12.97),(142226,'SBF','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142226,33.77,0.48,56.8,68680,NULL,NULL,'Malmquist cor.','NGC 6483',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142227,'D-Sigma','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142227,33.07,0.4,41.1,68680,75,NULL,'Edat, raw','NGC 6483',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142228,'D-Sigma','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142228,33.4,0.4,47.9,68680,75,NULL,'Edat, cor','NGC 6483',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142229,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142229,33.8,0.41,57.5,68680,NULL,NULL,NULL,'NGC 6483',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142230,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142230,34.03,0.41,63.9,68680,NULL,NULL,'Malmquist cor.','NGC 6483',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142231,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142231,33.86,0.45,59.1,68680,NULL,NULL,'K','NGC 6483',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142232,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142232,33.98,0.4,62.6,68680,NULL,NULL,'mean','NGC 6483',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142233,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142233,38.08,0.48,413,68681,NULL,NULL,'Malmquist cor.','2MASX J17594494+6911252',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000033,NULL,'15.83',NULL,'Sbc:',NULL,NULL,NULL,NULL,1,269.937333,69.19039,0.173,NULL,57044137024,891314641,13926791,15.83),(142234,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142234,38.11,0.47,418,68681,NULL,NULL,NULL,'2MASX J17594494+6911252',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142235,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142235,38.15,0.2,427,68681,74.4,NULL,NULL,'2MASX J17594494+6911252',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142236,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142236,37.65,0.13,339,68682,70,NULL,NULL,'ABELL 2295',NULL,'1999AJ....118.1489D',1999,1,NULL,'Struble and Rood (1987ApJS...63..543S) give z=0.0508.','GClstr',NULL,NULL,NULL,NULL,'II-III [BM]',NULL,NULL,NULL,NULL,1,269.982417,69.21681,0.173,NULL,57044127036,891314484,13926788,NULL),(142237,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142237,37.76,0.14,356,68682,NULL,NULL,'ABELL 2295 cluster, avg. of 10 spiral galaxies','ABELL 2295',NULL,'2003AJ....126..675D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142238,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142238,35.39,NULL,120,68683,NULL,NULL,'Dipole + Quadrupole','MCG +07-37-013',NULL,'2010Ap&SS.325..163P',2010,1,1.2,NULL,'G',0.000053,NULL,'15.5',0.15,'Sc',NULL,NULL,NULL,NULL,1,270.017416667,44.52733,0.137,NULL,54224066910,847251045,13238297,15.5),(142239,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142239,35.39,NULL,120,68683,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG +07-37-013',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142240,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142240,35.42,NULL,122,68683,NULL,NULL,NULL,'MCG +07-37-013',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142241,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142241,35.44,NULL,122,68683,NULL,NULL,'Dipole','MCG +07-37-013',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142242,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142242,36.2,0.49,174,68683,75,NULL,'IR','MCG +07-37-013',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142243,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142243,36.5,0.53,200,68684,70,NULL,NULL,'2MASX J18002107-6952539',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00011,NULL,'15.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,270.087875,-69.88169,0.153,NULL,48453810029,757090781,11829543,15.3),(142244,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142244,35.11,0.54,105,68685,70,NULL,NULL,'2MASX J18002405-6801258',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,270.100125,-68.02383,0.425,NULL,48452702501,757073476,11829273,14.9),(142245,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142245,33.85,0.4,59,68686,NULL,NULL,'mean','2MFGC 14160',NULL,'2007A&A...465...71T',2007,1,0.5,NULL,'G',0.000043,NULL,'17.62',0.1,'S+S            LIRG',NULL,NULL,NULL,NULL,1,270.132917,-4.01481,NULL,NULL,47251254372,738300849,11535950,17.62),(142246,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142246,33.88,0.47,59.7,68686,NULL,NULL,'H','2MFGC 14160',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142247,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142247,33.9,0.45,60.4,68686,NULL,NULL,'K','2MFGC 14160',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142248,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142248,32.48,0.8,31.3,68687,75,NULL,'MAT, I','ESO 139- G 049',NULL,'1997ApJS..109..333W',1997,1,2.3,'Confused HIPASS source','G',0.000025,NULL,'13.90',0.7,'SB(s)cd: pec',NULL,NULL,NULL,NULL,1,270.145833,-59.1365,0.349,NULL,48962209927,765034530,11953664,13.9),(142249,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142249,32.22,0.32,27.8,68687,85,NULL,'I, raw','ESO 139- G 049',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142250,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142250,32.24,0.32,28,68687,85,NULL,'I, inv','ESO 139- G 049',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142251,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142251,32.28,0.4,28.6,68687,NULL,NULL,NULL,'ESO 139- G 049',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142252,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142252,32.35,0.43,29.5,68687,75,NULL,'MAT, I, raw','ESO 139- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142253,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142253,32.45,0.43,30.9,68687,75,NULL,'MAT, I, inv','ESO 139- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142254,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142254,32.58,0.49,32.7,68687,75,NULL,'IR','ESO 139- G 049',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142255,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142255,32.72,0.43,35,68687,75,NULL,'MAT, I, cor','ESO 139- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142256,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142256,33.34,0.69,46.5,68688,100,NULL,'mid-IR','UGC 11090',NULL,'2013ApJ...771...88L',2013,1,1.3,NULL,'G',0.000006,NULL,'14.34',0.9,'Scd:',NULL,NULL,NULL,NULL,1,270.18,28.71186,0.237,NULL,54329676518,848901195,13264081,14.34),(142257,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142257,33.5,0.48,50.2,68688,NULL,NULL,NULL,'UGC 11090',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142258,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142258,33.55,0.2,51.3,68688,74.4,NULL,NULL,'UGC 11090',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142259,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142259,33.74,0.43,56.1,68688,NULL,NULL,'Malmquist cor.','UGC 11090',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142260,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142260,34.93,0.38,96.8,68689,NULL,NULL,'Malmquist cor.','UGC 11091',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.40',0.6,'Scd:','Isolated galaxy',NULL,NULL,NULL,1,270.182125,35.01367,0.241,NULL,54241272341,847519880,13242498,15.4),(142261,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142261,35.03,0.36,101,68689,NULL,NULL,NULL,'UGC 11091',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142262,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142262,35.05,0.2,102,68689,74.4,NULL,NULL,'UGC 11091',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142263,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142263,37.25,0.48,282,68690,NULL,NULL,'Malmquist cor.','2MASX J18004511+6919288',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000023,NULL,'14.91',NULL,'Sb',NULL,NULL,NULL,NULL,1,270.1880417,69.32478,0.173,NULL,52682966904,823171357,12862052,14.91),(142264,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142264,37.5,0.43,316,68690,NULL,NULL,NULL,'2MASX J18004511+6919288',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142265,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142265,37.54,0.2,322,68690,74.4,NULL,NULL,'2MASX J18004511+6919288',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142266,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142266,37.65,0.13,339,68690,70,NULL,'ABELL 2295, BGC','2MASX J18004511+6919288',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142267,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142267,37.66,0.58,340,68691,NULL,NULL,'Malmquist cor.','2MASX J18005650+6929399',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000023,NULL,'15.80',NULL,'Sbc',NULL,NULL,NULL,NULL,1,270.235583,69.49444,0.165,NULL,52683008859,823172013,12862062,15.8),(142268,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142268,37.79,0.54,362,68691,NULL,NULL,NULL,'2MASX J18005650+6929399',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142269,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142269,37.83,0.2,368,68691,74.4,NULL,NULL,'2MASX J18005650+6929399',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142270,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142270,36.37,0.63,188,68692,70,NULL,NULL,'ESO 229- G 004',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'14.9R',0.6,'S',NULL,NULL,NULL,NULL,1,270.258083333,-51.80142,0.601,NULL,48880722843,763761294,11933770,14.9),(142271,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142271,35.67,0.48,136,68693,70,NULL,NULL,'2MASX J18012872-6344515',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000117,NULL,'13.1R',0.9,'S0- pec?',NULL,NULL,NULL,NULL,1,270.369583,-63.74792,0.273,NULL,48932557507,764571211,11946425,13.1),(142272,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2001bf',NULL,142272,33.29,0.21,44.8,68694,74.2,NULL,'SALT 2','CGCG 141-044',0.015501,'2010ApJ...716..712A',2010,1,0.35,NULL,'G',0.000103,NULL,'14.8',0.25,NULL,NULL,NULL,NULL,NULL,1,270.3900417,26.25283,0.521,NULL,54301287285,848457613,13257150,14.8),(142273,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2001bf',NULL,142273,33.78,0.04,56.1,68694,72,NULL,'MLCS31','CGCG 141-044',0.015501,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142274,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2001bf',NULL,142274,33.79,0.04,56.4,68694,70,NULL,'SALT 2','CGCG 141-044',0.015501,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142275,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2001bf',NULL,142275,33.86,0.09,59.2,68694,74.4,NULL,NULL,'CGCG 141-044',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142276,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2001bf',NULL,142276,33.94,0.18,60.4,68694,73.8,NULL,'SALT 2 (SNANA)','CGCG 141-044',0.0155,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142277,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2001bf',NULL,142277,34.04,0.23,63.4,68694,65,NULL,'MLCS31','CGCG 141-044',0.015501,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142278,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2001bf',NULL,142278,34.06,0.22,63.8,68694,65,NULL,'MLCS17','CGCG 141-044',0.015501,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142279,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2001bf',NULL,142279,34.06,0.23,63.8,68694,65,NULL,'SALT','CGCG 141-044',0.015501,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142280,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2001bf',NULL,142280,34.17,0.24,67.3,68694,65,NULL,'SALT2','CGCG 141-044',0.015501,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142281,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142281,36.24,0.31,177,68695,70,NULL,NULL,'GIN 649',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.000123,NULL,'14.98',NULL,'E/S0',NULL,NULL,NULL,NULL,1,270.4285417,42.71897,0.117,NULL,54225895294,847279613,13238743,14.98),(142282,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142282,37.32,0.25,291,68695,74.4,NULL,NULL,'GIN 649',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142283,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142283,36.79,0.43,228,68696,NULL,NULL,'Malmquist cor.','2MASX J18014487+6930538',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000023,NULL,'16.57',NULL,'S0',NULL,NULL,NULL,NULL,1,270.4365,69.51497,0.165,NULL,52683004535,823171945,12862061,16.57),(142284,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142284,37,0.39,251,68696,NULL,NULL,NULL,'2MASX J18014487+6930538',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142285,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142285,37.04,0.2,256,68696,74.4,NULL,NULL,'2MASX J18014487+6930538',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142286,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142286,34.3,0.45,72.3,68697,NULL,NULL,'K','NGC 6527',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000033,NULL,'14.30',1,'Sa:',NULL,NULL,NULL,NULL,1,270.443041667,19.72872,0.397,NULL,53822457811,840975903,13140248,14.3),(142287,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142287,34.34,0.47,73.9,68697,NULL,NULL,'H','NGC 6527',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142288,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142288,34.39,0.4,75.6,68697,NULL,NULL,'mean','NGC 6527',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142289,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142289,34.44,0.46,77.4,68697,NULL,NULL,'J','NGC 6527',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142290,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142290,37.95,0.5,390,68698,NULL,NULL,'Malmquist cor.','AGC 280132',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000023,NULL,'16.58',NULL,'Sc',NULL,NULL,NULL,NULL,1,270.454333,69.24411,0.173,NULL,52682858621,823169665,12862026,16.58),(142291,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142291,37.98,0.49,394,68698,NULL,NULL,NULL,'AGC 280132',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142292,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142292,38.02,0.2,402,68698,74.4,NULL,NULL,'AGC 280132',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142293,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142293,32.29,0.8,28.7,68699,75,NULL,'A82, H','UGC 11093',NULL,'1997ApJS..109..333W',1997,1,5.38,NULL,'G',0.000003,NULL,'13.7',0.68,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,270.465291667,6.96825,0.781,NULL,53728410383,839506412,13117287,13.7),(142294,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142294,31.52,0.4,20.1,68699,NULL,NULL,'Virgo cluster at 15.6 Mpc','UGC 11093',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142295,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142295,31.55,0.4,20.4,68699,75,NULL,NULL,'UGC 11093',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142296,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142296,31.63,0.38,21.2,68699,NULL,NULL,NULL,'UGC 11093',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142297,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142297,31.69,0.43,21.8,68699,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11093',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142298,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142298,31.75,NULL,22.4,68699,NULL,NULL,'Dipole','UGC 11093',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142299,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142299,31.75,0.43,22.4,68699,75,NULL,'3.6 micron, color corrected','UGC 11093',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142300,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142300,31.76,NULL,22.5,68699,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11093',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142301,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142301,31.76,NULL,22.5,68699,NULL,NULL,'Dipole + Quadrupole','UGC 11093',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142302,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142302,31.79,0.2,22.8,68699,74.4,NULL,NULL,'UGC 11093',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142303,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142303,31.81,NULL,23,68699,NULL,NULL,NULL,'UGC 11093',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142304,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142304,31.84,0.46,23.3,68699,NULL,NULL,'J','UGC 11093',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142305,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142305,31.84,0.47,23.3,68699,75,NULL,'A82, H, raw','UGC 11093',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142306,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142306,31.88,0.47,23.8,68699,NULL,NULL,'H','UGC 11093',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142307,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142307,31.89,0.47,23.9,68699,75,NULL,'A82, H, inv','UGC 11093',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142308,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142308,32,0.45,25.1,68699,NULL,NULL,'K','UGC 11093',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142309,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142309,32,0.4,25.1,68699,NULL,NULL,'Malmquist cor.','UGC 11093',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142310,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142310,32,0.4,25.1,68699,NULL,NULL,NULL,'UGC 11093',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142311,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142311,32.02,0.4,25.3,68699,NULL,NULL,'mean','UGC 11093',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142312,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142312,32.11,0.49,26.4,68699,75,NULL,'IR','UGC 11093',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142313,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142313,32.28,0.47,28.6,68699,75,NULL,'A82, H, cor','UGC 11093',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142314,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142314,32.39,0.4,30.1,68699,75,NULL,'B','UGC 11093',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142315,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142315,36.4,0.62,191,68700,70,NULL,NULL,'2MASX J18015251-6750192',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,270.4687083,-67.83867,0.537,NULL,48452620294,757072192,11829253,15.4),(142316,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142316,37.54,0.53,323,68701,NULL,NULL,'Malmquist cor.','2MASX J18015270+6842437',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000023,NULL,'15.19',NULL,'Sa',NULL,NULL,NULL,NULL,1,270.469417,68.71219,0.201,NULL,52681003041,823140672,12861573,15.19),(142317,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142317,37.72,0.49,349,68701,NULL,NULL,NULL,'2MASX J18015270+6842437',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142318,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142318,37.76,0.2,356,68701,74.4,NULL,NULL,'2MASX J18015270+6842437',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142319,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142319,36.19,0.54,173,68702,70,NULL,NULL,'2MASX J18015559-6944532',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,270.481875,-69.74808,0.153,NULL,48454505466,757101647,11829713,16.7),(142320,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142320,36.38,0.72,189,68703,70,NULL,NULL,'2MASX J18020944-6436319',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,270.5392917,-64.60889,0.269,NULL,48931826749,764559792,11946246,15.5),(142321,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 2005de',NULL,142321,34.24,0.2,69.4,68704,70,NULL,'SALT 2','UGC 11097',0.015184,'2013MNRAS.433.2240G',2013,1,1.2,NULL,'G',0.000117,NULL,'13.2B',0.4,'S?',NULL,NULL,NULL,NULL,1,270.603625,26.04039,0.521,NULL,54301322056,848458157,13257158,13.2),(142322,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142322,33.2,0.49,43.7,68704,75,NULL,'IR','UGC 11097',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142323,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142323,34.89,0.49,95.1,68705,75,NULL,'IR','ESO 102- G 023',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000033,NULL,'15.23',0.2,'Sbc: sp',NULL,NULL,NULL,NULL,1,270.6415,-63.31694,0.281,NULL,48934465587,764601024,11946891,15.23),(142324,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142324,35.28,0.52,114,68705,NULL,NULL,'Malmquist cor.','ESO 102- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142325,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142325,35.45,0.47,123,68705,NULL,NULL,'H','ESO 102- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142326,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142326,35.46,0.4,124,68705,NULL,NULL,'mean','ESO 102- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142327,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142327,35.47,0.48,124,68705,NULL,NULL,NULL,'ESO 102- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142328,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142328,35.51,0.2,126,68705,74.4,NULL,NULL,'ESO 102- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142329,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142329,35.6,0.45,132,68705,NULL,NULL,'K','ESO 102- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142330,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142330,35.66,0.46,136,68705,NULL,NULL,'J','ESO 102- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142331,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142331,36.08,0.25,164,68706,74.4,NULL,NULL,'CGCG 227-016 NED02',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000067,NULL,'13.93',NULL,'cD',NULL,NULL,NULL,NULL,1,270.667667,42.79547,0.137,NULL,54226057408,847282147,13238783,13.93),(142332,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142332,36.24,0.31,177,68706,70,NULL,NULL,'CGCG 227-016 NED02',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142333,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142333,33.38,0.48,47.5,68707,70,NULL,NULL,'NGC 6492',NULL,'2014MNRAS.445.2677S',2014,1,2.5,NULL,'G',0.000026,NULL,'12.3',1.2,'SAB(rs)b','Pair member (points to parent)',NULL,NULL,NULL,1,270.7014583,-66.43064,0.281,NULL,48923106017,764423531,11944117,12.3),(142334,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142334,33.35,NULL,46.8,68707,NULL,NULL,'B','NGC 6492',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142335,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142335,33.61,0.47,52.8,68707,NULL,NULL,'H','NGC 6492',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142336,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142336,33.65,0.46,53.8,68707,NULL,NULL,'J','NGC 6492',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142337,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142337,33.76,0.45,56.6,68707,NULL,NULL,'K','NGC 6492',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142338,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142338,33.81,0.4,57.9,68707,NULL,NULL,'mean','NGC 6492',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142339,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142339,33.84,NULL,58.6,68707,NULL,NULL,'I','NGC 6492',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142340,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142340,34.22,0.07,70,68707,NULL,NULL,NULL,'NGC 6492',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142341,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142341,36.88,0.59,238,68708,70,NULL,NULL,'2MASX J18024904-6518065',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,270.7042083,-65.30172,0.265,NULL,48924544041,764446000,11944468,15.5),(142342,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142342,35.6,0.63,132,68709,70,NULL,NULL,'ESO 024- G 011',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'16.4b',0.3,'S...',NULL,NULL,NULL,NULL,1,270.7252917,-79.13833,0.649,NULL,48352177201,755502768,11804730,16.4),(142343,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142343,35.59,0.48,131,68710,NULL,NULL,'Malmquist cor.','UGC 11102',NULL,'2009ApJS..182..474S',2009,1,1.28,NULL,'G',0.00003,NULL,'17.',0.11,'Sc',NULL,NULL,NULL,NULL,1,270.742875,52.11453,0.141,NULL,52923188354,826924818,12920700,17),(142344,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142344,35.87,NULL,149,68710,NULL,NULL,NULL,'UGC 11102',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142345,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142345,35.89,0.42,150,68710,NULL,NULL,NULL,'UGC 11102',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142346,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142346,35.93,0.2,153,68710,74.4,NULL,NULL,'UGC 11102',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142347,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142347,34.27,0.2,71.5,68711,74.4,NULL,NULL,'UGC 11101',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',NULL,NULL,'16.0',0.3,'Scd:',NULL,NULL,NULL,NULL,1,270.7677083,45.25639,0.141,NULL,54760993373,855640521,13369383,16),(142348,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142348,34.31,0.46,72.7,68711,NULL,NULL,NULL,'UGC 11101',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142349,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142349,34.63,0.4,84.2,68711,NULL,NULL,'Malmquist cor.','UGC 11101',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142350,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142350,36.07,0.25,164,68712,74.4,NULL,NULL,'GIN 652',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000063,NULL,'15.29',NULL,'E/S0',NULL,NULL,NULL,NULL,1,270.7682083,42.95614,0.137,NULL,54225824200,847278503,13238726,15.29),(142351,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142351,36.24,0.31,177,68712,70,NULL,NULL,'GIN 652',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142352,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142352,38.52,0.5,507,68713,NULL,NULL,NULL,'2MASX J18031234+6917048',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000023,NULL,'16.11',NULL,'Sbc:',NULL,NULL,NULL,NULL,1,270.8015,69.28456,0.205,NULL,52683060893,823172826,12862075,16.11),(142353,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142353,38.52,0.5,507,68713,NULL,NULL,'Malmquist cor.','2MASX J18031234+6917048',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142354,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142354,38.57,0.2,518,68713,74.4,NULL,NULL,'2MASX J18031234+6917048',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142355,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142355,43.12,NULL,4210,68714,70,NULL,'Pseudo z = 9.5','GRB 010612',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE/Ulysses',NULL,NULL,NULL,NULL,1,270.825,-32.13333,NULL,NULL,47667679006,744807484,11637616,NULL),(142356,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142356,36.59,0.7,208,68715,70,NULL,NULL,'2MFGC 14185',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,270.849875,-71.00853,0.473,NULL,48459855916,757185248,11831019,15.4),(142357,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142357,35.77,0.5,142,68716,70,NULL,NULL,'2MASX J18032585-5228417',NULL,'2014MNRAS.445.2677S',2014,1,0.16,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,270.8577917,-52.47817,0.569,NULL,48882181477,763784085,11934126,15.2),(142358,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142358,36.5,0.61,200,68717,70,NULL,NULL,'2MASX J18034670-6601098',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,270.9445,-66.01942,0.265,NULL,48924819652,764450307,11944536,15.8),(142359,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142359,37.17,0.57,272,68718,NULL,NULL,'Malmquist cor.','2MASX J18034705+6922579',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000023,NULL,'15.43',NULL,'Sbc',NULL,NULL,NULL,NULL,1,270.9457083,69.38281,0.185,NULL,52683051443,823172678,12862073,15.43),(142360,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142360,37.49,0.5,315,68718,NULL,NULL,NULL,'2MASX J18034705+6922579',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142361,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142361,37.54,0.2,322,68718,74.4,NULL,NULL,'2MASX J18034705+6922579',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142362,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142362,36.89,0.7,238,68719,70,NULL,NULL,'2MASX J18035551-5728564',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,270.9814583,-57.48228,0.413,NULL,48956300327,764942192,11952221,15),(142363,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142363,36.09,0.5,165,68720,70,NULL,NULL,'2MASX J18040312-6654557',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,271.012875,-66.91547,0.289,NULL,48923398350,764428099,11944189,14.6),(142364,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142364,35.98,0.67,157,68721,70,NULL,NULL,'2MASX J18041135-6656515',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,271.0470417,-66.94761,0.289,NULL,48923353746,764427402,11944178,14.4),(142365,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142365,35.92,0.49,153,68722,75,NULL,'IR','FGC 2180',NULL,'2011yCatp016004901K',2011,1,0.91,NULL,'G',NULL,NULL,'16.6',0.11,'Sbc',NULL,NULL,NULL,NULL,1,271.0507083,45.06314,0.157,NULL,54761000640,855640635,13369384,16.6),(142366,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142366,35.94,NULL,154,68722,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2180',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142367,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142367,35.96,NULL,156,68722,NULL,NULL,'Dipole + Quadrupole','FGC 2180',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142368,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142368,35.97,NULL,156,68722,NULL,NULL,NULL,'FGC 2180',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142369,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142369,35.98,NULL,157,68722,NULL,NULL,'Dipole','FGC 2180',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142370,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142370,34.23,0.46,70.1,68723,70,NULL,NULL,'NGC 6502',NULL,'2014MNRAS.445.2677S',2014,1,1.3,'Blakeslee (priv.comm.2002) says v=4880 in 2001MNRAS.327.1004B incorrect.','G',0.000057,NULL,'13.57',1.1,'SA0-:',NULL,NULL,NULL,NULL,1,271.057167,-65.40994,0.265,NULL,48925455835,764460247,11944691,13.57),(142371,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142371,32.19,0.43,27.5,68724,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 056-008',NULL,'2014MNRAS.444..527S',2014,1,0.8,NULL,'G',0.000087,NULL,'15.7',0.2,'S',NULL,NULL,NULL,NULL,1,271.064833,7.04094,0.869,NULL,53727608841,839493888,13117092,15.7),(142372,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142372,35.31,0.75,116,68725,70,NULL,NULL,'ESO 044- G 024',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000033,NULL,'16.0b',0.3,'S...',NULL,NULL,NULL,NULL,1,271.069833333,-73.70889,0.461,NULL,48477977756,757468402,11835443,16),(142373,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142373,35.95,0.4,155,68725,NULL,NULL,'Malmquist cor.','ESO 044- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142374,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142374,35.98,0.39,157,68725,NULL,NULL,NULL,'ESO 044- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142375,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142375,36.02,0.2,160,68725,74.4,NULL,NULL,'ESO 044- G 024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142376,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142376,37.69,0.51,345,68726,NULL,NULL,'Malmquist cor.','2MASX J18042418+6915401',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000023,NULL,'15.90',NULL,'Sbc',NULL,NULL,NULL,NULL,1,271.1007083,69.26119,0.205,NULL,52684014199,823187721,12862308,15.9),(142377,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142377,37.76,0.49,356,68726,NULL,NULL,NULL,'2MASX J18042418+6915401',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142378,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142378,37.8,0.2,363,68726,74.4,NULL,NULL,'2MASX J18042418+6915401',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142379,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142379,35.37,0.52,119,68727,70,NULL,NULL,'2MASX J18042526-6952396',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000143,NULL,'15.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,271.1052083,-69.87769,0.153,NULL,48454634358,757103661,11829744,15.1),(142380,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142380,32.67,0.4,34.2,68728,75,NULL,'B','UGC 11105',NULL,'1988NBGC.C....0000T',1988,1,2.2,NULL,'G',0.00002,NULL,'14.2',1.7,'Sdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,271.150333333,21.63789,0.385,NULL,54559922501,852498789,13320293,14.2),(142381,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142381,44.52,0.67,2510,68729,72,NULL,NULL,'GRB 050922',2.2,'2008JCAP...07..004M',2008,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'INTEGRAL',NULL,NULL,NULL,NULL,1,271.094,-32.041,NULL,NULL,47668226867,744816044,11637750,NULL),(142382,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142382,45.57,0.52,4060,68729,69.7,NULL,'Calibrated','GRB 050922',2.2,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142383,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142383,45.71,0.55,4330,68729,69.7,NULL,'Fiducial','GRB 050922',2.2,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142384,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142384,45.77,0.56,4460,68729,72,NULL,NULL,'GRB 050922',2.2,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142385,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142385,46.12,0.65,5220,68729,NULL,NULL,NULL,'GRB 050922',2.2,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142386,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142386,35.11,NULL,105,68730,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11108',NULL,'2010Ap&SS.325..163P',2010,1,1.14,NULL,'G',0.000014,NULL,'16.5',0.1,'Scd',NULL,NULL,NULL,NULL,1,271.2550417,20.03967,0.377,NULL,53824502486,841007851,13140747,16.5),(142387,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142387,35.11,NULL,105,68730,NULL,NULL,'Dipole','UGC 11108',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142388,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142388,35.11,NULL,105,68730,NULL,NULL,'Dipole + Quadrupole','UGC 11108',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142389,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142389,35.12,0.49,106,68730,75,NULL,'IR','UGC 11108',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142390,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142390,35.18,NULL,108,68730,NULL,NULL,NULL,'UGC 11108',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142391,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142391,34.18,0.69,68.5,68731,100,NULL,'mid-IR','NGC 6560',NULL,'2013ApJ...771...88L',2013,1,1.2,NULL,'G',0.00001,NULL,'14.16',0.8,'S pec?',NULL,NULL,NULL,NULL,1,271.30825,46.88158,0.113,NULL,52885860317,826341567,12911586,14.16),(142392,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142392,35.02,0.4,101,68731,NULL,NULL,'mean','NGC 6560',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142393,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142393,35.21,0.47,110,68731,NULL,NULL,'H','NGC 6560',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142394,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142394,32.76,0.4,35.7,68732,75,NULL,'B','UGC 11113',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000013,NULL,'14.2',1.8,'SABd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,271.379375,23.27217,0.465,NULL,54294829367,848356708,13255573,14.2),(142395,'SBF','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142395,31.81,0.21,23,68733,NULL,NULL,'I','NGC 6548',NULL,'2001ApJ...546..681T',2001,1,1.4,NULL,'G',0.000033,NULL,'14.72',0.4,'S?','Pair member (points to parent)',NULL,NULL,NULL,1,271.45625,18.53803,0.433,NULL,53836311998,841192374,13143630,14.72),(142396,'SBF','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142396,31.83,0.14,23.2,68733,74.4,NULL,NULL,'NGC 6548',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142397,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142397,34.22,0.47,69.8,68733,NULL,NULL,'H','NGC 6548',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142398,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142398,34.25,0.45,70.6,68733,NULL,NULL,'K','NGC 6548',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142399,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142399,34.34,0.49,73.7,68733,75,NULL,'IR','NGC 6548',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142400,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142400,34.36,0.46,74.6,68733,NULL,NULL,'J','NGC 6548',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142401,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142401,34.64,0.4,84.8,68733,NULL,NULL,'mean','NGC 6548',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142402,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142402,34.95,0.8,97.7,68734,75,NULL,'CF, r','UGC 11118',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000077,NULL,'15.09',0.6,'Sb',NULL,NULL,NULL,NULL,1,271.467458333,34.01831,0.285,NULL,54241049369,847516396,13242443,15.09),(142403,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142403,34.61,0.38,83.6,68734,75,NULL,'CF, r, raw','UGC 11118',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142404,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142404,34.73,0.38,88.3,68734,75,NULL,'CF, r, inv','UGC 11118',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142405,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142405,34.86,0.38,93.8,68734,75,NULL,'CF, r, cor','UGC 11118',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142406,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142406,32.92,0.4,38.4,68735,NULL,NULL,'mean','NGC 6550',NULL,'2007A&A...465...71T',2007,1,3,NULL,'G',0.000017,NULL,'12.73',2.8,'SB0','Pair member (points to parent)',NULL,NULL,NULL,1,271.496833,18.58725,0.433,NULL,53836277504,841191836,13143622,12.73),(142407,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142407,33.64,0.45,53.4,68735,NULL,NULL,'K','NGC 6550',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142408,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142408,35.89,0.58,151,68736,70,NULL,NULL,'2MASX J18061404-7004355',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,271.558667,-70.07661,0.153,NULL,48454603699,757103182,11829737,14.9),(142409,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142409,36.27,0.59,180,68737,70,NULL,NULL,'2MASX J18061744-7043285',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,271.572375,-70.72461,0.541,NULL,48467384197,757302878,11832857,15.6),(142410,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142410,35.79,0.75,144,68738,70,NULL,NULL,'2MASX J18063817-6609021',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,271.659291667,-66.15056,0.265,NULL,48925956326,764468067,11944813,15.5),(142411,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142411,37.14,0.64,268,68739,70,NULL,NULL,'2MASX J18064396-6500287',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,271.6827917,-65.00794,0.261,NULL,48936086537,764626352,11947286,14.2),(142412,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142412,36.61,0.65,210,68740,70,NULL,NULL,'2MASX J18064749-7314479',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,271.697833333,-73.24675,0.293,NULL,48511545100,757992892,11843638,14.4),(142413,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142413,35.58,0.55,131,68741,70,NULL,NULL,'2MASX J18064924-5203264',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,271.705,-52.05742,0.553,NULL,48883917934,763811217,11934550,15.4),(142414,'BL Lac Luminosity','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142414,36.85,NULL,223,68742,NULL,NULL,NULL,'UGC 11130',0.051,'2005ApJ...635..173S',2005,1,0.15,NULL,'G',0.0003,NULL,'14.2V',0.15,'E;BLLAC        LEG',NULL,NULL,'radio jet','Flat-Spectrum Radio Source',1,271.711167,69.82447,0.193,NULL,52683580903,823180951,12862202,14.2),(142415,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142415,33.59,0.47,52.1,68743,70,NULL,NULL,'ESO 139- G 055',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.00015,NULL,'13.70',1.1,'(R)SA(rl)0^0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,271.752833333,-57.73092,0.365,NULL,48959903941,764998499,11953101,13.7),(142416,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142416,32.94,NULL,38.7,68744,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11120',NULL,'2010Ap&SS.325..163P',2010,1,1.4,NULL,'G',0.000013,NULL,'15.34',0.18,'Sdm',NULL,NULL,NULL,NULL,1,271.759667,20.48814,0.357,NULL,53823762056,840996282,13140566,15.34),(142417,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142417,32.96,NULL,39.1,68744,NULL,NULL,'Dipole + Quadrupole','UGC 11120',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142418,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142418,32.96,NULL,39.1,68744,NULL,NULL,'Dipole','UGC 11120',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142419,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142419,36.18,0.49,172,68745,70,NULL,NULL,'PKS 1801-702',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000123,NULL,'16.5',NULL,'Elliptical',NULL,NULL,NULL,NULL,1,271.811916667,-70.21067,0.241,NULL,48453728900,757089514,11829523,16.5),(142420,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142420,32.15,0.4,26.9,68746,75,NULL,'B','UGC 11124',NULL,'1988NBGC.C....0000T',1988,1,2.5,NULL,'G',0.00001,NULL,'13.4',2.3,'SB(s)cd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,271.864583,35.56333,0.157,NULL,54254639523,847728742,13245761,13.4),(142421,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142421,36.96,0.65,246,68747,70,NULL,NULL,'2MASX J18074223-6414568',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,271.925917,-64.24914,0.301,NULL,48932259780,764566559,11946352,15.5),(142422,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142422,32.65,0.4,33.9,68748,75,NULL,'B','NGC 6555',NULL,'1988NBGC.C....0000T',1988,1,2,'HOLM 774B is a clump of stars.','G',0.000013,NULL,'12.99',1.5,'SAB(rs)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,271.954875,17.60489,0.553,NULL,53827487433,841054491,13141476,12.99),(142423,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142423,34.46,0.43,78.1,68749,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2185',NULL,'2014MNRAS.444..527S',2014,1,0.99,NULL,'G',0.000013,NULL,'16.6',0.1,'Scd',NULL,NULL,NULL,NULL,1,272.024125,16.57914,0.705,NULL,53882498938,841914045,13154906,16.6),(142424,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142424,35.33,0.49,116,68749,75,NULL,'IR','FGC 2185',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142425,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142425,35.57,NULL,130,68749,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2185',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142426,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142426,35.59,NULL,131,68749,NULL,NULL,'Dipole + Quadrupole','FGC 2185',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142427,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142427,35.6,NULL,132,68749,NULL,NULL,'Dipole','FGC 2185',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142428,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142428,35.61,NULL,132,68749,NULL,NULL,NULL,'FGC 2185',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142429,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142429,34.12,0.55,66.7,68750,NULL,NULL,NULL,'IC 4688',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000023,NULL,'13.8',1.1,'Scd:',NULL,NULL,NULL,NULL,1,272.0495,11.71222,0.473,NULL,53840129260,841252019,13144562,13.8),(142430,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142430,34.16,0.2,67.9,68750,74.4,NULL,NULL,'IC 4688',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142431,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142431,34.19,0.54,68.8,68750,NULL,NULL,'Malmquist cor.','IC 4688',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142432,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142432,34.28,0.47,71.6,68750,NULL,NULL,'H','IC 4688',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142433,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142433,34.34,0.45,73.8,68750,NULL,NULL,'K','IC 4688',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142434,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142434,34.37,0.46,74.9,68750,NULL,NULL,'J','IC 4688',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142435,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142435,34.55,0.4,81.1,68750,NULL,NULL,'mean','IC 4688',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142436,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142436,33.63,0.8,53.1,68751,75,NULL,'MAT, I','IC 4674',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.87',0.6,'SAB(s)d:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,272.0545,-62.3955,0.353,NULL,48977830061,765278594,11957478,14.87),(142437,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142437,32.21,0.32,27.7,68751,85,NULL,'I, raw','IC 4674',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142438,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142438,32.21,0.32,27.7,68751,85,NULL,'I, inv','IC 4674',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142439,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142439,32.55,0.43,32.4,68751,75,NULL,'MAT, I, raw','IC 4674',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142440,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142440,32.6,0.43,33.1,68751,75,NULL,'MAT, I, inv','IC 4674',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142441,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142441,32.94,0.43,38.7,68751,75,NULL,'MAT, I, cor','IC 4674',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142442,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142442,36.45,0.77,195,68752,70,NULL,NULL,'2MASX J18082419-5204181',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,272.100875,-52.07175,0.553,NULL,48884027874,763812935,11934577,15.4),(142443,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142443,35.72,0.52,139,68753,70,NULL,NULL,'2MASX J18082523-4709251',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,272.105041667,-47.15689,0.529,NULL,48858421386,763412834,11928325,14.1),(142444,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142444,36.09,0.6,165,68754,70,NULL,NULL,'2MASX J18082519-5658023',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,272.105125,-56.96742,0.377,NULL,49090619090,767040923,11985014,15.3),(142445,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142445,33.94,0.53,61.4,68755,70,NULL,NULL,'ESO 229- G 007',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000147,NULL,'15.4b',0.2,'SA(s)b',NULL,NULL,NULL,NULL,1,272.123916667,-52.10597,0.553,NULL,48883999195,763812487,11934570,15.4),(142446,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142446,43.07,0.38,2100,68756,69.7,NULL,'Calibrated','GRB 970828:[DFK2001] A',0.9578,'2009MNRAS.400..775C',2009,1,NULL,NULL,'G',0.0001,NULL,'25.05',NULL,NULL,NULL,NULL,NULL,NULL,1,272.132333333,59.31458,0.097,NULL,53047418009,828865906,12951029,25.05),(142447,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142447,43.86,0.45,2210,68756,73,NULL,'H const./H=100','GRB 970828:[DFK2001] A',0.9578,'2006astro.ph..9262M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142448,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142448,43.2,0.64,2230,68756,69.7,NULL,'Calibrated','GRB 970828:[DFK2001] A',0.9578,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142449,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142449,43.38,0.49,2420,68756,69.7,NULL,'Fiducial','GRB 970828:[DFK2001] A',0.9578,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142450,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142450,43.43,0.47,2480,68756,72,NULL,NULL,'GRB 970828:[DFK2001] A',0.9578,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142451,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142451,43.58,0.46,2660,68756,70,NULL,NULL,'GRB 970828:[DFK2001] A',0.9578,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142452,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142452,34.28,0.49,71.8,68757,75,NULL,'IR','UGC 11126',NULL,'2011yCatp016004901K',2011,1,1.55,NULL,'G',0.000047,NULL,'17.',0.1,'Sd',NULL,NULL,NULL,NULL,1,272.1409583,25.72494,0.569,NULL,54302191039,848471734,13257370,17),(142453,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142453,34.31,NULL,72.9,68757,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11126',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142454,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142454,34.33,NULL,73.4,68757,NULL,NULL,'Dipole + Quadrupole','UGC 11126',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142455,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142455,34.33,NULL,73.4,68757,NULL,NULL,'Dipole','UGC 11126',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142456,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142456,35.74,0.58,141,68758,70,NULL,NULL,'2MASX J18083485-6644017',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,272.145375,-66.73383,0.341,NULL,48926163969,764471312,11944864,14.2),(142457,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142457,36.08,0.79,164,68759,70,NULL,NULL,'2MASX J18084308-6351340',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,272.1797083,-63.85944,0.305,NULL,48934084250,764595066,11946797,15.1),(142458,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142458,37.06,0.81,258,68760,70,NULL,NULL,'2MASX J18085179-7327292',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,272.215875,-73.45817,0.517,NULL,48511416385,757990881,11843607,16.9),(142459,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142459,36.25,0.54,178,68761,70,NULL,NULL,'2MASX J18085404-6535310',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,272.2250417,-65.592,0.265,NULL,48925188899,764456076,11944626,14.9),(142460,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142460,36.7,0.54,219,68762,70,NULL,NULL,'2MASX J18085586-4844290',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,272.232917,-48.74144,0.473,NULL,48870200826,763596887,11931201,15.4),(142461,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142461,36.66,0.73,215,68763,70,NULL,NULL,'2MASX J18090029-6504041',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,272.251125,-65.06783,0.261,NULL,48936931416,764639553,11947493,13.9),(142462,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142462,35.78,0.67,143,68764,70,NULL,NULL,'2MASX J18091135-5719040',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,272.29725,-57.31775,0.377,NULL,48956504944,764945389,11952271,15),(142463,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142463,36.55,0.6,204,68765,70,NULL,NULL,'2MASX J18092457-5719210',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,272.35225,-57.32247,0.377,NULL,48956504344,764945380,11952271,15.3),(142464,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142464,33.04,0.4,40.6,68766,75,NULL,NULL,'UGC 11132',NULL,'2008Ap.....51..336K',2008,1,2.49,NULL,'G',0.000013,NULL,'15.38',0.38,'Sb','Isolated galaxy',NULL,NULL,NULL,1,272.359083,38.79442,0.145,NULL,54286646944,848228858,13253575,15.38),(142465,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142465,33.15,0.4,42.6,68766,NULL,NULL,'mean','UGC 11132',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142466,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142466,33.42,0.43,48.3,68766,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11132',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142467,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142467,33.6,0.43,52.5,68766,75,NULL,'3.6 micron, color corrected','UGC 11132',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142468,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142468,33.62,0.47,52.9,68766,NULL,NULL,'H','UGC 11132',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142469,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142469,33.66,0.45,53.8,68766,NULL,NULL,'K','UGC 11132',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142470,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142470,33.74,0.49,56,68766,75,NULL,'IR','UGC 11132',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142471,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142471,33.83,0.2,58.3,68766,74.4,NULL,NULL,'UGC 11132',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142472,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142472,36.96,0.58,247,68767,70,NULL,NULL,'2MASX J18092622-5732270',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,272.3592917,-57.54086,0.373,NULL,48959563294,764993176,11953018,15.6),(142473,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142473,36.02,0.65,160,68768,70,NULL,NULL,'2MASX J18092945-6459259',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,272.3724583,-64.99047,0.261,NULL,48937041507,764641273,11947519,15.9),(142474,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142474,34.47,0.5,78.3,68769,70,NULL,NULL,'ESO 182- G?004',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'14.16',1,'SB(rs)a',NULL,NULL,NULL,NULL,1,272.37725,-52.56561,0.373,NULL,48883686034,763807594,11934493,14.16),(142475,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142475,33.87,0.51,59.4,68770,70,NULL,NULL,'ESO 103- G 005',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'14.81',0.5,'S0?',NULL,NULL,NULL,NULL,1,272.420583333,-63.21683,0.313,NULL,48934265396,764597896,11946842,14.81),(142476,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142476,35.77,0.69,143,68771,70,NULL,NULL,'2MASX J18095847-6907044',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,272.493833333,-69.11803,0.389,NULL,48456583107,757134111,11830220,15.5),(142477,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142477,36.31,0.69,183,68772,70,NULL,NULL,'2MASX J18102926-7315166',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,272.621667,-73.25456,0.401,NULL,48512230134,758003595,11843806,15.6),(142478,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142478,36.1,0.62,166,68773,70,NULL,NULL,'2MASX J18104454-7000034',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,272.685833,-70.00089,0.169,NULL,48454166661,757096354,11829630,15.2),(142479,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 2002cu',NULL,142479,34.9,0.17,93.2,68774,70,NULL,'SALT 2','NGC 6575',0.023323,'2013MNRAS.433.2240G',2013,1,1.8,NULL,'G',0.00005,NULL,'13.69',1.3,'E','Pair member (points to parent)',NULL,NULL,NULL,1,272.7395417,31.11619,0.305,NULL,54339234611,849050540,13266414,13.69),(142480,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142480,38.01,NULL,400,68775,NULL,NULL,NULL,'GRB 790325b',NULL,'1992grbo.book..107S',1992,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,272.941875,31.40567,0.285,NULL,54326885736,848857589,13263399,NULL),(142481,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142481,38.58,NULL,520,68775,65,NULL,'L = 10e57 photons/s','GRB 790325b',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142482,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142482,39.19,NULL,688,68775,75,NULL,NULL,'GRB 790325b',NULL,'1995ApJ...453..583W',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142483,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142483,41.34,NULL,1850,68775,65,NULL,'L = 2 x 10e58 photons/s','GRB 790325b',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142484,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142484,32.56,0.8,32.5,68776,75,NULL,'A82, H','NGC 6570',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000017,NULL,'13.30',1.1,'SB(rs)m:','in a pair',NULL,NULL,NULL,1,272.780417,14.09308,0.665,NULL,53850728027,841417625,13147150,13.3),(142485,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142485,31.2,0.4,17.4,68776,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 6570',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142486,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142486,31.65,0.47,21.4,68776,75,NULL,'A82, H, inv','NGC 6570',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142487,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142487,31.65,0.47,21.4,68776,75,NULL,'A82, H, raw','NGC 6570',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142488,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142488,32.21,0.47,27.7,68776,75,NULL,'A82, H, cor','NGC 6570',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142489,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142489,32.69,0.4,34.5,68776,75,NULL,'B','NGC 6570',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142490,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142490,33.97,0.2,62.2,68777,74.4,NULL,NULL,'UGC 11140',NULL,'2013AJ....146...86T',2013,1,2.4,NULL,'G',0.000013,NULL,'15.00',0.4,'Scd:',NULL,NULL,NULL,NULL,1,272.788917,39.1705,0.125,NULL,54286235938,848222436,13253475,15),(142491,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142491,34.16,0.62,67.8,68777,NULL,NULL,NULL,'UGC 11140',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142492,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142492,34.33,0.57,73.6,68777,NULL,NULL,'Malmquist cor.','UGC 11140',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142493,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142493,34.05,0.2,61.3,68778,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','UGC 11149',0.05422,'2011A&A...526A..81B',2011,1,1.3,NULL,'G',0.000043,NULL,'14.2V',0.7,'Sb;BrClG',NULL,NULL,NULL,NULL,1,272.790708333,49.86469,0.189,NULL,52892620916,826447201,12913237,14.2),(142494,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142494,35.75,0.22,134,68778,74.2,NULL,'SALT 2','UGC 11149',0.05422,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142495,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142495,36.46,0.27,186,68778,70,NULL,'SALT','UGC 11149',0.05422,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142496,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142496,36.59,0.26,197,68778,65,NULL,'SALT','UGC 11149',0.05422,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142497,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142497,36.63,0.26,201,68778,72,NULL,NULL,'UGC 11149',0.05422,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142498,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142498,36.54,0.08,203,68778,74.4,NULL,NULL,'UGC 11149',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142499,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142499,36.7,0.04,207,68778,70,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','UGC 11149',0.05422,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142500,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142500,36.7,0.16,207,68778,70,NULL,'SALT 2','UGC 11149',0.05422,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142501,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142501,36.61,0.05,208,68778,70,NULL,NULL,'UGC 11149',0.05422,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142502,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142502,36.74,0.17,212,68778,73.8,NULL,'SALT 2 (SNANA)','UGC 11149',0.0537,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142503,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142503,36.75,0.13,212,68778,65,NULL,'SALT2','UGC 11149',0.05422,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142504,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142504,36.75,0.1,213,68778,72,NULL,NULL,'UGC 11149',0.05422,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142505,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142505,36.68,0.17,217,68778,70.8,NULL,NULL,'UGC 11149',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142506,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142506,36.92,0.1,218,68778,65,NULL,'MLCS2k2','UGC 11149',0.05422,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142507,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142507,36.85,0.04,223,68778,65,NULL,'SALT','UGC 11149',0.05422,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142508,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142508,36.89,0.14,226,68778,65,NULL,'MLCS31','UGC 11149',0.05422,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142509,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142509,36.9,0.14,228,68778,65,NULL,'MLCS17','UGC 11149',0.05422,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142510,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142510,36.92,0.1,229,68778,65,NULL,'MLCS2k2','UGC 11149',0.05422,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142511,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142511,36.96,0.18,233,68778,65,NULL,'SALT2','UGC 11149',0.05422,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142512,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142512,36.97,0.18,235,68778,65,NULL,NULL,'UGC 11149',0.05422,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142513,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142513,37,0.08,238,68778,65,NULL,'MLCS2k2','UGC 11149',0.05422,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142514,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142514,36.95,0.14,245,68778,60,NULL,NULL,'UGC 11149',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142515,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142515,34.28,0.49,71.6,68779,75,NULL,'IR','IC 1279',NULL,'2011yCatp016004901K',2011,1,2.6,NULL,'G',0.000023,NULL,'14.26',0.6,'Sb',NULL,NULL,NULL,NULL,1,272.814083333,36.00778,0.161,NULL,54257289123,847770142,13246408,14.26),(142516,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142516,34.49,0.47,78.9,68779,NULL,NULL,'H','IC 1279',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142517,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142517,34.56,0.46,81.5,68779,NULL,NULL,'J','IC 1279',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142518,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142518,34.61,0.45,83.5,68779,NULL,NULL,'K','IC 1279',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142519,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142519,34.68,0.4,86.3,68779,NULL,NULL,'mean','IC 1279',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142520,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142520,33.16,0.8,42.8,68780,75,NULL,'MAT, I','IC 4679',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000024,NULL,'13.80',0.9,'SB(s)c',NULL,NULL,NULL,NULL,1,272.852041667,-56.25439,0.393,NULL,49093560163,767086877,11985732,13.8),(142521,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142521,32.46,0.32,31,68780,85,NULL,'I, raw','IC 4679',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142522,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142522,32.46,0.32,31.1,68780,85,NULL,'I, inv','IC 4679',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142523,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142523,32.83,0.43,36.9,68780,75,NULL,'MAT, I, raw','IC 4679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142524,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142524,32.93,0.43,38.6,68780,75,NULL,'MAT, I, inv','IC 4679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142525,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142525,33.17,0.43,43,68780,75,NULL,'MAT, I, cor','IC 4679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142526,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142526,34.09,NULL,65.9,68781,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2187',NULL,'2010Ap&SS.325..163P',2010,1,0.92,NULL,'G',0.000043,':','16.6',0.1,'Sd',NULL,NULL,NULL,NULL,1,272.885,25.00583,0.713,NULL,54304457541,848507149,13257924,16.6),(142527,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142527,34.12,NULL,66.6,68781,NULL,NULL,'Dipole + Quadrupole','FGC 2187',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142528,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142528,34.12,NULL,66.8,68781,NULL,NULL,'Dipole','FGC 2187',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142529,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142529,33.83,0.49,58.5,68782,75,NULL,'IR','UGC 11142',NULL,'2011yCatp016004901K',2011,1,1.81,'Marzke, et al. (1996AJ....112.1803M) give v=7456 +/- 40 km/sec.','G',0.00001,NULL,'15.41',0.24,'Sc',NULL,NULL,NULL,NULL,1,272.911,25.65764,0.713,NULL,54303754617,848496165,13257752,15.41),(142530,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142530,34.11,0.43,66.4,68782,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11142',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142531,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142531,34.12,0.4,66.7,68782,NULL,NULL,'mean','UGC 11142',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142532,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142532,34.17,0.43,68.3,68782,75,NULL,'3.6 micron, color corrected','UGC 11142',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142533,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142533,34.31,0.2,72.8,68782,74.4,NULL,NULL,'UGC 11142',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142534,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142534,34.39,0.47,75.5,68782,NULL,NULL,'H','UGC 11142',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142535,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142535,34.4,0.42,75.9,68782,NULL,NULL,'Malmquist cor.','UGC 11142',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142536,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142536,34.46,NULL,78.1,68782,NULL,NULL,NULL,'UGC 11142',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142537,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142537,34.48,NULL,78.8,68782,NULL,NULL,'Dipole','UGC 11142',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142538,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142538,34.49,NULL,79,68782,NULL,NULL,'Dipole + Quadrupole','UGC 11142',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142539,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142539,34.49,NULL,79.2,68782,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11142',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142540,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142540,34.53,0.39,80.5,68782,NULL,NULL,NULL,'UGC 11142',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142541,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142541,32.99,0.8,39.6,68783,75,NULL,'MAT, I','ESO 071- G 004',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000013,NULL,'15.16',0.4,'SB(s)d? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,272.9505417,-67.63925,0.509,NULL,49191521589,768617524,12009648,15.16),(142542,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142542,32.61,0.32,33.3,68783,85,NULL,'I, raw','ESO 071- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142543,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142543,32.61,0.32,33.3,68783,85,NULL,'I, inv','ESO 071- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142544,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142544,32.88,0.43,37.7,68783,75,NULL,'MAT, I, raw','ESO 071- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142545,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142545,32.94,0.43,38.6,68783,75,NULL,'MAT, I, inv','ESO 071- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142546,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142546,33.11,0.53,41.9,68783,NULL,NULL,NULL,'ESO 071- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142547,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142547,33.15,0.2,42.7,68783,74.4,NULL,NULL,'ESO 071- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142548,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142548,33.25,0.43,44.6,68783,75,NULL,'MAT, I, cor','ESO 071- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142549,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142549,33.4,0.46,47.8,68783,NULL,NULL,'Malmquist cor.','ESO 071- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142550,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142550,32.64,0.4,33.8,68784,75,NULL,'B','UGC 11141',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.000019,NULL,'13.7',1.6,'Sdm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,272.9525,12.08861,0.569,NULL,53844970923,841327670,13145744,13.7),(142551,'Tully est','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142551,32.72,0.8,35,68785,75,NULL,'B','NGC 6574',NULL,'1988NBGC.C....0000T',1988,1,1.4,NULL,'G',0.000017,NULL,'12.83',1.1,'SAB(rs)bc:     Sy2','in a pair',NULL,NULL,NULL,1,272.963458333,14.98178,0.829,NULL,53881478050,841898094,13154657,12.83),(142552,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142552,32.52,0.4,32,68785,NULL,NULL,'mean','NGC 6574',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142553,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142553,32.82,0.45,36.6,68785,NULL,NULL,'K','NGC 6574',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142554,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142554,32.92,0.46,38.3,68785,NULL,NULL,'J','NGC 6574',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142555,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142555,32.95,0.4,38.9,68785,NULL,NULL,NULL,'NGC 6574',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142556,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142556,33.11,0.2,41.9,68785,74.4,NULL,NULL,'NGC 6574',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142557,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142557,32.14,0.8,26.8,68786,75,NULL,'MAT, I','ESO 140- G 006',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000019,NULL,'14.58',0.5,'SB(r)a:',NULL,NULL,NULL,NULL,1,273.002583,-58.97539,0.317,NULL,48971670249,765182347,11955974,14.58),(142558,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142558,31.67,0.32,21.6,68786,85,NULL,'I, inv','ESO 140- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142559,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142559,31.69,0.32,21.8,68786,85,NULL,'I, raw','ESO 140- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142560,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142560,31.84,0.4,23.3,68786,NULL,NULL,NULL,'ESO 140- G 006',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142561,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142561,31.84,0.4,23.3,68786,73,NULL,'opt','ESO 140- G 006',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142562,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142562,32.04,0.43,25.6,68786,75,NULL,'MAT, I, inv','ESO 140- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142563,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142563,32.05,0.43,25.7,68786,75,NULL,'MAT, I, raw','ESO 140- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142564,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142564,32.14,0.2,26.8,68786,74.4,NULL,NULL,'ESO 140- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142565,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142565,32.46,0.43,31,68786,75,NULL,'MAT, I, cor','ESO 140- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142566,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142566,34.1,NULL,66,68787,NULL,NULL,'Dipole','FGC 2189',NULL,'2010Ap&SS.325..163P',2010,1,0.81,NULL,'G',0.000025,':','16.9',0.11,'Scd',NULL,NULL,NULL,NULL,1,273.00475,25.57547,0.713,NULL,54303896224,848498378,13257787,16.9),(142567,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142567,34.1,NULL,66,68787,NULL,NULL,'Dipole + Quadrupole','FGC 2189',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142568,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142568,34.1,NULL,66.1,68787,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2189',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142569,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142569,34.2,NULL,69.3,68787,NULL,NULL,NULL,'FGC 2189',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142570,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142570,34.75,0.49,89,68788,75,NULL,'IR','UGC 11151',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.00011,NULL,'14.9',0.3,'S',NULL,NULL,NULL,NULL,1,273.023208333,29.15189,0.357,NULL,54337381400,849021584,13265962,14.9),(142571,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142571,33.75,NULL,56.2,68789,NULL,NULL,'Dipole','UGC 11150',NULL,'2010Ap&SS.325..163P',2010,1,1.96,NULL,'G',0.000103,NULL,'15.5',0.27,'Sc',NULL,NULL,NULL,NULL,1,273.028875,25.59539,0.713,NULL,54303897146,848498392,13257787,15.5),(142572,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142572,33.76,NULL,56.5,68789,NULL,NULL,'Dipole + Quadrupole','UGC 11150',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142573,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142573,33.76,NULL,56.6,68789,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11150',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142574,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142574,33.78,0.49,57.1,68789,75,NULL,'IR','UGC 11150',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142575,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142575,33.9,NULL,60.2,68789,NULL,NULL,NULL,'UGC 11150',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142576,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142576,35.57,0.56,130,68790,70,NULL,NULL,'2MASX J18121426-7315055',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000123,NULL,'14.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,273.059333,-73.25161,0.401,NULL,48512226263,758003535,11843805,14.8),(142577,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142577,33.22,0.25,44.1,68791,74.4,NULL,NULL,'NGC 6545',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000107,NULL,'14.16',0.9,'E1',NULL,NULL,NULL,NULL,1,273.061541667,-63.77614,0.313,NULL,48934019742,764594058,11946782,14.16),(142578,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142578,33.31,0.48,45.9,68791,70,NULL,NULL,'NGC 6545',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142579,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142579,33.82,0.4,58.1,68791,NULL,NULL,'mean','NGC 6545',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142580,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142580,34.29,0.45,72.1,68791,NULL,NULL,'K','NGC 6545',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142581,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142581,32.16,0.4,27.1,68792,75,NULL,NULL,'NGC 6585',NULL,'2008Ap.....51..336K',2008,1,1.9,NULL,'G',0.00002,NULL,'13.80',0.4,'S?',NULL,NULL,NULL,NULL,1,273.090791667,39.633,0.125,NULL,54285757292,848214957,13253358,13.8),(142582,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142582,32.42,0.43,30.4,68792,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6585',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142583,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142583,32.52,0.43,31.9,68792,75,NULL,'3.6 micron, color corrected','NGC 6585',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142584,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142584,32.65,0.2,33.9,68792,74.4,NULL,NULL,'NGC 6585',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142585,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142585,32.79,0.49,36.2,68792,75,NULL,'IR','NGC 6585',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142586,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142586,32.96,0.47,39.1,68792,NULL,NULL,'H','NGC 6585',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142587,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142587,33.02,0.46,40.2,68792,NULL,NULL,'J','NGC 6585',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142588,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142588,33.1,0.45,41.7,68792,NULL,NULL,'K','NGC 6585',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142589,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142589,33.11,0.4,41.9,68792,NULL,NULL,'mean','NGC 6585',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142590,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142590,35.32,0.49,116,68793,75,NULL,'IR','NGC 6608',NULL,'2011yCatp016004901K',2011,1,0.83,'MCG misidentifies this object as NGC 6609.','G',NULL,NULL,'16',0.1,'Sd',NULL,NULL,NULL,NULL,1,273.120333,61.29817,0.153,NULL,53044611022,828822047,12950344,16),(142591,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142591,35.76,NULL,142,68793,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 6608',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142592,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142592,35.77,NULL,143,68793,NULL,NULL,'Dipole + Quadrupole','NGC 6608',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142593,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142593,35.78,NULL,144,68793,NULL,NULL,NULL,'NGC 6608',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142594,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142594,35.8,NULL,144,68793,NULL,NULL,'Dipole','NGC 6608',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142595,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142595,35.46,0.46,124,68794,70,NULL,NULL,'ESO 229- G 009',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000103,NULL,'14.0R',0.6,'S0',NULL,NULL,NULL,NULL,1,273.1339583,-48.15461,0.477,NULL,48871857762,763622777,11931605,14),(142596,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142596,33.03,0.4,40.4,68795,75,NULL,'B','UGC 11152',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.000013,NULL,'14.1',1.1,'SBdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,273.134333,18.59892,0.613,NULL,53831053389,841110209,13142347,14.1),(142597,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142597,33.9,0.47,60.4,68796,NULL,NULL,'H','NGC 6621',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000007,NULL,'14',0.7,'Sb: pec    HII;LIRG','Pair member (points to parent)',NULL,NULL,NULL,1,273.230458333,68.36344,0.217,NULL,53553644579,836775696,13074620,14),(142598,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142598,33.96,0.45,62,68796,NULL,NULL,'K','NGC 6621',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142599,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142599,34.02,0.46,63.7,68796,NULL,NULL,'J','NGC 6621',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142600,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142600,34.54,0.4,81,68796,NULL,NULL,'mean','NGC 6621',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142601,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142601,35.07,0.47,103,68797,70,NULL,NULL,'2MASX J18131647-4920047',NULL,'2014MNRAS.445.2677S',2014,1,0.16,NULL,'G',0.00008,NULL,'14.3R',NULL,'S?',NULL,NULL,NULL,NULL,1,273.318583,-49.33467,0.453,NULL,48860895760,763451496,11928929,14.3),(142602,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142602,35.21,0.56,110,68798,70,NULL,NULL,'2MASX J18132081-4122266',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,273.336667,-41.37406,0.477,NULL,47529175399,742643365,11603802,15.9),(142603,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142603,33.79,0.8,57.2,68799,75,NULL,'HMCL, I','IC 4680',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00015,NULL,'13.88',0.8,'(R\')SB(rs)ab',NULL,NULL,NULL,NULL,1,273.3735,-64.47672,0.285,NULL,48936533885,764633341,11947395,13.88),(142604,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142604,33.58,0.4,52,68799,75,NULL,'HMCL, I, raw','IC 4680',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142605,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142605,33.76,0.46,56.4,68799,NULL,NULL,'J','IC 4680',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142606,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142606,33.79,0.47,57.2,68799,NULL,NULL,'H','IC 4680',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142607,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142607,33.8,0.4,57.5,68799,75,NULL,'HMCL, I, inv','IC 4680',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142608,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142608,33.8,0.45,57.5,68799,NULL,NULL,'K','IC 4680',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142609,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142609,33.81,0.4,57.8,68799,75,NULL,'HMCL, I, cor','IC 4680',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142610,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142610,33.9,0.4,60.3,68799,NULL,NULL,'mean','IC 4680',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142611,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142611,32.84,0.43,36.9,68800,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6586',NULL,'2014MNRAS.444..527S',2014,1,1,NULL,'G',0.000107,NULL,'14.6',0.5,'S',NULL,NULL,NULL,NULL,1,273.410417,21.09008,0.621,NULL,54574759713,852730620,13323915,14.6),(142612,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142612,36.63,0.62,212,68801,70,NULL,NULL,'2MASX J18134287-7309202',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,273.428667,-73.15569,0.361,NULL,48511960191,757999377,11843740,15.6),(142613,'Faber-Jackson','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142613,32.55,0.44,32.4,68802,95,NULL,'Weighted Mean','NGC 6587',NULL,'1984ApJS...56...91D',1984,1,1.3,'UZC gives v = 8301 +/- 28 km/sec.','G',0.000073,NULL,'13.9',1.1,'SAB0-:',NULL,NULL,NULL,NULL,1,273.4620417,18.82519,0.609,NULL,53831759352,841121239,13142519,13.9),(142614,'Faber-Jackson','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142614,32.91,0.46,38.2,68802,95,NULL,'Michard 1979a','NGC 6587',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142615,'Faber-Jackson','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142615,33,0.63,39.8,68802,95,NULL,'Michard 1979b, c','NGC 6587',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142616,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142616,34.66,0.2,85.5,68803,74.4,NULL,NULL,'NGC 6617',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',NULL,NULL,'15.2',1,'SA(s)d',NULL,NULL,NULL,NULL,1,273.5105,61.31956,0.153,NULL,53043768823,828808887,12950138,15.2),(142617,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142617,34.74,0.5,88.6,68803,NULL,NULL,NULL,'NGC 6617',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142618,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142618,34.79,0.49,90.7,68803,NULL,NULL,'Malmquist cor.','NGC 6617',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142619,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142619,36.07,0.73,164,68804,70,NULL,NULL,'2MASX J18141188-8036568',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,273.549667,-80.61578,0.581,NULL,48355734029,755558344,11805599,16.6),(142620,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142620,32.82,0.8,36.7,68805,75,NULL,'MAT, I','ESO 140- G 012',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.00002,NULL,'13.55',1.4,'(R)SAB(rs)a    HII',NULL,NULL,NULL,NULL,1,273.570416667,-60.09169,0.389,NULL,48971937783,765186527,11956039,13.55),(142621,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142621,32.59,0.43,33,68805,75,NULL,'MAT, I, raw','ESO 140- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142622,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142622,32.66,0.32,34.1,68805,85,NULL,'I, raw','ESO 140- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142623,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142623,32.69,0.32,34.5,68805,85,NULL,'I, inv','ESO 140- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142624,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142624,32.7,0.43,34.7,68805,75,NULL,'MAT, I, inv','ESO 140- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142625,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142625,32.97,0.43,39.3,68805,75,NULL,'MAT, I, cor','ESO 140- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142626,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142626,37.19,0.58,275,68806,70,NULL,NULL,'2MASX J18143088-4434143',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,273.62875,-44.57067,0.581,NULL,51005514816,796961169,12452518,15.5),(142627,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142627,33.26,0.49,44.9,68807,75,NULL,'IR','UGC 11182',NULL,'2011yCatp016004901K',2011,1,1.29,NULL,'G',0.000053,NULL,'16.5',0.13,'Sc',NULL,NULL,NULL,NULL,1,273.6922083,56.49836,0.137,NULL,53103652603,829744571,12964758,16.5),(142628,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142628,34,0.43,63.2,68807,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11182',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142629,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142629,34.69,NULL,86.7,68807,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11182',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142630,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142630,34.71,NULL,87.3,68807,NULL,NULL,'Dipole + Quadrupole','UGC 11182',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142631,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142631,34.71,NULL,87.4,68807,NULL,NULL,'Dipole','UGC 11182',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142632,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142632,34.75,NULL,89.1,68807,NULL,NULL,NULL,'UGC 11182',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142633,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142633,33.98,0.8,62.4,68808,75,NULL,'MAT, I','IC 4692',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000026,NULL,'14.27',0.9,'SB(r)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,273.7082083,-58.69378,0.337,NULL,48969958381,765155599,11955556,14.27),(142634,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142634,33.37,0.32,47.2,68808,85,NULL,'I, raw','IC 4692',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142635,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142635,33.41,0.32,48,68808,85,NULL,'I, inv','IC 4692',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142636,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142636,33.46,0.43,49.3,68808,75,NULL,'MAT, I, raw','IC 4692',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142637,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142637,33.63,0.43,53.3,68808,75,NULL,'MAT, I, inv','IC 4692',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142638,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142638,33.75,0.43,56.2,68808,75,NULL,'MAT, I, cor','IC 4692',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142639,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142639,34.1,0.4,66.1,68808,NULL,NULL,'mean','IC 4692',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142640,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142640,34.18,0.47,68.6,68808,NULL,NULL,'H','IC 4692',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142641,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142641,34.2,0.09,69.3,68808,NULL,NULL,NULL,'IC 4692',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142642,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142642,34.23,0.46,70,68808,NULL,NULL,'J','IC 4692',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142643,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142643,34.3,0.45,72.6,68808,NULL,NULL,'K','IC 4692',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142644,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142644,32.09,0.4,26.1,68809,75,NULL,'B','UGC 11193',NULL,'1988NBGC.C....0000T',1988,1,1.3,'Misidentified in CGCG and UGC as \'NGC 6651\'. NED follows RC2.','G',0.000013,NULL,'14.80',0.9,'Im',NULL,NULL,NULL,NULL,1,273.753333,71.00583,0.173,NULL,52694788612,823356072,12864938,14.8),(142645,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142645,35.14,0.52,107,68810,70,NULL,NULL,'2MASX J18152387-7301344',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6b',NULL,'(R)SB(r)0^+',NULL,NULL,NULL,NULL,1,273.8497917,-73.02625,0.361,NULL,48457092634,757142072,11830344,15.6),(142646,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142646,32.5,0.8,31.7,68811,75,NULL,'MAT, I','IC 4694',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000019,NULL,'13.72',0.8,'SB(s)c:',NULL,NULL,NULL,NULL,1,273.8602083,-58.20892,0.353,NULL,48959061273,764985332,11952895,13.72),(142647,'Tully est','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142647,32.77,0.8,35.8,68811,75,NULL,NULL,'IC 4694',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142648,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142648,31.85,0.32,23.4,68811,85,NULL,'I, raw','IC 4694',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142649,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142649,31.85,0.32,23.4,68811,85,NULL,'I, inv','IC 4694',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142650,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142650,32.06,0.43,25.8,68811,75,NULL,'MAT, I, raw','IC 4694',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142651,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142651,32.13,0.43,26.6,68811,75,NULL,'MAT, I, inv','IC 4694',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142652,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142652,32.46,0.4,31,68811,NULL,NULL,NULL,'IC 4694',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142653,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142653,32.47,0.43,31.1,68811,75,NULL,'MAT, I, cor','IC 4694',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142654,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142654,36,0.51,159,68812,70,NULL,NULL,'2MASX J18152771-4403516',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.5R',NULL,'SB(r)0^+',NULL,NULL,NULL,NULL,1,273.865375,-44.06439,0.581,NULL,51005453336,796960208,12452503,13.5),(142655,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142655,34.54,0.53,80.8,68813,70,NULL,NULL,'2MASX J18153889-5836496',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,273.912083,-58.61378,0.345,NULL,48958657038,764979016,11952797,14.9),(142656,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142656,37.23,0.55,279,68814,70,NULL,NULL,'2MASX J18155395-6458321',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.4,NULL,NULL,NULL,NULL,NULL,1,273.974875,-64.97558,0.317,NULL,48938743000,764667859,11947935,13.9),(142657,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142657,30.55,0.43,12.9,68815,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 084-030',NULL,'2014MNRAS.444..527S',2014,1,0.6,NULL,'G',0.000037,NULL,'14.7',0.3,'Sc;HSB',NULL,NULL,NULL,NULL,1,273.9927083,13.78533,0.693,NULL,53874769238,841793269,13153019,14.7),(142658,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142658,36.97,0.55,248,68816,70,NULL,NULL,'2MASX J18160366-6439310',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,274.01525,-64.65856,0.321,NULL,48938658620,764666540,11947914,15.8),(142659,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142659,33.2,0.8,43.6,68817,75,NULL,'MAT, I','IC 4682',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.000021,NULL,'13.23',1.6,'(R\')SB(rs)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,274.107125,-71.58131,0.533,NULL,48459427673,757178557,11830914,13.23),(142660,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142660,32.85,NULL,37.2,68817,NULL,NULL,'B','IC 4682',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142661,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142661,32.85,NULL,37.2,68817,NULL,NULL,'I','IC 4682',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142662,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142662,33.01,0.47,40.1,68817,NULL,NULL,'H','IC 4682',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142663,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142663,33.01,0.46,40.1,68817,NULL,NULL,'J','IC 4682',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142664,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142664,33.04,0.45,40.6,68817,NULL,NULL,'K','IC 4682',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142665,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142665,33.15,0.43,42.7,68817,75,NULL,'MAT, I, raw','IC 4682',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142666,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142666,33.3,0.32,45.7,68817,85,NULL,'I, raw','IC 4682',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142667,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142667,33.36,0.4,46.9,68817,NULL,NULL,'mean','IC 4682',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142668,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142668,33.37,0.32,47.3,68817,85,NULL,'I, inv','IC 4682',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142669,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142669,33.44,0.43,48.7,68817,75,NULL,'MAT, I, inv','IC 4682',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142670,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142670,33.48,0.43,49.7,68817,75,NULL,'MAT, I, cor','IC 4682',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142671,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142671,33.68,0.08,54.6,68817,NULL,NULL,NULL,'IC 4682',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142672,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142672,35.94,0.64,154,68818,70,NULL,NULL,'2MASX J18163769-6903128',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,274.157167,-69.05358,0.437,NULL,48454989520,757109211,11829831,15.7),(142673,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142673,35.96,0.6,155,68819,70,NULL,NULL,'2MASX J18165031-4215264',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,274.2095417,-42.25733,0.473,NULL,47519525642,742492588,11601446,15.4),(142674,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142674,36.89,0.59,239,68820,70,NULL,NULL,'2MASX J18170775-7340018',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,274.282583333,-73.66719,0.585,NULL,48512162242,758002535,11843789,16.9),(142675,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142675,33.7,0.43,55,68821,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11188',NULL,'2014MNRAS.444..527S',2014,1,1.28,NULL,'G',0.000011,NULL,'15.8',0.16,'Sd',NULL,NULL,NULL,NULL,1,274.373625,18.90364,0.953,NULL,54566306935,852598545,13321852,15.8),(142676,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142676,33.92,0.49,60.8,68821,75,NULL,'IR','UGC 11188',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142677,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142677,34.56,NULL,81.6,68821,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11188',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142678,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142678,34.57,NULL,82,68821,NULL,NULL,'Dipole + Quadrupole','UGC 11188',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142679,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142679,34.57,NULL,82.2,68821,NULL,NULL,'Dipole','UGC 11188',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142680,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142680,34.62,NULL,84.1,68821,NULL,NULL,NULL,'UGC 11188',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142681,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142681,36.4,0.67,191,68822,70,NULL,NULL,'2MASX J18173170-6921195',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,274.38225,-69.3555,0.349,NULL,48455086739,757110730,11829855,15.6),(142682,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142682,36.03,0.73,161,68823,70,NULL,NULL,'2MASX J18174773-7140157',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,274.449167,-71.67111,0.533,NULL,48459953852,757186778,11831043,17.3),(142683,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142683,33.98,0.2,62.5,68824,74.4,NULL,NULL,'UGC 11194',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.000023,NULL,'14.05',0.9,'SBbc',NULL,NULL,NULL,NULL,1,274.486667,26.75722,0.541,NULL,54358156070,849346188,13271034,14.05),(142684,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142684,33.99,0.43,62.7,68824,75,NULL,'3.6 micron, color corrected','UGC 11194',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142685,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142685,34.06,0.43,64.9,68824,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11194',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142686,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142686,34.08,0.32,65.5,68824,NULL,NULL,NULL,'UGC 11194',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142687,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142687,34.13,0.31,67,68824,NULL,NULL,'Malmquist cor.','UGC 11194',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142688,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142688,33.87,0.47,59.5,68825,70,NULL,NULL,'MC 1805-833',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,274.4982083,-83.36144,0.545,NULL,48359647424,755619491,11806554,14.8),(142689,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142689,31.68,0.43,21.7,68826,75,NULL,'3.6 micron, color + selection bias corrected','ESO 182-IG 010',NULL,'2014MNRAS.444..527S',2014,1,1.9,NULL,'G',0.000003,NULL,'13.63',1.4,'SAB(r)bc',NULL,NULL,NULL,NULL,1,274.6275417,-54.69439,0.445,NULL,48887650719,763869542,11935461,13.63),(142690,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142690,33.56,0.4,51.5,68826,NULL,NULL,'mean','ESO 182-IG 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142691,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142691,33.7,0.47,54.9,68826,NULL,NULL,'H','ESO 182-IG 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142692,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142692,36.78,0.55,227,68827,70,NULL,NULL,'2MASX J18184165-7147368',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,274.6735417,-71.7935,0.533,NULL,48458130289,757158285,11830598,14.8),(142693,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142693,34.35,NULL,74.1,68828,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2198',NULL,'2010Ap&SS.325..163P',2010,1,0.75,NULL,'G',NULL,NULL,'17.31',0.09,'Scd',NULL,NULL,NULL,NULL,1,274.737917,52.90472,0.161,NULL,52927963690,826999432,12921866,17.31),(142694,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142694,34.37,NULL,74.9,68828,NULL,NULL,'Dipole + Quadrupole','FGC 2198',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142695,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142695,34.39,NULL,75.6,68828,NULL,NULL,'Dipole','FGC 2198',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142696,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142696,34.61,NULL,83.6,68828,NULL,NULL,NULL,'FGC 2198',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142697,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2000dm',NULL,142697,34,0.21,62.2,68829,70,NULL,'SALT 2','UGC 11198',0.01507,'2013MNRAS.433.2240G',2013,1,1.1,NULL,'G',0.000066,NULL,'13.5B',0.2,'Sab',NULL,NULL,NULL,NULL,1,274.746625,16.24956,0.973,NULL,53879888497,841873257,13154269,13.5),(142698,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',142698,34.38,0.49,75,68829,75,NULL,'IR','UGC 11198',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142699,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142699,34.79,0.5,90.7,68830,70,NULL,NULL,'ESO 280- G 009',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000143,NULL,'13.2R',0.5,'(R\'_1)SAB(s)a',NULL,NULL,NULL,NULL,1,274.831167,-42.63083,0.497,NULL,51012398027,797068719,12454198,13.2),(142700,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142700,34.18,0.4,68.4,68831,NULL,NULL,'mean','NGC 6623',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'GPair',0.000103,NULL,NULL,NULL,'E',NULL,NULL,NULL,NULL,1,274.92875,23.70556,0.645,NULL,54298747336,848417927,13256530,NULL),(142701,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142701,34.48,0.45,78.6,68831,NULL,NULL,'K','NGC 6623',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142702,'HII region diameter','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',142702,33.39,NULL,47.7,68832,NULL,NULL,NULL,'NGC 6643',NULL,'1988ApL&C..27...41S',1988,1,3.8,NULL,'G',0.000005,NULL,'11.73',1.9,'SA(rs)c','Isolated galaxy',NULL,NULL,NULL,1,274.943375,74.56836,0.217,NULL,52721928815,823780137,12871564,11.73),(142703,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142703,31.96,0.8,24.6,68832,75,NULL,'A82, H','NGC 6643',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142704,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142704,30.94,NULL,15.4,68832,75,NULL,'CO','NGC 6643',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142705,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142705,31.05,NULL,16.2,68832,75,NULL,'HI','NGC 6643',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142706,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142706,31.12,0.69,16.7,68832,100,NULL,'mid-IR','NGC 6643',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142707,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142707,31.22,0.4,17.5,68832,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 6643',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142708,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142708,31.36,0.4,18.7,68832,NULL,NULL,'mean','NGC 6643',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142709,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142709,31.43,0.46,19.3,68832,NULL,NULL,'J','NGC 6643',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142710,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142710,31.45,0.45,19.5,68832,NULL,NULL,'K','NGC 6643',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142711,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142711,31.46,0.43,19.6,68832,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6643',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142712,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142712,31.51,0.47,20.1,68832,75,NULL,'A82, H, raw','NGC 6643',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142713,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142713,31.53,0.43,20.2,68832,75,NULL,'3.6 micron, color corrected','NGC 6643',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142714,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142714,31.57,0.38,20.6,68832,NULL,NULL,NULL,'NGC 6643',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142715,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142715,31.63,0.47,21.2,68832,75,NULL,'A82, H, inv','NGC 6643',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142716,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142716,31.64,0.2,21.3,68832,74.4,NULL,NULL,'NGC 6643',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142717,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142717,31.8,0.54,22.9,68832,NULL,NULL,NULL,'NGC 6643',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142718,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142718,31.81,0.47,23,68832,75,NULL,'A82, H, cor','NGC 6643',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142719,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142719,31.84,0.53,23.4,68832,NULL,NULL,'Malmquist cor.','NGC 6643',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142720,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142720,32.04,0.4,25.5,68832,75,NULL,'B','NGC 6643',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142721,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142721,36.8,0.61,229,68833,70,NULL,NULL,'2MASX J18195219-6435205',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,274.967625,-64.58906,0.333,NULL,48935413086,764615829,11947122,15.1),(142722,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142722,34.22,0.8,69.8,68834,75,NULL,'MAT, I','ESO 230- G 002',NULL,'1997ApJS..109..333W',1997,1,1.95,'Stars superposed.','G',0.000033,NULL,'13.81',0.2,'Sc',NULL,NULL,NULL,NULL,1,275.001708333,-51.53928,0.409,NULL,48919767740,764371370,11943302,13.81),(142723,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142723,33.82,0.32,58,68834,85,NULL,'I, raw','ESO 230- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142724,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142724,33.84,0.32,58.5,68834,85,NULL,'I, inv','ESO 230- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142725,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142725,33.88,0.43,59.6,68834,75,NULL,'MAT, I, raw','ESO 230- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142726,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',142726,33.94,0.49,61.3,68834,75,NULL,'IR','ESO 230- G 002',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142727,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142727,33.99,0.43,62.9,68834,75,NULL,'MAT, I, inv','ESO 230- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142728,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142728,34.14,0.43,67.2,68834,75,NULL,'MAT, I, cor','ESO 230- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142729,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142729,34.14,NULL,67.2,68834,NULL,NULL,NULL,'ESO 230- G 002',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142730,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142730,34.22,0.45,69.8,68834,NULL,NULL,'Malmquist cor.','ESO 230- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142731,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142731,34.26,NULL,71.1,68834,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 230- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142732,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142732,34.27,NULL,71.4,68834,NULL,NULL,'Dipole + Quadrupole','ESO 230- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142733,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142733,34.27,NULL,71.5,68834,NULL,NULL,'Dipole','ESO 230- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142734,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142734,34.44,0.41,77.2,68834,NULL,NULL,NULL,'ESO 230- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142735,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142735,34.48,0.2,78.7,68834,74.4,NULL,NULL,'ESO 230- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142736,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142736,34.63,0.48,84.5,68835,70,NULL,NULL,'2MASX J18200383-4407442',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,275.0160417,-44.12897,0.477,NULL,51017194742,797143667,12455369,14.2),(142737,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142737,33.91,0.8,60.5,68836,75,NULL,'HMCL, I','IC 4696',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.000022,NULL,'13.47',0.9,'SAB(rs)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,275.074625,-64.73408,0.365,NULL,48935337484,764614648,11947103,13.47),(142738,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142738,33.91,0.8,60.6,68836,75,NULL,'MAT, I','IC 4696',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142739,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142739,32.92,0.4,38.4,68836,75,NULL,'HMCL, I, raw','IC 4696',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142740,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142740,33.11,0.4,41.9,68836,75,NULL,'HMCL, I, inv','IC 4696',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142741,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142741,33.26,0.4,44.9,68836,75,NULL,'HMCL, I, cor','IC 4696',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142742,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142742,33.48,0.32,49.7,68836,85,NULL,'I, raw','IC 4696',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142743,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142743,33.49,0.46,50,68836,NULL,NULL,'J','IC 4696',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142744,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142744,33.51,0.43,50.3,68836,75,NULL,'MAT, I, raw','IC 4696',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142745,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142745,33.55,0.32,51.3,68836,85,NULL,'I, inv','IC 4696',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142746,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142746,33.57,0.45,51.7,68836,NULL,NULL,'K','IC 4696',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142747,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142747,33.58,0.47,51.9,68836,NULL,NULL,'H','IC 4696',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142748,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142748,33.78,0.43,56.9,68836,75,NULL,'MAT, I, cor','IC 4696',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142749,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142749,33.8,0.43,57.5,68836,75,NULL,'MAT, I, inv','IC 4696',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142750,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142750,33.95,0.4,61.6,68836,NULL,NULL,'mean','IC 4696',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142751,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142751,34.03,0.08,64.1,68836,NULL,NULL,NULL,'IC 4696',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142752,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142752,33.84,0.8,58.5,68837,75,NULL,'MAT, I','IC 4698',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000033,NULL,'15.31',0.3,'Sb:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,275.2497083,-63.34794,0.329,NULL,48978844484,765294445,11957725,15.31),(142753,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142753,33.84,0.8,58.6,68837,75,NULL,'HMCL, I','IC 4698',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142754,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142754,33.39,0.32,47.6,68837,85,NULL,'I, raw','IC 4698',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142755,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142755,33.4,0.32,47.9,68837,85,NULL,'I, inv','IC 4698',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142756,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142756,33.44,0.4,48.8,68837,75,NULL,'HMCL, I, raw','IC 4698',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142757,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142757,33.52,0.4,50.7,68837,75,NULL,'HMCL, I, inv','IC 4698',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142758,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',142758,33.54,0.49,51.1,68837,75,NULL,'IR','IC 4698',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142759,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142759,33.58,0.43,52,68837,75,NULL,'MAT, I, raw','IC 4698',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142760,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142760,33.69,0.43,54.6,68837,75,NULL,'MAT, I, inv','IC 4698',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142761,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142761,33.7,0.4,55,68837,75,NULL,'HMCL, I, cor','IC 4698',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142762,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142762,33.83,0.43,58.2,68837,75,NULL,'MAT, I, cor','IC 4698',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142763,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142763,33.9,0.12,60.4,68837,NULL,NULL,NULL,'IC 4698',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142764,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142764,35.71,0.6,138,68838,70,NULL,NULL,'2MASX J18210575-5115500',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,275.273875,-51.26394,0.313,NULL,48921878151,764404346,11943817,14.5),(142765,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142765,34.83,0.68,92.4,68839,70,NULL,NULL,'2MASX J18210765-7641418',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000087,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,275.281875,-76.69503,0.721,NULL,48483476230,757554316,11836786,14.6),(142766,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142766,36.14,0.51,169,68840,70,NULL,NULL,'2MASX J18212253-4715119',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,275.343916667,-47.25333,0.377,NULL,51009137955,797017780,12453402,15.3),(142767,'D-Sigma','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142767,33.49,0.4,49.8,68841,75,NULL,'Edat, raw','NGC 6557',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.00015,NULL,'14.3',1.1,'SA(r)0^0^',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,275.353417,-76.58297,0.721,NULL,48483363197,757552549,11836758,14.3),(142768,'D-Sigma','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142768,33.82,0.4,58.1,68841,75,NULL,'Edat, cor','NGC 6557',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142769,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142769,33.61,0.48,52.8,68841,70,NULL,NULL,'NGC 6557',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142770,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142770,33.97,0.45,62.1,68841,NULL,NULL,'K','NGC 6557',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142771,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142771,34.25,0.4,70.9,68841,NULL,NULL,'mean','NGC 6557',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142772,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',142772,34,0.49,63.2,68842,75,NULL,'IR','NGC 6636 NED01',NULL,'2011yCatp016004901K',2011,1,2.2,'UZC has V = 3995 +- 37 km/sec.','G',0.000083,NULL,'14',0.4,'Sc             Sy2','Pair member (points to parent)',NULL,NULL,NULL,1,275.511958333,66.61656,0.241,NULL,53018982532,828421602,12944087,14),(142773,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142773,33.81,NULL,57.9,68843,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11210',NULL,'2010Ap&SS.325..163P',2010,1,1.38,NULL,'G',0.000017,NULL,'17.',0.1,'Sd',NULL,NULL,NULL,NULL,1,275.532125,21.17739,0.901,NULL,54570612451,852665819,13322903,17),(142774,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142774,33.83,NULL,58.3,68843,NULL,NULL,'Dipole + Quadrupole','UGC 11210',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142775,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142775,33.83,NULL,58.4,68843,NULL,NULL,'Dipole','UGC 11210',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142776,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',142776,33.8,0.49,57.6,68844,75,NULL,'IR','ESO 024- G 014',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'14.13',0.3,'S...',NULL,NULL,NULL,NULL,1,275.5559583,-80.16572,0.369,NULL,48355466118,755554158,11805533,14.13),(142777,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142777,34.3,0.49,72.3,68844,NULL,NULL,NULL,'ESO 024- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142778,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142778,34.34,0.2,73.8,68844,74.4,NULL,NULL,'ESO 024- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142779,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142779,34.43,0.46,76.9,68844,NULL,NULL,'Malmquist cor.','ESO 024- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142780,'Tully est','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142780,32.37,0.8,29.8,68845,75,NULL,'B','NGC 6438',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.00007,NULL,'12.10',1.3,'S0 pec (Ring A)','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,275.572833,-85.40206,0.341,NULL,48327776276,755121504,11798773,12.1),(142781,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142781,34.68,NULL,86.1,68846,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 395- G 002',NULL,'2010Ap&SS.325..163P',2010,1,2.45,NULL,'G',0.000037,NULL,'15.1',0.35,'Sc',NULL,NULL,NULL,NULL,1,275.609917,-35.67792,0.537,NULL,47558456408,743100881,11610951,15.1),(142782,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142782,34.68,NULL,86.3,68846,NULL,NULL,'Dipole','ESO 395- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142783,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142783,34.68,NULL,86.4,68846,NULL,NULL,'Dipole + Quadrupole','ESO 395- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142784,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142784,36.44,0.55,194,68847,70,NULL,NULL,'2MFGC 14370',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,275.62675,-48.56169,0.373,NULL,48866990129,763546720,11930417,15.1),(142785,'Tully est','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142785,32.45,0.8,30.9,68848,75,NULL,NULL,'NGC 6438A',NULL,'1988NBGC.C....0000T',1988,1,2.7,NULL,'G',0.000097,NULL,'12.57',1,'S pec (Ring B)','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,275.647875,-85.40633,0.341,NULL,48327599248,755118738,11798730,12.57),(142786,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142786,33.53,0.25,49.9,68849,74.2,NULL,'SALT 2','NGC 6627',0.01757,'2010ApJ...716..712A',2010,1,1.3,NULL,'G',0.000025,NULL,'14.3',1.1,'(R\')SB(s)b',NULL,NULL,NULL,NULL,1,275.662166667,15.698,1.101,NULL,53879291127,841863923,13154123,14.3),(142787,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142787,33.69,0.2,53.6,68849,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','NGC 6627',0.01757,'2011A&A...526A..81B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142788,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142788,34.11,0.19,65.3,68849,70,NULL,'SALT 2','NGC 6627',0.01757,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142789,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142789,34.08,0.08,65.5,68849,74.4,NULL,NULL,'NGC 6627',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142790,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142790,34.19,0.08,67.6,68849,72,NULL,NULL,'NGC 6627',0.01757,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142791,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142791,34.19,0.29,67.7,68849,70,NULL,'SALT','NGC 6627',0.01757,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142792,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142792,34.21,0.18,68.2,68849,73.8,NULL,'SALT 2 (SNANA)','NGC 6627',0.0174,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142793,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142793,34.22,0.13,68.5,68849,70,NULL,NULL,'NGC 6627',0.01757,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142794,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142794,34.23,0.19,68.9,68849,72,NULL,NULL,'NGC 6627',0.01757,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142795,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142795,34.34,0.21,72.6,68849,65,NULL,'MLCS31','NGC 6627',0.01757,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142796,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142796,34.35,0.32,72.8,68849,65,NULL,'SALT','NGC 6627',0.01757,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142797,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142797,34.35,0.06,72.9,68849,70,NULL,'SALT 2','NGC 6627',0.01757,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142798,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142798,34.35,0.2,73,68849,65,NULL,'MLCS17','NGC 6627',0.01757,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142799,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142799,34.4,0.1,73.1,68849,65,NULL,'MLCS2k2','NGC 6627',0.01757,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142800,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142800,34.36,0.1,73.2,68849,65,NULL,'MLCS2k2','NGC 6627',0.01757,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142801,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142801,34.33,0.17,73.5,68849,70.8,NULL,NULL,'NGC 6627',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142802,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142802,34.4,0.23,74.7,68849,65,NULL,'SALT2','NGC 6627',0.01757,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142803,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142803,34.47,0.23,77,68849,65,NULL,NULL,'NGC 6627',0.01757,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142804,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142804,34.48,0.02,77.2,68849,65,NULL,'SALT','NGC 6627',0.01757,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142805,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142805,34.63,0.14,84.3,68849,60,NULL,NULL,'NGC 6627',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142806,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142806,34.35,0.47,74.2,68850,70,NULL,NULL,'IC 4702',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00015,NULL,'14.01',1,'(R)SB(r)0/a',NULL,NULL,NULL,NULL,1,275.765917,-59.23894,0.329,NULL,48970192031,765159250,11955613,14.01),(142807,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2007co',NULL,142807,34.59,0.17,80.6,68851,74.2,NULL,'SALT 2','CGCG 172-029',0.026962,'2010ApJ...716..712A',2010,1,0.8,NULL,'G',0.00011,NULL,'14.9',0.8,NULL,NULL,NULL,NULL,NULL,1,275.767208333,29.90139,0.437,NULL,54463662187,850994721,13296792,14.9),(142808,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2007co',NULL,142808,35.17,0.09,108,68851,74.4,NULL,NULL,'CGCG 172-029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142809,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2007co',NULL,142809,35.35,0.15,114,68851,73.8,NULL,'SALT 2 (SNANA)','CGCG 172-029',0.0271,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142810,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2007co',NULL,142810,35.37,0.03,115,68851,72,NULL,'MLCS31','CGCG 172-029',0.026962,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142811,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2007co',NULL,142811,35.38,0.17,116,68851,65,NULL,'MLCS31','CGCG 172-029',0.026962,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142812,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2007co',NULL,142812,35.38,0.1,116,68851,72,NULL,'MLCS2k2, R(V) = 3.1','CGCG 172-029',0.026962,'2010ApJ...721.1608B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142813,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2007co',NULL,142813,35.4,0.16,117,68851,70,NULL,'SALT 2','CGCG 172-029',0.026962,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142814,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2007co',NULL,142814,35.42,0.17,118,68851,65,NULL,'SALT','CGCG 172-029',0.026962,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142815,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2007co',NULL,142815,35.42,0.16,118,68851,65,NULL,'MLCS17','CGCG 172-029',0.026962,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142816,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2007co',NULL,142816,35.42,0.08,118,68851,72,NULL,'MLCS2k2, R(V) = 1.7','CGCG 172-029',0.026962,'2010ApJ...721.1608B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142817,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2007co',NULL,142817,35.48,0.19,121,68851,65,NULL,'SALT2','CGCG 172-029',0.026962,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142818,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2007co',NULL,142818,36.06,0.04,159,68851,70,NULL,'SALT 2','CGCG 172-029',0.026962,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142819,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142819,34.87,0.56,94,68852,70,NULL,NULL,'ESO 024-IG 015 NED02',NULL,'2014MNRAS.445.2677S',2014,1,NULL,'1979MNRAS.188..349F has z = 0.0045? +- 0.007.','G',0.00015,NULL,'14.4R',NULL,'Bright nucleus',NULL,NULL,NULL,NULL,1,275.778833,-77.69697,0.649,NULL,48472694606,757385853,11834153,14.4),(142820,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142820,34.49,0.8,79,68853,75,NULL,'MAT, I','ESO 280- G 013',NULL,'1997ApJS..109..333W',1997,1,2.9,NULL,'G',0.000013,NULL,'11.74',0.6,'Sb',NULL,NULL,NULL,NULL,1,275.824417,-43.14253,0.413,NULL,51012639834,797072497,12454257,11.74),(142821,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142821,33.84,0.43,58.7,68853,75,NULL,'MAT, I, raw','ESO 280- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142822,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142822,33.97,0.47,62.3,68853,NULL,NULL,'H','ESO 280- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142823,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142823,34.01,0.46,63.2,68853,NULL,NULL,'J','ESO 280- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142824,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142824,34.03,0.45,64.1,68853,NULL,NULL,'K','ESO 280- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142825,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',142825,34.17,0.49,68.3,68853,75,NULL,'IR','ESO 280- G 013',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142826,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142826,34.18,0.43,68.5,68853,75,NULL,'MAT, I, inv','ESO 280- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142827,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142827,34.21,0.32,69.5,68853,85,NULL,'I, raw','ESO 280- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142828,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142828,34.21,0.31,69.5,68853,NULL,NULL,NULL,'ESO 280- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142829,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142829,34.25,0.43,70.7,68853,75,NULL,'MAT, I, cor','ESO 280- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142830,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142830,34.25,0.2,70.8,68853,74.4,NULL,NULL,'ESO 280- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142831,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142831,34.3,0.32,72.3,68853,85,NULL,'I, inv','ESO 280- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142832,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142832,34.35,0.29,74,68853,NULL,NULL,'Malmquist cor.','ESO 280- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142833,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142833,34.43,0.4,76.8,68853,NULL,NULL,'mean','ESO 280- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142834,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',142834,33.56,0.49,51.5,68854,75,NULL,'IR','UGC 11225',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000017,NULL,'15.48',0.2,'Sdm:',NULL,NULL,NULL,NULL,1,275.836125,60.75606,0.161,NULL,53045583976,828837249,12950582,15.48),(142835,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142835,33.83,0.8,58.4,68855,75,NULL,'MAT, I','ESO 045- G 004',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000024,NULL,'13.36',1,'SAB(rs)cd',NULL,NULL,NULL,NULL,1,275.8429583,-72.73894,0.325,NULL,48458620045,757165938,11830717,13.36),(142836,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142836,33.95,0.32,61.7,68855,85,NULL,'I, raw','ESO 045- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142837,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142837,33.98,0.32,62.5,68855,85,NULL,'I, inv','ESO 045- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142838,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142838,33.99,0.43,62.8,68855,75,NULL,'MAT, I, raw','ESO 045- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142839,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142839,34.06,0.1,65,68855,NULL,NULL,NULL,'ESO 045- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142840,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142840,34.12,0.43,66.7,68855,75,NULL,'MAT, I, inv','ESO 045- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142841,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142841,34.16,0.43,67.8,68855,75,NULL,'MAT, I, cor','ESO 045- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142842,'Tully est','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142842,31.98,0.8,24.9,68856,75,NULL,NULL,'UGC 11220',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000017,NULL,'17.',1.3,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,275.85625,40.94528,0.161,NULL,54236288898,847442014,13241281,17),(142843,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142843,34.66,0.55,85.6,68857,70,NULL,NULL,'2MASX J18233691-7111511',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,275.903833333,-71.19747,0.513,NULL,48469161164,757330643,11833291,16.1),(142844,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142844,37.14,0.65,268,68858,70,NULL,NULL,'2MASX J18233722-7042251',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,275.905333,-70.70694,0.489,NULL,48468521364,757320646,11833135,17),(142845,'BL Lac Luminosity','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142845,39.12,NULL,667,68859,NULL,NULL,'Min. z = 0.17','NVSS J182338-345412',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'RadioS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,275.910875,-34.90333,NULL,NULL,47555487537,743054492,11610226,NULL),(142846,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142846,36.77,0.72,226,68860,70,NULL,NULL,'2MASX J18235542-6144311',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,275.981,-61.74189,0.453,NULL,48979154673,765299291,11957801,15.8),(142847,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',142847,34.51,0.49,79.9,68861,75,NULL,'IR','UGC 11230',NULL,'2011yCatp016004901K',2011,1,2.52,NULL,'G',0.000027,NULL,'16.0',0.15,'Sc',NULL,NULL,NULL,NULL,1,276.010041667,65.30625,0.173,NULL,53032510942,828632983,12947390,16),(142848,'BL Lac Luminosity','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142848,43.06,NULL,2460,68862,NULL,NULL,NULL,'[HB89] 1823+568',0.664,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.001,NULL,'18.4',NULL,'FSRQ           BLLAC',NULL,NULL,'radio jet','Flat-Spectrum Radio Source',1,276.029458333,56.85042,0.229,NULL,53115141554,829924086,12967563,18.4),(142849,'Tully est','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142849,32.35,0.8,29.5,68863,75,NULL,'B','NGC 6654',NULL,'1988NBGC.C....0000T',1988,1,2.6,NULL,'G',0.000033,NULL,'13.0',2.1,'(R\')SB(s)0/a','Isolated galaxy',NULL,NULL,NULL,1,276.031541667,73.18322,0.197,NULL,52736605859,824009466,12875147,13),(142850,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142850,35.66,0.48,136,68864,NULL,NULL,NULL,'ESO 024- G 016',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'13.56',0.4,'S...',NULL,NULL,NULL,NULL,1,276.035083,-78.69228,0.629,NULL,48537042098,758391282,11849863,13.56),(142851,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142851,35.7,0.47,138,68864,NULL,NULL,'Malmquist cor.','ESO 024- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142852,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142852,35.7,0.2,138,68864,74.4,NULL,NULL,'ESO 024- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142853,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142853,33.83,0.69,58.4,68865,100,NULL,'mid-IR','NGC 6651',NULL,'2013ApJ...771...88L',2013,1,1.6,'NGC 6651 is misidentified in CGCG and UGC.  NED follows MCG and RC2.','G',0.00002,NULL,'13.76',0.7,'SA(r)c',NULL,NULL,NULL,NULL,1,276.082125,71.60192,0.173,NULL,52693415601,823334618,12864603,13.76),(142854,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142854,34.14,0.43,67.4,68865,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6651',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142855,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142855,34.19,0.43,69,68865,75,NULL,'3.6 micron, color corrected','NGC 6651',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142856,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142856,34.32,0.47,73,68865,NULL,NULL,'H','NGC 6651',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142857,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142857,34.32,0.45,73.1,68865,NULL,NULL,'K','NGC 6651',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142858,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142858,34.32,0.2,73.1,68865,74.4,NULL,NULL,'NGC 6651',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142859,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142859,34.35,0.4,74.1,68865,NULL,NULL,'mean','NGC 6651',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142860,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142860,34.36,0.46,74.4,68865,NULL,NULL,'J','NGC 6651',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142861,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142861,34.36,0.54,74.6,68865,NULL,NULL,NULL,'NGC 6651',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142862,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142862,34.41,0.53,76.1,68865,NULL,NULL,'Malmquist cor.','NGC 6651',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142863,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142863,33.41,0.69,48.1,68866,100,NULL,'mid-IR','ESO 395-G 004',NULL,'2013ApJ...771...88L',2013,1,1.2,'abs(b) < 10 degrees.','G',0.00003,NULL,'15.8',0.7,'Sbc',NULL,NULL,NULL,NULL,1,276.0972917,-34.18183,NULL,NULL,47736048322,745875755,11654308,15.8),(142864,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142864,35.86,0.68,149,68867,70,NULL,NULL,'2MASX J18243117-6135329',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.7I',0.4,NULL,NULL,NULL,NULL,NULL,1,276.129875,-61.5925,0.453,NULL,48979207415,765300115,11957814,13.7),(142865,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142865,36.15,0.56,170,68868,70,NULL,NULL,'2MASX J18244364-6808369',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,276.182083,-68.1435,0.409,NULL,49194039568,768656868,12010263,15.3),(142866,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142866,36.5,0.72,199,68869,70,NULL,NULL,'2MASX J18244910-4950392',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,276.2045417,-49.84431,0.485,NULL,48911736253,764245878,11941341,15.6),(142867,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142867,33.8,0.36,57.7,68870,NULL,NULL,NULL,'ESO 140- G 021',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.49',0.3,'S...',NULL,NULL,NULL,NULL,1,276.2477917,-60.061,0.373,NULL,48966955031,765108672,11954823,15.49),(142868,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142868,33.85,0.2,58.9,68870,74.4,NULL,NULL,'ESO 140- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142869,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142869,33.92,0.34,60.8,68870,NULL,NULL,'Malmquist cor.','ESO 140- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142870,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142870,33.98,0.46,62.5,68871,NULL,NULL,'J','NGC 6632',NULL,'2007A&A...465...71T',2007,1,3,NULL,'G',0.000027,NULL,'12.94',1.4,'SA(rs)bc',NULL,NULL,NULL,NULL,1,276.262875,27.53531,0.517,NULL,54344971936,849140186,13267815,12.94),(142871,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142871,34.03,0.47,63.9,68871,NULL,NULL,'H','NGC 6632',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142872,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142872,34.06,0.45,64.7,68871,NULL,NULL,'K','NGC 6632',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142873,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142873,34.17,0.4,68.1,68871,NULL,NULL,'mean','NGC 6632',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142874,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142874,34,0.47,63.2,68872,70,NULL,NULL,'NGC 6614',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000073,NULL,'13.77',1.1,'SB(s)0-:','Group member, radial-velocity confirmed',NULL,NULL,'Flat-Spectrum Radio Source',1,276.2800417,-63.24836,0.413,NULL,48978914586,765295540,11957742,13.77),(142875,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142875,34.09,0.25,65.8,68872,74.4,NULL,NULL,'NGC 6614',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142876,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142876,33.89,0.4,60,68872,NULL,NULL,'mean','NGC 6614',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142877,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142877,34.35,0.45,74,68872,NULL,NULL,'K','NGC 6614',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142878,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142878,36.11,0.69,167,68873,70,NULL,NULL,'2MASX J18252958-6452410',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,276.37325,-64.87808,0.353,NULL,48935552609,764618009,11947156,15.8),(142879,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142879,34.04,NULL,64.2,68874,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11231',NULL,'2010Ap&SS.325..163P',2010,1,0.81,NULL,'G',NULL,NULL,'17.',0.11,'Sdm',NULL,NULL,NULL,NULL,1,276.409583,29.3755,0.517,NULL,54463199098,850987485,13296679,17),(142880,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142880,34.08,NULL,65.5,68874,NULL,NULL,'Dipole + Quadrupole','UGC 11231',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142881,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142881,34.09,NULL,65.7,68874,NULL,NULL,'Dipole','UGC 11231',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142882,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142882,36.24,0.5,177,68875,70,NULL,NULL,'2MASX J18254825-6230400',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,276.451,-62.51108,0.389,NULL,48979524867,765305076,11957891,14.8),(142883,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142883,38.74,NULL,561,68876,65,NULL,'L = 10e57 photons/s','3B 920711',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,276.5375,73.37972,0.189,NULL,52738767688,824043245,12875675,NULL),(142884,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142884,41.5,NULL,2000,68876,65,NULL,'L = 2 x 10e58 photons/s','3B 920711',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142885,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142885,34,0.43,63.2,68877,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2203',NULL,'2014MNRAS.444..527S',2014,1,0.9,NULL,'G',0.000006,NULL,'16.6',0.12,'Scd',NULL,NULL,NULL,NULL,1,276.567917,25.33167,0.561,NULL,54351491166,849242049,13269407,16.6),(142886,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142886,34.2,NULL,69.2,68877,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2203',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142887,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142887,34.21,NULL,69.4,68877,NULL,NULL,'Dipole + Quadrupole','FGC 2203',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142888,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142888,34.21,NULL,69.4,68877,NULL,NULL,'Dipole','FGC 2203',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142889,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142889,34.3,NULL,72.3,68877,NULL,NULL,NULL,'FGC 2203',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142890,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142890,36.78,0.6,227,68878,70,NULL,NULL,'2MASX J18264019-5123189',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,276.667417,-51.38864,0.281,NULL,48922328078,764411376,11943927,15.3),(142891,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142891,35.64,0.71,135,68879,70,NULL,NULL,'2MASX J18270503-6429511',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,276.771125,-64.49747,0.405,NULL,48935127272,764611363,11947052,14.3),(142892,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142892,33.82,0.48,58.1,68880,70,NULL,NULL,'2MASX J18270752-6243302',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000053,NULL,'13.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,276.781291667,-62.72508,0.417,NULL,48985814687,765403354,11959427,13.4),(142893,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142893,36.8,0.61,229,68881,70,NULL,NULL,'2MASX J18270910-3503105',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1R',0.4,'with *   poss. LINER',NULL,NULL,NULL,NULL,1,276.788,-35.05289,0.453,NULL,47555173969,743049593,11610149,14.1),(142894,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142894,34.08,0.2,65.5,68882,74.4,NULL,NULL,'UGC 11237',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000033,NULL,'14.7',0.8,'Scd:',NULL,NULL,NULL,NULL,1,276.8214583,24.88492,0.629,NULL,54318648377,848728880,13261388,14.7),(142895,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142895,34.25,0.35,70.7,68882,NULL,NULL,'Malmquist cor.','UGC 11237',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142896,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142896,34.25,0.35,70.8,68882,NULL,NULL,NULL,'UGC 11237',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142897,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142897,35.37,0.68,119,68883,70,NULL,NULL,'2MASX J18272441-7704385',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,276.851333,-77.07744,0.677,NULL,48485167844,757580747,11837199,14.8),(142898,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142898,33.98,0.52,62.4,68884,70,NULL,NULL,'2MASX J18273402-6100482',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00007,NULL,'13.8R',0.7,'SA0-:',NULL,NULL,NULL,NULL,1,276.89175,-61.01358,0.441,NULL,48966647580,765103868,11954747,13.8),(142899,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142899,36.02,0.5,160,68885,70,NULL,NULL,'2MASX J18273604-5127357',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,276.9000417,-51.45992,0.281,NULL,48922259542,764410305,11943911,14.5),(142900,'SGRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142900,43.01,NULL,4010,68886,70,NULL,'Photometric Distance, Host A, M(R) = -20 mag and spectral slope Beta = 1.0 ','GRB 060919',NULL,'2012A&A...545A..77R',2012,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,276.923917,-51.01456,0.229,NULL,48921604644,764400072,11943751,NULL),(142901,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142901,33.69,0.48,54.7,68887,70,NULL,NULL,'ESO 182- G 017',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'14.36',0.3,'S0: sp',NULL,NULL,NULL,NULL,1,276.965917,-53.21006,0.265,NULL,48908119214,764189362,11940458,14.36),(142902,'D-Sigma','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142902,32.96,0.4,39.1,68888,75,NULL,'Edat, raw','IC 4704',NULL,'1997ApJS..109..333W',1997,1,2.9,NULL,'G',0.00004,NULL,'13.17',2.2,'SA(s)0^-','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,276.9735,-71.60986,0.085,NULL,48465975856,757280872,11832513,13.17),(142903,'D-Sigma','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142903,33.2,0.4,43.6,68888,75,NULL,'Edat, cor','IC 4704',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142904,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142904,33.09,0.45,41.5,68888,NULL,NULL,'K','IC 4704',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142905,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142905,33.58,0.4,52,68888,NULL,NULL,'mean','IC 4704',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142906,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142906,34.23,0.1,70.3,68889,NULL,NULL,NULL,'ESO 182- G 016',NULL,'2009ApJS..182..474S',2009,1,1.23,NULL,'G',0.000033,NULL,'16.21',0.11,'Sd',NULL,NULL,NULL,NULL,1,277.010083,-57.30017,0.353,NULL,49105932357,767280193,11988753,16.21),(142907,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',142907,34.45,0.49,77.5,68889,75,NULL,'IR','ESO 182- G 016',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142908,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142908,34.85,NULL,93.3,68889,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 182- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142909,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142909,34.86,NULL,93.9,68889,NULL,NULL,'Dipole + Quadrupole','ESO 182- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142910,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142910,34.88,NULL,94.6,68889,NULL,NULL,'Dipole','ESO 182- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142911,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142911,34.91,0.49,95.9,68890,70,NULL,NULL,'2MASX J18280401-3643235',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000117,NULL,'13.5R',0.3,NULL,NULL,NULL,NULL,NULL,1,277.0167083,-36.72322,0.561,NULL,47565859750,743216558,11612758,13.5),(142912,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142912,34.27,NULL,71.5,68891,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11243',NULL,'2010Ap&SS.325..163P',2010,1,1.23,NULL,'G',0.000113,NULL,'17.',0.11,'Sd;LSB',NULL,NULL,NULL,NULL,1,277.025083,22.71044,0.685,NULL,54614227076,853347298,13333551,17),(142913,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142913,34.27,NULL,71.6,68891,NULL,NULL,'Dipole','UGC 11243',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142914,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142914,34.28,NULL,71.6,68891,NULL,NULL,'Dipole + Quadrupole','UGC 11243',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142915,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142915,34.93,NULL,96.7,68891,NULL,NULL,NULL,'UGC 11243',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142916,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142916,34.56,0.47,81.5,68892,NULL,NULL,'H','NGC 6640',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000057,NULL,'14.18',0.8,'Scd:',NULL,NULL,NULL,NULL,1,277.0344583,34.30267,0.261,NULL,54467398183,851053096,13297704,14.18),(142917,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142917,34.58,0.46,82.3,68892,NULL,NULL,'J','NGC 6640',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142918,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142918,34.66,0.45,85.7,68892,NULL,NULL,'K','NGC 6640',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142919,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142919,34.75,0.4,89.1,68892,NULL,NULL,'mean','NGC 6640',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142920,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142920,35.52,0.54,127,68893,70,NULL,NULL,'2MASX J18281784-7709311',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000127,NULL,'13.2R',NULL,'D',NULL,NULL,NULL,NULL,1,277.0744583,-77.15869,0.677,NULL,48485110119,757579845,11837185,13.2),(142921,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142921,34.57,0.34,82,68894,70,NULL,'H, 2MASS','UGC 11246',NULL,'2011A&A...531A..87I',2011,1,1.1,NULL,'G',0.00005,NULL,'14.9',0.4,'Sab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,277.0995,22.73689,0.685,NULL,54614223561,853347243,13333550,14.9),(142922,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142922,34.6,0.34,83.2,68894,70,NULL,'H, UH88/IRSF/2MASS','UGC 11246',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142923,'TRGB','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142923,29.34,0.1,7.38,68895,74.4,NULL,NULL,'IC 4710',NULL,'2013AJ....146...86T',2013,1,3.6,NULL,'G',0.000007,NULL,'12.5',2.8,'SB(s)m         HII','Possible group member',NULL,NULL,NULL,1,277.1582083,-66.98228,0.377,NULL,49192924008,768639437,12009991,12.5),(142924,'Tully est','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142924,29.75,0.8,8.9,68895,75,NULL,'B','IC 4710',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142925,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142925,35.83,0.55,146,68896,70,NULL,NULL,'2MASX J18284087-3444034',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.6R',0.1,NULL,NULL,NULL,NULL,NULL,1,277.170375,-34.73428,0.473,NULL,47555076993,743048078,11610126,15.6),(142926,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142926,34.16,0.8,67.8,68897,75,NULL,'CF, r','UGC 11252',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.00024,NULL,'14.83',0.5,'Scd:',NULL,NULL,NULL,NULL,1,277.174916667,48.24319,0.221,NULL,52886562021,826352531,12911758,14.83),(142927,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142927,33.75,0.38,56.1,68897,75,NULL,'CF, r, raw','UGC 11252',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142928,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142928,33.85,0.38,58.8,68897,75,NULL,'CF, r, inv','UGC 11252',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142929,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142929,33.86,0.47,59,68897,NULL,NULL,'H','UGC 11252',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142930,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142930,34.01,0.46,63.3,68897,NULL,NULL,'J','UGC 11252',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142931,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142931,34.03,0.45,63.8,68897,NULL,NULL,'K','UGC 11252',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142932,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142932,34.09,0.38,65.7,68897,75,NULL,'CF, r, cor','UGC 11252',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142933,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142933,34.09,0.4,65.7,68897,NULL,NULL,'mean','UGC 11252',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142934,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142934,34.64,0.63,84.6,68898,NULL,NULL,'Malmquist cor.','ESO 182- G 018',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.11',0.5,'S...',NULL,NULL,NULL,NULL,1,277.209667,-52.89242,0.213,NULL,48908527232,764195738,11940558,15.11),(142935,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142935,34.87,0.57,94.4,68898,NULL,NULL,NULL,'ESO 182- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142936,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142936,34.92,0.2,96.4,68898,74.4,NULL,NULL,'ESO 182- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142937,'D-Sigma','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142937,32.96,0.4,39.1,68899,75,NULL,'Edat, raw','ESO 071- G 013',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.00015,NULL,'13.76',1,'SAB:(rl)0^0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,277.2147917,-72.09214,0,NULL,48466045458,757281960,11832530,13.76),(142938,'D-Sigma','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142938,33.2,0.4,43.6,68899,75,NULL,'Edat, cor','ESO 071- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142939,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142939,32.7,0.49,34.7,68899,70,NULL,NULL,'ESO 071- G 013',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142940,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142940,33.12,0.4,42.1,68899,NULL,NULL,'mean','ESO 071- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142941,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142941,33.21,0.45,43.9,68899,NULL,NULL,'K','ESO 071- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142942,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',142942,34.91,0.49,96.2,68900,75,NULL,'IR','UGC 11255',NULL,'2011yCatp016004901K',2011,1,1.49,NULL,'G',NULL,NULL,'15.54',0.17,'Sc',NULL,NULL,NULL,NULL,1,277.2394583,51.65103,0.153,NULL,52947987144,827312299,12926754,15.54),(142943,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142943,35.09,NULL,104,68900,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11255',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142944,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142944,35.1,NULL,105,68900,NULL,NULL,'Dipole + Quadrupole','UGC 11255',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142945,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142945,35.11,NULL,105,68900,NULL,NULL,'Dipole','UGC 11255',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142946,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142946,35.24,NULL,112,68900,NULL,NULL,NULL,'UGC 11255',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142947,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142947,35.35,0.38,117,68900,NULL,NULL,'Malmquist cor.','UGC 11255',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142948,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142948,35.35,0.43,117,68900,75,NULL,'3.6 micron, color corrected','UGC 11255',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142949,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142949,35.41,0.43,121,68900,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11255',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142950,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142950,35.43,0.2,122,68900,74.4,NULL,NULL,'UGC 11255',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142951,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142951,35.49,0.35,126,68900,NULL,NULL,NULL,'UGC 11255',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142952,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142952,35.35,0.53,117,68901,70,NULL,NULL,'2MASX J18293588-7114468',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,277.399625,-71.24633,0.469,NULL,48469110690,757329854,11833278,14.9),(142953,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142953,33.96,0.4,61.8,68902,NULL,NULL,'mean','UGC 11253',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000067,NULL,'15.7',0.15,'Sc;HSB',NULL,NULL,NULL,NULL,1,277.415291667,23.06858,0.677,NULL,54598138368,853095912,13329623,15.7),(142954,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',142954,34.11,0.49,66.4,68902,75,NULL,'IR','UGC 11253',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142955,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142955,34.3,0.45,72.4,68902,NULL,NULL,'K','UGC 11253',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142956,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142956,34.35,0.47,74,68902,NULL,NULL,'H','UGC 11253',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142957,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142957,33.5,NULL,50.2,68903,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11254',NULL,'2010Ap&SS.325..163P',2010,1,1.74,NULL,'G',0.000005,NULL,'16.10',0.16,'Scd',NULL,NULL,NULL,NULL,1,277.425083333,30.43797,0.525,NULL,54483257014,851300890,13301576,16.1),(142958,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142958,33.51,NULL,50.4,68903,NULL,NULL,'Dipole + Quadrupole','UGC 11254',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142959,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142959,33.52,NULL,50.6,68903,NULL,NULL,'Dipole','UGC 11254',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142960,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142960,33.58,NULL,52.1,68903,NULL,NULL,NULL,'UGC 11254',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142961,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142961,33.71,0.43,55.1,68903,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11254',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142962,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142962,33.85,0.43,58.8,68903,75,NULL,'3.6 micron, color corrected','UGC 11254',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142963,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142963,33.87,0.2,59.4,68903,74.4,NULL,NULL,'UGC 11254',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142964,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142964,33.95,0.39,61.7,68903,NULL,NULL,NULL,'UGC 11254',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142965,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142965,34.11,0.36,66.5,68903,NULL,NULL,'Malmquist cor.','UGC 11254',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142966,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142966,36.03,0.54,160,68904,70,NULL,NULL,'2MASX J18294221-7706043',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000107,NULL,'13.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,277.426167,-77.10119,0.677,NULL,48485135031,757580234,11837191,13.4),(142967,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142967,34.63,0.46,84.4,68905,NULL,NULL,'J','ESO 281- G 001',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.00003,NULL,'15',0.9,'(R\'_1)SB(rl)a',NULL,NULL,NULL,NULL,1,277.4365,-42.75325,0.417,NULL,51014710200,797104846,12454763,15),(142968,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142968,34.65,0.4,85.3,68905,NULL,NULL,'mean','ESO 281- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142969,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142969,34.67,0.47,85.9,68905,NULL,NULL,'H','ESO 281- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142970,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142970,34.68,0.45,86.4,68905,NULL,NULL,'K','ESO 281- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142971,'SGRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142971,42.93,NULL,3860,68906,70,NULL,'Photometric Distance, Host A, M(R) = -20 mag and spectral slope Beta = 1.0 ','GRB 070517',NULL,'2012A&A...545A..77R',2012,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,277.620625,-62.2975,0.509,NULL,48987729394,765433271,11959894,NULL),(142972,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142972,35.95,0.53,155,68907,70,NULL,NULL,'2MASX J18302531-5146372',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,277.605375,-51.77706,0.281,NULL,48920983533,764390367,11943599,15),(142973,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2001br',NULL,142973,34.96,0.18,96.3,68908,70,NULL,'SALT 2','UGC 11260',0.020628,'2013MNRAS.433.2240G',2013,1,1,NULL,'G',0.00016,NULL,'15.20',0.8,'SBa',NULL,NULL,NULL,NULL,1,277.605875,34.10281,0.241,NULL,54475712954,851183014,13299734,15.2),(142974,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2001br','R',142974,35.02,0.07,101,68908,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 11260',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142975,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2001br','R',142975,35.03,0.06,101,68908,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 11260',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142976,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142976,36.14,0.62,169,68909,70,NULL,NULL,'2MASX J18302832-6443153',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,277.617917,-64.72089,0.365,NULL,48928578837,764509044,11945453,15.8),(142977,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142977,35.88,0.76,150,68910,70,NULL,NULL,'2MASX J18303499-4141524',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,277.6457083,-41.69797,0.461,NULL,51012144549,797064758,12454136,15.2),(142978,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142978,34.61,0.2,83.6,68911,74.4,NULL,NULL,'UGC 11262',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.00012,NULL,'15.20',0.6,'Sd',NULL,NULL,NULL,NULL,1,277.648875,42.69275,0.181,NULL,54768934603,855764603,13371321,15.2),(142979,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142979,34.67,0.31,85.8,68911,NULL,NULL,NULL,'UGC 11262',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142980,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142980,34.76,0.3,89.5,68911,NULL,NULL,'Malmquist cor.','UGC 11262',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142981,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142981,32.98,0.4,39.5,68912,75,NULL,'B','NGC 6667',NULL,'1988NBGC.C....0000T',1988,1,2.3,NULL,'G',0.00002,NULL,'13.55',1.1,'SABab? pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,277.6657917,67.98703,0.305,NULL,53554412601,836787696,13074807,13.55),(142982,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142982,33.04,0.4,40.5,68912,NULL,NULL,'mean','NGC 6667',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142983,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142983,33.17,0.43,43,68912,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6667',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142984,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142984,33.17,0.43,43.1,68912,75,NULL,'3.6 micron, color corrected','NGC 6667',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142985,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142985,33.24,0.45,44.6,68912,NULL,NULL,'K','NGC 6667',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142986,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142986,33.26,0.2,44.9,68912,74.4,NULL,NULL,'NGC 6667',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142987,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142987,33.26,0.4,44.9,68912,NULL,NULL,NULL,'NGC 6667',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142988,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142988,33.31,0.47,45.9,68912,NULL,NULL,'H','NGC 6667',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142989,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142989,33.35,0.46,46.8,68912,NULL,NULL,'J','NGC 6667',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142990,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142990,34.96,0.48,98,68913,70,NULL,NULL,'2MASX J18304409-4552149',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000107,NULL,'14.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,277.683583333,-45.87083,0.133,NULL,51008323960,797005061,12453204,14.2),(142991,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142991,35.99,0.71,158,68914,70,NULL,NULL,'2MASX J18305477-6020002',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,277.72825,-60.33339,0.393,NULL,48967844307,765122567,11955040,15.3),(142992,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142992,33.8,0.8,57.5,68915,75,NULL,'HMCL, I','IC 4714',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000117,NULL,'15.08',0.3,'Scd? sp','Possible group member',NULL,NULL,NULL,1,277.7322917,-66.65175,0.353,NULL,48928707133,764511048,11945485,15.08),(142993,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',142993,33.06,0.49,40.9,68915,75,NULL,'IR','IC 4714',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142994,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142994,33.18,0.4,43.2,68915,75,NULL,'HMCL, I, raw','IC 4714',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142995,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142995,33.22,0.4,44,68915,75,NULL,'HMCL, I, inv','IC 4714',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142996,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142996,33.49,0.4,49.9,68915,75,NULL,'HMCL, I, cor','IC 4714',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142997,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142997,36.53,0.55,202,68916,70,NULL,NULL,'2MASX J18305756-5143167',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,277.7397083,-51.72133,0.281,NULL,48920957212,764389956,11943593,14.4),(142998,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142998,33.33,0.8,46.4,68917,75,NULL,'MAT, I','IC 4712',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.000033,NULL,'12.97',1.2,'SA(rs)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,277.778833,-71.69367,0.085,NULL,48465540264,757274066,11832407,12.97),(142999,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',142999,32.69,NULL,34.5,68917,NULL,NULL,'B','IC 4712',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143000,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',143000,32.69,NULL,34.5,68917,NULL,NULL,'I','IC 4712',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143001,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143001,33.13,0.46,42.2,68917,NULL,NULL,'J','IC 4712',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143002,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143002,33.19,0.45,43.5,68917,NULL,NULL,'K','IC 4712',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143003,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143003,33.27,0.32,45,68917,85,NULL,'I, raw','IC 4712',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143004,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143004,33.29,0.47,45.6,68917,NULL,NULL,'H','IC 4712',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143005,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143005,33.33,0.32,46.3,68917,85,NULL,'I, inv','IC 4712',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143006,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143006,33.42,0.43,48.3,68917,75,NULL,'MAT, I, raw','IC 4712',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143007,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143007,33.44,0.4,48.7,68917,NULL,NULL,'mean','IC 4712',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143008,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143008,33.62,0.07,53.1,68917,NULL,NULL,NULL,'IC 4712',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143009,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143009,33.69,0.43,54.7,68917,75,NULL,'MAT, I, inv','IC 4712',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143010,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143010,33.73,0.43,55.7,68917,75,NULL,'MAT, I, cor','IC 4712',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143011,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143011,36.22,0.52,175,68918,70,NULL,NULL,'2MASX J18310860-4808197',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,277.785875,-48.13875,0.241,NULL,51007541370,796992833,12453013,15.6),(143012,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143012,36.2,0.69,174,68919,70,NULL,NULL,'2MASX J18312211-5215456',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,277.842167,-52.26258,0.273,NULL,48906952291,764171129,11940173,15.7),(143013,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143013,35.95,NULL,155,68920,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2209',NULL,'2010Ap&SS.325..163P',2010,1,0.87,NULL,'G',NULL,NULL,'16.8',0.08,'Sd',NULL,NULL,NULL,NULL,1,277.902083,50.35472,0.221,NULL,52944636904,827259951,12925936,16.8),(143014,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143014,35.98,NULL,157,68920,NULL,NULL,'Dipole + Quadrupole','FGC 2209',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143015,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143015,35.99,NULL,158,68920,NULL,NULL,NULL,'FGC 2209',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143016,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143016,36,NULL,158,68920,NULL,NULL,'Dipole','FGC 2209',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143017,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143017,36.91,0.62,241,68921,70,NULL,NULL,'2MASX J18314286-6019422',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,277.928417,-60.32842,0.357,NULL,48967859883,765122810,11955043,15.5),(143018,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143018,34.17,0.8,68.1,68922,75,NULL,'CF, r','UGC 11264',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000053,NULL,'14.96',0.5,'Sbc',NULL,NULL,NULL,NULL,1,277.941875,31.08983,0.461,NULL,54482775306,851293364,13301458,14.96),(143019,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143019,33.99,0.38,62.7,68922,75,NULL,'CF, r, raw','UGC 11264',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143020,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143020,34.05,0.38,64.7,68922,75,NULL,'CF, r, inv','UGC 11264',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143021,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143021,34.23,0.38,70,68922,75,NULL,'CF, r, cor','UGC 11264',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143022,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143022,34.49,0.47,79.1,68923,70,NULL,NULL,'2MASX J18314901-5550106',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000057,NULL,'13.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,277.95425,-55.83631,0.361,NULL,49099905094,767186017,11987281,13.8),(143023,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143023,34.43,0.47,77,68924,NULL,NULL,'H','ESO 457- G 015',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.00002,NULL,'13.3R',0.7,'SA(r)bc?       HII',NULL,NULL,NULL,NULL,1,277.983416667,-31.79522,0.705,NULL,47778492333,746538942,11664670,13.3),(143024,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143024,34.44,0.46,77.2,68924,NULL,NULL,'J','ESO 457- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143025,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143025,34.54,0.45,80.9,68924,NULL,NULL,'K','ESO 457- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143026,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143026,34.58,0.4,82.6,68924,NULL,NULL,'mean','ESO 457- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143027,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143027,34.97,0.29,98.7,68925,NULL,NULL,'Malmquist cor.','UGC 11268',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000023,NULL,'14.64',0.5,'Sbc',NULL,NULL,NULL,NULL,1,278.028875,37.61358,0.133,NULL,54262787260,847856050,13247750,14.64),(143028,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143028,35.36,0.24,118,68925,NULL,NULL,NULL,'UGC 11268',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143029,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143029,35.4,0.2,120,68925,74.4,NULL,NULL,'UGC 11268',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143030,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143030,36.25,0.54,178,68926,70,NULL,NULL,'2MASX J18320801-7105306',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,278.033375,-71.09186,0.469,NULL,48466791099,757293610,11832712,15.1),(143031,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'RN',143031,45.57,0.57,5680,68927,72,NULL,NULL,'GRB 050126 OA',1.29002,'2008JCAP...07..004M',2008,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143032,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'N',143032,45.71,0.57,6060,68927,70,NULL,NULL,'GRB 050126 OA',1.29002,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143033,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'N',143033,45.74,0.52,6140,68927,69.7,NULL,'Calibrated','GRB 050126 OA',1.29002,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143034,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'N',143034,46.33,0.55,8060,68927,69.7,NULL,'Fiducial','GRB 050126 OA',1.29002,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143035,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143035,37.23,0.62,279,68928,70,NULL,NULL,'2MASX J18322937-6017262',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,278.122417,-60.29058,0.357,NULL,48967900431,765123444,11955053,13.9),(143036,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2005nc','R',143036,42.58,0.33,2040,68929,72,NULL,'SN 2005nc','GRB 050525',0.61,'2010JCAP...08..020W',2010,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,278.13575,26.33961,0.609,NULL,54313392126,848646751,13260105,NULL),(143037,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2005nc','R',143037,43.27,0.43,2800,68929,72,NULL,NULL,'GRB 050525',0.61,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143038,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2005nc',NULL,143038,43.28,0.37,2810,68929,69.7,NULL,'Calibrated','GRB 050525',0.61,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143039,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2005nc',NULL,143039,43.34,0.42,2890,68929,70,NULL,NULL,'GRB 050525',0.61,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143040,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2005nc',NULL,143040,43.55,0.44,3190,68929,69.7,NULL,'Fiducial','GRB 050525',0.61,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143041,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',143041,42.72,0.13,3500,68929,NULL,NULL,NULL,'GRB 050525',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143042,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',143042,42.83,0.07,3680,68929,NULL,NULL,NULL,'GRB 050525',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143043,'Tully est','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143043,32.72,0.8,35.1,68930,75,NULL,NULL,'ESO 140- G 023',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000017,NULL,'13.34',1.1,'SB(s)d',NULL,NULL,NULL,NULL,1,278.1714583,-57.67089,0.349,NULL,49106165932,767283842,11988810,13.34),(143044,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143044,36.97,0.57,248,68931,70,NULL,NULL,'2MFGC 14452',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,278.2165,-55.23383,0.409,NULL,49102254143,767222720,11987855,15.6),(143045,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143045,33.08,0.43,41.4,68932,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11295',NULL,'2014MNRAS.444..527S',2014,1,1.4,NULL,'G',0.000017,NULL,'16.5',0.16,'Sdm',NULL,NULL,NULL,NULL,1,278.281333,75.40025,0.285,NULL,52720221815,823753465,12871147,16.5),(143046,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143046,33.14,NULL,42.6,68932,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11295',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143047,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143047,33.15,NULL,42.6,68932,NULL,NULL,'Dipole + Quadrupole','UGC 11295',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143048,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143048,33.16,NULL,42.9,68932,NULL,NULL,'Dipole','UGC 11295',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143049,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',143049,34.88,0.49,94.7,68933,75,NULL,'IR','NGC 6676',NULL,'2011yCatp016004901K',2011,1,1.6,'Haynes, et al. (1999AJ....117.2039H) give v = 6798 km/sec.','G',0.000123,NULL,'15.20',0.3,'Sbc',NULL,NULL,NULL,NULL,1,278.2915,66.95906,0.361,NULL,53559218724,836862792,13075981,15.2),(143050,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143050,35.16,0.4,108,68933,NULL,NULL,'mean','NGC 6676',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143051,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143051,35.26,0.47,113,68933,NULL,NULL,'H','NGC 6676',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143052,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143052,35.41,0.45,121,68933,NULL,NULL,'K','NGC 6676',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143053,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143053,35.43,0.46,122,68933,NULL,NULL,'J','NGC 6676',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143054,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',143054,35.15,0.49,107,68934,75,NULL,'IR','UGC 11277',NULL,'2011yCatp016004901K',2011,1,1.34,NULL,'G',NULL,NULL,'16.3',0.11,'Sbc',NULL,NULL,NULL,NULL,1,278.2979583,52.94875,0.185,NULL,52936259417,827129053,12923891,16.3),(143055,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143055,35.35,NULL,117,68934,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11277',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143056,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143056,35.36,NULL,118,68934,NULL,NULL,'Dipole + Quadrupole','UGC 11277',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143057,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143057,35.37,NULL,119,68934,NULL,NULL,'Dipole','UGC 11277',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143058,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143058,35.39,NULL,120,68934,NULL,NULL,NULL,'UGC 11277',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143059,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143059,32.83,0.8,36.9,68935,75,NULL,'MAT, I','IC 4717',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.3',0.3,'Sb? sp',NULL,NULL,NULL,NULL,1,278.321875,-57.97572,0.353,NULL,49105088370,767267005,11988546,14.3),(143060,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143060,33.22,0.43,44.1,68935,75,NULL,'MAT, I, raw','IC 4717',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143061,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143061,33.27,0.32,45,68935,85,NULL,'I, raw','IC 4717',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143062,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143062,33.33,0.32,46.3,68935,85,NULL,'I, inv','IC 4717',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143063,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',143063,33.47,0.49,49.5,68935,75,NULL,'IR','IC 4717',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143064,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143064,33.48,0.43,49.6,68935,75,NULL,'MAT, I, inv','IC 4717',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143065,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143065,33.55,0.43,51.2,68935,75,NULL,'MAT, I, cor','IC 4717',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143066,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143066,33.58,0.36,52,68935,NULL,NULL,NULL,'IC 4717',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143067,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143067,33.62,0.2,53,68935,74.4,NULL,NULL,'IC 4717',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143068,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143068,33.66,0.35,54,68935,NULL,NULL,'Malmquist cor.','IC 4717',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143069,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143069,35.32,0.52,116,68936,70,NULL,NULL,'2MASX J18331806-4239225',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,278.325166667,-42.65622,0.409,NULL,51013497940,797085905,12454467,14.9),(143070,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143070,31.84,0.8,23.4,68937,75,NULL,'MAT, I','IC 4720',NULL,'1997ApJS..109..333W',1997,1,2.5,'Confused HIPASS source','G',0.000018,NULL,'13.61',0.9,'SB(rs)cd:','in a pair',NULL,NULL,NULL,1,278.385417,-58.40536,0.393,NULL,49097130776,767142668,11986604,13.61),(143071,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143071,30.85,0.32,14.8,68937,85,NULL,'I, inv','IC 4720',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143072,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143072,30.87,0.32,14.9,68937,85,NULL,'I, raw','IC 4720',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143073,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143073,31.1,0.43,16.6,68937,75,NULL,'MAT, I, raw','IC 4720',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143074,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143074,31.11,0.43,16.7,68937,75,NULL,'MAT, I, inv','IC 4720',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143075,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143075,31.48,0.43,19.8,68937,75,NULL,'MAT, I, cor','IC 4720',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143076,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143076,31.8,0.64,22.9,68937,NULL,NULL,NULL,'IC 4720',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143077,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143077,31.84,0.2,23.3,68937,74.4,NULL,NULL,'IC 4720',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143078,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143078,31.84,0.63,23.4,68937,NULL,NULL,'Malmquist cor.','IC 4720',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143079,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',143079,34.67,0.49,86.1,68938,75,NULL,'IR','UGC 11275',NULL,'2011yCatp016004901K',2011,1,1.95,NULL,'G',0.000009,NULL,'16.5',0.11,'Scd',NULL,NULL,NULL,NULL,1,278.4149583,32.13967,0.369,NULL,54477155086,851205548,13300086,16.5),(143080,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143080,34.95,NULL,97.5,68938,NULL,NULL,'Dipole','UGC 11275',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143081,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143081,34.95,NULL,97.8,68938,NULL,NULL,'Dipole + Quadrupole','UGC 11275',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143082,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143082,34.95,NULL,97.9,68938,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11275',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143083,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143083,35.02,NULL,101,68938,NULL,NULL,NULL,'UGC 11275',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143084,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143084,35.06,0.31,103,68938,NULL,NULL,'Malmquist cor.','UGC 11275',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143085,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143085,35.15,0.2,107,68938,74.4,NULL,NULL,'UGC 11275',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143086,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143086,35.17,0.43,108,68938,75,NULL,'3.6 micron, color corrected','UGC 11275',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143087,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143087,35.32,0.43,116,68938,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11275',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143088,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143088,35.42,0.26,122,68938,NULL,NULL,NULL,'UGC 11275',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143089,'G Lens','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143089,40.21,NULL,1100,68939,NULL,NULL,NULL,'PKS 1830-21 GAL',NULL,'1995ApJ...444..561v',1995,1,NULL,'This galaxy lenses the QSO PKS 1830-21.','G',0.000001,NULL,'22.6',NULL,'Sb or Sc',NULL,NULL,NULL,NULL,1,278.4162083,-21.06106,NULL,NULL,48244959163,753827486,11778554,22.6),(143090,'G Lens','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143090,41.41,0.68,1910,68939,NULL,NULL,NULL,'PKS 1830-21 GAL',NULL,'2007ApJ...660....1O',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143091,'G Lens','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143091,42.03,NULL,2550,68939,NULL,NULL,'R(H) = ct','PKS 1830-21 GAL',NULL,'2014ApJ...788..190W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143092,'G Lens','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143092,42.09,NULL,2620,68939,NULL,NULL,'Standard','PKS 1830-21 GAL',NULL,'2014ApJ...788..190W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143093,'G Lens','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143093,43.69,0.76,5480,68939,NULL,NULL,NULL,'PKS 1830-21 GAL',NULL,'2014MNRAS.437..600S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143094,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143094,35.12,0.8,106,68940,75,NULL,'MAT, I','ESO 281- G 008',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'12.16',0.8,'(R\')SB?(ls)0/a?',NULL,NULL,NULL,NULL,1,278.417458333,-46.7515,0.221,NULL,51010623582,797040993,12453765,12.16),(143095,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143095,33.25,0.43,44.7,68940,75,NULL,'MAT, I, raw','ESO 281- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143096,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143096,33.44,0.43,48.7,68940,75,NULL,'MAT, I, inv','ESO 281- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143097,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143097,33.5,0.32,50.2,68940,85,NULL,'I, raw','ESO 281- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143098,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143098,33.55,0.32,51.3,68940,85,NULL,'I, inv','ESO 281- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143099,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143099,33.72,0.43,55.5,68940,75,NULL,'MAT, I, cor','ESO 281- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143100,'D-Sigma','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143100,33.81,0.4,57.8,68941,75,NULL,'Edat, raw','IC 4718',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.0001,NULL,'13.78',0.9,'Sb:',NULL,NULL,NULL,NULL,1,278.459,-60.12911,0.301,NULL,48968283507,765129429,11955147,13.78),(143101,'D-Sigma','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143101,33.85,0.4,58.8,68941,75,NULL,'Edat, cor','IC 4718',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143102,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143102,32.49,0.4,31.5,68942,75,NULL,'B','IC 1291',NULL,'1988NBGC.C....0000T',1988,1,1.8,NULL,'G',0.000004,NULL,'13.54',1.5,'SB(s)dm?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,278.4690417,49.27861,0.265,NULL,52940648363,827197630,12924962,13.54),(143103,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143103,37.14,0.57,268,68943,70,NULL,NULL,'2MASX J18335382-5213199',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,278.474375,-52.22219,0.285,NULL,48907079081,764173110,11940204,15.5),(143104,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143104,35.45,0.25,123,68944,74.4,NULL,NULL,'GIN 655',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000107,NULL,'14.11',NULL,'E',NULL,NULL,NULL,NULL,1,278.5204583,51.41344,0.165,NULL,52946615702,827290870,12926419,14.11),(143105,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143105,35.66,0.27,135,68944,70,NULL,NULL,'GIN 655',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143106,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143106,34.77,0.43,90,68945,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6662',NULL,'2014MNRAS.444..527S',2014,1,1.6,NULL,'G',0.00004,NULL,'14.59',0.5,'SBab?','Group member',NULL,NULL,NULL,1,278.546583,32.06458,0.385,NULL,54476965965,851202593,13300040,14.59),(143107,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143107,34.98,0.6,99.3,68946,NULL,NULL,'Malmquist cor.','ESO 281- G 011',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.22',0.7,'SAB(rs)b',NULL,NULL,NULL,NULL,1,278.568833333,-46.759,0.221,NULL,51010628526,797041070,12453766,14.22),(143108,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143108,34.99,0.6,99.5,68946,NULL,NULL,NULL,'ESO 281- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143109,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143109,35.03,0.2,101,68946,74.4,NULL,NULL,'ESO 281- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143110,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143110,32.03,0.8,25.4,68947,75,NULL,'MAT, I','IC 4721',NULL,'1997ApJS..109..333W',1997,1,5.2,'Confused HIPASS source','G',0.00001,NULL,'12.38',1.5,'SAB(rs)c','in a pair',NULL,NULL,NULL,1,278.603166667,-58.49661,0.393,NULL,49097141688,767142838,11986606,12.38),(143111,'Tully est','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143111,32.3,0.8,28.8,68947,75,NULL,'B','IC 4721',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143112,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143112,30.97,0.36,15.6,68947,NULL,NULL,NULL,'IC 4721',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143113,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143113,31.29,0.32,18.1,68947,85,NULL,'I, raw','IC 4721',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143114,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143114,31.32,0.32,18.4,68947,85,NULL,'I, inv','IC 4721',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143115,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143115,31.37,0.43,18.8,68947,75,NULL,'MAT, I, raw','IC 4721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143116,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143116,31.47,0.43,19.7,68947,75,NULL,'3.6 micron, color corrected','IC 4721',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143117,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143117,31.48,0.2,19.8,68947,74.4,NULL,NULL,'IC 4721',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143118,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143118,31.48,0.4,19.8,68947,73,NULL,'opt','IC 4721',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143119,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143119,31.49,0.43,19.9,68947,75,NULL,'3.6 micron, color + selection bias corrected','IC 4721',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143120,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143120,31.53,0.43,20.2,68947,75,NULL,'MAT, I, inv','IC 4721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143121,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143121,31.79,0.43,22.8,68947,75,NULL,'MAT, I, cor','IC 4721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143122,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143122,31.84,0.46,23.4,68947,NULL,NULL,'J','IC 4721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143123,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143123,31.89,0.47,23.9,68947,NULL,NULL,'H','IC 4721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143124,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143124,32.04,0.45,25.5,68947,NULL,NULL,'K','IC 4721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143125,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143125,32.23,0.4,28,68947,NULL,NULL,'mean','IC 4721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143126,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143126,34.59,1.01,82.9,68948,NULL,NULL,'Malmquist cor.','ESO 045- G 008',NULL,'2009ApJS..182..474S',2009,1,1.23,NULL,'G',0.000033,NULL,'14.08',0.17,'Sb',NULL,NULL,NULL,NULL,1,278.608291667,-72.894,0.329,NULL,48513647799,758025746,11844152,14.08),(143127,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143127,35.02,NULL,101,68948,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 045- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143128,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143128,35.02,0.83,101,68948,NULL,NULL,NULL,'ESO 045- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143129,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143129,35.03,NULL,101,68948,NULL,NULL,'Dipole + Quadrupole','ESO 045- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143130,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143130,35.05,NULL,102,68948,NULL,NULL,'Dipole','ESO 045- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143131,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143131,35.06,0.2,103,68948,74.4,NULL,NULL,'ESO 045- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143132,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143132,34.01,0.8,63.3,68949,75,NULL,'MAT, I','IC 4722',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'13.64',1.2,'SA(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,278.631375,-57.79278,0.629,NULL,49103294874,767238982,11988109,13.64),(143133,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143133,32.55,0.32,32.4,68949,85,NULL,'I, raw','IC 4722',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143134,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143134,32.58,0.32,32.8,68949,85,NULL,'I, inv','IC 4722',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143135,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143135,32.78,0.43,36,68949,75,NULL,'MAT, I, raw','IC 4722',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143136,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143136,32.94,0.43,38.8,68949,75,NULL,'MAT, I, inv','IC 4722',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143137,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143137,33.16,0.43,42.9,68949,75,NULL,'MAT, I, cor','IC 4722',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143138,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143138,33.12,0.69,42.1,68950,100,NULL,'mid-IR','NGC 6660',NULL,'2013ApJ...771...88L',2013,1,1.7,NULL,'G',0.000073,NULL,'13.05',1.1,'SA(s)0/a','in a pair',NULL,NULL,NULL,1,278.652791667,22.90967,0.721,NULL,54600846417,853138225,13330284,13.05),(143139,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',143139,34.84,0.49,93.1,68951,75,NULL,'IR','UGC 11287',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',NULL,NULL,'14.9',1.2,'Sc','Isolated galaxy',NULL,NULL,NULL,1,278.689417,47.03503,0.253,NULL,54769786635,855777916,13371529,14.9),(143140,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143140,30.43,0.8,12.2,68952,75,NULL,'A82, H','NGC 6689',NULL,'1997ApJS..109..333W',1997,1,3.8,NULL,'G',0.000003,NULL,'13.1',1.3,'SBcd           HII','Isolated galaxy',NULL,NULL,NULL,1,278.709375,70.52392,0.177,NULL,52686885544,823232586,12863009,13.1),(143141,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143141,30.43,0.4,12.2,68952,75,NULL,'B','NGC 6689',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143142,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143142,30.54,0.4,12.8,68952,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 6689',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143143,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143143,30.59,0.38,13.1,68952,NULL,NULL,NULL,'NGC 6689',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143144,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143144,30.62,0.2,13.3,68952,74.4,NULL,NULL,'NGC 6689',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143145,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143145,30.64,0.43,13.4,68952,75,NULL,'3.6 micron, color corrected','NGC 6689',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143146,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143146,30.66,0.43,13.5,68952,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6689',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143147,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143147,30.72,0.47,13.9,68952,75,NULL,'A82, H, inv','NGC 6689',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143148,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143148,30.77,0.45,14.2,68952,NULL,NULL,'Malmquist cor.','NGC 6689',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143149,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143149,30.79,0.47,14.4,68952,75,NULL,'A82, H, raw','NGC 6689',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143150,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143150,30.88,0.43,15,68952,NULL,NULL,NULL,'NGC 6689',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143151,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143151,31.1,0.47,16.6,68952,75,NULL,'A82, H, cor','NGC 6689',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143152,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143152,35.82,0.56,146,68953,70,NULL,NULL,'2MASX J18353191-7550062',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,278.8827917,-75.83514,0.469,NULL,48482882225,757545034,11836641,14.8),(143153,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143153,35,0.58,100,68954,NULL,NULL,'Malmquist cor.','ESO 281- G 012',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'13.02',0.6,'SAB(rs)a       NELG',NULL,NULL,NULL,NULL,1,278.890083333,-46.94342,0.233,NULL,51007208205,796987628,12452931,13.02),(143154,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143154,35.19,0.53,109,68954,NULL,NULL,NULL,'ESO 281- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143155,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143155,35.23,0.2,111,68954,74.4,NULL,NULL,'ESO 281- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143156,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143156,35.94,0.63,154,68955,70,NULL,NULL,'2MASX J18353580-7724042',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,278.899,-77.40125,0.673,NULL,48484834507,757575539,11837117,14.9),(143157,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143157,32.98,0.69,39.4,68956,100,NULL,'mid-IR','UGC 11289',NULL,'2013ApJ...771...88L',2013,1,1.5,NULL,'G',0.00002,NULL,'14.1',1,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,278.947917,22.47058,0.773,NULL,54600485067,853132579,13330196,14.1),(143158,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143158,33.56,0.43,51.4,68956,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11289',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143159,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143159,33.89,0.4,60.1,68956,NULL,NULL,'mean','UGC 11289',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143160,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143160,33.96,0.47,61.9,68956,NULL,NULL,'H','UGC 11289',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143161,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143161,34.02,0.45,63.6,68956,NULL,NULL,'K','UGC 11289',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143162,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143162,34.04,0.46,64.2,68956,NULL,NULL,'J','UGC 11289',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143163,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143163,34.18,0.41,68.6,68957,NULL,NULL,'Malmquist cor.','ESO 140- G 029',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.76',0.3,'Sb ?',NULL,NULL,NULL,NULL,1,278.969417,-59.44319,0.297,NULL,48964568790,765071387,11954240,15.76),(143164,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143164,34.51,0.35,79.9,68957,NULL,NULL,NULL,'ESO 140- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143165,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143165,34.55,0.2,81.3,68957,74.4,NULL,NULL,'ESO 140- G 029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143166,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143166,35.45,0.25,123,68958,74.4,NULL,NULL,'CGCG 279-018',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000097,NULL,'13.90',0.4,'E/S0',NULL,NULL,NULL,NULL,1,278.993875,51.45886,0.165,NULL,52941656613,827213384,12925209,13.9),(143167,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143167,35.66,0.27,135,68958,70,NULL,NULL,'CGCG 279-018',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143168,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143168,37.84,0.62,369,68959,70,NULL,NULL,'2MASX J18360246-5942185',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,279.010167,-59.70525,0.301,NULL,48968008178,765125127,11955080,14.8),(143169,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143169,33.63,0.8,53.3,68960,75,NULL,'MAT, I','ESO 336- G 006',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000023,NULL,'13.5b',0.6,'SB:(r)b',NULL,NULL,NULL,NULL,1,279.029833,-37.94583,0.489,NULL,47541120031,742830000,11606718,13.5),(143170,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143170,33.68,0.46,54.4,68960,NULL,NULL,'J','ESO 336- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143171,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143171,33.69,0.47,54.6,68960,NULL,NULL,'H','ESO 336- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143172,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143172,33.79,0.45,57.2,68960,NULL,NULL,'K','ESO 336- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143173,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143173,33.83,0.4,58.3,68960,NULL,NULL,'mean','ESO 336- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143174,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143174,33.89,0.43,59.9,68960,75,NULL,'MAT, I, raw','ESO 336- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143175,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143175,33.99,0.32,62.9,68960,85,NULL,'I, raw','ESO 336- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143176,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143176,34.06,0.32,65,68960,85,NULL,'I, inv','ESO 336- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143177,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143177,34.14,0.46,67.2,68960,NULL,NULL,NULL,'ESO 336- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143178,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143178,34.15,0.45,67.6,68960,NULL,NULL,'Malmquist cor.','ESO 336- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143179,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143179,34.18,0.43,68.5,68960,75,NULL,'MAT, I, inv','ESO 336- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143180,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143180,34.18,0.2,68.6,68960,74.4,NULL,NULL,'ESO 336- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143181,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143181,34.27,0.43,71.6,68960,75,NULL,'MAT, I, cor','ESO 336- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143182,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143182,35.92,0.68,153,68961,70,NULL,NULL,'2MFGC 14493',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,279.043375,-45.72144,0.169,NULL,51064484798,797882574,12466915,15),(143183,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143183,35.47,0.25,124,68962,74.4,NULL,NULL,'UGC 11298',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.0001,NULL,'13.13',0.9,'cD;E',NULL,NULL,NULL,NULL,1,279.0857917,51.46647,0.165,NULL,52941666737,827213542,12925211,13.13),(143184,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143184,35.66,0.27,135,68962,70,NULL,NULL,'UGC 11298',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143185,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143185,33.47,0.43,49.5,68963,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J18362423+1018467',NULL,'2014MNRAS.444..527S',2014,1,0.89,NULL,'G',0.000067,NULL,'14.43',0.33,'Spiral',NULL,NULL,NULL,NULL,1,279.101,10.31294,NULL,NULL,53903558723,842243105,13160048,14.43),(143186,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143186,33.59,0.69,52.1,68964,100,NULL,'mid-IR','UGC 11294',NULL,'2013ApJ...771...88L',2013,1,1.3,NULL,'G',0.000217,NULL,'13.9',0.8,'E0?','Group member',NULL,NULL,NULL,1,279.155375,19.9215,1.457,NULL,54625392574,853521758,13336277,13.9),(143187,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143187,34.76,0.47,89.5,68964,NULL,NULL,'Malmquist cor.','UGC 11294',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143188,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143188,35.07,0.4,103,68964,NULL,NULL,NULL,'UGC 11294',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143189,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143189,34.51,0.58,79.7,68965,70,NULL,NULL,'ESO 045- G 009',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000103,NULL,'14.2R',0.3,'S0',NULL,NULL,NULL,NULL,1,279.164167,-77.28806,0.673,NULL,48484754154,757574283,11837098,14.2),(143190,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143190,35.45,0.25,123,68966,74.4,NULL,NULL,'MCG +09-30-027',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000067,NULL,'14.34',0.3,'S',NULL,NULL,NULL,NULL,1,279.213917,51.43458,0.165,NULL,52941661788,827213465,12925210,14.34),(143191,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143191,35.66,0.27,135,68966,70,NULL,NULL,'MCG +09-30-027',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143192,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143192,35.45,0.25,123,68967,74.4,NULL,NULL,'GIN 657',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.00005,NULL,'14.39',0.2,'E/S0',NULL,NULL,NULL,NULL,1,279.217458333,51.53072,0.141,NULL,52941652905,827213326,12925208,14.39),(143193,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143193,35.66,0.27,135,68967,70,NULL,NULL,'GIN 657',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143194,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143194,34.88,0.47,94.4,68968,70,NULL,NULL,'ESO 281- G 015',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000127,NULL,'13.2R',0.7,'S0',NULL,NULL,NULL,NULL,1,279.229958333,-43.76319,0.325,NULL,51059271067,797801110,12465642,13.2),(143195,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143195,35.87,0.34,149,68969,NULL,NULL,'Malmquist cor.','ESO 103- G 030',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.76',0.4,'SAB(s)b','in a triple',NULL,NULL,NULL,1,279.2435,-67.27417,0.249,NULL,49204564086,768821313,12012833,15.76),(143196,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143196,35.89,0.34,151,68969,NULL,NULL,NULL,'ESO 103- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143197,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143197,35.93,0.2,153,68969,74.4,NULL,NULL,'ESO 103- G 030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143198,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143198,34.21,0.3,69.5,68970,NULL,NULL,'Malmquist cor.','UGC 11297',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000167,NULL,'15.1',0.2,'Sbc',NULL,NULL,NULL,NULL,1,279.3154583,19.97853,1.457,NULL,54624705376,853511021,13336109,15.1),(143199,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143199,34.3,0.29,72.5,68970,NULL,NULL,NULL,'UGC 11297',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143200,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',143200,34.31,0.49,72.6,68970,75,NULL,'IR','UGC 11297',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143201,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143201,34.32,0.2,73.1,68970,74.4,NULL,NULL,'UGC 11297',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143202,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143202,35.61,0.76,132,68971,70,NULL,NULL,'2MASX J18372375-5045418',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,279.348916667,-50.76167,0.381,NULL,48912392948,764256139,11941502,15.1),(143203,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143203,32.85,0.4,37.1,68972,NULL,NULL,'mean','NGC 6675',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000013,NULL,'13.25',1.3,'Sbc',NULL,NULL,NULL,NULL,1,279.360333,40.05772,0.241,NULL,54786939737,856045933,13375717,13.25),(143204,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143204,32.9,0.43,38,68972,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6675',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143205,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143205,32.91,0.43,38.2,68972,75,NULL,'3.6 micron, color corrected','NGC 6675',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143206,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143206,32.93,0.45,38.6,68972,NULL,NULL,'K','NGC 6675',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143207,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143207,32.93,0.47,38.6,68972,NULL,NULL,'H','NGC 6675',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143208,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143208,32.98,0.46,39.4,68972,NULL,NULL,'J','NGC 6675',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143209,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143209,33.02,0.2,40.2,68972,74.4,NULL,NULL,'NGC 6675',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143210,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143210,33.25,0.45,44.7,68972,NULL,NULL,NULL,'NGC 6675',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143211,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143211,33.29,0.44,45.4,68972,NULL,NULL,'Malmquist cor.','NGC 6675',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143212,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143212,34.99,0.61,99.4,68973,NULL,NULL,'Malmquist cor.','ESO 281- G 016',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.39',0.5,'Sb:',NULL,NULL,NULL,NULL,1,279.3717917,-47.15539,0.229,NULL,51062022497,797844101,12466314,14.39),(143213,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143213,35.01,0.6,101,68973,NULL,NULL,NULL,'ESO 281- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143214,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143214,35.05,0.2,102,68973,74.4,NULL,NULL,'ESO 281- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143215,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143215,35.24,0.57,112,68974,70,NULL,NULL,'2MASX J18373254-6643228',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,279.385417,-66.72294,0.293,NULL,49200378273,768755910,12011811,14.5),(143216,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143216,36.29,0.59,181,68975,70,NULL,NULL,'2MASX J18374861-6417081',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,279.4524583,-64.28553,0.389,NULL,48984191734,765377995,11959031,14.1),(143217,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',143217,33.71,0.49,55.3,68976,75,NULL,'IR','UGC 11301',NULL,'2011yCatp016004901K',2011,1,2.63,'Superposed star.','G',0.000011,NULL,'15.5',0.19,'Sc',NULL,NULL,NULL,NULL,1,279.476875,17.53386,1.689,NULL,54611958909,853311857,13332997,15.5),(143218,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143218,33.8,0.46,57.6,68976,NULL,NULL,'J','UGC 11301',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143219,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143219,33.83,0.47,58.2,68976,NULL,NULL,'H','UGC 11301',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143220,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143220,33.86,0.45,59.3,68976,NULL,NULL,'K','UGC 11301',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143221,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143221,33.9,0.4,60.3,68976,NULL,NULL,'mean','UGC 11301',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143222,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143222,33.97,0.33,62.1,68976,70,NULL,'H, 2MASS','UGC 11301',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143223,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143223,33.98,0.33,62.7,68976,70,NULL,'H, UH88/IRSF/2MASS','UGC 11301',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143224,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143224,34.3,0.43,72.3,68976,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11301',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143225,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143225,34.45,NULL,77.5,68976,NULL,NULL,'Dipole','UGC 11301',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143226,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143226,34.45,NULL,77.8,68976,NULL,NULL,'Dipole + Quadrupole','UGC 11301',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143227,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143227,34.46,NULL,78,68976,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11301',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143228,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143228,34.58,NULL,82.6,68976,NULL,NULL,NULL,'UGC 11301',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143229,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143229,32.88,0.2,37.7,68977,74.4,NULL,NULL,'UGC 11307',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000667,NULL,'14.8',0.4,'SBcd:',NULL,NULL,NULL,NULL,1,279.480375,27.79353,0.673,NULL,54435057099,850547767,13289808,14.8),(143230,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143230,33.1,0.46,41.6,68977,NULL,NULL,NULL,'UGC 11307',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143231,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143231,33.39,0.4,47.7,68977,NULL,NULL,'Malmquist cor.','UGC 11307',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143232,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143232,33.79,0.25,57.3,68978,74.4,NULL,NULL,'IC 4727',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000133,NULL,'14.03',1.1,'S0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,279.483583333,-62.70067,0.393,NULL,48988591966,765446749,11960105,14.03),(143233,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143233,33.91,0.45,60.4,68978,NULL,NULL,'K','IC 4727',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143234,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143234,33.92,0.4,60.8,68978,NULL,NULL,'mean','IC 4727',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143235,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143235,36.09,0.51,165,68979,70,NULL,NULL,'2MASX J18382505-5846558',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,279.604375,-58.78217,0.325,NULL,49098484896,767163826,11986934,14.9),(143236,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143236,33.91,0.8,60.6,68980,75,NULL,'MAT, I','IC 4734',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.18',0.8,'(R\')SB(s)ab;HII;LIRG','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,279.607083,-57.49044,0.569,NULL,49103619175,767244049,11988188,14.18),(143237,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143237,33.45,0.45,48.9,68980,NULL,NULL,'K','IC 4734',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143238,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143238,33.49,0.47,49.9,68980,NULL,NULL,'H','IC 4734',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143239,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143239,33.6,0.43,52.5,68980,75,NULL,'MAT, I, raw','IC 4734',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143240,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143240,33.65,0.32,53.6,68980,85,NULL,'I, raw','IC 4734',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143241,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143241,33.65,0.46,53.8,68980,NULL,NULL,'J','IC 4734',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143242,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143242,33.7,0.32,55,68980,85,NULL,'I, inv','IC 4734',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143243,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143243,33.82,0.43,58.2,68980,75,NULL,'MAT, I, cor','IC 4734',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143244,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143244,33.85,0.43,58.9,68980,75,NULL,'MAT, I, inv','IC 4734',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143245,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143245,34.06,0.5,64.9,68980,NULL,NULL,'Malmquist cor.','IC 4734',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143246,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143246,34.08,0.4,65.6,68980,NULL,NULL,'mean','IC 4734',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143247,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143247,34.57,0.4,82,68980,NULL,NULL,NULL,'IC 4734',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143248,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143248,34.61,0.2,83.6,68980,74.4,NULL,NULL,'IC 4734',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143249,'Ring Diameter','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143249,31.8,0.84,23,68981,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 6674',NULL,'1981ApJS...45..541P',1981,1,4,NULL,'G',0.000017,NULL,'13.0',2.2,'SB(r)b',NULL,NULL,NULL,NULL,1,279.641125,25.37514,0.665,NULL,54323265887,848801029,13262516,13),(143250,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143250,32.7,0.69,34.7,68981,100,NULL,'mid-IR','NGC 6674',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143251,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143251,33.5,0.4,50.1,68981,NULL,NULL,'mean','NGC 6674',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143252,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143252,33.65,0.2,53.7,68981,74.4,NULL,NULL,'NGC 6674',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143253,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143253,33.65,0.43,53.8,68981,75,NULL,'3.6 micron, color corrected','NGC 6674',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143254,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143254,33.66,0.47,54,68981,NULL,NULL,'H','NGC 6674',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143255,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143255,33.68,0.46,54.6,68981,NULL,NULL,'J','NGC 6674',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143256,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143256,33.7,0.35,55,68981,70,NULL,'H, UH88/IRSF/2MASS','NGC 6674',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143257,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143257,33.7,0.35,55,68981,70,NULL,'H, 2MASS','NGC 6674',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143258,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143258,33.75,0.45,56.3,68981,NULL,NULL,'K','NGC 6674',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143259,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143259,33.76,0.43,56.6,68981,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6674',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143260,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143260,36.34,0.52,185,68982,70,NULL,NULL,'2MASX J18383474-5357088',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,279.644875,-53.95247,0.365,NULL,48906570740,764165167,11940080,15),(143261,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143261,34.8,0.58,91.1,68983,70,NULL,NULL,'ESO 071- G 017',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000093,NULL,'15.61',0.4,'(R\'_2)SB(s)a',NULL,NULL,NULL,NULL,1,279.6565,-72.15808,0.245,NULL,48463232879,757238013,11831843,15.61),(143262,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143262,32.99,0.8,39.6,68984,75,NULL,'MAT, I','IC 4736',NULL,'1997ApJS..109..333W',1997,1,1.7,'Confused HIPASS source','G',0.000022,NULL,'14.56',0.9,'SB(s)dm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,279.665875,-57.89328,0.629,NULL,49095792170,767121752,11986277,14.56),(143263,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143263,32.46,0.43,31,68984,75,NULL,'MAT, I, raw','IC 4736',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143264,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143264,32.48,0.43,31.3,68984,75,NULL,'MAT, I, inv','IC 4736',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143265,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143265,32.71,0.32,34.9,68984,85,NULL,'I, raw','IC 4736',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143266,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143266,32.71,0.32,34.9,68984,85,NULL,'I, inv','IC 4736',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143267,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143267,32.86,0.43,37.4,68984,75,NULL,'MAT, I, cor','IC 4736',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143268,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143268,33.31,0.57,46,68984,NULL,NULL,NULL,'IC 4736',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143269,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143269,33.35,0.2,46.8,68984,74.4,NULL,NULL,'IC 4736',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143270,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143270,33.74,0.47,55.9,68984,NULL,NULL,'Malmquist cor.','IC 4736',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143271,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143271,32.95,0.25,38.9,68985,74.4,NULL,NULL,'IC 4731',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.00007,NULL,'12.52',0.7,'SB(r)0+:',NULL,NULL,NULL,NULL,1,279.679083333,-62.94303,0.393,NULL,48989016792,765453387,11960209,12.52),(143272,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143272,33.91,0.8,60.4,68986,75,NULL,'MAT, I','ESO 183- G 005',NULL,'1997ApJS..109..333W',1997,1,1.79,NULL,'G',0.000033,NULL,'15.71',0.22,'SB(s)d',NULL,NULL,NULL,NULL,1,279.761625,-55.61739,0.349,NULL,49099186163,767174783,11987105,15.71),(143273,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143273,33.13,0.32,42.2,68986,85,NULL,'I, inv','ESO 183- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143274,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143274,33.14,0.32,42.5,68986,85,NULL,'I, raw','ESO 183- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143275,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143275,33.42,0.43,48.3,68986,75,NULL,'MAT, I, raw','ESO 183- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143276,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143276,33.42,0.43,48.4,68986,75,NULL,'MAT, I, inv','ESO 183- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143277,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143277,33.51,NULL,50.4,68986,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 183- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143278,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143278,33.53,NULL,50.8,68986,NULL,NULL,'Dipole','ESO 183- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143279,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143279,33.53,NULL,50.8,68986,NULL,NULL,'Dipole + Quadrupole','ESO 183- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143280,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143280,33.59,NULL,52.3,68986,NULL,NULL,NULL,'ESO 183- G 005',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143281,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143281,33.7,0.43,55,68986,75,NULL,'MAT, I, cor','ESO 183- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143282,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',143282,33.91,0.49,60.7,68986,75,NULL,'IR','ESO 183- G 005',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143283,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143283,34.16,0.12,68.1,68986,NULL,NULL,NULL,'ESO 183- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143284,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143284,35.4,0.54,120,68987,70,NULL,NULL,'2MASX J18391238-4647172',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,279.801625,-46.78814,0.225,NULL,51065116635,797892447,12467069,14.8),(143285,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143285,33.8,0.8,57.6,68988,75,NULL,'MAT, I','ESO 103- G 039',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'15.02',1.1,'Sc?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,279.841667,-66.69919,0.245,NULL,49201095817,768767122,12011986,15.02),(143286,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143286,33.33,0.32,46.4,68988,85,NULL,'I, inv','ESO 103- G 039',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143287,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143287,33.34,0.32,46.5,68988,85,NULL,'I, raw','ESO 103- G 039',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143288,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143288,33.41,0.43,48.1,68988,75,NULL,'MAT, I, raw','ESO 103- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143289,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143289,33.43,0.43,48.4,68988,75,NULL,'MAT, I, inv','ESO 103- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143290,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143290,33.7,0.43,55,68988,75,NULL,'MAT, I, cor','ESO 103- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143291,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143291,34.03,0.09,64.1,68988,NULL,NULL,NULL,'ESO 103- G 039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143292,'Tully est','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143292,32.11,0.8,26.4,68989,75,NULL,NULL,'NGC 6654A',NULL,'1988NBGC.C....0000T',1988,1,2.6,NULL,'G',0.000023,NULL,'13.54',0.8,'SB(s)d pec?','in a pair',NULL,NULL,NULL,1,279.853917,73.57975,0.293,NULL,52736488225,824007628,12875119,13.54),(143293,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143293,35.01,0.43,101,68990,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11334',NULL,'2014MNRAS.444..527S',2014,1,1.96,NULL,'G',0.000017,NULL,'16.0',0.28,'Sc',NULL,NULL,NULL,NULL,1,279.8744583,73.82589,0.305,NULL,52736512527,824008008,12875125,16),(143294,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143294,34.89,0.52,95,68991,70,NULL,NULL,'2MASX J18393158-7736475',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,279.88175,-77.61319,0.549,NULL,48484651271,757572676,11837073,15.2),(143295,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',143295,45.22,1.51,3730,68992,NULL,NULL,NULL,'GRB 081008',1.9685,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,279.958,-57.43186,0.353,NULL,49102895275,767232738,11988011,NULL),(143296,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2006bq',NULL,143296,34.19,0.18,67.4,68993,74.2,NULL,'SALT 2','NGC 6685',0.021905,'2010ApJ...716..712A',2010,1,1.1,NULL,'G',0.00012,NULL,'14.45',0.9,'S0-:','Group member',NULL,NULL,NULL,1,279.994333,39.98178,0.237,NULL,54786335526,856036492,13375570,14.45),(143297,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2006bq',NULL,143297,34.76,0.09,89.5,68993,74.4,NULL,NULL,'NGC 6685',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143298,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2006bq',NULL,143298,34.89,0.17,93,68993,70,NULL,'SALT 2','NGC 6685',0.021905,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143299,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2006bq',NULL,143299,34.96,0.04,96.1,68993,72,NULL,'SALT','NGC 6685',0.021905,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143300,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2006bq',NULL,143300,35.05,0.19,100,68993,65,NULL,'SALT','NGC 6685',0.021905,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143301,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2006bq',NULL,143301,35.06,0.21,101,68993,65,NULL,'SALT2','NGC 6685',0.021905,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143302,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2006bq',NULL,143302,35.11,0.18,103,68993,65,NULL,'MLCS17','NGC 6685',0.021905,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143303,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2006bq',NULL,143303,35.16,0.19,105,68993,65,NULL,'MLCS31','NGC 6685',0.021905,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143304,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2006bq',NULL,143304,35.86,0.03,146,68993,70,NULL,'SALT 2','NGC 6685',0.021905,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143305,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143305,36.44,0.59,194,68994,70,NULL,NULL,'2MASX J18401747-2856368',NULL,'2014MNRAS.445.2677S',2014,1,0.1,NULL,'G',0.00015,NULL,'15.8R',0.1,'stellar:',NULL,NULL,NULL,NULL,1,280.0727083,-28.94356,0.565,NULL,47719844021,745622562,11650352,15.8),(143306,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143306,33,0.69,39.8,68995,100,NULL,'mid-IR','UGC 11315',NULL,'2013ApJ...771...88L',2013,1,2.1,NULL,'G',0.000006,NULL,'13.4',1,'Sb;HSB',NULL,NULL,NULL,NULL,1,280.0825417,24.19997,0.825,NULL,54310084964,848595077,13259298,13.4),(143307,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143307,33.89,0.4,59.9,68995,NULL,NULL,'mean','UGC 11315',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143308,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143308,34.2,0.47,69.1,68995,NULL,NULL,'H','UGC 11315',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143309,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143309,34.22,0.46,69.9,68995,NULL,NULL,'J','UGC 11315',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143310,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143310,34.29,0.45,72,68995,NULL,NULL,'K','UGC 11315',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143311,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143311,34.8,0.51,91.4,68996,70,NULL,NULL,'AM 1832-771 NED02',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,280.121083,-77.13353,0.681,NULL,48484399291,757568738,11837011,14.4),(143312,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143312,34.22,0.48,69.9,68997,70,NULL,NULL,'ESO 045- G 011',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000077,NULL,'14.4',1.2,'E             blazar',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,280.1602917,-77.15803,0.681,NULL,48484852776,757575824,11837122,14.4),(143313,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143313,34.46,0.4,78.1,68998,NULL,NULL,'mean','NGC 6688',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000097,NULL,'13.60',1.7,'SA0+',NULL,NULL,NULL,NULL,1,280.1672083,36.28964,0.189,NULL,54271832654,847997385,13249959,13.6),(143314,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143314,34.75,0.45,89.3,68998,NULL,NULL,'K','NGC 6688',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143315,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',143315,34.1,0.49,66.1,68999,75,NULL,'IR','UGC 11325',NULL,'2011yCatp016004901K',2011,1,2.3,NULL,'G',0.000023,NULL,'14.42',0.5,'Sb',NULL,NULL,NULL,NULL,1,280.182333,36.16375,0.189,NULL,54271926840,847998856,13249982,14.42),(143316,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143316,34.13,0.47,66.9,68999,NULL,NULL,'H','UGC 11325',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143317,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143317,34.23,0.46,70.2,68999,NULL,NULL,'J','UGC 11325',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143318,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143318,34.24,0.45,70.4,68999,NULL,NULL,'K','UGC 11325',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143319,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143319,34.53,0.4,80.4,68999,NULL,NULL,'mean','UGC 11325',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143320,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',143320,34.13,0.49,66.9,69000,75,NULL,'IR','UGC 11320',NULL,'2011yCatp016004901K',2011,1,2.11,'Haynes, et al. (1999AJ....117.2039H) give v = 4810 km/sec.','G',0.00002,NULL,'14.9',0.28,'Sc;HSB',NULL,NULL,NULL,NULL,1,280.200333333,23.68403,0.573,NULL,54309964540,848593195,13259268,14.9),(143321,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143321,34.26,0.33,71,69000,NULL,NULL,'Malmquist cor.','UGC 11320',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143322,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143322,34.26,NULL,71.3,69000,70,NULL,'H, 2MASS, Malmquist corr.','UGC 11320',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143323,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143323,34.28,NULL,71.8,69000,70,NULL,'H, UH88/IRSF/2MASS, Malmquist corr.','UGC 11320',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143324,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143324,34.3,0.31,72.6,69000,70,NULL,'H, 2MASS','UGC 11320',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143325,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143325,34.32,0.31,73.1,69000,70,NULL,'H, UH88/IRSF/2MASS','UGC 11320',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143326,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143326,34.32,0.2,73.1,69000,74.4,NULL,NULL,'UGC 11320',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143327,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143327,34.36,0.43,74.4,69000,75,NULL,'3.6 micron, color corrected','UGC 11320',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143328,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143328,34.38,0.43,75.3,69000,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11320',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143329,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143329,34.4,0.31,75.9,69000,NULL,NULL,NULL,'UGC 11320',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143330,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143330,34.44,NULL,77.3,69000,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11320',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143331,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143331,34.45,NULL,77.5,69000,NULL,NULL,'Dipole','UGC 11320',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143332,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143332,34.45,NULL,77.6,69000,NULL,NULL,'Dipole + Quadrupole','UGC 11320',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143333,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143333,34.49,NULL,79,69001,NULL,NULL,NULL,'UGC 11328',NULL,'2000BSAO...50....5K',2000,1,1.34,NULL,'G',0.00003,NULL,'16.0',0.15,'Sc',NULL,NULL,NULL,NULL,1,280.208083333,38.00458,0.213,NULL,54264420747,847881574,13248149,16),(143334,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143334,34.51,NULL,79.7,69001,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11328',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143335,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143335,34.52,NULL,80.1,69001,NULL,NULL,'Dipole + Quadrupole','UGC 11328',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143336,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143336,34.52,NULL,80.3,69001,NULL,NULL,'Dipole','UGC 11328',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143337,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,'R',143337,34.67,0.49,85.8,69001,75,NULL,'IR','UGC 11328',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143338,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143338,34.79,0.2,90.8,69001,74.4,NULL,NULL,'UGC 11328',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143339,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143339,34.8,0.43,91,69001,75,NULL,'3.6 micron, color corrected','UGC 11328',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143340,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143340,34.82,0.34,91.9,69001,NULL,NULL,'Malmquist cor.','UGC 11328',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143341,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143341,34.84,0.43,92.7,69001,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11328',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143342,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143342,34.92,0.32,96.3,69001,NULL,NULL,NULL,'UGC 11328',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143343,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143343,35.58,0.53,131,69002,70,NULL,NULL,'2MASX J18405544-7555373',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00014,NULL,'13.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,280.2310417,-75.92706,0.445,NULL,48482045201,757531956,11836436,13.6),(143344,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143344,33.36,0.2,47,69003,74.4,NULL,NULL,'UGC 11323',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000043,NULL,'14.5',0.6,'SB(s)bc',NULL,NULL,NULL,NULL,1,280.239875,23.08517,0.909,NULL,54607892719,853248323,13332005,14.5),(143345,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143345,34.05,0.25,64.6,69004,74.4,NULL,NULL,'ESO 103- G 046',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000123,NULL,'14.39',0.7,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,280.351,-64.01392,0.365,NULL,48983853202,765372706,11958948,14.39),(143346,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143346,34.06,0.52,64.9,69005,70,NULL,NULL,'IC 4743',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'14.91',0.4,'S0',NULL,NULL,NULL,NULL,1,280.3714583,-61.77222,0.417,NULL,48976038578,765250602,11957040,14.91),(143347,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143347,36.31,0.56,183,69006,70,NULL,NULL,'2MASX J18414226-5141410',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.8I',0.2,NULL,NULL,NULL,NULL,NULL,1,280.4262083,-51.69478,0.293,NULL,48901424419,764084756,11938824,14.8),(143348,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143348,36.78,0.58,227,69007,70,NULL,NULL,'2MASX J18414880-4653064',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,280.453458333,-46.88519,0.265,NULL,51065410319,797897036,12467141,15.5),(143349,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143349,33.81,0.4,57.8,69008,75,NULL,'Edat, raw','IC 4742',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000097,NULL,'16.3b',1.3,'E1','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,280.4690417,-63.86208,0.317,NULL,48984260513,765379070,11959047,16.3),(143350,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143350,33.85,0.4,58.8,69008,75,NULL,'Edat, cor','IC 4742',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143351,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143351,33.81,0.25,57.8,69008,74.4,NULL,NULL,'IC 4742',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143352,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143352,33.15,0.45,42.7,69008,NULL,NULL,'K','IC 4742',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143353,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143353,33.96,0.4,62,69008,NULL,NULL,'mean','IC 4742',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143354,'BL Lac Luminosity','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143354,39.44,NULL,772,69009,NULL,NULL,'Min. z = 0.2','1FGL J1841.9+3220',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,280.477,32.341,0.469,NULL,54477769139,851215142,13300236,NULL),(143355,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143355,35.65,NULL,135,69010,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2223',NULL,'2010Ap&SS.325..163P',2010,1,0.96,NULL,'G',NULL,NULL,'16.5',0.11,'Scd',NULL,NULL,NULL,NULL,1,280.477125,49.91339,0.201,NULL,52907800540,826684383,12916943,16.5),(143356,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143356,35.67,NULL,136,69010,NULL,NULL,'Dipole + Quadrupole','FGC 2223',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143357,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143357,35.69,NULL,137,69010,NULL,NULL,'Dipole','FGC 2223',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143358,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143358,35.7,NULL,138,69010,NULL,NULL,NULL,'FGC 2223',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143359,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,'R',143359,35.95,0.49,155,69010,75,NULL,'IR','FGC 2223',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143360,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143360,34.99,0.62,99.3,69011,70,NULL,NULL,'2MASX J18420100-7713035',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,280.504167,-77.21761,0.681,NULL,48484851898,757575810,11837122,15),(143361,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143361,33.97,0.51,62.2,69012,70,NULL,NULL,'ESO 103- G 049',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'14.91',0.4,'S0?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,280.506375,-65.09556,0.249,NULL,48930286498,764535726,11945870,14.91),(143362,'AGN time lag','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143362,38.01,0.9,400,69013,44,NULL,NULL,'3C 390.3',NULL,'2007MNRAS.380..669C',2007,1,NULL,NULL,'G',NULL,NULL,'14.37',NULL,'Opt.var.;BLRG  Sy1',NULL,NULL,'FR II','Flat-Spectrum Radio Source',1,280.5374583,79.77142,0.169,NULL,52851812359,825809568,12903274,14.37),(143363,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143363,33.15,0.25,42.7,69014,74.4,NULL,NULL,'2MASX J18421613-6336596',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000103,NULL,'15.08',NULL,NULL,NULL,NULL,NULL,NULL,1,280.567083333,-63.61653,0.325,NULL,48982405843,765350091,11958595,15.08),(143364,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143364,34.04,0.59,64.3,69014,70,NULL,NULL,'2MASX J18421613-6336596',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143365,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143365,34.41,0.41,76.2,69015,NULL,NULL,NULL,'ESO 396- G 001',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.27',0.3,'Sb:',NULL,NULL,NULL,NULL,1,280.64,-35.57447,0.425,NULL,47544654384,742885224,11607581,14.27),(143366,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143366,34.45,0.2,77.6,69015,74.4,NULL,NULL,'ESO 396- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143367,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143367,34.51,0.39,79.8,69015,NULL,NULL,'Malmquist cor.','ESO 396- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143368,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143368,34.62,0.4,83.8,69016,NULL,NULL,'mean','NGC 6695',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000043,NULL,'14.28',0.7,'SBb','Isolated galaxy',NULL,NULL,NULL,1,280.678083,40.36689,0.281,NULL,54790146458,856096038,13376500,14.28),(143369,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143369,34.89,0.47,95.2,69016,NULL,NULL,'H','NGC 6695',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143370,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143370,34.93,0.46,96.9,69016,NULL,NULL,'J','NGC 6695',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143371,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143371,34.94,0.45,97.2,69016,NULL,NULL,'K','NGC 6695',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143372,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143372,35.28,0.43,114,69016,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6695',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143373,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143373,33.21,0.25,43.9,69017,74.4,NULL,NULL,'IC 4748',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.00014,NULL,'14.29',0.8,'S0?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,280.6915,-64.07267,0.365,NULL,48984344186,765380377,11959068,14.29),(143374,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143374,33.83,0.4,58.3,69018,NULL,NULL,'mean','IC 4749',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.00012,NULL,'14.25',0.9,'S0?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,280.7062083,-63.20842,0.341,NULL,48987051975,765422687,11959729,14.25),(143375,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143375,34.01,0.45,63.4,69018,NULL,NULL,'K','IC 4749',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143376,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143376,34.8,0.34,91.1,69019,NULL,NULL,'Malmquist cor.','UGC 11341',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000127,NULL,'15.36',0.3,'Scd:',NULL,NULL,NULL,NULL,1,280.711875,39.54906,0.253,NULL,54789745093,856089767,13376402,15.36),(143377,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143377,34.82,0.2,92,69019,74.4,NULL,NULL,'UGC 11341',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143378,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143378,34.98,0.31,99.2,69019,NULL,NULL,NULL,'UGC 11341',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143379,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143379,33.52,0.45,50.7,69020,NULL,NULL,'K','IC 4751',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.0001,NULL,'14.05',0.6,'(R)SB(rl)0^0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,280.830583,-62.11228,0.421,NULL,48975469163,765241705,11956901,14.05),(143380,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143380,33.97,0.4,62.4,69020,NULL,NULL,'mean','IC 4751',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143381,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143381,34.75,0.5,89.2,69021,70,NULL,NULL,'2MASX J18432743-5339389',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.5I',0.4,'(R_1)SB0^0',NULL,NULL,NULL,NULL,1,280.864125,-53.66083,0.281,NULL,48897931067,764030172,11937971,13.5),(143382,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143382,36.57,NULL,207,69022,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11366',NULL,'2010Ap&SS.325..163P',2010,1,0.99,NULL,'G',0.0001,NULL,'16.5',0.11,'Sbc',NULL,NULL,NULL,NULL,1,280.960666667,81.73425,0.177,NULL,52645897165,822592143,12853002,16.5),(143383,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143383,36.58,NULL,207,69022,NULL,NULL,NULL,'UGC 11366',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143384,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143384,36.6,NULL,209,69022,NULL,NULL,'Dipole + Quadrupole','UGC 11366',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143385,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143385,36.64,NULL,213,69022,NULL,NULL,'Dipole','UGC 11366',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143386,'Cepheids','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,'RN',143386,19.77,NULL,0.09,69023,NULL,NULL,NULL,'NORMA DWARF A',NULL,'2016AAS...22744106C',2016,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143387,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143387,34.82,0.59,91.9,69023,70,NULL,NULL,'IC 4761',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143388,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143388,36.21,0.87,174,69024,70,NULL,NULL,'2MASX J18441365-8505140',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,281.056875,-85.08731,0.481,NULL,48373365092,755833829,11809903,16.9),(143389,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143389,33.54,0.2,51.1,69025,74.4,NULL,NULL,'UGC 11344',NULL,'2013AJ....146...86T',2013,1,2,NULL,'G',0.000013,NULL,'13.6',1,'Sab',NULL,NULL,NULL,NULL,1,281.064167,24.1425,0.889,NULL,54310306943,848598545,13259352,13.6),(143390,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143390,33.72,0.43,55.5,69025,75,NULL,'3.6 micron, color corrected','UGC 11344',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143391,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143391,33.77,0.4,56.9,69025,NULL,NULL,'mean','UGC 11344',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143392,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143392,33.82,0.47,58,69025,NULL,NULL,'H','UGC 11344',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143393,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143393,33.85,0.45,58.8,69025,NULL,NULL,'K','UGC 11344',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143394,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143394,33.86,0.46,59,69025,NULL,NULL,'J','UGC 11344',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143395,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143395,33.93,0.34,61,69025,70,NULL,'H, 2MASS','UGC 11344',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143396,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143396,33.99,0.43,62.8,69025,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11344',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143397,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143397,34.1,0.34,66,69025,70,NULL,'H, UH88/IRSF/2MASS','UGC 11344',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143398,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,'R',143398,33.18,0.49,43.3,69026,75,NULL,'IR','UGC 11346',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'14.5',0.8,'SBb',NULL,NULL,NULL,NULL,1,281.070208333,25.25647,0.961,NULL,54309572920,848587076,13259173,14.5),(143399,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143399,35.42,0.52,122,69027,70,NULL,NULL,'2MASX J18442238-7600494',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,281.0929583,-76.01381,0.445,NULL,48482136909,757533389,11836459,14.8),(143400,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143400,34.24,NULL,70.6,69028,70,NULL,'H, UH88/IRSF/2MASS, Malmquist corr.','IRAS  18421+1218',NULL,'2011A&A...531A..87I',2011,1,0.9,NULL,'G',NULL,NULL,NULL,0.1,'Spiral;HSB',NULL,NULL,NULL,NULL,1,281.13,12.36472,NULL,NULL,54577199153,852768736,13324511,NULL),(143401,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143401,34.24,NULL,70.6,69028,70,NULL,'H, 2MASS, Malmquist corr.','IRAS  18421+1218',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143402,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143402,34.39,0.46,75.6,69028,70,NULL,'H, UH88/IRSF/2MASS','IRAS  18421+1218',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143403,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143403,34.39,0.46,75.6,69028,70,NULL,'H, 2MASS','IRAS  18421+1218',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143404,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143404,33.29,0.4,45.5,69029,75,NULL,'Edat, raw','NGC 6653',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000187,NULL,'12.2',1.5,'E1:',NULL,NULL,NULL,NULL,1,281.159875,-73.26342,0.277,NULL,48515725686,758058213,11844659,12.2),(143405,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143405,33.62,0.4,53,69029,75,NULL,'Edat, cor','NGC 6653',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143406,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143406,33.95,0.45,61.7,69029,NULL,NULL,'K','NGC 6653',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143407,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143407,34.18,0.4,68.5,69029,NULL,NULL,'mean','NGC 6653',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143408,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143408,34.65,0.59,85.2,69030,70,NULL,NULL,'AM 1839-652',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,281.16325,-65.26758,0.229,NULL,48926842251,764481910,11945029,14.5),(143409,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143409,36.34,0.82,185,69031,70,NULL,NULL,'2MASX J18444843-7618394',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,281.201583,-76.31106,0.417,NULL,48482575864,757540247,11836566,14.6),(143410,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143410,33.56,0.8,51.5,69032,75,NULL,'HMCL, I','ESO 140- G 043',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000031,NULL,'14.7',0.9,'(R\'_2)SB(rs)b  Sy1','Line-of-sight pair member',NULL,NULL,'Sy 1',1,281.224916667,-62.36483,0.329,NULL,48975404182,765240690,11956885,14.7),(143411,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143411,33.59,0.8,52.3,69032,75,NULL,'MAT, I','ESO 140- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143412,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143412,32.45,0.43,30.8,69032,75,NULL,'MAT, I, raw','ESO 140- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143413,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143413,32.51,0.32,31.7,69032,85,NULL,'I, raw','ESO 140- G 043',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143414,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143414,32.53,0.32,32,69032,85,NULL,'I, inv','ESO 140- G 043',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143415,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143415,32.55,0.43,32.3,69032,75,NULL,'MAT, I, inv','ESO 140- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143416,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143416,32.88,0.43,37.6,69032,75,NULL,'MAT, I, cor','ESO 140- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143417,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143417,33,0.45,39.8,69032,NULL,NULL,'K','ESO 140- G 043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143418,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143418,33.3,0.47,45.8,69032,NULL,NULL,'H','ESO 140- G 043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143419,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143419,33.53,0.4,50.9,69032,75,NULL,'HMCL, I, raw','ESO 140- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143420,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143420,33.57,0.46,51.8,69032,NULL,NULL,'J','ESO 140- G 043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143421,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143421,33.7,0.4,55,69032,75,NULL,'HMCL, I, inv','ESO 140- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143422,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143422,33.74,0.4,56.1,69032,75,NULL,'HMCL, I, cor','ESO 140- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143423,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143423,33.79,0.4,57.2,69032,NULL,NULL,'mean','ESO 140- G 043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143424,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143424,34.03,0.08,64.1,69032,NULL,NULL,NULL,'ESO 140- G 043',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143425,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143425,34.37,0.43,74.8,69033,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J18445773+2147268',NULL,'2014MNRAS.444..527S',2014,1,0.56,NULL,'G',0.00003,NULL,NULL,0.22,'Spiral',NULL,NULL,NULL,NULL,1,281.2405,21.79078,1.117,NULL,54608938902,853264670,13332260,NULL),(143426,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143426,33.73,0.47,55.7,69034,NULL,NULL,'H','IC 4755',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00015,NULL,'17.2b',0.3,'Sa:','Group member',NULL,NULL,NULL,1,281.2547917,-63.69222,0.325,NULL,48982633131,765353642,11958650,17.2),(143427,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143427,33.81,0.45,57.9,69034,NULL,NULL,'K','IC 4755',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143428,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143428,33.9,0.46,60.3,69034,NULL,NULL,'J','IC 4755',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143429,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,'R',143429,33.9,0.49,60.3,69034,75,NULL,'IR','IC 4755',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143430,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143430,33.97,0.4,62.2,69034,NULL,NULL,'mean','IC 4755',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143431,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143431,32.75,0.45,35.5,69035,NULL,NULL,'K','ESO 103- G 059',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000033,NULL,'14.99',0.2,'S0','Group member',NULL,NULL,NULL,1,281.255541667,-63.517,0.325,NULL,48982607913,765353248,11958644,14.99),(143432,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143432,33.55,0.4,51.3,69035,NULL,NULL,'mean','ESO 103- G 059',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143433,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143433,30.16,0.14,10.8,69036,74.4,NULL,NULL,'NGC 6673',NULL,'2013AJ....146...86T',2013,1,2.2,NULL,'G',0.00006,NULL,'12.57',0.9,'SAB(s)0-:','Line-of-sight pair member',NULL,NULL,NULL,1,281.276333333,-62.29722,0.329,NULL,48975514580,765242415,11956912,12.57),(143434,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143434,30.18,0.23,10.9,69036,NULL,NULL,'I','NGC 6673',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143435,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143435,30.77,0.4,14.3,69036,75,NULL,'Edat, raw','NGC 6673',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143436,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143436,30.95,0.4,15.5,69036,75,NULL,'Edat, cor','NGC 6673',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143437,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143437,30.63,0.45,13.4,69036,NULL,NULL,'K','NGC 6673',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143438,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143438,31.28,0.4,18.1,69036,NULL,NULL,'mean','NGC 6673',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143439,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143439,33.86,0.8,59.2,69037,75,NULL,'MAT, I','ESO 336- G 013',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.00001,NULL,'14.5',1,'SAb:',NULL,NULL,NULL,NULL,1,281.371875,-39.18144,0.425,NULL,51043602019,797556281,12461816,14.5),(143440,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143440,33.55,0.43,51.2,69037,75,NULL,'MAT, I, raw','ESO 336- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143441,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143441,33.58,0.32,52.1,69037,85,NULL,'I, raw','ESO 336- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143442,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143442,33.64,0.32,53.5,69037,85,NULL,'I, inv','ESO 336- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143443,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143443,33.79,0.43,57.2,69037,75,NULL,'MAT, I, inv','ESO 336- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143444,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143444,33.97,0.47,62.2,69037,NULL,NULL,'H','ESO 336- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143445,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143445,34,0.45,63,69037,NULL,NULL,'K','ESO 336- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143446,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143446,34.03,0.46,64.1,69037,NULL,NULL,'J','ESO 336- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143447,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143447,34.06,0.43,65,69037,75,NULL,'MAT, I, cor','ESO 336- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143448,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143448,34.09,0.4,65.6,69037,NULL,NULL,'mean','ESO 336- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143449,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143449,34.36,0.29,74.4,69037,NULL,NULL,NULL,'ESO 336- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143450,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143450,34.4,0.2,75.9,69037,74.4,NULL,NULL,'ESO 336- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143451,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143451,34.44,0.28,77.2,69037,NULL,NULL,'Malmquist cor.','ESO 336- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143452,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143452,34.07,0.45,65,69038,NULL,NULL,'K','IC 4760',NULL,'2007A&A...465...71T',2007,1,0.8,NULL,'G',0.00005,NULL,'15.09',0.7,'SA(rl)0^0','Group member',NULL,NULL,NULL,1,281.4414583,-62.95836,0.345,NULL,48987323021,765426922,11959795,15.09),(143453,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143453,34.19,0.4,69,69038,NULL,NULL,'mean','IC 4760',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143454,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143454,33.74,0.4,56,69039,NULL,NULL,'mean','2MASX J18454690-6259551',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'G',0.000087,NULL,'16.25',NULL,'SB0','Group member',NULL,NULL,NULL,1,281.445083,-62.99864,0.345,NULL,48987321932,765426905,11959795,16.25),(143455,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143455,34.04,0.45,64.2,69039,NULL,NULL,'K','2MASX J18454690-6259551',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143456,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143456,33.94,0.25,61.4,69040,74.4,NULL,NULL,'2MASX J18455069-6314091',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.00008,NULL,'15',NULL,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,281.461417,-63.23578,0.341,NULL,48987185579,765424774,11959762,15),(143457,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143457,34.15,0.47,67.6,69041,NULL,NULL,'H','ESO 230- G 010',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000033,NULL,'12.78',0.4,'S              HII',NULL,NULL,NULL,NULL,1,281.510875,-50.77444,0.217,NULL,48896321475,764005023,11937578,12.78),(143458,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143458,34.21,0.4,69.6,69041,NULL,NULL,'mean','ESO 230- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143459,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143459,34.23,0.45,70.1,69041,NULL,NULL,'K','ESO 230- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143460,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143460,34.29,0.46,72,69041,NULL,NULL,'J','ESO 230- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143461,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143461,34.37,0.38,74.7,69041,NULL,NULL,'Malmquist cor.','ESO 230- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143462,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143462,34.52,0.35,80.2,69041,NULL,NULL,NULL,'ESO 230- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143463,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143463,34.56,0.2,81.7,69041,74.4,NULL,NULL,'ESO 230- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143464,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143464,34.2,0.4,69.1,69042,NULL,NULL,'mean','NGC 6700',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.00003,NULL,'13.8',1,'SB(rs)c',NULL,NULL,NULL,NULL,1,281.5182917,32.27961,0.381,NULL,54454768068,850855751,13294621,13.8),(143465,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143465,34.39,0.45,75.5,69042,NULL,NULL,'K','NGC 6700',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143466,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143466,34.39,0.46,75.6,69042,NULL,NULL,'J','NGC 6700',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143467,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143467,34.42,0.47,76.5,69042,NULL,NULL,'H','NGC 6700',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143468,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143468,34.53,0.46,80.7,69042,NULL,NULL,'Malmquist cor.','NGC 6700',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143469,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143469,34.56,0.35,81.7,69042,70,NULL,'H, UH88/IRSF/2MASS','NGC 6700',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143470,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143470,34.56,0.35,81.7,69042,70,NULL,'H, 2MASS','NGC 6700',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143471,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143471,34.66,0.2,85.5,69042,74.4,NULL,NULL,'NGC 6700',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143472,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143472,34.7,0.42,87.2,69042,NULL,NULL,NULL,'NGC 6700',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143473,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143473,37.55,0.56,324,69043,70,NULL,NULL,'2MASX J18460669-5517332',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,281.528,-55.29253,0.285,NULL,49107900172,767310940,11989233,15.4),(143474,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143474,34.13,0.43,67,69044,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11350',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.000017,NULL,'14.1',1.1,'Scd:',NULL,NULL,NULL,NULL,1,281.570167,22.61519,1.129,NULL,54596358737,853068105,13329189,14.1),(143475,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143475,33.2,0.15,43,69045,74.2,NULL,'SALT 2','IC 4758',0.0155,'2010ApJ...716..712A',2010,1,1.1,NULL,'G',0.000127,NULL,'14.16',0.9,'Sc',NULL,NULL,NULL,NULL,1,281.576125,-65.75667,0.221,NULL,48927400630,764490634,11945166,14.16),(143476,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143476,33.78,0.08,57,69045,74.4,NULL,NULL,'IC 4758',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143477,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143477,33.83,0.06,57.5,69045,72,NULL,NULL,'IC 4758',0.0155,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143478,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143478,33.83,0.15,57.5,69045,72,NULL,NULL,'IC 4758',0.0155,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143479,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143479,33.85,0.2,58.1,69045,70,NULL,'SALT 2','IC 4758',0.0155,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143480,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143480,33.89,0.19,59.1,69045,73.8,NULL,'SALT 2 (SNANA)','IC 4758',0.0155,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143481,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143481,33.89,0.04,59.1,69045,72,NULL,NULL,'IC 4758',0.0155,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143482,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143482,33.9,0.02,59.4,69045,72,NULL,NULL,'IC 4758',0.0155,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143483,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143483,33.91,0.19,59.6,69045,72,NULL,NULL,'IC 4758',0.0155,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143484,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143484,33.91,0.05,60.5,69045,72,NULL,'M(H) = -18.317 mag','IC 4758',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143485,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143485,34.03,0.15,63,69045,70,NULL,'SALT','IC 4758',0.0155,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143486,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143486,34.06,0.11,63.8,69045,65,NULL,'MLCS2k2','IC 4758',0.0155,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143487,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143487,34.08,0.22,64.5,69045,65,NULL,'MLCS31','IC 4758',0.0155,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143488,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143488,34.13,0.11,65,69045,65,NULL,'MLCS2k2','IC 4758',0.0155,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143489,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143489,34.12,0.14,65.6,69045,70,NULL,NULL,'IC 4758',0.0155,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143490,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143490,34.13,0.22,65.8,69045,65,NULL,'MLCS17','IC 4758',0.0155,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143491,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143491,34.13,0.24,65.9,69045,65,NULL,'SALT2','IC 4758',0.0155,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143492,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143492,34.1,0.17,66.1,69045,70.8,NULL,NULL,'IC 4758',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143493,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143493,34.15,0.22,66.4,69045,65,NULL,'SALT','IC 4758',0.0155,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143494,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143494,34.4,0.02,74.7,69045,65,NULL,'SALT','IC 4758',0.0155,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143495,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143495,35.07,0.03,102,69045,70,NULL,'SALT 2','IC 4758',0.0155,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143496,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143496,34.14,0.37,67.4,69046,NULL,NULL,NULL,'ESO 230- G 011',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'13.74',0.4,'Sb-c',NULL,NULL,NULL,NULL,1,281.5960417,-52.15636,0.229,NULL,48901837660,764091213,11938925,13.74),(143497,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143497,34.18,0.2,68.6,69046,74.4,NULL,NULL,'ESO 230- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143498,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143498,34.2,0.36,69.2,69046,NULL,NULL,'Malmquist cor.','ESO 230- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143499,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143499,33.81,0.4,57.8,69047,75,NULL,'Edat, raw','2MASX J18462497-6319312',NULL,'1997ApJS..109..333W',1997,1,NULL,NULL,'G',0.000047,NULL,'14',NULL,'SB0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,281.603917,-63.32517,0.289,NULL,48986930320,765420786,11959699,14),(143500,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143500,33.85,0.4,58.8,69047,75,NULL,'Edat, cor','2MASX J18462497-6319312',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143501,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143501,33.53,0.23,50.8,69047,74.4,NULL,NULL,'2MASX J18462497-6319312',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143502,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143502,36.02,0.59,160,69048,70,NULL,NULL,'2MASX J18463484-5924023',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,281.645375,-59.40061,0.349,NULL,49094777545,767105899,11986029,15.3),(143503,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143503,33.81,0.4,57.8,69049,75,NULL,'Edat, raw','ESO 104- G 002',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000033,NULL,'14.14',0.3,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,281.7235,-63.36122,0.289,NULL,48982525522,765351961,11958624,14.14),(143504,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143504,33.85,0.4,58.8,69049,75,NULL,'Edat, cor','ESO 104- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143505,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143505,33.75,0.23,56.2,69049,74.4,NULL,NULL,'ESO 104- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143506,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143506,33.51,0.24,50.4,69050,NULL,NULL,'I','NGC 6702',NULL,'2001ApJ...546..681T',2001,1,1.8,NULL,'G',0.000017,NULL,'13.23',1.3,'E:             LINER','in a pair',NULL,NULL,NULL,1,281.739916667,45.70567,0.233,NULL,54826255388,856660240,13385316,13.23),(143507,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143507,33.51,0.24,50.4,69050,NULL,NULL,NULL,'NGC 6702',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143508,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143508,33.58,0.14,52,69050,74.4,NULL,NULL,'NGC 6702',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143509,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143509,33.93,0.24,61,69050,NULL,NULL,'Malmquist cor.','NGC 6702',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143510,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143510,33.17,0.4,43.1,69050,75,NULL,'Edat, raw','NGC 6702',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143511,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143511,33.51,0.4,50.3,69050,75,NULL,'Edat, cor','NGC 6702',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143512,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143512,33.27,0.44,45.1,69050,95,NULL,'Weighted Mean','NGC 6702',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143513,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143513,33.74,0.46,56,69050,95,NULL,'Michard 1979a','NGC 6702',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143514,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143514,33.75,0.63,56.2,69050,95,NULL,'Michard 1979b, c','NGC 6702',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143515,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143515,33.08,0.41,41.3,69050,NULL,NULL,NULL,'NGC 6702',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143516,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143516,33.67,0.41,54.2,69050,NULL,NULL,'Malmquist cor.','NGC 6702',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143517,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143517,33.54,0.45,51.1,69050,NULL,NULL,'K','NGC 6702',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143518,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143518,34.08,0.4,65.5,69050,NULL,NULL,'mean','NGC 6702',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143519,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143519,34.66,0.8,85.5,69051,75,NULL,'MAT, I','ESO 024- G 019',NULL,'1997ApJS..109..333W',1997,1,2.22,NULL,'G',0.000033,NULL,'13.88',0.15,'Sc',NULL,NULL,NULL,NULL,1,281.804583,-82.12861,0.529,NULL,48368639647,755759994,11808749,13.88),(143520,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143520,34.41,0.41,76.1,69051,NULL,NULL,'Malmquist cor.','ESO 024- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143521,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143521,34.53,0.38,80.4,69051,NULL,NULL,NULL,'ESO 024- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143522,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143522,34.57,0.2,82,69051,74.4,NULL,NULL,'ESO 024- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143523,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143523,34.69,0.43,86.9,69051,75,NULL,'MAT, I, raw','ESO 024- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143524,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143524,34.83,0.32,92.5,69051,85,NULL,'I, raw','ESO 024- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143525,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143525,34.87,NULL,94,69051,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 024- G 019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143526,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143526,34.87,0.32,94.4,69051,85,NULL,'I, inv','ESO 024- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143527,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143527,34.88,NULL,94.5,69051,NULL,NULL,'Dipole','ESO 024- G 019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143528,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143528,34.88,NULL,94.6,69051,NULL,NULL,'Dipole + Quadrupole','ESO 024- G 019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143529,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143529,34.9,0.43,95.4,69051,75,NULL,'MAT, I, inv','ESO 024- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143530,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143530,34.92,NULL,96.5,69051,NULL,NULL,NULL,'ESO 024- G 019',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143531,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143531,35.07,0.43,103,69051,75,NULL,'MAT, I, cor','ESO 024- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143532,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,'R',143532,33.83,0.49,58.5,69052,75,NULL,'IR','ESO 230- G 012',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'13.05',0.3,'S...',NULL,NULL,NULL,NULL,1,281.805333,-48.35739,0.269,NULL,51031417497,797365898,12458842,13.05),(143533,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143533,34.27,0.34,71.3,69052,NULL,NULL,NULL,'ESO 230- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143534,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143534,34.31,0.2,72.8,69052,74.4,NULL,NULL,'ESO 230- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143535,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143535,34.36,0.32,74.6,69052,NULL,NULL,'Malmquist cor.','ESO 230- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143536,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143536,34.25,0.24,70.8,69053,75,NULL,NULL,'IC 4765',NULL,'1982AJ.....87..462G',1982,1,3.5,NULL,'G',0.000019,NULL,'12.33',1.9,'cD;E+4','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,281.8247083,-63.33133,0.289,NULL,48986914856,765420544,11959696,12.33),(143537,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143537,33.81,0.4,57.8,69053,75,NULL,'Edat, raw','IC 4765',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143538,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143538,33.81,0.4,57.8,69053,75,NULL,'Edat, raw','IC 4765',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143539,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143539,33.85,0.4,58.8,69053,75,NULL,'Edat, cor','IC 4765',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143540,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143540,33.85,0.4,58.8,69053,75,NULL,'Edat, cor','IC 4765',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143541,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143541,33.87,0.13,59.5,69053,72,NULL,'ABELL S0805, Pavo II CLUSTER, 12 galaxies','IC 4765',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143542,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143542,34,0.28,63,69053,70,NULL,'ABELL S0805, Pavo II CLUSTER, 70 galaxies','IC 4765',NULL,'1988MNRAS.235.1177L',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143543,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143543,34.3,0.23,72.4,69053,74.4,NULL,NULL,'IC 4765',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143544,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143544,33.47,0.45,49.4,69053,NULL,NULL,'K','IC 4765',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143545,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143545,33.53,NULL,50.9,69053,71,NULL,'ABELL S0805, Pavo II CLUSTER, 70 galaxies','IC 4765',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143546,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143546,33.62,0.3,52.9,69053,NULL,NULL,'ABELL S0805, Pavo II CLUSTER, 13 galaxies','IC 4765',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143547,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143547,33.97,0.4,62.1,69053,NULL,NULL,'mean','IC 4765',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143548,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143548,33.81,0.4,57.8,69054,75,NULL,'Edat, raw','ESO 104- G 007',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'12.90',0.8,'E?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,281.824833333,-63.35939,0.289,NULL,48982524583,765351946,11958624,12.9),(143549,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143549,33.85,0.4,58.8,69054,75,NULL,'Edat, cor','ESO 104- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143550,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143550,33.78,0.23,57,69054,74.4,NULL,NULL,'ESO 104- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143551,'GCLF','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143551,31.7,0.23,21.9,69055,NULL,NULL,NULL,'NGC 6703',NULL,'2001AJ....122.1251K',2001,1,2.5,NULL,'G',0.000017,NULL,'12.32',2.3,'SA0-','in a pair',NULL,NULL,NULL,1,281.8284583,45.55064,0.257,NULL,54826364389,856661943,13385342,12.32),(143552,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143552,32.13,0.29,26.7,69055,NULL,NULL,'I','NGC 6703',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143553,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143553,32.13,0.29,26.7,69055,NULL,NULL,NULL,'NGC 6703',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143554,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143554,32.17,0.14,27.2,69055,74.4,NULL,NULL,'NGC 6703',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143555,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143555,32.84,0.29,37,69055,NULL,NULL,'Malmquist cor.','NGC 6703',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143556,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143556,31.49,0.4,19.9,69055,75,NULL,'Edat, raw','NGC 6703',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143557,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143557,31.83,0.4,23.2,69055,75,NULL,'Edat, cor','NGC 6703',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143558,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143558,31.13,0.39,16.8,69055,95,NULL,'de Vaucouleurs','NGC 6703',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143559,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143559,31.15,0.29,17,69055,95,NULL,'Weighted Mean','NGC 6703',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143560,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143560,31.17,0.63,17.1,69055,95,NULL,'Michard 1979b, c','NGC 6703',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143561,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143561,31.56,0.46,20.5,69055,95,NULL,'Michard 1979a','NGC 6703',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143562,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143562,32.04,0.41,25.6,69055,NULL,NULL,NULL,'NGC 6703',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143563,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143563,32.86,0.41,37.3,69055,NULL,NULL,'Malmquist cor.','NGC 6703',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143564,'Tertiary','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143564,32.42,0.71,30.5,69055,95,NULL,NULL,'NGC 6703',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143565,'Tully est','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143565,32.77,0.8,35.9,69055,75,NULL,'B','NGC 6703',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143566,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143566,32.44,0.45,30.8,69055,NULL,NULL,'K','NGC 6703',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143567,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143567,32.44,0.4,30.8,69055,NULL,NULL,'mean','NGC 6703',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143568,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143568,33.97,0.8,62.1,69056,75,NULL,'MAT, I','ESO 336- G 016',NULL,'1997ApJS..109..333W',1997,1,2,'Marginal HIPASS detection.','G',0.000013,NULL,'14.5',0.8,'SA(s)c:',NULL,NULL,NULL,NULL,1,281.845791667,-41.71803,0.373,NULL,51041689586,797526399,12461349,14.5),(143569,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143569,33.42,0.43,48.4,69056,75,NULL,'MAT, I, raw','ESO 336- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143570,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143570,33.64,0.32,53.4,69056,85,NULL,'I, raw','ESO 336- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143571,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143571,33.69,0.43,54.7,69056,75,NULL,'MAT, I, inv','ESO 336- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143572,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143572,33.7,0.32,55,69056,85,NULL,'I, inv','ESO 336- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143573,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143573,33.97,0.43,62.2,69056,75,NULL,'MAT, I, cor','ESO 336- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143574,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143574,34.34,0.47,74,69056,NULL,NULL,'H','ESO 336- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143575,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143575,34.37,0.46,74.7,69056,NULL,NULL,'J','ESO 336- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143576,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143576,34.46,0.45,78,69056,NULL,NULL,'K','ESO 336- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143577,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143577,34.59,0.4,82.7,69056,NULL,NULL,'mean','ESO 336- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143578,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143578,33.6,0.45,52.5,69057,NULL,NULL,'K','ESO 104- G 008',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000033,NULL,'14',0.5,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,281.845417,-63.31033,0.289,NULL,48986456899,765413389,11959584,14),(143579,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143579,33.68,0.4,54.4,69057,NULL,NULL,'mean','ESO 104- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143580,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143580,36.07,0.83,164,69058,70,NULL,NULL,'2MASX J18473178-4303507',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,281.882458333,-43.06414,0.317,NULL,51068716778,797948699,12467948,15.4),(143581,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143581,36.47,0.64,197,69059,70,NULL,NULL,'2MASX J18473486-7122092',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,281.89525,-71.36925,0.217,NULL,48465039921,757266248,11832285,15.4),(143582,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143582,33.81,0.4,57.8,69060,75,NULL,'Edat, raw','IC 4767',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000014,NULL,'14.31',0.5,'S pec sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,281.923875,-63.40567,0.289,NULL,48983050165,765360158,11958752,14.31),(143583,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143583,33.81,0.4,57.8,69060,75,NULL,'Edat, raw','IC 4767',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143584,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143584,33.85,0.4,58.8,69060,75,NULL,'Edat, cor','IC 4767',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143585,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143585,33.85,0.4,58.8,69060,75,NULL,'Edat, cor','IC 4767',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143586,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143586,33.87,0.25,59.4,69060,74.4,NULL,NULL,'IC 4767',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143587,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143587,32.93,0.45,38.5,69060,NULL,NULL,'K','IC 4767',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143588,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143588,33.32,0.4,46.2,69060,NULL,NULL,'mean','IC 4767',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143589,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143589,33.81,0.8,57.9,69061,75,NULL,'MAT, I','IC 4769',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'14.06',1.2,'SB(rs)bc       Sy2','Group member, radial-velocity confirmed',NULL,NULL,'Sy 2',1,281.9335417,-63.157,0.277,NULL,48986513295,765414270,11959597,14.06),(143590,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143590,33.23,0.32,44.2,69061,85,NULL,'I, raw','IC 4769',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143591,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143591,33.27,0.32,45.1,69061,85,NULL,'I, inv','IC 4769',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143592,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143592,33.51,0.43,50.4,69061,75,NULL,'MAT, I, raw','IC 4769',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143593,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143593,33.72,0.43,55.6,69061,75,NULL,'MAT, I, inv','IC 4769',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143594,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143594,33.75,0.43,56.2,69061,75,NULL,'MAT, I, cor','IC 4769',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143595,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143595,33.9,0.45,60.1,69061,NULL,NULL,'K','IC 4769',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143596,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143596,33.9,0.47,60.4,69061,NULL,NULL,'H','IC 4769',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143597,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143597,33.93,0.4,61,69061,NULL,NULL,'mean','IC 4769',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143598,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143598,34.02,0.46,63.8,69061,NULL,NULL,'J','IC 4769',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143599,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143599,34.03,0.08,64.1,69061,NULL,NULL,NULL,'IC 4769',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143600,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143600,33.73,0.45,55.7,69062,NULL,NULL,'K','ESO 104-IG 012 NED01',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'G',0.000067,NULL,'16.5b',NULL,'S0','Group member',NULL,NULL,NULL,1,281.9845417,-63.18364,0.277,NULL,48986510767,765414230,11959597,16.5),(143601,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143601,33.78,0.4,56.9,69062,NULL,NULL,'mean','ESO 104-IG 012 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143602,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143602,34.32,0.47,73.2,69063,70,NULL,'H, UH88/IRSF/2MASS','UGC 11355',NULL,'2011A&A...531A..87I',2011,1,1.2,NULL,'G',0.000033,NULL,'14.2',0.7,'Sb',NULL,NULL,NULL,NULL,1,281.987416667,22.94253,1.097,NULL,54597025211,853078518,13329351,14.2),(143603,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143603,34.32,0.47,73.2,69063,70,NULL,'H, 2MASS','UGC 11355',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143604,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143604,35.58,0.51,131,69064,70,NULL,NULL,'2MASX J18475760-8008575',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,281.990375,-80.14925,0.493,NULL,48538232194,758409878,11850154,17),(143605,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143605,33.83,0.4,58.3,69065,NULL,NULL,'mean','2MASX J18480210-6336094',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'G',0.00014,NULL,'15.70',NULL,'S0','Group member',NULL,NULL,NULL,1,282.00875,-63.60261,0.313,NULL,48983077964,765360593,11958759,15.7),(143606,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143606,34.28,0.45,71.8,69065,NULL,NULL,'K','2MASX J18480210-6336094',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143607,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143607,33.97,0.4,62.1,69066,NULL,NULL,'mean','2MASX J18480798-6312353',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'G',0.000077,NULL,'16',NULL,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,282.033125,-63.20989,0.277,NULL,48986515495,765414304,11959598,16),(143608,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143608,34.71,0.45,87.4,69066,NULL,NULL,'K','2MASX J18480798-6312353',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143609,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,'R',143609,35.45,0.49,123,69067,75,NULL,'IR','ESO 104- G 014',NULL,'2011yCatp016004901K',2011,1,1.12,'ESO-LV gives v= 10224+/- 10 km/sec.','G',0.000033,NULL,'16.22',0.15,'SA(rs)bc:','Group member',NULL,NULL,NULL,1,282.09275,-63.21758,0.277,NULL,48986516447,765414319,11959598,16.22),(143610,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143610,35.62,0.49,133,69067,NULL,NULL,'Malmquist cor.','ESO 104- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143611,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143611,35.68,0.48,137,69067,NULL,NULL,NULL,'ESO 104- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143612,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143612,35.72,0.2,139,69067,74.4,NULL,NULL,'ESO 104- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143613,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143613,36.21,NULL,174,69067,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 104- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143614,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143614,36.23,NULL,176,69067,NULL,NULL,'Dipole + Quadrupole','ESO 104- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143615,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143615,36.26,NULL,178,69067,NULL,NULL,'Dipole','ESO 104- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143616,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143616,36.08,0.57,165,69068,70,NULL,NULL,'2MASX J18482619-5243132',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,282.1090417,-52.72028,0.157,NULL,48899853468,764060210,11938440,15.5),(143617,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143617,33.07,0.8,41.1,69069,75,NULL,'MAT, I','IC 4775',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.69',0.3,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,282.109541667,-57.18372,0.285,NULL,49108070867,767313607,11989275,14.69),(143618,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143618,33.02,0.32,40.2,69069,85,NULL,'I, raw','IC 4775',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143619,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143619,33.03,0.32,40.4,69069,85,NULL,'I, inv','IC 4775',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143620,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143620,33.22,0.43,44.1,69069,75,NULL,'MAT, I, raw','IC 4775',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143621,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143621,33.32,0.43,46.1,69069,75,NULL,'MAT, I, inv','IC 4775',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143622,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143622,33.45,0.44,49,69069,NULL,NULL,NULL,'IC 4775',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143623,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,'R',143623,33.48,0.49,49.8,69069,75,NULL,'IR','IC 4775',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143624,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143624,33.49,0.2,49.9,69069,74.4,NULL,NULL,'IC 4775',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143625,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143625,33.54,0.43,51.1,69069,75,NULL,'MAT, I, cor','IC 4775',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143626,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143626,33.67,0.39,54.3,69069,NULL,NULL,'Malmquist cor.','IC 4775',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143627,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143627,34.81,0.47,91.5,69070,70,NULL,NULL,'ESO 281- G 027',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000143,NULL,'13.8R',0.5,'S0',NULL,NULL,NULL,NULL,1,282.119417,-44.09064,0.365,NULL,51068905619,797951650,12467994,13.8),(143628,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143628,35.42,0.59,121,69071,70,NULL,NULL,'2MASX J18484589-5714081',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,282.191333333,-57.23561,0.285,NULL,49108064832,767313513,11989273,15.9),(143629,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143629,30.66,0.14,13.6,69072,74.4,NULL,NULL,'NGC 6684',NULL,'2013AJ....146...86T',2013,1,4,NULL,'G',0.000006,NULL,'11.31',2.6,'(L)SB(r)0^+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,282.241167,-65.17344,0.225,NULL,48981724804,765339450,11958428,11.31),(143630,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143630,30.72,0.24,13.9,69072,NULL,NULL,'I','NGC 6684',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143631,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143631,30.72,0.24,13.9,69072,NULL,NULL,NULL,'NGC 6684',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143632,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143632,30.79,0.24,14.4,69072,NULL,NULL,'Malmquist cor.','NGC 6684',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143633,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143633,30.77,0.4,14.3,69072,75,NULL,'Edat, raw','NGC 6684',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143634,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143634,30.95,0.4,15.5,69072,75,NULL,'Edat, cor','NGC 6684',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143635,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143635,28.72,0.63,5.55,69072,95,NULL,'Michard 1979b, c','NGC 6684',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143636,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,'R',143636,29.17,NULL,6.82,69072,NULL,NULL,'LEDA [April 2006]','NGC 6684',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143637,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143637,29.44,0.37,7.73,69072,95,NULL,'Weighted Mean','NGC 6684',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143638,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143638,29.74,0.46,8.87,69072,95,NULL,'Michard 1979a','NGC 6684',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143639,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143639,30.64,0.81,13.4,69072,55,NULL,'Visvanathan & Sandage 1979','NGC 6684',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143640,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143640,29.49,0.41,7.89,69072,NULL,NULL,NULL,'NGC 6684',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143641,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143641,29.7,0.41,8.72,69072,NULL,NULL,'Malmquist cor.','NGC 6684',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143642,'Tully est','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143642,30.18,0.8,10.9,69072,75,NULL,'B','NGC 6684',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143643,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143643,29.7,NULL,8.71,69072,NULL,NULL,NULL,'NGC 6684',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143644,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143644,36.81,0.54,230,69073,70,NULL,NULL,'2MASX J18492490-4359392',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,282.353833,-43.99422,0.289,NULL,51068486148,797945096,12467892,14.9),(143645,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143645,36.92,0.89,242,69074,70,NULL,NULL,'2MASX J18493744-7134486',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,282.406166667,-71.58011,0.217,NULL,48465160312,757268129,11832314,16),(143646,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143646,35.94,0.55,154,69075,70,NULL,NULL,'2MASX J18500333-5958223',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,282.514041667,-59.97292,0.389,NULL,49111324466,767364444,11990069,14.6),(143647,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143647,35.48,0.48,124,69076,NULL,NULL,'Malmquist cor.','ESO 231- G 004',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.10',0.7,'Sb-c',NULL,NULL,NULL,NULL,1,282.518791667,-50.76653,0.237,NULL,48895798414,763996850,11937450,15.1),(143648,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143648,35.59,0.46,131,69076,NULL,NULL,NULL,'ESO 231- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143649,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143649,35.63,0.2,134,69076,74.4,NULL,NULL,'ESO 231- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143650,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,'R',143650,34.06,0.49,65,69077,75,NULL,'IR','UGC 11390',NULL,'2011yCatp016004901K',2011,1,1.28,NULL,'G',NULL,NULL,'16.5',0.16,'Sc',NULL,NULL,NULL,NULL,1,282.685875,84.58278,0.269,NULL,52672538121,823008408,12859506,16.5),(143651,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143651,34.9,NULL,95.5,69077,NULL,NULL,'Dipole + Quadrupole','UGC 11390',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143652,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143652,34.9,NULL,95.7,69077,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11390',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143653,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143653,34.91,NULL,95.7,69077,NULL,NULL,'Dipole','UGC 11390',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143654,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143654,35.03,NULL,101,69077,NULL,NULL,NULL,'UGC 11390',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143655,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143655,36.08,0.58,165,69078,70,NULL,NULL,'2MASX J18505589-2941406',NULL,'2014MNRAS.445.2677S',2014,1,0.1,NULL,'G',0.00015,NULL,'14.3R',0.1,NULL,NULL,NULL,NULL,NULL,1,282.732833,-29.69467,0.585,NULL,47769391742,746396745,11662449,14.3),(143656,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143656,35.36,0.8,118,69079,75,NULL,'CF, r','UGC 11373',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000147,NULL,'14.82',0.5,'Sb',NULL,NULL,NULL,NULL,1,282.866375,58.08278,0.229,NULL,53143824535,830372258,12974566,14.82),(143657,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143657,35.1,0.38,105,69079,75,NULL,'CF, r, raw','UGC 11373',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143658,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143658,35.29,0.38,114,69079,75,NULL,'CF, r, inv','UGC 11373',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143659,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143659,35.32,0.38,116,69079,75,NULL,'CF, r, cor','UGC 11373',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143660,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143660,35.58,0.4,131,69079,NULL,NULL,'mean','UGC 11373',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143661,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143661,35.64,0.47,134,69079,NULL,NULL,'H','UGC 11373',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143662,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143662,35.75,0.45,141,69079,NULL,NULL,'K','UGC 11373',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143663,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143663,33.37,0.69,47.2,69080,100,NULL,'mid-IR','UGC 11369',NULL,'2013ApJ...771...88L',2013,1,1.1,NULL,'G',0.000117,NULL,'14.1',0.6,'SBa:',NULL,NULL,NULL,NULL,1,282.9072917,23.63475,1.165,NULL,54593308426,853020444,13328444,14.1),(143664,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143664,34.65,0.37,85,69081,NULL,NULL,'Malmquist cor.','ESO 336- G 018',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.06',0.5,'Sb:',NULL,NULL,NULL,NULL,1,282.931166667,-40.93358,0.349,NULL,51049907586,797654806,12463356,14.06),(143665,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143665,34.66,0.37,85.4,69081,NULL,NULL,NULL,'ESO 336- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143666,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143666,34.7,0.2,87.1,69081,74.4,NULL,NULL,'ESO 336- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143667,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143667,34.24,0.54,70.5,69082,70,NULL,NULL,'2MASX J18514671-5234217',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,282.9447917,-52.57275,0.161,NULL,48902971534,764108930,11939202,14.7),(143668,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143668,33.41,0.43,48.1,69083,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11371',NULL,'2014MNRAS.444..527S',2014,1,1.6,NULL,'G',0.00002,NULL,'14.3',0.6,'Sc;HSB','in a triple',NULL,NULL,NULL,1,282.9839583,26.48822,1.109,NULL,54426428054,850412938,13287702,14.3),(143669,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',143669,33.43,0.49,48.5,69083,75,NULL,'IR','UGC 11371',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143670,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143670,33.43,0.47,48.5,69083,NULL,NULL,'H','UGC 11371',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143671,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143671,33.45,0.43,49,69083,75,NULL,'3.6 micron, color corrected','UGC 11371',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143672,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143672,33.46,0.46,49.2,69083,NULL,NULL,'J','UGC 11371',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143673,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143673,33.46,0.45,49.3,69083,NULL,NULL,'K','UGC 11371',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143674,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143674,33.48,0.2,49.7,69083,74.4,NULL,NULL,'UGC 11371',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143675,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143675,33.56,0.4,51.6,69083,NULL,NULL,'mean','UGC 11371',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143676,'Ring Diameter','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143676,34.1,0.84,66,69084,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 6699',NULL,'1981ApJS...45..541P',1981,1,1.5,NULL,'G',0.000034,NULL,'12.64',1.5,'SAB(s)bc',NULL,NULL,NULL,NULL,1,283.0085,-57.32075,0.289,NULL,49122505250,767539144,11992799,12.64),(143677,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143677,33.79,0.48,57.2,69085,70,NULL,NULL,'ESO 281- G 031',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'13.1R',0.8,'SB(rl)0^0',NULL,NULL,NULL,NULL,1,283.069625,-47.00764,0.261,NULL,51030205005,797346953,12458546,13.1),(143678,'Tully est','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143678,30.49,0.8,12.6,69086,75,NULL,NULL,'NGC 6684A',NULL,'1988NBGC.C....0000T',1988,1,3,NULL,'G',0.000007,NULL,'13.20',1.9,'IB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,283.095083,-64.83147,0.225,NULL,48981438423,765334975,11958358,13.2),(143679,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143679,35.59,0.48,131,69087,NULL,NULL,'Malmquist cor.','ESO 231- G 005',NULL,'2009ApJS..182..474S',2009,1,1.14,NULL,'G',0.000033,NULL,'16.33',0.13,'Sc',NULL,NULL,NULL,NULL,1,283.0989583,-48.35544,0.237,NULL,51031159737,797361870,12458779,16.33),(143680,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143680,35.66,NULL,136,69087,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 231- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143681,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143681,35.69,NULL,137,69087,NULL,NULL,'Dipole + Quadrupole','ESO 231- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143682,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143682,35.7,NULL,138,69087,NULL,NULL,'Dipole','ESO 231- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143683,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143683,35.71,NULL,139,69087,NULL,NULL,NULL,'ESO 231- G 005',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143684,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143684,35.79,0.44,144,69087,NULL,NULL,NULL,'ESO 231- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143685,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143685,35.83,0.2,147,69087,74.4,NULL,NULL,'ESO 231- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143686,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',143686,34.53,0.49,80.4,69088,75,NULL,'IR','UGC 11377',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.0001,NULL,'15.65',0.16,'Scd',NULL,NULL,NULL,NULL,1,283.1002917,73.19203,0.337,NULL,52742184269,824096629,12876509,15.65),(143687,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143687,34.75,NULL,89.1,69088,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11377',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143688,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143688,34.76,NULL,89.5,69088,NULL,NULL,'Dipole + Quadrupole','UGC 11377',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143689,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143689,34.76,NULL,89.6,69088,NULL,NULL,'Dipole','UGC 11377',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143690,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143690,34.82,NULL,92.1,69088,NULL,NULL,NULL,'UGC 11377',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143691,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143691,34.95,0.43,97.6,69088,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11377',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143692,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143692,33.83,0.8,58.4,69089,75,NULL,'MAT, I','ESO 231- G 006',NULL,'1997ApJS..109..333W',1997,1,1.55,'Marginal HIPASS detection.','G',0.000033,NULL,'15.66',0.19,'Scd',NULL,NULL,NULL,NULL,1,283.154875,-51.46781,0.237,NULL,48903862748,764122855,11939419,15.66),(143693,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143693,33.52,0.32,50.5,69089,85,NULL,'I, inv','ESO 231- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143694,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143694,33.52,0.32,50.6,69089,85,NULL,'I, raw','ESO 231- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143695,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143695,33.68,0.43,54.6,69089,75,NULL,'MAT, I, raw','ESO 231- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143696,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143696,33.72,0.43,55.6,69089,75,NULL,'MAT, I, inv','ESO 231- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143697,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143697,33.81,0.5,57.8,69089,NULL,NULL,NULL,'ESO 231- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143698,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143698,33.85,0.2,58.9,69089,74.4,NULL,NULL,'ESO 231- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143699,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',143699,33.9,0.49,60.3,69089,75,NULL,'IR','ESO 231- G 006',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143700,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143700,33.94,NULL,61.4,69089,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 231- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143701,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143701,33.95,NULL,61.7,69089,NULL,NULL,'Dipole + Quadrupole','ESO 231- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143702,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143702,33.96,NULL,62,69089,NULL,NULL,'Dipole','ESO 231- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143703,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143703,33.97,0.43,62.4,69089,75,NULL,'MAT, I, cor','ESO 231- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143704,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143704,34.03,NULL,63.8,69089,NULL,NULL,NULL,'ESO 231- G 006',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143705,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143705,34.08,0.45,65.3,69089,NULL,NULL,'Malmquist cor.','ESO 231- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143706,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143706,33.81,0.4,57.8,69090,75,NULL,'Edat, raw','IC 4784',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00013,NULL,'13.71',1.1,'S0?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,283.200083333,-63.25961,0.221,NULL,48982183092,765346610,11958540,13.71),(143707,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143707,33.85,0.4,58.8,69090,75,NULL,'Edat, cor','IC 4784',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143708,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143708,34.67,0.25,85.9,69090,74.4,NULL,NULL,'IC 4784',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143709,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143709,34.08,0.4,65.6,69090,NULL,NULL,'mean','IC 4784',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143710,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143710,34.73,0.45,88.3,69090,NULL,NULL,'K','IC 4784',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143711,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143711,34.42,0.48,76.6,69091,70,NULL,NULL,'2MASX J18525345-5420296',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,283.222666667,-54.34167,0.277,NULL,49080979112,766890298,11982660,14.8),(143712,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143712,35.51,0.64,126,69092,70,NULL,NULL,'2MASX J18525387-5250281',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,283.224375,-52.84114,0.145,NULL,48898542375,764039724,11938120,15.1),(143713,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143713,33.43,0.48,48.5,69093,70,NULL,NULL,'IC 4785',NULL,'2014MNRAS.445.2677S',2014,1,3.1,NULL,'G',0.000017,NULL,'13.09',1.4,'(R\'_2)SB(r)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,283.230125,-59.25542,0.301,NULL,49111776107,767371501,11990179,13.09),(143714,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143714,33.14,0.8,42.5,69093,75,NULL,'MAT, I','IC 4785',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143715,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143715,33.02,0.43,40.2,69093,75,NULL,'MAT, I, raw','IC 4785',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143716,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143716,33.11,0.47,41.9,69093,NULL,NULL,'H','IC 4785',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143717,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143717,33.2,0.32,43.7,69093,85,NULL,'I, raw','IC 4785',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143718,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143718,33.24,0.45,44.5,69093,NULL,NULL,'K','IC 4785',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143719,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143719,33.26,0.46,44.9,69093,NULL,NULL,'J','IC 4785',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143720,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143720,33.27,0.32,45.1,69093,85,NULL,'I, inv','IC 4785',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143721,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143721,33.29,0.43,45.6,69093,75,NULL,'MAT, I, inv','IC 4785',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143722,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143722,33.39,0.43,47.7,69093,75,NULL,'MAT, I, cor','IC 4785',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143723,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143723,33.44,0.4,48.7,69093,NULL,NULL,'mean','IC 4785',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143724,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143724,33.51,0.2,50.4,69093,74.4,NULL,NULL,'IC 4785',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143725,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',143725,35.07,0.49,103,69094,75,NULL,'IR','ESO 336- G 020',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'16.2b',0.2,'Sb:',NULL,NULL,NULL,NULL,1,283.3964583,-40.01803,0.349,NULL,51052829978,797700468,12464069,16.2),(143726,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143726,35.12,0.54,106,69094,NULL,NULL,'Malmquist cor.','ESO 336- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143727,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143727,35.44,0.47,123,69094,NULL,NULL,NULL,'ESO 336- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143728,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143728,35.48,0.2,125,69094,74.4,NULL,NULL,'ESO 336- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143729,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143729,36.73,0.89,221,69095,70,NULL,NULL,'2MASX J18534293-5249526',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,283.428875,-52.83131,0.145,NULL,48903065357,764110396,11939224,15.6),(143730,'BL Lac Luminosity','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143730,40.13,NULL,876,69096,NULL,NULL,NULL,'1RXS J185351.0+671356',0.212,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',NULL,NULL,'16.4',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,283.467,67.23214,0.225,NULL,53561231859,836894247,13076472,16.4),(143731,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',143731,34.59,0.49,82.8,69097,75,NULL,'IR','ESO 281- G 035',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'13.60',0.3,'S...',NULL,NULL,NULL,NULL,1,283.5454583,-42.93339,0.293,NULL,51055013170,797734580,12464602,13.6),(143732,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143732,34.64,0.38,84.8,69097,NULL,NULL,'Malmquist cor.','ESO 281- G 035',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143733,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143733,34.8,0.36,91.1,69097,NULL,NULL,NULL,'ESO 281- G 035',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143734,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143734,34.84,0.2,92.9,69097,74.4,NULL,NULL,'ESO 281- G 035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143735,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143735,35.13,0.66,106,69098,70,NULL,NULL,'2MASX J18541146-4438450',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,283.547667,-44.64592,0.265,NULL,51055912288,797748629,12464822,15.3),(143736,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143736,34.37,0.8,74.7,69099,75,NULL,'MAT, I','ESO 396- G 007',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000033,NULL,'14',0.7,'Sc:            HII',NULL,NULL,NULL,NULL,1,283.592541667,-34.61119,0.325,NULL,47751481978,746116905,11658076,14),(143737,'Sosies','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143737,34.47,0.15,78.3,69099,NULL,NULL,NULL,'ESO 396- G 007',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143738,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143738,33.81,0.43,57.8,69099,75,NULL,'MAT, I, raw','ESO 396- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143739,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143739,33.92,0.32,60.8,69099,85,NULL,'I, raw','ESO 396- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143740,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143740,33.99,0.32,62.8,69099,85,NULL,'I, inv','ESO 396- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143741,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143741,34.02,0.2,63.7,69099,74.4,NULL,NULL,'ESO 396- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143742,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143742,34.04,0.43,64.2,69099,75,NULL,'3.6 micron, color corrected','ESO 396- G 007',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143743,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143743,34.1,0.43,66.2,69099,75,NULL,'MAT, I, inv','ESO 396- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143744,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143744,34.14,0.43,67.3,69099,75,NULL,'3.6 micron, color + selection bias corrected','ESO 396- G 007',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143745,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143745,34.21,0.43,69.5,69099,75,NULL,'MAT, I, cor','ESO 396- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143746,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143746,35.94,0.58,154,69100,70,NULL,NULL,'2MASX J18551285-4725315',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,283.803583333,-47.42544,0.229,NULL,51033016676,797390885,12459232,15.5),(143747,'Carbon Stars','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143747,16.71,0.57,0.022,69101,NULL,NULL,'Carbon star S29, RA 289.7724, DEC -30.9072','Sagittarius Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,1,450,'Likely associated with M54; not the same as Sagittarius Dwarf Irregular Galaxy.','G',NULL,NULL,'4.5',216,'dSph(t)',NULL,NULL,NULL,NULL,1,283.83125,-30.54528,0.557,0,47753037814,746141215,11658456,4.5),(143748,'Carbon Stars','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143748,16.99,0.57,0.025,69101,NULL,NULL,'Carbon star S31, RA 292.2203, DEC -29.5899','Sagittarius Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143749,'Carbon Stars','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143749,17.39,0.57,0.03,69101,NULL,NULL,'Carbon star S28, RA 288.9922, DEC -30.5467','Sagittarius Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143750,'Carbon Stars','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143750,17.45,NULL,0.031,69101,NULL,NULL,'PL','Sagittarius Dwarf Spheroidal',NULL,'2009MNRAS.396..598L',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143751,'Carbon Stars','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143751,17.5,NULL,0.032,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'2009MNRAS.396..598L',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143752,'Carbon Stars','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143752,17.66,0.57,0.034,69101,NULL,NULL,'Carbon star S30, RA 290.9395, DEC -34.5209','Sagittarius Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143753,'Carbon Stars','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143753,17.9,0.57,0.038,69101,NULL,NULL,'Carbon star S32, RA 295.7120, DEC -33.5759','Sagittarius Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143754,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143754,16.67,0.19,0.0216,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'2002ApJ...573L..19M',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143755,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143755,16.9,0.17,0.024,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'1995MNRAS.277..781I',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143756,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',143756,16.95,NULL,0.0246,69101,NULL,NULL,'MESSIER 054, NGC 6715','Sagittarius Dwarf Spheroidal',NULL,'2000yCat..33300453M',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143757,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',143757,16.99,NULL,0.025,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'1994Natur.370..194I',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143758,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143758,17.05,0.05,0.0253,69101,NULL,NULL,'Terzan 7','Sagittarius Dwarf Spheroidal',NULL,'2011ApJ...743...20S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143759,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143759,17.09,0.17,0.0262,69101,NULL,NULL,'outer','Sagittarius Dwarf Spheroidal',NULL,'2002MNRAS.332...91D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143760,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143760,17.1,NULL,0.0263,69101,NULL,NULL,'CMD at 12 Gyr','Sagittarius Dwarf Spheroidal',NULL,'1996ApJ...459L..65F',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143761,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',143761,17.1,NULL,0.0263,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'2008MmSAI..79..692C',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143762,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143762,17.1,NULL,0.0263,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'2006A&A...446L...1B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143763,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143763,17.11,0.14,0.0264,69101,NULL,NULL,'central','Sagittarius Dwarf Spheroidal',NULL,'2002MNRAS.332...91D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143764,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143764,17.17,0.12,0.0272,69101,NULL,NULL,'NGC 5634, GC','Sagittarius Dwarf Spheroidal',NULL,'2002AJ....124..915B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143765,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143765,17.24,0.2,0.028,69101,NULL,NULL,'AM 4, AM 4, MW center, 8.0 kpc','Sagittarius Dwarf Spheroidal',NULL,'2009AJ....137.3809C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143766,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143766,17.26,0.05,0.0283,69101,NULL,NULL,'Terzan 8','Sagittarius Dwarf Spheroidal',NULL,'2011ApJ...743...20S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143767,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143767,17.27,NULL,0.0284,69101,NULL,NULL,'MESSIER 054, NGC 6715','Sagittarius Dwarf Spheroidal',NULL,'2007ApJ...667L..57S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143768,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143768,17.27,0.05,0.0284,69101,NULL,NULL,'MESSIER 054','Sagittarius Dwarf Spheroidal',NULL,'2011ApJ...743...20S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143769,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143769,17.3,NULL,0.0289,69101,NULL,NULL,'CMD at 10 Gyr','Sagittarius Dwarf Spheroidal',NULL,'1996ApJ...459L..65F',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143770,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143770,17.3,NULL,0.0289,69101,NULL,NULL,'SGR center, unweighted mean of 9 CMD','Sagittarius Dwarf Spheroidal',NULL,'2011ApJ...743...20S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143771,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143771,17.32,NULL,0.0291,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143772,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143772,17.32,NULL,0.0291,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143773,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143773,17.33,0.05,0.0292,69101,NULL,NULL,'SGR debris behind NGC 6624','Sagittarius Dwarf Spheroidal',NULL,'2011ApJ...743...20S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143774,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143774,17.34,0.14,0.0294,69101,NULL,NULL,'WHI B0200-03, Whiting 1','Sagittarius Dwarf Spheroidal',NULL,'2007A&A...466..181C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143775,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143775,17.34,0.05,0.0294,69101,NULL,NULL,'Arp 2','Sagittarius Dwarf Spheroidal',NULL,'2011ApJ...743...20S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143776,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143776,17.34,0.05,0.0294,69101,NULL,NULL,'SGR debris behind NGC 6809','Sagittarius Dwarf Spheroidal',NULL,'2011ApJ...743...20S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143777,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143777,17.35,0.05,0.0295,69101,NULL,NULL,'SGR debris behind NGC 6637','Sagittarius Dwarf Spheroidal',NULL,'2011ApJ...743...20S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143778,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143778,17.41,NULL,0.0304,69101,NULL,NULL,'SGR center, weighted mean of 9 CMD','Sagittarius Dwarf Spheroidal',NULL,'2011ApJ...743...20S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143779,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143779,17.42,0.05,0.0305,69101,NULL,NULL,'SGR debris behind NGC 6652','Sagittarius Dwarf Spheroidal',NULL,'2011ApJ...743...20S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143780,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143780,17.42,0.05,0.0305,69101,NULL,NULL,'SGR debris behind NGC 6681','Sagittarius Dwarf Spheroidal',NULL,'2011ApJ...743...20S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143781,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143781,17.48,0.1,0.0313,69101,NULL,NULL,'NIR, WHI B0200-03, Whiting 1','Sagittarius Dwarf Spheroidal',NULL,'2015MNRAS.446..730V',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143782,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143782,17.7,0.2,0.035,69101,NULL,NULL,'AM 4, AM 4, heliocentric','Sagittarius Dwarf Spheroidal',NULL,'2009AJ....137.3809C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143783,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143783,18.4,NULL,0.045,69101,NULL,NULL,'WHI B0200-03, Whiting 1','Sagittarius Dwarf Spheroidal',NULL,'2005ApJ...621L..61C',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143784,'Horizontal Branch','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143784,16.38,NULL,0.0189,69101,NULL,NULL,'MESSIER 054, NGC 6715, D(GSR)','Sagittarius Dwarf Spheroidal',NULL,'1996AJ....112.1487H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143785,'Horizontal Branch','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143785,16.95,NULL,0.025,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'1998A&A...330..453M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143786,'Horizontal Branch','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143786,17,0.18,0.0251,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'1995AJ....109.2533D',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143787,'Horizontal Branch','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143787,17.25,0.2,0.028,69101,NULL,NULL,'D(helio)','Sagittarius Dwarf Spheroidal',NULL,'1999MNRAS.304..633B',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143788,'M Stars','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143788,17.85,NULL,0.0372,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'2010ApJ...722..750S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143789,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143789,16.71,0.1,0.022,69101,NULL,NULL,'30','Sagittarius Dwarf Spheroidal',NULL,'1997ApJ...474..217A',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143790,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143790,16.9,0.08,0.024,69101,NULL,NULL,'313 RRab','Sagittarius Dwarf Spheroidal',NULL,'1996ApJ...458L..17A',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143791,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',143791,16.94,0.07,0.0243,69101,NULL,NULL,'150, MW center 8.0 kpc','Sagittarius Dwarf Spheroidal',NULL,'2009AAS...21332501K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143792,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143792,16.97,0.07,0.0248,69101,NULL,NULL,'203','Sagittarius Dwarf Spheroidal',NULL,'2009AJ....137.4478K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143793,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',143793,16.97,0.78,0.0248,69101,NULL,NULL,'2','Sagittarius Dwarf Spheroidal',NULL,'1998AcA....48..341M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143794,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143794,17,NULL,0.025,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'1995AJ....109..588M',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143795,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143795,17,0.07,0.0251,69101,NULL,NULL,'Sgr Clump, Z(0.15[Fe/H]+1.01)','Sagittarius Dwarf Spheroidal',NULL,'1995AJ....109.1086S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143796,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143796,17.02,0.08,0.0253,69101,NULL,NULL,'MESSIER 054, NGC 6715, D(GSR), Z(0.15[Fe/H]+1.01)','Sagittarius Dwarf Spheroidal',NULL,'1995AJ....109.1086S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143797,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143797,17.02,0.19,0.0254,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'1995AJ....110.1141M',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143798,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143798,17.06,0.08,0.0258,69101,NULL,NULL,'Sgr RHB, Z(0.15[Fe/H]+1.01)','Sagittarius Dwarf Spheroidal',NULL,'1995AJ....109.1086S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143799,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143799,17.13,0.11,0.0267,69101,NULL,NULL,'MESSIER 054, NGC 6715, 154','Sagittarius Dwarf Spheroidal',NULL,'2010MNRAS.406..329S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143800,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143800,17.15,0.06,0.0269,69101,NULL,NULL,'Sgr Clump, Z(0.30[Fe/H]+0.94)','Sagittarius Dwarf Spheroidal',NULL,'1995AJ....109.1086S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143801,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143801,17.16,0.08,0.027,69101,NULL,NULL,'MESSIER 054, NGC 6715, D(GSR), M(V)RR = +0.6 mag','Sagittarius Dwarf Spheroidal',NULL,'1995AJ....109.1086S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143802,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143802,17.18,0.18,0.0273,69101,NULL,NULL,'tidal tail','Sagittarius Dwarf Spheroidal',NULL,'1996ApJ...458L..13M',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143803,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143803,17.19,0.03,0.0274,69101,NULL,NULL,'MESSIER 054, NGC 6715, 63, D(helio)','Sagittarius Dwarf Spheroidal',NULL,'2000AJ....119.1760L',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143804,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143804,17.2,0.07,0.0276,69101,NULL,NULL,'Sgr Clump, Z(0.17[Fe/H]+0.82)','Sagittarius Dwarf Spheroidal',NULL,'1995AJ....109.1086S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143805,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143805,17.22,NULL,0.0278,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'2011AJ....142..110M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143806,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143806,17.22,NULL,0.0278,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'2008ApJ...679...52T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143807,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143807,17.24,0.07,0.028,69101,NULL,NULL,'MESSIER 054, NGC 6715, D(GSR), Z(0.17[Fe/H]+0.82)','Sagittarius Dwarf Spheroidal',NULL,'1995AJ....109.1086S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143808,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143808,17.27,0.08,0.0285,69101,NULL,NULL,'Sgr RHB, M(V)RR = +0.6 mag','Sagittarius Dwarf Spheroidal',NULL,'1995AJ....109.1086S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143809,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143809,17.27,0.08,0.0285,69101,NULL,NULL,'Sgr RHB, Z(0.17[Fe/H]+0.82)','Sagittarius Dwarf Spheroidal',NULL,'1995AJ....109.1086S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143810,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143810,17.33,0.08,0.0292,69101,NULL,NULL,'Sgr RHB, Z(0.30[Fe/H]+0.94)','Sagittarius Dwarf Spheroidal',NULL,'1995AJ....109.1086S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143811,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143811,17.33,0.07,0.0293,69101,NULL,NULL,'Sgr Clump, M(V)RR = +0.6 mag','Sagittarius Dwarf Spheroidal',NULL,'1995AJ....109.1086S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143812,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143812,17.35,0.08,0.0295,69101,NULL,NULL,'MESSIER 054, NGC 6715, D(GSR), Z(0.30[Fe/H]+0.94)','Sagittarius Dwarf Spheroidal',NULL,'1995AJ....109.1086S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143813,'SX Phe Stars','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143813,17.23,NULL,0.0279,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'2011AJ....142..110M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143814,'TRGB','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',143814,16.5,NULL,0.02,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'2000glg..book.....V',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143815,'TRGB','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143815,16.93,0.19,0.0243,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'2013MNRAS.436..413M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143816,'TRGB','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143816,17.1,0.15,0.0263,69101,NULL,NULL,'D(helio)','Sagittarius Dwarf Spheroidal',NULL,'2004MNRAS.353..874M',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143817,'TRGB','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',143817,25.24,0.17,1.12,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143818,'Eclipsing Binary','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143818,16.6,0.3,0.0209,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'1995AJ....110.1141M',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143819,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143819,32.5,0.8,31.7,69102,75,NULL,'MAT, I','NGC 6707',NULL,'1997ApJS..109..333W',1997,1,2.1,'Confused HIPASS source','G',0.000021,NULL,'13.31',0.9,'SB(s)c?','in a pair',NULL,NULL,NULL,1,283.841917,-53.81844,0.297,NULL,48898874283,764044910,11938201,13.31),(143820,'Tully est','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143820,32.76,0.8,35.7,69102,75,NULL,NULL,'NGC 6707',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143821,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143821,32.25,0.32,28.2,69102,85,NULL,'I, raw','NGC 6707',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143822,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143822,32.28,0.32,28.6,69102,85,NULL,'I, inv','NGC 6707',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143823,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143823,32.37,0.43,29.7,69102,75,NULL,'MAT, I, raw','NGC 6707',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143824,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143824,32.53,0.43,32,69102,75,NULL,'MAT, I, inv','NGC 6707',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143825,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143825,32.58,0.46,32.9,69102,NULL,NULL,'J','NGC 6707',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143826,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143826,32.65,0.47,33.8,69102,NULL,NULL,'H','NGC 6707',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143827,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143827,32.65,0.4,33.8,69102,NULL,NULL,'mean','NGC 6707',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143828,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143828,32.67,0.45,34.2,69102,NULL,NULL,'K','NGC 6707',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143829,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143829,32.75,0.43,35.5,69102,75,NULL,'MAT, I, cor','NGC 6707',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143830,'Tully est','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143830,32.76,0.8,35.7,69103,75,NULL,NULL,'NGC 6708',NULL,'1988NBGC.C....0000T',1988,1,1.1,NULL,'G',0.000043,NULL,'12.7',0.9,'Sb:            HII','in a pair',NULL,NULL,NULL,1,283.8985,-53.72344,0.229,NULL,48898889146,764045142,11938205,12.7),(143831,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',143831,34.45,0.49,77.5,69104,75,NULL,'IR','ESO 396- G 008',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'13.27',0.3,'Sb:',NULL,NULL,NULL,NULL,1,283.9065,-34.72314,0.309,NULL,47748668690,746072948,11657389,13.27),(143832,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143832,34.63,0.34,84.5,69104,NULL,NULL,'Malmquist cor.','ESO 396- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143833,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143833,34.7,0.33,87,69104,NULL,NULL,NULL,'ESO 396- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143834,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143834,34.74,0.2,88.7,69104,74.4,NULL,NULL,'ESO 396- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143835,'TRGB','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143835,29.76,0.1,8.95,69105,74.4,NULL,NULL,'ESO 104- G 022',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000007,NULL,'15.56',1,'IB(s)m',NULL,NULL,NULL,NULL,1,283.921833,-64.81089,0.213,NULL,48981569444,765337022,11958390,15.56),(143836,'Tully est','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143836,29.93,0.8,9.7,69105,75,NULL,NULL,'ESO 104- G 022',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143837,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143837,29.13,NULL,6.7,69105,NULL,NULL,NULL,'ESO 104- G 022',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143838,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143838,34.86,0.48,93.6,69106,70,NULL,NULL,'2MASX J18554307-4646507',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'13.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,283.9295,-46.78069,0.225,NULL,51032315610,797379931,12459061,13.4),(143839,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143839,33.64,0.8,53.4,69107,75,NULL,'MAT, I','IC 4789',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'13.99',0.7,'SA(s)c:',NULL,NULL,NULL,NULL,1,284.077041667,-68.56711,0.213,NULL,49204352186,768818002,12012781,13.99),(143840,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143840,32.97,0.32,39.2,69107,85,NULL,'I, raw','IC 4789',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143841,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143841,32.97,0.32,39.3,69107,85,NULL,'I, inv','IC 4789',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143842,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143842,33.16,0.43,42.8,69107,75,NULL,'MAT, I, raw','IC 4789',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143843,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143843,33.22,0.43,44,69107,75,NULL,'MAT, I, inv','IC 4789',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143844,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143844,33.5,0.43,50,69107,75,NULL,'MAT, I, cor','IC 4789',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143845,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143845,33.85,0.09,59,69107,NULL,NULL,NULL,'IC 4789',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143846,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143846,34.05,0.46,64.4,69108,70,NULL,NULL,'ESO 337- G 002',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000117,NULL,'13.5',1.2,'Sa',NULL,NULL,NULL,NULL,1,284.082583,-40.97753,0.321,NULL,51047305227,797614144,12462721,13.5),(143847,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143847,33.88,0.8,59.8,69109,75,NULL,'MAT, I','ESO 281- G 038',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000027,NULL,'12.39',0.3,'SAa:',NULL,NULL,NULL,NULL,1,284.087375,-43.14686,0.273,NULL,51054895180,797732737,12464574,12.39),(143848,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143848,33.7,0.43,54.9,69109,75,NULL,'3.6 micron, color + selection bias corrected','ESO 281- G 038',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143849,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143849,33.84,0.43,58.6,69109,75,NULL,'3.6 micron, color corrected','ESO 281- G 038',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143850,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143850,33.93,0.45,61.2,69109,NULL,NULL,'K','ESO 281- G 038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143851,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143851,33.94,0.47,61.5,69109,NULL,NULL,'H','ESO 281- G 038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143852,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143852,33.96,0.32,62,69109,85,NULL,'I, raw','ESO 281- G 038',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143853,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143853,33.97,0.43,62.1,69109,75,NULL,'MAT, I, raw','ESO 281- G 038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143854,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143854,34.02,0.32,63.7,69109,85,NULL,'I, inv','ESO 281- G 038',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143855,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143855,34.03,0.4,64.1,69109,NULL,NULL,'mean','ESO 281- G 038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143856,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143856,34.04,0.2,64.3,69109,74.4,NULL,NULL,'ESO 281- G 038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143857,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143857,34.14,0.31,67.2,69109,NULL,NULL,NULL,'ESO 281- G 038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143858,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143858,34.17,0.46,68.1,69109,NULL,NULL,'J','ESO 281- G 038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143859,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143859,34.21,0.43,69.6,69109,75,NULL,'MAT, I, inv','ESO 281- G 038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143860,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143860,34.26,0.43,71.1,69109,75,NULL,'MAT, I, cor','ESO 281- G 038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143861,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143861,34.4,0.28,75.7,69109,NULL,NULL,'Malmquist cor.','ESO 281- G 038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143862,'Tully est','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143862,32.76,0.8,35.7,69110,75,NULL,NULL,'IC 4796',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.000057,NULL,'13.23',0.9,'SB(s)0^0^:','in a pair',NULL,NULL,NULL,1,284.116,-54.21394,0.285,NULL,49080019329,766875302,11982426,13.23),(143863,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143863,32.24,0.2,28.1,69111,NULL,NULL,'I','IC 4797',NULL,'2001ApJ...546..681T',2001,1,3,NULL,'G',0.000067,NULL,'12.30',1.3,'E+ pec:','in a pair',NULL,NULL,NULL,1,284.123667,-54.30578,0.285,NULL,49080013772,766875215,11982425,12.3),(143864,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143864,32.24,0.2,28.1,69111,NULL,NULL,NULL,'IC 4797',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143865,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143865,32.26,0.14,28.3,69111,74.4,NULL,NULL,'IC 4797',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143866,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143866,32.35,0.2,29.6,69111,NULL,NULL,'Malmquist cor.','IC 4797',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143867,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143867,31.66,0.4,21.4,69111,75,NULL,'Edat, raw','IC 4797',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143868,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143868,32.05,0.4,25.8,69111,75,NULL,'Edat, cor','IC 4797',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143869,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143869,30.14,0.63,10.7,69111,95,NULL,'Michard 1979b, c','IC 4797',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143870,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143870,31.1,0.46,16.6,69111,95,NULL,'Michard 1979a','IC 4797',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (143871,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143871,31.21,0.37,17.5,69111,95,NULL,'Weighted Mean','IC 4797',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143872,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143872,34.22,0.81,69.8,69111,55,NULL,'Visvanathan & Sandage 1979','IC 4797',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143873,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143873,32.61,0.41,33.3,69111,NULL,NULL,NULL,'IC 4797',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143874,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143874,33.01,0.41,40,69111,NULL,NULL,'Malmquist cor.','IC 4797',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143875,'Tully est','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143875,32.76,0.8,35.7,69111,75,NULL,'B','IC 4797',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143876,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143876,32.12,0.45,26.6,69111,NULL,NULL,'K','IC 4797',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143877,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143877,32.71,0.4,34.8,69111,NULL,NULL,'mean','IC 4797',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143878,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143878,33.71,0.8,55.3,69112,75,NULL,'HMCL, I','IC 4790',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000053,NULL,'13.94',0.7,'(R\')SAB(rs)bc',NULL,NULL,NULL,NULL,1,284.134208333,-64.92892,0.213,NULL,48981537935,765336530,11958383,13.94),(143879,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143879,33.36,0.47,47,69112,NULL,NULL,'H','IC 4790',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143880,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143880,33.39,0.45,47.7,69112,NULL,NULL,'K','IC 4790',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143881,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143881,33.44,0.46,48.8,69112,NULL,NULL,'J','IC 4790',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143882,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143882,33.59,0.4,52.1,69112,75,NULL,'HMCL, I, raw','IC 4790',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143883,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143883,33.76,0.4,56.5,69112,75,NULL,'HMCL, I, inv','IC 4790',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143884,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143884,33.78,0.4,56.9,69112,75,NULL,'HMCL, I, cor','IC 4790',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143885,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143885,33.85,0.4,58.8,69112,NULL,NULL,'mean','IC 4790',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143886,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143886,35.61,0.69,133,69113,70,NULL,NULL,'2MASX J18565078-6143382',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.8I',0.4,NULL,NULL,NULL,NULL,NULL,1,284.211583,-61.72733,0.261,NULL,48947216325,764800255,11950003,13.8),(143887,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143887,33.37,0.45,47.1,69114,NULL,NULL,'K','NGC 6706',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00007,NULL,'13.85',0.7,'S0-: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,284.212667,-63.16622,0.221,NULL,48951754176,764871159,11951111,13.85),(143888,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143888,33.54,0.4,51,69114,NULL,NULL,'mean','NGC 6706',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143889,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143889,32.19,0.43,27.4,69115,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11380',NULL,'2014MNRAS.444..527S',2014,1,1.5,NULL,'G',0.00006,NULL,'13.7',0.6,'Sab',NULL,NULL,NULL,NULL,1,284.212667,36.62397,0.401,NULL,54778309228,855911081,13373610,13.7),(143890,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143890,32.97,0.47,39.2,69115,NULL,NULL,'H','UGC 11380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143891,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143891,32.97,0.46,39.2,69115,NULL,NULL,'J','UGC 11380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143892,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143892,32.99,0.45,39.6,69115,NULL,NULL,'K','UGC 11380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143893,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143893,32.99,0.4,39.7,69115,NULL,NULL,'mean','UGC 11380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143894,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143894,33.92,0.4,60.8,69116,NULL,NULL,'mean','IC 4793',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000033,NULL,'14.55',0.6,'Sb',NULL,NULL,NULL,NULL,1,284.231667,-61.39978,0.253,NULL,48943661791,764744715,11949136,14.55),(143895,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143895,34.03,0.08,64.1,69116,NULL,NULL,NULL,'IC 4793',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143896,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143896,34.29,0.47,72.2,69116,NULL,NULL,'H','IC 4793',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143897,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143897,34.31,0.46,72.8,69116,NULL,NULL,'J','IC 4793',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143898,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143898,32.8,0.54,36.3,69117,NULL,NULL,NULL,'ESO 183- G 030',NULL,'2001MNRAS.327.1004B',2001,1,1.9,NULL,'G',0.000107,NULL,'12.65',1.4,'SA0- pec?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,284.233083333,-54.54544,0.293,NULL,49081639427,766900616,11982822,12.65),(143899,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143899,33.42,0.54,48.4,69117,NULL,NULL,'Malmquist cor.','ESO 183- G 030',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143900,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143900,31.66,0.4,21.4,69117,75,NULL,'Edat, raw','ESO 183- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143901,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143901,32.05,0.4,25.8,69117,75,NULL,'Edat, cor','ESO 183- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143902,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143902,31.95,0.41,24.6,69117,NULL,NULL,NULL,'ESO 183- G 030',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143903,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143903,32.42,0.41,30.4,69117,NULL,NULL,'Malmquist cor.','ESO 183- G 030',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143904,'Tully est','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143904,32.76,0.8,35.7,69117,75,NULL,'B','ESO 183- G 030',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143905,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143905,37.01,0.84,252,69118,70,NULL,NULL,'2MASX J18570281-4742569',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,284.26175,-47.71581,0.205,NULL,51032557180,797383705,12459120,15.4),(143906,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143906,34.02,0.09,63.8,69119,NULL,NULL,NULL,'IC 4795',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.76',0.2,'S...',NULL,NULL,NULL,NULL,1,284.318166667,-61.60908,0.261,NULL,48947172680,764799573,11949993,15.76),(143907,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143907,32.93,0.8,38.5,69120,75,NULL,'MAT, I','ESO 281- G 040',NULL,'1997ApJS..109..333W',1997,1,1.81,NULL,'G',0.000038,NULL,'15.35',0.22,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,284.326667,-47.05861,0.225,NULL,51032967410,797390115,12459220,15.35),(143908,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143908,32.75,NULL,35.4,69120,NULL,NULL,'Dipole + Quadrupole','ESO 281- G 040',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143909,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143909,32.75,NULL,35.4,69120,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 281- G 040',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143910,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143910,32.76,NULL,35.7,69120,NULL,NULL,'Dipole','ESO 281- G 040',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143911,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143911,32.84,NULL,37,69120,NULL,NULL,NULL,'ESO 281- G 040',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143912,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143912,33.61,0.32,52.7,69120,85,NULL,'I, inv','ESO 281- G 040',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143913,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143913,33.65,0.32,53.6,69120,85,NULL,'I, raw','ESO 281- G 040',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143914,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143914,33.85,0.43,58.9,69120,75,NULL,'MAT, I, inv','ESO 281- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143915,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143915,33.92,0.43,60.9,69120,75,NULL,'MAT, I, raw','ESO 281- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143916,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143916,34.2,0.43,69.1,69120,75,NULL,'MAT, I, cor','ESO 281- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143917,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143917,34.01,0.8,63.5,69121,75,NULL,'MAT, I','ESO 231- G 011',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000013,NULL,'14.06',0.5,'SAB:(r:)c',NULL,NULL,NULL,NULL,1,284.417333,-47.55072,0.205,NULL,51033111146,797392361,12459255,14.06),(143918,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143918,33.67,0.32,54.3,69121,85,NULL,'I, raw','ESO 231- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143919,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143919,33.68,0.43,54.4,69121,75,NULL,'MAT, I, raw','ESO 231- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143920,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143920,33.72,0.32,55.5,69121,85,NULL,'I, inv','ESO 231- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143921,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143921,33.81,0.47,57.7,69121,NULL,NULL,'H','ESO 231- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143922,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143922,33.9,0.43,60.2,69121,75,NULL,'MAT, I, inv','ESO 231- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143923,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143923,33.94,0.46,61.4,69121,NULL,NULL,'J','ESO 231- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143924,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143924,33.98,0.45,62.4,69121,NULL,NULL,'K','ESO 231- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143925,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143925,34.05,0.43,64.4,69121,75,NULL,'MAT, I, cor','ESO 231- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143926,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143926,34.09,0.4,65.7,69121,NULL,NULL,'mean','ESO 231- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143927,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143927,34.27,0.28,71.4,69121,NULL,NULL,NULL,'ESO 231- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143928,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143928,34.31,0.2,72.8,69121,74.4,NULL,NULL,'ESO 231- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143929,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143929,34.32,0.27,73.1,69121,NULL,NULL,'Malmquist cor.','ESO 231- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143930,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143930,34.01,NULL,63.4,69122,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2231',NULL,'2010Ap&SS.325..163P',2010,1,1.06,NULL,'G',NULL,NULL,'16.42',0.11,'Sc',NULL,NULL,NULL,NULL,1,284.5044583,42.22364,0.373,NULL,54783529987,855992656,13374885,16.42),(143931,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143931,34.03,NULL,64,69122,NULL,NULL,'Dipole + Quadrupole','FGC 2231',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143932,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143932,34.03,NULL,64.1,69122,NULL,NULL,'Dipole','FGC 2231',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143933,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143933,34.09,NULL,65.7,69122,NULL,NULL,NULL,'FGC 2231',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143934,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143934,34.83,0.43,92.6,69122,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2231',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143935,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143935,36.73,0.63,222,69123,70,NULL,NULL,'2MASX J18581743-4816427',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,284.572833,-48.27856,0.209,NULL,51035981111,797437204,12459956,15.9),(143936,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143936,34.5,0.29,79.5,69124,NULL,NULL,NULL,'ESO 396- G 009',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'16',0.6,'Sb:',NULL,NULL,NULL,NULL,1,284.575041667,-35.22378,0.285,NULL,47747990154,746062346,11657224,16),(143937,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143937,34.54,0.2,80.9,69124,74.4,NULL,NULL,'ESO 396- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143938,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143938,34.54,0.28,81,69124,NULL,NULL,'Malmquist cor.','ESO 396- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143939,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143939,33.36,0.45,46.9,69125,NULL,NULL,'K','IC 4798',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000077,NULL,'13.17',1.2,'SA(s)0^0^: pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,284.5870417,-62.11842,0.257,NULL,48945172323,764768317,11949504,13.17),(143940,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143940,33.98,0.4,62.6,69125,NULL,NULL,'mean','IC 4798',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143941,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143941,36.24,0.55,177,69126,70,NULL,NULL,'2MASX J18583339-4811215',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,284.639083333,-48.18931,0.209,NULL,51035929201,797436393,12459943,13.9),(143942,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143942,33.82,0.8,58.1,69127,75,NULL,'HMCL, I','IC 4799',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000053,NULL,'13.99',1.1,'SB(rs)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,284.7357917,-63.93097,0.213,NULL,48950625088,764853517,11950836,13.99),(143943,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143943,30.7,0.4,13.8,69127,75,NULL,'HMCL, I, inv','IC 4799',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143944,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143944,30.76,0.4,14.2,69127,75,NULL,'HMCL, I, raw','IC 4799',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143945,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143945,31.02,0.4,16,69127,75,NULL,'HMCL, I, cor','IC 4799',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143946,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143946,32.77,0.47,35.9,69127,NULL,NULL,'H','IC 4799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143947,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143947,33.2,0.45,43.7,69127,NULL,NULL,'K','IC 4799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143948,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143948,33.25,0.46,44.6,69127,NULL,NULL,'J','IC 4799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143949,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143949,33.92,0.4,60.9,69127,NULL,NULL,'mean','IC 4799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143950,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143950,34.3,0.43,72.6,69128,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J18591639+1919573',NULL,'2014MNRAS.444..527S',2014,1,0.89,NULL,'G',0.00004,NULL,'10.3K',0.33,'Spiral',NULL,NULL,NULL,NULL,1,284.818333333,19.33256,NULL,NULL,54740547199,855321049,13364391,10.3),(143951,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143951,35.24,0.56,112,69129,70,NULL,NULL,'ESO 183- G 033',NULL,'2014MNRAS.445.2677S',2014,1,1.43,'Star superposed.','G',0.00011,NULL,'15.83',0.17,'Sbc',NULL,NULL,NULL,NULL,1,284.84825,-52.71319,0.161,NULL,48903418641,764115916,11939311,15.83),(143952,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143952,33.15,0.43,42.6,69130,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11385',NULL,'2014MNRAS.444..527S',2014,1,1.2,NULL,'G',0.000017,NULL,'16.0',0.8,'Sdm:',NULL,NULL,NULL,NULL,1,284.901917,19.42742,NULL,NULL,54743389724,855365464,13365085,16),(143953,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143953,33.17,0.25,43.1,69131,74.4,NULL,NULL,'IC 4801',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.00004,NULL,'13.60',1,'(R)SAB(rl)0^+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,284.9099583,-64.67514,0.213,NULL,48948086793,764813856,11950216,13.6),(143954,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143954,33.47,0.45,49.4,69131,NULL,NULL,'K','IC 4801',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143955,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143955,33.97,0.4,62.2,69131,NULL,NULL,'mean','IC 4801',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143956,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143956,34.37,0.8,74.8,69132,75,NULL,'MAT, I','ESO 337- G 006',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'15',0.7,'SAB(rs)bc',NULL,NULL,NULL,NULL,1,284.91325,-41.76281,0.329,NULL,51048806456,797637600,12463087,15),(143957,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143957,33.55,0.43,51.2,69132,75,NULL,'MAT, I, raw','ESO 337- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143958,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143958,33.58,0.32,51.9,69132,85,NULL,'I, raw','ESO 337- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143959,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143959,33.62,0.32,53,69132,85,NULL,'I, inv','ESO 337- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143960,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143960,33.75,0.43,56.3,69132,75,NULL,'MAT, I, inv','ESO 337- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143961,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143961,34.04,0.43,64.3,69132,75,NULL,'MAT, I, cor','ESO 337- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143962,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143962,34.25,0.29,70.8,69132,NULL,NULL,NULL,'ESO 337- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143963,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143963,34.29,0.2,72.1,69132,74.4,NULL,NULL,'ESO 337- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143964,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143964,34.3,0.47,72.4,69132,NULL,NULL,'H','ESO 337- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143965,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143965,34.42,0.27,76.5,69132,NULL,NULL,'Malmquist cor.','ESO 337- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143966,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143966,34.43,0.46,77.1,69132,NULL,NULL,'J','ESO 337- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143967,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143967,34.45,0.45,77.5,69132,NULL,NULL,'K','ESO 337- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143968,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143968,34.52,0.4,80,69132,NULL,NULL,'mean','ESO 337- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143969,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143969,37.26,0.72,283,69133,70,NULL,NULL,'2MASX J18594226-4820236',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,284.926167,-48.33989,0.249,NULL,51035970389,797437037,12459953,15.5),(143970,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',143970,33.61,0.49,52.8,69134,75,NULL,'IR','2MFGC 14677',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',NULL,NULL,'13.51',0.3,'LSB',NULL,NULL,NULL,NULL,1,284.946583,18.83039,NULL,NULL,54740511829,855320497,13364382,13.51),(143971,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143971,34.23,0.36,70.3,69134,70,NULL,'H, 2MASS','2MFGC 14677',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143972,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143972,34.5,0.36,79.6,69134,70,NULL,'H, UH88/IRSF/2MASS','2MFGC 14677',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143973,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143973,36.23,0.52,176,69135,70,NULL,NULL,'2MASX J18595845-4907003',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,284.993583,-49.11678,0.265,NULL,51033956702,797405573,12459462,14.7),(143974,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143974,36.31,0.53,183,69136,70,NULL,NULL,'2MASX J19000094-4838313',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.8I',0.3,NULL,NULL,NULL,NULL,NULL,1,285.0039583,-48.64197,0.289,NULL,51035895148,797435861,12459935,13.8),(143975,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143975,36.24,0.6,177,69137,70,NULL,NULL,'2MASX J19000444-4752264',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,285.018417,-47.87397,0.229,NULL,51036029803,797437965,12459968,15.3),(143976,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143976,36.2,0.8,174,69138,70,NULL,NULL,'2MASX J19001327-5725236',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000103,NULL,'16.3b',0.4,NULL,NULL,NULL,NULL,NULL,1,285.0552083,-57.42319,0.257,NULL,49123508511,767554820,11993044,16.3),(143977,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143977,36.33,0.54,184,69139,70,NULL,NULL,'2MASX J19003547-4858263',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,285.14775,-48.97406,0.373,NULL,51033802960,797403171,12459424,15.1),(143978,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143978,33.02,0.43,40.1,69140,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6750',NULL,'2014MNRAS.444..527S',2014,1,1,NULL,'G',0.000113,NULL,'13.7',0.6,'Sc',NULL,NULL,NULL,NULL,1,285.1504583,59.16675,0.237,NULL,53144321488,830380023,12974687,13.7),(143979,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143979,33.6,0.4,52.5,69140,NULL,NULL,'mean','NGC 6750',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143980,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143980,33.74,0.47,55.9,69140,NULL,NULL,'H','NGC 6750',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143981,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143981,33.79,0.45,57.4,69140,NULL,NULL,'K','NGC 6750',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143982,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143982,33.81,0.46,57.9,69140,NULL,NULL,'J','NGC 6750',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143983,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143983,37.19,0.55,274,69141,70,NULL,NULL,'2MASX J19004847-4905034',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,285.202083,-49.08425,0.265,NULL,51033945066,797405391,12459459,15.6),(143984,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143984,33.81,0.4,57.8,69142,75,NULL,'Edat, raw','NGC 6721',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000083,NULL,'13.06',1.4,'E+:','Isolated elliptical galaxy',NULL,NULL,NULL,1,285.211708333,-57.75944,0.257,NULL,49123462493,767554101,11993032,13.06),(143985,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143985,33.85,0.4,58.8,69142,75,NULL,'Edat, cor','NGC 6721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143986,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143986,32.68,0.37,34.4,69142,95,NULL,'Weighted Mean','NGC 6721',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143987,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143987,33.07,0.46,41.1,69142,95,NULL,'Michard 1979a','NGC 6721',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143988,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143988,34.3,0.81,72.4,69142,55,NULL,'Visvanathan & Sandage 1979','NGC 6721',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143989,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143989,33.82,0.47,58.2,69142,70,NULL,NULL,'NGC 6721',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143990,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',143990,33.3,0.49,45.7,69143,75,NULL,'IR','ESO 183- G 035',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.97',0.2,'S...',NULL,NULL,NULL,NULL,1,285.2520417,-53.9695,0.305,NULL,49079819241,766872175,11982377,15.97),(143991,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143991,33.85,0.47,58.8,69143,NULL,NULL,'H','ESO 183- G 035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143992,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143992,33.94,0.45,61.4,69143,NULL,NULL,'K','ESO 183- G 035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143993,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143993,33.97,0.4,62.3,69143,NULL,NULL,'mean','ESO 183- G 035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143994,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143994,34.14,0.46,67.3,69143,NULL,NULL,'J','ESO 183- G 035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143995,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143995,33.99,0.8,62.7,69144,75,NULL,'MAT, I','IC 4808',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000024,NULL,'12.92',0.8,'SA(s)c',NULL,NULL,NULL,NULL,1,285.28175,-45.31372,0.209,NULL,51025343337,797270989,12457359,12.92),(143996,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143996,33.23,0.43,44.3,69144,75,NULL,'MAT, I, raw','IC 4808',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143997,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143997,33.24,0.32,44.5,69144,85,NULL,'I, raw','IC 4808',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143998,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143998,33.29,0.32,45.6,69144,85,NULL,'I, inv','IC 4808',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143999,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143999,33.38,0.47,47.5,69144,NULL,NULL,'H','IC 4808',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144000,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144000,33.39,0.45,47.6,69144,NULL,NULL,'K','IC 4808',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144001,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144001,33.39,0.46,47.6,69144,NULL,NULL,'J','IC 4808',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144002,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144002,33.48,0.43,49.5,69144,75,NULL,'MAT, I, inv','IC 4808',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144003,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144003,33.73,0.43,55.6,69144,75,NULL,'MAT, I, cor','IC 4808',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144004,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144004,33.77,0.63,56.8,69144,NULL,NULL,NULL,'IC 4808',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144005,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144005,33.81,0.2,57.8,69144,74.4,NULL,NULL,'IC 4808',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144006,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144006,33.98,0.57,62.6,69144,NULL,NULL,'Malmquist cor.','IC 4808',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144007,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144007,34.1,0.4,66,69144,NULL,NULL,'mean','IC 4808',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144008,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144008,37.79,0.69,362,69145,70,NULL,NULL,'2MASX J19012720-2931591',NULL,'2014MNRAS.445.2677S',2014,1,0.1,NULL,'G',0.00015,NULL,'15.5R',0.1,NULL,NULL,NULL,NULL,NULL,1,285.36325,-29.53317,0.557,NULL,47631000781,744234387,11628662,15.5),(144009,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144009,33.64,0.8,53.4,69146,75,NULL,'MAT, I','IC 4806',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.00012,NULL,'13.06',0.6,'(R\'_2)SAB(s)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,285.377875,-57.53206,0.257,NULL,49123676744,767557449,11993085,13.06),(144010,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144010,33.47,0.43,49.5,69146,75,NULL,'MAT, I, raw','IC 4806',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144011,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144011,33.66,0.32,54,69146,85,NULL,'I, raw','IC 4806',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144012,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144012,33.67,0.46,54.1,69146,NULL,NULL,'J','IC 4806',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144013,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144013,33.67,0.47,54.2,69146,NULL,NULL,'H','IC 4806',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144014,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144014,33.71,0.43,55.2,69146,75,NULL,'MAT, I, cor','IC 4806',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144015,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144015,33.74,0.32,55.9,69146,85,NULL,'I, inv','IC 4806',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144016,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144016,33.75,0.45,56.2,69146,NULL,NULL,'K','IC 4806',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144017,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144017,33.78,0.43,57.1,69146,75,NULL,'MAT, I, inv','IC 4806',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144018,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144018,33.85,0.4,58.8,69146,NULL,NULL,'mean','IC 4806',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144019,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',144019,34.05,0.49,64.6,69146,75,NULL,'IR','IC 4806',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144020,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144020,34.2,0.09,69.3,69146,NULL,NULL,NULL,'IC 4806',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144021,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144021,36.07,0.8,163,69147,70,NULL,NULL,'2MASX J19020695-4914522',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,285.528916667,-49.24778,0.397,NULL,51033494606,797398353,12459349,15.8),(144022,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144022,35.04,0.55,102,69148,70,NULL,NULL,'FAIRALL 0504',NULL,'2014MNRAS.445.2677S',2014,1,0.7,'1983MNRAS.203...47F has V = 14900? +- 100 km/s.','G',0.00015,NULL,'13.7I',0.5,NULL,NULL,NULL,NULL,NULL,1,285.616625,-53.19281,0.237,NULL,48890955349,763921177,11936268,13.7),(144023,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144023,32.84,0.8,37,69149,75,NULL,'MAT, I','IC 4810',NULL,'1997ApJS..109..333W',1997,1,4.59,NULL,'G',0.000017,NULL,'13.14',0.57,'SAB(s)d? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,285.7487917,-56.15972,0.257,NULL,49109248200,767332003,11989562,13.14),(144024,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144024,32.32,NULL,29.1,69149,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 4810',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144025,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144025,32.32,NULL,29.2,69149,NULL,NULL,'Dipole + Quadrupole','IC 4810',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144026,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144026,32.33,NULL,29.2,69149,NULL,NULL,'Dipole','IC 4810',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144027,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144027,32.45,NULL,30.9,69149,NULL,NULL,NULL,'IC 4810',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144028,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',144028,32.47,0.49,31.2,69149,75,NULL,'IR','IC 4810',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144029,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144029,32.6,0.32,33.1,69149,85,NULL,'I, raw','IC 4810',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144030,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144030,32.62,0.32,33.4,69149,85,NULL,'I, inv','IC 4810',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144031,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144031,32.62,0.2,33.4,69149,74.4,NULL,NULL,'IC 4810',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144032,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144032,32.66,0.43,34.1,69149,75,NULL,'MAT, I, raw','IC 4810',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144033,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144033,32.69,0.43,34.5,69149,75,NULL,'3.6 micron, color corrected','IC 4810',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144034,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144034,32.73,0.43,35.1,69149,75,NULL,'3.6 micron, color + selection bias corrected','IC 4810',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144035,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144035,32.79,0.43,36.1,69149,75,NULL,'MAT, I, inv','IC 4810',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144036,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144036,33.06,0.43,41,69149,75,NULL,'MAT, I, cor','IC 4810',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144037,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144037,33.15,0.4,42.7,69149,NULL,NULL,'mean','IC 4810',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144038,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144038,33.21,0.47,43.9,69149,NULL,NULL,'H','IC 4810',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144039,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144039,33.3,0.46,45.7,69149,NULL,NULL,'J','IC 4810',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144040,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144040,33.5,0.45,50.1,69149,NULL,NULL,'K','IC 4810',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144041,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144041,37.95,0.67,390,69150,70,NULL,NULL,'2MASX J19030433-4910234',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,285.768125,-49.17319,0.397,NULL,51033515078,797398673,12459354,15),(144042,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144042,33.33,0.8,46.4,69151,75,NULL,'MAT, I','NGC 6719',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000025,NULL,'13.47',0.8,'SAB:(rs)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,285.781208333,-68.58836,0.197,NULL,49201500761,768773449,12012085,13.47),(144043,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144043,32.7,0.32,34.7,69151,85,NULL,'I, raw','NGC 6719',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144044,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144044,32.72,0.32,35,69151,85,NULL,'I, inv','NGC 6719',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144045,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144045,32.91,0.43,38.1,69151,75,NULL,'MAT, I, raw','NGC 6719',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144046,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144046,33.03,0.43,40.3,69151,75,NULL,'MAT, I, inv','NGC 6719',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144047,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144047,33.28,0.43,45.3,69151,75,NULL,'MAT, I, cor','NGC 6719',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144048,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144048,33.55,0.4,51.2,69151,NULL,NULL,'mean','NGC 6719',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144049,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144049,33.67,0.09,54.3,69151,NULL,NULL,NULL,'NGC 6719',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144050,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144050,33.72,0.46,55.4,69151,NULL,NULL,'J','NGC 6719',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144051,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144051,33.76,0.45,56.5,69151,NULL,NULL,'K','NGC 6719',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144052,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144052,33.77,0.47,56.7,69151,NULL,NULL,'H','NGC 6719',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144053,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144053,33.18,0.8,43.2,69152,75,NULL,'MAT, I','ESO 184- G 003',NULL,'1997ApJS..109..333W',1997,1,1.3,'Marginal HIPASS detection.','G',0.000033,NULL,'15.74',0.4,'SB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,285.81175,-53.44147,0.237,NULL,49074410637,766787666,11981057,15.74),(144054,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144054,33.05,0.32,40.8,69152,85,NULL,'I, inv','ESO 184- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144055,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144055,33.08,0.32,41.3,69152,85,NULL,'I, raw','ESO 184- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144056,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144056,33.57,0.43,51.9,69152,75,NULL,'MAT, I, inv','ESO 184- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144057,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144057,33.6,0.43,52.6,69152,75,NULL,'MAT, I, raw','ESO 184- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144058,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144058,33.86,0.43,59.1,69152,75,NULL,'MAT, I, cor','ESO 184- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144059,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',144059,33.5,0.49,50.1,69153,75,NULL,'IR','UGC 11394',NULL,'2011yCatp016004901K',2011,1,1.93,'abs(b) < 10 degrees.','G',0.00002,NULL,'16.0',0.22,'Scd',NULL,NULL,NULL,NULL,1,285.901875,27.60664,NULL,NULL,54402648228,850041378,13281896,16),(144060,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144060,33.89,0.47,60,69153,NULL,NULL,'H','UGC 11394',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144061,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144061,33.94,0.4,61.4,69153,NULL,NULL,'mean','UGC 11394',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144062,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144062,34.03,0.46,63.8,69153,NULL,NULL,'J','UGC 11394',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144063,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144063,34.06,0.45,64.8,69153,NULL,NULL,'K','UGC 11394',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144064,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144064,34.06,0.43,64.8,69153,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11394',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144065,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144065,34.16,NULL,67.9,69153,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11394',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144066,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144066,34.16,NULL,68,69153,NULL,NULL,'Dipole','UGC 11394',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144067,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144067,34.17,NULL,68.2,69153,NULL,NULL,'Dipole + Quadrupole','UGC 11394',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144068,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144068,34.17,NULL,68.3,69153,NULL,NULL,NULL,'UGC 11394',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144069,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144069,34.17,0.4,68.3,69154,NULL,NULL,'mean','UGC 11397',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000033,NULL,'13.7',0.6,'SBa',NULL,NULL,NULL,NULL,1,285.9547917,33.84469,0.517,NULL,54378486243,849663847,13275997,13.7),(144070,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144070,34.45,0.45,77.6,69154,NULL,NULL,'K','UGC 11397',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144071,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144071,34.48,0.47,78.6,69154,NULL,NULL,'H','UGC 11397',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144072,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144072,34.54,0.46,80.8,69154,NULL,NULL,'J','UGC 11397',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144073,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144073,37.02,0.61,253,69155,70,NULL,NULL,'2MASX J19040106-7659280',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,286.004625,-76.99103,0.385,NULL,48476882290,757451285,11835176,15.5),(144074,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144074,35.51,0.57,126,69156,70,NULL,NULL,'2MASX J19042121-5342395',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.6I',0.6,NULL,NULL,NULL,NULL,NULL,1,286.08825,-53.71089,0.289,NULL,49088262272,767004098,11984439,13.6),(144075,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144075,33.67,0.8,54.2,69157,75,NULL,'MAT, I','IC 4814',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000029,NULL,'14.34',0.6,'S...',NULL,NULL,NULL,NULL,1,286.245375,-58.57939,0.217,NULL,49120359492,767505617,11992275,14.34),(144076,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144076,32.51,0.32,31.7,69157,85,NULL,'I, raw','IC 4814',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144077,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144077,32.51,0.32,31.8,69157,85,NULL,'I, inv','IC 4814',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144078,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144078,32.81,0.43,36.5,69157,75,NULL,'MAT, I, raw','IC 4814',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144079,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144079,32.89,0.43,37.9,69157,75,NULL,'MAT, I, inv','IC 4814',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144080,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144080,33.21,0.43,43.9,69157,75,NULL,'MAT, I, cor','IC 4814',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144081,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144081,33.87,0.4,59.5,69157,NULL,NULL,'mean','IC 4814',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144082,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144082,33.97,0.09,62.4,69157,NULL,NULL,NULL,'IC 4814',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144083,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144083,34.03,0.47,63.9,69157,NULL,NULL,'H','IC 4814',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144084,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144084,35.49,0.52,125,69158,70,NULL,NULL,'ESO 141- G 024',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000103,NULL,'14.78',0.5,'(R\')SA(s)ab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,286.2552917,-57.98494,0.225,NULL,49119827286,767497301,11992145,14.78),(144085,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144085,36.24,0.55,177,69159,70,NULL,NULL,'2MASX J19052300-2947477',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,286.345791667,-29.79653,0.485,NULL,47624640356,744135005,11627109,15.5),(144086,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144086,36.12,NULL,167,69160,NULL,NULL,NULL,'FGC 2237',NULL,'2000BSAO...50....5K',2000,1,0.74,NULL,'G',NULL,NULL,'16.95',0.09,'Sdm',NULL,NULL,NULL,NULL,1,286.4127083,43.63703,0.237,NULL,54811316797,856426824,13381669,16.95),(144087,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',144087,36.49,0.49,198,69160,75,NULL,'IR','FGC 2237',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144088,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144088,33.89,0.8,60,69161,75,NULL,'MAT, I','ESO 184- G 008',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'15.10',0.8,'SA(s)cd',NULL,NULL,NULL,NULL,1,286.464583,-54.10736,0.297,NULL,49089024459,767016007,11984625,15.1),(144089,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144089,33.22,0.32,44.1,69161,85,NULL,'I, inv','ESO 184- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144090,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144090,33.23,0.32,44.2,69161,85,NULL,'I, raw','ESO 184- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144091,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144091,33.89,0.43,60.1,69161,75,NULL,'MAT, I, raw','ESO 184- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144092,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144092,33.97,0.43,62.3,69161,75,NULL,'MAT, I, inv','ESO 184- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144093,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144093,33.99,0.46,62.7,69161,NULL,NULL,NULL,'ESO 184- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144094,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144094,34.03,0.2,64,69161,74.4,NULL,NULL,'ESO 184- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144095,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144095,34.06,0.43,65,69161,75,NULL,'MAT, I, cor','ESO 184- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144096,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144096,34.11,0.44,66.3,69161,NULL,NULL,'Malmquist cor.','ESO 184- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144097,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144097,34.86,0.48,93.7,69162,70,NULL,NULL,'ESO 282- G 010',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000067,NULL,'12.6R',0.8,'E',NULL,NULL,NULL,NULL,1,286.479625,-43.72539,0.301,NULL,51053321129,797708142,12464189,12.6),(144098,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144098,34.44,0.46,77.1,69163,70,NULL,NULL,'ESO 337- G 010',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000087,NULL,'12.5',1.1,'SA(s)0^-:',NULL,NULL,NULL,NULL,1,286.49975,-42.36569,0.317,NULL,51045117878,797579966,12462186,12.5),(144099,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144099,37.62,0.73,335,69164,70,NULL,NULL,'2MASX J19060528-2517125',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,286.5220417,-25.28683,0.709,NULL,47611158603,743924353,11623818,16.4),(144100,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144100,33.81,0.4,57.8,69165,75,NULL,'Edat, raw','NGC 6733',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000107,NULL,'13.39',1.2,'SAB0^0^ pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,286.544291667,-62.19692,0.221,NULL,48946001569,764781274,11949707,13.39),(144101,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144101,33.85,0.4,58.8,69165,75,NULL,'Edat, cor','NGC 6733',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144102,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144102,34.28,0.25,71.8,69165,74.4,NULL,NULL,'NGC 6733',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144103,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144103,34.13,0.4,66.9,69165,NULL,NULL,'mean','NGC 6733',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144104,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144104,34.62,0.45,84,69165,NULL,NULL,'K','NGC 6733',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144105,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144105,32.75,0.8,35.5,69166,75,NULL,'MAT, I','IC 4817',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'14.48',0.5,'SAB(r)b','Pair member (points to parent)',NULL,NULL,NULL,1,286.5514583,-56.15936,0.269,NULL,49078601027,766853141,11982080,14.48),(144106,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144106,32.82,0.32,36.7,69166,85,NULL,'I, raw','IC 4817',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144107,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144107,32.84,0.32,36.9,69166,85,NULL,'I, inv','IC 4817',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144108,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144108,33.07,0.43,41,69166,75,NULL,'MAT, I, raw','IC 4817',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144109,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144109,33.15,0.43,42.7,69166,75,NULL,'MAT, I, inv','IC 4817',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144110,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144110,33.42,0.43,48.3,69166,75,NULL,'MAT, I, cor','IC 4817',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144111,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144111,34.2,0.47,69.1,69167,NULL,NULL,'H','ESO 592- G 010',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000023,NULL,'15.2b',0.5,'SB(r)bc?',NULL,NULL,NULL,NULL,1,286.577875,-19.94581,0.741,NULL,48275388928,754302952,11785983,15.2),(144112,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144112,34.24,0.45,70.6,69167,NULL,NULL,'K','ESO 592- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144113,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144113,34.31,0.46,72.6,69167,NULL,NULL,'J','ESO 592- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144114,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144114,34.4,0.4,75.7,69167,NULL,NULL,'mean','ESO 592- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144115,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144115,35.56,0.56,130,69168,70,NULL,NULL,'2MASX J19062464-3206523',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.3R',0.2,'E',NULL,NULL,NULL,NULL,1,286.6027917,-32.11447,0.373,NULL,47629712941,744214264,11628347,15.3),(144116,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144116,35.05,0.48,102,69169,70,NULL,NULL,'ESO 459- G 001',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000077,NULL,'13.4R',0.7,'S0:',NULL,NULL,NULL,NULL,1,286.698708333,-32.01589,0.373,NULL,47629574480,744212101,11628314,13.4),(144117,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144117,35.66,0.7,136,69170,70,NULL,NULL,'2MASX J19065551-4200054',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,286.7312083,-42.00164,0.349,NULL,51225578331,800399661,12506244,15.4),(144118,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144118,35.77,NULL,142,69171,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11395',NULL,'2010Ap&SS.325..163P',2010,1,1.06,'UGC RA (19h 01.5m) is incorrect.','G',NULL,NULL,'16.5:',0.13,'Scd',NULL,NULL,NULL,NULL,1,286.745375,71.76553,0.473,NULL,52684828007,823200437,12862506,16.5),(144119,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144119,35.77,NULL,143,69171,NULL,NULL,'Dipole + Quadrupole','UGC 11395',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144120,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144120,35.78,NULL,143,69171,NULL,NULL,'Dipole','UGC 11395',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144121,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144121,35.82,NULL,146,69171,NULL,NULL,NULL,'UGC 11395',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144122,'Sosies','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144122,32.93,0.16,38.5,69172,NULL,NULL,NULL,'UGC 11404',NULL,'2002A&A...393...57T',2002,1,2.3,NULL,'G',0.000004,NULL,'14.0',1.6,'Sbc',NULL,NULL,NULL,NULL,1,286.76575,29.00647,NULL,NULL,54411399267,850178113,13284033,14),(144123,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144123,33,0.69,39.8,69172,100,NULL,'mid-IR','UGC 11404',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144124,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144124,33.24,0.43,44.5,69172,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11404',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144125,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144125,31.63,0.8,21.2,69173,75,NULL,'MAT, I','IC 4819',NULL,'1997ApJS..109..333W',1997,1,3.36,NULL,'G',0.00002,NULL,'14.12',0.34,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,286.780417,-59.46694,0.197,NULL,49067995599,766687431,11979491,14.12),(144126,'Tully est','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144126,31.86,0.8,23.5,69173,75,NULL,NULL,'IC 4819',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144127,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144127,31.44,0.32,19.4,69173,85,NULL,'I, inv','IC 4819',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144128,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144128,31.46,0.32,19.6,69173,85,NULL,'I, raw','IC 4819',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144129,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144129,31.55,0.4,20.4,69173,NULL,NULL,NULL,'IC 4819',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144130,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144130,31.55,0.4,20.4,69173,73,NULL,'opt','IC 4819',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144131,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144131,31.69,0.43,21.8,69173,75,NULL,'MAT, I, inv','IC 4819',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144132,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144132,31.71,0.43,22,69173,75,NULL,'MAT, I, raw','IC 4819',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144133,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144133,31.86,NULL,23.6,69173,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 4819',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144134,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144134,31.88,NULL,23.8,69173,NULL,NULL,'Dipole + Quadrupole','IC 4819',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144135,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144135,31.9,NULL,24,69173,NULL,NULL,'Dipole','IC 4819',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144136,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144136,32.03,NULL,25.5,69173,NULL,NULL,NULL,'IC 4819',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144137,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144137,32.15,0.43,26.9,69173,75,NULL,'MAT, I, cor','IC 4819',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144138,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144138,33.77,0.4,56.7,69174,NULL,NULL,'mean','NGC 6734',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00005,NULL,'16.5b',1.1,'S0-','Pair member (points to parent)',NULL,NULL,NULL,1,286.8097083,-65.46186,0.225,NULL,48947927962,764811374,11950177,16.5),(144139,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144139,33.82,0.45,58,69174,NULL,NULL,'K','NGC 6734',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144140,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144140,33.36,0.45,47,69175,NULL,NULL,'K','NGC 6730',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.00007,NULL,'12.21',1.5,'E1',NULL,NULL,NULL,NULL,1,286.8902083,-68.91281,0.209,NULL,49253726804,769589481,12024835,12.21),(144141,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144141,33.78,0.4,56.9,69175,NULL,NULL,'mean','NGC 6730',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144142,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144142,32.78,0.47,36,69176,70,NULL,NULL,'NGC 6739',NULL,'2014MNRAS.445.2677S',2014,1,2.4,NULL,'G',0.000087,NULL,'13.15',0.9,'(L)SA(r)0^0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,286.953167,-61.36811,0.189,NULL,48945851447,764778928,11949670,13.15),(144143,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144143,34.82,0.62,91.9,69177,70,NULL,NULL,'2MASX J19075668-5517509',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,286.986125,-55.29742,0.249,NULL,49086631150,766978611,11984040,15.9),(144144,'HII region diameter','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',144144,32.86,0.13,37.4,69178,NULL,NULL,NULL,'NGC 6764',NULL,'2005JKAS...38....7I',2005,1,2.3,NULL,'G',0.000013,NULL,'12.56',1.3,'SB(s)bc;LINER  Sy2','Group member, radial-velocity confirmed',NULL,NULL,'H II',1,287.0682083,50.93322,0.237,NULL,54795997098,856187454,13377928,12.56),(144145,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144145,32.75,0.8,35.5,69178,75,NULL,'A82, H','NGC 6764',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144146,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',144146,31.56,0.4,20.5,69178,75,NULL,NULL,'NGC 6764',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144147,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144147,31.7,0.43,21.9,69178,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6764',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144148,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144148,31.78,0.43,22.6,69178,75,NULL,'3.6 micron, color corrected','NGC 6764',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144149,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144149,31.87,0.2,23.7,69178,74.4,NULL,NULL,'NGC 6764',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144150,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144150,32.07,0.4,25.9,69178,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 6764',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144151,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144151,32.09,0.38,26.2,69178,NULL,NULL,NULL,'NGC 6764',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144152,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',144152,32.18,0.49,27.3,69178,75,NULL,'IR','NGC 6764',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144153,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144153,32.46,0.47,31.1,69178,NULL,NULL,'H','NGC 6764',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144154,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144154,32.48,0.46,31.3,69178,NULL,NULL,'J','NGC 6764',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144155,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144155,32.5,0.45,31.7,69178,NULL,NULL,'K','NGC 6764',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144156,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144156,32.51,0.47,31.7,69178,75,NULL,'A82, H, raw','NGC 6764',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144157,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144157,32.52,0.4,31.9,69178,NULL,NULL,'mean','NGC 6764',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144158,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144158,32.58,0.47,32.8,69178,75,NULL,'A82, H, inv','NGC 6764',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144159,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144159,32.84,0.4,37,69178,75,NULL,'B','NGC 6764',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144160,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144160,32.94,0.47,38.7,69178,75,NULL,'A82, H, cor','NGC 6764',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144161,'TRGB','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144161,29.09,0.1,6.58,69179,74.4,NULL,NULL,'UGC 11411',NULL,'2013AJ....146...86T',2013,1,0.9,'Radial velocity suggests this is a Galactic object.','G',0.000127,NULL,'16.0',0.7,'Sc',NULL,NULL,NULL,NULL,1,287.176167,70.28394,0.465,NULL,53563627211,836931675,13077057,16),(144162,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144162,34.01,0.8,63.4,69180,75,NULL,'MAT, I','NGC 6754A',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'14.34',0.3,'Sb',NULL,NULL,NULL,NULL,1,287.182375,-51.04606,0.217,NULL,51022960914,797233764,12456777,14.34),(144163,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144163,33.77,0.47,56.8,69180,NULL,NULL,'H','NGC 6754A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144164,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144164,33.81,0.45,57.8,69180,NULL,NULL,'K','NGC 6754A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144165,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144165,33.82,0.46,58.1,69180,NULL,NULL,'J','NGC 6754A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144166,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',144166,34.01,0.49,63.4,69180,75,NULL,'IR','NGC 6754A',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144167,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144167,34.06,0.43,64.8,69180,75,NULL,'MAT, I, raw','NGC 6754A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144168,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144168,34.1,0.32,66,69180,85,NULL,'I, raw','NGC 6754A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144169,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144169,34.13,0.4,67.1,69180,NULL,NULL,'mean','NGC 6754A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144170,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144170,34.17,0.32,68.2,69180,85,NULL,'I, inv','NGC 6754A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144171,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144171,34.23,0.3,70.3,69180,NULL,NULL,'Malmquist cor.','NGC 6754A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144172,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144172,34.24,0.43,70.4,69180,75,NULL,'MAT, I, cor','NGC 6754A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144173,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144173,34.32,0.29,73.1,69180,NULL,NULL,NULL,'NGC 6754A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144174,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144174,34.36,0.43,74.4,69180,75,NULL,'MAT, I, inv','NGC 6754A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144175,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144175,34.36,0.2,74.5,69180,74.4,NULL,NULL,'NGC 6754A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144176,'GRB','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',144176,47.52,1.58,9300,69181,NULL,NULL,NULL,'GRB 080413',2.433,'2010JCAP...08..020W',2010,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,287.2987083,-27.67778,0.581,NULL,47644595238,744446800,11631981,NULL),(144177,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144177,32.47,0.8,31.2,69182,75,NULL,'MAT, I','IC 4821',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000023,NULL,'13.63',0.7,'SA(s)c?',NULL,NULL,NULL,NULL,1,287.383375,-55.01731,0.265,NULL,49089473886,767023029,11984734,13.63),(144178,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144178,31.91,0.32,24.1,69182,85,NULL,'I, raw','IC 4821',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144179,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144179,31.91,0.32,24.1,69182,85,NULL,'I, inv','IC 4821',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144180,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144180,31.99,0.4,25,69182,NULL,NULL,NULL,'IC 4821',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144181,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144181,31.99,0.4,25,69182,73,NULL,'opt','IC 4821',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144182,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144182,32.25,0.43,28.2,69182,75,NULL,'MAT, I, raw','IC 4821',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144183,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144183,32.33,0.43,29.2,69182,75,NULL,'MAT, I, inv','IC 4821',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144184,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144184,32.59,0.4,33,69182,NULL,NULL,'mean','IC 4821',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144185,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144185,32.59,0.46,33,69182,NULL,NULL,'J','IC 4821',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144186,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144186,32.63,0.47,33.5,69182,NULL,NULL,'H','IC 4821',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144187,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144187,32.66,0.43,34.1,69182,75,NULL,'MAT, I, cor','IC 4821',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144188,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144188,32.73,0.45,35.2,69182,NULL,NULL,'K','IC 4821',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144189,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144189,34.63,0.4,84.3,69183,NULL,NULL,'mean','ESO 397- G 004',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00002,NULL,'12.7R',1,'(R\')SA(s)bc    HII',NULL,NULL,NULL,NULL,1,287.389625,-33.35456,0.325,NULL,51156224972,799316015,12489312,12.7),(144190,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144190,35.25,0.45,112,69183,NULL,NULL,'K','ESO 397- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144191,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144191,35.27,0.47,113,69183,NULL,NULL,'H','ESO 397- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144192,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144192,35.34,0.46,117,69183,NULL,NULL,'J','ESO 397- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144193,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144193,35.34,0.66,117,69184,70,NULL,NULL,'ESO 104- G 040',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000103,NULL,'16.0b',0.3,'S...',NULL,NULL,NULL,NULL,1,287.434167,-64.517,0.185,NULL,48951541413,764867834,11951059,16),(144194,'TRGB','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144194,29.81,0.09,9.15,69185,74.4,NULL,NULL,'NGC 6744',NULL,'2013AJ....146...86T',2013,1,20,'Extended HIPASS source','G',0.000007,NULL,'9.14',12.9,'SAB(r)bc       LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,287.442083,-63.85753,0.141,NULL,48948838914,764825608,11950400,9.14),(144195,'Ring Diameter','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144195,28.4,0.98,4.7,69185,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 6744',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144196,'Ring Diameter','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144196,28.9,0.76,6,69185,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 6744',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144197,'Sosies','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144197,29.85,0.1,9.33,69185,NULL,NULL,NULL,'NGC 6744',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144198,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144198,29.25,0.4,7.08,69185,NULL,NULL,NULL,'NGC 6744',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144199,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144199,29.4,0.43,7.6,69185,75,NULL,'3.6 micron, color corrected','NGC 6744',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144200,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144200,29.45,0.43,7.8,69185,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6744',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144201,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',144201,29.54,NULL,8.09,69185,NULL,NULL,'LEDA [April 2006]','NGC 6744',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144202,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144202,29.6,NULL,8.32,69185,NULL,NULL,NULL,'NGC 6744',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144203,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144203,29.81,0.09,9.15,69185,74.4,NULL,NULL,'NGC 6744',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144204,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144204,29.87,0.29,9.41,69185,NULL,NULL,NULL,'NGC 6744',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144205,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144205,30.09,0.4,10.4,69185,75,NULL,'B','NGC 6744',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144206,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144206,30.17,0.4,10.8,69185,73,NULL,'opt','NGC 6744',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144207,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144207,30.27,0.24,11.3,69185,NULL,NULL,'Malmquist cor.','NGC 6744',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144208,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144208,34.33,0.4,73.4,69186,NULL,NULL,'mean','UGC 11408',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000043,NULL,'14.6',0.5,'Sab',NULL,NULL,NULL,NULL,1,287.4525417,41.57611,0.389,NULL,55007945608,859499150,13429674,14.6),(144209,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144209,34.38,0.46,75.1,69186,NULL,NULL,'J','UGC 11408',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144210,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144210,34.38,0.47,75.3,69186,NULL,NULL,'H','UGC 11408',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144211,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144211,34.4,0.45,75.8,69186,NULL,NULL,'K','UGC 11408',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144212,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144212,34.24,0.48,70.4,69187,70,NULL,NULL,'ESO 282- G 016',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.13',0.4,'S0?',NULL,NULL,NULL,NULL,1,287.4707083,-43.53597,0.309,NULL,51254448761,800850761,12513293,15.13),(144213,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144213,34.38,NULL,75.2,69188,NULL,NULL,'Dipole','UGC 11411A',NULL,'2010Ap&SS.325..163P',2010,1,2.37,NULL,'G',0.00002,NULL,'15',0.24,'Sbc',NULL,NULL,NULL,NULL,1,287.544125,60.12567,0.353,NULL,53088727134,829511361,12961115,15),(144214,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144214,34.4,NULL,75.7,69188,NULL,NULL,'Dipole + Quadrupole','UGC 11411A',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144215,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144215,34.4,NULL,75.9,69188,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11411A',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144216,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',144216,34.52,0.49,80,69188,75,NULL,'IR','UGC 11411A',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144217,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144217,35.61,0.47,133,69189,70,NULL,NULL,'2MASX J19101597-4312391',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,287.5665,-43.21089,0.289,NULL,51225279440,800394991,12506171,14.7),(144218,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144218,35.35,0.65,117,69190,70,NULL,NULL,'2MASX J19102200-8044092',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,287.591125,-80.736,0.493,NULL,48537767192,758402612,11850040,16.4),(144219,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144219,33.81,0.4,57.8,69191,75,NULL,'Edat, raw','NGC 6746',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000133,NULL,'12.6',0.9,'SA0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,287.591708333,-61.97017,0.161,NULL,48946347072,764786673,11949791,12.6),(144220,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144220,33.85,0.4,58.8,69191,75,NULL,'Edat, cor','NGC 6746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144221,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144221,33.96,0.43,62,69192,75,NULL,'3.6 micron, color corrected','ESO 282- G 018',NULL,'2014MNRAS.444..527S',2014,1,1.2,NULL,'G',0.000033,NULL,'14.42',0.7,'(R\')SB(s)c',NULL,NULL,NULL,NULL,1,287.668375,-44.18011,0.313,NULL,51246267271,800722926,12511295,14.42),(144222,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144222,33.98,0.2,62.5,69192,74.4,NULL,NULL,'ESO 282- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144223,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144223,33.99,0.43,62.8,69192,75,NULL,'3.6 micron, color + selection bias corrected','ESO 282- G 018',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144224,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144224,35.98,0.63,157,69193,70,NULL,NULL,'2MASX J19105406-4740525',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,287.7252917,-47.68131,0.301,NULL,51034293267,797410832,12459544,15.5),(144225,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144225,36.71,0.67,219,69194,70,NULL,NULL,'2MASX J19111373-5753168',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,287.807208333,-57.88797,0.209,NULL,49118139339,767470927,11991733,15.8),(144226,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144226,33.78,0.53,57.1,69195,70,NULL,NULL,'2MASX J19112166-5037339',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00006,NULL,'13.7R',NULL,NULL,'in a pair',NULL,NULL,NULL,1,287.8402083,-50.62608,0.217,NULL,51023014986,797234609,12456790,13.7),(144227,'TRGB','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144227,29.94,0.1,9.73,69196,74.4,NULL,NULL,'ESO 104- G 044',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.00001,NULL,'14.96',1.1,'SABm',NULL,NULL,NULL,NULL,1,287.8464583,-64.21908,0.157,NULL,48949074080,764829282,11950457,14.96),(144228,'Ring Diameter','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144228,34.3,0.84,74,69197,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 6753',NULL,'1981ApJS...45..541P',1981,1,2.5,NULL,'G',0.000027,NULL,'11.97',2.1,'(R\')SA(r)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,287.8485,-57.04956,0.233,NULL,49117349774,767458590,11991540,11.97),(144229,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144229,31.85,0.49,23.4,69197,70,NULL,NULL,'NGC 6753',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144230,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144230,32.93,0.8,38.5,69198,75,NULL,'MAT, I','NGC 6754',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'12.89',0.9,'SAB(rs)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,287.857166667,-50.64181,0.217,NULL,51023014229,797234597,12456790,12.89),(144231,'Sosies','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144231,32.98,0.09,39.4,69198,NULL,NULL,NULL,'NGC 6754',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144232,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144232,32.92,0.47,38.3,69198,NULL,NULL,'H','NGC 6754',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144233,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144233,32.95,0.46,38.8,69198,NULL,NULL,'J','NGC 6754',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144234,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144234,32.95,0.45,38.9,69198,NULL,NULL,'K','NGC 6754',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144235,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144235,33.08,0.4,41.3,69198,NULL,NULL,'mean','NGC 6754',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144236,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144236,33.11,0.43,41.9,69198,75,NULL,'MAT, I, raw','NGC 6754',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144237,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144237,33.17,0.32,43.1,69198,85,NULL,'I, raw','NGC 6754',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144238,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144238,33.24,0.32,44.4,69198,85,NULL,'I, inv','NGC 6754',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144239,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144239,33.39,0.43,47.6,69198,75,NULL,'MAT, I, inv','NGC 6754',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144240,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144240,33.48,0.43,49.6,69198,75,NULL,'MAT, I, cor','NGC 6754',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144241,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2003hu',NULL,144241,36.54,0.16,189,69199,74.2,NULL,'SALT 2','2MASX J19113272+7753382',0.075,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,287.886625,77.89397,0.193,NULL,52724103121,823814111,12872095,NULL),(144242,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2003hu',NULL,144242,37.17,0.09,272,69199,74.4,NULL,NULL,'2MASX J19113272+7753382',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144243,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2003hu',NULL,144243,37.53,0.22,298,69199,65,NULL,'SALT2','2MASX J19113272+7753382',0.075,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144244,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2003hu',NULL,144244,37.64,0.17,314,69199,65,NULL,'MLCS17','2MASX J19113272+7753382',0.075,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144245,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2003hu',NULL,144245,37.69,0.2,321,69199,65,NULL,'MLCS31','2MASX J19113272+7753382',0.075,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144246,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144246,36.08,0.73,164,69200,70,NULL,NULL,'2MASX J19113877-4703203',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,287.911667,-47.05564,0.301,NULL,51025895924,797279623,12457494,14.5),(144247,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',144247,35.63,0.49,134,69201,75,NULL,'IR','FGCE 1355',NULL,'2011yCatp016004901K',2011,1,1.79,NULL,'G',0.000033,NULL,'16.2',0.17,'Sc',NULL,NULL,NULL,NULL,1,287.94175,-17.22086,0.577,NULL,48305547078,754774173,11793346,16.2),(144248,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144248,35.14,0.8,107,69202,75,NULL,'MAT, I','ESO 593- G 003',NULL,'1997ApJS..109..333W',1997,1,1.85,NULL,'G',0.000033,NULL,'13.87',0.2,'Scd',NULL,NULL,NULL,NULL,1,287.94575,-21.166,0.705,NULL,48096411445,751506428,11742287,13.87),(144249,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144249,34.78,0.43,90.4,69202,75,NULL,'MAT, I, raw','ESO 593- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144250,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144250,34.87,NULL,94.1,69202,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 593- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144251,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144251,34.88,NULL,94.6,69202,NULL,NULL,'Dipole + Quadrupole','ESO 593- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144252,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144252,34.88,NULL,94.7,69202,NULL,NULL,'Dipole','ESO 593- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144253,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144253,34.92,NULL,96.4,69202,NULL,NULL,NULL,'ESO 593- G 003',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144254,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144254,35,0.43,100,69202,75,NULL,'MAT, I, inv','ESO 593- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144255,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144255,35.02,0.32,101,69202,85,NULL,'I, raw','ESO 593- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144256,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144256,35.07,0.32,103,69202,85,NULL,'I, inv','ESO 593- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144257,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',144257,35.07,0.49,104,69202,75,NULL,'IR','ESO 593- G 003',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144258,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144258,35.08,0.43,104,69202,75,NULL,'MAT, I, cor','ESO 593- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144259,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144259,35.09,0.43,104,69202,75,NULL,'3.6 micron, color + selection bias corrected','ESO 593- G 003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144260,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144260,35.16,0.43,108,69202,75,NULL,'3.6 micron, color corrected','ESO 593- G 003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144261,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144261,35.31,0.2,115,69202,74.4,NULL,NULL,'ESO 593- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144262,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144262,35.4,0.46,120,69202,NULL,NULL,NULL,'ESO 593- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144263,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144263,35.41,0.46,121,69202,NULL,NULL,'Malmquist cor.','ESO 593- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144264,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144264,36.01,0.81,159,69203,70,NULL,NULL,'2MASX J19114785-2740136',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'15.9R',0.1,NULL,NULL,NULL,NULL,NULL,1,287.949417,-27.67039,0.489,NULL,47644478127,744444970,11631952,15.9),(144265,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144265,34.18,NULL,68.5,69204,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2240',NULL,'2010Ap&SS.325..163P',2010,1,0.88,NULL,'G',NULL,NULL,'16.7',0.11,'Sc',NULL,NULL,NULL,NULL,1,288.030833,42.17722,0.357,NULL,55004822996,859450359,13428911,16.7),(144266,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144266,34.2,NULL,69.3,69204,NULL,NULL,'Dipole','FGC 2240',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144267,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144267,34.21,NULL,69.4,69204,NULL,NULL,'Dipole + Quadrupole','FGC 2240',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144268,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144268,34.26,NULL,71.1,69204,NULL,NULL,NULL,'FGC 2240',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144269,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144269,32.53,0.8,32,69205,75,NULL,'MAT, I','ESO 459- G 006',NULL,'1997ApJS..109..333W',1997,1,1.6,'Mathewson, et al. (1992ApJS...81..413M) give v = 2513 +/- 10 km/sec.','G',0.00002,NULL,'14.5',0.5,'SB(rs)b:       HII',NULL,NULL,NULL,NULL,1,288.0367083,-32.1265,0.393,NULL,47628523677,744195682,11628057,14.5),(144270,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144270,34.02,0.43,63.7,69205,75,NULL,'MAT, I, raw','ESO 459- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144271,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144271,34.07,0.32,65.3,69205,85,NULL,'I, raw','ESO 459- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144272,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144272,34.14,0.32,67.4,69205,85,NULL,'I, inv','ESO 459- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144273,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144273,34.2,0.47,69.1,69205,NULL,NULL,'H','ESO 459- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144274,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144274,34.23,0.46,70.2,69205,NULL,NULL,'J','ESO 459- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144275,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144275,34.3,0.43,72.6,69205,75,NULL,'MAT, I, inv','ESO 459- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144276,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144276,34.32,0.45,73,69205,NULL,NULL,'K','ESO 459- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144277,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144277,34.39,0.43,75.6,69205,75,NULL,'3.6 micron, color corrected','ESO 459- G 006',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144278,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144278,34.4,0.43,75.8,69205,75,NULL,'MAT, I, cor','ESO 459- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144279,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144279,34.42,0.2,76.6,69205,74.4,NULL,NULL,'ESO 459- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144280,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144280,34.57,0.34,82,69205,NULL,NULL,'Malmquist cor.','ESO 459- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144281,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144281,34.58,0.43,82.2,69205,75,NULL,'3.6 micron, color + selection bias corrected','ESO 459- G 006',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144282,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144282,34.63,0.4,84.5,69205,NULL,NULL,'mean','ESO 459- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144283,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144283,34.72,0.32,87.7,69205,NULL,NULL,NULL,'ESO 459- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144284,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144284,35.32,0.62,116,69206,70,NULL,NULL,'2MASX J19120924-3416314',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,288.0385,-34.27544,0.285,NULL,51156542689,799320979,12489390,14.3),(144285,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144285,36.1,0.6,166,69207,70,NULL,NULL,'2MASX J19123585-1752336',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,288.149375,-17.87594,0.609,NULL,48302201185,754721893,11792529,15.7),(144286,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144286,33.97,0.47,62.3,69208,NULL,NULL,'H','ESO 282- G 021',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000023,NULL,'13.74',1.1,'(R\')SB(s)b',NULL,NULL,NULL,NULL,1,288.199208333,-46.01156,0.197,NULL,51247642637,800744416,12511631,13.74),(144287,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144287,34.02,0.46,63.6,69208,NULL,NULL,'J','ESO 282- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144288,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144288,34.03,0.45,64,69208,NULL,NULL,'K','ESO 282- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144289,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144289,34.25,0.4,70.9,69208,NULL,NULL,'mean','ESO 282- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144290,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144290,34.91,0.52,95.8,69209,70,NULL,NULL,'ESO 184- G 034',NULL,'2014MNRAS.445.2677S',2014,1,0.6,'6dF DR2 has z = 0.019771.','G',0.00015,NULL,'14.95',0.3,'S0?',NULL,NULL,NULL,NULL,1,288.248333,-52.51364,0.209,NULL,48889577024,763899641,11935931,14.95),(144291,'Tully est','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144291,30.35,0.8,11.8,69210,75,NULL,NULL,'IC 4824',NULL,'1988NBGC.C....0000T',1988,1,2.7,'-1m 10s, -7.6m error in A-M position.','G',0.000007,NULL,'16.76',1.7,'IAB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,288.308625,-62.08828,0.161,NULL,48953896657,764904635,11951634,16.76),(144292,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144292,29.23,0.2,7.01,69210,74.4,NULL,NULL,'IC 4824',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144293,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144293,36.01,0.68,159,69211,70,NULL,NULL,'2MASX J19131904-7300553',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,288.329083,-73.01536,0.225,NULL,48510638753,757978730,11843417,16),(144294,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144294,33.66,0.8,54,69212,75,NULL,'HMCL, I','IC 4827',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.000033,NULL,'13.24',0.5,'SA(s)ab: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,288.3385,-60.86017,0.173,NULL,49066482796,766663793,11979121,13.24),(144295,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144295,33.7,0.8,55.1,69212,75,NULL,'MAT, I','IC 4827',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144296,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',144296,33.29,0.49,45.5,69212,75,NULL,'IR','IC 4827',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144297,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144297,33.4,0.46,47.9,69212,NULL,NULL,'J','IC 4827',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144298,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144298,33.41,0.4,48.2,69212,75,NULL,'HMCL, I, raw','IC 4827',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144299,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144299,33.48,0.45,49.6,69212,NULL,NULL,'K','IC 4827',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144300,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144300,33.5,0.43,50.1,69212,75,NULL,'MAT, I, raw','IC 4827',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144301,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144301,33.5,0.47,50.2,69212,NULL,NULL,'H','IC 4827',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144302,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144302,33.64,0.4,53.5,69212,75,NULL,'HMCL, I, cor','IC 4827',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144303,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144303,33.68,0.4,54.5,69212,75,NULL,'HMCL, I, inv','IC 4827',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144304,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144304,33.71,0.43,55.2,69212,75,NULL,'MAT, I, cor','IC 4827',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144305,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144305,33.76,0.32,56.4,69212,85,NULL,'I, raw','IC 4827',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144306,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144306,33.82,0.4,58.1,69212,NULL,NULL,'mean','IC 4827',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144307,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144307,33.85,0.32,58.8,69212,85,NULL,'I, inv','IC 4827',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144308,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144308,33.85,0.43,59,69212,75,NULL,'MAT, I, inv','IC 4827',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144309,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144309,34.26,0.12,71.3,69212,NULL,NULL,NULL,'IC 4827',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144310,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144310,36.65,0.6,214,69213,70,NULL,NULL,'2MASX J19134009-4415432',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,288.417125,-44.26208,0.317,NULL,51246869418,800732334,12511442,15.2),(144311,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2001bt',NULL,144311,33.06,0.16,40.3,69214,74.2,NULL,'SALT 2','IC 4830',0.01464,'2010ApJ...716..712A',2010,1,1.7,NULL,'G',0.000033,NULL,'13.17',1.3,'SB(r)b',NULL,NULL,NULL,NULL,1,288.452333333,-59.29436,0.197,NULL,49069400113,766709376,11979834,13.17),(144312,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2001bt',NULL,144312,33.57,0.09,51.8,69214,74.4,NULL,NULL,'IC 4830',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144313,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2001bt',NULL,144313,33.61,0.19,52,69214,72,NULL,NULL,'IC 4830',0.01464,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144314,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2001bt',NULL,144314,33.62,0.04,52.1,69214,72,NULL,NULL,'IC 4830',0.01464,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144315,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2001bt',NULL,144315,33.71,0.2,54.3,69214,70,NULL,'SALT 2','IC 4830',0.01464,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144316,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2001bt',NULL,144316,33.78,0.04,56.2,69214,72,NULL,NULL,'IC 4830',0.01464,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144317,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2001bt',NULL,144317,33.83,0.05,57.5,69214,72,NULL,NULL,'IC 4830',0.01464,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144318,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2001bt',NULL,144318,33.84,0.09,57.8,69214,72,NULL,NULL,'IC 4830',0.01464,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144319,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2001bt',NULL,144319,33.9,0.16,59.4,69214,70,NULL,'SALT','IC 4830',0.01464,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144320,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2001bt',NULL,144320,33.9,0.23,59.4,69214,65,NULL,'MLCS31','IC 4830',0.01464,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144321,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2001bt',NULL,144321,33.95,0.11,59.9,69214,65,NULL,'MLCS2k2','IC 4830',0.01464,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144322,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2001bt',NULL,144322,33.96,0.03,61.9,69214,72,NULL,'M(H) = -18.317 mag','IC 4830',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144323,'SNIa','2016-12-15 15:15:49','2016-12-16 11:21:03','1','SN 2001bt',NULL,144323,33.97,0.17,62.2,69214,70.8,NULL,NULL,'IC 4830',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144324,'SNIa','2016-12-15 15:15:49','2016-12-16 11:21:03','1','SN 2001bt',NULL,144324,34.01,0.25,62.4,69214,65,NULL,'SALT2','IC 4830',0.01464,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144325,'SNIa','2016-12-15 15:15:49','2016-12-16 11:21:03','1','SN 2001bt',NULL,144325,34.03,0.23,62.9,69214,65,NULL,'MLCS17','IC 4830',0.01464,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144326,'SNIa','2016-12-15 15:15:49','2016-12-16 11:21:03','1','SN 2001bt',NULL,144326,35.24,0.03,110,69214,70,NULL,'SALT 2','IC 4830',0.01464,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144327,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144327,32.86,0.53,37.3,69214,70,NULL,NULL,'IC 4830',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144328,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144328,33.68,0.8,54.4,69214,75,NULL,'MAT, I','IC 4830',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144329,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144329,33.86,0.45,59.2,69214,NULL,NULL,'K','IC 4830',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144330,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144330,33.87,0.47,59.4,69214,NULL,NULL,'H','IC 4830',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144331,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144331,33.87,0.4,59.4,69214,NULL,NULL,'mean','IC 4830',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144332,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144332,33.89,0.46,59.9,69214,NULL,NULL,'J','IC 4830',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144333,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144333,34.01,0.43,63.5,69214,75,NULL,'MAT, I, raw','IC 4830',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144334,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144334,34.07,0.43,65.2,69214,75,NULL,'MAT, I, cor','IC 4830',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144335,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144335,34.19,0.32,68.8,69214,85,NULL,'I, raw','IC 4830',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144336,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144336,34.2,0.07,69.3,69214,NULL,NULL,NULL,'IC 4830',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144337,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144337,34.28,0.32,71.7,69214,85,NULL,'I, inv','IC 4830',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144338,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144338,34.38,0.43,75.1,69214,75,NULL,'MAT, I, inv','IC 4830',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144339,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144339,36.25,0.74,178,69215,70,NULL,NULL,'2MASX J19135002-4408581',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,288.4585,-44.14956,0.325,NULL,51246861300,800732207,12511440,15.6),(144340,'D-Sigma','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144340,32.95,0.4,38.8,69216,75,NULL,'Edat, raw','NGC 6758',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000133,NULL,'12.65',1.7,'E+:            LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,288.468083,-56.30994,0.205,NULL,49084883052,766951297,11983614,12.65),(144341,'D-Sigma','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144341,33.2,0.4,43.6,69216,75,NULL,'Edat, cor','NGC 6758',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144342,'Faber-Jackson','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144342,32.23,0.65,27.9,69216,95,NULL,'Weighted Mean','NGC 6758',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144343,'Faber-Jackson','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144343,33.74,0.81,56,69216,55,NULL,'Visvanathan & Sandage 1979','NGC 6758',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144344,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144344,33.3,0.45,45.8,69216,NULL,NULL,'K','NGC 6758',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144345,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144345,33.31,0.4,45.9,69216,NULL,NULL,'mean','NGC 6758',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144346,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144346,36.92,0.99,242,69217,70,NULL,NULL,'2MASX J19141461-7125211',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,288.56075,-71.42247,0.205,NULL,49249676492,769526195,12023846,17),(144347,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144347,34.03,0.48,63.9,69218,70,NULL,NULL,'2MASX J19142423-5815441',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000053,NULL,'15.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,288.601125,-58.26217,0.209,NULL,49118429452,767475460,11991804,15.2),(144348,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144348,36.32,0.52,184,69219,70,NULL,NULL,'2MASX J19142530-4614247',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.9I',0.5,NULL,NULL,NULL,NULL,NULL,1,288.6055417,-46.24022,0.225,NULL,51247751359,800746114,12511658,13.9),(144349,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144349,33.89,0.52,59.9,69220,NULL,NULL,NULL,'ESO 282- G 029',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'15.20',1,'SA(r)c',NULL,NULL,NULL,NULL,1,288.6525417,-46.95769,0.277,NULL,51247932566,800748946,12511702,15.2),(144350,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144350,33.93,0.2,61.1,69220,74.4,NULL,NULL,'ESO 282- G 029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144351,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144351,34.23,0.44,70.2,69220,NULL,NULL,'Malmquist cor.','ESO 282- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144352,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144352,33.69,0.8,54.6,69221,75,NULL,'HMCL, I','IC 4831',NULL,'1997ApJS..109..333W',1997,1,3.4,NULL,'G',0.000021,NULL,'13.6b',0.9,'(R\'_2)SAB(s)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,288.682667,-62.27261,0.189,NULL,48954775806,764918371,11951849,13.6),(144353,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144353,33.26,0.4,45,69221,75,NULL,'HMCL, I, raw','IC 4831',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144354,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144354,33.36,0.47,46.9,69221,NULL,NULL,'H','IC 4831',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144355,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144355,33.36,0.46,47,69221,NULL,NULL,'J','IC 4831',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144356,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144356,33.44,0.45,48.7,69221,NULL,NULL,'K','IC 4831',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144357,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144357,33.54,0.4,51.1,69221,75,NULL,'HMCL, I, inv','IC 4831',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144358,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144358,33.54,0.4,51.1,69221,75,NULL,'HMCL, I, cor','IC 4831',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144359,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144359,33.83,0.4,58.3,69221,NULL,NULL,'mean','IC 4831',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144360,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144360,36.12,0.7,168,69222,70,NULL,NULL,'2MASX J19145507-7258092',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,288.729667,-72.96914,0.225,NULL,48507803751,757934433,11842725,16.9),(144361,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144361,34.81,0.48,91.4,69223,NULL,NULL,NULL,'ESO 524- G 011',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.31',0.5,'Sb-c:',NULL,NULL,NULL,NULL,1,288.7512917,-23.75819,0.553,NULL,48088474004,751382406,11740350,14.31),(144362,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144362,34.85,0.2,93.3,69223,74.4,NULL,NULL,'ESO 524- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144363,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144363,35.06,0.43,103,69223,NULL,NULL,'Malmquist cor.','ESO 524- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144364,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144364,35.77,0.44,142,69224,NULL,NULL,NULL,'ESO 141- G 039',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.67',0.2,'Sc',NULL,NULL,NULL,NULL,1,288.782917,-58.36617,0.201,NULL,49118408118,767475126,11991798,16.67),(144365,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144365,35.76,0.45,142,69224,NULL,NULL,'Malmquist cor.','ESO 141- G 039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144366,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144366,35.81,0.2,145,69224,74.4,NULL,NULL,'ESO 141- G 039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144367,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,'R',144367,34.6,0.49,83.3,69225,75,NULL,'IR','2MFGC 14823',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.000023,NULL,'13.6R',0.4,'SBb?           HII',NULL,NULL,NULL,NULL,1,288.805583,-16.93767,0.377,NULL,48302018516,754719039,11792484,13.6),(144368,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144368,34.92,0.47,96.4,69225,NULL,NULL,'H','2MFGC 14823',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144369,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144369,35.02,0.4,101,69225,NULL,NULL,'mean','2MFGC 14823',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144370,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144370,35.08,0.45,104,69225,NULL,NULL,'K','2MFGC 14823',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144371,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144371,35.15,0.46,107,69225,NULL,NULL,'J','2MFGC 14823',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144372,'Tully est','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144372,32.7,0.8,34.7,69226,75,NULL,'B','IC 4837',NULL,'1988NBGC.C....0000T',1988,1,2.6,NULL,'G',0.00006,NULL,'13.01',1.2,'SB(s)cd pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,288.811,-54.66142,0.237,NULL,49087372724,766990198,11984221,13.01),(144373,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144373,32.25,0.46,28.2,69227,NULL,NULL,'J','IC 4837A',NULL,'2007A&A...465...71T',2007,1,4.1,NULL,'G',0.000024,NULL,'12.55',0.6,'SA(s)b: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,288.817375,-54.1325,0.257,NULL,49076033469,766813022,11981453,12.55),(144374,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144374,32.3,0.47,28.8,69227,NULL,NULL,'H','IC 4837A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144375,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144375,32.36,0.45,29.6,69227,NULL,NULL,'K','IC 4837A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144376,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,'R',144376,32.45,0.49,31,69227,75,NULL,'IR','IC 4837A',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144377,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144377,32.77,0.4,35.8,69227,NULL,NULL,'mean','IC 4837A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144378,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,'R',144378,33.57,0.4,51.7,69227,75,NULL,NULL,'IC 4837A',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144379,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144379,34.17,0.07,68.4,69228,NULL,NULL,NULL,'IC 4835',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000033,NULL,'14.74',0.6,'S...',NULL,NULL,NULL,NULL,1,288.8645,-58.238,0.209,NULL,49118228739,767472324,11991755,14.74),(144380,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144380,32.49,0.8,31.5,69229,75,NULL,'MAT, I','IC 4839',NULL,'1997ApJS..109..333W',1997,1,2.3,'Redshifts reported at z = 0.009 apply to IC 4837.','G',0.00015,NULL,'13.19',1.5,'(R\')SAB(s)bc','Group member',NULL,NULL,NULL,1,288.892166667,-54.62669,0.237,NULL,49087367104,766990111,11984220,13.19),(144381,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144381,29.87,0.32,9.4,69229,85,NULL,'I, inv','IC 4839',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144382,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144382,29.87,0.32,9.44,69229,85,NULL,'I, raw','IC 4839',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144383,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144383,30.25,0.43,11.2,69229,75,NULL,'MAT, I, raw','IC 4839',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144384,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144384,30.27,0.43,11.3,69229,75,NULL,'MAT, I, inv','IC 4839',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144385,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144385,30.52,0.43,12.7,69229,75,NULL,'MAT, I, cor','IC 4839',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144386,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144386,31.48,0.47,19.8,69229,NULL,NULL,'H','IC 4839',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144387,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144387,31.55,0.45,20.4,69229,NULL,NULL,'K','IC 4839',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144388,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144388,31.57,0.46,20.6,69229,NULL,NULL,'J','IC 4839',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144389,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144389,32.6,0.4,33.1,69229,NULL,NULL,'mean','IC 4839',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144390,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144390,35.68,0.55,137,69230,70,NULL,NULL,'2MASX J19153585-5819179',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,288.899583,-58.32158,0.197,NULL,49118411324,767475176,11991799,14),(144391,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144391,33.91,0.8,60.5,69231,75,NULL,'MAT, I','ESO 231- G 029',NULL,'1997ApJS..109..333W',1997,1,2.04,NULL,'G',0.000033,NULL,'15.16',0.29,'Scd',NULL,NULL,NULL,NULL,1,288.906125,-47.88639,0.261,NULL,51251309739,800801714,12512526,15.16),(144392,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144392,33.07,0.32,41.2,69231,85,NULL,'I, raw','ESO 231- G 029',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144393,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144393,33.07,0.32,41.2,69231,85,NULL,'I, inv','ESO 231- G 029',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144394,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144394,33.21,0.43,43.8,69231,75,NULL,'MAT, I, raw','ESO 231- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144395,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,'R',144395,33.24,0.49,44.4,69231,75,NULL,'IR','ESO 231- G 029',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144396,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144396,33.26,0.43,45,69231,75,NULL,'MAT, I, inv','ESO 231- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144397,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144397,33.62,0.43,52.9,69231,75,NULL,'MAT, I, cor','ESO 231- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144398,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144398,33.65,0.54,53.7,69231,NULL,NULL,NULL,'ESO 231- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144399,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144399,33.69,0.2,54.7,69231,74.4,NULL,NULL,'ESO 231- G 029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144400,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144400,33.73,NULL,55.8,69231,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 231- G 029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144401,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144401,33.76,NULL,56.4,69231,NULL,NULL,'Dipole','ESO 231- G 029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144402,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144402,33.77,NULL,56.7,69231,NULL,NULL,'Dipole + Quadrupole','ESO 231- G 029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144403,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144403,33.81,NULL,57.8,69231,NULL,NULL,NULL,'ESO 231- G 029',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144404,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144404,33.95,0.47,61.6,69231,NULL,NULL,'Malmquist cor.','ESO 231- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144405,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144405,35.93,0.65,154,69232,70,NULL,NULL,'2MASX J19154577-7653080',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,288.940958333,-76.88553,0.325,NULL,48477404625,757459447,11835303,15.2),(144406,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144406,32.58,0.43,32.8,69233,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11422',NULL,'2014MNRAS.444..527S',2014,1,1.23,NULL,'G',NULL,NULL,'15.3',0.15,'Scd',NULL,NULL,NULL,NULL,1,288.942583,43.44072,0.301,NULL,55013329875,859583279,13430988,15.3),(144407,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,'R',144407,34.21,0.49,69.4,69233,75,NULL,'IR','UGC 11422',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144408,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144408,34.44,NULL,77.1,69233,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11422',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144409,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144409,34.46,NULL,78,69233,NULL,NULL,'Dipole + Quadrupole','UGC 11422',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144410,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144410,34.47,NULL,78.5,69233,NULL,NULL,'Dipole','UGC 11422',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144411,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144411,34.59,NULL,82.9,69233,NULL,NULL,NULL,'UGC 11422',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144412,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144412,33.06,0.54,40.9,69234,NULL,NULL,NULL,'IC 4840',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.4b',0.7,'SAB(rs)a:','Group member',NULL,NULL,NULL,1,288.965375,-56.20908,0.205,NULL,49084692449,766948319,11983567,14.4),(144413,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144413,33.1,0.2,41.7,69234,74.4,NULL,NULL,'IC 4840',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144414,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144414,33.41,0.46,48.2,69234,NULL,NULL,'Malmquist cor.','IC 4840',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144415,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144415,36.99,0.65,250,69235,70,NULL,NULL,'2MASX J19161028-1519288',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,289.042875,-15.32464,0.681,NULL,48296185477,754627898,11791060,15.9),(144416,'Tully est','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144416,30.23,0.8,11.1,69236,75,NULL,NULL,'ESO 141- G 042',NULL,'1988NBGC.C....0000T',1988,1,3,'Confused HIPASS source','G',0.000007,NULL,'14.44',0.5,'SB(s)m',NULL,NULL,NULL,NULL,1,289.0502083,-62.36175,0.181,NULL,48954691443,764917053,11951828,14.44),(144417,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144417,34.44,0.46,77.3,69237,70,NULL,NULL,'NGC 6768',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00008,NULL,'13.5',1.1,'E4',NULL,NULL,NULL,NULL,1,289.135833,-40.20917,0.373,NULL,51234181668,800534088,12508345,13.5),(144418,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144418,27.83,0.06,3.68,69238,NULL,NULL,NULL,'NGC 6789',NULL,'2012MNRAS.423..406G',2012,1,1.3,NULL,'G',0.00003,NULL,'13.76',1,'Im','in a pair',NULL,NULL,NULL,1,289.175667,63.97147,0.325,NULL,53064670490,829135476,12955241,13.76),(144419,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144419,27.85,0.04,3.72,69238,NULL,NULL,NULL,'NGC 6789',NULL,'2010ApJ...721..297M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144420,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144420,26.6,0.1,2.1,69238,NULL,NULL,NULL,'NGC 6789',NULL,'2000A&AS..142..347D',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144421,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144421,27.75,0.1,3.55,69238,74.4,NULL,NULL,'NGC 6789',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144422,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144422,27.8,0.13,3.6,69238,NULL,NULL,'I','NGC 6789',NULL,'2001ApJ...551L.135D',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144423,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144423,27.78,0.12,3.6,69238,NULL,NULL,NULL,'NGC 6789',NULL,'2014A&A...566A..71L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144424,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144424,35.98,0.54,157,69239,70,NULL,NULL,'2MASX J19164773-2512079',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'14.8R',0.2,'E',NULL,NULL,NULL,NULL,1,289.1989583,-25.20217,0.545,NULL,47639367036,744365109,11630704,14.8),(144425,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144425,34.87,0.8,94.1,69240,75,NULL,'MAT, I','ESO 184- G 051',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000027,NULL,'14.22',0.7,'SAB(s)bc:',NULL,NULL,NULL,NULL,1,289.236708333,-53.70067,0.257,NULL,49077456983,766835265,11981801,14.22),(144426,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144426,34.2,0.43,69.2,69240,75,NULL,'MAT, I, raw','ESO 184- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144427,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144427,34.33,0.43,73.5,69240,75,NULL,'MAT, I, cor','ESO 184- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144428,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144428,34.38,0.39,75.2,69240,NULL,NULL,'Malmquist cor.','ESO 184- G 051',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144429,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144429,34.41,0.32,76.2,69240,85,NULL,'I, raw','ESO 184- G 051',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144430,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144430,34.49,0.32,78.9,69240,85,NULL,'I, inv','ESO 184- G 051',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144431,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144431,34.5,0.43,79.5,69240,75,NULL,'MAT, I, inv','ESO 184- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144432,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144432,34.56,0.47,81.8,69240,NULL,NULL,'H','ESO 184- G 051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144433,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144433,34.62,0.46,83.8,69240,NULL,NULL,'J','ESO 184- G 051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144434,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144434,34.7,0.45,87.2,69240,NULL,NULL,'K','ESO 184- G 051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144435,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144435,34.77,0.33,90.1,69240,NULL,NULL,NULL,'ESO 184- G 051',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144436,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144436,34.81,0.2,91.6,69240,74.4,NULL,NULL,'ESO 184- G 051',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144437,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144437,34.84,0.4,93,69240,NULL,NULL,'mean','ESO 184- G 051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144438,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144438,36.02,0.55,160,69241,70,NULL,NULL,'2MASX J19170067-7049537',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,289.252833333,-70.83164,0.209,NULL,49250222495,769534726,12023980,16.4),(144439,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144439,35.59,0.56,131,69242,70,NULL,NULL,'2MASX J19170949-5905489',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.4b',0.4,NULL,NULL,NULL,NULL,NULL,1,289.2895,-59.09686,0.193,NULL,49061911223,766592362,11978005,16.4),(144440,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144440,34.21,0.4,69.4,69243,NULL,NULL,'mean','ESO 282- G 033',NULL,'2007A&A...465...71T',2007,1,1.69,NULL,'G',0.000033,NULL,'15.50',0.22,'Sbc',NULL,NULL,NULL,NULL,1,289.308667,-46.68875,0.269,NULL,51247989694,800749838,12511716,15.5),(144441,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,'R',144441,34.22,0.49,69.7,69243,75,NULL,'IR','ESO 282- G 033',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144442,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144442,34.33,0.47,73.6,69243,NULL,NULL,'H','ESO 282- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144443,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144443,34.48,0.45,78.7,69243,NULL,NULL,'K','ESO 282- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144444,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144444,34.5,0.34,79.6,69243,NULL,NULL,'Malmquist cor.','ESO 282- G 033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144445,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144445,34.63,0.32,84.5,69243,NULL,NULL,NULL,'ESO 282- G 033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144446,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144446,34.67,0.2,85.9,69243,74.4,NULL,NULL,'ESO 282- G 033',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144447,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144447,34.88,NULL,94.6,69243,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 282- G 033',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144448,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144448,34.89,NULL,95.1,69243,NULL,NULL,'Dipole + Quadrupole','ESO 282- G 033',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144449,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144449,34.9,NULL,95.5,69243,NULL,NULL,'Dipole','ESO 282- G 033',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144450,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144450,37,0.68,251,69244,70,NULL,NULL,'2MASX J19171677-1904530',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,289.3199583,-19.08136,0.513,NULL,48100764383,751574443,11743350,15.6),(144451,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144451,35.12,0.57,106,69245,NULL,NULL,'Malmquist cor.','ESO 397- G 012',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.83',0.4,'Sc:',NULL,NULL,NULL,NULL,1,289.346417,-36.29506,0.349,NULL,51168450753,799507043,12492297,14.83),(144452,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144452,35.43,0.5,122,69245,NULL,NULL,NULL,'ESO 397- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144453,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144453,35.47,0.2,124,69245,74.4,NULL,NULL,'ESO 397- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144454,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144454,35.02,0.64,101,69246,70,NULL,NULL,'2MASX J19172980-2120011',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,289.374125,-21.33369,0.581,NULL,48088799859,751387497,11740429,15),(144455,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144455,35.8,0.7,144,69247,70,NULL,NULL,'2MASX J19173192-7308436',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,289.382917,-73.14544,0.209,NULL,48510559787,757977496,11843398,16.8),(144456,'BL Lac Luminosity','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144456,39.33,NULL,646,69248,NULL,NULL,NULL,'PMN J1917-1921',0.137,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.001,NULL,'15.4R',NULL,'BLLAC',NULL,NULL,NULL,'BL Lac',1,289.43675,-19.35878,0.509,NULL,48103985983,751624780,11744137,15.4),(144457,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144457,36.17,0.56,171,69249,70,NULL,NULL,'2MASX J19174962-1618400',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,289.456833,-16.31108,0.469,NULL,48296718582,754636227,11791191,15.3),(144458,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144458,36.29,0.55,181,69250,70,NULL,NULL,'2MASX J19175143-6332295',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,289.4645,-63.54147,0.157,NULL,48953156932,764893077,11951454,16.7),(144459,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144459,34.13,0.36,66.9,69251,NULL,NULL,NULL,'ESO 459- G 011',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'13.72',0.7,'Sb',NULL,NULL,NULL,NULL,1,289.498667,-30.20483,0.481,NULL,47618309571,744036087,11625563,13.72),(144460,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144460,34.17,0.2,68.2,69251,74.4,NULL,NULL,'ESO 459- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144461,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144461,34.48,0.31,78.9,69251,NULL,NULL,'Malmquist cor.','ESO 459- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144462,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144462,33.3,0.43,45.8,69252,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11426',NULL,'2014MNRAS.444..527S',2014,1,0.9,NULL,'G',0.000023,NULL,'14.4',0.7,'S',NULL,NULL,NULL,NULL,1,289.5902083,34.83706,0.917,NULL,54877381460,857459085,13397798,14.4),(144463,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144463,33.57,NULL,51.7,69252,70,NULL,'H, UH88/IRSF/2MASS, Malmquist corr.','UGC 11426',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144464,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144464,33.57,NULL,51.7,69252,70,NULL,'H, 2MASS, Malmquist corr.','UGC 11426',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144465,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144465,34.07,0.33,65.1,69252,70,NULL,'H, UH88/IRSF/2MASS','UGC 11426',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144466,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144466,34.07,0.33,65.1,69252,70,NULL,'H, 2MASS','UGC 11426',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144467,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144467,36.13,0.73,168,69253,70,NULL,NULL,'2MASX J19183210-2845055',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,289.6337083,-28.75158,0.445,NULL,47638841975,744356905,11630576,15.9),(144468,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144468,34.26,0.8,71.3,69254,75,NULL,'MAT, I','ESO 337- G 022',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'13.50',1.3,'Sb-c',NULL,NULL,NULL,NULL,1,289.679,-38.34192,0.409,NULL,51235245673,800550713,12508604,13.5),(144469,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144469,34.17,0.32,68.2,69254,85,NULL,'I, raw','ESO 337- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144470,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144470,34.2,0.32,69.1,69254,85,NULL,'I, inv','ESO 337- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144471,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144471,34.38,0.29,75.2,69254,NULL,NULL,NULL,'ESO 337- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144472,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144472,34.42,0.2,76.6,69254,74.4,NULL,NULL,'ESO 337- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144473,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144473,34.43,0.43,77.1,69254,75,NULL,'MAT, I, raw','ESO 337- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144474,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144474,34.52,0.28,80.1,69254,NULL,NULL,'Malmquist cor.','ESO 337- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144475,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144475,34.59,0.43,82.8,69254,75,NULL,'MAT, I, cor','ESO 337- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144476,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144476,34.6,0.43,83.3,69254,75,NULL,'MAT, I, inv','ESO 337- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144477,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144477,33.03,0.8,40.4,69255,75,NULL,'MAT, I','IC 4844',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.01',1,'SB(r)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,289.761,-56.02717,0.193,NULL,49084978993,766952796,11983637,14.01),(144478,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144478,33.21,0.32,43.9,69255,85,NULL,'I, raw','IC 4844',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144479,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144479,33.25,0.32,44.7,69255,85,NULL,'I, inv','IC 4844',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144480,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144480,33.35,0.43,46.7,69255,75,NULL,'MAT, I, raw','IC 4844',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144481,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144481,33.37,0.4,47.3,69255,NULL,NULL,'mean','IC 4844',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144482,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144482,33.53,0.43,50.9,69255,75,NULL,'MAT, I, inv','IC 4844',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144483,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144483,33.56,0.47,51.6,69255,NULL,NULL,'H','IC 4844',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144484,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144484,33.63,0.43,53.2,69255,75,NULL,'MAT, I, cor','IC 4844',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144485,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144485,33.67,0.45,54.2,69255,NULL,NULL,'K','IC 4844',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144486,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144486,33.69,0.46,54.8,69255,NULL,NULL,'J','IC 4844',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144487,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144487,33.93,0.37,61.1,69255,NULL,NULL,'Malmquist cor.','IC 4844',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144488,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144488,33.95,0.36,61.7,69255,NULL,NULL,NULL,'IC 4844',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144489,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144489,33.99,0.2,62.8,69255,74.4,NULL,NULL,'IC 4844',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144490,'D-Sigma','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144490,33.81,0.4,57.8,69256,75,NULL,'Edat, raw','IC 4842',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000057,NULL,'13.43',0.9,'E:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,289.851958333,-60.64425,0.169,NULL,49070892913,766732701,11980198,13.43),(144491,'D-Sigma','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144491,33.85,0.4,58.8,69256,75,NULL,'Edat, cor','IC 4842',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144492,'Faber-Jackson','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144492,32.94,0.44,38.7,69256,95,NULL,'Weighted Mean','IC 4842',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144493,'Faber-Jackson','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144493,33.18,0.63,43.3,69256,95,NULL,'Michard 1979b, c','IC 4842',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144494,'Faber-Jackson','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144494,33.5,0.46,50.1,69256,95,NULL,'Michard 1979a','IC 4842',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144495,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144495,33.79,0.51,57.3,69256,70,NULL,NULL,'IC 4842',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144496,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144496,33.17,0.45,43,69256,NULL,NULL,'K','IC 4842',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144497,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144497,33.71,0.4,55.1,69256,NULL,NULL,'mean','IC 4842',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144498,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144498,36.2,0.7,174,69257,70,NULL,NULL,'2MASX J19192610-2010023',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,289.8587917,-20.16742,0.421,NULL,48102317732,751598714,11743729,15.4),(144499,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144499,34.43,0.51,76.7,69258,NULL,NULL,NULL,'ESO 397- G 016',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000033,NULL,'14.65',1,'Sb-c',NULL,NULL,NULL,NULL,1,289.9087083,-35.72433,0.337,NULL,51169380172,799521565,12492524,14.65),(144500,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144500,34.47,0.2,78.3,69258,74.4,NULL,NULL,'ESO 397- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144501,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144501,34.63,0.47,84.2,69258,NULL,NULL,'Malmquist cor.','ESO 397- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144502,'GRB','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144502,37.47,NULL,312,69259,65,NULL,'L = 10e57 photons/s','2B 920406',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,289.908333,-57.68972,0.201,NULL,49119241123,767488142,11992002,NULL),(144503,'GRB','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144503,40.54,NULL,1280,69259,65,NULL,'L = 2 x 10e58 photons/s','2B 920406',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144504,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144504,35.57,0.6,130,69260,70,NULL,NULL,'2MASX J19193950-1356541',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'14.2R',0.2,NULL,NULL,NULL,NULL,NULL,1,289.914625,-13.94833,0.977,NULL,48298097760,754657777,11791527,14.2),(144505,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144505,34.9,0.4,95.6,69261,NULL,NULL,'mean','ESO 459- G 012',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000033,NULL,'13.19',0.4,'S              HII',NULL,NULL,NULL,NULL,1,289.961875,-28.81292,0.445,NULL,47638661668,744354088,11630532,13.19),(144506,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144506,35.07,0.47,103,69261,NULL,NULL,'H','ESO 459- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144507,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144507,35.1,0.45,105,69261,NULL,NULL,'K','ESO 459- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144508,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144508,35.34,0.6,117,69261,NULL,NULL,'Malmquist cor.','ESO 459- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144509,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144509,35.7,0.5,138,69261,NULL,NULL,NULL,'ESO 459- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144510,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144510,35.74,0.2,141,69261,74.4,NULL,NULL,'ESO 459- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144511,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144511,34.71,0.55,87.5,69262,70,NULL,NULL,'FAIRALL 0056',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000057,NULL,'14.2R',NULL,'Bright nucleus',NULL,NULL,NULL,NULL,1,290.00775,-60.81875,0.169,NULL,49070921997,766733156,11980205,14.2),(144512,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144512,34.54,0.69,80.7,69263,70,NULL,NULL,'ESO 184- G 057',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.00',0.2,'S0',NULL,NULL,NULL,NULL,1,290.098041667,-54.34619,0.229,NULL,49076367560,766818243,11981535,15),(144513,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144513,36.64,0.59,213,69264,70,NULL,NULL,'2MASX J19202879-6330058',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,290.120083,-63.50169,0.181,NULL,48953292771,764895199,11951487,17.2),(144514,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144514,35.86,0.73,149,69265,70,NULL,NULL,'2MASX J19204479-6011029',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,290.186667,-60.18408,0.165,NULL,49073102253,766767222,11980737,16),(144515,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144515,35.15,0.61,107,69266,70,NULL,NULL,'2MASX J19204628-1355094',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,290.192791667,-13.91931,0.909,NULL,48300906431,754701662,11792213,14.3),(144516,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144516,35.6,0.5,132,69267,70,NULL,NULL,'2MASX J19205449-1203324',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'14.7R',0.2,NULL,NULL,NULL,NULL,NULL,1,290.2270417,-12.059,1.077,NULL,48291574311,754555848,11789935,14.7),(144517,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144517,33.37,0.69,47.2,69268,100,NULL,'mid-IR','NGC 6792',NULL,'2013ApJ...771...88L',2013,1,2.2,NULL,'G',0.000017,NULL,'12.9',1.3,'SBb','in a pair',NULL,NULL,NULL,1,290.2392083,43.1325,0.421,NULL,55016629558,859634836,13431794,12.9),(144518,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144518,33.99,0.38,62.8,69268,NULL,NULL,NULL,'NGC 6792',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144519,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144519,34.02,0.38,63.6,69268,NULL,NULL,'Malmquist cor.','NGC 6792',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144520,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144520,34.08,0.46,65.6,69268,NULL,NULL,'J','NGC 6792',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144521,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144521,34.09,0.4,65.8,69268,NULL,NULL,'mean','NGC 6792',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144522,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144522,34.14,0.47,67.2,69268,NULL,NULL,'H','NGC 6792',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144523,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144523,34.14,0.45,67.4,69268,NULL,NULL,'K','NGC 6792',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144524,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144524,34.17,0.2,68.2,69268,74.4,NULL,NULL,'NGC 6792',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144525,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144525,34.39,0.43,75.6,69268,75,NULL,'3.6 micron, color corrected','NGC 6792',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144526,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144526,34.62,0.43,84.1,69268,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6792',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144527,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144527,35.12,NULL,106,69269,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2247',NULL,'2010Ap&SS.325..163P',2010,1,1.16,NULL,'G',0.00009,NULL,'16.8',0.08,'Sd',NULL,NULL,NULL,NULL,1,290.26,54.815,0.457,NULL,53131544281,830180379,12971568,16.8),(144528,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144528,35.12,NULL,106,69269,NULL,NULL,'Dipole','FGC 2247',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144529,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144529,35.13,NULL,106,69269,NULL,NULL,'Dipole + Quadrupole','FGC 2247',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144530,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144530,35.13,NULL,106,69269,NULL,NULL,NULL,'FGC 2247',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144531,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144531,34.9,0.8,95.3,69270,75,NULL,'MAT, I','ESO 459- G 014',NULL,'1997ApJS..109..333W',1997,1,1.6,'6dF DR1 has z = 0.021207.','G',0.000033,NULL,'13.79',0.4,'S...',NULL,NULL,NULL,NULL,1,290.287875,-28.90397,0.477,NULL,47635075526,744298055,11629657,13.79),(144532,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144532,33.71,0.43,55.2,69270,75,NULL,'MAT, I, raw','ESO 459- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144533,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144533,33.71,0.32,55.3,69270,85,NULL,'I, raw','ESO 459- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144534,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144534,33.73,0.32,55.7,69270,85,NULL,'I, inv','ESO 459- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144535,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144535,33.81,0.43,57.9,69270,75,NULL,'MAT, I, inv','ESO 459- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144536,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144536,33.99,0.43,62.8,69270,NULL,NULL,NULL,'ESO 459- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144537,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144537,33.99,0.2,62.8,69270,74.4,NULL,NULL,'ESO 459- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144538,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144538,34.28,0.43,71.8,69270,75,NULL,'MAT, I, cor','ESO 459- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144539,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144539,34.42,0.35,76.6,69270,NULL,NULL,'Malmquist cor.','ESO 459- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144540,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144540,34.99,0.57,99.8,69271,70,NULL,NULL,'2MASX J19210936-5848383',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00009,NULL,'15.5b',0.8,'SA0/a pec',NULL,NULL,NULL,NULL,1,290.289083333,-58.81078,0.185,NULL,49062513606,766601775,11978152,15.5),(144541,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144541,32.44,0.4,30.7,69272,NULL,NULL,'mean','NGC 6796',NULL,'2007A&A...465...71T',2007,1,1.9,'Misidentified as NGC 6797 in CGCG.','G',0.00002,NULL,'13.48',0.4,'Sbc: sp',NULL,NULL,NULL,NULL,1,290.378625,61.14489,0.381,NULL,53098815280,829668988,12963577,13.48),(144542,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,'R',144542,32.68,0.4,34.4,69272,75,NULL,NULL,'NGC 6796',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144543,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144543,32.7,0.47,34.6,69272,NULL,NULL,'H','NGC 6796',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144544,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144544,32.7,0.46,34.7,69272,NULL,NULL,'J','NGC 6796',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144545,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144545,32.75,0.45,35.4,69272,NULL,NULL,'K','NGC 6796',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144546,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144546,32.86,0.43,37.3,69272,75,NULL,'3.6 micron, color corrected','NGC 6796',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144547,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144547,32.86,0.43,37.4,69272,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6796',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144548,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144548,32.92,0.2,38.4,69272,74.4,NULL,NULL,'NGC 6796',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144549,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,'R',144549,33.07,0.49,41.1,69272,75,NULL,'IR','NGC 6796',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144550,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144550,36.78,0.77,227,69273,70,NULL,NULL,'2MASX J19213174-1153170',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.4R',0.2,NULL,NULL,NULL,NULL,NULL,1,290.382166667,-11.88814,1.069,NULL,48160650737,752510167,11757971,15.4),(144551,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144551,35.4,0.52,120,69274,NULL,NULL,'Malmquist cor.','ESO 525- G 003',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.90',0.4,'S...',NULL,NULL,NULL,NULL,1,290.421375,-25.05025,0.557,NULL,47584894943,743513983,11617405,14.9),(144552,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144552,35.42,0.52,121,69274,NULL,NULL,NULL,'ESO 525- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144553,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144553,35.46,0.2,124,69274,74.4,NULL,NULL,'ESO 525- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144554,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144554,36.51,0.83,201,69275,70,NULL,NULL,'2MASX J19215689-1943549',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,290.4870417,-19.73189,0.397,NULL,48101610255,751587660,11743557,15.9),(144555,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144555,33.78,0.49,57.1,69276,70,NULL,NULL,'2MASX J19215935-6002349',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000067,NULL,'14.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,290.4975,-60.043,0.161,NULL,49072697528,766760898,11980639,14.7),(144556,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144556,35.54,0.52,128,69277,70,NULL,NULL,'2MASX J19220548-1138420',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.9R',0.2,NULL,NULL,NULL,NULL,NULL,1,290.522875,-11.64506,1.033,NULL,48160949491,752514835,11758044,14.9),(144557,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144557,35.73,0.76,140,69278,70,NULL,NULL,'2MASX J19221167-1900559',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,290.548583,-19.01553,0.381,NULL,48104394962,751631171,11744237,15.2),(144558,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144558,32.74,0.8,35.3,69279,75,NULL,'MAT, I','ESO 184- G 060',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'14.75',1,'(R\')SAB(rs)d:',NULL,NULL,NULL,NULL,1,290.672917,-54.58611,0.157,NULL,49075602849,766806294,11981348,14.75),(144559,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144559,31.73,0.32,22.2,69279,85,NULL,'I, inv','ESO 184- G 060',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144560,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144560,31.77,0.32,22.6,69279,85,NULL,'I, raw','ESO 184- G 060',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144561,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144561,32.3,0.43,28.9,69279,75,NULL,'MAT, I, inv','ESO 184- G 060',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144562,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144562,32.35,0.43,29.6,69279,75,NULL,'MAT, I, raw','ESO 184- G 060',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144563,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144563,32.76,0.43,35.6,69279,75,NULL,'MAT, I, cor','ESO 184- G 060',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144564,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144564,34.78,0.57,90.3,69280,70,NULL,NULL,'2MASX J19230788-6258131',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,290.78275,-62.97036,0.173,NULL,48940479222,764694987,11948359,15.6),(144565,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144565,36.02,0.66,160,69281,70,NULL,NULL,'ESO 593- G 013',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.3R',0.5,'Sb:',NULL,NULL,NULL,NULL,1,290.785958333,-17.7235,0.401,NULL,48074608983,751165765,11736965,15.3),(144566,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144566,36.99,0.59,250,69282,70,NULL,NULL,'2MASX J19233275-6427439',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,290.886291667,-64.46217,0.209,NULL,48948637167,764822455,11950350,17.1),(144567,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144567,35.8,0.57,144,69283,70,NULL,NULL,'2MASX J19233782-1148031',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'13.9I',0.2,NULL,NULL,NULL,NULL,NULL,1,290.907541667,-11.80089,1.021,NULL,48160273210,752504268,11757879,13.9),(144568,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144568,32.87,0.8,37.6,69284,75,NULL,'MAT, I','ESO 184- G 063',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000024,NULL,'14.65',0.5,'Sb: pec sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,290.9175417,-55.06564,0.153,NULL,49082894955,766920233,11983128,14.65),(144569,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144569,32.83,0.45,36.8,69284,NULL,NULL,'K','ESO 184- G 063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144570,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144570,32.86,0.47,37.3,69284,NULL,NULL,'H','ESO 184- G 063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144571,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144571,33.06,0.46,40.9,69284,NULL,NULL,'J','ESO 184- G 063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144572,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144572,33.11,0.43,41.8,69284,75,NULL,'MAT, I, raw','ESO 184- G 063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144573,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144573,33.13,0.32,42.2,69284,85,NULL,'I, raw','ESO 184- G 063',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144574,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144574,33.15,0.32,42.7,69284,85,NULL,'I, inv','ESO 184- G 063',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144575,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144575,33.17,0.4,43.1,69284,NULL,NULL,'mean','ESO 184- G 063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144576,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144576,33.26,0.43,44.9,69284,75,NULL,'MAT, I, inv','ESO 184- G 063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144577,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144577,33.43,0.47,48.6,69284,NULL,NULL,NULL,'ESO 184- G 063',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144578,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144578,33.46,0.43,49.1,69284,75,NULL,'MAT, I, cor','ESO 184- G 063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144579,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144579,33.47,0.2,49.4,69284,74.4,NULL,NULL,'ESO 184- G 063',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144580,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144580,33.62,0.43,52.9,69284,NULL,NULL,'Malmquist cor.','ESO 184- G 063',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144581,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144581,33.45,NULL,49.1,69285,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11433',NULL,'2010Ap&SS.325..163P',2010,1,1.05,'Matthews et al. (2000A&AS..143..421M) give v = 2945 +/- 14 km/sec.','G',0.00001,NULL,'15.6',0.11,'Sd',NULL,NULL,NULL,NULL,1,290.9587083,34.795,NULL,NULL,54874358830,857411856,13397060,15.6),(144582,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,'R',144582,33.47,0.49,49.5,69285,75,NULL,'IR','UGC 11433',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144583,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144583,33.48,NULL,49.6,69285,NULL,NULL,'Dipole + Quadrupole','UGC 11433',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144584,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144584,33.48,NULL,49.6,69285,NULL,NULL,'Dipole','UGC 11433',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144585,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144585,33.54,NULL,51.1,69285,NULL,NULL,NULL,'UGC 11433',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144586,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144586,33.58,0.43,51.9,69285,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11433',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144587,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,'R',144587,32.78,0.49,35.9,69286,75,NULL,'IR','UGC 11435',NULL,'2011yCatp016004901K',2011,1,2.41,NULL,'G',0.00003,NULL,'14.92',0.32,'Sc',NULL,NULL,NULL,NULL,1,290.9622917,55.98761,0.529,NULL,53124404278,830068816,12969825,14.92),(144588,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144588,32.79,0.43,36.2,69286,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11435',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144589,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144589,32.85,0.2,37.2,69286,74.4,NULL,NULL,'UGC 11435',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144590,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144590,32.87,0.43,37.4,69286,75,NULL,'3.6 micron, color corrected','UGC 11435',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144591,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144591,32.91,0.54,38.1,69286,NULL,NULL,NULL,'UGC 11435',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144592,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144592,33.01,0.52,40,69286,NULL,NULL,'Malmquist cor.','UGC 11435',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144593,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144593,33.18,0.47,43.3,69286,NULL,NULL,'H','UGC 11435',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144594,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144594,33.32,NULL,46,69286,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11435',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144595,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144595,33.32,NULL,46.1,69286,NULL,NULL,'Dipole','UGC 11435',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144596,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144596,33.32,NULL,46.2,69286,NULL,NULL,'Dipole + Quadrupole','UGC 11435',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144597,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144597,33.38,0.46,47.5,69286,NULL,NULL,'J','UGC 11435',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144598,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144598,33.38,0.45,47.5,69286,NULL,NULL,'K','UGC 11435',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144599,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144599,33.5,0.4,50,69286,NULL,NULL,'mean','UGC 11435',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144600,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144600,34.1,0.8,66.1,69287,75,NULL,'MAT, I','ESO 397- G 018',NULL,'1997ApJS..109..333W',1997,1,2.41,NULL,'G',0.000023,NULL,'13.36',0.31,'Sc',NULL,NULL,NULL,NULL,1,291.0449583,-35.18131,0.321,NULL,51166840180,799481877,12491904,13.36),(144601,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,'R',144601,33.49,0.49,49.9,69287,75,NULL,'IR','ESO 397- G 018',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144602,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144602,33.71,0.32,55.2,69287,85,NULL,'I, raw','ESO 397- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144603,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144603,33.74,0.43,55.9,69287,75,NULL,'MAT, I, raw','ESO 397- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144604,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144604,33.74,0.32,55.9,69287,85,NULL,'I, inv','ESO 397- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144605,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144605,33.88,0.43,59.8,69287,75,NULL,'MAT, I, inv','ESO 397- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144606,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144606,33.9,0.52,60.3,69287,NULL,NULL,NULL,'ESO 397- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144607,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144607,34,NULL,63,69287,NULL,NULL,NULL,'ESO 397- G 018',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144608,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144608,34.03,0.43,63.9,69287,75,NULL,'3.6 micron, color + selection bias corrected','ESO 397- G 018',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144609,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144609,34.13,NULL,67.1,69287,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 397- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144610,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144610,34.14,NULL,67.3,69287,NULL,NULL,'Dipole','ESO 397- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144611,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144611,34.14,0.43,67.3,69287,75,NULL,'3.6 micron, color corrected','ESO 397- G 018',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144612,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144612,34.14,NULL,67.4,69287,NULL,NULL,'Dipole + Quadrupole','ESO 397- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144613,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144613,34.19,0.43,69,69287,75,NULL,'MAT, I, cor','ESO 397- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144614,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144614,34.26,0.2,71.1,69287,74.4,NULL,NULL,'ESO 397- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144615,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144615,34.29,0.43,72,69287,NULL,NULL,'Malmquist cor.','ESO 397- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144616,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144616,35.78,0.57,143,69288,70,NULL,NULL,'2MASX J19241364-1544354',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,291.056875,-15.74319,0.745,NULL,48295118799,754611231,11790800,14.7),(144617,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144617,35.41,0.63,121,69289,70,NULL,NULL,'2MASX J19241538-7518059',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,291.064083333,-75.30175,0.277,NULL,48505004878,757890701,11842042,15),(144618,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144618,36.59,0.59,208,69290,70,NULL,NULL,'2MASX J19241852-2457249',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,291.077167,-24.95692,0.501,NULL,47588361289,743568145,11618252,14.4),(144619,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144619,36.37,0.82,188,69291,70,NULL,NULL,'2MASX J19250338-6308115',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,291.264167,-63.13658,0.205,NULL,48942501930,764726592,11948853,17.2),(144620,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144620,36.81,0.67,230,69292,70,NULL,NULL,'2MASX J19250396-5810557',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,291.2667083,-58.18217,0.185,NULL,49061071827,766579247,11977800,17.2),(144621,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144621,33.35,0.8,46.7,69293,75,NULL,'MAT, I','NGC 6776A',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.80',0.3,'SB(s)cd: sp','Pair member (points to parent)',NULL,NULL,NULL,1,291.272417,-63.68344,0.185,NULL,48941852999,764716453,11948694,14.8),(144622,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,'R',144622,33.14,0.49,42.4,69293,75,NULL,'IR','NGC 6776A',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144623,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144623,33.23,0.32,44.3,69293,85,NULL,'I, raw','NGC 6776A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144624,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144624,33.25,0.32,44.6,69293,85,NULL,'I, inv','NGC 6776A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144625,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144625,33.51,0.43,50.4,69293,75,NULL,'MAT, I, raw','NGC 6776A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144626,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144626,33.62,0.43,53.1,69293,75,NULL,'MAT, I, inv','NGC 6776A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144627,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144627,33.7,0.1,55.1,69293,NULL,NULL,NULL,'NGC 6776A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144628,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144628,33.72,0.43,55.4,69293,75,NULL,'MAT, I, cor','NGC 6776A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144629,'D-Sigma','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144629,32.77,0.4,35.8,69294,75,NULL,'Edat, raw','NGC 6776',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000043,NULL,'13.05',1.4,'E+ pec:     LINER/Sy','Pair member (points to parent)',NULL,NULL,NULL,1,291.3297917,-63.86017,0.185,NULL,48942096110,764720251,11948753,13.05),(144630,'D-Sigma','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144630,33.11,0.4,41.8,69294,75,NULL,'Edat, cor','NGC 6776',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144631,'Faber-Jackson','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144631,32.15,0.44,26.9,69294,95,NULL,'Weighted Mean','NGC 6776',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144632,'Faber-Jackson','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144632,32.26,0.63,28.3,69294,95,NULL,'Michard 1979b, c','NGC 6776',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144633,'Faber-Jackson','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144633,32.64,0.46,33.7,69294,95,NULL,'Michard 1979a','NGC 6776',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144634,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144634,34.06,0.45,64.8,69294,NULL,NULL,'K','NGC 6776',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144635,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144635,34.36,0.4,74.4,69294,NULL,NULL,'mean','NGC 6776',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144636,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144636,34.52,0.49,80.3,69295,75,NULL,'IR','ESO 460- G 001',NULL,'2011yCatp016004901K',2011,1,1.5,'6dF final data release has z = 0.180722 +- 0.000183.','G',0.000033,NULL,'15.9b',0.3,'S...',NULL,NULL,NULL,NULL,1,291.345583,-32.21836,0.345,NULL,51165678210,799463722,12491620,15.9),(144637,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144637,34.94,0.45,97.5,69295,NULL,NULL,'Malmquist cor.','ESO 460- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144638,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144638,35.16,0.4,108,69295,NULL,NULL,NULL,'ESO 460- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144639,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144639,35.2,0.2,110,69295,74.4,NULL,NULL,'ESO 460- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144640,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144640,34.33,0.8,73.5,69296,75,NULL,'MAT, I','ESO 282- G 035',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000031,NULL,'15.26',1.7,'SA(s)c',NULL,NULL,NULL,NULL,1,291.3527917,-42.78561,0.289,NULL,51257029483,800891085,12513923,15.26),(144641,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144641,33.22,0.32,44.1,69296,85,NULL,'I, inv','ESO 282- G 035',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144642,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144642,33.23,0.32,44.3,69296,85,NULL,'I, raw','ESO 282- G 035',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144643,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144643,33.88,0.43,59.7,69296,75,NULL,'MAT, I, raw','ESO 282- G 035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144644,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144644,33.93,0.43,61.1,69296,75,NULL,'MAT, I, inv','ESO 282- G 035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144645,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144645,34.2,0.43,69.1,69296,75,NULL,'MAT, I, cor','ESO 282- G 035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144646,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144646,36.56,0.68,205,69297,70,NULL,NULL,'2MASX J19252769-1810245',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,291.365333,-18.17353,0.405,NULL,48103294027,751613969,11743968,15.8),(144647,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144647,34.59,0.6,82.9,69298,NULL,NULL,'Malmquist cor.','IC 4849',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.53',0.5,'SA:(s)c',NULL,NULL,NULL,NULL,1,291.3999583,-62.93272,0.209,NULL,48942442450,764725663,11948838,14.53),(144648,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144648,35.1,0.48,105,69298,NULL,NULL,NULL,'IC 4849',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144649,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144649,35.14,0.2,107,69298,74.4,NULL,NULL,'IC 4849',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144650,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144650,35.27,0.47,113,69298,NULL,NULL,'H','IC 4849',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144651,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144651,35.41,0.45,121,69298,NULL,NULL,'K','IC 4849',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144652,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144652,35.47,0.46,124,69298,NULL,NULL,'J','IC 4849',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144653,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144653,35.5,0.4,126,69298,NULL,NULL,'mean','IC 4849',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144654,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144654,36.83,0.58,232,69299,70,NULL,NULL,'2MASX J19253882-1004422',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'16.1R',0.2,NULL,NULL,NULL,NULL,NULL,1,291.411791667,-10.0785,1.069,NULL,48167013906,752609592,11759524,16.1),(144655,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144655,36.82,0.52,231,69300,70,NULL,NULL,'2MASX J19255063-4520088',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,291.461083,-45.33581,0.233,NULL,51248279012,800754359,12511786,14.9),(144656,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144656,37.17,0.67,271,69301,70,NULL,NULL,'2MASX J19260350-2633219',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,291.514625,-26.55606,0.469,NULL,47593809690,743653276,11619582,15.7),(144657,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144657,36.47,0.6,197,69302,70,NULL,NULL,'2MASX J19261335-6907212',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,291.5554583,-69.1225,0.305,NULL,49257569330,769649520,12025773,16.9),(144658,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144658,34.57,0.49,82.1,69303,70,NULL,NULL,'NGC 6784B',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000087,NULL,'14.84',0.9,'SAB0','Pair member (points to parent)',NULL,NULL,NULL,1,291.6499583,-65.61769,0.289,NULL,49231429459,769241085,12019391,14.84),(144659,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144659,35.5,0.7,126,69304,70,NULL,NULL,'2MASX J19263690-1338526',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,291.653833333,-13.64797,0.801,NULL,48287514385,754492412,11788943,15.8),(144660,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144660,33.67,0.2,54.2,69305,74.4,NULL,NULL,'UGC 11438',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.00002,NULL,'14.4',0.9,'Scd:',NULL,NULL,NULL,NULL,1,291.655833,49.75844,0.333,NULL,54982488408,859101381,13423459,14.4),(144661,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144661,33.75,0.58,56.3,69305,NULL,NULL,NULL,'UGC 11438',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144662,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144662,33.91,0.54,60.6,69305,NULL,NULL,'Malmquist cor.','UGC 11438',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144663,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144663,32.85,0.8,37.1,69306,75,NULL,'MAT, I','NGC 6788',NULL,'1997ApJS..109..333W',1997,1,2.9,NULL,'G',0.000033,NULL,'12.86',0.9,'SA(s)ab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,291.7072917,-54.95131,0.149,NULL,49012545052,765821016,11965953,12.86),(144664,'Sosies','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144664,33.26,0.05,44.9,69306,NULL,NULL,NULL,'NGC 6788',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144665,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144665,32.9,0.46,37.9,69306,NULL,NULL,'J','NGC 6788',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144666,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144666,32.92,0.47,38.4,69306,NULL,NULL,'H','NGC 6788',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144667,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144667,32.96,0.45,39.1,69306,NULL,NULL,'K','NGC 6788',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144668,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144668,33.11,0.4,42,69306,NULL,NULL,'mean','NGC 6788',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144669,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144669,33.24,0.43,44.5,69306,75,NULL,'MAT, I, raw','NGC 6788',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144670,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144670,33.31,0.32,46,69306,85,NULL,'I, raw','NGC 6788',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144671,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144671,33.37,0.39,47.3,69306,NULL,NULL,NULL,'NGC 6788',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144672,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144672,33.39,0.39,47.6,69306,NULL,NULL,'Malmquist cor.','NGC 6788',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144673,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144673,33.4,0.32,47.8,69306,85,NULL,'I, inv','NGC 6788',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144674,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144674,33.42,0.2,48.3,69306,74.4,NULL,NULL,'NGC 6788',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144675,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144675,33.56,0.43,51.6,69306,75,NULL,'MAT, I, cor','NGC 6788',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144676,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144676,33.59,0.43,52.2,69306,75,NULL,'MAT, I, inv','NGC 6788',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144677,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144677,35.58,0.65,131,69307,70,NULL,NULL,'2MASX J19265088-1147169',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.3R',0.2,'E',NULL,NULL,NULL,NULL,1,291.712083,-11.78803,0.849,NULL,48152953892,752389904,11756092,15.3),(144678,'BL Lac Luminosity','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144678,39,NULL,631,69308,NULL,NULL,'Min. z = 0.16','1FGL J1926.8+6153',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,291.725,61.884,0.233,NULL,53085056727,829454011,12960218,NULL),(144679,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144679,36.44,0.53,194,69309,70,NULL,NULL,'2MASX J19265863-6256546',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,291.744375,-62.9485,0.209,NULL,48942478176,764726221,11948847,15.9),(144680,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144680,34.95,0.59,97.9,69310,70,NULL,NULL,'2MASX J19272537-7941079',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000133,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,291.855333333,-79.68553,0.541,NULL,48553236716,758644323,11853817,16.2),(144681,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144681,37.55,0.63,324,69311,70,NULL,NULL,'2MASX J19272987-1004539',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,291.8745,-10.08164,1.089,NULL,48167361353,752615021,11759609,16.1),(144682,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144682,33.21,0.43,43.9,69312,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6801',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.000143,NULL,'14.62',0.7,'SAcd',NULL,NULL,NULL,NULL,1,291.899208333,54.37289,0.701,NULL,52984756682,827886823,12935731,14.62),(144683,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144683,33.23,0.2,44.3,69312,74.4,NULL,NULL,'NGC 6801',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144684,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144684,33.24,0.43,44.4,69312,75,NULL,'3.6 micron, color corrected','NGC 6801',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144685,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144685,33.26,0.47,44.9,69312,NULL,NULL,NULL,'NGC 6801',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144686,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144686,33.27,0.69,45.2,69312,100,NULL,'mid-IR','NGC 6801',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144687,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144687,33.34,0.45,46.6,69312,NULL,NULL,'Malmquist cor.','NGC 6801',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144688,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144688,33.77,0.47,56.8,69312,NULL,NULL,'H','NGC 6801',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144689,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144689,33.84,0.4,58.6,69312,NULL,NULL,'mean','NGC 6801',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144690,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144690,33.85,0.45,58.8,69312,NULL,NULL,'K','NGC 6801',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144691,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144691,33.85,0.46,59,69312,NULL,NULL,'J','NGC 6801',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144692,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144692,35.6,0.49,132,69313,70,NULL,NULL,'2MASX J19273793-6925046',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,291.907917,-69.41786,0.281,NULL,49257599138,769649986,12025781,15.7),(144693,'GRB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144693,37.99,NULL,396,69314,65,NULL,'L = 10e57 photons/s','GRB 790331',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,291.999375,3.68011,NULL,NULL,54642232362,853784880,13340388,NULL),(144694,'GRB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144694,40.92,NULL,1530,69314,65,NULL,'L = 2 x 10e58 photons/s','GRB 790331',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144695,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144695,34.71,0.4,87.4,69315,NULL,NULL,'mean','NGC 6794',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.00003,NULL,'13.9',1.5,'SA(rl)a',NULL,NULL,NULL,NULL,1,292.016166667,-38.91875,0.441,NULL,51232883733,800513808,12508028,13.9),(144696,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144696,34.9,0.47,95.7,69315,NULL,NULL,'H','NGC 6794',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144697,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144697,34.94,0.45,97.2,69315,NULL,NULL,'K','NGC 6794',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144698,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144698,34.95,0.46,97.7,69315,NULL,NULL,'J','NGC 6794',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144699,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144699,36.32,0.54,184,69316,70,NULL,NULL,'2MASX J19281270-2940252',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,292.0529583,-29.67375,0.449,NULL,51142102862,799095357,12485864,14.7),(144700,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144700,35.37,0.46,118,69317,70,NULL,NULL,'ESO 460- G 004',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000067,NULL,'13.83',1.3,'E+4',NULL,NULL,NULL,NULL,1,292.070875,-29.529,0.465,NULL,51142018195,799094034,12485844,13.83),(144701,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144701,33.87,0.8,59.5,69318,75,NULL,'MAT, I','IC 4857',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'13.7',1.2,'SB(s)cd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,292.16325,-58.76792,0.193,NULL,49064767964,766636999,11978703,13.7),(144702,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144702,33.33,0.43,46.3,69318,75,NULL,'MAT, I, raw','IC 4857',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144703,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144703,33.44,0.32,48.7,69318,85,NULL,'I, raw','IC 4857',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144704,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144704,33.47,0.32,49.5,69318,85,NULL,'I, inv','IC 4857',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144705,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144705,33.49,0.43,50,69318,75,NULL,'MAT, I, inv','IC 4857',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144706,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144706,33.61,0.43,52.6,69318,75,NULL,'MAT, I, cor','IC 4857',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144707,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144707,33.99,0.08,62.9,69318,NULL,NULL,NULL,'IC 4857',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144708,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144708,34.01,0.4,63.3,69318,NULL,NULL,'mean','IC 4857',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144709,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144709,34.11,0.47,66.5,69318,NULL,NULL,'H','IC 4857',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144710,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144710,34.23,0.45,70.2,69318,NULL,NULL,'K','IC 4857',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144711,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144711,34.24,0.46,70.5,69318,NULL,NULL,'J','IC 4857',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144712,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144712,36.57,0.75,207,69319,70,NULL,NULL,'2MASX J19290073-7555180',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,292.2530417,-75.92167,0.285,NULL,48506860794,757919699,11842495,15.1),(144713,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144713,34.07,0.38,65.2,69320,NULL,NULL,'Malmquist cor.','IC 4861',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.50',0.3,'Sc:',NULL,NULL,NULL,NULL,1,292.319666667,-57.57497,0.181,NULL,49115549134,767430455,11991100,15.5),(144714,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144714,34.11,0.37,66.5,69320,NULL,NULL,NULL,'IC 4861',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144715,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144715,34.15,0.49,67.5,69320,75,NULL,'IR','IC 4861',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144716,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144716,34.15,0.2,67.6,69320,74.4,NULL,NULL,'IC 4861',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144717,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144717,35.37,0.49,118,69321,75,NULL,'IR','UGC 11447',NULL,'2011yCatp016004901K',2011,1,1.18,NULL,'G',NULL,NULL,'17.',0.12,'Sc',NULL,NULL,NULL,NULL,1,292.320916667,50.43386,0.441,NULL,54981307688,859082932,13423170,17),(144718,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144718,35.66,NULL,136,69321,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11447',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144719,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144719,35.68,NULL,137,69321,NULL,NULL,'Dipole + Quadrupole','UGC 11447',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144720,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144720,35.69,NULL,137,69321,NULL,NULL,'Dipole','UGC 11447',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144721,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144721,35.7,NULL,138,69321,NULL,NULL,NULL,'UGC 11447',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144722,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144722,34.42,0.8,76.5,69322,75,NULL,'MAT, I','ESO 460- G 008',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000032,NULL,'14.37',0.7,'SAb:',NULL,NULL,NULL,NULL,1,292.334625,-32.19244,0.361,NULL,51197471709,799960495,12499382,14.37),(144723,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144723,33.94,0.43,61.5,69322,75,NULL,'MAT, I, raw','ESO 460- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144724,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144724,34.08,0.32,65.6,69322,85,NULL,'I, raw','ESO 460- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144725,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144725,34.12,0.43,66.7,69322,75,NULL,'MAT, I, inv','ESO 460- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144726,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144726,34.13,0.32,66.9,69322,85,NULL,'I, inv','ESO 460- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144727,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144727,34.37,0.43,74.9,69322,75,NULL,'MAT, I, cor','ESO 460- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144728,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144728,37.02,0.67,254,69323,70,NULL,NULL,'2MASX J19292798-6903228',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,292.366625,-69.05639,0.305,NULL,49257889751,769654527,12025851,16.9),(144729,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144729,37.04,0.78,256,69324,70,NULL,NULL,'2MASX J19294638-8412199',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,292.442375,-84.2055,0.469,NULL,48375945091,755874142,11810533,17.3),(144730,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144730,35.9,0.51,151,69325,70,NULL,NULL,'2MASX J19295118-6238385',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,292.4630417,-62.64411,0.225,NULL,48942909254,764732957,11948952,16),(144731,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144731,33.98,0.46,62.4,69326,NULL,NULL,'J','UGC 11455',NULL,'2007A&A...465...71T',2007,1,2.74,NULL,'G',0.000053,NULL,'15.00',0.37,'Sc','Pair member (points to parent)',NULL,NULL,NULL,1,292.484417,72.11281,0.457,NULL,53591521255,837367519,13083867,15),(144732,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144732,33.98,0.47,62.5,69326,NULL,NULL,'H','UGC 11455',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144733,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144733,34.07,0.45,65.3,69326,NULL,NULL,'K','UGC 11455',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144734,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144734,34.08,0.49,65.5,69326,75,NULL,'IR','UGC 11455',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144735,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144735,34.28,0.4,71.7,69326,NULL,NULL,'mean','UGC 11455',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144736,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144736,34.66,NULL,85.6,69326,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11455',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144737,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144737,34.67,NULL,85.8,69326,NULL,NULL,'Dipole + Quadrupole','UGC 11455',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144738,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144738,34.67,NULL,85.9,69326,NULL,NULL,'Dipole','UGC 11455',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144739,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144739,34.67,0.51,86,69326,NULL,NULL,'Malmquist cor.','UGC 11455',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144740,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144740,34.69,0.43,86.5,69326,75,NULL,'3.6 micron, color corrected','UGC 11455',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144741,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144741,34.7,0.2,87.1,69326,74.4,NULL,NULL,'UGC 11455',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144742,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144742,34.79,0.43,90.7,69326,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11455',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144743,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144743,34.88,0.46,94.6,69326,NULL,NULL,NULL,'UGC 11455',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144744,'Brightest Stars','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144744,25.21,NULL,1.1,69327,NULL,NULL,'PHOTOGRAPHIC','Sagittarius Dwarf Irregular',NULL,'1978MNRAS.183P..97L',1978,1,2.9,NULL,'G',0.000003,NULL,'14.1B',2.1,'IB(s)m:','Group member',NULL,NULL,NULL,1,292.49825,-17.68092,0.549,0,48079550362,751242974,11738171,14.1),(144745,'Brightest Stars','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144745,25.3,NULL,1.15,69327,NULL,NULL,'Blue','Sagittarius Dwarf Irregular',NULL,'1988ASPC....4...75C',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144746,'Carbon Stars','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144746,25,NULL,1,69327,NULL,NULL,NULL,'Sagittarius Dwarf Irregular',NULL,'1988ASPC....4...75C',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144747,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144747,25.11,NULL,1.05,69327,NULL,NULL,NULL,'Sagittarius Dwarf Irregular',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144748,'Red Clump','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144748,24.94,NULL,0.971,69327,NULL,NULL,'I, M RC(I) = -0.50 mag','Sagittarius Dwarf Irregular',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144749,'Red Clump','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144749,24.95,NULL,0.977,69327,NULL,NULL,'V, M RC(V) = +0.73 mag','Sagittarius Dwarf Irregular',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144750,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144750,25.09,0.1,1.04,69327,NULL,NULL,NULL,'Sagittarius Dwarf Irregular',NULL,'2002A&A...389..812K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144751,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144751,25.13,0.2,1.06,69327,NULL,NULL,'I','Sagittarius Dwarf Irregular',NULL,'1999A&A...352..363K',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144752,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144752,25.14,0.18,1.07,69327,NULL,NULL,'I','Sagittarius Dwarf Irregular',NULL,'2002A&A...384..393M',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144753,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144753,25.16,0.11,1.08,69327,NULL,NULL,'I','Sagittarius Dwarf Irregular',NULL,'2014A&A...570A..78B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144754,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144754,25.17,0.1,1.08,69327,74.4,NULL,NULL,'Sagittarius Dwarf Irregular',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144755,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144755,25.36,0.18,1.18,69327,NULL,NULL,'I','Sagittarius Dwarf Irregular',NULL,'2000AJ....119..777L',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144756,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144756,25.36,NULL,1.18,69327,NULL,NULL,'I, M TRGB(I) = -4.05 mag','Sagittarius Dwarf Irregular',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144757,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144757,25.4,NULL,1.2,69327,NULL,NULL,'I','Sagittarius Dwarf Irregular',NULL,'1988ASPC....4...75C',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144758,'Tully est','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144758,24.23,0.8,0.7,69327,75,NULL,NULL,'Sagittarius Dwarf Irregular',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144759,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144759,36.7,0.77,219,69328,70,NULL,NULL,'2MASX J19300317-2249458',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,292.51325,-22.82942,0.349,NULL,48061728327,750964505,11733820,15.8),(144760,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144760,37.54,0.6,323,69329,70,NULL,NULL,'2MASX J19300568-7034439',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,292.523833,-70.57886,0.281,NULL,49251228574,769550446,12024225,16.9),(144761,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144761,36.51,0.53,201,69330,70,NULL,NULL,'2MASX J19302777-2750566',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,292.615791667,-27.84897,0.501,NULL,47590318257,743598722,11618730,15.4),(144762,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144762,34.15,0.8,67.7,69331,75,NULL,'MAT, I','ESO 184- G 074',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000026,NULL,'14.79',0.4,'SAB(rl)a:',NULL,NULL,NULL,NULL,1,292.627375,-57.28386,0.145,NULL,49081991264,766906113,11982908,14.79),(144763,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144763,34.03,0.32,63.9,69331,85,NULL,'I, raw','ESO 184- G 074',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144764,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144764,34.05,0.43,64.5,69331,75,NULL,'MAT, I, raw','ESO 184- G 074',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144765,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144765,34.08,0.32,65.5,69331,85,NULL,'I, inv','ESO 184- G 074',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144766,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144766,34.11,0.43,66.5,69331,75,NULL,'MAT, I, cor','ESO 184- G 074',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144767,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144767,34.16,0.42,67.8,69331,NULL,NULL,'Malmquist cor.','ESO 184- G 074',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144768,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144768,34.23,0.4,70.2,69331,NULL,NULL,'mean','ESO 184- G 074',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144769,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144769,34.27,0.49,71.5,69331,75,NULL,'IR','ESO 184- G 074',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144770,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144770,34.29,0.43,72,69331,75,NULL,'MAT, I, inv','ESO 184- G 074',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144771,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144771,34.35,0.47,74.1,69331,NULL,NULL,'H','ESO 184- G 074',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144772,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144772,34.46,0.45,77.9,69331,NULL,NULL,'K','ESO 184- G 074',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144773,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144773,34.52,0.46,80.1,69331,NULL,NULL,'J','ESO 184- G 074',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144774,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144774,34.53,0.36,80.4,69331,NULL,NULL,NULL,'ESO 184- G 074',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144775,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144775,34.57,0.2,82,69331,74.4,NULL,NULL,'ESO 184- G 074',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144776,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144776,33.02,0.68,40.1,69332,NULL,NULL,NULL,'UGC 11448',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000017,NULL,'16.0',0.8,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,292.63825,35.77681,NULL,NULL,54873442019,857397531,13396836,16),(144777,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144777,33.23,0.2,44.3,69332,74.4,NULL,NULL,'UGC 11448',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144778,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144778,33.26,0.61,44.8,69332,NULL,NULL,'Malmquist cor.','UGC 11448',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144779,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144779,35.47,0.55,124,69333,70,NULL,NULL,'2MASX J19303773-5217259',NULL,'2014MNRAS.445.2677S',2014,1,60,NULL,'G',0.00015,NULL,'2.35',2.92,'IRAS FaintSrcCat(v2)',NULL,NULL,NULL,NULL,1,292.657208333,-52.29056,0.125,NULL,51103685614,798495087,12476485,2.35),(144780,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144780,32.34,0.49,29.4,69334,75,NULL,'IR','FGC 2253',NULL,'2011yCatp016004901K',2011,1,1.09,NULL,'G',NULL,NULL,'16.1',0.13,'Sc',NULL,NULL,NULL,NULL,1,292.693583,53.889,0.757,NULL,52985259207,827894675,12935854,16.1),(144781,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144781,32.67,0.43,34.1,69334,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2253',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144782,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144782,33.18,NULL,43.3,69334,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2253',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144783,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144783,33.19,NULL,43.5,69334,NULL,NULL,'Dipole + Quadrupole','FGC 2253',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144784,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144784,33.22,NULL,44,69334,NULL,NULL,'Dipole','FGC 2253',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144785,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144785,33.27,NULL,45,69334,NULL,NULL,NULL,'FGC 2253',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144786,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144786,33.41,0.69,48.1,69335,100,NULL,'mid-IR','IC 1302',NULL,'2013ApJ...771...88L',2013,1,0.9,NULL,'G',0.000027,NULL,'14.1',0.5,'SAB(s)c?','in a pair',NULL,NULL,NULL,1,292.720375,35.78525,NULL,NULL,54873506049,857398532,13396852,14.1),(144787,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144787,34.03,0.46,64.1,69335,NULL,NULL,'J','IC 1302',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144788,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144788,34.03,0.47,64.1,69335,NULL,NULL,'H','IC 1302',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144789,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144789,34.05,0.4,64.7,69335,NULL,NULL,'mean','IC 1302',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144790,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144790,34.13,0.45,66.9,69335,NULL,NULL,'K','IC 1302',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144791,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144791,32.39,0.8,30.1,69336,75,NULL,'MAT, I','ESO 010- G 004',NULL,'1997ApJS..109..333W',1997,1,2.4,NULL,'G',0.000022,NULL,'13.97',1.2,'SB(rs)d',NULL,NULL,NULL,NULL,1,292.758917,-86.01564,0.441,NULL,48329248320,755144505,11799132,13.97),(144792,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144792,32.09,0.32,26.2,69336,85,NULL,'I, raw','ESO 010- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144793,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144793,32.09,0.32,26.2,69336,85,NULL,'I, inv','ESO 010- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144794,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144794,32.4,0.43,30.2,69336,75,NULL,'MAT, I, raw','ESO 010- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144795,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144795,32.46,0.43,31,69336,75,NULL,'MAT, I, inv','ESO 010- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144796,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144796,32.57,0.39,32.7,69336,73,NULL,'opt','ESO 010- G 004',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144797,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144797,32.64,0.43,33.7,69336,75,NULL,'MAT, I, cor','ESO 010- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144798,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144798,32.69,0.46,34.5,69336,NULL,NULL,'Malmquist cor.','ESO 010- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144799,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144799,32.78,0.45,36,69336,NULL,NULL,NULL,'ESO 010- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144800,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144800,32.82,0.2,36.6,69336,74.4,NULL,NULL,'ESO 010- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144801,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144801,33.15,0.45,42.7,69337,NULL,NULL,'K','UGC 11453',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.00002,NULL,'12.9B',1,'Sb','Pair member (points to parent)',NULL,NULL,NULL,1,292.783583,54.10217,0.669,NULL,52985277068,827894954,12935858,12.9),(144802,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144802,33.17,0.47,43,69337,NULL,NULL,'H','UGC 11453',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144803,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144803,33.21,0.46,43.9,69337,NULL,NULL,'J','UGC 11453',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144804,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144804,33.43,0.4,48.6,69337,NULL,NULL,'mean','UGC 11453',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144805,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144805,35.67,0.46,136,69338,NULL,NULL,'Malmquist cor.','ESO 398- G 005',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'13.98',0.2,'S',NULL,NULL,NULL,NULL,1,292.790333,-33.31528,0.353,NULL,51196960163,799952502,12499257,13.98),(144806,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144806,35.89,0.42,151,69338,NULL,NULL,NULL,'ESO 398- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144807,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144807,35.93,0.2,153,69338,74.4,NULL,NULL,'ESO 398- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144808,'SGRB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144808,35,0.48,100,69339,NULL,NULL,NULL,'GRB 020603',NULL,'2006ApJ...640..849N',2006,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'IPN',NULL,NULL,NULL,NULL,1,292.816667,4.91667,NULL,NULL,54634319008,853661234,13338456,NULL),(144809,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144809,35.64,NULL,135,69340,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11451',NULL,'2010Ap&SS.325..163P',2010,1,1.43,'Double star superposed near nucleus.','G',NULL,NULL,'16.5',0.17,'Sc',NULL,NULL,NULL,NULL,1,292.8177083,42.19886,0.545,NULL,55028658329,859822786,13434731,16.5),(144810,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144810,35.66,NULL,135,69340,NULL,NULL,'Dipole + Quadrupole','UGC 11451',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144811,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144811,35.67,NULL,136,69340,NULL,NULL,'Dipole','UGC 11451',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144812,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144812,35.69,NULL,137,69340,NULL,NULL,NULL,'UGC 11451',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144813,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144813,35.85,0.49,148,69340,75,NULL,'IR','UGC 11451',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144814,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144814,35.24,0.63,112,69341,70,NULL,NULL,'2MASX J19311943-0601360',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'15.3R',0.2,'S',NULL,NULL,NULL,NULL,1,292.831,-6.02678,1.273,NULL,48171655963,752682124,11760658,15.3),(144815,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144815,33.31,0.69,46,69342,100,NULL,'mid-IR','IC 1303',NULL,'2013ApJ...771...88L',2013,1,1.3,NULL,'G',0.000057,NULL,'15.0',0.8,'SAc:','in a pair',NULL,NULL,NULL,1,292.87525,35.87661,NULL,NULL,54873338091,857395907,13396811,15),(144816,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144816,33.82,0.47,58.1,69342,NULL,NULL,'H','IC 1303',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144817,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144817,33.85,0.45,58.9,69342,NULL,NULL,'K','IC 1303',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144818,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144818,33.87,0.46,59.4,69342,NULL,NULL,'J','IC 1303',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144819,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144819,33.96,0.4,62.1,69342,NULL,NULL,'mean','IC 1303',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144820,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144820,32.91,0.8,38.2,69343,75,NULL,'MAT, I','ESO 184- G 077',NULL,'1997ApJS..109..333W',1997,1,2.02,NULL,'G',0.00003,NULL,'15.46',0.21,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,292.904375,-53.55189,0.137,NULL,49009476509,765773070,11965204,15.46),(144821,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144821,33.03,0.32,40.3,69343,85,NULL,'I, inv','ESO 184- G 077',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144822,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144822,33.04,0.32,40.5,69343,85,NULL,'I, raw','ESO 184- G 077',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144823,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144823,33.27,0.43,45.1,69343,75,NULL,'MAT, I, raw','ESO 184- G 077',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144824,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144824,33.29,0.43,45.6,69343,75,NULL,'MAT, I, inv','ESO 184- G 077',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144825,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144825,33.44,NULL,48.8,69343,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 184- G 077',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144826,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144826,33.46,NULL,49.1,69343,NULL,NULL,'Dipole + Quadrupole','ESO 184- G 077',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144827,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144827,33.46,NULL,49.2,69343,NULL,NULL,'Dipole','ESO 184- G 077',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144828,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144828,33.52,NULL,50.6,69343,NULL,NULL,NULL,'ESO 184- G 077',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144829,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144829,33.6,0.43,52.4,69343,75,NULL,'MAT, I, cor','ESO 184- G 077',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144830,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144830,34.06,0.8,64.8,69344,75,NULL,'MAT, I','IC 4862',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.54',0.4,'SAB:(rs)bc','Pair member (points to parent)',NULL,NULL,NULL,1,292.918125,-67.32289,0.321,NULL,49247439836,769491247,12023300,14.54),(144831,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144831,34.1,0.32,66,69344,85,NULL,'I, raw','IC 4862',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144832,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144832,34.14,0.43,67.1,69344,75,NULL,'MAT, I, raw','IC 4862',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144833,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144833,34.14,0.32,67.4,69344,85,NULL,'I, inv','IC 4862',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144834,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144834,34.2,0.43,69.2,69344,75,NULL,'MAT, I, cor','IC 4862',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144835,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144835,34.25,0.09,70.9,69344,NULL,NULL,NULL,'IC 4862',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144836,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144836,34.34,0.43,73.9,69344,75,NULL,'MAT, I, inv','IC 4862',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144837,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144837,36.18,0.85,172,69345,70,NULL,NULL,'2MASX J19315896-2721290',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,292.995625,-27.35808,0.489,NULL,47590611544,743603305,11618801,15.4),(144838,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144838,36.64,0.55,213,69346,70,NULL,NULL,'2MASX J19320744-1113063',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.6R',0.2,NULL,NULL,NULL,NULL,NULL,1,293.0310417,-11.21836,1.061,NULL,48154705519,752417273,11756519,15.6),(144839,'D-Sigma','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144839,32.95,0.4,38.8,69347,75,NULL,'Edat, raw','NGC 6799',NULL,'1997ApJS..109..333W',1997,1,1.6,'ESO-LV gives v = 5590 +/- 40 km/sec.','G',0.00002,NULL,'13.39',1.2,'SA0-:',NULL,NULL,NULL,NULL,1,293.068875,-55.90792,0.137,NULL,49012906991,765826671,11966041,13.39),(144840,'D-Sigma','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144840,33.2,0.4,43.6,69347,75,NULL,'Edat, cor','NGC 6799',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144841,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144841,33.6,0.51,52.5,69347,70,NULL,NULL,'NGC 6799',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144842,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144842,33.41,0.45,48.1,69347,NULL,NULL,'K','NGC 6799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144843,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144843,33.94,0.4,61.4,69347,NULL,NULL,'mean','NGC 6799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144844,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144844,35.81,0.41,145,69348,NULL,NULL,'Malmquist cor.','ESO 460- G 011',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'15.16',0.9,'Sb',NULL,NULL,NULL,NULL,1,293.092083,-30.27397,0.449,NULL,51141424031,799084750,12485699,15.16),(144845,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144845,36.05,0.36,162,69348,NULL,NULL,NULL,'ESO 460- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144846,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144846,36.09,0.2,165,69348,74.4,NULL,NULL,'ESO 460- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144847,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144847,35.6,0.58,132,69349,70,NULL,NULL,'2MASX J19322277-6232561',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,293.0947917,-62.54883,0.277,NULL,48942869248,764732332,11948942,16.3),(144848,'D-Sigma','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144848,33.81,0.4,57.8,69350,75,NULL,'Edat, raw','ESO 105- G 004',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00005,NULL,'12.73',1.1,'E+',NULL,NULL,NULL,NULL,1,293.103583,-64.41339,0.249,NULL,49225579132,769149673,12017963,12.73),(144849,'D-Sigma','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144849,33.85,0.4,58.8,69350,75,NULL,'Edat, cor','ESO 105- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144850,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144850,34.15,0.49,67.6,69350,70,NULL,NULL,'ESO 105- G 004',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144851,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144851,33.63,0.4,53.1,69350,NULL,NULL,'mean','ESO 105- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144852,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144852,34.23,0.45,70.2,69350,NULL,NULL,'K','ESO 105- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144853,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144853,36.7,0.52,219,69351,70,NULL,NULL,'2MASX J19322507-5111235',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,293.1045,-51.18994,0.141,NULL,51106974832,798546481,12477288,14.7),(144854,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144854,34.9,0.42,95.5,69352,NULL,NULL,'Malmquist cor.','ESO 460- G 012',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.84',0.5,'S...',NULL,NULL,NULL,NULL,1,293.114583,-29.93956,0.469,NULL,51144854858,799138357,12486536,15.84),(144855,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144855,35.05,0.39,102,69352,NULL,NULL,NULL,'ESO 460- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144856,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144856,35.09,0.2,104,69352,74.4,NULL,NULL,'ESO 460- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144857,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144857,36.84,0.56,233,69353,70,NULL,NULL,'2MASX J19323184-5156426',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,293.1327083,-51.94511,0.157,NULL,51107274188,798551159,12477361,14.6),(144858,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144858,36.42,0.7,192,69354,70,NULL,NULL,'2MASX J19324463-6111261',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.6b',0.4,NULL,NULL,NULL,NULL,NULL,1,293.186083,-61.19061,0.249,NULL,49059758543,766558727,11977480,16.6),(144859,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144859,36.47,0.58,197,69355,70,NULL,NULL,'2MASX J19324565-1148207',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.2R',0.3,NULL,NULL,NULL,NULL,NULL,1,293.19025,-11.80572,0.889,NULL,48151175540,752362117,11755658,15.2),(144860,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144860,36.1,0.77,166,69356,70,NULL,NULL,'2MASX J19331878-1530509',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,293.32825,-15.51414,0.713,NULL,48082668107,751291689,11738932,17),(144861,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144861,34.52,0.27,80.1,69357,NULL,NULL,NULL,'ESO 398- G 008',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'13.27',0.5,'SAB(r)bc',NULL,NULL,NULL,NULL,1,293.329,-33.14917,0.357,NULL,51201510970,800023608,12500368,13.27),(144862,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144862,34.56,0.2,81.7,69357,74.4,NULL,NULL,'ESO 398- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144863,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144863,34.63,0.26,84.2,69357,NULL,NULL,'Malmquist cor.','ESO 398- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144864,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144864,35.5,0.52,126,69358,70,NULL,NULL,'2MASX J19332236-5943103',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,293.34325,-59.71953,0.213,NULL,49063767551,766621367,11978458,16.1),(144865,'BL Lac Luminosity','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144865,39.44,NULL,772,69359,NULL,NULL,'Min. z = 0.2','1FGL J1933.3+0723',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,293.346,7.4,NULL,NULL,54652288924,853942014,13342843,NULL),(144866,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144866,33.99,0.4,62.8,69360,NULL,NULL,NULL,'ESO 398- G 010',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'13.35',0.4,'Sb:',NULL,NULL,NULL,NULL,1,293.561417,-34.13792,0.381,NULL,51189517885,799836216,12497440,13.35),(144867,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144867,34.03,0.2,64,69360,74.4,NULL,NULL,'ESO 398- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144868,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144868,34.46,0.32,77.8,69360,NULL,NULL,'Malmquist cor.','ESO 398- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144869,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144869,36.09,0.67,165,69361,70,NULL,NULL,'2MASX J19341785-7536475',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,293.5742917,-75.61314,0.281,NULL,48504524389,757883193,11841924,16.6),(144870,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144870,34.79,0.58,90.6,69362,70,NULL,NULL,'2MASX J19342626-1748335',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,293.6095,-17.80928,0.377,NULL,48077711414,751214240,11737722,16.1),(144871,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144871,35.89,0.65,151,69363,70,NULL,NULL,'2MASX J19342750-7437435',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,293.614667,-74.62881,0.241,NULL,48498758652,757793103,11840517,16.6),(144872,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144872,33.89,0.55,60,69364,NULL,NULL,NULL,'IC 4873',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.13',0.8,'Sb',NULL,NULL,NULL,NULL,1,293.727875,-46.13583,0.205,NULL,51243711434,800682991,12510671,15.13),(144873,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144873,33.93,0.2,61.1,69364,74.4,NULL,NULL,'IC 4873',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144874,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144874,34.32,0.45,73,69364,NULL,NULL,'Malmquist cor.','IC 4873',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144875,'D-Sigma','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144875,33.81,0.4,57.8,69365,75,NULL,'Edat, raw','ESO 105- G 007',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',NULL,NULL,'14.43',0.8,'(R\')SB(s)0/a',NULL,NULL,NULL,NULL,1,293.7292917,-64.74067,0.301,NULL,49226323940,769161311,12018145,14.43),(144876,'D-Sigma','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144876,33.85,0.4,58.8,69365,75,NULL,'Edat, cor','ESO 105- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144877,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144877,33.83,0.4,58.2,69365,NULL,NULL,'mean','ESO 105- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144878,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144878,34.69,0.45,86.8,69365,NULL,NULL,'K','ESO 105- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144879,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144879,35.43,0.6,122,69366,70,NULL,NULL,'2MASX J19350269-6048563',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'16.2b',0.4,NULL,NULL,NULL,NULL,NULL,1,293.76125,-60.81569,0.241,NULL,49058075059,766532422,11977069,16.2),(144880,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144880,35.81,0.43,145,69367,NULL,NULL,NULL,'ESO 184- G 083',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.33',0.2,'S...',NULL,NULL,NULL,NULL,1,293.843,-57.03478,0.137,NULL,49011398983,765803109,11965673,16.33),(144881,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144881,35.83,0.43,147,69367,NULL,NULL,'Malmquist cor.','ESO 184- G 083',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144882,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144882,35.85,0.2,148,69367,74.4,NULL,NULL,'ESO 184- G 083',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144883,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144883,36.63,0.75,212,69368,70,NULL,NULL,'2MASX J19353304-1114182',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.7R',0.2,NULL,NULL,NULL,NULL,NULL,1,293.887583333,-11.2385,1.145,NULL,48150955781,752358684,11755604,15.7),(144884,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144884,31.74,0.8,22.3,69369,75,NULL,'MAT, I','IC 4871',NULL,'1997ApJS..109..333W',1997,1,4.14,'6dF DR2 has z = 0.149518.','G',0.000002,NULL,'14.00',0.25,'SAB(s)d? sp',NULL,NULL,NULL,NULL,1,293.925958333,-57.51922,0.237,NULL,49040040124,766250626,11972666,14),(144885,'Tully est','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144885,31.93,0.8,24.3,69369,75,NULL,NULL,'IC 4871',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144886,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144886,31.77,0.37,22.6,69369,NULL,NULL,NULL,'IC 4871',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144887,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144887,31.88,0.4,23.8,69369,75,NULL,NULL,'IC 4871',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144888,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144888,31.88,0.4,23.8,69369,73,NULL,'IR','IC 4871',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144889,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144889,32.05,0.2,25.7,69369,74.4,NULL,NULL,'IC 4871',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144890,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144890,32.15,0.32,26.9,69369,85,NULL,'I, raw','IC 4871',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144891,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144891,32.16,0.32,27,69369,85,NULL,'I, inv','IC 4871',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144892,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144892,32.23,0.43,27.9,69369,75,NULL,'MAT, I, raw','IC 4871',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144893,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144893,32.24,0.43,28.1,69369,75,NULL,'3.6 micron, color corrected','IC 4871',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144894,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144894,32.3,0.49,28.9,69369,75,NULL,'IR','IC 4871',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144895,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144895,32.31,0.43,29,69369,75,NULL,'MAT, I, inv','IC 4871',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144896,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144896,32.36,0.43,29.7,69369,75,NULL,'3.6 micron, color + selection bias corrected','IC 4871',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144897,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144897,32.44,0.4,30.7,69369,NULL,NULL,'mean','IC 4871',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144898,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144898,32.54,NULL,32.3,69369,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 4871',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144899,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144899,32.55,NULL,32.3,69369,NULL,NULL,'Dipole + Quadrupole','IC 4871',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144900,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144900,32.56,NULL,32.4,69369,NULL,NULL,'Dipole','IC 4871',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144901,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144901,32.65,0.43,33.9,69369,75,NULL,'MAT, I, cor','IC 4871',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144902,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144902,32.66,NULL,34.1,69369,NULL,NULL,NULL,'IC 4871',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144903,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144903,32.87,0.47,37.6,69369,NULL,NULL,'H','IC 4871',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144904,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144904,32.92,0.46,38.3,69369,NULL,NULL,'J','IC 4871',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144905,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144905,33.03,0.45,40.4,69369,NULL,NULL,'K','IC 4871',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144906,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144906,33.89,0.47,59.9,69370,70,NULL,NULL,'ESO 142- G 023',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000133,NULL,'13.99',1,'SA(r)0^0',NULL,NULL,NULL,NULL,1,293.9274583,-59.78967,0.221,NULL,49063067739,766610433,11978288,13.99),(144907,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144907,34.56,NULL,81.6,69371,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 283-IG 010',NULL,'2010Ap&SS.325..163P',2010,1,2.06,NULL,'G',0.000033,NULL,'16.3b',0.22,'Scd',NULL,NULL,NULL,NULL,1,293.931833,-43.97147,0.321,NULL,51261448311,800960129,12515002,16.3),(144908,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144908,34.57,NULL,82,69371,NULL,NULL,'Dipole','ESO 283-IG 010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144909,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144909,34.57,NULL,82,69371,NULL,NULL,'Dipole + Quadrupole','ESO 283-IG 010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144910,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144910,35.04,0.43,102,69372,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2260',NULL,'2014MNRAS.444..527S',2014,1,1,NULL,'G',NULL,NULL,'16.6',0.09,'Scd',NULL,NULL,NULL,NULL,1,293.98,64.07194,0.333,NULL,53572234149,837066158,13079158,16.6),(144911,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144911,35.36,NULL,118,69372,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2260',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144912,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144912,35.37,NULL,119,69372,NULL,NULL,'Dipole + Quadrupole','FGC 2260',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144913,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144913,35.39,NULL,120,69372,NULL,NULL,'Dipole','FGC 2260',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144914,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144914,35.41,NULL,121,69372,NULL,NULL,NULL,'FGC 2260',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144915,'Tully est','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144915,31.77,0.8,22.6,69373,75,NULL,NULL,'IC 4869',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000017,NULL,'16.8b',1.5,'SA(s)dm pec',NULL,NULL,NULL,NULL,1,294.0097083,-61.02786,0.245,NULL,49058447646,766538244,11977160,16.8),(144916,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144916,34.4,0.48,75.9,69374,70,NULL,NULL,'ESO 398- G 012',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.00015,NULL,'15',1.8,'Sa',NULL,NULL,NULL,NULL,1,294.050458333,-33.99492,0.381,NULL,51201355533,800021180,12500330,15),(144917,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144917,33.55,0.68,51.2,69375,NULL,NULL,NULL,'ESO 232- G 011',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.81',0.3,'SB?...',NULL,NULL,NULL,NULL,1,294.069417,-48.52764,0.209,NULL,51244134232,800689597,12510774,15.81),(144918,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144918,33.59,0.2,52.2,69375,74.4,NULL,NULL,'ESO 232- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144919,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144919,34.1,0.52,66.1,69375,NULL,NULL,'Malmquist cor.','ESO 232- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144920,'GRB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144920,42.44,0.11,2000,69376,NULL,NULL,NULL,'GRB 090618',0.54,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,293.9940417,78.35675,0.289,NULL,52856392175,825881127,12904392,NULL),(144921,'GRB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144921,42.33,0.19,2920,69376,NULL,NULL,NULL,'GRB 090618',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144922,'GRB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144922,42.43,0.04,3060,69376,NULL,NULL,NULL,'GRB 090618',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144923,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144923,37.61,0.6,333,69377,70,NULL,NULL,'2MASX J19363769-1506552',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,294.157,-15.11539,0.637,NULL,48081273345,751269896,11738592,17),(144924,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144924,34.44,0.49,77.2,69378,75,NULL,'IR','FGC 2261',NULL,'2011yCatp016004901K',2011,1,0.99,NULL,'G',NULL,NULL,'16.4',0.12,'Scd',NULL,NULL,NULL,NULL,1,294.176291667,77.10178,0.309,NULL,52722626109,823791032,12871734,16.4),(144925,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144925,35.05,NULL,102,69378,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2261',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144926,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144926,35.07,NULL,103,69378,NULL,NULL,'Dipole + Quadrupole','FGC 2261',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144927,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144927,35.08,NULL,104,69378,NULL,NULL,'Dipole','FGC 2261',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144928,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144928,35.11,NULL,105,69378,NULL,NULL,NULL,'FGC 2261',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144929,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144929,36.44,0.57,194,69379,70,NULL,NULL,'2MASX J19365323-5330315',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,294.221791667,-53.50869,0.165,NULL,49008952021,765764875,11965076,14.8),(144930,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144930,36.9,0.56,240,69380,70,NULL,NULL,'2MASX J19365486-5318085',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,294.228625,-53.30244,0.105,NULL,49009390959,765771733,11965183,14.5),(144931,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144931,35.76,0.5,142,69381,70,NULL,NULL,'FAIRALL 0516',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,294.2875417,-63.52042,0.249,NULL,48939702644,764682853,11948169,15.9),(144932,'SNII optical','2016-12-15 15:15:49','2016-12-16 11:21:04','1','SN 2001do',NULL,144932,32.35,0.15,28.9,69382,NULL,NULL,'SEAM','UGC 11459',0.010421,'2009ApJ...694.1067P',2009,1,2.2,'abs(b) < 10 degrees.','G',0.000017,NULL,'12.8B',1.3,'Sd','in a pair',NULL,NULL,NULL,1,294.3439583,40.7055,NULL,NULL,55018400013,859662500,13432226,12.8),(144933,'Sosies','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144933,33.45,0.16,49,69382,NULL,NULL,NULL,'UGC 11459',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144934,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144934,32.61,0.69,33.3,69382,100,NULL,'mid-IR','UGC 11459',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144935,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144935,33.38,0.2,47.4,69382,74.4,NULL,NULL,'UGC 11459',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144936,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144936,33.42,0.43,48.3,69382,75,NULL,'3.6 micron, color corrected','UGC 11459',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144937,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144937,33.49,0.43,49.8,69382,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11459',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144938,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144938,33.54,0.4,51.1,69382,NULL,NULL,'mean','UGC 11459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144939,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144939,33.9,0.47,60.4,69382,NULL,NULL,'H','UGC 11459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144940,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144940,33.93,0.46,61.2,69382,NULL,NULL,'J','UGC 11459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144941,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144941,33.97,0.45,62.1,69382,NULL,NULL,'K','UGC 11459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144942,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144942,35.97,0.51,156,69383,70,NULL,NULL,'2MASX J19372417-1745017',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,294.35075,-17.75053,0.377,NULL,48075858484,751185288,11737270,16.5),(144943,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144943,34.43,0.8,76.7,69384,75,NULL,'MAT, I','ESO 594- G 008',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000013,NULL,'15.4b',0.4,'Sd? sp',NULL,NULL,NULL,NULL,1,294.36525,-17.45514,0.429,NULL,48078596467,751228069,11737938,15.4),(144944,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144944,34.38,0.32,75.1,69384,85,NULL,'I, raw','ESO 594- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144945,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144945,34.39,0.43,75.7,69384,75,NULL,'MAT, I, raw','ESO 594- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144946,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144946,34.41,0.32,76.3,69384,85,NULL,'I, inv','ESO 594- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144947,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144947,34.51,0.49,80,69384,75,NULL,'IR','ESO 594- G 008',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144948,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144948,34.57,0.43,81.9,69384,75,NULL,'MAT, I, inv','ESO 594- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144949,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144949,34.68,0.49,86.2,69384,NULL,NULL,'Malmquist cor.','ESO 594- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144950,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144950,34.73,0.48,88.2,69384,NULL,NULL,NULL,'ESO 594- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144951,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144951,34.77,0.2,90,69384,74.4,NULL,NULL,'ESO 594- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144952,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144952,34.78,0.43,90.2,69384,75,NULL,'MAT, I, cor','ESO 594- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144953,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144953,29.65,0.1,8.5,69385,74.4,NULL,NULL,'IC 4870',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.000003,NULL,'13.89',0.9,'IBM? pec;HII   Sy2',NULL,NULL,NULL,'H II',1,294.406667,-65.81183,0.337,NULL,49241022973,769390983,12021734,13.89),(144954,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144954,29.32,NULL,7.31,69385,NULL,NULL,NULL,'IC 4870',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144955,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144955,34.34,0.8,73.6,69386,75,NULL,'MAT, I','IC 4876',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.31',0.9,'SAB(rs)c',NULL,NULL,NULL,NULL,1,294.428208333,-52.84275,0.073,NULL,51105039608,798516243,12476816,14.31),(144956,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144956,34.2,0.43,69.3,69386,75,NULL,'MAT, I, raw','IC 4876',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144957,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144957,34.32,0.43,73,69386,75,NULL,'MAT, I, cor','IC 4876',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144958,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144958,34.33,0.32,73.4,69386,85,NULL,'I, raw','IC 4876',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144959,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144959,34.38,0.32,75.2,69386,85,NULL,'I, inv','IC 4876',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144960,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144960,34.41,0.43,76.3,69386,75,NULL,'MAT, I, inv','IC 4876',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144961,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144961,34.46,0.4,78,69386,NULL,NULL,'mean','IC 4876',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144962,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144962,34.9,0.47,95.3,69386,NULL,NULL,'H','IC 4876',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144963,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144963,35.85,0.61,148,69387,70,NULL,NULL,'ESO 185- G 005',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.60',0.6,'SB(s)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,294.5649583,-52.82108,0.073,NULL,51105315647,798520556,12476883,15.6),(144964,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144964,36.38,0.52,189,69388,70,NULL,NULL,'2MASX J19382179-5039151',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,294.5907083,-50.65414,0.133,NULL,51106265323,798535395,12477115,14.5),(144965,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144965,36.23,0.51,176,69389,70,NULL,NULL,'FAIRALL 0062',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000117,NULL,'15.6b',NULL,'Bright nucleus',NULL,NULL,NULL,NULL,1,294.640333,-60.70492,0.249,NULL,49057839028,766528734,11977011,15.6),(144966,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144966,36.26,0.65,179,69390,70,NULL,NULL,'2MASX J19383915-0915090',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,294.663167,-9.25247,0.833,NULL,47868400596,747943759,11686621,17),(144967,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144967,36.1,0.5,166,69391,70,NULL,NULL,'2MASX J19384291-0535151',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00009,NULL,'15.1R',0.2,NULL,NULL,NULL,NULL,NULL,1,294.6787917,-5.58758,0.709,NULL,47907718916,748558108,11696220,15.1),(144968,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144968,34.9,0.45,95.3,69392,NULL,NULL,'Malmquist cor.','ESO 398- G 017',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.11',0.2,'S...',NULL,NULL,NULL,NULL,1,294.7784583,-33.04769,0.469,NULL,51203818263,800059660,12500932,14.11),(144969,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144969,35.16,0.4,108,69392,NULL,NULL,NULL,'ESO 398- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144970,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144970,35.2,0.2,110,69392,74.4,NULL,NULL,'ESO 398- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144971,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144971,36.91,0.6,241,69393,70,NULL,NULL,'2MASX J19390708-1553156',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,294.7795,-15.88764,0.441,NULL,48077042088,751203782,11737559,17.3),(144972,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144972,32.83,0.49,36.9,69394,75,NULL,'IR','UGC 11461',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000013,NULL,'15.40',0.2,'Scd:',NULL,NULL,NULL,NULL,1,294.787083,8.81033,NULL,NULL,54138886526,845920101,13217501,15.4),(144973,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144973,33.17,0.47,43.1,69394,NULL,NULL,'H','UGC 11461',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144974,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144974,33.21,0.4,43.9,69394,NULL,NULL,'mean','UGC 11461',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144975,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144975,33.27,0.45,45.2,69394,NULL,NULL,'K','UGC 11461',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144976,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144976,33.35,0.46,46.9,69394,NULL,NULL,'J','UGC 11461',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144977,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144977,34.6,0.3,83.3,69395,NULL,NULL,'Malmquist cor.','ESO 338- G 018',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000033,NULL,'16.01',0.9,'(R\')SAB(r)b:',NULL,NULL,NULL,NULL,1,294.790166667,-37.87572,0.517,NULL,51179131436,799673928,12494905,16.01),(144978,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144978,34.65,0.29,85.1,69395,NULL,NULL,NULL,'ESO 338- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144979,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144979,34.69,0.2,86.7,69395,74.4,NULL,NULL,'ESO 338- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144980,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144980,36.21,0.54,175,69396,70,NULL,NULL,'2MASX J19391760-1714226',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,294.823333,-17.23958,0.417,NULL,48075468843,751179200,11737175,15.8),(144981,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144981,34.02,0.47,63.7,69397,NULL,NULL,'H','CGCG 397-003',NULL,'2007A&A...465...71T',2007,1,0.56,NULL,'G',0.000067,NULL,'15.7',0.45,'Spiral',NULL,NULL,NULL,NULL,1,294.871625,6.34847,NULL,NULL,54131195671,845799932,13215623,15.7),(144982,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144982,34.2,0.46,69.2,69397,NULL,NULL,'J','CGCG 397-003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144983,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144983,34.25,0.45,70.7,69397,NULL,NULL,'K','CGCG 397-003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144984,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144984,34.38,0.4,75,69397,NULL,NULL,'mean','CGCG 397-003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144985,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144985,35.96,0.6,155,69398,70,NULL,NULL,'2MASX J19394121-6018571',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,294.921833,-60.31594,0.245,NULL,49057643398,766525678,11976963,15.3),(144986,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144986,34.31,0.61,72.9,69399,70,NULL,NULL,'CGCG 371-003',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.7',0.3,NULL,NULL,NULL,NULL,NULL,1,294.929875,-0.501,1.093,NULL,47862356404,747849318,11685145,15.7),(144987,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144987,35.12,0.58,106,69400,NULL,NULL,'Malmquist cor.','ESO 460- G 020',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'16.21',0.5,'Sb:',NULL,NULL,NULL,NULL,1,294.963208333,-27.887,0.561,NULL,51152659191,799260299,12488442,16.21),(144988,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144988,35.35,0.52,117,69400,NULL,NULL,NULL,'ESO 460- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144989,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144989,35.39,0.2,120,69400,74.4,NULL,NULL,'ESO 460- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144990,'GRB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'RN',144990,38.49,NULL,500,69401,NULL,NULL,NULL,'GRB 791101',NULL,'1992grbo.book..107S',1992,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144991,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144991,36.28,0.67,180,69402,70,NULL,NULL,'2MASX J19395331-5332075',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,294.972167,-53.53544,0.205,NULL,49008492437,765757694,11964963,15.3),(144992,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144992,36.98,0.51,249,69403,70,NULL,NULL,'2MASX J19395823-5103235',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,294.99275,-51.0565,0.133,NULL,51117307787,798707934,12479811,14.5),(144993,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144993,36.57,0.57,206,69404,70,NULL,NULL,'2MASX J19395988-2238096',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,294.999583,-22.63606,0.517,NULL,48053125896,750830092,11731720,14.2),(144994,'D-Sigma','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144994,35.33,0.4,116,69405,75,NULL,'Edat, raw','IC 4864',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',NULL,NULL,'14.8',0.4,'SAB(rs)a',NULL,NULL,NULL,NULL,1,295.0257083,-77.55817,0.417,NULL,48545000611,758515634,11851806,14.8),(144995,'D-Sigma','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144995,35.66,0.4,136,69405,75,NULL,'Edat, cor','IC 4864',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144996,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144996,36.24,0.5,177,69406,70,NULL,NULL,'2MASX J19401737-1903592',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.2I',0.5,NULL,NULL,NULL,NULL,NULL,1,295.072333,-19.06644,0.509,NULL,48055184581,750862259,11732222,13.2),(144997,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144997,34.15,0.48,67.5,69407,70,NULL,NULL,'IC 4880',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.00015,NULL,'14.27',0.4,'(R\'_1)SAB(l)a:',NULL,NULL,NULL,NULL,1,295.1287917,-56.41017,0.137,NULL,49014357146,765849330,11966395,14.27),(144998,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144998,33.56,0.8,51.5,69408,75,NULL,'MAT, I','ESO 142- G 030',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'14.57',0.4,'Sc',NULL,NULL,NULL,NULL,1,295.161875,-60.04817,0.245,NULL,49032526650,766133228,11970831,14.57),(144999,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144999,33.68,0.32,54.5,69408,85,NULL,'I, raw','ESO 142- G 030',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145000,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145000,33.73,0.32,55.7,69408,85,NULL,'I, inv','ESO 142- G 030',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145001,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145001,33.8,0.43,57.6,69408,75,NULL,'MAT, I, raw','ESO 142- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145002,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145002,33.87,0.49,59.3,69408,75,NULL,'IR','ESO 142- G 030',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145003,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145003,33.89,0.09,60.1,69408,NULL,NULL,NULL,'ESO 142- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145004,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145004,33.9,0.43,60.2,69408,75,NULL,'MAT, I, cor','ESO 142- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145005,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145005,34.03,0.43,64,69408,75,NULL,'MAT, I, inv','ESO 142- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145006,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145006,36.06,0.56,163,69409,70,NULL,NULL,'2MASX J19404092-1859372',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,295.1704583,-18.99364,0.509,NULL,48055134866,750861482,11732210,14.6),(145007,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145007,35.51,0.57,126,69410,70,NULL,NULL,'2MASX J19404231-7025467',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,295.17625,-70.42964,0.313,NULL,49250778432,769543413,12024115,16),(145008,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145008,36,0.49,158,69411,70,NULL,NULL,'2MASX J19404710-5057433',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,295.1962083,-50.96197,0.133,NULL,51117351706,798708620,12479822,15),(145009,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145009,37.85,0.77,372,69412,70,NULL,NULL,'2MASX J19410123-7958185',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,295.255333,-79.97178,0.545,NULL,48552550562,758633602,11853650,17.2),(145010,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145010,35,0.61,99.8,69413,70,NULL,NULL,'2MASX J19410969-0642577',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'14.6R',0.2,'nuc. dominant',NULL,NULL,NULL,NULL,1,295.290417,-6.716,0.633,NULL,47876701546,748073461,11688647,14.6),(145011,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145011,29.68,0.43,8.6,69414,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J19411657+0152227',NULL,'2014MNRAS.444..527S',2014,1,0.5,NULL,'G',0.000023,NULL,'11.3K',0.3,'with *',NULL,NULL,NULL,NULL,1,295.319,1.87294,1.325,NULL,54102886754,845357605,13208712,11.3),(145012,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145012,36.59,0.6,208,69415,70,NULL,NULL,'2MASX J19412389-6233575',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.8b',NULL,'Sa(r)',NULL,NULL,NULL,NULL,1,295.349583,-62.56594,0.241,NULL,49057444300,766522567,11976915,16.8),(145013,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145013,37.18,0.77,273,69416,70,NULL,NULL,'2MASX J19412526-1022286',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,295.355333333,-10.37461,0.597,NULL,47869286008,747957593,11686837,16),(145014,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145014,34.08,0.8,65.5,69417,75,NULL,'MAT, I','ESO 398- G 020',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'13.38',0.2,'Scd: sp        HII',NULL,NULL,NULL,NULL,1,295.379208333,-36.34053,0.445,NULL,51190967378,799858865,12497794,13.38),(145015,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145015,34.05,0.32,64.7,69417,85,NULL,'I, raw','ESO 398- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145016,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145016,34.09,0.32,65.8,69417,85,NULL,'I, inv','ESO 398- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145017,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145017,34.11,0.43,66.3,69417,75,NULL,'MAT, I, raw','ESO 398- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145018,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145018,34.15,0.49,67.7,69417,75,NULL,'IR','ESO 398- G 020',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145019,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145019,34.28,0.43,71.9,69417,75,NULL,'MAT, I, inv','ESO 398- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145020,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145020,34.33,0.2,73.5,69417,74.4,NULL,NULL,'ESO 398- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145021,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145021,34.38,0.43,75.1,69417,75,NULL,'MAT, I, cor','ESO 398- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145022,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145022,34.58,0.25,82.6,69417,NULL,NULL,'Malmquist cor.','ESO 398- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145023,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145023,34.64,0.25,84.6,69417,NULL,NULL,NULL,'ESO 398- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145024,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145024,33.68,0.8,54.4,69418,75,NULL,'MAT, I','IC 4883',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.58',0.4,'SB(s)b?',NULL,NULL,NULL,NULL,1,295.5022083,-55.54553,0.149,NULL,49011900788,765810949,11965796,14.58),(145025,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145025,33.81,0.32,57.7,69418,85,NULL,'I, raw','IC 4883',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145026,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145026,33.84,0.43,58.7,69418,75,NULL,'MAT, I, raw','IC 4883',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145027,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145027,33.86,0.32,59.1,69418,85,NULL,'I, inv','IC 4883',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145028,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145028,33.99,0.43,62.7,69418,75,NULL,'MAT, I, cor','IC 4883',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145029,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145029,34.07,0.43,65.1,69418,75,NULL,'MAT, I, inv','IC 4883',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145030,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145030,34.14,0.38,67.3,69418,NULL,NULL,'Malmquist cor.','IC 4883',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145031,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145031,34.24,0.36,70.6,69418,NULL,NULL,NULL,'IC 4883',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145032,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145032,34.28,0.2,71.8,69418,74.4,NULL,NULL,'IC 4883',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145033,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145033,35.23,0.53,111,69419,70,NULL,NULL,'2MASX J19421431-3559435',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,295.559667,-35.99547,0.429,NULL,51188901663,799826588,12497290,14.7),(145034,'SNII optical','2016-12-15 15:15:49','2016-12-16 11:21:04','1','SN 1991al',NULL,145034,33.7,0.17,55,69420,NULL,NULL,'V, photospheric magnitude method','2MASX J19422191-5506275',NULL,'2014AJ....148..107R',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'S',NULL,NULL,NULL,NULL,1,295.592,-55.10456,0.161,NULL,49019546961,765930421,11967662,NULL),(145035,'SNII optical','2016-12-15 15:15:49','2016-12-16 11:21:04','1','SN 1991al',NULL,145035,33.89,0.53,60,69420,NULL,NULL,'SCM, I','2MASX J19422191-5506275',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145036,'SNII optical','2016-12-15 15:15:49','2016-12-16 11:21:04','1','SN 1991al',NULL,145036,33.96,0.07,61.9,69420,NULL,NULL,'I, photospheric magnitude method','2MASX J19422191-5506275',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145037,'SNII optical','2016-12-15 15:15:49','2016-12-16 11:21:04','1','SN 1991al',NULL,145037,34.04,0.54,64.3,69420,NULL,NULL,'SCM, V','2MASX J19422191-5506275',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145038,'SNII optical','2016-12-15 15:15:49','2016-12-16 11:21:04','1','SN 1991al',NULL,145038,34.05,0.28,64.6,69420,NULL,NULL,'SCM, BVI','2MASX J19422191-5506275',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145039,'SNII optical','2016-12-15 15:15:49','2016-12-16 11:21:04','1','SN 1991al',NULL,145039,34.14,0.41,67.3,69420,NULL,NULL,'SCM, B','2MASX J19422191-5506275',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145040,'SNII optical','2016-12-15 15:15:49','2016-12-16 11:21:04','1','SN 1991al',NULL,145040,34.23,NULL,70,69420,NULL,NULL,NULL,'2MASX J19422191-5506275',NULL,'2003MNRAS.346...97N',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145041,'SNII optical','2016-12-15 15:15:49','2016-12-16 11:21:04','1','SN 1991al',NULL,145041,34.28,0.54,70.4,69420,NULL,NULL,'SEAM','2MASX J19422191-5506275',0.01,'2009ApJ...694.1067P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145042,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145042,34.37,0.8,74.7,69421,75,NULL,'MAT, I','MCG -03-50-003',NULL,'1997ApJS..109..333W',1997,1,2,'2MASXi position not centered on galaxy.','G',0.000031,NULL,'14',0.3,'Sc: sp',NULL,NULL,NULL,NULL,1,295.599333,-15.86411,0.425,NULL,47955927720,749311370,11707990,14),(145043,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145043,34.36,0.2,74.5,69421,74.4,NULL,NULL,'MCG -03-50-003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145044,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145044,34.41,0.43,76.2,69421,75,NULL,'3.6 micron, color corrected','MCG -03-50-003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145045,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145045,34.41,0.43,76.4,69421,75,NULL,'MAT, I, raw','MCG -03-50-003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145046,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145046,34.5,0.39,79.5,69421,NULL,NULL,'Malmquist cor.','MCG -03-50-003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145047,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145047,34.56,0.43,81.8,69421,75,NULL,'3.6 micron, color + selection bias corrected','MCG -03-50-003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145048,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145048,34.59,0.38,82.7,69421,NULL,NULL,NULL,'MCG -03-50-003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145049,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145049,34.71,0.32,87.7,69421,85,NULL,'I, raw','MCG -03-50-003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145050,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145050,34.73,0.43,88.2,69421,75,NULL,'MAT, I, inv','MCG -03-50-003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145051,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145051,34.78,0.43,90.2,69421,75,NULL,'MAT, I, cor','MCG -03-50-003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145052,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145052,34.79,0.32,90.8,69421,85,NULL,'I, inv','MCG -03-50-003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145053,'Tully est','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145053,31.94,0.8,24.4,69422,75,NULL,NULL,'ESO 142- G 032',NULL,'1988NBGC.C....0000T',1988,1,1.4,NULL,'G',0.000023,NULL,'15.31',0.7,'SB(s)m: pec','in a pair',NULL,NULL,NULL,1,295.653875,-58.80178,0.213,NULL,49035575811,766180872,11971576,15.31),(145054,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145054,31.11,0.39,16.7,69423,73,NULL,'opt','CGMW 3-4603',NULL,'2011A&A...532A.104N',2011,1,1.1,NULL,'G',0.000025,NULL,NULL,0.2,'nebula:',NULL,NULL,NULL,NULL,1,295.658416667,-7.61092,0.565,NULL,47881842075,748153782,11689902,NULL),(145055,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145055,31.79,0.4,22.8,69424,75,NULL,'B','NGC 6814',NULL,'1988NBGC.C....0000T',1988,1,3,NULL,'G',0.000007,NULL,'12.06',2.8,'SAB(rs)bc;HII  Sy1.5','Group member, radial-velocity confirmed',NULL,NULL,'Sy 1.5',1,295.669333,-10.3235,0.597,NULL,47867026066,747922282,11686285,12.06),(145056,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145056,35.1,0.6,105,69425,70,NULL,NULL,'2MASX J19424113-0656035',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4R',0.3,NULL,NULL,NULL,NULL,NULL,1,295.671375,-6.93425,0.533,NULL,47878389071,748099829,11689059,14.4),(145057,'BL Lac Luminosity','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145057,39.44,NULL,772,69426,NULL,NULL,'Min. z = 0.2','1FGL J1942.7+1033',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,295.689,10.56,NULL,NULL,54158428448,846225444,13222272,NULL),(145058,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145058,34.33,0.8,73.6,69427,75,NULL,'MAT, I','ESO 460- G 025',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.63',0.9,'SB(r)a',NULL,NULL,NULL,NULL,1,295.71925,-28.50197,0.649,NULL,51153645148,799275705,12488682,14.63),(145059,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145059,34.15,0.43,67.7,69427,75,NULL,'MAT, I, raw','ESO 460- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145060,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145060,34.25,0.47,70.7,69427,NULL,NULL,'H','ESO 460- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145061,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145061,34.28,0.32,71.7,69427,85,NULL,'I, raw','ESO 460- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145062,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145062,34.32,0.45,73.2,69427,NULL,NULL,'K','ESO 460- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145063,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145063,34.35,0.32,74.1,69427,85,NULL,'I, inv','ESO 460- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145064,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145064,34.37,0.46,74.8,69427,NULL,NULL,'J','ESO 460- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145065,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145065,34.44,0.43,77.3,69427,75,NULL,'MAT, I, inv','ESO 460- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145066,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145066,34.56,0.32,81.7,69427,NULL,NULL,NULL,'ESO 460- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145067,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145067,34.56,0.32,81.7,69427,NULL,NULL,'Malmquist cor.','ESO 460- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145068,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145068,34.58,0.43,82.3,69427,75,NULL,'MAT, I, cor','ESO 460- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145069,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145069,34.59,0.4,82.7,69427,NULL,NULL,'mean','ESO 460- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145070,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145070,34.6,0.2,83.2,69427,74.4,NULL,NULL,'ESO 460- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145071,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145071,30.45,0.43,12.3,69428,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11466',NULL,'2014MNRAS.444..527S',2014,1,2,NULL,'G',0.000007,NULL,'12.7',1.2,'S?',NULL,NULL,NULL,NULL,1,295.744833,45.29819,0.965,NULL,55021347067,859708547,13432946,12.7),(145072,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145072,30.75,0.43,14.1,69428,75,NULL,'3.6 micron, color corrected','UGC 11466',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145073,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145073,30.96,0.2,15.6,69428,74.4,NULL,NULL,'UGC 11466',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145074,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145074,31.29,0.4,18.1,69428,NULL,NULL,NULL,'UGC 11466',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145075,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145075,33.53,0.8,50.8,69429,75,NULL,'MAT, I','ESO 142- G 034',NULL,'1997ApJS..109..333W',1997,1,1.59,'Allen, et al. (1991, MNRAS, 248, 528) give z=0.016 +/- 0.001.','G',0.000033,NULL,'15.92',0.2,'Sc',NULL,NULL,NULL,NULL,1,295.7525417,-59.94617,0.241,NULL,49032576840,766134013,11970843,15.92),(145076,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145076,33.39,0.32,47.7,69429,85,NULL,'I, raw','ESO 142- G 034',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145077,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145077,33.39,0.32,47.7,69429,85,NULL,'I, inv','ESO 142- G 034',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145078,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145078,33.59,0.43,52.2,69429,75,NULL,'MAT, I, raw','ESO 142- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145079,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145079,33.65,0.43,53.6,69429,75,NULL,'MAT, I, inv','ESO 142- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145080,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145080,33.76,0.43,56.5,69429,75,NULL,'MAT, I, cor','ESO 142- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145081,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145081,33.98,0.49,62.5,69429,75,NULL,'IR','ESO 142- G 034',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145082,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145082,34.09,NULL,65.8,69429,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 142- G 034',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145083,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145083,34.1,NULL,66.2,69429,NULL,NULL,'Dipole + Quadrupole','ESO 142- G 034',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145084,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145084,34.11,NULL,66.5,69429,NULL,NULL,'Dipole','ESO 142- G 034',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145085,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145085,34.16,NULL,67.8,69429,NULL,NULL,NULL,'ESO 142- G 034',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145086,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145086,34.99,0.58,99.3,69430,70,NULL,NULL,'2MASX J19430129-5354071',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,295.7555,-53.90206,0.181,NULL,49020871604,765951118,11967986,14.9),(145087,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145087,34.77,0.47,90,69431,70,NULL,NULL,'2MASX J19430960-0704121',NULL,'2014MNRAS.445.2677S',2014,1,0.8,'1998PASJ...50...47R has z = 0.039.','G',0.00015,NULL,'14.4I',0.2,NULL,NULL,NULL,NULL,NULL,1,295.7899583,-7.07,0.533,NULL,47878928313,748108254,11689191,14.4),(145088,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145088,30.28,0.4,11.4,69432,73,NULL,'IR','MCG -01-50-001',NULL,'2011A&A...532A.104N',2011,1,1.2,'Confused HIPASS source','G',0.00001,NULL,'13.3R',0.3,'IBm? sp        HII',NULL,NULL,NULL,NULL,1,295.802333,-6.93967,0.533,NULL,47878958476,748108726,11689198,13.3),(145089,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145089,30.28,0.4,11.4,69432,75,NULL,NULL,'MCG -01-50-001',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145090,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145090,30.46,0.49,12.3,69432,75,NULL,'IR','MCG -01-50-001',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145091,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145091,34.83,0.5,92.7,69433,70,NULL,NULL,'IC 4886',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'14.15',0.7,'Sb: pec',NULL,NULL,NULL,NULL,1,295.810625,-51.8075,0.157,NULL,51118687359,798729489,12480148,14.15),(145092,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145092,34.5,0.58,79.6,69434,70,NULL,NULL,'ESO 232- G 019',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000103,NULL,'14.90',0.5,'SA(l)0^0',NULL,NULL,NULL,NULL,1,295.85225,-48.53531,0.197,NULL,51113527247,798648863,12478888,14.9),(145093,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145093,35.97,0.69,156,69435,70,NULL,NULL,'2MASX J19433061-0802060',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,295.8775,-8.03497,0.521,NULL,47882075294,748157426,11689959,15.9),(145094,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145094,34.24,0.39,70.3,69436,NULL,NULL,NULL,'ESO 460- G 028',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.76',0.4,'Sb',NULL,NULL,NULL,NULL,1,295.8865,-27.69994,0.677,NULL,51152687909,799260748,12488449,15.76),(145095,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145095,34.28,0.2,71.8,69436,74.4,NULL,NULL,'ESO 460- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145096,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145096,34.5,0.34,79.5,69436,NULL,NULL,'Malmquist cor.','ESO 460- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145097,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145097,31.85,0.8,23.4,69437,75,NULL,'MAT, I','NGC 6810',NULL,'1997ApJS..109..333W',1997,1,3.2,NULL,'G',0.000033,NULL,'12.37',0.9,'SA(s)ab:sp     Sy2','in a pair',NULL,NULL,NULL,1,295.8927083,-58.65558,0.169,NULL,49035389643,766177963,11971530,12.37),(145098,'Tully est','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145098,32.01,0.8,25.3,69437,75,NULL,'B','NGC 6810',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145099,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145099,31.56,0.45,20.5,69437,NULL,NULL,'K','NGC 6810',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145100,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145100,31.58,0.47,20.7,69437,NULL,NULL,'H','NGC 6810',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145101,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145101,31.69,0.46,21.7,69437,NULL,NULL,'J','NGC 6810',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145102,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145102,32.21,0.32,27.7,69437,85,NULL,'I, raw','NGC 6810',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145103,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145103,32.27,0.32,28.5,69437,85,NULL,'I, inv','NGC 6810',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145104,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145104,32.28,0.43,28.6,69437,75,NULL,'MAT, I, raw','NGC 6810',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145105,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145105,32.29,0.51,28.7,69437,NULL,NULL,NULL,'NGC 6810',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145106,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145106,32.3,0.4,28.8,69437,NULL,NULL,'mean','NGC 6810',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145107,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145107,32.33,0.2,29.2,69437,74.4,NULL,NULL,'NGC 6810',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145108,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145108,32.58,0.43,32.8,69437,75,NULL,'MAT, I, inv','NGC 6810',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145109,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145109,32.64,0.44,33.8,69437,NULL,NULL,'Malmquist cor.','NGC 6810',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145110,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145110,32.71,0.43,34.8,69437,75,NULL,'MAT, I, cor','NGC 6810',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145111,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145111,35.12,0.5,106,69438,70,NULL,NULL,'ESO 398- G 024',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000137,NULL,'16',1,'S...',NULL,NULL,NULL,NULL,1,295.91325,-35.2875,0.437,NULL,51189328873,799833263,12497394,16),(145112,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145112,32.86,0.69,37.3,69439,100,NULL,'mid-IR','NGC 6824',NULL,'2013ApJ...771...88L',2013,1,1.7,NULL,'G',0.0001,NULL,'13.0',1.2,'SA(s)b:',NULL,NULL,NULL,NULL,1,295.919583,56.10947,0.809,NULL,52993948261,828030441,12937975,13),(145113,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145113,33.52,0.4,50.5,69439,NULL,NULL,'mean','NGC 6824',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145114,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145114,33.64,0.45,53.4,69439,NULL,NULL,'K','NGC 6824',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145115,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145115,33.68,0.46,54.4,69439,NULL,NULL,'J','NGC 6824',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145116,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145116,33.59,0.8,52.3,69440,75,NULL,'MAT, I','IC 4885',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'14.52',0.4,'SA(s)c:',NULL,NULL,NULL,NULL,1,295.966833,-60.65175,0.241,NULL,49025329105,766020767,11969074,14.52),(145117,'Tully est','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145117,32.51,0.8,31.8,69440,75,NULL,NULL,'IC 4885',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145118,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145118,32.33,0.32,29.2,69440,85,NULL,'I, raw','IC 4885',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145119,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145119,32.35,0.32,29.5,69440,85,NULL,'I, inv','IC 4885',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145120,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145120,32.45,0.43,31,69440,75,NULL,'MAT, I, raw','IC 4885',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145121,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145121,32.59,0.43,32.9,69440,75,NULL,'MAT, I, inv','IC 4885',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145122,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145122,32.89,0.43,37.8,69440,75,NULL,'MAT, I, cor','IC 4885',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145123,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145123,33.23,0.49,44.4,69440,75,NULL,'IR','IC 4885',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145124,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145124,33.88,0.12,59.8,69440,NULL,NULL,NULL,'IC 4885',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145125,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145125,37.86,0.67,373,69441,70,NULL,NULL,'2MASX J19435290-2244594',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,'SAB(rl)0/a',NULL,NULL,NULL,NULL,1,295.970375,-22.74989,0.389,NULL,48053669802,750838590,11731852,15.3),(145126,'BL Lac Luminosity','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145126,38.74,NULL,560,69442,70,NULL,'z = 0.14','2MASS J19435624+2118233',NULL,'2011A&A...529A..49H',2011,1,NULL,'abs(b) < 3 deg.','QSO',NULL,NULL,NULL,NULL,'BLLAC',NULL,NULL,NULL,NULL,1,295.984333,21.30647,NULL,NULL,54494555930,851477436,13304334,NULL),(145127,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145127,34,0.8,63,69443,75,NULL,'MAT, I','ESO 460- G 029',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.00002,NULL,'14.23',1,'SB(rs)bc pec',NULL,NULL,NULL,NULL,1,295.9957917,-28.48689,0.649,NULL,51153567313,799274489,12488663,14.23),(145128,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145128,34.68,0.35,86.3,69443,NULL,NULL,'Malmquist cor.','ESO 460- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145129,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145129,34.89,0.32,95.1,69443,NULL,NULL,NULL,'ESO 460- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145130,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145130,34.9,0.43,95.4,69443,75,NULL,'MAT, I, raw','ESO 460- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145131,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145131,34.93,0.2,96.8,69443,74.4,NULL,NULL,'ESO 460- G 029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145132,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145132,35.08,0.32,104,69443,85,NULL,'I, raw','ESO 460- G 029',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145133,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145133,35.18,0.32,108,69443,85,NULL,'I, inv','ESO 460- G 029',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145134,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145134,35.17,0.43,108,69443,75,NULL,'MAT, I, cor','ESO 460- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145135,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145135,35.28,0.43,114,69443,75,NULL,'MAT, I, inv','ESO 460- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145136,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145136,34.27,0.8,71.5,69444,75,NULL,'MAT, I','ESO 460- G 031',NULL,'1997ApJS..109..333W',1997,1,4.05,NULL,'G',0.000013,NULL,'15.10',0.45,'Sbc            HII',NULL,NULL,NULL,NULL,1,296.089625,-27.40689,0.661,NULL,51140107128,799064173,12485377,15.1),(145137,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145137,33.95,0.43,61.5,69444,75,NULL,'MAT, I, raw','ESO 460- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145138,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145138,33.95,NULL,61.7,69444,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 460- G 031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145139,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145139,33.95,NULL,61.7,69444,NULL,NULL,'Dipole','ESO 460- G 031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145140,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145140,33.96,NULL,61.8,69444,NULL,NULL,'Dipole + Quadrupole','ESO 460- G 031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145141,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145141,34.03,NULL,63.9,69444,NULL,NULL,NULL,'ESO 460- G 031',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145142,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145142,34.2,0.32,69.2,69444,85,NULL,'I, raw','ESO 460- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145143,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145143,34.23,0.43,70,69444,75,NULL,'MAT, I, inv','ESO 460- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145144,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145144,34.23,0.49,70.3,69444,75,NULL,'IR','ESO 460- G 031',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145145,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145145,34.27,0.32,71.4,69444,85,NULL,'I, inv','ESO 460- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145146,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145146,34.29,0.47,72.1,69444,NULL,NULL,'H','ESO 460- G 031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145147,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145147,34.39,0.2,75.5,69444,74.4,NULL,NULL,'ESO 460- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145148,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145148,34.41,0.45,76.4,69444,NULL,NULL,'K','ESO 460- G 031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145149,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145149,34.42,0.46,76.7,69444,NULL,NULL,'J','ESO 460- G 031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145150,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145150,34.45,0.43,77.6,69444,75,NULL,'MAT, I, cor','ESO 460- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145151,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145151,34.47,0.31,78.2,69444,NULL,NULL,NULL,'ESO 460- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145152,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145152,34.5,0.3,79.4,69444,NULL,NULL,'Malmquist cor.','ESO 460- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145153,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145153,34.51,0.43,79.9,69444,75,NULL,'3.6 micron, color corrected','ESO 460- G 031',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145154,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145154,34.54,0.4,80.9,69444,NULL,NULL,'mean','ESO 460- G 031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145155,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145155,34.71,0.43,87.3,69444,75,NULL,'3.6 micron, color + selection bias corrected','ESO 460- G 031',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145156,'Tully est','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145156,31.76,0.8,22.5,69445,75,NULL,'B','NGC 6821',NULL,'1988NBGC.C....0000T',1988,1,1.2,'Confused HIPASS source','G',0.000017,NULL,'13.62',1,'SB(s)d:        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,296.10025,-6.83344,0.501,NULL,47878852288,748107067,11689172,13.62),(145157,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145157,30.88,0.4,15,69445,73,NULL,'opt','NGC 6821',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145158,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145158,35.36,0.76,118,69446,70,NULL,NULL,'2MASX J19443465-5234038',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,296.144458333,-52.56772,0.061,NULL,51118338953,798724046,12480063,14.6),(145159,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145159,34.55,0.4,81.2,69447,NULL,NULL,'mean','ESO 460- G 032',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000063,NULL,'14.72',0.8,'SA(rs)bc:',NULL,NULL,NULL,NULL,1,296.16225,-27.979,0.637,NULL,51152716104,799261189,12488456,14.72),(145160,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145160,34.75,0.47,89.1,69447,NULL,NULL,'H','ESO 460- G 032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145161,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145161,34.85,0.46,93.5,69447,NULL,NULL,'J','ESO 460- G 032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145162,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145162,34.87,0.45,94.1,69447,NULL,NULL,'K','ESO 460- G 032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145163,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145163,35.15,0.65,107,69448,NULL,NULL,'Malmquist cor.','ESO 398- G 028',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.35',0.4,'Sb:',NULL,NULL,NULL,NULL,1,296.229875,-32.64728,0.541,NULL,51192855496,799888367,12498255,14.35),(145164,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145164,35.54,0.55,128,69448,NULL,NULL,NULL,'ESO 398- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145165,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145165,35.58,0.2,131,69448,74.4,NULL,NULL,'ESO 398- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145166,'Brightest Stars','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145166,23.2,0.2,0.437,69449,NULL,NULL,NULL,'NGC 6822',NULL,'1980ApJ...238...65H',1980,1,15.5,'The position is the approximate center of the bar.','G',0.000007,NULL,'9.31',13.5,'IB(s)m','Group member',NULL,NULL,NULL,1,296.240583,-14.80344,0.861,0,47964467970,749444812,11710075,9.31),(145167,'Brightest Stars','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145167,23.2,0.2,0.437,69449,NULL,NULL,NULL,'NGC 6822',NULL,'1983ApJ...269..335H',1983,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145168,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145168,21.73,0.01,0.222,69449,NULL,NULL,'NGC 6822:[PGU2004] cep028, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145169,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145169,22.42,0.01,0.305,69449,NULL,NULL,'NGC 6822:[PGU2004] cep025, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145170,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145170,23.01,0.01,0.4,69449,NULL,NULL,'NGC 6822:[PGU2004] cep019, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145171,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145171,23.01,0.07,0.4,69449,NULL,NULL,'NGC 6822:[PGU2004] cep034, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145172,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145172,23.09,0.01,0.415,69449,NULL,NULL,'NGC 6822:[PGU2004] cep027, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145173,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145173,23.1,0.08,0.417,69449,NULL,18.47,'10, B, Photographic','NGC 6822',NULL,'1987SAAOC..11..125W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145174,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145174,23.11,0.07,0.419,69449,NULL,NULL,'NGC 6822:[PGU2004] cep033, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145175,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145175,23.18,0.1,0.433,69449,NULL,NULL,NULL,'NGC 6822',NULL,'1989ApJ...346..629V',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145176,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145176,23.21,NULL,0.439,69449,NULL,NULL,'NGC 6822:[PGU2004] cep026, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145177,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145177,23.22,0.52,0.441,69449,NULL,NULL,'MW HIPP','NGC 6822',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145178,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145178,23.23,0.04,0.443,69449,NULL,NULL,'VI(W), inner, syst. +/- 0.16 mag','NGC 6822',NULL,'2014A&A...572A..64M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145179,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145179,23.23,0.07,0.443,69449,NULL,NULL,'NGC 6822:[PGU2004] cep035, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145180,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145180,23.26,0.02,0.449,69449,NULL,NULL,'NGC 6822:[PGU2004] cep007, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145181,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145181,23.27,0.18,0.45,69449,NULL,NULL,'LMC W01','NGC 6822',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145182,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145182,23.27,0.07,0.451,69449,NULL,NULL,'3.6 micron, inner, syst. +/- 0.27 mag','NGC 6822',NULL,'2014A&A...572A..64M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145183,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145183,23.28,0.03,0.453,69449,NULL,NULL,'VI(W), outer, syst. +/- 0.15 mag','NGC 6822',NULL,'2014A&A...572A..64M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145184,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145184,23.28,0.01,0.453,69449,NULL,NULL,'NGC 6822:[PGU2004] cep002, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145185,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145185,23.3,0.4,0.457,69449,NULL,NULL,'MW P02','NGC 6822',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145186,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145186,23.3,0.02,0.457,69449,NULL,NULL,'NGC 6822:[PGU2004] cep003, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145187,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145187,23.3,0.03,0.457,69449,NULL,NULL,'VI(W), outermost, syst. +/- 0.13 mag','NGC 6822',NULL,'2014A&A...572A..64M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145188,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145188,23.3,0.04,0.457,69449,NULL,NULL,'3.6 micron, outer, syst. +/- 0.17 mag','NGC 6822',NULL,'2014A&A...572A..64M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145189,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145189,23.31,0.03,0.459,69449,NULL,18.54,'LMC ZP','NGC 6822',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145190,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145190,23.31,0.02,0.46,69449,NULL,NULL,'56, JK','NGC 6822',NULL,'2006ApJ...647.1056G',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145191,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145191,23.32,0.13,0.461,69449,NULL,18.47,'9, H, Photographic','NGC 6822',NULL,'1987SAAOC..11..125W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145192,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145192,23.32,0.05,0.461,69449,NULL,NULL,'3.6 micron, outermost, syst. +/- 0.16 mag','NGC 6822',NULL,'2014A&A...572A..64M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145193,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145193,23.34,0.18,0.466,69449,NULL,NULL,'JK(W)','NGC 6822',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145194,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145194,23.34,0.04,0.466,69449,NULL,NULL,'45, VI,WI','NGC 6822',NULL,'2004AJ....128.2815P',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145195,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145195,23.34,0.01,0.466,69449,NULL,NULL,'NGC 6822:[PGU2004] cep018, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145196,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145196,23.34,0.01,0.466,69449,NULL,NULL,'NGC 6822:[PGU2004] cep020, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145197,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145197,23.35,0.01,0.468,69449,NULL,NULL,'NGC 6822:[PGU2004] cep008, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145198,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145198,23.35,0.07,0.468,69449,NULL,NULL,'NGC 6822:[PGU2004] cep030, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145199,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145199,23.35,0.09,0.468,69449,NULL,NULL,'NGC 6822:[PGU2004] cep038, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145200,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145200,23.36,0.01,0.47,69449,NULL,NULL,'NGC 6822:[PGU2004] cep015, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145201,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145201,23.37,0.04,0.472,69449,NULL,NULL,'NGC 6822:[PGU2004] cep024, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145202,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145202,23.38,0.52,0.474,69449,NULL,NULL,'MW GFG','NGC 6822',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145203,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145203,23.38,0.22,0.474,69449,NULL,NULL,'VI(W)','NGC 6822',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145204,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145204,23.38,0.52,0.474,69449,NULL,NULL,'4, VI','NGC 6822',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145205,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145205,23.38,0.01,0.474,69449,NULL,NULL,'NGC 6822:[PGU2004] cep006, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145206,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145206,23.38,0.01,0.474,69449,NULL,NULL,'NGC 6822:[PGU2004] cep017, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145207,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145207,23.38,0.04,0.474,69449,NULL,NULL,'NGC 6822:[PGU2004] cep023, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145208,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145208,23.38,0.05,0.474,69449,NULL,NULL,'NGC 6822:[PGU2004] cep029, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145209,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145209,23.38,0.05,0.474,69449,NULL,NULL,'19, 3.6 micron, 17, 4.5 micron, Stat. +/- 0.02, Syst. +/- 0.04','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145210,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145210,23.39,0.08,0.476,69449,NULL,NULL,'LMC VIHJK','NGC 6822',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145211,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145211,23.39,0.08,0.476,69449,NULL,NULL,'NGC 6822:[PGU2004] cep031, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145212,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145212,23.39,0.08,0.476,69449,NULL,NULL,'20, JHKs, GAL PL','NGC 6822',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145213,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145213,23.4,0.08,0.479,69449,NULL,18.47,'10, V, Photographic','NGC 6822',NULL,'1987SAAOC..11..125W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145214,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145214,23.4,0.05,0.479,69449,NULL,NULL,'VIJHK','NGC 6822',NULL,'2012MNRAS.421.2998F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145215,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145215,23.4,0.04,0.479,69449,NULL,NULL,'NGC 6822:[PGU2004] cep036, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145216,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145216,23.4,0.06,0.479,69449,NULL,NULL,'NGC 6822:[PGU2004] cep039, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145217,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145217,23.41,0.06,0.48,69449,74.4,NULL,NULL,'NGC 6822',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145218,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145218,23.41,0.06,0.481,69449,NULL,NULL,'20, JHKs, LMC PL','NGC 6822',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145219,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145219,23.41,0.08,0.481,69449,NULL,NULL,'NGC 6822:[PGU2004] cep021, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145220,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145220,23.42,NULL,0.483,69449,NULL,NULL,NULL,'NGC 6822',NULL,'1985PASAu...6..140V',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145221,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145221,23.42,0.01,0.483,69449,NULL,NULL,'NGC 6822:[PGU2004] cep016, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145222,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145222,23.43,0.02,0.485,69449,NULL,NULL,'NGC 6822:[PGU2004] cep014, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145223,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145223,23.43,0.06,0.485,69449,NULL,NULL,'20, JHKs, GAL+LMC PL','NGC 6822',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145224,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145224,23.45,0.06,0.49,69449,NULL,18.54,'3.6 micron','NGC 6822',NULL,'2009AIPC.1170...37N',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145225,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145225,23.45,0.02,0.49,69449,NULL,NULL,'NGC 6822:[PGU2004] cep010, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145226,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145226,23.46,0.07,0.492,69449,NULL,18.54,'4.5 micron','NGC 6822',NULL,'2009AIPC.1170...37N',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145227,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145227,23.46,0.07,0.492,69449,NULL,NULL,'4.5 micron, LMC m-M = 18.50 PL','NGC 6822',NULL,'2012Ap&SS.341..105N',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145228,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145228,23.46,0.02,0.492,69449,NULL,NULL,'NGC 6822:[PGU2004] cep004, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145229,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145229,23.46,0.08,0.492,69449,NULL,NULL,'NGC 6822:[PGU2004] cep005, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145230,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145230,23.47,0.11,0.494,69449,NULL,NULL,'9, H','NGC 6822',NULL,'1983ApJ...273..539M',1983,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145231,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145231,23.47,0.07,0.494,69449,NULL,NULL,'4.5 micron, SMC m-M = 18.90 PL','NGC 6822',NULL,'2012Ap&SS.341..105N',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145232,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145232,23.48,0.02,0.497,69449,NULL,NULL,'NGC 6822:[PGU2004] cep011, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145233,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145233,23.49,0.09,0.499,69449,NULL,NULL,'HST KP Calibrated','NGC 6822',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145234,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145234,23.49,0.08,0.499,69449,NULL,NULL,'6, BVRI','NGC 6822',NULL,'1996AJ....112.1928G',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145235,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145235,23.5,NULL,0.5,69449,NULL,NULL,NULL,'NGC 6822',NULL,'2000glg..book.....V',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145236,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145236,23.49,0.03,0.5,69449,NULL,NULL,'16, BVRIJHK, IRAC','NGC 6822',NULL,'2009ApJ...693..936M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145237,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145237,23.51,0.08,0.504,69449,NULL,NULL,'NGC 6822:[PGU2004] cep009, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145238,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145238,23.54,0.03,0.511,69449,NULL,NULL,'NGC 6822:[PGU2004] cep022, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145239,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145239,23.55,0.01,0.513,69449,NULL,NULL,'NGC 6822:[PGU2004] cep012, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145240,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145240,23.58,0.05,0.52,69449,NULL,NULL,'NGC 6822:[PGU2004] cep032, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145241,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145241,23.62,NULL,0.53,69449,NULL,NULL,NULL,'NGC 6822',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145242,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145242,23.62,0.07,0.53,69449,NULL,NULL,'NGC 6822:[PGU2004] cep037, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145243,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145243,23.66,0.13,0.54,69449,NULL,NULL,'BVH','NGC 6822',NULL,'1991PASP..103..933M',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145244,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145244,23.7,0.08,0.55,69449,NULL,NULL,'NGC 6822:[PGU2004] cep013, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145245,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145245,23.96,0.02,0.619,69449,NULL,NULL,'NGC 6822:[PGU2004] cep001, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145246,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145246,24.25,0.04,0.708,69449,NULL,NULL,'BVRI','NGC 6822',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145247,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145247,24.3,0.04,0.724,69449,NULL,NULL,'BVRI+','NGC 6822',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145248,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145248,24.35,0.06,0.741,69449,NULL,NULL,'3.6 micron, LMC m-M = 18.50 PL','NGC 6822',NULL,'2012Ap&SS.341..105N',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145249,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145249,24.43,0.06,0.769,69449,NULL,NULL,'3.6 micron, SMC m-M = 18.90 PL','NGC 6822',NULL,'2012Ap&SS.341..105N',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145250,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145250,24.6,NULL,0.832,69449,NULL,NULL,'Photographic, APPARENT BLUE m-M','NGC 6822',NULL,'1988PASP..100..935S',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145251,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145251,23.35,NULL,0.468,69449,NULL,NULL,NULL,'NGC 6822',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145252,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145252,23.35,NULL,0.468,69449,NULL,NULL,NULL,'NGC 6822',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145253,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145253,23.35,NULL,0.468,69449,NULL,NULL,NULL,'NGC 6822',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145254,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145254,23.38,0.05,0.474,69449,NULL,NULL,'Field 1','NGC 6822',NULL,'2010ApJ...721..297M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145255,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145255,23.39,0.04,0.476,69449,NULL,NULL,'Field 2','NGC 6822',NULL,'2010ApJ...721..297M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145256,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145256,23.4,0.06,0.479,69449,NULL,NULL,NULL,'NGC 6822',NULL,'2012A&A...548A.129F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145257,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145257,23.45,0.06,0.49,69449,NULL,NULL,'Field 3','NGC 6822',NULL,'2010ApJ...721..297M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145258,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145258,24.1,0.1,0.661,69449,NULL,NULL,'Field 1','NGC 6822',NULL,'2014A&A...572A..26F',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145259,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145259,24.1,0.1,0.661,69449,NULL,NULL,'Field 5','NGC 6822',NULL,'2014A&A...572A..26F',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145260,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145260,24.1,0.1,0.661,69449,NULL,NULL,'Field 6','NGC 6822',NULL,'2014A&A...572A..26F',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145261,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145261,24.2,0.1,0.692,69449,NULL,NULL,'Field 2','NGC 6822',NULL,'2014A&A...572A..26F',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145262,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145262,24.2,0.1,0.692,69449,NULL,NULL,'Field 3','NGC 6822',NULL,'2014A&A...572A..26F',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145263,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145263,24.2,0.1,0.692,69449,NULL,NULL,'Field 4','NGC 6822',NULL,'2014A&A...572A..26F',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145264,'FGLR','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145264,23.31,NULL,0.459,69449,NULL,NULL,NULL,'NGC 6822',NULL,'2008ApJ...681..269K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145265,'M Stars','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145265,19.83,NULL,0.0926,69449,NULL,18.54,NULL,'NGC 6822',NULL,'2010ApJ...722..750S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145266,'Miras','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145266,23.38,0.16,0.474,69449,NULL,NULL,'4','NGC 6822',NULL,'2013MNRAS.428.2216W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145267,'Miras','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145267,23.43,NULL,0.485,69449,NULL,18.39,NULL,'NGC 6822',NULL,'2012Ap&SS.341..123W',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145268,'Miras','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145268,23.56,0.03,0.515,69449,NULL,NULL,'50','NGC 6822',NULL,'2013MNRAS.428.2216W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145269,'PNLF','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145269,23.64,0.23,0.535,69449,NULL,NULL,'26','NGC 6822',NULL,'2009A&A...495..447H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145270,'Red Clump','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145270,23.34,0.1,0.466,69449,NULL,NULL,NULL,'NGC 6822',NULL,'2003AJ....125.3097W',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145271,'Red Clump','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145271,23.98,NULL,0.625,69449,NULL,NULL,'I, M RC(I) = -0.50 mag','NGC 6822',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145272,'Red Clump','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145272,24.18,NULL,0.685,69449,NULL,NULL,'V, M RC(V) = +0.73 mag','NGC 6822',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145273,'RR Lyrae','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145273,23.36,0.17,0.47,69449,NULL,NULL,NULL,'NGC 6822',NULL,'2003ApJ...588L..85C',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145274,'RR Lyrae','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145274,23.43,NULL,0.485,69449,NULL,NULL,NULL,'NGC 6822',NULL,'2008ApJ...679...52T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145275,'RR Lyrae','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145275,23.49,0.05,0.499,69449,NULL,NULL,NULL,'NGC 6822',NULL,'2012MNRAS.421.2998F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145276,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145276,23.26,0.07,0.449,69449,NULL,NULL,'K','NGC 6822',NULL,'2011AJ....141..194G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145277,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145277,23.31,0.05,0.459,69449,NULL,NULL,'J','NGC 6822',NULL,'2011AJ....141..194G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145278,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145278,23.32,0.1,0.461,69449,NULL,NULL,NULL,'NGC 6822',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145279,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145279,23.34,0.12,0.466,69449,NULL,NULL,'I, MI = _4.04 mag','NGC 6822',NULL,'2005A&A...429..837C',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145280,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145280,23.37,0.07,0.472,69449,NULL,NULL,NULL,'NGC 6822',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145281,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145281,23.39,0.16,0.476,69449,NULL,NULL,'HST KP Calibrated','NGC 6822',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145282,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145282,23.4,0.1,0.479,69449,NULL,NULL,'Z','NGC 6822',NULL,'1996AJ....112.1928G',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145283,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145283,23.41,0.06,0.48,69449,74.4,NULL,NULL,'NGC 6822',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145284,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145284,23.41,0.17,0.481,69449,NULL,NULL,'JHK','NGC 6822',NULL,'2008JASS...25..249S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145285,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145285,23.44,0.16,0.488,69449,NULL,NULL,'I, avg','NGC 6822',NULL,'2003AJ....125.3097W',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145286,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145286,23.46,0.1,0.492,69449,NULL,NULL,'I','NGC 6822',NULL,'1993ApJ...417..553L',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145287,'TRGB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145287,23.5,NULL,0.501,69449,NULL,NULL,'I','NGC 6822',NULL,'2011ApJ...738...58H',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145288,'TRGB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145288,23.51,0.05,0.504,69449,NULL,NULL,'I, Z correct','NGC 6822',NULL,'2012A&A...548A.129F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145289,'TRGB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145289,23.53,0.05,0.508,69449,NULL,NULL,'I, Mean of 2','NGC 6822',NULL,'2012A&A...548A.129F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145290,'TRGB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145290,23.54,0.05,0.511,69449,NULL,NULL,'I','NGC 6822',NULL,'2012A&A...548A.129F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145291,'TRGB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145291,23.6,0.12,0.525,69449,NULL,NULL,NULL,'NGC 6822',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145292,'TRGB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145292,23.61,NULL,0.527,69449,NULL,NULL,NULL,'NGC 6822',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145293,'TRGB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145293,23.61,NULL,0.527,69449,NULL,NULL,'DA90','NGC 6822',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145294,'TRGB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145294,23.64,NULL,0.535,69449,NULL,NULL,'theory','NGC 6822',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145295,'TRGB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145295,23.64,0.19,0.535,69449,NULL,NULL,NULL,'NGC 6822',NULL,'1996AJ....112.1928G',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145296,'TRGB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145296,23.68,NULL,0.545,69449,NULL,NULL,'Yale','NGC 6822',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145297,'TRGB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145297,23.73,NULL,0.557,69449,NULL,NULL,'K97','NGC 6822',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145298,'TRGB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145298,24,NULL,0.631,69449,NULL,NULL,'I, M TRGB(I) = -4.05 mag','NGC 6822',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145299,'Statistical','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145299,23.36,0.01,0.469,69449,NULL,NULL,'12 estimates','NGC 6822',NULL,'2014arXiv1410.7843C',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145300,'HII region diameter','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145300,24.47,0.13,0.783,69449,NULL,NULL,'Method 2','NGC 6822',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145301,'HII region diameter','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145301,24.69,0.15,0.867,69449,NULL,NULL,'Method 1','NGC 6822',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145302,'Magnitude','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145302,24.02,0.11,0.637,69449,NULL,NULL,NULL,'NGC 6822',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145303,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145303,24.23,0.4,0.7,69449,75,NULL,'B','NGC 6822',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145304,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145304,25.48,NULL,1.25,69449,NULL,NULL,'LEDA [April 2006]','NGC 6822',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145305,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145305,32.33,0.16,29.2,69450,NULL,NULL,'I','IC 4889',NULL,'2001ApJ...546..681T',2001,1,2.9,NULL,'G',0.000014,NULL,'12.06',1.7,'E5-6           Sy2',NULL,NULL,NULL,NULL,1,296.313125,-54.34414,0.181,NULL,49020623116,765947236,11967925,12.06),(145306,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145306,32.33,0.16,29.2,69450,NULL,NULL,NULL,'IC 4889',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145307,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145307,32.34,0.14,29.4,69450,74.4,NULL,NULL,'IC 4889',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145308,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145308,32.4,0.16,30.2,69450,NULL,NULL,'Malmquist cor.','IC 4889',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145309,'D-Sigma','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145309,32.16,0.4,27.1,69450,75,NULL,'Edat, raw','IC 4889',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145310,'D-Sigma','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145310,32.35,0.4,29.6,69450,75,NULL,'Edat, cor','IC 4889',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145311,'Faber-Jackson','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145311,30.87,0.65,14.9,69450,95,NULL,'Weighted Mean','IC 4889',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145312,'Faber-Jackson','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145312,32.06,0.81,25.8,69450,55,NULL,'Visvanathan & Sandage 1979','IC 4889',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145313,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145313,31.46,0.41,19.6,69450,NULL,NULL,NULL,'IC 4889',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145314,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145314,31.83,0.51,23.2,69450,70,NULL,NULL,'IC 4889',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145315,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145315,31.91,0.41,24.1,69450,NULL,NULL,'Malmquist cor.','IC 4889',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145316,'Tully est','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145316,32.55,0.8,32.3,69450,75,NULL,'B','IC 4889',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145317,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145317,32.02,0.45,25.3,69450,NULL,NULL,'K','IC 4889',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145318,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145318,32.46,0.4,31.1,69450,NULL,NULL,'mean','IC 4889',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145319,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145319,34.44,0.43,77.2,69451,75,NULL,'3.6 micron, color + selection bias corrected','ESO 398- G 029',NULL,'2014MNRAS.444..527S',2014,1,1.7,NULL,'G',0.000023,NULL,'15.8',0.22,'Sbc            HII',NULL,NULL,NULL,NULL,1,296.318417,-34.74828,0.417,NULL,51202127574,800033243,12500519,15.8),(145320,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145320,34.88,NULL,94.5,69451,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 398- G 029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145321,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145321,34.89,NULL,94.9,69451,NULL,NULL,'Dipole + Quadrupole','ESO 398- G 029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145322,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145322,34.9,NULL,95.3,69451,NULL,NULL,'Dipole','ESO 398- G 029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145323,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145323,34.27,0.8,71.5,69452,75,NULL,'MAT, I','ESO 338- G 022',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'15.73',0.4,'Sb',NULL,NULL,NULL,NULL,1,296.325916667,-38.33464,0.437,NULL,51179174637,799674603,12494915,15.73),(145324,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145324,33.67,0.32,54.1,69452,85,NULL,'I, raw','ESO 338- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145325,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145325,33.67,0.32,54.2,69452,85,NULL,'I, inv','ESO 338- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145326,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145326,33.77,0.43,56.7,69452,75,NULL,'MAT, I, raw','ESO 338- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145327,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145327,33.85,0.43,58.8,69452,75,NULL,'MAT, I, inv','ESO 338- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145328,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145328,34.19,0.43,68.8,69452,75,NULL,'MAT, I, cor','ESO 338- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145329,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145329,34.34,0.29,73.7,69452,NULL,NULL,NULL,'ESO 338- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145330,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145330,34.38,0.2,75.2,69452,74.4,NULL,NULL,'ESO 338- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145331,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145331,34.51,0.27,79.8,69452,NULL,NULL,'Malmquist cor.','ESO 338- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145332,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145332,36.77,0.59,226,69453,70,NULL,NULL,'2MASX J19451872-5211019',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.5I',0.4,NULL,NULL,NULL,NULL,NULL,1,296.327875,-52.18383,0.137,NULL,51119069798,798735465,12480241,14.5),(145333,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145333,36.5,0.59,200,69454,70,NULL,NULL,'2MASX J19451954-1929035',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,296.331416667,-19.48428,0.373,NULL,47927917196,748873706,11701151,15.5),(145334,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145334,34.02,0.47,63.7,69455,70,NULL,NULL,'NGC 6812',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000097,NULL,'13.56',1.1,'S0: pec',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,296.350916667,-55.34681,0.153,NULL,49019851426,765935178,11967737,13.56),(145335,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145335,33.39,0.69,47.7,69456,100,NULL,'mid-IR','UGC 11473',NULL,'2013ApJ...771...88L',2013,1,1.8,'abs(b) < 10 degrees.','G',0.00001,NULL,'14.20',1.1,'Sd',NULL,NULL,NULL,NULL,1,296.3827917,43.14061,NULL,NULL,54968005133,858875080,13419923,14.2),(145336,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145336,33.53,0.2,50.8,69456,74.4,NULL,NULL,'UGC 11473',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145337,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145337,34.2,0.4,69.1,69456,NULL,NULL,'mean','UGC 11473',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145338,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145338,34.37,0.47,74.9,69456,NULL,NULL,'H','UGC 11473',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145339,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145339,34.45,0.46,77.7,69456,NULL,NULL,'J','UGC 11473',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145340,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145340,34.52,0.45,80.1,69456,NULL,NULL,'K','UGC 11473',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145341,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145341,34.73,0.55,88.5,69457,70,NULL,NULL,'2MASX J19455058-0618280',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000047,NULL,'14.5R',0.5,'SB(s)c?        HII',NULL,NULL,NULL,NULL,1,296.460875,-6.30789,0.493,NULL,47870879610,747982493,11687226,14.5),(145342,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145342,35.56,0.2,129,69457,74.4,NULL,NULL,'2MASX J19455058-0618280',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145343,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145343,35.77,0.47,143,69457,NULL,NULL,'H','2MASX J19455058-0618280',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145344,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145344,35.91,0.45,152,69457,NULL,NULL,'K','2MASX J19455058-0618280',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145345,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145345,35.91,0.4,152,69457,NULL,NULL,'mean','2MASX J19455058-0618280',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145346,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145346,35.99,0.46,158,69457,NULL,NULL,'J','2MASX J19455058-0618280',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145347,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145347,34.91,0.8,96.1,69458,75,NULL,'MAT, I','ESO 232- G 023',NULL,'1997ApJS..109..333W',1997,1,1.3,'Marginal HIPASS detection.','G',0.000027,NULL,'14.98',1.1,'SA(s)c',NULL,NULL,NULL,NULL,1,296.468125,-50.29444,0.125,NULL,51119771168,798746424,12480412,14.98),(145348,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145348,33.68,0.43,54.4,69458,75,NULL,'MAT, I, inv','ESO 232- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145349,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145349,33.72,0.43,55.4,69458,75,NULL,'MAT, I, raw','ESO 232- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145350,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145350,34.01,0.43,63.4,69458,75,NULL,'MAT, I, cor','ESO 232- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145351,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145351,34.28,0.32,71.9,69458,85,NULL,'I, inv','ESO 232- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145352,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145352,34.29,0.32,72,69458,85,NULL,'I, raw','ESO 232- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145353,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145353,36.93,0.7,243,69459,70,NULL,NULL,'ESO 594- G 013',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.4R',1,'(R\'_1)SB(r)a',NULL,NULL,NULL,NULL,1,296.5120417,-19.05914,0.353,NULL,47928072048,748876125,11701189,15.4),(145354,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145354,36.83,0.68,233,69460,70,NULL,NULL,'2MASX J19461371-1931397',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,296.557083,-19.52767,0.369,NULL,47928116304,748876817,11701200,15.8),(145355,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145355,35.15,0.62,107,69461,70,NULL,NULL,'ESO 185- G 019',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'15.51',0.3,'SB(s)b? sp',NULL,NULL,NULL,NULL,1,296.5845,-55.72542,0.157,NULL,49011609869,765806404,11965725,15.51),(145356,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145356,37.61,0.7,333,69462,70,NULL,NULL,'2MASX J19462913-0931308',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,296.621417,-9.52522,0.557,NULL,47985176808,749768387,11715131,15.7),(145357,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145357,35.32,0.49,116,69463,75,NULL,'IR','ESO 232- G 024',NULL,'2011yCatp016004901K',2011,1,1.03,NULL,'G',0.000033,NULL,'16.09',0.12,'Sbc',NULL,NULL,NULL,NULL,1,296.63425,-52.09944,0.137,NULL,51119026724,798734792,12480231,16.09),(145358,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145358,35.69,0.57,138,69463,NULL,NULL,'Malmquist cor.','ESO 232- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145359,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145359,35.72,0.56,139,69463,NULL,NULL,NULL,'ESO 232- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145360,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145360,35.73,NULL,140,69463,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 232- G 024',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145361,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145361,35.74,NULL,141,69463,NULL,NULL,'Dipole + Quadrupole','ESO 232- G 024',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145362,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145362,35.76,0.2,142,69463,74.4,NULL,NULL,'ESO 232- G 024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145363,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145363,35.77,NULL,143,69463,NULL,NULL,'Dipole','ESO 232- G 024',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145364,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145364,35.77,NULL,143,69463,NULL,NULL,NULL,'ESO 232- G 024',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145365,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145365,36.98,0.92,249,69464,70,NULL,NULL,'2MASX J19463331-2222559',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,296.638791667,-22.38219,0.381,NULL,47919354455,748739913,11699061,15.8),(145366,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145366,33.33,0.2,46.3,69465,74.4,NULL,NULL,'UGC 11475',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.00004,NULL,'15.10',0.8,'SBd',NULL,NULL,NULL,NULL,1,296.6720417,59.7005,0.433,NULL,52972589982,827696718,12932761,15.1),(145367,'GRB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145367,43.95,0.33,2740,69466,69.7,NULL,'Calibrated','GRB 020813',1.254,'2009MNRAS.400..775C',2009,1,NULL,NULL,'G',0.005,NULL,'24.8R',NULL,'HETE',NULL,NULL,NULL,NULL,1,296.6745,-19.60142,0.369,NULL,47927399373,748865615,11701025,24.8),(145368,'GRB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145368,44.01,0.41,2810,69466,72,NULL,NULL,'GRB 020813',1.254,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145369,'GRB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145369,44.07,0.43,2890,69466,69.7,NULL,'Fiducial','GRB 020813',1.254,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145370,'GRB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145370,44.11,0.41,2950,69466,70,NULL,NULL,'GRB 020813',1.254,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145371,'GRB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145371,45,1.07,3240,69466,73,NULL,'H const./H=100','GRB 020813',1.254,'2006astro.ph..9262M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145372,'GRB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145372,44.92,0.18,4280,69466,69.7,NULL,'Calibrated','GRB 020813',1.254,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145373,'GRB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145373,42.38,NULL,2990,69467,70,NULL,'Pseudo z = 1.37','GRB 020813',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'G',0.005,NULL,'24.8R',NULL,'HETE',NULL,NULL,NULL,NULL,1,296.6745,-19.60142,0.369,NULL,47927399373,748865615,11701025,24.8),(145374,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145374,34.24,0.48,70.4,69468,70,NULL,NULL,'ESO 105- G 012',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000053,NULL,'15.3b',0.2,'S 0 :',NULL,NULL,NULL,NULL,1,296.6854583,-65.24697,0.277,NULL,49227004331,769171942,12018311,15.3),(145375,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145375,36.79,0.61,228,69469,70,NULL,NULL,'2MASX J19464712-1157209',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,296.6964583,-11.95569,0.589,NULL,47984751455,749761741,11715027,16.2),(145376,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145376,32.87,0.43,37.4,69470,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11477',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.00005,NULL,'15.3',0.2,'Sd',NULL,NULL,NULL,NULL,1,296.746791667,56.91067,0.677,NULL,53002998341,828171849,12940185,15.3),(145377,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145377,33.2,0.49,43.7,69470,75,NULL,'IR','UGC 11477',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145378,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145378,33.64,0.4,53.5,69470,NULL,NULL,'mean','UGC 11477',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145379,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145379,33.66,0.47,54,69470,NULL,NULL,'H','UGC 11477',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145380,'GRB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'N',145380,38.21,NULL,438,69471,65,NULL,'L = 10e57 photons/s','GRB 910122',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145381,'GRB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'N',145381,41.04,NULL,1610,69471,65,NULL,'L = 2 x 10e58 photons/s','GRB 910122',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145382,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145382,35.7,0.47,138,69472,70,NULL,NULL,'ESO 594- G 016',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000117,NULL,'14.3R',0.3,'S0',NULL,NULL,NULL,NULL,1,296.772,-20.20558,0.393,NULL,47925563976,748836937,11700577,14.3),(145383,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145383,35.94,0.72,154,69473,70,NULL,NULL,'2MASX J19470550-0543308',NULL,'2014MNRAS.445.2677S',2014,1,0.1,NULL,'G',0.00015,NULL,'15.1I',0.1,'E',NULL,NULL,NULL,NULL,1,296.772958333,-5.72525,0.501,NULL,47901306147,748457908,11694654,15.1),(145384,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145384,33.78,0.49,57.1,69474,75,NULL,'IR','NGC 6829',NULL,'2011yCatp016004901K',2011,1,1.6,NULL,'G',0.00004,NULL,'14.91',0.4,'Sb',NULL,NULL,NULL,NULL,1,296.7815,59.90708,0.433,NULL,52981325988,827833218,12934894,14.91),(145385,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145385,36.57,0.51,206,69475,70,NULL,NULL,'2MASX J19470986-2244562',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.3I',0.5,NULL,NULL,NULL,NULL,NULL,1,296.791208333,-22.749,0.401,NULL,47916436504,748694320,11698348,13.3),(145386,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145386,35.66,0.55,135,69476,70,NULL,NULL,'2MASX J19471745-6142362',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,296.82275,-61.71017,0.265,NULL,49023597954,765993718,11968651,15.1),(145387,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145387,35.84,0.51,147,69477,70,NULL,NULL,'2MASX J19472031-0900519',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.7I',0.5,NULL,NULL,NULL,NULL,NULL,1,296.834667,-9.01442,0.477,NULL,47871689068,747995141,11687424,13.7),(145388,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145388,33.86,0.51,59.2,69478,70,NULL,NULL,'2MASX J19473300-1006561',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00011,NULL,'13.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,296.8875,-10.11558,0.521,NULL,47985575303,749774614,11715228,13.4),(145389,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145389,35.48,0.64,125,69479,70,NULL,NULL,'2MASX J19473426-0837531',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.5,NULL,NULL,NULL,NULL,NULL,1,296.89275,-8.63144,0.481,NULL,47871907199,747998549,11687477,14),(145390,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145390,36.17,0.53,171,69480,70,NULL,NULL,'ESO 025- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'16.5b',0.4,'S0',NULL,NULL,NULL,NULL,1,296.938875,-79.19428,0.549,NULL,48547702211,758557847,11852466,16.5),(145391,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145391,36.2,0.84,173,69481,70,NULL,NULL,'2MASX J19474588-1415550',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,296.94125,-14.26528,0.713,NULL,47965858044,749466531,11710414,15.3),(145392,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145392,34.98,0.6,99.2,69482,70,NULL,NULL,'ESO 142- G 043',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.99',0.2,'Compact',NULL,NULL,NULL,NULL,1,297.0177917,-59.52428,0.201,NULL,49032773234,766137081,11970891,15.99),(145393,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145393,36.26,0.61,178,69483,70,NULL,NULL,'2MASX J19480771-1803534',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,297.032083,-18.06478,0.357,NULL,47973926600,749592603,11712384,15.5),(145394,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145394,34.58,0.45,82.5,69484,NULL,NULL,NULL,'ESO 526- G 006',NULL,'2009ApJS..182..474S',2009,1,1.6,NULL,'G',0.00002,NULL,'14.32',0.4,'Sb:',NULL,NULL,NULL,NULL,1,297.0559583,-23.50956,0.429,NULL,47915803307,748684426,11698194,14.32),(145395,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145395,34.62,0.2,84,69484,74.4,NULL,NULL,'ESO 526- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145396,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145396,34.68,0.43,86.4,69484,NULL,NULL,'Malmquist cor.','ESO 526- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145397,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145397,35.47,0.63,124,69485,70,NULL,NULL,'2MASX J19481765-1418284',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,297.0735,-14.30783,0.713,NULL,47965670564,749463602,11710368,14.8),(145398,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145398,31.85,0.8,23.4,69486,75,NULL,'MAT, I','UGCA 416',NULL,'1997ApJS..109..333W',1997,1,2.9,NULL,'G',0.000022,NULL,'14.5',1.6,'(R\')SB(s)m pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,297.0915,-18.07836,0.397,NULL,47971843186,749560049,11711875,14.5),(145399,'Tully est','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145399,31.94,0.8,24.4,69486,75,NULL,NULL,'UGCA 416',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145400,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145400,31.32,0.4,18.4,69486,NULL,NULL,NULL,'UGCA 416',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145401,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145401,31.32,0.4,18.4,69486,73,NULL,'opt','UGCA 416',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145402,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145402,31.44,0.32,19.4,69486,85,NULL,'I, inv','UGCA 416',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145403,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145403,31.46,0.32,19.6,69486,85,NULL,'I, raw','UGCA 416',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145404,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145404,31.66,0.2,21.5,69486,74.4,NULL,NULL,'UGCA 416',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145405,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145405,31.83,0.43,23.3,69486,75,NULL,'MAT, I, inv','UGCA 416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145406,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145406,31.84,0.43,23.3,69486,75,NULL,'MAT, I, raw','UGCA 416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145407,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145407,32.04,0.43,25.5,69486,75,NULL,'MAT, I, cor','UGCA 416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145408,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145408,36.57,0.7,206,69487,70,NULL,NULL,'2MASX J19482337-1226084',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.4I',0.4,NULL,NULL,NULL,NULL,NULL,1,297.097417,-12.43567,0.581,NULL,47951417254,749240894,11706888,14.4),(145409,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145409,34.74,0.49,88.5,69488,75,NULL,'IR','CGCG 397-007',NULL,'2011yCatp016004901K',2011,1,0.78,NULL,'G',0.000117,NULL,'15.5',0.22,'Spiral',NULL,NULL,NULL,NULL,1,297.225917,3.48633,0.993,NULL,54156429487,846194210,13221784,15.5),(145410,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145410,35.68,0.57,137,69489,70,NULL,NULL,'2MASX J19490651-0455554',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'13.6I',0.2,'S',NULL,NULL,NULL,NULL,1,297.2772083,-4.93197,0.481,NULL,47901812660,748465822,11694778,13.6),(145411,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145411,34.63,0.66,84.4,69490,70,NULL,NULL,'2MASX J19492513-1038297',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,297.354625,-10.64167,0.553,NULL,47998090019,749970156,11718283,14.7),(145412,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145412,33.6,0.8,52.5,69491,75,NULL,'MAT, I','IC 4892',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'14.76',0.4,'Sbc? sp','in a triple',NULL,NULL,NULL,1,297.3817083,-70.22744,0.245,NULL,49243286611,769426353,12022286,14.76),(145413,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145413,32.89,0.32,37.8,69491,85,NULL,'I, raw','IC 4892',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145414,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145414,32.9,0.32,38.1,69491,85,NULL,'I, inv','IC 4892',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145415,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145415,33.06,0.43,40.9,69491,75,NULL,'MAT, I, raw','IC 4892',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145416,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145416,33.17,0.43,43.1,69491,75,NULL,'MAT, I, inv','IC 4892',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145417,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145417,33.32,0.49,46.1,69491,75,NULL,'IR','IC 4892',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145418,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145418,33.35,0.43,46.9,69491,75,NULL,'MAT, I, cor','IC 4892',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145419,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145419,33.76,0.4,56.5,69491,NULL,NULL,'mean','IC 4892',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145420,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145420,33.78,0.12,57.1,69491,NULL,NULL,NULL,'IC 4892',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145421,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145421,34.03,0.47,64,69491,NULL,NULL,'H','IC 4892',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145422,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145422,33.91,0.69,60.6,69492,100,NULL,'mid-IR','ESO 526- G 007',NULL,'2013ApJ...771...88L',2013,1,3.2,NULL,'G',0.00001,NULL,'15',2.2,'SA(r)b:',NULL,NULL,NULL,NULL,1,297.399417,-26.43231,0.633,NULL,51139359484,799052491,12485195,15),(145423,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145423,34.59,0.4,82.7,69492,NULL,NULL,'mean','ESO 526- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145424,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145424,34.79,0.47,90.7,69492,NULL,NULL,'H','ESO 526- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145425,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145425,34.85,0.45,93.4,69492,NULL,NULL,'K','ESO 526- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145426,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145426,34.89,0.46,95,69492,NULL,NULL,'J','ESO 526- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145427,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145427,36.37,0.56,188,69493,70,NULL,NULL,'2MASX J19493847-2156060',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.4,'SA(s)a',NULL,NULL,NULL,NULL,1,297.410166667,-21.93514,0.445,NULL,47919755538,748746180,11699159,13.9),(145428,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145428,35.09,0.54,104,69494,70,NULL,NULL,'2MASX J19493902-2254410',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.8I',0.3,NULL,NULL,NULL,NULL,NULL,1,297.412667,-22.91142,0.421,NULL,47916214284,748690848,11698294,13.8),(145429,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145429,35.75,0.56,141,69495,70,NULL,NULL,'2MASX J19494420-0937357',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,297.434125,-9.62658,0.497,NULL,47997504837,749961013,11718140,14),(145430,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145430,34.56,0.49,81.7,69496,75,NULL,'IR','FGC 2264',NULL,'2011yCatp016004901K',2011,1,1.29,'The 6dF redshift z = 0.020229 confirms the value in 2000A&AS..143..421M.','G',0.00002,':','16.6',0.09,'Sd',NULL,NULL,NULL,NULL,1,297.4425417,-10.77444,0.553,NULL,47998266118,749972908,11718326,16.6),(145431,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145431,35.14,NULL,106,69496,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2264',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145432,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145432,35.14,NULL,107,69496,NULL,NULL,'Dipole','FGC 2264',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145433,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145433,35.14,NULL,107,69496,NULL,NULL,'Dipole + Quadrupole','FGC 2264',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145434,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145434,37.1,0.7,263,69497,70,NULL,NULL,'2MASX J19500201-0647518',NULL,'2014MNRAS.445.2677S',2014,1,0.1,NULL,'G',0.00015,NULL,'15.7R',0.1,NULL,NULL,NULL,NULL,NULL,1,297.508458333,-6.79772,0.561,NULL,47873425430,748022272,11687848,15.7),(145435,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145435,36.34,0.59,185,69498,70,NULL,NULL,'2MASX J19500700-0902048',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,297.529167,-9.03467,0.465,NULL,47992340795,749880324,11716880,15.5),(145436,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145436,36.64,0.51,213,69499,70,NULL,NULL,'2MASX J19501232-1854242',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,297.551333,-18.90669,0.377,NULL,47926824445,748856631,11700884,14.9),(145437,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145437,36.17,0.79,171,69500,70,NULL,NULL,'2MASX J19501286-1804432',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,297.553666667,-18.07878,0.373,NULL,47971949002,749561703,11711901,14.6),(145438,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145438,35.99,0.64,158,69501,70,NULL,NULL,'2MASX J19501738-6411062',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,297.572583,-64.18511,0.225,NULL,49225024369,769141005,12017828,15.8),(145439,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145439,36.88,0.92,238,69502,70,NULL,NULL,'2MASX J19501880-0641280',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.0I',0.1,'E',NULL,NULL,NULL,NULL,1,297.578333,-6.69108,0.509,NULL,47873464551,748022883,11687857,15),(145440,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145440,36.6,0.74,209,69503,70,NULL,NULL,'2MASX J19502206-1328084',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,297.5919583,-13.46903,0.613,NULL,47963497418,749429647,11709838,16.2),(145441,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145441,34.77,0.43,89.8,69504,NULL,NULL,'Malmquist cor.','ESO 526- G 009',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'16',0.3,'S...',NULL,NULL,NULL,NULL,1,297.615375,-24.52114,0.493,NULL,51272089095,801126392,12517599,16),(145442,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145442,34.87,0.41,94.4,69504,NULL,NULL,NULL,'ESO 526- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145443,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145443,34.91,0.2,95.9,69504,74.4,NULL,NULL,'ESO 526- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145444,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145444,36.14,0.55,169,69505,70,NULL,NULL,'2MASX J19502838-0600270',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'13.5I',0.5,NULL,NULL,NULL,NULL,NULL,1,297.61825,-6.00747,0.401,NULL,47901322280,748458160,11694658,13.5),(145445,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145445,34.97,0.8,98.8,69506,75,NULL,'MAT, I','ESO 461- G 003',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.00002,NULL,'14.75',0.6,'SA(rs)bc?',NULL,NULL,NULL,NULL,1,297.663167,-28.262,0.653,NULL,51150804392,799231318,12487989,14.75),(145446,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145446,33.99,0.43,62.7,69506,75,NULL,'MAT, I, raw','ESO 461- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145447,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145447,34.13,0.32,67.1,69506,85,NULL,'I, raw','ESO 461- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145448,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145448,34.19,0.32,69,69506,85,NULL,'I, inv','ESO 461- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145449,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145449,34.25,0.43,70.7,69506,75,NULL,'MAT, I, inv','ESO 461- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145450,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145450,34.47,0.43,78.5,69506,75,NULL,'MAT, I, cor','ESO 461- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145451,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145451,34.68,0.4,86.1,69506,NULL,NULL,'Malmquist cor.','ESO 461- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145452,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145452,34.68,0.49,86.5,69506,75,NULL,'IR','ESO 461- G 003',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145453,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145453,34.87,0.36,94.3,69506,NULL,NULL,NULL,'ESO 461- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145454,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145454,34.91,0.2,95.9,69506,74.4,NULL,NULL,'ESO 461- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145455,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145455,35.12,0.47,106,69506,NULL,NULL,'H','ESO 461- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145456,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145456,35.19,0.4,109,69506,NULL,NULL,'mean','ESO 461- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145457,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145457,35.3,0.45,115,69506,NULL,NULL,'K','ESO 461- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145458,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145458,35.33,0.46,116,69506,NULL,NULL,'J','ESO 461- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145459,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145459,35.43,0.55,122,69507,70,NULL,NULL,'2MASX J19504830-1914515',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'13.5I',0.4,NULL,NULL,NULL,NULL,NULL,1,297.701291667,-19.24764,0.389,NULL,47928728421,748886381,11701349,13.5),(145460,'SGRB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'N',145460,42.87,NULL,3750,69508,70,NULL,'Photometric Distance, Host A, M(R) = -20 mag and spectral slope Beta = 1.0 ','GRB 070429A HOST',NULL,'2012A&A...545A..77R',2012,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145461,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145461,34.41,0.44,76.2,69509,NULL,NULL,NULL,'ESO 233- G 003',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.66',0.6,'SA(s)d:',NULL,NULL,NULL,NULL,1,297.70625,-47.37442,0.173,NULL,51112687015,798635734,12478683,15.66),(145462,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145462,34.45,0.2,77.6,69509,74.4,NULL,NULL,'ESO 233- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145463,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145463,34.45,0.43,77.7,69509,NULL,NULL,'Malmquist cor.','ESO 233- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145464,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145464,33.19,0.47,43.5,69510,NULL,NULL,'H','2MASX J19505731+1822281',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000022,NULL,'14.18',0.33,'Spiral',NULL,NULL,NULL,NULL,1,297.738791667,18.3745,NULL,NULL,54028791337,844199864,13190622,14.18),(145465,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145465,33.29,0.46,45.6,69510,NULL,NULL,'J','2MASX J19505731+1822281',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145466,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145466,33.3,0.45,45.7,69510,NULL,NULL,'K','2MASX J19505731+1822281',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145467,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145467,33.46,0.4,49.1,69510,NULL,NULL,'mean','2MASX J19505731+1822281',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145468,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145468,34.53,0.46,80.4,69511,70,NULL,NULL,'ESO 461- G 005',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000057,NULL,'14.44',0.8,'S0',NULL,NULL,NULL,NULL,1,297.770541667,-30.75794,0.497,NULL,51148960972,799202515,12487539,14.44),(145469,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145469,35.43,0.63,122,69512,70,NULL,NULL,'2MASX J19511573-3103045',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000117,NULL,'16.49',NULL,NULL,NULL,NULL,NULL,NULL,1,297.815541667,-31.05133,0.497,NULL,51148994539,799203039,12487547,16.49),(145470,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145470,35.21,0.49,110,69513,70,NULL,NULL,'CGCG 371-005',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00011,NULL,'15.4',0.2,'E',NULL,NULL,NULL,NULL,1,297.835833,-2.26178,0.609,NULL,47905571112,748524548,11695696,15.4),(145471,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145471,35.44,0.55,122,69514,70,NULL,NULL,'2MASX J19512142-3240205',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000127,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,297.839375,-32.67242,0.529,NULL,51195449366,799928896,12498889,14.4),(145472,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145472,35.28,0.4,114,69515,NULL,NULL,'mean','UGC 11488',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.00002,NULL,'14.5',0.9,'Sbc',NULL,NULL,NULL,NULL,1,297.86375,3.56097,0.861,NULL,54154695244,846167113,13221361,14.5),(145473,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145473,35.62,0.47,133,69515,NULL,NULL,'H','UGC 11488',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145474,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145474,35.21,0.56,110,69516,70,NULL,NULL,'2MASX J19513838-1749450',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.4,NULL,NULL,NULL,NULL,NULL,1,297.909833,-17.82922,0.397,NULL,47972177384,749565271,11711957,14.2),(145475,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145475,35.36,0.54,118,69517,70,NULL,NULL,'2MASX J19514317-1244350',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,297.929917,-12.74297,0.593,NULL,47959733211,749370831,11708919,15.2),(145476,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145476,36.15,0.59,170,69518,70,NULL,NULL,'2MASX J19514661-2134553',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.6I',0.2,NULL,NULL,NULL,NULL,NULL,1,297.9442083,-21.582,0.417,NULL,47917124459,748705069,11698516,14.6),(145477,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145477,34.9,0.48,95.5,69519,70,NULL,NULL,'MCG -05-47-001',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00006,NULL,'15.85',0.32,'S0','Compact group member',NULL,NULL,NULL,1,297.966416667,-30.80844,0.497,NULL,51148879855,799201247,12487519,15.85),(145478,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145478,34.44,0.43,77.4,69520,75,NULL,'3.6 micron, color + selection bias corrected','ESO 461- G 006',NULL,'2014MNRAS.444..527S',2014,1,2.24,NULL,'G',0.000033,NULL,'16.21',0.18,'Sbc',NULL,NULL,NULL,NULL,1,297.982541667,-31.97558,0.501,NULL,51191986452,799874788,12498043,16.21),(145479,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145479,34.56,NULL,81.7,69520,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 461- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145480,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145480,34.57,NULL,81.9,69520,NULL,NULL,'Dipole + Quadrupole','ESO 461- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145481,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145481,34.58,NULL,82.3,69520,NULL,NULL,'Dipole','ESO 461- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145482,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145482,36.16,0.87,171,69521,70,NULL,NULL,'2MASX J19515995-8344333',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,297.999375,-83.74258,0.529,NULL,48383403797,755990684,11812354,17.1),(145483,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145483,34.48,0.5,78.8,69522,NULL,NULL,NULL,'ESO 526- G 010',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.06',0.6,'S...',NULL,NULL,NULL,NULL,1,298.002917,-23.45067,0.397,NULL,50802103006,793782859,12402857,14.06),(145484,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145484,34.52,0.2,80.2,69522,74.4,NULL,NULL,'ESO 526- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145485,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145485,34.67,0.46,85.9,69522,NULL,NULL,'Malmquist cor.','ESO 526- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145486,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145486,33.95,0.69,61.6,69523,100,NULL,'mid-IR','UGC 11489',NULL,'2013ApJ...771...88L',2013,1,1.2,NULL,'G',0.000017,NULL,'14.5',0.7,'Scd:',NULL,NULL,NULL,NULL,1,298.009333,4.77903,0.841,NULL,54144179703,846002807,13218793,14.5),(145487,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145487,35.76,0.5,142,69524,70,NULL,NULL,'2MASX J19520254-6048505',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,298.010541667,-60.814,0.169,NULL,49025687828,766026372,11969162,16),(145488,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145488,34.62,0.45,84,69525,NULL,NULL,'K','ESO 461- G 007',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000037,NULL,'14.31',0.7,'E2','Compact group member',NULL,NULL,NULL,1,298.036541667,-30.82575,0.497,NULL,51148878686,799201229,12487519,14.31),(145489,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145489,34.63,0.4,84.4,69525,NULL,NULL,'mean','ESO 461- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145490,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145490,36.88,0.57,238,69526,70,NULL,NULL,'2MASX J19521374-1153221',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,298.05725,-11.88958,0.705,NULL,47989221209,749831581,11716118,15.8),(145491,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145491,35.8,0.57,145,69527,70,NULL,NULL,'2MASX J19521912-1152131',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,298.079667,-11.87042,0.705,NULL,47990085768,749845090,11716329,14.6),(145492,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145492,33.79,0.59,57.3,69528,70,NULL,NULL,'ESO 073- G 013',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.39',0.8,'(R\')SAB(r)a',NULL,NULL,NULL,NULL,1,298.119333,-69.67961,0.261,NULL,49244164855,769440075,12022501,14.39),(145493,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145493,35.92,0.6,153,69529,70,NULL,NULL,'2MASX J19523251-1008361',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,298.135583333,-10.14339,0.517,NULL,47999388257,749990441,11718600,16),(145494,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145494,36.37,0.69,188,69530,70,NULL,NULL,'2MASX J19523585-2222422',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,298.1494583,-22.37839,0.425,NULL,50803817006,793809640,12403275,15.5),(145495,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145495,33.05,0.43,40.7,69531,75,NULL,'3.6 micron, color corrected','UGC 11492',NULL,'2014MNRAS.444..527S',2014,1,1.7,NULL,'G',0.000023,NULL,'13.9',1,'SAB(s)bc',NULL,NULL,NULL,NULL,1,298.16625,57.45992,0.753,NULL,53002471296,828163614,12940056,13.9),(145496,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145496,33.07,0.43,41.2,69531,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11492',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145497,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145497,33.08,0.2,41.3,69531,74.4,NULL,NULL,'UGC 11492',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145498,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145498,33.27,0.4,45,69531,NULL,NULL,NULL,'UGC 11492',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145499,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145499,33.28,0.4,45.2,69531,NULL,NULL,'Malmquist cor.','UGC 11492',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145500,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145500,33.6,0.4,52.4,69531,NULL,NULL,'mean','UGC 11492',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145501,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145501,33.71,0.47,55.3,69531,NULL,NULL,'H','UGC 11492',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145502,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145502,33.72,0.46,55.5,69531,NULL,NULL,'J','UGC 11492',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145503,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145503,33.77,0.45,56.7,69531,NULL,NULL,'K','UGC 11492',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145504,'RR Lyrae','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'N',145504,19.13,0.15,0.067,69532,NULL,NULL,'1','Sagittarius II/Laevens 5',NULL,'2015ApJ...813...44L',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145505,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145505,35.62,0.51,133,69533,70,NULL,NULL,'ESO 233- G 005',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.31',0.2,'N',NULL,NULL,NULL,NULL,1,298.1735417,-49.07258,0.213,NULL,51114735636,798667744,12479183,15.31),(145506,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145506,34.34,0.51,73.6,69534,70,NULL,NULL,'2MASX J19525518-1752190',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000133,NULL,'16.23',NULL,NULL,NULL,NULL,NULL,NULL,1,298.229958333,-17.87186,0.429,NULL,47971556087,749555563,11711805,16.23),(145507,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145507,34.28,0.8,71.8,69535,75,NULL,'MAT, I','ESO 526- G 011',NULL,'1997ApJS..109..333W',1997,1,1.85,NULL,'G',0.000033,NULL,'14.26',0.17,'Sd',NULL,NULL,NULL,NULL,1,298.23,-25.15,0.561,NULL,51274659196,801166549,12518227,14.26),(145508,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145508,34.44,0.43,77.1,69535,75,NULL,'MAT, I, raw','ESO 526- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145509,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145509,34.48,NULL,78.6,69535,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 526- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145510,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145510,34.49,NULL,79,69535,NULL,NULL,'Dipole','ESO 526- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145511,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145511,34.49,NULL,79.2,69535,NULL,NULL,'Dipole + Quadrupole','ESO 526- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145512,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145512,34.5,0.32,79.4,69535,85,NULL,'I, raw','ESO 526- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145513,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145513,34.52,0.32,80.2,69535,85,NULL,'I, inv','ESO 526- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145514,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145514,34.53,0.39,80.5,69535,NULL,NULL,NULL,'ESO 526- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145515,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145515,34.55,0.2,81.3,69535,74.4,NULL,NULL,'ESO 526- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145516,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145516,34.57,0.43,82.1,69535,75,NULL,'MAT, I, inv','ESO 526- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145517,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145517,34.58,0.38,82.6,69535,NULL,NULL,'Malmquist cor.','ESO 526- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145518,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145518,34.64,0.43,84.7,69535,75,NULL,'3.6 micron, color corrected','ESO 526- G 011',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145519,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145519,34.66,0.43,85.5,69535,75,NULL,'3.6 micron, color + selection bias corrected','ESO 526- G 011',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145520,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145520,34.72,NULL,88.1,69535,NULL,NULL,NULL,'ESO 526- G 011',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145521,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145521,34.85,0.43,93.4,69535,75,NULL,'MAT, I, cor','ESO 526- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145522,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145522,34.29,0.48,72.1,69536,70,NULL,NULL,'ESO 142- G 049',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000067,NULL,'13.81',0.8,'E4',NULL,NULL,NULL,NULL,1,298.2315,-60.98447,0.217,NULL,49026404271,766037566,11969336,13.81),(145523,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145523,34.28,0.49,71.9,69537,75,NULL,'IR','2MFGC 15174',NULL,'2011yCatp016004901K',2011,1,NULL,NULL,'G',NULL,NULL,'12.0K',NULL,NULL,NULL,NULL,NULL,NULL,1,298.233875,-25.14997,0.561,NULL,51274659147,801166549,12518227,12),(145524,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145524,36.52,0.58,201,69538,70,NULL,NULL,'2MASX J19530399-1913324',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,298.2667083,-19.22561,0.489,NULL,47929343851,748895997,11701499,15),(145525,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145525,37.39,0.55,301,69539,70,NULL,NULL,'2MASX J19530739-2130154',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.54',NULL,NULL,NULL,NULL,NULL,NULL,1,298.280875,-21.5045,0.493,NULL,47917737731,748714652,11698666,16.54),(145526,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145526,34.92,0.5,96.4,69540,70,NULL,NULL,'2MASX J19530976-1309342',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000143,NULL,'14.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,298.290625,-13.15956,0.605,NULL,47960988108,749390439,11709225,14.1),(145527,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145527,37.79,0.61,361,69541,70,NULL,NULL,'2MASX J19531218-5500051',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,298.3007917,-55.00139,0.161,NULL,49017571602,765899556,11967180,15.5),(145528,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145528,36.01,0.54,159,69542,70,NULL,NULL,'2MASX J19531559-0823096',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,298.315041667,-8.38597,0.445,NULL,47994558768,749914980,11717421,15.5),(145529,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145529,35.85,0.58,148,69543,70,NULL,NULL,'2MASX J19531806-2131444',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,298.32525,-21.52894,0.493,NULL,47917761691,748715026,11698672,14.9),(145530,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145530,36.4,0.59,190,69544,70,NULL,NULL,'2MASX J19532217-7026100',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,298.342541667,-70.43622,0.249,NULL,49212848342,768950755,12014855,16.3),(145531,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145531,34.56,0.49,81.7,69545,75,NULL,'IR','CGCG 397-014',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',NULL,NULL,'15.6',0.1,NULL,NULL,NULL,NULL,NULL,1,298.3477083,8.34783,NULL,NULL,54164287174,846316987,13223702,15.6),(145532,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145532,36.78,0.57,227,69546,70,NULL,NULL,'2MASX J19532802-2009583',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.59',NULL,NULL,NULL,NULL,NULL,NULL,1,298.366583,-20.16606,0.537,NULL,47931879163,748935611,11702118,16.59),(145533,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145533,35.94,0.57,154,69547,70,NULL,NULL,'2MASX J19533741-2113418',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.54',NULL,NULL,NULL,NULL,NULL,NULL,1,298.405583,-21.22814,0.473,NULL,47916858819,748700919,11698451,16.54),(145534,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145534,34.65,0.8,85.1,69548,75,NULL,'MAT, I','ESO 461- G 010',NULL,'1997ApJS..109..333W',1997,1,1.79,NULL,'G',0.000033,NULL,'15.93',0.22,'Sb',NULL,NULL,NULL,NULL,1,298.51825,-30.48428,0.481,NULL,51149169870,799205779,12487590,15.93),(145535,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145535,33.98,0.32,62.5,69548,85,NULL,'I, raw','ESO 461- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145536,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145536,33.99,0.43,62.9,69548,75,NULL,'MAT, I, raw','ESO 461- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145537,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145537,34,0.32,63,69548,85,NULL,'I, inv','ESO 461- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145538,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145538,34.09,0.43,65.9,69548,75,NULL,'MAT, I, inv','ESO 461- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145539,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145539,34.24,NULL,70.5,69548,NULL,NULL,NULL,'ESO 461- G 010',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145540,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145540,34.43,0.43,77.1,69548,75,NULL,'MAT, I, cor','ESO 461- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145541,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145541,34.51,0.49,79.8,69548,75,NULL,'IR','ESO 461- G 010',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145542,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145542,34.69,NULL,86.5,69548,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 461- G 010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145543,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145543,34.7,NULL,86.9,69548,NULL,NULL,'Dipole + Quadrupole','ESO 461- G 010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145544,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145544,34.7,NULL,87.3,69548,NULL,NULL,'Dipole','ESO 461- G 010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145545,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145545,34.8,0.41,91.3,69548,NULL,NULL,'Malmquist cor.','ESO 461- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145546,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145546,34.94,0.38,97.4,69548,NULL,NULL,NULL,'ESO 461- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145547,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145547,34.98,0.2,99.1,69548,74.4,NULL,NULL,'ESO 461- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145548,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145548,35.18,0.53,108,69549,70,NULL,NULL,'2MFGC 15190',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,'(RL)S0^0',NULL,NULL,NULL,NULL,1,298.5394583,-66.01142,0.221,NULL,49238859945,769357186,12021206,16.2),(145549,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145549,36.07,0.76,163,69550,70,NULL,NULL,'2MASX J19541557-0610339',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.7R',0.1,NULL,NULL,NULL,NULL,NULL,1,298.5649583,-6.17614,0.449,NULL,47869722280,747964410,11686943,15.7),(145550,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145550,36.21,0.67,175,69551,70,NULL,NULL,'2MASX J19541812-1739309',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,298.5755417,-17.65864,0.433,NULL,47978868060,749669813,11713590,15.5),(145551,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145551,36.79,0.56,228,69552,70,NULL,NULL,'2MASX J19542259-1728599',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,298.594083,-17.48331,0.433,NULL,47978820220,749669065,11713579,15.3),(145552,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145552,31.96,0.8,24.7,69553,75,NULL,'MAT, I','IC 4901',NULL,'1997ApJS..109..333W',1997,1,4.8,NULL,'G',0.00001,NULL,'12.29',3.2,'SAB(r)c        LINER','in a pair',NULL,NULL,NULL,1,298.598041667,-58.71356,0.129,NULL,49034381567,766162211,11971284,12.29),(145553,'Tully est','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145553,32.16,0.8,27.1,69553,75,NULL,NULL,'IC 4901',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145554,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145554,31.26,0.36,17.9,69553,NULL,NULL,NULL,'IC 4901',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145555,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145555,31.26,0.4,17.9,69553,73,NULL,'opt','IC 4901',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145556,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145556,31.38,0.43,18.9,69553,75,NULL,'MAT, I, raw','IC 4901',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145557,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145557,31.51,0.43,20,69553,75,NULL,'MAT, I, inv','IC 4901',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145558,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145558,31.65,0.32,21.4,69553,85,NULL,'I, raw','IC 4901',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145559,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145559,31.68,0.32,21.7,69553,85,NULL,'I, inv','IC 4901',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145560,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145560,31.77,0.43,22.6,69553,75,NULL,'MAT, I, cor','IC 4901',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145561,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145561,32.06,0.45,25.9,69553,NULL,NULL,'K','IC 4901',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145562,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145562,32.09,0.47,26.2,69553,NULL,NULL,'H','IC 4901',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145563,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145563,32.11,0.46,26.4,69553,NULL,NULL,'J','IC 4901',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145564,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145564,32.16,0.4,27.1,69553,NULL,NULL,'mean','IC 4901',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145565,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145565,35.45,0.5,123,69554,70,NULL,NULL,'AM 1950-471',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'14.2R',NULL,'COMPACT',NULL,NULL,NULL,NULL,1,298.60425,-47.04147,0.145,NULL,51121146760,798767918,12480748,14.2),(145566,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:04','1','SN 1962J','R',145566,32.54,NULL,32.2,69555,NULL,NULL,'Photographic','NGC 6835',NULL,'1988SSRv...48....1R',1988,1,2.3,NULL,'G',0.00003,NULL,'13.41',0.5,'SB(s)a? sp','in a pair',NULL,NULL,NULL,1,298.637291667,-12.56758,0.537,NULL,47961585608,749399775,11709371,13.41),(145567,'Tully est','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145567,31.79,0.8,22.8,69555,75,NULL,'B','NGC 6835',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145568,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145568,30.52,0.39,12.7,69555,73,NULL,'opt','NGC 6835',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145569,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145569,36.06,0.82,163,69556,70,NULL,NULL,'2MASX J19543755-0323485',NULL,'2014MNRAS.445.2677S',2014,1,0.1,NULL,'G',0.00015,NULL,'15.7R',0.1,'E',NULL,NULL,NULL,NULL,1,298.6565417,-3.39683,0.573,NULL,47900036359,748438068,11694344,15.7),(145570,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145570,35.73,0.6,140,69557,70,NULL,NULL,'ESO 526- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'14.8R',0.4,'Sa:',NULL,NULL,NULL,NULL,1,298.661583,-25.33472,0.565,NULL,51275318031,801176844,12518388,14.8),(145571,'Tully est','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145571,31.84,0.8,23.3,69558,75,NULL,NULL,'NGC 6836',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.00002,NULL,'13.40',1.3,'SABm','in a pair',NULL,NULL,NULL,1,298.666916667,-12.68794,0.549,NULL,47961593149,749399892,11709373,13.4),(145572,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145572,34.23,0.51,70.2,69559,70,NULL,NULL,'2MASX J19545644-0628535',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.3R',0.5,'HII',NULL,NULL,NULL,NULL,1,298.735125,-6.48153,0.505,NULL,47869754850,747964919,11686951,13.3),(145573,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145573,34.09,0.47,65.8,69560,70,NULL,NULL,'ESO 526- G 016',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'15',0.8,'(R\'_1R\'_2)SB(s)a',NULL,NULL,NULL,NULL,1,298.8029583,-23.27289,0.485,NULL,50805562548,793836914,12403701,15),(145574,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145574,34.33,0.8,73.4,69561,75,NULL,'MAT, I','ESO 185- G 026',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'15.81',0.3,'Sab: sp',NULL,NULL,NULL,NULL,1,298.828166667,-54.99306,0.173,NULL,49017083386,765891927,11967061,15.81),(145575,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145575,34.25,0.43,70.7,69561,75,NULL,'MAT, I, raw','ESO 185- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145576,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145576,34.26,0.32,71,69561,85,NULL,'I, raw','ESO 185- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145577,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145577,34.3,0.32,72.3,69561,85,NULL,'I, inv','ESO 185- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145578,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145578,34.33,0.43,73.6,69561,75,NULL,'MAT, I, cor','ESO 185- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145579,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145579,34.44,0.43,77.3,69561,75,NULL,'MAT, I, inv','ESO 185- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145580,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145580,34.46,0.4,77.9,69561,NULL,NULL,'mean','ESO 185- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145581,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145581,34.49,0.49,79,69561,75,NULL,'IR','ESO 185- G 026',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145582,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145582,34.51,0.47,79.8,69561,NULL,NULL,'H','ESO 185- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145583,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145583,34.58,0.45,82.4,69561,NULL,NULL,'K','ESO 185- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145584,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145584,36.59,0.59,208,69562,70,NULL,NULL,'2MASX J19552055-0551458',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'14.9R',0.2,NULL,NULL,NULL,NULL,NULL,1,298.835583333,-5.86275,0.465,NULL,47899175151,748424611,11694134,14.9),(145585,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145585,37,0.6,251,69563,70,NULL,NULL,'2MASX J19552294-2135014',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,298.845625,-21.58375,0.457,NULL,50803740412,793808443,12403256,15.4),(145586,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145586,36.23,0.67,176,69564,70,NULL,NULL,'2MASX J19552677-5509199',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,'E/S0',NULL,NULL,NULL,NULL,1,298.861625,-55.15556,0.149,NULL,49017173302,765893332,11967083,16.7),(145587,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145587,37.09,0.65,262,69565,70,NULL,NULL,'2MASX J19554294-0623046',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,298.928875,-6.38456,0.485,NULL,47991245864,749863216,11716612,15.6),(145588,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145588,36.37,0.57,188,69566,70,NULL,NULL,'2MASX J19554352-0432496',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,298.931417,-4.54714,0.521,NULL,47891090728,748298292,11692160,15.9),(145589,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145589,35.23,0.62,111,69567,70,NULL,NULL,'2MASX J19555392-1225091',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,298.97475,-12.41917,0.529,NULL,47957965166,749343205,11708487,15.2),(145590,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145590,35.97,0.67,156,69568,70,NULL,NULL,'2MASX J19560281-0517276',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.0117083,-5.29103,0.485,NULL,47899344935,748427264,11694176,15.9),(145591,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:04','1','SN 2002do',NULL,145591,33.53,0.24,50,69569,74.2,NULL,'SALT 2','MCG +07-41-001',0.015881,'2010ApJ...716..712A',2010,1,0.4,'abs(b) < 10 degrees.','G',0.000193,NULL,'13.2B',0.4,'E1:',NULL,NULL,NULL,NULL,1,299.053583333,40.43397,NULL,NULL,54976266075,859004157,13421939,13.2),(145592,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:04','1','SN 2002do',NULL,145592,34.12,0.09,66.7,69569,74.4,NULL,NULL,'MCG +07-41-001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145593,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:04','1','SN 2002do',NULL,145593,34.2,0.21,68,69569,70,NULL,'SALT 2','MCG +07-41-001',0.015881,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145594,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:04','1','SN 2002do',NULL,145594,34.31,0.22,71.5,69569,65,NULL,'MLCS31','MCG +07-41-001',0.015881,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145595,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:04','1','SN 2002do',NULL,145595,34.32,0.23,71.8,69569,65,NULL,'SALT','MCG +07-41-001',0.015881,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145596,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:04','1','SN 2002do',NULL,145596,34.34,0.23,72.6,69569,65,NULL,'MLCS17','MCG +07-41-001',0.015881,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145597,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:04','1','SN 2002do',NULL,145597,34.45,0.3,76.5,69569,65,NULL,'SALT2','MCG +07-41-001',0.015881,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145598,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145598,36.15,0.72,169,69570,70,NULL,NULL,'2MASX J19561309-1638569',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.054583,-16.64919,0.481,NULL,47982446006,749725718,11714464,15.3),(145599,'D-Sigma','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145599,32.16,0.4,27.1,69571,75,NULL,'Edat, raw','ESO 185- G 027',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000123,NULL,'13.8',1,'SAB0-',NULL,NULL,NULL,NULL,1,299.060417,-56.91031,0.129,NULL,49053941929,766467842,11976060,13.8),(145600,'D-Sigma','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145600,32.35,0.4,29.6,69571,75,NULL,'Edat, cor','ESO 185- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145601,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145601,36.13,0.72,168,69572,70,NULL,NULL,'ESO 526- G 018 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,NULL,0.6,'S0 pec',NULL,NULL,NULL,NULL,1,299.121333,-25.92108,0.565,NULL,51274576482,801165257,12518207,NULL),(145602,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145602,37.14,0.54,268,69573,70,NULL,NULL,'2MASX J19562991-2056117',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.31',NULL,NULL,NULL,NULL,NULL,NULL,1,299.124667,-20.93669,0.497,NULL,47922077083,748782454,11699725,16.31),(145603,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145603,34.14,0.43,67.4,69574,75,NULL,'3.6 micron, color + selection bias corrected','ESO 339- G 008',NULL,'2014MNRAS.444..527S',2014,1,1.2,NULL,'G',0.000027,NULL,'14.76',0.4,'Sa:            HII',NULL,NULL,NULL,NULL,1,299.143416667,-38.10039,0.369,NULL,51184232031,799753625,12496150,14.76),(145604,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145604,34.2,0.43,69.2,69574,75,NULL,'3.6 micron, color corrected','ESO 339- G 008',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145605,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145605,34.38,0.47,75.2,69574,NULL,NULL,'H','ESO 339- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145606,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145606,34.42,0.45,76.4,69574,NULL,NULL,'K','ESO 339- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145607,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145607,34.42,0.4,76.7,69574,NULL,NULL,'mean','ESO 339- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145608,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145608,34.43,0.2,76.9,69574,74.4,NULL,NULL,'ESO 339- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145609,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145609,34.49,0.46,79.1,69574,NULL,NULL,'J','ESO 339- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145610,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145610,34.62,0.25,84.1,69574,NULL,NULL,'Malmquist cor.','ESO 339- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145611,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145611,34.73,0.23,88.3,69574,NULL,NULL,NULL,'ESO 339- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145612,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145612,36.41,0.57,192,69575,NULL,NULL,'Malmquist cor.','2MASX J19563521-3827142',NULL,'2009ApJS..182..474S',2009,1,0.61,NULL,'G',0.000027,NULL,'15.27',NULL,'Sc',NULL,NULL,NULL,NULL,1,299.146583,-38.45394,0.361,NULL,51184241592,799753774,12496152,15.27),(145613,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145613,36.54,0.54,204,69575,NULL,NULL,NULL,'2MASX J19563521-3827142',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145614,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145614,36.58,0.2,207,69575,74.4,NULL,NULL,'2MASX J19563521-3827142',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145615,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145615,35.84,0.57,147,69576,70,NULL,NULL,'2MASX J19564116-1830077',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.1715,-18.50219,0.545,NULL,47921876616,748779322,11699676,15.4),(145616,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145616,33.53,0.48,50.9,69577,70,NULL,NULL,'6dF J1956475-602805',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'12.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.198083,-60.468,0.157,NULL,49038985353,766234146,11972408,12.5),(145617,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145617,37.24,0.6,280,69578,70,NULL,NULL,'2MASX J19564822-5235366',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,299.200958333,-52.59358,0.173,NULL,51111750680,798621104,12478454,14.2),(145618,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145618,36.55,0.49,204,69579,NULL,NULL,'Malmquist cor.','AGC 590071',NULL,'2009ApJS..182..474S',2009,1,0.66,NULL,'G',0.00003,NULL,'16.35',NULL,'Sc',NULL,NULL,NULL,NULL,1,299.2385417,-38.54714,0.353,NULL,51172753919,799574279,12493348,16.35),(145619,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145619,36.59,0.48,208,69579,NULL,NULL,NULL,'AGC 590071',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145620,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145620,36.63,0.2,212,69579,74.4,NULL,NULL,'AGC 590071',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145621,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145621,35.56,0.61,129,69580,70,NULL,NULL,'2MASX J19570594-1849267',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.274708333,-18.82406,0.581,NULL,47921820358,748778443,11699663,15.5),(145622,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145622,36.49,0.72,198,69581,70,NULL,NULL,'2MASX J19570918-6010057',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.288375,-60.16819,0.153,NULL,49039718936,766245608,11972587,15.3),(145623,'Sosies','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145623,34.03,0.44,64,69582,NULL,NULL,NULL,'UGC 11498',NULL,'2002A&A...393...57T',2002,1,3.2,NULL,'G',0.000027,NULL,'13.5',1,'SBb:',NULL,NULL,NULL,NULL,1,299.3125417,5.89042,0.849,NULL,54182077081,846594954,13228046,13.5),(145624,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145624,32.82,0.46,36.6,69582,NULL,NULL,'J','UGC 11498',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145625,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145625,32.9,0.47,38,69582,NULL,NULL,'H','UGC 11498',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145626,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145626,32.92,0.45,38.5,69582,NULL,NULL,'K','UGC 11498',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145627,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145627,33.04,0.4,40.6,69582,NULL,NULL,'mean','UGC 11498',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145628,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145628,34.25,0.59,70.8,69583,70,NULL,NULL,'ESO 399- G 006',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.00015,NULL,'15',0.4,'Sa?',NULL,NULL,NULL,NULL,1,299.325375,-32.478,0.457,NULL,51191639858,799869372,12497958,15),(145629,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',145629,33.78,0.49,57.1,69584,75,NULL,'IR','ESO 185- G 031',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.67',0.3,'SB(s)ab',NULL,NULL,NULL,NULL,1,299.342333,-55.13711,0.149,NULL,49017225205,765894143,11967095,15.67),(145630,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145630,34.01,0.41,63.5,69584,NULL,NULL,NULL,'ESO 185- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145631,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145631,34.05,0.2,64.6,69584,74.4,NULL,NULL,'ESO 185- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145632,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145632,34.08,0.4,65.4,69584,NULL,NULL,'Malmquist cor.','ESO 185- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145633,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145633,36.08,0.65,165,69585,70,NULL,NULL,'2MASX J19572970-1923312',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.373791667,-19.39203,0.505,NULL,47923281466,748801272,11700019,15.8),(145634,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145634,36.51,0.7,200,69586,70,NULL,NULL,'2MASX J19573386-0946371',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.391125,-9.777,0.561,NULL,47988208889,749815763,11715871,16),(145635,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145635,33.69,0.56,54.6,69587,NULL,NULL,NULL,'CGCG 372-002',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.00002,NULL,'15.6',0.8,'Sc             HII',NULL,NULL,NULL,NULL,1,299.400875,-0.235,0.725,NULL,47889837624,748278712,11691854,15.6),(145636,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145636,33.73,0.2,55.7,69587,74.4,NULL,NULL,'CGCG 372-002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145637,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145637,34.3,0.42,72.4,69587,NULL,NULL,'Malmquist cor.','CGCG 372-002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145638,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145638,33.94,0.47,61.4,69588,NULL,NULL,'H','ESO 339- G 011',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000023,NULL,'12.47',0.4,'Sb        LIRG;Sy2',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,299.406583333,-37.93564,0.369,NULL,51185115313,799767426,12496366,12.47),(145639,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145639,33.96,0.45,62,69588,NULL,NULL,'K','ESO 339- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145640,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145640,34.07,0.5,65.2,69588,NULL,NULL,NULL,'ESO 339- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145641,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145641,34.08,0.46,65.5,69588,NULL,NULL,'J','ESO 339- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145642,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145642,34.11,0.2,66.4,69588,74.4,NULL,NULL,'ESO 339- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145643,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145643,34.3,0.45,72.4,69588,NULL,NULL,'Malmquist cor.','ESO 339- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145644,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145644,34.45,0.4,77.6,69588,NULL,NULL,'mean','ESO 339- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145645,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145645,35.78,0.59,143,69589,70,NULL,NULL,'2MASX J19574079-5907275',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.42,-59.12431,0.125,NULL,49036569262,766196394,11971818,15.1),(145646,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145646,30.85,0.32,14.8,69590,NULL,NULL,NULL,'ESO 461- G 022',NULL,'2009ApJS..182..474S',2009,1,1.5,'Springob et al. (2005ApJS..160..149S) give v= 6032 km/sec.','G',0.000033,NULL,'15.5',0.4,'Sb-c',NULL,NULL,NULL,NULL,1,299.4317083,-30.71928,0.477,NULL,51276018350,801187786,12518559,15.5),(145647,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145647,31.41,0.24,19.1,69590,NULL,NULL,'Malmquist cor.','ESO 461- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145648,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',145648,34.54,0.49,81,69590,75,NULL,'IR','ESO 461- G 022',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145649,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145649,35.8,0.75,145,69591,70,NULL,NULL,'2MASX J19574406-5231482',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.4335417,-52.53014,0.173,NULL,51111764716,798621323,12478458,15.1),(145650,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145650,35.35,0.58,118,69592,70,NULL,NULL,'2MASX J19574703-2417517',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.4460417,-24.29775,0.581,NULL,50803228032,793800438,12403131,15.2),(145651,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145651,36.18,0.55,172,69593,70,NULL,NULL,'2MASX J19574891-5308417',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,299.45375,-53.14503,0.097,NULL,51111113790,798611152,12478299,16.4),(145652,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145652,36.03,0.75,161,69594,70,NULL,NULL,'2MASX J19575466-1902325',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.477833,-19.04244,0.473,NULL,47923928292,748811379,11700177,15.8),(145653,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145653,34.35,0.47,74,69595,70,NULL,NULL,'ESO 399- G 010',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'14.22',1.3,'SA(s)0- pec:;D',NULL,NULL,NULL,NULL,1,299.499916667,-32.66336,0.441,NULL,51174820673,799606573,12493852,14.22),(145654,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145654,35.36,0.51,118,69596,70,NULL,NULL,'2MASX J19580336-1753173',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000087,NULL,'16.08',NULL,NULL,NULL,NULL,NULL,NULL,1,299.514083333,-17.88817,0.529,NULL,47976973502,749640210,11713128,16.08),(145655,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145655,34.12,0.8,66.8,69597,75,NULL,'MAT, I','ESO 185- G 036',NULL,'1997ApJS..109..333W',1997,1,1.71,NULL,'G',0.000033,NULL,'15.76',0.16,'Sb',NULL,NULL,NULL,NULL,1,299.553333,-55.68125,0.149,NULL,49050276335,766410567,11975165,15.76),(145656,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145656,34.26,NULL,71.2,69597,NULL,NULL,NULL,'ESO 185- G 036',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145657,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145657,34.32,0.48,73.1,69597,NULL,NULL,'Malmquist cor.','ESO 185- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145658,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145658,34.44,NULL,77.2,69597,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 185- G 036',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145659,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',145659,34.45,0.49,77.7,69597,75,NULL,'IR','ESO 185- G 036',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145660,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145660,34.47,NULL,78.2,69597,NULL,NULL,'Dipole + Quadrupole','ESO 185- G 036',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145661,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145661,34.49,NULL,79.1,69597,NULL,NULL,'Dipole','ESO 185- G 036',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145662,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145662,34.55,0.43,81.1,69597,NULL,NULL,NULL,'ESO 185- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145663,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145663,34.55,0.43,81.2,69597,75,NULL,'MAT, I, raw','ESO 185- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145664,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145664,34.57,0.32,82.2,69597,85,NULL,'I, raw','ESO 185- G 036',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145665,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145665,34.59,0.2,82.8,69597,74.4,NULL,NULL,'ESO 185- G 036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145666,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145666,34.6,0.32,83.2,69597,85,NULL,'I, inv','ESO 185- G 036',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145667,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145667,34.7,0.43,86.9,69597,75,NULL,'MAT, I, inv','ESO 185- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145668,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145668,34.71,0.43,87.7,69597,75,NULL,'MAT, I, cor','ESO 185- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145669,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145669,34.55,0.8,81.4,69598,75,NULL,'MAT, I','ESO 461- G 025',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000023,NULL,'14.48',0.9,'SB(rs)c pec?   HII',NULL,NULL,NULL,NULL,1,299.57,-31.77225,0.445,NULL,51145408481,799147007,12486671,14.48),(145670,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145670,33.9,0.32,60.3,69598,85,NULL,'I, raw','ESO 461- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145671,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145671,33.95,0.32,61.7,69598,85,NULL,'I, inv','ESO 461- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145672,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145672,33.97,0.43,62.3,69598,75,NULL,'MAT, I, raw','ESO 461- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145673,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145673,34.1,0.2,66.1,69598,74.4,NULL,NULL,'ESO 461- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145674,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145674,34.19,0.43,68.8,69598,75,NULL,'MAT, I, inv','ESO 461- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145675,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145675,34.31,0.43,72.8,69598,NULL,NULL,NULL,'ESO 461- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145676,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145676,34.39,0.43,75.5,69598,75,NULL,'MAT, I, cor','ESO 461- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145677,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145677,34.45,0.41,77.7,69598,NULL,NULL,'Malmquist cor.','ESO 461- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145678,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145678,34.65,0.47,85,69598,NULL,NULL,'H','ESO 461- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145679,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145679,34.72,0.4,87.8,69598,NULL,NULL,'mean','ESO 461- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145680,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145680,34.79,0.45,90.8,69598,NULL,NULL,'K','ESO 461- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145681,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145681,34.85,0.46,93.3,69598,NULL,NULL,'J','ESO 461- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145682,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145682,34.19,0.49,68.9,69599,70,NULL,NULL,'2MASX J19581838-1916401',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00009,NULL,'15.36',NULL,NULL,NULL,NULL,NULL,NULL,1,299.57675,-19.27778,0.473,NULL,47924053500,748813335,11700208,15.36),(145683,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145683,34.92,0.5,96.6,69600,NULL,NULL,'Malmquist cor.','ESO 399- G 011',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'16.11',0.3,'S...',NULL,NULL,NULL,NULL,1,299.587875,-36.41192,0.357,NULL,51187162500,799799414,12496865,16.11),(145684,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145684,35.27,0.43,113,69600,NULL,NULL,NULL,'ESO 399- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145685,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145685,35.31,0.2,115,69600,74.4,NULL,NULL,'ESO 399- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145686,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145686,35.72,0.55,139,69601,70,NULL,NULL,'2MASX J19582674-1549163',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,299.6115,-15.82117,0.513,NULL,47980035272,749688051,11713875,14.5),(145687,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145687,36.21,0.63,174,69602,70,NULL,NULL,'2MASX J19582797-0706497',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,299.616667,-7.11378,0.497,NULL,48037865530,750591648,11727994,14.4),(145688,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145688,36.79,0.61,228,69603,70,NULL,NULL,'2MASX J19583063-5237393',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,299.62775,-52.62761,0.173,NULL,51111588989,798618577,12478415,16.5),(145689,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145689,36.5,0.52,200,69604,70,NULL,NULL,'FAIRALL 0877',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.649125,-52.58603,0.173,NULL,51111555318,798618051,12478407,13.6),(145690,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145690,36.02,0.63,160,69605,70,NULL,NULL,'2MASX J19584348-5238234',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.6810417,-52.63978,0.173,NULL,51111585187,798618518,12478414,15.3),(145691,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145691,36.66,0.53,215,69606,70,NULL,NULL,'2MASX J19585126-1152462',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.6I',0.5,NULL,NULL,NULL,NULL,NULL,1,299.713625,-11.87956,0.581,NULL,47987905681,749811026,11715797,13.6),(145692,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145692,36.31,0.67,183,69607,70,NULL,NULL,'2MASX J19585203-5229234',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.7167083,-52.48981,0.169,NULL,51111545690,798617901,12478404,15.1),(145693,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1990T',NULL,145693,35.38,0.16,114,69608,74.2,NULL,'SALT 2','2MASX J19585927-5615279',0.040485,'2010ApJ...716..712A',2010,1,1.3,NULL,'G',0.00015,NULL,'14.75',0.7,'SA(s)0^0^?',NULL,NULL,NULL,NULL,1,299.7470417,-56.25794,0.145,NULL,49054084855,766470075,11976094,14.75),(145694,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1990T',NULL,145694,36.19,0.15,166,69608,70,NULL,'SALT 2','2MASX J19585927-5615279',0.040485,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145695,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1990T',NULL,145695,36.12,0.09,167,69608,74.4,NULL,NULL,'2MASX J19585927-5615279',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145696,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1990T',NULL,145696,36.18,0.12,172,69608,70.8,NULL,NULL,'2MASX J19585927-5615279',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145697,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1990T',NULL,145697,36.32,0.03,177,69608,72,NULL,NULL,'2MASX J19585927-5615279',0.04,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145698,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1990T',NULL,145698,36.2,0.33,180,69608,67,NULL,NULL,'2MASX J19585927-5615279',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145699,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1990T',NULL,145699,36.37,0.08,181,69608,70,NULL,'SALT','2MASX J19585927-5615279',0.04,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145700,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1990T',NULL,145700,36.38,0.19,182,69608,65,NULL,NULL,'2MASX J19585927-5615279',0.04,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145701,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1990T',NULL,145701,36.32,0.16,184,69608,60,NULL,'M(V) = -19.47 mag','2MASX J19585927-5615279',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145702,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1990T',NULL,145702,36.32,0.15,184,69608,60,NULL,'M(I) = -19.19 mag','2MASX J19585927-5615279',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145703,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1990T',NULL,145703,36.34,0.21,185,69608,60,NULL,'M(B) = -19.48 mag','2MASX J19585927-5615279',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145704,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1990T',NULL,145704,36.56,0.17,189,69608,65,NULL,'MLCS2k2','2MASX J19585927-5615279',0.04,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145705,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1990T',NULL,145705,36.63,0.14,212,69608,60,NULL,NULL,'2MASX J19585927-5615279',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145706,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145706,35.77,0.49,142,69609,NULL,NULL,'Malmquist cor.','2MASX J19590008-3759096',NULL,'2009ApJS..182..474S',2009,1,0.64,NULL,'G',0.000027,NULL,'14.19',NULL,'Sbc',NULL,NULL,NULL,NULL,1,299.750375,-37.986,0.357,NULL,51173249181,799582018,12493469,14.19),(145707,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145707,36.06,0.43,163,69609,NULL,NULL,NULL,'2MASX J19590008-3759096',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145708,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145708,36.1,0.2,166,69609,74.4,NULL,NULL,'2MASX J19590008-3759096',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145709,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',145709,33.93,0.49,61,69610,75,NULL,'IR','ESO 339- G 013',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000027,NULL,'15.53',0.3,'Sb:',NULL,NULL,NULL,NULL,1,299.771916667,-38.01089,0.357,NULL,51173249849,799582028,12493469,15.53),(145710,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145710,34.73,0.4,88.5,69610,NULL,NULL,'Malmquist cor.','ESO 339- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145711,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145711,34.94,0.36,97.4,69610,NULL,NULL,NULL,'ESO 339- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145712,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145712,34.98,0.2,99.1,69610,74.4,NULL,NULL,'ESO 339- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145713,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145713,35.87,0.61,149,69611,NULL,NULL,'Malmquist cor.','2MASX J19590607-3829136',NULL,'2009ApJS..182..474S',2009,1,0.42,NULL,'G',0.000023,NULL,'15.24',NULL,'Sc',NULL,NULL,NULL,NULL,1,299.775333,-38.48719,0.357,NULL,51173486901,799585732,12493527,15.24),(145714,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145714,36.02,0.57,160,69611,NULL,NULL,NULL,'2MASX J19590607-3829136',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145715,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145715,36.06,0.2,163,69611,74.4,NULL,NULL,'2MASX J19590607-3829136',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145716,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145716,35.9,0.56,151,69612,70,NULL,NULL,'2MASX J19590667-7503320',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,299.778,-75.059,0.301,NULL,48502465744,757851027,11841422,17.1),(145717,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145717,36.83,0.54,232,69613,70,NULL,NULL,'2MASX J19591166-5942399',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.798625,-59.711,0.145,NULL,49039138363,766236536,11972445,15.3),(145718,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145718,35.35,0.51,118,69614,70,NULL,NULL,'CGCG 372-005',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5',NULL,NULL,NULL,NULL,NULL,NULL,1,299.844916667,-0.38039,0.649,NULL,47888816237,748262753,11691605,15.5),(145719,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145719,35.31,0.57,115,69615,70,NULL,NULL,'2MASX J19592803-4345535',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.866708333,-43.76489,0.165,NULL,51214096986,800220265,12503441,15.1),(145720,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145720,35.88,0.68,150,69616,NULL,NULL,'Malmquist cor.','AGC 590074',NULL,'2009ApJS..182..474S',2009,1,0.41,NULL,'G',0.000033,NULL,'16.24',NULL,'Sc',NULL,NULL,NULL,NULL,1,299.883333,-38.32472,0.361,NULL,51173513304,799586145,12493533,16.24),(145721,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145721,35.9,0.68,151,69616,NULL,NULL,NULL,'AGC 590074',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145722,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145722,35.94,0.2,154,69616,74.4,NULL,NULL,'AGC 590074',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145723,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145723,33.65,0.47,53.7,69617,NULL,NULL,'H','CGCG 423-002',NULL,'2007A&A...465...71T',2007,1,0.67,NULL,'G',0.000107,NULL,'14.9',0.56,'Spiral',NULL,NULL,NULL,NULL,1,299.932417,14.76544,NULL,NULL,54074393223,844912394,13201756,14.9),(145724,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145724,33.81,0.46,57.9,69617,NULL,NULL,'J','CGCG 423-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145725,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145725,33.83,0.4,58.2,69617,NULL,NULL,'mean','CGCG 423-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145726,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145726,33.88,0.45,59.8,69617,NULL,NULL,'K','CGCG 423-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145727,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145727,35.46,0.5,124,69618,70,NULL,NULL,'2MASX J19594927-0002155',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.955333,-0.03775,0.665,NULL,47888889633,748263900,11691623,14.9),(145728,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145728,35.62,0.57,133,69619,70,NULL,NULL,'2MASX J19595082-1141219',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.96175,-11.68944,0.569,NULL,47987988587,749812321,11715817,14.5),(145729,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145729,37.29,0.64,287,69620,70,NULL,NULL,'2MASX J19595165-5343326',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,299.965333,-53.72575,0.193,NULL,51108219396,798565928,12477592,16.5),(145730,'BL Lac Luminosity','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145730,37.09,NULL,250,69621,NULL,NULL,NULL,'2MASX J19595975+6508547',0.047,'2005ApJ...635..173S',2005,1,NULL,'TXS codes: model(N);confusion(X);lobes(W)','G',NULL,NULL,'14.71',NULL,'E              BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,299.999375,65.14853,0.561,NULL,53638983062,838109110,13095454,14.71),(145731,'GeV TeV ratio','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145731,34.79,NULL,90.6,69621,72,NULL,NULL,'2MASX J19595975+6508547',NULL,'2010MNRAS.405L..76P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145732,'GeV TeV ratio','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',145732,37.24,0.74,281,69621,72,NULL,NULL,'2MASX J19595975+6508547',NULL,'2011arXiv1111.0913P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145733,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145733,37.16,0.58,271,69622,70,NULL,NULL,'2MASX J20000272-5244274',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,300.0112083,-52.74092,0.161,NULL,51111410779,798615793,12478371,15.8),(145734,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145734,34.64,0.51,84.7,69623,70,NULL,NULL,'ESO 461- G 029',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000027,NULL,'15.07',0.3,'SAB(r)ab?',NULL,NULL,NULL,NULL,1,300.014667,-32.08481,0.445,NULL,51296350594,801505478,12523523,15.07),(145735,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145735,32.88,0.22,37.1,69624,74.2,NULL,'SALT 2','IC 4919',0.01422,'2010ApJ...716..712A',2010,1,1.5,NULL,'G',0.000027,NULL,'14.98',0.7,'SB(s)dm pec','Pair member (points to parent)',NULL,NULL,NULL,1,300.0377083,-55.37339,0.149,NULL,49049987424,766406053,11975094,14.98),(145736,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145736,33.58,0.08,52,69624,74.4,NULL,NULL,'IC 4919',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145737,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145737,33.65,0.15,53.7,69624,60,NULL,'M(V) = -19.47 mag','IC 4919',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145738,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145738,33.7,0.16,54.2,69624,70,NULL,'SALT','IC 4919',0.01422,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145739,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145739,33.68,0.14,54.5,69624,60,NULL,'M(B) = -19.48 mag','IC 4919',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145740,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145740,33.7,0.19,55,69624,60,NULL,'M(I) = -19.19 mag','IC 4919',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145741,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145741,33.74,0.21,55.3,69624,70,NULL,'SALT 2','IC 4919',0.01422,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145742,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145742,33.78,0.25,56.2,69624,72,NULL,NULL,'IC 4919',0.01422,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145743,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145743,33.78,0.03,56.3,69624,72,NULL,NULL,'IC 4919',0.01422,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145744,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145744,33.86,0.26,58.3,69624,65,NULL,'SALT2','IC 4919',0.01422,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145745,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145745,33.9,0.06,60.3,69624,65,NULL,'LCS','IC 4919',NULL,'1995ApJ...445L..91R',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145746,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145746,33.94,0.17,61.4,69624,70.8,NULL,NULL,'IC 4919',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145747,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145747,34.01,0.1,61.5,69624,65,NULL,'MLCS2k2','IC 4919',0.01422,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145748,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145748,33.99,0.24,62,69624,65,NULL,'MLCS31','IC 4919',0.01422,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145749,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145749,34,0.24,62.3,69624,65,NULL,'MLCS17','IC 4919',0.01422,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145750,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145750,34.04,0.14,64.3,69624,60,NULL,NULL,'IC 4919',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145751,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145751,34.13,0.25,66.1,69624,65,NULL,NULL,'IC 4919',0.01422,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145752,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145752,34.16,0.09,67,69624,65,NULL,'MLCS','IC 4919',0.01422,'1996ApJ...473..588R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145753,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145753,34.15,0.08,67.6,69624,65,NULL,'Snapshot','IC 4919',NULL,'1996ApJ...473...88R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145754,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145754,34.19,0.25,68.9,69625,74.4,NULL,NULL,'IC 4926',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000022,NULL,'13.85',1,'E?',NULL,NULL,NULL,NULL,1,300.050625,-38.57858,0.357,NULL,51173651288,799588301,12493567,13.85),(145755,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145755,34.59,0.4,82.7,69625,NULL,NULL,'mean','IC 4926',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145756,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145756,34.82,0.45,92,69625,NULL,NULL,'K','IC 4926',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145757,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145757,36.15,0.58,170,69626,70,NULL,NULL,'2MASX J20002488-6048263',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.2I',0.4,NULL,NULL,NULL,NULL,NULL,1,300.103583,-60.80736,0.149,NULL,49038350386,766224224,11972253,14.2),(145758,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145758,34.54,0.14,81.1,69627,70,NULL,NULL,'ABELL 3656',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I-II   [BM];I  [A]',NULL,NULL,NULL,NULL,1,300.1337917,-38.52864,0.357,NULL,51173640079,799588126,12493564,NULL),(145759,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145759,34.25,0.47,70.8,69628,NULL,NULL,'H','ESO 399- G 014',NULL,'2007A&A...465...71T',2007,1,2.2,NULL,'G',0.000003,NULL,'13.60',1.9,'SA(s)c pec     HII',NULL,NULL,NULL,NULL,1,300.147833333,-34.77756,0.373,NULL,51177602068,799650032,12494531,13.6),(145760,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145760,34.31,0.4,72.7,69628,NULL,NULL,'mean','ESO 399- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145761,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145761,34.41,0.46,76.1,69628,NULL,NULL,'J','ESO 399- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145762,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145762,34.62,0.44,84.1,69629,NULL,NULL,NULL,'2MASX J20003567-3837350',NULL,'2009ApJS..182..474S',2009,1,0.52,NULL,'G',0.000033,NULL,'15.27',NULL,'Sc',NULL,NULL,NULL,NULL,1,300.14875,-38.62642,0.357,NULL,51173647563,799588243,12493566,15.27),(145763,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145763,34.66,0.2,85.5,69629,74.4,NULL,NULL,'2MASX J20003567-3837350',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145764,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145764,34.67,0.43,85.9,69629,NULL,NULL,'Malmquist cor.','2MASX J20003567-3837350',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145765,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145765,35.48,0.54,125,69630,70,NULL,NULL,'2MASX J20003752-6114583',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'13.3I',0.7,'(R\'_2)SB(rl)0/a',NULL,NULL,NULL,NULL,1,300.1564583,-61.24956,0.137,NULL,49025079884,766016873,11969013,13.3),(145766,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145766,35.13,0.64,106,69631,70,NULL,NULL,'2MASX J20003896-2648140',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,300.162333,-26.80386,0.557,NULL,51287151382,801361740,12521277,14.4),(145767,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145767,35.6,0.58,132,69632,70,NULL,NULL,'2MASX J20004164-5256408',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,300.173417,-52.94467,0.169,NULL,51108394848,798568669,12477635,15.6),(145768,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145768,32.53,0.22,32.1,69633,NULL,NULL,'I','NGC 6869',NULL,'2001ApJ...546..681T',2001,1,1.5,NULL,'G',0.000083,NULL,'13.11',1.3,'S0',NULL,NULL,NULL,NULL,1,300.1767083,66.22753,0.605,NULL,53576150878,837127357,13080114,13.11),(145769,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145769,32.57,0.14,32.7,69633,74.4,NULL,NULL,'NGC 6869',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145770,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145770,32.44,0.45,30.8,69633,NULL,NULL,'K','NGC 6869',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145771,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145771,32.98,0.4,39.4,69633,NULL,NULL,'mean','NGC 6869',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145772,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145772,34.13,0.25,67,69634,74.4,NULL,NULL,'IC 4931',NULL,'2013AJ....146...86T',2013,1,2.4,NULL,'G',0.000019,NULL,'12.96',1.9,'E+:','Brightest group member',NULL,NULL,NULL,1,300.209833,-38.57506,0.357,NULL,51173640506,799588132,12493564,12.96),(145773,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145773,34.54,0.14,81.1,69634,70,NULL,'ABELL 3656, BGC','IC 4931',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145774,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145774,34.44,0.25,77.3,69635,74.4,NULL,NULL,'2MASX J20005562-3841481',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000014,NULL,'13.9R',NULL,'S0',NULL,NULL,NULL,NULL,1,300.231833,-38.69664,0.329,NULL,51173619366,799587802,12493559,13.9),(145775,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145775,36.23,0.66,176,69636,70,NULL,NULL,'ESO 595- G 006',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'13.9I',0.7,'S...',NULL,NULL,NULL,NULL,1,300.233625,-18.8315,0.365,NULL,47920266043,748754156,11699283,13.9),(145776,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145776,33.7,0.48,54.9,69637,70,NULL,NULL,'2MASX J20005660-5537536',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00007,NULL,'14.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,300.2357083,-55.63158,0.149,NULL,49050031678,766406744,11975105,14.8),(145777,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145777,35.91,0.41,152,69638,NULL,NULL,'Malmquist cor.','ESO 339- G 024',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000023,NULL,'15.57',0.2,'Sb:',NULL,NULL,NULL,NULL,1,300.236,-38.34697,0.361,NULL,51173411860,799584560,12493508,15.57),(145778,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145778,36.18,0.36,172,69638,NULL,NULL,NULL,'ESO 339- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145779,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145779,36.22,0.2,175,69638,74.4,NULL,NULL,'ESO 339- G 024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145780,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145780,34.68,0.47,86.1,69639,70,NULL,NULL,'IC 4923',NULL,'2014MNRAS.445.2677S',2014,1,1,'1984MNRAS.210...69F has V = 6700: +- 200 km/s.','G',0.00015,NULL,'14.50',0.9,'(RL)SB(l)0^0',NULL,NULL,NULL,NULL,1,300.2390417,-52.63167,0.161,NULL,51111420396,798615943,12478374,14.5),(145781,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145781,37.21,0.64,277,69640,70,NULL,NULL,'2MASX J20010021-5232339',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,300.2509583,-52.54272,0.161,NULL,51111427649,798616057,12478375,16.7),(145782,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145782,37.2,0.81,276,69641,70,NULL,NULL,'2MASX J20010208-5228539',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,300.258625,-52.48164,0.153,NULL,51111426181,798616034,12478375,15.3),(145783,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145783,34.84,0.49,92.7,69642,70,NULL,NULL,'MCG -03-51-001',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000087,NULL,'15.5',0.4,'SA(rl)b',NULL,NULL,NULL,NULL,1,300.2612917,-17.05239,0.441,NULL,47978465194,749663518,11713492,15.5),(145784,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145784,34.46,0.51,77.8,69643,70,NULL,NULL,'ESO 073- G 018',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000077,NULL,'14.82',0.3,'S0?',NULL,NULL,NULL,NULL,1,300.269083,-71.20103,0.257,NULL,49221008776,769078262,12016847,14.82),(145785,'BL Lac Luminosity','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145785,38.24,NULL,445,69644,70,NULL,'z > 0.11','2FGL J2001.1+4352',NULL,'2013ApJ...764..135S',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,300.275,43.86667,NULL,NULL,54938899932,858420311,13412817,NULL),(145786,'BL Lac Luminosity','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145786,39.23,0.39,702,69644,70,NULL,'z = 0.18 +/- 0.04','2FGL J2001.1+4352',NULL,'2014A&A...572A.121A',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145787,'BL Lac Luminosity','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145787,39.44,NULL,772,69644,70,NULL,'z = 0.2','2FGL J2001.1+4352',NULL,'2009MNRAS.397L..55B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145788,'GeV TeV ratio','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145788,39.12,0.89,667,69644,70,NULL,'z = 0.17 +/- 0.10','2FGL J2001.1+4352',NULL,'2014A&A...572A.121A',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145789,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145789,33.81,NULL,57.9,69645,NULL,NULL,'Dipole','FGC 2265',NULL,'2010Ap&SS.325..163P',2010,1,1.39,NULL,'G',0.00002,NULL,'16.1',0.17,'Scd',NULL,NULL,NULL,NULL,1,300.295833,53.075,1.525,NULL,54921065168,858141643,13408463,16.1),(145790,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145790,33.83,NULL,58.3,69645,NULL,NULL,'Dipole + Quadrupole','FGC 2265',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145791,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145791,33.84,NULL,58.6,69645,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2265',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145792,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145792,33.93,NULL,61.1,69645,NULL,NULL,NULL,'FGC 2265',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145793,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145793,35.28,0.51,114,69646,70,NULL,NULL,'2MASX J20011210-6136446',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,300.300583333,-61.61239,0.133,NULL,49024805759,766012589,11968946,14.3),(145794,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145794,35.64,0.57,134,69647,70,NULL,NULL,'2MASX J20011324-1856579',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.13',0.3,NULL,NULL,NULL,NULL,NULL,1,300.305083,-18.94958,0.365,NULL,47920588408,748759193,11699362,16.13),(145795,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145795,35.84,0.65,147,69648,70,NULL,NULL,'2MASX J20011788-2006019',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.5I',0.5,NULL,NULL,NULL,NULL,NULL,1,300.3245,-20.10056,0.473,NULL,50811588843,793931075,12405173,13.5),(145796,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145796,36.56,0.61,205,69649,70,NULL,NULL,'2MASX J20011830-2126380',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.40',0.5,NULL,NULL,NULL,NULL,NULL,1,300.326208333,-21.44408,0.493,NULL,50815638796,793994356,12406161,16.4),(145797,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145797,36.96,0.45,247,69650,NULL,NULL,'Malmquist cor.','2MASX J20011957-3905473',NULL,'2009ApJS..182..474S',2009,1,0.54,NULL,'G',0.000023,NULL,'14.90',NULL,'Sc',NULL,NULL,NULL,NULL,1,300.331583,-39.09642,0.313,NULL,51173059079,799579048,12493422,14.9),(145798,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145798,37.11,0.42,265,69650,NULL,NULL,NULL,'2MASX J20011957-3905473',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145799,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145799,37.15,0.2,269,69650,74.4,NULL,NULL,'2MASX J20011957-3905473',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145800,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145800,35.39,0.54,119,69651,70,NULL,NULL,'ESO 185-IG 047 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.46',NULL,NULL,NULL,NULL,NULL,NULL,1,300.3317083,-52.9655,0.169,NULL,51108434345,798569286,12477645,16.46),(145801,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145801,36.18,0.56,172,69652,70,NULL,NULL,'2MASX J20012653-2120399',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.0I',0.5,NULL,NULL,NULL,NULL,NULL,1,300.360458333,-21.34444,0.489,NULL,50815645448,793994460,12406163,14),(145802,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145802,34.73,0.25,88.3,69653,74.4,NULL,NULL,'2MASX J20013057-3903483',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000014,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,300.377417,-39.06347,0.313,NULL,51173062125,799579095,12493423,14.9),(145803,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145803,36.76,0.75,225,69654,70,NULL,NULL,'2MASX J20013332-5036148',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,300.388833,-50.60414,0.173,NULL,51126718925,798854983,12482109,15.6),(145804,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145804,34.96,0.49,98,69655,70,NULL,NULL,'ESO 595- G 007',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000133,NULL,'15.71',0.2,'S0-a',NULL,NULL,NULL,NULL,1,300.4932083,-18.06178,0.369,NULL,47975209653,749612650,11712697,15.71),(145805,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145805,36.62,0.66,211,69656,70,NULL,NULL,'2MASX J20020258-7011026',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,300.510667,-70.18408,0.173,NULL,49213626775,768962918,12015045,15.8),(145806,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145806,33.51,1.13,50.4,69657,NULL,NULL,NULL,'ESO 339- G 028',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.04',0.8,'Sc',NULL,NULL,NULL,NULL,1,300.590125,-38.61464,0.329,NULL,51172991396,799577990,12493406,15.04),(145807,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145807,34.28,0.79,71.8,69657,NULL,NULL,'Malmquist cor.','ESO 339- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145808,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145808,36.36,0.51,187,69658,70,NULL,NULL,'2MASX J20022737-1017590',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.8I',0.4,NULL,NULL,NULL,NULL,NULL,1,300.614125,-10.29967,0.445,NULL,48045164331,750705692,11729776,13.8),(145809,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145809,36.73,0.63,222,69659,70,NULL,NULL,'2MASX J20023152-1045294',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.7I',0.3,NULL,NULL,NULL,NULL,NULL,1,300.631375,-10.75817,0.417,NULL,48042225955,750659780,11729059,14.7),(145810,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SDSS-II SN 17790','R',145810,40.38,0.28,1010,69660,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007jx','SN 2007jx',0.178,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,300.63675,0.37169,0.693,NULL,54116188247,845565441,13211960,NULL),(145811,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SDSS-II SN 17790','R',145811,40.74,0.23,1190,69660,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007jx','SN 2007jx',0.178,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145812,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145812,34.41,0.52,76.2,69661,70,NULL,NULL,'2MASX J20023610-5549280',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,300.650333333,-55.82453,0.161,NULL,49049623847,766400372,11975005,14.4),(145813,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145813,34.39,0.8,75.7,69662,75,NULL,'MAT, I','ESO 105- G 020',NULL,'1997ApJS..109..333W',1997,1,1.93,NULL,'G',0.000033,NULL,'15.98',0.15,'Sc',NULL,NULL,NULL,NULL,1,300.672,-64.07864,0.137,NULL,49362552861,771289888,12051404,15.98),(145814,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',145814,33.96,0.49,61.9,69662,75,NULL,'IR','ESO 105- G 020',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145815,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145815,34.04,0.37,64.2,69662,NULL,NULL,'Malmquist cor.','ESO 105- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145816,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145816,34.2,NULL,69.1,69662,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 105- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145817,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145817,34.21,NULL,69.4,69662,NULL,NULL,'Dipole + Quadrupole','ESO 105- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145818,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145818,34.22,NULL,69.7,69662,NULL,NULL,'Dipole','ESO 105- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145819,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145819,34.25,0.32,70.7,69662,85,NULL,'I, raw','ESO 105- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145820,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145820,34.26,0.32,71.1,69662,85,NULL,'I, inv','ESO 105- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145821,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145821,34.27,NULL,71.4,69662,NULL,NULL,NULL,'ESO 105- G 020',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145822,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145822,34.3,0.43,72.3,69662,75,NULL,'MAT, I, raw','ESO 105- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145823,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145823,34.35,0.32,74,69662,NULL,NULL,NULL,'ESO 105- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145824,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145824,34.39,0.2,75.5,69662,74.4,NULL,NULL,'ESO 105- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145825,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145825,34.4,0.43,75.9,69662,75,NULL,'MAT, I, inv','ESO 105- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145826,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145826,34.42,0.43,76.7,69662,75,NULL,'MAT, I, cor','ESO 105- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145827,'D-Sigma','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145827,33.49,0.21,50,69663,NULL,NULL,'GRM 15, 7 galaxies','NGC 6848',NULL,'2000ApJ...529..768K',2000,1,2.5,NULL,'G',0.000254,':','12.08',1,'Sa: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,300.696875,-56.09031,0.141,NULL,49049551373,766399240,11974988,12.08),(145828,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145828,33.38,0.21,47.4,69663,NULL,NULL,'GRM 15, 7 galaxies','NGC 6848',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145829,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145829,33.49,0.21,50,69663,NULL,NULL,'GRM 15, 7 galaxies','NGC 6848',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145830,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145830,35.73,0.51,140,69664,70,NULL,NULL,'2MASX J20024952-7905130',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,300.7062917,-79.08697,0.561,NULL,48547894968,758560858,11852513,16.2),(145831,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 2006eu',NULL,145831,33.92,0.19,59.5,69665,74.2,NULL,'SALT 2','CGCG 257-035',0.0229,'2010ApJ...716..712A',2010,1,0.4,NULL,'G',0.000163,NULL,'14.7',0.4,'E?',NULL,NULL,NULL,NULL,1,300.7077917,49.31975,NULL,NULL,54959409560,858740774,13417824,14.7),(145832,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 2006eu',NULL,145832,34.5,0.1,79.4,69665,74.4,NULL,NULL,'CGCG 257-035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145833,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145833,33.69,0.4,54.7,69666,NULL,NULL,'mean','UGC 11510',NULL,'2007A&A...465...71T',2007,1,2,NULL,'G',0.000027,NULL,'14.7',0.6,'Sd',NULL,NULL,NULL,NULL,1,300.7329583,53.88508,1.697,NULL,54920284545,858129446,13408272,14.7),(145834,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145834,33.79,0.46,57.3,69666,NULL,NULL,'J','UGC 11510',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145835,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145835,33.85,0.47,58.8,69666,NULL,NULL,'H','UGC 11510',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145836,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145836,33.89,0.45,60,69666,NULL,NULL,'K','UGC 11510',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145837,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145837,35.68,0.83,137,69667,70,NULL,NULL,'2MASX J20030121-8305310',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,300.754958333,-83.09192,0.577,NULL,48363358303,755677473,11807460,16.8),(145838,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145838,35.19,0.47,109,69668,NULL,NULL,'H','IC 1309',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000017,NULL,'12.9I',1.3,'SAB(rs)bc pec',NULL,NULL,NULL,NULL,1,300.756333,-17.23208,0.349,NULL,47978311332,749661114,11713454,12.9),(145839,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145839,35.27,0.4,113,69668,NULL,NULL,'mean','IC 1309',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145840,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145840,35.32,0.45,116,69668,NULL,NULL,'K','IC 1309',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145841,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145841,35.38,0.46,119,69668,NULL,NULL,'J','IC 1309',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145842,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145842,37.3,0.7,288,69669,70,NULL,NULL,'2MASX J20030164-1224056',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,300.756875,-12.40161,0.561,NULL,47936873094,749013642,11703338,14.6),(145843,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145843,36.02,0.67,160,69670,70,NULL,NULL,'2MASX J20030377-1318486',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.9I',0.5,NULL,NULL,NULL,NULL,NULL,1,300.7657917,-13.31356,0.541,NULL,47937200583,749018759,11703418,13.9),(145844,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145844,35.32,0.67,116,69671,70,NULL,NULL,'2MASX J20031565-6026004',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,300.815166667,-60.4335,0.097,NULL,49038705684,766229776,11972340,15.4),(145845,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145845,35.2,0.51,110,69672,70,NULL,NULL,'FAIRALL 0527',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,300.8245,-52.85178,0.185,NULL,51108068262,798563566,12477555,14),(145846,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145846,34.15,0.25,67.6,69673,74.4,NULL,NULL,'MCG -06-44-014',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000017,NULL,'14.6b',0.5,NULL,NULL,NULL,NULL,NULL,1,300.861833,-38.40533,0.329,NULL,51174573892,799602717,12493792,14.6),(145847,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145847,33.33,0.45,46.4,69674,NULL,NULL,'K','ESO 185- G 054',NULL,'2007A&A...465...71T',2007,1,3.5,NULL,'G',0.000087,NULL,'11.3',2.4,'E2','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,300.862625,-55.94717,0.141,NULL,49051484315,766429442,11975460,11.3),(145848,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145848,33.81,0.4,57.9,69674,NULL,NULL,'mean','ESO 185- G 054',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145849,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145849,33.98,0.8,62.5,69675,75,NULL,'MAT, I','IC 4933',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.00002,NULL,'12.93',1.9,'SB(rs)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,300.871,-54.97994,0.181,NULL,49048698470,766385913,11974779,12.93),(145850,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145850,33.2,0.47,43.7,69675,NULL,NULL,'H','IC 4933',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145851,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145851,33.31,0.45,45.9,69675,NULL,NULL,'K','IC 4933',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145852,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145852,33.31,0.46,45.9,69675,NULL,NULL,'J','IC 4933',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145853,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145853,33.53,0.32,50.7,69675,85,NULL,'I, raw','IC 4933',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145854,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145854,33.59,0.32,52.2,69675,85,NULL,'I, inv','IC 4933',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145855,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145855,34.07,0.4,65.1,69675,NULL,NULL,'mean','IC 4933',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145856,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145856,34.36,0.43,74.5,69675,75,NULL,'MAT, I, raw','IC 4933',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145857,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145857,34.46,0.43,78.1,69675,75,NULL,'MAT, I, cor','IC 4933',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145858,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145858,34.72,0.43,88,69675,75,NULL,'MAT, I, inv','IC 4933',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145859,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145859,33.78,0.45,57.1,69676,NULL,NULL,'K','NGC 6850',NULL,'2007A&A...465...71T',2007,1,2.1,NULL,'G',0.000067,NULL,'13.50',1.1,'SB(s)0+ pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,300.875417,-54.84478,0.201,NULL,49048676458,766385569,11974774,13.5),(145860,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145860,34.06,0.4,64.9,69676,NULL,NULL,'mean','NGC 6850',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145861,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145861,32.79,0.21,36.1,69677,NULL,NULL,'I','NGC 6851',NULL,'2001ApJ...546..681T',2001,1,2,NULL,'G',0.00005,NULL,'12.69',1.5,'E:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,300.8932083,-48.2845,0.161,NULL,51123365567,798802586,12481290,12.69),(145862,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145862,32.79,0.21,36.1,69677,NULL,NULL,NULL,'NGC 6851',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145863,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145863,32.85,0.14,37.2,69677,74.4,NULL,NULL,'NGC 6851',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145864,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145864,32.87,0.21,37.5,69677,NULL,NULL,'Malmquist cor.','NGC 6851',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145865,'D-Sigma','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145865,32.24,0.4,28,69677,75,NULL,'Edat, raw','NGC 6851',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145866,'D-Sigma','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145866,32.36,0.4,29.7,69677,75,NULL,'Edat, cor','NGC 6851',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145867,'Faber-Jackson','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145867,30.89,0.65,15.1,69677,95,NULL,'Weighted Mean','NGC 6851',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145868,'Faber-Jackson','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145868,32.08,0.81,26.1,69677,55,NULL,'Visvanathan & Sandage 1979','NGC 6851',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145869,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145869,32.4,0.41,30.2,69677,NULL,NULL,NULL,'NGC 6851',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145870,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145870,32.62,0.49,33.4,69677,70,NULL,NULL,'NGC 6851',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145871,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145871,32.76,0.41,35.7,69677,NULL,NULL,'Malmquist cor.','NGC 6851',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145872,'Tertiary','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145872,32.18,0.71,27.3,69677,95,NULL,NULL,'NGC 6851',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145873,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145873,35.95,0.46,155,69678,NULL,NULL,'Malmquist cor.','ESO 233- G 020',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000033,NULL,'15.41',0.3,'SAB(rs)a',NULL,NULL,NULL,NULL,1,300.896125,-50.08669,0.181,NULL,51134983187,798984112,12484126,15.41),(145874,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145874,36.06,0.44,163,69678,NULL,NULL,NULL,'ESO 233- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145875,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145875,36.1,0.2,166,69678,74.4,NULL,NULL,'ESO 233- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145876,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145876,36.39,0.65,190,69679,70,NULL,NULL,'2MASX J20033747-1840576',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.32',NULL,NULL,NULL,NULL,NULL,NULL,1,300.9060417,-18.68264,0.409,NULL,47920094153,748751471,11699241,16.32),(145877,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145877,32.71,0.81,34.8,69680,NULL,NULL,NULL,'ESO 185- G 057',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.92',0.2,'S...',NULL,NULL,NULL,NULL,1,300.947583333,-54.97383,0.181,NULL,49048695359,766385864,11974779,15.92),(145878,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',145878,32.94,0.49,38.8,69680,75,NULL,'IR','ESO 185- G 057',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145879,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145879,33.45,0.58,48.9,69680,NULL,NULL,'Malmquist cor.','ESO 185- G 057',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145880,'TRGB','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145880,29.18,0.1,6.85,69681,74.4,NULL,NULL,'ESO 461- G 036',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.00002,NULL,'17.0B',0.6,'dwarf Irr',NULL,NULL,NULL,NULL,1,300.989083,-31.68161,0.437,NULL,51330856603,802044634,12531947,17),(145881,'TRGB','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145881,29.45,0.1,7.76,69681,NULL,NULL,NULL,'ESO 461- G 036',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145882,'TRGB','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145882,29.47,NULL,7.83,69681,NULL,NULL,NULL,'ESO 461- G 036',NULL,'2006AJ....131.1361K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145883,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145883,36.65,0.6,214,69682,70,NULL,NULL,'2MASX J20040446-5103492',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.4,NULL,NULL,NULL,NULL,NULL,1,301.018625,-51.06367,0.169,NULL,51127481796,798866903,12482295,14.4),(145884,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145884,34.1,0.43,66.2,69683,NULL,NULL,NULL,'ESO 339- G 031',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000027,NULL,'14.31',0.4,'(R\')SB(s)a?',NULL,NULL,NULL,NULL,1,301.061,-38.16711,0.329,NULL,51174620643,799603447,12493803,14.31),(145885,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145885,34.11,0.2,66.4,69683,74.4,NULL,NULL,'ESO 339- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145886,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145886,34.38,0.38,75.1,69683,NULL,NULL,'Malmquist cor.','ESO 339- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145887,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145887,32.32,0.8,29.1,69684,75,NULL,'MAT, I','ESO 595- G 010',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000017,NULL,'15',0.7,'SB(s)dm pec:   HII',NULL,NULL,NULL,NULL,1,301.078083333,-19.06444,0.409,NULL,50810722816,793917544,12404961,15),(145888,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145888,32.23,0.4,27.9,69684,NULL,NULL,NULL,'ESO 595- G 010',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145889,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145889,32.33,0.43,29.2,69684,75,NULL,'3.6 micron, color + selection bias corrected','ESO 595- G 010',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145890,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145890,32.42,0.43,30.5,69684,75,NULL,'3.6 micron, color corrected','ESO 595- G 010',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145891,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145891,32.43,0.2,30.6,69684,74.4,NULL,NULL,'ESO 595- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145892,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145892,32.54,0.4,32.2,69684,NULL,NULL,NULL,'ESO 595- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145893,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145893,32.56,0.32,32.5,69684,85,NULL,'I, raw','ESO 595- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145894,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145894,32.57,0.32,32.6,69684,85,NULL,'I, inv','ESO 595- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145895,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',145895,32.75,0.49,35.5,69684,75,NULL,'IR','ESO 595- G 010',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145896,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145896,32.92,0.43,38.3,69684,75,NULL,'MAT, I, raw','ESO 595- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145897,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145897,32.92,0.33,38.4,69684,NULL,NULL,'Malmquist cor.','ESO 595- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145898,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145898,33,0.43,39.9,69684,75,NULL,'MAT, I, inv','ESO 595- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145899,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145899,33.26,0.43,44.8,69684,75,NULL,'MAT, I, cor','ESO 595- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145900,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145900,35.57,0.51,130,69685,70,NULL,NULL,'2MASX J20042864-1037505',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00013,NULL,'13.3I',0.6,NULL,NULL,NULL,NULL,NULL,1,301.11925,-10.63072,0.401,NULL,48045375788,750708996,11729828,13.3),(145901,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145901,34.88,0.48,94.7,69686,NULL,NULL,'Malmquist cor.','2MASX J20043370-3907119',NULL,'2009ApJS..182..474S',2009,1,0.63,NULL,'G',0.000023,NULL,'13.72',NULL,'Sab:',NULL,NULL,NULL,NULL,1,301.1405,-39.11994,0.277,NULL,51173970012,799593281,12493645,13.72),(145902,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145902,35.14,0.43,107,69686,NULL,NULL,NULL,'2MASX J20043370-3907119',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145903,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145903,35.18,0.2,109,69686,74.4,NULL,NULL,'2MASX J20043370-3907119',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145904,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145904,33.44,0.5,48.7,69687,70,NULL,NULL,'IC 4935',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000067,NULL,'14.01',0.4,'(R\')SB(r)ab','Pair member (points to parent)',NULL,NULL,NULL,1,301.142166667,-57.59817,0.093,NULL,49054860180,766482190,11976284,14.01),(145905,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145905,33.58,0.47,52.1,69688,NULL,NULL,'H','UGC 11512',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.00008,NULL,'14.38',0.5,'SB?',NULL,NULL,NULL,NULL,1,301.143833333,12.73944,NULL,NULL,54065402627,844771916,13199561,14.38),(145906,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145906,33.66,0.46,53.8,69688,NULL,NULL,'J','UGC 11512',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145907,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145907,33.66,0.45,53.9,69688,NULL,NULL,'K','UGC 11512',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145908,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145908,33.8,0.4,57.5,69688,NULL,NULL,'mean','UGC 11512',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145909,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145909,35.54,0.47,128,69689,70,NULL,NULL,'ESO 233- G 022',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000083,NULL,'14.83',0.6,'SAB(r)0^+:',NULL,NULL,NULL,NULL,1,301.154583,-50.31008,0.161,NULL,51127320685,798864385,12482256,14.83),(145910,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145910,35.68,0.49,137,69690,70,NULL,NULL,'2MASX J20043786-1849243',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.0001,NULL,'13.3I',0.5,NULL,NULL,NULL,NULL,NULL,1,301.15775,-18.8235,0.397,NULL,50809919162,793904986,12404765,13.3),(145911,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145911,34.37,0.49,74.7,69691,70,NULL,NULL,'2MASX J20045017-2142513',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000073,NULL,'15.51',0.5,NULL,NULL,NULL,NULL,NULL,1,301.209167,-21.71436,0.485,NULL,50817692292,794026442,12406663,15.51),(145912,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145912,30.35,0.43,11.8,69692,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11515',NULL,'2014MNRAS.444..527S',2014,1,1.4,NULL,'G',0.000017,NULL,'14.4',1.4,'Sd',NULL,NULL,NULL,NULL,1,301.234167,62.79806,0.621,NULL,53455741498,835245960,13050718,14.4),(145913,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145913,36.73,0.75,222,69693,70,NULL,NULL,'2MASX J20045753-1646226',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,301.239666667,-16.773,0.373,NULL,47974713792,749604903,11712576,16.1),(145914,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145914,35.72,0.5,139,69694,70,NULL,NULL,'2MASX J20051155-1250425',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,301.298125,-12.84508,0.437,NULL,47940183208,749065362,11704146,14),(145915,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145915,35.45,0.56,123,69695,NULL,NULL,'Malmquist cor.','2MASX J20051375-3910124',NULL,'2009ApJS..182..474S',2009,1,0.75,NULL,'G',0.00003,NULL,'14.55',NULL,'Sc',NULL,NULL,NULL,NULL,1,301.3072917,-39.17014,0.277,NULL,51173922659,799592541,12493633,14.55),(145916,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145916,35.77,0.48,143,69695,NULL,NULL,NULL,'2MASX J20051375-3910124',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145917,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145917,35.81,0.2,145,69695,74.4,NULL,NULL,'2MASX J20051375-3910124',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145918,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145918,35.53,0.42,127,69696,NULL,NULL,'Malmquist cor.','2MASX J20051427-3909104',NULL,'2009ApJS..182..474S',2009,1,0.85,NULL,'G',0.000023,NULL,'13.27',NULL,'Sab',NULL,NULL,NULL,NULL,1,301.309458333,-39.15289,0.277,NULL,51173976501,799593382,12493646,13.27),(145919,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145919,35.81,0.37,145,69696,NULL,NULL,NULL,'2MASX J20051427-3909104',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145920,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145920,35.85,0.2,148,69696,74.4,NULL,NULL,'2MASX J20051427-3909104',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145921,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145921,36.34,0.54,185,69697,NULL,NULL,NULL,'2MASX J20052329-3909004',NULL,'2009ApJS..182..474S',2009,1,0.43,NULL,'G',0.000027,NULL,'16.06',NULL,'Sc',NULL,NULL,NULL,NULL,1,301.3472083,-39.15014,0.277,NULL,51173977570,799593399,12493646,16.06),(145922,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145922,36.36,0.53,187,69697,NULL,NULL,'Malmquist cor.','2MASX J20052329-3909004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145923,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145923,36.38,0.2,189,69697,74.4,NULL,NULL,'2MASX J20052329-3909004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145924,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145924,36.2,0.74,174,69698,70,NULL,NULL,'2MASX J20052518-0746506',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,301.354917,-7.78072,0.369,NULL,48049344113,750771001,11730796,14.8),(145925,'BL Lac Luminosity','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145925,41.6,NULL,1630,69699,NULL,NULL,NULL,'[HB89] 2007+777',0.342,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',NULL,NULL,'16.7V',NULL,'BLLAC',NULL,NULL,'HYMORS','Flat-Spectrum Radio Source',1,301.378875,77.87864,0.481,NULL,52870037631,826094337,12907724,16.7),(145926,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145926,34.3,0.8,72.5,69700,75,NULL,'MAT, I','ESO 284- G 013',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'15.23',0.4,'Sb: sp',NULL,NULL,NULL,NULL,1,301.401333,-42.70411,0.197,NULL,51087896657,798248385,12472631,15.23),(145927,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',145927,34.4,0.15,75.9,69700,NULL,NULL,'B, Hubble-type-TF','ESO 284- G 013',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145928,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145928,34.54,0.43,80.8,69700,75,NULL,'MAT, I, raw','ESO 284- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145929,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145929,34.54,0.32,81,69700,85,NULL,'I, raw','ESO 284- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145930,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145930,34.59,0.32,82.8,69700,85,NULL,'I, inv','ESO 284- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145931,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145931,34.66,0.41,85.4,69700,NULL,NULL,'Malmquist cor.','ESO 284- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145932,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145932,34.7,0.43,87.3,69700,75,NULL,'MAT, I, cor','ESO 284- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145933,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145933,34.75,0.43,89.3,69700,75,NULL,'MAT, I, inv','ESO 284- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145934,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145934,34.89,0.37,95,69700,NULL,NULL,NULL,'ESO 284- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145935,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145935,34.93,0.2,96.8,69700,74.4,NULL,NULL,'ESO 284- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145936,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145936,35.03,0.56,101,69701,NULL,NULL,'Malmquist cor.','ESO 527- G 008',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'16.3b',0.8,'Sb-c',NULL,NULL,NULL,NULL,1,301.407667,-25.14508,0.573,NULL,51280711234,801261113,12519704,16.3),(145937,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145937,35.22,0.51,111,69701,NULL,NULL,NULL,'ESO 527- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145938,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145938,35.26,0.2,113,69701,74.4,NULL,NULL,'ESO 527- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145939,'Faber-Jackson','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145939,31.53,0.65,20.2,69702,95,NULL,'Weighted Mean','NGC 6854',NULL,'1984ApJS...56...91D',1984,1,2,NULL,'G',0.000087,NULL,'13.2b',1.3,'SAB(s)0- pec:','Parent (of companion) galaxy',NULL,NULL,NULL,1,301.411667,-54.37561,0.201,NULL,49014792650,765856135,11966502,13.2),(145940,'Faber-Jackson','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145940,32.87,0.81,37.5,69702,55,NULL,'Visvanathan & Sandage 1979','NGC 6854',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145941,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145941,34.17,0.45,68.1,69702,NULL,NULL,'K','NGC 6854',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145942,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145942,34.42,0.4,76.7,69702,NULL,NULL,'mean','NGC 6854',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145943,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145943,32.95,0.89,38.9,69703,NULL,NULL,NULL,'NGC 6851B',NULL,'2009ApJS..182..474S',2009,1,1.32,NULL,'G',NULL,NULL,'16.67',0.13,'SB(rs)d','Pair member (points to parent)',NULL,NULL,NULL,1,301.416416667,-47.97906,0.157,NULL,51123017531,798797148,12481205,16.67),(145944,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145944,33.31,0.75,46,69703,NULL,NULL,'Malmquist cor.','NGC 6851B',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145945,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145945,33.38,NULL,47.4,69703,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 6851B',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145946,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145946,33.4,NULL,47.9,69703,NULL,NULL,'Dipole + Quadrupole','NGC 6851B',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145947,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145947,33.42,NULL,48.3,69703,NULL,NULL,'Dipole','NGC 6851B',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145948,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145948,35.14,0.57,107,69704,70,NULL,NULL,'MCG -02-51-001',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'16.5',0.7,'S0',NULL,NULL,NULL,NULL,1,301.43225,-10.578,0.325,NULL,48045243648,750706932,11729795,16.5),(145949,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145949,36.66,0.65,215,69705,70,NULL,NULL,'2MASX J20054633-0101044',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,301.443041667,-1.01794,0.617,NULL,47883721485,748183148,11690361,14.9),(145950,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145950,37.68,0.73,343,69706,70,NULL,NULL,'2MASX J20054646-2142470',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,301.443625,-21.71306,0.485,NULL,50817708629,794026697,12406667,16.1),(145951,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145951,33.08,0.8,41.3,69707,75,NULL,'MAT, I','NGC 6851A',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000028,NULL,'14.83',0.5,'(R\')SB(s)m','Pair member (points to parent)',NULL,NULL,NULL,1,301.452125,-47.97825,0.137,NULL,51123046701,798797604,12481212,14.83),(145952,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145952,31.68,0.32,21.7,69707,85,NULL,'I, inv','NGC 6851A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145953,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145953,31.73,0.32,22.2,69707,85,NULL,'I, raw','NGC 6851A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145954,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145954,32.37,0.43,29.8,69707,75,NULL,'MAT, I, inv','NGC 6851A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145955,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145955,32.46,0.43,31.1,69707,75,NULL,'MAT, I, raw','NGC 6851A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145956,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145956,32.75,0.43,35.5,69707,75,NULL,'MAT, I, cor','NGC 6851A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145957,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145957,32.99,0.2,39.6,69707,74.4,NULL,NULL,'NGC 6851A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145958,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145958,33.39,0.8,47.6,69708,75,NULL,'MAT, I','IC 4936',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.53',0.8,'SB(s)d:',NULL,NULL,NULL,NULL,1,301.4675,-61.42853,0.097,NULL,49024264833,766004138,11968814,14.53),(145959,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145959,32.03,0.32,25.5,69708,85,NULL,'I, inv','IC 4936',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145960,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145960,32.05,0.32,25.7,69708,85,NULL,'I, raw','IC 4936',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145961,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145961,32.59,0.43,32.9,69708,75,NULL,'MAT, I, inv','IC 4936',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145962,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145962,32.59,0.43,33,69708,75,NULL,'MAT, I, raw','IC 4936',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145963,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145963,32.98,0.43,39.5,69708,75,NULL,'MAT, I, cor','IC 4936',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145964,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145964,33.65,0.09,53.8,69708,NULL,NULL,NULL,'IC 4936',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145965,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145965,33.63,0.49,53.3,69709,70,NULL,NULL,'NGC 6865',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000123,NULL,'14.64',0.5,'SB:0o:',NULL,NULL,NULL,NULL,1,301.485333333,-9.04092,0.317,NULL,48047347160,750739799,11730309,14.64),(145966,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145966,35.58,0.63,131,69710,70,NULL,NULL,'2MASX J20060312-2000111',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,301.5129583,-20.00303,0.485,NULL,50813739531,793964680,12405698,15),(145967,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145967,32.52,0.47,31.9,69711,NULL,NULL,'H','IC 4938',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000093,NULL,'13.40',1.3,'(R)SAB(rs)ab','in a pair',NULL,NULL,NULL,1,301.54875,-60.21161,0.049,NULL,49038117619,766220587,11972196,13.4),(145968,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145968,32.62,0.46,33.4,69711,NULL,NULL,'J','IC 4938',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145969,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145969,32.71,0.45,34.9,69711,NULL,NULL,'K','IC 4938',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145970,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145970,33.36,0.4,47,69711,NULL,NULL,'mean','IC 4938',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145971,'GRB','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145971,42.6,0.03,3310,69712,NULL,NULL,'z = 1.79 +/- 0.07','4B 941017',NULL,'2016ApJ...819...79G',2016,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,301.55,9.81,1.013,NULL,54214324764,847098824,13235919,NULL),(145972,'D-Sigma','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145972,33.51,0.4,50.4,69713,75,NULL,'Edat, raw','NGC 6849',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000043,NULL,'13.5b',1.1,'SB0-:',NULL,NULL,NULL,NULL,1,301.565083333,-40.19831,0.261,NULL,51207870022,800122969,12501921,13.5),(145973,'D-Sigma','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145973,33.85,0.4,58.8,69713,75,NULL,'Edat, cor','NGC 6849',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145974,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145974,34.14,0.8,67.2,69714,75,NULL,'MAT, I','ESO 284- G 016',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'14.07',0.8,'SA(s)c',NULL,NULL,NULL,NULL,1,301.588083,-42.76414,0.197,NULL,51087922393,798248787,12472637,14.07),(145975,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145975,33.53,0.32,50.8,69714,85,NULL,'I, raw','ESO 284- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145976,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145976,33.56,0.32,51.5,69714,85,NULL,'I, inv','ESO 284- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145977,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',145977,33.57,0.19,51.8,69714,NULL,NULL,'B, Hubble-type-TF','ESO 284- G 016',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145978,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145978,33.59,0.43,52.2,69714,75,NULL,'MAT, I, raw','ESO 284- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145979,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145979,33.75,0.43,56.2,69714,75,NULL,'MAT, I, inv','ESO 284- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145980,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145980,34.07,0.43,65.2,69714,75,NULL,'MAT, I, cor','ESO 284- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145981,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145981,35.93,0.66,153,69715,70,NULL,NULL,'2MASX J20062247-2022520',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.17',NULL,NULL,NULL,NULL,NULL,NULL,1,301.593667,-20.38117,0.489,NULL,50813883103,793966923,12405733,16.17),(145982,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145982,32.48,0.19,31.3,69716,NULL,NULL,'I','IC 4943',NULL,'2001ApJ...546..681T',2001,1,1.5,NULL,'G',0.000063,NULL,'13.61',1.1,'E pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,301.61775,-48.37561,0.141,NULL,51134082920,798970045,12483906,13.61),(145983,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145983,32.48,0.19,31.3,69716,NULL,NULL,NULL,'IC 4943',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145984,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145984,32.52,0.14,31.9,69716,74.4,NULL,NULL,'IC 4943',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145985,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145985,32.58,0.19,32.9,69716,NULL,NULL,'Malmquist cor.','IC 4943',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145986,'D-Sigma','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145986,32.24,0.4,28,69716,75,NULL,'Edat, raw','IC 4943',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145987,'D-Sigma','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145987,32.36,0.4,29.7,69716,75,NULL,'Edat, cor','IC 4943',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145988,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145988,33.42,0.41,48.2,69716,NULL,NULL,NULL,'IC 4943',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145989,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145989,33.51,0.52,50.3,69716,70,NULL,NULL,'IC 4943',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145990,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145990,33.82,0.41,57.9,69716,NULL,NULL,'Malmquist cor.','IC 4943',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145991,'Tully est','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145991,32.75,0.8,35.5,69716,75,NULL,NULL,'IC 4943',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145992,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145992,33.47,0.4,49.3,69716,NULL,NULL,'mean','IC 4943',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145993,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145993,34.05,0.45,64.6,69716,NULL,NULL,'K','IC 4943',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145994,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145994,35.4,0.49,120,69717,70,NULL,NULL,'6dF J2006344-463623',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,301.6432083,-46.60636,0.145,NULL,51092720468,798323757,12473808,15.1),(145995,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145995,33.67,0.8,54.1,69718,75,NULL,'MAT, I','IC 4929',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.29',0.4,'Sb: pec',NULL,NULL,NULL,NULL,1,301.67375,-71.68356,0.253,NULL,49224322402,769130037,12017656,14.29),(145996,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145996,33.19,0.32,43.4,69718,85,NULL,'I, raw','IC 4929',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145997,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145997,33.22,0.32,44,69718,85,NULL,'I, inv','IC 4929',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145998,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145998,33.25,0.43,44.8,69718,75,NULL,'MAT, I, raw','IC 4929',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145999,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145999,33.41,0.43,48,69718,75,NULL,'MAT, I, inv','IC 4929',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146000,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146000,33.49,0.43,50,69718,75,NULL,'MAT, I, cor','IC 4929',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146001,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',146001,33.51,0.49,50.3,69718,75,NULL,'IR','IC 4929',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146002,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146002,33.78,0.47,57,69718,NULL,NULL,'H','IC 4929',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146003,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146003,33.83,0.4,58.2,69718,NULL,NULL,'mean','IC 4929',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146004,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146004,33.83,0.1,58.5,69718,NULL,NULL,NULL,'IC 4929',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146005,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146005,33.86,0.46,59.2,69718,NULL,NULL,'J','IC 4929',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146006,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146006,33.92,0.45,60.9,69718,NULL,NULL,'K','IC 4929',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146007,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146007,34.55,0.8,81.2,69719,75,NULL,'MAT, I','IC 4912',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'15.50',0.5,'SB(rs)c',NULL,NULL,NULL,NULL,1,301.707041667,-77.3575,0.469,NULL,48524824653,758200385,11846881,15.5),(146008,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146008,33.59,0.32,52.3,69719,85,NULL,'I, raw','IC 4912',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146009,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146009,33.6,0.32,52.5,69719,85,NULL,'I, inv','IC 4912',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146010,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146010,33.88,0.43,59.8,69719,75,NULL,'MAT, I, raw','IC 4912',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146011,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146011,33.96,0.43,62,69719,75,NULL,'MAT, I, inv','IC 4912',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146012,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146012,34.08,0.43,65.5,69719,75,NULL,'MAT, I, cor','IC 4912',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146013,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146013,34.31,0.41,72.9,69719,NULL,NULL,NULL,'IC 4912',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146014,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146014,34.35,0.2,74.1,69719,74.4,NULL,NULL,'IC 4912',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146015,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146015,34.45,0.38,77.7,69719,NULL,NULL,'Malmquist cor.','IC 4912',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146016,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',146016,35.04,0.49,102,69720,75,NULL,'IR','CGCG 398-013',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',NULL,NULL,'15.7',0.1,NULL,NULL,NULL,NULL,NULL,1,301.711541667,5.65969,0.709,NULL,54184293713,846629589,13228587,15.7),(146017,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146017,34.37,0.52,74.8,69721,70,NULL,NULL,'ESO 185- G 064',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00008,NULL,'14.93',0.5,'(R)SA(r)0^+',NULL,NULL,NULL,NULL,1,301.718416667,-54.30397,0.205,NULL,49048421010,766381578,11974712,14.93),(146018,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146018,37.51,0.72,317,69722,70,NULL,NULL,'2MASX J20065478-5522456',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,301.7282917,-55.37939,0.177,NULL,49052161897,766440029,11975625,16.5),(146019,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146019,34.18,0.46,68.7,69723,70,NULL,NULL,'ESO 284- G 017',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000103,NULL,'14.24',0.6,'SAB0^-',NULL,NULL,NULL,NULL,1,301.7765,-42.81378,0.161,NULL,51087767848,798246372,12472599,14.24),(146020,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146020,34.25,0.45,70.8,69724,NULL,NULL,'K','IC 4944',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000077,NULL,'14.58',0.6,'SA(rs)0+:',NULL,NULL,NULL,NULL,1,301.786833,-54.44689,0.201,NULL,49048440839,766381888,11974717,14.58),(146021,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146021,34.49,0.4,79.1,69724,NULL,NULL,'mean','IC 4944',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146022,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146022,33.25,0.8,44.7,69725,75,NULL,'MAT, I','IC 4939',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'15.08',0.8,'Sc?',NULL,NULL,NULL,NULL,1,301.796,-60.73881,0.057,NULL,49037812683,766215823,11972122,15.08),(146023,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146023,32.84,0.32,36.9,69725,85,NULL,'I, inv','IC 4939',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146024,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146024,32.86,0.32,37.3,69725,85,NULL,'I, raw','IC 4939',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146025,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146025,33.39,0.43,47.7,69725,75,NULL,'MAT, I, inv','IC 4939',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146026,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146026,33.41,0.43,48,69725,75,NULL,'MAT, I, raw','IC 4939',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146027,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146027,33.64,0.43,53.4,69725,75,NULL,'MAT, I, cor','IC 4939',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146028,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146028,33.65,0.09,53.8,69725,NULL,NULL,NULL,'IC 4939',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146029,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146029,34.16,0.8,68.1,69726,75,NULL,'MAT, I','ESO 185- G 068',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'15.68',0.3,'SB(s)d: sp',NULL,NULL,NULL,NULL,1,301.8082083,-53.79189,0.205,NULL,51107652630,798557072,12477454,15.68),(146030,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146030,33.46,0.32,49.1,69726,85,NULL,'I, inv','ESO 185- G 068',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146031,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146031,33.46,0.32,49.2,69726,85,NULL,'I, raw','ESO 185- G 068',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146032,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146032,33.6,0.43,52.5,69726,75,NULL,'MAT, I, raw','ESO 185- G 068',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146033,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146033,33.64,0.43,53.6,69726,75,NULL,'MAT, I, inv','ESO 185- G 068',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146034,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146034,33.88,0.43,59.6,69726,75,NULL,'MAT, I, cor','ESO 185- G 068',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146035,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146035,33.95,0.48,61.7,69726,NULL,NULL,NULL,'ESO 185- G 068',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146036,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146036,33.99,0.2,62.8,69726,74.4,NULL,NULL,'ESO 185- G 068',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146037,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146037,34.1,0.45,66,69726,NULL,NULL,'Malmquist cor.','ESO 185- G 068',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146038,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146038,33.06,0.8,41,69727,75,NULL,'MAT, I','IC 4934',NULL,'1997ApJS..109..333W',1997,1,1.57,NULL,'G',0.000032,NULL,'14.94',0.22,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,301.811875,-69.47919,0.181,NULL,49212054618,768938353,12014661,14.94),(146039,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146039,33.09,0.32,41.5,69727,85,NULL,'I, raw','IC 4934',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146040,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146040,33.1,0.32,41.6,69727,85,NULL,'I, inv','IC 4934',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146041,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146041,33.33,0.43,46.3,69727,75,NULL,'MAT, I, raw','IC 4934',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146042,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146042,33.39,0.43,47.7,69727,75,NULL,'MAT, I, inv','IC 4934',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146043,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',146043,33.52,0.49,50.6,69727,75,NULL,'IR','IC 4934',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146044,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146044,33.55,0.43,51.3,69727,75,NULL,'MAT, I, cor','IC 4934',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146045,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146045,33.88,NULL,59.8,69727,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 4934',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146046,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146046,33.91,NULL,60.4,69727,NULL,NULL,'Dipole + Quadrupole','IC 4934',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146047,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146047,33.93,NULL,61.1,69727,NULL,NULL,'Dipole','IC 4934',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146048,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146048,34.82,0.61,92.2,69728,70,NULL,NULL,'2MASX J20071746-2004194',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,301.822791667,-20.07194,0.425,NULL,50813293295,793957707,12405589,14),(146049,'GCLF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146049,32.1,NULL,26.3,69729,NULL,NULL,NULL,'NGC 6861',NULL,'2015MNRAS.449..612E',2015,1,2.8,NULL,'G',0.000057,NULL,'12.12',1.8,'SA(s)0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,301.831167,-48.37022,0.141,NULL,51134135021,798970859,12483919,12.12),(146050,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146050,32.24,0.36,28.1,69729,NULL,NULL,'I','NGC 6861',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146051,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146051,32.28,0.14,28.6,69729,74.4,NULL,NULL,'NGC 6861',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146052,'Faber-Jackson','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146052,30.32,0.63,11.6,69729,95,NULL,'Michard 1979b, c','NGC 6861',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146053,'Faber-Jackson','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146053,30.86,0.46,14.9,69729,95,NULL,'Michard 1979a','NGC 6861',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146054,'Faber-Jackson','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146054,31.14,0.37,16.9,69729,95,NULL,'Weighted Mean','NGC 6861',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146055,'Faber-Jackson','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146055,34.16,0.81,67.9,69729,55,NULL,'Visvanathan & Sandage 1979','NGC 6861',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146056,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146056,33.21,0.5,43.8,69729,70,NULL,NULL,'NGC 6861',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146057,'Tertiary','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146057,32.18,0.71,27.3,69729,95,NULL,NULL,'NGC 6861',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146058,'Tully est','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146058,32.75,0.8,35.5,69729,75,NULL,'B','NGC 6861',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146059,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146059,36.91,0.56,240,69730,70,NULL,NULL,'2MASX J20072145-5305439',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,301.839375,-53.09544,0.197,NULL,51125228391,798831693,12481745,15.3),(146060,'GRB','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',146060,47.23,1.48,10700,69731,NULL,NULL,NULL,'GRB 071003',1.604,'2010JCAP...08..020W',2010,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,301.8504583,10.9475,0.825,NULL,54198479785,846851246,13232050,NULL),(146061,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146061,36.58,0.62,207,69732,70,NULL,NULL,'2MASX J20072706-2034517',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.20',0.4,NULL,NULL,NULL,NULL,NULL,1,301.862833,-20.58097,0.433,NULL,50813876765,793966824,12405731,16.2),(146062,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146062,36.49,0.81,198,69733,70,NULL,NULL,'2MASX J20073073-0705115',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.8I',0.3,NULL,NULL,NULL,NULL,NULL,1,301.8780417,-7.08661,0.365,NULL,48048872720,750763636,11730681,14.8),(146063,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SDSS-II SN 20090',NULL,146063,39.35,0.3,741,69734,70,NULL,'SN photometric redshift distance, z photo =0.191 +/- 0.032','SDSS-II SN 20090',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,301.8999583,-0.07333,0.509,NULL,47883859766,748185308,11690395,NULL),(146064,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146064,37.15,0.55,269,69735,70,NULL,NULL,'2MASX J20073610-5304259',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'14.7R',0.38,NULL,NULL,NULL,NULL,NULL,1,301.9002917,-53.07394,0.197,NULL,51125281785,798832527,12481758,14.7),(146065,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146065,32.38,0.8,29.9,69736,75,NULL,'MAT, I','ESO 595- G 014',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000007,NULL,'13.5',1.2,'SB(s)cd',NULL,NULL,NULL,NULL,1,301.905291667,-21.12519,0.449,NULL,50812675893,793948060,12405438,13.5),(146066,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146066,31.95,0.69,24.6,69736,100,NULL,'mid-IR','ESO 595- G 014',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146067,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146067,32.3,0.32,28.9,69736,85,NULL,'I, raw','ESO 595- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146068,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146068,32.33,0.32,29.2,69736,85,NULL,'I, inv','ESO 595- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146069,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146069,32.68,1.11,34.4,69736,NULL,NULL,NULL,'ESO 595- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146070,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146070,32.72,0.2,35,69736,74.4,NULL,NULL,'ESO 595- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146071,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146071,32.88,0.43,37.7,69736,75,NULL,'MAT, I, raw','ESO 595- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146072,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146072,33.05,0.43,40.7,69736,75,NULL,'MAT, I, inv','ESO 595- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146073,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146073,33.18,0.43,43.3,69736,75,NULL,'MAT, I, cor','ESO 595- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146074,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146074,33.23,0.86,44.2,69736,NULL,NULL,'Malmquist cor.','ESO 595- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146075,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146075,37.09,0.61,262,69737,70,NULL,NULL,'2MASX J20073842-0019201',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,301.910125,-0.32222,0.497,NULL,47884005098,748187579,11690430,15.6),(146076,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146076,34.23,0.47,70.3,69738,NULL,NULL,'H','ESO 461- G 043',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000027,NULL,'14.6',0.9,'SAB(rs)c:',NULL,NULL,NULL,NULL,1,301.949167,-29.81286,0.449,NULL,51332406184,802068846,12532325,14.6),(146077,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146077,34.51,0.45,79.9,69738,NULL,NULL,'K','ESO 461- G 043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146078,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146078,34.53,0.46,80.4,69738,NULL,NULL,'J','ESO 461- G 043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146079,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146079,34.83,0.4,92.3,69738,NULL,NULL,'mean','ESO 461- G 043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146080,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146080,35.8,0.51,144,69739,70,NULL,NULL,'2MASX J20074859-2015107',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.75',NULL,NULL,NULL,NULL,NULL,NULL,1,301.952625,-20.253,0.445,NULL,50813378629,793959041,12405610,15.75),(146081,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146081,36.45,0.88,195,69740,70,NULL,NULL,'2MASX J20075110-2027066',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.7I',0.3,NULL,NULL,NULL,NULL,NULL,1,301.9630417,-20.45183,0.445,NULL,50813347847,793958560,12405602,14.7),(146082,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146082,35.59,0.62,131,69741,70,NULL,NULL,'2MASX J20075166-2143583',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00014,NULL,'16.05',0.6,NULL,NULL,NULL,NULL,NULL,1,301.9655,-21.73286,0.401,NULL,50814511305,793976739,12405886,16.05),(146083,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146083,34.93,0.59,97,69742,70,NULL,NULL,'2MASX J20075197-6021185',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,301.9665,-60.35514,0.049,NULL,49029919346,766092489,11970195,14.3),(146084,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146084,36.35,0.65,186,69743,70,NULL,NULL,'2MASX J20075627-8411193',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,301.9850417,-84.18878,0.509,NULL,48384351226,756005487,11812585,17.2),(146085,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146085,34.73,0.8,88.4,69744,75,NULL,'MAT, I','ESO 461- G 044',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000027,NULL,'15.01',0.2,'Sbc: sp',NULL,NULL,NULL,NULL,1,302.021167,-29.31869,0.469,NULL,51277280544,801207508,12518867,15.01),(146086,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',146086,34.23,0.49,70.2,69744,75,NULL,'IR','ESO 461- G 044',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146087,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146087,34.28,0.43,71.7,69744,75,NULL,'MAT, I, raw','ESO 461- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146088,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146088,34.29,0.32,72.2,69744,85,NULL,'I, raw','ESO 461- G 044',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146089,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146089,34.35,0.32,74.1,69744,85,NULL,'I, inv','ESO 461- G 044',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146090,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146090,34.52,0.43,80.2,69744,75,NULL,'MAT, I, inv','ESO 461- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146091,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146091,34.64,0.47,84.6,69744,NULL,NULL,'H','ESO 461- G 044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146092,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146092,34.65,0.43,85.2,69744,75,NULL,'MAT, I, cor','ESO 461- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146093,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146093,34.73,0.45,88.1,69744,NULL,NULL,'K','ESO 461- G 044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146094,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146094,34.77,0.36,90,69744,NULL,NULL,'Malmquist cor.','ESO 461- G 044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146095,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146095,34.84,0.4,92.8,69744,NULL,NULL,'mean','ESO 461- G 044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146096,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146096,34.89,0.46,94.9,69744,NULL,NULL,'J','ESO 461- G 044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146097,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146097,34.96,0.33,98,69744,NULL,NULL,NULL,'ESO 461- G 044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146098,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146098,35.05,0.2,102,69744,74.4,NULL,NULL,'ESO 461- G 044',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146099,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146099,33.45,0.5,48.9,69745,70,NULL,NULL,'NGC 6861D',NULL,'2014MNRAS.445.2677S',2014,1,2.3,NULL,'G',0.000073,NULL,'13.38',0.8,'SA(s)0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,302.081167,-48.21142,0.137,NULL,51134294875,798973357,12483958,13.38),(146100,'Tully est','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146100,32.75,0.8,35.5,69745,75,NULL,NULL,'NGC 6861D',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146101,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146101,35.8,0.55,145,69746,70,NULL,NULL,'2MASX J20082325-2139297',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.11',NULL,NULL,NULL,NULL,NULL,NULL,1,302.097125,-21.65839,0.393,NULL,50814435604,793975556,12405868,16.11),(146102,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146102,33.63,0.8,53.1,69747,75,NULL,'MAT, I','IC 4950',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'15.13',0.4,'SB?(rs)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,302.114,-56.16183,0.165,NULL,49051069127,766422955,11975358,15.13),(146103,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146103,33.34,0.32,46.6,69747,85,NULL,'I, raw','IC 4950',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146104,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146104,33.36,0.32,47,69747,85,NULL,'I, inv','IC 4950',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146105,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146105,33.52,0.43,50.5,69747,75,NULL,'MAT, I, raw','IC 4950',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146106,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146106,33.64,0.43,53.5,69747,75,NULL,'MAT, I, inv','IC 4950',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146107,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',146107,33.69,0.49,54.8,69747,75,NULL,'IR','IC 4950',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146108,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146108,33.71,0.41,55.2,69747,NULL,NULL,NULL,'IC 4950',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146109,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146109,33.75,0.2,56.2,69747,74.4,NULL,NULL,'IC 4950',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146110,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146110,33.77,0.43,56.9,69747,75,NULL,'MAT, I, cor','IC 4950',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146111,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146111,33.9,0.38,60.1,69747,NULL,NULL,'Malmquist cor.','IC 4950',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146112,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146112,35.11,0.8,105,69748,75,NULL,'MAT, I','ESO 527- G 011',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.4b',0.5,'SA(r)c',NULL,NULL,NULL,NULL,1,302.1297917,-25.45856,0.557,NULL,51281622568,801275352,12519927,14.4),(146113,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146113,33.68,0.43,54.6,69748,75,NULL,'MAT, I, raw','ESO 527- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146114,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146114,33.9,0.32,60.2,69748,85,NULL,'I, raw','ESO 527- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146115,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146115,33.97,0.32,62.1,69748,85,NULL,'I, inv','ESO 527- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146116,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146116,33.96,0.43,62.1,69748,75,NULL,'MAT, I, inv','ESO 527- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146117,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146117,34.19,0.43,68.9,69748,75,NULL,'MAT, I, cor','ESO 527- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146118,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146118,34.64,0.42,84.8,69748,NULL,NULL,'Malmquist cor.','ESO 527- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146119,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146119,34.84,0.39,92.9,69748,NULL,NULL,NULL,'ESO 527- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146120,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146120,34.88,0.2,94.6,69748,74.4,NULL,NULL,'ESO 527- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146121,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146121,35.32,0.47,116,69748,NULL,NULL,'H','ESO 527- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146122,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146122,35.39,0.4,120,69748,NULL,NULL,'mean','ESO 527- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146123,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146123,35.4,0.45,120,69748,NULL,NULL,'K','ESO 527- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146124,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146124,35.47,0.46,124,69748,NULL,NULL,'J','ESO 527- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146125,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146125,36.02,0.89,160,69749,70,NULL,NULL,'2MASX J20083121-2004087',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.23',NULL,NULL,NULL,NULL,NULL,NULL,1,302.130083333,-20.06906,0.425,NULL,50813452297,793960192,12405628,16.23),(146126,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146126,37.36,0.77,296,69750,70,NULL,NULL,'2MASX J20083349-2016037',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,302.139583,-20.26778,0.425,NULL,50813355219,793958675,12405604,15.4),(146127,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146127,33.01,0.52,40,69751,70,NULL,NULL,'IC 4952',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000087,NULL,'14.01',0.6,'Sa:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,302.156875,-55.45367,0.177,NULL,49051809465,766434522,11975539,14.01),(146128,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146128,35.97,0.68,156,69752,70,NULL,NULL,'2MASX J20083818-5314354',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,302.1589583,-53.24314,0.205,NULL,51124548626,798821072,12481579,14.4),(146129,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146129,35.91,0.59,152,69753,70,NULL,NULL,'2MASX J20084688-2151417',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,302.19525,-21.86153,0.401,NULL,50814927696,793983245,12405988,15.2),(146130,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146130,37.25,0.69,282,69754,70,NULL,NULL,'2MASX J20085389-5428018',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'17.0b',0.2,NULL,NULL,NULL,NULL,NULL,1,302.22475,-54.46722,0.201,NULL,49048343056,766380360,11974693,17),(146131,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146131,35.15,0.63,107,69755,NULL,NULL,'Malmquist cor.','ESO 399- G 022',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.66',0.2,'S...',NULL,NULL,NULL,NULL,1,302.248667,-35.32081,0.273,NULL,51301740380,801589693,12524838,16.66),(146132,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146132,35.31,0.58,115,69755,NULL,NULL,NULL,'ESO 399- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146133,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146133,35.35,0.2,117,69755,74.4,NULL,NULL,'ESO 399- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146134,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146134,37.06,0.6,258,69756,70,NULL,NULL,'2MASX J20090318-5427018',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,302.2632917,-54.45047,0.201,NULL,49048344987,766380390,11974693,14.3),(146135,'GRB','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146135,37.75,NULL,354,69757,65,NULL,'L = 10e57 photons/s','GRB 781104b',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,302.234041667,-21.453,0.393,NULL,50812494619,793945228,12405394,NULL),(146136,'GRB','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146136,40.59,NULL,1310,69757,65,NULL,'L = 2 x 10e58 photons/s','GRB 781104b',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146137,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146137,36.98,0.58,249,69758,70,NULL,NULL,'2MASX J20091337-5421218',NULL,'2014MNRAS.445.2677S',2014,1,0.24,NULL,'G',0.00015,NULL,'17.1b',0.14,NULL,NULL,NULL,NULL,NULL,1,302.3055417,-54.35603,0.205,NULL,49048226193,766378534,11974664,17.1),(146138,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146138,35.91,0.58,152,69759,70,NULL,NULL,'ESO 284- G 020',NULL,'2014MNRAS.445.2677S',2014,1,2.35,NULL,'G',0.00015,NULL,'15.78',0.33,'Sc: pec sp',NULL,NULL,NULL,NULL,1,302.3110417,-46.35072,0.045,NULL,51092074013,798313656,12473650,15.78),(146139,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146139,37.2,1,276,69760,70,NULL,NULL,'2MASX J20091558-2102295',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,302.314833,-21.04164,0.389,NULL,50812914726,793951792,12405496,15.5),(146140,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146140,37.2,0.59,276,69761,70,NULL,NULL,'2MASX J20091565-5419178',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,302.315166667,-54.32153,0.205,NULL,49048225049,766378516,11974664,15.6),(146141,'Tully est','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146141,31.61,0.8,21,69762,75,NULL,NULL,'UGCA 417',NULL,'1988NBGC.C....0000T',1988,1,2.5,NULL,'G',0.000003,NULL,'15.3',1.3,'SB(s)m?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,302.338333,-6.28611,0.333,NULL,48034466716,750538542,11727164,15.3),(146142,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146142,30.41,0.39,12.1,69762,73,NULL,'opt','UGCA 417',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146143,'BL Lac Luminosity','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146143,37.64,NULL,315,69763,NULL,NULL,NULL,'[HB89] 2005-489',0.071,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',NULL,NULL,'15.3',NULL,'Opt.var.       BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,302.3557917,-48.83158,0.141,NULL,51136086498,799001351,12484396,15.3),(146144,'GeV TeV ratio','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146144,37.94,NULL,388,69763,72,NULL,NULL,'[HB89] 2005-489',NULL,'2010MNRAS.405L..76P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146145,'GeV TeV ratio','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',146145,39.17,0.3,683,69763,72,NULL,NULL,'[HB89] 2005-489',NULL,'2011arXiv1111.0913P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146146,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146146,33.37,0.54,47.1,69764,70,NULL,NULL,'ESO 233- G 035',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000033,NULL,'14.33',0.4,'S0',NULL,NULL,NULL,NULL,1,302.3567917,-48.28483,0.141,NULL,51134276893,798973076,12483954,14.33),(146147,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146147,36.4,0.64,191,69765,70,NULL,NULL,'2MASX J20093030-2113155',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.35',NULL,'(R)SB0/a:',NULL,NULL,NULL,NULL,1,302.3764583,-21.22103,0.389,NULL,50812786324,793949786,12405465,16.35),(146148,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146148,29.88,0.8,9.45,69766,75,NULL,'MAT, I','IC 4951',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.000007,NULL,'13.97',0.5,'SB(s)dm: sp',NULL,NULL,NULL,NULL,1,302.382375,-61.85047,0.065,NULL,49143602893,767868795,11997949,13.97),(146149,'Tully est','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146149,29.97,0.8,9.9,69766,75,NULL,NULL,'IC 4951',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146150,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146150,28.78,0.32,5.69,69766,85,NULL,'I, inv','IC 4951',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146151,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146151,28.85,0.32,5.91,69766,85,NULL,'I, raw','IC 4951',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146152,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146152,29.21,0.43,6.96,69766,75,NULL,'MAT, I, inv','IC 4951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146153,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146153,29.42,0.43,7.65,69766,75,NULL,'MAT, I, raw','IC 4951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146154,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146154,29.56,0.2,8.17,69766,74.4,NULL,NULL,'IC 4951',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146155,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146155,29.61,0.62,8.37,69766,NULL,NULL,NULL,'IC 4951',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146156,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146156,29.67,0.43,8.6,69766,75,NULL,'MAT, I, cor','IC 4951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146157,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146157,29.96,NULL,9.82,69766,NULL,NULL,NULL,'IC 4951',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146158,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146158,30.27,0.36,11.3,69766,NULL,NULL,NULL,'IC 4951',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146159,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146159,30.27,0.4,11.3,69766,73,NULL,'opt','IC 4951',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146160,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146160,30.65,0.38,13.5,69766,NULL,NULL,'Malmquist cor.','IC 4951',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146161,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146161,32.99,0.8,39.7,69767,75,NULL,'MAT, I','ESO 233- G 036',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.72',0.4,'Sab? sp','Line-of-sight pair member',NULL,NULL,NULL,1,302.393167,-49.22147,0.157,NULL,51136872326,799013630,12484587,14.72),(146162,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146162,32.49,0.32,31.5,69767,85,NULL,'I, raw','ESO 233- G 036',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146163,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146163,32.5,0.32,31.6,69767,85,NULL,'I, inv','ESO 233- G 036',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146164,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146164,32.78,0.43,35.9,69767,75,NULL,'MAT, I, raw','ESO 233- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146165,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146165,32.86,0.43,37.3,69767,75,NULL,'MAT, I, inv','ESO 233- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146166,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146166,33.09,0.43,41.5,69767,75,NULL,'MAT, I, cor','ESO 233- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146167,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',146167,33.13,0.49,42.3,69767,75,NULL,'IR','ESO 233- G 036',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146168,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146168,33.24,0.4,44.4,69767,NULL,NULL,'mean','ESO 233- G 036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146169,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146169,33.29,0.57,45.5,69767,NULL,NULL,NULL,'ESO 233- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146170,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146170,33.33,0.2,46.3,69767,74.4,NULL,NULL,'ESO 233- G 036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146171,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146171,33.41,0.54,48.1,69767,NULL,NULL,'Malmquist cor.','ESO 233- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146172,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146172,33.49,0.47,49.8,69767,NULL,NULL,'H','ESO 233- G 036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146173,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146173,33.62,0.46,52.9,69767,NULL,NULL,'J','ESO 233- G 036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146174,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146174,33.66,0.48,54.1,69768,70,NULL,NULL,'ESO 233- G 037',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'14.52',0.3,'Sb','Line-of-sight pair member',NULL,NULL,NULL,1,302.413125,-49.33172,0.157,NULL,51136886922,799013858,12484591,14.52),(146175,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146175,36.58,0.85,207,69769,70,NULL,NULL,'2MASX J20094051-5433103',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,302.418666667,-54.55292,0.201,NULL,49048381960,766380968,11974702,14.5),(146176,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146176,34.34,0.8,73.8,69770,75,NULL,'MAT, I','ESO 284- G 021',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.19',0.8,'SAB(rs+)c',NULL,NULL,NULL,NULL,1,302.4335417,-44.15372,0.097,NULL,51101637647,798463088,12475985,14.19),(146177,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146177,33.13,0.32,42.3,69770,85,NULL,'I, raw','ESO 284- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146178,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146178,33.15,0.32,42.6,69770,85,NULL,'I, inv','ESO 284- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146179,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146179,33.28,0.2,45.3,69770,74.4,NULL,NULL,'ESO 284- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146180,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146180,33.34,0.43,46.5,69770,75,NULL,'MAT, I, raw','ESO 284- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146181,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146181,33.44,0.43,48.8,69770,75,NULL,'MAT, I, inv','ESO 284- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146182,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',146182,33.74,0.52,56,69770,NULL,NULL,'B, Hubble-type-TF','ESO 284- G 021',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146183,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146183,33.75,0.66,56.3,69770,NULL,NULL,NULL,'ESO 284- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146184,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146184,33.8,0.43,57.5,69770,75,NULL,'MAT, I, cor','ESO 284- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146185,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146185,34.16,0.55,67.9,69770,NULL,NULL,'Malmquist cor.','ESO 284- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146186,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146186,35.86,0.53,148,69771,70,NULL,NULL,'2MASX J20094410-6640249',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,302.4337917,-66.67367,0.165,NULL,49365330979,771333296,12052082,14.4),(146187,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146187,34.36,0.8,74.4,69772,75,NULL,'MAT, I','ESO 399- G 023',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.05',0.9,'SAB(r)bc',NULL,NULL,NULL,NULL,1,302.449375,-37.32975,0.305,NULL,51290522577,801414415,12522100,14.05),(146188,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146188,33.99,0.43,62.9,69772,75,NULL,'MAT, I, raw','ESO 399- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146189,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146189,34.12,0.32,66.6,69772,85,NULL,'I, raw','ESO 399- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146190,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146190,34.18,0.32,68.5,69772,85,NULL,'I, inv','ESO 399- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146191,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146191,34.24,0.43,70.4,69772,75,NULL,'MAT, I, inv','ESO 399- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146192,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146192,34.27,0.47,71.5,69772,NULL,NULL,'H','ESO 399- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146193,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146193,34.32,0.43,73.2,69772,75,NULL,'MAT, I, cor','ESO 399- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146194,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146194,34.36,0.46,74.3,69772,NULL,NULL,'J','ESO 399- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146195,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146195,34.38,0.45,75,69772,NULL,NULL,'K','ESO 399- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146196,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146196,34.44,0.34,77.2,69772,NULL,NULL,NULL,'ESO 399- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146197,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146197,34.45,0.2,77.6,69772,74.4,NULL,NULL,'ESO 399- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146198,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146198,34.51,0.33,79.8,69772,NULL,NULL,'Malmquist cor.','ESO 399- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146199,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146199,34.53,0.4,80.4,69772,NULL,NULL,'mean','ESO 399- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146200,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146200,36.84,0.61,233,69773,70,NULL,NULL,'2MASX J20094919-5900464',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,302.454875,-59.01294,0.061,NULL,49028995005,766078046,11969969,14.6),(146201,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146201,32.14,0.25,26.8,69774,NULL,NULL,'I','NGC 6868',NULL,'2001ApJ...546..681T',2001,1,3.5,NULL,'G',0.00005,NULL,'11.66',2.8,'E2             LINER','Group member, radial-velocity confirmed',NULL,NULL,'Flat-Spectrum Radio Source',1,302.4752917,-48.37956,0.141,NULL,51134158740,798971230,12483925,11.66),(146202,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146202,32.14,0.25,26.8,69774,NULL,NULL,NULL,'NGC 6868',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146203,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146203,32.21,0.14,27.7,69774,74.4,NULL,NULL,'NGC 6868',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146204,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146204,32.33,0.25,29.2,69774,NULL,NULL,'Malmquist cor.','NGC 6868',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146205,'D-Sigma','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146205,32.24,0.4,28,69774,75,NULL,'Edat, raw','NGC 6868',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146206,'D-Sigma','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146206,32.36,0.4,29.7,69774,75,NULL,'Edat, cor','NGC 6868',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146207,'Faber-Jackson','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146207,32.14,0.65,26.8,69774,95,NULL,'Weighted Mean','NGC 6868',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146208,'Faber-Jackson','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146208,33.63,0.81,53.2,69774,55,NULL,'Visvanathan & Sandage 1979','NGC 6868',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146209,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146209,32.5,0.41,31.7,69774,NULL,NULL,NULL,'NGC 6868',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146210,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146210,32.66,0.5,34,69774,70,NULL,NULL,'NGC 6868',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146211,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146211,32.83,0.41,36.8,69774,NULL,NULL,'Malmquist cor.','NGC 6868',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146212,'Tertiary','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146212,32.18,0.71,27.3,69774,95,NULL,NULL,'NGC 6868',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146213,'Tully est','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146213,32.75,0.8,35.5,69774,75,NULL,'B','NGC 6868',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146214,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146214,32.49,0.45,31.4,69774,NULL,NULL,'K','NGC 6868',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146215,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146215,33,0.4,39.9,69774,NULL,NULL,'mean','NGC 6868',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146216,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146216,33.11,0.52,41.9,69775,70,NULL,NULL,'NGC 6870',NULL,'2014MNRAS.445.2677S',2014,1,2.6,NULL,'G',0.000033,NULL,'13.18',1.2,'SAB(rs)ab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,302.54525,-48.28708,0.141,NULL,51134155517,798971179,12483924,13.18),(146217,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146217,32.76,0.8,35.6,69775,75,NULL,'MAT, I','NGC 6870',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146218,'Tully est','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146218,32.75,0.8,35.5,69775,75,NULL,'B','NGC 6870',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146219,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146219,33.74,0.32,56,69775,85,NULL,'I, raw','NGC 6870',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146220,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146220,33.79,0.43,57.2,69775,75,NULL,'MAT, I, raw','NGC 6870',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146221,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146221,33.83,0.32,58.3,69775,85,NULL,'I, inv','NGC 6870',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146222,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146222,33.97,0.38,62.3,69775,NULL,NULL,'Malmquist cor.','NGC 6870',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146223,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146223,33.98,0.38,62.6,69775,NULL,NULL,NULL,'NGC 6870',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146224,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146224,34.02,0.2,63.7,69775,74.4,NULL,NULL,'NGC 6870',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146225,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146225,34.12,0.43,66.8,69775,75,NULL,'MAT, I, cor','NGC 6870',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146226,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146226,34.15,0.43,67.5,69775,75,NULL,'MAT, I, inv','NGC 6870',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146227,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146227,34.52,0.6,80.1,69776,70,NULL,NULL,'2MASX J20101168-4358310',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,302.548667,-43.97539,0.101,NULL,51102096282,798470254,12476097,14.3),(146228,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146228,36.76,0.6,225,69777,70,NULL,NULL,'2MASX J20102381-2146313',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.48',0.4,NULL,NULL,NULL,NULL,NULL,1,302.59925,-21.77558,0.417,NULL,50814951410,793983615,12405993,16.48),(146229,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146229,35,0.52,100,69778,70,NULL,NULL,'2MASX J20102462-5938506',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,302.602583,-59.6475,0.081,NULL,49030531886,766102060,11970344,15.4),(146230,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SDSS-II SN 11092',NULL,146230,37.42,0.43,305,69779,70,NULL,'SN photometric redshift distance, z photo =0.074 +/- 0.017','SDSS-II SN 11092',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,302.623333,1.12161,0.453,NULL,54107015314,845422114,13209720,NULL),(146231,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146231,33.67,0.8,54.3,69780,75,NULL,'MAT, I','NGC 6867',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000022,NULL,'13.89',0.7,'SB(rs)bc:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,302.623583,-54.78325,0.213,NULL,49048795605,766387431,11974803,13.89),(146232,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146232,33.33,0.32,46.3,69780,85,NULL,'I, raw','NGC 6867',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146233,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146233,33.34,0.43,46.5,69780,75,NULL,'MAT, I, raw','NGC 6867',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146234,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146234,33.37,0.32,47.3,69780,85,NULL,'I, inv','NGC 6867',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146235,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',146235,33.41,0.49,48.1,69780,75,NULL,'IR','NGC 6867',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146236,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146236,33.53,0.47,50.9,69780,NULL,NULL,'H','NGC 6867',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146237,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146237,33.55,0.43,51.2,69780,75,NULL,'MAT, I, inv','NGC 6867',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146238,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146238,33.6,0.46,52.5,69780,NULL,NULL,'J','NGC 6867',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146239,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146239,33.61,0.45,52.6,69780,NULL,NULL,'K','NGC 6867',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146240,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146240,33.67,0.43,54.3,69780,75,NULL,'MAT, I, cor','NGC 6867',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146241,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146241,33.82,0.4,58.2,69780,NULL,NULL,'mean','NGC 6867',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146242,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146242,35.56,0.6,129,69781,70,NULL,NULL,'2MASX J20103773-8651282',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,'Elliptical',NULL,NULL,NULL,NULL,1,302.656917,-86.85792,0.417,NULL,48331278756,755176230,11799628,16.6),(146243,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146243,36.87,0.48,237,69782,NULL,NULL,'Malmquist cor.','2MASX J20105045-5632598',NULL,'2009ApJS..182..474S',2009,1,0.41,NULL,'G',0.00003,NULL,'16.5V',0.12,'Sc',NULL,NULL,NULL,NULL,1,302.710333333,-56.54997,0.197,NULL,49053309549,766457961,11975905,16.5),(146244,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146244,37.12,0.43,265,69782,NULL,NULL,NULL,'2MASX J20105045-5632598',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146245,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146245,37.16,0.2,270,69782,74.4,NULL,NULL,'2MASX J20105045-5632598',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146246,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146246,32.42,0.8,30.5,69783,75,NULL,'MAT, I','NGC 6861E',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'15.06',0.3,'Sab:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,302.756333,-48.69058,0.141,NULL,51136040628,799000634,12484384,15.06),(146247,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146247,32.14,0.32,26.8,69783,85,NULL,'I, inv','NGC 6861E',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146248,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146248,32.16,0.32,27,69783,85,NULL,'I, raw','NGC 6861E',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146249,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146249,32.5,0.43,31.6,69783,75,NULL,'MAT, I, inv','NGC 6861E',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146250,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146250,32.51,0.43,31.7,69783,75,NULL,'MAT, I, raw','NGC 6861E',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146251,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146251,32.8,0.43,36.3,69783,75,NULL,'MAT, I, cor','NGC 6861E',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146252,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',146252,33,0.49,39.8,69783,75,NULL,'IR','NGC 6861E',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146253,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146253,33.07,0.53,41.1,69783,NULL,NULL,NULL,'NGC 6861E',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146254,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146254,33.11,0.2,41.9,69783,74.4,NULL,NULL,'NGC 6861E',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146255,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146255,33.12,0.52,42.1,69783,NULL,NULL,'Malmquist cor.','NGC 6861E',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146256,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146256,36.76,0.54,225,69784,70,NULL,NULL,'2MASX J20110463-5411587',NULL,'2014MNRAS.445.2677S',2014,1,0.28,NULL,'G',0.00015,NULL,'15.3R',0.15,NULL,NULL,NULL,NULL,NULL,1,302.7692083,-54.19972,0.217,NULL,48993707863,765526685,11961354,15.3),(146257,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146257,32.93,0.8,38.5,69785,75,NULL,'MAT, I','NGC 6861F',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'15.19',0.3,'SBdm? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,302.799167,-48.27583,0.141,NULL,51134638456,798978725,12484042,15.19),(146258,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146258,32.95,0.8,38.9,69785,75,NULL,'HMCL, I','NGC 6861F',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146259,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146259,31.41,0.32,19.1,69785,85,NULL,'I, inv','NGC 6861F',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146260,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146260,31.45,0.32,19.5,69785,85,NULL,'I, raw','NGC 6861F',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146261,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146261,31.55,0.4,20.4,69785,75,NULL,'HMCL, I, inv','NGC 6861F',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146262,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146262,31.65,0.4,21.4,69785,75,NULL,'HMCL, I, raw','NGC 6861F',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146263,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146263,31.82,0.43,23.1,69785,75,NULL,'MAT, I, inv','NGC 6861F',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146264,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146264,31.83,0.4,23.2,69785,NULL,NULL,NULL,'NGC 6861F',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146265,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146265,31.93,0.43,24.3,69785,75,NULL,'MAT, I, raw','NGC 6861F',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146266,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146266,32.02,0.4,25.3,69785,75,NULL,'HMCL, I, cor','NGC 6861F',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146267,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146267,32.24,0.4,28,69785,73,NULL,'opt','NGC 6861F',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146268,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146268,32.32,0.43,29.1,69785,75,NULL,'MAT, I, cor','NGC 6861F',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146269,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146269,32.34,0.59,29.3,69785,NULL,NULL,NULL,'NGC 6861F',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146270,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146270,32.38,0.2,29.9,69785,74.4,NULL,NULL,'NGC 6861F',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146271,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146271,32.63,0.52,33.5,69785,NULL,NULL,'Malmquist cor.','NGC 6861F',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146272,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146272,33.6,0.8,52.5,69786,75,NULL,'MAT, I','NGC 6876A',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'14.79',0.3,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,302.820208333,-71.01294,0.197,NULL,49223576401,769118381,12017474,14.79),(146273,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',146273,33.41,0.49,48.2,69786,75,NULL,'IR','NGC 6876A',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146274,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146274,33.53,0.32,50.9,69786,85,NULL,'I, raw','NGC 6876A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146275,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146275,33.55,0.32,51.3,69786,85,NULL,'I, inv','NGC 6876A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146276,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146276,33.7,0.43,54.9,69786,75,NULL,'MAT, I, raw','NGC 6876A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146277,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146277,33.75,0.4,56.2,69786,NULL,NULL,'mean','NGC 6876A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146278,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146278,33.82,0.43,58.1,69786,75,NULL,'MAT, I, inv','NGC 6876A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146279,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146279,33.83,0.1,58.5,69786,NULL,NULL,NULL,'NGC 6876A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146280,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146280,33.86,0.43,59.1,69786,75,NULL,'MAT, I, cor','NGC 6876A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146281,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146281,33.94,0.47,61.4,69786,NULL,NULL,'H','NGC 6876A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146282,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146282,37.66,0.61,341,69787,70,NULL,NULL,'2MASX J20111901-5340356',NULL,'2014MNRAS.445.2677S',2014,1,0.27,NULL,'G',0.00015,NULL,'15.5R',0.16,NULL,NULL,NULL,NULL,NULL,1,302.829417,-53.67656,0.209,NULL,51078456565,798100883,12470326,15.5),(146283,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146283,35.15,0.66,107,69788,70,NULL,NULL,'2MASX J20112633-5247086',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,302.859667,-52.78578,0.177,NULL,51124800277,798825004,12481640,14.2),(146284,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146284,34.23,0.8,70.1,69789,75,NULL,'MAT, I','ESO 339- G 036',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.68',0.6,'S?',NULL,NULL,NULL,NULL,1,302.862375,-38.19756,0.317,NULL,51288492249,801382691,12521604,14.68),(146285,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146285,33.71,0.32,55.2,69789,85,NULL,'I, raw','ESO 339- G 036',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146286,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146286,33.74,0.32,56,69789,85,NULL,'I, inv','ESO 339- G 036',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146287,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146287,33.82,0.43,58.1,69789,75,NULL,'MAT, I, raw','ESO 339- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146288,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146288,33.98,0.43,62.6,69789,75,NULL,'MAT, I, inv','ESO 339- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146289,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146289,34.03,0.2,64,69789,74.4,NULL,NULL,'ESO 339- G 036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146290,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146290,34.1,0.47,65.9,69789,NULL,NULL,NULL,'ESO 339- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146291,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146291,34.24,0.43,70.4,69789,75,NULL,'MAT, I, cor','ESO 339- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146292,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146292,34.4,0.41,75.8,69789,NULL,NULL,'Malmquist cor.','ESO 339- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146293,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146293,34.37,0.8,74.9,69790,75,NULL,'MAT, I','IC 4961',NULL,'1997ApJS..109..333W',1997,1,1.5,'This may also be IC 4959.','G',0.000033,NULL,'15.02',0.5,'SAB(s)dm:',NULL,NULL,NULL,NULL,1,302.869125,-53.12511,0.205,NULL,51125304660,798832885,12481763,15.02),(146294,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146294,33.49,0.32,50,69790,85,NULL,'I, raw','IC 4961',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146295,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146295,33.51,0.32,50.4,69790,85,NULL,'I, inv','IC 4961',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146296,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146296,33.55,0.43,51.4,69790,75,NULL,'MAT, I, raw','IC 4961',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146297,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146297,33.66,0.43,53.9,69790,75,NULL,'MAT, I, inv','IC 4961',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146298,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146298,33.86,0.43,59.1,69790,75,NULL,'MAT, I, cor','IC 4961',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146299,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146299,34.23,0.37,70,69790,NULL,NULL,NULL,'IC 4961',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146300,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146300,34.23,0.37,70.1,69790,NULL,NULL,'Malmquist cor.','IC 4961',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146301,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146301,34.27,0.2,71.5,69790,74.4,NULL,NULL,'IC 4961',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146302,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146302,34.03,0.45,64,69791,NULL,NULL,'K','IC 4956',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000073,NULL,'13.4',1.6,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,302.88025,-45.59322,0,NULL,51100093316,798438958,12475608,13.4),(146303,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146303,34.23,0.4,70.1,69791,NULL,NULL,'mean','IC 4956',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146304,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146304,35.44,0.58,122,69792,70,NULL,NULL,'ESO 596- G 001',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.00004,NULL,'15',1.5,'(R\'_2)SAB(s)c',NULL,NULL,NULL,NULL,1,302.9187917,-20.8205,0.277,NULL,50812825967,793950405,12405475,15),(146305,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146305,36.66,0.42,214,69793,NULL,NULL,'Malmquist cor.','2MASX J20114286-5703283',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.00003,NULL,'16.5V',0.1,'Sb:',NULL,NULL,NULL,NULL,1,302.9285,-57.05792,0.165,NULL,49053000083,766453126,11975830,16.5),(146306,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146306,36.9,0.37,240,69793,NULL,NULL,NULL,'2MASX J20114286-5703283',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146307,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146307,36.94,0.2,244,69793,74.4,NULL,NULL,'2MASX J20114286-5703283',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146308,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146308,35.62,0.5,133,69794,NULL,NULL,'Malmquist cor.','ESO 462- G 002',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.85',0.4,'Sb',NULL,NULL,NULL,NULL,1,302.932875,-28.86542,0.477,NULL,51332035421,802063053,12532235,15.85),(146309,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146309,35.76,0.47,142,69794,NULL,NULL,NULL,'ESO 462- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146310,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146310,35.8,0.2,145,69794,74.4,NULL,NULL,'ESO 462- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146311,'SNII optical','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 2003fb',NULL,146311,34.41,0.44,76.2,69795,NULL,NULL,'SCM, B','UGC 11522',NULL,'2010ApJ...715..833O',2010,1,1,NULL,'G',0.000117,NULL,'14.5',0.5,'Sbc','Group member',NULL,NULL,NULL,1,302.955667,5.76378,0.745,NULL,54179774155,846558971,13227483,14.5),(146312,'SNII optical','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 2003fb',NULL,146312,34.47,0.37,78.3,69795,NULL,NULL,'V, photospheric magnitude method','UGC 11522',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146313,'SNII optical','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 2003fb',NULL,146313,34.49,0.29,79.1,69795,NULL,NULL,'SCM, BVI','UGC 11522',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146314,'SNII optical','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 2003fb',NULL,146314,34.52,0.16,80.2,69795,NULL,NULL,'I, photospheric magnitude method','UGC 11522',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146315,'SNII optical','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 2003fb',NULL,146315,34.55,0.54,81.3,69795,NULL,NULL,'SCM, I','UGC 11522',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146316,'SNII optical','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 2003fb',NULL,146316,34.56,0.55,81.7,69795,NULL,NULL,'SCM, V','UGC 11522',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146317,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146317,33.69,0.69,54.7,69795,100,NULL,'mid-IR','UGC 11522',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146318,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146318,34.09,0.47,65.6,69795,NULL,NULL,'H','UGC 11522',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146319,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146319,34.15,0.45,67.7,69795,NULL,NULL,'K','UGC 11522',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146320,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146320,34.18,0.4,68.5,69795,NULL,NULL,'mean','UGC 11522',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146321,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146321,34.24,0.46,70.6,69795,NULL,NULL,'J','UGC 11522',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146322,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146322,32.91,0.8,38.2,69796,75,NULL,'MAT, I','NGC 6875A',NULL,'1997ApJS..109..333W',1997,1,2.7,NULL,'G',0.000033,NULL,'13.93',0.5,'SAB(s)d','in a pair',NULL,NULL,NULL,1,302.98275,-46.14408,0.005,NULL,51099406857,798428232,12475441,13.93),(146323,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146323,32.93,0.8,38.6,69796,75,NULL,'HMCL, I','NGC 6875A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146324,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146324,31.84,0.32,23.3,69796,85,NULL,'I, raw','NGC 6875A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146325,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146325,31.86,0.32,23.5,69796,85,NULL,'I, inv','NGC 6875A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146326,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146326,32.02,0.43,25.4,69796,75,NULL,'MAT, I, raw','NGC 6875A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146327,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146327,32.12,0.43,26.5,69796,75,NULL,'MAT, I, inv','NGC 6875A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146328,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146328,32.32,0.4,29.1,69796,NULL,NULL,NULL,'NGC 6875A',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146329,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146329,32.35,0.49,29.5,69796,75,NULL,'IR','NGC 6875A',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146330,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146330,32.39,0.43,30.1,69796,75,NULL,'MAT, I, cor','NGC 6875A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146331,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146331,32.58,0.47,32.8,69796,NULL,NULL,'H','NGC 6875A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146332,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146332,32.64,0.46,33.8,69796,NULL,NULL,'J','NGC 6875A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146333,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146333,32.65,0.4,33.9,69796,75,NULL,'HMCL, I, raw','NGC 6875A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146334,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146334,32.72,0.45,35,69796,NULL,NULL,'K','NGC 6875A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146335,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146335,32.77,0.4,35.8,69796,75,NULL,'HMCL, I, inv','NGC 6875A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146336,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146336,32.78,0.45,35.9,69796,NULL,NULL,NULL,'NGC 6875A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146337,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146337,32.82,0.2,36.6,69796,74.4,NULL,NULL,'NGC 6875A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146338,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146338,32.83,0.44,36.8,69796,NULL,NULL,'Malmquist cor.','NGC 6875A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146339,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146339,32.85,0.4,37.1,69796,75,NULL,'HMCL, I, cor','NGC 6875A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146340,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146340,33.11,0.4,42,69796,NULL,NULL,'mean','NGC 6875A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146341,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146341,35.15,0.49,107,69797,75,NULL,'IR','ESO 284- G 025',NULL,'2011yCatp016004901K',2011,1,1.12,NULL,'G',0.000033,NULL,'16.0b',0.16,'Sbc',NULL,NULL,NULL,NULL,1,303.001416667,-47.02386,0.073,NULL,51133824420,798966006,12483843,16),(146342,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146342,35.29,NULL,114,69797,NULL,NULL,NULL,'ESO 284- G 025',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146343,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146343,35.35,0.62,118,69797,NULL,NULL,'Malmquist cor.','ESO 284- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146344,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146344,35.43,NULL,122,69797,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 284- G 025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146345,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146345,35.46,NULL,124,69797,NULL,NULL,'Dipole + Quadrupole','ESO 284- G 025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146346,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146346,35.49,NULL,126,69797,NULL,NULL,'Dipole','ESO 284- G 025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146347,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146347,35.61,0.55,132,69797,NULL,NULL,NULL,'ESO 284- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146348,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146348,35.65,0.2,135,69797,74.4,NULL,NULL,'ESO 284- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146349,'Ring Diameter','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146349,34.3,0.84,74,69798,NULL,NULL,'Published at H = 100 km/s/Mpc','UGC 11524',NULL,'1981ApJS...45..541P',1981,1,1.1,NULL,'G',0.000023,NULL,'14.12',1,'SA(r)c:','Group member',NULL,NULL,NULL,1,303.016291667,5.76367,0.745,NULL,54179759786,846558746,13227480,14.12),(146350,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146350,36.05,0.53,162,69799,70,NULL,NULL,'2MASX J20120429-5251129',NULL,'2014MNRAS.445.2677S',2014,1,0.28,NULL,'G',0.00015,NULL,'15.0R',0.25,NULL,NULL,NULL,NULL,NULL,1,303.017958333,-52.85364,0.177,NULL,51124808607,798825134,12481642,15),(146351,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146351,34.73,0.5,88.1,69800,70,NULL,NULL,'ESO 284- G 026',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.22',0.9,'S0-:',NULL,NULL,NULL,NULL,1,303.049,-44.14667,0.097,NULL,51102445338,798475708,12476182,14.22),(146352,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146352,36.8,0.67,229,69801,70,NULL,NULL,'2MASX J20121530-0032056',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000103,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,303.0637917,-0.53489,0.609,NULL,47883056108,748172751,11690199,14.5),(146353,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146353,34.59,0.49,82.8,69802,75,NULL,'IR','UGC 11525',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000223,NULL,'15.11',0.3,'Sab: sp',NULL,NULL,NULL,NULL,1,303.07675,1.95758,0.461,NULL,54177778368,846527787,13226996,15.11),(146354,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146354,34.26,0.48,71.3,69803,70,NULL,NULL,'ESO 596- G 003',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000113,NULL,'15.55',0.4,'Sa:',NULL,NULL,NULL,NULL,1,303.0849583,-17.59175,0.293,NULL,50839960894,794374388,12412099,15.55),(146355,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146355,37.64,0.73,337,69804,70,NULL,NULL,'ESO 105- G 029',NULL,'2014MNRAS.445.2677S',2014,1,1.2,'1983MNRAS.203...47F has V = 5950? +- 100 km/s.','G',0.00015,NULL,'16.05',0.7,'(R)SAB0/a',NULL,NULL,NULL,NULL,1,303.110625,-65.41597,0.149,NULL,49374055567,771469618,12054212,16.05),(146356,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146356,35.61,0.7,132,69805,70,NULL,NULL,'2MASX J20122705-1846145',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.34',NULL,NULL,NULL,NULL,NULL,NULL,1,303.11275,-18.77056,0.269,NULL,50856636272,794634941,12416170,16.34),(146357,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146357,36.42,0.24,192,69806,70,NULL,'ABELL 3667, BGC','IC 4965',NULL,'1999AJ....118.1489D',1999,1,1.1,NULL,'G',0.000127,NULL,'13.2V',1,'SA0^0;BrClG',NULL,NULL,NULL,NULL,1,303.113833,-56.82678,0.185,NULL,49053257517,766457148,11975892,13.2),(146358,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146358,36.42,0.24,192,69807,70,NULL,NULL,'ABELL 3667',NULL,'1999AJ....118.1489D',1999,1,NULL,'Katgert (1996,A&A,310,8) identifies multiple redshift systems in this cluster.','GClstr',NULL,NULL,NULL,NULL,'I-II   [BM];IR:[A]',NULL,NULL,NULL,NULL,1,303.127083,-56.83194,0.185,NULL,49053257127,766457142,11975892,NULL),(146359,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146359,34.96,0.63,98.3,69808,70,NULL,NULL,'2MASX J20123427-4546540',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.4,NULL,NULL,NULL,NULL,NULL,1,303.14275,-45.78172,0,NULL,51100201201,798440643,12475635,13.9),(146360,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146360,35.57,0.51,130,69809,70,NULL,NULL,'ESO 284- G 027',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.13',0.3,'N',NULL,NULL,NULL,NULL,1,303.160666667,-45.75917,0,NULL,51100248107,798441376,12475646,15.13),(146361,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146361,34.54,0.47,80.8,69810,NULL,NULL,'H','ESO 340- G 001',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000033,NULL,'15.0b',0.4,'Sb-c',NULL,NULL,NULL,NULL,1,303.165333,-40.13261,0.185,NULL,51204285610,800066962,12501046,15),(146362,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146362,34.57,0.49,82.1,69810,75,NULL,'IR','ESO 340- G 001',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146363,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146363,34.62,0.45,83.8,69810,NULL,NULL,'K','ESO 340- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146364,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146364,34.72,0.46,87.9,69810,NULL,NULL,'J','ESO 340- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146365,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146365,34.73,0.42,88.2,69810,NULL,NULL,'Malmquist cor.','ESO 340- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146366,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146366,34.77,0.4,89.9,69810,NULL,NULL,'mean','ESO 340- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146367,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146367,35.02,0.37,101,69810,NULL,NULL,NULL,'ESO 340- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146368,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146368,35.06,0.2,103,69810,74.4,NULL,NULL,'ESO 340- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146369,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146369,34.9,0.5,95.5,69811,NULL,NULL,'Malmquist cor.','ESO 399- G 024',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'16.1b',0.4,'(R\'_2:)SB(r)a',NULL,NULL,NULL,NULL,1,303.197,-33.58758,0.337,NULL,51299188372,801549818,12524215,16.1),(146370,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146370,35.2,0.43,109,69811,NULL,NULL,NULL,'ESO 399- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146371,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146371,35.24,0.2,112,69811,74.4,NULL,NULL,'ESO 399- G 024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146372,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146372,35.34,0.49,117,69811,75,NULL,'IR','ESO 399- G 024',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146373,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146373,36.18,0.66,172,69812,70,NULL,NULL,'2MASX J20125700-2011237',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.4,NULL,NULL,NULL,NULL,NULL,1,303.237583333,-20.18994,0.281,NULL,50857710491,794651726,12416433,14.2),(146374,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146374,36.91,0.51,241,69813,NULL,NULL,'Malmquist cor.','2MFGC 15388',NULL,'2009ApJS..182..474S',2009,1,0.49,NULL,'G',0.000027,NULL,'17.94',0.11,'Sc',NULL,NULL,NULL,NULL,1,303.2730417,-57.17878,0.117,NULL,49045444677,766335073,11973985,17.94),(146375,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146375,37.09,0.49,261,69813,75,NULL,'IR','2MFGC 15388',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146376,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146376,37.26,0.43,283,69813,NULL,NULL,NULL,'2MFGC 15388',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146377,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146377,37.3,0.2,288,69813,74.4,NULL,NULL,'2MFGC 15388',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146378,'Faber-Jackson','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146378,30.52,0.65,12.7,69814,95,NULL,'Weighted Mean','NGC 6875',NULL,'1984ApJS...56...91D',1984,1,2.3,NULL,'G',0.000083,NULL,'13.03',1.3,'S0^0p','in a pair',NULL,NULL,NULL,1,303.3019583,-46.16164,0.005,NULL,51099295339,798426489,12475413,13.03),(146379,'Faber-Jackson','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146379,31.62,0.81,21.1,69814,55,NULL,'Visvanathan & Sandage 1979','NGC 6875',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146380,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146380,33.86,0.49,59.1,69815,75,NULL,'IR','UGC 11529',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.00003,NULL,'16.5',0.7,'Sbc',NULL,NULL,NULL,NULL,1,303.324875,66.29056,0.653,NULL,53646659520,838229055,13097328,16.5),(146381,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146381,36.82,0.52,231,69816,70,NULL,NULL,'2MASX J20133274-5357398',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,303.3864583,-53.96106,0.217,NULL,51078358260,798099347,12470302,14),(146382,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146382,35.48,0.49,125,69817,75,NULL,'IR','ESO 284- G 030',NULL,'2011yCatp016004901K',2011,1,1.23,NULL,'G',0.000033,NULL,'15.98',0.17,'Scd',NULL,NULL,NULL,NULL,1,303.391375,-43.3625,0.093,NULL,51102352078,798474251,12476160,15.98),(146383,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146383,35.73,NULL,140,69817,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 284- G 030',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146384,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146384,35.76,NULL,142,69817,NULL,NULL,'Dipole + Quadrupole','ESO 284- G 030',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146385,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146385,35.79,NULL,144,69817,NULL,NULL,'Dipole','ESO 284- G 030',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146386,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146386,35.92,0.47,153,69817,NULL,NULL,'Malmquist cor.','ESO 284- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146387,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146387,36.17,0.42,172,69817,NULL,NULL,NULL,'ESO 284- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146388,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146388,36.21,0.2,175,69817,74.4,NULL,NULL,'ESO 284- G 030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146389,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146389,33.93,0.69,61,69818,100,NULL,'mid-IR','UGC 11526',NULL,'2013ApJ...771...88L',2013,1,1.3,NULL,'G',0.000077,NULL,'14.7',0.6,'Sa',NULL,NULL,NULL,NULL,1,303.399583,7.28172,0.757,NULL,54211055100,847047735,13235120,14.7),(146390,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146390,34.41,0.47,76.1,69818,NULL,NULL,'H','UGC 11526',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146391,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146391,34.41,0.46,76.3,69818,NULL,NULL,'J','UGC 11526',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146392,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146392,34.43,0.45,77,69818,NULL,NULL,'K','UGC 11526',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146393,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146393,34.45,0.4,77.5,69818,NULL,NULL,'mean','UGC 11526',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146394,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146394,34.04,0.8,64.2,69819,75,NULL,'MAT, I','NGC 6878A',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'13.75',0.8,'SAB(rs)c','in a pair',NULL,NULL,NULL,1,303.4,-44.81617,0.073,NULL,51103166384,798486974,12476358,13.75),(146395,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146395,32.9,0.2,38,69819,NULL,NULL,'B, Hubble-type-TF','NGC 6878A',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146396,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146396,33.34,0.32,46.6,69819,85,NULL,'I, raw','NGC 6878A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146397,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146397,33.37,0.32,47.3,69819,85,NULL,'I, inv','NGC 6878A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146398,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146398,33.53,0.43,50.7,69819,75,NULL,'MAT, I, raw','NGC 6878A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146399,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146399,33.7,0.43,55,69819,75,NULL,'MAT, I, inv','NGC 6878A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146400,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146400,33.93,0.47,61.1,69819,NULL,NULL,NULL,'NGC 6878A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146401,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146401,33.97,0.2,62.2,69819,74.4,NULL,NULL,'NGC 6878A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146402,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146402,33.99,0.43,62.7,69819,75,NULL,'MAT, I, cor','NGC 6878A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146403,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146403,34.2,0.41,69.1,69819,NULL,NULL,'Malmquist cor.','NGC 6878A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146404,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146404,36.41,0.56,191,69820,70,NULL,NULL,'2MASX J20135129-6408474',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.8R',0.18,NULL,NULL,NULL,NULL,NULL,1,303.463875,-64.14656,0.161,NULL,49361469730,771272964,12051140,15.8),(146405,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146405,33.95,0.49,61.7,69821,75,NULL,'IR','UGC 11527',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.00002,NULL,'14.29',0.4,'SB(s)ab?       HII',NULL,NULL,NULL,NULL,1,303.47675,-1.1575,0.645,NULL,48017202648,750268791,11722949,14.29),(146406,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146406,33.97,0.46,62.2,69821,NULL,NULL,'J','UGC 11527',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146407,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146407,34,0.47,63,69821,NULL,NULL,'H','UGC 11527',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146408,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146408,34.02,0.45,63.8,69821,NULL,NULL,'K','UGC 11527',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146409,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146409,34.17,0.2,68.2,69821,74.4,NULL,NULL,'UGC 11527',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146410,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146410,34.2,0.4,69,69821,NULL,NULL,'mean','UGC 11527',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146411,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146411,34.24,0.43,70.6,69821,75,NULL,'3.6 micron, color corrected','UGC 11527',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146412,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146412,34.25,0.34,70.7,69821,NULL,NULL,NULL,'UGC 11527',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146413,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146413,34.34,0.33,73.8,69821,NULL,NULL,'Malmquist cor.','UGC 11527',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146414,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146414,34.4,0.43,75.8,69821,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11527',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146415,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146415,34.18,0.55,68.6,69822,70,NULL,NULL,'ESO 284- G 033',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000083,NULL,'14.12',0.7,'SAB0^0^',NULL,NULL,NULL,NULL,1,303.552166667,-44.62317,0.073,NULL,51103238459,798488100,12476376,14.12),(146416,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146416,36.79,0.44,228,69823,NULL,NULL,'Malmquist cor.','2MASX J20141338-5719030',NULL,'2009ApJS..182..474S',2009,1,0.39,NULL,'G',0.00003,NULL,'17.62',0.1,'Sc',NULL,NULL,NULL,NULL,1,303.555791667,-57.31744,0.117,NULL,49045478565,766335602,11973993,17.62),(146417,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146417,37.09,0.38,262,69823,NULL,NULL,NULL,'2MASX J20141338-5719030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146418,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146418,37.13,0.2,267,69823,74.4,NULL,NULL,'2MASX J20141338-5719030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146419,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146419,36.06,0.49,163,69824,70,NULL,NULL,'ESO 143- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1.2,'6dF DR2 has z = 0.036070.','G',0.00015,NULL,'15.57',0.5,'S0',NULL,NULL,NULL,NULL,1,303.556875,-59.49247,0.069,NULL,49031184228,766112253,11970503,15.57),(146420,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146420,34.05,0.8,64.7,69825,75,NULL,'MAT, I','ESO 233- G 047',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'15.44',0.7,'(R\')SB(rs)bc',NULL,NULL,NULL,NULL,1,303.570625,-48.82669,0.133,NULL,51136661859,799010341,12484536,15.44),(146421,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146421,33.97,0.43,62.3,69825,75,NULL,'MAT, I, raw','ESO 233- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146422,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146422,34.04,0.43,64.2,69825,75,NULL,'MAT, I, inv','ESO 233- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146423,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146423,34.07,0.32,65.1,69825,85,NULL,'I, raw','ESO 233- G 047',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146424,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146424,34.08,0.32,65.5,69825,85,NULL,'I, inv','ESO 233- G 047',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146425,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146425,34.23,0.43,70.2,69825,75,NULL,'MAT, I, cor','ESO 233- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146426,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146426,35.37,0.54,119,69826,70,NULL,NULL,'2MASX J20143427-1216148',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00007,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,303.642833,-12.27078,0.265,NULL,47933770195,748965159,11702580,14.6),(146427,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146427,34.79,0.66,90.9,69827,70,NULL,NULL,'2MASX J20144323-0700345',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00008,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,303.680125,-7.00961,0.241,NULL,48036654828,750572731,11727698,14.5),(146428,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146428,36.94,0.59,244,69828,70,NULL,NULL,'2MASX J20144467-1730378',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,303.686083,-17.51047,0.245,NULL,50843122432,794423788,12412871,15.2),(146429,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146429,34.47,0.53,78.3,69829,70,NULL,NULL,'FAIRALL 0886',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'13.4I',0.6,NULL,NULL,NULL,NULL,NULL,1,303.691667,-51.67639,0.141,NULL,51126127737,798845745,12481964,13.4),(146430,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146430,34.72,0.8,87.7,69830,75,NULL,'MAT, I','ESO 596- G 009',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'15.74',0.5,'SBbc?',NULL,NULL,NULL,NULL,1,303.713291667,-18.02161,0.249,NULL,50842873848,794419903,12412810,15.74),(146431,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146431,33.83,0.32,58.3,69830,85,NULL,'I, raw','ESO 596- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146432,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146432,33.84,0.32,58.7,69830,85,NULL,'I, inv','ESO 596- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146433,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146433,33.96,0.43,61.9,69830,75,NULL,'MAT, I, raw','ESO 596- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146434,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146434,34.05,0.43,64.5,69830,75,NULL,'MAT, I, inv','ESO 596- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146435,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146435,34.41,0.43,76.2,69830,75,NULL,'MAT, I, cor','ESO 596- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146436,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146436,34.68,0.58,86.2,69830,NULL,NULL,NULL,'ESO 596- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146437,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146437,34.72,0.2,87.9,69830,74.4,NULL,NULL,'ESO 596- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146438,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146438,34.82,0.54,92,69830,NULL,NULL,'Malmquist cor.','ESO 596- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146439,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146439,35.82,0.51,146,69831,70,NULL,NULL,'2MASX J20145495-1944047',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.99',0.5,NULL,NULL,NULL,NULL,NULL,1,303.729,-19.73464,0.313,NULL,50859996725,794687448,12416991,15.99),(146440,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146440,35.61,NULL,132,69832,NULL,NULL,NULL,'FGCE 1446',NULL,'2000BSAO...50....5K',2000,1,0.73,NULL,'G',0.000023,'?','17.7',0.07,'Sd',NULL,NULL,NULL,NULL,1,303.747083,-19.85528,0.261,NULL,50859940547,794686571,12416977,17.7),(146441,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146441,37.09,0.6,262,69833,70,NULL,NULL,'2MASX J20145978-5307301',NULL,'2014MNRAS.445.2677S',2014,1,0.24,NULL,'G',0.00015,NULL,'15.6R',0.16,NULL,NULL,NULL,NULL,NULL,1,303.749167,-53.12511,0.193,NULL,51078967143,798108861,12470450,15.6),(146442,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146442,34.84,0.49,92.9,69834,75,NULL,'IR','UGC 11531',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.00005,NULL,'17.',0.1,NULL,NULL,NULL,NULL,NULL,1,303.769625,58.44294,1.349,NULL,53011492927,828304576,12942259,17),(146443,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146443,34.52,0.2,80.2,69835,74.4,NULL,NULL,'ESO 399- G 026',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000033,NULL,'14.70',0.6,'S?',NULL,NULL,NULL,NULL,1,303.777625,-37.23694,0.225,NULL,51292034122,801438033,12522469,14.7),(146444,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146444,34.66,0.29,85.4,69835,NULL,NULL,'Malmquist cor.','ESO 399- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146445,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146445,34.66,0.29,85.7,69835,NULL,NULL,NULL,'ESO 399- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146446,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146446,34.35,0.8,74.2,69836,75,NULL,'MAT, I','ESO 186- G 021',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'14.12',1,'SAB(rs)c',NULL,NULL,NULL,NULL,1,303.787375,-52.71747,0.141,NULL,51078816949,798106514,12470414,14.12),(146447,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146447,34.11,NULL,66.4,69836,NULL,NULL,'B','ESO 186- G 021',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146448,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146448,34.12,0.15,66.7,69836,NULL,NULL,'B, Hubble-type-TF','ESO 186- G 021',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146449,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146449,34.18,0.32,68.4,69836,85,NULL,'I, raw','ESO 186- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146450,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146450,34.23,0.32,70.2,69836,85,NULL,'I, inv','ESO 186- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146451,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146451,34.24,0.43,70.4,69836,75,NULL,'MAT, I, raw','ESO 186- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146452,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146452,34.31,0.37,72.7,69836,NULL,NULL,'Malmquist cor.','ESO 186- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146453,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146453,34.36,0.43,74.6,69836,75,NULL,'MAT, I, cor','ESO 186- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146454,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146454,34.4,NULL,75.9,69836,NULL,NULL,'I','ESO 186- G 021',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146455,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146455,34.41,0.4,76.3,69836,NULL,NULL,'mean','ESO 186- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146456,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146456,34.44,0.34,77.4,69836,NULL,NULL,NULL,'ESO 186- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146457,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146457,34.49,0.43,79,69836,75,NULL,'MAT, I, inv','ESO 186- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146458,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146458,34.49,0.2,79.1,69836,74.4,NULL,NULL,'ESO 186- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146459,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146459,34.56,0.47,81.8,69836,NULL,NULL,'H','ESO 186- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146460,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146460,34.66,0.46,85.7,69836,NULL,NULL,'J','ESO 186- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146461,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146461,34.68,0.45,86.3,69836,NULL,NULL,'K','ESO 186- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146462,'BL Lac Luminosity','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146462,41.98,NULL,2480,69837,70,NULL,'nucleus-to-host flux ratio, z > 0.94','PKS 2012-017',NULL,'2006AJ....132....1S',2006,1,NULL,NULL,'QSO',NULL,NULL,'17.5',NULL,'BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,303.813167,-1.62572,0.445,NULL,48019862699,750310354,11723599,17.5),(146463,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146463,37.13,0.58,266,69838,70,NULL,NULL,'2MASX J20151973-4708520',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.4b',0.3,'(R)SB(rs)0/a',NULL,NULL,NULL,NULL,1,303.8322917,-47.14775,0.121,NULL,51129835815,798903684,12482870,16.4),(146464,'GRB','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'N',146464,41.66,NULL,1400,69839,71,NULL,NULL,'GRB 061122 HOST',0.54,'2013MNRAS.431.3550G',2013,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146465,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146465,36.11,0.52,166,69840,70,NULL,NULL,'IC 4974 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.57',NULL,'Compact',NULL,NULL,NULL,NULL,1,303.858875,-61.85767,0.089,NULL,49154547465,768039804,12000621,15.57),(146466,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146466,34.89,0.43,94.9,69841,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-51-004',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.000023,NULL,'14.5',0.5,NULL,NULL,NULL,NULL,NULL,1,303.9160417,-13.62203,0.341,NULL,47935682677,748995041,11703047,14.5),(146467,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146467,35.26,0.62,113,69842,70,NULL,NULL,'IC 4976',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.58',0.4,'(R)SB(r)a:',NULL,NULL,NULL,NULL,1,303.921083333,-61.87514,0.089,NULL,49154546118,768039783,12000621,15.58),(146468,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146468,33.8,0.49,57.6,69843,75,NULL,'IR','ESO 284- G 036',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000033,NULL,'15.77',0.3,'Sb',NULL,NULL,NULL,NULL,1,303.934917,-43.13339,0.105,NULL,51089490748,798273292,12473020,15.77),(146469,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146469,33.93,0.55,61.1,69843,NULL,NULL,NULL,'ESO 284- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146470,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146470,33.97,0.2,62.2,69843,74.4,NULL,NULL,'ESO 284- G 036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146471,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146471,34.34,0.46,73.8,69843,NULL,NULL,'Malmquist cor.','ESO 284- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146472,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146472,34.19,0.8,69,69844,75,NULL,'MAT, I','MCG -01-51-001',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000017,NULL,'15',0.5,'SB(rs)bc?      HII',NULL,NULL,NULL,NULL,1,303.9535,-2.90047,0.413,NULL,48018641627,750291275,11723301,15),(146473,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146473,33.84,0.32,58.7,69844,85,NULL,'I, raw','MCG -01-51-001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146474,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146474,33.87,0.43,59.5,69844,75,NULL,'MAT, I, raw','MCG -01-51-001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146475,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146475,33.88,0.32,59.8,69844,85,NULL,'I, inv','MCG -01-51-001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146476,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146476,33.91,0.2,60.5,69844,74.4,NULL,NULL,'MCG -01-51-001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146477,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146477,34.05,0.43,64.6,69844,75,NULL,'MAT, I, inv','MCG -01-51-001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146478,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146478,34.12,0.38,66.8,69844,NULL,NULL,NULL,'MCG -01-51-001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146479,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146479,34.22,0.43,69.9,69844,75,NULL,'MAT, I, cor','MCG -01-51-001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146480,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146480,34.34,0.35,73.7,69844,NULL,NULL,'Malmquist cor.','MCG -01-51-001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146481,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146481,36.53,0.83,203,69845,70,NULL,NULL,'2MASX J20155152-4426150',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,303.9647083,-44.43753,0.049,NULL,51102957166,798483705,12476307,14.3),(146482,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146482,36.05,0.48,162,69846,70,NULL,NULL,'2MASX J20155293-5316223',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.2I',0.7,NULL,NULL,NULL,NULL,NULL,1,303.970625,-53.27289,0.197,NULL,51078925375,798108208,12470440,13.2),(146483,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146483,35.06,0.48,103,69847,70,NULL,NULL,'ESO 284- G 037',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.0001,NULL,'14.49',0.6,'SA0^0',NULL,NULL,NULL,NULL,1,303.981625,-46.15058,0.057,NULL,51097976575,798405883,12475091,14.49),(146484,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146484,35.4,0.52,120,69848,70,NULL,NULL,'2MASX J20155569-4418490',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.5I',0.5,NULL,NULL,NULL,NULL,NULL,1,303.982167,-44.31361,0.077,NULL,51100910491,798451726,12475808,13.5),(146485,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146485,34.15,0.8,67.6,69849,75,NULL,'MAT, I','ESO 284- G 039',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'14.61',0.7,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,304.027125,-44.42164,0.049,NULL,51102950623,798483603,12476306,14.61),(146486,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146486,32.52,0.32,31.9,69849,85,NULL,'I, raw','ESO 284- G 039',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146487,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146487,32.53,0.32,32,69849,85,NULL,'I, inv','ESO 284- G 039',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146488,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146488,33.18,0.43,43.3,69849,75,NULL,'MAT, I, raw','ESO 284- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146489,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146489,33.31,0.43,45.9,69849,75,NULL,'MAT, I, inv','ESO 284- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146490,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146490,33.57,0.43,51.9,69849,75,NULL,'MAT, I, cor','ESO 284- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146491,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146491,34.38,0.4,75.3,69849,NULL,NULL,'mean','ESO 284- G 039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146492,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146492,34.49,0.47,79,69849,NULL,NULL,'H','ESO 284- G 039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146493,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146493,33.73,0.54,55.8,69850,70,NULL,NULL,'ESO 233- G 049',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00005,NULL,'13.93',1,'SA(rs)0-?',NULL,NULL,NULL,NULL,1,304.040667,-49.31322,0.113,NULL,51133265540,798957274,12483707,13.93),(146494,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146494,36.07,0.65,164,69851,70,NULL,NULL,'IC 4984',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.39',0.5,'Sa-b',NULL,NULL,NULL,NULL,1,304.0727083,-52.70372,0.141,NULL,51078795723,798106183,12470409,15.39),(146495,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146495,33.89,0.71,60,69852,NULL,NULL,NULL,'ESO 400- G 002',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.75',0.3,'S...','in a pair',NULL,NULL,NULL,1,304.07925,-37.01533,0.233,NULL,51292046237,801438222,12522472,15.75),(146496,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146496,33.93,0.2,61.1,69852,74.4,NULL,NULL,'ESO 400- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146497,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146497,34.34,0.58,73.9,69852,NULL,NULL,'Malmquist cor.','ESO 400- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146498,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146498,33.97,0.58,62.2,69853,NULL,NULL,NULL,'ESO 284- G 043',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'14.51',0.6,'SB(s)dm',NULL,NULL,NULL,NULL,1,304.1294583,-44.70911,0.009,NULL,51102976545,798484008,12476312,14.51),(146499,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146499,34.01,0.2,63.4,69853,74.4,NULL,NULL,'ESO 284- G 043',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146500,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146500,34.29,0.5,72.2,69853,NULL,NULL,'Malmquist cor.','ESO 284- G 043',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146501,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146501,34.02,0.48,63.6,69854,70,NULL,NULL,'ESO 284- G 044',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000087,NULL,'13.59',1.1,'SAB0^0',NULL,NULL,NULL,NULL,1,304.14925,-46.966,0.105,NULL,51097186292,798393535,12474898,13.59),(146502,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146502,35.16,0.64,108,69855,70,NULL,NULL,'2MASX J20164318-4545529',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,304.179875,-45.76469,0,NULL,51097733867,798402091,12475032,14.4),(146503,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146503,34.39,0.8,75.5,69856,75,NULL,'MAT, I','ESO 400- G 005',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000013,NULL,'14.05',0.9,'SA(s)c','in a pair',NULL,NULL,NULL,1,304.213125,-36.98697,0.217,NULL,51291262657,801425979,12522280,14.05),(146504,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146504,33.6,0.32,52.5,69856,85,NULL,'I, raw','ESO 400- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146505,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146505,33.62,0.43,52.9,69856,75,NULL,'MAT, I, raw','ESO 400- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146506,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146506,33.64,0.32,53.5,69856,85,NULL,'I, inv','ESO 400- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146507,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146507,33.81,0.43,57.8,69856,75,NULL,'MAT, I, inv','ESO 400- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146508,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146508,34.12,0.43,66.8,69856,75,NULL,'MAT, I, cor','ESO 400- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146509,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146509,34.21,0.2,69.5,69856,74.4,NULL,NULL,'ESO 400- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146510,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146510,34.37,0.31,75,69856,NULL,NULL,NULL,'ESO 400- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146511,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146511,34.48,0.47,78.7,69856,NULL,NULL,'H','ESO 400- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146512,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146512,34.53,0.29,80.5,69856,NULL,NULL,'Malmquist cor.','ESO 400- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146513,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146513,34.57,0.4,81.9,69856,NULL,NULL,'mean','ESO 400- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146514,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146514,34.59,0.46,82.7,69856,NULL,NULL,'J','ESO 400- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146515,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146515,34.62,0.45,84.1,69856,NULL,NULL,'K','ESO 400- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146516,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146516,33.19,0.81,43.5,69857,NULL,NULL,NULL,'ESO 233- G 050',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.81',0.6,'SA(s)b',NULL,NULL,NULL,NULL,1,304.2617917,-47.77114,0.117,NULL,51130623893,798915998,12483062,14.81),(146517,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146517,33.23,0.2,44.3,69857,74.4,NULL,NULL,'ESO 233- G 050',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146518,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146518,33.43,0.73,48.5,69857,NULL,NULL,'Malmquist cor.','ESO 233- G 050',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146519,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146519,34.69,0.5,86.9,69858,70,NULL,NULL,'MCG -07-41-022',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00009,NULL,'15',0.15,NULL,NULL,NULL,NULL,NULL,1,304.2714583,-43.58494,0.093,NULL,51100699357,798448427,12475756,15),(146520,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146520,32,0.8,25.1,69859,75,NULL,'MAT, I','IC 4986',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.00001,NULL,'14.13',0.9,'SAB(s)dm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,304.2985417,-55.03639,0.217,NULL,48997530090,765586407,11962287,14.13),(146521,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146521,31.99,0.32,25,69859,85,NULL,'I, inv','IC 4986',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146522,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146522,32,0.32,25.1,69859,85,NULL,'I, raw','IC 4986',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146523,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146523,32.26,0.43,28.3,69859,75,NULL,'MAT, I, raw','IC 4986',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146524,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146524,32.27,0.43,28.5,69859,75,NULL,'MAT, I, inv','IC 4986',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146525,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146525,32.55,0.46,32.4,69859,NULL,NULL,NULL,'IC 4986',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146526,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146526,32.59,0.2,33,69859,74.4,NULL,NULL,'IC 4986',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146527,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146527,32.64,0.43,33.7,69859,75,NULL,'MAT, I, cor','IC 4986',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146528,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146528,32.87,0.4,37.5,69859,NULL,NULL,'Malmquist cor.','IC 4986',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146529,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146529,32.73,0.8,35.2,69860,75,NULL,'MAT, I','ESO 340- G 008',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.00001,NULL,'15.39',0.2,'Scd',NULL,NULL,NULL,NULL,1,304.299083,-40.92372,0.153,NULL,51087224791,798237887,12472466,15.39),(146530,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146530,32.93,0.4,38.5,69860,75,NULL,NULL,'ESO 340- G 008',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146531,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146531,33.02,0.32,40.1,69860,85,NULL,'I, inv','ESO 340- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146532,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146532,33.03,0.32,40.3,69860,85,NULL,'I, raw','ESO 340- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146533,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146533,33.15,NULL,42.7,69860,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 340- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146534,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146534,33.16,NULL,42.9,69860,NULL,NULL,'Dipole','ESO 340- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146535,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146535,33.17,NULL,43,69860,NULL,NULL,'Dipole + Quadrupole','ESO 340- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146536,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146536,33.2,0.43,43.7,69860,75,NULL,'MAT, I, raw','ESO 340- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146537,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146537,33.23,0.43,44.2,69860,75,NULL,'MAT, I, inv','ESO 340- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146538,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146538,33.24,0.59,44.6,69860,NULL,NULL,'Malmquist cor.','ESO 340- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146539,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146539,33.25,NULL,44.7,69860,NULL,NULL,NULL,'ESO 340- G 008',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146540,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146540,33.34,0.56,46.5,69860,NULL,NULL,NULL,'ESO 340- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146541,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146541,33.38,0.2,47.4,69860,74.4,NULL,NULL,'ESO 340- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146542,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146542,33.46,0.49,49.3,69860,75,NULL,'IR','ESO 340- G 008',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146543,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146543,33.65,0.43,53.7,69860,75,NULL,'MAT, I, cor','ESO 340- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146544,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146544,35.33,0.52,116,69861,70,NULL,NULL,'ESO 233- G 051',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.65',0.2,'Compact:',NULL,NULL,NULL,NULL,1,304.302166667,-52.11622,0.149,NULL,51080641141,798135017,12470859,15.65),(146545,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146545,36.35,0.61,186,69862,70,NULL,NULL,'2MASX J20171347-6502314',NULL,'2014MNRAS.445.2677S',2014,1,0.26,NULL,'G',0.00015,NULL,'15.6R',0.17,NULL,NULL,NULL,NULL,NULL,1,304.305917,-65.04208,0.137,NULL,49374557565,771477461,12054335,15.6),(146546,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146546,35.56,0.69,130,69863,70,NULL,NULL,'2MASX J20171553-7913453',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,304.3147083,-79.22919,0.569,NULL,48579674936,759057420,11860272,16.7),(146547,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146547,36.56,0.59,206,69864,70,NULL,NULL,'2MASX J20171638-1906113',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.36',0.4,NULL,NULL,NULL,NULL,NULL,1,304.3182083,-19.10314,0.225,NULL,50858375510,794662117,12416595,16.36),(146548,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146548,32.53,0.8,32.1,69865,75,NULL,'MAT, I','NGC 6887',NULL,'1997ApJS..109..333W',1997,1,3.4,NULL,'G',0.000021,NULL,'12.82',1.3,'SAB(rs)bc',NULL,NULL,NULL,NULL,1,304.322041667,-52.79675,0.141,NULL,51081660302,798150942,12471108,12.82),(146549,'Tully est','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146549,32.67,0.8,34.2,69865,75,NULL,'B','NGC 6887',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146550,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146550,32.37,0.47,29.8,69865,NULL,NULL,'H','NGC 6887',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146551,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146551,32.39,0.4,30.1,69865,NULL,NULL,NULL,'NGC 6887',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146552,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146552,32.4,0.46,30.2,69865,NULL,NULL,'J','NGC 6887',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146553,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146553,32.48,0.45,31.4,69865,NULL,NULL,'K','NGC 6887',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146554,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146554,32.5,0.43,31.7,69865,75,NULL,'MAT, I, raw','NGC 6887',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146555,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146555,32.52,0.32,31.9,69865,85,NULL,'I, raw','NGC 6887',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146556,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146556,32.58,0.32,32.8,69865,85,NULL,'I, inv','NGC 6887',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146557,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146557,32.72,0.4,35,69865,NULL,NULL,'mean','NGC 6887',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146558,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146558,32.72,NULL,35,69865,NULL,NULL,'B','NGC 6887',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146559,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146559,32.73,NULL,35.2,69865,NULL,NULL,'I','NGC 6887',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146560,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146560,32.75,0.43,35.5,69865,75,NULL,'MAT, I, inv','NGC 6887',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146561,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146561,32.86,0.43,37.3,69865,75,NULL,'MAT, I, cor','NGC 6887',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146562,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146562,32.52,0.8,31.9,69866,75,NULL,'MAT, I','ESO 340- G 009',NULL,'1997ApJS..109..333W',1997,1,2.44,NULL,'G',0.000017,NULL,'14.48',0.32,'Sdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,304.3355,-38.67375,0.185,NULL,51288924944,801389452,12521710,14.48),(146563,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146563,32.14,0.2,26.8,69866,74.4,NULL,NULL,'ESO 340- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146564,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146564,32.23,0.43,28,69866,75,NULL,'3.6 micron, color corrected','ESO 340- G 009',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146565,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146565,32.24,0.43,28,69866,75,NULL,'3.6 micron, color + selection bias corrected','ESO 340- G 009',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146566,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146566,32.36,0.4,29.6,69866,NULL,NULL,NULL,'ESO 340- G 009',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146567,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146567,32.51,NULL,31.8,69866,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 340- G 009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146568,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146568,32.53,NULL,32.1,69866,NULL,NULL,'Dipole + Quadrupole','ESO 340- G 009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146569,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146569,32.54,0.4,32.2,69866,75,NULL,NULL,'ESO 340- G 009',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146570,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146570,32.55,NULL,32.3,69866,NULL,NULL,'Dipole','ESO 340- G 009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146571,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146571,32.56,0.32,32.5,69866,85,NULL,'I, inv','ESO 340- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146572,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146572,32.57,0.32,32.7,69866,85,NULL,'I, raw','ESO 340- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146573,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146573,32.75,0.43,35.5,69866,75,NULL,'MAT, I, raw','ESO 340- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146574,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146574,32.76,0.43,35.7,69866,75,NULL,'MAT, I, inv','ESO 340- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146575,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146575,32.87,NULL,37.5,69866,NULL,NULL,NULL,'ESO 340- G 009',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146576,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146576,32.95,0.43,38.9,69866,75,NULL,'MAT, I, cor','ESO 340- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146577,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146577,32.99,0.49,39.6,69866,75,NULL,'IR','ESO 340- G 009',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146578,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146578,34.43,0.6,76.9,69867,70,NULL,NULL,'2MASX J20172214-5317101',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00015,NULL,'14.3R',0.21,NULL,NULL,NULL,NULL,NULL,1,304.342417,-53.28617,0.197,NULL,51078900316,798107817,12470434,14.3),(146579,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146579,32.96,0.8,39.1,69868,75,NULL,'MAT, I','IC 4964',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'13.40',0.7,'SB(s)cd',NULL,NULL,NULL,NULL,1,304.3497083,-73.88564,0.197,NULL,48488206182,757628221,11837940,13.4),(146580,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146580,32.08,0.32,26.1,69868,85,NULL,'I, inv','IC 4964',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146581,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146581,32.11,0.32,26.4,69868,85,NULL,'I, raw','IC 4964',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146582,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146582,32.38,0.43,29.9,69868,75,NULL,'MAT, I, inv','IC 4964',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146583,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146583,32.42,0.43,30.4,69868,75,NULL,'MAT, I, raw','IC 4964',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146584,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146584,32.76,0.43,35.7,69868,75,NULL,'MAT, I, cor','IC 4964',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146585,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146585,32.97,0.4,39.3,69868,NULL,NULL,NULL,'IC 4964',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146586,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146586,37.01,0.78,252,69869,70,NULL,NULL,'2MASX J20172524-6331104',NULL,'2014MNRAS.445.2677S',2014,1,0.27,NULL,'G',0.00015,NULL,'15.6R',0.19,NULL,NULL,NULL,NULL,NULL,1,304.355125,-63.51947,0.149,NULL,49141709888,767839217,11997487,15.6),(146587,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146587,33.71,NULL,55.2,69870,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2266',NULL,'2010Ap&SS.325..163P',2010,1,0.93,NULL,'G',0.00001,NULL,'16.3',0.13,'Sbc',NULL,NULL,NULL,NULL,1,304.3712917,-10.84742,0.229,NULL,48002249281,750035145,11719299,16.3),(146588,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146588,33.72,NULL,55.5,69870,NULL,NULL,'Dipole + Quadrupole','FGC 2266',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146589,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146589,33.75,NULL,56.2,69870,NULL,NULL,'Dipole','FGC 2266',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146590,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146590,35.24,0.51,112,69871,70,NULL,NULL,'ESO 596- G 015',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000123,NULL,'15.81',1,'S0',NULL,NULL,NULL,NULL,1,304.434041667,-22.23917,0.269,NULL,50863188153,794737314,12417770,15.81),(146591,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146591,37.62,0.57,334,69872,70,NULL,NULL,'2MASX J20174521-4621013',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,304.4385417,-46.35042,0.041,NULL,51098129641,798408275,12475129,16.9),(146592,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146592,36.36,0.65,187,69873,70,NULL,NULL,'2MASX J20175279-1210435',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,304.470041667,-12.17883,0.277,NULL,48002022360,750031599,11719243,14.1),(146593,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146593,35.5,0.53,126,69874,70,NULL,NULL,'2MASX J20175838-2156572',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000117,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,304.493167,-21.94922,0.297,NULL,50862405649,794725088,12417579,14.8),(146594,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146594,35.12,0.48,106,69875,70,NULL,NULL,'ESO 284- G 051',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00012,NULL,'14.30',0.7,'SB0^-','Pair member (points to parent)',NULL,NULL,NULL,1,304.513625,-45.51925,0,NULL,51097694984,798401484,12475023,14.3),(146595,'Tully est','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146595,32.51,0.8,31.8,69876,75,NULL,'B','NGC 6890',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.000083,NULL,'13.01',1.2,'(R\')SA(r:)ab   Sy2','Group member',NULL,NULL,'Sy 1.9',1,304.575417,-44.80672,0.033,NULL,51100798982,798449984,12475781,13.01),(146596,'SBF','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146596,33.35,0.38,46.8,69877,NULL,NULL,NULL,'NGC 6876',NULL,'2001MNRAS.327.1004B',2001,1,2.8,NULL,'G',0.000053,NULL,'12.06',2.2,'SB0^-','in a pair',NULL,NULL,NULL,1,304.5797917,-70.85881,0.161,NULL,49214627277,768978551,12015289,12.06),(146597,'SBF','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146597,33.53,0.38,50.9,69877,NULL,NULL,'Malmquist cor.','NGC 6876',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146598,'D-Sigma','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146598,32.54,0.4,32.2,69877,75,NULL,'Edat, raw','NGC 6876',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146599,'D-Sigma','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146599,32.88,0.4,37.6,69877,75,NULL,'Edat, cor','NGC 6876',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146600,'Faber-Jackson','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146600,32.62,0.65,33.4,69877,95,NULL,'Weighted Mean','NGC 6876',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146601,'Faber-Jackson','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146601,34.22,0.81,69.8,69877,55,NULL,'Visvanathan & Sandage 1979','NGC 6876',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146602,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146602,32.57,0.41,32.6,69877,NULL,NULL,NULL,'NGC 6876',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146603,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146603,32.97,0.41,39.2,69877,NULL,NULL,'Malmquist cor.','NGC 6876',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146604,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146604,32.71,0.3,34.8,69877,NULL,NULL,'Pavo I GROUP, 5 galaxies','NGC 6876',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146605,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146605,32.83,0.45,36.8,69877,NULL,NULL,'K','NGC 6876',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146606,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146606,33.71,0.4,55.2,69877,NULL,NULL,'mean','NGC 6876',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146607,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146607,35.3,0.49,115,69878,70,NULL,NULL,'2MASX J20182212-4153472',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00009,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,304.59225,-41.89653,0.145,NULL,51090067543,798282305,12473161,14.4),(146608,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146608,34.24,0.49,70.6,69879,75,NULL,'IR','ESO 462- G 007',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.000023,NULL,'15.48',0.2,'Sb-c',NULL,NULL,NULL,NULL,1,304.594666667,-27.45481,0.361,NULL,51327460881,801991576,12531118,15.48),(146609,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146609,34.57,0.2,82,69879,74.4,NULL,NULL,'ESO 462- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146610,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146610,34.57,0.31,82.1,69879,NULL,NULL,NULL,'ESO 462- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146611,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146611,34.65,0.3,85.3,69879,NULL,NULL,'Malmquist cor.','ESO 462- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146612,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146612,34.27,0.46,71.5,69880,70,NULL,NULL,'IC 4991',NULL,'2014MNRAS.445.2677S',2014,1,2.6,NULL,'G',0.000073,NULL,'11.56',1.8,'SA(r)0^0^? pec',NULL,NULL,NULL,NULL,1,304.597,-41.05017,0.145,NULL,51372251696,802691432,12542053,11.56),(146613,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146613,31.25,0.4,17.8,69881,NULL,NULL,'mean','UGC 11539',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'GPair',0.000097,NULL,NULL,NULL,'E',NULL,NULL,NULL,NULL,1,304.63375,62.69056,0.857,NULL,53466151431,835408616,13053259,NULL),(146614,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146614,32.81,0.45,36.6,69881,NULL,NULL,'K','UGC 11539',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146615,'Tully est','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146615,32.74,0.8,35.3,69882,75,NULL,'B','ESO 340- G 012',NULL,'1988NBGC.C....0000T',1988,1,1.1,NULL,'G',0.000083,NULL,'13.8b',1,'SAB(rs)cd:','in a pair',NULL,NULL,NULL,1,304.638041667,-39.33678,0.161,NULL,51506231288,804784863,12574763,13.8),(146616,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146616,34.17,0.8,68.1,69883,75,NULL,'MAT, I','UGC 11537',NULL,'1997ApJS..109..333W',1997,1,2.4,'1998A&AS..130..333T has V = 5416 +- 2 km/sec.','G',0.00003,NULL,'14.34',0.7,'Sc:',NULL,NULL,NULL,NULL,1,304.6587083,-0.1505,0.413,NULL,47798927655,746858244,11669660,14.34),(146617,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146617,33.73,0.49,55.6,69883,75,NULL,'IR','UGC 11537',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146618,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146618,33.86,0.43,59.2,69883,75,NULL,'MAT, I, raw','UGC 11537',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146619,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146619,33.88,0.46,59.8,69883,NULL,NULL,'J','UGC 11537',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146620,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146620,33.89,0.47,60,69883,NULL,NULL,'H','UGC 11537',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146621,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146621,34.01,0.45,63.5,69883,NULL,NULL,'K','UGC 11537',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146622,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146622,34.03,0.32,63.9,69883,85,NULL,'I, raw','UGC 11537',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146623,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146623,34.05,0.2,64.6,69883,74.4,NULL,NULL,'UGC 11537',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146624,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146624,34.09,0.36,65.8,69883,NULL,NULL,NULL,'UGC 11537',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146625,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146625,34.11,0.32,66.3,69883,85,NULL,'I, inv','UGC 11537',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146626,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146626,34.18,0.43,68.5,69883,75,NULL,'MAT, I, inv','UGC 11537',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146627,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146627,34.18,0.4,68.5,69883,NULL,NULL,'mean','UGC 11537',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146628,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146628,34.18,0.35,68.5,69883,NULL,NULL,'Malmquist cor.','UGC 11537',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146629,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146629,34.2,0.43,69.3,69883,75,NULL,'MAT, I, cor','UGC 11537',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146630,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146630,34.22,0.43,70,69883,75,NULL,'3.6 micron, color corrected','UGC 11537',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146631,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146631,34.49,0.43,79.2,69883,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11537',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146632,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146632,36.01,0.7,159,69884,70,NULL,NULL,'2MASX J20184365-4541562',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,304.681875,-45.69889,0.033,NULL,51097678864,798401232,12475019,15.7),(146633,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146633,32.6,0.4,33.2,69885,NULL,NULL,'mean','NGC 6889',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.00001,NULL,'13.68',1.1,'SBbc? pec',NULL,NULL,NULL,NULL,1,304.721791667,-53.95708,0.197,NULL,51078738333,798105286,12470395,13.68),(146634,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146634,32.68,0.47,34.4,69885,NULL,NULL,'H','NGC 6889',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146635,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146635,32.75,0.46,35.4,69885,NULL,NULL,'J','NGC 6889',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146636,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146636,32.79,0.45,36.2,69885,NULL,NULL,'K','NGC 6889',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146637,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146637,34.84,0.48,92.8,69886,70,NULL,NULL,'MCG -07-41-027',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000067,NULL,'15.5',0.3,NULL,NULL,NULL,NULL,NULL,1,304.737375,-41.26942,0.145,NULL,51372141600,802689712,12542026,15.5),(146638,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146638,36.31,0.53,182,69887,70,NULL,NULL,'2MASX J20190248-5743204',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,304.760417,-57.72228,0.133,NULL,49045723698,766339432,11974053,14),(146639,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146639,35.66,0.58,136,69888,70,NULL,NULL,'2MASX J20190372-0108522',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000097,NULL,'13.4I',0.6,NULL,NULL,NULL,NULL,NULL,1,304.765583,-1.14781,0.417,NULL,47802320905,746911264,11670488,13.4),(146640,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146640,36.25,0.71,178,69889,70,NULL,NULL,'2MASX J20190627-5237445',NULL,'2014MNRAS.445.2677S',2014,1,0.23,NULL,'G',0.00015,NULL,'15.4R',0.2,NULL,NULL,NULL,NULL,NULL,1,304.776167,-52.62906,0.125,NULL,51081864440,798154131,12471158,15.4),(146641,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 15171','R',146641,39.11,0.18,582,69890,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006kb','SN 2006kb',0.1392,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,304.7925417,-1.0645,0.397,NULL,47802466009,746913531,11670523,NULL),(146642,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 15171','R',146642,39.38,0.07,660,69890,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006kb','SN 2006kb',0.1392,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146643,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146643,36.14,0.55,169,69891,70,NULL,NULL,'2MASX J20191315-1942221',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.09',NULL,NULL,NULL,NULL,NULL,NULL,1,304.80475,-19.70608,0.205,NULL,50858607017,794665734,12416652,16.09),(146644,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146644,36.45,0.73,195,69892,70,NULL,NULL,'2MASX J20191656-1046034',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,304.819083,-10.76758,0.213,NULL,48002909213,750045456,11719460,15.6),(146645,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146645,36.2,0.53,174,69893,70,NULL,NULL,'2MASX J20192466-5244464',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'14.9R',0.3,NULL,NULL,NULL,NULL,NULL,1,304.85275,-52.74622,0.125,NULL,51081842919,798153795,12471153,14.9),(146646,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146646,35.7,0.56,138,69894,70,NULL,NULL,'2MASX J20193137-6539143',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'14.5R',0.29,NULL,NULL,NULL,NULL,NULL,1,304.880667,-65.65392,0.125,NULL,49374741193,771480331,12054380,14.5),(146647,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146647,32.26,0.4,28.3,69895,NULL,NULL,NULL,'NGC 6911',NULL,'2009AJ....138..323T',2009,1,1.7,NULL,'G',0.000027,NULL,'15.1',1.1,'SBb:',NULL,NULL,NULL,NULL,1,304.909708333,66.72833,0.781,NULL,53648375979,838255874,13097748,15.1),(146648,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146648,32.44,0.45,30.8,69895,NULL,NULL,'K','NGC 6911',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146649,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146649,32.49,0.46,31.5,69895,NULL,NULL,'J','NGC 6911',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146650,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146650,32.55,0.43,32.3,69895,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6911',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146651,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146651,32.55,0.2,32.4,69895,74.4,NULL,NULL,'NGC 6911',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146652,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146652,32.57,0.47,32.7,69895,NULL,NULL,'H','NGC 6911',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146653,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146653,32.62,0.43,33.4,69895,75,NULL,'3.6 micron, color corrected','NGC 6911',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146654,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146654,32.74,0.4,35.3,69895,NULL,NULL,'mean','NGC 6911',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146655,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146655,34.37,0.57,74.9,69896,70,NULL,NULL,'2MASX J20193988-4944212',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.000063,NULL,'14.1R',0.28,NULL,NULL,NULL,NULL,NULL,1,304.9162083,-49.73933,0.109,NULL,51131256504,798925882,12483216,14.1),(146656,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146656,36.28,0.64,180,69897,70,NULL,NULL,'2MASX J20194084-5236312',NULL,'2014MNRAS.445.2677S',2014,1,0.21,NULL,'G',0.00015,NULL,'15.6R',0.18,NULL,NULL,NULL,NULL,NULL,1,304.920125,-52.60869,0.125,NULL,51081802610,798153165,12471143,15.6),(146657,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146657,32.98,0.43,39.5,69898,75,NULL,'3.6 micron, color + selection bias corrected','ESO 340-IG 017',NULL,'2014MNRAS.444..527S',2014,1,2.6,NULL,'G',0.000013,NULL,'13.18',0.9,'SB(s)dm: pec','in a pair',NULL,NULL,NULL,1,304.923625,-39.28861,0.121,NULL,51507049687,804797651,12574963,13.18),(146658,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146658,36.72,0.67,221,69899,70,NULL,NULL,'2MASX J20194208-5257092',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'15.6R',0.11,NULL,NULL,NULL,NULL,NULL,1,304.925583,-52.95258,0.181,NULL,51081840917,798153764,12471152,15.6),(146659,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146659,35.93,0.49,154,69900,70,NULL,NULL,'2MASX J20194340-2947426',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,304.930916667,-29.79517,0.301,NULL,51338068736,802157324,12533708,14.8),(146660,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146660,33.98,0.47,62.5,69901,70,NULL,NULL,'IC 4994',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00015,NULL,'13.89',1.3,'SA0^0^: pec',NULL,NULL,NULL,NULL,1,304.9355,-53.44736,0.185,NULL,51082044082,798156938,12471202,13.89),(146661,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146661,36.29,0.53,181,69902,70,NULL,NULL,'2MASX J20194685-6645425',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'14.9R',0.26,'(R_1R\'_2)SB(s)a',NULL,NULL,NULL,NULL,1,304.94525,-66.76175,0.093,NULL,49366778214,771355909,12052436,14.9),(146662,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146662,35.97,0.64,157,69903,70,NULL,NULL,'2MASX J20195437-0314263',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,304.976583,-3.24081,0.321,NULL,47805437457,746959960,11671249,14),(146663,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146663,34.86,0.46,93.6,69904,NULL,NULL,'Malmquist cor.','ESO 400- G 008',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.78',0.7,'S...',NULL,NULL,NULL,NULL,1,304.983875,-37.20883,0.213,NULL,51289658972,801400921,12521889,15.78),(146664,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146664,34.96,0.44,98.1,69904,NULL,NULL,NULL,'ESO 400- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146665,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146665,35,0.2,100,69904,74.4,NULL,NULL,'ESO 400- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146666,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 12928','R',146666,39.08,0.21,574,69905,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ew','SN 2006ew',0.1397,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,305.0090417,-0.97569,0.397,NULL,47802393489,746912398,11670506,NULL),(146667,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 12928','R',146667,39.09,0.15,576,69905,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ew','SN 2006ew',0.1397,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146668,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146668,35.43,0.52,122,69906,70,NULL,NULL,'2MASX J20200342-1459382',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,305.01425,-14.99392,0.237,NULL,50836982786,794327856,12411372,14),(146669,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146669,35.21,0.51,110,69907,70,NULL,NULL,'2MASX J20200429-5856111',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,305.017875,-58.93644,0.133,NULL,49044641511,766322523,11973789,14.4),(146670,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146670,37.41,0.8,303,69908,70,NULL,NULL,'2MASX J20201020-6719199',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,'SB(r)b',NULL,NULL,NULL,NULL,1,305.042583,-67.32228,0.109,NULL,49366572273,771352691,12052385,14.9),(146671,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146671,35.72,0.58,139,69909,70,NULL,NULL,'2MASX J20201104-1944142',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.7I',0.4,NULL,NULL,NULL,NULL,NULL,1,305.046083,-19.73742,0.205,NULL,50858576145,794665252,12416644,13.7),(146672,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146672,37.09,0.66,262,69910,70,NULL,NULL,'2MASX J20201376-5314475',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,305.057208333,-53.24658,0.185,NULL,51082216714,798159636,12471244,15.5),(146673,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2005iu',NULL,146673,37.11,0.12,242,69911,74.2,NULL,'SALT 2','2MASX J20201665+0012557',0.09,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,305.069417,0.21544,0.473,NULL,53992805710,843637589,13181837,NULL),(146674,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2005iu',NULL,146674,37.87,0.05,344,69911,70,NULL,'SDSS-II SN 06773','2MASX J20201665+0012557',0.09,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146675,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 06773','R',146675,37.92,0.19,352,69911,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005iu','2MASX J20201665+0012557',0.09,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146676,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2005iu',NULL,146676,37.96,0.09,359,69911,65,NULL,'SALT2','2MASX J20201665+0012557',0.09,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146677,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 06773','R',146677,38.11,0.07,384,69911,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005iu','2MASX J20201665+0012557',0.09,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146678,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2005iu',NULL,146678,38.11,0.11,384,69911,65,NULL,'MLCS2k2','2MASX J20201665+0012557',0.09,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146679,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146679,34.96,0.48,98.3,69912,70,NULL,NULL,'ESO 234- G 003',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000073,NULL,'14.99',0.3,'N',NULL,NULL,NULL,NULL,1,305.120666667,-51.62297,0.109,NULL,51081256978,798144640,12471010,14.99),(146680,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146680,37.18,0.54,273,69913,70,NULL,NULL,'2MASX J20203217-2109062',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.22',0.3,NULL,NULL,NULL,NULL,NULL,1,305.134125,-21.15172,0.237,NULL,50865150267,794767972,12418249,16.22),(146681,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146681,36.15,0.53,170,69914,70,NULL,NULL,'2MASX J20203458-1222250',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.6I',0.4,NULL,NULL,NULL,NULL,NULL,1,305.1442083,-12.37358,0.241,NULL,47932919991,748951874,11702373,13.6),(146682,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146682,37.2,0.58,276,69915,70,NULL,NULL,'2MASX J20204325-5303506',NULL,'2014MNRAS.445.2677S',2014,1,0.26,NULL,'G',0.00015,NULL,'15.5R',0.12,NULL,NULL,NULL,NULL,NULL,1,305.180375,-53.06414,0.181,NULL,51082394277,798162410,12471287,15.5),(146683,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146683,35.99,0.64,158,69916,70,NULL,NULL,'2MASX J20204437-1909293',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,305.184875,-19.15814,0.249,NULL,50858945389,794671021,12416734,14.9),(146684,'SNII optical','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2000dc',NULL,146684,32.93,0.14,37.8,69917,NULL,NULL,'SEAM','ESO 527- G 019',0.010397,'2009ApJ...694.1067P',2009,1,1.4,NULL,'G',0.000013,NULL,'13.2B',0.9,'SB(r)b:',NULL,NULL,NULL,NULL,1,305.1905,-24.12819,0.273,NULL,50805670122,793838595,12403728,13.2),(146685,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146685,32.97,0.8,39.3,69917,75,NULL,'MAT, I','ESO 527- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146686,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146686,32.95,0.43,38.9,69917,75,NULL,'3.6 micron, color + selection bias corrected','ESO 527- G 019',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146687,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146687,33.01,0.43,39.9,69917,75,NULL,'3.6 micron, color corrected','ESO 527- G 019',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146688,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146688,33.11,0.2,41.9,69917,74.4,NULL,NULL,'ESO 527- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146689,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146689,33.16,0.32,42.8,69917,85,NULL,'I, raw','ESO 527- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146690,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146690,33.19,0.32,43.5,69917,85,NULL,'I, inv','ESO 527- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146691,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146691,33.24,0.4,44.4,69917,NULL,NULL,'mean','ESO 527- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146692,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146692,33.29,0.54,45.4,69917,NULL,NULL,'Malmquist cor.','ESO 527- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146693,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146693,33.32,0.53,46.1,69917,NULL,NULL,NULL,'ESO 527- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146694,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146694,33.45,0.43,49,69917,75,NULL,'MAT, I, raw','ESO 527- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146695,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146695,33.64,0.43,53.4,69917,75,NULL,'MAT, I, inv','ESO 527- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146696,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146696,33.76,0.46,56.6,69917,NULL,NULL,'J','ESO 527- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146697,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146697,33.81,0.47,57.9,69917,NULL,NULL,'H','ESO 527- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146698,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146698,33.83,0.45,58.2,69917,NULL,NULL,'K','ESO 527- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146699,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146699,33.83,0.43,58.4,69917,75,NULL,'MAT, I, cor','ESO 527- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146700,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146700,36.61,0.76,210,69918,70,NULL,NULL,'2MASX J20204673-0935414',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,305.194833,-9.59492,0.185,NULL,48014458027,750225906,11722279,15),(146701,'Faber-Jackson','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146701,32.78,0.65,36,69919,95,NULL,'Weighted Mean','NGC 6893',NULL,'1984ApJS...56...91D',1984,1,2.6,'Mislabeled as NGC 6873 in de Vaucouleours, 1957HPh....53..275d.','G',0.000087,NULL,'12.79',1.7,'(L)SA(rs)0^+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,305.206833,-48.23908,0.089,NULL,51132621026,798947203,12483550,12.79),(146702,'Faber-Jackson','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146702,34.42,0.81,76.6,69919,55,NULL,'Visvanathan & Sandage 1979','NGC 6893',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146703,'Tertiary','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146703,32.18,0.71,27.3,69919,95,NULL,NULL,'NGC 6893',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146704,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146704,36.46,0.72,196,69920,70,NULL,NULL,'2MASX J20205096-0045258',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.8I',0.3,NULL,NULL,NULL,NULL,NULL,1,305.212416667,-0.75711,0.401,NULL,47801836756,746903699,11670370,14.8),(146705,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146705,35.79,0.48,144,69921,70,NULL,NULL,'ESO 186-IG 035 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.0001,NULL,'15.53',0.62,NULL,NULL,NULL,NULL,NULL,1,305.2212083,-52.684,0.125,NULL,51081784730,798152886,12471138,15.53),(146706,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146706,34.4,0.53,76,69922,70,NULL,NULL,'2MASX J20205372-4946486',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.5R',0.2,NULL,NULL,NULL,NULL,NULL,1,305.223917,-49.78022,0.109,NULL,51131519274,798929988,12483281,14.5),(146707,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146707,31.96,0.2,24.7,69923,74.4,NULL,NULL,'ESO 596- G 019',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.00015,NULL,'16.19',0.6,'S...',NULL,NULL,NULL,NULL,1,305.2402083,-19.45736,0.241,NULL,50858631842,794666122,12416658,16.19),(146708,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146708,33.8,0.2,57.5,69924,74.4,NULL,NULL,'NGC 6897',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000043,NULL,'14.8b',0.5,'SAB:(rs?)bc: pec: II',NULL,NULL,NULL,NULL,1,305.2552917,-12.25469,0.241,NULL,47932960267,748952504,11702382,14.8),(146709,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146709,33.81,0.69,57.7,69924,100,NULL,'mid-IR','NGC 6897',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146710,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146710,34.01,0.59,63.5,69924,NULL,NULL,NULL,'NGC 6897',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146711,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146711,34.07,0.47,65.2,69924,NULL,NULL,'H','NGC 6897',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146712,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146712,34.07,0.57,65.3,69924,NULL,NULL,'Malmquist cor.','NGC 6897',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146713,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146713,34.17,0.45,68.2,69924,NULL,NULL,'K','NGC 6897',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146714,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146714,34.23,0.46,70.1,69924,NULL,NULL,'J','NGC 6897',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146715,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146715,34.29,0.4,72.1,69924,NULL,NULL,'mean','NGC 6897',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146716,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146716,34.29,0.47,72.1,69925,NULL,NULL,'H','2MASX J20210419-1509571',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000027,NULL,'12.7I',0.7,'Sab',NULL,NULL,NULL,NULL,1,305.267583,-15.16581,0.281,NULL,50836471250,794319863,12411247,12.7),(146717,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146717,34.35,0.45,74.1,69925,NULL,NULL,'K','2MASX J20210419-1509571',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146718,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146718,34.53,0.46,80.7,69925,NULL,NULL,'J','2MASX J20210419-1509571',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146719,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146719,34.6,0.4,83,69925,NULL,NULL,'mean','2MASX J20210419-1509571',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146720,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146720,35.62,0.77,133,69926,70,NULL,NULL,'ESO 234- G 007',NULL,'2014MNRAS.445.2677S',2014,1,1.29,NULL,'G',0.000127,NULL,'16.28',0.17,'Sbc',NULL,NULL,NULL,NULL,1,305.2819583,-49.28081,0.093,NULL,51131353758,798927402,12483240,16.28),(146721,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146721,36.92,0.78,242,69927,70,NULL,NULL,'2MASX J20211680-5228325',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.8R',0.26,NULL,NULL,NULL,NULL,NULL,1,305.320167,-52.47569,0.125,NULL,51080673817,798135528,12470867,14.8),(146722,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146722,33.63,0.48,53.2,69928,70,NULL,NULL,'ESO 186- G 036',NULL,'2014MNRAS.445.2677S',2014,1,1.9,NULL,'G',0.000087,NULL,'12.55',0.5,'SBa? sp',NULL,NULL,NULL,NULL,1,305.33125,-53.76319,0.185,NULL,51082164004,798158812,12471231,12.55),(146723,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 12947','RN',146723,39.34,0.19,637,69929,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 12947',0.1592,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146724,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 12947','RN',146724,39.64,0.11,732,69929,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 12947',0.1592,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146725,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146725,34.6,0.8,83.4,69930,75,NULL,'MAT, I','ESO 285- G 001',NULL,'1997ApJS..109..333W',1997,1,1.7,'1996ApJS..107...97M has z = 0.021295 +- 0.000033.','G',0.000087,NULL,'14.87',0.4,'(R)SB0^+',NULL,NULL,NULL,NULL,1,305.3710417,-44.60981,0.089,NULL,51096461582,798382212,12474722,14.87),(146726,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146726,33.93,0.32,61.2,69930,85,NULL,'I, raw','ESO 285- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146727,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146727,33.98,0.32,62.4,69930,85,NULL,'I, inv','ESO 285- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146728,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146728,33.99,0.43,62.9,69930,75,NULL,'MAT, I, raw','ESO 285- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146729,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146729,34.2,0.43,69.1,69930,75,NULL,'MAT, I, inv','ESO 285- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146730,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146730,34.31,0.43,72.7,69930,75,NULL,'MAT, I, cor','ESO 285- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146731,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146731,34.35,0.49,74.2,69930,75,NULL,'IR','ESO 285- G 001',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146732,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146732,35.46,0.35,124,69931,NULL,NULL,'Malmquist cor.','ESO 596- G 021',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.40',0.8,'Sb',NULL,NULL,NULL,NULL,1,305.378291667,-20.42522,0.209,NULL,50867984339,794812255,12418941,15.4),(146733,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146733,35.47,0.4,124,69931,NULL,NULL,'mean','ESO 596- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146734,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146734,35.55,0.47,129,69931,NULL,NULL,'H','ESO 596- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146735,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146735,35.58,0.33,130,69931,NULL,NULL,NULL,'ESO 596- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146736,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146736,35.62,0.2,133,69931,74.4,NULL,NULL,'ESO 596- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146737,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146737,35.66,0.45,136,69931,NULL,NULL,'K','ESO 596- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146738,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146738,35.73,0.46,140,69931,NULL,NULL,'J','ESO 596- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146739,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146739,34.01,0.47,63.3,69932,NULL,NULL,'H','MCG -02-52-003',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000023,NULL,'14.5',0.4,'Sd: sp         HII',NULL,NULL,NULL,NULL,1,305.4487917,-10.48969,0.245,NULL,48001368367,750021380,11719084,14.5),(146740,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146740,34.08,0.46,65.4,69932,NULL,NULL,'J','MCG -02-52-003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146741,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146741,34.09,0.45,65.9,69932,NULL,NULL,'K','MCG -02-52-003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146742,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146742,34.16,0.49,67.8,69932,75,NULL,'IR','MCG -02-52-003',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146743,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146743,34.27,0.4,71.3,69932,NULL,NULL,'mean','MCG -02-52-003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146744,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146744,34.4,0.43,75.8,69932,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-52-003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146745,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146745,36.4,0.62,191,69933,70,NULL,NULL,'2MASX J20214806-5259304',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,305.450167,-52.99178,0.181,NULL,51082338510,798161539,12471274,14.6),(146746,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146746,34.29,0.58,72.2,69934,70,NULL,NULL,'AM 2018-495',NULL,'2014MNRAS.445.2677S',2014,1,1.9,NULL,'G',0.00015,NULL,'12.92',1.1,'SAB0^0^: pec;cD',NULL,NULL,NULL,NULL,1,305.461208333,-49.70228,0.109,NULL,51131539372,798930302,12483285,12.92),(146747,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146747,31.2,0.43,17.4,69935,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11545',NULL,'2014MNRAS.444..527S',2014,1,1.48,NULL,'G',0.000067,NULL,'16.5',0.17,'Sc',NULL,NULL,NULL,NULL,1,305.474083,52.40897,NULL,NULL,54901096318,857829629,13403587,16.5),(146748,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146748,32.61,NULL,33.2,69935,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11545',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146749,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146749,32.62,NULL,33.5,69935,NULL,NULL,'Dipole','UGC 11545',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146750,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146750,32.63,NULL,33.6,69935,NULL,NULL,'Dipole + Quadrupole','UGC 11545',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146751,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146751,33.73,NULL,55.8,69935,NULL,NULL,NULL,'UGC 11545',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146752,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146752,36.3,0.93,182,69936,70,NULL,NULL,'2MASX J20215651-2046257',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,305.4854583,-20.77392,0.205,NULL,50868268412,794816693,12419010,15.3),(146753,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146753,34.31,0.53,72.6,69937,70,NULL,NULL,'ESO 234- G 011',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000087,NULL,'14.55',0.6,'(R)SA(r)0^+','in a pair',NULL,NULL,NULL,1,305.512667,-47.98686,0.085,NULL,51132333571,798942712,12483479,14.55),(146754,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146754,35.94,0.51,154,69938,70,NULL,NULL,'2MASX J20220503-4134490',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'13.5I',0.4,NULL,NULL,NULL,NULL,NULL,1,305.521,-41.58022,0.137,NULL,51375750806,802746106,12542907,13.5),(146755,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146755,34.8,0.45,91,69939,NULL,NULL,'Malmquist cor.','IC 4998',NULL,'2009ApJS..182..474S',2009,1,1.5,'Neither IC identification is certain.','G',0.000033,NULL,'13.99',1.2,'SB(s)c:',NULL,NULL,NULL,NULL,1,305.544083,-38.30833,0.193,NULL,51509489633,804835775,12575558,13.99),(146756,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146756,34.86,0.4,93.9,69939,NULL,NULL,'mean','IC 4998',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146757,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146757,34.99,0.47,99.7,69939,NULL,NULL,'H','IC 4998',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146758,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146758,35.05,0.46,102,69939,NULL,NULL,'J','IC 4998',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146759,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146759,35.06,0.4,103,69939,NULL,NULL,NULL,'IC 4998',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146760,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146760,35.07,0.45,103,69939,NULL,NULL,'K','IC 4998',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146761,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146761,35.1,0.2,105,69939,74.4,NULL,NULL,'IC 4998',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146762,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146762,33.41,0.4,48.2,69940,NULL,NULL,'mean','MCG -03-52-002',NULL,'2007A&A...465...71T',2007,1,2.6,'HD 193713 (V=7.6) 48 arcsec north of center.','G',0.000013,NULL,'15',2.2,'SA(rs)cd',NULL,NULL,NULL,NULL,1,305.5472917,-16.79289,0.189,NULL,50851191365,794549865,12414841,15),(146763,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146763,33.45,0.46,49.1,69940,NULL,NULL,'J','MCG -03-52-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146764,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146764,32.95,0.8,38.9,69941,75,NULL,'MAT, I','ESO 462- G 010',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000031,NULL,'15.06',0.9,'SAB(s)c:',NULL,NULL,NULL,NULL,1,305.562375,-29.85761,0.281,NULL,51338203316,802159426,12533741,15.06),(146765,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146765,33.73,0.32,55.7,69941,85,NULL,'I, raw','ESO 462- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146766,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146766,33.73,0.32,55.8,69941,85,NULL,'I, inv','ESO 462- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146767,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146767,33.89,0.2,60,69941,74.4,NULL,NULL,'ESO 462- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146768,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146768,33.99,0.43,62.9,69941,75,NULL,'MAT, I, raw','ESO 462- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146769,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146769,34.05,0.43,64.6,69941,75,NULL,'MAT, I, inv','ESO 462- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146770,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146770,34.4,0.43,76,69941,75,NULL,'MAT, I, cor','ESO 462- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146771,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146771,37.59,0.9,330,69942,70,NULL,NULL,'2MASX J20221768-1944224',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.17',0.4,NULL,NULL,NULL,NULL,NULL,1,305.573791667,-19.73956,0.205,NULL,50866882180,794795034,12418672,16.17),(146772,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146772,35.86,0.58,149,69943,70,NULL,NULL,'2MASX J20221859-5311034',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,305.5775417,-53.18436,0.185,NULL,51082371728,798162058,12471282,14.7),(146773,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146773,33.9,0.4,60.3,69944,NULL,NULL,'mean','NGC 6901',NULL,'2007A&A...465...71T',2007,1,1.4,'Called IC 1316 in RC2 by mistake (IC 1316 is non-existent).','G',0.000083,NULL,'14.58',0.6,'SB(r)ab','in a pair',NULL,NULL,NULL,1,305.589625,6.42986,0.473,NULL,53977468721,843397948,13178092,14.58),(146774,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146774,34.24,0.47,70.4,69944,NULL,NULL,'H','NGC 6901',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146775,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146775,34.25,0.45,70.9,69944,NULL,NULL,'K','NGC 6901',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146776,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146776,34.32,0.43,73.1,69944,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6901',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146777,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146777,34.33,0.46,73.6,69944,NULL,NULL,'J','NGC 6901',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146778,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146778,35.82,0.53,146,69945,70,NULL,NULL,'2MASX J20223243-7604240',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,305.635208333,-76.07331,0.305,NULL,48526123040,758220672,11847198,16.1),(146779,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146779,33.85,0.8,58.8,69946,75,NULL,'MAT, I','ESO 234- G 013',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000031,NULL,'14.62',0.6,'SAB(r)b',NULL,NULL,NULL,NULL,1,305.63525,-50.75289,0.113,NULL,51075088835,798048263,12469504,14.62),(146780,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146780,33.77,NULL,56.8,69946,NULL,NULL,'B','ESO 234- G 013',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146781,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146781,33.77,NULL,56.8,69946,NULL,NULL,'I','ESO 234- G 013',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146782,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146782,33.78,0.21,57,69946,NULL,NULL,'B, Hubble-type-TF','ESO 234- G 013',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146783,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146783,34.1,0.32,66.2,69946,85,NULL,'I, raw','ESO 234- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146784,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146784,34.13,0.43,67,69946,75,NULL,'MAT, I, raw','ESO 234- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146785,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146785,34.14,0.32,67.4,69946,85,NULL,'I, inv','ESO 234- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146786,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146786,34.31,0.43,72.7,69946,75,NULL,'MAT, I, cor','ESO 234- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146787,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146787,34.32,0.43,73,69946,75,NULL,'MAT, I, inv','ESO 234- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146788,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146788,34.4,0.36,75.8,69946,NULL,NULL,'Malmquist cor.','ESO 234- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146789,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146789,34.54,0.34,80.9,69946,NULL,NULL,NULL,'ESO 234- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146790,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146790,34.58,0.2,82.4,69946,74.4,NULL,NULL,'ESO 234- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146791,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146791,35.64,0.52,134,69947,70,NULL,NULL,'2MASX J20223654-5954295',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,305.652375,-59.90831,0.105,NULL,49149332953,767958327,11999348,14.7),(146792,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146792,35.71,0.63,139,69948,70,NULL,NULL,'2MASX J20224325-5259025',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.2I',0.2,NULL,NULL,NULL,NULL,NULL,1,305.680333,-52.98406,0.181,NULL,51082333294,798161457,12471272,14.2),(146793,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146793,37.24,0.56,281,69949,70,NULL,NULL,'2MASX J20224336-5301185',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.8I',0.4,NULL,NULL,NULL,NULL,NULL,1,305.6807083,-53.02189,0.181,NULL,51082332562,798161446,12471272,13.8),(146794,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146794,35.9,0.5,151,69950,70,NULL,NULL,'2MASX J20224661-5136165',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.8I',0.4,NULL,NULL,NULL,NULL,NULL,1,305.694167,-51.60456,0.109,NULL,51080510547,798132977,12470827,13.8),(146795,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146795,35.76,0.52,142,69951,70,NULL,NULL,'2MASX J20225816-3423521',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00008,NULL,'13.2I',0.5,NULL,NULL,NULL,NULL,NULL,1,305.742417,-34.39786,0.265,NULL,51303943044,801624110,12525376,13.2),(146796,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146796,32.67,0.8,34.2,69952,75,NULL,'HMCL, I','NGC 6902A',NULL,'1997ApJS..109..333W',1997,1,NULL,NULL,'GPair',0.0001,NULL,NULL,NULL,'Ring?',NULL,NULL,NULL,NULL,1,305.749,-44.27153,0.065,NULL,51096146036,798377281,12474645,NULL),(146797,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146797,33.11,0.4,42,69952,75,NULL,'HMCL, I, raw','NGC 6902A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146798,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146798,33.36,0.4,47,69952,75,NULL,'HMCL, I, inv','NGC 6902A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146799,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146799,33.4,0.4,47.8,69952,75,NULL,'HMCL, I, cor','NGC 6902A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146800,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146800,36.87,0.61,236,69953,70,NULL,NULL,'2MASX J20230568-0221295',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,305.77375,-2.35817,0.293,NULL,47814467500,747101054,11673453,14.5),(146801,'Tully est','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146801,32.91,0.8,38.2,69954,75,NULL,'B','NGC 6902B',NULL,'1988NBGC.C....0000T',1988,1,1.5,'Confused HIPASS source','G',0.00002,NULL,'14.09',1.3,'SA(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,305.779375,-43.86861,0.081,NULL,51096088376,798376380,12474630,14.09),(146802,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146802,35.1,NULL,105,69955,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 596- G 026',NULL,'2010Ap&SS.325..163P',2010,1,1.03,NULL,'G',0.000153,'?','17.41',0.11,'Sd',NULL,NULL,NULL,NULL,1,305.785667,-21.19417,0.229,NULL,50868250122,794816408,12419006,17.41),(146803,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146803,35.12,NULL,106,69955,NULL,NULL,'Dipole + Quadrupole','ESO 596- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146804,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146804,35.14,NULL,106,69955,NULL,NULL,'Dipole','ESO 596- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146805,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146805,35.17,NULL,108,69955,NULL,NULL,NULL,'ESO 596- G 026',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146806,'D-Sigma','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146806,33.58,0.4,52,69956,75,NULL,'Edat, raw','ESO 462- G 015',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00009,NULL,'12.95',1.3,'E3','in a pair',NULL,NULL,NULL,1,305.807667,-27.71456,0.289,NULL,51329772593,802027696,12531682,12.95),(146807,'D-Sigma','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146807,33.91,0.4,60.6,69956,75,NULL,'Edat, cor','ESO 462- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146808,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146808,34.36,0.45,74.4,69956,NULL,NULL,'K','ESO 462- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146809,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146809,34.43,0.4,77,69956,NULL,NULL,'mean','ESO 462- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146810,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146810,36.35,0.58,186,69957,70,NULL,NULL,'2MASX J20231411-4447232',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'14.7R',0.38,NULL,NULL,NULL,NULL,NULL,1,305.808667,-44.78972,0,NULL,51097101477,798392210,12474878,14.7),(146811,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 16578','R',146811,39.34,0.21,629,69958,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006po','SN 2006po',0.1747,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,305.8132083,-0.8485,0.461,NULL,47801035827,746891184,11670174,NULL),(146812,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 16578','R',146812,39.47,0.15,666,69958,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006po','SN 2006po',0.1747,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146813,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146813,36.33,0.58,185,69959,70,NULL,NULL,'2MASX J20232024-8220458',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,305.8347917,-82.34614,0.465,NULL,48361170722,755643292,11806926,17),(146814,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146814,35,0.48,100,69960,70,NULL,NULL,'ESO 596- G 028',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000083,NULL,'15.08',0.6,'S0',NULL,NULL,NULL,NULL,1,305.838083,-18.32256,0.161,NULL,50840232165,794378627,12412166,15.08),(146815,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146815,34.6,0.57,83.3,69961,70,NULL,NULL,'ESO 234- G 015',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00012,NULL,'14.76',0.6,'(R\')SB(rs)a',NULL,NULL,NULL,NULL,1,305.844083,-52.08311,0.085,NULL,51081216729,798144011,12471000,14.76),(146816,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146816,34.85,0.57,93.5,69962,70,NULL,NULL,'ESO 285- G 006',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000097,NULL,'15.34',0.2,'S0-a',NULL,NULL,NULL,NULL,1,305.860541667,-46.77122,0,NULL,51098443516,798413179,12475205,15.34),(146817,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146817,36.49,0.53,199,69963,70,NULL,NULL,'2MASX J20232712-5231543',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.5I',0.7,NULL,NULL,NULL,NULL,NULL,1,305.863125,-52.53183,0.089,NULL,51081044240,798141316,12470958,13.5),(146818,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146818,33.67,0.8,54.1,69964,75,NULL,'MAT, I','IC 4992',NULL,'1997ApJS..109..333W',1997,1,2.69,'Confused HIPASS source','G',0.000028,NULL,'14.45',0.25,'SB(s)c? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,305.8660417,-71.56492,0.193,NULL,49223149342,769111708,12017370,14.45),(146819,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146819,32.95,0.32,38.9,69964,85,NULL,'I, raw','IC 4992',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146820,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146820,32.96,0.32,39,69964,85,NULL,'I, inv','IC 4992',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146821,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146821,33.02,0.43,40.1,69964,75,NULL,'MAT, I, raw','IC 4992',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146822,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146822,33.06,0.49,40.9,69964,75,NULL,'IR','IC 4992',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146823,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146823,33.1,0.43,41.7,69964,75,NULL,'MAT, I, inv','IC 4992',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146824,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146824,33.23,NULL,44.4,69964,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 4992',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146825,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146825,33.26,NULL,44.8,69964,NULL,NULL,'Dipole + Quadrupole','IC 4992',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146826,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146826,33.27,NULL,45,69964,NULL,NULL,'Dipole','IC 4992',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146827,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146827,33.27,0.43,45.1,69964,75,NULL,'MAT, I, cor','IC 4992',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146828,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146828,33.31,NULL,46,69964,NULL,NULL,NULL,'IC 4992',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146829,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146829,33.82,0.15,58.2,69964,NULL,NULL,NULL,'IC 4992',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146830,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146830,36.72,0.62,221,69965,70,NULL,NULL,'2MASX J20232854-5244533',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.8I',0.5,NULL,NULL,NULL,NULL,NULL,1,305.869,-52.74811,0.089,NULL,51081509431,798148584,12471071,13.8),(146831,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146831,37.24,0.79,281,69966,70,NULL,NULL,'2MASX J20233152-8437039',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,305.881208333,-84.61783,0.405,NULL,48383892140,755998314,11812473,17.2),(146832,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2002cd',NULL,146832,32.67,0.29,33.8,69967,74.2,NULL,'SALT 2','NGC 6916',0.010344,'2010ApJ...716..712A',2010,1,1.8,NULL,'G',0.000023,NULL,'14.3',1.1,'SBbc',NULL,NULL,NULL,NULL,1,305.887833,58.34406,1.741,NULL,53008224718,828253511,12941461,14.3),(146833,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2002cd',NULL,146833,33.21,0.09,43.9,69967,74.4,NULL,NULL,'NGC 6916',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146834,'Sosies','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146834,33.42,0.3,48.3,69967,NULL,NULL,NULL,'NGC 6916',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146835,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146835,33.14,0.4,42.5,69967,75,NULL,'HOSTS SN 2002cd','NGC 6916',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146836,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146836,33.17,0.46,43,69967,NULL,NULL,'J','NGC 6916',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146837,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146837,33.19,0.47,43.5,69967,NULL,NULL,'H','NGC 6916',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146838,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146838,33.21,0.09,43.9,69967,74.4,NULL,NULL,'NGC 6916',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146839,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146839,33.21,0.4,43.9,69967,NULL,NULL,'mean','NGC 6916',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146840,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146840,33.23,0.45,44.3,69967,NULL,NULL,'K','NGC 6916',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146841,'Sosies','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146841,34.09,0.63,65.8,69968,NULL,NULL,NULL,'NGC 6906',NULL,'2002A&A...393...57T',2002,1,1.7,NULL,'G',0.000027,NULL,'13.16',0.8,'SB(rs)bc:','in a pair',NULL,NULL,NULL,1,305.8912917,6.44367,0.473,NULL,53976968310,843390129,13177970,13.16),(146842,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146842,33.68,0.46,54.6,69968,NULL,NULL,'J','NGC 6906',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146843,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146843,33.71,0.47,55.2,69968,NULL,NULL,'H','NGC 6906',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146844,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146844,33.75,0.45,56.3,69968,NULL,NULL,'K','NGC 6906',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146845,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146845,33.95,0.4,61.6,69968,NULL,NULL,'mean','NGC 6906',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146846,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146846,34.13,0.43,66.9,69968,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6906',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146847,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146847,32.93,0.8,38.5,69969,75,NULL,'MAT, I','ESO 462- G 016',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00002,NULL,'13.59',1.2,'SA(s)cd        HII','in a pair',NULL,NULL,NULL,1,305.912333,-28.27783,0.321,NULL,51328541302,802008457,12531382,13.59),(146848,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146848,32.42,0.69,30.5,69969,100,NULL,'mid-IR','ESO 462- G 016',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146849,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146849,32.46,0.32,31.1,69969,85,NULL,'I, raw','ESO 462- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146850,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146850,32.48,0.32,31.3,69969,85,NULL,'I, inv','ESO 462- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146851,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146851,32.73,0.43,35.2,69969,75,NULL,'MAT, I, raw','ESO 462- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146852,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146852,32.85,0.43,37.1,69969,75,NULL,'MAT, I, inv','ESO 462- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146853,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146853,32.9,0.43,38,69969,75,NULL,'MAT, I, cor','ESO 462- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146854,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146854,33,0.2,39.8,69969,74.4,NULL,NULL,'ESO 462- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146855,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146855,33.15,0.52,42.6,69969,NULL,NULL,'Malmquist cor.','ESO 462- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146856,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146856,33.21,0.51,43.8,69969,NULL,NULL,NULL,'ESO 462- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146857,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146857,33.26,0.4,45,69969,NULL,NULL,'mean','ESO 462- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146858,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146858,33.62,0.47,52.9,69969,NULL,NULL,'H','ESO 462- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146859,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146859,36.02,0.8,160,69970,70,NULL,NULL,'2MASX J20233973-4441142',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.9I',0.3,NULL,NULL,NULL,NULL,NULL,1,305.915541667,-44.68731,0.037,NULL,51097055352,798391489,12474867,13.9),(146860,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146860,36.4,0.73,191,69971,70,NULL,NULL,'ESO 234- G 018',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.69',0.7,'SB(rs+)a pec',NULL,NULL,NULL,NULL,1,305.9289583,-48.44097,0.093,NULL,51132726262,798948847,12483575,15.69),(146861,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146861,33.43,0.5,48.5,69972,70,NULL,NULL,'NGC 6903',NULL,'2014MNRAS.445.2677S',2014,1,2.7,NULL,'G',0.000073,NULL,'12.90',2.5,'SAB0- pec:',NULL,NULL,NULL,NULL,1,305.936917,-19.32542,0.213,NULL,50866503805,794789121,12418580,12.9),(146862,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146862,33.21,0.4,43.9,69972,NULL,NULL,'mean','NGC 6903',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146863,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146863,33.24,0.45,44.5,69972,NULL,NULL,'K','NGC 6903',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146864,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146864,33.56,0.2,51.5,69973,NULL,NULL,'B, Hubble-type-TF','ESO 234- G 019',NULL,'2005Ap&SS.298..577R',2005,1,1.99,'Confused HIPASS source','G',0.000033,NULL,'15.19',0.24,'Scd',NULL,NULL,NULL,NULL,1,305.9625417,-48.35881,0.093,NULL,51132542549,798945977,12483530,15.19),(146865,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146865,34.24,0.49,70.5,69973,75,NULL,'IR','ESO 234- G 019',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146866,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146866,34.25,0.35,70.8,69973,NULL,NULL,NULL,'ESO 234- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146867,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146867,34.26,NULL,71.3,69973,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 234- G 019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146868,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146868,34.29,NULL,72.1,69973,NULL,NULL,'Dipole + Quadrupole','ESO 234- G 019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146869,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146869,34.29,0.2,72.1,69973,74.4,NULL,NULL,'ESO 234- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146870,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146870,34.3,NULL,72.3,69973,NULL,NULL,'Dipole','ESO 234- G 019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146871,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146871,34.33,NULL,73.4,69973,NULL,NULL,NULL,'ESO 234- G 019',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146872,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146872,34.33,0.34,73.4,69973,NULL,NULL,'Malmquist cor.','ESO 234- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146873,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146873,35.83,0.58,147,69974,70,NULL,NULL,'2MASX J20235268-5939138',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,305.969583,-59.65378,0.105,NULL,49027813336,766059583,11969680,15.3),(146874,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146874,32.99,0.8,39.6,69975,75,NULL,'MAT, I','IC 4999',NULL,'1997ApJS..109..333W',1997,1,1.8,'Confused HIPASS source','G',0.00002,NULL,'13.5b',1,'SAB(rs)d:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,305.98475,-26.01494,0.233,NULL,51326555150,801977424,12530897,13.5),(146875,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146875,31.96,0.32,24.7,69975,85,NULL,'I, raw','IC 4999',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146876,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146876,31.96,0.32,24.7,69975,85,NULL,'I, inv','IC 4999',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146877,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146877,32.33,0.43,29.2,69975,75,NULL,'MAT, I, raw','IC 4999',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146878,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146878,32.39,0.43,30,69975,75,NULL,'MAT, I, inv','IC 4999',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146879,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146879,32.62,0.2,33.4,69975,74.4,NULL,NULL,'IC 4999',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146880,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146880,32.63,0.43,33.6,69975,75,NULL,'MAT, I, cor','IC 4999',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146881,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146881,32.88,0.55,37.7,69975,NULL,NULL,NULL,'IC 4999',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146882,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146882,32.89,0.55,37.9,69975,NULL,NULL,'Malmquist cor.','IC 4999',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146883,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146883,33.46,0.4,49.2,69975,NULL,NULL,'mean','IC 4999',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146884,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146884,33.49,0.47,49.9,69975,NULL,NULL,'H','IC 4999',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146885,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146885,33.64,0.46,53.5,69975,NULL,NULL,'J','IC 4999',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146886,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146886,33.71,0.45,55.2,69975,NULL,NULL,'K','IC 4999',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146887,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146887,35.71,0.5,139,69976,70,NULL,NULL,'2MASX J20235734-0916531',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000093,NULL,'13.0I',0.5,NULL,NULL,NULL,NULL,NULL,1,305.988875,-9.28136,0.221,NULL,47817318303,747145598,11674149,13),(146888,'Tully est','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146888,32.89,0.8,37.9,69977,75,NULL,'B','IC 4946',NULL,'1988NBGC.C....0000T',1988,1,2.5,'The IC ID is not certain; ESO 284- ? 015 is for its nominal position.','G',0.00006,NULL,'12.61',1,'SB(rl)0^0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,305.9919583,-43.99528,0.081,NULL,51096104244,798376628,12474634,12.61),(146889,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146889,31.87,0.4,23.7,69978,75,NULL,'B','UGC 11557',NULL,'1988NBGC.C....0000T',1988,1,2.2,NULL,'G',0.000013,NULL,'13.7',1.7,'SAB(s)dm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,306.002917,60.19472,1.149,NULL,53457076673,835266823,13051044,13.7),(146890,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146890,35.33,0.62,116,69979,70,NULL,NULL,'2MASX J20241155-5022394',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'14.0R',0.4,NULL,NULL,NULL,NULL,NULL,1,306.048167,-50.37756,0.065,NULL,51075305255,798051644,12469556,14),(146891,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146891,37.44,0.79,308,69980,70,NULL,NULL,'2MASX J20241439-5237374',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'16.7b',0.11,NULL,NULL,NULL,NULL,NULL,1,306.060125,-52.62703,0.089,NULL,51081480123,798148126,12471064,16.7),(146892,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146892,36.43,0.89,194,69981,70,NULL,NULL,'2MASX J20241669-2107270',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.30',0.4,'SB(rl)0/a:',NULL,NULL,NULL,NULL,1,306.069666667,-21.12433,0.205,NULL,50868110047,794814219,12418972,16.3),(146893,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146893,34.36,0.8,74.4,69982,75,NULL,'MAT, I','NGC 6899',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'13.41',1,'SAB(rs)bc',NULL,NULL,NULL,NULL,1,306.092666667,-50.43394,0.065,NULL,51075316316,798051817,12469559,13.41),(146894,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146894,33.67,0.32,54.1,69982,85,NULL,'I, raw','NGC 6899',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146895,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146895,33.72,0.32,55.5,69982,85,NULL,'I, inv','NGC 6899',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146896,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146896,33.73,0.43,55.8,69982,75,NULL,'MAT, I, raw','NGC 6899',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146897,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146897,33.74,NULL,56,69982,75,NULL,'B','NGC 6899',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146898,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146898,33.74,NULL,56,69982,75,NULL,'I','NGC 6899',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146899,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146899,33.74,NULL,56,69982,NULL,NULL,'B','NGC 6899',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146900,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146900,33.76,0.15,56.5,69982,NULL,NULL,'B, Hubble-type-TF','NGC 6899',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146901,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146901,33.88,NULL,59.7,69982,NULL,NULL,'I','NGC 6899',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146902,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146902,33.89,0.47,60.1,69982,NULL,NULL,'H','NGC 6899',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146903,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146903,33.94,0.46,61.5,69982,NULL,NULL,'J','NGC 6899',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146904,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146904,33.97,0.45,62.1,69982,NULL,NULL,'K','NGC 6899',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146905,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146905,33.99,0.43,62.9,69982,75,NULL,'MAT, I, inv','NGC 6899',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146906,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146906,34.04,0.43,64.4,69982,75,NULL,'MAT, I, cor','NGC 6899',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146907,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146907,34.45,0.4,77.5,69982,NULL,NULL,'mean','NGC 6899',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146908,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146908,35.56,0.54,130,69983,70,NULL,NULL,'2MASX J20242552-0704197',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.6I',0.4,NULL,NULL,NULL,NULL,NULL,1,306.106333,-7.07208,0.193,NULL,47827635091,747306798,11676668,13.6),(146909,'Ring Diameter','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146909,32.8,0.84,36,69984,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 6902',NULL,'1981ApJS...45..541P',1981,1,5.6,'The IC identification is not certain.','G',0.000013,NULL,'11.64',3.9,'SA(r)b         LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,306.11725,-43.65353,0.085,NULL,51378140584,802783446,12543491,11.64),(146910,'Sosies','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146910,32.41,0.29,30.3,69984,NULL,NULL,NULL,'NGC 6902',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146911,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146911,32.76,0.4,35.7,69984,75,NULL,'B','NGC 6902',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146912,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146912,32.83,0.4,36.9,69984,NULL,NULL,'mean','NGC 6902',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146913,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146913,32.97,0.46,39.2,69984,NULL,NULL,'J','NGC 6902',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146914,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146914,33.03,0.45,40.3,69984,NULL,NULL,'K','NGC 6902',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146915,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146915,33.04,0.47,40.5,69984,NULL,NULL,'H','NGC 6902',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146916,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146916,33.34,0.4,46.6,69984,NULL,NULL,NULL,'NGC 6902',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146917,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146917,35.1,0.56,105,69985,70,NULL,NULL,'2MASX J20243049-2101080',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.95',NULL,NULL,NULL,NULL,NULL,NULL,1,306.12725,-21.019,0.205,NULL,50868087080,794813860,12418966,15.95),(146918,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146918,35.98,0.56,157,69986,70,NULL,NULL,'ESO 462- G 017',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'15.67',0.2,'S       poss. LINER?',NULL,NULL,NULL,NULL,1,306.148417,-30.46503,0.281,NULL,51337239655,802144369,12533505,15.67),(146919,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146919,33.87,0.4,59.5,69987,NULL,NULL,'mean','UGC 11552',NULL,'2007A&A...465...71T',2007,1,1.9,'The HIPASS beam probably includes the galaxy UGC 11550.','G',0.000024,NULL,'14.7',0.6,'Sab',NULL,NULL,NULL,NULL,1,306.149208333,12.44375,0.597,NULL,55180319763,862192496,13471757,14.7),(146920,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146920,34.07,0.45,65.3,69987,NULL,NULL,'K','UGC 11552',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146921,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146921,34.14,0.47,67.2,69987,NULL,NULL,'H','UGC 11552',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146922,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146922,34.25,0.46,70.8,69987,NULL,NULL,'J','UGC 11552',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146923,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146923,34.26,0.31,71.2,69987,NULL,NULL,'Malmquist cor.','UGC 11552',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146924,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146924,34.35,0.43,74,69987,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11552',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146925,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146925,34.47,0.43,78.3,69987,75,NULL,'3.6 micron, color corrected','UGC 11552',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146926,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146926,34.54,0.27,81.1,69987,NULL,NULL,NULL,'UGC 11552',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146927,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146927,34.59,0.2,82.8,69987,74.4,NULL,NULL,'UGC 11552',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146928,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146928,33.63,0.47,53.2,69988,NULL,NULL,'H','UGC 11551',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.00006,NULL,'14.83',0.4,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,306.15175,6.91119,0.449,NULL,53980447033,843444484,13178820,14.83),(146929,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146929,33.64,0.45,53.5,69988,NULL,NULL,'K','UGC 11551',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146930,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146930,33.7,0.43,55,69988,75,NULL,'3.6 micron, color corrected','UGC 11551',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146931,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146931,33.71,0.46,55.2,69988,NULL,NULL,'J','UGC 11551',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146932,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146932,33.71,0.43,55.3,69988,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11551',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146933,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146933,33.73,0.49,55.6,69988,75,NULL,'IR','UGC 11551',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146934,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146934,33.78,0.2,57,69988,74.4,NULL,NULL,'UGC 11551',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146935,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146935,33.94,0.33,61.5,69988,NULL,NULL,NULL,'UGC 11551',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146936,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146936,33.96,0.4,61.8,69988,NULL,NULL,'mean','UGC 11551',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146937,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146937,34.09,0.31,65.7,69988,NULL,NULL,'Malmquist cor.','UGC 11551',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146938,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146938,34.15,0.8,67.6,69989,75,NULL,'MAT, I','ESO 340- G 026',NULL,'1997ApJS..109..333W',1997,1,3.02,NULL,'G',0.000033,NULL,'14.80',0.31,'Sc',NULL,NULL,NULL,NULL,1,306.181667,-41.51208,0.125,NULL,51375888719,802748261,12542941,14.8),(146939,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146939,33.73,0.49,55.7,69989,75,NULL,'IR','ESO 340- G 026',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146940,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146940,33.8,NULL,57.5,69989,NULL,NULL,NULL,'ESO 340- G 026',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146941,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146941,33.81,NULL,57.7,69989,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 340- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146942,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146942,33.82,NULL,58.2,69989,NULL,NULL,'Dipole + Quadrupole','ESO 340- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146943,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146943,33.84,NULL,58.5,69989,NULL,NULL,'Dipole','ESO 340- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146944,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146944,34.13,0.43,66.9,69989,75,NULL,'MAT, I, raw','ESO 340- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146945,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146945,34.2,0.41,69.3,69989,NULL,NULL,NULL,'ESO 340- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146946,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146946,34.25,0.2,70.8,69989,74.4,NULL,NULL,'ESO 340- G 026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146947,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146947,34.26,0.32,71.2,69989,85,NULL,'I, raw','ESO 340- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146948,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146948,34.31,0.32,72.9,69989,85,NULL,'I, inv','ESO 340- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146949,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146949,34.35,0.43,74.1,69989,75,NULL,'MAT, I, inv','ESO 340- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146950,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146950,34.36,0.38,74.4,69989,NULL,NULL,'Malmquist cor.','ESO 340- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146951,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146951,34.38,0.4,75.3,69989,NULL,NULL,'mean','ESO 340- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146952,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146952,34.43,0.43,76.9,69989,75,NULL,'MAT, I, cor','ESO 340- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146953,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146953,34.57,0.47,82.1,69989,NULL,NULL,'H','ESO 340- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146954,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146954,34.61,0.45,83.5,69989,NULL,NULL,'K','ESO 340- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146955,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146955,34.63,0.46,84.5,69989,NULL,NULL,'J','ESO 340- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146956,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146956,32.71,0.2,34.8,69990,74.4,NULL,NULL,'ESO 596- G 032',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',NULL,NULL,'15.90',0.8,'S...',NULL,NULL,NULL,NULL,1,306.220125,-18.34522,0.153,NULL,50845488838,794460763,12413449,15.9),(146957,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146957,32.75,0.43,35.4,69990,NULL,NULL,NULL,'ESO 596- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146958,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146958,33,0.38,39.8,69990,NULL,NULL,'Malmquist cor.','ESO 596- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146959,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146959,36.29,0.58,181,69991,70,NULL,NULL,'2MASX J20245981-6234185',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'14.6R',0.31,NULL,NULL,NULL,NULL,NULL,1,306.249333,-62.57178,0.197,NULL,49156260844,768066575,12001040,14.6),(146960,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146960,32.68,0.8,34.3,69992,75,NULL,'MAT, I','ESO 026- G 001',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00002,NULL,'14.55',1.4,'(R\'_2)SAB(rs)cd',NULL,NULL,NULL,NULL,1,306.258833,-81.57528,0.369,NULL,48541485220,758460706,11850948,14.55),(146961,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146961,30.32,0.32,11.6,69992,85,NULL,'I, inv','ESO 026- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146962,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146962,30.38,0.32,11.9,69992,85,NULL,'I, raw','ESO 026- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146963,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146963,30.55,0.4,12.9,69992,NULL,NULL,NULL,'ESO 026- G 001',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146964,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146964,30.88,0.43,15,69992,75,NULL,'MAT, I, inv','ESO 026- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146965,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146965,30.99,0.43,15.8,69992,75,NULL,'MAT, I, raw','ESO 026- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146966,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146966,31.25,0.43,17.8,69992,75,NULL,'MAT, I, cor','ESO 026- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146967,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146967,33.01,0.8,40,69993,75,NULL,'MAT, I','NGC 6907',NULL,'1997ApJS..109..333W',1997,1,3.3,NULL,'G',0.000013,NULL,'11.4B',2.7,'SB(s)bc        LIRG','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,306.277625,-24.80917,0.309,NULL,50826816139,794169002,12408890,11.4),(146968,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146968,32.53,0.32,32.1,69993,85,NULL,'I, raw','NGC 6907',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146969,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146969,32.6,0.45,33.1,69993,NULL,NULL,'K','NGC 6907',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146970,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146970,32.61,0.32,33.2,69993,85,NULL,'I, inv','NGC 6907',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146971,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146971,32.63,0.47,33.6,69993,NULL,NULL,'H','NGC 6907',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146972,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146972,32.63,0.46,33.6,69993,NULL,NULL,'J','NGC 6907',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146973,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146973,32.66,0.68,34,69993,NULL,NULL,'Malmquist cor.','NGC 6907',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146974,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146974,32.73,0.43,35.2,69993,75,NULL,'MAT, I, raw','NGC 6907',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146975,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146975,32.76,0.65,35.6,69993,NULL,NULL,NULL,'NGC 6907',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146976,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146976,32.8,0.2,36.3,69993,74.4,NULL,NULL,'NGC 6907',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146977,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146977,32.94,0.43,38.7,69993,75,NULL,'MAT, I, cor','NGC 6907',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146978,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146978,33.08,0.43,41.4,69993,75,NULL,'MAT, I, inv','NGC 6907',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146979,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146979,33.26,0.4,45,69993,NULL,NULL,'mean','NGC 6907',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146980,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146980,36.32,0.6,184,69994,70,NULL,NULL,'2MASX J20250744-6520045',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'15.2R',0.25,NULL,NULL,NULL,NULL,NULL,1,306.280875,-65.33453,0.129,NULL,49375001803,771484403,12054443,15.2),(146981,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146981,33.95,0.8,61.7,69995,75,NULL,'CF, r','UGC 11555',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.00002,NULL,'13.90',1.2,'SA(s)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,306.300083333,5.26308,0.381,NULL,54009791587,843902993,13185984,13.9),(146982,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146982,32.81,0.38,36.4,69995,75,NULL,'CF, r, raw','UGC 11555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146983,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146983,32.83,0.38,36.8,69995,75,NULL,'CF, r, inv','UGC 11555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146984,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146984,33.28,0.38,45.3,69995,75,NULL,'CF, r, cor','UGC 11555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146985,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146985,33.47,0.69,49.5,69995,100,NULL,'mid-IR','UGC 11555',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146986,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146986,33.93,0.47,61.2,69995,NULL,NULL,'H','UGC 11555',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146987,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146987,33.94,0.4,61.5,69995,NULL,NULL,'mean','UGC 11555',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146988,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146988,37.18,0.69,272,69996,70,NULL,NULL,'2MASX J20251288-2052013',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.23',NULL,NULL,NULL,NULL,NULL,NULL,1,306.3035,-20.86717,0.201,NULL,50868327898,794817623,12419025,16.23),(146989,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146989,33.23,0.4,44.2,69997,NULL,NULL,'mean','IC 5005',NULL,'2007A&A...465...71T',2007,1,1.9,'Confused HIPASS source','G',0.000019,NULL,'13.56',1.6,'SB(s)cd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,306.334208333,-25.82928,0.237,NULL,51309852635,801716447,12526819,13.56),(146990,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146990,33.48,0.47,49.6,69997,NULL,NULL,'H','IC 5005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146991,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146991,33.58,0.46,52.1,69997,NULL,NULL,'J','IC 5005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146992,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146992,33.6,0.45,52.5,69997,NULL,NULL,'K','IC 5005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146993,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146993,36.32,0.52,184,69998,70,NULL,NULL,'2MASX J20252383-5321106',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.2I',0.6,NULL,NULL,NULL,NULL,NULL,1,306.349333,-53.35294,0.169,NULL,51079619041,798119047,12470610,13.2),(146994,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146994,33.38,0.8,47.4,69999,NULL,NULL,NULL,'ESO 340- G 028',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.04',0.5,'S...',NULL,NULL,NULL,NULL,1,306.351208333,-40.1615,0.121,NULL,51375249668,802738276,12542785,15.04),(146995,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146995,33.42,0.2,48.3,69999,74.4,NULL,NULL,'ESO 340- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146996,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146996,33.44,0.78,48.8,69999,NULL,NULL,'Malmquist cor.','ESO 340- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146997,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146997,34.4,0.8,76,70000,75,NULL,'MAT, I','ESO 234- G 024',NULL,'1997ApJS..109..333W',1997,1,1.8,'Confused HIPASS source','G',0.000033,NULL,'14.84',0.4,'SAB(s:)b',NULL,NULL,NULL,NULL,1,306.365917,-51.53214,0.085,NULL,51082502126,798164095,12471313,14.84),(146998,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146998,33.85,0.21,58.9,70000,NULL,NULL,'B, Hubble-type-TF','ESO 234- G 024',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146999,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146999,33.86,NULL,59.2,70000,NULL,NULL,'B','ESO 234- G 024',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147000,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147000,33.86,NULL,59.2,70000,NULL,NULL,'I','ESO 234- G 024',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147001,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147001,34.37,0.49,74.9,70000,75,NULL,'IR','ESO 234- G 024',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147002,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147002,34.44,0.43,77.1,70000,75,NULL,'MAT, I, raw','ESO 234- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147003,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147003,34.48,0.32,78.7,70000,85,NULL,'I, raw','ESO 234- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147004,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147004,34.53,0.32,80.4,70000,85,NULL,'I, inv','ESO 234- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147005,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147005,34.55,0.43,81.3,70000,75,NULL,'MAT, I, cor','ESO 234- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147006,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147006,34.65,0.43,85.3,70000,75,NULL,'MAT, I, inv','ESO 234- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147007,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147007,35.05,0.67,102,70001,70,NULL,NULL,'MCG -03-52-005',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000127,NULL,'15',0.6,NULL,NULL,NULL,NULL,NULL,1,306.372833,-15.85372,0.277,NULL,50850844033,794544438,12414756,15),(147008,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147008,34.89,0.47,95.1,70002,NULL,NULL,'H','CGCG 424-005',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.00006,NULL,'14.9',0.8,'Sbc',NULL,NULL,NULL,NULL,1,306.375875,10.57247,0.501,NULL,53976128720,843377011,13177765,14.9),(147009,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147009,35.04,0.45,102,70002,NULL,NULL,'K','CGCG 424-005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147010,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147010,35.06,0.46,103,70002,NULL,NULL,'J','CGCG 424-005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147011,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147011,35.07,0.4,103,70002,NULL,NULL,'mean','CGCG 424-005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147012,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147012,36.32,0.59,184,70003,70,NULL,NULL,'2MASX J20254004-6320518',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.8R',0.19,NULL,NULL,NULL,NULL,NULL,1,306.417,-63.34769,0.189,NULL,49155252609,768050822,12000794,15.8),(147013,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147013,34.59,0.51,82.9,70004,70,NULL,NULL,'ESO 596- G 035',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000097,NULL,'15.25',0.9,'(RL)SA0^+',NULL,NULL,NULL,NULL,1,306.42325,-17.44253,0.173,NULL,50847988857,794499825,12414059,15.25),(147014,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147014,33.1,0.47,41.7,70005,NULL,NULL,'H','ESO 400- G 020',NULL,'2007A&A...465...71T',2007,1,2.1,NULL,'G',0.000013,NULL,'16.9b',0.7,'SA(s)b:',NULL,NULL,NULL,NULL,1,306.4495417,-34.1935,0.209,NULL,51295534818,801492731,12523323,16.9),(147015,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147015,33.18,0.46,43.2,70005,NULL,NULL,'J','ESO 400- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147016,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147016,33.34,0.45,46.6,70005,NULL,NULL,'K','ESO 400- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147017,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147017,33.43,0.4,48.6,70005,NULL,NULL,'mean','ESO 400- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147018,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147018,35.14,0.49,107,70006,NULL,NULL,NULL,'ESO 596- G 036',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.00002,NULL,'15',1,'Sc',NULL,NULL,NULL,NULL,1,306.459333,-18.52378,0.145,NULL,50845469852,794460466,12413444,15),(147019,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147019,35.18,0.2,109,70006,74.4,NULL,NULL,'ESO 596- G 036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147020,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147020,35.31,0.46,115,70006,NULL,NULL,'Malmquist cor.','ESO 596- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147021,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147021,35.22,0.55,110,70007,70,NULL,NULL,'2MASX J20255179-2208426',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.15',NULL,NULL,NULL,NULL,NULL,NULL,1,306.4657917,-22.14536,0.229,NULL,50861649173,794713268,12417394,16.15),(147022,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147022,35.39,0.55,120,70008,70,NULL,NULL,'2MASX J20255359-0809173',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,306.47325,-8.15492,0.177,NULL,47829458702,747335292,11677113,14.9),(147023,'GRB','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147023,46.11,0.98,5650,70009,69.7,NULL,'Fiducial','GRB 050315',1.95,'2009MNRAS.400..775C',2009,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,306.475417,-42.60061,0.113,NULL,51373866272,802716660,12542447,NULL),(147024,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147024,37.37,0.57,298,70010,70,NULL,NULL,'2MASX J20260121-2200336',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,306.505083,-22.00939,0.193,NULL,50861698749,794714042,12417406,15.6),(147025,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147025,34.43,0.58,76.9,70011,NULL,NULL,'Malmquist cor.','ESO 186- G 041',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.71',0.5,'S...',NULL,NULL,NULL,NULL,1,306.5095417,-54.38325,0.169,NULL,51079926405,798123850,12470685,15.71),(147026,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147026,34.59,0.54,82.8,70011,NULL,NULL,NULL,'ESO 186- G 041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147027,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147027,34.63,0.2,84.3,70011,74.4,NULL,NULL,'ESO 186- G 041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147028,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 06197',NULL,147028,39.96,0.26,982,70012,70,NULL,'SN photometric redshift distance, z photo =0.263 +/- 0.039','SDSS-II SN 06197',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,306.5540417,0.84492,0.469,NULL,54004733087,843823954,13184749,NULL),(147029,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147029,34.65,0.49,85.2,70013,70,NULL,NULL,'ESO 186- G 043',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000093,NULL,'14.62',0.8,'(R)SB(r)ab',NULL,NULL,NULL,NULL,1,306.573167,-52.40475,0.089,NULL,51080877217,798138706,12470917,14.62),(147030,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147030,34.71,0.52,87.5,70014,70,NULL,NULL,'ESO 234- G 026',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.20',0.3,'N',NULL,NULL,NULL,NULL,1,306.583,-48.04386,0.093,NULL,51129366206,798896346,12482755,15.2),(147031,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147031,34.74,0.69,88.7,70015,100,NULL,'mid-IR','CGCG 424-006',NULL,'2013ApJ...771...88L',2013,1,1,NULL,'G',NULL,NULL,'15.7',0.6,NULL,NULL,NULL,NULL,NULL,1,306.6095,15.01786,0.477,NULL,55181808295,862215754,13472121,15.7),(147032,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147032,34.24,0.8,70.4,70016,75,NULL,'MAT, I','ESO 400- G 021',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.00002,NULL,'15.10',0.4,'S?',NULL,NULL,NULL,NULL,1,306.639625,-32.46306,0.317,NULL,51324010792,801937668,12530276,15.1),(147033,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147033,34.01,0.32,63.5,70016,85,NULL,'I, raw','ESO 400- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147034,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147034,34.03,0.32,63.9,70016,85,NULL,'I, inv','ESO 400- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147035,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147035,34.26,0.43,71.1,70016,75,NULL,'MAT, I, raw','ESO 400- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147036,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147036,34.33,0.2,73.5,70016,74.4,NULL,NULL,'ESO 400- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147037,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147037,34.36,0.43,74.6,70016,75,NULL,'MAT, I, inv','ESO 400- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147038,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147038,34.44,0.29,77.1,70016,NULL,NULL,NULL,'ESO 400- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147039,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147039,34.52,0.43,80.1,70016,75,NULL,'MAT, I, cor','ESO 400- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147040,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147040,34.58,0.28,82.2,70016,NULL,NULL,'Malmquist cor.','ESO 400- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147041,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147041,33.85,0.47,59,70017,70,NULL,NULL,'IC 5002',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00009,NULL,'14.19',0.8,'S0^0^','Pair member (points to parent)',NULL,NULL,NULL,1,306.6662083,-54.79969,0.173,NULL,48996774853,765574607,11962103,14.19),(147042,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147042,36.29,0.5,181,70018,70,NULL,NULL,'2MASX J20264693-7406223',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,306.695583333,-74.10628,0.197,NULL,48490213601,757659587,11838431,16.3),(147043,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147043,35.72,0.82,140,70019,70,NULL,NULL,'2MASX J20265263-0149236',NULL,'2014MNRAS.445.2677S',2014,1,0.28,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,306.719333,-1.82314,0.469,NULL,47811162530,747049414,11672647,15.4),(147044,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147044,36.01,0.62,159,70020,70,NULL,NULL,'2MASX J20265625-5254100',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'15.3R',0.2,NULL,NULL,NULL,NULL,NULL,1,306.734417,-52.90275,0.157,NULL,51081417697,798147151,12471049,15.3),(147045,'SNIa SDSS','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 05339','RN',147045,38.41,0.15,423,70021,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 05339',0.138,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147046,'SNIa SDSS','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 05339','RN',147046,38.67,0.27,476,70021,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 05339',0.138,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147047,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147047,36.76,0.76,225,70022,70,NULL,NULL,'2MASX J20271961-5142190',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.5R',0.17,NULL,NULL,NULL,NULL,NULL,1,306.831667,-51.70522,0.057,NULL,51083376387,798177756,12471527,15.5),(147048,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 15884',NULL,147048,38.61,0.64,528,70023,70,NULL,'SN photometric redshift distance, z photo =0.132 +/- 0.050','SDSS-II SN 15884',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,306.839667,-0.01906,0.541,NULL,47807760304,746996254,11671816,NULL),(147049,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147049,37.04,0.62,255,70024,70,NULL,NULL,'2MASX J20272337-6706302',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'15.0R',0.24,NULL,NULL,NULL,NULL,NULL,1,306.847375,-67.10833,0.113,NULL,49364552236,771321128,12051892,15),(147050,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147050,33.07,0.47,41.1,70025,NULL,NULL,'H','NGC 6917',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.00002,NULL,'14.3',1.1,'S',NULL,NULL,NULL,NULL,1,306.868167,8.09808,0.689,NULL,53988455418,843569615,13180775,14.3),(147051,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147051,33.12,0.45,42.1,70025,NULL,NULL,'K','NGC 6917',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147052,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147052,33.14,0.46,42.4,70025,NULL,NULL,'J','NGC 6917',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147053,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147053,33.41,0.69,48.1,70025,100,NULL,'mid-IR','NGC 6917',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147054,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147054,33.87,0.4,59.4,70025,NULL,NULL,'mean','NGC 6917',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147055,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147055,33.05,0.79,40.8,70026,NULL,NULL,NULL,'ESO 234- G 028',NULL,'2009ApJS..182..474S',2009,1,1.2,'Confused HIPASS source','G',0.00003,NULL,'14.27',0.6,'SAB(s)bc pec',NULL,NULL,NULL,NULL,1,306.8839583,-51.65547,0.057,NULL,51083377545,798177774,12471527,14.27),(147056,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147056,33.09,0.2,41.5,70026,74.4,NULL,NULL,'ESO 234- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147057,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147057,33.47,0.66,49.4,70026,NULL,NULL,'Malmquist cor.','ESO 234- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147058,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147058,36.23,0.54,176,70027,70,NULL,NULL,'2MASX J20273247-4429094',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,306.885375,-44.48592,0.077,NULL,51379049611,802797650,12543713,16.3),(147059,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147059,34.85,0.49,93.2,70028,75,NULL,'IR','ESO 596- G 040',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000033,NULL,'15.57',0.3,'SAB(s)c:',NULL,NULL,NULL,NULL,1,306.897167,-18.83503,0.177,NULL,50852961648,794577525,12415273,15.57),(147060,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147060,35.18,0.35,108,70028,NULL,NULL,NULL,'ESO 596- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147061,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147061,35.22,0.2,111,70028,74.4,NULL,NULL,'ESO 596- G 040',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147062,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147062,35.31,0.33,115,70028,NULL,NULL,'Malmquist cor.','ESO 596- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147063,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147063,36.31,0.75,183,70029,70,NULL,NULL,'2MASX J20273660-1852239',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.16',0.6,NULL,NULL,NULL,NULL,NULL,1,306.902625,-18.87356,0.177,NULL,50853668680,794588573,12415446,16.16),(147064,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147064,35.72,0.49,140,70030,70,NULL,NULL,'2MASX J20273752-6654143',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'14.6R',0.21,NULL,NULL,NULL,NULL,NULL,1,306.90625,-66.90394,0.105,NULL,49364505984,771320406,12051881,14.6),(147065,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147065,31.99,0.4,25,70031,73,NULL,'opt','ESO 400- G 025',NULL,'2011A&A...532A.104N',2011,1,1.7,NULL,'G',0.000013,NULL,'15.19',0.7,'SAB(s)dm:',NULL,NULL,NULL,NULL,1,306.908167,-32.95744,0.221,NULL,51293930375,801467662,12522932,15.19),(147066,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147066,32.28,0.2,28.6,70031,74.4,NULL,NULL,'ESO 400- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147067,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147067,32.45,0.43,30.9,70031,75,NULL,'3.6 micron, color corrected','ESO 400- G 025',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147068,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147068,32.58,0.43,32.8,70031,75,NULL,'3.6 micron, color + selection bias corrected','ESO 400- G 025',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147069,'SBF','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147069,32.75,0.16,35.5,70032,NULL,NULL,'I','NGC 6909',NULL,'2001ApJ...546..681T',2001,1,2.2,NULL,'G',0.00005,NULL,'12.61',1.1,'SA0^-','Group member',NULL,NULL,NULL,1,306.9120417,-47.02703,0.069,NULL,51095626272,798369160,12474518,12.61),(147070,'SBF','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147070,32.75,0.16,35.5,70032,NULL,NULL,NULL,'NGC 6909',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147071,'SBF','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147071,32.77,0.14,35.8,70032,74.4,NULL,NULL,'NGC 6909',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147072,'SBF','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147072,32.8,0.16,36.4,70032,NULL,NULL,'Malmquist cor.','NGC 6909',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147073,'D-Sigma','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147073,32.24,0.4,28,70032,75,NULL,'Edat, raw','NGC 6909',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147074,'D-Sigma','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147074,32.36,0.4,29.7,70032,75,NULL,'Edat, cor','NGC 6909',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147075,'Faber-Jackson','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147075,29.67,1.31,8.59,70032,95,NULL,'Weighted Mean','NGC 6909',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147076,'Faber-Jackson','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147076,30.58,1.61,13.1,70032,55,NULL,'Visvanathan & Sandage 1979','NGC 6909',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147077,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147077,32.65,0.41,33.8,70032,NULL,NULL,NULL,'NGC 6909',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147078,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147078,32.9,0.41,38,70032,NULL,NULL,'Malmquist cor.','NGC 6909',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147079,'Tertiary','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147079,32.18,0.71,27.3,70032,95,NULL,NULL,'NGC 6909',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147080,'Tully est','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147080,32.68,0.8,34.3,70032,75,NULL,'B','NGC 6909',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147081,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147081,32.54,0.45,32.2,70032,NULL,NULL,'K','NGC 6909',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147082,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147082,33.02,0.4,40.2,70032,NULL,NULL,'mean','NGC 6909',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147083,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147083,33.52,0.49,50.6,70033,75,NULL,'IR','UGC 11564 NED02',NULL,'2011yCatp016004901K',2011,1,0.8,'Not noted as a pair in CGCG.','G',0.000053,NULL,'15.1',0.2,'Sb',NULL,NULL,NULL,NULL,1,306.914875,10.75725,0.629,NULL,53972976826,843327762,13176996,15.1),(147084,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147084,33.62,0.8,53.1,70034,75,NULL,'MAT, I','ESO 143- G 027',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.00004,NULL,'15.64',0.5,'SB(s)m? sp',NULL,NULL,NULL,NULL,1,306.93475,-58.65297,0.201,NULL,48998042189,765594409,11962412,15.64),(147085,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147085,32.71,0.32,34.8,70034,85,NULL,'I, inv','ESO 143- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147086,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147086,32.75,0.32,35.4,70034,85,NULL,'I, raw','ESO 143- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147087,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147087,33.01,0.43,40.1,70034,75,NULL,'MAT, I, inv','ESO 143- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147088,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147088,33.07,0.43,41.1,70034,75,NULL,'MAT, I, raw','ESO 143- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147089,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147089,33.39,0.43,47.6,70034,75,NULL,'MAT, I, cor','ESO 143- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147090,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147090,33.77,0.8,56.8,70035,75,NULL,'MAT, I','ESO 186- G 047',NULL,'1997ApJS..109..333W',1997,1,1.5,'Confused HIPASS source','G',0.000027,NULL,'14.43',0.7,'SB(rs)bc?',NULL,NULL,NULL,NULL,1,306.94025,-52.38436,0.057,NULL,51082746381,798167912,12471373,14.43),(147091,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147091,33.59,0.32,52.3,70035,85,NULL,'I, raw','ESO 186- G 047',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147092,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147092,33.63,0.32,53.2,70035,85,NULL,'I, inv','ESO 186- G 047',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147093,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147093,33.7,0.49,55,70035,75,NULL,'IR','ESO 186- G 047',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147094,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147094,33.75,0.43,56.3,70035,75,NULL,'MAT, I, raw','ESO 186- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147095,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147095,33.9,0.31,60.3,70035,NULL,NULL,'B, Hubble-type-TF','ESO 186- G 047',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147096,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147096,33.9,NULL,60.3,70035,NULL,NULL,'B, Hubble-type-TF','ESO 186- G 047',NULL,'2005Ap&SS.299..387R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147097,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147097,33.91,NULL,60.5,70035,NULL,NULL,'B','ESO 186- G 047',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147098,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147098,33.91,NULL,60.5,70035,NULL,NULL,'I','ESO 186- G 047',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147099,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147099,33.91,NULL,60.6,70035,NULL,NULL,'B','ESO 186- G 047',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147100,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147100,33.94,0.43,61.2,70035,75,NULL,'MAT, I, inv','ESO 186- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147101,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147101,33.94,NULL,61.4,70035,NULL,NULL,'I','ESO 186- G 047',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147102,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147102,33.98,0.4,62.4,70035,NULL,NULL,'mean','ESO 186- G 047',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147103,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147103,34.02,0.43,63.8,70035,75,NULL,'MAT, I, cor','ESO 186- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147104,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147104,34.23,0.47,70.1,70035,NULL,NULL,'H','ESO 186- G 047',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147105,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147105,34.3,0.46,72.6,70035,NULL,NULL,'J','ESO 186- G 047',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147106,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147106,34.33,0.45,73.4,70035,NULL,NULL,'K','ESO 186- G 047',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147107,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147107,32.94,0.47,38.6,70036,70,NULL,NULL,'NGC 6915',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00014,NULL,'12.26',1,'(R\')Sab? poss. LINER',NULL,NULL,NULL,NULL,1,306.941916667,-3.07706,0.197,NULL,47803559753,746930621,11670790,12.26),(147108,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147108,35.31,0.5,115,70037,70,NULL,NULL,'FAIRALL 0898',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.0b',0.5,NULL,NULL,NULL,NULL,NULL,1,306.957333,-47.07431,0.089,NULL,51095659077,798369673,12474526,16),(147109,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147109,36.35,0.57,186,70038,70,NULL,NULL,'2MASX J20275255-4257203',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'14.9R',0.31,NULL,NULL,NULL,NULL,NULL,1,306.9690417,-42.95569,0.105,NULL,51387372108,802927689,12545745,14.9),(147110,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147110,34.71,0.6,87.3,70039,NULL,NULL,NULL,'ESO 596- G 041',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15',0.7,'SB(r)0/a:      HII',NULL,NULL,NULL,NULL,1,307.0047917,-18.77894,0.177,NULL,50853650176,794588284,12415441,15),(147111,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147111,34.75,0.2,89.1,70039,74.4,NULL,NULL,'ESO 596- G 041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147112,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147112,35,0.53,100,70039,NULL,NULL,'Malmquist cor.','ESO 596- G 041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147113,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147113,33.21,0.49,43.9,70040,75,NULL,'IR','UGC 11565',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.00003,NULL,'15.04',0.2,'Im?',NULL,NULL,NULL,NULL,1,307.011917,4.96197,0.329,NULL,54009209276,843893894,13185842,15.04),(147114,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147114,35.26,0.76,113,70041,70,NULL,NULL,'FAIRALL 0900',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.5I',0.7,NULL,NULL,NULL,NULL,NULL,1,307.0209583,-45.14514,0.033,NULL,51378436495,802788070,12543563,13.5),(147115,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 05340','R',147115,39.51,0.2,668,70042,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05340',0.1937,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,307.0212917,-0.273,0.541,NULL,47807905005,746998515,11671851,NULL),(147116,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 05340','R',147116,39.67,0.13,720,70042,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 05340',0.1937,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147117,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147117,34.44,0.8,77.2,70043,75,NULL,'MAT, I','ESO 234- G 032',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.45',0.6,'(R\')SB(s)bc',NULL,NULL,NULL,NULL,1,307.026917,-51.69161,0.057,NULL,51083431775,798178621,12471540,14.45),(147118,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147118,33.9,NULL,60.3,70043,NULL,NULL,'B','ESO 234- G 032',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147119,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147119,33.9,0.16,60.3,70043,NULL,NULL,'B, Hubble-type-TF','ESO 234- G 032',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147120,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147120,33.9,NULL,60.3,70043,NULL,NULL,'I','ESO 234- G 032',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147121,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147121,34.01,0.43,63.3,70043,75,NULL,'MAT, I, raw','ESO 234- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147122,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147122,34.18,0.43,68.6,70043,75,NULL,'MAT, I, inv','ESO 234- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147123,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147123,34.21,0.43,69.6,70043,75,NULL,'MAT, I, cor','ESO 234- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147124,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147124,34.23,0.32,70.1,70043,85,NULL,'I, raw','ESO 234- G 032',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147125,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147125,34.27,0.32,71.4,70043,85,NULL,'I, inv','ESO 234- G 032',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147126,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147126,31.63,0.39,21.2,70044,73,NULL,'opt','ESO 400-IG 026',NULL,'2011A&A...532A.104N',2011,1,1.4,NULL,'G',0.000018,NULL,'15.06',0.5,'IBm: pec',NULL,NULL,NULL,NULL,1,307.0399583,-35.8105,0.093,NULL,51294264397,801472881,12523013,15.06),(147127,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147127,35.06,0.47,103,70045,NULL,NULL,NULL,'IC 1321',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.18',0.8,'(R\')SB(r)bc    HII',NULL,NULL,NULL,NULL,1,307.0460417,-18.2915,0.177,NULL,50846410854,794475169,12413674,15.18),(147128,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147128,35.1,0.2,105,70045,74.4,NULL,NULL,'IC 1321',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147129,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147129,35.22,0.44,110,70045,NULL,NULL,'Malmquist cor.','IC 1321',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147130,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 15381','R',147130,39.08,0.11,563,70046,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15381',0.162,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,307.07625,0.49336,0.525,NULL,53996366761,843693230,13182706,NULL),(147131,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 15381','R',147131,39.27,0.25,615,70046,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15381',0.162,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147132,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147132,33.65,0.47,53.6,70047,NULL,NULL,'H','UGC 11568',NULL,'2007A&A...465...71T',2007,1,2.1,NULL,'G',0.000005,NULL,'14.5',0.6,'Scd?',NULL,NULL,NULL,NULL,1,307.0777917,10.75578,0.629,NULL,53972866112,843326033,13176969,14.5),(147133,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147133,33.65,0.46,53.7,70047,NULL,NULL,'J','UGC 11568',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147134,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147134,33.68,0.45,54.4,70047,NULL,NULL,'K','UGC 11568',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147135,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147135,33.68,0.4,54.4,70047,NULL,NULL,'mean','UGC 11568',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147136,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147136,33.71,0.43,55.1,70047,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11568',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147137,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147137,33.71,0.43,55.3,70047,75,NULL,'3.6 micron, color corrected','UGC 11568',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147138,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147138,33.78,0.33,57,70047,70,NULL,'H, UH88/IRSF/2MASS','UGC 11568',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147139,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147139,33.78,0.33,57,70047,70,NULL,'H, 2MASS','UGC 11568',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147140,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147140,33.85,0.2,58.9,70047,74.4,NULL,NULL,'UGC 11568',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147141,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147141,34.1,0.28,66.1,70047,NULL,NULL,'Malmquist cor.','UGC 11568',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147142,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147142,34.11,0.28,66.4,70047,NULL,NULL,NULL,'UGC 11568',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147143,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 19023','R',147143,40.57,0.2,1050,70048,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ls','SN 2007ls',0.243,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,307.1169583,0.00622,0.533,NULL,53995446699,843678854,13182482,NULL),(147144,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 19023','R',147144,40.69,0.1,1100,70048,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ls','SN 2007ls',0.243,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147145,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 20639',NULL,147145,39.76,0.39,894,70049,70,NULL,'SN photometric redshift distance, z photo =0.236 +/- 0.054','SDSS-II SN 20639',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,307.122791667,0.788,0.469,NULL,53996062043,843688469,13182632,NULL),(147146,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147146,35.69,0.55,137,70050,70,NULL,NULL,'2MASX J20283290-4404299',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'14.2R',0.46,NULL,NULL,NULL,NULL,NULL,1,307.137083,-44.07506,0.085,NULL,51378997911,802796842,12543700,14.2),(147147,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147147,35.82,0.42,146,70051,NULL,NULL,NULL,'ESO 143- G 028',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.59',0.5,'SA(r)c',NULL,NULL,NULL,NULL,1,307.139917,-61.71847,0.185,NULL,49153330740,768020792,12000324,15.59),(147148,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147148,35.84,0.42,147,70051,NULL,NULL,'Malmquist cor.','ESO 143- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147149,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147149,35.87,0.2,149,70051,74.4,NULL,NULL,'ESO 143- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147150,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147150,36.8,0.69,229,70052,70,NULL,NULL,'2MASX J20284234-4810287',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.4b',0.18,NULL,NULL,NULL,NULL,NULL,1,307.176417,-48.17456,0.077,NULL,51129451413,798897678,12482776,16.4),(147151,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147151,34.5,0.79,79.5,70053,NULL,NULL,'Malmquist cor.','UGC 11569',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',NULL,NULL,'16.0',0.6,'Scd:',NULL,NULL,NULL,NULL,1,307.188333,10.62844,0.629,NULL,53975771449,843371428,13177678,16),(147152,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147152,34.52,0.78,80.3,70053,NULL,NULL,NULL,'UGC 11569',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147153,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147153,34.56,0.2,81.7,70053,74.4,NULL,NULL,'UGC 11569',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147154,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 14988',NULL,147154,40.29,0.13,1140,70054,70,NULL,'SN photometric redshift distance, z photo =0.315 +/- 0.024','SDSS-II SN 14988',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,307.204958333,0.28889,0.525,NULL,53996341868,843692841,13182700,NULL),(147155,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147155,35.47,0.51,124,70055,70,NULL,NULL,'2MASX J20285063-7406114',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,307.210833,-74.10319,0.201,NULL,48490197866,757659341,11838427,16),(147156,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147156,35.88,0.63,150,70056,70,NULL,NULL,'2MASX J20285199-1851060',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.03',NULL,NULL,NULL,NULL,NULL,NULL,1,307.2165,-18.85175,0.149,NULL,50853679521,794588742,12415449,16.03),(147157,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147157,35.78,0.51,143,70057,70,NULL,NULL,'2MASX J20285230-7921533',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,307.2182083,-79.36483,0.577,NULL,48583812343,759122067,11861282,16.7),(147158,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2005hp',NULL,147158,38.82,0.13,492,70058,74.2,NULL,'SALT 2','[BBB2005b] J202852.60-004645.3',0.18,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,307.219167,-0.77925,0.653,NULL,47808078794,747001231,11671894,NULL),(147159,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2005hp',NULL,147159,39.47,0.06,665,70058,70,NULL,'SDSS-II SN 05350','[BBB2005b] J202852.60-004645.3',0.18,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147160,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2005hp',NULL,147160,39.53,0.12,682,70058,65,NULL,'SALT2','[BBB2005b] J202852.60-004645.3',0.18,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147161,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2005hp',NULL,147161,39.54,0.13,686,70058,70,NULL,'SDSS-II SN 05350, SALT 2','[BBB2005b] J202852.60-004645.3',0.18,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147162,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 05350','R',147162,39.55,0.2,689,70058,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005hp','[BBB2005b] J202852.60-004645.3',0.18,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147163,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 05350','R',147163,39.72,0.13,745,70058,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005hp','[BBB2005b] J202852.60-004645.3',0.18,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147164,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2005hp',NULL,147164,39.8,0.15,773,70058,65,NULL,'MLCS2k2','[BBB2005b] J202852.60-004645.3',0.18,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147165,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147165,35.79,0.62,144,70059,70,NULL,NULL,'2MASX J20285410-2111450',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,307.225417,-21.19581,0.185,NULL,50866343720,794786620,12418540,15.6),(147166,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147166,33.25,0.2,44.7,70060,74.4,NULL,NULL,'UGC 11571',NULL,'2013AJ....146...86T',2013,1,2,NULL,'G',0.000027,NULL,'14.8',0.6,'SBcd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,307.256167,10.67869,0.629,NULL,53975712986,843370515,13177664,14.8),(147167,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147167,33.27,0.53,45.1,70060,NULL,NULL,NULL,'UGC 11571',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147168,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147168,33.46,0.49,49.2,70060,75,NULL,'IR','UGC 11571',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147169,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147169,33.48,0.48,49.7,70060,NULL,NULL,'Malmquist cor.','UGC 11571',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147170,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147170,33.93,0.4,61.2,70060,NULL,NULL,'mean','UGC 11571',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147171,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147171,34.28,0.47,71.7,70060,NULL,NULL,'H','UGC 11571',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147172,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147172,34.4,0.45,75.8,70060,NULL,NULL,'K','UGC 11571',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147173,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 20128',NULL,147173,39.4,0.57,758,70061,70,NULL,'SN photometric redshift distance, z photo =0.196 +/- 0.068','SDSS-II SN 20128',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,307.3495,0.18789,0.525,NULL,53995822338,843684724,13182573,NULL),(147174,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 04953',NULL,147174,39.62,0.25,841,70062,70,NULL,'SN photometric redshift distance, z photo =0.220 +/- 0.031','SDSS-II SN 04953',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,307.3527083,-0.99825,0.729,NULL,47810015615,747031493,11672367,NULL),(147175,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147175,34.37,0.47,74.8,70063,70,NULL,NULL,'CGCG 373-016',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'14.8',0.4,NULL,NULL,NULL,NULL,NULL,1,307.352833,-0.174,0.673,NULL,47808376565,747005883,11671966,14.8),(147176,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147176,36.52,0.57,201,70064,70,NULL,NULL,'2MASX J20292556-0744086',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.5I',0.7,NULL,NULL,NULL,NULL,NULL,1,307.3565,-7.73575,0.189,NULL,47831595167,747368674,11677635,13.5),(147177,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147177,34.34,0.43,73.6,70065,NULL,NULL,'Malmquist cor.','IC 5012',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.00003,NULL,'15.22',0.5,'SB(rs)c',NULL,NULL,NULL,NULL,1,307.38325,-56.74311,0.233,NULL,49002358794,765661856,11963466,15.22),(147178,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147178,34.51,0.4,80,70065,NULL,NULL,NULL,'IC 5012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147179,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147179,34.55,0.2,81.3,70065,74.4,NULL,NULL,'IC 5012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147180,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147180,33.01,0.69,39.9,70066,100,NULL,'mid-IR','MCG -02-52-006',NULL,'2013ApJ...771...88L',2013,1,1,NULL,'G',0.000027,NULL,'14.1b',0.4,NULL,NULL,NULL,NULL,NULL,1,307.3962083,-12.50342,0.169,NULL,50970072817,796407387,12443865,14.1),(147181,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147181,33.66,NULL,54,70066,70,NULL,'H, UH88/IRSF/2MASS, Malmquist corr.','MCG -02-52-006',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147182,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147182,33.66,NULL,54,70066,70,NULL,'H, 2MASS, Malmquist corr.','MCG -02-52-006',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147183,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147183,33.75,0.44,56.2,70066,70,NULL,'H, UH88/IRSF/2MASS','MCG -02-52-006',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147184,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147184,33.75,0.44,56.2,70066,70,NULL,'H, 2MASS','MCG -02-52-006',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147185,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147185,34.7,0.8,87,70067,75,NULL,'MAT, I','ESO 285- G 020',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.66',0.8,'SA(r)bc',NULL,NULL,NULL,NULL,1,307.4065417,-43.84106,0.089,NULL,51378993933,802796780,12543699,14.66),(147186,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147186,34.54,0.32,80.8,70067,85,NULL,'I, raw','ESO 285- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147187,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147187,34.58,0.32,82.3,70067,85,NULL,'I, inv','ESO 285- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147188,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147188,34.61,0.43,83.5,70067,75,NULL,'MAT, I, raw','ESO 285- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147189,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147189,34.81,0.43,91.4,70067,75,NULL,'MAT, I, inv','ESO 285- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147190,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147190,34.89,0.43,94.9,70067,75,NULL,'MAT, I, cor','ESO 285- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147191,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147191,34.78,0.62,90.3,70068,NULL,NULL,'Malmquist cor.','ESO 285- G 021',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'15.63',0.7,'S(r?)...',NULL,NULL,NULL,NULL,1,307.4440417,-45.413,0.045,NULL,51379450319,802803911,12543811,15.63),(147192,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147192,34.91,0.58,96,70068,NULL,NULL,NULL,'ESO 285- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147193,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147193,34.95,0.2,97.7,70068,74.4,NULL,NULL,'ESO 285- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147194,'SNIa SDSS','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 08412','R',147194,40.6,0.17,1070,70069,70,NULL,'SDSS CAND. Unknown; MLCS2K2; SN 2005jq','[BBB2005a] J202947.68+010833.7',0.234,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,307.448667,1.14269,0.429,NULL,53996504588,843695384,13182740,NULL),(147195,'SNIa SDSS','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 08412','R',147195,40.65,0.23,1090,70069,70,NULL,'SDSS CAND. Unknown; SALT 2; SN 2005jq','[BBB2005a] J202947.68+010833.7',0.234,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147196,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147196,33.85,0.43,59,70070,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 373-018',NULL,'2014MNRAS.444..527S',2014,1,0.7,NULL,'G',0.000023,NULL,'15.7',0.15,NULL,NULL,NULL,NULL,NULL,1,307.454875,-2.02897,0.453,NULL,47809820291,747028442,11672319,15.7),(147197,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147197,34.58,0.49,82.2,70071,75,NULL,'IR','FGC 2269',NULL,'2011yCatp016004901K',2011,1,1.08,NULL,'G',0.00003,NULL,'16.3',0.11,'Sdm',NULL,NULL,NULL,NULL,1,307.477,-1.79181,0.517,NULL,47809623926,747025373,11672271,16.3),(147198,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147198,34.63,0.48,84.3,70072,70,NULL,NULL,'ESO 596- G 048',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000073,NULL,'13.91',0.5,'E?',NULL,NULL,NULL,NULL,1,307.559458333,-19.11603,0.149,NULL,50853488831,794585762,12415402,13.91),(147199,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147199,34.28,0.47,71.9,70073,NULL,NULL,'H','ESO 400- G 033',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000033,NULL,'15.1b',0.3,'Sb',NULL,NULL,NULL,NULL,1,307.5637083,-34.812,0.081,NULL,51294715172,801479924,12523123,15.1),(147200,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147200,34.35,0.45,74.2,70073,NULL,NULL,'K','ESO 400- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147201,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147201,34.47,0.46,78.2,70073,NULL,NULL,'J','ESO 400- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147202,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147202,34.47,0.4,78.5,70073,NULL,NULL,'mean','ESO 400- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147203,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147203,34.81,0.45,91.6,70073,NULL,NULL,'Malmquist cor.','ESO 400- G 033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147204,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147204,34.99,0.41,99.7,70073,NULL,NULL,NULL,'ESO 400- G 033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147205,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147205,35.03,0.2,101,70073,74.4,NULL,NULL,'ESO 400- G 033',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147206,'Brightest Stars','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147206,28.85,NULL,5.9,70074,NULL,NULL,NULL,'UGC 11583',NULL,'1997AstL...23..373S',1997,1,2.5,NULL,'G',0.000007,NULL,'17.',0.6,'Irr',NULL,NULL,NULL,NULL,1,307.56375,60.44028,1.353,NULL,53460255367,835316490,13051820,17),(147207,'Brightest Stars','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147207,29.57,NULL,8.2,70074,NULL,NULL,NULL,'UGC 11583',NULL,'2000A&A...362..544K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147208,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147208,35.75,0.63,141,70075,70,NULL,NULL,'2MASX J20302222-5243009',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.5I',0.4,NULL,NULL,NULL,NULL,NULL,1,307.5927083,-52.71686,0.057,NULL,51084035220,798188050,12471688,14.5),(147209,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147209,35.78,0.74,143,70076,70,NULL,NULL,'IC 5010',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.88',0.3,'Sa - b',NULL,NULL,NULL,NULL,1,307.611167,-66.09736,0.133,NULL,49372066739,771438542,12053727,15.88),(147210,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147210,34.88,0.55,94.5,70077,70,NULL,NULL,'2MASX J20303209-4420396',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,307.63375,-44.34439,0.081,NULL,51378937336,802795895,12543685,16.8),(147211,'Brightest Stars','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147211,28.63,NULL,5.3,70078,NULL,NULL,NULL,'LEDA 166192',NULL,'2000A&A...362..544K',2000,1,1.6,NULL,'G',0.000007,NULL,'16.5',0.8,'Irr?',NULL,NULL,NULL,NULL,1,307.637083,60.35472,1.353,NULL,53460235985,835316187,13051815,16.5),(147212,'Brightest Stars','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147212,28.85,NULL,5.9,70078,NULL,NULL,NULL,'LEDA 166192',NULL,'1997AstL...23..373S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147213,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147213,35.91,0.68,152,70079,70,NULL,NULL,'2MASX J20303663-8429251',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,307.6519583,-84.49028,0.405,NULL,48383729173,755995768,11812433,16.5),(147214,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147214,32.93,0.8,38.6,70080,75,NULL,'MAT, I','IC 5020',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000018,NULL,'13.05',2.1,'SA(s)bc        HII?','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,307.660375,-33.48556,0.141,NULL,51296081946,801501280,12523457,13.05),(147215,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147215,32.77,0.43,35.8,70080,75,NULL,'MAT, I, raw','IC 5020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147216,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147216,32.89,0.32,37.9,70080,85,NULL,'I, raw','IC 5020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147217,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147217,32.93,0.43,38.5,70080,75,NULL,'MAT, I, cor','IC 5020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147218,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147218,32.94,0.32,38.8,70080,85,NULL,'I, inv','IC 5020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147219,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147219,32.99,0.43,39.7,70080,75,NULL,'MAT, I, inv','IC 5020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147220,'SNII optical','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 1992af',NULL,147220,33.7,0.9,55,70081,NULL,NULL,NULL,'ESO 340- G 038',NULL,'1994ApJ...432...42S',1994,1,1.1,NULL,'G',0.00015,NULL,'15.04',1,'S...',NULL,NULL,NULL,NULL,1,307.66175,-42.30906,0.097,NULL,51387089371,802923271,12545676,15.04),(147221,'SNII optical','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 1992af',NULL,147221,34.05,0.87,62.2,70081,NULL,NULL,'SEAM','ESO 340- G 038',0.018466,'2009ApJ...694.1067P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147222,'SNII optical','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 1992af',NULL,147222,33.97,0.07,62.2,70081,NULL,NULL,'I, photospheric magnitude method','ESO 340- G 038',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147223,'SNII optical','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 1992af',NULL,147223,34.08,0.13,65.5,70081,NULL,NULL,'V, photospheric magnitude method','ESO 340- G 038',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147224,'SNII optical','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 1992af',NULL,147224,34.13,0.54,67,70081,NULL,NULL,'SCM, V','ESO 340- G 038',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147225,'SNII optical','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 1992af',NULL,147225,34.13,0.54,67,70081,NULL,NULL,'SCM, I','ESO 340- G 038',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147226,'SNII optical','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 1992af',NULL,147226,34.15,0.28,67.6,70081,NULL,NULL,'SCM, BVI','ESO 340- G 038',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147227,'SNII optical','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 1992af',NULL,147227,34.18,0.41,68.5,70081,NULL,NULL,'SCM, B','ESO 340- G 038',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147228,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 05363',NULL,147228,39.74,0.33,887,70082,70,NULL,'SN photometric redshift distance, z photo =0.234 +/- 0.045','SDSS-II SN 05363',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,307.6615,0.94675,0.429,NULL,53997429339,843709833,13182966,NULL),(147229,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147229,34.67,0.59,85.8,70083,70,NULL,NULL,'CGCG 373-026',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000127,NULL,'15.5',0.5,NULL,NULL,NULL,NULL,NULL,1,307.6647083,-2.32519,0.417,NULL,47808842925,747013170,11672080,15.5),(147230,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147230,34.83,0.4,92.3,70084,NULL,NULL,'mean','ESO 340- G 040',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000033,NULL,'15',0.4,'S...',NULL,NULL,NULL,NULL,1,307.694583,-39.24861,0.101,NULL,51507943643,804811619,12575181,15),(147231,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147231,34.87,0.47,94.1,70084,NULL,NULL,'H','ESO 340- G 040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147232,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147232,34.98,0.46,98.9,70084,NULL,NULL,'J','ESO 340- G 040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147233,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147233,35.01,0.45,101,70084,NULL,NULL,'K','ESO 340- G 040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147234,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147234,35.14,0.53,107,70084,NULL,NULL,'Malmquist cor.','ESO 340- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147235,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147235,35.4,0.47,120,70084,NULL,NULL,NULL,'ESO 340- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147236,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147236,35.44,0.2,122,70084,74.4,NULL,NULL,'ESO 340- G 040',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147237,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147237,34.08,0.49,65.4,70085,75,NULL,'IR','UGC 11580',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000043,NULL,'16.0',0.2,'Scd:',NULL,NULL,NULL,NULL,1,307.7114583,8.09139,0.529,NULL,53988667789,843572934,13180827,16),(147238,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147238,34.36,0.49,74.5,70086,75,NULL,'IR','UGC 11579',NULL,'2011yCatp016004901K',2011,1,1.49,NULL,'G',0.00004,NULL,'16.0',0.2,'Sc','Field galaxy',NULL,NULL,NULL,1,307.730291667,-0.64933,0.549,NULL,47810435891,747038060,11672469,16),(147239,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147239,34.54,0.4,80.8,70086,NULL,NULL,'mean','UGC 11579',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147240,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147240,34.58,0.36,82.6,70086,NULL,NULL,'Malmquist cor.','UGC 11579',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147241,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147241,34.64,0.2,84.7,70086,74.4,NULL,NULL,'UGC 11579',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147242,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147242,34.69,0.34,86.6,70086,NULL,NULL,NULL,'UGC 11579',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147243,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147243,34.82,0.43,91.9,70086,75,NULL,'3.6 micron, color corrected','UGC 11579',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147244,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147244,34.94,NULL,97.1,70086,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11579',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147245,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147245,34.94,0.47,97.3,70086,NULL,NULL,'H','UGC 11579',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147246,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147246,34.94,NULL,97.4,70086,NULL,NULL,'Dipole + Quadrupole','UGC 11579',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147247,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147247,34.96,NULL,98,70086,NULL,NULL,'Dipole','UGC 11579',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147248,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147248,34.98,0.43,98.9,70086,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11579',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147249,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147249,34.82,0.64,91.9,70087,NULL,NULL,NULL,'ESO 462- G 027',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000033,NULL,'13.7I',NULL,NULL,NULL,NULL,NULL,NULL,1,307.7399583,-30.66692,0.253,NULL,51323215121,801925236,12530081,13.7),(147250,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147250,34.86,0.2,93.8,70087,74.4,NULL,NULL,'ESO 462- G 027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147251,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147251,34.94,0.61,97.1,70087,NULL,NULL,'Malmquist cor.','ESO 462- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147252,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147252,36.48,0.56,197,70088,70,NULL,NULL,'2MASX J20311146-5341401',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'14.8R',0.31,NULL,NULL,NULL,NULL,NULL,1,307.7977083,-53.69456,0.145,NULL,51079350672,798114854,12470544,14.8),(147253,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147253,35.52,0.78,127,70089,70,NULL,NULL,'ESO 285- G 025',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.07',0.7,'SB(r)a',NULL,NULL,NULL,NULL,1,307.800833,-44.26231,0.081,NULL,51378932518,802795820,12543684,15.07),(147254,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147254,32.93,0.8,38.5,70090,75,NULL,'MAT, I','ESO 400- G 037',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000013,NULL,'14.54',1.1,'SB(s)cd pec','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,307.806083,-33.47819,0.105,NULL,51295944902,801499139,12523424,14.54),(147255,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147255,33.52,0.2,50.6,70090,74.4,NULL,NULL,'ESO 400- G 037',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147256,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147256,33.58,0.32,52,70090,85,NULL,'I, raw','ESO 400- G 037',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147257,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147257,33.6,0.32,52.5,70090,85,NULL,'I, inv','ESO 400- G 037',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147258,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147258,33.7,0.43,54.9,70090,75,NULL,'MAT, I, raw','ESO 400- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147259,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147259,33.73,0.7,55.8,70090,NULL,NULL,NULL,'ESO 400- G 037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147260,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147260,33.81,0.43,57.8,70090,75,NULL,'MAT, I, inv','ESO 400- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147261,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147261,33.99,0.62,62.8,70090,NULL,NULL,'Malmquist cor.','ESO 400- G 037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147262,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147262,34.17,0.43,68.2,70090,75,NULL,'MAT, I, cor','ESO 400- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147263,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147263,34.39,0.58,75.5,70091,NULL,NULL,NULL,'ESO 596- G 052',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.00015,NULL,'15.82',0.4,'S...',NULL,NULL,NULL,NULL,1,307.8262917,-19.04881,0.153,NULL,50853530010,794586406,12415412,15.82),(147264,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147264,34.43,0.2,76.9,70091,74.4,NULL,NULL,'ESO 596- G 052',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147265,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147265,34.58,0.53,82.4,70091,NULL,NULL,'Malmquist cor.','ESO 596- G 052',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147266,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147266,35.43,0.51,122,70092,NULL,NULL,NULL,'ESO 528- G 015',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.3b',0.3,'S...',NULL,NULL,NULL,NULL,1,307.840375,-26.98419,0.241,NULL,51310625310,801728520,12527008,16.3),(147267,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147267,35.43,0.51,122,70092,NULL,NULL,'Malmquist cor.','ESO 528- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147268,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147268,35.47,0.2,124,70092,74.4,NULL,NULL,'ESO 528- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147269,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147269,36.23,0.59,177,70093,70,NULL,NULL,'2MASX J20312836-5420485',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,307.8682083,-54.34681,0.153,NULL,51079500325,798117192,12470581,15),(147270,'Brightest Stars','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147270,28.64,NULL,5.3,70094,NULL,NULL,NULL,'LEDA 166193',NULL,'2000A&A...362..544K',2000,1,0.9,NULL,'G',0.000003,NULL,'17.1',0.9,'Sph?',NULL,NULL,NULL,NULL,1,307.883333,60.81222,1.673,NULL,53460155910,835314936,13051795,17.1),(147271,'Brightest Stars','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147271,28.85,NULL,5.9,70094,NULL,NULL,NULL,'LEDA 166193',NULL,'1997AstL...23..373S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147272,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147272,37.37,0.6,298,70095,70,NULL,NULL,'2MASX J20313219-5351542',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,'E?',NULL,NULL,NULL,NULL,1,307.884125,-53.86514,0.145,NULL,51079402411,798115662,12470557,17),(147273,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147273,34.89,0.5,94.9,70096,70,NULL,NULL,'ESO 597- G 001',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000083,NULL,'15',0.8,'SAB(r)0/a',NULL,NULL,NULL,NULL,1,307.889708333,-19.36869,0.149,NULL,50855537314,794617770,12415902,15),(147274,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147274,34.69,0.8,86.7,70097,75,NULL,'MAT, I','NGC 6919',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000027,NULL,'13.58',1.2,'SA(rs)c',NULL,NULL,NULL,NULL,1,307.908833,-44.21642,0.081,NULL,51378817743,802794027,12543656,13.58),(147275,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147275,33.82,0.43,58.1,70097,75,NULL,'MAT, I, raw','NGC 6919',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147276,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147276,34.05,0.43,64.7,70097,75,NULL,'MAT, I, inv','NGC 6919',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147277,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147277,34.19,0.43,68.8,70097,75,NULL,'MAT, I, cor','NGC 6919',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147278,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147278,34.22,0.32,69.7,70097,85,NULL,'I, raw','NGC 6919',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147279,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147279,34.28,0.32,71.8,70097,85,NULL,'I, inv','NGC 6919',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147280,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147280,34.45,0.39,77.6,70097,NULL,NULL,NULL,'NGC 6919',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147281,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147281,34.45,0.39,77.6,70097,NULL,NULL,'Malmquist cor.','NGC 6919',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147282,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147282,34.47,0.47,78.3,70097,NULL,NULL,'H','NGC 6919',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147283,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147283,34.49,0.2,79.1,70097,74.4,NULL,NULL,'NGC 6919',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147284,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147284,34.67,0.46,86.1,70097,NULL,NULL,'J','NGC 6919',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147285,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147285,34.72,0.45,87.9,70097,NULL,NULL,'K','NGC 6919',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147286,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147286,34.89,0.4,95,70097,NULL,NULL,'mean','NGC 6919',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147287,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147287,32.76,0.8,35.7,70098,75,NULL,'MAT, I','NGC 6923',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.00001,NULL,'12.68',1.3,'SB(rs)b:','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,307.9127917,-30.83189,0.213,NULL,51325283117,801957548,12530586,12.68),(147288,'Sosies','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147288,32.62,0.09,33.4,70098,NULL,NULL,NULL,'NGC 6923',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147289,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147289,32.59,0.32,33,70098,85,NULL,'I, raw','NGC 6923',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147290,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147290,32.65,0.32,33.9,70098,85,NULL,'I, inv','NGC 6923',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147291,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147291,32.67,0.47,34.2,70098,NULL,NULL,'H','NGC 6923',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147292,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147292,32.7,0.46,34.7,70098,NULL,NULL,'J','NGC 6923',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147293,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147293,32.74,0.45,35.3,70098,NULL,NULL,'K','NGC 6923',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147294,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147294,32.74,0.43,35.3,70098,75,NULL,'MAT, I, raw','NGC 6923',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147295,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147295,32.85,0.4,37.2,70098,NULL,NULL,NULL,'NGC 6923',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147296,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147296,32.89,0.43,37.8,70098,75,NULL,'MAT, I, cor','NGC 6923',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147297,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147297,32.91,0.4,38.2,70098,NULL,NULL,'mean','NGC 6923',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147298,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147298,33.01,0.43,40.1,70098,75,NULL,'MAT, I, inv','NGC 6923',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147299,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2005iv',NULL,147299,40.32,0.16,891,70099,74.2,NULL,'SALT 2','[BBB2005a] J203144.67+001441.1',0.3,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,307.936125,0.24475,0.517,NULL,53996742128,843699095,13182798,NULL),(147300,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2005iv',NULL,147300,41.01,0.16,1230,70099,65,NULL,'SALT2','[BBB2005a] J203144.67+001441.1',0.3,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147301,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2005iv',NULL,147301,41.02,0.18,1230,70099,70,NULL,'SALT 2','[BBB2005a] J203144.67+001441.1',0.3,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147302,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 06137','R',147302,41.12,0.26,1290,70099,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005iv','[BBB2005a] J203144.67+001441.1',0.3,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147303,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2005iv',NULL,147303,41.16,0.12,1310,70099,65,NULL,'MLCS2k2','[BBB2005a] J203144.67+001441.1',0.3,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147304,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 06137','R',147304,41.3,0.17,1400,70099,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005iv','[BBB2005a] J203144.67+001441.1',0.3,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147305,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147305,37.28,0.7,286,70100,70,NULL,NULL,'2MASX J20314479-5429304',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,307.936708333,-54.49181,0.153,NULL,51079330713,798114542,12470539,15.9),(147306,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147306,37.03,0.55,254,70101,70,NULL,NULL,'AM 2020-841 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000127,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,307.940583,-84.05831,0.433,NULL,48384046585,756000727,11812511,16.2),(147307,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147307,34.09,0.49,65.7,70102,75,NULL,'IR','CGCG 424-018',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',NULL,NULL,'15.7',0.2,NULL,NULL,NULL,NULL,NULL,1,307.9407917,10.05631,0.417,NULL,55064468095,860382313,13443473,15.7),(147308,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147308,36.38,0.65,189,70103,70,NULL,NULL,'2MASX J20314855-7452087',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,307.9520417,-74.86914,0.233,NULL,48489252775,757644574,11838196,17.1),(147309,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147309,34.25,0.49,70.7,70104,75,NULL,'IR','UGC 11584',NULL,'2011yCatp016004901K',2011,1,2.13,NULL,'G',0.000009,NULL,'15.37',0.26,'Sc',NULL,NULL,NULL,NULL,1,307.9574583,1.54489,0.461,NULL,53994884793,843670074,13182344,15.37),(147310,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147310,34.54,NULL,80.9,70104,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11584',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147311,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147311,34.55,NULL,81.2,70104,NULL,NULL,'Dipole + Quadrupole','UGC 11584',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147312,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147312,34.55,NULL,81.2,70104,NULL,NULL,'Dipole','UGC 11584',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147313,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147313,34.6,NULL,83.3,70104,NULL,NULL,NULL,'UGC 11584',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147314,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147314,34.64,0.43,84.9,70104,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11584',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147315,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147315,34.83,0.43,92.3,70104,75,NULL,'3.6 micron, color corrected','UGC 11584',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147316,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147316,34.88,0.39,94.8,70104,NULL,NULL,'Malmquist cor.','UGC 11584',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147317,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147317,35.06,0.2,103,70104,74.4,NULL,NULL,'UGC 11584',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147318,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147318,35.2,0.34,110,70104,NULL,NULL,NULL,'UGC 11584',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147319,'SNIa SDSS','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 16290','RN',147319,39.12,0.21,580,70105,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16290',0.1511,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147320,'SNIa SDSS','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 16290','RN',147320,39.36,0.1,646,70105,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16290',0.1511,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147321,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147321,35.68,0.6,137,70106,70,NULL,NULL,'2MASX J20315435-0130330',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'17.09',0.5,NULL,NULL,NULL,NULL,NULL,1,307.976583,-1.50911,0.521,NULL,47810121320,747033145,11672392,17.09),(147322,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147322,35.68,0.52,137,70107,70,NULL,NULL,'2MASX J20320061-5023085',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'14.7R',0.22,NULL,NULL,NULL,NULL,NULL,1,308.002583,-50.38567,0.029,NULL,51075463667,798054119,12469595,14.7),(147323,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147323,34.65,0.67,85,70108,70,NULL,NULL,'ESO 285- G 028',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000147,NULL,'15.09',0.3,'Sa:',NULL,NULL,NULL,NULL,1,308.012875,-44.41692,0.081,NULL,51378790936,802793608,12543650,15.09),(147324,'SNIa SDSS','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 14599','R',147324,38.31,0.06,437,70109,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2006jl','[BBB2006] J203204.67-003428.3',0.05,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,308.0194583,-0.57453,0.565,NULL,47810537038,747039641,11672494,NULL),(147325,'SNIa SDSS','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 14599','R',147325,38.97,0.3,593,70109,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2006jl','[BBB2006] J203204.67-003428.3',0.05,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147326,'SNII optical','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2006jl',NULL,147326,36.83,0.09,221,70109,NULL,NULL,'SCM 55 SNII','[BBB2006] J203204.67-003428.3',0.05,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147327,'SNII optical','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2006jl',NULL,147327,36.85,0.11,224,70109,NULL,NULL,'SCM 15 SDSS SNII','[BBB2006] J203204.67-003428.3',0.05,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147328,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147328,34.31,0.5,72.8,70110,70,NULL,NULL,'2MASX J20320481-1959487',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00008,NULL,'15.59',0.6,'SA(r)0^+',NULL,NULL,NULL,NULL,1,308.019917,-19.99706,0.181,NULL,50855845308,794622582,12415977,15.59),(147329,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147329,34.2,0.46,69.1,70111,70,NULL,NULL,'IC 1324',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000033,NULL,'14.5',1.5,'(R\')SA(rs)0/a:',NULL,NULL,NULL,NULL,1,308.0512917,-9.05611,0.265,NULL,47829900279,747342191,11677221,14.5),(147330,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147330,32.36,0.49,29.7,70112,75,NULL,'IR','MCG -02-52-011',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.00005,NULL,'15',0.5,'IBm pec',NULL,NULL,NULL,NULL,1,308.053333,-8.73372,0.233,NULL,47829829916,747341092,11677204,15),(147331,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147331,32.33,0.8,29.2,70113,75,NULL,'MAT, I','ESO 234- G 043',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000017,NULL,'14.22',1.5,'SB(rs)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,308.05725,-48.53072,0.093,NULL,51074985478,798046648,12469478,14.22),(147332,'Tully est','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147332,32.46,0.8,31.1,70113,75,NULL,NULL,'ESO 234- G 043',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147333,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147333,31.09,0.32,16.5,70113,85,NULL,'I, inv','ESO 234- G 043',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147334,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147334,31.14,0.32,16.9,70113,85,NULL,'I, raw','ESO 234- G 043',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147335,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147335,31.35,0.43,18.6,70113,75,NULL,'3.6 micron, color + selection bias corrected','ESO 234- G 043',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147336,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147336,31.35,0.2,18.6,70113,74.4,NULL,NULL,'ESO 234- G 043',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147337,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147337,31.39,0.43,19,70113,75,NULL,'3.6 micron, color corrected','ESO 234- G 043',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147338,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147338,31.44,0.4,19.4,70113,NULL,NULL,NULL,'ESO 234- G 043',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147339,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147339,31.44,0.4,19.4,70113,73,NULL,'opt','ESO 234- G 043',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147340,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147340,32.01,0.43,25.3,70113,75,NULL,'MAT, I, inv','ESO 234- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147341,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147341,32.08,0.43,26.1,70113,75,NULL,'MAT, I, raw','ESO 234- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147342,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147342,32.43,0.43,30.6,70113,75,NULL,'MAT, I, cor','ESO 234- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147343,'SNIa SDSS','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 17548','R',147343,37.31,0.07,278,70114,70,NULL,'SDSS CAND. SNIc; MLCS2K2; SN 2007ms','SN 2007ms',0.039,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'II-pec',NULL,NULL,NULL,NULL,1,308.076417,-1.01475,0.617,NULL,47810214381,747034599,11672415,NULL),(147344,'SNIa SDSS','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 17548','R',147344,38.01,0.4,386,70114,70,NULL,'SDSS CAND. SNIc; SALT 2; SN 2007ms','SN 2007ms',0.039,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147345,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147345,35.49,0.47,125,70115,70,NULL,NULL,'2MASX J20322742-2109579',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00011,NULL,'15.85',NULL,'SB(r)0^+',NULL,NULL,NULL,NULL,1,308.114333,-21.16628,0.165,NULL,50854037431,794594334,12415536,15.85),(147346,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 14451','R',147346,39.61,0.2,709,70116,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ji','SN 2006ji',0.179,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,308.1949583,0.92708,0.445,NULL,53993656701,843650885,13182045,NULL),(147347,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 14451','R',147347,39.89,0.09,804,70116,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ji','SN 2006ji',0.179,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147348,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2004eo',NULL,147348,33.7,0.19,54,70117,72,NULL,NULL,'NGC 6928',0.015701,'2009ApJ...704.1036F',2009,1,2,NULL,'G',0.00002,NULL,'13.16',0.6,'SB(s)ab','in a pair',NULL,NULL,NULL,1,308.20925,9.92642,0.417,NULL,55064040023,860375625,13443369,13.16),(147349,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2004eo',NULL,147349,33.83,0.17,56.7,70117,72,NULL,NULL,'NGC 6928',0.01475,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147350,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2004eo',NULL,147350,33.81,0.01,57.8,70117,72,NULL,NULL,'NGC 6928',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147351,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2004eo',NULL,147351,33.86,0.1,59.2,70117,74.4,NULL,NULL,'NGC 6928',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147352,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2004eo',NULL,147352,33.91,0.2,59.7,70117,70,NULL,'SALT 2','NGC 6928',0.015701,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147353,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2004eo',NULL,147353,33.92,0.1,59.9,70117,72,NULL,NULL,'NGC 6928',0.015701,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147354,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2004eo',NULL,147354,33.92,0.05,59.9,70117,72,NULL,NULL,'NGC 6928',0.015701,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147355,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2004eo',NULL,147355,33.93,0.1,60.1,70117,72,NULL,NULL,'NGC 6928',0.015701,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147356,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2004eo',NULL,147356,33.98,0.17,61.5,70117,73.8,NULL,'SALT 2 (SNANA)','NGC 6928',0.0155,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147357,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2004eo',NULL,147357,33.98,0.03,61.6,70117,72,NULL,NULL,'NGC 6928',0.015701,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147358,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2004eo',NULL,147358,34.01,0.04,63.4,70117,72,NULL,'M(H) = -18.317 mag','NGC 6928',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147359,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2004eo',NULL,147359,34.66,0.04,84.4,70117,70,NULL,NULL,'NGC 6928',0.015701,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147360,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147360,32.8,0.47,36.4,70117,NULL,NULL,'H','NGC 6928',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147361,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147361,32.81,0.45,36.4,70117,NULL,NULL,'K','NGC 6928',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147362,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147362,32.83,0.46,36.9,70117,NULL,NULL,'J','NGC 6928',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147363,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147363,33.2,0.49,43.6,70117,75,NULL,'IR','NGC 6928',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147364,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147364,33.91,0.4,60.4,70117,NULL,NULL,'mean','NGC 6928',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147365,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 11093',NULL,147365,39.95,0.27,979,70118,70,NULL,'SN photometric redshift distance, z photo =0.262 +/- 0.042','SDSS-II SN 11093',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,308.2432083,-0.99453,0.529,NULL,47807361708,746990026,11671719,NULL),(147366,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2003gt',NULL,147366,33.99,0.2,61.8,70119,70,NULL,'SALT 2','NGC 6930',0.015657,'2013MNRAS.433.2240G',2013,1,1.3,NULL,'G',0.000057,NULL,'12.6B',0.5,'SB(s)ab? sp','in a pair',NULL,NULL,NULL,1,308.245,9.87444,0.417,NULL,55064040897,860375639,13443369,12.6),(147367,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 04906',NULL,147367,40.1,0.27,1050,70120,70,NULL,'SN photometric redshift distance, z photo =0.283 +/- 0.045','SDSS-II SN 04906',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,308.293583,-0.01592,0.465,NULL,47806972925,746983951,11671624,NULL),(147368,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147368,34.39,0.8,75.7,70121,75,NULL,'MAT, I','ESO 528- G 017',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000033,NULL,'16.10',0.22,'SBcd? sp',NULL,NULL,NULL,NULL,1,308.336,-27.09778,0.169,NULL,51310340054,801724063,12526938,16.1),(147369,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147369,34.11,NULL,66.5,70121,NULL,NULL,NULL,'ESO 528- G 017',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147370,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147370,34.18,0.32,68.5,70121,85,NULL,'I, raw','ESO 528- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147371,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147371,34.19,0.32,68.8,70121,85,NULL,'I, inv','ESO 528- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147372,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147372,34.23,0.43,70.2,70121,75,NULL,'MAT, I, raw','ESO 528- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147373,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147373,34.28,NULL,71.7,70121,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 528- G 017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147374,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147374,34.29,NULL,72,70121,NULL,NULL,'Dipole','ESO 528- G 017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147375,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147375,34.29,NULL,72.2,70121,NULL,NULL,'Dipole + Quadrupole','ESO 528- G 017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147376,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147376,34.33,0.43,73.3,70121,75,NULL,'MAT, I, inv','ESO 528- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147377,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147377,34.65,0.43,85.2,70121,75,NULL,'MAT, I, cor','ESO 528- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147378,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147378,34.7,0.49,87.3,70121,75,NULL,'IR','ESO 528- G 017',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147379,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147379,34.72,0.2,87.9,70121,74.4,NULL,NULL,'ESO 528- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147380,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147380,34.89,0.43,94.9,70121,NULL,NULL,NULL,'ESO 528- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147381,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147381,34.96,0.42,98.3,70121,NULL,NULL,'Malmquist cor.','ESO 528- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147382,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147382,37.25,0.57,281,70122,70,NULL,NULL,'2MASX J20332953-6645223',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.00015,NULL,'15.5R',0.13,NULL,NULL,NULL,NULL,NULL,1,308.372875,-66.75622,0.129,NULL,49363996712,771312448,12051757,15.5),(147383,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147383,33.93,0.33,61.1,70123,NULL,NULL,'B, Hubble-type-TF','ESO 234- G 044',NULL,'2005Ap&SS.298..577R',2005,1,1,NULL,'G',0.000033,NULL,'14.99',0.6,'SB(s)bc',NULL,NULL,NULL,NULL,1,308.375166667,-49.576,0.033,NULL,51078003121,798093798,12470215,14.99),(147384,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147384,34.58,0.49,82.5,70123,NULL,NULL,'Malmquist cor.','ESO 234- G 044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147385,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147385,34.78,0.44,90.3,70123,NULL,NULL,NULL,'ESO 234- G 044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147386,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147386,34.82,0.2,92,70123,74.4,NULL,NULL,'ESO 234- G 044',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147387,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2003ib',NULL,147387,34.78,0.23,90.4,70124,NULL,NULL,'V, photospheric magnitude method','ESO 528- G 018',NULL,'2014AJ....148..107R',2014,1,1.1,NULL,'G',0.00015,NULL,'14.97',0.4,'(R)S(r?)b',NULL,NULL,NULL,NULL,1,308.379041667,-24.62389,0.185,NULL,50830345884,794224154,12409752,14.97),(147388,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2003ib',NULL,147388,35.03,0.14,101,70124,NULL,NULL,'I, photospheric magnitude method','ESO 528- G 018',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147389,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147389,35.61,0.48,132,70125,70,NULL,NULL,'2MASX J20333916-4354197',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000097,NULL,'13.7R',0.9,'SA(s)0^0^?',NULL,NULL,NULL,NULL,1,308.413375,-43.90561,0.101,NULL,51378673320,802791770,12543621,13.7),(147390,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SDSS-II SN 10997',NULL,147390,38.09,1.13,415,70126,70,NULL,'SN photometric redshift distance, z photo =0.102 +/- 0.077','SDSS-II SN 10997',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,308.421958333,0.52097,0.393,NULL,53994084668,843657572,13182149,NULL),(147391,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147391,32.03,0.47,25.5,70127,NULL,NULL,'H','NGC 6931',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000127,NULL,'14.2b',0.4,'Sb pec?        HII',NULL,NULL,NULL,NULL,1,308.4222917,-11.36886,0.233,NULL,50755255388,793050865,12391419,14.2),(147392,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147392,32.17,0.45,27.1,70127,NULL,NULL,'K','NGC 6931',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147393,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147393,32.21,0.46,27.6,70127,NULL,NULL,'J','NGC 6931',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147394,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147394,32.82,0.4,36.6,70127,NULL,NULL,'mean','NGC 6931',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147395,'G Lens','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147395,43.67,0.43,5430,70128,NULL,NULL,NULL,'WFI J2033-4723',NULL,'2014MNRAS.437..600S',2014,1,NULL,'This QSO may be lensed by a z=0.66 galaxy.','QSO',0.003,NULL,'17.59',NULL,NULL,NULL,NULL,NULL,'QSO',1,308.42475,-47.39519,0.093,NULL,51128567461,798883866,12482560,17.59),(147396,'GRB','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147396,42.26,NULL,2830,70129,70,NULL,'Pseudo z = 1.21','GRB 030725',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,308.445833,-50.76667,0.033,NULL,51077197231,798081206,12470018,NULL),(147397,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147397,36.86,0.71,236,70130,70,NULL,NULL,'ESO 597- G 011',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.8R',0.4,'S0',NULL,NULL,NULL,NULL,1,308.479667,-21.12822,0.141,NULL,50853908832,794592325,12415505,14.8),(147398,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SDSS-II SN 11097','RN',147398,39.76,0.25,747,70131,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 11097',0.196,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147399,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SDSS-II SN 11097','RN',147399,39.99,0.12,833,70131,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 11097',0.196,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147400,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147400,35.77,0.53,142,70132,70,NULL,NULL,'2MASX J20335752-5247064',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,308.4897917,-52.78517,0.033,NULL,51084133205,798189581,12471712,14.9),(147401,'Tully est','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147401,32.56,0.8,32.4,70133,75,NULL,NULL,'ESO 186- G 062',NULL,'1988NBGC.C....0000T',1988,1,2.2,NULL,'G',0.000024,NULL,'12.97',2.2,'SB(rs)cd',NULL,NULL,NULL,NULL,1,308.50875,-52.98119,0.121,NULL,51084268779,798191699,12471745,12.97),(147402,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147402,37.2,0.67,275,70134,70,NULL,NULL,'2MASX J20340292-0134425',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,308.512167,-1.57844,0.521,NULL,47843949887,747561716,11680651,15.5),(147403,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147403,36.79,0.62,228,70135,70,NULL,NULL,'ESO 234- G 046',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000103,NULL,'15.30',0.5,'SB:(r)bc',NULL,NULL,NULL,NULL,1,308.51475,-49.70839,0.033,NULL,51078220930,798097202,12470268,15.3),(147404,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147404,36.21,0.51,174,70136,70,NULL,NULL,'2MASX J20340357-4842012',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.000103,NULL,'16.1b',0.26,NULL,NULL,NULL,NULL,NULL,1,308.5147917,-48.70036,0.093,NULL,51075072128,798048002,12469500,16.1),(147405,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147405,38.04,0.67,405,70137,70,NULL,NULL,'2MASX J20340451-5920468',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000133,NULL,'16.1',NULL,NULL,NULL,NULL,NULL,NULL,1,308.519,-59.34628,0.149,NULL,49182583097,768477860,12007466,16.1),(147406,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147406,36.27,0.67,180,70138,70,NULL,NULL,'2MASX J20340569-4515037',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'15.0R',0.33,NULL,NULL,NULL,NULL,NULL,1,308.5237917,-45.25097,0.073,NULL,51380000872,802812513,12543945,15),(147407,'Ring Diameter','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147407,32.4,0.84,30,70139,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 6925',NULL,'1981ApJS...45..541P',1981,1,4.5,'Identification as IC 5015 is not certain.','G',0.000013,NULL,'12.07',1.2,'SA(s)bc        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,308.5857083,-31.98089,0.233,NULL,51322551048,801914860,12529919,12.07),(147408,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147408,32.72,0.8,35,70139,75,NULL,'MAT, I','NGC 6925',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147409,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147409,32.73,0.8,35.2,70139,75,NULL,'A82, H','NGC 6925',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147410,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147410,31.84,0.43,23.3,70139,75,NULL,'MAT, I, raw','NGC 6925',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147411,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147411,32,0.32,25.1,70139,85,NULL,'I, raw','NGC 6925',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147412,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147412,32.07,0.32,26,70139,85,NULL,'I, inv','NGC 6925',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147413,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147413,32.1,0.4,26.3,70139,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 6925',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147414,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147414,32.17,0.43,27.1,70139,75,NULL,'MAT, I, inv','NGC 6925',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147415,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147415,32.23,0.2,27.9,70139,74.4,NULL,NULL,'NGC 6925',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147416,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147416,32.24,0.46,28,70139,NULL,NULL,'J','NGC 6925',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147417,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147417,32.26,0.38,28.3,70139,NULL,NULL,NULL,'NGC 6925',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147418,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147418,32.27,0.43,28.4,70139,75,NULL,'MAT, I, cor','NGC 6925',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147419,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147419,32.27,0.43,28.5,70139,NULL,NULL,'Malmquist cor.','NGC 6925',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147420,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147420,32.28,0.4,28.5,70139,75,NULL,NULL,'NGC 6925',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147421,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147421,32.29,0.47,28.7,70139,NULL,NULL,'H','NGC 6925',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147422,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147422,32.38,0.45,29.9,70139,NULL,NULL,'K','NGC 6925',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147423,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147423,32.44,0.39,30.8,70139,NULL,NULL,NULL,'NGC 6925',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147424,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147424,32.48,0.47,31.3,70139,75,NULL,'A82, H, raw','NGC 6925',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147425,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147425,32.52,0.43,31.9,70139,75,NULL,'3.6 micron, color corrected','NGC 6925',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147426,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147426,32.6,0.49,33.1,70139,75,NULL,'IR','NGC 6925',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147427,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147427,32.71,0.4,34.8,70139,NULL,NULL,'mean','NGC 6925',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147428,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147428,32.71,0.47,34.8,70139,75,NULL,'A82, H, inv','NGC 6925',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (147429,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147429,32.73,0.47,35.2,70139,75,NULL,'A82, H, cor','NGC 6925',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147430,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147430,32.82,0.4,36.6,70139,75,NULL,'B','NGC 6925',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147431,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147431,32.97,0.43,39.4,70139,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6925',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147432,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147432,36.43,0.71,194,70140,70,NULL,NULL,'2MASX J20342202-5459123',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'14.6R',0.27,NULL,NULL,NULL,NULL,NULL,1,308.591625,-54.98681,0.177,NULL,49004404805,765693825,11963966,14.6),(147433,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147433,36.11,0.7,167,70141,70,NULL,NULL,'2MASX J20342892-8340111',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,308.620375,-83.66969,0.413,NULL,48370108856,755782950,11809108,17.2),(147434,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147434,37.5,0.65,316,70142,70,NULL,NULL,'2MASX J20343166-5358233',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'14.9R',0.37,NULL,NULL,NULL,NULL,NULL,1,308.632,-53.97314,0.145,NULL,51083729840,798183278,12471613,14.9),(147435,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147435,36.92,0.71,242,70143,70,NULL,NULL,'FAIRALL 0546',NULL,'2014MNRAS.445.2677S',2014,1,0.54,'1983MNRAS.203...47F has V = 13,600? +- 100 km/s.','G',0.00015,NULL,'14.8R',0.39,NULL,NULL,NULL,NULL,NULL,1,308.649167,-47.55836,0.089,NULL,51074049570,798032024,12469250,14.8),(147436,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147436,35.09,0.49,104,70144,75,NULL,'IR','UGC 11594',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',NULL,NULL,'15.6',0.2,'S',NULL,NULL,NULL,NULL,1,308.6505,12.94644,0.353,NULL,55251173227,863299581,13489055,15.6),(147437,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SDSS-II SN 18582',NULL,147437,39.73,0.19,884,70145,70,NULL,'SN photometric redshift distance, z photo =0.233 +/- 0.024','SDSS-II SN 18582',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,308.66625,-0.63136,0.445,NULL,47807592995,746993640,11671775,NULL),(147438,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147438,35.05,0.49,102,70146,75,NULL,'IR','UGC 11593 NED02',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.00002,NULL,'15.0',0.1,'Sc','Pair member (points to parent)',NULL,NULL,NULL,1,308.6859583,7.98664,0.397,NULL,53982569776,843477652,13179338,15),(147439,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147439,35.96,0.59,156,70147,70,NULL,NULL,'2MASX J20344935-4606330',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'16.6b',0.25,NULL,NULL,NULL,NULL,NULL,1,308.705583,-46.10917,0.173,NULL,51377065872,802766654,12543228,16.6),(147440,'Brightest Stars','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147440,28.85,NULL,5.9,70148,NULL,NULL,NULL,'NGC 6946',NULL,'1997AstL...23..373S',1997,1,11.5,NULL,'G',0.000007,NULL,'8.23B',9.8,'SAB(rs)cd;Sy2  HII','Isolated galaxy',NULL,NULL,NULL,1,308.718,60.15392,1.613,NULL,53473738247,835527160,13055111,8.23),(147441,'Brightest Stars','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147441,28.89,NULL,6,70148,NULL,NULL,NULL,'NGC 6946',NULL,'2001bmya.meet...89P',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147442,'PNLF','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147442,28.92,0.21,6.08,70148,NULL,NULL,NULL,'NGC 6946',NULL,'2008ApJ...683..630H',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147443,'SNII radio','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 1980K',NULL,147443,30.52,0.31,12.7,70148,NULL,NULL,NULL,'NGC 6946',NULL,'1998ApJ...500...51W',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147444,'TRGB','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147444,29.14,0.05,6.72,70148,NULL,NULL,NULL,'NGC 6946',NULL,'2014AstL...40..537T',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147445,'TRGB','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147445,29.15,NULL,6.8,70148,NULL,NULL,NULL,'NGC 6946',NULL,'2000A&A...362..544K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147446,'HII region diameter','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147446,31.11,NULL,16.7,70148,NULL,NULL,NULL,'NGC 6946',NULL,'1988ApL&C..27...41S',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147447,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004et',NULL,147447,28.02,0.5,4.02,70148,NULL,NULL,'EPM, H01','NGC 6946',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147448,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004et',NULL,147448,28.17,0.55,4.31,70148,NULL,NULL,'SCM, I','NGC 6946',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147449,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004et',NULL,147449,28.21,0.58,4.39,70148,NULL,NULL,'SCM, V','NGC 6946',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147450,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004et',NULL,147450,28.27,0.07,4.51,70148,NULL,NULL,'SCM','NGC 6946',NULL,'2015ApJ...799..215P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147451,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004et',NULL,147451,28.34,0.35,4.66,70148,NULL,NULL,'EPM, H01, fixed explosion epoch','NGC 6946',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147452,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004et',NULL,147452,28.36,0.09,4.7,70148,NULL,NULL,'SEAM','NGC 6946',0.00016,'2009ApJ...694.1067P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147453,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004et',NULL,147453,28.37,0.31,4.72,70148,NULL,NULL,'SCM, BVI','NGC 6946',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147454,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004et',NULL,147454,28.41,0.17,4.8,70148,NULL,NULL,'EPM','NGC 6946',NULL,'2012MNRAS.419.2783T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147455,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004et',NULL,147455,28.41,0.26,4.8,70148,NULL,NULL,'EPM, expansion velocity modeled','NGC 6946',NULL,'2012MNRAS.419.2783T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147456,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 1980K',NULL,147456,28.49,NULL,5,70148,NULL,NULL,NULL,'NGC 6946',NULL,'1988IAUS..129..175B',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147457,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004et',NULL,147457,28.64,0.5,5.35,70148,NULL,NULL,'SCM, B','NGC 6946',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147458,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004et',NULL,147458,28.65,0.08,5.37,70148,NULL,NULL,'V, photospheric magnitude method','NGC 6946',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147459,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004et',NULL,147459,28.67,0.37,5.41,70148,NULL,NULL,'EPM, D05','NGC 6946',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147460,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004et',NULL,147460,28.73,0.05,5.57,70148,NULL,NULL,'I, photospheric magnitude method','NGC 6946',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147461,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 1980K',NULL,147461,28.78,0.25,5.7,70148,NULL,NULL,NULL,'NGC 6946',NULL,'1994ApJ...432...42S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147462,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004et',NULL,147462,28.78,NULL,5.7,70148,NULL,NULL,NULL,'NGC 6946',NULL,'2006MNRAS.372.1315S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147463,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004et',NULL,147463,28.84,0.26,5.86,70148,NULL,NULL,'EPM, D05, fixed explosion epoch','NGC 6946',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147464,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2002hh',NULL,147464,28.89,0.23,6,70148,NULL,NULL,'SEAM','NGC 6946',0.00016,'2009ApJ...694.1067P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147465,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 1980K',NULL,147465,29.29,0.28,7.2,70148,NULL,NULL,'EPM','NGC 6946',NULL,'1992ApJ...395..366S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147466,'Sosies','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147466,28.73,0.68,5.57,70148,NULL,NULL,NULL,'NGC 6946',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147467,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147467,28.66,NULL,5.4,70148,75,NULL,'CO','NGC 6946',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147468,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147468,28.7,0.4,5.5,70148,NULL,18.45,'SN 1980K host','NGC 6946',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147469,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147469,28.7,NULL,5.5,70148,75,NULL,'HI','NGC 6946',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147470,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147470,28.7,0.4,5.5,70148,75,NULL,'B','NGC 6946',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147471,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147471,29.03,NULL,6.4,70148,NULL,NULL,'LEDA [April 2006]','NGC 6946',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147472,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147472,36.78,0.91,227,70149,70,NULL,NULL,'2MASX J20345244-4211100',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,308.7185,-42.18611,0.073,NULL,51387745412,802933522,12545836,14.8),(147473,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147473,31.63,0.43,21.2,70150,75,NULL,'3.6 micron, color + selection bias corrected','ESO 340- G 042',NULL,'2014MNRAS.444..527S',2014,1,1.5,'Gallagher et al. (1995, AJ, 109, 2003) also gives v=945 +/- 22 km/sec.','G',0.00003,NULL,'14.22',1.3,'SB(s)dm',NULL,NULL,NULL,NULL,1,308.7329583,-40.62414,0.073,NULL,51374094421,802720225,12542503,14.22),(147474,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147474,35.94,0.52,154,70151,70,NULL,NULL,'2MASX J20345841-4203355',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,308.743416667,-42.05983,0.073,NULL,51387753812,802933653,12545838,15.4),(147475,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147475,36.56,0.59,206,70152,70,NULL,NULL,'2MASX J20345920-6736343',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,308.7464583,-67.60958,0.125,NULL,49383110969,771611108,12056423,15),(147476,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147476,33.39,NULL,47.6,70153,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2277',NULL,'2010Ap&SS.325..163P',2010,1,0.93,NULL,'G',0.00008,NULL,'16.4',0.11,'Sd',NULL,NULL,NULL,NULL,1,308.76,-7.61889,0.177,NULL,47822485409,747226334,11675411,16.4),(147477,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147477,33.41,NULL,48.1,70153,NULL,NULL,'Dipole + Quadrupole','FGC 2277',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147478,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147478,33.43,NULL,48.6,70153,NULL,NULL,'Dipole','FGC 2277',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147479,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147479,33.48,NULL,49.7,70153,NULL,NULL,NULL,'FGC 2277',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147480,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147480,37.01,0.84,253,70154,70,NULL,NULL,'2MASX J20350264-7140353',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,308.7610417,-71.67653,0.157,NULL,49208834552,768888039,12013875,15.3),(147481,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147481,33.55,0.43,51.4,70155,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11595',NULL,'2014MNRAS.444..527S',2014,1,2.07,'The 2MASX position applies to the northern part of the galaxy.','G',0.000007,NULL,'15.25',0.22,'Sc',NULL,NULL,NULL,NULL,1,308.768667,1.93564,0.449,NULL,54014199121,843971861,13187060,15.25),(147482,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147482,33.63,0.49,53.3,70155,75,NULL,'IR','UGC 11595',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147483,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147483,33.7,0.43,54.9,70155,75,NULL,'3.6 micron, color corrected','UGC 11595',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147484,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147484,33.84,0.2,58.6,70155,74.4,NULL,NULL,'UGC 11595',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147485,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147485,34.03,0.43,63.9,70155,NULL,NULL,NULL,'UGC 11595',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147486,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147486,34.09,NULL,65.8,70155,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11595',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147487,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147487,34.1,NULL,66,70155,NULL,NULL,'Dipole','UGC 11595',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147488,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147488,34.1,NULL,66.1,70155,NULL,NULL,'Dipole + Quadrupole','UGC 11595',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147489,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147489,34.16,NULL,68,70155,NULL,NULL,NULL,'UGC 11595',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147490,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147490,34.19,0.4,68.7,70155,NULL,NULL,'Malmquist cor.','UGC 11595',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147491,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147491,34.36,0.45,74.4,70156,NULL,NULL,'K','ESO 340- G 043',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.00005,NULL,'13.75',1.1,'SA(l)0^0',NULL,NULL,NULL,NULL,1,308.770041667,-41.68417,0.073,NULL,51385823803,802903496,12545367,13.75),(147492,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147492,34.38,0.4,75.2,70156,NULL,NULL,'mean','ESO 340- G 043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147493,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004fu',NULL,147493,32.35,0.31,29.3,70157,74.2,NULL,'SALT 2','NGC 6949',0.0087,'2010ApJ...716..712A',2010,1,1.4,NULL,'G',0.00003,NULL,'14.5',1.2,'Sc             HII','X-ray-faint group member',NULL,NULL,'H II',1,308.778833,64.80281,1.589,NULL,53644330115,838192658,13096760,14.5),(147494,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004fu',NULL,147494,32.93,0.1,38.6,70157,74.4,NULL,NULL,'NGC 6949',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147495,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147495,32.94,0.4,38.8,70157,NULL,NULL,'mean','NGC 6949',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147496,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147496,33.77,0.47,56.8,70157,NULL,NULL,'H','NGC 6949',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147497,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147497,33.79,0.45,57.3,70157,NULL,NULL,'K','NGC 6949',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147498,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147498,33.8,0.46,57.5,70157,NULL,NULL,'J','NGC 6949',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147499,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147499,35.62,0.73,133,70158,70,NULL,NULL,'2MASX J20350766-5318278',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'15.4R',0.2,NULL,NULL,NULL,NULL,NULL,1,308.781833,-53.30775,0.121,NULL,51084490162,798195158,12471799,15.4),(147500,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147500,36.2,0.63,174,70159,70,NULL,NULL,'FAIRALL 0073',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.0I',0.3,'Bright nucleus',NULL,NULL,NULL,NULL,1,308.8037917,-57.98478,0.333,NULL,49001567278,765649488,11963273,14),(147501,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147501,34.44,0.4,77.1,70160,NULL,NULL,'mean','MCG -01-52-008',NULL,'2007A&A...465...71T',2007,1,2.11,NULL,'G',0.000017,NULL,'14.5',0.18,'Sd(f)',NULL,NULL,NULL,NULL,1,308.849083333,-6.24464,0.149,NULL,47821078373,747204349,11675067,14.5),(147502,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147502,34.5,0.49,79.4,70160,75,NULL,'IR','MCG -01-52-008',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147503,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147503,34.59,0.47,82.7,70160,NULL,NULL,'H','MCG -01-52-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147504,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147504,34.62,0.39,84,70160,NULL,NULL,'Malmquist cor.','MCG -01-52-008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147505,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147505,34.63,0.45,84.4,70160,NULL,NULL,'K','MCG -01-52-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147506,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147506,34.7,0.46,86.9,70160,NULL,NULL,'J','MCG -01-52-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147507,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147507,34.83,0.36,92.4,70160,NULL,NULL,NULL,'MCG -01-52-008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147508,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147508,34.87,0.2,94.2,70160,74.4,NULL,NULL,'MCG -01-52-008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147509,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147509,35.01,0.43,100,70160,75,NULL,'3.6 micron, color corrected','MCG -01-52-008',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147510,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147510,35.03,0.43,101,70160,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-52-008',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147511,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147511,35.09,NULL,104,70160,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -01-52-008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147512,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147512,35.1,NULL,105,70160,NULL,NULL,'Dipole + Quadrupole','MCG -01-52-008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147513,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147513,35.11,NULL,105,70160,NULL,NULL,'Dipole','MCG -01-52-008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147514,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147514,36.31,0.82,183,70161,70,NULL,NULL,'2MASX J20352499-4346165',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'15.3R',0.19,NULL,NULL,NULL,NULL,NULL,1,308.85425,-43.77122,0.101,NULL,51386780974,802918452,12545600,15.3),(147515,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147515,36.22,0.55,175,70162,70,NULL,NULL,'2MASX J20352707-7507369',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,308.863083,-75.12689,0.289,NULL,48489171597,757643306,11838176,16.6),(147516,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147516,37.95,0.33,389,70163,70,NULL,NULL,'2MASX J20353144-0631337',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00009,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,308.881125,-6.52614,0.133,NULL,47820981666,747202838,11675044,17.3),(147517,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147517,35.43,0.49,122,70164,70,NULL,NULL,'MCG -07-42-014',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000097,NULL,'15',0.8,'SAB0^0^ pec;D/cD',NULL,NULL,NULL,NULL,1,308.881833,-43.43864,0.081,NULL,51387871281,802935488,12545867,15),(147518,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147518,35.41,0.49,121,70165,75,NULL,'IR','ESO 285- G 038',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'15.43',0.3,'Sb? sp',NULL,NULL,NULL,NULL,1,308.896833,-44.37528,0.077,NULL,51379436716,802803698,12543807,15.43),(147519,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147519,35.44,0.48,123,70165,NULL,NULL,'Malmquist cor.','ESO 285- G 038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147520,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147520,35.58,0.45,131,70165,NULL,NULL,NULL,'ESO 285- G 038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147521,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147521,35.62,0.2,133,70165,74.4,NULL,NULL,'ESO 285- G 038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147522,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147522,36.76,0.46,225,70166,70,NULL,NULL,'2MASX J20353615-0532289',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000082,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,308.900833,-5.54122,0.169,NULL,47838974701,747483979,11679437,17),(147523,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147523,34.98,0.69,99,70167,NULL,NULL,NULL,'ESO 285- G 039',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.69',0.6,'Sb',NULL,NULL,NULL,NULL,1,308.914125,-43.60883,0.073,NULL,51387837501,802934960,12545858,15.69),(147524,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147524,35.02,0.2,101,70167,74.4,NULL,NULL,'ESO 285- G 039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147525,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147525,35.01,0.68,101,70167,NULL,NULL,'Malmquist cor.','ESO 285- G 039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147526,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147526,36.15,0.69,170,70168,70,NULL,NULL,'2MASX J20353946-5542242',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'15.1R',0.16,NULL,NULL,NULL,NULL,NULL,1,308.914333333,-55.70672,0.205,NULL,49004825612,765700400,11964068,15.1),(147527,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147527,37.95,0.33,389,70169,70,NULL,NULL,'SDSS J203542.04-063538.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000085,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,308.925167,-6.59392,0.133,NULL,47823029543,747234836,11675544,18.4),(147528,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147528,36.87,0.71,236,70170,70,NULL,NULL,'2MASX J20355373-6503361',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,308.9739583,-65.06008,0.125,NULL,49370121805,771408153,12053252,15.1),(147529,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147529,35.37,0.56,119,70171,70,NULL,NULL,'2MASX J20355445-5225450',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,308.976917,-52.42919,0.021,NULL,51085740940,798214702,12472104,15.4),(147530,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147530,36.29,0.54,181,70172,70,NULL,NULL,'2MASX J20355560-4836380',NULL,'2014MNRAS.445.2677S',2014,1,0.31,NULL,'G',0.000103,NULL,'16.6b',0.15,NULL,NULL,NULL,NULL,NULL,1,308.981667,-48.61056,0.073,NULL,51074931654,798045807,12469465,16.6),(147531,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147531,33.08,0.5,41.2,70173,70,NULL,NULL,'ESO 186- G 065',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000087,NULL,'14.10',0.4,'S0-: sp',NULL,NULL,NULL,NULL,1,308.9885417,-54.29947,0.133,NULL,51071984945,797999764,12468746,14.1),(147532,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147532,36.31,0.79,183,70174,70,NULL,NULL,'2MASX J20355745-4436148',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'15.0R',0.33,NULL,NULL,NULL,NULL,NULL,1,308.989375,-44.60411,0.069,NULL,51379353483,802802398,12543787,15),(147533,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147533,34.94,0.5,97.2,70175,70,NULL,NULL,'ESO 234- G 051',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.000093,NULL,'13.77',1,'SA0- pec?',NULL,NULL,NULL,NULL,1,308.991167,-49.60422,0,NULL,51077648292,798088254,12470128,13.77),(147534,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147534,36.83,0.66,233,70176,70,NULL,NULL,'2MASX J20360252-4205088',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000133,NULL,'15.6',NULL,NULL,NULL,NULL,NULL,NULL,1,309.0104583,-42.08586,0.073,NULL,51387708572,802932946,12545827,15.6),(147535,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147535,36.22,0.51,175,70177,70,NULL,NULL,'2MASX J20360810-5255290',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,309.033833333,-52.92475,0.089,NULL,51083847798,798185121,12471642,16.2),(147536,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147536,33.84,0.49,58.6,70178,75,NULL,'IR','UGC 11603',NULL,'2011yCatp016004901K',2011,1,1.46,NULL,'G',0.000053,NULL,'17.',0.17,'Sc',NULL,NULL,NULL,NULL,1,309.0572917,63.73989,1.533,NULL,53462257806,835347778,13052309,17),(147537,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147537,33.89,0.43,60,70178,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11603',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147538,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147538,34.51,0.4,79.9,70178,NULL,NULL,'mean','UGC 11603',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147539,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147539,34.71,0.47,87.3,70178,NULL,NULL,'H','UGC 11603',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147540,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147540,34.87,NULL,94.3,70178,NULL,NULL,'Dipole','UGC 11603',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147541,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147541,34.88,NULL,94.7,70178,NULL,NULL,'Dipole + Quadrupole','UGC 11603',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147542,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147542,34.88,NULL,94.8,70178,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11603',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147543,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147543,34.06,0.69,64.7,70179,100,NULL,'mid-IR','NGC 6941',NULL,'2013ApJ...771...88L',2013,1,1.78,NULL,'G',0.000027,NULL,'13.6g',1.1,'SAB(rs)b',NULL,NULL,NULL,NULL,1,309.097791667,-4.61875,0.173,NULL,47839220152,747487814,11679497,13.6),(147544,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147544,34.36,0.47,74.3,70179,NULL,NULL,'H','NGC 6941',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147545,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147545,34.36,0.45,74.5,70179,NULL,NULL,'K','NGC 6941',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147546,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147546,34.38,0.46,75.3,70179,NULL,NULL,'J','NGC 6941',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147547,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147547,34.61,0.4,83.7,70179,NULL,NULL,'mean','NGC 6941',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147548,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147548,33.67,0.47,54.1,70180,70,NULL,NULL,'ESO 234- G 053',NULL,'2014MNRAS.445.2677S',2014,1,1.9,NULL,'G',0.00009,NULL,'14.32',0.5,'S0',NULL,NULL,NULL,NULL,1,309.104291667,-49.25906,0.009,NULL,51077560853,798086888,12470107,14.32),(147549,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SDSS-II SN 05359',NULL,147549,40.55,0.37,1290,70181,70,NULL,'SN photometric redshift distance, z photo =0.363 +/- 0.087','SDSS-II SN 05359',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,309.105125,0.50767,0.309,NULL,54010207076,843909485,13186085,NULL),(147550,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147550,35.49,0.48,125,70182,70,NULL,NULL,'ESO 234- G 052',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'14.84',0.5,'S0-: pec',NULL,NULL,NULL,NULL,1,309.113416667,-52.2845,0.021,NULL,51085671845,798213622,12472087,14.84),(147551,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147551,33.41,0.47,48.1,70183,NULL,NULL,'H','UGC 11599',NULL,'2007A&A...465...71T',2007,1,2.3,NULL,'G',0.000013,NULL,'13.47',1.9,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,309.1409583,11.49469,0.369,NULL,55065585234,860399769,13443746,13.47),(147552,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147552,33.43,0.45,48.6,70183,NULL,NULL,'K','UGC 11599',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147553,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147553,33.48,0.46,49.6,70183,NULL,NULL,'J','UGC 11599',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147554,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147554,33.81,0.4,57.9,70183,NULL,NULL,'mean','UGC 11599',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147555,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147555,33.97,0.43,62.4,70183,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11599',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147556,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147556,35.66,0.53,136,70184,70,NULL,NULL,'ESO 143- G 035',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000133,NULL,'15.02',0.6,'S0',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,309.1440417,-57.62325,0.321,NULL,48999613127,765618955,11962796,15.02),(147557,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147557,36.67,0.58,215,70185,70,NULL,NULL,'2MASX J20364464-5437368',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'15.0R',0.18,NULL,NULL,NULL,NULL,NULL,1,309.186083,-54.62686,0.141,NULL,48990555179,765477424,11960584,15),(147558,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147558,34.7,0.8,87.1,70186,75,NULL,'MAT, I','ESO 285- G 040',NULL,'1997ApJS..109..333W',1997,1,2.74,NULL,'G',0.000033,NULL,'15.15',0.39,'Sb',NULL,NULL,NULL,NULL,1,309.197125,-45.30811,0.089,NULL,51379879537,802810617,12543915,15.15),(147559,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147559,34.78,NULL,90.3,70186,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 285- G 040',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147560,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147560,34.79,NULL,90.6,70186,NULL,NULL,'Dipole','ESO 285- G 040',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147561,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147561,34.79,NULL,90.6,70186,NULL,NULL,'Dipole + Quadrupole','ESO 285- G 040',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147562,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147562,34.84,NULL,92.7,70186,NULL,NULL,NULL,'ESO 285- G 040',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147563,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147563,34.9,0.4,95.6,70186,NULL,NULL,'mean','ESO 285- G 040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147564,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147564,35.23,0.49,111,70186,75,NULL,'IR','ESO 285- G 040',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147565,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147565,35.28,0.43,114,70186,75,NULL,'MAT, I, raw','ESO 285- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147566,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147566,35.33,0.47,117,70186,NULL,NULL,'H','ESO 285- G 040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147567,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147567,35.4,0.45,120,70186,NULL,NULL,'K','ESO 285- G 040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147568,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147568,35.44,0.32,122,70186,85,NULL,'I, raw','ESO 285- G 040',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147569,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147569,35.51,0.32,126,70186,85,NULL,'I, inv','ESO 285- G 040',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147570,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147570,35.51,0.43,127,70186,75,NULL,'MAT, I, cor','ESO 285- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147571,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147571,35.59,0.36,131,70186,NULL,NULL,'Malmquist cor.','ESO 285- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147572,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147572,35.59,0.43,131,70186,75,NULL,'MAT, I, inv','ESO 285- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147573,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147573,35.75,0.33,141,70186,NULL,NULL,NULL,'ESO 285- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147574,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147574,35.79,0.2,144,70186,74.4,NULL,NULL,'ESO 285- G 040',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147575,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 17605','R',147575,39.16,0.14,592,70187,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007js','SN 2007js',0.14643,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,309.202791667,0.09844,0.381,NULL,53993336981,843645890,13181967,NULL),(147576,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 17605','R',147576,39.25,0.22,618,70187,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007js','SN 2007js',0.14643,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147577,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 03118',NULL,147577,39.77,0.18,901,70188,70,NULL,'SN photometric redshift distance, z photo =0.238 +/- 0.024','SDSS-II SN 03118',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,309.209167,1.06467,0.313,NULL,54011066129,843922908,13186295,NULL),(147578,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147578,36.54,0.87,203,70189,70,NULL,NULL,'2MASX J20365747-5147092',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'15.0R',0.31,NULL,NULL,NULL,NULL,NULL,1,309.239417,-51.78592,0.009,NULL,51084867516,798201054,12471891,15),(147579,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147579,37.43,0.46,306,70190,70,NULL,NULL,'2MASX J20365847-0508239',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000072,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,309.2437083,-5.14014,0.177,NULL,47840137988,747502156,11679721,17.9),(147580,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147580,36.56,0.5,205,70191,70,NULL,NULL,'ESO 186-IG 069 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3b',NULL,'S0 pec',NULL,NULL,NULL,NULL,1,309.3010417,-54.65178,0.141,NULL,48990736244,765480253,11960628,15.3),(147581,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2000E',NULL,147581,31.31,0.17,18.3,70192,70.8,NULL,NULL,'NGC 6951',NULL,'2008MNRAS.389.1577T',2008,1,3.9,NULL,'G',0.000005,NULL,'10.0B',3.2,'SAB(rs)bc;LINERSy2','Group member, radial-velocity confirmed',NULL,NULL,'Sy 2',1,309.3087083,66.10564,0.877,NULL,53649556515,838274320,13098036,10),(147582,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2000E',NULL,147582,31.37,0.1,18.8,70192,74.4,NULL,NULL,'NGC 6951',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147583,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2000E',NULL,147583,31.61,0.04,20.9,70192,72,NULL,NULL,'NGC 6951',0.00475,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147584,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2000E',NULL,147584,31.72,0.11,21.9,70192,65,NULL,'MLCS2k2','NGC 6951',0.00475,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147585,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2000E',NULL,147585,31.79,0.22,22.7,70192,72,NULL,NULL,'NGC 6951',0.00475,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147586,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2000E',NULL,147586,31.84,0.19,23.2,70192,72,NULL,NULL,'NGC 6951',0.00475,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147587,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2000E',NULL,147587,31.83,0.03,23.3,70192,72,NULL,'M(H) = -18.317 mag','NGC 6951',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147588,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2000E',NULL,147588,31.89,0.07,23.8,70192,72,NULL,NULL,'NGC 6951',0.00475,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147589,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2000E','R',147589,31.89,NULL,23.9,70192,62.3,NULL,NULL,'NGC 6951',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147590,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2000E',NULL,147590,31.98,0.14,24.9,70192,60,NULL,NULL,'NGC 6951',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147591,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2000E',NULL,147591,32.14,0.21,26.8,70192,55,NULL,NULL,'NGC 6951',NULL,'2003ApJ...595..779V',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147592,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2000E',NULL,147592,32.59,0.47,33,70192,NULL,NULL,'MLCS','NGC 6951',NULL,'2001A&A...372..824V',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147593,'HII region diameter','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147593,31.93,0.18,24.3,70192,NULL,NULL,NULL,'NGC 6951',NULL,'2005JKAS...38....7I',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147594,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147594,31.05,0.43,16.2,70192,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6951',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147595,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147595,31.91,0.4,24.1,70192,75,NULL,'B','NGC 6951',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147596,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147596,35.75,0.61,141,70193,70,NULL,NULL,'2MASX J20372217-7408382',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,309.3424583,-74.144,0.209,NULL,48490090412,757657662,11838400,16.2),(147597,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147597,37.05,0.52,257,70194,70,NULL,NULL,'2MASX J20372748-4438353',NULL,'2014MNRAS.445.2677S',2014,1,0.26,NULL,'G',0.00015,NULL,'15.3R',0.22,NULL,NULL,NULL,NULL,NULL,1,309.364583,-44.64311,0.069,NULL,51379317477,802801835,12543778,15.3),(147598,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147598,37.06,0.46,258,70195,70,NULL,NULL,'2MASX J20373439-0438000',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000081,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,309.393333,-4.63344,0.173,NULL,47839342005,747489718,11679526,16.5),(147599,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147599,35.79,0.73,144,70196,70,NULL,NULL,'2MASX J20373908-0303330',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.36',0.4,NULL,NULL,NULL,NULL,NULL,1,309.412875,-3.05914,0.257,NULL,47844500608,747570322,11680786,16.36),(147600,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147600,35.41,0.45,121,70197,NULL,NULL,NULL,'ESO 597- G 017',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.30',0.8,'Sc',NULL,NULL,NULL,NULL,1,309.421125,-21.60675,0.145,NULL,50824379995,794130937,12408295,14.3),(147601,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147601,35.45,0.2,123,70197,74.4,NULL,NULL,'ESO 597- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147602,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147602,35.49,0.43,126,70197,NULL,NULL,'Malmquist cor.','ESO 597- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147603,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147603,37.38,0.61,299,70198,70,NULL,NULL,'2MASX J20374210-0144200',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,309.425417,-1.73886,0.341,NULL,47843683771,747557558,11680586,14),(147604,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147604,37.24,0.75,281,70199,70,NULL,NULL,'2MASX J20374354-7812199',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,309.431166667,-78.20556,0.473,NULL,48581334340,759083349,11860677,17),(147605,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147605,36.4,0.54,191,70200,70,NULL,NULL,'2MASX J20374472-1552306',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.05',0.4,NULL,NULL,NULL,NULL,NULL,1,309.436375,-15.87525,0.145,NULL,50976368923,796505764,12445402,16.05),(147606,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 01783',NULL,147606,39.98,0.3,992,70201,70,NULL,'SN photometric redshift distance, z photo =0.266 +/- 0.048','SDSS-II SN 01783',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,309.438375,-0.62797,0.389,NULL,47840422708,747506604,11679790,NULL),(147607,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147607,35.08,0.49,104,70202,75,NULL,'IR','FGC 2280',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.00005,NULL,'15.9',0.17,'Scd',NULL,NULL,NULL,NULL,1,309.447666667,-3.18533,0.257,NULL,47844556797,747571199,11680799,15.9),(147608,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147608,35.4,NULL,120,70202,NULL,NULL,'Dipole + Quadrupole','FGC 2280',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147609,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147609,35.4,NULL,121,70202,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2280',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147610,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147610,35.41,NULL,121,70202,NULL,NULL,'Dipole','FGC 2280',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147611,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147611,35.46,NULL,123,70202,NULL,NULL,NULL,'FGC 2280',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147612,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147612,35.71,0.66,138,70203,70,NULL,NULL,'2MASX J20375204-0156290',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,309.466875,-1.94147,0.353,NULL,47842823285,747544113,11680376,15),(147613,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 12779','R',147613,37.88,0.2,348,70204,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006fd','SN 2006fd',0.079948,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,309.471875,1.22114,0.301,NULL,54010538113,843914658,13186166,NULL),(147614,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 12779','R',147614,38.18,0.11,400,70204,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006fd','SN 2006fd',0.079948,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147615,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147615,35.9,0.56,151,70205,70,NULL,NULL,'2MASX J20380766-5134205',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.6I',0.5,NULL,NULL,NULL,NULL,NULL,1,309.532041667,-51.57233,0.021,NULL,51084883139,798201299,12471895,13.6),(147616,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147616,37.07,0.62,260,70206,70,NULL,NULL,'2MASX J20380809-5510365',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,309.5337083,-55.17683,0.181,NULL,48991441544,765491274,11960801,17),(147617,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147617,32.97,0.8,39.3,70207,75,NULL,'MAT, I','IC 5023',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.17',0.5,'S(r)a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,309.544667,-67.18464,0.133,NULL,49382648346,771603880,12056310,14.17),(147618,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147618,33.37,0.32,47.3,70207,85,NULL,'I, raw','IC 5023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147619,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147619,33.42,0.32,48.3,70207,85,NULL,'I, inv','IC 5023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147620,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147620,33.46,0.43,49.2,70207,75,NULL,'MAT, I, raw','IC 5023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147621,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147621,33.6,0.43,52.5,70207,75,NULL,'MAT, I, cor','IC 5023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147622,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147622,33.66,0.43,54,70207,75,NULL,'MAT, I, inv','IC 5023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147623,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147623,33.75,0.33,56.2,70207,NULL,NULL,'Malmquist cor.','IC 5023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147624,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147624,34.03,0.29,63.9,70207,NULL,NULL,NULL,'IC 5023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147625,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147625,34.07,0.2,65.2,70207,74.4,NULL,NULL,'IC 5023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147626,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147626,36.31,0.82,182,70208,70,NULL,NULL,'2MASX J20381412-1556161',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.6I',0.2,NULL,NULL,NULL,NULL,NULL,1,309.558875,-15.93786,0.145,NULL,50976491355,796507677,12445432,14.6),(147627,'Ring Diameter','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147627,32.6,0.84,33,70209,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 6935',NULL,'1981ApJS...45..541P',1981,1,2,NULL,'G',0.00006,NULL,'12.80',1.7,'(R)SA(r)a','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,309.58425,-52.11044,0.021,NULL,51085242313,798206911,12471982,12.8),(147628,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147628,33.01,0.51,40,70209,70,NULL,NULL,'NGC 6935',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147629,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147629,35.09,0.49,104,70210,75,NULL,'IR','ESO 463- G 010',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.000033,NULL,'15.13',0.5,'SB(s)c',NULL,NULL,NULL,NULL,1,309.5960417,-31.92178,0.197,NULL,51313268303,801769817,12527653,15.13),(147630,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147630,35.11,0.56,105,70210,NULL,NULL,'Malmquist cor.','ESO 463- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147631,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147631,35.25,0.53,112,70210,NULL,NULL,NULL,'ESO 463- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147632,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147632,35.29,0.2,114,70210,74.4,NULL,NULL,'ESO 463- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147633,'Faber-Jackson','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147633,33.28,0.44,45.3,70211,95,NULL,'Weighted Mean','NGC 6944',NULL,'1984ApJS...56...91D',1984,1,1.5,NULL,'G',0.00012,NULL,'14.79',0.6,'S0-:','in a pair',NULL,NULL,NULL,1,309.599417,6.99644,0.409,NULL,53981042502,843453789,13178965,14.79),(147634,'Faber-Jackson','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147634,33.68,0.46,54.5,70211,95,NULL,'Michard 1979a','NGC 6944',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147635,'Faber-Jackson','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147635,33.88,0.63,59.7,70211,95,NULL,'Michard 1979b, c','NGC 6944',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147636,'Tertiary','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147636,33.25,0.5,44.7,70211,95,NULL,NULL,'NGC 6944',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147637,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147637,35.89,0.5,151,70212,70,NULL,NULL,'AM 2035-441',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5R',0.31,NULL,NULL,NULL,NULL,NULL,1,309.616375,-44.05156,0.073,NULL,51377588728,802774823,12543356,14.5),(147638,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 11098',NULL,147638,40.45,0.17,1230,70213,70,NULL,'SN photometric redshift distance, z photo =0.343 +/- 0.034','SDSS-II SN 11098',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.2g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,309.636666667,1.20825,0.361,NULL,53964458896,843194670,13174916,21.2),(147639,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 01906','RN',147639,39.75,0.24,744,70214,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 01906',0.20023,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147640,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 01906','RN',147640,39.82,0.27,768,70214,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 01906',0.20023,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147641,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147641,35.14,0.64,107,70215,70,NULL,NULL,'2MASX J20383584-1527541',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.85',NULL,NULL,NULL,NULL,NULL,NULL,1,309.6495,-15.46492,0.137,NULL,50984315159,796629924,12447342,15.85),(147642,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147642,35.9,0.51,151,70216,70,NULL,NULL,'2MASX J20383916-2029027',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.70',NULL,NULL,NULL,NULL,NULL,NULL,1,309.663167,-20.48425,0.117,NULL,50826102515,794157851,12408716,15.7),(147643,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2006ex',NULL,147643,39.01,0.09,634,70217,70,NULL,'Hubble residual 0.17 for z0.14749','SDSS-II SN 12930 HOST',NULL,'2011ApJ...740...92G',2011,1,0.24,NULL,'G',0.00017,NULL,'18.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,309.682667,-0.47639,0.333,NULL,47785800081,746653126,11666455,18.1),(147644,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 12930','R',147644,39.43,0.21,670,70217,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ex','SDSS-II SN 12930 HOST',0.14749,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147645,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 12930','R',147645,39.7,0.12,759,70217,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ex','SDSS-II SN 12930 HOST',0.14749,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147646,'GRB','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147646,42.89,NULL,3790,70218,70,NULL,'Pseudo z = 3.03','GRB 020812',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,309.7,-5.38333,0.125,NULL,47839511940,747492374,11679568,NULL),(147647,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147647,36.58,0.46,207,70219,70,NULL,NULL,'2MASX J20384933+0041269',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000174,NULL,'16.3g',0.34,'E0',NULL,NULL,NULL,NULL,1,309.7055,0.69081,0.317,NULL,53964822370,843200349,13175005,16.3),(147648,'CMD','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'N',147648,21.65,0.16,0.214,70220,NULL,NULL,'If object = GC, ID = DESJ0002_6051','Tucana IV',NULL,'2015ApJ...813..109D',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147649,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147649,36.32,0.81,184,70221,70,NULL,NULL,'2MASX J20385336-4340164',NULL,'2014MNRAS.445.2677S',2014,1,0.26,NULL,'G',0.00015,NULL,'15.5R',0.2,NULL,NULL,NULL,NULL,NULL,1,309.722333,-43.67131,0.073,NULL,51385188345,802893567,12545211,15.5),(147650,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 13996',NULL,147650,40.29,0.21,1140,70222,70,NULL,'SN photometric redshift distance, z photo =0.315 +/- 0.039','SDSS-II SN 13996',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.5g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,309.7255417,-0.06594,0.325,NULL,47785920886,746655013,11666484,22.5),(147651,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147651,35.51,0.44,127,70223,NULL,NULL,'Malmquist cor.','ESO 285- G 041',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.44',0.5,'SA(rs)d:',NULL,NULL,NULL,NULL,1,309.72575,-43.38375,0.077,NULL,51385163927,802893186,12545206,15.44),(147652,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147652,35.62,0.42,133,70223,NULL,NULL,NULL,'ESO 285- G 041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147653,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147653,35.66,0.2,136,70223,74.4,NULL,NULL,'ESO 285- G 041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147654,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147654,32.96,NULL,39.2,70224,70,NULL,'H, UH88/IRSF/2MASS, Malmquist corr.','MCG -01-52-016',NULL,'2011A&A...531A..87I',2011,1,2.61,NULL,'G',0.00002,NULL,'13.6g',0.64,'(R\')Sa:',NULL,NULL,NULL,NULL,1,309.7270417,-5.64,0.121,NULL,47836756555,747449321,11678895,13.6),(147655,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147655,32.96,NULL,39.2,70224,70,NULL,'H, 2MASS, Malmquist corr.','MCG -01-52-016',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147656,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147656,33.12,0.33,42.1,70224,70,NULL,'H, UH88/IRSF/2MASS','MCG -01-52-016',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147657,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147657,33.12,0.33,42.1,70224,70,NULL,'H, 2MASS','MCG -01-52-016',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147658,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147658,33.17,0.47,43.1,70224,NULL,NULL,'H','MCG -01-52-016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147659,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147659,33.19,0.45,43.4,70224,NULL,NULL,'K','MCG -01-52-016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147660,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147660,33.2,0.43,43.6,70224,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-52-016',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147661,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147661,33.23,0.46,44.2,70224,NULL,NULL,'J','MCG -01-52-016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147662,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147662,33.44,0.4,48.9,70224,NULL,NULL,'mean','MCG -01-52-016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147663,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147663,35.65,0.63,135,70225,70,NULL,NULL,'FAIRALL 0550',NULL,'2014MNRAS.445.2677S',2014,1,0.33,'1983MNRAS.203...47F has V = 14700? +- 100 km/s.','G',0.00015,NULL,'15.2R',0.27,'(R_1R\'_2)SB(s)a',NULL,NULL,NULL,NULL,1,309.730167,-57.21844,0.321,NULL,48999867640,765622931,11962858,15.2),(147664,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147664,35.59,0.56,131,70226,70,NULL,NULL,'2MASX J20385712-2244116',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.13',0.5,NULL,NULL,NULL,NULL,NULL,1,309.737917,-22.73675,0.169,NULL,50831558932,794243108,12410048,16.13),(147665,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147665,38.29,0.46,455,70227,70,NULL,NULL,'SDSS J203859.72+005623.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000163,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,309.748833,0.93983,0.361,NULL,53964525679,843195713,13174933,18.5),(147666,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147666,33.13,0.45,42.2,70228,NULL,NULL,'K','NGC 6945',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000033,NULL,'13.26',0.9,'S0-',NULL,NULL,NULL,NULL,1,309.752583,-4.97258,0.137,NULL,47839873316,747498020,11679656,13.26),(147667,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147667,33.45,0.4,48.9,70228,NULL,NULL,'mean','NGC 6945',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147668,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147668,35.66,0.35,136,70229,NULL,NULL,'Malmquist cor.','ESO 597- G 020',NULL,'2009ApJS..182..474S',2009,1,1.6,NULL,'G',0.00002,NULL,'15',0.5,'Sb-c',NULL,NULL,NULL,NULL,1,309.7800417,-20.24083,0.121,NULL,50822666297,794104160,12407877,15),(147669,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147669,35.87,0.32,149,70229,NULL,NULL,NULL,'ESO 597- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147670,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147670,35.91,0.2,152,70229,74.4,NULL,NULL,'ESO 597- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147671,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147671,36.38,0.78,189,70230,70,NULL,NULL,'2MASX J20390910-2119078',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.42',0.4,NULL,NULL,NULL,NULL,NULL,1,309.788041667,-21.31892,0.129,NULL,50823765827,794121341,12408145,16.42),(147672,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147672,37.12,0.52,266,70231,70,NULL,NULL,'2MASX J20391420-4342164',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,309.809083,-43.70467,0.061,NULL,51385178172,802893408,12545209,14.6),(147673,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147673,37.63,0.46,335,70232,70,NULL,NULL,'2MASX J20392006-0601068',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000107,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,309.83375,-6.01861,0.173,NULL,47836686346,747448224,11678878,17.1),(147674,'BL Lac Luminosity','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147674,39.28,NULL,682,70233,NULL,NULL,NULL,'2MASX J20392354+5219498',0.053,'2005ApJ...635..173S',2005,1,NULL,NULL,'G',NULL,NULL,'19.0V',NULL,'BLLAC',NULL,NULL,NULL,'BL Lac ?',1,309.848041667,52.33058,NULL,NULL,54909187426,857956053,13405563,19),(147675,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 04907',NULL,147675,40.58,0.16,1310,70234,70,NULL,'SN photometric redshift distance, z photo =0.370 +/- 0.037','SDSS-II SN 04907',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.4g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,309.858625,-0.11419,0.337,NULL,47785899835,746654684,11666479,22.4),(147676,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147676,37.04,0.46,255,70235,70,NULL,NULL,'2MASX J20393230-0609568',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000084,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,309.884625,-6.16575,0.173,NULL,47819656259,747182129,11674720,17),(147677,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147677,36.1,0.5,166,70236,70,NULL,NULL,'2MASX J20393289-5306039',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,309.886958333,-53.10108,0.105,NULL,51072492329,798007692,12468870,14),(147678,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147678,35.61,0.43,132,70237,NULL,NULL,'Malmquist cor.','ESO 463- G 014',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14',0.7,'Sb-c',NULL,NULL,NULL,NULL,1,309.8934583,-28.48883,0.325,NULL,51321013893,801890842,12529544,14),(147679,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147679,35.72,0.41,139,70237,NULL,NULL,NULL,'ESO 463- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147680,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147680,35.72,0.47,139,70237,NULL,NULL,'H','ESO 463- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147681,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147681,35.76,0.2,142,70237,74.4,NULL,NULL,'ESO 463- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147682,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147682,35.77,0.4,143,70237,NULL,NULL,'mean','ESO 463- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147683,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147683,35.84,0.45,147,70237,NULL,NULL,'K','ESO 463- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147684,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147684,35.87,0.46,149,70237,NULL,NULL,'J','ESO 463- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147685,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147685,35.86,0.82,148,70238,70,NULL,NULL,'2MASX J20393526-5102559',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'14.9R',0.25,NULL,NULL,NULL,NULL,NULL,1,309.897083,-51.04892,0.017,NULL,51084920404,798201881,12471904,14.9),(147686,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147686,36.69,0.71,217,70239,70,NULL,NULL,'2MASX J20393610-5301009',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,309.900333333,-53.01683,0.077,NULL,51083747664,798183557,12471618,16.9),(147687,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147687,35.12,0.46,106,70240,70,NULL,NULL,'2MASX J20393782-0625228',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000081,NULL,'15.8g',0.29,'S0',NULL,NULL,NULL,NULL,1,309.907625,-6.42289,0.177,NULL,47820220616,747190947,11674858,15.8),(147688,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147688,38.03,0.46,403,70241,70,NULL,NULL,'2MASX J20394005-0544425',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000123,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,309.9167083,-5.74519,0.169,NULL,47836924410,747451943,11678936,16.6),(147689,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147689,34.57,0.49,82,70242,75,NULL,'IR','2MFGC 15660',NULL,'2011yCatp016004901K',2011,1,NULL,'This is the northeastern end of CGCG 424-037.','PofG',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,309.92975,13.96389,0.429,NULL,55263118665,863486229,13491972,NULL),(147690,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147690,32.41,0.4,30.3,70243,75,NULL,NULL,'UGC 11613',NULL,'2008Ap.....51..336K',2008,1,1.85,NULL,'G',0.000007,NULL,'17.',0.17,'Sdm','X-ray-faint group member',NULL,NULL,NULL,1,309.934125,63.59828,1.761,NULL,53464370882,835380795,13052824,17),(147691,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147691,32.72,0.43,34.9,70243,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11613',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147692,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147692,32.75,0.49,35.5,70243,75,NULL,'IR','UGC 11613',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147693,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147693,32.77,0.2,35.8,70243,74.4,NULL,NULL,'UGC 11613',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147694,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147694,32.84,0.43,37,70243,75,NULL,'3.6 micron, color corrected','UGC 11613',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147695,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147695,33.38,NULL,47.5,70243,NULL,NULL,'Dipole','UGC 11613',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147696,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147696,33.39,NULL,47.6,70243,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11613',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147697,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147697,33.39,NULL,47.7,70243,NULL,NULL,'Dipole + Quadrupole','UGC 11613',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147698,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 12964','RN',147698,40.06,0.25,844,70244,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 12964',0.2167,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147699,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 12964','RN',147699,40.3,0.2,942,70244,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 12964',0.2167,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147700,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147700,35.47,0.54,124,70245,70,NULL,NULL,'2MASX J20395411-2136139',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.31',NULL,NULL,NULL,NULL,NULL,NULL,1,309.975625,-21.60372,0.129,NULL,50823937421,794124022,12408187,16.31),(147701,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147701,36.01,0.57,160,70246,70,NULL,NULL,'2MASX J20400667-4255341',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.6I',0.4,NULL,NULL,NULL,NULL,NULL,1,310.02775,-42.92619,0.057,NULL,51384752527,802886758,12545105,13.6),(147702,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 08188','RN',147702,42.55,0.2,2290,70247,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 08188',0.41524,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147703,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 08188','RN',147703,42.75,0.25,2500,70247,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08188',0.41524,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147704,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147704,36.92,0.63,242,70248,70,NULL,NULL,'2MASX J20400936-2048053',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,310.0389583,-20.80144,0.117,NULL,50826136606,794158384,12408724,15.6),(147705,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147705,37.08,0.46,260,70249,70,NULL,NULL,'2MASX J20401197-0555468',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000128,NULL,'16.1g',0.35,'S0/a',NULL,NULL,NULL,NULL,1,310.05,-5.92956,0.169,NULL,47836893594,747451462,11678929,16.1),(147706,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147706,33.8,0.22,57.5,70250,NULL,NULL,'B, Hubble-type-TF','ESO 234- G 061',NULL,'2005Ap&SS.298..577R',2005,1,0.96,'Star superposed on western side.','G',0.000033,NULL,'16.83',0.11,'Sc',NULL,NULL,NULL,NULL,1,310.055833,-50.79611,0.009,NULL,51077048915,798078889,12469982,16.83),(147707,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147707,34.77,NULL,89.8,70250,NULL,NULL,NULL,'ESO 234- G 061',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147708,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147708,34.8,NULL,91,70250,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 234- G 061',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147709,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147709,34.84,NULL,93,70250,NULL,NULL,'Dipole + Quadrupole','ESO 234- G 061',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147710,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147710,34.87,NULL,94,70250,NULL,NULL,'Dipole','ESO 234- G 061',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147711,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147711,34.99,0.69,99.5,70250,NULL,NULL,'Malmquist cor.','ESO 234- G 061',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147712,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147712,35,0.68,100,70250,NULL,NULL,NULL,'ESO 234- G 061',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147713,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147713,35.04,0.2,102,70250,74.4,NULL,NULL,'ESO 234- G 061',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147714,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147714,35.75,0.51,141,70251,70,NULL,NULL,'2MASX J20401714-2246543',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,'(R)SA0^+?',NULL,NULL,NULL,NULL,1,310.071417,-22.78172,0.169,NULL,50834711123,794292361,12410818,14.9),(147715,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147715,35.59,0.7,131,70252,70,NULL,NULL,'ESO 186- G 072',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.93',0.2,'Sa:',NULL,NULL,NULL,NULL,1,310.077041667,-53.53236,0.117,NULL,51072673970,798010530,12468914,15.93),(147716,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005jw',NULL,147716,40.72,0.15,1020,70253,74.2,NULL,'SALT 2','SDSS J204019.15-000022.9',0.37,'2010ApJ...716..712A',2010,1,0.05,NULL,'G',NULL,NULL,'22.5g',0.03,NULL,NULL,NULL,NULL,NULL,1,310.0797917,-0.00639,0.337,NULL,47786295320,746660864,11666576,22.5),(147717,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005jw',NULL,147717,40.83,0.04,1070,70253,70,NULL,'SDSS-II SN 07779','SDSS J204019.15-000022.9',0.37,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147718,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005jw',NULL,147718,41.42,0.15,1410,70253,65,NULL,'SALT2','SDSS J204019.15-000022.9',0.37,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147719,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005jw',NULL,147719,41.46,0.16,1430,70253,70,NULL,'SDSS-II SN 07779, SALT 2','SDSS J204019.15-000022.9',0.37,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147720,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 07779','R',147720,41.58,0.23,1510,70253,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005jw','SDSS J204019.15-000022.9',0.37,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147721,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005jw',NULL,147721,41.6,0.1,1530,70253,65,NULL,'MLCS2k2','SDSS J204019.15-000022.9',0.37,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147722,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 07779','R',147722,41.61,0.13,1530,70253,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005jw','SDSS J204019.15-000022.9',0.37,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147723,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147723,36.12,0.6,168,70254,70,NULL,NULL,'2MFGC 15667',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,310.081083333,-22.56758,0.161,NULL,50834299808,794285934,12410717,14.8),(147724,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147724,36.95,0.61,246,70255,70,NULL,NULL,'2MASX J20401970-5300303',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,310.082083,-53.00847,0.077,NULL,51072483075,798007548,12468867,16.7),(147725,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147725,36.96,0.46,246,70256,70,NULL,NULL,'2MASX J20402220-0449598',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000102,NULL,'16.2g',0.29,'E0',NULL,NULL,NULL,NULL,1,310.092666667,-4.83333,0.157,NULL,47839756044,747496188,11679627,16.2),(147726,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147726,35.84,0.46,147,70257,70,NULL,NULL,'2MASX J20402259-0621317',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000094,NULL,'15.5g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,310.0940417,-6.35892,0.173,NULL,47819348625,747177322,11674645,15.5),(147727,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147727,35.21,0.55,110,70258,NULL,NULL,NULL,'ESO 401- G 001',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'16.20',0.5,'Sb-c',NULL,NULL,NULL,NULL,1,310.110167,-35.53786,0.113,NULL,51517668819,804963575,12577555,16.2),(147728,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147728,35.2,0.56,110,70258,NULL,NULL,'Malmquist cor.','ESO 401- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147729,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147729,35.25,0.2,112,70258,74.4,NULL,NULL,'ESO 401- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147730,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147730,35.89,0.54,151,70259,70,NULL,NULL,'2MASX J20402835-5317263',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.7R',0.17,NULL,NULL,NULL,NULL,NULL,1,310.118167,-53.29067,0.105,NULL,51072508002,798007937,12468874,14.7),(147731,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147731,36.09,0.76,165,70260,70,NULL,NULL,'2MASX J20403120-4634385',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.6I',0.2,NULL,NULL,NULL,NULL,NULL,1,310.130041667,-46.57731,0.113,NULL,51393695431,803026491,12547288,14.6),(147732,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147732,34.58,0.2,82.4,70261,74.4,NULL,NULL,'UGC 11611',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000127,NULL,'15.0',0.7,'SBcd:',NULL,NULL,NULL,NULL,1,310.132125,14.27486,0.373,NULL,55263312649,863489260,13492019,15),(147733,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147733,34.59,0.52,82.9,70261,NULL,NULL,'Malmquist cor.','UGC 11611',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147734,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147734,34.7,0.49,87.1,70261,NULL,NULL,NULL,'UGC 11611',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147735,'Faber-Jackson','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147735,32.21,0.65,27.7,70262,95,NULL,'Weighted Mean','NGC 6942',NULL,'1984ApJS...56...91D',1984,1,2,'RC3 gives v = 3934 +/- 66 km/sec.','G',0.000087,NULL,'12.67',1.5,'(R\'_2)SB(rs)a',NULL,NULL,NULL,NULL,1,310.1577083,-54.30306,0.117,NULL,51072923033,798014422,12468975,12.67),(147736,'Faber-Jackson','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147736,33.71,0.81,55.2,70262,55,NULL,'Visvanathan & Sandage 1979','NGC 6942',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147737,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147737,33.16,0.49,42.8,70262,70,NULL,NULL,'NGC 6942',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147738,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147738,36.84,0.67,233,70263,70,NULL,NULL,'2MASX J20404081-2039449',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,310.170041667,-20.66256,0.117,NULL,50826216518,794159633,12408744,15.4),(147739,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147739,37.4,0.46,302,70264,70,NULL,NULL,'2MASX J20405194+0056444',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,310.216416667,0.94564,0.293,NULL,53967394671,843240541,13175633,17.2),(147740,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147740,34.85,0.49,93.5,70265,75,NULL,'IR','UGC 11612',NULL,'2011yCatp016004901K',2011,1,1.41,NULL,'G',0.000033,NULL,'15.6g',0.27,'Sbc','Isolated galaxy',NULL,NULL,NULL,1,310.217,0.65278,0.305,NULL,53964249195,843191393,13174865,15.6),(147741,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147741,34.98,NULL,98.9,70265,NULL,NULL,NULL,'UGC 11612',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147742,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147742,35.07,NULL,103,70265,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11612',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147743,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147743,35.08,NULL,104,70265,NULL,NULL,'Dipole','UGC 11612',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147744,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147744,35.09,NULL,104,70265,NULL,NULL,'Dipole + Quadrupole','UGC 11612',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147745,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147745,36.38,0.52,189,70266,70,NULL,NULL,'2MASX J20405976-4736002',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'15.4R',0.15,NULL,NULL,NULL,NULL,NULL,1,310.249125,-47.60003,0.081,NULL,51347530911,802305170,12536018,15.4),(147746,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147746,35.95,0.54,155,70267,70,NULL,NULL,'ESO 597- G 027',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'15',0.8,'SAB(r)b:',NULL,NULL,NULL,NULL,1,310.2705,-22.20292,0.121,NULL,50834203386,794284427,12410694,15),(147747,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 17528','R',147747,40.93,0.35,1130,70268,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007iy','SDSS J204105.96-002519.6',0.36,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,':',NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,310.274833,-0.42211,0.313,NULL,47786404957,746662577,11666602,NULL),(147748,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 17528','R',147748,41.57,0.34,1520,70268,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007iy','SDSS J204105.96-002519.6',0.36,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147749,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147749,33.65,0.8,53.6,70269,75,NULL,'MAT, I','ESO 186- G 075',NULL,'1997ApJS..109..333W',1997,1,1.65,NULL,'G',0.000033,NULL,'15.67',0.16,'Scd',NULL,NULL,NULL,NULL,1,310.280875,-53.49633,0.117,NULL,51072688264,798010754,12468918,15.67),(147750,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147750,33.11,0.32,41.9,70269,85,NULL,'I, inv','ESO 186- G 075',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147751,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147751,33.13,0.32,42.3,70269,85,NULL,'I, raw','ESO 186- G 075',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147752,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147752,33.34,0.43,46.6,70269,75,NULL,'MAT, I, inv','ESO 186- G 075',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147753,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147753,33.35,0.43,46.7,70269,75,NULL,'MAT, I, raw','ESO 186- G 075',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147754,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147754,33.56,NULL,51.5,70269,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 186- G 075',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147755,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147755,33.57,NULL,51.8,70269,NULL,NULL,'Dipole + Quadrupole','ESO 186- G 075',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147756,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147756,33.59,NULL,52.2,70269,NULL,NULL,'Dipole','ESO 186- G 075',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147757,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147757,33.63,NULL,53.3,70269,NULL,NULL,NULL,'ESO 186- G 075',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147758,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147758,33.65,0.57,53.6,70269,NULL,NULL,NULL,'ESO 186- G 075',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147759,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147759,33.69,0.2,54.7,70269,74.4,NULL,NULL,'ESO 186- G 075',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147760,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147760,33.69,0.43,54.8,70269,75,NULL,'MAT, I, cor','ESO 186- G 075',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147761,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147761,33.97,0.49,62.3,70269,NULL,NULL,'Malmquist cor.','ESO 186- G 075',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147762,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147762,34.05,0.49,64.5,70269,75,NULL,'IR','ESO 186- G 075',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147763,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147763,35.97,0.73,156,70270,70,NULL,NULL,'2MASX J20411010-2559386',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,310.292166667,-25.99408,0.385,NULL,51319605973,801868843,12529200,15.7),(147764,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147764,36.09,0.57,165,70271,70,NULL,NULL,'2MASX J20411202-5257379',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.000087,NULL,'15.84',0.57,NULL,NULL,NULL,NULL,NULL,1,310.3000417,-52.96042,0.077,NULL,51073004270,798015691,12468995,15.84),(147765,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147765,34.19,0.8,68.8,70272,75,NULL,'MAT, I','NGC 6947',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'14',1,'(R\')SB(rs)b',NULL,NULL,NULL,NULL,1,310.313,-32.48642,0.193,NULL,51493494179,804585846,12571653,14),(147766,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147766,33.89,0.43,60.1,70272,75,NULL,'MAT, I, raw','NGC 6947',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147767,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147767,34.13,0.32,67.1,70272,85,NULL,'I, raw','NGC 6947',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147768,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147768,34.17,0.43,68.4,70272,75,NULL,'MAT, I, inv','NGC 6947',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147769,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147769,34.2,0.32,69.3,70272,85,NULL,'I, inv','NGC 6947',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147770,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147770,34.28,0.43,71.9,70272,75,NULL,'MAT, I, cor','NGC 6947',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147771,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147771,34.43,0.41,76.8,70272,NULL,NULL,NULL,'NGC 6947',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147772,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147772,34.47,0.2,78.3,70272,74.4,NULL,NULL,'NGC 6947',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147773,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147773,34.51,0.4,79.7,70272,NULL,NULL,'Malmquist cor.','NGC 6947',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147774,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147774,36.4,0.51,191,70273,70,NULL,NULL,'2MASX J20411954-4909400',NULL,'2014MNRAS.445.2677S',2014,1,0.23,NULL,'G',0.000103,NULL,'15.2R',0.18,NULL,NULL,NULL,NULL,NULL,1,310.3315,-49.16122,0.025,NULL,51350399165,802349986,12536718,15.2),(147775,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147775,35.99,0.7,158,70274,70,NULL,NULL,'2MASX J20412014-5110161',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.000103,NULL,'15.4R',0.17,NULL,NULL,NULL,NULL,NULL,1,310.334,-51.17119,0.025,NULL,51084645486,798197585,12471837,15.4),(147776,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 13839',NULL,147776,40.38,0.11,1190,70275,70,NULL,'SN photometric redshift distance, z photo =0.330 +/- 0.021','SDSS-II SN 13839',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,310.3357917,0.17831,0.305,NULL,53964402016,843193781,13174902,NULL),(147777,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 01821','RN',147777,39.03,0.12,584,70276,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01821',0.096105,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147778,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 01821','RN',147778,39.64,0.21,773,70276,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01821',0.096105,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147779,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147779,37.4,0.53,302,70277,70,NULL,NULL,'2MASX J20412263-5102481',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.000103,NULL,'14.9R',0.22,NULL,NULL,NULL,NULL,NULL,1,310.3442917,-51.04681,0.017,NULL,51076273124,798066767,12469793,14.9),(147780,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147780,36.85,0.69,235,70278,70,NULL,NULL,'2MASX J20412921-6213027',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'17.2b',0.18,NULL,NULL,NULL,NULL,NULL,1,310.371625,-62.21742,0.225,NULL,49146665646,767916650,11998697,17.2),(147781,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147781,35.18,0.49,109,70279,75,NULL,'IR','UGC 11614',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',NULL,NULL,'15.43',0.2,'Sb',NULL,NULL,NULL,NULL,1,310.3757917,13.07342,0.421,NULL,55262224328,863472255,13491753,15.43),(147782,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147782,35.27,0.62,113,70280,70,NULL,NULL,'2MASX J20413170-2026263',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,310.382,-20.44069,0.129,NULL,50826315424,794161178,12408768,14.8),(147783,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147783,34.9,0.57,95.5,70281,70,NULL,NULL,'2MASX J20413309-2055288',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.89',NULL,NULL,NULL,NULL,NULL,NULL,1,310.387833,-20.92467,0.149,NULL,50826572521,794165195,12408831,15.89),(147784,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147784,36.56,0.59,205,70282,70,NULL,NULL,'2MASX J20413758-4730150',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'15.2R',0.22,NULL,NULL,NULL,NULL,NULL,1,310.4065,-47.50414,0.073,NULL,51347268953,802301077,12535954,15.2),(147785,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147785,35.85,0.47,148,70283,70,NULL,NULL,'2MASX J20414021-4255420',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.000087,NULL,'14.2R',0.41,NULL,NULL,NULL,NULL,NULL,1,310.417583,-42.92831,0.057,NULL,51384764776,802886949,12545108,14.2),(147786,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147786,32.87,0.43,37.6,70284,75,NULL,'3.6 micron, color + selection bias corrected','MCG +09-34-001',NULL,'2014MNRAS.444..527S',2014,1,0.8,NULL,'G',0.000017,NULL,'10.0K',0.4,'Spiral',NULL,NULL,NULL,NULL,1,310.4254583,55.69814,NULL,NULL,52952090371,827376412,12927756,10),(147787,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147787,33.05,0.4,40.8,70284,NULL,NULL,'mean','MCG +09-34-001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147788,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147788,33.14,0.47,42.5,70284,NULL,NULL,'H','MCG +09-34-001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147789,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147789,33.19,0.46,43.4,70284,NULL,NULL,'J','MCG +09-34-001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147790,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147790,33.21,0.45,43.9,70284,NULL,NULL,'K','MCG +09-34-001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147791,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147791,37.39,0.46,301,70285,70,NULL,NULL,'2MASX J20414731+0112473',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000191,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,310.447208333,1.21308,0.281,NULL,53968030104,843250470,13175788,16.8),(147792,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 19317','R',147792,40,0.24,848,70286,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19317',0.178687,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,310.454833,1.06483,0.293,NULL,53968072787,843251137,13175799,NULL),(147793,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 19317','R',147793,40.42,0.35,1030,70286,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19317',0.178687,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147794,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147794,35.09,0.5,104,70287,70,NULL,NULL,'2MASX J20415168-2032088',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'15.43',NULL,NULL,NULL,NULL,NULL,NULL,1,310.465333,-20.53586,0.125,NULL,50826325110,794161329,12408770,15.43),(147795,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147795,36.21,0.5,175,70288,70,NULL,NULL,'2MASX J20415286-5026001',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.000103,NULL,'14.8R',0.26,NULL,NULL,NULL,NULL,NULL,1,310.470167,-50.43344,0,NULL,51077095209,798079612,12469993,14.8),(147796,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 11659','RN',147796,42.67,0.24,2330,70289,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 11659',0.467013,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147797,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147797,34.47,0.2,78.3,70290,74.4,NULL,NULL,'ESO 401- G 004',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000027,NULL,'15.65',1,'Sc',NULL,NULL,NULL,NULL,1,310.4824583,-32.82428,0.173,NULL,51523057163,805047768,12578871,15.65),(147798,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147798,34.66,0.38,85.6,70290,NULL,NULL,NULL,'ESO 401- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147799,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147799,34.73,0.37,88.2,70290,NULL,NULL,'Malmquist cor.','ESO 401- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147800,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005ix',NULL,147800,39.65,0.04,680,70291,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 06315, SN 2005ix','SDSS J204155.81+010530.8',0.25,'2011ApJS..192....1C',2011,1,0.04,NULL,'G',NULL,NULL,'22.7g',0.02,NULL,NULL,NULL,NULL,NULL,1,310.482583,1.09189,0.293,NULL,53968102939,843251608,13175806,22.7),(147801,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005ix',NULL,147801,39.79,0.13,726,70291,74.2,NULL,'SALT 2','SDSS J204155.81+010530.8',0.25,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147802,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 06315','R',147802,40.5,0.2,1010,70291,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ix','SDSS J204155.81+010530.8',0.25,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147803,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005ix',NULL,147803,40.53,0.09,1020,70291,65,NULL,'SALT2','SDSS J204155.81+010530.8',0.25,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147804,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005ix',NULL,147804,40.59,0.14,1050,70291,70,NULL,'SALT 2','SDSS J204155.81+010530.8',0.25,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147805,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005ix',NULL,147805,40.62,NULL,1060,70291,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 06315, SN 2005ix','SDSS J204155.81+010530.8',0.25,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147806,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005ix',NULL,147806,40.7,0.09,1100,70291,65,NULL,'MLCS2k2','SDSS J204155.81+010530.8',0.25,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147807,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 06315','R',147807,40.86,0.12,1190,70291,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ix','SDSS J204155.81+010530.8',0.25,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147808,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147808,35.72,0.37,139,70292,NULL,NULL,'Malmquist cor.','IC 1328',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.8b',0.4,'Sc',NULL,NULL,NULL,NULL,1,310.487667,-19.63306,0.149,NULL,50823251729,794113308,12408020,14.8),(147809,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147809,35.92,0.34,153,70292,NULL,NULL,NULL,'IC 1328',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147810,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147810,35.96,0.2,156,70292,74.4,NULL,NULL,'IC 1328',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147811,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147811,37.56,0.46,325,70293,70,NULL,NULL,'2MASX J20420269-0558515',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000077,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,310.511375,-5.98089,0.153,NULL,47836102517,747439101,11678735,17.5),(147812,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147812,38.52,0.69,507,70294,70,NULL,NULL,'2MASX J20420331-0307438',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.88',NULL,NULL,NULL,NULL,NULL,NULL,1,310.513833,-3.12869,0.173,NULL,47792189006,746752953,11668014,16.88),(147813,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147813,36.96,0.58,247,70295,70,NULL,NULL,'2MASX J20420400-4915056',NULL,'2014MNRAS.445.2677S',2014,1,0.24,NULL,'G',0.000103,NULL,'15.6R',0.13,NULL,NULL,NULL,NULL,NULL,1,310.5167083,-49.25156,0,NULL,51350367810,802349497,12536710,15.6),(147814,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147814,36.23,0.52,176,70296,70,NULL,NULL,'2MASX J20420558-5254447',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.00015,NULL,'16.0b',0.43,NULL,NULL,NULL,NULL,NULL,1,310.523375,-52.91247,0.077,NULL,51073031690,798016120,12469001,16),(147815,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147815,33.34,0.48,46.5,70297,70,NULL,NULL,'NGC 6932',NULL,'2014MNRAS.445.2677S',2014,1,2.1,NULL,'G',0.00007,NULL,'13.27',1.5,'(R_1)SAB(r)0^+',NULL,NULL,NULL,NULL,1,310.53575,-73.61936,0.209,NULL,49208202096,768878157,12013721,13.27),(147816,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147816,35.44,0.54,122,70298,NULL,NULL,'Malmquist cor.','ESO 341- G 007',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'14.29',1.1,'Sc',NULL,NULL,NULL,NULL,1,310.5430417,-37.69044,0.097,NULL,51519323621,804989431,12577959,14.29),(147817,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147817,35.51,0.52,126,70298,NULL,NULL,NULL,'ESO 341- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147818,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147818,35.55,0.2,129,70298,74.4,NULL,NULL,'ESO 341- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147819,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147819,35,0.49,99.8,70299,75,NULL,'IR','ESO 187- G 004',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000033,NULL,'15.44',0.3,'Sb-c',NULL,NULL,NULL,NULL,1,310.54575,-55.23844,0.209,NULL,48990853630,765482087,11960657,15.44),(147820,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147820,35.3,0.57,115,70299,NULL,NULL,'Malmquist cor.','ESO 187- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147821,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147821,35.39,0.54,120,70299,NULL,NULL,NULL,'ESO 187- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147822,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147822,35.43,0.2,122,70299,74.4,NULL,NULL,'ESO 187- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147823,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 05439',NULL,147823,41.18,0.21,1720,70300,70,NULL,'SN photometric redshift distance, z photo =0.530 +/- 0.078','SDSS-II SN 05439',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'*',NULL,'PHOT','21.2g',NULL,'Point Src [SDSS]',NULL,NULL,NULL,NULL,1,310.5479583,0.25197,0.305,NULL,53964210016,843190781,13174855,21.2),(147824,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 13810','RN',147824,40.93,0.17,1100,70301,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13810',0.388981,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147825,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 13810','RN',147825,41.53,0.23,1460,70301,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13810',0.388981,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147826,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147826,37.73,0.87,351,70302,70,NULL,NULL,'2MASX J20421536-5137507',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.000113,NULL,'15.2R',0.26,NULL,NULL,NULL,NULL,NULL,1,310.564083333,-51.63081,0.021,NULL,51084696137,798198377,12471849,15.2),(147827,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147827,35.82,0.54,146,70303,70,NULL,NULL,'2MASX J20422166-4756277',NULL,'2014MNRAS.445.2677S',2014,1,0.23,NULL,'G',0.000103,NULL,'15.5R',0.16,NULL,NULL,NULL,NULL,NULL,1,310.590375,-47.94106,0.069,NULL,51347358450,802302475,12535976,15.5),(147828,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147828,35.93,0.67,153,70304,70,NULL,NULL,'2MASX J20422683-2010524',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.16',NULL,NULL,NULL,NULL,NULL,NULL,1,310.611917,-20.18122,0.145,NULL,50823090931,794110795,12407981,16.16),(147829,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 14303',NULL,147829,40.15,0.17,1070,70305,70,NULL,'SN photometric redshift distance, z photo =0.291 +/- 0.029','SDSS-II SN 14303',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.0g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,310.614541667,-0.53536,0.301,NULL,47789366521,746708851,11667325,21),(147830,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147830,34.29,0.8,72.1,70306,75,NULL,'MAT, I','ESO 528- G 034',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.66',0.7,'SB(s)c','in an interacting pair',NULL,NULL,NULL,1,310.62175,-24.14969,0.205,NULL,50832758566,794261852,12410341,14.66),(147831,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147831,33.92,0.32,60.9,70306,85,NULL,'I, raw','ESO 528- G 034',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147832,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147832,33.95,0.32,61.8,70306,85,NULL,'I, inv','ESO 528- G 034',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147833,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147833,34,0.43,63.1,70306,75,NULL,'MAT, I, raw','ESO 528- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147834,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147834,34.17,0.43,68.2,70306,75,NULL,'MAT, I, inv','ESO 528- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147835,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147835,34.48,0.43,78.8,70306,75,NULL,'MAT, I, cor','ESO 528- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147836,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147836,34.55,0.47,81.2,70306,NULL,NULL,NULL,'ESO 528- G 034',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147837,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147837,34.59,0.2,82.8,70306,74.4,NULL,NULL,'ESO 528- G 034',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147838,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147838,34.68,0.44,86.1,70306,NULL,NULL,'Malmquist cor.','ESO 528- G 034',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147839,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 16657','RN',147839,40.87,0.15,1250,70307,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16657',0.192,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147840,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 16657','RN',147840,40.98,0.27,1320,70307,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16657',0.192,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147841,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147841,34.86,0.52,93.8,70308,70,NULL,NULL,'2MASX J20423127-7809458',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,310.6305417,-78.16269,0.433,NULL,48581563334,759086927,11860733,16.8),(147842,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147842,35.12,0.56,106,70309,70,NULL,NULL,'FAIRALL 0910',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.4I',0.4,NULL,NULL,NULL,NULL,NULL,1,310.6480417,-43.75644,0.053,NULL,51384565276,802883832,12545059,13.4),(147843,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 13675',NULL,147843,40.18,0.15,1090,70310,70,NULL,'SN photometric redshift distance, z photo =0.296 +/- 0.025','SDSS-II SN 13675',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,310.6589583,-0.91661,0.265,NULL,47789818394,746715912,11667436,NULL),(147844,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147844,34,0.49,63,70311,75,NULL,'IR','FGC 2286',NULL,'2011yCatp016004901K',2011,1,1.56,NULL,'G',0.00002,NULL,'16.0',0.12,'Sd',NULL,NULL,NULL,NULL,1,310.6797083,-2.76683,0.161,NULL,47795059637,746797806,11668715,16),(147845,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147845,34.14,NULL,67.2,70311,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2286',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147846,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147846,34.15,NULL,67.6,70311,NULL,NULL,'Dipole + Quadrupole','FGC 2286',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147847,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147847,34.15,NULL,67.7,70311,NULL,NULL,'Dipole','FGC 2286',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147848,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147848,34.21,NULL,69.7,70311,NULL,NULL,NULL,'FGC 2286',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147849,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147849,35.23,0.54,111,70312,70,NULL,NULL,'2MASX J20425115-5253513',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.80',0.24,NULL,NULL,NULL,NULL,NULL,1,310.71325,-52.89769,0.065,NULL,51073025373,798016021,12469000,16.8),(147850,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147850,36.35,0.51,187,70313,70,NULL,NULL,'2MASX J20430076-4818594',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,310.7532083,-48.31647,0.073,NULL,51347457438,802304022,12536000,14.2),(147851,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147851,33.82,0.8,57.9,70314,75,NULL,'MAT, I','ESO 187- G 006',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00003,NULL,'14.87',0.6,'(R\':)SAB(r)b',NULL,NULL,NULL,NULL,1,310.7582083,-52.51464,0.025,NULL,51071411385,797990802,12468606,14.87),(147852,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147852,33.39,0.32,47.6,70314,85,NULL,'I, raw','ESO 187- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147853,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147853,33.39,0.32,47.7,70314,85,NULL,'I, inv','ESO 187- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147854,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147854,33.53,0.43,50.8,70314,75,NULL,'MAT, I, raw','ESO 187- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147855,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147855,33.6,0.43,52.4,70314,75,NULL,'MAT, I, inv','ESO 187- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147856,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147856,33.86,0.43,59,70314,75,NULL,'MAT, I, cor','ESO 187- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147857,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147857,34.2,0.37,69.2,70314,NULL,NULL,NULL,'ESO 187- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147858,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147858,34.24,0.2,70.5,70314,74.4,NULL,NULL,'ESO 187- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147859,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147859,34.24,0.37,70.6,70314,NULL,NULL,'Malmquist cor.','ESO 187- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147860,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147860,36.15,0.64,170,70315,70,NULL,NULL,'2MASX J20430701-5608530',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.31',0.48,'S0',NULL,NULL,NULL,NULL,1,310.77925,-56.14806,0.209,NULL,48992179710,765502807,11960981,16.31),(147861,'GRB','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147861,41.99,NULL,2500,70316,70,NULL,'Pseudo z = 0.95','GRB 020801',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,310.783333,-46.83333,0.045,NULL,51393159245,803018113,12547158,NULL),(147862,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147862,32.65,0.8,34,70317,75,NULL,'MAT, I','IC 5003',NULL,'1997ApJS..109..333W',1997,1,2.4,NULL,'G',0.00003,NULL,'13.25',0.6,'Sbc: sp','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,310.80975,-29.85339,0.245,NULL,51314956406,801796193,12528065,13.25),(147863,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147863,31.6,0.43,20.8,70317,75,NULL,'3.6 micron, color + selection bias corrected','IC 5003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147864,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147864,31.72,0.43,22.1,70317,75,NULL,'3.6 micron, color corrected','IC 5003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147865,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147865,31.87,0.2,23.7,70317,74.4,NULL,NULL,'IC 5003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147866,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147866,32.1,0.41,26.3,70317,NULL,NULL,NULL,'IC 5003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147867,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147867,32.21,0.39,27.7,70317,NULL,NULL,'Malmquist cor.','IC 5003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147868,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147868,32.35,0.4,29.5,70317,NULL,NULL,NULL,'IC 5003',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147869,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147869,32.45,0.32,30.9,70317,85,NULL,'I, raw','IC 5003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147870,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147870,32.48,0.32,31.3,70317,85,NULL,'I, inv','IC 5003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147871,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147871,32.55,0.43,32.3,70317,75,NULL,'MAT, I, raw','IC 5003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147872,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147872,32.63,0.46,33.5,70317,NULL,NULL,'J','IC 5003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147873,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147873,32.65,0.4,33.9,70317,NULL,NULL,'mean','IC 5003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147874,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147874,32.68,0.47,34.3,70317,NULL,NULL,'H','IC 5003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147875,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147875,32.7,0.43,34.7,70317,75,NULL,'MAT, I, inv','IC 5003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147876,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147876,32.73,0.43,35.2,70317,75,NULL,'MAT, I, cor','IC 5003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147877,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147877,32.77,0.45,35.8,70317,NULL,NULL,'K','IC 5003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147878,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147878,37.02,0.46,253,70318,70,NULL,NULL,'2MASX J20431738-0649222',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000067,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,310.8224583,-6.82281,0.125,NULL,50759643740,793119433,12392491,17.4),(147879,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147879,35.53,0.63,128,70319,70,NULL,NULL,'2MASX J20431739-5330144',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.80',0.22,NULL,NULL,NULL,NULL,NULL,1,310.8224583,-53.50408,0.105,NULL,51073111395,798017365,12469021,16.8),(147880,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147880,37.31,0.46,290,70320,70,NULL,NULL,'2MASX J20431877+0115038',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000149,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,310.82825,1.25122,0.277,NULL,53967320818,843239387,13175615,17.5),(147881,'Tully est','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147881,31.49,0.8,19.9,70321,75,NULL,NULL,'IC 5028',NULL,'1988NBGC.C....0000T',1988,1,1.2,NULL,'G',0.000022,NULL,'15.19',1,'IAB(s)m?',NULL,NULL,NULL,NULL,1,310.841791667,-65.64781,0.125,NULL,49370031913,771406748,12053230,15.19),(147882,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147882,33.71,0.8,55.2,70322,75,NULL,'MAT, I','ESO 187- G 008',NULL,'1997ApJS..109..333W',1997,1,0.98,NULL,'G',0.000033,NULL,'15.69',0.21,'Scd',NULL,NULL,NULL,NULL,1,310.853917,-56.20364,0.209,NULL,48992186196,765502909,11960982,15.69),(147883,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147883,33.54,0.32,51.1,70322,85,NULL,'I, raw','ESO 187- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147884,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147884,33.54,0.32,51.1,70322,85,NULL,'I, inv','ESO 187- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147885,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147885,33.68,NULL,54.5,70322,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 187- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147886,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147886,33.7,0.43,55,70322,75,NULL,'MAT, I, raw','ESO 187- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147887,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147887,33.71,NULL,55.2,70322,NULL,NULL,'Dipole + Quadrupole','ESO 187- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147888,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147888,33.72,NULL,55.5,70322,NULL,NULL,'Dipole','ESO 187- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147889,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147889,33.75,0.43,56.4,70322,75,NULL,'MAT, I, inv','ESO 187- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147890,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147890,33.76,NULL,56.4,70322,NULL,NULL,NULL,'ESO 187- G 008',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147891,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147891,33.91,0.43,60.6,70322,75,NULL,'MAT, I, cor','ESO 187- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147892,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147892,34.06,0.42,64.8,70322,NULL,NULL,NULL,'ESO 187- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147893,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147893,34.1,0.2,66.1,70322,74.4,NULL,NULL,'ESO 187- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147894,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147894,34.13,0.41,66.9,70322,NULL,NULL,'Malmquist cor.','ESO 187- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147895,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147895,34.48,0.49,78.5,70322,75,NULL,'IR','ESO 187- G 008',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147896,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 14013',NULL,147896,39.46,0.35,779,70323,70,NULL,'SN photometric redshift distance, z photo =0.202 +/- 0.040','SDSS-II SN 14013',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,310.867625,-1.20475,0.289,NULL,47789086401,746704475,11667257,NULL),(147897,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147897,32.98,0.8,39.5,70324,75,NULL,'MAT, I','NGC 6948',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000033,NULL,'13.76',1,'SA(s)a: sp',NULL,NULL,NULL,NULL,1,310.871417,-53.35672,0.105,NULL,51073106936,798017295,12469020,13.76),(147898,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147898,33.29,0.4,45.5,70324,NULL,NULL,'mean','NGC 6948',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147899,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147899,33.57,0.45,51.7,70324,NULL,NULL,'K','NGC 6948',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147900,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147900,33.65,0.47,53.7,70324,NULL,NULL,'H','NGC 6948',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147901,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147901,33.75,0.46,56.2,70324,NULL,NULL,'J','NGC 6948',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147902,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147902,34.54,0.43,80.9,70324,75,NULL,'MAT, I, raw','NGC 6948',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147903,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147903,34.62,0.32,84,70324,85,NULL,'I, raw','NGC 6948',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147904,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147904,34.68,0.32,86.2,70324,85,NULL,'I, inv','NGC 6948',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147905,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147905,34.72,0.43,87.9,70324,75,NULL,'MAT, I, cor','NGC 6948',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147906,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147906,34.78,0.43,90.5,70324,75,NULL,'MAT, I, inv','NGC 6948',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147907,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147907,37.65,0.46,338,70325,70,NULL,NULL,'2MASX J20432958+0050219',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000143,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,310.8732917,0.83936,0.337,NULL,53967914105,843248657,13175760,17.4),(147908,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147908,33.56,0.46,51.5,70326,NULL,NULL,'J','UGC 11635',NULL,'2007A&A...465...71T',2007,1,2.9,NULL,'G',0.00001,NULL,'13.8',1.2,'Sbc','Isolated galaxy',NULL,NULL,NULL,1,310.8742083,80.15611,0.353,NULL,52866401077,826037516,12906836,13.8),(147909,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147909,33.58,0.45,51.9,70326,NULL,NULL,'K','UGC 11635',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147910,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147910,33.6,0.47,52.5,70326,NULL,NULL,'H','UGC 11635',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147911,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147911,33.87,0.4,59.5,70326,NULL,NULL,'mean','UGC 11635',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147912,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147912,34.19,0.2,68.9,70326,74.4,NULL,NULL,'UGC 11635',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147913,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147913,34.22,0.43,69.9,70326,75,NULL,'3.6 micron, color corrected','UGC 11635',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147914,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147914,34.34,0.43,73.9,70326,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11635',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147915,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147915,32.68,0.8,34.3,70327,75,NULL,'MAT, I','IC 5007',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.000003,NULL,'12.58',1.5,'SAB(s)d        HII','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,310.8935417,-29.70364,0.281,NULL,51315012198,801797065,12528079,12.58),(147916,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147916,32.3,0.32,28.8,70327,85,NULL,'I, raw','IC 5007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147917,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147917,32.33,0.32,29.2,70327,85,NULL,'I, inv','IC 5007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147918,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147918,32.52,0.43,31.9,70327,75,NULL,'MAT, I, raw','IC 5007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147919,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147919,32.52,0.43,31.9,70327,75,NULL,'3.6 micron, color + selection bias corrected','IC 5007',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147920,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147920,32.57,0.4,32.7,70327,NULL,NULL,NULL,'IC 5007',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147921,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147921,32.57,0.43,32.7,70327,75,NULL,'3.6 micron, color corrected','IC 5007',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147922,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147922,32.62,0.2,33.4,70327,74.4,NULL,NULL,'IC 5007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147923,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147923,32.66,0.43,34.1,70327,75,NULL,'MAT, I, inv','IC 5007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147924,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147924,32.71,0.43,34.9,70327,75,NULL,'MAT, I, cor','IC 5007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147925,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147925,32.71,0.48,34.9,70327,NULL,NULL,'Malmquist cor.','IC 5007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147926,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147926,32.75,0.47,35.5,70327,NULL,NULL,NULL,'IC 5007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147927,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147927,36.16,0.46,171,70328,70,NULL,NULL,'2MASX J20433471+0058039',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00017,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,310.894583,0.96775,0.345,NULL,53967253520,843238336,13175599,16.8),(147928,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147928,36.51,0.5,200,70329,70,NULL,NULL,'2MASX J20434052-5113345',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,310.91875,-51.22631,0.021,NULL,51084548447,798196069,12471813,14.2),(147929,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147929,35.88,0.53,150,70330,70,NULL,NULL,'IC 5034',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000093,NULL,'14.63',0.7,'SAB(rs)bc','in a pair',NULL,NULL,NULL,1,310.923625,-57.03031,0.285,NULL,48998967629,765608869,11962638,14.63),(147930,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147930,35.78,0.54,143,70331,70,NULL,NULL,'2MASX J20434167-5259455',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'16.02',0.37,NULL,NULL,NULL,NULL,NULL,1,310.92375,-52.99606,0.065,NULL,51073217620,798019025,12469047,16.02),(147931,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147931,36.11,0.6,167,70332,70,NULL,NULL,'AM 2040-263 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,310.931417,-26.41914,0.269,NULL,51320052388,801875818,12529309,15.3),(147932,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147932,35.93,0.54,153,70333,70,NULL,NULL,'FAIRALL 0557',NULL,'2014MNRAS.445.2677S',2014,1,0.7,'1983MNRAS.203...47F has V = 5800: +- 100 km/s.','G',0.00015,NULL,'14.0I',0.3,'SB(s)a',NULL,NULL,NULL,NULL,1,310.938,-48.22819,0.073,NULL,51347340556,802302196,12535971,14),(147933,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147933,36.34,0.53,186,70334,70,NULL,NULL,'2MASX J20434965-2635321',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.4,NULL,NULL,NULL,NULL,NULL,1,310.957,-26.59228,0.345,NULL,51320166794,801877606,12529337,13.9),(147934,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147934,36.77,0.55,226,70335,70,NULL,NULL,'2MASX J20435212-7335115',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,310.967125,-73.58656,0.201,NULL,49208177115,768877767,12013715,17.1),(147935,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147935,34.81,0.56,91.6,70336,70,NULL,NULL,'CGCG 374-002',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00011,NULL,'15.5',0.5,NULL,NULL,NULL,NULL,NULL,1,310.969833,-1.87731,0.265,NULL,47794642932,746791295,11668613,15.5),(147936,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 14304',NULL,147936,40.29,0.15,1140,70337,70,NULL,'SN photometric redshift distance, z photo =0.315 +/- 0.028','SDSS-II SN 14304',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,311.00175,-0.60592,0.301,NULL,47788135933,746689623,11667025,NULL),(147937,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 18583','RN',147937,39.93,0.1,826,70338,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 18583',0.17212,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147938,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 18583','RN',147938,40.33,0.2,994,70338,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 18583',0.17212,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147939,'AGN time lag','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147939,35.11,0.13,105,70339,NULL,NULL,NULL,'MRK 0509',NULL,'2014ApJ...784L..11Y',2014,1,0.5,NULL,'G',0.00004,NULL,'14.2r',NULL,'Compact        Sy1.2',NULL,NULL,NULL,'Sy 1.5',1,311.040583,-10.72347,0.181,NULL,50767230453,793237975,12394343,14.2),(147940,'AGN time lag','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147940,37.88,0.46,376,70339,44,NULL,NULL,'MRK 0509',NULL,'2007MNRAS.380..669C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147941,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147941,35.91,0.51,152,70340,70,NULL,NULL,'FAIRALL 0558',NULL,'2014MNRAS.445.2677S',2014,1,0.8,'1983MNRAS.203...47F has V = 5200: +- 100 km/s.','G',0.00015,NULL,'13.6I',0.4,'SB(r)0^+:',NULL,NULL,NULL,NULL,1,311.064167,-47.72453,0.073,NULL,51347439904,802303748,12535996,13.6),(147942,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 06496','R',147942,41.14,0.19,1290,70341,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06496',0.3088,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,311.0662917,0.05203,0.309,NULL,53965506022,843211031,13175172,NULL),(147943,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 06496','R',147943,41.15,0.28,1300,70341,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06496',0.3088,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147944,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 02027','RN',147944,41.26,0.2,1520,70342,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02027',0.172969,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147945,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 02027','RN',147945,41.83,0.24,1980,70342,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02027',0.172969,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147946,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147946,38.16,0.46,429,70343,70,NULL,NULL,'2MASX J20442150-0556455',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000091,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,311.089541667,-5.94614,0.137,NULL,50738733995,792792718,12387386,17.5),(147947,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147947,33.98,0.4,62.4,70344,NULL,NULL,'mean','UGC 11623',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.00003,NULL,'14.85',0.7,'SB(r)a','in a triple',NULL,NULL,NULL,1,311.110875,12.49772,0.433,NULL,55253904371,863342255,13489722,14.85),(147948,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147948,34.14,0.47,67.2,70344,NULL,NULL,'H','UGC 11623',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147949,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147949,34.22,0.45,69.9,70344,NULL,NULL,'K','UGC 11623',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147950,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147950,34.28,0.46,71.9,70344,NULL,NULL,'J','UGC 11623',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147951,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 05877',NULL,147951,40.3,0.16,1150,70345,70,NULL,'SN photometric redshift distance, z photo =0.317 +/- 0.029','SDSS-II SN 05877',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','22.8g',0.01,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,311.112,0.541,0.337,NULL,53965775213,843215237,13175238,22.8),(147952,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147952,34.55,0.63,81.2,70346,70,NULL,NULL,'2MASX J20442728-3043364',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'14.9R',0.25,NULL,NULL,NULL,NULL,NULL,1,311.113625,-30.72678,0.225,NULL,51316786851,801824794,12528512,14.9),(147953,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147953,37.11,0.67,264,70347,70,NULL,NULL,'2MASX J20442911-5333332',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.06',0.38,NULL,NULL,NULL,NULL,NULL,1,311.12125,-53.55917,0.105,NULL,51073962175,798030658,12469229,16.06),(147954,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147954,32.91,0.8,38.2,70348,75,NULL,'MAT, I','NGC 6943',NULL,'1997ApJS..109..333W',1997,1,4,NULL,'G',0.000013,NULL,'12.05',2,'SAB(r)cd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,311.140583,-68.74772,0.173,NULL,49381221799,771581590,12055962,12.05),(147955,'Sosies','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147955,32.29,0.13,28.7,70348,NULL,NULL,NULL,'NGC 6943',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147956,'Tully est','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147956,32.94,0.8,38.8,70348,75,NULL,'B','NGC 6943',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147957,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147957,32.44,NULL,30.8,70348,NULL,NULL,'B','NGC 6943',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147958,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147958,32.47,0.43,31.3,70348,75,NULL,'MAT, I, raw','NGC 6943',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147959,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147959,32.5,0.32,31.6,70348,85,NULL,'I, raw','NGC 6943',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147960,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147960,32.5,0.4,31.6,70348,NULL,NULL,NULL,'NGC 6943',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147961,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147961,32.5,0.39,31.6,70348,73,NULL,'opt','NGC 6943',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147962,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147962,32.57,0.32,32.6,70348,85,NULL,'I, inv','NGC 6943',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147963,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147963,32.67,0.46,34.2,70348,NULL,NULL,'J','NGC 6943',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147964,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147964,32.68,NULL,34.3,70348,NULL,NULL,'I','NGC 6943',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147965,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147965,32.75,0.43,35.5,70348,75,NULL,'MAT, I, inv','NGC 6943',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147966,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147966,32.75,0.43,35.5,70348,75,NULL,'3.6 micron, color corrected','NGC 6943',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147967,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147967,32.76,0.2,35.7,70348,74.4,NULL,NULL,'NGC 6943',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147968,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147968,32.78,0.45,35.9,70348,NULL,NULL,'K','NGC 6943',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147969,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147969,32.82,0.43,36.7,70348,75,NULL,'MAT, I, cor','NGC 6943',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147970,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147970,32.84,0.43,37,70348,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6943',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147971,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147971,32.91,0.47,38.2,70348,NULL,NULL,'H','NGC 6943',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147972,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147972,33.03,0.4,40.4,70348,NULL,NULL,'mean','NGC 6943',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147973,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147973,34.79,0.51,90.9,70349,70,NULL,NULL,'2MASX J20443443-5742363',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.000103,NULL,'15.80',0.5,'E',NULL,NULL,NULL,NULL,1,311.1434583,-57.71003,0.337,NULL,49131023629,767672244,11994878,15.8),(147974,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147974,35.2,0.6,110,70350,70,NULL,NULL,'ESO 597- G 033',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000083,NULL,'15.52',0.9,'S0',NULL,NULL,NULL,NULL,1,311.164417,-20.53492,0.161,NULL,50825840919,794153764,12408652,15.52),(147975,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147975,32.61,0.8,33.2,70351,75,NULL,'HMCL, I','ESO 285- G 048',NULL,'1997ApJS..109..333W',1997,1,2.5,'Confused HIPASS source','G',0.000023,NULL,'13.57',1,'SB(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,311.1675417,-45.9785,0.021,NULL,51396471588,803069868,12547966,13.57),(147976,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147976,32.61,0.8,33.2,70351,75,NULL,'MAT, I','ESO 285- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147977,'Tully est','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147977,32.68,0.8,34.3,70351,75,NULL,NULL,'ESO 285- G 048',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147978,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147978,32.25,0.4,28.2,70351,NULL,NULL,NULL,'ESO 285- G 048',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147979,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147979,32.25,0.39,28.2,70351,73,NULL,'opt','ESO 285- G 048',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147980,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147980,32.25,0.32,28.2,70351,85,NULL,'I, raw','ESO 285- G 048',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147981,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147981,32.26,0.32,28.3,70351,85,NULL,'I, inv','ESO 285- G 048',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147982,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147982,32.49,0.4,31.5,70351,75,NULL,'HMCL, I, raw','ESO 285- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147983,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147983,32.49,0.5,31.5,70351,NULL,NULL,NULL,'ESO 285- G 048',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147984,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147984,32.53,0.2,32.1,70351,74.4,NULL,NULL,'ESO 285- G 048',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147985,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147985,32.56,0.4,32.5,70351,75,NULL,'HMCL, I, inv','ESO 285- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147986,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147986,32.62,0.43,33.4,70351,75,NULL,'MAT, I, raw','ESO 285- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147987,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147987,32.63,0.47,33.6,70351,NULL,NULL,'Malmquist cor.','ESO 285- G 048',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147988,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147988,32.69,0.4,34.5,70351,75,NULL,'HMCL, I, cor','ESO 285- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147989,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147989,32.71,0.43,34.8,70351,75,NULL,'MAT, I, inv','ESO 285- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147990,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147990,32.84,0.43,37,70351,75,NULL,'MAT, I, cor','ESO 285- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147991,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147991,36.4,0.71,191,70352,70,NULL,NULL,'2MASX J20444456-4412157',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.2,NULL,NULL,NULL,NULL,NULL,1,311.1857917,-44.20431,0.053,NULL,51377339967,802770936,12543295,14.5),(147992,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147992,35.51,0.74,126,70353,70,NULL,NULL,'2MASX J20445136-5414332',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'16.16',0.29,NULL,NULL,NULL,NULL,NULL,1,311.214125,-54.24267,0.105,NULL,51072437777,798006840,12468856,16.16),(147993,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147993,36.5,0.57,200,70354,70,NULL,NULL,'2MASX J20445862-4358137',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,311.244333,-43.97058,0.045,NULL,51377310699,802770479,12543288,14.4),(147994,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147994,34.65,0.8,85,70355,75,NULL,'MAT, I','IC 5025',NULL,'1997ApJS..109..333W',1997,1,1.66,NULL,'G',0.000033,NULL,'15.36',0.21,'Sbc',NULL,NULL,NULL,NULL,1,311.246166667,-76.98469,0.361,NULL,48525249042,758207016,11846984,15.36),(147995,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147995,34.38,0.43,75.1,70355,75,NULL,'MAT, I, raw','IC 5025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147996,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147996,34.46,0.32,77.9,70355,85,NULL,'I, raw','IC 5025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147997,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147997,34.5,0.32,79.6,70355,85,NULL,'I, inv','IC 5025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147998,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147998,34.52,0.38,80.1,70355,NULL,NULL,'Malmquist cor.','IC 5025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147999,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147999,34.52,0.49,80.2,70355,75,NULL,'IR','IC 5025',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148000,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148000,34.53,0.38,80.4,70355,NULL,NULL,NULL,'IC 5025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148001,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148001,34.57,0.2,82,70355,74.4,NULL,NULL,'IC 5025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148002,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148002,34.59,0.43,82.9,70355,75,NULL,'MAT, I, inv','IC 5025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148003,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148003,34.73,0.43,88.5,70355,75,NULL,'MAT, I, cor','IC 5025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148004,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148004,34.98,NULL,98.9,70355,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 5025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148005,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148005,34.98,NULL,99.2,70355,NULL,NULL,'Dipole + Quadrupole','IC 5025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148006,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148006,35,NULL,100,70355,NULL,NULL,'Dipole','IC 5025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148007,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148007,35.03,NULL,101,70355,NULL,NULL,NULL,'IC 5025',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148008,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148008,38.46,0.46,492,70356,70,NULL,NULL,'SDSS J204459.44-061253.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000078,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,311.2477083,-6.215,0.117,NULL,50793236702,793644323,12400692,18.7),(148009,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 03407','RN',148009,43.56,0.4,3940,70357,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03407',0.30996,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148010,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 03407','RN',148010,43.62,0.32,4040,70357,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03407',0.30996,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148011,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148011,36.83,0.8,233,70358,70,NULL,NULL,'2MASX J20450165-5124507',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,311.256958333,-51.41408,0.021,NULL,51084564710,798196323,12471817,15.6),(148012,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148012,33.73,0.47,55.7,70359,NULL,NULL,'H','VV 546',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'GPair',0.00006,NULL,NULL,NULL,'Sa',NULL,NULL,NULL,NULL,1,311.258666667,-11.10458,0.185,NULL,50766244365,793222568,12394102,NULL),(148013,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148013,33.79,0.45,57.3,70359,NULL,NULL,'K','VV 546',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148014,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148014,33.84,0.46,58.5,70359,NULL,NULL,'J','VV 546',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148015,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148015,34.17,0.4,68.2,70359,NULL,NULL,'mean','VV 546',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148016,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148016,34.12,0.54,66.8,70360,70,NULL,NULL,'NGC 6985',NULL,'2014MNRAS.445.2677S',2014,1,1.7,'10 minute error in NGC RA.','G',0.0001,NULL,'15.50',0.6,'SB:(s)a: pec',NULL,NULL,NULL,NULL,1,311.262417,-11.10419,0.185,NULL,50766246144,793222596,12394103,15.5),(148017,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 14622','RN',148017,36.8,0.4,214,70361,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 14622',0.071119,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148018,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148018,36.74,0.68,223,70362,70,NULL,NULL,'2MASX J20451305-5330367',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.58',0.31,NULL,NULL,NULL,NULL,NULL,1,311.3044583,-53.51022,0.105,NULL,51073954283,798030535,12469227,16.58),(148019,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148019,39.07,0.46,652,70363,70,NULL,NULL,'SDSS J204514.13-055743.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000096,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,311.308916667,-5.96197,0.137,NULL,50738729573,792792649,12387385,18.6),(148020,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148020,34.2,0.53,69.1,70364,70,NULL,NULL,'ESO 074- G 007',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.33',0.3,'SAB(s)a',NULL,NULL,NULL,NULL,1,311.3257083,-71.39722,0.153,NULL,49327280639,770738759,12042793,14.33),(148021,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148021,35.04,0.49,102,70365,75,NULL,'IR','ESO 401- G 007',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000033,NULL,'14.2R',0.6,'SAB(r)a',NULL,NULL,NULL,NULL,1,311.32675,-35.24069,0.141,NULL,51516961225,804952519,12577383,14.2),(148022,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148022,35.42,0.4,121,70365,NULL,NULL,'mean','ESO 401- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148023,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148023,35.55,0.42,129,70365,NULL,NULL,'Malmquist cor.','ESO 401- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148024,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148024,35.62,0.47,133,70365,NULL,NULL,'H','ESO 401- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148025,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148025,35.66,0.4,135,70365,NULL,NULL,NULL,'ESO 401- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148026,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148026,35.7,0.2,138,70365,74.4,NULL,NULL,'ESO 401- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148027,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148027,38.89,0.46,600,70366,70,NULL,NULL,'2MASX J20451954-0617358',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00013,NULL,'17.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,311.331333,-6.29325,0.117,NULL,50793173072,793643329,12400677,17.3),(148028,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148028,35.3,0.47,115,70367,70,NULL,NULL,'ESO 285- G 049',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'14.34',0.6,'(L)SA0^0',NULL,NULL,NULL,NULL,1,311.3347917,-45.61567,0.017,NULL,51395277559,803051211,12547675,14.34),(148029,'Brightest Stars','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148029,28.66,NULL,5.4,70368,NULL,NULL,NULL,'KKR 55',NULL,'2000A&A...362..544K',2000,1,0.6,NULL,'G',0.000002,NULL,'17.0',0.4,'Ir',NULL,NULL,NULL,NULL,1,311.336625,60.41111,2.325,NULL,53476403223,835568800,13055762,17),(148030,'Brightest Stars','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148030,28.85,NULL,5.9,70368,NULL,NULL,NULL,'KKR 55',NULL,'1997AstL...23..373S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148031,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 15822','RN',148031,40.52,0.14,1030,70369,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15822',0.2333,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148032,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 15822','RN',148032,40.62,0.26,1080,70369,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15822',0.2333,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148033,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148033,35.59,0.51,131,70370,70,NULL,NULL,'2MASX J20452657-5318297',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'16.17',0.33,'S',NULL,NULL,NULL,NULL,1,311.360583333,-53.30822,0.105,NULL,51073863443,798029116,12469204,16.17),(148034,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148034,36.23,0.49,176,70371,75,NULL,'IR','2MFGC 15724',NULL,'2011yCatp016004901K',2011,1,0.53,NULL,'G',0.000037,NULL,'17.31',0.14,'Sc',NULL,NULL,NULL,NULL,1,311.384417,-52.71653,0.045,NULL,51071226167,797987908,12468561,17.31),(148035,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148035,36.36,0.43,187,70371,NULL,NULL,'Malmquist cor.','2MFGC 15724',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148036,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148036,36.4,0.43,190,70371,NULL,NULL,NULL,'2MFGC 15724',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148037,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148037,36.44,0.2,194,70371,74.4,NULL,NULL,'2MFGC 15724',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148038,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 13615',NULL,148038,39.66,0.25,854,70372,70,NULL,'SN photometric redshift distance, z photo =0.224 +/- 0.031','SDSS-II SN 13615',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,311.412333,1.18661,0.357,NULL,53969914975,843279921,13176248,NULL),(148039,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148039,36.35,0.46,186,70373,NULL,NULL,'Malmquist cor.','2MASX J20454491-5245416',NULL,'2009ApJS..182..474S',2009,1,0.75,NULL,'G',0.000033,NULL,'16.64',0.16,'Sc',NULL,NULL,NULL,NULL,1,311.437,-52.76167,0.045,NULL,51071229037,797987953,12468561,16.64),(148040,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148040,36.42,0.45,192,70373,NULL,NULL,NULL,'2MASX J20454491-5245416',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148041,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148041,36.46,0.2,196,70373,74.4,NULL,NULL,'2MASX J20454491-5245416',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148042,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148042,38.29,0.46,455,70374,70,NULL,NULL,'2MASX J20454992-0619498',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00009,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,311.4579583,-6.33047,0.117,NULL,50793197664,793643713,12400683,18.2),(148043,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148043,36.27,0.52,179,70375,70,NULL,NULL,'ESO 234- G 068',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'14.34',0.8,'SAB(s)0^0^:',NULL,NULL,NULL,NULL,1,311.4677083,-51.10747,0.009,NULL,51084526477,798195726,12471808,14.34),(148044,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148044,33.1,0.22,41.1,70376,74.2,NULL,'SALT 2','ESO 234- G 069',0.014,'2010ApJ...716..712A',2010,1,2.1,NULL,'G',0.000027,NULL,'14.15',0.7,'SAB(s)c',NULL,NULL,NULL,NULL,1,311.477375,-51.39111,0.021,NULL,51070957080,797983704,12468495,14.15),(148045,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148045,33.49,0.03,49.2,70376,70,NULL,'SALT 2','ESO 234- G 069',0.014,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148046,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148046,33.77,0.19,56,70376,72,NULL,NULL,'ESO 234- G 069',0.014,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148047,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148047,33.78,0.21,56.2,70376,70,NULL,'SALT','ESO 234- G 069',0.014,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148048,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148048,33.75,0.08,56.2,70376,74.4,NULL,NULL,'ESO 234- G 069',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148049,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148049,33.84,0.21,57.8,70376,70,NULL,'SALT 2','ESO 234- G 069',0.014,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148050,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148050,33.82,0.07,58.1,70376,60,NULL,'M(B) = -19.48 mag','ESO 234- G 069',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148051,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148051,33.88,0.2,58.9,70376,73.8,NULL,'SALT 2 (SNANA)','ESO 234- G 069',0.0138,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148052,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148052,33.88,0.17,59.7,70376,70.8,NULL,NULL,'ESO 234- G 069',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148053,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148053,33.92,0.11,60,70376,65,NULL,'MLCS','ESO 234- G 069',0.014,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148054,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148054,33.9,0.06,60.3,70376,60,NULL,'M(V) = -19.47 mag','ESO 234- G 069',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148055,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148055,33.96,0.23,61.2,70376,65,NULL,'MLCS17','ESO 234- G 069',0.014,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148056,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148056,33.98,0.04,61.6,70376,72,NULL,NULL,'ESO 234- G 069',0.014,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148057,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148057,33.96,0.06,61.9,70376,60,NULL,'M(I) = -19.19 mag','ESO 234- G 069',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148058,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148058,34.02,0.25,62.9,70376,65,NULL,'SALT2','ESO 234- G 069',0.014,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148059,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148059,34.03,0.23,63.1,70376,65,NULL,'MLCS31','ESO 234- G 069',0.014,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148060,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148060,34.13,0.07,65,70376,65,NULL,'MLCS2k2','ESO 234- G 069',0.014,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148061,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148061,34.12,0.25,65.8,70376,65,NULL,NULL,'ESO 234- G 069',0.014,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148062,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148062,34.13,0.14,66.1,70376,65,NULL,'Template','ESO 234- G 069',0.014,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148063,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148063,34.2,0.14,69.2,70376,60,NULL,NULL,'ESO 234- G 069',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148064,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148064,33.64,0.8,53.6,70376,75,NULL,'MAT, I','ESO 234- G 069',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148065,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148065,33.21,0.32,43.9,70376,85,NULL,'I, raw','ESO 234- G 069',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148066,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148066,33.24,0.32,44.5,70376,85,NULL,'I, inv','ESO 234- G 069',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148067,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148067,33.33,0.43,46.4,70376,75,NULL,'MAT, I, raw','ESO 234- G 069',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148068,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148068,33.42,0.49,48.4,70376,75,NULL,'IR','ESO 234- G 069',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148069,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148069,33.48,0.43,49.6,70376,75,NULL,'MAT, I, inv','ESO 234- G 069',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148070,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148070,33.71,0.43,55.2,70376,75,NULL,'MAT, I, cor','ESO 234- G 069',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148071,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148071,33.9,0.4,60.4,70376,NULL,NULL,'mean','ESO 234- G 069',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148072,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148072,34.24,0.47,70.4,70376,NULL,NULL,'H','ESO 234- G 069',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148073,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148073,36.53,0.46,202,70377,70,NULL,NULL,'2MASX J20460047+0023316',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000178,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,311.502,0.39206,0.373,NULL,53965949346,843217958,13175280,16.5),(148074,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148074,32.65,0.8,33.9,70378,75,NULL,'HMCL, I','ESO 285- G 051',NULL,'1997ApJS..109..333W',1997,1,1,'Confused HIPASS source','G',0.000024,NULL,'15.54',0.7,'SB(s)m',NULL,NULL,NULL,NULL,1,311.5035,-45.84961,0.017,NULL,51396407966,803068874,12547951,15.54),(148075,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148075,32.65,0.8,33.9,70378,75,NULL,'MAT, I','ESO 285- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148076,'Tully est','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148076,32.71,0.8,34.8,70378,75,NULL,NULL,'ESO 285- G 051',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148077,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148077,33.63,0.32,53.3,70378,85,NULL,'I, inv','ESO 285- G 051',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148078,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148078,33.66,0.32,53.9,70378,85,NULL,'I, raw','ESO 285- G 051',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148079,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148079,33.8,0.43,57.6,70378,75,NULL,'MAT, I, inv','ESO 285- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148080,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148080,33.85,0.43,58.8,70378,75,NULL,'MAT, I, raw','ESO 285- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148081,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148081,34.15,0.43,67.7,70378,75,NULL,'MAT, I, cor','ESO 285- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148082,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148082,35.1,0.4,105,70378,75,NULL,'HMCL, I, raw','ESO 285- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148083,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148083,35.17,0.4,108,70378,75,NULL,'HMCL, I, inv','ESO 285- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148084,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148084,35.34,0.4,117,70378,75,NULL,'HMCL, I, cor','ESO 285- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148085,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148085,35.33,0.46,116,70379,70,NULL,NULL,'2MASX J20460301-0544280',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00008,NULL,'15.5g',0.42,'S0/a',NULL,NULL,NULL,NULL,1,311.512667,-5.74097,0.229,NULL,50739446388,792803849,12387560,15.5),(148086,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148086,34.06,0.48,64.8,70380,70,NULL,NULL,'ESO 234- G 070',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000103,NULL,'14.56',1,'S0',NULL,NULL,NULL,NULL,1,311.5152083,-51.61606,0.025,NULL,51071143656,797986619,12468540,14.56),(148087,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148087,35.17,0.8,108,70381,75,NULL,'MAT, I','IC 1330',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'14.6b',0.4,'Sc? sp',NULL,NULL,NULL,NULL,1,311.56225,-14.02322,0.129,NULL,50985449462,796647647,12447619,14.6),(148088,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148088,34.85,0.43,93.2,70381,75,NULL,'MAT, I, raw','IC 1330',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148089,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148089,34.94,0.32,97.3,70381,85,NULL,'I, raw','IC 1330',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148090,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148090,35.01,0.32,101,70381,85,NULL,'I, inv','IC 1330',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148091,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148091,35.07,0.47,103,70381,NULL,NULL,'H','IC 1330',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148092,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148092,35.13,0.43,106,70381,75,NULL,'MAT, I, cor','IC 1330',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148093,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148093,35.14,0.43,107,70381,75,NULL,'MAT, I, inv','IC 1330',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148094,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148094,35.15,0.45,107,70381,NULL,NULL,'K','IC 1330',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148095,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148095,35.19,0.39,109,70381,NULL,NULL,NULL,'IC 1330',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148096,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148096,35.23,0.2,111,70381,74.4,NULL,NULL,'IC 1330',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148097,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148097,35.25,0.46,112,70381,NULL,NULL,'J','IC 1330',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148098,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148098,35.25,0.4,112,70381,NULL,NULL,'mean','IC 1330',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148099,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148099,35.28,0.37,114,70381,NULL,NULL,'Malmquist cor.','IC 1330',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148100,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148100,37.07,0.76,260,70382,70,NULL,NULL,'2MASX J20461652-5209506',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'17.1b',0.15,NULL,NULL,NULL,NULL,NULL,1,311.5689583,-52.16408,0.025,NULL,51071892863,797998325,12468723,17.1),(148101,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148101,36.35,0.5,186,70383,70,NULL,NULL,'2MASX J20462184-5237231',NULL,'2014MNRAS.445.2677S',2014,1,0.31,NULL,'G',0.000103,NULL,'15.1R',0.19,NULL,NULL,NULL,NULL,NULL,1,311.5909583,-52.62303,0.045,NULL,51071742612,797995978,12468687,15.1),(148102,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148102,37.81,0.46,364,70384,70,NULL,NULL,'2MASX J20462663-0714301',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000066,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,311.611083,-7.24183,0.233,NULL,50793511392,793648615,12400759,18.1),(148103,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148103,36.65,0.49,213,70385,70,NULL,NULL,'ESO 234- G 071',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.000103,NULL,'15.87',0.2,'N',NULL,NULL,NULL,NULL,1,311.64925,-50.11978,0,NULL,51348703061,802323485,12536304,15.87),(148104,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148104,37.11,0.77,264,70386,70,NULL,NULL,'2MASX J20463654-7317503',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,311.652,-73.29731,0.197,NULL,49208612503,768884570,12013821,15.6),(148105,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148105,34.43,0.48,76.7,70387,70,NULL,NULL,'ESO 529- G 001',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000097,NULL,'14.5',1,'S0-:     poss. LINER',NULL,NULL,NULL,NULL,1,311.655125,-23.63047,0.173,NULL,50821346697,794083542,12407555,14.5),(148106,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 05735',NULL,148106,39.35,0.51,741,70388,70,NULL,'SN photometric redshift distance, z photo =0.191 +/- 0.058','SDSS-II SN 05735',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,311.6587917,0.65058,0.373,NULL,53965044484,843203820,13175059,NULL),(148107,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148107,35.42,0.49,121,70389,70,NULL,NULL,'ESO 144- G 004',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000117,NULL,'14.75',0.6,'(L)SB(s)0^+',NULL,NULL,NULL,NULL,1,311.665083,-58.68639,0.297,NULL,49131937402,767686521,11995101,14.75),(148108,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148108,35.62,0.53,133,70390,70,NULL,NULL,'AM 2043-442 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00013,NULL,'14.1R',0.33,NULL,NULL,NULL,NULL,NULL,1,311.681583333,-44.28281,0.037,NULL,51394923042,803045672,12547588,14.1),(148109,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 09268',NULL,148109,40.67,0.19,1360,70391,70,NULL,'SN photometric redshift distance, z photo =0.389 +/- 0.047','SDSS-II SN 09268',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,311.6865,-0.17425,0.297,NULL,47787918251,746686222,11666972,NULL),(148110,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148110,34.48,0.56,78.6,70392,70,NULL,NULL,'ESO 285- G 052',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'14.61',1,'S0- pec',NULL,NULL,NULL,NULL,1,311.6935,-44.63444,0.033,NULL,51394993693,803046776,12547605,14.61),(148111,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148111,36.77,0.54,226,70393,70,NULL,NULL,'2MASX J20464694-5311012',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'15.82',0.42,'SBa','Group member',NULL,NULL,NULL,1,311.695625,-53.18364,0.089,NULL,51073906958,798029796,12469215,15.82),(148112,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148112,36.03,0.72,161,70394,70,NULL,NULL,'2MASX J20464710-7759067',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,311.696125,-77.98519,0.433,NULL,48580614183,759072096,11860501,16.4),(148113,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148113,33.63,0.8,53.3,70395,75,NULL,'MAT, I','IC 5038',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00002,NULL,'13.38',0.7,'(R\':)SB(s)bc   HII','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,311.7152083,-65.01681,0.105,NULL,49370604279,771415691,12053370,13.38),(148114,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148114,32.48,0.32,31.4,70395,85,NULL,'I, raw','IC 5038',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148115,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148115,32.5,0.32,31.6,70395,85,NULL,'I, inv','IC 5038',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148116,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148116,32.65,0.43,33.9,70395,75,NULL,'MAT, I, raw','IC 5038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148117,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148117,32.77,0.43,35.8,70395,75,NULL,'MAT, I, inv','IC 5038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148118,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148118,32.95,0.43,38.9,70395,75,NULL,'MAT, I, cor','IC 5038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148119,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148119,33.3,0.47,45.7,70395,NULL,NULL,'H','IC 5038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148120,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148120,33.43,0.46,48.6,70395,NULL,NULL,'J','IC 5038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148121,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148121,33.46,0.45,49.2,70395,NULL,NULL,'K','IC 5038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148122,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148122,33.66,0.4,54.1,70395,NULL,NULL,'mean','IC 5038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148123,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148123,33.85,0.09,59,70395,NULL,NULL,NULL,'IC 5038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148124,'Brightest Stars','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148124,27.81,NULL,3.65,70396,NULL,NULL,'Blue','DDO 210',NULL,'1997AstL...23..644G',1997,1,2.2,NULL,'G',0.000007,NULL,'14.0B',1.1,'IB(s)m','Group member',NULL,NULL,NULL,1,311.715875,-12.84792,0.141,NULL,50979666748,796557292,12446207,14),(148125,'Brightest Stars','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148125,27.81,NULL,3.65,70396,NULL,NULL,'LF','DDO 210',NULL,'1997AstL...23..656G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148126,'Brightest Stars','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148126,28.1,NULL,4.17,70396,NULL,NULL,'Red + Blue','DDO 210',NULL,'1997AstL...23..644G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148127,'Brightest Stars','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148127,28.1,0.4,4.17,70396,NULL,NULL,'3B + 3R mean','DDO 210',NULL,'1997AstL...23..656G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148128,'Brightest Stars','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148128,28.2,NULL,4.37,70396,NULL,NULL,'Red','DDO 210',NULL,'1997AstL...23..644G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148129,'CMD','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148129,24.6,NULL,0.8,70396,NULL,NULL,NULL,'DDO 210',NULL,'1994AJ....107.1328V',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148130,'CMD','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148130,24.85,NULL,0.933,70396,NULL,NULL,NULL,'DDO 210',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148131,'CMD','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148131,24.95,0.1,0.977,70396,NULL,NULL,NULL,'DDO 210',NULL,'2014ApJ...795...54C',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148132,'CMD','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148132,28,NULL,3.98,70396,NULL,NULL,NULL,'DDO 210',NULL,'1993AJ....105..894G',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148133,'RR Lyrae','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148133,25.07,0.12,1.03,70396,NULL,NULL,'32, BI','DDO 210',NULL,'2016MNRAS.455.2163O',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148134,'TRGB','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148134,24.86,0.14,0.938,70396,NULL,NULL,NULL,'DDO 210',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148135,'TRGB','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148135,24.86,0.1,0.94,70396,NULL,NULL,NULL,'DDO 210',NULL,'2002A&A...389..812K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148136,'TRGB','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148136,24.89,0.11,0.95,70396,NULL,NULL,'I','DDO 210',NULL,'1999AJ....118..853L',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148137,'TRGB','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148137,24.93,0.14,0.968,70396,NULL,NULL,'I','DDO 210',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148138,'TRGB','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148138,25.02,0.08,1.01,70396,74.4,NULL,NULL,'DDO 210',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148139,'TRGB','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148139,25.05,0.11,1.03,70396,NULL,NULL,NULL,'DDO 210',NULL,'1999IAUS..192..268L',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148140,'TRGB','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148140,25.15,0.08,1.07,70396,NULL,NULL,NULL,'DDO 210',NULL,'2005MNRAS.356..979M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148141,'Tully est','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148141,24.23,0.8,0.7,70396,75,NULL,NULL,'DDO 210',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148142,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 20097','R',148142,40.13,0.13,868,70397,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2007rd','SN 2007rd',0.221,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia?',NULL,NULL,NULL,NULL,1,311.7545417,-0.09933,0.297,NULL,47787910374,746686099,11666970,NULL),(148143,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 20097','R',148143,40.23,0.23,912,70397,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2007rd','SN 2007rd',0.221,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148144,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148144,36.58,0.88,207,70398,70,NULL,NULL,'2MASX J20470246-3503429',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'16.69',0.19,NULL,NULL,NULL,NULL,NULL,1,311.7602083,-35.06194,0.157,NULL,51524609761,805072027,12579250,16.69),(148145,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148145,36.56,0.69,205,70399,70,NULL,NULL,'2MASX J20470270-1358005',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000013,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,311.7614583,-13.96678,0.129,NULL,50980194955,796565546,12446336,16.1),(148146,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148146,36.59,0.72,207,70400,70,NULL,NULL,'2MASX J20470769-7214285',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,311.782125,-72.24133,0.157,NULL,49327437577,770741212,12042831,15.8),(148147,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148147,34.29,0.27,72,70401,70,NULL,NULL,'NGC 6961',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000023,NULL,'14.74',0.5,'E+ pec?','Group member',NULL,NULL,NULL,1,311.7937917,0.36328,0.365,NULL,53965200829,843206262,13175097,14.74),(148148,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 18590','R',148148,39.08,0.08,620,70402,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2007nw','2MASX J20471136-0115292',0.057185,'2014arXiv1401.3317S',2014,1,0.33,NULL,'G',0.000202,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,311.797375,-1.25806,0.233,NULL,47797015922,746828373,11669193,17.2),(148149,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 18590','R',148149,39.87,0.21,893,70402,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2007nw','2MASX J20471136-0115292',0.057185,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148150,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2007nw',NULL,148150,37.31,0.09,274,70402,NULL,NULL,'SCM 55 SNII','2MASX J20471136-0115292',0.057185,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148151,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2007nw',NULL,148151,37.49,0.11,297,70402,NULL,NULL,'SCM 15 SDSS SNII','2MASX J20471136-0115292',0.057185,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148152,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148152,36.72,0.58,220,70403,70,NULL,NULL,'2MASX J20471507-5331222',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.00015,NULL,'15.86',0.53,'S0',NULL,NULL,NULL,NULL,1,311.81275,-53.52286,0.097,NULL,51074027019,798031672,12469244,15.86),(148153,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148153,34.02,0.47,63.7,70404,70,NULL,NULL,'2MFGC 15746',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000063,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,311.815041667,-76.44372,0.337,NULL,48534752499,758355507,11849304,15.9),(148154,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148154,36.73,0.57,222,70405,70,NULL,NULL,'2MASX J20471674-6703006',NULL,'2014MNRAS.445.2677S',2014,1,0.22,NULL,'G',0.00015,NULL,'15.7R',0.12,NULL,NULL,NULL,NULL,NULL,1,311.8199583,-67.05011,0.133,NULL,49390473923,771726155,12058221,15.7),(148155,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148155,37.17,0.5,272,70406,70,NULL,NULL,'ESO 234- G 072',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.71',0.4,'Sa',NULL,NULL,NULL,NULL,1,311.822833,-51.36594,0.025,NULL,51340406672,802193854,12534278,15.71),(148156,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2002ha',NULL,148156,33.1,0.23,41.1,70407,74.2,NULL,'SALT 2','NGC 6962',0.014046,'2010ApJ...716..712A',2010,1,2.9,NULL,'G',0.00007,NULL,'13.3g',2.3,'SAB(r)ab','Pair member (points to parent)',NULL,NULL,NULL,1,311.829417,0.32081,0.365,NULL,53965208943,843206389,13175099,13.3),(148157,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2002ha',NULL,148157,33.65,0.03,53,70407,72,NULL,'SALT2','NGC 6962',0.014046,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148158,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2002ha',NULL,148158,33.75,0.08,56.2,70407,74.4,NULL,NULL,'NGC 6962',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148159,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2002ha',NULL,148159,33.81,0.21,57.1,70407,70,NULL,'SALT 2','NGC 6962',0.014046,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148160,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2002ha',NULL,148160,33.84,0.2,57.7,70407,73.8,NULL,'SALT 2 (SNANA)','NGC 6962',0.0137,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148161,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2002ha',NULL,148161,33.92,0.04,60,70407,70,NULL,'SALT 2','NGC 6962',0.014046,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148162,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2002ha',NULL,148162,34.01,0.27,62.4,70407,65,NULL,'SALT2','NGC 6962',0.014046,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148163,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2002ha',NULL,148163,34.01,0.24,62.6,70407,65,NULL,'MLCS17','NGC 6962',0.014046,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148164,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2002ha',NULL,148164,34.03,0.24,63.1,70407,65,NULL,'MLCS31','NGC 6962',0.014046,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148165,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148165,33.74,0.45,56.1,70407,NULL,NULL,'K','NGC 6962',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148166,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148166,33.75,0.08,56.2,70407,74.4,NULL,NULL,'NGC 6962',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148167,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148167,33.76,0.4,56.4,70407,NULL,NULL,'mean','NGC 6962',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148168,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148168,33.76,0.6,56.5,70407,NULL,NULL,'Malmquist cor.','NGC 6962',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148169,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148169,33.77,0.47,56.8,70407,NULL,NULL,'H','NGC 6962',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148170,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148170,33.78,0.46,57,70407,NULL,NULL,'J','NGC 6962',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148171,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148171,33.78,0.59,57.1,70407,NULL,NULL,NULL,'NGC 6962',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148172,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148172,34.27,0.43,71.4,70407,75,NULL,'3.6 micron, color corrected','NGC 6962',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148173,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148173,34.28,0.4,71.8,70407,75,NULL,'HOSTS SN 2002ha','NGC 6962',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148174,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148174,34.35,0.42,74.1,70407,NULL,18.48,'3.6 micron','NGC 6962',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148175,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148175,34.45,0.43,77.7,70407,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6962',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148176,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 03543',NULL,148176,39.35,1.19,741,70408,70,NULL,'SN photometric redshift distance, z photo =0.191 +/- 0.170','SDSS-II SN 03543',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,311.834208333,0.05344,0.309,NULL,53965180629,843205947,13175092,NULL),(148177,'Faber-Jackson','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148177,33.77,0.44,56.8,70409,95,NULL,'Weighted Mean','NGC 6965',NULL,'1984ApJS...56...91D',1984,1,0.7,'NGC 6963 is a double star.','G',0.000087,NULL,'14.9g',0.6,'S0^0^:','Group member',NULL,NULL,NULL,1,311.834875,0.48406,0.365,NULL,53965068506,843204195,13175065,14.9),(148178,'Faber-Jackson','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148178,33.78,0.63,57,70409,95,NULL,'Michard 1979b, c','NGC 6965',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148179,'Faber-Jackson','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148179,34.61,0.46,83.6,70409,95,NULL,'Michard 1979a','NGC 6965',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148180,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148180,34.29,0.27,72,70409,70,NULL,NULL,'NGC 6965',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148181,'Tertiary','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148181,33.25,0.5,44.7,70409,95,NULL,NULL,'NGC 6965',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148182,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005fl',NULL,148182,39.49,0.15,641,70410,74.2,NULL,'SALT 2','SDSS J204722.09-011511.8',0.234,'2010ApJ...716..712A',2010,1,0.08,NULL,'G',NULL,NULL,'20.2g',0.07,NULL,NULL,NULL,NULL,NULL,1,311.842083,-1.25331,0.269,NULL,47797041397,746828771,11669199,20.2),(148183,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005fl',NULL,148183,40.16,0.18,872,70410,70,NULL,'SALT 2','SDSS J204722.09-011511.8',0.234,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148184,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 02030','R',148184,40.26,0.26,907,70410,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fl','SDSS J204722.09-011511.8',0.24,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148185,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 02030','R',148185,40.36,0.18,953,70410,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fl','SDSS J204722.09-011511.8',0.24,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148186,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148186,37.06,0.57,258,70411,70,NULL,NULL,'2MASX J20472420-4246487',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,311.850916667,-42.78017,0.057,NULL,51383193759,802862402,12544725,15.1),(148187,'Faber-Jackson','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148187,33.55,0.44,51.3,70412,95,NULL,'Weighted Mean','NGC 6964',NULL,'1984ApJS...56...91D',1984,1,1.7,NULL,'G',0.000053,NULL,'13.8g',1.3,'E+ pec:','Pair member (points to parent)',NULL,NULL,NULL,1,311.85125,0.30083,0.365,NULL,53965209327,843206395,13175099,13.8),(148188,'Faber-Jackson','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148188,33.64,0.63,53.5,70412,95,NULL,'Michard 1979b, c','NGC 6964',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148189,'Faber-Jackson','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148189,34.31,0.46,72.8,70412,95,NULL,'Michard 1979a','NGC 6964',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148190,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148190,34.29,0.27,72,70412,70,NULL,NULL,'NGC 6964',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148191,'Tertiary','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148191,33.25,0.5,44.7,70412,95,NULL,NULL,'NGC 6964',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148192,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148192,33.62,0.4,52.9,70412,NULL,NULL,'mean','NGC 6964',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148193,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148193,34.11,0.45,66.4,70412,NULL,NULL,'K','NGC 6964',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148194,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 14472','RN',148194,42.69,0.18,2530,70413,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14472',0.3643,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148195,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 14472','RN',148195,42.92,0.28,2820,70413,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 14472',0.3643,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148196,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148196,36.63,0.72,212,70414,70,NULL,NULL,'2MASX J20473965-4450308',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'15.1R',0.28,NULL,NULL,NULL,NULL,NULL,1,311.915333,-44.84192,0.029,NULL,51395888106,803060751,12547824,15.1),(148197,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148197,35.76,0.63,142,70415,70,NULL,NULL,'2MASX J20474862-5212436',NULL,'2014MNRAS.445.2677S',2014,1,0.28,NULL,'G',0.00015,NULL,'16.4b',0.15,'S0','Group member',NULL,NULL,NULL,1,311.952625,-52.21203,0.029,NULL,51071809727,797997026,12468703,16.4),(148198,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 03367','RN',148198,42.83,0.18,2280,70416,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03367',0.616329,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148199,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 14305',NULL,148199,40.25,0.14,1120,70417,70,NULL,'SN photometric redshift distance, z photo =0.307 +/- 0.024','SDSS-II SN 14305',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,311.969083333,-0.5935,0.269,NULL,47796396978,746818702,11669042,NULL),(148200,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148200,37.61,0.46,333,70418,70,NULL,NULL,'GALEXMSC J204754.34+003913.1',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'UvS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,311.9764583,0.65367,0.357,NULL,53969361001,843271265,13176113,NULL),(148201,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148201,33.55,0.49,51.3,70419,75,NULL,'IR','UGC 11631',NULL,'2011yCatp016004901K',2011,1,0.67,NULL,'G',0.000017,NULL,'15.1g',0.38,'Im:;LLIRG      HII',NULL,NULL,NULL,NULL,1,311.9997917,-0.18,0.297,NULL,47787858420,746685287,11666957,15.1),(148202,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148202,36.16,0.46,171,70420,NULL,NULL,'Malmquist cor.','2MASX J20480119-5258087',NULL,'2009ApJS..182..474S',2009,1,0.72,NULL,'G',0.000033,NULL,'15.11',0.48,'Sb','Group member',NULL,NULL,NULL,1,312.0050417,-52.96903,0.081,NULL,51073638037,798025594,12469149,15.11),(148203,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148203,36.42,0.41,192,70420,NULL,NULL,NULL,'2MASX J20480119-5258087',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148204,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148204,36.46,0.2,196,70420,74.4,NULL,NULL,'2MASX J20480119-5258087',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148205,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 06326','R',148205,40.33,0.23,951,70421,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06326',0.2228,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,312.01425,-0.80961,0.249,NULL,47797063218,746829112,11669204,NULL),(148206,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 06326','R',148206,40.4,0.14,983,70421,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06326',0.2228,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148207,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148207,35.1,0.8,105,70422,75,NULL,'MAT, I','ESO 463- G 025',NULL,'1997ApJS..109..333W',1997,1,2.46,NULL,'G',0.000033,NULL,'15.61',0.21,'SBd: sp',NULL,NULL,NULL,NULL,1,312.026,-30.22658,0.293,NULL,51496000374,804625005,12572265,15.61),(148208,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148208,34.99,0.43,99.6,70422,75,NULL,'MAT, I, raw','ESO 463- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148209,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148209,35.03,0.49,101,70422,75,NULL,'IR','ESO 463- G 025',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148210,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148210,35.23,NULL,111,70422,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 463- G 025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148211,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148211,35.25,0.32,112,70422,85,NULL,'I, raw','ESO 463- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148212,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148212,35.24,NULL,112,70422,NULL,NULL,'Dipole','ESO 463- G 025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148213,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148213,35.24,NULL,112,70422,NULL,NULL,'Dipole + Quadrupole','ESO 463- G 025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148214,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148214,35.28,NULL,114,70422,NULL,NULL,NULL,'ESO 463- G 025',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148215,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148215,35.28,0.43,114,70422,75,NULL,'MAT, I, inv','ESO 463- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148216,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148216,35.32,0.32,116,70422,85,NULL,'I, inv','ESO 463- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148217,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148217,35.31,0.52,116,70422,NULL,NULL,'Malmquist cor.','ESO 463- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148218,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148218,35.39,0.43,119,70422,75,NULL,'MAT, I, cor','ESO 463- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148219,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148219,35.41,0.49,121,70422,NULL,NULL,NULL,'ESO 463- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148220,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148220,35.43,0.4,122,70422,NULL,NULL,'mean','ESO 463- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148221,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148221,35.45,0.2,123,70422,74.4,NULL,NULL,'ESO 463- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148222,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148222,35.51,0.47,127,70422,NULL,NULL,'H','ESO 463- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148223,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148223,35.62,0.45,133,70422,NULL,NULL,'K','ESO 463- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148224,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148224,36.76,0.57,225,70423,70,NULL,NULL,'2MASX J20480771-5713152',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.000103,NULL,'16.59',0.36,NULL,NULL,NULL,NULL,NULL,1,312.0322917,-57.22092,0.301,NULL,49138608886,767790763,11996730,16.59),(148225,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148225,35.84,0.56,147,70424,70,NULL,NULL,'2MASX J20480812-4514354',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,'(R_1)SB0/a:',NULL,NULL,NULL,NULL,1,312.0340417,-45.24303,0.025,NULL,51395930085,803061407,12547834,15.1),(148226,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 17800','R',148226,40.1,0.28,861,70425,70,NULL,'SDSS CAND. zSNIa; SALT 2; SN 2007kn','SDSS J204809.20-010054.3',0.217,'2014arXiv1401.3317S',2014,1,0.14,NULL,'G',NULL,NULL,'21.1g',0.04,NULL,NULL,NULL,NULL,NULL,1,312.038375,-1.01508,0.249,NULL,47797214496,746831476,11669241,21.1),(148227,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 17800','R',148227,40.14,0.27,878,70425,70,NULL,'SDSS CAND. zSNIa; MLCS2K2; SN 2007kn','SDSS J204809.20-010054.3',0.217,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148228,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148228,36.31,0.67,183,70426,70,NULL,NULL,'2MASX J20480948-2314591',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'15.4R',0.16,NULL,NULL,NULL,NULL,NULL,1,312.0395417,-23.24986,0.157,NULL,50819722658,794058166,12407158,15.4),(148229,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 08477','RN',148229,37.67,0.23,323,70427,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 08477',0.056335,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148230,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005fm',NULL,148230,38.46,0.11,435,70428,74.2,NULL,'SALT 2','SDSS J204810.43-011016.8',0.13,'2010ApJ...716..712A',2010,1,0.05,NULL,'G',NULL,NULL,'20.9g',0.05,NULL,NULL,NULL,NULL,NULL,1,312.0435,-1.17136,0.269,NULL,47796994872,746828044,11669188,20.9),(148231,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005fm',NULL,148231,38.56,0.03,455,70428,70,NULL,'SDSS-II SN 02031','SDSS J204810.43-011016.8',0.13,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148232,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005fm',NULL,148232,39.22,0.12,617,70428,70,NULL,'SDSS-II SN 02031, SALT 2','SDSS J204810.43-011016.8',0.13,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148233,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005fm',NULL,148233,39.22,0.07,619,70428,65,NULL,'SALT2','SDSS J204810.43-011016.8',0.13,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148234,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 02031','R',148234,39.24,0.19,623,70428,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fm','SDSS J204810.43-011016.8',0.13,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148235,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005fm',NULL,148235,39.47,0.08,692,70428,65,NULL,'MLCS2k2','SDSS J204810.43-011016.8',0.13,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148236,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 02031','R',148236,39.51,0.09,705,70428,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fm','SDSS J204810.43-011016.8',0.13,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148237,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148237,35.9,0.77,151,70429,NULL,NULL,NULL,'ESO-LV 1870151',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000033,NULL,'16.55',0.26,'Sc','Group member',NULL,NULL,NULL,1,312.043666667,-52.49219,0.033,NULL,51071615353,797993989,12468656,16.55),(148238,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148238,35.94,0.2,154,70429,74.4,NULL,NULL,'ESO-LV 1870151',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148239,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148239,36.27,0.65,179,70429,NULL,NULL,'Malmquist cor.','ESO-LV 1870151',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148240,'BCG','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148240,38.63,0.35,464,70430,60,NULL,NULL,'ABELL 2328',0.147,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,312.044167,-17.84389,0.225,NULL,50990816572,796731508,12448929,NULL),(148241,'BCG','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148241,38.63,0.35,464,70431,60,NULL,'ABELL 2328, BCG','2MASX J20481162-1749034',0.147,'1980ApJ...241..486H',1980,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,'E/D','Brightest group member',NULL,NULL,NULL,1,312.048125,-17.81775,0.225,NULL,50993635755,796775558,12449618,15.3),(148242,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148242,35.06,0.33,103,70432,NULL,NULL,NULL,'ESO 597- G 035',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000022,NULL,'16.09',0.2,'Sb             HII','in a triple',NULL,NULL,NULL,1,312.0499583,-19.83219,0.205,NULL,50947878689,796060604,12438446,16.09),(148243,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148243,35.1,0.2,105,70432,74.4,NULL,NULL,'ESO 597- G 035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148244,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148244,35.35,0.29,117,70432,NULL,NULL,'Malmquist cor.','ESO 597- G 035',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148245,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148245,34.96,0.56,98.3,70433,70,NULL,NULL,'2MASX J20481208-6858217',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.2R',NULL,'(R)SA0^0',NULL,NULL,NULL,NULL,1,312.050167,-68.97261,0.141,NULL,49336426485,770881663,12045025,14.2),(148246,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148246,36.55,0.89,204,70434,70,NULL,NULL,'2MASX J20481207-5346457',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.09',0.45,'S0',NULL,NULL,NULL,NULL,1,312.050333,-53.77944,0.093,NULL,51073815429,798028366,12469193,16.09),(148247,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148247,36.01,0.54,159,70435,70,NULL,NULL,'2MASX J20481472-5315497',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.00015,NULL,'15.66',0.48,'S0',NULL,NULL,NULL,NULL,1,312.0612917,-53.26389,0.097,NULL,51073598822,798024981,12469140,15.66),(148248,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148248,34.84,0.51,92.8,70436,70,NULL,NULL,'6dF J2048197-354037',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'13.4R',NULL,'poss. LINER',NULL,NULL,NULL,NULL,1,312.082166667,-35.67686,0.161,NULL,51524053153,805063330,12579114,13.4),(148249,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148249,35.72,0.47,140,70437,NULL,NULL,'Malmquist cor.','2MASX J20482125+1620167',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000033,NULL,'16.0',0.15,NULL,NULL,NULL,NULL,NULL,1,312.0885417,16.33794,0.365,NULL,55258778808,863418418,13490912,16),(148250,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148250,35.75,0.2,141,70437,74.4,NULL,NULL,'2MASX J20482125+1620167',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148251,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148251,35.84,0.45,147,70437,NULL,NULL,NULL,'2MASX J20482125+1620167',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148252,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148252,35.57,0.57,130,70438,70,NULL,NULL,'2MASX J20482388-5319047',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.21',0.43,'S0',NULL,NULL,NULL,NULL,1,312.0995,-53.31803,0.097,NULL,51073712855,798026763,12469168,16.21),(148253,'Brightest Stars','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148253,28.85,NULL,5.9,70439,NULL,NULL,NULL,'KKR 56',NULL,'1997AstL...23..373S',1997,1,0.7,NULL,'G',0.000027,NULL,'17.6',0.45,'Ir',NULL,NULL,NULL,NULL,1,312.1005,58.61828,NULL,NULL,53430268047,834847938,13044499,17.6),(148254,'Brightest Stars','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148254,29.04,NULL,6.4,70439,NULL,NULL,NULL,'KKR 56',NULL,'2000A&A...362..544K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148255,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148255,37.57,0.66,326,70440,70,NULL,NULL,'2MASX J20482414-4429305',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'14.9R',0.49,NULL,NULL,NULL,NULL,NULL,1,312.1005,-44.49178,0.037,NULL,51395127937,803048874,12547638,14.9),(148256,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 01909','RN',148256,41.53,0.18,1360,70441,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01909',0.48507,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148257,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148257,33.95,0.4,61.5,70442,NULL,NULL,'mean','NGC 6969',NULL,'2007A&A...465...71T',2007,1,1.1,'RC3 has V = 4000 +- 60 km/sec.','G',0.00013,NULL,'14.89',0.3,'Sa','Isolated galaxy',NULL,NULL,NULL,1,312.115125,7.73997,0.393,NULL,55086186203,860721659,13448775,14.89),(148258,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148258,34.07,0.47,65,70442,NULL,NULL,'H','NGC 6969',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148259,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148259,34.09,0.46,65.8,70442,NULL,NULL,'J','NGC 6969',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148260,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148260,34.12,0.28,66.6,70442,NULL,NULL,'Malmquist cor.','NGC 6969',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148261,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148261,34.12,0.28,66.7,70442,NULL,NULL,NULL,'NGC 6969',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148262,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148262,34.13,0.45,67.1,70442,NULL,NULL,'K','NGC 6969',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148263,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148263,34.14,0.2,67.3,70442,74.4,NULL,NULL,'NGC 6969',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148264,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148264,34.19,0.49,68.8,70442,75,NULL,'IR','NGC 6969',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148265,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148265,32.65,0.8,33.9,70443,75,NULL,'MAT, I','IC 5026',NULL,'1997ApJS..109..333W',1997,1,2.8,'da Costa et al. (1991,ApJS, 75, 935) give v=15+/-32. Superimposed star.','G',0.000033,NULL,'15.42',0.24,'Sc',NULL,NULL,NULL,NULL,1,312.116875,-78.06925,0.433,NULL,48580699985,759073437,11860522,15.42),(148266,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148266,32.46,0.32,31,70443,85,NULL,'I, inv','IC 5026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148267,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148267,32.46,0.32,31.1,70443,85,NULL,'I, raw','IC 5026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148268,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148268,32.62,0.43,33.4,70443,75,NULL,'MAT, I, raw','IC 5026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148269,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148269,32.63,0.39,33.6,70443,73,NULL,'opt','IC 5026',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148270,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148270,32.64,0.4,33.7,70443,75,NULL,NULL,'IC 5026',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148271,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148271,32.64,0.39,33.7,70443,73,NULL,'IR','IC 5026',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148272,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148272,32.65,0.43,33.8,70443,75,NULL,'MAT, I, inv','IC 5026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148273,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148273,32.74,0.4,35.3,70443,73,NULL,'opt','IC 5026',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148274,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148274,32.76,0.48,35.6,70443,NULL,NULL,NULL,'IC 5026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148275,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148275,32.8,0.2,36.3,70443,74.4,NULL,NULL,'IC 5026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148276,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148276,32.83,0.46,36.7,70443,NULL,NULL,'Malmquist cor.','IC 5026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148277,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148277,32.82,0.49,36.7,70443,75,NULL,'IR','IC 5026',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148278,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148278,32.89,NULL,37.8,70443,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 5026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148279,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148279,32.89,NULL,37.9,70443,NULL,NULL,'Dipole + Quadrupole','IC 5026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148280,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148280,32.9,NULL,38.1,70443,NULL,NULL,'Dipole','IC 5026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148281,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148281,32.92,0.43,38.3,70443,75,NULL,'MAT, I, cor','IC 5026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148282,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148282,32.99,NULL,39.6,70443,NULL,NULL,NULL,'IC 5026',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148283,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148283,35.89,0.48,151,70444,70,NULL,NULL,'2MASX J20483442-4729244',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'16.16',0.3,'(R)SA0^+',NULL,NULL,NULL,NULL,1,312.143583,-47.49014,0.069,NULL,51394437736,803038089,12547470,16.16),(148284,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148284,38.33,0.46,464,70445,70,NULL,NULL,'2MASX J20483778-0613056',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.0001,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,312.157417,-6.21825,0.205,NULL,50793657899,793650904,12400795,17.5),(148285,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148285,34.79,0.49,90.6,70446,75,NULL,'IR','FGC 2288',NULL,'2011yCatp016004901K',2011,1,2.08,NULL,'G',0.00015,NULL,'16.1',0.1,'Sd',NULL,NULL,NULL,NULL,1,312.1602083,-17.24175,0.177,NULL,50993778350,796777786,12449652,16.1),(148286,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148286,36.15,0.54,170,70447,70,NULL,NULL,'FAIRALL 0566',NULL,'2014MNRAS.445.2677S',2014,1,0.44,'1983MNRAS.203...47F has V = 17,600 +- 100.','G',0.00015,NULL,'16.27',0.32,NULL,NULL,NULL,NULL,NULL,1,312.165833,-49.79678,0,NULL,51348146554,802314789,12536168,16.27),(148287,'D-Sigma','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148287,32.35,0.4,29.5,70448,75,NULL,'Edat, raw','NGC 6958',NULL,'1997ApJS..109..333W',1997,1,2.1,'+4m 16s, +0.6m error in A-M position.','G',0.000043,NULL,'12.33',1.7,'E+          Sy;LINER','Isolated elliptical galaxy',NULL,NULL,NULL,1,312.1774583,-37.99742,0.093,NULL,51512133233,804877081,12576204,12.33),(148288,'D-Sigma','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148288,32.69,0.4,34.4,70448,75,NULL,'Edat, cor','NGC 6958',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148289,'Faber-Jackson','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148289,30.98,0.65,15.7,70448,95,NULL,'Weighted Mean','NGC 6958',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148290,'Faber-Jackson','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148290,32.19,0.81,27.4,70448,55,NULL,'Visvanathan & Sandage 1979','NGC 6958',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148291,'Tully est','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148291,32.74,0.8,35.4,70448,75,NULL,'B','NGC 6958',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148292,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148292,32.76,0.45,35.7,70448,NULL,NULL,'K','NGC 6958',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148293,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148293,32.8,0.4,36.4,70448,NULL,NULL,'mean','NGC 6958',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148294,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 02482','RN',148294,41.76,0.18,1540,70449,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02482',0.465715,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148295,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 18933',NULL,148295,39.96,0.33,982,70450,70,NULL,'SN photometric redshift distance, z photo =0.263 +/- 0.051','SDSS-II SN 18933',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','20.7g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,312.1960417,0.65997,0.357,NULL,53969288735,843270136,13176095,20.7),(148296,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148296,35.99,0.46,158,70451,70,NULL,NULL,'2MASX J20484709-0659396',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000057,NULL,'15.3g',0.45,'HII',NULL,NULL,NULL,NULL,1,312.196125,-6.99439,0.285,NULL,50793362664,793646291,12400723,15.3),(148297,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148297,36.24,0.46,177,70452,NULL,NULL,NULL,'2MASX J20484768-5223327',NULL,'2009ApJS..182..474S',2009,1,0.42,NULL,'G',0.000033,NULL,'16.49',0.22,'Sb','Group member',NULL,NULL,NULL,1,312.198667,-52.39239,0.033,NULL,51071516005,797992437,12468631,16.49),(148298,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148298,36.26,0.46,178,70452,NULL,NULL,'Malmquist cor.','2MASX J20484768-5223327',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148299,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148299,36.28,0.2,180,70452,74.4,NULL,NULL,'2MASX J20484768-5223327',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148300,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005fn',NULL,148300,37.36,0.04,271,70453,70,NULL,'SDSS-II SN 02102','SDSS J204853.04+001129.8',0.095,'2011ApJS..192....1C',2011,1,0.08,NULL,'G',NULL,NULL,'20.5g',0.05,NULL,NULL,NULL,NULL,NULL,1,312.2210417,0.19161,0.365,NULL,53969215524,843268992,13176078,20.5),(148301,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005fn',NULL,148301,37.46,0.12,284,70453,74.2,NULL,'SALT 2','SDSS J204853.04+001129.8',0.095,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148302,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 02102','R',148302,38.26,0.19,408,70453,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fn','SDSS J204853.04+001129.8',0.1,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148303,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005fn',NULL,148303,38.26,0.13,409,70453,70,NULL,'SDSS-II SN 02102, SALT 2','SDSS J204853.04+001129.8',0.095,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148304,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 02102','R',148304,38.41,0.07,437,70453,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fn','SDSS J204853.04+001129.8',0.1,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148305,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148305,36.18,0.46,172,70454,70,NULL,NULL,'2MASX J20485459-0049167',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00015,NULL,'16.2g',0.39,'E0',NULL,NULL,NULL,NULL,1,312.2275417,-0.82139,0.269,NULL,47797056039,746829000,11669203,16.2),(148306,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148306,37.03,0.57,255,70454,70,NULL,NULL,'2MASX J20485459-0049167',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148307,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148307,34.39,0.4,75.5,70455,NULL,NULL,'mean','UGC 11642',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',NULL,NULL,'16.0',0.3,'S?',NULL,NULL,NULL,NULL,1,312.2297917,70.23192,1.313,NULL,53634985840,838046653,13094478,16),(148308,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148308,34.52,0.47,80.1,70455,NULL,NULL,'H','UGC 11642',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148309,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148309,34.63,0.45,84.2,70455,NULL,NULL,'K','UGC 11642',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148310,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148310,34.63,0.46,84.2,70455,NULL,NULL,'J','UGC 11642',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148311,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148311,36.98,0.8,249,70456,70,NULL,NULL,'2MASX J20490151-3858165',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.82',0.38,NULL,NULL,NULL,NULL,NULL,1,312.256333,-38.97128,0.089,NULL,51514431661,804912994,12576765,16.82),(148312,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 14430',NULL,148312,39.93,0.35,969,70457,70,NULL,'SN photometric redshift distance, z photo =0.259 +/- 0.055','SDSS-II SN 14430',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.8g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,312.273417,-1.24019,0.221,NULL,47796950029,746827344,11669177,21.8),(148313,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148313,36.43,0.69,193,70458,70,NULL,NULL,'2MASX J20491587-5345163',NULL,'2014MNRAS.445.2677S',2014,1,0.31,NULL,'G',0.00015,NULL,'17.2b',0.19,NULL,NULL,NULL,NULL,NULL,1,312.316,-53.75458,0.093,NULL,51073793060,798028016,12469187,17.2),(148314,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148314,36.88,0.53,237,70459,70,NULL,NULL,'2MFGC 15770',NULL,'2014MNRAS.445.2677S',2014,1,0.74,NULL,'G',0.00015,NULL,'16.51',0.17,NULL,NULL,NULL,NULL,NULL,1,312.333875,-47.61183,0.073,NULL,51349077348,802329333,12536395,16.51),(148315,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148315,35.58,0.61,131,70460,70,NULL,NULL,'2MASX J20492169-5126424',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.4b',0.25,'S',NULL,NULL,NULL,NULL,1,312.3405,-51.44514,0.025,NULL,51340638570,802197477,12534335,16.4),(148316,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148316,37.22,0.58,278,70461,70,NULL,NULL,'AM 2045-521',NULL,'2014MNRAS.445.2677S',2014,1,0.98,NULL,'G',0.00015,NULL,'16.3b',0.3,'S0','Group member',NULL,NULL,NULL,1,312.344167,-52.0015,0.025,NULL,51340443754,802194433,12534288,16.3),(148317,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148317,39.02,0.46,636,70462,70,NULL,NULL,'SDSS J204923.35-061143.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000099,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,312.347333,-6.19544,0.273,NULL,50793564148,793649439,12400772,18.5),(148318,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148318,37.78,0.46,360,70463,70,NULL,NULL,'SDSS J204924.48+011502.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,312.352,1.25061,0.453,NULL,53969639444,843275616,13176181,18.3),(148319,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148319,37.19,1.02,274,70464,70,NULL,NULL,'2MASX J20492595-1947303',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,312.358166667,-19.79172,0.425,NULL,50948007557,796062618,12438478,15.4),(148320,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148320,36.9,0.85,240,70465,70,NULL,NULL,'2MASX J20492915-5512175',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.000097,NULL,'15.81',0.57,'(R\')SB(r)a',NULL,NULL,NULL,NULL,1,312.371417,-55.20483,0.181,NULL,48993277969,765519968,11961249,15.81),(148321,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 18596','R',148321,36.98,0.04,242,70466,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2007ld','SDSS J204929.40+000016.8',0.03,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,312.3725,0.00467,0.361,NULL,53957648618,843088259,13173254,NULL),(148322,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 18596','R',148322,37.41,0.54,294,70466,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2007ld','SDSS J204929.40+000016.8',0.03,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148323,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2007ld',NULL,148323,35,0.09,97,70466,NULL,NULL,'SCM 55 SNII','SDSS J204929.40+000016.8',0.03,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148324,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2007ld',NULL,148324,35.37,0.11,115,70466,NULL,NULL,'SCM 15 SDSS SNII','SDSS J204929.40+000016.8',0.03,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148325,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148325,32.42,0.49,30.5,70467,75,NULL,'IR','FGC 2574',NULL,'2011yCatp016004901K',2011,1,2.1,NULL,'G',0.000007,NULL,'15.7',0.2,'Sm',NULL,NULL,NULL,NULL,1,312.3864583,58.1065,NULL,NULL,53428386074,834818532,13044039,15.7),(148326,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148326,32.51,0.4,31.7,70467,75,NULL,NULL,'FGC 2574',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148327,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148327,33.55,NULL,51.2,70467,NULL,NULL,'Dipole','FGC 2574',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148328,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148328,33.55,NULL,51.3,70467,NULL,NULL,'Dipole + Quadrupole','FGC 2574',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148329,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148329,33.56,NULL,51.5,70467,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2574',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148330,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 18241','R',148330,38.33,0.22,422,70468,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ks','SDSS J204933.01-004543.0',0.095,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,312.3875417,-0.76194,0.269,NULL,47783477566,746616836,11665888,NULL),(148331,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2007ks',NULL,148331,38.14,0.35,424,70468,70,NULL,'Hubble residual 0.20 for z0.09500','SDSS J204933.01-004543.0',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148332,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 18241','R',148332,38.61,0.1,481,70468,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ks','SDSS J204933.01-004543.0',0.095,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148333,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 01713','RN',148333,42.94,0.22,2620,70469,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01713',0.47519,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148334,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148334,33.9,0.69,60.2,70470,100,NULL,'mid-IR','UGC 11638',NULL,'2013ApJ...771...88L',2013,1,2,NULL,'G',0.000017,NULL,'13.84',1.3,'SBb:',NULL,NULL,NULL,NULL,1,312.401917,16.86558,0.333,NULL,55291054195,863922721,13498792,13.84),(148335,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148335,34.08,0.47,65.6,70470,NULL,NULL,'H','UGC 11638',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148336,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148336,34.13,0.46,67,70470,NULL,NULL,'J','UGC 11638',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148337,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148337,34.16,0.45,67.9,70470,NULL,NULL,'K','UGC 11638',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148338,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148338,34.31,0.4,72.9,70470,NULL,NULL,'mean','UGC 11638',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148339,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 20430','R',148339,39.53,0.22,692,70471,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007qj','SN 2007qj',0.164,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,312.416833,0.46864,0.357,NULL,53957806627,843090728,13173292,NULL),(148340,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 20430','R',148340,39.83,0.14,795,70471,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007qj','SN 2007qj',0.164,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148341,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 17170','RN',148341,40.32,0.25,950,70472,70,NULL,'SDSS CAND. SNIb; SALT 2','SDSS-II SN 17170',0.22,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148342,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 17170','RN',148342,40.56,0.21,1060,70472,70,NULL,'SDSS CAND. SNIb; MLCS2K2','SDSS-II SN 17170',0.22,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148343,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148343,35.52,0.45,127,70473,NULL,NULL,'Malmquist cor.','AM 2046-520 NED01',NULL,'2009ApJS..182..474S',2009,1,0.93,NULL,'G',0.000023,NULL,'15.57',0.23,'Sc','Group member',NULL,NULL,NULL,1,312.4357083,-51.94958,0.025,NULL,51341298582,802207790,12534496,15.57),(148344,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148344,35.57,0.44,130,70473,NULL,NULL,NULL,'AM 2046-520 NED01',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148345,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148345,35.61,0.2,132,70473,74.4,NULL,NULL,'AM 2046-520 NED01',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148346,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148346,36.88,0.55,238,70474,70,NULL,NULL,'2MASX J20495029-4324345',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'15.66',0.63,'E',NULL,NULL,NULL,NULL,1,312.459583,-43.40964,0.065,NULL,51389812650,802965822,12546340,15.66),(148347,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148347,35.82,0.52,146,70475,NULL,NULL,NULL,'2MFGC 15783',NULL,'2009ApJS..182..474S',2009,1,0.56,NULL,'G',0.000033,NULL,'16.3V',0.14,'Sd/I','Group member',NULL,NULL,NULL,1,312.4629583,-52.92,0.061,NULL,51073532491,798023945,12469124,16.3),(148348,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148348,35.86,0.2,149,70475,74.4,NULL,NULL,'2MFGC 15783',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148349,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148349,35.93,0.49,154,70475,NULL,NULL,'Malmquist cor.','2MFGC 15783',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148350,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148350,35.98,0.49,157,70475,75,NULL,'IR','2MFGC 15783',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148351,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148351,34.38,0.8,75.1,70476,75,NULL,'MAT, I','MCG -01-53-012',NULL,'1997ApJS..109..333W',1997,1,1.99,NULL,'G',0.000023,NULL,'15.2g',0.35,'Sb(f)',NULL,NULL,NULL,NULL,1,312.467625,-7.02181,0.293,NULL,50797013064,793703329,12401614,15.2),(148352,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148352,34.2,NULL,69.3,70476,NULL,NULL,'Dipole','MCG -01-53-012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148353,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148353,34.22,NULL,69.8,70476,NULL,NULL,'Dipole + Quadrupole','MCG -01-53-012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148354,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148354,34.23,NULL,70.1,70476,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -01-53-012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148355,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148355,34.55,0.49,81.4,70476,75,NULL,'IR','MCG -01-53-012',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148356,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148356,34.61,0.4,83.6,70476,NULL,NULL,'mean','MCG -01-53-012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148357,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148357,34.7,0.47,86.9,70476,NULL,NULL,'H','MCG -01-53-012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148358,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148358,34.75,0.45,89.3,70476,NULL,NULL,'K','MCG -01-53-012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148359,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148359,34.88,0.46,94.5,70476,NULL,NULL,'J','MCG -01-53-012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148360,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148360,34.94,0.43,97.1,70476,75,NULL,'3.6 micron, color corrected','MCG -01-53-012',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148361,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148361,34.94,0.43,97.4,70476,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-53-012',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148362,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148362,34.99,0.43,99.3,70476,75,NULL,'MAT, I, raw','MCG -01-53-012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148363,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148363,35.01,0.2,100,70476,74.4,NULL,NULL,'MCG -01-53-012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148364,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148364,35.03,0.47,101,70476,NULL,NULL,'Malmquist cor.','MCG -01-53-012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148365,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148365,35.19,0.44,109,70476,NULL,NULL,NULL,'MCG -01-53-012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148366,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148366,35.22,0.43,111,70476,75,NULL,'MAT, I, cor','MCG -01-53-012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148367,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148367,35.31,0.32,115,70476,85,NULL,'I, raw','MCG -01-53-012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148368,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148368,35.31,0.43,115,70476,75,NULL,'MAT, I, inv','MCG -01-53-012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148369,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148369,35.38,0.32,119,70476,85,NULL,'I, inv','MCG -01-53-012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148370,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148370,37.59,0.46,330,70477,70,NULL,NULL,'2MASX J20495263+0040058',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000138,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,312.469125,0.66833,0.405,NULL,53958481198,843101268,13173457,17.6),(148371,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148371,38.13,0.46,423,70478,70,NULL,NULL,'2MASX J20495315-0628516',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000086,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,312.471375,-6.48097,0.297,NULL,50793761993,793652531,12400820,18.2),(148372,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148372,36.66,0.46,215,70479,70,NULL,NULL,'2MASX J20495569+0053578',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000193,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,312.482125,0.89958,0.453,NULL,53958278604,843098103,13173407,16.6),(148373,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148373,35.72,0.62,140,70480,70,NULL,NULL,'2MASX J20500326-5247425',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00009,NULL,'15.1V',0.55,'E','Group member',NULL,NULL,NULL,1,312.513666667,-52.79503,0.061,NULL,51071460568,797991571,12468618,15.1),(148374,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148374,36.09,0.25,165,70480,74.4,NULL,NULL,'2MASX J20500326-5247425',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148375,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148375,39.14,0.46,673,70481,70,NULL,NULL,'SDSS J205007.74-000701.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000157,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,312.5322917,-0.11719,0.333,NULL,47782787041,746606047,11665719,18.6),(148376,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148376,36.81,0.65,230,70482,70,NULL,NULL,'2MASX J20500788-1130246',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.3b',0.3,NULL,NULL,NULL,NULL,NULL,1,312.532917,-11.50681,0.189,NULL,50759396998,793115578,12392430,16.3),(148377,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148377,36.94,0.93,244,70483,70,NULL,NULL,'2MASX J20501352-6828211',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,312.5562917,-68.47264,0.133,NULL,49381578173,771587158,12056049,16.7),(148378,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148378,35.79,0.51,144,70484,70,NULL,NULL,'2MASX J20501393-1847085',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.90',0.5,NULL,NULL,NULL,NULL,NULL,1,312.5582083,-18.78583,0.229,NULL,50990429314,796725458,12448835,15.9),(148379,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148379,35.47,0.58,124,70485,70,NULL,NULL,'ESO 597- G 041',NULL,'2014MNRAS.445.2677S',2014,1,2.5,NULL,'G',0.000013,NULL,'15',1.8,'SAB(rs)b pec:',NULL,NULL,NULL,NULL,1,312.5624583,-19.42594,0.377,NULL,50947510512,796054851,12438357,15),(148380,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 15293',NULL,148380,40.97,0.4,1560,70486,70,NULL,'SN photometric redshift distance, z photo =0.466 +/- 0.134','SDSS-II SN 15293',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','23.0g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,312.578875,-0.78781,0.285,NULL,47782992696,746609260,11665769,23),(148381,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005hq',NULL,148381,41.02,0.21,1140,70487,74.2,NULL,'SALT 2','SDSS J205019.95-004930.7',0.401,'2010ApJ...716..712A',2010,1,0.05,NULL,'G',NULL,NULL,'22.5g',0.02,NULL,NULL,NULL,NULL,NULL,1,312.583125,-0.82519,0.285,NULL,47783001442,746609397,11665771,22.5),(148382,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 05821','R',148382,41.73,0.3,1580,70487,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2005hq','SDSS J205019.95-004930.7',0.41,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148383,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005hq',NULL,148383,41.81,0.23,1640,70487,70,NULL,'SALT 2','SDSS J205019.95-004930.7',0.401,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148384,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 05821','R',148384,42.08,0.36,1850,70487,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2005hq','SDSS J205019.95-004930.7',0.41,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148385,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 15386','R',148385,40.48,0.23,971,70488,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15386',0.2871,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,312.58475,-1.23258,0.249,NULL,47782874132,746607408,11665740,NULL),(148386,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 15386','R',148386,40.68,0.14,1060,70488,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15386',0.2871,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148387,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005ht',NULL,148387,39.11,0.12,558,70489,74.2,NULL,'SALT 2','SDSS J205024.45-000957.3',0.19,'2010ApJ...716..712A',2010,1,0.06,NULL,'G',NULL,NULL,'19.3g',0.06,NULL,NULL,NULL,NULL,NULL,1,312.601875,-0.16594,0.333,NULL,47782740600,746605321,11665708,19.3),(148388,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005ht',NULL,148388,39.45,0.04,653,70489,70,NULL,'SDSS-II SN 05994','SDSS J205024.45-000957.3',0.19,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148389,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005ht',NULL,148389,39.85,0.09,783,70489,65,NULL,'SALT2','SDSS J205024.45-000957.3',0.19,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148390,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005ht',NULL,148390,39.86,0.13,789,70489,70,NULL,'SDSS-II SN 05994, SALT 2','SDSS J205024.45-000957.3',0.19,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148391,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 05994','R',148391,39.87,0.2,793,70489,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ht','SDSS J205024.45-000957.3',0.19,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148392,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005ht',NULL,148392,40.02,0.1,848,70489,65,NULL,'MLCS2k2','SDSS J205024.45-000957.3',0.19,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148393,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 05994','R',148393,40.07,0.1,869,70489,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ht','SDSS J205024.45-000957.3',0.19,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148394,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148394,36.37,0.37,188,70490,NULL,NULL,NULL,'2MASX J20502701-5203126',NULL,'2009ApJS..182..474S',2009,1,0.35,NULL,'G',0.000027,NULL,'17.17',0.19,'Sc','Group member',NULL,NULL,NULL,1,312.612375,-52.05347,0.037,NULL,51340781357,802199708,12534370,17.17),(148395,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148395,36.41,0.2,191,70490,74.4,NULL,NULL,'2MASX J20502701-5203126',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148396,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148396,36.44,0.36,194,70490,NULL,NULL,'Malmquist cor.','2MASX J20502701-5203126',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148397,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148397,35.62,0.25,133,70491,74.4,NULL,NULL,'FAIRALL 0567',NULL,'2013AJ....146...86T',2013,1,0.58,'Declination in 1997AJ....113..492C is 1.0 arcmin in error.','G',0.00009,NULL,'16.5b',0.35,'S0','Group member',NULL,NULL,NULL,1,312.625625,-52.9005,0.061,NULL,51071457419,797991522,12468617,16.5),(148398,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148398,36.31,0.53,183,70491,70,NULL,NULL,'FAIRALL 0567',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148399,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 12883','R',148399,40.55,0.3,988,70492,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006fr','SN 2006fr',0.307,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia?',NULL,NULL,NULL,NULL,1,312.625875,0.39869,0.397,NULL,53958607037,843103234,13173488,NULL),(148400,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 12883','R',148400,40.81,0.27,1110,70492,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006fr','SN 2006fr',0.307,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148401,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148401,38.99,0.46,629,70493,70,NULL,NULL,'SDSS J205030.93-001508.0',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000182,NULL,'19.0g',0.08,NULL,NULL,NULL,NULL,NULL,1,312.628875,-0.25225,0.333,NULL,47782737643,746605275,11665707,19),(148402,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148402,35.19,0.66,109,70494,70,NULL,NULL,'2MASX J20503133-5334556',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'15.87',0.38,'S',NULL,NULL,NULL,NULL,1,312.6305417,-53.58206,0.097,NULL,51073704143,798026627,12469166,15.87),(148403,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148403,35.58,0.58,131,70495,NULL,NULL,'Malmquist cor.','ESO 187- G 016',NULL,'2009ApJS..182..474S',2009,1,0.93,NULL,'G',0.000043,NULL,'15.5V',0.21,'Sb','Group member',NULL,NULL,NULL,1,312.636,-52.45594,0.041,NULL,51071519076,797992485,12468632,15.5),(148404,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148404,35.6,NULL,132,70495,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 187- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148405,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148405,35.64,NULL,135,70495,NULL,NULL,'Dipole + Quadrupole','ESO 187- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148406,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148406,35.68,0.56,136,70495,NULL,NULL,NULL,'ESO 187- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148407,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148407,35.68,NULL,137,70495,NULL,NULL,'Dipole','ESO 187- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148408,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148408,35.72,0.2,139,70495,74.4,NULL,NULL,'ESO 187- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148409,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005gh',NULL,148409,39.61,0.05,664,70496,70,NULL,'SDSS 3241','SDSS J205036.66-002115.2',0.25888,'2011ApJS..192....1C',2011,1,0.18,NULL,'G',0.00018,NULL,'19.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,312.652791667,-0.35422,0.333,NULL,47783428787,746616074,11665876,19.1),(148410,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005gh',NULL,148410,39.94,0.14,773,70496,74.2,NULL,'SALT 2','SDSS J205036.66-002115.2',0.25888,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148411,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 03241','R',148411,40.69,0.22,1090,70496,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2005gh','SDSS J205036.66-002115.2',0.25888,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148412,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005gh',NULL,148412,40.75,0.15,1120,70496,70,NULL,'SDSS 3241, SALT 2','SDSS J205036.66-002115.2',0.25888,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148413,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SN 2005gh',NULL,148413,40.83,0.2,1160,70496,72,NULL,'SDSS 3241','SDSS J205036.66-002115.2',0.25888,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148414,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 03241','R',148414,40.91,0.17,1210,70496,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2005gh','SDSS J205036.66-002115.2',0.25888,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148415,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SN 2005gh',NULL,148415,40.66,0.16,1360,70496,70,NULL,'SALT 2','SDSS J205036.66-002115.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148416,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SN 2005gh',NULL,148416,40.68,0.16,1370,70496,70,NULL,'SALT 2, Malmquist cor.','SDSS J205036.66-002115.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148417,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 01835','R',148417,40.44,0.3,965,70497,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01835',0.2716,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,312.664125,1.07186,0.453,NULL,53958366385,843099474,13173429,NULL),(148418,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 01835','R',148418,40.76,0.23,1110,70497,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01835',0.2716,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148419,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148419,36.27,0.55,179,70498,70,NULL,NULL,'2MASX J20504307-8028482',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,312.6792083,-80.48017,0.589,NULL,48574118377,758970599,11858915,16.7),(148420,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148420,36.28,0.42,180,70499,NULL,NULL,NULL,'AGC 600260',NULL,'2009ApJS..182..474S',2009,1,0.62,NULL,'G',0.000027,NULL,'16.24',0.29,'Sc','Group member',NULL,NULL,NULL,1,312.682833,-53.15789,0.081,NULL,51073557086,798024329,12469130,16.24),(148421,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148421,36.32,0.2,184,70499,74.4,NULL,NULL,'AGC 600260',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148422,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148422,36.41,0.39,191,70499,NULL,NULL,'Malmquist cor.','AGC 600260',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148423,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148423,36.91,0.89,241,70500,70,NULL,NULL,'2MASX J20504390-5919155',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,312.683125,-59.32092,0.241,NULL,49129533014,767648953,11994514,15.8),(148424,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 14014',NULL,148424,40.5,1.05,1260,70501,70,NULL,'SN photometric redshift distance, z photo =0.354 +/- 0.327','SDSS-II SN 14014',NULL,'2011ApJ...738..162S',2011,1,0.13,NULL,'G',NULL,'PHOT','20.5g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,312.694625,-1.14219,0.249,NULL,47783064581,746610384,11665787,20.5),(148425,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148425,35.79,0.56,144,70502,NULL,NULL,NULL,'2MASX J20504929-5256061',NULL,'2009ApJS..182..474S',2009,1,0.58,NULL,'G',0.000033,NULL,'16.5V',0.16,'Sd','Group member',NULL,NULL,NULL,1,312.7057917,-52.93492,0.085,NULL,51073543726,798024120,12469126,16.5),(148426,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148426,35.83,0.2,147,70502,74.4,NULL,NULL,'2MASX J20504929-5256061',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148427,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148427,35.91,0.53,152,70502,NULL,NULL,'Malmquist cor.','2MASX J20504929-5256061',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148428,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,'R',148428,36.62,0.46,211,70503,70,NULL,NULL,'2MASX J20505080-0043507',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00015,NULL,'15.9g',0.42,'E0',NULL,NULL,NULL,NULL,1,312.711583,-0.73081,0.321,NULL,47783560158,746618127,11665908,15.9),(148429,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 16624','RN',148429,38.98,0.2,590,70504,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 16624',0.057096,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148430,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 16624','RN',148430,40.14,0.25,1010,70504,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 16624',0.057096,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148431,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,'R',148431,37.89,0.46,379,70505,70,NULL,NULL,'2MASX J20505798+0043587',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000168,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,312.741583333,0.73294,0.421,NULL,53958430398,843100474,13173444,17.2),(148432,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148432,36.29,0.46,181,70506,NULL,NULL,'Malmquist cor.','2MASX J20505989-5307251',NULL,'2009ApJS..182..474S',2009,1,0.68,NULL,'G',0.000027,NULL,'16.49',0.2,'Sd','Group member',NULL,NULL,NULL,1,312.749417,-53.12419,0.085,NULL,51073566517,798024476,12469132,16.49),(148433,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148433,36.47,0.42,197,70506,NULL,NULL,NULL,'2MASX J20505989-5307251',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148434,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148434,36.51,0.2,200,70506,74.4,NULL,NULL,'2MASX J20505989-5307251',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148435,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148435,35.5,0.57,126,70507,70,NULL,NULL,'2MASX J20510169-6238054',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,312.757,-62.63483,0.125,NULL,49176443903,768381935,12005967,17.1),(148436,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148436,36.31,0.42,183,70508,NULL,NULL,NULL,'AGC 600240',NULL,'2009ApJS..182..474S',2009,1,0.46,NULL,'G',0.00003,NULL,'15.50',0.18,'Sc','Group member',NULL,NULL,NULL,1,312.762917,-52.66589,0.049,NULL,51071448036,797991375,12468615,15.5),(148437,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148437,36.35,0.2,186,70508,74.4,NULL,NULL,'AGC 600240',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148438,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148438,36.42,0.4,192,70508,NULL,NULL,'Malmquist cor.','AGC 600240',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148439,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148439,36.23,0.43,176,70509,NULL,NULL,NULL,'AGC 600266',NULL,'2009ApJS..182..474S',2009,1,0.57,NULL,'G',0.000027,NULL,'17.1V',0.13,'Sc','Group member',NULL,NULL,NULL,1,312.771167,-52.75044,0.073,NULL,51071481636,797991900,12468623,17.1),(148440,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148440,36.27,0.2,179,70509,74.4,NULL,NULL,'AGC 600266',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148441,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148441,36.41,0.39,192,70509,NULL,NULL,'Malmquist cor.','AGC 600266',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148442,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148442,35.59,NULL,131,70510,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 187- G 019',NULL,'2010Ap&SS.325..163P',2010,1,1.66,NULL,'G',0.00004,NULL,'15.72',0.2,'Sb','Group member',NULL,NULL,NULL,1,312.777333333,-52.71258,0.073,NULL,51071480869,797991888,12468623,15.72),(148443,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148443,35.62,NULL,133,70510,NULL,NULL,'Dipole + Quadrupole','ESO 187- G 019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148444,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148444,35.66,NULL,135,70510,NULL,NULL,'Dipole','ESO 187- G 019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148445,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,'R',148445,35.83,0.49,146,70510,75,NULL,'IR','ESO 187- G 019',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148446,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148446,36.14,0.57,169,70510,NULL,NULL,'Malmquist cor.','ESO 187- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148447,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148447,36.51,0.09,201,70510,70,NULL,'ABELL 3716, BGC','ESO 187- G 019',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148448,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148448,36.62,0.46,210,70510,NULL,NULL,NULL,'ESO 187- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148449,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148449,36.66,0.2,215,70510,74.4,NULL,NULL,'ESO 187- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148450,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 08596','RN',148450,40.66,0.45,1220,70511,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08596',0.106755,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148451,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148451,36.57,0.38,206,70512,NULL,NULL,'Malmquist cor.','2MASX J20510833-5302391',NULL,'2009ApJS..182..474S',2009,1,0.47,NULL,'G',0.000037,NULL,'15.69',0.11,'I/S','Group member',NULL,NULL,NULL,1,312.78475,-53.04411,0.085,NULL,51073578728,798024667,12469135,15.69),(148452,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148452,36.7,0.35,219,70512,NULL,NULL,NULL,'2MASX J20510833-5302391',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148453,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148453,36.75,0.2,224,70512,74.4,NULL,NULL,'2MASX J20510833-5302391',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148454,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148454,34.28,0.2,71.8,70513,74.4,NULL,NULL,'ESO 529- G 009',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'13.57',0.2,'S              HII',NULL,NULL,NULL,NULL,1,312.793291667,-25.71383,0.229,NULL,51308623990,801697249,12526519,13.57),(148455,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148455,34.56,0.41,81.8,70513,NULL,NULL,NULL,'ESO 529- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148456,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148456,34.65,0.39,85.3,70513,NULL,NULL,'Malmquist cor.','ESO 529- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148457,'Brightest Stars','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148457,28.89,NULL,6,70514,NULL,NULL,NULL,'CEPHEUS 1',NULL,'2000A&A...362..544K',2000,1,11.7,NULL,'G',0.00001,NULL,'15.4B',1.5,'Sm?',NULL,NULL,NULL,NULL,1,312.794167,56.89028,NULL,NULL,53420939612,834702181,13042221,15.4),(148458,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SN 2007ph',NULL,148458,38.5,0.14,502,70515,70,NULL,'Hubble residual -0.07 for z0.12946','2MASX J20511361-0057276',NULL,'2011ApJ...740...92G',2011,1,0.23,NULL,'G',0.000177,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,312.806791667,-0.95778,0.285,NULL,47782931328,746608302,11665754,18.2),(148459,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 20350','R',148459,38.95,0.2,547,70515,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ph','2MASX J20511361-0057276',0.12939,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148460,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 20350','R',148460,39.05,0.1,572,70515,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ph','2MASX J20511361-0057276',0.12939,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148461,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 01757','R',148461,39.34,0.4,654,70515,70,NULL,'SDSS CAND. Variable; MLCS2K2; SN 2007ph','2MASX J20511361-0057276',0.129455,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148462,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 01757','R',148462,40.61,0.42,1170,70515,70,NULL,'SDSS CAND. Variable; SALT 2; SN 2007ph','2MASX J20511361-0057276',0.129455,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148463,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148463,36.1,0.25,166,70516,74.4,NULL,NULL,'2MASX J20511622-5241261',NULL,'2013AJ....146...86T',2013,1,0.49,NULL,'G',0.000107,NULL,'14.9V',0.4,'E','Group member',NULL,NULL,NULL,1,312.817375,-52.69069,0.073,NULL,51071445931,797991342,12468614,14.9),(148464,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148464,36.51,0.09,201,70517,70,NULL,NULL,'ABELL 3716',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I-II:  [BM];IR [A]',NULL,NULL,NULL,NULL,1,312.819625,-52.69542,0.073,NULL,51071445941,797991342,12468614,NULL),(148465,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148465,37.2,0.94,275,70518,70,NULL,NULL,'2MASX J20511805-5255251',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00008,NULL,'15.6V',0.15,'Sab','Group member',NULL,NULL,NULL,1,312.8252083,-52.92356,0.085,NULL,51071426668,797991041,12468610,15.6),(148466,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148466,36.68,0.25,217,70519,74.4,NULL,NULL,'2MASX J20511929-5240411',NULL,'2013AJ....146...86T',2013,1,0.52,NULL,'G',0.00015,NULL,'14.8V',0.43,'E','Group member',NULL,NULL,NULL,1,312.830166667,-52.67814,0.049,NULL,51071445817,797991340,12468614,14.8),(148467,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,'R',148467,36.4,0.46,190,70520,70,NULL,NULL,'2MASX J20511962+0047316',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,312.831667,0.792,0.421,NULL,53958319925,843098748,13173417,17.3),(148468,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148468,36.16,0.25,171,70521,74.4,NULL,NULL,'ESO 187- G 020',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000103,NULL,'13.8V',1,'S0- pec','Group member',NULL,NULL,NULL,1,312.8329583,-52.63625,0.049,NULL,51071444447,797991319,12468614,13.8),(148469,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148469,36.22,0.49,176,70521,70,NULL,NULL,'ESO 187- G 020',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148470,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 20474','R',148470,40.63,0.25,1060,70522,70,NULL,'SDSS CAND. Unknown; SALT 2; SN 2007rg','SN 2007rg',0.266,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia?',NULL,NULL,NULL,NULL,1,312.8344583,1.01889,0.441,NULL,53958309618,843098587,13173415,NULL),(148471,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 20474','R',148471,40.75,0.17,1110,70522,70,NULL,'SDSS CAND. Unknown; MLCS2K2; SN 2007rg','SN 2007rg',0.266,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148472,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 17351','R',148472,39.88,0.23,800,70523,70,NULL,'SDSS CAND. SNIb; SALT 2; SN 2007jy','SN 2007jy',0.182,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ib?',NULL,NULL,NULL,NULL,1,312.8392917,0.39939,0.429,NULL,53958635115,843103673,13173494,NULL),(148473,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 17351','R',148473,39.99,0.15,844,70523,70,NULL,'SDSS CAND. SNIb; MLCS2K2; SN 2007jy','SN 2007jy',0.182,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148474,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,'R',148474,39.15,0.46,677,70524,70,NULL,NULL,'2MASX J20512184-0616472',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000114,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,312.841,-6.27992,0.281,NULL,50796442094,793694407,12401475,17.8),(148475,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,'R',148475,38.17,0.17,430,70525,70,NULL,NULL,'SDSS J205123.13-000607.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000151,NULL,'19.0g',0.1,NULL,NULL,NULL,NULL,NULL,1,312.846375,-0.10194,0.361,NULL,47783426648,746616041,11665875,19),(148476,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148476,35.04,0.47,102,70526,NULL,NULL,'H','UGC 11643',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000033,NULL,'14.7',0.4,'SBb','Pair member (points to parent)',NULL,NULL,NULL,1,312.8579583,18.96781,0.317,NULL,55236371201,863068300,13485442,14.7),(148477,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148477,35.14,0.45,106,70526,NULL,NULL,'K','UGC 11643',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148478,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148478,35.22,0.46,111,70526,NULL,NULL,'J','UGC 11643',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148479,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148479,35.25,0.4,112,70526,NULL,NULL,'mean','UGC 11643',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148480,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,'R',148480,37.17,0.46,272,70527,70,NULL,NULL,'2MASX J20512656-0708052',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000061,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,312.860583333,-7.13481,0.209,NULL,50797209062,793706391,12401662,17.2),(148481,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,'R',148481,38.17,0.17,430,70528,70,NULL,NULL,'2MASX J20513513-0007160',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,312.896333,-0.12108,0.361,NULL,47783421839,746615966,11665874,18.5),(148482,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148482,36.1,0.69,166,70529,70,NULL,NULL,'2MASX J20513521-5251433',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000087,NULL,'15.6V',0.66,'Ep','Group member',NULL,NULL,NULL,1,312.896625,-52.86189,0.073,NULL,51071429294,797991082,12468610,15.6),(148483,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148483,36.41,0.25,191,70529,74.4,NULL,NULL,'2MASX J20513521-5251433',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148484,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,'R',148484,38.17,0.17,430,70530,70,NULL,NULL,'2MASX J20513673-0002580',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000183,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,312.903,-0.04944,0.361,NULL,47783151119,746611736,11665808,18.1),(148485,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,'R',148485,38.17,0.17,430,70531,70,NULL,NULL,'2MASX J20513826-0003210',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00015,NULL,'16.6g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,312.90925,-0.05589,0.361,NULL,47783151358,746611739,11665808,16.6),(148486,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148486,36.41,0.2,191,70532,74.4,NULL,NULL,'2MASX J20513989-5234534',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000087,NULL,'16.3V',0.24,'S0','Group member',NULL,NULL,NULL,1,312.916416667,-52.58131,0.049,NULL,51340688307,802198254,12534347,16.3),(148487,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148487,36.72,0.79,221,70533,70,NULL,NULL,'IC 5048',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.76',0.5,'SB(r)ab',NULL,NULL,NULL,NULL,1,312.919333,-71.80078,0.145,NULL,49327911907,770748623,12042947,15.76),(148488,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148488,36.13,0.44,168,70534,NULL,NULL,'Malmquist cor.','ESO 187- G 022',NULL,'2009ApJS..182..474S',2009,1,0.9,'Fairall (1983,MNRAS,203,47) gives v = 7550: +/- 100 km/sec.','G',0.000027,NULL,'14.4V',0.5,'SAB(r)0^+','Group member',NULL,NULL,NULL,1,312.919375,-52.60042,0.049,NULL,51340680052,802198125,12534345,14.4),(148489,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148489,36.37,0.39,188,70534,NULL,NULL,NULL,'ESO 187- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148490,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,'R',148490,38.49,0.46,500,70535,70,NULL,NULL,'2MASX J20514074+0052006',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000185,NULL,'18.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,312.9197917,0.86689,0.421,NULL,53958284724,843098198,13173409,18.1),(148491,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148491,36.67,0.74,216,70536,70,NULL,NULL,'2MFGC 15801',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,312.920833,-73.41967,0.201,NULL,49207783801,768871621,12013619,16.9),(148492,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 07547','RN',148492,37.91,0.08,345,70537,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 07547',0.106409,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148493,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 07547','RN',148493,39.5,0.18,717,70537,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 07547',0.106409,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148494,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148494,35.82,0.51,146,70538,70,NULL,NULL,'MCG -02-53-010',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000113,NULL,'17.5b',0.2,NULL,NULL,NULL,NULL,NULL,1,312.9244583,-12.20647,0.169,NULL,50755808836,793059513,12391554,17.5),(148495,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,'R',148495,38.17,0.17,430,70539,70,NULL,NULL,'2MASX J20514253-0010430',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00014,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,312.92725,-0.17853,0.361,NULL,47783420003,746615937,11665874,18.2),(148496,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,'R',148496,38.17,0.17,430,70540,70,NULL,NULL,'2MASX J20514272-0000220',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00014,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,312.9279583,-0.00614,0.397,NULL,47783150117,746611720,11665808,17.8),(148497,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148497,35.29,0.45,114,70541,NULL,NULL,NULL,'ESO 597- G 045',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.54',0.7,'Sc',NULL,NULL,NULL,NULL,1,312.936667,-18.33172,0.209,NULL,50994054306,796782098,12449720,14.54),(148498,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148498,35.33,0.2,116,70541,74.4,NULL,NULL,'ESO 597- G 045',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148499,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148499,35.51,0.41,126,70541,NULL,NULL,'Malmquist cor.','ESO 597- G 045',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148500,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,'R',148500,37.51,0.46,318,70542,70,NULL,NULL,'2MASX J20514503-0042550',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00015,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,312.9377083,-0.71539,0.321,NULL,47783357115,746614954,11665858,16.8),(148501,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148501,34.41,0.5,76.2,70543,70,NULL,NULL,'IC 5065',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000047,NULL,'14.58',0.9,'SB pec',NULL,NULL,NULL,NULL,1,312.940833,-29.84728,0.293,NULL,51495712396,804620506,12572195,14.58),(148502,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148502,36.17,0.25,171,70544,74.4,NULL,NULL,'2MASX J20514691-5247024',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.00013,NULL,'15.0V',0.39,'E','Group member',NULL,NULL,NULL,1,312.9457083,-52.78397,0.073,NULL,51071426121,797991033,12468609,15),(148503,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 13332','RN',148503,40.35,0.21,1020,70545,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 13332',0.14731,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148504,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 13332','RN',148504,40.65,0.24,1180,70545,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 13332',0.14731,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148505,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,'R',148505,38.04,0.46,405,70546,70,NULL,NULL,'SDSS J205147.56-004328.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000199,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,312.948166667,-0.72469,0.321,NULL,47783357479,746614960,11665858,18.5),(148506,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 10922','RN',148506,39.81,0.71,800,70547,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10922',0.146015,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148507,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148507,36.5,0.25,200,70548,74.4,NULL,NULL,'2MASX J20515121-5247424',NULL,'2013AJ....146...86T',2013,1,0.37,NULL,'G',0.000087,NULL,'15.9V',0.3,'S0','Group member',NULL,NULL,NULL,1,312.9635417,-52.79508,0.073,NULL,51071425725,797991026,12468609,15.9),(148508,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148508,35.7,0.58,138,70549,70,NULL,NULL,'2MASX J20515140-5324294',NULL,'2014MNRAS.445.2677S',2014,1,0.93,NULL,'G',0.00015,NULL,'15.87',0.43,'S0',NULL,NULL,NULL,NULL,1,312.9640417,-53.40814,0.101,NULL,51070340173,797974065,12468344,15.87),(148509,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148509,38.17,0.17,430,70550,70,NULL,NULL,'2MASX J20515220-0010430',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000138,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,312.967375,-0.17861,0.361,NULL,47783207280,746612613,11665822,17.9),(148510,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148510,35.4,0.25,120,70551,74.4,NULL,NULL,'ESO 187-IG 025 NED01',NULL,'2013AJ....146...86T',2013,1,1.15,NULL,'G',0.000143,NULL,'13.7V',0.42,'S0','Group member',NULL,NULL,NULL,1,312.969083333,-52.83092,0.073,NULL,51071434000,797991156,12468611,13.7),(148511,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 16103',NULL,148511,39.47,0.19,783,70552,70,NULL,NULL,'SDSS-II SN 16103',NULL,'2013MNRAS.434.1443X',2013,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,312.975167,-1.05017,0.285,NULL,47784850742,746638292,11666223,NULL),(148512,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 16103','R',148512,39.93,0.2,804,70552,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16103',0.2024,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148513,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 16103','R',148513,40.13,0.09,882,70552,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16103',0.2024,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148514,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148514,36.27,0.48,179,70553,NULL,NULL,'Malmquist cor.','2MASX J20515512-5149284',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000023,NULL,'15.31',0.42,'Sc','Group member',NULL,NULL,NULL,1,312.979667,-51.82456,0.033,NULL,51341344984,802208515,12534508,15.31),(148515,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148515,36.61,0.41,210,70553,NULL,NULL,NULL,'2MASX J20515512-5149284',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148516,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148516,36.65,0.2,214,70553,74.4,NULL,NULL,'2MASX J20515512-5149284',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148517,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148517,35.8,0.25,145,70554,74.4,NULL,NULL,'ESO 187-IG 025 NED02',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.00003,NULL,'14.4V',NULL,'E','Pair member (points to parent)',NULL,NULL,NULL,1,312.986875,-52.75303,0.073,NULL,51071423145,797990986,12468609,14.4),(148518,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148518,35.86,0.25,149,70555,74.4,NULL,NULL,'ESO 187-IG 025 NED03',NULL,'2013AJ....146...86T',2013,1,0.77,NULL,'G',0.000123,NULL,'14.2V',0.57,'D','Group member',NULL,NULL,NULL,1,312.99025,-52.80186,0.073,NULL,51071425170,797991018,12468609,14.2),(148519,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148519,36.67,0.77,216,70556,70,NULL,NULL,'ESO 187- G 024',NULL,'2014MNRAS.445.2677S',2014,1,1.25,NULL,'G',0.00015,NULL,'16.13',0.2,'Sb:',NULL,NULL,NULL,NULL,1,312.99025,-54.48683,0.105,NULL,51070462884,797975982,12468374,16.13),(148520,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148520,36.15,0.25,170,70557,74.4,NULL,NULL,'2MASX J20515920-5235063',NULL,'2013AJ....146...86T',2013,1,0.37,NULL,'G',0.00009,NULL,'16.1V',0.18,'S0','Group member',NULL,NULL,NULL,1,312.996875,-52.585,0.049,NULL,51340686066,802198219,12534347,16.1),(148521,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148521,36.25,0.71,178,70558,70,NULL,NULL,'2MASX J20520030-5408356',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'16.23',0.57,'S0',NULL,NULL,NULL,NULL,1,313.0012917,-54.14328,0.097,NULL,51070654609,797978978,12468421,16.23),(148522,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148522,36.13,0.25,168,70559,74.4,NULL,NULL,'ESO 187-IG 025 NED04',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.00003,NULL,'13.6V',NULL,'E2','Pair member (points to parent)',NULL,NULL,NULL,1,313.001625,-52.75492,0.073,NULL,51071423208,797990987,12468609,13.6),(148523,'TRGB','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148523,28.7,0.1,5.5,70560,74.4,NULL,NULL,'IC 5052',NULL,'2013AJ....146...86T',2013,1,5.9,'The 2MASX position is for the eccentric bulge.','G',0.00001,NULL,'11.6B',0.8,'SBd: sp','Group member',NULL,NULL,NULL,1,313.023208333,-69.20164,0.169,NULL,49335666386,770869787,12044840,11.6),(148524,'TRGB','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148524,28.76,0.1,5.6,70560,NULL,NULL,'I','IC 5052',NULL,'2011ApJS..195...18R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148525,'TRGB','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148525,28.75,0.07,5.62,70560,NULL,NULL,NULL,'IC 5052',NULL,'2006astro.ph..3457T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148526,'TRGB','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148526,28.9,0.04,6.03,70560,NULL,NULL,NULL,'IC 5052',NULL,'2005AJ....129.1331S',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148527,'IRAS','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148527,29.17,0.8,6.81,70560,75,NULL,'A82, H','IC 5052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148528,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148528,29.11,0.4,6.7,70560,75,NULL,'B','IC 5052',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148529,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148529,29.73,0.47,8.84,70560,75,NULL,'A82, H, inv','IC 5052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148530,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148530,29.86,0.47,9.39,70560,75,NULL,'A82, H, raw','IC 5052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148531,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148531,30.17,0.47,10.8,70560,75,NULL,'A82, H, cor','IC 5052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148532,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148532,34.85,0.56,93.2,70561,70,NULL,NULL,'2MASX J20520164-1328568',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.9b',0.3,NULL,NULL,NULL,NULL,NULL,1,313.0067917,-13.48256,0.145,NULL,50981717589,796589337,12446708,15.9),(148533,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148533,36.05,0.56,163,70562,70,NULL,NULL,'2MASX J20520220-3805597',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00015,NULL,'15.49',0.4,'S',NULL,NULL,NULL,NULL,1,313.0092083,-38.09992,0.089,NULL,51512067865,804876060,12576188,15.49),(148534,'Faber-Jackson','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148534,32.08,0.63,26.1,70563,95,NULL,'Michard 1979b, c','IC 5063',NULL,'1984ApJS...56...91D',1984,1,2.1,NULL,'G',0.00002,NULL,'12.89',1.4,'SA(s)0+:       Sy2','Pair member, radial velocity confirmed',NULL,NULL,'Sy 1 h',1,313.00975,-57.06878,0.237,NULL,49138502164,767789096,11996704,12.89),(148535,'Faber-Jackson','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148535,32.13,0.37,26.7,70563,95,NULL,'Weighted Mean','IC 5063',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148536,'Faber-Jackson','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148536,32.57,0.46,32.7,70563,95,NULL,'Michard 1979a','IC 5063',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148537,'Faber-Jackson','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148537,33.83,0.81,58.3,70563,55,NULL,'Visvanathan & Sandage 1979','IC 5063',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148538,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148538,32.87,0.45,37.5,70563,NULL,NULL,'K','IC 5063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148539,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148539,33.31,0.4,45.9,70563,NULL,NULL,'mean','IC 5063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148540,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 05595',NULL,148540,39.29,0.45,720,70564,70,NULL,'SN photometric redshift distance, z photo =0.185 +/- 0.049','SDSS-II SN 05595',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','22.4g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,313.0192917,-0.10242,0.361,NULL,47783211900,746612685,11665823,22.4),(148541,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148541,37.64,0.46,338,70565,70,NULL,NULL,'SDSS J205206.03-002131.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000139,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,313.025167,-0.35867,0.361,NULL,47783284582,746613821,11665840,18.7),(148542,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 12844','R',148542,38.07,0.1,384,70566,70,NULL,'SDSS CAND. SNIc; MLCS2K2; SN 2006fe','SN 2006fe',0.070498,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,313.038167,-0.51111,0.349,NULL,47783255677,746613369,11665833,NULL),(148543,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 12844','R',148543,38.36,0.22,439,70566,70,NULL,'SDSS CAND. SNIc; SALT 2; SN 2006fe','SN 2006fe',0.070498,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148544,'IRAS','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148544,34.11,0.8,66.3,70567,75,NULL,'HMCL, I','NGC 6970',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000087,NULL,'13.16',0.9,'Sbc pec','Group non-member, background',NULL,NULL,NULL,1,313.039417,-48.77778,0.029,NULL,51349513270,802336144,12536502,13.16),(148545,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148545,33.18,0.4,43.3,70567,75,NULL,'HMCL, I, raw','NGC 6970',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148546,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148546,33.35,0.4,46.7,70567,75,NULL,'HMCL, I, inv','NGC 6970',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148547,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148547,33.52,0.4,50.6,70567,75,NULL,'HMCL, I, cor','NGC 6970',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148548,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148548,35.98,0.25,157,70568,74.4,NULL,NULL,'ESO 187-IG 025 NED05',NULL,'2013AJ....146...86T',2013,1,0.55,NULL,'G',0.000083,NULL,'14.2V',0.52,'E','Group member',NULL,NULL,'Flat-Spectrum Radio Source',1,313.0397917,-52.79597,0.073,NULL,51071425461,797991022,12468609,14.2),(148549,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148549,35.99,0.46,158,70568,70,NULL,NULL,'ESO 187-IG 025 NED05',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148550,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148550,36.59,0.69,208,70569,70,NULL,NULL,'2MASX J20521357-5318108',NULL,'2014MNRAS.445.2677S',2014,1,0.85,NULL,'G',0.00015,NULL,'16.06',0.37,'S0',NULL,NULL,NULL,NULL,1,313.056708333,-53.303,0.097,NULL,51070139748,797970933,12468295,16.06),(148551,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148551,36.27,0.52,180,70570,70,NULL,NULL,'2MASX J20521491-4305160',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,313.062,-43.08775,0.061,NULL,51390523805,802976934,12546514,15.7),(148552,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148552,35.51,0.62,126,70571,NULL,NULL,NULL,'2MASX J20521648-5145368',NULL,'2009ApJS..182..474S',2009,1,0.48,NULL,'G',0.000033,NULL,'16.52',0.29,'Sb','Group member',NULL,NULL,NULL,1,313.068833333,-51.76028,0.033,NULL,51341419017,802209672,12534526,16.52),(148553,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148553,35.55,0.2,129,70571,74.4,NULL,NULL,'2MASX J20521648-5145368',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148554,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148554,35.59,0.6,131,70571,NULL,NULL,'Malmquist cor.','2MASX J20521648-5145368',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148555,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148555,36.28,0.59,180,70572,NULL,NULL,'Malmquist cor.','2MASX J20521837-5157518',NULL,'2009ApJS..182..474S',2009,1,0.93,NULL,'G',0.000033,NULL,'15.92',0.28,'Sc','Group member',NULL,NULL,NULL,1,313.076583,-51.96447,0.033,NULL,51341313438,802208022,12534500,15.92),(148556,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148556,36.67,0.49,216,70572,NULL,NULL,NULL,'2MASX J20521837-5157518',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148557,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148557,36.71,0.2,220,70572,74.4,NULL,NULL,'2MASX J20521837-5157518',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148558,'SNII optical','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2002fa',NULL,148558,37.03,0.54,255,70573,NULL,NULL,'SCM, I','NEAT J205221.51+020841.9',NULL,'2010ApJ...715..833O',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,313.089625,2.14497,0.425,NULL,53957569558,843087024,13173234,NULL),(148559,'SNII optical','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2002fa',NULL,148559,37.16,0.29,270,70573,NULL,NULL,'SCM, BVI','NEAT J205221.51+020841.9',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148560,'SNII optical','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2002fa',NULL,148560,37.16,0.55,270,70573,NULL,NULL,'SCM, V','NEAT J205221.51+020841.9',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148561,'SNII optical','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2002fa',NULL,148561,37.23,0.44,279,70573,NULL,NULL,'SCM, B','NEAT J205221.51+020841.9',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148562,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148562,37.36,0.62,297,70574,70,NULL,NULL,'FGCE 1531',NULL,'2014MNRAS.445.2677S',2014,1,0.84,NULL,'G',0.00015,NULL,'16.7b',0.15,'Sbc',NULL,NULL,NULL,NULL,1,313.092541667,-49.53019,0,NULL,51347989473,802312335,12536130,16.7),(148563,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 01998',NULL,148563,41.43,0.14,1930,70575,70,NULL,'SN photometric redshift distance, z photo =0.625 +/- 0.063','SDSS-II SN 01998',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','20.2g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,313.097417,0.56433,0.421,NULL,53958010913,843093920,13173342,20.2),(148564,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2007kb',NULL,148564,39.24,0.1,705,70576,70,NULL,'Hubble residual 0.45 for z0.14450','SDSS-II SN 17568 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,313.10325,0.27747,0.429,NULL,53958088594,843095134,13173361,NULL),(148565,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 17568','R',148565,39.73,0.23,776,70576,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007kb','SDSS-II SN 17568 HOST',0.138,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148566,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 17568','R',148566,39.82,0.14,810,70576,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007kb','SDSS-II SN 17568 HOST',0.138,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148567,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148567,36.59,0.74,208,70577,70,NULL,NULL,'2MASX J20522659-5200419',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.89',0.25,'S0','Group member',NULL,NULL,NULL,1,313.110667,-52.01161,0.037,NULL,51341315522,802208055,12534500,16.89),(148568,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148568,36.4,0.69,191,70578,70,NULL,NULL,'2MASX J20522734-4242549',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.58',0.36,NULL,NULL,NULL,NULL,NULL,1,313.113875,-42.71525,0.069,NULL,51390299571,802973430,12546459,16.58),(148569,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148569,36.35,0.68,186,70579,70,NULL,NULL,'2MASX J20522950-5555277',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'15.85',0.57,'S0',NULL,NULL,NULL,NULL,1,313.122958333,-55.92436,0.213,NULL,48991832986,765497390,11960896,15.85),(148570,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148570,35.95,0.25,155,70580,74.4,NULL,NULL,'2MASX J20523438-5250448',NULL,'2013AJ....146...86T',2013,1,0.33,NULL,'G',0.000083,NULL,'16.4V',0.17,'S0','Group member',NULL,NULL,NULL,1,313.143125,-52.84583,0.073,NULL,51340643126,802197548,12534336,16.4),(148571,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148571,37.07,0.21,259,70581,70,NULL,NULL,'2MASX J20523462-0058599',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000196,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,313.144375,-0.98319,0.337,NULL,47785536140,746649002,11666390,16.9),(148572,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148572,37.06,0.57,258,70582,70,NULL,NULL,'2MASX J20523663-4310479',NULL,'2014MNRAS.445.2677S',2014,1,0.14,NULL,'G',0.00015,NULL,'20.28',0.09,NULL,NULL,NULL,NULL,NULL,1,313.152583,-43.18006,0.065,NULL,51390577704,802977776,12546527,20.28),(148573,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 15199','R',148573,38.96,0.17,436,70583,70,NULL,'SDSS CAND. Variable; MLCS2K2; SN 2007oh','SDSS J205236.96-002715.0',0.4199,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',0.0005,NULL,'23.5g',0.02,NULL,NULL,NULL,NULL,NULL,1,313.154,-0.45419,0.361,NULL,47783266734,746613542,11665836,23.5),(148574,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 15199','R',148574,39.74,0.26,625,70583,70,NULL,'SDSS CAND. Variable; SALT 2; SN 2007oh','SDSS J205236.96-002715.0',0.4199,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148575,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2007oh',NULL,148575,41.02,0.24,1600,70583,70,NULL,'Hubble residual 0.22 for z0.41990','SDSS J205236.96-002715.0',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148576,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 19211','R',148576,42.08,0.36,1860,70583,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007oh','SDSS J205236.96-002715.0',0.404,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148577,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 19211','R',148577,42.11,0.32,1880,70583,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007oh','SDSS J205236.96-002715.0',0.404,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148578,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148578,37.07,0.21,259,70584,70,NULL,NULL,'2MASX J20524168-0058369',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00015,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,313.173833,-0.977,0.337,NULL,47785537737,746649027,11666391,16.4),(148579,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148579,35.37,0.58,119,70585,70,NULL,NULL,'2MASX J20524437-6851555',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7b',NULL,'(RL)SA(rl)0^0',NULL,NULL,NULL,NULL,1,313.184875,-68.86533,0.141,NULL,49335606146,770868846,12044825,15.7),(148580,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148580,35.98,0.42,157,70586,NULL,NULL,'Malmquist cor.','ESO 235- G 009',NULL,'2009ApJS..182..474S',2009,1,1.2,'Fairall (1984,MNRAS,210,69) gives v = 1500 +/- 200 km/sec.','G',0.00003,NULL,'14.85',0.6,'SB(r)0/a','Group member',NULL,NULL,NULL,1,313.1897083,-52.16444,0.037,NULL,51340851863,802200810,12534387,14.85),(148581,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148581,36.19,0.49,173,70586,NULL,NULL,'Malmquist cor.','ESO 235- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148582,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148582,36.21,0.37,174,70586,NULL,NULL,NULL,'ESO 235- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148583,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148583,36.5,0.42,200,70586,NULL,NULL,NULL,'ESO 235- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148584,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148584,36.54,0.2,203,70586,74.4,NULL,NULL,'ESO 235- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148585,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148585,36.28,0.41,180,70587,NULL,NULL,NULL,'2MASX J20524639-5304398',NULL,'2009ApJS..182..474S',2009,1,0.36,NULL,'G',0.000033,NULL,'16',0.22,'Sc','Group member',NULL,NULL,NULL,1,313.19325,-53.07775,0.085,NULL,51070123945,797970686,12468291,16),(148586,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148586,36.32,0.2,184,70587,74.4,NULL,NULL,'2MASX J20524639-5304398',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148587,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148587,36.4,0.39,191,70587,NULL,NULL,'Malmquist cor.','2MASX J20524639-5304398',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148588,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148588,36.95,0.52,246,70588,NULL,NULL,'Malmquist cor.','2MASX J20524746-5155158',NULL,'2009ApJS..182..474S',2009,1,0.46,NULL,'G',0.00003,NULL,'17.30',0.17,'Sa','Group member',NULL,NULL,NULL,1,313.19775,-51.92108,0.033,NULL,51341391327,802209239,12534519,17.3),(148589,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148589,37.35,0.43,295,70588,NULL,NULL,NULL,'2MASX J20524746-5155158',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148590,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148590,37.39,0.2,301,70588,74.4,NULL,NULL,'2MASX J20524746-5155158',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148591,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 05781',NULL,148591,39.11,0.79,663,70589,70,NULL,'SN photometric redshift distance, z photo =0.169 +/- 0.086','SDSS-II SN 05781',NULL,'2011ApJ...738..162S',2011,1,0.03,NULL,'G',NULL,'PHOT','23.4g',0.02,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,313.1982917,-1.09214,0.337,NULL,47785642694,746650667,11666416,23.4),(148592,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148592,38.04,0.46,405,70590,70,NULL,NULL,'2MASX J20525005+0053259',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,313.2087083,0.89061,0.429,NULL,53959654533,843119602,13173743,17.6),(148593,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148593,34.45,0.6,77.7,70591,NULL,NULL,'Malmquist cor.','ESO 235- G 010',NULL,'2009ApJS..182..474S',2009,1,0.88,NULL,'G',0.00003,NULL,'14',0.65,'SAB(rs)bc      Sy2','Group member',NULL,NULL,NULL,1,313.2477917,-51.86547,0.033,NULL,51341390484,802209226,12534519,14),(148594,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148594,34.46,0.6,78,70591,NULL,NULL,NULL,'ESO 235- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148595,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148595,34.27,0.49,71.4,70592,75,NULL,'IR','UGC 11644',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000057,NULL,'14.91',0.4,'SBb',NULL,NULL,NULL,NULL,1,313.260375,7.15958,0.373,NULL,55087109686,860736088,13449001,14.91),(148596,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148596,35.84,0.7,147,70593,70,NULL,NULL,'2MASX J20530408-5235149',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.0001,NULL,'14.8V',0.52,'E','Group member',NULL,NULL,NULL,1,313.266958333,-52.58736,0.049,NULL,51340691617,802198306,12534348,14.8),(148597,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148597,34.72,0.83,87.8,70594,NULL,NULL,NULL,'2MASX J20530661-5147539',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000033,NULL,'16.27',0.33,'SBb','Group member',NULL,NULL,NULL,1,313.277625,-51.79831,0.033,NULL,51341413327,802209583,12534524,16.27),(148598,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148598,34.85,0.78,93.4,70594,NULL,NULL,'Malmquist cor.','2MASX J20530661-5147539',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148599,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148599,32.86,0.43,37.3,70595,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11648',NULL,'2014MNRAS.444..527S',2014,1,1.4,NULL,'G',0.000017,NULL,'17.',0.3,'Im',NULL,NULL,NULL,NULL,1,313.2897083,67.17581,1.673,NULL,53684658852,838822794,13106606,17),(148600,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148600,33.12,0.49,42,70595,75,NULL,'IR','UGC 11648',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148601,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148601,37.8,0.46,363,70596,70,NULL,NULL,'SDSS J205313.71-070734.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000083,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,313.307167,-7.12619,0.201,NULL,50796293515,793692086,12401438,17.8),(148602,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148602,37.26,0.46,282,70597,70,NULL,NULL,'SDSS J205315.32-063429.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00011,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,313.313833,-6.57472,0.217,NULL,50795489764,793679527,12401242,18.6),(148603,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148603,36.17,0.73,171,70598,70,NULL,NULL,'2MASX J20531726-1608498',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.35',0.5,NULL,NULL,NULL,NULL,NULL,1,313.321875,-16.14731,0.245,NULL,51000766887,796886982,12451359,16.35),(148604,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 13408','RN',148604,41.59,0.4,1480,70599,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13408',0.408662,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148605,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 13408','RN',148605,42.6,0.35,2350,70599,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13408',0.408662,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148606,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148606,37.13,0.67,267,70600,70,NULL,NULL,'2MASX J20532656-1615408',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,313.360667,-16.26133,0.245,NULL,51000719426,796886241,12451347,14.4),(148607,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148607,37.47,0.46,311,70601,70,NULL,NULL,'SDSS J205330.61-062048.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000079,NULL,'18.8g',0.09,NULL,NULL,NULL,NULL,NULL,1,313.377583,-6.34675,0.217,NULL,50795639997,793681874,12401279,18.8),(148608,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148608,35.88,0.65,150,70602,70,NULL,NULL,'FAIRALL 0575',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00007,NULL,'16.76',0.19,'S0','Group member',NULL,NULL,NULL,1,313.390833333,-52.73156,0.073,NULL,51340644538,802197570,12534337,16.76),(148609,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148609,36.14,0.48,169,70602,NULL,NULL,NULL,'FAIRALL 0575',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148610,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148610,36.18,0.2,172,70602,74.4,NULL,NULL,'FAIRALL 0575',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148611,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148611,36.33,0.44,185,70602,NULL,NULL,'Malmquist cor.','FAIRALL 0575',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148612,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148612,35.59,0.51,131,70603,70,NULL,NULL,'2MASX J20533526-1430342',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000037,NULL,'15.71',0.8,NULL,NULL,NULL,NULL,NULL,1,313.396875,-14.50947,0.165,NULL,50980120206,796564378,12446318,15.71),(148613,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148613,37.07,0.21,259,70604,70,NULL,NULL,'2MASX J20533977-0037478',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.00015,NULL,'16.1g',0.38,'E0',NULL,NULL,NULL,NULL,1,313.415708333,-0.63003,0.345,NULL,47785391678,746646744,11666355,16.1),(148614,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148614,37.5,0.69,317,70604,70,NULL,NULL,'2MASX J20533977-0037478',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148615,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 20323',NULL,148615,38.26,1.16,449,70605,70,NULL,'SN photometric redshift distance, z photo =0.111 +/- 0.087','SDSS-II SN 20323',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,313.429125,1.14497,0.389,NULL,53959689966,843120155,13173752,NULL),(148616,'IRAS','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148616,33.75,0.8,56.3,70606,75,NULL,'MAT, I','IC 5054',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000033,NULL,'13.94',0.4,'(R\':)SAB(r)a','in an interacting pair',NULL,NULL,NULL,1,313.43925,-71.02475,0.149,NULL,49339162491,770924413,12045693,13.94),(148617,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148617,33.65,0.32,53.7,70606,85,NULL,'I, raw','IC 5054',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148618,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148618,33.68,0.47,54.4,70606,NULL,NULL,'H','IC 5054',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148619,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148619,33.71,0.32,55.1,70606,85,NULL,'I, inv','IC 5054',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148620,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148620,33.75,0.46,56.1,70606,NULL,NULL,'J','IC 5054',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148621,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148621,33.79,0.45,57.2,70606,NULL,NULL,'K','IC 5054',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148622,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148622,33.82,0.08,58.2,70606,NULL,NULL,NULL,'IC 5054',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148623,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148623,33.84,0.4,58.6,70606,NULL,NULL,'mean','IC 5054',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148624,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148624,34.23,0.43,70.2,70606,75,NULL,'MAT, I, raw','IC 5054',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148625,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148625,34.52,0.43,80.1,70606,75,NULL,'MAT, I, inv','IC 5054',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148626,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148626,34.54,0.43,80.7,70606,75,NULL,'MAT, I, cor','IC 5054',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148627,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148627,37.77,0.54,358,70607,70,NULL,NULL,'2MASX J20534556-5214166',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00013,NULL,'16.7b',0.34,'E/S0','Group member',NULL,NULL,NULL,1,313.44,-52.23794,0.041,NULL,51340726354,802198849,12534357,16.7),(148628,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 12862','RN',148628,40.47,0.11,1150,70608,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 12862',0.078189,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148629,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 12862','RN',148629,41.08,0.21,1520,70608,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 12862',0.078189,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148630,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148630,36.08,0.45,164,70609,NULL,NULL,'Malmquist cor.','2MASX J20534668-5259096',NULL,'2009ApJS..182..474S',2009,1,0.62,NULL,'G',0.000033,NULL,'15.64',0.35,'Sbc','Group member',NULL,NULL,NULL,1,313.444625,-52.98594,0.085,NULL,51338819120,802169048,12533891,15.64),(148631,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148631,36.28,0.41,180,70609,NULL,NULL,NULL,'2MASX J20534668-5259096',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148632,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148632,36.32,0.2,184,70609,74.4,NULL,NULL,'2MASX J20534668-5259096',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148633,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148633,37.07,0.21,259,70610,70,NULL,NULL,'2MASX J20535556-0038345',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000198,NULL,'16.3g',0.36,'E0',NULL,NULL,NULL,NULL,1,313.481625,-0.64303,0.313,NULL,47785384876,746646638,11666353,16.3),(148634,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148634,37.27,0.46,284,70611,70,NULL,NULL,'2MASX J20535760-0611208',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000093,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,313.489916667,-6.18928,0.217,NULL,50795543803,793680371,12401255,17.3),(148635,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 15254','R',148635,40.06,0.21,855,70612,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2006oy','SN 2006oy',0.203,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,313.492917,-0.36006,0.313,NULL,47785201728,746643777,11666309,NULL),(148636,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 15254','R',148636,40.24,0.12,929,70612,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2006oy','SN 2006oy',0.203,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148637,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148637,36.27,0.52,180,70613,70,NULL,NULL,'2MASX J20540180-4242396',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.41',0.42,'E',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,313.507541667,-42.711,0.069,NULL,51390447523,802975742,12546495,16.41),(148638,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148638,35.21,0.49,110,70614,75,NULL,'IR','ESO 463- G 032',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'15.88',0.3,'Sb',NULL,NULL,NULL,NULL,1,313.526291667,-28.68222,0.429,NULL,51490418292,804537785,12570902,15.88),(148639,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148639,35.59,0.44,131,70614,NULL,NULL,NULL,'ESO 463- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148640,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148640,35.61,0.44,132,70614,NULL,NULL,'Malmquist cor.','ESO 463- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148641,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148641,35.63,0.2,134,70614,74.4,NULL,NULL,'ESO 463- G 032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148642,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 19188',NULL,148642,40.67,0.35,1360,70615,70,NULL,'SN photometric redshift distance, z photo =0.389 +/- 0.090','SDSS-II SN 19188',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','22.6g',0.01,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,313.5377083,-0.18175,0.337,NULL,47785186551,746643539,11666305,22.6),(148643,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148643,35.57,0.67,130,70616,70,NULL,NULL,'2MASX J20540933-5313316',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15',0.42,'E','Group member',NULL,NULL,NULL,1,313.539,-53.22547,0.097,NULL,51338831351,802169239,12533894,15),(148644,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148644,37.07,0.21,259,70617,70,NULL,NULL,'2MASX J20541084-0057484',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,313.54525,-0.96353,0.345,NULL,47785481387,746648146,11666377,17.6),(148645,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148645,36.63,0.59,212,70618,70,NULL,NULL,'2MASX J20541157-7324474',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,313.548458333,-73.41314,0.201,NULL,49207809492,768872023,12013625,16.5),(148646,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 18405',NULL,148646,39.64,0.28,847,70619,70,NULL,'SN photometric redshift distance, z photo =0.222 +/- 0.035','SDSS-II SN 18405',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,313.548875,-0.91769,0.345,NULL,47785507273,746648551,11666383,NULL),(148647,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148647,34.97,0.49,98.5,70620,75,NULL,'IR','UGC 11647',NULL,'2011yCatp016004901K',2011,1,1.77,NULL,'G',0.000009,NULL,'15.57',0.16,'Sc',NULL,NULL,NULL,NULL,1,313.5507917,17.77933,0.349,NULL,55292095066,863938985,13499046,15.57),(148648,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148648,35.21,0.43,110,70620,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11647',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148649,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148649,35.31,NULL,115,70620,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11647',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148650,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148650,35.32,NULL,116,70620,NULL,NULL,'Dipole','UGC 11647',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148651,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148651,35.32,NULL,116,70620,NULL,NULL,'Dipole + Quadrupole','UGC 11647',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148652,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148652,35.34,0.43,117,70620,75,NULL,'3.6 micron, color corrected','UGC 11647',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148653,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148653,35.36,0.4,118,70620,NULL,NULL,'mean','UGC 11647',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148654,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148654,35.37,NULL,118,70620,NULL,NULL,NULL,'UGC 11647',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148655,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148655,35.46,0.34,123,70620,NULL,NULL,'Malmquist cor.','UGC 11647',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148656,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148656,35.51,0.47,126,70620,NULL,NULL,'H','UGC 11647',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148657,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148657,35.54,0.45,128,70620,NULL,NULL,'K','UGC 11647',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148658,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148658,35.55,0.2,129,70620,74.4,NULL,NULL,'UGC 11647',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148659,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148659,35.63,0.31,134,70620,NULL,NULL,NULL,'UGC 11647',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148660,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148660,33.33,0.49,46.4,70621,75,NULL,'IR','CGCG 425-017',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000057,NULL,'15.3',0.2,NULL,NULL,NULL,NULL,NULL,1,313.552666667,10.54981,0.421,NULL,55073615430,860525241,13445706,15.3),(148661,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 03488','R',148661,39.48,0.15,678,70622,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03488',0.16,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,313.555167,-1.01042,0.345,NULL,47785482928,746648170,11666377,NULL),(148662,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 03488','R',148662,39.54,0.26,697,70622,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03488',0.16,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148663,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148663,37.52,0.64,319,70623,70,NULL,NULL,'2MASX J20541442-4646356',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00015,NULL,'15.87',0.47,'E',NULL,NULL,NULL,NULL,1,313.56,-46.77661,0.041,NULL,51394796397,803043693,12547557,15.87),(148664,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148664,36.25,0.46,178,70624,70,NULL,NULL,'2MASX J20541513-0510294',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000069,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,313.563041667,-5.17497,0.185,NULL,50739925529,792811336,12387677,17.2),(148665,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148665,38.75,0.46,561,70625,70,NULL,NULL,'SDSS J205416.46+010225.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000186,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,313.568583,1.04031,0.305,NULL,53959366742,843115105,13173673,18.6),(148666,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148666,36.71,0.7,220,70626,70,NULL,NULL,'2MASX J20541684-5249585',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'16.75',0.18,'S03/a','Group member',NULL,NULL,NULL,1,313.570208333,-52.83286,0.073,NULL,51341748406,802214818,12534606,16.75),(148667,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148667,37.05,0.46,258,70627,70,NULL,NULL,'2MASX J20541699-0114564',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000178,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,313.57075,-1.24917,0.337,NULL,47785121675,746642526,11666289,17.3),(148668,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14299','RN',148668,41.26,0.22,1480,70628,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14299',0.2093,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148669,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14299','RN',148669,41.92,0.3,2000,70628,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 14299',0.2093,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148670,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148670,36.39,0.52,189,70629,70,NULL,NULL,'MCG -07-43-001',NULL,'2014MNRAS.445.2677S',2014,1,0.74,NULL,'G',0.000117,NULL,'15.30',0.6,'E',NULL,NULL,NULL,NULL,1,313.58525,-43.06636,0.065,NULL,51390467937,802976061,12546500,15.3),(148671,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148671,37.5,0.56,316,70630,70,NULL,NULL,'2MASX J20542047-5149530',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'15.9b',0.35,'Sb','Group member',NULL,NULL,NULL,1,313.58525,-51.83142,0.033,NULL,51341216229,802206503,12534476,15.9),(148672,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148672,34.03,0.51,63.9,70631,70,NULL,NULL,'ESO 286- G 010',NULL,'2014MNRAS.445.2677S',2014,1,2.1,NULL,'G',0.000083,NULL,'13.40',1.7,'(R\')SA(rs)a',NULL,NULL,NULL,NULL,1,313.587875,-44.06267,0.065,NULL,51404154040,803189906,12549842,13.4),(148673,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148673,36.9,0.63,240,70632,70,NULL,NULL,'2MASX J20542143-4256236',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.83',0.25,NULL,NULL,NULL,NULL,NULL,1,313.589458333,-42.93983,0.065,NULL,51390352300,802974254,12546472,16.83),(148674,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 13743','RN',148674,42.2,0.3,2290,70633,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13743',0.201787,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148675,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 13743','RN',148675,42.81,0.36,3030,70633,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13743',0.201787,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148676,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148676,36.61,0.46,210,70634,70,NULL,NULL,'2MASX J20542411-0048313',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00015,NULL,'16.3g',0.37,'E0',NULL,NULL,NULL,NULL,1,313.6005,-0.80878,0.345,NULL,47785451241,746647675,11666369,16.3),(148677,'SNII optical','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2002ew',NULL,148677,35.32,0.2,116,70635,NULL,NULL,'V, photospheric magnitude method','SDSS J205430.45-000820.8',NULL,'2014AJ....148..107R',2014,1,0.34,NULL,'G',0.000077,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,313.627083,-0.13944,0.337,NULL,47781780745,746590324,11665473,16.6),(148678,'SNII optical','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2002ew',NULL,148678,35.33,0.11,116,70635,NULL,NULL,'I, photospheric magnitude method','SDSS J205430.45-000820.8',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148679,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148679,35.85,0.62,148,70636,70,NULL,NULL,'2MASX J20543202-5521024',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.7b',0.3,NULL,NULL,NULL,NULL,NULL,1,313.633458333,-55.35075,0.185,NULL,48990087582,765470118,11960470,16.7),(148680,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 13410','RN',148680,38.3,0.06,443,70637,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13410',0.029825,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148681,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 13410','RN',148681,39.08,0.22,635,70637,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13410',0.029825,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148682,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148682,38.44,0.46,487,70638,70,NULL,NULL,'SDSS J205433.36-065858.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000086,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,313.639,-6.98297,0.201,NULL,50795830352,793684849,12401325,18.7),(148683,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148683,38.2,0.46,436,70639,70,NULL,NULL,'SDSS J205436.27-064803.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000084,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,313.651167,-6.80086,0.201,NULL,50795968145,793687002,12401359,18.5),(148684,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148684,35.25,0.57,112,70640,70,NULL,NULL,'2MASX J20543785-7250595',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,313.657917,-72.84992,0.185,NULL,49325632113,770713001,12042390,14.5),(148685,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148685,36.12,0.52,168,70641,70,NULL,NULL,'2MASX J20543970-4330430',NULL,'2014MNRAS.445.2677S',2014,1,0.88,NULL,'G',0.00015,NULL,'15.19',0.55,NULL,NULL,NULL,NULL,NULL,1,313.6655,-43.51192,0.065,NULL,51390610330,802978286,12546535,15.19),(148686,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148686,36.48,0.62,198,70642,70,NULL,NULL,'2MASX J20543996-4304350',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.23',0.39,'(R)SAB0^0',NULL,NULL,NULL,NULL,1,313.666583333,-43.07644,0.065,NULL,51390477793,802976215,12546503,16.23),(148687,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 09126','RN',148687,37.61,0.34,311,70643,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 09126',0.0695,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148688,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148688,37.69,0.46,345,70644,70,NULL,NULL,'2MASX J20544340-0641501',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000099,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,313.6807083,-6.69711,0.177,NULL,50795948849,793686700,12401354,17.1),(148689,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148689,35.96,0.54,155,70645,70,NULL,NULL,'2MASX J20544546-1215458',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,313.6894583,-12.26269,0.193,NULL,50755872863,793060513,12391570,16),(148690,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 13840','RN',148690,40.02,0.2,811,70646,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13840',0.2419,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148691,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 13840','RN',148691,40.15,0.13,862,70646,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13840',0.2419,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148692,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2006ni',NULL,148692,39.05,0.2,646,70647,70,NULL,'SDSS-II SN 15648','SDSS J205452.51-001144.9',NULL,'2013MNRAS.434.1443X',2013,1,0.13,NULL,'G',0.000166,NULL,'19.1g',0.1,NULL,NULL,NULL,NULL,NULL,1,313.7187917,-0.19581,0.337,NULL,47781799947,746590624,11665478,19.1),(148693,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2006ni',NULL,148693,39.09,0.11,658,70647,70,NULL,'Hubble residual -0.09 for z0.17496','SDSS J205452.51-001144.9',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148694,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 15648','R',148694,39.53,0.21,686,70647,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ni','SDSS J205452.51-001144.9',0.174962,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148695,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 15648','R',148695,39.63,0.12,718,70647,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ni','SDSS J205452.51-001144.9',0.174962,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148696,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2006ni',NULL,148696,39.33,0.13,735,70647,70,NULL,'SALT 2','SDSS J205452.51-001144.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148697,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2006ni',NULL,148697,39.34,0.13,738,70647,70,NULL,'SALT 2, Malmquist cor.','SDSS J205452.51-001144.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148698,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148698,34.42,NULL,76.4,70648,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2292',NULL,'2010Ap&SS.325..163P',2010,1,0.9,NULL,'G',0.000007,NULL,'17.0',0.08,'Scd',NULL,NULL,NULL,NULL,1,313.729167,17.66167,0.349,NULL,55292165558,863940086,13499063,17),(148699,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148699,34.42,NULL,76.7,70648,NULL,NULL,'Dipole + Quadrupole','FGC 2292',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148700,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148700,34.43,NULL,76.8,70648,NULL,NULL,'Dipole','FGC 2292',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148701,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148701,34.5,NULL,79.6,70648,NULL,NULL,NULL,'FGC 2292',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148702,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148702,35.59,0.58,131,70649,70,NULL,NULL,'2MASX J20550321-4258330',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.89',0.37,NULL,NULL,NULL,NULL,NULL,1,313.763333,-42.97581,0.065,NULL,51390356731,802974323,12546473,16.89),(148703,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148703,37.7,0.58,347,70650,70,NULL,NULL,'2MASX J20550895-4333319',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'16.20',0.49,NULL,NULL,NULL,NULL,NULL,1,313.78725,-43.55886,0.065,NULL,51390598026,802978094,12546532,16.2),(148704,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 03372','RN',148704,41.27,0.25,1550,70651,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 03372',0.157654,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148705,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148705,35.62,0.55,133,70652,70,NULL,NULL,'ESO 187- G 032',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.16',0.8,'S?',NULL,NULL,NULL,NULL,1,313.8015,-54.52364,0.121,NULL,51070027717,797969183,12468268,15.16),(148706,'IRAS','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148706,34.8,0.8,91.4,70653,75,NULL,'MAT, I','ESO 235- G 016',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'14.17',1.1,'(R\')SB(r)bc',NULL,NULL,NULL,NULL,1,313.807083,-49.18831,0.013,NULL,51351177736,802362152,12536908,14.17),(148707,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148707,34.36,0.43,74.6,70653,NULL,NULL,'Malmquist cor.','ESO 235- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148708,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148708,34.38,0.43,75.3,70653,75,NULL,'MAT, I, raw','ESO 235- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148709,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148709,34.49,0.41,79.2,70653,NULL,NULL,NULL,'ESO 235- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148710,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148710,34.51,0.32,79.7,70653,85,NULL,'I, raw','ESO 235- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148711,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148711,34.53,0.2,80.5,70653,74.4,NULL,NULL,'ESO 235- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148712,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148712,34.57,0.32,81.9,70653,85,NULL,'I, inv','ESO 235- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148713,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148713,34.59,0.43,82.8,70653,75,NULL,'MAT, I, cor','ESO 235- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148714,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148714,34.63,0.43,84.2,70653,75,NULL,'MAT, I, inv','ESO 235- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148715,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 12863','RN',148715,42.94,0.22,2770,70654,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 12863',0.3954,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148716,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 12863','RN',148716,43.11,0.2,3000,70654,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 12863',0.3954,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148717,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14984',NULL,148717,39.42,0.21,766,70655,70,NULL,NULL,'SDSS J205520.06-000534.0',NULL,'2013MNRAS.434.1443X',2013,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,313.833583,-0.09278,0.321,NULL,47781821954,746590968,11665483,NULL),(148718,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14984','R',148718,39.94,0.21,818,70655,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006js','SDSS J205520.06-000534.0',0.19,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148719,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14984','R',148719,39.96,0.11,825,70655,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006js','SDSS J205520.06-000534.0',0.19,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148720,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148720,36.95,0.6,245,70656,70,NULL,NULL,'2MASX J20552107-5445282',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'13.03',0.31,NULL,NULL,NULL,NULL,NULL,1,313.8377083,-54.75781,0.149,NULL,48989573393,765462084,11960345,13.03),(148721,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 16408','RN',148721,41,0.32,1250,70657,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16408',0.2667,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148722,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 16408','RN',148722,41.19,0.28,1370,70657,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16408',0.2667,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148723,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148723,33.53,0.4,50.8,70658,NULL,NULL,'mean','UGC 11649',NULL,'2007A&A...465...71T',2007,1,1.35,NULL,'G',0.000013,NULL,'14.0g',1.02,'SB(r)a pec',NULL,NULL,NULL,NULL,1,313.865083,-1.22525,0.389,NULL,47782069363,746594833,11665544,14),(148724,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148724,33.76,0.47,56.4,70658,NULL,NULL,'H','UGC 11649',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148725,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148725,33.77,0.45,56.7,70658,NULL,NULL,'K','UGC 11649',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148726,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148726,33.79,0.46,57.3,70658,NULL,NULL,'J','UGC 11649',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148727,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148727,33.86,0.35,59.3,70658,NULL,NULL,NULL,'UGC 11649',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148728,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148728,33.89,0.35,60,70658,NULL,NULL,'Malmquist cor.','UGC 11649',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148729,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148729,33.9,0.2,60.3,70658,74.4,NULL,NULL,'UGC 11649',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148730,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148730,35.12,0.59,106,70659,70,NULL,NULL,'2MASX J20553057-4327450',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.00015,NULL,'15.78',0.3,'S',NULL,NULL,NULL,NULL,1,313.8775,-43.4625,0.065,NULL,51390480611,802976259,12546504,15.78),(148731,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148731,35.72,0.46,139,70660,70,NULL,NULL,'CGCG 374-030',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000112,NULL,'15.5g',0.48,'Sa      poss. LINER?','Isolated galaxy',NULL,NULL,NULL,1,313.902125,-0.63658,0.313,NULL,47782308241,746598566,11665602,15.5),(148732,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148732,37.68,0.46,344,70661,70,NULL,NULL,'2MASX J20553782-0714580',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000093,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,313.907625,-7.24958,0.221,NULL,50795892035,793685813,12401340,16.5),(148733,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148733,37.42,0.79,304,70662,70,NULL,NULL,'2MASX J20553935-5731291',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000133,NULL,'15.91',0.42,'E',NULL,NULL,NULL,NULL,1,313.914,-57.52483,0.281,NULL,49139161484,767799398,11996865,15.91),(148734,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 05616','RN',148734,39.08,0.38,592,70663,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05616',0.104598,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148735,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 05616','RN',148735,39.93,0.51,876,70663,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 05616',0.104598,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148736,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148736,38.02,0.46,402,70664,70,NULL,NULL,'2MASX J20554518-0035273',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,313.938458333,-0.59094,0.337,NULL,47782353252,746599269,11665613,18.1),(148737,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148737,35.94,0.62,154,70665,70,NULL,NULL,'2MASX J20554966-5408102',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.9b',0.3,NULL,NULL,NULL,NULL,NULL,1,313.957041667,-54.13611,0.109,NULL,51069938167,797967783,12468246,16.9),(148738,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148738,35.88,0.63,150,70666,70,NULL,NULL,'AM 2052-440',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'16.17',0.58,'(R_1R\'_2)SB0/a',NULL,NULL,NULL,NULL,1,313.9725417,-43.81344,0.073,NULL,51390075954,802969936,12546405,16.17),(148739,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148739,38.01,0.63,400,70667,70,NULL,NULL,'2MASX J20555490-5154356',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.33',0.47,'S0',NULL,NULL,NULL,NULL,1,313.9787917,-51.90986,0.033,NULL,51341042830,802203794,12534434,16.33),(148740,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148740,36.96,0.46,247,70668,70,NULL,NULL,'2MASX J20555707-0015362',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000179,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,313.987667,-0.26008,0.321,NULL,47781976405,746593381,11665521,16.7),(148741,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148741,36.37,0.5,188,70669,70,NULL,NULL,'2MASX J20555953-4319541',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.35',0.35,NULL,NULL,NULL,NULL,NULL,1,313.998,-43.33164,0.065,NULL,51390015095,802968985,12546390,16.35),(148742,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148742,36.68,0.53,217,70670,70,NULL,NULL,'2MASX J20560440-4605031',NULL,'2014MNRAS.445.2677S',2014,1,0.92,NULL,'G',0.00009,NULL,'16.14',0.32,'E',NULL,NULL,NULL,NULL,1,314.018458333,-46.08431,0.029,NULL,51401959945,803155624,12549306,16.14),(148743,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148743,37.05,0.46,257,70671,70,NULL,NULL,'2MASX J20560699-0619578',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000064,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,314.02925,-6.33272,0.145,NULL,50796089574,793688899,12401389,17.6),(148744,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148744,36.29,0.6,181,70672,70,NULL,NULL,'2MASX J20560728-0813488',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.52',NULL,NULL,NULL,NULL,NULL,NULL,1,314.0302083,-8.23008,0.213,NULL,50799010503,793734539,12402102,16.52),(148745,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148745,35.7,0.52,138,70673,70,NULL,NULL,'2MASX J20561137-1702333',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.09',0.5,NULL,NULL,NULL,NULL,NULL,1,314.047333333,-17.04264,0.205,NULL,51002003716,796906308,12451661,16.09),(148746,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 13744','RN',148746,39.17,0.21,557,70674,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13744',0.222542,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148747,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 13744','RN',148747,39.95,0.23,799,70674,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13744',0.222542,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148748,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148748,37.73,0.46,352,70675,70,NULL,NULL,'2MASX J20561457-0110501',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,314.0607917,-1.18067,0.297,NULL,47782059109,746594673,11665541,18),(148749,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148749,36.7,0.46,219,70676,70,NULL,NULL,'2MASX J20562197-0521165',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000073,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,314.091583,-5.35461,0.157,NULL,50739976992,792812140,12387689,17.2),(148750,'SZ effect','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148750,41.61,NULL,2100,70677,NULL,NULL,'4.2 (black) calibration','MS 2053.7-0449',NULL,'2010ApJ...721..653R',2010,1,NULL,NULL,'GClstr',0.003,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,314.090833,-4.63083,0.193,NULL,50747417961,792928405,12389506,NULL),(148751,'SZ effect','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148751,41.85,NULL,2340,70677,NULL,NULL,'3.1 (red) calibration','MS 2053.7-0449',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148752,'SZ effect','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148752,41.97,0.35,2480,70677,NULL,NULL,'Hydrost. Eq.','MS 2053.7-0449',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148753,'SZ effect','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148753,42.03,NULL,2550,70677,NULL,NULL,'4.1 (blue) calibration','MS 2053.7-0449',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148754,'SZ effect','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148754,42.46,0.82,3110,70677,NULL,NULL,'Isotherm.','MS 2053.7-0449',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148755,'SZ effect','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148755,42.77,0.91,3580,70677,NULL,NULL,'Isotherm., r < 100 kpc','MS 2053.7-0449',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148756,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148756,34.53,0.53,80.4,70678,70,NULL,NULL,'MCG -02-53-014',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000083,NULL,'15.5',0.3,NULL,NULL,NULL,NULL,NULL,1,314.095917,-14.30436,0.189,NULL,50987566872,796680732,12448136,15.5),(148757,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148757,35.12,0.49,106,70679,75,NULL,'IR','UGC 11650',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',NULL,NULL,'15.42',0.3,'Scd:',NULL,NULL,NULL,NULL,1,314.1147917,12.04128,0.429,NULL,55071295519,860488992,13445140,15.42),(148758,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148758,35.41,0.32,121,70679,NULL,NULL,'Malmquist cor.','UGC 11650',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148759,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148759,35.47,0.2,124,70679,74.4,NULL,NULL,'UGC 11650',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148760,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148760,35.48,0.31,125,70679,NULL,NULL,NULL,'UGC 11650',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148761,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2002el',NULL,148761,34.95,0.22,95,70680,72,NULL,NULL,'NGC 6986',0.02873,'2006ApJ...645..488W',2006,1,1,'2002IAUC.7954A...1W has V = 6986 km/s.','G',0.000087,NULL,'14.55',0.6,'SB0-?',NULL,NULL,NULL,NULL,1,314.12775,-18.56656,0.225,NULL,50991381998,796740343,12449067,14.55),(148762,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2002el',NULL,148762,35.2,0.16,106,70680,70,NULL,'SALT 2','NGC 6986',0.02873,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148763,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2002el','R',148763,35.18,0.05,109,70680,NULL,NULL,'MLCS2k2, R(V) = 1.8','NGC 6986',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148764,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2002el','R',148764,35.23,0.05,111,70680,NULL,NULL,'MLCS2k2, R(V) = 3.1','NGC 6986',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148765,'L(H{beta})-{sigma}','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148765,44.67,NULL,1624,70681,74.3,NULL,NULL,'WISP 159_0134',1.3,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,314.1287917,-4.79897,0.205,NULL,50747435286,792928676,12389510,NULL),(148766,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148766,36.58,0.5,207,70682,70,NULL,NULL,'2MASX J20563161-5208314',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'16.2b',0.37,'S0',NULL,NULL,NULL,NULL,1,314.131833,-52.14214,0.041,NULL,51341822649,802215978,12534624,16.2),(148767,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 20536',NULL,148767,41.56,0.03,2050,70683,70,NULL,'SN photometric redshift distance, z photo =0.686 +/- 0.014','SDSS-II SN 20536',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.8g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,314.141375,-0.38786,0.253,NULL,47782520435,746601881,11665654,21.8),(148768,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148768,37.67,0.46,342,70684,70,NULL,NULL,'2MASX J20563550-0713460',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000101,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,314.1479583,-7.22939,0.173,NULL,50795743682,793683495,12401304,17.4),(148769,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148769,34.98,0.49,99.2,70685,70,NULL,NULL,'2MASX J20563628-0320525',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000037,NULL,'15.5',0.8,'S0- pec',NULL,NULL,NULL,NULL,1,314.1512083,-3.34794,0.237,NULL,50749601677,792962526,12390039,15.5),(148770,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148770,36.11,0.5,167,70686,70,NULL,NULL,'ESO 235- G 018',NULL,'2014MNRAS.445.2677S',2014,1,0.81,NULL,'G',0.0001,NULL,'15.37',0.7,'SB(rs)a',NULL,NULL,NULL,NULL,1,314.152416667,-51.56125,0.033,NULL,51341156767,802205574,12534462,15.37),(148771,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2005jj',NULL,148771,41.16,0.2,1250,70687,74.2,NULL,'SALT 2','SDSS J205644.45+002429.6',0.368,'2010ApJ...716..712A',2010,1,0.08,NULL,'G',NULL,NULL,'20.6g',0.05,NULL,NULL,NULL,NULL,NULL,1,314.18525,0.40825,0.273,NULL,53956563523,843071305,13172989,20.6),(148772,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 07947','R',148772,41.84,0.31,1700,70687,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2005jj','SDSS J205644.45+002429.6',0.37,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148773,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2005jj',NULL,148773,41.91,0.23,1760,70687,70,NULL,'SALT 2','SDSS J205644.45+002429.6',0.368,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148774,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 07947','R',148774,42.32,0.31,2130,70687,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2005jj','SDSS J205644.45+002429.6',0.37,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148775,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148775,38.56,0.46,516,70688,70,NULL,NULL,'SDSS J205651.91-072110.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000093,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,314.216333333,-7.35297,0.221,NULL,50797512970,793711140,12401736,17.9),(148776,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148776,36.85,0.46,234,70689,70,NULL,NULL,'2MASX J20565334+0010448',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000223,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,314.222125,0.17917,0.273,NULL,53956389206,843068581,13172946,16.8),(148777,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 15652','RN',148777,42.89,0.26,2400,70690,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 15652',0.573376,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148778,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148778,36.7,0.52,218,70691,70,NULL,NULL,'2MASX J20565516-4206324',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.20',0.45,NULL,NULL,NULL,NULL,NULL,1,314.23,-42.10903,0.081,NULL,51388891331,802951427,12546116,16.2),(148779,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14030','RN',148779,39.61,0.08,768,70692,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14030',0.086529,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148780,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14030','RN',148780,40.19,0.21,1000,70692,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 14030',0.086529,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148781,'Tully est','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148781,32.09,0.8,26.2,70693,75,NULL,NULL,'ESO 187-IG 035',NULL,'1988NBGC.C....0000T',1988,1,1.4,NULL,'G',0.000026,NULL,'15.26',0.8,'SB(s)m',NULL,NULL,NULL,NULL,1,314.2327083,-55.71992,0.201,NULL,49124204308,767565692,11993213,15.26),(148782,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2006jp',NULL,148782,38.56,0.06,514,70694,70,NULL,'Hubble residual -0.45 for z0.16040','SDSS-II SN 14782 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,314.234083,-0.27917,0.253,NULL,47782492713,746601448,11665647,NULL),(148783,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14782','R',148783,39.12,0.2,566,70694,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006jp','SDSS-II SN 14782 HOST',0.179,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148784,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14782','R',148784,39.24,0.08,599,70694,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006jp','SDSS-II SN 14782 HOST',0.179,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148785,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148785,36.54,0.52,203,70695,70,NULL,NULL,'2MASX J20570010-4924585',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.38',0.48,'S',NULL,NULL,NULL,NULL,1,314.250417,-49.41622,0.025,NULL,51354683064,802416922,12537764,16.38),(148786,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 15823','R',148786,40.21,0.2,905,70696,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15823',0.2152,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,314.2525417,0.199,0.273,NULL,53956438063,843069344,13172958,NULL),(148787,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 15823','R',148787,40.44,0.12,1010,70696,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15823',0.2152,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148788,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 12852','R',148788,40.74,0.22,1110,70697,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 12852',0.264,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,314.2530417,0.68914,0.249,NULL,53956470962,843069858,13172966,NULL),(148789,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 12852','R',148789,40.74,0.29,1110,70697,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 12852',0.264,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148790,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148790,36.62,0.68,211,70698,70,NULL,NULL,'2MASX J20570375-5206225',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'16.67',0.23,NULL,NULL,NULL,NULL,NULL,1,314.265667,-52.10631,0.045,NULL,51342345479,802224148,12534752,16.67),(148791,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148791,35.44,0.53,123,70699,70,NULL,NULL,'2MASX J20570805-6152531',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.000133,NULL,'15.8b',0.35,'E',NULL,NULL,NULL,NULL,1,314.283583,-61.88136,0.113,NULL,49176860961,768388452,12006069,15.8),(148792,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148792,34.08,0.2,65.5,70700,74.4,NULL,NULL,'CGCG 425-022',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.00012,NULL,'15.5',0.2,NULL,NULL,NULL,NULL,NULL,1,314.288625,13.52397,0.397,NULL,55281563017,863774422,13496475,15.5),(148793,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148793,34.22,0.49,69.7,70700,75,NULL,'IR','CGCG 425-022',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148794,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148794,34.26,0.32,71.3,70700,NULL,NULL,NULL,'CGCG 425-022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148795,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148795,34.3,0.31,72.6,70700,NULL,NULL,'Malmquist cor.','CGCG 425-022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148796,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148796,35.62,0.56,133,70701,70,NULL,NULL,'2MASX J20571032-0754250',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.37',0.5,NULL,NULL,NULL,NULL,NULL,1,314.2929583,-7.90708,0.201,NULL,50800906823,793764169,12402565,16.37),(148797,'IRAS','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148797,31.79,0.8,22.8,70702,75,NULL,'A82, H','UGC 11651',NULL,'1997ApJS..109..333W',1997,1,3.1,NULL,'G',0.000005,NULL,'14.4',0.8,'Sdm',NULL,NULL,NULL,NULL,1,314.314125,25.96486,0.797,NULL,55717207735,870581370,13602833,14.4),(148798,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148798,31.59,0.38,20.8,70702,NULL,NULL,NULL,'UGC 11651',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148799,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148799,31.62,0.2,21.1,70702,74.4,NULL,NULL,'UGC 11651',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148800,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148800,31.73,0.4,22.2,70702,NULL,NULL,'Virgo cluster at 15.6 Mpc','UGC 11651',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148801,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148801,31.87,0.4,23.7,70702,75,NULL,'B','UGC 11651',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148802,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148802,31.95,0.47,24.5,70702,75,NULL,'A82, H, raw','UGC 11651',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148803,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148803,31.96,0.47,24.6,70702,75,NULL,'A82, H, inv','UGC 11651',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148804,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148804,32.27,0.47,28.4,70702,75,NULL,'A82, H, cor','UGC 11651',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148805,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148805,32.32,0.49,29.2,70702,75,NULL,'IR','UGC 11651',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148806,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148806,36.06,0.46,163,70703,70,NULL,NULL,'2MASX J20571901-0029426',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000168,NULL,'16.1g',0.34,'E0',NULL,NULL,NULL,NULL,1,314.329125,-0.49511,0.253,NULL,47782394867,746599919,11665623,16.1),(148807,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 03545','RN',148807,40.9,0.24,1340,70704,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03545',0.135542,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148808,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 03545','RN',148808,41.09,0.23,1460,70704,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03545',0.135542,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148809,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 16204','RN',148809,37.57,0.08,310,70705,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16204',0.054544,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148810,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 16204','RN',148810,38.47,0.3,469,70705,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16204',0.054544,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148811,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148811,37.38,0.33,299,70706,70,NULL,NULL,'2MASX J20572566+0038011',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,314.356875,0.63358,0.249,NULL,53956499245,843070300,13172973,17.5),(148812,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148812,38.09,0.46,415,70707,70,NULL,NULL,'2MASX J20572622-0033336',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,314.359167,-0.55931,0.253,NULL,47782390750,746599855,11665622,18.1),(148813,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148813,35.3,0.63,115,70708,70,NULL,NULL,'2MASX J20572892-5258362',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.00015,NULL,'15.81',0.3,'S',NULL,NULL,NULL,NULL,1,314.370583,-52.97675,0.077,NULL,51338962345,802171286,12533926,15.81),(148814,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148814,37.38,0.33,299,70709,70,NULL,NULL,'2MASX J20573339+0039371',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,314.389083333,0.66039,0.269,NULL,53956455134,843069611,13172962,17.5),(148815,'IRAS','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148815,33.94,0.8,61.3,70710,75,NULL,'MAT, I','ESO 286- G 016',NULL,'1997ApJS..109..333W',1997,1,1.63,NULL,'G',0.000033,NULL,'14.58',0.35,'Sab? sp','Pair member (points to parent)',NULL,NULL,NULL,1,314.410625,-46.60547,0.025,NULL,51402062149,803157221,12549331,14.58),(148816,'IRAS','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148816,33.95,0.8,61.5,70710,75,NULL,'HMCL, I','ESO 286- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148817,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148817,33.58,0.4,52.1,70710,75,NULL,'HMCL, I, raw','ESO 286- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148818,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148818,33.65,0.49,53.8,70710,75,NULL,'IR','ESO 286- G 016',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148819,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148819,33.72,0.4,55.5,70710,75,NULL,'HMCL, I, inv','ESO 286- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148820,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148820,33.88,0.32,59.7,70710,85,NULL,'I, raw','ESO 286- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148821,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148821,33.92,0.43,60.8,70710,75,NULL,'MAT, I, raw','ESO 286- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148822,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148822,33.92,0.4,60.8,70710,75,NULL,'HMCL, I, cor','ESO 286- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148823,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148823,33.92,0.32,60.9,70710,85,NULL,'I, inv','ESO 286- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148824,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148824,34.09,0.47,65.8,70710,NULL,NULL,'H','ESO 286- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148825,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148825,34.11,0.33,66.4,70710,NULL,NULL,NULL,'ESO 286- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148826,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148826,34.13,0.43,66.9,70710,75,NULL,'MAT, I, inv','ESO 286- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148827,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148827,34.15,0.2,67.6,70710,74.4,NULL,NULL,'ESO 286- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148828,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148828,34.18,0.45,68.5,70710,NULL,NULL,'K','ESO 286- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148829,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148829,34.19,0.43,68.9,70710,75,NULL,'MAT, I, cor','ESO 286- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148830,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148830,34.21,0.4,69.5,70710,NULL,NULL,'mean','ESO 286- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148831,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148831,34.22,0.31,69.9,70710,NULL,NULL,'Malmquist cor.','ESO 286- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148832,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148832,34.25,0.46,70.7,70710,NULL,NULL,'J','ESO 286- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148833,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148833,36.78,0.5,227,70711,70,NULL,NULL,'FAIRALL 0925',NULL,'2014MNRAS.445.2677S',2014,1,0.87,NULL,'G',0.00015,NULL,'15.64',0.53,'S0',NULL,NULL,NULL,NULL,1,314.417125,-51.19617,0.037,NULL,51340930195,802202034,12534406,15.64),(148834,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148834,36.19,0.74,173,70712,70,NULL,NULL,'6dF J2057419-333154',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,314.424375,-33.53158,0.305,NULL,51525065664,805079151,12579361,15.8),(148835,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148835,33.62,0.5,53,70713,70,NULL,NULL,'ESO 144- G 010',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000087,NULL,'17.7b',1,'(RL)SB(s)0^0',NULL,NULL,NULL,NULL,1,314.4265417,-61.43864,0.109,NULL,49187933749,768561464,12008772,17.7),(148836,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148836,34.49,0.49,79.2,70714,75,NULL,'IR','UGC 11655',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000013,NULL,'16.5',0.3,'Sd:',NULL,NULL,NULL,NULL,1,314.455333,25.63786,0.517,NULL,55717369366,870583896,13602873,16.5),(148837,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148837,36.85,0.61,235,70715,70,NULL,NULL,'2MASX J20574940-1611293',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.94',0.3,NULL,NULL,NULL,NULL,NULL,1,314.455916667,-16.19147,0.193,NULL,51001300185,796895315,12451489,15.94),(148838,'IRAS','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148838,35.34,0.8,117,70716,75,NULL,'MAT, I','ESO 286- G 018',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000033,NULL,'14.26',0.4,'SB(s)bc? sp','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,314.45975,-43.37442,0.065,NULL,51390036444,802969319,12546395,14.26),(148839,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148839,34.36,0.46,74.5,70716,NULL,NULL,'B, Hubble-type-TF','ESO 286- G 018',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148840,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148840,34.81,0.57,91.5,70716,NULL,NULL,'Malmquist cor.','ESO 286- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148841,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148841,34.87,0.47,94.3,70716,NULL,NULL,'H','ESO 286- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148842,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148842,34.9,0.45,95.3,70716,NULL,NULL,'K','ESO 286- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148843,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148843,34.94,0.46,97.1,70716,NULL,NULL,'J','ESO 286- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148844,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148844,34.96,0.43,98.3,70716,75,NULL,'MAT, I, raw','ESO 286- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148845,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148845,34.99,0.49,99.6,70716,75,NULL,'IR','ESO 286- G 018',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148846,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148846,35.09,0.5,104,70716,NULL,NULL,NULL,'ESO 286- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148847,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148847,35.13,0.2,106,70716,74.4,NULL,NULL,'ESO 286- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148848,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148848,35.29,0.43,114,70716,75,NULL,'MAT, I, cor','ESO 286- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148849,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148849,35.36,0.43,118,70716,75,NULL,'MAT, I, inv','ESO 286- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148850,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148850,35.38,0.4,119,70716,NULL,NULL,'mean','ESO 286- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148851,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148851,35.39,0.32,120,70716,85,NULL,'I, raw','ESO 286- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148852,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148852,35.49,0.32,125,70716,85,NULL,'I, inv','ESO 286- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148853,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148853,35.68,0.55,137,70717,70,NULL,NULL,'2MASX J20575387-5448327',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'15.80',0.5,'S',NULL,NULL,NULL,NULL,1,314.474417,-54.80914,0.129,NULL,48989492284,765460816,11960325,15.8),(148854,'Ring Diameter','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148854,34.5,0.84,79,70718,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 6984',NULL,'1981ApJS...45..541P',1981,1,1.8,NULL,'G',0.00003,NULL,'13.17',1.2,'SB(r)c','in a pair',NULL,NULL,NULL,1,314.474916667,-51.87083,0.037,NULL,51341548790,802211699,12534557,13.17),(148855,'IRAS','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148855,33.82,0.8,58.1,70718,75,NULL,'MAT, I','NGC 6984',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148856,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148856,32.76,0.32,35.7,70718,85,NULL,'I, raw','NGC 6984',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148857,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148857,32.79,0.32,36.2,70718,85,NULL,'I, inv','NGC 6984',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148858,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148858,32.93,0.43,38.5,70718,75,NULL,'MAT, I, raw','NGC 6984',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148859,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148859,33.09,0.43,41.6,70718,75,NULL,'MAT, I, inv','NGC 6984',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148860,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148860,33.11,NULL,41.9,70718,NULL,NULL,'I','NGC 6984',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148861,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148861,33.13,0.22,42.3,70718,NULL,NULL,'B, Hubble-type-TF','NGC 6984',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148862,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148862,33.14,NULL,42.5,70718,NULL,NULL,'B','NGC 6984',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148863,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148863,33.25,0.43,44.7,70718,75,NULL,'MAT, I, cor','NGC 6984',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148864,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148864,33.47,0.61,49.3,70718,NULL,NULL,NULL,'NGC 6984',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148865,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148865,33.51,0.2,50.4,70718,74.4,NULL,NULL,'NGC 6984',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148866,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148866,33.58,0.58,52.1,70718,NULL,NULL,'Malmquist cor.','NGC 6984',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148867,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148867,33.67,0.47,54.2,70718,NULL,NULL,'H','NGC 6984',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148868,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148868,33.69,0.46,54.8,70718,NULL,NULL,'J','NGC 6984',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148869,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148869,33.72,0.45,55.4,70718,NULL,NULL,'K','NGC 6984',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148870,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148870,33.98,0.4,62.5,70718,NULL,NULL,'mean','NGC 6984',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148871,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148871,34.73,0.47,88.2,70719,70,NULL,NULL,'IC 1339',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000033,NULL,'14.14',0.9,'SB(rs)ab poss. LINER',NULL,NULL,NULL,NULL,1,314.481333333,-17.94283,0.205,NULL,50999396742,796865574,12451024,14.14),(148872,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148872,35.21,0.47,110,70719,NULL,NULL,'H','IC 1339',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148873,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148873,35.24,0.4,112,70719,NULL,NULL,'mean','IC 1339',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148874,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148874,35.28,0.45,114,70719,NULL,NULL,'K','IC 1339',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148875,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148875,35.31,0.46,115,70719,NULL,NULL,'J','IC 1339',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148876,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148876,35.49,0.28,125,70719,NULL,NULL,'Malmquist cor.','IC 1339',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148877,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148877,35.7,0.25,138,70719,NULL,NULL,NULL,'IC 1339',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148878,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148878,35.74,0.2,141,70719,74.4,NULL,NULL,'IC 1339',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148879,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148879,35.83,0.57,147,70720,70,NULL,NULL,'2MASX J20575761-7257011',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,314.489916667,-72.95031,0.177,NULL,49325916781,770717449,12042460,15.6),(148880,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148880,36.75,0.46,224,70721,70,NULL,NULL,'2MASX J20575947-0639557',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000088,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,314.49775,-6.66564,0.117,NULL,50795308351,793676692,12401198,17.1),(148881,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148881,36.82,0.61,231,70722,70,NULL,NULL,'2MASX J20580060-5328470',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.000117,NULL,'16.6b',0.22,'S0',NULL,NULL,NULL,NULL,1,314.5020417,-53.47997,0.105,NULL,51339167500,802174492,12533976,16.6),(148882,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148882,37.23,0.33,279,70723,70,NULL,NULL,'2MASX J20580238-0733276',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000101,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,314.5097917,-7.55764,0.225,NULL,50797714013,793714281,12401785,17.1),(148883,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148883,35.38,0.5,119,70724,NULL,NULL,'Malmquist cor.','ESO 464- G 003',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000033,NULL,'14.34',0.7,'Sb             HII',NULL,NULL,NULL,NULL,1,314.51,-32.29042,0.317,NULL,51494762590,804605665,12571963,14.34),(148884,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148884,35.44,0.48,122,70724,NULL,NULL,NULL,'ESO 464- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148885,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148885,35.48,0.2,125,70724,74.4,NULL,NULL,'ESO 464- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148886,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148886,35.67,0.47,136,70724,NULL,NULL,'H','ESO 464- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148887,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148887,35.7,0.4,138,70724,NULL,NULL,'mean','ESO 464- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148888,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148888,35.72,0.45,139,70724,NULL,NULL,'K','ESO 464- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148889,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148889,35.78,0.46,143,70724,NULL,NULL,'J','ESO 464- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148890,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14450','R',148890,40.05,0.09,915,70725,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2006kn','SDSS J205805.22+005401.7',0.12,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,314.52175,0.90047,0.281,NULL,55029865241,859841644,13435025,NULL),(148891,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14450','R',148891,40.53,0.2,1140,70725,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2006kn','SDSS J205805.22+005401.7',0.12,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148892,'SNII optical','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2006kn',NULL,148892,38.23,0.09,395,70725,NULL,NULL,'SCM 55 SNII','SDSS J205805.22+005401.7',0.12,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148893,'SNII optical','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2006kn',NULL,148893,38.51,0.11,450,70725,NULL,NULL,'SCM 15 SDSS SNII','SDSS J205805.22+005401.7',0.12,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148894,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148894,35.48,0.61,125,70726,70,NULL,NULL,'6dF J2058061-274806',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,314.5259583,-27.80167,0.405,NULL,51493068828,804579200,12571550,14.9),(148895,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148895,35.01,0.62,100,70727,NULL,NULL,'Malmquist cor.','CGCG 425-027 NED02',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000117,NULL,'13.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,314.5269583,13.51522,0.385,NULL,55281540297,863774067,13496469,13.2),(148896,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148896,35.12,0.59,106,70727,NULL,NULL,NULL,'CGCG 425-027 NED02',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148897,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148897,35.27,0.2,113,70727,74.4,NULL,NULL,'CGCG 425-027 NED02',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148898,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148898,35.99,0.62,158,70728,70,NULL,NULL,'2MASX J20580953-4349496',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.88',0.23,NULL,NULL,NULL,NULL,NULL,1,314.539875,-43.83053,0.073,NULL,51389978647,802968416,12546381,16.88),(148899,'D-Sigma','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148899,34.01,0.4,63.5,70729,75,NULL,'Edat, raw','NGC 6987',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00009,NULL,'13.44',1.2,'E0:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,314.543166667,-48.63031,0.073,NULL,51351846407,802372600,12537071,13.44),(148900,'D-Sigma','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148900,34.28,0.4,71.9,70729,75,NULL,'Edat, cor','NGC 6987',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148901,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148901,34.53,0.46,80.7,70729,70,NULL,NULL,'NGC 6987',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148902,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148902,34.32,0.4,73.3,70729,NULL,NULL,'mean','NGC 6987',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148903,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148903,34.64,0.45,84.5,70729,NULL,NULL,'K','NGC 6987',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148904,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148904,36.93,0.83,243,70730,70,NULL,NULL,'2MASX J20581163-1446266',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'13.3I',0.7,NULL,NULL,NULL,NULL,NULL,1,314.5485417,-14.77406,0.149,NULL,50989238340,796706849,12448544,13.3),(148905,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 02842','RN',148905,36.76,0.14,214,70731,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02842',0.052639,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148906,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 02842','RN',148906,38.59,0.72,496,70731,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02842',0.052639,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148907,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148907,35.03,0.49,102,70732,75,NULL,'IR','CGCG 400-014',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000113,NULL,'15.7',0.2,NULL,NULL,NULL,NULL,NULL,1,314.562416667,8.35833,0.265,NULL,55096253010,860878953,13451233,15.7),(148908,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148908,37.23,0.33,279,70733,70,NULL,NULL,'2MASX J20581650-0732156',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000078,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,314.568666667,-7.53764,0.225,NULL,50797584660,793712260,12401754,17.3),(148909,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 01785','RN',148909,44.05,0.58,4460,70734,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01785',0.450842,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148910,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148910,34.27,0.49,71.6,70735,70,NULL,NULL,'ESO 235- G 022',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.33',0.6,'SA(s)0^0^: pec',NULL,NULL,NULL,NULL,1,314.5754583,-49.01247,0.045,NULL,51351211055,802362672,12536916,14.33),(148911,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148911,36.6,0.23,208,70736,70,NULL,NULL,'2MASX J20582113-0021041',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,314.588083,-0.35114,0.277,NULL,47781733014,746589578,11665462,17),(148912,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 08912',NULL,148912,39.39,0.73,755,70737,70,NULL,'SN photometric redshift distance, z photo =0.195 +/- 0.092','SDSS-II SN 08912',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.1g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,314.59075,-0.16089,0.277,NULL,47781746071,746589782,11665465,21.1),(148913,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148913,35.82,0.63,146,70738,70,NULL,NULL,'2MASX J20582178-7922596',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,'E',NULL,NULL,NULL,NULL,1,314.591,-79.38325,0.617,NULL,48585934354,759155224,11861800,17),(148914,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148914,34.67,0.51,85.8,70739,70,NULL,NULL,'ESO 464- G 005',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00009,NULL,'14.89',0.8,'S?       poss. LINER','Pair member (points to parent)',NULL,NULL,NULL,1,314.604083,-31.47167,0.301,NULL,51502749870,804730466,12573913,14.89),(148915,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148915,34.68,0.49,86.2,70740,70,NULL,NULL,'2MASX J20582527-1527435',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.08',0.3,NULL,NULL,NULL,NULL,NULL,1,314.605333333,-15.46206,0.185,NULL,50987313937,796676780,12448074,15.08),(148916,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148916,35.05,0.47,103,70741,NULL,NULL,'H','ESO 598- G 009',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000033,NULL,'14.26',0.5,'Sb pec         HII','in a triple',NULL,NULL,NULL,1,314.618916667,-19.98142,0.209,NULL,50948639778,796072496,12438632,14.26),(148917,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148917,35.11,0.46,105,70741,NULL,NULL,'J','ESO 598- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148918,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148918,35.12,0.45,106,70741,NULL,NULL,'K','ESO 598- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148919,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148919,35.29,0.4,114,70741,NULL,NULL,'mean','ESO 598- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148920,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148920,35.35,0.27,117,70741,NULL,NULL,NULL,'ESO 598- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148921,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148921,35.39,0.2,120,70741,74.4,NULL,NULL,'ESO 598- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148922,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148922,35.41,0.26,121,70741,NULL,NULL,'Malmquist cor.','ESO 598- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148923,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148923,35.97,0.56,156,70742,70,NULL,NULL,'2MASX J20582978-5842539',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.00015,NULL,'15.83',0.63,'E',NULL,NULL,NULL,NULL,1,314.624,-58.71492,0.217,NULL,49137181728,767768464,11996382,15.83),(148924,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148924,38.62,0.46,528,70743,70,NULL,NULL,'2MASX J20582993+0107397',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000192,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,314.624625,1.12769,0.281,NULL,55029876630,859841822,13435028,17.7),(148925,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148925,37.14,0.46,268,70744,70,NULL,NULL,'2MASX J20583186+0039137',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000183,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,314.632833,0.65394,0.269,NULL,55029405641,859834463,13434913,17),(148926,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148926,37.01,0.46,253,70745,70,NULL,NULL,'2MASX J20583225-0736410',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000074,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,314.6345,-7.6115,0.225,NULL,50797589372,793712333,12401755,17.4),(148927,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148927,37.67,0.46,342,70746,70,NULL,NULL,'SDSS J205832.79-001040.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000133,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,314.636666667,-0.17781,0.277,NULL,47781751154,746589861,11665466,18.5),(148928,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148928,36.07,0.54,164,70747,70,NULL,NULL,'2MASX J20583502-6047036',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'16.3b',0.25,NULL,NULL,NULL,NULL,NULL,1,314.645833,-60.78439,0.169,NULL,49190554853,768602419,12009412,16.3),(148929,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148929,36.1,0.5,166,70748,70,NULL,NULL,'PKS 2054-581',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.000103,NULL,'15.0',0.53,'S0',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,314.6565417,-57.94333,0.201,NULL,49140239540,767816242,11997128,15),(148930,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148930,36.65,0.63,214,70749,70,NULL,NULL,'2MASX J20583812-4316373',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.83',0.57,'E',NULL,NULL,NULL,NULL,1,314.658833,-43.27703,0.065,NULL,51391911852,802998622,12546853,15.83),(148931,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148931,35.99,0.46,158,70750,70,NULL,NULL,'CGCG 374-034',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000157,NULL,'15.1g',0.64,'E0',NULL,NULL,NULL,NULL,1,314.659375,0.91258,0.281,NULL,55030177609,859846525,13435101,15.1),(148932,'IRAS','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148932,33.93,0.8,61,70751,75,NULL,'MAT, I','ESO 187- G 039',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.94',0.9,'SAB(s)dm?',NULL,NULL,NULL,NULL,1,314.6947917,-52.80767,0.085,NULL,51341760333,802215005,12534609,14.94),(148933,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148933,32.96,0.32,39.1,70751,85,NULL,'I, inv','ESO 187- G 039',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148934,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148934,32.97,0.32,39.3,70751,85,NULL,'I, raw','ESO 187- G 039',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148935,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148935,33.06,0.43,40.9,70751,75,NULL,'MAT, I, inv','ESO 187- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148936,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148936,33.07,0.43,41.1,70751,75,NULL,'MAT, I, raw','ESO 187- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148937,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148937,33.4,0.43,47.8,70751,75,NULL,'MAT, I, cor','ESO 187- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148938,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148938,37.03,0.54,255,70752,70,NULL,NULL,'2MASX J20584861-4520053',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.00015,NULL,'15.63',0.6,'E',NULL,NULL,NULL,NULL,1,314.7025,-45.33489,0.025,NULL,51405164520,803205695,12550088,15.63),(148939,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148939,34.78,0.54,90.5,70753,70,NULL,NULL,'MCG -02-53-015',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00007,NULL,'15',0.9,NULL,NULL,NULL,NULL,NULL,1,314.70775,-14.03958,0.129,NULL,50989821063,796715954,12448686,15),(148940,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148940,36.92,0.61,242,70754,70,NULL,NULL,'2MASX J20585166-5301173',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.97',0.27,NULL,NULL,NULL,NULL,NULL,1,314.715333,-53.02161,0.097,NULL,51338949372,802171083,12533923,16.97),(148941,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148941,35.35,0.6,117,70755,70,NULL,NULL,'2MASX J20585908-1820261',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,314.746083333,-18.34069,0.185,NULL,50998691607,796854556,12450852,14),(148942,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148942,35.22,0.52,110,70756,NULL,NULL,'Malmquist cor.','ESO 341- G 023',NULL,'2009ApJS..182..474S',2009,1,1.7,NULL,'G',0.000033,NULL,'14.52',0.4,'(R\':)SB(s)bc:',NULL,NULL,NULL,NULL,1,314.752,-39.46158,0.013,NULL,51527193677,805112401,12579881,14.52),(148943,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148943,35.34,0.49,117,70756,NULL,NULL,NULL,'ESO 341- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148944,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148944,35.38,0.2,119,70756,74.4,NULL,NULL,'ESO 341- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148945,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148945,35.51,0.4,126,70756,NULL,NULL,'mean','ESO 341- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148946,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148946,35.63,0.47,134,70756,NULL,NULL,'H','ESO 341- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148947,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148947,33.96,0.43,61.9,70757,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11656',NULL,'2014MNRAS.444..527S',2014,1,0.96,NULL,'G',NULL,NULL,'15.69',0.13,'Scd',NULL,NULL,NULL,NULL,1,314.7724583,11.28144,0.349,NULL,55080548568,860633571,13447399,15.69),(148948,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148948,34.06,0.49,65,70757,75,NULL,'IR','UGC 11656',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148949,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148949,34.09,0.43,65.8,70757,75,NULL,'3.6 micron, color corrected','UGC 11656',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148950,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148950,34.18,0.2,68.6,70757,74.4,NULL,NULL,'UGC 11656',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148951,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148951,34.19,0.28,68.8,70757,NULL,NULL,NULL,'UGC 11656',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148952,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148952,34.22,0.28,70,70757,NULL,NULL,'Malmquist cor.','UGC 11656',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148953,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148953,34.8,NULL,91.4,70757,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11656',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148954,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148954,34.82,NULL,92,70757,NULL,NULL,'Dipole + Quadrupole','UGC 11656',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148955,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148955,34.83,NULL,92.5,70757,NULL,NULL,'Dipole','UGC 11656',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148956,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148956,36.03,0.52,161,70758,70,NULL,NULL,'2MASX J20590569-5428305',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'16.27',0.48,'S0',NULL,NULL,NULL,NULL,1,314.773666667,-54.47511,0.121,NULL,51338318742,802161230,12533769,16.27),(148957,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148957,36.6,0.23,208,70759,70,NULL,NULL,'2MASX J20590822-0014219',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000175,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,314.78425,-0.2395,0.277,NULL,47781559553,746586868,11665419,17.1),(148958,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148958,36.66,0.78,214,70760,70,NULL,NULL,'2MASX J20590925-5428575',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'16.0b',0.35,'S',NULL,NULL,NULL,NULL,1,314.788583,-54.48261,0.121,NULL,51338318722,802161230,12533769,16),(148959,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148959,36.6,0.23,208,70761,70,NULL,NULL,'2MASX J20591037-0033029',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,314.7930417,-0.55086,0.245,NULL,50734411182,792725174,12386330,17.5),(148960,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148960,36.3,0.52,182,70762,70,NULL,NULL,'2MASX J20591502-5207113',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.3b',0.32,NULL,NULL,NULL,NULL,NULL,1,314.812667,-52.11983,0.053,NULL,51342392541,802224883,12534763,16.3),(148961,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148961,36.24,0.51,177,70763,70,NULL,NULL,'2MASX J20591516-5101343',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.4b',0.43,NULL,NULL,NULL,NULL,NULL,1,314.813167,-51.02628,0.037,NULL,51352181430,802377834,12537153,16.4),(148962,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148962,36.56,0.74,205,70764,70,NULL,NULL,'2MASX J20591748-1642317',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.07',0.3,NULL,NULL,NULL,NULL,NULL,1,314.822875,-16.70872,0.185,NULL,51002701768,796917215,12451831,16.07),(148963,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148963,36.17,0.72,172,70765,70,NULL,NULL,'2MASX J20592192-5621096',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'17.28',0.17,NULL,NULL,NULL,NULL,NULL,1,314.8414583,-56.35264,0.113,NULL,49127829031,767622328,11994098,17.28),(148964,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148964,35.92,0.62,153,70766,70,NULL,NULL,'2MASX J20592276-2118501',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'16.12',0.44,NULL,NULL,NULL,NULL,NULL,1,314.8447917,-21.31408,0.193,NULL,50951536319,796117754,12439339,16.12),(148965,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148965,37.2,0.6,275,70767,70,NULL,NULL,'2MASX J20592451-5422566',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.7b',0.35,NULL,NULL,NULL,NULL,NULL,1,314.852,-54.38236,0.109,NULL,51338326141,802161345,12533771,16.7),(148966,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148966,37.43,0.81,306,70768,70,NULL,NULL,'2MASX J20592757-5717156',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.92',0.29,NULL,NULL,NULL,NULL,NULL,1,314.865083,-57.28758,0.281,NULL,49139439041,767803735,11996933,16.92),(148967,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148967,38.28,0.46,454,70769,70,NULL,NULL,'2MASX J20592798+0041157',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,314.866667,0.68758,0.253,NULL,55029448437,859835131,13434923,18.1),(148968,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2006jj',NULL,148968,40.04,0.11,1020,70770,70,NULL,'Hubble residual 0.03 for z0.27010','SDSS J205934.81+011323.7',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,314.895125,1.22328,0.293,NULL,55030084374,859845068,13435079,NULL),(148969,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14298','R',148969,40.83,0.14,1150,70770,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006jj','SDSS J205934.81+011323.7',0.2701,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148970,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14298','R',148970,40.86,0.22,1170,70770,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006jj','SDSS J205934.81+011323.7',0.2701,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148971,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148971,36.13,0.51,168,70771,70,NULL,NULL,'2MASX J20593583-5159176',NULL,'2014MNRAS.445.2677S',2014,1,1.02,NULL,'G',0.00015,NULL,'15.26',0.52,'S0',NULL,NULL,NULL,NULL,1,314.899375,-51.98822,0.053,NULL,51341510311,802211098,12534548,15.26),(148972,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148972,36.6,0.23,208,70772,70,NULL,NULL,'2MASX J20593860-0002133',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00015,NULL,'16.3g',0.26,'E0',NULL,NULL,NULL,NULL,1,314.9107917,-0.03708,0.265,NULL,47781526221,746586347,11665411,16.3),(148973,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 16722','RN',148973,41,0.3,1180,70773,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16722',0.3448,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148974,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 16722','RN',148974,41.26,0.26,1330,70773,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16722',0.3448,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148975,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148975,35.95,0.55,155,70774,70,NULL,NULL,'2MFGC 15895',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,314.9309583,-69.64611,0.161,NULL,49338641022,770916265,12045566,16.5),(148976,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148976,36.59,0.63,208,70775,70,NULL,NULL,'2MASX J20594609-5352216',NULL,'2014MNRAS.445.2677S',2014,1,0.27,NULL,'G',0.00015,NULL,'15.6R',0.14,NULL,NULL,NULL,NULL,NULL,1,314.942083,-53.87267,0.113,NULL,51338445506,802163211,12533800,15.6),(148977,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 13716',NULL,148977,40.33,0.15,1170,70776,70,NULL,'SN photometric redshift distance, z photo =0.322 +/- 0.028','SDSS-II SN 13716',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,314.954167,0.48847,0.261,NULL,55029527759,859836371,13434943,NULL),(148978,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148978,36.06,0.66,163,70777,70,NULL,NULL,'FAIRALL 0577',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,'Eastern',NULL,NULL,NULL,NULL,1,314.975625,-80.76881,0.529,NULL,48574037079,758969329,11858895,17.2),(148979,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148979,34.93,0.46,96.6,70778,70,NULL,NULL,'FAIRALL 0929',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'15.60',0.9,'E2:',NULL,NULL,NULL,NULL,1,314.993375,-49.03703,0.049,NULL,51351714847,802370544,12537039,15.6),(148980,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 21042','R',148980,40.87,0.25,1140,70779,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007qz','SN 2007qz',0.312,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,315.0115417,0.82758,0.253,NULL,55030255197,859847737,13435120,NULL),(148981,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 21042','R',148981,41.06,0.18,1240,70779,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007qz','SN 2007qz',0.312,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148982,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148982,37.13,0.46,267,70780,70,NULL,NULL,'2MASX J21000403+0011537',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000182,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,315.01675,0.19839,0.257,NULL,55029328126,859833251,13434894,16.8),(148983,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148983,38.45,0.46,490,70781,70,NULL,NULL,'SDSS J210004.78+001915.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000139,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,315.0199583,0.32097,0.261,NULL,55029321116,859833142,13434892,18.3),(148984,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 03034','RN',148984,40.72,0.1,1130,70782,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03034',0.232492,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148985,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 03034','RN',148985,40.83,0.2,1190,70782,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03034',0.232492,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148986,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148986,36.23,0.95,177,70783,70,NULL,NULL,'2MASX J21000757-6942231',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,315.03175,-69.70642,0.165,NULL,49338631661,770916119,12045564,15.4),(148987,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148987,35.26,0.7,113,70784,70,NULL,NULL,'2MASX J21001075-5911012',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.000103,NULL,'15.1r',0.38,NULL,NULL,NULL,NULL,NULL,1,315.044708333,-59.18369,0.197,NULL,49136333090,767755204,11996175,15.1),(148988,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 15341','RN',148988,40.68,0.14,1230,70785,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 15341',0.105802,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148989,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 15341','RN',148989,41.25,0.22,1610,70785,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 15341',0.105802,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148990,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148990,35.37,0.53,119,70786,70,NULL,NULL,'IC 1341',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.2b',0.3,NULL,NULL,NULL,NULL,NULL,1,315.0695,-13.97633,0.129,NULL,50989436415,796709943,12448592,15.2),(148991,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148991,36.54,0.46,203,70787,70,NULL,NULL,'2MASX J21001817-0638346',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000089,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,315.075875,-6.64286,0.173,NULL,50797470902,793710482,12401726,16.8),(148992,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148992,37.3,0.72,289,70788,70,NULL,NULL,'2MASX J21001839-4615443',NULL,'2014MNRAS.445.2677S',2014,1,1.05,NULL,'G',0.00015,NULL,'15.13',0.52,'(R\')SA(r)0/a',NULL,NULL,NULL,NULL,1,315.0765417,-46.26236,0.041,NULL,51402202720,803159417,12549365,15.13),(148993,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148993,36.95,0.54,245,70789,70,NULL,NULL,'2MASX J21001910-3315460',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.000103,NULL,'15.0r',0.33,NULL,NULL,NULL,NULL,NULL,1,315.079667,-33.26289,0.309,NULL,51536682825,805260669,12582197,15),(148994,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148994,36.17,0.64,172,70790,70,NULL,NULL,'2MASX J21002323-5903432',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.000103,NULL,'15.0r',0.3,NULL,NULL,NULL,NULL,NULL,1,315.0967917,-59.06197,0.197,NULL,49136509418,767757959,11996218,15),(148995,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148995,36.54,0.57,204,70791,70,NULL,NULL,'2MASX J21002613-0322080',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.58',0.2,NULL,NULL,NULL,NULL,NULL,1,315.109125,-3.36894,0.261,NULL,50750075669,792969932,12390155,16.58),(148996,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148996,36.25,0.49,177,70792,70,NULL,NULL,'ESO 286- G 022',NULL,'2014MNRAS.445.2677S',2014,1,0.81,NULL,'G',0.000093,NULL,'14.0r',0.6,'Compact',NULL,NULL,NULL,NULL,1,315.1195,-42.42319,0.069,NULL,51392600471,803009382,12547021,14),(148997,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148997,36.69,0.97,217,70793,70,NULL,NULL,'2MASX J21003025-5427502',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'15.1r',0.38,NULL,NULL,NULL,NULL,NULL,1,315.126,-54.46389,0.117,NULL,51338342244,802161597,12533774,15.1),(148998,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148998,37.36,0.46,296,70794,70,NULL,NULL,'2MASX J21003133+0021452',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,315.130667,0.36247,0.261,NULL,55029299287,859832801,13434887,17.3),(148999,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148999,33.09,0.2,41.5,70795,74.4,NULL,NULL,'UGC 11660',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',NULL,NULL,'16.0',0.2,'S?',NULL,NULL,NULL,NULL,1,315.131667,13.49139,0.381,NULL,55281942416,863780350,13496567,16),(149000,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149000,33.23,0.64,44.3,70795,NULL,NULL,NULL,'UGC 11660',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149001,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149001,33.77,0.5,56.8,70795,NULL,NULL,'Malmquist cor.','UGC 11660',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149002,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149002,36.69,0.61,218,70796,70,NULL,NULL,'2MASX J21003596-3809061',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.6r',0.3,NULL,NULL,NULL,NULL,NULL,1,315.149916667,-38.15178,0.093,NULL,51530981961,805171593,12580806,15.6),(149003,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 06501',NULL,149003,40.43,0.14,1220,70797,70,NULL,'SN photometric redshift distance, z photo =0.340 +/- 0.028','SDSS-II SN 06501',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,315.156875,0.13144,0.225,NULL,52076533329,813695833,12713997,NULL),(149004,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 11102','RN',149004,39.45,0.12,672,70798,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 11102',0.153917,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149005,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 02052','RN',149005,41.3,0.2,1270,70799,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02052',0.434518,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149006,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 02052','RN',149006,41.75,0.13,1560,70799,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02052',0.434518,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149007,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149007,33.97,0.43,62.2,70800,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7003',NULL,'2014MNRAS.444..527S',2014,1,1.1,NULL,'G',0.000017,NULL,'13.76',0.8,'Sbc',NULL,NULL,NULL,NULL,1,315.17675,17.80489,0.373,NULL,55294403450,863975053,13499610,13.76),(149008,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149008,34,0.43,63,70800,75,NULL,'3.6 micron, color corrected','NGC 7003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149009,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149009,34.03,0.3,63.9,70800,NULL,NULL,NULL,'NGC 7003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149010,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149010,34.04,0.2,64.3,70800,74.4,NULL,NULL,'NGC 7003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149011,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149011,34.22,0.27,70,70800,NULL,NULL,'Malmquist cor.','NGC 7003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149012,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149012,34.23,0.46,70.1,70800,NULL,NULL,'J','NGC 7003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149013,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149013,34.25,0.47,70.9,70800,NULL,NULL,'H','NGC 7003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149014,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149014,34.27,0.4,71.5,70800,NULL,NULL,'mean','NGC 7003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149015,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149015,34.33,0.45,73.4,70800,NULL,NULL,'K','NGC 7003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149016,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 13411',NULL,149016,39.16,0.09,681,70801,70,NULL,'Hubble residual 0.13 for z0.16300','SDSS J210045.52+001130.3',NULL,'2011ApJ...740...92G',2011,1,0.07,NULL,'G',0.0005,NULL,'21.9g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,315.189666667,0.19175,0.233,NULL,52076516880,813695576,12713993,21.9),(149017,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 13411','R',149017,39.68,0.21,743,70801,70,NULL,'SDSS CAND. SNIa; SALT 2','SDSS J210045.52+001130.3',0.163,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149018,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 13411','R',149018,39.81,0.12,788,70801,70,NULL,'SDSS CAND. SNIa; MLCS2K2','SDSS J210045.52+001130.3',0.163,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149019,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149019,35.75,0.52,141,70802,70,NULL,NULL,'6dF J2100494-324344',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,315.205833,-32.72883,0.313,NULL,51499768710,804683886,12573185,14.3),(149020,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149020,38.71,0.46,551,70803,70,NULL,NULL,'2MASX J21004950-0540256',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000104,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,315.2064583,-5.67381,0.169,NULL,50747114692,792923667,12389432,17.5),(149021,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149021,34.58,0.92,82.5,70804,NULL,NULL,'Malmquist cor.','ESO 235- G 033',NULL,'2009ApJS..182..474S',2009,1,1.8,NULL,'G',0.000033,NULL,'12.7r',1.5,'SA(s)c',NULL,NULL,NULL,NULL,1,315.2122917,-48.59861,0.073,NULL,51351739560,802370930,12537045,12.7),(149022,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149022,35.28,0.66,114,70804,NULL,NULL,NULL,'ESO 235- G 033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149023,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149023,35.32,0.2,116,70804,74.4,NULL,NULL,'ESO 235- G 033',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149024,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149024,34.66,0.51,85.6,70805,70,NULL,NULL,'ESO 235-IG 034 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,315.221833,-48.23969,0.073,NULL,51351015449,802359616,12536869,15.9),(149025,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149025,36.22,0.52,175,70806,70,NULL,NULL,'ESO 235- G 032',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000143,NULL,'13.2r',0.7,'SA(r)0+',NULL,NULL,NULL,NULL,1,315.2282917,-52.22414,0.053,NULL,51342299913,802223436,12534741,13.2),(149026,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149026,34.87,0.48,94.1,70807,70,NULL,NULL,'IC 1343',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00009,NULL,'15.10',0.7,NULL,NULL,NULL,NULL,NULL,1,315.25275,-15.40369,0.165,NULL,50988636762,796697449,12448397,15.1),(149027,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149027,35.97,0.65,156,70808,70,NULL,NULL,'2MASX J21010534-4108117',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'17.19',0.21,NULL,NULL,NULL,NULL,NULL,1,315.2722917,-41.13664,0.049,NULL,51388782528,802949727,12546089,17.19),(149028,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149028,34.4,0.5,75.8,70809,70,NULL,NULL,'NGC 7001',NULL,'2014MNRAS.445.2677S',2014,1,1.25,NULL,'G',0.000087,NULL,'13.8g',1.06,'SAB(rs)ab:',NULL,NULL,NULL,NULL,1,315.2822917,-0.19517,0.217,NULL,49660580245,775946566,12124165,13.8),(149029,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149029,36.07,0.71,163,70810,70,NULL,NULL,'2MASX J21011018-2813280',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.000087,NULL,'15.5r',0.2,NULL,NULL,NULL,NULL,NULL,1,315.292417,-28.22444,0.429,NULL,51492551389,804571115,12571423,15.5),(149030,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149030,36.33,0.58,184,70811,70,NULL,NULL,'ESO 598- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'14.4r',0.7,'S0',NULL,NULL,NULL,NULL,1,315.301583333,-18.02569,0.185,NULL,50998612214,796853315,12450833,14.4),(149031,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 01787','RN',149031,42.5,0.21,2080,70812,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01787',0.519749,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149032,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149032,34.09,NULL,65.9,70813,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2299',NULL,'2010Ap&SS.325..163P',2010,1,1.04,'Matthews (2000A&AS..143..421M) detects another feature at v=6222 km/sec.','G',0.000137,NULL,'16.2',0.13,'Sdm',NULL,NULL,NULL,NULL,1,315.314583,-17.13361,0.213,NULL,51002402552,796912539,12451758,16.2),(149033,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149033,34.11,NULL,66.5,70813,NULL,NULL,'Dipole + Quadrupole','FGC 2299',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149034,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149034,34.12,NULL,66.8,70813,NULL,NULL,'Dipole','FGC 2299',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149035,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149035,34.17,NULL,68.3,70813,NULL,NULL,NULL,'FGC 2299',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149036,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 04968','RN',149036,40.6,0.16,1120,70814,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 04968',0.182045,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149037,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 04968','RN',149037,41.06,0.21,1380,70814,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 04968',0.182045,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149038,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149038,35.84,0.64,148,70815,70,NULL,NULL,'2MASX J21011852-5238569',NULL,'2014MNRAS.445.2677S',2014,1,0.32,NULL,'G',0.00015,NULL,'15.0r',0.19,NULL,NULL,NULL,NULL,NULL,1,315.327333,-52.64914,0.069,NULL,51342121873,802220654,12534697,15),(149039,'IRAS','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149039,32.95,0.8,38.8,70816,75,NULL,'MAT, I','IC 5071',NULL,'1997ApJS..109..333W',1997,1,3.4,NULL,'G',0.00002,NULL,'13.26',0.8,'SAB(s)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,315.33225,-72.64272,0.161,NULL,49325855596,770716493,12042445,13.26),(149040,'Tully est','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149040,32.93,0.8,38.5,70816,75,NULL,NULL,'IC 5071',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149041,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149041,32.45,0.4,30.9,70816,NULL,NULL,NULL,'IC 5071',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149042,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149042,32.45,0.4,30.9,70816,73,NULL,'opt','IC 5071',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149043,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149043,32.51,0.43,31.8,70816,75,NULL,'MAT, I, raw','IC 5071',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149044,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149044,32.62,0.32,33.4,70816,85,NULL,'I, raw','IC 5071',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149045,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149045,32.66,0.32,34.1,70816,85,NULL,'I, inv','IC 5071',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149046,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149046,32.72,0.43,35,70816,75,NULL,'MAT, I, inv','IC 5071',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149047,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149047,32.83,0.49,36.8,70816,75,NULL,'IR','IC 5071',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149048,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149048,32.85,0.43,37.1,70816,75,NULL,'MAT, I, cor','IC 5071',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149049,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 20794','RN',149049,42.9,0.2,2280,70817,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20794',0.661744,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149050,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149050,36.54,0.54,203,70818,70,NULL,NULL,'2MASX J21012236-5430448',NULL,'2014MNRAS.445.2677S',2014,1,0.51,'The APMUKS image includes a superposed star.','G',0.00015,NULL,'14.8r',0.4,NULL,NULL,NULL,NULL,NULL,1,315.3432083,-54.51247,0.117,NULL,50600139021,790627172,12353549,14.8),(149051,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149051,37.03,0.46,254,70819,70,NULL,NULL,'2MASX J21012489+1035015',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,315.3537917,10.58389,0.341,NULL,55083097746,860673402,13448021,17.2),(149052,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149052,34.52,0.5,80.4,70820,70,NULL,NULL,'ESO 286- G 026',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000133,NULL,'13.5r',0.8,'S(rl)0^0','Pair member (points to parent)',NULL,NULL,NULL,1,315.382166667,-46.03753,0.037,NULL,51401555643,803149306,12549207,13.5),(149053,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2007pa',NULL,149053,38.63,0.07,533,70821,70,NULL,'Hubble residual -0.33 for z0.15710','SDSS J210134.34-001610.9',NULL,'2011ApJ...740...92G',2011,1,0.05,NULL,'G',0.0008,NULL,'21.6g',0.04,NULL,NULL,NULL,NULL,NULL,1,315.393125,-0.26972,0.217,NULL,49660820308,775950317,12124223,21.6),(149054,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 19940','R',149054,39.1,0.2,572,70821,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007pa','SDSS J210134.34-001610.9',0.1571,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149055,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 19940','R',149055,39.25,0.09,613,70821,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007pa','SDSS J210134.34-001610.9',0.1571,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149056,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149056,36.04,0.55,162,70822,70,NULL,NULL,'IC 1346',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'15',0.5,NULL,NULL,NULL,NULL,NULL,1,315.40425,-13.96069,0.121,NULL,50989471761,796710496,12448601,15),(149057,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149057,36.31,0.25,183,70823,74.4,NULL,NULL,'NGC 6998',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000028,NULL,'15.16',0.7,'E0;Radio galaxy','Group member, 2nd ranked galaxy',NULL,'radio jet',NULL,1,315.407,-28.03192,0.421,NULL,51493349112,804583579,12571618,15.16),(149058,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149058,36.55,0.51,204,70823,70,NULL,NULL,'NGC 6998',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149059,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149059,36.05,0.4,162,70823,NULL,NULL,'mean','NGC 6998',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149060,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149060,36.3,0.45,182,70823,NULL,NULL,'K','NGC 6998',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149061,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149061,34.49,0.49,79.1,70824,70,NULL,NULL,'2MASX J21013815-4252587',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'16.06',0.35,'E',NULL,NULL,NULL,NULL,1,315.408917,-42.88303,0.061,NULL,51392737662,803011525,12547055,16.06),(149062,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149062,36.13,0.25,168,70825,74.4,NULL,NULL,'2MASX J21013847-2753583',NULL,'2013AJ....146...86T',2013,1,0.52,NULL,'G',0.000019,NULL,'14.9r',0.37,NULL,NULL,NULL,NULL,NULL,1,315.410375,-27.89944,0.421,NULL,51493345090,804583517,12571617,14.9),(149063,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149063,35.49,0.25,125,70826,74.4,NULL,NULL,'2MASX J21013882-2818093',NULL,'2013AJ....146...86T',2013,1,0.49,NULL,'G',0.000025,NULL,'14.9r',0.43,NULL,NULL,NULL,NULL,NULL,1,315.411583,-28.30258,0.429,NULL,51492524358,804570693,12571417,14.9),(149064,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 12836','RN',149064,42.72,0.22,2560,70827,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 12836',0.369564,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149065,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 12836','RN',149065,42.86,0.17,2730,70827,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 12836',0.369564,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149066,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149066,36.27,0.48,179,70828,70,NULL,NULL,'MCG -07-43-011',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.000133,NULL,'15.76',0.52,'E',NULL,NULL,NULL,NULL,1,315.4247917,-38.49781,0.085,NULL,51527390803,805115481,12579929,15.76),(149067,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149067,36.54,0.46,203,70829,70,NULL,NULL,'2MASX J21014305+1017525',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,315.4292917,10.29792,0.261,NULL,55083177462,860674647,13448041,17),(149068,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149068,35.16,0.52,108,70830,70,NULL,NULL,'IC 1348',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.33',NULL,NULL,NULL,NULL,NULL,NULL,1,315.4337917,-13.358,0.137,NULL,50986606805,796665731,12447902,15.33),(149069,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149069,35.71,0.52,139,70831,70,NULL,NULL,'2MASX J21014443-4909008',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'14.7r',0.25,NULL,NULL,NULL,NULL,NULL,1,315.435083333,-49.15019,0.033,NULL,51351569633,802368275,12537004,14.7),(149070,'Magnitude','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149070,35.36,0.13,118,70832,100,NULL,NULL,'ABELL 3733',NULL,'1998A&A...337...31R',1998,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I-II   [BM];RI [A]',NULL,NULL,NULL,NULL,1,315.452917,-28.035,0.421,NULL,51493348374,804583568,12571618,NULL),(149071,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149071,35.12,0.46,106,70833,70,NULL,NULL,'2MASX J21014980-4933238',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.0r',0.47,'(R)SA(rl)0^0',NULL,NULL,NULL,NULL,1,315.457417,-49.55664,0.049,NULL,51354389062,802412329,12537692,14),(149072,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 20431',NULL,149072,40.71,0.23,1390,70834,70,NULL,'SN photometric redshift distance, z photo =0.399 +/- 0.059','SDSS-II SN 20431',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,315.459041667,0.48569,0.249,NULL,52076672507,813698007,12714031,NULL),(149073,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149073,34.8,0.47,91.4,70835,70,NULL,NULL,'IC 1350',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00009,NULL,'15',0.4,NULL,NULL,NULL,NULL,NULL,1,315.467875,-13.85267,0.121,NULL,50986637531,796666211,12447909,15),(149074,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149074,35.21,0.52,110,70836,70,NULL,NULL,'2MASX J21015340-4825328',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'14.3r',0.43,'S0',NULL,NULL,NULL,NULL,1,315.472625,-48.42572,0.073,NULL,51351003865,802359435,12536866,14.3),(149075,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149075,35.03,0.25,101,70837,74.4,NULL,NULL,'2MASX J21015558-2745563',NULL,'2013AJ....146...86T',2013,1,0.58,NULL,'G',0.000017,NULL,'14.7r',0.5,'S0',NULL,NULL,NULL,NULL,1,315.4817917,-27.76539,0.369,NULL,51492852167,804575815,12571497,14.7),(149076,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149076,36.01,0.61,160,70838,70,NULL,NULL,'2MASX J21015626-4338174',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'15.2r',0.32,NULL,NULL,NULL,NULL,NULL,1,315.484333,-43.63811,0.057,NULL,51391276816,802988700,12546698,15.2),(149077,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149077,35.73,0.51,140,70839,70,NULL,NULL,'2MASX J21015941-2815363',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.000019,NULL,'14.2r',0.58,'S0',NULL,NULL,NULL,NULL,1,315.497625,-28.26008,0.429,NULL,51492033374,804563021,12571297,14.2),(149078,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149078,35.77,0.25,143,70839,74.4,NULL,NULL,'2MASX J21015941-2815363',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149079,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149079,36.52,0.25,201,70840,74.4,NULL,NULL,'NGC 6999',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000036,NULL,'14.97',0.7,'SA(s)0^0^','Brightest group member',NULL,NULL,NULL,1,315.498083,-28.05892,0.421,NULL,51492489041,804570141,12571408,14.97),(149080,'Magnitude','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149080,35.36,0.13,118,70840,100,NULL,NULL,'NGC 6999',NULL,'1998A&A...337...31R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149081,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149081,36.03,0.45,160,70840,NULL,NULL,'K','NGC 6999',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149082,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149082,36.03,0.4,161,70840,NULL,NULL,'mean','NGC 6999',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149083,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149083,37.67,0.46,343,70841,70,NULL,NULL,'2MASX J21015950+1037170',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,315.4979583,10.62131,0.341,NULL,55083245120,860675705,13448057,17.8),(149084,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 01823',NULL,149084,39.55,0.21,813,70842,70,NULL,'SN photometric redshift distance, z photo =0.212 +/- 0.024','SDSS-II SN 01823',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','22.3g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,315.5085,0.36453,0.249,NULL,52076682213,813698159,12714033,22.3),(149085,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149085,34.76,0.25,89.5,70843,74.4,NULL,NULL,'2MASX J21020299-2823543',NULL,'2013AJ....146...86T',2013,1,0.65,NULL,'G',0.000017,NULL,'13.9r',0.57,'S0',NULL,NULL,NULL,NULL,1,315.512583,-28.39839,0.445,NULL,51492057164,804563393,12571303,13.9),(149086,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149086,34.73,0.47,88.5,70844,70,NULL,NULL,'MCG -01-53-020',NULL,'2014MNRAS.445.2677S',2014,1,1.32,NULL,'G',0.000037,NULL,'14.2g',0.98,'SB(rs)b',NULL,NULL,NULL,NULL,1,315.514833,-6.29686,0.153,NULL,50790094297,793595223,12399925,14.2),(149087,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149087,35.57,0.25,130,70845,74.4,NULL,NULL,'2MASX J21020388-2752163',NULL,'2013AJ....146...86T',2013,1,0.93,NULL,'G',0.000022,NULL,'14.0r',0.58,'S0',NULL,NULL,NULL,NULL,1,315.5157083,-27.871,0.421,NULL,51492824613,804575384,12571490,14),(149088,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149088,36.03,0.51,161,70845,70,NULL,NULL,'2MASX J21020388-2752163',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149089,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149089,37.89,0.46,379,70846,70,NULL,NULL,'2MASX J21020794-0522093',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000081,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,315.533125,-5.36928,0.185,NULL,50746949658,792921088,12389392,17.8),(149090,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149090,35.72,0.47,140,70847,70,NULL,NULL,'2MASX J21020977-1257282',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.30',NULL,NULL,NULL,NULL,NULL,NULL,1,315.540667,-12.95803,0.145,NULL,50956675292,796198051,12440594,15.3),(149091,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149091,36.18,0.49,172,70848,70,NULL,NULL,'2MASX J21021109-5100077',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'15.0r',0.25,NULL,NULL,NULL,NULL,NULL,1,315.546291667,-51.00225,0.025,NULL,51353537495,802399023,12537484,15),(149092,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149092,36.19,0.5,173,70849,70,NULL,NULL,'2MASX J21021467-3800138',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'14.4r',0.57,'E',NULL,NULL,NULL,NULL,1,315.561125,-38.00383,0.093,NULL,51530905094,805170392,12580787,14.4),(149093,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149093,34.39,NULL,75.4,70850,NULL,NULL,NULL,'UGC 11666',NULL,'2000BSAO...50....5K',2000,1,1.01,NULL,'G',0.00006,NULL,'15.3',0.11,'Sdm',NULL,NULL,NULL,NULL,1,315.563417,15.136,0.381,NULL,55282353131,863786767,13496668,15.3),(149094,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149094,34.44,NULL,77.4,70850,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11666',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149095,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149095,34.45,NULL,77.8,70850,NULL,NULL,'Dipole','UGC 11666',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149096,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149096,34.45,NULL,77.8,70850,NULL,NULL,'Dipole + Quadrupole','UGC 11666',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149097,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149097,35.52,0.5,127,70851,70,NULL,NULL,'2MASX J21021648-1450232',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.7I',0.4,NULL,NULL,NULL,NULL,NULL,1,315.56875,-14.83975,0.157,NULL,50988715967,796698686,12448416,13.7),(149098,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149098,35.12,0.5,106,70852,70,NULL,NULL,'2MASX J21021681-1731082',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'14.5r',0.5,NULL,NULL,NULL,NULL,NULL,1,315.5699583,-17.51892,0.229,NULL,50999061547,796860336,12450942,14.5),(149099,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14317','R',149099,39.46,0.23,659,70853,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14317',0.181,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,315.570667,0.33022,0.249,NULL,52076677501,813698085,12714032,NULL),(149100,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14317','R',149100,39.57,0.1,695,70853,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14317',0.181,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149101,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149101,36.62,0.53,211,70854,70,NULL,NULL,'ESO 187- G 047',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1r',0.49,'N',NULL,NULL,NULL,NULL,1,315.5900417,-54.58864,0.125,NULL,50600105661,790626650,12353541,14.1),(149102,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149102,35.64,0.51,134,70855,70,NULL,NULL,'2MASX J21022469-1801034',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'14.5r',0.5,NULL,NULL,NULL,NULL,NULL,1,315.602958333,-18.01767,0.309,NULL,50997297990,796832781,12450512,14.5),(149103,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149103,35.35,0.68,118,70856,70,NULL,NULL,'ESO 286- G 028',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.1r',0.35,'(R\')SB(s)a?',NULL,NULL,NULL,NULL,1,315.604625,-43.49094,0.049,NULL,51391456422,802991506,12546742,14.1),(149104,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149104,36.64,0.33,212,70857,70,NULL,NULL,'2MASX J21022560+0016168',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000176,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,315.606667,0.27122,0.249,NULL,52076574073,813696469,12714007,16.5),(149105,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149105,36.82,0.85,231,70858,70,NULL,NULL,'2MASX J21022806-1446364',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.4,NULL,NULL,NULL,NULL,NULL,1,315.616917,-14.77686,0.157,NULL,50988843735,796700683,12448448,14.3),(149106,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149106,35.13,0.65,106,70859,70,NULL,NULL,'2MASX J21022946-1311404',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.3I',0.4,NULL,NULL,NULL,NULL,NULL,1,315.622833,-13.19461,0.145,NULL,50956996427,796203069,12440672,14.3),(149107,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149107,35.49,0.51,125,70860,70,NULL,NULL,'2MASX J21022993-1425554',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,315.62475,-14.43208,0.109,NULL,50989520868,796711263,12448613,14.4),(149108,'IRAS','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149108,31.48,0.8,19.7,70861,75,NULL,'MAT, I','IC 5078',NULL,'1997ApJS..109..333W',1997,1,7.4,NULL,'G',0.000005,NULL,'13.00',2.8,'SA(s)cd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,315.6302917,-16.81831,0.213,NULL,51002449237,796913269,12451769,13),(149109,'Tully est','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149109,31.55,0.8,20.4,70861,75,NULL,NULL,'IC 5078',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149110,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149110,31.19,0.4,17.3,70861,73,NULL,'IR','IC 5078',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149111,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149111,31.19,0.4,17.3,70861,75,NULL,NULL,'IC 5078',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149112,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149112,31.23,0.32,17.6,70861,85,NULL,'I, raw','IC 5078',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149113,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149113,31.24,0.32,17.7,70861,85,NULL,'I, inv','IC 5078',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149114,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149114,31.41,0.4,19.1,70861,NULL,NULL,NULL,'IC 5078',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149115,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149115,31.48,0.2,19.8,70861,74.4,NULL,NULL,'IC 5078',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149116,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149116,31.53,0.39,20.2,70861,73,NULL,'opt','IC 5078',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149117,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149117,31.55,0.43,20.4,70861,75,NULL,'3.6 micron, color corrected','IC 5078',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149118,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149118,31.62,0.41,21.1,70861,NULL,NULL,'Malmquist cor.','IC 5078',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149119,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149119,31.65,0.43,21.4,70861,75,NULL,'3.6 micron, color + selection bias corrected','IC 5078',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149120,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149120,31.68,0.43,21.7,70861,75,NULL,'MAT, I, raw','IC 5078',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149121,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149121,31.73,0.39,22.1,70861,NULL,NULL,NULL,'IC 5078',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149122,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149122,31.77,0.43,22.6,70861,75,NULL,'MAT, I, inv','IC 5078',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149123,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149123,31.84,0.49,23.4,70861,75,NULL,'IR','IC 5078',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149124,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149124,32.01,0.43,25.2,70861,75,NULL,'MAT, I, cor','IC 5078',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149125,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 07419','RN',149125,40.79,0.66,1240,70862,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07419',0.160926,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149126,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149126,35.75,0.51,141,70863,70,NULL,NULL,'6dF J2102370-353036',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'14.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,315.65425,-35.51006,0.449,NULL,51539217909,805300279,12582816,14.2),(149127,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149127,37.43,0.46,306,70864,70,NULL,NULL,'2MASX J21023849+0010461',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,315.6604583,0.17953,0.233,NULL,52076548136,813696064,12714001,17.4),(149128,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149128,36.73,0.46,222,70865,70,NULL,NULL,'2MASX J21023902+1049300',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,315.6625,10.825,0.321,NULL,55080158609,860627478,13447304,17.2),(149129,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149129,37.66,0.46,340,70866,70,NULL,NULL,'2MASX J21024130-0640457',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00008,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,315.6722917,-6.67947,0.241,NULL,50789966496,793593226,12399894,18.3),(149130,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149130,35.09,0.67,104,70867,70,NULL,NULL,'2MFGC 15937',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00011,NULL,'14.3r',0.4,NULL,NULL,NULL,NULL,NULL,1,315.675167,-17.27575,0.213,NULL,50998835905,796856811,12450887,14.3),(149131,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149131,33.99,0.25,62.8,70868,74.4,NULL,NULL,'ESO 235- G 039',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000017,NULL,'13.5r',0.9,'SA(rl)0^0',NULL,NULL,NULL,NULL,1,315.680833,-48.35781,0.073,NULL,51351009370,802359521,12536867,13.5),(149132,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149132,34.33,0.46,73.5,70868,70,NULL,NULL,'ESO 235- G 039',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149133,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 01921',NULL,149133,41.56,0.03,2060,70869,70,NULL,'SN photometric redshift distance, z photo =0.687 +/- 0.013','SDSS-II SN 01921',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','23.3g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,315.700167,0.8425,0.293,NULL,52077073592,813704274,12714129,23.3),(149134,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149134,35.59,0.49,131,70870,70,NULL,NULL,'IC 1356',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00009,NULL,'15.9',0.3,NULL,NULL,NULL,NULL,NULL,1,315.720833,-15.81158,0.169,NULL,51000054348,796875849,12451185,15.9),(149135,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 06912',NULL,149135,41.07,0.52,1640,70871,70,NULL,'SN photometric redshift distance, z photo =0.495 +/- 0.205','SDSS-II SN 06912',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,315.732375,-0.64258,0.237,NULL,49661529001,775961390,12124396,NULL),(149136,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 03421',NULL,149136,39.96,0.25,982,70872,70,NULL,'SN photometric redshift distance, z photo =0.263 +/- 0.038','SDSS-II SN 03421',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','22.1g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,315.7359583,0.85047,0.293,NULL,52077128734,813705136,12714142,22.1),(149137,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 06826','RN',149137,40.09,0.25,928,70873,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06826',0.123224,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149138,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 06826','RN',149138,40.27,0.35,1010,70873,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06826',0.123224,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149139,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149139,36.19,0.48,173,70874,70,NULL,NULL,'ESO 464- G 017',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'13.5r',0.7,'SA(s)0-:',NULL,NULL,NULL,NULL,1,315.751083333,-30.97864,0.345,NULL,51502143669,804720994,12573765,13.5),(149140,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149140,35.45,0.25,123,70875,74.4,NULL,NULL,'ESO 464- G 018',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000019,NULL,'13.3r',1,'E0:',NULL,NULL,NULL,NULL,1,315.757041667,-28.33922,0.429,NULL,51492069073,804563579,12571305,13.3),(149141,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149141,35.89,0.45,150,70875,NULL,NULL,'K','ESO 464- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149142,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149142,35.98,0.4,157,70875,NULL,NULL,'mean','ESO 464- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149143,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149143,36.59,0.51,208,70876,70,NULL,NULL,'2MASX J21030320-3756272',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00009,NULL,'14.7r',0.48,'E',NULL,NULL,NULL,NULL,1,315.763333,-37.94086,0.093,NULL,51530801623,805168775,12580762,14.7),(149144,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149144,37.79,0.46,362,70877,70,NULL,NULL,'2MASXi J2103037-070037',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000078,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,315.7657083,-7.01036,0.257,NULL,50790330577,793598915,12399983,18.4),(149145,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149145,35.13,0.25,106,70878,74.4,NULL,NULL,'ESO 286- G 029',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000022,NULL,'13.7r',0.7,'S0- pec?',NULL,NULL,NULL,NULL,1,315.767667,-47.14581,0.073,NULL,51399320182,803114377,12548662,13.7),(149146,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149146,35.49,0.47,126,70878,70,NULL,NULL,'ESO 286- G 029',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149147,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149147,34.23,0.4,70.3,70878,NULL,NULL,'mean','ESO 286- G 029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149148,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149148,35.69,0.45,137,70878,NULL,NULL,'K','ESO 286- G 029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149149,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149149,35.11,0.46,105,70879,70,NULL,NULL,'MCG -03-53-024',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.000057,NULL,'15.5',0.2,NULL,NULL,NULL,NULL,NULL,1,315.7717083,-16.80128,0.217,NULL,51002443319,796913176,12451768,15.5),(149150,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149150,35.62,0.54,133,70880,70,NULL,NULL,'MCG -03-53-023',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00009,NULL,'15.5',0.1,NULL,NULL,NULL,NULL,NULL,1,315.773666667,-14.52375,0.129,NULL,50988425127,796694142,12448345,15.5),(149151,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149151,36.72,0.56,221,70881,70,NULL,NULL,'2MASX J21030740-1409115',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'15.78',0.4,NULL,NULL,NULL,NULL,NULL,1,315.7807917,-14.15314,0.121,NULL,50989418196,796709659,12448588,15.78),(149152,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149152,35.3,0.5,115,70882,70,NULL,NULL,'2MASX J21030802-1351395',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000083,NULL,'15.10',0.9,NULL,NULL,NULL,NULL,NULL,1,315.783458333,-13.86097,0.125,NULL,50986539230,796664675,12447885,15.1),(149153,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2007hz',NULL,149153,38.72,0.07,554,70883,70,NULL,'Hubble residual -0.01 for z0.13933','SDSS J210308.39-010152.2',NULL,'2011ApJ...740...92G',2011,1,0.28,NULL,'G',0.000166,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,315.785,-1.03117,0.245,NULL,49660984414,775952881,12124263,17.9),(149154,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 17366','R',149154,39.01,0.19,556,70883,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007hz','SDSS J210308.39-010152.2',0.139332,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149155,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 17366','R',149155,39.35,0.09,650,70883,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007hz','SDSS J210308.39-010152.2',0.139332,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149156,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149156,35.2,0.46,110,70884,70,NULL,NULL,'MCG -03-53-025',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.000083,NULL,'14.13',1,'SAB(rs)0^0^ pec',NULL,NULL,NULL,NULL,1,315.788083333,-14.52458,0.129,NULL,50988424441,796694131,12448345,14.13),(149157,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149157,37.33,0.33,292,70885,70,NULL,NULL,'2MASX J21031093-0551136',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00008,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,315.7954583,-5.85383,0.173,NULL,50744883959,792888811,12388887,17.5),(149158,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149158,36.6,0.46,209,70886,70,NULL,NULL,'2MASX J21031218-0716131',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000062,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,315.8007917,-7.2705,0.217,NULL,50790285900,793598217,12399972,17.6),(149159,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 20432','R',149159,40.79,0.18,1100,70887,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007qk','SDSS J210314.31+002730.6',0.303,'2014arXiv1401.3317S',2014,1,0.09,NULL,'G',NULL,NULL,'20.2g',0.07,NULL,NULL,NULL,NULL,NULL,1,315.809625,0.4585,0.265,NULL,52077522037,813711281,12714238,20.2),(149160,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 20432','R',149160,40.94,0.35,1180,70887,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007qk','SDSS J210314.31+002730.6',0.303,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149161,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149161,36.28,0.46,180,70888,70,NULL,NULL,'2MASX J21031948+1056385',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000096,NULL,'15.5g',0.5,'S0',NULL,NULL,NULL,NULL,1,315.831333,10.94414,0.305,NULL,55080187675,860627932,13447311,15.5),(149162,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149162,36.44,0.53,194,70889,70,NULL,NULL,'2MASX J21031998-5132509',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00015,NULL,'14.0r',0.68,'S',NULL,NULL,NULL,NULL,1,315.833208333,-51.54744,0.033,NULL,51339842063,802185032,12534141,14),(149163,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149163,37.19,0.33,274,70890,70,NULL,NULL,'SDSS J210321.33-063337.4',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000077,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,315.838917,-6.56042,0.225,NULL,50790826723,793606667,12400104,18.8),(149164,'Brightest Stars','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149164,28.34,NULL,4.7,70891,NULL,NULL,NULL,'KKR 59',NULL,'2000A&A...362..544K',2000,1,2.3,NULL,'G',0.000013,NULL,'15.7',1.4,'Ir',NULL,NULL,NULL,NULL,1,315.8507917,57.28719,NULL,NULL,53434083629,834907556,13045430,15.7),(149165,'Brightest Stars','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149165,28.85,NULL,5.9,70891,NULL,NULL,NULL,'KKR 59',NULL,'1997AstL...23..373S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149166,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149166,35.36,0.51,118,70892,70,NULL,NULL,'2MASX J21032422-4929569',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'14.3r',0.47,'(RL)SAB0^0:',NULL,NULL,NULL,NULL,1,315.851,-49.49911,0.037,NULL,51354517337,802414333,12537723,14.3),(149167,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149167,37.19,0.33,274,70893,70,NULL,NULL,'2MASX J21032470-0635168',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000111,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,315.852875,-6.58789,0.225,NULL,50790828537,793606695,12400104,16.5),(149168,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149168,33.75,0.47,56.2,70894,70,NULL,NULL,'ESO 235- G 042',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000073,NULL,'12.9r',1,'(R\')SB(r)a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,315.862125,-48.20494,0.065,NULL,51343649405,802244521,12535070,12.9),(149169,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149169,34.81,0.55,91.8,70895,70,NULL,NULL,'6dF J2103281-351218',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,315.866875,-35.205,0.429,NULL,51539244705,805300698,12582823,13.8),(149170,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149170,35.36,0.55,118,70896,70,NULL,NULL,'2MASX J21032845-3000051',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'14.3r',0.6,'S0       poss. LINER',NULL,NULL,NULL,NULL,1,315.868583333,-30.00136,0.361,NULL,51503573954,804743343,12574114,14.3),(149171,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149171,32.2,0.5,27.5,70897,70,NULL,NULL,'ESO 107- G 004',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000023,NULL,'12.1r',1.3,'SA0^-',NULL,NULL,NULL,NULL,1,315.873417,-67.18133,0.057,NULL,49391980892,771749701,12058589,12.1),(149172,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149172,33.1,0.4,41.7,70897,NULL,NULL,'mean','ESO 107- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149173,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149173,33.35,0.45,46.8,70897,NULL,NULL,'K','ESO 107- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149174,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149174,37.33,0.33,292,70898,70,NULL,NULL,'2MASX J21032959-0553466',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000074,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,315.873417,-5.89631,0.233,NULL,50744880315,792888754,12388886,18.4),(149175,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149175,35.59,0.48,132,70899,70,NULL,NULL,'2MASX J21033278-1458357',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000053,NULL,'15.5',0.7,NULL,NULL,NULL,NULL,NULL,1,315.886625,-14.97669,0.157,NULL,50988865111,796701017,12448453,15.5),(149176,'Ring Diameter','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149176,32.2,0.84,27,70900,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7013',NULL,'1981ApJS...45..541P',1981,1,4,NULL,'G',0.000005,NULL,'12.40',1.4,'SA(r)0/a       LINER',NULL,NULL,NULL,NULL,1,315.889917,29.89747,1.209,NULL,55799718269,871870597,13622978,12.4),(149177,'Tully est','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149177,30.76,0.8,14.2,70900,75,NULL,'B','NGC 7013',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149178,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149178,35.95,0.49,155,70901,70,NULL,NULL,'2MASX J21033437-1425537',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.35',0.4,NULL,NULL,NULL,NULL,NULL,1,315.8932083,-14.43147,0.141,NULL,50988549755,796696089,12448376,15.35),(149179,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149179,36.92,0.5,242,70902,70,NULL,NULL,'2MASX J21033632-5141329',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.3r',0.63,'S0',NULL,NULL,NULL,NULL,1,315.901417,-51.69247,0.033,NULL,51339709540,802182961,12534108,14.3),(149180,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149180,37.05,0.46,257,70903,70,NULL,NULL,'2MASX J21033745+1030010',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000197,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,315.906166667,10.50033,0.269,NULL,55081985049,860656016,13447750,16.9),(149181,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149181,37.49,0.56,315,70904,70,NULL,NULL,'2MASX J21034172-5130288',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'15.1r',0.32,NULL,NULL,NULL,NULL,NULL,1,315.92375,-51.50806,0.033,NULL,51339843371,802185052,12534141,15.1),(149182,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149182,35.5,0.61,126,70905,70,NULL,NULL,'6dF J2103417-350359',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,315.924208333,-35.06628,0.389,NULL,51539300308,805301567,12582836,14.4),(149183,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149183,37.76,0.57,357,70906,70,NULL,NULL,'2MASX J21034238-4645014',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00015,NULL,'15.94',0.35,NULL,NULL,NULL,NULL,NULL,1,315.9267083,-46.75039,0.053,NULL,51399964854,803124450,12548819,15.94),(149184,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149184,38.3,0.33,457,70907,70,NULL,NULL,'SDSS J210343.11+102909.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,315.929625,10.48583,0.269,NULL,55081990134,860656095,13447751,18),(149185,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149185,38.3,0.33,457,70908,70,NULL,NULL,'2MASX J21034457+1027190',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'18.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,315.935625,10.45531,0.269,NULL,55081991228,860656112,13447751,18),(149186,'D-Sigma','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149186,34.58,0.4,82.2,70909,75,NULL,'Edat, raw','NGC 7002',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00005,NULL,'13.46',1.2,'E1 pec?','Pair member (points to parent)',NULL,NULL,NULL,1,315.936667,-49.02975,0.037,NULL,51351635003,802369296,12537020,13.46),(149187,'D-Sigma','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149187,34.91,0.4,96,70909,75,NULL,'Edat, cor','NGC 7002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149188,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149188,34.88,0.45,94.7,70909,NULL,NULL,'K','NGC 7002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149189,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149189,35.04,0.4,102,70909,NULL,NULL,'mean','NGC 7002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149190,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149190,35.39,0.25,120,70910,74.4,NULL,NULL,'2MASX J21034575-2802078',NULL,'2013AJ....146...86T',2013,1,0.55,NULL,'G',0.000022,NULL,'15.0r',0.42,'S0',NULL,NULL,NULL,NULL,1,315.940708333,-28.03533,0.409,NULL,51491725366,804558208,12571222,15),(149191,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 02002','RN',149191,39.51,0.2,760,70911,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 02002',0.051571,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149192,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 02002','RN',149192,40.31,0.34,1100,70911,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 02002',0.051571,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149193,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149193,31.39,NULL,19,70912,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2303',NULL,'2010Ap&SS.325..163P',2010,1,0.71,NULL,'G',0.000057,NULL,'17.1',0.07,'Sd',NULL,NULL,NULL,NULL,1,315.95,-17.77306,0.293,NULL,50997076320,796829317,12450458,17.1),(149194,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149194,31.48,NULL,19.7,70912,NULL,NULL,'Dipole + Quadrupole','FGC 2303',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149195,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149195,31.56,NULL,20.5,70912,NULL,NULL,'Dipole','FGC 2303',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149196,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149196,31.61,NULL,21,70912,NULL,NULL,NULL,'FGC 2303',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149197,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149197,36.82,0.72,231,70913,70,NULL,NULL,'2MASX J21034922-1605137',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.5,NULL,NULL,NULL,NULL,NULL,1,315.9550417,-16.08711,0.249,NULL,51000597071,796884329,12451317,14),(149198,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149198,37.22,0.46,278,70914,70,NULL,NULL,'2MASX J21035478-0536186',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000079,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,315.978375,-5.60514,0.237,NULL,50745778698,792902792,12389106,17.9),(149199,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14015',NULL,149199,40.37,0.15,1180,70915,70,NULL,'SN photometric redshift distance, z photo =0.328 +/- 0.028','SDSS-II SN 14015',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,315.985875,-1.10642,0.193,NULL,49661067764,775954183,12124284,NULL),(149200,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149200,36.64,0.33,212,70916,70,NULL,NULL,'2MASX J21035830+0027216',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.0g',0.24,'AGN',NULL,NULL,NULL,NULL,1,315.993083,0.45608,0.265,NULL,52077300898,813707826,12714184,17),(149201,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149201,36.49,0.7,199,70917,70,NULL,NULL,'2MASX J21035850-5149372',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'14.9r',0.23,NULL,NULL,NULL,NULL,NULL,1,315.99375,-51.82703,0.029,NULL,51339664897,802182264,12534097,14.9),(149202,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149202,35.05,0.49,102,70918,70,NULL,NULL,'NGC 7004',NULL,'2014MNRAS.445.2677S',2014,1,1.31,NULL,'G',0.000133,NULL,'13.8',0.44,'(R\'_2)SAB(s)a','Pair member (points to parent)',NULL,NULL,NULL,1,316.009083,-49.11425,0.021,NULL,51351634854,802369294,12537020,13.8),(149203,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149203,36.62,0.46,211,70919,70,NULL,NULL,'2MASX J21040411+0955034',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000199,NULL,'16.3g',0.26,'S0/a',NULL,NULL,NULL,NULL,1,316.017041667,9.91761,0.249,NULL,55082525725,860664464,13447882,16.3),(149204,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149204,36.12,0.46,167,70920,70,NULL,NULL,'2MASX J21040787-0046121',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00015,NULL,'16.3g',0.31,'E0',NULL,NULL,NULL,NULL,1,316.0327083,-0.77014,0.205,NULL,49660911923,775951748,12124246,16.3),(149205,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149205,36.17,0.65,172,70920,70,NULL,NULL,'2MASX J21040787-0046121',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149206,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149206,37.49,0.46,315,70921,70,NULL,NULL,'2MASX J21041045+0859424',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000161,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,316.043583,8.99514,0.325,NULL,55094207969,860846999,13450734,17.2),(149207,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149207,36.71,0.83,220,70922,70,NULL,NULL,'ESO 286- G 036',NULL,'2014MNRAS.445.2677S',2014,1,1.68,NULL,'G',0.00015,NULL,'15.98',0.22,'Sb',NULL,NULL,NULL,NULL,1,316.055,-44.90181,0.049,NULL,51402910391,803170474,12549538,15.98),(149208,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149208,36.27,0.67,179,70923,70,NULL,NULL,'2MASX J21041326-6002500',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'15.3r',0.2,NULL,NULL,NULL,NULL,NULL,1,316.0555,-60.04725,0.161,NULL,49187205390,768550084,12008595,15.3),(149209,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149209,36.28,0.53,181,70924,70,NULL,NULL,'2MASX J21041350-1823416',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,316.0562083,-18.39481,0.217,NULL,50997435788,796834934,12450545,15.5),(149210,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149210,36.09,0.5,165,70925,70,NULL,NULL,'AM 2101-353',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000127,NULL,'15.12',0.4,'INTERACTING',NULL,NULL,NULL,NULL,1,316.063458333,-35.3745,0.449,NULL,51535791479,805246741,12581980,15.12),(149211,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149211,36.38,0.62,189,70926,70,NULL,NULL,'2MASX J21041751-5439499',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'14.6r',0.3,NULL,NULL,NULL,NULL,NULL,1,316.073041667,-54.66397,0.125,NULL,50600194609,790628040,12353563,14.6),(149212,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149212,36.18,0.76,172,70927,70,NULL,NULL,'2MASX J21041869-4602556',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'15.3r',0.31,NULL,NULL,NULL,NULL,NULL,1,316.0777917,-46.04886,0.045,NULL,51401500646,803148447,12549194,15.3),(149213,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2007ko',NULL,149213,39.73,0.12,883,70928,70,NULL,'Hubble residual 0.23 for z0.20640','SDSS J210422.51-005354.4',NULL,'2011ApJ...740...92G',2011,1,0.22,NULL,'G',0.0005,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,316.093791667,-0.89847,0.205,NULL,49660951758,775952371,12124255,18.8),(149214,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 17801','R',149214,40.28,0.22,942,70928,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ko','SDSS J210422.51-005354.4',0.2064,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149215,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 17801','R',149215,40.37,0.17,985,70928,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ko','SDSS J210422.51-005354.4',0.2064,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149216,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149216,37.73,0.46,352,70929,70,NULL,NULL,'SDSS J210423.75-063006.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000071,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,316.099,-6.50194,0.229,NULL,50790776949,793605889,12400092,18.7),(149217,'Ring Diameter','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149217,33.4,0.84,47,70930,NULL,NULL,'Published at H = 100 km/s/Mpc','ESO 598- G 020',NULL,'1981ApJS...45..541P',1981,1,1.4,NULL,'G',0.000033,NULL,'13.2r',1.1,'SB(r)c',NULL,NULL,NULL,NULL,1,316.103583,-21.78047,0.153,NULL,50951215801,796112746,12439261,13.2),(149218,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149218,34.91,0.47,96,70930,NULL,NULL,'H','ESO 598- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149219,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149219,35.1,0.46,105,70930,NULL,NULL,'J','ESO 598- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149220,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149220,35.13,0.45,106,70930,NULL,NULL,'K','ESO 598- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149221,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149221,35.23,0.72,111,70930,NULL,NULL,NULL,'ESO 598- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149222,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149222,35.27,0.2,113,70930,74.4,NULL,NULL,'ESO 598- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149223,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149223,35.29,0.4,114,70930,NULL,NULL,'mean','ESO 598- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149224,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149224,35.3,0.7,115,70930,NULL,NULL,'Malmquist cor.','ESO 598- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149225,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149225,37.66,0.46,340,70931,70,NULL,NULL,'SDSS J210424.93-073110.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000072,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,316.103917,-7.51958,0.233,NULL,50790150988,793596109,12399939,18.8),(149226,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149226,35.93,0.5,154,70932,70,NULL,NULL,'2MASX J21042540-3758206',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000133,NULL,'14.8r',0.35,'E',NULL,NULL,NULL,NULL,1,316.105875,-37.97239,0.097,NULL,51528631041,805134860,12580232,14.8),(149227,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149227,36.8,0.46,229,70933,70,NULL,NULL,'2MASX J21042681+0906406',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000181,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,316.1117083,9.11131,0.325,NULL,55094165117,860846329,13450723,16.7),(149228,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149228,37.21,0.61,277,70934,70,NULL,NULL,'2MASX J21042708-5150351',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'16.59',0.33,NULL,NULL,NULL,NULL,NULL,1,316.112833,-51.84314,0.029,NULL,51340124408,802189443,12534210,16.59),(149229,'IRAS','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149229,33.96,0.8,61.9,70935,75,NULL,'HMCL, I','ESO 235- G 047',NULL,'1997ApJS..109..333W',1997,1,0.86,NULL,'G',0.000217,NULL,'13.6r',0.67,'SB(r)a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,316.1134583,-48.2395,0.065,NULL,51344495154,802257736,12535277,13.6),(149230,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149230,33.52,0.4,50.6,70935,75,NULL,'HMCL, I, raw','ESO 235- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149231,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149231,33.61,0.4,52.6,70935,75,NULL,'HMCL, I, inv','ESO 235- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149232,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149232,33.86,0.4,59.1,70935,75,NULL,'HMCL, I, cor','ESO 235- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149233,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149233,34.76,0.65,89.7,70936,NULL,NULL,'Malmquist cor.','CGCG 400-022',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.0001,NULL,'15.3',0.2,NULL,NULL,NULL,NULL,NULL,1,316.12075,7.98044,0.249,NULL,55093807690,860840745,13450636,15.3),(149234,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149234,34.77,0.2,90,70936,74.4,NULL,NULL,'CGCG 400-022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149235,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149235,34.9,0.61,95.6,70936,NULL,NULL,NULL,'CGCG 400-022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149236,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149236,36.26,0.53,179,70937,70,NULL,NULL,'2MFGC 15959',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,316.126833,-72.76242,0.177,NULL,49325475491,770710554,12042352,16.8),(149237,'D-Sigma','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149237,34.01,0.4,63.5,70938,75,NULL,'Edat, raw','ESO 235- G 049',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000011,NULL,'12.6r',0.9,'E:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,316.1709583,-48.19089,0.065,NULL,51344479505,802257492,12535273,12.6),(149238,'D-Sigma','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149238,34.28,0.4,71.9,70938,75,NULL,'Edat, cor','ESO 235- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149239,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149239,33.68,0.25,54.5,70938,74.4,NULL,NULL,'ESO 235- G 049',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149240,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149240,33.83,0.46,58.2,70938,70,NULL,NULL,'ESO 235- G 049',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149241,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149241,38.27,0.46,451,70939,70,NULL,NULL,'2MASX J21044257+0945576',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000168,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,316.1775417,9.76606,0.249,NULL,55082740055,860667813,13447934,18.4),(149242,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14695','R',149242,39.62,0.29,722,70940,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 14695',0.161721,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,316.190875,-0.45097,0.217,NULL,49661266345,775957286,12124332,NULL),(149243,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14695','R',149243,39.73,0.3,760,70940,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 14695',0.161721,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149244,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14695',NULL,149244,40.2,0.27,1100,70940,70,NULL,'SN photometric redshift distance, z photo =0.300 +/- 0.048','SDSS-II SN 14695',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149245,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149245,35.64,0.35,134,70941,NULL,NULL,'Malmquist cor.','ESO 598- G 021',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.7r',0.4,'Sb',NULL,NULL,NULL,NULL,1,316.204667,-17.88525,0.293,NULL,50997172385,796830818,12450481,14.7),(149246,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149246,35.72,0.34,139,70941,NULL,NULL,NULL,'ESO 598- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149247,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149247,35.76,0.2,142,70941,74.4,NULL,NULL,'ESO 598- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149248,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 02387','RN',149248,39.11,0.14,633,70942,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02387',0.047981,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149249,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 02387','RN',149249,40.43,0.28,1160,70942,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02387',0.047981,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149250,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149250,35.33,0.49,116,70943,70,NULL,NULL,'FAIRALL 0941',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000133,NULL,'14.0r',0.45,'E',NULL,NULL,NULL,NULL,1,316.221667,-48.95308,0.037,NULL,51351405042,802365703,12536964,14),(149251,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149251,37.2,0.51,275,70944,70,NULL,NULL,'2MASX J21045356-5024043',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'15.0r',0.2,NULL,NULL,NULL,NULL,NULL,1,316.2232917,-50.40131,0,NULL,51353809301,802403270,12537551,15),(149252,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2007of',NULL,149252,41,0.27,1590,70945,70,NULL,'Hubble residual 0.27 for z0.40470','SDSS J210456.30+000339.1',NULL,'2011ApJ...740...92G',2011,1,0.04,NULL,'G',0.0005,NULL,'22.6g',0.03,NULL,NULL,NULL,NULL,NULL,1,316.234625,0.06089,0.261,NULL,52076797360,813699958,12714061,22.6),(149253,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 19033','R',149253,41.98,0.37,1770,70945,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007of','SDSS J210456.30+000339.1',0.4047,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149254,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 19033','R',149254,42.06,0.37,1840,70945,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007of','SDSS J210456.30+000339.1',0.4047,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149255,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149255,35.29,0.48,114,70946,70,NULL,NULL,'2MASX J21045753-1356482',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00009,NULL,'15.06',0.5,NULL,NULL,NULL,NULL,NULL,1,316.239583,-13.94678,0.137,NULL,50960270572,796254227,12441472,15.06),(149256,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 13383',NULL,149256,40.1,0.18,1050,70947,70,NULL,'SN photometric redshift distance, z photo =0.284 +/- 0.029','SDSS-II SN 13383',NULL,'2011ApJ...738..162S',2011,1,0.12,NULL,'G',NULL,'PHOT','19.7g',0.08,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,316.241833,-0.28347,0.245,NULL,49661302962,775957858,12124341,19.7),(149257,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149257,37.85,0.46,372,70948,70,NULL,NULL,'SDSS J210458.98-065716.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000093,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,316.24575,-6.95472,0.241,NULL,50790233641,793597400,12399959,18.4),(149258,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149258,36.72,0.62,221,70949,70,NULL,NULL,'ESO 286- G 040',NULL,'2014MNRAS.445.2677S',2014,1,0.97,NULL,'G',0.00015,NULL,'15.1r',0.18,'S...',NULL,NULL,NULL,NULL,1,316.2682917,-43.13383,0.053,NULL,51391542145,802992846,12546763,15.1),(149259,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149259,35.94,0.47,154,70950,70,NULL,NULL,'ESO 286- G 041',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000087,NULL,'13.2r',0.9,'SA(s)0^+;cD','Brightest group member',NULL,NULL,NULL,1,316.268791667,-43.41969,0.053,NULL,51391728130,802995752,12546808,13.2),(149260,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 07092','R',149260,40.18,0.23,886,70951,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07092',0.2254,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,316.280417,1.22042,0.421,NULL,52080128320,813752005,12714875,NULL),(149261,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 07092','R',149261,40.5,0.15,1030,70951,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07092',0.2254,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149262,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149262,36.76,0.52,225,70952,70,NULL,NULL,'2MASX J21050808-5150082',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'15.80',0.33,NULL,NULL,NULL,NULL,NULL,1,316.283583,-51.83564,0.029,NULL,51340172227,802190191,12534221,15.8),(149263,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14453',NULL,149263,39.71,0.81,874,70953,70,NULL,'SN photometric redshift distance, z photo =0.230 +/- 0.127','SDSS-II SN 14453',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,316.28625,0.94936,0.369,NULL,52079962151,813749408,12714834,NULL),(149264,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149264,38.85,0.46,588,70954,70,NULL,NULL,'SDSS J210511.49+103527.7',NULL,'2015arXiv151105856S',2015,1,0.11,NULL,'G',0.000177,NULL,'19.0g',0.1,NULL,NULL,NULL,NULL,NULL,1,316.297917,10.59106,0.261,NULL,55051838014,860184968,13440390,19),(149265,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149265,35.7,0.47,138,70955,70,NULL,NULL,'LCRS B210155.3-442644',NULL,'2014MNRAS.445.2677S',2014,1,0.86,NULL,'G',0.00009,NULL,'13.7r',0.67,'SAB(s)0/a',NULL,NULL,NULL,NULL,1,316.311,-44.24578,0.057,NULL,51403187526,803174805,12549606,13.7),(149266,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149266,35.55,0.58,129,70956,70,NULL,NULL,'2MASX J21051651-1438312',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.7I',0.4,NULL,NULL,NULL,NULL,NULL,1,316.318833333,-14.64208,0.133,NULL,50988500156,796695314,12448364,13.7),(149267,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 07121','R',149267,40.69,0.22,1100,70957,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07121',0.2545,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,316.320583333,-0.06092,0.261,NULL,49661099369,775954677,12124291,NULL),(149268,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 07121','R',149268,40.87,0.15,1190,70957,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07121',0.2545,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149269,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149269,37.85,0.46,372,70958,70,NULL,NULL,'2MASX J21052285-0639415',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000084,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,316.345083,-6.66167,0.289,NULL,50790694373,793604599,12400071,17.6),(149270,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149270,34.87,0.49,94,70959,75,NULL,'IR','MCG -01-53-023',NULL,'2011yCatp016004901K',2011,1,1.21,NULL,'G',0.000017,NULL,'15.6g',0.26,'SB(r)a pec?',NULL,NULL,NULL,NULL,1,316.347333,-7.75164,0.217,NULL,50791505535,793617273,12400269,15.6),(149271,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149271,36.85,0.52,234,70960,70,NULL,NULL,'2MASX J21052429-5043019',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,316.351083333,-50.71711,0,NULL,51353846775,802403855,12537560,16.9),(149272,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149272,37.51,0.33,318,70961,70,NULL,NULL,'2MASX J21052461-0732475',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000091,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,316.3525,-7.54656,0.233,NULL,50792037808,793625590,12400399,17.8),(149273,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149273,36.48,0.58,198,70962,70,NULL,NULL,'2MASX J21052772-4315297',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,316.365458333,-43.25833,0.053,NULL,51391742838,802995981,12546812,14.9),(149274,'Faber-Jackson','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149274,31.54,0.65,20.3,70963,95,NULL,'Weighted Mean','NGC 7007',NULL,'1984ApJS...56...91D',1984,1,1.9,NULL,'G',0.000067,NULL,'12.94',1.1,'SA0-:',NULL,NULL,NULL,NULL,1,316.366333,-52.55197,0.041,NULL,51341970814,802218293,12534660,12.94),(149275,'Faber-Jackson','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149275,32.88,0.81,37.7,70963,55,NULL,'Visvanathan & Sandage 1979','NGC 7007',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149276,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149276,32.15,0.51,26.9,70963,70,NULL,NULL,'NGC 7007',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149277,'Tully est','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149277,32.86,0.8,37.3,70963,75,NULL,'B','NGC 7007',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149278,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149278,32.42,0.45,30.5,70963,NULL,NULL,'K','NGC 7007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149279,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149279,33.08,0.4,41.4,70963,NULL,NULL,'mean','NGC 7007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149280,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149280,37.83,0.33,368,70964,70,NULL,NULL,'2MASX J21052926-0735285',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000074,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,316.3719583,-7.59122,0.233,NULL,50792031541,793625492,12400398,18.6),(149281,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149281,35.59,0.48,131,70965,70,NULL,NULL,'ESO 286- G 042',NULL,'2014MNRAS.445.2677S',2014,1,0.89,'ESO-LV have V = 4944 +- 27 km/s.','G',0.00009,NULL,'13.4r',0.59,'SA0^0^:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,316.379083,-47.04569,0.073,NULL,51400096995,803126515,12548851,13.4),(149282,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149282,37.51,0.33,318,70966,70,NULL,NULL,'2MASX J21053120-0733265',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.0001,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,316.3799583,-7.55731,0.233,NULL,50792037558,793625586,12400399,16.9),(149283,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149283,36.67,0.78,216,70967,70,NULL,NULL,'2MASX J21053182-6059107',NULL,'2014MNRAS.445.2677S',2014,1,0.19,NULL,'G',0.00015,NULL,'15.5r',0.17,NULL,NULL,NULL,NULL,NULL,1,316.382583,-60.98625,0.109,NULL,49189084925,768579451,12009053,15.5),(149284,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149284,37.37,0.46,298,70968,70,NULL,NULL,'SDSS J210534.61+001424.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,316.3942083,0.24014,0.285,NULL,52080188980,813752952,12714889,18.3),(149285,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149285,37.83,0.33,368,70969,70,NULL,NULL,'2MASX J21053470-0735315',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000084,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,316.394583,-7.59214,0.233,NULL,50792031629,793625494,12400398,16.9),(149286,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149286,35.74,0.62,141,70970,NULL,NULL,NULL,'AGC 610198',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000023,NULL,'17.00',NULL,'Scd',NULL,NULL,NULL,NULL,1,316.4135417,-25.55094,0.245,NULL,51422787148,803481049,12554391,17),(149287,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149287,35.79,0.2,144,70970,74.4,NULL,NULL,'AGC 610198',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149288,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149288,35.94,0.56,154,70970,NULL,NULL,'Malmquist cor.','AGC 610198',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149289,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149289,35.8,0.33,145,70971,70,NULL,NULL,'CGCG 400-027',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.00011,NULL,'14.7g',0.68,'E0',NULL,NULL,NULL,NULL,1,316.41825,9.23433,0.333,NULL,55093334756,860833355,13450521,14.7),(149290,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149290,37.67,0.46,342,70972,70,NULL,NULL,'2MASX J21054130-0020114',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00015,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,316.421958333,-0.33653,0.237,NULL,49663998210,775999972,12124999,16.9),(149291,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149291,35.96,0.55,155,70973,70,NULL,NULL,'ESO 235- G 054',NULL,'2014MNRAS.445.2677S',2014,1,1.06,NULL,'G',0.00015,NULL,'13.4r',0.54,'(R\')SA:(r)a',NULL,NULL,NULL,NULL,1,316.4352917,-51.70992,0.029,NULL,51340157955,802189968,12534218,13.4),(149292,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149292,36.23,0.59,176,70974,70,NULL,NULL,'2MASX J21054962-6109307',NULL,'2014MNRAS.445.2677S',2014,1,0.31,NULL,'G',0.00015,NULL,'15.3r',0.12,NULL,NULL,NULL,NULL,NULL,1,316.456917,-61.15858,0.097,NULL,49189541005,768586578,12009165,15.3),(149293,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149293,37.2,0.46,276,70975,70,NULL,NULL,'2MASX J21055481-0541293',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000098,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,316.47825,-5.69158,0.237,NULL,50745146565,792892915,12388951,16.5),(149294,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 06833',NULL,149294,40.84,0.63,1470,70976,70,NULL,'SN photometric redshift distance, z photo =0.430 +/- 0.213','SDSS-II SN 06833',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.7g',0.07,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,316.481375,0.12014,0.285,NULL,52080155555,813752430,12714881,21.7),(149295,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149295,37.68,0.8,344,70977,70,NULL,NULL,'2MASX J21055715-3936537',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'15.1r',0.36,'E/S0','Group member',NULL,NULL,NULL,1,316.488167,-39.61497,0.057,NULL,51481923169,804405049,12568828,15.1),(149296,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149296,36.13,0.7,168,70978,70,NULL,NULL,'2MASX J21055819-1351468',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,316.492375,-13.86303,0.121,NULL,50960298842,796254669,12441479,15.7),(149297,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149297,36.59,0.54,208,70979,70,NULL,NULL,'2MASX J21055898-3441568',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.000103,NULL,'14.9r',0.41,NULL,NULL,NULL,NULL,NULL,1,316.4957917,-34.69908,0.341,NULL,51533856716,805216511,12581507,14.9),(149298,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149298,36.06,0.25,163,70980,74.4,NULL,NULL,'2MASX J21060042-2606154',NULL,'2013AJ....146...86T',2013,1,0.31,NULL,'G',0.000017,NULL,'15.3r',0.22,NULL,NULL,NULL,NULL,NULL,1,316.5017917,-26.10433,0.301,NULL,51423010525,803484539,12554445,15.3),(149299,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149299,36.23,0.61,176,70981,70,NULL,NULL,'2MASX J21060065-6300566',NULL,'2014MNRAS.445.2677S',2014,1,0.21,NULL,'G',0.00015,NULL,'15.0r',0.14,NULL,NULL,NULL,NULL,NULL,1,316.502667,-63.01575,0.049,NULL,49174327079,768348860,12005450,15),(149300,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149300,35.54,0.69,128,70982,70,NULL,NULL,'2MASX J21060103-1548578',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000063,NULL,'15.73',NULL,NULL,NULL,NULL,NULL,NULL,1,316.504291667,-15.81606,0.161,NULL,50999680272,796870004,12451093,15.73),(149301,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149301,37.95,0.46,388,70983,70,NULL,NULL,'2MASX J21060132-0115208',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,316.505458333,-1.25583,0.173,NULL,49664325730,776005089,12125079,17.7),(149302,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149302,36.24,0.46,177,70984,70,NULL,NULL,'2MASX J21060289-0610162',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000075,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,316.512125,-6.17133,0.257,NULL,50790513399,793601771,12400027,17),(149303,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149303,35.84,0.59,147,70985,70,NULL,NULL,'KAZ 515',NULL,'2014MNRAS.445.2677S',2014,1,0.13,NULL,'G',0.000103,NULL,'16.14',NULL,NULL,NULL,NULL,NULL,NULL,1,316.512417,-12.68667,0.117,NULL,50957335622,796208369,12440755,16.14),(149304,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149304,35.82,0.25,146,70986,74.4,NULL,NULL,'2MASX J21060354-2610284',NULL,'2013AJ....146...86T',2013,1,0.38,NULL,'G',0.000031,NULL,'14.7r',0.35,NULL,NULL,NULL,NULL,NULL,1,316.514708333,-26.17458,0.301,NULL,51422498988,803476546,12554321,14.7),(149305,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149305,34.1,0.46,66.1,70987,70,NULL,NULL,'ESO 286- G 046',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'14.13',0.7,'(R?)SABa',NULL,NULL,NULL,NULL,1,316.519333,-45.43292,0.041,NULL,51402832220,803169253,12549519,14.13),(149306,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149306,34.41,0.43,76.2,70988,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11677',NULL,'2014MNRAS.444..527S',2014,1,1.3,'HIPASS data may include other galaxies.','G',0.000024,NULL,'16.0',0.6,'I?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,316.5214583,15.97272,0.389,NULL,55295805530,863996961,13499952,16),(149307,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149307,36.35,0.51,187,70989,70,NULL,NULL,'2MASX J21060545-3937515',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.30',0.43,'E','Group member',NULL,NULL,NULL,1,316.52275,-39.63092,0.057,NULL,51481922895,804405045,12568828,16.3),(149308,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149308,35.98,0.56,157,70990,70,NULL,NULL,'2MASX J21060859-5444588',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.00015,NULL,'14.3r',0.69,'SAB(s)a: pec',NULL,NULL,NULL,NULL,1,316.535958333,-54.74967,0.109,NULL,48654061353,760219708,11878432,14.3),(149309,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149309,35.19,0.5,109,70991,70,NULL,NULL,'2MASX J21060892-1547538',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000087,NULL,'14.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,316.53725,-15.79831,0.177,NULL,50999795836,796871809,12451122,14.1),(149310,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149310,37.69,0.33,345,70992,70,NULL,NULL,'2MASX J21061026-0051368',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000178,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,316.542917,-0.86033,0.217,NULL,49664538336,776008411,12125131,17.1),(149311,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149311,35.35,0.52,118,70993,70,NULL,NULL,'2MASX J21061269-1407498',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,316.552833,-14.13061,0.101,NULL,50958389827,796224841,12441013,14.2),(149312,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 20130','RN',149312,38.83,0.24,555,70994,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 20130',0.050593,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149313,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 20130','RN',149313,40.27,0.28,1080,70994,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20130',0.050593,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149314,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 16104',NULL,149314,41.57,0.02,2060,70995,70,NULL,'SN photometric redshift distance, z photo =0.691 +/- 0.009','SDSS-II SN 16104',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','20.1g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,316.56475,-1.06636,0.181,NULL,49664735202,776011487,12125179,20.1),(149315,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149315,36.42,0.9,192,70996,70,NULL,NULL,'2MASX J21061567-0952555',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,316.565375,-9.88211,0.237,NULL,50785822302,793528473,12398882,15.6),(149316,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149316,37.19,0.46,275,70997,70,NULL,NULL,'2MASX J21061690-0602045',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000083,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,316.57025,-6.03464,0.257,NULL,50745275451,792894928,12388983,17.3),(149317,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149317,37.69,0.33,345,70998,70,NULL,NULL,'2MASX J21061887-0103599',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000151,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,316.578625,-1.06669,0.181,NULL,49664736866,776011513,12125179,17.3),(149318,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149318,35.78,0.69,143,70999,70,NULL,NULL,'2MASX J21062230-1257578',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,316.592917,-12.96603,0.105,NULL,50957266351,796207286,12440738,15.4),(149319,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149319,35.14,0.47,107,71000,70,NULL,NULL,'FAIRALL 0945',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00015,NULL,'14.0r',0.53,'S0',NULL,NULL,NULL,NULL,1,316.602041667,-49.04583,0.021,NULL,51343849914,802247654,12535119,14),(149320,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149320,36.33,0.68,185,71001,70,NULL,NULL,'2MASX J21062500-6241202',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'15.0r',0.21,NULL,NULL,NULL,NULL,NULL,1,316.604333333,-62.68903,0.085,NULL,49177711689,768401745,12006277,15),(149321,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149321,35.67,0.38,136,71002,NULL,NULL,NULL,'NGC 7019',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.00003,NULL,'15.09',0.9,'SB(s)b:        HII',NULL,NULL,NULL,NULL,1,316.6072083,-24.41267,0.241,NULL,50902742244,795355347,12427427,15.09),(149322,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149322,35.69,0.38,138,71002,NULL,NULL,'Malmquist cor.','NGC 7019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149323,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149323,35.71,0.2,139,71002,74.4,NULL,NULL,'NGC 7019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149324,'SNII optical','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2003ho',NULL,149324,33.71,0.6,55.2,71003,NULL,NULL,'V, photospheric magnitude method','ESO 235- G 058',NULL,'2014AJ....148..107R',2014,1,2.4,NULL,'G',0.000029,NULL,'14.3r',1.6,'(PR?)SB:(rs:)cd:',NULL,NULL,NULL,NULL,1,316.618333,-48.12103,0.065,NULL,51344568855,802258888,12535295,14.3),(149325,'SNII optical','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2003ho',NULL,149325,33.99,0.26,62.8,71003,NULL,NULL,'I, photospheric magnitude method','ESO 235- G 058',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149326,'SNII optical','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2003ho',NULL,149326,34.1,0.41,66.1,71003,NULL,NULL,'SCM, B','ESO 235- G 058',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149327,'SNII optical','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2003ho',NULL,149327,34.13,0.28,67,71003,NULL,NULL,'SCM, BVI','ESO 235- G 058',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149328,'SNII optical','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2003ho',NULL,149328,34.13,0.53,67,71003,NULL,NULL,'SCM, I','ESO 235- G 058',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149329,'SNII optical','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2003ho',NULL,149329,34.18,0.54,68.5,71003,NULL,NULL,'SCM, V','ESO 235- G 058',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149330,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149330,35.8,0.5,144,71004,NULL,NULL,NULL,'AGC 610212',NULL,'2009ApJS..182..474S',2009,1,0.44,NULL,'G',0.000023,NULL,'16.38',0.09,'Sc',NULL,NULL,NULL,NULL,1,316.6297083,-24.48853,0.173,NULL,50902875183,795357424,12427459,16.38),(149331,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149331,35.84,0.2,147,71004,74.4,NULL,NULL,'AGC 610212',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149332,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149332,35.95,0.46,155,71004,NULL,NULL,'Malmquist cor.','AGC 610212',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149333,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 03546','R',149333,39.9,0.11,803,71005,70,NULL,'SDSS CAND. Variable; MLCS2K2; SN 2006ki','SDSS-II SN 14019 HOST',0.190057,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,316.642375,-0.64861,0.237,NULL,49664141069,776002204,12125034,NULL),(149334,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2006ki',NULL,149334,39.98,0.1,993,71005,70,NULL,'Hubble residual 0.39 for z0.21640','SDSS-II SN 14019 HOST',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149335,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14019','R',149335,40.51,0.21,1040,71005,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ki','SDSS-II SN 14019 HOST',0.2164,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149336,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14019','R',149336,40.71,0.15,1140,71005,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ki','SDSS-II SN 14019 HOST',0.2164,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149337,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 03546','R',149337,40.8,0.19,1210,71005,70,NULL,'SDSS CAND. Variable; SALT 2; SN 2006ki','SDSS-II SN 14019 HOST',0.190057,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149338,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149338,36.19,0.46,173,71006,70,NULL,NULL,'2MASX J21063573-0020236',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,316.649,-0.33994,0.265,NULL,49662935611,775983368,12124740,16.6),(149339,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149339,38.05,0.46,407,71007,70,NULL,NULL,'2MASX J21063774+1042491',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000183,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,316.657167,10.71361,0.257,NULL,55052029048,860187953,13440436,17.3),(149340,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149340,37.1,0.64,264,71008,70,NULL,NULL,'2MASX J21063849-5456251',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.9r',0.33,NULL,NULL,NULL,NULL,NULL,1,316.6605417,-54.94031,0.109,NULL,48654842374,760231912,11878623,14.9),(149341,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149341,35.6,0.49,132,71009,75,NULL,'IR','FGCE 1557',NULL,'2011yCatp016004901K',2011,1,0.92,NULL,'G',0.000023,NULL,'16.89',0.11,'Sc',NULL,NULL,NULL,NULL,1,316.666916667,-25.4655,0.237,NULL,51422941752,803483464,12554429,16.89),(149342,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149342,35.69,NULL,137,71009,NULL,NULL,'Dipole + Quadrupole + Octopole','FGCE 1557',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149343,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149343,35.72,NULL,139,71009,NULL,NULL,'Dipole + Quadrupole','FGCE 1557',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149344,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149344,35.74,NULL,140,71009,NULL,NULL,'Dipole','FGCE 1557',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149345,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149345,35.92,0.39,152,71009,NULL,NULL,NULL,'FGCE 1557',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149346,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149346,35.94,0.39,154,71009,NULL,NULL,'Malmquist cor.','FGCE 1557',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149347,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149347,35.96,0.2,156,71009,74.4,NULL,NULL,'FGCE 1557',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149348,'GCLF','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149348,34.06,0.25,64.9,71010,NULL,NULL,'NGC 7014','Abell 3742',NULL,'1998ApJ...499..577L',1998,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III [BM];I  [A]',NULL,NULL,NULL,NULL,1,316.674041667,-47.14883,0.069,NULL,51400039977,803125624,12548837,NULL),(149349,'SBF','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149349,33.88,0.12,59.7,71010,NULL,NULL,'NGC 7014','Abell 3742',NULL,'1998ApJ...499..577L',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149350,'SBF','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149350,34.18,0.16,68.5,71010,NULL,NULL,'HST KP Calibrated, F814W','ABELL 3742',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149351,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149351,37.07,0.46,259,71011,70,NULL,NULL,'SDSS J210643.61+003348.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000138,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,316.68175,0.56342,0.337,NULL,52080258339,813754036,12714906,17.8),(149352,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149352,35.98,0.5,157,71012,70,NULL,NULL,'2MASX J21064719-4423461',NULL,'2014MNRAS.445.2677S',2014,1,1.18,NULL,'G',0.000127,NULL,'15.10',0.62,'E',NULL,NULL,NULL,NULL,1,316.696583,-44.39619,0.069,NULL,51403233462,803175522,12549617,15.1),(149353,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149353,34.04,0.25,64.3,71013,74.4,NULL,NULL,'ESO 286- G 049',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000014,NULL,'12.8r',0.7,'E+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,316.697917,-47.18786,0.069,NULL,51400037559,803125586,12548837,12.8),(149354,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149354,34.52,0.46,80.2,71013,70,NULL,NULL,'ESO 286- G 049',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149355,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149355,34.59,0.4,82.9,71013,NULL,NULL,'mean','ESO 286- G 049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149356,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149356,34.63,0.45,84.2,71013,NULL,NULL,'K','ESO 286- G 049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149357,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149357,35.8,0.33,145,71014,70,NULL,NULL,'2MASX J21065027+0911507',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000127,NULL,'15.4g',NULL,'E0',NULL,NULL,NULL,NULL,1,316.7095,9.19736,0.337,NULL,55093251956,860832061,13450500,15.4),(149358,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149358,35.89,0.58,150,71015,70,NULL,NULL,'2MASX J21065055-5459471',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'14.9r',0.35,NULL,NULL,NULL,NULL,NULL,1,316.7107917,-54.99642,0.109,NULL,48654820335,760231567,11878618,14.9),(149359,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149359,36.27,0.56,180,71016,70,NULL,NULL,'2MASX J21065082-6217162',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'14.8r',0.33,NULL,NULL,NULL,NULL,NULL,1,316.711667,-62.28792,0.085,NULL,49175764620,768371322,12005801,14.8),(149360,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149360,34.76,0.53,89.4,71017,70,NULL,NULL,'LCRS B210332.1-450614',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000093,NULL,'13.9r',0.42,'S',NULL,NULL,NULL,NULL,1,316.717583,-44.90275,0.057,NULL,51402865748,803169777,12549527,13.9),(149361,'CMD','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'N',149361,19.14,0.1,0.067,71018,NULL,NULL,NULL,'Laevens 3',NULL,'2015ApJ...813...44L',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149362,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149362,37.83,0.46,369,71019,70,NULL,NULL,'2MASX J21065887+0044223',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000148,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,316.7452917,0.73956,0.337,NULL,52080239185,813753737,12714902,17.1),(149363,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149363,36.12,0.43,167,71020,NULL,NULL,NULL,'AGC 610217',NULL,'2009ApJS..182..474S',2009,1,0.37,NULL,'G',0.000023,NULL,'16.01',0.11,'Sbc',NULL,NULL,NULL,NULL,1,316.752083,-24.62031,0.177,NULL,50902411302,795350176,12427346,16.01),(149364,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149364,36.16,0.2,171,71020,74.4,NULL,NULL,'AGC 610217',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149365,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149365,36.16,0.42,171,71020,NULL,NULL,'Malmquist cor.','AGC 610217',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149366,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 12853','R',149366,39.35,0.2,633,71021,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ey','SN 2006ey',0.1694,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,316.7655417,0.72308,0.337,NULL,52080272052,813754250,12714910,NULL),(149367,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 12853','R',149367,39.64,0.13,723,71021,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ey','SN 2006ey',0.1694,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149368,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149368,34.64,0.49,84.7,71022,70,NULL,NULL,'ESO 286- G 055',NULL,'2014MNRAS.445.2677S',2014,1,1.47,NULL,'G',0.000147,NULL,'13.9r',0.26,'Sa:',NULL,NULL,NULL,NULL,1,316.773625,-45.208,0.053,NULL,51403013244,803172081,12549563,13.9),(149369,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149369,37.45,0.46,310,71023,70,NULL,NULL,'SDSS J210707.35+100644.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00012,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,316.780667,10.11239,0.313,NULL,55052150021,860189844,13440466,18.1),(149370,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149370,36.5,0.55,200,71024,70,NULL,NULL,'2MASX J21070788-5020184',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.07',0.5,'S0',NULL,NULL,NULL,NULL,1,316.7827917,-50.33836,0,NULL,51353963439,802405678,12537588,16.07),(149371,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149371,37.21,0.58,276,71025,70,NULL,NULL,'2MASX J21070818-3708321',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'15.1r',0.32,NULL,NULL,NULL,NULL,NULL,1,316.7840417,-37.14225,0.177,NULL,51528951181,805139862,12580310,15.1),(149372,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149372,35.84,0.4,147,71026,NULL,NULL,'Malmquist cor.','2MASX J21071118-2515110',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000033,NULL,'15.4r',0.3,'Sa',NULL,NULL,NULL,NULL,1,316.796583,-25.25297,0.233,NULL,51422708358,803479818,12554372,15.4),(149373,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149373,35.94,0.38,154,71026,NULL,NULL,NULL,'2MASX J21071118-2515110',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149374,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149374,35.98,0.2,157,71026,74.4,NULL,NULL,'2MASX J21071118-2515110',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149375,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149375,35.87,0.56,150,71027,70,NULL,NULL,'LCRS B210351.9-450214',NULL,'2014MNRAS.445.2677S',2014,1,0.31,NULL,'G',0.00009,NULL,'17.31',0.27,NULL,NULL,NULL,NULL,NULL,1,316.7992083,-44.83572,0.057,NULL,51402860146,803169689,12549526,17.31),(149376,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149376,36.04,0.11,162,71028,70,NULL,NULL,'ABELL 3744',NULL,'1999AJ....118.1489D',1999,1,NULL,'Katgert (1996,A&A,310,8) identifies multiple redshift systems in this cluster.','GClstr',NULL,NULL,NULL,NULL,'II-III [BM];IR:[A]',NULL,NULL,NULL,NULL,1,316.80125,-25.43806,0.237,NULL,51422931278,803483301,12554426,NULL),(149377,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149377,38.54,0.46,510,71029,70,NULL,NULL,'2MASX J21071547+0110223',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,316.8145,1.17303,0.377,NULL,52080577163,813759018,12714984,18.4),(149378,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149378,35.93,0.25,153,71030,74.4,NULL,NULL,'NGC 7016',NULL,'2013AJ....146...86T',2013,1,1.8,NULL,'G',0.000028,NULL,'14.85',1.8,'E0','Brightest group member',NULL,NULL,NULL,1,316.817833333,-25.46894,0.237,NULL,51422940676,803483448,12554428,14.85),(149379,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149379,36.04,0.11,162,71030,70,NULL,'ABELL 3744, BGC','NGC 7016',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149380,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 01825','RN',149380,39.71,0.26,757,71031,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01825',0.156311,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149381,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 01825','RN',149381,40.36,0.36,1020,71031,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01825',0.156311,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149382,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149382,37.38,0.46,300,71032,70,NULL,NULL,'2MASX J21071881+0044423',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000184,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,316.82825,0.74508,0.385,NULL,52080220989,813753452,12714897,17.3),(149383,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149383,35.59,0.49,131,71033,75,NULL,'IR','2MFGC 16001',NULL,'2011yCatp016004901K',2011,1,0.5,NULL,'G',0.000023,NULL,'15.0r',0.13,'Sc',NULL,NULL,NULL,NULL,1,316.837083,-25.63056,0.245,NULL,51422915254,803483050,12554422,15),(149384,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149384,35.81,0.35,146,71033,NULL,NULL,'Malmquist cor.','2MFGC 16001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149385,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149385,35.84,0.34,147,71033,NULL,NULL,NULL,'2MFGC 16001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149386,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149386,35.88,0.2,150,71033,74.4,NULL,NULL,'2MFGC 16001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149387,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149387,36.95,0.25,245,71034,74.4,NULL,NULL,'2MASX J21072205-2527210',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000039,NULL,'15.2r',0.3,'S0',NULL,NULL,NULL,NULL,1,316.841875,-25.45575,0.237,NULL,51422929639,803483275,12554426,15.2),(149388,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149388,35.8,0.53,145,71035,NULL,NULL,NULL,'2MASX J21072347-2534169',NULL,'2009ApJS..182..474S',2009,1,0.32,NULL,'G',0.000023,NULL,'16.3r',0.14,'Sc',NULL,NULL,NULL,NULL,1,316.84775,-25.57142,0.245,NULL,51422909668,803482963,12554421,16.3),(149389,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149389,35.84,0.2,147,71035,74.4,NULL,NULL,'2MASX J21072347-2534169',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149390,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149390,36.03,0.48,161,71035,NULL,NULL,'Malmquist cor.','2MASX J21072347-2534169',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149391,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149391,38.44,0.46,487,71036,70,NULL,NULL,'2MASX J21072517+1041359',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000175,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,316.855041667,10.69328,0.257,NULL,55051970574,860187040,13440422,18.2),(149392,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149392,36.72,0.57,221,71037,70,NULL,NULL,'2MASX J21072666-3941115',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'14.9r',0.47,'(R\'_2?)SB(s)a:','Group member',NULL,NULL,NULL,1,316.861083,-39.68656,0.045,NULL,51481712752,804401761,12568777,14.9),(149393,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 15080',NULL,149393,39.93,0.67,969,71038,70,NULL,'SN photometric redshift distance, z photo =0.259 +/- 0.117','SDSS-II SN 15080',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,316.879625,-1.03872,0.217,NULL,49664661714,776010339,12125161,NULL),(149394,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149394,35.32,0.25,116,71039,74.4,NULL,NULL,'GALEXASC J210732.33-253834.8',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000014,NULL,'14.7R',NULL,'E',NULL,NULL,NULL,NULL,1,316.8847917,-25.64308,0.245,NULL,51422918362,803483099,12554423,14.7),(149395,'Tully est','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149395,31.13,0.8,16.8,71040,75,NULL,NULL,'ESO 187- G 051',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000017,NULL,'14.85',1.2,'SB(s)m',NULL,NULL,NULL,NULL,1,316.887917,-54.95056,0.109,NULL,48654825848,760231653,11878619,14.85),(149396,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149396,35.93,0.56,154,71041,70,NULL,NULL,'VV 764 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16',0.3,'Sa',NULL,NULL,NULL,NULL,1,316.903,-25.41806,0.237,NULL,51422712224,803479878,12554373,16),(149397,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 17370',NULL,149397,40.08,0.34,1040,71042,70,NULL,'SN photometric redshift distance, z photo =0.281 +/- 0.057','SDSS-II SN 17370',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.4g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,316.903916667,0.19142,0.349,NULL,52078137360,813720896,12714389,21.4),(149398,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149398,36.32,0.51,184,71043,NULL,NULL,'Malmquist cor.','2MASX J21073898-2439240',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000027,NULL,'15.4r',0.3,'Sb',NULL,NULL,NULL,NULL,1,316.912416667,-24.65661,0.177,NULL,50905899397,795404678,12428198,15.4),(149399,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149399,36.76,0.41,225,71043,NULL,NULL,NULL,'2MASX J21073898-2439240',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149400,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149400,36.8,0.2,229,71043,74.4,NULL,NULL,'2MASX J21073898-2439240',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149401,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149401,36.77,0.46,226,71044,70,NULL,NULL,'2MASX J21073959-0113418',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00015,NULL,'16.3g',0.36,'E0',NULL,NULL,NULL,NULL,1,316.915083,-1.22819,0.181,NULL,49663871918,775997998,12124968,16.3),(149402,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149402,37.12,0.46,266,71045,70,NULL,NULL,'2MASX J21074333-0038338',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00015,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,316.930583,-0.64267,0.281,NULL,49662998857,775984357,12124755,16.8),(149403,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149403,37.5,0.46,317,71046,70,NULL,NULL,'2MASX J21074395+0945191',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000158,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,316.933167,9.75531,0.325,NULL,55051451822,860178934,13440295,17.5),(149404,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149404,35.07,0.48,103,71047,70,NULL,NULL,'AM 2103-583 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.000133,NULL,'15.49',0.53,'E',NULL,NULL,NULL,NULL,1,316.943917,-58.30372,0.141,NULL,49134711184,767729862,11995779,15.49),(149405,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149405,34.23,0.4,70,71048,NULL,NULL,'mean','NGC 7025',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000017,NULL,'13.71',1.3,'Sa','Isolated galaxy',NULL,NULL,NULL,1,316.94725,16.33586,0.341,NULL,55287402812,863865668,13497901,13.71),(149406,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149406,34.37,0.47,74.9,71048,NULL,NULL,'H','NGC 7025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149407,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149407,34.39,0.46,75.6,71048,NULL,NULL,'J','NGC 7025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149408,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149408,34.41,0.45,76.1,71048,NULL,NULL,'K','NGC 7025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149409,'GCLF','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149409,34.06,0.25,64.9,71049,NULL,NULL,NULL,'NGC 7014',NULL,'1998ApJ...499..577L',1998,1,1.9,NULL,'G',0.000017,NULL,'13.38',1.5,'E','Isolated elliptical galaxy',NULL,NULL,NULL,1,316.967375,-47.179,0.069,NULL,51399526060,803117594,12548712,13.38),(149410,'GCLF','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149410,34.09,0.19,65.8,71049,NULL,NULL,NULL,'NGC 7014',NULL,'2002ApJ...567..294O',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149411,'SBF','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149411,33.84,0.15,58.6,71049,NULL,NULL,'I','NGC 7014',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149412,'SBF','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149412,33.88,0.12,59.7,71049,NULL,NULL,'I','NGC 7014',NULL,'1998ApJ...499..577L',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149413,'SBF','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149413,34,0.15,63.1,71049,NULL,NULL,NULL,'NGC 7014',NULL,'2001ApJ...550..503J',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149414,'SBF','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149414,34.18,0.16,68.5,71049,NULL,NULL,'HST KP Calibrated, F814W','NGC 7014',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149415,'D-Sigma','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149415,34.01,0.4,63.5,71049,75,NULL,'Edat, raw','NGC 7014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149416,'D-Sigma','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149416,34.28,0.4,71.9,71049,75,NULL,'Edat, cor','NGC 7014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149417,'Faber-Jackson','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149417,33.58,0.37,52,71049,95,NULL,'Weighted Mean','NGC 7014',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149418,'Faber-Jackson','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149418,33.9,0.46,60.3,71049,95,NULL,'Michard 1979a','NGC 7014',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149419,'Faber-Jackson','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149419,34.06,0.63,64.9,71049,95,NULL,'Michard 1979b, c','NGC 7014',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149420,'Faber-Jackson','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149420,35.69,0.81,137,71049,55,NULL,'Visvanathan & Sandage 1979','NGC 7014',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149421,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149421,34.34,0.25,73.8,71049,74.4,NULL,NULL,'NGC 7014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149422,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149422,34.79,0.46,90.9,71049,70,NULL,NULL,'NGC 7014',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149423,'Tertiary','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149423,33.39,0.5,47.6,71049,95,NULL,NULL,'NGC 7014',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149424,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149424,34.08,0.4,65.3,71049,NULL,NULL,'mean','NGC 7014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149425,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149425,34.63,0.45,84.5,71049,NULL,NULL,'K','NGC 7014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149426,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149426,36.34,0.55,185,71050,70,NULL,NULL,'6dF J2107545-344617',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,316.976875,-34.77139,0.341,NULL,51534069124,805219830,12581559,14.4),(149427,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149427,35.87,0.73,149,71051,70,NULL,NULL,'2MASX J21075449-4315415',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.000022,NULL,'14.5r',0.53,'E',NULL,NULL,NULL,NULL,1,316.977083,-43.26161,0.053,NULL,51391667908,802994811,12546793,14.5),(149428,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149428,35.47,0.65,124,71052,70,NULL,NULL,'2MASX J21075491-0243304',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.1R',NULL,'HII?',NULL,NULL,NULL,NULL,1,316.978833333,-2.72508,0.181,NULL,49661654328,775963348,12124427,14.1),(149429,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149429,36.71,0.83,220,71053,70,NULL,NULL,'LCRS B210446.5-394057',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.00015,NULL,'15.88',0.37,'Ep','Group member',NULL,NULL,NULL,1,316.99375,-39.48114,0.057,NULL,51481683038,804401297,12568770,15.88),(149430,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149430,35.51,0.57,126,71054,70,NULL,NULL,'2MASX J21080312-5517354',NULL,'2014MNRAS.445.2677S',2014,1,0.93,NULL,'G',0.00015,NULL,'14.3r',0.42,'S0',NULL,NULL,NULL,NULL,1,317.013125,-55.29308,0.105,NULL,48654753030,760230516,11878601,14.3),(149431,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149431,33.94,0.46,61.3,71055,70,NULL,NULL,'ESO 402-IG 010',NULL,'2014MNRAS.445.2677S',2014,1,2,NULL,'G',0.00005,NULL,'13.98',0.9,'SB0? pec',NULL,NULL,NULL,NULL,1,317.031375,-33.24278,0.389,NULL,51532947031,805202297,12581285,13.98),(149432,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,'R',149432,37.36,0.46,297,71056,70,NULL,NULL,'2MASX J21080800+1121222',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000183,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,317.033333,11.35619,0.305,NULL,55054192722,860221761,13440965,17.5),(149433,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,'R',149433,37.3,0.46,289,71057,70,NULL,NULL,'2MASX J21080963-0015025',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,317.040166667,-0.25083,0.321,NULL,49663089448,775985772,12124777,17),(149434,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,'R',149434,37.23,0.46,279,71058,70,NULL,NULL,'2MASX J21081243-0014235',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000159,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,317.0519583,-0.24003,0.321,NULL,49663088923,775985764,12124777,17.1),(149435,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149435,34.36,0.45,74.6,71059,NULL,NULL,NULL,'ESO 286- G 058',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.0r',0.7,'SA(s)c',NULL,NULL,NULL,NULL,1,317.0744583,-43.91522,0.061,NULL,51390866469,802982288,12546598,14),(149436,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,'R',149436,34.38,0.56,75.2,71059,NULL,NULL,'B, Hubble-type-TF','ESO 286- G 058',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149437,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149437,34.41,0.44,76.2,71059,NULL,NULL,'Malmquist cor.','ESO 286- G 058',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149438,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149438,34.41,0.2,76.2,71059,74.4,NULL,NULL,'ESO 286- G 058',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149439,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149439,36.57,0.53,206,71060,70,NULL,NULL,'2MASX J21081934-3623208',NULL,'2014MNRAS.445.2677S',2014,1,0.87,NULL,'G',0.00015,NULL,'13.7r',0.68,'E',NULL,NULL,NULL,NULL,1,317.0805,-36.38906,0.373,NULL,51535641158,805244393,12581943,13.7),(149440,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149440,36.71,0.55,219,71061,70,NULL,NULL,'2MASX J21082264-1533443',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.77',NULL,NULL,NULL,NULL,NULL,NULL,1,317.094333,-15.56236,0.225,NULL,50988066024,796688531,12448258,15.77),(149441,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:08','1','SDSS-II SN 14311','RN',149441,41.11,0.28,1250,71062,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14311',0.336024,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149442,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:08','1','SDSS-II SN 14311','RN',149442,41.24,0.24,1330,71062,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14311',0.336024,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149443,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:08','1','SDSS-II SN 14311','N',149443,41,0.18,1580,71062,70,NULL,'SALT 2','SDSS-II SN 14311',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149444,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:08','1','SDSS-II SN 14311','N',149444,41.04,0.18,1610,71062,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14311',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149445,'SNII optical','2016-12-15 15:15:54','2016-12-16 11:21:08','1','SN 2004du',NULL,149445,33.94,0.13,59.4,71063,NULL,NULL,'SEAM','UGC 11683',0.016762,'2009ApJ...694.1067P',2009,1,1.1,NULL,'G',0.000067,NULL,'15.18',0.3,'Scd:','Pair member (points to parent)',NULL,NULL,NULL,1,317.111375,18.19119,0.441,NULL,55288905902,863889154,13498268,15.18),(149446,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,'R',149446,34.16,0.49,68,71063,75,NULL,'IR','UGC 11683',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149447,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149447,34.3,0.2,72.4,71063,74.4,NULL,NULL,'UGC 11683',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149448,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149448,34.4,0.33,75.8,71063,NULL,NULL,'Malmquist cor.','UGC 11683',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149449,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149449,34.44,0.32,77.2,71063,NULL,NULL,NULL,'UGC 11683',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149450,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149450,35.97,0.59,157,71064,70,NULL,NULL,'AM 2105-273 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'15.92',0.43,NULL,NULL,NULL,NULL,NULL,1,317.113333,-27.28889,0.313,NULL,51423935334,803498989,12554671,15.92),(149451,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,'R',149451,38.1,0.46,416,71065,70,NULL,NULL,'2MASX J21082739+0953142',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000179,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,317.114167,9.88728,0.313,NULL,55051492236,860179566,13440305,17.7),(149452,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:08','1','SDSS-II SN 01826','RN',149452,42.68,0.26,2390,71066,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01826',0.435618,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149453,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:08','1','SDSS-II SN 01826','RN',149453,42.73,0.31,2450,71066,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01826',0.435618,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149454,'D-Sigma','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149454,35.09,0.4,104,71067,75,NULL,'Edat, raw','ESO 286- G 059',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000028,NULL,'13.2r',0.7,'S0^-','Brightest group member',NULL,NULL,NULL,1,317.1630417,-43.48614,0.045,NULL,51390918231,802983097,12546610,13.2),(149455,'D-Sigma','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149455,35.42,0.4,121,71067,75,NULL,'Edat, cor','ESO 286- G 059',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149456,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149456,35.67,0.4,136,71067,NULL,NULL,'mean','ESO 286- G 059',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149457,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149457,35.76,0.45,142,71067,NULL,NULL,'K','ESO 286- G 059',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149458,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149458,36.65,0.66,214,71068,70,NULL,NULL,'2MASX J21084291-1447154',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.14',NULL,NULL,NULL,NULL,NULL,NULL,1,317.178625,-14.78753,0.197,NULL,50957815564,796215868,12440872,16.14),(149459,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,'R',149459,32.6,0.49,33.2,71069,75,NULL,'IR','IC 1359',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'14.77',0.3,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,317.17925,12.48428,0.341,NULL,55276220697,863690948,13495171,14.77),(149460,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149460,36.76,0.75,225,71070,70,NULL,NULL,'AM 2103-724',NULL,'2014MNRAS.445.2677S',2014,1,0.1,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,317.1812917,-72.58831,0.169,NULL,49325327084,770708235,12042316,15.1),(149461,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149461,34.67,0.58,86,71071,NULL,NULL,NULL,'ESO 530- G 004',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.5r',0.7,'S...',NULL,NULL,NULL,NULL,1,317.186125,-22.90958,0.133,NULL,50905136855,795392763,12428011,15.5),(149462,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149462,34.71,0.2,87.5,71071,74.4,NULL,NULL,'ESO 530- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149463,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149463,35.28,0.43,114,71071,NULL,NULL,'Malmquist cor.','ESO 530- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149464,'CMD','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,'N',149464,19.2,NULL,0.069,71072,NULL,NULL,'DES J2108.8_5109','Indus I',NULL,'2015ApJ...807...50B',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149465,'CMD','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,'N',149465,20,NULL,0.1,71072,NULL,NULL,NULL,'Indus I',NULL,'2015ApJ...805..130K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149466,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,'R',149466,38.03,0.46,404,71073,70,NULL,NULL,'2MASX J21084867-0108399',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,317.20275,-1.14444,0.181,NULL,49663803581,775996930,12124952,17.8),(149467,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,'R',149467,37.42,0.46,305,71074,70,NULL,NULL,'2MASX J21085023-0713437',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000098,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,317.2092083,-7.22872,0.269,NULL,50793014960,793640858,12400638,17.3),(149468,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,'R',149468,37.54,0.46,321,71075,70,NULL,NULL,'2MASX J21085166+0104256',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000186,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,317.215333,1.07372,0.361,NULL,52077890316,813717036,12714328,17.9),(149469,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:08','1','SDSS-II SN 06914','RN',149469,41.91,0.29,1710,71076,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06914',0.414257,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149470,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:08','1','SDSS-II SN 06914','RN',149470,42.24,0.29,1980,71076,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06914',0.414257,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149471,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:08','1','SDSS-II SN 06914','N',149471,41.86,0.18,2360,71076,70,NULL,'SALT 2','SDSS-II SN 06914',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149472,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:08','1','SDSS-II SN 06914','N',149472,41.93,0.18,2430,71076,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 06914',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149473,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:08','1','SDSS-II SN 18598','RN',149473,40.05,0.24,850,71077,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18598',0.203086,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149474,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:08','1','SDSS-II SN 18598','RN',149474,41.23,0.29,1470,71077,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18598',0.203086,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149475,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:08','1','SDSS-II SN 06648','N',149475,41.55,0.26,2040,71078,70,NULL,'SALT 2','SDSS-II SN 06648',NULL,'2013ApJ...763...88C',2013,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149476,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:08','1','SDSS-II SN 06648','N',149476,41.63,0.26,2120,71078,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 06648',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149477,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149477,35.9,0.51,151,71079,70,NULL,NULL,'2MASX J21090270-0217189',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00012,NULL,'14.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,317.26125,-2.28861,0.169,NULL,49662528444,775977006,12124640,14.1),(149478,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,'R',149478,38.08,0.46,413,71080,70,NULL,NULL,'SDSS J210903.49+002927.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000187,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,317.264583,0.49097,0.357,NULL,52078571632,813727681,12714495,18.8),(149479,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,'R',149479,34.4,0.49,76,71081,75,NULL,'IR','ESO 530- G 007',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.00003,NULL,'15.2r',0.2,'Sb:',NULL,NULL,NULL,NULL,1,317.279416667,-25.5565,0.241,NULL,51425637552,803525586,12555087,15.2),(149480,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149480,34.52,0.61,80.3,71081,NULL,NULL,NULL,'ESO 530- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149481,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149481,34.56,0.2,81.7,71081,74.4,NULL,NULL,'ESO 530- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149482,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149482,34.84,0.53,92.9,71081,NULL,NULL,'Malmquist cor.','ESO 530- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149483,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149483,37.09,0.46,262,71082,70,NULL,NULL,'2MASX J21090766-0537179',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000087,NULL,'18.1g',0.15,'NLAGN',NULL,NULL,NULL,'Sy 2',1,317.281875,-5.62156,0.245,NULL,50746332850,792911450,12389241,18.1),(149484,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149484,35.73,0.49,140,71083,70,NULL,NULL,'2MASX J21090976-7910357',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,317.29075,-79.17661,0.557,NULL,48586207237,759159488,11861867,15.6),(149485,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149485,36.82,0.46,231,71084,70,NULL,NULL,'2MASX J21091440-0744186',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000096,NULL,'16.1g',0.35,'S0',NULL,NULL,NULL,NULL,1,317.3102083,-7.73856,0.245,NULL,50791267498,793613554,12400211,16.1),(149486,'Sosies','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149486,33.77,0.39,56.8,71085,NULL,NULL,NULL,'IC 5084',NULL,'2002A&A...393...57T',2002,1,1.6,NULL,'G',0.000032,NULL,'12.60',1,'SB(s)b? pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,317.311958333,-63.29003,0.041,NULL,49166358296,768224348,12003505,12.6),(149487,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149487,32.79,0.47,36.2,71085,NULL,NULL,'H','IC 5084',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149488,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149488,32.82,0.45,36.6,71085,NULL,NULL,'K','IC 5084',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149489,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149489,32.88,0.46,37.7,71085,NULL,NULL,'J','IC 5084',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149490,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149490,33.14,0.4,42.5,71085,NULL,NULL,'mean','IC 5084',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149491,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149491,35.76,0.47,142,71086,NULL,NULL,NULL,'AGC 610251',NULL,'2009ApJS..182..474S',2009,1,0.43,NULL,'G',0.000023,NULL,'16.63',0.1,'Scd',NULL,NULL,NULL,NULL,1,317.317833333,-25.56097,0.241,NULL,51425637878,803525591,12555087,16.63),(149492,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149492,35.8,0.2,145,71086,74.4,NULL,NULL,'AGC 610251',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149493,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149493,35.88,0.45,150,71086,NULL,NULL,'Malmquist cor.','AGC 610251',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149494,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 17408','RN',149494,40.44,0.26,989,71087,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17408',0.240267,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149495,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 17408','RN',149495,40.6,0.21,1060,71087,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17408',0.240267,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149496,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149496,36.82,0.46,231,71088,70,NULL,NULL,'2MASX J21091762+0016187',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000206,NULL,'17.0g',0.23,'Candidate      BLAGN',NULL,NULL,NULL,NULL,1,317.3235417,0.27197,0.389,NULL,52077705305,813714145,12714283,17),(149497,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149497,36.06,0.75,163,71089,70,NULL,NULL,'2MASX J21091834-2100463',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.9I',0.3,NULL,NULL,NULL,NULL,NULL,1,317.3265,-21.01286,0.125,NULL,50942961719,795983776,12437246,14.9),(149498,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149498,35.82,0.55,146,71090,70,NULL,NULL,'2MASX J21091936-1405001',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.76',0.3,NULL,NULL,NULL,NULL,NULL,1,317.3305417,-14.08339,0.197,NULL,50957982197,796218471,12440913,15.76),(149499,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149499,37.99,0.46,397,71091,70,NULL,NULL,'SDSS J210920.88-053110.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000094,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,317.3370417,-5.51969,0.329,NULL,50746213101,792909579,12389212,18.7),(149500,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149500,35.72,0.49,139,71092,70,NULL,NULL,'ESO 530- G 009',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.1r',0.4,'S0',NULL,NULL,NULL,NULL,1,317.342666667,-23.2495,0.201,NULL,50905006923,795390733,12427980,14.1),(149501,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149501,35.9,0.57,151,71093,70,NULL,NULL,'2MASX J21092601-1613091',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.7I',0.3,NULL,NULL,NULL,NULL,NULL,1,317.358333,-16.21917,0.217,NULL,50995597832,796806216,12450097,14.7),(149502,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149502,38.69,0.46,546,71094,70,NULL,NULL,'2MASX J21092764+1013225',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000171,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,317.365125,10.22294,0.293,NULL,55052227555,860191055,13440485,18.1),(149503,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149503,36.27,0.52,180,71095,70,NULL,NULL,'AM 2105-530 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00011,NULL,'15.80',0.65,'S0',NULL,NULL,NULL,NULL,1,317.36725,-52.93331,0.069,NULL,50603530441,790680163,12354377,15.8),(149504,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149504,37.8,0.46,364,71096,70,NULL,NULL,'2MASX J21093006+0911274',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,317.3754583,9.19092,0.433,NULL,55056542740,860258480,13441538,18.1),(149505,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149505,36.43,0.54,193,71097,70,NULL,NULL,'2MASX J21093224-6453210',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.6b',0.29,NULL,NULL,NULL,NULL,NULL,1,317.384375,-64.88914,0.029,NULL,49346494859,771038982,12047484,16.6),(149506,'GRB','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149506,44.74,0.98,2770,71098,69.7,NULL,'Fiducial','GRB 050922C',2.2,'2009MNRAS.400..775C',2009,1,NULL,NULL,'VisS',NULL,NULL,'14.7R',NULL,'Swift',NULL,NULL,NULL,NULL,1,317.3875,-8.75836,0.253,NULL,50791168046,793612000,12400187,14.7),(149507,'GRB','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149507,45.92,0.57,4770,71098,70,NULL,NULL,'GRB 050922C',2.2,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149508,'GRB','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149508,46.83,1.61,7250,71098,100,NULL,NULL,'GRB 050922C',2.2,'2009EPJC...63..139W',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149509,'GRB','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149509,46.97,1.55,7740,71098,69.7,NULL,'Fiducial','GRB 050922C',2.2,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149510,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149510,31.53,0.47,20.2,71099,NULL,NULL,'H','UGC 11689',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000023,NULL,'14.4',1,'SB(r)b',NULL,NULL,NULL,NULL,1,317.4037917,66.16994,2.401,NULL,53672331551,838630180,13103596,14.4),(149511,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149511,31.6,0.45,20.9,71099,NULL,NULL,'K','UGC 11689',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149512,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149512,31.71,0.46,21.9,71099,NULL,NULL,'J','UGC 11689',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149513,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149513,32.65,0.4,33.9,71099,NULL,NULL,'mean','UGC 11689',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149514,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149514,35.41,0.65,121,71100,70,NULL,NULL,'MCG -01-54-002',NULL,'2014MNRAS.445.2677S',2014,1,0.6,'Marginal HIPASS detection.','G',0.00003,NULL,'16.5',0.6,NULL,NULL,NULL,NULL,NULL,1,317.4075,-3.51175,0.225,NULL,50743887558,792873243,12388644,16.5),(149515,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149515,37.86,0.46,374,71101,70,NULL,NULL,'2MASX J21093914+0014442',NULL,'2015arXiv151105856S',2015,1,0.02,NULL,'G',0.000176,NULL,'17.3g',0.02,NULL,NULL,NULL,NULL,NULL,1,317.412917,0.24522,0.389,NULL,52077730106,813714532,12714289,17.3),(149516,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149516,36,0.63,158,71102,70,NULL,NULL,'2MASX J21093934-1402581',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.14',NULL,NULL,NULL,NULL,NULL,NULL,1,317.41375,-14.04939,0.177,NULL,50957987984,796218562,12440915,16.14),(149517,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149517,37.65,0.46,339,71103,70,NULL,NULL,'SDSS J210951.70+002353.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,317.465417,0.39819,0.397,NULL,52077623449,813712866,12714263,18.3),(149518,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149518,35.86,0.55,148,71104,70,NULL,NULL,'2MASX J21095357-1608540',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.93',0.4,NULL,NULL,NULL,NULL,NULL,1,317.473166667,-16.1485,0.229,NULL,50995551832,796805497,12450085,15.93),(149519,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149519,36.62,0.51,211,71105,70,NULL,NULL,'2MASX J21095588-7014077',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,317.482875,-70.23556,0.161,NULL,49341043422,770953803,12046153,16),(149520,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 12778','R',149520,38.53,0.21,463,71106,70,NULL,'SDSS CAND. Unknown; SALT 2; SN 2006fs','SN 2006fs',0.099304,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,317.495833,0.40878,0.397,NULL,52077615810,813712747,12714261,NULL),(149521,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 12778','R',149521,38.56,0.13,469,71106,70,NULL,'SDSS CAND. Unknown; MLCS2K2; SN 2006fs','SN 2006fs',0.099304,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149522,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149522,31.3,0.43,18.2,71107,75,NULL,'3.6 micron, color + selection bias corrected','ESO 342-IG 013',NULL,'2014MNRAS.444..527S',2014,1,1.6,NULL,'G',0.000027,NULL,'13.75',0.6,'Pec            HII',NULL,NULL,NULL,NULL,1,317.5019583,-37.50378,0.113,NULL,51483942726,804436605,12569321,13.75),(149523,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149523,31.38,0.43,18.9,71107,75,NULL,'3.6 micron, color corrected','ESO 342-IG 013',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149524,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149524,31.53,0.2,20.2,71107,74.4,NULL,NULL,'ESO 342-IG 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149525,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149525,31.73,0.49,22.2,71107,75,NULL,'IR','ESO 342-IG 013',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149526,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149526,32.89,0.4,37.9,71107,NULL,NULL,'mean','ESO 342-IG 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149527,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149527,33.03,0.47,40.4,71107,NULL,NULL,'H','ESO 342-IG 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149528,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149528,33.12,0.46,42.1,71107,NULL,NULL,'J','ESO 342-IG 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149529,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149529,35.35,0.47,117,71108,70,NULL,NULL,'2MASX J21100087-1404410',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000067,NULL,'15.68',0.5,NULL,NULL,NULL,NULL,NULL,1,317.5035,-14.07792,0.177,NULL,50958041053,796219391,12440927,15.68),(149530,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149530,36.26,0.46,178,71109,70,NULL,NULL,'2MASX J21100106+0952057',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000175,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,317.5044583,9.86822,0.361,NULL,55051416120,860178376,13440287,16.7),(149531,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149531,32.33,0.8,29.3,71110,75,NULL,'MAT, I','MCG -01-54-003',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000017,NULL,'14.5',1.1,'SB(rs)bc:',NULL,NULL,NULL,NULL,1,317.5212083,-3.70172,0.209,NULL,50743929227,792873894,12388654,14.5),(149532,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149532,32.59,0.32,32.9,71110,85,NULL,'I, inv','MCG -01-54-003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149533,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149533,32.59,0.32,33,71110,85,NULL,'I, raw','MCG -01-54-003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149534,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149534,32.61,0.43,33.3,71110,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-54-003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149535,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149535,32.62,0.43,33.4,71110,75,NULL,'3.6 micron, color corrected','MCG -01-54-003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149536,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149536,32.68,0.2,34.4,71110,74.4,NULL,NULL,'MCG -01-54-003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149537,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149537,32.94,0.43,38.7,71110,75,NULL,'MAT, I, raw','MCG -01-54-003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149538,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149538,32.98,0.43,39.5,71110,75,NULL,'MAT, I, inv','MCG -01-54-003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149539,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149539,33.03,0.46,40.4,71110,NULL,NULL,NULL,'MCG -01-54-003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149540,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149540,33.36,0.43,47,71110,75,NULL,'MAT, I, cor','MCG -01-54-003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149541,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149541,33.37,0.39,47.2,71110,NULL,NULL,'Malmquist cor.','MCG -01-54-003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149542,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149542,37.28,0.46,286,71111,70,NULL,NULL,'2MASX J21100809-0609168',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000093,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,317.5337083,-6.15464,0.253,NULL,50789128845,793580138,12399689,17.5),(149543,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149543,35.89,0.46,151,71112,70,NULL,NULL,'2MASX J21100815-0046227',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000163,NULL,'16.5g',0.28,'E0',NULL,NULL,NULL,NULL,1,317.534,-0.773,0.297,NULL,49663252986,775988327,12124817,16.5),(149544,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149544,36.5,0.94,200,71112,70,NULL,NULL,'2MASX J21100815-0046227',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149545,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149545,34.16,0.62,68,71113,NULL,NULL,NULL,'ESO 464- G 026',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000033,NULL,'13.7r',0.4,'(R\')SB(s)ab:   HII',NULL,NULL,NULL,NULL,1,317.5799583,-29.52742,0.325,NULL,51498961001,804671265,12572988,13.7),(149546,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149546,34.2,0.2,69.2,71113,74.4,NULL,NULL,'ESO 464- G 026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149547,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149547,34.24,0.6,70.4,71113,NULL,NULL,'Malmquist cor.','ESO 464- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149548,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149548,34.24,0.47,70.5,71113,NULL,NULL,'H','ESO 464- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149549,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149549,34.37,0.4,74.7,71113,NULL,NULL,'mean','ESO 464- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149550,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149550,34.38,0.45,75.3,71113,NULL,NULL,'K','ESO 464- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149551,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149551,34.43,0.46,76.8,71113,NULL,NULL,'J','ESO 464- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149552,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149552,35.49,0.74,125,71114,70,NULL,NULL,'2MASX J21101995-0230504',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.36',0.5,NULL,NULL,NULL,NULL,NULL,1,317.583083,-2.51414,0.169,NULL,49676113246,776189269,12127957,16.36),(149553,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15466','R',149553,40.19,0.21,875,71115,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006hj','SDSS J211021.14+005557.5',0.245675,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,317.588083,0.93264,0.345,NULL,52077978200,813718409,12714350,NULL),(149554,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13727','R',149554,40.29,0.19,928,71115,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006hj','SDSS J211021.14+005557.5',0.23,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149555,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15466','R',149555,40.4,0.16,965,71115,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006hj','SDSS J211021.14+005557.5',0.245675,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149556,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13727','R',149556,40.39,0.12,973,71115,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006hj','SDSS J211021.14+005557.5',0.23,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149557,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2006hj',NULL,149557,40.24,0.09,1120,71115,70,NULL,'SALT 2','SDSS J211021.14+005557.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149558,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2006hj',NULL,149558,40.26,0.09,1130,71115,70,NULL,'SALT 2, Malmquist cor.','SDSS J211021.14+005557.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149559,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149559,37.19,0.46,274,71116,70,NULL,NULL,'SDSS J211024.41+004526.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000162,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,317.6017083,0.75731,0.361,NULL,52078448153,813725752,12714464,17.9),(149560,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149560,37.77,0.46,359,71117,70,NULL,NULL,'2MASX J21102718+1127387',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000142,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,317.613375,11.46083,0.293,NULL,55054317066,860223704,13440995,17.9),(149561,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149561,36.89,0.63,239,71118,70,NULL,NULL,'2MASX J21102722-2915126',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,317.613416667,-29.25342,0.337,NULL,51498768662,804668260,12572941,14.4),(149562,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149562,35.91,0.56,152,71119,70,NULL,NULL,'2MASX J21102885-2312480',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'14.9r',0.37,'S0',NULL,NULL,NULL,NULL,1,317.62025,-23.21336,0.201,NULL,50904776716,795387136,12427924,14.9),(149563,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149563,36.31,0.63,183,71120,70,NULL,NULL,'2MASX J21102901-0856597',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.92',0.4,NULL,NULL,NULL,NULL,NULL,1,317.620917,-8.94992,0.301,NULL,50773317061,793333079,12395829,16.92),(149564,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149564,36.94,0.46,245,71121,70,NULL,NULL,'2MASX J21103185+0053427',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00019,NULL,'16.4g',0.32,'E0',NULL,NULL,NULL,NULL,1,317.6327083,0.89506,0.345,NULL,52091758162,813933721,12717714,16.4),(149565,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2006mz',NULL,149565,39.45,0.12,776,71122,70,NULL,'Hubble residual -0.39 for z0.24610','SDSS-II SN 15466 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,317.6454583,-0.12272,0.361,NULL,49662719437,775979991,12124687,NULL),(149566,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2006mz',NULL,149566,40.19,0.11,1090,71122,70,NULL,'SALT 2','SDSS-II SN 15466 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149567,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2006mz',NULL,149567,40.21,0.11,1100,71122,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15466 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149568,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 03044','R',149568,42.15,0.22,1860,71122,70,NULL,'SDSS CAND. AGN; MLCS2K2; SN 2006mz','SDSS-II SN 15466 HOST',0.444114,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149569,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 03044','R',149569,42.55,0.21,2240,71122,70,NULL,'SDSS CAND. AGN; SALT 2; SN 2006mz','SDSS-II SN 15466 HOST',0.444114,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149570,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01827','RN',149570,42.23,0.25,2070,71123,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01827',0.353205,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149571,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01827','RN',149571,42.27,0.26,2100,71123,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01827',0.353205,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149572,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149572,35.61,0.6,133,71124,70,NULL,NULL,'ESO 530- G 016',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'14.4r',0.2,'S...',NULL,NULL,NULL,NULL,1,317.698417,-23.37525,0.161,NULL,50904870607,795388603,12427946,14.4),(149573,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149573,35.52,0.49,127,71125,75,NULL,'IR','2MFGC 16044',NULL,'2011yCatp016004901K',2011,1,NULL,NULL,'G',NULL,NULL,'11.9K',NULL,NULL,NULL,NULL,NULL,NULL,1,317.7032917,4.34522,0.337,NULL,55036083631,859938806,13436543,11.9),(149574,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02464',NULL,149574,39.79,0.37,907,71126,70,NULL,'SN photometric redshift distance, z photo =0.240 +/- 0.052','SDSS-II SN 02464',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,317.712083,0.10289,0.389,NULL,52077532204,813711440,12714241,NULL),(149575,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02464',NULL,149575,40.48,0.21,1250,71126,70,NULL,'SALT 2','SDSS-II SN 02464',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149576,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02464',NULL,149576,40.51,0.21,1260,71126,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 02464',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149577,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149577,35.87,0.54,149,71127,70,NULL,NULL,'ESO 187- G 056',NULL,'2014MNRAS.445.2677S',2014,1,1.09,NULL,'G',0.000113,NULL,'14.2r',0.27,'Sa:',NULL,NULL,NULL,NULL,1,317.713208333,-53.42125,0.117,NULL,50603588901,790681076,12354391,14.2),(149578,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15647',NULL,149578,40.67,0.24,1360,71128,70,NULL,'SN photometric redshift distance, z photo =0.389 +/- 0.058','SDSS-II SN 15647',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','21.4g',0.02,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,317.7150417,0.64975,0.389,NULL,52091296945,813926514,12717601,21.4),(149579,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149579,37.92,0.33,384,71129,70,NULL,NULL,'2MASX J21105273+0935451',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00014,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,317.719667,9.59589,0.361,NULL,55058850625,860294541,13442102,18.2),(149580,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149580,36.31,0.62,183,71130,70,NULL,NULL,'2MASX J21105420-0346348',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000017,NULL,'16.37',0.5,NULL,NULL,NULL,NULL,NULL,1,317.725875,-3.77636,0.177,NULL,49667770683,776058916,12125920,16.37),(149581,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149581,35.62,0.53,133,71131,70,NULL,NULL,'IC 5089',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.99',NULL,NULL,NULL,NULL,NULL,NULL,1,317.7272083,-3.86278,0.177,NULL,50744328948,792880139,12388752,15.99),(149582,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149582,36.62,0.86,211,71132,70,NULL,NULL,'2MASX J21105640-0205478',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000103,NULL,'16.61',0.4,NULL,NULL,NULL,NULL,NULL,1,317.735125,-2.09678,0.161,NULL,49675915358,776186177,12127909,16.61),(149583,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149583,35.19,0.54,109,71133,70,NULL,NULL,'ESO 286- G 070',NULL,'2014MNRAS.445.2677S',2014,1,1.39,NULL,'G',0.000087,NULL,'13.6r',0.33,'Sa?',NULL,NULL,NULL,NULL,1,317.738458333,-43.711,0.053,NULL,51390771056,802980797,12546574,13.6),(149584,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149584,35.77,0.45,143,71134,NULL,NULL,'Malmquist cor.','ESO 107- G 011',NULL,'2009ApJS..182..474S',2009,1,0.95,NULL,'G',0.000033,NULL,'14.6r',0.47,'Sc',NULL,NULL,NULL,NULL,1,317.760791667,-65.52728,0.009,NULL,49377920907,771530014,12055156,14.6),(149585,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149585,35.95,0.42,155,71134,NULL,NULL,NULL,'ESO 107- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149586,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149586,35.99,0.2,158,71134,74.4,NULL,NULL,'ESO 107- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149587,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 03102',NULL,149587,40.62,0.97,1330,71135,70,NULL,'SN photometric redshift distance, z photo =0.379 +/- 0.321','SDSS-II SN 03102',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.4g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,317.7620417,-0.80117,0.297,NULL,49675122406,776173787,12127715,21.4),(149588,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149588,37.03,0.93,255,71136,70,NULL,NULL,'2MASX J21110413-2257486',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,317.767291667,-22.96342,0.145,NULL,50905031012,795391109,12427986,15.7),(149589,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149589,37.78,0.46,359,71137,70,NULL,NULL,'2MASXi J2111047-064431',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000085,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,317.76975,-6.74203,0.213,NULL,50789162171,793580658,12399697,18.1),(149590,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149590,33.41,0.49,48.1,71138,75,NULL,'IR','ESO 464- G 027',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000033,NULL,'15.94',0.2,'Sb',NULL,NULL,NULL,NULL,1,317.77075,-29.99803,0.333,NULL,51499591736,804681120,12573142,15.94),(149591,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149591,34.6,0.4,83,71138,NULL,NULL,'mean','ESO 464- G 027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149592,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149592,34.71,0.47,87.3,71138,NULL,NULL,'H','ESO 464- G 027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149593,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149593,36.27,0.87,180,71139,70,NULL,NULL,'2MASX J21110743-2043576',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.4r',0.3,NULL,NULL,NULL,NULL,NULL,1,317.781083,-20.73272,0.133,NULL,50942391062,795974860,12437107,15.4),(149594,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149594,37.32,0.72,291,71140,70,NULL,NULL,'2MASX J21110786-2314104',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'15.3r',0.41,NULL,NULL,NULL,NULL,NULL,1,317.7827917,-23.23625,0.161,NULL,50904901509,795389086,12427954,15.3),(149595,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149595,34.88,0.59,94.5,71141,70,NULL,NULL,'2MASX J21111025-2206344',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'14.0r',0.39,NULL,NULL,NULL,NULL,NULL,1,317.792625,-22.10981,0.161,NULL,50915751502,795558617,12430603,14),(149596,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149596,35.29,0.5,115,71142,70,NULL,NULL,'2MASX J21111253-8050481',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000147,NULL,'14.9b',NULL,'S0 pec',NULL,NULL,NULL,NULL,1,317.801375,-80.84681,0.537,NULL,48573932887,758967701,11858870,14.9),(149597,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 12839','RN',149597,44.11,0.33,4650,71143,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 12839',0.425394,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149598,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 12839','RN',149598,44.95,0.49,6840,71143,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 12839',0.425394,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149599,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149599,35.5,0.47,126,71144,70,NULL,NULL,'2MASX J21111476-4830160',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000133,NULL,'13.4r',0.5,'E',NULL,NULL,NULL,NULL,1,317.811625,-48.50447,0.057,NULL,51346483647,802288806,12535762,13.4),(149600,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149600,35.7,0.57,138,71145,70,NULL,NULL,'2MASX J21111750-5049410',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00012,NULL,'14.6r',0.45,'S',NULL,NULL,NULL,NULL,1,317.822917,-50.82808,0.005,NULL,51353202454,802393788,12537402,14.6),(149601,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149601,36.44,0.46,194,71146,70,NULL,NULL,'2MASX J21111749+1028569',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,317.822917,10.48258,0.317,NULL,55051776040,860184000,13440375,16.7),(149602,'Ring Diameter','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149602,31.6,0.84,21,71147,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7020',NULL,'1981ApJS...45..541P',1981,1,3.7,NULL,'G',0.000087,NULL,'12.78',1.8,'(R)SA(r)0^+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,317.8337083,-64.02533,0.033,NULL,49346630441,771041100,12047517,12.78),(149603,'Tully est','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149603,32.89,0.8,37.8,71147,75,NULL,'B','NGC 7020',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149604,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149604,37.92,0.33,384,71148,70,NULL,NULL,'2MASX J21112023+0934099',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000161,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,317.834167,9.56956,0.361,NULL,55058832394,860294256,13442097,17.3),(149605,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2005fj',NULL,149605,38.55,0.12,449,71149,74.2,NULL,'SALT 2','SDSS J211120.87-002643.5',0.143,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,317.8369583,-0.44542,0.241,NULL,49674436606,776163071,12127547,NULL),(149606,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2005fj',NULL,149606,39.13,0.05,587,71149,70,NULL,'SDSS-II SN 01794','SDSS J211120.87-002643.5',0.143,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149607,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01794','R',149607,39.32,0.19,641,71149,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fj','SDSS J211120.87-002643.5',0.14,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149608,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2005fj',NULL,149608,39.35,0.14,649,71149,70,NULL,'SDSS-II SN 01794, SALT 2','SDSS J211120.87-002643.5',0.143,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149609,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01794','R',149609,39.53,0.1,708,71149,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fj','SDSS J211120.87-002643.5',0.14,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149610,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2005fj',NULL,149610,39.3,0.08,724,71149,70,NULL,'SALT 2','SDSS J211120.87-002643.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149611,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2005fj',NULL,149611,39.31,0.08,728,71149,70,NULL,'SALT 2, Malmquist cor.','SDSS J211120.87-002643.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149612,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149612,37.54,0.46,322,71150,70,NULL,NULL,'2MASX J21112115+0021276',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000185,NULL,'17.5g',0.24,'AGN',NULL,NULL,NULL,NULL,1,317.8382083,0.35778,0.397,NULL,52091200861,813925013,12717578,17.5),(149613,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 07949','RN',149613,39.64,0.29,791,71151,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 07949',0.069905,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149614,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 07949','RN',149614,40.24,6.19,1050,71151,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07949',0.069905,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149615,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13593',NULL,149615,40.95,0.15,1550,71152,70,NULL,'SN photometric redshift distance, z photo =0.461 +/- 0.046','SDSS-II SN 13593',NULL,'2011ApJ...738..162S',2011,1,0.03,NULL,'G',NULL,'PHOT','22.6g',0.02,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,317.846083,0.21239,0.397,NULL,52091213726,813925214,12717581,22.6),(149616,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149616,34.68,0.47,86.3,71153,NULL,NULL,'H','IC 5090',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000017,NULL,'14.39',0.5,'Sa pec?        HII','Group member',NULL,NULL,NULL,1,317.877,-2.03256,0.153,NULL,49676393554,776193649,12128025,14.39),(149617,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149617,34.81,0.45,91.4,71153,NULL,NULL,'K','IC 5090',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149618,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149618,34.9,0.46,95.6,71153,NULL,NULL,'J','IC 5090',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149619,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149619,35.4,0.4,120,71153,NULL,NULL,'mean','IC 5090',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149620,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149620,35.69,0.66,137,71154,70,NULL,NULL,'2MASX J21113239-4238519',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'14.9r',0.42,NULL,NULL,NULL,NULL,NULL,1,317.8850417,-42.64783,0.057,NULL,51361334311,802520848,12539388,14.9),(149621,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20791',NULL,149621,39.45,0.73,776,71155,70,NULL,'SN photometric redshift distance, z photo =0.201 +/- 0.095','SDSS-II SN 20791',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,317.947833333,-0.386,0.241,NULL,49674408508,776162632,12127541,NULL),(149622,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20791','R',149622,41.25,0.26,1330,71155,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20791',0.335856,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149623,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20791','R',149623,41.47,0.22,1470,71155,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20791',0.335856,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149624,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20791',NULL,149624,41.14,0.16,1690,71155,70,NULL,'SALT 2','SDSS-II SN 20791',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149625,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20791',NULL,149625,41.18,0.16,1720,71155,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20791',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149626,'GRB','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149626,41.68,0.31,2170,71156,70,NULL,'z = 0.75 +/- 0.15','GRB 101023A',NULL,'2013A&A...551A.133P',2012,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,317.963875,-65.38811,0.021,NULL,49347588604,771056071,12047751,NULL),(149627,'GRB','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149627,41.92,0.11,2420,71156,NULL,NULL,'0.24 mag syst.','GRB 101023A',NULL,'2012A&A...538A..58P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149628,'GRB','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149628,41.92,NULL,2420,71156,70,NULL,'Photo z = 0.9','GRB 101023A',NULL,'2013A&A...552L...5P',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149629,'SBF','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149629,32.92,0.49,38.4,71157,NULL,NULL,'I','NGC 7029',NULL,'2001ApJ...546..681T',2001,1,2.6,'The APM position is southwest of the nucleus.','G',0.000033,NULL,'12.35',1.4,'E','in a pair',NULL,NULL,NULL,1,317.966875,-49.28372,0,NULL,51345740183,802277190,12535581,12.35),(149630,'SBF','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149630,32.92,0.49,38.4,71157,NULL,NULL,NULL,'NGC 7029',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149631,'SBF','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149631,32.96,0.14,39.1,71157,74.4,NULL,NULL,'NGC 7029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149632,'SBF','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149632,33.25,0.49,44.7,71157,NULL,NULL,'Malmquist cor.','NGC 7029',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149633,'D-Sigma','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149633,32.52,0.4,32,71157,75,NULL,'Edat, raw','NGC 7029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149634,'D-Sigma','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149634,32.7,0.4,34.7,71157,75,NULL,'Edat, cor','NGC 7029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149635,'Faber-Jackson','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149635,30.56,0.65,12.9,71157,95,NULL,'Weighted Mean','NGC 7029',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149636,'Faber-Jackson','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149636,31.67,0.81,21.6,71157,55,NULL,'Visvanathan & Sandage 1979','NGC 7029',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149637,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149637,32.42,0.41,30.5,71157,NULL,NULL,NULL,'NGC 7029',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149638,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149638,32.69,0.41,34.5,71157,NULL,NULL,'Malmquist cor.','NGC 7029',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149639,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149639,33,0.5,39.8,71157,70,NULL,NULL,'NGC 7029',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149640,'Tertiary','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149640,31.55,0.71,20.4,71157,95,NULL,NULL,'NGC 7029',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149641,'Tully est','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149641,32.8,0.8,36.3,71157,75,NULL,'B','NGC 7029',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149642,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149642,32.61,0.45,33.2,71157,NULL,NULL,'K','NGC 7029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149643,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149643,32.8,0.4,36.2,71157,NULL,NULL,'mean','NGC 7029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149644,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149644,33.06,0.8,40.9,71158,75,NULL,'MAT, I','ESO 107- G 014',NULL,'1997ApJS..109..333W',1997,1,1.25,NULL,'G',0.000033,NULL,'15.22',0.46,'SB(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,317.978667,-64.22828,0.037,NULL,49346594015,771040531,12047508,15.22),(149645,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149645,33.49,0.32,49.9,71158,85,NULL,'I, inv','ESO 107- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149646,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149646,33.53,0.32,50.7,71158,85,NULL,'I, raw','ESO 107- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149647,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149647,33.57,0.43,51.7,71158,75,NULL,'MAT, I, inv','ESO 107- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149648,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149648,33.66,0.43,54,71158,75,NULL,'MAT, I, raw','ESO 107- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149649,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149649,33.76,0.43,56.5,71158,75,NULL,'MAT, I, cor','ESO 107- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149650,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149650,33.95,0.35,61.5,71159,NULL,NULL,NULL,'UGC 11696',NULL,'2009ApJS..182..474S',2009,1,1.06,NULL,'G',0.000017,NULL,'16.8g',0.2,'Sdm:',NULL,NULL,NULL,NULL,1,317.979416667,11.37936,0.281,NULL,55053051685,860203932,13440686,16.8),(149651,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149651,33.99,0.2,62.8,71159,74.4,NULL,NULL,'UGC 11696',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149652,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149652,34.07,0.49,65.3,71159,75,NULL,'IR','UGC 11696',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149653,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149653,34.18,0.31,68.7,71159,NULL,NULL,'Malmquist cor.','UGC 11696',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149654,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149654,35.2,0.47,110,71160,70,NULL,NULL,'ESO 235- G 074',NULL,'2014MNRAS.445.2677S',2014,1,1.02,'1984MNRAS.210...69F has V = 11400: +- 200 km/s.','G',0.00015,NULL,'14.1r',0.27,'S0?',NULL,NULL,NULL,NULL,1,317.990417,-48.45006,0.065,NULL,51346513358,802289271,12535769,14.1),(149655,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149655,35.96,0.5,155,71161,70,NULL,NULL,'2MASX J21115772-2309358',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'14.4r',0.43,'E',NULL,NULL,NULL,NULL,1,317.990541667,-23.16,0.145,NULL,50904804368,795387568,12427930,14.4),(149656,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149656,33.56,0.69,51.5,71162,100,NULL,'mid-IR','CGCG 426-015',NULL,'2013ApJ...771...88L',2013,1,0.87,NULL,'G',0.000033,NULL,'14.9g',0.57,'Sa','Group member',NULL,NULL,NULL,1,318.005417,11.49564,0.281,NULL,55053049560,860203899,13440685,14.9),(149657,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149657,34.68,0.59,86.2,71162,NULL,NULL,'Malmquist cor.','CGCG 426-015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149658,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149658,34.77,0.57,89.9,71162,NULL,NULL,NULL,'CGCG 426-015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149659,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149659,34.81,0.2,91.6,71162,74.4,NULL,NULL,'CGCG 426-015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149660,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149660,34.23,0.44,70.2,71163,NULL,NULL,NULL,'UGC 11696 NOTES01',NULL,'2009ApJS..182..474S',2009,1,0.52,NULL,'G',0.000226,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,318.026375,11.34528,0.281,NULL,55053021216,860203456,13440679,16.9),(149661,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149661,34.24,0.2,70.5,71163,74.4,NULL,NULL,'UGC 11696 NOTES01',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149662,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149662,34.33,0.43,73.3,71163,NULL,NULL,'Malmquist cor.','UGC 11696 NOTES01',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149663,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149663,36.46,0.61,195,71164,70,NULL,NULL,'2MASX J21120799-2324447',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,318.033458333,-23.41247,0.161,NULL,50904911935,795389248,12427957,14.8),(149664,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149664,34.36,0.4,74.6,71165,NULL,NULL,'mean','UGC 11697',NULL,'2007A&A...465...71T',2007,1,1,'Springob et al. (2005ApJS..160..149S) give v= 9030 km/sec.','G',0.000033,NULL,'15.04',0.6,'SBbc           Sbrst',NULL,NULL,NULL,NULL,1,318.042208333,11.65942,0.281,NULL,55053186733,860206042,13440719,15.04),(149665,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149665,34.51,0.47,80,71165,NULL,NULL,'H','UGC 11697',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149666,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149666,35.84,0.4,147,71166,NULL,NULL,'mean','UGC 11695',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000033,NULL,'14.91',0.8,'SA(r)b pec:    HII',NULL,NULL,NULL,NULL,1,318.043833333,-1.47525,0.189,NULL,49674529116,776164517,12127570,14.91),(149667,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149667,35.98,0.47,157,71166,NULL,NULL,'H','UGC 11695',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149668,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149668,36.01,0.45,159,71166,NULL,NULL,'K','UGC 11695',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149669,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149669,36.15,0.46,170,71166,NULL,NULL,'J','UGC 11695',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149670,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149670,33.02,0.8,40.2,71167,75,NULL,'MAT, I','ESO 187- G 058',NULL,'1997ApJS..109..333W',1997,1,2,'Allen, et al. (1991, MNRAS, 248, 528) give z=0.065 +/- 0.001.','G',0.000021,NULL,'13.6r',0.29,'SBc? sp',NULL,NULL,NULL,NULL,1,318.0435417,-57.278,0.153,NULL,49137535556,767773993,11996468,13.6),(149671,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149671,33.14,0.49,42.5,71167,75,NULL,'IR','ESO 187- G 058',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149672,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149672,33.19,NULL,43.5,71167,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 187- G 058',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149673,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149673,33.21,NULL,43.8,71167,NULL,NULL,'Dipole','ESO 187- G 058',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149674,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149674,33.23,NULL,44.2,71167,NULL,NULL,'Dipole + Quadrupole','ESO 187- G 058',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149675,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149675,33.23,0.32,44.3,71167,85,NULL,'I, raw','ESO 187- G 058',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149676,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149676,33.25,0.32,44.7,71167,85,NULL,'I, inv','ESO 187- G 058',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149677,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149677,33.26,0.43,45,71167,75,NULL,'MAT, I, raw','ESO 187- G 058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149678,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149678,33.38,NULL,47.4,71167,NULL,NULL,NULL,'ESO 187- G 058',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149679,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149679,33.38,0.43,47.4,71167,75,NULL,'MAT, I, inv','ESO 187- G 058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149680,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149680,33.46,0.43,49.3,71167,75,NULL,'MAT, I, cor','ESO 187- G 058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149681,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149681,34.57,NULL,81.9,71168,NULL,NULL,NULL,'ESO 342- G 017',NULL,'2000BSAO...50....5K',2000,1,1.55,NULL,'G',0.000033,NULL,'16.43',0.13,'Sd',NULL,NULL,NULL,NULL,1,318.045417,-37.62744,0.113,NULL,51483888851,804435763,12569308,16.43),(149682,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149682,34.57,NULL,81.9,71168,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 342- G 017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149683,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149683,34.58,NULL,82.4,71168,NULL,NULL,'Dipole + Quadrupole','ESO 342- G 017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149684,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149684,34.59,NULL,82.8,71168,NULL,NULL,'Dipole','ESO 342- G 017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149685,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149685,35,0.68,100,71168,NULL,NULL,NULL,'ESO 342- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149686,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149686,35.04,0.2,102,71168,74.4,NULL,NULL,'ESO 342- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149687,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149687,35.18,0.63,108,71168,NULL,NULL,'Malmquist cor.','ESO 342- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149688,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149688,36.07,0.61,163,71169,70,NULL,NULL,'2MASX J21121221-4617444',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'15.0r',0.28,NULL,NULL,NULL,NULL,NULL,1,318.050875,-46.29567,0.077,NULL,51401135261,803142738,12549105,15),(149689,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20131','RN',149689,38.97,0.48,528,71170,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 20131',0.178591,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149690,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20131','RN',149690,40.44,0.73,1040,71170,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20131',0.178591,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149691,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2011gf',NULL,149691,35.16,0.01,108,71171,72,NULL,'M(H) = -18.317 mag','SDSS J211222.69-074913.9',NULL,'2014ApJ...784..105W',2013,1,0.41,NULL,'G',0.000056,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,318.0945417,-7.82056,0.305,NULL,50791241265,793613144,12400205,17.4),(149692,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 03246','RN',149692,41.53,0.27,1520,71172,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 03246',0.337703,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149693,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 03246','RN',149693,42.09,0.26,1960,71172,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 03246',0.337703,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149694,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149694,36.7,0.63,219,71173,70,NULL,NULL,'2MASX J21122838-0517077',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.91',0.4,NULL,NULL,NULL,NULL,NULL,1,318.118167,-5.28536,0.377,NULL,50743049554,792860149,12388439,16.91),(149695,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149695,35.92,0.79,153,71174,70,NULL,NULL,'2MASX J21123049-4320565',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'15.1r',0.18,NULL,NULL,NULL,NULL,NULL,1,318.127041667,-43.349,0.069,NULL,51360542843,802508481,12539195,15.1),(149696,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20104','R',149696,40.69,0.2,1170,71175,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J211233.27+001653.9',0.178292,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,'PHOT','21.9g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,318.138625,0.28167,0.397,NULL,52082989588,813796712,12715573,21.9),(149697,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20104','R',149697,40.83,0.29,1240,71175,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J211233.27+001653.9',0.178292,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149698,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20104',NULL,149698,40.61,0.16,1320,71175,70,NULL,'SALT 2','SDSS J211233.27+001653.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149699,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20104',NULL,149699,40.62,0.16,1330,71175,70,NULL,'SALT 2, Malmquist cor.','SDSS J211233.27+001653.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149700,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149700,36.88,0.69,238,71176,70,NULL,NULL,'2MASX J21123470-8152003',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,318.14425,-81.86681,0.445,NULL,48561892745,758779574,11855930,17.4),(149701,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13747','RN',149701,42.22,0.19,1900,71177,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13747',0.462691,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149702,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149702,38,0.79,398,71178,70,NULL,NULL,'ESO 530- G 023',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'15.39',1,'SB(r)ab',NULL,NULL,NULL,NULL,1,318.178916667,-23.14589,0.145,NULL,50916117849,795564341,12430692,15.39),(149703,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149703,35.33,0.54,116,71179,NULL,NULL,'Malmquist cor.','ESO 402- G 015',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.64',0.6,'Sb             HII',NULL,NULL,NULL,NULL,1,318.1832917,-36.85889,0.185,NULL,51485324402,804458193,12569659,14.64),(149704,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149704,35.38,0.53,119,71179,NULL,NULL,NULL,'ESO 402- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149705,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149705,35.42,0.2,121,71179,74.4,NULL,NULL,'ESO 402- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149706,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149706,35.29,0.72,114,71180,70,NULL,NULL,'2MASX J21124674-1949009',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'14.8r',0.28,NULL,NULL,NULL,NULL,NULL,1,318.194833,-19.81708,0.133,NULL,50940499916,795945311,12436645,14.8),(149707,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 14024','R',149707,39.11,0.21,578,71181,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ht','SN 2006ht',0.146,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,318.198583,0.91633,0.377,NULL,52092127771,813939496,12717804,NULL),(149708,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 14024','R',149708,39.27,0.1,624,71181,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ht','SN 2006ht',0.146,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149709,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149709,36.77,0.54,226,71182,70,NULL,NULL,'LCRS B210929.5-444949',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'14.2r',0.42,'E',NULL,NULL,NULL,NULL,1,318.199333,-44.62406,0.081,NULL,51398254038,803097719,12548401,14.2),(149710,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2006ht',NULL,149710,38.89,0.08,600,71183,70,NULL,'SALT 2','2MASX J21124822+0055050',NULL,'2013ApJ...763...88C',2013,1,0.1,NULL,'G',NULL,NULL,'19.3g',0.09,NULL,NULL,NULL,NULL,NULL,1,318.200791667,0.91783,0.377,NULL,52092138785,813939668,12717807,19.3),(149711,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2006ht',NULL,149711,38.9,0.08,603,71183,70,NULL,'SALT 2, Malmquist cor.','2MASX J21124822+0055050',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149712,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16356',NULL,149712,37.05,1.23,257,71184,70,NULL,'SN photometric redshift distance, z photo =0.062 +/- 0.050','SDSS-II SN 16356',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.1g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,318.200958333,-0.56758,0.241,NULL,49674346661,776161666,12127526,21.1),(149713,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16356','R',149713,41.84,0.29,1670,71184,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16356',0.399335,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149714,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16356','R',149714,42.04,0.27,1820,71184,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16356',0.399335,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149715,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16356',NULL,149715,41.71,0.18,2200,71184,70,NULL,'SALT 2','SDSS-II SN 16356',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149716,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16356',NULL,149716,41.78,0.18,2270,71184,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16356',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149717,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149717,36.55,0.46,204,71185,70,NULL,NULL,'2MASX J21125250-0745379',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000093,NULL,'16.1g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,318.218666667,-7.76064,0.305,NULL,50773623965,793337874,12395904,16.1),(149718,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 06502','RN',149718,40.5,0.11,1130,71186,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 06502',0.114669,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149719,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 06502','RN',149719,40.66,0.22,1210,71186,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 06502',0.114669,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149720,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149720,35.48,0.54,125,71187,70,NULL,NULL,'ESO 187- G 059',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000137,NULL,'14.83',0.8,'S0',NULL,NULL,NULL,NULL,1,318.2509583,-55.04661,0.101,NULL,48657581989,760274718,11879292,14.83),(149721,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 03430','RN',149721,39.61,0.14,761,71188,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03430',0.097627,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149722,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 03430','RN',149722,40.14,0.3,972,71188,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03430',0.097627,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149723,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149723,34.87,0.55,94.1,71189,70,NULL,NULL,'2MASX J21131201-0008368',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'15.9g',0.18,'S0/a',NULL,NULL,NULL,NULL,1,318.2999583,-0.14353,0.289,NULL,49670148368,776096068,12126501,15.9),(149724,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149724,35.56,0.48,129,71190,NULL,NULL,'Malmquist cor.','ESO 144- G 019',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.91',0.5,'SA(s)c: pec',NULL,NULL,NULL,NULL,1,318.3005,-58.42983,0.145,NULL,49135420302,767740942,11995952,14.91),(149725,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149725,35.62,0.47,133,71190,NULL,NULL,NULL,'ESO 144- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149726,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149726,35.66,0.2,136,71190,74.4,NULL,NULL,'ESO 144- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149727,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149727,35.9,0.4,151,71190,NULL,NULL,'mean','ESO 144- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149728,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149728,36,0.47,159,71190,NULL,NULL,'H','ESO 144- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149729,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 17611','RN',149729,43.12,0.4,2920,71191,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 17611',0.443089,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149730,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 17611','RN',149730,43.31,0.4,3180,71191,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17611',0.443089,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149731,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149731,34.65,0.5,85,71192,NULL,NULL,'Malmquist cor.','CGCG 375-011',NULL,'2009ApJS..182..474S',2009,1,0.93,NULL,'G',0.000013,NULL,'15.0g',0.47,'Sb',NULL,NULL,NULL,NULL,1,318.30425,-0.36661,0.265,NULL,49670205033,776096953,12126514,15),(149732,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149732,34.68,0.2,86.3,71192,74.4,NULL,NULL,'CGCG 375-011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149733,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149733,34.74,0.48,88.8,71192,NULL,NULL,NULL,'CGCG 375-011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149734,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149734,35.74,0.67,141,71193,70,NULL,NULL,'2MASX J21131543-3732127',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.97',0.22,NULL,NULL,NULL,NULL,NULL,1,318.314375,-37.53689,0.129,NULL,51483850621,804435165,12569299,15.97),(149735,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149735,33.05,0.43,40.8,71194,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7040',NULL,'2014MNRAS.444..527S',2014,1,1.1,'The companion noted in CGCG and UGC may be a line of three stars.','G',0.000026,NULL,'14.9P',0.8,'S',NULL,NULL,NULL,NULL,1,318.31875,8.86497,0.405,NULL,55057425067,860272266,13441754,14.9),(149736,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13813',NULL,149736,39.65,0.21,851,71195,70,NULL,'SN photometric redshift distance, z photo =0.223 +/- 0.026','SDSS-II SN 13813',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,318.320875,-0.40486,0.205,NULL,49670084931,776095077,12126485,NULL),(149737,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13813','R',149737,40.45,0.21,995,71195,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13813',0.23646,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149738,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13813','R',149738,40.68,0.15,1110,71195,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13813',0.23646,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149739,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13813',NULL,149739,40.32,0.15,1160,71195,70,NULL,'SALT 2','SDSS-II SN 13813',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149740,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13813',NULL,149740,40.34,0.15,1170,71195,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13813',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149741,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149741,35.32,0.58,116,71196,70,NULL,NULL,'FAIRALL 0957',NULL,'2014MNRAS.445.2677S',2014,1,0.6,'1984MNRAS.210...69F has V = 11100: +- 200 km/s.','G',0.00015,NULL,'14.2r',0.53,'(R\'_1)SB(s)a',NULL,NULL,NULL,NULL,1,318.33675,-47.95339,0.053,NULL,51346186582,802284165,12535690,14.2),(149742,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149742,36.71,0.68,220,71197,70,NULL,NULL,'2MASX J21132322-7229198',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,318.3465417,-72.48886,0.097,NULL,49291988351,770187317,12034176,16.8),(149743,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149743,35.42,0.52,121,71198,70,NULL,NULL,'ESO 047- G 024',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'16.1b',0.2,'Compact',NULL,NULL,NULL,NULL,1,318.3679583,-74.44897,0.237,NULL,48402572566,756290196,11817034,16.1),(149744,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149744,34.89,0.53,95,71199,70,NULL,NULL,'CGCG 375-014',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000097,NULL,'15.0',0.5,NULL,NULL,NULL,NULL,NULL,1,318.3860417,-1.38006,0.181,NULL,49674898936,776170295,12127660,15),(149745,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149745,36.82,0.66,231,71200,70,NULL,NULL,'2MASX J21133544-4300222',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'14.8r',0.49,NULL,NULL,NULL,NULL,NULL,1,318.39775,-43.00617,0.073,NULL,51360371605,802505806,12539153,14.8),(149746,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149746,36.88,0.9,238,71201,70,NULL,NULL,'2MASX J21133707-5400255',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'14.9r',0.42,'S0',NULL,NULL,NULL,NULL,1,318.404375,-54.00711,0.109,NULL,50603958822,790686856,12354482,14.9),(149747,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 06371','RN',149747,40.09,2.22,932,71202,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06371',0.120792,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149748,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149748,36.71,0.74,220,71203,70,NULL,NULL,'2MASX J21133996-2902563',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'15.0r',0.53,'S',NULL,NULL,NULL,NULL,1,318.416583333,-29.04903,0.349,NULL,51428650011,803572656,12555822,15),(149749,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149749,33.1,0.8,41.7,71204,75,NULL,'MAT, I','ESO 107- G 015',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.000027,NULL,'13.5r',0.4,'SB(s)cd: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,318.42925,-63.3365,0.041,NULL,49169106089,768267282,12004176,13.5),(149750,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149750,32.81,0.4,36.5,71204,NULL,NULL,NULL,'ESO 107- G 015',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149751,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149751,32.85,0.49,37.1,71204,75,NULL,'IR','ESO 107- G 015',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149752,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149752,32.94,0.32,38.7,71204,85,NULL,'I, raw','ESO 107- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149753,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149753,32.95,0.32,38.9,71204,85,NULL,'I, inv','ESO 107- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149754,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149754,33,0.43,39.7,71204,75,NULL,'MAT, I, raw','ESO 107- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149755,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149755,33.1,0.43,41.7,71204,75,NULL,'MAT, I, inv','ESO 107- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149756,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149756,33.14,0.43,42.5,71204,75,NULL,'MAT, I, cor','ESO 107- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149757,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149757,33.27,0.4,45.1,71204,NULL,NULL,'mean','ESO 107- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149758,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149758,33.32,0.47,46.1,71204,NULL,NULL,'H','ESO 107- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149759,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149759,33.46,0.46,49.3,71204,NULL,NULL,'J','ESO 107- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149760,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149760,33.47,0.45,49.4,71204,NULL,NULL,'K','ESO 107- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149761,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13432','R',149761,40.23,0.31,903,71205,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13432',0.228542,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,318.453208333,-1.07564,0.185,NULL,49674831634,776169244,12127644,NULL),(149762,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13432','R',149762,40.3,0.34,935,71205,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13432',0.228542,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149763,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149763,34.69,NULL,86.8,71206,NULL,NULL,'Dipole','ESO 144- G 020',NULL,'2010Ap&SS.325..163P',2010,1,2.13,NULL,'G',0.000033,NULL,'15.1r',0.24,'Sc',NULL,NULL,NULL,NULL,1,318.459708333,-61.28925,0.073,NULL,49188812890,768575201,12008987,15.1),(149764,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149764,34.69,NULL,86.8,71206,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 144- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149765,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149765,34.72,NULL,88,71206,NULL,NULL,'Dipole + Quadrupole','ESO 144- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149766,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149766,35.42,0.54,121,71206,NULL,NULL,NULL,'ESO 144- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149767,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149767,35.43,0.54,122,71206,NULL,NULL,'Malmquist cor.','ESO 144- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149768,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149768,35.46,0.2,124,71206,74.4,NULL,NULL,'ESO 144- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149769,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149769,37.23,0.46,279,71207,70,NULL,NULL,'2MASX J21135107+1012095',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,318.462667,10.20256,0.277,NULL,55059305437,860301647,13442213,17.9),(149770,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20105',NULL,149770,40.14,0.31,1060,71208,70,NULL,'SN photometric redshift distance, z photo =0.289 +/- 0.055','SDSS-II SN 20105',NULL,'2011ApJ...738..162S',2011,1,0.03,NULL,'G',NULL,'PHOT','24.0g',0.01,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,318.478375,0.39703,0.369,NULL,52083756689,813808698,12715760,24),(149771,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 03057','RN',149771,39.45,0.4,684,71209,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03057',0.135786,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149772,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 03057','RN',149772,39.81,0.35,807,71209,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03057',0.135786,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149773,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149773,36.45,0.52,195,71210,70,NULL,NULL,'2MASX J21140138-1234446',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.80',0.24,NULL,NULL,NULL,NULL,NULL,1,318.505791667,-12.57908,0.137,NULL,50958788376,796231068,12441110,16.8),(149774,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149774,36.92,0.33,242,71211,70,NULL,NULL,'2MASX J21140394+0020497',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,318.516291667,0.34706,0.369,NULL,52083734507,813808351,12715755,17.6),(149775,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149775,37.42,0.46,305,71212,70,NULL,NULL,'2MASX J21141097+1116543',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000146,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,318.545583,11.28178,0.281,NULL,55052973703,860202714,13440667,17.4),(149776,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 19025','R',149776,41.81,0.33,1630,71213,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007mx','SDSS J211411.07-001743.7',0.406,'2014arXiv1401.3317S',2014,1,0.04,NULL,'G',NULL,NULL,'23.3g',0.02,NULL,NULL,NULL,NULL,NULL,1,318.546125,-0.2955,0.217,NULL,49670870078,776107344,12126677,23.3),(149777,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 19025','R',149777,41.91,0.31,1720,71213,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007mx','SDSS J211411.07-001743.7',0.406,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149778,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149778,36.14,0.64,169,71214,70,NULL,NULL,'2MASX J21141246-4240476',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'15.0r',0.29,NULL,NULL,NULL,NULL,NULL,1,318.5519583,-42.67994,0.069,NULL,51360734825,802511481,12539241,15),(149779,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149779,32.05,0.49,25.8,71215,75,NULL,'IR','IC 1368',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000037,NULL,'14.30',0.4,'Sa? sp         Sy2',NULL,NULL,NULL,'Sy 2',1,318.5524583,2.178,0.261,NULL,52093055775,813953996,12718031,14.3),(149780,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149780,32.7,0.47,34.7,71215,NULL,NULL,'H','IC 1368',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149781,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149781,32.8,0.45,36.3,71215,NULL,NULL,'K','IC 1368',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149782,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149782,32.87,0.46,37.5,71215,NULL,NULL,'J','IC 1368',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149783,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149783,33.39,0.4,47.6,71215,NULL,NULL,'mean','IC 1368',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149784,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149784,37.62,0.46,334,71216,70,NULL,NULL,'2MASX J21141261+1106353',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000183,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,318.552583333,11.10978,0.269,NULL,55061021039,860328453,13442632,17.5),(149785,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149785,35.55,0.57,129,71217,70,NULL,NULL,'2MASX J21141455-6513361',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.00015,NULL,'14.2r',0.42,'S',NULL,NULL,NULL,NULL,1,318.5607917,-65.22672,0.009,NULL,49347772794,771058949,12047796,14.2),(149786,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149786,37.43,0.56,307,71218,70,NULL,NULL,'2MASX J21141628-5147217',NULL,'2014MNRAS.445.2677S',2014,1,0.95,NULL,'G',0.00009,NULL,'14.6r',0.43,'S0',NULL,NULL,NULL,NULL,1,318.567958333,-51.78933,0,NULL,50602381663,790662213,12354097,14.6),(149787,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149787,37.1,0.64,264,71219,70,NULL,NULL,'2MASX J21142031-7907018',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,318.584625,-79.11725,0.577,NULL,48586182232,759159097,11861860,17.2),(149788,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149788,34.24,NULL,70.5,71220,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11706',NULL,'2010Ap&SS.325..163P',2010,1,1.77,NULL,'G',0.000023,NULL,'15.41',0.22,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,318.593167,15.24411,0.393,NULL,55277340844,863708450,13495444,15.41),(149789,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149789,34.25,NULL,70.8,71220,NULL,NULL,'Dipole','UGC 11706',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149790,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149790,34.25,NULL,70.8,71220,NULL,NULL,'Dipole + Quadrupole','UGC 11706',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149791,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149791,34.31,0.49,72.9,71220,75,NULL,'IR','UGC 11706',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149792,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149792,34.58,0.43,82.4,71220,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11706',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149793,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149793,34.62,0.56,83.8,71220,NULL,NULL,'Malmquist cor.','UGC 11706',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149794,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149794,34.63,0.43,84.3,71220,75,NULL,'3.6 micron, color corrected','UGC 11706',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149795,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149795,34.69,0.2,86.7,71220,74.4,NULL,NULL,'UGC 11706',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149796,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149796,34.73,0.53,88.3,71220,NULL,NULL,NULL,'UGC 11706',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149797,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02388','RN',149797,39.87,0.19,890,71221,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02388',0.060036,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149798,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02388','RN',149798,41.08,0.26,1550,71221,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02388',0.060036,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149799,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149799,38,0.46,398,71222,70,NULL,NULL,'2MASX J21142346+0108026',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,318.597791667,1.13403,0.253,NULL,52091569107,813930767,12717668,18),(149800,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149800,34.94,0.6,97.2,71223,70,NULL,NULL,'2MASX J21142354-0505564',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.27',NULL,NULL,NULL,NULL,NULL,NULL,1,318.598125,-5.09908,0.297,NULL,50743109623,792861087,12388454,16.27),(149801,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149801,36.92,0.33,242,71224,70,NULL,NULL,'2MASX J21142585+0000405',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000179,NULL,'17.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,318.60775,0.01108,0.269,NULL,52083177495,813799648,12715619,17),(149802,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20408',NULL,149802,40.25,0.17,1120,71225,70,NULL,'SN photometric redshift distance, z photo =0.308 +/- 0.030','SDSS-II SN 20408',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,318.616333,-0.76411,0.193,NULL,49670939661,776108432,12126694,NULL),(149803,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01725','RN',149803,37.41,0.61,267,71226,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 01725',0.136477,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149804,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01725','RN',149804,39.72,0.45,773,71226,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 01725',0.136477,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149805,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149805,34.81,0.66,91.8,71227,70,NULL,NULL,'2MASX J21143002-2326260',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.000103,NULL,'14.7r',0.38,'E',NULL,NULL,NULL,NULL,1,318.625041667,-23.44056,0.189,NULL,50917810877,795590794,12431106,14.7),(149806,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149806,30.99,0.8,15.8,71228,75,NULL,'A82, H','UGC 11707',NULL,'1997ApJS..109..333W',1997,1,3.6,NULL,'G',0.000003,NULL,'14.5',1.9,'SAdm',NULL,NULL,NULL,NULL,1,318.6322917,26.73458,0.637,NULL,55601059999,868766562,13574477,14.5),(149807,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149807,30.98,0.4,15.7,71228,75,NULL,'B','UGC 11707',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149808,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149808,31.84,0.4,23.3,71228,NULL,NULL,'Virgo cluster at 15.6 Mpc','UGC 11707',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149809,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149809,31.84,0.47,23.3,71228,75,NULL,'A82, H, inv','UGC 11707',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149810,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149810,31.92,0.47,24.2,71228,75,NULL,'A82, H, raw','UGC 11707',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149811,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149811,32.26,0.47,28.3,71228,75,NULL,'A82, H, cor','UGC 11707',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149812,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149812,37.91,0.46,382,71229,70,NULL,NULL,'2MASX J21143416+0930456',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000137,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,318.6425,9.51275,0.337,NULL,55059101934,860298467,13442163,18),(149813,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13333',NULL,149813,39.57,0.31,820,71230,70,NULL,'SN photometric redshift distance, z photo =0.214 +/- 0.038','SDSS-II SN 13333',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','20.4g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,318.649125,0.27844,0.369,NULL,52083714906,813808045,12715750,20.4),(149814,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13333','R',149814,40.43,0.19,956,71230,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13333',0.277326,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149815,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13333','R',149815,40.67,0.29,1060,71230,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13333',0.277326,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149816,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 11334','RN',149816,38.95,0.22,538,71231,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 11334',0.145992,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149817,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 11334','RN',149817,40.07,0.11,899,71231,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 11334',0.145992,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149818,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149818,36.7,0.67,219,71232,70,NULL,NULL,'2MASX J21144012-2827204',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'15.4r',0.18,NULL,NULL,NULL,NULL,NULL,1,318.6672083,-28.45572,0.381,NULL,51437887521,803716992,12558078,15.4),(149819,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 03248','RN',149819,42.37,0.23,1800,71233,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03248',0.652057,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149820,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149820,35.53,0.5,128,71234,NULL,NULL,NULL,'ESO 464- G 029',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000033,NULL,'14.4r',0.8,'Sb-c',NULL,NULL,NULL,NULL,1,318.675125,-31.58231,0.341,NULL,51498016343,804656505,12572757,14.4),(149821,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149821,35.58,0.2,131,71234,74.4,NULL,NULL,'ESO 464- G 029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149822,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149822,35.6,0.49,132,71234,NULL,NULL,'Malmquist cor.','ESO 464- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149823,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149823,35.11,0.46,105,71235,70,NULL,NULL,'SDSS J211454.22-072427.6',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000108,NULL,'15.4g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,318.725958333,-7.40769,0.269,NULL,50772530766,793320793,12395637,15.4),(149824,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149824,33.16,0.69,42.9,71236,100,NULL,'mid-IR','NGC 7046',NULL,'2013ApJ...771...88L',2013,1,1.9,NULL,'G',0.000007,NULL,'13.75',1.3,'SB(rs)cd      LINER:',NULL,NULL,NULL,NULL,1,318.7335,2.83483,0.261,NULL,52089347234,813896050,12717125,13.75),(149825,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149825,33.66,0.4,53.9,71236,NULL,NULL,'mean','NGC 7046',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149826,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149826,33.7,0.43,55,71236,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7046',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149827,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149827,33.74,0.47,56.1,71236,NULL,NULL,'H','NGC 7046',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149828,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149828,33.8,0.45,57.5,71236,NULL,NULL,'K','NGC 7046',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149829,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149829,33.83,0.46,58.3,71236,NULL,NULL,'J','NGC 7046',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149830,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149830,36.86,0.59,236,71237,70,NULL,NULL,'2MASX J21145600-6729239',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,318.733416667,-67.49003,0.065,NULL,49385287455,771645116,12056954,16.4),(149831,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 03161','R',149831,41.02,0.4,1160,71238,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03161',0.371513,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',NULL,'PHOT','22.9g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,318.743625,1.13672,0.253,NULL,52083533510,813805211,12715706,22.9),(149832,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 03161','R',149832,41.21,0.44,1270,71238,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03161',0.371513,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149833,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 03161',NULL,149833,40.75,0.3,1410,71238,70,NULL,'SN photometric redshift distance, z photo =0.409 +/- 0.080','SDSS-II SN 03161',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149834,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 07255','RN',149834,40.48,0.26,1020,71239,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 07255',0.22557,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149835,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 07255','RN',149835,41.4,0.44,1550,71239,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07255',0.22557,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149836,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15192','RN',149836,39.52,0.3,702,71240,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15192',0.139552,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149837,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13815','RN',149837,40.64,0.23,1190,71241,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13815',0.133715,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149838,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13815','RN',149838,41.23,0.25,1560,71241,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13815',0.133715,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149839,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149839,37.32,0.46,291,71242,70,NULL,NULL,'SDSS J211506.41+011012.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,318.77675,1.17011,0.253,NULL,52083315456,813801804,12715653,18.3),(149840,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149840,33.94,0.8,61.5,71243,75,NULL,'MAT, I','NGC 7038',NULL,'1997ApJS..109..333W',1997,1,3.2,NULL,'G',0.000023,NULL,'12.55',1.6,'SA(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,318.781291667,-47.2205,0.061,NULL,51397745926,803089780,12548277,12.55),(149841,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149841,33.95,0.8,61.7,71243,75,NULL,'HMCL, I','NGC 7038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149842,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149842,33.34,NULL,46.6,71243,NULL,NULL,'B','NGC 7038',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149843,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149843,33.37,0.3,47.2,71243,NULL,NULL,'B, Hubble-type-TF','NGC 7038',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149844,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149844,33.65,0.46,53.8,71243,NULL,NULL,'J','NGC 7038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149845,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149845,33.73,0.45,55.7,71243,NULL,NULL,'K','NGC 7038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149846,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149846,33.73,0.47,55.8,71243,NULL,NULL,'H','NGC 7038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149847,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149847,33.78,0.43,57.1,71243,75,NULL,'MAT, I, raw','NGC 7038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149848,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149848,33.8,0.4,57.7,71243,75,NULL,'HMCL, I, raw','NGC 7038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149849,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149849,33.99,0.32,62.8,71243,85,NULL,'I, raw','NGC 7038',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149850,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149850,34.06,NULL,64.9,71243,NULL,NULL,'I','NGC 7038',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149851,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149851,34.06,0.4,65,71243,75,NULL,'HMCL, I, cor','NGC 7038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149852,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149852,34.08,0.32,65.5,71243,85,NULL,'I, inv','NGC 7038',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149853,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149853,34.08,0.43,65.5,71243,75,NULL,'MAT, I, cor','NGC 7038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149854,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149854,34.09,0.4,65.7,71243,75,NULL,'HMCL, I, inv','NGC 7038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149855,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149855,34.12,0.4,66.6,71243,NULL,NULL,'mean','NGC 7038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149856,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149856,34.15,0.43,67.5,71243,75,NULL,'MAT, I, inv','NGC 7038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149857,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149857,35.99,0.52,157,71244,70,NULL,NULL,'2MASX J21150822-2321306',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.000083,NULL,'14.4r',0.3,'S',NULL,NULL,NULL,NULL,1,318.7842917,-23.35847,0.153,NULL,50917845612,795591337,12431114,14.4),(149858,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 09814',NULL,149858,40.7,0.35,1380,71245,70,NULL,'SN photometric redshift distance, z photo =0.396 +/- 0.094','SDSS-II SN 09814',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,318.787833,-0.41989,0.217,NULL,49670799823,776106247,12126660,NULL),(149859,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 09814',NULL,149859,42.38,0.23,2990,71245,70,NULL,'SALT 2','SDSS-II SN 09814',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149860,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 09814',NULL,149860,42.56,0.23,3250,71245,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 09814',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149861,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149861,37.47,0.63,312,71246,70,NULL,NULL,'2MASX J21151458-5148589',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'15.2r',0.28,NULL,NULL,NULL,NULL,NULL,1,318.81075,-51.81639,0,NULL,50602374522,790662101,12354095,15.2),(149862,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149862,36.8,0.71,230,71247,70,NULL,NULL,'ESO 235- G 079',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.7r',0.36,'S0',NULL,NULL,NULL,NULL,1,318.813625,-51.33297,0.009,NULL,50613742416,790839725,12356870,14.7),(149863,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149863,36.42,0.5,192,71248,70,NULL,NULL,'2MASX J21151919-7222123',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,318.830083333,-72.37,0.097,NULL,49293832283,770216129,12034627,16),(149864,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02053','R',149864,39.31,0.22,591,71249,70,NULL,'SDSS CAND. SNIc; MLCS2K2; SN 2005fk','SN 2005fk',0.233613,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ibc',NULL,NULL,NULL,NULL,1,318.832625,-0.38294,0.217,NULL,49670686979,776104484,12126632,NULL),(149865,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02053','R',149865,39.36,0.27,603,71249,70,NULL,'SDSS CAND. SNIc; SALT 2; SN 2005fk','SN 2005fk',0.233613,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149866,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01773','RN',149866,39.04,0.2,575,71250,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01773',0.120184,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149867,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01773','RN',149867,39.75,0.35,797,71250,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01773',0.120184,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149868,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149868,36.72,0.46,221,71251,70,NULL,NULL,'2MASX J21152339+1004596',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000174,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,318.8475,10.08331,0.253,NULL,55062103510,860345367,13442896,16.5),(149869,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15825','RN',149869,43.69,0.38,3450,71252,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15825',0.583445,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149870,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 19013',NULL,149870,40.83,0.38,1460,71253,70,NULL,'SN photometric redshift distance, z photo =0.428 +/- 0.113','SDSS-II SN 19013',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,318.8695417,-0.67031,0.149,NULL,49670837539,776106836,12126669,NULL),(149871,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2005kn',NULL,149871,39.21,0.14,580,71254,74.2,NULL,'SALT 2','SDSS J211531.80-002116.5',0.198,'2010ApJ...716..712A',2010,1,0.14,NULL,'G',0.000134,NULL,'19.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,318.8825,-0.35458,0.217,NULL,49670724170,776105065,12126641,19.1),(149872,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 07335','R',149872,39.83,0.21,772,71254,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2005kn','SDSS J211531.80-002116.5',0.197473,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149873,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2005kn',NULL,149873,39.91,0.15,799,71254,70,NULL,'SDSS-II SN 07335, SALT 2','SDSS J211531.80-002116.5',0.198,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149874,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2005kn',NULL,149874,39.56,0.1,817,71254,70,NULL,'SALT 2','SDSS J211531.80-002116.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149875,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2005kn',NULL,149875,39.57,0.1,820,71254,70,NULL,'SALT 2, Malmquist cor.','SDSS J211531.80-002116.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149876,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 07335','R',149876,40.09,0.12,871,71254,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2005kn','SDSS J211531.80-002116.5',0.197473,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149877,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2005kn',NULL,149877,40.99,0.04,1320,71254,70,NULL,'SDSS-II SN 07335','SDSS J211531.80-002116.5',0.198,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149878,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15208','RN',149878,43.7,0.24,3910,71255,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 15208',0.406588,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149879,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15208','RN',149879,44.27,0.37,5070,71255,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 15208',0.406588,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149880,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149880,37.47,0.6,312,71256,70,NULL,NULL,'2MASX J21153555-4652287',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'15.3r',0.3,NULL,NULL,NULL,NULL,NULL,1,318.8982917,-46.87458,0.073,NULL,51397717827,803089341,12548270,15.3),(149881,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149881,36.98,0.62,249,71257,70,NULL,NULL,'2MASX J21153582-4717297',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.000133,NULL,'14.8r',0.43,NULL,NULL,NULL,NULL,NULL,1,318.89925,-47.29156,0.061,NULL,51397763756,803090058,12548282,14.8),(149882,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15129','R',149882,39.86,0.19,783,71258,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006kq','SDSS J211536.58-001917.1',0.197395,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,318.902416667,-0.32142,0.217,NULL,49670723543,776105055,12126641,NULL),(149883,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15129','R',149883,40.08,0.11,865,71258,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006kq','SDSS J211536.58-001917.1',0.197395,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149884,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 14807','R',149884,40.19,0.17,909,71258,70,NULL,'SDSS CAND. zSNII; MLCS2K2; SN 2006kq','SDSS J211536.58-001917.1',0.2,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149885,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2006kq',NULL,149885,39.82,0.08,920,71258,70,NULL,'SALT 2','SDSS J211536.58-001917.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149886,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2006kq',NULL,149886,39.83,0.08,925,71258,70,NULL,'SALT 2, Malmquist cor.','SDSS J211536.58-001917.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149887,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 14807','R',149887,40.96,0.24,1290,71258,70,NULL,'SDSS CAND. zSNII; SALT 2; SN 2006kq','SDSS J211536.58-001917.1',0.2,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149888,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13729',NULL,149888,38.47,1.46,495,71259,70,NULL,'SN photometric redshift distance, z photo =0.123 +/- 0.136','SDSS-II SN 13729',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,318.918666667,0.87517,0.345,NULL,52083487389,813804490,12715695,NULL),(149889,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149889,38.19,0.46,434,71260,70,NULL,NULL,'SDSS J211543.67+004422.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,318.932,0.73969,0.345,NULL,52083563584,813805681,12715713,18.4),(149890,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149890,34.85,0.65,93.3,71261,70,NULL,NULL,'2MASX J21154428-2259234',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'14.4r',0.27,'S',NULL,NULL,NULL,NULL,1,318.934458333,-22.98989,0.145,NULL,50917991247,795593613,12431150,14.4),(149891,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149891,35.39,0.49,120,71262,75,NULL,'IR','UGC 11711',NULL,'2011yCatp016004901K',2011,1,1.05,NULL,'G',0.000007,NULL,'16.0',0.1,'Scd',NULL,NULL,NULL,NULL,1,318.937833333,17.35972,0.481,NULL,55268845657,863575713,13493370,16),(149892,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149892,35.81,NULL,145,71262,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11711',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149893,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149893,35.83,NULL,147,71262,NULL,NULL,'Dipole + Quadrupole','UGC 11711',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149894,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149894,35.84,NULL,147,71262,NULL,NULL,NULL,'UGC 11711',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149895,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149895,35.85,NULL,148,71262,NULL,NULL,'Dipole','UGC 11711',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149896,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149896,36.09,0.43,165,71262,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11711',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149897,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2007pc',NULL,149897,38.63,0.07,532,71263,70,NULL,'Hubble residual -0.07 for z0.13790','SDSS J211549.47+003904.3',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,318.956125,0.65119,0.345,NULL,52083565892,813805717,12715714,NULL),(149898,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 19775','R',149898,39.07,0.18,572,71263,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007pc','SDSS J211549.47+003904.3',0.1379,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149899,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 19775','R',149899,39.16,0.1,596,71263,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007pc','SDSS J211549.47+003904.3',0.1379,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149900,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2007pc',NULL,149900,38.91,0.07,605,71263,70,NULL,'SALT 2','SDSS J211549.47+003904.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149901,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2007pc',NULL,149901,38.92,0.07,608,71263,70,NULL,'SALT 2, Malmquist cor.','SDSS J211549.47+003904.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149902,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02054','RN',149902,39.6,0.31,661,71264,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02054',0.261299,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149903,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02054','RN',149903,40.61,0.29,1050,71264,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02054',0.261299,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149904,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01775','R',149904,41.41,0.29,1470,71265,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01775',0.303881,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,318.993375,-1.00942,0.169,NULL,49670363513,776099429,12126553,NULL),(149905,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01775','R',149905,41.66,0.25,1650,71265,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01775',0.303881,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149906,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16105','RN',149906,39.83,0.19,813,71266,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16105',0.139636,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149907,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16105','RN',149907,39.86,0.14,822,71266,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16105',0.139636,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149908,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149908,36.01,0.57,160,71267,70,NULL,NULL,'2MFGC 16105',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.00015,NULL,'14.2r',0.37,'S',NULL,NULL,NULL,NULL,1,319.0037917,-46.67489,0.081,NULL,51397659726,803088433,12548256,14.2),(149909,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16715','RN',149909,42.07,0.3,2140,71268,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16715',0.209974,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149910,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16715','RN',149910,42.33,0.51,2420,71268,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16715',0.209974,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149911,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149911,31.64,0.8,21.3,71269,75,NULL,'MAT, I','ESO 107- G 016',NULL,'1997ApJS..109..333W',1997,1,3.47,NULL,'G',0.00002,NULL,'15.11',0.34,'SB(s)dm: sp',NULL,NULL,NULL,NULL,1,319.025833,-64.81694,0.013,NULL,49349938138,771092783,12048324,15.11),(149912,'Tully est','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149912,31.78,0.8,22.7,71269,75,NULL,NULL,'ESO 107- G 016',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149913,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149913,31.95,NULL,24.5,71269,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 107- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149914,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149914,31.96,NULL,24.7,71269,NULL,NULL,'Dipole','ESO 107- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149915,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149915,31.96,NULL,24.7,71269,NULL,NULL,'Dipole + Quadrupole','ESO 107- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149916,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149916,32.06,NULL,25.8,71269,NULL,NULL,NULL,'ESO 107- G 016',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149917,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149917,32.4,0.32,30.2,71269,85,NULL,'I, inv','ESO 107- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149918,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149918,32.43,0.32,30.6,71269,85,NULL,'I, raw','ESO 107- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149919,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149919,32.49,0.4,31.5,71269,NULL,NULL,NULL,'ESO 107- G 016',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149920,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149920,32.49,0.4,31.5,71269,73,NULL,'opt','ESO 107- G 016',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149921,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149921,32.73,0.43,35.1,71269,75,NULL,'MAT, I, inv','ESO 107- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149922,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149922,32.77,0.43,35.8,71269,75,NULL,'MAT, I, raw','ESO 107- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149923,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149923,32.99,0.43,39.7,71269,75,NULL,'MAT, I, cor','ESO 107- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149924,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 11360','RN',149924,39.23,0.27,617,71270,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 11360',0.135957,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149925,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149925,35.36,0.52,118,71271,70,NULL,NULL,'ESO 599- G 004',NULL,'2014MNRAS.445.2677S',2014,1,1.22,NULL,'G',0.000097,NULL,'14.0r',0.47,'SAB(s)0^0^:',NULL,NULL,NULL,NULL,1,319.060375,-22.23461,0.121,NULL,50916490261,795570160,12430783,14),(149926,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149926,33.02,0.8,40.3,71272,75,NULL,'MAT, I','IC 5092',NULL,'1997ApJS..109..333W',1997,1,2.9,'ESO-LV gives v= 4141+/-29 km/sec.','G',0.000022,NULL,'12.77',2.4,'(R\')SB(rs)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,319.060417,-64.46467,0.033,NULL,49349524570,771086321,12048223,12.77),(149927,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149927,32.03,0.32,25.5,71272,85,NULL,'I, raw','IC 5092',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149928,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149928,32.07,0.32,25.9,71272,85,NULL,'I, inv','IC 5092',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149929,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149929,32.45,0.43,30.9,71272,75,NULL,'MAT, I, raw','IC 5092',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149930,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149930,32.63,0.43,33.6,71272,75,NULL,'MAT, I, inv','IC 5092',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149931,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149931,32.79,0.43,36.1,71272,75,NULL,'MAT, I, cor','IC 5092',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149932,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 06433',NULL,149932,39.7,0.3,871,71273,70,NULL,'SN photometric redshift distance, z photo =0.229 +/- 0.039','SDSS-II SN 06433',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,319.064583,-0.33317,0.269,NULL,49670735111,776105236,12126644,NULL),(149933,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149933,36.44,0.69,194,71274,70,NULL,NULL,'ESO 188- G 001',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00009,NULL,'14.6r',0.8,'SA(s)c:',NULL,NULL,NULL,NULL,1,319.071333,-55.51094,0.117,NULL,48657160952,760268139,11879189,14.6),(149934,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2006iz',NULL,149934,38.89,0.1,599,71275,70,NULL,'Hubble residual 0.21 for z0.13630','SDSS J211617.20+003334.2',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,319.071667,0.5595,0.269,NULL,52083151836,813799247,12715613,NULL),(149935,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 14815','R',149935,39.39,0.07,665,71275,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006iz','SDSS J211617.20+003334.2',0.1363,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149936,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 14815','R',149936,39.64,0.2,745,71275,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006iz','SDSS J211617.20+003334.2',0.1363,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149937,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20805','RN',149937,41.38,0.28,1410,71276,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20805',0.34033,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149938,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20805','RN',149938,41.47,0.23,1470,71276,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20805',0.34033,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149939,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149939,37.85,0.46,371,71277,70,NULL,NULL,'2MASX J21161902+1030256',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,319.079291667,10.507,0.225,NULL,55062214366,860347099,13442923,17.8),(149940,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149940,37.14,0.46,268,71278,70,NULL,NULL,'2MASX J21161973-0556034',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.0001,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,319.08225,-5.93422,0.473,NULL,50742748186,792855440,12388366,17.5),(149941,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 19653','RN',149941,41.63,0.33,1570,71279,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19653',0.346893,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149942,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 19653','RN',149942,41.76,0.3,1670,71279,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 19653',0.346893,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149943,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149943,35.48,0.45,125,71280,NULL,NULL,NULL,'CGCG 375-024',NULL,'2009ApJS..182..474S',2009,1,0.59,NULL,'G',0.000146,NULL,'16.1g',0.35,'Sb',NULL,NULL,NULL,NULL,1,319.091541667,1.08489,0.253,NULL,52083928046,813811375,12715802,16.1),(149944,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149944,35.53,0.44,127,71280,NULL,NULL,'Malmquist cor.','CGCG 375-024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149945,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149945,35.58,0.2,131,71280,74.4,NULL,NULL,'CGCG 375-024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149946,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149946,35.07,0.57,103,71281,NULL,NULL,'Malmquist cor.','ESO 342- G 025',NULL,'2009ApJS..182..474S',2009,1,1.25,NULL,'G',0.000033,NULL,'13.8r',0.46,'Sb-c',NULL,NULL,NULL,NULL,1,319.092,-38.98156,0.125,NULL,51482450341,804413286,12568957,13.8),(149947,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149947,35.13,0.56,106,71281,NULL,NULL,NULL,'ESO 342- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149948,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149948,35.17,0.2,108,71281,74.4,NULL,NULL,'ESO 342- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149949,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149949,35.53,0.47,128,71281,NULL,NULL,'H','ESO 342- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149950,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149950,35.53,0.4,128,71281,NULL,NULL,'mean','ESO 342- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149951,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149951,35.69,0.46,138,71281,NULL,NULL,'J','ESO 342- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149952,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149952,34.25,0.46,70.8,71282,70,NULL,NULL,'CGCG 426-029',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000123,NULL,'15.1g',0.46,'S0','Isolated galaxy',NULL,NULL,NULL,1,319.10325,10.27339,0.241,NULL,55062608395,860353256,13443019,15.1),(149953,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149953,36.5,0.55,199,71283,70,NULL,NULL,'2MASX J21162540-5139340',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'15.0r',0.31,NULL,NULL,NULL,NULL,NULL,1,319.105917,-51.65939,0.005,NULL,50613836015,790841187,12356893,15),(149954,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149954,33.85,0.69,58.9,71284,100,NULL,'mid-IR','NGC 7047',NULL,'2013ApJ...771...88L',2013,1,1.38,NULL,'G',0.000033,NULL,'14.0g',0.69,'SAB(r)b:       HII',NULL,NULL,NULL,NULL,1,319.1152083,-0.8265,0.149,NULL,49672947695,776139807,12127184,14),(149955,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149955,34.48,0.43,78.6,71284,NULL,NULL,'Malmquist cor.','NGC 7047',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149956,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149956,34.62,0.4,83.9,71284,NULL,NULL,NULL,'NGC 7047',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149957,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149957,34.66,0.2,85.5,71284,74.4,NULL,NULL,'NGC 7047',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149958,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149958,34.73,0.43,88.5,71284,75,NULL,'3.6 micron, color corrected','NGC 7047',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149959,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149959,34.89,0.43,94.9,71284,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7047',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149960,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149960,37,0.46,251,71285,70,NULL,NULL,'2MASX J21162884-0105563',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000157,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,319.1200417,-1.09883,0.169,NULL,49672246784,776128856,12127013,17.1),(149961,'SBF','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149961,32.03,0.14,25.5,71286,74.4,NULL,NULL,'NGC 7041',NULL,'2013AJ....146...86T',2013,1,3.6,NULL,'G',0.00008,NULL,'12.09',1.5,'SA(rs)0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,319.134916667,-48.36356,0.061,NULL,51342803022,802231297,12534864,12.09),(149962,'SBF','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149962,32.05,0.31,25.7,71286,NULL,NULL,'I','NGC 7041',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149963,'Faber-Jackson','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149963,31.16,0.37,17.1,71286,95,NULL,'Weighted Mean','NGC 7041',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149964,'Faber-Jackson','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149964,31.33,0.63,18.5,71286,95,NULL,'Michard 1979b, c','NGC 7041',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149965,'Faber-Jackson','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149965,31.58,0.46,20.7,71286,95,NULL,'Michard 1979a','NGC 7041',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149966,'Faber-Jackson','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149966,32.19,0.81,27.4,71286,55,NULL,'Visvanathan & Sandage 1979','NGC 7041',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149967,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149967,32.5,0.55,31.6,71286,70,NULL,NULL,'NGC 7041',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149968,'Tertiary','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149968,31.55,0.71,20.4,71286,95,NULL,NULL,'NGC 7041',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149969,'Tully est','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149969,31.92,0.8,24.2,71286,75,NULL,'B','NGC 7041',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149970,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149970,31.95,0.4,24.5,71286,NULL,NULL,'mean','NGC 7041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149971,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149971,32.14,0.45,26.8,71286,NULL,NULL,'K','NGC 7041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149972,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149972,36.95,0.33,246,71287,70,NULL,NULL,'2MASX J21163260-0045133',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'14.6I',0.3,'BrClG',NULL,NULL,NULL,NULL,1,319.1357083,-0.75372,0.149,NULL,49672684782,776135699,12127120,14.6),(149973,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149973,35.33,0.49,116,71288,75,NULL,'IR','ESO 599- G 005',NULL,'2011yCatp016004901K',2011,1,1.99,NULL,'G',0.00005,NULL,'14.6r',0.2,'Sbc',NULL,NULL,NULL,NULL,1,319.139041667,-22.2155,0.121,NULL,50916475606,795569931,12430780,14.6),(149974,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 19003','R',149974,36.98,0.09,235,71289,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007mp','SN 2007mp',0.05991,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,319.1484583,-0.76989,0.149,NULL,49672958988,776139984,12127187,NULL),(149975,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 19003','R',149975,37.29,0.2,270,71289,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007mp','SN 2007mp',0.05991,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149976,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149976,36.95,0.33,246,71290,70,NULL,NULL,'2MASX J21164014-0046253',NULL,'2015arXiv151105856S',2015,1,0.44,'SDSS DR3 gives z= 0.059 and 0.393.','G',0.000183,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,319.167083,-0.77372,0.149,NULL,49672955046,776139922,12127186,16.3),(149977,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149977,37.36,0.46,296,71291,70,NULL,NULL,'2MASX J21164078+1051143',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000139,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,319.169875,10.85392,0.229,NULL,55061107773,860329808,13442653,18),(149978,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149978,37.37,0.46,297,71292,70,NULL,NULL,'2MASX J21164106+1024053',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000159,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,319.171125,10.40153,0.225,NULL,55062712114,860354876,13443044,17.1),(149979,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149979,37.59,0.85,329,71293,70,NULL,NULL,'2MASX J21164155-5257329',NULL,'2014MNRAS.445.2677S',2014,1,0.69,NULL,'G',0.00015,NULL,'15.1r',0.2,NULL,NULL,NULL,NULL,NULL,1,319.173,-52.95914,0.061,NULL,50603461390,790679084,12354360,15.1),(149980,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149980,37.35,0.46,295,71294,70,NULL,NULL,'2MASX J21164614-0726564',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000086,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,319.1922083,-7.44917,0.329,NULL,50772403103,793318798,12395606,17.2),(149981,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149981,34.73,0.47,88.3,71295,70,NULL,NULL,'ESO 342- G 026',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000077,NULL,'13.0r',1,'SB(s)0^0^ pec','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,319.192458333,-42.26169,0.069,NULL,51360617411,802509647,12539213,13),(149982,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 17614','RN',149982,41.76,0.12,1670,71296,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 17614',0.3442,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149983,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 17614','RN',149983,41.91,0.2,1790,71296,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17614',0.3442,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149984,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149984,35.3,0.54,115,71297,70,NULL,NULL,'ESO 464- G 030',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000103,NULL,'14.0r',0.2,'Sb             HII',NULL,NULL,NULL,NULL,1,319.237833333,-28.32636,0.345,NULL,51437237677,803706838,12557919,14),(149985,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149985,34.21,0.43,69.4,71298,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11738',NULL,'2014MNRAS.444..527S',2014,1,1,NULL,'G',0.000143,NULL,'15.22',0.4,'Sbc','Isolated galaxy',NULL,NULL,NULL,1,319.241916667,83.82125,0.305,NULL,52665238995,822894359,12857724,15.22),(149986,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149986,34.26,0.43,71.2,71298,75,NULL,'3.6 micron, color corrected','UGC 11738',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149987,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149987,34.33,0.2,73.5,71298,74.4,NULL,NULL,'UGC 11738',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149988,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149988,34.86,0.49,93.7,71299,75,NULL,'IR','MCG -01-54-007',NULL,'2011yCatp016004901K',2011,1,1.04,NULL,'G',0.000083,NULL,'15.6g',0.3,'Sbc            AGN',NULL,NULL,NULL,NULL,1,319.260167,-6.75203,0.329,NULL,50772256306,793316504,12395570,15.6),(149989,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149989,35.53,0.47,128,71300,NULL,NULL,'H','ESO 402- G 021',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000117,NULL,'15.13',0.3,'SB(s)a? pec',NULL,NULL,NULL,NULL,1,319.2645417,-33.98881,0.405,NULL,51531844260,805185066,12581016,15.13),(149990,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149990,35.54,0.4,128,71300,NULL,NULL,'mean','ESO 402- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149991,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149991,35.3,0.47,115,71301,70,NULL,NULL,'ESO 530- G 029',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'14.0r',0.5,'S0',NULL,NULL,NULL,NULL,1,319.2765417,-23.1215,0.113,NULL,50917967575,795593243,12431144,14),(149992,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149992,37.48,0.46,313,71302,70,NULL,NULL,'2MASX J21170937-0037122',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000155,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,319.289041667,-0.62,0.185,NULL,49672704654,776136010,12127125,17.1),(149993,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149993,36.15,0.73,170,71303,70,NULL,NULL,'2MASX J21171038-7557100',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'16.9b',0.17,NULL,NULL,NULL,NULL,NULL,1,319.2934583,-75.95272,0.321,NULL,48534299007,758348421,11849194,16.9),(149994,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149994,37.31,0.73,290,71304,70,NULL,NULL,'ESO 188-IG 002 NED02',NULL,'2014MNRAS.445.2677S',2014,1,NULL,'The APM image includes a superposed star.','G',0.00015,NULL,'16.39',NULL,NULL,NULL,NULL,NULL,NULL,1,319.2997917,-55.93778,0.185,NULL,48655479667,760241869,11878779,16.39),(149995,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149995,35.89,0.56,151,71305,70,NULL,NULL,'2MASX J21171271-1937371',NULL,'2014MNRAS.445.2677S',2014,1,0.9,'The APM image includes 2-3 superposed stars and a companion galaxy.','G',0.00015,NULL,'15.77',0.43,'E',NULL,NULL,NULL,NULL,1,319.303375,-19.62706,0.125,NULL,50911433350,795491146,12429549,15.77),(149996,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149996,35.23,0.46,111,71306,70,NULL,NULL,'2MASX J21171829-0613471',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000103,NULL,'16.2g',0.38,'S0/a',NULL,NULL,NULL,NULL,1,319.326208333,-6.22964,0.317,NULL,50772064942,793313514,12395523,16.2),(149997,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149997,34.56,0.48,81.6,71307,NULL,NULL,'Malmquist cor.','UGC 11713',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.00011,NULL,'14.95',0.5,'SBcd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,319.367666667,15.56581,0.413,NULL,55269657468,863588397,13493568,14.95),(149998,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149998,34.6,0.2,83.2,71307,74.4,NULL,NULL,'UGC 11713',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149999,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149999,34.67,0.45,85.8,71307,NULL,NULL,NULL,'UGC 11713',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150000,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150000,34.91,0.51,96.1,71308,70,NULL,NULL,'ESO 530- G 030',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000083,NULL,'13.5r',1.1,'SB(rs)a  poss. LINER',NULL,NULL,NULL,NULL,1,319.368125,-22.81625,0.121,NULL,50918694437,795604600,12431321,13.5),(150001,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150001,34.89,0.68,95.2,71309,70,NULL,NULL,'2MASX J21172918-8048085',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,319.3712083,-80.80236,0.537,NULL,48573761896,758965029,11858828,16.1),(150002,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2007re',NULL,150002,39.19,0.15,688,71310,70,NULL,'Hubble residual -0.35 for z0.21090','SDSS J211734.92-003126.3',NULL,'2011ApJ...740...92G',2011,1,0.06,NULL,'G',0.0005,NULL,'20.9g',0.05,NULL,NULL,NULL,NULL,NULL,1,319.3955417,-0.52397,0.205,NULL,49672873602,776138650,12127166,20.9),(150003,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20376','R',150003,39.64,0.2,700,71310,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007re','SDSS J211734.92-003126.3',0.2109,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150004,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20376','R',150004,39.79,0.13,750,71310,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007re','SDSS J211734.92-003126.3',0.2109,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150005,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2007re',NULL,150005,39.46,0.1,780,71310,70,NULL,'SALT 2','SDSS J211734.92-003126.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150006,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2007re',NULL,150006,39.48,0.1,787,71310,70,NULL,'SALT 2, Malmquist cor.','SDSS J211734.92-003126.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150007,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 17564','R',150007,40.49,0.09,999,71311,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2007iz','SDSS J211735.50+001856.3',0.255,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,':',NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,319.397917,0.31564,0.269,NULL,52084112519,813814258,12715847,NULL),(150008,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150008,34.32,0.49,73.2,71312,75,NULL,'IR','CGCG 471-003',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.000033,NULL,'15.7',0.2,'Sa',NULL,NULL,NULL,NULL,1,319.400833,24.36556,0.421,NULL,55127740975,861370952,13458921,15.7),(150009,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150009,35.76,0.44,142,71313,NULL,NULL,'Malmquist cor.','ESO 287- G 003',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.6r',0.5,'SB(rs)c',NULL,NULL,NULL,NULL,1,319.406583333,-46.72469,0.129,NULL,51397852248,803091441,12548303,14.6),(150010,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150010,35.95,0.4,155,71313,NULL,NULL,NULL,'ESO 287- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150011,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150011,35.99,0.2,158,71313,74.4,NULL,NULL,'ESO 287- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150012,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16466','RN',150012,40.92,0.24,1290,71314,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16466',0.187801,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150013,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16466','RN',150013,40.99,0.17,1330,71314,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16466',0.187801,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150014,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150014,35.62,0.67,133,71315,70,NULL,NULL,'2MASX J21174247-8450426',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,319.426167,-84.84525,0.517,NULL,48385221344,756019083,11812798,16.6),(150015,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20823',NULL,150015,40.32,0.28,1160,71316,70,NULL,'SN photometric redshift distance, z photo =0.320 +/- 0.054','SDSS-II SN 20823',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.2g',0.02,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,319.4275,0.54858,0.269,NULL,52084331128,813817673,12715901,22.2),(150016,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20823','R',150016,41.41,0.35,1320,71316,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 20823',0.444252,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150017,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15649','RN',150017,40.03,0.11,893,71317,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15649',0.134154,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150018,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15649','RN',150018,40.25,0.21,991,71317,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15649',0.134154,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150019,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01832','RN',150019,41.66,0.2,1480,71318,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01832',0.450293,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150020,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150020,34.32,0.49,73,71319,75,NULL,'IR','UGC 11715',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.58',0.2,'Scd?','Isolated galaxy',NULL,NULL,NULL,1,319.449833,13.59347,0.289,NULL,55278618243,863728410,13495756,15.58),(150021,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150021,36.62,0.61,211,71320,70,NULL,NULL,'2MASX J21175507-2246243',NULL,'2014MNRAS.445.2677S',2014,1,0.92,NULL,'G',0.000103,NULL,'14.6r',0.35,'S',NULL,NULL,NULL,NULL,1,319.4795417,-22.77339,0.121,NULL,50918687786,795604496,12431320,14.6),(150022,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150022,34.96,0.8,98.3,71321,75,NULL,'MAT, I','ESO 530- G 034',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'14.21',0.5,'Sc             LINER',NULL,NULL,NULL,NULL,1,319.4957917,-22.83558,0.121,NULL,50918700397,795604693,12431323,14.21),(150023,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150023,34.36,0.43,74.4,71321,75,NULL,'MAT, I, raw','ESO 530- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150024,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150024,34.41,0.32,76.2,71321,85,NULL,'I, raw','ESO 530- G 034',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150025,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150025,34.47,0.32,78.3,71321,85,NULL,'I, inv','ESO 530- G 034',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150026,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150026,34.62,0.43,83.8,71321,75,NULL,'MAT, I, inv','ESO 530- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150027,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150027,34.88,0.52,94.6,71321,NULL,NULL,NULL,'ESO 530- G 034',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150028,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150028,34.89,0.43,94.9,71321,75,NULL,'MAT, I, cor','ESO 530- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150029,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150029,34.92,0.2,96.4,71321,74.4,NULL,NULL,'ESO 530- G 034',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150030,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150030,35.09,0.47,104,71321,NULL,NULL,'H','ESO 530- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150031,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150031,35.13,0.46,106,71321,NULL,NULL,'Malmquist cor.','ESO 530- G 034',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150032,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150032,35.17,0.4,108,71321,NULL,NULL,'mean','ESO 530- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150033,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150033,35.24,0.46,112,71321,NULL,NULL,'J','ESO 530- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150034,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150034,35.27,0.45,113,71321,NULL,NULL,'K','ESO 530- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150035,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150035,36.04,0.46,162,71322,70,NULL,NULL,'2MASX J21180087+0034150',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00016,NULL,'16.4g',0.35,'E0',NULL,NULL,NULL,NULL,1,319.503625,0.57086,0.265,NULL,52084189474,813815460,12715866,16.4),(150036,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 10037','R',150036,40.48,0.27,994,71323,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J211801.05+010655.1',0.2537,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',0.01,NULL,'20.7g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,319.504417,1.11533,0.261,NULL,52084855663,813825869,12716029,20.7),(150037,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 10037','R',150037,40.58,0.29,1040,71323,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J211801.05+010655.1',0.2537,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150038,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 10037',NULL,150038,40.31,0.2,1150,71323,70,NULL,'SALT 2','SDSS J211801.05+010655.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150039,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 10037',NULL,150039,40.33,0.2,1160,71323,70,NULL,'SALT 2, Malmquist cor.','SDSS J211801.05+010655.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150040,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150040,36.52,0.76,202,71324,70,NULL,NULL,'2MASX J21180410-5143385',NULL,'2014MNRAS.445.2677S',2014,1,0.98,NULL,'G',0.00015,NULL,'14.6r',0.33,'S',NULL,NULL,NULL,NULL,1,319.517125,-51.72733,0,NULL,50614671055,790854235,12357097,14.6),(150041,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150041,35.42,0.52,121,71325,70,NULL,NULL,'2MASX J21180548-2239503',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000077,NULL,'14.1r',0.53,'E',NULL,NULL,NULL,NULL,1,319.523,-22.66406,0.101,NULL,50918414379,795600224,12431253,14.1),(150042,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150042,33.59,0.8,52.1,71326,75,NULL,'MAT, I','ESO 287- G 004',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'13.4r',0.5,'SB(rs)b:',NULL,NULL,NULL,NULL,1,319.526333333,-46.30072,0.153,NULL,51397497448,803085897,12548217,13.4),(150043,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150043,33.12,0.32,42.1,71326,85,NULL,'I, raw','ESO 287- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150044,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150044,33.14,0.32,42.4,71326,85,NULL,'I, inv','ESO 287- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150045,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150045,33.31,0.43,45.9,71326,75,NULL,'MAT, I, raw','ESO 287- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150046,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150046,33.42,0.43,48.4,71326,75,NULL,'MAT, I, inv','ESO 287- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150047,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150047,33.7,0.43,54.8,71326,75,NULL,'MAT, I, cor','ESO 287- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150048,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 21323','RN',150048,42.64,0.19,2530,71327,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 21323',0.33481,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150049,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 21323','RN',150049,43.04,0.23,3030,71327,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 21323',0.33481,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150050,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20643','RN',150050,42.03,0.3,2000,71328,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 20643',0.276022,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150051,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20643','RN',150051,42.42,0.3,2390,71328,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20643',0.276022,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150052,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150052,37.91,0.46,381,71329,70,NULL,NULL,'2MASX J21181082+0932069',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000164,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,319.545125,9.53517,0.273,NULL,55062328639,860348884,13442951,17.6),(150053,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 12857','RN',150053,40.45,0.16,1100,71330,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 12857',0.120869,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150054,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 12857','RN',150054,40.62,0.26,1190,71330,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 12857',0.120869,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150055,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20093','RN',150055,42.83,0.19,2240,71331,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 20093',0.645019,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150056,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150056,35.42,0.58,121,71332,70,NULL,NULL,'2MASX J21181593-2356220',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.000103,NULL,'14.6r',0.35,'S0',NULL,NULL,NULL,NULL,1,319.566417,-23.9395,0.121,NULL,50917564045,795586938,12431045,14.6),(150057,'D-Sigma','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150057,32.52,0.4,32,71333,75,NULL,'Edat, raw','ESO 235- G 085',NULL,'1997ApJS..109..333W',1997,1,0.88,NULL,'G',0.000103,NULL,'13.2r',0.65,'Sa?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,319.567458333,-48.53753,0.053,NULL,51343195354,802237427,12534959,13.2),(150058,'D-Sigma','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150058,32.7,0.4,34.7,71333,75,NULL,'Edat, cor','ESO 235- G 085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150059,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 17374','RN',150059,40.48,0.24,997,71334,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17374',0.252054,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150060,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 17374','RN',150060,40.51,0.18,1010,71334,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17374',0.252054,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150061,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02488','RN',150061,40.45,0.24,1050,71335,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 02488',0.170996,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150062,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02488','RN',150062,41.37,0.27,1610,71335,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 02488',0.170996,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150063,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150063,32.95,0.8,39,71336,75,NULL,'MAT, I','IC 5096',NULL,'1997ApJS..109..333W',1997,1,4.14,NULL,'G',0.000033,NULL,'13.30',0.56,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,319.58975,-63.76067,0.033,NULL,49169364499,768271320,12004239,13.3),(150064,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150064,32.95,0.47,38.8,71336,NULL,NULL,'H','IC 5096',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150065,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150065,33.01,0.46,40,71336,NULL,NULL,'J','IC 5096',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150066,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150066,33.05,0.45,40.8,71336,NULL,NULL,'K','IC 5096',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150067,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150067,33.14,0.4,42.4,71336,NULL,NULL,'mean','IC 5096',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150068,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150068,33.29,0.49,45.4,71336,75,NULL,'IR','IC 5096',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150069,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150069,33.48,0.43,49.7,71336,75,NULL,'MAT, I, raw','IC 5096',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150070,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150070,33.55,0.43,51.2,71336,75,NULL,'MAT, I, cor','IC 5096',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150071,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150071,33.75,0.32,56.3,71336,85,NULL,'I, raw','IC 5096',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150072,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150072,33.82,0.43,58.1,71336,75,NULL,'MAT, I, inv','IC 5096',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150073,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150073,33.84,NULL,58.5,71336,NULL,NULL,NULL,'IC 5096',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150074,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150074,33.84,0.32,58.6,71336,85,NULL,'I, inv','IC 5096',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150075,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150075,33.97,NULL,62.3,71336,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 5096',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150076,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150076,33.99,NULL,62.9,71336,NULL,NULL,'Dipole + Quadrupole','IC 5096',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150077,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150077,34,NULL,63.1,71336,NULL,NULL,'Dipole','IC 5096',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150078,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150078,36.06,0.56,163,71337,70,NULL,NULL,'6dF J2118215-272053',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,319.58975,-27.34806,0.257,NULL,51438066071,803719782,12558121,13.6),(150079,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150079,37.4,0.46,302,71338,70,NULL,NULL,'2MASX J21182556+1146113',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000176,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,319.6065417,11.76986,0.233,NULL,55060880004,860326250,13442597,17.5),(150080,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150080,35.6,0.75,132,71339,70,NULL,NULL,'2MASX J21182700-6626498',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.6r',0.57,'S0',NULL,NULL,NULL,NULL,1,319.6125,-66.44711,0,NULL,49388991423,771702990,12057859,14.6),(150081,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150081,33.33,0.45,46.4,71340,NULL,NULL,'K','NGC 7052',NULL,'2007A&A...465...71T',2007,1,2.5,'1995A&A...300..675H has V = 4159 +- 33 km/sec.','G',0.000027,NULL,'13.4',1.4,'E',NULL,NULL,'radio jet','Flat-Spectrum Radio Source',1,319.637708333,26.44703,0.593,NULL,55615395048,868990547,13577977,13.4),(150082,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150082,33.77,0.4,56.7,71340,NULL,NULL,'mean','NGC 7052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150083,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 06884','RN',150083,44.37,0.22,5160,71341,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 06884',0.451583,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150084,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150084,37.81,0.46,365,71342,70,NULL,NULL,'SDSS J211836.17-010831.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,319.650708333,-1.14219,0.157,NULL,49673093860,776142091,12127220,18),(150085,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 14648','RN',150085,38.29,0.38,429,71343,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 14648',0.061332,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150086,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 14648','RN',150086,40.22,0.5,1040,71343,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 14648',0.061332,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150087,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2006ky',NULL,150087,39.45,0.08,775,71344,70,NULL,'Hubble residual 0.17 for z0.18370','SDSS-II SN 15453 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,319.6684583,-1.02425,0.177,NULL,49672927615,776139493,12127179,NULL),(150088,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15453','R',150088,39.93,0.2,824,71344,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ky','SDSS-II SN 15453 HOST',0.175,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150089,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15453','R',150089,40.06,0.09,874,71344,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ky','SDSS-II SN 15453 HOST',0.175,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150090,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150090,35.55,0.6,129,71345,70,NULL,NULL,'ESO 287- G 006',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000087,NULL,'14.2r',0.6,'SB(s)0/a:',NULL,NULL,NULL,NULL,1,319.6745,-45.00717,0.137,NULL,51366057354,802594646,12540541,14.2),(150091,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150091,36.75,0.46,223,71346,70,NULL,NULL,'2MASX J21184432-0703382',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000071,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,319.6845417,-7.06081,0.337,NULL,50772958620,793327478,12395741,18),(150092,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 12858','RN',150092,40.67,0.63,1090,71347,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 12858',0.251443,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150093,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150093,32.92,0.8,38.4,71348,75,NULL,'MAT, I','ESO 145- G 004',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000021,NULL,'13.4r',0.5,'SAB(s)bc:',NULL,NULL,NULL,NULL,1,319.7125,-57.64028,0.137,NULL,49133731381,767714552,11995539,13.4),(150094,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150094,33.18,0.32,43.2,71348,85,NULL,'I, raw','ESO 145- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150095,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150095,33.19,0.49,43.5,71348,75,NULL,'IR','ESO 145- G 004',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150096,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150096,33.2,0.32,43.7,71348,85,NULL,'I, inv','ESO 145- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150097,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150097,33.28,0.43,45.3,71348,75,NULL,'MAT, I, raw','ESO 145- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150098,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150098,33.41,0.43,48,71348,75,NULL,'MAT, I, inv','ESO 145- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150099,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150099,33.45,0.43,48.9,71348,75,NULL,'MAT, I, cor','ESO 145- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150100,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16410','R',150100,41.11,0.19,1290,71349,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16410 HOST',0.287998,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,'PHOT',NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,319.715,0.64811,0.249,NULL,52081343276,813770988,12715171,NULL),(150101,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16410','R',150101,41.12,0.28,1300,71349,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16410 HOST',0.287998,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150102,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16410',NULL,150102,41.07,0.16,1640,71349,70,NULL,'SALT 2','SDSS-II SN 16410 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150103,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16410',NULL,150103,41.1,0.16,1660,71349,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16410 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150104,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150104,36.36,0.6,187,71350,70,NULL,NULL,'2MASX J21185287-5526436',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.9r',0.5,NULL,NULL,NULL,NULL,NULL,1,319.720333,-55.44544,0.157,NULL,48656762909,760261920,11879092,14.9),(150105,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150105,35.18,0.49,109,71351,75,NULL,'IR','UGC 11719',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.00001,NULL,'15.51',0.18,'Sb',NULL,NULL,NULL,NULL,1,319.7224583,15.68083,0.381,NULL,55271019822,863609684,13493901,15.51),(150106,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150106,35.35,0.4,118,71351,NULL,NULL,'mean','UGC 11719',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150107,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150107,35.61,NULL,132,71351,NULL,NULL,'Dipole + Quadrupole','UGC 11719',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150108,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150108,35.61,NULL,133,71351,NULL,NULL,'Dipole','UGC 11719',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150109,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150109,35.61,NULL,133,71351,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11719',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150110,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150110,35.62,0.47,133,71351,NULL,NULL,'H','UGC 11719',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150111,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150111,35.82,NULL,146,71351,NULL,NULL,NULL,'UGC 11719',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150112,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150112,35.97,0.43,156,71351,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11719',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150113,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20434','RN',150113,41.11,0.24,1300,71352,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20434',0.280855,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150114,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20434','RN',150114,41.37,0.37,1470,71352,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20434',0.280855,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150115,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20434','N',150115,41.17,0.23,1710,71352,70,NULL,'SALT 2','SDSS-II SN 20434',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150116,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20434','N',150116,41.2,0.23,1740,71352,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20434',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150117,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150117,30.96,0.43,15.6,71353,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 471-006',NULL,'2014MNRAS.444..527S',2014,1,1,NULL,'G',0.000033,NULL,'15.05',0.3,'S?',NULL,NULL,NULL,NULL,1,319.745375,25.43106,0.401,NULL,55614434959,868975546,13577742,15.05),(150118,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 14791','RN',150118,42.09,0.22,2200,71354,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 14791',0.18672,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150119,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 14791','RN',150119,42.33,0.3,2470,71354,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 14791',0.18672,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150120,'SBF','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150120,32.38,0.22,29.9,71355,NULL,NULL,'I','NGC 7049',NULL,'2001ApJ...546..681T',2001,1,4.3,NULL,'G',0.00002,NULL,'11.72',3,'SA(s)0^0^','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,319.75125,-48.56217,0.029,NULL,51343172546,802237071,12534954,11.72),(150121,'SBF','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150121,32.38,0.14,29.9,71355,74.4,NULL,NULL,'NGC 7049',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150122,'Faber-Jackson','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150122,31.25,0.63,17.8,71355,95,NULL,'Michard 1979b, c','NGC 7049',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150123,'Faber-Jackson','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150123,31.33,0.46,18.5,71355,95,NULL,'Michard 1979a','NGC 7049',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150124,'Faber-Jackson','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150124,31.65,0.37,21.4,71355,95,NULL,'Weighted Mean','NGC 7049',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150125,'Faber-Jackson','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150125,32.02,NULL,25.4,71355,NULL,NULL,'LEDA [April 2006]','NGC 7049',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150126,'Faber-Jackson','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150126,34.59,0.81,82.8,71355,55,NULL,'Visvanathan & Sandage 1979','NGC 7049',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150127,'Tertiary','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150127,31.55,0.71,20.4,71355,95,NULL,NULL,'NGC 7049',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150128,'Tully est','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150128,32.2,0.8,27.6,71355,75,NULL,'B','NGC 7049',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150129,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150129,31.99,0.45,25,71355,NULL,NULL,'K','NGC 7049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150130,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150130,32.41,0.4,30.3,71355,NULL,NULL,'mean','NGC 7049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150131,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150131,38.38,0.46,475,71356,70,NULL,NULL,'2MASX J21190096-0727159',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00009,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,319.754083,-7.4545,0.341,NULL,50772746262,793324160,12395690,18.7),(150132,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 07337','RN',150132,42.42,0.55,2320,71357,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 07337',0.31105,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150133,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150133,36.06,0.59,163,71358,70,NULL,NULL,'2MASX J21190674-2141546',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'15.3r',0.24,NULL,NULL,NULL,NULL,NULL,1,319.778125,-21.69867,0.097,NULL,50913633823,795525528,12430086,15.3),(150134,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15483',NULL,150134,40.44,0.2,1220,71359,70,NULL,'SALT 2','SDSS-II SN 15483',NULL,'2013ApJ...763...88C',2013,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,319.7919583,0.69697,0.241,NULL,52081461163,813772830,12715200,NULL),(150135,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15483',NULL,150135,40.47,0.21,1240,71359,70,NULL,'SN photometric redshift distance, z photo =0.348 +/- 0.044','SDSS-II SN 15483',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150136,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15483',NULL,150136,40.48,0.2,1250,71359,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15483',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150137,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150137,35.99,0.5,158,71360,70,NULL,NULL,'2MASX J21191534-7114599',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'14.2r',0.55,'SAB0^-:',NULL,NULL,NULL,NULL,1,319.814167,-71.25006,0.137,NULL,49326083822,770720059,12042500,14.2),(150138,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150138,37.58,0.46,327,71361,70,NULL,NULL,'2MASX J21191557+1004144',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000189,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,319.8147917,10.07064,0.177,NULL,55062641080,860353766,13443027,16.7),(150139,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 10039','RN',150139,38.47,0.53,435,71362,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10039',0.134302,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150140,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150140,35.43,0.5,122,71363,70,NULL,NULL,'2MASX J21191866-0614409',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.000091,NULL,'15.7g',0.26,'Sa',NULL,NULL,NULL,NULL,1,319.827833,-6.24478,0.333,NULL,49685880682,776341885,12130341,15.7),(150141,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150141,38.05,0.33,407,71364,70,NULL,NULL,'2MASX J21192459-0557344',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000089,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,319.852333,-5.95944,0.245,NULL,49719408246,776865753,12138527,17.6),(150142,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150142,35.32,0.53,116,71365,70,NULL,NULL,'2MASX J21192590-0645304',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.000087,NULL,'16.0g',0.26,'S0/a',NULL,NULL,NULL,NULL,1,319.8580417,-6.75842,0.377,NULL,49685806972,776340733,12130323,16),(150143,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16712','RN',150143,40.83,1.44,1270,71366,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 16712',0.153624,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150144,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150144,33.78,0.49,56.9,71367,75,NULL,'IR','UGC 11721',NULL,'2011yCatp016004901K',2011,1,1.52,'The UZC position applies to a superposed star.','G',0.000013,NULL,'15.19',0.17,'Sdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,319.8615417,14.05742,0.313,NULL,55280033578,863750524,13496101,15.19),(150145,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150145,34.02,NULL,63.8,71367,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11721',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150146,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150146,34.05,NULL,64.5,71367,NULL,NULL,'Dipole + Quadrupole','UGC 11721',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150147,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150147,34.05,NULL,64.5,71367,NULL,NULL,'Dipole','UGC 11721',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150148,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150148,36.8,0.46,229,71368,70,NULL,NULL,'2MASX J21193055+0941256',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000177,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,319.877125,9.6905,0.225,NULL,55060395095,860318673,13442479,17.2),(150149,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150149,34.49,0.59,79.1,71369,70,NULL,NULL,'2MASX J21193434-5522028',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'16.20',0.25,NULL,NULL,NULL,NULL,NULL,1,319.8932083,-55.36742,0.145,NULL,48656802555,760262539,11879102,16.2),(150150,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16291','RN',150150,41.91,0.96,2200,71370,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 16291',0.094864,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150151,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150151,37.95,0.46,390,71371,70,NULL,NULL,'2MASX J21193464-0022003',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,319.894417,-0.36667,0.177,NULL,49669883574,776091930,12126436,17),(150152,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150152,38.05,0.33,407,71372,70,NULL,NULL,'2MASX J21193603-0551303',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000081,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,319.9,-5.85839,0.245,NULL,49720237997,776878718,12138729,18.2),(150153,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150153,35.09,0.56,104,71373,70,NULL,NULL,'ESO 107- G 020',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'14.3r',0.6,'(R_1R\'_2)SAB(r)0/a',NULL,NULL,NULL,NULL,1,319.909333,-67.05361,0.045,NULL,49385743479,771652241,12057066,14.3),(150154,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150154,33.73,0.47,55.7,71374,NULL,NULL,'H','UGC 11722',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000023,NULL,'15.01',0.5,'S?',NULL,NULL,NULL,NULL,1,319.909583,21.972,0.605,NULL,55126287196,861348237,13458566,15.01),(150155,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150155,33.84,0.46,58.6,71374,NULL,NULL,'J','UGC 11722',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150156,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150156,33.91,0.45,60.5,71374,NULL,NULL,'K','UGC 11722',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150157,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150157,34.06,0.4,64.8,71374,NULL,NULL,'mean','UGC 11722',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150158,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150158,37.3,0.46,288,71375,70,NULL,NULL,'2MASX J21193890-0003173',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000136,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,319.912125,-0.05481,0.237,NULL,49669867067,776091672,12126432,17.5),(150159,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01804','RN',150159,42.57,0.21,2100,71376,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01804',0.552948,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150160,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150160,34.9,0.41,95.4,71377,NULL,NULL,NULL,'ESO 599- G 007',NULL,'2009ApJS..182..474S',2009,1,1.4,'Position in 1997AJ....113.1548C refers to a superposed star.','G',0.000033,NULL,'15.60',0.6,'Sb:',NULL,NULL,NULL,NULL,1,319.9447917,-22.19678,0.097,NULL,50914942152,795545971,12430405,15.6),(150161,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150161,34.94,0.2,97.3,71377,74.4,NULL,NULL,'ESO 599- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150162,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150162,35.31,0.34,115,71377,NULL,NULL,'Malmquist cor.','ESO 599- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150163,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150163,35.9,0.64,151,71378,70,NULL,NULL,'2MASX J21194750-6847438',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'14.9r',0.36,NULL,NULL,NULL,NULL,NULL,1,319.9480417,-68.79544,0.049,NULL,49386103211,771657862,12057154,14.9),(150164,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150164,32.06,0.45,25.8,71379,NULL,NULL,'K','NGC 7051',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000012,NULL,'12.9B',1.1,'SB(r)a pec     HII',NULL,NULL,NULL,NULL,1,319.963875,-8.78294,0.269,NULL,50774846799,793356981,12396202,12.9),(150165,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150165,32.07,0.47,26,71379,NULL,NULL,'H','NGC 7051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150166,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150166,32.19,0.46,27.4,71379,NULL,NULL,'J','NGC 7051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150167,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150167,32.41,0.4,30.3,71379,NULL,NULL,'mean','NGC 7051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150168,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150168,36.27,0.66,179,71380,70,NULL,NULL,'2MASX J21195170-5131082',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'15.1r',0.32,'S0',NULL,NULL,NULL,NULL,1,319.965375,-51.51894,0,NULL,50614751439,790855491,12357117,15.1),(150169,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150169,36.44,0.63,194,71381,70,NULL,NULL,'2MASX J21195280-4741220',NULL,'2014MNRAS.445.2677S',2014,1,0.13,NULL,'G',0.00015,NULL,'15.4r',0.1,NULL,NULL,NULL,NULL,NULL,1,319.970041667,-47.68947,0.077,NULL,51343449606,802241400,12535021,15.4),(150170,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150170,35.7,0.54,138,71382,70,NULL,NULL,'2MASX J21195306-3046199',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.000103,NULL,'14.6r',0.31,NULL,NULL,NULL,NULL,NULL,1,319.971083333,-30.77228,0.273,NULL,51427020303,803547192,12555424,14.6),(150171,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150171,35.53,0.66,128,71383,70,NULL,NULL,'2MASX J21195697-4327161',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'14.6r',0.23,'S',NULL,NULL,NULL,NULL,1,319.9872917,-43.45453,0.077,NULL,51368101853,802626591,12541040,14.6),(150172,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150172,37,0.46,252,71384,70,NULL,NULL,'2MASX J21195790-0638082',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00009,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,319.991333333,-6.63575,0.329,NULL,49686690072,776354532,12130539,17.7),(150173,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150173,34.63,0.53,84.3,71385,70,NULL,NULL,'2MASX J21200028-0507466',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.8I',0.3,NULL,NULL,NULL,NULL,NULL,1,320.00125,-5.12956,0.205,NULL,49719962350,776874411,12138662,13.8),(150174,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150174,36.7,0.53,218,71386,70,NULL,NULL,'2MASX J21200263-4759452',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'14.8r',0.23,'S',NULL,NULL,NULL,NULL,1,320.011125,-47.996,0.077,NULL,51343463511,802241617,12535025,14.8),(150175,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150175,37.32,0.57,291,71387,70,NULL,NULL,'2MASX J21200298-6924152',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'14.6r',0.43,'S0',NULL,NULL,NULL,NULL,1,320.01225,-69.40436,0.113,NULL,49333244118,770831939,12044249,14.6),(150176,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15467',NULL,150176,39.42,0.08,767,71388,70,NULL,'Hubble residual -0.11 for z0.21043','SDSS-II SN 15467 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.00009,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,320.020125,-0.17736,0.213,NULL,49669874325,776091786,12126434,NULL),(150177,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15467','R',150177,40.06,0.19,851,71388,70,NULL,'SDSS CAND. SNIa; SALT 2','SDSS-II SN 15467 HOST',0.21043,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150178,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15467','R',150178,40.12,0.1,873,71388,70,NULL,'SDSS CAND. SNIa; MLCS2K2','SDSS-II SN 15467 HOST',0.21043,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150179,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15467',NULL,150179,39.92,0.08,964,71388,70,NULL,'SALT 2','SDSS-II SN 15467 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150180,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15467',NULL,150180,39.94,0.08,973,71388,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15467 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150181,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150181,36.37,0.57,188,71389,70,NULL,NULL,'2MASX J21200543-1950039',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000127,NULL,'14.3r',0.52,'S',NULL,NULL,NULL,NULL,1,320.022417,-19.83461,0.109,NULL,50911079225,795485612,12429462,14.3),(150182,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02056','RN',150182,41.42,0.39,1620,71390,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 02056',0.189482,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150183,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2006cm',NULL,150183,33.93,0.21,60.1,71391,74.2,NULL,'SALT 2','UGC 11723',0.016341,'2010ApJ...716..712A',2010,1,1.9,NULL,'G',0.000017,NULL,'13.7B',0.3,'Sb             HII?','Isolated galaxy',NULL,NULL,NULL,1,320.072833,-1.68433,0.169,NULL,49671328457,776114507,12126789,13.7),(150184,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2006cm',NULL,150184,34.26,0.03,70,71391,72,NULL,'Malmquist cor.','UGC 11723',0.016341,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150185,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2006cm',NULL,150185,34.52,0.09,80.2,71391,74.4,NULL,NULL,'UGC 11723',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150186,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150186,33.83,0.45,58.3,71391,NULL,NULL,'K','UGC 11723',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150187,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150187,33.87,0.47,59.6,71391,NULL,NULL,'H','UGC 11723',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150188,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150188,34.04,0.4,64.2,71391,NULL,NULL,'mean','UGC 11723',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150189,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150189,34.07,0.46,65.2,71391,NULL,NULL,'J','UGC 11723',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150190,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150190,34.25,0.49,70.7,71391,75,NULL,'IR','UGC 11723',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150191,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150191,34.52,0.09,80.2,71391,74.4,NULL,NULL,'UGC 11723',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150192,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150192,34.52,0.4,80.2,71391,75,NULL,'HOSTS SN 2006cm','UGC 11723',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150193,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150193,34.63,0.41,84.5,71391,NULL,NULL,'Malmquist cor.','UGC 11723',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150194,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150194,34.69,0.4,86.5,71391,NULL,NULL,NULL,'UGC 11723',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150195,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150195,36.49,0.46,199,71392,70,NULL,NULL,'2MASX J21202044-0821021',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000084,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,320.085125,-8.35053,0.241,NULL,50774487643,793351369,12396115,16.7),(150196,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150196,35.43,0.49,122,71393,75,NULL,'IR','MCG -02-54-005',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000043,NULL,'15',0.3,'Sc: sp         HII',NULL,NULL,NULL,NULL,1,320.0975,-13.17131,0.185,NULL,50953862264,796154097,12439907,15),(150197,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150197,35.64,0.42,134,71393,NULL,NULL,'Malmquist cor.','MCG -02-54-005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150198,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150198,35.93,0.37,154,71393,NULL,NULL,NULL,'MCG -02-54-005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150199,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150199,35.97,0.2,156,71393,74.4,NULL,NULL,'MCG -02-54-005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150200,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150200,36.35,0.68,186,71394,70,NULL,NULL,'2MASX J21202848-2010123',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'15.3r',0.33,NULL,NULL,NULL,NULL,NULL,1,320.118708333,-20.17008,0.081,NULL,50911210308,795487661,12429494,15.3),(150201,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 05208','RN',150201,43.23,0.23,3000,71395,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05208',0.474463,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150202,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150202,34.67,0.49,85.9,71396,75,NULL,'IR','UGC 11726',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.00003,NULL,'15.15',0.4,'Sbc',NULL,NULL,NULL,NULL,1,320.12525,37.58422,NULL,NULL,55817590867,872149857,13627341,15.15),(150203,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150203,35.05,0.47,102,71396,NULL,NULL,'H','UGC 11726',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150204,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150204,35.15,0.45,107,71396,NULL,NULL,'K','UGC 11726',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150205,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150205,35.17,0.4,108,71396,NULL,NULL,'mean','UGC 11726',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150206,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150206,35.22,0.46,111,71396,NULL,NULL,'J','UGC 11726',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150207,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150207,35.58,0.53,131,71397,70,NULL,NULL,'MCG -07-43-038',NULL,'2014MNRAS.445.2677S',2014,1,0.15,NULL,'G',0.0001,NULL,'15.5',0.15,'E',NULL,NULL,NULL,NULL,1,320.129833,-43.44817,0.077,NULL,51368112529,802626758,12541043,15.5),(150208,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150208,37.18,0.46,272,71398,70,NULL,NULL,'2MASX J21203355+1058013',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000161,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,320.139875,10.96706,0.269,NULL,55061274602,860332415,13442693,17.3),(150209,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02041','RN',150209,40.2,0.28,906,71399,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02041',0.209821,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150210,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02041','RN',150210,40.44,0.21,1010,71399,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 02041',0.209821,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150211,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150211,33.93,0.2,61.1,71400,74.4,NULL,NULL,'UGC 11724',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.00013,NULL,'15.02',0.3,'SBcd:',NULL,NULL,NULL,NULL,1,320.159333,1.04719,0.189,NULL,52081195189,813768674,12715135,15.02),(150212,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150212,33.99,0.47,62.9,71400,NULL,NULL,'Malmquist cor.','UGC 11724',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150213,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150213,33.99,0.47,62.9,71400,NULL,NULL,NULL,'UGC 11724',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150214,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16590',NULL,150214,39.61,1.32,834,71401,70,NULL,'SN photometric redshift distance, z photo =0.218 +/- 0.235','SDSS-II SN 16590',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','20.6g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,320.17475,0.69611,0.241,NULL,52081622094,813775345,12715239,20.6),(150215,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16590','R',150215,40.9,0.27,1160,71401,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16590',0.30637,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150216,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16590',NULL,150216,40.73,0.24,1400,71401,70,NULL,'SALT 2','SDSS-II SN 16590',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150217,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16590',NULL,150217,40.76,0.24,1420,71401,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16590',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150218,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150218,37.19,0.83,274,71402,70,NULL,NULL,'2MASX J21204245-5300479',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'15.2r',0.33,'S',NULL,NULL,NULL,NULL,1,320.176917,-53.01328,0.037,NULL,50615348705,790864823,12357262,15.2),(150219,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2001fh',NULL,150219,32.59,0.3,32.5,71403,74.2,NULL,'SALT 2','2MASX J21204248+4423590',0.01299,'2010ApJ...716..712A',2010,1,2,NULL,'G',0.00014,NULL,'11.1B',NULL,'Sb',NULL,NULL,NULL,NULL,1,320.177,44.39975,NULL,NULL,55672400424,869881256,13591894,11.1),(150220,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2001fh',NULL,150220,33.16,0.09,42.9,71403,74.4,NULL,NULL,'2MASX J21204248+4423590',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150221,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2001fh',NULL,150221,33.46,0.29,48.6,71403,65,NULL,'SALT2','2MASX J21204248+4423590',0.01299,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150222,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2001fh',NULL,150222,33.5,0.23,49.4,71403,70,NULL,'SALT 2','2MASX J21204248+4423590',0.01299,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150223,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2001fh',NULL,150223,33.73,0.27,55,71403,65,NULL,'MLCS31','2MASX J21204248+4423590',0.01299,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150224,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2001fh',NULL,150224,33.78,0.28,56.2,71403,65,NULL,'MLCS17','2MASX J21204248+4423590',0.01299,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150225,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150225,37.55,0.46,323,71404,70,NULL,NULL,'2MASX J21204534-0612307',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000085,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,320.188875,-6.20869,0.285,NULL,49686327876,776348873,12130451,17.6),(150226,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150226,35.64,0.51,134,71405,70,NULL,NULL,'MCG -05-50-014',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.5',0.2,'S0',NULL,NULL,NULL,NULL,1,320.218041667,-30.57481,0.221,NULL,51430215975,803597124,12556205,15.5),(150227,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150227,37.46,0.46,311,71406,70,NULL,NULL,'2MASX J21205356-0643596',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000088,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,320.223375,-6.73319,0.381,NULL,49686737627,776355275,12130551,18.4),(150228,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150228,35.1,0.62,105,71407,70,NULL,NULL,'2MASX J21205646-7245515',NULL,'2014MNRAS.445.2677S',2014,1,0.31,NULL,'G',0.00015,NULL,'16.4b',0.14,NULL,NULL,NULL,NULL,NULL,1,320.235375,-72.76431,0.133,NULL,49294955602,770233681,12034901,16.4),(150229,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2001dl',NULL,150229,35.17,0.17,106,71408,70,NULL,'SALT 2','UGC 11725',0.020694,'2013MNRAS.433.2240G',2013,1,1.1,NULL,'G',0.000017,NULL,'15.14',0.4,'Sdm:',NULL,NULL,NULL,NULL,1,320.257333,9.1775,0.189,NULL,55055883763,860248183,13441377,15.14),(150230,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150230,34.33,0.49,73.6,71408,75,NULL,'IR','UGC 11725',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150231,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150231,35.17,0.6,108,71409,70,NULL,NULL,'ESO 047-IG 029 NED02',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'16.1b',0.25,NULL,NULL,NULL,NULL,NULL,1,320.266,-72.76881,0.133,NULL,49294962872,770233794,12034903,16.1),(150232,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 08917','RN',150232,41.34,0.21,1590,71410,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 08917',0.16167,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150233,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 08917','RN',150233,42,0.24,2170,71410,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 08917',0.16167,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150234,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150234,35.62,0.55,133,71411,70,NULL,NULL,'2MASX J21210936-6006549',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'14.4r',0.42,'S',NULL,NULL,NULL,NULL,1,320.2889583,-60.11533,0.069,NULL,49181722776,768464418,12007256,14.4),(150235,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13730','RN',150235,40.25,0.4,892,71412,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13730',0.256496,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150236,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13730','RN',150236,41.13,0.46,1340,71412,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13730',0.256496,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150237,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150237,34.1,0.2,66.1,71413,74.4,NULL,NULL,'UGC 11729',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',NULL,NULL,'16.5',0.3,'SBcd:',NULL,NULL,NULL,NULL,1,320.31125,25.02889,0.385,NULL,55122746273,861292910,13457701,16.5),(150238,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150238,34.22,0.43,69.9,71413,NULL,NULL,'Malmquist cor.','UGC 11729',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150239,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150239,34.27,0.42,71.4,71413,NULL,NULL,NULL,'UGC 11729',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150240,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 11119','RN',150240,40.54,0.3,1150,71414,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 11119',0.115319,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150241,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 11119','RN',150241,40.99,0.27,1420,71414,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 11119',0.115319,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150242,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150242,32.61,0.8,33.3,71415,75,NULL,'MAT, I','ESO 287- G 009',NULL,'1997ApJS..109..333W',1997,1,1.52,NULL,'G',0.000031,NULL,'13.7r',0.32,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,320.317917,-46.15278,0.033,NULL,51364085664,802563838,12540059,13.7),(150243,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150243,32.05,0.39,25.7,71415,73,NULL,'IR','ESO 287- G 009',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150244,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150244,32.05,0.4,25.7,71415,75,NULL,NULL,'ESO 287- G 009',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150245,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150245,32.33,0.39,29.2,71415,73,NULL,'opt','ESO 287- G 009',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150246,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150246,32.6,0.4,33.1,71415,NULL,NULL,NULL,'ESO 287- G 009',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150247,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150247,32.63,0.49,33.5,71415,75,NULL,'IR','ESO 287- G 009',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150248,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150248,32.71,0.32,34.9,71415,85,NULL,'I, raw','ESO 287- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150249,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150249,32.71,0.32,34.9,71415,85,NULL,'I, inv','ESO 287- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150250,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150250,32.91,0.43,38.2,71415,75,NULL,'MAT, I, raw','ESO 287- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150251,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150251,32.97,0.43,39.3,71415,75,NULL,'MAT, I, inv','ESO 287- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150252,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150252,33.15,0.43,42.7,71415,75,NULL,'MAT, I, cor','ESO 287- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150253,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150253,33.47,NULL,49.5,71415,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 287- G 009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150254,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150254,33.48,NULL,49.7,71415,NULL,NULL,'Dipole + Quadrupole','ESO 287- G 009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150255,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150255,33.5,NULL,50.1,71415,NULL,NULL,'Dipole','ESO 287- G 009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150256,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150256,33.93,NULL,61.1,71415,NULL,NULL,NULL,'ESO 287- G 009',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150257,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15830','RN',150257,39.56,0.25,717,71416,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15830',0.139221,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150258,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15830','RN',150258,39.74,0.28,778,71416,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15830',0.139221,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150259,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150259,36.5,0.55,199,71417,70,NULL,NULL,'2MASX J21212394-5253324',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.000133,NULL,'13.9r',0.67,'S0',NULL,NULL,NULL,NULL,1,320.349833333,-52.89228,0.037,NULL,50615343378,790864740,12357261,13.9),(150260,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150260,34.79,0.55,90.6,71418,NULL,NULL,NULL,'ESO 530- G 037',NULL,'2009ApJS..182..474S',2009,1,1.4,'Da Costa, et al. (1998,AJ,116,1) give v = 7260 +/- 52 km/sec.','G',0.000033,NULL,'14.3r',0.8,'Sb',NULL,NULL,NULL,NULL,1,320.35525,-24.37161,0.117,NULL,50909230973,795456733,12429011,14.3),(150261,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150261,34.83,0.2,92.5,71418,74.4,NULL,NULL,'ESO 530- G 037',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150262,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150262,35.05,0.49,102,71418,NULL,NULL,'Malmquist cor.','ESO 530- G 037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150263,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150263,37.55,0.46,323,71419,70,NULL,NULL,'2MASX J21212928+0933512',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000151,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,320.372041667,9.56436,0.137,NULL,55060571920,860321436,13442522,17.4),(150264,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150264,33.98,0.49,62.4,71420,75,NULL,'IR','IC 5104',NULL,'2011yCatp016004901K',2011,1,1.6,NULL,'G',0.000017,NULL,'14.27',0.4,'SBab?','Isolated galaxy',NULL,NULL,NULL,1,320.371875,21.24197,0.441,NULL,55119245325,861238208,13456847,14.27),(150265,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150265,34.01,0.2,63.4,71420,74.4,NULL,NULL,'IC 5104',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150266,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150266,34.03,0.43,64,71420,75,NULL,'3.6 micron, color corrected','IC 5104',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150267,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150267,34.11,0.43,66.2,71420,75,NULL,'3.6 micron, color + selection bias corrected','IC 5104',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150268,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150268,34.13,0.4,66.9,71420,NULL,NULL,'mean','IC 5104',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150269,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150269,34.3,0.47,72.4,71420,NULL,NULL,'H','IC 5104',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150270,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150270,34.35,0.46,74.1,71420,NULL,NULL,'J','IC 5104',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150271,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150271,34.35,0.45,74.1,71420,NULL,NULL,'K','IC 5104',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150272,'CMD','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150272,16.1,NULL,0.0166,71421,NULL,NULL,NULL,'Segue 3',NULL,'2010ApJ...712L.103B',2010,1,NULL,'May be a MW globular cluster. See 2011AJ....142...88F.','G',NULL,NULL,NULL,NULL,'Poss. galactic',NULL,NULL,NULL,NULL,1,320.379167,19.11722,0.349,1,55146906481,861670413,13463600,NULL),(150273,'CMD','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150273,16.14,0.09,0.0169,71421,NULL,NULL,NULL,'Segue 3',NULL,'2011AJ....142...88F',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150274,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150274,37.45,0.46,309,71422,70,NULL,NULL,'2MASX J21213259+0933202',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000182,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,320.385958333,9.55561,0.137,NULL,55060573772,860321465,13442522,16.8),(150275,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02057','R',150275,39.95,0.21,805,71423,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 02057',0.211587,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,320.3997083,-0.31708,0.169,NULL,49669172196,776080815,12126262,NULL),(150276,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02057','R',150276,40.01,0.16,830,71423,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 02057',0.211587,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150277,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150277,36.95,0.2,245,71424,74.4,NULL,NULL,'CGCG 426-043',NULL,'2013AJ....146...86T',2013,1,0.86,NULL,'G',0.000098,NULL,'15.6g',0.42,'Sm','Isolated galaxy',NULL,NULL,NULL,1,320.401625,11.30067,0.277,NULL,55047611013,860118922,13439358,15.6),(150278,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150278,35.73,0.51,140,71425,70,NULL,NULL,'2MASX J21213661-7118141',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.6r',0.32,'S',NULL,NULL,NULL,NULL,1,320.402667,-71.30392,0.145,NULL,49326128351,770720755,12042511,14.6),(150279,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 06479','R',150279,40.12,0.2,856,71426,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J212137.75+003500.9',0.234,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',0.0005,NULL,'20.9g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,320.4072917,0.58361,0.173,NULL,52080743628,813761619,12715025,20.9),(150280,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 06479','R',150280,40.38,0.13,967,71426,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J212137.75+003500.9',0.234,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150281,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 06479',NULL,150281,39.98,0.1,991,71426,70,NULL,'SALT 2','SDSS J212137.75+003500.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150282,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 06479',NULL,150282,39.99,0.1,995,71426,70,NULL,'SALT 2, Malmquist cor.','SDSS J212137.75+003500.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150283,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2005fc',NULL,150283,40.42,0.22,936,71427,74.2,NULL,'SALT 2','SDSS J212139.08+005342.7',0.297,'2010ApJ...716..712A',2010,1,0.09,NULL,'G',NULL,NULL,'20.5g',0.05,NULL,NULL,NULL,NULL,NULL,1,320.412875,0.89519,0.189,NULL,52081074134,813766783,12715105,20.5),(150284,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2005fc',NULL,150284,41.03,0.24,1240,71427,70,NULL,'SALT 2','SDSS J212139.08+005342.7',0.297,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150285,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01119','R',150285,41.22,0.36,1360,71427,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fc','SDSS J212139.08+005342.7',0.29,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150286,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01119','R',150286,41.34,0.21,1440,71427,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fc','SDSS J212139.08+005342.7',0.29,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150287,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2005fc',NULL,150287,41.1,0.22,1660,71427,70,NULL,'SALT 2','SDSS J212139.08+005342.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150288,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2005fc',NULL,150288,41.13,0.22,1680,71427,70,NULL,'SALT 2, Malmquist cor.','SDSS J212139.08+005342.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150289,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150289,34.13,0.8,67.1,71428,75,NULL,'MAT, I','IC 5100',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000007,NULL,'14.57',0.4,'SBc?','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,320.431083,-65.93336,0.013,NULL,49347144706,771049136,12047642,14.57),(150290,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150290,34.22,0.32,69.8,71428,85,NULL,'I, raw','IC 5100',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150291,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150291,34.25,0.43,70.9,71428,75,NULL,'MAT, I, raw','IC 5100',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150292,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150292,34.25,0.32,70.9,71428,85,NULL,'I, inv','IC 5100',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150293,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150293,34.42,0.43,76.6,71428,75,NULL,'MAT, I, inv','IC 5100',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150294,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150294,34.65,0.43,84.9,71428,75,NULL,'MAT, I, cor','IC 5100',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150295,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150295,34.81,0.61,91.8,71428,NULL,NULL,NULL,'IC 5100',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150296,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150296,34.85,0.2,93.3,71428,74.4,NULL,NULL,'IC 5100',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150297,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150297,34.93,0.58,97,71428,NULL,NULL,'Malmquist cor.','IC 5100',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150298,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150298,36.67,0.46,216,71429,70,NULL,NULL,'2MASX J21214661-0009382',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00015,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,320.444167,-0.16072,0.169,NULL,49669001203,776078143,12126220,16.5),(150299,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150299,34.64,0.46,84.8,71430,70,NULL,NULL,'CGCG 426-044',NULL,'2015arXiv151105856S',2015,1,0.91,NULL,'G',0.000117,NULL,'14.7g',0.63,'E0',NULL,NULL,NULL,NULL,1,320.4535,10.65608,0.201,NULL,55059941154,860311580,13442368,14.7),(150300,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15592',NULL,150300,34.85,5.77,93.2,71431,70,NULL,'SN photometric redshift distance, z photo =0.022 +/- 0.356','SDSS-II SN 15592',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,320.467333,-1.1785,0.177,NULL,49715563110,776805673,12137588,NULL),(150301,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15592','R',150301,41.59,0.25,1470,71431,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15592',0.415635,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150302,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15592','R',150302,41.9,0.25,1700,71431,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15592',0.415635,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150303,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15592',NULL,150303,41.45,0.16,1950,71431,70,NULL,'SALT 2','SDSS-II SN 15592',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150304,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15592',NULL,150304,41.52,0.16,2010,71431,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15592',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150305,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 19908','RN',150305,40.12,0.2,855,71432,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19908',0.235551,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150306,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 19908','RN',150306,40.34,0.12,947,71432,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 19908',0.235551,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150307,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150307,35.97,0.5,156,71433,70,NULL,NULL,'2MASX J21215489-5555365',NULL,'2014MNRAS.445.2677S',2014,1,0.87,NULL,'G',0.000073,NULL,'14.0r',0.68,'S0',NULL,NULL,NULL,NULL,1,320.478833333,-55.92683,0.205,NULL,48669683098,760463798,11882246,14),(150308,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 14441','RN',150308,43.35,0.25,2980,71434,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 14441',0.570644,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150309,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150309,36.71,0.46,220,71435,70,NULL,NULL,'2MASX J21220247+1137470',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,320.510417,11.62964,0.269,NULL,55048108814,860126700,13439479,17.7),(150310,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 12578','RN',150310,39.03,0.68,563,71436,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 12578',0.135043,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150311,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 12578','RN',150311,39.12,0.48,586,71436,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 12578',0.135043,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150312,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150312,33.51,0.49,50.4,71437,75,NULL,'IR','NGC 7056',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000023,NULL,'13.75',0.9,'SBb','Isolated galaxy',NULL,NULL,NULL,1,320.5315,18.66567,0.341,NULL,55138467619,861538556,13461539,13.75),(150313,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150313,36.25,0.49,178,71438,70,NULL,NULL,'2MASX J21221500-0925578',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000047,NULL,'15.62',0.43,NULL,NULL,NULL,NULL,NULL,1,320.562416667,-9.43269,0.237,NULL,50783508747,793492324,12398317,15.62),(150314,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150314,35.82,0.46,146,71439,70,NULL,NULL,'2MASX J21221501-0747228',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000069,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,320.5625417,-7.78964,0.421,NULL,49687302806,776364106,12130689,17.1),(150315,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13845','RN',150315,42.86,0.22,2620,71440,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13845',0.423313,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150316,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13845','RN',150316,42.99,0.18,2780,71440,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13845',0.423313,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150317,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150317,37.91,0.46,382,71441,70,NULL,NULL,'2MASX J21221899+0035368',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,320.579208333,0.59367,0.173,NULL,52135389078,814615454,12728366,17.3),(150318,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150318,36.87,0.8,237,71442,70,NULL,NULL,'2MASX J21222044-5026445',NULL,'2014MNRAS.445.2677S',2014,1,0.92,NULL,'G',0.00015,NULL,'14.8r',0.38,'S',NULL,NULL,NULL,NULL,1,320.585125,-50.44564,0,NULL,50609875811,790779309,12355926,14.8),(150319,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150319,37.17,0.46,271,71443,70,NULL,NULL,'2MASX J21222214-0020442',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000141,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,320.592375,-0.34547,0.173,NULL,49715104987,776798515,12137476,17.2),(150320,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150320,37.2,0.6,275,71444,70,NULL,NULL,'2MASX J21222292-5600143',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.22',0.38,'S0',NULL,NULL,NULL,NULL,1,320.603417,-56.00681,0.141,NULL,48669675360,760463677,11882244,16.22),(150321,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150321,35.97,0.65,156,71445,70,NULL,NULL,'2MASX J21222931-4511550',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.000133,NULL,'14.5r',0.47,'E',NULL,NULL,NULL,NULL,1,320.6222917,-45.19864,0.073,NULL,51367066565,802610415,12540787,14.5),(150322,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150322,37.04,0.46,256,71446,70,NULL,NULL,'2MASX J21223060+0946295',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000145,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,320.627417,9.77506,0.173,NULL,55060644041,860322563,13442540,17.1),(150323,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150323,35.93,0.61,154,71447,70,NULL,NULL,'2MASX J21223094-4952544',NULL,'2014MNRAS.445.2677S',2014,1,1,'The APMUKS image includes a superposed star.','G',0.00015,NULL,'14.8r',0.5,'S0',NULL,NULL,NULL,NULL,1,320.629,-49.88183,0,NULL,50612261227,790816581,12356509,14.8),(150324,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150324,32.9,0.4,38.1,71448,NULL,NULL,'mean','ESO 402- G 026',NULL,'2007A&A...465...71T',2007,1,2.8,NULL,'G',0.000027,NULL,'13.69',0.8,'(R\'_1)SAB(r)b',NULL,NULL,NULL,NULL,1,320.6307917,-36.68156,0.177,NULL,51488526995,804508234,12570441,13.69),(150325,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150325,33.52,0.47,50.6,71448,NULL,NULL,'H','ESO 402- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150326,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150326,33.52,0.45,50.6,71448,NULL,NULL,'K','ESO 402- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150327,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150327,33.64,0.46,53.3,71448,NULL,NULL,'J','ESO 402- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150328,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150328,35.46,0.55,123,71449,70,NULL,NULL,'2MASX J21223806-1928273',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'14.7r',0.48,'E',NULL,NULL,NULL,NULL,1,320.658625,-19.47439,0.137,NULL,50919853314,795622708,12431604,14.7),(150329,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150329,37.33,0.71,292,71450,70,NULL,NULL,'AM 2119-503',NULL,'2014MNRAS.445.2677S',2014,1,0.98,NULL,'G',0.00015,NULL,'18.8b',0.3,'INTERACTING',NULL,NULL,NULL,NULL,1,320.661541667,-50.44383,0,NULL,50609911033,790779859,12355935,18.8),(150330,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150330,36.91,0.54,241,71451,70,NULL,NULL,'2MASX J21224573-2136573',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'15.2r',0.3,NULL,NULL,NULL,NULL,NULL,1,320.6904583,-21.61606,0.105,NULL,50913462195,795522846,12430044,15.2),(150331,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150331,36.1,0.59,166,71452,70,NULL,NULL,'2MASX J21224850-2204563',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00015,NULL,'15.0r',0.38,NULL,NULL,NULL,NULL,NULL,1,320.7022917,-22.08244,0.093,NULL,50915579144,795555924,12430561,15),(150332,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150332,37.76,0.46,356,71453,70,NULL,NULL,'SDSS J212250.16-060942.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.00009,NULL,'19.0g',0.11,NULL,NULL,NULL,NULL,NULL,1,320.709041667,-6.16181,0.297,NULL,49686264379,776347880,12130435,19),(150333,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150333,36.09,0.74,165,71454,70,NULL,NULL,'2MASX J21225062-4945499',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'14.6r',0.48,'(R_1)SB(r)0^+',NULL,NULL,NULL,NULL,1,320.710875,-49.76381,0,NULL,50612258130,790816533,12356508,14.6),(150334,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150334,36.3,0.46,182,71455,70,NULL,NULL,'2MASX J21225161+1124347',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,320.715125,11.40964,0.269,NULL,55047484569,860116946,13439327,17.5),(150335,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150335,37.79,0.46,361,71456,70,NULL,NULL,'SDSS J212252.36-011456.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000131,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,320.718167,-1.24911,0.153,NULL,49715553319,776805520,12137586,18.1),(150336,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150336,35.25,0.55,112,71457,70,NULL,NULL,'ESO 599- G 009',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'14.8r',0.2,'Sa:',NULL,NULL,NULL,NULL,1,320.723917,-19.89725,0.097,NULL,50919350911,795614857,12431482,14.8),(150337,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150337,37.5,0.46,316,71458,70,NULL,NULL,'2MASX J21225537+1030537',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,320.730583,10.51481,0.201,NULL,55048694594,860135853,13439622,17.3),(150338,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01627','RN',150338,42.7,0.44,2590,71459,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 01627',0.338934,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150339,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01627','RN',150339,43.19,0.43,3240,71459,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 01627',0.338934,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150340,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150340,36.77,0.6,226,71460,70,NULL,NULL,'2MASX J21225650-4818509',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'15.1r',0.52,'S0',NULL,NULL,NULL,NULL,1,320.7354583,-48.31414,0.049,NULL,51343327473,802239491,12534992,15.1),(150341,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150341,35.25,0.46,112,71461,70,NULL,NULL,'CGCG 375-032',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000157,NULL,'15.4g',0.44,'E0',NULL,NULL,NULL,NULL,1,320.744541667,1.02672,0.165,NULL,52136093571,814626462,12728538,15.4),(150342,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150342,37.38,0.46,299,71462,70,NULL,NULL,'SDSS J212304.21+100257.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,320.767583,10.04939,0.153,NULL,55060125079,860314454,13442413,18.1),(150343,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150343,35.55,0.59,129,71463,70,NULL,NULL,'2MASX J21230457-7120293',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'14.7r',0.33,'S',NULL,NULL,NULL,NULL,1,320.769167,-71.34158,0.129,NULL,49326101389,770720334,12042505,14.7),(150344,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150344,35.77,0.47,143,71464,70,NULL,NULL,'AM 2119-475 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.000133,NULL,'15.51',0.53,'INTERACTING',NULL,NULL,NULL,NULL,1,320.7765417,-47.65478,0.061,NULL,51342722596,802230040,12534844,15.51),(150345,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150345,36.49,0.53,198,71465,70,NULL,NULL,'2MASX J21231300-1936242',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'14.7r',0.48,'E',NULL,NULL,NULL,NULL,1,320.804083333,-19.60658,0.097,NULL,50919209937,795612655,12431447,14.7),(150346,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150346,32.62,0.8,33.3,71466,75,NULL,'HMCL, I','ESO 287- G 013',NULL,'1997ApJS..109..333W',1997,1,3.2,'The APM position is on a bright knot 17 arcsec southeast of the nucleus.','G',0.000017,NULL,'12.2r',0.9,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,320.8080417,-45.77311,0.037,NULL,51364154070,802564907,12540076,12.2),(150347,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150347,32.62,0.8,33.4,71466,75,NULL,'MAT, I','ESO 287- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150348,'Tully est','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150348,32.64,0.8,33.7,71466,75,NULL,'B','ESO 287- G 013',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150349,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150349,32.21,0.39,27.7,71466,73,NULL,'IR','ESO 287- G 013',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150350,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150350,32.21,0.4,27.7,71466,75,NULL,NULL,'ESO 287- G 013',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150351,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150351,32.34,0.4,29.4,71466,73,NULL,'opt','ESO 287- G 013',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150352,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150352,32.43,0.32,30.6,71466,85,NULL,'I, raw','ESO 287- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150353,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150353,32.45,0.43,30.9,71466,75,NULL,'MAT, I, raw','ESO 287- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150354,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150354,32.47,0.32,31.2,71466,85,NULL,'I, inv','ESO 287- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150355,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150355,32.47,0.4,31.2,71466,NULL,NULL,NULL,'ESO 287- G 013',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150356,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150356,32.48,0.4,31.4,71466,75,NULL,'HMCL, I, raw','ESO 287- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150357,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150357,32.64,0.43,33.7,71466,75,NULL,'MAT, I, cor','ESO 287- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150358,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150358,32.64,0.4,33.7,71466,75,NULL,'HMCL, I, inv','ESO 287- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150359,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150359,32.64,0.4,33.7,71466,75,NULL,'HMCL, I, cor','ESO 287- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150360,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150360,32.65,0.43,33.8,71466,75,NULL,'MAT, I, inv','ESO 287- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150361,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150361,32.68,0.46,34.3,71466,NULL,NULL,'J','ESO 287- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150362,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150362,32.71,0.47,34.8,71466,NULL,NULL,'H','ESO 287- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150363,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150363,32.72,0.4,34.9,71466,NULL,NULL,'mean','ESO 287- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150364,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150364,32.74,0.45,35.3,71466,NULL,NULL,'K','ESO 287- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150365,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150365,32.8,0.44,36.3,71466,NULL,NULL,'Malmquist cor.','ESO 287- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150366,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150366,32.81,0.2,36.5,71466,74.4,NULL,NULL,'ESO 287- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150367,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,'R',150367,32.81,0.49,36.5,71466,75,NULL,'IR','ESO 287- G 013',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150368,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150368,32.86,0.43,37.3,71466,NULL,NULL,NULL,'ESO 287- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150369,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 18857','RN',150369,42.94,0.22,2740,71467,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 18857',0.413696,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150370,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 18857','RN',150370,42.96,0.2,2770,71467,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 18857',0.413696,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150371,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 07636',NULL,150371,40.91,0.23,1520,71468,70,NULL,'SN photometric redshift distance, z photo =0.449 +/- 0.067','SDSS-II SN 07636',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,320.855083333,0.11878,0.205,NULL,52101707667,814089182,12720143,NULL),(150372,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 06509','RN',150372,38.72,0.23,524,71469,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06509',0.058196,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150373,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 14001','RN',150373,41.84,0.18,2020,71470,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 14001',0.15501,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150374,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 14001','RN',150374,42.24,0.22,2430,71470,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 14001',0.15501,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150375,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 16481',NULL,150375,40.15,0.27,1070,71471,70,NULL,'SN photometric redshift distance, z photo =0.292 +/- 0.047','SDSS-II SN 16481',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','20.2g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,320.8815417,0.98503,0.165,NULL,52136244117,814628814,12728575,20.2),(150376,'GRB','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,'R',150376,38.71,0.11,493,71472,69.7,NULL,'Fiducial','GRB 060614',0.12,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,320.883917,-53.02669,0.017,NULL,50615541769,790867840,12357310,NULL),(150377,'GRB','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150377,42.26,0.88,2530,71472,69.7,NULL,'Fiducial','GRB 060614',0.12,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150378,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 13435','RN',150378,40.74,0.15,1320,71473,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13435',0.063034,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150379,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 13435','RN',150379,41.44,0.26,1830,71473,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13435',0.063034,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150380,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150380,34.63,0.69,84.5,71474,100,NULL,'mid-IR','ARK 546',NULL,'2013ApJ...771...88L',2013,1,0.5,NULL,'G',0.000033,NULL,'15.0',0.3,NULL,NULL,NULL,NULL,NULL,1,320.889083333,17.58386,0.217,NULL,55138813665,861543963,13461624,15),(150381,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150381,35.35,0.4,117,71474,NULL,NULL,'mean','ARK 546',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150382,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150382,35.38,0.47,119,71474,NULL,NULL,'H','ARK 546',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150383,'FP','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150383,36.04,0.63,162,71475,70,NULL,NULL,'2MASX J21233395-4947109',NULL,'2014MNRAS.445.2677S',2014,1,0.31,NULL,'G',0.00015,NULL,'15.3r',0.18,NULL,NULL,NULL,NULL,NULL,1,320.891583333,-49.78631,0,NULL,50612234913,790816170,12356502,15.3),(150384,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 13399','RN',150384,42.72,0.2,2330,71476,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13399',0.503181,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150385,'FP','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150385,34.73,0.5,88.5,71477,70,NULL,NULL,'MCG -01-54-014',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.000087,NULL,'16',0.2,NULL,NULL,NULL,NULL,NULL,1,320.915333,-5.43381,0.205,NULL,49720984767,776890386,12138912,16),(150386,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,'R',150386,34.62,0.49,83.9,71478,75,NULL,'IR','FGC 2323',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.000019,NULL,'16.9',0.1,'Sd',NULL,NULL,NULL,NULL,1,320.924375,19.12906,0.301,NULL,55147709421,861682959,13463796,16.9),(150387,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150387,34.72,0.43,88,71478,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2323',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150388,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150388,35.02,NULL,101,71478,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2323',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150389,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150389,35.05,NULL,102,71478,NULL,NULL,'Dipole + Quadrupole','FGC 2323',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150390,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150390,35.05,NULL,102,71478,NULL,NULL,'Dipole','FGC 2323',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150391,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150391,35.31,NULL,115,71478,NULL,NULL,NULL,'FGC 2323',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150392,'FP','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,'R',150392,37.67,0.46,342,71479,70,NULL,NULL,'2MASX J21234237-0047056',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000152,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,320.926667,-0.78492,0.137,NULL,49715963789,776811934,12137686,17.1),(150393,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SN 2006oa',NULL,150393,36.41,0.16,181,71480,74.2,NULL,'SALT 2','SDSS J212342.94-005036.5',0.06,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,320.928916667,-0.84347,0.137,NULL,49715969535,776812023,12137687,NULL),(150394,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SN 2006oa',NULL,150394,37.03,0.15,240,71480,65,NULL,'SALT','SDSS J212342.94-005036.5',0.06,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150395,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SN 2006oa',NULL,150395,37.05,0.03,243,71480,70,NULL,'SALT 2','SDSS J212342.94-005036.5',0.06,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150396,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SN 2006oa',NULL,150396,37.17,0.15,256,71480,70,NULL,'SALT 2','SDSS J212342.94-005036.5',0.06,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150397,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 16314','R',150397,37.17,0.18,256,71480,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006oa','SDSS J212342.94-005036.5',0.06,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150398,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SN 2006oa',NULL,150398,37.17,0.15,257,71480,73.8,NULL,'SALT 2 (SNANA)','SDSS J212342.94-005036.5',0.0585,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150399,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SN 2006oa',NULL,150399,37.2,0.03,260,71480,72,NULL,'SALT','SDSS J212342.94-005036.5',0.06,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150400,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SN 2006oa','R',150400,37.13,0.07,267,71480,NULL,NULL,'MLCS2k2, R(V) = 1.8','SDSS J212342.94-005036.5',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150401,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SN 2006oa',NULL,150401,37.26,0.17,267,71480,65,NULL,'SALT2','SDSS J212342.94-005036.5',0.06,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150402,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SN 2006oa',NULL,150402,37.26,0.14,267,71480,65,NULL,'MLCS17','SDSS J212342.94-005036.5',0.06,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150403,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SN 2006oa','R',150403,37.16,0.07,270,71480,NULL,NULL,'MLCS2k2, R(V) = 3.1','SDSS J212342.94-005036.5',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150404,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 16314','R',150404,37.34,0.06,277,71480,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006oa','SDSS J212342.94-005036.5',0.06,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150405,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SN 2006oa',NULL,150405,37.34,0.15,278,71480,65,NULL,'MLCS31','SDSS J212342.94-005036.5',0.06,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150406,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150406,34.65,0.69,85,71481,100,NULL,'mid-IR','CGCG 449-022',NULL,'2013ApJ...771...88L',2013,1,0.7,NULL,'G',0.000033,NULL,'15.0',0.3,NULL,NULL,NULL,NULL,NULL,1,320.958875,17.57117,0.217,NULL,55138684453,861541944,13461592,15),(150407,'FP','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150407,36.04,0.55,162,71482,70,NULL,NULL,'2MASX J21235442-1105128',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.84',0.24,NULL,NULL,NULL,NULL,NULL,1,320.976583,-11.087,0.185,NULL,50771238670,793300604,12395321,16.84),(150408,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 20613','R',150408,41.07,0.2,1190,71483,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20613',0.375039,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,'PHOT','21.6g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,320.987083,-0.56283,0.173,NULL,49715244335,776800692,12137510,21.6),(150409,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 20613',NULL,150409,40.53,1.07,1270,71483,70,NULL,'SN photometric redshift distance, z photo =0.359 +/- 0.341','SDSS-II SN 20613',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150410,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 20613','R',150410,41.51,0.29,1460,71483,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20613',0.375039,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150411,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 03437','RN',150411,39.88,0.23,829,71484,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03437',0.140038,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150412,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 03437','RN',150412,39.91,0.11,840,71484,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03437',0.140038,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150413,'FP','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,'R',150413,37.07,0.46,259,71485,70,NULL,NULL,'2MASX J21235929-0703078',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000106,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,320.997,-7.05208,0.329,NULL,49689875529,776404305,12131317,16.5),(150414,'FP','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,'R',150414,36.11,0.33,167,71486,70,NULL,NULL,'2MASX J21235975+0115111',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000172,NULL,'15.7g',0.41,'E0',NULL,NULL,NULL,NULL,1,320.999041667,1.25294,0.173,NULL,52136023259,814625363,12728521,15.7),(150415,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 15396','RN',150415,38.06,0.19,386,71487,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 15396',0.061925,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150416,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 15396','RN',150416,39.69,0.27,815,71487,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 15396',0.061925,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150417,'FP','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,'R',150417,36.21,0.46,174,71488,70,NULL,NULL,'2MASX J21240375-0829517',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000079,NULL,'16.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,321.01575,-8.49775,0.257,NULL,50774215406,793347115,12396048,16.2),(150418,'FP','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,'R',150418,36.11,0.33,167,71489,70,NULL,NULL,'2MASX J21241467+0113366',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000177,NULL,'16.2g',0.36,'E0',NULL,NULL,NULL,NULL,1,321.061167,1.22675,0.173,NULL,52136032434,814625506,12728523,16.2),(150419,'FP','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,'R',150419,37.24,0.46,280,71490,70,NULL,NULL,'SDSS J212419.29-011346.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000137,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,321.080375,-1.22947,0.153,NULL,49715774614,776808978,12137640,17.7),(150420,'Faber-Jackson','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150420,32.41,0.65,30.3,71491,95,NULL,'Weighted Mean','IC 5105',NULL,'1984ApJS...56...91D',1984,1,2.6,NULL,'G',0.000043,NULL,'12.62',1.6,'E+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,321.091708333,-40.53772,0.061,NULL,51356126804,802439481,12538116,12.62),(150421,'Faber-Jackson','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150421,33.96,0.81,61.9,71491,55,NULL,'Visvanathan & Sandage 1979','IC 5105',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150422,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150422,33.77,0.45,56.9,71491,NULL,NULL,'K','IC 5105',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150423,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150423,34.33,0.4,73.5,71491,NULL,NULL,'mean','IC 5105',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150424,'FP','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,'R',150424,36.49,0.46,199,71492,70,NULL,NULL,'2MASX J21242340+0034586',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000126,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,321.097375,0.58297,0.141,NULL,52101781199,814090331,12720161,17.6),(150425,'FP','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150425,35.74,0.62,140,71493,70,NULL,NULL,'2MASX J21242596-1131109',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000067,NULL,'16.61',0.31,NULL,NULL,NULL,NULL,NULL,1,321.108166667,-11.51983,0.189,NULL,50771398061,793303094,12395360,16.61),(150426,'FP','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150426,35.07,0.47,103,71494,70,NULL,NULL,'ESO 236- G 008',NULL,'2014MNRAS.445.2677S',2014,1,1.3,'RC3 gives v = 10,600 +/- 190 km/sec.','G',0.000083,NULL,'13.8r',1.1,'(R_1R\'_2)SB(s)b',NULL,NULL,NULL,NULL,1,321.109625,-49.28022,0,NULL,50612334498,790817726,12356526,13.8),(150427,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 15553',NULL,150427,40.19,0.2,1090,71495,70,NULL,'SN photometric redshift distance, z photo =0.297 +/- 0.034','SDSS-II SN 15553',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,321.120125,0.94417,0.165,NULL,52136173764,814627715,12728558,NULL),(150428,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 15553','R',150428,41.18,0.21,1290,71495,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15553',0.335192,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150429,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 15553','R',150429,41.27,0.28,1340,71495,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15553',0.335192,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150430,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 15553',NULL,150430,41.48,0.17,1980,71495,70,NULL,'SALT 2','SDSS-II SN 15553',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150431,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 15553',NULL,150431,41.52,0.17,2010,71495,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15553',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150432,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 06885','RN',150432,38.63,0.43,507,71496,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06885',0.049457,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150433,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150433,35.77,0.34,142,71497,NULL,NULL,'Malmquist cor.','ESO 342- G 040',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.6r',0.4,'Sb-c',NULL,NULL,NULL,NULL,1,321.14525,-37.40028,0.169,NULL,51488294666,804504604,12570384,14.6),(150434,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150434,35.97,0.31,156,71497,NULL,NULL,NULL,'ESO 342- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150435,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150435,36.01,0.2,159,71497,74.4,NULL,NULL,'ESO 342- G 040',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150436,'FP','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150436,36.83,0.86,233,71498,70,NULL,NULL,'2MASX J21243550-1930093',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'15.3r',0.37,NULL,NULL,NULL,NULL,NULL,1,321.147875,-19.50264,0.125,NULL,50919639426,795619366,12431552,15.3),(150437,'FP','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,'R',150437,38.42,0.46,483,71499,70,NULL,NULL,'2MASX J21243636-0819429',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000099,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,321.1515,-8.32861,0.257,NULL,49687686259,776370097,12130782,18),(150438,'FP','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150438,35.77,0.63,143,71500,70,NULL,NULL,'2MASX J21243856-2007013',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.1r',0.2,'S',NULL,NULL,NULL,NULL,1,321.1607083,-20.117,0.121,NULL,50922759023,795668109,12432314,15.1),(150439,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 17908','RN',150439,40.52,0.25,1030,71501,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17908',0.233889,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150440,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 17908','N',150440,40.4,0.16,1200,71501,70,NULL,'SALT 2','SDSS-II SN 17908',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150441,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 17908','RN',150441,40.87,0.22,1210,71501,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17908',0.233889,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150442,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 17908','N',150442,40.41,0.16,1210,71501,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 17908',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150443,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 02483','RN',150443,41.47,0.3,1680,71502,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02483',0.173699,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150444,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15669',NULL,150444,40.92,0.49,1530,71503,70,NULL,'SN photometric redshift distance, z photo =0.453 +/- 0.167','SDSS-II SN 15669',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,321.2040417,0.39083,0.141,NULL,52101810449,814090788,12720168,NULL),(150445,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150445,36.42,0.73,192,71504,70,NULL,NULL,'2MASX J21245057-5923577',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'15.1r',0.36,NULL,NULL,NULL,NULL,NULL,1,321.210875,-59.39933,0.073,NULL,49178306066,768411032,12006422,15.1),(150446,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005iy',NULL,150446,41.2,0.21,1240,71505,74.2,NULL,'SALT 2','SDSS J212451.96+002303.3',0.404,'2010ApJ...716..712A',2010,1,0.05,NULL,'G',0.0005,NULL,'21.2g',0.04,NULL,NULL,NULL,NULL,NULL,1,321.2165417,0.38425,0.141,NULL,52101808670,814090760,12720168,21.2),(150447,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005iy',NULL,150447,40.96,0.22,1550,71505,70,NULL,'Hubble residual 0.22 for z0.40430','SDSS J212451.96+002303.3',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150448,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005iy',NULL,150448,42,0.26,1790,71505,70,NULL,'SALT 2','SDSS J212451.96+002303.3',0.404,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150449,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06777','R',150449,42.02,0.3,1810,71505,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005iy','SDSS J212451.96+002303.3',0.4043,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150450,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06777','R',150450,42.19,0.38,1950,71505,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005iy','SDSS J212451.96+002303.3',0.4043,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150451,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07258','R',150451,40.92,0.16,1220,71506,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J212455.14-005955.3',0.2546,'2014arXiv1401.3317S',2014,1,0.1,NULL,'G',0.0005,NULL,'20.2g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,321.2297917,-0.99869,0.137,NULL,49715736956,776808389,12137631,20.2),(150452,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07258','R',150452,41.14,0.25,1350,71506,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J212455.14-005955.3',0.2546,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150453,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07258',NULL,150453,40.84,0.13,1470,71506,70,NULL,'SALT 2','SDSS J212455.14-005955.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150454,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07258',NULL,150454,40.86,0.13,1490,71506,70,NULL,'SALT 2, Malmquist cor.','SDSS J212455.14-005955.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150455,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150455,33.96,0.47,62.1,71507,70,NULL,NULL,'NGC 7057',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00005,NULL,'12.60',1,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,321.244583,-42.46044,0.081,NULL,51371655633,802682119,12541908,12.6),(150456,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150456,36.06,0.52,163,71508,70,NULL,NULL,'2MASX J21250052-1848013',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000073,NULL,'14.9r',0.43,'S0',NULL,NULL,NULL,NULL,1,321.2522083,-18.80044,0.125,NULL,50919617835,795619028,12431547,14.9),(150457,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20541','RN',150457,41.99,0.25,1880,71509,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20541',0.333022,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150458,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20541','RN',150458,42.58,0.28,2460,71509,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20541',0.333022,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150459,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21496','RN',150459,43.57,0.33,3260,71510,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 21496',0.588037,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150460,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150460,34.63,0.54,84.4,71511,NULL,NULL,'Malmquist cor.','ESO 342- G 041',NULL,'2009ApJS..182..474S',2009,1,0.93,NULL,'G',0.000033,NULL,'17.7b',0.52,'S...',NULL,NULL,NULL,NULL,1,321.260541667,-39.82275,0.061,NULL,51474844599,804294446,12567100,17.7),(150461,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150461,34.69,0.53,86.7,71511,NULL,NULL,NULL,'ESO 342- G 041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150462,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150462,34.73,0.2,88.3,71511,74.4,NULL,NULL,'ESO 342- G 041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150463,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 12841','R',150463,40.83,0.32,1130,71512,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006gk','SN 2006gk',0.293488,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,321.34725,-1.03367,0.137,NULL,49715714841,776808044,12137625,NULL),(150464,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 12841','R',150464,41.1,0.31,1280,71512,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006gk','SN 2006gk',0.293488,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150465,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01688',NULL,150465,40.61,0.2,975,71513,74.2,NULL,'SALT 2','SDSS J212525.50+001931.5',0.3587,'2010ApJ...716..712A',2010,1,NULL,NULL,'*',NULL,NULL,'22.6g',NULL,'Point Src [SDSS]',NULL,NULL,NULL,NULL,1,321.356291667,0.32542,0.141,NULL,52102605553,814103211,12720362,22.6),(150466,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01688',NULL,150466,40.55,0.23,1290,71513,70,NULL,'Hubble residual 0.02 for z0.35870','SDSS J212525.50+001931.5',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150467,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01688','R',150467,41.35,0.26,1370,71513,70,NULL,'SDSS CAND. SNIa; MLCS2K2','SDSS J212525.50+001931.5',0.359161,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150468,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01688',NULL,150468,41.38,0.26,1390,71513,65,NULL,'SALT2','SDSS J212525.50+001931.5',0.3587,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150469,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01688','R',150469,41.4,0.32,1400,71513,70,NULL,'SDSS CAND. SNIa; SALT 2','SDSS J212525.50+001931.5',0.359161,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150470,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01688',NULL,150470,41.53,0.24,1490,71513,70,NULL,'SALT 2','SDSS J212525.50+001931.5',0.3587,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150471,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01688',NULL,150471,41.67,0.18,1590,71513,65,NULL,'MLCS2k2','SDSS J212525.50+001931.5',0.3587,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150472,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01688',NULL,150472,41.3,0.21,1820,71513,70,NULL,'SALT 2','SDSS J212525.50+001931.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150473,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01688',NULL,150473,41.35,0.21,1860,71513,70,NULL,'SALT 2, Malmquist cor.','SDSS J212525.50+001931.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150474,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 14455',NULL,150474,38.5,0.56,502,71514,70,NULL,'SN photometric redshift distance, z photo =0.125 +/- 0.040','SDSS-II SN 14455',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,321.3627083,0.85133,0.125,NULL,52102294258,814098347,12720286,NULL),(150475,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150475,36.76,0.46,225,71515,70,NULL,NULL,'2MASX J21252868+0944237',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,321.369417,9.74003,0.129,NULL,55048294885,860129607,13439525,17),(150476,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150476,36.62,0.69,211,71516,70,NULL,NULL,'2MASX J21252881-4236597',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.8r',0.42,'E',NULL,NULL,NULL,NULL,1,321.369958333,-42.61661,0.077,NULL,51371666841,802682294,12541910,14.8),(150477,'IRAS','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150477,34.01,0.8,63.5,71517,75,NULL,'MAT, I','IC 5105A',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000027,NULL,'13.47',1.4,'SAB(rs)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,321.37825,-40.27414,0.061,NULL,51356334780,802442730,12538167,13.47),(150478,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150478,33.21,0.32,43.9,71517,85,NULL,'I, raw','IC 5105A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150479,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150479,33.25,0.32,44.7,71517,85,NULL,'I, inv','IC 5105A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150480,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150480,33.36,0.43,46.9,71517,75,NULL,'MAT, I, raw','IC 5105A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150481,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150481,33.48,NULL,49.7,71517,NULL,NULL,'I','IC 5105A',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150482,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150482,33.56,0.43,51.5,71517,75,NULL,'MAT, I, inv','IC 5105A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150483,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150483,33.57,NULL,51.7,71517,NULL,NULL,'B','IC 5105A',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150484,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150484,33.73,0.43,55.6,71517,75,NULL,'MAT, I, cor','IC 5105A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150485,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150485,33.86,0.47,59.1,71517,NULL,NULL,'H','IC 5105A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150486,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150486,33.92,0.46,60.8,71517,NULL,NULL,'J','IC 5105A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150487,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150487,33.96,0.45,61.9,71517,NULL,NULL,'K','IC 5105A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150488,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150488,34.15,0.4,67.6,71517,NULL,NULL,'mean','IC 5105A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150489,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150489,35.66,0.54,135,71518,70,NULL,NULL,'ESO 287- G 019',NULL,'2014MNRAS.445.2677S',2014,1,1.23,NULL,'G',0.00015,NULL,'14.2r',0.32,'(R)SB0^+',NULL,NULL,NULL,NULL,1,321.387,-42.69569,0.069,NULL,51371698826,802682794,12541918,14.2),(150490,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150490,37.5,0.46,316,71519,70,NULL,NULL,'2MASX J21253358-0114080',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000133,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,321.3900417,-1.23553,0.185,NULL,49715852849,776810200,12137659,17.4),(150491,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15670','RN',150491,45.03,0.29,7890,71520,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 15670',0.284422,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150492,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15670','RN',150492,45.94,0.32,12000,71520,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 15670',0.284422,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150493,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 17539','RN',150493,41.33,0.19,1530,71521,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 17539',0.205939,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150494,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 17539','RN',150494,42.05,0.24,2130,71521,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 17539',0.205939,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150495,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150495,37.05,0.46,258,71522,70,NULL,NULL,'2MASX J21254204+1112598',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,321.425167,11.21653,0.253,NULL,55050184057,860159125,13439986,17.1),(150496,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150496,36.21,NULL,175,71523,NULL,NULL,NULL,'ESO 342- G 044',NULL,'2000BSAO...50....5K',2000,1,1.14,NULL,'G',0.00004,'?','17.01',0.11,'Scd',NULL,NULL,NULL,NULL,1,321.437917,-40.12444,0.061,NULL,51474694561,804292102,12567064,17.01),(150497,'Magnitude','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150497,36.68,0.13,217,71524,100,NULL,NULL,'SARS 320.67665-34.94768',NULL,'1998A&A...337...31R',1998,1,NULL,NULL,'G',0.000157,NULL,'15.48',NULL,'E',NULL,NULL,NULL,NULL,1,321.439375,-34.73122,0.169,NULL,51480138260,804377160,12568393,15.48),(150498,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150498,35.58,0.2,131,71525,74.4,NULL,NULL,'ESO 402- G 028',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000027,NULL,'13.8r',0.5,'SB(r)a',NULL,NULL,NULL,NULL,1,321.440958333,-34.07725,0.217,NULL,51447643494,803869429,12560459,13.8),(150499,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150499,35.62,0.39,133,71525,NULL,NULL,NULL,'ESO 402- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150500,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150500,35.64,0.38,134,71525,NULL,NULL,'Malmquist cor.','ESO 402- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150501,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150501,35.24,0.5,112,71526,70,NULL,NULL,'2MASX J21254656-5452136',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'14.3r',0.43,'S0',NULL,NULL,NULL,NULL,1,321.4440417,-54.87044,0.113,NULL,48667799130,760434361,11881786,14.3),(150502,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06560',NULL,150502,40,0.62,1000,71527,70,NULL,'SN photometric redshift distance, z photo =0.269 +/- 0.110','SDSS-II SN 06560',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,321.446541667,0.84972,0.125,NULL,52102263501,814097867,12720279,NULL),(150503,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06560',NULL,150503,40.12,0.28,1060,71527,70,NULL,NULL,'SDSS-II SN 06560',NULL,'2013MNRAS.434.1443X',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150504,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06560','R',150504,40.83,0.21,1150,71527,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06560',0.273265,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150505,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06560',NULL,150505,40.67,0.18,1360,71527,70,NULL,'SALT 2','SDSS-II SN 06560',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150506,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06560',NULL,150506,40.7,0.18,1380,71527,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 06560',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150507,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06560','R',150507,41.23,0.24,1390,71527,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06560',0.273265,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150508,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150508,35.83,0.6,147,71528,70,NULL,NULL,'2MASX J21255348-0951455',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.00015,NULL,'16.09',0.45,NULL,NULL,NULL,NULL,NULL,1,321.47275,-9.86264,0.197,NULL,50769000628,793265634,12394775,16.09),(150509,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150509,33.44,0.48,48.7,71529,70,NULL,NULL,'NGC 7060',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.00008,NULL,'13.74',0.9,'(R\'_1)SB(rs)ab LLAGN','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,321.47325,-42.41128,0.085,NULL,51370960112,802671251,12541738,13.74),(150510,'Magnitude','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150510,36.68,0.13,217,71530,100,NULL,NULL,'ABELL 3764',NULL,'1998A&A...337...31R',1998,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III [BM];RI [A]',NULL,NULL,NULL,NULL,1,321.479583,-34.72444,0.169,NULL,51479077873,804360591,12568134,NULL),(150511,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150511,35.81,0.53,145,71531,70,NULL,NULL,'MCG -02-54-008',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.0001,NULL,'15.5',0.4,NULL,NULL,NULL,NULL,NULL,1,321.4889583,-9.03206,0.161,NULL,49686783265,776355988,12130562,15.5),(150512,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20046',NULL,150512,39.77,0.32,901,71532,70,NULL,'SN photometric redshift distance, z photo =0.238 +/- 0.044','SDSS-II SN 20046',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,321.493167,0.80122,0.125,NULL,52102254442,814097725,12720276,NULL),(150513,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20046','R',150513,40.75,0.22,1120,71532,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20046',0.263952,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150514,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20046','R',150514,40.75,0.14,1120,71532,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20046',0.263952,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150515,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20046',NULL,150515,40.66,0.12,1360,71532,70,NULL,'SALT 2','SDSS-II SN 20046',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150516,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20046',NULL,150516,40.69,0.12,1370,71532,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20046',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150517,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150517,33.37,0.43,47.1,71533,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-54-016',NULL,'2014MNRAS.444..527S',2014,1,1.51,NULL,'G',0.00001,NULL,'15',0.13,'Sdm',NULL,NULL,NULL,NULL,1,321.49925,-3.80989,0.161,NULL,49726973032,776983953,12140374,15),(150518,'IRAS','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150518,32.21,0.8,27.6,71534,75,NULL,'MAT, I','IC 5105B',NULL,'1997ApJS..109..333W',1997,1,1.39,NULL,'G',0.000027,NULL,'13.71',0.39,'SB(rs)ab:',NULL,NULL,NULL,NULL,1,321.501083333,-40.83478,0.073,NULL,51356178344,802440286,12538129,13.71),(150519,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150519,31.14,0.32,16.9,71534,85,NULL,'I, inv','IC 5105B',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150520,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150520,31.16,0.32,17.1,71534,85,NULL,'I, raw','IC 5105B',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150521,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150521,31.73,0.4,22.2,71534,NULL,NULL,NULL,'IC 5105B',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150522,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150522,31.73,0.39,22.2,71534,73,NULL,'opt','IC 5105B',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150523,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150523,31.79,0.43,22.8,71534,75,NULL,'MAT, I, raw','IC 5105B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150524,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150524,31.82,0.43,23.1,71534,75,NULL,'MAT, I, inv','IC 5105B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150525,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150525,31.93,0.47,24.3,71534,NULL,NULL,'H','IC 5105B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150526,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150526,32.01,0.45,25.3,71534,NULL,NULL,'K','IC 5105B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150527,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150527,32.02,0.46,25.4,71534,NULL,NULL,'J','IC 5105B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150528,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150528,32.15,0.43,26.9,71534,75,NULL,'MAT, I, cor','IC 5105B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150529,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150529,32.2,0.09,27.6,71534,NULL,NULL,NULL,'IC 5105B',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150530,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150530,32.35,0.4,29.5,71534,NULL,NULL,'mean','IC 5105B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150531,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16739',NULL,150531,39.17,0.58,681,71535,70,NULL,'SN photometric redshift distance, z photo =0.174 +/- 0.061','SDSS-II SN 16739',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','22.0g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,321.50875,-1.05314,0.185,NULL,49698797116,776543704,12133495,22),(150532,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16739','R',150532,40.9,0.22,1190,71535,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16739',0.265638,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150533,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16739','R',150533,40.96,0.12,1230,71535,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16739',0.265638,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150534,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16739',NULL,150534,40.78,0.11,1430,71535,70,NULL,'SALT 2','SDSS-II SN 16739',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150535,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16739',NULL,150535,40.81,0.11,1450,71535,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16739',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150536,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 19045','RN',150536,41.64,0.18,1950,71536,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 19045',0.09247,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150537,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 19045','RN',150537,42.01,0.3,2310,71536,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 19045',0.09247,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150538,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150538,37.51,0.21,318,71537,70,NULL,NULL,'2MASX J21260500-0715345',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000103,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,321.520875,-7.25958,0.305,NULL,49688971372,776390177,12131096,17.2),(150539,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150539,37.51,0.21,318,71538,70,NULL,NULL,'2MASX J21260641-0713265',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000096,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,321.526833333,-7.22389,0.305,NULL,49688972514,776390195,12131096,17.3),(150540,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150540,34.54,0.49,81,71539,75,NULL,'IR','UGC 11740',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.00012,NULL,'14.49',0.5,'S?',NULL,NULL,NULL,NULL,1,321.559833333,9.79792,0.161,NULL,55048355597,860130556,13439539,14.49),(150541,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150541,34.58,0.2,82.4,71539,74.4,NULL,NULL,'UGC 11740',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150542,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150542,34.58,0.4,82.5,71539,NULL,NULL,'Malmquist cor.','UGC 11740',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150543,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150543,34.63,0.39,84.2,71539,NULL,NULL,NULL,'UGC 11740',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150544,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150544,37.51,0.21,318,71540,70,NULL,NULL,'2MASX J21261566-0656269',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000078,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,321.5652083,-6.94083,0.289,NULL,49688516003,776383062,12130985,17.5),(150545,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01595','R',150545,39.84,0.2,765,71541,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01595',0.2136,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,321.567875,-0.55406,0.145,NULL,49699332168,776552065,12133626,NULL),(150546,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01595','R',150546,40.01,0.12,828,71541,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01595',0.2136,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150547,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150547,37.51,0.21,318,71542,70,NULL,NULL,'SDSS J212617.43-071100.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000078,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,321.572667,-7.18342,0.305,NULL,49688497256,776382769,12130980,18.4),(150548,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150548,37.9,0.46,380,71543,70,NULL,NULL,'SDSS J212619.79+100352.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00015,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,321.5825,10.06461,0.125,NULL,55049141637,860142838,13439731,18.7),(150549,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150549,36.23,0.46,176,71544,70,NULL,NULL,'2MASX J21261995-0045166',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000167,NULL,'16.1g',0.33,'S0',NULL,NULL,NULL,NULL,1,321.583,-0.75469,0.145,NULL,49699128926,776548889,12133576,16.1),(150550,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150550,37.58,0.46,328,71545,70,NULL,NULL,'SDSS J212622.87+103824.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000146,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,321.5952917,10.64014,0.209,NULL,55048931654,860139557,13439680,18),(150551,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150551,37.71,0.46,348,71546,70,NULL,NULL,'2MASX J21262386+1046389',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,321.5995,10.77753,0.209,NULL,55050110620,860157978,13439968,17.1),(150552,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150552,38.05,0.46,407,71547,70,NULL,NULL,'2MASX J21262581-0727089',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000107,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,321.6075417,-7.45242,0.297,NULL,49688922407,776389412,12131084,18.1),(150553,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150553,38.12,0.46,420,71548,70,NULL,NULL,'2MASX J21263122+1145169',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,321.629875,11.75469,0.257,NULL,55049975653,860155869,13439935,17.5),(150554,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07357',NULL,150554,40.68,0.38,1370,71549,70,NULL,'SN photometric redshift distance, z photo =0.392 +/- 0.099','SDSS-II SN 07357',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,321.635875,-0.36267,0.137,NULL,49699032765,776547386,12133552,NULL),(150555,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07357',NULL,150555,41.91,0.19,2410,71549,70,NULL,'SALT 2','SDSS-II SN 07357',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150556,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07357',NULL,150556,42.08,0.19,2610,71549,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 07357',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150557,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150557,37.19,0.46,274,71550,70,NULL,NULL,'2MASX J21263399-0816598',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00008,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,321.641625,-8.28333,0.165,NULL,49687177140,776362142,12130658,17.1),(150558,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150558,36.78,0.46,227,71551,70,NULL,NULL,'2MASX J21263987+0018299',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000192,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,321.666125,0.30836,0.141,NULL,52102118839,814095606,12720243,16.5),(150559,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150559,37.54,0.27,322,71552,70,NULL,NULL,'2MASX J21264033+1134278',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000145,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,321.667958333,11.57439,0.257,NULL,55049893099,860154579,13439915,17.5),(150560,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150560,37.51,0.21,318,71553,70,NULL,NULL,'2MASX J21264167-0716098',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000089,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,321.67375,-7.26939,0.305,NULL,49688381642,776380963,12130952,17.2),(150561,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 13334','R',150561,40.54,0.27,1030,71554,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13334',0.24571,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,321.6770417,0.39447,0.113,NULL,52101990336,814093599,12720212,NULL),(150562,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 13334','R',150562,40.68,0.23,1100,71554,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13334',0.24571,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150563,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150563,33.56,0.6,51.6,71555,70,NULL,NULL,'NGC 7065',NULL,'2014MNRAS.445.2677S',2014,1,1,'Star superposed 5.0 arcsec southwest of the nucleus.','G',0.00015,NULL,'13.1R',0.9,'SB(r)ab?','in a pair',NULL,NULL,NULL,1,321.677125,-6.99492,0.289,NULL,49688558527,776383726,12130995,13.1),(150564,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150564,35.38,0.47,119,71556,70,NULL,NULL,'ESO 599- G 012',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000093,NULL,'14.68',0.8,'SBc            LINER',NULL,NULL,NULL,NULL,1,321.6810417,-21.833,0.097,NULL,50912569870,795508904,12429826,14.68),(150565,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07550','RN',150565,41.03,0.23,1380,71557,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07550',0.16237,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150566,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07550','RN',150566,41.16,0.29,1470,71557,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07550',0.16237,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150567,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150567,37.54,0.27,322,71558,70,NULL,NULL,'2MASX J21264913+1140052',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000171,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,321.70475,11.66811,0.257,NULL,55049916620,860154947,13439921,17),(150568,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150568,36.87,0.54,237,71559,70,NULL,NULL,'2MASX J21265176-1901356',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'15.7r',0.21,NULL,NULL,NULL,NULL,NULL,1,321.715833,-19.02669,0.121,NULL,50922282129,795660658,12432197,15.7),(150569,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150569,37.77,0.46,358,71560,70,NULL,NULL,'2MASX J21265268+1124342',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000174,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,321.719625,11.40939,0.233,NULL,55050010049,860156407,13439943,17),(150570,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150570,37.62,0.46,335,71561,70,NULL,NULL,'2MASX J21265882-0636139',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000075,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,321.745,-6.604,0.221,NULL,49688705041,776386016,12131031,17.4),(150571,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150571,37.87,0.46,374,71562,70,NULL,NULL,'2MASX J21270180-0733529',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000097,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,321.757583,-7.56461,0.297,NULL,49688886646,776388853,12131075,17.3),(150572,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150572,37.33,0.46,292,71563,70,NULL,NULL,'SDSS J212707.71-064917.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000087,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,321.782125,-6.82158,0.221,NULL,49688712667,776386135,12131033,17.6),(150573,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01285',NULL,150573,40.46,0.23,1230,71564,70,NULL,'SN photometric redshift distance, z photo =0.345 +/- 0.048','SDSS-II SN 01285',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','20.5g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,321.783458333,0.54311,0.165,NULL,52102033335,814094270,12720222,20.5),(150574,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150574,37.54,0.27,322,71565,70,NULL,NULL,'2MASX J21270845+1137262',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,321.785167,11.624,0.249,NULL,55049897660,860154650,13439916,17.6),(150575,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 13731','RN',150575,42.28,0.44,1960,71566,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13731',0.458686,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150576,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150576,37.67,0.46,342,71567,70,NULL,NULL,'2MASX J21271273+1044382',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,321.803167,10.74397,0.209,NULL,55049592528,860149883,13439841,17.2),(150577,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15640','RN',150577,40.44,0.12,1050,71568,70,NULL,'SDSS CAND. SNIa?; MLCS2K2','SDSS-II SN 15640',0.1664,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150578,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15640','RN',150578,40.46,0.2,1060,71568,70,NULL,'SDSS CAND. SNIa?; SALT 2','SDSS-II SN 15640',0.1664,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150579,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150579,37.41,0.46,303,71569,70,NULL,NULL,'2MASX J21271429+1049202',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,321.809583,10.82242,0.253,NULL,55049646960,860150733,13439855,17.3),(150580,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150580,38.72,0.46,556,71570,70,NULL,NULL,'2MASX J21271999+1200108',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,321.833375,12.00314,0.309,NULL,55046338099,860099032,13439047,17.9),(150581,'IRAS','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150581,31.57,0.8,20.6,71571,75,NULL,'MAT, I','NGC 7059',NULL,'1997ApJS..109..333W',1997,1,3.5,NULL,'G',0.00001,NULL,'12.35',1.7,'SAB(s)c pec',NULL,NULL,NULL,NULL,1,321.839458333,-60.01458,0.057,NULL,49161852372,768153943,12002405,12.35),(150582,'IRAS','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150582,31.6,0.8,20.9,71571,75,NULL,'A82, H','NGC 7059',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150583,'Sosies','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150583,31.13,0.35,16.8,71571,NULL,NULL,NULL,'NGC 7059',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150584,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150584,31.54,0.37,20.3,71571,NULL,NULL,NULL,'NGC 7059',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150585,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150585,31.54,0.4,20.3,71571,73,NULL,'opt','NGC 7059',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150586,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150586,31.57,0.43,20.6,71571,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7059',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150587,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150587,31.66,0.4,21.5,71571,75,NULL,'B','NGC 7059',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150588,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150588,32.16,0.43,27,71571,75,NULL,'3.6 micron, color corrected','NGC 7059',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150589,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150589,32.26,0.4,28.3,71571,NULL,NULL,'mean','NGC 7059',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150590,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150590,32.72,0.2,35,71571,74.4,NULL,NULL,'NGC 7059',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150591,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150591,32.83,0.47,36.8,71571,75,NULL,'A82, H, raw','NGC 7059',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150592,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150592,32.88,0.46,37.6,71571,NULL,NULL,'J','NGC 7059',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150593,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150593,32.94,0.47,38.7,71571,NULL,NULL,'H','NGC 7059',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150594,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150594,32.94,0.47,38.8,71571,75,NULL,'A82, H, inv','NGC 7059',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150595,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150595,32.96,0.45,39.1,71571,NULL,NULL,'K','NGC 7059',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150596,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150596,33.04,0.47,40.6,71571,75,NULL,'A82, H, cor','NGC 7059',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150597,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150597,33.14,0.32,42.5,71571,85,NULL,'I, raw','NGC 7059',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150598,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150598,33.17,0.32,43,71571,85,NULL,'I, inv','NGC 7059',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150599,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150599,33.22,0.43,44.1,71571,75,NULL,'MAT, I, raw','NGC 7059',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150600,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150600,33.31,0.43,45.9,71571,75,NULL,'MAT, I, cor','NGC 7059',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150601,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150601,33.35,0.43,46.8,71571,75,NULL,'MAT, I, inv','NGC 7059',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150602,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150602,36.24,0.58,177,71572,70,NULL,NULL,'LCRS B212406.2-453559',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.00015,NULL,'14.0r',0.48,'E',NULL,NULL,NULL,NULL,1,321.844167,-45.38175,0.017,NULL,51367268924,802613576,12540837,14),(150603,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150603,35.21,0.46,110,71573,70,NULL,NULL,'NGC 7061',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.12',0.7,'E+4','Pair member (points to parent)',NULL,NULL,NULL,1,321.861875,-49.0635,0,NULL,50609186582,790768540,12355758,14.12),(150604,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 03494','RN',150604,39.87,0.08,798,71574,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03494',0.178742,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150605,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 03494','RN',150605,40.59,0.19,1110,71574,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03494',0.178742,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150606,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150606,37.31,0.46,289,71575,70,NULL,NULL,'2MASX J21273114-0032498',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000137,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,321.879667,-0.54728,0.169,NULL,49699021134,776547205,12133550,17.6),(150607,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150607,35.48,0.59,125,71576,70,NULL,NULL,'IC 1381',NULL,'2014MNRAS.445.2677S',2014,1,1.01,NULL,'G',0.000043,NULL,'15.0g',0.59,'Sab',NULL,NULL,NULL,NULL,1,321.890416667,-1.18861,0.185,NULL,49702204902,776596951,12134327,15),(150608,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150608,38.21,0.46,439,71577,70,NULL,NULL,'SDSS J212738.35+114436.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,321.909833,11.74358,0.293,NULL,55049877071,860154329,13439911,18.5),(150609,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150609,32.99,0.47,39.6,71578,NULL,NULL,'H','UGC 11748',NULL,'2007A&A...465...71T',2007,1,1.4,'abs(b) < 10 degrees.','G',NULL,NULL,'17.',0.5,'S',NULL,NULL,NULL,NULL,1,321.915541667,45.483,NULL,NULL,55674506035,869914156,13592408,17),(150610,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150610,33.13,0.45,42.3,71578,NULL,NULL,'K','UGC 11748',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150611,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150611,33.37,0.46,47.3,71578,NULL,NULL,'J','UGC 11748',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150612,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150612,33.97,0.4,62.2,71578,NULL,NULL,'mean','UGC 11748',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150613,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150613,36.01,0.46,159,71579,70,NULL,NULL,'2MASX J21274330+1206248',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000161,NULL,'16.5g',0.28,'E0',NULL,NULL,NULL,NULL,1,321.930583,12.10675,0.317,NULL,55046360199,860099378,13439052,16.5),(150614,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150614,34.75,0.46,89,71580,70,NULL,NULL,'KAZ 522',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000146,NULL,'15.9g',0.4,'S0',NULL,NULL,NULL,NULL,1,321.9397083,0.32642,0.165,NULL,52101926719,814092604,12720196,15.9),(150615,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150615,37.94,0.46,387,71581,70,NULL,NULL,'2MASX J21275196+1209192',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000147,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,321.966416667,12.15539,0.317,NULL,55046350983,860099234,13439050,17.7),(150616,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150616,35.49,0.57,125,71582,70,NULL,NULL,'2MFGC 16240',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.00015,NULL,'15.90',0.22,NULL,NULL,NULL,NULL,NULL,1,321.9722917,-11.30669,0.153,NULL,50771845967,793310093,12395470,15.9),(150617,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150617,38.09,0.33,415,71583,70,NULL,NULL,'2MASX J21275991+1035339',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,321.999583,10.59269,0.141,NULL,55048512880,860133013,13439578,18),(150618,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150618,34.82,0.69,92,71584,100,NULL,'mid-IR','CGCG 426-057',NULL,'2013ApJ...771...88L',2013,1,0.6,NULL,'G',NULL,NULL,'15.6',0.4,NULL,NULL,NULL,NULL,NULL,1,322.0087917,12.74642,0.277,NULL,55264835269,863513051,13492391,15.6),(150619,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150619,38.09,0.33,415,71585,70,NULL,NULL,'2MASX J21280337+1050118',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000175,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,322.014125,10.83672,0.137,NULL,55049607443,860150116,13439845,18.3),(150620,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150620,34.64,0.47,84.9,71586,70,NULL,NULL,'NGC 7069',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000143,NULL,'14.36',0.9,'SAB(s)0-?     LINER?',NULL,NULL,NULL,NULL,1,322.0244583,-1.64686,0.173,NULL,49699925880,776561341,12133770,14.36),(150621,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150621,38.51,0.46,503,71587,70,NULL,NULL,'2MASX J21280795+1113508',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,322.033083333,11.23072,0.233,NULL,55049578042,860149656,13439838,17.8),(150622,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','PTF10trp','N',150622,36.64,0.03,203,71588,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10trp',0.0489,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150623,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150623,37.56,0.23,325,71589,70,NULL,NULL,'2MASX J21280934+1114577',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000179,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,322.0389583,11.24931,0.233,NULL,55049580185,860149690,13439838,17.8),(150624,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150624,36.32,0.46,184,71590,70,NULL,NULL,'MCG +00-54-020',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.00013,NULL,'15.1g',0.5,NULL,NULL,NULL,NULL,NULL,1,322.048583,0.29992,0.165,NULL,52105360291,814146254,12721035,15.1),(150625,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150625,37.9,0.33,380,71591,70,NULL,NULL,'2MASX J21281190+1152504',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000176,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,322.049667,11.88083,0.293,NULL,55046543704,860102245,13439097,17.6),(150626,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150626,33.79,0.66,57.3,71592,NULL,NULL,'Malmquist cor.','IC 5107',NULL,'2009ApJS..182..474S',2009,1,1.09,NULL,'G',0.000033,NULL,'14.64',0.39,'S...',NULL,NULL,NULL,NULL,1,322.062041667,-65.73553,0.009,NULL,49355274017,771176156,12049627,14.64),(150627,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150627,34.17,0.55,68.2,71592,NULL,NULL,NULL,'IC 5107',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150628,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150628,34.21,0.2,69.5,71592,74.4,NULL,NULL,'IC 5107',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150629,'IRAS','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150629,32.61,0.8,33.2,71593,75,NULL,'MAT, I','ESO 342- G 050',NULL,'1997ApJS..109..333W',1997,1,2.2,'Confused HIPASS source','G',0.000023,NULL,'12.88',1.2,'SA(rs)c pec?',NULL,NULL,NULL,NULL,1,322.0627083,-37.86131,0.121,NULL,51487730707,804495792,12570246,12.88),(150630,'Tully est','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150630,32.58,0.8,32.8,71593,75,NULL,'B','ESO 342- G 050',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150631,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150631,31.85,0.4,23.4,71593,NULL,NULL,NULL,'ESO 342- G 050',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150632,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150632,31.85,0.4,23.4,71593,73,NULL,'opt','ESO 342- G 050',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150633,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150633,32.05,0.32,25.7,71593,85,NULL,'I, raw','ESO 342- G 050',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150634,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150634,32.07,0.32,26,71593,85,NULL,'I, inv','ESO 342- G 050',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150635,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150635,32.19,0.43,27.5,71593,75,NULL,'3.6 micron, color + selection bias corrected','ESO 342- G 050',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150636,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150636,32.24,0.43,28.1,71593,75,NULL,'3.6 micron, color corrected','ESO 342- G 050',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150637,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150637,32.3,0.43,28.8,71593,75,NULL,'MAT, I, raw','ESO 342- G 050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150638,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150638,32.31,0.2,29,71593,74.4,NULL,NULL,'ESO 342- G 050',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150639,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150639,32.35,NULL,29.5,71593,NULL,NULL,'I','ESO 342- G 050',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150640,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150640,32.44,0.43,30.7,71593,75,NULL,'MAT, I, inv','ESO 342- G 050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150641,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150641,32.45,0.47,30.9,71593,NULL,NULL,'H','ESO 342- G 050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150642,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150642,32.46,0.46,31,71593,NULL,NULL,'J','ESO 342- G 050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150643,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150643,32.49,0.45,31.5,71593,NULL,NULL,'K','ESO 342- G 050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150644,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150644,32.53,0.43,32.1,71593,75,NULL,'MAT, I, cor','ESO 342- G 050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150645,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150645,32.71,0.1,34.9,71593,NULL,NULL,NULL,'ESO 342- G 050',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150646,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150646,32.72,NULL,35,71593,NULL,NULL,'B','ESO 342- G 050',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150647,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150647,32.83,0.4,36.8,71593,NULL,NULL,'mean','ESO 342- G 050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150648,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150648,36.86,0.16,219,71594,74.2,NULL,'SALT 2','[WM92] 212426.8-614612',0.075,'2010ApJ...716..712A',2010,1,1.1,NULL,'G',0.002,NULL,'17.43',0.9,'E1?',NULL,NULL,NULL,NULL,1,322.073125,-61.55178,0.085,NULL,49170464662,768288510,12004507,17.43),(150649,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150649,37.48,0.23,291,71594,72,NULL,NULL,'[WM92] 212426.8-614612',0.075,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150650,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150650,37.5,0.19,294,71594,70,NULL,'SALT 2','[WM92] 212426.8-614612',0.075,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150651,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150651,37.57,0.2,303,71594,73.8,NULL,'SALT 2 (SNANA)','[WM92] 212426.8-614612',0.0746,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150652,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150652,37.57,0.15,304,71594,65,NULL,'SALT2','[WM92] 212426.8-614612',0.075,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150653,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150653,37.73,0.17,304,71594,65,NULL,'MLCS2k2','[WM92] 212426.8-614612',0.075,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150654,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150654,37.43,0.08,306,71594,74.4,NULL,NULL,'[WM92] 212426.8-614612',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150655,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150655,37.61,0.04,309,71594,72,NULL,NULL,'[WM92] 212426.8-614612',0.075,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150656,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150656,37.64,0.05,314,71594,70,NULL,NULL,'[WM92] 212426.8-614612',0.075,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150657,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150657,37.65,0.05,315,71594,70,NULL,'SALT 2','[WM92] 212426.8-614612',0.075,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150658,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150658,37.67,0.15,318,71594,70,NULL,'SALT','[WM92] 212426.8-614612',0.075,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150659,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150659,37.71,0.19,325,71594,65,NULL,'MLCS17','[WM92] 212426.8-614612',0.075,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150660,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150660,37.72,0.22,325,71594,65,NULL,'MLCS31','[WM92] 212426.8-614612',0.075,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150661,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150661,37.72,0.18,325,71594,65,NULL,'SALT2','[WM92] 212426.8-614612',0.075,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150662,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150662,37.72,0.19,326,71594,65,NULL,'MLCS2k2','[WM92] 212426.8-614612',0.075,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150663,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150663,37.58,0.12,328,71594,70.8,NULL,NULL,'[WM92] 212426.8-614612',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150664,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150664,37.76,0.11,332,71594,65,NULL,'MLCS2k2','[WM92] 212426.8-614612',0.075,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150665,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150665,37.77,0.19,333,71594,65,NULL,NULL,'[WM92] 212426.8-614612',0.075,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150666,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150666,37.77,0.19,333,71594,65,NULL,'Template','[WM92] 212426.8-614612',0.075,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150667,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150667,37.8,0.06,337,71594,65,NULL,'MLCS','[WM92] 212426.8-614612',0.075,'1996ApJ...473..588R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150668,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150668,37.8,0.17,338,71594,65,NULL,'MLCS','[WM92] 212426.8-614612',0.075,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150669,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150669,37.83,0.13,343,71594,65,NULL,'SALT','[WM92] 212426.8-614612',0.075,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150670,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150670,37.68,0.09,344,71594,65,NULL,'LCS','[WM92] 212426.8-614612',NULL,'1995ApJ...445L..91R',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150671,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150671,37.71,0.14,348,71594,60,NULL,NULL,'[WM92] 212426.8-614612',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150672,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150672,37.88,0.03,351,71594,65,NULL,'SALT','[WM92] 212426.8-614612',0.075,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150673,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150673,37.79,0.09,361,71594,65,NULL,'Snapshot','[WM92] 212426.8-614612',NULL,'1996ApJ...473...88R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150674,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150674,37.8,0.08,363,71594,60,NULL,'M(V) = -19.47 mag','[WM92] 212426.8-614612',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150675,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150675,37.86,0.12,373,71594,60,NULL,'M(B) = -19.48 mag','[WM92] 212426.8-614612',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150676,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21055','RN',150676,38.13,0.18,403,71595,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 05611 HOST',0.050284,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150677,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 05611','RN',150677,38.22,0.28,420,71595,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05611 HOST',0.050284,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150678,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07783','RN',150678,38.62,0.34,504,71595,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05611 HOST',0.050284,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150679,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21055','RN',150679,39.47,0.34,746,71595,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 05611 HOST',0.050284,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150680,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01108','RN',150680,42.12,0.22,1870,71596,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01108',0.422703,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150681,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01108','RN',150681,43.98,0.29,4390,71596,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01108',0.422703,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150682,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150682,37.91,0.46,382,71597,70,NULL,NULL,'SDSS J212823.87-070814.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000074,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,322.0995,-7.13736,0.181,NULL,49690378190,776412159,12131439,18.8),(150683,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150683,37.9,0.33,380,71598,70,NULL,NULL,'2MASX J21282504+1152087',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,322.10425,11.86897,0.293,NULL,55046542197,860102221,13439097,17.6),(150684,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150684,36.83,0.33,233,71599,70,NULL,NULL,'SDSS J212826.69+011339.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000147,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,322.11125,1.22772,0.157,NULL,52105264065,814144751,12721011,17.9),(150685,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150685,36.83,0.33,233,71600,70,NULL,NULL,'2MASX J21282861+0109514',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'17.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,322.119167,1.16431,0.157,NULL,52105252222,814144565,12721008,17.1),(150686,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150686,37.86,0.46,374,71601,70,NULL,NULL,'2MASX J21282902+0958327',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000199,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,322.121083,9.97583,0.145,NULL,55048539807,860133434,13439584,16.9),(150687,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 04910','RN',150687,40.19,0.44,957,71602,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04910',0.137796,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150688,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 04910','RN',150688,40.75,0.34,1240,71602,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04910',0.137796,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150689,'GRB','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150689,47.04,0.68,5330,71603,69.7,NULL,'Calibrated','GRB 060605',3.8,'2009MNRAS.400..775C',2009,1,NULL,NULL,'VisS',0.001,NULL,'15.2R',NULL,'Swift',NULL,NULL,NULL,NULL,1,322.155458333,-6.05858,0.177,NULL,49724524823,776945700,12139776,15.2),(150690,'GRB','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150690,47.07,0.81,5400,71603,NULL,NULL,NULL,'GRB 060605',3.8,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150691,'GRB','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150691,47.11,0.73,5510,71603,72,NULL,NULL,'GRB 060605',3.8,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150692,'GRB','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150692,47.21,0.72,5760,71603,70,NULL,NULL,'GRB 060605',3.8,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150693,'GRB','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150693,47.66,0.57,7090,71603,69.7,NULL,'Fiducial','GRB 060605',3.8,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150694,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006eq',NULL,150694,36.54,0.1,185,71604,72,NULL,NULL,'2MASX J21283758+0113490',0.04839,'2013ApJ...773...53F',2013,1,0.38,NULL,'G',0.000059,NULL,'17.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,322.156667,1.23017,0.145,NULL,52105218913,814144045,12721000,17.3),(150695,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006eq',NULL,150695,36.54,0.02,194,71604,72,NULL,NULL,'2MASX J21283758+0113490',0.049509,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150696,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006eq',NULL,150696,36.48,0.1,198,71604,74.4,NULL,NULL,'2MASX J21283758+0113490',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150697,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006eq',NULL,150697,36.66,0.15,205,71604,70,NULL,'SALT 2','2MASX J21283758+0113490',0.049509,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150698,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006eq',NULL,150698,36.57,0.02,206,71604,72,NULL,NULL,'2MASX J21283758+0113490',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150699,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 12780','R',150699,36.73,0.2,212,71604,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006eq','2MASX J21283758+0113490',0.049509,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150700,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006eq',NULL,150700,36.88,0.29,238,71604,72,NULL,'M(H) = -18.317 mag','2MASX J21283758+0113490',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150701,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 12780','R',150701,37.28,0.11,273,71604,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006eq','2MASX J21283758+0113490',0.049509,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150702,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 18408','R',150702,38.47,0.05,475,71605,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2007lj','SDSS J212841.86-000401.0',0.04,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',NULL,NULL,'20.8g',0.07,NULL,NULL,NULL,NULL,NULL,1,322.1744583,-0.06694,0.153,NULL,49700678526,776573101,12133954,20.8),(150703,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 18408','R',150703,39.05,0.19,620,71605,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2007lj','SDSS J212841.86-000401.0',0.04,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150704,'SNII optical','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2007lj',NULL,150704,36.6,0.09,201,71605,NULL,NULL,'SCM 55 SNII','SDSS J212841.86-000401.0',0.04,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150705,'SNII optical','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2007lj',NULL,150705,36.91,0.11,231,71605,NULL,NULL,'SCM 15 SDSS SNII','SDSS J212841.86-000401.0',0.04,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150706,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06146','RN',150706,42.24,0.15,2080,71606,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 06146',0.34785,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150707,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06146','RN',150707,42.27,0.29,2110,71606,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 06146',0.34785,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150708,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150708,34.91,0.55,96,71607,70,NULL,NULL,'ESO 075- G 010',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'14.7r',0.34,'S0',NULL,NULL,NULL,NULL,1,322.182833,-67.37564,0.021,NULL,49385371330,771646427,12056975,14.7),(150709,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 19205',NULL,150709,40.1,0.2,1050,71608,70,NULL,'SN photometric redshift distance, z photo =0.284 +/- 0.033','SDSS-II SN 19205',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,322.186083,-0.84681,0.169,NULL,49702287304,776598239,12134347,NULL),(150710,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 19205','R',150710,41.15,0.13,1270,71608,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19205',0.3346,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150711,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 19205','R',150711,41.23,0.22,1320,71608,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19205',0.3346,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150712,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150712,37.5,0.46,316,71609,70,NULL,NULL,'2MASX J21284543+1045204',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,322.1895,10.75569,0.137,NULL,55049489203,860148268,13439816,17.3),(150713,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150713,34.74,0.56,88.7,71610,70,NULL,NULL,'2MASX J21284802-4523044',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.000133,NULL,'15.21',0.63,'E',NULL,NULL,NULL,NULL,1,322.200083333,-45.38458,0.017,NULL,51367161819,802611903,12540810,15.21),(150714,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 13297','RN',150714,40.74,0.26,1170,71611,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13297',0.202806,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150715,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 13297','RN',150715,41.57,0.37,1710,71611,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13297',0.202806,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150716,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 08363','RN',150716,38.24,0.27,408,71612,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08363',0.088257,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150717,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 08363','RN',150717,38.95,0.44,567,71612,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 08363',0.088257,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150718,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150718,37.32,0.46,291,71613,70,NULL,NULL,'2MASX J21285604-0728330',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000086,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,322.2335,-7.47572,0.189,NULL,49690418961,776412796,12131449,17.4),(150719,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150719,37.14,0.46,268,71614,70,NULL,NULL,'2MASX J21290054+1203419',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000159,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,322.25225,12.06181,0.273,NULL,55046529874,860102029,13439094,17.2),(150720,'IRAS','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150720,30.11,0.8,10.5,71615,75,NULL,'MAT, I','NGC 7064',NULL,'1997ApJS..109..333W',1997,1,3.8,NULL,'G',0.00001,NULL,'13.1',0.6,'SB(s)c? sp',NULL,NULL,NULL,NULL,1,322.262417,-52.76761,0,NULL,50615255720,790863370,12357240,13.1),(150721,'Tully est','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150721,30.14,0.8,10.6,71615,75,NULL,'B','NGC 7064',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150722,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150722,30,0.32,10,71615,85,NULL,'I, inv','NGC 7064',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150723,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150723,30.04,0.32,10.2,71615,85,NULL,'I, raw','NGC 7064',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150724,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150724,30.06,0.36,10.3,71615,NULL,NULL,NULL,'NGC 7064',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150725,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150725,30.06,0.4,10.3,71615,73,NULL,'opt','NGC 7064',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150726,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150726,30.21,0.2,11,71615,74.4,NULL,NULL,'NGC 7064',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150727,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150727,30.27,0.43,11.3,71615,75,NULL,'MAT, I, inv','NGC 7064',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150728,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150728,30.3,0.43,11.5,71615,75,NULL,'3.6 micron, color corrected','NGC 7064',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150729,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150729,30.32,0.43,11.6,71615,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7064',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150730,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150730,30.35,0.43,11.7,71615,75,NULL,'MAT, I, raw','NGC 7064',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150731,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150731,30.69,0.43,13.7,71615,75,NULL,'MAT, I, cor','NGC 7064',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150732,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150732,36.51,0.46,201,71616,70,NULL,NULL,'2MASX J21290678+1011454',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000146,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,322.278166667,10.19592,0.133,NULL,55048562646,860133791,13439590,16.6),(150733,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150733,35.85,0.49,148,71617,75,NULL,'IR','UGC 11750',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000113,NULL,'16.0',0.3,'S',NULL,NULL,NULL,NULL,1,322.284833333,2.79989,0.225,NULL,52136335770,814630246,12728597,16),(150734,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150734,36.45,0.46,195,71618,70,NULL,NULL,'2MASX J21291105+1031370',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,322.296125,10.52706,0.137,NULL,55048454839,860132106,13439564,16.5),(150735,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150735,35.06,0.57,103,71619,70,NULL,NULL,'2MASX J21291249-0037185',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.7g',0.32,'E0',NULL,NULL,NULL,NULL,1,322.302166667,-0.62175,0.165,NULL,49701890307,776592036,12134250,15.7),(150736,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150736,35.24,0.27,112,71619,70,NULL,NULL,'2MASX J21291249-0037185',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150737,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150737,37.56,0.23,325,71620,70,NULL,NULL,'SDSS J212913.10+111448.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000126,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,322.304583,11.24686,0.221,NULL,55046725975,860105093,13439142,18.4),(150738,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01631','RN',150738,40.23,0.15,973,71621,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01631',0.14415,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150739,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01631','RN',150739,40.53,0.21,1120,71621,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01631',0.14415,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150740,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 03134','RN',150740,42.1,0.23,1910,71622,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03134',0.373435,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150741,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 03134','RN',150741,42.72,0.15,2550,71622,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03134',0.373435,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150742,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150742,36.39,0.53,189,71623,70,NULL,NULL,'2MASX J21291683-5119020',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'14.9r',0.43,'S',NULL,NULL,NULL,NULL,1,322.320125,-51.31725,0,NULL,50613136507,790830257,12356722,14.9),(150743,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2007jl',NULL,150743,39.9,0.11,955,71624,70,NULL,'Hubble residual 0.00 for z0.25420','SDSS-II SN 17552 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,322.32125,-1.00283,0.177,NULL,49702496806,776601512,12134398,NULL),(150744,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 17552','R',150744,40.62,0.21,1060,71624,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007jl','SDSS-II SN 17552 HOST',0.253291,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150745,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 17552','R',150745,40.68,0.15,1090,71624,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007jl','SDSS-II SN 17552 HOST',0.253291,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150746,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2007jl',NULL,150746,40.52,0.12,1270,71624,70,NULL,'SALT 2','SDSS-II SN 17552 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150747,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2007jl',NULL,150747,40.54,0.12,1280,71624,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 17552 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150748,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150748,37.56,0.23,325,71625,70,NULL,NULL,'2MASX J21291856+1112040',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000199,NULL,'16.2g',0.39,'E0',NULL,NULL,NULL,NULL,1,322.3275417,11.20094,0.221,NULL,55046726823,860105106,13439142,16.2),(150749,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150749,38.26,0.46,449,71626,70,NULL,NULL,'2MASX J21292504+1145420',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,322.354291667,11.76178,0.273,NULL,55046865970,860107280,13439176,18.1),(150750,'SZ effect','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150750,40.19,NULL,1090,71627,NULL,NULL,'4.2 (black) calibration','MACS J2129.4-0741',NULL,'2010ApJ...721..653R',2010,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,322.359208333,-7.69061,0.189,NULL,49693747765,776464808,12132262,NULL),(150751,'SZ effect','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150751,40.23,NULL,1110,71627,NULL,NULL,'3.1 (red) calibration','MACS J2129.4-0741',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150752,'SZ effect','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150752,40.4,NULL,1200,71627,NULL,NULL,'4.1 (blue) calibration','MACS J2129.4-0741',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150753,'SZ effect','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150753,40.43,0.56,1220,71627,NULL,NULL,'Isotherm., r < 100 kpc','MACS J2129.4-0741',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150754,'SZ effect','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150754,40.62,0.56,1330,71627,NULL,NULL,'Hydrost. Eq.','MACS J2129.4-0741',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150755,'SZ effect','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150755,40.72,0.56,1390,71627,NULL,NULL,'Isotherm.','MACS J2129.4-0741',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150756,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15554','RN',150756,43.09,0.28,2760,71628,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15554',0.499308,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150757,'BCG','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150757,38.9,0.35,538,71629,60,NULL,'ABELL 2347, BCG','2MASX J21293166-2212142',0.1196,'1980ApJ...241..486H',1980,1,0.41,NULL,'G',NULL,NULL,'15.7r',0.26,NULL,'Brightest group member',NULL,NULL,NULL,1,322.382,-22.20397,0.089,NULL,50925379183,795709049,12432953,15.7),(150758,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150758,37.1,0.46,263,71630,70,NULL,NULL,'2MASX J21293175+0102116',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00014,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,322.382375,1.03661,0.117,NULL,52105784416,814152881,12721138,16.9),(150759,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150759,37.56,0.23,325,71631,70,NULL,NULL,'2MASX J21293229+1117370',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,322.384541667,11.29367,0.221,NULL,55046759494,860105617,13439150,17.7),(150760,'BCG','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150760,38.9,0.35,538,71632,60,NULL,NULL,'ABELL 2347',0.1196,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III:   [BM]',NULL,NULL,NULL,NULL,1,322.386083,-22.21383,0.089,NULL,50925379268,795709051,12432953,NULL),(150761,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150761,37.88,0.46,377,71633,70,NULL,NULL,'SDSS J212933.36-001429.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000116,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,322.389041667,-0.24153,0.153,NULL,49700914729,776576792,12134012,17.9),(150762,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150762,36.98,0.46,249,71634,70,NULL,NULL,'2MASX J21293399+0001357',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,322.391583333,0.02667,0.157,NULL,52103447469,814116366,12720568,17.1),(150763,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150763,35.61,0.67,133,71635,70,NULL,NULL,'2MASX J21293459-7907318',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,322.394,-79.12544,0.533,NULL,48576962077,759015032,11859609,16.5),(150764,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150764,36.08,0.46,165,71636,70,NULL,NULL,'2MASX J21293539-0016142',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000144,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,322.397583333,-0.27075,0.153,NULL,49700907133,776576673,12134010,16.7),(150765,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150765,35.39,0.46,120,71637,70,NULL,NULL,'IC 1386',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.0001,NULL,'14.04',0.9,'SA0-:',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,322.4059583,-21.19569,0.101,NULL,50933677428,795838709,12434979,14.04),(150766,'SZ effect','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150766,38.31,0.48,460,71638,NULL,NULL,'Hydrost. Eq.','MaxBCG J322.41649+00.08920',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,322.407875,0.09406,0.157,NULL,52103447808,814116372,12720568,NULL),(150767,'SZ effect','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150767,38.74,0.75,560,71638,NULL,NULL,'Isotherm., r < 100 kpc','MaxBCG J322.41649+00.08920',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150768,'SZ effect','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150768,39.4,0.71,760,71638,NULL,NULL,'Isotherm.','MaxBCG J322.41649+00.08920',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150769,'SZ effect','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150769,39.97,NULL,988,71638,NULL,NULL,'4.2 (black) calibration','MaxBCG J322.41649+00.08920',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150770,'SZ effect','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150770,40.06,NULL,1030,71638,NULL,NULL,'3.1 (red) calibration','MaxBCG J322.41649+00.08920',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150771,'SZ effect','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150771,40.06,NULL,1030,71638,NULL,NULL,'4.1 (blue) calibration','MaxBCG J322.41649+00.08920',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150772,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 11172',NULL,150772,39.03,0.21,640,71639,70,NULL,NULL,'SDSS J212939.01-001207.9',NULL,'2013MNRAS.434.1443X',2013,1,0.16,NULL,'G',NULL,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,322.412583333,-0.20219,0.153,NULL,49700916116,776576814,12134012,18.6),(150773,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 11172','R',150773,39.39,0.21,665,71639,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J212939.01-001207.9',0.136329,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150774,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 11172','R',150774,39.64,0.15,747,71639,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J212939.01-001207.9',0.136329,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150775,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 11172',NULL,150775,39.17,0.1,682,71640,70,NULL,'SALT 2','SDSS J212939.01-001207.9',NULL,'2013ApJ...763...88C',2013,1,0.16,NULL,'G',NULL,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,322.412583333,-0.20219,0.153,NULL,49700916116,776576814,12134012,18.6),(150776,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 11172',NULL,150776,39.18,0.1,685,71640,70,NULL,'SALT 2, Malmquist cor.','SDSS J212939.01-001207.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150777,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150777,36.5,0.6,199,71641,70,NULL,NULL,'2MASX J21293971-0608214',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'17.11',0.2,NULL,NULL,NULL,NULL,NULL,1,322.415417,-6.13936,0.165,NULL,49682619739,776290933,12129545,17.11),(150778,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150778,37.91,0.46,381,71642,70,NULL,NULL,'2MASX J21294185-0831444',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000089,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,322.424417,-8.52906,0.121,NULL,49691302489,776426601,12131665,17.2),(150779,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150779,38.51,0.46,504,71643,70,NULL,NULL,'SDSS J212942.37+114602.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000177,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,322.4265417,11.76739,0.273,NULL,55046867673,860107307,13439176,17.9),(150780,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20144','R',150780,40.05,0.21,839,71644,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ql','SN 2007ql',0.22,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,322.431917,0.44461,0.113,NULL,52103377661,814115275,12720551,NULL),(150781,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20144','R',150781,40.31,0.13,947,71644,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ql','SN 2007ql',0.22,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150782,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150782,36.66,0.46,215,71645,70,NULL,NULL,'2MASX J21294683+1011242',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000148,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,322.44525,10.18997,0.133,NULL,52111842505,814247539,12722617,17.3),(150783,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150783,36.44,0.46,195,71646,70,NULL,NULL,'2MASX J21294778-0815394',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000089,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,322.449125,-8.26103,0.117,NULL,49693661470,776463460,12132241,16.5),(150784,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150784,35.24,0.27,112,71647,70,NULL,NULL,'2MASX J21294846-0018492',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000155,NULL,'15.8g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,322.451917,-0.31356,0.153,NULL,49700920710,776576886,12134013,15.8),(150785,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150785,34.93,0.51,97.1,71648,70,NULL,NULL,'IC 1388',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.000087,NULL,'15.0',0.2,NULL,NULL,NULL,NULL,NULL,1,322.467417,-0.63128,0.141,NULL,49701854670,776591479,12134241,15),(150786,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150786,35.24,0.27,112,71648,70,NULL,NULL,'IC 1388',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150787,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150787,37.39,0.46,300,71649,70,NULL,NULL,'2MASX J21295427+1014382',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,322.47625,10.24411,0.125,NULL,52111851154,814247674,12722619,17.6),(150788,'Tully est','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150788,30.62,0.8,13.3,71650,75,NULL,'B','NGC 7077',NULL,'1988NBGC.C....0000T',1988,1,0.8,NULL,'G',0.000017,NULL,'14.14',0.7,'BCD/E          HII',NULL,NULL,NULL,NULL,1,322.498375,2.41417,0.165,NULL,52103869822,814122965,12720671,14.14),(150789,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150789,31.18,0.39,17.2,71650,73,NULL,'opt','NGC 7077',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150790,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150790,36.28,0.46,181,71651,70,NULL,NULL,'2MASX J21300156-0113512',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'16.56',0.44,NULL,NULL,NULL,NULL,NULL,1,322.5064583,-1.23094,0.177,NULL,49701619612,776587806,12134184,16.56),(150791,'Ring Diameter','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150791,33.1,0.84,41,71652,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7080',NULL,'1981ApJS...45..541P',1981,1,1.8,NULL,'G',0.000017,NULL,'13.13',1.7,'SB(r)b',NULL,NULL,NULL,NULL,1,322.508125,26.71781,0.425,NULL,55607673248,868869894,13576092,13.13),(150792,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16452','RN',150792,39.96,0.23,815,71653,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 16452',0.206111,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150793,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16452','RN',150793,40.09,0.21,862,71653,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 16452',0.206111,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150794,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150794,35.46,0.67,124,71654,70,NULL,NULL,'MCG -01-54-019',NULL,'2014MNRAS.445.2677S',2014,1,1.26,NULL,'G',0.00008,NULL,'14.8g',0.44,'Sc',NULL,NULL,NULL,NULL,1,322.559291667,-8.06697,0.121,NULL,49694084724,776470073,12132344,14.8),(150795,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150795,36.62,0.46,211,71655,70,NULL,NULL,'2MASX J21301492+0041103',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000144,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,322.562167,0.68611,0.117,NULL,52103351498,814114867,12720544,17.3),(150796,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20435',NULL,150796,38.33,0.79,464,71656,70,NULL,'SN photometric redshift distance, z photo =0.115 +/- 0.055','SDSS-II SN 20435',NULL,'2011ApJ...738..162S',2011,1,0.03,NULL,'G',NULL,'PHOT','22.8g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,322.565917,0.55872,0.161,NULL,52103405155,814115705,12720557,22.8),(150797,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20435','R',150797,41.23,0.23,1320,71656,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20435',0.340192,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150798,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20435','R',150798,41.35,0.32,1390,71656,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20435',0.340192,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150799,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20435',NULL,150799,41.39,0.2,1900,71656,70,NULL,'SALT 2','SDSS-II SN 20435',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150800,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20435',NULL,150800,41.44,0.2,1940,71656,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20435',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150801,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150801,37.9,0.46,381,71657,70,NULL,NULL,'2MASX J21301891-0641351',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000093,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,322.578875,-6.69325,0.129,NULL,49690108328,776407942,12131374,17.5),(150802,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 19490',NULL,150802,39.28,0.83,717,71658,70,NULL,'SN photometric redshift distance, z photo =0.184 +/- 0.100','SDSS-II SN 19490',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,322.579917,-0.55125,0.137,NULL,49700790913,776574858,12133982,NULL),(150803,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150803,36.91,0.46,241,71659,70,NULL,NULL,'2MASX J21302216-0725461',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000098,NULL,'16.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,322.59225,-7.42942,0.085,NULL,49690764091,776418188,12131534,16.5),(150804,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150804,37.08,0.61,260,71660,70,NULL,NULL,'2MASX J21302318-5126212',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'15.6r',0.23,NULL,NULL,NULL,NULL,NULL,1,322.596667,-51.43925,0,NULL,50613488842,790835763,12356808,15.6),(150805,'Tully est','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150805,32.41,0.8,30.3,71661,75,NULL,'B','NGC 7070',NULL,'1988NBGC.C....0000T',1988,1,2.3,NULL,'G',0.000017,NULL,'12.80',1.8,'SB(s)c','in a pair',NULL,NULL,NULL,1,322.605625,-43.08711,0.033,NULL,51369678384,802651224,12541425,12.8),(150806,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150806,34.69,0.48,86.8,71662,70,NULL,NULL,'2MASX J21302824-6344352',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.00015,NULL,'14.2r',0.45,'S0',NULL,NULL,NULL,NULL,1,322.617541667,-63.74308,0.049,NULL,49166834713,768231792,12003621,14.2),(150807,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150807,37.79,0.46,361,71663,70,NULL,NULL,'2MASX J21302906+0100262',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000146,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,322.6212083,1.00739,0.121,NULL,52104984843,814140388,12720943,17.2),(150808,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150808,37.13,0.21,267,71664,70,NULL,NULL,'SDSS J213031.80+102837.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000165,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,322.6325,10.47711,0.145,NULL,52111661048,814244703,12722573,18.3),(150809,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150809,37.13,0.21,267,71665,70,NULL,NULL,'2MASX J21303261+1036216',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000182,NULL,'16.1g',0.37,'E0',NULL,NULL,NULL,NULL,1,322.635916667,10.60617,0.145,NULL,52111607158,814243861,12722560,16.1),(150810,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16439',NULL,150810,40.17,0.31,1080,71666,70,NULL,'SN photometric redshift distance, z photo =0.294 +/- 0.056','SDSS-II SN 16439',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.0g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,322.639625,-0.84303,0.141,NULL,49701061789,776579090,12134048,21),(150811,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16439','R',150811,41.42,0.25,1380,71666,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16439',0.396513,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150812,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16439','R',150812,41.7,0.31,1570,71666,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16439',0.396513,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150813,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16439',NULL,150813,41.55,0.2,2040,71666,70,NULL,'SALT 2','SDSS-II SN 16439',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150814,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16439',NULL,150814,41.61,0.2,2100,71666,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16439',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150815,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150815,34.64,NULL,84.8,71667,NULL,NULL,NULL,'ESO 403- G 003',NULL,'2000BSAO...50....5K',2000,1,1.51,'SGC printed catalog incorrectly lists R.A. as 21h37.3m; tape version correct.','G',0.00002,NULL,'14.4r',0.2,'Sbc            HII',NULL,NULL,NULL,NULL,1,322.642625,-33.65017,0.133,NULL,51451306716,803926667,12561354,14.4),(150816,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150816,34.68,0.49,86.3,71667,75,NULL,'IR','ESO 403- G 003',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150817,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150817,35.13,NULL,106,71667,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 403- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150818,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150818,35.16,NULL,108,71667,NULL,NULL,'Dipole + Quadrupole','ESO 403- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150819,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150819,35.19,NULL,109,71667,NULL,NULL,'Dipole','ESO 403- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150820,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150820,35.33,0.6,116,71667,NULL,NULL,NULL,'ESO 403- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150821,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150821,35.33,0.2,116,71667,74.4,NULL,NULL,'ESO 403- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150822,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150822,35.36,0.59,118,71667,NULL,NULL,'Malmquist cor.','ESO 403- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150823,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 17615','RN',150823,42.86,0.21,2390,71668,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17615',0.563169,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150824,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150824,36.27,0.59,179,71669,70,NULL,NULL,'2MASX J21303822-1232192',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'17.18',0.24,NULL,NULL,NULL,NULL,NULL,1,322.659333,-12.53858,0.193,NULL,50953373842,796146466,12439788,17.18),(150825,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150825,37.13,0.21,267,71670,70,NULL,NULL,'2MASX J21304204+1036299',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000195,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,322.67525,10.60825,0.145,NULL,52111608766,814243886,12722560,16.8),(150826,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150826,37.07,0.87,259,71671,70,NULL,NULL,'2MASX J21304237-5515161',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.000137,NULL,'15.1r',0.28,'S',NULL,NULL,NULL,NULL,1,322.676667,-55.25458,0.141,NULL,48668188317,760440442,11881881,15.1),(150827,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150827,37.13,0.21,267,71672,70,NULL,NULL,'2MASX J21304442+1041269',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,322.6849583,10.69081,0.145,NULL,52110295125,814223361,12722240,17),(150828,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150828,36.72,0.46,221,71673,70,NULL,NULL,'2MASX J21304658-0750079',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000088,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,322.6940417,-7.83544,0.073,NULL,49693905394,776467271,12132301,16.6),(150829,'GRB','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150829,41.46,NULL,1960,71674,70,NULL,'Pseudo z = 0.64','GRB 030823',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,322.695833,21.98333,0.321,NULL,55156276263,861816816,13465887,NULL),(150830,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16768','R',150830,38.97,0.28,531,71675,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 16768',0.168949,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,322.7005417,0.69283,0.205,NULL,52103490484,814117038,12720578,NULL),(150831,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16768','R',150831,39.19,0.21,589,71675,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 16768',0.168949,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150832,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 09148','RN',150832,42.54,0.24,2230,71676,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 09148',0.450222,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150833,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150833,37.13,0.21,267,71677,70,NULL,NULL,'SDSS J213048.58+103442.3',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,322.7024583,10.57842,0.145,NULL,52113709907,814276717,12723073,17.3),(150834,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150834,36.22,0.49,176,71678,70,NULL,NULL,'FAIRALL 0972',NULL,'2014MNRAS.445.2677S',2014,1,0.97,NULL,'G',0.000133,NULL,'14.0r',0.68,'E',NULL,NULL,NULL,NULL,1,322.7249583,-51.42253,0,NULL,50613680761,790838761,12356855,14),(150835,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01632','R',150835,39.03,0.07,605,71679,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01632',0.057524,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,322.725958333,-0.13394,0.157,NULL,49701329714,776583276,12134113,NULL),(150836,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01632','R',150836,39.79,0.2,857,71679,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01632',0.057524,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150837,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150837,38.64,0.46,535,71680,70,NULL,NULL,'SDSS J213056.06+112406.8',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000132,NULL,'19.0g',0.09,NULL,NULL,NULL,NULL,NULL,1,322.733625,11.40189,0.233,NULL,55046653691,860103963,13439124,19),(150838,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15531','RN',150838,41.82,0.25,1890,71681,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15531',0.227575,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150839,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15531','RN',150839,42.42,0.33,2490,71681,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15531',0.227575,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150840,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150840,36.38,0.2,189,71682,74.4,NULL,NULL,'IC 5115',NULL,'2013AJ....146...86T',2013,1,0.77,NULL,'G',0.000166,NULL,'15.7g',0.46,'Sbc',NULL,NULL,NULL,NULL,1,322.7387083,11.7635,0.245,NULL,55047088254,860110753,13439230,15.7),(150841,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006ev',NULL,150841,35.08,0.18,101,71683,74.2,NULL,'SALT 2','UGC 11758',0.0276,'2010ApJ...716..712A',2010,1,1.74,NULL,'G',0.000015,NULL,'15.31',0.24,'Sbc',NULL,NULL,NULL,NULL,1,322.740083,13.98608,0.293,NULL,55132305040,861442266,13460035,15.31),(150842,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006ev',NULL,150842,35.5,0.1,119,71683,72,NULL,NULL,'UGC 11758',0.02762,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150843,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006ev',NULL,150843,35.68,0.14,133,71683,73.8,NULL,'SALT 2 (SNANA)','UGC 11758',0.0277,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150844,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006ev',NULL,150844,35.72,0.19,135,71683,70,NULL,'SALT 2','UGC 11758',0.0276,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150845,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006ev',NULL,150845,35.66,0.1,136,71683,74.4,NULL,NULL,'UGC 11758',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150846,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006ev',NULL,150846,35.66,0.07,136,71683,72,NULL,'M(H) = -18.317 mag','UGC 11758',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150847,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150847,35.21,NULL,110,71683,NULL,NULL,NULL,'UGC 11758',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150848,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150848,35.33,NULL,116,71683,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11758',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150849,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150849,35.34,0.47,117,71683,NULL,NULL,'H','UGC 11758',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150850,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150850,35.35,NULL,118,71683,NULL,NULL,'Dipole + Quadrupole','UGC 11758',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150851,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150851,35.38,NULL,119,71683,NULL,NULL,'Dipole','UGC 11758',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150852,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150852,35.39,0.45,119,71683,NULL,NULL,'K','UGC 11758',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150853,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150853,35.38,0.49,119,71683,75,NULL,'IR','UGC 11758',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150854,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150854,35.41,0.4,121,71683,NULL,NULL,'mean','UGC 11758',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150855,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150855,35.44,0.46,122,71683,NULL,NULL,'J','UGC 11758',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150856,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150856,36.19,0.43,173,71683,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11758',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150857,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150857,37.32,0.46,291,71684,70,NULL,NULL,'2MASX J21310349-0034340',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00015,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,322.7645417,-0.57622,0.137,NULL,49701241305,776581895,12134092,16.9),(150858,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150858,37.02,0.46,254,71685,70,NULL,NULL,'2MASX J21310778+1128267',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000164,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,322.7822917,11.47406,0.233,NULL,55046932466,860108319,13439192,16.9),(150859,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15101',NULL,150859,39.04,0.66,642,71686,70,NULL,'SN photometric redshift distance, z photo =0.163 +/- 0.066','SDSS-II SN 15101',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','20.5g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,322.7850417,-0.48614,0.137,NULL,49701410293,776584535,12134133,20.5),(150860,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15101','R',150860,40.54,0.27,1090,71686,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15101',0.18195,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150861,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15101','R',150861,40.56,0.25,1090,71686,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15101',0.18195,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150862,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150862,34.1,NULL,65.9,71687,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2328',NULL,'2010Ap&SS.325..163P',2010,1,0.76,NULL,'G',0.000011,NULL,'17.3',0.08,'Scd',NULL,NULL,NULL,NULL,1,322.8,3.28028,0.177,NULL,52128944544,814514758,12726793,17.3),(150863,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150863,34.12,NULL,66.6,71687,NULL,NULL,'Dipole + Quadrupole','FGC 2328',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150864,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150864,34.12,NULL,66.6,71687,NULL,NULL,'Dipole','FGC 2328',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150865,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150865,34.23,NULL,70,71687,NULL,NULL,NULL,'FGC 2328',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150866,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005ik',NULL,150866,40.48,0.15,952,71688,74.2,NULL,'SALT 2','SDSS J213115.62-010326.3',0.31,'2010ApJ...716..712A',2010,1,0.07,NULL,'G',NULL,NULL,'21.1g',0.07,NULL,NULL,NULL,NULL,NULL,1,322.815125,-1.05733,0.145,NULL,49701079641,776579369,12134052,21.1),(150867,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005ik',NULL,150867,40.79,0.05,1100,71688,70,NULL,'SDSS 6699','SDSS J213115.62-010326.3',0.31,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150868,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005ik',NULL,150868,41.06,0.19,1250,71688,72,NULL,'SDSS 6699','SDSS J213115.62-010326.3',0.31,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150869,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06699','R',150869,41.19,0.26,1320,71688,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ik','SDSS J213115.62-010326.3',0.31,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150870,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005ik',NULL,150870,41.22,NULL,1340,71688,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 06699, SN 2005ik','SDSS J213115.62-010326.3',0.31,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150871,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005ik',NULL,150871,41.24,0.18,1350,71688,65,NULL,'SALT2','SDSS J213115.62-010326.3',0.31,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150872,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005ik',NULL,150872,41.28,0.18,1380,71688,70,NULL,'SDSS 6699, SALT 2','SDSS J213115.62-010326.3',0.31,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (150873,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06699','R',150873,41.47,0.17,1500,71688,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ik','SDSS J213115.62-010326.3',0.31,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150874,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005ik',NULL,150874,41.48,0.12,1510,71688,65,NULL,'MLCS2k2','SDSS J213115.62-010326.3',0.31,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150875,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150875,35.32,0.61,116,71689,NULL,NULL,NULL,'ESO 465- G 005',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.9r',0.6,'Sb',NULL,NULL,NULL,NULL,1,322.836167,-29.26106,0.145,NULL,51469461328,804210333,12565786,14.9),(150876,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150876,35.36,0.2,118,71689,74.4,NULL,NULL,'ESO 465- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150877,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150877,35.57,0.54,130,71689,NULL,NULL,'Malmquist cor.','ESO 465- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150878,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150878,35.79,0.66,144,71690,70,NULL,NULL,'2MFGC 16267',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.000084,NULL,'16.5g',0.15,'Sb(f)',NULL,NULL,NULL,NULL,1,322.838375,-6.43744,0.121,NULL,49683450323,776303911,12129748,16.5),(150879,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150879,37.96,0.33,391,71691,70,NULL,NULL,'SDSS J213121.55-080438.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000072,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,322.839833,-8.07742,0.121,NULL,49694067491,776469804,12132340,17.6),(150880,'GRB','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'RN',150880,46.04,1.47,5770,71692,NULL,NULL,NULL,'GRB 080514B HOST',1.8,'2010JCAP...08..020W',2010,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150881,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150881,37.96,0.33,391,71693,70,NULL,NULL,'SDSS J213127.38-075948.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000073,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,322.864125,-7.99669,0.073,NULL,49693409370,776459521,12132180,18.5),(150882,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150882,37.19,0.33,274,71694,70,NULL,NULL,'2MASX J21312871+1055167',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,322.869666667,10.92122,0.165,NULL,52110335048,814223985,12722249,17.8),(150883,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150883,37.33,0.46,293,71695,70,NULL,NULL,'2MASX J21312947-0833578',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000093,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,322.872875,-8.56619,0.105,NULL,49693274003,776457406,12132146,16.3),(150884,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150884,37.19,0.33,274,71696,70,NULL,NULL,'2MASX J21313013+1053267',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,322.875625,10.89081,0.165,NULL,52110333716,814223964,12722249,17.3),(150885,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150885,34.53,0.5,80.4,71697,70,NULL,NULL,'2MASX J21313030-5719205',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.000087,NULL,'14.1r',0.48,'S0',NULL,NULL,NULL,NULL,1,322.8762917,-57.32236,0.113,NULL,48661413236,760334581,11880227,14.1),(150886,'D-Sigma','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150886,34.11,0.4,66.3,71698,75,NULL,'Edat, raw','NGC 7075',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000067,NULL,'14.13',0.9,'E+?','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,322.887416667,-38.61792,0.089,NULL,51475843519,804310054,12567344,14.13),(150887,'D-Sigma','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150887,34.44,0.4,77.4,71698,75,NULL,'Edat, cor','NGC 7075',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150888,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150888,34.37,0.4,74.8,71698,NULL,NULL,'mean','NGC 7075',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150889,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150889,34.76,0.45,89.4,71698,NULL,NULL,'K','NGC 7075',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150890,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150890,38.16,0.46,429,71699,70,NULL,NULL,'SDSS J213133.24+110645.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000141,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,322.8885417,11.11256,0.193,NULL,55046803063,860106297,13439160,18.3),(150891,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 18647','R',150891,40.25,0.22,924,71700,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J213134.36-001810.3',0.212839,'2014arXiv1401.3317S',2014,1,0.21,NULL,'G',0.00016,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,322.893167,-0.30289,0.133,NULL,49701368472,776583882,12134123,18.2),(150892,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 18647','R',150892,40.43,0.16,1010,71700,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J213134.36-001810.3',0.212839,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150893,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 18647',NULL,150893,40.06,0.16,1030,71700,70,NULL,'SALT 2','SDSS J213134.36-001810.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150894,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 18647',NULL,150894,40.08,0.16,1040,71700,70,NULL,'SALT 2, Malmquist cor.','SDSS J213134.36-001810.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150895,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150895,35.84,0.57,147,71701,70,NULL,NULL,'ESO 287- G 033',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000024,NULL,'13.7r',1,'SAB(r)bc',NULL,NULL,NULL,NULL,1,322.898667,-46.88742,0.025,NULL,50638773776,791230840,12362981,13.7),(150896,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20574','RN',150896,43.6,0.3,3520,71702,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20574',0.491039,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150897,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150897,36.92,0.58,242,71703,70,NULL,NULL,'2MASX J21313608-1040248',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.81',0.34,NULL,NULL,NULL,NULL,NULL,1,322.900375,-10.67367,0.121,NULL,49680770811,776262043,12129094,16.81),(150898,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150898,35.06,0.46,103,71704,70,NULL,NULL,'CGCG 426-062',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000113,NULL,'14.8g',0.69,'E0',NULL,NULL,NULL,NULL,1,322.9065417,11.83161,0.245,NULL,55047029227,860109831,13439216,14.8),(150899,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150899,38.21,0.46,438,71705,70,NULL,NULL,'2MASX J21314097+1009391',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,322.9207917,10.16094,0.149,NULL,52113827090,814278548,12723102,17.3),(150900,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150900,33.43,0.2,48.5,71706,74.4,NULL,NULL,'CGCG 426-063',NULL,'2013AJ....146...86T',2013,1,0.42,NULL,'G',NULL,NULL,'15.7',0.17,NULL,NULL,NULL,NULL,NULL,1,322.92625,12.47778,0.289,NULL,55264320611,863505009,13492265,15.7),(150901,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150901,36.49,0.69,198,71707,70,NULL,NULL,'2MFGC 16275',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00007,NULL,'15.1r',0.17,'S',NULL,NULL,NULL,NULL,1,322.9285,-68.91244,0.021,NULL,49330152837,770783638,12043494,15.1),(150902,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150902,35.23,0.2,111,71708,74.4,NULL,NULL,'CGCG 376-001',NULL,'2013AJ....146...86T',2013,1,0.81,NULL,'G',0.000133,NULL,'15.5g',0.45,'Sc',NULL,NULL,NULL,NULL,1,322.9287917,0.35781,0.161,NULL,52103563137,814118174,12720596,15.5),(150903,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150903,37,0.46,251,71709,70,NULL,NULL,'2MASX J21314403+1122521',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000178,NULL,'16.9g',0.32,NULL,NULL,NULL,NULL,NULL,1,322.933375,11.38122,0.233,NULL,55046694542,860104602,13439134,16.9),(150904,'GRB','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150904,49.65,1.1,13900,71710,69.7,NULL,'Fiducial','GRB 060522',5.11,'2009MNRAS.400..775C',2009,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,322.936875,2.88633,0.177,NULL,52105897377,814154646,12721166,NULL),(150905,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 11017','R',150905,41.49,0.26,1640,71711,70,NULL,'SDSS CAND. zSNII; MLCS2K2; SN 2005mj','SN 2005mj',0.21,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'IIn?',NULL,NULL,NULL,NULL,1,322.956,-1.06939,0.117,NULL,49701154953,776580546,12134071,NULL),(150906,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 11017','R',150906,42.17,0.41,2240,71711,70,NULL,'SDSS CAND. zSNII; SALT 2; SN 2005mj','SN 2005mj',0.21,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150907,'BL Lac Luminosity','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150907,41.87,NULL,2360,71712,70,NULL,'nucleus-to-host flux ratio, z > 0.86','2MASS J21315152-2515588',NULL,'2006AJ....132....1S',2006,1,NULL,NULL,'QSO',NULL,NULL,'18.0R',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,322.96375,-25.26633,0.133,NULL,51430985956,803609155,12556393,18),(150908,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150908,36.51,0.61,201,71713,70,NULL,NULL,'2MASX J21315150-1110068',NULL,'2014MNRAS.445.2677S',2014,1,0.49,'The APM image includes a faint star or companion.','G',0.00015,NULL,'16.39',0.33,NULL,NULL,NULL,NULL,NULL,1,322.964583,-11.16858,0.141,NULL,50768279025,793254359,12394599,16.39),(150909,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150909,34.46,0.58,77.8,71714,70,NULL,NULL,'ESO 287- G 035',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.38',0.6,'SAB(r)a        LLAGN','in an interacting pair',NULL,NULL,NULL,1,322.969375,-46.05853,0.049,NULL,50638580832,791227825,12362934,14.38),(150910,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150910,35.68,0.46,137,71715,70,NULL,NULL,'2MASX J21315376-0000292',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000145,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,322.974125,-0.00814,0.129,NULL,49700510118,776570470,12133913,16.4),(150911,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150911,37.01,0.55,253,71716,70,NULL,NULL,'2MASX J21315605-6250285',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'14.8r',0.45,NULL,NULL,NULL,NULL,NULL,1,322.9834583,-62.84122,0.049,NULL,49171602275,768306285,12004785,14.8),(150912,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150912,37.31,0.46,290,71717,70,NULL,NULL,'2MASX J21315710-0821018',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000083,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,322.988083,-8.3505,0.089,NULL,49693993313,776468645,12132322,16.9),(150913,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150913,37.7,0.46,347,71718,70,NULL,NULL,'2MASX J21315818-0016272',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00018,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,322.9925417,-0.27419,0.133,NULL,49700502184,776570346,12133911,17.6),(150914,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150914,38.03,0.46,403,71719,70,NULL,NULL,'2MASX J21320101-0045291',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000134,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,323.00425,-0.758,0.137,NULL,49701291187,776582674,12134104,17.2),(150915,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150915,34.89,0.49,94.9,71720,75,NULL,'IR','ESO 465- G 006',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'14.7r',0.3,'(R?)SB0^+:',NULL,NULL,NULL,NULL,1,323.0167083,-30.82189,0.073,NULL,51458975232,804046488,12563226,14.7),(150916,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150916,35.21,0.66,110,71720,NULL,NULL,NULL,'ESO 465- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150917,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150917,35.25,0.65,112,71720,NULL,NULL,'Malmquist cor.','ESO 465- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150918,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150918,35.26,0.2,113,71720,74.4,NULL,NULL,'ESO 465- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150919,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150919,36.7,0.46,219,71721,70,NULL,NULL,'2MASX J21320546-0641013',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000084,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,323.022833,-6.68383,0.085,NULL,49683621479,776306585,12129790,16.8),(150920,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150920,36.73,0.62,222,71722,70,NULL,NULL,'2MASX J21320623-1107443',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'17.09',0.25,NULL,NULL,NULL,NULL,NULL,1,323.0259583,-11.12889,0.141,NULL,49677974117,776218345,12128411,17.09),(150921,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 02064','RN',150921,41.66,0.42,1480,71723,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02064',0.456693,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150922,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150922,37.76,0.46,356,71724,70,NULL,NULL,'SDSS J213208.11+111745.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,323.033791667,11.29589,0.233,NULL,55046692555,860104571,13439133,18.4),(150923,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150923,37.84,0.46,369,71725,70,NULL,NULL,'2MASX J21320925+1049325',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000171,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,323.0385,10.82556,0.161,NULL,52110533894,814227092,12722298,17),(150924,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150924,37.08,0.46,261,71726,70,NULL,NULL,'2MASX J21320952+1036015',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,323.039625,10.60039,0.165,NULL,52113918056,814279969,12723124,17.2),(150925,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 13323','R',150925,40.49,0.21,1010,71727,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13323',0.23262,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,323.051167,-0.13475,0.129,NULL,49700515353,776570552,12133914,NULL),(150926,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 13323','R',150926,40.61,0.14,1080,71727,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13323',0.23262,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150927,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16294','RN',150927,40.7,0.25,1220,71728,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 16294',0.137498,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150928,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16294','RN',150928,42.38,0.42,2630,71728,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 16294',0.137498,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150929,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150929,37.06,0.46,259,71729,70,NULL,NULL,'2MASX J21321338+1017365',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000189,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,323.05575,10.29342,0.169,NULL,52113788445,814277944,12723092,16.4),(150930,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150930,34.04,0.64,64.2,71730,70,NULL,NULL,'ESO 236- G 018',NULL,'2014MNRAS.445.2677S',2014,1,1.45,NULL,'G',0.000133,NULL,'13.7r',0.29,'S0',NULL,NULL,NULL,NULL,1,323.056375,-48.00411,0.025,NULL,50655440235,791491253,12367050,13.7),(150931,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 13768',NULL,150931,39.93,0.14,966,71731,70,NULL,'SN photometric redshift distance, z photo =0.258 +/- 0.020','SDSS-II SN 13768',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,323.0759583,-0.76319,0.133,NULL,49701294688,776582729,12134105,NULL),(150932,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15829',NULL,150932,40.14,0.26,1070,71732,70,NULL,'SN photometric redshift distance, z photo =0.290 +/- 0.045','SDSS-II SN 15829',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,323.0855,-0.76231,0.133,NULL,49701294656,776582729,12134105,NULL),(150933,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15829','R',150933,40.93,0.2,1230,71732,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15829',0.248862,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150934,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15829','R',150934,40.99,0.27,1270,71732,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15829',0.248862,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150935,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15829',NULL,150935,40.9,0.15,1510,71732,70,NULL,'SALT 2','SDSS-II SN 15829',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150936,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15829',NULL,150936,40.92,0.15,1530,71732,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15829',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150937,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 14985','RN',150937,39.26,0.6,653,71733,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 14985',0.088652,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150938,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 14985','RN',150938,39.43,0.4,707,71733,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 14985',0.088652,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150939,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150939,36.54,0.46,203,71734,70,NULL,NULL,'2MASX J21322519+1232508',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000181,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,323.105166667,12.54761,0.293,NULL,55264360770,863505637,13492275,17),(150940,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150940,36.47,0.7,197,71735,70,NULL,NULL,'2MASX J21322541-5149077',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'15.1r',0.48,NULL,NULL,NULL,NULL,NULL,1,323.105875,-51.81875,0,NULL,50613275683,790832432,12356756,15.1),(150941,'Black Hole','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150941,37.61,0.32,333,71736,NULL,NULL,NULL,'UGC 11763',NULL,'2014ApJ...793..108W',2014,1,0.5,NULL,'G',0.0001,NULL,'14.3V',0.2,'(R)Sa          Sy1',NULL,NULL,NULL,'Sy 1.5',1,323.115875,10.13875,0.169,NULL,52114075450,814282428,12723162,14.3),(150942,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150942,35.16,0.58,108,71737,70,NULL,NULL,'FAIRALL 0101',NULL,'2014MNRAS.445.2677S',2014,1,0.31,NULL,'G',0.00015,NULL,'15.0r',0.18,'Compact',NULL,NULL,NULL,NULL,1,323.120791667,-76.32211,0.405,NULL,48530155553,758283680,11848182,15),(150943,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150943,36.69,0.66,218,71738,70,NULL,NULL,'2MASX J21322926-7141119',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'14.8r',0.42,NULL,NULL,NULL,NULL,NULL,1,323.122,-71.68664,0.069,NULL,49306013265,770406457,12037600,14.8),(150944,'Faber-Jackson','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150944,30.52,0.65,12.7,71739,95,NULL,'Weighted Mean','NGC 7079',NULL,'1984ApJS...56...91D',1984,1,2.1,NULL,'G',0.000053,NULL,'12.46',1.3,'(L)SB(r)0^0    LINER','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,323.146875,-44.06756,0.029,NULL,51364706984,802573546,12540211,12.46),(150945,'Faber-Jackson','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150945,31.62,0.81,21.1,71739,55,NULL,'Visvanathan & Sandage 1979','NGC 7079',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150946,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150946,32.35,0.52,29.5,71739,70,NULL,NULL,'NGC 7079',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150947,'Tully est','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150947,32.65,0.8,33.9,71739,75,NULL,'B','NGC 7079',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150948,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150948,32.11,0.45,26.4,71739,NULL,NULL,'K','NGC 7079',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150949,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150949,32.73,0.4,35.1,71739,NULL,NULL,'mean','NGC 7079',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150950,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21060',NULL,150950,40.96,0.28,1550,71740,70,NULL,'SN photometric redshift distance, z photo =0.462 +/- 0.088','SDSS-II SN 21060',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.6g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,323.168875,0.31361,0.125,NULL,52102946758,814108543,12720445,22.6),(150951,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21060','R',150951,41.75,0.31,1590,71740,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21060',0.409255,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150952,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21060','R',150952,42.02,0.34,1800,71740,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 21060',0.409255,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150953,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21060',NULL,150953,41.63,0.21,2120,71740,70,NULL,'SALT 2','SDSS-II SN 21060',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150954,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21060',NULL,150954,41.7,0.21,2190,71740,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 21060',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150955,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150955,37.59,0.46,330,71741,70,NULL,NULL,'2MASX J21324137-0713219',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000082,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,323.172417,-7.22281,0.077,NULL,49683059164,776297799,12129653,17.1),(150956,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150956,37.76,0.46,356,71742,70,NULL,NULL,'2MASX J21324159-0823209',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000075,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,323.1732917,-8.38917,0.089,NULL,49692344780,776442887,12131920,17.8),(150957,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150957,36.02,0.7,160,71743,70,NULL,NULL,'CGCG 376-008',NULL,'2014MNRAS.445.2677S',2014,1,0.93,NULL,'G',0.00015,NULL,'15.2g',0.5,'Sb',NULL,NULL,NULL,NULL,1,323.174,-0.12783,0.129,NULL,49700644479,776572569,12133946,15.2),(150958,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20721','R',150958,40.18,0.26,898,71744,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J213244.34-003721.8',0.2118,'2014arXiv1401.3317S',2014,1,0.12,NULL,'G',0.0001,NULL,'19.2g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,323.1847917,-0.62275,0.145,NULL,49700546063,776571032,12133922,19.2),(150959,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20721','R',150959,40.25,0.17,925,71744,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J213244.34-003721.8',0.2118,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150960,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20721',NULL,150960,39.99,0.21,995,71744,70,NULL,'SALT 2','SDSS J213244.34-003721.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150961,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20721',NULL,150961,40,0.21,1000,71744,70,NULL,'SALT 2, Malmquist cor.','SDSS J213244.34-003721.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150962,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150962,37.12,0.46,266,71745,70,NULL,NULL,'2MASX J21324737-0749539',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000081,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,323.197375,-7.83169,0.101,NULL,49693366090,776458845,12132169,16.5),(150963,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150963,35.14,0.46,107,71746,70,NULL,NULL,'2MASX J21324774-0647229',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000069,NULL,'15.5g',0.4,'S0/a',NULL,NULL,NULL,NULL,1,323.198833,-6.78981,0.085,NULL,49683411151,776303299,12129739,15.5),(150964,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150964,35.24,0.5,112,71746,70,NULL,NULL,'2MASX J21324774-0647229',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150965,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15892','R',150965,39.55,0.14,687,71747,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15892',0.18408,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,323.1989583,0.68939,0.177,NULL,52103624659,814119135,12720611,NULL),(150966,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15892','R',150966,39.61,0.21,704,71747,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15892',0.18408,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150967,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 14619',NULL,150967,41.21,0.19,1750,71748,70,NULL,'SN photometric redshift distance, z photo =0.542 +/- 0.070','SDSS-II SN 14619',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,323.20875,-0.06067,0.137,NULL,49700434413,776569287,12133895,NULL),(150968,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150968,35.65,0.39,135,71749,NULL,NULL,'Malmquist cor.','IC 5108',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.07',0.4,'(R\')SB(s)bc',NULL,NULL,NULL,NULL,1,323.214583,-72.65969,0.089,NULL,49294788272,770231066,12034860,15.07),(150969,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150969,35.85,0.35,148,71749,NULL,NULL,NULL,'IC 5108',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150970,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150970,35.89,0.2,151,71749,74.4,NULL,NULL,'IC 5108',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150971,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150971,37.43,0.46,306,71750,70,NULL,NULL,'SDSS J213251.84+103443.4',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,323.216,10.57875,0.165,NULL,52113895637,814279619,12723119,18.1),(150972,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20065',NULL,150972,39.06,0.6,649,71751,70,NULL,'SN photometric redshift distance, z photo =0.165 +/- 0.059','SDSS-II SN 20065',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'*',NULL,'PHOT','22.1g',NULL,'Point Src [SDSS]',NULL,NULL,NULL,NULL,1,323.223,-0.94672,0.133,NULL,49701049211,776578893,12134045,22.1),(150973,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20065','R',150973,40.84,0.24,1120,71751,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20065',0.309838,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150974,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20065','R',150974,40.97,0.28,1190,71751,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20065',0.309838,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150975,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20065',NULL,150975,40.83,0.18,1470,71751,70,NULL,'SALT 2','SDSS-II SN 20065',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150976,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20065',NULL,150976,40.86,0.18,1490,71751,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20065',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150977,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150977,36.33,0.46,185,71752,70,NULL,NULL,'2MASX J21325346-0711479',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000095,NULL,'15.7g',0.42,'E0',NULL,NULL,NULL,NULL,1,323.222875,-7.19672,0.077,NULL,49683081678,776298151,12129658,15.7),(150978,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005jl',NULL,150978,39.02,0.12,540,71753,74.2,NULL,'SALT 2','SDSS J213256.13-004200.2',0.18,'2010ApJ...716..712A',2010,1,0.14,NULL,'G',0.0005,NULL,'19.9g',0.08,NULL,NULL,NULL,NULL,NULL,1,323.233875,-0.70006,0.145,NULL,49701258877,776582169,12134096,19.9),(150979,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005jl',NULL,150979,39.23,0.07,702,71753,70,NULL,'Hubble residual -0.01 for z0.18100','SDSS J213256.13-004200.2',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150980,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005jl',NULL,150980,39.68,0.13,732,71753,70,NULL,'SALT 2','SDSS J213256.13-004200.2',0.18,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150981,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06936','R',150981,39.73,0.19,748,71753,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005jl','SDSS J213256.13-004200.2',0.181,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150982,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005jl',NULL,150982,39.75,0.08,755,71753,65,NULL,'SALT2','SDSS J213256.13-004200.2',0.18,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150983,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005jl',NULL,150983,39.76,0.03,758,71753,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 06936, SN 2005jl','SDSS J213256.13-004200.2',0.18,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150984,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005jl',NULL,150984,39.81,NULL,776,71753,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 06936, SN 2005jl','SDSS J213256.13-004200.2',0.18,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150985,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005jl',NULL,150985,39.92,0.09,815,71753,65,NULL,'MLCS2k2','SDSS J213256.13-004200.2',0.18,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150986,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06936','R',150986,39.94,0.1,823,71753,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005jl','SDSS J213256.13-004200.2',0.181,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150987,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005jl',NULL,150987,39.59,0.07,828,71753,70,NULL,'SALT 2','SDSS J213256.13-004200.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150988,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005jl',NULL,150988,39.6,0.07,832,71753,70,NULL,'SALT 2, Malmquist cor.','SDSS J213256.13-004200.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150989,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150989,35.08,0.55,104,71754,70,NULL,NULL,'2MASX J21325855-4803005',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'14.8r',0.23,'S',NULL,NULL,NULL,NULL,1,323.2440417,-48.05006,0.025,NULL,50655450565,791491415,12367053,14.8),(150990,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150990,37.14,0.46,267,71755,70,NULL,NULL,'SDSS J213301.06-074115.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000083,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,323.2544583,-7.68758,0.081,NULL,49693329983,776458280,12132160,17.5),(150991,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 17895','RN',150991,39.88,0.13,779,71756,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 17895',0.213018,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150992,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 17895','RN',150992,40.42,0.26,1000,71756,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 17895',0.213018,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150993,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150993,37.6,0.33,332,71757,70,NULL,NULL,'SDSS J213304.64+103614.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,323.269333,10.60392,0.165,NULL,52113850008,814278906,12723107,18.3),(150994,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21315','RN',150994,43.53,0.25,3540,71758,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 21315',0.436423,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150995,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21315','RN',150995,44.64,0.66,5890,71758,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 21315',0.436423,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150996,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2007ih',NULL,150996,39.4,0.1,759,71759,70,NULL,'Hubble residual 0.27 for z0.17060','SDSS-II SN 17389 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,323.295,-0.96008,0.133,NULL,49709246744,776706980,12136046,NULL),(150997,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 17389','R',150997,39.88,0.2,809,71759,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ih','SDSS-II SN 17389 HOST',0.170901,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150998,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 17389','R',150998,39.93,0.12,827,71759,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ih','SDSS-II SN 17389 HOST',0.170901,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150999,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150999,36.79,0.33,229,71760,70,NULL,NULL,'2MASX J21331089+1152293',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000205,NULL,'16.3g',0.34,'E0',NULL,NULL,NULL,NULL,1,323.2954583,11.87483,0.253,NULL,55046270362,860097974,13439030,16.3),(151000,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151000,37.6,0.33,332,71761,70,NULL,NULL,'2MASX J21331110+1038393',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000203,NULL,'16.2g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,323.296333333,10.64419,0.161,NULL,52113849039,814278891,12723107,16.2),(151001,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151001,38.11,0.27,420,71762,70,NULL,NULL,'2MASX J21331555-0841559',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000089,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,323.3147083,-8.699,0.105,NULL,49692720602,776448759,12132011,17.2),(151002,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151002,38.82,0.46,581,71763,70,NULL,NULL,'SDSS J213315.83-071030.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00008,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,323.316,-7.17525,0.057,NULL,49683072249,776298003,12129656,18.6),(151003,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151003,36.47,0.46,197,71764,70,NULL,NULL,'2MASX J21331647+1141243',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000199,NULL,'15.9g',0.34,'S0',NULL,NULL,NULL,NULL,1,323.318625,11.69006,0.253,NULL,55046235900,860097435,13439022,15.9),(151004,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151004,36.79,0.33,229,71765,70,NULL,NULL,'II Zw 138',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,323.3202917,11.62053,0.253,NULL,55046181207,860096581,13439009,16.6),(151005,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151005,36.21,0.65,174,71766,70,NULL,NULL,'2MASX J21332265-7917580',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,323.344375,-79.29947,0.517,NULL,48576466518,759007289,11859488,16.9),(151006,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151006,35.9,0.57,151,71767,70,NULL,NULL,'2MASX J21332398-0237006',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.80',0.32,NULL,NULL,NULL,NULL,NULL,1,323.34975,-2.61681,0.153,NULL,49707692604,776682696,12135667,16.8),(151007,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151007,35.96,0.54,156,71768,70,NULL,NULL,'2MASX J21332452-3113110',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.00015,NULL,'15.1r',0.29,NULL,NULL,NULL,NULL,NULL,1,323.352167,-31.21964,0.097,NULL,51459024337,804047255,12563238,15.1),(151008,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 17687','RN',151008,41.44,0.49,1490,71769,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17687',0.303225,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151009,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 17687','RN',151009,41.46,0.49,1500,71769,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17687',0.303225,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151010,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 17687','N',151010,41.28,0.38,1800,71769,70,NULL,'SALT 2','SDSS-II SN 17687',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151011,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 17687','N',151011,41.31,0.38,1830,71769,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 17687',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151012,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15339','R',151012,39.82,0.2,820,71770,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2006ns','SN 2006ns',0.119964,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'II',NULL,NULL,NULL,NULL,1,323.38425,0.78483,0.165,NULL,52107753594,814183649,12721619,NULL),(151013,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15339','R',151013,39.88,0.08,845,71770,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2006ns','SN 2006ns',0.119964,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151014,'IRAS','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151014,34.66,0.8,85.3,71771,75,NULL,'CF, r','UGC 11765',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000033,NULL,'14.99',0.6,'Sb',NULL,NULL,NULL,NULL,1,323.3882083,8.77247,0.129,NULL,52124008924,814437639,12725588,14.99),(151015,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151015,34.73,0.52,88.2,71771,NULL,NULL,NULL,'UGC 11765',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151016,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151016,34.78,0.38,90.5,71771,75,NULL,'CF, r, raw','UGC 11765',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151017,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151017,34.79,0.2,90.8,71771,74.4,NULL,NULL,'UGC 11765',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151018,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151018,34.8,0.5,91.3,71771,NULL,NULL,'Malmquist cor.','UGC 11765',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151019,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151019,34.88,0.38,94.5,71771,75,NULL,'CF, r, inv','UGC 11765',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151020,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151020,35.09,0.38,104,71771,75,NULL,'CF, r, cor','UGC 11765',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151021,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151021,32.21,0.43,27.7,71772,75,NULL,'3.6 micron, color + selection bias corrected','2MFGC 16293',NULL,'2014MNRAS.444..527S',2014,1,1.12,'abs(b) < 10 degrees.','G',0.00002,NULL,'10.6K',0.22,'Spiral',NULL,NULL,NULL,NULL,1,323.3942083,42.72411,NULL,NULL,55668778856,869824669,13591010,10.6),(151022,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151022,37.7,0.27,346,71773,70,NULL,NULL,'2MASX J21333586+1125194',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000172,NULL,'16.6g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,323.399417,11.42208,0.201,NULL,52111003773,814234433,12722413,16.6),(151023,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151023,37.7,0.27,346,71774,70,NULL,NULL,'2MASX J21334062+1128124',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00019,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,323.4192917,11.47008,0.201,NULL,52110156743,814221199,12722206,16.8),(151024,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15175','RN',151024,40.95,0.6,1410,71775,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15175',0.103089,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151025,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151025,35.75,0.57,141,71776,70,NULL,NULL,'ESO 107- G 035',NULL,'2014MNRAS.445.2677S',2014,1,0.92,NULL,'G',0.000133,NULL,'14.43',0.58,'S0?',NULL,NULL,NULL,NULL,1,323.431166667,-63.57756,0.053,NULL,49166712652,768229885,12003591,14.43),(151026,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 14624',NULL,151026,40.54,1.02,1280,71777,70,NULL,'SN photometric redshift distance, z photo =0.361 +/- 0.323','SDSS-II SN 14624',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.2g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,323.440958333,0.34558,0.157,NULL,52106934039,814170844,12721419,21.2),(151027,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 14624','R',151027,41.54,0.25,1420,71777,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14624',0.434864,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151028,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 14624',NULL,151028,40.78,0.3,1430,71777,70,NULL,NULL,'SDSS-II SN 14624',NULL,'2013MNRAS.434.1443X',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151029,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 14624','R',151029,41.86,0.29,1640,71777,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14624',0.434864,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151030,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151030,36.68,0.46,217,71778,70,NULL,NULL,'2MASX J21334814-0650421',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000084,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,323.4505417,-6.845,0.085,NULL,49683235788,776300559,12129696,16.8),(151031,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151031,38.11,0.27,420,71779,70,NULL,NULL,'2MASX J21334833-0830461',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000086,NULL,'17.4g',0.21,'BrClG',NULL,NULL,NULL,NULL,1,323.45125,-8.51294,0.125,NULL,49692847244,776450738,12132042,17.4),(151032,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 12842','R',151032,39.48,0.05,722,71780,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2006ez','SN 2006ez',0.0887,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'II',NULL,NULL,NULL,NULL,1,323.45525,-1.01594,0.133,NULL,49709226338,776706661,12136041,NULL),(151033,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 12842','R',151033,39.58,0.18,756,71780,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2006ez','SN 2006ez',0.0887,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151034,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151034,38.11,0.27,420,71781,70,NULL,NULL,'2MASX J21335143-0837291',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000089,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,323.4644583,-8.62486,0.105,NULL,49693041103,776453767,12132090,17.6),(151035,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151035,37.7,0.27,346,71782,70,NULL,NULL,'SDSS J213352.49+113008.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000158,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,323.46875,11.50236,0.261,NULL,52110126046,814220719,12722198,18.6),(151036,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151036,36.2,0.67,174,71783,70,NULL,NULL,'2MASX J21335255-5540483',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.99',0.3,NULL,NULL,NULL,NULL,NULL,1,323.4689583,-55.68008,0.077,NULL,48666785054,760418516,11881539,15.99),(151037,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151037,37.72,0.46,350,71784,70,NULL,NULL,'2MASX J21335291+1026234',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000185,NULL,'16.7g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,323.470583333,10.43972,0.193,NULL,52113532397,814273943,12723030,16.7),(151038,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 11083','RN',151038,39.68,0.26,768,71785,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 11083',0.121929,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151039,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 11083','RN',151039,39.96,0.26,877,71785,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 11083',0.121929,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151040,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151040,34.37,0.4,74.8,71786,NULL,NULL,'mean','IC 5119',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000067,NULL,'15.35',0.2,'Sa',NULL,NULL,NULL,NULL,1,323.4827083,21.83792,0.353,NULL,55156558993,861821234,13465956,15.35),(151041,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151041,34.41,0.47,76.4,71786,NULL,NULL,'H','IC 5119',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151042,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151042,34.44,0.45,77.4,71786,NULL,NULL,'K','IC 5119',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151043,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151043,34.5,0.46,79.4,71786,NULL,NULL,'J','IC 5119',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151044,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151044,34.75,0.2,89.1,71786,74.4,NULL,NULL,'IC 5119',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151045,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151045,34.77,0.43,89.8,71786,75,NULL,'3.6 micron, color corrected','IC 5119',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151046,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151046,34.89,0.43,95.1,71786,75,NULL,'3.6 micron, color + selection bias corrected','IC 5119',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151047,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2007ow',NULL,151047,39.54,0.14,808,71787,70,NULL,'Hubble residual -0.01 for z0.21160','SDSS J213402.01-004426.3',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,323.508375,-0.74064,0.145,NULL,49708887619,776701369,12135958,NULL),(151048,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 19425','R',151048,40.02,0.17,833,71787,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2007ow','SDSS J213402.01-004426.3',0.2116,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151049,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 19425','R',151049,40.1,0.22,864,71787,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2007ow','SDSS J213402.01-004426.3',0.2116,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151050,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2007ow',NULL,151050,39.89,0.12,951,71787,70,NULL,'SALT 2','SDSS J213402.01-004426.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151051,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2007ow',NULL,151051,39.9,0.12,955,71787,70,NULL,'SALT 2, Malmquist cor.','SDSS J213402.01-004426.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151052,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15549',NULL,151052,40.83,0.17,1470,71788,70,NULL,'SN photometric redshift distance, z photo =0.429 +/- 0.047','SDSS-II SN 15549',NULL,'2011ApJ...738..162S',2011,1,0.03,NULL,'G',NULL,'PHOT','21.9g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,323.510916667,0.63364,0.185,NULL,52107063250,814172863,12721450,21.9),(151053,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15549','R',151053,42.01,0.24,1740,71788,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15549',0.448849,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151054,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15549','R',151054,42.06,0.28,1780,71788,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15549',0.448849,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151055,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15549',NULL,151055,42.09,0.19,2620,71788,70,NULL,'SALT 2','SDSS-II SN 15549',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151056,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15549',NULL,151056,42.18,0.19,2730,71788,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15549',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151057,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','PTF11mty','N',151057,37.63,0.04,312,71789,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF11mty',0.077,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151058,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21046',NULL,151058,39.84,0.45,930,71790,70,NULL,'SN photometric redshift distance, z photo =0.247 +/- 0.068','SDSS-II SN 21046',NULL,'2011ApJ...738..162S',2011,1,0.2,NULL,'G',NULL,'PHOT','21.8g',0.02,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,323.5239583,1.11194,0.173,NULL,52107494033,814179594,12721556,21.8),(151059,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21046','R',151059,41.31,0.31,1280,71790,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 21046',0.42774,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151060,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21046','R',151060,41.45,0.32,1360,71790,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 21046',0.42774,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151061,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21046',NULL,151061,41.27,0.23,1790,71790,70,NULL,'SALT 2','SDSS-II SN 21046',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151062,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21046',NULL,151062,41.35,0.23,1860,71790,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 21046',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151063,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151063,31.19,0.43,17.3,71791,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7091',NULL,'2014MNRAS.444..527S',2014,1,2.1,NULL,'G',0.000007,NULL,'13.98',1.7,'SB(s)dm:',NULL,NULL,NULL,NULL,1,323.533083333,-36.65372,0.069,NULL,51441271788,803769871,12558904,13.98),(151064,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151064,35.77,0.32,142,71792,NULL,NULL,'Malmquist cor.','ESO 599- G 020',NULL,'2009ApJS..182..474S',2009,1,1.5,'1991ApJS ...75..935d gives V = 10747 +- 33.','G',0.000033,NULL,'13.9r',0.4,'SAB(s)ab pec sp',NULL,NULL,NULL,NULL,1,323.53525,-20.471,0.097,NULL,50934837974,795856843,12435263,13.9),(151065,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151065,35.95,0.47,155,71792,NULL,NULL,'H','ESO 599- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151066,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151066,35.98,0.4,157,71792,NULL,NULL,'mean','ESO 599- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151067,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151067,35.99,0.29,158,71792,NULL,NULL,NULL,'ESO 599- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151068,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151068,36.03,0.2,161,71792,74.4,NULL,NULL,'ESO 599- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151069,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151069,36.09,0.45,165,71792,NULL,NULL,'K','ESO 599- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151070,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151070,36.15,0.46,170,71792,NULL,NULL,'J','ESO 599- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151071,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151071,37.5,0.46,317,71793,70,NULL,NULL,'2MASX J21340982+1005493',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000204,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,323.540875,10.09686,0.193,NULL,52113580689,814274698,12723042,16.6),(151072,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151072,37.79,0.46,362,71794,70,NULL,NULL,'SDSS J213410.47+010349.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,323.543666667,1.06381,0.173,NULL,52107775074,814183985,12721624,18),(151073,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 12849','RN',151073,41.27,0.15,1460,71795,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 12849',0.233317,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151074,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 12849','RN',151074,41.58,0.21,1680,71795,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 12849',0.233317,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151075,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 09292','RN',151075,39.36,0.6,637,71796,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 09292',0.166778,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151076,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15301','R',151076,40.06,0.2,792,71797,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006lo','SDSS J213419.18+003520.8',0.296,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,323.579917,0.58911,0.185,NULL,52107089020,814173265,12721457,NULL),(151077,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006lo',NULL,151077,39.6,0.07,832,71797,70,NULL,'SALT 2','SDSS J213419.18+003520.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151078,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006lo',NULL,151078,39.61,0.07,836,71797,70,NULL,'SALT 2, Malmquist cor.','SDSS J213419.18+003520.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151079,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15301','R',151079,40.3,0.1,886,71797,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006lo','SDSS J213419.18+003520.8',0.296,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151080,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005jx',NULL,151080,41.03,0.22,1330,71798,74.2,NULL,'SALT 2','SDSS J213420.02-004053.0',0.21,'2010ApJ...716..712A',2010,1,0.08,NULL,'G',NULL,NULL,'20.2g',0.06,NULL,NULL,NULL,NULL,NULL,1,323.583458333,-0.68142,0.145,NULL,49708992597,776703009,12135984,20.2),(151081,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07460','R',151081,41.96,0.31,2040,71798,70,NULL,'SDSS CAND. zSNIa; SALT 2; SN 2005jx','SDSS J213420.02-004053.0',0.21,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151082,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07460','R',151082,42.1,0.31,2170,71798,70,NULL,'SDSS CAND. zSNIa; MLCS2K2; SN 2005jx','SDSS J213420.02-004053.0',0.21,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151083,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151083,35.44,0.67,122,71799,70,NULL,NULL,'2MASX J21342018-5239511',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000103,NULL,'14.8r',0.17,'S',NULL,NULL,NULL,NULL,1,323.584,-52.66414,0,NULL,50607471539,790741742,12355339,14.8),(151084,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','PTF10qsc','N',151084,38.19,0.02,399,71800,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10qsc',0.0879,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151085,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151085,36.02,0.54,160,71801,70,NULL,NULL,'2MASX J21342422-1940328',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'15.5r',0.23,NULL,NULL,NULL,NULL,NULL,1,323.6010417,-19.67589,0.109,NULL,50932921167,795826893,12434795,15.5),(151086,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 05626','RN',151086,38.59,0.29,480,71802,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05626',0.085817,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151087,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 05626','RN',151087,38.71,0.32,509,71802,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 05626',0.085817,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151088,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151088,37.44,0.46,307,71803,70,NULL,NULL,'2MASX J21342471-0036112',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000165,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,323.603083333,-0.60322,0.125,NULL,49709003352,776703177,12135987,16.8),(151089,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151089,36.74,0.57,223,71804,70,NULL,NULL,'2MASX J21342486-0740143',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.000077,NULL,'16.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,323.603667,-7.67058,0.081,NULL,49684186390,776315412,12129928,16.5),(151090,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151090,34.75,0.53,89.1,71805,70,NULL,NULL,'6dF J2134250-332507',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,323.604291667,-33.41864,0.113,NULL,51450222642,803909728,12561089,14.1),(151091,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20257','RN',151091,41.48,0.3,1520,71806,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20257',0.301715,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151092,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20257','RN',151092,41.52,0.22,1540,71806,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20257',0.301715,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151093,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151093,36.07,0.84,164,71807,70,NULL,NULL,'2MASX J21343013-4833481',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.3r',0.2,NULL,NULL,NULL,NULL,NULL,1,323.6255,-48.56336,0.013,NULL,50658451547,791538305,12367786,15.3),(151094,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151094,35.66,NULL,135,71808,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2329',NULL,'2010Ap&SS.325..163P',2010,1,0.84,NULL,'G',0.00003,NULL,'16.6',0.1,'Scd',NULL,NULL,NULL,NULL,1,323.631875,14.68092,0.313,NULL,55133201839,861456278,13460254,16.6),(151095,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151095,35.67,NULL,136,71808,NULL,NULL,'Dipole + Quadrupole','FGC 2329',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151096,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151096,35.7,NULL,138,71808,NULL,NULL,NULL,'FGC 2329',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151097,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151097,35.7,NULL,138,71808,NULL,NULL,'Dipole','FGC 2329',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151098,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16350','R',151098,40.51,0.21,1020,71809,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ph','SDSS J213433.30-005305.9',0.24,'2014arXiv1401.3317S',2014,1,0.11,NULL,'G',NULL,NULL,'20.0g',0.09,NULL,NULL,NULL,NULL,NULL,1,323.638791667,-0.88497,0.145,NULL,49709791628,776715494,12136179,20),(151099,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006ph',NULL,151099,40.11,0.11,1050,71809,70,NULL,'SALT 2','SDSS J213433.30-005305.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151100,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006ph',NULL,151100,40.13,0.11,1060,71809,70,NULL,'SALT 2, Malmquist cor.','SDSS J213433.30-005305.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151101,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16350','R',151101,40.63,0.14,1080,71809,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ph','SDSS J213433.30-005305.9',0.24,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151102,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151102,35.05,0.49,102,71810,75,NULL,'IR','UGC 11768',NULL,'2011yCatp016004901K',2011,1,1.31,NULL,'G',0.000012,NULL,'16.0',0.16,'Sbc',NULL,NULL,NULL,NULL,1,323.6419583,18.95086,0.373,NULL,55147988942,861687327,13463864,16),(151103,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151103,35.32,0.43,116,71810,75,NULL,'3.6 micron, color corrected','UGC 11768',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151104,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151104,35.33,NULL,116,71810,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11768',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151105,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151105,35.33,0.43,116,71810,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11768',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151106,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151106,35.34,NULL,117,71810,NULL,NULL,'Dipole + Quadrupole','UGC 11768',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151107,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151107,35.35,NULL,118,71810,NULL,NULL,'Dipole','UGC 11768',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151108,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151108,35.38,NULL,119,71810,NULL,NULL,NULL,'UGC 11768',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151109,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151109,35.38,0.2,119,71810,74.4,NULL,NULL,'UGC 11768',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151110,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151110,35.43,0.37,122,71810,NULL,NULL,'Malmquist cor.','UGC 11768',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151111,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151111,35.45,0.37,123,71810,NULL,NULL,NULL,'UGC 11768',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151112,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01198','RN',151112,39.17,0.17,609,71811,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01198',0.119688,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151113,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01198','RN',151113,39.63,0.23,753,71811,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01198',0.119688,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151114,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151114,37.68,0.46,343,71812,70,NULL,NULL,'SDSS J213439.57-071641.9',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000496,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,323.664875,-7.27833,0.057,NULL,49684888131,776326377,12130099,17.2),(151115,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15343','R',151115,39.29,0.21,615,71813,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 15343',0.174876,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,323.672333,0.68478,0.185,NULL,52106983607,814171618,12721431,NULL),(151116,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15343','R',151116,39.41,0.14,649,71813,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 15343',0.174876,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151117,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151117,38.36,0.46,471,71814,70,NULL,NULL,'SDSS J213445.21-070211.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00007,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,323.688417,-7.03647,0.065,NULL,49685591950,776337374,12130271,18.5),(151118,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151118,38,0.33,398,71815,70,NULL,NULL,'SDSS J213445.32-083622.2',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000076,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,323.688833,-8.60619,0.125,NULL,49692978517,776452789,12132074,17.6),(151119,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 09739','R',151119,39.74,0.16,793,71816,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 09739',0.119451,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,323.6937917,-0.87892,0.145,NULL,49709791102,776715485,12136179,NULL),(151120,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 09739','R',151120,39.83,0.24,825,71816,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 09739',0.119451,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151121,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006fc',NULL,151121,38.45,0.06,490,71817,70,NULL,'Hubble residual 0.00 for z0.12170','SDSS J213446.61+011033.3',NULL,'2011ApJ...740...92G',2011,1,0.19,NULL,'G',0.0005,NULL,'19.0g',0.09,NULL,NULL,NULL,NULL,NULL,1,323.6949583,1.17542,0.189,NULL,52107698092,814182782,12721605,19),(151122,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 12860','R',151122,38.85,0.18,526,71817,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006fc','SDSS J213446.61+011033.3',0.1217,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151123,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 12860','R',151123,38.9,0.09,538,71817,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006fc','SDSS J213446.61+011033.3',0.1217,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151124,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006fc',NULL,151124,38.68,0.07,545,71817,70,NULL,'SALT 2','SDSS J213446.61+011033.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151125,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006fc',NULL,151125,38.68,0.07,545,71817,70,NULL,'SALT 2, Malmquist cor.','SDSS J213446.61+011033.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151126,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151126,36.92,0.69,242,71818,70,NULL,NULL,'2MASX J21345105-0537311',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'16.67',0.26,NULL,NULL,NULL,NULL,NULL,1,323.7127083,-5.62525,0.121,NULL,49714403352,776787552,12137305,16.67),(151127,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151127,35.87,0.49,150,71819,75,NULL,'IR','UGC 11770',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',NULL,NULL,'15.6',0.15,'S',NULL,NULL,NULL,NULL,1,323.74525,1.45553,0.173,NULL,52107556164,814180565,12721571,15.6),(151128,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151128,35.84,0.16,140,71820,74.2,NULL,'SALT 2','2MASX J21345926-6244143',0.0503,'2010ApJ...716..712A',2010,1,0.47,NULL,'G',0.00015,NULL,'16.5b',0.42,'SB0',NULL,NULL,NULL,NULL,1,323.747125,-62.73736,0.037,NULL,49171715309,768308051,12004813,16.5),(151129,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151129,36.5,0.19,190,71820,72,NULL,NULL,'2MASX J21345926-6244143',0.0503,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151130,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151130,36.53,0.15,193,71820,65,NULL,'MLCS','2MASX J21345926-6244143',0.0503,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151131,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151131,36.43,0.08,193,71820,74.4,NULL,NULL,'2MASX J21345926-6244143',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151132,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151132,36.56,0.13,195,71820,65,NULL,'SALT2','2MASX J21345926-6244143',0.0503,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151133,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151133,36.6,0.18,199,71820,70,NULL,'SALT 2','2MASX J21345926-6244143',0.0503,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151134,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151134,36.6,0.19,199,71820,65,NULL,'MLCS17','2MASX J21345926-6244143',0.0503,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151135,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151135,36.71,0.16,200,71820,65,NULL,'MLCS2k2','2MASX J21345926-6244143',0.0503,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151136,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151136,36.63,0.05,202,71820,70,NULL,NULL,'2MASX J21345926-6244143',0.0503,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151137,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151137,36.65,0.02,203,71820,72,NULL,NULL,'2MASX J21345926-6244143',0.0503,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151138,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151138,36.65,0.21,203,71820,65,NULL,'MLCS31','2MASX J21345926-6244143',0.0503,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151139,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151139,36.67,0.25,205,71820,65,NULL,'Template','2MASX J21345926-6244143',0.0503,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151140,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151140,36.69,0.17,207,71820,65,NULL,'MLCS2k2','2MASX J21345926-6244143',0.0503,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151141,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151141,36.69,0.19,207,71820,73.8,NULL,'SALT 2 (SNANA)','2MASX J21345926-6244143',0.0495,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151142,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151142,36.7,0.15,208,71820,70,NULL,'SALT','2MASX J21345926-6244143',0.0503,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151143,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151143,36.62,0.06,211,71820,65,NULL,'LCS','2MASX J21345926-6244143',NULL,'1995ApJ...445L..91R',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151144,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151144,36.76,0.18,214,71820,65,NULL,'SALT2','2MASX J21345926-6244143',0.0503,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151145,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151145,36.69,0.12,218,71820,70.8,NULL,NULL,'2MASX J21345926-6244143',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151146,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151146,36.8,0.1,218,71820,65,NULL,'MLCS2k2','2MASX J21345926-6244143',0.0503,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151147,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151147,36.84,0.21,222,71820,65,NULL,NULL,'2MASX J21345926-6244143',0.0503,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151148,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151148,36.85,0.07,223,71820,65,NULL,'MLCS','2MASX J21345926-6244143',0.0503,'1996ApJ...473..588R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151149,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151149,36.87,0.14,225,71820,65,NULL,'SALT','2MASX J21345926-6244143',0.0503,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151150,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151150,36.89,0.02,227,71820,65,NULL,'SALT','2MASX J21345926-6244143',0.0503,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151151,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151151,36.87,0.06,237,71820,65,NULL,'Snapshot','2MASX J21345926-6244143',NULL,'1996ApJ...473...88R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151152,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151152,37.03,0.15,242,71820,70,NULL,'SALT 2','2MASX J21345926-6244143',0.0503,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151153,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151153,36.98,0.14,249,71820,60,NULL,NULL,'2MASX J21345926-6244143',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151154,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151154,37.1,0.06,263,71820,60,NULL,'M(V) = -19.47 mag','2MASX J21345926-6244143',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151155,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151155,37.1,0.6,265,71820,67,NULL,NULL,'2MASX J21345926-6244143',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151156,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151156,37.13,0.07,267,71820,60,NULL,'M(B) = -19.48 mag','2MASX J21345926-6244143',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151157,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151157,37.35,0.03,281,71820,70,NULL,'SALT 2','2MASX J21345926-6244143',0.0503,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151158,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151158,36.91,0.76,241,71821,70,NULL,NULL,'2MASX J21345994-7035425',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.2r',0.35,'S',NULL,NULL,NULL,NULL,1,323.75,-70.59514,0.037,NULL,49301918381,770342474,12036601,15.2),(151159,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151159,38.54,0.46,511,71822,70,NULL,NULL,'2MASX J21350010+1108107',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,323.7504583,11.13639,0.221,NULL,52110653348,814228958,12722327,18.1),(151160,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151160,35.96,0.46,156,71823,70,NULL,NULL,'IC 1391',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00015,NULL,'15.6g',0.48,'E0',NULL,NULL,NULL,NULL,1,323.751667,-0.51144,0.125,NULL,49708957667,776702463,12135975,15.6),(151161,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151161,37.18,0.59,273,71823,70,NULL,NULL,'IC 1391',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151162,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151162,38,0.33,398,71824,70,NULL,NULL,'SDSS J213502.05-082602.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000009,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,323.758583333,-8.43414,0.097,NULL,49692940863,776452200,12132065,18),(151163,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06472','RN',151163,38.81,0.13,549,71825,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06472',0.050899,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151164,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151164,35.36,0.53,118,71826,70,NULL,NULL,'2MASX J21350521-7314506',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,323.771625,-73.24733,0.209,NULL,49293235283,770206801,12034481,16.6),(151165,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151165,37.7,0.46,347,71827,70,NULL,NULL,'2MASX J21350597+1023467',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000156,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,323.775,10.39622,0.169,NULL,52113660654,814275947,12723061,17.1),(151166,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151166,38.12,0.46,420,71828,70,NULL,NULL,'2MASX J21350734+0105409',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,323.780625,1.09478,0.189,NULL,52107891999,814185812,12721653,17.2),(151167,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151167,37.37,0.46,298,71829,70,NULL,NULL,'2MASX J21350802-0846021',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000096,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,323.783458333,-8.76742,0.105,NULL,49692098598,776439040,12131860,16.8),(151168,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 13750','RN',151168,42.15,0.27,2020,71830,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13750',0.331974,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151169,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 13750','RN',151169,42.56,0.39,2440,71830,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13750',0.331974,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151170,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005fd',NULL,151170,39.81,0.14,727,71831,74.2,NULL,'SALT 2','SDSS J213511.65+000946.1',0.26,'2010ApJ...716..712A',2010,1,0.1,NULL,'G',0.005,NULL,'20.5g',0.07,NULL,NULL,NULL,NULL,NULL,1,323.798583,0.16283,0.165,NULL,52095593551,813993649,12718650,20.5),(151171,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005fd',NULL,151171,40.34,0.05,927,71831,70,NULL,'SDSS-II SN 01253','SDSS J213511.65+000946.1',0.26,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151172,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005fd',NULL,151172,39.84,0.16,931,71831,70,NULL,'Hubble residual -0.11 for z0.26200','SDSS J213511.65+000946.1',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151173,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01253','R',151173,40.48,0.22,988,71831,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fd','SDSS J213511.65+000946.1',0.262,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151174,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005fd',NULL,151174,40.52,0.14,1010,71831,65,NULL,'SALT2','SDSS J213511.65+000946.1',0.26,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151175,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005fd',NULL,151175,40.53,0.16,1010,71831,70,NULL,'SDSS-II SN 01253, SALT 2','SDSS J213511.65+000946.1',0.26,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151176,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005fd',NULL,151176,40.65,0.14,1070,71831,65,NULL,'MLCS2k2','SDSS J213511.65+000946.1',0.26,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151177,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01253','R',151177,40.72,0.19,1100,71831,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fd','SDSS J213511.65+000946.1',0.262,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151178,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 14784','R',151178,40.04,0.12,853,71832,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J213511.75-002055.9',0.192,'2014arXiv1401.3317S',2014,1,0.17,NULL,'G',0.01,NULL,'19.7g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,323.799,-0.34886,0.137,NULL,49695407005,776490734,12132667,19.7),(151179,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 14784','R',151179,40.06,0.2,864,71832,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J213511.75-002055.9',0.192,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151180,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 14784',NULL,151180,39.94,0.09,973,71832,70,NULL,'SALT 2','SDSS J213511.75-002055.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151181,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 14784',NULL,151181,39.95,0.09,977,71832,70,NULL,'SALT 2, Malmquist cor.','SDSS J213511.75-002055.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151182,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 02007','RN',151182,41.91,0.36,1720,71833,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 02007',0.400453,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151183,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 02007','RN',151183,42.62,0.36,2390,71833,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02007',0.400453,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151184,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151184,38.28,0.46,452,71834,70,NULL,NULL,'2MASX J21351512+1045277',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,323.813,10.75769,0.149,NULL,52110592246,814228003,12722312,17.4),(151185,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151185,35.44,0.63,122,71835,70,NULL,NULL,'2MASX J21351739-0311247',NULL,'2014MNRAS.445.2677S',2014,1,0.85,NULL,'G',0.00015,NULL,'16.52',0.5,NULL,NULL,NULL,NULL,NULL,1,323.822625,-3.19017,0.137,NULL,49705233776,776644277,12135066,16.52),(151186,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151186,37.22,0.57,278,71836,70,NULL,NULL,'2MASX J21351823-0930081',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.81',0.46,NULL,NULL,NULL,NULL,NULL,1,323.826166667,-9.50228,0.097,NULL,49679347053,776239797,12128746,16.81),(151187,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151187,35.02,0.57,101,71837,70,NULL,NULL,'2MASX J21352020-2056458',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00015,NULL,'14.3r',0.45,'S0',NULL,NULL,NULL,NULL,1,323.834083,-20.946,0.097,NULL,50935554148,795868033,12435438,14.3),(151188,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151188,34.37,0.55,74.9,71838,70,NULL,NULL,'ESO 343- G 011',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000107,NULL,'13.9r',0.7,'S0',NULL,NULL,NULL,NULL,1,323.836625,-37.69153,0.021,NULL,51474281344,804285646,12566963,13.9),(151189,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151189,37.39,0.33,300,71839,70,NULL,NULL,'2MASX J21352530+0019480',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000125,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,323.8552917,0.33003,0.165,NULL,52095610374,813993912,12718654,17.4),(151190,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151190,38.24,0.46,444,71840,70,NULL,NULL,'SDSS J213528.45+101503.1',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000151,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,323.8685417,10.25089,0.161,NULL,52112624797,814259762,12722808,18.1),(151191,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151191,37.8,0.46,362,71841,70,NULL,NULL,'2MASX J21352853-0825015',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000079,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,323.868791667,-8.41719,0.097,NULL,49692082337,776438786,12131856,17.6),(151192,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151192,37.39,0.33,300,71842,70,NULL,NULL,'2MASX J21352917+0016060',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000181,NULL,'16.1g',0.39,'BrClG',NULL,NULL,NULL,NULL,1,323.871375,0.26831,0.165,NULL,52095611258,813993925,12718655,16.1),(151193,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006fa',NULL,151193,38.77,0.1,568,71843,70,NULL,'Hubble residual -0.31 for z0.16704','SDSS J213530.84-005846.6',NULL,'2011ApJ...740...92G',2011,1,0.15,NULL,'G',0.000128,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,323.8785,-0.97964,0.145,NULL,49709691714,776713933,12136155,18.5),(151194,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 12843','R',151194,39.23,0.19,601,71843,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006fa','SDSS J213530.84-005846.6',0.167038,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151195,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 12843','R',151195,39.41,0.12,653,71843,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006fa','SDSS J213530.84-005846.6',0.167038,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151196,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151196,35.15,0.56,107,71844,70,NULL,NULL,'2MASX J21353257-5817496',NULL,'2014MNRAS.445.2677S',2014,1,0.97,NULL,'G',0.00015,NULL,'13.6r',0.88,'(R\')SAB(rs)b',NULL,NULL,NULL,NULL,1,323.8857917,-58.29708,0.037,NULL,48713282305,761145036,11892891,13.6),(151197,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151197,33.65,0.45,53.8,71845,NULL,NULL,'K','IC 1392',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000067,NULL,'12.5',1.3,'S0-:','in a triple',NULL,NULL,NULL,1,323.886208333,35.39833,1.025,NULL,55598524497,868726945,13573858,12.5),(151198,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151198,33.75,0.4,56.3,71845,NULL,NULL,'mean','IC 1392',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151199,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151199,35.82,0.36,146,71846,NULL,NULL,'Malmquist cor.','ESO 600- G 002',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000033,NULL,'14.0r',0.8,'SA(r)c',NULL,NULL,NULL,NULL,1,323.89225,-19.03103,0.085,NULL,50932727239,795823863,12434747,14),(151200,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151200,36.13,0.31,168,71846,NULL,NULL,NULL,'ESO 600- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151201,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151201,36.17,0.2,171,71846,74.4,NULL,NULL,'ESO 600- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151202,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 09740','R',151202,40.2,0.28,887,71847,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 09740',0.238,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,323.8970417,-1.02853,0.145,NULL,49709693754,776713964,12136155,NULL),(151203,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 09740','R',151203,40.48,0.25,1010,71847,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 09740',0.238,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151204,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151204,36.6,0.56,209,71848,70,NULL,NULL,'2MASX J21353550-0905534',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,323.898,-9.09825,0.081,NULL,49692174815,776440231,12131878,15.6),(151205,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151205,36.32,0.46,183,71849,70,NULL,NULL,'2MASX J21354144+0033420',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.77',0.3,NULL,NULL,NULL,NULL,NULL,1,323.9227083,0.56164,0.185,NULL,52095543502,813992867,12718638,16.77),(151206,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151206,36.83,0.46,232,71850,70,NULL,NULL,'2MASX J21354311-0843354',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000078,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,323.929416667,-8.72672,0.093,NULL,49692131849,776439560,12131868,17),(151207,'IRAS','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151207,32.94,0.8,38.8,71851,75,NULL,'MAT, I','NGC 7083',NULL,'1997ApJS..109..333W',1997,1,3.9,NULL,'G',0.000013,NULL,'11.87',2.3,'SAB(rs)c       LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,323.936208333,-63.90283,0.057,NULL,49356533005,771195828,12049934,11.87),(151208,'IRAS','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151208,32.96,0.8,39.1,71851,75,NULL,'A82, H','NGC 7083',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151209,'Sosies','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151209,32.68,0.07,34.4,71851,NULL,NULL,NULL,'NGC 7083',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151210,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151210,31.83,0.47,23.2,71851,75,NULL,'A82, H, raw','NGC 7083',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151211,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151211,31.96,0.4,24.7,71851,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 7083',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151212,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151212,31.97,0.47,24.7,71851,75,NULL,'A82, H, inv','NGC 7083',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151213,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151213,32.28,0.47,28.6,71851,75,NULL,'A82, H, cor','NGC 7083',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151214,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151214,32.37,0.36,29.8,71851,NULL,NULL,NULL,'NGC 7083',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151215,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151215,32.37,0.4,29.8,71851,73,NULL,'opt','NGC 7083',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151216,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151216,32.46,0.32,31.1,71851,85,NULL,'I, raw','NGC 7083',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151217,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151217,32.47,0.43,31.1,71851,75,NULL,'MAT, I, raw','NGC 7083',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151218,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151218,32.48,NULL,31.3,71851,NULL,NULL,'B','NGC 7083',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151219,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151219,32.53,0.32,32.1,71851,85,NULL,'I, inv','NGC 7083',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151220,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151220,32.68,NULL,34.4,71851,NULL,NULL,'I','NGC 7083',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151221,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151221,32.74,0.43,35.4,71851,75,NULL,'MAT, I, inv','NGC 7083',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151222,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151222,32.78,0.2,36,71851,74.4,NULL,NULL,'NGC 7083',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151223,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151223,32.79,0.43,36.2,71851,75,NULL,'MAT, I, cor','NGC 7083',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151224,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151224,32.94,0.4,38.7,71851,75,NULL,'B','NGC 7083',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151225,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151225,32.99,0.38,39.6,71851,NULL,NULL,NULL,'NGC 7083',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151226,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151226,33.08,0.36,41.3,71851,NULL,NULL,'Malmquist cor.','NGC 7083',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151227,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151227,37.98,0.46,394,71852,70,NULL,NULL,'2MASX J21354703+0015560',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000153,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,323.9460417,0.26553,0.165,NULL,52095560909,813993139,12718642,17.2),(151228,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151228,35.64,0.49,134,71853,70,NULL,NULL,'6dF J2135502-344257',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,323.959167,-34.71572,0.093,NULL,51448678015,803885593,12560712,14.6),(151229,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006kt',NULL,151229,39.88,0.19,946,71854,70,NULL,'SDSS-II SN 15287','SDSS J213550.32-010326.8',NULL,'2013MNRAS.434.1443X',2013,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,323.959667,-1.05744,0.145,NULL,49709413977,776709593,12136087,NULL),(151230,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006kt',NULL,151230,39.92,0.11,964,71854,70,NULL,'Hubble residual 0.02 for z0.25400','SDSS J213550.32-010326.8',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151231,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15287','R',151231,40.5,0.19,1000,71854,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006kt','SDSS J213550.32-010326.8',0.254,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151232,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006kt',NULL,151232,40.61,0.16,1070,71854,72,NULL,'SDSS 15287','SDSS J213550.32-010326.8',0.24,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151233,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15287','R',151233,40.67,0.09,1080,71854,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006kt','SDSS J213550.32-010326.8',0.254,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151234,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006kt',NULL,151234,40.44,0.08,1220,71854,70,NULL,'SALT 2','SDSS J213550.32-010326.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151235,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006kt',NULL,151235,40.45,0.08,1230,71854,70,NULL,'SALT 2, Malmquist cor.','SDSS J213550.32-010326.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151236,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 14986','RN',151236,41.11,0.29,1510,71855,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 14986',0.102567,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151237,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 14986','RN',151237,41.59,0.37,1890,71855,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 14986',0.102567,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151238,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151238,37.91,0.46,382,71856,70,NULL,NULL,'2MASX J21355062-0008494',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000184,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,323.9609583,-0.14714,0.149,NULL,49695346569,776489790,12132652,17.6),(151239,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151239,37.39,0.62,301,71857,70,NULL,NULL,'2MASX J21355753-0853276',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'17.33',0.29,NULL,NULL,NULL,NULL,NULL,1,323.9897917,-8.89108,0.089,NULL,49692278110,776441845,12131903,17.33),(151240,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151240,36.67,0.5,216,71858,70,NULL,NULL,'2MASX J21355876-0423314',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00015,NULL,'16.14',0.41,NULL,NULL,NULL,NULL,NULL,1,323.994917,-4.39214,0.097,NULL,49705964157,776655689,12135245,16.14),(151241,'IRAS','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151241,33.54,0.8,51.1,71859,75,NULL,'MAT, I','ESO 048- G 002',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.000024,NULL,'13.6r',0.6,'Sb',NULL,NULL,NULL,NULL,1,324.000167,-76.34575,0.417,NULL,48530175204,758283987,11848187,13.6),(151242,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151242,33.68,0.45,54.4,71859,NULL,NULL,'K','ESO 048- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151243,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151243,33.73,0.47,55.8,71859,NULL,NULL,'H','ESO 048- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151244,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151244,33.76,0.4,56.5,71859,NULL,NULL,'mean','ESO 048- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151245,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151245,33.81,0.43,57.9,71859,75,NULL,'MAT, I, raw','ESO 048- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151246,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151246,33.82,0.11,58.2,71859,NULL,NULL,NULL,'ESO 048- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151247,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151247,33.87,0.32,59.5,71859,85,NULL,'I, raw','ESO 048- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151248,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151248,33.93,0.32,61,71859,85,NULL,'I, inv','ESO 048- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151249,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151249,33.96,0.49,61.9,71859,75,NULL,'IR','ESO 048- G 002',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151250,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151250,33.97,0.46,62.2,71859,NULL,NULL,'J','ESO 048- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151251,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151251,34.02,0.43,63.7,71859,75,NULL,'MAT, I, cor','ESO 048- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151252,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151252,34.05,0.43,64.6,71859,75,NULL,'MAT, I, inv','ESO 048- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151253,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 10066',NULL,151253,40.9,0.32,1510,71860,70,NULL,'SN photometric redshift distance, z photo =0.447 +/- 0.099','SDSS-II SN 10066',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'G',NULL,'PHOT','22.9g',NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,324.0034583,-0.05417,0.165,NULL,49695353140,776489892,12132654,22.9),(151254,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 10066','R',151254,41.81,0.38,1590,71860,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 10066',0.442393,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151255,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151255,38.98,0.46,625,71861,70,NULL,NULL,'SDSS J213602.93+113348.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000182,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,324.01225,11.56356,0.313,NULL,52294662576,817104102,12767251,18.3),(151256,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21162','RN',151256,42.67,0.31,2170,71862,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 21162',0.570684,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151257,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151257,35.09,0.46,104,71863,70,NULL,NULL,'2MASX J21360388-0320164',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000047,NULL,'15.29',0.59,NULL,NULL,NULL,NULL,NULL,1,324.016083,-3.33775,0.137,NULL,49705342055,776645969,12135093,15.29),(151258,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151258,35.96,0.46,156,71864,70,NULL,NULL,'2MASX J21360817-0735106',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000074,NULL,'16.0g',0.35,'S0/a',NULL,NULL,NULL,NULL,1,324.034125,-7.58619,0.093,NULL,49685073199,776329268,12130144,16),(151259,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151259,36.41,0.58,191,71864,70,NULL,NULL,'2MASX J21360817-0735106',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151260,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151260,37.72,0.46,350,71865,70,NULL,NULL,'2MASX J21361007-0813166',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000091,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,324.041875,-8.22139,0.117,NULL,49684532915,776320826,12130012,16.9),(151261,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151261,34.48,0.47,78.8,71866,NULL,NULL,'H','ESO 343-IG 013 NED01',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000117,NULL,'14.55',0.7,'S?;HII?        LINER','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,324.0440417,-38.54522,0.017,NULL,51476348981,804317952,12567468,14.55),(151262,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151262,34.5,0.4,79.3,71866,NULL,NULL,'mean','ESO 343-IG 013 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151263,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151263,34.56,0.45,81.6,71866,NULL,NULL,'K','ESO 343-IG 013 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151264,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151264,34.68,0.46,86.2,71866,NULL,NULL,'J','ESO 343-IG 013 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151265,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151265,36.21,0.81,174,71867,70,NULL,NULL,'2MASX J21361141-7206436',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.9b',0.37,'S0',NULL,NULL,NULL,NULL,1,324.047875,-72.11211,0.077,NULL,49294109140,770220455,12034694,16.9),(151266,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 08519','RN',151266,42.73,0.34,2420,71868,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 08519',0.4527,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151267,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 17618','RN',151267,43.07,0.3,2580,71869,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17618',0.593405,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151268,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151268,36.46,0.72,196,71870,70,NULL,NULL,'2MASX J21361546-5630409',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'15.4r',0.19,NULL,NULL,NULL,NULL,NULL,1,324.064583,-56.51139,0.041,NULL,48666687714,760416995,11881515,15.4),(151269,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151269,36.5,0.5,199,71871,70,NULL,NULL,'2MASX J21361582-2753447',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.000113,NULL,'14.8r',0.5,'E',NULL,NULL,NULL,NULL,1,324.0660417,-27.89581,0.145,NULL,51465499755,804148433,12564819,14.8),(151270,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151270,36.73,0.54,222,71872,70,NULL,NULL,'2MASX J21361682-0830396',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.62',0.35,NULL,NULL,NULL,NULL,NULL,1,324.070083,-8.511,0.093,NULL,49683824064,776309751,12129839,16.62),(151271,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 13998','RN',151271,37.53,0.2,286,71873,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13998',0.122683,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151272,'BL Lac Luminosity','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151272,42.03,NULL,2540,71874,70,NULL,'nucleus-to-host flux ratio, z > 0.98','GALEXASC J213618.24-444349.6',NULL,'2006AJ....132....1S',2006,1,NULL,NULL,'QSO',NULL,NULL,'19',NULL,'BLLAC',NULL,NULL,NULL,'BL Lac',1,324.0760417,-44.73047,0,NULL,50640971952,791265186,12363518,19),(151273,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151273,37,0.46,251,71875,70,NULL,NULL,'2MASX J21362059+0043148',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000181,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,324.085667,0.72069,0.181,NULL,52096214280,814003348,12718802,16.5),(151274,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151274,34.94,0.49,97.1,71876,75,NULL,'IR','UGC 11776',NULL,'2011yCatp016004901K',2011,1,1.41,NULL,'G',0.000161,NULL,'15.6g',0.25,'Scd:',NULL,NULL,NULL,NULL,1,324.094916667,12.23631,0.309,NULL,52227503507,816054742,12750855,15.6),(151275,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151275,35.75,0.5,142,71877,70,NULL,NULL,'2MASX J21362371-0358222',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.0001,NULL,'16.15',0.53,NULL,NULL,NULL,NULL,NULL,1,324.098875,-3.97286,0.105,NULL,49706046954,776656983,12135265,16.15),(151276,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151276,33.93,0.5,61,71878,70,NULL,NULL,'ESO 107- G 039',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.000083,NULL,'14.53',0.58,'Compact',NULL,NULL,NULL,NULL,1,324.099,-64.42556,0.045,NULL,49357431815,771209872,12050154,14.53),(151277,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151277,37.56,0.46,326,71879,70,NULL,NULL,'2MASX J21362392+0100268',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,324.099625,1.00761,0.189,NULL,52107339544,814177180,12721518,16.7),(151278,'TRGB','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151278,29.7,0.09,8.72,71880,74.4,NULL,NULL,'NGC 7090',NULL,'2013AJ....146...86T',2013,1,7.4,'Position in 1997AJ....113.1548C is incorrect.','G',0.00001,NULL,'11.33',1.3,'SBc? sp','Group non-member, foreground',NULL,NULL,NULL,1,324.12025,-54.55733,0,NULL,48664105916,760376654,11880885,11.33),(151279,'IRAS','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151279,30.09,0.8,10.4,71880,75,NULL,'A82, H','NGC 7090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151280,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151280,28.97,0.43,6.2,71880,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7090',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151281,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151281,28.99,0.35,6.28,71880,NULL,NULL,NULL,'NGC 7090',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151282,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151282,29.01,0.43,6.3,71880,75,NULL,'3.6 micron, color corrected','NGC 7090',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151283,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151283,29.1,0.4,6.6,71880,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 7090',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151284,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151284,29.13,NULL,6.7,71880,NULL,NULL,NULL,'NGC 7090',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151285,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151285,29.43,0.47,7.68,71880,75,NULL,'A82, H, inv','NGC 7090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151286,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151286,29.52,0.47,8.03,71880,75,NULL,'A82, H, raw','NGC 7090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151287,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151287,29.7,0.09,8.72,71880,74.4,NULL,NULL,'NGC 7090',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151288,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151288,29.87,0.47,9.4,71880,75,NULL,'A82, H, cor','NGC 7090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151289,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151289,30.09,0.4,10.4,71880,75,NULL,'B','NGC 7090',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151290,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151290,30.3,0.4,11.5,71880,73,NULL,'IR','NGC 7090',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151291,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151291,30.3,0.4,11.5,71880,75,NULL,NULL,'NGC 7090',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151292,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151292,30.39,0.49,12,71880,75,NULL,'IR','NGC 7090',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151293,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151293,36.39,0.59,190,71881,70,NULL,NULL,'2MASX J21363060-0359292',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'17.32',0.18,NULL,NULL,NULL,NULL,NULL,1,324.1274583,-3.99147,0.105,NULL,49706053875,776657091,12135267,17.32),(151294,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151294,36.2,0.49,173,71882,75,NULL,'IR','UGC 11778',NULL,'2011yCatp016004901K',2011,1,1.14,NULL,'G',NULL,NULL,'16.5',0.15,'Sc',NULL,NULL,NULL,NULL,1,324.1335,5.73828,0.209,NULL,52127745123,814496017,12726500,16.5),(151295,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151295,36.21,NULL,174,71882,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11778',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151296,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151296,36.21,NULL,175,71882,NULL,NULL,'Dipole + Quadrupole','UGC 11778',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151297,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151297,36.22,NULL,175,71882,NULL,NULL,'Dipole','UGC 11778',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151298,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151298,34.41,0.5,76.3,71883,70,NULL,NULL,'MCG -05-51-003',NULL,'2014MNRAS.445.2677S',2014,1,0.65,'6dF DR2 has z = 0.019019.','G',0.00015,NULL,'15.19',0.52,'E',NULL,NULL,NULL,NULL,1,324.1565417,-27.72522,0.185,NULL,51468122531,804189414,12565459,15.19),(151299,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151299,37.59,0.27,330,71884,70,NULL,NULL,'2MASX J21363871+1037226',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000194,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,324.161125,10.62286,0.197,NULL,52296169991,817127656,12767619,17.6),(151300,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151300,37.47,0.46,312,71885,70,NULL,NULL,'2MASX J21363996-0111341',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,324.166583333,-1.19281,0.145,NULL,49709552896,776711764,12136121,17.6),(151301,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20094','RN',151301,42.2,0.24,2180,71886,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 20094',0.266389,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151302,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151302,36.75,0.46,224,71887,70,NULL,NULL,'2MASX J21364239-0642435',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000097,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,324.1767083,-6.71219,0.069,NULL,49681866719,776279167,12129361,16.8),(151303,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151303,35.79,0.46,144,71888,70,NULL,NULL,'II Zw 142',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00018,NULL,'15.5g',0.5,'E0',NULL,NULL,NULL,NULL,1,324.190833,1.249,0.161,NULL,52107367884,814177623,12721525,15.5),(151304,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151304,34.74,0.55,88.6,71889,70,NULL,NULL,'ESO 531- G 009',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000023,NULL,'13.6r',0.4,'SB(r)a:',NULL,NULL,NULL,NULL,1,324.203,-22.80542,0.073,NULL,50927238437,795738100,12433407,13.6),(151305,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151305,37.59,0.27,330,71890,70,NULL,NULL,'2MASX J21365051+1037356',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00017,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,324.2102917,10.62658,0.197,NULL,52296167682,817127620,12767619,18),(151306,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07951','RN',151306,40.89,0.26,1350,71891,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 07951',0.119055,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151307,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07951','RN',151307,41.07,0.33,1460,71891,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 07951',0.119055,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151308,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151308,35.44,0.48,123,71892,70,NULL,NULL,'2MASX J21365416-2020375',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.00015,NULL,'14.3r',0.52,'E',NULL,NULL,NULL,NULL,1,324.225791667,-20.34375,0.081,NULL,50935468087,795866688,12435417,14.3),(151309,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 19722','RN',151309,41.85,0.22,1860,71893,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19722',0.259634,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151310,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 19722','RN',151310,42.72,0.41,2780,71893,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19722',0.259634,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151311,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151311,38.07,0.46,410,71894,70,NULL,NULL,'2MASX J21365872+1119067',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,324.244583,11.31844,0.297,NULL,52295048057,817110125,12767345,17.8),(151312,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 13732','RN',151312,41.8,0.29,1640,71895,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13732',0.402256,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151313,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 13732','RN',151313,42.16,0.41,1930,71895,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13732',0.402256,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151314,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07785','RN',151314,43.37,0.28,3170,71896,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 07785',0.487872,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151315,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151315,36.55,0.33,204,71897,70,NULL,NULL,'UGC 11780 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00015,NULL,'16.17',0.4,NULL,NULL,NULL,NULL,NULL,1,324.284875,0.44642,0.181,NULL,52096394860,814006169,12718846,16.17),(151316,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151316,37.59,0.27,330,71898,70,NULL,NULL,'2MASX J21371178+1039498',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000185,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,324.299083,10.66381,0.197,NULL,52296192112,817128001,12767625,16.9),(151317,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151317,38.76,0.46,564,71899,70,NULL,NULL,'SDSS J213716.28-074759.2',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000078,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,324.317833333,-7.79981,0.109,NULL,49684004941,776312577,12129884,17.9),(151318,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151318,37.34,0.46,293,71900,70,NULL,NULL,'2MASX J21372146-0828558',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,324.339416667,-8.48214,0.105,NULL,49683722775,776308168,12129815,17.1),(151319,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151319,36.55,0.33,204,71901,70,NULL,NULL,'CGCG 376-017',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00011,NULL,'15.5',0.28,NULL,'Group member',NULL,NULL,NULL,1,324.342,0.39628,0.181,NULL,52096354482,814005538,12718836,15.5),(151320,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151320,37.16,0.65,271,71902,70,NULL,NULL,'2MASX J21372239-0356431',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'17.43',0.25,NULL,NULL,NULL,NULL,NULL,1,324.343333,-3.94542,0.121,NULL,49706616401,776665881,12135404,17.43),(151321,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151321,36.02,0.66,160,71903,70,NULL,NULL,'2MASX J21372379-7051001',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'15.3r',0.3,NULL,NULL,NULL,NULL,NULL,1,324.348833333,-70.85003,0.049,NULL,49301874329,770341786,12036590,15.3),(151322,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151322,36.96,0.56,247,71904,70,NULL,NULL,'2MASX J21372793-5542163',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.00015,NULL,'14.9r',0.32,NULL,NULL,NULL,NULL,NULL,1,324.366333,-55.70456,0.045,NULL,48665191924,760393623,11881150,14.9),(151323,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151323,34.89,0.72,95,71905,70,NULL,NULL,'ESO 287- G 040',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00007,NULL,'14.25',0.9,'Ring?',NULL,NULL,NULL,NULL,1,324.367417,-47.03583,0.021,NULL,50639414686,791240854,12363138,14.25),(151324,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151324,34.79,0.49,90.7,71906,70,NULL,NULL,'MCG -05-51-004',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.00013,NULL,'15.44',0.4,'E',NULL,NULL,NULL,NULL,1,324.379167,-29.44453,0.073,NULL,51472048877,804250763,12566418,15.44),(151325,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151325,35.7,0.69,138,71907,70,NULL,NULL,'2MASX J21373182-3102033',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'15.0r',0.3,'E',NULL,NULL,NULL,NULL,1,324.3825417,-31.03422,0.073,NULL,51471159536,804236867,12566201,15),(151326,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151326,36.37,0.6,188,71908,70,NULL,NULL,'2MASX J21373293-1441386',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000057,NULL,'16.54',0.36,NULL,NULL,NULL,NULL,NULL,1,324.38725,-14.69414,0.165,NULL,50888055819,795125872,12423841,16.54),(151327,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151327,38.25,0.46,447,71909,70,NULL,NULL,'2MASX J21373659-0812569',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,324.4025,-8.21592,0.105,NULL,49684603239,776321925,12130030,18),(151328,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06561','RN',151328,42.24,0.27,2700,71910,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06561',0.040943,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151329,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06561','RN',151329,43.02,0.34,3860,71910,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06561',0.040943,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151330,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 09273','R',151330,38.65,0.14,488,71911,70,NULL,'SDSS CAND. SNIc; MLCS2K2; SN 2005ks','SN 2005ks',0.098826,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ib/c',NULL,NULL,NULL,NULL,1,324.485666667,-0.03247,0.193,NULL,49695785574,776496649,12132760,NULL),(151331,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 09273','R',151331,38.97,0.21,566,71911,70,NULL,'SDSS CAND. SNIc; SALT 2; SN 2005ks','SN 2005ks',0.098826,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151332,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151332,37.57,0.33,326,71912,70,NULL,NULL,'2MASX J21375671+0100284',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,324.486417,1.00778,0.161,NULL,52096101717,814001589,12718774,17.8),(151333,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151333,36.25,0.76,178,71913,70,NULL,NULL,'2MASX J21380140-1150353',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.84',0.37,NULL,NULL,NULL,NULL,NULL,1,324.50575,-11.84317,0.137,NULL,49896381306,779630957,12181733,16.84),(151334,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151334,36.71,0.33,219,71914,70,NULL,NULL,'2MASX J21380280-0706403',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00008,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,324.511625,-7.11114,0.109,NULL,49682279924,776285623,12129462,16.7),(151335,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151335,36.8,0.63,229,71915,70,NULL,NULL,'2MASX J21380486-0426179',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'17.24',0.22,'poss. LINER',NULL,NULL,NULL,NULL,1,324.5202083,-4.43833,0.101,NULL,49705983471,776655991,12135249,17.24),(151336,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151336,35.84,0.51,147,71916,70,NULL,NULL,'2MASX J21380697-2641578',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'14.8r',0.37,'S0',NULL,NULL,NULL,NULL,1,324.529,-26.69939,0.129,NULL,51464897779,804139027,12564672,14.8),(151337,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151337,34.97,0.48,98.8,71917,70,NULL,NULL,'ESO 287- G 042',NULL,'2014MNRAS.445.2677S',2014,1,0.75,'This is not NGC 7095.  That is = NGC 7097.','G',0.000133,NULL,'13.9r',0.5,'S0?            AGN',NULL,NULL,NULL,'Sy 1.8',1,324.533083333,-42.60486,0,NULL,51358076799,802469949,12538592,13.9),(151338,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151338,35.63,0.72,133,71918,70,NULL,NULL,'2MASX J21380821-1152123',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'16.55',0.36,NULL,NULL,NULL,NULL,NULL,1,324.53425,-11.86997,0.137,NULL,49896389307,779631082,12181735,16.55),(151339,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151339,31.15,0.4,17,71919,75,NULL,'B','UGC 11782',NULL,'1988NBGC.C....0000T',1988,1,2.2,NULL,'G',0.000013,NULL,'14.5',1.3,'SB(s)m',NULL,NULL,NULL,NULL,1,324.540417,8.96139,0.113,NULL,52300932131,817202064,12768782,14.5),(151340,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151340,31.22,0.4,17.5,71919,73,NULL,'opt','UGC 11782',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151341,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01760','RN',151341,43.13,0.24,3040,71920,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01760',0.394171,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151342,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01760','RN',151342,43.79,0.24,4110,71920,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01760',0.394171,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151343,'IRAS','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151343,32.44,0.8,30.7,71921,75,NULL,'MAT, I','ESO 287- G 043',NULL,'1997ApJS..109..333W',1997,1,1.89,NULL,'G',0.000033,NULL,'14.49',0.3,'Scd? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,324.5519583,-43.9345,0,NULL,50648563080,791383798,12365371,14.49),(151344,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151344,32.05,0.43,25.7,71921,75,NULL,'3.6 micron, color + selection bias corrected','ESO 287- G 043',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151345,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151345,32.06,0.4,25.8,71921,73,NULL,'IR','ESO 287- G 043',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151346,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151346,32.06,0.4,25.8,71921,75,NULL,NULL,'ESO 287- G 043',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151347,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151347,32.12,0.4,26.5,71921,73,NULL,'opt','ESO 287- G 043',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151348,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151348,32.12,0.32,26.5,71921,85,NULL,'I, inv','ESO 287- G 043',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151349,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151349,32.13,0.43,26.7,71921,75,NULL,'3.6 micron, color corrected','ESO 287- G 043',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151350,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151350,32.14,0.32,26.8,71921,85,NULL,'I, raw','ESO 287- G 043',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151351,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151351,32.18,0.2,27.3,71921,74.4,NULL,NULL,'ESO 287- G 043',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151352,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151352,32.18,0.4,27.3,71921,NULL,NULL,NULL,'ESO 287- G 043',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151353,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151353,32.4,0.43,30.2,71921,75,NULL,'MAT, I, inv','ESO 287- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151354,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151354,32.41,0.43,30.3,71921,75,NULL,'MAT, I, raw','ESO 287- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151355,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151355,32.48,0.49,31.3,71921,75,NULL,'IR','ESO 287- G 043',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151356,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151356,32.52,0.11,32,71921,NULL,NULL,NULL,'ESO 287- G 043',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151357,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151357,32.59,0.43,33,71921,75,NULL,'MAT, I, cor','ESO 287- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151358,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151358,37.57,0.33,326,71922,70,NULL,NULL,'2MASX J21381298+0057484',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,324.5542083,0.96336,0.161,NULL,52096029902,814000467,12718757,17.7),(151359,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151359,37.15,0.46,269,71923,70,NULL,NULL,'2MASX J21381360+1047581',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000186,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,324.556667,10.79961,0.189,NULL,52298488751,817163886,12768185,17.2),(151360,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151360,36.71,0.33,219,71924,70,NULL,NULL,'2MASX J21381812-0709152',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00015,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,324.5755,-7.15411,0.109,NULL,49682303163,776285986,12129468,16.3),(151361,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151361,36.85,0.67,235,71924,70,NULL,NULL,'2MASX J21381812-0709152',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151362,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151362,35.89,0.55,151,71925,70,NULL,NULL,'PRC B-20',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'15.90',0.5,'E',NULL,NULL,NULL,NULL,1,324.5835417,-21.31836,0.069,NULL,50932111745,795814246,12434597,15.9),(151363,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151363,36.9,0.46,240,71926,70,NULL,NULL,'2MASX J21382110-0041122',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000157,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,324.588125,-0.68683,0.149,NULL,49695964595,776499446,12132803,17),(151364,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151364,37.12,0.78,265,71927,70,NULL,NULL,'2MASX J21382518-0446162',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'17.57',0.21,NULL,NULL,NULL,NULL,NULL,1,324.605,-4.77119,0.097,NULL,49703346218,776614784,12134606,17.57),(151365,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151365,37.12,0.27,265,71928,70,NULL,NULL,'2MASX J21382557+1132595',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,324.606583,11.54983,0.317,NULL,52295374272,817115223,12767425,17.8),(151366,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151366,36.64,0.46,213,71929,70,NULL,NULL,'2MASX J21382644-0041402',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,324.61025,-0.69464,0.149,NULL,49695963734,776499433,12132803,17.7),(151367,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151367,37.77,0.46,358,71930,70,NULL,NULL,'2MASX J21382709+0033107',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,324.6129583,0.55311,0.173,NULL,52095740904,813995951,12718686,17.6),(151368,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07102','R',151368,40.35,0.11,981,71931,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 07102',0.196407,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,324.619916667,-0.61558,0.149,NULL,49695829213,776497331,12132770,NULL),(151369,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07102','R',151369,40.42,0.19,1010,71931,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 07102',0.196407,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151370,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151370,35.79,0.5,144,71932,70,NULL,NULL,'2MASX J21382882-5429093',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000073,NULL,'14.6r',0.2,'S',NULL,NULL,NULL,NULL,1,324.6202083,-54.48622,0,NULL,48665992922,760406139,11881345,14.6),(151371,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151371,38.12,0.46,421,71933,70,NULL,NULL,'2MASX J21382983-0837261',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000142,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,324.624375,-8.62397,0.105,NULL,49905070357,779766724,12183855,17.9),(151372,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151372,36.49,0.46,199,71934,70,NULL,NULL,'2MASX J21383186-0814161',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,324.632625,-8.23781,0.105,NULL,49905476294,779773067,12183954,16.4),(151373,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151373,36.35,0.46,186,71935,70,NULL,NULL,'2MASX J21383461-0754261',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000023,NULL,'15.4g',0.56,'S0^-',NULL,NULL,NULL,NULL,1,324.644125,-7.90717,0.113,NULL,49683937912,776311529,12129867,15.4),(151374,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151374,36.77,0.5,226,71935,70,NULL,NULL,'2MASX J21383461-0754261',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151375,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151375,37.12,0.27,265,71936,70,NULL,NULL,'SDSS J213836.22+112800.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,324.650958333,11.46686,0.317,NULL,52295372580,817115196,12767424,17.9),(151376,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01615','RN',151376,39.36,0.81,687,71937,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 01615',0.082675,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151377,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151377,37.12,0.27,265,71938,70,NULL,NULL,'2MASX J21383803+1118425',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000188,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,324.658583333,11.31169,0.317,NULL,52298399318,817162489,12768163,16.7),(151378,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151378,36.33,0.72,184,71939,70,NULL,NULL,'2MASX J21383930-0640001',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.0g',0.27,'Sa',NULL,NULL,NULL,NULL,1,324.6637083,-6.66669,0.109,NULL,49682409724,776287651,12129494,16),(151379,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151379,37.53,0.46,320,71940,70,NULL,NULL,'2MASX J21383959-0739321',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000146,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,324.665,-7.65883,0.125,NULL,49683891615,776310806,12129856,17.9),(151380,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151380,37.5,0.46,317,71941,70,NULL,NULL,'2MASX J21383988-0824161',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00015,NULL,'16.9g',0.23,'BrClG',NULL,NULL,NULL,NULL,1,324.666,-8.40447,0.105,NULL,49905742953,779777233,12184019,16.9),(151381,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151381,34.25,0.2,70.8,71942,74.4,NULL,NULL,'CGCG 493-003',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000033,NULL,'15.5',0.5,'Sc',NULL,NULL,NULL,NULL,1,324.675,29.83764,0.709,NULL,55633167276,869268238,13582316,15.5),(151382,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151382,34.45,0.45,77.8,71942,NULL,NULL,NULL,'CGCG 493-003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151383,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151383,34.54,0.44,81,71942,NULL,NULL,'Malmquist cor.','CGCG 493-003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151384,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151384,35.52,0.48,127,71943,70,NULL,NULL,'FAIRALL 0110',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'14.6r',0.4,'Bright nucleus',NULL,NULL,NULL,NULL,1,324.6765417,-72.7785,0.149,NULL,49292868034,770201063,12034391,14.6),(151385,'IRAS','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151385,33.1,0.8,41.7,71944,75,NULL,'MAT, I','NGC 7096A',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'14.12',0.6,'SAB(s)bc pec?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,324.701125,-64.35019,0.045,NULL,49357351406,771208615,12050134,14.12),(151386,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151386,32.58,0.32,32.8,71944,85,NULL,'I, raw','NGC 7096A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151387,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151387,32.59,0.32,33,71944,85,NULL,'I, inv','NGC 7096A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151388,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151388,32.86,0.4,37.3,71944,NULL,NULL,NULL,'NGC 7096A',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151389,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151389,32.87,0.43,37.5,71944,75,NULL,'MAT, I, raw','NGC 7096A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151390,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151390,32.97,0.43,39.3,71944,75,NULL,'MAT, I, inv','NGC 7096A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151391,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151391,33.03,0.43,40.4,71944,75,NULL,'MAT, I, cor','NGC 7096A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151392,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151392,36.98,0.46,249,71945,70,NULL,NULL,'2MASX J21384966+1231345',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,324.706917,12.52625,0.301,NULL,52228423602,816069118,12751079,17.8),(151393,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151393,36.52,0.46,201,71946,70,NULL,NULL,'2MASX J21385447+0056149',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,324.727,0.93736,0.169,NULL,52096477375,814007458,12718866,17.5),(151394,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151394,35.95,0.62,155,71947,70,NULL,NULL,'2MASX J21385908-7831571',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,324.74625,-78.53256,0.481,NULL,48578353927,759036780,11859949,17),(151395,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 02744','R',151395,38.36,0.2,455,71948,70,NULL,'SDSS CAND. SNIb; SALT 2; SN 2005hm','SN 2005hm',0.034782,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ib',NULL,NULL,NULL,NULL,1,324.7527083,-1.02742,0.177,NULL,49697455246,776522738,12133167,NULL),(151396,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 02744','R',151396,38.52,0.06,488,71948,70,NULL,'SDSS CAND. SNIb; MLCS2K2; SN 2005hm','SN 2005hm',0.034782,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151397,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151397,35.98,0.49,157,71949,NULL,NULL,'Malmquist cor.','ESO 600- G 005',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.9r',0.6,'S...',NULL,NULL,NULL,NULL,1,324.794083,-20.85272,0.077,NULL,50931776609,795809009,12434515,14.9),(151398,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:10','1',NULL,NULL,151398,36.41,0.4,191,71949,NULL,NULL,NULL,'ESO 600- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151399,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:10','1',NULL,NULL,151399,36.45,0.2,195,71949,74.4,NULL,NULL,'ESO 600- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151400,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:10','1','SDSS-II SN 06887','RN',151400,40.41,0.42,1090,71950,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06887',0.105008,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151401,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:10','1','SDSS-II SN 06887','RN',151401,41.47,0.36,1780,71950,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06887',0.105008,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151402,'FP','2016-12-15 15:15:56','2016-12-16 11:21:10','1',NULL,'R',151402,37.57,0.27,326,71951,70,NULL,NULL,'2MASX J21391188+1156210',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000166,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,324.7992917,11.93931,0.353,NULL,52295365605,817115087,12767423,16.9),(151403,'FP','2016-12-15 15:15:56','2016-12-16 11:21:10','1',NULL,'R',151403,36.53,0.46,202,71952,70,NULL,NULL,'CGCG 376-019',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.00011,NULL,'15.7g',0.49,'E0',NULL,NULL,NULL,NULL,1,324.8045,-0.50853,0.165,NULL,49697898470,776529663,12133275,15.7),(151404,'FP','2016-12-15 15:15:56','2016-12-16 11:21:10','1',NULL,'R',151404,37.57,0.27,326,71953,70,NULL,NULL,'SDSS J213915.70+115815.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000151,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,324.8154583,11.97106,0.353,NULL,52295366969,817115108,12767423,18.7),(151405,'FP','2016-12-15 15:15:56','2016-12-16 11:21:10','1',NULL,'R',151405,37.58,0.27,328,71954,70,NULL,NULL,'2MASX J21392009+1032270',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'17.46',0.42,NULL,NULL,NULL,NULL,NULL,1,324.833625,10.54075,0.221,NULL,52296426775,817131668,12767682,17.46),(151406,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:10','1','SDSS-II SN 13300','RN',151406,38.28,0.34,414,71955,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 13300',0.091421,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151407,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13300','RN',151407,39.17,0.38,626,71955,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 13300',0.091421,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151408,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151408,36.87,0.59,237,71956,70,NULL,NULL,'2MASX J21392273-5043289',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'15.0r',0.47,'S0',NULL,NULL,NULL,NULL,1,324.844875,-50.72469,0,NULL,50660938307,791577161,12368393,15),(151409,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151409,37.2,0.46,275,71957,70,NULL,NULL,'SDSS J213923.90+004654.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,324.849625,0.78169,0.209,NULL,52097323991,814020687,12719073,17.8),(151410,'BL Lac Luminosity','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151410,39.79,NULL,907,71958,70,NULL,'nucleus-to-host flux ratio, z > 0.24','WISE J213924.16-423520.3',NULL,'2006AJ....132....1S',2006,1,NULL,NULL,'G',NULL,NULL,'17.5',NULL,'BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,324.850667,-42.589,0,NULL,50635283534,791176305,12362129,17.5),(151411,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 02347','RN',151411,41.09,0.44,1170,71959,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02347',0.403882,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151412,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 02347','RN',151412,41.8,0.47,1630,71959,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 02347',0.403882,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151413,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 02172','RN',151413,40.92,0.23,1320,71960,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02172',0.156773,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151414,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 02172','RN',151414,41.69,0.25,1890,71960,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02172',0.156773,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151415,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151415,33.95,0.49,61.7,71961,75,NULL,'IR','UGC 11785',NULL,'2011yCatp016004901K',2011,1,1.68,NULL,'G',0.000033,NULL,'15.18',0.17,'Sd','Isolated galaxy',NULL,NULL,NULL,1,324.8615,2.82711,0.217,NULL,52108913391,814201771,12721902,15.18),(151416,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151416,33.99,0.79,62.8,71961,NULL,NULL,'Malmquist cor.','UGC 11785',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151417,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151417,34.11,0.2,66.4,71961,74.4,NULL,NULL,'UGC 11785',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151418,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151418,34.19,0.72,68.9,71961,NULL,NULL,NULL,'UGC 11785',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151419,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151419,34.47,NULL,78.2,71961,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11785',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151420,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151420,34.49,NULL,79.2,71961,NULL,NULL,'Dipole + Quadrupole','UGC 11785',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151421,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151421,34.5,NULL,79.3,71961,NULL,NULL,'Dipole','UGC 11785',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151422,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151422,37.48,0.46,313,71962,70,NULL,NULL,'2MASX J21393111-0735067',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,324.879625,-7.58528,0.125,NULL,49904095524,779751492,12183617,16.4),(151423,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 02116','RN',151423,40.41,0.22,924,71963,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 02116',0.3078,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151424,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 02116','RN',151424,40.62,0.3,1020,71963,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 02116',0.3078,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151425,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16734','RN',151425,41.14,0.28,1420,71964,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16734',0.190059,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151426,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151426,37.57,0.27,326,71965,70,NULL,NULL,'2MASX J21393758+1158056',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.0002,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,324.90675,11.96817,0.353,NULL,52295327271,817114488,12767413,18.1),(151427,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151427,38.78,0.46,570,71966,70,NULL,NULL,'2MASX J21393767-0816546',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000198,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,324.907125,-8.28189,0.093,NULL,49905614038,779775219,12183987,18.1),(151428,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151428,33.79,0.49,57.2,71967,75,NULL,'IR','UGC 11786 NOTES01',NULL,'2011yCatp016004901K',2011,1,0.45,NULL,'G',0.00005,NULL,'15.43',0.1,NULL,NULL,NULL,NULL,NULL,1,324.9289583,6.26794,0.189,NULL,52118480219,814351253,12724238,15.43),(151429,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151429,37.58,0.27,328,71968,70,NULL,NULL,'II Zw 143 NOTES02',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,'FoF','18.3',0.31,NULL,NULL,NULL,NULL,NULL,1,324.9300417,10.3305,0.221,NULL,52295975899,817124623,12767572,18.3),(151430,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151430,35.86,0.46,149,71969,70,NULL,NULL,'II Zw 143 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000127,NULL,'14.8g',0.68,'E0',NULL,NULL,NULL,NULL,1,324.930916667,10.3375,0.221,NULL,52295975724,817124620,12767572,14.8),(151431,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151431,37.27,0.33,285,71970,70,NULL,NULL,'2MASX J21394398+1243177',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000148,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,324.933167,12.72147,0.305,NULL,52227829458,816059835,12750934,17.4),(151432,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151432,34.63,0.56,84.1,71971,70,NULL,NULL,'2MASX J21394628-2952372',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.00013,NULL,'15.46',0.33,'S',NULL,NULL,NULL,NULL,1,324.942791667,-29.87706,0.073,NULL,51472486313,804257598,12566524,15.46),(151433,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151433,37.24,0.46,281,71972,70,NULL,NULL,'2MASX J21394680-0852086',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000148,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,324.945,-8.86903,0.097,NULL,49905834193,779778659,12184041,17.6),(151434,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151434,34.44,0.49,77.2,71973,70,NULL,NULL,'ESO 403- G 012',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000037,NULL,'13.75',1.3,'(R:)SAB(r)a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,324.965583,-36.03697,0.045,NULL,51452999836,803953122,12561767,13.75),(151435,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151435,35.39,0.69,120,71974,70,NULL,NULL,'2MASX J21395237-2245361',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'14.6r',0.4,'S0',NULL,NULL,NULL,NULL,1,324.968167,-22.76,0.081,NULL,50924775214,795699612,12432806,14.6),(151436,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151436,37.58,0.27,328,71975,70,NULL,NULL,'2MASX J21395419+1021516',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000181,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,324.975791667,10.36436,0.221,NULL,52296092572,817126446,12767600,17),(151437,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151437,38.52,0.33,506,71976,70,NULL,NULL,'SDSS J213956.35+122955.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000203,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,324.984833,12.49878,0.317,NULL,52227988188,816062315,12750973,18.7),(151438,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151438,37.7,0.46,347,71977,70,NULL,NULL,'2MASX J21395655-0014589',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,324.9857917,-0.24978,0.161,NULL,49697824484,776528507,12133257,17.8),(151439,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 02117','RN',151439,41.54,0.52,1720,71978,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02117',0.184662,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151440,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151440,34.62,0.56,84,71979,70,NULL,NULL,'MCG -04-51-007',NULL,'2014MNRAS.445.2677S',2014,1,0.71,NULL,'G',0.000107,NULL,'14.97',0.67,'S0',NULL,NULL,NULL,NULL,1,324.996583,-22.69217,0.081,NULL,50924808005,795700125,12432814,14.97),(151441,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151441,37.31,0.46,290,71980,70,NULL,NULL,'2MASXi J2140002-084140',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,325.0010417,-8.69464,0.093,NULL,49905920981,779780015,12184062,17.6),(151442,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2005ld',NULL,151442,38.46,0.12,430,71981,74.2,NULL,'SALT 2','SDSS J214000.48-000002.9',0.1442,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,'PHOT',NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,325.002,-0.00081,0.197,NULL,49694384203,776474753,12132418,NULL),(151443,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2005ld',NULL,151443,39.05,0.05,564,71981,70,NULL,'SDSS-II SN 08921','SDSS J214000.48-000002.9',0.1442,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151444,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 08921','R',151444,39.24,0.18,615,71981,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ld','SDSS J214000.48-000002.9',0.145387,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151445,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2005ld',NULL,151445,39.26,0.1,623,71981,65,NULL,'SALT2','SDSS J214000.48-000002.9',0.1442,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151446,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 08921','R',151446,39.46,0.11,680,71981,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ld','SDSS J214000.48-000002.9',0.145387,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151447,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2005ld',NULL,151447,39.47,0.1,685,71981,65,NULL,'MLCS2k2','SDSS J214000.48-000002.9',0.1442,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151448,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2005ld',NULL,151448,39.18,0.07,685,71981,70,NULL,'SALT 2','SDSS J214000.48-000002.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151449,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2005ld',NULL,151449,39.18,0.07,685,71981,70,NULL,'SALT 2, Malmquist cor.','SDSS J214000.48-000002.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151450,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151450,36.2,0.55,174,71982,70,NULL,NULL,'2MASX J21400073-0643245',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,325.002958333,-6.72364,0.113,NULL,49903956483,779749320,12183583,16.5),(151451,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151451,33.86,0.8,59.2,71982,75,NULL,'MAT, I','ESO 287- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151452,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151452,33.82,0.43,58,71982,75,NULL,'MAT, I, raw','ESO 287- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151453,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151453,33.9,0.32,60.3,71982,85,NULL,'I, raw','ESO 287- G 046',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151454,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151454,33.93,0.32,61,71982,85,NULL,'I, inv','ESO 287- G 046',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151455,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151455,33.95,0.43,61.5,71982,75,NULL,'MAT, I, inv','ESO 287- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151456,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151456,34.12,0.43,66.8,71982,75,NULL,'MAT, I, cor','ESO 287- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151457,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151457,37.27,0.33,285,71983,70,NULL,NULL,'SDSS J214001.40+124652.9',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,325.005875,12.78136,0.305,NULL,52227808819,816059512,12750929,17.1),(151458,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151458,36.55,0.46,204,71984,70,NULL,NULL,'2MASX J21400194+0003020',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000148,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,325.00825,0.05061,0.197,NULL,52093785614,813965400,12718209,17.3),(151459,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151459,37.29,0.46,287,71985,70,NULL,NULL,'2MASX J21400217+1046237',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,325.0090417,10.77314,0.209,NULL,52297918527,817154976,12768046,17.5),(151460,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151460,33.71,0.49,55.1,71986,70,NULL,NULL,'ESO 107- G 044',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'13.85',0.6,'SAB(s)0^0^?','in a triple',NULL,NULL,NULL,1,325.01425,-63.90894,0.045,NULL,49343083401,770985678,12046651,13.85),(151461,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13677','R',151461,41,0.28,1210,71987,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J214004.88-010117.1',0.3045,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',0.01,NULL,'20.3g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,325.020375,-1.02142,0.149,NULL,49698254677,776535229,12133362,20.3),(151462,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13677','R',151462,41.26,0.22,1370,71987,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J214004.88-010117.1',0.3045,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151463,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13677',NULL,151463,40.82,0.17,1460,71987,70,NULL,'SALT 2','SDSS J214004.88-010117.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151464,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13677',NULL,151464,40.85,0.17,1480,71987,70,NULL,'SALT 2, Malmquist cor.','SDSS J214004.88-010117.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151465,'SBF','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151465,32.52,0.14,31.9,71988,74.4,NULL,NULL,'NGC 7097',NULL,'2013AJ....146...86T',2013,1,1.9,'SGC incorrectly calls this galaxy NGC 7095.','G',0.000063,NULL,'12.61',1.3,'E              LINER','in a pair',NULL,NULL,NULL,1,325.0537917,-42.53939,0,NULL,50635303466,791176616,12362134,12.61),(151466,'SBF','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151466,32.55,0.21,32.4,71988,NULL,NULL,'I','NGC 7097',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151467,'Faber-Jackson','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151467,31.12,0.65,16.7,71988,95,NULL,'Weighted Mean','NGC 7097',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151468,'Faber-Jackson','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151468,32.36,0.81,29.6,71988,55,NULL,'Visvanathan & Sandage 1979','NGC 7097',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151469,'Tully est','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151469,32.41,0.8,30.4,71988,75,NULL,'B','NGC 7097',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151470,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151470,32.64,0.4,33.7,71988,NULL,NULL,'mean','NGC 7097',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151471,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151471,33.08,0.45,41.2,71988,NULL,NULL,'K','NGC 7097',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151472,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151472,35.47,0.5,124,71989,70,NULL,NULL,'IC 1393',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000143,NULL,'15.45',0.5,'S0',NULL,NULL,NULL,NULL,1,325.059375,-22.41139,0.061,NULL,50924939120,795702173,12432846,15.45),(151473,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 17541',NULL,151473,40.14,0.24,1070,71990,70,NULL,'SN photometric redshift distance, z photo =0.290 +/- 0.041','SDSS-II SN 17541',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,325.059333,0.72586,0.197,NULL,52096745758,814011652,12718932,NULL),(151474,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 17541','R',151474,40.67,0.25,1080,71990,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 17541',0.267938,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151475,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 17541','R',151475,40.71,0.2,1090,71990,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 17541',0.267938,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151476,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151476,38.52,0.33,506,71991,70,NULL,NULL,'2MASX J21401729+1235525',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,325.072125,12.59792,0.325,NULL,52227844085,816060063,12750938,17.9),(151477,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151477,36.96,0.46,246,71992,70,NULL,NULL,'2MASX J21401790-0043445',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00015,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,325.074667,-0.72886,0.165,NULL,49697951697,776530495,12133288,16.4),(151478,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151478,37,0.54,251,71993,70,NULL,NULL,'2MASX J21401977-3254205',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'15.1r',0.33,NULL,NULL,NULL,NULL,NULL,1,325.082375,-32.90572,0.053,NULL,51451759196,803933737,12561464,15.1),(151479,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151479,36.27,0.53,179,71994,70,NULL,NULL,'2MASX J21402291-5716265',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'15.4r',0.28,NULL,NULL,NULL,NULL,NULL,1,325.095625,-57.27403,0.041,NULL,48715677470,761182460,11893475,15.4),(151480,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151480,33.16,0.8,42.8,71995,75,NULL,'MAT, I','ESO 531- G 022',NULL,'1997ApJS..109..333W',1997,1,3.02,NULL,'G',0.000013,NULL,'14',0.36,'Sc',NULL,NULL,NULL,NULL,1,325.122791667,-26.52794,0.089,NULL,51464883460,804138804,12564668,14),(151481,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151481,33.21,0.49,43.9,71995,75,NULL,'IR','ESO 531- G 022',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151482,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151482,33.26,0.43,44.8,71995,75,NULL,'MAT, I, raw','ESO 531- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151483,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151483,33.38,0.32,47.5,71995,85,NULL,'I, raw','ESO 531- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151484,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151484,33.43,0.32,48.5,71995,85,NULL,'I, inv','ESO 531- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151485,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151485,33.46,0.43,49.3,71995,75,NULL,'MAT, I, inv','ESO 531- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151486,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151486,33.49,0.2,49.9,71995,74.4,NULL,NULL,'ESO 531- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151487,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151487,33.5,0.43,50.1,71995,75,NULL,'MAT, I, cor','ESO 531- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151488,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151488,33.55,0.49,51.2,71995,NULL,NULL,'Malmquist cor.','ESO 531- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151489,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151489,33.64,0.46,53.5,71995,NULL,NULL,NULL,'ESO 531- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151490,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151490,33.87,NULL,59.5,71995,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 531- G 022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151491,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151491,33.88,NULL,59.6,71995,NULL,NULL,'Dipole + Quadrupole','ESO 531- G 022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151492,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151492,33.88,NULL,59.8,71995,NULL,NULL,'Dipole','ESO 531- G 022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151493,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151493,33.89,NULL,60.1,71995,NULL,NULL,NULL,'ESO 531- G 022',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151494,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151494,35.98,0.56,157,71996,70,NULL,NULL,'2MASX J21403336-1320432',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.71',0.34,NULL,NULL,NULL,NULL,NULL,1,325.1392083,-13.34531,0.137,NULL,49765115745,777579933,12149686,16.71),(151495,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151495,36.84,0.51,233,71997,70,NULL,NULL,'2MASX J21403539-4948179',NULL,'2014MNRAS.445.2677S',2014,1,0.79,NULL,'G',0.000133,NULL,'14.2r',0.52,'E',NULL,NULL,NULL,NULL,1,325.1475417,-49.80497,0,NULL,50663850980,791622671,12369104,14.2),(151496,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 02008','RN',151496,40.91,0.23,1300,71998,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02008',0.165129,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151497,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 02008','RN',151497,41.27,0.26,1540,71998,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02008',0.165129,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151498,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13719','RN',151498,40.79,0.29,1280,71999,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13719',0.119584,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151499,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151499,35.34,0.53,117,72000,70,NULL,NULL,'ABELL S0963:[GMT93] M',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.75',0.23,'Sa',NULL,NULL,NULL,NULL,1,325.154958333,-22.33969,0.061,NULL,50924904073,795701626,12432837,16.75),(151500,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151500,36.35,0.46,186,72001,70,NULL,NULL,'2MASX J21403847-0722017',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,325.16025,-7.36706,0.077,NULL,49904180063,779752813,12183637,17.1),(151501,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151501,37.29,0.46,288,72002,70,NULL,NULL,'2MASX J21403869+1143216',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000157,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,325.161333,11.72278,0.277,NULL,52298249418,817160147,12768127,17),(151502,'SNII optical','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN ASASSN-13co','R',151502,34.46,0.23,78,72003,73,NULL,'EPM','CGCG 402-014',NULL,'2014arXiv1411.3322H',2014,1,0.6,NULL,'G',NULL,NULL,'15.7',0.4,NULL,NULL,NULL,NULL,NULL,1,325.1622917,6.50978,0.153,NULL,52299014735,817172105,12768314,15.7),(151503,'Magnitude','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151503,35.96,0.13,156,72004,100,NULL,NULL,'2MASX J21404094-1416322',NULL,'1998A&A...337...31R',1998,1,0.29,NULL,'G',0.00013,NULL,'17.81',0.23,NULL,NULL,NULL,NULL,NULL,1,325.170625,-14.27561,0.165,NULL,50887808659,795122010,12423781,17.81),(151504,'Magnitude','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151504,35.96,0.13,156,72005,100,NULL,NULL,'ABELL 2362',NULL,'1998A&A...337...31R',1998,1,NULL,'Katgert (1996,A&A,310,8) identifies multiple redshift systems in this cluster.','GClstr',NULL,NULL,NULL,NULL,'II     [BM]',NULL,NULL,NULL,NULL,1,325.181875,-14.27236,0.165,NULL,50887808679,795122010,12423781,NULL),(151505,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151505,36.34,0.25,185,72006,74.4,NULL,NULL,'GIN 659',NULL,'2013AJ....146...86T',2013,1,0.52,NULL,'G',0.000053,NULL,'14.31',0.37,'E/S0',NULL,NULL,NULL,NULL,1,325.2399583,-16.71578,0.113,NULL,50895052311,795235192,12425549,14.31),(151506,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151506,36.52,0.41,202,72006,70,NULL,NULL,'GIN 659',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151507,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151507,32.88,0.8,37.7,72007,75,NULL,'MAT, I','ESO 011- G 005',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000026,NULL,'16.26',0.3,'SB(s)cd: sp',NULL,NULL,NULL,NULL,1,325.244,-82.79964,0.429,NULL,48343086557,755360727,11802511,16.26),(151508,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151508,32.94,0.4,38.8,72007,75,NULL,NULL,'ESO 011- G 005',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151509,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151509,33.25,0.4,44.7,72007,NULL,NULL,NULL,'ESO 011- G 005',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151510,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151510,33.37,0.49,47.3,72007,75,NULL,'IR','ESO 011- G 005',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151511,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151511,33.55,0.32,51.2,72007,85,NULL,'I, inv','ESO 011- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151512,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151512,33.55,0.32,51.3,72007,85,NULL,'I, raw','ESO 011- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151513,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151513,33.77,0.43,56.7,72007,75,NULL,'MAT, I, raw','ESO 011- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151514,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151514,33.81,0.43,57.9,72007,75,NULL,'MAT, I, inv','ESO 011- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151515,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151515,33.94,0.43,61.4,72007,75,NULL,'MAT, I, cor','ESO 011- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151516,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 06535','R',151516,40.39,0.13,917,72008,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J214059.77+000311.7',0.3064,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',0.0005,NULL,'21.5g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,325.249083,0.05325,0.189,NULL,52093880699,813966885,12718232,21.5),(151517,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 06535','R',151517,40.49,0.22,958,72008,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J214059.77+000311.7',0.3064,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151518,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 06535',NULL,151518,40.37,0.11,1190,72008,70,NULL,'SALT 2','SDSS J214059.77+000311.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151519,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 06535',NULL,151519,40.4,0.11,1200,72008,70,NULL,'SALT 2, Malmquist cor.','SDSS J214059.77+000311.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151520,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151520,35.33,0.8,116,72009,75,NULL,'CF, r','UGC 11789',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000037,NULL,'14.67',0.6,'Sb',NULL,NULL,NULL,NULL,1,325.2502917,1.33506,0.181,NULL,52097262179,814019721,12719058,14.67),(151521,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151521,34.36,0.38,74.4,72009,75,NULL,'CF, r, raw','UGC 11789',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151522,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151522,34.44,0.38,77.4,72009,75,NULL,'CF, r, inv','UGC 11789',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151523,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151523,34.73,0.38,88.2,72009,75,NULL,'CF, r, cor','UGC 11789',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151524,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20722','R',151524,40.89,0.26,1160,72010,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J214101.54+004205.5',0.301347,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',NULL,'PHOT','21.2g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,325.2564583,0.70156,0.197,NULL,52096734639,814011478,12718929,21.2),(151525,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20722','R',151525,41.02,0.21,1230,72010,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J214101.54+004205.5',0.301347,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151526,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20722',NULL,151526,40.77,0.15,1430,72010,70,NULL,'SALT 2','SDSS J214101.54+004205.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151527,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20722',NULL,151527,40.8,0.15,1450,72010,70,NULL,'SALT 2, Malmquist cor.','SDSS J214101.54+004205.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151528,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 02049','RN',151528,42.24,0.19,1730,72011,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02049',0.624003,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151529,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151529,38.58,0.46,519,72012,70,NULL,NULL,'2MASX J21410260-0054027',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000175,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,325.261,-0.90078,0.193,NULL,49698110910,776532982,12133327,17.8),(151530,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20575','R',151530,39.63,0.11,690,72013,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007rh','SDSS J214103.77+000832.8',0.22,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,325.2657083,0.14244,0.189,NULL,52094016208,813969003,12718265,NULL),(151531,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20575','R',151531,39.67,0.19,703,72013,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007rh','SDSS J214103.77+000832.8',0.22,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151532,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2007rh',NULL,151532,39.45,0.08,776,72013,70,NULL,'SALT 2','SDSS J214103.77+000832.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151533,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2007rh',NULL,151533,39.46,0.08,780,72013,70,NULL,'SALT 2, Malmquist cor.','SDSS J214103.77+000832.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151534,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151534,36.34,0.25,185,72014,74.4,NULL,NULL,'GIN 658',NULL,'2013AJ....146...86T',2013,1,0.7,'May contribute to the radio flux of PMN J2141-1642.','G',0.000097,NULL,'15.44',0.5,'cD',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,325.26625,-16.69397,0.113,NULL,50895052699,795235198,12425549,15.44),(151535,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151535,36.52,0.41,202,72014,70,NULL,NULL,'GIN 658',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151536,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151536,37.67,0.33,342,72015,70,NULL,NULL,'2MASX J21411350-0815358',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,325.306375,-8.26011,0.089,NULL,49907571280,779805801,12184465,18.1),(151537,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151537,36.12,0.6,167,72016,70,NULL,NULL,'2MASX J21411374-5558356',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'15.5r',0.19,NULL,NULL,NULL,NULL,NULL,1,325.307375,-55.97667,0.049,NULL,48665397183,760396830,11881200,15.5),(151538,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 21482',NULL,151538,39.8,0.59,914,72017,70,NULL,'SN photometric redshift distance, z photo =0.242 +/- 0.092','SDSS-II SN 21482',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,325.327083,-0.09614,0.157,NULL,49694528902,776477014,12132453,NULL),(151539,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151539,35.77,0.57,143,72018,70,NULL,NULL,'2MASX J21411891-0129514',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,325.32875,-1.49761,0.185,NULL,49697668017,776526062,12133219,15.6),(151540,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151540,33.24,0.49,44.5,72019,70,NULL,NULL,'NGC 7096',NULL,'2014MNRAS.445.2677S',2014,1,1.9,NULL,'G',0.00009,NULL,'12.82',1.6,'(R\')SA(rs)ab','Parent (of companion) galaxy',NULL,NULL,NULL,1,325.330333333,-63.90869,0.045,NULL,49343048125,770985126,12046642,12.82),(151541,'Tully est','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151541,32.82,0.8,36.7,72019,75,NULL,'B','NGC 7096',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151542,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151542,36.28,0.79,180,72020,70,NULL,NULL,'2MASX J21412121-7000237',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'16.9b',0.33,NULL,NULL,NULL,NULL,NULL,1,325.3382917,-70.00658,0.021,NULL,49303771052,770371422,12037053,16.9),(151543,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151543,36.96,0.46,247,72021,70,NULL,NULL,'2MASX J21412205-0701404',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000173,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,325.342,-7.02783,0.121,NULL,49904824127,779762876,12183794,17.5),(151544,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151544,38.16,0.46,428,72022,70,NULL,NULL,'2MASX J21412351+0011166',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,325.347875,0.18806,0.189,NULL,52093894841,813967106,12718236,17.6),(151545,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151545,37.67,0.33,342,72023,70,NULL,NULL,'SDSS J214124.43-081826.1',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000201,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,325.351833,-8.30725,0.089,NULL,49907840866,779810013,12184531,16.8),(151546,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151546,37.79,0.46,361,72024,70,NULL,NULL,'2MASX J21412596-0742093',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00015,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,325.35825,-7.70278,0.089,NULL,49907643262,779806925,12184483,17.2),(151547,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151547,36.48,0.46,198,72025,70,NULL,NULL,'2MASX J21412630-0751043',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00015,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,325.3594583,-7.85117,0.089,NULL,49907668478,779807319,12184489,16.5),(151548,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151548,37.24,0.83,281,72025,70,NULL,NULL,'2MASX J21412630-0751043',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151549,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151549,38.11,0.46,419,72026,70,NULL,NULL,'2MASX J21412736+0059026',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,325.364,0.98419,0.189,NULL,52097094647,814017103,12719017,17.5),(151550,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151550,33.91,0.8,60.6,72027,75,NULL,'MAT, I','ESO 343- G 018',NULL,'1997ApJS..109..333W',1997,1,1.67,NULL,'G',0.000033,NULL,'14.60',0.33,'Sc: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,325.3669583,-39.76492,0,NULL,51472658869,804260294,12566567,14.6),(151551,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151551,33.76,0.32,56.5,72027,85,NULL,'I, raw','ESO 343- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151552,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151552,33.79,0.32,57.2,72027,85,NULL,'I, inv','ESO 343- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151553,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151553,33.85,0.43,58.8,72027,75,NULL,'MAT, I, raw','ESO 343- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151554,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151554,34,0.43,63,72027,75,NULL,'MAT, I, inv','ESO 343- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151555,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151555,34,0.49,63,72027,75,NULL,'IR','ESO 343- G 018',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151556,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151556,34.11,0.34,66.3,72027,NULL,NULL,NULL,'ESO 343- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151557,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151557,34.12,0.43,66.7,72027,75,NULL,'MAT, I, cor','ESO 343- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151558,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151558,34.15,0.2,67.6,72027,74.4,NULL,NULL,'ESO 343- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151559,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151559,34.2,0.32,69,72027,NULL,NULL,'Malmquist cor.','ESO 343- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151560,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151560,36.2,0.46,174,72028,70,NULL,NULL,'2MASX J21412864+0036296',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,325.36925,0.60828,0.197,NULL,52093923794,813967559,12718243,16.7),(151561,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151561,33.74,0.49,56,72029,NULL,NULL,'Malmquist cor.','UGC 11790',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'14.71',1.1,'SA(rs)d:','Isolated galaxy',NULL,NULL,NULL,1,325.374875,0.89464,0.189,NULL,52097066740,814016667,12719010,14.71),(151562,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151562,34.01,0.43,63.3,72029,NULL,NULL,NULL,'UGC 11790',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151563,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151563,34.05,0.2,64.6,72029,74.4,NULL,NULL,'UGC 11790',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151564,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151564,35.32,0.59,116,72030,NULL,NULL,NULL,'ESO 531- G 023',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.6r',0.7,'SA(r)bc',NULL,NULL,NULL,NULL,1,325.401333,-26.59222,0.089,NULL,51464694374,804135849,12564622,14.6),(151565,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151565,35.36,0.2,118,72030,74.4,NULL,NULL,'ESO 531- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151566,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151566,35.47,0.55,124,72030,NULL,NULL,'Malmquist cor.','ESO 531- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151567,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151567,37.51,0.46,317,72031,70,NULL,NULL,'SDSS J214137.06-084624.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,325.404416667,-8.77344,0.073,NULL,49905344519,779771008,12183922,18.3),(151568,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15347',NULL,151568,39.82,0.34,920,72032,70,NULL,'SN photometric redshift distance, z photo =0.244 +/- 0.049','SDSS-II SN 15347',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.5g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,325.405167,1.20442,0.181,NULL,52097136098,814017751,12719027,21.5),(151569,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15347','R',151569,40.36,0.23,931,72032,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15347',0.270007,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151570,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15347','R',151570,40.58,0.16,1030,72032,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15347',0.270007,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151571,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15347',NULL,151571,40.09,0.13,1040,72032,70,NULL,'SALT 2','SDSS-II SN 15347',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151572,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15347',NULL,151572,40.11,0.13,1050,72032,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15347',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151573,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 12850','RN',151573,40.63,0.32,1020,72033,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 12850',0.305003,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151574,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 12850','RN',151574,40.72,0.25,1070,72033,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 12850',0.305003,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151575,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151575,38.08,0.46,412,72034,70,NULL,NULL,'2MASX J21413925-0832163',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,325.413458333,-8.538,0.069,NULL,49907110406,779798600,12184353,18.3),(151576,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20476','R',151576,40.62,0.17,1140,72035,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20476',0.169122,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,325.420041667,0.83897,0.189,NULL,52097060019,814016562,12719008,NULL),(151577,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20476','R',151577,40.72,0.22,1190,72035,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20476',0.169122,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151578,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 17396',NULL,151578,40.22,0.18,1100,72036,70,NULL,'SN photometric redshift distance, z photo =0.302 +/- 0.031','SDSS-II SN 17396',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,325.4207083,-0.47711,0.161,NULL,49694467475,776476054,12132438,NULL),(151579,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151579,33.77,0.47,56.6,72037,70,NULL,NULL,'NGC 7105',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00012,NULL,'13.51',0.8,'(R\')SB0^0^:',NULL,NULL,NULL,NULL,1,325.4222917,-10.6355,0.137,NULL,49898073984,779657406,12182146,13.51),(151580,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151580,36.06,0.71,163,72038,70,NULL,NULL,'2MASX J21414560-5505407',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'15.2r',0.16,NULL,NULL,NULL,NULL,NULL,1,325.4399583,-55.09461,0.021,NULL,48666281118,760410642,11881416,15.2),(151581,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151581,35.55,0.53,129,72039,70,NULL,NULL,'2MASX J21414684-4649159',NULL,'2014MNRAS.445.2677S',2014,1,1.9,NULL,'G',0.000133,NULL,'13.9r',1.6,'S0-:',NULL,NULL,NULL,NULL,1,325.4452917,-46.82106,0,NULL,50639741060,791245954,12363218,13.9),(151582,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151582,37.76,0.33,357,72040,70,NULL,NULL,'SDSS J214148.77-005811.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,325.453208333,-0.96972,0.193,NULL,49697648859,776525763,12133215,18.5),(151583,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151583,37.76,0.33,357,72041,70,NULL,NULL,'2MASX J21414887-0102180',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000159,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,325.45375,-1.03828,0.193,NULL,49697650125,776525783,12133215,17.2),(151584,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151584,34.53,0.5,80.6,72042,NULL,NULL,'Malmquist cor.','ESO 403- G 014',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.84',0.4,'Sb-c',NULL,NULL,NULL,NULL,1,325.455625,-35.19578,0.013,NULL,51454837877,803981841,12562216,15.84),(151585,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151585,34.58,0.48,82.6,72042,NULL,NULL,NULL,'ESO 403- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151586,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151586,34.63,0.2,84.3,72042,74.4,NULL,NULL,'ESO 403- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151587,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 11120','R',151587,38.47,0.2,445,72043,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J214150.10+002209.4',0.1074,'2014arXiv1401.3317S',2014,1,0.36,NULL,'G',0.0001,NULL,'17.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,325.45875,0.36928,0.181,NULL,52093976726,813968386,12718256,17.2),(151588,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 11120','R',151588,38.53,0.1,460,72043,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J214150.10+002209.4',0.1074,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151589,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 11120',NULL,151589,38.36,0.12,470,72043,70,NULL,'SALT 2','SDSS J214150.10+002209.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151590,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 11120',NULL,151590,38.37,0.12,472,72043,70,NULL,'SALT 2, Malmquist cor.','SDSS J214150.10+002209.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151591,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151591,34.64,0.46,84.9,72044,70,NULL,NULL,'NGC 7108',NULL,'2015arXiv151105856S',2015,1,1.07,NULL,'G',0.000067,NULL,'14.4g',0.75,'E3/S0-',NULL,NULL,NULL,NULL,1,325.4739583,-6.70883,0.089,NULL,49903965168,779749455,12183585,14.4),(151592,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151592,35.03,0.47,101,72044,70,NULL,NULL,'NGC 7108',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151593,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151593,36.69,0.58,218,72045,70,NULL,NULL,'2MASX J21415966-0646197',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.000077,NULL,'15.9g',0.42,'E0',NULL,NULL,NULL,NULL,1,325.498583,-6.77203,0.089,NULL,49903974710,779749604,12183587,15.9),(151594,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151594,36.85,0.13,234,72045,70,NULL,NULL,'2MASX J21415966-0646197',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151595,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151595,36.34,0.25,185,72046,74.4,NULL,NULL,'GIN 661',NULL,'2013AJ....146...86T',2013,1,0.47,NULL,'G',0.000087,NULL,'15.08',0.35,'E/S0',NULL,NULL,NULL,NULL,1,325.506583333,-16.90364,0.121,NULL,50896878603,795263728,12425995,15.08),(151596,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151596,36.52,0.41,202,72046,70,NULL,NULL,'GIN 661',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151597,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151597,37.38,0.46,299,72047,70,NULL,NULL,'SDSS J214206.72-072533.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000178,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,325.528,-7.426,0.101,NULL,49904521710,779758151,12183721,18.1),(151598,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 01196','RN',151598,42.1,0.2,1920,72048,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01196',0.370508,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151599,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 01196','RN',151599,42.3,0.14,2100,72048,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01196',0.370508,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151600,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151600,34.55,0.6,81.4,72049,70,NULL,NULL,'2MASX J21420736-1904396',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.00015,NULL,'14.7r',0.55,'S0',NULL,NULL,NULL,NULL,1,325.53075,-19.07764,0.065,NULL,50929132242,795767691,12433870,14.7),(151601,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 05461','RN',151601,42.11,0.26,2370,72050,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 05461',0.115844,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151602,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 05461','RN',151602,42.19,0.2,2450,72050,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 05461',0.115844,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151603,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20828',NULL,151603,39.5,0.68,793,72051,70,NULL,'SN photometric redshift distance, z photo =0.206 +/- 0.090','SDSS-II SN 20828',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.4g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,325.5382083,0.96236,0.181,NULL,52097081370,814016896,12719014,21.4),(151604,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20828','R',151604,41.44,0.28,1430,72051,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20828',0.358376,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151605,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20828','R',151605,41.5,0.37,1470,72051,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20828',0.358376,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151606,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20828',NULL,151606,41.36,0.22,1870,72051,70,NULL,'SALT 2','SDSS-II SN 20828',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151607,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20828',NULL,151607,41.41,0.22,1910,72051,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20828',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151608,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151608,37.73,0.21,351,72052,70,NULL,NULL,'2MASX J21421006-0633527',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,325.5419583,-6.56453,0.089,NULL,49912335009,779880234,12185628,17.4),(151609,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 21164','RN',151609,44.09,0.35,4100,72053,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 21164',0.601231,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151610,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151610,34.11,0.8,66.3,72054,75,NULL,'MAT, I','NGC 7110',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.23',0.6,'SB(r)b','in a pair',NULL,NULL,NULL,1,325.550625,-34.16222,0.037,NULL,51452185202,803940393,12561568,14.23),(151611,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151611,34.13,0.32,66.9,72054,85,NULL,'I, raw','NGC 7110',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151612,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151612,34.16,0.43,67.9,72054,75,NULL,'MAT, I, raw','NGC 7110',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151613,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151613,34.18,0.32,68.6,72054,85,NULL,'I, inv','NGC 7110',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151614,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151614,34.35,0.3,74.2,72054,NULL,NULL,'Malmquist cor.','NGC 7110',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151615,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151615,34.4,0.43,75.9,72054,75,NULL,'MAT, I, inv','NGC 7110',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151616,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151616,34.42,0.29,76.7,72054,NULL,NULL,NULL,'NGC 7110',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151617,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151617,34.45,0.43,77.5,72054,75,NULL,'MAT, I, cor','NGC 7110',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151618,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151618,34.47,0.2,78.3,72054,74.4,NULL,NULL,'NGC 7110',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151619,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151619,33.78,0.66,57.1,72055,NULL,NULL,'Malmquist cor.','UGC 11792',NULL,'2009ApJS..182..474S',2009,1,1.69,NULL,'G',NULL,NULL,'15.49',0.22,'Sc',NULL,NULL,NULL,NULL,1,325.5532917,5.61531,0.249,NULL,52320736681,817511510,12773617,15.49),(151620,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151620,33.87,0.2,59.4,72055,74.4,NULL,NULL,'UGC 11792',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151621,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151621,34.03,0.59,63.9,72055,NULL,NULL,NULL,'UGC 11792',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151622,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151622,34.55,NULL,81.1,72055,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11792',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151623,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151623,34.56,NULL,81.5,72055,NULL,NULL,'Dipole + Quadrupole','UGC 11792',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151624,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151624,34.56,NULL,81.6,72055,NULL,NULL,'Dipole','UGC 11792',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151625,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151625,36.35,0.25,186,72056,74.4,NULL,NULL,'MCG -03-55-006',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000063,NULL,'14.69',0.66,'S',NULL,NULL,NULL,NULL,1,325.565833,-16.938,0.121,NULL,50897044727,795266323,12426036,14.69),(151626,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151626,36.52,0.41,202,72056,70,NULL,NULL,'MCG -03-55-006',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151627,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151627,37.39,0.89,301,72057,70,NULL,NULL,'2MASX J21422171-7441071',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'15.4r',0.19,NULL,NULL,NULL,NULL,NULL,1,325.590458333,-74.68531,0.177,NULL,48417491589,756523306,11820676,15.4),(151628,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151628,37.73,0.21,351,72058,70,NULL,NULL,'SDSS J214222.37-063710.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,325.59325,-6.61964,0.089,NULL,49912342186,779880346,12185630,18.3),(151629,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151629,34.06,0.49,64.9,72059,75,NULL,'IR','UGC 11794',NULL,'2011yCatp016004901K',2011,1,1.34,'Often mistakenly called NGC 7112.','G',0.00006,NULL,'14.9g',0.43,'Sab','Pair member (points to parent)',NULL,NULL,NULL,1,325.595167,12.49828,0.317,NULL,52229274551,816082414,12751287,14.9),(151630,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151630,34.26,0.43,71.2,72059,75,NULL,'3.6 micron, color corrected','UGC 11794',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151631,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151631,34.27,0.43,71.3,72059,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11794',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151632,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151632,34.3,0.2,72.4,72059,74.4,NULL,NULL,'UGC 11794',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151633,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151633,35.51,0.58,126,72060,70,NULL,NULL,'2MASX J21422438-1233477',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,325.60175,-12.56328,0.129,NULL,49763814976,777559609,12149368,14.5),(151634,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151634,32.21,0.4,27.6,72061,75,NULL,'B','NGC 7107',NULL,'1988NBGC.C....0000T',1988,1,2,NULL,'G',0.000019,NULL,'13.3',1.5,'SB(rs)cd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,325.610333,-44.79028,0,NULL,50648597744,791384339,12365380,13.3),(151635,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151635,37.73,0.21,351,72062,70,NULL,NULL,'2MASX J21422693-0635127',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.00015,NULL,'16.0g',0.43,'E0',NULL,NULL,NULL,NULL,1,325.6120417,-6.58678,0.089,NULL,49912310527,779879851,12185622,16),(151636,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151636,36.85,0.13,234,72063,70,NULL,NULL,'2MASX J21422700-0654057',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000117,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,325.612541667,-6.90169,0.089,NULL,49904419152,779756549,12183696,17.2),(151637,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151637,35.9,0.52,151,72064,70,NULL,NULL,'2MASX J21422987-0625397',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.0001,NULL,'16.26',0.43,NULL,NULL,NULL,NULL,NULL,1,325.624667,-6.42783,0.089,NULL,49912416053,779881500,12185648,16.26),(151638,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2007oq',NULL,151638,40.42,0.28,1210,72065,70,NULL,'Hubble residual -0.01 for z0.33910','SDSS J214230.73+005904.8',NULL,'2011ApJ...740...92G',2011,1,0.04,NULL,'G',0.0005,NULL,'23.2g',0.02,NULL,NULL,NULL,NULL,NULL,1,325.628083333,0.98469,0.181,NULL,52093629431,813962959,12718171,23.2),(151639,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 19067','R',151639,41.19,0.26,1290,72065,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2007oq','SDSS J214230.73+005904.8',0.3391,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151640,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 19067','R',151640,41.22,0.19,1310,72065,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2007oq','SDSS J214230.73+005904.8',0.3391,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151641,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13820','RN',151641,40.31,0.25,1010,72066,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13820',0.135721,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151642,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13820','RN',151642,40.54,0.23,1130,72066,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13820',0.135721,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151643,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13820','N',151643,40.3,0.13,1150,72066,70,NULL,'SALT 2','SDSS-II SN 13820',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151644,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13820','N',151644,40.31,0.13,1150,72066,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13820',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151645,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151645,37.34,0.46,293,72067,70,NULL,NULL,'2MASX J21423262-0823337',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00015,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,325.635875,-8.39281,0.109,NULL,49907138973,779799046,12184360,16.6),(151646,'GRB','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151646,42.77,NULL,3590,72068,70,NULL,'Pseudo z = 2.36','GRB 030821',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,325.6375,-45.2,0,NULL,50649643912,791400686,12365635,NULL),(151647,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151647,37.73,0.21,351,72069,70,NULL,NULL,'2MASX J21423471-0635427',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,325.644541667,-6.59525,0.089,NULL,49912309544,779879836,12185622,17.8),(151648,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151648,33.08,0.8,41.3,72070,75,NULL,'MAT, I','NGC 7106',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000026,NULL,'13.87',1,'SAB(rs)c',NULL,NULL,NULL,NULL,1,325.6524583,-52.69953,0,NULL,50607991122,790749861,12355466,13.87),(151649,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151649,33.03,0.32,40.4,72070,85,NULL,'I, raw','NGC 7106',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151650,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151650,33.05,0.32,40.8,72070,85,NULL,'I, inv','NGC 7106',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151651,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151651,33.22,0.43,44,72070,75,NULL,'MAT, I, raw','NGC 7106',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151652,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151652,33.36,0.43,47,72070,75,NULL,'MAT, I, inv','NGC 7106',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151653,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151653,33.4,0.4,47.9,72070,NULL,NULL,'mean','NGC 7106',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151654,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151654,33.42,0.43,48.2,72070,75,NULL,'MAT, I, cor','NGC 7106',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151655,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151655,33.61,0.46,52.7,72070,NULL,NULL,'J','NGC 7106',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151656,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151656,33.62,0.45,52.9,72070,NULL,NULL,'K','NGC 7106',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151657,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151657,33.65,0.47,53.6,72070,NULL,NULL,'H','NGC 7106',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151658,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151658,36.85,0.13,234,72071,70,NULL,NULL,'2MASX J21423740-0647207',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'16.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,325.6560417,-6.78908,0.089,NULL,49913149407,779892959,12185827,16.7),(151659,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151659,37.2,0.54,276,72071,70,NULL,NULL,'2MASX J21423740-0647207',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151660,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151660,33.44,0.47,48.8,72072,NULL,NULL,'H','NGC 7116',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000033,NULL,'14.31',0.4,'S?',NULL,NULL,NULL,NULL,1,325.667583,28.94658,0.621,NULL,55629675561,869213680,13581463,14.31),(151661,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151661,33.45,0.4,48.9,72072,NULL,NULL,'mean','NGC 7116',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151662,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151662,33.56,0.46,51.5,72072,NULL,NULL,'J','NGC 7116',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151663,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151663,33.6,0.45,52.6,72072,NULL,NULL,'K','NGC 7116',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151664,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151664,38.24,0.46,446,72073,70,NULL,NULL,'2MASX J21424404-0849067',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,325.6835417,-8.81839,0.073,NULL,49907021281,779797207,12184331,17.6),(151665,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151665,37.05,0.59,257,72074,70,NULL,NULL,'LCRS B213940.9-384712',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'15.2r',0.29,NULL,NULL,NULL,NULL,NULL,1,325.68725,-38.55811,0,NULL,51439836096,803747439,12558553,15.2),(151666,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151666,36.85,0.13,234,72075,70,NULL,NULL,'2MASX J21424588-0651526',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000184,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,325.691333333,-6.86461,0.069,NULL,49913136166,779892752,12185824,16.8),(151667,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151667,36.46,0.49,196,72076,70,NULL,NULL,'MCG -01-55-004 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000083,NULL,'15.89',0.47,'cD;BrClG',NULL,NULL,NULL,NULL,1,325.7032917,-6.86853,0.069,NULL,49912620039,779884688,12185698,15.89),(151668,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151668,38.29,0.46,455,72077,70,NULL,NULL,'SDSS J214250.52+124345.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,325.7105417,12.72931,0.333,NULL,52229238330,816081848,12751278,18.2),(151669,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151669,36.85,0.13,234,72078,70,NULL,NULL,'2MASX J21425132-0652136',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000178,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,325.713917,-6.87044,0.069,NULL,49912620251,779884691,12185698,17.3),(151670,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151670,36.85,0.13,234,72079,70,NULL,NULL,'2MASX J21425219-0648476',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,325.717375,-6.81328,0.069,NULL,49913140502,779892820,12185825,17.5),(151671,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151671,36.85,0.13,234,72080,70,NULL,NULL,'2MASX J21425542-0652506',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000178,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,325.730916667,-6.88078,0.069,NULL,49912620822,779884700,12185698,17),(151672,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151672,36.85,0.13,234,72081,70,NULL,NULL,'2MASX J21425568-0635536',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'16.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,325.732,-6.59811,0.089,NULL,49913181962,779893468,12185835,16.5),(151673,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151673,37.07,0.63,259,72081,70,NULL,NULL,'2MASX J21425568-0635536',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151674,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151674,36.43,0.63,193,72082,70,NULL,NULL,'2MASX J21425904-5514572',NULL,'2014MNRAS.445.2677S',2014,1,0.32,NULL,'G',0.00015,NULL,'15.4r',0.27,NULL,NULL,NULL,NULL,NULL,1,325.7459583,-55.24919,0.025,NULL,48665980110,760405939,11881342,15.4),(151675,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151675,36.85,0.13,234,72083,70,NULL,NULL,'2MASX J21425999-0657546',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,325.750083,-6.96508,0.069,NULL,49912616844,779884638,12185697,16.7),(151676,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151676,37.73,0.21,351,72084,70,NULL,NULL,'2MASX J21430112-0632406',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00015,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,325.754667,-6.54458,0.089,NULL,49913202589,779893790,12185840,16.8),(151677,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151677,36.85,0.13,234,72085,70,NULL,NULL,'2MASX J21430227-0701536',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.0001,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,325.7595417,-7.03156,0.073,NULL,49912668750,779885449,12185710,16.4),(151678,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151678,37.74,0.56,354,72085,70,NULL,NULL,'2MASX J21430227-0701536',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151679,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151679,36.41,0.82,191,72086,70,NULL,NULL,'2MFGC 16396',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'16.7b',0.16,NULL,NULL,NULL,NULL,NULL,1,325.768667,-71.96133,0.045,NULL,49307409067,770428266,12037941,16.7),(151680,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151680,35.26,0.46,113,72087,70,NULL,NULL,'MCG -06-47-013',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000133,NULL,'14.73',0.5,'E',NULL,NULL,NULL,NULL,1,325.7727083,-36.73889,0,NULL,51442343070,803786610,12559165,14.73),(151681,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151681,36.69,0.54,218,72088,70,NULL,NULL,'2MASX J21430577-0704066',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.000103,NULL,'15.5g',0.51,'S0^-',NULL,NULL,NULL,NULL,1,325.774167,-7.06847,0.073,NULL,49912636354,779884943,12185702,15.5),(151682,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151682,36.85,0.13,234,72088,70,NULL,NULL,'2MASX J21430577-0704066',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151683,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151683,36.68,0.46,217,72089,70,NULL,NULL,'2MASX J21430655-0817486',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00015,NULL,'16.1g',0.38,'E0',NULL,NULL,NULL,NULL,1,325.77725,-8.29678,0.109,NULL,49907930112,779811408,12184553,16.1),(151684,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151684,37.41,0.75,303,72090,70,NULL,NULL,'2MASX J21431248-5157400',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,325.8020417,-51.96108,0,NULL,50661377416,791584022,12368500,17.1),(151685,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151685,35.73,0.83,140,72091,70,NULL,NULL,'2MASX J21431256-4658577',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'15.0r',0.28,NULL,NULL,NULL,NULL,NULL,1,325.8024583,-46.98264,0,NULL,50639018871,791234669,12363041,15),(151686,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 11026','RN',151686,41.02,0.24,1240,72092,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 11026',0.284202,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151687,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 11026','RN',151687,41.46,0.32,1530,72092,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 11026',0.284202,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151688,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15263','R',151688,41.89,0.36,1630,72093,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J214313.54+000036.0',0.467976,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,'PHOT','21.8g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,325.8064583,0.01,0.189,NULL,52093412578,813959571,12718118,21.8),(151689,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15263',NULL,151689,41.75,0.27,2240,72093,70,NULL,'SALT 2','SDSS J214313.54+000036.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151690,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15263',NULL,151690,41.86,0.27,2360,72093,70,NULL,'SALT 2, Malmquist cor.','SDSS J214313.54+000036.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151691,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 19047','RN',151691,42.07,0.26,1840,72094,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19047',0.412081,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151692,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 19047','RN',151692,42.47,0.41,2210,72094,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19047',0.412081,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151693,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151693,36.85,0.13,234,72095,70,NULL,NULL,'2MASX J21431906-0658484',NULL,'2015arXiv151105856S',2015,1,0.41,'Star superposed 15\\\" northwest of the nucleus.','G',0.00015,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,325.8295417,-6.97997,0.069,NULL,49912675770,779885558,12185711,16.3),(151694,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151694,37.84,0.67,370,72095,70,NULL,NULL,'2MASX J21431906-0658484',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151695,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151695,33.58,0.4,51.9,72096,NULL,NULL,'mean','UGC 11797',NULL,'2007A&A...465...71T',2007,1,1.4,'UZC has V = 4176 +- 56 km/sec.','G',0.000057,NULL,'15.2',0.7,'_',NULL,NULL,NULL,NULL,1,325.834208333,43.57631,NULL,NULL,55395638601,865556853,13524325,15.2),(151696,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151696,33.99,0.46,62.7,72096,NULL,NULL,'J','UGC 11797',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151697,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151697,34,0.47,63.2,72096,NULL,NULL,'H','UGC 11797',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151698,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151698,34.12,0.45,66.7,72096,NULL,NULL,'K','UGC 11797',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151699,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151699,34.25,0.8,70.9,72097,75,NULL,'MAT, I','ESO 236- G 037',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'13.5r',0.9,'SA(rs)bc',NULL,NULL,NULL,NULL,1,325.8400417,-48.31894,0.013,NULL,50657469739,791522964,12367546,13.5),(151700,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151700,33.65,NULL,53.7,72097,NULL,NULL,'B','ESO 236- G 037',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151701,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151701,33.65,0.27,53.7,72097,NULL,NULL,'B, Hubble-type-TF','ESO 236- G 037',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151702,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151702,33.97,0.32,62.3,72097,85,NULL,'I, raw','ESO 236- G 037',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151703,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151703,34.01,0.43,63.3,72097,75,NULL,'MAT, I, raw','ESO 236- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151704,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151704,34.02,0.32,63.6,72097,85,NULL,'I, inv','ESO 236- G 037',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151705,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151705,34.21,0.43,69.5,72097,75,NULL,'MAT, I, inv','ESO 236- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151706,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151706,34.25,NULL,70.8,72097,NULL,NULL,'I','ESO 236- G 037',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151707,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151707,34.31,0.43,72.9,72097,75,NULL,'MAT, I, cor','ESO 236- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151708,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151708,34.37,0.47,75,72097,NULL,NULL,'H','ESO 236- G 037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151709,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151709,34.37,0.31,75,72097,NULL,NULL,'Malmquist cor.','ESO 236- G 037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151710,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151710,34.43,0.3,76.8,72097,NULL,NULL,NULL,'ESO 236- G 037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151711,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151711,34.46,0.4,78,72097,NULL,NULL,'mean','ESO 236- G 037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151712,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151712,34.47,0.2,78.3,72097,74.4,NULL,NULL,'ESO 236- G 037',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151713,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151713,34.49,0.46,78.9,72097,NULL,NULL,'J','ESO 236- G 037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151714,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151714,34.54,0.45,80.9,72097,NULL,NULL,'K','ESO 236- G 037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151715,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151715,37.17,0.46,272,72098,70,NULL,NULL,'2MASX J21432262+1140161',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,325.8442083,11.67114,0.273,NULL,52297726818,817151981,12767999,17.4),(151716,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151716,37.11,0.46,265,72099,70,NULL,NULL,'2MASX J21432438+0009071',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,325.85175,0.15192,0.197,NULL,52093408061,813959500,12718117,17),(151717,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151717,32.32,0.47,29.1,72100,NULL,NULL,'H','UGC 11798',NULL,'2007A&A...465...71T',2007,1,1.9,'abs(b) < 10 degrees.','G',0.00004,NULL,'15.2',0.3,'S',NULL,NULL,NULL,NULL,1,325.862583,43.55514,NULL,NULL,55395637735,865556839,13524325,15.2),(151718,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151718,32.43,0.45,30.7,72100,NULL,NULL,'K','UGC 11798',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151719,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151719,32.62,0.46,33.4,72100,NULL,NULL,'J','UGC 11798',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151720,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151720,33.42,0.4,48.3,72100,NULL,NULL,'mean','UGC 11798',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151721,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151721,36.78,0.46,227,72101,70,NULL,NULL,'2MASX J21433416-0645184',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00015,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,325.8922917,-6.75522,0.077,NULL,49913226448,779894163,12185846,16.5),(151722,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151722,34.24,0.4,70.5,72102,NULL,NULL,'mean','UGC 11799',NULL,'2007A&A...465...71T',2007,1,1.1,'abs(b) < 10 degrees.','G',NULL,NULL,'13.1B',1,'SB?',NULL,NULL,NULL,NULL,1,325.8962917,43.69411,NULL,NULL,55395740122,865558439,13524350,13.1),(151723,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151723,34.45,0.43,77.6,72102,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11799',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151724,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151724,34.67,0.46,85.8,72102,NULL,NULL,'J','UGC 11799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151725,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151725,34.7,0.45,87,72102,NULL,NULL,'K','UGC 11799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151726,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151726,34.73,0.47,88.2,72102,NULL,NULL,'H','UGC 11799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151727,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151727,34.96,0.2,98.2,72103,74.4,NULL,NULL,'CGCG 376-025',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000043,NULL,'15.2',0.3,'Sb','Isolated galaxy',NULL,NULL,NULL,1,325.906667,2.63492,0.197,NULL,52313571951,817399561,12771868,15.2),(151728,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151728,35.02,0.32,101,72103,NULL,NULL,NULL,'CGCG 376-025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151729,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151729,35.31,0.28,115,72103,NULL,NULL,'Malmquist cor.','CGCG 376-025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151730,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151730,33.22,0.8,44,72104,75,NULL,'MAT, I','NGC 7115',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000026,NULL,'15.05',0.4,'Sb pec',NULL,NULL,NULL,NULL,1,325.9105417,-25.35161,0.125,NULL,51410286370,803285724,12551339,15.05),(151731,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151731,32.03,0.2,25.5,72104,74.4,NULL,NULL,'NGC 7115',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151732,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151732,32.95,0.32,38.9,72104,85,NULL,'I, raw','NGC 7115',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151733,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151733,32.98,0.32,39.4,72104,85,NULL,'I, inv','NGC 7115',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151734,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151734,33.13,0.43,42.3,72104,75,NULL,'MAT, I, raw','NGC 7115',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151735,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151735,33.28,0.43,45.4,72104,75,NULL,'MAT, I, inv','NGC 7115',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151736,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151736,33.37,0.43,47.2,72104,75,NULL,'MAT, I, cor','NGC 7115',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151737,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151737,36.13,0.46,168,72105,70,NULL,NULL,'2MASX J21433892-0843234',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000154,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,325.912125,-8.72319,0.069,NULL,49907205686,779800088,12184376,16.9),(151738,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151738,37.87,0.46,375,72106,70,NULL,NULL,'2MASX J21433993+1238537',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000144,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,325.916333333,12.64819,0.245,NULL,52229327335,816083239,12751300,17.9),(151739,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151739,36.26,0.48,179,72107,70,NULL,NULL,'2MASX J21434056-5206460',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,325.918917,-52.11275,0,NULL,50661201076,791581266,12368457,15.8),(151740,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151740,35.89,0.55,151,72108,70,NULL,NULL,'2MASX J21434383-5328090',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'14.9r',0.28,NULL,NULL,NULL,NULL,NULL,1,325.932583,-53.46919,0,NULL,50605108144,790704814,12354762,14.9),(151741,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151741,36.56,0.46,205,72109,70,NULL,NULL,'2MASX J21434628-0745471',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,325.942791667,-7.76297,0.097,NULL,49907260765,779800949,12184389,17.5),(151742,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151742,36.98,0.56,249,72110,70,NULL,NULL,'2MASX J21434702-0834121',NULL,'2014MNRAS.445.2677S',2014,1,0.49,'Brighter star 12\\\" to the west.','G',0.00015,NULL,'15.4R',0.45,NULL,NULL,NULL,NULL,NULL,1,325.9459583,-8.56992,0.109,NULL,49907097065,779798391,12184349,15.4),(151743,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151743,36.07,0.48,164,72111,70,NULL,NULL,'2MASX J21434945-0804261',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000073,NULL,'15.94',0.68,NULL,NULL,NULL,NULL,NULL,1,325.956,-8.07408,0.097,NULL,49907420601,779803446,12184428,15.94),(151744,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15935',NULL,151744,39.37,0.35,748,72112,70,NULL,'SN photometric redshift distance, z photo =0.193 +/- 0.039','SDSS-II SN 15935',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','22.8g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,325.963083,0.43994,0.217,NULL,52093343171,813958487,12718101,22.8),(151745,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151745,35.13,0.52,106,72113,70,NULL,NULL,'CGCG 376-027',NULL,'2014MNRAS.445.2677S',2014,1,0.5,'Second entry in 1999ApJS..121..287H has RA +1 minute in error.','G',0.000113,NULL,'15.5g',0.48,'E0',NULL,NULL,NULL,NULL,1,325.963791667,-0.32139,0.201,NULL,49694370285,776474535,12132414,15.5),(151746,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151746,35.35,0.46,117,72113,70,NULL,NULL,'CGCG 376-027',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151747,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 06332','R',151747,39.41,0.17,660,72114,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 06332',0.152229,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,325.964833333,-0.71814,0.189,NULL,49694977254,776484019,12132562,NULL),(151748,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 06332','R',151748,40.03,0.28,881,72114,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 06332',0.152229,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151749,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151749,37.31,0.46,290,72115,70,NULL,NULL,'2MASX J21435201-0821391',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000159,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,325.966583333,-8.36094,0.093,NULL,49907895419,779810865,12184544,18.2),(151750,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151750,37.55,0.54,323,72116,70,NULL,NULL,'2MASX J21435620-5135031',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.000103,NULL,'15.1r',0.39,NULL,NULL,NULL,NULL,NULL,1,325.984125,-51.58425,0,NULL,50661363367,791583802,12368496,15.1),(151751,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151751,36.07,0.57,163,72117,70,NULL,NULL,'2MASX J21435667-0841311',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,325.98625,-8.69189,0.069,NULL,49906611311,779790801,12184231,16.3),(151752,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151752,36.35,0.33,186,72117,70,NULL,NULL,'2MASX J21435667-0841311',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151753,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151753,38.02,0.46,401,72118,70,NULL,NULL,'2MASX J21435713+1042038',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000149,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,325.9879583,10.70119,0.193,NULL,52308578040,817321531,12770648,17.4),(151754,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151754,36.35,0.33,186,72119,70,NULL,NULL,'2MASX J21435727-0818371',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00015,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,325.9885417,-8.31039,0.093,NULL,49907370991,779802671,12184416,16.5),(151755,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13610','R',151755,40.78,0.23,1100,72120,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006hd','SDSS J214403.55+004334.6',0.3,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,326.0147917,0.72628,0.237,NULL,52094188270,813971691,12718307,NULL),(151756,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13610','R',151756,40.97,0.14,1200,72120,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006hd','SDSS J214403.55+004334.6',0.3,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151757,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2006hd',NULL,151757,40.62,0.12,1330,72120,70,NULL,'SALT 2','SDSS J214403.55+004334.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151758,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2006hd',NULL,151758,40.64,0.12,1340,72120,70,NULL,'SALT 2, Malmquist cor.','SDSS J214403.55+004334.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151759,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151759,36.54,0.46,203,72121,70,NULL,NULL,'2MASX J21440396-0858111',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,326.016583,-8.96967,0.085,NULL,49906500659,779789072,12184204,16.4),(151760,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151760,36.6,0.62,209,72121,70,NULL,NULL,'2MASX J21440396-0858111',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151761,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151761,36.9,0.66,240,72122,70,NULL,NULL,'2MASX J21440469-0827351',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.00015,NULL,'15.6g',0.35,'Sab',NULL,NULL,NULL,NULL,1,326.019625,-8.45967,0.109,NULL,49906583114,779790361,12184224,15.6),(151762,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151762,32.26,0.8,28.3,72123,75,NULL,'MAT, I','ESO 403- G 017',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'15.05',0.5,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,326.0290417,-36.17992,0,NULL,51440309317,803754833,12558669,15.05),(151763,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151763,31.36,0.32,18.7,72123,85,NULL,'I, inv','ESO 403- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151764,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151764,31.41,0.32,19.1,72123,85,NULL,'I, raw','ESO 403- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151765,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151765,31.59,0.43,20.8,72123,75,NULL,'MAT, I, inv','ESO 403- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151766,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151766,31.73,0.43,22.1,72123,75,NULL,'MAT, I, raw','ESO 403- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151767,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151767,31.81,0.4,23,72123,NULL,NULL,NULL,'ESO 403- G 017',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151768,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151768,31.81,0.4,23,72123,73,NULL,'opt','ESO 403- G 017',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151769,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151769,31.81,0.43,23,72123,75,NULL,'3.6 micron, color + selection bias corrected','ESO 403- G 017',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151770,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151770,31.82,0.2,23.1,72123,74.4,NULL,NULL,'ESO 403- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151771,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151771,31.85,0.43,23.5,72123,75,NULL,'3.6 micron, color corrected','ESO 403- G 017',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151772,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151772,32.11,0.43,26.4,72123,75,NULL,'MAT, I, cor','ESO 403- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151773,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151773,32.61,0.26,33.3,72123,NULL,NULL,NULL,'ESO 403- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151774,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151774,37.91,0.46,382,72124,70,NULL,NULL,'SDSS J214409.65+001731.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000125,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,326.0402083,0.29217,0.225,NULL,52093498293,813960910,12718139,18.5),(151775,'Tully est','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151775,32.32,0.8,29.1,72125,75,NULL,NULL,'NGC 7098',NULL,'1988NBGC.C....0000T',1988,1,4.1,NULL,'G',0.000019,NULL,'12.23',2.6,'(R)SAB(r)a',NULL,NULL,NULL,NULL,1,326.067167,-75.11133,0.373,NULL,48417939845,756530310,11820786,12.23),(151776,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151776,37.01,0.46,252,72126,70,NULL,NULL,'2MASX J21441995-0815562',NULL,'2015arXiv151105856S',2015,1,0.35,'Star superposed 12\\\" northwest of the nucleus.','G',0.000155,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,326.083208333,-8.26569,0.093,NULL,49906265960,779785405,12184146,17),(151777,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 19464','RN',151777,42.65,0.3,2730,72127,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 19464',0.239213,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151778,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 19464','RN',151778,42.94,0.28,3130,72127,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19464',0.239213,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151779,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151779,37.72,0.46,350,72128,70,NULL,NULL,'2MASX J21442296+1112174',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,326.095666667,11.20475,0.281,NULL,52308671982,817322999,12770671,17.4),(151780,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151780,36.5,0.46,200,72129,70,NULL,NULL,'2MASX J21442548-0015509',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,326.106083333,-0.26408,0.189,NULL,49694155845,776471185,12132362,17),(151781,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151781,37.96,0.46,391,72130,70,NULL,NULL,'2MASX J21442547+1122264',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,326.106125,11.37397,0.273,NULL,52308608879,817322013,12770656,17.7),(151782,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151782,37.59,0.46,330,72131,70,NULL,NULL,'2MASX J21442728+1217451',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000194,NULL,'16.5g',0.4,NULL,NULL,NULL,NULL,NULL,1,326.11375,12.29583,0.277,NULL,52228668956,816072952,12751139,16.5),(151783,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151783,35.81,0.74,145,72132,70,NULL,NULL,'2MASX J21442818-0632232',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'16.90',0.21,NULL,NULL,NULL,NULL,NULL,1,326.117417,-6.53983,0.069,NULL,49912907664,779889182,12185768,16.9),(151784,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 19048','R',151784,39.85,0.17,821,72133,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19048',0.136789,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,326.1245417,0.59556,0.237,NULL,52093330329,813958286,12718098,NULL),(151785,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 19048','R',151785,39.96,0.23,865,72133,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19048',0.136789,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151786,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151786,34.79,0.58,90.8,72134,NULL,NULL,NULL,'ESO 600- G 009',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'15.19',0.8,'Sb:',NULL,NULL,NULL,NULL,1,326.129041667,-20.04417,0.093,NULL,50929999094,795781235,12434081,15.19),(151787,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151787,34.83,0.2,92.5,72134,74.4,NULL,NULL,'ESO 600- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151788,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151788,34.9,0.55,95.3,72134,NULL,NULL,'Malmquist cor.','ESO 600- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151789,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151789,37.11,0.46,265,72135,70,NULL,NULL,'2MASX J21443118+1114064',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,326.1299583,11.23519,0.281,NULL,52308663885,817322873,12770669,17.7),(151790,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151790,37.19,0.59,274,72136,70,NULL,NULL,'2MASX J21443144-0911282',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.50',0.3,NULL,NULL,NULL,NULL,NULL,1,326.1310417,-9.19128,0.085,NULL,49908325614,779817587,12184649,16.5),(151791,'GRB','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151791,44.05,0.83,3070,72137,NULL,NULL,NULL,'GRB 080413B',1.1,'2010JCAP...08..020W',2010,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,326.144125,-19.98103,0.093,NULL,50930460626,795788447,12434194,NULL),(151792,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151792,35.62,0.61,133,72138,70,NULL,NULL,'2MASX J21443337-1001282',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.00015,NULL,'15.99',0.47,NULL,NULL,NULL,NULL,NULL,1,326.139083333,-10.02453,0.113,NULL,49912198561,779878102,12185595,15.99),(151793,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151793,37.31,0.46,290,72139,70,NULL,NULL,'SDSS J214434.59+104828.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,326.144125,10.80792,0.209,NULL,52308606027,817321969,12770655,18.4),(151794,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151794,36.43,0.53,193,72140,70,NULL,NULL,'2MASX J21443568-0609222',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000103,NULL,'16.16',0.43,NULL,NULL,NULL,NULL,NULL,1,326.148708333,-6.15639,0.093,NULL,49912975312,779890239,12185784,16.16),(151795,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151795,38.29,0.46,454,72141,70,NULL,NULL,'SDSS J214438.49+110326.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000141,NULL,'18.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,326.160375,11.05731,0.201,NULL,52308674405,817323037,12770672,18.9),(151796,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','PTF10wos','N',151796,37.97,0.04,363,72142,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10wos',0.082,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151797,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151797,33.17,NULL,43.1,72143,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2339',NULL,'2010Ap&SS.325..163P',2010,1,2.05,NULL,'G',0.000013,NULL,'15.5g',0.22,'Sd(f)',NULL,NULL,NULL,NULL,1,326.164417,-6.68964,0.069,NULL,49913061708,779891589,12185806,15.5),(151798,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151798,33.19,NULL,43.4,72143,NULL,NULL,'Dipole','FGC 2339',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151799,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151799,33.19,NULL,43.4,72143,NULL,NULL,'Dipole + Quadrupole','FGC 2339',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151800,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151800,33.26,NULL,45,72143,NULL,NULL,NULL,'FGC 2339',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151801,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151801,34.37,0.4,74.9,72144,NULL,NULL,'Malmquist cor.','ESO 343- G 026',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'13.8r',0.7,'Sb',NULL,NULL,NULL,NULL,1,326.1732917,-39.18481,0,NULL,51439204229,803737566,12558399,13.8),(151802,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151802,34.44,0.39,77.2,72144,NULL,NULL,NULL,'ESO 343- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151803,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151803,34.48,0.2,78.7,72144,74.4,NULL,NULL,'ESO 343- G 026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151804,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151804,34.53,0.46,80.4,72145,70,NULL,NULL,'MCG -01-55-007',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.00003,NULL,'14.9g',0.5,'S0/a',NULL,NULL,NULL,NULL,1,326.1832083,-7.05775,0.069,NULL,49912588681,779884198,12185690,14.9),(151805,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15777',NULL,151805,40.21,0.19,1100,72146,70,NULL,'SN photometric redshift distance, z photo =0.301 +/- 0.033','SDSS-II SN 15777',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,326.1885417,-0.61831,0.177,NULL,49878785636,779356025,12177437,NULL),(151806,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16878',NULL,151806,40.37,0.27,1190,72147,70,NULL,'SN photometric redshift distance, z photo =0.329 +/- 0.055','SDSS-II SN 16878',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.5g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,326.203833333,-0.12433,0.189,NULL,49694125636,776470713,12132354,21.5),(151807,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151807,36.24,0.6,177,72148,70,NULL,NULL,'2MASX J21444932-0844127',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'15.8g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,326.205458333,-8.73678,0.081,NULL,49906628327,779791067,12184235,15.8),(151808,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151808,36.47,0.46,197,72148,70,NULL,NULL,'2MASX J21444932-0844127',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151809,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151809,34.54,0.5,80.8,72149,70,NULL,NULL,'IC 5123',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00015,NULL,'14.45',0.5,'(R)SAB(r)ab',NULL,NULL,NULL,NULL,1,326.205625,-72.42075,0.049,NULL,49306899771,770420308,12037817,14.45),(151810,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151810,35.36,0.4,118,72150,NULL,NULL,'mean','NGC 7121',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.00003,NULL,'14.28',0.5,'SB(r)bc?       HII',NULL,NULL,NULL,NULL,1,326.219083333,-3.61972,0.065,NULL,49893413166,779584580,12181009,14.28),(151811,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151811,35.48,0.47,125,72150,NULL,NULL,'H','NGC 7121',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151812,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 07024','RN',151812,42.18,0.26,2040,72151,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07024',0.339001,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151813,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 07024','RN',151813,42.25,0.38,2100,72151,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07024',0.339001,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151814,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 18884',NULL,151814,41.59,NULL,2080,72152,70,NULL,'SN photometric redshift distance, z photo =0.700 +/- 0.001','SDSS-II SN 18884',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,326.263,-0.94997,0.137,NULL,49879638081,779369345,12177646,NULL),(151815,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151815,36.38,0.52,189,72153,70,NULL,NULL,'2MASX J21451239-5454340',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'14.8r',0.42,'S0',NULL,NULL,NULL,NULL,1,326.301667,-54.90953,0.005,NULL,48663011953,760359561,11880618,14.8),(151816,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151816,36.6,0.74,209,72154,70,NULL,NULL,'2MASX J21451515-0816065',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.000103,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,326.313167,-8.26844,0.093,NULL,49906394966,779787421,12184178,16.4),(151817,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151817,36.82,0.46,232,72155,70,NULL,NULL,'2MASX J21451599-0011461',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00015,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,326.3165417,-0.19622,0.189,NULL,49878717689,779354963,12177421,16.5),(151818,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151818,36.24,0.59,177,72156,70,NULL,NULL,'6dF J2145180-350003',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,326.325,-35.00083,0,NULL,51453965520,803968211,12562003,15.6),(151819,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 01294','RN',151819,38.53,0.25,421,72157,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01294',0.20665,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151820,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 01294','RN',151820,39.69,0.25,719,72157,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01294',0.20665,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151821,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151821,37.66,0.33,340,72158,70,NULL,NULL,'2MASX J21452357-0818235',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,326.348333,-8.30667,0.093,NULL,49906387827,779787309,12184176,17.4),(151822,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151822,35.29,0.55,114,72159,70,NULL,NULL,'2MASX J21452504-7723178',NULL,'2014MNRAS.445.2677S',2014,1,0.26,NULL,'G',0.00015,NULL,'15.3r',0.22,NULL,NULL,NULL,NULL,NULL,1,326.354417,-77.38831,0.413,NULL,48528881347,758263771,11847871,15.3),(151823,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 02118','RN',151823,41.79,0.09,1750,72160,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 02118',0.306109,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151824,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 02118','RN',151824,42.01,0.24,1930,72160,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 02118',0.306109,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151825,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151825,35.78,0.67,143,72161,70,NULL,NULL,'2MASX J21453092-7537597',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'15.3r',0.12,NULL,NULL,NULL,NULL,NULL,1,326.379041667,-75.63322,0.425,NULL,48408730914,756386420,11818537,15.3),(151826,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151826,37.66,0.33,340,72162,70,NULL,NULL,'2MASX J21453179-0809245',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,326.3825,-8.15692,0.093,NULL,49906445930,779788217,12184190,17.3),(151827,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151827,34.35,0.8,74.1,72163,75,NULL,'MAT, I','ESO 466- G 005',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000027,NULL,'14.5r',0.6,'Sb',NULL,NULL,NULL,NULL,1,326.384417,-29.07344,0.081,NULL,51468471546,804194867,12565544,14.5),(151828,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151828,34.49,0.32,79.1,72163,85,NULL,'I, raw','ESO 466- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151829,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151829,34.52,0.32,80,72163,85,NULL,'I, inv','ESO 466- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151830,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151830,34.69,0.43,86.8,72163,75,NULL,'MAT, I, raw','ESO 466- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151831,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151831,34.79,0.2,90.8,72163,74.4,NULL,NULL,'ESO 466- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151832,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151832,34.83,0.43,92.3,72163,75,NULL,'MAT, I, inv','ESO 466- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151833,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151833,34.86,0.57,93.8,72163,NULL,NULL,'Malmquist cor.','ESO 466- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151834,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151834,34.96,0.55,98.1,72163,NULL,NULL,NULL,'ESO 466- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151835,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151835,35.08,0.43,104,72163,75,NULL,'MAT, I, cor','ESO 466- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151836,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 06660',NULL,151836,39.29,0.76,720,72164,70,NULL,'SN photometric redshift distance, z photo =0.185 +/- 0.090','SDSS-II SN 06660',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.3g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,326.388,-0.25225,0.189,NULL,49878701823,779354715,12177417,21.3),(151837,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151837,37.99,0.46,397,72165,70,NULL,NULL,'2MASX J21453322+1239227',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000183,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,326.388583,12.65625,0.277,NULL,52228620096,816072189,12751127,17.2),(151838,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151838,35.85,0.66,148,72166,70,NULL,NULL,'2MASX J21453763-5518504',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'14.9r',0.3,'S',NULL,NULL,NULL,NULL,1,326.406667,-55.31403,0.009,NULL,48665733754,760402089,11881282,14.9),(151839,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151839,36.96,0.52,246,72167,70,NULL,NULL,'2MASX J21454401-1042334',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'16.20',0.5,NULL,NULL,NULL,NULL,NULL,1,326.4332083,-10.70942,0.125,NULL,49910457723,779850901,12185170,16.2),(151840,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151840,37.15,0.46,269,72168,70,NULL,NULL,'SDSS J214544.23-084108.4',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,326.434291667,-8.68567,0.081,NULL,49906947111,779796048,12184313,17.7),(151841,'D-Sigma','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151841,34.45,0.4,77.6,72169,75,NULL,'Edat, raw','NGC 7117',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00007,NULL,'13.76',0.9,'SA(s)0-:',NULL,NULL,NULL,NULL,1,326.446,-48.42042,0.009,NULL,50665615869,791650247,12369535,13.76),(151842,'D-Sigma','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151842,34.72,0.4,88,72169,75,NULL,'Edat, cor','NGC 7117',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151843,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151843,34.13,0.48,67.1,72169,70,NULL,NULL,'NGC 7117',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151844,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151844,34.43,0.4,77,72169,NULL,NULL,'mean','NGC 7117',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151845,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151845,34.81,0.45,91.8,72169,NULL,NULL,'K','NGC 7117',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151846,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151846,35.19,0.39,109,72170,NULL,NULL,NULL,'IC 1398',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000103,NULL,'15.4',0.4,NULL,NULL,NULL,NULL,NULL,1,326.4642917,9.47533,0.205,NULL,52307888995,817310765,12770480,15.4),(151847,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151847,35.29,0.37,114,72170,NULL,NULL,'Malmquist cor.','IC 1398',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151848,'BL Lac Luminosity','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151848,40.48,NULL,1010,72171,NULL,NULL,NULL,'2MASX J21455230+0719270',0.237,'2005ApJ...635..173S',2005,1,NULL,NULL,'G',0.003,NULL,'18.04',NULL,'BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,326.467917,7.32422,0.201,NULL,52331797721,817684339,12776317,18.04),(151849,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151849,37.43,0.46,306,72172,70,NULL,NULL,'2MASX J21455345+1236504',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000137,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,326.4725417,12.61408,0.277,NULL,52228637557,816072461,12751132,18),(151850,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 03497','RN',151850,40.97,0.22,1340,72173,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 03497',0.166681,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151851,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 03497','RN',151851,41.34,0.31,1590,72173,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 03497',0.166681,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151852,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151852,37.52,0.33,319,72174,70,NULL,NULL,'2MASX J21455797-0747484',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00015,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,326.4915417,-7.79686,0.065,NULL,49913839683,779903745,12185996,16.3),(151853,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151853,33.4,0.47,48,72175,NULL,NULL,'H','UGC 11808',NULL,'2007A&A...465...71T',2007,1,2.1,NULL,'G',0.000013,NULL,'16.5',1.5,'S?',NULL,NULL,NULL,NULL,1,326.493625,41.27194,NULL,NULL,55382432957,865350514,13521101,16.5),(151854,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151854,33.41,0.45,48.2,72175,NULL,NULL,'K','UGC 11808',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151855,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151855,33.54,0.46,51,72175,NULL,NULL,'J','UGC 11808',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151856,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151856,33.84,0.4,58.6,72175,NULL,NULL,'mean','UGC 11808',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151857,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151857,33.9,0.49,60.2,72176,75,NULL,'IR','CGCG 402-018',NULL,'2011yCatp016004901K',2011,1,0.6,NULL,'G',0.00011,NULL,'15.3',0.2,NULL,NULL,NULL,NULL,NULL,1,326.494917,7.87164,0.225,NULL,52330538546,817664664,12776010,15.3),(151858,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151858,34.05,0.2,64.6,72176,74.4,NULL,NULL,'CGCG 402-018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151859,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151859,34.31,0.33,72.6,72176,NULL,NULL,NULL,'CGCG 402-018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151860,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151860,34.59,0.29,82.7,72176,NULL,NULL,'Malmquist cor.','CGCG 402-018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151861,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151861,37.52,0.33,319,72177,70,NULL,NULL,'2MASX J21455885-0748464',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,326.495333,-7.81292,0.085,NULL,49913839834,779903747,12185996,17.5),(151862,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151862,38.04,0.46,406,72178,70,NULL,NULL,'2MASX J21455896-0906204',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,326.495667,-9.10569,0.097,NULL,49906531943,779789561,12184211,17.4),(151863,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16393',NULL,151863,39.76,0.35,894,72179,70,NULL,'SN photometric redshift distance, z photo =0.236 +/- 0.048','SDSS-II SN 16393',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.2g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,326.501,-0.06092,0.193,NULL,49811592607,778306134,12161033,21.2),(151864,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16393','R',151864,40.42,0.24,920,72179,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16393',0.31643,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151865,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16393','R',151865,40.66,0.17,1030,72179,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16393',0.31643,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151866,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16393',NULL,151866,40.26,0.13,1130,72179,70,NULL,'SALT 2','SDSS-II SN 16393',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151867,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16393',NULL,151867,40.3,0.13,1150,72179,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16393',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151868,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 17171','R',151868,39.39,0.19,649,72180,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007id','2MASX J21460084-0113096',0.160311,'2014arXiv1401.3317S',2014,1,0.18,NULL,'G',NULL,':','19.1g',0.08,NULL,NULL,NULL,NULL,NULL,1,326.5035,-1.21933,0.137,NULL,49879498095,779367157,12177611,19.1),(151869,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 17171','R',151869,39.75,0.18,767,72180,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007id','2MASX J21460084-0113096',0.160311,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151870,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151870,36.77,0.46,226,72181,70,NULL,NULL,'2MASX J21460451+1054360',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000168,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,326.519,10.91003,0.201,NULL,52308909272,817326707,12770729,16.4),(151871,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15351','R',151871,40.82,0.23,1110,72182,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15351',0.316355,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,326.535333,-0.05333,0.281,NULL,49811602517,778306289,12161035,NULL),(151872,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15351',NULL,151872,40.23,0.27,1110,72182,70,NULL,'SN photometric redshift distance, z photo =0.305 +/- 0.050','SDSS-II SN 15351',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151873,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15351','R',151873,40.94,0.29,1170,72182,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15351',0.316355,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151874,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15351',NULL,151874,40.79,0.18,1440,72182,70,NULL,'SALT 2','SDSS-II SN 15351',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151875,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15351',NULL,151875,40.82,0.18,1460,72182,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15351',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151876,'D-Sigma','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151876,34.45,0.4,77.6,72183,75,NULL,'Edat, raw','NGC 7118',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00006,NULL,'13.53',1.2,'SA0- pec:',NULL,NULL,NULL,NULL,1,326.540583,-48.35381,0.009,NULL,50665559334,791649364,12369521,13.53),(151877,'D-Sigma','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151877,34.72,0.4,88,72183,75,NULL,'Edat, cor','NGC 7118',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151878,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151878,34.09,0.53,65.8,72183,70,NULL,NULL,'NGC 7118',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151879,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151879,34.16,0.4,67.8,72183,NULL,NULL,'mean','NGC 7118',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151880,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151880,34.18,0.45,68.4,72183,NULL,NULL,'K','NGC 7118',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151881,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151881,35.02,0.2,101,72184,74.4,NULL,NULL,'CGCG 402-020',NULL,'2013AJ....146...86T',2013,1,0.4,'Not to be confused with IC 1398.','G',0.000017,NULL,'15.5',0.2,NULL,NULL,NULL,NULL,NULL,1,326.549,9.56294,0.205,NULL,52307968911,817312014,12770500,15.5),(151882,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15264','RN',151882,41.18,0.23,1430,72185,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15264',0.209736,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151883,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15264','RN',151883,41.83,0.33,1920,72185,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15264',0.209736,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151884,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20152',NULL,151884,39.47,0.37,783,72186,70,NULL,'SN photometric redshift distance, z photo =0.203 +/- 0.043','SDSS-II SN 20152',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,326.5549583,1.028,0.289,NULL,52312405972,817381343,12771583,NULL),(151885,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20152','R',151885,40.26,0.15,872,72186,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20152',0.294849,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151886,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20152','R',151886,41,0.33,1220,72186,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20152',0.294849,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151887,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 06981','RN',151887,42.66,0.22,2100,72187,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 06981',0.622043,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151888,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151888,36.8,0.59,230,72188,70,NULL,NULL,'ESO 188-IG 019 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.46,'ESO and ESO-LV both have two entries for this object.','G',0.00015,NULL,'15.2r',0.24,NULL,NULL,NULL,NULL,NULL,1,326.559083,-52.26819,0,NULL,50662240486,791597507,12368711,15.2),(151889,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151889,37.62,0.46,334,72189,70,NULL,NULL,'2MASX J21461470+0108315',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000188,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,326.5612917,1.14219,0.245,NULL,52312166454,817377600,12771525,16.7),(151890,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151890,35.4,0.34,120,72190,NULL,NULL,'Malmquist cor.','CGCG 402-021',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',NULL,NULL,'15.6',0.3,NULL,NULL,NULL,NULL,NULL,1,326.5694583,9.68558,0.217,NULL,52307980665,817312197,12770503,15.6),(151891,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151891,35.43,0.34,122,72190,NULL,NULL,NULL,'CGCG 402-021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151892,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151892,35.65,0.2,135,72190,74.4,NULL,NULL,'CGCG 402-021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151893,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13280','RN',151893,39.97,0.26,873,72191,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13280',0.127606,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151894,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13280','RN',151894,40.5,0.36,1120,72191,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13280',0.127606,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151895,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20047','R',151895,41.69,0.26,1590,72192,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J214621.80+003751.9',0.374084,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',0.000135,NULL,'20.6g',0.04,NULL,NULL,NULL,NULL,NULL,1,326.590833,0.63111,0.261,NULL,52311487854,817366997,12771359,20.6),(151896,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20047','R',151896,41.99,0.24,1820,72192,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J214621.80+003751.9',0.374084,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151897,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20047',NULL,151897,41.58,0.16,2070,72192,70,NULL,'SALT 2','SDSS J214621.80+003751.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151898,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20047',NULL,151898,41.64,0.16,2130,72192,70,NULL,'SALT 2, Malmquist cor.','SDSS J214621.80+003751.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151899,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 07517','N',151899,41.98,0.19,2490,72193,70,NULL,'SALT 2','SDSS-II SN 07517',NULL,'2013ApJ...763...88C',2013,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151900,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 07517','N',151900,42.04,0.19,2560,72193,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 07517',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151901,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 01298','RN',151901,40.18,0.23,884,72194,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 01298',0.22649,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151902,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','PTF09dlc',NULL,151902,37.17,0.02,272,72195,NULL,NULL,'J','PTF09dlc',NULL,'2012MNRAS.425.1007B',2012,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,326.647917,6.38986,0.205,NULL,52331835854,817684935,12776327,NULL),(151903,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','PTF09dlc',NULL,151903,37.4,0.02,283,72195,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF09dlc',0.0666,'2014MNRAS.438.1391P',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151904,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','PTF09dlc',NULL,151904,37.31,0.05,290,72195,72,NULL,'M(H) = -18.317 mag','PTF09dlc',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151905,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','PTF09dlc',NULL,151905,37.37,0.02,298,72195,NULL,NULL,'H','PTF09dlc',NULL,'2012MNRAS.425.1007B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151906,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','PTF09dlc',NULL,151906,37.82,0.07,343,72195,70,NULL,'SiFTO+SALT2, SN PTF09dlc','PTF09dlc',0.0666,'2012MNRAS.426.2359M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151907,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151907,36.95,0.51,246,72196,70,NULL,NULL,'2MASX J21463413-5059011',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000103,NULL,'15.1r',0.34,NULL,NULL,NULL,NULL,NULL,1,326.642375,-50.98361,0,NULL,50661626869,791587919,12368561,15.1),(151908,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 03157','RN',151908,43.54,0.26,3420,72197,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03157',0.493477,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151909,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151909,36.94,0.46,245,72198,70,NULL,NULL,'2MASX J21463544+0016587',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000149,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,326.647666667,0.28294,0.241,NULL,52177400871,815271888,12738623,17.3),(151910,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151910,37.01,0.63,253,72199,70,NULL,NULL,'2MASX J21463585-5225001',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.000103,NULL,'14.9r',0.38,'S0',NULL,NULL,NULL,NULL,1,326.649333,-52.41664,0,NULL,50659376515,791552758,12368011,14.9),(151911,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151911,37.25,0.46,281,72200,70,NULL,NULL,'2MASX J21463793-0722017',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00015,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,326.658,-7.36706,0.057,NULL,49915985861,779937279,12186519,16.5),(151912,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151912,35.78,0.8,143,72201,75,NULL,'CF, r','UGC 11809',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'15.18',0.4,'Sb','Isolated galaxy',NULL,NULL,NULL,1,326.65875,8.29461,0.197,NULL,52300424583,817194134,12768658,15.18),(151913,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151913,35.65,0.32,135,72201,NULL,NULL,'Malmquist cor.','UGC 11809',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151914,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151914,35.84,0.38,147,72201,75,NULL,'CF, r, raw','UGC 11809',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151915,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151915,36.05,0.38,162,72201,75,NULL,'CF, r, cor','UGC 11809',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151916,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151916,36.1,0.38,166,72201,75,NULL,'CF, r, inv','UGC 11809',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151917,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151917,36.1,0.26,166,72201,NULL,NULL,NULL,'UGC 11809',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151918,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151918,36.34,0.2,185,72201,74.4,NULL,NULL,'UGC 11809',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151919,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151919,31.86,0.43,23.5,72202,75,NULL,'3.6 micron, color + selection bias corrected','ESO 403- G 024',NULL,'2014MNRAS.444..527S',2014,1,1.3,'1996ApJS..107..201L have V = 4 +- 25 km/s for the superposed star.','G',0.000057,NULL,'15.01',0.6,'SABcd:',NULL,NULL,NULL,NULL,1,326.665667,-36.20539,0,NULL,51440438361,803756849,12558700,15.01),(151920,'BL Lac Luminosity','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151920,40.08,NULL,1040,72203,NULL,NULL,'Min. z = 0.28','1FGL J2146.6-1345',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,326.672,-13.753,0.101,NULL,49776991464,777765491,12152585,NULL),(151921,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151921,35.32,0.49,116,72204,70,NULL,NULL,'2MASX J21464257-0513447',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00005,NULL,'15.42',0.46,NULL,NULL,NULL,NULL,NULL,1,326.677333333,-5.229,0.037,NULL,49884243032,779441297,12178770,15.42),(151922,'Quasar spectrum','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151922,42.76,NULL,3560,72205,NULL,NULL,NULL,'[HB89] 2143-158',NULL,'2002A&A...381L..57D',2002,1,NULL,NULL,'QSO',NULL,NULL,'21.2',NULL,NULL,NULL,NULL,NULL,NULL,1,326.681,-15.65936,0.165,NULL,49767612258,777618941,12150295,21.2),(151923,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151923,37.5,0.46,316,72206,70,NULL,NULL,'2MASX J21464379-0743049',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,326.6824583,-7.71794,0.085,NULL,49913950844,779905481,12186023,17.1),(151924,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151924,38.95,0.46,616,72207,70,NULL,NULL,'SDSS J214651.11-075105.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000137,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,326.713,-7.85158,0.085,NULL,49913991792,779906121,12186033,18.7),(151925,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 06889',NULL,151925,39.07,0.82,653,72208,70,NULL,'SN photometric redshift distance, z photo =0.166 +/- 0.087','SDSS-II SN 06889',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,326.719917,0.90947,0.289,NULL,52312337612,817380275,12771566,NULL),(151926,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151926,35.58,0.51,131,72209,70,NULL,NULL,'2MASX J21465614-5416020',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'16.05',0.27,NULL,NULL,NULL,NULL,NULL,1,326.7337917,-54.26719,0,NULL,48662445288,760350707,11880479,16.05),(151927,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151927,33.89,0.8,59.9,72210,75,NULL,'A82, H','IC 1401',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000013,NULL,'14.41',0.7,'SAB(r)bc:','Isolated galaxy',NULL,NULL,NULL,1,326.747875,1.71275,0.225,NULL,52315351949,817427374,12772302,14.41),(151928,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151928,33.9,0.8,60.3,72210,75,NULL,'CF, r','IC 1401',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151929,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151929,33.64,0.33,53.8,72210,91,NULL,'H','IC 1401',NULL,'1984ApJ...278..475B',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151930,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151930,34,0.38,63.2,72210,75,NULL,'CF, r, raw','IC 1401',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151931,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151931,34.05,0.47,64.6,72210,75,NULL,'A82, H, raw','IC 1401',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151932,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151932,34.12,0.38,66.6,72210,75,NULL,'CF, r, inv','IC 1401',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151933,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151933,34.16,0.2,67.9,72210,74.4,NULL,NULL,'IC 1401',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151934,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151934,34.16,0.47,68,72210,75,NULL,'A82, H, inv','IC 1401',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151935,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151935,34.19,0.4,69,72210,NULL,NULL,'mean','IC 1401',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151936,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151936,34.25,0.38,70.7,72210,75,NULL,'CF, r, cor','IC 1401',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151937,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151937,34.41,0.63,76.1,72210,NULL,NULL,NULL,'IC 1401',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151938,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151938,34.55,0.47,81.2,72210,75,NULL,'A82, H, cor','IC 1401',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151939,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151939,34.56,0.47,81.8,72210,NULL,NULL,'H','IC 1401',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151940,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151940,34.61,0.58,83.4,72210,NULL,NULL,'Malmquist cor.','IC 1401',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151941,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151941,35.44,0.64,122,72211,70,NULL,NULL,'2MASX J21470166-1031048',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000047,NULL,'16.4',0.4,NULL,NULL,NULL,NULL,NULL,1,326.756917,-10.51794,0.109,NULL,49911484213,779866940,12185420,16.4),(151942,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151942,35.78,0.5,143,72212,70,NULL,NULL,'FAIRALL 0979',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.8r',0.22,'S',NULL,NULL,NULL,NULL,1,326.763916667,-46.66253,0,NULL,50646257696,791347776,12364809,14.8),(151943,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151943,37.07,0.27,259,72213,70,NULL,NULL,'2MASX J21470427-0825188',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,326.7677917,-8.42183,0.093,NULL,49905992700,779781135,12184080,16.3),(151944,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16721',NULL,151944,40.58,0.96,1310,72214,70,NULL,'SN photometric redshift distance, z photo =0.370 +/- 0.304','SDSS-II SN 16721',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.8g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,326.7675417,-0.26564,0.193,NULL,49811758282,778308723,12161073,21.8),(151945,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16721','R',151945,41.61,0.31,1540,72214,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16721',0.367298,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151946,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16721','R',151946,41.66,0.35,1570,72214,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16721',0.367298,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151947,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16721',NULL,151947,41.6,0.22,2090,72214,70,NULL,'SALT 2','SDSS-II SN 16721',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151948,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16721',NULL,151948,41.65,0.22,2140,72214,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16721',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151949,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151949,35.68,0.63,137,72215,70,NULL,NULL,'2MASX J21471012-5337071',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.000103,NULL,'14.5r',0.25,'S',NULL,NULL,NULL,NULL,1,326.792125,-53.61858,0,NULL,50604375632,790693369,12354583,14.5),(151950,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16454','RN',151950,40.4,0.17,976,72216,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16454',0.229863,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151951,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16454','RN',151951,40.6,0.29,1070,72216,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16454',0.229863,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151952,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151952,37.1,0.46,263,72217,70,NULL,NULL,'2MASX J21471221-0811161',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000092,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,326.800917,-8.18786,0.089,NULL,49914155216,779908675,12186073,16.6),(151953,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151953,37.07,0.27,259,72218,70,NULL,NULL,'2MASX J21471342-0823301',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000073,NULL,'15.8g',0.44,'BrClG',NULL,NULL,NULL,NULL,1,326.805875,-8.39164,0.093,NULL,49913399552,779896868,12185888,15.8),(151954,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20215','RN',151954,42.59,0.28,1960,72219,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20215',0.683836,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151955,'Sosies','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151955,31.86,0.3,23.6,72220,NULL,NULL,NULL,'UGC 11818',NULL,'2002A&A...393...57T',2002,1,1.4,NULL,'G',0.000013,NULL,'15.0',1.2,'S?',NULL,NULL,NULL,NULL,1,326.8172083,72.47214,2.325,NULL,53516612062,836197063,13065579,15),(151956,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151956,32.07,0.2,25.9,72220,74.4,NULL,NULL,'UGC 11818',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151957,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151957,32.36,0.43,29.6,72220,75,NULL,'3.6 micron, color corrected','UGC 11818',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151958,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151958,32.37,0.43,29.8,72220,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11818',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151959,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151959,32.85,0.4,37.1,72220,NULL,NULL,'mean','UGC 11818',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151960,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151960,32.9,0.46,38,72220,NULL,NULL,'J','UGC 11818',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151961,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151961,32.97,0.45,39.3,72220,NULL,NULL,'K','UGC 11818',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151962,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151962,32.99,0.47,39.7,72220,NULL,NULL,'H','UGC 11818',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151963,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151963,34.57,0.69,81.9,72221,100,NULL,'mid-IR','NGC 7132',NULL,'2013ApJ...771...88L',2013,1,1,NULL,'G',0.00012,NULL,'14.6',0.6,NULL,NULL,NULL,NULL,NULL,1,326.819083,10.24117,0.193,NULL,52307672913,817307389,12770427,14.6),(151964,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13416','RN',151964,42.32,0.21,1800,72222,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13416',0.619782,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151965,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151965,37.07,0.27,259,72223,70,NULL,NULL,'2MASX J21471780-0823211',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000169,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,326.824125,-8.38911,0.093,NULL,49914119759,779908121,12186064,17.7),(151966,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2006kz',NULL,151966,39.22,0.11,700,72224,70,NULL,'Hubble residual -0.01 for z0.18000','SDSS-II SN 15461 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,326.8482083,-0.49475,0.193,NULL,49811646223,778306972,12161046,NULL),(151967,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15461','R',151967,39.75,0.18,752,72224,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006kz','SDSS-II SN 15461 HOST',0.186169,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151968,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15461','R',151968,39.94,0.09,820,72224,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006kz','SDSS-II SN 15461 HOST',0.186169,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151969,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2006kz',NULL,151969,39.62,0.07,839,72224,70,NULL,'SALT 2','SDSS-II SN 15461 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151970,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2006kz',NULL,151970,39.64,0.07,847,72224,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15461 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151971,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151971,33.78,0.8,57,72225,75,NULL,'MAT, I','ESO 343- G 028',NULL,'1997ApJS..109..333W',1997,1,1.19,NULL,'G',0.000033,NULL,'15.3r',0.47,'Sb-c',NULL,NULL,NULL,NULL,1,326.851916667,-38.713,0,NULL,51439339141,803739674,12558432,15.3),(151972,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151972,34.03,0.32,63.9,72225,85,NULL,'I, inv','ESO 343- G 028',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151973,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151973,34.04,0.32,64.3,72225,85,NULL,'I, raw','ESO 343- G 028',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151974,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151974,34.21,0.43,69.5,72225,75,NULL,'MAT, I, raw','ESO 343- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151975,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151975,34.22,0.43,69.7,72225,75,NULL,'MAT, I, inv','ESO 343- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151976,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151976,34.41,0.43,76.1,72225,NULL,NULL,'Malmquist cor.','ESO 343- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151977,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151977,34.41,0.43,76.4,72225,NULL,NULL,NULL,'ESO 343- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151978,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151978,34.46,0.2,78,72225,74.4,NULL,NULL,'ESO 343- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151979,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151979,34.48,0.43,78.6,72225,75,NULL,'MAT, I, cor','ESO 343- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151980,'Tully est','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151980,32.61,0.8,33.3,72226,75,NULL,'B','IC 5131',NULL,'1988NBGC.C....0000T',1988,1,1.4,NULL,'G',0.000083,NULL,'13.65',1.4,'SB0-','in a pair',NULL,NULL,NULL,1,326.8554583,-34.88367,0,NULL,51454096371,803970255,12562035,13.65),(151981,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151981,36.13,0.46,168,72227,70,NULL,NULL,'2MASX J21472854-0738031',NULL,'2015arXiv151105856S',2015,1,0.48,'SDSS DR3 gives z= 0.036 and 0.0597.','G',0.00015,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,326.868833,-7.63422,0.085,NULL,49913925170,779905080,12186016,16.5),(151982,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151982,37.75,0.46,355,72228,70,NULL,NULL,'2MASX J21473071-0749321',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000156,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,326.878083333,-7.82572,0.085,NULL,49914077226,779907456,12186054,17),(151983,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151983,37.25,0.46,281,72229,70,NULL,NULL,'2MASX J21473486+0046231',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000183,NULL,'16.5g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,326.89525,0.77322,0.289,NULL,52177733627,815277087,12738704,16.5),(151984,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 1998co',NULL,151984,33.65,0.31,52.7,72230,74.2,NULL,'SALT 2','NGC 7131',0.01807,'2010ApJ...716..712A',2010,1,1.7,NULL,'G',0.000043,NULL,'14.5',1,'(R\')SA(rs)0^0^?',NULL,NULL,NULL,NULL,1,326.9004583,-13.18261,0.113,NULL,49775862175,777747846,12152310,14.5),(151985,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 1998co',NULL,151985,34.15,0.08,67.6,72230,74.4,NULL,NULL,'NGC 7131',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151986,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 1998co',NULL,151986,34.22,0.41,68.6,72230,73.8,NULL,'SALT 2 (SNANA)','NGC 7131',0.0172,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151987,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 1998co',NULL,151987,34.27,0.29,70.2,72230,70,NULL,'SALT','NGC 7131',0.01807,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151988,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 1998co',NULL,151988,34.29,0.08,70.8,72230,72,NULL,NULL,'NGC 7131',0.01807,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151989,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 1998co',NULL,151989,34.37,0.22,73.6,72230,65,NULL,'MLCS31','NGC 7131',0.01807,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151990,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 1998co',NULL,151990,34.43,0.13,74.2,72230,65,NULL,'MLCS2k2','NGC 7131',0.01807,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151991,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 1998co',NULL,151991,34.4,0.32,74.4,72230,65,NULL,'SALT','NGC 7131',0.01807,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151992,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 1998co',NULL,151992,34.48,0.22,77.1,72230,65,NULL,'MLCS17','NGC 7131',0.01807,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151993,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 1998co',NULL,151993,34.68,0.24,84.8,72230,65,NULL,NULL,'NGC 7131',0.01807,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151994,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151994,35.09,0.49,104,72230,70,NULL,NULL,'NGC 7131',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151995,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151995,34.51,0.4,79.8,72230,NULL,NULL,'mean','NGC 7131',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151996,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151996,34.68,0.45,86.4,72230,NULL,NULL,'K','NGC 7131',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151997,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151997,33.92,0.2,60.8,72231,74.4,NULL,NULL,'MCG -01-55-011',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000036,NULL,'14.5',0.5,'(R)SB(s)b pec  HII',NULL,NULL,NULL,NULL,1,326.922917,-4.16156,0.097,NULL,49894803208,779606300,12181348,14.5),(151998,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151998,34.01,0.55,63.4,72231,NULL,NULL,NULL,'MCG -01-55-011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151999,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151999,34.19,0.51,68.7,72231,NULL,NULL,'Malmquist cor.','MCG -01-55-011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152000,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152000,34.36,0.4,74.5,72231,NULL,NULL,'mean','MCG -01-55-011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152001,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152001,34.61,0.47,83.5,72231,NULL,NULL,'H','MCG -01-55-011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152002,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152002,37.25,0.46,282,72232,70,NULL,NULL,'2MASX J21474245-0646146',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,326.926917,-6.77081,0.053,NULL,49915769714,779933901,12186467,16.8),(152003,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152003,36.75,0.64,224,72233,70,NULL,NULL,'2MASX J21480121-1155025',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000073,NULL,'16.81',0.48,NULL,NULL,NULL,NULL,NULL,1,327.005083,-11.91753,0.141,NULL,49901987249,779718550,12183102,16.81),(152004,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152004,32.48,0.8,31.3,72234,75,NULL,'MAT, I','ESO 403- G 031',NULL,'1997ApJS..109..333W',1997,1,1.3,'The APMUKS image includes a superposed star.','G',0.000017,NULL,'15.19',0.5,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,327.018167,-36.77408,0,NULL,51440803719,803762558,12558789,15.19),(152005,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152005,31.9,0.32,24,72234,85,NULL,'I, inv','ESO 403- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152006,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152006,31.96,0.32,24.7,72234,85,NULL,'I, raw','ESO 403- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152007,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152007,32.21,0.43,27.6,72234,75,NULL,'MAT, I, inv','ESO 403- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152008,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152008,32.37,0.43,29.7,72234,75,NULL,'MAT, I, raw','ESO 403- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152009,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152009,32.53,0.43,32.1,72234,75,NULL,'3.6 micron, color + selection bias corrected','ESO 403- G 031',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152010,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152010,32.6,0.43,33.1,72234,75,NULL,'MAT, I, cor','ESO 403- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152011,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152011,32.61,0.1,33.3,72234,NULL,NULL,NULL,'ESO 403- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152012,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152012,32.63,0.43,33.6,72234,75,NULL,'3.6 micron, color corrected','ESO 403- G 031',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152013,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152013,32.67,0.2,34.2,72234,74.4,NULL,NULL,'ESO 403- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152014,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152014,34.09,0.8,65.8,72235,75,NULL,'MAT, I','NGC 7124',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000028,NULL,'13.10',1.3,'SB(rs)c        LINER','in a pair',NULL,NULL,NULL,1,327.0224583,-50.56522,0,NULL,50661485898,791585717,12368526,13.1),(152015,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152015,33.65,0.43,53.6,72235,75,NULL,'MAT, I, raw','NGC 7124',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152016,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152016,33.68,NULL,54.5,72235,NULL,NULL,'B','NGC 7124',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152017,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152017,33.69,0.46,54.7,72235,NULL,NULL,'B, Hubble-type-TF','NGC 7124',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152018,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152018,33.69,0.32,54.8,72235,85,NULL,'I, raw','NGC 7124',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152019,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152019,33.74,0.46,56.1,72235,NULL,NULL,'J','NGC 7124',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152020,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152020,33.76,0.32,56.6,72235,85,NULL,'I, inv','NGC 7124',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152021,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152021,33.85,0.45,58.8,72235,NULL,NULL,'K','NGC 7124',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152022,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152022,33.85,NULL,58.9,72235,NULL,NULL,'I','NGC 7124',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152023,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152023,33.86,0.47,59.3,72235,NULL,NULL,'H','NGC 7124',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152024,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152024,33.94,0.43,61.3,72235,75,NULL,'MAT, I, inv','NGC 7124',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152025,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152025,33.97,0.43,62.3,72235,75,NULL,'MAT, I, cor','NGC 7124',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152026,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152026,34.15,0.4,67.5,72235,NULL,NULL,'mean','NGC 7124',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152027,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152027,35.69,0.52,137,72236,70,NULL,NULL,'2MASX J21480647-7626027',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'14.8r',0.18,NULL,NULL,NULL,NULL,NULL,1,327.027125,-76.43417,0.401,NULL,48529680595,758276259,11848066,14.8),(152028,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 19068','RN',152028,41.43,0.23,1630,72237,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19068',0.18656,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152029,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 19068','RN',152029,42.22,0.31,2340,72237,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19068',0.18656,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152030,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152030,37.31,0.46,290,72238,70,NULL,NULL,'2MASX J21481145-0748200',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00014,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,327.0477917,-7.80561,0.085,NULL,49914060830,779907200,12186050,17.7),(152031,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152031,31.99,0.4,25,72239,75,NULL,'B','NGC 7137',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.00001,NULL,'13.05',1.4,'SAB(rs)c',NULL,NULL,NULL,NULL,1,327.054333,22.15958,0.297,NULL,55109101940,861079717,13454370,13.05),(152032,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152032,36.13,0.54,168,72240,70,NULL,NULL,'AM 2144-551 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.00015,NULL,'15.27',0.63,'SB(rs)b',NULL,NULL,NULL,NULL,1,327.065875,-54.982,0.009,NULL,48708865365,761076021,11891812,15.27),(152033,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 11085','RN',152033,40.35,0.09,915,72241,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 11085',0.282957,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152034,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152034,36.2,0.58,174,72242,70,NULL,NULL,'2MASX J21483072-5703242',NULL,'2014MNRAS.445.2677S',2014,1,0.87,NULL,'G',0.000117,NULL,'14.2r',0.38,'S',NULL,NULL,NULL,NULL,1,327.128,-57.05681,0,NULL,48717273586,761207399,11893865,14.2),(152035,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152035,36.9,0.46,240,72243,70,NULL,NULL,'2MASX J21484103+1145034',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000176,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,327.171083333,11.75086,0.257,NULL,52304972427,817265194,12769768,17.1),(152036,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 10045','R',152036,39.48,0.23,707,72244,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 10045',0.116045,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,327.195167,1.21144,0.289,NULL,52177696688,815276510,12738695,NULL),(152037,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 10045','R',152037,39.52,0.16,717,72244,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 10045',0.116045,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152038,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 10045',NULL,152038,40.38,0.13,1190,72244,70,NULL,'SN photometric redshift distance, z photo =0.330 +/- 0.026','SDSS-II SN 10045',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152039,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152039,36.88,0.33,237,72245,70,NULL,NULL,'2MASX J21484717-0110155',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000192,NULL,'17.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,327.1964583,-1.17106,0.281,NULL,49811863000,778310359,12161099,17),(152040,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152040,38.48,0.46,496,72246,70,NULL,NULL,'2MASX J21484782-0658059',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000097,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,327.19925,-6.96831,0.069,NULL,49914975612,779921493,12186273,18),(152041,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 06683','RN',152041,42.32,0.52,1930,72247,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06683',0.508965,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152042,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 06683','N',152042,42.29,0.39,2870,72247,70,NULL,'SALT 2','SDSS-II SN 06683',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152043,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 06683','N',152043,42.44,0.39,3080,72247,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 06683',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152044,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 04927','RN',152044,43.71,0.21,3680,72248,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04927',0.503608,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152045,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152045,38.32,0.46,461,72249,70,NULL,NULL,'SDSS J214855.39+115618.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000152,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,327.230833,11.93856,0.225,NULL,52304198635,817253103,12769579,18.7),(152046,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16582',NULL,152046,40.07,0.29,1030,72250,70,NULL,'SN photometric redshift distance, z photo =0.279 +/- 0.049','SDSS-II SN 16582',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,327.241083,-0.43389,0.289,NULL,49812360726,778318136,12161220,NULL),(152047,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152047,35.34,0.4,117,72251,NULL,NULL,'mean','NGC 7138',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000033,NULL,'15.05',0.5,'SBa','Isolated galaxy',NULL,NULL,NULL,1,327.2545417,12.51422,0.249,NULL,52233974361,816155849,12752435,15.05),(152048,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152048,35.37,0.47,119,72251,NULL,NULL,'H','NGC 7138',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152049,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152049,35.4,0.45,120,72251,NULL,NULL,'K','NGC 7138',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152050,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152050,35.45,0.46,123,72251,NULL,NULL,'J','NGC 7138',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152051,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152051,35.73,0.2,140,72251,74.4,NULL,NULL,'NGC 7138',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152052,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152052,37.32,0.33,291,72252,70,NULL,NULL,'2MASX J21490358+0111349',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,327.265,1.193,0.269,NULL,52177688256,815276379,12738693,17),(152053,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152053,38.37,0.46,472,72253,70,NULL,NULL,'SDSS J214904.16-071707.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000077,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,327.267375,-7.28528,0.069,NULL,49915607398,779931365,12186427,18.6),(152054,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152054,37.32,0.33,291,72254,70,NULL,NULL,'2MASX J21490711+0111409',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,327.279583,1.19464,0.269,NULL,52177717718,815276839,12738700,18.2),(152055,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2004ey',NULL,152055,33.55,0.05,50.4,72255,70,NULL,NULL,'UGC 11816',0.015786,'2011ApJS..192....1C',2011,1,0.96,NULL,'G',0.000022,NULL,'14.9g',0.92,'SB(rs)c:','Isolated galaxy',NULL,NULL,NULL,1,327.280375,0.44733,0.321,NULL,52177962658,815280666,12738760,14.9),(152056,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2004ey',NULL,152056,33.92,0.01,60.8,72255,72,NULL,NULL,'UGC 11816',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152057,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2004ey',NULL,152057,33.99,0.02,62.8,72255,72,NULL,'M(H) = -18.317 mag','UGC 11816',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152058,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2004ey',NULL,152058,34.03,0.19,62.9,72255,72,NULL,NULL,'UGC 11816',0.015786,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152059,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2004ey',NULL,152059,34,0.1,63.1,72255,74.4,NULL,NULL,'UGC 11816',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152060,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2004ey',NULL,152060,34.06,0.05,63.9,72255,72,NULL,NULL,'UGC 11816',0.015786,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152061,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2004ey',NULL,152061,34.13,0.16,65.1,72255,72,NULL,NULL,'UGC 11816',0.01464,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152062,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2004ey',NULL,152062,34.16,0.17,66.8,72255,73.8,NULL,'SALT 2 (SNANA)','UGC 11816',0.0156,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152063,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2004ey',NULL,152063,34.18,0.2,67.5,72255,70,NULL,'SALT 2','UGC 11816',0.015786,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152064,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152064,35.84,0.59,147,72256,70,NULL,NULL,'2MASX J21490903-5540155',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.6b',0.3,NULL,NULL,NULL,NULL,NULL,1,327.2875,-55.67092,0,NULL,48710188627,761096697,11892135,16.6),(152065,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152065,35.85,0.65,148,72257,70,NULL,NULL,'2MASX J21491476-0937070',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000123,NULL,'16.32',0.35,NULL,NULL,NULL,NULL,NULL,1,327.311541667,-9.61847,0.101,NULL,49900784585,779699759,12182808,16.32),(152066,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 01271','RN',152066,42.16,0.2,1750,72258,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01271',0.540634,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152067,'Tully est','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152067,32.92,0.8,38.4,72259,75,NULL,'B','NGC 7125',NULL,'1988NBGC.C....0000T',1988,1,3.1,'Extended HIPASS source','G',0.000003,NULL,'12.8',2.1,'SAB(s)c','Possible pair member',NULL,NULL,NULL,1,327.316583333,-60.71317,0.049,NULL,48680391985,760631124,11884861,12.8),(152068,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152068,33.23,0.4,44.2,72259,NULL,NULL,'mean','NGC 7125',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152069,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152069,33.7,0.47,55,72259,NULL,NULL,'H','NGC 7125',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152070,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152070,33.73,0.46,55.7,72259,NULL,NULL,'J','NGC 7125',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152071,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152071,33.79,0.45,57.3,72259,NULL,NULL,'K','NGC 7125',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152072,'Ring Diameter','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152072,33.2,0.84,43,72260,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7126',NULL,'1981ApJS...45..541P',1981,1,2.8,NULL,'G',0.000007,NULL,'12.87',1.3,'SA:(rs:)bc','Possible pair member',NULL,NULL,NULL,1,327.3255417,-60.60922,0.049,NULL,48680339457,760630304,11884848,12.87),(152073,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152073,32.9,0.8,38,72260,75,NULL,'MAT, I','NGC 7126',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152074,'Sosies','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152074,32.86,0.14,37.3,72260,NULL,NULL,NULL,'NGC 7126',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152075,'Tully est','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152075,32.87,0.8,37.5,72260,75,NULL,'B','NGC 7126',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152076,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152076,32.68,0.32,34.4,72260,85,NULL,'I, raw','NGC 7126',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152077,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152077,32.73,0.32,35.1,72260,85,NULL,'I, inv','NGC 7126',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152078,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152078,32.84,0.43,36.9,72260,75,NULL,'MAT, I, raw','NGC 7126',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152079,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152079,33,0.43,39.7,72260,75,NULL,'MAT, I, cor','NGC 7126',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152080,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152080,33.04,0.43,40.6,72260,75,NULL,'MAT, I, inv','NGC 7126',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152081,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152081,33.18,0.34,43.2,72260,NULL,NULL,NULL,'NGC 7126',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152082,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152082,33.21,0.46,43.8,72260,NULL,NULL,'J','NGC 7126',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152083,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152083,33.22,0.33,44,72260,NULL,NULL,'Malmquist cor.','NGC 7126',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152084,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152084,33.22,0.2,44.1,72260,74.4,NULL,NULL,'NGC 7126',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152085,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152085,33.23,0.47,44.2,72260,NULL,NULL,'H','NGC 7126',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152086,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152086,33.24,0.4,44.4,72260,NULL,NULL,'mean','NGC 7126',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152087,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152087,33.26,0.45,44.8,72260,NULL,NULL,'K','NGC 7126',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152088,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152088,36.88,0.33,237,72261,70,NULL,NULL,'2MASX J21491880-0100262',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'16.5g',0.32,'S0^-',NULL,NULL,NULL,NULL,1,327.328333,-1.00717,0.217,NULL,49812053599,778313337,12161145,16.5),(152089,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 19069',NULL,152089,40.86,0.3,1490,72262,70,NULL,'SN photometric redshift distance, z photo =0.437 +/- 0.088','SDSS-II SN 19069',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,327.335083,1.05133,0.273,NULL,52177891789,815279559,12738743,NULL),(152090,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152090,37.62,0.33,334,72263,70,NULL,NULL,'SDSS J214924.06-064209.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000086,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,327.35025,-6.70264,0.077,NULL,49915342020,779927219,12186362,18.3),(152091,'GRB','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152091,41.34,NULL,1850,72264,70,NULL,'Pseudo z = 0.59','GRB 030723',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'VisS',NULL,NULL,'>19.5',NULL,'HETE',NULL,NULL,NULL,NULL,1,327.35175,-27.71314,0.045,NULL,51410752798,803293012,12551453,0),(152092,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152092,38.34,0.33,466,72265,70,NULL,NULL,'2MASX J21492482-0812500',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000094,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,327.3534583,-8.21397,0.069,NULL,49914187944,779909186,12186081,18.3),(152093,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 09155','R',152093,41.14,0.23,1300,72266,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J214925.15-004704.0',0.3049,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',0.0005,NULL,'21.0g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,327.3547917,-0.78447,0.269,NULL,49811940273,778311566,12161118,21),(152094,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 09155','R',152094,41.31,0.36,1400,72266,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J214925.15-004704.0',0.3049,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152095,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 09155',NULL,152095,41.18,0.22,1720,72266,70,NULL,'SALT 2','SDSS J214925.15-004704.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152096,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 09155',NULL,152096,41.21,0.22,1750,72266,70,NULL,'SALT 2, Malmquist cor.','SDSS J214925.15-004704.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152097,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152097,36.93,0.46,244,72267,70,NULL,NULL,'2MASX J21492564+0107326',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000182,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,327.356875,1.12586,0.253,NULL,52177885389,815279459,12738741,17.5),(152098,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 02498','RN',152098,39.86,0.16,795,72268,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02498',0.178769,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152099,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 02498','RN',152099,40.83,0.22,1240,72268,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02498',0.178769,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152100,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152100,38.34,0.33,466,72269,70,NULL,NULL,'2MASX J21492651-0811160',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000084,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,327.360583333,-8.18783,0.069,NULL,49913712732,779901761,12185965,17.5),(152101,'Tully est','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152101,31.17,0.8,17.1,72270,75,NULL,NULL,'UGC 11820',NULL,'1988NBGC.C....0000T',1988,1,2,NULL,'G',0.000013,NULL,'17.',1.8,'Sm',NULL,NULL,NULL,NULL,1,327.368333,14.23111,0.329,NULL,52244237573,816316212,12754940,17),(152102,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152102,37.88,0.46,377,72271,70,NULL,NULL,'SDSS J214929.40-073508.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000071,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,327.3725,-7.58581,0.065,NULL,49915410844,779928294,12186379,18.6),(152103,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152103,34.16,0.47,67.9,72272,NULL,NULL,'H','UGC 11821',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000017,NULL,'14.96',0.3,'Sa',NULL,NULL,NULL,NULL,1,327.398,15.79044,0.305,NULL,52237249502,816207023,12753234,14.96),(152104,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152104,34.21,0.45,69.4,72272,NULL,NULL,'K','UGC 11821',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152105,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152105,34.34,0.46,73.9,72272,NULL,NULL,'J','UGC 11821',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152106,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152106,34.86,0.49,93.7,72272,75,NULL,'IR','UGC 11821',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152107,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152107,34.99,0.4,99.6,72272,NULL,NULL,'mean','UGC 11821',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152108,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 12869','R',152108,40.61,0.2,1030,72273,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ge','SN 2006ge',0.279533,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,327.399125,0.00106,0.361,NULL,52177442840,815272544,12738633,NULL),(152109,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 12869','R',152109,40.77,0.2,1120,72273,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ge','SN 2006ge',0.279533,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152110,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152110,37.62,0.33,334,72274,70,NULL,NULL,'2MASX J21493804-0641297',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000108,NULL,'16.1g',0.39,'E0',NULL,NULL,NULL,NULL,1,327.4085417,-6.6915,0.077,NULL,49915336138,779927127,12186361,16.1),(152111,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152111,36.06,0.75,163,72275,70,NULL,NULL,'AM 2146-565 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00015,NULL,'16.43',0.2,'S0',NULL,NULL,NULL,NULL,1,327.412917,-56.68806,0,NULL,48717736702,761214635,11893978,16.43),(152112,'Faber-Jackson','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152112,31.4,1.31,19.1,72276,95,NULL,'Weighted Mean','NGC 7135',NULL,'1984ApJS...56...91D',1984,1,3,'Joguet et al. (2001A&A...380...19J) claim \\\"No activity\\\".','G',0.000003,NULL,'12.71',1.9,'SA0- pec       HII','in a pair',NULL,NULL,'AGN',1,327.4417083,-34.87628,0,NULL,51445835188,803841174,12560018,12.71),(152113,'Faber-Jackson','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152113,32.71,1.61,34.8,72276,55,NULL,'Visvanathan & Sandage 1979','NGC 7135',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152114,'Tully est','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152114,32.7,0.8,34.7,72276,75,NULL,'B','NGC 7135',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152115,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152115,37.49,0.46,314,72277,70,NULL,NULL,'SDSS J214946.36-072632.9',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000193,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,327.4432083,-7.44247,0.069,NULL,49915422380,779928474,12186382,16.2),(152116,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152116,34.5,0.49,79.3,72278,75,NULL,'IR','CGCG 493-009',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000033,NULL,'15.70',0.2,'Sc',NULL,NULL,NULL,NULL,1,327.467917,31.61094,0.509,NULL,55628764806,869199450,13581241,15.7),(152117,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152117,35.55,0.57,129,72279,70,NULL,NULL,'2MASX J21495311-5349371',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'14.9r',0.29,NULL,NULL,NULL,NULL,NULL,1,327.471417,-53.82692,0,NULL,50604305064,790692266,12354566,14.9),(152118,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152118,34.88,0.6,94.4,72280,70,NULL,NULL,'2MASX J21495695-5242191',NULL,'2014MNRAS.445.2677S',2014,1,0.67,'Muriel et al. (1995,AJ,110,1032) also give v = 5,022 km/sec.','G',0.000133,NULL,'13.5r',0.55,'E',NULL,NULL,NULL,NULL,1,327.4874583,-52.70525,0,NULL,50659612860,791556450,12368069,13.5),(152119,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152119,36.84,0.58,233,72281,70,NULL,NULL,'2MASX J21495733-0450301',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'17.05',0.33,NULL,NULL,NULL,NULL,NULL,1,327.489,-4.84181,0.057,NULL,49892058558,779563414,12180678,17.05),(152120,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152120,35.99,0.46,158,72282,70,NULL,NULL,'2MASX J21495842+0032427',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000161,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,327.4932917,0.54536,0.297,NULL,52177524490,815273820,12738653,16.6),(152121,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 01958','R',152121,40.43,0.41,889,72283,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 01958',0.3698,'2014arXiv1401.3317S',2014,1,NULL,NULL,'*',NULL,'PHOT','22.9g',NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,327.504583,0.87389,0.273,NULL,52177804163,815278190,12738721,22.9),(152122,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 01958','R',152122,40.59,0.39,957,72283,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 01958',0.3698,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152123,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 01958',NULL,152123,40.67,0.62,1360,72283,70,NULL,'SN photometric redshift distance, z photo =0.390 +/- 0.181','SDSS-II SN 01958',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152124,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152124,37.43,0.46,307,72284,70,NULL,NULL,'2MASXi J2150024+124605',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000169,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,327.51025,12.76814,0.269,NULL,52234637756,816166214,12752597,18.2),(152125,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152125,37.16,0.46,271,72285,70,NULL,NULL,'2MASX J21500448+0026338',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000188,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,327.518708333,0.44258,0.297,NULL,52177518356,815273724,12738651,17),(152126,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152126,36.59,0.46,208,72286,70,NULL,NULL,'2MASX J21500501+0023578',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000176,NULL,'16.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,327.521,0.39928,0.297,NULL,52177504386,815273506,12738648,16.6),(152127,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152127,37.41,0.62,303,72287,70,NULL,NULL,'2MASX J21500534-6134039',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'15.2r',0.36,NULL,NULL,NULL,NULL,NULL,1,327.522166667,-61.56783,0.025,NULL,49158500229,768101566,12001586,15.2),(152128,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16301',NULL,152128,39.38,0.75,752,72288,70,NULL,'SN photometric redshift distance, z photo =0.194 +/- 0.094','SDSS-II SN 16301',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,327.528583,1.03331,0.253,NULL,52180653552,815322711,12739417,NULL),(152129,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152129,34.92,0.49,96.5,72289,75,NULL,'IR','UGC 11824',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000033,NULL,'16.0',0.3,'SBcd?',NULL,NULL,NULL,NULL,1,327.5435,30.8235,0.541,NULL,55629013279,869203332,13581302,16),(152130,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152130,38.12,0.46,421,72290,70,NULL,NULL,'2MASX J21501212-0659310',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00008,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,327.550625,-6.99192,0.077,NULL,49914928491,779920757,12186261,17.6),(152131,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152131,36.83,0.46,232,72291,70,NULL,NULL,'2MASX J21501308+0036018',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,327.554583,0.60056,0.297,NULL,52180947566,815327305,12739489,17.3),(152132,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152132,37.92,0.33,383,72292,70,NULL,NULL,'2MASX J21501406-0709020',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000086,NULL,'16.8g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,327.5585417,-7.15053,0.069,NULL,49915078696,779923104,12186298,16.8),(152133,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152133,35.98,0.59,157,72293,70,NULL,NULL,'2MASX J21501521-1449522',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'16.41',0.19,NULL,NULL,NULL,NULL,NULL,1,327.563458333,-14.83117,0.109,NULL,49777456136,777772752,12152699,16.41),(152134,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152134,36.74,0.46,223,72294,70,NULL,NULL,'2MASX J21501682-0703140',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00007,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,327.570083,-7.05392,0.069,NULL,49915089105,779923267,12186301,17.3),(152135,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152135,36.32,0.57,184,72295,70,NULL,NULL,'FAIRALL 0118',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'14.8r',0.53,'S0',NULL,NULL,NULL,NULL,1,327.575375,-59.90447,0.041,NULL,48682399430,760662491,11885351,14.8),(152136,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152136,38.18,0.46,433,72296,70,NULL,NULL,'2MASX J21501901-0050541',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,327.579333333,-0.84836,0.257,NULL,49815357580,778364962,12161952,18.6),(152137,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152137,34.87,0.56,94.1,72297,70,NULL,NULL,'2MASX J21502061-0404110',NULL,'2014MNRAS.445.2677S',2014,1,0.69,NULL,'G',0.00015,NULL,'16.39',0.36,NULL,NULL,NULL,NULL,NULL,1,327.5859583,-4.06967,0.081,NULL,49895291894,779613935,12181467,16.39),(152138,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152138,37.92,0.33,383,72298,70,NULL,NULL,'SDSS J215020.80-070455.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000081,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,327.586667,-7.08214,0.069,NULL,49915073308,779923020,12186297,18.2),(152139,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152139,37.47,0.46,312,72299,70,NULL,NULL,'2MASX J21502206-0018370',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,327.5919583,-0.31025,0.325,NULL,49812113069,778314266,12161160,17.2),(152140,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152140,35.41,0.53,121,72300,70,NULL,NULL,'2MASX J21502221-0550590',NULL,'2014MNRAS.445.2677S',2014,1,0.32,NULL,'G',0.00015,NULL,'17.39',0.27,NULL,NULL,NULL,NULL,NULL,1,327.5924583,-5.84964,0.021,NULL,49884144173,779439752,12178746,17.39),(152141,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152141,35.02,0.8,101,72301,75,NULL,'MAT, I','IC 5130',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'14.49',0.6,'SA(s)bc:',NULL,NULL,NULL,NULL,1,327.601125,-73.99742,0.173,NULL,48416358367,756505599,11820399,14.49),(152142,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152142,34.7,0.43,87,72301,75,NULL,'MAT, I, raw','IC 5130',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152143,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152143,34.8,0.32,91.2,72301,85,NULL,'I, raw','IC 5130',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152144,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152144,34.87,0.32,94.2,72301,85,NULL,'I, inv','IC 5130',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152145,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152145,34.99,0.43,99.7,72301,75,NULL,'MAT, I, inv','IC 5130',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152146,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152146,35.06,0.47,103,72301,NULL,NULL,'H','IC 5130',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152147,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152147,35.1,0.43,105,72301,75,NULL,'MAT, I, cor','IC 5130',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152148,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152148,35.15,0.46,107,72301,NULL,NULL,'J','IC 5130',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152149,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152149,35.16,0.45,108,72301,NULL,NULL,'K','IC 5130',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152150,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152150,35.16,0.4,108,72301,NULL,NULL,'mean','IC 5130',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152151,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152151,35.18,0.43,109,72301,NULL,NULL,'Malmquist cor.','IC 5130',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152152,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152152,35.21,0.42,110,72301,NULL,NULL,NULL,'IC 5130',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152153,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152153,35.25,0.2,112,72301,74.4,NULL,NULL,'IC 5130',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152154,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152154,33.97,0.45,62.1,72302,NULL,NULL,'K','IC 5139',NULL,'2007A&A...465...71T',2007,1,2.1,NULL,'G',0.000083,NULL,'13.69',1,'SB0-?          HII','Pair member (points to parent)',NULL,NULL,NULL,1,327.606917,-30.99472,0,NULL,51464097321,804126520,12564476,13.69),(152155,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152155,34.24,0.4,70.4,72302,NULL,NULL,'mean','IC 5139',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152156,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 11363','RN',152156,38.53,0.21,434,72303,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 11363',0.172747,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152157,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 11363','RN',152157,38.68,0.07,464,72303,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 11363',0.172747,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152158,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152158,34.93,0.46,96.7,72304,70,NULL,NULL,'2MASX J21502753+1238103',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000165,NULL,'16.5g',0.19,'S0/a',NULL,NULL,NULL,NULL,1,327.614833,12.63628,0.317,NULL,52234806837,816168856,12752638,16.5),(152159,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152159,36.61,0.2,210,72305,74.4,NULL,NULL,'UGC 11825',NULL,'2013AJ....146...86T',2013,1,1.01,NULL,'G',0.000067,NULL,'15.2g',0.46,'Sa?            AGN',NULL,NULL,NULL,NULL,1,327.676417,0.91197,0.253,NULL,52181127571,815330118,12739533,15.2),(152160,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152160,37.18,0.46,273,72306,70,NULL,NULL,'2MASX J21504335-0724275',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00015,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,327.680583,-7.40764,0.069,NULL,49914863729,779919745,12186246,16.2),(152161,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152161,35.68,0.66,137,72307,70,NULL,NULL,'ESO 145- G 020',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00011,NULL,'14.3r',0.3,'Sb- c',NULL,NULL,NULL,NULL,1,327.695667,-61.76414,0.029,NULL,49159289953,768113905,12001779,14.3),(152162,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152162,36.22,0.64,175,72308,70,NULL,NULL,'2MASX J21505563-0251491',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'16.69',0.36,NULL,NULL,NULL,NULL,NULL,1,327.7317917,-2.86364,0.137,NULL,49881623985,779400374,12178130,16.69),(152163,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152163,34.05,0.47,64.6,72309,70,NULL,NULL,'IC 1404',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000067,NULL,'14.55',1,NULL,NULL,NULL,NULL,NULL,1,327.734917,-9.26658,0.101,NULL,49918737502,779980273,12187191,14.55),(152164,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 07736',NULL,152164,38.91,1.42,606,72310,70,NULL,'SN photometric redshift distance, z photo =0.153 +/- 0.168','SDSS-II SN 07736',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,327.7527917,0.11806,0.333,NULL,52178724710,815292573,12738946,NULL),(152165,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152165,34.99,0.47,99.6,72311,70,NULL,NULL,'MC 2147-465',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00015,NULL,'15.26',1.2,'(R\')SA(s)0^0^: pec',NULL,NULL,NULL,NULL,1,327.777875,-46.27531,0,NULL,50644301294,791317207,12364331,15.26),(152166,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152166,37.36,0.46,297,72312,70,NULL,NULL,'SDSS J215107.77+104739.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.6g',0.19,'AGN',NULL,NULL,NULL,NULL,1,327.782375,10.79422,0.233,NULL,52307048214,817297628,12770275,17.6),(152167,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2005ic',NULL,152167,40.31,0.14,880,72313,74.2,NULL,'SALT 2','SDSS J215108.63-005033.1',0.31,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,327.785958333,-0.84253,0.273,NULL,49815531721,778367683,12161995,NULL),(152168,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2005ic',NULL,152168,40.45,0.05,938,72313,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 05844, SN 2005ic','SDSS J215108.63-005033.1',0.31,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152169,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2005ic',NULL,152169,40.22,0.1,1110,72313,70,NULL,'Hubble residual -0.05 for z0.31080','SDSS J215108.63-005033.1',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152170,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2005ic',NULL,152170,40.95,0.12,1180,72313,65,NULL,'SALT2','SDSS J215108.63-005033.1',0.31,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152171,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2005ic',NULL,152171,41.01,0.15,1220,72313,70,NULL,'SALT 2','SDSS J215108.63-005033.1',0.31,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152172,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 05844','R',152172,41.09,0.22,1260,72313,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ic','SDSS J215108.63-005033.1',0.31,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152173,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2005ic',NULL,152173,41.11,NULL,1270,72313,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 05844, SN 2005ic','SDSS J215108.63-005033.1',0.31,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152174,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2005ic',NULL,152174,41.15,0.1,1290,72313,65,NULL,'MLCS2k2','SDSS J215108.63-005033.1',0.31,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152175,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 05844','R',152175,41.29,0.12,1380,72313,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ic','SDSS J215108.63-005033.1',0.31,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152176,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 01670','RN',152176,43.13,0.2,2930,72314,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 01670',0.442036,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152177,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 01670','RN',152177,43.44,0.27,3390,72314,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 01670',0.442036,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152178,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152178,37.28,0.57,286,72315,70,NULL,NULL,'2MASX J21511190-5726363',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'14.9r',0.33,'S0',NULL,NULL,NULL,NULL,1,327.799583,-57.44344,0,NULL,48717108038,761204813,11893825,14.9),(152179,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152179,37.71,0.27,349,72316,70,NULL,NULL,'2MASX J21511398-0711088',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000079,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,327.8082083,-7.18575,0.061,NULL,49926273296,780098020,12189031,16.9),(152180,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152180,36.55,0.6,204,72317,70,NULL,NULL,'2MASX J21512031-5519284',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'15.3r',0.19,NULL,NULL,NULL,NULL,NULL,1,327.83475,-55.32453,0,NULL,48712305118,761129767,11892652,15.3),(152181,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152181,35.3,0.51,115,72318,70,NULL,NULL,'ARK 554',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.000113,NULL,'15.1',0.25,NULL,NULL,NULL,NULL,NULL,1,327.834875,-1.64939,0.293,NULL,49813350148,778333596,12161462,15.1),(152182,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152182,37.71,0.27,349,72319,70,NULL,NULL,'2MASX J21512069-0713268',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000077,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,327.836125,-7.22406,0.061,NULL,49926265261,780097894,12189029,17.7),(152183,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152183,38.03,0.46,403,72320,70,NULL,NULL,'2MASX J21512202-0915018',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000082,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,327.841667,-9.25039,0.121,NULL,49918662070,779979094,12187173,18.3),(152184,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152184,36.85,0.74,235,72321,70,NULL,NULL,'2MASX J21512300-5425214',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.1r',0.32,'S',NULL,NULL,NULL,NULL,1,327.845958333,-54.42264,0,NULL,48708687767,761073246,11891769,15.1),(152185,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152185,37.07,0.46,260,72322,70,NULL,NULL,'2MASX J21512369+1100589',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000132,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,327.848667,11.01631,0.269,NULL,52307083580,817298180,12770284,17.7),(152186,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15454','R',152186,41.45,0.21,1410,72323,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J215126.08-005057.0',0.3829,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',0.0001,NULL,'21.4g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,327.858667,-0.84917,0.273,NULL,49815532559,778367696,12161995,21.4),(152187,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15454','R',152187,41.73,0.29,1610,72323,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J215126.08-005057.0',0.3829,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152188,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15454',NULL,152188,41.61,0.18,2100,72323,70,NULL,'SALT 2','SDSS J215126.08-005057.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152189,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15454',NULL,152189,41.67,0.18,2160,72323,70,NULL,'SALT 2, Malmquist cor.','SDSS J215126.08-005057.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152190,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152190,34.68,0.49,86.3,72324,75,NULL,'IR','UGC 11833',NULL,'2011yCatp016004901K',2011,1,1.01,NULL,'G',0.00003,NULL,'17.',0.11,'Sc',NULL,NULL,NULL,NULL,1,327.859416667,34.13233,0.701,NULL,55592697703,868635901,13572435,17),(152191,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152191,35.08,0.43,104,72324,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11833',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152192,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152192,35.48,NULL,125,72324,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11833',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152193,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152193,35.48,NULL,125,72324,NULL,NULL,'Dipole + Quadrupole','UGC 11833',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152194,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152194,35.49,NULL,125,72324,NULL,NULL,'Dipole','UGC 11833',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152195,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16889','RN',152195,40.39,0.3,952,72325,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16889',0.255983,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152196,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16889','RN',152196,40.71,0.29,1100,72325,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16889',0.255983,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152197,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152197,37.64,0.46,337,72326,70,NULL,NULL,'2MASX J21512805+0000392',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,327.866791667,0.01106,0.333,NULL,52178739659,815292807,12738950,17.8),(152198,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152198,34.85,0.2,93.3,72327,74.4,NULL,NULL,'CGCG 472-012',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',NULL,NULL,'15.7',0.3,'Sc',NULL,NULL,NULL,NULL,1,327.874167,22.84483,0.197,NULL,55112397197,861131206,13455175,15.7),(152199,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152199,35.01,0.7,100,72327,NULL,NULL,NULL,'CGCG 472-012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152200,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152200,35.11,0.67,105,72327,NULL,NULL,'Malmquist cor.','CGCG 472-012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152201,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13721','RN',152201,39.31,0.37,566,72328,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13721',0.282295,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152202,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13721','RN',152202,40.06,0.41,801,72328,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13721',0.282295,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152203,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 06685','RN',152203,42.39,0.27,2250,72329,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 06685',0.33969,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152204,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 06685','RN',152204,42.87,0.29,2800,72329,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 06685',0.33969,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152205,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16937',NULL,152205,39.87,0.44,943,72330,70,NULL,'SN photometric redshift distance, z photo =0.251 +/- 0.067','SDSS-II SN 16937',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,327.88175,-0.46581,0.333,NULL,49815191099,778362360,12161911,NULL),(152206,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152206,36.89,0.46,239,72331,70,NULL,NULL,'2MASX J21513303+0039025',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000195,NULL,'16.3g',0.34,'E0',NULL,NULL,NULL,NULL,1,327.887666667,0.65083,0.265,NULL,52181017617,815328400,12739506,16.3),(152207,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152207,37.71,0.27,349,72332,70,NULL,NULL,'2MASX J21513336-0708416',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000093,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,327.889083333,-7.14511,0.053,NULL,49926292986,780098327,12189036,17.2),(152208,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152208,35.46,0.37,124,72333,NULL,NULL,NULL,'CGCG 472-013',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',NULL,NULL,'15.67',0.2,'S?',NULL,NULL,NULL,NULL,1,327.895667,22.65181,0.197,NULL,55112466506,861132289,13455192,15.67),(152209,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152209,35.5,0.2,126,72333,74.4,NULL,NULL,'CGCG 472-013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152210,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152210,35.52,0.36,127,72333,NULL,NULL,'Malmquist cor.','CGCG 472-013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152211,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152211,36.73,0.23,221,72334,70,NULL,NULL,'2MASX J21513605-0707216',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000092,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,327.900333333,-7.12267,0.053,NULL,49926305874,780098529,12189039,16.6),(152212,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152212,36.93,0.55,243,72335,70,NULL,NULL,'2MASX J21513744-7144270',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'15.0r',0.31,NULL,NULL,NULL,NULL,NULL,1,327.90625,-71.74094,0.045,NULL,49308198401,770440600,12038134,15),(152213,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152213,37.2,0.46,276,72336,70,NULL,NULL,'2MASX J21514042-0708036',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000078,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,327.9184583,-7.13442,0.053,NULL,49926297603,780098400,12189037,16.7),(152214,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152214,33.86,0.49,59.1,72337,75,NULL,'IR','UGC 11836',NULL,'2011yCatp016004901K',2011,1,1.4,'Within 10 degrees of the galactic plane.','G',0.00004,NULL,'17.',0.3,'Sdm:',NULL,NULL,NULL,NULL,1,327.9225,46.61917,NULL,NULL,55387026862,865422294,13522223,17),(152215,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152215,36.73,0.23,221,72338,70,NULL,NULL,'2MASX J21514398-0703426',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000071,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,327.933375,-7.06181,0.053,NULL,49926295681,780098370,12189037,17.1),(152216,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152216,35.06,NULL,103,72339,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11832',NULL,'2010Ap&SS.325..163P',2010,1,1.67,NULL,'G',0.000009,NULL,'16.0g',0.17,'Sc',NULL,NULL,NULL,NULL,1,327.934,11.57542,0.273,NULL,52306730802,817292668,12770197,16),(152217,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152217,35.07,NULL,103,72339,NULL,NULL,'Dipole + Quadrupole','UGC 11832',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152218,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152218,35.08,NULL,104,72339,NULL,NULL,'Dipole','UGC 11832',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152219,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152219,35.11,NULL,105,72339,NULL,NULL,NULL,'UGC 11832',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152220,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152220,35.2,0.49,109,72339,75,NULL,'IR','UGC 11832',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152221,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152221,35.39,0.2,120,72339,74.4,NULL,NULL,'UGC 11832',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152222,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152222,36.73,0.23,221,72340,70,NULL,NULL,'2MASX J21514505-0700106',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000092,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,327.9377083,-7.00297,0.053,NULL,49926771143,780105799,12189153,16.9),(152223,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 21691','RN',152223,42.73,0.43,2660,72341,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 21691',0.317092,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152224,'BCG','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152224,37.9,0.35,357,72342,60,NULL,NULL,'ABELL 2382',0.0648,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III [BM]',NULL,NULL,NULL,NULL,1,327.970417,-15.71722,0.125,NULL,49768720124,777636251,12150566,NULL),(152225,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152225,35.38,0.52,119,72343,70,NULL,NULL,'MC 2149-276',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'15.45',0.65,'S0',NULL,NULL,NULL,NULL,1,327.971333,-27.42164,0.073,NULL,51418594860,803415544,12553367,15.45),(152226,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152226,37.32,0.6,292,72344,70,NULL,NULL,'2MASX J21515458-5507196',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.5b',0.23,NULL,NULL,NULL,NULL,NULL,1,327.97725,-55.12219,0,NULL,48708839570,761075618,11891806,16.5),(152227,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13424','RN',152227,40.35,0.08,958,72345,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13424',0.22442,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152228,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13424','RN',152228,40.46,0.18,1010,72345,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13424',0.22442,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152229,'BCG','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152229,37.9,0.35,357,72346,60,NULL,'ABELL 2382, BCG','2MASX J21515562-1542218',0.0648,'1980ApJ...241..486H',1980,1,0.64,NULL,'G',0.000053,NULL,'14.5V',0.36,'E              BrClG','Brightest group member',NULL,NULL,NULL,1,327.981833,-15.70583,0.125,NULL,49766832470,777606757,12150105,14.5),(152230,'SGRB','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152230,38.73,NULL,557,72347,71,NULL,NULL,'GRB 070429B',NULL,'2010ApJ...709..664R',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,328.015875,-38.82833,0,NULL,50550139171,789845924,12341342,NULL),(152231,'G Lens','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152231,41.31,1.65,1830,72348,NULL,NULL,NULL,'HE 2149-2745:MWKZ GROUP 4',NULL,'2013ApJ...770..154T',2013,1,NULL,'This galaxy group lenses a z=2 QSO group.','GGroup',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,328.020833,-27.52667,0.073,NULL,51418872815,803419887,12553435,NULL),(152232,'G Lens','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152232,41.41,0.38,1910,72348,NULL,NULL,NULL,'HE 2149-2745:MWKZ GROUP 4',NULL,'2007ApJ...660....1O',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152233,'G Lens','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152233,41.4,NULL,1910,72348,NULL,NULL,'R(H) = ct','HE 2149-2745:MWKZ GROUP 4',NULL,'2014ApJ...788..190W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152234,'G Lens','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152234,41.4,NULL,1910,72348,NULL,NULL,'Standard','HE 2149-2745:MWKZ GROUP 4',NULL,'2014ApJ...788..190W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152235,'G Lens','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152235,41.79,1.66,2290,72348,NULL,NULL,NULL,'HE 2149-2745:MWKZ GROUP 4',NULL,'2013ApJ...770..154T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152236,'G Lens','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152236,41.8,1.66,2290,72348,NULL,NULL,NULL,'HE 2149-2745:MWKZ GROUP 4',NULL,'2013ApJ...770..154T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152237,'G Lens','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152237,42.21,1.64,2760,72348,NULL,NULL,NULL,'HE 2149-2745:MWKZ GROUP 4',NULL,'2013ApJ...770..154T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152238,'G Lens','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152238,43.19,0.79,4350,72348,NULL,NULL,NULL,'HE 2149-2745:MWKZ GROUP 4',NULL,'2014MNRAS.437..600S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152239,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152239,36.45,0.63,195,72349,70,NULL,NULL,'2MASX J21520752-8015508',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,328.031125,-80.26411,0.477,NULL,48564652878,758822701,11856604,17.7),(152240,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152240,38.42,0.46,483,72350,70,NULL,NULL,'2MASX J21520925+1110151',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,328.0385417,11.17092,0.253,NULL,52307122295,817298785,12770293,18.3),(152241,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152241,35.26,0.68,112,72351,NULL,NULL,NULL,'ESO 404- G 001',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.80',0.7,'Sc             HII',NULL,NULL,NULL,NULL,1,328.0492083,-36.84053,0,NULL,50552776353,789887130,12341986,14.8),(152242,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152242,35.25,0.68,112,72351,NULL,NULL,'Malmquist cor.','ESO 404- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152243,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152243,35.3,0.2,115,72351,74.4,NULL,NULL,'ESO 404- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152244,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152244,35.95,0.74,155,72352,70,NULL,NULL,'2MASX J21521256-0136031',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'17.15',0.3,NULL,NULL,NULL,NULL,NULL,1,328.05225,-1.60069,0.325,NULL,49813272264,778332379,12161443,17.15),(152245,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152245,33.59,0.69,52.2,72353,100,NULL,'mid-IR','UGC 11837',NULL,'2013ApJ...771...88L',2013,1,1.3,NULL,'G',0.000033,NULL,'16.0',0.9,'Sd',NULL,NULL,NULL,NULL,1,328.055625,36.09894,1.041,NULL,55585077008,868516828,13570575,16),(152246,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152246,34.4,0.4,75.9,72353,NULL,NULL,'mean','UGC 11837',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152247,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152247,34.47,0.47,78.5,72353,NULL,NULL,'H','UGC 11837',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152248,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152248,34.52,0.2,80.2,72353,74.4,NULL,NULL,'UGC 11837',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152249,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152249,34.54,0.44,80.8,72353,NULL,NULL,'Malmquist cor.','UGC 11837',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152250,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152250,34.58,0.43,82.5,72353,NULL,NULL,NULL,'UGC 11837',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152251,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152251,34.64,0.46,84.9,72353,NULL,NULL,'J','UGC 11837',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152252,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152252,34.67,0.45,86,72353,NULL,NULL,'K','UGC 11837',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152253,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152253,37.45,0.46,309,72354,70,NULL,NULL,'2MASX J21521368-0657228',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000084,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,328.056917,-6.95631,0.057,NULL,49926816979,780106515,12189164,17.3),(152254,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152254,36.88,0.46,238,72355,70,NULL,NULL,'2MASX J21521385-0752368',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.0001,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,328.0577083,-7.87694,0.077,NULL,49928206928,780128233,12189503,16.5),(152255,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152255,35.25,0.49,112,72356,75,NULL,'IR','CGCG 402-024 NED02',NULL,'2011yCatp016004901K',2011,1,0.7,NULL,'G',0.00009,NULL,'12.1K',0.3,NULL,NULL,NULL,NULL,NULL,1,328.063,8.39861,0.121,NULL,52342563699,817852557,12778946,12.1),(152256,'Tully est','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152256,32.87,0.8,37.4,72357,75,NULL,NULL,'NGC 7140',NULL,'1988NBGC.C....0000T',1988,1,4.2,NULL,'G',0.00001,NULL,'12.4b',3,'(R\'_2)SB(rs)b',NULL,NULL,NULL,NULL,1,328.0637917,-55.56967,0,NULL,48712497876,761132779,11892699,12.4),(152257,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152257,32.06,0.43,25.8,72357,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7140',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152258,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152258,32.19,0.43,27.5,72357,75,NULL,'3.6 micron, color corrected','NGC 7140',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152259,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152259,32.37,0.2,29.8,72357,74.4,NULL,NULL,'NGC 7140',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152260,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152260,35.45,0.49,123,72358,70,NULL,NULL,'2MFGC 16503',NULL,'2014MNRAS.445.2677S',2014,1,0.72,'6dF DR2 has z = 0.051128.','G',0.00015,NULL,'14.7r',0.17,'S',NULL,NULL,NULL,NULL,1,328.064583,-44.05536,0,NULL,50647876282,791373066,12365204,14.7),(152261,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152261,36.45,0.46,195,72359,70,NULL,NULL,'2MASX J21521551+1120511',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000154,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,328.06475,11.34747,0.309,NULL,52306932451,817295819,12770247,17.6),(152262,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2005iz',NULL,152262,39.15,0.13,563,72360,74.2,NULL,'SALT 2','SDSS J215216.94+001600.4',0.2,'2010ApJ...716..712A',2010,1,0.04,NULL,'G',NULL,NULL,'23.8g',0.01,NULL,NULL,NULL,NULL,NULL,1,328.070625,0.26681,0.281,NULL,52178974490,815296476,12739007,23.8),(152263,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2005iz',NULL,152263,39.79,0.16,756,72360,65,NULL,'SALT2','SDSS J215216.94+001600.4',0.2,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152264,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 06780','R',152264,39.81,0.2,763,72360,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005iz','SDSS J215216.94+001600.4',0.2,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152265,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2005iz',NULL,152265,39.85,0.14,777,72360,70,NULL,'SALT 2','SDSS J215216.94+001600.4',0.2,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152266,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2005iz',NULL,152266,39.86,NULL,780,72360,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 06780, SN 2005iz','SDSS J215216.94+001600.4',0.2,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152267,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2005iz',NULL,152267,39.63,0.1,843,72360,70,NULL,'SALT 2','SDSS J215216.94+001600.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152268,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2005iz',NULL,152268,39.64,0.1,847,72360,70,NULL,'SALT 2, Malmquist cor.','SDSS J215216.94+001600.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152269,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2005iz',NULL,152269,40.1,0.12,872,72360,65,NULL,'MLCS2k2','SDSS J215216.94+001600.4',0.2,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152270,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 06780','R',152270,40.13,0.12,883,72360,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005iz','SDSS J215216.94+001600.4',0.2,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152271,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2005iz',NULL,152271,40.44,0.06,1020,72360,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 06780, SN 2005iz','SDSS J215216.94+001600.4',0.2,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152272,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152272,37.26,0.55,283,72361,70,NULL,NULL,'2MASX J21521727-6201483',NULL,'2014MNRAS.445.2677S',2014,1,0.22,NULL,'G',0.00015,NULL,'15.6r',0.17,NULL,NULL,NULL,NULL,NULL,1,328.071916667,-62.03011,0.029,NULL,49159105610,768111025,12001734,15.6),(152273,'BCG','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152273,38.58,0.35,475,72362,60,NULL,NULL,'ABELL 2384',0.0943,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III [BM]',NULL,NULL,NULL,NULL,1,328.0789583,-19.57844,0.061,NULL,50873182682,794893479,12420210,NULL),(152274,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2005jm',NULL,152274,39.27,0.13,595,72363,74.2,NULL,'SALT 2','SDSS J215219.03+002818.6',0.2,'2010ApJ...716..712A',2010,1,0.07,NULL,'G',NULL,NULL,'21.8g',0.03,NULL,NULL,NULL,NULL,NULL,1,328.079333333,0.47183,0.265,NULL,52178874755,815294918,12738983,21.8),(152275,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2005jm',NULL,152275,39.89,0.05,794,72363,70,NULL,'SDSS 7243','SDSS J215219.03+002818.6',0.2,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152276,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2005jm',NULL,152276,40.03,0.11,845,72363,65,NULL,'SALT2','SDSS J215219.03+002818.6',0.2,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152277,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2005jm',NULL,152277,40.04,0.15,847,72363,70,NULL,'SDSS 7243, SALT 2','SDSS J215219.03+002818.6',0.2,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152278,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 07243','R',152278,40.05,0.2,852,72363,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005jm','SDSS J215219.03+002818.6',0.2,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152279,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 07243','R',152279,40.12,0.13,879,72363,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005jm','SDSS J215219.03+002818.6',0.2,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152280,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2005jm',NULL,152280,40.15,0.17,892,72363,72,NULL,'SDSS 7243','SDSS J215219.03+002818.6',0.2,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152281,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2005jm',NULL,152281,40.18,0.12,905,72363,65,NULL,'MLCS2k2','SDSS J215219.03+002818.6',0.2,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152282,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2005jm',NULL,152282,39.98,0.1,991,72363,70,NULL,'SALT 2','SDSS J215219.03+002818.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152283,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2005jm',NULL,152283,39.99,0.1,995,72363,70,NULL,'SALT 2, Malmquist cor.','SDSS J215219.03+002818.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152284,'BCG','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152284,38.58,0.35,475,72364,60,NULL,'ABELL 2384, BCG','2MASX J21522195-1932484',0.0943,'1980ApJ...241..486H',1980,1,1.25,NULL,'G',NULL,NULL,'0.74',0.82,'BrClG','Brightest group member',NULL,NULL,NULL,1,328.0914583,-19.54683,0.061,NULL,50873182826,794893481,12420210,0.74),(152285,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152285,35.92,0.57,153,72365,70,NULL,NULL,'2MFGC 16505',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.00015,NULL,'14.5r',0.23,'S',NULL,NULL,NULL,NULL,1,328.0914583,-52.41444,0,NULL,50659182945,791549733,12367964,14.5),(152286,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 05790','RN',152286,40.08,0.11,842,72366,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 05790',0.231994,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152287,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 05790','RN',152287,40.71,0.19,1120,72366,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05790',0.231994,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152288,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152288,37.79,0.46,362,72367,70,NULL,NULL,'SDSS J215224.79-073728.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000077,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,328.103333,-7.62461,0.065,NULL,49928107051,780126672,12189479,18.1),(152289,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 07953','RN',152289,42.67,0.26,2030,72368,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07953',0.681936,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152290,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152290,32.52,0.8,32,72369,75,NULL,'MAT, I','NGC 7095',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.00001,NULL,'12.23',2.7,'SB(s)c','in a pair',NULL,NULL,NULL,1,328.110167,-81.53083,0.445,NULL,48565366360,758833849,11856778,12.23),(152291,'Tully est','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152291,32.48,0.8,31.3,72369,75,NULL,NULL,'NGC 7095',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152292,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152292,29.23,0.32,7.03,72369,85,NULL,'I, inv','NGC 7095',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152293,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152293,29.29,0.32,7.16,72369,85,NULL,'I, raw','NGC 7095',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152294,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152294,29.73,0.43,8.83,72369,75,NULL,'MAT, I, inv','NGC 7095',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152295,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152295,29.8,0.43,9.11,72369,75,NULL,'MAT, I, raw','NGC 7095',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152296,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152296,30.06,0.43,10.3,72369,75,NULL,'MAT, I, cor','NGC 7095',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152297,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152297,38.34,0.46,466,72370,70,NULL,NULL,'2MASX J21522804+0029386',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,328.11675,0.49408,0.265,NULL,52178904140,815295377,12738990,17.8),(152298,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152298,35.16,0.46,108,72371,70,NULL,NULL,'MCG +02-55-019',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000073,NULL,'15.2g',0.55,'S0',NULL,NULL,NULL,NULL,1,328.122125,12.41139,0.317,NULL,52234055103,816157110,12752454,15.2),(152299,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152299,36.58,0.46,207,72372,70,NULL,NULL,'2MASX J21523208+0009586',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000174,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,328.133541667,0.16642,0.289,NULL,52178948224,815296066,12739001,16.5),(152300,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 05802',NULL,152300,40.02,0.44,1010,72373,70,NULL,'SN photometric redshift distance, z photo =0.271 +/- 0.074','SDSS-II SN 05802',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,328.145,0.84567,0.213,NULL,52181152583,815330509,12739539,NULL),(152301,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 05802','R',152301,40.8,0.21,1110,72373,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05802',0.300656,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152302,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 05802','R',152302,40.9,0.12,1160,72373,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 05802',0.300656,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152303,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 05802',NULL,152303,40.7,0.11,1380,72373,70,NULL,'SALT 2','SDSS-II SN 05802',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152304,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 05802',NULL,152304,40.73,0.11,1400,72373,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 05802',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152305,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152305,33.25,0.8,44.7,72374,75,NULL,'W91PP, r','UGC 11838',NULL,'1997ApJS..109..333W',1997,1,2.08,NULL,'G',0.000009,NULL,'15.27',0.17,'Sd',NULL,NULL,NULL,NULL,1,328.149333,28.30658,0.337,NULL,55578869279,868419832,13569059,15.27),(152306,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152306,33.1,0.49,41.7,72374,75,NULL,'IR','UGC 11838',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152307,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152307,33.35,0.38,46.8,72374,75,NULL,'W91PP, r, inv','UGC 11838',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152308,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152308,33.36,0.38,47.1,72374,75,NULL,'W91PP, r, raw','UGC 11838',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152309,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152309,33.41,0.2,48.1,72374,74.4,NULL,NULL,'UGC 11838',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152310,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152310,33.42,NULL,48.3,72374,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11838',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152311,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152311,33.43,NULL,48.5,72374,NULL,NULL,'Dipole','UGC 11838',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152312,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152312,33.43,NULL,48.5,72374,NULL,NULL,'Dipole + Quadrupole','UGC 11838',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152313,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152313,33.49,0.56,50,72374,NULL,NULL,NULL,'UGC 11838',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152314,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152314,33.5,NULL,50.1,72374,NULL,NULL,NULL,'UGC 11838',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152315,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152315,33.56,0.43,51.6,72374,75,NULL,'3.6 micron, color corrected','UGC 11838',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152316,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152316,33.62,0.38,52.9,72374,75,NULL,'W91PP, r, cor','UGC 11838',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152317,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152317,33.64,0.43,53.5,72374,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11838',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152318,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152318,33.65,0.52,53.8,72374,NULL,NULL,'Malmquist cor.','UGC 11838',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152319,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152319,34.91,0.43,96.1,72375,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11839',NULL,'2014MNRAS.444..527S',2014,1,0.9,NULL,'G',0.00013,NULL,'15.5',0.1,'Sbc',NULL,NULL,NULL,NULL,1,328.168917,36.46072,1.041,NULL,55466673366,866666771,13541668,15.5),(152320,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152320,34.97,0.43,98.7,72375,75,NULL,'3.6 micron, color corrected','UGC 11839',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152321,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152321,35.07,0.2,103,72375,74.4,NULL,NULL,'UGC 11839',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152322,'SBF','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152322,31.94,0.14,24.4,72376,74.4,NULL,NULL,'NGC 7144',NULL,'2013AJ....146...86T',2013,1,3.7,NULL,'G',0.000057,NULL,'11.70',3.6,'E0','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,328.1767917,-48.25375,0,NULL,50665652013,791650812,12369543,11.7),(152323,'SBF','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152323,31.95,0.12,24.5,72376,NULL,NULL,'I','NGC 7144',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152324,'SBF','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152324,31.95,0.12,24.5,72376,NULL,NULL,NULL,'NGC 7144',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152325,'SBF','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152325,31.97,0.12,24.7,72376,NULL,NULL,'Malmquist cor.','NGC 7144',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152326,'D-Sigma','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152326,31.63,0.4,21.2,72376,75,NULL,'Edat, raw','NGC 7144',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152327,'D-Sigma','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152327,31.85,0.4,23.5,72376,75,NULL,'Edat, cor','NGC 7144',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152328,'Faber-Jackson','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152328,31.95,0.37,24.5,72376,95,NULL,'Weighted Mean','NGC 7144',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152329,'Faber-Jackson','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152329,32.07,0.81,25.9,72376,55,NULL,'Visvanathan & Sandage 1979','NGC 7144',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152330,'Faber-Jackson','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152330,32.62,0.46,33.4,72376,95,NULL,'Michard 1979a','NGC 7144',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152331,'Faber-Jackson','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152331,33.12,0.63,42.1,72376,95,NULL,'Michard 1979b, c','NGC 7144',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152332,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152332,32.14,0.41,26.8,72376,NULL,NULL,NULL,'NGC 7144',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152333,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152333,32.36,0.41,29.7,72376,NULL,NULL,'Malmquist cor.','NGC 7144',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152334,'Tertiary','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152334,31.55,0.71,20.4,72376,95,NULL,NULL,'NGC 7144',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152335,'Tully est','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152335,31.98,0.8,24.8,72376,75,NULL,'B','NGC 7144',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152336,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152336,32.1,0.4,26.3,72376,NULL,NULL,'mean','NGC 7144',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152337,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152337,32.28,0.45,28.6,72376,NULL,NULL,'K','NGC 7144',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152338,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152338,35.59,NULL,131,72377,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2349',NULL,'2010Ap&SS.325..163P',2010,1,0.99,NULL,'G',0.000016,NULL,'16.8',0.1,'Sd',NULL,NULL,NULL,NULL,1,328.1877083,3.54419,0.237,NULL,52326996764,817609324,12775145,16.8),(152339,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152339,35.6,NULL,132,72377,NULL,NULL,'Dipole','FGC 2349',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152340,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152340,35.6,NULL,132,72377,NULL,NULL,'Dipole + Quadrupole','FGC 2349',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152341,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152341,35.61,0.49,132,72377,75,NULL,'IR','FGC 2349',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152342,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152342,35.61,NULL,133,72377,NULL,NULL,NULL,'FGC 2349',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152343,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152343,34.28,NULL,71.9,72378,NULL,NULL,'Dipole','UGC 11841',NULL,'2010Ap&SS.325..163P',2010,1,3.09,NULL,'G',0.000017,NULL,'16.5',0.24,'Scd',NULL,NULL,NULL,NULL,1,328.1899583,38.93642,1.593,NULL,55466160962,866658765,13541543,16.5),(152344,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152344,34.3,NULL,72.5,72378,NULL,NULL,'Dipole + Quadrupole','UGC 11841',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152345,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152345,34.32,NULL,73,72378,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11841',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152346,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152346,34.47,0.49,78.4,72379,75,NULL,'IR','MCG -02-55-006',NULL,'2011yCatp016004901K',2011,1,1.42,NULL,'G',0.00015,NULL,'15',0.1,'Scd',NULL,NULL,NULL,NULL,1,328.208833,-10.51097,0.089,NULL,49901257081,779707141,12182924,15),(152347,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152347,34.86,0.54,93.7,72379,NULL,NULL,'Malmquist cor.','MCG -02-55-006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152348,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152348,34.89,0.2,95.1,72379,74.4,NULL,NULL,'MCG -02-55-006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152349,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152349,34.94,NULL,97.2,72379,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -02-55-006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152350,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152350,34.95,NULL,97.7,72379,NULL,NULL,'Dipole + Quadrupole','MCG -02-55-006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152351,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152351,34.96,NULL,98.2,72379,NULL,NULL,'Dipole','MCG -02-55-006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152352,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152352,35.06,0.49,103,72379,NULL,NULL,NULL,'MCG -02-55-006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152353,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152353,34.88,NULL,94.5,72380,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 288- G 015',NULL,'2010Ap&SS.325..163P',2010,1,1.09,NULL,'G',0.000033,NULL,'15.6r',0.12,'Sbc',NULL,NULL,NULL,NULL,1,328.210875,-45.15539,0,NULL,50644704797,791323512,12364429,15.6),(152354,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152354,34.89,NULL,95,72380,NULL,NULL,'Dipole + Quadrupole','ESO 288- G 015',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152355,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152355,34.91,NULL,96.1,72380,NULL,NULL,'Dipole','ESO 288- G 015',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152356,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152356,34.93,NULL,97,72380,NULL,NULL,NULL,'ESO 288- G 015',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152357,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152357,35.58,0.43,131,72380,NULL,NULL,'Malmquist cor.','ESO 288- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152358,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152358,35.6,0.42,132,72380,NULL,NULL,NULL,'ESO 288- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152359,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152359,35.64,0.2,134,72380,74.4,NULL,NULL,'ESO 288- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152360,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152360,37.06,0.46,258,72381,70,NULL,NULL,'2MASX J21525196-0058229',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.81',0.2,NULL,NULL,NULL,NULL,NULL,1,328.2165417,-0.97306,0.313,NULL,49814790735,778356105,12161814,17.81),(152361,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2006jk',NULL,152361,39.92,0.11,962,72382,70,NULL,'Hubble residual -0.20 for z0.28580','SDSS-II SN 14261 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,328.240417,0.25369,0.245,NULL,52178811243,815293925,12738967,NULL),(152362,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 14261','R',152362,40.64,0.22,1040,72382,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006jk','SDSS-II SN 14261 HOST',0.285847,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152363,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 14261','R',152363,40.65,0.14,1050,72382,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006jk','SDSS-II SN 14261 HOST',0.285847,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152364,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2006jk',NULL,152364,40.55,0.11,1290,72382,70,NULL,'SALT 2','SDSS-II SN 14261 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152365,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2006jk',NULL,152365,40.58,0.11,1310,72382,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14261 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152366,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152366,37.98,0.78,394,72383,70,NULL,NULL,'2MASX J21525800-6232472',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'15.2r',0.27,'S',NULL,NULL,NULL,NULL,1,328.241625,-62.54642,0.033,NULL,49161411106,768147048,12002297,15.2),(152367,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152367,38.2,0.46,436,72384,70,NULL,NULL,'2MASX J21525886-0006389',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,328.2452083,-0.11089,0.289,NULL,49814106971,778345421,12161647,18.1),(152368,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152368,35.92,0.66,153,72385,70,NULL,NULL,'2MASX J21525931-7241003',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'15.1r',0.19,NULL,NULL,NULL,NULL,NULL,1,328.247125,-72.68333,0.041,NULL,49306340892,770411576,12037680,15.1),(152369,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152369,37.78,0.46,360,72386,70,NULL,NULL,'2MASX J21530265+1229248',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,328.260916667,12.49014,0.309,NULL,52235125881,816173841,12752716,17.6),(152370,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152370,36.73,0.23,221,72387,70,NULL,NULL,'2MASX J21530507-0711066',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.00012,NULL,'15.1g',0.46,'FR II    poss. LINER',NULL,NULL,NULL,NULL,1,328.271167,-7.18525,0.061,NULL,49926881598,780107524,12189180,15.1),(152371,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152371,33.83,0.49,58.5,72388,70,NULL,NULL,'IC 1408',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00012,NULL,'14.88',0.4,NULL,NULL,NULL,NULL,NULL,1,328.287583333,-13.34678,0.137,NULL,49772955419,777702428,12151600,14.88),(152372,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152372,35.4,0.5,120,72389,70,NULL,NULL,'2MASX J21531072-0734116',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000077,NULL,'15.7g',0.23,'Sa',NULL,NULL,NULL,NULL,1,328.294833,-7.56975,0.057,NULL,49926179380,780096552,12189008,15.7),(152373,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152373,37.88,0.46,376,72390,70,NULL,NULL,'2MASX J21531223-0106249',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,328.300958333,-1.10683,0.313,NULL,49814789766,778356090,12161813,18.3),(152374,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152374,33.54,0.8,50.9,72391,75,NULL,'MAT, I','ESO 075- G 033',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'14.8r',0.9,'SB(rs)cd?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,328.306,-71.02281,0.037,NULL,49304548495,770383570,12037243,14.8),(152375,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152375,33.48,0.32,49.7,72391,85,NULL,'I, inv','ESO 075- G 033',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152376,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152376,33.49,0.32,49.9,72391,85,NULL,'I, raw','ESO 075- G 033',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152377,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152377,33.71,0.08,55.3,72391,NULL,NULL,NULL,'ESO 075- G 033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152378,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152378,33.89,0.43,60,72391,75,NULL,'MAT, I, raw','ESO 075- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152379,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152379,33.91,0.43,60.6,72391,75,NULL,'MAT, I, inv','ESO 075- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152380,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152380,34.16,0.43,67.8,72391,75,NULL,'MAT, I, cor','ESO 075- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152381,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152381,35.94,0.49,154,72392,75,NULL,'IR','CGCG 427-035 NED02',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000247,NULL,'15.5',0.25,NULL,NULL,NULL,NULL,NULL,1,328.316583333,15.61539,0.285,NULL,52238978227,816234034,12753656,15.5),(152382,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152382,33.81,0.8,57.7,72393,75,NULL,'MAT, I','IC 5141',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000028,NULL,'13.47',1.3,'SAB:(r:)b','Pair member (points to parent)',NULL,NULL,NULL,1,328.321,-59.49356,0.049,NULL,48681936380,760655255,11885238,13.47),(152383,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152383,33.55,0.54,51.2,72393,NULL,NULL,'Malmquist cor.','IC 5141',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152384,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152384,33.55,0.43,51.4,72393,75,NULL,'MAT, I, raw','IC 5141',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152385,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152385,33.61,0.47,52.8,72393,NULL,NULL,'H','IC 5141',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152386,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152386,33.64,0.43,53.4,72393,75,NULL,'MAT, I, cor','IC 5141',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152387,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152387,33.64,0.45,53.4,72393,NULL,NULL,'K','IC 5141',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152388,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152388,33.65,0.46,53.6,72393,NULL,NULL,'J','IC 5141',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152389,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152389,33.65,0.32,53.7,72393,85,NULL,'I, raw','IC 5141',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152390,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152390,33.71,0.32,55.1,72393,85,NULL,'I, inv','IC 5141',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152391,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152391,33.78,0.4,57.1,72393,NULL,NULL,'mean','IC 5141',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152392,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152392,33.8,0.43,57.5,72393,75,NULL,'MAT, I, inv','IC 5141',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152393,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152393,33.97,0.44,62.1,72393,NULL,NULL,NULL,'IC 5141',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152394,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152394,34.01,0.2,63.4,72393,74.4,NULL,NULL,'IC 5141',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152395,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 01131','RN',152395,40.8,0.27,1230,72394,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01131',0.17379,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152396,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 01131','RN',152396,41.6,0.28,1780,72394,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01131',0.17379,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152397,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 06687','R',152397,40.67,0.44,976,72395,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06687',0.3956,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,328.3307083,0.47703,0.237,NULL,52179008050,815297000,12739015,NULL),(152398,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 06687','R',152398,40.93,0.41,1100,72395,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06687',0.3956,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152399,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152399,37.52,0.46,319,72396,70,NULL,NULL,'2MASX J21531956-0754516',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000102,NULL,'16.2g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,328.331583,-7.91419,0.065,NULL,49928828030,780137937,12189655,16.2),(152400,'SBF','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152400,31.85,0.21,23.4,72397,NULL,NULL,'I','NGC 7145',NULL,'2001ApJ...546..681T',2001,1,2.5,NULL,'G',0.000033,NULL,'12.04',2.4,'E','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,328.334333333,-47.88244,0,NULL,50651947592,791436681,12366198,12.04),(152401,'SBF','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152401,31.85,0.21,23.4,72397,NULL,NULL,NULL,'NGC 7145',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152402,'SBF','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152402,31.86,0.14,23.6,72397,74.4,NULL,NULL,'NGC 7145',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152403,'SBF','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152403,31.91,0.21,24.1,72397,NULL,NULL,'Malmquist cor.','NGC 7145',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152404,'D-Sigma','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152404,31.63,0.4,21.2,72397,75,NULL,'Edat, raw','NGC 7145',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152405,'D-Sigma','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152405,31.85,0.4,23.5,72397,75,NULL,'Edat, cor','NGC 7145',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152406,'Faber-Jackson','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152406,30.34,0.65,11.7,72397,95,NULL,'Weighted Mean','NGC 7145',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152407,'Faber-Jackson','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152407,31.4,0.81,19.1,72397,55,NULL,'Visvanathan & Sandage 1979','NGC 7145',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152408,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152408,31.66,0.41,21.5,72397,NULL,NULL,NULL,'NGC 7145',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152409,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152409,31.92,0.41,24.2,72397,NULL,NULL,'Malmquist cor.','NGC 7145',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152410,'Tertiary','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152410,31.55,0.71,20.4,72397,95,NULL,NULL,'NGC 7145',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152411,'Tully est','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152411,31.89,0.8,23.8,72397,75,NULL,'B','NGC 7145',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152412,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152412,32.09,0.45,26.1,72397,NULL,NULL,'K','NGC 7145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152413,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152413,32.1,0.4,26.3,72397,NULL,NULL,'mean','NGC 7145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152414,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152414,34.39,0.8,75.5,72398,75,NULL,'W91PP, r','UGC 11842',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000067,NULL,'15.57',0.2,'Sab',NULL,NULL,NULL,NULL,1,328.3344583,25.51136,0.281,NULL,55576496881,868382763,13568480,15.57),(152415,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152415,34.32,0.38,73.2,72398,75,NULL,'W91PP, r, raw','UGC 11842',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152416,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152416,34.39,0.38,75.4,72398,75,NULL,'W91PP, r, inv','UGC 11842',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152417,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152417,34.45,0.49,77.7,72398,75,NULL,'IR','UGC 11842',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152418,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152418,34.53,0.38,80.6,72398,75,NULL,'W91PP, r, cor','UGC 11842',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152419,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152419,38.04,0.46,405,72399,70,NULL,NULL,'SDSS J215326.96+125331.1',NULL,'2015arXiv151105856S',2015,1,0.1,NULL,'G',0.000139,NULL,'19.4g',0.09,'BrClG',NULL,NULL,NULL,NULL,1,328.362333333,12.892,0.317,NULL,52235242457,816175663,12752744,19.4),(152420,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152420,35.65,0.68,135,72400,70,NULL,NULL,'AM 2149-574 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'15.89',0.28,NULL,NULL,NULL,NULL,NULL,1,328.3650417,-57.43964,0,NULL,48720533724,761258339,11894661,15.89),(152421,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152421,37.31,0.15,290,72401,70,NULL,NULL,'SDSS J215329.96-084448.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000074,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,328.374875,-8.74692,0.113,NULL,49927270125,780113595,12189274,18),(152422,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152422,37.65,0.46,339,72402,70,NULL,NULL,'2MASX J21533247-0055294',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,328.38525,-0.92492,0.333,NULL,49814365029,778349453,12161710,17.9),(152423,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152423,37.08,0.46,261,72403,70,NULL,NULL,'2MASX J21534622-0751115',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000103,NULL,'16.1g',0.38,'E0',NULL,NULL,NULL,NULL,1,328.442625,-7.85303,0.065,NULL,49928863497,780138492,12189663,16.1),(152424,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2007lt',NULL,152424,38.53,0.16,509,72404,70,NULL,'Hubble residual 0.23 for z0.11300','SDSS J215347.32+000054.0',NULL,'2011ApJ...740...92G',2011,1,0.07,NULL,'G',0.005,NULL,'20.9g',0.05,NULL,NULL,NULL,NULL,NULL,1,328.447208333,0.015,0.245,NULL,52178335902,815286498,12738851,20.9),(152425,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 18650','R',152425,38.78,0.18,511,72404,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007lt','SDSS J215347.32+000054.0',0.113,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152426,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 18650','R',152426,38.95,0.07,554,72404,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007lt','SDSS J215347.32+000054.0',0.113,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152427,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2007lt',NULL,152427,38.73,0.06,557,72404,70,NULL,'SALT 2','SDSS J215347.32+000054.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152428,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2007lt',NULL,152428,38.73,0.06,557,72404,70,NULL,'SALT 2, Malmquist cor.','SDSS J215347.32+000054.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152429,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152429,36.92,0.66,242,72405,70,NULL,NULL,'2MASX J21535200-1740475',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'15.6r',0.29,NULL,NULL,NULL,NULL,NULL,1,328.466667,-17.67992,0.101,NULL,49765528016,777586375,12149787,15.6),(152430,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152430,36.92,0.55,242,72406,70,NULL,NULL,'2MASX J21535316-0306560',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.36',NULL,NULL,NULL,NULL,NULL,NULL,1,328.471583,-3.11558,0.133,NULL,49892307220,779567300,12180739,16.36),(152431,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152431,35.91,0.49,152,72407,75,NULL,'IR','CGCG 402-026',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',NULL,NULL,'15.7',0.1,NULL,NULL,NULL,NULL,NULL,1,328.489833333,6.74842,0.161,NULL,52334560551,817727508,12776992,15.7),(152432,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152432,38.8,0.46,576,72408,70,NULL,NULL,'SDSS J215357.85-081735.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000093,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,328.4910417,-8.29314,0.105,NULL,49928895264,780138988,12189671,18.5),(152433,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152433,34.55,0.8,81.3,72409,75,NULL,'MAT, I','NGC 7152',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000023,NULL,'14.25',0.6,'SB(rs)b? pec',NULL,NULL,NULL,NULL,1,328.496,-29.28908,0,NULL,51416695379,803385865,12552904,14.25),(152434,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152434,34.1,0.32,66,72409,85,NULL,'I, raw','NGC 7152',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152435,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152435,34.14,0.32,67.3,72409,85,NULL,'I, inv','NGC 7152',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152436,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152436,34.2,0.43,69.3,72409,75,NULL,'MAT, I, raw','NGC 7152',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152437,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152437,34.37,0.2,74.8,72409,74.4,NULL,NULL,'NGC 7152',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152438,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152438,34.4,0.43,75.9,72409,75,NULL,'MAT, I, inv','NGC 7152',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152439,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152439,34.47,0.43,78.2,72409,75,NULL,'MAT, I, cor','NGC 7152',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152440,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152440,34.48,0.43,78.8,72409,NULL,NULL,'Malmquist cor.','NGC 7152',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152441,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152441,34.62,0.4,84.1,72409,NULL,NULL,NULL,'NGC 7152',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152442,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152442,34.63,0.4,84.4,72409,NULL,NULL,'mean','NGC 7152',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152443,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152443,34.81,0.47,91.6,72409,NULL,NULL,'H','NGC 7152',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152444,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05776','RN',152444,40.73,0.24,1130,72410,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05776',0.238652,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152445,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05776','RN',152445,41.04,0.21,1310,72410,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 05776',0.238652,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152446,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05776','N',152446,40.69,0.15,1370,72410,70,NULL,'SALT 2','SDSS-II SN 05776',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152447,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05776','N',152447,40.7,0.15,1380,72410,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 05776',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152448,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152448,31.76,0.8,22.5,72411,75,NULL,NULL,'ESO 145- G 025',NULL,'1988NBGC.C....0000T',1988,1,2.3,'The APM position is northwest of the center of the bar.','G',0.00001,NULL,'14.02',1.8,'SAB(s)dm',NULL,NULL,NULL,NULL,1,328.523875,-57.61361,0,NULL,48718633994,761228656,11894197,14.02),(152449,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152449,31.1,0.43,16.6,72411,75,NULL,'3.6 micron, color + selection bias corrected','ESO 145- G 025',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152450,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152450,35.56,0.5,130,72412,70,NULL,NULL,'2MASX J21541023-1713466',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'15.1r',0.12,NULL,NULL,NULL,NULL,NULL,1,328.542625,-17.22972,0.125,NULL,49765872438,777591756,12149871,15.1),(152451,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16200','RN',152451,40.24,0.22,1030,72413,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 16200',0.090465,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152452,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16200','RN',152452,40.32,0.14,1060,72413,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 16200',0.090465,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152453,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152453,35.8,0.65,144,72414,70,NULL,NULL,'2MASX J21541269-5515252',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.5r',0.48,'S0',NULL,NULL,NULL,NULL,1,328.552875,-55.25703,0,NULL,48711930409,761123912,11892561,14.5),(152454,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152454,33.57,0.8,51.7,72415,75,NULL,'MAT, I','IC 5140',NULL,'1997ApJS..109..333W',1997,1,2.24,NULL,'G',0.000033,NULL,'15.15',0.21,'SBd? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,328.566791667,-67.33139,0.009,NULL,49282304069,770036001,12031812,15.15),(152455,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152455,33.14,0.32,42.4,72415,85,NULL,'I, raw','IC 5140',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152456,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152456,33.14,0.32,42.4,72415,85,NULL,'I, inv','IC 5140',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152457,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152457,33.29,0.43,45.4,72415,75,NULL,'MAT, I, raw','IC 5140',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152458,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152458,33.34,0.43,46.5,72415,75,NULL,'MAT, I, cor','IC 5140',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152459,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152459,33.35,0.43,46.7,72415,75,NULL,'MAT, I, inv','IC 5140',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152460,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152460,33.37,0.49,47.1,72415,75,NULL,'IR','IC 5140',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152461,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152461,33.64,NULL,53.4,72415,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 5140',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152462,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152462,33.65,NULL,53.8,72415,NULL,NULL,'Dipole + Quadrupole','IC 5140',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152463,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152463,33.68,NULL,54.3,72415,NULL,NULL,'Dipole','IC 5140',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152464,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152464,33.73,NULL,55.7,72415,NULL,NULL,NULL,'IC 5140',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152465,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152465,33.73,0.14,55.8,72415,NULL,NULL,NULL,'IC 5140',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152466,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152466,35.07,0.49,103,72416,70,NULL,NULL,'2MASX J21541607-1640226',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.20',NULL,NULL,NULL,NULL,NULL,NULL,1,328.567167,-16.67297,0.109,NULL,49769141234,777642831,12150669,16.2),(152467,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152467,37.31,0.15,290,72417,70,NULL,NULL,'2MASX J21541797-0836009',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,328.574958333,-8.60036,0.105,NULL,49928430190,780131721,12189558,17.2),(152468,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152468,36.48,0.55,198,72418,70,NULL,NULL,'2MASX J21541957-1409376',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,328.5815,-14.16056,0.109,NULL,49772596265,777696816,12151512,15.3),(152469,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152469,36.73,0.46,222,72419,70,NULL,NULL,'2MASX J21541992-0111157',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,328.5829583,-1.18786,0.333,NULL,49814209906,778347029,12161672,17.5),(152470,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16467',NULL,152470,39.88,0.13,946,72420,70,NULL,'SALT 2','SDSS J215420.48+000703.7',NULL,'2013ApJ...763...88C',2013,1,0.11,NULL,'G',0.0005,NULL,'19.8g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,328.585375,0.11772,0.245,NULL,52178384648,815287260,12738863,19.8),(152471,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16467',NULL,152471,39.89,0.13,951,72420,70,NULL,'SALT 2, Malmquist cor.','SDSS J215420.48+000703.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152472,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16467',NULL,152472,39.35,0.22,741,72421,70,NULL,NULL,'SDSS-II SN 16467',NULL,'2013MNRAS.434.1443X',2013,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,328.5857083,0.11822,0.245,NULL,52178384196,815287253,12738863,NULL),(152473,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16467','R',152473,39.94,0.22,797,72421,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16467',0.221151,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152474,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16467','R',152474,40.24,0.15,913,72421,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16467',0.221151,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152475,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152475,32.53,0.51,32,72422,NULL,NULL,'Malmquist cor.','UGC 11845 NOTES02',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',NULL,NULL,'15.7',0.4,NULL,'Group member',NULL,NULL,NULL,1,328.586083,15.04406,0.257,NULL,52240290475,816254538,12753977,15.7),(152476,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152476,33.14,0.38,42.5,72422,NULL,NULL,NULL,'UGC 11845 NOTES02',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152477,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152477,37.29,0.46,288,72423,70,NULL,NULL,'2MASX J21542096-0855099',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000173,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,328.587333333,-8.9195,0.113,NULL,49927187098,780112298,12189254,17),(152478,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152478,32.4,0.8,30.2,72424,75,NULL,'MAT, I','ESO 466- G 014',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.3r',0.2,'Sb:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,328.5952917,-31.96919,0,NULL,51460570973,804071421,12563615,14.3),(152479,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152479,32.47,0.1,31.3,72424,NULL,NULL,NULL,'ESO 466- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152480,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152480,33.37,0.32,47.2,72424,85,NULL,'I, raw','ESO 466- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152481,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152481,33.38,0.32,47.4,72424,85,NULL,'I, inv','ESO 466- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152482,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152482,33.74,0.43,55.9,72424,75,NULL,'MAT, I, raw','ESO 466- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152483,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152483,33.84,0.43,58.7,72424,75,NULL,'MAT, I, inv','ESO 466- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152484,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152484,33.98,0.43,62.6,72424,75,NULL,'MAT, I, cor','ESO 466- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152485,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152485,34.86,0.4,93.8,72425,NULL,NULL,'mean','IC 5145',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000017,NULL,'14.30',0.9,'Sab','Group member',NULL,NULL,NULL,1,328.596083,15.15683,0.233,NULL,52240170061,816252657,12753947,14.3),(152486,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152486,34.86,0.47,93.8,72425,NULL,NULL,'H','IC 5145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152487,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152487,34.86,0.45,93.8,72425,NULL,NULL,'K','IC 5145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152488,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152488,34.88,0.46,94.5,72425,NULL,NULL,'J','IC 5145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152489,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152489,35.35,0.43,118,72425,75,NULL,'3.6 micron, color + selection bias corrected','IC 5145',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152490,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152490,37.04,0.46,256,72426,70,NULL,NULL,'2MASX J21542321-0914229',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,328.596708333,-9.23964,0.093,NULL,49919054905,779985232,12187269,16.9),(152491,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05785','R',152491,38.75,0.13,491,72427,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 05785',0.148398,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,328.597375,0.08375,0.245,NULL,52178379984,815287187,12738862,NULL),(152492,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05785','R',152492,38.85,0.19,514,72427,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 05785',0.148398,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152493,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152493,33.56,0.49,51.6,72428,75,NULL,'IR','2MFGC 16536',NULL,'2011yCatp016004901K',2011,1,0.35,NULL,'G',0.000017,NULL,'12.3K',NULL,NULL,NULL,NULL,NULL,NULL,1,328.6027083,46.53878,NULL,NULL,55387485146,865429455,13522335,12.3),(152494,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 03444','RN',152494,41.88,0.19,1720,72429,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03444',0.378981,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152495,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 03444','RN',152495,42.25,0.11,2040,72429,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03444',0.378981,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152496,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152496,33.93,0.49,61.2,72430,75,NULL,'IR','2MFGC 16538',NULL,'2011yCatp016004901K',2011,1,0.67,NULL,'G',0.000043,NULL,'10.7K',0.22,'Spiral',NULL,NULL,NULL,NULL,1,328.608833,41.7345,NULL,NULL,55501556930,867211827,13550184,10.7),(152497,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152497,34.4,0.4,76,72430,NULL,NULL,'mean','2MFGC 16538',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152498,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152498,34.46,0.47,77.9,72430,NULL,NULL,'H','2MFGC 16538',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152499,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152499,34.51,0.45,79.7,72430,NULL,NULL,'K','2MFGC 16538',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152500,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152500,34.76,0.46,89.5,72430,NULL,NULL,'J','2MFGC 16538',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152501,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152501,37.31,0.15,290,72431,70,NULL,NULL,'2MASX J21542625-0823288',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000103,NULL,'16.6g',0.37,NULL,NULL,NULL,NULL,NULL,1,328.609375,-8.39142,0.105,NULL,49928291237,780129550,12189524,16.6),(152502,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006pl',NULL,152502,39.55,0.19,813,72432,70,NULL,'SDSS-II SN 16473','SDSS J215426.92+003518.7',NULL,'2013MNRAS.434.1443X',2013,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,328.612167,0.58853,0.157,NULL,52179128460,815298882,12739045,NULL),(152503,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16473','R',152503,40.07,0.2,859,72432,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006pl','SDSS J215426.92+003518.7',0.2,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152504,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006pl',NULL,152504,39.9,0.1,955,72432,70,NULL,'SALT 2','SDSS J215426.92+003518.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152505,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006pl',NULL,152505,39.92,0.1,964,72432,70,NULL,'SALT 2, Malmquist cor.','SDSS J215426.92+003518.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152506,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16473','R',152506,40.37,0.15,988,72432,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006pl','SDSS J215426.92+003518.7',0.2,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152507,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152507,37.24,0.46,281,72433,70,NULL,NULL,'2MASX J21542737-0711091',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000072,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,328.613875,-7.18586,0.061,NULL,49926488738,780101386,12189084,17.8),(152508,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152508,34.91,0.2,95.9,72434,74.4,NULL,NULL,'UGC 11845',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000542,NULL,'15.61',0.2,'Sbc',NULL,NULL,NULL,NULL,1,328.616708333,15.01653,0.257,NULL,52240308612,816254822,12753981,15.61),(152509,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152509,34.94,0.52,97.2,72434,NULL,NULL,NULL,'UGC 11845',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152510,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152510,35.07,0.49,103,72434,NULL,NULL,'Malmquist cor.','UGC 11845',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152511,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152511,36.93,0.46,243,72435,70,NULL,NULL,'2MASX J21542883-0818341',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,328.62,-8.30944,0.105,NULL,49928768363,780137005,12189640,17.8),(152512,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152512,37.31,0.15,290,72436,70,NULL,NULL,'2MASX J21543186-0837391',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,328.632667,-8.62736,0.105,NULL,49928468193,780132315,12189567,17.8),(152513,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152513,38.18,0.33,433,72437,70,NULL,NULL,'SDSS J215432.20-085734.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,328.634208333,-8.95958,0.089,NULL,49927218066,780112782,12189262,17.9),(152514,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152514,37.29,0.46,287,72438,70,NULL,NULL,'2MASX J21543364+1154154',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000165,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,328.640125,11.90444,0.305,NULL,52303399157,817240611,12769384,17.7),(152515,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152515,37.61,0.33,333,72439,70,NULL,NULL,'2MASX J21543462-0916321',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,328.6442917,-9.27578,0.093,NULL,49919098070,779985907,12187279,17.5),(152516,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152516,38.18,0.33,433,72440,70,NULL,NULL,'2MASX J21543503-0856421',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,328.6460417,-8.945,0.089,NULL,49927184607,780112259,12189254,17.7),(152517,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152517,37.61,0.33,333,72441,70,NULL,NULL,'2MASX J21543719-0915341',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00015,NULL,'16.2g',0.36,'E0',NULL,NULL,NULL,NULL,1,328.655125,-9.25956,0.093,NULL,49919098528,779985914,12187279,16.2),(152518,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152518,36.37,0.73,188,72442,70,NULL,NULL,'2MASX J21543758-0622451',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.55',0.39,NULL,NULL,NULL,NULL,NULL,1,328.6565,-6.37928,0.041,NULL,49922537147,780039642,12188119,16.55),(152519,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152519,37.31,0.15,290,72443,70,NULL,NULL,'2MASX J21543786-0839221',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000172,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,328.65775,-8.65631,0.105,NULL,49928467927,780132311,12189567,16.8),(152520,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 13590','RN',152520,42.04,0.4,1710,72444,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13590',0.496918,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152521,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 19191','RN',152521,40.72,0.24,1200,72445,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19191',0.162727,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152522,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 19191','RN',152522,41.29,0.43,1560,72445,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19191',0.162727,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152523,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hu',NULL,152523,39.48,0.12,645,72446,74.2,NULL,'SALT 2','SDSS J215440.78+002446.9',0.22,'2010ApJ...716..712A',2010,1,0.05,NULL,'G',0.0005,NULL,'23.7g',0.04,NULL,NULL,NULL,NULL,NULL,1,328.669917,0.41303,0.237,NULL,52179141014,815299078,12739048,23.7),(152524,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hu',NULL,152524,39.61,0.07,834,72446,70,NULL,'Hubble residual -0.01 for z0.21970','SDSS J215440.78+002446.9',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152525,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hu',NULL,152525,40.16,0.13,882,72446,70,NULL,'SALT 2','SDSS J215440.78+002446.9',0.22,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152526,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hu',NULL,152526,40.18,0.07,891,72446,65,NULL,'SALT2','SDSS J215440.78+002446.9',0.22,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152527,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05533','R',152527,40.19,0.18,894,72446,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005hu','SDSS J215440.78+002446.9',0.2197,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152528,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hu',NULL,152528,40.21,NULL,901,72446,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 05533, SN 2005hu','SDSS J215440.78+002446.9',0.22,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152529,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hu',NULL,152529,40.32,0.08,949,72446,65,NULL,'MLCS2k2','SDSS J215440.78+002446.9',0.22,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152530,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05533','R',152530,40.35,0.09,961,72446,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005hu','SDSS J215440.78+002446.9',0.2197,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152531,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hu',NULL,152531,40.06,0.07,1030,72446,70,NULL,'SALT 2','SDSS J215440.78+002446.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152532,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hu',NULL,152532,40.07,0.07,1030,72446,70,NULL,'SALT 2, Malmquist cor.','SDSS J215440.78+002446.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152533,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hu',NULL,152533,40.56,0.03,1060,72446,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 05533, SN 2005hu','SDSS J215440.78+002446.9',0.22,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152534,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152534,37.31,0.15,290,72447,70,NULL,NULL,'2MASX J21544110-0827061',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000175,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,328.6712917,-8.45178,0.105,NULL,49928305496,780129773,12189527,17.7),(152535,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152535,36.46,0.68,196,72448,70,NULL,NULL,'2MASX J21544334-1244054',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,328.680667,-12.73489,0.081,NULL,49769996264,777656191,12150877,15.3),(152536,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152536,35.21,0.8,110,72449,75,NULL,'CF, r','UGC 11846',NULL,'1997ApJS..109..333W',1997,1,0.9,'Springob et al. (2005ApJS..160..149S) give v= 8493 km/sec.','G',0.000123,NULL,'15.01',0.5,'Sbc',NULL,NULL,NULL,NULL,1,328.688375,6.42158,0.193,NULL,52335392459,817740507,12777195,15.01),(152537,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152537,35.08,0.38,104,72449,75,NULL,'CF, r, raw','UGC 11846',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152538,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152538,35.24,0.38,112,72449,75,NULL,'CF, r, inv','UGC 11846',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152539,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152539,35.3,0.38,115,72449,75,NULL,'CF, r, cor','UGC 11846',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152540,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152540,37.31,0.15,290,72450,70,NULL,NULL,'2MASX J21544548-0829201',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000182,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,328.6895417,-8.48889,0.105,NULL,49928297439,780129647,12189525,17),(152541,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152541,36.87,0.46,237,72451,70,NULL,NULL,'2MASX J21544578-0720291',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00015,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,328.690875,-7.34144,0.061,NULL,49926634341,780103661,12189119,16.5),(152542,'SGRB','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'N',152542,38.73,NULL,557,72452,71,NULL,NULL,'GRB 051221A HOST',NULL,'2010ApJ...709..664R',2010,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152543,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152543,37.31,0.15,290,72453,70,NULL,NULL,'2MASX J21544920-0849331',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00017,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,328.705167,-8.82603,0.093,NULL,49928261185,780129081,12189516,17.9),(152544,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006pm',NULL,152544,39.6,0.23,832,72454,70,NULL,'SDSS-II SN 16482','APMUKS(BJ) B215217.32+004145.2',NULL,'2013MNRAS.434.1443X',2013,1,0.1,NULL,'G',NULL,NULL,'20.24',0.1,NULL,NULL,NULL,NULL,NULL,1,328.710833,0.933,0.177,NULL,52178653332,815291458,12738929,20.24),(152545,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16482','R',152545,40.11,0.24,869,72454,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006pm','APMUKS(BJ) B215217.32+004145.2',0.210771,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152546,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006pm',NULL,152546,39.7,0.12,871,72454,70,NULL,'SALT 2','APMUKS(BJ) B215217.32+004145.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152547,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006pm',NULL,152547,39.72,0.12,879,72454,70,NULL,'SALT 2, Malmquist cor.','APMUKS(BJ) B215217.32+004145.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152548,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16482','R',152548,40.23,0.14,919,72454,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006pm','APMUKS(BJ) B215217.32+004145.2',0.210771,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152549,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05792',NULL,152549,41.26,0.16,1790,72455,70,NULL,'SALT 2','SDSS-II SN 05792',NULL,'2013ApJ...763...88C',2013,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,328.714167,-1.23786,0.377,NULL,49814239957,778347499,12161679,NULL),(152550,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05792',NULL,152550,41.32,0.16,1840,72455,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 05792',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152551,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05792',NULL,152551,41.49,0.05,1980,72455,70,NULL,'SN photometric redshift distance, z photo =0.651 +/- 0.021','SDSS-II SN 05792',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152552,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152552,38.85,0.46,590,72456,70,NULL,NULL,'SDSS J215453.25-011448.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000174,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,328.721875,-1.24675,0.377,NULL,49814240360,778347505,12161679,18.7),(152553,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152553,37.31,0.15,290,72457,70,NULL,NULL,'2MASX J21545599-0848307',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000157,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,328.733416667,-8.80844,0.093,NULL,49928259855,780129060,12189516,16.8),(152554,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152554,37.4,0.46,302,72458,70,NULL,NULL,'2MASX J21545633+1131526',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,328.734667,11.53142,0.305,NULL,52304000409,817250006,12769531,17.5),(152555,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152555,37.02,0.46,254,72459,70,NULL,NULL,'2MASX J21545739-0735517',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000103,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,328.7392917,-7.59761,0.049,NULL,49926586393,780102912,12189108,16.3),(152556,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 13437','R',152556,41.97,0.34,1730,72460,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13437',0.435782,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,328.74725,-0.66194,0.309,NULL,49814565448,778352585,12161759,NULL),(152557,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 13437','R',152557,42.15,0.4,1870,72460,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13437',0.435782,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152558,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 18615','RN',152558,40.82,0.22,1200,72461,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18615',0.213402,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152559,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152559,31.76,0.8,22.5,72462,75,NULL,'MAT, I','NGC 7151',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000022,NULL,'13.46',1.2,'SA(rs)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,328.76725,-50.65789,0,NULL,50660798633,791574978,12368359,13.46),(152560,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152560,31.58,0.4,20.7,72462,75,NULL,NULL,'NGC 7151',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152561,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152561,31.58,0.39,20.7,72462,73,NULL,'IR','NGC 7151',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152562,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152562,31.69,0.4,21.8,72462,73,NULL,'opt','NGC 7151',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152563,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152563,31.76,0.32,22.5,72462,85,NULL,'I, raw','NGC 7151',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152564,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152564,31.77,0.32,22.6,72462,85,NULL,'I, inv','NGC 7151',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152565,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152565,31.8,0.4,22.9,72462,NULL,NULL,NULL,'NGC 7151',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152566,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152566,32,0.43,25.1,72462,75,NULL,'MAT, I, raw','NGC 7151',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152567,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152567,32.07,0.43,26,72462,75,NULL,'MAT, I, inv','NGC 7151',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152568,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152568,32.21,0.49,27.7,72462,75,NULL,'IR','NGC 7151',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152569,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152569,32.25,0.43,28.1,72462,75,NULL,'MAT, I, cor','NGC 7151',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152570,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152570,34.69,0.46,86.8,72463,NULL,NULL,'Malmquist cor.','CGCG 493-012',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000033,NULL,'15.4',0.6,'Sc',NULL,NULL,NULL,NULL,1,328.769541667,30.58406,0.481,NULL,55625410599,869147040,13580422,15.4),(152571,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152571,34.84,0.43,92.7,72463,NULL,NULL,NULL,'CGCG 493-012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152572,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152572,35.04,0.2,102,72463,74.4,NULL,NULL,'CGCG 493-012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152573,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152573,36.14,0.63,169,72464,70,NULL,NULL,'2MASX J21550591-0625097',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'16.09',0.46,NULL,NULL,NULL,NULL,NULL,1,328.77475,-6.41925,0.065,NULL,49922556243,780039941,12188124,16.09),(152574,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16879','RN',152574,41.06,0.27,1340,72465,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16879',0.214394,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152575,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16879','RN',152575,41.73,0.42,1830,72465,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16879',0.214394,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152576,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152576,35.89,0.63,151,72466,70,NULL,NULL,'SDSS J215507.85-004613.0',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,328.78275,-0.77028,0.309,NULL,49814246389,778347599,12161681,16.6),(152577,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152577,36.51,0.58,200,72467,70,NULL,NULL,'KAZ 533',NULL,'2014MNRAS.445.2677S',2014,1,0.17,NULL,'G',0.00015,NULL,'16.5',0.29,NULL,NULL,NULL,NULL,NULL,1,328.7954583,-12.05569,0.069,NULL,49900228882,779691076,12182673,16.5),(152578,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152578,37.48,0.33,314,72468,70,NULL,NULL,'SDSS J215513.69-091805.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,328.807083,-9.30161,0.093,NULL,49919565672,779993213,12187393,18),(152579,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 13678','RN',152579,40.99,0.13,1270,72469,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 13678',0.239877,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152580,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 13678','RN',152580,41.41,0.21,1540,72469,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 13678',0.239877,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152581,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152581,36.08,0.52,165,72470,70,NULL,NULL,'ESO 189- G 010',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.82',1,'(R)SB(s)0/a',NULL,NULL,NULL,NULL,1,328.8195,-55.57228,0,NULL,48712568133,761133877,11892716,14.82),(152582,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152582,37.48,0.33,314,72471,70,NULL,NULL,'2MASX J21551727-0917517',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00015,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,328.822083,-9.29778,0.093,NULL,49919563113,779993173,12187393,16.3),(152583,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152583,34.22,0.8,69.8,72472,75,NULL,'MAT, I','IC 5142',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'14.47',0.8,'SAB(rs)c',NULL,NULL,NULL,NULL,1,328.835375,-65.51003,0.021,NULL,49355522734,771180042,12049688,14.47),(152584,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152584,34.15,0.32,67.7,72472,85,NULL,'I, raw','IC 5142',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152585,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152585,34.19,0.32,68.8,72472,85,NULL,'I, inv','IC 5142',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152586,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152586,34.35,0.43,74.2,72472,75,NULL,'MAT, I, raw','IC 5142',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152587,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152587,34.53,0.43,80.6,72472,75,NULL,'MAT, I, inv','IC 5142',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152588,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152588,34.84,0.43,93,72472,75,NULL,'MAT, I, cor','IC 5142',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152589,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152589,32.58,0.8,32.8,72473,75,NULL,'MAT, I','NGC 7154',NULL,'1997ApJS..109..333W',1997,1,2.1,'Confused HIPASS source','G',0.00001,NULL,'13.14',1.6,'SB(s)m pec:','in a pair',NULL,NULL,NULL,1,328.837666667,-34.81414,0,NULL,51445630974,803837983,12559968,13.14),(152590,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152590,32.61,0.8,33.3,72473,75,NULL,NULL,'NGC 7154',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152591,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152591,31.72,0.43,22.1,72473,75,NULL,'MAT, I, raw','NGC 7154',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152592,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152592,31.75,0.43,22.4,72473,75,NULL,'MAT, I, inv','NGC 7154',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152593,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152593,31.94,0.32,24.4,72473,85,NULL,'I, raw','NGC 7154',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152594,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152594,31.95,0.32,24.5,72473,85,NULL,'I, inv','NGC 7154',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152595,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152595,32.1,0.43,26.3,72473,75,NULL,'MAT, I, cor','NGC 7154',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152596,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152596,32.6,0.06,33.2,72473,NULL,NULL,NULL,'NGC 7154',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152597,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16455',NULL,152597,38.42,0.52,483,72474,70,NULL,'SN photometric redshift distance, z photo =0.120 +/- 0.035','SDSS-II SN 16455',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,328.8377917,-0.39336,0.277,NULL,49813803133,778340673,12161573,NULL),(152598,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152598,37.43,0.54,306,72475,70,NULL,NULL,'2MASX J21552211-4753053',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'15.2r',0.36,NULL,NULL,NULL,NULL,NULL,1,328.8422083,-47.88486,0,NULL,50651839516,791434992,12366171,15.2),(152599,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152599,34.92,0.46,96.4,72476,70,NULL,NULL,'2MASX J21552271-0000531',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'16.2g',0.16,'S0',NULL,NULL,NULL,NULL,1,328.8447083,-0.01486,0.281,NULL,49813679845,778338747,12161542,16.2),(152600,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152600,37.13,0.46,267,72477,70,NULL,NULL,'2MASX J21552419-0020161',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00017,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,328.85075,-0.33786,0.277,NULL,49813876132,778341814,12161590,16.9),(152601,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152601,36.25,0.54,178,72478,70,NULL,NULL,'2MASX J21553099-6002070',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000103,NULL,'14.7r',0.43,'S0',NULL,NULL,NULL,NULL,1,328.879291667,-60.03536,0.017,NULL,48684911653,760701744,11885964,14.7),(152602,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2007rf',NULL,152602,40.02,0.12,1010,72479,70,NULL,'Hubble residual -0.11 for z0.28800','SDSS J215531.06+004854.3',NULL,'2011ApJ...740...92G',2011,1,0.04,NULL,'G',0.0005,NULL,'22.3g',0.03,NULL,NULL,NULL,NULL,NULL,1,328.879417,0.81508,0.177,NULL,52178598432,815290600,12738915,22.3),(152603,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 20040','R',152603,40.83,0.23,1140,72479,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007rf','SDSS J215531.06+004854.3',0.288,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152604,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 20040','R',152604,40.94,0.15,1200,72479,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007rf','SDSS J215531.06+004854.3',0.288,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152605,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2007rf',NULL,152605,40.69,0.12,1370,72479,70,NULL,'SALT 2','SDSS J215531.06+004854.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152606,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2007rf',NULL,152606,40.72,0.12,1390,72479,70,NULL,'SALT 2, Malmquist cor.','SDSS J215531.06+004854.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152607,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2007my',NULL,152607,39.73,0.14,882,72480,70,NULL,'Hubble residual -0.44 for z0.29320','SDSS J215532.17-002218.4',NULL,'2011ApJ...740...92G',2011,1,0.05,NULL,'G',0.0005,NULL,'21.9g',0.04,NULL,NULL,NULL,NULL,NULL,1,328.8840417,-0.37181,0.277,NULL,49813874548,778341789,12161590,21.9),(152608,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 19027','R',152608,40.53,0.23,986,72480,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007my','SDSS J215532.17-002218.4',0.2932,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152609,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 19027','R',152609,40.6,0.17,1020,72480,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007my','SDSS J215532.17-002218.4',0.2932,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152610,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2007my',NULL,152610,40.4,0.12,1200,72480,70,NULL,'SALT 2','SDSS J215532.17-002218.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152611,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2007my',NULL,152611,40.43,0.12,1220,72480,70,NULL,'SALT 2, Malmquist cor.','SDSS J215532.17-002218.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152612,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152612,37.87,0.46,375,72481,70,NULL,NULL,'2MASX J21553273-0654083',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00015,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,328.886291667,-6.90239,0.057,NULL,49922115289,780033051,12188016,16.7),(152613,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 02501','RN',152613,42.09,0.21,1940,72482,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02501',0.350513,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152614,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 02501','RN',152614,42.23,0.15,2070,72482,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02501',0.350513,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152615,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','PTF11htb','N',152615,36.63,0.04,202,72483,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF11htb',0.0493,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152616,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 03040','RN',152616,40.31,0.18,951,72484,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03040',0.215388,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152617,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 03040','RN',152617,40.87,0.23,1230,72484,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03040',0.215388,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152618,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 17386','R',152618,37.57,0.18,299,72485,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2007jm','SDSS J215538.80-001034.2',0.091147,'2014arXiv1401.3317S',2014,1,0.17,NULL,'G',NULL,':','19.4g',0.06,NULL,NULL,NULL,NULL,NULL,1,328.911667,-0.17617,0.281,NULL,49813702624,778339103,12161548,19.4),(152619,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152619,35.12,0.8,106,72486,75,NULL,'MAT, I','ESO 189- G 012',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'14.2r',0.22,'SAc: sp',NULL,NULL,NULL,NULL,1,328.911917,-54.87619,0,NULL,48709185788,761081027,11891891,14.2),(152620,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152620,34.92,0.49,96.4,72486,75,NULL,'IR','ESO 189- G 012',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152621,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152621,35.35,NULL,118,72486,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 189- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152622,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152622,35.36,NULL,118,72486,NULL,NULL,'Dipole + Quadrupole','ESO 189- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152623,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152623,35.38,NULL,119,72486,NULL,NULL,'Dipole','ESO 189- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152624,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152624,35.39,NULL,120,72486,NULL,NULL,NULL,'ESO 189- G 012',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152625,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152625,35.6,0.43,132,72486,75,NULL,'MAT, I, raw','ESO 189- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152626,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152626,35.82,0.41,146,72486,NULL,NULL,'Malmquist cor.','ESO 189- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152627,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152627,35.86,0.32,148,72486,85,NULL,'I, raw','ESO 189- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152628,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152628,35.89,0.43,150,72486,75,NULL,'MAT, I, cor','ESO 189- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152629,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152629,35.89,0.43,150,72486,75,NULL,'MAT, I, inv','ESO 189- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152630,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152630,35.92,0.32,153,72486,85,NULL,'I, inv','ESO 189- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152631,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152631,35.92,0.39,153,72486,NULL,NULL,NULL,'ESO 189- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152632,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152632,35.96,0.2,156,72486,74.4,NULL,NULL,'ESO 189- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152633,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 19417','N',152633,41.96,0.2,2470,72487,70,NULL,'SALT 2','SDSS-II SN 19417',NULL,'2013ApJ...763...88C',2013,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152634,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 19417','N',152634,42.02,0.2,2540,72487,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19417',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152635,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152635,34.41,0.8,76.2,72488,75,NULL,'W91PP, r','UGC 11849',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.00001,NULL,'14.46',0.9,'SBcd:',NULL,NULL,NULL,NULL,1,328.91775,24.89781,0.289,NULL,55579836396,868434943,13569295,14.46),(152636,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152636,33.86,0.69,59.2,72488,100,NULL,'mid-IR','UGC 11849',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152637,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152637,34.15,0.38,67.5,72488,75,NULL,'W91PP, r, raw','UGC 11849',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152638,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152638,34.3,0.38,72.5,72488,75,NULL,'W91PP, r, inv','UGC 11849',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152639,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152639,34.32,0.2,73.1,72488,74.4,NULL,NULL,'UGC 11849',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152640,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152640,34.37,0.38,75,72488,75,NULL,'W91PP, r, cor','UGC 11849',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152641,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152641,34.46,0.53,77.8,72488,NULL,NULL,NULL,'UGC 11849',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152642,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152642,34.54,0.51,80.9,72488,NULL,NULL,'Malmquist cor.','UGC 11849',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152643,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152643,34.59,0.4,82.8,72488,NULL,NULL,'mean','UGC 11849',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152644,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152644,34.81,0.47,91.5,72488,NULL,NULL,'H','UGC 11849',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152645,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152645,37.47,0.46,313,72489,70,NULL,NULL,'2MASXi J2155444-065340',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,328.93525,-6.89464,0.057,NULL,49922000618,780031259,12187988,17.9),(152646,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005fo',NULL,152646,40.02,0.05,801,72490,70,NULL,'SDSS-II SN 02017','SDSS J215546.53+003536.4',0.26,'2011ApJS..192....1C',2011,1,0.07,NULL,'G',0.0005,NULL,'20.9g',0.06,NULL,NULL,NULL,NULL,NULL,1,328.943917,0.59347,0.177,NULL,52178264396,815285381,12738834,20.9),(152647,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005fo',NULL,152647,40.09,0.15,827,72490,74.2,NULL,'SALT 2','SDSS J215546.53+003536.4',0.26,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152648,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005fo',NULL,152648,40.22,0.15,1110,72490,70,NULL,'Hubble residual 0.27 for z0.26160','SDSS J215546.53+003536.4',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152649,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005fo',NULL,152649,40.84,0.15,1170,72490,65,NULL,'SALT2','SDSS J215546.53+003536.4',0.26,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152650,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005fo',NULL,152650,40.91,0.18,1210,72490,70,NULL,'SDSS-II SN 02017, SALT 2','SDSS J215546.53+003536.4',0.26,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152651,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 02017','R',152651,40.97,0.24,1240,72490,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fo','SDSS J215546.53+003536.4',0.2616,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152652,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005fo',NULL,152652,40.99,0.13,1250,72490,65,NULL,'MLCS2k2','SDSS J215546.53+003536.4',0.26,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152653,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 02017','R',152653,41.05,0.18,1280,72490,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fo','SDSS J215546.53+003536.4',0.2616,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152654,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152654,35.44,0.34,123,72491,NULL,NULL,'Malmquist cor.','CGCG 428-001',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.00058,NULL,'15.47',0.3,NULL,NULL,NULL,NULL,NULL,1,328.948083,14.73108,0.237,NULL,52232975760,816140246,12752191,15.47),(152655,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152655,35.53,0.33,128,72491,NULL,NULL,NULL,'CGCG 428-001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152656,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152656,35.71,0.2,139,72491,74.4,NULL,NULL,'CGCG 428-001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152657,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005lh',NULL,152657,39.65,0.15,698,72492,74.2,NULL,'SALT 2','SDSS J215548.23+011052.7',0.22,'2010ApJ...716..712A',2010,1,0.14,NULL,'G',NULL,NULL,'19.96',0.11,NULL,NULL,NULL,NULL,NULL,1,328.950958333,1.18133,0.165,NULL,52192590349,815509224,12742331,19.96),(152658,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005lh',NULL,152658,40.13,0.06,871,72492,70,NULL,'SDSS-II SN 09467','SDSS J215548.23+011052.7',0.22,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152659,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005lh',NULL,152659,40.32,0.23,951,72492,65,NULL,'SALT2','SDSS J215548.23+011052.7',0.22,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152660,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005lh',NULL,152660,39.9,0.22,955,72492,70,NULL,'SDSS-II SN 09467','SDSS J215548.23+011052.7',NULL,'2013MNRAS.434.1443X',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152661,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 09467','R',152661,40.36,0.22,967,72492,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005lh','SDSS J215548.23+011052.7',0.22,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152662,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005lh',NULL,152662,40.37,0.17,971,72492,70,NULL,'SDSS-II SN 09467, SALT 2','SDSS J215548.23+011052.7',0.22,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152663,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005lh',NULL,152663,40.5,0.18,1030,72492,65,NULL,'MLCS2k2','SDSS J215548.23+011052.7',0.22,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152664,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 09467','R',152664,40.52,0.19,1040,72492,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005lh','SDSS J215548.23+011052.7',0.22,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152665,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005lh',NULL,152665,40.18,0.14,1090,72492,70,NULL,'SALT 2','SDSS J215548.23+011052.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152666,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005lh',NULL,152666,40.19,0.14,1090,72492,70,NULL,'SALT 2, Malmquist cor.','SDSS J215548.23+011052.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152667,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152667,37.38,0.46,299,72493,70,NULL,NULL,'2MASX J21555000-0919553',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,328.9582917,-9.33186,0.093,NULL,49917747249,779964800,12186950,17),(152668,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152668,35.6,0.76,132,72494,70,NULL,NULL,'2MASX J21555152-0131386',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'17.45',0.18,NULL,NULL,NULL,NULL,NULL,1,328.964583,-1.52733,0.361,NULL,49827292108,778551439,12164866,17.45),(152669,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 20394',NULL,152669,37.59,1.6,329,72495,70,NULL,'SN photometric redshift distance, z photo =0.080 +/- 0.096','SDSS-II SN 20394',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,328.970333,-1.15317,0.373,NULL,49825674372,778526162,12164471,NULL),(152670,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 21846','RN',152670,38.7,0.58,514,72496,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 21846',0.068641,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152671,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006on',NULL,152671,36.75,0.19,209,72497,74.2,NULL,'SALT 2','SDSS J215558.49-010413.0',0.07,'2010ApJ...716..712A',2010,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,328.99375,-1.07028,0.373,NULL,49825601141,778525017,12164453,18),(152672,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006on','R',152672,37.09,0.15,262,72497,NULL,NULL,'MLCS2k2, R(V) = 3.1','SDSS J215558.49-010413.0',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152673,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16333','R',152673,37.33,0.2,274,72497,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006on','SDSS J215558.49-010413.0',0.07,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152674,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006on','R',152674,37.19,0.11,274,72497,NULL,NULL,'MLCS2k2, R(V) = 1.8','SDSS J215558.49-010413.0',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152675,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006on',NULL,152675,37.35,0.18,276,72497,70,NULL,'SALT 2','SDSS J215558.49-010413.0',0.07,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152676,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006on',NULL,152676,37.43,0.19,286,72497,73.8,NULL,'SALT 2 (SNANA)','SDSS J215558.49-010413.0',0.0679,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152677,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006on',NULL,152677,37.47,0.21,291,72497,65,NULL,'MLCS31','SDSS J215558.49-010413.0',0.07,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152678,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16333','R',152678,37.5,0.07,296,72497,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006on','SDSS J215558.49-010413.0',0.07,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152679,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006on',NULL,152679,37.58,0.18,306,72497,65,NULL,'MLCS17','SDSS J215558.49-010413.0',0.07,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152680,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006on',NULL,152680,37.59,0.16,308,72497,65,NULL,'SALT','SDSS J215558.49-010413.0',0.07,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152681,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006on',NULL,152681,37.6,0.2,309,72497,65,NULL,'SALT2','SDSS J215558.49-010413.0',0.07,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152682,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006on',NULL,152682,37.98,0.06,368,72497,70,NULL,'SALT 2','SDSS J215558.49-010413.0',0.07,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152683,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152683,36.77,0.56,226,72498,70,NULL,NULL,'2MASX J21555881-4635386',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000113,NULL,'15.0r',0.4,'E',NULL,NULL,NULL,NULL,1,328.995041667,-46.59403,0,NULL,50644598946,791321858,12364404,15),(152684,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152684,34.42,0.8,76.5,72499,75,NULL,'W91PP, r','UGC 11852',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.72',0.7,'SBa?           HII',NULL,NULL,NULL,NULL,1,328.997125,27.89842,0.353,NULL,55579473280,868429270,13569207,14.72),(152685,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152685,33.85,0.69,59,72499,100,NULL,'mid-IR','UGC 11852',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152686,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152686,34.33,0.38,73.3,72499,75,NULL,'W91PP, r, raw','UGC 11852',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152687,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152687,34.51,0.38,79.9,72499,75,NULL,'W91PP, r, inv','UGC 11852',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152688,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152688,34.55,0.38,81.4,72499,75,NULL,'W91PP, r, cor','UGC 11852',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152689,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152689,34.63,0.4,84.3,72499,NULL,NULL,'mean','UGC 11852',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152690,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152690,34.66,0.47,85.4,72499,NULL,NULL,'H','UGC 11852',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152691,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152691,34.73,0.45,88.1,72499,NULL,NULL,'K','UGC 11852',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152692,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152692,34.78,0.46,90.5,72499,NULL,NULL,'J','UGC 11852',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152693,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152693,35.69,0.51,138,72500,70,NULL,NULL,'IC 1410',NULL,'2014MNRAS.445.2677S',2014,1,0.79,NULL,'G',0.000093,NULL,'15.94',0.52,NULL,NULL,NULL,NULL,NULL,1,329.008917,-2.90028,0.285,NULL,49826364015,778536937,12164639,15.94),(152694,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152694,37.48,0.46,313,72501,70,NULL,NULL,'2MASX J21560322-0803109',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000097,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,329.013416667,-8.05308,0.037,NULL,49928620428,780134694,12189604,17.3),(152695,'Faber-Jackson','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152695,31.65,0.65,21.4,72502,95,NULL,'Weighted Mean','NGC 7155',NULL,'1984ApJS...56...91D',1984,1,2.2,'SGC and ESO misidentify IC 5143.','G',0.000083,NULL,'13.1',1.8,'SB(r)0^0','in a triple',NULL,NULL,NULL,1,329.040541667,-49.52194,0,NULL,50665028610,791641072,12369391,13.1),(152696,'Faber-Jackson','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152696,33.02,0.81,40.2,72502,55,NULL,'Visvanathan & Sandage 1979','NGC 7155',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152697,'Tertiary','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152697,31.55,0.71,20.4,72502,95,NULL,NULL,'NGC 7155',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152698,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152698,31.86,0.8,23.5,72502,75,NULL,'B','NGC 7155',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152699,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 03077','RN',152699,39.94,0.19,780,72503,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03077',0.2455,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152700,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 03077','RN',152700,40,0.1,804,72503,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03077',0.2455,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152701,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152701,34.68,0.69,86.3,72504,100,NULL,'mid-IR','CGCG 377-004',NULL,'2013ApJ...771...88L',2013,1,0.7,NULL,'G',0.000107,NULL,'14.7',0.4,NULL,NULL,NULL,NULL,NULL,1,329.062375,2.17261,0.165,NULL,52191123597,815486306,12741973,14.7),(152702,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152702,34.87,0.36,94.1,72504,NULL,NULL,NULL,'CGCG 377-004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152703,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152703,34.91,0.2,95.9,72504,74.4,NULL,NULL,'CGCG 377-004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152704,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152704,35.18,0.31,109,72504,NULL,NULL,'Malmquist cor.','CGCG 377-004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152705,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152705,36.33,0.55,185,72505,70,NULL,NULL,'2MASX J21561642-5704019',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.33',0.38,NULL,NULL,NULL,NULL,NULL,1,329.068375,-57.06722,0,NULL,48721012910,761265826,11894778,16.33),(152706,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152706,36.86,0.1,235,72506,70,NULL,NULL,'2MASX J21561816-0749268',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00005,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,329.075625,-7.82397,0.049,NULL,49925088202,780079503,12188742,17.5),(152707,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152707,33.62,0.2,53,72507,74.4,NULL,NULL,'UGC 11853',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000017,NULL,'14.91',0.8,'SB(s)c',NULL,NULL,NULL,NULL,1,329.0764583,-1.17353,0.373,NULL,49825648933,778525764,12164465,14.91),(152708,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152708,30.79,0.4,14.4,72508,NULL,NULL,NULL,'UGC 11861',NULL,'2009AJ....138..323T',2009,1,3.5,NULL,'G',0.000013,NULL,'14.2',2.6,'SABdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,329.1,73.26072,1.813,NULL,52787426890,824803545,12887555,14.2),(152709,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152709,31.97,0.4,24.7,72508,75,NULL,'B','UGC 11861',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152710,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152710,34.33,0.8,73.4,72509,75,NULL,'W91PP, r','UGC 11855',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'15.49',0.3,'Sbc',NULL,NULL,NULL,NULL,1,329.108125,30.78761,0.457,NULL,55570756617,868293072,13567079,15.49),(152711,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152711,34.28,0.38,71.7,72509,75,NULL,'W91PP, r, raw','UGC 11855',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152712,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152712,34.47,0.47,78.2,72509,NULL,NULL,'H','UGC 11855',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152713,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152713,34.49,0.49,78.9,72509,75,NULL,'IR','UGC 11855',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152714,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152714,34.5,0.38,79.4,72509,75,NULL,'W91PP, r, inv','UGC 11855',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152715,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152715,34.5,0.45,79.6,72509,NULL,NULL,'K','UGC 11855',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152716,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152716,34.51,0.38,79.7,72509,75,NULL,'W91PP, r, cor','UGC 11855',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152717,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152717,34.52,0.4,80.3,72509,NULL,NULL,'mean','UGC 11855',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152718,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152718,34.62,0.46,83.9,72509,NULL,NULL,'J','UGC 11855',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152719,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152719,34.75,0.2,89.1,72509,74.4,NULL,NULL,'UGC 11855',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152720,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152720,34.77,0.37,90,72509,NULL,NULL,'Malmquist cor.','UGC 11855',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152721,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152721,34.91,0.34,96.1,72509,NULL,NULL,NULL,'UGC 11855',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152722,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152722,37,0.46,251,72510,70,NULL,NULL,'2MASX J21562643-0909466',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,329.11025,-9.16314,0.089,NULL,49917756879,779964951,12186952,17.6),(152723,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152723,35.32,0.51,116,72511,70,NULL,NULL,'2MASX J21563230-5353560',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.000103,NULL,'14.0r',0.33,'E',NULL,NULL,NULL,NULL,1,329.13475,-53.89883,0,NULL,50625324575,791020696,12359698,14),(152724,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152724,35.02,0.59,101,72512,70,NULL,NULL,'AM 2153-554 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'15.64',0.55,'SA(rl)0^+',NULL,NULL,NULL,NULL,1,329.152667,-55.55447,0,NULL,48712523075,761133173,11892705,15.64),(152725,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152725,36.48,0.46,198,72513,70,NULL,NULL,'2MASX J21563744+0057156',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000169,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,329.155916667,0.95433,0.165,NULL,52192711932,815511123,12742361,17.7),(152726,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152726,36.86,0.1,235,72514,70,NULL,NULL,'2MASX J21564310-0732595',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000067,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,329.1797083,-7.54997,0.065,NULL,49923768205,780058878,12188419,16.4),(152727,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152727,37.15,0.27,269,72515,70,NULL,NULL,'2MASX J21564374-0654115',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000168,NULL,'16.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,329.182375,-6.90317,0.065,NULL,49921998699,780031229,12187987,16.8),(152728,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152728,38.62,0.46,530,72516,70,NULL,NULL,'SDSS J215645.23-092035.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,329.188458333,-9.34311,0.097,NULL,49917971860,779968310,12187004,18.7),(152729,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152729,37.15,0.27,269,72517,70,NULL,NULL,'2MASX J21564677-0656505',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000103,NULL,'16.0g',0.35,'AGN',NULL,NULL,NULL,NULL,1,329.194833,-6.94733,0.065,NULL,49921993944,780031155,12187986,16),(152730,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152730,37.4,0.46,302,72518,70,NULL,NULL,'SDSS J215646.92-003123.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000156,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,329.1955,-0.52308,0.253,NULL,49825436941,778522452,12164413,18.4),(152731,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005ei',NULL,152731,38.19,0.12,385,72519,74.2,NULL,'SALT 2','SDSS J215647.63+001901.3',0.128,'2010ApJ...716..712A',2010,1,0.14,NULL,'G',NULL,NULL,'20.1g',0.05,NULL,NULL,NULL,NULL,NULL,1,329.1985,0.31706,0.181,NULL,52191844330,815497567,12742149,20.1),(152732,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005ei',NULL,152732,38.93,0.14,541,72519,70,NULL,'SDSS-II SN 00744, SALT 2','SDSS J215647.63+001901.3',0.128,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152733,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 00744','R',152733,38.97,0.19,555,72519,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ei','SDSS J215647.63+001901.3',0.12,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152734,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005ei',NULL,152734,39.05,0.05,572,72519,70,NULL,'SDSS-II SN 00744','SDSS J215647.63+001901.3',0.128,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152735,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 00744','R',152735,39.2,0.1,617,72519,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ei','SDSS J215647.63+001901.3',0.12,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152736,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152736,36.64,0.63,212,72520,70,NULL,NULL,'2MASX J21564784-1159487',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'16.35',0.19,NULL,NULL,NULL,NULL,NULL,1,329.199417,-11.99683,0.077,NULL,49899888919,779685764,12182590,16.35),(152737,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152737,34.71,0.51,87.5,72521,70,NULL,NULL,'LCRS B215340.0-450417',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.000093,NULL,'13.8r',0.68,'(R)S0^+',NULL,NULL,NULL,NULL,1,329.199833,-44.83342,0,NULL,50645310678,791332979,12364577,13.8),(152738,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152738,36.86,0.1,235,72522,70,NULL,NULL,'2MASX J21565004-0748425',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000145,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,329.2084583,-7.81183,0.049,NULL,49925119695,780079995,12188749,17.5),(152739,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152739,37.89,0.46,378,72523,70,NULL,NULL,'2MASX J21565061-0715535',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000168,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,329.2109583,-7.26478,0.069,NULL,49923785229,780059144,12188424,17.2),(152740,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152740,35.98,0.59,157,72524,70,NULL,NULL,'2MASX J21565153-1126315',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,329.214833333,-11.44217,0.081,NULL,49916552899,779946139,12186658,15.7),(152741,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152741,35.45,0.2,123,72525,74.4,NULL,NULL,'UGC 11857',NULL,'2013AJ....146...86T',2013,1,0.95,NULL,'G',0.000103,NULL,'15.2g',0.52,'SB?',NULL,NULL,NULL,NULL,1,329.219625,12.31611,0.305,NULL,52231850383,816122662,12751916,15.2),(152742,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152742,35.2,0.51,109,72526,70,NULL,NULL,'2MASX J21565444-5539422',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'14.5r',0.5,'E',NULL,NULL,NULL,NULL,1,329.2269583,-55.66181,0,NULL,48711664895,761119763,11892496,14.5),(152743,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152743,37.15,0.27,269,72527,70,NULL,NULL,'2MASX J21565690-0657514',NULL,'2015arXiv151105856S',2015,1,0.24,'Star 11\\\" east of the nucleus.','G',0.000172,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,329.2372083,-6.96425,0.065,NULL,49923890067,780060782,12188449,17.2),(152744,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152744,35.87,0.49,149,72528,70,NULL,NULL,'2MASX J21565707-6847095',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'16.13',0.4,'S0',NULL,NULL,NULL,NULL,1,329.237667,-68.78592,0.021,NULL,49309068016,770454187,12038346,16.13),(152745,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152745,36.86,0.1,235,72529,70,NULL,NULL,'SDSS J215657.90-075149.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000057,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,329.2412917,-7.86364,0.049,NULL,49925101144,780079705,12188745,17.9),(152746,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152746,37.18,0.46,272,72530,70,NULL,NULL,'2MASX J21570049-0803124',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000073,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,329.252,-8.05356,0.069,NULL,49925310815,780082981,12188796,16.7),(152747,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152747,36.86,0.1,235,72531,70,NULL,NULL,'2MASX J21570123-0754154',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000063,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,329.255125,-7.90425,0.069,NULL,49925108676,780079823,12188747,16.5),(152748,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152748,36.86,0.1,235,72532,70,NULL,NULL,'2MASX J21570170-0750224',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.00008,NULL,'15.3g',0.58,'cD;BrClG',NULL,NULL,NULL,NULL,1,329.257167,-7.83958,0.049,NULL,49925099848,780079685,12188745,15.3),(152749,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152749,35.75,0.59,141,72533,70,NULL,NULL,'2MASX J21570186-7127556',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'14.6r',0.43,'S0',NULL,NULL,NULL,NULL,1,329.257625,-71.46547,0.025,NULL,49307528263,770430129,12037970,14.6),(152750,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hn',NULL,152750,37.93,0.12,350,72534,74.2,NULL,'SALT 2','SDSS J215704.19-001324.4',0.1,'2010ApJ...716..712A',2010,1,0.09,NULL,'G',0.0005,NULL,'19.8g',0.07,NULL,NULL,NULL,NULL,NULL,1,329.267458333,-0.22344,0.237,NULL,49821019219,778453425,12163334,19.8),(152751,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hn',NULL,152751,38.23,0.06,442,72534,70,NULL,'Hubble residual 0.03 for z0.10760','SDSS J215704.19-001324.4',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152752,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 03256','R',152752,38.57,0.18,468,72534,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005hn','SDSS J215704.19-001324.4',0.1076,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152753,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hn',NULL,152753,38.57,0.12,471,72534,70,NULL,'SDSS-II SN 03256, SALT 2','SDSS J215704.19-001324.4',0.1,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152754,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 03256','R',152754,38.62,0.09,479,72534,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005hn','SDSS J215704.19-001324.4',0.1076,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152755,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hn',NULL,152755,38.62,0.14,482,72534,65,NULL,'SALT2','SDSS J215704.19-001324.4',0.1,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152756,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hn',NULL,152756,38.46,0.07,492,72534,70,NULL,'SALT 2','SDSS J215704.19-001324.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152757,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hn',NULL,152757,38.47,0.07,494,72534,70,NULL,'SALT 2, Malmquist cor.','SDSS J215704.19-001324.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152758,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hn',NULL,152758,38.69,0.05,498,72534,70,NULL,'SDSS-II SN 03256','SDSS J215704.19-001324.4',0.1,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152759,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hn',NULL,152759,38.73,0.11,506,72534,65,NULL,'MLCS2k2','SDSS J215704.19-001324.4',0.1,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152760,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152760,35.18,0.45,109,72535,NULL,NULL,'K','ESO 075- G 041',NULL,'2007A&A...465...71T',2007,1,1.6,'Mulchaey, et al (1996, ApJS, 102, 309) say this is not a Seyfert.','G',0.000103,NULL,'14.3',0.8,'SA0-;Radio gal;Sy2',NULL,NULL,'radio jet','Sy 1',1,329.274917,-69.68992,0,NULL,49302267318,770347926,12036686,14.3),(152761,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152761,35.28,0.4,114,72535,NULL,NULL,'mean','ESO 075- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152762,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152762,32.61,0.8,33.3,72536,75,NULL,'MAT, I','ESO 404- G 012',NULL,'1997ApJS..109..333W',1997,1,2.3,'Confused HIPASS source','G',0.00001,NULL,'12.1r',1.8,'SAB(r)c        HII','in a pair',NULL,NULL,NULL,1,329.279958333,-34.58222,0,NULL,50559966876,789999482,12343741,12.1),(152763,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152763,32.61,0.06,33.3,72536,NULL,NULL,NULL,'ESO 404- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152764,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152764,32.75,0.43,35.4,72536,75,NULL,'MAT, I, raw','ESO 404- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152765,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152765,32.77,0.4,35.9,72536,NULL,NULL,'mean','ESO 404- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152766,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152766,32.83,0.45,36.8,72536,NULL,NULL,'K','ESO 404- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152767,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152767,32.84,0.47,36.9,72536,NULL,NULL,'H','ESO 404- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152768,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152768,32.88,0.32,37.6,72536,85,NULL,'I, raw','ESO 404- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152769,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152769,32.88,0.46,37.6,72536,NULL,NULL,'J','ESO 404- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152770,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152770,32.9,0.4,38,72536,NULL,NULL,NULL,'ESO 404- G 012',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152771,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152771,32.92,0.32,38.4,72536,85,NULL,'I, inv','ESO 404- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152772,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152772,32.92,0.43,38.4,72536,75,NULL,'MAT, I, cor','ESO 404- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152773,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152773,32.95,0.43,38.8,72536,75,NULL,'MAT, I, inv','ESO 404- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152774,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152774,33.17,NULL,43.1,72536,NULL,NULL,'I','ESO 404- G 012',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152775,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152775,33.41,NULL,48.1,72536,NULL,NULL,'B','ESO 404- G 012',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152776,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152776,36.86,0.1,235,72537,70,NULL,NULL,'2MASX J21570908-0722053',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,329.287958333,-7.36825,0.069,NULL,49923793209,780059268,12188426,17.5),(152777,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16111',NULL,152777,39.58,0.27,824,72538,70,NULL,'SN photometric redshift distance, z photo =0.215 +/- 0.033','SDSS-II SN 16111',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,329.316916667,0.93544,0.165,NULL,52192816049,815512750,12742386,NULL),(152778,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152778,36.86,0.1,235,72539,70,NULL,NULL,'SDSS J215717.31-074849.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000057,NULL,'17.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,329.322125,-7.81378,0.069,NULL,49923255059,780050860,12188294,17.7),(152779,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152779,36.86,0.1,235,72540,70,NULL,NULL,'2MASX J21571914-0800453',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000077,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,329.3299583,-8.01275,0.069,NULL,49925277077,780082454,12188788,16.3),(152780,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152780,37.28,0.33,286,72541,70,NULL,NULL,'2MASX J21571935-0703303',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000103,NULL,'16.5g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,329.330625,-7.05836,0.069,NULL,49923945057,780061641,12188463,16.5),(152781,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152781,36.86,0.1,235,72542,70,NULL,NULL,'2MASX J21572142-0748473',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000063,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,329.3392083,-7.81303,0.069,NULL,49923256389,780050881,12188295,16.4),(152782,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152782,36.86,0.1,235,72543,70,NULL,NULL,'2MASX J21572341-0758143',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000083,NULL,'16.0g',0.37,'E0',NULL,NULL,NULL,NULL,1,329.3475417,-7.97056,0.069,NULL,49925098774,780079668,12188744,16),(152783,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152783,37.28,0.33,286,72544,70,NULL,NULL,'SDSS J215724.40-070246.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000138,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,329.3517083,-7.04639,0.065,NULL,49923939963,780061561,12188461,18.6),(152784,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152784,36.86,0.1,235,72545,70,NULL,NULL,'SDSS J215725.63-074926.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,329.3567917,-7.82406,0.069,NULL,49923256914,780050889,12188295,18.4),(152785,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 15928','RN',152785,40.92,0.21,1280,72546,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15928',0.192202,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152786,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 15928','RN',152786,40.99,0.15,1330,72546,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15928',0.192202,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152787,'BCG','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152787,37.68,0.35,325,72547,60,NULL,NULL,'ABELL 2399',0.0587,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,329.3575,-7.79472,0.073,NULL,49923249330,780050770,12188293,NULL),(152788,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152788,36.9,0.37,240,72547,72,NULL,NULL,'ABELL 2399',NULL,'2015MNRAS.451.2723S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152789,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152789,37.07,0.22,260,72547,72,NULL,'MASS PLANE','ABELL 2399',NULL,'2015MNRAS.451.2723S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152790,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05627','RN',152790,42.86,0.19,2800,72548,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05627',0.331062,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152791,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05627','RN',152791,42.93,0.23,2890,72548,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 05627',0.331062,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152792,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152792,36.86,0.1,235,72549,70,NULL,NULL,'2MASX J21572630-0751383',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000087,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,329.359667,-7.8605,0.069,NULL,49923260355,780050943,12188295,16.8),(152793,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 06987','RN',152793,42.65,0.36,2620,72550,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06987',0.2943,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152794,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152794,36.37,0.58,188,72551,70,NULL,NULL,'2MASX J21572885-5626503',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'15.1r',0.31,NULL,NULL,NULL,NULL,NULL,1,329.370167,-56.44736,0,NULL,48719231498,761237992,11894343,15.1),(152795,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152795,36.86,0.1,235,72552,70,NULL,NULL,'2MASX J21572939-0747443',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.0001,NULL,'15.6g',0.39,'BrClG',NULL,NULL,NULL,NULL,1,329.372583,-7.79572,0.073,NULL,49923249776,780050777,12188293,15.6),(152796,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 17393',NULL,152796,39.72,0.77,877,72553,70,NULL,'SN photometric redshift distance, z photo =0.231 +/- 0.120','SDSS-II SN 17393',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','21.2g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,329.377583,-0.9285,0.329,NULL,49826180568,778534071,12164594,21.2),(152797,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 17393','R',152797,40.21,0.29,905,72553,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17393',0.2174,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152798,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 17393',NULL,152798,39.95,0.17,977,72553,70,NULL,'SALT 2','SDSS-II SN 17393',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152799,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 17393',NULL,152799,39.97,0.17,986,72553,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 17393',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152800,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 17393','R',152800,40.47,0.23,1020,72553,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17393',0.2174,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152801,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 14315','RN',152801,42.57,0.54,2940,72554,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 14315',0.11003,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152802,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 14315','RN',152802,45.23,0.82,10000,72554,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 14315',0.11003,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152803,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152803,34.58,0.54,82.5,72555,70,NULL,NULL,'2MASX J21573337-1402227',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.88',NULL,NULL,NULL,NULL,NULL,NULL,1,329.389,-14.03969,0.069,NULL,49779604440,777806319,12153223,14.88),(152804,'BCG','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152804,37.68,0.35,325,72556,60,NULL,'ABELL 2399, BCG','2MASX J21573344-0747393',0.0587,'1980ApJ...241..486H',1980,1,0.55,NULL,'G',0.00009,NULL,'15.7g',0.48,'E0','Brightest group member',NULL,NULL,NULL,1,329.389458333,-7.79422,0.073,NULL,49923248390,780050756,12188293,15.7),(152805,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152805,36.86,0.1,235,72556,70,NULL,NULL,'2MASX J21573344-0747393',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152806,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152806,36.9,0.37,240,72556,72,NULL,'ABELL 2399, BCG','2MASX J21573344-0747393',NULL,'2015MNRAS.451.2723S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152807,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152807,37.07,0.22,260,72556,72,NULL,'MASS PLANE, ABELL 2399, BCG','2MASX J21573344-0747393',NULL,'2015MNRAS.451.2723S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152808,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 02502','RN',152808,37.92,0.21,315,72557,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02502',0.218529,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152809,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152809,34.9,NULL,95.5,72558,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 344- G 002',NULL,'2010Ap&SS.325..163P',2010,1,1.17,NULL,'G',0.000033,NULL,'15.4r',0.14,'Sc',NULL,NULL,NULL,NULL,1,329.423875,-40.41836,0,NULL,50670464483,791726007,12370718,15.4),(152810,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152810,34.92,NULL,96.2,72558,NULL,NULL,'Dipole + Quadrupole','ESO 344- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152811,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152811,34.93,NULL,97,72558,NULL,NULL,'Dipole','ESO 344- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152812,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152812,34.96,NULL,98.1,72558,NULL,NULL,NULL,'ESO 344- G 002',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152813,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152813,34.97,0.49,98.7,72558,75,NULL,'IR','ESO 344- G 002',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152814,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152814,35.13,0.64,106,72558,NULL,NULL,NULL,'ESO 344- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152815,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152815,35.17,0.2,108,72558,74.4,NULL,NULL,'ESO 344- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152816,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152816,35.28,0.59,114,72558,NULL,NULL,'Malmquist cor.','ESO 344- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152817,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152817,37.97,0.46,393,72559,70,NULL,NULL,'SDSS J215741.77-070229.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000149,NULL,'18.9g',0.1,NULL,NULL,NULL,NULL,NULL,1,329.424041667,-7.04164,0.065,NULL,49924629497,780072335,12188630,18.9),(152818,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152818,35.58,0.48,131,72560,70,NULL,NULL,'2MASX J21574207-1622507',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.40',0.4,NULL,NULL,NULL,NULL,NULL,1,329.42525,-16.38061,0.089,NULL,49785130792,777892668,12154572,15.4),(152819,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152819,34.18,NULL,68.4,72561,NULL,NULL,'Dipole','UGC 11862',NULL,'2010Ap&SS.325..163P',2010,1,1.99,NULL,'G',0.000017,NULL,'16.5',0.26,'Sd',NULL,NULL,NULL,NULL,1,329.4297083,38.93508,1.009,NULL,55468037287,866688082,13542001,16.5),(152820,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152820,34.18,NULL,68.7,72561,NULL,NULL,'Dipole + Quadrupole','UGC 11862',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152821,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152821,34.19,NULL,68.8,72561,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11862',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152822,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152822,34.46,0.43,78.1,72561,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11862',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152823,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152823,34.73,0.49,88.2,72561,75,NULL,'IR','UGC 11862',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152824,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152824,36.86,0.1,235,72562,70,NULL,NULL,'2MASX J21574316-0723472',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000103,NULL,'16.1g',0.36,'S0',NULL,NULL,NULL,NULL,1,329.429875,-7.39653,0.069,NULL,49924004769,780062574,12188477,16.1),(152825,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152825,36.86,0.1,235,72563,70,NULL,NULL,'2MASX J21574326-0745452',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000073,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,329.430167,-7.76253,0.073,NULL,49923269564,780051086,12188298,16.3),(152826,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 03257','RN',152826,42.79,0.41,2700,72564,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03257',0.334896,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152827,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 03257','RN',152827,42.84,0.42,2770,72564,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03257',0.334896,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152828,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152828,36.62,0.51,211,72565,70,NULL,NULL,'2MASX J21574748-1246347',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000147,NULL,'15.48',0.7,NULL,NULL,NULL,NULL,NULL,1,329.447625,-12.77617,0.133,NULL,49769753357,777652396,12150818,15.48),(152829,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152829,36.6,0.52,209,72566,70,NULL,NULL,'2MASX J21575064-0429045',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,329.461083,-4.48467,0.137,NULL,49888663209,779510362,12179849,13.8),(152830,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 03041','RN',152830,41.76,0.21,1740,72567,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03041',0.28914,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152831,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 03041','RN',152831,41.77,0.15,1760,72567,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03041',0.28914,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152832,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152832,34.64,0.46,84.7,72568,70,NULL,NULL,'2MASX J21575345-6950254',NULL,'2014MNRAS.445.2677S',2014,1,0.85,NULL,'G',0.000063,NULL,'14.1r',0.4,'S',NULL,NULL,NULL,NULL,1,329.472666667,-69.84031,0,NULL,49302455678,770350869,12036732,14.1),(152833,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152833,36.86,0.1,235,72569,70,NULL,NULL,'2MASX J21575406-0742068',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00006,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,329.47525,-7.70203,0.073,NULL,49923455871,780053997,12188343,17.3),(152834,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152834,35.06,NULL,103,72570,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 532- G 005',NULL,'2010Ap&SS.325..163P',2010,1,1.18,'Star superposed or knot.','G',0.000053,NULL,'14.9r',0.15,'Sc',NULL,NULL,NULL,NULL,1,329.480667,-22.91864,0.057,NULL,50884286705,795066979,12422921,14.9),(152835,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152835,35.07,NULL,103,72570,NULL,NULL,'Dipole + Quadrupole','ESO 532- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152836,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152836,35.1,NULL,105,72570,NULL,NULL,'Dipole','ESO 532- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152837,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152837,31.55,0.8,20.4,72571,75,NULL,NULL,'ESO 146- GA002',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.00001,NULL,'14.6',1.3,'IB(s)m',NULL,NULL,NULL,NULL,1,329.4817083,-60.30828,0,NULL,48685044338,760703817,11885997,14.6),(152838,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152838,38.73,0.46,557,72572,70,NULL,NULL,'2MASX J21575682+1128294',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000196,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,329.486708333,11.47481,0.289,NULL,52336722201,817761284,12777520,18.1),(152839,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152839,38.27,0.27,451,72573,70,NULL,NULL,'2MASX J21575736-0841038',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000187,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,329.4890417,-8.6845,0.077,NULL,49925799580,780090618,12188915,17.4),(152840,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152840,33.03,0.8,40.4,72574,75,NULL,'W91PP, r','UGC 11860',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00001,NULL,'16.0',0.6,'Sdm',NULL,NULL,NULL,NULL,1,329.49875,24.26667,0.241,NULL,55097682832,860901294,13451582,16),(152841,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152841,34.03,0.38,64,72574,75,NULL,'W91PP, r, inv','UGC 11860',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152842,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152842,34.15,0.38,67.7,72574,75,NULL,'W91PP, r, raw','UGC 11860',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152843,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152843,34.38,0.38,75.3,72574,75,NULL,'W91PP, r, cor','UGC 11860',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152844,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152844,37.72,0.46,350,72575,70,NULL,NULL,'2MASX J21580052-0749328',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000077,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,329.502,-7.82581,0.073,NULL,49923476718,780054323,12188348,17.1),(152845,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152845,34.66,0.53,85.7,72576,70,NULL,NULL,'FAIRALL 0122',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'14.7r',0.23,'Bright nucleus',NULL,NULL,NULL,NULL,1,329.518583,-73.01378,0.129,NULL,49297802383,770278162,12035596,14.7),(152846,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152846,38.27,0.27,451,72577,70,NULL,NULL,'SDSS J215805.58-085329.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,329.5232917,-8.89156,0.085,NULL,49925713511,780089273,12188894,18.1),(152847,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152847,34.22,0.27,69.9,72578,NULL,NULL,NULL,'LCSB L0767O',NULL,'2009ApJS..182..474S',2009,1,1.17,NULL,'G',0.000023,NULL,'15.0g',0.41,'Sc',NULL,NULL,NULL,NULL,1,329.5240417,-7.84517,0.073,NULL,49923489001,780054515,12188351,15),(152848,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152848,34.26,0.2,71.1,72578,74.4,NULL,NULL,'LCSB L0767O',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152849,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152849,34.35,0.26,74,72578,NULL,NULL,'Malmquist cor.','LCSB L0767O',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152850,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152850,36.86,0.1,235,72579,70,NULL,NULL,'2MASX J21580665-0806428',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000063,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,329.527625,-8.11178,0.069,NULL,49923333907,780052092,12188313,16.7),(152851,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152851,33.55,NULL,51.4,72580,NULL,NULL,'Dipole','UGC 11859',NULL,'2010Ap&SS.325..163P',2010,1,3.47,'Multiple SDSS entries describe this object.','G',0.000012,NULL,'15.16',0.26,'Sc             HII','Isolated galaxy',NULL,NULL,NULL,1,329.530875,1.00897,0.177,NULL,52192771996,815512062,12742375,15.16),(152852,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152852,33.59,NULL,52.1,72580,NULL,NULL,'Dipole + Quadrupole','UGC 11859',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152853,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152853,33.6,NULL,52.4,72580,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11859',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152854,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152854,33.78,NULL,57.1,72580,NULL,NULL,NULL,'UGC 11859',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152855,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152855,36.86,0.1,235,72581,70,NULL,NULL,'2MASX J21580752-0755458',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00008,NULL,'16.1g',0.31,'S0/a',NULL,NULL,NULL,NULL,1,329.531291667,-7.92928,0.069,NULL,49923462701,780054104,12188345,16.1),(152856,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152856,38.32,0.46,461,72582,70,NULL,NULL,'2MASX J21581044-0702187',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,329.543417,-7.03853,0.065,NULL,49924628127,780072314,12188629,17.5),(152857,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152857,33.67,0.69,54.1,72583,100,NULL,'mid-IR','ESO 466-G 024',NULL,'2013ApJ...771...88L',2013,1,1.3,NULL,'G',0.00003,NULL,'13.0r',0.7,'(R\')SA(r)a     HII','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,329.5435417,-27.39214,0.033,NULL,51421736155,803464627,12554134,13),(152858,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152858,37.13,0.9,266,72584,70,NULL,NULL,'LCRS B215503.3-452033',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'15.1r',0.38,NULL,NULL,NULL,NULL,NULL,1,329.546791667,-45.10381,0,NULL,50646068174,791344815,12364762,15.1),(152859,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152859,38.27,0.27,451,72585,70,NULL,NULL,'2MASX J21581166-0844457',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000206,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,329.5485417,-8.74622,0.077,NULL,49925670472,780088601,12188884,17.4),(152860,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152860,48.47,1.54,7480,72586,100,NULL,NULL,'GRB 060927',5.6,'2009EPJC...63..139W',2009,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,329.5497083,5.36397,0.217,NULL,52315884946,817435702,12772432,NULL),(152861,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152861,48.62,1.47,8030,72586,100,NULL,NULL,'GRB 060927',5.6,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152862,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152862,35.5,0.59,126,72587,70,NULL,NULL,'2MASX J21581454-6938452',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,329.5605,-69.64592,0,NULL,49302265765,770347902,12036685,15.9),(152863,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152863,35.2,0.47,110,72588,NULL,NULL,'H','ESO 532- G 006',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000123,NULL,'14.90',0.4,'(R\'_1)SB(r\'l)a HII',NULL,NULL,NULL,NULL,1,329.563458333,-24.88844,0.085,NULL,51406689326,803229520,12550461,14.9),(152864,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152864,35.32,0.45,116,72588,NULL,NULL,'K','ESO 532- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152865,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152865,35.42,0.4,122,72588,NULL,NULL,'mean','ESO 532- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152866,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 20578','RN',152866,41.12,0.32,1300,72589,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20578',0.290371,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152867,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 20578','RN',152867,41.34,0.23,1440,72589,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20578',0.290371,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152868,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 20578','N',152868,40.95,0.19,1550,72589,70,NULL,'SALT 2','SDSS-II SN 20578',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152869,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 20578','N',152869,40.97,0.19,1560,72589,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20578',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152870,'Magnitude','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152870,37.09,0.13,262,72590,100,NULL,NULL,'2MASX J21582577-6023286',NULL,'1998A&A...337...31R',1998,1,0.59,NULL,'G',0.00022,NULL,'14.8r',0.28,'E/S0',NULL,NULL,NULL,NULL,1,329.6075,-60.39131,0,NULL,48685181509,760705961,11886030,14.8),(152871,'Magnitude','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152871,37.09,0.13,262,72591,100,NULL,NULL,'ABELL 3825',NULL,'1998A&A...337...31R',1998,1,NULL,'Katgert (1996,A&A,310,8) identifies multiple redshift systems in this cluster.','GClstr',NULL,NULL,NULL,NULL,'III    [BM];R  [A]',NULL,NULL,NULL,NULL,1,329.613333,-60.39944,0,NULL,48685183899,760705998,11886031,NULL),(152872,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152872,37.8,0.33,362,72592,70,NULL,NULL,'2MASX J21583578-0740079',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000083,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,329.64925,-7.66875,0.057,NULL,49923418080,780053407,12188334,17.9),(152873,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152873,36.95,0.57,246,72593,70,NULL,NULL,'2MASX J21583729-1207542',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.96',0.17,NULL,NULL,NULL,NULL,NULL,1,329.655417,-12.13186,0.077,NULL,49916415313,779943989,12186624,16.96),(152874,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152874,37.06,0.46,258,72594,70,NULL,NULL,'2MASX J21583900+0103492',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000143,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,329.662583333,1.06367,0.177,NULL,52192260512,815504070,12742251,17.6),(152875,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152875,37.7,0.46,347,72595,70,NULL,NULL,'2MASX J21583940-0722299',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,329.66425,-7.37503,0.073,NULL,49923842491,780060038,12188438,17.3),(152876,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152876,37.86,0.46,373,72596,70,NULL,NULL,'2MASX J21583982-0748259',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000083,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,329.666083,-7.80731,0.073,NULL,49923403214,780053175,12188330,17.1),(152877,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05793','RN',152877,41.4,0.19,1400,72597,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05793',0.357335,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152878,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152878,36.51,0.65,200,72598,70,NULL,NULL,'2MASX J21584349-1956463',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'15.6r',0.29,'S0',NULL,NULL,NULL,NULL,1,329.681125,-19.94625,0.049,NULL,50875137348,794924021,12420687,15.6),(152879,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152879,37.4,0.56,302,72599,70,NULL,NULL,'2MASX J21584357-0423154',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.45',NULL,NULL,NULL,NULL,NULL,NULL,1,329.6817083,-4.38769,0.169,NULL,49818115286,778408051,12162625,16.45),(152880,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152880,37.2,0.46,276,72600,70,NULL,NULL,'2MASX J21584365-0910068',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,329.681875,-9.16869,0.085,NULL,49917537370,779961521,12186898,16.6),(152881,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 02503','RN',152881,42.63,0.21,2120,72601,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02503',0.589348,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152882,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 15132','R',152882,39.43,0.18,672,72602,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006jt','SDSS-II SN 15132 HOST',0.144,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,329.6999583,0.19878,0.181,NULL,52183524062,815367563,12740118,NULL),(152883,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 15132','R',152883,39.71,0.08,765,72602,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006jt','SDSS-II SN 15132 HOST',0.144,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152884,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006jt',NULL,152884,39.42,0.07,766,72602,70,NULL,'SALT 2','SDSS-II SN 15132 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152885,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006jt',NULL,152885,39.42,0.07,766,72602,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15132 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152886,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006jt',NULL,152886,38.97,0.13,623,72603,70,NULL,'Hubble residual 0.18 for z0.14400','SDSS-II SN 15132 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,329.6999583,0.19878,0.181,NULL,52183524062,815367563,12740118,NULL),(152887,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 19465',NULL,152887,40.1,0.22,1050,72604,70,NULL,'SN photometric redshift distance, z photo =0.283 +/- 0.036','SDSS-II SN 19465',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,329.7062917,-0.85794,0.225,NULL,49825788972,778527952,12164499,NULL),(152888,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152888,46.24,0.55,4340,72605,69.7,NULL,'Calibrated','GRB 060607A',3.08,'2009MNRAS.400..775C',2009,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,329.71,-22.49631,0.057,NULL,50883937342,795061520,12422836,NULL),(152889,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152889,46.3,0.66,4460,72605,NULL,NULL,NULL,'GRB 060607A',3.08,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152890,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152890,46.33,0.58,4520,72605,72,NULL,NULL,'GRB 060607A',3.08,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152891,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152891,46.48,0.59,4850,72605,70,NULL,NULL,'GRB 060607A',3.08,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152892,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152892,46.68,0.58,5310,72605,69.7,NULL,'Fiducial','GRB 060607A',3.08,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152893,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152893,49.43,1.73,18900,72605,69.7,NULL,'Fiducial','GRB 060607A',3.08,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152894,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152894,38.53,0.33,508,72606,70,NULL,NULL,'2MASX J21585067+0001275',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000144,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,329.71125,0.02431,0.181,NULL,52183501479,815367210,12740112,18.8),(152895,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152895,38.64,0.46,533,72607,70,NULL,NULL,'SDSS J215850.81-080752.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000146,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,329.711708333,-8.13136,0.069,NULL,49923318578,780051852,12188310,18.8),(152896,'GeV TeV ratio','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152896,38.46,NULL,492,72608,72,NULL,NULL,'[HB89] 2155-304',NULL,'2010MNRAS.405L..76P',2010,1,NULL,NULL,'QSO',0.002,NULL,'14.',NULL,'Opt.var.       BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,329.7169583,-30.22558,0,NULL,51414449339,803350770,12552355,14),(152897,'GeV TeV ratio','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152897,39.56,0.09,817,72608,72,NULL,NULL,'[HB89] 2155-304',NULL,'2011arXiv1111.0913P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152898,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152898,38.53,0.33,508,72609,70,NULL,NULL,'2MASX J21585316+0000423',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000204,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,329.7214583,0.01175,0.181,NULL,52183502114,815367220,12740112,17.1),(152899,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152899,33.96,0.8,61.9,72610,75,NULL,'CF, r','UGC 11867',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.00002,NULL,'15.10',0.5,'Sbc',NULL,NULL,NULL,NULL,1,329.72475,-1.98931,0.257,NULL,49828309734,778567339,12165114,15.1),(152900,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152900,33.88,0.38,59.7,72610,75,NULL,'CF, r, raw','UGC 11867',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152901,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152901,33.88,0.2,59.7,72610,74.4,NULL,NULL,'UGC 11867',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152902,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152902,33.9,0.65,60.4,72610,NULL,NULL,'Malmquist cor.','UGC 11867',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152903,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152903,33.92,0.38,60.8,72610,75,NULL,'CF, r, inv','UGC 11867',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152904,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152904,34,0.62,63,72610,NULL,NULL,NULL,'UGC 11867',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152905,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152905,34.06,0.38,65,72610,75,NULL,'CF, r, cor','UGC 11867',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152906,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152906,34.17,0.8,68.1,72611,75,NULL,'MAT, I','IC 5149',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'14.41',0.5,'(R\')Sa','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,329.746,-27.41392,0.033,NULL,51421721208,803464393,12554131,14.41),(152907,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152907,34.41,0.43,76.1,72611,75,NULL,'MAT, I, raw','IC 5149',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152908,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152908,34.45,0.32,77.7,72611,85,NULL,'I, raw','IC 5149',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152909,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152909,34.51,0.32,79.7,72611,85,NULL,'I, inv','IC 5149',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152910,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152910,34.57,0.2,82,72611,74.4,NULL,NULL,'IC 5149',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152911,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152911,34.66,0.43,85.3,72611,75,NULL,'MAT, I, inv','IC 5149',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152912,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152912,34.68,0.43,86.2,72611,75,NULL,'MAT, I, cor','IC 5149',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152913,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 20095','RN',152913,43.69,0.35,3710,72612,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20095',0.47278,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152914,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152914,31.18,0.8,17.2,72613,75,NULL,NULL,'UGC 11868',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000017,NULL,'14.04',1.6,'SB(s)m',NULL,NULL,NULL,NULL,1,329.769541667,18.17744,0.261,NULL,52269998206,816718721,12761230,14.04),(152915,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152915,38.21,0.46,439,72614,70,NULL,NULL,'2MASX J21590583-0103349',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.58',0.18,NULL,NULL,NULL,NULL,NULL,1,329.774417,-1.05967,0.241,NULL,49825818794,778528418,12164506,18.58),(152916,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152916,35.92,0.7,152,72615,70,NULL,NULL,'2MASX J21590629-6938410',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'17.40',0.2,NULL,NULL,NULL,NULL,NULL,1,329.776375,-69.64469,0,NULL,49302248865,770347638,12036681,17.4),(152917,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05630','RN',152917,38.21,0.49,388,72616,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05630',0.131692,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152918,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05630','RN',152918,38.53,0.4,449,72616,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 05630',0.131692,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152919,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152919,37.28,0.46,286,72617,70,NULL,NULL,'2MASX J21590897-0658506',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000103,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,329.7874583,-6.98083,0.089,NULL,49924591055,780071735,12188620,16.5),(152920,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152920,37.8,0.33,362,72618,70,NULL,NULL,'SDSS J215911.29-073830.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000137,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,329.797083,-7.64183,0.057,NULL,49923361415,780052522,12188320,18.3),(152921,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152921,35.83,0.54,147,72619,70,NULL,NULL,'2MASX J21591191-1526016',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.40',NULL,'poss. LINER',NULL,NULL,NULL,NULL,1,329.799541667,-15.434,0.085,NULL,49793560346,778024380,12156630,15.4),(152922,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152922,34.4,0.8,76,72620,75,NULL,'MAT, I','ESO 466- G 028',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000023,NULL,'14.1r',0.5,'SAB(s)cd:',NULL,NULL,NULL,NULL,1,329.805583,-28.69006,0.045,NULL,51416960785,803390012,12552968,14.1),(152923,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152923,33.95,0.32,61.8,72620,85,NULL,'I, raw','ESO 466- G 028',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152924,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152924,33.98,0.32,62.6,72620,85,NULL,'I, inv','ESO 466- G 028',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152925,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152925,34.04,0.43,64.3,72620,75,NULL,'MAT, I, raw','ESO 466- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152926,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152926,34.19,0.43,68.8,72620,75,NULL,'MAT, I, inv','ESO 466- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152927,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152927,34.29,0.43,72.3,72620,75,NULL,'MAT, I, cor','ESO 466- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152928,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152928,34.38,0.2,75.2,72620,74.4,NULL,NULL,'ESO 466- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152929,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152929,34.46,0.49,77.9,72620,75,NULL,'IR','ESO 466- G 028',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152930,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152930,34.47,0.44,78.2,72620,NULL,NULL,'Malmquist cor.','ESO 466- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152931,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152931,34.61,0.41,83.4,72620,NULL,NULL,NULL,'ESO 466- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152932,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 01132','RN',152932,42.03,0.2,1870,72621,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 01132',0.359774,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152933,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 01132','RN',152933,42.06,0.13,1900,72621,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 01132',0.359774,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152934,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 17394','RN',152934,39.86,0.14,848,72622,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 17394',0.107332,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152935,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 17394','RN',152935,40.07,0.21,933,72622,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 17394',0.107332,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152936,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152936,32.7,0.8,34.7,72623,75,NULL,'MAT, I','NGC 7163',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'13.76',1.1,'SB?(r)b?       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,329.835167,-31.88317,0,NULL,51459979539,804062180,12563471,13.76),(152937,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152937,31.66,0.32,21.5,72623,85,NULL,'I, raw','NGC 7163',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152938,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152938,31.67,0.32,21.6,72623,85,NULL,'I, inv','NGC 7163',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152939,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152939,31.95,0.43,24.5,72623,75,NULL,'MAT, I, raw','NGC 7163',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152940,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152940,32.01,0.43,25.2,72623,75,NULL,'MAT, I, inv','NGC 7163',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152941,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152941,32.29,0.47,28.7,72623,NULL,NULL,'H','NGC 7163',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152942,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152942,32.32,0.43,29.1,72623,75,NULL,'MAT, I, cor','NGC 7163',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152943,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152943,32.34,0.45,29.4,72623,NULL,NULL,'K','NGC 7163',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152944,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152944,32.38,0.46,30,72623,NULL,NULL,'J','NGC 7163',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152945,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152945,32.53,0.09,32.1,72623,NULL,NULL,NULL,'NGC 7163',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152946,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152946,32.68,0.4,34.4,72623,NULL,NULL,'mean','NGC 7163',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152947,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152947,36.22,0.58,176,72624,70,NULL,NULL,'2MASX J21592046-5626051',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'14.5r',0.5,'E',NULL,NULL,NULL,NULL,1,329.83525,-56.43483,0,NULL,48719450429,761241412,11894397,14.5),(152948,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152948,38.29,0.46,456,72625,70,NULL,NULL,'SDSS J215920.49-081432.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000144,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,329.835375,-8.24233,0.069,NULL,49923620558,780056571,12188383,18.2),(152949,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152949,38.51,0.46,503,72626,70,NULL,NULL,'2MASX J21592081+0115048',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,329.836667,1.25125,0.161,NULL,52192331841,815505185,12742268,18.2),(152950,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 13734',NULL,152950,39.96,1.63,982,72627,70,NULL,'SN photometric redshift distance, z photo =0.263 +/- 0.436','SDSS-II SN 13734',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','22.6g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,329.8380417,1.01058,0.161,NULL,52184062907,815375982,12740249,22.6),(152951,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 13734','R',152951,41.11,0.34,1210,72627,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13734',0.378459,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152952,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 13734','R',152952,41.35,0.39,1350,72627,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13734',0.378459,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152953,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152953,36.78,0.33,227,72628,70,NULL,NULL,'2MASX J21592117-0750484',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00015,NULL,'16.1g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,329.838125,-7.84689,0.073,NULL,49923516914,780054951,12188358,16.1),(152954,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152954,37.87,0.58,375,72628,70,NULL,NULL,'2MASX J21592117-0750484',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152955,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 02063','R',152955,40,0.09,837,72629,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 02063',0.192931,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,329.849125,-1.1075,0.241,NULL,49825811030,778528297,12164504,NULL),(152956,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 02063','R',152956,40.32,0.19,970,72629,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 02063',0.192931,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152957,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152957,34.3,0.8,72.4,72630,75,NULL,'MAT, I','IC 5147',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'15.06',0.6,'SB(r)bc',NULL,NULL,NULL,NULL,1,329.859667,-65.44986,0.021,NULL,49343920763,770998761,12046855,15.06),(152958,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152958,34.17,0.32,68.2,72630,85,NULL,'I, raw','IC 5147',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152959,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152959,34.19,0.32,68.8,72630,85,NULL,'I, inv','IC 5147',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152960,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152960,34.19,0.43,68.9,72630,75,NULL,'MAT, I, raw','IC 5147',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152961,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152961,34.29,0.43,72.3,72630,75,NULL,'MAT, I, inv','IC 5147',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152962,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152962,34.66,0.43,85.3,72630,75,NULL,'MAT, I, cor','IC 5147',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152963,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152963,36.78,0.33,227,72631,70,NULL,NULL,'2MASX J21592702-0746594',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000103,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,329.8627083,-7.78306,0.057,NULL,49923495491,780054617,12188353,16.8),(152964,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 17586','RN',152964,40.27,0.32,891,72632,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17586',0.273141,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152965,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 17586','RN',152965,40.36,0.25,926,72632,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17586',0.273141,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152966,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152966,35.27,NULL,113,72633,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2356',NULL,'2010Ap&SS.325..163P',2010,1,0.91,NULL,'G',0.000018,NULL,'16.4',0.11,'Scd',NULL,NULL,NULL,NULL,1,329.880083333,6.55525,0.197,NULL,52333049855,817703903,12776623,16.4),(152967,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152967,35.28,NULL,114,72633,NULL,NULL,'Dipole + Quadrupole','FGC 2356',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152968,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152968,35.31,NULL,115,72633,NULL,NULL,'Dipole','FGC 2356',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152969,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152969,35.43,NULL,122,72633,NULL,NULL,NULL,'FGC 2356',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152970,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 09477','RN',152970,37.86,0.43,339,72634,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 09477',0.100901,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152971,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 09477','RN',152971,38.05,0.36,370,72634,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 09477',0.100901,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152972,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152972,38.03,0.46,403,72635,70,NULL,NULL,'2MASX J21593215+0109399',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,329.883833333,1.16119,0.161,NULL,52192300991,815504702,12742260,18),(152973,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152973,36.16,0.58,170,72636,70,NULL,NULL,'2MASX J21593548-5447293',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,329.89775,-54.7915,0,NULL,48692000478,760812507,11887695,14.1),(152974,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152974,35.31,0.53,115,72637,70,NULL,NULL,'2MASX J21593694-5612273',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.5r',0.45,'E',NULL,NULL,NULL,NULL,1,329.903875,-56.20758,0,NULL,48719363957,761240061,11894375,14.5),(152975,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16441','RN',152975,41.38,0.17,1460,72638,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16441',0.2915,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152976,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16441','RN',152976,41.42,0.4,1490,72638,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16441',0.2915,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152977,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152977,32.27,0.8,28.4,72639,75,NULL,'B','NGC 7162',NULL,'1988NBGC.C....0000T',1988,1,2.8,'The APMBGC position is 17 arcsec south of the nucleus.','G',0.00002,NULL,'13.29',1,'(R\')SA(r)bc    LINER','in a pair',NULL,NULL,NULL,1,329.9130417,-43.30597,0,NULL,50673689487,791776398,12371506,13.29),(152978,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152978,32.55,0.4,32.4,72639,NULL,NULL,'mean','NGC 7162',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152979,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152979,32.79,0.46,36.1,72639,NULL,NULL,'J','NGC 7162',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152980,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152980,32.83,0.47,36.8,72639,NULL,NULL,'H','NGC 7162',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152981,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152981,32.93,0.45,38.5,72639,NULL,NULL,'K','NGC 7162',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152982,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152982,38.02,0.46,402,72640,70,NULL,NULL,'2MASX J21594302+1120107',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,329.9292083,11.33636,0.237,NULL,52282405064,816912579,12764259,18),(152983,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152983,34.77,0.48,89.9,72641,70,NULL,NULL,'2MASX J21594326-7012136',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'14.4r',0.5,'S',NULL,NULL,NULL,NULL,1,329.930417,-70.20375,0.025,NULL,49302988325,770359192,12036862,14.4),(152984,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152984,37.08,0.54,260,72642,70,NULL,NULL,'2MASX J21594415-1528439',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.88',0.4,NULL,NULL,NULL,NULL,NULL,1,329.934,-15.479,0.085,NULL,49793583038,778024734,12156636,15.88),(152985,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 20051','RN',152985,40.54,0.15,1040,72643,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007pv','SDSS-II SN 20051',0.235152,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152986,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 20051','RN',152986,40.79,0.25,1160,72643,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007pv','SDSS-II SN 20051',0.235152,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152987,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 20051','N',152987,40.49,0.13,1250,72643,70,NULL,'SALT 2','SDSS-II SN 20051',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152988,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 20051','N',152988,40.51,0.13,1260,72643,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20051',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152989,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152989,35.91,0.51,152,72644,70,NULL,NULL,'2MASX J21594545-4653343',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.7r',0.28,'E',NULL,NULL,NULL,NULL,1,329.9394583,-46.89292,0,NULL,50654131519,791470804,12366731,14.7),(152990,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152990,36.24,0.53,177,72645,70,NULL,NULL,'2MASX J21594642-1752379',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'15.4r',0.22,NULL,NULL,NULL,NULL,NULL,1,329.943583,-17.87731,0.069,NULL,49785893613,777904587,12154759,15.4),(152991,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006oo',NULL,152991,40.22,0.27,863,72646,72,NULL,'SDSS 16442','SDSS J215947.23-004359.6',0.28,'2009ApJ...704.1036F',2009,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,329.946791667,-0.73322,0.161,NULL,49821928782,778467637,12163556,NULL),(152992,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16442','R',152992,40.52,0.29,991,72646,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006oo','SDSS J215947.23-004359.6',0.28,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152993,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16442','R',152993,40.67,0.16,1060,72646,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006oo','SDSS J215947.23-004359.6',0.28,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152994,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006oo',NULL,152994,40.31,0.14,1150,72646,70,NULL,'SALT 2','SDSS J215947.23-004359.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152995,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006oo',NULL,152995,40.34,0.14,1170,72646,70,NULL,'SALT 2, Malmquist cor.','SDSS J215947.23-004359.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152996,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 01278','RN',152996,39.32,0.06,576,72647,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01278',0.271673,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152997,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005lk',NULL,152997,37.77,0.12,324,72648,74.2,NULL,'SALT 2','2MFGC 16592',0.104,'2010ApJ...716..712A',2010,1,0.56,NULL,'G',NULL,'PHOT','18.06',0.12,NULL,NULL,NULL,NULL,NULL,1,329.957208333,-1.19242,0.241,NULL,49825730002,778527031,12164484,18.06),(152998,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005lk',NULL,152998,38.21,0.04,398,72648,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 10434, SN 2005lk','2MFGC 16592',0.104,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152999,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005lk',NULL,152999,38.5,0.13,454,72648,70,NULL,'SALT 2','2MFGC 16592',0.104,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153000,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 10434','R',153000,38.51,0.18,456,72648,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005lk','2MFGC 16592',0.104161,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153001,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005lk',NULL,153001,38.58,NULL,471,72648,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 10434, SN 2005lk','2MFGC 16592',0.104,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153002,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005lk',NULL,153002,38.44,0.07,488,72648,70,NULL,'SALT 2','2MFGC 16592',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153003,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005lk',NULL,153003,38.44,0.07,488,72648,70,NULL,'SALT 2, Malmquist cor.','2MFGC 16592',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153004,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 10434','R',153004,38.67,0.11,492,72648,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005lk','2MFGC 16592',0.104161,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153005,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',153005,38.1,0.46,417,72649,70,NULL,NULL,'2MASX J21595501-0038034',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,329.97925,-0.63439,0.161,NULL,49822005681,778468838,12163575,17.9),(153006,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,153006,36.53,0.66,203,72650,70,NULL,NULL,'ESO 075- G 046',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.41',0.5,'(R_1)SB(r)a',NULL,NULL,NULL,NULL,1,330.0024583,-71.66122,0.017,NULL,49307469089,770429204,12037956,15.41),(153007,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',153007,38.18,0.46,432,72651,70,NULL,NULL,'2MASX J22000112+0025086',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,330.0047083,0.41908,0.193,NULL,52184435738,815381808,12740340,17.4),(153008,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,153008,35.94,0.52,154,72652,70,NULL,NULL,'MCG -02-56-002',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000147,NULL,'15.21',0.4,'poss. LINER',NULL,NULL,NULL,NULL,1,330.00875,-13.795,0.093,NULL,49781855342,777841489,12153773,15.21),(153009,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',153009,38.07,0.46,411,72653,70,NULL,NULL,'2MASX J22000481-0804460',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,330.02,-8.07939,0.069,NULL,49923744810,780058512,12188414,17.2),(153010,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',153010,37.68,0.27,344,72654,70,NULL,NULL,'2MASX J22000942-0717599',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,330.03925,-7.30014,0.085,NULL,49924223594,780065993,12188531,17.8),(153011,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',153011,37.68,0.27,344,72655,70,NULL,NULL,'2MASX J22000963-0718229',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,330.040125,-7.30656,0.085,NULL,49924216214,780065878,12188529,17.7),(153012,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',153012,37.68,0.27,344,72656,70,NULL,NULL,'2MASX J22001467-0719109',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,330.0612917,-7.31967,0.085,NULL,49924215972,780065874,12188529,17.3),(153013,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',153013,37.97,0.46,392,72657,70,NULL,NULL,'SDSS J220016.22-073347.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000159,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,330.067625,-7.56328,0.073,NULL,49924171085,780065173,12188518,18.5),(153014,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 06289','RN',153014,40.76,0.12,1280,72658,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 06289',0.110404,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153015,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 06289','RN',153015,41.19,0.22,1560,72658,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 06289',0.110404,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153016,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 14224','RN',153016,39.42,0.16,678,72659,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14224',0.128182,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153017,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 14224','RN',153017,40.01,0.22,889,72659,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 14224',0.128182,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153018,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 15455','R',153018,41.89,0.29,1700,72660,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15455',0.407071,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,330.0804583,-1.05142,0.225,NULL,49821502498,778460976,12163452,NULL),(153019,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 15455','R',153019,41.98,0.27,1770,72660,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15455',0.407071,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153020,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 15455',NULL,153020,41.3,0.22,1820,72660,70,NULL,'SN photometric redshift distance, z photo =0.575 +/- 0.093','SDSS-II SN 15455',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153021,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 15455',NULL,153021,41.8,0.19,2290,72660,70,NULL,'SALT 2','SDSS-II SN 15455',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153022,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 15455',NULL,153022,41.87,0.19,2370,72660,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15455',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153023,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,153023,34.62,0.45,83.9,72661,NULL,NULL,'Malmquist cor.','IC 1417',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000017,NULL,'14.36',0.4,'Sb? sp         Sy2','Line-of-sight pair member',NULL,NULL,'Sy 2',1,330.0900417,-13.14736,0.101,NULL,49778896513,777795258,12153050,14.36),(153024,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,153024,35.01,0.38,100,72661,NULL,NULL,NULL,'IC 1417',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153025,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,153025,35.05,0.2,102,72661,74.4,NULL,NULL,'IC 1417',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153026,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',153026,36.86,0.1,235,72662,70,NULL,NULL,'2MASX J22002270-0729495',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,330.094625,-7.497,0.085,NULL,49924176278,780065254,12188519,17.5),(153027,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',153027,38.95,0.46,618,72663,70,NULL,NULL,'SDSS J220024.74+005849.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000197,NULL,'18.1g',0.18,'Candidate      BLAGN',NULL,NULL,NULL,NULL,1,330.103125,0.98031,0.161,NULL,52184215521,815378367,12740286,18.1),(153028,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 09377','RN',153028,36.93,0.35,216,72664,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 09377',0.126098,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153029,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,153029,35.28,0.6,114,72665,70,NULL,NULL,'2MASX J22002578-4636072',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.0I',0.3,NULL,NULL,NULL,NULL,NULL,1,330.1072917,-46.602,0,NULL,50650727549,791417617,12365900,14),(153030,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,153030,33.96,0.47,61.9,72666,NULL,NULL,'H','ESO 404- G 015',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00008,NULL,'14.36',0.3,'S?             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,330.122333,-33.37161,0,NULL,50558963247,789983800,12343496,14.36),(153031,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,153031,33.99,0.4,62.7,72666,NULL,NULL,'mean','ESO 404- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153032,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,153032,34.06,0.46,64.7,72666,NULL,NULL,'J','ESO 404- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153033,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,153033,34.06,0.45,64.9,72666,NULL,NULL,'K','ESO 404- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153034,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,153034,32.36,0.46,29.7,72667,NULL,NULL,'J','NGC 7167',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000007,NULL,'12.87',1.3,'SB(s)c:        HII',NULL,NULL,NULL,NULL,1,330.127667,-24.63261,0.065,NULL,51407300343,803239067,12550610,12.87),(153035,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,153035,32.42,0.47,30.4,72667,NULL,NULL,'H','NGC 7167',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153036,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,153036,32.45,0.45,30.9,72667,NULL,NULL,'K','NGC 7167',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153037,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,153037,32.62,0.4,33.4,72667,NULL,NULL,'mean','NGC 7167',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153038,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 01305','RN',153038,39.64,0.1,771,72668,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 01305',0.09786,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153039,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 01305','RN',153039,40.04,0.2,929,72668,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 01305',0.09786,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153040,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153040,38.11,0.27,419,72669,70,NULL,NULL,'2MASX J22003134+0035417',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,330.1305,0.59497,0.177,NULL,52184275529,815379305,12740301,18),(153041,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153041,35.5,0.58,126,72670,70,NULL,NULL,'2MASX J22003223-5800453',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.31',0.33,NULL,NULL,NULL,NULL,NULL,1,330.134375,-58.01267,0,NULL,48718019763,761219058,11894047,16.31),(153042,'Faber-Jackson','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153042,31.73,0.63,22.2,72671,95,NULL,'Michard 1979b, c','NGC 7166',NULL,'1984ApJS...56...91D',1984,1,2.5,NULL,'G',0.00008,NULL,'12.85',0.9,'SA0^-','in a pair',NULL,NULL,NULL,1,330.137167,-43.38972,0,NULL,50674448399,791788256,12371691,12.85),(153043,'Faber-Jackson','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153043,31.87,0.37,23.7,72671,95,NULL,'Weighted Mean','NGC 7166',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153044,'Faber-Jackson','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153044,32.05,0.46,25.7,72671,95,NULL,'Michard 1979a','NGC 7166',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153045,'Faber-Jackson','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153045,34.42,0.81,76.6,72671,55,NULL,'Visvanathan & Sandage 1979','NGC 7166',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153046,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153046,33.3,0.52,45.8,72671,70,NULL,NULL,'NGC 7166',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153047,'Tertiary','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153047,31.55,0.71,20.4,72671,95,NULL,NULL,'NGC 7166',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153048,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153048,32.4,0.8,30.2,72671,75,NULL,'B','NGC 7166',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153049,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153049,37.59,0.46,330,72672,70,NULL,NULL,'2MASX J22003356-0824465',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000174,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,330.139791667,-8.41286,0.069,NULL,49922800175,780043752,12188183,16.5),(153050,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153050,37.51,0.33,318,72673,70,NULL,NULL,'2MASX J22003561+0103327',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000141,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,330.148417,1.05914,0.149,NULL,52184183573,815377868,12740279,17.7),(153051,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153051,32.25,0.8,28.1,72674,75,NULL,'MAT, I','NGC 7162A',NULL,'1997ApJS..109..333W',1997,1,2.6,'The APMBGC position is 8 arcsec northwest of the center of the bar.','G',0.00001,NULL,'13.1',2.3,'SB(s)m','in a pair',NULL,NULL,NULL,1,330.1489583,-43.14172,0,NULL,50673661840,791775966,12371499,13.1),(153052,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153052,30.88,0.32,15,72674,85,NULL,'I, inv','NGC 7162A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153053,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153053,30.92,0.32,15.3,72674,85,NULL,'I, raw','NGC 7162A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153054,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153054,31.5,0.4,20,72674,NULL,NULL,NULL,'NGC 7162A',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153055,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153055,31.51,0.4,20,72674,73,NULL,'opt','NGC 7162A',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153056,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153056,32.28,0.4,28.6,72674,75,NULL,'B','NGC 7162A',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153057,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153057,32.44,0.09,30.8,72674,NULL,NULL,NULL,'NGC 7162A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153058,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153058,32.64,0.43,33.8,72674,75,NULL,'MAT, I, raw','NGC 7162A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153059,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153059,32.71,0.43,34.8,72674,75,NULL,'MAT, I, inv','NGC 7162A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153060,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153060,32.79,0.43,36.1,72674,75,NULL,'MAT, I, cor','NGC 7162A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153061,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 00694','RN',153061,38.73,0.18,495,72675,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 00694',0.127493,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153062,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 00694','RN',153062,39.02,0.08,565,72675,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 00694',0.127493,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153063,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153063,36.08,0.2,164,72676,74.4,NULL,NULL,'CGCG 428-012',NULL,'2013AJ....146...86T',2013,1,0.61,NULL,'G',0.000155,NULL,'15.5g',0.35,'Sb',NULL,NULL,NULL,NULL,1,330.160666667,11.37433,0.237,NULL,52282425863,816912904,12764264,15.5),(153064,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153064,34.62,0.49,83.9,72677,75,NULL,'IR','UGC 11873',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000017,NULL,'16.0',0.2,'S?',NULL,NULL,NULL,NULL,1,330.169458333,19.66794,0.293,NULL,52218455690,815913370,12748646,16),(153065,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153065,34.98,0.47,99.1,72677,NULL,NULL,NULL,'UGC 11873',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153066,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153066,35.01,0.2,100,72677,74.4,NULL,NULL,'UGC 11873',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153067,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153067,35.16,0.43,108,72677,NULL,NULL,'Malmquist cor.','UGC 11873',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153068,'Ring Diameter','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153068,33.3,0.98,46,72678,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7177',NULL,'1981ApJS...45..541P',1981,1,3.1,NULL,'G',0.000003,NULL,'12.01',2,'SAB(r)b; HII   LINER',NULL,NULL,NULL,NULL,1,330.171833,17.73806,0.233,NULL,52271884394,816748193,12761690,12.01),(153069,'Ring Diameter','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153069,33.5,0.76,51,72678,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7177',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153070,'Sosies','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153070,31.56,0.14,20.5,72678,NULL,NULL,NULL,'NGC 7177',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153071,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153071,31.3,0.8,18.2,72678,75,NULL,'B','NGC 7177',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153072,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153072,30.59,0.69,13.1,72678,100,NULL,'mid-IR','NGC 7177',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153073,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153073,31.54,NULL,20.3,72678,NULL,NULL,'B','NGC 7177',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153074,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153074,31.85,0.4,23.4,72678,NULL,NULL,NULL,'NGC 7177',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153075,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153075,31.96,0.2,24.7,72678,74.4,NULL,NULL,'NGC 7177',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153076,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153076,31.97,0.38,24.8,72678,NULL,NULL,'Malmquist cor.','NGC 7177',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153077,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153077,31.99,0.43,25,72678,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7177',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153078,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153078,32.03,0.43,25.4,72678,75,NULL,'3.6 micron, color corrected','NGC 7177',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153079,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153079,35.08,0.47,104,72679,NULL,NULL,'H','UGC 11871',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'GPair',0.000033,NULL,NULL,NULL,'Sb             Sy1.9','Isolated galaxy',NULL,NULL,NULL,1,330.174583,10.54972,0.201,NULL,52283622458,816931600,12764556,NULL),(153080,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153080,35.12,0.45,106,72679,NULL,NULL,'K','UGC 11871',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153081,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153081,35.2,0.4,109,72679,NULL,NULL,'mean','UGC 11871',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153082,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153082,35.27,0.46,113,72679,NULL,NULL,'J','UGC 11871',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153083,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153083,35.03,0.57,102,72680,70,NULL,NULL,'2MASX J22004272-4649062',NULL,'2014MNRAS.445.2677S',2014,1,0.22,NULL,'G',0.00015,NULL,'16.5b',0.19,NULL,NULL,NULL,NULL,NULL,1,330.178083,-46.81842,0,NULL,50650920007,791420625,12365947,16.5),(153084,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153084,35.75,0.55,141,72681,70,NULL,NULL,'2MASX J22004433-5506302',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'16.29',0.25,'E',NULL,NULL,NULL,NULL,1,330.184625,-55.10833,0,NULL,48710865071,761107266,11892301,16.29),(153085,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 06895','R',153085,39.86,0.2,769,72682,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J220046.28+005541.4',0.2174,'2014arXiv1401.3317S',2014,1,0.15,NULL,'G',0.0005,NULL,'19.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,330.192875,0.92817,0.165,NULL,52184140787,815377199,12740268,19),(153086,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 06895','R',153086,39.86,0.13,771,72682,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J220046.28+005541.4',0.2174,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153087,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 06895',NULL,153087,39.68,0.09,863,72682,70,NULL,'SALT 2','SDSS J220046.28+005541.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153088,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 06895',NULL,153088,39.7,0.09,871,72682,70,NULL,'SALT 2, Malmquist cor.','SDSS J220046.28+005541.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153089,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153089,37.45,0.46,310,72683,70,NULL,NULL,'2MASX J22004743-0720543',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000156,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,330.197625,-7.34831,0.085,NULL,49924261376,780066584,12188540,17.2),(153090,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153090,37.86,0.46,372,72684,70,NULL,NULL,'2MASX J22005061-0034031',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00015,NULL,'17.0g',0.26,'BrClG',NULL,NULL,NULL,NULL,1,330.210833,-0.56767,0.165,NULL,49821655197,778463362,12163490,17),(153091,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153091,35.51,0.47,126,72685,70,NULL,NULL,'CGCG 377-011',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00009,NULL,'15.3',NULL,NULL,NULL,NULL,NULL,NULL,1,330.2127083,-1.83931,0.249,NULL,49824431209,778506737,12164167,15.3),(153092,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 03049','R',153092,39.65,0.2,731,72686,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 03049',0.166701,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,330.223417,-1.23658,0.201,NULL,49821279513,778457492,12163398,NULL),(153093,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 03049','R',153093,39.93,0.14,828,72686,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 03049',0.166701,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153094,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153094,37.51,0.33,318,72687,70,NULL,NULL,'2MASX J22005462+0111577',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000144,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,330.2275417,1.19947,0.149,NULL,52184005296,815375082,12740235,17.3),(153095,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153095,32.49,0.8,31.5,72688,75,NULL,'MAT, I','ESO 404- G 017',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000017,NULL,'15.03',0.6,'SB(s)dm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,330.2327917,-35.287,0,NULL,50559472616,789991759,12343621,15.03),(153096,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153096,32.6,0.1,33.2,72688,NULL,NULL,NULL,'ESO 404- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153097,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153097,32.96,0.32,39.1,72688,85,NULL,'I, inv','ESO 404- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153098,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153098,32.98,0.4,39.4,72688,NULL,NULL,NULL,'ESO 404- G 017',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153099,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153099,32.98,0.32,39.4,72688,85,NULL,'I, raw','ESO 404- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153100,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153100,33.11,0.2,41.9,72688,74.4,NULL,NULL,'ESO 404- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153101,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153101,33.23,0.43,44.3,72688,75,NULL,'3.6 micron, color corrected','ESO 404- G 017',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153102,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153102,33.32,0.43,46.1,72688,75,NULL,'MAT, I, raw','ESO 404- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153103,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153103,33.32,0.43,46.2,72688,75,NULL,'MAT, I, inv','ESO 404- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153104,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153104,33.35,0.43,46.8,72688,75,NULL,'3.6 micron, color + selection bias corrected','ESO 404- G 017',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153105,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153105,33.55,0.43,51.4,72688,75,NULL,'MAT, I, cor','ESO 404- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153106,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153106,36.15,0.51,170,72689,70,NULL,NULL,'2MASX J22005597-1412037',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.5,NULL,NULL,NULL,NULL,NULL,1,330.233167,-14.20097,0.085,NULL,49782185038,777846641,12153853,13.9),(153107,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 20545','R',153107,39.67,0.19,723,72690,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J220100.11-002526.4',0.1895,'2014arXiv1401.3317S',2014,1,0.1,NULL,'G',0.01,NULL,'19.9g',0.08,NULL,NULL,NULL,NULL,NULL,1,330.2505,-0.424,0.133,NULL,49821696669,778464010,12163500,19.9),(153108,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 20545','R',153108,39.76,0.13,754,72690,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J220100.11-002526.4',0.1895,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153109,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 20545',NULL,153109,39.44,0.09,773,72690,70,NULL,'SALT 2','SDSS J220100.11-002526.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153110,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 20545',NULL,153110,39.45,0.09,776,72690,70,NULL,'SALT 2, Malmquist cor.','SDSS J220100.11-002526.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153111,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 06896',NULL,153111,40.12,0.32,1060,72691,70,NULL,'SN photometric redshift distance, z photo =0.287 +/- 0.055','SDSS-II SN 06896',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','20.4g',0.07,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,330.2537917,1.01675,0.201,NULL,52184119040,815376860,12740263,20.4),(153112,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 06896','R',153112,40.94,0.25,1150,72691,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06896',0.33504,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153113,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 06896','R',153113,41.26,0.35,1340,72691,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06896',0.33504,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153114,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 06896',NULL,153114,41.11,0.22,1670,72691,70,NULL,'SALT 2','SDSS-II SN 06896',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153115,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 06896',NULL,153115,41.15,0.22,1700,72691,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 06896',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153116,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 12855','R',153116,39.41,0.21,656,72692,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006fk','SDSS J220101.33+004258.5',0.16,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,330.255541667,0.71625,0.165,NULL,52184234731,815378667,12740291,NULL),(153117,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SN 2006fk',NULL,153117,39.42,0.18,661,72692,72,NULL,'SDSS 12855','SDSS J220101.33+004258.5',0.16,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153118,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 12855','R',153118,39.64,0.1,730,72692,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006fk','SDSS J220101.33+004258.5',0.16,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153119,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153119,32.68,0.8,34.4,72693,75,NULL,'MAT, I','NGC 7171',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.000019,NULL,'13.23',1.5,'SB(rs)b        HII','Line-of-sight pair member',NULL,NULL,NULL,1,330.258375,-13.26975,0.081,NULL,49778607404,777790740,12152980,13.23),(153120,'Sosies','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153120,33.29,0.1,45.5,72693,NULL,NULL,NULL,'NGC 7171',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153121,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153121,32.7,0.8,34.7,72693,75,NULL,'B','NGC 7171',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153122,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153122,32.92,0.4,38.4,72693,NULL,NULL,'mean','NGC 7171',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153123,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153123,32.97,0.32,39.2,72693,85,NULL,'I, raw','NGC 7171',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153124,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153124,33.02,0.43,40.2,72693,75,NULL,'MAT, I, raw','NGC 7171',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153125,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153125,33.02,0.32,40.2,72693,85,NULL,'I, inv','NGC 7171',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153126,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153126,33.04,0.4,40.6,72693,NULL,NULL,NULL,'NGC 7171',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153127,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153127,33.08,0.46,41.2,72693,NULL,NULL,'J','NGC 7171',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153128,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153128,33.08,0.47,41.3,72693,NULL,NULL,'H','NGC 7171',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153129,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153129,33.12,0.43,42.1,72693,75,NULL,'3.6 micron, color corrected','NGC 7171',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153130,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153130,33.13,0.2,42.3,72693,74.4,NULL,NULL,'NGC 7171',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153131,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153131,33.13,0.45,42.3,72693,NULL,NULL,'K','NGC 7171',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153132,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153132,33.2,0.43,43.6,72693,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7171',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153133,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153133,33.26,0.43,44.8,72693,75,NULL,'MAT, I, inv','NGC 7171',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153134,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153134,33.39,0.43,47.7,72693,75,NULL,'MAT, I, cor','NGC 7171',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153135,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153135,36.86,0.46,236,72694,70,NULL,NULL,'2MASX J22010357-0715373',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00015,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,330.264875,-7.26044,0.073,NULL,49924032062,780063000,12188484,16.6),(153136,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153136,36.18,0.49,172,72695,70,NULL,NULL,'2MASX J22010427-1442268',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.47',NULL,NULL,NULL,NULL,NULL,NULL,1,330.267917,-14.70747,0.085,NULL,49781308280,777832941,12153639,15.47),(153137,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153137,35.04,0.52,102,72696,70,NULL,NULL,'2MASX J22010504-0447502',NULL,'2014MNRAS.445.2677S',2014,1,0.94,NULL,'G',0.00015,NULL,'15.46',0.6,NULL,NULL,NULL,NULL,NULL,1,330.271,-4.79736,0.165,NULL,49816450880,778382045,12162219,15.46),(153138,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153138,31.68,0.43,21.7,72697,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J22010637+7156385',NULL,'2014MNRAS.444..527S',2014,1,1.68,NULL,'G',0.00002,NULL,'9.34K',1.56,'Spiral LSB',NULL,NULL,NULL,NULL,1,330.2767083,71.944,2.529,NULL,53516752152,836199252,13065613,9.34),(153139,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153139,36.36,0.7,187,72698,70,NULL,NULL,'2MASX J22010717-7244231',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'16.8b',0.11,NULL,NULL,NULL,NULL,NULL,1,330.2797917,-72.73972,0.129,NULL,49297926350,770280099,12035626,16.8),(153140,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153140,35.69,0.64,138,72699,70,NULL,NULL,'2MASX J22010777-1105363',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.00',0.45,NULL,NULL,NULL,NULL,NULL,1,330.282333333,-11.0935,0.105,NULL,49870950370,779233599,12175524,16),(153141,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153141,32.26,0.8,28.4,72700,75,NULL,'MAT, I','ESO 404- G 018',NULL,'1997ApJS..109..333W',1997,1,2.97,NULL,'G',0.00001,NULL,'15.38',0.22,'SB(s)d? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,330.292333,-32.57881,0,NULL,50558396949,789974952,12343358,15.38),(153142,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153142,31.22,0.32,17.5,72700,85,NULL,'I, inv','ESO 404- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153143,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153143,31.26,0.32,17.9,72700,85,NULL,'I, raw','ESO 404- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153144,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153144,31.57,0.43,20.7,72700,75,NULL,'MAT, I, inv','ESO 404- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153145,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153145,31.69,0.43,21.8,72700,75,NULL,'MAT, I, raw','ESO 404- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153146,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153146,32.08,0.43,26.1,72700,75,NULL,'MAT, I, cor','ESO 404- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153147,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153147,32.16,0.4,27,72700,NULL,NULL,NULL,'ESO 404- G 018',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153148,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153148,32.16,0.4,27,72700,73,NULL,'opt','ESO 404- G 018',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153149,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153149,32.3,0.2,28.8,72700,74.4,NULL,NULL,'ESO 404- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153150,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153150,32.34,NULL,29.4,72700,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 404- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153151,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153151,32.36,NULL,29.6,72700,NULL,NULL,'Dipole + Quadrupole','ESO 404- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153152,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153152,32.36,NULL,29.7,72700,NULL,NULL,'Dipole','ESO 404- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153153,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153153,32.55,0.43,32.3,72700,75,NULL,'3.6 micron, color corrected','ESO 404- G 018',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153154,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153154,32.56,NULL,32.5,72700,NULL,NULL,NULL,'ESO 404- G 018',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153155,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153155,32.61,0.13,33.3,72700,NULL,NULL,NULL,'ESO 404- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153156,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153156,32.69,0.43,34.5,72700,75,NULL,'3.6 micron, color + selection bias corrected','ESO 404- G 018',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153157,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153157,38.15,0.33,426,72701,70,NULL,NULL,'SDSS J220111.55-005824.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000134,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,330.298125,-0.97361,0.217,NULL,49821356628,778458697,12163417,18.4),(153158,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153158,38.15,0.33,426,72702,70,NULL,NULL,'SDSS J220112.16-005759.8',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,330.300667,-0.96664,0.217,NULL,49821356874,778458701,12163417,17),(153159,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153159,45.49,1.17,3740,72703,69.7,NULL,'Fiducial','GRB 051109A',2.35,'2009MNRAS.400..775C',2009,1,NULL,NULL,'VisS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,330.3135,40.82311,1.089,NULL,55514250126,867410158,13553283,NULL),(153160,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153160,45.69,0.83,4100,72703,72,NULL,NULL,'GRB 051109A',2.35,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153161,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153161,45.82,0.83,4350,72703,70,NULL,NULL,'GRB 051109A',2.35,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153162,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153162,45.84,0.8,4390,72703,69.7,NULL,'Calibrated','GRB 051109A',2.35,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153163,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153163,45.87,0.83,4460,72703,69.7,NULL,'Fiducial','GRB 051109A',2.35,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153164,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153164,45.9,0.96,4510,72703,NULL,NULL,NULL,'GRB 051109A',2.35,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153165,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153165,47.28,1.68,8540,72703,100,NULL,NULL,'GRB 051109A',2.35,'2009EPJC...63..139W',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153166,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153166,47.44,1.63,9180,72703,69.7,NULL,'Fiducial','GRB 051109A',2.35,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153167,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153167,35.2,0.46,110,72704,70,NULL,NULL,'2MASX J22011629-5504260',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00011,NULL,'15.66',0.43,'E',NULL,NULL,NULL,NULL,1,330.3177083,-55.07389,0,NULL,48693308946,760832952,11888014,15.66),(153168,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 04928','RN',153168,40.16,0.18,955,72705,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 04928',0.126496,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153169,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 04928','RN',153169,40.61,0.29,1180,72705,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 04928',0.126496,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153170,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153170,35.38,0.56,119,72706,70,NULL,NULL,'2MASX J22011929-5221007',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.00015,NULL,'16.21',0.28,'S',NULL,NULL,NULL,NULL,1,330.3302917,-52.35017,0,NULL,50628821890,791075342,12360552,16.21),(153171,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153171,32.96,0.4,39.1,72707,NULL,NULL,'mean','ESO 466- G 036',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000031,NULL,'14.70',0.5,'Sa','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,330.33525,-31.52969,0,NULL,51413798705,803340604,12552196,14.7),(153172,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153172,33.76,0.43,56.4,72707,75,NULL,'3.6 micron, color corrected','ESO 466- G 036',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153173,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153173,33.75,0.43,56.4,72707,75,NULL,'3.6 micron, color + selection bias corrected','ESO 466- G 036',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153174,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153174,33.82,0.2,58.1,72707,74.4,NULL,NULL,'ESO 466- G 036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153175,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153175,33.93,0.47,61.1,72707,NULL,NULL,'H','ESO 466- G 036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153176,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153176,35.69,0.46,138,72708,70,NULL,NULL,'2MASX J22012088+1211481',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000171,NULL,'15.8g',0.35,'S0/a',NULL,NULL,NULL,NULL,1,330.3372083,12.19667,0.285,NULL,52252707001,816448546,12757008,15.8),(153177,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153177,38.11,0.27,419,72709,70,NULL,NULL,'SDSS J220122.44+001656.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,330.3435,0.28242,0.193,NULL,52183726288,815370723,12740167,18),(153178,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153178,38.11,0.27,419,72710,70,NULL,NULL,'2MASX J22012326+0019582',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,330.3469583,0.33269,0.177,NULL,52183928706,815373886,12740216,18.5),(153179,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153179,34.72,0.47,87.7,72711,70,NULL,NULL,'2MASX J22012356-0345241',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000143,NULL,'15.28',NULL,NULL,NULL,NULL,NULL,NULL,1,330.348125,-3.75667,0.225,NULL,49819079616,778423119,12162861,15.28),(153180,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153180,34.98,0.59,99,72712,NULL,NULL,'Malmquist cor.','ESO 404- G 019',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.38',0.8,'Sb',NULL,NULL,NULL,NULL,1,330.349167,-33.9125,0,NULL,50562080119,790032501,12344257,14.38),(153181,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153181,35.09,0.56,104,72712,NULL,NULL,NULL,'ESO 404- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153182,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153182,35.13,0.2,106,72712,74.4,NULL,NULL,'ESO 404- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153183,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153183,35.25,0.49,112,72713,70,NULL,NULL,'NGC 7170',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000147,NULL,'14.77',0.8,'SA0-?',NULL,NULL,NULL,NULL,1,330.359416667,-5.43278,0.137,NULL,49887127299,779486364,12179474,14.77),(153184,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 15102','R',153184,42.18,0.38,1720,72714,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15102',0.583407,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,'PHOT','23.4g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,330.369833333,-0.59792,0.165,NULL,49823687099,778495110,12163986,23.4),(153185,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 15102',NULL,153185,41.23,0.36,1760,72714,70,NULL,'SN photometric redshift distance, z photo =0.548 +/- 0.152','SDSS-II SN 15102',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153186,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153186,34.3,NULL,72.3,72715,NULL,NULL,NULL,'FGC 2357',NULL,'2000BSAO...50....5K',2000,1,0.8,NULL,'G',0.000036,NULL,'17.3',0.08,'Sdm',NULL,NULL,NULL,NULL,1,330.37,3.56444,0.133,NULL,52188307849,815442310,12741286,17.3),(153187,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153187,34.48,NULL,78.8,72715,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2357',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153188,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153188,34.49,NULL,79,72715,NULL,NULL,'Dipole + Quadrupole','FGC 2357',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153189,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153189,34.5,NULL,79.3,72715,NULL,NULL,'Dipole','FGC 2357',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153190,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 03050','RN',153190,39.87,0.14,855,72716,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 03050',0.100844,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153191,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 03050','RN',153191,40.06,0.32,934,72716,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 03050',0.100844,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153192,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153192,34.05,0.8,64.5,72717,75,NULL,'MAT, I','ESO 601- G 004',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00002,NULL,'14.33',0.5,'SB(s)c:        HII',NULL,NULL,NULL,NULL,1,330.377083,-22.07086,0.041,NULL,50869961173,794843143,12419424,14.33),(153193,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153193,33.92,0.43,60.9,72717,75,NULL,'MAT, I, raw','ESO 601- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153194,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153194,33.94,0.32,61.3,72717,85,NULL,'I, raw','ESO 601- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153195,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153195,33.98,0.32,62.5,72717,85,NULL,'I, inv','ESO 601- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153196,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153196,34.02,0.2,63.7,72717,74.4,NULL,NULL,'ESO 601- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153197,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153197,34.12,0.43,66.5,72717,75,NULL,'MAT, I, inv','ESO 601- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153198,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153198,34.18,0.43,68.5,72717,75,NULL,'MAT, I, cor','ESO 601- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153199,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153199,34.25,0.41,70.6,72717,NULL,NULL,NULL,'ESO 601- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153200,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153200,34.27,0.4,71.4,72717,NULL,NULL,'Malmquist cor.','ESO 601- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153201,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153201,36.65,0.27,214,72718,70,NULL,NULL,'2MASX J22013271+0011528',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,330.386291667,0.19808,0.165,NULL,52183722476,815370663,12740166,17.2),(153202,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SN 2007lu',NULL,153202,41.07,0.27,1630,72719,70,NULL,'Hubble residual 0.75 for z0.31950','SDSS J220134.88-001524.8',NULL,'2011ApJ...740...92G',2011,1,0.05,NULL,'G',0.0005,NULL,'21.7g',0.03,NULL,NULL,NULL,NULL,NULL,1,330.395333,-0.25689,0.149,NULL,49821563326,778461926,12163467,21.7),(153203,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 19029','R',153203,41.67,0.2,1640,72719,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007lu','SDSS J220134.88-001524.8',0.3195,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153204,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 19029','R',153204,41.91,0.31,1830,72719,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007lu','SDSS J220134.88-001524.8',0.3195,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153205,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153205,36.43,0.51,194,72720,70,NULL,NULL,'2MASX J22013731-1554462',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.64',0.4,NULL,NULL,NULL,NULL,NULL,1,330.405417,-15.91281,0.081,NULL,49793466446,778022913,12156608,15.64),(153206,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153206,34.04,0.8,64.3,72721,75,NULL,'MAT, I','ESO 601- G 005',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'15.32',0.3,'Sb:',NULL,NULL,NULL,NULL,1,330.4082083,-21.51117,0.073,NULL,50883458292,795054035,12422719,15.32),(153207,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153207,33.49,0.32,50,72721,85,NULL,'I, raw','ESO 601- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153208,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153208,33.52,0.32,50.6,72721,85,NULL,'I, inv','ESO 601- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153209,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153209,33.58,0.43,52.1,72721,75,NULL,'MAT, I, raw','ESO 601- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153210,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153210,33.73,0.43,55.7,72721,75,NULL,'MAT, I, inv','ESO 601- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153211,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153211,33.85,0.2,58.9,72721,74.4,NULL,NULL,'ESO 601- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153212,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153212,33.92,0.52,60.8,72721,NULL,NULL,NULL,'ESO 601- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153213,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153213,33.95,0.43,61.6,72721,75,NULL,'MAT, I, cor','ESO 601- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153214,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153214,34.07,0.49,65.1,72721,NULL,NULL,'Malmquist cor.','ESO 601- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153215,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153215,34.09,0.49,65.6,72721,75,NULL,'IR','ESO 601- G 005',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153216,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153216,34.32,0.4,73.2,72721,NULL,NULL,'mean','ESO 601- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153217,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153217,34.36,0.47,74.6,72721,NULL,NULL,'H','ESO 601- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153218,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153218,38.01,0.46,399,72722,70,NULL,NULL,'2MASX J22013873-0719025',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,330.4112917,-7.31722,0.081,NULL,49921169207,780018268,12187785,17.8),(153219,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 16298','RN',153219,40.92,0.29,1190,72723,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16298',0.282787,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153220,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 16298','RN',153220,41.14,0.27,1320,72723,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16298',0.282787,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153221,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 16298','N',153221,40.82,0.19,1460,72723,70,NULL,'SALT 2','SDSS-II SN 16298',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153222,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 16298','N',153222,40.85,0.19,1480,72723,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16298',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153223,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153223,37.07,0.46,259,72724,70,NULL,NULL,'2MASX J22014179-0738165',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000103,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,330.4239583,-7.63786,0.081,NULL,49922971197,780046424,12188225,16.8),(153224,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153224,34.96,0.47,98.1,72725,70,NULL,NULL,'NGC 7181',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.0001,NULL,'14.96',0.8,'S0^0^ pec:','Group member',NULL,NULL,NULL,1,330.4312083,-1.96056,0.233,NULL,49824628509,778509820,12164215,14.96),(153225,'BCG','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153225,37.88,0.35,349,72726,60,NULL,'ABELL 2410, BCG','2MASX J22014508-0953361',0.0806,'1980ApJ...241..486H',1980,1,0.51,NULL,'G',0.000103,NULL,'15.98',0.45,NULL,'Brightest group member',NULL,NULL,NULL,1,330.437875,-9.89331,0.097,NULL,49873323741,779270683,12176104,15.98),(153226,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 19545','R',153226,40.72,0.24,1060,72727,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19545',0.309131,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,330.443041667,0.40111,0.177,NULL,52184957697,815389964,12740468,NULL),(153227,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 19545','R',153227,40.86,0.21,1140,72727,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19545',0.309131,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153228,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 19545',NULL,153228,40.36,0.09,1180,72727,70,NULL,'SN photometric redshift distance, z photo =0.327 +/- 0.017','SDSS-II SN 19545',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153229,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 19545',NULL,153229,40.6,0.15,1320,72727,70,NULL,'SALT 2','SDSS-II SN 19545',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153230,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 19545',NULL,153230,40.63,0.15,1340,72727,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19545',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153231,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153231,38,0.46,399,72728,70,NULL,NULL,'2MASXi J2201478-080455',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.3g',0.15,'AGN',NULL,NULL,NULL,NULL,1,330.449333,-8.08211,0.073,NULL,49923122993,780048796,12188262,18.3),(153232,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SNF20080909-030','RN',153232,35.49,0.13,125,72729,NULL,NULL,'MLCS2k2, R(V) = 3.1','SNF20080909-030',NULL,'2015Sci...347.1459K',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153233,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SNF20080909-030','RN',153233,35.52,0.12,127,72729,NULL,NULL,'MLCS2k2, R(V) = 1.8','SNF20080909-030',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153234,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 02639','R',153234,39.84,0.19,766,72730,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J220151.40+003952.0',0.215,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',0.01,NULL,'19.8g',0.07,NULL,NULL,NULL,NULL,NULL,1,330.4642083,0.66447,0.165,NULL,52184929356,815389521,12740461,19.8),(153235,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 02639','R',153235,40.02,0.13,832,72730,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J220151.40+003952.0',0.215,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153236,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 02639',NULL,153236,39.74,0.09,887,72730,70,NULL,'SALT 2','SDSS J220151.40+003952.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153237,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 02639',NULL,153237,39.76,0.09,895,72730,70,NULL,'SALT 2, Malmquist cor.','SDSS J220151.40+003952.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153238,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153238,35.16,0.48,108,72731,70,NULL,NULL,'NGC 7182',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000067,NULL,'15.35',0.4,'SB(rs)0+:','Group member',NULL,NULL,NULL,1,330.46525,-2.19658,0.261,NULL,49824565428,778508834,12164200,15.35),(153239,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153239,36.65,0.27,214,72732,70,NULL,NULL,'2MASX J22015197+0019078',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000201,NULL,'15.6g',0.42,'E0',NULL,NULL,NULL,NULL,1,330.4665417,0.319,0.129,NULL,52184792265,815387379,12740427,15.6),(153240,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SN 2006iy',NULL,153240,39.5,0.06,794,72733,70,NULL,'Hubble residual 0.01 for z0.20540','SDSS-II SN 14212 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,330.470625,1.04447,0.201,NULL,52184568844,815383888,12740373,NULL),(153241,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 14212','R',153241,40.06,0.18,853,72733,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006iy','SDSS-II SN 14212 HOST',0.20449,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153242,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 14212','R',153242,40.2,0.08,908,72733,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006iy','SDSS-II SN 14212 HOST',0.20449,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153243,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SN 2006iy',NULL,153243,39.91,0.07,959,72733,70,NULL,'SALT 2','SDSS-II SN 14212 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153244,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SN 2006iy',NULL,153244,39.92,0.07,964,72733,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14212 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153245,'Magnitude','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153245,37.21,0.13,277,72734,100,NULL,NULL,'ESO 146-IG 005 NED01',NULL,'1998A&A...337...31R',1998,1,NULL,NULL,'G',0.00016,NULL,'16.1r',NULL,'E+ p',NULL,NULL,NULL,NULL,1,330.472125,-59.94531,0,NULL,48687451125,760741423,11886584,16.1),(153246,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153246,37.96,0.46,391,72735,70,NULL,NULL,'2MASX J22015404+0004548',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000192,NULL,'17.9g',0.11,'AGN',NULL,NULL,NULL,NULL,1,330.475125,0.08178,0.165,NULL,52184746979,815386671,12740416,17.9),(153247,'Magnitude','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153247,37.21,0.13,277,72736,100,NULL,NULL,'ABELL 3827',NULL,'1998A&A...337...31R',1998,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I      [BM];R  [A]',NULL,NULL,NULL,NULL,1,330.483333,-59.94944,0,NULL,48687450980,760741421,11886584,NULL),(153248,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153248,32.78,0.8,36,72737,75,NULL,NULL,'UGCA 424',NULL,'1988NBGC.C....0000T',1988,1,2,NULL,'G',0.00002,NULL,'14',1.8,'SB(s)dm',NULL,NULL,NULL,NULL,1,330.497125,-12.19047,0.089,NULL,49749231784,777331746,12145808,14),(153249,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153249,35.78,0.58,144,72738,70,NULL,NULL,'2MASX J22015957-1428241',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.50',NULL,NULL,NULL,NULL,NULL,NULL,1,330.498417,-14.47353,0.081,NULL,49781238863,777831857,12153622,15.5),(153250,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 06690','RN',153250,44.09,0.41,4840,72739,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 06690',0.356647,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153251,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153251,37.6,0.46,331,72740,70,NULL,NULL,'2MASX J22020061-0058275',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000191,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,330.5027083,-0.97439,0.217,NULL,49823257156,778488393,12163881,17.5),(153252,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153252,36.65,0.27,214,72741,70,NULL,NULL,'2MASX J22020089+0005551',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,330.5035417,0.09875,0.165,NULL,52184758847,815386856,12740419,17.5),(153253,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153253,32.65,0.8,33.9,72742,75,NULL,'B','NGC 7172',NULL,'1988NBGC.C....0000T',1988,1,2.5,'Joguet et al. (2001A&A...380...19J) claim \\\"No activity\\\".','G',0.00004,NULL,'12.85',1.4,'Sa pec sp;Sy2  HII','Group member, radial-velocity confirmed',NULL,NULL,'Sy 2',1,330.507875,-31.86967,0,NULL,50537196895,789643701,12338182,12.85),(153254,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','PTF10pvi','N',153254,37.94,0.03,359,72743,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10pvi',0.0802,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153255,'GCLF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153255,32.48,0.15,31.3,72744,NULL,NULL,'TOM(g) = -7.2 mag','NGC 7173',NULL,'2012MNRAS.422.3591C',2012,1,1.2,NULL,'G',0.00004,NULL,'13.08',0.9,'E+ pec:','in a triple',NULL,NULL,NULL,1,330.5132917,-31.97369,0,NULL,50591733484,790495835,12351497,13.08),(153256,'GCLF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153256,32.76,0.24,35.6,72744,NULL,NULL,'TOM(z) = -8.4 mag','NGC 7173',NULL,'2012MNRAS.422.3591C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153257,'SBF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153257,32.48,0.19,31.3,72744,NULL,NULL,'I','NGC 7173',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153258,'SBF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153258,32.48,0.19,31.3,72744,NULL,NULL,NULL,'NGC 7173',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153259,'SBF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153259,32.48,0.14,31.3,72744,74.4,NULL,NULL,'NGC 7173',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153260,'SBF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153260,32.59,0.19,32.9,72744,NULL,NULL,'Malmquist cor.','NGC 7173',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153261,'D-Sigma','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153261,32.86,0.4,37.4,72744,75,NULL,'Edat, raw','NGC 7173',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153262,'D-Sigma','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153262,33.13,0.4,42.2,72744,75,NULL,'Edat, cor','NGC 7173',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153263,'Faber-Jackson','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153263,31.57,0.63,20.6,72744,95,NULL,'Michard 1979b, c','NGC 7173',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153264,'Faber-Jackson','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153264,31.77,0.44,22.6,72744,95,NULL,'Weighted Mean','NGC 7173',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153265,'Faber-Jackson','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153265,32.4,0.46,30.2,72744,95,NULL,'Michard 1979a','NGC 7173',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153266,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153266,32.87,0.41,37.4,72744,NULL,NULL,NULL,'NGC 7173',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153267,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153267,33.03,0.41,40.4,72744,NULL,NULL,'Malmquist cor.','NGC 7173',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153268,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153268,32.52,0.8,32,72744,75,NULL,'B','NGC 7173',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153269,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153269,32.77,0.4,35.8,72744,NULL,NULL,'mean','NGC 7173',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153270,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153270,33.48,0.45,49.6,72744,NULL,NULL,'K','NGC 7173',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153271,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153271,36.1,0.46,166,72745,70,NULL,NULL,'2MASX J22020354+1127245',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,330.514833,11.45672,0.237,NULL,52282788905,816918576,12764352,17.5),(153272,'BCG','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153272,37.88,0.35,349,72746,60,NULL,NULL,'ABELL 2410',0.0806,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,330.524583,-9.82444,0.097,NULL,49872538285,779258410,12175912,NULL),(153273,'GCLF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153273,32.3,0.19,28.8,72747,NULL,NULL,'g-band','NGC 7174',NULL,'2015MNRAS.447.3639M',2015,1,2.3,NULL,'G',0.00003,NULL,'14.23',1.2,'Sab pec sp','in a triple',NULL,NULL,NULL,1,330.526875,-31.99297,0,NULL,50591732922,790495826,12351497,14.23),(153274,'GCLF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153274,32.7,0.19,34.8,72747,NULL,NULL,'z-band','NGC 7174',NULL,'2015MNRAS.447.3639M',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153275,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153275,32.75,0.8,35.5,72747,75,NULL,'B','NGC 7174',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153276,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153276,37.38,0.53,300,72748,70,NULL,NULL,'2MASX J22020687-1431551',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.73',NULL,NULL,NULL,NULL,NULL,NULL,1,330.52875,-14.53208,0.077,NULL,49781273829,777832403,12153631,15.73),(153277,'SBF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153277,32.72,0.24,35,72749,NULL,NULL,'I','NGC 7168',NULL,'2001ApJ...546..681T',2001,1,2,NULL,'G',0.00007,NULL,'12.86',1.5,'E+','Line-of-sight pair member',NULL,NULL,NULL,1,330.530833,-51.74308,0,NULL,50628146940,791064795,12360387,12.86),(153278,'SBF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153278,32.75,0.14,35.5,72749,74.4,NULL,NULL,'NGC 7168',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153279,'Faber-Jackson','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153279,31.54,0.65,20.3,72749,95,NULL,'Weighted Mean','NGC 7168',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153280,'Faber-Jackson','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153280,32.88,0.81,37.7,72749,55,NULL,'Visvanathan & Sandage 1979','NGC 7168',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153281,'Tertiary','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153281,31.55,0.71,20.4,72749,95,NULL,NULL,'NGC 7168',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153282,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153282,32.7,0.8,34.7,72749,75,NULL,'B','NGC 7168',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153283,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153283,32.72,0.4,35,72749,73,NULL,'opt','NGC 7168',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153284,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153284,32.9,0.4,38,72749,NULL,NULL,'mean','NGC 7168',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153285,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153285,32.94,0.45,38.7,72749,NULL,NULL,'K','NGC 7168',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153286,'GCLF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153286,32.3,0.19,28.8,72750,NULL,NULL,'g-band','NGC 7176',NULL,'2015MNRAS.447.3639M',2015,1,1,NULL,'G',0.000047,NULL,'12.34',0.8,'E pec:','in a triple',NULL,NULL,NULL,1,330.535167,-31.98975,0,NULL,50591732909,790495826,12351497,12.34),(153287,'GCLF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153287,32.7,0.19,34.8,72750,NULL,NULL,'z-band','NGC 7176',NULL,'2015MNRAS.447.3639M',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153288,'D-Sigma','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153288,32.86,0.4,37.4,72750,75,NULL,'Edat, raw','NGC 7176',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153289,'D-Sigma','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153289,33.13,0.4,42.2,72750,75,NULL,'Edat, cor','NGC 7176',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153290,'Faber-Jackson','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153290,30.37,0.63,11.9,72750,95,NULL,'Michard 1979b, c','NGC 7176',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153291,'Faber-Jackson','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153291,30.95,0.44,15.5,72750,95,NULL,'Weighted Mean','NGC 7176',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153292,'Faber-Jackson','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153292,31.66,0.46,21.5,72750,95,NULL,'Michard 1979a','NGC 7176',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153293,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153293,32.54,0.8,32.3,72750,75,NULL,'B','NGC 7176',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153294,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153294,32.48,NULL,31.3,72750,71,NULL,'HDCE 1175,[MdL89] 59, 75 galaxies','NGC 7176',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153295,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153295,32.56,0.45,32.5,72750,NULL,NULL,'K','NGC 7176',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153296,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153296,32.56,0.3,32.5,72750,NULL,NULL,'HDCE 1175,[MdL89] 59, 10 galaxies','NGC 7176',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153297,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153297,32.77,0.4,35.8,72750,NULL,NULL,'mean','NGC 7176',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153298,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 17535','RN',153298,40.99,0.16,1360,72751,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 17535',0.159653,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153299,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 17535','RN',153299,41.65,0.24,1840,72751,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 17535',0.159653,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153300,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153300,37.91,0.46,383,72752,70,NULL,NULL,'2MASX J22021368-0104205',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,330.556875,-1.07228,0.217,NULL,49823253930,778488342,12163880,18.7),(153301,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153301,36.78,0.46,227,72753,70,NULL,NULL,'2MASX J22021798-0805523',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00015,NULL,'16.1g',0.33,'AGN',NULL,NULL,NULL,NULL,1,330.574833333,-8.09786,0.089,NULL,49867761431,779183772,12174746,16.1),(153302,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153302,35.36,0.58,118,72754,70,NULL,NULL,'2MASX J22021809-5147062',NULL,'2014MNRAS.445.2677S',2014,1,0.87,NULL,'G',0.000133,NULL,'15.0',0.63,'E','Line-of-sight pair member',NULL,NULL,NULL,1,330.5752917,-51.78503,0,NULL,50628135458,791064616,12360384,15),(153303,'SBF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153303,31.23,0.14,17.6,72755,74.4,NULL,NULL,'NGC 7180',NULL,'2013AJ....146...86T',2013,1,1.6,'Da Costa, et al. (1998,AJ,116,1) give v = 1566 +/- 33 km/sec.','G',0.000057,NULL,'13.52',0.7,'S0^0^?         LLAGN',NULL,NULL,NULL,NULL,1,330.576916667,-20.54775,0.073,NULL,49737279949,777144999,12142890,13.52),(153304,'SBF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153304,31.26,0.26,17.9,72755,NULL,NULL,'I','NGC 7180',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153305,'SBF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153305,31.26,0.26,17.9,72755,NULL,NULL,NULL,'NGC 7180',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153306,'SBF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153306,31.39,0.26,18.9,72755,NULL,NULL,'Malmquist cor.','NGC 7180',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153307,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153307,31.54,0.41,20.3,72755,NULL,NULL,NULL,'NGC 7180',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153308,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153308,31.92,0.41,24.2,72755,NULL,NULL,'Malmquist cor.','NGC 7180',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153309,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153309,31.26,0.8,17.8,72755,75,NULL,'B','NGC 7180',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153310,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153310,30.57,0.4,13,72755,NULL,NULL,'mean','NGC 7180',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153311,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153311,31.34,0.45,18.5,72755,NULL,NULL,'K','NGC 7180',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153312,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153312,36.19,0.2,173,72756,74.4,NULL,NULL,'UGC 11877',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',NULL,NULL,'15.37',0.4,'Sd',NULL,NULL,NULL,NULL,1,330.58375,11.85897,0.257,NULL,52282735768,816917746,12764339,15.37),(153313,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153313,31.76,0.8,22.5,72757,75,NULL,'MAT, I','ESO 601- G 007',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000026,NULL,'15.39',0.4,'Sc',NULL,NULL,NULL,NULL,1,330.590125,-21.04092,0.057,NULL,50874873282,794919895,12420623,15.39),(153314,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153314,30.72,0.32,13.9,72757,85,NULL,'I, inv','ESO 601- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153315,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153315,30.78,0.32,14.3,72757,85,NULL,'I, raw','ESO 601- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153316,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153316,30.96,0.62,15.5,72757,NULL,NULL,NULL,'ESO 601- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153317,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153317,31.19,0.43,17.3,72757,75,NULL,'MAT, I, inv','ESO 601- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153318,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153318,31.31,0.53,18.3,72757,NULL,NULL,'Malmquist cor.','ESO 601- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153319,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153319,31.35,0.43,18.7,72757,75,NULL,'MAT, I, raw','ESO 601- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153320,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153320,31.44,0.2,19.4,72757,74.4,NULL,NULL,'ESO 601- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153321,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153321,31.52,0.43,20.2,72757,75,NULL,'3.6 micron, color + selection bias corrected','ESO 601- G 007',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153322,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153322,31.7,0.43,21.9,72757,75,NULL,'3.6 micron, color corrected','ESO 601- G 007',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153323,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153323,31.71,0.43,22,72757,75,NULL,'MAT, I, cor','ESO 601- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153324,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153324,31.99,0.4,25,72757,NULL,NULL,NULL,'ESO 601- G 007',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153325,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153325,31.99,0.4,25,72757,73,NULL,'opt','ESO 601- G 007',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153326,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153326,34.99,0.56,99.7,72758,NULL,NULL,'Malmquist cor.','NGC 7178',NULL,'2009ApJS..182..474S',2009,1,1.22,NULL,'G',0.000033,NULL,'14.32',0.46,'Sb:',NULL,NULL,NULL,NULL,1,330.605,-35.79036,0,NULL,50566031500,790094242,12345222,14.32),(153327,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153327,35.09,0.54,104,72758,NULL,NULL,NULL,'NGC 7178',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153328,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153328,35.13,0.2,106,72758,74.4,NULL,NULL,'NGC 7178',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153329,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153329,36.28,0.56,180,72759,70,NULL,NULL,'2MASX J22022773-0224359',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.00015,NULL,'16.94',0.19,NULL,NULL,NULL,NULL,NULL,1,330.6155417,-2.41006,0.265,NULL,49825106564,778517290,12164332,16.94),(153330,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153330,34.37,0.49,75,72760,75,NULL,'IR','UGC 11876',NULL,'2011yCatp016004901K',2011,1,1.14,NULL,'G',0.000037,NULL,'16.0',0.1,'Sd',NULL,NULL,NULL,NULL,1,330.62075,2.83411,0.109,NULL,52190696635,815479634,12741869,16),(153331,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153331,34.44,0.2,77.3,72760,74.4,NULL,NULL,'UGC 11876',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153332,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153332,34.54,0.53,81.1,72760,NULL,NULL,NULL,'UGC 11876',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153333,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153333,34.59,NULL,82.8,72760,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11876',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153334,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153334,34.62,NULL,84,72760,NULL,NULL,'Dipole + Quadrupole','UGC 11876',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153335,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153335,34.63,NULL,84.5,72760,NULL,NULL,'Dipole','UGC 11876',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153336,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153336,34.69,NULL,86.7,72760,NULL,NULL,NULL,'UGC 11876',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153337,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153337,34.88,0.45,94.7,72760,NULL,NULL,'Malmquist cor.','UGC 11876',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153338,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153338,35.4,0.52,120,72761,70,NULL,NULL,'2MASX J22022947-0200549',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.34',0.41,NULL,NULL,NULL,NULL,NULL,1,330.6227083,-2.01525,0.233,NULL,49822670740,778479230,12163737,16.34),(153339,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 16312','RN',153339,40.56,0.23,1000,72762,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16312',0.28907,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153340,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 16312','RN',153340,40.83,0.15,1140,72762,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16312',0.28907,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153341,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 13033','RN',153341,42.73,0.23,2740,72763,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13033',0.282192,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153342,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 13033','RN',153342,42.74,0.26,2750,72763,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13033',0.282192,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153343,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153343,31.62,0.8,21.1,72764,75,NULL,'B','IC 1420',NULL,'1988NBGC.C....0000T',1988,1,NULL,'Colliding pair, not noted as double in CGCG, MCG, or UGC.','GPair',0.000017,NULL,NULL,NULL,'I0pec + I0pec',NULL,NULL,NULL,NULL,1,330.633208333,19.75011,0.177,NULL,52217703502,815901617,12748462,NULL),(153344,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153344,36.52,0.46,201,72765,70,NULL,NULL,'2MASX J22023330-0917313',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00015,NULL,'15.6g',0.44,'E0',NULL,NULL,NULL,NULL,1,330.638833,-9.29208,0.089,NULL,49874689750,779292027,12176437,15.6),(153345,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153345,36.53,0.57,202,72765,70,NULL,NULL,'2MASX J22023330-0917313',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153346,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153346,31.61,0.8,21,72766,75,NULL,NULL,'ESO 189- G 021',NULL,'1988NBGC.C....0000T',1988,1,1.8,NULL,'G',0.00002,NULL,'15.14',1.1,'SAB(s)m',NULL,NULL,NULL,NULL,1,330.652375,-54.07864,0,NULL,48695195650,760862432,11888475,15.14),(153347,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153347,36.65,0.63,214,72767,70,NULL,NULL,'2MASX J22023686-4730272',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.84',0.32,NULL,NULL,NULL,NULL,NULL,1,330.653667,-47.50758,0,NULL,50653897500,791467148,12366674,16.84),(153348,'Ring Diameter','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153348,30.4,0.84,12,72768,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7184',NULL,'1981ApJS...45..541P',1981,1,6,NULL,'G',0.00001,NULL,'12.24',1.5,'SB(r)c         LLAGN',NULL,NULL,NULL,NULL,1,330.665917,-20.81283,0.057,NULL,49737140385,777142818,12142856,12.24),(153349,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153349,32.6,0.8,33.1,72768,75,NULL,'A82, H','NGC 7184',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153350,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153350,32.6,0.8,33.1,72768,75,NULL,'MAT, I','NGC 7184',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153351,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153351,32.27,0.43,28.5,72768,75,NULL,'MAT, I, raw','NGC 7184',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153352,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153352,32.43,0.35,30.6,72768,NULL,NULL,NULL,'NGC 7184',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153353,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153353,32.48,0.32,31.3,72768,85,NULL,'I, raw','NGC 7184',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153354,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153354,32.56,0.32,32.5,72768,85,NULL,'I, inv','NGC 7184',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153355,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153355,32.56,0.43,32.5,72768,75,NULL,'MAT, I, cor','NGC 7184',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153356,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153356,32.6,0.47,33.1,72768,75,NULL,'A82, H, raw','NGC 7184',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153357,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153357,32.61,0.43,33.2,72768,75,NULL,'MAT, I, inv','NGC 7184',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153358,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153358,32.67,0.4,34.1,72768,75,NULL,'B','NGC 7184',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153359,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153359,32.72,0.2,35,72768,74.4,NULL,NULL,'NGC 7184',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153360,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153360,32.74,0.43,35.3,72768,75,NULL,'3.6 micron, color corrected','NGC 7184',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153361,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153361,32.79,0.09,36.2,72768,NULL,NULL,NULL,'NGC 7184',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153362,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153362,32.84,0.47,37.1,72768,75,NULL,'A82, H, inv','NGC 7184',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153363,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153363,32.91,0.47,38.1,72768,75,NULL,'A82, H, cor','NGC 7184',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153364,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153364,32.91,0.43,38.2,72768,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7184',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153365,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153365,38.13,0.46,423,72769,70,NULL,NULL,'SDSS J220240.27-001044.0',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,330.667791667,-0.17889,0.165,NULL,49820264143,778441627,12163150,17.9),(153366,'Cepheids','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153366,25.9,NULL,1.51,72770,NULL,18.4,NULL,'IC 5152',NULL,'1988BAAS...20Q1084C',1988,1,5.2,NULL,'G',0.000007,NULL,'11.0B',3.2,'IA(s)m','Group non-member, foreground',NULL,NULL,NULL,1,330.6729583,-51.29644,0,0,50628367673,791068244,12360441,11),(153367,'CMD','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153367,26.15,0.2,1.7,72770,NULL,NULL,NULL,'IC 5152',NULL,'1999AJ....117.1743Z',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153368,'TRGB','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153368,26.36,0.1,1.87,72770,NULL,NULL,NULL,'IC 5152',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153369,'TRGB','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153369,26.39,0.19,1.9,72770,NULL,NULL,NULL,'IC 5152',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153370,'TRGB','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153370,26.46,0.1,1.96,72770,74.4,NULL,NULL,'IC 5152',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153371,'TRGB','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153371,26.47,0.08,1.97,72770,NULL,NULL,NULL,'IC 5152',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153372,'TRGB','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153372,26.55,0.06,2.04,72770,NULL,NULL,'I','IC 5152',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153373,'TRGB','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153373,26.58,0.18,2.07,72770,NULL,NULL,NULL,'IC 5152',NULL,'2002A&A...389..812K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153374,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153374,25.09,0.8,1,72770,75,NULL,'B','IC 5152',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153375,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153375,27.1,NULL,2.63,72770,NULL,NULL,'LEDA [April 2006]','IC 5152',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153376,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153376,33.72,0.8,55.5,72771,75,NULL,'MAT, I','ESO 404- G 023',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00001,NULL,'13.97',1.1,'SB(rs)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,330.673166667,-33.80506,0,NULL,50561675709,790026182,12344159,13.97),(153377,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153377,33.21,0.32,43.8,72771,85,NULL,'I, raw','ESO 404- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153378,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153378,33.24,0.32,44.4,72771,85,NULL,'I, inv','ESO 404- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153379,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153379,33.27,0.43,45.1,72771,75,NULL,'MAT, I, raw','ESO 404- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153380,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153380,33.42,0.43,48.3,72771,75,NULL,'MAT, I, inv','ESO 404- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153381,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153381,33.5,0.43,50.2,72771,75,NULL,'MAT, I, cor','ESO 404- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153382,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153382,33.59,0.2,52.2,72771,74.4,NULL,NULL,'ESO 404- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153383,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153383,33.76,0.61,56.6,72771,NULL,NULL,NULL,'ESO 404- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153384,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153384,33.83,0.59,58.5,72771,NULL,NULL,'Malmquist cor.','ESO 404- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153385,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153385,33.95,0.4,61.8,72771,NULL,NULL,'mean','ESO 404- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153386,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153386,34.1,0.47,66.1,72771,NULL,NULL,'H','ESO 404- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153387,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153387,34.21,0.46,69.5,72771,NULL,NULL,'J','ESO 404- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153388,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153388,34.22,0.45,70,72771,NULL,NULL,'K','ESO 404- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153389,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153389,37.12,0.58,266,72772,70,NULL,NULL,'2MASX J22024195-0230589',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.84',0.33,NULL,NULL,NULL,NULL,NULL,1,330.6747917,-2.51647,0.249,NULL,49825103588,778517243,12164331,16.84),(153390,'BL Lac Luminosity','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153390,38.31,NULL,430,72773,NULL,NULL,NULL,'BL Lac',0.0686,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.0004,NULL,'14.7V',NULL,'Opt.var.       BLLAC',NULL,NULL,'radio jet','HP BL Lac',1,330.680375,42.27778,1.321,NULL,55513547671,867399182,13553112,14.7),(153391,'GeV TeV ratio','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153391,38.55,NULL,514,72773,72,NULL,NULL,'BL Lac',NULL,'2010MNRAS.405L..76P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153392,'GeV TeV ratio','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153392,39.95,0.75,977,72773,72,NULL,NULL,'BL Lac',NULL,'2011arXiv1111.0913P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153393,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153393,35.52,0.71,127,72774,70,NULL,NULL,'2MASX J22024374-0206069',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'17.58',0.23,NULL,NULL,NULL,NULL,NULL,1,330.682208333,-2.10189,0.233,NULL,49822638861,778478732,12163730,17.58),(153394,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 13771','RN',153394,43.34,0.26,3280,72775,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13771',0.423507,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153395,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 13771','RN',153395,44.13,0.31,4700,72775,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13771',0.423507,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153396,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153396,35.12,0.46,106,72776,70,NULL,NULL,'NGC 7169',NULL,'2014MNRAS.445.2677S',2014,1,0.97,NULL,'G',0.00015,NULL,'14.51',0.48,'SAB0- sp:',NULL,NULL,NULL,NULL,1,330.702667,-47.69783,0,NULL,50653930761,791467668,12366682,14.51),(153397,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153397,34.05,0.2,64.6,72777,74.4,NULL,NULL,'UGC 11881',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000017,NULL,'16.0',0.2,'S?',NULL,NULL,NULL,NULL,1,330.71925,17.90306,0.213,NULL,52272469894,816757342,12761833,16),(153398,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153398,34.25,0.33,70.7,72777,NULL,NULL,NULL,'UGC 11881',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153399,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153399,34.48,0.29,78.6,72777,NULL,NULL,'Malmquist cor.','UGC 11881',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153400,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153400,36.99,0.46,250,72778,70,NULL,NULL,'2MASX J22025366-0047049',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,330.72375,-0.78458,0.169,NULL,49823891914,778498311,12164036,16.7),(153401,'SBF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153401,31.51,0.37,20,72779,NULL,NULL,'I','NGC 7185',NULL,'2001ApJ...546..681T',2001,1,2.3,NULL,'G',0.000047,NULL,'13.37',1.5,'SAB(rs)0- pec?',NULL,NULL,NULL,NULL,1,330.7364583,-20.47128,0.069,NULL,49737190433,777143600,12142868,13.37),(153402,'SBF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153402,31.55,0.14,20.4,72779,74.4,NULL,NULL,'NGC 7185',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153403,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153403,31.98,0.4,24.9,72779,NULL,NULL,'mean','NGC 7185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153404,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153404,32.36,0.45,29.6,72779,NULL,NULL,'K','NGC 7185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153405,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153405,31.66,0.8,21.5,72780,75,NULL,'MAT, I','ESO 532- G 014',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000017,NULL,'15.24',0.7,'SAB(s)cd pec:',NULL,NULL,NULL,NULL,1,330.738083,-22.47197,0.045,NULL,50869914428,794842412,12419412,15.24),(153406,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153406,30.45,0.32,12.3,72780,85,NULL,'I, inv','ESO 532- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153407,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153407,30.55,0.32,12.9,72780,85,NULL,'I, raw','ESO 532- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153408,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153408,30.95,0.43,15.5,72780,75,NULL,'MAT, I, inv','ESO 532- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153409,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153409,31.22,0.43,17.5,72780,75,NULL,'MAT, I, raw','ESO 532- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153410,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153410,31.57,0.43,20.6,72780,75,NULL,'MAT, I, cor','ESO 532- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153411,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153411,31.59,0.2,20.8,72780,74.4,NULL,NULL,'ESO 532- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153412,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153412,31.71,0.43,22,72780,75,NULL,'3.6 micron, color corrected','ESO 532- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153413,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153413,31.78,0.43,22.7,72780,75,NULL,'3.6 micron, color + selection bias corrected','ESO 532- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153414,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153414,31.83,0.56,23.2,72780,NULL,NULL,NULL,'ESO 532- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153415,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153415,31.98,0.4,24.9,72780,NULL,NULL,NULL,'ESO 532- G 014',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153416,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153416,31.98,0.4,24.9,72780,73,NULL,'opt','ESO 532- G 014',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153417,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153417,32.12,0.49,26.6,72780,NULL,NULL,'Malmquist cor.','ESO 532- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153418,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153418,37.86,0.46,373,72781,70,NULL,NULL,'2MASX J22025808+1156206',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000147,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,330.742125,11.93894,0.257,NULL,52282772540,816918320,12764348,17.5),(153419,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153419,36.39,0.53,190,72782,70,NULL,NULL,'IC 1419',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.00015,NULL,'15.98',0.34,NULL,NULL,NULL,NULL,NULL,1,330.745167,-9.92097,0.097,NULL,49873230897,779269232,12176081,15.98),(153420,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153420,31.11,0.87,16.7,72783,NULL,NULL,NULL,'ESO 532- G 015',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000027,NULL,'15.75',0.3,'S.../Irr',NULL,NULL,NULL,NULL,1,330.7842917,-22.39447,0.045,NULL,50870389016,794849828,12419528,15.75),(153421,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153421,31.15,0.2,17,72783,74.4,NULL,NULL,'ESO 532- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153422,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153422,31.73,0.39,22.2,72783,73,NULL,'opt','ESO 532- G 015',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153423,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153423,31.83,0.62,23.2,72783,NULL,NULL,'Malmquist cor.','ESO 532- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153424,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153424,37.1,0.46,263,72784,70,NULL,NULL,'2MASX J22031228+0100593',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,330.801167,1.01658,0.157,NULL,52185529154,815398893,12740607,17.7),(153425,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153425,35.54,0.42,128,72785,NULL,NULL,'Malmquist cor.','ESO 532- G 016',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.80',0.7,'Sb',NULL,NULL,NULL,NULL,1,330.8027917,-26.40686,0.029,NULL,51408055358,803250864,12550794,14.8),(153426,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153426,35.61,0.41,132,72785,NULL,NULL,NULL,'ESO 532- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153427,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153427,35.65,0.2,135,72785,74.4,NULL,NULL,'ESO 532- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153428,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153428,39,0.46,630,72786,70,NULL,NULL,'SDSS J220313.32-091710.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00016,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,330.8055417,-9.28625,0.089,NULL,49874649889,779291404,12176428,18.6),(153429,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153429,32.7,0.8,34.7,72787,75,NULL,'MAT, I','IC 5156',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000033,NULL,'13.21',0.8,'SB(rs)ab       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,330.811958333,-33.83844,0,NULL,50561663637,790025994,12344156,13.21),(153430,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153430,32.58,0.8,32.8,72787,75,NULL,'B','IC 5156',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153431,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153431,32.62,0.47,33.4,72787,NULL,NULL,'H','IC 5156',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153432,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153432,32.62,0.46,33.4,72787,NULL,NULL,'J','IC 5156',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153433,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153433,32.63,0.45,33.6,72787,NULL,NULL,'K','IC 5156',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153434,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153434,32.7,0.07,34.7,72787,NULL,NULL,NULL,'IC 5156',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153435,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153435,32.75,0.4,35.5,72787,NULL,NULL,'mean','IC 5156',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153436,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153436,32.83,0.43,36.8,72787,75,NULL,'3.6 micron, color corrected','IC 5156',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153437,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153437,32.87,0.43,37.4,72787,75,NULL,'3.6 micron, color + selection bias corrected','IC 5156',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153438,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153438,32.87,0.32,37.5,72787,85,NULL,'I, raw','IC 5156',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153439,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153439,32.88,0.2,37.7,72787,74.4,NULL,NULL,'IC 5156',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153440,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153440,32.91,0.43,38.2,72787,75,NULL,'MAT, I, raw','IC 5156',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153441,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153441,32.93,0.32,38.5,72787,85,NULL,'I, inv','IC 5156',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153442,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153442,33.1,0.43,41.7,72787,75,NULL,'MAT, I, cor','IC 5156',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153443,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153443,33.16,0.43,42.8,72787,75,NULL,'MAT, I, inv','IC 5156',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153444,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153444,35.34,0.2,117,72788,74.4,NULL,NULL,'NGC 7189',NULL,'2013AJ....146...86T',2013,1,0.83,NULL,'G',0.00003,NULL,'14.2g',0.75,'SB(rs)b pec:   LINER',NULL,NULL,NULL,NULL,1,330.816667,0.57111,0.129,NULL,52184864779,815388512,12740445,14.2),(153445,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 16357','R',153445,41.57,0.35,1500,72789,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006pi','SN 2006pi',0.368,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,330.819166667,-0.60683,0.157,NULL,49823806815,778496981,12164015,NULL),(153446,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 16357','R',153446,41.63,0.2,1550,72789,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006pi','SN 2006pi',0.368,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153447,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153447,35.44,0.56,122,72790,70,NULL,NULL,'2MASX J22031661-1756404',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00015,NULL,'15.77',0.43,'S0',NULL,NULL,NULL,NULL,1,330.819208333,-17.94464,0.069,NULL,49783413284,777865832,12154153,15.77),(153448,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153448,35.52,0.46,127,72791,70,NULL,NULL,'CGCG 428-021',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000168,NULL,'16.0g',0.28,'S0','Group member',NULL,NULL,NULL,1,330.844125,12.64936,0.253,NULL,52252994290,816453035,12757078,16),(153449,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153449,38.05,0.46,407,72792,70,NULL,NULL,'2MASX J22032411-0713136',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000149,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,330.850333,-7.22047,0.081,NULL,49866543453,779164741,12174449,17.6),(153450,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 15401',NULL,153450,40.41,0.25,1210,72793,70,NULL,'SN photometric redshift distance, z photo =0.337 +/- 0.051','SDSS-II SN 15401',NULL,'2011ApJ...738..162S',2011,1,0.03,NULL,'G',NULL,'PHOT','22.6g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,330.855333333,0.57633,0.129,NULL,52184866081,815388532,12740445,22.6),(153451,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153451,37.76,0.23,357,72794,70,NULL,NULL,'2MASX J22032672-0015338',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000136,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,330.861291667,-0.25936,0.149,NULL,49820452749,778444574,12163196,17.5),(153452,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153452,30.83,0.43,14.7,72795,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7188',NULL,'2014MNRAS.444..527S',2014,1,1.6,NULL,'G',0.00004,NULL,'13.78',0.7,'(R\'_2)SB(s)bc  HII',NULL,NULL,NULL,NULL,1,330.870833,-20.31797,0.061,NULL,49738082334,777157536,12143086,13.78),(153453,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153453,35.28,0.4,114,72796,NULL,NULL,'mean','NGC 7194',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000023,NULL,'14.14',0.9,'E','Group member',NULL,NULL,NULL,1,330.878917,12.63678,0.253,NULL,52253018118,816453408,12757084,14.14),(153454,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153454,35.45,0.45,123,72796,NULL,NULL,'K','NGC 7194',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153455,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153455,38.53,0.46,508,72797,70,NULL,NULL,'SDSS J220332.79+003231.5',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000148,NULL,'18.9g',0.1,NULL,NULL,NULL,NULL,NULL,1,330.886625,0.54211,0.129,NULL,52182016907,815344014,12739750,18.9),(153456,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153456,29.43,0.2,7.69,72798,74.4,NULL,NULL,'UGC 11891',NULL,'2013AJ....146...86T',2013,1,4.2,'Position in 1987A&AS...70..191S is for an HII region in the galaxy.','G',0.00001,NULL,'14.4',3.2,'Im',NULL,NULL,NULL,NULL,1,330.891166667,43.74922,NULL,NULL,55509187278,867331051,13552047,14.4),(153457,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153457,29.64,0.4,8.47,72798,NULL,NULL,NULL,'UGC 11891',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153458,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153458,30.1,0.4,10.5,72798,75,NULL,'B','UGC 11891',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153459,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153459,30.62,0.4,13.3,72798,73,NULL,'opt','UGC 11891',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153460,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153460,37.52,0.46,319,72799,70,NULL,NULL,'2MASX J22033446+0058491',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,330.8935417,0.98047,0.157,NULL,52185292742,815395199,12740549,18.1),(153461,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 13772','RN',153461,42.13,0.21,2070,72800,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13772',0.287611,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153462,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 13772','RN',153462,42.38,0.25,2320,72800,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13772',0.287611,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153463,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153463,36.41,0.56,192,72801,70,NULL,NULL,'2MASX J22034105-1002290',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00015,NULL,'16.09',0.43,NULL,NULL,NULL,NULL,NULL,1,330.921083333,-10.04136,0.093,NULL,49872972377,779265193,12176018,16.09),(153464,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153464,37.76,0.23,357,72802,70,NULL,NULL,'2MASX J22034138-0009108',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,330.922375,-0.15311,0.149,NULL,49820430041,778444219,12163190,17.5),(153465,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SN 2005fz',NULL,153465,38.08,0.12,369,72803,74.2,NULL,'SALT 2','SDSS J220341.69+003413.9',0.12,'2010ApJ...716..712A',2010,1,0.04,NULL,'G',NULL,NULL,'24.3g',0.02,NULL,NULL,NULL,NULL,NULL,1,330.923708333,0.57056,0.129,NULL,52181996431,815343694,12739745,24.3),(153466,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SN 2005fz',NULL,153466,38.73,0.13,497,72803,70,NULL,'SALT 2','SDSS J220341.69+003413.9',0.12,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153467,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 02916','R',153467,38.75,0.19,500,72803,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fz','SDSS J220341.69+003413.9',0.1242,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153468,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SN 2005fz',NULL,153468,38.75,0.14,502,72803,65,NULL,'SALT2','SDSS J220341.69+003413.9',0.12,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153469,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SN 2005fz',NULL,153469,38.76,NULL,504,72803,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 02916, SN 2005fz','SDSS J220341.69+003413.9',0.12,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153470,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SN 2005fz',NULL,153470,38.92,0.11,542,72803,65,NULL,'MLCS2k2','SDSS J220341.69+003413.9',0.12,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153471,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 02916','R',153471,38.94,0.11,546,72803,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fz','SDSS J220341.69+003413.9',0.1242,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153472,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SN 2005fz',NULL,153472,39.53,0.06,719,72803,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 02916, SN 2005fz','SDSS J220341.69+003413.9',0.12,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153473,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153473,38.19,0.46,435,72804,70,NULL,NULL,'2MASX J22034380+0006541',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,330.9327083,0.11511,0.129,NULL,52181968201,815343253,12739738,17.4),(153474,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 12888','RN',153474,39.72,0.2,732,72805,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 12888',0.201101,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153475,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 12888','RN',153475,40.05,0.15,851,72805,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 12888',0.201101,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153476,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153476,35.19,0.52,109,72806,70,NULL,NULL,'2MASX J22034776-0228248',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.000073,NULL,'16.39',0.3,NULL,NULL,NULL,NULL,NULL,1,330.949041667,-2.47347,0.257,NULL,49822195836,778471809,12163622,16.39),(153477,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153477,32.53,0.8,32.1,72807,75,NULL,'MAT, I','ESO 404- G 027',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000003,NULL,'13.92',0.9,'SB(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,330.949333,-32.285,0,NULL,50591791239,790496738,12351511,13.92),(153478,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153478,32.06,0.69,25.8,72807,100,NULL,'mid-IR','ESO 404- G 027',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153479,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153479,32.58,0.4,32.8,72807,NULL,NULL,NULL,'ESO 404- G 027',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153480,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153480,32.61,0.13,33.3,72807,NULL,NULL,NULL,'ESO 404- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153481,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153481,32.66,0.32,34,72807,85,NULL,'I, raw','ESO 404- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153482,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153482,32.68,0.32,34.3,72807,85,NULL,'I, inv','ESO 404- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153483,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153483,32.71,0.43,34.8,72807,75,NULL,'MAT, I, raw','ESO 404- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153484,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153484,32.73,0.2,35.2,72807,74.4,NULL,NULL,'ESO 404- G 027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153485,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153485,32.76,0.43,35.6,72807,75,NULL,'3.6 micron, color corrected','ESO 404- G 027',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153486,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153486,32.82,0.43,36.6,72807,75,NULL,'3.6 micron, color + selection bias corrected','ESO 404- G 027',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153487,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153487,32.83,0.43,36.9,72807,75,NULL,'MAT, I, inv','ESO 404- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153488,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153488,32.89,NULL,37.8,72807,NULL,NULL,'B','ESO 404- G 027',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153489,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153489,32.9,NULL,38,72807,NULL,NULL,'I','ESO 404- G 027',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153490,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153490,32.91,0.43,38.2,72807,75,NULL,'MAT, I, cor','ESO 404- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153491,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153491,32.97,0.4,39.2,72807,NULL,NULL,'mean','ESO 404- G 027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153492,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153492,33.37,0.46,47.2,72807,NULL,NULL,'J','ESO 404- G 027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153493,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153493,33.45,0.45,49,72807,NULL,NULL,'K','ESO 404- G 027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153494,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153494,33.51,0.47,50.3,72807,NULL,NULL,'H','ESO 404- G 027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153495,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153495,36.39,0.54,190,72808,70,NULL,NULL,'2MASX J22034782-1757487',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.83',0.32,NULL,NULL,NULL,NULL,NULL,1,330.9495,-17.96353,0.069,NULL,49783444318,777866317,12154161,16.83),(153496,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153496,37.07,0.46,260,72809,70,NULL,NULL,'SDSS J220348.04+010235.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,330.9502083,1.04319,0.153,NULL,52185285893,815395092,12740548,18.3),(153497,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153497,36.47,0.67,197,72810,70,NULL,NULL,'2MASX J22035034-1326057',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.78',NULL,NULL,NULL,NULL,NULL,NULL,1,330.9597917,-13.43494,0.085,NULL,49752358147,777380596,12146571,15.78),(153498,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 01902','RN',153498,40.15,0.18,881,72811,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 01902',0.216732,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153499,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153499,37.76,0.23,357,72812,70,NULL,NULL,'2MASX J22035085-0005318',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000182,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,330.962,-0.09228,0.153,NULL,49820364933,778443202,12163175,17.3),(153500,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153500,37.76,0.23,357,72813,70,NULL,NULL,'2MASX J22035191-0017279',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00014,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,330.96625,-0.29108,0.149,NULL,49820414121,778443970,12163187,18.3),(153501,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153501,36.04,0.5,161,72814,70,NULL,NULL,'2MASX J22035701-1150410',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.06',0.37,NULL,NULL,NULL,NULL,NULL,1,330.987667,-11.84483,0.093,NULL,49873989930,779281092,12176267,16.06),(153502,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153502,35.54,0.46,128,72815,70,NULL,NULL,'2MASX J22035802+1154217',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000163,NULL,'16.1g',0.41,'S0',NULL,NULL,NULL,NULL,1,330.9917917,11.90592,0.257,NULL,52285434944,816959921,12764998,16.1),(153503,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 03193','RN',153503,42.87,0.25,2450,72816,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 03193',0.530363,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153504,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 08195','R',153504,40.55,0.22,1020,72817,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J220401.53-005344.4',0.2689,'2014arXiv1401.3317S',2014,1,0.13,NULL,'G',0.0001,NULL,'19.4g',0.09,NULL,NULL,NULL,NULL,NULL,1,331.006417,-0.89567,0.169,NULL,49823887007,778498234,12164034,19.4),(153505,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 08195','R',153505,40.65,0.29,1060,72817,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J220401.53-005344.4',0.2689,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153506,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 08195',NULL,153506,40.58,0.18,1310,72817,70,NULL,'SALT 2','SDSS J220401.53-005344.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153507,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 08195',NULL,153507,40.6,0.18,1320,72817,70,NULL,'SALT 2, Malmquist cor.','SDSS J220401.53-005344.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153508,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 11002','RN',153508,38.09,0.16,395,72818,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 11002',0.049263,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153509,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 11002','RN',153509,39.15,0.25,644,72818,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 11002',0.049263,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153510,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153510,35.84,0.46,147,72819,70,NULL,NULL,'2MASX J22040180+0035050',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00018,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,331.007625,0.58461,0.129,NULL,52182002520,815343789,12739746,16.2),(153511,'CMD','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'N',153511,18.62,0.21,0.053,72820,NULL,NULL,'If object = GC, ID = DES J0117 _1725','Cetus II',NULL,'2015ApJ...813..109D',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153512,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153512,35.61,0.66,132,72821,70,NULL,NULL,'2MASX J22040518-6953302',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'16.37',0.22,'S',NULL,NULL,NULL,NULL,1,331.021833333,-69.89172,0.033,NULL,49309880268,770466879,12038544,16.37),(153513,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153513,37.9,0.46,381,72822,70,NULL,NULL,'2MASX J22040591+1231079',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000132,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,331.0245417,12.51894,0.249,NULL,52253134690,816455229,12757112,17.7),(153514,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153514,34.32,0.8,73.2,72823,75,NULL,'W91PP, r','UGC 11893',NULL,'1997ApJS..109..333W',1997,1,2.26,NULL,'G',0.000023,NULL,'16.0',0.27,'Sc',NULL,NULL,NULL,NULL,1,331.0282083,35.93847,0.749,NULL,55481580555,866899696,13545307,16),(153515,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153515,34.79,0.49,90.7,72823,75,NULL,'IR','UGC 11893',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153516,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153516,34.9,0.38,95.6,72823,75,NULL,'W91PP, r, raw','UGC 11893',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153517,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153517,35.07,0.38,103,72823,75,NULL,'W91PP, r, cor','UGC 11893',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153518,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153518,35.11,NULL,105,72823,NULL,NULL,'Dipole','UGC 11893',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153519,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153519,35.12,NULL,106,72823,NULL,NULL,'Dipole + Quadrupole','UGC 11893',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153520,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153520,35.12,NULL,106,72823,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11893',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153521,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153521,35.17,0.35,108,72823,NULL,NULL,'Malmquist cor.','UGC 11893',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153522,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153522,35.2,0.38,110,72823,75,NULL,'W91PP, r, inv','UGC 11893',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153523,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153523,35.24,NULL,112,72823,NULL,NULL,NULL,'UGC 11893',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153524,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153524,35.36,0.43,118,72823,75,NULL,'3.6 micron, color corrected','UGC 11893',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153525,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153525,35.37,0.2,119,72823,74.4,NULL,NULL,'UGC 11893',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153526,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153526,35.55,0.43,129,72823,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11893',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153527,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153527,35.61,0.29,132,72823,NULL,NULL,NULL,'UGC 11893',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153528,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153528,36.19,0.53,173,72824,70,NULL,NULL,'2MASX J22041302-7135083',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.45',0.39,NULL,NULL,NULL,NULL,NULL,1,331.0540417,-71.58567,0.017,NULL,49304594525,770384289,12037254,16.45),(153529,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153529,36.58,0.58,207,72825,70,NULL,NULL,'2MASX J22041634-5537293',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.29',0.4,'S0',NULL,NULL,NULL,NULL,1,331.0682083,-55.62489,0,NULL,48710678247,761104347,11892255,16.29),(153530,'BL Lac Luminosity','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153530,35.46,NULL,120,72826,NULL,NULL,NULL,'CGCG 403-019',0.027,'2005ApJ...635..173S',2005,1,NULL,NULL,'G',NULL,NULL,'15.2',NULL,'E;BLLAC        Sy1',NULL,NULL,'radio jet','Flat-Spectrum Radio Source',1,331.073583,4.66722,0.157,NULL,52186062298,815407223,12740737,15.2),(153531,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153531,37.69,0.46,345,72827,70,NULL,NULL,'2MASX J22041886+0111201',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,331.078583,1.18897,0.153,NULL,52185218142,815394033,12740531,16.9),(153532,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153532,35.91,0.67,152,72828,70,NULL,NULL,'2MASX J22041917-0924302',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'16.1g',0.29,'S0/a',NULL,NULL,NULL,NULL,1,331.0797917,-9.40847,0.089,NULL,49875373159,779302705,12176604,16.1),(153533,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153533,35.47,0.46,124,72829,70,NULL,NULL,'CGCG 428-026',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.00009,NULL,'15.4g',0.46,'E0',NULL,NULL,NULL,NULL,1,331.080917,12.96839,0.273,NULL,52256574169,816508971,12757952,15.4),(153534,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153534,36.11,0.62,167,72830,70,NULL,NULL,'2MASX J22042077-7346477',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.000103,NULL,'17.0b',0.17,NULL,NULL,NULL,NULL,NULL,1,331.086583333,-73.77986,0.085,NULL,48416553712,756508651,11820447,17),(153535,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153535,33.93,0.2,61.1,72831,74.4,NULL,NULL,'UGC 11895',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000037,NULL,'14.2',0.9,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,331.093417,39.74375,0.941,NULL,55513884891,867404451,13553194,14.2),(153536,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153536,33.99,0.43,62.7,72831,75,NULL,'3.6 micron, color corrected','UGC 11895',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153537,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153537,34.06,0.43,65,72831,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11895',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153538,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153538,34.07,0.4,65.2,72831,NULL,NULL,'mean','UGC 11895',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153539,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153539,34.37,0.45,74.9,72831,NULL,NULL,'K','UGC 11895',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153540,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153540,34.39,0.46,75.6,72831,NULL,NULL,'J','UGC 11895',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153541,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153541,34.45,0.47,77.7,72831,NULL,NULL,'H','UGC 11895',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153542,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153542,36.58,0.55,207,72832,70,NULL,NULL,'2MASX J22042294-4837450',NULL,'2014MNRAS.445.2677S',2014,1,0.85,NULL,'G',0.000107,NULL,'15.50',0.62,'E',NULL,NULL,NULL,NULL,1,331.0955,-48.62919,0,NULL,50622726389,790980099,12359064,15.5),(153543,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SN 2006he',NULL,153543,39.6,0.08,831,72833,70,NULL,'Hubble residual 0.03 for z0.21390','SDSS-II SN 13305 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,331.100166667,0.69078,0.141,NULL,52182137928,815345905,12739779,NULL),(153544,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 13305','R',153544,40.16,0.19,886,72833,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006he','SDSS-II SN 13305 HOST',0.214812,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153545,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 13305','R',153545,40.31,0.11,949,72833,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006he','SDSS-II SN 13305 HOST',0.214812,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153546,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SN 2006he',NULL,153546,40.05,0.08,1020,72833,70,NULL,'SALT 2','SDSS-II SN 13305 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153547,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SN 2006he',NULL,153547,40.07,0.08,1030,72833,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13305 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153548,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153548,35.59,0.46,131,72834,70,NULL,NULL,'CGCG 377-020',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000107,NULL,'15.1g',0.49,'E0',NULL,NULL,NULL,NULL,1,331.1054583,0.71542,0.141,NULL,52182136107,815345876,12739779,15.1),(153549,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153549,35.7,0.77,138,72835,70,NULL,NULL,'2MASX J22042542-1935468',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'15.91',0.57,'S0',NULL,NULL,NULL,NULL,1,331.106,-19.59631,0.057,NULL,49739217790,777175277,12143363,15.91),(153550,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153550,37.01,0.46,253,72836,70,NULL,NULL,'2MASX J22043004+1153285',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,331.125166667,11.89119,0.325,NULL,52285445338,816960083,12765001,17.3),(153551,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153551,36.07,0.78,164,72837,70,NULL,NULL,'2MASX J22043286-2214118',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.93',0.26,NULL,NULL,NULL,NULL,NULL,1,331.137,-22.23669,0.057,NULL,50870590168,794852971,12419577,16.93),(153552,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153552,37.92,0.33,384,72838,70,NULL,NULL,'SDSS J220435.38+004729.2',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,331.147417,0.79144,0.141,NULL,52181678880,815338732,12739667,17.5),(153553,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 16592','RN',153553,43.27,0.25,2970,72839,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 16592',0.516442,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153554,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153554,38.58,0.46,520,72840,70,NULL,NULL,'2MASX J22043713+1150165',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,331.1547083,11.83792,0.325,NULL,52285455508,816960242,12765003,18.7),(153555,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153555,36.82,0.56,231,72841,70,NULL,NULL,'2MASX J22043802-2014198',NULL,'2014MNRAS.445.2677S',2014,1,0.28,NULL,'G',0.00015,NULL,'17.50',0.28,NULL,NULL,NULL,NULL,NULL,1,331.158416667,-20.23875,0.057,NULL,49741945777,777217902,12144029,17.5),(153556,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153556,36.05,0.49,162,72842,70,NULL,NULL,'2MASX J22044048-5015042',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'15.65',0.58,'E',NULL,NULL,NULL,NULL,1,331.168625,-50.25125,0,NULL,50629700925,791089076,12360766,15.65),(153557,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153557,37.92,0.33,384,72843,70,NULL,NULL,'2MASX J22044097+0044161',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000132,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,331.170875,0.73769,0.141,NULL,52182134476,815345851,12739778,18.3),(153558,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 15655',NULL,153558,38.84,1.18,587,72844,70,NULL,'SN photometric redshift distance, z photo =0.148 +/- 0.124','SDSS-II SN 15655',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,331.176667,0.78575,0.141,NULL,52181671032,815338609,12739665,NULL),(153559,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153559,34.33,0.2,73.5,72845,74.4,NULL,NULL,'ESO 532- G 017',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000147,NULL,'14.98',0.4,'SB(rs)d:',NULL,NULL,NULL,NULL,1,331.1797917,-26.40175,0.045,NULL,51408194320,803253036,12550828,14.98),(153560,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153560,34.47,0.46,78.2,72845,NULL,NULL,NULL,'ESO 532- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153561,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153561,34.47,0.46,78.3,72845,NULL,NULL,'Malmquist cor.','ESO 532- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153562,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153562,35.37,0.33,118,72846,NULL,NULL,NULL,'UGC 11896',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000017,NULL,'15.18',0.6,'Sbc',NULL,NULL,NULL,NULL,1,331.196625,15.79381,0.165,NULL,52276373114,816818329,12762786,15.18),(153563,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153563,35.36,0.34,118,72846,NULL,NULL,'Malmquist cor.','UGC 11896',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153564,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153564,35.38,0.2,119,72846,74.4,NULL,NULL,'UGC 11896',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153565,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153565,32.88,0.8,37.7,72847,75,NULL,'MAT, I','NGC 7179',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000033,NULL,'13.33',0.8,'SB(r)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,331.2055,-64.04683,0.009,NULL,49342337715,770974026,12046469,13.33),(153566,'Tully est','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153566,32.76,0.8,35.7,72847,75,NULL,NULL,'NGC 7179',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153567,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153567,33.08,0.4,41.2,72847,NULL,NULL,'mean','NGC 7179',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153568,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153568,33.22,0.46,44.1,72847,NULL,NULL,'J','NGC 7179',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153569,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153569,33.24,0.4,44.5,72847,NULL,NULL,NULL,'NGC 7179',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153570,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153570,33.26,0.47,44.9,72847,NULL,NULL,'H','NGC 7179',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153571,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153571,33.34,0.45,46.5,72847,NULL,NULL,'K','NGC 7179',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153572,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153572,33.37,0.36,47.2,72847,NULL,NULL,'Malmquist cor.','NGC 7179',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153573,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153573,33.41,0.32,48,72847,85,NULL,'I, raw','NGC 7179',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153574,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153574,33.46,0.32,49.3,72847,85,NULL,'I, inv','NGC 7179',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153575,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153575,33.48,0.43,49.6,72847,75,NULL,'MAT, I, raw','NGC 7179',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153576,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153576,33.5,0.43,50.1,72847,75,NULL,'MAT, I, cor','NGC 7179',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153577,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153577,33.63,0.32,53.2,72847,NULL,NULL,NULL,'NGC 7179',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153578,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153578,33.67,0.2,54.2,72847,74.4,NULL,NULL,'NGC 7179',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153579,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153579,33.75,0.43,56.1,72847,75,NULL,'MAT, I, inv','NGC 7179',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153580,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153580,36.93,0.79,243,72848,70,NULL,NULL,'2MASX J22044955-5737204',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'15.88',0.53,'S',NULL,NULL,NULL,NULL,1,331.2062917,-57.62242,0,NULL,48707133147,761048955,11891389,15.88),(153581,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153581,38.29,0.46,456,72849,70,NULL,NULL,'2MASX J22045100+0018513',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000155,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,331.212667,0.31419,0.129,NULL,52182231640,815347369,12739802,17),(153582,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 13018','RN',153582,39.21,0.34,610,72850,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13018',0.141205,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153583,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 13018','RN',153583,39.67,0.37,754,72850,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13018',0.141205,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153584,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153584,37.83,0.46,368,72851,70,NULL,NULL,'2MASX J22045753+0050423',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000195,NULL,'17.6g',0.21,'NLAGN',NULL,NULL,NULL,NULL,1,331.239625,0.84503,0.141,NULL,52181723699,815339432,12739678,17.6),(153585,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153585,34.39,NULL,75.6,72852,NULL,NULL,NULL,'ESO 075- G 053',NULL,'2000BSAO...50....5K',2000,1,1.34,NULL,'G',0.000033,NULL,'16.10',0.18,'Sc',NULL,NULL,NULL,NULL,1,331.254041667,-69.97669,0.033,NULL,49309419368,770459677,12038432,16.1),(153586,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153586,34.44,NULL,77.1,72852,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 075- G 053',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153587,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153587,34.44,NULL,77.4,72852,NULL,NULL,'Dipole + Quadrupole','ESO 075- G 053',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153588,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153588,34.47,NULL,78.2,72852,NULL,NULL,'Dipole','ESO 075- G 053',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153589,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153589,35.63,0.43,133,72852,NULL,NULL,'Malmquist cor.','ESO 075- G 053',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153590,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153590,35.76,0.4,142,72852,NULL,NULL,NULL,'ESO 075- G 053',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153591,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153591,35.8,0.2,145,72852,74.4,NULL,NULL,'ESO 075- G 053',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153592,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153592,37.16,0.46,270,72853,70,NULL,NULL,'2MASX J22050401-0901272',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.00015,NULL,'15.9g',0.42,'E0',NULL,NULL,NULL,NULL,1,331.266833,-9.02411,0.081,NULL,49867553591,779180524,12174695,15.9),(153593,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 08216',NULL,153593,38.39,0.76,476,72854,70,NULL,'SN photometric redshift distance, z photo =0.118 +/- 0.054','SDSS-II SN 08216',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.6g',0.02,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,331.2695,-0.05211,0.149,NULL,49820023998,778437874,12163091,21.6),(153594,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 08216','R',153594,40.84,0.25,1140,72854,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 08216',0.291349,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153595,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 08216','R',153595,40.9,0.22,1170,72854,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 08216',0.291349,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153596,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 08216',NULL,153596,40.68,0.16,1370,72854,70,NULL,'SALT 2','SDSS-II SN 08216',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153597,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 08216',NULL,153597,40.71,0.16,1390,72854,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 08216',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153598,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153598,33.94,0.69,61.5,72855,100,NULL,'mid-IR','CGCG 473-003',NULL,'2013ApJ...771...88L',2013,1,0.8,NULL,'G',0.000033,NULL,'14.98',0.5,'Sa','Isolated galaxy',NULL,NULL,NULL,1,331.2872083,26.60711,0.325,NULL,55567535185,868242737,13566292,14.98),(153599,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153599,34.73,0.4,88.2,72855,NULL,NULL,'mean','CGCG 473-003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153600,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153600,34.87,0.47,94.1,72855,NULL,NULL,'H','CGCG 473-003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153601,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 05490','RN',153601,37.85,0.22,338,72856,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05490',0.098073,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153602,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153602,33.82,0.46,58.1,72857,70,NULL,NULL,'NGC 7198',NULL,'2015arXiv151105856S',2015,1,1.5,NULL,'G',0.000137,NULL,'14.31',1,'S0 pec',NULL,NULL,NULL,NULL,1,331.309333,-0.64828,0.193,NULL,49820751984,778449249,12163269,14.31),(153603,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153603,34.13,0.52,66.9,72857,70,NULL,NULL,'NGC 7198',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153604,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153604,35.25,0.58,112,72858,70,NULL,NULL,'2MASX J22051543-0107334',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.000086,NULL,'15.3g',0.47,'NLAGN',NULL,NULL,NULL,'Sy 2',1,331.3142917,-1.12594,0.193,NULL,49823449261,778491394,12163928,15.3),(153605,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153605,33.87,0.8,59.6,72859,75,NULL,'MAT, I','ESO 146- G 006',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'15.45',0.25,'Sc','in a pair',NULL,NULL,NULL,1,331.315875,-60.67625,0,NULL,48685910475,760717351,11886208,15.45),(153606,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153606,31.97,0.32,24.8,72859,85,NULL,'I, inv','ESO 146- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153607,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153607,31.98,0.32,24.9,72859,85,NULL,'I, raw','ESO 146- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153608,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153608,32.23,0.43,28,72859,75,NULL,'MAT, I, raw','ESO 146- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153609,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153609,32.27,0.43,28.4,72859,75,NULL,'MAT, I, inv','ESO 146- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153610,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153610,32.58,0.43,32.9,72859,75,NULL,'MAT, I, cor','ESO 146- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153611,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153611,33.11,0.49,41.9,72859,75,NULL,'IR','ESO 146- G 006',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153612,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153612,33.31,0.47,45.9,72859,NULL,NULL,'Malmquist cor.','ESO 146- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153613,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153613,33.47,NULL,49.5,72859,NULL,NULL,NULL,'ESO 146- G 006',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153614,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153614,33.62,0.4,52.9,72859,NULL,NULL,NULL,'ESO 146- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153615,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153615,33.66,0.2,54,72859,74.4,NULL,NULL,'ESO 146- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153616,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153616,33.78,NULL,57,72859,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 146- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153617,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153617,33.81,NULL,57.7,72859,NULL,NULL,'Dipole + Quadrupole','ESO 146- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153618,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153618,33.82,NULL,58.1,72859,NULL,NULL,'Dipole','ESO 146- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153619,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153619,33.35,NULL,46.8,72860,NULL,NULL,'Dipole + Quadrupole + Octopole','FGCE 1693',NULL,'2010Ap&SS.325..163P',2010,1,0.99,NULL,'G',0.000013,NULL,'17.0',0.1,'Sd',NULL,NULL,NULL,NULL,1,331.335,-20.61361,0.061,NULL,49742173868,777221466,12144085,17),(153620,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153620,33.37,NULL,47.1,72860,NULL,NULL,'Dipole + Quadrupole','FGCE 1693',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153621,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153621,33.39,NULL,47.7,72860,NULL,NULL,'Dipole','FGCE 1693',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153622,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153622,33.4,NULL,47.8,72860,NULL,NULL,NULL,'FGCE 1693',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153623,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153623,35.22,0.5,111,72861,70,NULL,NULL,'2MASX J22052165-0725094',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.5g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,331.3402083,-7.41942,0.093,NULL,49866744580,779167884,12174498,15.5),(153624,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153624,35.27,0.46,113,72861,70,NULL,NULL,'2MASX J22052165-0725094',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153625,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153625,34.94,0.49,97.1,72862,75,NULL,'IR','UGC 11901',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000157,NULL,'15.41',0.2,'S?',NULL,NULL,NULL,NULL,1,331.3422083,5.18389,0.149,NULL,52194391186,815537362,12742771,15.41),(153626,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153626,37.9,0.61,381,72863,70,NULL,NULL,'2MASX J22052593-1822307',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.83',0.37,NULL,NULL,NULL,NULL,NULL,1,331.357917,-18.37519,0.065,NULL,49738199112,777159361,12143115,16.83),(153627,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153627,35.94,0.64,154,72864,70,NULL,NULL,'2MASX J22052605-1935557',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'16.37',0.25,'S',NULL,NULL,NULL,NULL,1,331.3585417,-19.59883,0.057,NULL,49740574597,777196478,12143694,16.37),(153628,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153628,35.52,0.65,127,72865,70,NULL,NULL,'2MFGC 16658',NULL,'2014MNRAS.445.2677S',2014,1,1.19,NULL,'G',0.0001,NULL,'15.4g',0.26,'Sb',NULL,NULL,NULL,NULL,1,331.362541667,-0.53344,0.193,NULL,49820982385,778452849,12163325,15.4),(153629,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 14809','R',153629,41.92,0.33,1760,72866,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J220530.24-003922.0',0.371489,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',NULL,'PHOT','21.4g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,331.376,-0.65611,0.193,NULL,49820973803,778452715,12163323,21.4),(153630,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 14809','R',153630,42.03,0.28,1860,72866,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J220530.24-003922.0',0.371489,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153631,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 14809',NULL,153631,41.82,0.21,2310,72866,70,NULL,'SALT 2','SDSS J220530.24-003922.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153632,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 14809',NULL,153632,41.87,0.21,2370,72866,70,NULL,'SALT 2, Malmquist cor.','SDSS J220530.24-003922.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153633,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153633,36.05,0.63,162,72867,NULL,NULL,NULL,'LCSB S2619P',NULL,'2009ApJS..182..474S',2009,1,0.61,NULL,'G',0.00015,NULL,'15.7V',0.35,NULL,NULL,NULL,NULL,NULL,1,331.3922917,-5.66803,0.149,NULL,49846098321,778845286,12169457,15.7),(153634,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153634,36.09,0.2,165,72867,74.4,NULL,NULL,'LCSB S2619P',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153635,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153635,36.26,0.57,179,72867,NULL,NULL,'Malmquist cor.','LCSB S2619P',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153636,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153636,34.27,0.4,71.3,72868,NULL,NULL,'mean','UGC 11906',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000087,NULL,'17.',0.3,'Sb-c',NULL,NULL,NULL,NULL,1,331.409041667,44.84061,NULL,NULL,55507935538,867311492,13551742,17),(153637,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153637,34.35,0.47,74,72868,NULL,NULL,'H','UGC 11906',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153638,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153638,37.49,0.46,315,72869,70,NULL,NULL,'2MASX J22053874-0856302',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,331.4115,-8.94178,0.081,NULL,49867432936,779178639,12174666,17.5),(153639,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153639,37.56,0.46,325,72870,70,NULL,NULL,'2MASX J22053968-0045310',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,331.415333,-0.75853,0.193,NULL,49820549260,778446082,12163220,17.4),(153640,'SBF','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153640,33.11,0.3,41.9,72871,NULL,NULL,'Malmquist cor.','NGC 7196',NULL,'2001MNRAS.327.1004B',2001,1,2.5,NULL,'G',0.000063,NULL,'12.40',1.8,'E:','Parent (of companion) galaxy',NULL,NULL,NULL,1,331.478375,-50.11933,0,NULL,50629631958,791087999,12360749,12.4),(153641,'SBF','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153641,33.27,0.3,45.1,72871,NULL,NULL,'I','NGC 7196',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153642,'SBF','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153642,33.27,0.3,45.1,72871,NULL,NULL,NULL,'NGC 7196',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153643,'SBF','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153643,33.28,0.14,45.3,72871,74.4,NULL,NULL,'NGC 7196',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153644,'D-Sigma','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153644,33.47,0.4,49.4,72871,75,NULL,'Edat, raw','NGC 7196',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153645,'D-Sigma','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153645,33.66,0.4,54,72871,75,NULL,'Edat, cor','NGC 7196',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153646,'Faber-Jackson','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153646,31.99,0.37,25,72871,95,NULL,'Weighted Mean','NGC 7196',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153647,'Faber-Jackson','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153647,32.01,0.63,25.2,72871,95,NULL,'Michard 1979b, c','NGC 7196',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153648,'Faber-Jackson','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153648,32.4,0.46,30.2,72871,95,NULL,'Michard 1979a','NGC 7196',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153649,'Faber-Jackson','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153649,33.6,0.81,52.5,72871,55,NULL,'Visvanathan & Sandage 1979','NGC 7196',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153650,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153650,33.25,0.41,44.7,72871,NULL,NULL,'Malmquist cor.','NGC 7196',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153651,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153651,33.38,0.41,47.4,72871,NULL,NULL,NULL,'NGC 7196',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153652,'Tertiary','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153652,32.17,0.41,27.2,72871,95,NULL,NULL,'NGC 7196',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153653,'Tully est','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153653,32.87,0.8,37.6,72871,75,NULL,'B','NGC 7196',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153654,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153654,32.99,0.4,39.7,72871,NULL,NULL,'mean','NGC 7196',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153655,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153655,33.33,0.45,46.4,72871,NULL,NULL,'K','NGC 7196',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153656,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153656,37.05,0.53,256,72872,70,NULL,NULL,'2MASX J22055607-1028152',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.000103,NULL,'15.60',0.5,NULL,NULL,NULL,NULL,NULL,1,331.483625,-10.47092,0.073,NULL,49878148058,779346063,12177282,15.6),(153657,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153657,37.35,0.46,295,72873,70,NULL,NULL,'2MASX J22055648-0841402',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,331.48525,-8.69444,0.085,NULL,49869442632,779210041,12175156,17.9),(153658,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153658,36.78,0.46,227,72874,70,NULL,NULL,'2MASX J22055698-0927172',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000161,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,331.4875,-9.45469,0.073,NULL,49875214941,779300233,12176566,17.1),(153659,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153659,35.98,0.5,157,72875,70,NULL,NULL,'2MASX J22061212-5033317',NULL,'2014MNRAS.445.2677S',2014,1,0.14,NULL,'G',0.00015,NULL,'19.49',0.1,NULL,NULL,NULL,NULL,NULL,1,331.5505,-50.55875,0,NULL,50630405203,791100081,12360938,19.49),(153660,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153660,36.73,0.46,222,72876,70,NULL,NULL,'2MASX J22061582+1148094',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000072,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,331.566,11.80247,0.221,NULL,52284555599,816946181,12764784,16.7),(153661,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153661,30.45,0.2,12.3,72877,74.4,NULL,NULL,'UGC 11909',NULL,'2013AJ....146...86T',2013,1,3,'The Bologna position is 5 arcsec southeast of the eccentric nucleus.','G',0.000003,NULL,'13.25',0.7,'S pec',NULL,NULL,NULL,NULL,1,331.567375,47.25122,NULL,NULL,55415592758,865868636,13529197,13.25),(153662,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153662,30.73,0.4,14,72877,NULL,NULL,NULL,'UGC 11909',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153663,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153663,30.83,0.49,14.7,72877,75,NULL,'IR','UGC 11909',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153664,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153664,31.38,0.4,18.8,72877,75,NULL,'B','UGC 11909',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153665,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 21058','RN',153665,39.33,0.1,631,72878,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 21058',0.1643,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153666,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 21058','RN',153666,39.54,0.21,695,72878,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 21058',0.1643,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153667,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153667,36.28,0.33,180,72879,70,NULL,NULL,'CGCG 377-024',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.00009,NULL,'15.1g',0.6,'E0',NULL,NULL,NULL,NULL,1,331.5855,1.12103,0.113,NULL,52181817491,815340898,12739701,15.1),(153668,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153668,34.91,0.46,96.1,72880,70,NULL,NULL,'NGC 7211',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000103,NULL,'14.6g',0.65,'S0o:',NULL,NULL,NULL,NULL,1,331.591125,-8.08997,0.085,NULL,49870167065,779221360,12175333,14.6),(153669,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153669,35.06,0.46,103,72880,70,NULL,NULL,'NGC 7211',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153670,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 19414','R',153670,40.63,0.25,1030,72881,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19414',0.291833,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,'PHOT','20.7g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,331.591708333,0.04017,0.145,NULL,52181372147,815333939,12739592,20.7),(153671,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 19414',NULL,153671,40.15,1.41,1070,72881,70,NULL,'SN photometric redshift distance, z photo =0.292 +/- 0.397','SDSS-II SN 19414',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153672,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 19414','R',153672,40.92,0.33,1180,72881,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19414',0.291833,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153673,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 19414',NULL,153673,40.92,0.21,1530,72881,70,NULL,'SALT 2','SDSS-II SN 19414',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153674,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 19414',NULL,153674,40.94,0.21,1540,72881,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19414',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153675,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153675,37.46,0.46,310,72882,70,NULL,NULL,'2MASX J22062338-0059189',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000152,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,331.597583,-0.98864,0.193,NULL,49820577614,778446525,12163226,17.4),(153676,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153676,35.23,NULL,111,72883,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2364',NULL,'2010Ap&SS.325..163P',2010,1,0.84,NULL,'G',0.000015,NULL,'16.0',0.11,'Sc',NULL,NULL,NULL,NULL,1,331.6,17.43389,0.137,NULL,52273745233,816777269,12762144,16),(153677,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153677,35.25,NULL,112,72883,NULL,NULL,'Dipole + Quadrupole','FGC 2364',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153678,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153678,35.27,NULL,113,72883,NULL,NULL,'Dipole','FGC 2364',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153679,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153679,35.33,NULL,116,72883,NULL,NULL,NULL,'FGC 2364',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153680,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153680,35.73,0.44,140,72883,NULL,NULL,'Malmquist cor.','FGC 2364',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153681,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153681,35.82,0.2,146,72883,74.4,NULL,NULL,'FGC 2364',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153682,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153682,35.91,0.4,152,72883,NULL,NULL,NULL,'FGC 2364',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153683,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 00976','RN',153683,42.19,0.2,1810,72884,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00976',0.514778,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153684,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153684,35.74,0.52,141,72885,70,NULL,NULL,'2MASX J22063469-7113233',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.03',0.48,'S0',NULL,NULL,NULL,NULL,1,331.644458333,-71.22325,0.013,NULL,49304644283,770385066,12037266,16.03),(153685,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 09387','RN',153685,43.08,0.26,2870,72886,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 09387',0.439001,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153686,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 09387','RN',153686,43.13,0.29,2930,72886,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 09387',0.439001,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153687,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153687,35.54,0.31,128,72887,NULL,NULL,'Malmquist cor.','CGCG 451-009',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000033,NULL,'15.4',0.4,'Sk:',NULL,NULL,NULL,NULL,1,331.658333,17.46083,0.137,NULL,52266339980,816661562,12760336,15.4),(153688,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153688,35.82,0.27,146,72887,NULL,NULL,NULL,'CGCG 451-009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153689,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153689,36.19,0.2,173,72887,74.4,NULL,NULL,'CGCG 451-009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153690,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153690,36.28,0.33,180,72888,70,NULL,NULL,'2MASX J22063845+0110365',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000194,NULL,'15.8g',0.42,'E0',NULL,NULL,NULL,NULL,1,331.66025,1.17689,0.113,NULL,52181634673,815338041,12739656,15.8),(153691,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153691,34.98,0.5,99,72889,70,NULL,NULL,'ESO 075- G 054',NULL,'2014MNRAS.445.2677S',2014,1,1.16,NULL,'G',0.00015,NULL,'15.26',0.25,'S0+: sp',NULL,NULL,NULL,NULL,1,331.674041667,-71.68878,0.017,NULL,49297026293,770266035,12035406,15.26),(153692,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153692,33.27,0.49,45.1,72890,75,NULL,'IR','UGC 11918',NULL,'2011yCatp016004901K',2011,1,1.02,NULL,'G',0.000053,NULL,'17.',0.14,'Sc',NULL,NULL,NULL,NULL,1,331.688791667,75.04769,1.529,NULL,52794017124,824906517,12889164,17),(153693,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153693,33.95,0.43,61.6,72890,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11918',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153694,'SBF','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153694,32.89,0.32,37.8,72891,NULL,NULL,'I','NGC 7192',NULL,'2001ApJ...546..681T',2001,1,2,'The APMUKS position is east of the nucleus.','G',0.000043,NULL,'12.19',1.9,'SA0^-          LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,331.709,-64.31625,0,NULL,49278365599,769974462,12030850,12.19),(153695,'SBF','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153695,32.89,0.32,37.8,72891,NULL,NULL,NULL,'NGC 7192',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153696,'SBF','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153696,32.94,0.14,38.7,72891,74.4,NULL,NULL,'NGC 7192',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153697,'SBF','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153697,33.07,0.32,41,72891,NULL,NULL,'Malmquist cor.','NGC 7192',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153698,'D-Sigma','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153698,32.1,0.4,26.3,72891,75,NULL,'Edat, raw','NGC 7192',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153699,'D-Sigma','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153699,32.43,0.4,30.6,72891,75,NULL,'Edat, cor','NGC 7192',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153700,'Faber-Jackson','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153700,30.55,0.65,12.9,72891,95,NULL,'Weighted Mean','NGC 7192',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153701,'Faber-Jackson','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153701,31.66,0.81,21.5,72891,55,NULL,'Visvanathan & Sandage 1979','NGC 7192',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153702,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153702,32.29,0.41,28.6,72891,NULL,NULL,NULL,'NGC 7192',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153703,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153703,32.7,0.41,34.6,72891,NULL,NULL,'Malmquist cor.','NGC 7192',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153704,'Tully est','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153704,32.76,0.8,35.6,72891,75,NULL,'B','NGC 7192',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153705,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153705,32.91,0.45,38.2,72891,NULL,NULL,'K','NGC 7192',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153706,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153706,33.03,0.4,40.3,72891,NULL,NULL,'mean','NGC 7192',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153707,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153707,32.84,0.8,37.1,72892,75,NULL,'MAT, I','NGC 7191',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'13.77',0.6,'SAB(rs)c       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,331.7157917,-64.63456,0.009,NULL,49276485074,769945079,12030391,13.77),(153708,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153708,32.42,0.32,30.5,72892,85,NULL,'I, raw','NGC 7191',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153709,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153709,32.44,0.32,30.7,72892,85,NULL,'I, inv','NGC 7191',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153710,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153710,32.69,NULL,34.5,72892,NULL,NULL,'I','NGC 7191',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153711,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153711,32.72,0.43,34.9,72892,75,NULL,'MAT, I, raw','NGC 7191',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153712,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153712,32.79,0.45,36.1,72892,NULL,NULL,NULL,'NGC 7191',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153713,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153713,32.83,0.2,36.8,72892,74.4,NULL,NULL,'NGC 7191',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153714,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153714,32.84,0.43,36.9,72892,75,NULL,'MAT, I, inv','NGC 7191',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153715,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153715,32.85,0.47,37.1,72892,NULL,NULL,'H','NGC 7191',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153716,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153716,32.85,0.46,37.2,72892,NULL,NULL,'J','NGC 7191',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153717,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153717,32.89,0.45,37.9,72892,NULL,NULL,'K','NGC 7191',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153718,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153718,32.94,0.43,38.7,72892,75,NULL,'MAT, I, cor','NGC 7191',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153719,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153719,33,NULL,39.9,72892,NULL,NULL,'B','NGC 7191',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153720,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153720,33.04,0.4,40.5,72892,NULL,NULL,'Malmquist cor.','NGC 7191',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153721,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153721,33.05,0.4,40.7,72892,NULL,NULL,'mean','NGC 7191',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153722,'Tully est','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153722,32.63,0.8,33.5,72893,75,NULL,NULL,'NGC 7204',NULL,'1988NBGC.C....0000T',1988,1,NULL,NULL,'GPair',NULL,NULL,NULL,NULL,'S0/a pec:','Group member',NULL,NULL,NULL,1,331.725833,-31.05139,0,NULL,50537559720,789649370,12338271,NULL),(153723,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153723,37.77,0.21,358,72894,70,NULL,NULL,'SDSS J220656.31-091505.2',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,331.734667,-9.25147,0.089,NULL,49877884767,779341949,12177217,18.2),(153724,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153724,38.46,0.46,493,72895,70,NULL,NULL,'2MASX J22065889+0003499',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000167,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,331.7452917,0.06375,0.145,NULL,52181390956,815334233,12739597,18.1),(153725,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153725,37.1,0.14,263,72896,70,NULL,NULL,'SDSS J220704.20-073500.0',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,331.7675,-7.58336,0.097,NULL,49869514648,779211166,12175174,17.9),(153726,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153726,36.71,0.46,220,72897,70,NULL,NULL,'2MASX J22070462-0006000',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00015,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,331.7692083,-0.10011,0.161,NULL,49820004404,778437568,12163087,16.6),(153727,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153727,36.98,0.46,249,72898,70,NULL,NULL,'2MASX J22070676+1301583',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00017,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,331.778083333,13.03294,0.213,NULL,52255931998,816498937,12757795,16.5),(153728,'SBF','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153728,32.71,0.32,34.8,72899,NULL,NULL,'I','NGC 7200',NULL,'2001ApJ...546..681T',2001,1,1.6,'6dF has z = 0.057530 +- 0.000150.','G',0.000043,NULL,'13.78',1.2,'E+:','Group member',NULL,NULL,NULL,1,331.789666667,-49.99547,0,NULL,50630308971,791098577,12360915,13.78),(153729,'SBF','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153729,32.71,0.32,34.8,72899,NULL,NULL,NULL,'NGC 7200',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153730,'SBF','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153730,32.71,0.14,34.8,72899,74.4,NULL,NULL,'NGC 7200',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153731,'SBF','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153731,32.8,0.32,36.3,72899,NULL,NULL,'Malmquist cor.','NGC 7200',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153732,'D-Sigma','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153732,33.47,0.4,49.4,72899,75,NULL,'Edat, raw','NGC 7200',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153733,'D-Sigma','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153733,33.66,0.4,54,72899,75,NULL,'Edat, cor','NGC 7200',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153734,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153734,34.34,0.41,73.7,72899,NULL,NULL,NULL,'NGC 7200',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153735,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153735,34.83,0.41,92.3,72899,NULL,NULL,'Malmquist cor.','NGC 7200',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153736,'Tully est','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153736,32.82,0.8,36.7,72899,75,NULL,NULL,'NGC 7200',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153737,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153737,32.71,0.4,34.8,72899,73,NULL,'opt','NGC 7200',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153738,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 01609','RN',153738,41.26,0.16,1250,72900,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01609',0.425523,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153739,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 01609','RN',153739,41.46,0.22,1370,72900,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01609',0.425523,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153740,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153740,37.1,0.14,263,72901,70,NULL,NULL,'2MASX J22071494-0730213',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000193,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,331.8122917,-7.50592,0.109,NULL,49866661235,779166581,12174477,16.3),(153741,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153741,36.37,0.53,188,72902,70,NULL,NULL,'2MASX J22071594-5311356',NULL,'2014MNRAS.445.2677S',2014,1,0.87,NULL,'G',0.00011,NULL,'15.60',0.5,'S0',NULL,NULL,NULL,NULL,1,331.816333,-53.19319,0,NULL,50627031546,791047367,12360115,15.6),(153742,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 14786',NULL,153742,40.03,0.34,1010,72903,70,NULL,'SN photometric redshift distance, z photo =0.273 +/- 0.056','SDSS-II SN 14786',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,331.820416667,-0.32144,0.181,NULL,49819977245,778437144,12163080,NULL),(153743,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153743,37.1,0.14,263,72904,70,NULL,NULL,'2MASX J22071959-0743083',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00015,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,331.8315417,-7.71892,0.097,NULL,49869541160,779211580,12175180,16.7),(153744,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153744,37.1,0.14,263,72905,70,NULL,NULL,'2MASX J22072072-0728583',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,331.836333333,-7.48303,0.109,NULL,49866659822,779166559,12174477,17.8),(153745,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153745,37.77,0.21,358,72906,70,NULL,NULL,'SDSS J220723.30-093148.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00016,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,331.847125,-9.53017,0.073,NULL,49878126284,779345723,12177276,18.6),(153746,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153746,37.1,0.14,263,72907,70,NULL,NULL,'2MASX J22072496-0732193',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000184,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,331.853875,-7.53861,0.109,NULL,49866613524,779165836,12174466,17.5),(153747,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153747,37.1,0.14,263,72908,70,NULL,NULL,'2MASX J22072523-0725353',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000178,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,331.855166667,-7.42636,0.109,NULL,49866664342,779166630,12174478,17),(153748,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153748,33.01,0.4,40,72909,NULL,NULL,'mean','MCG -02-56-014',NULL,'2007A&A...465...71T',2007,1,0.6,NULL,'G',0.000023,NULL,'15.41',0.2,'Sbc','Pair member, contact system',NULL,NULL,NULL,1,331.857333333,-10.71203,0.077,NULL,49876257604,779316525,12176820,15.41),(153749,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153749,33.39,0.47,47.6,72909,NULL,NULL,'H','MCG -02-56-014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153750,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153750,33.39,0.2,47.6,72909,74.4,NULL,NULL,'MCG -02-56-014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153751,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153751,33.41,0.45,48,72909,NULL,NULL,'K','MCG -02-56-014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153752,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153752,33.45,0.46,48.9,72909,NULL,NULL,'J','MCG -02-56-014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153753,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153753,37.1,0.14,263,72910,70,NULL,NULL,'2MASX J22072610-0721183',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00015,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,331.8587083,-7.35519,0.109,NULL,49866629358,779166083,12174470,16.7),(153754,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153754,34.77,0.8,89.9,72911,75,NULL,'MAT, I','ESO 601- G 019',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.80',0.5,'SB(s)cd:',NULL,NULL,NULL,NULL,1,331.862625,-20.84281,0.065,NULL,49741774814,777215231,12143987,14.8),(153755,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153755,33.78,0.32,57.1,72911,85,NULL,'I, raw','ESO 601- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153756,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153756,33.81,0.32,57.9,72911,85,NULL,'I, inv','ESO 601- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153757,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153757,33.85,0.43,58.9,72911,75,NULL,'MAT, I, raw','ESO 601- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153758,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153758,34.01,0.43,63.4,72911,75,NULL,'MAT, I, inv','ESO 601- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153759,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153759,34.14,0.43,67.2,72911,75,NULL,'MAT, I, cor','ESO 601- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153760,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153760,34.73,0.51,88.1,72911,NULL,NULL,'Malmquist cor.','ESO 601- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153761,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153761,34.86,0.48,93.8,72911,NULL,NULL,NULL,'ESO 601- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153762,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153762,34.9,0.2,95.5,72911,74.4,NULL,NULL,'ESO 601- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153763,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153763,36.18,0.5,172,72912,70,NULL,NULL,'2MASX J22072745-4349538',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.000133,NULL,'15.43',0.52,'E',NULL,NULL,NULL,NULL,1,331.864458333,-43.83169,0,NULL,50675539791,791805309,12371957,15.43),(153764,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153764,37.77,0.21,358,72913,70,NULL,NULL,'2MASX J22072780-0929513',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000103,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,331.865875,-9.49753,0.077,NULL,49878094245,779345222,12177269,16.3),(153765,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 15456','R',153765,41.13,0.27,1220,72914,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ll','SDSS-II SN 15456 HOST',0.3821,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,331.866833333,-0.90381,0.193,NULL,49854419688,778975307,12171489,NULL),(153766,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SN 2006ll',NULL,153766,40.46,0.24,1230,72914,70,NULL,'Hubble residual -0.18 for z0.38210','SDSS-II SN 15456 HOST',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153767,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 15456','R',153767,41.38,0.24,1370,72914,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ll','SDSS-II SN 15456 HOST',0.3821,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153768,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153768,35.46,0.49,123,72915,70,NULL,NULL,'MCG -07-45-010',NULL,'2014MNRAS.445.2677S',2014,1,0.71,NULL,'G',0.000133,NULL,'15.36',0.59,'E',NULL,NULL,NULL,NULL,1,331.876166667,-43.59578,0,NULL,50675528202,791805128,12371955,15.36),(153769,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153769,37.03,0.46,254,72916,70,NULL,NULL,'2MASX J22073644-0111594',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000181,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,331.90175,-1.19981,0.205,NULL,49854015947,778968999,12171390,17.2),(153770,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153770,35.42,0.59,122,72917,70,NULL,NULL,'2MASX J22073908-7254474',NULL,'2014MNRAS.445.2677S',2014,1,0.26,NULL,'G',0.00015,NULL,'16.7b',0.13,NULL,NULL,NULL,NULL,NULL,1,331.9127083,-72.91311,0.053,NULL,49298672870,770291763,12035808,16.7),(153771,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153771,36.01,0.7,159,72918,70,NULL,NULL,'2MASX J22073950-4903498',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00014,NULL,'16.78',0.33,NULL,NULL,NULL,NULL,NULL,1,331.915125,-49.06394,0,NULL,50622951916,790983623,12359119,16.78),(153772,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153772,35.37,0.55,119,72919,70,NULL,NULL,'ESO 237-IG 039 NED02',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.51',NULL,NULL,NULL,NULL,NULL,NULL,1,331.925,-47.37294,0,NULL,50621510225,790961097,12358767,16.51),(153773,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153773,36.76,0.46,225,72920,70,NULL,NULL,'2MASX J22074566-0819021',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,331.940083,-8.31722,0.125,NULL,49868506959,779195421,12174928,16.5),(153774,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153774,37.78,0.33,359,72921,70,NULL,NULL,'2MASX J22074602+0018290',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000179,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,331.941833,0.30806,0.133,NULL,52198164059,815596313,12743692,18.1),(153775,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153775,37.72,0.46,350,72922,70,NULL,NULL,'2MASX J22074688-0042088',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,331.94525,-0.70253,0.173,NULL,49853589872,778962341,12171286,18.3),(153776,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 19893','RN',153776,38.72,0.73,499,72923,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 19893',0.109389,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153777,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 19893','RN',153777,39.6,0.54,749,72923,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 19893',0.109389,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153778,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 15539',NULL,153778,39.51,0.52,800,72924,70,NULL,'SN photometric redshift distance, z photo =0.208 +/- 0.066','SDSS-II SN 15539',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,331.950167,0.16694,0.153,NULL,52198119215,815595612,12743681,NULL),(153779,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153779,37.6,0.46,331,72925,70,NULL,NULL,'2MASX J22074918-0859241',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,331.955083,-8.99003,0.101,NULL,49868723590,779198806,12174981,17.4),(153780,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153780,37.37,0.46,298,72926,70,NULL,NULL,'2MASXi J2207497-071105',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'17.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,331.957417,-7.18475,0.117,NULL,49837005288,778703207,12167237,17.8),(153781,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','PTF11opu','N',153781,39.03,0.05,601,72927,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF11opu',0.0649,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153782,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SN 2007mz',NULL,153782,39.55,0.1,811,72928,70,NULL,'Hubble residual -0.18 for z0.23220','SDSS J220751.19-010412.3',NULL,'2011ApJ...740...92G',2011,1,0.08,NULL,'G',0.0005,NULL,'20.6g',0.06,NULL,NULL,NULL,NULL,NULL,1,331.963291667,-1.07008,0.193,NULL,49853924797,778967574,12171368,20.6),(153783,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 19008','R',153783,40.14,0.22,866,72928,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007mz','SDSS J220751.19-010412.3',0.2322,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153784,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 19008','R',153784,40.24,0.12,907,72928,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007mz','SDSS J220751.19-010412.3',0.2322,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153785,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153785,37.75,0.33,355,72929,70,NULL,NULL,'2MASX J22075143-0938471',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000142,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,331.964333333,-9.6465,0.073,NULL,49878131629,779345806,12177278,17.3),(153786,'Ring Diameter','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153786,31.5,0.98,20,72930,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7217',NULL,'1981ApJS...45..541P',1981,1,3.9,NULL,'G',0.000006,NULL,'11.02',3.2,'(R)SA(r)ab;Sy  LINER','Isolated galaxy',NULL,NULL,'LINER',1,331.9682917,31.35933,0.413,NULL,55440875671,866263682,13535370,11.02),(153787,'Ring Diameter','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153787,31.8,0.76,23,72930,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7217',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153788,'Tully est','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153788,31.02,0.8,16,72930,75,NULL,'B','NGC 7217',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153789,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153789,31.32,NULL,18.4,72930,NULL,NULL,'B','NGC 7217',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153790,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153790,37.78,0.33,359,72931,70,NULL,NULL,'2MASX J22075362+0018110',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,331.9735417,0.30303,0.129,NULL,52198165578,815596337,12743692,17),(153791,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153791,37.75,0.33,355,72932,70,NULL,NULL,'2MASX J22075630-0937251',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,331.984708333,-9.62353,0.073,NULL,49878098373,779345287,12177270,17.7),(153792,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153792,38.28,0.46,452,72933,70,NULL,NULL,'SDSS J220757.61+000430.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000142,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,331.9900417,0.07528,0.153,NULL,52151991987,814874874,12732419,18.6),(153793,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153793,34.22,NULL,69.8,72934,NULL,NULL,'Dipole','FGC 2367',NULL,'2010Ap&SS.325..163P',2010,1,1.06,NULL,'G',0.000023,NULL,'16.8',0.1,'Scd',NULL,NULL,NULL,NULL,1,332.000833,15.71833,0.181,NULL,52267508219,816679815,12760622,16.8),(153794,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153794,34.23,NULL,70,72934,NULL,NULL,'Dipole + Quadrupole','FGC 2367',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153795,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153795,34.23,NULL,70.1,72934,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2367',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153796,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153796,34.52,NULL,80.2,72934,NULL,NULL,NULL,'FGC 2367',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153797,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153797,36,0.6,158,72935,70,NULL,NULL,'2MASX J22080309-1635173',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.01',NULL,NULL,NULL,NULL,NULL,NULL,1,332.012917,-16.58814,0.093,NULL,49787726460,777933225,12155206,16.01),(153798,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153798,33.1,NULL,41.6,72936,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2366',NULL,'2010Ap&SS.325..163P',2010,1,2.16,NULL,'G',0.000013,NULL,'16.0',0.1,'Sd',NULL,NULL,NULL,NULL,1,332.02,-10.33306,0.077,NULL,49878505345,779351646,12177369,16),(153799,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153799,33.11,NULL,41.9,72936,NULL,NULL,'Dipole','FGC 2366',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153800,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153800,33.11,NULL,41.9,72936,NULL,NULL,'Dipole + Quadrupole','FGC 2366',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153801,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153801,33.19,NULL,43.5,72936,NULL,NULL,NULL,'FGC 2366',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153802,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 20477','RN',153802,41.34,0.2,1480,72937,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 20477',0.252729,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153803,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 20477','RN',153803,42.41,0.31,2420,72937,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 20477',0.252729,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153804,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153804,37.77,0.21,358,72938,70,NULL,NULL,'SDSS J220810.10-092419.5',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000161,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,332.042083,-9.40544,0.077,NULL,49877060014,779329062,12177016,18.7),(153805,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153805,33.57,0.69,51.6,72939,100,NULL,'mid-IR','UGC 11919',NULL,'2013ApJ...771...88L',2013,1,1.6,NULL,'G',0.00002,NULL,'14.30',1,'SABbc          HII',NULL,NULL,NULL,NULL,1,332.044,41.17736,1.109,NULL,55515116476,867423694,13553495,14.3),(153806,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153806,33.6,0.47,52.6,72939,NULL,NULL,'H','UGC 11919',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153807,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153807,33.84,0.45,58.7,72939,NULL,NULL,'K','UGC 11919',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153808,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153808,33.89,0.46,60.1,72939,NULL,NULL,'J','UGC 11919',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153809,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153809,34.37,0.4,74.8,72939,NULL,NULL,'mean','UGC 11919',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153810,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153810,37.12,0.46,265,72940,70,NULL,NULL,'2MASX J22081096-0813479',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,332.045625,-8.23,0.125,NULL,49868563882,779196310,12174942,17.6),(153811,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153811,37.28,0.46,286,72941,70,NULL,NULL,'2MASX J22081138-0903479',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,332.0472917,-9.06331,0.101,NULL,49868721531,779198773,12174980,17.9),(153812,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153812,37.77,0.21,358,72942,70,NULL,NULL,'2MASX J22081179-0923039',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00017,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,332.049041667,-9.38447,0.077,NULL,49877059728,779329058,12177016,17),(153813,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153813,33.67,0.8,54.2,72943,75,NULL,'MAT, I','ESO 404- G 031',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00002,NULL,'14.83',0.6,'SA(s)c:',NULL,NULL,NULL,NULL,1,332.057667,-32.46081,0,NULL,50595170027,790549531,12352336,14.83),(153814,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153814,33.23,0.32,44.2,72943,85,NULL,'I, raw','ESO 404- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153815,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153815,33.23,0.32,44.3,72943,85,NULL,'I, inv','ESO 404- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153816,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153816,33.53,NULL,50.8,72943,NULL,NULL,'B','ESO 404- G 031',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153817,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153817,33.54,0.43,50.9,72943,75,NULL,'MAT, I, raw','ESO 404- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153818,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153818,33.54,NULL,51.1,72943,NULL,NULL,'I','ESO 404- G 031',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153819,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153819,33.58,0.2,52,72943,74.4,NULL,NULL,'ESO 404- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153820,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153820,33.62,0.43,52.9,72943,75,NULL,'MAT, I, inv','ESO 404- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153821,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153821,33.78,0.43,57.1,72943,75,NULL,'MAT, I, cor','ESO 404- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153822,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153822,33.82,0.56,58.1,72943,NULL,NULL,NULL,'ESO 404- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153823,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153823,33.94,0.53,61.5,72943,NULL,NULL,'Malmquist cor.','ESO 404- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153824,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153824,34.61,0.45,83.5,72944,NULL,NULL,'Malmquist cor.','ESO 532- G 021',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.00002,NULL,'14.47',0.5,'SB(r)a?',NULL,NULL,NULL,NULL,1,332.057917,-25.06069,0.041,NULL,51406187482,803221679,12550338,14.47),(153825,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153825,34.67,0.44,86.1,72944,NULL,NULL,NULL,'ESO 532- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153826,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153826,34.73,0.2,88.3,72944,74.4,NULL,NULL,'ESO 532- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153827,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153827,37.38,0.53,300,72945,70,NULL,NULL,'2MASX J22081533-5921339',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.000103,NULL,'16.86',0.24,NULL,NULL,NULL,NULL,NULL,1,332.0637917,-59.35939,0,NULL,48683816939,760684639,11885697,16.86),(153828,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 21808','RN',153828,39.7,0.48,795,72946,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 21808',0.09415,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153829,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153829,37.1,0.14,263,72947,70,NULL,NULL,'2MASX J22081680-0729189',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00015,NULL,'16.0g',0.44,'E0',NULL,NULL,NULL,NULL,1,332.070083,-7.48861,0.109,NULL,49840403831,778756309,12168067,16),(153830,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SN 2006hy',NULL,153830,38.77,0.05,569,72948,70,NULL,'Hubble residual -0.09 for z0.14910','SDSS-II SN 14437 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,332.080917,-1.19633,0.193,NULL,49853843961,778966311,12171348,NULL),(153831,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 14437','R',153831,39.2,0.18,603,72948,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006hy','SDSS-II SN 14437 HOST',0.149267,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153832,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 14437','R',153832,39.39,0.08,656,72948,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006hy','SDSS-II SN 14437 HOST',0.149267,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153833,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SN 2006hy',NULL,153833,39.11,0.06,664,72948,70,NULL,'SALT 2','SDSS-II SN 14437 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153834,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SN 2006hy',NULL,153834,39.11,0.06,664,72948,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14437 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153835,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SN 2006no',NULL,153835,39.87,0.13,942,72949,70,NULL,'Hubble residual 0.00 for z0.25120','SDSS J220821.57-010853.8',NULL,'2011ApJ...740...92G',2011,1,0.09,NULL,'G',0.0005,NULL,'19.8g',0.08,NULL,NULL,NULL,NULL,NULL,1,332.089917,-1.14831,0.193,NULL,49854320091,778973751,12171464,19.8),(153836,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 16106','R',153836,40.52,0.22,1010,72949,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006no','SDSS J220821.57-010853.8',0.2512,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153837,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 16106','R',153837,40.77,0.14,1140,72949,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006no','SDSS J220821.57-010853.8',0.2512,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153838,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153838,36.32,0.53,184,72950,70,NULL,NULL,'ESO 237-IG 040 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000067,NULL,'15.23',0.43,'E',NULL,NULL,NULL,NULL,1,332.0947083,-49.43108,0,NULL,50622563635,790977556,12359024,15.23),(153839,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153839,37.1,0.14,263,72951,70,NULL,NULL,'2MASX J22082574-0729079',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000168,NULL,'16.8g',0.34,NULL,NULL,NULL,NULL,NULL,1,332.1072917,-7.4855,0.117,NULL,49840403138,778756299,12168067,16.8),(153840,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153840,30.54,0.69,12.8,72952,100,NULL,'mid-IR','UGC 11920',NULL,'2013ApJ...771...88L',2013,1,2.4,NULL,'G',0.000013,NULL,'12.86',1.5,'SB0/a',NULL,NULL,NULL,NULL,1,332.114125,48.44078,NULL,NULL,55410384958,865787264,13527926,12.86),(153841,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153841,33.96,0.2,61.9,72953,74.4,NULL,NULL,'ESO 404- G 032',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'14.33',0.2,'S              Sy2',NULL,NULL,NULL,'Sy 2',1,332.117875,-34.10628,0,NULL,50560637355,790009958,12343905,14.33),(153842,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153842,34.31,0.44,72.6,72953,NULL,NULL,'Malmquist cor.','ESO 404- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153843,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153843,34.4,0.42,75.9,72953,NULL,NULL,NULL,'ESO 404- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153844,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153844,37.38,0.46,299,72954,70,NULL,NULL,'2MASX J22082900-0034229',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,332.120708333,-0.57308,0.173,NULL,49853698135,778964033,12171313,18.1),(153845,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153845,36.96,0.46,246,72955,70,NULL,NULL,'2MASX J22083256-0845248',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,332.13575,-8.75697,0.085,NULL,49868901170,779201580,12175024,17.1),(153846,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153846,34.79,0.48,90.8,72956,NULL,NULL,NULL,'ESO 601- G 022',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.27',0.2,'S...',NULL,NULL,NULL,NULL,1,332.1385417,-20.43636,0.077,NULL,49743575609,777243368,12144427,16.27),(153847,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153847,34.79,0.48,90.8,72956,NULL,NULL,'Malmquist cor.','ESO 601- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153848,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153848,34.83,0.2,92.5,72956,74.4,NULL,NULL,'ESO 601- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153849,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153849,36.11,0.58,167,72957,70,NULL,NULL,'2MASX J22083341-1859140',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'16.85',0.3,NULL,NULL,NULL,NULL,NULL,1,332.1392083,-18.98719,0.037,NULL,49740844037,777200688,12143760,16.85),(153850,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153850,31.55,0.8,20.5,72958,75,NULL,'A82, H','NGC 7205',NULL,'1997ApJS..109..333W',1997,1,4.1,NULL,'G',0.000019,NULL,'11.55',2,'SA(s)bc;HII    LINER','Line-of-sight pair member',NULL,NULL,NULL,1,332.142875,-57.44258,0,NULL,48707533879,761055216,11891487,11.55),(153851,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153851,31.56,0.8,20.5,72958,75,NULL,'MAT, I','NGC 7205',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153852,'Sosies','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153852,31.17,0.21,17.1,72958,NULL,NULL,NULL,'NGC 7205',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153853,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153853,30.79,0.4,14.4,72958,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 7205',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153854,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153854,30.96,NULL,15.6,72958,NULL,NULL,'B','NGC 7205',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153855,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153855,31.15,0.43,17,72958,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7205',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153856,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153856,31.17,0.35,17.1,72958,NULL,NULL,NULL,'NGC 7205',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153857,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153857,31.16,0.39,17.1,72958,73,NULL,'opt','NGC 7205',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153858,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153858,31.25,0.47,17.7,72958,75,NULL,'A82, H, raw','NGC 7205',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153859,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153859,31.27,0.43,18,72958,75,NULL,'3.6 micron, color corrected','NGC 7205',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153860,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153860,31.34,0.47,18.6,72958,75,NULL,'A82, H, inv','NGC 7205',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153861,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153861,31.44,0.46,19.4,72958,NULL,NULL,'J','NGC 7205',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153862,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153862,31.45,0.2,19.5,72958,74.4,NULL,NULL,'NGC 7205',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153863,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153863,31.46,0.32,19.6,72958,85,NULL,'I, raw','NGC 7205',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153864,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153864,31.46,0.45,19.6,72958,NULL,NULL,'K','NGC 7205',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153865,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153865,31.49,0.47,19.9,72958,NULL,NULL,'H','NGC 7205',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153866,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153866,31.51,0.32,20,72958,85,NULL,'I, inv','NGC 7205',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153867,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153867,31.53,0.43,20.3,72958,75,NULL,'MAT, I, raw','NGC 7205',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153868,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153868,31.56,0.4,20.5,72958,75,NULL,'B','NGC 7205',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153869,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153869,31.58,0.47,20.7,72958,75,NULL,'A82, H, cor','NGC 7205',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153870,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153870,31.74,0.43,22.3,72958,75,NULL,'MAT, I, inv','NGC 7205',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153871,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153871,31.76,0.4,22.5,72958,NULL,NULL,'mean','NGC 7205',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153872,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153872,31.79,0.43,22.9,72958,75,NULL,'MAT, I, cor','NGC 7205',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153873,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153873,31.85,NULL,23.4,72958,NULL,NULL,'LEDA [April 2006]','NGC 7205',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153874,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153874,34.51,0.5,79.9,72959,70,NULL,NULL,'2MASX J22083612-7202569',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.000083,NULL,'16.06',0.25,'S',NULL,NULL,NULL,NULL,1,332.1505417,-72.04914,0.009,NULL,49298902698,770295354,12035864,16.06),(153875,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153875,35.53,0.55,128,72960,70,NULL,NULL,'2MASX J22084129-4351464',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00015,NULL,'16.04',0.25,'S',NULL,NULL,NULL,NULL,1,332.1720417,-43.86292,0,NULL,50675336561,791802133,12371908,16.04),(153876,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153876,37.53,0.46,321,72961,70,NULL,NULL,'2MASX J22084501-0059076',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,332.1874583,-0.98547,0.173,NULL,49854542386,778977224,12171519,17.4),(153877,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 06169','RN',153877,39.5,0.14,730,72962,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06169',0.087384,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153878,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 06169','RN',153878,40.03,0.24,934,72962,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06169',0.087384,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153879,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153879,33.91,0.8,60.4,72963,75,NULL,'MAT, I','IC 5168',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000027,NULL,'15.48',0.3,'SB(s)c: sp','in an interacting pair',NULL,NULL,NULL,1,332.18975,-27.85647,0.017,NULL,50534044679,789594448,12337413,15.48),(153880,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153880,33.49,0.32,49.9,72963,85,NULL,'I, inv','IC 5168',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153881,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153881,33.5,0.32,50.1,72963,85,NULL,'I, raw','IC 5168',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153882,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153882,33.77,0.43,56.9,72963,75,NULL,'MAT, I, raw','IC 5168',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153883,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153883,33.79,0.43,57.4,72963,75,NULL,'MAT, I, inv','IC 5168',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153884,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153884,34.06,0.43,64.8,72963,75,NULL,'MAT, I, cor','IC 5168',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153885,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 15540','RN',153885,40.52,0.25,1080,72964,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 15540',0.174792,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153886,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 15540','RN',153886,40.91,0.33,1290,72964,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 15540',0.174792,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153887,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153887,36.59,0.64,208,72965,70,NULL,NULL,'2MASX J22085506-5718042',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'16.96',0.3,NULL,NULL,NULL,NULL,NULL,1,332.229333,-57.30114,0,NULL,48707613180,761056455,11891507,16.96),(153888,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153888,32.82,0.8,36.6,72966,75,NULL,'MAT, I','ESO 048- G 017',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.60',1,'SB(rs)cd',NULL,NULL,NULL,NULL,1,332.2317083,-73.38192,0.109,NULL,48412716225,756448691,11819510,14.6),(153889,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153889,31.51,0.32,20,72966,85,NULL,'I, inv','ESO 048- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153890,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153890,31.55,0.32,20.4,72966,85,NULL,'I, raw','ESO 048- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153891,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153891,31.87,0.4,23.7,72966,NULL,NULL,NULL,'ESO 048- G 017',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153892,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153892,31.87,0.39,23.7,72966,73,NULL,'opt','ESO 048- G 017',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153893,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153893,32.15,0.43,26.9,72966,75,NULL,'MAT, I, inv','ESO 048- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153894,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153894,32.22,0.43,27.8,72966,75,NULL,'MAT, I, raw','ESO 048- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153895,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153895,32.57,0.43,32.6,72966,75,NULL,'MAT, I, cor','ESO 048- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153896,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153896,34.68,0.8,86.4,72967,75,NULL,'MAT, I','NGC 7214',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000033,NULL,'13.05',1.4,'SB(s)bc pec:   Sy1.2','Pair member (points to parent)',NULL,NULL,'Sy 1.2',1,332.282,-27.80947,0.005,NULL,50534046611,789594478,12337413,13.05),(153897,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153897,32.51,0.32,31.8,72967,85,NULL,'I, raw','NGC 7214',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153898,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153898,32.55,0.32,32.3,72967,85,NULL,'I, inv','NGC 7214',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153899,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153899,33.67,0.47,54.1,72967,NULL,NULL,'H','NGC 7214',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153900,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153900,33.68,0.45,54.4,72967,NULL,NULL,'K','NGC 7214',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153901,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153901,33.76,0.46,56.6,72967,NULL,NULL,'J','NGC 7214',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153902,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153902,33.87,0.43,59.3,72967,75,NULL,'MAT, I, raw','NGC 7214',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153903,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153903,34.14,0.43,67.2,72967,75,NULL,'MAT, I, cor','NGC 7214',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153904,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153904,34.19,0.43,69,72967,75,NULL,'MAT, I, inv','NGC 7214',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153905,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153905,34.71,0.4,87.5,72967,NULL,NULL,'mean','NGC 7214',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153906,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153906,37.12,0.46,266,72968,70,NULL,NULL,'2MASX J22090974-0039066',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,332.290667,-0.65183,0.173,NULL,49853687845,778963872,12171310,17.7),(153907,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153907,37.7,0.46,346,72969,70,NULL,NULL,'SDSS J220909.93+010100.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000132,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,332.291417,1.01689,0.113,NULL,52199122915,815611295,12743926,18.6),(153908,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153908,35.19,0.46,109,72970,70,NULL,NULL,'CGCG 428-036',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000103,NULL,'15.5',0.4,NULL,NULL,NULL,NULL,NULL,1,332.2945417,13.50606,0.189,NULL,52253965806,816468215,12757315,15.5),(153909,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153909,38.06,0.46,409,72971,70,NULL,NULL,'SDSS J220911.15-084551.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000149,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,332.2965,-8.76419,0.117,NULL,49869074889,779204295,12175067,18.4),(153910,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153910,32.58,0.8,32.7,72972,75,NULL,'MAT, I','ESO 532- G 022',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'14.76',0.8,'SAB(rs)d:',NULL,NULL,NULL,NULL,1,332.296958333,-27.16642,0.045,NULL,50534167855,789596372,12337443,14.76),(153911,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153911,31.87,0.32,23.7,72972,85,NULL,'I, inv','ESO 532- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153912,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153912,31.91,0.32,24.1,72972,85,NULL,'I, raw','ESO 532- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153913,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153913,32.23,0.43,27.9,72972,75,NULL,'MAT, I, inv','ESO 532- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153914,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153914,32.3,0.43,28.8,72972,75,NULL,'MAT, I, raw','ESO 532- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153915,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153915,32.34,0.08,29.4,72972,NULL,NULL,NULL,'ESO 532- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153916,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153916,32.6,0.43,33.1,72972,75,NULL,'MAT, I, cor','ESO 532- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153917,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 03400','RN',153917,41,0.29,1350,72973,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 03400',0.178468,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153918,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 03400','RN',153918,41.61,0.32,1780,72973,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 03400',0.178468,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153919,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153919,31.51,0.43,20.1,72974,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11921',NULL,'2014MNRAS.444..527S',2014,1,1.7,NULL,'G',0.000003,NULL,'14.35',0.7,'IBm','Isolated galaxy',NULL,NULL,NULL,1,332.315166667,14.36,0.237,NULL,52257236444,816519319,12758114,14.35),(153920,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153920,37.1,0.14,263,72975,70,NULL,NULL,'2MASX J22091577-0736227',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00015,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,332.315833,-7.60622,0.165,NULL,49838341182,778724080,12167563,16.5),(153921,'Tully est','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153921,31.71,0.8,22,72976,75,NULL,'B','NGC 7213',NULL,'1988NBGC.C....0000T',1988,1,3.1,NULL,'G',0.000019,NULL,'11.01',2.8,'SA(s)0^0;LINER Sy1.5','Group member',NULL,NULL,'Flat-Spectrum Radio Source',1,332.317958333,-47.16661,0,NULL,50622015599,790968993,12358890,11.01),(153922,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153922,37.1,0.14,263,72977,70,NULL,NULL,'2MASX J22091738-0734367',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,332.322417,-7.57697,0.165,NULL,49838327555,778723868,12167560,17.8),(153923,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153923,37.82,0.46,367,72978,70,NULL,NULL,'2MASX J22092130+0113260',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000127,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,332.338625,1.22397,0.069,NULL,52198947114,815608548,12743883,17.9),(153924,'SNII optical','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2001cy',NULL,153924,33.01,0.12,38.8,72979,NULL,NULL,'SEAM','UGC 11927',0.014937,'2009ApJ...694.1067P',2009,1,1.5,NULL,'G',0.000037,NULL,'14.4',1.2,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,332.364333,40.98969,0.901,NULL,55515254371,867425849,13553528,14.4),(153925,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2007kp',NULL,153925,40.63,0.19,1340,72980,70,NULL,'Hubble residual 0.51 for z0.28620','SDSS J220929.61+004417.0',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,332.373375,0.73806,0.097,NULL,52198179964,815596561,12743696,NULL),(153926,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 17791','R',153926,41.34,0.27,1440,72980,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007kp','SDSS J220929.61+004417.0',0.2862,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153927,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 17791','R',153927,41.56,0.25,1590,72980,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007kp','SDSS J220929.61+004417.0',0.2862,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153928,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153928,37.36,0.33,297,72981,70,NULL,NULL,'SDSS J220930.84-000914.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,332.3785417,-0.154,0.153,NULL,49799152352,778111755,12157996,18),(153929,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153929,33.8,0.2,57.5,72982,74.4,NULL,NULL,'MCG -01-56-002',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.000027,NULL,'15.07',1.1,'SAB(r)cd:',NULL,NULL,NULL,NULL,1,332.393375,-6.11428,0.145,NULL,49839095433,778735866,12167747,15.07),(153930,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153930,34.02,0.47,63.8,72982,NULL,NULL,NULL,'MCG -01-56-002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153931,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153931,34.16,0.44,68,72982,NULL,NULL,'Malmquist cor.','MCG -01-56-002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153932,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153932,37.36,0.33,297,72983,70,NULL,NULL,'2MASX J22093665-0009190',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000177,NULL,'15.9g',0.4,'E0',NULL,NULL,NULL,NULL,1,332.402667,-0.15533,0.141,NULL,49799155679,778111807,12157996,15.9),(153933,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153933,35.46,0.55,124,72984,NULL,NULL,'Malmquist cor.','ESO 532- G 023',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'14.93',0.8,'Sb-c',NULL,NULL,NULL,NULL,1,332.4045,-27.2465,0,NULL,50534162572,789596290,12337442,14.93),(153934,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153934,35.68,0.5,137,72984,NULL,NULL,NULL,'ESO 532- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153935,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153935,35.72,0.2,139,72984,74.4,NULL,NULL,'ESO 532- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153936,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153936,35.19,0.49,109,72985,75,NULL,'IR','CGCG 428-038',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',NULL,NULL,'15.65',0.2,'S?',NULL,NULL,NULL,NULL,1,332.418416667,13.63589,0.181,NULL,52258409352,816537646,12758400,15.65),(153937,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153937,35.59,0.2,131,72986,74.4,NULL,NULL,'CGCG 428-038',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',NULL,NULL,'15.65',0.2,'S?',NULL,NULL,NULL,NULL,1,332.418416667,13.63589,0.181,NULL,52258409352,816537646,12758400,15.65),(153938,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153938,37.13,0.33,267,72987,70,NULL,NULL,'2MASX J22094050-0925483',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00015,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,332.41875,-9.43017,0.085,NULL,49877503793,779335996,12177124,16.4),(153939,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153939,36.96,0.7,247,72988,70,NULL,NULL,'2MASX J22094092-1447040',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,332.4205417,-14.7845,0.117,NULL,49757239420,777456865,12147763,14.6),(153940,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153940,37.47,0.27,312,72989,70,NULL,NULL,'2MASX J22094408-0929373',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,332.433666667,-9.49367,0.085,NULL,49877569199,779337018,12177140,17.5),(153941,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 09754','RN',153941,39.46,0.24,715,72990,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03166 HOST',0.088847,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153942,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 09754','RN',153942,39.52,0.17,735,72990,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03166 HOST',0.088847,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153943,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 03166','RN',153943,39.6,0.17,763,72990,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03166 HOST',0.088964,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153944,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 03166','RN',153944,39.66,0.26,785,72990,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03166 HOST',0.088964,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153945,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153945,35,0.4,99.9,72991,NULL,NULL,'mean','KUG 2207+182',NULL,'2007A&A...465...71T',2007,1,0.85,NULL,'G',0.000033,NULL,'15.4',0.35,'Sp:',NULL,NULL,NULL,NULL,1,332.447167,18.5025,0.165,NULL,52222122150,815970658,12749541,15.4),(153946,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153946,35.34,0.47,117,72991,NULL,NULL,'H','KUG 2207+182',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153947,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153947,37.13,0.33,267,72992,70,NULL,NULL,'2MASX J22094773-0931103',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000182,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,332.448875,-9.51964,0.085,NULL,49877567467,779336991,12177140,17.9),(153948,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 18651','R',153948,40.45,0.24,983,72993,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 18651',0.248997,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,332.457083,0.11261,0.121,NULL,52152103895,814876623,12732447,NULL),(153949,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 18651','R',153949,40.74,0.2,1130,72993,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 18651',0.248997,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153950,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153950,35.03,0.5,102,72994,70,NULL,NULL,'2MASX J22095113-5716166',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.42',0.27,'S',NULL,NULL,NULL,NULL,1,332.463083,-57.27122,0,NULL,48707571093,761055798,11891496,16.42),(153951,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153951,35.62,0.2,133,72995,74.4,NULL,NULL,'IC 5172',NULL,'2013AJ....146...86T',2013,1,0.71,NULL,'G',0.000076,NULL,'15.8g',0.28,'Sbc',NULL,NULL,NULL,NULL,1,332.4812917,12.81806,0.197,NULL,52253756197,816464940,12757264,15.8),(153952,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153952,37.47,0.27,312,72996,70,NULL,NULL,'2MASX J22095727-0936573',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00015,NULL,'16.1g',0.42,'AGN',NULL,NULL,NULL,NULL,1,332.488667,-9.61603,0.097,NULL,49877397162,779334330,12177098,16.1),(153953,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153953,35.02,0.49,101,72997,75,NULL,'IR','UGC 11930',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000017,NULL,'16.0',0.2,'Sab',NULL,NULL,NULL,NULL,1,332.4919583,20.93336,0.245,NULL,52224614495,816009601,12750150,16),(153954,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153954,34.87,0.48,94.2,72998,70,NULL,NULL,'AM 2206-500 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00007,NULL,'15.56',0.55,'(R)SAB0^+',NULL,NULL,NULL,NULL,1,332.505625,-49.67581,0,NULL,50622412163,790975190,12358987,15.56),(153955,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 05990','RN',153955,41.61,0.19,1510,72999,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05990',0.388384,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153956,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 05990','RN',153956,42.08,0.1,1880,72999,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 05990',0.388384,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153957,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 05890','R',153957,39.78,0.19,766,73000,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J221003.78+003634.9',0.1796,'2014arXiv1401.3317S',2014,1,0.1,NULL,'G',0.0005,NULL,'19.9g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,332.51575,0.60969,0.097,NULL,52152832317,814888004,12732625,19.9),(153958,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 05890','R',153958,40.06,0.11,873,73000,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J221003.78+003634.9',0.1796,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153959,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 05890',NULL,153959,39.72,0.08,879,73000,70,NULL,'SALT 2','SDSS J221003.78+003634.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153960,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 05890',NULL,153960,39.73,0.08,883,73000,70,NULL,'SALT 2, Malmquist cor.','SDSS J221003.78+003634.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153961,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153961,35.91,0.71,152,73001,70,NULL,NULL,'LCRS B220659.8-451404',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.13',0.42,'E',NULL,NULL,NULL,NULL,1,332.5212917,-44.98828,0,NULL,50672369198,791755768,12371183,16.13),(153962,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153962,37.23,0.46,279,73002,70,NULL,NULL,'SDSS J221005.25-071514.9',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,332.521916667,-7.25414,0.193,NULL,49840765781,778761965,12168155,17.7),(153963,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153963,33.44,0.49,48.7,73003,75,NULL,'IR','IC 5169',NULL,'2011yCatp016004901K',2011,1,1.9,NULL,'G',0.000043,NULL,'13.60',0.8,'(R_1)SAB(r)0+;HIISy2',NULL,NULL,NULL,'Sy 2',1,332.541583333,-36.08861,0,NULL,50555403383,789928177,12342627,13.6),(153964,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2006fm',NULL,153964,38.57,0.05,518,73004,70,NULL,'Hubble residual 0.06 for z0.12570','SDSS J221010.31+003013.9',NULL,'2011ApJ...740...92G',2011,1,0.14,NULL,'G',0.0005,NULL,'19.92',0.11,NULL,NULL,NULL,NULL,NULL,1,332.543,0.50392,0.121,NULL,52152860268,814888441,12732631,19.92),(153965,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 13044','R',153965,38.88,0.18,531,73004,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006fm','SDSS J221010.31+003013.9',0.1257,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153966,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2006fm',NULL,153966,38.77,0.06,568,73004,70,NULL,'SALT 2','SDSS J221010.31+003013.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153967,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2006fm',NULL,153967,38.78,0.06,570,73004,70,NULL,'SALT 2, Malmquist cor.','SDSS J221010.31+003013.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153968,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 13044','R',153968,39.06,0.08,576,73004,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006fm','SDSS J221010.31+003013.9',0.1257,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153969,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153969,31.64,0.8,21.3,73005,75,NULL,'MAT, I','NGC 7218',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000021,NULL,'12.81',1.1,'SB(r)c         HII',NULL,NULL,NULL,NULL,1,332.5487917,-16.661,0.077,NULL,49790387026,777974797,12155856,12.81),(153970,'Sosies','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153970,32.1,0.09,26.3,73005,NULL,NULL,NULL,'NGC 7218',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153971,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153971,31.64,0.43,21.3,73005,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7218',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153972,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153972,31.69,0.4,21.8,73005,NULL,NULL,NULL,'NGC 7218',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153973,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153973,31.69,0.4,21.8,73005,73,NULL,'opt','NGC 7218',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153974,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153974,31.71,0.4,22,73005,75,NULL,'B','NGC 7218',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153975,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153975,31.74,0.4,22.3,73005,NULL,NULL,'mean','NGC 7218',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153976,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153976,31.77,0.43,22.6,73005,75,NULL,'3.6 micron, color corrected','NGC 7218',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153977,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153977,31.85,0.2,23.4,73005,74.4,NULL,NULL,'NGC 7218',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153978,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153978,31.89,0.32,23.9,73005,85,NULL,'I, raw','NGC 7218',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153979,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153979,31.9,0.41,24,73005,NULL,NULL,NULL,'NGC 7218',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153980,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153980,31.91,0.32,24.1,73005,85,NULL,'I, inv','NGC 7218',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153981,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153981,31.97,0.47,24.8,73005,NULL,NULL,'H','NGC 7218',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153982,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153982,31.98,0.46,24.9,73005,NULL,NULL,'J','NGC 7218',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153983,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153983,32.05,0.45,25.7,73005,NULL,NULL,'K','NGC 7218',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153984,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153984,32.05,0.43,25.7,73005,75,NULL,'MAT, I, raw','NGC 7218',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153985,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153985,32.07,0.38,26,73005,NULL,NULL,'Malmquist cor.','NGC 7218',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153986,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153986,32.18,0.43,27.3,73005,75,NULL,'MAT, I, inv','NGC 7218',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153987,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153987,32.37,0.43,29.8,73005,75,NULL,'MAT, I, cor','NGC 7218',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153988,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153988,31.73,0.8,22.2,73006,75,NULL,'MAT, I','UGCA 426',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000027,NULL,'14.59',0.7,'SAB(s)dm III-IV','Pair member (points to parent)',NULL,NULL,NULL,1,332.553417,-18.86492,0.017,NULL,49733731666,777089557,12142024,14.59),(153989,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153989,31.43,0.32,19.3,73006,85,NULL,'I, inv','UGCA 426',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153990,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153990,31.46,0.32,19.6,73006,85,NULL,'I, raw','UGCA 426',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153991,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153991,31.53,0.4,20.2,73006,NULL,NULL,NULL,'UGCA 426',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153992,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153992,31.53,0.39,20.2,73006,73,NULL,'opt','UGCA 426',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153993,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153993,31.79,0.4,22.8,73006,75,NULL,'B','UGCA 426',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153994,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153994,31.93,0.43,24.3,73006,75,NULL,'MAT, I, inv','UGCA 426',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153995,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153995,32.02,0.43,25.3,73006,75,NULL,'MAT, I, raw','UGCA 426',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153996,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153996,32.35,0.43,29.6,73006,75,NULL,'MAT, I, cor','UGCA 426',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153997,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153997,32.38,0.53,29.9,73006,NULL,NULL,NULL,'UGCA 426',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153998,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153998,32.42,0.2,30.5,73006,74.4,NULL,NULL,'UGCA 426',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153999,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153999,32.5,0.5,31.7,73006,NULL,NULL,'Malmquist cor.','UGCA 426',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154000,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154000,37.47,0.27,312,73007,70,NULL,NULL,'2MASX J22101288-0936366',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,332.553666667,-9.61025,0.097,NULL,49877601773,779337527,12177148,17.9),(154001,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154001,35.94,0.48,154,73008,70,NULL,NULL,'FAIRALL 1001',NULL,'2014MNRAS.445.2677S',2014,1,0.98,NULL,'G',0.00015,NULL,'15.22',0.53,'E',NULL,NULL,NULL,NULL,1,332.568708333,-44.73008,0,NULL,50671815180,791747112,12371048,15.22),(154002,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154002,38.12,0.46,420,73009,70,NULL,NULL,'2MASX J22101749-0001256',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,332.572791667,-0.02378,0.141,NULL,49799103041,778110985,12157984,17.8),(154003,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 06737','RN',154003,42.46,0.34,2140,73010,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 06737',0.44941,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154004,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 06737','RN',154004,42.99,0.32,2730,73010,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 06737',0.44941,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154005,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 17399','RN',154005,39.57,0.09,785,73011,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 17399',0.045525,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154006,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 17399','RN',154006,40.09,0.22,999,73011,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 17399',0.045525,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154007,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 07986',NULL,154007,40.74,0.32,1410,73012,70,NULL,'SN photometric redshift distance, z photo =0.406 +/- 0.085','SDSS-II SN 07986',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,332.6214583,-0.43756,0.153,NULL,49799970763,778124543,12158195,NULL),(154008,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154008,36.59,0.57,208,73013,70,NULL,NULL,'2MASX J22102985-0226486',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'16.76',0.22,NULL,NULL,NULL,NULL,NULL,1,332.6244583,-2.44681,0.209,NULL,49856850123,779013283,12172082,16.76),(154009,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154009,37.87,0.46,375,73014,70,NULL,NULL,'2MASX J22103046-0910100',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.0002,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,332.626958333,-9.1695,0.109,NULL,49876693002,779323328,12176927,17.1),(154010,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154010,37.62,0.46,334,73015,70,NULL,NULL,'2MASX J22103364-0113375',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,332.64025,-1.22714,0.197,NULL,49854281729,778973152,12171455,17.7),(154011,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 03625','RN',154011,42.76,0.2,2610,73016,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03625',0.364195,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154012,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 03625','RN',154012,42.99,0.23,2900,73016,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03625',0.364195,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154013,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154013,38.29,0.46,455,73017,70,NULL,NULL,'2MASX J22103633-0839450',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,332.6514583,-8.66253,0.125,NULL,49868267397,779191678,12174869,17.3),(154014,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154014,35.12,0.58,106,73018,NULL,NULL,'Malmquist cor.','ESO 467- G 017',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.00001,NULL,'14.48',0.7,'SA(rs)bc',NULL,NULL,NULL,NULL,1,332.6702083,-27.89631,0,NULL,50547843880,789810060,12340782,14.48),(154015,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154015,35.28,0.54,114,73018,NULL,NULL,NULL,'ESO 467- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154016,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154016,35.32,0.2,116,73018,74.4,NULL,NULL,'ESO 467- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154017,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154017,35.4,0.4,120,73018,NULL,NULL,'mean','ESO 467- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154018,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154018,35.68,0.47,137,73018,NULL,NULL,'H','ESO 467- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154019,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154019,36.85,0.64,235,73019,70,NULL,NULL,'MCG -02-56-020',NULL,'2014MNRAS.445.2677S',2014,1,0.15,NULL,'G',0.00015,NULL,'15',0.15,NULL,NULL,NULL,NULL,NULL,1,332.673625,-10.46442,0.061,NULL,49877679282,779338738,12177167,15),(154020,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154020,35.12,0.54,105,73020,70,NULL,NULL,'2MASX J22104239-8519120',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,332.67575,-85.31997,0.441,NULL,48379989077,755937329,11811520,16.3),(154021,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 07954','R',154021,40.27,0.22,904,73021,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07954',0.2553,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,332.6769583,0.34772,0.121,NULL,52152943544,814889742,12732652,NULL),(154022,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 07954','R',154022,40.46,0.17,984,73021,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07954',0.2553,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154023,'CMD','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'N',154023,17.52,0.11,0.0319,73022,NULL,NULL,NULL,'SDSS J2211+1457',NULL,'2013ApJ...767..101B',2013,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154024,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154024,37.11,0.46,264,73023,70,NULL,NULL,'2MASX J22104526-0023007',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000143,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,332.688625,-0.38353,0.153,NULL,49799962666,778124416,12158194,17.5),(154025,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154025,37.1,0.55,263,73024,70,NULL,NULL,'2MASX J22104544-7250439',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.000103,NULL,'15.0r',0.23,NULL,NULL,NULL,NULL,NULL,1,332.68925,-72.84558,0.053,NULL,49298205337,770284458,12035694,15),(154026,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 03262','RN',154026,42.96,0.42,2900,73025,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03262',0.346705,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154027,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 03262','RN',154027,43.25,0.32,3310,73025,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03262',0.346705,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154028,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154028,37.2,0.46,275,73026,70,NULL,NULL,'2MASX J22104762-0054067',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,332.698417,-0.90192,0.189,NULL,49799416378,778115880,12158060,17.4),(154029,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 06170','RN',154029,41.94,0.25,2230,73027,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06170',0.094676,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154030,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2008dr',NULL,154030,36.29,0.14,174,73028,70,NULL,'SALT 2','NGC 7222',0.041449,'2013MNRAS.433.2240G',2013,1,1.2,NULL,'G',0.000133,NULL,'14.59',1.2,'SB(r)b',NULL,NULL,NULL,NULL,1,332.715667,2.10581,0.073,NULL,52202166968,815658858,12744669,14.59),(154031,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2008dr','R',154031,36.26,0.06,179,73028,NULL,NULL,'MLCS2k2, R(V) = 1.8','NGC 7222',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154032,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2008dr','R',154032,36.28,0.07,180,73028,NULL,NULL,'MLCS2k2, R(V) = 3.1','NGC 7222',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154033,'Tully est','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154033,32.66,0.8,34.1,73029,75,NULL,NULL,'IC 5171',NULL,'1988NBGC.C....0000T',1988,1,3,NULL,'G',0.000017,NULL,'13.43',0.4,'(R\':)SB(r)b',NULL,NULL,NULL,NULL,1,332.73625,-46.08147,0,NULL,50692395498,792068679,12376073,13.43),(154034,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154034,32.45,0.4,30.9,73029,73,NULL,'IR','IC 5171',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154035,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154035,32.45,0.4,30.9,73029,73,NULL,'opt','IC 5171',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154036,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154036,32.45,0.4,30.9,73029,75,NULL,NULL,'IC 5171',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154037,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154037,32.53,0.49,32.1,73029,75,NULL,'IR','IC 5171',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154038,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154038,32.54,0.46,32.2,73029,NULL,NULL,'J','IC 5171',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154039,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154039,32.58,0.47,32.8,73029,NULL,NULL,'H','IC 5171',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154040,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154040,32.65,0.45,33.9,73029,NULL,NULL,'K','IC 5171',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154041,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154041,32.82,0.4,36.6,73029,NULL,NULL,'mean','IC 5171',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154042,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154042,37.38,0.46,299,73030,70,NULL,NULL,'2MASX J22105748-0910100',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000157,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,332.739583,-9.16928,0.113,NULL,49876675401,779323053,12176922,17.2),(154043,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154043,34.78,0.43,90.4,73031,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2370',NULL,'2014MNRAS.444..527S',2014,1,0.94,NULL,'G',0.000009,NULL,'16.5',0.11,'Sc',NULL,NULL,NULL,NULL,1,332.7455,22.77525,0.233,NULL,52211077026,815798078,12746844,16.5),(154044,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154044,34.84,0.49,92.8,73031,75,NULL,'IR','FGC 2370',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154045,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154045,34.89,NULL,95.3,73031,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2370',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154046,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154046,34.91,NULL,96,73031,NULL,NULL,'Dipole + Quadrupole','FGC 2370',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154047,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154047,34.92,NULL,96.6,73031,NULL,NULL,'Dipole','FGC 2370',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154048,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154048,34.97,NULL,98.6,73031,NULL,NULL,NULL,'FGC 2370',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154049,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154049,36.83,0.46,232,73032,70,NULL,NULL,'2MASX J22110154+1222274',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000169,NULL,'15.9g',0.31,'E0',NULL,NULL,NULL,NULL,1,332.756333,12.37433,0.217,NULL,52257941040,816530328,12758286,15.9),(154050,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 17415','RN',154050,40.39,0.09,997,73033,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 17415',0.201492,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154051,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 17415','RN',154051,41,0.18,1320,73033,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17415',0.201492,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154052,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154052,38.68,0.46,545,73034,70,NULL,NULL,'2MASX J22110481-0924545',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000172,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,332.77,-9.41525,0.105,NULL,49876766176,779324471,12176944,17.3),(154053,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 16053','RN',154053,41.05,0.3,1320,73035,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 16053',0.229895,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154054,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 16053','RN',154054,41.4,0.41,1550,73035,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 16053',0.229895,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154055,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 02262','RN',154055,41.13,0.17,1230,73036,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02262',0.361914,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154056,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 02262','RN',154056,41.95,0.24,1800,73036,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02262',0.361914,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154057,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 00870','RN',154057,42.18,0.19,1630,73037,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00870',0.666893,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154058,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 13855','RN',154058,39.47,0.32,664,73038,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13855',0.177735,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154059,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 13855','RN',154059,40.79,0.37,1220,73038,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13855',0.177735,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154060,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154060,33.66,0.8,54,73039,75,NULL,'MAT, I','NGC 7221',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.00001,NULL,'12.80',1.6,'SB(rs)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,332.8135417,-30.56317,0,NULL,50538876730,789669948,12338592,12.8),(154061,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154061,33.51,0.43,50.3,73039,75,NULL,'MAT, I, raw','NGC 7221',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154062,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154062,33.62,0.47,53.1,73039,NULL,NULL,'H','NGC 7221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154063,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154063,33.71,0.45,55.3,73039,NULL,NULL,'K','NGC 7221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154064,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154064,33.77,0.46,56.7,73039,NULL,NULL,'J','NGC 7221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154065,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154065,33.79,0.43,57.2,73039,75,NULL,'MAT, I, cor','NGC 7221',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154066,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154066,33.79,0.43,57.4,73039,75,NULL,'MAT, I, inv','NGC 7221',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154067,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154067,33.86,0.32,59.2,73039,85,NULL,'I, raw','NGC 7221',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154068,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154068,33.89,0.4,59.9,73039,NULL,NULL,'mean','NGC 7221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154069,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154069,33.94,0.32,61.4,73039,85,NULL,'I, inv','NGC 7221',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154070,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154070,34.11,0.2,66.4,73039,74.4,NULL,NULL,'NGC 7221',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154071,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154071,37.7,0.46,346,73040,70,NULL,NULL,'SDSS J221115.35-091524.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000162,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,332.8139583,-9.25672,0.113,NULL,49876799930,779324998,12176953,18.3),(154072,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 15660',NULL,154072,41.3,0.27,1820,73041,70,NULL,'SN photometric redshift distance, z photo =0.574 +/- 0.114','SDSS-II SN 15660',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,332.82225,-0.04061,0.125,NULL,49799601394,778118771,12158105,NULL),(154073,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 06098','RN',154073,44.38,0.61,5610,73042,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06098',0.341108,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154074,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 07248','RN',154074,39.01,0.27,564,73043,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 07248',0.12622,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154075,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 07248','RN',154075,40.07,0.29,916,73043,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 07248',0.12622,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154076,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154076,36.3,0.46,182,73044,70,NULL,NULL,'2MASX J22112741-0003016',NULL,'2015arXiv151105856S',2015,1,0.54,'The APM image includes a neighboring star.','G',0.00015,NULL,'15.8g',0.42,'poss. LINER',NULL,NULL,NULL,NULL,1,332.8642917,-0.05061,0.125,NULL,49799609457,778118897,12158107,15.8),(154077,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154077,36.71,0.53,219,73044,70,NULL,NULL,'2MASX J22112741-0003016',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154078,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2006fl',NULL,154078,39.23,0.07,702,73045,70,NULL,'Hubble residual 0.09 for z0.17173','SDSS J221127.68+004520.0',NULL,'2011ApJ...740...92G',2011,1,0.18,NULL,'G',0.00011,NULL,'18.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,332.865375,0.75558,0.093,NULL,52152665710,814885401,12732584,18.8),(154079,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 12856','R',154079,39.62,0.19,716,73045,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006fl','SDSS J221127.68+004520.0',0.17173,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154080,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 12856','R',154080,39.96,0.09,837,73045,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006fl','SDSS J221127.68+004520.0',0.17173,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154081,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154081,36.86,0.61,235,73046,70,NULL,NULL,'2MASX J22112948-1819263',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'16.72',0.2,NULL,NULL,NULL,NULL,NULL,1,332.872791667,-18.32397,0.073,NULL,49733478629,777085603,12141962,16.72),(154082,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154082,34.77,0.57,89.9,73047,70,NULL,NULL,'NGC 7220',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00009,NULL,'14.87',0.7,'SAB(s)0^0^:',NULL,NULL,NULL,NULL,1,332.879167,-22.95286,0.041,NULL,49728474397,777007412,12140740,14.87),(154083,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 15470','RN',154083,41.6,0.22,1700,73048,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15470',0.233684,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154084,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 15470','RN',154084,41.88,0.31,1920,73048,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15470',0.233684,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154085,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2007mo',NULL,154085,39.31,0.14,727,73049,70,NULL,'Hubble residual -0.33 for z0.22150','SDSS-II SN 19230',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,332.8910417,0.76478,0.093,NULL,52152665326,814885395,12732584,NULL),(154086,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 19230','R',154086,39.9,0.22,784,73049,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007mo','SDSS-II SN 19230',0.221,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154087,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 19230','R',154087,40.04,0.15,833,73049,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007mo','SDSS-II SN 19230',0.221,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154088,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154088,34.77,0.8,90.1,73050,75,NULL,'W91PP, r','UGC 11941',NULL,'1997ApJS..109..333W',1997,1,0.95,NULL,'G',0.000033,NULL,'16.5',0.13,'Sbc',NULL,NULL,NULL,NULL,1,332.8917083,29.85989,0.345,NULL,55443480048,866304375,13536005,16.5),(154089,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154089,35.03,0.38,101,73050,NULL,NULL,'Malmquist cor.','UGC 11941',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154090,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154090,35.15,0.38,107,73050,75,NULL,'W91PP, r, raw','UGC 11941',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154091,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154091,35.18,0.38,109,73050,75,NULL,'W91PP, r, inv','UGC 11941',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154092,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154092,35.21,0.49,110,73050,75,NULL,'IR','UGC 11941',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154093,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154093,35.25,NULL,112,73050,NULL,NULL,NULL,'UGC 11941',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154094,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154094,35.28,0.43,114,73050,75,NULL,'3.6 micron, color corrected','UGC 11941',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154095,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154095,35.28,NULL,114,73050,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11941',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154096,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154096,35.3,NULL,115,73050,NULL,NULL,'Dipole','UGC 11941',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154097,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154097,35.3,NULL,115,73050,NULL,NULL,'Dipole + Quadrupole','UGC 11941',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154098,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154098,35.31,0.2,115,73050,74.4,NULL,NULL,'UGC 11941',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154099,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154099,35.32,0.43,116,73050,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11941',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154100,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154100,35.35,0.38,117,73050,75,NULL,'W91PP, r, cor','UGC 11941',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154101,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154101,35.4,0.32,120,73050,NULL,NULL,NULL,'UGC 11941',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154102,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154102,34.54,0.69,80.9,73051,100,NULL,'mid-IR','IC 5177',NULL,'2013ApJ...771...88L',2013,1,1.6,NULL,'G',0.000033,NULL,'14.70',0.8,'SBb',NULL,NULL,NULL,NULL,1,332.892791667,11.79594,0.185,NULL,52279103817,816860997,12763453,14.7),(154103,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154103,35.16,0.2,108,73051,74.4,NULL,NULL,'IC 5177',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154104,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154104,35.29,0.4,114,73051,NULL,NULL,'mean','IC 5177',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154105,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154105,35.43,0.47,122,73051,NULL,NULL,'H','IC 5177',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154106,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154106,35.51,0.45,127,73051,NULL,NULL,'K','IC 5177',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154107,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 03402',NULL,154107,40.9,0.44,1520,73052,70,NULL,'SN photometric redshift distance, z photo =0.448 +/- 0.142','SDSS-II SN 03402',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,332.8960417,0.52697,0.097,NULL,52152805913,814887592,12732618,NULL),(154108,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154108,34.67,0.49,85.7,73053,75,NULL,'IR','2MFGC 16741',NULL,'2011yCatp016004901K',2011,1,0.71,NULL,'G',0.000172,NULL,'16.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,332.899625,13.95408,0.173,NULL,52260715817,816573684,12758963,16.7),(154109,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154109,34.77,0.2,90,73054,74.4,NULL,NULL,'2MFGC 16741',NULL,'2013AJ....146...86T',2013,1,0.71,NULL,'G',0.000172,NULL,'16.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,332.899625,13.95408,0.173,NULL,52260715817,816573684,12758963,16.7),(154110,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154110,35.13,NULL,106,73055,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2371',NULL,'2010Ap&SS.325..163P',2010,1,0.78,NULL,'G',0.000012,NULL,'16.7',0.1,'Sd',NULL,NULL,NULL,NULL,1,332.910583,15.71847,0.157,NULL,52250387402,816412303,12756442,16.7),(154111,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154111,35.14,NULL,107,73055,NULL,NULL,'Dipole + Quadrupole','FGC 2371',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154112,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154112,35.16,NULL,108,73055,NULL,NULL,'Dipole','FGC 2371',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154113,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154113,35.19,NULL,109,73055,NULL,NULL,NULL,'FGC 2371',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154114,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154114,35.51,0.49,127,73055,75,NULL,'IR','FGC 2371',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154115,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 06171','RN',154115,39.73,0.38,816,73056,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06171',0.081137,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154116,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 06171','RN',154116,39.98,0.44,915,73056,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06171',0.081137,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154117,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154117,34.36,0.4,74.6,73057,NULL,NULL,'mean','UGC 11946',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000027,NULL,'14.3',0.8,'SAB(s)c        HII',NULL,NULL,NULL,NULL,1,332.912375,46.30961,NULL,NULL,55537000223,867765628,13558837,14.3),(154118,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154118,34.5,0.47,79.4,73057,NULL,NULL,'H','UGC 11946',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154119,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154119,34.5,0.45,79.4,73057,NULL,NULL,'K','UGC 11946',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154120,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154120,34.56,0.46,81.7,73057,NULL,NULL,'J','UGC 11946',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154121,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154121,34.67,0.2,85.9,73057,74.4,NULL,NULL,'UGC 11946',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154122,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154122,34.73,0.43,88.4,73057,75,NULL,'3.6 micron, color corrected','UGC 11946',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154123,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154123,34.82,0.43,92.2,73057,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11946',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154124,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 19953','R',154124,38.8,0.18,514,73058,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007pf','APMUKS(BJ) B220909.80+001954.4',0.12,'2014arXiv1401.3317S',2014,1,0.14,NULL,'G',NULL,NULL,'20.00',0.11,NULL,NULL,NULL,NULL,NULL,1,332.93,0.57936,0.093,NULL,52152826099,814887907,12732623,20),(154125,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2007pf',NULL,154125,38.78,0.07,570,73058,70,NULL,'SALT 2','APMUKS(BJ) B220909.80+001954.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154126,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2007pf',NULL,154126,38.79,0.07,573,73058,70,NULL,'SALT 2, Malmquist cor.','APMUKS(BJ) B220909.80+001954.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154127,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 19953','R',154127,39.07,0.08,583,73058,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007pf','APMUKS(BJ) B220909.80+001954.4',0.12,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154128,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154128,37.37,0.46,298,73059,70,NULL,NULL,'2MASX J22114360-0843099',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,332.9317083,-8.71956,0.133,NULL,49837805089,778715704,12167432,17.7),(154129,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 15941',NULL,154129,40.27,0.14,1130,73060,70,NULL,'SN photometric redshift distance, z photo =0.311 +/- 0.025','SDSS-II SN 15941',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.8g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,332.932041667,-0.68481,0.185,NULL,49799813517,778122086,12158157,21.8),(154130,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 15941','R',154130,40.95,0.26,1170,73060,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15941',0.326069,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154131,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 15941','R',154131,41.07,0.22,1230,73060,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15941',0.326069,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154132,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 15941',NULL,154132,40.84,0.17,1470,73060,70,NULL,'SALT 2','SDSS-II SN 15941',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154133,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 15941',NULL,154133,40.88,0.17,1500,73060,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15941',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154134,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 16199','R',154134,40.57,0.17,1010,73061,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16199',0.282392,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,332.94425,1.13494,0.077,NULL,52152542089,814883470,12732554,NULL),(154135,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 16199','R',154135,40.62,0.24,1040,73061,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16199',0.282392,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154136,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 16199',NULL,154136,40.15,0.29,1070,73061,70,NULL,'SN photometric redshift distance, z photo =0.291 +/- 0.050','SDSS-II SN 16199',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154137,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 16199',NULL,154137,40.49,0.13,1250,73061,70,NULL,'SALT 2','SDSS-II SN 16199',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154138,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 16199',NULL,154138,40.52,0.13,1270,73061,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16199',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154139,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154139,31.91,0.8,24.1,73062,75,NULL,'MAT, I','ESO 288- G 049',NULL,'1997ApJS..109..333W',1997,1,2.3,'RC3 gives V = 17193 +- 48 km/sec.','G',0.000028,NULL,'13.94',1.5,'SB(s)dm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,332.952333333,-45.58964,0,NULL,50726167221,792596362,12384318,13.94),(154140,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154140,30.73,0.32,14,73062,85,NULL,'I, inv','ESO 288- G 049',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154141,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154141,30.78,0.32,14.3,73062,85,NULL,'I, raw','ESO 288- G 049',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154142,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154142,30.81,0.4,14.5,73062,NULL,NULL,NULL,'ESO 288- G 049',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154143,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154143,31.29,0.43,18.1,73062,75,NULL,'MAT, I, inv','ESO 288- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154144,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154144,31.36,0.43,18.7,73062,75,NULL,'MAT, I, raw','ESO 288- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154145,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154145,31.52,0.39,20.1,73062,73,NULL,'opt','ESO 288- G 049',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154146,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154146,31.65,0.43,21.4,73062,75,NULL,'MAT, I, cor','ESO 288- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154147,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154147,34.69,0.4,86.8,73063,NULL,NULL,'mean','NGC 7228',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000033,NULL,'14.4',1.3,'(R\')SB(s)a',NULL,NULL,NULL,NULL,1,332.9525,38.69917,0.641,NULL,55505810620,867278290,13551223,14.4),(154148,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154148,34.7,0.47,87,73063,NULL,NULL,'H','NGC 7228',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154149,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154149,34.7,0.45,87.2,73063,NULL,NULL,'K','NGC 7228',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154150,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154150,34.73,0.46,88.2,73063,NULL,NULL,'J','NGC 7228',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154151,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154151,35.61,0.14,132,73064,70,NULL,NULL,'2MASX J22114920+1358032',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00007,NULL,'16.3g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,332.955125,13.96767,0.173,NULL,52260703430,816573491,12758960,16.3),(154152,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154152,37.11,0.33,264,73065,70,NULL,NULL,'2MASX J22115558-0919229',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,332.9815,-9.32289,0.113,NULL,49876787018,779324797,12176949,17.4),(154153,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154153,37.66,0.46,341,73066,70,NULL,NULL,'2MASX J22115628-0851379',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00015,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,332.9845417,-8.86039,0.125,NULL,49868204512,779190695,12174854,16.4),(154154,'Tully est','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154154,32,0.8,25.1,73067,75,NULL,NULL,'UGC 11944',NULL,'1988NBGC.C....0000T',1988,1,2.4,NULL,'G',0.000013,NULL,'16.0',0.8,'Im:',NULL,NULL,NULL,NULL,1,333.003167,17.90267,0.177,NULL,52268948965,816702327,12760973,16),(154155,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154155,36.83,0.46,232,73068,70,NULL,NULL,'SDSS J221202.93+000314.2',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'16.4g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,333.01225,0.05397,0.113,NULL,52152284476,814879444,12732491,16.4),(154156,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154156,37.1,0.46,263,73069,70,NULL,NULL,'2MASX J22120417-0043348',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,333.017416667,-0.72636,0.185,NULL,49799770089,778121407,12158146,17.3),(154157,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154157,37.11,0.33,264,73070,70,NULL,NULL,'2MASX J22120663-0919326',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00015,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,333.027583,-9.32575,0.113,NULL,49876608838,779322013,12176906,16.6),(154158,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 08196','RN',154158,39.21,0.23,645,73071,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 08196',0.080016,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154159,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 08196','RN',154159,39.37,0.16,693,73071,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 08196',0.080016,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154160,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154160,35.73,0.5,140,73072,70,NULL,NULL,'IC 1433 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.64',NULL,NULL,NULL,NULL,NULL,NULL,1,333.044333333,-12.76558,0.129,NULL,49759316117,777489314,12148270,15.64),(154161,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154161,36.99,0.46,250,73073,70,NULL,NULL,'2MASX J22121062-0927116',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00015,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,333.0444583,-9.45317,0.113,NULL,49876714671,779323666,12176932,16.9),(154162,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154162,36.71,0.33,220,73074,70,NULL,NULL,'2MASX J22121237-0105065',NULL,'2015arXiv151105856S',2015,1,0.68,'The APM image includes a brighter superposed star.','G',0.00015,NULL,'15.7g',0.44,'E0',NULL,NULL,NULL,NULL,1,333.0514583,-1.08506,0.189,NULL,49799466720,778116667,12158072,15.7),(154163,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154163,37.31,0.59,290,73075,70,NULL,NULL,'2MASX J22121418-4608169',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'16.66',0.36,NULL,NULL,NULL,NULL,NULL,1,333.0590417,-46.13797,0,NULL,50692587489,792071679,12376119,16.66),(154164,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154164,38.07,0.46,411,73076,70,NULL,NULL,'2MASXi J2212160+134015',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000122,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,333.0670417,13.67094,0.189,NULL,52260572771,816571449,12758928,17.8),(154165,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154165,37.88,0.46,377,73077,70,NULL,NULL,'2MASX J22121720-0828396',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,333.071708333,-8.47758,0.141,NULL,49837974300,778718348,12167474,17.9),(154166,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154166,35.71,0.58,139,73078,70,NULL,NULL,'ESO 189- G 028',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.0',0.8,'SB(rs)ab',NULL,NULL,NULL,NULL,1,333.080625,-54.29842,0,NULL,48694319058,760848735,11888261,15),(154167,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','PS1 SN PS11ala','N',154167,41.39,0.12,1390,73079,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11ala HOST',0.3688,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154168,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154168,37.9,0.46,380,73080,70,NULL,NULL,'2MASX J22121978+1249558',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,333.0825417,12.83217,0.209,NULL,52257955039,816530547,12758289,18.2),(154169,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154169,36.71,0.33,220,73081,70,NULL,NULL,'2MASX J22122044-0056335',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00015,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,333.085083,-0.94267,0.185,NULL,49799352832,778114888,12158045,16.8),(154170,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154170,35.19,0.36,109,73082,NULL,NULL,NULL,'UGC 11948',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000093,NULL,'14.81',0.8,'SBb',NULL,NULL,NULL,NULL,1,333.0927917,14.02436,0.173,NULL,52260996472,816578069,12759032,14.81),(154171,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154171,35.27,0.34,113,73082,NULL,NULL,'Malmquist cor.','UGC 11948',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154172,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154172,35.31,0.2,115,73082,74.4,NULL,NULL,'UGC 11948',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154173,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154173,35.59,0.4,131,73083,NULL,NULL,'Malmquist cor.','ESO 048- G 018',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.46',0.3,'Sb-c',NULL,NULL,NULL,NULL,1,333.097917,-72.56886,0.017,NULL,49298222615,770284728,12035698,15.46),(154174,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154174,35.69,0.38,138,73083,NULL,NULL,NULL,'ESO 048- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154175,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154175,35.73,0.2,140,73083,74.4,NULL,NULL,'ESO 048- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154176,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 15255',NULL,154176,40.22,0.2,1100,73084,70,NULL,'SN photometric redshift distance, z photo =0.302 +/- 0.035','SDSS-II SN 15255',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','21.0g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,333.100667,-0.259,0.177,NULL,49799716775,778120574,12158133,21),(154177,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 01311','RN',154177,41.11,0.37,1320,73085,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 01311',0.261826,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154178,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 01311','RN',154178,41.55,0.42,1620,73085,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 01311',0.261826,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154179,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154179,31.48,0.8,19.8,73086,75,NULL,'MAT, I','IC 5170',NULL,'1997ApJS..109..333W',1997,1,3.4,'Two entries for IC 5170 in ESO and ESO-LV.','G',0.000033,NULL,'13.34',1.9,'SB0^+','Pair member (points to parent)',NULL,NULL,NULL,1,333.1235,-47.22194,0,NULL,50621672111,790963626,12358806,13.34),(154180,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154180,31.1,0.32,16.6,73086,85,NULL,'I, raw','IC 5170',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154181,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154181,31.1,0.32,16.6,73086,85,NULL,'I, inv','IC 5170',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154182,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154182,31.45,0.45,19.5,73086,NULL,NULL,'K','IC 5170',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154183,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154183,31.45,0.4,19.5,73086,NULL,NULL,'mean','IC 5170',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154184,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154184,31.48,0.46,19.8,73086,NULL,NULL,'J','IC 5170',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154185,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154185,31.48,0.47,19.8,73086,NULL,NULL,'H','IC 5170',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154186,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154186,31.5,0.43,19.9,73086,75,NULL,'MAT, I, raw','IC 5170',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154187,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154187,31.56,0.43,20.5,73086,75,NULL,'MAT, I, inv','IC 5170',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154188,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154188,31.63,0.54,21.2,73086,NULL,NULL,NULL,'IC 5170',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154189,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154189,31.68,0.2,21.7,73086,74.4,NULL,NULL,'IC 5170',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154190,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154190,31.76,0.43,22.5,73086,75,NULL,'MAT, I, cor','IC 5170',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154191,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154191,31.76,0.4,22.5,73086,73,NULL,'opt','IC 5170',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154192,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154192,31.92,0.49,24.2,73086,75,NULL,'IR','IC 5170',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154193,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154193,31.95,0.47,24.6,73086,NULL,NULL,'Malmquist cor.','IC 5170',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154194,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154194,30.76,0.2,14.2,73087,74.4,NULL,NULL,'NGC 7231',NULL,'2013AJ....146...86T',2013,1,1.9,'abs(b) < 10 degrees.','G',0.000007,NULL,'13.90',0.7,'SBa',NULL,NULL,NULL,NULL,1,333.1255,45.32847,NULL,NULL,55554514214,868039284,13563113,13.9),(154195,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154195,30.8,0.4,14.5,73087,NULL,NULL,NULL,'NGC 7231',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154196,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154196,30.81,0.4,14.5,73087,73,NULL,'opt','NGC 7231',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154197,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154197,36.47,0.27,197,73088,70,NULL,NULL,'2MASX J22123161-0900378',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.00015,NULL,'15.4g',0.49,'E0',NULL,NULL,NULL,NULL,1,333.13175,-9.01039,0.125,NULL,49868179077,779190298,12174848,15.4),(154198,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 06120','R',154198,41.85,0.36,1600,73089,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06120',0.470141,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',NULL,'PHOT','21.4g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,333.143833333,-0.05761,0.113,NULL,49799555351,778118052,12158094,21.4),(154199,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 06120',NULL,154199,41.16,0.26,1700,73089,70,NULL,'SN photometric redshift distance, z photo =0.524 +/- 0.097','SDSS-II SN 06120',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154200,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 06120',NULL,154200,41.73,0.24,2220,73089,70,NULL,'SALT 2','SDSS-II SN 06120',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154201,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 06120',NULL,154201,41.84,0.24,2330,73089,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 06120',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154202,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154202,32.69,0.55,34.6,73090,70,NULL,NULL,'NGC 7216',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.00007,NULL,'13.53',1,'SA(rs)0-:','in a pair',NULL,NULL,NULL,1,333.149333,-68.66186,0.017,NULL,49311505801,770492278,12038941,13.53),(154203,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154203,35.61,0.14,132,73091,70,NULL,NULL,'2MASX J22123607+1401035',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000083,NULL,'16.0g',0.42,'E0',NULL,NULL,NULL,NULL,1,333.150333333,14.01775,0.173,NULL,52261002044,816578156,12759033,16),(154204,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154204,37.25,0.46,282,73092,70,NULL,NULL,'2MASX J22123615+1145027',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,333.150708333,11.75089,0.173,NULL,52279736364,816870880,12763607,16.7),(154205,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154205,37.83,0.33,368,73093,70,NULL,NULL,'2MASX J22123664+1351195',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,333.152583,13.85553,0.189,NULL,52260893342,816576458,12759007,17.2),(154206,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 21810','R',154206,39.44,0.15,656,73094,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007se','SN 2007se',0.175,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,333.154583,0.79672,0.109,NULL,52155449915,814928904,12733264,NULL),(154207,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 21810','R',154207,39.62,0.22,714,73094,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007se','SN 2007se',0.175,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154208,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154208,34.45,NULL,77.7,73095,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2373',NULL,'2010Ap&SS.325..163P',2010,1,0.84,NULL,'G',0.000013,NULL,'16.7',0.11,'Scd',NULL,NULL,NULL,NULL,1,333.16,5.87417,0.293,NULL,52196134251,815564597,12743196,16.7),(154209,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154209,34.46,NULL,77.9,73095,NULL,NULL,'Dipole + Quadrupole','FGC 2373',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154210,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154210,34.47,NULL,78.2,73095,NULL,NULL,'Dipole','FGC 2373',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154211,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154211,34.54,NULL,81,73095,NULL,NULL,NULL,'FGC 2373',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154212,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 02022','RN',154212,42.34,0.17,2230,73096,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02022',0.317397,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154213,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 02022','RN',154213,42.45,0.22,2350,73096,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02022',0.317397,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154214,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154214,36.47,0.27,197,73097,70,NULL,NULL,'2MASX J22123924-0859488',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,333.163417,-8.99681,0.125,NULL,49837772689,778715198,12167424,17.2),(154215,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154215,37.44,0.46,308,73098,70,NULL,NULL,'2MASX J22124042-0112158',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,333.168375,-1.20431,0.217,NULL,49802855514,778169617,12158900,17.8),(154216,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154216,37.83,0.33,368,73099,70,NULL,NULL,'SDSS J221240.65+135221.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00012,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,333.169417,13.87256,0.181,NULL,52260896758,816576511,12759007,18.5),(154217,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154217,35.61,0.14,132,73100,70,NULL,NULL,'2MASX J22124130+1404345',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000103,NULL,'15.9g',0.42,'E0',NULL,NULL,NULL,NULL,1,333.172167,14.07622,0.173,NULL,52261007525,816578242,12759035,15.9),(154218,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154218,37.52,0.59,319,73101,70,NULL,NULL,'2MASX J22124155-1925154',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'17.63',0.27,NULL,NULL,NULL,NULL,NULL,1,333.173125,-19.42097,0.049,NULL,49735095191,777110862,12142357,17.63),(154219,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2005hv',NULL,154219,39.37,0.13,639,73102,74.2,NULL,'SALT 2','SDSS J221243.87-000206.2',0.17,'2010ApJ...716..712A',2010,1,0.07,NULL,'G',NULL,NULL,'20.3g',0.07,NULL,NULL,NULL,NULL,NULL,1,333.182833,-0.03506,0.113,NULL,49799502568,778117227,12158081,20.3),(154220,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2005hv',NULL,154220,40.04,0.11,871,73102,65,NULL,'SALT2','SDSS J221243.87-000206.2',0.17,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154221,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2005hv',NULL,154221,40.05,0.13,875,73102,70,NULL,'SDSS-II SN 05635, SALT 2','SDSS J221243.87-000206.2',0.17,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154222,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 05635','R',154222,40.1,0.2,895,73102,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005hv','SDSS J221243.87-000206.2',0.17,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154223,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2005hv',NULL,154223,40.12,0.04,905,73102,70,NULL,'SDSS-II SN 05635','SDSS J221243.87-000206.2',0.17,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154224,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2005hv',NULL,154224,40.27,0.11,970,73102,65,NULL,'MLCS2k2','SDSS J221243.87-000206.2',0.17,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154225,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 05635','R',154225,40.29,0.12,976,73102,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005hv','SDSS J221243.87-000206.2',0.17,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154226,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154226,36.47,0.27,197,73103,70,NULL,NULL,'2MASX J22124416-0854058',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00015,NULL,'16.0g',0.43,'E0',NULL,NULL,NULL,NULL,1,333.184125,-8.90153,0.125,NULL,49837776895,778715263,12167425,16),(154227,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154227,34.96,0.2,98.2,73104,74.4,NULL,NULL,'2MASX J22124529+1351485',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000067,NULL,'14.0I',0.3,NULL,NULL,NULL,NULL,NULL,1,333.188583,13.86339,0.181,NULL,52260894266,816576472,12759007,14),(154228,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154228,35.43,0.39,122,73104,NULL,NULL,'Malmquist cor.','2MASX J22124529+1351485',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154229,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154229,35.49,0.38,125,73104,NULL,NULL,NULL,'2MASX J22124529+1351485',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154230,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154230,38.03,0.33,404,73105,70,NULL,NULL,'2MASX J22125063-0845327',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,333.211,-8.75917,0.129,NULL,49837799336,778715614,12167431,17.3),(154231,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154231,35.47,0.59,124,73106,70,NULL,NULL,'2MASX J22125122-0105498',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'16.4g',0.18,'Sa',NULL,NULL,NULL,NULL,1,333.213375,-1.09725,0.217,NULL,49802796115,778168689,12158885,16.4),(154232,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154232,35.78,0.46,143,73107,70,NULL,NULL,'2MASX J22125304+1221585',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000132,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,333.2212083,12.36631,0.209,NULL,52246444334,816350692,12755479,16.5),(154233,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154233,38.03,0.33,404,73108,70,NULL,NULL,'2MASX J22125313-0846457',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,333.221375,-8.77939,0.129,NULL,49837794410,778715537,12167430,17.3),(154234,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154234,32.6,NULL,33.1,73109,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 532- G 032',NULL,'2010Ap&SS.325..163P',2010,1,2.04,NULL,'G',0.000013,NULL,'16.19',0.2,'Sdm',NULL,NULL,NULL,NULL,1,333.221541667,-25.643,0.021,NULL,50533488330,789585755,12337277,16.19),(154235,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154235,32.62,NULL,33.5,73109,NULL,NULL,'Dipole','ESO 532- G 032',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154236,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154236,32.64,NULL,33.7,73109,NULL,NULL,'Dipole + Quadrupole','ESO 532- G 032',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154237,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154237,32.73,NULL,35.1,73109,NULL,NULL,NULL,'ESO 532- G 032',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154238,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154238,37.99,0.46,396,73110,70,NULL,NULL,'2MASX J22125366+1345525',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,333.2235417,13.76456,0.189,NULL,52260118860,816564357,12758818,17.4),(154239,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154239,36.92,0.46,242,73111,70,NULL,NULL,'2MASX J22125763-0829361',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,333.240125,-8.49333,0.141,NULL,49837888001,778717000,12167453,17.7),(154240,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 05486','R',154240,40.49,0.16,1020,73112,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J221259.50-002441.7',0.2292,'2014arXiv1401.3317S',2014,1,0.15,NULL,'G',0.0005,NULL,'20.4g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,333.247917,-0.41161,0.177,NULL,49802609104,778165767,12158840,20.4),(154241,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 05486','R',154241,40.51,0.23,1030,73112,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J221259.50-002441.7',0.2292,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154242,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 05486',NULL,154242,40.43,0.13,1220,73112,70,NULL,'SALT 2','SDSS J221259.50-002441.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154243,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 05486',NULL,154243,40.45,0.13,1230,73112,70,NULL,'SALT 2, Malmquist cor.','SDSS J221259.50-002441.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154244,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154244,31.57,0.8,20.6,73113,75,NULL,'MAT, I','ESO 146- G 014',NULL,'1997ApJS..109..333W',1997,1,3.25,NULL,'G',0.000017,NULL,'15.12',0.25,'SBd? sp',NULL,NULL,NULL,NULL,1,333.2517917,-62.06761,0.053,NULL,48671155482,760486804,11882606,15.12),(154245,'Tully est','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154245,31.56,0.8,20.5,73113,75,NULL,NULL,'ESO 146- G 014',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154246,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154246,31.22,0.43,17.5,73113,75,NULL,'3.6 micron, color + selection bias corrected','ESO 146- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154247,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154247,31.31,0.32,18.3,73113,85,NULL,'I, inv','ESO 146- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154248,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154248,31.37,0.32,18.8,73113,85,NULL,'I, raw','ESO 146- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154249,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154249,31.4,0.43,19,73113,75,NULL,'3.6 micron, color corrected','ESO 146- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154250,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154250,31.43,NULL,19.3,73113,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 146- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154251,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154251,31.44,0.2,19.4,73113,74.4,NULL,NULL,'ESO 146- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154252,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154252,31.45,NULL,19.5,73113,NULL,NULL,'Dipole + Quadrupole','ESO 146- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154253,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154253,31.46,NULL,19.6,73113,NULL,NULL,'Dipole','ESO 146- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154254,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154254,31.54,NULL,20.4,73113,NULL,NULL,NULL,'ESO 146- G 014',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154255,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154255,31.68,0.4,21.7,73113,NULL,NULL,NULL,'ESO 146- G 014',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154256,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154256,31.68,0.39,21.7,73113,73,NULL,'opt','ESO 146- G 014',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154257,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154257,31.69,0.43,21.8,73113,75,NULL,'MAT, I, inv','ESO 146- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154258,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154258,31.83,0.43,23.3,73113,75,NULL,'MAT, I, raw','ESO 146- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154259,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154259,32.16,0.43,27.1,73113,75,NULL,'MAT, I, cor','ESO 146- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154260,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154260,35.97,0.46,157,73114,70,NULL,NULL,'2MASX J22130154+0014407',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000178,NULL,'16.0g',0.39,'E0',NULL,NULL,NULL,NULL,1,333.2565417,0.24458,0.121,NULL,52155686393,814932599,12733321,16),(154261,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154261,37.67,0.27,342,73115,70,NULL,NULL,'SDSS J221302.61-000304.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,333.260916667,-0.05136,0.173,NULL,49799498091,778117157,12158080,18),(154262,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154262,37.67,0.27,342,73116,70,NULL,NULL,'2MASX J22130378-0007378',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,333.265875,-0.12725,0.173,NULL,49802385841,778162278,12158785,18),(154263,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154263,32.87,0.8,37.5,73117,75,NULL,'MAT, I','NGC 7219',NULL,'1997ApJS..109..333W',1997,1,1.7,'ESO-LV gives v= 4400+/- 10 km/sec.','G',0.000033,NULL,'13.27',1,'(R\'_2)SA(r)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,333.287583333,-64.84897,0,NULL,49278019272,769969051,12030766,13.27),(154264,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154264,32.9,0.32,38.1,73117,85,NULL,'I, raw','NGC 7219',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154265,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154265,32.94,0.32,38.8,73117,85,NULL,'I, inv','NGC 7219',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154266,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154266,33.02,0.39,40.1,73117,NULL,NULL,NULL,'NGC 7219',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154267,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154267,33.03,0.43,40.3,73117,75,NULL,'MAT, I, raw','NGC 7219',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154268,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154268,33.06,0.2,40.9,73117,74.4,NULL,NULL,'NGC 7219',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154269,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154269,33.12,0.43,42.1,73117,75,NULL,'MAT, I, cor','NGC 7219',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154270,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154270,33.16,0.36,42.8,73117,NULL,NULL,'Malmquist cor.','NGC 7219',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154271,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154271,33.23,0.43,44.2,73117,75,NULL,'MAT, I, inv','NGC 7219',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154272,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2005gs',NULL,154272,40.06,0.13,809,73118,74.2,NULL,'SALT 2','SDSS J221310.18+010301.3',0.27,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.292417,1.05036,0.077,NULL,52155471063,814929235,12733269,NULL),(154273,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2005gs',NULL,154273,40.61,0.04,1040,73118,70,NULL,'SDSS-II SN 03199','SDSS J221310.18+010301.3',0.27,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154274,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2005gs',NULL,154274,40.18,0.1,1090,73118,70,NULL,'Hubble residual 0.31 for z0.25110','SDSS J221310.18+010301.3',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154275,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2005gs',NULL,154275,40.77,0.11,1120,73118,65,NULL,'SALT2','SDSS J221310.18+010301.3',0.27,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154276,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2005gs',NULL,154276,40.85,0.15,1160,73118,70,NULL,'SDSS-II SN 03199, SALT 2','SDSS J221310.18+010301.3',0.27,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154277,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 03199','R',154277,40.85,0.13,1180,73118,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005gs','SDSS J221310.18+010301.3',0.2511,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154278,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2005gs',NULL,154278,40.91,0.12,1190,73118,65,NULL,'MLCS2k2','SDSS J221310.18+010301.3',0.27,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154279,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 03199','R',154279,40.92,0.2,1220,73118,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005gs','SDSS J221310.18+010301.3',0.2511,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154280,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154280,34.24,0.4,70.5,73119,NULL,NULL,'mean','ESO 532- G 034',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000033,NULL,'13.92',0.6,'Sb             HII',NULL,NULL,NULL,NULL,1,333.2935,-22.445,0.053,NULL,49731556778,777055574,12141493,13.92),(154281,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154281,34.45,0.42,77.8,73119,NULL,NULL,'Malmquist cor.','ESO 532- G 034',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154282,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154282,34.47,0.47,78.2,73119,NULL,NULL,'H','ESO 532- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154283,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154283,34.52,0.4,80.2,73119,NULL,NULL,NULL,'ESO 532- G 034',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154284,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154284,34.54,0.45,80.8,73119,NULL,NULL,'K','ESO 532- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154285,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154285,34.56,0.2,81.7,73119,74.4,NULL,NULL,'ESO 532- G 034',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154286,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154286,34.56,0.46,81.8,73119,NULL,NULL,'J','ESO 532- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154287,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 05512','RN',154287,41.34,0.18,1320,73120,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05512',0.408648,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154288,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 05512','RN',154288,41.4,0.1,1350,73120,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 05512',0.408648,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154289,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154289,35.83,0.5,146,73121,70,NULL,NULL,'2MASX J22131283-5724358',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000103,NULL,'15.48',0.52,'S0',NULL,NULL,NULL,NULL,1,333.3035,-57.40997,0,NULL,48708234040,761066156,11891658,15.48),(154290,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154290,35.23,0.46,111,73122,70,NULL,NULL,'2MASX J22131344-0733061',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'15.9g',0.37,'E0',NULL,NULL,NULL,NULL,1,333.305833,-7.55161,0.185,NULL,49839874317,778748036,12167938,15.9),(154291,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154291,35.44,0.59,123,73122,70,NULL,NULL,'2MASX J22131344-0733061',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154292,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154292,36.39,0.82,190,73123,70,NULL,NULL,'2MASX J22131445-1040251',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'17.01',0.28,NULL,NULL,NULL,NULL,NULL,1,333.310333333,-10.67367,0.105,NULL,49865247439,779144491,12174132,17.01),(154293,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154293,37.41,0.46,303,73124,70,NULL,NULL,'2MASX J22131546-0038018',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00015,NULL,'16.76',0.28,NULL,NULL,NULL,NULL,NULL,1,333.3144583,-0.63375,0.177,NULL,49802507642,778164181,12158815,16.76),(154294,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154294,34.6,0.2,83.2,73125,74.4,NULL,NULL,'2MASX J22131544+1359011',NULL,'2013AJ....146...86T',2013,1,0.76,NULL,'G',0.00009,NULL,'16.2g',0.27,'Scd',NULL,NULL,NULL,NULL,1,333.314583,13.98383,0.181,NULL,52260848803,816575762,12758996,16.2),(154295,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154295,34.73,0.44,88.1,73125,NULL,NULL,NULL,'2MASX J22131544+1359011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154296,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154296,34.98,0.39,99.1,73125,NULL,NULL,'Malmquist cor.','2MASX J22131544+1359011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154297,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154297,38.33,0.46,464,73126,70,NULL,NULL,'SDSS J221318.38-002054.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000153,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,333.326625,-0.34836,0.177,NULL,49802402482,778162538,12158789,18.7),(154298,'Faber-Jackson','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154298,31.22,0.65,17.5,73127,95,NULL,'Weighted Mean','IC 5181',NULL,'1984ApJS...56...91D',1984,1,2.6,NULL,'G',0.00008,NULL,'12.51',0.8,'S0^0           LINER','in a pair',NULL,NULL,NULL,1,333.340417,-46.01761,0,NULL,50692548381,792071068,12376110,12.51),(154299,'Faber-Jackson','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154299,32.49,0.81,31.5,73127,55,NULL,'Visvanathan & Sandage 1979','IC 5181',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154300,'Tully est','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154300,31.97,0.8,24.8,73127,75,NULL,'B','IC 5181',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154301,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154301,35.01,0.49,101,73128,NULL,NULL,'Malmquist cor.','ESO 532- G 035',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.80',0.7,'Sb',NULL,NULL,NULL,NULL,1,333.347833,-27.21964,0,NULL,50534372157,789599564,12337493,14.8),(154302,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154302,35.11,0.46,105,73128,NULL,NULL,NULL,'ESO 532- G 035',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154303,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154303,35.15,0.2,107,73128,74.4,NULL,NULL,'ESO 532- G 035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154304,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 05487',NULL,154304,40.32,0.15,1160,73129,70,NULL,'SN photometric redshift distance, z photo =0.320 +/- 0.028','SDSS-II SN 05487',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,333.349583,-0.26314,0.173,NULL,49802442062,778163157,12158799,NULL),(154305,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154305,37.67,0.27,342,73130,70,NULL,NULL,'2MASX J22132499-0008207',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00015,NULL,'16.3g',0.39,'BrClG',NULL,NULL,NULL,NULL,1,333.35425,-0.13914,0.173,NULL,49802388766,778162324,12158786,16.3),(154306,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154306,34.18,0.47,68.7,73131,NULL,NULL,'H','IC 1435',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000027,NULL,'13.73',0.8,'SA(rs:)b;ALG   HII',NULL,NULL,NULL,NULL,1,333.359541667,-22.09669,0.049,NULL,49729404255,777021941,12140967,13.73),(154307,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154307,34.27,0.45,71.5,73131,NULL,NULL,'K','IC 1435',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154308,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154308,34.29,0.46,72,73131,NULL,NULL,'J','IC 1435',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154309,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154309,34.31,0.4,72.7,73131,NULL,NULL,'mean','IC 1435',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154310,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154310,34.56,0.42,81.6,73131,NULL,NULL,'Malmquist cor.','IC 1435',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154311,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154311,34.65,0.4,85.3,73131,NULL,NULL,NULL,'IC 1435',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154312,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154312,34.69,0.2,86.7,73131,74.4,NULL,NULL,'IC 1435',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154313,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4ev',NULL,154313,42.27,0.17,1650,73132,NULL,NULL,'SALT2','SNLS 05D4ev HOST',0.722,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.37675,-17.70078,0.049,NULL,49787079192,777923112,12155048,NULL),(154314,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4ev',NULL,154314,43.33,0.22,2700,73132,70,NULL,'SALT 2','SNLS 05D4ev HOST',0.722,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154315,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4ev',NULL,154315,43.35,0.15,2720,73132,NULL,NULL,'SIFTO','SNLS 05D4ev HOST',0.722,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154316,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4ev',NULL,154316,43.57,0.06,3010,73132,70,NULL,'SALT2','SNLS 05D4ev HOST',0.722,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154317,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154317,38.19,0.46,434,73133,70,NULL,NULL,'SDSS J221330.98+004919.6',NULL,'2015arXiv151105856S',2015,1,0.07,NULL,'G',0.000144,NULL,'18.4g',0.06,NULL,NULL,NULL,NULL,NULL,1,333.379083,0.82214,0.109,NULL,52155967170,814936987,12733390,18.4),(154318,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154318,34.1,0.8,66.1,73134,75,NULL,'MAT, I','ESO 467- G 023',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'13.73',0.4,'Sab pec:       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,333.380583,-27.55803,0,NULL,50534507546,789601680,12337526,13.73),(154319,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154319,33.68,0.45,54.6,73134,NULL,NULL,'K','ESO 467- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154320,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154320,33.71,0.47,55.1,73134,NULL,NULL,'H','ESO 467- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154321,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154321,33.73,0.46,55.8,73134,NULL,NULL,'J','ESO 467- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154322,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154322,34.05,0.4,64.4,73134,NULL,NULL,'mean','ESO 467- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154323,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154323,34.07,0.43,65.2,73134,75,NULL,'MAT, I, raw','ESO 467- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154324,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154324,34.15,0.32,67.7,73134,85,NULL,'I, raw','ESO 467- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154325,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154325,34.22,0.32,69.9,73134,85,NULL,'I, inv','ESO 467- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154326,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154326,34.29,0.4,72.1,73134,NULL,NULL,'Malmquist cor.','ESO 467- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154327,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154327,34.33,0.43,73.3,73134,75,NULL,'MAT, I, cor','ESO 467- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154328,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154328,34.36,0.43,74.4,73134,75,NULL,'MAT, I, inv','ESO 467- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154329,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154329,34.4,0.38,76,73134,NULL,NULL,NULL,'ESO 467- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154330,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154330,34.44,0.2,77.3,73134,74.4,NULL,NULL,'ESO 467- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154331,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4cn',NULL,154331,43.2,0.05,2480,73135,70,NULL,'SIFTO','SNLS 05D4cn HOST',0.763,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.3810417,-17.28886,0.045,NULL,49786744900,777917889,12154967,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (154332,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4cn',NULL,154332,43.37,0.15,2670,73135,NULL,NULL,'SIFTO','SNLS 05D4cn HOST',0.763,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154333,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4cn',NULL,154333,43.4,0.21,2710,73135,70,NULL,'SALT 2','SNLS 05D4cn HOST',0.763,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154334,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4cn',NULL,154334,44.91,0.17,5440,73135,NULL,NULL,'SALT2','SNLS 05D4cn HOST',0.763,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154335,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154335,37.2,0.46,276,73136,70,NULL,NULL,'2MASX J22133184+0050568',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000152,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,333.382625,0.84925,0.109,NULL,52155971145,814937049,12733391,17.3),(154336,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 19070','R',154336,42.59,0.49,2240,73137,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007na','SDSS J221332.71+005249.5',0.470359,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,NULL,'21.2g',0.04,NULL,NULL,NULL,NULL,NULL,1,333.386291667,0.88042,0.109,NULL,52155972793,814937074,12733391,21.2),(154337,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 03403','RN',154337,44.48,0.38,5370,73138,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03403',0.467519,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154338,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154338,37.34,0.46,293,73139,70,NULL,NULL,'2MASX J22133843-0039338',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,333.41025,-0.65939,0.177,NULL,49802467940,778163561,12158805,17.7),(154339,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154339,34.47,NULL,78.2,73140,NULL,NULL,'Dipole','UGC 11952',NULL,'2010Ap&SS.325..163P',2010,1,2.24,NULL,'G',0.000009,NULL,'15.47',0.28,'SBcd?',NULL,NULL,NULL,NULL,1,333.41175,14.21908,0.177,NULL,52260949418,816577334,12759020,15.47),(154340,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154340,34.49,NULL,79.2,73140,NULL,NULL,'Dipole + Quadrupole','UGC 11952',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154341,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154341,34.51,NULL,79.7,73140,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11952',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154342,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154342,34.79,NULL,90.8,73140,NULL,NULL,NULL,'UGC 11952',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154343,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154343,35.25,0.2,112,73140,74.4,NULL,NULL,'UGC 11952',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154344,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154344,35.27,0.34,113,73140,NULL,NULL,NULL,'UGC 11952',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154345,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154345,35.32,0.33,116,73140,NULL,NULL,'Malmquist cor.','UGC 11952',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154346,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154346,35.59,0.49,131,73141,70,NULL,NULL,'2MASX J22134008-7301532',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'15.6b',0.36,NULL,NULL,NULL,NULL,NULL,1,333.416833,-73.03147,0.077,NULL,48412437571,756444337,11819442,15.6),(154347,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy','R',154347,43.11,NULL,2180,73142,65,NULL,'MLCS17','[HSP2005] J221340.46-174053.90',0.927,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.418583,-17.68164,0.049,NULL,49787193645,777924900,12155076,NULL),(154348,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy',NULL,154348,43.24,0.29,2310,73142,74.2,NULL,'SALT 2','[HSP2005] J221340.46-174053.90',0.927,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154349,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy',NULL,154349,43.67,0.1,2810,73142,70,NULL,'MLCS17','[HSP2005] J221340.46-174053.90',0.927,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154350,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy',NULL,154350,43.89,0.27,3110,73142,65,NULL,'MLCS2k2','[HSP2005] J221340.46-174053.90',0.927,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154351,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy',NULL,154351,43.99,0.26,3260,73142,65,NULL,'SALT2','[HSP2005] J221340.46-174053.90',0.927,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154352,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy',NULL,154352,44.04,0.2,3340,73142,65,NULL,'MLCS17','[HSP2005] J221340.46-174053.90',0.927,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154353,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy',NULL,154353,44.09,0.28,3410,73142,70,NULL,'SALT 2','[HSP2005] J221340.46-174053.90',0.927,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154354,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy',NULL,154354,44.14,0.15,3500,73142,NULL,NULL,'SIFTO','[HSP2005] J221340.46-174053.90',0.927,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154355,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy',NULL,154355,44.15,0.14,3510,73142,65,NULL,'MLCS2k2','[HSP2005] J221340.46-174053.90',0.927,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154356,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy',NULL,154356,44.15,0.16,3510,73142,65,NULL,'MLCS31','[HSP2005] J221340.46-174053.90',0.927,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154357,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy',NULL,154357,44.55,0.38,4220,73142,70,NULL,NULL,'[HSP2005] J221340.46-174053.90',0.927,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154358,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy',NULL,154358,44.74,0.62,4600,73142,70,NULL,'SALT','[HSP2005] J221340.46-174053.90',0.927,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154359,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy',NULL,154359,44.87,0.24,4880,73142,65,NULL,'SALT','[HSP2005] J221340.46-174053.90',0.927,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154360,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy',NULL,154360,45,0.58,5180,73142,65,NULL,'SALT','[HSP2005] J221340.46-174053.90',0.927,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154361,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy',NULL,154361,45.07,0.5,5370,73142,65,NULL,'SALT2','[HSP2005] J221340.46-174053.90',0.927,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154362,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy',NULL,154362,45.23,0.17,5770,73142,NULL,NULL,'SALT2','[HSP2005] J221340.46-174053.90',0.927,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154363,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154363,37.05,0.46,257,73143,70,NULL,NULL,'2MASX J22134223+1204167',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000136,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,333.425791667,12.07139,0.169,NULL,52279457127,816866517,12763539,17.3),(154364,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 21062','R',154364,39.54,0.19,709,73144,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007rp','SDSS J221343.62+002346.6',0.138642,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,NULL,'21.2g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,333.4317917,0.39631,0.117,NULL,52155884299,814935692,12733370,21.2),(154365,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 21062','R',154365,39.58,0.11,722,73144,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007rp','SDSS J221343.62+002346.6',0.138642,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154366,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2007rp',NULL,154366,39.33,0.07,735,73144,70,NULL,'SALT 2','SDSS J221343.62+002346.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154367,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2007rp',NULL,154367,39.34,0.07,738,73144,70,NULL,'SALT 2, Malmquist cor.','SDSS J221343.62+002346.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154368,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154368,35.61,0.14,132,73145,70,NULL,NULL,'CGCG 428-050',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000103,NULL,'15.7',0.4,NULL,NULL,NULL,NULL,NULL,1,333.436,13.99389,0.157,NULL,52260061445,816563460,12758804,15.7),(154369,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154369,37.7,0.23,347,73146,70,NULL,NULL,'SDSS J221345.50-083350.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,333.439583,-8.56414,0.145,NULL,49842149456,778783585,12168493,18.2),(154370,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154370,34.36,0.49,74.6,73147,75,NULL,'IR','CGCG 428-049',NULL,'2011yCatp016004901K',2011,1,1.03,NULL,'G',0.000093,NULL,'15.6g',0.26,'Sab            AGN','Group member',NULL,NULL,NULL,1,333.443833333,13.79075,0.181,NULL,52260201419,816565647,12758838,15.6),(154371,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154371,37.43,0.46,306,73148,70,NULL,NULL,'2MASX J22134705+0051249',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,333.445916667,0.85692,0.109,NULL,52155930090,814936407,12733381,17.1),(154372,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4ag',NULL,154372,42.77,0.19,2190,73149,70,NULL,'SALT 2','SNLS 05D4ag HOST',0.64,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.447625,-18.16528,0.049,NULL,49732273881,777066779,12141668,NULL),(154373,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4ag',NULL,154373,43.03,0.15,2460,73149,NULL,NULL,'SIFTO','SNLS 05D4ag HOST',0.64,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154374,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4ag',NULL,154374,43.24,0.06,2710,73149,70,NULL,'SIFTO','SNLS 05D4ag HOST',0.64,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154375,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4ag',NULL,154375,43.51,0.17,3070,73149,NULL,NULL,'SALT2','SNLS 05D4ag HOST',0.64,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154376,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154376,38.03,0.46,404,73150,70,NULL,NULL,'2MASX J22134905-0854027',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000178,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,333.4545417,-8.90072,0.129,NULL,49842204613,778784447,12168506,17.3),(154377,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 19207','R',154377,40.62,0.25,1050,73151,70,NULL,'SDSS CAND. SNIa; SALT 2','SN 2007oa',0.2587,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,333.4639583,-0.92028,0.233,NULL,49802944643,778171010,12158922,NULL),(154378,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 19207','R',154378,40.7,0.18,1100,73151,70,NULL,'SDSS CAND. SNIa; MLCS2K2','SN 2007oa',0.2587,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154379,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 04D4jy',NULL,154379,43.7,0.11,2850,73152,70,NULL,'SIFTO','[HSP2005] J221351.60-172418.13',0.93,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.02,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.465,-17.40503,0.041,NULL,49787222742,777925355,12155083,NULL),(154380,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 04D4jy',NULL,154380,44.16,0.27,3520,73152,70,NULL,'SALT 2','[HSP2005] J221351.60-172418.13',0.93,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154381,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 04D4jy',NULL,154381,44.27,0.15,3700,73152,NULL,NULL,'SIFTO','[HSP2005] J221351.60-172418.13',0.93,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154382,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 04D4jy',NULL,154382,44.36,0.17,3850,73152,NULL,NULL,'SALT2','[HSP2005] J221351.60-172418.13',0.93,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154383,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154383,37.22,0.33,278,73153,70,NULL,NULL,'2MASX J22135181-0840227',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000166,NULL,'17.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,333.465833,-8.67297,0.141,NULL,49842135326,778783364,12168490,17.1),(154384,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154384,37.69,0.46,345,73154,70,NULL,NULL,'2MASX J22135263+1244410',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,333.469333,12.74464,0.193,NULL,52247244619,816363197,12755674,17.9),(154385,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154385,35.56,0.51,129,73155,70,NULL,NULL,'2MASX J22135420-7246492',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00015,NULL,'15.6b',1.2,'S0- pec?',NULL,NULL,NULL,NULL,1,333.475667,-72.78044,0.037,NULL,49298231168,770284862,12035700,15.6),(154386,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154386,36.41,0.67,191,73156,70,NULL,NULL,'2MASX J22135427-7250362',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'16.3b',0.26,NULL,NULL,NULL,NULL,NULL,1,333.47625,-72.84344,0.077,NULL,48412328891,756442638,11819416,16.3),(154387,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154387,35.29,0.2,114,73157,74.4,NULL,NULL,'UGC 11953',NULL,'2013AJ....146...86T',2013,1,1.06,NULL,'G',0.00006,NULL,'15.0g',0.4,'Sab','Group member',NULL,NULL,NULL,1,333.483167,13.75539,0.181,NULL,52260204801,816565700,12758839,15),(154388,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2005ka',NULL,154388,40.67,0.19,1030,73158,74.2,NULL,'SALT 2','SDSS J221356.02+010510.1',0.32,'2010ApJ...716..712A',2010,1,0.07,NULL,'G',0.0005,NULL,'21.0g',0.06,NULL,NULL,NULL,NULL,NULL,1,333.483416667,1.08617,0.113,NULL,52156124303,814939442,12733428,21),(154389,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 06100','R',154389,41.19,0.2,1310,73158,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ka','SDSS J221356.02+010510.1',0.3177,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154390,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2005ka',NULL,154390,40.71,0.22,1390,73158,70,NULL,'Hubble residual 0.41 for z0.31770','SDSS J221356.02+010510.1',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154391,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 06100','R',154391,41.45,0.3,1480,73158,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ka','SDSS J221356.02+010510.1',0.3177,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154392,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2005ka',NULL,154392,41.46,0.18,1490,73158,65,NULL,'MLCS2k2','SDSS J221356.02+010510.1',0.32,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154393,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2005ka',NULL,154393,41.49,0.27,1500,73158,65,NULL,'SALT2','SDSS J221356.02+010510.1',0.32,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154394,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154394,37.33,0.46,293,73159,70,NULL,NULL,'SDSS J221356.98-010503.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000141,NULL,'18.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,333.487416667,-1.08425,0.217,NULL,49803135641,778173994,12158968,18.9),(154395,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4ef',NULL,154395,41.48,0.17,1230,73160,NULL,NULL,'SALT2','SNLS 05D4ef HOST',0.605,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.497125,-18.21233,0.049,NULL,49732279109,777066861,12141669,NULL),(154396,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4ef',NULL,154396,42.95,0.16,2420,73160,70,NULL,'SALT 2','SNLS 05D4ef HOST',0.605,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154397,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4ef',NULL,154397,42.99,0.15,2470,73160,NULL,NULL,'SIFTO','SNLS 05D4ef HOST',0.605,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154398,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4ef',NULL,154398,43.1,0.05,2590,73160,70,NULL,'SALT2','SNLS 05D4ef HOST',0.605,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154399,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154399,32.56,0.8,32.5,73161,75,NULL,'MAT, I','ESO 533- G 004',NULL,'1997ApJS..109..333W',1997,1,2.82,NULL,'G',0.00001,NULL,'15.29',0.39,'Scd',NULL,NULL,NULL,NULL,1,333.512583,-26.93772,0.025,NULL,50536309487,789629835,12337966,15.29),(154400,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154400,32.4,0.4,30.2,73161,75,NULL,NULL,'ESO 533- G 004',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154401,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154401,32.4,0.39,30.2,73161,73,NULL,'IR','ESO 533- G 004',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154402,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154402,32.6,0.15,33.2,73161,NULL,NULL,NULL,'ESO 533- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154403,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154403,32.67,0.4,34.2,73161,NULL,NULL,'mean','ESO 533- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154404,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154404,32.79,0.43,36.1,73161,75,NULL,'MAT, I, raw','ESO 533- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154405,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154405,32.8,0.43,36.3,73161,75,NULL,'3.6 micron, color + selection bias corrected','ESO 533- G 004',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154406,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154406,32.82,0.32,36.7,73161,85,NULL,'I, raw','ESO 533- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154407,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154407,32.83,0.47,36.8,73161,NULL,NULL,'H','ESO 533- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154408,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154408,32.85,0.46,37.1,73161,NULL,NULL,'J','ESO 533- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154409,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154409,32.85,0.32,37.2,73161,85,NULL,'I, inv','ESO 533- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154410,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154410,32.86,0.45,37.4,73161,NULL,NULL,'K','ESO 533- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154411,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154411,32.9,0.43,38,73161,75,NULL,'3.6 micron, color corrected','ESO 533- G 004',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154412,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154412,32.94,0.43,38.7,73161,75,NULL,'MAT, I, inv','ESO 533- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154413,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154413,32.94,0.49,38.7,73161,75,NULL,'IR','ESO 533- G 004',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154414,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154414,33.04,0.2,40.6,73161,74.4,NULL,NULL,'ESO 533- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154415,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154415,33.05,0.43,40.7,73161,75,NULL,'MAT, I, cor','ESO 533- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154416,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154416,33.55,NULL,51.2,73161,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 533- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154417,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154417,33.55,NULL,51.3,73161,NULL,NULL,NULL,'ESO 533- G 004',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154418,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154418,33.57,NULL,51.6,73161,NULL,NULL,'Dipole + Quadrupole','ESO 533- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154419,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154419,33.57,NULL,51.9,73161,NULL,NULL,'Dipole','ESO 533- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154420,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154420,37.22,0.33,278,73162,70,NULL,NULL,'2MASXi J2214054-084337',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00021,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,333.52275,-8.727,0.141,NULL,49842174432,778783975,12168499,17.6),(154421,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154421,37.59,0.46,330,73163,70,NULL,NULL,'2MASXi J2214065-072511',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000137,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,333.527417,-7.41961,0.181,NULL,49841231564,778769243,12168269,17.7),(154422,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154422,37.49,0.46,315,73164,70,NULL,NULL,'2MASX J22140659-0804371',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,333.527417,-8.07692,0.165,NULL,49842721239,778792519,12168633,17.4),(154423,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154423,35.61,0.14,132,73165,70,NULL,NULL,'2MASX J22140773+1342301',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,333.532125,13.70853,0.181,NULL,52260206603,816565728,12758839,16.9),(154424,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154424,35.09,0.59,104,73166,70,NULL,NULL,'2MASX J22140795-5220285',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'16.12',0.4,'E',NULL,NULL,NULL,NULL,1,333.533041667,-52.34133,0,NULL,50631370737,791115167,12361174,16.12),(154425,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154425,33.64,0.8,53.4,73167,75,NULL,'MAT, I','ESO 404- G 045',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.000023,NULL,'15.20',0.28,'Sbc',NULL,NULL,NULL,NULL,1,333.5399583,-33.23542,0,NULL,50593069279,790516707,12351823,15.2),(154426,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154426,33.06,0.32,40.9,73167,85,NULL,'I, raw','ESO 404- G 045',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154427,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154427,33.08,0.32,41.3,73167,85,NULL,'I, inv','ESO 404- G 045',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154428,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154428,33.08,0.43,41.4,73167,75,NULL,'MAT, I, raw','ESO 404- G 045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154429,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154429,33.21,0.43,43.8,73167,75,NULL,'MAT, I, inv','ESO 404- G 045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154430,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154430,33.3,0.43,45.7,73167,75,NULL,'MAT, I, cor','ESO 404- G 045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154431,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154431,33.57,NULL,51.7,73167,NULL,NULL,NULL,'ESO 404- G 045',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154432,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154432,33.92,NULL,60.8,73167,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 404- G 045',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154433,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154433,33.94,NULL,61.4,73167,NULL,NULL,'Dipole + Quadrupole','ESO 404- G 045',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154434,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154434,33.96,NULL,62,73167,NULL,NULL,'Dipole','ESO 404- G 045',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154435,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154435,34.15,0.2,67.6,73167,74.4,NULL,NULL,'ESO 404- G 045',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154436,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154436,34.37,0.49,74.8,73167,75,NULL,'IR','ESO 404- G 045',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154437,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154437,34.52,0.47,80.2,73167,NULL,NULL,'Malmquist cor.','ESO 404- G 045',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154438,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154438,34.61,0.45,83.7,73167,NULL,NULL,NULL,'ESO 404- G 045',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154439,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4cq',NULL,154439,42.65,0.05,1990,73168,70,NULL,'SIFTO','SNLS 05D4cq HOST',0.701,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.5402083,-18.22672,0.049,NULL,49732278029,777066844,12141669,NULL),(154440,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4cq',NULL,154440,43.12,0.15,2480,73168,NULL,NULL,'SIFTO','SNLS 05D4cq HOST',0.701,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154441,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4cq',NULL,154441,43.3,0.19,2680,73168,70,NULL,'SALT 2','SNLS 05D4cq HOST',0.701,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154442,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4cq',NULL,154442,44.42,0.17,4500,73168,NULL,NULL,'SALT2','SNLS 05D4cq HOST',0.701,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154443,'G Lens','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154443,45.59,0.17,7700,73168,NULL,NULL,'SNLS 05D4cq HOST','SNLS 05D4cq HOST',0.701,'2010A&A...514A..44K',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154444,'Faber-Jackson','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154444,45.55,0.17,7570,73168,NULL,NULL,'SNLS 05D4cq HOST','SNLS 05D4cq HOST',0.701,'2010A&A...514A..44K',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154445,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di','R',154445,42.52,NULL,1680,73169,65,NULL,'MLCS17','[AGR2006] J221410.24-173024.1',0.905,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.5427083,-17.50672,0.041,NULL,49787395300,777928051,12155125,NULL),(154446,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di',NULL,154446,42.93,0.26,2020,73169,74.2,NULL,'SALT 2','[AGR2006] J221410.24-173024.1',0.905,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154447,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di',NULL,154447,43.18,0.08,2280,73169,70,NULL,'MLCS17','[AGR2006] J221410.24-173024.1',0.905,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154448,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di',NULL,154448,43.69,0.42,2870,73169,70,NULL,'SALT','[AGR2006] J221410.24-173024.1',0.905,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154449,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di',NULL,154449,43.71,0.26,2900,73169,70,NULL,NULL,'[AGR2006] J221410.24-173024.1',0.905,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154450,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di',NULL,154450,43.72,0.23,2910,73169,65,NULL,'SALT2','[AGR2006] J221410.24-173024.1',0.905,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154451,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di',NULL,154451,43.74,0.22,2940,73169,65,NULL,'MLCS2k2','[AGR2006] J221410.24-173024.1',0.905,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154452,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di',NULL,154452,43.82,0.18,3050,73169,65,NULL,'MLCS17','[AGR2006] J221410.24-173024.1',0.905,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154453,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di',NULL,154453,43.83,0.39,3060,73169,65,NULL,'SALT','[AGR2006] J221410.24-173024.1',0.905,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154454,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di',NULL,154454,43.83,0.24,3070,73169,70,NULL,'SALT 2','[AGR2006] J221410.24-173024.1',0.905,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154455,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di',NULL,154455,43.84,0.13,3070,73169,65,NULL,'MLCS2k2','[AGR2006] J221410.24-173024.1',0.905,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154456,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di',NULL,154456,43.84,0.15,3070,73169,65,NULL,'MLCS31','[AGR2006] J221410.24-173024.1',0.905,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154457,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di',NULL,154457,43.84,0.15,3070,73169,NULL,NULL,'SIFTO','[AGR2006] J221410.24-173024.1',0.905,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154458,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di',NULL,154458,43.87,0.37,3130,73169,65,NULL,'SALT2','[AGR2006] J221410.24-173024.1',0.905,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154459,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di',NULL,154459,44,0.17,3310,73169,65,NULL,'SALT','[AGR2006] J221410.24-173024.1',0.905,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154460,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di',NULL,154460,45.54,0.17,6740,73169,NULL,NULL,'SALT2','[AGR2006] J221410.24-173024.1',0.905,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154461,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154461,34.98,0.2,99.1,73170,74.4,NULL,NULL,'CGCG 428-053',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00006,NULL,'15.4g',0.48,'Sbc',NULL,NULL,NULL,NULL,1,333.54275,13.27883,0.197,NULL,52258177368,816534021,12758344,15.4),(154462,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4av',NULL,154462,42.26,0.13,1870,73171,70,NULL,'SALT 2','SNLS 05D4av HOST',0.509,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.543833333,-17.91186,0.045,NULL,49787005912,777921967,12155030,NULL),(154463,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4av',NULL,154463,42.32,0.15,1930,73171,NULL,NULL,'SIFTO','SNLS 05D4av HOST',0.509,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154464,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4av',NULL,154464,43.22,0.04,2920,73171,70,NULL,'SIFTO','SNLS 05D4av HOST',0.509,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154465,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4av',NULL,154465,43.47,0.17,3270,73171,NULL,NULL,'SALT2','SNLS 05D4av HOST',0.509,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154466,'SNII optical','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 04D4fu',NULL,154466,38.85,0.11,459,73172,NULL,NULL,'SEAM','APMUKS(BJ) B221128.89-174722.6',0.133,'2009ApJ...694.1067P',2009,1,0.13,NULL,'G',NULL,NULL,'18.8r',0.12,NULL,NULL,NULL,NULL,NULL,1,333.551083,-17.54106,0.041,NULL,49787393579,777928024,12155125,18.8),(154467,'SNII optical','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 04D4fu',NULL,154467,38.94,0.14,614,73172,NULL,NULL,NULL,'APMUKS(BJ) B221128.89-174722.6',NULL,'2006ApJ...645..841N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154468,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 04D4jr',NULL,154468,41.55,0.03,1380,73173,70,NULL,'SIFTO','[NSB2006] J221414.33-172100.9',0.482,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.007,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.55975,-17.35025,0.045,NULL,49786814883,777918982,12154984,NULL),(154469,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 04D4jr',NULL,154469,42.11,0.12,1780,73173,70,NULL,'SALT 2','[NSB2006] J221414.33-172100.9',0.482,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154470,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 04D4jr',NULL,154470,42.16,0.15,1830,73173,NULL,NULL,'SIFTO','[NSB2006] J221414.33-172100.9',0.482,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154471,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 04D4jr',NULL,154471,44.01,0.17,4280,73173,NULL,NULL,'SALT2','[NSB2006] J221414.33-172100.9',0.482,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154472,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154472,35.56,0.58,129,73174,70,NULL,NULL,'ESO 189- G 031',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000033,NULL,'14.04',0.7,'SB(rs)bc',NULL,NULL,NULL,NULL,1,333.5659583,-54.12042,0,NULL,48702583365,760977865,11890279,14.04),(154473,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154473,35.6,1.15,132,73174,NULL,NULL,'Malmquist cor.','ESO 189- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154474,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154474,36.44,0.78,194,73174,NULL,NULL,NULL,'ESO 189- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154475,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154475,36.48,0.2,198,73174,74.4,NULL,NULL,'ESO 189- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154476,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SDSS-II SN 15657',NULL,154476,40.3,0.26,1150,73175,70,NULL,'SN photometric redshift distance, z photo =0.316 +/- 0.049','SDSS-II SN 15657',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','20.3g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,333.5780417,0.67264,0.109,NULL,52155743715,814933495,12733335,20.3),(154477,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SDSS-II SN 07988','RN',154477,43.45,0.43,3490,73176,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 07988',0.401473,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154478,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 06D4dh',NULL,154478,40.19,0.03,837,73177,70,NULL,'SIFTO','SNLS 06D4dh',0.303,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,333.5820417,-17.585,0.041,NULL,49787423293,777928488,12155132,NULL),(154479,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 06D4dh',NULL,154479,41.08,0.1,1260,73177,70,NULL,'SALT 2','SNLS 06D4dh',0.303,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154480,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 06D4dh',NULL,154480,41.13,0.15,1290,73177,NULL,NULL,'SIFTO','SNLS 06D4dh',0.303,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154481,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 06D4dh',NULL,154481,41.92,0.17,1860,73177,NULL,NULL,'SALT2','SNLS 06D4dh',0.303,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154482,'FP','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154482,37.7,0.23,347,73178,70,NULL,NULL,'2MASX J22141981-0828330',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,333.582667,-8.47572,0.145,NULL,49842866532,778794789,12168668,18.2),(154483,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154483,35.87,0.2,149,73179,74.4,NULL,NULL,'CGCG 377-040',NULL,'2013AJ....146...86T',2013,1,0.87,NULL,'G',0.000087,NULL,'15.2g',0.47,'Sab',NULL,NULL,NULL,NULL,1,333.58675,1.01869,0.113,NULL,52156169841,814940153,12733439,15.2),(154484,'FP','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154484,37.7,0.23,347,73180,70,NULL,NULL,'2MASX J22142102-0822330',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,333.5875,-8.37583,0.161,NULL,49842860824,778794700,12168667,17.7),(154485,'FP','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154485,35.61,0.14,132,73181,70,NULL,NULL,'CGCG 428-054',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000097,NULL,'15.0g',0.63,'E0','Group member',NULL,NULL,NULL,1,333.5907083,13.95311,0.157,NULL,52260213235,816565831,12758841,15),(154486,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4ic',NULL,154486,42.19,0.17,1630,73182,NULL,NULL,'SALT2','[HSP2005] J221421.84-175636.43',0.68,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.02,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.591,-17.94344,0.045,NULL,49787035969,777922437,12155038,NULL),(154487,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4ic',NULL,154487,43.11,0.25,2490,73182,70,NULL,'SALT 2','[HSP2005] J221421.84-175636.43',0.68,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154488,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4ic',NULL,154488,43.28,0.15,2690,73182,NULL,NULL,'SIFTO','[HSP2005] J221421.84-175636.43',0.68,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154489,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4ic',NULL,154489,43.44,0.06,2900,73182,70,NULL,'SALT2','[HSP2005] J221421.84-175636.43',0.68,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154490,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf','R',154490,41.78,NULL,1430,73183,65,NULL,'MLCS31','[AGR2006] J221422.90-174402.4',0.581,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.5954583,-17.73403,0.049,NULL,49787410723,777928292,12155129,NULL),(154491,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf',NULL,154491,42.05,0.16,1630,73183,74.2,NULL,'SALT 2','[AGR2006] J221422.90-174402.4',0.581,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154492,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf',NULL,154492,42.44,0.04,1950,73183,70,NULL,'MLCS31','[AGR2006] J221422.90-174402.4',0.581,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154493,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf',NULL,154493,42.6,0.15,2090,73183,70,NULL,'SALT 2','[AGR2006] J221422.90-174402.4',0.581,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154494,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf',NULL,154494,42.65,0.15,2140,73183,NULL,NULL,'SIFTO','[AGR2006] J221422.90-174402.4',0.581,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154495,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf',NULL,154495,42.76,0.05,2260,73183,70,NULL,NULL,'[AGR2006] J221422.90-174402.4',0.581,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154496,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf',NULL,154496,42.79,0.15,2290,73183,70,NULL,'SALT','[AGR2006] J221422.90-174402.4',0.581,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154497,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf',NULL,154497,42.82,0.11,2310,73183,65,NULL,'SALT2','[AGR2006] J221422.90-174402.4',0.581,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154498,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf',NULL,154498,42.81,0.16,2310,73183,65,NULL,'MLCS2k2','[AGR2006] J221422.90-174402.4',0.581,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154499,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf',NULL,154499,42.85,0.15,2350,73183,65,NULL,'MLCS2k2','[AGR2006] J221422.90-174402.4',0.581,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154500,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf',NULL,154500,42.85,0.18,2350,73183,65,NULL,'MLCS31','[AGR2006] J221422.90-174402.4',0.581,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154501,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf',NULL,154501,42.86,0.18,2370,73183,65,NULL,'MLCS17','[AGR2006] J221422.90-174402.4',0.581,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154502,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf',NULL,154502,42.95,0.18,2460,73183,65,NULL,'SALT2','[AGR2006] J221422.90-174402.4',0.581,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154503,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf',NULL,154503,42.97,0.12,2480,73183,65,NULL,'SALT','[AGR2006] J221422.90-174402.4',0.581,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154504,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf',NULL,154504,43.04,0.05,2560,73183,65,NULL,'SALT','[AGR2006] J221422.90-174402.4',0.581,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154505,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf',NULL,154505,43.58,0.17,3290,73183,NULL,NULL,'SALT2','[AGR2006] J221422.90-174402.4',0.581,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154506,'FP','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154506,37.25,0.46,282,73184,70,NULL,NULL,'2MASX J22142304-0818430',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000149,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,333.595917,-8.31189,0.161,NULL,49842849009,778794515,12168664,17.4),(154507,'FP','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154507,37.54,0.33,322,73185,70,NULL,NULL,'2MASX J22142399-0036599',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,333.5997917,-0.61647,0.249,NULL,49802561286,778165020,12158828,17.7),(154508,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at','R',154508,42.21,NULL,1700,73186,65,NULL,'MLCS17','[AGR2006] J221424.02-174636.0',0.633,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.600083,-17.77667,0.049,NULL,49787284533,777926320,12155098,NULL),(154509,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154509,42.35,0.17,1810,73186,74.2,NULL,'SALT 2','[AGR2006] J221424.02-174636.0',0.633,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154510,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154510,42.89,0.05,2320,73186,70,NULL,'MLCS17','[AGR2006] J221424.02-174636.0',0.633,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154511,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154511,42.91,0.15,2330,73186,NULL,NULL,'SIFTO','[AGR2006] J221424.02-174636.0',0.633,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154512,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154512,43,NULL,2440,73186,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','[AGR2006] J221424.02-174636.0',0.633,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154513,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154513,43.01,0.22,2440,73186,70,NULL,'SALT 2','[AGR2006] J221424.02-174636.0',0.633,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154514,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154514,43.13,0.06,2590,73186,70,NULL,NULL,'[AGR2006] J221424.02-174636.0',0.633,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154515,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154515,43.17,0.16,2640,73186,65,NULL,'MLCS2k2','[AGR2006] J221424.02-174636.0',0.633,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154516,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154516,43.18,0.14,2650,73186,65,NULL,'SALT2','[AGR2006] J221424.02-174636.0',0.633,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154517,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154517,43.2,0.2,2670,73186,70,NULL,'SALT','[AGR2006] J221424.02-174636.0',0.633,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154518,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154518,43.21,0.22,2680,73186,65,NULL,'MLCS17','[AGR2006] J221424.02-174636.0',0.633,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154519,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154519,43.26,0.23,2740,73186,65,NULL,'MLCS2k2','[AGR2006] J221424.02-174636.0',0.633,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154520,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154520,43.26,0.25,2740,73186,65,NULL,'MLCS31','[AGR2006] J221424.02-174636.0',0.633,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154521,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154521,43.29,0.19,2790,73186,65,NULL,'SALT2','[AGR2006] J221424.02-174636.0',0.633,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154522,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154522,43.39,0.17,2910,73186,65,NULL,'SALT','[AGR2006] J221424.02-174636.0',0.633,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154523,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154523,43.4,0.17,2930,73186,NULL,NULL,'SALT2','[AGR2006] J221424.02-174636.0',0.633,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154524,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154524,43.41,0.05,2940,73186,65,NULL,'SALT','[AGR2006] J221424.02-174636.0',0.633,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154525,'FP','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154525,35.01,0.75,100,73187,70,NULL,NULL,'ESO 048- G 020',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00015,NULL,'15.73',0.5,'Sa: pec sp',NULL,NULL,NULL,NULL,1,333.60025,-76.05894,0.381,NULL,48410283702,756410682,11818916,15.73),(154526,'FP','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154526,36.36,0.8,187,73188,70,NULL,NULL,'FAIRALL 1003',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'15.91',0.53,'(R)SB(s)a',NULL,NULL,NULL,NULL,1,333.6002917,-67.07961,0.025,NULL,49280362496,770005664,12031338,15.91),(154527,'FP','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154527,37.78,0.46,360,73189,70,NULL,NULL,'2MASX J22142485-0846479',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,333.603625,-8.78003,0.141,NULL,49842059476,778782179,12168471,17.4),(154528,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4dt',NULL,154528,41.02,0.17,1140,73190,NULL,NULL,'SALT2','SNLS 05D4dt HOST',0.407,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.6077083,-17.67111,0.049,NULL,49787427321,777928551,12155133,NULL),(154529,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4dt',NULL,154529,41.89,0.11,1700,73190,70,NULL,'SALT 2','SNLS 05D4dt HOST',0.407,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154530,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4dt',NULL,154530,41.94,0.15,1740,73190,NULL,NULL,'SIFTO','SNLS 05D4dt HOST',0.407,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154531,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4dt',NULL,154531,42.1,0.03,1870,73190,70,NULL,'SALT2','SNLS 05D4dt HOST',0.407,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154532,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SDSS-II SN 07496','RN',154532,40.93,0.32,990,73191,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 07496',0.551336,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154533,'FP','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154533,37.19,0.46,274,73192,70,NULL,NULL,'2MASX J22142675-0932049',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,333.611583333,-9.53464,0.129,NULL,49830532595,778602071,12165657,17.6),(154534,'FP','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154534,37.54,0.33,322,73193,70,NULL,NULL,'2MASX J22142878-0034449',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,333.619833333,-0.57911,0.249,NULL,49802561711,778165026,12158828,17.6),(154535,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2001fd',NULL,154535,34.77,0.09,90,73194,74.4,NULL,NULL,'UGC 11957',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.00011,NULL,'15.16',0.5,'Sbc',NULL,NULL,NULL,NULL,1,333.621125,5.03117,0.281,NULL,52208442254,815756910,12746201,15.16),(154536,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154536,35.17,0.8,108,73194,75,NULL,'CF, r','UGC 11957',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154537,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154537,34.99,0.38,99.5,73194,75,NULL,'CF, r, raw','UGC 11957',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154538,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154538,35.1,0.38,105,73194,75,NULL,'CF, r, inv','UGC 11957',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154539,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154539,35.27,0.38,113,73194,75,NULL,'CF, r, cor','UGC 11957',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154540,'FP','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154540,37.07,0.46,259,73195,70,NULL,NULL,'2MASX J22142936+1329266',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000174,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,333.6224583,13.49089,0.189,NULL,52258206396,816534474,12758351,16.7),(154541,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4ay',NULL,154541,39.55,0.17,577,73196,NULL,NULL,'SALT2','SNLS 05D4ay HOST',0.408,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.638291667,-17.76767,0.049,NULL,49787282134,777926283,12155098,NULL),(154542,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4ay',NULL,154542,42.01,0.15,1790,73196,NULL,NULL,'SIFTO','SNLS 05D4ay HOST',0.408,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154543,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4ht',NULL,154543,40.45,0.15,1010,73197,NULL,NULL,'SIFTO','[NSB2006] J221433.28-172131.3',0.217,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.638708333,-17.35869,0.045,NULL,49787331618,777927056,12155110,NULL),(154544,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4ht',NULL,154544,41.47,0.17,1620,73197,NULL,NULL,'SALT2','[NSB2006] J221433.28-172131.3',0.217,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154545,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154545,42.7,0.29,1780,73198,74.2,NULL,'SALT 2','[AGR2006] J221433.75-173515.3',0.949,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.014,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.640625,-17.58758,0.041,NULL,49787432169,777928627,12155134,NULL),(154546,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx','R',154546,42.75,NULL,1820,73198,65,NULL,'SALT2','[AGR2006] J221433.75-173515.3',0.949,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154547,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154547,43.43,0.26,2490,73198,70,NULL,'SALT 2','[AGR2006] J221433.75-173515.3',0.949,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154548,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154548,43.46,0.17,2530,73198,NULL,NULL,'SALT2','[AGR2006] J221433.75-173515.3',0.949,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154549,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154549,43.47,0.47,2540,73198,70,NULL,'SALT','[AGR2006] J221433.75-173515.3',0.949,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154550,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154550,43.51,0.27,2580,73198,70,NULL,NULL,'[AGR2006] J221433.75-173515.3',0.949,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154551,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154551,43.51,0.29,2580,73198,65,NULL,'SALT2','[AGR2006] J221433.75-173515.3',0.949,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154552,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154552,43.54,NULL,2620,73198,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','[AGR2006] J221433.75-173515.3',0.949,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154553,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154553,43.54,0.15,2620,73198,NULL,NULL,'SIFTO','[AGR2006] J221433.75-173515.3',0.949,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154554,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154554,43.57,0.38,2650,73198,65,NULL,'SALT2','[AGR2006] J221433.75-173515.3',0.949,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154555,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154555,43.61,0.44,2700,73198,65,NULL,'SALT','[AGR2006] J221433.75-173515.3',0.949,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154556,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154556,43.78,0.18,2920,73198,65,NULL,'SALT','[AGR2006] J221433.75-173515.3',0.949,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154557,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154557,43.81,0.08,2960,73198,70,NULL,'SALT 2','[AGR2006] J221433.75-173515.3',0.949,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154558,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154558,43.83,0.3,2990,73198,65,NULL,'MLCS2k2','[AGR2006] J221433.75-173515.3',0.949,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154559,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154559,44.16,0.18,3480,73198,65,NULL,'MLCS17','[AGR2006] J221433.75-173515.3',0.949,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154560,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154560,44.23,0.15,3600,73198,65,NULL,'MLCS31','[AGR2006] J221433.75-173515.3',0.949,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154561,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154561,44.26,0.13,3640,73198,65,NULL,'MLCS2k2','[AGR2006] J221433.75-173515.3',0.949,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154562,'G Lens','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154562,44.64,0.17,4350,73198,NULL,NULL,'SNLS 03D4cx HOST','[AGR2006] J221433.75-173515.3',0.949,'2010A&A...514A..44K',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154563,'Faber-Jackson','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154563,44.67,0.17,4400,73198,NULL,NULL,'SNLS 03D4cx HOST','[AGR2006] J221433.75-173515.3',0.949,'2010A&A...514A..44K',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154564,'FP','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154564,37.73,0.46,351,73199,70,NULL,NULL,'2MASX J22143544-0102103',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,333.64775,-1.03628,0.233,NULL,49803105307,778173520,12158961,17.7),(154565,'FP','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154565,36.03,0.46,160,73200,70,NULL,NULL,'2MASX J22143829+1251096',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00015,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,333.659458333,12.85272,0.177,NULL,52247153598,816361774,12755652,17),(154566,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154566,34.09,0.8,65.8,73201,75,NULL,'MAT, I','ESO 467- G 027',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000027,NULL,'13.35',0.7,'(R\')SA(rs)bc   HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,333.666333333,-27.46397,0,NULL,50534349396,789599209,12337487,13.35),(154567,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154567,29.38,0.58,7.5,73201,NULL,NULL,NULL,'ESO 467- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154568,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154568,30.03,0.43,10.2,73201,NULL,NULL,'Malmquist cor.','ESO 467- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154569,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154569,33.44,0.32,48.8,73201,85,NULL,'I, raw','ESO 467- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154570,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154570,33.48,0.43,49.7,73201,75,NULL,'MAT, I, raw','ESO 467- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154571,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154571,33.49,0.32,50,73201,85,NULL,'I, inv','ESO 467- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154572,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154572,33.65,NULL,53.7,73201,NULL,NULL,'I','ESO 467- G 027',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154573,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154573,33.72,0.43,55.5,73201,75,NULL,'MAT, I, inv','ESO 467- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154574,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154574,33.81,0.43,57.7,73201,75,NULL,'MAT, I, cor','ESO 467- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154575,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154575,33.93,NULL,61.1,73201,NULL,NULL,'B','ESO 467- G 027',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154576,'FP','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154576,35.61,0.14,132,73202,70,NULL,NULL,'2MASX J22144047+1352416',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00011,NULL,'17.39',0.15,NULL,NULL,NULL,NULL,NULL,1,333.6685,13.87839,0.157,NULL,52260218018,816565906,12758842,17.39),(154577,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq',NULL,154577,34.18,0.17,66.9,73203,74.2,NULL,'SALT 2','2MASX J22144070+0504435',0.0247,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.669541667,5.07872,0.285,NULL,52208164958,815752577,12746134,NULL),(154578,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq',NULL,154578,34.96,0.03,95.8,73203,72,NULL,'z lit','2MASX J22144070+0504435',0.0247,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154579,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq',NULL,154579,34.98,0.15,96.7,73203,72,NULL,NULL,'2MASX J22144070+0504435',0.0247,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154580,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq',NULL,154580,34.99,0.15,97,73203,73.8,NULL,'SALT 2 (SNANA)','2MASX J22144070+0504435',0.0255,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154581,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq',NULL,154581,35.01,0.19,98,73203,72,NULL,'z lit','2MASX J22144070+0504435',0.0247,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154582,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq',NULL,154582,35.08,0.1,101,73203,72,NULL,'MLCS2k2, R(V) = 1.7','2MASX J22144070+0504435',0.0247,'2010ApJ...721.1608B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154583,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq',NULL,154583,35.08,0.17,101,73203,65,NULL,'MLCS17, z SN CMB','2MASX J22144070+0504435',0.0247,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154584,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq',NULL,154584,35.09,0.16,102,73203,70,NULL,'SALT 2','2MASX J22144070+0504435',0.0247,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154585,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq',NULL,154585,35.09,0.2,102,73203,65,NULL,'SALT2, z SN CMB','2MASX J22144070+0504435',0.0247,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154586,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq',NULL,154586,35.09,0.18,102,73203,65,NULL,'SALT, z SN CMB','2MASX J22144070+0504435',0.0247,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154587,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq',NULL,154587,35.16,0.04,105,73203,70,NULL,'SALT 2','2MASX J22144070+0504435',0.0247,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154588,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq',NULL,154588,35.16,0.12,105,73203,72,NULL,'MLCS2k2, R(V) = 3.1','2MASX J22144070+0504435',0.0247,'2010ApJ...721.1608B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154589,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq',NULL,154589,35.16,0.18,105,73203,65,NULL,'MLCS31, z SN CMB','2MASX J22144070+0504435',0.0247,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154590,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq','R',154590,35.14,0.06,107,73203,NULL,NULL,'MLCS2k2, R(V) = 1.8','2MASX J22144070+0504435',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154591,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq','R',154591,35.18,0.06,109,73203,NULL,NULL,'MLCS2k2, R(V) = 3.1','2MASX J22144070+0504435',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154592,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq',NULL,154592,35.32,0.1,116,73203,72,NULL,'M(H) = -18.317 mag','2MASX J22144070+0504435',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154593,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SDSS-II SN 20043',NULL,154593,40.46,0.13,1240,73204,70,NULL,'SN photometric redshift distance, z photo =0.346 +/- 0.026','SDSS-II SN 20043',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,333.682541667,1.20172,0.105,NULL,52156083074,814938798,12733418,NULL),(154594,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gl','R',154594,41.68,NULL,1380,73205,65,NULL,'MLCS17','[HSP2005] J221444.17-173144.47',0.571,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.684083,-17.52903,0.041,NULL,49787326705,777926979,12155109,NULL),(154595,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gl',NULL,154595,41.7,0.18,1390,73205,74.2,NULL,'SALT 2','[HSP2005] J221444.17-173144.47',0.571,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154596,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gl',NULL,154596,42.31,0.08,1850,73205,70,NULL,'MLCS17','[HSP2005] J221444.17-173144.47',0.571,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154597,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gl',NULL,154597,42.45,0.35,1960,73205,65,NULL,'MLCS2k2','[HSP2005] J221444.17-173144.47',0.571,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154598,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gl',NULL,154598,42.45,0.39,1970,73205,65,NULL,'MLCS17','[HSP2005] J221444.17-173144.47',0.571,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154599,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gl',NULL,154599,42.47,0.07,1980,73205,70,NULL,NULL,'[HSP2005] J221444.17-173144.47',0.571,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154600,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gl',NULL,154600,42.46,0.18,1980,73205,70,NULL,'SALT','[HSP2005] J221444.17-173144.47',0.571,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154601,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gl',NULL,154601,42.46,0.37,1980,73205,65,NULL,'MLCS31','[HSP2005] J221444.17-173144.47',0.571,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154602,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gl',NULL,154602,42.62,0.15,2130,73205,65,NULL,'SALT','[HSP2005] J221444.17-173144.47',0.571,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154603,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gl',NULL,154603,42.75,0.06,2250,73205,65,NULL,'SALT','[HSP2005] J221444.17-173144.47',0.571,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154604,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gl',NULL,154604,42.77,0.17,2270,73205,72,NULL,NULL,'[HSP2005] J221444.17-173144.47',0.571,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154605,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gl',NULL,154605,43.11,0.26,2670,73205,65,NULL,'SALT2','[HSP2005] J221444.17-173144.47',0.571,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154606,'D-Sigma','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154606,34.43,0.4,76.9,73206,75,NULL,'Edat, raw','NGC 7236',NULL,'1997ApJS..109..333W',1997,1,1.25,'Component \'a)\' in UGC notes.','G',0.000033,NULL,'14.7g',0.56,'SA0-           AGN:','Pair member, contact system',NULL,NULL,NULL,1,333.6874583,13.84653,0.157,NULL,52260002345,816562536,12758789,14.7),(154607,'D-Sigma','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154607,34.67,0.4,86.1,73206,75,NULL,'Edat, cor','NGC 7236',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154608,'Faber-Jackson','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154608,33.99,0.44,62.8,73206,95,NULL,'Weighted Mean','NGC 7236',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154609,'Faber-Jackson','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154609,34.15,0.63,67.6,73206,95,NULL,'Michard 1979b, c','NGC 7236',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154610,'Faber-Jackson','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154610,34.79,0.46,90.8,73206,95,NULL,'Michard 1979a','NGC 7236',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154611,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154611,34.99,0.45,99.6,73206,NULL,NULL,'K','NGC 7236',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154612,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154612,35.2,0.4,110,73206,NULL,NULL,'mean','NGC 7236',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154613,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha','R',154613,39.71,NULL,681,73207,65,NULL,'SNLS 03D4ag, SALT','APMUKS(BJ) B221202.39-175918.2',0.285,'2010arXiv1006.2112L',2010,1,0.13,NULL,'G',0.0003,NULL,'19.92',0.11,NULL,NULL,NULL,NULL,NULL,1,333.690958333,-17.73953,0.049,NULL,49787261692,777925963,12155093,19.92),(154614,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha',NULL,154614,40.12,0.14,822,73207,74.2,NULL,'SALT 2','APMUKS(BJ) B221202.39-175918.2',0.285,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154615,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha',NULL,154615,40.2,0.03,852,73207,70,NULL,'SNLS 03D4ag, SALT','APMUKS(BJ) B221202.39-175918.2',0.285,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154616,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha',NULL,154616,40.69,0.12,1070,73207,70,NULL,'SNLS 03D4ag, SALT 2','APMUKS(BJ) B221202.39-175918.2',0.285,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154617,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha',NULL,154617,40.71,0.13,1080,73207,70,NULL,'SNLS 03D4ag, SALT','APMUKS(BJ) B221202.39-175918.2',0.285,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154618,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha',NULL,154618,40.73,0.02,1090,73207,70,NULL,'SNLS 03D4ag','APMUKS(BJ) B221202.39-175918.2',0.285,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154619,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha',NULL,154619,40.8,0.15,1130,73207,NULL,NULL,'SNLS 03D4ag, SIFTO','APMUKS(BJ) B221202.39-175918.2',0.285,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154620,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha',NULL,154620,40.91,0.1,1180,73207,65,NULL,'SNLS 03D4ag, SALT','APMUKS(BJ) B221202.39-175918.2',0.285,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154621,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha',NULL,154621,40.93,0.14,1190,73207,65,NULL,'SNLS 03D4ag, MLCS17','APMUKS(BJ) B221202.39-175918.2',0.285,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154622,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha',NULL,154622,40.94,0.01,1200,73207,65,NULL,'SNLS 03D4ag, SALT','APMUKS(BJ) B221202.39-175918.2',0.285,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154623,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha',NULL,154623,40.94,0.09,1200,73207,65,NULL,'SNLS 03D4ag, SALT2','APMUKS(BJ) B221202.39-175918.2',0.285,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154624,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha',NULL,154624,40.98,0.09,1220,73207,65,NULL,'SNLS 03D4ag, MLCS2k2','APMUKS(BJ) B221202.39-175918.2',0.285,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154625,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha',NULL,154625,40.97,0.11,1220,73207,65,NULL,'SNLS 03D4ag, MLCS2k2','APMUKS(BJ) B221202.39-175918.2',0.285,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154626,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha',NULL,154626,40.98,0.12,1220,73207,65,NULL,'SNLS 03D4ag, MLCS31','APMUKS(BJ) B221202.39-175918.2',0.285,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154627,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha',NULL,154627,40.99,0.16,1220,73207,65,NULL,'SNLS 03D4ag, SALT2','APMUKS(BJ) B221202.39-175918.2',0.285,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154628,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha',NULL,154628,41.93,0.17,1890,73207,NULL,NULL,'SNLS 03D4ag, SALT2','APMUKS(BJ) B221202.39-175918.2',0.285,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154629,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154629,33.97,NULL,62.2,73208,70,NULL,'H, UH88/IRSF/2MASS, Malmquist corr.','UGC 11961',NULL,'2011A&A...531A..87I',2011,1,1.98,NULL,'G',0.00002,NULL,'15.0',0.28,'Sb',NULL,NULL,NULL,NULL,1,333.693125,42.18117,1.125,NULL,55509552404,867336756,13552136,15),(154630,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154630,33.97,NULL,62.2,73208,70,NULL,'H, 2MASS, Malmquist corr.','UGC 11961',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154631,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154631,34.03,0.35,64,73208,70,NULL,'H, UH88/IRSF/2MASS','UGC 11961',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154632,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154632,34.03,0.35,64,73208,70,NULL,'H, 2MASS','UGC 11961',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154633,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154633,34.24,0.43,70.5,73208,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11961',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154634,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154634,34.28,0.49,71.8,73208,75,NULL,'IR','UGC 11961',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154635,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154635,34.32,0.43,73.2,73208,75,NULL,'3.6 micron, color corrected','UGC 11961',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154636,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154636,34.42,0.2,76.6,73208,74.4,NULL,NULL,'UGC 11961',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154637,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154637,34.54,NULL,81,73208,NULL,NULL,'Dipole','UGC 11961',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154638,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154638,34.56,NULL,81.5,73208,NULL,NULL,'Dipole + Quadrupole','UGC 11961',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154639,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154639,34.56,NULL,81.7,73208,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11961',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154640,'D-Sigma','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154640,34.43,0.4,76.9,73209,75,NULL,'Edat, raw','NGC 7237',NULL,'1997ApJS..109..333W',1997,1,1.81,'Component \'b)\' in UGC notes.','G',0.000037,NULL,'14.2g',0.72,'SA0-','Pair member, contact system',NULL,'radio jet',NULL,1,333.695333,13.84086,0.157,NULL,52260001026,816562516,12758789,14.2),(154641,'D-Sigma','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154641,34.67,0.4,86.1,73209,75,NULL,'Edat, cor','NGC 7237',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154642,'Faber-Jackson','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154642,34.79,0.44,90.8,73209,95,NULL,'Weighted Mean','NGC 7237',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154643,'Faber-Jackson','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154643,35.29,0.46,114,73209,95,NULL,'Michard 1979a','NGC 7237',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154644,'Faber-Jackson','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154644,35.65,0.63,135,73209,95,NULL,'Michard 1979b, c','NGC 7237',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154645,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4gw',NULL,154645,43.47,0.25,2740,73210,70,NULL,'SALT 2','SNLS 05D4gw HOST',0.808,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.697375,-17.53194,0.041,NULL,49787355335,777927427,12155116,NULL),(154646,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4gw',NULL,154646,43.63,0.15,2940,73210,NULL,NULL,'SIFTO','SNLS 05D4gw HOST',0.808,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154647,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4gw',NULL,154647,43.8,0.07,3190,73210,70,NULL,'SIFTO','SNLS 05D4gw HOST',0.808,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154648,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4gw',NULL,154648,43.84,0.17,3250,73210,NULL,NULL,'SALT2','SNLS 05D4gw HOST',0.808,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154649,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154649,35.59,NULL,131,73211,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2376',NULL,'2010Ap&SS.325..163P',2010,1,0.8,NULL,'G',0.000017,NULL,'16.9',0.09,'Sc',NULL,NULL,NULL,NULL,1,333.7035,14.46819,0.193,NULL,52259272540,816551133,12758611,16.9),(154650,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154650,35.62,NULL,133,73211,NULL,NULL,'Dipole + Quadrupole','FGC 2376',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154651,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154651,35.63,NULL,134,73211,NULL,NULL,'Dipole','FGC 2376',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154652,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154652,35.69,NULL,137,73211,NULL,NULL,NULL,'FGC 2376',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154653,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154653,36.12,0.49,167,73211,75,NULL,'IR','FGC 2376',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154654,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq',NULL,154654,41.57,0.16,1330,73212,74.2,NULL,'SALT 2','[AGR2006] J221449.39-174939.3',0.55,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.7057917,-17.82761,0.049,NULL,49787303305,777926614,12155103,NULL),(154655,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq','R',154655,41.85,NULL,1510,73212,65,NULL,'SALT2','[AGR2006] J221449.39-174939.3',0.55,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154656,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq',NULL,154656,42.21,0.15,1780,73212,70,NULL,'SALT 2','[AGR2006] J221449.39-174939.3',0.55,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154657,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq',NULL,154657,42.26,0.15,1830,73212,NULL,NULL,'SIFTO','[AGR2006] J221449.39-174939.3',0.55,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154658,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq',NULL,154658,42.36,0.12,1910,73212,65,NULL,'SALT2','[AGR2006] J221449.39-174939.3',0.55,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154659,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq',NULL,154659,42.38,0.14,1930,73212,65,NULL,'MLCS2k2','[AGR2006] J221449.39-174939.3',0.55,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154660,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq',NULL,154660,42.4,0.16,1950,73212,70,NULL,'SALT','[AGR2006] J221449.39-174939.3',0.55,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154661,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq',NULL,154661,42.48,0.18,2020,73212,65,NULL,'SALT2','[AGR2006] J221449.39-174939.3',0.55,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154662,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq',NULL,154662,42.49,0.06,2030,73212,70,NULL,NULL,'[AGR2006] J221449.39-174939.3',0.55,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154663,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq',NULL,154663,42.54,0.13,2080,73212,65,NULL,'SALT','[AGR2006] J221449.39-174939.3',0.55,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154664,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq',NULL,154664,42.69,0.26,2230,73212,65,NULL,'MLCS17','[AGR2006] J221449.39-174939.3',0.55,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154665,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq',NULL,154665,42.73,0.29,2270,73212,65,NULL,'MLCS31','[AGR2006] J221449.39-174939.3',0.55,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154666,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq',NULL,154666,42.75,0.05,2290,73212,65,NULL,'SALT','[AGR2006] J221449.39-174939.3',0.55,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154667,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq',NULL,154667,42.75,0.27,2290,73212,65,NULL,'MLCS2k2','[AGR2006] J221449.39-174939.3',0.55,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154668,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq',NULL,154668,42.85,0.04,2390,73212,70,NULL,'SALT 2','[AGR2006] J221449.39-174939.3',0.55,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154669,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq',NULL,154669,43.3,0.17,2960,73212,NULL,NULL,'SALT2','[AGR2006] J221449.39-174939.3',0.55,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154670,'G Lens','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154670,44.5,0.17,5140,73212,NULL,NULL,'SNLS 04D4bq HOST','[AGR2006] J221449.39-174939.3',0.55,'2010A&A...514A..44K',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154671,'Faber-Jackson','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154671,44.42,0.17,4940,73212,NULL,NULL,'SNLS 04D4bq HOST','[AGR2006] J221449.39-174939.3',0.55,'2010A&A...514A..44K',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154672,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4cw',NULL,154672,40.83,0.17,1070,73213,NULL,NULL,'SALT2','SNLS 05D4cw HOST',0.375,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.708666667,-17.73878,0.049,NULL,49787263261,777925988,12155093,NULL),(154673,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4cw',NULL,154673,41.1,0.03,1210,73213,70,NULL,'SALT2','SNLS 05D4cw HOST',0.375,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154674,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4cw',NULL,154674,41.39,0.17,1380,73213,72,NULL,'z lit','SNLS 05D4cw HOST',0.375,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154675,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4cw',NULL,154675,41.54,0.11,1480,73213,70,NULL,'SALT 2','SNLS 05D4cw HOST',0.375,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154676,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4cw',NULL,154676,41.61,NULL,1520,73213,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SNLS 05D4cw HOST',0.375,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154677,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4cw',NULL,154677,41.64,0.15,1550,73213,NULL,NULL,'SIFTO','SNLS 05D4cw HOST',0.375,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154678,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy','R',154678,41.69,NULL,1360,73214,65,NULL,'SALT','[AGR2006] J221450.51-175723.2',0.604,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.7104583,-17.95644,0.045,NULL,49787253214,777925831,12155091,NULL),(154679,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy',NULL,154679,41.83,0.16,1450,73214,74.2,NULL,'SALT 2','[AGR2006] J221450.51-175723.2',0.604,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154680,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy',NULL,154680,42.11,0.06,1650,73214,70,NULL,'SALT','[AGR2006] J221450.51-175723.2',0.604,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154681,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy',NULL,154681,42.44,0.14,1920,73214,70,NULL,'SALT','[AGR2006] J221450.51-175723.2',0.604,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154682,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy',NULL,154682,42.5,0.11,1970,73214,65,NULL,'SALT2','[AGR2006] J221450.51-175723.2',0.604,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154683,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy',NULL,154683,42.51,0.16,1980,73214,65,NULL,'MLCS2k2','[AGR2006] J221450.51-175723.2',0.604,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154684,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy',NULL,154684,42.52,0.03,1990,73214,70,NULL,NULL,'[AGR2006] J221450.51-175723.2',0.604,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154685,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy',NULL,154685,42.57,0.11,2040,73214,65,NULL,'SALT','[AGR2006] J221450.51-175723.2',0.604,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154686,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy',NULL,154686,42.63,0.17,2090,73214,65,NULL,'SALT2','[AGR2006] J221450.51-175723.2',0.604,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154687,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy',NULL,154687,42.62,0.29,2090,73214,65,NULL,'MLCS17','[AGR2006] J221450.51-175723.2',0.604,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154688,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy',NULL,154688,42.74,0.33,2200,73214,65,NULL,'MLCS31','[AGR2006] J221450.51-175723.2',0.604,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154689,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy',NULL,154689,42.79,0.31,2250,73214,65,NULL,'MLCS2k2','[AGR2006] J221450.51-175723.2',0.604,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154690,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy',NULL,154690,42.81,0.14,2270,73214,70,NULL,'SALT 2','[AGR2006] J221450.51-175723.2',0.604,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154691,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy',NULL,154691,42.81,0.03,2280,73214,65,NULL,'SALT','[AGR2006] J221450.51-175723.2',0.604,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154692,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy',NULL,154692,42.82,0.15,2280,73214,NULL,NULL,'SIFTO','[AGR2006] J221450.51-175723.2',0.604,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154693,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy',NULL,154693,44.53,0.17,5010,73214,NULL,NULL,'SALT2','[AGR2006] J221450.51-175723.2',0.604,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154694,'FP','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154694,36.39,0.54,190,73215,70,NULL,NULL,'2MASX J22145074-0150592',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.98',0.3,NULL,NULL,NULL,NULL,NULL,1,333.7112917,-1.84964,0.181,NULL,49800826774,778137918,12158404,16.98),(154695,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154695,35.67,0.49,136,73216,75,NULL,'IR','2MFGC 16780',NULL,'2011yCatp016004901K',2011,1,NULL,NULL,'G',NULL,NULL,'12.6K',NULL,NULL,NULL,NULL,NULL,NULL,1,333.723,14.45894,0.193,NULL,52259271967,816551124,12758611,12.6),(154696,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154696,33.73,0.4,55.8,73217,NULL,NULL,'mean','ESO 467- G 030',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000017,NULL,'15.26',0.5,'(R\')SA(rs)b',NULL,NULL,NULL,NULL,1,333.729917,-27.93364,0,NULL,50548213982,789815843,12340872,15.26),(154697,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154697,33.75,0.47,56.3,73217,NULL,NULL,'H','ESO 467- G 030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154698,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154698,33.87,0.46,59.4,73217,NULL,NULL,'J','ESO 467- G 030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154699,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154699,33.91,0.45,60.6,73217,NULL,NULL,'K','ESO 467- G 030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154700,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154700,31.64,0.8,21.3,73218,75,NULL,'A82, H','IC 5176',NULL,'1997ApJS..109..333W',1997,1,6.05,'The APM position is southwest of the nucleus.','G',0.00001,NULL,'13.52',0.78,'SAB(s)bc? sp',NULL,NULL,NULL,NULL,1,333.7330417,-66.84942,0.025,NULL,49287892789,770123324,12033176,13.52),(154701,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154701,31.64,0.8,21.3,73218,75,NULL,'MAT, I','IC 5176',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154702,'Tully est','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154702,31.61,0.8,21,73218,75,NULL,NULL,'IC 5176',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154703,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154703,31.57,0.39,20.6,73218,73,NULL,'IR','IC 5176',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154704,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154704,31.57,0.4,20.6,73218,75,NULL,NULL,'IC 5176',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154705,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154705,31.84,0.4,23.3,73218,73,NULL,'opt','IC 5176',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154706,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154706,31.97,0.47,24.8,73218,75,NULL,'A82, H, raw','IC 5176',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154707,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154707,32.02,0.4,25.3,73218,NULL,NULL,'mean','IC 5176',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154708,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154708,32.05,0.43,25.7,73218,75,NULL,'3.6 micron, color + selection bias corrected','IC 5176',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154709,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154709,32.06,0.47,25.8,73218,NULL,NULL,'H','IC 5176',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154710,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154710,32.08,0.47,26.1,73218,75,NULL,'A82, H, inv','IC 5176',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154711,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154711,32.1,0.45,26.3,73218,NULL,NULL,'K','IC 5176',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154712,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154712,32.11,0.46,26.4,73218,NULL,NULL,'J','IC 5176',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154713,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154713,32.11,0.35,26.4,73218,NULL,NULL,NULL,'IC 5176',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154714,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154714,32.19,0.43,27.5,73218,75,NULL,'3.6 micron, color corrected','IC 5176',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154715,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154715,32.26,0.43,28.4,73218,75,NULL,'MAT, I, raw','IC 5176',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154716,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154716,32.29,NULL,28.7,73218,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 5176',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154717,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154717,32.3,NULL,28.9,73218,NULL,NULL,'Dipole + Quadrupole','IC 5176',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154718,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154718,32.31,NULL,28.9,73218,NULL,NULL,'Dipole','IC 5176',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154719,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154719,32.35,0.49,29.5,73218,75,NULL,'IR','IC 5176',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154720,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154720,32.36,0.2,29.7,73218,74.4,NULL,NULL,'IC 5176',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154721,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154721,32.37,0.32,29.8,73218,85,NULL,'I, raw','IC 5176',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154722,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154722,32.37,NULL,29.8,73218,NULL,NULL,NULL,'IC 5176',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154723,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154723,32.41,0.47,30.3,73218,75,NULL,'A82, H, cor','IC 5176',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154724,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154724,32.41,0.32,30.4,73218,85,NULL,'I, inv','IC 5176',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154725,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154725,32.47,0.43,31.1,73218,75,NULL,'MAT, I, inv','IC 5176',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154726,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154726,32.63,0.43,33.6,73218,75,NULL,'MAT, I, cor','IC 5176',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154727,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154727,38.61,0.46,526,73219,70,NULL,NULL,'SDSS J221457.22-083116.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,333.738458333,-8.52122,0.145,NULL,49843010501,778797039,12168703,18.4),(154728,'SZ effect','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154728,40.79,0.38,1440,73220,NULL,NULL,'Hydrost. Eq.','MACS J2214.9-1359',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.73925,-14.003,0.089,NULL,49760322314,777505036,12148516,NULL),(154729,'SZ effect','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154729,41.35,0.45,1860,73220,NULL,NULL,'Isotherm., r < 100 kpc','MACS J2214.9-1359',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154730,'SZ effect','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154730,41.43,NULL,1930,73220,NULL,NULL,'3.1 (red) calibration','MACS J2214.9-1359',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154731,'SZ effect','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154731,41.47,0.44,1970,73220,NULL,NULL,'Isotherm.','MACS J2214.9-1359',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154732,'SZ effect','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154732,41.96,NULL,2470,73220,NULL,NULL,'4.2 (black) calibration','MACS J2214.9-1359',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154733,'SZ effect','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154733,42.2,NULL,2760,73220,NULL,NULL,'4.1 (blue) calibration','MACS J2214.9-1359',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154734,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154734,35.61,0.14,132,73221,70,NULL,NULL,'CGCG 428-060',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000083,NULL,'15.8g',0.43,'E0','Group member',NULL,NULL,NULL,1,333.741125,13.76192,0.157,NULL,52260040666,816563135,12758798,15.8),(154735,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bj',NULL,154735,43.08,0.2,2420,73222,70,NULL,'SALT 2','SNLS 05D4bj HOST',0.701,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.748583,-18.13342,0.013,NULL,49732259146,777066549,12141664,NULL),(154736,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bj',NULL,154736,43.13,0.15,2490,73222,NULL,NULL,'SIFTO','SNLS 05D4bj HOST',0.701,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154737,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bj',NULL,154737,43.45,0.17,2880,73222,NULL,NULL,'SALT2','SNLS 05D4bj HOST',0.701,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154738,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bj',NULL,154738,43.48,0.05,2920,73222,70,NULL,'SIFTO','SNLS 05D4bj HOST',0.701,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154739,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4im',NULL,154739,42.99,0.05,2260,73223,70,NULL,'SIFTO','[HSP2005] J221500.88-172345.84',0.751,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.7537083,-17.39606,0.045,NULL,49787363903,777927560,12155118,NULL),(154740,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4im',NULL,154740,43.14,0.15,2430,73223,NULL,NULL,'SIFTO','[HSP2005] J221500.88-172345.84',0.751,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154741,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4im',NULL,154741,44.12,0.17,3800,73223,NULL,NULL,'SALT2','[HSP2005] J221500.88-172345.84',0.751,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154742,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154742,35.57,0.54,130,73224,70,NULL,NULL,'ESO 189- G 032',NULL,'2014MNRAS.445.2677S',2014,1,1.12,NULL,'G',0.00015,NULL,'15.49',0.38,'(R\')SB(s)0/a',NULL,NULL,NULL,NULL,1,333.7577917,-55.97486,0,NULL,48698965614,760921337,11889395,15.49),(154743,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154743,36.83,0.46,232,73225,70,NULL,NULL,'2MASX J22150216-0930205',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,333.758917,-9.50575,0.129,NULL,49830523661,778601932,12165655,17.7),(154744,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2007qf',NULL,154744,39.61,0.09,835,73226,70,NULL,'Hubble residual 0.13 for z0.20380','SDSS J221502.93-002030.0',NULL,'2011ApJ...740...92G',2011,1,0.1,NULL,'G',0.0005,NULL,'20.4g',0.07,NULL,NULL,NULL,NULL,NULL,1,333.7622083,-0.34169,0.205,NULL,49801536034,778149000,12158578,20.4),(154745,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 19913','R',154745,40.11,0.21,872,73226,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007qf','SDSS J221502.93-002030.0',0.2038,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154746,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 19913','R',154746,40.26,0.11,936,73226,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007qf','SDSS J221502.93-002030.0',0.2038,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154747,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4bw',NULL,154747,43.04,0.05,2340,73227,70,NULL,'SIFTO','SNLS 06D4bw',0.732,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,333.7655,-17.88344,0.045,NULL,49787301535,777926586,12155102,NULL),(154748,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4bw',NULL,154748,43.09,0.21,2390,73227,70,NULL,'SALT 2','SNLS 06D4bw',0.732,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154749,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4bw',NULL,154749,43.2,0.15,2520,73227,NULL,NULL,'SIFTO','SNLS 06D4bw',0.732,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154750,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4bw',NULL,154750,44.11,0.17,3840,73227,NULL,NULL,'SALT2','SNLS 06D4bw',0.732,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154751,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154751,37.92,0.46,385,73228,70,NULL,NULL,'2MASX J22150550-0720415',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000149,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,333.772958333,-7.34494,0.193,NULL,49841428852,778772325,12168317,18.1),(154752,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154752,37.25,0.46,282,73229,70,NULL,NULL,'2MASX J22150711+0005355',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000171,NULL,'17.9g',0.19,'NLAGN',NULL,NULL,NULL,'Sy 2',1,333.77975,0.09314,0.165,NULL,52153659502,814900929,12732827,17.9),(154753,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk','R',154753,42.66,NULL,1850,73230,65,NULL,'SALT2','[AGR2006] J221507.68-180336.7',0.84,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.782,-18.06022,0.029,NULL,49787240713,777925636,12155088,NULL),(154754,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk',NULL,154754,43.09,0.06,2260,73230,70,NULL,'SALT2','[AGR2006] J221507.68-180336.7',0.84,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154755,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk',NULL,154755,43.17,0.23,2340,73230,74.2,NULL,'SALT 2','[AGR2006] J221507.68-180336.7',0.84,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154756,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk',NULL,154756,43.34,0.31,2530,73230,65,NULL,'SALT2','[AGR2006] J221507.68-180336.7',0.84,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154757,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk',NULL,154757,43.35,0.33,2540,73230,70,NULL,'SALT','[AGR2006] J221507.68-180336.7',0.84,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154758,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk',NULL,154758,43.48,0.19,2690,73230,70,NULL,NULL,'[AGR2006] J221507.68-180336.7',0.84,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154759,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk',NULL,154759,43.47,0.32,2690,73230,65,NULL,'SALT','[AGR2006] J221507.68-180336.7',0.84,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154760,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk',NULL,154760,43.74,0.14,3040,73230,65,NULL,'SALT','[AGR2006] J221507.68-180336.7',0.84,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154761,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk',NULL,154761,43.74,0.23,3050,73230,65,NULL,'SALT2','[AGR2006] J221507.68-180336.7',0.84,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154762,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk',NULL,154762,43.88,0.14,3240,73230,65,NULL,'MLCS2k2','[AGR2006] J221507.68-180336.7',0.84,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154763,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk',NULL,154763,43.88,0.16,3240,73230,65,NULL,'MLCS31','[AGR2006] J221507.68-180336.7',0.84,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154764,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk',NULL,154764,43.88,0.17,3240,73230,65,NULL,'MLCS17','[AGR2006] J221507.68-180336.7',0.84,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154765,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk',NULL,154765,43.9,0.16,3280,73230,65,NULL,'MLCS2k2','[AGR2006] J221507.68-180336.7',0.84,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154766,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk',NULL,154766,43.94,0.22,3330,73230,70,NULL,'SALT 2','[AGR2006] J221507.68-180336.7',0.84,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154767,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk',NULL,154767,43.95,0.15,3350,73230,NULL,NULL,'SIFTO','[AGR2006] J221507.68-180336.7',0.84,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154768,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk',NULL,154768,46.21,0.17,9500,73230,NULL,NULL,'SALT2','[AGR2006] J221507.68-180336.7',0.84,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154769,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4in',NULL,154769,41.77,0.04,1490,73231,70,NULL,'SIFTO','[NSB2006] J221508.58-171539.8',0.516,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.78575,-17.26106,0.049,NULL,49786794505,777918664,12154979,NULL),(154770,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4in',NULL,154770,42.43,0.15,2020,73231,NULL,NULL,'SIFTO','[NSB2006] J221508.58-171539.8',0.516,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154771,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4in',NULL,154771,42.45,0.12,2040,73231,70,NULL,'SALT 2','[NSB2006] J221508.58-171539.8',0.516,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154772,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4in',NULL,154772,44.51,0.17,5270,73231,NULL,NULL,'SALT2','[NSB2006] J221508.58-171539.8',0.516,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154773,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 01677','RN',154773,43.77,0.33,3730,73232,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01677',0.519408,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154774,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154774,37.41,0.46,303,73233,70,NULL,NULL,'2MASX J22151253+1159061',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,333.8022917,11.985,0.181,NULL,52279400141,816865627,12763525,17),(154775,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154775,36.44,0.46,194,73234,70,NULL,NULL,'2MASX J22151492+1354191',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000159,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,333.8122083,13.90544,0.157,NULL,52259502868,816554732,12758667,16.8),(154776,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154776,35.61,0.46,133,73235,70,NULL,NULL,'2MASX J22151621-0915475',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000097,NULL,'15.4g',0.47,'HII',NULL,NULL,NULL,NULL,1,333.817458333,-9.26322,0.133,NULL,49830598459,778603100,12165673,15.4),(154777,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154777,34.51,0.43,79.9,73236,75,NULL,'3.6 micron, color + selection bias corrected','IC 1441',NULL,'2014MNRAS.444..527S',2014,1,0.5,NULL,'G',0.000103,NULL,'15.3',0.3,'SBa?','in a pair',NULL,NULL,NULL,1,333.82975,37.3015,0.737,NULL,55477808768,866840762,13544386,15.3),(154778,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154778,37.75,0.46,355,73237,70,NULL,NULL,'SDSS J221520.24-001412.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,333.834375,-0.23681,0.165,NULL,49801504398,778148506,12158570,18.7),(154779,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4fo',NULL,154779,40.99,0.17,1150,73238,NULL,NULL,'SALT2','SNLS 05D4fo HOST',0.373,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.8372083,-17.26814,0.049,NULL,49786782952,777918483,12154976,NULL),(154780,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4fo',NULL,154780,41.6,0.11,1520,73238,70,NULL,'SALT 2','SNLS 05D4fo HOST',0.373,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154781,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4fo',NULL,154781,41.62,NULL,1540,73238,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SNLS 05D4fo HOST',0.373,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154782,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4fo',NULL,154782,41.62,0.15,1540,73238,NULL,NULL,'SIFTO','SNLS 05D4fo HOST',0.373,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154783,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4fo',NULL,154783,41.69,0.12,1590,73238,72,NULL,'z lit','SNLS 05D4fo HOST',0.373,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154784,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4fo',NULL,154784,41.71,0.03,1600,73238,70,NULL,'SALT2','SNLS 05D4fo HOST',0.373,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154785,'Faber-Jackson','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154785,33.8,0.44,57.5,73239,95,NULL,'Weighted Mean','NGC 7240',NULL,'1984ApJS...56...91D',1984,1,0.7,NULL,'G',0.000187,NULL,'15.2',0.7,'S0-:','in a pair',NULL,NULL,NULL,1,333.844,37.28067,0.737,NULL,55477805490,866840710,13544386,15.2),(154786,'Faber-Jackson','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154786,34.25,0.63,70.8,73239,95,NULL,'Michard 1979b, c','NGC 7240',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154787,'Faber-Jackson','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154787,34.37,0.46,74.8,73239,95,NULL,'Michard 1979a','NGC 7240',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154788,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm',NULL,154788,42.7,0.21,1910,73240,74.2,NULL,'SALT 2','[HSP2005] J221525.47-171442.71',0.811,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.856125,-17.24519,0.049,NULL,49753438103,777397470,12146835,NULL),(154789,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm','R',154789,42.82,NULL,2030,73240,65,NULL,'MLCS17','[HSP2005] J221525.47-171442.71',0.811,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154790,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm',NULL,154790,43.39,0.17,2630,73240,NULL,NULL,'SALT2','[HSP2005] J221525.47-171442.71',0.811,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154791,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm',NULL,154791,43.44,0.22,2690,73240,70,NULL,'SALT 2','[HSP2005] J221525.47-171442.71',0.811,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154792,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm',NULL,154792,43.55,0.2,2830,73240,65,NULL,'SALT2','[HSP2005] J221525.47-171442.71',0.811,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154793,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm',NULL,154793,43.55,0.2,2830,73240,65,NULL,'MLCS2k2','[HSP2005] J221525.47-171442.71',0.811,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154794,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm',NULL,154794,43.56,0.15,2840,73240,NULL,NULL,'SIFTO','[HSP2005] J221525.47-171442.71',0.811,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154795,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm',NULL,154795,43.67,0.26,2990,73240,65,NULL,'MLCS17','[HSP2005] J221525.47-171442.71',0.811,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154796,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm',NULL,154796,43.7,0.06,3040,73240,70,NULL,'SALT 2','[HSP2005] J221525.47-171442.71',0.811,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154797,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm',NULL,154797,43.92,0.22,3350,73240,65,NULL,'MLCS2k2','[HSP2005] J221525.47-171442.71',0.811,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154798,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm',NULL,154798,43.92,0.23,3350,73240,65,NULL,'MLCS31','[HSP2005] J221525.47-171442.71',0.811,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154799,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm',NULL,154799,43.95,0.26,3410,73240,70,NULL,NULL,'[HSP2005] J221525.47-171442.71',0.811,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154800,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm',NULL,154800,44.06,0.36,3580,73240,70,NULL,'SALT','[HSP2005] J221525.47-171442.71',0.811,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154801,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm',NULL,154801,44.22,0.21,3850,73240,65,NULL,'SALT','[HSP2005] J221525.47-171442.71',0.811,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154802,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm',NULL,154802,44.25,0.46,3910,73240,65,NULL,'SALT2','[HSP2005] J221525.47-171442.71',0.811,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154803,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm',NULL,154803,44.27,0.37,3940,73240,65,NULL,'SALT','[HSP2005] J221525.47-171442.71',0.811,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154804,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4co',NULL,154804,41.5,0.17,1390,73241,NULL,NULL,'SALT2','SNLS 06D4co HOST',0.437,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.8605,-17.86919,0.049,NULL,49786559546,777914992,12154921,NULL),(154805,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4co',NULL,154805,41.7,0.03,1520,73241,70,NULL,'SALT2','SNLS 06D4co HOST',0.437,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154806,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4co',NULL,154806,41.7,0.11,1520,73241,70,NULL,'SALT 2','SNLS 06D4co HOST',0.437,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154807,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4co',NULL,154807,41.79,0.15,1590,73241,NULL,NULL,'SIFTO','SNLS 06D4co HOST',0.437,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154808,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4bo',NULL,154808,42.22,0.05,1790,73242,70,NULL,'SIFTO','SNLS 06D4bo',0.552,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,333.867125,-17.40919,0.045,NULL,49787308643,777926697,12155104,NULL),(154809,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4bo',NULL,154809,42.58,0.13,2110,73242,70,NULL,'SALT 2','SNLS 06D4bo',0.552,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154810,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4bo',NULL,154810,42.7,0.15,2230,73242,NULL,NULL,'SIFTO','SNLS 06D4bo',0.552,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154811,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4bo',NULL,154811,43.84,0.17,3770,73242,NULL,NULL,'SALT2','SNLS 06D4bo',0.552,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154812,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4bc',NULL,154812,43.09,0.23,2640,73243,74.2,NULL,'SALT 2','[AGR2006] J221528.14-174948.6',0.572,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.86725,-17.83019,0.049,NULL,49786567385,777915115,12154923,NULL),(154813,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4bc',NULL,154813,43.52,0.14,3220,73243,70,NULL,NULL,'[AGR2006] J221528.14-174948.6',0.572,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154814,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4bc',NULL,154814,43.56,0.23,3280,73243,70,NULL,'SALT','[AGR2006] J221528.14-174948.6',0.572,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154815,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154815,31.85,NULL,23.4,73244,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11964',NULL,'2010Ap&SS.325..163P',2010,1,2.13,NULL,'G',0.000005,NULL,'16.0',0.3,'Sd','in a pair',NULL,NULL,NULL,1,333.871375,19.22006,0.209,NULL,52222903452,815982866,12749732,16),(154816,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154816,31.87,NULL,23.6,73244,NULL,NULL,'Dipole + Quadrupole','UGC 11964',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154817,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154817,31.87,NULL,23.7,73244,NULL,NULL,'Dipole','UGC 11964',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154818,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154818,32.32,0.2,29.1,73244,74.4,NULL,NULL,'UGC 11964',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154819,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154819,32.48,0.44,31.4,73244,NULL,NULL,NULL,'UGC 11964',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154820,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154820,32.54,0.43,32.2,73244,NULL,NULL,'Malmquist cor.','UGC 11964',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154821,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154821,33.06,NULL,40.9,73244,NULL,NULL,NULL,'UGC 11964',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154822,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','PS1 SN PS10ahl','N',154822,43.05,0.25,2490,73245,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10ahl HOST',0.6338,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154823,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4dy',NULL,154823,43.63,0.06,2970,73246,70,NULL,'SIFTO','SNLS 05D4dy HOST',0.79,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.875417,-18.21542,0.013,NULL,49731935109,777061486,12141585,NULL),(154824,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4dy',NULL,154824,43.88,0.17,3330,73246,NULL,NULL,'SALT2','SNLS 05D4dy HOST',0.79,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154825,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4dy',NULL,154825,44.03,0.23,3570,73246,70,NULL,'SALT 2','SNLS 05D4dy HOST',0.79,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154826,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4dy',NULL,154826,44.04,0.15,3590,73246,NULL,NULL,'SIFTO','SNLS 05D4dy HOST',0.79,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154827,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154827,35.61,0.14,132,73247,70,NULL,NULL,'2MASX J22153029+1340228',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00017,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,333.876166667,13.67319,0.185,NULL,52259456595,816554009,12758656,16.5),(154828,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154828,34.07,0.8,65.1,73248,75,NULL,'W91PP, r','UGC 11967',NULL,'1997ApJS..109..333W',1997,1,1.39,NULL,'G',0.000009,NULL,'15.66',0.19,'Sbc',NULL,NULL,NULL,NULL,1,333.8935,33.62997,0.477,NULL,55497397481,867146835,13549169,15.66),(154829,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154829,33.73,0.49,55.8,73248,75,NULL,'IR','UGC 11967',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154830,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154830,33.81,0.38,57.7,73248,75,NULL,'W91PP, r, raw','UGC 11967',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154831,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154831,33.85,0.38,58.9,73248,75,NULL,'W91PP, r, inv','UGC 11967',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154832,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154832,34.04,0.43,64.2,73248,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11967',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154833,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154833,34.13,0.38,66.9,73248,75,NULL,'W91PP, r, cor','UGC 11967',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154834,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154834,34.16,NULL,67.8,73248,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11967',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154835,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154835,34.17,NULL,68.2,73248,NULL,NULL,'Dipole + Quadrupole','UGC 11967',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154836,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154836,34.17,NULL,68.3,73248,NULL,NULL,'Dipole','UGC 11967',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154837,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154837,34.22,NULL,69.9,73248,NULL,NULL,NULL,'UGC 11967',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154838,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4ba',NULL,154838,42.62,0.06,1970,73249,70,NULL,'SIFTO','SNLS 06D4ba',0.7,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,333.898917,-18.22911,0.013,NULL,49731935704,777061495,12141585,NULL),(154839,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4ba',NULL,154839,43.25,0.15,2630,73249,NULL,NULL,'SIFTO','SNLS 06D4ba',0.7,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154840,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4ba',NULL,154840,43.32,0.25,2720,73249,70,NULL,'SALT 2','SNLS 06D4ba',0.7,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154841,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4ba',NULL,154841,44.31,0.17,4290,73249,NULL,NULL,'SALT2','SNLS 06D4ba',0.7,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154842,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4hu',NULL,154842,42.88,0.05,2210,73250,70,NULL,'SIFTO','[HSP2005] J221536.19-175019.81',0.7027,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.0003,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.900791667,-17.83883,0.049,NULL,49786566430,777915100,12154923,NULL),(154843,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4hu',NULL,154843,43.3,0.15,2680,73250,NULL,NULL,'SIFTO','[HSP2005] J221536.19-175019.81',0.7027,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154844,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4hu',NULL,154844,43.43,0.2,2840,73250,70,NULL,'SALT 2','[HSP2005] J221536.19-175019.81',0.7027,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154845,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4hu',NULL,154845,43.82,0.17,3410,73250,NULL,NULL,'SALT2','[HSP2005] J221536.19-175019.81',0.7027,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154846,'Tully est','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154846,31.74,0.8,22.3,73251,75,NULL,'B','NGC 7232',NULL,'1988NBGC.C....0000T',1988,1,2.6,'Confused HIPASS source','G',0.000018,NULL,'12.95',0.9,'SB(rs)a:       LLAGN','in a triple',NULL,NULL,NULL,1,333.908333,-45.85008,0,NULL,50692958105,792077470,12376210,12.95),(154847,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4fe',NULL,154847,44.51,0.15,4020,73252,NULL,NULL,'SIFTO','SNLS 05D4fe HOST',0.984,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.917791667,-17.52844,0.045,NULL,49786458395,777913412,12154897,NULL),(154848,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4fe',NULL,154848,48.38,0.17,23900,73252,NULL,NULL,'SALT2','SNLS 05D4fe HOST',0.984,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154849,'Faber-Jackson','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154849,33.77,0.44,56.8,73253,95,NULL,'Weighted Mean','NGC 7242',NULL,'1984ApJS...56...91D',1984,1,NULL,NULL,'GPair',0.000127,NULL,NULL,NULL,'E+:','Group member',NULL,NULL,NULL,1,333.91875,37.30056,0.737,NULL,55477344856,866833513,13544273,NULL),(154850,'Faber-Jackson','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154850,33.9,0.46,60.3,73253,95,NULL,'Michard 1979a','NGC 7242',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154851,'Faber-Jackson','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154851,34.94,0.63,97.3,73253,95,NULL,'Michard 1979b, c','NGC 7242',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154852,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 06800','RN',154852,39.01,0.3,605,73254,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06800',0.047749,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154853,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 20412','RN',154853,42.32,0.27,2010,73255,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20412',0.444671,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154854,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 20412','RN',154854,42.32,0.27,2020,73255,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 20412',0.444671,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154855,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 11129','RN',154855,37.99,0.23,360,73256,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10697 HOST',0.099112,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154856,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 10697','RN',154856,38.12,0.22,382,73256,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10697 HOST',0.099112,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154857,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 10697','RN',154857,38.2,0.08,396,73256,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10697 HOST',0.099112,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154858,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154858,38.27,0.46,451,73257,70,NULL,NULL,'2MASX J22154779-0905213',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,333.949167,-9.08939,0.129,NULL,49831022250,778609722,12165776,17.6),(154859,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','PS1 SN PS0909006','N',154859,40.58,0.31,1020,73258,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS0909006 HOST',0.2828,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154860,'Tully est','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154860,31.78,0.8,22.7,73259,75,NULL,NULL,'NGC 7233',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000023,NULL,'13.09',1.3,'SAB(r)a        HII','in a triple',NULL,NULL,NULL,1,333.954083333,-45.84644,0,NULL,50692960105,792077501,12376210,13.09),(154861,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154861,34.4,0.49,75.8,73260,75,NULL,'IR','ESO 467- G 034',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'15.05',0.5,'Sb?:           HII',NULL,NULL,NULL,NULL,1,333.953125,-27.51381,0,NULL,50534286294,789598223,12337472,15.05),(154862,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154862,34.54,0.53,81.1,73260,NULL,NULL,NULL,'ESO 467- G 034',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154863,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154863,34.58,0.2,82.4,73260,74.4,NULL,NULL,'ESO 467- G 034',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154864,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154864,34.59,0.52,82.9,73260,NULL,NULL,'Malmquist cor.','ESO 467- G 034',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154865,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154865,32.16,0.49,27,73261,75,NULL,'IR','NGC 7241',NULL,'2011yCatp016004901K',2011,1,3.4,NULL,'G',0.000003,NULL,'13.37',1.1,'SB(s)bc? pec','in a pair',NULL,NULL,NULL,1,333.9577917,19.23236,0.209,NULL,52222787819,815981059,12749704,13.37),(154866,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154866,33.69,0.43,54.8,73261,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7241',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154867,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154867,33.88,0.43,59.6,73261,75,NULL,'3.6 micron, color corrected','NGC 7241',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154868,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154868,34.17,0.2,68.2,73261,74.4,NULL,NULL,'NGC 7241',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154869,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','PS1 SN PS11alv','N',154869,39.19,0.1,603,73262,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11alv HOST',0.1438,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154870,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4ej',NULL,154870,42.88,0.15,2370,73263,NULL,NULL,'SIFTO','SNLS 05D4ej HOST',0.585,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.968833333,-18.19572,0.013,NULL,49731989640,777062338,12141599,NULL),(154871,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4ej',NULL,154871,42.94,0.14,2440,73263,70,NULL,'SALT 2','SNLS 05D4ej HOST',0.585,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154872,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4ej',NULL,154872,42.97,0.05,2480,73263,70,NULL,'SIFTO','SNLS 05D4ej HOST',0.585,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154873,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4ej',NULL,154873,43.48,0.17,3130,73263,NULL,NULL,'SALT2','SNLS 05D4ej HOST',0.585,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154874,'Tully est','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154874,32.02,0.8,25.3,73264,75,NULL,NULL,'NGC 7232B',NULL,'1988NBGC.C....0000T',1988,1,1.7,'Confused HIPASS source','G',0.000019,NULL,'13.9',1.5,'(R\'_2)SB(s)dm  LINER','in a triple',NULL,NULL,NULL,1,333.9685417,-45.78064,0,NULL,50726310208,792598597,12384353,13.9),(154875,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154875,35.17,0.49,108,73265,75,NULL,'IR','FGC 2381',NULL,'2011yCatp016004901K',2011,1,0.77,NULL,'G',0.000018,NULL,'16.4g',0.21,'Sc',NULL,NULL,NULL,NULL,1,333.969167,14.07944,0.177,NULL,52259714506,816558039,12758719,16.4),(154876,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154876,35.81,NULL,145,73265,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2381',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154877,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154877,35.83,NULL,147,73265,NULL,NULL,'Dipole + Quadrupole','FGC 2381',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154878,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154878,35.83,NULL,147,73265,NULL,NULL,NULL,'FGC 2381',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154879,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154879,35.85,NULL,148,73265,NULL,NULL,'Dipole','FGC 2381',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154880,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154880,38.08,0.46,414,73266,70,NULL,NULL,'SDSS J221554.87-073613.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00017,NULL,'18.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,333.978625,-7.60364,0.177,NULL,49844776476,778824632,12169134,18.6),(154881,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154881,36.99,0.46,250,73267,70,NULL,NULL,'2MASX J22155505+1316198',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,333.979375,13.27219,0.189,NULL,52247627008,816369172,12755768,16.5),(154882,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ii',NULL,154882,43.5,0.07,2690,73268,70,NULL,'SIFTO','[HSP2005] J221555.64-173927.09',0.866,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.981875,-17.65753,0.017,NULL,49786505626,777914150,12154908,NULL),(154883,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ii',NULL,154883,43.66,0.22,2890,73268,70,NULL,'SALT 2','[HSP2005] J221555.64-173927.09',0.866,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154884,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ii',NULL,154884,43.71,0.15,2950,73268,NULL,NULL,'SIFTO','[HSP2005] J221555.64-173927.09',0.866,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154885,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ii',NULL,154885,45.56,0.17,6920,73268,NULL,NULL,'SALT2','[HSP2005] J221555.64-173927.09',0.866,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154886,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bi',NULL,154886,42.83,0.06,2070,73269,70,NULL,'SIFTO','SNLS 05D4bi HOST',0.775,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.985625,-17.98606,0.029,NULL,49786541240,777914706,12154917,NULL),(154887,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bi',NULL,154887,43.66,0.15,3030,73269,NULL,NULL,'SIFTO','SNLS 05D4bi HOST',0.775,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154888,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bi',NULL,154888,43.7,0.23,3100,73269,70,NULL,'SALT 2','SNLS 05D4bi HOST',0.775,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154889,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bi',NULL,154889,45.19,0.17,6160,73269,NULL,NULL,'SALT2','SNLS 05D4bi HOST',0.775,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154890,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an',NULL,154890,42.26,0.17,1760,73270,74.2,NULL,'SALT 2','[AGR2006] J221557.11-174143.9',0.613,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.988,-17.69553,0.017,NULL,49786478210,777913722,12154901,NULL),(154891,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an','R',154891,42.65,NULL,2100,73270,65,NULL,'MLCS17','[AGR2006] J221557.11-174143.9',0.613,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154892,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an',NULL,154892,42.91,0.29,2370,73270,65,NULL,'MLCS17','[AGR2006] J221557.11-174143.9',0.613,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154893,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an',NULL,154893,42.93,0.16,2380,73270,65,NULL,'SALT2','[AGR2006] J221557.11-174143.9',0.613,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154894,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an',NULL,154894,42.94,0.17,2400,73270,65,NULL,'MLCS2k2','[AGR2006] J221557.11-174143.9',0.613,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154895,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an',NULL,154895,42.96,0.06,2420,73270,70,NULL,NULL,'[AGR2006] J221557.11-174143.9',0.613,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154896,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an',NULL,154896,42.96,0.15,2420,73270,70,NULL,'SALT','[AGR2006] J221557.11-174143.9',0.613,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154897,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an',NULL,154897,43.06,0.17,2540,73270,70,NULL,'SALT 2','[AGR2006] J221557.11-174143.9',0.613,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154898,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an',NULL,154898,43.06,0.39,2540,73270,65,NULL,'MLCS31','[AGR2006] J221557.11-174143.9',0.613,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154899,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an',NULL,154899,43.08,0.38,2560,73270,65,NULL,'MLCS2k2','[AGR2006] J221557.11-174143.9',0.613,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154900,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an',NULL,154900,43.11,0.12,2590,73270,65,NULL,'SALT','[AGR2006] J221557.11-174143.9',0.613,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154901,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an',NULL,154901,43.11,0.19,2600,73270,65,NULL,'SALT2','[AGR2006] J221557.11-174143.9',0.613,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154902,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an',NULL,154902,43.15,0.15,2640,73270,NULL,NULL,'SIFTO','[AGR2006] J221557.11-174143.9',0.613,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154903,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an',NULL,154903,43.23,0.05,2740,73270,65,NULL,'SALT','[AGR2006] J221557.11-174143.9',0.613,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154904,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an',NULL,154904,43.3,0.17,2840,73270,NULL,NULL,'SALT2','[AGR2006] J221557.11-174143.9',0.613,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154905,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an',NULL,154905,43.35,0.05,2900,73270,70,NULL,'SALT 2','[AGR2006] J221557.11-174143.9',0.613,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154906,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154906,35.61,0.14,132,73271,70,NULL,NULL,'CGCG 428-063',NULL,'2015arXiv151105856S',2015,1,0.75,'MCG RA is +1 minute in error.','G',0.000087,NULL,'14.5g',0.67,'S0^-',NULL,NULL,NULL,NULL,1,333.9977917,14.12497,0.197,NULL,52259713842,816558028,12758719,14.5),(154907,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154907,35.61,0.14,132,73272,70,NULL,NULL,'2MASX J22155949+1327158',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000179,NULL,'16.3g',0.24,'E0',NULL,NULL,NULL,NULL,1,333.9979583,13.45428,0.185,NULL,52247448597,816366384,12755724,16.3),(154908,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154908,36.05,0.49,162,73273,70,NULL,NULL,'2MASX J22160091-5808566',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.000103,NULL,'15.65',0.48,'S0',NULL,NULL,NULL,NULL,1,334.00375,-58.14906,0,NULL,48675181816,760549715,11883589,15.65),(154909,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SCP 06A04',NULL,154909,44.59,0.05,3780,73274,70,NULL,'SALT2, M(B) -19.289 mag, Alpha -0.019, Beta 3.480, Delta -0.151','CXO J221601.1-173722',1.192,'2012ApJ...746...85S',2012,1,NULL,NULL,'G',NULL,NULL,'22.2i',NULL,NULL,NULL,NULL,NULL,NULL,1,334.004917,-17.62294,0.017,NULL,49786518026,777914344,12154911,22.2),(154910,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154910,32.84,0.8,37.1,73275,75,NULL,'MAT, I','ESO 237- G 049',NULL,'1997ApJS..109..333W',1997,1,2.16,NULL,'G',0.00002,NULL,'14.53',0.27,'SBcd? sp',NULL,NULL,NULL,NULL,1,334.012583,-47.66222,0,NULL,50624463272,791007238,12359488,14.53),(154911,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154911,32.11,0.32,26.4,73275,85,NULL,'I, inv','ESO 237- G 049',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154912,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154912,32.14,0.32,26.8,73275,85,NULL,'I, raw','ESO 237- G 049',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154913,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154913,32.39,0.43,30,73275,75,NULL,'MAT, I, inv','ESO 237- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154914,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154914,32.43,0.43,30.6,73275,75,NULL,'MAT, I, raw','ESO 237- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154915,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154915,32.6,0.43,33.1,73275,75,NULL,'MAT, I, cor','ESO 237- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154916,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154916,32.65,0.4,33.9,73275,73,NULL,'opt','ESO 237- G 049',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154917,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154917,32.73,NULL,35.1,73275,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 237- G 049',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154918,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154918,32.74,NULL,35.3,73275,NULL,NULL,'Dipole + Quadrupole','ESO 237- G 049',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154919,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154919,32.74,0.45,35.4,73275,NULL,NULL,'Malmquist cor.','ESO 237- G 049',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154920,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154920,32.75,NULL,35.5,73275,NULL,NULL,'Dipole','ESO 237- G 049',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154921,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154921,32.76,0.4,35.6,73275,NULL,NULL,NULL,'ESO 237- G 049',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154922,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154922,32.81,NULL,36.4,73275,NULL,NULL,NULL,'ESO 237- G 049',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154923,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154923,32.92,0.42,38.3,73275,NULL,NULL,NULL,'ESO 237- G 049',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154924,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154924,32.96,0.2,39.1,73275,74.4,NULL,NULL,'ESO 237- G 049',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154925,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154925,37.7,0.23,347,73276,70,NULL,NULL,'2MASX J22160335-0813080',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,334.013916667,-8.219,0.161,NULL,49844651503,778822679,12169104,17.6),(154926,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154926,37.94,0.46,387,73277,70,NULL,NULL,'2MASX J22160336+0012474',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,334.013916667,0.21319,0.145,NULL,52153933645,814905213,12732893,17.2),(154927,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154927,37.55,0.46,323,73278,70,NULL,NULL,'SDSS J221603.61-092147.9',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,334.015083333,-9.36331,0.133,NULL,49831331511,778614554,12165852,17.6),(154928,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154928,36.86,0.46,236,73279,70,NULL,NULL,'2MASX J22160462-0801220',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00015,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,334.0192917,-8.02292,0.165,NULL,49844677228,778823081,12169110,16.7),(154929,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154929,34.71,0.8,87.5,73280,75,NULL,'MAT, I','ESO 533- G 006',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.23',0.5,'Sb','in a pair',NULL,NULL,NULL,1,334.020375,-26.68025,0,NULL,50536216064,789628376,12337943,14.23),(154930,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154930,34.42,0.32,76.5,73280,85,NULL,'I, raw','ESO 533- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154931,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154931,34.46,0.43,77.9,73280,75,NULL,'MAT, I, raw','ESO 533- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154932,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154932,34.47,0.32,78.4,73280,85,NULL,'I, inv','ESO 533- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154933,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154933,34.7,0.43,87,73280,75,NULL,'MAT, I, inv','ESO 533- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154934,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154934,34.72,0.43,88.1,73280,75,NULL,'MAT, I, cor','ESO 533- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154935,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154935,34.77,0.5,89.9,73280,NULL,NULL,'Malmquist cor.','ESO 533- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154936,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154936,34.84,0.48,93,73280,NULL,NULL,NULL,'ESO 533- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154937,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154937,34.85,0.4,93.2,73280,NULL,NULL,'mean','ESO 533- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154938,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154938,34.88,0.2,94.6,73280,74.4,NULL,NULL,'ESO 533- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154939,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154939,34.95,0.47,97.9,73280,NULL,NULL,'H','ESO 533- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154940,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154940,35.02,0.45,101,73280,NULL,NULL,'K','ESO 533- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154941,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154941,35.09,0.46,104,73280,NULL,NULL,'J','ESO 533- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154942,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154942,34.9,0.8,95.5,73281,75,NULL,'MAT, I','ESO 467- G 036',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.58',0.7,'SA(s)bc',NULL,NULL,NULL,NULL,1,334.02575,-30.36889,0,NULL,50545696055,789776500,12340257,14.58),(154943,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154943,34.66,0.32,85.5,73281,85,NULL,'I, raw','ESO 467- G 036',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154944,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154944,34.71,0.32,87.6,73281,85,NULL,'I, inv','ESO 467- G 036',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154945,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154945,34.71,0.43,87.7,73281,75,NULL,'MAT, I, raw','ESO 467- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154946,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154946,34.82,0.59,92,73281,NULL,NULL,'Malmquist cor.','ESO 467- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154947,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154947,34.93,0.56,97,73281,NULL,NULL,NULL,'ESO 467- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154948,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154948,34.96,0.43,98.1,73281,75,NULL,'MAT, I, inv','ESO 467- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154949,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154949,34.97,0.2,98.6,73281,74.4,NULL,NULL,'ESO 467- G 036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154950,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154950,35.02,0.43,101,73281,75,NULL,'MAT, I, cor','ESO 467- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154951,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cj',NULL,154951,39.89,0.03,749,73282,70,NULL,'SIFTO','[HSP2005] J221606.66-174216.72',0.27,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.02775,-17.70464,0.017,NULL,49786503423,777914115,12154908,NULL),(154952,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cj',NULL,154952,40.58,0.11,1030,73282,70,NULL,'SALT 2','[HSP2005] J221606.66-174216.72',0.27,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154953,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cj',NULL,154953,40.64,0.15,1060,73282,NULL,NULL,'SIFTO','[HSP2005] J221606.66-174216.72',0.27,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154954,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cj',NULL,154954,42.16,0.17,2130,73282,NULL,NULL,'SALT2','[HSP2005] J221606.66-174216.72',0.27,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154955,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154955,36.54,0.69,204,73283,70,NULL,NULL,'2MASX J22160676-0921020',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.0001,NULL,'16.65',0.28,NULL,NULL,NULL,NULL,NULL,1,334.028125,-9.35067,0.133,NULL,49831330992,778614546,12165852,16.65),(154956,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154956,38.04,0.16,406,73284,70,NULL,NULL,'2MASXi J2216068-091840',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000166,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,334.028625,-9.31122,0.117,NULL,49831336902,778614639,12165853,18.3),(154957,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154957,38.04,0.16,406,73285,70,NULL,NULL,'2MASX J22160703-0920190',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,334.029208333,-9.33872,0.133,NULL,49831330840,778614544,12165852,18.2),(154958,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 1999ee',NULL,154958,33.12,0.11,41.6,73286,72,NULL,NULL,'IC 5179',0.01141,'2008ApJ...689..377W',2008,1,2.3,'1995ApJS...98..129K has V = 4990 +- 80 km/s; 6dF DR1 has V = 3342 km/s.','G',0.000033,NULL,'12.38',1.1,'SA(rs)bc   HII;LIRG',NULL,NULL,NULL,NULL,1,334.037917,-36.84372,0,NULL,50557836499,789966195,12343221,12.38),(154959,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 1999ee',NULL,154959,33.19,0.03,43,73286,72,NULL,NULL,'IC 5179',0.01141,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154960,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 1999ee',NULL,154960,33.2,0.05,43.2,73286,72,NULL,NULL,'IC 5179',0.01141,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154961,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 1999ee',NULL,154961,33.18,0.08,43.3,73286,74.4,NULL,NULL,'IC 5179',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154962,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 1999ee',NULL,154962,33.26,0.19,44.4,73286,72,NULL,NULL,'IC 5179',0.01141,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154963,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 1999ee',NULL,154963,33.25,0.17,44.7,73286,70.8,NULL,NULL,'IC 5179',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154964,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 1999ee',NULL,154964,33.29,0.25,45,73286,70,NULL,'SALT 2','IC 5179',0.01141,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154965,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 1999ee',NULL,154965,33.27,0.02,45,73286,72,NULL,'M(H) = -18.317 mag','IC 5179',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154966,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 1999ee',NULL,154966,33.31,0.22,45.5,73286,73.8,NULL,'SALT 2 (SNANA)','IC 5179',0.0108,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154967,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 1999ee',NULL,154967,33.34,0.28,46.1,73286,65,NULL,'MLCS31','IC 5179',0.01141,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154968,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 1999ee',NULL,154968,33.35,0.02,46.2,73286,72,NULL,NULL,'IC 5179',0.01141,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154969,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 1999ee',NULL,154969,33.47,0.09,48.3,73286,65,NULL,'MLCS2k2','IC 5179',0.01141,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154970,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 1999ee',NULL,154970,33.53,0.3,50.2,73286,65,NULL,'SALT2','IC 5179',0.01141,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154971,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 1999ee',NULL,154971,33.57,0.28,51.2,73286,65,NULL,'MLCS17','IC 5179',0.01141,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154972,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 1999ee',NULL,154972,33.61,0.14,52.7,73286,60,NULL,NULL,'IC 5179',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154973,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154973,33.18,0.8,43.3,73286,75,NULL,'MAT, I','IC 5179',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154974,'Sosies','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154974,33.32,0.17,46.1,73286,NULL,NULL,NULL,'IC 5179',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154975,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154975,32.61,0.43,33.3,73286,75,NULL,'3.6 micron, color + selection bias corrected','IC 5179',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154976,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154976,32.76,0.45,35.6,73286,NULL,NULL,'K','IC 5179',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154977,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154977,32.78,0.47,36,73286,NULL,NULL,'H','IC 5179',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154978,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154978,32.82,0.43,36.6,73286,75,NULL,'3.6 micron, color corrected','IC 5179',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154979,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154979,32.82,0.46,36.7,73286,NULL,NULL,'J','IC 5179',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154980,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154980,32.86,0.42,37.3,73286,NULL,18.48,'3.6 micron','IC 5179',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154981,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154981,32.89,0.32,37.8,73286,85,NULL,'I, raw','IC 5179',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154982,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154982,32.91,0.4,38.2,73286,NULL,NULL,'mean','IC 5179',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154983,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154983,32.92,0.43,38.3,73286,75,NULL,'MAT, I, raw','IC 5179',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154984,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154984,32.96,0.32,39,73286,85,NULL,'I, inv','IC 5179',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154985,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154985,33.09,0.43,41.4,73286,75,NULL,'MAT, I, cor','IC 5179',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154986,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154986,33.09,0.4,41.5,73286,75,NULL,'HOSTS SN 1999ee','IC 5179',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154987,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154987,33.18,0.08,43.3,73286,74.4,NULL,NULL,'IC 5179',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154988,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154988,33.2,0.43,43.6,73286,75,NULL,'MAT, I, inv','IC 5179',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154989,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154989,33.26,0.46,44.8,73286,NULL,NULL,'Malmquist cor.','IC 5179',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154990,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154990,33.41,0.43,48.2,73286,NULL,NULL,NULL,'IC 5179',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154991,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4gg',NULL,154991,41.73,0.12,1560,73287,70,NULL,'SALT 2','[HSP2005] J221609.26-171739.98',0.4238,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',0.0004,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.038625,-17.29444,0.041,NULL,49753691789,777401434,12146897,NULL),(154992,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4gg',NULL,154992,41.74,0.15,1570,73287,NULL,NULL,'SIFTO','[HSP2005] J221609.26-171739.98',0.4238,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154993,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4gg',NULL,154993,42.17,0.05,1910,73287,70,NULL,'SIFTO','[HSP2005] J221609.26-171739.98',0.4238,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154994,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4gg',NULL,154994,43.26,0.17,3160,73287,NULL,NULL,'SALT2','[HSP2005] J221609.26-171739.98',0.4238,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154995,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4au',NULL,154995,41.82,0.17,1570,73288,74.2,NULL,'SALT 2','[AGR2006] J221609.91-180439.1',0.468,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.041333,-18.07756,0.029,NULL,49786545221,777914769,12154918,NULL),(154996,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4au',NULL,154996,42.49,0.16,2140,73288,70,NULL,'SALT','[AGR2006] J221609.91-180439.1',0.468,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154997,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4au',NULL,154997,42.54,0.16,2190,73288,70,NULL,'SALT 2','[AGR2006] J221609.91-180439.1',0.468,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154998,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4au',NULL,154998,42.57,0.13,2230,73288,65,NULL,'SALT','[AGR2006] J221609.91-180439.1',0.468,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154999,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4au',NULL,154999,42.61,0.15,2260,73288,NULL,NULL,'SIFTO','[AGR2006] J221609.91-180439.1',0.468,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155000,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4au',NULL,155000,42.71,0.07,2370,73288,70,NULL,NULL,'[AGR2006] J221609.91-180439.1',0.468,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155001,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4au','R',155001,42.72,NULL,2380,73288,65,NULL,'SALT','[AGR2006] J221609.91-180439.1',0.468,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155002,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4au',NULL,155002,43.25,0.17,3040,73288,NULL,NULL,'SALT2','[AGR2006] J221609.91-180439.1',0.468,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155003,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4au',NULL,155003,43.46,0.04,3350,73288,70,NULL,'SALT 2','[AGR2006] J221609.91-180439.1',0.468,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155004,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155004,38.65,0.46,538,73289,70,NULL,NULL,'SDSS J221611.96+002259.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000126,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,334.049833,0.38333,0.145,NULL,52154046740,814906980,12732921,18.7),(155005,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155005,38.04,0.16,406,73290,70,NULL,NULL,'2MASX J22161230-0921460',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000182,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,334.051167,-9.36269,0.133,NULL,49831324494,778614445,12165850,18),(155006,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155006,37.97,0.46,392,73291,70,NULL,NULL,'2MASX J22161312-0029111',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000195,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,334.0545417,-0.48631,0.205,NULL,49802073462,778157397,12158709,17.6),(155007,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155007,35.43,0.49,122,73292,70,NULL,NULL,'2MASX J22161338-5925106',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.80',0.55,'S',NULL,NULL,NULL,NULL,1,334.055708333,-59.41967,0,NULL,48677811544,760590805,11884231,15.8),(155008,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155008,37.79,0.46,362,73293,70,NULL,NULL,'2MASX J22161426-0806160',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000144,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,334.0595,-8.10453,0.165,NULL,49844674611,778823040,12169110,17.8),(155009,'SNII optical','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cw',NULL,155009,38.52,0.47,380,73294,NULL,NULL,'SEAM','APMUKS(BJ) B221331.31-172920.9',0.1543,'2009ApJ...694.1067P',2009,1,0.13,NULL,'G',NULL,NULL,'17.8r',0.12,NULL,NULL,NULL,NULL,NULL,1,334.05975,-17.23947,0.041,NULL,49753747728,777402308,12146911,17.8),(155010,'SNII optical','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cw',NULL,155010,39.11,0.55,664,73294,NULL,NULL,NULL,'APMUKS(BJ) B221331.31-172920.9',NULL,'2006ApJ...645..841N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155011,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd','R',155011,42.6,NULL,1850,73295,65,NULL,'SALT','[HSP2005] J221614.47-172344.37',0.791,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.003,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.0602917,-17.39567,0.029,NULL,49752976088,777390251,12146722,NULL),(155012,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd',NULL,155012,42.86,0.2,2080,73295,74.2,NULL,'SALT 2','[HSP2005] J221614.47-172344.37',0.791,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155013,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd',NULL,155013,43.27,0.07,2510,73295,70,NULL,'SALT','[HSP2005] J221614.47-172344.37',0.791,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155014,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd',NULL,155014,43.33,0.19,2590,73295,70,NULL,'SALT','[HSP2005] J221614.47-172344.37',0.791,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155015,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd',NULL,155015,43.35,0.08,2620,73295,70,NULL,NULL,'[HSP2005] J221614.47-172344.37',0.791,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155016,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd',NULL,155016,43.5,0.17,2790,73295,65,NULL,'SALT','[HSP2005] J221614.47-172344.37',0.791,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155017,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd',NULL,155017,43.6,0.23,2920,73295,70,NULL,'SALT 2','[HSP2005] J221614.47-172344.37',0.791,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155018,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd',NULL,155018,43.6,0.15,2930,73295,NULL,NULL,'SIFTO','[HSP2005] J221614.47-172344.37',0.791,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155019,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd',NULL,155019,43.62,0.07,2960,73295,65,NULL,'SALT','[HSP2005] J221614.47-172344.37',0.791,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155020,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd',NULL,155020,43.64,0.23,2980,73295,65,NULL,'MLCS17','[HSP2005] J221614.47-172344.37',0.791,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155021,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd',NULL,155021,43.67,0.18,3030,73295,65,NULL,'MLCS2k2','[HSP2005] J221614.47-172344.37',0.791,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155022,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd',NULL,155022,43.68,0.18,3040,73295,65,NULL,'SALT2','[HSP2005] J221614.47-172344.37',0.791,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155023,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd',NULL,155023,43.75,0.2,3140,73295,65,NULL,'MLCS31','[HSP2005] J221614.47-172344.37',0.791,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155024,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd',NULL,155024,43.75,0.22,3140,73295,65,NULL,'SALT2','[HSP2005] J221614.47-172344.37',0.791,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155025,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd',NULL,155025,43.75,0.19,3150,73295,65,NULL,'MLCS2k2','[HSP2005] J221614.47-172344.37',0.791,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155026,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd',NULL,155026,44.93,0.17,5390,73295,NULL,NULL,'SALT2','[HSP2005] J221614.47-172344.37',0.791,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155027,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155027,38.04,0.16,406,73296,70,NULL,NULL,'2MASX J22161500-0910050',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00015,NULL,'16.5g',0.34,'AGN',NULL,NULL,NULL,NULL,1,334.062375,-9.16822,0.129,NULL,49831023749,778609746,12165777,16.5),(155028,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gf',NULL,155028,39.56,0.13,659,73297,74.2,NULL,'SALT 2','SDSS J221616.44+004228.0',0.24,'2010ApJ...716..712A',2010,1,0.09,NULL,'G',0.0005,NULL,'20.7g',0.04,NULL,NULL,NULL,NULL,NULL,1,334.0685,0.70778,0.137,NULL,52153851712,814903933,12732873,20.7),(155029,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gf',NULL,155029,39.97,0.04,796,73297,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 03451, SN 2005gf','SDSS J221616.44+004228.0',0.24,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155030,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gf',NULL,155030,39.61,0.09,836,73297,70,NULL,'Hubble residual -0.25 for z0.25000','SDSS J221616.44+004228.0',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155031,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gf',NULL,155031,40.29,0.09,922,73297,65,NULL,'SALT2','SDSS J221616.44+004228.0',0.24,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155032,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gf',NULL,155032,40.29,0.14,922,73297,70,NULL,'SALT 2','SDSS J221616.44+004228.0',0.24,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155033,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 03451','R',155033,40.35,0.2,941,73297,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005gf','SDSS J221616.44+004228.0',0.25,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155034,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gf',NULL,155034,40.38,NULL,960,73297,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 03451, SN 2005gf','SDSS J221616.44+004228.0',0.24,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155035,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gf',NULL,155035,40.5,0.12,1010,73297,65,NULL,'MLCS2k2','SDSS J221616.44+004228.0',0.24,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155036,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 03451','R',155036,40.51,0.13,1010,73297,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005gf','SDSS J221616.44+004228.0',0.25,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155037,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gf',NULL,155037,40.22,0.1,1110,73297,70,NULL,'SALT 2','SDSS J221616.44+004228.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155038,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gf',NULL,155038,40.24,0.1,1120,73297,70,NULL,'SALT 2, Malmquist cor.','SDSS J221616.44+004228.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155039,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155039,38.04,0.16,406,73298,70,NULL,NULL,'SDSS J221617.16-091831.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000169,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,334.0715417,-9.30864,0.133,NULL,49831321541,778614399,12165849,18.4),(155040,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155040,35.7,0.48,138,73299,70,NULL,NULL,'FAIRALL 1006',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'16.44',0.25,'S',NULL,NULL,NULL,NULL,1,334.080166667,-48.53167,0,NULL,50623505799,790992278,12359254,16.44),(155041,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155041,35.52,0.64,127,73300,70,NULL,NULL,'2MASX J22161924-8112527',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'16.9b',0.19,NULL,NULL,NULL,NULL,NULL,1,334.0805417,-81.21464,0.469,NULL,48563731807,758808309,11856379,16.9),(155042,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155042,35.71,0.64,138,73301,70,NULL,NULL,'2MASX J22161948-7853047',NULL,'2014MNRAS.445.2677S',2014,1,0.31,NULL,'G',0.00015,NULL,'16.7b',0.17,NULL,NULL,NULL,NULL,NULL,1,334.080917,-78.88472,0.481,NULL,48560738667,758761541,11855649,16.7),(155043,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4ff',NULL,155043,41.01,0.17,1140,73302,NULL,NULL,'SALT2','SNLS 05D4ff HOST',0.402,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.084,-18.04256,0.029,NULL,49786537343,777914645,12154916,NULL),(155044,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4ff',NULL,155044,41.58,0.11,1480,73302,70,NULL,'SALT 2','SNLS 05D4ff HOST',0.402,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155045,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4ff',NULL,155045,41.65,0.15,1530,73302,NULL,NULL,'SIFTO','SNLS 05D4ff HOST',0.402,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155046,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4ff',NULL,155046,42.01,0.03,1800,73302,70,NULL,'SALT2','SNLS 05D4ff HOST',0.402,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155047,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4id','N',155047,43,0.06,2250,73303,70,NULL,'SIFTO','SNLS 04D4id HOST',0.769,'2011ApJS..192....1C',2011,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155048,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4id','N',155048,43.74,0.15,3170,73303,NULL,NULL,'SIFTO','SNLS 04D4id HOST',0.769,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155049,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4id','N',155049,43.96,0.23,3500,73303,70,NULL,'SALT 2','SNLS 04D4id HOST',0.769,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155050,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4id','N',155050,44.95,0.17,5530,73303,NULL,NULL,'SALT2','SNLS 04D4id HOST',0.769,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155051,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155051,38.04,0.16,406,73304,70,NULL,NULL,'2MASX J22162443-0918338',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000181,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,334.101875,-9.30942,0.133,NULL,49831319940,778614374,12165849,16.8),(155052,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155052,38.29,0.46,456,73305,70,NULL,NULL,'SDSS J221624.74-093510.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000137,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,334.103125,-9.58631,0.149,NULL,49831464031,778616625,12165884,18.7),(155053,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155053,35.63,0.53,134,73306,70,NULL,NULL,'2MASX J22162494-8033306',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'16.2b',0.29,NULL,NULL,NULL,NULL,NULL,1,334.103875,-80.55853,0.441,NULL,48562971555,758796430,11856194,16.2),(155054,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bf',NULL,155054,42.78,0.15,2260,73307,70,NULL,'SALT 2','SNLS 05D4bf',0.589,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,334.1097917,-18.23206,0.013,NULL,49731972743,777062074,12141594,NULL),(155055,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bf',NULL,155055,42.8,0.15,2280,73307,NULL,NULL,'SIFTO','SNLS 05D4bf',0.589,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155056,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bf',NULL,155056,42.85,0.04,2340,73307,70,NULL,'SIFTO','SNLS 05D4bf',0.589,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155057,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bf',NULL,155057,43.27,0.17,2840,73307,NULL,NULL,'SALT2','SNLS 05D4bf',0.589,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155058,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4ek',NULL,155058,42.24,0.13,1830,73308,70,NULL,'SALT 2','SNLS 05D4ek HOST',0.536,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.114667,-17.73631,0.017,NULL,49786624881,777916013,12154937,NULL),(155059,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4ek',NULL,155059,42.38,0.15,1950,73308,NULL,NULL,'SIFTO','SNLS 05D4ek HOST',0.536,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155060,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4ek',NULL,155060,42.69,0.04,2240,73308,70,NULL,'SIFTO','SNLS 05D4ek HOST',0.536,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155061,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4ek',NULL,155061,42.75,0.17,2310,73308,NULL,NULL,'SALT2','SNLS 05D4ek HOST',0.536,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155062,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155062,37.59,0.46,329,73309,70,NULL,NULL,'2MASXi J2216278-094839',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000171,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,334.1162083,-9.81119,0.137,NULL,49830854726,778607105,12165736,17.9),(155063,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155063,32.7,0.54,34.7,73310,70,NULL,NULL,'IC 1438',NULL,'2014MNRAS.445.2677S',2014,1,2.4,NULL,'G',0.00001,NULL,'13.19',2,'(R_1R\'_2)SAB(r)a HII','in a triple',NULL,NULL,NULL,1,334.1212083,-21.43069,0.061,NULL,50199577391,784368396,12255756,13.19),(155064,'Tully est','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155064,32.64,0.8,33.8,73310,75,NULL,NULL,'IC 1438',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155065,'Tully est','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155065,32.89,0.8,37.9,73311,75,NULL,NULL,'ESO 108- G 023',NULL,'1988NBGC.C....0000T',1988,1,2.6,NULL,'G',0.00001,NULL,'13.42',2.3,'SAB(s)cd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,334.133625,-64.38906,0,NULL,49278770299,769980785,12030949,13.42),(155066,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4af',NULL,155066,42.26,0.04,1890,73312,70,NULL,'SIFTO','SNLS 05D4af HOST',0.499,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.138083,-18.00492,0.049,NULL,49786603005,777915671,12154932,NULL),(155067,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4af',NULL,155067,42.32,0.13,1950,73312,70,NULL,'SALT 2','SNLS 05D4af HOST',0.499,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155068,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4af',NULL,155068,42.38,0.15,2000,73312,NULL,NULL,'SIFTO','SNLS 05D4af HOST',0.499,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155069,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4af',NULL,155069,42.72,0.17,2330,73312,NULL,NULL,'SALT2','SNLS 05D4af HOST',0.499,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155070,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cn',NULL,155070,42.68,0.27,1890,73313,74.2,NULL,'SALT 2','[HSP2005] J221634.60-171613.55',0.818,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.144167,-17.27044,0.041,NULL,49753715609,777401806,12146903,NULL),(155071,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cn','R',155071,43.2,NULL,2400,73313,65,NULL,'SALT','[HSP2005] J221634.60-171613.55',0.818,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155072,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cn',NULL,155072,43.53,0.3,2800,73313,70,NULL,NULL,'[HSP2005] J221634.60-171613.55',0.818,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155073,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cn',NULL,155073,43.57,0.56,2850,73313,70,NULL,'SALT','[HSP2005] J221634.60-171613.55',0.818,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155074,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cn',NULL,155074,43.73,0.55,3060,73313,65,NULL,'SALT','[HSP2005] J221634.60-171613.55',0.818,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155075,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cn',NULL,155075,43.8,0.2,3160,73313,65,NULL,'SALT','[HSP2005] J221634.60-171613.55',0.818,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155076,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cn',NULL,155076,44.14,0.25,3710,73313,65,NULL,'MLCS2k2','[HSP2005] J221634.60-171613.55',0.818,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155077,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155077,38.04,0.16,406,73314,70,NULL,NULL,'2MASX J22163544-0919128',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,334.147666667,-9.32014,0.133,NULL,49831049004,778610140,12165783,17.9),(155078,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4fx',NULL,155078,42.58,0.05,2020,73315,70,NULL,'SIFTO','SNLS 04D4fx HOST',0.629,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.158917,-18.06636,0.029,NULL,49786421827,777912841,12154888,NULL),(155079,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4fx',NULL,155079,42.75,0.15,2180,73315,NULL,NULL,'SIFTO','SNLS 04D4fx HOST',0.629,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155080,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4fx',NULL,155080,42.85,0.18,2280,73315,70,NULL,'SALT 2','SNLS 04D4fx HOST',0.629,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155081,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4fx',NULL,155081,44.18,0.17,4200,73315,NULL,NULL,'SALT2','SNLS 04D4fx HOST',0.629,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155082,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155082,37.22,0.58,279,73316,70,NULL,NULL,'2MASX J22163823-4804568',NULL,'2014MNRAS.445.2677S',2014,1,0.74,NULL,'G',0.00015,NULL,'16.57',0.18,NULL,NULL,NULL,NULL,NULL,1,334.159375,-48.08242,0,NULL,50623434800,790991168,12359237,16.57),(155083,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155083,34.59,0.61,82.9,73317,70,NULL,NULL,'IC 1439',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00003,NULL,'15.00',0.9,'(R_1R\'_2)SB(s)a','in a triple',NULL,NULL,NULL,1,334.16725,-21.48594,0.061,NULL,50199745300,784371020,12255797,15),(155084,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg','R',155084,41.82,NULL,1450,73318,65,NULL,'SALT','[AGR2006] J221640.18-180951.8',0.592,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.167458333,-18.16439,0.029,NULL,49732093261,777063957,12141624,NULL),(155085,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg',NULL,155085,41.84,0.17,1470,73318,74.2,NULL,'SALT 2','[AGR2006] J221640.18-180951.8',0.592,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155086,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg',NULL,155086,42.52,0.2,2000,73318,70,NULL,'SALT','[AGR2006] J221640.18-180951.8',0.592,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155087,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg',NULL,155087,42.56,0.09,2040,73318,70,NULL,NULL,'[AGR2006] J221640.18-180951.8',0.592,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155088,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg',NULL,155088,42.56,0.24,2040,73318,65,NULL,'MLCS2k2','[AGR2006] J221640.18-180951.8',0.592,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155089,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg',NULL,155089,42.57,0.14,2050,73318,65,NULL,'SALT2','[AGR2006] J221640.18-180951.8',0.592,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155090,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg',NULL,155090,42.57,0.15,2050,73318,NULL,NULL,'SIFTO','[AGR2006] J221640.18-180951.8',0.592,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155091,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg',NULL,155091,42.59,0.17,2070,73318,70,NULL,'SALT 2','[AGR2006] J221640.18-180951.8',0.592,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155092,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg',NULL,155092,42.63,0.05,2110,73318,70,NULL,'SALT','[AGR2006] J221640.18-180951.8',0.592,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155093,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg',NULL,155093,42.66,0.17,2140,73318,65,NULL,'SALT','[AGR2006] J221640.18-180951.8',0.592,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155094,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg',NULL,155094,42.7,0.19,2170,73318,65,NULL,'SALT2','[AGR2006] J221640.18-180951.8',0.592,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155095,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg',NULL,155095,42.83,0.23,2320,73318,65,NULL,'MLCS17','[AGR2006] J221640.18-180951.8',0.592,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155096,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg',NULL,155096,42.85,0.08,2340,73318,65,NULL,'SALT','[AGR2006] J221640.18-180951.8',0.592,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155097,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg',NULL,155097,42.87,0.23,2350,73318,65,NULL,'MLCS2k2','[AGR2006] J221640.18-180951.8',0.592,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155098,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg',NULL,155098,42.91,0.26,2400,73318,65,NULL,'MLCS31','[AGR2006] J221640.18-180951.8',0.592,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155099,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg',NULL,155099,43.79,0.17,3600,73318,NULL,NULL,'SALT2','[AGR2006] J221640.18-180951.8',0.592,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155100,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155100,38.04,0.16,406,73319,70,NULL,NULL,'2MASX J22164131-0914138',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00015,NULL,'16.2g',0.35,'E0',NULL,NULL,NULL,NULL,1,334.172125,-9.23731,0.137,NULL,49831070201,778610471,12165788,16.2),(155101,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4fg',NULL,155101,43.05,0.06,2220,73320,70,NULL,'SIFTO','SNLS 05D4fg HOST',0.839,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.1722917,-17.59547,0.029,NULL,49752997441,777390585,12146727,NULL),(155102,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4fg',NULL,155102,43.74,0.15,3050,73320,NULL,NULL,'SIFTO','SNLS 05D4fg HOST',0.839,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155103,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4fg',NULL,155103,43.76,NULL,3080,73320,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SNLS 05D4fg HOST',0.839,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155104,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4fg',NULL,155104,43.78,0.2,3100,73320,70,NULL,'SALT 2','SNLS 05D4fg HOST',0.839,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155105,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4fg',NULL,155105,44.37,0.17,4070,73320,NULL,NULL,'SALT2','SNLS 05D4fg HOST',0.839,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155106,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ib',NULL,155106,42.37,0.05,1750,73321,70,NULL,'SIFTO','SNLS 04D4ib HOST',0.699,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.1737917,-18.10508,0.029,NULL,49731879007,777060609,12141572,NULL),(155107,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ib',NULL,155107,43.17,0.15,2530,73321,NULL,NULL,'SIFTO','SNLS 04D4ib HOST',0.699,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155108,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ib',NULL,155108,43.26,0.18,2640,73321,70,NULL,'SALT 2','SNLS 04D4ib HOST',0.699,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155109,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ib',NULL,155109,44.63,0.17,4950,73321,NULL,NULL,'SALT2','SNLS 04D4ib HOST',0.699,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155110,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz',NULL,155110,41.37,0.17,1110,73322,NULL,NULL,'SALT2','[HSP2005] J221641.87-175534.54',0.695,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.1744583,-17.92625,0.049,NULL,49786606162,777915721,12154933,NULL),(155111,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz',NULL,155111,42.48,0.21,1850,73322,74.2,NULL,'SALT 2','[HSP2005] J221641.87-175534.54',0.695,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155112,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz','R',155112,42.51,NULL,1870,73322,65,NULL,'MLCS17','[HSP2005] J221641.87-175534.54',0.695,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155113,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz',NULL,155113,42.98,0.22,2330,73322,65,NULL,'MLCS2k2','[HSP2005] J221641.87-175534.54',0.695,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155114,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz',NULL,155114,42.98,0.31,2330,73322,65,NULL,'MLCS17','[HSP2005] J221641.87-175534.54',0.695,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155115,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz',NULL,155115,43.02,0.09,2370,73322,70,NULL,NULL,'[HSP2005] J221641.87-175534.54',0.695,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155116,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz',NULL,155116,43.1,0.34,2460,73322,65,NULL,'MLCS31','[HSP2005] J221641.87-175534.54',0.695,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155117,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz',NULL,155117,43.11,0.33,2470,73322,65,NULL,'MLCS2k2','[HSP2005] J221641.87-175534.54',0.695,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155118,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz',NULL,155118,43.14,0.15,2500,73322,NULL,NULL,'SIFTO','[HSP2005] J221641.87-175534.54',0.695,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155119,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz',NULL,155119,43.15,0.2,2520,73322,65,NULL,'SALT2','[HSP2005] J221641.87-175534.54',0.695,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155120,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz',NULL,155120,43.16,0.18,2530,73322,70,NULL,'SALT','[HSP2005] J221641.87-175534.54',0.695,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155121,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz',NULL,155121,43.28,0.28,2670,73322,70,NULL,'SALT 2','[HSP2005] J221641.87-175534.54',0.695,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155122,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz',NULL,155122,43.29,0.06,2680,73322,70,NULL,'SALT2','[HSP2005] J221641.87-175534.54',0.695,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155123,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz',NULL,155123,43.33,0.07,2740,73322,65,NULL,'SALT','[HSP2005] J221641.87-175534.54',0.695,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155124,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz',NULL,155124,43.34,0.15,2750,73322,65,NULL,'SALT','[HSP2005] J221641.87-175534.54',0.695,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155125,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz',NULL,155125,43.41,0.23,2830,73322,65,NULL,'SALT2','[HSP2005] J221641.87-175534.54',0.695,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155126,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 20068','RN',155126,43.07,0.26,2910,73323,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 20068',0.409815,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155127,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 20068','RN',155127,43.15,0.25,3030,73323,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 20068',0.409815,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155128,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155128,32.74,0.8,35.3,73324,75,NULL,'MAT, I','ESO 289- G 010',NULL,'1997ApJS..109..333W',1997,1,2.46,NULL,'G',0.000017,NULL,'14.76',0.26,'SB(s)d? sp',NULL,NULL,NULL,NULL,1,334.180417,-47.11869,0,NULL,50692852466,792075819,12376184,14.76),(155129,'Tully est','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155129,32.67,0.8,34.3,73324,75,NULL,NULL,'ESO 289- G 010',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155130,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155130,32.3,0.4,28.8,73324,73,NULL,'IR','ESO 289- G 010',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155131,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155131,32.3,0.4,28.8,73324,75,NULL,NULL,'ESO 289- G 010',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155132,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155132,32.51,0.4,31.8,73324,73,NULL,'opt','ESO 289- G 010',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155133,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155133,32.72,0.4,35,73324,NULL,NULL,NULL,'ESO 289- G 010',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155134,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155134,32.72,0.4,35,73324,73,NULL,'opt','ESO 289- G 010',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155135,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155135,32.76,0.32,35.7,73324,85,NULL,'I, raw','ESO 289- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155136,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155136,32.76,0.32,35.7,73324,85,NULL,'I, inv','ESO 289- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155137,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155137,32.81,0.46,36.5,73324,NULL,NULL,'Malmquist cor.','ESO 289- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155138,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155138,32.91,0.43,38.2,73324,75,NULL,'MAT, I, raw','ESO 289- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155139,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155139,32.95,0.43,39,73324,75,NULL,'MAT, I, inv','ESO 289- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155140,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155140,33.01,0.43,40,73324,75,NULL,'MAT, I, cor','ESO 289- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155141,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155141,33.04,NULL,40.5,73324,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 289- G 010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155142,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155142,33.04,0.42,40.6,73324,NULL,NULL,NULL,'ESO 289- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155143,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155143,33.05,NULL,40.7,73324,NULL,NULL,'Dipole + Quadrupole','ESO 289- G 010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155144,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155144,33.06,NULL,41,73324,NULL,NULL,'Dipole','ESO 289- G 010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155145,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155145,33.08,0.2,41.3,73324,74.4,NULL,NULL,'ESO 289- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155146,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155146,33.1,0.49,41.7,73324,75,NULL,'IR','ESO 289- G 010',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155147,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155147,33.16,NULL,42.9,73324,NULL,NULL,NULL,'ESO 289- G 010',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155148,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155148,37.43,0.46,306,73325,70,NULL,NULL,'2MASX J22164397-0824228',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000154,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,334.183375,-8.40636,0.161,NULL,49844196559,778815571,12168993,17.4),(155149,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dw','R',155149,42.84,NULL,1880,73326,65,NULL,'MLCS17','[AGR2006] J221644.66-175002.3',0.961,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.186125,-17.834,0.049,NULL,49786627756,777916058,12154938,NULL),(155150,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dw',NULL,155150,43.33,0.1,2360,73326,70,NULL,'MLCS17','[AGR2006] J221644.66-175002.3',0.961,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155151,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dw',NULL,155151,43.54,0.35,2600,73326,74.2,NULL,'SALT 2','[AGR2006] J221644.66-175002.3',0.961,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155152,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dw',NULL,155152,44,0.29,3220,73326,70,NULL,NULL,'[AGR2006] J221644.66-175002.3',0.961,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155153,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dw',NULL,155153,44.01,0.15,3230,73326,NULL,NULL,'SIFTO','[AGR2006] J221644.66-175002.3',0.961,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155154,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dw',NULL,155154,44.09,0.54,3350,73326,70,NULL,'SALT','[AGR2006] J221644.66-175002.3',0.961,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155155,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dw',NULL,155155,44.1,0.22,3360,73326,65,NULL,'MLCS2k2','[AGR2006] J221644.66-175002.3',0.961,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155156,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dw',NULL,155156,44.16,0.13,3460,73326,65,NULL,'MLCS2k2','[AGR2006] J221644.66-175002.3',0.961,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155157,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dw',NULL,155157,44.17,0.21,3470,73326,65,NULL,'MLCS17','[AGR2006] J221644.66-175002.3',0.961,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155158,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dw',NULL,155158,44.23,0.26,3570,73326,70,NULL,'SALT 2','[AGR2006] J221644.66-175002.3',0.961,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155159,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dw',NULL,155159,44.26,0.31,3630,73326,65,NULL,'SALT2','[AGR2006] J221644.66-175002.3',0.961,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155160,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dw',NULL,155160,44.27,0.21,3640,73326,65,NULL,'SALT','[AGR2006] J221644.66-175002.3',0.961,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155161,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dw',NULL,155161,44.3,0.5,3690,73326,65,NULL,'SALT','[AGR2006] J221644.66-175002.3',0.961,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155162,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dw',NULL,155162,45.69,0.17,6990,73326,NULL,NULL,'SALT2','[AGR2006] J221644.66-175002.3',0.961,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155163,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155163,37.23,0.46,279,73327,70,NULL,NULL,'SDSS J221644.82-083242.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000165,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,334.186791667,-8.54511,0.161,NULL,49842331335,778786427,12168537,18.4),(155164,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 07798','RN',155164,38.63,0.13,477,73328,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 07798',0.118668,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155165,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 07798','RN',155165,38.86,0.48,528,73328,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07798',0.118668,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155166,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155166,36.86,0.46,236,73329,70,NULL,NULL,'2MASX J22164717-0050070',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'16.4g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,334.196541667,-0.83522,0.205,NULL,49801758955,778152483,12158632,16.4),(155167,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155167,37.6,0.46,331,73330,70,NULL,NULL,'2MASX J22164735-0943288',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'17.0g',0.24,'BrClG',NULL,NULL,NULL,NULL,1,334.197417,-9.72478,0.137,NULL,49831263766,778613496,12165835,17),(155168,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155168,37.23,0.46,279,73331,70,NULL,NULL,'2MASX J22164916+1200376',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000182,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,334.204833,12.01047,0.161,NULL,52278077468,816844960,12763202,17.8),(155169,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155169,33.13,0.46,42.3,73332,NULL,NULL,'J','UGC 11973',NULL,'2007A&A...465...71T',2007,1,3.2,NULL,'G',0.000037,NULL,'12.9',0.9,'SAB(s)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,334.210375,41.50283,0.945,NULL,55504494131,867257720,13550901,12.9),(155170,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155170,33.21,0.47,43.8,73332,NULL,NULL,'H','UGC 11973',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155171,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155171,33.27,0.45,45.1,73332,NULL,NULL,'K','UGC 11973',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155172,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155172,33.31,0.2,45.9,73332,74.4,NULL,NULL,'UGC 11973',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155173,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155173,33.47,0.43,49.4,73332,75,NULL,'3.6 micron, color corrected','UGC 11973',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155174,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155174,33.62,0.4,53,73332,NULL,NULL,'mean','UGC 11973',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155175,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155175,33.69,0.43,54.7,73332,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11973',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155176,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155176,32.61,0.4,33.3,73333,75,NULL,'B','UGCA 427',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.000027,NULL,'14.73',0.7,'SB(s)m','in a triple',NULL,NULL,NULL,1,334.211667,-21.24997,0.065,NULL,50211123029,784548797,12258574,14.73),(155177,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155177,37.59,0.33,330,73334,70,NULL,NULL,'2MASX J22165197-0812138',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,334.216416667,-8.20392,0.141,NULL,49844974634,778827728,12169183,17.4),(155178,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4be',NULL,155178,41.63,0.04,1380,73335,70,NULL,'SIFTO','SNLS 05D4be HOST',0.537,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.2224583,-17.23611,0.041,NULL,49753830604,777403603,12146931,NULL),(155179,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4be',NULL,155179,42.55,0.15,2100,73335,NULL,NULL,'SIFTO','SNLS 05D4be HOST',0.537,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155180,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4be',NULL,155180,42.66,0.12,2210,73335,70,NULL,'SALT 2','SNLS 05D4be HOST',0.537,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155181,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4be',NULL,155181,44.04,0.17,4190,73335,NULL,NULL,'SALT2','SNLS 05D4be HOST',0.537,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155182,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155182,37.21,0.46,276,73336,70,NULL,NULL,'2MASX J22165419-0803448',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000135,NULL,'17.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,334.225708333,-8.06236,0.145,NULL,49845083919,778829436,12169209,17.9),(155183,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4cq',NULL,155183,41.7,0.03,1550,73337,70,NULL,'SIFTO','SNLS 06D4cq HOST',0.411,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.231333333,-17.71197,0.017,NULL,49753047058,777391360,12146740,NULL),(155184,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4cq',NULL,155184,41.82,0.11,1640,73337,70,NULL,'SALT 2','SNLS 06D4cq HOST',0.411,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155185,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4cq',NULL,155185,41.82,0.15,1640,73337,NULL,NULL,'SIFTO','SNLS 06D4cq HOST',0.411,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155186,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4cq',NULL,155186,41.85,NULL,1660,73337,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SNLS 06D4cq HOST',0.411,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155187,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4cq',NULL,155187,42.53,0.17,2270,73337,NULL,NULL,'SALT2','SNLS 06D4cq HOST',0.411,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155188,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4dw',NULL,155188,43.6,0.22,2820,73338,70,NULL,'SALT 2','SNLS 05D4dw HOST',0.855,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.232833,-18.05147,0.029,NULL,49786436370,777913068,12154891,NULL),(155189,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4dw',NULL,155189,43.61,0.07,2840,73338,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SNLS 05D4dw HOST',0.855,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155190,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4dw',NULL,155190,43.7,NULL,2960,73338,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SNLS 05D4dw HOST',0.855,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155191,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4dw',NULL,155191,43.74,0.15,3020,73338,NULL,NULL,'SIFTO','SNLS 05D4dw HOST',0.855,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155192,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4dw',NULL,155192,44.41,0.17,4110,73338,NULL,NULL,'SALT2','SNLS 05D4dw HOST',0.855,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155193,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155193,37.59,0.33,330,73339,70,NULL,NULL,'2MASX J22165641-0809078',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,334.235125,-8.15219,0.141,NULL,49844932910,778827076,12169173,17.5),(155194,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 15265','RN',155194,42.46,0.37,2520,73340,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15265',0.231513,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155195,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4cl',NULL,155195,43.4,0.09,2390,73341,70,NULL,'SIFTO','SNLS 06D4cl HOST',1,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.2377083,-17.45064,0.041,NULL,49753009337,777390770,12146730,NULL),(155196,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4cl',NULL,155196,44.04,0.22,3210,73341,70,NULL,'SALT 2','SNLS 06D4cl HOST',1,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155197,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4cl',NULL,155197,44.23,0.15,3510,73341,NULL,NULL,'SIFTO','SNLS 06D4cl HOST',1,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155198,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4cl',NULL,155198,45.56,0.17,6460,73341,NULL,NULL,'SALT2','SNLS 06D4cl HOST',1,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155199,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4hf',NULL,155199,43.89,0.31,3100,73342,70,NULL,'SALT 2','SNLS 04D4hf HOST',0.936,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',0.014,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.24125,-17.68703,0.017,NULL,49753047724,777391370,12146740,NULL),(155200,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4hf',NULL,155200,44,0.1,3250,73342,70,NULL,'SIFTO','SNLS 04D4hf HOST',0.936,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155201,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4hf',NULL,155201,44.06,0.15,3340,73342,NULL,NULL,'SIFTO','SNLS 04D4hf HOST',0.936,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155202,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4hf',NULL,155202,45.06,0.17,5310,73342,NULL,NULL,'SALT2','SNLS 04D4hf HOST',0.936,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155203,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4gz',NULL,155203,42.13,0.15,1940,73343,NULL,NULL,'SIFTO','[NSB2006] J221659.01-173719.0',0.375,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.245916667,-17.62194,0.029,NULL,49753060415,777391568,12146743,NULL),(155204,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4gz',NULL,155204,42.3,0.17,2100,73343,NULL,NULL,'SALT2','[NSB2006] J221659.01-173719.0',0.375,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155205,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ju',NULL,155205,42.43,0.14,2080,73344,70,NULL,'SALT 2','[NSB2006] J221702.73-171958.3',0.472,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.261375,-17.33286,0.041,NULL,49753703240,777401613,12146900,NULL),(155206,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ju',NULL,155206,42.44,0.15,2090,73344,NULL,NULL,'SIFTO','[NSB2006] J221702.73-171958.3',0.472,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155207,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ju',NULL,155207,42.46,NULL,2110,73344,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','[NSB2006] J221702.73-171958.3',0.472,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155208,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ju',NULL,155208,43.2,0.17,2970,73344,NULL,NULL,'SALT2','[NSB2006] J221702.73-171958.3',0.472,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155209,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ju',NULL,155209,43.5,0.04,3400,73344,70,NULL,'SIFTO','[NSB2006] J221702.73-171958.3',0.472,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155210,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bm',NULL,155210,41.27,0.03,1310,73345,70,NULL,'SIFTO','SNLS 05D4bm HOST',0.375,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.26925,-17.67761,0.017,NULL,49753050280,777391410,12146740,NULL),(155211,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bm',NULL,155211,41.54,0.11,1480,73345,70,NULL,'SALT 2','SNLS 05D4bm HOST',0.375,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155212,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bm',NULL,155212,41.59,0.15,1510,73345,NULL,NULL,'SIFTO','SNLS 05D4bm HOST',0.375,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155213,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bm',NULL,155213,42.03,0.17,1850,73345,NULL,NULL,'SALT2','SNLS 05D4bm HOST',0.375,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155214,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 16230',NULL,155214,39.63,0.41,844,73346,70,NULL,'SN photometric redshift distance, z photo =0.221 +/- 0.054','SDSS-II SN 16230',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,334.278916667,-0.89997,0.205,NULL,49801800198,778153128,12158642,NULL),(155215,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 16230','R',155215,42.84,0.48,2180,73346,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 16230',0.690995,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155216,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155216,37.99,0.46,396,73347,70,NULL,NULL,'2MASX J22170813+1218109',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000204,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,334.283875,12.30308,0.189,NULL,52244812098,816325189,12755081,16.6),(155217,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155217,36.03,0.52,161,73348,70,NULL,NULL,'2MASX J22170988-8114451',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,334.2907917,-81.24594,0.469,NULL,48563723150,758808174,11856377,17),(155218,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155218,38.15,0.46,427,73349,70,NULL,NULL,'2MASX J22171077-0050084',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000147,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,334.295,-0.83572,0.205,NULL,49801689256,778151394,12158615,17.7),(155219,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155219,36.24,0.52,177,73350,70,NULL,NULL,'2MASX J22171119-4829438',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.33',0.43,'S0',NULL,NULL,NULL,NULL,1,334.296583,-48.49547,0,NULL,50623611779,790993934,12359280,16.33),(155220,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155220,36.14,0.51,169,73351,70,NULL,NULL,'2MASX J22171321-4823338',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'17.02',0.3,NULL,NULL,NULL,NULL,NULL,1,334.3050417,-48.39272,0,NULL,50623626179,790994159,12359283,17.02),(155221,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4hn',NULL,155221,43.26,0.23,2440,73352,70,NULL,'SALT 2','SNLS 05D4hn HOST',0.842,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.306417,-17.91261,0.049,NULL,49786447778,777913246,12154894,NULL),(155222,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4hn',NULL,155222,43.39,0.07,2580,73352,70,NULL,'SIFTO','SNLS 05D4hn HOST',0.842,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155223,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4hn',NULL,155223,43.48,0.15,2690,73352,NULL,NULL,'SIFTO','SNLS 05D4hn HOST',0.842,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155224,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4hn',NULL,155224,45.23,0.17,6030,73352,NULL,NULL,'SALT2','SNLS 05D4hn HOST',0.842,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155225,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 03601','RN',155225,41.27,0.16,1360,73353,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03601',0.320009,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155226,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 03601','RN',155226,41.62,0.22,1600,73353,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03601',0.320009,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155227,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155227,36.54,0.54,203,73354,70,NULL,NULL,'ESO 237- G 051',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'14.83',0.8,'E+3 pec',NULL,NULL,NULL,NULL,1,334.315667,-48.30047,0,NULL,50623618621,790994040,12359281,14.83),(155228,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155228,37.36,0.46,297,73355,70,NULL,NULL,'2MASX J22171601-0927268',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000151,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,334.316667,-9.45753,0.133,NULL,49831126441,778611350,12165802,16.9),(155229,'Tully est','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155229,31.76,0.8,22.5,73356,75,NULL,NULL,'ESO 289- G 011',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.00002,NULL,'14.89',1,'IB(s)m','Group member',NULL,NULL,NULL,1,334.3180417,-45.0665,0,NULL,50726297263,792598394,12384349,14.89),(155230,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ih',NULL,155230,43.07,0.08,2130,73357,70,NULL,'SIFTO','[HSP2005] J221717.04-174038.74',0.934,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.321,-17.67742,0.029,NULL,49753061789,777391590,12146743,NULL),(155231,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ih',NULL,155231,44.16,0.15,3510,73357,NULL,NULL,'SIFTO','[HSP2005] J221717.04-174038.74',0.934,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155232,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ih',NULL,155232,44.22,0.21,3620,73357,70,NULL,'SALT 2','[HSP2005] J221717.04-174038.74',0.934,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155233,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ih',NULL,155233,44.6,0.17,4300,73357,NULL,NULL,'SALT2','[HSP2005] J221717.04-174038.74',0.934,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155234,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4ce',NULL,155234,42.99,0.07,2150,73358,70,NULL,'SIFTO','SNLS 06D4ce HOST',0.85,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.321875,-17.23594,0.041,NULL,49753793626,777403025,12146922,NULL),(155235,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4ce',NULL,155235,43.8,0.15,3110,73358,NULL,NULL,'SIFTO','SNLS 06D4ce HOST',0.85,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155236,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4ce',NULL,155236,43.83,0.23,3150,73358,70,NULL,'SALT 2','SNLS 06D4ce HOST',0.85,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155237,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4ce',NULL,155237,45.86,0.17,8030,73358,NULL,NULL,'SALT2','SNLS 06D4ce HOST',0.85,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155238,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4cs',NULL,155238,42.8,0.05,2020,73359,70,NULL,'SIFTO','SNLS 05D4cs HOST',0.79,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.32425,-17.88014,0.017,NULL,49786416634,777912759,12154886,NULL),(155239,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4cs',NULL,155239,43.46,0.15,2750,73359,NULL,NULL,'SIFTO','SNLS 05D4cs HOST',0.79,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155240,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4cs',NULL,155240,43.61,0.19,2950,73359,70,NULL,'SALT 2','SNLS 05D4cs HOST',0.79,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155241,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4cs',NULL,155241,45.39,0.17,6670,73359,NULL,NULL,'SALT2','SNLS 05D4cs HOST',0.79,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155242,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4jw',NULL,155242,43.66,0.14,2760,73360,70,NULL,'SALT2','SNLS 04D4jw HOST',0.961,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.3287083,-17.6655,0.029,NULL,49753054223,777391472,12146741,NULL),(155243,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4jw',NULL,155243,43.85,0.17,3010,73360,NULL,NULL,'SALT2','SNLS 04D4jw HOST',0.961,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155244,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4jw',NULL,155244,44.47,0.26,3990,73360,70,NULL,'SALT 2','SNLS 04D4jw HOST',0.961,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155245,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4jw',NULL,155245,44.48,0.15,4020,73360,NULL,NULL,'SIFTO','SNLS 04D4jw HOST',0.961,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155246,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2011fs',NULL,155246,34.46,0.09,77.9,73361,72,NULL,'M(H) = -18.317 mag','UGC 11975',NULL,'2014ApJ...784..105W',2013,1,1.5,NULL,'G',0.000093,NULL,'15.2',1.2,'S0/a',NULL,NULL,NULL,NULL,1,334.33225,35.57117,0.525,NULL,55483993850,866937403,13545896,15.2),(155247,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 09424','R',155247,39.99,0.26,818,73362,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 09424',0.217237,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,334.33975,0.09747,0.197,NULL,52153250885,814894545,12732727,NULL),(155248,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 09424','R',155248,40.37,0.29,975,73362,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 09424',0.217237,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155249,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 09424',NULL,155249,40.72,0.38,1390,73362,70,NULL,'SN photometric redshift distance, z photo =0.401 +/- 0.102','SDSS-II SN 09424',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155250,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155250,37.46,0.46,311,73363,70,NULL,NULL,'2MASX J22172207-0859325',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,334.341833333,-8.99233,0.137,NULL,49842273626,778785525,12168523,17.7),(155251,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155251,37.28,0.46,286,73364,70,NULL,NULL,'2MASX J22172456-0727505',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,334.3524583,-7.46392,0.189,NULL,49841596447,778774944,12168358,17.6),(155252,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155252,35.48,0.49,125,73365,75,NULL,'IR','CGCG 428-067',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000599,NULL,'15.61',0.2,NULL,NULL,NULL,NULL,NULL,1,334.353125,15.21708,0.149,NULL,52251410398,816428287,12756691,15.61),(155253,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155253,37.26,0.23,283,73366,70,NULL,NULL,'2MASX J22172482+1231225',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00019,NULL,'16.5g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,334.353417,12.52297,0.197,NULL,52247889401,816373271,12755832,16.5),(155254,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155254,37.26,0.23,283,73367,70,NULL,NULL,'SDSS J221725.27+123517.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,334.355333333,12.58828,0.189,NULL,52247894347,816373349,12755833,18.6),(155255,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 01979',NULL,155255,39.5,0.85,793,73368,70,NULL,'SN photometric redshift distance, z photo =0.206 +/- 0.118','SDSS-II SN 01979',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,':','22.5g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,334.356,0.94456,0.125,NULL,52153540618,814899072,12732798,22.5),(155256,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 01979','R',155256,40.66,0.31,1060,73368,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01979',0.2834,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155257,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 01979','R',155257,40.89,0.26,1170,73368,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01979',0.2834,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155258,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 01979',NULL,155258,40.66,0.19,1360,73368,70,NULL,'SALT 2','SDSS-II SN 01979',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155259,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 01979',NULL,155259,40.68,0.19,1370,73368,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 01979',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155260,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155260,38.07,0.46,411,73369,70,NULL,NULL,'2MASX J22172591-0825315',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000188,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,334.3580417,-8.42539,0.141,NULL,49844233979,778816155,12169002,16.8),(155261,'HII LF','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155261,46.76,0.56,3900,73370,71,NULL,NULL,'SSA 22a MD46',3.091,'2005MNRAS.356.1117S',2005,1,NULL,NULL,'G',0.001,NULL,'23.3R',NULL,'LBG',NULL,NULL,NULL,NULL,1,334.363625,0.30275,0.161,NULL,52153234393,814894287,12732723,23.3),(155262,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155262,37.68,0.46,343,73371,70,NULL,NULL,'2MASX J22173071-0108220',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,334.377917,-1.13928,0.205,NULL,49801616677,778150260,12158597,18.3),(155263,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh','R',155263,41.75,NULL,1370,73372,65,NULL,'SALT','[AGR2006] J221731.04-173746.9',0.627,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.0004,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.379333333,-17.62972,0.029,NULL,49753082991,777391921,12146748,NULL),(155264,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh',NULL,155264,42.06,0.16,1590,73372,74.2,NULL,'SALT 2','[AGR2006] J221731.04-173746.9',0.627,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155265,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh',NULL,155265,42.28,0.04,1750,73372,70,NULL,'SALT','[AGR2006] J221731.04-173746.9',0.627,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155266,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh',NULL,155266,42.71,0.15,2140,73372,70,NULL,'SALT','[AGR2006] J221731.04-173746.9',0.627,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155267,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh',NULL,155267,42.75,0.04,2180,73372,70,NULL,NULL,'[AGR2006] J221731.04-173746.9',0.627,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155268,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh',NULL,155268,42.81,0.11,2240,73372,65,NULL,'SALT2','[AGR2006] J221731.04-173746.9',0.627,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155269,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh',NULL,155269,42.87,0.17,2300,73372,70,NULL,'SALT 2','[AGR2006] J221731.04-173746.9',0.627,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155270,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh',NULL,155270,42.88,0.12,2310,73372,65,NULL,'SALT','[AGR2006] J221731.04-173746.9',0.627,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155271,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh',NULL,155271,42.88,0.15,2310,73372,65,NULL,'MLCS2k2','[AGR2006] J221731.04-173746.9',0.627,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155272,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh',NULL,155272,42.91,0.15,2350,73372,NULL,NULL,'SIFTO','[AGR2006] J221731.04-173746.9',0.627,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155273,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh',NULL,155273,42.91,0.2,2350,73372,65,NULL,'MLCS17','[AGR2006] J221731.04-173746.9',0.627,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155274,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh',NULL,155274,42.93,0.17,2370,73372,65,NULL,'SALT2','[AGR2006] J221731.04-173746.9',0.627,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155275,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh',NULL,155275,42.94,0.21,2380,73372,65,NULL,'MLCS2k2','[AGR2006] J221731.04-173746.9',0.627,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155276,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh',NULL,155276,42.94,0.23,2380,73372,65,NULL,'MLCS31','[AGR2006] J221731.04-173746.9',0.627,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155277,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh',NULL,155277,43,0.03,2450,73372,65,NULL,'SALT','[AGR2006] J221731.04-173746.9',0.627,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155278,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh',NULL,155278,44.49,0.17,4870,73372,NULL,NULL,'SALT2','[AGR2006] J221731.04-173746.9',0.627,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155279,'HII LF','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155279,49.71,0.43,15200,73373,71,NULL,NULL,'LAB 30',3.086,'2005MNRAS.356.1117S',2005,1,NULL,NULL,'G',0.001,NULL,'23.37',NULL,'LBG',NULL,NULL,NULL,NULL,1,334.3850417,0.19247,0.197,NULL,52153279702,814894995,12732734,23.37),(155280,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2008ei',NULL,155280,36.11,0.16,161,73374,70,NULL,'SALT 2','UGC 11977',0.037639,'2013MNRAS.433.2240G',2013,1,1.1,NULL,'G',0.000033,NULL,'16.5',0.8,'SABdm',NULL,NULL,NULL,NULL,1,334.3892917,33.25611,0.325,NULL,55498466295,867163535,13549430,16.5),(155281,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155281,34.63,0.8,84.2,73375,75,NULL,'W91PP, r','UGC 11976',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000033,NULL,'16.29',0.2,'S?',NULL,NULL,NULL,NULL,1,334.401083,28.95422,0.305,NULL,55448002961,866375046,13537110,16.29),(155282,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155282,34.91,0.38,95.9,73375,75,NULL,'W91PP, r, inv','UGC 11976',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155283,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155283,34.91,0.38,96.1,73375,75,NULL,'W91PP, r, raw','UGC 11976',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155284,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155284,35.07,0.38,103,73375,75,NULL,'W91PP, r, cor','UGC 11976',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155285,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 17176','R',155285,38.17,0.13,394,73376,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ie','SN 2007ie',0.093413,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia?',NULL,NULL,NULL,NULL,1,334.402875,0.61333,0.137,NULL,52153996832,814906200,12732909,NULL),(155286,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 17176','R',155286,38.22,0.2,402,73376,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ie','SN 2007ie',0.093413,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155287,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155287,37.26,0.23,283,73377,70,NULL,NULL,'2MASX J22173834+1234005',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,334.409875,12.56683,0.209,NULL,52247770537,816371414,12755803,17.4),(155288,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155288,36.97,0.46,248,73378,70,NULL,NULL,'2MASX J22173937-0107050',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000154,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,334.4140417,-1.118,0.205,NULL,49801835760,778153683,12158651,17.2),(155289,'HII LF','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155289,48.96,0.85,13900,73379,71,NULL,NULL,'SSA 22a MD041',2.1713,'2005MNRAS.356.1117S',2005,1,NULL,NULL,'G',0.002,NULL,'23.3R',NULL,'LBG',NULL,NULL,NULL,NULL,1,334.4165417,0.28639,0.161,NULL,52153275697,814894932,12732733,23.3),(155290,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155290,32.47,0.8,31.2,73380,75,NULL,'MAT, I','NGC 7247',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'13.09',0.9,'SB(s)b:','in a pair',NULL,NULL,NULL,1,334.421875,-23.73103,0.069,NULL,50197775522,784340242,12255316,13.09),(155291,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155291,32.22,0.43,27.7,73380,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7247',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155292,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155292,32.39,0.43,30.1,73380,75,NULL,'3.6 micron, color corrected','NGC 7247',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155293,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155293,32.44,0.45,30.8,73380,NULL,NULL,'K','NGC 7247',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155294,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155294,32.46,0.07,31.1,73380,NULL,NULL,NULL,'NGC 7247',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155295,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155295,32.48,0.47,31.3,73380,NULL,NULL,'H','NGC 7247',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155296,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155296,32.53,0.46,32,73380,NULL,NULL,'J','NGC 7247',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155297,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155297,32.55,0.4,32.3,73380,NULL,NULL,'mean','NGC 7247',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155298,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155298,32.59,0.2,33,73380,74.4,NULL,NULL,'NGC 7247',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155299,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155299,32.7,0.32,34.7,73380,85,NULL,'I, raw','NGC 7247',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155300,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155300,32.74,0.32,35.3,73380,85,NULL,'I, inv','NGC 7247',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155301,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155301,32.87,0.43,37.5,73380,75,NULL,'MAT, I, raw','NGC 7247',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155302,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155302,33.05,0.43,40.7,73380,75,NULL,'MAT, I, inv','NGC 7247',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155303,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155303,33.16,0.43,42.8,73380,75,NULL,'MAT, I, cor','NGC 7247',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155304,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155304,33.07,0.69,41.1,73381,100,NULL,'mid-IR','NGC 7246',NULL,'2013ApJ...771...88L',2013,1,1.4,NULL,'G',0.000013,NULL,'13.67',0.7,'(R)SA(r)a:     HII',NULL,NULL,NULL,NULL,1,334.427833,-15.57128,0.073,NULL,49754928228,777420753,12147199,13.67),(155305,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 15289',NULL,155305,38.84,1.86,587,73382,70,NULL,'SN photometric redshift distance, z photo =0.148 +/- 0.250','SDSS-II SN 15289',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,334.4330417,-1.19864,0.205,NULL,49801625405,778150396,12158599,NULL),(155306,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155306,32.83,0.8,36.8,73383,75,NULL,'MAT, I','ESO 237- G 052',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000026,NULL,'14.40',0.8,'(R\'_2)SAB(s)c',NULL,NULL,NULL,NULL,1,334.447125,-49.25994,0,NULL,50624020222,791000315,12359379,14.4),(155307,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155307,32.43,0.4,30.6,73383,NULL,NULL,NULL,'ESO 237- G 052',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155308,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155308,32.43,0.39,30.6,73383,73,NULL,'opt','ESO 237- G 052',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155309,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155309,32.5,0.32,31.6,73383,85,NULL,'I, inv','ESO 237- G 052',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155310,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155310,32.51,0.32,31.8,73383,85,NULL,'I, raw','ESO 237- G 052',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155311,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155311,32.88,0.43,37.6,73383,75,NULL,'MAT, I, raw','ESO 237- G 052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155312,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155312,32.89,0.43,37.9,73383,75,NULL,'MAT, I, inv','ESO 237- G 052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155313,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155313,32.98,0.43,39.4,73383,75,NULL,'MAT, I, cor','ESO 237- G 052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155314,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155314,35.61,0.5,133,73384,70,NULL,NULL,'ESO 533- G 009',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000103,NULL,'15.03',1,'S0','in a pair',NULL,NULL,NULL,1,334.454,-23.89194,0.045,NULL,50197868115,784341689,12255338,15.03),(155315,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','PTF10qky','N',155315,37.64,0.04,314,73385,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10qky',0.0742,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155316,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 07892',NULL,155316,38.07,0.87,411,73386,70,NULL,'SN photometric redshift distance, z photo =0.101 +/- 0.054','SDSS-II SN 07892',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,334.454375,-1.00736,0.205,NULL,49801707124,778151673,12158619,NULL),(155317,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155317,36.15,0.46,170,73387,70,NULL,NULL,'2MASX J22175024+1259415',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,334.459375,12.99492,0.197,NULL,52248224191,816378502,12755914,17.5),(155318,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','PS1 SN PS10byr','N',155318,40.57,0.28,1050,73388,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10byr HOST',0.2388,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155319,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','PS1 SN PS11ajs','N',155319,40.32,0.12,942,73389,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11ajs HOST',0.2288,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155320,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155320,36.82,0.74,231,73390,70,NULL,NULL,'2MASX J22175127-1235177',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'16.84',0.26,NULL,NULL,NULL,NULL,NULL,1,334.463791667,-12.58831,0.121,NULL,49748276838,777316825,12145575,16.84),(155321,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155321,37.11,0.46,264,73391,70,NULL,NULL,'2MASX J22175203-0817462',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000151,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,334.46675,-8.29631,0.141,NULL,49845011670,778828307,12169192,17),(155322,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155322,35.41,0.46,121,73392,70,NULL,NULL,'2MASX J22175466-0831232',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.00015,NULL,'15.7g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,334.4777083,-8.52306,0.161,NULL,49844311511,778817367,12169021,15.7),(155323,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155323,37.54,0.46,322,73393,70,NULL,NULL,'SDSS J221755.09-000545.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000184,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,334.4795417,-0.09608,0.197,NULL,49801090122,778142033,12158469,18.4),(155324,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155324,34.29,0.61,72.1,73394,NULL,NULL,NULL,'ESO 467- G 040',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000033,NULL,'15.76',0.34,'Sb',NULL,NULL,NULL,NULL,1,334.487625,-27.52906,0.021,NULL,50547095660,789798369,12340599,15.76),(155325,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155325,34.33,0.2,73.5,73394,74.4,NULL,NULL,'ESO 467- G 040',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155326,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155326,34.41,0.57,76.2,73394,NULL,NULL,'Malmquist cor.','ESO 467- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155327,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155327,35.08,0.48,104,73395,70,NULL,NULL,'ESO 237- G 053',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.12',0.3,'S0',NULL,NULL,NULL,NULL,1,334.4962917,-48.47664,0,NULL,50623585202,790993518,12359273,15.12),(155328,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155328,37.26,0.23,283,73396,70,NULL,NULL,'2MASX J22175945+1248587',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000155,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,334.497583333,12.81636,0.213,NULL,52247781453,816371585,12755806,17.3),(155329,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 03150',NULL,155329,40.2,0.19,1100,73397,70,NULL,'SN photometric redshift distance, z photo =0.300 +/- 0.034','SDSS-II SN 03150',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.1g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,334.512167,-0.63156,0.181,NULL,49801213629,778143962,12158499,22.1),(155330,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 03150','R',155330,41.18,0.23,1290,73397,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03150',0.333268,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155331,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 03150','R',155331,41.18,0.28,1290,73397,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03150',0.333268,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155332,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 03150',NULL,155332,41.03,0.18,1610,73397,70,NULL,'SALT 2','SDSS-II SN 03150',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155333,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 03150',NULL,155333,41.07,0.18,1640,73397,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 03150',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155334,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155334,36.56,0.87,205,73398,70,NULL,NULL,'2MASX J22180610-2020257',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,334.5254583,-20.34056,0.053,NULL,50207473874,784491779,12257684,14.4),(155335,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155335,37.51,0.46,318,73399,70,NULL,NULL,'2MASX J22181034-0751122',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000183,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,334.543208333,-7.85339,0.145,NULL,49844531795,778820809,12169075,17.6),(155336,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2013dy',NULL,155336,31.49,0.01,19.7,73400,NULL,NULL,'SNooPy','NGC 7250',0.003889,'2015MNRAS.452.4307P',2015,1,1.7,NULL,'G',0.000017,NULL,'13.22',0.8,'Sdm?           Sbrst','in a pair',NULL,NULL,NULL,1,334.574167,40.56239,0.625,NULL,55504884729,867263823,13550997,13.22),(155337,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155337,29.92,0.2,9.64,73400,74.4,NULL,NULL,'NGC 7250',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155338,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155338,30.68,0.4,13.7,73400,NULL,NULL,NULL,'NGC 7250',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155339,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155339,30.68,0.39,13.7,73400,73,NULL,'opt','NGC 7250',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155340,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155340,35.83,0.59,146,73401,70,NULL,NULL,'2MASX J22181921-6612027',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'16.97',0.27,NULL,NULL,NULL,NULL,NULL,1,334.580166667,-66.20086,0,NULL,49290766040,770168219,12033878,16.97),(155341,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 12870','RN',155341,40.62,0.18,930,73402,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 12870',0.428459,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155342,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','PS1 SN PS10agw','N',155342,41.36,0.11,1410,73403,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10agw HOST',0.3288,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155343,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155343,35.77,0.55,143,73404,70,NULL,NULL,'2MASX J22183005-5510397',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.0001,NULL,'15.73',0.45,'E',NULL,NULL,NULL,NULL,1,334.625041667,-55.17772,0,NULL,48700426903,760944170,11889752,15.73),(155344,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155344,37.84,0.46,370,73405,70,NULL,NULL,'2MASX J22183393-0919075',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000172,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,334.641333,-9.31881,0.137,NULL,49831504815,778617262,12165894,17.8),(155345,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gg',NULL,155345,39.54,0.12,658,73406,74.2,NULL,'SALT 2','SDSS J221841.10+003822.2',0.23,'2010ApJ...716..712A',2010,1,0.04,NULL,'G',0.0005,NULL,'22.2g',0.03,NULL,NULL,NULL,NULL,NULL,1,334.6712917,0.63953,0.133,NULL,52157409415,814959522,12733742,22.2),(155346,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gg',NULL,155346,39.67,0.04,697,73406,70,NULL,'SDSS-II SN 03452','SDSS J221841.10+003822.2',0.23,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155347,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gg',NULL,155347,39.69,0.09,867,73406,70,NULL,'Hubble residual -0.02 for z0.23040','SDSS J221841.10+003822.2',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155348,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gg',NULL,155348,40.27,0.1,919,73406,65,NULL,'SALT2','SDSS J221841.10+003822.2',0.23,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155349,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gg',NULL,155349,40.28,0.13,924,73406,70,NULL,'SDSS-II SN 03452, SALT 2','SDSS J221841.10+003822.2',0.23,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155350,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 03452','R',155350,40.29,0.19,928,73406,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005gg','SDSS J221841.10+003822.2',0.2304,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155351,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gg',NULL,155351,40.45,0.1,1000,73406,65,NULL,'MLCS2k2','SDSS J221841.10+003822.2',0.23,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155352,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 03452','R',155352,40.48,0.12,1020,73406,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005gg','SDSS J221841.10+003822.2',0.2304,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155353,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gg',NULL,155353,40.24,0.09,1120,73406,70,NULL,'SALT 2','SDSS J221841.10+003822.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155354,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gg',NULL,155354,40.26,0.09,1130,73406,70,NULL,'SALT 2, Malmquist cor.','SDSS J221841.10+003822.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155355,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155355,36.63,0.46,212,73407,70,NULL,NULL,'2MASX J22184464+1254375',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,334.685917,12.91042,0.197,NULL,52248053861,816375841,12755872,18),(155356,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155356,33.61,0.45,52.8,73408,NULL,NULL,'K','IC 5186',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.00006,NULL,'13.69',1.2,'(R\':)SB?(r)ab',NULL,NULL,NULL,NULL,1,334.693833333,-36.80158,0,NULL,50554243419,789910053,12342344,13.69),(155357,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155357,33.65,0.47,53.6,73408,NULL,NULL,'H','IC 5186',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155358,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155358,33.7,0.46,54.8,73408,NULL,NULL,'J','IC 5186',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155359,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155359,33.97,0.4,62.1,73408,NULL,NULL,'mean','IC 5186',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155360,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155360,37.66,0.46,341,73409,70,NULL,NULL,'2MASX J22184819-0037309',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,334.700791667,-0.62514,0.181,NULL,49809588185,778274815,12160543,17.7),(155361,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155361,36.4,0.51,191,73410,70,NULL,NULL,'2MASX J22184915-4913256',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'14.9R',0.24,NULL,NULL,NULL,NULL,NULL,1,334.704875,-49.22375,0,NULL,50623293880,790988966,12359202,14.9),(155362,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 13405','RN',155362,42.24,0.21,2130,73411,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13405',0.315477,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155363,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 13405','RN',155363,42.29,0.14,2180,73411,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13405',0.315477,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155364,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155364,33.88,0.49,59.8,73412,75,NULL,'IR','UGC 11982',NULL,'2011yCatp016004901K',2011,1,1.68,NULL,'G',0.000023,NULL,'15.50',0.21,'SB(s)cd?','Isolated galaxy',NULL,NULL,NULL,1,334.720625,-1.05867,0.177,NULL,49809896377,778279630,12160619,15.5),(155365,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155365,34.06,0.38,64.9,73412,NULL,NULL,'Malmquist cor.','UGC 11982',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155366,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155366,34.08,0.2,65.5,73412,74.4,NULL,NULL,'UGC 11982',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155367,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155367,34.14,0.37,67.3,73412,NULL,NULL,NULL,'UGC 11982',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155368,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155368,34.32,NULL,73,73412,NULL,NULL,'Dipole','UGC 11982',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155369,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155369,34.32,NULL,73.2,73412,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11982',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155370,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155370,34.33,NULL,73.4,73412,NULL,NULL,'Dipole + Quadrupole','UGC 11982',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155371,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155371,37.38,0.33,299,73413,70,NULL,NULL,'2MASX J22185407-0745358',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000171,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,334.7252917,-7.75997,0.145,NULL,49844366403,778818225,12169034,17.3),(155372,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 16236',NULL,155372,40.15,0.27,1070,73414,70,NULL,'SN photometric redshift distance, z photo =0.291 +/- 0.046','SDSS-II SN 16236',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.8g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,334.7354583,-0.51175,0.165,NULL,49809692987,778276452,12160569,21.8),(155373,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 16236','R',155373,41.62,0.28,1500,73414,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16236',0.405999,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155374,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 16236','R',155374,42.07,0.37,1850,73414,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16236',0.405999,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155375,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 18273','R',155375,40.97,0.23,1190,73415,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J221857.47-003748.9',0.3163,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',0.0001,NULL,'20.6g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,334.7394583,-0.63028,0.165,NULL,49809574520,778274601,12160540,20.6),(155376,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 18273','R',155376,41.08,0.29,1250,73415,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J221857.47-003748.9',0.3163,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155377,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 18273',NULL,155377,40.93,0.18,1530,73415,70,NULL,'SALT 2','SDSS J221857.47-003748.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155378,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 18273',NULL,155378,40.97,0.18,1560,73415,70,NULL,'SALT 2, Malmquist cor.','SDSS J221857.47-003748.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155379,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155379,35.14,0.52,107,73416,70,NULL,NULL,'2MASX J22185861-5356506',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.000077,NULL,'15.55',0.43,'S0',NULL,NULL,NULL,NULL,1,334.74425,-53.94742,0,NULL,48703179934,760987186,11890424,15.55),(155380,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155380,37.56,0.46,325,73417,70,NULL,NULL,'SDSS J221858.85+000209.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000136,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,334.7452083,0.03592,0.161,NULL,52145688493,814776382,12730880,18.7),(155381,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155381,37.38,0.33,299,73418,70,NULL,NULL,'SDSS J221859.11-074621.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,334.746333,-7.77253,0.145,NULL,49844367661,778818244,12169035,17.8),(155382,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155382,34.43,0.46,77,73419,70,NULL,NULL,'CGCG 428-072',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000158,NULL,'15.8g',0.37,'E','Pair member (points to parent)',NULL,NULL,NULL,1,334.7475,13.18747,0.165,NULL,52248094484,816376476,12755882,15.8),(155383,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 15627','RN',155383,38.8,0.33,525,73420,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15627',0.097708,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155384,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 15627','RN',155384,40.52,0.25,1160,73420,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15627',0.097708,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155385,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155385,37.83,0.33,369,73421,70,NULL,NULL,'2MASX J22190268-0047181',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00015,NULL,'17.71',0.2,NULL,NULL,NULL,NULL,NULL,1,334.761125,-0.78833,0.181,NULL,49810428510,778287945,12160749,17.71),(155386,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155386,38.09,0.46,415,73422,70,NULL,NULL,'2MASX J22190265-0913188',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000193,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,334.7612083,-9.22197,0.137,NULL,49829646532,778588227,12165441,17.3),(155387,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155387,34.18,0.4,68.7,73423,NULL,NULL,'mean','IC 1443',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000137,NULL,'13.76',1.2,'E2:',NULL,NULL,NULL,NULL,1,334.76525,-20.93992,0.073,NULL,50207798089,784496845,12257763,13.76),(155388,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155388,34.39,0.45,75.4,73423,NULL,NULL,'K','IC 1443',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155389,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155389,34.01,0.8,63.3,73424,75,NULL,'W91PP, r','UGC 11983',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'15.64',0.2,'Sbc',NULL,NULL,NULL,NULL,1,334.767166667,33.32944,0.381,NULL,55498930637,867170791,13549543,15.64),(155390,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155390,33.7,0.38,54.9,73424,75,NULL,'W91PP, r, raw','UGC 11983',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155391,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155391,33.73,0.38,55.8,73424,75,NULL,'W91PP, r, inv','UGC 11983',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155392,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155392,33.83,0.2,58.3,73424,74.4,NULL,NULL,'UGC 11983',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155393,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155393,33.99,0.49,62.7,73424,75,NULL,'IR','UGC 11983',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155394,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155394,34.04,0.38,64.3,73424,75,NULL,'W91PP, r, cor','UGC 11983',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155395,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155395,37.86,0.46,374,73425,70,NULL,NULL,'SDSS J221905.92-094932.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000147,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,334.774667,-9.82575,0.185,NULL,49832442021,778631906,12166123,18.4),(155396,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2002eb',NULL,155396,35.36,0.15,115,73426,70,NULL,'SALT 2','CGCG 473-011',0.027536,'2013MNRAS.433.2240G',2013,1,0.9,NULL,'G',0.000033,NULL,'15.30',0.5,'Sb','Isolated galaxy',NULL,NULL,NULL,1,334.77625,24.59819,0.241,NULL,51875506577,810554790,12664918,15.3),(155397,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2002eb','R',155397,35.42,0.04,121,73426,NULL,NULL,'MLCS2k2, R(V) = 3.1','CGCG 473-011',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155398,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2002eb','R',155398,35.43,0.03,122,73426,NULL,NULL,'MLCS2k2, R(V) = 1.8','CGCG 473-011',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155399,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2007su',NULL,155399,35.48,0.21,122,73427,73.8,NULL,'SALT 2 (SNANA)','SDSS J221908.85+131040.5',0.0267,'2014ApJ...795...44R',2014,1,0.17,NULL,'G',0.000089,NULL,'18.5g',0.09,NULL,NULL,NULL,NULL,NULL,1,334.786875,13.17792,0.165,NULL,52248093379,816376459,12755882,18.5),(155400,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155400,37.83,0.33,369,73428,70,NULL,NULL,'2MASX J22190962-0051041',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,334.790125,-0.85111,0.181,NULL,49810438540,778288102,12160751,17.8),(155401,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155401,36.97,0.49,248,73429,75,NULL,'IR','FGC 2402',NULL,'2011yCatp016004901K',2011,1,0.65,NULL,'G',NULL,NULL,'17.3',0.08,'Sc',NULL,NULL,NULL,NULL,1,334.7905,88.81233,0.333,NULL,52616990785,822140481,12845945,17.3),(155402,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155402,37.07,NULL,260,73429,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2402',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155403,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155403,37.1,NULL,264,73429,NULL,NULL,'Dipole + Quadrupole','FGC 2402',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155404,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155404,37.13,NULL,267,73429,NULL,NULL,NULL,'FGC 2402',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155405,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155405,37.14,NULL,268,73429,NULL,NULL,'Dipole','FGC 2402',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155406,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 05230','RN',155406,41.07,0.21,1240,73430,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 05230',0.322057,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155407,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 05230','RN',155407,41.09,0.25,1250,73430,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05230',0.322057,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155408,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 05230','N',155408,41.03,0.16,1610,73430,70,NULL,'SALT 2','SDSS-II SN 05230',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155409,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 05230','N',155409,41.07,0.16,1640,73430,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 05230',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155410,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 08226',NULL,155410,41.11,0.25,1660,73431,70,NULL,'SN photometric redshift distance, z photo =0.507 +/- 0.088','SDSS-II SN 08226',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,334.8172083,0.74911,0.129,NULL,52157389029,814959203,12733737,NULL),(155411,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155411,38.6,0.46,525,73432,70,NULL,NULL,'SDSS J221916.18-080145.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000153,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,334.817458333,-8.02944,0.145,NULL,49843387343,778802927,12168795,18.8),(155412,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155412,38.38,0.46,475,73433,70,NULL,NULL,'2MASX J22191936-0058411',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,334.830583,-0.978,0.177,NULL,49810396457,778287444,12160741,17.9),(155413,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155413,37.49,0.46,315,73434,70,NULL,NULL,'SDSS J221919.97+004820.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00014,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,334.83325,0.80561,0.129,NULL,52158103275,814970363,12733911,18.3),(155414,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155414,37.3,0.46,288,73435,70,NULL,NULL,'2MASX J22192055-0006298',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000178,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,334.835583333,-0.10825,0.145,NULL,49795831633,778059869,12157185,18.1),(155415,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 01981','RN',155415,38.94,0.17,580,73436,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01981',0.056828,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155416,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 01981','RN',155416,39.85,0.26,882,73436,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01981',0.056828,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155417,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005fe',NULL,155417,39.58,0.14,677,73437,74.2,NULL,'SALT 2','SDSS J221927.32+002938.8',0.217,'2010ApJ...716..712A',2010,1,0.07,NULL,'G',NULL,NULL,'21.0g',0.06,NULL,NULL,NULL,NULL,NULL,1,334.863833,0.49411,0.133,NULL,52157479837,814960622,12733759,21),(155418,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005fe',NULL,155418,39.81,0.08,751,73437,70,NULL,'SDSS-II SN 01316','SDSS J221927.32+002938.8',0.217,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155419,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 01316','R',155419,40.35,0.22,970,73437,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fe','SDSS J221927.32+002938.8',0.21,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155420,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 01316','R',155420,40.51,0.16,1050,73437,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fe','SDSS J221927.32+002938.8',0.21,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155421,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155421,33.85,0.8,58.8,73438,75,NULL,'W91PP, r','NGC 7253A',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00002,NULL,'14.4',0.5,'SABc','Pair member (points to parent)',NULL,NULL,NULL,1,334.865458333,29.39581,0.261,NULL,55445290989,866332671,13536447,14.4),(155422,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155422,33.72,0.49,55.6,73438,75,NULL,'IR','NGC 7253A',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155423,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155423,33.99,0.38,62.9,73438,75,NULL,'W91PP, r, raw','NGC 7253A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155424,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155424,34.18,0.38,68.6,73438,75,NULL,'W91PP, r, inv','NGC 7253A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155425,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155425,34.31,0.38,72.7,73438,75,NULL,'W91PP, r, cor','NGC 7253A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155426,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155426,36.86,0.46,235,73439,70,NULL,NULL,'2MASX J22192944-0110088',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000173,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,334.872583,-1.16914,0.177,NULL,49809802013,778278156,12160596,17.3),(155427,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 15122','RN',155427,40.22,0.3,1050,73440,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15122',0.056573,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155428,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 15122','RN',155428,41.41,0.55,1810,73440,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15122',0.056573,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155429,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155429,33.8,0.8,57.5,73441,75,NULL,'W91PP, r','NGC 7253B',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'13.2B',0.5,'S?','Pair member (points to parent)',NULL,NULL,NULL,1,334.875417,29.38778,0.261,NULL,55445290845,866332669,13536447,13.2),(155430,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155430,32.8,0.38,36.4,73441,75,NULL,'W91PP, r, inv','NGC 7253B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155431,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155431,32.81,0.38,36.5,73441,75,NULL,'W91PP, r, raw','NGC 7253B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155432,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155432,33.15,0.38,42.7,73441,75,NULL,'W91PP, r, cor','NGC 7253B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155433,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155433,36.51,0.46,201,73442,70,NULL,NULL,'2MASX J22193314-0846514',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000141,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,334.888125,-8.781,0.157,NULL,49843795601,778809306,12168895,17.5),(155434,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155434,34.04,0.8,64.2,73443,75,NULL,'MAT, I','IC 5199',NULL,'1997ApJS..109..333W',1997,1,1.61,NULL,'G',0.000033,NULL,'14.43',0.3,'SAb: sp        HII',NULL,NULL,NULL,NULL,1,334.888416667,-37.53381,0,NULL,50554905990,789920406,12342506,14.43),(155435,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155435,33.97,0.47,62.3,73443,NULL,NULL,'H','IC 5199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155436,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155436,33.99,0.43,62.8,73443,75,NULL,'MAT, I, raw','IC 5199',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155437,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155437,34.03,0.45,63.9,73443,NULL,NULL,'K','IC 5199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155438,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155438,34.05,0.4,64.5,73443,NULL,NULL,'mean','IC 5199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155439,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155439,34.08,0.49,65.5,73443,75,NULL,'IR','IC 5199',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155440,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155440,34.11,0.32,66.5,73443,85,NULL,'I, raw','IC 5199',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155441,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155441,34.12,0.46,66.6,73443,NULL,NULL,'J','IC 5199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155442,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155442,34.13,0.41,67.1,73443,NULL,NULL,'Malmquist cor.','IC 5199',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155443,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155443,34.14,0.41,67.2,73443,NULL,NULL,NULL,'IC 5199',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155444,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155444,34.16,0.32,68,73443,85,NULL,'I, inv','IC 5199',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155445,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155445,34.2,0.43,69.3,73443,75,NULL,'MAT, I, inv','IC 5199',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155446,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155446,34.24,0.43,70.6,73443,75,NULL,'MAT, I, cor','IC 5199',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155447,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155447,34.5,0.2,79.4,73443,74.4,NULL,NULL,'IC 5199',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155448,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155448,36.61,0.58,210,73444,70,NULL,NULL,'2MASX J22193484-6251212',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.000103,NULL,'16.31',0.42,'S',NULL,NULL,NULL,NULL,1,334.895125,-62.85589,0,NULL,48755505929,761804780,11903199,16.31),(155449,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155449,33.7,0.2,55,73445,74.4,NULL,NULL,'ESO 533- G 013',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000017,NULL,'15.38',0.2,'Sc',NULL,NULL,NULL,NULL,1,334.910166667,-25.33239,0.057,NULL,50066926109,782295720,12223370,15.38),(155450,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155450,33.8,0.55,57.6,73445,NULL,NULL,NULL,'ESO 533- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155451,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155451,33.84,0.49,58.5,73445,75,NULL,'IR','ESO 533- G 013',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155452,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155452,33.91,0.52,60.6,73445,NULL,NULL,'Malmquist cor.','ESO 533- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155453,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155453,37.13,0.33,267,73446,70,NULL,NULL,'SDSS J221941.36+122848.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000145,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,334.922375,12.48011,0.221,NULL,52245274299,816332410,12755193,18.1),(155454,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155454,36.16,0.46,171,73447,70,NULL,NULL,'2MASX J22194275+1346126',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,334.928125,13.77011,0.181,NULL,52246077523,816344961,12755390,17.1),(155455,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 13072','R',155455,40.29,0.21,930,73448,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006fi','SN 2006fi',0.230633,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,334.959417,0.02439,0.129,NULL,52145715104,814776798,12730887,NULL),(155456,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 13072','R',155456,40.32,0.16,940,73448,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006fi','SN 2006fi',0.230633,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155457,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155457,38.39,0.46,477,73449,70,NULL,NULL,'2MASX J22195432-0802322',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000188,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,334.976291667,-8.04228,0.165,NULL,49843526577,778805102,12168829,17.5),(155458,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 09652',NULL,155458,40.59,1,1310,73450,70,NULL,'SN photometric redshift distance, z photo =0.373 +/- 0.327','SDSS-II SN 09652',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','20.6g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,334.985583,-0.43767,0.165,NULL,49809608298,778275129,12160548,20.6),(155459,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 05641',NULL,155459,41.53,0.06,2030,73451,70,NULL,'SN photometric redshift distance, z photo =0.672 +/- 0.028','SDSS-II SN 05641',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','20.6g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,334.985583,-0.43767,0.165,NULL,49809608298,778275129,12160548,20.6),(155460,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 20156','RN',155460,43.67,0.28,3690,73452,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20156',0.468247,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155461,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155461,38.04,0.33,406,73453,70,NULL,NULL,'2MASX J22195707+1311438',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,334.9877917,13.19561,0.177,NULL,52248068206,816376065,12755876,18),(155462,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155462,37.13,0.33,267,73454,70,NULL,NULL,'2MASX J22200344+1226498',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000133,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,335.014417,12.44733,0.221,NULL,52245243456,816331929,12755186,17.5),(155463,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155463,37.76,0.46,357,73455,70,NULL,NULL,'SDSS J222006.54+001504.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,335.0272917,0.25119,0.137,NULL,52145905657,814779775,12730933,18.3),(155464,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155464,34.79,0.53,90.6,73456,NULL,NULL,NULL,'UGC 11987',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.00011,NULL,'15.18',0.3,'SB?',NULL,NULL,NULL,NULL,1,335.0332083,9.01769,0.233,NULL,52174408413,815225131,12737892,15.18),(155465,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155465,34.85,0.2,93.3,73456,74.4,NULL,NULL,'UGC 11987',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155466,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155466,34.93,0.49,96.9,73456,NULL,NULL,'Malmquist cor.','UGC 11987',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155467,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155467,38.04,0.46,406,73457,70,NULL,NULL,'2MASX J22200902-0926031',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,335.0375417,-9.43431,0.173,NULL,49829750366,778589849,12165466,18),(155468,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155468,38,0.33,399,73458,70,NULL,NULL,'2MASX J22200931-0847361',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000141,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,335.0389583,-8.79339,0.157,NULL,49843624825,778806637,12168853,17.9),(155469,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 18243',NULL,155469,40.14,0.2,1060,73459,70,NULL,'SN photometric redshift distance, z photo =0.289 +/- 0.033','SDSS-II SN 18243',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,335.044875,-0.74008,0.165,NULL,49809628629,778275447,12160553,NULL),(155470,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155470,36.79,0.58,228,73460,70,NULL,NULL,'2MASX J22201081-5658204',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.000103,NULL,'16.67',0.38,NULL,NULL,NULL,NULL,NULL,1,335.045167,-56.97225,0,NULL,48704671494,761010492,11890788,16.67),(155471,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155471,45.92,0.77,6550,73461,NULL,NULL,NULL,'GRB 071117',1.331,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,335.043917,-63.44331,0,NULL,48755080741,761798136,11903095,NULL),(155472,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SN 2006lm',NULL,155472,39.85,0.13,933,73462,70,NULL,'Hubble residual -0.19 for z0.27470','SDSS-II SN 15356 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,335.053333,0.40994,0.133,NULL,52145833452,814778647,12730916,NULL),(155473,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 15356','R',155473,40.55,0.22,1010,73462,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006lm','SDSS-II SN 15356 HOST',0.274927,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155474,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 15356','R',155474,40.79,0.16,1130,73462,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006lm','SDSS-II SN 15356 HOST',0.274927,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155475,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SN 2006lm',NULL,155475,40.42,0.12,1210,73462,70,NULL,'SALT 2','SDSS-II SN 15356 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155476,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SN 2006lm',NULL,155476,40.44,0.12,1220,73462,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15356 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155477,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155477,38.04,0.33,406,73463,70,NULL,NULL,'2MASX J22201282+1314488',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,335.0535,13.24689,0.177,NULL,52244531690,816320807,12755012,17.8),(155478,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155478,36.63,0.46,211,73464,70,NULL,NULL,'2MASX J22201851+1245347',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000162,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,335.07725,12.75958,0.189,NULL,52245186147,816331033,12755172,16.7),(155479,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','PTF10viq','N',155479,35.86,0.03,144,73465,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10viq',0.0342,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155480,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155480,34.09,0.47,65.9,73466,NULL,NULL,'H','UGC 11991',NULL,'2007A&A...465...71T',2007,1,1.8,'abs(b) < 10 degrees.','G',0.000033,NULL,'14.53',0.9,'Scd:',NULL,NULL,NULL,NULL,1,335.094583,47.70592,NULL,NULL,55539228230,867800441,13559381,14.53),(155481,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155481,34.16,0.46,68,73466,NULL,NULL,'J','UGC 11991',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155482,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155482,34.19,0.45,68.9,73466,NULL,NULL,'K','UGC 11991',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155483,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155483,34.33,0.4,73.3,73466,NULL,NULL,'mean','UGC 11991',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155484,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155484,38,0.33,399,73467,70,NULL,NULL,'2MASX J22202729-0849591',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,335.113833,-8.83322,0.165,NULL,49843628748,778806699,12168854,18.1),(155485,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155485,37.2,0.46,276,73468,70,NULL,NULL,'2MASX J22203058+0017469',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000161,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,335.127375,0.29653,0.137,NULL,52145941727,814780339,12730942,17.3),(155486,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155486,37.38,0.88,300,73469,70,NULL,NULL,'2MASX J22203125-1611156',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'17.07',0.4,NULL,NULL,NULL,NULL,NULL,1,335.1302083,-16.18772,0.073,NULL,50237712235,784964253,12265066,17.07),(155487,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 14811',NULL,155487,38.66,2.38,539,73470,70,NULL,'SN photometric redshift distance, z photo =0.135 +/- 0.353','SDSS-II SN 14811',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,335.133083,-0.76697,0.165,NULL,49810313879,778286154,12160721,NULL),(155488,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155488,38,0.46,398,73471,70,NULL,NULL,'2MASX J22203369-0847081',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,335.1405,-8.78561,0.165,NULL,49843903408,778810990,12168921,17.7),(155489,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155489,35.79,0.67,144,73472,70,NULL,NULL,'2MASX J22203456-0829361',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.3g',0.24,'S0',NULL,NULL,NULL,NULL,1,335.1440417,-8.49336,0.177,NULL,49844046782,778813230,12168956,16.3),(155490,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155490,37.13,0.46,266,73473,70,NULL,NULL,'2MASX J22203697+0000403',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,335.154125,0.01131,0.129,NULL,52145789846,814777966,12730905,17.9),(155491,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155491,34.01,0.49,63.4,73474,75,NULL,'IR','UGC 11993',NULL,'2011yCatp016004901K',2011,1,1.32,NULL,'G',0.001114,NULL,'16.0',0.16,'Scd',NULL,NULL,NULL,NULL,1,335.165417,35.22228,0.517,NULL,55485580529,866962195,13546284,16),(155492,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155492,34.84,NULL,93,73474,NULL,NULL,'Dipole','UGC 11993',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155493,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155493,34.85,NULL,93.1,73474,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11993',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155494,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155494,34.85,NULL,93.2,73474,NULL,NULL,'Dipole + Quadrupole','UGC 11993',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155495,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 08382','RN',155495,38.84,0.39,538,73475,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 08382',0.087041,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155496,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 08382','RN',155496,38.88,0.32,550,73475,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08382',0.087041,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155497,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 20396','RN',155497,43.48,0.4,3710,73476,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 20396',0.336125,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155498,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 20396','RN',155498,43.55,0.46,3840,73476,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20396',0.336125,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155499,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155499,33.79,0.45,57.2,73477,NULL,NULL,'K','NGC 7252',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000003,NULL,'12.74',1.6,'(R)SA(r)0^0^:  HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,335.1864583,-24.67828,0.049,NULL,50066706679,782292291,12223317,12.74),(155500,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155500,33.89,0.4,60.1,73477,NULL,NULL,'mean','NGC 7252',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155501,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155501,36.42,0.65,193,73478,70,NULL,NULL,'2MASX J22204571-5506093',NULL,'2014MNRAS.445.2677S',2014,1,0.8,'Loveday (1996,MNRAS,278,1025) position at midpoint of two galaxies.','G',0.00015,NULL,'15.36',0.53,'S0','Group member, 2nd ranked galaxy',NULL,NULL,NULL,1,335.190417,-55.10258,0,NULL,48703971570,760999555,11890618,15.36),(155502,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155502,33.67,0.2,54.2,73479,74.4,NULL,NULL,'UGC 11992',NULL,'2013AJ....146...86T',2013,1,0.88,NULL,'G',0.000003,NULL,'15.5g',0.59,'Sd:',NULL,NULL,NULL,NULL,1,335.197208333,14.23461,0.149,NULL,52364182686,818190354,12784224,15.5),(155503,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155503,37.99,0.33,396,73480,70,NULL,NULL,'2MASX J22204779+1319337',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00017,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,335.199125,13.32597,0.181,NULL,52244571412,816321428,12755022,17.9),(155504,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155504,38.59,0.46,522,73481,70,NULL,NULL,'2MASXi J2220518+121354',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000175,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,335.215625,12.23178,0.173,NULL,52244474629,816319916,12754998,18),(155505,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SN 2002dl',NULL,155505,34.34,0.2,72.5,73482,70,NULL,'SALT 2','UGC 11994',0.016251,'2013MNRAS.433.2240G',2013,1,2.69,NULL,'G',0.000033,NULL,'14.85',0.3,'Sc',NULL,NULL,NULL,NULL,1,335.221333,33.29533,0.385,NULL,55498875414,867169928,13549530,14.85),(155506,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155506,33.99,0.8,62.8,73482,75,NULL,'W91PP, r','UGC 11994',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155507,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155507,33.77,0.49,56.8,73482,75,NULL,'IR','UGC 11994',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155508,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155508,33.81,0.38,57.9,73482,75,NULL,'W91PP, r, raw','UGC 11994',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155509,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155509,33.87,0.47,59.3,73482,NULL,NULL,'H','UGC 11994',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155510,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155510,33.87,NULL,59.5,73482,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11994',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155511,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155511,33.87,NULL,59.5,73482,NULL,NULL,'Dipole + Quadrupole','UGC 11994',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155512,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155512,33.88,NULL,59.6,73482,NULL,NULL,'Dipole','UGC 11994',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155513,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155513,33.96,0.46,61.9,73482,NULL,NULL,'J','UGC 11994',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155514,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155514,33.96,NULL,62,73482,NULL,NULL,NULL,'UGC 11994',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155515,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155515,33.97,0.45,62.3,73482,NULL,NULL,'K','UGC 11994',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155516,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155516,33.99,0.38,62.8,73482,75,NULL,'W91PP, r, inv','UGC 11994',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155517,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155517,34.09,0.2,65.8,73482,74.4,NULL,NULL,'UGC 11994',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155518,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155518,34.11,0.43,66.4,73482,75,NULL,'3.6 micron, color corrected','UGC 11994',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155519,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155519,34.15,0.38,67.7,73482,75,NULL,'W91PP, r, cor','UGC 11994',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155520,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155520,34.16,0.4,68.1,73482,NULL,NULL,'mean','UGC 11994',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155521,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155521,34.18,0.43,68.7,73482,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11994',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155522,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155522,34.23,0.38,70.2,73482,NULL,NULL,NULL,'UGC 11994',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155523,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155523,34.33,0.37,73.4,73482,NULL,NULL,'Malmquist cor.','UGC 11994',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155524,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155524,30.29,0.8,11.4,73483,75,NULL,'MAT, I','IC 5201',NULL,'1997ApJS..109..333W',1997,1,8.5,'The APM position is 0.5 arcmin north of the center of the bar.','G',0.000007,NULL,'11.3',3.9,'SB(s)cd        Sy2','Group non-member, foreground',NULL,NULL,NULL,1,335.239333333,-46.03586,0,NULL,50695985424,792124772,12376949,11.3),(155525,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155525,29.38,0.4,7.5,73483,73,NULL,'opt','IC 5201',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155526,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155526,29.57,0.32,8.17,73483,85,NULL,'I, inv','IC 5201',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155527,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155527,29.6,0.32,8.29,73483,85,NULL,'I, raw','IC 5201',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155528,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155528,29.72,NULL,8.79,73483,NULL,NULL,NULL,'IC 5201',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155529,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155529,29.82,0.36,9.2,73483,NULL,NULL,NULL,'IC 5201',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155530,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155530,30,0.4,10,73483,NULL,NULL,'mean','IC 5201',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155531,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155531,30.07,0.53,10.3,73483,NULL,NULL,NULL,'IC 5201',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155532,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155532,30.09,0.43,10.4,73483,75,NULL,'3.6 micron, color + selection bias corrected','IC 5201',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155533,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155533,30.12,0.2,10.6,73483,74.4,NULL,NULL,'IC 5201',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155534,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155534,30.13,0.43,10.6,73483,75,NULL,'MAT, I, inv','IC 5201',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155535,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155535,30.17,0.43,10.8,73483,75,NULL,'MAT, I, raw','IC 5201',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155536,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155536,30.18,0.43,10.8,73483,75,NULL,'3.6 micron, color corrected','IC 5201',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155537,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155537,30.22,0.4,11.1,73483,75,NULL,'B','IC 5201',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155538,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155538,30.55,0.43,12.9,73483,75,NULL,'MAT, I, cor','IC 5201',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155539,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155539,30.69,0.4,13.7,73483,NULL,NULL,'Malmquist cor.','IC 5201',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155540,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155540,31.9,0.46,24,73483,NULL,NULL,'J','IC 5201',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155541,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155541,31.94,0.47,24.4,73483,NULL,NULL,'H','IC 5201',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155542,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155542,31.94,0.45,24.4,73483,NULL,NULL,'K','IC 5201',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155543,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 21172','RN',155543,40.96,0.56,1330,73484,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21172',0.171339,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155544,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 21172','RN',155544,41.6,0.8,1780,73484,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 21172',0.171339,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155545,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155545,37.99,0.33,396,73485,70,NULL,NULL,'2MASX J22205978+1326023',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000145,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,335.249125,13.43414,0.181,NULL,52244527584,816320743,12755011,17.8),(155546,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 07527','R',155546,40.36,0.17,955,73486,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07527',0.237,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,335.256333,-1.20414,0.177,NULL,49810148254,778283566,12160680,NULL),(155547,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 07527','R',155547,40.54,0.28,1040,73486,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07527',0.237,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155548,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 15345','R',155548,40.54,0.25,1000,73487,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15345',0.2802,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,335.25675,0.81053,0.153,NULL,52158138092,814970907,12733920,NULL),(155549,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 15345','R',155549,40.79,0.17,1120,73487,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15345',0.2802,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155550,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SN 2005mi',NULL,155550,39.37,0.13,613,73488,74.2,NULL,'SALT 2','SDSS J222102.65-004453.4',0.22,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,335.2610417,-0.74817,0.153,NULL,49809588272,778274816,12160544,NULL),(155551,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SN 2005mi',NULL,155551,39.88,0.05,776,73488,70,NULL,'SDSS-II SN 08495','SDSS J222102.65-004453.4',0.22,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155552,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SN 2005mi',NULL,155552,40.12,0.13,864,73488,65,NULL,'SALT2','SDSS J222102.65-004453.4',0.22,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155553,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 08495','R',155553,40.12,0.21,868,73488,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005mi','SDSS J222102.65-004453.4',0.22,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155554,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SN 2005mi',NULL,155554,40.28,0.13,932,73488,65,NULL,'MLCS2k2','SDSS J222102.65-004453.4',0.22,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155555,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 08495','R',155555,40.29,0.13,936,73488,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005mi','SDSS J222102.65-004453.4',0.22,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155556,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SN 2005mi',NULL,155556,40.05,0.1,1020,73488,70,NULL,'SALT 2','SDSS J222102.65-004453.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155557,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SN 2005mi',NULL,155557,40.07,0.1,1030,73488,70,NULL,'SALT 2, Malmquist cor.','SDSS J222102.65-004453.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155558,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 20397',NULL,155558,40.28,0.16,1140,73489,70,NULL,'SN photometric redshift distance, z photo =0.312 +/- 0.030','SDSS-II SN 20397',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,335.2727917,-1.06131,0.165,NULL,49810079591,778282493,12160663,NULL),(155559,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 07857','R',155559,41.33,0.27,1350,73490,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07857',0.371262,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,'PHOT','21.4g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,335.2780417,1.18522,0.173,NULL,52157680299,814963754,12733808,21.4),(155560,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 07857','R',155560,41.56,0.33,1500,73490,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07857',0.371262,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155561,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 07857',NULL,155561,40.97,0.22,1560,73490,70,NULL,'SN photometric redshift distance, z photo =0.466 +/- 0.068','SDSS-II SN 07857',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155562,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 07857',NULL,155562,41.47,0.21,1970,73490,70,NULL,'SALT 2','SDSS-II SN 07857',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155563,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 07857',NULL,155563,41.53,0.21,2020,73490,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 07857',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155564,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155564,37.73,0.46,352,73491,70,NULL,NULL,'2MASX J22210864-0105505',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000155,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,335.2860417,-1.09739,0.177,NULL,49810078698,778282479,12160663,17.5),(155565,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155565,37.62,0.46,334,73492,70,NULL,NULL,'2MASX J22210974-0835000',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,335.290541667,-8.58322,0.189,NULL,49844009264,778812644,12168947,17.7),(155566,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155566,38.17,0.46,431,73493,70,NULL,NULL,'2MASX J22211638-0903537',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000194,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,335.318333333,-9.065,0.165,NULL,49829774320,778590223,12165472,17.4),(155567,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15357',NULL,155567,40.2,0.25,1100,73494,70,NULL,'SN photometric redshift distance, z photo =0.299 +/- 0.045','SDSS-II SN 15357',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,335.3372917,0.23419,0.137,NULL,52145778279,814777785,12730902,NULL),(155568,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155568,38.11,0.46,418,73495,70,NULL,NULL,'2MASX J22212391-0805047',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,335.349625,-8.08467,0.173,NULL,49835269807,778676090,12166813,17.7),(155569,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155569,37.2,0.46,275,73496,70,NULL,NULL,'2MASX J22212657-0853227',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00015,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,335.3607083,-8.88953,0.165,NULL,49843868266,778810441,12168913,16.3),(155570,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155570,36.33,0.54,184,73497,70,NULL,NULL,'2MASX J22212716-0838497',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.00015,NULL,'15.7g',0.29,'S0/a',NULL,NULL,NULL,NULL,1,335.363125,-8.64717,0.189,NULL,49843994951,778812421,12168944,15.7),(155571,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02074','RN',155571,40.75,0.43,1100,73498,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02074',0.287541,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155572,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02074','RN',155572,40.82,0.33,1140,73498,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02074',0.287541,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155573,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155573,37.64,0.46,337,73499,70,NULL,NULL,'2MASXi J2221276+125609',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,335.364875,12.93625,0.185,NULL,52244649682,816322651,12755041,18.3),(155574,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155574,34.95,0.49,97.7,73500,75,NULL,'IR','UGC 11996',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',NULL,NULL,'16.5',0.1,'S?',NULL,NULL,NULL,NULL,1,335.368791667,12.50992,0.161,NULL,52244367175,816318237,12754972,16.5),(155575,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155575,37.31,0.33,290,73501,70,NULL,NULL,'SDSS J222130.35+001616.8',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00022,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,335.3765,0.27133,0.145,NULL,52146641627,814791275,12731113,18.1),(155576,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 16958',NULL,155576,40.22,0.39,1110,73502,70,NULL,'SN photometric redshift distance, z photo =0.303 +/- 0.074','SDSS-II SN 16958',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,335.380333333,-0.26911,0.141,NULL,49796705427,778073522,12157398,NULL),(155577,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 14227',NULL,155577,41.32,0.26,1840,73503,70,NULL,'SN photometric redshift distance, z photo =0.582 +/- 0.114','SDSS-II SN 14227',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,335.38425,-0.63161,0.153,NULL,49796805207,778075081,12157423,NULL),(155578,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155578,37.31,0.33,290,73504,70,NULL,NULL,'2MASX J22213246+0016455',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.31',0.32,'AGN',NULL,NULL,NULL,NULL,1,335.385125,0.27928,0.145,NULL,52146641418,814791272,12731113,16.31),(155579,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15313','RN',155579,43.13,0.25,2760,73505,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 15313',0.534226,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155580,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155580,36.35,0.67,186,73506,70,NULL,NULL,'2MASX J22213556-0658346',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'17.20',0.32,NULL,NULL,NULL,NULL,NULL,1,335.3982083,-6.97647,0.229,NULL,49836692688,778698323,12167161,17.2),(155581,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155581,35.97,0.52,156,73507,70,NULL,NULL,'2MASX J22213585-4845013',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'15.55',0.6,'S0',NULL,NULL,NULL,NULL,1,335.3994583,-48.75039,0,NULL,50693555008,792086797,12376356,15.55),(155582,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13317','RN',155582,41.34,0.15,1390,73508,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13317',0.331451,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155583,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13317','RN',155583,41.69,0.23,1630,73508,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13317',0.331451,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155584,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155584,37.23,0.33,279,73509,70,NULL,NULL,'SDSS J222139.86-082623.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,335.416125,-8.43992,0.201,NULL,49843938055,778811532,12168930,17.9),(155585,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155585,37.23,0.33,279,73510,70,NULL,NULL,'2MASX J22214017-0825266',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00015,NULL,'16.4g',0.33,'AGN',NULL,NULL,NULL,NULL,1,335.4175,-8.42389,0.201,NULL,49843941136,778811580,12168930,16.4),(155586,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 10411','RN',155586,43.23,0.39,2770,73511,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 10411',0.596841,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155587,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155587,37.71,0.46,348,73512,70,NULL,NULL,'2MASX J22214405-0854516',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,335.4334583,-8.91419,0.165,NULL,49843197735,778799964,12168749,17.6),(155588,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 06903','R',155588,40.27,0.22,905,73513,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J222146.45+005818.3',0.253,'2014arXiv1401.3317S',2014,1,0.1,NULL,'G',0.01,NULL,'19.6g',0.08,'BrClG',NULL,NULL,NULL,NULL,1,335.443583,0.97175,0.157,NULL,52146311784,814786121,12731033,19.6),(155589,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 06903','R',155589,40.44,0.16,976,73513,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J222146.45+005818.3',0.253,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155590,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 06903',NULL,155590,40.03,0.12,1010,73513,70,NULL,'SALT 2','SDSS J222146.45+005818.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155591,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 06903',NULL,155591,40.05,0.12,1020,73513,70,NULL,'SALT 2, Malmquist cor.','SDSS J222146.45+005818.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155592,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155592,32.62,0.49,33.5,73514,75,NULL,'IR','UGC 11999',NULL,'2011yCatp016004901K',2011,1,0.86,NULL,'G',0.000023,NULL,'17.',0.11,'Sdm',NULL,NULL,NULL,NULL,1,335.461708333,42.95119,1.193,NULL,55562580054,868165313,13565083,17),(155593,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155593,33.87,NULL,59.4,73514,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11999',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155594,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155594,33.89,NULL,60,73514,NULL,NULL,'Dipole + Quadrupole','UGC 11999',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155595,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155595,33.9,NULL,60.2,73514,NULL,NULL,'Dipole','UGC 11999',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155596,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155596,33.95,NULL,61.8,73514,NULL,NULL,NULL,'UGC 11999',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155597,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155597,36.98,0.46,249,73515,70,NULL,NULL,'2MASX J22215280+1352355',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000151,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,335.4699583,13.87661,0.165,NULL,52364072958,818188639,12784197,17.5),(155598,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155598,37.32,0.46,292,73516,70,NULL,NULL,'2MASX J22215567-0103191',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.17',0.18,NULL,NULL,NULL,NULL,NULL,1,335.482,-1.05531,0.165,NULL,49810094216,778282722,12160667,18.17),(155599,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155599,36.8,0.65,229,73517,70,NULL,NULL,'2MASX J22220249-6252327',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.67',0.35,NULL,NULL,NULL,NULL,NULL,1,335.5105,-62.87583,0,NULL,48755278529,761801227,11903144,16.67),(155600,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155600,34.86,0.47,93.6,73518,NULL,NULL,'Malmquist cor.','ESO 602- G 010',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.33',0.5,'Sb-c           HII',NULL,NULL,NULL,NULL,1,335.511625,-19.57306,0.049,NULL,50206379340,784474677,12257416,14.33),(155601,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155601,34.95,0.45,97.7,73518,NULL,NULL,NULL,'ESO 602- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155602,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155602,34.99,0.2,99.5,73518,74.4,NULL,NULL,'ESO 602- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155603,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155603,35.8,0.55,144,73519,NULL,NULL,'Malmquist cor.','AGC 320755',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',NULL,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,335.546667,2.93083,0.189,NULL,52159579182,814993424,12734272,14.6),(155604,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155604,35.83,0.54,147,73519,NULL,NULL,NULL,'AGC 320755',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155605,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155605,35.96,0.2,156,73519,74.4,NULL,NULL,'AGC 320755',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155606,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155606,33.67,0.8,54.2,73520,75,NULL,'W91PP, r','NGC 7264',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000033,NULL,'14.58',0.3,'Sb',NULL,NULL,NULL,NULL,1,335.557417,36.387,0.589,NULL,55483050250,866922660,13545666,14.58),(155607,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155607,33.9,0.4,60.1,73520,NULL,NULL,'mean','NGC 7264',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155608,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155608,34.18,0.38,68.4,73520,75,NULL,'W91PP, r, raw','NGC 7264',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155609,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155609,34.26,0.49,71,73520,75,NULL,'IR','NGC 7264',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155610,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155610,34.26,0.45,71.2,73520,NULL,NULL,'K','NGC 7264',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155611,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155611,34.27,0.46,71.6,73520,NULL,NULL,'J','NGC 7264',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155612,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155612,34.36,0.47,74.5,73520,NULL,NULL,'H','NGC 7264',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155613,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155613,34.42,0.38,76.7,73520,75,NULL,'W91PP, r, inv','NGC 7264',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155614,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155614,34.42,0.38,76.7,73520,75,NULL,'W91PP, r, cor','NGC 7264',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155615,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155615,34.58,0.4,82.6,73520,70,NULL,'H, UH88/IRSF/2MASS','NGC 7264',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155616,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155616,34.58,0.4,82.6,73520,70,NULL,'H, 2MASS','NGC 7264',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155617,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155617,34.7,0.43,87,73520,75,NULL,'3.6 micron, color corrected','NGC 7264',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155618,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155618,34.71,0.43,87.4,73520,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7264',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155619,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155619,34.79,0.2,90.8,73520,74.4,NULL,NULL,'NGC 7264',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155620,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155620,37.11,0.46,264,73521,70,NULL,NULL,'2MASX J22221389+1212464',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000138,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,335.5580417,12.21286,0.161,NULL,52361703076,818151610,12783618,17.4),(155621,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155621,37.82,0.75,366,73522,70,NULL,NULL,'2MASX J22221681-1015284',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.55',0.25,NULL,NULL,NULL,NULL,NULL,1,335.570083,-10.25789,0.129,NULL,49832020212,778625315,12166020,16.55),(155622,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 00700','RN',155622,42.48,0.21,1960,73523,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00700',0.595712,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155623,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155623,37.41,0.15,303,73524,70,NULL,NULL,'2MASX J22221969-0856074',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00015,NULL,'16.1g',0.43,'S0',NULL,NULL,NULL,NULL,1,335.582,-8.93533,0.189,NULL,49843165883,778799466,12168741,16.1),(155624,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155624,36.28,0.75,181,73525,70,NULL,NULL,'2MASX J22222109-0807494',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.0g',0.37,'S0/a',NULL,NULL,NULL,NULL,1,335.587833,-8.13058,0.213,NULL,49835539373,778680302,12166879,16),(155625,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155625,35.31,0.32,116,73526,NULL,NULL,'Malmquist cor.','2MASX J22222570+0244036',NULL,'2009ApJS..182..474S',2009,1,0.61,NULL,'G',NULL,NULL,'16.00',0.31,NULL,NULL,NULL,NULL,NULL,1,335.607166667,2.73436,0.185,NULL,52159616292,814994004,12734281,16),(155626,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155626,35.34,0.32,117,73526,NULL,NULL,NULL,'2MASX J22222570+0244036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155627,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155627,35.61,0.2,132,73526,74.4,NULL,NULL,'2MASX J22222570+0244036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155628,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155628,35.15,0.36,107,73527,NULL,NULL,NULL,'UGC 12000',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',NULL,NULL,'15.38',0.5,'S?',NULL,NULL,NULL,NULL,1,335.607166667,2.86047,0.189,NULL,52159590389,814993599,12734274,15.38),(155629,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155629,35.19,0.2,109,73527,74.4,NULL,NULL,'UGC 12000',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155630,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155630,35.22,0.35,111,73527,NULL,NULL,'Malmquist cor.','UGC 12000',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155631,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155631,37.52,0.33,320,73528,70,NULL,NULL,'SDSS J222228.33+142002.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000142,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,335.6180417,14.33397,0.129,NULL,52364608308,818197004,12784328,18.6),(155632,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05128','RN',155632,41.48,0.31,1480,73529,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05128',0.329451,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155633,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05128','RN',155633,42.34,0.31,2210,73529,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 05128',0.329451,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155634,'TRGB','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155634,29.52,0.1,8.02,73530,74.4,NULL,NULL,'ESO 238- G 005',NULL,'2013AJ....146...86T',2013,1,2.9,'The APMUKS data apply to the short bar.','G',0.00001,NULL,'15.6',1.3,'IABm',NULL,NULL,NULL,NULL,1,335.62525,-48.40489,0,NULL,50693609629,792087650,12376369,15.6),(155635,'Tully est','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155635,29.62,0.8,8.4,73530,75,NULL,NULL,'ESO 238- G 005',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155636,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155636,29.46,NULL,7.8,73530,NULL,NULL,NULL,'ESO 238- G 005',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155637,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 10072','RN',155637,40.74,0.07,1150,73531,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 10072',0.223609,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155638,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 10072','RN',155638,40.86,0.2,1220,73531,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 10072',0.223609,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155639,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155639,34.34,0.45,73.7,73532,70,NULL,NULL,'IC 5210',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000087,NULL,'14.21',1.1,'SA0-:','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,335.629625,-18.86969,0.049,NULL,50252415112,785193986,12268656,14.21),(155640,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155640,37.79,0.46,361,73533,70,NULL,NULL,'SDSS J222233.31-083807.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,335.638791667,-8.63533,0.201,NULL,49843119583,778798743,12168730,18.2),(155641,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 01985',NULL,155641,39.39,0.61,755,73534,70,NULL,'SN photometric redshift distance, z photo =0.195 +/- 0.074','SDSS-II SN 01985',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.3g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,335.640416667,1.04061,0.173,NULL,52146451066,814788297,12731067,21.3),(155642,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 01985','R',155642,40.55,0.28,1070,73534,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01985',0.201287,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155643,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155643,32.23,0.69,27.9,73535,100,NULL,'mid-IR','NGC 7254',NULL,'2013ApJ...771...88L',2013,1,1.4,NULL,'G',0.00001,NULL,'13.88',0.6,'S(r?)b',NULL,NULL,NULL,NULL,1,335.650958333,-21.73722,0.049,NULL,50213813702,784590839,12259231,13.88),(155644,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155644,34.05,0.54,64.4,73536,70,NULL,NULL,'NGC 7257',NULL,'2014MNRAS.445.2677S',2014,1,1.9,NULL,'G',0.000027,NULL,'13.66',1.4,'SAB(rs)bc      HII',NULL,NULL,NULL,NULL,1,335.651833333,-4.12075,0.149,NULL,49806749505,778230461,12159850,13.66),(155645,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155645,33.96,0.8,61.9,73536,75,NULL,'MAT, I','NGC 7257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155646,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155646,34.11,0.43,66.2,73536,75,NULL,'MAT, I, raw','NGC 7257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155647,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155647,34.18,0.32,68.4,73536,85,NULL,'I, raw','NGC 7257',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155648,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155648,34.24,0.32,70.5,73536,85,NULL,'I, inv','NGC 7257',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155649,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155649,34.25,0.21,70.7,73536,NULL,NULL,'Malmquist cor.','NGC 7257',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155650,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155650,34.29,0.4,72.3,73536,NULL,NULL,'mean','NGC 7257',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155651,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155651,34.31,0.43,72.7,73536,75,NULL,'MAT, I, cor','NGC 7257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155652,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155652,34.31,0.21,72.9,73536,NULL,NULL,NULL,'NGC 7257',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155653,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155653,34.34,0.2,73.8,73536,74.4,NULL,NULL,'NGC 7257',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155654,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155654,34.39,0.43,75.5,73536,75,NULL,'MAT, I, inv','NGC 7257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155655,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155655,34.45,0.45,77.6,73536,NULL,NULL,'K','NGC 7257',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155656,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155656,34.45,0.46,77.6,73536,NULL,NULL,'J','NGC 7257',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155657,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155657,34.45,0.47,77.8,73536,NULL,NULL,'H','NGC 7257',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155658,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155658,36.39,0.46,190,73537,70,NULL,NULL,'2MASX J22224039-0839523',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000149,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,335.668416667,-8.66447,0.201,NULL,49843123206,778798800,12168731,17.3),(155659,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 03172','RN',155659,40.61,0.24,1010,73538,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03172',0.316958,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155660,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 03172','RN',155660,40.71,0.37,1050,73538,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03172',0.316958,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155661,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155661,35.12,0.47,106,73539,70,NULL,NULL,'IC 5211',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000073,NULL,'14.69',0.7,'S?','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,335.679416667,-18.88022,0.049,NULL,50252304330,785192255,12268628,14.69),(155662,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155662,35.2,0.49,110,73540,75,NULL,'IR','ESO 467- G 047',NULL,'2011yCatp016004901K',2011,1,1,'Sometimes mistakenly called IC 5214.','G',0.000033,NULL,'15.22',0.2,'Sb?            HII',NULL,NULL,NULL,NULL,1,335.6810417,-27.35569,0,NULL,50546855851,789794622,12340540,15.22),(155663,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155663,35.48,0.4,125,73540,NULL,NULL,'Malmquist cor.','ESO 467- G 047',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155664,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155664,35.6,0.37,132,73540,NULL,NULL,NULL,'ESO 467- G 047',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155665,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155665,35.64,0.2,134,73540,74.4,NULL,NULL,'ESO 467- G 047',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155666,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 09278','RN',155666,42.71,0.32,2550,73541,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 09278',0.365207,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155667,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 09278','RN',155667,43.47,0.4,3620,73541,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 09278',0.365207,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155668,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155668,32.63,0.8,33.6,73542,75,NULL,'MAT, I','ESO 602- G 015',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000022,NULL,'15.35',0.3,'SB(s)c',NULL,NULL,NULL,NULL,1,335.711,-20.34983,0.033,NULL,50209885471,784529460,12258272,15.35),(155669,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155669,32.44,0.32,30.7,73542,85,NULL,'I, inv','ESO 602- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155670,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155670,32.48,0.32,31.3,73542,85,NULL,'I, raw','ESO 602- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155671,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155671,32.64,0.1,33.8,73542,NULL,NULL,NULL,'ESO 602- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155672,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155672,32.71,0.43,34.9,73542,75,NULL,'MAT, I, inv','ESO 602- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155673,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155673,32.81,0.43,36.4,73542,75,NULL,'MAT, I, raw','ESO 602- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155674,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155674,33.07,0.2,41.1,73542,74.4,NULL,NULL,'ESO 602- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155675,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155675,33.08,0.43,41.2,73542,75,NULL,'MAT, I, cor','ESO 602- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155676,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155676,33.14,0.4,42.5,73542,NULL,NULL,NULL,'ESO 602- G 015',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155677,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155677,33.22,0.43,44.1,73542,75,NULL,'3.6 micron, color corrected','ESO 602- G 015',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155678,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155678,33.34,0.43,46.5,73542,75,NULL,'3.6 micron, color + selection bias corrected','ESO 602- G 015',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155679,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155679,36.69,0.55,217,73543,70,NULL,NULL,'2MASX J22225293-1737491',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.00015,NULL,'16.50',0.18,NULL,NULL,NULL,NULL,NULL,1,335.7207083,-17.63042,0.053,NULL,50235553938,784930530,12264539,16.5),(155680,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155680,36,0.46,159,73544,70,NULL,NULL,'2MASX J22225305+1326593',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,335.721125,13.44978,0.185,NULL,52362437819,818163090,12783798,16.7),(155681,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155681,37.52,0.33,320,73545,70,NULL,NULL,'SDSS J222255.31+141703.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000139,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,335.7305,14.28433,0.129,NULL,52364143973,818189749,12784214,18),(155682,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155682,33.41,0.8,48.1,73546,75,NULL,'MAT, I','NGC 7258',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'13.92',0.6,'Sb:            HII',NULL,NULL,NULL,NULL,1,335.7419583,-28.34514,0,NULL,50542827131,789731673,12339557,13.92),(155683,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155683,33.14,0.32,42.4,73546,85,NULL,'I, raw','NGC 7258',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155684,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155684,33.17,0.32,43,73546,85,NULL,'I, inv','NGC 7258',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155685,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155685,33.26,0.43,45,73546,75,NULL,'MAT, I, raw','NGC 7258',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155686,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155686,33.42,0.43,48.3,73546,75,NULL,'MAT, I, inv','NGC 7258',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155687,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155687,33.52,0.47,50.6,73546,NULL,NULL,'H','NGC 7258',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155688,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155688,33.54,0.4,51,73546,NULL,NULL,'mean','NGC 7258',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155689,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155689,33.56,0.43,51.6,73546,75,NULL,'MAT, I, cor','NGC 7258',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155690,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155690,33.6,0.46,52.5,73546,NULL,NULL,'J','NGC 7258',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155691,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155691,33.61,0.45,52.8,73546,NULL,NULL,'K','NGC 7258',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155692,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155692,37.41,0.15,303,73547,70,NULL,NULL,'2MASX J22225951-0908008',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,335.747875,-9.13369,0.137,NULL,49829612359,778587693,12165432,17),(155693,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155693,37.3,0.46,289,73548,70,NULL,NULL,'2MASX J22225973-0800328',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000137,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,335.748917,-8.00919,0.217,NULL,49835657800,778682153,12166908,18),(155694,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155694,36.99,0.46,250,73549,70,NULL,NULL,'2MASX J22230145+1346284',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00018,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,335.756083,13.77464,0.185,NULL,52365346208,818208534,12784508,16.6),(155695,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155695,33.26,0.69,44.9,73550,100,NULL,'mid-IR','UGC 12012',NULL,'2013ApJ...771...88L',2013,1,1,NULL,'G',0.000033,NULL,'15.06',0.7,'Sb',NULL,NULL,NULL,NULL,1,335.760125,35.82086,0.493,NULL,55485752818,866964887,13546326,15.06),(155696,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155696,34.14,0.4,67.4,73550,NULL,NULL,'mean','UGC 12012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155697,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155697,34.44,0.47,77.4,73550,NULL,NULL,'H','UGC 12012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155698,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155698,34.54,0.46,81,73550,NULL,NULL,'J','UGC 12012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155699,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155699,34.56,0.45,81.6,73550,NULL,NULL,'K','UGC 12012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155700,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02125','RN',155700,41.56,0.09,1580,73551,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 02125',0.299129,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155701,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155701,32.47,0.8,31.1,73552,75,NULL,'MAT, I','ESO 027- G 008',NULL,'1997ApJS..109..333W',1997,1,2.7,NULL,'G',0.000033,NULL,'12.94',1.1,'SAB(s)c',NULL,NULL,NULL,NULL,1,335.7675,-79.99694,0.429,NULL,48569690226,758901409,11857834,12.94),(155702,'Sosies','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155702,32.44,0.08,30.8,73552,NULL,NULL,NULL,'ESO 027- G 008',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155703,'Tully est','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155703,31.68,0.8,21.7,73552,75,NULL,NULL,'ESO 027- G 008',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155704,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155704,32.15,0.43,26.9,73552,75,NULL,'MAT, I, raw','ESO 027- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155705,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155705,32.18,0.32,27.3,73552,85,NULL,'I, raw','ESO 027- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155706,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155706,32.22,0.32,27.8,73552,85,NULL,'I, inv','ESO 027- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155707,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155707,32.34,0.43,29.4,73552,75,NULL,'MAT, I, inv','ESO 027- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155708,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155708,32.46,0.43,31,73552,75,NULL,'MAT, I, cor','ESO 027- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155709,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155709,32.87,0.4,37.5,73552,73,NULL,'opt','ESO 027- G 008',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155710,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155710,32.9,0.42,38.1,73552,NULL,NULL,NULL,'ESO 027- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155711,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155711,32.95,0.2,38.9,73552,74.4,NULL,NULL,'ESO 027- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155712,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155712,32.95,0.41,39,73552,NULL,NULL,'Malmquist cor.','ESO 027- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155713,'SNII optical','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2009ip',NULL,155713,31.52,0.08,20.1,73553,NULL,NULL,NULL,'NGC 7259',NULL,'2013MNRAS.431L..98P',2013,1,1.1,'This pair is made up of ESO 467- G 050 + ESO 467- G 051.','G',0.000018,NULL,'13.88',0.9,'Sb','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,335.773,-28.95483,0,NULL,50544557815,789758715,12339979,13.88),(155714,'SNII optical','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2009ip','R',155714,31.52,0.08,20.1,73553,NULL,NULL,'Dense Shell Method (Baade ruler)','NGC 7259',NULL,'2013JETPL..98..432B',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155715,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155715,37.77,0.46,358,73554,70,NULL,NULL,'2MASX J22230652+0018277',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,335.77725,0.30767,0.153,NULL,52146155915,814783686,12730995,17.6),(155716,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155716,37.18,0.46,273,73555,70,NULL,NULL,'2MASX J22231032-0004119',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,335.793125,-0.06992,0.149,NULL,49796581769,778071590,12157368,18),(155717,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02513','RN',155717,41.7,0.24,1470,73556,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02513',0.493724,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155718,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155718,38.04,0.46,405,73557,70,NULL,NULL,'SDSS J222311.25+141000.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000127,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,335.796917,14.16669,0.129,NULL,52364169533,818190148,12784221,18.4),(155719,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20398','RN',155719,41.37,0.23,1480,73558,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 20398',0.266266,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155720,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20398','RN',155720,42.19,0.35,2170,73558,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20398',0.266266,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155721,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155721,38.01,0.46,400,73559,70,NULL,NULL,'2MASX J22231363-0927404',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000176,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,335.806875,-9.46131,0.137,NULL,49829552696,778586760,12165418,17.5),(155722,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155722,35.4,0.67,120,73560,70,NULL,NULL,'2MASX J22231469-6019495',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.93',0.27,NULL,NULL,NULL,NULL,NULL,1,335.811083,-60.33047,0,NULL,48802016024,762531500,11914554,16.93),(155723,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005li',NULL,155723,39.77,0.15,714,73561,74.2,NULL,'SALT 2','SDSS J222315.50+001513.3',0.26,'2010ApJ...716..712A',2010,1,0.08,NULL,'G',0.0005,NULL,'20.4g',0.07,NULL,NULL,NULL,NULL,NULL,1,335.814625,0.25369,0.157,NULL,52146208573,814784508,12731007,20.4),(155724,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005li',NULL,155724,39.91,0.17,957,73561,70,NULL,'Hubble residual -0.01 for z0.25690','SDSS J222315.50+001513.3',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155725,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005li',NULL,155725,40.51,0.19,1000,73561,65,NULL,'SALT2','SDSS J222315.50+001513.3',0.26,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155726,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005li',NULL,155726,40.51,0.17,1000,73561,70,NULL,'SDSS-II SN 09457, SALT 2','SDSS J222315.50+001513.3',0.26,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155727,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 09457','R',155727,40.52,0.23,1010,73561,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005li','SDSS J222315.50+001513.3',0.2569,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155728,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 09457','R',155728,40.65,0.2,1070,73561,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005li','SDSS J222315.50+001513.3',0.2569,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155729,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005li',NULL,155729,40.71,0.19,1100,73561,65,NULL,'MLCS2k2','SDSS J222315.50+001513.3',0.26,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155730,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005li',NULL,155730,40.76,0.07,1130,73561,70,NULL,'SDSS-II SN 09457','SDSS J222315.50+001513.3',0.26,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155731,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155731,31.74,0.8,22.3,73562,75,NULL,'MAT, I','ESO 467- G 051',NULL,'1997ApJS..109..333W',1997,1,3.64,NULL,'G',0.00001,NULL,'14.79',0.34,'Sdm','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,335.819208333,-28.98097,0,NULL,50544551775,789758621,12339978,14.79),(155732,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155732,30.89,0.32,15.1,73562,85,NULL,'I, inv','ESO 467- G 051',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155733,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155733,30.95,0.32,15.5,73562,85,NULL,'I, raw','ESO 467- G 051',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155734,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155734,31.24,0.43,17.7,73562,75,NULL,'MAT, I, inv','ESO 467- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155735,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155735,31.36,NULL,18.7,73562,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 467- G 051',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155736,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155736,31.38,0.43,18.9,73562,75,NULL,'MAT, I, raw','ESO 467- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155737,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155737,31.39,NULL,19,73562,NULL,NULL,'Dipole + Quadrupole','ESO 467- G 051',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155738,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155738,31.4,NULL,19,73562,NULL,NULL,'Dipole','ESO 467- G 051',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155739,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155739,31.45,NULL,19.5,73562,NULL,NULL,NULL,'ESO 467- G 051',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155740,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155740,31.72,0.43,22.1,73562,75,NULL,'MAT, I, cor','ESO 467- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155741,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155741,32.27,0.43,28.5,73563,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12010',NULL,'2014MNRAS.444..527S',2014,1,1,NULL,'G',0.000113,NULL,'15.33',0.2,'Sab',NULL,NULL,NULL,NULL,1,335.8280417,5.53386,0.245,NULL,52203190718,815674854,12744919,15.33),(155742,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155742,32.7,0.49,34.7,73563,75,NULL,'IR','UGC 12010',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155743,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 01776','RN',155743,41.19,0.31,1150,73564,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 01776',0.507319,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155744,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155744,37.18,0.55,273,73565,70,NULL,NULL,'2MASX J22232467-5743291',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'17.35',0.21,NULL,NULL,NULL,NULL,NULL,1,335.852958333,-57.72478,0,NULL,48674997696,760546839,11883544,17.35),(155745,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155745,37.41,0.15,303,73566,70,NULL,NULL,'SDSS J222326.25-090543.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000136,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,335.859375,-9.09542,0.141,NULL,49829407211,778584487,12165382,18.5),(155746,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155746,37.41,0.15,303,73567,70,NULL,NULL,'2MASX J22232625-0903214',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000154,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,335.8594583,-9.05608,0.141,NULL,49829405646,778584463,12165382,17.2),(155747,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155747,38.18,0.46,432,73568,70,NULL,NULL,'2MASX J22232639+0004573',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,335.86,0.08264,0.157,NULL,52145995296,814781176,12730955,18),(155748,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155748,35.16,0.45,107,73569,NULL,NULL,NULL,'IC 5207',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'15.13',0.9,'SA(s)c',NULL,NULL,NULL,NULL,1,335.8727083,-60.56497,0,NULL,48790430141,762350470,11911726,15.13),(155749,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155749,35.2,0.2,110,73569,74.4,NULL,NULL,'IC 5207',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155750,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155750,35.28,0.43,114,73569,NULL,NULL,'Malmquist cor.','IC 5207',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155751,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155751,37.1,0.46,263,73570,70,NULL,NULL,'2MASX J22232997-0112086',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,335.874875,-1.20233,0.145,NULL,49796118424,778064350,12157255,18.1),(155752,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155752,37.05,0.55,258,73571,70,NULL,NULL,'2MASX J22233236-6312014',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.000103,NULL,'15.82',0.63,'S0',NULL,NULL,NULL,NULL,1,335.8847917,-63.20039,0,NULL,48754928543,761795758,11903058,15.82),(155753,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155753,37.41,0.15,303,73572,70,NULL,NULL,'2MASX J22233254-0904374',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00015,NULL,'16.3g',0.39,'BrClG',NULL,NULL,NULL,NULL,1,335.8857083,-9.07719,0.141,NULL,49829438451,778584975,12165390,16.3),(155754,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 01903','RN',155754,39.82,0.06,846,73573,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01903',0.090148,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155755,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 01903','RN',155755,40.1,0.18,962,73573,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01903',0.090148,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155756,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155756,32.42,0.8,30.5,73574,75,NULL,'MAT, I','ESO 289- G 026',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000021,NULL,'14.33',1.3,'SB(s)cd',NULL,NULL,NULL,NULL,1,335.888458333,-42.27458,0,NULL,50730916689,792670573,12385477,14.33),(155757,'Tully est','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155757,32.41,0.8,30.3,73574,75,NULL,NULL,'ESO 289- G 026',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155758,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155758,31.29,0.32,18.1,73574,85,NULL,'I, inv','ESO 289- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155759,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155759,31.34,0.32,18.5,73574,85,NULL,'I, raw','ESO 289- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155760,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155760,31.61,0.4,21,73574,NULL,NULL,NULL,'ESO 289- G 026',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155761,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155761,31.61,0.4,21,73574,73,NULL,'opt','ESO 289- G 026',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155762,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155762,31.75,0.43,22.4,73574,75,NULL,'MAT, I, inv','ESO 289- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155763,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155763,31.84,0.43,23.3,73574,75,NULL,'MAT, I, raw','ESO 289- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155764,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155764,32.1,0.43,26.3,73574,75,NULL,'MAT, I, cor','ESO 289- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155765,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155765,32.48,0.1,31.4,73574,NULL,NULL,NULL,'ESO 289- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155766,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155766,36.47,0.58,197,73575,70,NULL,NULL,'2MASX J22233372-8019543',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'16.7b',0.23,NULL,NULL,NULL,NULL,NULL,1,335.8902083,-80.33175,0.441,NULL,48567452096,758866439,11857288,16.7),(155767,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155767,37.32,0.72,291,73576,70,NULL,NULL,'2MASX J22233643-5452382',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.95',0.33,NULL,NULL,NULL,NULL,NULL,1,335.901875,-54.87731,0,NULL,48701832569,760966133,11890095,16.95),(155768,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155768,34.73,0.8,88.3,73577,75,NULL,'W91PP, r','UGC 12018',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'14.73',0.4,'SBb?',NULL,NULL,NULL,NULL,1,335.904125,30.857,0.389,NULL,55493169442,867080772,13548137,14.73),(155769,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155769,34.39,0.38,75.7,73577,75,NULL,'W91PP, r, raw','UGC 12018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155770,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155770,34.6,0.38,83.3,73577,75,NULL,'W91PP, r, inv','UGC 12018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155771,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155771,34.65,0.38,85.1,73577,75,NULL,'W91PP, r, cor','UGC 12018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155772,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155772,34.74,0.34,88.6,73577,NULL,NULL,NULL,'UGC 12018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155773,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155773,34.74,0.49,88.8,73577,75,NULL,'IR','UGC 12018',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155774,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155774,34.74,0.34,88.9,73577,NULL,NULL,'Malmquist cor.','UGC 12018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155775,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155775,34.79,0.2,90.8,73577,74.4,NULL,NULL,'UGC 12018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155776,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155776,34.97,0.4,98.8,73577,NULL,NULL,'mean','UGC 12018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155777,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155777,35.12,0.47,106,73577,NULL,NULL,'H','UGC 12018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155778,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155778,35.17,0.45,108,73577,NULL,NULL,'K','UGC 12018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155779,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155779,35.27,0.46,113,73577,NULL,NULL,'J','UGC 12018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155780,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155780,36.71,0.46,220,73578,70,NULL,NULL,'2MASX J22233853-0747024',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,335.9105,-7.78403,0.209,NULL,49835091490,778673304,12166770,17.1),(155781,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155781,37.41,0.15,303,73579,70,NULL,NULL,'2MASX J22233853-0842104',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000177,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,335.910666667,-8.70294,0.145,NULL,49834667459,778666679,12166666,17.2),(155782,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155782,33,0.51,39.8,73580,70,NULL,NULL,'MCG -01-57-004',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.00002,NULL,'13.25',1.1,'S0^0^',NULL,NULL,NULL,NULL,1,335.913167,-3.43161,0.157,NULL,49806459687,778225932,12159780,13.25),(155783,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155783,37.41,0.15,303,73581,70,NULL,NULL,'2MASX J22234163-0840240',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000148,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,335.9234583,-8.67342,0.145,NULL,49834664023,778666625,12166666,17),(155784,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155784,37.84,0.46,369,73582,70,NULL,NULL,'2MASX J22234231-0934340',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00015,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,335.926167,-9.57606,0.137,NULL,49829568873,778587013,12165422,16.7),(155785,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155785,35.08,0.47,104,73583,NULL,NULL,'H','ESO 533- G 024',NULL,'2007A&A...465...71T',2007,1,1.4,'1996ApJS..107...97M has z = 0.021942 +- 0.000033.','G',0.000103,NULL,'13.96',0.7,'Sb-c           HII',NULL,NULL,NULL,NULL,1,335.92675,-26.61267,0,NULL,50064478972,782257483,12222773,13.96),(155786,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155786,35.08,0.4,104,73583,NULL,NULL,'mean','ESO 533- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155787,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155787,35.17,0.48,108,73583,NULL,NULL,'Malmquist cor.','ESO 533- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155788,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155788,35.19,0.46,109,73583,NULL,NULL,'J','ESO 533- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155789,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155789,35.24,0.45,112,73583,NULL,NULL,'K','ESO 533- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155790,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155790,35.32,0.45,116,73583,NULL,NULL,NULL,'ESO 533- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155791,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155791,35.36,0.2,118,73583,74.4,NULL,NULL,'ESO 533- G 024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155792,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155792,36.04,0.67,161,73584,70,NULL,NULL,'2MASX J22234415-7317177',NULL,'2014MNRAS.445.2677S',2014,1,0.31,NULL,'G',0.00015,NULL,'16.3b',0.23,NULL,NULL,NULL,NULL,NULL,1,335.93425,-73.28825,0.053,NULL,48414849276,756482019,11820031,16.3),(155793,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155793,37.41,0.15,303,73585,70,NULL,NULL,'2MASX J22234710-0910090',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,335.9462917,-9.16914,0.141,NULL,49829434778,778584918,12165389,17.4),(155794,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155794,34.7,0.4,87.3,73586,NULL,NULL,'mean','UGC 12020',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000023,NULL,'15.00',1.3,'SBa',NULL,NULL,NULL,NULL,1,335.947083,35.38994,0.517,NULL,55485845775,866966340,13546349,15),(155795,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155795,35.17,0.45,108,73586,NULL,NULL,'K','UGC 12020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155796,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155796,35.2,0.47,110,73586,NULL,NULL,'H','UGC 12020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155797,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155797,35.27,0.46,113,73586,NULL,NULL,'J','UGC 12020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155798,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155798,34.71,0.8,87.4,73587,75,NULL,'W91PP, r','NGC 7270',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000033,NULL,'14.88',0.6,'S?             HII','Group member',NULL,NULL,NULL,1,335.9480417,32.40303,0.325,NULL,55495102266,867110972,13548608,14.88),(155799,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155799,34.94,0.4,97.3,73587,NULL,NULL,'mean','NGC 7270',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155800,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155800,35.15,0.46,107,73587,NULL,NULL,'J','NGC 7270',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155801,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155801,35.17,0.47,108,73587,NULL,NULL,'H','NGC 7270',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155802,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155802,35.24,0.45,111,73587,NULL,NULL,'K','NGC 7270',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155803,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155803,35.31,0.38,116,73587,75,NULL,'W91PP, r, raw','NGC 7270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155804,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155804,35.44,0.38,123,73587,75,NULL,'W91PP, r, cor','NGC 7270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155805,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155805,35.65,0.38,135,73587,75,NULL,'W91PP, r, inv','NGC 7270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155806,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155806,33.45,NULL,49,73588,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2388',NULL,'2010Ap&SS.325..163P',2010,1,0.77,NULL,'G',0.000009,NULL,'16.7',0.1,'Sdm',NULL,NULL,NULL,NULL,1,335.96,6.89806,0.253,NULL,52169132221,815142690,12736604,16.7),(155807,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155807,33.48,NULL,49.7,73588,NULL,NULL,'Dipole + Quadrupole','FGC 2388',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155808,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155808,33.51,NULL,50.2,73588,NULL,NULL,'Dipole','FGC 2388',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155809,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155809,33.71,NULL,55.2,73588,NULL,NULL,NULL,'FGC 2388',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155810,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155810,37.41,0.15,303,73589,70,NULL,NULL,'2MASX J22235505-0851130',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,335.979333,-8.85364,0.141,NULL,49834677400,778666834,12166669,17.2),(155811,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05233','RN',155811,41.87,0.23,1940,73590,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 05233',0.217327,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155812,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05233','RN',155812,41.99,0.35,2060,73590,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 05233',0.217327,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155813,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155813,35.61,0.51,133,73591,70,NULL,NULL,'MCG -02-57-001',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.5',0.2,NULL,NULL,NULL,NULL,NULL,1,335.9999583,-11.14139,0.141,NULL,50349156905,786705576,12292274,15.5),(155814,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15340','R',155814,39.31,0.11,633,73592,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006mu','SN 2006mu',0.1475,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,336.002833333,0.82136,0.145,NULL,52146802507,814793789,12731152,NULL),(155815,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15340','R',155815,39.41,0.21,663,73592,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006mu','SN 2006mu',0.1475,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155816,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15936','RN',155816,44.65,0.73,6610,73593,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 15936',0.284505,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155817,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15936','RN',155817,44.72,1.21,6840,73593,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 15936',0.284505,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155818,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155818,34.66,0.8,85.5,73594,75,NULL,'W91PP, r','UGC 12022',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.89',0.5,'Sbc',NULL,NULL,NULL,NULL,1,336.0117083,33.43692,0.341,NULL,55496699946,867135936,13548999,14.89),(155819,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155819,34.58,0.38,82.3,73594,75,NULL,'W91PP, r, raw','UGC 12022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155820,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155820,34.68,0.37,86.2,73594,NULL,NULL,'Malmquist cor.','UGC 12022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155821,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155821,34.7,0.36,87.1,73594,NULL,NULL,NULL,'UGC 12022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155822,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155822,34.75,0.38,89.2,73594,75,NULL,'W91PP, r, cor','UGC 12022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155823,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155823,34.76,0.2,89.5,73594,74.4,NULL,NULL,'UGC 12022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155824,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155824,34.76,0.38,89.6,73594,75,NULL,'W91PP, r, inv','UGC 12022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155825,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155825,34.79,0.49,90.6,73594,75,NULL,'IR','UGC 12022',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155826,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155826,34.88,0.4,94.5,73594,NULL,NULL,'mean','UGC 12022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155827,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155827,35.09,0.47,104,73594,NULL,NULL,'H','UGC 12022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155828,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155828,35.15,0.45,107,73594,NULL,NULL,'K','UGC 12022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155829,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155829,36,0.56,159,73595,70,NULL,NULL,'2MASX J22240855-6913110',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.78',0.36,'E',NULL,NULL,NULL,NULL,1,336.035625,-69.21972,0.013,NULL,49324085375,770688833,12042013,16.78),(155830,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 17924','RN',155830,38.66,0.2,471,73596,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 17924',0.145721,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155831,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 17924','RN',155831,38.96,0.13,539,73596,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 17924',0.145721,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155832,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155832,34.64,0.4,84.7,73597,NULL,NULL,'mean','NGC 7274',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00009,NULL,'13.77',1.5,'E','Triplet member, first-ranked galaxy',NULL,NULL,NULL,1,336.046291667,36.12586,0.489,NULL,55482941314,866920958,13545639,13.77),(155833,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155833,35.25,0.45,112,73597,NULL,NULL,'K','NGC 7274',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155834,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155834,37.28,0.46,286,73598,70,NULL,NULL,'2MASXi J2224113+142139',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,336.0475,14.36086,0.145,NULL,52364905598,818201649,12784400,18),(155835,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155835,34.19,0.4,68.9,73599,NULL,NULL,'Malmquist cor.','UGC 12021',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.97',0.5,'Sb',NULL,NULL,NULL,NULL,1,336.048375,6.00361,0.273,NULL,52202414001,815662718,12744729,14.97),(155836,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155836,34.21,0.2,69.5,73599,74.4,NULL,NULL,'UGC 12021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155837,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155837,34.27,0.38,71.5,73599,NULL,NULL,NULL,'UGC 12021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155838,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155838,38.13,0.46,422,73600,70,NULL,NULL,'2MASX J22241201+1426324',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,336.05,14.44236,0.161,NULL,52364458390,818194662,12784291,17.8),(155839,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 19731','RN',155839,40.37,0.26,1040,73601,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19731',0.144637,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155840,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 19731','RN',155840,41.08,0.4,1430,73601,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19731',0.144637,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155841,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155841,36,0.51,158,73602,70,NULL,NULL,'2MASX J22241661-8026098',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'16.1b',0.22,NULL,NULL,NULL,NULL,NULL,1,336.0692917,-80.43589,0.425,NULL,48567639618,758869369,11857333,16.1),(155842,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155842,33.72,0.49,55.5,73603,75,NULL,'IR','NGC 7275',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000033,NULL,'15.17',0.2,'Sa','Group member',NULL,NULL,NULL,1,336.0717917,32.44625,0.325,NULL,55491956199,867061815,13547840,15.17),(155843,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155843,34.74,0.47,88.8,73603,NULL,NULL,'H','NGC 7275',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155844,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155844,34.88,0.46,94.5,73603,NULL,NULL,'J','NGC 7275',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155845,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155845,34.89,0.4,94.9,73603,NULL,NULL,'mean','NGC 7275',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155846,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155846,34.91,0.45,96.1,73603,NULL,NULL,'K','NGC 7275',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155847,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155847,38.08,0.46,412,73604,70,NULL,NULL,'2MASX J22241910-0957159',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,336.079625,-9.95442,0.141,NULL,50351444803,786741325,12292833,18),(155848,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155848,37.49,0.46,315,73605,70,NULL,NULL,'2MASX J22242021-0835469',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000178,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,336.084208333,-8.59642,0.149,NULL,49834725249,778667582,12166680,16.9),(155849,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155849,31.34,0.47,18.6,73606,NULL,NULL,'H','NGC 7267',NULL,'2007A&A...465...71T',2007,1,1.6,'Position in 1997AJ....113.1548C is incorrect.','G',0.00004,NULL,'13.23',1.3,'(R\'_1)SB(rs)a  HII',NULL,NULL,NULL,NULL,1,336.090875,-33.69408,0,NULL,50599015706,790609620,12353275,13.23),(155850,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155850,31.47,0.46,19.7,73606,NULL,NULL,'J','NGC 7267',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155851,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155851,31.5,0.45,19.9,73606,NULL,NULL,'K','NGC 7267',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155852,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155852,32.74,0.4,35.3,73606,NULL,NULL,'mean','NGC 7267',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155853,'CMD','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155853,21.56,0.2,0.205,73607,NULL,NULL,NULL,'Pegasus III',NULL,'2015ApJ...804L..44K',2015,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,349.261583333,9.81156,0.097,1,51742450353,808475786,12632434,NULL),(155854,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155854,34.54,0.6,80.9,73608,NULL,NULL,NULL,'VV 483',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000017,NULL,'15.3',0.3,NULL,NULL,NULL,NULL,NULL,1,336.0972917,18.07144,0.209,NULL,52370607765,818290746,12785792,15.3),(155855,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155855,34.58,0.2,82.4,73608,74.4,NULL,NULL,'VV 483',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155856,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155856,35.05,0.47,102,73608,NULL,NULL,'Malmquist cor.','VV 483',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155857,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155857,35.82,0.62,146,73609,70,NULL,NULL,'2MASX J22242651-8011078',NULL,'2014MNRAS.445.2677S',2014,1,0.21,NULL,'G',0.00015,NULL,'16.9b',0.19,NULL,NULL,NULL,NULL,NULL,1,336.110875,-80.18547,0.441,NULL,48569751171,758902362,11857849,16.9),(155858,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 03177','RN',155858,39.58,0.24,718,73610,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03177',0.147618,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155859,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 03177','RN',155859,39.62,0.17,732,73610,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03177',0.147618,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155860,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 16711','RN',155860,41.93,0.37,1820,73611,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16711',0.339034,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155861,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 14475','RN',155861,38.76,0.11,494,73612,70,NULL,'SDSS CAND. SNIc; MLCS2K2','SDSS-II SN 14475',0.144045,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155862,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 14475','RN',155862,38.99,0.19,548,73612,70,NULL,'SDSS CAND. SNIc; SALT 2','SDSS-II SN 14475',0.144045,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155863,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155863,37.18,0.46,273,73613,70,NULL,NULL,'2MASX J22243211-0915299',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,336.133917,-9.25831,0.141,NULL,50350584831,786727887,12292623,17.9),(155864,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155864,35.24,0.55,112,73614,70,NULL,NULL,'MCG -01-57-008',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000047,NULL,'15.25',0.5,'SBb',NULL,NULL,NULL,NULL,1,336.13675,-4.75181,0.181,NULL,49804014068,778187719,12159183,15.25),(155865,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155865,37.55,0.46,324,73615,70,NULL,NULL,'SDSS J222435.22+131616.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000148,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,336.146791667,13.27125,0.193,NULL,52362511393,818164240,12783816,18.6),(155866,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05797','RN',155866,42.15,0.19,2130,73616,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 05797',0.260602,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155867,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05797','RN',155867,42.22,0.2,2200,73616,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05797',0.260602,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155868,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13344','RN',155868,40.24,0.26,925,73617,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13344',0.207977,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155869,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13344','RN',155869,40.42,0.21,1000,73617,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13344',0.207977,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155870,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155870,36.15,0.46,170,73618,70,NULL,NULL,'2MASX J22244636+1356550',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,336.193167,13.94861,0.181,NULL,52365840934,818216264,12784629,16.9),(155871,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155871,37.38,0.46,299,73619,70,NULL,NULL,'2MASX J22244717-0835144',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000142,NULL,'17.0g',0.32,NULL,NULL,NULL,NULL,NULL,1,336.196541667,-8.58733,0.149,NULL,50358025860,786844154,12294439,17),(155872,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 01136','RN',155872,39.64,0.19,760,73620,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 01136',0.11268,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155873,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20548','RN',155873,41.33,0.29,1570,73621,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20548',0.172999,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155874,'D-Sigma','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155874,35.25,0.4,112,73622,75,NULL,'Edat, raw','ESO 467- G 054',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000067,NULL,'14.89',0.6,'S0-',NULL,NULL,NULL,NULL,1,336.2107083,-31.32581,0,NULL,50589341034,790458453,12350913,14.89),(155875,'D-Sigma','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155875,35.59,0.4,131,73622,75,NULL,'Edat, cor','ESO 467- G 054',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155876,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155876,36.08,0.47,165,73623,70,NULL,NULL,'2MASX J22245142-5825363',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000103,NULL,'15.59',1,'E3:',NULL,NULL,NULL,NULL,1,336.2142083,-58.42669,0,NULL,48675528191,760555127,11883673,15.59),(155877,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 00703','R',155877,40.8,0.24,1110,73624,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J222452.32+003902.8',0.3,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',0.01,NULL,'21.9g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,336.218,0.65081,0.161,NULL,52147168764,814799511,12731242,21.9),(155878,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 00703','R',155878,40.86,0.17,1140,73624,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J222452.32+003902.8',0.3,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155879,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 00703',NULL,155879,40.69,0.14,1370,73624,70,NULL,'SALT 2','SDSS J222452.32+003902.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155880,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 00703',NULL,155880,40.72,0.14,1390,73624,70,NULL,'SALT 2, Malmquist cor.','SDSS J222452.32+003902.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155881,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155881,37.35,0.46,295,73625,70,NULL,NULL,'2MASX J22245359-0856234',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000143,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,336.223375,-8.93997,0.141,NULL,50357925437,786842584,12294415,17.4),(155882,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 16831','RN',155882,41.59,0.33,1440,73626,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16831',0.446155,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155883,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 16831','RN',155883,41.97,0.44,1720,73626,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16831',0.446155,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155884,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155884,36.7,0.88,218,73627,70,NULL,NULL,'2MASX J22245614-4355163',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00015,NULL,'16.83',0.23,NULL,NULL,NULL,NULL,NULL,1,336.2339583,-43.92117,0,NULL,50727259052,792613422,12384584,16.83),(155885,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 03506',NULL,155885,39.33,0.21,734,73628,70,NULL,'SN photometric redshift distance, z photo =0.189 +/- 0.022','SDSS-II SN 03506',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,336.250625,-0.97822,0.137,NULL,49798798555,778106227,12157909,NULL),(155886,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155886,38.17,0.46,431,73629,70,NULL,NULL,'2MASX J22250276-0733044',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000186,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,336.261625,-7.55128,0.225,NULL,49834888923,778670139,12166720,17.5),(155887,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05114','RN',155887,42.9,0.26,2430,73630,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05114',0.565177,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155888,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155888,38.21,0.23,439,73631,70,NULL,NULL,'2MASX J22250505+1336008',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000172,NULL,'17.4g',0.24,'BrClG',NULL,NULL,NULL,NULL,1,336.2712083,13.60011,0.161,NULL,52365500103,818210939,12784545,17.4),(155889,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155889,38.21,0.23,439,73632,70,NULL,NULL,'SDSS J222505.25+133742.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000169,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,336.271916667,13.62839,0.161,NULL,52365498314,818210911,12784545,18.7),(155890,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155890,43.16,0.23,2540,73633,NULL,NULL,NULL,'GRB 080916',0.689,'2010JCAP...08..020W',2010,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,336.276375,-57.02297,0,NULL,48696739933,760886561,11888852,NULL),(155891,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155891,35.94,0.5,154,73634,70,NULL,NULL,'ESO 048- G 022',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.0001,NULL,'14.87',0.9,'S0',NULL,NULL,NULL,NULL,1,336.27925,-72.58822,0.025,NULL,48410967345,756421364,11819083,14.87),(155892,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155892,37.02,0.9,253,73635,70,NULL,NULL,'2MASX J22250713-0206292',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.44',0.22,NULL,NULL,NULL,NULL,NULL,1,336.2797083,-2.10811,0.137,NULL,49808859688,778263432,12160366,16.44),(155893,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155893,38.21,0.23,439,73636,70,NULL,NULL,'2MASX J22250896+1334548',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,336.2875,13.58203,0.161,NULL,52365497268,818210894,12784545,18.1),(155894,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 07529','RN',155894,41.51,0.32,1540,73637,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 07529',0.300125,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155895,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 07529','RN',155895,42.29,0.41,2210,73637,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07529',0.300125,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155896,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13827','RN',155896,41.4,0.17,1670,73638,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13827',0.142747,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155897,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13827','RN',155897,41.71,0.22,1920,73638,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13827',0.142747,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155898,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155898,36.2,0.56,174,73639,70,NULL,NULL,'2MASX J22251609-5915234',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'16.29',0.35,'S0',NULL,NULL,NULL,NULL,1,336.3170417,-59.2565,0,NULL,48798363487,762474429,11913662,16.29),(155899,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155899,37.69,0.46,345,73640,70,NULL,NULL,'2MASXi J2225168-081002',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00014,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,336.3202917,-8.16747,0.141,NULL,50358517376,786851834,12294559,17.8),(155900,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155900,37.31,0.46,290,73641,70,NULL,NULL,'2MASX J22252187-0014438',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,336.341125,-0.24564,0.181,NULL,49795071762,778047996,12156999,18.3),(155901,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155901,38.21,0.23,439,73642,70,NULL,NULL,'2MASX J22252214+1340109',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,336.34225,13.66964,0.161,NULL,52365555344,818211802,12784559,17.5),(155902,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155902,37.66,0.27,340,73643,70,NULL,NULL,'2MASX J22252324-0842036',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,336.346916667,-8.701,0.149,NULL,50358116927,786845576,12294462,17.5),(155903,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 16402','R',155903,40.32,0.24,900,73644,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006sv','SN 2006sv',0.29,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,336.3677083,0.26528,0.149,NULL,52144158508,814752476,12730507,NULL),(155904,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 16402','R',155904,40.72,0.13,1080,73644,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006sv','SN 2006sv',0.29,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155905,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155905,37.66,0.27,340,73645,70,NULL,NULL,'2MASX J22252884-0843406',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00015,NULL,'16.3g',0.32,'S0^-',NULL,NULL,NULL,NULL,1,336.3700417,-8.72794,0.149,NULL,50358118792,786845606,12294462,16.3),(155906,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 01987','RN',155906,43.09,0.24,2560,73646,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01987',0.62478,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155907,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155907,35.34,NULL,117,73647,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2390',NULL,'2010Ap&SS.325..163P',2010,1,0.92,NULL,'G',0.000017,NULL,'16.0',0.11,'Sdm',NULL,NULL,NULL,NULL,1,336.3875,18.99547,0.181,NULL,52407587476,818868554,12794821,16),(155908,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155908,35.36,NULL,118,73647,NULL,NULL,'Dipole + Quadrupole','FGC 2390',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155909,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155909,35.37,NULL,119,73647,NULL,NULL,'Dipole','FGC 2390',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155910,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155910,35.42,NULL,121,73647,NULL,NULL,NULL,'FGC 2390',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155911,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155911,35.5,0.49,126,73647,75,NULL,'IR','FGC 2390',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155912,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155912,35.01,0.48,100,73648,NULL,NULL,'Malmquist cor.','ESO 533- G 026',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'14.62',0.5,'Sb:',NULL,NULL,NULL,NULL,1,336.391541667,-24.2415,0.041,NULL,50065554458,782274288,12223035,14.62),(155913,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155913,35.04,0.47,102,73648,NULL,NULL,NULL,'ESO 533- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155914,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155914,35.2,0.2,110,73648,74.4,NULL,NULL,'ESO 533- G 026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155915,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155915,37.18,0.46,273,73649,70,NULL,NULL,'2MASX J22253454-0938576',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00015,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,336.394,-9.64931,0.153,NULL,50350697940,786729655,12292650,16.5),(155916,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13050','RN',155916,43.96,0.39,4090,73650,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 13050',0.510429,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155917,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155917,38.01,0.46,399,73651,70,NULL,NULL,'SDSS J222536.59-002908.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00014,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,336.4024583,-0.48578,0.153,NULL,49798609694,778103276,12157863,18.8),(155918,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15663',NULL,155918,40.1,0.2,1050,73652,70,NULL,'SN photometric redshift distance, z photo =0.283 +/- 0.033','SDSS-II SN 15663',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.4g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,336.40725,1.22953,0.141,NULL,52147612487,814806445,12731350,21.4),(155919,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15663','R',155919,40.68,0.24,1060,73652,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15663',0.292197,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155920,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15663','R',155920,40.87,0.19,1160,73652,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15663',0.292197,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155921,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15663',NULL,155921,40.57,0.15,1300,73652,70,NULL,'SALT 2','SDSS-II SN 15663',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155922,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15663',NULL,155922,40.6,0.15,1320,73652,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15663',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155923,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155923,35.46,0.49,123,73653,75,NULL,'IR','FGC 2391',NULL,'2011yCatp016004901K',2011,1,0.95,NULL,'G',0.000067,NULL,'16.52',0.12,'Scd',NULL,NULL,NULL,NULL,1,336.434583,39.40219,0.589,NULL,55558574136,868102720,13564105,16.52),(155924,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155924,38.04,0.46,406,73654,70,NULL,NULL,'2MASX J22254796-0954188',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000177,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,336.4497917,-9.90519,0.153,NULL,50351397364,786740583,12292821,17.4),(155925,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02092','RN',155925,39.15,0.3,592,73655,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 02092',0.143391,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155926,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02092','RN',155926,39.56,0.32,713,73655,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 02092',0.143391,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155927,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155927,33.19,0.2,43.5,73656,74.4,NULL,NULL,'NGC 7282',NULL,'2013AJ....146...86T',2013,1,2.5,NULL,'G',0.000037,NULL,'14.5',1,'SB(r)b         Sy2',NULL,NULL,NULL,NULL,1,336.474417,40.31486,0.725,NULL,55561941069,868155329,13564927,14.5),(155928,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155928,33.32,0.43,46.2,73656,75,NULL,'3.6 micron, color corrected','NGC 7282',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155929,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155929,33.47,0.43,49.5,73656,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7282',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155930,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155930,33.75,0.47,56.3,73656,NULL,NULL,'H','NGC 7282',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155931,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155931,33.9,0.46,60.3,73656,NULL,NULL,'J','NGC 7282',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155932,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155932,33.93,0.45,61.1,73656,NULL,NULL,'K','NGC 7282',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155933,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155933,33.94,0.4,61.3,73656,NULL,NULL,'mean','NGC 7282',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155934,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155934,38.15,0.46,426,73657,70,NULL,NULL,'2MASX J22255508+1323078',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00017,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,336.479583,13.38553,0.173,NULL,52362194224,818159284,12783738,18.2),(155935,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 09102','RN',155935,41.3,0.49,1550,73658,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 09102',0.171605,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155936,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155936,37.85,0.46,371,73659,70,NULL,NULL,'2MASX J22255660-0923058',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000158,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,336.4857917,-9.38508,0.153,NULL,50362300541,786910945,12295483,17.4),(155937,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155937,37.18,0.46,273,73660,70,NULL,NULL,'2MASX J22260133+0015448',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000206,NULL,'16.6g',0.32,'AGN',NULL,NULL,NULL,NULL,1,336.505666667,0.26233,0.149,NULL,52144371497,814755804,12730559,16.6),(155938,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155938,35.69,0.5,137,73661,70,NULL,NULL,'ESO 109- G 001',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000103,NULL,'15.62',0.5,'(L)SB(r)0^+',NULL,NULL,NULL,NULL,1,336.516916667,-63.28458,0.005,NULL,48758434827,761850544,11903914,15.62),(155939,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 00702','RN',155939,42.72,0.18,2220,73662,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00702',0.578379,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155940,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155940,37.88,0.46,377,73663,70,NULL,NULL,'2MASX J22260686+0030574',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000182,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,336.5285417,0.51589,0.161,NULL,52144270609,814754228,12730534,17.9),(155941,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155941,35.97,0.52,156,73664,70,NULL,NULL,'2MASX J22260961-8006083',NULL,'2014MNRAS.445.2677S',2014,1,0.22,NULL,'G',0.00015,NULL,'16.8b',0.14,NULL,NULL,NULL,NULL,NULL,1,336.540166667,-80.10239,0.445,NULL,48569724464,758901944,11857842,16.8),(155942,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155942,37.73,0.46,351,73665,70,NULL,NULL,'2MASX J22260969-0751136',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00015,NULL,'16.8g',0.3,'AGN',NULL,NULL,NULL,NULL,1,336.540417,-7.85378,0.141,NULL,50358434307,786850536,12294539,16.8),(155943,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155943,37.66,0.27,340,73666,70,NULL,NULL,'2MASX J22261010-0844346',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'17.2g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,336.5420417,-8.74303,0.149,NULL,50357947401,786842928,12294420,17.2),(155944,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155944,33.56,0.4,51.5,73667,NULL,NULL,'mean','NGC 7277',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000017,NULL,'14.10',0.6,'(R)Sb:         HII',NULL,NULL,NULL,NULL,1,336.545583,-31.14525,0,NULL,50591292678,790488948,12351389,14.1),(155945,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155945,33.63,0.47,53.2,73667,NULL,NULL,'H','NGC 7277',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155946,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155946,33.71,0.46,55.2,73667,NULL,NULL,'J','NGC 7277',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155947,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155947,33.75,0.45,56.3,73667,NULL,NULL,'K','NGC 7277',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155948,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155948,35.17,0.46,108,73668,70,NULL,NULL,'CGCG 378-006',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.000093,NULL,'14.9g',0.55,'E0',NULL,NULL,NULL,NULL,1,336.560958333,0.66781,0.161,NULL,52147076645,814798072,12731219,14.9),(155949,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155949,36.59,0.64,208,73669,70,NULL,NULL,'2MASX J22261722-7017407',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.00015,NULL,'16.74',0.3,NULL,NULL,NULL,NULL,NULL,1,336.571583,-70.29467,0.033,NULL,49315546080,770555407,12039928,16.74),(155950,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05234','RN',155950,41.07,0.36,1550,73670,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05234',0.057989,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155951,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155951,35.57,0.48,130,73671,NULL,NULL,NULL,'CGCG 452-010',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000017,NULL,'15.6',0.4,'Elliptical',NULL,NULL,NULL,NULL,1,336.581917,19.58189,0.173,NULL,52407188353,818862318,12794723,15.6),(155952,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155952,35.6,0.47,132,73671,NULL,NULL,'Malmquist cor.','CGCG 452-010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155953,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155953,35.74,0.2,141,73671,74.4,NULL,NULL,'CGCG 452-010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155954,'SBF','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155954,31.77,0.22,22.6,73672,NULL,NULL,'I','NGC 7280',NULL,'2003ApJ...583..712J',2003,1,2.2,NULL,'G',0.000017,NULL,'13.01',1.5,'SAB(r)0+       AGN','Pair member (points to parent)',NULL,NULL,NULL,1,336.614917,16.14822,0.213,NULL,52378060351,818407192,12787612,13.01),(155955,'SBF','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155955,31.93,0.22,24.3,73672,NULL,NULL,'I','NGC 7280',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155956,'SBF','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155956,31.93,0.14,24.3,73672,74.4,NULL,NULL,'NGC 7280',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155957,'Tully est','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155957,32.09,0.8,26.2,73672,75,NULL,'B','NGC 7280',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155958,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155958,31.6,0.45,20.9,73672,NULL,NULL,'K','NGC 7280',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155959,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155959,31.64,0.4,21.3,73672,NULL,NULL,'mean','NGC 7280',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155960,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 10324',NULL,155960,39.31,0.57,727,73673,70,NULL,'SN photometric redshift distance, z photo =0.187 +/- 0.065','SDSS-II SN 10324',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.0g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,336.617666667,0.58683,0.161,NULL,52144255119,814753986,12730531,21),(155961,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 10324','R',155961,40.25,0.24,896,73673,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 10324',0.251725,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155962,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 10324',NULL,155962,40.1,0.15,1050,73673,70,NULL,'SALT 2','SDSS-II SN 10324',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155963,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 10324','R',155963,40.6,0.2,1050,73673,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 10324',0.251725,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155964,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 10324',NULL,155964,40.12,0.15,1060,73673,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 10324',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155965,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 19424',NULL,155965,40,0.29,1000,73674,70,NULL,'SN photometric redshift distance, z photo =0.269 +/- 0.046','SDSS-II SN 19424',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,336.62275,0.95206,0.149,NULL,52147544659,814805385,12731334,NULL),(155966,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 19424','R',155966,41.61,0.26,1540,73674,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19424',0.364553,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155967,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 19424','R',155967,41.62,0.31,1550,73674,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19424',0.364553,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155968,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 19424',NULL,155968,41.51,0.2,2000,73674,70,NULL,'SALT 2','SDSS-II SN 19424',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155969,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 19424',NULL,155969,41.56,0.2,2050,73674,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19424',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155970,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155970,38.08,0.46,413,73675,70,NULL,NULL,'SDSS J222629.77-091947.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,336.624083333,-9.32989,0.149,NULL,50362266499,786910414,12295475,18.1),(155971,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155971,35.04,0.2,102,73676,74.4,NULL,NULL,'MCG -01-57-010',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.00015,NULL,'15.31',0.15,'Sc',NULL,NULL,NULL,NULL,1,336.626667,-6.39436,0.201,NULL,50356837690,786825588,12294149,15.31),(155972,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155972,35.04,0.43,102,73676,75,NULL,'3.6 micron, color corrected','MCG -01-57-010',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155973,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155973,35.13,0.43,106,73676,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-57-010',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155974,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155974,37.36,0.46,296,73677,70,NULL,NULL,'2MASX J22263298+0051274',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,336.637583333,0.85758,0.149,NULL,52147526227,814805097,12731329,17.5),(155975,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155975,36.05,0.57,162,73678,70,NULL,NULL,'AM 2223-635 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.68,'The APM image includes a superposed star.','G',0.00015,NULL,'16.28',0.31,'r?',NULL,NULL,NULL,NULL,1,336.64825,-63.69261,0,NULL,48756391826,761818622,11903415,16.28),(155976,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155976,36.45,0.56,195,73679,70,NULL,NULL,'2MASX J22263615-5039273',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.41',0.37,'S0',NULL,NULL,NULL,NULL,1,336.650708333,-50.65758,0,NULL,50618620674,790915948,12358061,16.41),(155977,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20218','RN',155977,40.73,0.13,1210,73680,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 20218',0.154405,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155978,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20218','RN',155978,41,0.25,1370,73680,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20218',0.154405,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155979,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155979,32.1,0.69,26.3,73681,100,NULL,'mid-IR','ESO 533- G 028',NULL,'2013ApJ...771...88L',2013,1,1.3,NULL,'G',0.000017,NULL,'13.43',0.6,'Sc?            HII',NULL,NULL,NULL,NULL,1,336.664,-24.87161,0.009,NULL,50077764977,782465077,12226016,13.43),(155980,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155980,32.57,0.43,32.6,73681,75,NULL,'3.6 micron, color + selection bias corrected','ESO 533- G 028',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155981,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155981,32.67,0.43,34.1,73681,75,NULL,'3.6 micron, color corrected','ESO 533- G 028',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155982,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155982,32.77,0.2,35.8,73681,74.4,NULL,NULL,'ESO 533- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155983,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155983,38.21,0.46,438,73682,70,NULL,NULL,'SDSS J222640.12+001321.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000139,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,336.667167,0.22267,0.185,NULL,52144199144,814753111,12730517,18.7),(155984,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 14053','RN',155984,40.65,0.24,1180,73683,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14053',0.141276,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155985,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 14053','RN',155985,41.26,0.52,1570,73683,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 14053',0.141276,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155986,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155986,38.16,0.46,428,73684,70,NULL,NULL,'SDSS J222642.94-005636.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000144,NULL,'18.8g',0.09,NULL,NULL,NULL,NULL,NULL,1,336.6789583,-0.94347,0.141,NULL,49798308451,778098569,12157790,18.8),(155987,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155987,32.16,0.4,27,73685,75,NULL,'B','UGCA 429',NULL,'1988NBGC.C....0000T',1988,1,1,NULL,'G',0.000017,NULL,'15.27',0.6,'Im','Pair member (points to parent)',NULL,NULL,NULL,1,336.687375,16.18283,0.213,NULL,52378030862,818406732,12787605,15.27),(155988,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20856','RN',155988,40.82,0.27,1250,73686,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 20856',0.16936,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155989,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155989,34.37,0.49,74.9,73687,70,NULL,NULL,'2MASX J22264634-1501230',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.39',0.36,NULL,NULL,NULL,NULL,NULL,1,336.693167,-15.02303,0.089,NULL,50233608750,784900136,12264064,15.39),(155990,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 14444',NULL,155990,39.3,0.25,724,73688,70,NULL,'SN photometric redshift distance, z photo =0.186 +/- 0.026','SDSS-II SN 14444',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,336.7015,-0.81572,0.157,NULL,49798254494,778097726,12157776,NULL),(155991,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 14444',NULL,155991,40.16,0.21,1080,73688,70,NULL,NULL,'SDSS-II SN 14444',NULL,'2013MNRAS.434.1443X',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155992,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 14444','R',155992,40.72,0.21,1120,73688,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14444',0.245916,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155993,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 14444','R',155993,40.87,0.15,1200,73688,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14444',0.245916,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155994,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155994,34.47,0.8,78.3,73689,75,NULL,'W91PP, r','UGC 12039',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000017,NULL,'13.84',1.3,'SB(r)b',NULL,NULL,NULL,NULL,1,336.701917,35.51872,0.485,NULL,55484663646,866947869,13546060,13.84),(155995,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155995,34.78,0.38,90.3,73689,75,NULL,'W91PP, r, raw','UGC 12039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155996,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155996,34.91,0.38,96.2,73689,75,NULL,'W91PP, r, cor','UGC 12039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155997,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155997,35.14,0.38,106,73689,75,NULL,'W91PP, r, inv','UGC 12039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155998,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02078',NULL,155998,39.51,0.79,800,73690,70,NULL,'SN photometric redshift distance, z photo =0.208 +/- 0.109','SDSS-II SN 02078',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','22.2g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,336.713833,-1.07997,0.141,NULL,49798272265,778098004,12157781,22.2),(155999,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02078','R',155999,41.15,0.32,1280,73690,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02078',0.323773,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156000,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02078','R',156000,41.38,0.25,1420,73690,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 02078',0.323773,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156001,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02078',NULL,156001,40.94,0.2,1540,73690,70,NULL,'SALT 2','SDSS-II SN 02078',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156002,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02078',NULL,156002,40.98,0.2,1570,73690,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 02078',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156003,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 14816','R',156003,38.25,0.18,403,73691,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ja','SDSS J222651.88+003023.0',0.11,'2014arXiv1401.3317S',2014,1,0.13,NULL,'G',NULL,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,336.716167,0.50642,0.161,NULL,52144281888,814754404,12730537,18.7),(156004,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2006ja',NULL,156004,38.1,0.07,417,73691,70,NULL,'SALT 2','SDSS J222651.88+003023.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156005,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 14816','R',156005,38.34,0.06,419,73691,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ja','SDSS J222651.88+003023.0',0.11,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156006,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2006ja',NULL,156006,38.11,0.07,419,73691,70,NULL,'SALT 2, Malmquist cor.','SDSS J222651.88+003023.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156007,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156007,35.91,0.59,152,73692,70,NULL,NULL,'2MASX J22265252-0234231',NULL,'2014MNRAS.445.2677S',2014,1,NULL,'The APM image includes a superposed star.','G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,336.718917,-2.57314,0.169,NULL,49797025400,778078521,12157476,15.1),(156008,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156008,36.23,0.6,176,73693,70,NULL,NULL,'AM 2223-635 NED03',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.000083,NULL,'16.21',0.47,'(R)SAB(s:)0^+',NULL,NULL,NULL,NULL,1,336.725375,-63.71442,0,NULL,48756385933,761818530,11903414,16.21),(156009,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156009,34.87,0.49,94.2,73694,75,NULL,'IR','UGC 12038',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000017,NULL,'14.98',0.3,'Sb',NULL,NULL,NULL,NULL,1,336.7264583,19.54819,0.173,NULL,52406847056,818856985,12794640,14.98),(156010,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156010,35.14,0.25,107,73694,NULL,NULL,NULL,'UGC 12038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156011,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156011,35.2,0.2,110,73694,74.4,NULL,NULL,'UGC 12038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156012,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156012,35.25,0.24,112,73694,NULL,NULL,'Malmquist cor.','UGC 12038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156013,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156013,35.5,0.4,126,73694,NULL,NULL,'mean','UGC 12038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156014,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156014,35.72,0.47,139,73694,NULL,NULL,'H','UGC 12038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156015,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156015,36,0.51,158,73695,70,NULL,NULL,'2MASX J22265758-5923037',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.59',0.34,NULL,NULL,NULL,NULL,NULL,1,336.73975,-59.38439,0,NULL,48798393340,762474895,11913670,16.59),(156016,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156016,37.67,0.23,342,73696,70,NULL,NULL,'2MASX J22270364-0012240',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.89',0.22,NULL,NULL,NULL,NULL,NULL,1,336.765333,-0.20678,0.165,NULL,49795719284,778058113,12157158,17.89),(156017,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156017,36.77,0.46,226,73697,70,NULL,NULL,'2MASX J22270422+0045170',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000206,NULL,'16.0g',0.34,'E0',NULL,NULL,NULL,NULL,1,336.7677083,0.75486,0.149,NULL,52143921153,814748768,12730449,16),(156018,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20399','RN',156018,41.66,0.27,1820,73698,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20399',0.177108,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156019,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20399','RN',156019,42.06,0.4,2200,73698,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20399',0.177108,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156020,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156020,37.67,0.23,342,73699,70,NULL,NULL,'2MASX J22270648-0008392',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'17.32',0.29,'BrClG',NULL,NULL,NULL,NULL,1,336.777,-0.14431,0.153,NULL,49795702022,778057844,12157153,17.32),(156021,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156021,34.46,0.49,77.9,73700,75,NULL,'IR','CGCG 495-001',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'15.38',0.2,'S?',NULL,NULL,NULL,NULL,1,336.799458333,31.50517,0.421,NULL,55494755305,867105551,13548524,15.38),(156022,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156022,34.77,0.2,90,73700,74.4,NULL,NULL,'CGCG 495-001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156023,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156023,34.83,0.35,92.6,73700,NULL,NULL,'Malmquist cor.','CGCG 495-001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156024,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156024,34.86,0.35,93.9,73700,NULL,NULL,NULL,'CGCG 495-001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156025,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156025,37.67,0.23,342,73701,70,NULL,NULL,'2MASX J22271221-0008022',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000174,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,336.800958333,-0.13411,0.153,NULL,49795701419,778057834,12157153,18.1),(156026,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156026,35.21,0.5,110,73702,70,NULL,NULL,'MCG -02-57-006',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00014,NULL,'15.28',0.5,NULL,NULL,NULL,NULL,NULL,1,336.8012917,-12.64719,0.173,NULL,50416380940,787755952,12308686,15.28),(156027,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156027,35.28,0.57,114,73703,NULL,NULL,'Malmquist cor.','NGC 7279',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.44',0.8,'SB(rs)c        HII?',NULL,NULL,NULL,NULL,1,336.80275,-35.14044,0,NULL,50584997731,790390589,12349852,14.44),(156028,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156028,35.35,0.55,118,73703,NULL,NULL,NULL,'NGC 7279',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156029,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156029,35.39,0.2,120,73703,74.4,NULL,NULL,'NGC 7279',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156030,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02079','RN',156030,40.47,0.25,948,73704,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 02079',0.306576,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156031,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02079','RN',156031,40.59,0.3,1010,73704,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02079',0.306576,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156032,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02079','N',156032,40.44,0.21,1220,73704,70,NULL,'SALT 2','SDSS-II SN 02079',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156033,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02079','N',156033,40.47,0.21,1240,73704,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 02079',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156034,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156034,37.61,0.46,333,73705,70,NULL,NULL,'2MASX J22271702-0014332',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.34',0.18,NULL,NULL,NULL,NULL,NULL,1,336.820791667,-0.24247,0.165,NULL,49795753643,778058650,12157166,18.34),(156035,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2006hv',NULL,156035,38.91,0.06,606,73706,70,NULL,'Hubble residual 0.04 for z0.15040','SDSS-II SN 13736 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,336.8327083,1.03072,0.161,NULL,52147415675,814803369,12731302,NULL),(156036,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13736','R',156036,39.33,0.18,637,73706,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006hv','SDSS-II SN 13736 HOST',0.150207,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156037,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2006hv',NULL,156037,39.26,0.06,711,73706,70,NULL,'SALT 2','SDSS-II SN 13736 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156038,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2006hv',NULL,156038,39.27,0.06,714,73706,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13736 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156039,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13736','R',156039,39.58,0.08,718,73706,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006hv','SDSS-II SN 13736 HOST',0.150207,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156040,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156040,37.06,0.46,258,73707,70,NULL,NULL,'SDSS J222720.73+004937.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,336.836416667,0.827,0.149,NULL,52143920310,814748754,12730449,18.2),(156041,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156041,33.56,NULL,51.4,73708,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 467- G 063',NULL,'2010Ap&SS.325..163P',2010,1,1.37,NULL,'G',0.000033,NULL,'16.80',0.11,'Sd',NULL,NULL,NULL,NULL,1,336.845,-31.00806,0,NULL,50591429126,790491080,12351423,16.8),(156042,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156042,33.58,NULL,52,73708,NULL,NULL,'Dipole + Quadrupole','ESO 467- G 063',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156043,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156043,33.59,NULL,52.3,73708,NULL,NULL,'Dipole','ESO 467- G 063',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156044,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156044,33.66,NULL,54,73708,NULL,NULL,NULL,'ESO 467- G 063',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156045,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156045,36.92,0.46,242,73709,70,NULL,NULL,'2MASX J22272973-0916248',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00015,NULL,'16.1g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,336.873875,-9.27358,0.157,NULL,50362935695,786920870,12295638,16.1),(156046,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156046,37.67,0.23,342,73710,70,NULL,NULL,'2MASX J22272980-0004132',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000145,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,336.874375,-0.07058,0.153,NULL,49794857536,778044649,12156947,17.5),(156047,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156047,30.86,NULL,14.9,73711,NULL,NULL,NULL,'FGC 2392',NULL,'2000BSAO...50....5K',2000,1,0.96,NULL,'G',0.000033,NULL,'16.6',0.1,'Sd',NULL,NULL,NULL,NULL,1,336.919417,-7.71683,0.121,NULL,50360659344,786885302,12295082,16.6),(156048,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156048,36.22,0.6,176,73712,70,NULL,NULL,'2MASX J22274184-6113143',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.000103,NULL,'16.74',0.33,NULL,NULL,NULL,NULL,NULL,1,336.92425,-61.22064,0,NULL,48791321164,762364393,11911943,16.74),(156049,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156049,37.24,0.33,281,73713,70,NULL,NULL,'2MASX J22274291-0037582',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.35',0.16,NULL,NULL,NULL,NULL,NULL,1,336.928875,-0.63294,0.145,NULL,49795586476,778056038,12157125,18.35),(156050,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13074','RN',156050,39.7,0.26,728,73714,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13074',0.194118,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156051,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13074','RN',156051,39.86,0.2,784,73714,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13074',0.194118,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156052,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156052,37.51,0.46,317,73715,70,NULL,NULL,'2MASX J22274660-0827255',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000151,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,336.94425,-8.45714,0.153,NULL,50358247486,786847616,12294494,17.2),(156053,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156053,36.88,0.46,238,73716,70,NULL,NULL,'2MASX J22274673-0831405',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'16.4g',0.31,'AGN',NULL,NULL,NULL,NULL,1,336.944667,-8.52783,0.149,NULL,50358216511,786847132,12294486,16.4),(156054,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156054,34.27,0.8,71.5,73717,75,NULL,'W91PP, r','UGC 12044',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000027,NULL,'15.0',0.6,'Sab',NULL,NULL,NULL,NULL,1,336.951333,38.58683,0.497,NULL,55524792601,867574884,13555857,15),(156055,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156055,34.04,0.38,64.4,73717,75,NULL,'W91PP, r, raw','UGC 12044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156056,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156056,34.26,0.38,71,73717,75,NULL,'W91PP, r, inv','UGC 12044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156057,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156057,34.26,0.38,71.2,73717,75,NULL,'W91PP, r, cor','UGC 12044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156058,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156058,34.41,0.4,76.3,73717,NULL,NULL,'mean','UGC 12044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156059,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156059,34.43,0.47,76.9,73717,NULL,NULL,'H','UGC 12044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156060,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156060,34.52,0.46,80,73717,NULL,NULL,'J','UGC 12044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156061,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156061,34.56,0.45,81.5,73717,NULL,NULL,'K','UGC 12044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156062,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20217',NULL,156062,40.43,0.17,1220,73718,70,NULL,'SN photometric redshift distance, z photo =0.340 +/- 0.035','SDSS-II SN 20217',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.4g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,336.955125,-0.63306,0.145,NULL,49795803020,778059422,12157178,21.4),(156063,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20217','R',156063,41.5,0.2,1460,73718,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20217',0.368842,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156064,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20217','R',156064,41.66,0.28,1570,73718,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20217',0.368842,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156065,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20217',NULL,156065,41.58,0.17,2070,73718,70,NULL,'SALT 2','SDSS-II SN 20217',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156066,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20217',NULL,156066,41.63,0.17,2120,73718,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20217',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156067,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156067,31.02,0.8,16,73719,75,NULL,'W91PP, r','NGC 7286',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'13.47',0.7,'S0/a',NULL,NULL,NULL,NULL,1,336.9605,29.09597,0.217,NULL,55439618143,866244033,13535063,13.47),(156068,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156068,31.57,0.38,20.6,73719,75,NULL,'W91PP, r, inv','NGC 7286',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156069,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156069,31.69,0.38,21.8,73719,75,NULL,'W91PP, r, raw','NGC 7286',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156070,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156070,31.84,0.38,23.4,73719,75,NULL,'W91PP, r, cor','NGC 7286',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156071,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156071,37.95,0.46,389,73720,70,NULL,NULL,'SDSS J222750.51+004236.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000165,NULL,'18.7g',0.08,NULL,NULL,NULL,NULL,NULL,1,336.9604583,0.71003,0.149,NULL,52144409839,814756403,12730568,18.7),(156072,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 19037','RN',156072,43.84,0.25,4020,73721,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19037',0.459279,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156073,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 03065','R',156073,40.11,0.35,908,73722,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03065',0.155771,'2014arXiv1401.3317S',2014,1,0.12,NULL,'G',NULL,'PHOT','19.9g',0.09,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,336.977791667,-1.15494,0.149,NULL,49798202195,778096909,12157764,19.9),(156074,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 03065',NULL,156074,39.91,0.57,960,73722,70,NULL,'SN photometric redshift distance, z photo =0.256 +/- 0.094','SDSS-II SN 03065',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156075,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 03065','R',156075,40.31,0.33,996,73722,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03065',0.155771,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156076,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20580',NULL,156076,40.67,0.27,1360,73723,70,NULL,'SN photometric redshift distance, z photo =0.390 +/- 0.067','SDSS-II SN 20580',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.1g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,336.981083,0.02733,0.185,NULL,52143776719,814746511,12730414,22.1),(156077,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20580','R',156077,41.75,0.32,1630,73723,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20580',0.375712,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156078,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20580','R',156078,42,0.35,1830,73723,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20580',0.375712,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156079,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20580',NULL,156079,41.67,0.23,2160,73723,70,NULL,'SALT 2','SDSS-II SN 20580',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156080,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20580',NULL,156080,41.72,0.23,2210,73723,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20580',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156081,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156081,37.24,0.33,281,73724,70,NULL,NULL,'SDSS J222758.65-004712.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000169,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,336.994417,-0.78683,0.145,NULL,49795469306,778054207,12157096,18.3),(156082,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15778','RN',156082,43.03,0.42,2890,73725,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 15778',0.398189,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156083,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15778','RN',156083,43.42,0.35,3460,73725,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 15778',0.398189,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156084,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156084,33.31,0.42,45.9,73726,NULL,NULL,'Malmquist cor.','IC 5220',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.08',0.3,'Sc',NULL,NULL,NULL,NULL,1,337.011375,-59.72344,0,NULL,48798022615,762469103,11913579,15.08),(156085,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156085,33.68,0.35,54.5,73726,NULL,NULL,NULL,'IC 5220',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156086,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156086,33.72,0.2,55.5,73726,74.4,NULL,NULL,'IC 5220',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156087,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ll',NULL,156087,39.41,0.15,613,73727,74.2,NULL,'SALT 2','SDSS J222805.78-010731.1',0.244,'2010ApJ...716..712A',2010,1,0.06,NULL,'G',NULL,NULL,'23.4g',0.01,NULL,NULL,NULL,NULL,NULL,1,337.024083,-1.12531,0.165,NULL,49795516135,778054939,12157108,23.4),(156088,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 10449','R',156088,40.15,0.16,865,73727,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ll','SDSS J222805.78-010731.1',0.24,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156089,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ll',NULL,156089,40.18,0.18,871,73727,70,NULL,'SDSS-II SN 10449, SALT 2','SDSS J222805.78-010731.1',0.244,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156090,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ll',NULL,156090,40.18,0.05,872,73727,70,NULL,'SDSS-II SN 10449','SDSS J222805.78-010731.1',0.244,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156091,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 10449','R',156091,40.25,0.24,903,73727,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ll','SDSS J222805.78-010731.1',0.24,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156092,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ll',NULL,156092,40.15,0.12,1070,73727,70,NULL,'SALT 2','SDSS J222805.78-010731.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156093,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ll',NULL,156093,40.16,0.12,1080,73727,70,NULL,'SALT 2, Malmquist cor.','SDSS J222805.78-010731.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156094,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156094,35.03,0.49,101,73728,75,NULL,'IR','ESO 027- G 010',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.99',0.2,'S...',NULL,NULL,NULL,NULL,1,337.048375,-79.50992,0.429,NULL,48569506919,758898545,11857789,15.99),(156095,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156095,35.54,0.46,128,73728,NULL,NULL,'Malmquist cor.','ESO 027- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156096,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156096,35.62,0.44,133,73728,NULL,NULL,NULL,'ESO 027- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156097,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156097,35.66,0.2,136,73728,74.4,NULL,NULL,'ESO 027- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156098,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156098,36.31,0.46,183,73729,70,NULL,NULL,'2MASX J22281267+0032358',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.00009,NULL,'15.4g',0.57,'E0',NULL,NULL,NULL,NULL,1,337.0527083,0.54322,0.109,NULL,52144574657,814758979,12730609,15.4),(156099,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156099,37.21,0.46,276,73730,70,NULL,NULL,'2MASX J22281269+1239210',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,337.05275,12.65581,0.149,NULL,52583602675,821618791,12837793,18),(156100,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156100,37,0.19,251,73731,70,NULL,NULL,'2MASX J22281319+0001506',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000162,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,337.054917,0.03064,0.185,NULL,52143744411,814746006,12730406,16.5),(156101,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156101,37.94,0.46,388,73732,70,NULL,NULL,'2MASX J22281325+0058418',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,337.055291667,0.97844,0.161,NULL,52144103339,814751614,12730493,18),(156102,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 17565','RN',156102,42.57,0.19,2370,73733,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 17565',0.376625,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156103,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 17565','RN',156103,42.68,0.22,2490,73733,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17565',0.376625,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156104,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 21693','RN',156104,38.21,0.19,403,73734,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 21693',0.089149,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156105,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 21693','RN',156105,38.84,0.23,539,73734,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 21693',0.089149,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156106,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20150','RN',156106,43.78,0.33,3480,73735,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20150',0.641724,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156107,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156107,36.87,0.56,237,73736,70,NULL,NULL,'2MASX J22282214-6641267',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'16.40',0.36,NULL,NULL,NULL,NULL,NULL,1,337.0925,-66.69072,0,NULL,49286034599,770094290,12032723,16.4),(156108,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156108,36.27,0.51,180,73737,70,NULL,NULL,'2MASX J22282227-1626172',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.36',0.53,NULL,NULL,NULL,NULL,NULL,1,337.09275,-16.43819,0.045,NULL,50247511625,785117369,12267458,16.36),(156109,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156109,37.68,0.33,343,73738,70,NULL,NULL,'2MASX J22282528-0946361',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,337.10525,-9.77675,0.169,NULL,50362483542,786913805,12295528,17.7),(156110,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156110,29.17,0.4,6.82,73739,NULL,NULL,NULL,'NGC 7292',NULL,'2009AJ....138..323T',2009,1,2.1,NULL,'G',0.000013,NULL,'13.03',1.7,'IBm','Isolated galaxy',NULL,NULL,NULL,1,337.1079583,30.29231,0.253,NULL,55436417474,866194023,13534281,13.03),(156111,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156111,30.11,0.4,10.5,73739,73,NULL,'opt','NGC 7292',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156112,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156112,31.05,0.4,16.2,73739,75,NULL,'B','NGC 7292',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156113,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156113,32.83,0.8,36.9,73740,75,NULL,'CF, r','NGC 7290',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000003,NULL,'13.0B',1,'SA(r)bc','Isolated galaxy (6 Mpc isolation)',NULL,NULL,NULL,1,337.110125,17.14744,0.229,NULL,52375248899,818363264,12786926,13),(156114,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156114,32.37,0.69,29.8,73740,100,NULL,'mid-IR','NGC 7290',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156115,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156115,33.03,0.52,40.3,73740,NULL,NULL,'Malmquist cor.','NGC 7290',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156116,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156116,33.06,0.43,41,73740,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7290',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156117,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156117,33.09,0.43,41.5,73740,75,NULL,'3.6 micron, color corrected','NGC 7290',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156118,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156118,33.15,0.2,42.7,73740,74.4,NULL,NULL,'NGC 7290',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156119,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156119,33.18,0.4,43.3,73740,NULL,NULL,'mean','NGC 7290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156120,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156120,33.33,0.45,46.3,73740,NULL,NULL,NULL,'NGC 7290',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156121,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156121,33.41,0.38,48.1,73740,75,NULL,'CF, r, raw','NGC 7290',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156122,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156122,33.44,0.47,48.7,73740,NULL,NULL,'H','NGC 7290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156123,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156123,33.49,0.38,50,73740,75,NULL,'CF, r, inv','NGC 7290',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156124,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156124,33.5,0.46,50.1,73740,NULL,NULL,'J','NGC 7290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156125,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156125,33.56,0.45,51.5,73740,NULL,NULL,'K','NGC 7290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156126,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156126,33.77,0.38,56.9,73740,75,NULL,'CF, r, cor','NGC 7290',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156127,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156127,36.3,0.73,182,73741,70,NULL,NULL,'2MASX J22282827-1237352',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'16.61',0.3,NULL,NULL,NULL,NULL,NULL,1,337.117875,-12.62633,0.197,NULL,50419064823,787797887,12309341,16.61),(156128,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156128,38.04,0.27,405,73742,70,NULL,NULL,'SDSS J222832.61+135028.0',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,337.135916667,13.84114,0.133,NULL,52363289610,818176400,12784006,17.7),(156129,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 07158','RN',156129,43.18,0.25,2950,73743,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 07158',0.468172,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156130,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13051','RN',156130,40.84,0.25,1150,73744,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13051',0.285147,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156131,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13051','RN',156131,41.07,0.23,1270,73744,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13051',0.285147,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156132,'SZ effect','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156132,40.43,0.39,1220,73745,NULL,NULL,'Hydrost. Eq.','MACS J2228.5+2036',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,337.141667,20.62167,0.209,NULL,52405987188,818843549,12794430,NULL),(156133,'SZ effect','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156133,41.34,0.51,1850,73745,NULL,NULL,'Isotherm.','MACS J2228.5+2036',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156134,'SZ effect','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156134,41.49,0.47,1990,73745,NULL,NULL,'Isotherm., r < 100 kpc','MACS J2228.5+2036',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156135,'SZ effect','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156135,41.99,NULL,2500,73745,NULL,NULL,'4.2 (black) calibration','MACS J2228.5+2036',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156136,'SZ effect','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156136,42.03,NULL,2550,73745,NULL,NULL,'3.1 (red) calibration','MACS J2228.5+2036',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156137,'SZ effect','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156137,42.36,NULL,2970,73745,NULL,NULL,'4.1 (blue) calibration','MACS J2228.5+2036',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156138,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 19231','RN',156138,39.11,0.31,611,73746,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 19231',0.085569,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156139,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156139,38.73,0.46,557,73747,70,NULL,NULL,'2MASX J22283416+0044243',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,337.142375,0.74022,0.161,NULL,52144531119,814758298,12730598,17.8),(156140,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156140,38.04,0.27,405,73748,70,NULL,NULL,'SDSS J222836.04+135124.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000139,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,337.150167,13.85672,0.133,NULL,52363282451,818176288,12784004,18.8),(156141,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156141,37.56,0.46,325,73749,70,NULL,NULL,'2MASX J22283666-0855520',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000152,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,337.152791667,-8.93106,0.153,NULL,50358286490,786848226,12294503,17.2),(156142,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156142,36.88,0.46,238,73750,70,NULL,NULL,'2MASX J22283679+1403138',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000166,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,337.153458333,14.05392,0.157,NULL,52363499273,818179676,12784057,16.4),(156143,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156143,37.41,0.46,304,73751,70,NULL,NULL,'2MASX J22283699-0946020',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,337.154083333,-9.76722,0.169,NULL,50362401365,786912521,12295508,17),(156144,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156144,37.5,0.46,317,73752,70,NULL,NULL,'2MASX J22283814-0829190',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000156,NULL,'17.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,337.158917,-8.48867,0.153,NULL,50358227672,786847307,12294489,17.1),(156145,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 19739',NULL,156145,39.02,2.12,638,73753,70,NULL,'SN photometric redshift distance, z photo =0.162 +/- 0.357','SDSS-II SN 19739',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'G',NULL,'PHOT','23.0g',NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,337.159375,-0.50111,0.145,NULL,49795655098,778057110,12157142,23),(156146,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156146,38.04,0.27,405,73754,70,NULL,NULL,'2MASX J22284031+1349048',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,337.167958333,13.81797,0.133,NULL,52582201666,821596901,12837451,17.6),(156147,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156147,37.66,0.46,340,73755,70,NULL,NULL,'2MASX J22284083-0805520',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000141,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,337.170083,-8.09789,0.157,NULL,50360861317,786888458,12295132,18.3),(156148,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156148,36.41,0.57,191,73756,70,NULL,NULL,'2MASX J22284843-6405593',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.000083,NULL,'16.96',0.27,NULL,NULL,NULL,NULL,NULL,1,337.201875,-64.09986,0,NULL,48756491819,761820184,11903440,16.96),(156149,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05536','RN',156149,40.29,0.12,1010,73757,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 05536',0.129567,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156150,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05536','RN',156150,40.85,0.31,1310,73757,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 05536',0.129567,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156151,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156151,37.68,0.33,343,73758,70,NULL,NULL,'2MASX J22285079-0938580',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000159,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,337.2115,-9.64942,0.117,NULL,50362887078,786920110,12295626,17.2),(156152,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05235','R',156152,40.47,0.21,992,73759,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05235',0.252225,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,337.22425,0.63614,0.161,NULL,52144515968,814758062,12730594,NULL),(156153,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05235','R',156153,40.47,0.17,993,73759,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 05235',0.252225,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156154,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05235',NULL,156154,40.3,0.12,1150,73759,70,NULL,'SALT 2','SDSS-II SN 05235',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156155,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05235',NULL,156155,40.32,0.12,1160,73759,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 05235',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156156,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05235',NULL,156156,40.42,0.2,1210,73759,70,NULL,'SN photometric redshift distance, z photo =0.338 +/- 0.040','SDSS-II SN 05235',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156157,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156157,46.23,0.57,4790,73760,69.7,NULL,'Calibrated','GRB 060604',2.68,'2009MNRAS.400..775C',2009,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,337.2292083,-10.9155,0.149,NULL,50351725167,786745705,12292901,NULL),(156158,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156158,46.31,0.72,4970,73760,NULL,NULL,NULL,'GRB 060604',2.68,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156159,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156159,46.36,0.64,5080,73760,72,NULL,NULL,'GRB 060604',2.68,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156160,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156160,46.48,0.63,5370,73760,70,NULL,NULL,'GRB 060604',2.68,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156161,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156161,47.18,0.55,7420,73760,69.7,NULL,'Fiducial','GRB 060604',2.68,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156162,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156162,36.78,0.46,227,73761,70,NULL,NULL,'2MASX J22290068-0824122',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00015,NULL,'16.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,337.252958333,-8.40344,0.157,NULL,50360143091,786877235,12294956,16.4),(156163,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156163,34.96,0.26,98.2,73762,NULL,NULL,NULL,'UGC 12050',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000033,NULL,'14.85',0.5,'S?',NULL,NULL,NULL,NULL,1,337.263416667,19.10047,0.193,NULL,52405197211,818831206,12794237,14.85),(156164,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156164,35.05,0.2,102,73762,74.4,NULL,NULL,'UGC 12050',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156165,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156165,35.19,0.23,109,73762,NULL,NULL,'Malmquist cor.','UGC 12050',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156166,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13933','R',156166,42.05,0.3,1790,73763,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13933',0.434257,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,337.2654583,-0.56347,0.149,NULL,49794961809,778046278,12156973,NULL),(156167,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13933','R',156167,42.33,0.32,2040,73763,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13933',0.434257,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156168,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02080','RN',156168,40.98,0.2,1420,73764,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 02080',0.103514,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156169,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02080','RN',156169,41.14,0.22,1530,73764,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 02080',0.103514,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156170,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156170,36.18,0.46,172,73765,70,NULL,NULL,'IC 1446',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.000103,NULL,'15.3g',0.48,'S0',NULL,NULL,NULL,NULL,1,337.269583,-1.18492,0.165,NULL,49795331354,778052052,12157063,15.3),(156171,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156171,36.88,0.46,238,73766,70,NULL,NULL,'2MASX J22290470-0752322',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000154,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,337.269583,-7.87564,0.149,NULL,50360790539,786887352,12295114,17),(156172,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 10450','R',156172,41.05,0.22,1270,73767,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 10450',0.272,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,337.275625,-1.12867,0.165,NULL,49795534082,778055220,12157112,NULL),(156173,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 10450','R',156173,41.44,0.34,1520,73767,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 10450',0.272,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156174,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156174,37,0.19,251,73768,70,NULL,NULL,'2MASX J22290739+0007152',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.54',0.42,NULL,NULL,NULL,NULL,NULL,1,337.280958333,0.12094,0.145,NULL,52143632261,814744254,12730378,16.54),(156175,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156175,37,0.19,251,73769,70,NULL,NULL,'SDSS J222908.07+000908.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000167,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,337.283625,0.15236,0.145,NULL,52143629076,814744204,12730378,18.1),(156176,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156176,37,0.19,251,73770,70,NULL,NULL,'2MASX J22290973+0004442',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000197,NULL,'16.3g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,337.290667,0.07886,0.165,NULL,52143632551,814744258,12730379,16.3),(156177,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156177,37,0.19,251,73771,70,NULL,NULL,'SDSS J222909.92+000722.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000195,NULL,'17.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,337.291333,0.12292,0.165,NULL,52143630705,814744229,12730378,17.8),(156178,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156178,35.35,0.8,118,73772,75,NULL,'CF, r','UGC 12052',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',NULL,NULL,'15.1',0.4,'Scd:',NULL,NULL,NULL,NULL,1,337.2925,38.53158,0.397,NULL,55524803045,867575047,13555860,15.1),(156179,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156179,34.99,0.38,99.7,73772,75,NULL,'CF, r, raw','UGC 12052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156180,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156180,35.09,0.38,104,73772,75,NULL,'CF, r, inv','UGC 12052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156181,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156181,35.19,0.38,109,73772,75,NULL,'CF, r, cor','UGC 12052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156182,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156182,38.09,0.46,415,73773,70,NULL,NULL,'2MASX J22291043-1005401',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000181,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,337.2935417,-10.09442,0.161,NULL,50362560435,786915006,12295546,17.3),(156183,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156183,35.77,0.71,143,73774,70,NULL,NULL,'2MASX J22291156-0920041',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'15.7g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,337.29825,-9.33456,0.145,NULL,50362784803,786918512,12295601,15.7),(156184,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156184,36.01,0.46,159,73774,70,NULL,NULL,'2MASX J22291156-0920041',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156185,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156185,37,0.19,251,73775,70,NULL,NULL,'2MASX J22291213+0009452',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000172,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,337.300625,0.16236,0.145,NULL,52143636876,814744326,12730380,17.6),(156186,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 17443','RN',156186,42.22,0.2,1820,73776,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 17443',0.525488,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156187,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02081','R',156187,40.73,0.24,1120,73777,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J222913.18-011228.1',0.252,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',0.01,NULL,'20.3g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,337.304917,-1.20781,0.165,NULL,49795319915,778051873,12157060,20.3),(156188,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02081','R',156188,41.03,0.2,1290,73777,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J222913.18-011228.1',0.252,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156189,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02081',NULL,156189,40.64,0.15,1340,73777,70,NULL,'SALT 2','SDSS J222913.18-011228.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156190,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02081',NULL,156190,40.66,0.15,1360,73777,70,NULL,'SALT 2, Malmquist cor.','SDSS J222913.18-011228.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156191,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 01303','RN',156191,41.5,0.14,1580,73778,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01303',0.26569,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156192,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 01303','RN',156192,42.07,0.19,2050,73778,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01303',0.26569,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156193,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156193,32.49,0.43,31.5,73779,75,NULL,'3.6 micron, color + selection bias corrected','IRAS22282+7506',NULL,'2014MNRAS.444..527S',2014,1,1.34,NULL,'G',0.000023,NULL,NULL,0.89,'Spiral LSB',NULL,NULL,NULL,NULL,1,337.3125,75.36556,1.569,NULL,52799598393,824993724,12890526,NULL),(156194,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 17599','RN',156194,40.59,0.33,912,73780,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 17599',0.438925,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156195,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 17599','RN',156195,41.58,0.35,1440,73780,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17599',0.438925,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156196,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005iw',NULL,156196,40.7,0.15,1080,73781,65,NULL,'MLCS2k2','SDSS J222917.88-000531.8',0.27,'2009ApJS..185...32K',2009,1,0.06,NULL,'G',NULL,NULL,'21.2g',0.04,NULL,NULL,NULL,NULL,NULL,1,337.3245417,-0.09217,0.157,NULL,49794835574,778044305,12156942,21.2),(156197,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 06127','R',156197,40.74,0.16,1110,73781,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005iw','SDSS J222917.88-000531.8',0.27,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156198,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005iw',NULL,156198,40.88,0.25,1180,73781,65,NULL,'SALT2','SDSS J222917.88-000531.8',0.27,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156199,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 06127','R',156199,41.11,0.28,1310,73781,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005iw','SDSS J222917.88-000531.8',0.27,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156200,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156200,37.09,0.64,261,73782,70,NULL,NULL,'2MASX J22291825-1324493',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'17.07',0.28,NULL,NULL,NULL,NULL,NULL,1,337.326,-13.41364,0.153,NULL,50419314206,787801784,12309402,17.07),(156201,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156201,37.53,0.46,321,73783,70,NULL,NULL,'2MASX J22291893-0818431',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000903,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,337.328917,-8.31217,0.157,NULL,50360126225,786876972,12294952,17.8),(156202,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13775','RN',156202,41.78,0.34,1930,73784,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13775',0.17589,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156203,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13775','RN',156203,42.07,0.29,2210,73784,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13775',0.17589,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156204,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13023','RN',156204,43.02,0.24,2530,73785,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13023',0.593717,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156205,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156205,37.96,0.46,392,73786,70,NULL,NULL,'SDSS J222925.67+125131.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000163,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,337.3569583,12.85869,0.157,NULL,52583759262,821621238,12837831,18.5),(156206,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156206,38.9,0.46,602,73787,70,NULL,NULL,'2MASX J22292680-0108409',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,337.3615417,-1.14461,0.165,NULL,50332123830,786439434,12288116,18.3),(156207,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156207,35.18,0.5,108,73788,70,NULL,NULL,'6dF J2229296-353310',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,337.373125,-35.55289,0,NULL,50577385206,790271643,12347994,15),(156208,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156208,32.8,0.2,36.3,73789,74.4,NULL,NULL,'UGC 12054',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000027,NULL,'14.93',0.2,'S?',NULL,NULL,NULL,NULL,1,337.38525,7.726,0.293,NULL,52453616146,819587752,12806058,14.93),(156209,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156209,32.81,0.43,36.5,73789,75,NULL,'3.6 micron, color corrected','UGC 12054',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156210,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156210,32.85,0.49,37.1,73789,75,NULL,'IR','UGC 12054',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156211,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156211,32.85,0.43,37.1,73789,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12054',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156212,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156212,33.1,0.6,41.7,73789,NULL,NULL,NULL,'UGC 12054',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156213,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156213,33.18,0.57,43.2,73789,NULL,NULL,'Malmquist cor.','UGC 12054',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156214,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156214,37.5,0.46,317,73790,70,NULL,NULL,'SDSS J222933.79-085329.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00014,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,337.390791667,-8.89164,0.125,NULL,50358189467,786846710,12294479,18.5),(156215,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156215,36.75,0.46,223,73791,70,NULL,NULL,'2MASX J22293564-0828346',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,337.3985417,-8.47628,0.157,NULL,50360217426,786878397,12294974,16.9),(156216,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156216,45.43,0.97,3380,73792,69.7,NULL,'Fiducial','GRB 050820',2.61,'2009MNRAS.400..775C',2009,1,NULL,NULL,'VisS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,337.4087917,19.56031,0.161,NULL,52406794907,818856170,12794627,NULL),(156217,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156217,46.27,0.59,4970,73792,69.7,NULL,'Calibrated','GRB 050820',2.61,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156218,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156218,46.3,1.58,5040,73792,100,NULL,NULL,'GRB 050820',2.61,'2009EPJC...63..139W',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156219,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156219,46.51,0.63,5550,73792,69.7,NULL,'Fiducial','GRB 050820',2.61,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156220,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156220,46.52,1.52,5580,73792,69.7,NULL,'Fiducial','GRB 050820',2.61,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156221,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156221,46.55,0.65,5660,73792,72,NULL,NULL,'GRB 050820',2.61,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156222,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156222,46.7,0.66,6060,73792,70,NULL,NULL,'GRB 050820',2.61,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156223,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156223,47.16,0.95,7480,73792,NULL,NULL,NULL,'GRB 050820',2.61,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156224,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156224,36.46,0.67,196,73793,70,NULL,NULL,'2MASX J22294092-1726212',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'15.1R',0.29,NULL,NULL,NULL,NULL,NULL,1,337.4205,-17.43919,0.113,NULL,50243742763,785058480,12266538,15.1),(156225,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156225,37.63,0.46,335,73794,70,NULL,NULL,'2MASX J22294281+1412454',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000112,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,337.4285,14.21256,0.169,NULL,52363340838,818177200,12784018,18.3),(156226,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 03179','RN',156226,40.11,0.15,869,73795,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03179',0.207584,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156227,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 16413','RN',156227,42.5,0.39,2570,73796,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16413',0.231097,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156228,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 16413','RN',156228,42.64,0.32,2730,73796,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16413',0.231097,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156229,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156229,34.4,0.47,76,73797,NULL,NULL,'H','UGC 12056',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.00002,NULL,'15.00',1,'Sa',NULL,NULL,NULL,NULL,1,337.468583,36.71928,0.529,NULL,55453562029,866461906,13538467,15),(156230,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156230,34.49,0.69,79.1,73797,100,NULL,'mid-IR','UGC 12056',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156231,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156231,34.54,0.46,80.8,73797,NULL,NULL,'J','UGC 12056',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156232,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156232,34.56,0.45,81.5,73797,NULL,NULL,'K','UGC 12056',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156233,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156233,34.91,0.4,95.7,73797,NULL,NULL,'mean','UGC 12056',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156234,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2007la',NULL,156234,38.52,0.09,506,73798,70,NULL,'Hubble residual -0.08 for z0.13070','2MASX J22295461+0103302',NULL,'2011ApJ...740...92G',2011,1,0.15,NULL,'G',0.0005,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,337.4775,1.05847,0.177,NULL,52412663428,818947866,12796060,18.6),(156235,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 18415','R',156235,38.92,0.18,538,73798,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007la','2MASX J22295461+0103302',0.1307,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156236,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2007la',NULL,156236,38.71,0.07,552,73798,70,NULL,'SALT 2','2MASX J22295461+0103302',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156237,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2007la',NULL,156237,38.71,0.07,552,73798,70,NULL,'SALT 2, Malmquist cor.','2MASX J22295461+0103302',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156238,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 18415','R',156238,39.11,0.1,587,73798,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007la','2MASX J22295461+0103302',0.1307,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156239,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15558','R',156239,40.94,0.38,1180,73799,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15558',0.305943,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,'PHOT','21.1g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,337.4935,0.95344,0.177,NULL,52412672375,818948005,12796062,21.1),(156240,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15558','R',156240,40.96,0.34,1190,73799,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15558',0.305943,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156241,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15558',NULL,156241,40.66,0.24,1360,73799,70,NULL,'SALT 2','SDSS-II SN 15558',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156242,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15558',NULL,156242,40.69,0.24,1370,73799,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15558',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156243,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15558',NULL,156243,41.34,0.13,1860,73799,70,NULL,'SN photometric redshift distance, z photo =0.591 +/- 0.056','SDSS-II SN 15558',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156244,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156244,33.12,0.4,42.1,73800,NULL,NULL,'mean','IC 1447',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.00001,NULL,'13.71',0.8,'SA(r)b?',NULL,NULL,NULL,NULL,1,337.499167,-5.11989,0.137,NULL,50339786608,786559165,12289986,13.71),(156245,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156245,33.48,0.46,49.6,73800,NULL,NULL,'J','IC 1447',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156246,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156246,33.51,0.47,50.3,73800,NULL,NULL,'H','IC 1447',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156247,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156247,33.55,0.45,51.2,73800,NULL,NULL,'K','IC 1447',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156248,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2006ks',NULL,156248,39.88,0.11,946,73801,70,NULL,'Hubble residual 0.36 for z0.20850','SDSS J223004.53+000011.2',NULL,'2011ApJ...740...92G',2011,1,0.12,NULL,'G',0.0005,NULL,'20.23',0.09,NULL,NULL,NULL,NULL,NULL,1,337.518917,0.00314,0.165,NULL,51673825404,807403521,12615680,20.23),(156249,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15201','R',156249,40.36,0.21,976,73801,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ks','SDSS J223004.53+000011.2',0.2085,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156250,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15201','R',156250,40.43,0.13,1010,73801,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ks','SDSS J223004.53+000011.2',0.2085,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156251,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2006ks',NULL,156251,40.16,0.11,1080,73801,70,NULL,'SALT 2','SDSS J223004.53+000011.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156252,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2006ks',NULL,156252,40.17,0.11,1080,73801,70,NULL,'SALT 2, Malmquist cor.','SDSS J223004.53+000011.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156253,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20400','R',156253,40.59,0.16,1010,73802,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20400',0.293582,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',NULL,'PHOT','20.9g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,337.5319583,-1.15425,0.165,NULL,50332165103,786440079,12288126,20.9),(156254,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20400',NULL,156254,40.12,0.27,1060,73802,70,NULL,'SN photometric redshift distance, z photo =0.286 +/- 0.046','SDSS-II SN 20400',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156255,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20400','R',156255,40.82,0.27,1130,73802,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20400',0.293582,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156256,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20400',NULL,156256,40.74,0.17,1410,73802,70,NULL,'SALT 2','SDSS-II SN 20400',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156257,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20400',NULL,156257,40.77,0.17,1430,73802,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20400',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156258,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15933','RN',156258,41.61,0.2,1740,73803,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15933',0.208124,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156259,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15933','RN',156259,42.23,0.26,2310,73803,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15933',0.208124,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156260,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156260,37.45,0.46,309,73804,70,NULL,NULL,'2MASX J22300839+0025398',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000144,NULL,'17.96',0.18,NULL,NULL,NULL,NULL,NULL,1,337.535,0.42767,0.161,NULL,52412249405,818941396,12795959,17.96),(156261,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 16716','RN',156261,41.16,0.2,1480,73805,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 16716',0.149774,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156262,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 16716','RN',156262,41.27,0.25,1560,73805,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 16716',0.149774,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156263,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2006kc',NULL,156263,39.41,0.08,761,73806,70,NULL,'Hubble residual -0.13 for z0.21003','SDSS-II SN 15259 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.00011,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,337.544208333,-0.40778,0.157,NULL,50331891136,786435799,12288059,NULL),(156264,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15259','R',156264,39.98,0.2,819,73806,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006kc','SDSS-II SN 15259 HOST',0.212,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156265,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15259','R',156265,40.12,0.11,872,73806,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006kc','SDSS-II SN 15259 HOST',0.212,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156266,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156266,37.84,0.27,369,73807,70,NULL,NULL,'2MASX J22301209-0928363',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,337.5502917,-9.47664,0.161,NULL,50362737862,786917779,12295590,17.7),(156267,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156267,37.76,0.46,356,73808,70,NULL,NULL,'2MASX J22301267+1219331',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000153,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,337.552666667,12.32583,0.185,NULL,52581596390,821587443,12837303,17.2),(156268,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156268,36.86,0.46,235,73809,70,NULL,NULL,'2MASX J22301271-0959313',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000147,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,337.5529583,-9.99197,0.161,NULL,50364344093,786942876,12295982,16.6),(156269,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13288','RN',156269,42.57,0.19,2080,73810,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13288',0.568682,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156270,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13423',NULL,156270,40.37,0.22,1180,73811,70,NULL,'SN photometric redshift distance, z photo =0.328 +/- 0.043','SDSS-II SN 13423',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,337.56525,0.07506,0.173,NULL,52412023999,818937874,12795904,NULL),(156271,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156271,36.02,0.58,160,73812,70,NULL,NULL,'2MASX J22302044-1404344',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'17.74',0.19,NULL,NULL,NULL,NULL,NULL,1,337.585125,-14.07625,0.141,NULL,50417197438,787768709,12308886,17.74),(156272,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 19195',NULL,156272,40.9,0.27,1510,73813,70,NULL,'SN photometric redshift distance, z photo =0.447 +/- 0.080','SDSS-II SN 19195',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,337.586125,-0.13531,0.165,NULL,50331657491,786432148,12288002,NULL),(156273,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156273,37.18,0.73,272,73814,70,NULL,NULL,'2MASX J22302109-8059092',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'16.8b',0.13,NULL,NULL,NULL,NULL,NULL,1,337.5880417,-80.98589,0.421,NULL,48562817638,758794025,11856156,16.8),(156274,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 14177','R',156274,40.38,0.37,919,73815,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 14177',0.293703,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,'PHOT','21.9g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,337.592417,0.51633,0.169,NULL,52412244741,818941324,12795958,21.9),(156275,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 14177','R',156275,40.56,0.33,1000,73815,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 14177',0.293703,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156276,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 14177',NULL,156276,40.64,0.39,1340,73815,70,NULL,'SN photometric redshift distance, z photo =0.384 +/- 0.100','SDSS-II SN 14177',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156277,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156277,37.84,0.27,369,73816,70,NULL,NULL,'2MASX J22302454-0934103',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000167,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,337.602333,-9.56956,0.157,NULL,50364800297,786950004,12296093,16.6),(156278,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13035','RN',156278,39.7,0.22,845,73817,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13035',0.030916,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156279,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13035','RN',156279,39.97,0.33,956,73817,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13035',0.030916,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156280,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156280,36.67,0.46,216,73818,70,NULL,NULL,'2MASX J22302745-0937023',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.00015,NULL,'16.1g',0.36,'E0',NULL,NULL,NULL,NULL,1,337.614458333,-9.61717,0.157,NULL,50364798957,786949983,12296093,16.1),(156281,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156281,32.98,0.49,39.5,73819,75,NULL,'IR','2MFGC 16956',NULL,'2011yCatp016004901K',2011,1,0.45,NULL,'G',0.00001,NULL,'9.6K',0.22,'Sbc:',NULL,NULL,NULL,NULL,1,337.626625,61.88047,NULL,NULL,53353998093,833656220,13025878,9.6),(156282,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156282,33.54,0.4,51.1,73819,NULL,NULL,'mean','2MFGC 16956',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156283,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156283,33.68,0.46,54.3,73819,NULL,NULL,'J','2MFGC 16956',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156284,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156284,33.7,0.47,54.9,73819,NULL,NULL,'H','2MFGC 16956',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156285,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156285,33.72,0.45,55.4,73819,NULL,NULL,'K','2MFGC 16956',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156286,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156286,34.92,0.53,96.5,73820,NULL,NULL,'Malmquist cor.','AGC 320785',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',NULL,NULL,'16.68',0.12,NULL,NULL,NULL,NULL,NULL,1,337.6285417,35.29228,0.517,NULL,55454758508,866480601,13538759,16.68),(156287,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156287,35.01,0.2,100,73820,74.4,NULL,NULL,'AGC 320785',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156288,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156288,35.2,0.46,109,73820,NULL,NULL,NULL,'AGC 320785',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156289,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156289,37.84,0.27,369,73821,70,NULL,NULL,'SDSS J223031.16-093241.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000172,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,337.629875,-9.54483,0.161,NULL,50364781675,786949713,12296089,18.6),(156290,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ig',NULL,156290,39.79,0.14,709,73822,74.2,NULL,'SALT 2','SDSS J223031.48-003008.5',0.28,'2010ApJ...716..712A',2010,1,0.06,NULL,'G',0.0005,NULL,'21.0g',0.04,NULL,NULL,NULL,NULL,NULL,1,337.631208333,-0.50239,0.145,NULL,50331900251,786435941,12288061,21),(156291,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ig',NULL,156291,39.87,0.13,943,73822,70,NULL,'Hubble residual -0.21 for z0.28070','SDSS J223031.48-003008.5',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156292,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 06196','R',156292,40.42,0.22,948,73822,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ig','SDSS J223031.48-003008.5',0.2807,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156293,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ig',NULL,156293,40.49,0.15,979,73822,65,NULL,'SALT2','SDSS J223031.48-003008.5',0.28,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156294,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ig',NULL,156294,40.5,0.16,982,73822,70,NULL,'SALT 2','SDSS J223031.48-003008.5',0.28,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156295,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 06196','R',156295,40.67,0.15,1060,73822,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ig','SDSS J223031.48-003008.5',0.2807,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156296,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ig',NULL,156296,40.68,0.13,1070,73822,65,NULL,'MLCS2k2','SDSS J223031.48-003008.5',0.28,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156297,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ig',NULL,156297,40.23,0.12,1110,73822,70,NULL,'SALT 2','SDSS J223031.48-003008.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156298,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ig',NULL,156298,40.25,0.12,1120,73822,70,NULL,'SALT 2, Malmquist cor.','SDSS J223031.48-003008.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156299,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156299,30.9,0.4,15.1,73823,75,NULL,'B','UGC 12060',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.000017,NULL,'14.90',1,'IBm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,337.641583333,33.81969,0.353,NULL,55461288179,866582627,13540353,14.9),(156300,'Tully est','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156300,31.65,0.8,21.4,73824,75,NULL,NULL,'[RC2] A2228-00',NULL,'1988NBGC.C....0000T',1988,1,0.24,NULL,'G',0.000011,NULL,'17.2g',0.2,'HII',NULL,NULL,NULL,NULL,1,337.653333,-0.11028,0.165,NULL,49459238713,772800604,12075009,17.2),(156301,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156301,31.98,NULL,24.9,73824,NULL,NULL,NULL,'[RC2] A2228-00',NULL,'2014A&A...562A..49M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156302,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156302,34.14,0.43,67.4,73825,NULL,NULL,'Malmquist cor.','NGC 7301',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.44',0.5,'SAB(s)bc       HII',NULL,NULL,NULL,NULL,1,337.644667,-17.57378,0.113,NULL,50243802629,785059416,12266553,14.44),(156303,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156303,34.16,0.43,67.8,73825,NULL,NULL,NULL,'NGC 7301',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156304,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156304,34.2,0.2,69.2,73825,74.4,NULL,NULL,'NGC 7301',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156305,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156305,33.26,0.8,44.9,73826,75,NULL,'MAT, I','ESO 533- G 037',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000024,NULL,'15.28',0.6,'SB(s)d','in a pair',NULL,NULL,NULL,1,337.66075,-26.93147,0,NULL,50078167320,782471364,12226115,15.28),(156306,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156306,31.73,0.32,22.2,73826,85,NULL,'I, inv','ESO 533- G 037',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156307,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156307,31.79,0.32,22.8,73826,85,NULL,'I, raw','ESO 533- G 037',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156308,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156308,32.35,0.43,29.5,73826,75,NULL,'MAT, I, inv','ESO 533- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156309,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156309,32.48,0.43,31.3,73826,75,NULL,'MAT, I, raw','ESO 533- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156310,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156310,32.76,0.43,35.6,73826,75,NULL,'MAT, I, cor','ESO 533- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156311,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156311,33.63,0.65,53.3,73826,NULL,NULL,NULL,'ESO 533- G 037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156312,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156312,33.67,0.2,54.2,73826,74.4,NULL,NULL,'ESO 533- G 037',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156313,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156313,33.75,0.62,56.3,73826,NULL,NULL,'Malmquist cor.','ESO 533- G 037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156314,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156314,36.5,0.71,199,73827,70,NULL,NULL,'2MASX J22303930-4235546',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'16.78',0.31,NULL,NULL,NULL,NULL,NULL,1,337.66375,-42.59853,0,NULL,50733342235,792708472,12386069,16.78),(156315,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 06567','RN',156315,43.63,0.51,4960,73828,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06567',0.071701,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156316,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 06567','RN',156316,43.71,0.5,5160,73828,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06567',0.071701,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156317,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156317,37.45,0.16,309,73829,70,NULL,NULL,'SDSS J223040.81-083751.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,337.670083,-8.631,0.149,NULL,50359976739,786874636,12294916,18.3),(156318,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ff',NULL,156318,37.26,0.12,265,73830,74.2,NULL,'SALT 2','SDSS J223041.15-004634.4',0.07,'2010ApJ...716..712A',2010,1,0.19,NULL,'G',NULL,NULL,'18.9g',0.09,NULL,NULL,NULL,NULL,NULL,1,337.6714583,-0.77625,0.153,NULL,50332613009,786447078,12288235,18.9),(156319,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ff',NULL,156319,37.91,0.12,357,73830,70,NULL,'SDSS-II SN 01241, SALT 2','SDSS J223041.15-004634.4',0.07,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156320,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ff',NULL,156320,37.93,0.09,360,73830,65,NULL,'SALT2','SDSS J223041.15-004634.4',0.07,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156321,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ff',NULL,156321,37.8,0.06,363,73830,70,NULL,'SALT 2','SDSS J223041.15-004634.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156322,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 01241','R',156322,37.96,0.18,365,73830,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ff','SDSS J223041.15-004634.4',0.07,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156323,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ff',NULL,156323,37.81,0.06,365,73830,70,NULL,'SALT 2, Malmquist cor.','SDSS J223041.15-004634.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156324,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ff',NULL,156324,38.1,0.09,390,73830,65,NULL,'MLCS2k2','SDSS J223041.15-004634.4',0.07,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156325,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 01241','R',156325,38.12,0.07,394,73830,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ff','SDSS J223041.15-004634.4',0.07,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156326,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ff',NULL,156326,38.64,0.03,499,73830,70,NULL,'SDSS-II SN 01241','SDSS J223041.15-004634.4',0.07,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156327,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 08387','RN',156327,38.96,0.53,547,73831,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 08387',0.131815,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156328,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 08387','RN',156328,39.27,0.69,630,73831,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08387',0.131815,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156329,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156329,35.13,0.56,106,73832,70,NULL,NULL,'2MASX J22304398-1700324',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.08',0.36,NULL,NULL,NULL,NULL,NULL,1,337.683333,-17.00897,0.133,NULL,50244006168,785062596,12266603,16.08),(156330,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156330,35.13,0.48,106,73833,NULL,NULL,NULL,'UGC 12059',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000067,NULL,'14.83',0.7,'SBb',NULL,NULL,NULL,NULL,1,337.684083,22.54253,0.149,NULL,52356067403,818063553,12782243,14.83),(156331,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156331,35.18,0.2,109,73833,74.4,NULL,NULL,'UGC 12059',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156332,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156332,35.24,0.46,112,73833,NULL,NULL,'Malmquist cor.','UGC 12059',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156333,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156333,37.97,0.27,393,73834,70,NULL,NULL,'2MASX J22304424-0051207',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000154,NULL,'17.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,337.684417,-0.85567,0.153,NULL,50332609413,786447022,12288234,17.3),(156334,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156334,37.45,0.16,309,73835,70,NULL,NULL,'2MASX J22304500-0829071',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,337.687416667,-8.48519,0.161,NULL,50360064709,786876011,12294937,17.7),(156335,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156335,37.07,0.33,259,73836,70,NULL,NULL,'2MASX J22304552-0109267',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00015,NULL,'16.87',0.34,NULL,NULL,NULL,NULL,NULL,1,337.6895417,-1.15758,0.165,NULL,50332110231,786439222,12288112,16.87),(156336,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156336,31.94,0.4,24.4,73837,NULL,NULL,NULL,'UGC 12069',NULL,'2009AJ....138..323T',2009,1,1.5,NULL,'G',0.000017,NULL,'15.1',1.1,'SAB(s)dm','Isolated galaxy',NULL,NULL,NULL,1,337.692417,76.51108,1.109,NULL,52798703230,824979737,12890308,15.1),(156337,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156337,32.78,0.4,35.9,73837,75,NULL,'B','UGC 12069',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156338,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156338,37.54,0.46,322,73838,70,NULL,NULL,'2MASX J22304670+0031593',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,337.69475,0.53314,0.181,NULL,52412280918,818941889,12795967,17.1),(156339,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20581','RN',156339,39.95,0.19,810,73839,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007qm','SDSS-II SN 20581',0.204807,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156340,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20581','RN',156340,40.22,0.13,918,73839,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007qm','SDSS-II SN 20581',0.204807,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156341,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20581','N',156341,39.82,0.08,920,73839,70,NULL,'SALT 2','SDSS-II SN 20581',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156342,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20581','N',156342,39.83,0.08,925,73839,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20581',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156343,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156343,35.19,0.58,109,73840,70,NULL,NULL,'2MASX J22304886-1842545',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.93',0.2,NULL,NULL,NULL,NULL,NULL,1,337.703667,-18.71519,0.109,NULL,50262519238,785351863,12271122,15.93),(156344,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156344,38.02,0.46,402,73841,70,NULL,NULL,'2MASX J22305012-0114597',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,337.7087917,-1.25003,0.161,NULL,50331998587,786437477,12288085,18.1),(156345,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156345,36.35,0.5,186,73842,70,NULL,NULL,'2MASX J22305241-1338047',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.12',0.46,NULL,NULL,NULL,NULL,NULL,1,337.718333,-13.63469,0.153,NULL,50417370406,787771412,12308928,16.12),(156346,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156346,37.07,0.33,259,73843,70,NULL,NULL,'2MASX J22305692-0104447',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000175,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,337.737125,-1.07922,0.165,NULL,50332650859,786447669,12288244,17.2),(156347,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156347,33.93,0.8,61.1,73844,75,NULL,'MAT, I','NGC 7300',NULL,'1997ApJS..109..333W',1997,1,2,'The IC identification is not certain.','G',0.000033,NULL,'13.6',1,'SAB(rs)b:      HII','in a pair',NULL,NULL,NULL,1,337.749625,-14.00353,0.161,NULL,50417614239,787775222,12308987,13.6),(156348,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156348,33.8,0.43,57.7,73844,75,NULL,'MAT, I, raw','NGC 7300',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156349,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156349,33.87,0.32,59.3,73844,85,NULL,'I, raw','NGC 7300',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156350,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156350,33.94,0.32,61.3,73844,85,NULL,'I, inv','NGC 7300',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156351,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156351,34.1,0.43,66.1,73844,75,NULL,'MAT, I, inv','NGC 7300',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156352,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156352,34.12,0.43,66.6,73844,75,NULL,'MAT, I, cor','NGC 7300',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156353,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156353,34.18,0.31,68.4,73844,NULL,NULL,'Malmquist cor.','NGC 7300',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156354,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156354,34.21,0.2,69.5,73844,74.4,NULL,NULL,'NGC 7300',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156355,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156355,34.33,0.28,73.4,73844,NULL,NULL,NULL,'NGC 7300',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156356,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156356,37.45,0.16,309,73845,70,NULL,NULL,'2MASX J22310012-0829318',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000166,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,337.750625,-8.49214,0.161,NULL,50359594949,786868671,12294822,17),(156357,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15179','RN',156357,40.42,0.3,1150,73846,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15179',0.057258,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156358,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15179','RN',156358,41.91,0.42,2280,73846,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15179',0.057258,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156359,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156359,36.09,0.52,165,73847,70,NULL,NULL,'2MASX J22310394-8013169',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'16.4b',0.27,NULL,NULL,NULL,NULL,NULL,1,337.766583,-80.22142,0.441,NULL,48567557822,758868090,11857313,16.4),(156360,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156360,36.92,0.46,242,73848,70,NULL,NULL,'2MASX J22310455-0746478',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,337.768875,-7.77992,0.157,NULL,50360257231,786879019,12294984,17.5),(156361,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156361,35.89,0.51,151,73849,70,NULL,NULL,'2MASX J22310580-1921315',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.17',0.2,NULL,NULL,NULL,NULL,NULL,1,337.7740417,-19.35869,0.093,NULL,50262952393,785358631,12271228,16.17),(156362,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156362,37.97,0.27,393,73850,70,NULL,NULL,'2MASX J22310893-0027430',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,337.787375,-0.462,0.133,NULL,50331870632,786435478,12288054,18),(156363,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156363,34.74,0.8,88.5,73851,75,NULL,'W91PP, r','UGC 12063',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'15.26',0.5,'Sab',NULL,NULL,NULL,NULL,1,337.794917,35.37511,0.517,NULL,55454733485,866480210,13538753,15.26),(156364,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156364,34.73,0.35,88.5,73851,NULL,NULL,'Malmquist cor.','UGC 12063',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156365,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156365,34.8,0.34,91.1,73851,NULL,NULL,NULL,'UGC 12063',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156366,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156366,34.82,0.4,91.9,73851,NULL,NULL,'mean','UGC 12063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156367,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156367,34.86,0.38,93.9,73851,75,NULL,'W91PP, r, raw','UGC 12063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156368,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156368,34.98,0.38,99.1,73851,75,NULL,'W91PP, r, cor','UGC 12063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156369,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156369,35.06,0.38,103,73851,75,NULL,'W91PP, r, inv','UGC 12063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156370,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156370,35.08,0.2,104,73851,74.4,NULL,NULL,'UGC 12063',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156371,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156371,35.12,0.47,106,73851,NULL,NULL,'H','UGC 12063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156372,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156372,38.06,0.33,409,73852,70,NULL,NULL,'2MASX J22311102-0045080',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.47',0.17,NULL,NULL,NULL,NULL,NULL,1,337.795875,-0.75231,0.145,NULL,50332517287,786445582,12288212,18.47),(156373,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05513','RN',156373,40.45,0.23,965,73853,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 05513',0.277766,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156374,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05513','RN',156374,41.11,0.24,1300,73853,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05513',0.277766,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156375,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156375,36.64,0.46,213,73854,70,NULL,NULL,'2MASX J22311127+0008178',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000177,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,337.797,0.13822,0.169,NULL,51673877820,807404340,12615692,16.7),(156376,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 06177','RN',156376,39.67,0.26,761,73855,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 01679 HOST',0.129373,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156377,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 01679','RN',156377,39.88,0.22,837,73855,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 01679 HOST',0.129373,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156378,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 01679','RN',156378,40.39,0.25,1060,73855,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 01679 HOST',0.129373,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156379,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 06177','RN',156379,40.48,0.28,1110,73855,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 01679 HOST',0.129373,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156380,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156380,36.35,0.46,186,73856,70,NULL,NULL,'2MASX J22311320-0022540',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,337.804917,-0.38161,0.133,NULL,50331861318,786435333,12288052,16.9),(156381,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156381,35.29,0.47,114,73857,70,NULL,NULL,'MCG -03-57-016',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00013,NULL,'15',0.4,NULL,NULL,NULL,NULL,NULL,1,337.805417,-17.32803,0.133,NULL,50244488079,785070126,12266720,15),(156382,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156382,34.88,0.47,94.8,73858,NULL,NULL,NULL,'ESO 468- G 005',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'16',0.4,'(R\'_2)SB(s)a:',NULL,NULL,NULL,NULL,1,337.8059583,-28.53722,0,NULL,50067983961,782312249,12223628,16),(156383,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156383,34.92,0.2,96.4,73858,74.4,NULL,NULL,'ESO 468- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156384,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156384,34.94,0.45,97.5,73858,NULL,NULL,'Malmquist cor.','ESO 468- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156385,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156385,37.97,0.27,393,73859,70,NULL,NULL,'SDSS J223116.62-003031.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000159,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,337.8192917,-0.50872,0.133,NULL,50331802911,786434420,12288037,18.4),(156386,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156386,38.68,0.46,545,73860,70,NULL,NULL,'2MASX J22311831+1220477',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000142,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,337.826375,12.34653,0.193,NULL,52581568502,821587007,12837296,18.3),(156387,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156387,34.26,0.4,71.1,73861,NULL,NULL,'mean','UGC 12064',NULL,'2007A&A...465...71T',2007,1,1.1,'May contribute to the radio flux of 3C 449 = CGCG 514-050.','G',0.000077,NULL,'14.49',1.1,'S0-:','X-ray-bright group member',NULL,NULL,'Flat-Spectrum Radio Source',1,337.83575,39.35819,0.525,NULL,55526616338,867603380,13556302,14.49),(156388,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156388,34.93,0.45,96.7,73861,NULL,NULL,'K','UGC 12064',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156389,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 01782',NULL,156389,40.01,0.29,1000,73862,70,NULL,'SN photometric redshift distance, z photo =0.270 +/- 0.047','SDSS-II SN 01782',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,337.8455417,0.24939,0.169,NULL,51674045369,807406958,12615733,NULL),(156390,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 13861',NULL,156390,40.46,0.18,1240,73863,70,NULL,'SN photometric redshift distance, z photo =0.346 +/- 0.037','SDSS-II SN 13861',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,337.8475,0.07536,0.169,NULL,51673842841,807403794,12615684,NULL),(156391,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 13861','R',156391,41.6,0.23,1500,73863,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13861',0.393679,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156392,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 13861','R',156392,41.62,0.27,1510,73863,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13861',0.393679,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156393,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 14186','R',156393,40.69,0.15,1050,73864,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 14186',0.3132,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,337.8504583,0.99219,0.161,NULL,52413070091,818954220,12796159,NULL),(156394,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 14186','R',156394,40.77,0.24,1080,73864,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 14186',0.3132,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156395,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156395,37.06,0.46,259,73865,70,NULL,NULL,'2MASX J22312442-0047420',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,337.85175,-0.79511,0.145,NULL,50332518290,786445598,12288212,17.4),(156396,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156396,35.19,0.57,109,73866,70,NULL,NULL,'2MASX J22312491-0717348',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'16.46',0.42,NULL,NULL,NULL,NULL,NULL,1,337.85375,-7.29306,0.173,NULL,50390691084,787354548,12302414,16.46),(156397,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156397,34.88,0.8,94.8,73867,75,NULL,'MAT, I','ESO 602- G 025',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.02',0.7,'SA(r)b;LIRG;HIILINER','Field galaxy',NULL,NULL,'Sy',1,337.856167,-19.03447,0.089,NULL,50263417126,785365892,12271342,14.02),(156398,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156398,34.26,0.32,71.2,73867,85,NULL,'I, raw','ESO 602- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156399,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156399,34.29,0.43,72.1,73867,75,NULL,'MAT, I, raw','ESO 602- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156400,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156400,34.32,0.32,73.1,73867,85,NULL,'I, inv','ESO 602- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156401,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156401,34.52,0.45,80.3,73867,NULL,NULL,'K','ESO 602- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156402,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156402,34.53,0.47,80.4,73867,NULL,NULL,'H','ESO 602- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156403,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156403,34.54,0.43,80.8,73867,75,NULL,'MAT, I, inv','ESO 602- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156404,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156404,34.6,0.43,83.1,73867,75,NULL,'MAT, I, cor','ESO 602- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156405,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156405,34.7,0.56,87,73867,NULL,NULL,'Malmquist cor.','ESO 602- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156406,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156406,34.72,0.46,88,73867,NULL,NULL,'J','ESO 602- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156407,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156407,34.87,0.4,94.2,73867,NULL,NULL,'mean','ESO 602- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156408,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156408,34.88,0.52,94.7,73867,NULL,NULL,NULL,'ESO 602- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156409,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156409,34.92,0.2,96.4,73867,74.4,NULL,NULL,'ESO 602- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156410,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156410,37.45,0.16,309,73868,70,NULL,NULL,'2MASX J22312600-0827328',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,337.858291667,-8.45897,0.161,NULL,50359621073,786869079,12294829,17.6),(156411,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156411,37.04,0.46,255,73869,70,NULL,NULL,'2MASX J22312770+1355327',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,337.865625,13.92578,0.149,NULL,52582916600,821608071,12837626,17.9),(156412,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156412,38.79,0.46,572,73870,70,NULL,NULL,'2MASX J22313000-0114120',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000177,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,337.875,-1.23675,0.169,NULL,50332475105,786444923,12288201,17.7),(156413,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 21724','RN',156413,42.27,0.27,2150,73871,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 21724',0.32522,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156414,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156414,37.45,0.16,309,73872,70,NULL,NULL,'SDSS J223131.88-082600.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,337.882875,-8.43336,0.161,NULL,50359623201,786869112,12294829,18.3),(156415,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SN 2005le',NULL,156415,39.8,0.15,730,73873,74.2,NULL,'SALT 2','SDSS J223132.21-002937.2',0.25,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,337.884208333,-0.49367,0.133,NULL,50331811591,786434556,12288039,NULL),(156416,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SN 2005le',NULL,156416,40.46,0.16,990,73873,70,NULL,'SDSS-II SN 09032, SALT 2','SDSS J223132.21-002937.2',0.25,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156417,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SN 2005le',NULL,156417,40.5,0.16,1010,73873,65,NULL,'SALT2','SDSS J223132.21-002937.2',0.25,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156418,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 09032','R',156418,40.51,0.24,1010,73873,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005le','SDSS J223132.21-002937.2',0.25,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156419,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SN 2005le',NULL,156419,40.58,0.06,1040,73873,70,NULL,'SDSS-II SN 09032','SDSS J223132.21-002937.2',0.25,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156420,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 09032','R',156420,40.57,0.18,1040,73873,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005le','SDSS J223132.21-002937.2',0.25,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156421,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SN 2005le',NULL,156421,40.62,0.16,1060,73873,65,NULL,'MLCS2k2','SDSS J223132.21-002937.2',0.25,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156422,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156422,38.06,0.33,409,73874,70,NULL,NULL,'2MASX J22313259-0044420',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000174,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,337.8857917,-0.74506,0.145,NULL,50332525673,786445713,12288214,17.5),(156423,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156423,31.88,0.64,23.8,73875,NULL,NULL,'Malmquist cor.','NGC 7303',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'13.58',1.2,'S?             LINER',NULL,NULL,NULL,NULL,1,337.8867917,30.95597,0.349,NULL,55491476210,867054315,13547723,13.58),(156424,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156424,31.9,0.64,24,73875,NULL,NULL,NULL,'NGC 7303',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156425,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156425,31.94,0.2,24.4,73875,74.4,NULL,NULL,'NGC 7303',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156426,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156426,33.44,0.47,48.7,73875,NULL,NULL,'H','NGC 7303',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156427,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156427,33.51,0.4,50.5,73875,NULL,NULL,'mean','NGC 7303',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156428,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156428,33.57,0.46,51.7,73875,NULL,NULL,'J','NGC 7303',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156429,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156429,33.63,0.45,53.2,73875,NULL,NULL,'K','NGC 7303',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156430,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156430,37.54,0.46,323,73876,70,NULL,NULL,'SDSS J223133.13+135507.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000127,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,337.888083,13.91878,0.149,NULL,52582917650,821608088,12837626,18.1),(156431,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156431,37.45,0.16,309,73877,70,NULL,NULL,'2MASX J22313864-0837018',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,337.910875,-8.61703,0.161,NULL,50359636164,786869315,12294833,17.4),(156432,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156432,37.45,0.16,309,73878,70,NULL,NULL,'PKS 2229-08',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.00015,NULL,'15.4g',0.57,'Elliptical;BrClG',NULL,NULL,'radio jet',NULL,1,337.929958333,-8.40881,0.137,NULL,50359754900,786871170,12294862,15.4),(156433,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156433,35.15,0.49,107,73879,75,NULL,'IR','ESO 468- G 007',NULL,'2011yCatp016004901K',2011,1,1,'Ratcliffe et al. (1998MNRAS.300..417R) give v = 2040 km/sec.','G',0.000033,NULL,'16.11',0.2,'S              HII',NULL,NULL,NULL,NULL,1,337.936791667,-27.30167,0.017,NULL,50070602176,782353159,12224268,16.11),(156434,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156434,35.32,0.44,116,73879,NULL,NULL,'Malmquist cor.','ESO 468- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156435,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156435,35.36,0.43,118,73879,NULL,NULL,NULL,'ESO 468- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156436,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156436,35.4,0.2,120,73879,74.4,NULL,NULL,'ESO 468- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156437,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156437,35.42,0.4,121,73880,NULL,NULL,'Malmquist cor.','UGC 12067',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000017,NULL,'15.00',0.6,'Sa','Pair member, S + S',NULL,NULL,NULL,1,337.9435417,20.60397,0.165,NULL,52408862074,818888469,12795132,15),(156438,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156438,35.45,0.4,123,73880,NULL,NULL,NULL,'UGC 12067',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156439,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156439,35.79,0.2,144,73880,74.4,NULL,NULL,'UGC 12067',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156440,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156440,42.13,0.33,1360,73881,73,NULL,'H const./H=100','GRB 990712',0.4331,'2006astro.ph..9262M',2006,1,0.02,NULL,'G',0.0004,NULL,'22.3V',0.02,'SAX/WFC',NULL,NULL,NULL,NULL,1,337.971083333,-73.40794,0.061,NULL,48414280914,756473139,11819892,22.3),(156441,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156441,41.51,0.58,1400,73881,72,NULL,NULL,'GRB 990712',0.4331,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156442,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156442,41.63,0.53,1480,73881,70,NULL,NULL,'GRB 990712',0.4331,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156443,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156443,41.76,0.44,1570,73881,69.7,NULL,'Calibrated','GRB 990712',0.4331,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156444,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156444,41.78,0.26,1580,73881,73,NULL,'H const./H=100','GRB 990712',0.4331,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156445,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156445,41.96,0.62,1720,73881,69.7,NULL,'Fiducial','GRB 990712',0.4331,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156446,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 02082','RN',156446,42.43,0.2,2040,73882,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02082',0.500691,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156447,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156447,34.22,0.8,69.9,73883,75,NULL,'MAT, I','MCG -03-57-018',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00003,NULL,'15',0.8,'SB(s)cd',NULL,NULL,NULL,NULL,1,337.982041667,-17.14506,0.133,NULL,50242116029,785033062,12266141,15),(156448,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156448,34.34,0.53,73.8,73883,NULL,NULL,'Malmquist cor.','MCG -03-57-018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156449,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156449,34.39,0.52,75.5,73883,NULL,NULL,NULL,'MCG -03-57-018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156450,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156450,34.49,0.2,79.1,73883,74.4,NULL,NULL,'MCG -03-57-018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156451,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156451,35.16,0.43,108,73883,75,NULL,'MAT, I, raw','MCG -03-57-018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156452,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156452,35.32,0.43,116,73883,75,NULL,'MAT, I, inv','MCG -03-57-018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156453,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156453,35.36,0.32,118,73883,85,NULL,'I, raw','MCG -03-57-018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156454,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156454,35.4,0.32,120,73883,85,NULL,'I, inv','MCG -03-57-018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156455,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156455,35.46,0.43,123,73883,75,NULL,'MAT, I, cor','MCG -03-57-018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156456,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156456,35.17,0.47,108,73884,70,NULL,NULL,'MCG -03-57-019',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15',0.6,NULL,NULL,NULL,NULL,NULL,1,337.9932917,-15.44,0.105,NULL,50244837483,785075585,12266806,15),(156457,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156457,38.12,0.46,420,73885,70,NULL,NULL,'2MASX J22315852+1318353',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,337.993917,13.30981,0.137,NULL,52583193182,821612393,12837693,17.6),(156458,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156458,38.06,0.46,410,73886,70,NULL,NULL,'SDSS J223201.64+143817.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,338.006875,14.63825,0.177,NULL,52582135296,821595864,12837435,18.4),(156459,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156459,35.65,0.46,135,73887,NULL,NULL,'Malmquist cor.','UGC 12068',NULL,'2009ApJS..182..474S',2009,1,1.08,NULL,'G',0.000101,NULL,'14.9g',0.56,'Sb',NULL,NULL,NULL,NULL,1,338.0302083,0.03708,0.185,NULL,51673944810,807405387,12615709,14.9),(156460,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156460,36.1,0.38,166,73887,NULL,NULL,NULL,'UGC 12068',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156461,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156461,36.35,0.2,186,73887,74.4,NULL,NULL,'UGC 12068',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156462,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156462,37.22,0.46,278,73888,70,NULL,NULL,'2MASX J22320769+1242023',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,338.032,12.70061,0.177,NULL,52581685543,821588836,12837325,17.7),(156463,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156463,36.52,0.46,201,73889,70,NULL,NULL,'2MASX J22321137-0751316',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00015,NULL,'16.3g',0.42,'AGN',NULL,NULL,NULL,NULL,1,338.047333333,-7.85886,0.153,NULL,50359390827,786865481,12294773,16.3),(156464,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 06807','RN',156464,40.66,0.18,1050,73890,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06807',0.295,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156465,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 06807','RN',156465,40.73,0.29,1080,73890,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06807',0.295,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156466,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 09317','R',156466,40.39,0.44,953,73891,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 09317',0.256085,'2014arXiv1401.3317S',2014,1,0.09,NULL,'G',NULL,'PHOT','20.4g',0.07,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,338.073916667,0.64311,0.193,NULL,52412101716,818939089,12795923,20.4),(156467,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 09317',NULL,156467,40.19,0.33,1090,73891,70,NULL,'SN photometric redshift distance, z photo =0.298 +/- 0.060','SDSS-II SN 09317',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156468,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156468,38.96,0.46,620,73892,70,NULL,NULL,'2MASX J22321880-0024210',NULL,'2015arXiv151105856S',2015,1,0.09,NULL,'G',0.000208,NULL,'18.1g',0.06,NULL,NULL,NULL,NULL,NULL,1,338.078375,-0.40592,0.177,NULL,49459320164,772801877,12075029,18.1),(156469,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 15291',NULL,156469,40.05,0.25,1020,73893,70,NULL,'SN photometric redshift distance, z photo =0.276 +/- 0.041','SDSS-II SN 15291',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,338.083833,-1.15178,0.193,NULL,50332453205,786444581,12288196,NULL),(156470,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156470,35.95,0.47,155,73894,NULL,NULL,'Malmquist cor.','CGCG 474-005',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000033,NULL,'15.7',0.3,'Sc',NULL,NULL,NULL,NULL,1,338.082833,23.86353,0.165,NULL,52354910216,818045472,12781960,15.7),(156471,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156471,36.1,0.44,166,73894,NULL,NULL,NULL,'CGCG 474-005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156472,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156472,36.18,0.2,172,73894,74.4,NULL,NULL,'CGCG 474-005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156473,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156473,36.96,0.46,247,73895,70,NULL,NULL,'2MASX J22322054+1355520',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000173,NULL,'16.1g',0.41,'E0',NULL,NULL,NULL,NULL,1,338.085583333,13.93103,0.149,NULL,52582502092,821601595,12837524,16.1),(156474,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156474,39,0.46,630,73896,70,NULL,NULL,'2MASX J22322074-0040570',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000178,NULL,'18.6g',0.14,'AGN',NULL,NULL,NULL,NULL,1,338.086291667,-0.68267,0.133,NULL,50331782184,786434096,12288032,18.6),(156475,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 15103',NULL,156475,40.59,0.14,1310,73897,70,NULL,'SN photometric redshift distance, z photo =0.373 +/- 0.032','SDSS-II SN 15103',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,338.098583,-0.50469,0.133,NULL,49459358738,772802480,12075038,NULL),(156476,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 15103','R',156476,41.76,0.29,1610,73897,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15103',0.397,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156477,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 15103','R',156477,41.84,0.25,1670,73897,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15103',0.397,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156478,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 15103',NULL,156478,41.7,0.19,2190,73897,70,NULL,'SALT 2','SDSS-II SN 15103',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156479,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 15103',NULL,156479,41.76,0.19,2250,73897,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15103',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156480,'SBF','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156480,31.88,0.21,23.8,73898,NULL,NULL,'I','NGC 7302',NULL,'2001ApJ...546..681T',2001,1,1.8,NULL,'G',0.000053,NULL,'13.58',1.1,'SA(s)0-:','in a pair',NULL,NULL,NULL,1,338.099167,-14.12053,0.173,NULL,50417562855,787774419,12308975,13.58),(156481,'SBF','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156481,31.93,0.14,24.3,73898,74.4,NULL,NULL,'NGC 7302',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156482,'Faber-Jackson','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156482,32.49,0.37,31.5,73898,95,NULL,'Weighted Mean','NGC 7302',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156483,'Faber-Jackson','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156483,32.91,0.63,38.2,73898,95,NULL,'Michard 1979b, c','NGC 7302',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156484,'Faber-Jackson','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156484,33,0.46,39.8,73898,95,NULL,'Michard 1979a','NGC 7302',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156485,'Faber-Jackson','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156485,33.85,0.81,58.9,73898,55,NULL,'Visvanathan & Sandage 1979','NGC 7302',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156486,'Tully est','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156486,32.64,0.8,33.7,73898,75,NULL,'B','NGC 7302',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156487,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156487,38.19,0.46,434,73899,70,NULL,NULL,'2MASX J22322448+0034316',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,338.101958333,0.57536,0.193,NULL,51673969428,807405772,12615715,17.6),(156488,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2006gr',NULL,156488,35.24,0.16,108,73900,74.2,NULL,'SALT 2','UGC 12071',0.034597,'2010ApJ...716..712A',2010,1,1.2,NULL,'G',0.000033,NULL,'14.97',0.4,'SBb',NULL,NULL,NULL,NULL,1,338.102083,30.83556,0.349,NULL,55491590589,867056102,13547751,14.97),(156489,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2006gr',NULL,156489,35.81,0.09,145,73900,74.4,NULL,NULL,'UGC 12071',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156490,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2006gr',NULL,156490,35.91,0.15,147,73900,70,NULL,'SALT 2','UGC 12071',0.034597,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156491,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2006gr',NULL,156491,35.99,0.15,153,73900,73.8,NULL,'SALT 2 (SNANA)','UGC 12071',0.0336,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156492,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2006gr',NULL,156492,36,0.19,153,73900,72,NULL,NULL,'UGC 12071',0.034597,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156493,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2006gr',NULL,156493,36.02,0.16,155,73900,65,NULL,'SALT','UGC 12071',0.034597,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156494,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2006gr',NULL,156494,36.09,0.04,160,73900,72,NULL,NULL,'UGC 12071',0.034597,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156495,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2006gr',NULL,156495,36.12,0.18,162,73900,65,NULL,'SALT2','UGC 12071',0.034597,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156496,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2006gr',NULL,156496,36.12,0.15,162,73900,72,NULL,NULL,'UGC 12071',0.034597,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156497,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2006gr',NULL,156497,36.21,0.14,168,73900,65,NULL,'MLCS17','UGC 12071',0.034597,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156498,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2006gr',NULL,156498,36.21,0.15,169,73900,65,NULL,'MLCS31','UGC 12071',0.034597,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156499,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2006gr',NULL,156499,36.39,0.03,183,73900,70,NULL,'SALT 2','UGC 12071',0.034597,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156500,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2006gr',NULL,156500,36.37,0.27,188,73900,72,NULL,'M(H) = -18.317 mag','UGC 12071',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156501,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156501,35.68,0.8,137,73900,75,NULL,'W91PP, r','UGC 12071',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156502,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156502,34.86,0.38,93.6,73900,75,NULL,'W91PP, r, raw','UGC 12071',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156503,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156503,34.95,0.38,97.9,73900,75,NULL,'W91PP, r, cor','UGC 12071',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156504,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156504,35.04,0.38,102,73900,75,NULL,'W91PP, r, inv','UGC 12071',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156505,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156505,38.1,0.46,417,73901,70,NULL,NULL,'2MASX J22322684-0842079',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000187,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,338.111917,-8.70219,0.165,NULL,50359532136,786867689,12294807,17),(156506,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15471','RN',156506,41.08,0.22,1430,73902,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15471',0.153213,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156507,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15471','RN',156507,41.53,0.34,1750,73902,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15471',0.153213,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156508,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13307','RN',156508,39.56,0.12,751,73903,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13307',0.08853,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156509,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13307','RN',156509,40.19,0.22,1000,73903,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13307',0.08853,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156510,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156510,37.45,0.16,309,73904,70,NULL,NULL,'2MASX J22322980-0823229',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00015,NULL,'16.9g',0.32,NULL,NULL,NULL,NULL,NULL,1,338.124125,-8.38953,0.137,NULL,50359738753,786870918,12294858,16.9),(156511,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15400','RN',156511,43.74,0.74,5160,73905,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15400',0.085468,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156512,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15400','RN',156512,46.65,0.98,19700,73905,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15400',0.085468,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156513,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156513,33.42,0.47,48.2,73906,NULL,NULL,'H','IC 5226',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000017,NULL,'13.54',1.4,'SB(r)b',NULL,NULL,NULL,NULL,1,338.125875,-25.66197,0.017,NULL,50076071952,782438624,12225603,13.54),(156514,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156514,33.58,0.45,52.1,73906,NULL,NULL,'K','IC 5226',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156515,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156515,33.6,0.46,52.6,73906,NULL,NULL,'J','IC 5226',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156516,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156516,34.15,0.4,67.7,73906,NULL,NULL,'mean','IC 5226',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156517,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156517,35.99,0.46,158,73907,70,NULL,NULL,'2MASX J22323135+0041156',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000167,NULL,'16.1g',0.27,'E0',NULL,NULL,NULL,NULL,1,338.130625,0.68758,0.193,NULL,52412089065,818938891,12795920,16.1),(156518,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 20829','R',156518,41.07,0.29,1250,73908,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007qu','SDSS J223232.65+005133.7',0.304931,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',NULL,NULL,'21.0g',0.05,NULL,NULL,NULL,NULL,NULL,1,338.1360417,0.85936,0.205,NULL,52412947773,818952308,12796129,21),(156519,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 20829','R',156519,41.38,0.2,1440,73908,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007qu','SDSS J223232.65+005133.7',0.304931,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156520,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156520,34.05,0.4,64.7,73909,NULL,NULL,'mean','UGC 12073',NULL,'2007A&A...465...71T',2007,1,2.1,NULL,'G',0.000037,NULL,'14.4',0.8,'SB(s)b','X-ray-bright group member',NULL,NULL,NULL,1,338.139,39.2155,0.525,NULL,55527817228,867622144,13556596,14.4),(156521,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156521,34.16,0.36,68,73909,NULL,NULL,NULL,'UGC 12073',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156522,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156522,34.2,0.2,69.2,73909,74.4,NULL,NULL,'UGC 12073',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156523,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156523,34.23,0.49,70.1,73909,75,NULL,'IR','UGC 12073',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156524,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156524,34.32,0.34,73,73909,NULL,NULL,'Malmquist cor.','UGC 12073',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156525,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156525,34.43,0.46,76.8,73909,NULL,NULL,'J','UGC 12073',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156526,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156526,34.44,0.47,77.1,73909,NULL,NULL,'H','UGC 12073',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156527,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156527,34.45,0.45,77.6,73909,NULL,NULL,'K','UGC 12073',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156528,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156528,35.69,0.56,137,73910,70,NULL,NULL,'MCG -02-57-014',NULL,'2014MNRAS.445.2677S',2014,1,0.79,NULL,'G',0.00015,NULL,'14.8g',0.6,'E0',NULL,NULL,NULL,NULL,1,338.143625,-9.51919,0.165,NULL,50361372738,786896449,12295257,14.8),(156529,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156529,35.8,0.46,145,73910,70,NULL,NULL,'MCG -02-57-014',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156530,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156530,36.79,0.27,228,73911,70,NULL,NULL,'2MASX J22323628-0057355',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,338.151333,-0.95994,0.173,NULL,50332266120,786441658,12288150,17),(156531,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156531,34.95,0.8,97.9,73912,75,NULL,'W91PP, r','UGC 12072',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'16.5',0.2,'S?',NULL,NULL,NULL,NULL,1,338.1522917,23.93178,0.185,NULL,52354921388,818045646,12781963,16.5),(156532,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156532,35.48,0.38,125,73912,75,NULL,'W91PP, r, raw','UGC 12072',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156533,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156533,35.57,0.38,130,73912,75,NULL,'W91PP, r, inv','UGC 12072',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156534,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156534,35.63,0.49,133,73912,75,NULL,'IR','UGC 12072',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156535,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156535,35.77,0.38,142,73912,75,NULL,'W91PP, r, cor','UGC 12072',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156536,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156536,35.79,0.49,144,73912,NULL,NULL,'Malmquist cor.','UGC 12072',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156537,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156537,35.93,0.46,154,73912,NULL,NULL,NULL,'UGC 12072',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156538,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156538,35.97,0.2,156,73912,74.4,NULL,NULL,'UGC 12072',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156539,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156539,37.93,0.46,386,73913,70,NULL,NULL,'SDSS J223240.50+121536.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00013,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,338.1687917,12.26006,0.201,NULL,52581721507,821589398,12837334,18.1),(156540,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156540,38.6,0.46,525,73914,70,NULL,NULL,'SDSS J223241.00-010046.0',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,338.170833,-1.01278,0.173,NULL,50332270097,786441720,12288151,18.4),(156541,'Horizontal Branch','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156541,24.55,0.12,0.811,73915,NULL,NULL,NULL,'Andromeda XXVIII',NULL,'2015ApJ...806..230S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,338.171667,31.21617,0.365,1,55491159559,867049368,13547646,NULL),(156542,'TRGB','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156542,24.1,0.5,0.65,73915,NULL,NULL,NULL,'Andromeda XXVIII',NULL,'2011ApJ...742L..14S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156543,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156543,36.41,0.46,191,73916,70,NULL,NULL,'2MASX J22324170-0927469',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00015,NULL,'16.1g',0.39,'S0/a',NULL,NULL,NULL,NULL,1,338.173583,-9.46303,0.157,NULL,50361399413,786896865,12295263,16.1),(156544,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','PTF10wor','N',156544,37.01,0.11,239,73917,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10wor',0.0568,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156545,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156545,35.03,0.49,101,73918,70,NULL,NULL,'FAIRALL 0131',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'15.98',0.52,'(R:)SA0^+:',NULL,NULL,NULL,NULL,1,338.185833,-59.47158,0,NULL,48799720751,762495636,11913994,15.98),(156546,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156546,37.82,0.33,366,73919,70,NULL,NULL,'2MASXi J2232474-011005',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000173,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,338.197917,-1.16831,0.193,NULL,50332384068,786443501,12288179,17.8),(156547,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156547,37.04,0.46,256,73920,70,NULL,NULL,'2MASX J22324911-0755599',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000138,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,338.2045417,-7.93328,0.153,NULL,50359321797,786864403,12294756,18),(156548,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156548,37.82,0.33,366,73921,70,NULL,NULL,'2MASX J22324962-0111145',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000174,NULL,'17.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,338.206833,-1.18731,0.193,NULL,50332375192,786443362,12288177,17.2),(156549,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 19319','RN',156549,39.74,0.16,772,73922,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19319',0.150863,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156550,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 19319','RN',156550,40.69,0.25,1190,73922,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19319',0.150863,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156551,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156551,36.79,0.27,228,73923,70,NULL,NULL,'2MASX J22325302-0058245',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000187,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,338.2210417,-0.9735,0.173,NULL,50332297089,786442142,12288158,16.3),(156552,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 06180','RN',156552,39.03,0.53,605,73924,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06180',0.057051,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156553,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 06180','RN',156553,41.57,0.5,1950,73924,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06180',0.057051,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156554,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156554,38.24,0.27,445,73925,70,NULL,NULL,'2MASX J22325695+1314018',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000135,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,338.2372917,13.23375,0.157,NULL,52582987831,821609184,12837643,18.2),(156555,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156555,37.75,0.46,355,73926,70,NULL,NULL,'2MASX J22330026+1233299',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000143,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,338.2512917,12.55825,0.173,NULL,52581851146,821591424,12837366,18),(156556,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156556,38.24,0.27,445,73927,70,NULL,NULL,'2MASX J22330462+1314559',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,338.26925,13.24883,0.157,NULL,52581132119,821580189,12837190,18.2),(156557,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156557,38.24,0.27,445,73928,70,NULL,NULL,'2MASX J22330462+1316079',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,338.26925,13.26892,0.157,NULL,52582980089,821609063,12837641,18.1),(156558,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156558,36.24,0.57,177,73929,70,NULL,NULL,'2MASX J22330595-2214250',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.42',NULL,'EL','Field galaxy',NULL,NULL,NULL,1,338.27475,-22.24044,0.073,NULL,50203299183,784426549,12256664,15.42),(156559,'Tully est','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156559,32.08,0.8,26.1,73930,75,NULL,'B','UGC 12074',NULL,'1988NBGC.C....0000T',1988,1,0.6,NULL,'G',0.000007,NULL,'14.41',0.4,'Irr            HII',NULL,NULL,NULL,NULL,1,338.2762083,8.09747,0.309,NULL,52451472895,819554263,12805535,14.41),(156560,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156560,31.6,0.69,20.8,73930,100,NULL,'mid-IR','UGC 12074',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156561,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156561,32.12,0.2,26.6,73930,74.4,NULL,NULL,'UGC 12074',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156562,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156562,32.16,0.4,27,73930,NULL,NULL,'mean','UGC 12074',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156563,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156563,32.54,0.45,32.2,73930,NULL,NULL,'K','UGC 12074',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156564,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156564,32.55,0.47,32.4,73930,NULL,NULL,'H','UGC 12074',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156565,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156565,32.58,0.46,32.8,73930,NULL,NULL,'J','UGC 12074',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156566,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156566,33.15,0.49,42.7,73931,75,NULL,'IR','FGC 2394',NULL,'2011yCatp016004901K',2011,1,1.62,NULL,'G',0.000017,NULL,'15.6',0.22,'Sdm',NULL,NULL,NULL,NULL,1,338.280625,72.47858,3.169,NULL,52786222434,824784725,12887261,15.6),(156567,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156567,33.74,0.43,56,73931,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2394',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156568,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156568,33.76,NULL,56.6,73931,NULL,NULL,NULL,'FGC 2394',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156569,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156569,33.91,NULL,60.4,73931,NULL,NULL,'Dipole','FGC 2394',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156570,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156570,33.91,NULL,60.4,73931,NULL,NULL,'Dipole + Quadrupole','FGC 2394',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156571,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156571,33.92,NULL,60.7,73931,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2394',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156572,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156572,37.32,0.46,290,73932,70,NULL,NULL,'2MASX J22330856-1008333',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00015,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,338.2857917,-10.14261,0.173,NULL,50364580410,786946568,12296040,16.5),(156573,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156573,34.7,0.48,87.2,73933,70,NULL,NULL,'MCG -03-57-021',NULL,'2014MNRAS.445.2677S',2014,1,3.5,NULL,'G',0.00012,NULL,'14.90',2.5,'(R\')SAB(rs)0^0^?',NULL,NULL,NULL,NULL,1,338.2892917,-17.06797,0.101,NULL,50242219169,785034674,12266166,14.9),(156574,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156574,35.8,0.76,145,73934,70,NULL,NULL,'2MASX J22331128-1447290',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'16.71',0.2,NULL,NULL,NULL,NULL,NULL,1,338.2970417,-14.79144,0.117,NULL,50430253234,787972706,12312073,16.71),(156575,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 21165','N',156575,42.12,0.35,2650,73935,70,NULL,'SALT 2','SDSS-II SN 21165',NULL,'2013ApJ...763...88C',2013,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156576,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 21165','N',156576,42.27,0.35,2840,73935,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 21165',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156577,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156577,35.85,0.59,148,73936,70,NULL,NULL,'2MASX J22331342-3737146',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'15.49',0.25,'(R_1)SAB(r)0^+',NULL,NULL,NULL,NULL,1,338.305833,-37.62064,0,NULL,50708412357,792318943,12379983,15.49),(156578,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156578,36.79,0.27,228,73937,70,NULL,NULL,'2MASX J22331420-0049453',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'16.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,338.309291667,-0.82925,0.149,NULL,49459633287,772806770,12075105,16.3),(156579,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156579,33.25,0.8,44.6,73938,75,NULL,'MAT, I','NGC 7306',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000013,NULL,'13.36',0.7,'(R\')SBb?',NULL,NULL,NULL,NULL,1,338.318625,-27.24661,0.061,NULL,50068970103,782327657,12223869,13.36),(156580,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156580,32.76,0.69,35.6,73938,100,NULL,'mid-IR','NGC 7306',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156581,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156581,33.18,0.32,43.3,73938,85,NULL,'I, raw','NGC 7306',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156582,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156582,33.2,0.43,43.7,73938,75,NULL,'MAT, I, raw','NGC 7306',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156583,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156583,33.23,0.32,44.2,73938,85,NULL,'I, inv','NGC 7306',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156584,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156584,33.24,0.47,44.4,73938,NULL,NULL,'H','NGC 7306',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156585,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156585,33.28,0.46,45.2,73938,NULL,NULL,'J','NGC 7306',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156586,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156586,33.29,0.45,45.5,73938,NULL,NULL,'K','NGC 7306',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156587,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156587,33.3,0.4,45.7,73938,NULL,NULL,'mean','NGC 7306',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156588,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156588,33.39,0.43,47.7,73938,75,NULL,'MAT, I, inv','NGC 7306',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156589,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156589,33.46,0.43,49.3,73938,75,NULL,'MAT, I, cor','NGC 7306',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156590,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156590,33.6,0.2,52.5,73938,74.4,NULL,NULL,'NGC 7306',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156591,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156591,33.82,0.46,58,73938,NULL,NULL,'Malmquist cor.','NGC 7306',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156592,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156592,33.89,0.45,59.9,73938,NULL,NULL,NULL,'NGC 7306',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156593,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 05506','RN',156593,40.59,0.25,1060,73939,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 05506',0.238884,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156594,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 05506','RN',156594,40.99,0.34,1270,73939,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05506',0.238884,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156595,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 12327','RN',156595,39.78,1.53,842,73940,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 12327',0.07381,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156596,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 12327','RN',156596,40.08,0.51,968,73940,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 12327',0.07381,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156597,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156597,37.56,0.46,325,73941,70,NULL,NULL,'SDSS J223325.06-003637.3',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,338.3544583,-0.61039,0.153,NULL,49460172662,772815197,12075237,17.5),(156598,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156598,37.36,0.46,296,73942,70,NULL,NULL,'2MASX J22332549-0822128',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,338.356333,-8.37028,0.153,NULL,50359881647,786873150,12294892,16.8),(156599,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 17410','RN',156599,42.8,0.18,2310,73943,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17410',0.573059,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156600,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156600,37.16,0.46,270,73944,70,NULL,NULL,'2MASX J22333056-0030516',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,338.3774583,-0.51428,0.153,NULL,49460277052,772816828,12075262,17.1),(156601,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156601,35.18,0.51,109,73945,70,NULL,NULL,'ESO 345- G 024',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00011,NULL,'15.28',0.37,'S0',NULL,NULL,NULL,NULL,1,338.383,-37.54403,0,NULL,50708405464,792318835,12379981,15.28),(156602,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156602,35.69,0.8,137,73946,75,NULL,'W91PP, r','UGC 12078',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'16.0',0.3,'S?',NULL,NULL,NULL,NULL,1,338.3889583,30.80481,0.365,NULL,55491575249,867055863,13547747,16),(156603,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156603,35.35,0.38,117,73946,75,NULL,'W91PP, r, raw','UGC 12078',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156604,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156604,35.47,0.38,124,73946,75,NULL,'W91PP, r, cor','UGC 12078',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156605,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156605,35.55,0.38,129,73946,75,NULL,'W91PP, r, inv','UGC 12078',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156606,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156606,35.66,0.46,135,73947,70,NULL,NULL,'2MASX J22333402-1010578',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00015,NULL,'15.4g',0.51,'E0',NULL,NULL,NULL,NULL,1,338.3917083,-10.18267,0.173,NULL,50364625651,786947275,12296051,15.4),(156607,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156607,35.96,0.49,156,73947,70,NULL,NULL,'2MASX J22333402-1010578',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156608,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 05745','RN',156608,39.81,0.35,862,73948,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05745',0.063477,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156609,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 05745','RN',156609,41.07,0.6,1540,73948,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 05745',0.063477,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156610,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156610,37.41,0.46,303,73949,70,NULL,NULL,'2MASX J22333854-0000296',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'16.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,338.4105417,-0.00825,0.193,NULL,49459860062,772810313,12075161,16.5),(156611,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156611,38.33,0.46,463,73950,70,NULL,NULL,'2MASX J22333883+1346588',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000196,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,338.41175,13.78289,0.137,NULL,52582446878,821600732,12837511,18.2),(156612,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156612,37.5,0.46,316,73951,70,NULL,NULL,'2MASX J22334166-0814058',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,338.423708333,-8.23511,0.149,NULL,50359835440,786872428,12294881,17.6),(156613,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 06085',NULL,156613,41.49,0.09,1980,73952,70,NULL,'SN photometric redshift distance, z photo =0.650 +/- 0.043','SDSS-II SN 06085',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,338.428625,0.40297,0.209,NULL,51674836086,807419313,12615926,NULL),(156614,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15268',NULL,156614,40.22,0.3,1110,73953,70,NULL,'SN photometric redshift distance, z photo =0.303 +/- 0.055','SDSS-II SN 15268',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,338.4449583,0.13867,0.201,NULL,51674282687,807410666,12615791,NULL),(156615,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15268','R',156615,41.01,0.23,1230,73953,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15268',0.298563,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156616,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15268','R',156616,41.14,0.15,1300,73953,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15268',0.298563,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156617,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15268',NULL,156617,40.8,0.12,1450,73953,70,NULL,'SALT 2','SDSS-II SN 15268',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156618,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15268',NULL,156618,40.83,0.12,1470,73953,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15268',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156619,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156619,38.55,0.46,514,73954,70,NULL,NULL,'SDSS J223347.23+125436.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000147,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,338.446791667,12.91019,0.157,NULL,52581288589,821582634,12837228,18.5),(156620,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2003gn','R',156620,36.05,0.06,162,73955,NULL,NULL,'MLCS2k2, R(V) = 3.1','CGCG 452-024',NULL,'2015Sci...347.1459K',2015,1,1,NULL,'G',0.000033,NULL,'15.24',0.3,'Sab',NULL,NULL,NULL,NULL,1,338.460333333,20.80531,0.157,NULL,52408578475,818884038,12795063,15.24),(156621,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2003gn',NULL,156621,36.14,0.15,163,73955,70,NULL,'SALT 2','CGCG 452-024',0.03445,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156622,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2003gn','R',156622,36.09,0.06,165,73955,NULL,NULL,'MLCS2k2, R(V) = 1.8','CGCG 452-024',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156623,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156623,32.06,0.8,25.8,73956,75,NULL,'MAT, I','NGC 7307',NULL,'1997ApJS..109..333W',1997,1,3.5,'Confused HIPASS source','G',0.000017,NULL,'12.92',0.9,'SB(s)cd pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,338.468917,-40.93272,0,NULL,50723978204,792562159,12383783,12.92),(156624,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156624,32.07,0.8,25.9,73956,75,NULL,'A82, H','NGC 7307',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156625,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156625,31.46,0.32,19.6,73956,85,NULL,'I, raw','NGC 7307',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156626,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156626,31.46,0.32,19.6,73956,85,NULL,'I, inv','NGC 7307',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156627,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156627,31.61,0.2,21,73956,74.4,NULL,NULL,'NGC 7307',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156628,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156628,31.62,0.43,21.1,73956,75,NULL,'3.6 micron, color corrected','NGC 7307',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156629,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156629,31.63,0.43,21.2,73956,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7307',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156630,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156630,31.69,0.43,21.7,73956,75,NULL,'MAT, I, raw','NGC 7307',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156631,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156631,31.72,0.35,22.1,73956,NULL,NULL,NULL,'NGC 7307',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156632,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156632,31.72,0.39,22.1,73956,73,NULL,'opt','NGC 7307',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156633,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156633,31.75,0.43,22.4,73956,75,NULL,'MAT, I, inv','NGC 7307',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156634,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156634,31.79,0.4,22.8,73956,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 7307',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156635,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156635,31.94,0.43,24.5,73956,75,NULL,'MAT, I, cor','NGC 7307',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156636,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156636,32.06,0.4,25.9,73956,75,NULL,'B','NGC 7307',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156637,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156637,32.1,0.11,26.4,73956,NULL,NULL,NULL,'NGC 7307',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156638,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156638,32.44,0.47,30.7,73956,75,NULL,'A82, H, inv','NGC 7307',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156639,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156639,32.44,0.47,30.8,73956,75,NULL,'A82, H, raw','NGC 7307',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156640,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156640,32.52,0.4,31.9,73956,NULL,NULL,'mean','NGC 7307',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156641,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156641,32.66,0.47,34.1,73956,75,NULL,'A82, H, cor','NGC 7307',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156642,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156642,32.95,0.46,38.8,73956,NULL,NULL,'J','NGC 7307',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156643,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156643,33.12,0.47,42,73956,NULL,NULL,'H','NGC 7307',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156644,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156644,33.18,0.45,43.3,73956,NULL,NULL,'K','NGC 7307',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156645,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 18588',NULL,156645,38.49,0.64,498,73957,70,NULL,'SN photometric redshift distance, z photo =0.124 +/- 0.047','SDSS-II SN 18588',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,338.47175,-1.20458,0.173,NULL,50332411595,786443931,12288186,NULL),(156646,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 18588','R',156646,40.64,0.23,1070,73957,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18588',0.251315,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156647,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 18588','R',156647,41.01,0.31,1270,73957,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18588',0.251315,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156648,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 18588',NULL,156648,40.92,0.19,1530,73957,70,NULL,'SALT 2','SDSS-II SN 18588',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156649,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 18588',NULL,156649,40.94,0.19,1540,73957,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18588',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156650,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13062','RN',156650,42.83,0.21,2600,73958,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13062',0.416357,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156651,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13062','RN',156651,43.04,0.18,2870,73958,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13062',0.416357,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156652,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156652,37.33,0.46,292,73959,70,NULL,NULL,'2MASX J22335936-0103566',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,338.497375,-1.06564,0.149,NULL,49459642479,772806913,12075108,17.3),(156653,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156653,36.67,0.44,216,73960,NULL,NULL,'Malmquist cor.','2MASX J22340264+0154591',NULL,'2009ApJS..182..474S',2009,1,0.53,NULL,'G',0.000023,NULL,'14.34',0.2,'Sa',NULL,NULL,NULL,NULL,1,338.511083333,1.91639,0.149,NULL,52415790647,818996728,12796823,14.34),(156654,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156654,36.84,0.4,233,73960,NULL,NULL,NULL,'2MASX J22340264+0154591',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156655,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156655,36.88,0.2,238,73960,74.4,NULL,NULL,'2MASX J22340264+0154591',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156656,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156656,36.01,0.47,159,73961,NULL,NULL,'H','UGC 12081',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000033,NULL,'15.13',0.4,'Sab','Isolated galaxy',NULL,NULL,NULL,1,338.5164583,10.17294,0.241,NULL,52462085268,819720082,12808126,15.13),(156657,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156657,36.08,0.4,164,73961,NULL,NULL,'mean','UGC 12081',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156658,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156658,36.08,0.45,165,73961,NULL,NULL,'K','UGC 12081',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156659,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156659,36.23,0.46,176,73961,NULL,NULL,'J','UGC 12081',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156660,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156660,33.86,0.43,59.2,73962,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J22340404+6826298',NULL,'2014MNRAS.444..527S',2014,1,1.12,NULL,'G',0.00002,NULL,'9.73K',0.33,'Spiral',NULL,NULL,NULL,NULL,1,338.516833,68.44167,NULL,NULL,53552301725,836754714,13074292,9.73),(156661,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 07037','RN',156661,38.57,0.66,474,73963,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07037',0.090174,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156662,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 07037','RN',156662,39.47,0.46,718,73963,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 07037',0.090174,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156663,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156663,37.49,0.46,315,73964,70,NULL,NULL,'2MASX J22340458+0008271',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000182,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,338.519,0.14075,0.201,NULL,51674239460,807409991,12615781,16.6),(156664,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156664,37.17,0.46,271,73965,70,NULL,NULL,'2MASX J22340552-1007213',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00015,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,338.522875,-10.12253,0.161,NULL,50364652670,786947697,12296057,16.7),(156665,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005kc',NULL,156665,33.3,0.22,45,73966,74.2,NULL,'SALT 2','NGC 7311',0.01512,'2010ApJ...716..712A',2010,1,1.6,NULL,'G',0.000017,NULL,'12.4B',0.8,'Sab','in a pair',NULL,NULL,NULL,1,338.5279583,5.56989,0.209,NULL,52422852884,819107076,12798548,12.4),(156666,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005kc',NULL,156666,33.76,0.04,55.7,73966,72,NULL,NULL,'NGC 7311',0.01512,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156667,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005kc',NULL,156667,33.77,0.24,55.8,73966,65,NULL,'MLCS31','NGC 7311',0.01512,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156668,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005kc',NULL,156668,33.82,0.01,58.1,73966,72,NULL,'MLCS31','NGC 7311',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156669,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005kc',NULL,156669,33.87,0.2,58.6,73966,72,NULL,NULL,'NGC 7311',0.01512,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156670,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005kc',NULL,156670,33.87,0.02,59.5,73966,72,NULL,'M(H) = -18.317 mag','NGC 7311',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156671,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005kc',NULL,156671,33.88,0.09,59.7,73966,74.4,NULL,NULL,'NGC 7311',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156672,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005kc',NULL,156672,33.94,0.05,60.5,73966,72,NULL,NULL,'NGC 7311',0.01512,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156673,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005kc',NULL,156673,33.95,0.21,60.7,73966,70,NULL,'SALT 2','NGC 7311',0.01512,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156674,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005kc',NULL,156674,33.98,0.26,61.5,73966,73.8,NULL,'SALT 2 (SNANA)','NGC 7311',0.015,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156675,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005kc',NULL,156675,34.06,0.18,63.1,73966,72,NULL,NULL,'NGC 7311',0.0139,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156676,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005kc',NULL,156676,34.05,0.25,63.7,73966,73.8,NULL,'SALT 2 (SNANA)','NGC 7311',0.015,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156677,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005kc',NULL,156677,34.08,0.24,64.6,73966,65,NULL,'MLCS17','NGC 7311',0.01512,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156678,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005kc',NULL,156678,34.19,0.26,67.7,73966,65,NULL,'SALT2','NGC 7311',0.01512,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156679,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005kc',NULL,156679,35.36,0.04,116,73966,70,NULL,'SALT 2','NGC 7311',0.01512,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156680,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156680,33.4,0.47,47.8,73966,NULL,NULL,'H','NGC 7311',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156681,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156681,33.41,0.46,48.1,73966,NULL,NULL,'J','NGC 7311',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156682,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156682,33.43,0.45,48.4,73966,NULL,NULL,'K','NGC 7311',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156683,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156683,33.69,0.4,54.7,73966,NULL,NULL,'mean','NGC 7311',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156684,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156684,38.24,0.46,444,73967,70,NULL,NULL,'SDSS J223408.55-000837.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,338.535625,-0.14386,0.193,NULL,49459863889,772810373,12075162,18.1),(156685,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156685,37.53,0.46,320,73968,70,NULL,NULL,'2MASX J22340900-0846343',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,338.537416667,-8.77617,0.157,NULL,50359097444,786860897,12294701,17.6),(156686,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2006gp',NULL,156686,39.53,0.16,805,73969,70,NULL,'Hubble residual -0.03 for z0.21290','SDSS J223410.00+000317.9',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,338.5414583,0.05486,0.201,NULL,51674236609,807409947,12615780,NULL),(156687,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13425','R',156687,40.05,0.24,845,73969,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006gp','SDSS J223410.00+000317.9',0.2129,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156688,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13425','R',156688,40.06,0.18,847,73969,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006gp','SDSS J223410.00+000317.9',0.2129,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156689,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156689,38.56,0.46,516,73970,70,NULL,NULL,'2MASX J22341038-0759143',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000177,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,338.543375,-7.98739,0.153,NULL,50392031763,787375496,12302742,17.7),(156690,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156690,30.72,0.4,13.9,73971,75,NULL,'B','UGC 12082',NULL,'1988NBGC.C....0000T',1988,1,2.6,NULL,'G',0.000003,NULL,'14.1',2.2,'Sm','Isolated galaxy',NULL,NULL,NULL,1,338.545083,32.8605,0.305,NULL,55460189124,866565455,13540085,14.1),(156691,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156691,37.46,0.33,310,73972,70,NULL,NULL,'2MASX J22341379+0036290',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,338.5574583,0.60817,0.217,NULL,51674635424,807416178,12615877,16.9),(156692,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156692,37.46,0.33,310,73973,70,NULL,NULL,'2MASX J22341473+0038250',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,338.5612917,0.64033,0.217,NULL,51674642917,807416295,12615879,18.2),(156693,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156693,36.98,0.46,248,73974,70,NULL,NULL,'2MASX J22341473+1423142',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,338.561375,14.38733,0.157,NULL,52594405423,821787584,12840431,17.7),(156694,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156694,38.21,0.33,439,73975,70,NULL,NULL,'2MASX J22342398+1349413',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00019,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,338.600083,13.82817,0.161,NULL,52593741684,821777213,12840268,17.3),(156695,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156695,36.97,0.46,248,73976,70,NULL,NULL,'2MASX J22342546+1225443',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.0002,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,338.606125,12.42897,0.169,NULL,52580957559,821577461,12837147,16.5),(156696,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156696,37.26,0.46,283,73977,70,NULL,NULL,'2MASX J22342794-0850286',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,338.616375,-8.84128,0.157,NULL,50359093826,786860841,12294700,16.9),(156697,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156697,37.36,0.46,296,73978,70,NULL,NULL,'2MASX J22343016-0807376',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.2g',0.27,'AGN',NULL,NULL,NULL,NULL,1,338.6257083,-8.12714,0.153,NULL,50392281572,787379399,12302803,17.2),(156698,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156698,35.8,0.71,145,73979,NULL,NULL,'Malmquist cor.','2MFGC 16997',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000027,NULL,'16.5',NULL,'Sc',NULL,NULL,NULL,NULL,1,338.627041667,1.56064,0.189,NULL,52415743228,818995987,12796812,16.5),(156699,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156699,36.19,0.6,173,73979,NULL,NULL,NULL,'2MFGC 16997',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156700,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156700,36.23,0.2,176,73979,74.4,NULL,NULL,'2MFGC 16997',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156701,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156701,36.38,0.56,189,73980,70,NULL,NULL,'ESO 238- G 017',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'16.73',0.27,'S0-a',NULL,NULL,NULL,NULL,1,338.629417,-48.11078,0,NULL,50699719530,792183117,12377861,16.73),(156702,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156702,34.23,0.8,70.3,73981,75,NULL,'MAT, I','ESO 533- G 048',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000023,NULL,'14.76',0.5,'IB(s)m','in a pair',NULL,NULL,NULL,1,338.632416667,-22.69153,0.041,NULL,50205308368,784457943,12257155,14.76),(156703,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156703,34.01,0.32,63.3,73981,85,NULL,'I, raw','ESO 533- G 048',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156704,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156704,34.03,0.32,64,73981,85,NULL,'I, inv','ESO 533- G 048',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156705,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156705,34.16,0.43,68,73981,75,NULL,'MAT, I, raw','ESO 533- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156706,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156706,34.3,0.43,72.4,73981,75,NULL,'MAT, I, inv','ESO 533- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156707,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156707,34.42,0.2,76.6,73981,74.4,NULL,NULL,'ESO 533- G 048',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156708,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156708,34.46,0.43,78,73981,75,NULL,'MAT, I, cor','ESO 533- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156709,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156709,34.56,0.48,81.5,73981,NULL,NULL,NULL,'ESO 533- G 048',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156710,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156710,34.58,0.47,82.5,73981,NULL,NULL,'Malmquist cor.','ESO 533- G 048',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156711,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156711,37.03,0.46,254,73982,70,NULL,NULL,'2MASX J22343235+1340333',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000141,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,338.634875,13.67603,0.153,NULL,52593693275,821776457,12840257,18.3),(156712,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156712,36.41,0.43,192,73983,NULL,NULL,'Malmquist cor.','2MASX J22343238+0124565',NULL,'2009ApJS..182..474S',2009,1,0.34,NULL,'G',0.000023,NULL,'15.15',0.18,'Sbc',NULL,NULL,NULL,NULL,1,338.635083,1.41583,0.189,NULL,52412342896,818942857,12795982,15.15),(156713,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156713,36.52,0.41,202,73983,NULL,NULL,NULL,'2MASX J22343238+0124565',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156714,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156714,36.56,0.2,205,73983,74.4,NULL,NULL,'2MASX J22343238+0124565',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156715,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156715,38.21,0.33,439,73984,70,NULL,NULL,'SDSS J223434.18+135409.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000181,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,338.642458333,13.90261,0.161,NULL,52593926178,821780096,12840314,18.6),(156716,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156716,34.62,0.69,83.8,73985,100,NULL,'mid-IR','NGC 7312',NULL,'2013ApJ...771...88L',2013,1,1.4,NULL,'G',0.000077,NULL,'14.20',0.8,'SB(s)b','in a pair',NULL,NULL,NULL,1,338.6449583,5.81736,0.205,NULL,52422966417,819108850,12798575,14.2),(156717,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156717,35.49,0.38,125,73985,NULL,NULL,'Malmquist cor.','NGC 7312',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156718,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156718,35.81,0.33,145,73985,NULL,NULL,NULL,'NGC 7312',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156719,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156719,36.29,0.2,181,73985,74.4,NULL,NULL,'NGC 7312',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156720,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156720,37.18,0.53,273,73986,NULL,NULL,'Malmquist cor.','2MASX J22343678+0155375',NULL,'2009ApJS..182..474S',2009,1,0.43,NULL,'G',0.000027,NULL,'15.84',0.1,'Sc',NULL,NULL,NULL,NULL,1,338.653333,1.92711,0.137,NULL,52415822063,818997219,12796831,15.84),(156721,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156721,37.38,0.48,299,73986,NULL,NULL,NULL,'2MASX J22343678+0155375',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156722,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156722,37.42,0.2,305,73986,74.4,NULL,NULL,'2MASX J22343678+0155375',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156723,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 10331','RN',156723,42.95,0.26,2620,73987,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10331',0.480693,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156724,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 07728','RN',156724,43.52,0.27,3700,73988,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 07728',0.367595,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156725,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 07728','RN',156725,43.55,0.31,3750,73988,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 07728',0.367595,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156726,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 12110','RN',156726,40.96,1.56,1220,73989,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 12110',0.28139,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156727,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 12110','RN',156727,41.42,0.31,1500,73989,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 12110',0.28139,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156728,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156728,37.03,0.5,254,73990,NULL,NULL,'Malmquist cor.','2MFGC 16998',NULL,'2009ApJS..182..474S',2009,1,0.52,NULL,'G',0.000023,NULL,'15.23',0.12,'Sbc:',NULL,NULL,NULL,NULL,1,338.681875,1.35914,0.189,NULL,52412297655,818942150,12795971,15.23),(156729,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156729,37.25,0.49,281,73990,75,NULL,'IR','2MFGC 16998',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156730,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156730,37.32,0.44,291,73990,NULL,NULL,NULL,'2MFGC 16998',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156731,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156731,37.36,0.2,296,73990,74.4,NULL,NULL,'2MFGC 16998',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156732,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156732,37.91,0.16,382,73991,70,NULL,NULL,'2MASX J22344385-0106030',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,338.68275,-1.10078,0.149,NULL,49459544258,772805379,12075084,17.7),(156733,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156733,37.91,0.16,382,73992,70,NULL,NULL,'2MASX J22344565-0104560',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00015,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,338.6902083,-1.08228,0.149,NULL,49459515547,772804930,12075077,16.4),(156734,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156734,36.55,0.54,205,73993,70,NULL,NULL,'2MASX J22344787-6525480',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.000103,NULL,'16.74',0.29,NULL,NULL,NULL,NULL,NULL,1,338.699417,-65.42997,0.005,NULL,49284547207,770071050,12032360,16.74),(156735,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156735,38.26,0.46,449,73994,70,NULL,NULL,'SDSS J223449.22+131329.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,338.705083,13.22497,0.153,NULL,52595239638,821800619,12840634,18.3),(156736,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156736,35.19,0.8,109,73995,75,NULL,'CF, r','UGC 12093',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000017,NULL,'14.91',0.7,'Scd:',NULL,NULL,NULL,NULL,1,338.70575,18.6385,0.153,NULL,52398379890,818724685,12792573,14.91),(156737,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156737,35.29,0.38,114,73995,75,NULL,'CF, r, raw','UGC 12093',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156738,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156738,35.35,0.33,118,73995,NULL,NULL,'Malmquist cor.','UGC 12093',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156739,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156739,35.41,0.32,121,73995,NULL,NULL,NULL,'UGC 12093',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156740,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156740,35.44,0.2,122,73995,74.4,NULL,NULL,'UGC 12093',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156741,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156741,35.46,0.38,124,73995,75,NULL,'CF, r, inv','UGC 12093',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156742,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156742,35.56,0.38,130,73995,75,NULL,'CF, r, cor','UGC 12093',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156743,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 09147','RN',156743,41.21,0.18,1560,73996,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 09147',0.119462,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156744,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 09147','RN',156744,41.59,0.31,1860,73996,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 09147',0.119462,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156745,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156745,36.86,0.27,236,73997,70,NULL,NULL,'2MASX J22345143+0110269',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,338.714333333,1.17403,0.189,NULL,51674414093,807412720,12615823,17.8),(156746,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156746,37.22,0.46,279,73998,70,NULL,NULL,'2MASX J22345269+1316387',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000176,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,338.719583,13.27756,0.153,NULL,52595237857,821800591,12840634,16.7),(156747,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156747,34.28,0.56,71.9,73999,70,NULL,NULL,'FAIRALL 0194',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.000103,NULL,'15.62',0.52,'S0',NULL,NULL,NULL,NULL,1,338.737625,-61.88364,0,NULL,48790070694,762344854,11911638,15.62),(156748,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156748,37.91,0.16,382,74000,70,NULL,NULL,'2MASX J22345934-0108028',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000175,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,338.747375,-1.13397,0.149,NULL,49459516767,772804949,12075077,17.4),(156749,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 1978E','R',156749,34.48,NULL,78.7,74001,NULL,NULL,'Photographic','CGCG 514-058',NULL,'1988SSRv...48....1R',1988,1,0.6,NULL,'G',0.000033,NULL,'15.3',0.6,'Sc',NULL,NULL,NULL,NULL,1,338.74925,37.1995,0.569,NULL,55525788347,867590442,13556100,15.3),(156750,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156750,37.35,0.33,295,74002,70,NULL,NULL,'2MASX J22350076+1327577',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000194,NULL,'15.9g',0.49,'E0',NULL,NULL,NULL,NULL,1,338.753125,13.46608,0.153,NULL,52595038755,821797480,12840585,15.9),(156751,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 14363','RN',156751,41.52,0.14,1450,74003,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 14363',0.39307,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156752,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 14363','RN',156752,41.91,0.21,1730,74003,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 14363',0.39307,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156753,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156753,35.11,0.58,105,74004,70,NULL,NULL,'LCRS B223211.4-383050',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'15.89',0.35,'E',NULL,NULL,NULL,NULL,1,338.769125,-38.255,0,NULL,50709067651,792329182,12380143,15.89),(156754,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156754,36.73,0.46,222,74005,70,NULL,NULL,'2MASX J22350637+0052020',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000164,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,338.776625,0.86722,0.221,NULL,51674539478,807414679,12615854,17.1),(156755,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15866','R',156755,39.78,0.2,759,74006,70,NULL,'SDSS CAND. zSNIa; SALT 2','2MASX J22350737+0058050',0.189,'2014arXiv1401.3317S',2014,1,0.12,NULL,'G',0.01,NULL,'19.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,338.780833,0.96808,0.213,NULL,51674511699,807414245,12615847,19.4),(156756,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15866','R',156756,39.93,0.13,815,74006,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','2MASX J22350737+0058050',0.189,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156757,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15866',NULL,156757,39.64,0.1,847,74006,70,NULL,'SALT 2','2MASX J22350737+0058050',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156758,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15866',NULL,156758,39.65,0.1,851,74006,70,NULL,'SALT 2, Malmquist cor.','2MASX J22350737+0058050',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156759,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156759,37.35,0.33,295,74007,70,NULL,NULL,'2MASX J22350995+1328147',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,338.791583333,13.47072,0.153,NULL,52595047276,821797613,12840587,17.8),(156760,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156760,36.37,0.47,188,74008,NULL,NULL,'Malmquist cor.','2MASX J22351010+0120460',NULL,'2009ApJS..182..474S',2009,1,0.59,NULL,'G',0.000023,NULL,'13.81',0.43,'Sbc:',NULL,NULL,NULL,NULL,1,338.7922917,1.34617,0.189,NULL,51674364936,807411952,12615811,13.81),(156761,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156761,36.57,0.43,206,74008,NULL,NULL,NULL,'2MASX J22351010+0120460',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156762,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156762,36.61,0.2,210,74008,74.4,NULL,NULL,'2MASX J22351010+0120460',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156763,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156763,36.67,0.46,216,74009,NULL,NULL,'Malmquist cor.','2MFGC 17007',NULL,'2009ApJS..182..474S',2009,1,0.62,NULL,'G',0.000027,NULL,'15.55',0.1,'Sc',NULL,NULL,NULL,NULL,1,338.7945417,0.84625,0.221,NULL,51674540847,807414700,12615854,15.55),(156764,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156764,36.84,0.49,234,74009,75,NULL,'IR','2MFGC 17007',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156765,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156765,36.87,0.42,236,74009,NULL,NULL,NULL,'2MFGC 17007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156766,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156766,36.91,0.2,241,74009,74.4,NULL,NULL,'2MFGC 17007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156767,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156767,37.91,0.16,382,74010,70,NULL,NULL,'SDSS J223511.53-010535.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,338.798083,-1.09322,0.149,NULL,49459513005,772804890,12075076,18.2),(156768,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156768,37.91,0.16,382,74011,70,NULL,NULL,'2MASX J22351195-0108498',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000202,NULL,'16.4g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,338.799833,-1.14719,0.149,NULL,49459527501,772805117,12075079,16.4),(156769,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156769,38.66,0.46,540,74012,70,NULL,NULL,'SDSS J223515.21-003519.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000138,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,338.813417,-0.58875,0.177,NULL,49459903814,772810997,12075171,18.2),(156770,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156770,37.41,0.46,304,74013,70,NULL,NULL,'2MASX J22351582-0953350',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000182,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,338.815875,-9.89297,0.201,NULL,50361783833,786902872,12295357,17.1),(156771,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 21166',NULL,156771,41.23,0.31,1760,74014,70,NULL,'SN photometric redshift distance, z photo =0.548 +/- 0.126','SDSS-II SN 21166',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,338.820041667,0.14178,0.209,NULL,51674147884,807408560,12615758,NULL),(156772,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156772,37.91,0.16,382,74015,70,NULL,NULL,'SDSS J223517.11-011054.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,338.8212917,-1.18167,0.149,NULL,49459520962,772805015,12075078,18.3),(156773,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156773,38.33,0.46,464,74016,70,NULL,NULL,'2MASX J22351807+1222058',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000149,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,338.825375,12.36833,0.153,NULL,52594694820,821792106,12840501,18.1),(156774,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 19576','RN',156774,41.24,0.27,1460,74017,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19576',0.206981,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156775,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 19576','RN',156775,42.05,0.33,2130,74017,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19576',0.206981,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156776,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156776,36.87,0.46,236,74018,70,NULL,NULL,'2MASX J22351954+1332448',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000134,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,338.831333,13.54572,0.153,NULL,52595553596,821805524,12840711,17.8),(156777,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SCP 06Z05',NULL,156777,42.59,0.14,2030,74019,70,NULL,'SALT2, M(B) -19.307 mag, Alpha 0.124, Beta 1.460, Delta 0.023','1WGA J2235.3-2557',0.623,'2012ApJ...746...85S',2012,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,338.835833,-25.96167,0.021,NULL,50074319934,782411248,12225175,NULL),(156778,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156778,36.86,0.27,236,74020,70,NULL,NULL,'2MASX J22352191+0112193',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000199,NULL,'16.0g',0.38,'E0',NULL,NULL,NULL,NULL,1,338.841333,1.2055,0.189,NULL,51674388777,807412324,12615817,16),(156779,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156779,36.86,0.27,236,74021,70,NULL,NULL,'SDSS J223524.19+011126.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,338.8507917,1.19078,0.189,NULL,51677258922,807457170,12616518,18.2),(156780,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156780,34.93,0.51,96.8,74022,70,NULL,NULL,'ESO 076- G 019',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000087,NULL,'14.03',1,'SAB(r)bc',NULL,NULL,NULL,NULL,1,338.861917,-70.28189,0.073,NULL,49315660495,770557195,12039956,14.03),(156781,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156781,35,0.55,100,74023,NULL,NULL,NULL,'ESO 405- G 031',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.72',0.6,'Sb',NULL,NULL,NULL,NULL,1,338.868916667,-35.12183,0,NULL,50579385968,790302905,12348482,14.72),(156782,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156782,35.01,0.54,101,74023,NULL,NULL,'Malmquist cor.','ESO 405- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156783,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156783,35.04,0.2,102,74023,74.4,NULL,NULL,'ESO 405- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156784,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 19038','RN',156784,39.87,0.23,791,74024,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 19038',0.191682,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156785,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 19038','RN',156785,40.92,0.23,1280,74024,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 19038',0.191682,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156786,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 20420','R',156786,38.28,0.24,393,74025,70,NULL,'SDSS CAND. SNIc; SALT 2; SN 2007qw','SDSS J223529.00+002856.1',0.150654,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',NULL,NULL,'20.1g',0.06,NULL,NULL,NULL,NULL,NULL,1,338.870875,0.48225,0.201,NULL,51674192353,807409255,12615769,20.1),(156787,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 20420','R',156787,38.48,0.11,431,74025,70,NULL,'SDSS CAND. SNIc; MLCS2K2; SN 2007qw','SDSS J223529.00+002856.1',0.150654,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156788,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156788,35,0.49,100,74026,75,NULL,'IR','FGC 2395',NULL,'2011yCatp016004901K',2011,1,0.66,NULL,'G',0.000033,NULL,'16.5',0.09,'Scd',NULL,NULL,NULL,NULL,1,338.8712917,19.30056,0.197,NULL,52409173242,818893331,12795208,16.5),(156789,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156789,35.22,NULL,111,74026,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2395',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156790,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156790,35.24,NULL,112,74026,NULL,NULL,'Dipole + Quadrupole','FGC 2395',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156791,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156791,35.26,NULL,113,74026,NULL,NULL,'Dipole','FGC 2395',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156792,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156792,35.37,NULL,119,74026,NULL,NULL,NULL,'FGC 2395',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156793,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156793,37.68,0.46,344,74027,70,NULL,NULL,'2MASX J22352980+1225018',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000178,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,338.874333,12.41711,0.153,NULL,52594722882,821792545,12840508,16.9),(156794,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156794,37.91,0.16,382,74028,70,NULL,NULL,'2MASX J22353246-0111047',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,338.885208333,-1.18475,0.149,NULL,49462950578,772858602,12075915,17.8),(156795,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156795,36.17,0.47,172,74029,NULL,NULL,'Malmquist cor.','2MASX J22353392+0151353',NULL,'2009ApJS..182..474S',2009,1,0.36,NULL,'G',0.000023,NULL,'15.23',0.18,'SBbc',NULL,NULL,NULL,NULL,1,338.891375,1.85972,0.197,NULL,52413823305,818965989,12796343,15.23),(156796,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156796,36.23,0.46,176,74029,NULL,NULL,NULL,'2MASX J22353392+0151353',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156797,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156797,36.27,0.2,179,74029,74.4,NULL,NULL,'2MASX J22353392+0151353',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156798,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 19723',NULL,156798,39.84,0.37,927,74030,70,NULL,'SN photometric redshift distance, z photo =0.246 +/- 0.055','SDSS-II SN 19723',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,338.891667,0.41764,0.217,NULL,51677645291,807463207,12616612,NULL),(156799,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 19723','R',156799,40.56,0.2,1030,74030,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19723',0.255413,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156800,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 19723','R',156800,40.7,0.12,1100,74030,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19723',0.255413,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156801,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 19723',NULL,156801,40.43,0.1,1220,74030,70,NULL,'SALT 2','SDSS-II SN 19723',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156802,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 19723',NULL,156802,40.45,0.1,1230,74030,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19723',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156803,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156803,37.91,0.16,382,74031,70,NULL,NULL,'2MASX J22353613-0107187',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,338.900667,-1.12172,0.149,NULL,49463119594,772861243,12075956,18.2),(156804,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156804,38.21,0.46,439,74032,70,NULL,NULL,'SDSS J223538.09-094102.9',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,338.90875,-9.68414,0.197,NULL,50361868474,786904194,12295378,18.3),(156805,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156805,38.31,0.46,460,74033,70,NULL,NULL,'2MASX J22353922+1244508',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,338.913417,12.74742,0.149,NULL,52595353484,821802398,12840662,17.9),(156806,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156806,37.66,0.46,341,74034,70,NULL,NULL,'SDSS J223539.99+134602.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000151,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,338.916667,13.76747,0.169,NULL,52595742703,821808479,12840757,18.6),(156807,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156807,34.76,NULL,89.5,74035,NULL,NULL,'B','IC 5230',NULL,'2005Ap&SS.298..577R',2005,1,1.03,NULL,'G',0.000033,NULL,'14.89',0.42,'S...',NULL,NULL,NULL,NULL,1,338.917375,-61.54769,0,NULL,48790121534,762345648,11911650,14.89),(156808,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156808,34.76,NULL,89.5,74035,NULL,NULL,'I','IC 5230',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156809,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156809,35.7,0.42,138,74035,NULL,NULL,'Malmquist cor.','IC 5230',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156810,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156810,35.76,0.41,142,74035,NULL,NULL,NULL,'IC 5230',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156811,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156811,35.8,0.2,145,74035,74.4,NULL,NULL,'IC 5230',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156812,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156812,35.5,NULL,126,74036,NULL,NULL,NULL,'FGC 2396',NULL,'2000BSAO...50....5K',2000,1,0.71,'HI data crossed with FGC 2395 (R.Giovanelli, 1997, priv.comm).','G',0.000023,NULL,'16.8',0.1,'Sdm',NULL,NULL,NULL,NULL,1,338.92,3.27389,0.201,NULL,52427260576,819175946,12799624,16.8),(156813,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156813,35.51,NULL,127,74036,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2396',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156814,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156814,35.52,NULL,127,74036,NULL,NULL,'Dipole + Quadrupole','FGC 2396',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156815,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156815,35.54,NULL,128,74036,NULL,NULL,'Dipole','FGC 2396',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156816,'BCG','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156816,37.24,0.35,265,74037,60,NULL,'ABELL 2457, BCG','2MASX J22354078+0129053',0.0597,'1980ApJ...241..486H',1980,1,0.71,NULL,'G',0.00011,NULL,'17.9',0.5,'cD;BrClG','Brightest group member',NULL,NULL,NULL,1,338.920083,1.48497,0.189,NULL,51676199437,807440616,12616259,17.9),(156817,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156817,37.01,0.11,253,74037,70,NULL,'ABELL 2457, BGC','2MASX J22354078+0129053',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156818,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156818,36.96,0.39,246,74038,NULL,NULL,'Malmquist cor.','2MASX J22354193+0139333',NULL,'2009ApJS..182..474S',2009,1,0.43,NULL,'G',0.000023,NULL,'16.58',0.22,'Sa             Sy1',NULL,NULL,NULL,'Sy 1',1,338.924625,1.65928,0.193,NULL,52413657512,818963398,12796303,16.58),(156819,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156819,37.17,0.35,271,74038,NULL,NULL,NULL,'2MASX J22354193+0139333',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156820,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156820,37.21,0.2,277,74038,74.4,NULL,NULL,'2MASX J22354193+0139333',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156821,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13737',NULL,156821,39.87,0.64,943,74039,70,NULL,'SN photometric redshift distance, z photo =0.251 +/- 0.106','SDSS-II SN 13737',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,338.926167,0.96261,0.241,NULL,51677354901,807458670,12616541,NULL),(156822,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13737','R',156822,41.77,0.26,1620,74039,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13737',0.394955,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156823,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13737','R',156823,41.95,0.23,1760,74039,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13737',0.394955,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156824,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13737',NULL,156824,41.72,0.17,2210,74039,70,NULL,'SALT 2','SDSS-II SN 13737',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156825,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13737',NULL,156825,41.79,0.17,2280,74039,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13737',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156826,'BCG','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156826,37.24,0.35,265,74040,60,NULL,NULL,'ABELL 2457',0.0597,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I-II:  [BM]',NULL,NULL,NULL,NULL,1,338.938333,1.47592,0.189,NULL,51676199714,807440620,12616259,NULL),(156827,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156827,37.01,0.11,253,74040,70,NULL,NULL,'ABELL 2457',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156828,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156828,31.29,0.8,18.1,74041,75,NULL,'MAT, I','NGC 7314',NULL,'1997ApJS..109..333W',1997,1,4.6,'Confused HIPASS source','G',0.00001,NULL,'11.88',2.1,'SAB(rs)bc      Sy1.9','in a pair',NULL,NULL,'Sy 1 h',1,338.942458333,-26.05047,0.021,NULL,50074596082,782415563,12225243,11.88),(156829,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156829,31.3,0.8,18.2,74041,75,NULL,'A82, H','NGC 7314',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156830,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156830,30.55,0.4,12.9,74041,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 7314',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156831,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156831,30.93,0.43,15.3,74041,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7314',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156832,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156832,31,0.38,15.8,74041,NULL,NULL,NULL,'NGC 7314',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156833,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156833,31.01,0.43,15.9,74041,75,NULL,'3.6 micron, color corrected','NGC 7314',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156834,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156834,31.17,0.4,17.1,74041,NULL,NULL,'mean','NGC 7314',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156835,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156835,31.18,0.32,17.2,74041,85,NULL,'I, raw','NGC 7314',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156836,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156836,31.2,0.2,17.4,74041,74.4,NULL,NULL,'NGC 7314',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156837,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156837,31.22,0.32,17.5,74041,85,NULL,'I, inv','NGC 7314',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156838,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156838,31.23,0.47,17.6,74041,75,NULL,'A82, H, raw','NGC 7314',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156839,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156839,31.3,0.47,18.2,74041,75,NULL,'A82, H, inv','NGC 7314',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156840,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156840,31.31,0.43,18.3,74041,75,NULL,'MAT, I, raw','NGC 7314',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156841,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156841,31.31,0.4,18.3,74041,75,NULL,'B','NGC 7314',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156842,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156842,31.34,0.46,18.6,74041,NULL,NULL,'J','NGC 7314',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156843,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156843,31.45,0.45,19.5,74041,NULL,NULL,'K','NGC 7314',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156844,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156844,31.49,0.43,19.9,74041,75,NULL,'MAT, I, inv','NGC 7314',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156845,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156845,31.51,0.39,20,74041,NULL,NULL,NULL,'NGC 7314',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156846,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156846,31.56,0.4,20.5,74041,73,NULL,'opt','NGC 7314',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156847,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156847,31.61,0.47,21,74041,75,NULL,'A82, H, cor','NGC 7314',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156848,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156848,31.62,0.43,21.1,74041,75,NULL,'MAT, I, cor','NGC 7314',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156849,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156849,31.65,0.37,21.4,74041,NULL,NULL,'Malmquist cor.','NGC 7314',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156850,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156850,35.35,0.47,117,74042,70,NULL,NULL,'2MASX J22354768-7436516',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.000093,NULL,'15.1b',0.45,NULL,NULL,NULL,NULL,NULL,1,338.948833,-74.61431,0.165,NULL,48449475730,757023058,11828485,15.1),(156851,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 01138','RN',156851,42.09,0.22,1960,74043,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01138',0.335599,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156852,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 01138','RN',156852,42.28,0.18,2140,74043,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01138',0.335599,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156853,'Faber-Jackson','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156853,34.06,NULL,65,74044,NULL,NULL,'Stephan\'s Quintet','NGC 7317',NULL,'1998A&A...334..473M',1998,1,1.1,NULL,'G',0.000087,NULL,'14.57',1.1,'E4','in an interacting quintet',NULL,NULL,NULL,1,338.966167,33.94489,0.329,NULL,55462101677,866595338,13540552,14.57),(156854,'Faber-Jackson','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156854,34.54,0.44,80.9,74044,95,NULL,'Weighted Mean','NGC 7317',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156855,'Faber-Jackson','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156855,35.15,0.46,107,74044,95,NULL,'Michard 1979a','NGC 7317',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156856,'Faber-Jackson','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156856,35.16,0.63,108,74044,95,NULL,'Michard 1979b, c','NGC 7317',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156857,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156857,37.26,0.46,283,74045,70,NULL,NULL,'2MASX J22355305-0026008',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00015,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,338.971125,-0.43364,0.165,NULL,49462871140,772857361,12075896,16.3),(156858,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15673','RN',156858,43.87,0.35,3650,74046,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15673',0.625973,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156859,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2007lo',NULL,156859,38.76,0.06,565,74047,70,NULL,'Hubble residual 0.05 for z0.13840','SDSS J223556.08+003632.7',NULL,'2011ApJ...740...92G',2011,1,0.09,NULL,'G',0.0005,NULL,'21.4g',0.03,NULL,NULL,NULL,NULL,NULL,1,338.9837083,0.60911,0.201,NULL,51677688579,807463884,12616623,21.4),(156860,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 18602','R',156860,39.19,0.63,604,74047,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007lo','SDSS J223556.08+003632.7',0.1384,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156861,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2007lo',NULL,156861,39.09,0.07,658,74047,70,NULL,'SALT 2','SDSS J223556.08+003632.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156862,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2007lo',NULL,156862,39.09,0.07,658,74047,70,NULL,'SALT 2, Malmquist cor.','SDSS J223556.08+003632.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156863,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 18602','R',156863,39.39,0.09,663,74047,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007lo','SDSS J223556.08+003632.7',0.1384,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156864,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156864,33.99,0.47,62.9,74048,NULL,NULL,'H','NGC 7316',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000017,NULL,'13.62',0.9,'SBc            Sbrst','Isolated galaxy',NULL,NULL,'Starburst',1,338.98475,20.32225,0.157,NULL,52411895162,818935861,12795872,13.62),(156865,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156865,34.1,0.45,66.2,74048,NULL,NULL,'K','NGC 7316',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156866,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156866,34.12,0.46,66.7,74048,NULL,NULL,'J','NGC 7316',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156867,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156867,34.32,0.4,73.2,74048,NULL,NULL,'mean','NGC 7316',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156868,'Faber-Jackson','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156868,33.95,0.44,61.7,74049,95,NULL,'Weighted Mean','NGC 7318A',NULL,'1984ApJS...56...91D',1984,1,0.9,'Misidentified in UGC as \'MCG +06-49-040\'.','G',0.000077,NULL,'14.33',0.9,'E2 pec','in an interacting quintet',NULL,NULL,NULL,1,338.9864583,33.96547,0.329,NULL,55462105058,866595391,13540552,14.33),(156869,'Faber-Jackson','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156869,34.06,NULL,65,74049,NULL,NULL,'Stephan\'s Quintet','NGC 7318A',NULL,'1998A&A...334..473M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156870,'Faber-Jackson','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156870,34.45,0.63,77.6,74049,95,NULL,'Michard 1979b, c','NGC 7318A',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156871,'Faber-Jackson','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156871,34.53,0.46,80.5,74049,95,NULL,'Michard 1979a','NGC 7318A',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156872,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 03605','RN',156872,42.51,0.22,2150,74050,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03605',0.482963,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156873,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156873,35.99,0.46,158,74051,70,NULL,NULL,'2MASX J22355798-0843394',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00015,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,338.991583333,-8.72761,0.149,NULL,50358939625,786858431,12294662,16.5),(156874,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156874,33.89,NULL,60,74052,NULL,NULL,'Stephan\'s Quintet','NGC 7318B',NULL,'1998A&A...334..473M',1998,1,1.9,'MCG misprints name as \'NGC 7318a\'.','G',0.00008,NULL,'13.92',1.2,'SB(s)bc pec','in an interacting quintet',NULL,NULL,NULL,1,338.993375,33.96589,0.329,NULL,55462104665,866595385,13540552,13.92),(156875,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156875,36.67,0.33,216,74053,70,NULL,NULL,'2MASX J22360010-0950414',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'16.3g',0.41,'E0',NULL,NULL,NULL,NULL,1,339.000417,-9.84478,0.201,NULL,50361654449,786900850,12295325,16.3),(156876,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 16727','R',156876,40.51,0.3,1000,74054,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16727',0.260743,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,'PHOT','20.4g',0.07,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,339.0047083,0.13203,0.161,NULL,51677502090,807460970,12616577,20.4),(156877,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 16727','R',156877,40.51,0.37,1000,74054,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16727',0.260743,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156878,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 16727',NULL,156878,40.23,0.32,1110,74054,70,NULL,'SN photometric redshift distance, z photo =0.304 +/- 0.060','SDSS-II SN 16727',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156879,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156879,30.68,0.8,13.7,74055,75,NULL,'A82, H','NGC 7320',NULL,'1997ApJS..109..333W',1997,1,2.2,'Position in 1990Obs...110...93A is for a superposed star.','G',0.000067,NULL,'13.23',1.1,'SA(s)d         HII','Line-of-sight galaxy, in a quintet',NULL,NULL,NULL,1,339.014083333,33.94811,0.329,NULL,55462102533,866595352,13540552,13.23),(156880,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156880,29.87,0.69,9.4,74055,100,NULL,'mid-IR','NGC 7320',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156881,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156881,30.4,NULL,12,74055,NULL,NULL,'Stephan\'s Quintet','NGC 7320',NULL,'1998A&A...334..473M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156882,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156882,30.7,0.4,13.8,74055,75,NULL,'B','NGC 7320',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156883,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156883,30.7,0.4,13.8,74055,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 7320',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156884,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156884,31.07,0.47,16.4,74055,75,NULL,'A82, H, inv','NGC 7320',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156885,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156885,31.18,0.47,17.2,74055,75,NULL,'A82, H, raw','NGC 7320',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156886,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156886,31.4,0.47,19.1,74055,75,NULL,'A82, H, cor','NGC 7320',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156887,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156887,34.14,0.47,67.4,74056,NULL,NULL,'H','NGC 7319',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000012,NULL,'14.11',1.3,'SB(s)bc pec    Sy2','in an interacting quintet',NULL,NULL,'Sy 2',1,339.0147917,33.97572,0.329,NULL,55462102807,866595356,13540552,14.11),(156888,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156888,34.32,0.45,73.2,74056,NULL,NULL,'K','NGC 7319',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156889,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156889,34.39,0.46,75.4,74056,NULL,NULL,'J','NGC 7319',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156890,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156890,34.84,0.4,93,74056,NULL,NULL,'mean','NGC 7319',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156891,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005jb',NULL,156891,39.9,0.16,759,74057,74.2,NULL,'SALT 2','SDSS J223602.72-002204.8',0.258,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,339.0155,-0.368,0.165,NULL,49462879958,772857499,12075898,NULL),(156892,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 07426','R',156892,41.54,0.15,1480,74057,70,NULL,'SDSS CAND. zSNII; MLCS2K2; SN 2005jb','SDSS J223602.72-002204.8',0.38,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156893,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 07426','R',156893,42.14,0.23,1940,74057,70,NULL,'SDSS CAND. zSNII; SALT 2; SN 2005jb','SDSS J223602.72-002204.8',0.38,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156894,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005fg',NULL,156894,40.57,0.16,1030,74058,65,NULL,'SALT2','SDSS J223604.04-002229.6',0.26,'2009ApJS..185...32K',2009,1,0.21,NULL,'G',NULL,NULL,'18.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,339.016833,-0.37492,0.165,NULL,49462879898,772857498,12075898,18.7),(156895,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005fg',NULL,156895,40.6,0.17,1050,74058,70,NULL,'SDSS-II SN 01112, SALT 2','SDSS J223604.04-002229.6',0.26,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156896,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 01112','R',156896,40.67,0.25,1080,74058,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fg','SDSS J223604.04-002229.6',0.26,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156897,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 01112','R',156897,40.71,0.2,1100,74058,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fg','SDSS J223604.04-002229.6',0.26,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156898,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005fg',NULL,156898,40.85,0.18,1170,74058,65,NULL,'MLCS2k2','SDSS J223604.04-002229.6',0.26,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156899,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005fg',NULL,156899,40.96,0.06,1230,74058,70,NULL,'SDSS-II SN 01112','SDSS J223604.04-002229.6',0.26,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156900,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005fg',NULL,156900,40.49,0.14,1250,74058,70,NULL,'SALT 2','SDSS J223604.04-002229.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156901,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005fg',NULL,156901,40.52,0.14,1270,74058,70,NULL,'SALT 2, Malmquist cor.','SDSS J223604.04-002229.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156902,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 03181','RN',156902,40.77,0.15,1200,74059,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03181',0.191322,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156903,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 03181','RN',156903,41.23,0.36,1480,74059,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03181',0.191322,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156904,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156904,36.41,0.44,192,74060,NULL,NULL,'Malmquist cor.','2MASX J22360683+0133324',NULL,'2009ApJS..182..474S',2009,1,0.46,NULL,'G',0.000023,NULL,'16.20',0.15,'S0',NULL,NULL,NULL,NULL,1,339.0284583,1.55914,0.193,NULL,51676239236,807441238,12616269,16.2),(156905,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156905,36.52,0.42,202,74060,NULL,NULL,NULL,'2MASX J22360683+0133324',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156906,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156906,36.56,0.2,205,74060,74.4,NULL,NULL,'2MASX J22360683+0133324',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156907,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156907,37.82,0.46,366,74061,70,NULL,NULL,'2MASX J22360726-0804384',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00015,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,339.030375,-8.07736,0.153,NULL,50392378252,787380910,12302826,17.3),(156908,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156908,37.02,0.46,253,74062,70,NULL,NULL,'2MASX J22361138+1328200',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000162,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,339.047333333,13.47222,0.153,NULL,52595158716,821799354,12840614,16.7),(156909,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 14805','RN',156909,40.27,0.56,1050,74063,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 14805',0.081802,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156910,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 14805','RN',156910,40.42,0.17,1120,74063,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 14805',0.081802,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156911,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156911,36.92,0.46,242,74064,70,NULL,NULL,'2MASX J22361710+0112380',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000063,NULL,'16.1g',0.34,'E0',NULL,NULL,NULL,NULL,1,339.071417,1.21056,0.189,NULL,51677494485,807460851,12616575,16.1),(156912,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS J223618.96+002846.7:SN',NULL,156912,40.42,0.18,980,74065,74.2,NULL,'SALT 2','SDSS J223618.96+002846.7',0.238,'2010ApJ...716..712A',2010,1,0.04,NULL,'G',NULL,NULL,'22.1g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,339.079041667,0.47967,0.201,NULL,51677751195,807464862,12616638,22.1),(156913,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 06696','R',156913,40.73,0.16,1130,74065,70,NULL,'SDSS CAND. SNIa?; MLCS2K2','SDSS J223618.96+002846.7',0.238,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156914,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 06696','R',156914,41.42,0.29,1560,74065,70,NULL,'SDSS CAND. SNIa?; SALT 2','SDSS J223618.96+002846.7',0.238,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156915,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156915,36.48,0.33,198,74066,70,NULL,NULL,'2MASX J22361989+1418523',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000172,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,339.0827917,14.31453,0.133,NULL,52594228854,821784825,12840387,17),(156916,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156916,35.07,0.43,103,74067,75,NULL,'3.6 micron, color + selection bias corrected','KUG 2233+137',NULL,'2014MNRAS.444..527S',2014,1,1.12,NULL,'G',0.000121,NULL,'16.1g',0.19,'Spiral',NULL,NULL,NULL,NULL,1,339.10775,14.02397,0.169,NULL,52595716620,821808072,12840751,16.1),(156917,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156917,35.15,0.49,107,74067,75,NULL,'IR','KUG 2233+137',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156918,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156918,35.17,0.43,108,74067,75,NULL,'3.6 micron, color corrected','KUG 2233+137',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156919,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156919,35.3,0.2,115,74067,74.4,NULL,NULL,'KUG 2233+137',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156920,'Quasar spectrum','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156920,42.9,NULL,3800,74068,NULL,NULL,NULL,'[HB89] 2233+136',NULL,'2002A&A...381L..57D',2002,1,NULL,NULL,'QSO',0.000454,NULL,'18.8g',NULL,'AGN',NULL,NULL,NULL,'QSO',1,339.112833,13.95389,0.169,NULL,52595697861,821807779,12840746,18.8),(156921,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156921,34.25,0.69,70.7,74069,100,NULL,'mid-IR','NGC 7321',NULL,'2013ApJ...771...88L',2013,1,1.6,'HOLM 793B is a star.','G',0.000017,NULL,'13.71',1.1,'SB(r)b','Group member',NULL,NULL,NULL,1,339.11675,21.62181,0.145,NULL,52402847509,818794492,12793663,13.71),(156922,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156922,34.73,0.47,88.3,74069,NULL,NULL,'H','NGC 7321',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156923,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156923,34.75,0.45,89.2,74069,NULL,NULL,'K','NGC 7321',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156924,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156924,34.77,0.46,89.8,74069,NULL,NULL,'J','NGC 7321',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156925,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156925,34.81,0.3,91.5,74069,NULL,NULL,NULL,'NGC 7321',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156926,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156926,34.95,0.4,97.5,74069,NULL,NULL,'mean','NGC 7321',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156927,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156927,35.08,0.26,104,74069,NULL,NULL,'Malmquist cor.','NGC 7321',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156928,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156928,35.1,0.2,105,74069,74.4,NULL,NULL,'NGC 7321',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156929,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15202','RN',156929,40.14,0.26,944,74070,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15202',0.132482,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156930,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15202','RN',156930,41.07,0.26,1440,74070,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15202',0.132482,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156931,'BL Lac Luminosity','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156931,41.49,NULL,1980,74071,70,NULL,'nucleus-to-host flux ratio, z > 0.65','PKS 2233-148',NULL,'2006AJ....132....1S',2006,1,NULL,'Drinkwater, et al. (1997MNRAS.284...85D) give z > 0.609.','QSO',NULL,NULL,'19.5',NULL,'FSRQ           BLLAC',NULL,NULL,NULL,'BL Lac',1,339.1420417,-14.55617,0.133,NULL,50430571736,787977683,12312151,19.5),(156932,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156932,37.86,0.16,373,74072,70,NULL,NULL,'2MASX J22363473+1314043',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00016,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,339.144833,13.23439,0.133,NULL,52595320435,821801881,12840654,17.7),(156933,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156933,31.8,0.4,22.9,74073,75,NULL,'B','ARP 003',NULL,'1988NBGC.C....0000T',1988,1,2.5,NULL,'G',0.000005,NULL,'14.82',2,'SA(s)m',NULL,NULL,NULL,NULL,1,339.1460417,-2.90678,0.145,NULL,50334372669,786474572,12288665,14.82),(156934,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156934,35.46,NULL,124,74074,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12104',NULL,'2010Ap&SS.325..163P',2010,1,1.68,NULL,'G',0.000008,NULL,'16.0',0.2,'Scd',NULL,NULL,NULL,NULL,1,339.1487917,2.39669,0.161,NULL,52414106801,818970418,12796412,16),(156935,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156935,35.47,NULL,124,74074,NULL,NULL,'Dipole + Quadrupole','UGC 12104',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156936,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156936,35.48,NULL,125,74074,NULL,NULL,'Dipole','UGC 12104',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156937,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156937,35.51,NULL,126,74074,NULL,NULL,NULL,'UGC 12104',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156938,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156938,35.72,0.49,140,74074,75,NULL,'IR','UGC 12104',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156939,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156939,35.01,0.8,100,74075,75,NULL,'MAT, I','ESO 534- G 003',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'15.25',0.4,'IB pec sp',NULL,NULL,NULL,NULL,1,339.1527083,-26.25936,0.021,NULL,50074568724,782415136,12225236,15.25),(156940,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156940,34.11,0.43,66.5,74075,75,NULL,'MAT, I, raw','ESO 534- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156941,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156941,34.12,0.32,66.7,74075,85,NULL,'I, raw','ESO 534- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156942,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156942,34.15,0.32,67.7,74075,85,NULL,'I, inv','ESO 534- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156943,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156943,34.28,0.43,71.8,74075,75,NULL,'MAT, I, inv','ESO 534- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156944,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156944,34.38,0.43,75.3,74075,75,NULL,'MAT, I, cor','ESO 534- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156945,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156945,35.21,0.48,110,74075,NULL,NULL,'Malmquist cor.','ESO 534- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156946,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156946,35.26,0.47,113,74075,NULL,NULL,NULL,'ESO 534- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156947,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156947,35.3,0.2,115,74075,74.4,NULL,NULL,'ESO 534- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156948,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156948,37.86,0.16,373,74076,70,NULL,NULL,'2MASX J22364034+1317332',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,339.168083,13.29256,0.133,NULL,52595319318,821801864,12840654,17.9),(156949,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15260',NULL,156949,39.57,0.27,820,74077,70,NULL,'SN photometric redshift distance, z photo =0.214 +/- 0.033','SDSS-II SN 15260',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,339.1772917,-0.27578,0.165,NULL,49461610676,772837666,12075588,NULL),(156950,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15260','R',156950,40.24,0.13,892,74077,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15260',0.253699,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156951,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15260','R',156951,40.39,0.21,954,74077,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15260',0.253699,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156952,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15260',NULL,156952,40.42,0.12,1210,74077,70,NULL,'SALT 2','SDSS-II SN 15260',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156953,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15260',NULL,156953,40.44,0.12,1220,74077,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15260',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156954,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 20402','RN',156954,39.58,0.47,757,74078,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 20402',0.087868,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156955,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 20402','RN',156955,40.77,0.27,1310,74078,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 20402',0.087868,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156956,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 05142',NULL,156956,40.28,0.12,1140,74079,70,NULL,'SN photometric redshift distance, z photo =0.312 +/- 0.022','SDSS-II SN 05142',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,339.197125,-1.00089,0.145,NULL,49463182542,772862227,12075972,NULL),(156957,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13440','RN',156957,41.1,0.15,1280,74080,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13440',0.2978,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156958,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156958,37.86,0.16,373,74081,70,NULL,NULL,'2MASX J22364750+1318169',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,339.19775,13.30453,0.133,NULL,52595267276,821801051,12840641,17.6),(156959,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156959,35.26,NULL,113,74082,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2399',NULL,'2010Ap&SS.325..163P',2010,1,0.78,NULL,'G',0.00001,NULL,'16.5',0.1,'Scd',NULL,NULL,NULL,NULL,1,339.202791667,18.85647,0.149,NULL,52398000807,818718762,12792480,16.5),(156960,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156960,35.29,NULL,114,74082,NULL,NULL,'Dipole + Quadrupole','FGC 2399',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156961,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156961,35.3,NULL,115,74082,NULL,NULL,NULL,'FGC 2399',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156962,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156962,35.32,NULL,116,74082,NULL,NULL,'Dipole','FGC 2399',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156963,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156963,35.33,0.49,116,74082,75,NULL,'IR','FGC 2399',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156964,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156964,35.51,0.2,126,74082,74.4,NULL,NULL,'FGC 2399',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156965,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156965,35.55,0.47,129,74082,NULL,NULL,NULL,'FGC 2399',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156966,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156966,35.57,0.47,130,74082,NULL,NULL,'Malmquist cor.','FGC 2399',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156967,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156967,34.64,0.46,84.6,74083,70,NULL,NULL,'CGCG 429-012',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000171,NULL,'15.4g',0.42,'E0',NULL,NULL,NULL,NULL,1,339.2077083,14.38694,0.133,NULL,52594097784,821782777,12840355,15.4),(156968,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156968,35.39,0.55,120,74084,NULL,NULL,'Malmquist cor.','2MFGC 17028',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000027,NULL,'14.90',NULL,'Sc',NULL,NULL,NULL,NULL,1,339.208875,1.6315,0.197,NULL,51676430797,807444231,12616316,14.9),(156969,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156969,35.58,0.51,131,74084,NULL,NULL,NULL,'2MFGC 17028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156970,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156970,35.62,0.2,133,74084,74.4,NULL,NULL,'2MFGC 17028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156971,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156971,35.89,0.49,151,74084,75,NULL,'IR','2MFGC 17028',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156972,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156972,37.5,0.46,316,74085,70,NULL,NULL,'2MASX J22365277-0939069',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00015,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,339.219833,-9.65203,0.197,NULL,50353741039,786777203,12293393,16.8),(156973,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156973,37.86,0.16,373,74086,70,NULL,NULL,'2MASX J22365299+1313149',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000162,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,339.22075,13.22069,0.133,NULL,52595325707,821801964,12840655,17.1),(156974,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156974,34.34,0.4,73.7,74087,NULL,NULL,'mean','NGC 7323',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000017,NULL,'13.74',1.1,'Sb','Pair member (points to parent)',NULL,NULL,NULL,1,339.223708333,19.14386,0.137,NULL,52398491466,818726429,12792600,13.74),(156975,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156975,34.46,0.47,78.1,74087,NULL,NULL,'H','NGC 7323',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156976,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156976,34.5,0.46,79.4,74087,NULL,NULL,'J','NGC 7323',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156977,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156977,34.54,0.45,81,74087,NULL,NULL,'K','NGC 7323',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156978,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156978,35.9,0.2,151,74088,74.4,NULL,NULL,'UGC 12110',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.00011,NULL,'15.33',0.2,'S?',NULL,NULL,NULL,NULL,1,339.2295,14.41236,0.133,NULL,52594094876,821782732,12840355,15.33),(156979,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156979,35.33,0.49,116,74089,75,NULL,'IR','UGC 12110',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.00011,NULL,'15.33',0.2,'S?',NULL,NULL,NULL,NULL,1,339.2295,14.41236,0.133,NULL,52594094876,821782732,12840355,15.33),(156980,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156980,34.99,0.69,99.7,74090,100,NULL,'mid-IR','ESO 602-G 031',NULL,'2013ApJ...771...88L',2013,1,1.5,NULL,'G',0.000017,NULL,'14.88',0.8,'(R\')SAB(rs)b   Sy1.8','Field galaxy',NULL,NULL,'Sy 1.8',1,339.233083333,-22.22078,0.073,NULL,50260297099,785317142,12270580,14.88),(156981,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156981,36.67,0.33,216,74091,70,NULL,NULL,'2MASX J22365669-0946239',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000179,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,339.236125,-9.77342,0.197,NULL,50354601234,786790644,12293603,17),(156982,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156982,37.89,0.21,378,74092,70,NULL,NULL,'2MASX J22365809-0820399',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,339.242167,-8.34436,0.153,NULL,50391539635,787367806,12302621,18.2),(156983,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156983,37.07,0.46,259,74093,70,NULL,NULL,'SDSS J223658.47-093853.8',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,339.243625,-9.64831,0.197,NULL,50353741556,786777211,12293393,17.6),(156984,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156984,37.86,0.16,373,74094,70,NULL,NULL,'2MASX J22370072+1314239',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000175,NULL,'17.4g',NULL,NULL,NULL,NULL,NULL,NULL,1,339.253,13.23989,0.133,NULL,52595317426,821801834,12840653,17.4),(156985,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 01645','RN',156985,41.27,0.48,1370,74095,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01645',0.308411,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156986,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156986,36.48,0.33,198,74096,70,NULL,NULL,'MCG +02-57-006',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000172,NULL,'15.8g',0.38,'E0',NULL,NULL,NULL,NULL,1,339.256583333,14.40486,0.133,NULL,52594089019,821782640,12840353,15.8),(156987,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 16584','R',156987,41.51,0.26,1440,74097,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16584',0.393346,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',NULL,'PHOT','21.5g',0.02,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,339.258333,-0.46358,0.161,NULL,49462803393,772856303,12075879,21.5),(156988,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 16584','R',156988,41.78,0.38,1630,74097,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16584',0.393346,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156989,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 16584',NULL,156989,41.13,0.23,1680,74097,70,NULL,'SN photometric redshift distance, z photo =0.514 +/- 0.084','SDSS-II SN 16584',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156990,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 16584',NULL,156990,41.72,0.2,2210,74097,70,NULL,'SALT 2','SDSS-II SN 16584',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156991,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 16584',NULL,156991,41.78,0.2,2270,74097,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16584',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156992,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156992,37.86,0.16,373,74098,70,NULL,NULL,'SDSS J223703.97+131559.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000149,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,339.266583,13.26658,0.133,NULL,52595318630,821801853,12840653,18.4),(156993,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156993,30.89,0.1,15.1,74099,NULL,NULL,'HST KP Calibrated','NGC 7320 GROUP',NULL,'2000ApJ...529..745F',2000,1,NULL,NULL,'GGroup',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,339.269041667,34.36122,0.329,NULL,55461952378,866593005,13540515,NULL),(156994,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156994,30.89,0.1,15.1,74099,NULL,NULL,'HST KP Calibrated','NGC 7320 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156995,'SBF','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156995,30.67,0.21,13.6,74099,NULL,NULL,'HST KP Calibrated, I','NGC 7320 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156996,'SBF','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156996,30.67,0.16,13.6,74099,NULL,NULL,'HST KP Calibrated, I','NGC 7320 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156997,'SBF','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156997,30.76,0.15,14.2,74099,NULL,NULL,'HST KP Calibrated, F814W','NGC 7320 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156998,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156998,30.71,0.08,13.9,74100,74.4,NULL,NULL,'NGC 7331',NULL,'2013AJ....146...86T',2013,1,10.5,'HOLM 795H is a double star; HOLM 795G,I are stars.','G',0.000004,NULL,'10.35',3.7,'SA(s)b;HII     LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,339.2667083,34.41553,0.329,NULL,55461943645,866592869,13540513,10.35),(156999,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156999,30.79,0.08,14.4,74100,NULL,NULL,'cte LMC K03','NGC 7331',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157000,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157000,30.79,0.12,14.4,74100,NULL,NULL,'LMC W01','NGC 7331',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157001,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157001,30.8,0.08,14.5,74100,NULL,NULL,'cte U99','NGC 7331',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157002,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157002,30.81,0.09,14.5,74100,NULL,NULL,'13, VI, KEY PROJECT','NGC 7331',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157003,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157003,30.8,0.11,14.5,74100,NULL,NULL,'MW HIPP','NGC 7331',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157004,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157004,30.82,0.08,14.6,74100,NULL,NULL,'cte LMC STS02','NGC 7331',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157005,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157005,30.84,0.09,14.7,74100,NULL,NULL,'13, VI, +Z, KEY PROJECT','NGC 7331',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157006,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157006,30.86,0.08,14.9,74100,NULL,NULL,'cte MW FSG03','NGC 7331',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157007,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157007,30.86,0.22,14.9,74100,NULL,NULL,'MW P02','NGC 7331',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157008,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157008,30.88,0.09,15,74100,NULL,NULL,'cte MW GFG98','NGC 7331',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157009,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157009,30.89,0.1,15.1,74100,NULL,NULL,'HST KP Calibrated','NGC 7331',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157010,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157010,30.89,NULL,15.1,74100,NULL,18.54,NULL,'NGC 7331',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157011,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157011,30.89,0.08,15.1,74100,NULL,NULL,'cte MF91','NGC 7331',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157012,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157012,30.89,0.1,15.1,74100,NULL,NULL,'13, VI','NGC 7331',NULL,'1998ApJ...501...32H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157013,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157013,30.89,0.1,15.1,74100,NULL,18.54,'LMC ZP','NGC 7331',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157014,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157014,30.93,0.12,15.3,74100,NULL,NULL,'MW GFG','NGC 7331',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157015,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157015,30.93,0.12,15.3,74100,NULL,NULL,'48, VI','NGC 7331',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157016,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157016,30.95,0.09,15.5,74100,NULL,NULL,'cte MW STS03','NGC 7331',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157017,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157017,31.8,NULL,22.9,74100,NULL,NULL,'13, VI','NGC 7331',NULL,'2006A&A...452..423P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157018,'SBF','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157018,30.39,0.1,12,74100,NULL,NULL,'I','NGC 7331',NULL,'1997ApJ...475..399T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157019,'SBF','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157019,30.43,0.17,12.2,74100,NULL,NULL,'I','NGC 7331',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157020,'SBF','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157020,30.59,0.17,13.1,74100,NULL,NULL,'I','NGC 7331',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157021,'SBF','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157021,30.67,0.21,13.6,74100,NULL,NULL,'HST KP Calibrated, I','NGC 7331',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157022,'SBF','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157022,30.71,0.08,13.9,74100,74.4,NULL,NULL,'NGC 7331',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157023,'Grav. Stability Gas. Disk','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157023,30.91,NULL,15.2,74100,NULL,NULL,NULL,'NGC 7331',NULL,'1996AstL...22...71Z',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157024,'HII region diameter','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157024,29.29,0.05,7.22,74100,NULL,NULL,'Photographic, 349 \'dark cloud\' diameters','NGC 7331',NULL,'1982AN....303..329O',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157025,'HII region diameter','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157025,30.97,0.13,15.6,74100,NULL,NULL,NULL,'NGC 7331',NULL,'2005JKAS...38....7I',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157026,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157026,30.75,0.8,14.1,74100,75,NULL,'A82, H','NGC 7331',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157027,'Sosies','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157027,30.86,0.09,14.9,74100,NULL,NULL,NULL,'NGC 7331',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157028,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157028,29.94,0.69,9.72,74100,100,NULL,'mid-IR','NGC 7331',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157029,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157029,30.25,0.47,11.2,74100,75,NULL,'A82, H, raw','NGC 7331',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157030,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157030,30.38,0.46,11.9,74100,NULL,NULL,'B','NGC 7331',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157031,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157031,30.5,0.47,12.6,74100,75,NULL,'A82, H, inv','NGC 7331',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157032,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157032,30.57,0.47,13,74100,75,NULL,'A82, H, cor','NGC 7331',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157033,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157033,30.64,0.2,13.4,74100,NULL,NULL,'I','NGC 7331',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157034,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157034,30.66,0.35,13.6,74100,NULL,NULL,NULL,'NGC 7331',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157035,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157035,30.67,0.4,13.6,74100,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 7331',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157036,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157036,30.71,0.08,13.9,74100,74.4,NULL,NULL,'NGC 7331',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157037,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157037,30.77,0.4,14.3,74100,75,NULL,'B','NGC 7331',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157038,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157038,30.78,NULL,14.3,74100,NULL,NULL,'B','NGC 7331',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157039,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157039,30.84,0.09,14.7,74100,75,NULL,NULL,'NGC 7331',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157040,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157040,30.87,NULL,14.9,74100,NULL,NULL,'I','NGC 7331',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157041,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157041,30.94,0.35,15.4,74100,NULL,NULL,NULL,'NGC 7331',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157042,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157042,30.99,0.35,15.8,74100,NULL,NULL,'Malmquist cor.','NGC 7331',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157043,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157043,31.01,NULL,15.9,74100,NULL,NULL,'LEDA [April 2006]','NGC 7331',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157044,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157044,31,0.43,15.9,74100,75,NULL,'3.6 micron, color corrected','NGC 7331',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157045,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157045,31.05,0.43,16.2,74100,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7331',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157046,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157046,31.06,0.4,16.3,74100,73,NULL,'opt','NGC 7331',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157047,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157047,35.99,0.2,158,74101,74.4,NULL,NULL,'CGCG 429-014',NULL,'2013AJ....146...86T',2013,1,0.46,NULL,'G',0.0001,NULL,'15.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,339.282125,14.23194,0.169,NULL,52596385160,821818518,12840914,15.9),(157048,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157048,37.2,0.65,276,74102,70,NULL,NULL,'2MASX J22370813-6140277',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.000083,NULL,'17.24',0.27,NULL,NULL,NULL,NULL,NULL,1,339.283875,-61.67439,0,NULL,48789308060,762332938,11911452,17.24),(157049,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157049,36.16,NULL,171,74103,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12112',NULL,'2010Ap&SS.325..163P',2010,1,1.23,NULL,'G',0.000009,NULL,'16.0',0.11,'Sc',NULL,NULL,NULL,NULL,1,339.306083,11.95078,0.113,NULL,52586192146,821659252,12838425,16),(157050,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157050,36.17,NULL,171,74103,NULL,NULL,'Dipole + Quadrupole','UGC 12112',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157051,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157051,36.18,NULL,172,74103,NULL,NULL,'Dipole','UGC 12112',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157052,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157052,36.27,NULL,179,74103,NULL,NULL,NULL,'UGC 12112',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157053,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157053,36.44,0.49,194,74103,75,NULL,'IR','UGC 12112',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157054,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2007pq',NULL,157054,39.32,0.12,730,74104,70,NULL,'Hubble residual 0.02 for z0.18550','SDSS J223713.94+004410.6',NULL,'2011ApJ...740...92G',2011,1,0.08,NULL,'G',0.0005,NULL,'20.4g',0.05,NULL,NULL,NULL,NULL,NULL,1,339.308125,0.73631,0.241,NULL,51677870232,807466722,12616667,20.4),(157055,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 20048','R',157055,39.82,0.21,777,74104,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007pq','SDSS J223713.94+004410.6',0.1855,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157056,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2007pq',NULL,157056,39.64,0.1,847,74104,70,NULL,'SALT 2','SDSS J223713.94+004410.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157057,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2007pq',NULL,157057,39.65,0.1,851,74104,70,NULL,'SALT 2, Malmquist cor.','SDSS J223713.94+004410.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157058,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 20048','R',157058,40.08,0.13,876,74104,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007pq','SDSS J223713.94+004410.6',0.1855,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157059,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157059,37.89,0.21,378,74105,70,NULL,NULL,'2MASX J22371568-0819139',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00015,NULL,'16.3g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,339.315333,-8.32044,0.153,NULL,50395748610,787433572,12303649,16.3),(157060,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157060,36.22,0.63,176,74106,70,NULL,NULL,'MCG -07-46-005',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.5',0.3,NULL,NULL,NULL,NULL,NULL,1,339.317583333,-43.70319,0,NULL,50720408320,792506380,12382912,15.5),(157061,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157061,37.89,0.21,378,74107,70,NULL,NULL,'2MASX J22371804-0821244',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,339.32525,-8.35672,0.153,NULL,50395747270,787433551,12303649,18),(157062,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 16414','R',157062,40.82,0.26,1120,74108,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006pj','SN 2006pj',0.307732,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,339.3264583,0.73814,0.241,NULL,51677862021,807466594,12616665,NULL),(157063,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 16414','R',157063,40.9,0.18,1160,74108,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006pj','SN 2006pj',0.307732,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157064,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157064,37.86,0.16,373,74109,70,NULL,NULL,'SDSS J223718.34+131652.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,339.3264583,13.28128,0.141,NULL,52595298367,821801536,12840649,18),(157065,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157065,37.77,0.23,358,74110,70,NULL,NULL,'2MASX J22372098+1227584',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000152,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,339.337417,12.46631,0.149,NULL,52586282765,821660668,12838447,16.7),(157066,'SBF','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157066,31.66,0.14,21.5,74111,74.4,NULL,NULL,'NGC 7332',NULL,'2013AJ....146...86T',2013,1,4.1,NULL,'G',0.000017,NULL,'12.02',1.1,'S0 pec sp','Pair member (points to parent)',NULL,NULL,NULL,1,339.35225,23.79833,0.109,NULL,52353385134,818021642,12781588,12.02),(157067,'SBF','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157067,31.81,0.2,23,74111,NULL,NULL,'I','NGC 7332',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157068,'Faber-Jackson','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157068,28.85,0.63,5.89,74111,95,NULL,'Michard 1979b, c','NGC 7332',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157069,'Faber-Jackson','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157069,30.09,0.46,10.4,74111,95,NULL,'Michard 1979a','NGC 7332',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157070,'Faber-Jackson','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157070,30.12,0.31,10.6,74111,95,NULL,'Weighted Mean','NGC 7332',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157071,'Faber-Jackson','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157071,30.14,0.81,10.7,74111,55,NULL,'Visvanathan & Sandage 1979','NGC 7332',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157072,'Faber-Jackson','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157072,31.86,0.6,23.6,74111,95,NULL,'de Vaucouleurs','NGC 7332',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157073,'Tertiary','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157073,30.56,0.25,12.9,74111,95,NULL,NULL,'NGC 7332',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157074,'Tully est','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157074,31.3,0.8,18.2,74111,75,NULL,'B','NGC 7332',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157075,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157075,29.69,0.45,8.66,74111,NULL,NULL,'K','NGC 7332',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157076,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157076,30.68,0.4,13.7,74111,NULL,NULL,'mean','NGC 7332',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157077,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157077,30.76,0.49,14.2,74111,75,NULL,'IR','NGC 7332',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157078,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 17690','RN',157078,42.8,0.18,2420,74112,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17690',0.49717,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157079,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157079,34.28,0.49,71.7,74113,75,NULL,'IR','NGC 7320B',NULL,'2011yCatp016004901K',2011,1,0.82,NULL,'G',0.001094,NULL,'15.7',0.24,NULL,NULL,NULL,NULL,NULL,1,339.36725,33.92292,0.317,NULL,55461648254,866588253,13540441,15.7),(157080,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157080,32.6,0.47,33.2,74114,NULL,NULL,'H','NGC 7328',NULL,'2007A&A...465...71T',2007,1,2,NULL,'G',0.000003,NULL,'13.98',0.7,'Sab            HII','Isolated galaxy',NULL,NULL,NULL,1,339.372,10.53158,0.213,NULL,52457354245,819646160,12806971,13.98),(157081,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157081,32.69,0.45,34.5,74114,NULL,NULL,'K','NGC 7328',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157082,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157082,32.72,0.46,35,74114,NULL,NULL,'J','NGC 7328',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157083,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157083,32.73,0.4,35.1,74114,NULL,NULL,'mean','NGC 7328',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157084,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157084,32.93,0.44,38.6,74114,NULL,NULL,'Malmquist cor.','NGC 7328',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157085,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157085,32.97,0.43,39.3,74114,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7328',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157086,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157086,33.03,0.43,40.4,74114,75,NULL,'3.6 micron, color corrected','NGC 7328',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157087,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157087,33.05,0.2,40.7,74114,74.4,NULL,NULL,'NGC 7328',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157088,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157088,33.05,0.42,40.8,74114,NULL,NULL,NULL,'NGC 7328',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157089,'GRB','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157089,44,0.82,3020,74115,NULL,NULL,NULL,'GRB 091024',1.092,'2010JCAP...08..020W',2010,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,339.251375,56.88944,NULL,NULL,53377496985,834023390,13031615,NULL),(157090,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157090,34.45,0.2,77.6,74116,74.4,NULL,NULL,'UGC 12119',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000017,NULL,'16.0',0.5,'S?',NULL,NULL,NULL,NULL,1,339.380375,18.79253,0.201,NULL,52398794014,818731156,12792674,16),(157091,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157091,34.48,0.68,78.7,74116,NULL,NULL,NULL,'UGC 12119',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157092,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157092,34.8,0.59,91.2,74116,NULL,NULL,'Malmquist cor.','UGC 12119',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157093,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157093,36.95,0.46,245,74117,70,NULL,NULL,'2MASX J22373257+0109004',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000193,NULL,'16.0g',0.47,'E0',NULL,NULL,NULL,NULL,1,339.3857917,1.15022,0.213,NULL,51677940690,807467823,12616684,16),(157094,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157094,37.86,0.16,373,74118,70,NULL,NULL,'2MASX J22373424+1313444',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000169,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,339.392791667,13.22911,0.141,NULL,52594835181,821794299,12840535,17.6),(157095,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157095,38.18,0.46,433,74119,70,NULL,NULL,'SDSS J223735.44+132652.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,339.397666667,13.448,0.141,NULL,52594816633,821794009,12840531,18.2),(157096,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157096,37.04,0.46,256,74120,70,NULL,NULL,'2MASX J22373689+1306224',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,339.40375,13.10625,0.133,NULL,52594934120,821795845,12840560,17.3),(157097,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157097,35.63,0.4,134,74121,NULL,NULL,'mean','CGCG 452-037',NULL,'2007A&A...465...71T',2007,1,0.8,NULL,'G',0.000033,NULL,'15.31',0.2,'S?',NULL,NULL,NULL,NULL,1,339.413583,20.01606,0.181,NULL,52410695242,818917113,12795579,15.31),(157098,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157098,35.86,0.47,149,74121,NULL,NULL,'H','CGCG 452-037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157099,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157099,37.51,0.33,317,74122,70,NULL,NULL,'2MASX J22374003+1408064',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,339.41675,14.13511,0.169,NULL,52596419335,821819052,12840922,17.2),(157100,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157100,37.98,0.46,394,74123,70,NULL,NULL,'2MASXi J2237401+134739',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,339.417083,13.79433,0.169,NULL,52596494260,821820222,12840940,17.7),(157101,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157101,37.51,0.33,317,74124,70,NULL,NULL,'2MASX J22374030+1406003',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000189,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,339.417958333,14.10003,0.169,NULL,52596417336,821819020,12840922,16.6),(157102,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157102,37.77,0.23,358,74125,70,NULL,NULL,'SDSS J223744.45+123645.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,339.4352083,12.61253,0.169,NULL,52586219530,821659680,12838432,18.3),(157103,'SNII optical','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 1989L',NULL,157103,30.94,0.19,15.3,74126,NULL,NULL,'SEAM','NGC 7339',0.00438,'2009ApJ...694.1067P',2009,1,3,NULL,'G',0.000027,NULL,'13.13',0.7,'SAB(s)bc:?','Pair member (points to parent)',NULL,NULL,NULL,1,339.446833,23.78669,0.109,NULL,52353514055,818023657,12781619,13.13),(157104,'SNII optical','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 1989L',NULL,157104,31.15,0.45,17,74126,NULL,NULL,NULL,'NGC 7339',NULL,'1994ApJ...432...42S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157105,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157105,31.42,0.8,19.2,74126,75,NULL,'MAT, I','NGC 7339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157106,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157106,31.42,0.8,19.2,74126,75,NULL,'W91PP, r','NGC 7339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157107,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157107,31.44,0.8,19.5,74126,75,NULL,'CF, r','NGC 7339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157108,'Tully est','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157108,31.43,0.8,19.3,74126,75,NULL,'B','NGC 7339',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157109,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157109,31.4,0.3,19.1,74126,NULL,18.45,'SN 1989L host','NGC 7339',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157110,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157110,31.53,0.43,20.2,74126,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7339',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157111,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157111,31.74,0.43,22.2,74126,75,NULL,'3.6 micron, color corrected','NGC 7339',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157112,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157112,31.75,0.37,22.4,74126,NULL,NULL,NULL,'NGC 7339',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157113,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157113,31.78,0.4,22.7,74126,75,NULL,NULL,'NGC 7339',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157114,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157114,31.84,0.38,23.3,74126,75,NULL,'W91PP, r, raw','NGC 7339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157115,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157115,31.85,0.38,23.5,74126,75,NULL,'CF, r, raw','NGC 7339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157116,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157116,31.93,0.38,24.3,74126,75,NULL,'W91PP, r, inv','NGC 7339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157117,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157117,31.93,0.38,24.4,74126,75,NULL,'CF, r, inv','NGC 7339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157118,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157118,31.95,0.32,24.5,74126,85,NULL,'I, raw','NGC 7339',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157119,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157119,31.98,0.32,24.9,74126,85,NULL,'I, inv','NGC 7339',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157120,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157120,32,0.43,25.1,74126,75,NULL,'MAT, I, raw','NGC 7339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157121,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157121,32,0.2,25.1,74126,74.4,NULL,NULL,'NGC 7339',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157122,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157122,32.02,0.38,25.3,74126,75,NULL,'W91PP, r, cor','NGC 7339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157123,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157123,32.03,0.38,25.4,74126,75,NULL,'CF, r, cor','NGC 7339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157124,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157124,32.19,0.43,27.4,74126,75,NULL,'MAT, I, inv','NGC 7339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157125,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157125,32.21,0.43,27.6,74126,75,NULL,'MAT, I, cor','NGC 7339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157126,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157126,32.23,0.47,27.9,74126,NULL,NULL,NULL,'NGC 7339',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157127,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157127,32.32,0.45,29.1,74126,NULL,NULL,'Malmquist cor.','NGC 7339',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157128,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157128,37.37,0.46,299,74127,70,NULL,NULL,'SDSS J223747.72+130707.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,339.448833,13.11861,0.141,NULL,52594935215,821795862,12840560,18),(157129,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157129,37.6,0.46,332,74128,70,NULL,NULL,'2MASX J22374824-0751162',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000239,NULL,'17.9g',0.17,'Candidate      BLAGN',NULL,NULL,NULL,NULL,1,339.451083,-7.85469,0.149,NULL,50396366573,787443227,12303800,17.9),(157130,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157130,37.89,0.21,378,74129,70,NULL,NULL,'2MASX J22375167-0819302',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000144,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,339.4654583,-8.32511,0.169,NULL,50395750706,787433604,12303650,17.7),(157131,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157131,33.55,0.8,51.3,74130,75,NULL,'MAT, I','UGC 12123',NULL,'1997ApJS..109..333W',1997,1,1.16,NULL,'G',0.000007,NULL,'15.70',0.13,'SBcd?',NULL,NULL,NULL,NULL,1,339.472666667,25.19333,0.129,NULL,51883163703,810674432,12666788,15.7),(157132,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157132,33.55,0.8,51.4,74130,75,NULL,'W91PP, r','UGC 12123',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157133,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157133,33.36,0.63,47,74130,NULL,NULL,'Malmquist cor.','UGC 12123',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157134,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157134,33.55,0.32,51.4,74130,85,NULL,'I, inv','UGC 12123',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157135,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157135,33.56,0.2,51.5,74130,74.4,NULL,NULL,'UGC 12123',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157136,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157136,33.57,0.32,51.8,74130,85,NULL,'I, raw','UGC 12123',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157137,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157137,33.62,0.56,52.9,74130,NULL,NULL,NULL,'UGC 12123',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157138,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157138,33.63,NULL,53.2,74130,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12123',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157139,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157139,33.66,NULL,53.9,74130,NULL,NULL,'Dipole + Quadrupole','UGC 12123',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157140,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157140,33.68,NULL,54.4,74130,NULL,NULL,'Dipole','UGC 12123',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157141,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157141,33.68,0.43,54.4,74130,75,NULL,'3.6 micron, color corrected','UGC 12123',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157142,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157142,33.73,0.49,55.6,74130,75,NULL,'IR','UGC 12123',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157143,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157143,33.77,0.43,56.7,74130,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12123',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157144,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157144,33.79,0.38,57.3,74130,75,NULL,'W91PP, r, inv','UGC 12123',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157145,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157145,33.81,NULL,57.8,74130,NULL,NULL,NULL,'UGC 12123',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157146,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157146,33.87,0.38,59.5,74130,75,NULL,'W91PP, r, raw','UGC 12123',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157147,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157147,33.87,0.43,59.5,74130,75,NULL,'MAT, I, raw','UGC 12123',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157148,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157148,33.88,0.43,59.6,74130,75,NULL,'MAT, I, inv','UGC 12123',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157149,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157149,34.22,0.38,69.8,74130,75,NULL,'W91PP, r, cor','UGC 12123',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157150,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157150,34.32,0.43,73,74130,75,NULL,'MAT, I, cor','UGC 12123',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157151,'L(H{beta})-{sigma}','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157151,45.06,NULL,1641,74131,74.3,NULL,NULL,'WISP 046_0075',1.504,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,339.485333333,-18.71281,0.029,NULL,50251519118,785179986,12268437,NULL),(157152,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 07532','RN',157152,43.13,0.33,2750,74132,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 07532',0.541159,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157153,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157153,37.24,0.46,281,74133,70,NULL,NULL,'2MASX J22380095+1417566',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000171,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,339.504041667,14.29894,0.189,NULL,52596145362,821814771,12840855,16.3),(157154,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157154,37.77,0.23,358,74134,70,NULL,NULL,'2MASX J22380109+1235246',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,339.5047083,12.59011,0.169,NULL,52586944496,821671007,12838609,17.8),(157155,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157155,37.77,0.23,358,74135,70,NULL,NULL,'2MASX J22380676+1242546',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,339.5282083,12.71519,0.129,NULL,52586690580,821667040,12838547,17.4),(157156,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157156,38.66,0.46,538,74136,70,NULL,NULL,'APMUKS(BJ) B223534.49+004600.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'19.35',0.11,NULL,NULL,NULL,NULL,NULL,1,339.532875,1.02697,0.213,NULL,51677843244,807466300,12616660,19.35),(157157,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157157,37.53,0.46,320,74137,70,NULL,NULL,'2MASX J22380865-0018503',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000176,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,339.535916667,-0.31406,0.173,NULL,49461790355,772840474,12075632,16.9),(157158,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157158,37.03,0.46,255,74138,70,NULL,NULL,'SDSS J223811.72+134833.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.2g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,339.548875,13.80936,0.169,NULL,52596460042,821819688,12840932,17.2),(157159,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157159,36.14,0.66,169,74139,70,NULL,NULL,'2MASX J22381207-6055513',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.000103,NULL,'16.77',0.25,NULL,NULL,NULL,NULL,NULL,1,339.550417,-60.93092,0,NULL,48803671883,762557373,11914958,16.77),(157160,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157160,32.89,0.4,37.8,74140,75,NULL,NULL,'UGC 12141',NULL,'2008Ap.....51..336K',2008,1,1.2,NULL,'G',0.00002,NULL,'15.54',0.3,'Scd:','Isolated galaxy',NULL,NULL,NULL,1,339.5614583,80.67725,0.613,NULL,52846230768,825722355,12901911,15.54),(157161,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157161,33.19,0.2,43.5,74140,74.4,NULL,NULL,'UGC 12141',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157162,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157162,33.27,0.66,45,74140,NULL,NULL,'Malmquist cor.','UGC 12141',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157163,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157163,33.33,0.64,46.4,74140,NULL,NULL,NULL,'UGC 12141',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157164,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157164,33.38,0.49,47.5,74140,75,NULL,'IR','UGC 12141',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157165,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157165,37.06,0.46,259,74141,70,NULL,NULL,'2MASX J22381738+1403320',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000193,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,339.572333,14.05897,0.169,NULL,52596548342,821821067,12840954,16.8),(157166,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13289','RN',157166,40.74,0.09,1250,74142,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13289',0.128939,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157167,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13289','RN',157167,41.25,0.19,1570,74142,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13289',0.128939,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157168,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157168,35.92,0.73,153,74143,70,NULL,NULL,'6dF J2238212-360101',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,339.588666667,-36.01683,0,NULL,50576889921,790263905,12347873,14.7),(157169,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157169,37.89,0.21,378,74144,70,NULL,NULL,'2MASX J22382263-0818475',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000194,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,339.594417,-8.31328,0.169,NULL,50396525941,787445717,12303839,18.2),(157170,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 20534','R',157170,40.48,0.14,1070,74145,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 20534',0.164366,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,339.608417,-0.23644,0.173,NULL,49462275680,772848057,12075750,NULL),(157171,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13722','RN',157171,40.28,0.06,1050,74146,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13722',0.087742,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157172,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13722','RN',157172,40.55,0.18,1190,74146,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13722',0.087742,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157173,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15391','RN',157173,39.02,0.12,586,74147,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 15391',0.088158,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157174,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15391','RN',157174,39.09,0.19,604,74147,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 15391',0.088158,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157175,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 01991',NULL,157175,39.98,0.33,992,74148,70,NULL,'SN photometric redshift distance, z photo =0.266 +/- 0.053','SDSS-II SN 01991',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,339.626583,0.90831,0.213,NULL,51677156958,807455577,12616493,NULL),(157176,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 01991','R',157176,40.65,0.27,1020,74148,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01991',0.315484,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157177,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 01991','R',157177,40.7,0.19,1050,74148,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01991',0.315484,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157178,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 01991',NULL,157178,40.54,0.16,1280,74148,70,NULL,'SALT 2','SDSS-II SN 01991',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157179,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 01991',NULL,157179,40.57,0.16,1300,74148,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 01991',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157180,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157180,36.05,0.62,162,74149,70,NULL,NULL,'2MASX J22383473-6822293',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'16.36',0.4,'S0',NULL,NULL,NULL,NULL,1,339.644708333,-68.37475,0.005,NULL,49321142530,770642852,12041294,16.36),(157181,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 03812','RN',157181,36.04,0.07,152,74150,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03812',0.060392,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157182,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 03812','RN',157182,40.47,0.61,1170,74150,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03812',0.060392,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157183,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 1974J','R',157183,34.95,NULL,97.7,74151,NULL,NULL,'Photographic','NGC 7343',NULL,'1988SSRv...48....1R',1988,1,1.1,'HMS gives v=1206 km/sec. RC3 gives v_21_=6065 km/s and v_opt_=6500 km/s.','G',0.000033,NULL,'14.4',0.9,'(R\')SB(s)bc:   LINER',NULL,NULL,NULL,NULL,1,339.65775,34.07144,0.281,NULL,55465120907,866642514,13541289,14.4),(157184,'Tully est','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157184,31.41,0.8,19.1,74151,75,NULL,'B','NGC 7343',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157185,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157185,35.05,0.4,102,74151,NULL,NULL,'mean','NGC 7343',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157186,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157186,35.34,0.47,117,74151,NULL,NULL,'H','NGC 7343',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157187,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157187,35.37,0.45,118,74151,NULL,NULL,'K','NGC 7343',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157188,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157188,35.42,0.46,121,74151,NULL,NULL,'J','NGC 7343',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157189,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157189,36.11,0.87,166,74152,70,NULL,NULL,'2MASX J22384028-6649417',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'16.2',0.47,'S0',NULL,NULL,NULL,NULL,1,339.6677083,-66.82833,0,NULL,49285645477,770088210,12032628,16.2),(157190,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157190,36.96,0.46,246,74153,70,NULL,NULL,'SDSS J223840.65+000603.4',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'15.7g',0.44,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,339.669375,0.10094,0.189,NULL,51675740864,807433451,12616147,15.7),(157191,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157191,37.71,0.46,348,74154,70,NULL,NULL,'2MASX J22384128+1406063',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000135,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,339.672125,14.10194,0.189,NULL,52596361592,821818149,12840908,18.1),(157192,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157192,33.16,0.8,42.8,74155,75,NULL,'MAT, I','ESO 534- G 009',NULL,'1997ApJS..109..333W',1997,1,2.9,NULL,'G',0.00001,NULL,'13.55',0.8,'SA(s)ab? sp;HIILINER',NULL,NULL,NULL,NULL,1,339.6725417,-25.85067,0,NULL,50074174813,782408981,12225140,13.55),(157193,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157193,33.19,0.45,43.4,74155,NULL,NULL,'K','ESO 534- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157194,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157194,33.21,0.4,43.8,74155,NULL,NULL,'mean','ESO 534- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157195,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157195,33.25,0.47,44.6,74155,NULL,NULL,'H','ESO 534- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157196,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157196,33.26,0.46,44.9,74155,NULL,NULL,'J','ESO 534- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157197,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157197,33.32,0.32,46.2,74155,85,NULL,'I, raw','ESO 534- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157198,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157198,33.38,0.32,47.5,74155,85,NULL,'I, inv','ESO 534- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157199,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157199,33.43,0.48,48.5,74155,NULL,NULL,'Malmquist cor.','ESO 534- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157200,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157200,33.46,0.43,49.3,74155,75,NULL,'MAT, I, raw','ESO 534- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157201,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157201,33.53,0.46,50.8,74155,NULL,NULL,NULL,'ESO 534- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157202,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157202,33.57,0.2,51.8,74155,74.4,NULL,NULL,'ESO 534- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157203,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157203,33.71,0.43,55.1,74155,75,NULL,'MAT, I, cor','ESO 534- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157204,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157204,33.73,0.43,55.7,74155,75,NULL,'MAT, I, inv','ESO 534- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157205,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15942',NULL,157205,39.74,0.46,887,74156,70,NULL,'SN photometric redshift distance, z photo =0.234 +/- 0.066','SDSS-II SN 15942',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,339.674666667,-0.6285,0.165,NULL,49462178018,772846531,12075727,NULL),(157206,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 15942',NULL,157206,41.17,0.13,1710,74156,70,NULL,'SALT 2','SDSS-II SN 15942',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157207,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 15942',NULL,157207,41.21,0.13,1750,74156,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15942',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157208,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157208,36.94,0.46,244,74157,70,NULL,NULL,'SDSS J223842.78+130445.6',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000184,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,339.67825,13.07936,0.141,NULL,52594885821,821795090,12840548,16.2),(157209,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157209,33.27,0.43,45,74158,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12135',NULL,'2014MNRAS.444..527S',2014,1,1.4,NULL,'G',0.000033,NULL,'16.0P',0.6,'Sc',NULL,NULL,NULL,NULL,1,339.6977917,72.54669,3.009,NULL,52786270667,824785479,12887273,16),(157210,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157210,33.42,0.43,48.3,74158,75,NULL,'3.6 micron, color corrected','UGC 12135',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157211,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157211,33.43,0.2,48.5,74158,74.4,NULL,NULL,'UGC 12135',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157212,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157212,33.6,0.57,52.4,74158,NULL,NULL,NULL,'UGC 12135',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157213,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157213,33.75,0.53,56.3,74158,NULL,NULL,'Malmquist cor.','UGC 12135',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157214,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157214,36.72,0.58,221,74159,70,NULL,NULL,'2MASX J22384875-2004488',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'15.89',0.33,NULL,'Field galaxy',NULL,NULL,NULL,1,339.703333,-20.08019,0.077,NULL,50250504353,785164130,12268189,15.89),(157215,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157215,34.49,0.8,79.1,74160,75,NULL,'W91PP, r','UGC 12132',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'15.24',0.5,'SBb?',NULL,NULL,NULL,NULL,1,339.711625,34.30303,0.345,NULL,55465265871,866644779,13541324,15.24),(157216,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157216,34.94,0.38,97.4,74160,75,NULL,'W91PP, r, raw','UGC 12132',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157217,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157217,35.02,0.38,101,74160,75,NULL,'W91PP, r, cor','UGC 12132',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157218,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157218,35.1,0.38,105,74160,75,NULL,'W91PP, r, inv','UGC 12132',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157219,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2007ik',NULL,157219,39.34,0.13,736,74161,70,NULL,'Hubble residual 0.06 for z0.18400','SDSS-II SN 17168 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,339.723625,-1.16725,0.133,NULL,49462585359,772852896,12075826,NULL),(157220,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 17168','R',157220,39.9,0.19,805,74161,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ik','SDSS-II SN 17168 HOST',0.185192,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157221,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2007ik',NULL,157221,39.75,0.09,891,74161,70,NULL,'SALT 2','SDSS-II SN 17168 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157222,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2007ik',NULL,157222,39.76,0.09,895,74161,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 17168 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157223,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 17168','R',157223,40.15,0.13,905,74161,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ik','SDSS-II SN 17168 HOST',0.185192,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157224,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157224,37.53,0.46,321,74162,70,NULL,NULL,'2MASX J22385614+1251594',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,339.734041667,12.86664,0.133,NULL,52586729154,821667643,12838556,17.2),(157225,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157225,36.96,0.61,247,74163,70,NULL,NULL,'2MASX J22385671-1924491',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.00',0.29,NULL,'Field galaxy',NULL,NULL,NULL,1,339.7365,-19.41369,0.061,NULL,50251034185,785172409,12268318,16),(157226,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157226,31.21,0.43,17.5,74164,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 432',NULL,'2014MNRAS.444..527S',2014,1,2.6,'Double star HD 214517 (V ~10 each, 18\\\" sep) superposed 54\\\" west-southwest.','G',0.000006,NULL,'13.5',0.9,'SAB(s)dm?',NULL,NULL,NULL,NULL,1,339.738333,-5.85314,0.133,NULL,50342136848,786595888,12290560,13.5),(157227,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 02681','RN',157227,40.33,0.18,941,74165,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02681',0.239856,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157228,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 02681','RN',157228,41.92,0.24,1950,74165,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02681',0.239856,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157229,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 18626',NULL,157229,40.49,0.24,1250,74166,70,NULL,'SN photometric redshift distance, z photo =0.352 +/- 0.051','SDSS-II SN 18626',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.3g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,339.766083,-0.27258,0.185,NULL,49462297657,772848400,12075756,21.3),(157230,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 18626','R',157230,41.47,0.33,1440,74166,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18626',0.362429,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157231,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 18626','R',157231,41.61,0.31,1540,74166,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18626',0.362429,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157232,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157232,37.5,0.46,316,74167,70,NULL,NULL,'2MASX J22390433+0020122',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000144,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,339.767958333,0.33678,0.193,NULL,51675775552,807433993,12616156,17.4),(157233,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 21813','R',157233,40.5,0.27,950,74168,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 21813',0.325169,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,'PHOT','21.9g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,339.7719583,1.18467,0.217,NULL,51677232861,807456763,12616511,21.9),(157234,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 21813',NULL,157234,40.2,0.59,1100,74168,70,NULL,'SN photometric redshift distance, z photo =0.299 +/- 0.120','SDSS-II SN 21813',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157235,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 21813','R',157235,40.85,0.37,1120,74168,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21813',0.325169,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157236,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 21813',NULL,157236,40.49,0.22,1250,74168,70,NULL,'SALT 2','SDSS-II SN 21813',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157237,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 21813',NULL,157237,40.52,0.22,1270,74168,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 21813',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157238,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157238,32.62,0.47,33.4,74169,NULL,NULL,'H','NGC 7341',NULL,'2007A&A...465...71T',2007,1,2.4,NULL,'G',0.000017,NULL,'13.28',1,'SAB(r)b',NULL,NULL,NULL,NULL,1,339.773083,-22.66667,0.041,NULL,50256516618,785258072,12269657,13.28),(157239,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157239,33.28,0.46,45.4,74169,NULL,NULL,'J','NGC 7341',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157240,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157240,33.34,0.45,46.5,74169,NULL,NULL,'K','NGC 7341',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157241,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157241,33.5,0.4,50.2,74169,NULL,NULL,'mean','NGC 7341',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157242,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157242,34.56,0.56,81.6,74170,70,NULL,NULL,'ESO 603- G 001',NULL,'2014MNRAS.445.2677S',2014,1,1.3,'Mathewson, et al. (1996,ApJS,107,97) give v = 8935 +/- 10 km/sec.','G',0.000033,NULL,'14.50',0.4,'(R\':)SAB(rs)ab','Field galaxy',NULL,NULL,NULL,1,339.7740417,-19.66233,0.061,NULL,50250573603,785165212,12268206,14.5),(157243,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157243,35.4,0.47,120,74170,NULL,NULL,'H','ESO 603- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157244,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157244,35.51,0.4,126,74170,NULL,NULL,'mean','ESO 603- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157245,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157245,35.53,0.45,127,74170,NULL,NULL,'K','ESO 603- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157246,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157246,35.6,0.46,132,74170,NULL,NULL,'J','ESO 603- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157247,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157247,35.6,0.35,132,74170,NULL,NULL,'Malmquist cor.','ESO 603- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157248,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157248,35.81,0.31,145,74170,NULL,NULL,NULL,'ESO 603- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157249,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157249,35.85,0.2,148,74170,74.4,NULL,NULL,'ESO 603- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157250,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157250,30.39,0.4,12,74171,75,NULL,'B','UGCA 433',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000013,NULL,'14.97',0.5,'Im:',NULL,NULL,NULL,NULL,1,339.787625,-4.76019,0.109,NULL,50344709059,786636079,12291188,14.97),(157251,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157251,35.75,0.56,141,74172,NULL,NULL,NULL,'AGC 620266',NULL,'2009ApJS..182..474S',2009,1,0.53,NULL,'G',0.00002,NULL,'16.95',0.28,NULL,NULL,NULL,NULL,NULL,1,339.802541667,-2.43914,0.145,NULL,49460430102,772819220,12075300,16.95),(157252,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157252,35.79,0.2,144,74172,74.4,NULL,NULL,'AGC 620266',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157253,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157253,35.8,0.55,145,74172,NULL,NULL,'Malmquist cor.','AGC 620266',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157254,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157254,36.64,0.17,213,74173,70,NULL,NULL,'2MASX J22391609-0059353',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000172,NULL,'16.2g',0.36,'E0',NULL,NULL,NULL,NULL,1,339.817167,-0.99311,0.145,NULL,49462491193,772851424,12075803,16.2),(157255,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 07254','R',157255,40.18,0.29,794,74174,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 07254',0.366238,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,'PHOT','22.2g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,339.8309583,0.54333,0.181,NULL,51675878589,807435602,12616181,22.2),(157256,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 07254','R',157256,40.18,0.38,797,74174,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 07254',0.366238,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157257,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 07254',NULL,157257,41.19,0.35,1730,74174,70,NULL,'SN photometric redshift distance, z photo =0.536 +/- 0.143','SDSS-II SN 07254',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157258,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157258,36.64,0.17,213,74175,70,NULL,NULL,'2MASX J22392403-0102163',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'16.16',0.33,'BrClG',NULL,NULL,NULL,NULL,1,339.850125,-1.03781,0.145,NULL,49462480485,772851257,12075800,16.16),(157259,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157259,37.12,0.46,266,74176,70,NULL,NULL,'2MASX J22392405+1320067',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,339.85025,13.33522,0.141,NULL,52594802519,821793789,12840527,16.9),(157260,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157260,36.64,0.17,213,74177,70,NULL,NULL,'2MASX J22392482-0041333',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000178,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,339.8535,-0.69272,0.169,NULL,49462135480,772845866,12075716,17.6),(157261,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157261,38.46,0.46,491,74178,70,NULL,NULL,'SDSS J223925.12+140043.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000145,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,339.8547083,14.012,0.189,NULL,52595912630,821811134,12840798,18.5),(157262,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157262,34.93,0.49,96.8,74179,75,NULL,'IR','ESO 603- G 002',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'16.31',0.2,'S              HII','Field galaxy',NULL,NULL,NULL,1,339.859416667,-20.37033,0.061,NULL,50261459867,785335310,12270864,16.31),(157263,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157263,35.09,0.53,104,74179,NULL,NULL,NULL,'ESO 603- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157264,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157264,35.13,0.2,106,74179,74.4,NULL,NULL,'ESO 603- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157265,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157265,35.19,0.51,109,74179,NULL,NULL,'Malmquist cor.','ESO 603- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157266,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157266,36.34,NULL,185,74180,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2405',NULL,'2010Ap&SS.325..163P',2010,1,0.93,NULL,'G',NULL,NULL,'16.51',0.08,'Scd',NULL,NULL,NULL,NULL,1,339.865875,40.45553,0.525,NULL,55528612614,867634572,13556790,16.51),(157267,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157267,36.35,NULL,186,74180,NULL,NULL,NULL,'FGC 2405',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157268,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157268,36.36,NULL,187,74180,NULL,NULL,'Dipole + Quadrupole','FGC 2405',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157269,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157269,36.39,NULL,190,74180,NULL,NULL,'Dipole','FGC 2405',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157270,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157270,36.98,0.46,249,74181,70,NULL,NULL,'2MASX J22392876+0012263',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,339.869833333,0.20736,0.189,NULL,51675050870,807422669,12615979,16.8),(157271,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 21695','RN',157271,43.5,0.54,3840,74182,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 21695',0.30628,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157272,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 19742','RN',157272,40.79,0.22,1060,74183,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19742',0.359576,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157273,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 19742','RN',157273,41.06,0.31,1200,74183,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19742',0.359576,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157274,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157274,33.88,0.2,58.2,74184,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','UGC 12133',0.02476,'2011A&A...526A..81B',2011,1,1.88,NULL,'G',0.000007,NULL,'15.39',0.21,'Sc',NULL,NULL,NULL,NULL,1,339.883333,8.61294,0.285,NULL,52477938461,819967788,12811996,15.39),(157275,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157275,34.44,0.23,75.4,74184,74.2,NULL,'SALT 2','UGC 12133',0.02476,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157276,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157276,35.02,0.24,98.5,74184,72,NULL,NULL,'UGC 12133',0.02476,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157277,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157277,35.02,0.17,101,74184,70.8,NULL,NULL,'UGC 12133',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157278,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157278,35.03,0.08,101,74184,74.4,NULL,NULL,'UGC 12133',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157279,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157279,35.09,0.18,102,74184,70,NULL,'SALT 2','UGC 12133',0.02476,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157280,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157280,35.1,0.06,102,74184,72,NULL,NULL,'UGC 12133',0.02476,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157281,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157281,35.14,0.11,104,74184,65,NULL,'SALT2','UGC 12133',0.02476,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157282,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157282,35.16,0.18,105,74184,73.8,NULL,'SALT 2 (SNANA)','UGC 12133',0.0235,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157283,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157283,35.19,0.28,107,74184,70,NULL,'SALT','UGC 12133',0.02476,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157284,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157284,35.25,0.1,110,74184,70,NULL,NULL,'UGC 12133',0.02476,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157285,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157285,35.35,0.12,112,74184,65,NULL,'MLCS2k2','UGC 12133',0.02476,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157286,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157286,35.31,0.19,112,74184,65,NULL,'MLCS31','UGC 12133',0.02476,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157287,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157287,35.32,0.21,113,74184,65,NULL,'SALT2','UGC 12133',0.02476,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157288,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157288,35.32,0.12,113,74184,65,NULL,'MLCS2k2','UGC 12133',0.02476,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157289,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157289,35.33,0.09,114,74184,65,NULL,'MLCS2k2','UGC 12133',0.02476,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157290,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157290,35.33,0.18,114,74184,65,NULL,'MLCS17','UGC 12133',0.02476,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157291,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157291,35.35,0.29,115,74184,65,NULL,'SALT','UGC 12133',0.02476,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157292,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157292,35.36,0.2,115,74184,65,NULL,NULL,'UGC 12133',0.02476,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157293,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157293,35.45,0.03,120,74184,65,NULL,'SALT','UGC 12133',0.02476,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157294,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157294,35.52,0.14,127,74184,60,NULL,NULL,'UGC 12133',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157295,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157295,34.62,0.49,83.8,74184,75,NULL,'IR','UGC 12133',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157296,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157296,35.03,0.08,101,74184,74.4,NULL,NULL,'UGC 12133',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157297,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157297,35.13,NULL,106,74184,NULL,NULL,'Dipole','UGC 12133',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157298,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157298,35.13,NULL,106,74184,NULL,NULL,'Dipole + Quadrupole','UGC 12133',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157299,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157299,35.14,NULL,106,74184,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12133',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157300,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157300,35.14,0.4,107,74184,75,NULL,'HOSTS SN 1998eg','UGC 12133',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157301,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157301,35.2,0.43,110,74184,75,NULL,'3.6 micron, color corrected','UGC 12133',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157302,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157302,35.25,NULL,112,74184,NULL,NULL,NULL,'UGC 12133',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157303,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157303,35.26,0.34,113,74184,NULL,NULL,'Malmquist cor.','UGC 12133',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157304,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157304,35.27,0.43,113,74184,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12133',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157305,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157305,35.37,0.32,119,74184,NULL,NULL,NULL,'UGC 12133',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157306,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157306,37.71,0.46,349,74185,70,NULL,NULL,'SDSS J223935.91-100850.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000174,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,339.899666667,-10.14731,0.197,NULL,50354370553,786787039,12293547,18),(157307,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157307,34.33,0.54,73.6,74186,70,NULL,NULL,'NGC 7344',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00002,NULL,'14.61',0.8,'(R\')SB(r)ab',NULL,NULL,NULL,NULL,1,339.9010417,-4.15897,0.109,NULL,50345864807,786654137,12291470,14.61),(157308,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157308,34.36,0.36,74.5,74186,NULL,NULL,'Malmquist cor.','NGC 7344',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157309,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157309,34.63,0.32,84.2,74186,NULL,NULL,NULL,'NGC 7344',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157310,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157310,34.76,0.2,89.5,74186,74.4,NULL,NULL,'NGC 7344',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157311,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157311,34.87,0.8,94,74187,75,NULL,'CF, r','UGC 12134',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000027,NULL,'14.15',0.6,'Sbc',NULL,NULL,NULL,NULL,1,339.906083,11.76989,0.113,NULL,52455780651,819621572,12806587,14.15),(157312,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157312,34.88,0.8,94.4,74187,75,NULL,'A82, H','UGC 12134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157313,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157313,34.61,0.38,83.6,74187,75,NULL,'CF, r, raw','UGC 12134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157314,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157314,34.63,0.33,84.3,74187,91,NULL,'H','UGC 12134',NULL,'1984ApJ...278..475B',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157315,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157315,34.76,0.38,89.7,74187,75,NULL,'CF, r, inv','UGC 12134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157316,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157316,34.92,0.38,96.4,74187,75,NULL,'CF, r, cor','UGC 12134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157317,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157317,34.95,0.2,97.7,74187,74.4,NULL,NULL,'UGC 12134',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157318,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157318,34.99,0.47,99.6,74187,75,NULL,'A82, H, raw','UGC 12134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157319,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157319,35.03,0.42,101,74187,NULL,NULL,NULL,'UGC 12134',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157320,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157320,35.09,0.41,104,74187,NULL,NULL,'Malmquist cor.','UGC 12134',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157321,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157321,35.17,0.47,108,74187,75,NULL,'A82, H, inv','UGC 12134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157322,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157322,35.44,0.47,123,74187,75,NULL,'A82, H, cor','UGC 12134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157323,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157323,34.45,NULL,77.6,74188,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2406',NULL,'2010Ap&SS.325..163P',2010,1,1.01,NULL,'G',0.000031,NULL,'16.20',0.1,'Sd',NULL,NULL,NULL,NULL,1,339.907083,33.57972,0.353,NULL,55464982865,866640357,13541255,16.2),(157324,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157324,34.47,NULL,78.3,74188,NULL,NULL,'Dipole + Quadrupole','FGC 2406',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157325,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157325,34.48,NULL,78.6,74188,NULL,NULL,'Dipole','FGC 2406',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157326,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157326,34.5,0.43,79.5,74188,NULL,NULL,NULL,'FGC 2406',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157327,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157327,34.53,NULL,80.5,74188,NULL,NULL,NULL,'FGC 2406',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157328,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157328,34.69,0.2,86.7,74188,74.4,NULL,NULL,'FGC 2406',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157329,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157329,34.69,0.39,86.8,74188,NULL,NULL,'Malmquist cor.','FGC 2406',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157330,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157330,34.85,0.43,93.5,74188,75,NULL,'3.6 micron, color corrected','FGC 2406',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157331,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157331,34.87,0.43,94,74188,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2406',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157332,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157332,37.68,0.33,344,74189,70,NULL,NULL,'2MASX J22393932+1445593',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,339.913791667,14.76656,0.181,NULL,52592668284,821760441,12840006,18.2),(157333,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 02539',NULL,157333,41.49,0.1,1980,74190,70,NULL,'SN photometric redshift distance, z photo =0.650 +/- 0.047','SDSS-II SN 02539',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.5g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,339.9390417,-0.30628,0.185,NULL,49461413420,772834584,12075540,21.5),(157334,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157334,36.64,0.17,213,74191,70,NULL,NULL,'2MASX J22394592-0055597',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,339.941375,-0.93317,0.145,NULL,49462076011,772844937,12075702,16.9),(157335,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157335,36.04,0.54,161,74192,70,NULL,NULL,'ESO 109-IG 010 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.62',0.47,'E2 pec',NULL,NULL,NULL,NULL,1,339.941916667,-66.73336,0,NULL,49285482148,770085658,12032588,15.62),(157336,'GRB','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157336,42.43,0.29,2000,74193,NULL,NULL,'SN 2008hw','SN 2008hw',0.5295,'2010JCAP...08..020W',2010,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ic',NULL,NULL,NULL,NULL,1,339.960333333,-40.14711,0,NULL,50713494441,792398350,12381224,NULL),(157337,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157337,37.91,0.46,382,74194,70,NULL,NULL,'2MASX J22395041+0106367',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000138,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,339.960166667,1.11025,0.197,NULL,51675156436,807424319,12616004,18),(157338,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157338,37.74,0.46,353,74195,70,NULL,NULL,'2MASX J22395361-0830078',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,339.9732917,-8.50208,0.133,NULL,50396624271,787447254,12303863,17.5),(157339,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157339,36.64,0.17,213,74196,70,NULL,NULL,'2MASX J22395499-0059186',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.00015,NULL,'15.9g',0.48,'E0',NULL,NULL,NULL,NULL,1,339.9790417,-0.98861,0.145,NULL,49462077580,772844962,12075702,15.9),(157340,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157340,37.27,0.67,284,74196,70,NULL,NULL,'2MASX J22395499-0059186',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157341,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157341,32.33,0.43,29.2,74197,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7347',NULL,'2014MNRAS.444..527S',2014,1,1.5,NULL,'G',0.000022,NULL,'14.57',0.3,'Sc',NULL,NULL,NULL,NULL,1,339.984041667,11.02756,0.173,NULL,52458141964,819658468,12807163,14.57),(157342,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157342,32.5,0.43,31.6,74197,75,NULL,'3.6 micron, color corrected','NGC 7347',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157343,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157343,32.69,0.2,34.5,74197,74.4,NULL,NULL,'NGC 7347',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157344,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157344,32.73,0.49,35.2,74197,75,NULL,'IR','NGC 7347',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157345,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157345,32.93,0.47,38.5,74197,NULL,NULL,NULL,'NGC 7347',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157346,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157346,32.94,0.47,38.8,74197,NULL,NULL,'Malmquist cor.','NGC 7347',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157347,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 04111','RN',157347,42.64,0.26,2440,74198,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 04111',0.383992,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157348,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 04111','RN',157348,42.98,0.31,2840,74198,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04111',0.383992,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157349,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157349,38.33,0.33,464,74199,70,NULL,NULL,'2MASX J22400335+1234284',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,340.014,12.57444,0.133,NULL,52586935123,821670861,12838607,17.5),(157350,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157350,36.64,0.17,213,74200,70,NULL,NULL,'2MASX J22400525-0048276',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00011,NULL,'15.73',0.36,'BrClG',NULL,NULL,NULL,NULL,1,340.02175,-0.80769,0.169,NULL,49461950590,772842977,12075671,15.73),(157351,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157351,36.82,0.19,231,74201,70,NULL,NULL,'2MASX J22400724-0018386',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000161,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,340.030166667,-0.31064,0.189,NULL,49461539338,772836552,12075571,16.7),(157352,'HII LF','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157352,47.73,0.25,5760,74202,71,NULL,NULL,'DSF 2237+116a C002',3.331,'2005MNRAS.356.1117S',2005,1,NULL,NULL,'G',0.001,NULL,'23.55',NULL,'Lyman-break gal.',NULL,NULL,NULL,NULL,1,340.0345417,11.818,0.125,NULL,52455560256,819618129,12806533,23.55),(157353,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 15934',NULL,157353,39.89,0.27,950,74203,70,NULL,'SN photometric redshift distance, z photo =0.253 +/- 0.040','SDSS-II SN 15934',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.9g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,340.035875,0.212,0.189,NULL,51675129298,807423895,12615998,21.9),(157354,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157354,37.85,0.46,372,74204,70,NULL,NULL,'SDSS J224009.03+124729.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,340.037667,12.7915,0.145,NULL,52586806164,821668846,12838575,18.6),(157355,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157355,37.68,0.33,344,74205,70,NULL,NULL,'SDSS J224010.12+144043.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000125,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,340.042166667,14.67869,0.173,NULL,52592885745,821763839,12840059,18.3),(157356,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157356,36.82,0.19,231,74206,70,NULL,NULL,'2MASX J22401030-0007465',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000167,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,340.0429583,-0.12956,0.189,NULL,49461568820,772837012,12075578,17.7),(157357,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 01992','RN',157357,42.93,0.5,2800,74207,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01992',0.37745,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157358,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 01992','RN',157358,43.57,0.49,3750,74207,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01992',0.37745,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157359,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157359,38.33,0.33,464,74208,70,NULL,NULL,'2MASX J22401382+1229146',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000171,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,340.0574583,12.48728,0.117,NULL,52586471477,821663616,12838494,18.2),(157360,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157360,36.03,NULL,161,74209,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2407',NULL,'2010Ap&SS.325..163P',2010,1,0.78,NULL,'G',0.00001,NULL,'16.5',0.11,'Sb',NULL,NULL,NULL,NULL,1,340.062416667,19.02586,0.293,NULL,52399083623,818735681,12792745,16.5),(157361,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157361,36.04,NULL,162,74209,NULL,NULL,'Dipole + Quadrupole','FGC 2407',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157362,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157362,36.06,NULL,163,74209,NULL,NULL,NULL,'FGC 2407',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157363,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157363,36.08,NULL,164,74209,NULL,NULL,'Dipole','FGC 2407',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157364,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157364,32.32,0.43,29.1,74210,75,NULL,'3.6 micron, color + selection bias corrected','II Zw 183',NULL,'2014MNRAS.444..527S',2014,1,2.2,NULL,'G',0.000017,NULL,'14.25',1.3,'SB(s)bc pec',NULL,NULL,NULL,NULL,1,340.063041667,-2.42406,0.165,NULL,49460517618,772820587,12075321,14.25),(157365,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157365,32.4,0.43,30.2,74210,75,NULL,'3.6 micron, color corrected','II Zw 183',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157366,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157366,32.41,0.69,30.3,74210,100,NULL,'mid-IR','II Zw 183',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157367,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157367,32.44,0.2,30.8,74210,74.4,NULL,NULL,'II Zw 183',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157368,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157368,32.51,0.58,31.8,74210,NULL,NULL,NULL,'II Zw 183',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157369,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157369,32.62,0.55,33.5,74210,NULL,NULL,'Malmquist cor.','II Zw 183',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157370,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157370,33.1,0.4,41.7,74210,NULL,NULL,'mean','II Zw 183',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157371,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157371,33.15,0.47,42.7,74210,NULL,NULL,'H','II Zw 183',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157372,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157372,33.23,0.46,44.3,74210,NULL,NULL,'J','II Zw 183',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157373,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157373,33.28,0.45,45.3,74210,NULL,NULL,'K','II Zw 183',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157374,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 14438',NULL,157374,39.81,0.25,917,74211,70,NULL,'SN photometric redshift distance, z photo =0.243 +/- 0.034','SDSS-II SN 14438',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,340.065166667,-1.06933,0.145,NULL,49462071380,772844865,12075701,NULL),(157375,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 14438','R',157375,41.03,0.22,1240,74211,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14438',0.297526,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157376,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 14438','R',157376,41.07,0.14,1260,74211,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14438',0.297526,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157377,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 14438',NULL,157377,40.99,0.11,1580,74211,70,NULL,'SALT 2','SDSS-II SN 14438',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157378,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 14438',NULL,157378,41.02,0.11,1600,74211,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14438',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157379,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 11675','RN',157379,40.04,0.31,941,74212,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 11675',0.084408,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157380,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157380,36.86,0.33,235,74213,70,NULL,NULL,'2MASXi J2240163-002855',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,340.068125,-0.48203,0.189,NULL,49461500257,772835941,12075561,18),(157381,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157381,34.49,0.49,79.1,74214,75,NULL,'IR','UGC 12139',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000127,NULL,'15.46',0.2,'SB?',NULL,NULL,NULL,NULL,1,340.071875,8.56592,0.261,NULL,52477641459,819963147,12811924,15.46),(157382,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157382,36.82,0.19,231,74215,70,NULL,NULL,'SDSS J224018.33-002106.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000178,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,340.076417,-0.35192,0.189,NULL,49461531181,772836424,12075569,18),(157383,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157383,36.86,0.33,235,74216,70,NULL,NULL,'2MASX J22401926-0029375',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,340.080333333,-0.49381,0.189,NULL,49461501295,772835957,12075561,17),(157384,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157384,37.29,0.46,287,74217,70,NULL,NULL,'SDSS J224019.40-001407.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00013,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,340.080875,-0.23536,0.189,NULL,49461589264,772837332,12075583,17.9),(157385,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157385,35.72,0.58,139,74218,70,NULL,NULL,'2MASX J22402377-4631400',NULL,'2014MNRAS.445.2677S',2014,1,0.21,NULL,'G',0.00015,NULL,'15.6R',0.13,NULL,NULL,NULL,NULL,NULL,1,340.099167,-46.52778,0,NULL,50690827162,792044174,12375690,15.6),(157386,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006bh',NULL,157386,33.25,0.07,44.2,74219,72,NULL,NULL,'NGC 7329',0.010847,'2010AJ....139..120F',2010,1,3.9,'The APMUKS position is northeast of the nucleus.','G',0.000013,NULL,'12.1',2.6,'SB(r)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,340.100916667,-66.47897,0,NULL,49286694697,770104604,12032884,12.1),(157387,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006bh',NULL,157387,33.3,0.22,44.8,74219,72,NULL,NULL,'NGC 7329',0.0105,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157388,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006bh',NULL,157388,33.26,0.09,44.9,74219,74.4,NULL,NULL,'NGC 7329',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157389,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006bh',NULL,157389,33.27,0.01,45.1,74219,72,NULL,NULL,'NGC 7329',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157390,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006bh',NULL,157390,33.33,0.24,45.8,74219,72,NULL,NULL,'NGC 7329',0.010847,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157391,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006bh',NULL,157391,33.38,0.25,46.9,74219,70,NULL,'SALT 2','NGC 7329',0.010847,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157392,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006bh',NULL,157392,33.38,0.06,47.3,74219,72,NULL,'M(H) = -18.317 mag','NGC 7329',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157393,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006bh',NULL,157393,33.43,0.21,48,74219,73.8,NULL,'SALT 2 (SNANA)','NGC 7329',0.0111,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157394,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006bh',NULL,157394,33.68,0.02,53.7,74219,70,NULL,NULL,'NGC 7329',0.010847,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157395,'Ring Diameter','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157395,31.6,0.84,21,74219,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7329',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157396,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157396,33.11,0.8,41.8,74219,75,NULL,'MAT, I','NGC 7329',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157397,'Sosies','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157397,33.02,0.22,40.2,74219,NULL,NULL,NULL,'NGC 7329',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157398,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157398,33.06,0.43,40.8,74219,75,NULL,'MAT, I, raw','NGC 7329',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157399,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157399,33.07,0.32,41.2,74219,85,NULL,'I, raw','NGC 7329',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157400,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157400,33.14,0.4,42.5,74219,NULL,NULL,'mean','NGC 7329',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157401,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157401,33.15,0.32,42.6,74219,85,NULL,'I, inv','NGC 7329',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157402,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157402,33.17,0.43,43.1,74219,75,NULL,'MAT, I, cor','NGC 7329',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157403,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157403,33.21,0.47,43.8,74219,NULL,NULL,'H','NGC 7329',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157404,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157404,33.22,0.45,44.1,74219,NULL,NULL,'K','NGC 7329',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157405,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157405,33.23,0.42,44.3,74219,NULL,18.48,'3.6 micron','NGC 7329',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157406,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157406,33.24,0.46,44.6,74219,NULL,NULL,'J','NGC 7329',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157407,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157407,33.26,0.09,44.9,74219,74.4,NULL,NULL,'NGC 7329',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157408,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157408,33.26,0.4,44.9,74219,75,NULL,'HOSTS SN 2006bh','NGC 7329',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157409,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157409,33.35,0.43,46.9,74219,75,NULL,'MAT, I, inv','NGC 7329',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157410,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157410,33.41,0.43,48,74219,75,NULL,'3.6 micron, color corrected','NGC 7329',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157411,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157411,33.41,0.43,48.2,74219,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7329',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157412,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157412,35.11,0.8,105,74220,75,NULL,'W91PP, r','UGC 12143',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.94',0.6,'Sab',NULL,NULL,NULL,NULL,1,340.1067917,31.84164,0.365,NULL,55460870581,866576102,13540251,14.94),(157413,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157413,34.81,0.38,91.7,74220,75,NULL,'W91PP, r, raw','UGC 12143',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157414,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157414,34.82,0.33,92.2,74220,NULL,NULL,NULL,'UGC 12143',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157415,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157415,34.82,0.33,92.2,74220,NULL,NULL,'Malmquist cor.','UGC 12143',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157416,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157416,34.91,0.38,96,74220,75,NULL,'W91PP, r, cor','UGC 12143',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157417,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157417,34.99,0.38,99.4,74220,75,NULL,'W91PP, r, inv','UGC 12143',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157418,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157418,35.09,0.2,104,74220,74.4,NULL,NULL,'UGC 12143',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157419,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157419,38.71,0.46,553,74221,70,NULL,NULL,'2MASX J22402713-0051575',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,340.113,-0.86589,0.169,NULL,49461972419,772843319,12075676,18.1),(157420,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157420,36.82,0.19,231,74222,70,NULL,NULL,'2MASX J22402811-0014575',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.00015,NULL,'15.6g',0.46,'E0',NULL,NULL,NULL,NULL,1,340.117,-0.24939,0.189,NULL,49461577823,772837153,12075580,15.6),(157421,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 00708','RN',157421,40.12,0.17,871,74223,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00708',0.21436,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157422,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157422,35.11,0.4,105,74224,NULL,NULL,'mean','UGC 12140',NULL,'2007A&A...465...71T',2007,1,1,'UGC Dec (+15 41) is incorrect.','G',0.000017,NULL,'15.08',0.4,'Sa','Isolated galaxy',NULL,NULL,NULL,1,340.119167,16.01078,0.201,NULL,52592352581,821755509,12839929,15.08),(157423,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157423,35.35,0.47,118,74224,NULL,NULL,'H','UGC 12140',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157424,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 05801','RN',157424,38.48,0.19,440,74225,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05801',0.127005,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157425,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157425,37.57,0.46,326,74226,70,NULL,NULL,'2MASX J22402912+1437496',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000156,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,340.1214583,14.63053,0.173,NULL,52592890026,821763906,12840061,17.4),(157426,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 14339','RN',157426,42.47,0.24,1980,74227,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 14339',0.57678,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157427,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 01113','RN',157427,38.51,0.06,476,74228,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01113',0.056915,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157428,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 01113','RN',157428,38.94,0.19,582,74228,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01113',0.056915,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157429,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157429,33.14,0.67,42.4,74229,NULL,NULL,NULL,'UGC 12144',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.04',0.8,'SB(s)b',NULL,NULL,NULL,NULL,1,340.1402917,33.46644,0.353,NULL,55463082858,866610669,13540791,15.04),(157430,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157430,33.41,0.59,48.1,74229,NULL,NULL,'Malmquist cor.','UGC 12144',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157431,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157431,36.64,0.17,213,74230,70,NULL,NULL,'2MASX J22403493-0044004',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00015,NULL,'16.2g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,340.145625,-0.73342,0.169,NULL,49461927393,772842615,12075665,16.2),(157432,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157432,31.9,0.49,24,74231,75,NULL,'IR','UGC 12154',NULL,'2011yCatp016004901K',2011,1,1.57,'UGC declination is 1 degree in error.','G',0.000067,NULL,'16.0',0.21,'Sb',NULL,NULL,NULL,NULL,1,340.1494583,72.86389,2.897,NULL,52802716793,825042449,12891288,16),(157433,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157433,34.64,0.2,84.7,74232,74.4,NULL,NULL,'NGC 7348',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.00021,NULL,'14.53',0.7,'Scd:',NULL,NULL,NULL,NULL,1,340.151167,11.90622,0.121,NULL,52455542821,819617856,12806529,14.53),(157434,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157434,34.8,0.59,91.3,74232,NULL,NULL,NULL,'NGC 7348',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157435,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157435,34.89,0.56,94.9,74232,NULL,NULL,'Malmquist cor.','NGC 7348',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157436,'TRGB','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157436,26.85,0.07,2.23,74233,NULL,NULL,NULL,'ESO 468- G 020',NULL,'2014MNRAS.443.1281K',2014,1,2.1,NULL,'G',NULL,NULL,'17.3B',1.3,'E3: pec',NULL,NULL,NULL,NULL,1,340.1830417,-30.80006,0,0,50088889669,782638901,12228732,17.3),(157437,'TRGB','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157437,26.75,0.1,2.24,74233,74.4,NULL,NULL,'ESO 468- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157438,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157438,35.55,0.49,129,74234,75,NULL,'IR','UGC 12145',NULL,'2011yCatp016004901K',2011,1,1,'Springob et al. (2005ApJS..160..149S) give v= 6498 km/sec.','G',0.000033,NULL,'16.0',0.3,'S?',NULL,NULL,NULL,NULL,1,340.19425,33.36658,0.353,NULL,55463100931,866610952,13540796,16),(157439,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157439,36.82,0.19,231,74235,70,NULL,NULL,'2MASX J22405105-0028282',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000186,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,340.212833333,-0.47467,0.201,NULL,49461520322,772836255,12075566,17.2),(157440,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157440,31.95,0.43,24.5,74236,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12160',NULL,'2014MNRAS.444..527S',2014,1,2.1,NULL,'G',0.00001,NULL,'15.5',1.7,'Scd:',NULL,NULL,NULL,NULL,1,340.2244583,75.16431,1.773,NULL,52799376381,824990255,12890472,15.5),(157441,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157441,32.05,0.2,25.7,74236,74.4,NULL,NULL,'UGC 12160',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157442,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157442,32.11,0.43,26.4,74236,75,NULL,'3.6 micron, color corrected','UGC 12160',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157443,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157443,32.81,0.8,36.5,74237,75,NULL,'MAT, I','ESO 289- G 048',NULL,'1997ApJS..109..333W',1997,1,1.81,NULL,'G',0.000022,NULL,'14.48',0.32,'SB(s)cd: sp',NULL,NULL,NULL,NULL,1,340.2370417,-45.66025,0,NULL,50692188014,792065437,12376022,14.48),(157444,'Tully est','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157444,32.73,0.8,35.2,74237,75,NULL,NULL,'ESO 289- G 048',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157445,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157445,32.29,0.32,28.7,74237,85,NULL,'I, inv','ESO 289- G 048',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157446,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157446,32.3,0.32,28.9,74237,85,NULL,'I, raw','ESO 289- G 048',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157447,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157447,32.49,0.4,31.5,74237,NULL,NULL,NULL,'ESO 289- G 048',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157448,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157448,32.49,0.4,31.5,74237,73,NULL,'opt','ESO 289- G 048',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157449,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157449,32.62,0.43,33.5,74237,75,NULL,'MAT, I, raw','ESO 289- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157450,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157450,32.63,0.43,33.5,74237,75,NULL,'MAT, I, inv','ESO 289- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157451,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157451,32.76,0.43,35.7,74237,75,NULL,'MAT, I, cor','ESO 289- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157452,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157452,35.86,0.8,148,74238,75,NULL,'W91PP, r','UGC 12146',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',NULL,NULL,'15.58',0.3,'Sbc',NULL,NULL,NULL,NULL,1,340.2385417,22.47633,0.137,NULL,52401806125,818778220,12793409,15.58),(157453,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157453,35.3,0.38,115,74238,75,NULL,'W91PP, r, raw','UGC 12146',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157454,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157454,35.44,0.38,123,74238,75,NULL,'W91PP, r, inv','UGC 12146',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157455,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157455,35.54,0.38,128,74238,75,NULL,'W91PP, r, cor','UGC 12146',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157456,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157456,35.6,0.49,132,74238,75,NULL,'IR','UGC 12146',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157457,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157457,36.99,0.46,250,74239,70,NULL,NULL,'2MASX J22405827-0049542',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00015,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,340.2427083,-0.83175,0.169,NULL,49461931144,772842674,12075666,16.5),(157458,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157458,35.3,0.51,115,74240,70,NULL,NULL,'2MASX J22405940-1247369',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'15.81',0.42,NULL,NULL,NULL,NULL,NULL,1,340.247417,-12.79375,0.217,NULL,50427214647,787925228,12311331,15.81),(157459,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157459,35.53,0.49,127,74241,75,NULL,'IR','FGC 2408',NULL,'2011yCatp016004901K',2011,1,0.96,NULL,'G',0.000016,NULL,'16.5',0.08,'Sd',NULL,NULL,NULL,NULL,1,340.2599583,19.33669,0.249,NULL,52399176968,818737140,12792767,16.5),(157460,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157460,35.77,NULL,143,74241,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2408',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157461,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157461,35.79,NULL,144,74241,NULL,NULL,'Dipole + Quadrupole','FGC 2408',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157462,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157462,35.81,NULL,146,74241,NULL,NULL,'Dipole','FGC 2408',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157463,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157463,35.9,NULL,152,74241,NULL,NULL,NULL,'FGC 2408',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157464,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 21487','RN',157464,39.65,0.19,716,74242,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21487',0.189116,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157465,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 21487','RN',157465,39.72,0.12,741,74242,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 21487',0.189116,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157466,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 21487','N',157466,39.42,0.08,766,74242,70,NULL,'SALT 2','SDSS-II SN 21487',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157467,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 21487','N',157467,39.43,0.08,769,74242,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 21487',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157468,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 15628','RN',157468,42.49,0.36,2170,74243,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15628',0.448918,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157469,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 15628','RN',157469,42.56,0.37,2250,74243,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15628',0.448918,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157470,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 15628','N',157470,42.47,0.25,3120,74243,70,NULL,'SALT 2','SDSS-II SN 15628',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157471,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 15628','N',157471,42.56,0.25,3250,74243,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15628',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157472,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157472,38.06,0.46,409,74244,70,NULL,NULL,'SDSS J224108.93+135521.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,340.28725,13.92258,0.117,NULL,52593149404,821767959,12840124,18.4),(157473,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157473,37.81,0.46,364,74245,70,NULL,NULL,'2MASX J22410960-0757445',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000201,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,340.29,-7.96242,0.117,NULL,50398611430,787478303,12304348,16.7),(157474,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157474,37.93,0.46,385,74246,70,NULL,NULL,'2MASX J22410993-0857575',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,340.291417,-8.966,0.141,NULL,50384704602,787261009,12300953,18.1),(157475,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157475,34.25,0.2,70.8,74247,74.4,NULL,NULL,'KUG 2238+130',NULL,'2013AJ....146...86T',2013,1,0.85,NULL,'G',0.000093,NULL,'15.4g',0.3,'Sa','Isolated galaxy',NULL,NULL,NULL,1,340.294375,13.33989,0.117,NULL,52587198557,821674977,12838671,15.4),(157476,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157476,34.25,0.38,70.9,74247,NULL,NULL,'Malmquist cor.','KUG 2238+130',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157477,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157477,34.31,0.37,72.8,74247,NULL,NULL,NULL,'KUG 2238+130',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157478,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157478,33.32,0.2,46.1,74248,74.4,NULL,NULL,'NGC 7349',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'14.92',0.5,'SBb pec?','Field galaxy',NULL,NULL,NULL,1,340.312083,-21.7985,0.045,NULL,50258066949,785282296,12270035,14.92),(157479,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157479,33.63,0.56,53.3,74248,NULL,NULL,NULL,'NGC 7349',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157480,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157480,33.64,0.56,53.4,74248,NULL,NULL,'Malmquist cor.','NGC 7349',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157481,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157481,33.99,0.49,62.7,74248,75,NULL,'IR','NGC 7349',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157482,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157482,38.29,0.46,454,74249,70,NULL,NULL,'2MASX J22411587-0912410',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000191,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,340.316083333,-9.21128,0.149,NULL,50384686584,787260727,12300948,17.8),(157483,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157483,37.27,0.46,284,74250,70,NULL,NULL,'2MASX J22411875+1444443',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,340.32825,14.74564,0.161,NULL,52592813412,821762709,12840042,17),(157484,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157484,36.82,0.19,231,74251,70,NULL,NULL,'2MASX J22412021-0031570',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,340.3342917,-0.53258,0.201,NULL,49472968405,773015131,12078361,16.9),(157485,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157485,38,0.23,399,74252,70,NULL,NULL,'2MASX J22412310+1233063',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,340.346333,12.55175,0.109,NULL,52587590535,821681102,12838767,18.1),(157486,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157486,37.35,0.46,295,74253,70,NULL,NULL,'2MASX J22412451-0819450',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,340.35225,-8.32914,0.121,NULL,50397867275,787466676,12304166,17),(157487,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157487,38.1,0.46,416,74254,70,NULL,NULL,'SDSS J224124.91-101013.9',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000175,NULL,'18.9g',0.1,NULL,NULL,NULL,NULL,NULL,1,340.353833,-10.17053,0.193,NULL,50354220585,786784696,12293510,18.9),(157488,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157488,35.33,0.7,116,74255,70,NULL,NULL,'IC 5236',NULL,'2014MNRAS.445.2677S',2014,1,0.71,NULL,'G',0.00015,NULL,'15.46',0.48,'S0^0',NULL,NULL,NULL,NULL,1,340.375583,-66.618,0,NULL,49286488293,770101379,12032834,15.46),(157489,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157489,38,0.23,399,74256,70,NULL,NULL,'2MASX J22413074+1238193',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000179,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,340.3782083,12.63878,0.109,NULL,52587537051,821680266,12838754,17.7),(157490,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157490,38,0.23,399,74257,70,NULL,NULL,'2MASX J22413184+1234503',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000185,NULL,'16.4g',0.36,'BrClG',NULL,NULL,NULL,NULL,1,340.38275,12.58058,0.109,NULL,52587582743,821680980,12838765,16.4),(157491,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157491,38,0.23,399,74258,70,NULL,NULL,'2MASX J22413361+1236423',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,340.390125,12.61161,0.109,NULL,52587585269,821681019,12838765,17.5),(157492,'Tully est','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157492,31.89,0.8,23.8,74259,75,NULL,NULL,'UGC 12151',NULL,'1988NBGC.C....0000T',1988,1,2.9,NULL,'G',0.000015,NULL,'14',2.2,'IB(s)m:',NULL,NULL,NULL,NULL,1,340.391125,0.40083,0.193,NULL,51688733400,807636459,12619319,14),(157493,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157493,34.34,NULL,73.8,74260,NULL,NULL,'B','ESO 147- G 005',NULL,'2004ApJ...607..241R',2004,1,1.5,NULL,'G',0.000033,NULL,'13.96',1,'SAB(rs)bc',NULL,NULL,NULL,NULL,1,340.402875,-57.60586,0,NULL,48846653119,763228954,11925452,13.96),(157494,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157494,34.56,NULL,81.7,74260,NULL,NULL,'I','ESO 147- G 005',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157495,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157495,34.65,NULL,85.1,74260,NULL,NULL,'B','ESO 147- G 005',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157496,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157496,34.65,NULL,85.1,74260,NULL,NULL,'B, Hubble-type-TF','ESO 147- G 005',NULL,'2005Ap&SS.299..405R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157497,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157497,34.65,0.91,85.1,74260,NULL,NULL,'B, Hubble-type-TF','ESO 147- G 005',NULL,'2005Ap&SS.299..387R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157498,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157498,34.65,NULL,85.1,74260,NULL,NULL,'B','ESO 147- G 005',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157499,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157499,34.65,NULL,85.1,74260,NULL,NULL,'B, Hubble-type-TF','ESO 147- G 005',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157500,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157500,34.65,0.91,85.1,74260,NULL,NULL,'B, Hubble-type-TF','ESO 147- G 005',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157501,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157501,34.65,NULL,85.1,74260,NULL,NULL,'I','ESO 147- G 005',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157502,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157502,36.28,0.46,180,74261,70,NULL,NULL,'2MASX J22413910+0112307',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,340.413083,1.20853,0.201,NULL,51689270783,807644855,12619450,17.5),(157503,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157503,37.87,0.33,375,74262,70,NULL,NULL,'2MASX J22414057-0049426',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,340.4192083,-0.82858,0.189,NULL,49473789060,773027954,12078561,17.3),(157504,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006py',NULL,157504,36.94,0.07,219,74263,72,NULL,NULL,'SDSS J224142.04-000812.9',0.05668,'2013ApJ...773...53F',2013,1,0.18,NULL,'G',0.000177,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,340.4252083,-0.13694,0.173,NULL,49472876141,773013689,12078338,18.5),(157505,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006py',NULL,157505,36.84,0.14,220,74263,72,NULL,NULL,'SDSS J224142.04-000812.9',0.0579,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157506,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006py','R',157506,36.73,0.11,222,74263,NULL,NULL,'MLCS2k2, R(V) = 3.1','SDSS J224142.04-000812.9',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157507,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006py',NULL,157507,36.88,0.02,225,74263,72,NULL,NULL,'SDSS J224142.04-000812.9',0.0579,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157508,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006py',NULL,157508,36.79,0.03,228,74263,72,NULL,NULL,'SDSS J224142.04-000812.9',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157509,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006py',NULL,157509,36.94,0.15,231,74263,70,NULL,'SALT 2','SDSS J224142.04-000812.9',0.0579,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157510,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006py','R',157510,36.83,0.1,232,74263,NULL,NULL,'MLCS2k2, R(V) = 1.8','SDSS J224142.04-000812.9',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157511,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006py',NULL,157511,36.98,0.13,235,74263,73.8,NULL,'SALT 2 (SNANA)','SDSS J224142.04-000812.9',0.0568,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157512,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157512,35.76,0.76,142,74264,70,NULL,NULL,'ESO 147- G 005 NOTES01',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00005,NULL,'16.79',0.18,NULL,NULL,NULL,NULL,NULL,1,340.43975,-57.60094,0,NULL,48846652930,763228952,11925452,16.79),(157513,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157513,37.87,0.33,375,74265,70,NULL,NULL,'2MASX J22414831-0047486',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,340.4512083,-0.79675,0.189,NULL,49473836210,773028690,12078573,17.4),(157514,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157514,37.6,0.46,331,74266,70,NULL,NULL,'SDSS J224148.39+130746.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000151,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,340.451667,13.12953,0.117,NULL,52587343947,821677249,12838707,18.6),(157515,'CMD','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157515,24.72,0.2,0.879,74267,NULL,NULL,'CMD','Tucana Dwarf',NULL,'1996A&A...310..715C',1996,1,2.9,'V= -135 km/sec probably caused by Local HI. See (2002A&A...389..812K)','G',0.000014,NULL,'15.7',1.2,'dE4',NULL,NULL,NULL,NULL,1,340.456667,-64.41944,0,0,48761051299,761891426,11904553,15.7),(157516,'CMD','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157516,24.73,NULL,0.883,74267,NULL,NULL,NULL,'Tucana Dwarf',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157517,'CMD','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157517,24.75,NULL,0.9,74267,NULL,NULL,NULL,'Tucana Dwarf',NULL,'1992AJ....103...81L',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157518,'CMD','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157518,24.8,0.2,0.91,74267,NULL,NULL,NULL,'Tucana Dwarf',NULL,'1994ESOC...49..221D',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157519,'CMD','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157519,24.85,0.1,0.933,74267,NULL,NULL,NULL,'Tucana Dwarf',NULL,'1996ASPC...98..433L',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157520,'Horizontal Branch','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157520,24.66,0.13,0.855,74267,NULL,NULL,NULL,'Tucana Dwarf',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157521,'RR Lyrae','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157521,24.66,0.09,0.855,74267,NULL,NULL,'V','Tucana Dwarf',NULL,'2013MNRAS.435.3206D',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157522,'RR Lyrae','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157522,24.7,0.1,0.871,74267,NULL,NULL,NULL,'Tucana Dwarf',NULL,'1996AAS...188.0903L',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157523,'RR Lyrae','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157523,24.74,0.12,0.89,74267,NULL,NULL,NULL,'Tucana Dwarf',NULL,'2009ApJ...699.1742B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157524,'TRGB','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157524,24.69,0.16,0.87,74267,NULL,NULL,'I','Tucana Dwarf',NULL,'1996A&A...315...40S',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157525,'TRGB','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157525,24.72,NULL,0.88,74267,NULL,NULL,NULL,'Tucana Dwarf',NULL,'1996AJ....112.1969O',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157526,'TRGB','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157526,24.76,0.06,0.9,74267,74.4,NULL,NULL,'Tucana Dwarf',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157527,'TRGB','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157527,24.81,0.04,0.916,74267,NULL,NULL,'I','Tucana Dwarf',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157528,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 18251','RN',157528,41.2,0.26,1460,74268,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18251',0.19134,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157529,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 18251','RN',157529,41.91,0.27,2020,74268,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18251',0.19134,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157530,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157530,37.81,0.33,365,74269,70,NULL,NULL,'SDSS J224151.18-082619.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000136,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,340.463291667,-8.43875,0.129,NULL,50397857454,787466522,12304164,18.1),(157531,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157531,37.81,0.33,365,74270,70,NULL,NULL,'2MASX J22415184-0828476',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,340.465958333,-8.47992,0.137,NULL,50397856644,787466510,12304164,18),(157532,'Ring Diameter','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157532,31.4,0.84,19,74271,NULL,NULL,'Published at H = 100 km/s/Mpc','IC 5240',NULL,'1981ApJS...45..541P',1981,1,2.8,NULL,'G',0.000024,NULL,'12.78',1.9,'SB(r)ab',NULL,NULL,NULL,NULL,1,340.46825,-44.76717,0,NULL,50691878229,792060597,12375946,12.78),(157533,'Tully est','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157533,31.65,0.8,21.4,74271,75,NULL,'B','IC 5240',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157534,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157534,31.98,0.4,24.9,74271,NULL,NULL,'mean','IC 5240',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157535,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157535,32.1,0.45,26.3,74271,NULL,NULL,'K','IC 5240',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157536,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157536,32.16,0.47,27,74271,NULL,NULL,'H','IC 5240',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157537,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157537,32.17,0.46,27.2,74271,NULL,NULL,'J','IC 5240',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157538,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157538,38.27,0.46,452,74272,70,NULL,NULL,'2MASX J22415324-0050496',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000162,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,340.471875,-0.847,0.181,NULL,49473841861,773028779,12078574,18.2),(157539,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157539,34.2,0.46,69.2,74273,NULL,NULL,'J','UGC 12157',NULL,'2007A&A...465...71T',2007,1,1.58,NULL,'G',0.000093,NULL,'15.5',0.33,'Irregular',NULL,NULL,NULL,NULL,1,340.473833,34.91978,0.277,NULL,55464061900,866625967,13541030,15.5),(157540,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157540,34.28,0.47,71.8,74273,NULL,NULL,'H','UGC 12157',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157541,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157541,34.4,0.45,75.9,74273,NULL,NULL,'K','UGC 12157',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157542,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157542,34.78,0.4,90.2,74273,NULL,NULL,'mean','UGC 12157',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157543,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157543,36.33,0.56,185,74274,70,NULL,NULL,'2MASX J22415433-5709082',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.000103,NULL,'15.88',0.52,'S0',NULL,NULL,NULL,NULL,1,340.4765,-57.15231,0,NULL,48846122692,763220667,11925322,15.88),(157544,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 00799','RN',157544,41.42,0.24,1670,74275,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 00799',0.147804,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157545,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 00799','RN',157545,41.9,0.31,2090,74275,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 00799',0.147804,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157546,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157546,34.93,0.8,96.9,74276,75,NULL,'W91PP, r','NGC 7356',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'14.85',0.5,'Sbc',NULL,NULL,NULL,NULL,1,340.5097917,30.70881,0.285,NULL,51916411143,811193924,12674905,14.85),(157547,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157547,34.94,0.8,97.4,74276,75,NULL,'CF, r','NGC 7356',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157548,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157548,35.06,0.38,103,74276,75,NULL,'W91PP, r, raw','NGC 7356',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157549,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157549,35.09,0.4,104,74276,NULL,NULL,'mean','NGC 7356',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157550,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157550,35.12,0.38,105,74276,75,NULL,'W91PP, r, cor','NGC 7356',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157551,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157551,35.31,0.47,115,74276,NULL,NULL,'H','NGC 7356',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157552,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157552,35.33,0.39,116,74276,NULL,NULL,'Malmquist cor.','NGC 7356',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157553,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157553,35.33,0.38,117,74276,75,NULL,'W91PP, r, inv','NGC 7356',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157554,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157554,35.34,0.46,117,74276,NULL,NULL,'J','NGC 7356',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157555,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157555,35.47,0.45,124,74276,NULL,NULL,'K','NGC 7356',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157556,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157556,35.63,0.38,134,74276,75,NULL,'CF, r, raw','NGC 7356',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157557,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157557,35.72,0.2,139,74276,74.4,NULL,NULL,'NGC 7356',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157558,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157558,35.74,0.33,141,74276,NULL,NULL,NULL,'NGC 7356',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157559,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157559,35.82,0.38,146,74276,75,NULL,'CF, r, cor','NGC 7356',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157560,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157560,35.9,0.38,151,74276,75,NULL,'CF, r, inv','NGC 7356',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157561,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157561,34.29,0.4,72.2,74277,NULL,NULL,'mean','MCG -01-57-023',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000047,NULL,'15.08',0.8,'(R)SB(r)a?',NULL,NULL,NULL,NULL,1,340.5222083,-2.78297,0.109,NULL,49474148381,773033568,12078649,15.08),(157562,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157562,34.48,0.47,78.7,74277,NULL,NULL,'H','MCG -01-57-023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157563,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157563,34.56,0.45,81.6,74277,NULL,NULL,'K','MCG -01-57-023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157564,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157564,34.63,0.46,84.3,74277,NULL,NULL,'J','MCG -01-57-023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157565,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157565,37.52,0.33,319,74278,70,NULL,NULL,'2MASX J22420637-0753536',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.00015,NULL,'16.0g',0.39,'E0',NULL,NULL,NULL,NULL,1,340.5264583,-7.89825,0.105,NULL,50398716656,787479947,12304374,16),(157566,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157566,37.42,0.33,304,74279,70,NULL,NULL,'2MASX J22420935+0052441',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000168,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,340.538875,0.879,0.197,NULL,51689408411,807647006,12619484,17.9),(157567,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2004ef',NULL,157567,34.78,0.21,87.6,74280,74.2,NULL,'SALT 2','UGC 12158',0.030985,'2010ApJ...716..712A',2010,1,1.2,NULL,'G',0.000017,NULL,'14.75',1.1,'Sb',NULL,NULL,NULL,NULL,1,340.5437917,19.99697,0.193,NULL,52396936834,818702138,12792220,14.75),(157568,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2004ef',NULL,157568,35.48,0.12,118,74280,72,NULL,NULL,'UGC 12158',0.02979,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157569,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2004ef',NULL,157569,35.37,0.01,119,74280,72,NULL,NULL,'UGC 12158',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157570,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2004ef',NULL,157570,35.38,0.09,119,74280,74.4,NULL,NULL,'UGC 12158',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157571,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2004ef',NULL,157571,35.46,0.15,120,74280,70,NULL,'SALT 2','UGC 12158',0.030985,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157572,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2004ef',NULL,157572,35.46,0.03,120,74280,72,NULL,NULL,'UGC 12158',0.030985,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157573,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2004ef',NULL,157573,35.49,0.25,122,74280,73.8,NULL,'SALT 2 (SNANA)','UGC 12158',0.0298,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157574,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2004ef',NULL,157574,35.5,0.14,122,74280,72,NULL,NULL,'UGC 12158',0.030985,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157575,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2004ef',NULL,157575,35.53,0.19,124,74280,73.8,NULL,'SALT 2 (SNANA)','UGC 12158',0.0298,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157576,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2004ef',NULL,157576,35.53,0.13,127,74280,72,NULL,'M(H) = -18.317 mag','UGC 12158',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157577,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2004ef','R',157577,35.52,0.05,127,74280,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 12158',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157578,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2004ef','R',157578,35.55,0.05,129,74280,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 12158',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157579,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157579,36.17,0.46,171,74281,70,NULL,NULL,'2MASX J22421075+0041271',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'16.28',0.21,NULL,NULL,NULL,NULL,NULL,1,340.54475,0.69092,0.201,NULL,51688670615,807635478,12619304,16.28),(157580,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157580,38.15,0.46,427,74282,70,NULL,NULL,'2MASX J22421095+1301185',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,340.545583,13.02194,0.117,NULL,52588086197,821688846,12838888,17.9),(157581,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157581,35.51,0.49,127,74283,70,NULL,NULL,'ESO 076- G 021',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00011,NULL,'15.08',0.5,'(R\')SA(s)0/a',NULL,NULL,NULL,NULL,1,340.55225,-67.7855,0,NULL,49320029787,770625465,12041022,15.08),(157582,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157582,37.67,0.33,343,74284,70,NULL,NULL,'SDSS J224214.80-085948.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000161,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,340.5617083,-8.99681,0.141,NULL,50384624769,787259762,12300933,18.5),(157583,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157583,36.81,0.46,230,74285,70,NULL,NULL,'2MASX J22421719-0034165',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000182,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,340.571625,-0.57117,0.189,NULL,49473073756,773016777,12078387,17.3),(157584,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157584,31,0.8,15.9,74286,75,NULL,'MAT, I','NGC 7361',NULL,'1997ApJS..109..333W',1997,1,3.8,'The 2MASS position refers to a knot 10 arcsec northeast of the center.','G',0.00001,NULL,'12.92',1,'S(r)c:?','Isolated galaxy',NULL,NULL,NULL,1,340.574625,-30.05767,0,NULL,50088937360,782639646,12228744,12.92),(157585,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157585,31.02,0.8,16,74286,75,NULL,'A82, H','NGC 7361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157586,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157586,30.45,0.4,12.3,74286,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 7361',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157587,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157587,30.73,0.35,14,74286,NULL,NULL,NULL,'NGC 7361',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157588,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157588,30.82,0.32,14.6,74286,85,NULL,'I, raw','NGC 7361',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157589,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157589,30.82,0.32,14.6,74286,85,NULL,'I, inv','NGC 7361',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157590,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157590,30.98,0.39,15.7,74286,73,NULL,'opt','NGC 7361',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157591,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157591,31,0.4,15.9,74286,75,NULL,'B','NGC 7361',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157592,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157592,31.02,0.43,16,74286,75,NULL,'3.6 micron, color corrected','NGC 7361',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157593,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157593,31.04,0.43,16.2,74286,75,NULL,'MAT, I, raw','NGC 7361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157594,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157594,31.08,0.43,16.4,74286,75,NULL,'MAT, I, inv','NGC 7361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157595,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157595,31.08,0.2,16.4,74286,74.4,NULL,NULL,'NGC 7361',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157596,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157596,31.08,0.43,16.5,74286,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7361',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157597,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157597,31.16,0.47,17.1,74286,75,NULL,'A82, H, inv','NGC 7361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157598,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157598,31.23,0.39,17.6,74286,73,NULL,'IR','NGC 7361',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157599,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157599,31.23,0.4,17.6,74286,75,NULL,NULL,'NGC 7361',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157600,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157600,31.24,0.47,17.7,74286,75,NULL,'A82, H, raw','NGC 7361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157601,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157601,31.36,0.43,18.7,74286,75,NULL,'MAT, I, cor','NGC 7361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157602,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157602,31.54,0.46,20.3,74286,NULL,NULL,NULL,'NGC 7361',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157603,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157603,31.61,0.47,20.9,74286,75,NULL,'A82, H, cor','NGC 7361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157604,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157604,31.73,0.42,22.2,74286,NULL,NULL,'Malmquist cor.','NGC 7361',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157605,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157605,31.86,0.49,23.5,74286,75,NULL,'IR','NGC 7361',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157606,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157606,36.94,0.46,245,74287,70,NULL,NULL,'2MASX J22421812-0041315',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000176,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,340.575417,-0.69197,0.201,NULL,49472950036,773014844,12078356,17),(157607,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157607,37.74,0.27,353,74288,70,NULL,NULL,'2MASX J22421885-0032055',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.22',0.18,NULL,NULL,NULL,NULL,NULL,1,340.578625,-0.53497,0.189,NULL,49473120731,773017511,12078398,18.22),(157608,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157608,38.19,0.46,434,74289,70,NULL,NULL,'SDSS J224221.71+135558.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00017,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,340.5905,13.93292,0.113,NULL,52585458814,821647793,12838246,18.3),(157609,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157609,37.42,0.33,304,74290,70,NULL,NULL,'2MASX J22422288+0053481',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000172,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,340.59525,0.89672,0.197,NULL,51689407375,807646990,12619484,17.3),(157610,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157610,37.67,0.33,343,74291,70,NULL,NULL,'2MASX J22422391-0906563',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000201,NULL,'17.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,340.5995,-9.11567,0.141,NULL,50384821577,787262837,12300981,17.2),(157611,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157611,34.44,0.69,77.2,74292,100,NULL,'mid-IR','NGC 7357',NULL,'2013ApJ...771...88L',2013,1,1.5,NULL,'G',0.000033,NULL,'14.78',0.7,'Sb',NULL,NULL,NULL,NULL,1,340.59975,30.17136,0.277,NULL,51916718911,811198732,12674980,14.78),(157612,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157612,34.78,0.33,90.4,74292,NULL,NULL,NULL,'NGC 7357',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157613,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157613,34.84,0.32,93,74292,NULL,NULL,'Malmquist cor.','NGC 7357',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157614,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157614,35.12,0.2,106,74292,74.4,NULL,NULL,'NGC 7357',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157615,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157615,37.17,0.46,272,74293,70,NULL,NULL,'2MASX J22422395+0113371',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'16.67',0.32,NULL,NULL,NULL,NULL,NULL,1,340.59975,1.22692,0.205,NULL,51689230946,807644233,12619441,16.67),(157616,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157616,37.52,0.33,319,74294,70,NULL,NULL,'2MASX J22422481-0753163',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,340.603333,-7.88794,0.105,NULL,50398648878,787478888,12304357,17.2),(157617,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157617,38.24,0.46,444,74295,70,NULL,NULL,'2MASX J22422634+1400496',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000177,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,340.609875,14.01364,0.113,NULL,52593020933,821765952,12840093,17.5),(157618,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 15358','RN',157618,41.59,0.23,1910,74296,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15358',0.089088,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157619,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 15358','RN',157619,41.96,0.25,2260,74296,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15358',0.089088,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157620,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157620,35.05,0.47,102,74297,70,NULL,NULL,'MCG -02-57-028',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'15.39',0.2,'S0',NULL,NULL,NULL,NULL,1,340.6215,-11.4715,0.233,NULL,50353319386,786770615,12293290,15.39),(157621,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157621,37.49,0.46,315,74298,70,NULL,NULL,'2MASX J22423018+1242306',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,340.625875,12.70858,0.109,NULL,52588137747,821689652,12838900,17.7),(157622,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157622,37.36,0.27,296,74299,70,NULL,NULL,'2MASX J22423525+0107241',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000233,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,340.646833,1.12342,0.205,NULL,51689193740,807643652,12619432,16.5),(157623,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157623,38.3,0.46,458,74300,70,NULL,NULL,'2MASX J22423702+1443425',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000165,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,340.6542917,14.72861,0.201,NULL,52593335868,821770872,12840169,17.4),(157624,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 09600','RN',157624,40.4,0.53,1140,74301,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 09600',0.057815,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157625,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157625,37.36,0.27,296,74302,70,NULL,NULL,'SDSS J224238.68+010843.5',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000206,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,340.661167,1.14544,0.205,NULL,51689195202,807643675,12619432,16.5),(157626,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157626,35.12,0.4,106,74303,NULL,NULL,'mean','UGC 12163',NULL,'2007A&A...465...71T',2007,1,0.7,NULL,'G',0.000067,NULL,'14.55',0.4,'SB;NLSy1       Sy1.8',NULL,NULL,NULL,'LINER',1,340.6639583,29.72536,0.273,NULL,51933088235,811454503,12678976,14.55),(157627,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157627,35.26,0.45,113,74303,NULL,NULL,'K','UGC 12163',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157628,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 10297','R',157628,40.22,0.14,963,74304,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2005mk','SN 2005mk',0.148293,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'II',NULL,NULL,NULL,NULL,1,340.669333,0.83303,0.197,NULL,51689504582,807648509,12619507,NULL),(157629,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 10297','R',157629,41.04,0.23,1410,74304,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2005mk','SN 2005mk',0.148293,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157630,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 10441','RN',157630,41.88,0.23,1690,74305,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 10441',0.408915,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157631,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 10441','RN',157631,42.68,0.24,2430,74305,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 10441',0.408915,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157632,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157632,37.74,0.27,353,74306,70,NULL,NULL,'2MASX J22424385-0034515',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000168,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,340.6827917,-0.58106,0.189,NULL,49473048127,773016376,12078380,17.9),(157633,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 00875','RN',157633,38.2,0.24,395,74307,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 00875',0.105389,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157634,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2006la',NULL,157634,38.98,0.06,625,74308,70,NULL,'Hubble residual 0.45 for z0.12670','SDSS J224248.34-005406.3',NULL,'2011ApJ...740...92G',2011,1,0.09,NULL,'G',0.0005,NULL,'20.5g',0.05,NULL,NULL,NULL,NULL,NULL,1,340.701417,-0.90178,0.169,NULL,49473906747,773029792,12078590,20.5),(157635,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 15459','R',157635,39.38,0.18,668,74308,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006la','SDSS J224248.34-005406.3',0.1267,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157636,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 15459','R',157636,39.49,0.09,701,74308,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006la','SDSS J224248.34-005406.3',0.1267,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157637,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2006la',NULL,157637,39.26,0.07,711,74308,70,NULL,'SALT 2','SDSS J224248.34-005406.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157638,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2006la',NULL,157638,39.26,0.07,711,74308,70,NULL,'SALT 2, Malmquist cor.','SDSS J224248.34-005406.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157639,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157639,34.64,0.8,84.7,74309,75,NULL,'W91PP, r','UGC 12165',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000024,NULL,'15.76',0.18,'Sbc',NULL,NULL,NULL,NULL,1,340.7077917,32.99364,0.325,NULL,55462921717,866608151,13540752,15.76),(157640,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157640,34.27,0.43,71.3,74309,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12165',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157641,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157641,34.4,NULL,75.7,74309,NULL,NULL,NULL,'UGC 12165',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157642,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157642,34.42,0.43,76.6,74309,75,NULL,'3.6 micron, color corrected','UGC 12165',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157643,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157643,34.44,NULL,77.1,74309,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12165',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157644,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157644,34.46,NULL,78.1,74309,NULL,NULL,'Dipole + Quadrupole','UGC 12165',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157645,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157645,34.48,NULL,78.7,74309,NULL,NULL,'Dipole','UGC 12165',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157646,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157646,34.5,0.49,79.3,74309,75,NULL,'IR','UGC 12165',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157647,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157647,34.59,0.38,82.9,74309,75,NULL,'W91PP, r, raw','UGC 12165',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157648,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157648,34.6,0.2,83.2,74309,74.4,NULL,NULL,'UGC 12165',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157649,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157649,34.63,0.37,84.3,74309,NULL,NULL,NULL,'UGC 12165',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157650,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157650,34.7,0.38,87,74309,75,NULL,'W91PP, r, inv','UGC 12165',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157651,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157651,34.73,0.35,88.3,74309,NULL,NULL,'Malmquist cor.','UGC 12165',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157652,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157652,34.77,0.38,90.1,74309,75,NULL,'W91PP, r, cor','UGC 12165',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157653,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157653,37.76,0.46,357,74310,70,NULL,NULL,'2MASX J22425022-0826192',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000165,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,340.709291667,-8.43864,0.129,NULL,50397948646,787467947,12304186,18.2),(157654,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157654,35.57,0.8,130,74311,75,NULL,'W91PP, r','UGC 12164',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'15.14',0.8,'Sb',NULL,NULL,NULL,NULL,1,340.709708333,30.50278,0.253,NULL,51916837852,811200591,12675009,15.14),(157655,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157655,35.46,0.38,124,74311,75,NULL,'W91PP, r, raw','UGC 12164',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157656,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157656,35.61,0.38,132,74311,75,NULL,'W91PP, r, cor','UGC 12164',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157657,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157657,35.74,0.38,141,74311,75,NULL,'W91PP, r, inv','UGC 12164',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157658,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157658,37.35,0.46,295,74312,70,NULL,NULL,'2MASX J22425128+1246050',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000151,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,340.7137083,12.76814,0.129,NULL,52588140798,821689699,12838901,17.3),(157659,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157659,37.59,0.63,330,74313,70,NULL,NULL,'MCG -02-57-029',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'15.0R',0.4,NULL,NULL,NULL,NULL,NULL,1,340.715667,-10.65897,0.169,NULL,50352945195,786764768,12293199,15),(157660,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 13329',NULL,157660,40.47,0.12,1240,74314,70,NULL,'SN photometric redshift distance, z photo =0.347 +/- 0.024','SDSS-II SN 13329',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,340.720125,-0.10853,0.193,NULL,49468898439,772951538,12077367,NULL),(157661,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157661,37.36,0.27,296,74315,70,NULL,NULL,'2MASX J22425473+0102222',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,340.7279583,1.03947,0.205,NULL,51689532853,807648950,12619514,17.5),(157662,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157662,35.39,0.58,120,74316,70,NULL,NULL,'ESO 345- G 044',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'14.85',0.59,'Compact',NULL,NULL,NULL,NULL,1,340.728625,-42.047,0,NULL,50711532166,792367690,12380745,14.85),(157663,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157663,37.74,0.27,353,74317,70,NULL,NULL,'2MASX J22425571-0028485',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,340.732041667,-0.48031,0.189,NULL,49473021375,773015958,12078374,17.9),(157664,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157664,36.58,0.46,207,74318,70,NULL,NULL,'2MASX J22430264-0013515',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000183,NULL,'16.59',0.24,'BrClG',NULL,NULL,NULL,NULL,1,340.760833,-0.23108,0.173,NULL,49468931237,772952050,12077375,16.59),(157665,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 20825',NULL,157665,38.66,1.06,539,74319,70,NULL,'SN photometric redshift distance, z photo =0.135 +/- 0.096','SDSS-II SN 20825',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,340.7882083,0.56578,0.201,NULL,51688627973,807634812,12619293,NULL),(157666,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157666,35.24,0.47,112,74320,70,NULL,NULL,'2MASX J22431065-0514187',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.000067,NULL,'15.52',0.37,NULL,NULL,NULL,NULL,NULL,1,340.7945417,-5.23842,0.093,NULL,50343635720,786619308,12290926,15.52),(157667,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 21494','R',157667,40.81,0.34,1050,74321,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 21494',0.378652,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,'PHOT','21.4g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,340.795875,0.30425,0.209,NULL,51680374550,807505852,12617278,21.4),(157668,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 21494','R',157668,41.49,0.46,1440,74321,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21494',0.378652,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157669,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 21494',NULL,157669,41.5,0.09,1990,74321,70,NULL,'SN photometric redshift distance, z photo =0.655 +/- 0.045','SDSS-II SN 21494',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157670,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157670,34.79,0.7,90.9,74322,70,NULL,NULL,'ESO 345-IG 045 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'15.69',0.47,'E              Liner',NULL,NULL,NULL,NULL,1,340.8095,-40.04878,0,NULL,50713801551,792403149,12381299,15.69),(157671,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157671,36.97,0.21,247,74323,70,NULL,NULL,'2MASX J22431472+0024570',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,340.8112083,0.41583,0.201,NULL,51680270025,807504219,12617253,16.3),(157672,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157672,35.03,0.49,101,74324,NULL,NULL,'Malmquist cor.','FGC 2412',NULL,'2009ApJS..182..474S',2009,1,1.01,NULL,'G',0.000014,NULL,'16.7',0.1,'Sd',NULL,NULL,NULL,NULL,1,340.8114583,8.43278,0.241,NULL,52478232160,819972377,12812068,16.7),(157673,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157673,35.09,0.48,104,74324,NULL,NULL,NULL,'FGC 2412',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157674,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157674,35.19,0.2,109,74324,74.4,NULL,NULL,'FGC 2412',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157675,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157675,35.23,NULL,111,74324,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2412',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157676,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157676,35.26,NULL,113,74324,NULL,NULL,'Dipole','FGC 2412',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157677,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157677,35.26,NULL,113,74324,NULL,NULL,'Dipole + Quadrupole','FGC 2412',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157678,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157678,35.28,0.49,114,74324,75,NULL,'IR','FGC 2412',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157679,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157679,35.29,NULL,114,74324,NULL,NULL,NULL,'FGC 2412',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157680,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 09771','RN',157680,40.91,1.59,1350,74325,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 09771',0.124932,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157681,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157681,37.94,0.46,387,74326,70,NULL,NULL,'2MASX J22431535+1234107',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,340.813833,12.56956,0.129,NULL,52587523053,821680047,12838750,17.2),(157682,'Tully est','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157682,32.14,0.8,26.7,74327,75,NULL,NULL,'ESO 345- G 046',NULL,'1988NBGC.C....0000T',1988,1,2.6,NULL,'G',0.00001,NULL,'13.21',2.3,'SA(s)d:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,340.8170417,-39.86636,0,NULL,50713679574,792401243,12381269,13.21),(157683,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 17965',NULL,157683,39.93,0.29,966,74328,70,NULL,'SN photometric redshift distance, z photo =0.258 +/- 0.043','SDSS-II SN 17965',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,340.8235417,-0.75889,0.161,NULL,49473774392,773027724,12078558,NULL),(157684,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 17965','R',157684,41.04,0.19,1220,74328,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17965',0.315534,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157685,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 17965','R',157685,41.36,0.31,1420,74328,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17965',0.315534,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157686,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 15674','R',157686,40.05,0.21,856,74329,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006nu','SN 2006nu',0.198,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,340.829167,0.26292,0.209,NULL,51680323615,807505056,12617266,NULL),(157687,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 15674','R',157687,40.26,0.12,943,74329,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006nu','SN 2006nu',0.198,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157688,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 13431','RN',157688,38.19,0.27,411,74330,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 13431',0.057508,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157689,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 13431','RN',157689,39.77,0.47,850,74330,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 13431',0.057508,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157690,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157690,36.97,0.21,247,74331,70,NULL,NULL,'2MASX J22431965+0027320',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000204,NULL,'16.2g',0.4,'Sb-Sc',NULL,NULL,NULL,NULL,1,340.8320417,0.45892,0.201,NULL,51680310521,807504851,12617263,16.2),(157691,'Tully est','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157691,30.77,0.8,14.2,74332,75,NULL,'B','NGC 7363',NULL,'1988NBGC.C....0000T',1988,1,1.1,'UZC has V = 830 +- 20 km/sec.','G',0.000033,NULL,'14.38',1,'SAB(s)d:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,340.8329583,34.0015,0.385,NULL,55462711292,866604863,13540700,14.38),(157692,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157692,36.97,0.21,247,74333,70,NULL,NULL,'2MASX J22432045+0031290',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000174,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,340.835167,0.52475,0.201,NULL,51680305945,807504780,12617262,18),(157693,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 21185',NULL,157693,39.61,0.5,834,74334,70,NULL,'SN photometric redshift distance, z photo =0.218 +/- 0.067','SDSS-II SN 21185',NULL,'2011ApJ...738..162S',2011,1,0.11,NULL,'G',NULL,'PHOT','20.1g',0.07,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,340.843791667,-0.71747,0.161,NULL,49473003788,773015684,12078370,20.1),(157694,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 21185','R',157694,40.32,0.34,938,74334,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 21185',0.233935,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157695,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 21185','R',157695,40.34,0.42,946,74334,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 21185',0.233935,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157696,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 06742','RN',157696,40.98,0.16,1250,74335,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 06742',0.259634,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157697,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 06742','RN',157697,42.22,0.24,2210,74335,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 06742',0.259634,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157698,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157698,38.51,0.46,504,74336,70,NULL,NULL,'SDSS J224324.90+135302.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000146,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,340.8537917,13.88414,0.137,NULL,52585974585,821655852,12838372,18.7),(157699,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157699,36.97,0.21,247,74337,70,NULL,NULL,'2MASX J22432592+0017550',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000188,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,340.858083,0.29864,0.209,NULL,51680326248,807505097,12617267,16.5),(157700,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 06743',NULL,157700,40.59,0.32,1310,74338,70,NULL,NULL,'SDSS-II SN 06743',NULL,'2013MNRAS.434.1443X',2013,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,340.8642917,-0.36669,0.173,NULL,49468756517,772949320,12077333,NULL),(157701,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 06743','R',157701,41.43,0.32,1420,74338,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06743',0.362142,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157702,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 06743','R',157702,41.71,0.32,1620,74338,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06743',0.362142,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157703,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 06743',NULL,157703,41.31,0.23,1830,74338,70,NULL,'SALT 2','SDSS-II SN 06743',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157704,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 06743',NULL,157704,41.36,0.23,1870,74338,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 06743',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157705,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157705,36.97,0.21,247,74339,70,NULL,NULL,'2MASX J22432772+0014110',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000173,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,340.8655417,0.23644,0.209,NULL,51680325204,807505081,12617266,17.6),(157706,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157706,36.08,0.51,165,74340,70,NULL,NULL,'2MASX J22432812-8105025',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.4b',0.3,NULL,NULL,NULL,NULL,NULL,1,340.867083,-81.08406,0.405,NULL,48562703416,758792240,11856128,16.4),(157707,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157707,38.78,0.46,569,74341,70,NULL,NULL,'2MASX J22433193-0016306',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00017,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,340.8830417,-0.27506,0.193,NULL,49468881365,772951271,12077363,18),(157708,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157708,35.2,0.58,110,74342,70,NULL,NULL,'2MASX J22433372-2103504',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'15.84',0.57,'E','Field galaxy',NULL,NULL,NULL,1,340.890583,-21.06394,0.065,NULL,50219469767,784679215,12260612,15.84),(157709,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157709,34.31,0.5,72.9,74343,NULL,NULL,NULL,'ESO 238- G 023',NULL,'2009ApJS..182..474S',2009,1,1.01,NULL,'G',0.000033,NULL,'15.16',0.35,'S...',NULL,NULL,NULL,NULL,1,340.892625,-48.6445,0,NULL,50685204578,791956321,12374317,15.16),(157710,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157710,34.36,0.2,74.5,74343,74.4,NULL,NULL,'ESO 238- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157711,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157711,34.36,0.49,74.6,74343,NULL,NULL,'Malmquist cor.','ESO 238- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157712,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157712,36.13,0.8,168,74344,75,NULL,'W91PP, r','UGC 12169',NULL,'1997ApJS..109..333W',1997,1,1,'May contribute to the IRAS F22411+2340 flux.','G',0.000769,NULL,'15.55',0.3,'Sb',NULL,NULL,NULL,NULL,1,340.913167,23.94978,0.217,NULL,52383525489,818492585,12788946,15.55),(157713,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157713,35.69,0.43,137,74344,NULL,NULL,'Malmquist cor.','UGC 12169',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157714,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157714,35.88,0.38,150,74344,75,NULL,'W91PP, r, raw','UGC 12169',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157715,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157715,35.95,0.38,155,74344,NULL,NULL,NULL,'UGC 12169',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157716,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157716,36.11,0.38,166,74344,75,NULL,'W91PP, r, inv','UGC 12169',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157717,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157717,36.14,0.38,169,74344,75,NULL,'W91PP, r, cor','UGC 12169',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157718,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157718,36.19,0.2,173,74344,74.4,NULL,NULL,'UGC 12169',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157719,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157719,35.29,0.49,114,74345,75,NULL,'IR','UGC 12168',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000834,NULL,'16.0',0.1,'S?',NULL,NULL,NULL,NULL,1,340.917125,6.12194,0.181,NULL,52473304277,819895379,12810865,16),(157720,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157720,35.65,0.5,135,74345,NULL,NULL,'Malmquist cor.','UGC 12168',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157721,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157721,35.76,0.47,142,74345,NULL,NULL,NULL,'UGC 12168',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157722,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157722,35.79,0.2,144,74345,74.4,NULL,NULL,'UGC 12168',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157723,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157723,36.69,0.71,218,74346,70,NULL,NULL,'2MASX J22434070-5417246',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000107,NULL,'17.01',0.15,'S',NULL,NULL,NULL,NULL,1,340.9195,-54.29042,0,NULL,48823043701,762860057,11919688,17.01),(157724,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2007lp',NULL,157724,39.31,0.08,728,74347,70,NULL,'Hubble residual 0.12 for z0.17610','SDSS J224340.96+002513.8',NULL,'2011ApJ...740...92G',2011,1,0.12,NULL,'G',0.0005,NULL,'19.5g',0.06,NULL,NULL,NULL,NULL,NULL,1,340.9207083,0.4205,0.209,NULL,51680293228,807504581,12617259,19.5),(157725,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 18604','R',157725,39.78,0.18,767,74347,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007lp','SDSS J224340.96+002513.8',0.1761,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157726,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 18604','R',157726,39.89,0.08,808,74347,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007lp','SDSS J224340.96+002513.8',0.1761,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157727,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2007lp',NULL,157727,39.59,0.08,828,74347,70,NULL,'SALT 2','SDSS J224340.96+002513.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157728,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2007lp',NULL,157728,39.6,0.08,832,74347,70,NULL,'SALT 2, Malmquist cor.','SDSS J224340.96+002513.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157729,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 08398','RN',157729,43.11,0.38,3960,74348,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 08398',0.057154,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157730,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157730,35.57,0.52,130,74349,70,NULL,NULL,'FAIRALL 1025',NULL,'2014MNRAS.445.2677S',2014,1,1.02,NULL,'G',0.000113,NULL,'15.51',0.37,'S0',NULL,NULL,NULL,NULL,1,340.947,-48.88569,0,NULL,50685885014,791966953,12374483,15.51),(157731,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 11022','RN',157731,39.44,0.43,683,74350,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 11022',0.131602,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157732,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 11022','RN',157732,40.3,1.31,1020,74350,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 11022',0.131602,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157733,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 07431','R',157733,41.16,0.17,1270,74351,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 07431',0.350266,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,340.954375,-0.275,0.193,NULL,49468836401,772950568,12077352,NULL),(157734,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 07431','R',157734,41.19,0.24,1280,74351,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 07431',0.350266,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157735,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157735,37.45,0.46,309,74352,70,NULL,NULL,'2MASX J22435018+1351084',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,340.959083,13.85239,0.137,NULL,52586052687,821657073,12838391,17.8),(157736,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157736,34.14,0.49,67.3,74353,75,NULL,'IR','2MFGC 17107',NULL,'2011yCatp016004901K',2011,1,0.87,NULL,'G',0.000897,NULL,'15.39',0.21,NULL,NULL,NULL,NULL,NULL,1,340.9615,35.91169,0.421,NULL,55449878276,866404348,13537567,15.39),(157737,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 14445','R',157737,40.39,0.24,970,74354,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J224351.16-004516.2',0.2349,'2014arXiv1401.3317S',2014,1,0.09,NULL,'G',0.0002,NULL,'20.4g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,340.963208333,-0.75453,0.161,NULL,49473719780,773026871,12078544,20.4),(157738,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 14445',NULL,157738,40.08,0.15,1040,74354,70,NULL,'SALT 2','SDSS J224351.16-004516.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157739,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 14445',NULL,157739,40.1,0.15,1050,74354,70,NULL,'SALT 2, Malmquist cor.','SDSS J224351.16-004516.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157740,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 14445','R',157740,40.88,0.19,1210,74354,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J224351.16-004516.2',0.2349,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157741,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 19467',NULL,157741,38.66,1.31,539,74355,70,NULL,'SN photometric redshift distance, z photo =0.135 +/- 0.129','SDSS-II SN 19467',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,340.964916667,-0.97697,0.169,NULL,49473755361,773027427,12078553,NULL),(157742,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157742,35.15,0.54,107,74356,NULL,NULL,'Malmquist cor.','FGC 2413',NULL,'2009ApJS..182..474S',2009,1,0.63,NULL,'G',0.000012,NULL,'17.0',0.09,'Sd',NULL,NULL,NULL,NULL,1,340.965,8.43333,0.221,NULL,52476362295,819943160,12811611,17),(157743,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157743,35.2,0.53,110,74356,NULL,NULL,NULL,'FGC 2413',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157744,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157744,35.3,0.2,115,74356,74.4,NULL,NULL,'FGC 2413',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157745,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157745,35.61,NULL,132,74356,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2413',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157746,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157746,35.64,NULL,134,74356,NULL,NULL,'Dipole + Quadrupole','FGC 2413',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157747,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157747,35.66,NULL,135,74356,NULL,NULL,'Dipole','FGC 2413',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157748,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157748,35.68,NULL,137,74356,NULL,NULL,NULL,'FGC 2413',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157749,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157749,36.82,0.46,232,74357,70,NULL,NULL,'2MASX J22435183-0835148',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000159,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,340.9660417,-8.5875,0.125,NULL,50397403386,787459427,12304053,16.9),(157750,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157750,33.95,0.8,61.8,74358,75,NULL,'CF, r','UGC 12173',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000017,NULL,'13.49',1.2,'SAB(rs)c','Isolated galaxy',NULL,NULL,NULL,1,340.96675,38.37686,0.489,NULL,55530097232,867657769,13557152,13.49),(157751,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157751,33.23,0.69,44.2,74358,100,NULL,'mid-IR','UGC 12173',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157752,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157752,33.71,0.43,55.3,74358,75,NULL,'3.6 micron, color corrected','UGC 12173',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157753,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157753,33.72,0.47,55.5,74358,NULL,NULL,'H','UGC 12173',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157754,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157754,33.73,0.46,55.8,74358,NULL,NULL,'J','UGC 12173',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157755,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157755,33.75,0.2,56.2,74358,74.4,NULL,NULL,'UGC 12173',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157756,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157756,33.78,0.45,57.1,74358,NULL,NULL,'K','UGC 12173',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157757,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157757,33.82,0.43,58,74358,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12173',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157758,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157758,33.83,0.38,58.3,74358,75,NULL,'CF, r, raw','UGC 12173',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157759,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157759,34,0.38,63.1,74358,75,NULL,'CF, r, inv','UGC 12173',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157760,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157760,34.02,0.33,63.7,74358,NULL,NULL,NULL,'UGC 12173',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157761,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157761,34.06,0.4,64.8,74358,NULL,NULL,'mean','UGC 12173',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157762,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157762,34.14,0.38,67.2,74358,75,NULL,'CF, r, cor','UGC 12173',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157763,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157763,34.19,0.3,68.9,74358,NULL,NULL,'Malmquist cor.','UGC 12173',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157764,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157764,34.93,0.8,96.9,74359,75,NULL,'CF, r','UGC 12172',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'15.15',0.5,'Scd:','Isolated galaxy',NULL,NULL,NULL,1,340.9872917,7.39058,0.245,NULL,52478610658,819978291,12812160,15.15),(157765,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157765,34.89,0.2,95.1,74359,74.4,NULL,NULL,'UGC 12172',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157766,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157766,34.94,0.48,97.1,74359,NULL,NULL,'Malmquist cor.','UGC 12172',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157767,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157767,34.95,0.47,97.9,74359,NULL,NULL,NULL,'UGC 12172',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157768,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157768,34.99,0.38,99.4,74359,75,NULL,'CF, r, raw','UGC 12172',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157769,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157769,35.15,0.38,107,74359,75,NULL,'CF, r, inv','UGC 12172',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157770,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157770,35.27,0.38,113,74359,75,NULL,'CF, r, cor','UGC 12172',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157771,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157771,36.81,0.46,230,74360,70,NULL,NULL,'2MASX J22435699+0100019',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000192,NULL,'16.2g',0.39,'E0',NULL,NULL,NULL,NULL,1,340.987333,1.0005,0.201,NULL,51688945744,807639777,12619371,16.2),(157772,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157772,34.87,0.49,94.3,74361,75,NULL,'IR','ESO 468- G 025',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'15.17',0.3,'Sb:',NULL,NULL,NULL,NULL,1,341.001083333,-27.23964,0,NULL,50126875343,783232427,12238006,15.17),(157773,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157773,35.15,0.39,107,74361,NULL,NULL,NULL,'ESO 468- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157774,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157774,35.19,0.2,109,74361,74.4,NULL,NULL,'ESO 468- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157775,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157775,35.23,0.38,111,74361,NULL,NULL,'Malmquist cor.','ESO 468- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157776,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157776,37.07,0.46,260,74362,70,NULL,NULL,'2MASX J22440383-0043502',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,341.015833,-0.73064,0.189,NULL,49469063878,772954123,12077408,17.7),(157777,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157777,37.34,0.46,294,74363,70,NULL,NULL,'2MASX J22440446+1435594',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,341.018625,14.59989,0.129,NULL,52592600507,821759382,12839990,17.3),(157778,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157778,36.31,0.69,183,74364,70,NULL,NULL,'2MASX J22440893-4607136',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'17.08',0.32,NULL,NULL,NULL,NULL,NULL,1,341.0372917,-46.12044,0,NULL,50690602840,792040669,12375635,17.08),(157779,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157779,38.36,0.33,469,74365,70,NULL,NULL,'SDSS J224411.34-003140.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000137,NULL,'18.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,341.04725,-0.52792,0.189,NULL,49469626350,772962911,12077545,18.9),(157780,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157780,37,0.72,251,74366,70,NULL,NULL,'2MASX J22441302-1810389',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'17.09',0.36,NULL,NULL,NULL,NULL,NULL,1,341.054333,-18.17742,0.097,NULL,50218417880,784662779,12260355,17.09),(157781,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1994an',NULL,157781,40.88,0.44,1090,74367,74.2,NULL,'SALT 2','[PDG95] J224418.86+000648.5',0.378,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,'Scd',NULL,NULL,NULL,NULL,1,341.078583,0.11347,0.209,NULL,51681048897,807516389,12617443,NULL),(157782,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1994an',NULL,157782,41.87,0.31,1720,74367,70,NULL,'SALT','[PDG95] J224418.86+000648.5',0.378,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157783,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 20858','RN',157783,40.36,0.2,1070,74368,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 20858',0.106605,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157784,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 20858','RN',157784,40.89,0.34,1360,74368,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20858',0.106605,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157785,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157785,37.22,0.46,278,74369,70,NULL,NULL,'2MASX J22442291-0901095',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00015,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,341.095417,-9.01942,0.157,NULL,50383342262,787239722,12300620,16.4),(157786,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157786,36.43,0.46,193,74370,70,NULL,NULL,'2MASX J22442370-0053042',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00015,NULL,'16.3g',0.24,'E0',NULL,NULL,NULL,NULL,1,341.098875,-0.88444,0.161,NULL,49473465828,773022903,12078482,16.3),(157787,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157787,37.64,0.46,337,74371,70,NULL,NULL,'SDSS J224424.00-083822.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000167,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,341.1,-8.63947,0.145,NULL,50397431236,787459863,12304060,18.2),(157788,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 15475','R',157788,34.48,0.05,77.6,74372,70,NULL,'SDSS CAND. SNIc; MLCS2K2; SN 2006lc','NGC 7364',0.016228,'2014arXiv1401.3317S',2014,1,1.5,NULL,'G',0.000017,NULL,'13.4g',0.95,'S0/a pec:',NULL,NULL,NULL,NULL,1,341.1015417,-0.16208,0.201,NULL,49469533051,772961453,12077522,13.4),(157789,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 15475','R',157789,35.26,0.25,111,74372,70,NULL,'SDSS CAND. SNIc; SALT 2; SN 2006lc','NGC 7364',0.016228,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157790,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157790,33.4,0.69,48,74372,100,NULL,'mid-IR','NGC 7364',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157791,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157791,33.86,0.45,59.2,74372,NULL,NULL,'Malmquist cor.','NGC 7364',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157792,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157792,33.88,0.44,59.6,74372,NULL,NULL,NULL,'NGC 7364',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157793,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157793,34.17,0.2,68.2,74372,74.4,NULL,NULL,'NGC 7364',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157794,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 07040','RN',157794,38.31,0.31,407,74373,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 07040',0.127524,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157795,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 07040','RN',157795,40.13,0.43,941,74373,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07040',0.127524,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157796,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157796,37.14,0.46,268,74374,70,NULL,NULL,'2MASX J22442704-0812445',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000177,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,341.112833,-8.2125,0.109,NULL,50397505788,787461027,12304078,16.9),(157797,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157797,37.74,0.46,353,74375,70,NULL,NULL,'2MASX J22443065+1238379',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'18.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,341.1277917,12.64397,0.137,NULL,52584323124,821630048,12837969,18.1),(157798,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 17973','RN',157798,39.08,0.18,569,74376,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 17973',0.148001,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157799,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 17973','RN',157799,39.18,0.13,598,74376,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 17973',0.148001,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157800,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157800,34.35,0.47,74.2,74377,NULL,NULL,'H','NGC 7367',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000033,NULL,'14.67',0.4,'Sab:           AGN?','Isolated galaxy',NULL,NULL,NULL,1,341.1435417,3.64639,0.173,NULL,51683871753,807560496,12618132,14.67);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (157801,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157801,34.41,0.46,76.1,74377,NULL,NULL,'J','NGC 7367',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157802,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157802,34.42,0.45,76.7,74377,NULL,NULL,'K','NGC 7367',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157803,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157803,34.47,0.49,78.4,74377,75,NULL,'IR','NGC 7367',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157804,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157804,34.73,0.4,88.4,74377,NULL,NULL,'mean','NGC 7367',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157805,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 05151','RN',157805,39.76,0.22,771,74378,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05151',0.159093,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157806,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 05151','RN',157806,40.02,0.28,870,74378,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 05151',0.159093,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157807,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157807,37.46,0.46,310,74379,70,NULL,NULL,'2MASX J22443548+1309139',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,341.1477917,13.15386,0.121,NULL,52587910771,821686105,12838845,17.2),(157808,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157808,35.74,0.78,140,74380,70,NULL,NULL,'2MASX J22443701-3945147',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.25',0.38,NULL,NULL,NULL,NULL,NULL,1,341.15425,-39.75411,0,NULL,50717151155,792455486,12382116,16.25),(157809,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157809,38.31,0.46,458,74381,70,NULL,NULL,'2MASX J22443931+0034120',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,341.1639583,0.56997,0.157,NULL,51681010279,807515785,12617434,17.7),(157810,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 01683','RN',157810,39.75,0.66,821,74382,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 01683 HOST',0.084961,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157811,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 10672','RN',157811,39.87,0.57,870,74382,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01683 HOST',0.084961,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157812,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 01683','RN',157812,40.48,1.45,1150,74382,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 01683 HOST',0.084961,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157813,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 10672','RN',157813,41.47,0.46,1810,74382,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01683 HOST',0.084961,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157814,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 15601','RN',157814,39.49,0.2,714,74383,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 15601',0.1065,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157815,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 15601','RN',157815,39.65,0.13,768,74383,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 15601',0.1065,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157816,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157816,37.25,0.46,282,74384,70,NULL,NULL,'2MASX J22444217+1248101',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00017,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,341.175833,12.80272,0.101,NULL,52584326069,821630094,12837970,17),(157817,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157817,38.02,0.46,403,74385,70,NULL,NULL,'2MASX J22444672+0107570',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,341.194583,1.13256,0.225,NULL,51688991228,807640487,12619382,18.1),(157818,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157818,34.73,0.8,88.3,74386,75,NULL,'MAT, I','ESO 238- G 024',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'12.56',0.5,'SA(r)bc',NULL,NULL,NULL,NULL,1,341.2005,-49.27703,0,NULL,50501962450,789093163,12329580,12.56),(157819,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157819,34.15,0.43,67.7,74386,75,NULL,'MAT, I, raw','ESO 238- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157820,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157820,34.23,0.32,70.3,74386,85,NULL,'I, raw','ESO 238- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157821,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157821,34.29,0.32,72.1,74386,85,NULL,'I, inv','ESO 238- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157822,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157822,34.39,0.43,75.6,74386,75,NULL,'MAT, I, inv','ESO 238- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157823,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157823,34.55,0.26,81.4,74386,NULL,NULL,'Malmquist cor.','ESO 238- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157824,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157824,34.57,0.43,82.1,74386,75,NULL,'MAT, I, cor','ESO 238- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157825,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157825,34.64,0.47,84.7,74386,NULL,NULL,'H','ESO 238- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157826,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157826,34.71,0.46,87.6,74386,NULL,NULL,'J','ESO 238- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157827,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157827,34.72,0.45,88,74386,NULL,NULL,'K','ESO 238- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157828,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157828,34.77,0.23,89.9,74386,NULL,NULL,NULL,'ESO 238- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157829,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157829,34.81,0.2,91.6,74386,74.4,NULL,NULL,'ESO 238- G 024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157830,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157830,34.81,0.4,91.7,74386,NULL,NULL,'mean','ESO 238- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157831,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157831,38.36,0.33,469,74387,70,NULL,NULL,'2MASX J22444846-0045299',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,341.201917,-0.75825,0.189,NULL,49469103659,772954744,12077417,18),(157832,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 16877','RN',157832,40.13,0.6,942,74388,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 16877',0.129274,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157833,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157833,37.91,0.46,382,74389,70,NULL,NULL,'SDSS J224449.43+144944.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000135,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,341.206,14.829,0.245,NULL,52592441096,821756892,12839951,18.4),(157834,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157834,37.51,0.33,318,74390,70,NULL,NULL,'2MASX J22445158+1338241',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,341.2149583,13.64014,0.149,NULL,52585736757,821652136,12838314,18.2),(157835,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157835,37.88,0.46,376,74391,70,NULL,NULL,'2MASX J22445285+0002040',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,341.220167,0.03444,0.209,NULL,51680567773,807508871,12617326,17.8),(157836,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157836,37.84,0.46,370,74392,70,NULL,NULL,'2MASX J22445496+1233441',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,341.2289583,12.56214,0.137,NULL,52584831369,821637990,12838093,18.1),(157837,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 16069','R',157837,38.92,0.18,539,74393,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006nd','2MASX J22445879-0100229',0.12878,'2014arXiv1401.3317S',2014,1,0.2,NULL,'G',0.000104,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,341.245041667,-1.00639,0.197,NULL,49473488024,773023250,12078488,18.2),(157838,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 16069','R',157838,38.94,0.1,543,74393,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006nd','2MASX J22445879-0100229',0.12878,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157839,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2006nd',NULL,157839,38.77,0.07,568,74393,70,NULL,'SALT 2','2MASX J22445879-0100229',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157840,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2006nd',NULL,157840,38.78,0.07,570,74393,70,NULL,'SALT 2, Malmquist cor.','2MASX J22445879-0100229',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157841,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157841,35.46,0.44,123,74394,NULL,NULL,NULL,'ESO 238- G 025',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000033,NULL,'15.99',0.34,'Sb:',NULL,NULL,NULL,NULL,1,341.2562083,-48.88708,0,NULL,50501583935,789087248,12329488,15.99),(157842,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157842,35.5,0.2,126,74394,74.4,NULL,NULL,'ESO 238- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157843,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157843,35.77,0.38,143,74394,NULL,NULL,'Malmquist cor.','ESO 238- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157844,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157844,37.51,0.33,318,74395,70,NULL,NULL,'2MASX J22450352+1337501',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000164,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,341.26475,13.63056,0.149,NULL,52585734623,821652103,12838314,17),(157845,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','PTF11kjn','N',157845,35.07,0.03,101,74396,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF11kjn',0.0234,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157846,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157846,31.93,0.43,24.3,74397,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12178',NULL,'2014MNRAS.444..527S',2014,1,3,'The position in 1990PNAOJ...1..181T is for a superposed star.','G',0.000003,NULL,'13.60',1.6,'SAB(s)dm       HII','Isolated galaxy',NULL,NULL,NULL,1,341.28625,6.43094,0.137,NULL,52474345041,819911641,12811119,13.6),(157847,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157847,32.12,0.4,26.5,74397,75,NULL,'B','UGC 12178',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157848,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157848,33.04,0.45,40.6,74398,NULL,NULL,'K','NGC 7365',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00006,NULL,'13.87',1,'SA(rs)0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,341.291833,-19.95203,0.081,NULL,50222181970,784721593,12261274,13.87),(157849,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157849,33.29,0.4,45.5,74398,NULL,NULL,'mean','NGC 7365',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157850,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157850,32.92,0.8,38.4,74399,75,NULL,'MAT, I','ESO 534- G 024',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000027,NULL,'13.64',1.2,'SAB(rs)d:','in a pair',NULL,NULL,NULL,1,341.311417,-22.73078,0.041,NULL,50226667787,784791684,12262370,13.64),(157851,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157851,32.48,0.69,31.3,74399,100,NULL,'mid-IR','ESO 534- G 024',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157852,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157852,32.74,0.32,35.3,74399,85,NULL,'I, raw','ESO 534- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157853,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157853,32.76,0.32,35.7,74399,85,NULL,'I, inv','ESO 534- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157854,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157854,32.82,0.43,36.7,74399,75,NULL,'MAT, I, raw','ESO 534- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157855,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157855,32.95,0.43,38.9,74399,75,NULL,'MAT, I, inv','ESO 534- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157856,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157856,33.06,0.43,40.8,74399,75,NULL,'MAT, I, cor','ESO 534- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157857,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157857,33.14,0.2,42.5,74399,74.4,NULL,NULL,'ESO 534- G 024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157858,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157858,33.29,0.4,45.6,74399,NULL,NULL,'mean','ESO 534- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157859,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157859,33.42,0.46,48.3,74399,NULL,NULL,'Malmquist cor.','ESO 534- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157860,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157860,33.43,0.46,48.6,74399,NULL,NULL,NULL,'ESO 534- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157861,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157861,33.62,0.47,52.9,74399,NULL,NULL,'H','ESO 534- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157862,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157862,33.74,0.46,56.1,74399,NULL,NULL,'J','ESO 534- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157863,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157863,33.78,0.45,57.1,74399,NULL,NULL,'K','ESO 534- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157864,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157864,36.53,0.67,202,74400,70,NULL,NULL,'2MASX J22452395-0613549',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'16.85',0.32,NULL,NULL,NULL,NULL,NULL,1,341.34975,-6.23192,0.085,NULL,50390082901,787345045,12302266,16.85),(157865,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157865,37.5,0.46,316,74401,70,NULL,NULL,'2MASX J22452769-0033052',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,341.36525,-0.55136,0.189,NULL,49469506505,772961039,12077516,17.9),(157866,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157866,37.07,0.56,260,74402,70,NULL,NULL,'2MASX J22452789-3733347',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.57',0.24,NULL,NULL,NULL,NULL,NULL,1,341.3662917,-37.55958,0,NULL,50716023924,792437873,12381841,16.57),(157867,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157867,34.8,0.8,91.3,74403,75,NULL,'W91PP, r','IC 5253',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'15.45',0.3,'S0/a',NULL,NULL,NULL,NULL,1,341.3705,21.80806,0.201,NULL,52391916649,818623697,12790995,15.45),(157868,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157868,34.56,0.49,81.7,74403,NULL,NULL,NULL,'IC 5253',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157869,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157869,34.62,0.38,84,74403,75,NULL,'W91PP, r, raw','IC 5253',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157870,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157870,34.74,0.38,88.8,74403,75,NULL,'W91PP, r, inv','IC 5253',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157871,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157871,34.76,0.2,89.5,74403,74.4,NULL,NULL,'IC 5253',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157872,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157872,34.85,0.38,93.4,74403,75,NULL,'W91PP, r, cor','IC 5253',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157873,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157873,34.94,0.41,97.4,74403,NULL,NULL,'Malmquist cor.','IC 5253',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157874,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157874,32.37,0.8,29.7,74404,75,NULL,'MAT, I','NGC 7368',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000021,NULL,'13.15',0.5,'SB(s)b? sp     HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,341.382,-39.34183,0,NULL,50717196830,792456200,12382128,13.15),(157875,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157875,32.37,0.8,29.8,74404,75,NULL,'A82, H','NGC 7368',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157876,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157876,32.02,0.4,25.4,74404,73,NULL,'IR','NGC 7368',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157877,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157877,32.03,0.4,25.4,74404,75,NULL,NULL,'NGC 7368',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157878,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157878,32.24,0.39,28.1,74404,73,NULL,'opt','NGC 7368',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157879,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157879,32.35,0.43,29.5,74404,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7368',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157880,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157880,32.43,0.11,30.7,74404,NULL,NULL,NULL,'NGC 7368',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157881,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157881,32.46,0.38,31,74404,NULL,NULL,NULL,'NGC 7368',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157882,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157882,32.46,0.46,31.1,74404,NULL,NULL,'J','NGC 7368',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157883,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157883,32.47,0.47,31.1,74404,NULL,NULL,'H','NGC 7368',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157884,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157884,32.48,0.45,31.4,74404,NULL,NULL,'K','NGC 7368',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157885,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157885,32.5,0.43,31.6,74404,75,NULL,'3.6 micron, color corrected','NGC 7368',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157886,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157886,32.52,0.47,32,74404,75,NULL,'A82, H, raw','NGC 7368',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157887,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157887,32.58,0.4,32.8,74404,NULL,NULL,'mean','NGC 7368',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157888,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157888,32.65,0.47,33.8,74404,75,NULL,'A82, H, inv','NGC 7368',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157889,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157889,32.66,0.32,34,74404,85,NULL,'I, raw','NGC 7368',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157890,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157890,32.66,0.49,34,74404,75,NULL,'IR','NGC 7368',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157891,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157891,32.69,0.43,34.4,74404,75,NULL,'MAT, I, raw','NGC 7368',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157892,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157892,32.7,0.32,34.7,74404,85,NULL,'I, inv','NGC 7368',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157893,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157893,32.71,0.2,34.8,74404,74.4,NULL,NULL,'NGC 7368',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157894,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157894,32.73,0.47,35.1,74404,75,NULL,'A82, H, cor','NGC 7368',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157895,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157895,32.83,0.43,36.8,74404,75,NULL,'MAT, I, cor','NGC 7368',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157896,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157896,32.89,0.43,37.9,74404,75,NULL,'MAT, I, inv','NGC 7368',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157897,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157897,35.65,0.16,128,74405,74.2,NULL,'SALT 2','2MFGC 17122',0.0499,'2010ApJ...716..712A',2010,1,0.94,NULL,'G',0.00015,NULL,'16.1g',0.21,'S              HII',NULL,NULL,NULL,NULL,1,341.3919583,-8.75072,0.145,NULL,50397304707,787457886,12304029,16.1),(157898,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157898,36.14,0.03,161,74405,70,NULL,'SALT 2','2MFGC 17122',0.0499,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157899,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157899,36.19,0.04,165,74405,72,NULL,NULL,'2MFGC 17122',0.0499,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157900,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157900,36.16,0.08,171,74405,74.4,NULL,NULL,'2MFGC 17122',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157901,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157901,36.35,0.17,177,74405,70,NULL,'SALT','2MFGC 17122',0.0499,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157902,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157902,36.38,0.05,180,74405,70,NULL,NULL,'2MFGC 17122',0.0499,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157903,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157903,36.39,0.15,181,74405,70,NULL,'SALT 2','2MFGC 17122',0.0499,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157904,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157904,36.4,0.05,181,74405,65,NULL,'SALT2','2MFGC 17122',0.0499,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157905,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157905,36.51,0.11,182,74405,65,NULL,'MLCS2k2','2MFGC 17122',0.0499,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157906,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157906,36.42,0.15,183,74405,73.8,NULL,'SALT 2 (SNANA)','2MFGC 17122',0.049,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157907,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157907,36.33,0.06,185,74405,60,NULL,'M(I) = -19.19 mag','2MFGC 17122',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157908,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157908,36.5,0.05,190,74405,65,NULL,'MLCS2k2','2MFGC 17122',0.0499,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157909,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157909,36.52,0.17,191,74405,65,NULL,'SALT2','2MFGC 17122',0.0499,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157910,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157910,36.52,0.16,192,74405,65,NULL,'SALT','2MFGC 17122',0.0499,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157911,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157911,36.52,0.2,192,74405,65,NULL,NULL,'2MFGC 17122',0.0499,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157912,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157912,36.42,0.07,192,74405,60,NULL,'M(B) = -19.48 mag','2MFGC 17122',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157913,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157913,36.54,0.15,193,74405,65,NULL,'MLCS31','2MFGC 17122',0.0499,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157914,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157914,36.43,0.06,193,74405,60,NULL,'M(V) = -19.47 mag','2MFGC 17122',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157915,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157915,36.56,0.22,195,74405,72,NULL,NULL,'2MFGC 17122',0.0499,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157916,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157916,36.57,0.11,196,74405,65,NULL,'MLCS2k2','2MFGC 17122',0.0499,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157917,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157917,36.6,0.16,199,74405,65,NULL,'Template','2MFGC 17122',0.0499,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157918,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157918,36.6,0.13,199,74405,65,NULL,'MLCS17','2MFGC 17122',0.0499,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157919,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157919,36.65,0.02,204,74405,65,NULL,'SALT','2MFGC 17122',0.0499,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157920,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157920,36.68,0.17,217,74405,70.8,NULL,NULL,'2MFGC 17122',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157921,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157921,36.85,0.13,223,74405,65,NULL,'MLCS','2MFGC 17122',0.0499,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157922,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 07762',NULL,157922,40.65,0.41,1350,74406,70,NULL,'SN photometric redshift distance, z photo =0.386 +/- 0.107','SDSS-II SN 07762',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','22.6g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,341.394333,0.14442,0.165,NULL,51680603342,807509427,12617334,22.6),(157923,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157923,36.32,0.68,184,74407,70,NULL,NULL,'2MASX J22453504-0845586',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.00015,NULL,'15.8g',0.25,'Sab',NULL,NULL,NULL,NULL,1,341.395916667,-8.76622,0.145,NULL,50397304808,787457887,12304029,15.8),(157924,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157924,38.48,0.46,497,74408,70,NULL,NULL,'2MASX J22454076-1013396',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000173,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,341.419833,-10.22775,0.157,NULL,50385792855,787278013,12301218,17.6),(157925,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157925,36.66,0.46,215,74409,70,NULL,NULL,'2MASX J22454475+0105280',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000201,NULL,'16.0g',0.39,'E0',NULL,NULL,NULL,NULL,1,341.436417,1.09108,0.225,NULL,51680664002,807510375,12617349,16),(157926,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 05806','RN',157926,40.22,0.12,983,74410,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 05806',0.123678,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157927,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 05806','RN',157927,40.73,0.2,1250,74410,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 05806',0.123678,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157928,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157928,37.23,0.46,279,74411,70,NULL,NULL,'2MASX J22455118-0820076',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00015,NULL,'16.3g',0.36,'AGN',NULL,NULL,NULL,NULL,1,341.463333,-8.33536,0.109,NULL,50397703154,787464111,12304126,16.3),(157929,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 02280','RN',157929,41.43,0.39,1430,74412,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02280',0.350224,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157930,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 02280','RN',157930,41.51,0.36,1480,74412,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 02280',0.350224,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157931,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 02280','N',157931,41.34,0.27,1850,74412,70,NULL,'SALT 2','SDSS-II SN 02280',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157932,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 02280','N',157932,41.38,0.27,1890,74412,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 02280',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157933,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 19899','R',157933,37.99,0.19,363,74413,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007pu','SN 2007pu',0.0914,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,341.4922917,-0.64872,0.229,NULL,49469511484,772961116,12077517,NULL),(157934,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 19899','R',157934,38.29,0.07,418,74413,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007pu','SN 2007pu',0.0914,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157935,'Magnitude','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157935,36.7,0.13,219,74414,100,NULL,NULL,'2MASX J22460031-1741210',NULL,'1998A&A...337...31R',1998,1,0.43,NULL,'G',0.000137,NULL,'15.30',0.36,'E/S0',NULL,NULL,NULL,NULL,1,341.5015417,-17.68936,0.061,NULL,50449173802,788268340,12316692,15.3),(157936,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157936,36.82,0.83,231,74415,70,NULL,NULL,'2MASX J22460123-0645176',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'16.79',0.2,NULL,NULL,NULL,NULL,NULL,1,341.505125,-6.75494,0.077,NULL,50390221052,787347203,12302300,16.79),(157937,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 13024','RN',157937,43.24,0.49,3180,74416,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13024',0.402179,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157938,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 13024','RN',157938,44.2,0.57,4940,74416,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13024',0.402179,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157939,'Ring Diameter','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157939,32.4,0.84,30,74417,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7371',NULL,'1981ApJS...45..541P',1981,1,2,'HOLM 797B is a star.','G',0.000013,NULL,'12.50',2,'(R)SA(r)0/a:',NULL,NULL,NULL,NULL,1,341.515583,-11.00114,0.169,NULL,50382855171,787232112,12300501,12.5),(157940,'Tully est','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157940,32.47,0.8,31.2,74417,75,NULL,'B','NGC 7371',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157941,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157941,36.85,0.68,234,74418,70,NULL,NULL,'2MASX J22460399-0703358',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.87',0.19,NULL,NULL,NULL,NULL,NULL,1,341.51675,-7.05992,0.097,NULL,50389416622,787334634,12302103,16.87),(157942,'Magnitude','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157942,36.7,0.13,219,74419,100,NULL,NULL,'ABELL 2480',NULL,'1998A&A...337...31R',1998,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II     [BM]',NULL,NULL,NULL,NULL,1,341.519583,-17.68644,0.045,NULL,50450040534,788281883,12316904,NULL),(157943,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157943,32.91,0.8,38.2,74420,75,NULL,'MAT, I','ESO 603- G 012',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000007,NULL,'15.00',0.5,'SB(s)dm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,341.523708333,-19.41539,0.049,NULL,50219204207,784675065,12260547,15),(157944,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157944,32.57,0.32,32.7,74420,85,NULL,'I, raw','ESO 603- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157945,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157945,32.57,0.32,32.7,74420,85,NULL,'I, inv','ESO 603- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157946,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157946,32.84,0.43,36.9,74420,75,NULL,'MAT, I, raw','ESO 603- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157947,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157947,32.88,0.43,37.7,74420,75,NULL,'MAT, I, inv','ESO 603- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157948,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157948,33.08,0.43,41.3,74420,75,NULL,'MAT, I, cor','ESO 603- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157949,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157949,33.28,0.2,45.3,74420,74.4,NULL,NULL,'ESO 603- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157950,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157950,33.38,0.52,47.4,74420,NULL,NULL,NULL,'ESO 603- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157951,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157951,33.39,0.51,47.7,74420,NULL,NULL,'Malmquist cor.','ESO 603- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157952,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157952,33.64,0.49,53.5,74420,75,NULL,'IR','ESO 603- G 012',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157953,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157953,34.35,0.48,74.2,74421,70,NULL,NULL,'2MASX J22460696-0332506',NULL,'2014MNRAS.445.2677S',2014,1,0.81,NULL,'G',0.000147,NULL,'15.70',0.35,NULL,NULL,NULL,NULL,NULL,1,341.529125,-3.54731,0.113,NULL,49466183404,772909115,12076704,15.7),(157954,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157954,35.19,0.47,109,74422,70,NULL,NULL,'2MASX J22460778-7119244',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000077,NULL,'15.32',0.8,'SA0- pec',NULL,NULL,NULL,NULL,1,341.532667,-71.32344,0.009,NULL,49312509904,770507967,12039186,15.32),(157955,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157955,35.8,NULL,145,74423,NULL,NULL,'Dipole + Quadrupole + Octopole','FGCE 1776',NULL,'2010Ap&SS.325..163P',2010,1,0.9,NULL,'G',0.000057,NULL,'16.6',0.11,'Sd',NULL,NULL,NULL,NULL,1,341.541333,-37.04308,0,NULL,50702751203,792230487,12378601,16.6),(157956,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157956,35.83,NULL,147,74423,NULL,NULL,'Dipole + Quadrupole','FGCE 1776',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157957,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157957,35.87,NULL,149,74423,NULL,NULL,'Dipole','FGCE 1776',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157958,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157958,35.89,NULL,151,74423,NULL,NULL,NULL,'FGCE 1776',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157959,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157959,37.39,0.46,300,74424,70,NULL,NULL,'2MASX J22461376-0759238',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,341.557417,-7.98981,0.073,NULL,50397066062,787454157,12303971,17.2),(157960,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2006fx',NULL,157960,40.02,0.19,827,74425,72,NULL,'SDSS 13025','SDSS J224616.26+002458.4',0.22,'2009ApJ...704.1036F',2009,1,0.13,NULL,'G',NULL,NULL,'19.3g',0.1,NULL,NULL,NULL,NULL,NULL,1,341.567791667,0.41622,0.153,NULL,51680495312,807507739,12617308,19.3),(157961,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 13025','R',157961,40.35,0.19,962,74425,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006fx','SDSS J224616.26+002458.4',0.22,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157962,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 13025','R',157962,40.55,0.1,1060,74425,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006fx','SDSS J224616.26+002458.4',0.22,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157963,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2006fx',NULL,157963,40.27,0.09,1130,74425,70,NULL,'SALT 2','SDSS J224616.26+002458.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157964,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2006fx',NULL,157964,40.28,0.09,1140,74425,70,NULL,'SALT 2, Malmquist cor.','SDSS J224616.26+002458.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157965,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 05807','RN',157965,39.71,0.15,733,74426,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 05807',0.195487,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157966,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 05807','RN',157966,40.25,0.26,937,74426,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05807',0.195487,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157967,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157967,37.21,0.46,277,74427,70,NULL,NULL,'2MASX J22462243-0024546',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,341.593625,-0.41514,0.201,NULL,49469347632,772958556,12077477,18.1),(157968,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 20953',NULL,157968,40.14,0.32,1060,74428,70,NULL,'SN photometric redshift distance, z photo =0.289 +/- 0.056','SDSS-II SN 20953',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,341.5972917,-0.25122,0.201,NULL,49469413446,772959585,12077493,NULL),(157969,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 20953',NULL,157969,40.81,0.18,1450,74428,70,NULL,'SALT 2','SDSS-II SN 20953',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157970,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 20953',NULL,157970,40.85,0.18,1480,74428,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20953',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157971,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157971,36.7,0.33,219,74429,70,NULL,NULL,'2MASX J22462410+0046250',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000201,NULL,'16.1g',0.34,'E0',NULL,NULL,NULL,NULL,1,341.6005417,0.77347,0.277,NULL,51680784669,807512260,12617379,16.1),(157972,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157972,32.76,NULL,35.6,74430,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -02-58-003',NULL,'2010Ap&SS.325..163P',2010,1,2.05,NULL,'G',0.000007,NULL,'15.06',0.26,'Sm',NULL,NULL,NULL,NULL,1,341.6010417,-14.17992,0.141,NULL,50458656958,788416514,12319008,15.06),(157973,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157973,32.77,NULL,35.8,74430,NULL,NULL,'Dipole','MCG -02-58-003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157974,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157974,32.77,NULL,35.8,74430,NULL,NULL,'Dipole + Quadrupole','MCG -02-58-003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157975,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157975,32.92,0.43,38.3,74430,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-58-003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157976,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 16758','R',157976,41.08,0.23,1240,74431,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006pw','SN 2006pw',0.326503,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,341.612333333,1.15081,0.241,NULL,51680689578,807510774,12617355,NULL),(157977,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 16758','R',157977,41.15,0.32,1280,74431,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006pw','SN 2006pw',0.326503,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157978,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 14412','RN',157978,42.66,0.21,2460,74432,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 14412',0.386225,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157979,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 14412','RN',157979,42.67,0.17,2470,74432,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 14412',0.386225,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157980,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 01243',NULL,157980,39.32,0.81,731,74433,70,NULL,'SN photometric redshift distance, z photo =0.188 +/- 0.100','SDSS-II SN 01243',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.9g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,341.6599583,-0.76467,0.229,NULL,49469001088,772953142,12077392,21.9),(157981,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 01243','R',157981,40.34,0.27,976,74433,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 01243',0.198426,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157982,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 01243','R',157982,40.66,0.37,1130,74433,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 01243',0.198426,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157983,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157983,36.7,0.33,219,74434,70,NULL,NULL,'2MASX J22464099+0032360',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000168,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,341.670667,0.54342,0.277,NULL,51680453449,807507085,12617298,17),(157984,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157984,37.53,0.46,320,74435,70,NULL,NULL,'2MASX J22464171-0835013',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00017,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,341.673875,-8.58383,0.109,NULL,50396830445,787450475,12303913,16.7),(157985,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157985,37.44,0.46,307,74436,70,NULL,NULL,'SDSS J224647.57+002320.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000166,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,341.6982083,0.38897,0.225,NULL,51680477594,807507462,12617304,18.4),(157986,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157986,36.6,0.56,209,74437,70,NULL,NULL,'2MASX J22464877-2123141',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.07',0.33,NULL,NULL,NULL,NULL,NULL,1,341.70325,-21.38722,0.065,NULL,50227399960,784803124,12262548,16.07),(157987,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 20245','R',157987,40.58,0.27,1000,74438,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007pi','SN 2007pi',0.302,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,341.705541667,0.75631,0.277,NULL,51681231185,807519237,12617488,NULL),(157988,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 20245','R',157988,40.65,0.17,1030,74438,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007pi','SN 2007pi',0.302,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157989,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 13026','RN',157989,43.4,0.25,3130,74439,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13026',0.525576,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157990,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157990,35.15,0.57,107,74440,70,NULL,NULL,'IC 1453',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'15.29',0.3,NULL,NULL,NULL,NULL,NULL,1,341.725958333,-13.44961,0.145,NULL,50459053936,788422717,12319104,15.29),(157991,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 19220','R',157991,39.82,0.21,766,74441,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2007ox','SN 2007ox',0.203,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia?',NULL,NULL,NULL,NULL,1,341.742,-0.07181,0.205,NULL,49471294596,772988978,12077952,NULL),(157992,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 19220','R',157992,39.9,0.17,793,74441,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2007ox','SN 2007ox',0.203,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157993,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157993,36.46,0.65,196,74442,70,NULL,NULL,'2MASX J22465846-4556220',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,341.743666667,-45.93953,0,NULL,50690550916,792039858,12375622,15.3),(157994,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157994,36.68,0.57,216,74443,70,NULL,NULL,'6dF J2246595-455701',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,341.748083,-45.95036,0,NULL,50690551004,792039859,12375622,15.2),(157995,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157995,33.65,0.9,53.7,74444,NULL,NULL,'Malmquist cor.','ESO 238- G 026',NULL,'2009ApJS..182..474S',2009,1,0.91,NULL,'G',0.000033,NULL,'15.30',0.44,'Sb-c:',NULL,NULL,NULL,NULL,1,341.757625,-48.58508,0,NULL,50501720585,789089384,12329521,15.3),(157996,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157996,33.68,0.89,54.4,74444,NULL,NULL,NULL,'ESO 238- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157997,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157997,33.72,0.2,55.5,74444,74.4,NULL,NULL,'ESO 238- G 026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157998,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157998,33.52,0.2,50.6,74445,74.4,NULL,NULL,'UGC 12183',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.00013,NULL,'15.5',0.3,'S',NULL,NULL,NULL,NULL,1,341.765625,-0.07778,0.205,NULL,49471294123,772988970,12077952,15.5),(157999,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157999,33.7,0.53,54.9,74445,NULL,NULL,NULL,'UGC 12183',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158000,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',158000,33.72,0.49,55.4,74445,75,NULL,'IR','UGC 12183',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158001,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158001,33.82,0.5,58.2,74445,NULL,NULL,'Malmquist cor.','UGC 12183',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158002,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158002,36.65,0.65,214,74446,70,NULL,NULL,'LCRS B224410.5-453725',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.0001,NULL,'17.00',0.26,NULL,NULL,NULL,NULL,NULL,1,341.775583,-45.35967,0,NULL,50688904251,792014128,12375220,17),(158003,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158003,32.36,0.8,29.7,74447,75,NULL,'MAT, I','IC 5249',NULL,'1997ApJS..109..333W',1997,1,4.37,NULL,'G',0.000013,NULL,'14.31',0.43,'Sd',NULL,NULL,NULL,NULL,1,341.776167,-64.83203,0,NULL,48761387859,761896685,11904635,14.31),(158004,'Tully est','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158004,32.3,0.8,28.8,74447,75,NULL,NULL,'IC 5249',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158005,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158005,31.97,NULL,24.8,74447,NULL,NULL,NULL,'IC 5249',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158006,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158006,31.97,NULL,24.8,74447,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 5249',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158007,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158007,32,NULL,25.1,74447,NULL,NULL,'Dipole + Quadrupole','IC 5249',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158008,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158008,32,NULL,25.1,74447,NULL,NULL,'Dipole','IC 5249',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158009,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158009,32.37,0.32,29.8,74447,85,NULL,'I, inv','IC 5249',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158010,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158010,32.38,0.32,29.9,74447,85,NULL,'I, raw','IC 5249',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158011,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158011,32.49,0.4,31.5,74447,NULL,NULL,NULL,'IC 5249',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158012,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158012,32.51,0.2,31.8,74447,74.4,NULL,NULL,'IC 5249',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158013,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158013,32.51,0.4,31.8,74447,73,NULL,'opt','IC 5249',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158014,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158014,32.55,0.4,32.3,74447,73,NULL,'IR','IC 5249',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158015,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',158015,32.55,0.4,32.3,74447,75,NULL,NULL,'IC 5249',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158016,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158016,32.56,0.43,32.5,74447,75,NULL,'MAT, I, raw','IC 5249',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158017,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158017,32.59,0.43,33,74447,75,NULL,'MAT, I, inv','IC 5249',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158018,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158018,32.65,0.43,33.8,74447,75,NULL,'3.6 micron, color corrected','IC 5249',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158019,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158019,32.71,0.43,34.8,74447,75,NULL,'3.6 micron, color + selection bias corrected','IC 5249',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158020,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158020,32.84,0.43,37,74447,75,NULL,'MAT, I, cor','IC 5249',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158021,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',158021,32.88,0.49,37.6,74447,75,NULL,'IR','IC 5249',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158022,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158022,34.14,0.44,67.3,74448,NULL,NULL,NULL,'CGCG 495-024',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000033,NULL,'15.7',0.2,'Sa',NULL,NULL,NULL,NULL,1,341.776291667,31.53925,0.293,NULL,51915610785,811181418,12674709,15.7),(158023,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158023,34.21,0.2,69.5,74448,74.4,NULL,NULL,'CGCG 495-024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158024,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158024,34.47,0.37,78.2,74448,NULL,NULL,'Malmquist cor.','CGCG 495-024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158025,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158025,35.86,0.64,149,74449,70,NULL,NULL,'2MFGC 17138',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'12.0K',NULL,NULL,NULL,NULL,NULL,NULL,1,341.8079583,-45.02453,0,NULL,50688854103,792013345,12375208,12),(158026,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158026,31.17,0.43,17.2,74450,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2420',NULL,'2014MNRAS.444..527S',2014,1,0.93,NULL,'G',0.000033,NULL,'16.6',0.11,'Sdm',NULL,NULL,NULL,NULL,1,341.81,75.75528,1.581,NULL,52801117042,825017453,12890897,16.6),(158027,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158027,32.84,NULL,37.1,74450,NULL,NULL,NULL,'FGC 2420',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158028,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158028,32.86,NULL,37.3,74450,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2420',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158029,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158029,32.88,NULL,37.6,74450,NULL,NULL,'Dipole + Quadrupole','FGC 2420',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158030,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158030,32.89,NULL,37.9,74450,NULL,NULL,'Dipole','FGC 2420',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158031,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 10111','RN',158031,43.6,0.45,4320,74451,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 10111',0.213939,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158032,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 10111','RN',158032,43.8,0.86,4730,74451,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 10111',0.213939,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158033,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158033,31.97,0.45,24.8,74452,NULL,NULL,'K','IC 5250A',NULL,'2007A&A...465...71T',2007,1,2.8,NULL,'G',0.000047,NULL,'12.21',2.8,'S0 pec?','Pair member (points to parent)',NULL,NULL,NULL,1,341.822917,-65.05972,0,NULL,48761150785,761892981,11904577,12.21),(158034,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158034,33.14,0.4,42.4,74452,NULL,NULL,'mean','IC 5250A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158035,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158035,35.16,0.5,108,74453,70,NULL,NULL,'2MASX J22472501-1722217',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.000137,NULL,'15.76',0.5,'S0',NULL,NULL,NULL,NULL,1,341.854167,-17.37272,0.069,NULL,50449885448,788279460,12316866,15.76),(158036,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158036,34.68,0.8,86.3,74454,75,NULL,'W91PP, r','UGC 12185',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.50',0.8,'SB(s)ab',NULL,NULL,NULL,NULL,1,341.854417,31.37353,0.293,NULL,51915771596,811183931,12674748,14.5),(158037,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158037,34.88,0.4,94.4,74454,NULL,NULL,'mean','UGC 12185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158038,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158038,35.12,0.38,106,74454,75,NULL,'W91PP, r, raw','UGC 12185',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158039,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158039,35.18,0.38,108,74454,75,NULL,'W91PP, r, cor','UGC 12185',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158040,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158040,35.32,0.47,116,74454,NULL,NULL,'H','UGC 12185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158041,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158041,35.35,0.45,118,74454,NULL,NULL,'K','UGC 12185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158042,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158042,35.36,0.46,118,74454,NULL,NULL,'J','UGC 12185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158043,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158043,35.4,0.38,120,74454,75,NULL,'W91PP, r, inv','UGC 12185',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158044,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158044,35.42,0.57,121,74455,70,NULL,NULL,'2MASX J22472883-1207257',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'16.09',0.36,NULL,NULL,NULL,NULL,NULL,1,341.8702083,-12.12372,0.157,NULL,50423956547,787874321,12310536,16.09),(158045,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158045,36.67,0.98,216,74456,70,NULL,NULL,'2MASX J22472890-4348079',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'16.60',0.27,NULL,NULL,NULL,NULL,NULL,1,341.870375,-43.80217,0,NULL,50717717900,792464342,12382255,16.6),(158046,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 10298','RN',158046,40.54,0.2,1120,74457,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10298',0.14854,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158047,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 10298','RN',158047,41.38,0.3,1640,74457,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10298',0.14854,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158048,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 03426','RN',158048,40.48,0.22,1010,74458,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03426',0.232672,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158049,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 03426','RN',158049,40.72,0.18,1130,74458,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03426',0.232672,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158050,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 03426','N',158050,40.39,0.13,1200,74458,70,NULL,'SALT 2','SDSS-II SN 03426',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158051,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 03426','N',158051,40.4,0.13,1200,74458,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 03426',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158052,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',158052,36.05,0.46,162,74459,70,NULL,NULL,'2MASX J22473708+0023061',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000169,NULL,'16.4g',0.31,'E0',NULL,NULL,NULL,NULL,1,341.9045,0.385,0.245,NULL,51681665659,807526025,12617594,16.4),(158053,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',158053,35.92,0.46,153,74460,70,NULL,NULL,'2MASX J22473818-0812538',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000149,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,341.909167,-8.21514,0.073,NULL,50388463095,787319735,12301870,16.9),(158054,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158054,34.66,0.5,85.5,74461,70,NULL,NULL,'ESO 603- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000033,NULL,'14.63',0.5,'SAB(r)0/a',NULL,NULL,NULL,NULL,1,341.925333333,-17.34922,0.077,NULL,50449422530,788272227,12316753,14.63),(158055,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158055,35.13,0.48,106,74461,NULL,NULL,'Malmquist cor.','ESO 603- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158056,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158056,35.17,0.47,108,74461,NULL,NULL,'H','ESO 603- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158057,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158057,35.27,0.45,113,74461,NULL,NULL,'K','ESO 603- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158058,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158058,35.31,0.4,115,74461,NULL,NULL,'mean','ESO 603- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158059,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158059,35.33,0.46,117,74461,NULL,NULL,'J','ESO 603- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158060,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158060,35.35,0.44,117,74461,NULL,NULL,NULL,'ESO 603- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158061,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158061,35.39,0.2,120,74461,74.4,NULL,NULL,'ESO 603- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158062,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',158062,37.61,0.33,332,74462,70,NULL,NULL,'SDSS J224746.42-084439.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000167,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,341.9434583,-8.74422,0.101,NULL,50396875665,787451182,12303924,18.4),(158063,'Faber-Jackson','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158063,31.34,0.76,18.5,74463,95,NULL,'Weighted Mean','NGC 7377',NULL,'1984ApJS...56...91D',1984,1,3,NULL,'G',0.000037,NULL,'12.07',2.5,'SA(s)0+  poss. LINER','in a pair',NULL,NULL,NULL,1,341.947917,-22.31211,0.041,NULL,50227111925,784798623,12262478,12.07),(158064,'Faber-Jackson','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158064,31.34,0.76,18.5,74463,95,NULL,'de Vaucouleurs','NGC 7377',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158065,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158065,33.05,0.49,40.7,74463,70,NULL,NULL,'NGC 7377',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158066,'Tertiary','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158066,32.66,0.5,34,74463,95,NULL,NULL,'NGC 7377',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158067,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158067,32,0.45,25.1,74463,NULL,NULL,'K','NGC 7377',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158068,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158068,33.27,0.4,45,74463,NULL,NULL,'mean','NGC 7377',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158069,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158069,31.96,0.43,24.6,74464,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7378',NULL,'2014MNRAS.444..527S',2014,1,1.4,NULL,'G',0.00002,NULL,'13.64',0.9,'(R\')SB(r)ab?   Sy2',NULL,NULL,NULL,'Sy 2',1,341.94875,-11.81664,0.133,NULL,50373591201,787087362,12298240,13.64),(158070,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158070,32.14,0.4,26.8,74464,73,NULL,'opt','NGC 7378',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158071,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158071,32.19,0.43,27.4,74464,75,NULL,'3.6 micron, color corrected','NGC 7378',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158072,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158072,32.34,0.2,29.4,74464,74.4,NULL,NULL,'NGC 7378',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158073,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158073,32.36,0.64,29.6,74464,NULL,NULL,NULL,'NGC 7378',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158074,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158074,32.42,0.63,30.4,74464,NULL,NULL,'Malmquist cor.','NGC 7378',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158075,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158075,32.59,0.4,33,74464,NULL,NULL,'mean','NGC 7378',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158076,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158076,32.73,0.45,35.1,74464,NULL,NULL,'K','NGC 7378',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158077,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158077,32.8,0.47,36.3,74464,NULL,NULL,'H','NGC 7378',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158078,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158078,32.81,0.46,36.5,74464,NULL,NULL,'J','NGC 7378',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158079,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',158079,36.87,0.46,236,74465,70,NULL,NULL,'2MASX J22475368+1305475',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,341.973583,13.0965,0.181,NULL,52601551698,821899245,12842175,17.6),(158080,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158080,36.19,0.64,173,74466,70,NULL,NULL,'2MASX J22475368-0410503',NULL,'2014MNRAS.445.2677S',2014,1,0.32,NULL,'G',0.00015,NULL,'16.87',0.29,NULL,NULL,NULL,NULL,NULL,1,341.973667,-4.18058,0.105,NULL,49466963592,772921306,12076895,16.87),(158081,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',158081,37.61,0.33,332,74467,70,NULL,NULL,'2MASX J22475679-0844548',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,341.986625,-8.74872,0.101,NULL,50396876363,787451193,12303924,17.7),(158082,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 21697','RN',158082,38.88,0.24,519,74468,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 21697',0.146873,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158083,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 21697','RN',158083,38.93,0.26,532,74468,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 21697',0.146873,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158084,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158084,34.91,0.8,95.8,74469,75,NULL,'W91PP, r','UGC 12190',NULL,'1997ApJS..109..333W',1997,1,2.18,NULL,'G',0.000023,NULL,'15.36',0.22,'Sbc','Isolated galaxy',NULL,NULL,NULL,1,342.027083,28.29269,0.241,NULL,51941331758,811583308,12680989,15.36),(158085,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',158085,34.96,0.49,98.3,74469,75,NULL,'IR','UGC 12190',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158086,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158086,35.15,0.38,107,74469,75,NULL,'W91PP, r, raw','UGC 12190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158087,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158087,35.17,NULL,108,74469,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12190',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158088,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158088,35.18,NULL,109,74469,NULL,NULL,'Dipole + Quadrupole','UGC 12190',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158089,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158089,35.19,NULL,109,74469,NULL,NULL,'Dipole','UGC 12190',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158090,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158090,35.23,NULL,111,74469,NULL,NULL,NULL,'UGC 12190',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158091,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158091,35.25,0.38,112,74469,75,NULL,'W91PP, r, cor','UGC 12190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158092,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158092,35.42,0.38,122,74469,75,NULL,'W91PP, r, inv','UGC 12190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158093,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158093,36.88,0.81,238,74470,70,NULL,NULL,'2MFGC 17150',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'17.18',0.14,NULL,NULL,NULL,NULL,NULL,1,342.0535417,-4.33994,0.105,NULL,49464086593,772876353,12076193,17.18),(158094,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',158094,36.66,0.46,215,74471,70,NULL,NULL,'2MASX J22481405-0902304',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00015,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,342.058375,-9.04178,0.093,NULL,50383280651,787238760,12300605,16.5),(158095,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 17692','RN',158095,39.32,0.3,640,74472,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17692',0.144548,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158096,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 17692','RN',158096,39.56,0.26,714,74472,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17692',0.144548,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158097,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',158097,37.39,0.46,300,74473,70,NULL,NULL,'2MASX J22481748+0009483',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,342.072875,0.16339,0.245,NULL,51678782376,807480974,12616890,17.6),(158098,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158098,36.68,0.56,217,74474,70,NULL,NULL,'ESO 147-IG 009 NED02',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.00015,NULL,'16.12',1.5,'E2: pec',NULL,NULL,NULL,NULL,1,342.0889583,-58.34147,0,NULL,48844647015,763197609,11924962,16.12),(158099,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',158099,37.04,0.46,256,74475,70,NULL,NULL,'2MASX J22482187+1400017',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,342.091125,14.00047,0.121,NULL,52603243301,821925676,12842588,17.8),(158100,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2006jg',NULL,158100,40.59,0.22,1310,74476,70,NULL,'Hubble residual 0.21 for z0.33000','SDSS-II SN 13934 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,342.110458333,-0.43514,0.281,NULL,49471441863,772991279,12077988,NULL),(158101,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 13934','R',158101,41.42,0.3,1450,74476,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006jg','SDSS-II SN 13934 HOST',0.330932,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158102,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 13934','R',158102,41.65,0.29,1600,74476,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006jg','SDSS-II SN 13934 HOST',0.330932,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158103,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',158103,37.54,0.46,323,74477,70,NULL,NULL,'2MASX J22482881-0946123',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000143,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,342.12025,-9.77028,0.121,NULL,50383662478,787244726,12300698,17.9),(158104,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 14074',NULL,158104,40.13,0.34,1060,74478,70,NULL,'SN photometric redshift distance, z photo =0.288 +/- 0.059','SDSS-II SN 14074',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,342.1259583,-0.82528,0.253,NULL,49471792380,772996755,12078074,NULL),(158105,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 14074','R',158105,40.76,0.24,1130,74478,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14074',0.26192,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158106,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 14074','R',158106,40.78,0.17,1130,74478,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14074',0.26192,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158107,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 14074',NULL,158107,40.66,0.14,1360,74478,70,NULL,'SALT 2','SDSS-II SN 14074',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158108,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 14074',NULL,158108,40.68,0.14,1370,74478,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14074',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158109,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158109,36.39,0.86,189,74479,70,NULL,NULL,'LCRS B224538.2-452750',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00011,NULL,'16.99',0.27,NULL,NULL,NULL,NULL,NULL,1,342.1389583,-45.19947,0,NULL,50688932148,792014564,12375227,16.99),(158110,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158110,32.39,0.8,30,74480,75,NULL,'MAT, I','ESO 346- G 001',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.000033,NULL,'14.57',0.34,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,342.141,-39.649,0,NULL,50715159475,792424366,12381630,14.57),(158111,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158111,30.95,NULL,15.5,74480,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 346- G 001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158112,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158112,30.99,NULL,15.8,74480,NULL,NULL,'Dipole + Quadrupole','ESO 346- G 001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158113,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158113,31.01,NULL,16,74480,NULL,NULL,'Dipole','ESO 346- G 001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158114,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158114,31.09,NULL,16.5,74480,NULL,NULL,NULL,'ESO 346- G 001',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158115,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158115,32.39,0.08,30.1,74480,NULL,NULL,NULL,'ESO 346- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158116,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158116,32.58,0.4,32.8,74480,NULL,NULL,'mean','ESO 346- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158117,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158117,32.72,0.43,35,74480,75,NULL,'3.6 micron, color + selection bias corrected','ESO 346- G 001',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158118,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158118,32.74,0.32,35.3,74480,85,NULL,'I, raw','ESO 346- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158119,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158119,32.74,0.32,35.3,74480,85,NULL,'I, inv','ESO 346- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158120,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158120,32.83,0.4,36.9,74480,75,NULL,NULL,'ESO 346- G 001',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158121,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158121,32.85,0.43,37.1,74480,75,NULL,'MAT, I, raw','ESO 346- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158122,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158122,32.91,0.43,38.2,74480,75,NULL,'3.6 micron, color corrected','ESO 346- G 001',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158123,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158123,32.92,0.43,38.3,74480,75,NULL,'MAT, I, inv','ESO 346- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158124,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158124,32.96,0.43,39.1,74480,75,NULL,'MAT, I, cor','ESO 346- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158125,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158125,32.96,0.47,39.1,74480,NULL,NULL,'H','ESO 346- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158126,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158126,33.09,0.2,41.5,74480,74.4,NULL,NULL,'ESO 346- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158127,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158127,33.15,0.49,42.7,74480,75,NULL,'IR','ESO 346- G 001',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158128,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 02481','RN',158128,40.69,0.21,1200,74481,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 02481',0.147189,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158129,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 02481','RN',158129,41.26,0.28,1560,74481,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 02481',0.147189,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158130,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158130,35.5,0.8,126,74482,75,NULL,'W91PP, r','UGC 12191',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000067,NULL,'14.67',0.7,'Sb','Pair member (points to parent)',NULL,NULL,NULL,1,342.169417,27.61169,0.177,NULL,51939909870,811561091,12680642,14.67),(158131,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158131,34.58,0.38,82.2,74482,75,NULL,'W91PP, r, raw','UGC 12191',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158132,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158132,34.71,0.38,87.5,74482,75,NULL,'W91PP, r, inv','UGC 12191',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158133,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158133,34.83,0.38,92.4,74482,75,NULL,'W91PP, r, cor','UGC 12191',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158134,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158134,35.13,0.42,106,74482,NULL,NULL,'Malmquist cor.','UGC 12191',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158135,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158135,35.22,0.4,111,74482,NULL,NULL,NULL,'UGC 12191',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158136,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158136,35.26,0.2,113,74482,74.4,NULL,NULL,'UGC 12191',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158137,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 08236','RN',158137,40.63,0.18,1120,74483,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 08236',0.193779,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158138,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 08236','N',158138,40.48,0.37,1250,74483,70,NULL,'SALT 2','SDSS-II SN 08236',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158139,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 08236','N',158139,40.49,0.37,1250,74483,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 08236',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158140,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 08236','RN',158140,41.4,0.29,1590,74483,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 08236',0.193779,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158141,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158141,34.21,0.2,69.5,74484,74.4,NULL,NULL,'ESO 468- G 028',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.00015,NULL,'15.83',0.2,'Sb-c',NULL,NULL,NULL,NULL,1,342.204083333,-27.60764,0.034,NULL,50129035355,783266177,12238534,15.83),(158142,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158142,34.43,0.53,76.7,74484,NULL,NULL,NULL,'ESO 468- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158143,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158143,34.63,0.48,84.4,74484,NULL,NULL,'Malmquist cor.','ESO 468- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158144,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158144,36.5,0.33,200,74485,70,NULL,NULL,'SDSS J224849.15-100326.2',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000198,NULL,'17.9g',0.11,NULL,NULL,NULL,NULL,NULL,1,342.204833,-10.05728,0.101,NULL,50383578696,787243417,12300678,17.9),(158145,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 13890','RN',158145,41.16,0.15,1310,74486,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13890',0.297799,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158146,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 13890','RN',158146,41.44,0.28,1500,74486,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13890',0.297799,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158147,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158147,36.48,0.46,198,74487,70,NULL,NULL,'2MASX J22485063-0029380',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,342.211,-0.49403,0.281,NULL,49467989712,772937339,12077145,17.4),(158148,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158148,35.6,0.8,132,74488,75,NULL,'W91PP, r','UGC 12194',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000017,NULL,'15.44',0.5,'S?',NULL,NULL,NULL,NULL,1,342.211875,27.96264,0.241,NULL,51941365780,811583840,12680997,15.44),(158149,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158149,35.24,0.42,112,74488,NULL,NULL,'Malmquist cor.','UGC 12194',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158150,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158150,35.38,0.38,119,74488,75,NULL,'W91PP, r, raw','UGC 12194',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158151,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158151,35.45,0.38,123,74488,NULL,NULL,NULL,'UGC 12194',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158152,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158152,35.53,0.38,127,74488,75,NULL,'W91PP, r, cor','UGC 12194',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158153,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158153,35.56,0.38,129,74488,75,NULL,'W91PP, r, inv','UGC 12194',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158154,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158154,35.67,0.2,136,74488,74.4,NULL,NULL,'UGC 12194',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158155,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158155,34.96,0.49,98.4,74489,75,NULL,'IR','UGC 12197',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000057,NULL,'17.',0.2,'Sbc',NULL,NULL,NULL,NULL,1,342.217458333,24.83797,0.265,NULL,51904363856,811005685,12671963,17),(158156,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158156,35.23,0.2,111,74489,74.4,NULL,NULL,'UGC 12197',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158157,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158157,35.3,0.39,115,74489,NULL,NULL,'Malmquist cor.','UGC 12197',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158158,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158158,35.36,0.38,118,74489,NULL,NULL,NULL,'UGC 12197',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158159,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158159,34.71,0.2,87.5,74490,70,NULL,NULL,'GIN 673',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.000043,NULL,'16.07',NULL,'S',NULL,NULL,NULL,NULL,1,342.2314583,11.34214,0.125,NULL,52433087309,819266989,12801046,16.07),(158160,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158160,34.75,NULL,89.1,74491,NULL,NULL,'B, Hubble-type-TF','ESO 147- G 010',NULL,'2004ApJ...607..241R',2004,1,1.28,NULL,'G',0.000033,NULL,'15.70',0.22,'Sbc? pec sp',NULL,NULL,NULL,NULL,1,342.239833333,-57.89569,0,NULL,48844226609,763191040,11924860,15.7),(158161,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158161,34.75,NULL,89.1,74491,NULL,NULL,'B','ESO 147- G 010',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158162,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158162,34.75,NULL,89.1,74491,NULL,NULL,'I','ESO 147- G 010',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158163,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158163,34.76,0.26,89.5,74491,NULL,NULL,'B, Hubble-type-TF','ESO 147- G 010',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158164,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158164,35.02,NULL,101,74491,NULL,NULL,'B','ESO 147- G 010',NULL,'2004ApJ...607..241R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158165,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158165,35.25,NULL,112,74491,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 147- G 010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158166,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158166,35.26,NULL,113,74491,NULL,NULL,'Dipole + Quadrupole','ESO 147- G 010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158167,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158167,35.27,NULL,113,74491,NULL,NULL,'Dipole','ESO 147- G 010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158168,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158168,35.3,NULL,115,74491,NULL,NULL,NULL,'ESO 147- G 010',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158169,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158169,35.35,0.49,118,74491,75,NULL,'IR','ESO 147- G 010',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158170,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158170,35.93,0.35,154,74491,NULL,NULL,'Malmquist cor.','ESO 147- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158171,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158171,36.06,0.33,163,74491,NULL,NULL,NULL,'ESO 147- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158172,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158172,36.1,0.2,166,74491,74.4,NULL,NULL,'ESO 147- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158173,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 21814','R',158173,38.18,0.12,393,74492,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007sf','SN 2007sf',0.101906,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,342.2462917,1.20608,0.245,NULL,51682082588,807532540,12617695,NULL),(158174,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 21814','R',158174,38.25,0.18,405,74492,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007sf','SN 2007sf',0.101906,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158175,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158175,37.35,0.46,295,74493,70,NULL,NULL,'2MASX J22485977-0002219',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000179,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,342.249041667,-0.03942,0.261,NULL,49468072240,772938628,12077166,16.6),(158176,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158176,35.93,0.54,154,74494,70,NULL,NULL,'FAIRALL 0142',NULL,'2014MNRAS.445.2677S',2014,1,0.93,NULL,'G',0.00015,NULL,'15.79',0.35,'S0',NULL,NULL,NULL,NULL,1,342.25875,-59.63983,0,NULL,48794345121,762411642,11912681,15.79),(158177,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 10299',NULL,158177,39.77,0.36,901,74495,70,NULL,'SN photometric redshift distance, z photo =0.238 +/- 0.050','SDSS-II SN 10299',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.3g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,342.264167,0.9935,0.265,NULL,51682195273,807534301,12617723,21.3),(158178,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 10299','R',158178,40.94,0.3,1230,74495,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 10299',0.261248,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158179,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 10299','R',158179,41.05,0.19,1290,74495,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 10299',0.261248,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158180,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158180,34.25,0.47,70.9,74496,NULL,NULL,'H','UGC 12199',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00002,NULL,'14.27',0.9,'SB(rs)b        LINER',NULL,NULL,NULL,NULL,1,342.2667083,40.00117,0.561,NULL,55522722193,867542534,13555352,14.27),(158181,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158181,34.29,0.69,72,74496,100,NULL,'mid-IR','UGC 12199',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158182,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158182,34.32,0.45,73.3,74496,NULL,NULL,'K','UGC 12199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158183,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158183,34.41,0.46,76.2,74496,NULL,NULL,'J','UGC 12199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158184,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158184,34.6,0.4,83.2,74496,NULL,NULL,'mean','UGC 12199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158185,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158185,34.47,0.46,78.3,74497,70,NULL,NULL,'MCG -03-58-006',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.000117,NULL,'14.94',0.2,'E/S0',NULL,NULL,NULL,NULL,1,342.270583333,-16.59194,0.069,NULL,50452360422,788318131,12317470,14.94),(158186,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158186,35.62,0.6,133,74498,70,NULL,NULL,'ESO 027- G 016',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'15.47',0.4,'S...',NULL,NULL,NULL,NULL,1,342.275375,-81.29569,0.413,NULL,48350056681,755469635,11804213,15.47),(158187,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158187,34.07,0.8,65.1,74499,75,NULL,'W91PP, r','UGC 12201',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000017,NULL,'14.91',0.3,'Sab            LINER',NULL,NULL,NULL,NULL,1,342.2885,34.99028,0.381,NULL,55452749113,866449204,13538268,14.91),(158188,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158188,34.19,0.38,68.9,74499,75,NULL,'W91PP, r, raw','UGC 12201',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158189,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158189,34.22,0.49,70,74499,75,NULL,'IR','UGC 12201',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158190,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158190,34.34,0.38,73.9,74499,75,NULL,'W91PP, r, inv','UGC 12201',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158191,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158191,34.35,0.37,74,74499,NULL,NULL,NULL,'UGC 12201',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158192,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158192,34.44,0.2,77.3,74499,74.4,NULL,NULL,'UGC 12201',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158193,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158193,34.47,0.35,78.3,74499,NULL,NULL,'Malmquist cor.','UGC 12201',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158194,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158194,34.5,0.38,79.3,74499,75,NULL,'W91PP, r, cor','UGC 12201',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158195,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158195,34.52,0.25,80.2,74500,74.4,NULL,NULL,'KUG 2246+112',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000033,NULL,'14.62',0.4,'S',NULL,NULL,NULL,NULL,1,342.29275,11.54978,0.133,NULL,52433250423,819269537,12801086,14.62),(158196,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158196,34.71,0.2,87.5,74500,70,NULL,NULL,'KUG 2246+112',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158197,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158197,35.62,0.44,133,74501,NULL,NULL,'Malmquist cor.','UGC 12198',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000013,NULL,'15.65',0.2,'S?',NULL,NULL,NULL,NULL,1,342.2955,27.86525,0.241,NULL,51939491025,811554547,12680539,15.65),(158198,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158198,35.91,0.39,152,74501,NULL,NULL,NULL,'UGC 12198',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158199,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158199,35.96,0.2,156,74501,74.4,NULL,NULL,'UGC 12198',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158200,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 10448',NULL,158200,40,0.88,998,74502,70,NULL,'SN photometric redshift distance, z photo =0.268 +/- 0.173','SDSS-II SN 10448',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','22.1g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,342.305625,-0.82508,0.189,NULL,49471607958,772993874,12078029,22.1),(158201,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 10448','R',158201,41.86,0.46,1640,74502,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 10448',0.43386,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158202,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 11411','RN',158202,40.45,0.27,1010,74503,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 11411',0.214081,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158203,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 11411','RN',158203,40.72,0.43,1150,74503,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 11411',0.214081,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158204,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 05039','RN',158204,39.38,0.12,693,74504,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 05039',0.082711,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158205,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 05039','RN',158205,39.86,0.24,867,74504,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 05039',0.082711,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158206,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158206,35.51,0.8,127,74505,75,NULL,'CF, r','UGC 12200',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'14.65',0.6,'Sb',NULL,NULL,NULL,NULL,1,342.33475,19.289,0.217,NULL,52567790894,821371732,12833933,14.65),(158207,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158207,35.66,0.38,135,74505,75,NULL,'CF, r, raw','UGC 12200',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158208,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158208,35.8,0.4,145,74505,NULL,NULL,'mean','UGC 12200',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158209,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158209,35.9,0.38,151,74505,75,NULL,'CF, r, inv','UGC 12200',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158210,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158210,35.97,0.38,156,74505,75,NULL,'CF, r, cor','UGC 12200',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158211,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158211,36.03,0.47,161,74505,NULL,NULL,'H','UGC 12200',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158212,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158212,36.11,0.46,167,74505,NULL,NULL,'J','UGC 12200',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158213,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158213,36.12,0.45,167,74505,NULL,NULL,'K','UGC 12200',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158214,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158214,36.5,0.33,200,74506,70,NULL,NULL,'2MASX J22492103-1004394',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000103,NULL,'15.9g',0.37,'E0',NULL,NULL,NULL,NULL,1,342.337583,-10.07747,0.149,NULL,50375995081,787124923,12298826,15.9),(158215,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158215,34.51,0.25,79.8,74507,74.4,NULL,NULL,'GIN 671',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000157,NULL,'15.20',NULL,'S',NULL,NULL,NULL,NULL,1,342.339833,11.93222,0.149,NULL,52554868621,821169822,12830778,15.2),(158216,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158216,34.71,0.2,87.5,74507,70,NULL,NULL,'GIN 671',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158217,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158217,34.62,0.49,83.8,74508,75,NULL,'IR','UGC 12204',NULL,'2011yCatp016004901K',2011,1,1.75,NULL,'G',0.000037,NULL,'16.0',0.19,'Sbc',NULL,NULL,NULL,NULL,1,342.3474583,40.23286,0.613,NULL,55522875761,867544933,13555389,16),(158218,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158218,34.79,NULL,90.7,74508,NULL,NULL,'Dipole','UGC 12204',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158219,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158219,34.8,NULL,91.2,74508,NULL,NULL,'Dipole + Quadrupole','UGC 12204',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158220,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158220,34.8,NULL,91.3,74508,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12204',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158221,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158221,35.03,NULL,101,74508,NULL,NULL,NULL,'UGC 12204',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158222,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158222,35.11,0.43,105,74508,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12204',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158223,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158223,35.16,0.43,108,74508,75,NULL,'3.6 micron, color corrected','UGC 12204',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158224,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158224,35.16,0.5,108,74508,NULL,NULL,'Malmquist cor.','UGC 12204',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158225,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158225,35.35,0.2,117,74508,74.4,NULL,NULL,'UGC 12204',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158226,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158226,35.6,0.41,132,74508,NULL,NULL,NULL,'UGC 12204',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158227,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158227,37.11,0.46,265,74509,70,NULL,NULL,'2MASX J22492389+0050065',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000189,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,342.3495,0.83519,0.245,NULL,51681959885,807530623,12617665,17.7),(158228,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158228,37.49,0.46,315,74510,70,NULL,NULL,'2MASX J22492415-0801384',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000166,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,342.350583,-8.02725,0.085,NULL,50389200603,787331259,12302050,17.2),(158229,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158229,38.31,0.46,458,74511,70,NULL,NULL,'SDSS J224924.85+144642.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,342.353583,14.77839,0.157,NULL,52603458894,821929045,12842641,18.5),(158230,'GRB','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158230,40.26,NULL,1130,74512,70,NULL,'Pseudo z = 0.31','GRB 020903',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,342.354167,-20.89972,0.045,NULL,50221088676,784704510,12261007,NULL),(158231,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158231,34.52,0.25,80.2,74513,74.4,NULL,NULL,'GIN 664',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000033,NULL,'14.69',0.4,'S','Group member',NULL,NULL,NULL,1,342.3554583,11.59236,0.133,NULL,52433195880,819268685,12801073,14.69),(158232,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158232,34.71,0.2,87.5,74513,70,NULL,NULL,'GIN 664',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158233,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158233,36.14,0.55,169,74514,70,NULL,NULL,'2MASX J22492658-3725086',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.37',0.35,'S0',NULL,NULL,NULL,NULL,1,342.360917,-37.41911,NULL,NULL,50702171120,792221423,12378459,16.37),(158234,'GRB','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158234,40.29,0.13,914,74515,72,NULL,NULL,'XRF 020903',0.25,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,342.354167,-20.89972,0.045,NULL,50221088676,784704510,12261007,NULL),(158235,'GRB','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158235,40.65,1.29,1080,74515,72,NULL,NULL,'XRF 020903',0.25,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158236,'GRB','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158236,40.79,1.14,1150,74515,70,NULL,NULL,'XRF 020903',0.25,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158237,'GRB','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158237,42.23,1.16,2230,74515,69.7,NULL,'Calibrated','XRF 020903',0.25,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158238,'GRB','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158238,43.07,1.26,3290,74515,69.7,NULL,'Fiducial','XRF 020903',0.25,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158239,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 20648','RN',158239,40.05,0.23,936,74516,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 20648',0.095343,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158240,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 20648','RN',158240,40.87,0.28,1370,74516,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20648',0.095343,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158241,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158241,34.75,0.8,89.1,74517,75,NULL,'W91PP, r','UGC 12206',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.000033,NULL,'14.7',1.5,'SB(rs)a',NULL,NULL,NULL,NULL,1,342.387,33.36039,0.361,NULL,55451722365,866433161,13538018,14.7),(158242,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158242,34.25,0.38,70.8,74517,75,NULL,'W91PP, r, raw','UGC 12206',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158243,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158243,34.45,0.38,77.8,74517,75,NULL,'W91PP, r, inv','UGC 12206',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158244,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158244,34.48,0.47,78.7,74517,NULL,NULL,'H','UGC 12206',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158245,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158245,34.56,0.38,81.6,74517,75,NULL,'W91PP, r, cor','UGC 12206',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158246,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158246,34.73,0.45,88.2,74517,NULL,NULL,'K','UGC 12206',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158247,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158247,34.77,0.46,90.1,74517,NULL,NULL,'J','UGC 12206',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158248,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158248,34.87,0.4,94.3,74517,NULL,NULL,'mean','UGC 12206',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158249,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 03212','RN',158249,40.94,0.16,1220,74518,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03212',0.264424,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158250,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 03212','RN',158250,41.47,0.23,1560,74518,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03212',0.264424,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158251,'Faber-Jackson','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158251,35.29,0.52,114,74519,95,NULL,'Weighted Mean','NGC 7383',NULL,'1984ApJS...56...91D',1984,1,0.8,NULL,'G',0.000027,NULL,'14.7',0.7,'SB0','in a pair',NULL,NULL,NULL,1,342.398417,11.55639,0.133,NULL,52433167780,819268246,12801066,14.7),(158252,'Faber-Jackson','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158252,36.28,0.63,180,74519,95,NULL,'Michard 1979b, c','NGC 7383',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158253,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158253,34.52,0.25,80.2,74519,74.4,NULL,NULL,'NGC 7383',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158254,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158254,34.71,0.2,87.5,74519,70,NULL,NULL,'NGC 7383',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158255,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158255,35.16,0.45,108,74520,NULL,NULL,'K','MCG -03-58-007',NULL,'2007A&A...465...71T',2007,1,0.5,NULL,'G',0.00005,NULL,'14.84',0.4,'(R\')SAB(s)0/a  Sy2',NULL,NULL,NULL,'Sy 1 h',1,342.4047917,-19.274,0.037,NULL,50440990071,788140469,12314694,14.84),(158256,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158256,35.39,0.47,119,74520,NULL,NULL,'H','MCG -03-58-007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158257,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158257,35.55,0.4,129,74520,NULL,NULL,'mean','MCG -03-58-007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158258,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158258,35.65,0.46,135,74520,NULL,NULL,'J','MCG -03-58-007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158259,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158259,34.51,0.25,79.8,74521,74.4,NULL,NULL,'NGC 7384',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'*',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,342.4272917,11.48744,0.133,NULL,52433161957,819268155,12801064,NULL),(158260,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 07435','RN',158260,39.4,0.26,623,74522,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 07435',0.219521,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158261,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 07435','RN',158261,40.58,0.27,1070,74522,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 07435',0.219521,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158262,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 15262','R',158262,39.14,0.28,540,74523,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 15262',0.247673,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,342.43275,-0.40417,0.273,NULL,49468441234,772944394,12077256,NULL),(158263,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 15262','R',158263,39.52,0.3,643,74523,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 15262',0.247673,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158264,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158264,34.71,0.2,87.5,74524,70,NULL,NULL,'GIN 666',NULL,'2001MNRAS.321..277C',2001,1,0.9,NULL,'G',0.000033,NULL,'14.71',0.7,'E','Group member',NULL,NULL,NULL,1,342.441667,11.55239,0.133,NULL,52433174448,819268350,12801067,14.71),(158265,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158265,36.75,0.46,223,74525,70,NULL,NULL,'2MASX J22494604-0855102',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000103,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,342.4417083,-8.91953,0.101,NULL,50375704563,787120383,12298755,16.7),(158266,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158266,35.12,0.44,106,74526,NULL,NULL,'Malmquist cor.','2MFGC 17171',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',NULL,NULL,'11.8K',0.1,NULL,NULL,NULL,NULL,NULL,1,342.446791667,34.94942,0.381,NULL,55452866213,866451034,13538297,11.8),(158267,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158267,35.51,0.37,127,74526,NULL,NULL,NULL,'2MFGC 17171',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158268,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158268,35.82,0.2,146,74526,74.4,NULL,NULL,'2MFGC 17171',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158269,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158269,36.06,0.46,163,74527,70,NULL,NULL,'2MASX J22494889+0057425',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000163,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,342.453667,0.96183,0.237,NULL,51681876849,807529325,12617645,16.7),(158270,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 11914','RN',158270,39.5,0.73,716,74528,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 11914',0.110491,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158271,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158271,35.51,0.57,127,74529,NULL,NULL,'Malmquist cor.','ESO 049- G 006',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.16',0.6,'SA(rs)bc:',NULL,NULL,NULL,NULL,1,342.475958333,-73.02658,0.061,NULL,48448065544,757001024,11828141,14.16),(158272,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158272,35.64,0.54,135,74529,NULL,NULL,NULL,'ESO 049- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158273,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158273,35.69,0.2,137,74529,74.4,NULL,NULL,'ESO 049- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158274,'D-Sigma','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158274,34.49,0.4,78.9,74530,75,NULL,'Edat, raw','NGC 7385',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'13.05',1.3,'cD;E pec:;     LERG','in a pair',NULL,'FR I','Flat-Spectrum Radio Source',1,342.4774583,11.60856,0.149,NULL,52433163437,819268178,12801065,13.05),(158275,'D-Sigma','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158275,34.82,0.4,92.1,74530,75,NULL,'Edat, cor','NGC 7385',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158276,'Faber-Jackson','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158276,33.86,0.42,59.2,74530,95,NULL,'Weighted Mean','NGC 7385',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158277,'Faber-Jackson','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158277,34.18,0.46,68.5,74530,95,NULL,'Michard 1979a','NGC 7385',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158278,'Faber-Jackson','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158278,34.35,0.63,74.1,74530,95,NULL,'Michard 1979b, c','NGC 7385',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158279,'Faber-Jackson','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158279,37.25,1.61,282,74530,55,NULL,'Visvanathan & Sandage 1979','NGC 7385',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158280,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158280,34.52,0.25,80.2,74530,74.4,NULL,NULL,'NGC 7385',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158281,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158281,34.71,0.2,87.5,74530,70,NULL,NULL,'NGC 7385',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158282,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158282,38.18,0.46,433,74531,70,NULL,NULL,'2MASX J22495698+0108237',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000164,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,342.4874583,1.13981,0.225,NULL,51681902377,807529724,12617651,17.9),(158283,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 16055','RN',158283,39.18,0.34,622,74532,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 16055',0.101448,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158284,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 16055','RN',158284,39.68,0.52,785,74532,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 16055',0.101448,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158285,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158285,35.82,0.75,146,74533,70,NULL,NULL,'2MASX J22495732-3732544',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'16.74',0.31,NULL,NULL,NULL,NULL,NULL,1,342.488375,-37.54828,NULL,NULL,50704108393,792251693,12378932,16.74),(158286,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 03607','RN',158286,39.67,0.19,788,74534,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 03607',0.089187,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158287,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158287,35.15,0.5,107,74535,70,NULL,NULL,'2MASX J22500101-8037307',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.0b',0.19,NULL,NULL,NULL,NULL,NULL,1,342.504041667,-80.62525,0.457,NULL,48555521660,758680025,11854375,16),(158288,'Faber-Jackson','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158288,33.87,0.44,59.4,74536,95,NULL,'Weighted Mean','NGC 7386',NULL,'1984ApJS...56...91D',1984,1,1.4,NULL,'G',0.000033,NULL,'13.32',1.2,'cD;SA0:','in a pair',NULL,NULL,NULL,1,342.5089583,11.69836,0.149,NULL,52433187273,819268551,12801071,13.32),(158289,'Faber-Jackson','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158289,34.24,0.46,70.5,74536,95,NULL,'Michard 1979a','NGC 7386',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158290,'Faber-Jackson','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158290,34.66,0.63,85.5,74536,95,NULL,'Michard 1979b, c','NGC 7386',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158291,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158291,34.51,0.25,79.8,74536,74.4,NULL,NULL,'NGC 7386',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158292,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158292,34.71,0.2,87.5,74536,70,NULL,NULL,'NGC 7386',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158293,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158293,35,0.4,100,74536,NULL,NULL,'mean','NGC 7386',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158294,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158294,35.09,0.45,104,74536,NULL,NULL,'K','NGC 7386',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158295,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158295,35.84,0.67,147,74537,70,NULL,NULL,'2MASX J22500630-0745266',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,342.5262083,-7.75744,0.073,NULL,50388690821,787323294,12301926,15),(158296,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 05468',NULL,158296,39.99,0.25,995,74538,70,NULL,'SN photometric redshift distance, z photo =0.267 +/- 0.038','SDSS-II SN 05468',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,342.530667,0.40475,0.285,NULL,51679049990,807485156,12616955,NULL),(158297,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158297,36.45,0.7,195,74539,70,NULL,NULL,'2MASX J22501227-2118324',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'16.26',0.18,NULL,NULL,NULL,NULL,NULL,1,342.551167,-21.30889,0.045,NULL,50229180554,784830946,12262983,16.26),(158298,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 18666',NULL,158298,40.35,0.17,1180,74540,70,NULL,'SN photometric redshift distance, z photo =0.326 +/- 0.033','SDSS-II SN 18666',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,342.564417,0.19475,0.285,NULL,51678929573,807483274,12616926,NULL),(158299,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 18666',NULL,158299,41.08,0.18,1640,74540,70,NULL,'SALT 2','SDSS-II SN 18666',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158300,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 18666',NULL,158300,41.11,0.18,1670,74540,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18666',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158301,'Faber-Jackson','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158301,33.87,0.52,59.4,74541,95,NULL,'Weighted Mean','NGC 7389',NULL,'1984ApJS...56...91D',1984,1,1.1,NULL,'G',0.000093,NULL,'14.78',0.9,'SB0','Group member',NULL,NULL,NULL,1,342.566875,11.56619,0.149,NULL,52433871373,819279240,12801238,14.78),(158302,'Faber-Jackson','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158302,34.55,0.63,81.3,74541,95,NULL,'Michard 1979b, c','NGC 7389',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158303,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158303,37.66,0.46,340,74542,70,NULL,NULL,'2MASX J22501621+1433208',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000174,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,342.5675,14.55583,0.169,NULL,52603645724,821931964,12842686,17),(158304,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158304,37.03,0.46,255,74543,70,NULL,NULL,'2MASX J22501723-0031236',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,342.571875,-0.52325,0.213,NULL,49468624996,772947265,12077301,17.7),(158305,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158305,34.51,0.25,79.8,74544,74.4,NULL,NULL,'NGC 7387',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000037,NULL,'15.0',0.4,'S0-:','Group member',NULL,NULL,NULL,1,342.5735,11.63672,0.149,NULL,52433134499,819267726,12801058,15),(158306,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158306,34.71,0.2,87.5,74544,70,NULL,NULL,'NGC 7387',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158307,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158307,37.45,0.46,309,74545,70,NULL,NULL,'2MASX J22501776-0940576',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000156,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,342.574167,-9.68253,0.121,NULL,50376658105,787135282,12298988,17),(158308,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158308,34.53,0.25,80.5,74546,74.4,NULL,NULL,'NGC 7390',NULL,'2013AJ....146...86T',2013,1,1,'1977A&A....59...23S has V = 7763 +- 150 km/s.','G',0.000033,NULL,'15.12',0.8,'S0?','Group member',NULL,NULL,NULL,1,342.58175,11.53103,0.149,NULL,52433904883,819279763,12801246,15.12),(158309,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158309,34.71,0.2,87.5,74546,70,NULL,NULL,'NGC 7390',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158310,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158310,34.95,0.53,97.9,74547,70,NULL,NULL,'2MASX J22502168-2021044',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'15.63',0.68,'SA(rl)0^0',NULL,NULL,NULL,NULL,1,342.590375,-20.35125,0.053,NULL,50221323312,784708176,12261065,15.63),(158311,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158311,34.64,0.53,84.6,74548,70,NULL,NULL,'6dF J2250240-365126',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'13.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,342.599958333,-36.85728,NULL,NULL,50704493707,792257714,12379026,13.7),(158312,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158312,35.34,0.5,117,74549,70,NULL,NULL,'2MASX J22502534-3732413',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'15.87',0.5,'E',NULL,NULL,NULL,NULL,1,342.605667,-37.54478,NULL,NULL,50704117135,792251830,12378934,15.87),(158313,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158313,32.36,0.55,29.7,74550,NULL,NULL,'Malmquist cor.','UGC 12221',NULL,'2009ApJS..182..474S',2009,1,2.3,NULL,'G',0.000037,NULL,'14.60',0.7,'SA(s)d','Isolated galaxy',NULL,NULL,NULL,1,342.606625,82.87703,0.561,NULL,52660298969,822817171,12856518,14.6),(158314,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158314,32.45,0.4,30.9,74550,NULL,NULL,'mean','UGC 12221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158315,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158315,32.45,0.53,30.9,74550,NULL,NULL,NULL,'UGC 12221',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158316,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158316,32.49,0.2,31.5,74550,74.4,NULL,NULL,'UGC 12221',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158317,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158317,32.54,0.4,32.2,74550,75,NULL,'B','UGC 12221',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158318,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158318,32.6,0.46,33.1,74550,NULL,NULL,'J','UGC 12221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158319,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158319,32.7,0.47,34.7,74550,NULL,NULL,'H','UGC 12221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158320,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158320,32.75,0.45,35.5,74550,NULL,NULL,'K','UGC 12221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158321,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 16606','R',158321,40.33,0.26,951,74551,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16606',0.225601,'2014arXiv1401.3317S',2014,1,0.09,NULL,'G',NULL,'PHOT','22.1g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,342.611,1.22269,0.225,NULL,51681950489,807530476,12617663,22.1),(158322,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 16606','R',158322,40.37,0.22,965,74551,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16606',0.225601,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158323,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 16606',NULL,158323,39.93,0.33,966,74551,70,NULL,'SN photometric redshift distance, z photo =0.258 +/- 0.050','SDSS-II SN 16606',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158324,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 16606',NULL,158324,40.15,0.17,1070,74551,70,NULL,'SALT 2','SDSS-II SN 16606',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158325,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 16606',NULL,158325,40.17,0.17,1080,74551,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16606',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158326,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158326,36.03,0.69,160,74552,70,NULL,NULL,'2MASX J22502916-0451063',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'16.86',0.23,NULL,NULL,NULL,NULL,NULL,1,342.6217917,-4.85175,0.109,NULL,49464373307,772880832,12076263,16.86),(158327,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 14446','RN',158327,41.63,0.44,1620,74553,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14446',0.308083,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158328,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 14446','RN',158328,42.35,0.28,2260,74553,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14446',0.308083,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158329,'Tully est','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158329,30.84,0.8,14.7,74554,75,NULL,NULL,'UGC 12212',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.000007,NULL,'16.0',0.9,'Sm:',NULL,NULL,NULL,NULL,1,342.626375,29.13844,0.245,NULL,51926613421,811353334,12677395,16),(158330,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158330,31.93,0.4,24.3,74554,NULL,NULL,NULL,'UGC 12212',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158331,'D-Sigma','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158331,33.64,0.4,53.5,74555,75,NULL,'Edat, raw','NGC 7391',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00003,NULL,'13.08',1.5,'E:',NULL,NULL,NULL,NULL,1,342.6505417,-1.54483,0.209,NULL,49470089919,772970154,12077658,13.08),(158332,'D-Sigma','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158332,33.98,0.4,62.5,74555,75,NULL,'Edat, cor','NGC 7391',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158333,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158333,33.67,0.5,54.3,74555,70,NULL,NULL,'NGC 7391',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158334,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158334,33.01,0.4,40,74555,NULL,NULL,'mean','NGC 7391',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158335,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158335,33.82,0.45,58.2,74555,NULL,NULL,'K','NGC 7391',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158336,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 01334','RN',158336,42.44,0.09,2150,74556,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01334',0.431265,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158337,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158337,36.09,NULL,166,74557,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2425',NULL,'2010Ap&SS.325..163P',2010,1,0.64,NULL,'G',0.000014,NULL,'17.1',0.09,'Sc',NULL,NULL,NULL,NULL,1,342.6540417,12.23533,0.129,NULL,52554794660,821168666,12830760,17.1),(158338,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158338,36.1,NULL,166,74557,NULL,NULL,'Dipole + Quadrupole','FGC 2425',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158339,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158339,36.12,NULL,168,74557,NULL,NULL,'Dipole','FGC 2425',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158340,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158340,36.18,NULL,172,74557,NULL,NULL,NULL,'FGC 2425',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158341,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158341,36.23,0.32,176,74557,NULL,NULL,'Malmquist cor.','FGC 2425',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158342,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158342,36.35,0.3,186,74557,NULL,NULL,NULL,'FGC 2425',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158343,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158343,36.43,0.2,193,74557,74.4,NULL,NULL,'FGC 2425',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158344,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158344,36.05,0.58,162,74558,70,NULL,NULL,'2MASX J22503952-4929395',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.55',0.24,NULL,NULL,NULL,NULL,NULL,1,342.664666667,-49.49428,0,NULL,50502667816,789104184,12329752,16.55),(158345,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158345,36.82,0.52,231,74559,70,NULL,NULL,'2MASX J22504125-0542102',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'16.15',0.47,NULL,NULL,NULL,NULL,NULL,1,342.671917,-5.703,0.089,NULL,50340047865,786563247,12290050,16.15),(158346,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 20582','RN',158346,42.12,0.26,1910,74560,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 20582',0.392504,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158347,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158347,38.58,0.46,519,74561,70,NULL,NULL,'2MASX J22505385+1454002',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,342.724375,14.89997,0.181,NULL,52611547920,822055436,12844616,18.5),(158348,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158348,37.9,0.46,380,74562,70,NULL,NULL,'2MASX J22505755-0017031',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,342.73975,-0.28419,0.205,NULL,49467705133,772932892,12077076,17.1),(158349,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158349,35.37,0.42,118,74563,NULL,NULL,'Malmquist cor.','KUG 2248+117',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.00006,NULL,'15.25',0.4,'S?',NULL,NULL,NULL,NULL,1,342.745833,12.05614,0.129,NULL,52555585152,821181018,12830953,15.25),(158350,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158350,35.44,0.41,123,74563,NULL,NULL,NULL,'KUG 2248+117',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158351,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158351,35.55,0.2,129,74563,74.4,NULL,NULL,'KUG 2248+117',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158352,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158352,36.83,0.67,232,74564,70,NULL,NULL,'LCRS B224806.3-453431',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'17.38',0.21,NULL,NULL,NULL,NULL,NULL,1,342.7535,-45.30983,0,NULL,50508322253,789192535,12331133,17.38),(158353,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158353,33.03,0.8,40.3,74565,75,NULL,'MAT, I','ESO 603- G 020',NULL,'1997ApJS..109..333W',1997,1,1.79,'Confused HIPASS source','G',0.000017,NULL,'15.00',0.17,'S pec sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,342.75575,-20.26856,0.053,NULL,50221433386,784709896,12261092,15),(158354,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158354,33.07,0.49,41.2,74565,75,NULL,'IR','ESO 603- G 020',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158355,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158355,33.09,0.32,41.4,74565,85,NULL,'I, raw','ESO 603- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158356,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158356,33.09,0.32,41.4,74565,85,NULL,'I, inv','ESO 603- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158357,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158357,33.23,0.43,44.3,74565,75,NULL,'MAT, I, raw','ESO 603- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158358,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158358,33.26,NULL,44.8,74565,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 603- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158359,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158359,33.28,NULL,45.3,74565,NULL,NULL,'Dipole + Quadrupole','ESO 603- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158360,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158360,33.28,0.43,45.4,74565,75,NULL,'MAT, I, inv','ESO 603- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158361,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158361,33.29,NULL,45.5,74565,NULL,NULL,'Dipole','ESO 603- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158362,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158362,33.41,0.74,48.1,74565,NULL,NULL,'Malmquist cor.','ESO 603- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158363,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158363,33.41,0.74,48.2,74565,NULL,NULL,NULL,'ESO 603- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158364,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158364,33.42,0.43,48.4,74565,75,NULL,'MAT, I, cor','ESO 603- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158365,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158365,33.46,0.2,49.2,74565,74.4,NULL,NULL,'ESO 603- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158366,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158366,33.66,NULL,53.8,74565,NULL,NULL,NULL,'ESO 603- G 020',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158367,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158367,37.46,0.6,311,74566,70,NULL,NULL,'2MASX J22510319-0424081',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'16.89',0.39,NULL,NULL,NULL,NULL,NULL,1,342.7634583,-4.40236,0.129,NULL,49463748091,772871063,12076110,16.89),(158368,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158368,35.86,0.53,149,74567,70,NULL,NULL,'2MASX J22510440-1837298',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.00015,NULL,'15.79',0.33,'E',NULL,NULL,NULL,NULL,1,342.768333,-18.62497,0.041,NULL,50444195741,788190558,12315477,15.79),(158369,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158369,34.71,0.2,87.5,74568,70,NULL,NULL,'GIN 670',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.000043,NULL,'15.49',NULL,'E',NULL,NULL,NULL,NULL,1,342.787667,11.25531,0.141,NULL,52433809177,819278268,12801222,15.49),(158370,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158370,37.48,0.25,313,74568,74.4,NULL,NULL,'GIN 670',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158371,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158371,34.58,0.8,82.5,74569,75,NULL,'W91PP, r','UGC 12218',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.00002,NULL,'14.90',0.4,'Im?            HII',NULL,NULL,NULL,NULL,1,342.840333,32.35044,0.353,NULL,51924001437,811312522,12676758,14.9),(158372,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158372,34.92,0.38,96.3,74569,75,NULL,'W91PP, r, raw','UGC 12218',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158373,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158373,34.99,0.38,99.5,74569,75,NULL,'W91PP, r, cor','UGC 12218',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158374,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158374,35.09,0.38,104,74569,75,NULL,'W91PP, r, inv','UGC 12218',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158375,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158375,36.35,0.46,186,74570,70,NULL,NULL,'2MASX J22512726+1452364',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000147,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,342.86375,14.87667,0.181,NULL,52611551833,822055497,12844617,17.5),(158376,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158376,37.78,0.46,360,74571,70,NULL,NULL,'2MASX J22512790+1434454',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,342.86625,14.57928,0.141,NULL,52603942502,821936601,12842759,17.8),(158377,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158377,34.52,0.25,80.2,74572,74.4,NULL,NULL,'GIN 669',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000037,NULL,'14.41',NULL,'E',NULL,NULL,NULL,NULL,1,342.867083,11.63192,0.173,NULL,52433647456,819275741,12801183,14.41),(158378,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158378,34.71,0.2,87.5,74572,70,NULL,NULL,'GIN 669',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158379,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158379,37.44,0.46,307,74573,70,NULL,NULL,'2MASX J22512845-0023552',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,342.868625,-0.39869,0.209,NULL,49467799208,772934362,12077099,18.2),(158380,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 07099','R',158380,40.03,0.19,831,74574,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07099',0.218886,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,342.8882083,1.16736,0.209,NULL,51678310412,807473600,12616775,NULL),(158381,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 07099','R',158381,40.14,0.1,876,74574,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07099',0.218886,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158382,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 20830','RN',158382,41.6,0.42,1800,74575,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20830',0.162058,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158383,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 20830','RN',158383,41.7,0.35,1880,74575,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20830',0.162058,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158384,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158384,32.82,0.47,36.7,74576,NULL,NULL,'H','NGC 7393',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000027,NULL,'13.42',0.9,'SB(rs)c pec    HII',NULL,NULL,NULL,NULL,1,342.9087083,-5.55731,0.093,NULL,49517991727,773718620,12089353,13.42),(158385,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158385,32.84,0.46,37,74576,NULL,NULL,'J','NGC 7393',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158386,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158386,32.85,0.2,37.2,74576,74.4,NULL,NULL,'NGC 7393',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158387,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158387,32.89,0.45,37.9,74576,NULL,NULL,'K','NGC 7393',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158388,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158388,33.05,0.42,40.7,74576,NULL,NULL,NULL,'NGC 7393',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158389,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158389,33.17,0.4,43.1,74576,NULL,NULL,'Malmquist cor.','NGC 7393',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158390,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158390,33.39,0.4,47.6,74576,NULL,NULL,'mean','NGC 7393',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158391,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158391,35.78,0.67,143,74577,70,NULL,NULL,'2MASX J22514146-4810544',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'17.02',0.17,NULL,NULL,NULL,NULL,NULL,1,342.9227083,-48.18172,0,NULL,50514095686,789282745,12332542,17.02),(158392,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158392,38.42,0.46,483,74578,70,NULL,NULL,'2MASX J22514694+1401517',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000177,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,342.9454583,14.03094,0.133,NULL,52604791196,821949862,12842966,17.8),(158393,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158393,32.64,0.51,33.7,74579,70,NULL,NULL,'NGC 7392',NULL,'2014MNRAS.445.2677S',2014,1,2.1,NULL,'G',0.000033,NULL,'12.63',1.3,'(R\':)SB(rs)ab  HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,342.953083,-20.60808,0.045,NULL,50221496158,784710877,12261107,12.63),(158394,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158394,33.01,0.8,40.1,74579,75,NULL,'MAT, I','NGC 7392',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158395,'Sosies','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158395,33.18,0.09,43.3,74579,NULL,NULL,NULL,'NGC 7392',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158396,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158396,32.56,0.69,32.5,74579,100,NULL,'mid-IR','NGC 7392',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158397,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158397,33.12,0.43,42,74579,75,NULL,'MAT, I, raw','NGC 7392',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158398,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158398,33.18,0.32,43.3,74579,85,NULL,'I, raw','NGC 7392',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158399,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158399,33.26,0.32,44.8,74579,85,NULL,'I, inv','NGC 7392',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158400,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158400,33.31,0.43,45.9,74579,75,NULL,'MAT, I, cor','NGC 7392',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158401,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158401,33.35,NULL,46.8,74579,NULL,NULL,'I','NGC 7392',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158402,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158402,33.36,NULL,47,74579,NULL,NULL,'B','NGC 7392',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158403,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158403,33.39,0.2,47.6,74579,74.4,NULL,NULL,'NGC 7392',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158404,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158404,33.42,0.43,48.3,74579,75,NULL,'MAT, I, inv','NGC 7392',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158405,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158405,33.48,0.36,49.7,74579,NULL,NULL,'Malmquist cor.','NGC 7392',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158406,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158406,33.55,0.35,51.2,74579,NULL,NULL,NULL,'NGC 7392',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158407,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158407,35.06,0.8,103,74580,75,NULL,'MAT, I','ESO 027- G 017',NULL,'1997ApJS..109..333W',1997,1,1.34,NULL,'G',0.000033,NULL,'15.91',0.18,'Sc',NULL,NULL,NULL,NULL,1,342.9977917,-80.83583,0.461,NULL,48555412886,758678326,11854348,15.91),(158408,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158408,34.71,0.43,87.4,74580,75,NULL,'MAT, I, raw','ESO 027- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158409,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158409,34.74,0.32,88.8,74580,85,NULL,'I, raw','ESO 027- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158410,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158410,34.77,0.32,89.9,74580,85,NULL,'I, inv','ESO 027- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158411,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158411,34.83,0.49,92.7,74580,75,NULL,'IR','ESO 027- G 017',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158412,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158412,34.86,0.43,93.7,74580,75,NULL,'MAT, I, inv','ESO 027- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158413,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158413,35,NULL,99.8,74580,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 027- G 017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158414,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158414,35.01,NULL,100,74580,NULL,NULL,'Dipole + Quadrupole','ESO 027- G 017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158415,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158415,35.02,NULL,101,74580,NULL,NULL,'Dipole','ESO 027- G 017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158416,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158416,35.05,NULL,102,74580,NULL,NULL,NULL,'ESO 027- G 017',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158417,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158417,35.14,0.43,106,74580,75,NULL,'MAT, I, cor','ESO 027- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158418,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158418,35.31,0.57,116,74580,NULL,NULL,'Malmquist cor.','ESO 027- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158419,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158419,35.44,0.54,122,74580,NULL,NULL,NULL,'ESO 027- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158420,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158420,35.48,0.2,125,74580,74.4,NULL,NULL,'ESO 027- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158421,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158421,36.37,0.46,188,74581,70,NULL,NULL,'2MASX J22520303-0855164',NULL,'2015arXiv151105856S',2015,1,0.49,'Star superposed 10\\\" northwest of the nucleus.','G',0.00015,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,343.0125,-8.92136,0.113,NULL,50377966948,787155733,12299308,16.5),(158422,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158422,37.3,0.33,288,74582,70,NULL,NULL,'2MASX J22520798-0941194',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000167,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,343.033125,-9.68883,0.129,NULL,50376548502,787133570,12298962,17.9),(158423,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158423,34.93,0.46,97,74583,70,NULL,NULL,'MCG -03-58-008',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00009,NULL,'14.83',0.3,NULL,NULL,NULL,NULL,NULL,1,343.0452083,-14.86797,0.097,NULL,50463247929,788488248,12320128,14.83),(158424,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 00820','RN',158424,41.53,0.19,1520,74584,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00820',0.330027,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158425,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 00820','RN',158425,41.67,0.11,1620,74584,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 00820',0.330027,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158426,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158426,37.3,0.33,288,74585,70,NULL,NULL,'2MASX J22521258-0943404',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00015,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,343.0525,-9.72778,0.129,NULL,50376303552,787129743,12298902,16.5),(158427,'CMD','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'N',158427,18.8,NULL,0.058,74586,NULL,NULL,'DES J2251.2 _5836','Tucana II',NULL,'2015ApJ...807...50B',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158428,'CMD','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'N',158428,19.2,NULL,0.069,74586,NULL,NULL,NULL,'Tucana II',NULL,'2015ApJ...805..130K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158429,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158429,37.75,0.46,354,74587,70,NULL,NULL,'2MASX J22521603+1310508',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,343.066833,13.18092,0.165,NULL,52601094066,821892094,12842063,17.8),(158430,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158430,38.23,0.46,442,74588,70,NULL,NULL,'2MASX J22521639+0111152',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000183,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,343.068375,1.18756,0.197,NULL,51733095556,808329618,12630150,17.7),(158431,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 20052','RN',158431,40.18,0.09,940,74589,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 20052',0.157665,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158432,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 20052','RN',158432,40.53,0.22,1100,74589,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 20052',0.157665,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158433,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158433,35.02,0.49,101,74590,75,NULL,'IR','ESO 534- G 029',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000033,NULL,'15.49',0.23,'Sc:',NULL,NULL,NULL,NULL,1,343.078166667,-26.33794,0.068,NULL,50109485141,782960705,12233761,15.49),(158434,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 19468',NULL,158434,41.53,0.05,2020,74591,70,NULL,'SN photometric redshift distance, z photo =0.669 +/- 0.026','SDSS-II SN 19468',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,343.08275,-0.84603,0.217,NULL,49468220957,772940952,12077202,NULL),(158435,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 15943','RN',158435,40.09,0.3,837,74592,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 15943',0.246411,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158436,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 15943','RN',158436,40.1,0.29,841,74592,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 15943',0.246411,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158437,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158437,33.42,0.69,48.3,74593,100,NULL,'mid-IR','NGC 7396',NULL,'2013ApJ...771...88L',2013,1,1.9,NULL,'G',0.000077,NULL,'13.75',1.1,'Sa pec sp','Group member',NULL,NULL,NULL,1,343.094333,1.09239,0.197,NULL,51733300050,808332813,12630200,13.75),(158438,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158438,34.35,0.62,74.2,74593,NULL,NULL,'Malmquist cor.','NGC 7396',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158439,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158439,34.75,0.52,88.9,74593,NULL,NULL,NULL,'NGC 7396',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158440,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158440,34.79,0.2,90.8,74593,74.4,NULL,NULL,'NGC 7396',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158441,'SNII optical','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SN 1993S',NULL,158441,35.32,0.14,109,74594,NULL,NULL,'SEAM','2MASX J22522390-4018432',0.033009,'2009ApJ...694.1067P',2009,1,0.77,NULL,'G',0.00005,NULL,'15.72',0.37,'S',NULL,NULL,NULL,NULL,1,343.09925,-40.31164,NULL,NULL,50711182702,792362229,12380659,15.72),(158442,'SNII optical','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SN 1993S',NULL,158442,35.48,0.06,125,74594,NULL,NULL,'I, photospheric magnitude method','2MASX J22522390-4018432',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158443,'SNII optical','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SN 1993S',NULL,158443,35.62,0.1,133,74594,NULL,NULL,'V, photospheric magnitude method','2MASX J22522390-4018432',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158444,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158444,37.81,0.46,365,74595,70,NULL,NULL,'2MASX J22522811+0017402',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000179,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,343.11725,0.2945,0.277,NULL,51732580219,808321565,12630024,16.7),(158445,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158445,36.85,0.46,235,74596,70,NULL,NULL,'2MASX J22523160-0023561',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000136,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,343.131625,-0.39892,0.217,NULL,49513857706,773654026,12088344,18.1),(158446,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158446,35.11,0.62,105,74597,NULL,NULL,'Malmquist cor.','UGC 12222',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.78',0.8,'Sb',NULL,NULL,NULL,NULL,1,343.136291667,11.662,0.149,NULL,52433757413,819277459,12801210,14.78),(158447,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158447,35.37,0.55,119,74597,NULL,NULL,NULL,'UGC 12222',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158448,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158448,35.52,0.4,127,74597,NULL,NULL,'mean','UGC 12222',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158449,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158449,35.73,0.2,140,74597,74.4,NULL,NULL,'UGC 12222',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158450,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158450,35.79,0.47,144,74597,NULL,NULL,'H','UGC 12222',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158451,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158451,35.86,0.45,148,74597,NULL,NULL,'K','UGC 12222',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158452,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158452,35.88,0.46,150,74597,NULL,NULL,'J','UGC 12222',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158453,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158453,37.67,0.46,341,74598,70,NULL,NULL,'2MASX J22523719+0006058',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000142,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,343.154875,0.10153,0.189,NULL,51732559187,808321237,12630019,17.9),(158454,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 09603','RN',158454,42.5,0.28,2070,74599,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 09603',0.533326,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158455,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 15675','R',158455,40.42,0.21,981,74600,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J225241.58+002149.6',0.2345,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',0.0005,NULL,'20.7g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,343.1732917,0.36381,0.277,NULL,51732760135,808324377,12630068,20.7),(158456,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 15675','R',158456,40.61,0.16,1070,74600,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J225241.58+002149.6',0.2345,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158457,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 15675',NULL,158457,40.3,0.11,1150,74600,70,NULL,'SALT 2','SDSS J225241.58+002149.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158458,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 15675',NULL,158458,40.31,0.11,1150,74600,70,NULL,'SALT 2, Malmquist cor.','SDSS J225241.58+002149.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158459,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 10121','R',158459,37.78,0.42,354,74601,70,NULL,'SDSS CAND. Variable; MLCS2K2','NGC 7398',0.015718,'2014arXiv1401.3317S',2014,1,1.21,'1999ApJS..121..287H has z = 0.034707 +- 0.000167.','G',0.000162,NULL,'14.3g',0.85,'SA(r)a:','Group member',NULL,NULL,NULL,1,343.205291667,1.20111,0.185,NULL,51733311061,808332985,12630202,14.3),(158460,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158460,34.14,0.37,67.4,74601,NULL,NULL,'Malmquist cor.','NGC 7398',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158461,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158461,34.15,0.37,67.7,74601,NULL,NULL,NULL,'NGC 7398',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158462,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158462,34.34,0.2,73.8,74601,74.4,NULL,NULL,'NGC 7398',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158463,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158463,36.68,0.46,217,74602,70,NULL,NULL,'2MASX J22525004-0057172',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,343.208333,-0.95492,0.217,NULL,49514216925,773659639,12088431,17.3),(158464,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158464,36.96,0.77,247,74603,70,NULL,NULL,'2MASX J22525345-0556352',NULL,'2014MNRAS.445.2677S',2014,1,0.74,NULL,'G',0.00015,NULL,'15.87',0.36,NULL,NULL,NULL,NULL,NULL,1,343.22275,-5.94314,0.109,NULL,49484644951,773197577,12081212,15.87),(158465,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 13393',NULL,158465,40.01,0.25,1000,74604,70,NULL,'SN photometric redshift distance, z photo =0.270 +/- 0.040','SDSS-II SN 13393',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.6g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,343.2379583,0.61747,0.229,NULL,51732740432,808324069,12630063,22.6),(158466,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158466,36.87,0.46,236,74605,70,NULL,NULL,'2MASX J22530486+0024289',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.0002,NULL,'15.9g',0.16,'AGN',NULL,NULL,NULL,NULL,1,343.2702917,0.40814,0.257,NULL,51732764311,808324442,12630069,15.9),(158467,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158467,35.69,0.54,137,74606,70,NULL,NULL,'2MASX J22530542-1836520',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.82',0.47,'E',NULL,NULL,NULL,NULL,1,343.2725417,-18.61433,0.045,NULL,50443126999,788173859,12315216,15.82),(158468,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158468,34.2,0.49,69,74607,75,NULL,'IR','UGC 12229',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.43',0.4,'S?',NULL,NULL,NULL,NULL,1,343.2842917,32.76356,0.377,NULL,51910273601,811098025,12673406,15.43),(158469,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 11100','RN',158469,39.85,0.27,771,74608,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 11100',0.210047,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158470,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 11100','RN',158470,40.29,0.19,944,74608,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 11100',0.210047,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158471,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 16563','R',158471,40.22,0.24,822,74609,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16563',0.345032,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,343.305583,-0.09531,0.189,NULL,49497042965,773391296,12084239,NULL),(158472,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 16563','R',158472,40.36,0.32,879,74609,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16563',0.345032,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158473,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158473,38.07,0.46,411,74610,70,NULL,NULL,'2MASXi J2253200-080420',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000177,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,343.3337917,-8.07261,0.101,NULL,50370775698,787043370,12297552,17.6),(158474,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158474,34.6,0.8,83.1,74611,75,NULL,'W91PP, r','NGC 7407',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000033,NULL,'13.95',0.9,'Sbc',NULL,NULL,NULL,NULL,1,343.337,32.13067,0.297,NULL,51924667588,811322931,12676920,13.95),(158475,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158475,34.6,0.8,83.3,74611,75,NULL,'CF, r','NGC 7407',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158476,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158476,34.48,0.38,78.7,74611,75,NULL,'W91PP, r, raw','NGC 7407',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158477,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158477,34.56,0.38,81.7,74611,75,NULL,'CF, r, raw','NGC 7407',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158478,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158478,34.71,0.38,87.4,74611,75,NULL,'W91PP, r, cor','NGC 7407',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158479,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158479,34.73,0.38,88.4,74611,75,NULL,'W91PP, r, inv','NGC 7407',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158480,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158480,34.75,0.38,89.3,74611,75,NULL,'CF, r, cor','NGC 7407',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158481,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158481,34.77,0.38,89.9,74611,75,NULL,'CF, r, inv','NGC 7407',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158482,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158482,34.98,0.3,99.2,74611,NULL,NULL,'Malmquist cor.','NGC 7407',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158483,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158483,35.15,0.2,107,74611,74.4,NULL,NULL,'NGC 7407',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158484,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158484,35.17,0.28,108,74611,NULL,NULL,NULL,'NGC 7407',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158485,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 13028','RN',158485,41.75,0.17,1780,74612,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13028',0.259389,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158486,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 13028','RN',158486,42.08,0.2,2060,74612,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13028',0.259389,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158487,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158487,36.53,0.46,202,74613,70,NULL,NULL,'2MASX J22533240+0037152',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,343.3849583,0.62089,0.229,NULL,51732757086,808324329,12630067,17),(158488,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158488,33.43,0.8,48.6,74614,75,NULL,'W91PP, r','UGC 12231',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.8',0.6,'SBcd:','Group member',NULL,NULL,NULL,1,343.386958333,31.61958,0.253,NULL,51925455037,811335234,12677113,14.8),(158489,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158489,33.66,0.38,54,74614,75,NULL,'W91PP, r, inv','UGC 12231',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158490,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158490,33.75,0.38,56.3,74614,75,NULL,'W91PP, r, raw','UGC 12231',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158491,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158491,34.14,0.38,67.4,74614,75,NULL,'W91PP, r, cor','UGC 12231',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158492,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158492,36.54,0.58,203,74615,70,NULL,NULL,'2MASX J22533388-1652151',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.00015,NULL,'16.09',0.39,NULL,NULL,NULL,NULL,NULL,1,343.3912917,-16.87075,0.073,NULL,50464396360,788506193,12320409,16.09),(158493,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 13076',NULL,158493,40.27,0.23,1130,74616,70,NULL,'SN photometric redshift distance, z photo =0.311 +/- 0.042','SDSS-II SN 13076',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,343.392458333,0.18808,0.217,NULL,51699034334,807797411,12621834,NULL),(158494,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158494,37.03,0.91,255,74617,70,NULL,NULL,'2MASX J22533800-0248128',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'17.11',0.14,NULL,NULL,NULL,NULL,NULL,1,343.408375,-2.80364,0.189,NULL,49514918264,773670597,12088603,17.11),(158495,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 05244','RN',158495,43.25,0.21,2730,74618,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05244',0.636791,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158496,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158496,37.27,0.46,284,74619,70,NULL,NULL,'SDSS J225339.97+002320.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'18.0g',0.16,'BLAGN',NULL,NULL,NULL,'Sy 1',1,343.4165417,0.389,0.217,NULL,51732778087,808324657,12630072,18),(158497,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158497,35.28,0.99,114,74620,NULL,NULL,'Malmquist cor.','ESO 603- G 025',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.37',0.7,'Sc',NULL,NULL,NULL,NULL,1,343.4202083,-17.47889,0.041,NULL,50451135206,788298987,12317171,15.37),(158498,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158498,35.77,0.79,142,74620,NULL,NULL,NULL,'ESO 603- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158499,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158499,35.81,0.2,145,74620,74.4,NULL,NULL,'ESO 603- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158500,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158500,34.56,0.8,81.8,74621,75,NULL,'W91PP, r','UGC 12234',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'13.48',0.7,'Sbc',NULL,NULL,NULL,NULL,1,343.4202083,33.70914,0.301,NULL,51910316685,811098698,12673417,13.48),(158501,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158501,34.58,0.8,82.5,74621,75,NULL,'CF, r','UGC 12234',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158502,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158502,33.7,0.43,55,74621,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12234',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158503,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158503,33.88,0.38,59.7,74621,75,NULL,'W91PP, r, raw','UGC 12234',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158504,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158504,34.12,0.38,66.7,74621,75,NULL,'W91PP, r, inv','UGC 12234',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158505,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158505,34.18,0.38,68.5,74621,75,NULL,'CF, r, raw','UGC 12234',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158506,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158506,34.26,0.38,71,74621,75,NULL,'W91PP, r, cor','UGC 12234',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158507,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158507,34.4,0.38,75.7,74621,75,NULL,'CF, r, inv','UGC 12234',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158508,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158508,34.49,0.38,79.2,74621,75,NULL,'CF, r, cor','UGC 12234',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158509,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158509,34.8,0.16,91.2,74622,NULL,NULL,'B, Hubble-type-TF','ESO 406- G 016',NULL,'2005Ap&SS.298..577R',2005,1,1.2,NULL,'G',0.000033,NULL,'15.74',0.5,'Sb-c',NULL,NULL,NULL,NULL,1,343.428125,-34.14719,NULL,NULL,50566797135,790106205,12345409,15.74),(158510,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158510,35.42,0.43,121,74622,NULL,NULL,NULL,'ESO 406- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158511,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158511,35.46,0.2,124,74622,74.4,NULL,NULL,'ESO 406- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158512,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158512,35.51,0.41,126,74622,NULL,NULL,'Malmquist cor.','ESO 406- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158513,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 20405',NULL,158513,39.9,0.31,953,74623,70,NULL,'SN photometric redshift distance, z photo =0.254 +/- 0.047','SDSS-II SN 20405',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,343.44175,-1.13783,0.217,NULL,49514106495,773657913,12088404,NULL),(158514,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 02645','RN',158514,39.27,0.45,654,74624,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02645',0.09111,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158515,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158515,37.09,0.46,261,74625,70,NULL,NULL,'2MASX J22535600-0949223',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000139,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,343.48325,-9.82289,0.113,NULL,50378275485,787160554,12299383,16.9),(158516,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158516,31.27,0.2,18,74626,74.4,NULL,NULL,'NGC 7406',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.000023,NULL,'14.17',0.4,'Sc',NULL,NULL,NULL,NULL,1,343.484333,-6.57925,0.085,NULL,50370258878,787035294,12297426,14.17),(158517,'GRB','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158517,38.89,NULL,601,74627,65,NULL,'L = 10e57 photons/s','GRB 791105B',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,343.571625,-2.30731,0.193,NULL,49515646933,773681983,12088780,NULL),(158518,'GRB','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158518,41.58,NULL,2070,74627,65,NULL,'L = 2 x 10e58 photons/s','GRB 791105B',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158519,'GRB','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158519,46.15,NULL,17000,74627,NULL,NULL,'L = 10e57 photons/s','GRB 791105B',NULL,'1992grbo.book..107S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158520,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158520,36.08,0.54,165,74628,70,NULL,NULL,'MCG -03-58-010',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16',0.15,NULL,NULL,NULL,NULL,NULL,1,343.5095417,-15.27572,0.093,NULL,50462033578,788469274,12319832,16),(158521,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158521,35.1,0.53,105,74629,70,NULL,NULL,'2MASX J22540390-1110123',NULL,'2014MNRAS.445.2677S',2014,1,0.71,NULL,'G',0.000103,NULL,'16.19',0.38,NULL,NULL,NULL,NULL,NULL,1,343.51625,-11.17019,0.113,NULL,50377382072,787146594,12299165,16.19),(158522,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158522,37.93,0.46,385,74630,70,NULL,NULL,'SDSS J225404.39+002716.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,343.5182917,0.45464,0.197,NULL,51732658772,808322793,12630043,18.1),(158523,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 20359','RN',158523,41.34,0.37,1210,74631,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 20359',0.530904,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158524,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158524,35.14,0.48,107,74632,NULL,NULL,NULL,'ESO 534- G 030',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'16.09',1.1,'S...',NULL,NULL,NULL,NULL,1,343.549167,-25.25206,0.063,NULL,50111956069,782999313,12234364,16.09),(158525,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158525,35.18,0.2,109,74632,74.4,NULL,NULL,'ESO 534- G 030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158526,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158526,35.39,0.43,120,74632,NULL,NULL,'Malmquist cor.','ESO 534- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158527,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SN 2006jm',NULL,158527,40.17,0.14,1080,74633,70,NULL,'Hubble residual -0.21 for z0.33000','SDSS J225412.27+010302.3',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,343.550917,1.05089,0.209,NULL,51733573424,808337084,12630266,NULL),(158528,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 14456','R',158528,40.99,0.23,1190,74633,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006jm','SDSS J225412.27+010302.3',0.33,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158529,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 14456','R',158529,41.06,0.15,1220,74633,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006jm','SDSS J225412.27+010302.3',0.33,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158530,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SN 2006jm',NULL,158530,41.11,0.13,1670,74633,70,NULL,'SALT 2','SDSS J225412.27+010302.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158531,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SN 2006jm',NULL,158531,41.15,0.13,1700,74633,70,NULL,'SALT 2, Malmquist cor.','SDSS J225412.27+010302.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158532,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158532,37.26,0.76,283,74634,70,NULL,NULL,'2MFGC 17217',NULL,'2014MNRAS.445.2677S',2014,1,0.89,NULL,'G',0.000096,NULL,'15.6g',0.41,'Sab',NULL,NULL,NULL,NULL,1,343.575916667,-9.44917,0.097,NULL,50378611250,787165800,12299465,15.6),(158533,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 09853','RN',158533,38.92,0.3,570,74635,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 09853',0.067734,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158534,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 09853','RN',158534,40.42,0.73,1140,74635,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 09853',0.067734,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158535,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158535,35.16,0.49,108,74636,75,NULL,'IR','UGC 12237',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000033,NULL,'15.35',0.3,'Sbc',NULL,NULL,NULL,'Sy 2',1,343.5819583,11.78247,0.157,NULL,52556205405,821190709,12831104,15.35),(158536,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158536,35.27,0.34,113,74636,NULL,NULL,'Malmquist cor.','UGC 12237',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158537,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158537,35.38,0.2,119,74636,74.4,NULL,NULL,'UGC 12237',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158538,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158538,35.4,0.32,120,74636,NULL,NULL,NULL,'UGC 12237',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158539,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158539,35.47,0.4,124,74636,NULL,NULL,'mean','UGC 12237',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158540,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158540,35.81,0.47,146,74636,NULL,NULL,'H','UGC 12237',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158541,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158541,37.24,0.46,280,74637,70,NULL,NULL,'2MASX J22542062+1435443',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,343.586,14.59578,0.133,NULL,52602251828,821910184,12842346,17.8),(158542,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158542,32.94,0.8,38.7,74638,75,NULL,'MAT, I','NGC 7400',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.00002,NULL,'13.60',0.5,'SAB:(r)b',NULL,NULL,NULL,NULL,1,343.58675,-45.34703,0,NULL,50508470864,789194857,12331169,13.6),(158543,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158543,32.77,0.4,35.8,74638,NULL,NULL,NULL,'NGC 7400',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158544,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158544,32.77,0.4,35.8,74638,73,NULL,'opt','NGC 7400',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158545,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158545,32.86,0.32,37.3,74638,85,NULL,'I, raw','NGC 7400',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158546,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158546,32.89,0.32,37.8,74638,85,NULL,'I, inv','NGC 7400',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158547,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158547,32.93,0.43,38.6,74638,75,NULL,'MAT, I, raw','NGC 7400',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158548,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158548,32.98,0.4,39.5,74638,NULL,NULL,'mean','NGC 7400',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158549,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158549,33.02,0.43,40.2,74638,75,NULL,'MAT, I, cor','NGC 7400',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158550,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158550,33.02,0.47,40.2,74638,NULL,NULL,'H','NGC 7400',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158551,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158551,33.04,0.46,40.5,74638,NULL,NULL,'J','NGC 7400',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158552,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158552,33.1,0.43,41.6,74638,75,NULL,'MAT, I, inv','NGC 7400',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158553,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158553,33.1,0.45,41.7,74638,NULL,NULL,'K','NGC 7400',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158554,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158554,33.12,0.48,42.2,74638,NULL,NULL,'Malmquist cor.','NGC 7400',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158555,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158555,33.19,0.47,43.5,74638,NULL,NULL,NULL,'NGC 7400',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158556,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158556,33.23,0.2,44.3,74638,74.4,NULL,NULL,'NGC 7400',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158557,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158557,33.31,0.4,45.8,74639,NULL,NULL,'mean','IC 5261',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00002,NULL,'13.88',1.3,'SB(s)cd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,343.605166667,-20.36289,0.065,NULL,50441961000,788155640,12314931,13.88),(158558,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158558,33.66,0.47,54.1,74639,NULL,NULL,'H','IC 5261',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158559,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158559,33.73,0.46,55.8,74639,NULL,NULL,'J','IC 5261',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158560,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158560,37.65,0.46,339,74640,70,NULL,NULL,'2MASX J22542770-0916329',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00015,NULL,'16.5g',0.28,'AGN',NULL,NULL,NULL,NULL,1,343.615417,-9.27589,0.093,NULL,50378599218,787165612,12299462,16.5),(158561,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158561,37.27,0.19,285,74641,70,NULL,NULL,'2MASX J22542992-0029485',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000178,NULL,'17.7g',0.22,'NLAGN',NULL,NULL,NULL,NULL,1,343.6247083,-0.49672,0.209,NULL,49497084183,773391940,12084249,17.7),(158562,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158562,37.27,0.19,285,74642,70,NULL,NULL,'2MASX J22543459-0034485',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,'PRED','17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,343.64425,-0.58025,0.209,NULL,49513894266,773654597,12088353,17),(158563,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158563,37.27,0.19,285,74643,70,NULL,NULL,'2MASX J22543472-0034155',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.0002,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,343.644667,-0.57106,0.209,NULL,49513894896,773654607,12088353,16.5),(158564,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 10703','RN',158564,36.97,0.16,232,74644,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10703',0.067948,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158565,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 10703','RN',158565,40.87,0.46,1390,74644,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10703',0.067948,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158566,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158566,37.19,0.46,274,74645,70,NULL,NULL,'2MASX J22543864+1428233',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000144,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,343.661,14.47322,0.133,NULL,52602763865,821918185,12842471,16.9),(158567,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158567,37.77,0.46,358,74646,70,NULL,NULL,'2MASX J22544271+1305573',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,343.678083,13.09936,0.161,NULL,52558260646,821222822,12831606,17.5),(158568,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 09265','RN',158568,43.34,0.37,3230,74647,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 09265',0.442362,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158569,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 20388','RN',158569,40.38,0.15,1010,74648,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 20388',0.178524,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158570,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 20388','RN',158570,40.75,0.26,1200,74648,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 20388',0.178524,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158571,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158571,37.27,0.19,285,74649,70,NULL,NULL,'2MASX J22544932-0021223',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000209,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,343.705541667,-0.35628,0.213,NULL,49497187468,773393554,12084274,16.4),(158572,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 01114','R',158572,37.01,0.21,246,74650,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2005lb','SN 2005lb',0.026478,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'II',NULL,NULL,NULL,NULL,1,343.7085417,-0.2525,0.213,NULL,49497184376,773393505,12084273,NULL),(158573,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158573,35.22,0.8,111,74651,75,NULL,'W91PP, r','UGC 12245',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'15.42',0.4,'Scd:','Isolated galaxy',NULL,NULL,NULL,1,343.709583,21.80653,0.161,NULL,52392494501,818632726,12791136,15.42),(158574,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158574,34.94,0.38,97.4,74651,75,NULL,'W91PP, r, raw','UGC 12245',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158575,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158575,35.08,0.38,104,74651,75,NULL,'W91PP, r, inv','UGC 12245',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158576,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158576,35.13,0.38,106,74651,75,NULL,'W91PP, r, cor','UGC 12245',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158577,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158577,35.82,0.49,146,74652,75,NULL,'IR','NGC 7415',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.000033,NULL,'15.5',0.15,'Sab','Group member',NULL,NULL,NULL,1,343.723417,20.26156,0.185,NULL,52569480726,821398136,12834345,15.5),(158578,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158578,36.53,0.56,202,74653,70,NULL,NULL,'2MFGC 17226',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.1I',0.2,NULL,NULL,NULL,NULL,NULL,1,343.725583,-49.22831,0,NULL,50514678148,789291846,12332685,14.1),(158579,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158579,31.52,0.8,20.1,74654,75,NULL,'B','NGC 7410',NULL,'1988NBGC.C....0000T',1988,1,5.2,NULL,'G',0.000093,NULL,'11.61',1.6,'SB(s)a;LINER   Sy2','in a pair',NULL,NULL,'LINER',1,343.7539583,-39.66133,NULL,NULL,50710244217,792347565,12380430,11.61),(158580,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158580,32.82,0.43,36.7,74654,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7410',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158581,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158581,33.15,0.43,42.7,74654,75,NULL,'3.6 micron, color corrected','NGC 7410',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158582,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158582,33.61,0.2,52.7,74654,74.4,NULL,NULL,'NGC 7410',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158583,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158583,37.27,0.19,285,74655,70,NULL,NULL,'2MASX J22550212-0022423',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,'PRED','16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,343.758875,-0.37842,0.213,NULL,49497065260,773391644,12084244,16.8),(158584,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158584,33.9,0.44,60.3,74656,95,NULL,'Weighted Mean','NGC 7413',NULL,'1984ApJS...56...91D',1984,1,0.83,NULL,'G',0.00008,NULL,'14.8g',0.55,'S0- pec:',NULL,NULL,NULL,NULL,1,343.762917,13.22047,0.161,NULL,52558185951,821221655,12831588,14.8),(158585,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158585,34.17,0.63,68.2,74656,95,NULL,'Michard 1979b, c','NGC 7413',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158586,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158586,34.6,0.46,83.2,74656,95,NULL,'Michard 1979a','NGC 7413',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158587,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158587,34.48,0.46,78.7,74656,70,NULL,NULL,'NGC 7413',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158588,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 10853','RN',158588,38.44,0.25,458,74657,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10853',0.066668,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158589,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 10853','RN',158589,39.26,0.91,667,74657,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10853',0.066668,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158590,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158590,37.32,0.46,291,74658,70,NULL,NULL,'2MASX J22550607+0044386',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000181,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,343.7754583,0.74414,0.149,NULL,51733466761,808335418,12630240,17.9),(158591,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158591,35.97,0.46,156,74659,70,NULL,NULL,'2MASX J22550681+0058396',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000104,NULL,'15.7g',0.39,'LINER',NULL,NULL,NULL,NULL,1,343.778333,0.97781,0.197,NULL,51733488671,808335760,12630246,15.7),(158592,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158592,32.68,0.8,34.4,74660,75,NULL,'MAT, I','ESO 346- G 014',NULL,'1997ApJS..109..333W',1997,1,1.81,NULL,'G',0.000013,NULL,'15.13',0.2,'SB(s)d? sp','Isolated galaxy',NULL,NULL,NULL,1,343.7792917,-38.58333,NULL,NULL,50702928822,792233262,12378644,15.13),(158593,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158593,32.41,0.4,30.4,74660,75,NULL,NULL,'ESO 346- G 014',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158594,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158594,32.41,0.4,30.4,74660,73,NULL,'IR','ESO 346- G 014',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158595,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158595,32.71,0.13,34.9,74660,NULL,NULL,NULL,'ESO 346- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158596,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158596,33.14,0.32,42.5,74660,85,NULL,'I, inv','ESO 346- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158597,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158597,33.15,0.32,42.6,74660,85,NULL,'I, raw','ESO 346- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158598,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158598,33.16,0.2,42.9,74660,74.4,NULL,NULL,'ESO 346- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158599,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158599,33.28,0.38,45.3,74660,NULL,NULL,NULL,'ESO 346- G 014',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158600,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158600,33.29,0.43,45.5,74660,75,NULL,'3.6 micron, color corrected','ESO 346- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158601,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158601,33.31,0.43,45.9,74660,75,NULL,'MAT, I, raw','ESO 346- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158602,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158602,33.34,0.43,46.7,74660,75,NULL,'MAT, I, inv','ESO 346- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158603,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158603,33.38,0.43,47.3,74660,75,NULL,'3.6 micron, color + selection bias corrected','ESO 346- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158604,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158604,33.41,NULL,48.2,74660,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 346- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158605,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158605,33.42,0.43,48.4,74660,75,NULL,'MAT, I, cor','ESO 346- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158606,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158606,33.44,NULL,48.8,74660,NULL,NULL,'Dipole + Quadrupole','ESO 346- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158607,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158607,33.45,0.49,49.1,74660,75,NULL,'IR','ESO 346- G 014',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158608,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158608,33.46,NULL,49.1,74660,NULL,NULL,'Dipole','ESO 346- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158609,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158609,33.47,NULL,49.4,74660,NULL,NULL,NULL,'ESO 346- G 014',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158610,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158610,34.14,0.49,67.3,74661,75,NULL,'IR','CGCG 496-019',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000033,NULL,'15.12',0.5,'S?',NULL,NULL,NULL,NULL,1,343.783791667,31.30881,0.265,NULL,51924981005,811327828,12676997,15.12),(158611,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158611,37.27,0.19,285,74662,70,NULL,NULL,'2MASX J22551005-0024333',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.00015,NULL,'16.43',0.48,'BrClG',NULL,NULL,NULL,NULL,1,343.7917917,-0.40939,0.213,NULL,49497066300,773391660,12084244,16.43),(158612,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158612,37.93,0.46,386,74663,70,NULL,NULL,'2MASX J22551232-1034373',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,343.8012917,-10.57689,0.101,NULL,50374924901,787108201,12298565,17.2),(158613,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158613,34.42,0.4,76.6,74664,NULL,NULL,'mean','IC 5259',NULL,'2007A&A...465...71T',2007,1,0.55,NULL,'G',0.000033,NULL,'14.8',0.4,NULL,NULL,NULL,NULL,NULL,1,343.8112083,36.67178,0.401,NULL,55516150164,867439846,13553747,14.8),(158614,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158614,34.49,0.47,79.2,74664,NULL,NULL,'H','IC 5259',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158615,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158615,34.5,0.45,79.5,74664,NULL,NULL,'K','IC 5259',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158616,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158616,34.56,0.46,81.6,74664,NULL,NULL,'J','IC 5259',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158617,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158617,35.14,0.35,107,74664,NULL,NULL,'Malmquist cor.','IC 5259',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158618,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158618,35.71,0.27,139,74664,NULL,NULL,NULL,'IC 5259',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158619,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158619,35.75,0.2,141,74664,74.4,NULL,NULL,'IC 5259',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158620,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158620,35.83,0.65,147,74665,70,NULL,NULL,'2MASX J22551619-5842087',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'16.58',0.22,NULL,NULL,NULL,NULL,NULL,1,343.817333,-58.70247,0,NULL,48849817492,763278398,11926224,16.58),(158621,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158621,35.71,0.61,139,74666,70,NULL,NULL,'2MASX J22551617-1843274',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'17.26',0.32,NULL,NULL,NULL,NULL,NULL,1,343.817375,-18.72428,0.057,NULL,50443404833,788178200,12315284,17.26),(158622,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 09324','RN',158622,41.2,0.29,1260,74667,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 09324',0.378093,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158623,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 09324','RN',158623,41.24,0.31,1290,74667,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 09324',0.378093,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158624,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 09324','N',158624,41.09,0.2,1650,74667,70,NULL,'SALT 2','SDSS-II SN 09324',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158625,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 09324','N',158625,41.15,0.2,1700,74667,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 09324',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158626,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158626,37.16,0.92,270,74668,70,NULL,NULL,'2MASX J22551913-0313388',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.56',0.37,NULL,NULL,NULL,NULL,NULL,1,343.829667,-3.22756,0.185,NULL,49523020639,773797197,12090581,16.56),(158627,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158627,38.23,0.46,443,74669,70,NULL,NULL,'2MASX J22551986+0059156',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000174,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,343.8327083,0.98772,0.197,NULL,51732984326,808327880,12630123,17.4),(158628,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158628,35.05,NULL,102,74670,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12249',NULL,'2010Ap&SS.325..163P',2010,1,1.15,NULL,'G',0.000012,NULL,'16.0',0.1,'Scd',NULL,NULL,NULL,NULL,1,343.8335417,28.34628,0.165,NULL,51929081125,811391892,12677998,16),(158629,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158629,35.06,NULL,103,74670,NULL,NULL,'Dipole + Quadrupole','UGC 12249',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158630,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158630,35.08,NULL,104,74670,NULL,NULL,'Dipole','UGC 12249',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158631,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158631,35.1,NULL,105,74670,NULL,NULL,NULL,'UGC 12249',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158632,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158632,35.12,0.49,105,74670,75,NULL,'IR','UGC 12249',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158633,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158633,35.19,0.42,109,74670,NULL,NULL,'Malmquist cor.','UGC 12249',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158634,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158634,35.24,0.43,112,74670,75,NULL,'3.6 micron, color corrected','UGC 12249',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158635,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158635,35.27,0.2,113,74670,74.4,NULL,NULL,'UGC 12249',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158636,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158636,35.29,0.43,114,74670,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12249',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158637,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158637,35.34,0.39,117,74670,NULL,NULL,NULL,'UGC 12249',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158638,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158638,38.41,0.46,480,74671,70,NULL,NULL,'2MASX J22552145-0056518',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00015,NULL,'17.1g',0.28,'AGN',NULL,NULL,NULL,NULL,1,343.839458333,-0.94778,0.177,NULL,49514407474,773662616,12088478,17.1),(158639,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158639,36.34,0.76,185,74672,70,NULL,NULL,'2MASX J22552594-8446268',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,343.858667,-84.77408,0.389,NULL,48380910087,755951720,11811745,16.6),(158640,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 18275',NULL,158640,38.26,0.6,449,74673,70,NULL,'SN photometric redshift distance, z photo =0.111 +/- 0.038','SDSS-II SN 18275',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.8g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,343.873333,-0.62231,0.213,NULL,49497909424,773404834,12084450,22.8),(158641,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 18275','R',158641,42.43,0.42,2080,74673,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18275',0.472048,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158642,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 13738','RN',158642,44.02,0.55,4540,74674,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13738',0.406084,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158643,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 13738','RN',158643,45.99,0.72,11200,74674,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13738',0.406084,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158644,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158644,37.64,0.46,337,74675,70,NULL,NULL,'2MASX J22553551+1443278',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000179,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,343.8980417,14.72431,0.165,NULL,52602735484,821917741,12842464,16.9),(158645,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158645,37.51,0.46,317,74676,70,NULL,NULL,'2MASX J22553569+1331078',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000146,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,343.898583,13.51886,0.165,NULL,52557196756,821206199,12831346,18.1),(158646,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158646,34.44,0.51,77.2,74677,NULL,NULL,'Malmquist cor.','UGC 12250',NULL,'2009ApJS..182..474S',2009,1,1.38,NULL,'G',0.00006,NULL,'14.2g',1.05,'SBb',NULL,NULL,NULL,NULL,1,343.899625,12.79031,0.113,NULL,52558820509,821231570,12831743,14.2),(158647,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158647,34.63,0.47,84.1,74677,NULL,NULL,NULL,'UGC 12250',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158648,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158648,34.82,0.2,92,74677,74.4,NULL,NULL,'UGC 12250',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158649,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158649,34.97,0.47,98.5,74677,NULL,NULL,'H','UGC 12250',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158650,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158650,35.01,0.45,101,74677,NULL,NULL,'K','UGC 12250',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158651,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158651,35.02,0.4,101,74677,NULL,NULL,'mean','UGC 12250',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158652,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158652,35.04,0.46,102,74677,NULL,NULL,'J','UGC 12250',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158653,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158653,37.81,0.46,364,74678,70,NULL,NULL,'2MASX J22553651+1354458',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,343.9019583,13.91289,0.169,NULL,52557126073,821205094,12831329,17.9),(158654,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158654,37.5,0.46,316,74679,70,NULL,NULL,'2MASX J22553780-0924258',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,343.907541667,-9.40725,0.093,NULL,50381272465,787207382,12300115,17.7),(158655,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158655,34.4,0.8,75.8,74680,75,NULL,'MAT, I','ESO 534- G 031',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000023,NULL,'14.56',0.7,'Sc',NULL,NULL,NULL,NULL,1,343.9175,-23.95383,0.041,NULL,50216405598,784631337,12259864,14.56),(158656,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158656,33.28,0.32,45.3,74680,85,NULL,'I, raw','ESO 534- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158657,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158657,33.29,0.32,45.5,74680,85,NULL,'I, inv','ESO 534- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158658,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158658,33.29,0.43,45.6,74680,75,NULL,'MAT, I, raw','ESO 534- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158659,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158659,33.36,0.43,47,74680,75,NULL,'MAT, I, inv','ESO 534- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158660,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158660,33.46,0.43,49.2,74680,75,NULL,'MAT, I, cor','ESO 534- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158661,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158661,32.8,0.8,36.3,74681,75,NULL,'B','NGC 7416',NULL,'1988NBGC.C....0000T',1988,1,3.2,NULL,'G',0.000025,NULL,'12.63',0.9,'SB(r)b         HII','Group member',NULL,NULL,NULL,1,343.92375,-5.49533,0.145,NULL,49518237721,773722464,12089413,12.63),(158662,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158662,32.36,0.46,29.6,74681,NULL,NULL,'J','NGC 7416',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158663,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158663,32.44,0.47,30.7,74681,NULL,NULL,'H','NGC 7416',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158664,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158664,32.51,0.45,31.7,74681,NULL,NULL,'K','NGC 7416',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158665,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158665,32.51,0.2,31.8,74681,74.4,NULL,NULL,'NGC 7416',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158666,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158666,32.53,0.43,32.1,74681,75,NULL,'3.6 micron, color corrected','NGC 7416',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158667,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158667,32.63,0.43,33.6,74681,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7416',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158668,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158668,32.65,0.52,33.9,74681,NULL,NULL,NULL,'NGC 7416',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158669,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158669,32.7,0.4,34.7,74681,NULL,NULL,'mean','NGC 7416',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158670,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158670,32.72,0.5,35,74681,NULL,NULL,'Malmquist cor.','NGC 7416',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158671,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158671,37.77,0.46,358,74682,70,NULL,NULL,'2MASX J22554270+0105231',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,343.927791667,1.08981,0.193,NULL,51733009055,808328266,12630129,17.7),(158672,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158672,34.87,0.8,94.3,74683,75,NULL,'W91PP, r','UGC 12252',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000012,NULL,'16.0',0.18,'Sc',NULL,NULL,NULL,NULL,1,343.93025,31.77153,0.269,NULL,51923003324,811296926,12676514,16),(158673,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158673,34.68,NULL,86.3,74683,NULL,NULL,'Dipole','UGC 12252',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158674,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158674,34.68,NULL,86.5,74683,NULL,NULL,'Dipole + Quadrupole','UGC 12252',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158675,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158675,34.69,NULL,86.5,74683,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12252',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158676,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158676,34.82,NULL,92,74683,NULL,NULL,NULL,'UGC 12252',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158677,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158677,34.97,0.37,98.7,74683,NULL,NULL,'Malmquist cor.','UGC 12252',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158678,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158678,35.02,0.38,101,74683,75,NULL,'W91PP, r, raw','UGC 12252',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158679,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158679,35.06,0.35,103,74683,NULL,NULL,NULL,'UGC 12252',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158680,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158680,35.07,0.38,103,74683,75,NULL,'W91PP, r, inv','UGC 12252',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158681,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158681,35.1,0.38,105,74683,75,NULL,'W91PP, r, cor','UGC 12252',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158682,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158682,35.15,0.2,107,74683,74.4,NULL,NULL,'UGC 12252',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158683,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158683,35.25,0.49,112,74683,75,NULL,'IR','UGC 12252',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158684,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158684,35.26,0.43,113,74683,75,NULL,'3.6 micron, color corrected','UGC 12252',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158685,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158685,35.38,0.43,119,74683,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12252',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158686,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 20987','RN',158686,41.33,0.4,1640,74684,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20987',0.12206,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158687,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 20987','RN',158687,41.53,0.32,1810,74684,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 20987',0.12206,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158688,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158688,31.64,0.8,21.3,74685,75,NULL,'MAT, I','NGC 7412',NULL,'1997ApJS..109..333W',1997,1,3.9,NULL,'G',0.000013,NULL,'11.88',2.9,'SAB(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,343.940625,-42.64203,0,NULL,50487840959,788872514,12326133,11.88),(158689,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158689,28.95,0.43,6.2,74685,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7412',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158690,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158690,29.03,0.32,6.41,74685,85,NULL,'I, inv','NGC 7412',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158691,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158691,29.06,0.32,6.51,74685,85,NULL,'I, raw','NGC 7412',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158692,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158692,29.29,0.43,7.2,74685,75,NULL,'3.6 micron, color corrected','NGC 7412',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158693,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158693,29.36,0.43,7.44,74685,75,NULL,'MAT, I, inv','NGC 7412',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158694,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158694,29.43,0.43,7.69,74685,75,NULL,'MAT, I, raw','NGC 7412',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158695,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158695,29.57,0.2,8.2,74685,74.4,NULL,NULL,'NGC 7412',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158696,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158696,29.64,0.36,8.47,74685,NULL,NULL,NULL,'NGC 7412',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158697,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158697,29.75,0.43,8.91,74685,75,NULL,'MAT, I, cor','NGC 7412',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158698,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158698,30.59,0.39,13.1,74685,73,NULL,'opt','NGC 7412',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158699,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158699,31.62,0.4,21.1,74685,75,NULL,'B','NGC 7412',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158700,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158700,35.99,0.46,158,74686,70,NULL,NULL,'2MASX J22554693-0854575',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000103,NULL,'15.7g',0.37,'E0',NULL,NULL,NULL,NULL,1,343.945667,-8.91606,0.093,NULL,50381217901,787206529,12300102,15.7),(158701,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158701,37.56,0.46,325,74687,70,NULL,NULL,'2MASX J22554824+1330248',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000149,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,343.951,13.50678,0.165,NULL,52557077918,821204342,12831317,17.6),(158702,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158702,36.62,0.33,211,74688,70,NULL,NULL,'2MASX J22554841-1019285',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,343.9517917,-10.32472,0.117,NULL,50379419893,787178435,12299663,16.7),(158703,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158703,39.21,0.46,696,74689,70,NULL,NULL,'SDSS J225548.66+125931.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000155,NULL,'18.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,343.952791667,12.99203,0.113,NULL,52558719206,821229987,12831718,18.8),(158704,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158704,37.9,0.46,380,74690,70,NULL,NULL,'2MASX J22555349-1017365',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,343.972917,-10.29361,0.133,NULL,50379414700,787178354,12299661,17.7),(158705,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158705,38.21,0.23,438,74691,70,NULL,NULL,'2MASX J22555395-0039072',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00015,NULL,'17.2g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,343.974833,-0.65192,0.213,NULL,49497957967,773405593,12084462,17.2),(158706,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158706,34.6,0.39,83.2,74692,NULL,NULL,NULL,'CGCG 496-024',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000033,NULL,'14.86',0.5,'S?             HII',NULL,NULL,NULL,NULL,1,343.980583,31.67158,0.269,NULL,51923058683,811297791,12676527,14.86),(158707,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158707,34.75,0.36,89.2,74692,NULL,NULL,'Malmquist cor.','CGCG 496-024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158708,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158708,35.1,0.2,105,74692,74.4,NULL,NULL,'CGCG 496-024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158709,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158709,32.82,0.8,36.7,74693,75,NULL,'MAT, I','IC 5269A',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000013,NULL,'13.88',1,'SB(s)m:','Isolated galaxy',NULL,NULL,NULL,1,343.98225,-36.34917,NULL,NULL,50701553773,792211777,12378309,13.88),(158710,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158710,32.48,0.32,31.4,74693,85,NULL,'I, inv','IC 5269A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158711,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158711,32.51,0.32,31.7,74693,85,NULL,'I, raw','IC 5269A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158712,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158712,32.84,0.4,37,74693,NULL,NULL,NULL,'IC 5269A',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158713,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158713,32.86,0.09,37.4,74693,NULL,NULL,NULL,'IC 5269A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158714,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158714,32.89,0.43,37.8,74693,75,NULL,'MAT, I, inv','IC 5269A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158715,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158715,32.9,0.43,37.9,74693,75,NULL,'MAT, I, raw','IC 5269A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158716,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158716,33.02,0.43,40.2,74693,75,NULL,'MAT, I, cor','IC 5269A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158717,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158717,37.53,0.33,321,74694,70,NULL,NULL,'2MASX J22555663+1509478',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,343.985917,15.16311,0.161,NULL,52610051932,822032061,12844250,17),(158718,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158718,37.85,0.46,371,74695,70,NULL,NULL,'2MASX J22555669+0050131',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000119,NULL,'18.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,343.986167,0.83706,0.149,NULL,51699636187,807806815,12621981,18.5),(158719,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158719,33.28,0.8,45.4,74696,75,NULL,'MAT, I','NGC 7408',NULL,'1997ApJS..109..333W',1997,1,1.5,'The APMUKS position is north of the nucleus.','G',0.000031,NULL,'13.33',1.2,'(R\')SB(rs)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,343.986917,-63.69472,0,NULL,48760249799,761878903,11904357,13.33),(158720,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158720,32.73,0.32,35.2,74696,85,NULL,'I, inv','NGC 7408',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158721,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158721,32.75,0.32,35.5,74696,85,NULL,'I, raw','NGC 7408',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158722,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158722,32.99,0.43,39.6,74696,75,NULL,'MAT, I, inv','NGC 7408',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158723,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158723,32.99,0.43,39.7,74696,75,NULL,'MAT, I, raw','NGC 7408',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158724,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158724,33.12,0.43,42.1,74696,75,NULL,'MAT, I, cor','NGC 7408',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158725,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158725,33.14,0.47,42.4,74696,NULL,NULL,'H','NGC 7408',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158726,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158726,33.25,0.46,44.6,74696,NULL,NULL,'J','NGC 7408',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158727,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158727,33.32,0.4,46.2,74696,NULL,NULL,'mean','NGC 7408',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158728,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158728,33.34,0.45,46.5,74696,NULL,NULL,'K','NGC 7408',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158729,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158729,34.35,0.48,74,74697,70,NULL,NULL,'ESO 076- G 031',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'13.93',1,'S0- pec:','Pair member (points to parent)',NULL,NULL,NULL,1,343.987333,-70.57367,0.021,NULL,49269823603,769840993,12028765,13.93),(158730,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158730,36.68,0.7,217,74698,70,NULL,NULL,'2MASX J22555800-0408332',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'17.12',0.23,NULL,NULL,NULL,NULL,NULL,1,343.991583333,-4.14256,0.165,NULL,49520615432,773759616,12089994,17.12),(158731,'GRB','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'RN',158731,41.71,0.62,1110,74699,73,NULL,'H const./H=100','GRB 010921 OT',0.451,'2006astro.ph..9262M',2006,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158732,'GRB','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'RN',158732,41.85,0.46,1620,74699,73,NULL,'H const./H=100','GRB 010921 OT',0.451,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158733,'GRB','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'RN',158733,42.34,0.62,2020,74699,72,NULL,NULL,'GRB 010921 OT',0.451,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158734,'GRB','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'N',158734,42.35,0.6,2030,74699,70,NULL,NULL,'GRB 010921 OT',0.451,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158735,'GRB','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'N',158735,42.53,0.54,2210,74699,69.7,NULL,'Calibrated','GRB 010921 OT',0.451,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158736,'GRB','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'N',158736,43,0.58,2740,74699,69.7,NULL,'Fiducial','GRB 010921 OT',0.451,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158737,'GRB','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158737,41.42,NULL,1920,74700,70,NULL,'Pseudo z = 0.62','GRB 010921',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE/Ulysses',NULL,NULL,NULL,NULL,1,343.9997083,40.93133,0.685,NULL,55341418641,864709666,13511088,NULL),(158738,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158738,37.53,0.33,321,74701,70,NULL,NULL,'2MASX J22560016+1510468',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,344.000541667,15.17953,0.161,NULL,52610051804,822032059,12844250,17.4),(158739,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158739,36.63,0.33,212,74702,70,NULL,NULL,'2MASX J22560014-0006382',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,344.000625,-0.11061,0.201,NULL,49497630797,773400481,12084382,17.1),(158740,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158740,34.22,0.49,69.7,74703,75,NULL,'IR','UGC 12253',NULL,'2011yCatp016004901K',2011,1,1.83,NULL,'G',0.000022,':','16.0',0.16,'Sbc',NULL,NULL,NULL,NULL,1,344.007625,12.76664,0.113,NULL,52558768946,821230764,12831730,16),(158741,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158741,34.55,0.2,81.3,74703,74.4,NULL,NULL,'UGC 12253',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158742,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158742,34.63,NULL,84.2,74703,NULL,NULL,'Dipole','UGC 12253',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158743,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158743,34.63,NULL,84.4,74703,NULL,NULL,'Dipole + Quadrupole','UGC 12253',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158744,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158744,34.64,NULL,84.5,74703,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12253',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158745,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158745,34.64,0.56,84.8,74703,NULL,NULL,'Malmquist cor.','UGC 12253',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158746,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158746,34.66,0.56,85.6,74703,NULL,NULL,NULL,'UGC 12253',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158747,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158747,36.62,0.33,211,74704,70,NULL,NULL,'2MASX J22560230-1019085',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,344.009667,-10.31911,0.133,NULL,50379422648,787178478,12299663,16.9),(158748,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158748,34.47,0.45,78.3,74705,NULL,NULL,NULL,'ESO 147- G 014',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.45',0.6,'SB:(r)a:',NULL,NULL,NULL,NULL,1,344.023208333,-58.39658,0,NULL,48851500825,763304700,11926635,14.45),(158749,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158749,34.51,0.2,79.8,74705,74.4,NULL,NULL,'ESO 147- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158750,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158750,34.56,0.43,81.5,74705,NULL,NULL,'Malmquist cor.','ESO 147- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158751,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158751,36.83,0.46,232,74706,70,NULL,NULL,'2MASX J22561082-0854005',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,344.0449583,-8.90014,0.093,NULL,50381254663,787207104,12300111,17.3),(158752,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158752,33.9,0.4,60.4,74707,NULL,NULL,'mean','NGC 7422',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000027,NULL,'14.18',0.8,'SB(s)b:',NULL,NULL,NULL,NULL,1,344.051583333,3.92678,0.173,NULL,51737496295,808398379,12631224,14.18),(158753,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158753,34.13,0.47,66.9,74707,NULL,NULL,'H','NGC 7422',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158754,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 13625','RN',158754,41.01,0.1,1340,74708,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13625',0.191387,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158755,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158755,38.21,0.23,438,74709,70,NULL,NULL,'2MASX J22561482-0034520',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000133,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,344.061833,-0.581,0.213,NULL,49497992245,773406128,12084470,17.9),(158756,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158756,36.63,0.33,212,74710,70,NULL,NULL,'2MASX J22561934-0006150',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,344.080583,-0.10422,0.201,NULL,49497634983,773400546,12084383,17.9),(158757,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158757,37.88,0.46,376,74711,70,NULL,NULL,'2MASX J22562128+0029434',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,344.0885,0.4955,0.149,NULL,51700026487,807812913,12622076,17.6),(158758,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158758,38.19,0.46,434,74712,70,NULL,NULL,'2MASX J22562126+1324431',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,344.0885417,13.41178,0.165,NULL,52557058778,821204043,12831313,18.2),(158759,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158759,37,0.46,251,74713,70,NULL,NULL,'2MASX J22562281-0016589',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,344.094958333,-0.28297,0.201,NULL,49497589871,773399841,12084372,16.8),(158760,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 07439','RN',158760,38.72,0.35,515,74714,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07439',0.078804,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158761,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 17169','RN',158761,40.11,0.23,862,74715,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17169',0.220524,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158762,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 17169','RN',158762,40.37,0.18,974,74715,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17169',0.220524,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158763,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158763,33.72,0.49,55.5,74716,75,NULL,'IR','CGCG 515-013',NULL,'2011yCatp016004901K',2011,1,0.75,NULL,'G',0.000033,NULL,'15.6',0.2,NULL,NULL,NULL,NULL,NULL,1,344.103625,36.24164,0.401,NULL,55516854063,867450844,13553919,15.6),(158764,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158764,37.56,0.46,325,74717,70,NULL,NULL,'2MASX J22562523+1454221',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000151,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,344.105125,14.90603,0.161,NULL,52609347631,822021056,12844079,17.2),(158765,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 06213','R',158765,38.73,0.24,502,74718,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 06213',0.109221,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,344.105833,-0.44994,0.217,NULL,49498008162,773406377,12084474,NULL),(158766,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 06213','R',158766,38.89,0.27,542,74718,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 06213',0.109221,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158767,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 17682','R',158767,40.25,0.32,861,74719,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17682',0.304812,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',NULL,'PHOT','20.9g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,344.107625,0.50142,0.149,NULL,51700026879,807812919,12622076,20.9),(158768,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 17682','R',158768,40.5,0.25,963,74719,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17682',0.304812,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158769,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 17682',NULL,158769,40.7,0.25,1380,74719,70,NULL,'SN photometric redshift distance, z photo =0.398 +/- 0.065','SDSS-II SN 17682',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158770,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158770,38.21,0.23,438,74720,70,NULL,NULL,'2MASX J22562655-0032359',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000138,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,344.110667,-0.54325,0.217,NULL,49497986614,773406040,12084469,18.4),(158771,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158771,37.06,0.46,259,74721,70,NULL,NULL,'2MASX J22562686+0110084',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000188,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,344.1119583,1.16903,0.193,NULL,51733026957,808328546,12630133,17.7),(158772,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158772,33.97,0.44,62.2,74722,NULL,NULL,'Malmquist cor.','UGC 12259',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000017,NULL,'16.0',0.3,'SB?',NULL,NULL,NULL,NULL,1,344.112375,18.70486,0.181,NULL,52568667403,821385428,12834147,16),(158773,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158773,34.04,0.2,64.3,74722,74.4,NULL,NULL,'UGC 12259',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158774,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158774,34.15,0.41,67.5,74722,NULL,NULL,NULL,'UGC 12259',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158775,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158775,38.21,0.23,438,74723,70,NULL,NULL,'2MASX J22562868-0031149',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,344.1194583,-0.52081,0.217,NULL,49498014520,773406476,12084476,18.3),(158776,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158776,37.75,0.46,355,74724,70,NULL,NULL,'2MASX J22562907+0027584',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000176,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,344.121,0.46617,0.149,NULL,51699997875,807812466,12622069,17.2),(158777,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158777,34.6,0.49,83.3,74725,75,NULL,'IR','UGC 12258',NULL,'2011yCatp016004901K',2011,1,1.5,'1999ApJS..121..287H has V = 6974 +- 31 km/sec.','G',0.000067,NULL,'14.94',0.3,'Sa',NULL,NULL,NULL,NULL,1,344.130667,17.78444,0.281,NULL,52598680284,821854379,12841474,14.94),(158778,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158778,34.97,0.47,98.7,74725,NULL,NULL,'H','UGC 12258',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158779,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158779,35.06,0.45,103,74725,NULL,NULL,'K','UGC 12258',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158780,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158780,35.13,0.46,106,74725,NULL,NULL,'J','UGC 12258',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158781,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158781,35.46,0.4,124,74725,NULL,NULL,'mean','UGC 12258',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158782,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158782,34.3,0.8,72.6,74726,75,NULL,'W91PP, r','UGC 12260',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'15.42',0.3,'Sd','Isolated galaxy',NULL,NULL,NULL,1,344.1327917,37.73919,0.589,NULL,55517626518,867462914,13554108,15.42),(158783,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158783,34.14,0.49,67.4,74726,75,NULL,'IR','UGC 12260',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158784,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158784,34.19,0.38,68.8,74726,NULL,NULL,NULL,'UGC 12260',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158785,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158785,34.19,0.2,68.9,74726,74.4,NULL,NULL,'UGC 12260',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158786,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158786,34.26,0.38,71.2,74726,75,NULL,'W91PP, r, raw','UGC 12260',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158787,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158787,34.3,0.38,72.5,74726,75,NULL,'W91PP, r, inv','UGC 12260',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158788,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158788,34.45,0.34,77.5,74726,NULL,NULL,'Malmquist cor.','UGC 12260',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158789,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158789,34.49,0.38,79.2,74726,75,NULL,'W91PP, r, cor','UGC 12260',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158790,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158790,38.14,0.46,425,74727,70,NULL,NULL,'SDSS J225633.91-082316.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000143,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,344.141333,-8.38789,0.093,NULL,50372246616,787066353,12297911,18.5),(158791,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158791,36.46,0.77,196,74728,70,NULL,NULL,'2MASX J22563554-0143419',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'16.13',0.42,NULL,NULL,NULL,NULL,NULL,1,344.1480417,-1.72828,0.205,NULL,49517379136,773709049,12089203,16.13),(158792,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158792,31.29,0.8,18.1,74729,75,NULL,'MAT, I','NGC 7418',NULL,'1997ApJS..109..333W',1997,1,3.5,NULL,'G',0.000017,NULL,'12.30',2.6,'SAB(rs)cd      HII','X-ray-bright group member',NULL,NULL,NULL,1,344.150667,-37.03008,NULL,NULL,50701307311,792207926,12378248,12.3),(158793,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158793,31.1,0.4,16.6,74729,NULL,NULL,NULL,'NGC 7418',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158794,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158794,31.1,0.39,16.6,74729,73,NULL,'opt','NGC 7418',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158795,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158795,31.15,0.32,17,74729,85,NULL,'I, raw','NGC 7418',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158796,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158796,31.18,0.32,17.2,74729,85,NULL,'I, inv','NGC 7418',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158797,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158797,31.21,0.43,17.5,74729,75,NULL,'MAT, I, raw','NGC 7418',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158798,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158798,31.25,0.4,17.8,74729,75,NULL,'B','NGC 7418',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158799,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158799,31.37,0.43,18.8,74729,75,NULL,'MAT, I, inv','NGC 7418',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158800,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158800,31.5,0.43,19.9,74729,75,NULL,'MAT, I, cor','NGC 7418',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158801,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158801,31.5,0.4,20,74729,NULL,NULL,'mean','NGC 7418',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158802,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158802,31.81,0.45,23.1,74729,NULL,NULL,'K','NGC 7418',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158803,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158803,31.82,0.47,23.1,74729,NULL,NULL,'H','NGC 7418',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158804,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158804,31.86,0.46,23.6,74729,NULL,NULL,'J','NGC 7418',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158805,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158805,31.58,0.8,20.7,74730,75,NULL,'A82, H','IC 5269B',NULL,'1997ApJS..109..333W',1997,1,4.1,'The APM position is 15 arcsec west of the nucleus.','G',0.000013,NULL,'13.2',0.8,'SB(rs)cd:','X-ray-bright group member',NULL,NULL,NULL,1,344.153,-36.24978,NULL,NULL,50701786088,792215407,12378365,13.2),(158806,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158806,31.6,0.8,20.9,74730,75,NULL,'MAT, I','IC 5269B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158807,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158807,31.56,0.8,20.5,74730,75,NULL,NULL,'IC 5269B',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158808,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158808,31.36,0.39,18.7,74730,73,NULL,'IR','IC 5269B',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158809,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158809,31.36,0.4,18.7,74730,75,NULL,NULL,'IC 5269B',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158810,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158810,31.52,0.2,20.1,74730,74.4,NULL,NULL,'IC 5269B',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158811,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158811,31.53,0.43,20.2,74730,75,NULL,'3.6 micron, color corrected','IC 5269B',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158812,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158812,31.54,0.32,20.3,74730,85,NULL,'I, raw','IC 5269B',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158813,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158813,31.54,0.32,20.3,74730,85,NULL,'I, inv','IC 5269B',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158814,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158814,31.61,0.38,21,74730,NULL,NULL,NULL,'IC 5269B',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158815,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158815,31.63,0.43,21.2,74730,75,NULL,'3.6 micron, color + selection bias corrected','IC 5269B',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158816,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158816,31.67,0.43,21.6,74730,75,NULL,'MAT, I, raw','IC 5269B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158817,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158817,31.68,0.49,21.7,74730,75,NULL,'IR','IC 5269B',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158818,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158818,31.74,0.43,22.2,74730,75,NULL,'MAT, I, inv','IC 5269B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158819,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158819,31.81,0.47,23.1,74730,75,NULL,'A82, H, inv','IC 5269B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158820,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158820,31.84,0.4,23.3,74730,NULL,NULL,'mean','IC 5269B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158821,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158821,31.87,0.47,23.6,74730,75,NULL,'A82, H, raw','IC 5269B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158822,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158822,31.87,0.55,23.7,74730,NULL,NULL,NULL,'IC 5269B',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158823,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158823,31.92,0.43,24.2,74730,75,NULL,'MAT, I, cor','IC 5269B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158824,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158824,31.95,0.39,24.6,74730,73,NULL,'opt','IC 5269B',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158825,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158825,32.04,0.51,25.6,74730,NULL,NULL,'Malmquist cor.','IC 5269B',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158826,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158826,32.15,0.47,26.9,74730,75,NULL,'A82, H, cor','IC 5269B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158827,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158827,32.56,0.46,32.6,74730,NULL,NULL,'J','IC 5269B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158828,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158828,32.67,0.47,34.2,74730,NULL,NULL,'H','IC 5269B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158829,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158829,32.87,0.45,37.6,74730,NULL,NULL,'K','IC 5269B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158830,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158830,37.71,0.46,348,74731,70,NULL,NULL,'2MASX J22563747-0910245',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000175,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,344.156166667,-9.1735,0.093,NULL,50381452555,787210196,12300159,17.5),(158831,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158831,32.02,0.8,25.4,74732,75,NULL,NULL,'NGC 7418A',NULL,'1988NBGC.C....0000T',1988,1,3.7,NULL,'G',0.000013,NULL,'13.82',1.8,'SA(rs)d:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,344.171875,-36.77272,NULL,NULL,50701526010,792211343,12378302,13.82),(158832,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158832,32.71,0.43,34.8,74732,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7418A',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158833,'BL Lac Luminosity','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158833,40.98,NULL,1570,74733,70,NULL,'nucleus-to-host flux ratio, z > 0.47','PKS 2254-204',NULL,'2006AJ....132....1S',2006,1,NULL,NULL,'QSO',NULL,NULL,'17.5',NULL,'BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,344.1717083,-20.19458,0.064,NULL,50446831661,788231744,12316121,17.5),(158834,'CMD','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'N',158834,20.4,NULL,0.12,74734,NULL,NULL,NULL,'Grus 1',NULL,'2015ApJ...805..130K',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158835,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158835,38.5,0.46,501,74735,70,NULL,NULL,'SDSS J225642.70-004107.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,344.1779583,-0.6855,0.205,NULL,49497804762,773403199,12084424,18.5),(158836,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158836,34.76,NULL,89.5,74736,NULL,NULL,'B','ESO 534- G 032',NULL,'2005Ap&SS.298..577R',2005,1,1.22,NULL,'G',0.000077,NULL,'14.45',0.47,'SAB(s)c:',NULL,NULL,NULL,NULL,1,344.187125,-24.95253,0.059,NULL,50112064600,783001009,12234390,14.45),(158837,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158837,34.89,NULL,95.1,74736,NULL,NULL,'I','ESO 534- G 032',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158838,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158838,35.3,0.38,115,74736,NULL,NULL,NULL,'ESO 534- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158839,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158839,35.31,0.2,115,74736,74.4,NULL,NULL,'ESO 534- G 032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158840,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158840,35.32,0.38,116,74736,NULL,NULL,'Malmquist cor.','ESO 534- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158841,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SN 2005fx',NULL,158841,40.13,0.15,823,74737,74.2,NULL,'SALT 2','SDSS J225648.48+002402.0',0.29,'2010ApJ...716..712A',2010,1,0.09,NULL,'G',0.0005,NULL,'20.7g',0.05,NULL,NULL,NULL,NULL,NULL,1,344.2020417,0.40058,0.149,NULL,51699810570,807809540,12622024,20.7),(158842,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SN 2005fx',NULL,158842,40.68,0.06,1060,74737,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 02789, SN 2005fx','SDSS J225648.48+002402.0',0.29,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158843,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 02789','R',158843,40.81,0.24,1130,74737,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fx','SDSS J225648.48+002402.0',0.2903,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158844,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SN 2005fx',NULL,158844,40.27,0.15,1130,74737,70,NULL,'Hubble residual 0.12 for z0.29030','SDSS J225648.48+002402.0',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158845,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SN 2005fx',NULL,158845,40.89,0.17,1170,74737,70,NULL,'SALT 2','SDSS J225648.48+002402.0',0.29,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158846,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SN 2005fx',NULL,158846,40.88,NULL,1170,74737,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 02789, SN 2005fx','SDSS J225648.48+002402.0',0.29,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158847,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SN 2005fx',NULL,158847,40.89,0.16,1170,74737,65,NULL,'SALT2','SDSS J225648.48+002402.0',0.29,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158848,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 02789','R',158848,41.1,0.19,1290,74737,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fx','SDSS J225648.48+002402.0',0.2903,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158849,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SN 2005fx',NULL,158849,41.13,0.14,1300,74737,65,NULL,'MLCS2k2','SDSS J225648.48+002402.0',0.29,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158850,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SN 2005fx',NULL,158850,40.69,0.14,1370,74737,70,NULL,'SALT 2','SDSS J225648.48+002402.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158851,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SN 2005fx',NULL,158851,40.72,0.14,1390,74737,70,NULL,'SALT 2, Malmquist cor.','SDSS J225648.48+002402.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158852,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158852,37.36,0.46,296,74738,70,NULL,NULL,'2MASX J22564915+1406497',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000157,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,344.20475,14.11389,0.181,NULL,52556796964,821199952,12831249,17),(158853,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158853,36.09,0.46,165,74739,NULL,NULL,'Malmquist cor.','VV 488',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'GPair',NULL,NULL,NULL,NULL,'S+S',NULL,NULL,NULL,NULL,1,344.207917,-8.96917,0.093,NULL,50381232322,787206755,12300105,NULL),(158854,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158854,36.1,0.46,166,74739,NULL,NULL,NULL,'VV 488',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158855,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158855,31.93,0.8,24.3,74740,75,NULL,'MAT, I','IC 5264',NULL,'1997ApJS..109..333W',1997,1,2.5,'ESO-LV gives v=5018 and Nordgren (1998,ApJS,115,43) has v=5050 km/sec.','G',0.000033,NULL,'13.72',0.5,'Sab pec sp','X-ray-bright group member',NULL,NULL,NULL,1,344.221,-36.55417,NULL,NULL,50701468294,792210442,12378288,13.72),(158856,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158856,33.55,0.43,51.2,74740,75,NULL,'MAT, I, raw','IC 5264',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158857,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158857,33.65,0.32,53.7,74740,85,NULL,'I, raw','IC 5264',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158858,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158858,33.73,0.32,55.6,74740,85,NULL,'I, inv','IC 5264',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158859,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158859,33.76,0.43,56.5,74740,75,NULL,'MAT, I, cor','IC 5264',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158860,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158860,33.86,0.43,59,74740,75,NULL,'MAT, I, inv','IC 5264',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158861,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158861,32.99,0.8,39.7,74741,75,NULL,NULL,'UGC 12263',NULL,'1988NBGC.C....0000T',1988,1,2.8,NULL,'G',0.000013,NULL,'17.',1.8,'Im?',NULL,NULL,NULL,NULL,1,344.255458333,72.70853,2.453,NULL,52805992292,825093629,12892087,17),(158862,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 19201','RN',158862,40.33,0.13,1060,74742,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19201',0.100119,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158863,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 19201','RN',158863,40.56,0.27,1180,74742,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19201',0.100119,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158864,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158864,37.54,0.33,322,74743,70,NULL,NULL,'2MASX J22570246-0101410',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.0002,NULL,'16.2g',0.4,'E0',NULL,NULL,NULL,NULL,1,344.260375,-1.02797,0.189,NULL,49497462334,773397848,12084341,16.2),(158865,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 19209',NULL,158865,37.37,0.88,297,74744,70,NULL,'SN photometric redshift distance, z photo =0.072 +/- 0.038','SDSS-II SN 19209',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,344.2632917,-0.88775,0.205,NULL,49497450978,773397671,12084338,NULL),(158866,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 19209','R',158866,39.4,0.15,671,74744,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 19209',0.128384,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158867,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 19209','R',158867,39.53,0.21,713,74744,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 19209',0.128384,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158868,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158868,37.57,0.33,326,74745,70,NULL,NULL,'2MASX J22570477-0942094',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00015,NULL,'16.1g',0.44,'E0',NULL,NULL,NULL,NULL,1,344.269917,-9.70256,0.069,NULL,50381958584,787218102,12300282,16.1),(158869,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158869,35.62,0.65,133,74746,70,NULL,NULL,'2MASX J22570602-1406502',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.000103,NULL,'15.47',0.42,NULL,NULL,NULL,NULL,NULL,1,344.275041667,-14.11403,0.093,NULL,50404186694,787565417,12305709,15.47),(158870,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158870,37.54,0.33,322,74747,70,NULL,NULL,'2MASX J22570792-0100223',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,344.282917,-1.00625,0.205,NULL,49497492652,773398322,12084348,16.8),(158871,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158871,30.26,0.8,11.3,74748,75,NULL,NULL,'NGC 7412A',NULL,'1988NBGC.C....0000T',1988,1,5.11,'The APM data are for the brighter eastern end.','G',0.00001,NULL,'14.5',0.5,'SBdm: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,344.2875417,-42.80447,NULL,NULL,50487309592,788864212,12326003,14.5),(158872,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158872,27.08,0.38,2.61,74748,NULL,NULL,NULL,'NGC 7412A',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158873,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158873,30.03,NULL,10.2,74748,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 7412A',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158874,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158874,30.06,NULL,10.3,74748,NULL,NULL,'Dipole + Quadrupole','NGC 7412A',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158875,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158875,30.07,NULL,10.3,74748,NULL,NULL,'Dipole','NGC 7412A',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158876,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158876,30.19,0.4,10.9,74748,73,NULL,'opt','NGC 7412A',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158877,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158877,30.51,NULL,12.6,74748,NULL,NULL,NULL,'NGC 7412A',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158878,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158878,38.52,0.46,506,74749,70,NULL,NULL,'2MASX J22571050-1008354',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000191,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,344.2937083,-10.14311,0.061,NULL,50381576659,787212135,12300189,17.1),(158879,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158879,32.29,0.14,28.7,74750,74.4,NULL,NULL,'IC 1459',NULL,'2013AJ....146...86T',2013,1,5.2,'Confused HIPASS source','G',0.000039,NULL,'10.97',3.8,'E3             LINER','X-ray-bright group member',NULL,NULL,'Flat-Spectrum Radio Source',1,344.294208333,-36.46222,NULL,NULL,50701633112,792213017,12378328,10.97),(158880,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158880,32.33,0.28,29.2,74750,NULL,NULL,'I','IC 1459',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158881,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158881,32.33,0.28,29.2,74750,NULL,NULL,NULL,'IC 1459',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158882,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158882,32.41,0.28,30.4,74750,NULL,NULL,'Malmquist cor.','IC 1459',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158883,'D-Sigma','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158883,31.93,0.4,24.3,74750,75,NULL,'Edat, raw','IC 1459',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158884,'D-Sigma','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158884,32.26,0.4,28.3,74750,75,NULL,'Edat, cor','IC 1459',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158885,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158885,30.65,0.63,13.5,74750,95,NULL,'Michard 1979b, c','IC 1459',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158886,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158886,30.82,0.37,14.6,74750,95,NULL,'Weighted Mean','IC 1459',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158887,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158887,30.98,0.46,15.7,74750,95,NULL,'Michard 1979a','IC 1459',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158888,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158888,32.42,0.81,30.5,74750,55,NULL,'Visvanathan & Sandage 1979','IC 1459',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158889,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158889,32.45,NULL,30.9,74750,NULL,NULL,'LEDA [April 2006]','IC 1459',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158890,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158890,32.09,0.41,26.1,74750,NULL,NULL,NULL,'IC 1459',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158891,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158891,32.26,0.41,28.4,74750,NULL,NULL,'Malmquist cor.','IC 1459',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158892,'Tertiary','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158892,31.19,0.28,17.3,74750,95,NULL,NULL,'IC 1459',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158893,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158893,31.51,0.8,20,74750,75,NULL,'B','IC 1459',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158894,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158894,31.43,0.07,19.3,74750,71,NULL,'Grus Cluster','IC 1459',NULL,'1982PASAu...4..419V',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158895,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158895,38.48,0.46,496,74751,70,NULL,NULL,'2MASX J22571116-0008163',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000181,NULL,'17.5g',0.22,'NLAGN',NULL,NULL,NULL,'Sy 2',1,344.2965417,-0.13778,0.177,NULL,49497747183,773402299,12084410,17.5),(158896,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158896,30.33,0.63,11.6,74752,95,NULL,'Michard 1979b, c','IC 5267',NULL,'1984ApJS...56...91D',1984,1,5.2,NULL,'G',0.000013,NULL,'11.43',3.9,'(R)SA(rs)0/a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,344.3065417,-43.39614,0,NULL,50516847144,789325736,12333214,11.43),(158897,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158897,30.57,0.44,13,74752,95,NULL,'Weighted Mean','IC 5267',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158898,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158898,31,0.46,15.8,74752,95,NULL,'Michard 1979a','IC 5267',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158899,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158899,31.94,0.6,24.5,74752,70,NULL,NULL,'IC 5267',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158900,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158900,31.63,0.8,21.2,74752,75,NULL,'A82, H','IC 5267',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158901,'Tertiary','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158901,31.19,0.28,17.3,74752,95,NULL,NULL,'IC 5267',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158902,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158902,31.61,0.8,21,74752,75,NULL,'B','IC 5267',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158903,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158903,32.18,0.47,27.3,74752,75,NULL,'A82, H, raw','IC 5267',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158904,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158904,32.41,0.47,30.3,74752,75,NULL,'A82, H, cor','IC 5267',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158905,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158905,32.43,0.47,30.6,74752,75,NULL,'A82, H, inv','IC 5267',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158906,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158906,36.24,0.53,177,74753,70,NULL,NULL,'MCG -01-58-008',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000147,NULL,'15',0.4,NULL,NULL,NULL,NULL,NULL,1,344.307083,-3.16214,0.189,NULL,49522885877,773795091,12090548,15),(158907,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158907,34.99,0.56,99.6,74754,70,NULL,NULL,'2MASX J22571481-2058014',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'15.00',0.48,'E',NULL,NULL,NULL,NULL,1,344.3117083,-20.96708,0.116,NULL,50434559470,788039991,12313124,15),(158908,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 09326',NULL,158908,40.78,0.19,1430,74755,70,NULL,'SALT 2','SDSS J225715.88+003741.3',NULL,'2013ApJ...763...88C',2013,1,0.07,NULL,'G',0.01,NULL,'20.9g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,344.316166667,0.62817,0.153,NULL,51699837074,807809954,12622030,20.9),(158909,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 09326',NULL,158909,40.8,0.19,1450,74755,70,NULL,'SALT 2, Malmquist cor.','SDSS J225715.88+003741.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158910,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 09326','R',158910,41.49,0.29,1470,74755,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J225715.88+003741.3',0.35,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158911,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 09326','R',158911,41.68,0.26,1610,74755,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J225715.88+003741.3',0.35,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158912,'BL Lac Luminosity','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158912,39.93,NULL,814,74756,NULL,NULL,NULL,'[HB89] 2254+074',0.19,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',NULL,NULL,'16.4V',NULL,'Opt.var.       BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,344.322083,7.72008,0.145,NULL,52439015884,819359623,12802494,16.4),(158913,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158913,30.3,0.4,11.5,74757,75,NULL,'B','NGC 7424',NULL,'1988NBGC.C....0000T',1988,1,9.5,'Extended HIPASS source','G',0.000007,NULL,'10.96',8.1,'SAB(rs)cd','Possible group member',NULL,NULL,NULL,1,344.3265417,-41.07058,NULL,NULL,50489320315,788895629,12326494,10.96),(158914,'Ring Diameter','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158914,33,0.84,40,74758,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7428',NULL,'1981ApJS...45..541P',1981,1,2.4,NULL,'G',0.000017,NULL,'13.40',1.3,'(R)SAB(r)a pec:','Isolated galaxy',NULL,NULL,NULL,1,344.331375,-1.049,0.205,NULL,49497484620,773398197,12084346,13.4),(158915,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158915,37.57,0.33,326,74759,70,NULL,NULL,'2MASX J22572043-0946426',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,344.335083,-9.77842,0.069,NULL,50381954882,787218045,12300281,17.7),(158916,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158916,38.02,0.46,401,74760,70,NULL,NULL,'2MASX J22572463+0036109',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,344.352667,0.60317,0.153,NULL,51699789697,807809214,12622018,18),(158917,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158917,32.75,0.43,35.6,74761,75,NULL,'3.6 micron, color + selection bias corrected','ESO 603- G 031',NULL,'2014MNRAS.444..527S',2014,1,1.1,NULL,'G',0.000033,NULL,'14.77',0.7,'Sa',NULL,NULL,NULL,NULL,1,344.360125,-17.88558,0.064,NULL,50437556655,788086822,12313856,14.77),(158918,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 13058','RN',158918,39.7,0.19,733,74762,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13058',0.187103,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158919,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 13058','RN',158919,40.43,0.32,1030,74762,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13058',0.187103,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158920,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158920,37.97,0.46,392,74763,70,NULL,NULL,'2MASX J22572989-0907426',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,344.3745,-9.12858,0.093,NULL,50380244605,787191321,12299864,17.5),(158921,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 21837','RN',158921,43.11,0.4,3090,74764,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 21837',0.354712,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158922,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 21837','RN',158922,43.18,0.35,3190,74764,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 21837',0.354712,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158923,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158923,32.62,0.43,33.4,74765,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12265',NULL,'2014MNRAS.444..527S',2014,1,NULL,NULL,'GPair',NULL,NULL,NULL,NULL,'DBL SYS',NULL,NULL,NULL,NULL,1,344.398333,19.78667,0.181,NULL,52577977263,821530894,12836420,NULL),(158924,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158924,37.65,0.46,339,74766,70,NULL,NULL,'2MASX J22573684-0909066',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000163,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,344.403583,-9.15172,0.093,NULL,50380257323,787191520,12299867,17.1),(158925,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158925,34.92,0.49,96.2,74767,75,NULL,'IR','UGC 12264',NULL,'2011yCatp016004901K',2011,1,1.42,NULL,'G',0.00001,NULL,'17.0g',0.14,'Sd',NULL,NULL,NULL,NULL,1,344.4129583,12.91583,0.109,NULL,52558032409,821219256,12831550,17),(158926,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158926,35.14,NULL,107,74767,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12264',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158927,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158927,35.15,NULL,107,74767,NULL,NULL,'Dipole + Quadrupole','UGC 12264',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158928,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158928,35.15,NULL,107,74767,NULL,NULL,'Dipole','UGC 12264',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158929,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158929,35.16,NULL,107,74767,NULL,NULL,NULL,'UGC 12264',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158930,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158930,35.51,0.54,127,74767,NULL,NULL,NULL,'UGC 12264',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158931,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158931,35.58,0.2,131,74767,74.4,NULL,NULL,'UGC 12264',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158932,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158932,35.6,0.52,132,74767,NULL,NULL,'Malmquist cor.','UGC 12264',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158933,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 14228','RN',158933,42.3,0.25,2250,74768,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14228',0.281205,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158934,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 14228','RN',158934,42.47,0.34,2430,74768,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 14228',0.281205,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158935,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158935,37.28,0.46,285,74769,70,NULL,NULL,'SDSS J225742.75+001412.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00014,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,344.428125,0.23683,0.165,NULL,51699276400,807801193,12621893,17.7),(158936,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158936,37.85,0.46,372,74770,70,NULL,NULL,'2MASX J22574350+1420322',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000168,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,344.431166667,14.34242,0.133,NULL,52556971251,821202675,12831291,16.9),(158937,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158937,32.02,0.3,25.4,74771,NULL,NULL,'I','IC 5269',NULL,'2001ApJ...546..681T',2001,1,1.8,'MCG identification as IC 5270 in error.','G',0.000033,NULL,'13.19',0.8,'SAB(rs):','X-ray-bright group member',NULL,NULL,NULL,1,344.431917,-36.02622,NULL,NULL,50700912570,792201758,12378152,13.19),(158938,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158938,32.05,0.14,25.7,74771,74.4,NULL,NULL,'IC 5269',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158939,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158939,30.24,0.65,11.2,74771,95,NULL,'Weighted Mean','IC 5269',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158940,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158940,31.28,0.81,18,74771,55,NULL,'Visvanathan & Sandage 1979','IC 5269',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158941,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158941,32.15,0.8,26.9,74771,75,NULL,'B','IC 5269',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158942,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158942,37.46,0.23,310,74772,70,NULL,NULL,'2MASX J22574682+1406223',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,344.445,14.10631,0.165,NULL,52556925469,821201960,12831280,18.2),(158943,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158943,37.46,0.23,310,74773,70,NULL,NULL,'SDSS J225750.27+140848.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000141,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,344.4595,14.14683,0.165,NULL,52556939002,821202171,12831283,18.6),(158944,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158944,37.55,0.46,323,74774,70,NULL,NULL,'SDSS J225753.81-082806.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000128,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,344.47425,-8.46853,0.081,NULL,50372113229,787064269,12297879,18.4),(158945,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SN 1993L',NULL,158945,31.47,0.17,19.7,74775,70.8,NULL,NULL,'IC 5270',NULL,'2008MNRAS.389.1577T',2008,1,3.2,'Position in 1997AJ....113.1548C is incorrect.','G',0.000017,NULL,'12.99',0.6,'SB(rs)c        HII','X-ray-bright group member',NULL,NULL,NULL,1,344.478916667,-35.85806,NULL,NULL,50700956166,792202440,12378163,12.99),(158946,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SN 1993L','R',158946,31.9,NULL,24,74775,62.3,NULL,NULL,'IC 5270',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158947,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SN 1993L',NULL,158947,31.99,0.31,24.6,74775,65,NULL,'MLCS2k2','IC 5270',0.006616,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158948,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SN 1993L',NULL,158948,31.99,0.14,25,74775,60,NULL,NULL,'IC 5270',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158949,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158949,31.91,0.8,24.1,74775,75,NULL,'MAT, I','IC 5270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158950,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158950,31.91,0.8,24.1,74775,75,NULL,'A82, H','IC 5270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158951,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158951,30.92,0.47,15.3,74775,75,NULL,'A82, H, inv','IC 5270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158952,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158952,30.97,0.47,15.6,74775,75,NULL,'A82, H, raw','IC 5270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158953,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158953,30.99,0.4,15.8,74775,75,NULL,NULL,'IC 5270',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158954,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158954,30.99,0.4,15.8,74775,73,NULL,'IR','IC 5270',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158955,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158955,31.35,0.47,18.6,74775,75,NULL,'A82, H, cor','IC 5270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158956,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158956,31.56,0.49,20.5,74775,75,NULL,'IR','IC 5270',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158957,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158957,31.58,0.32,20.7,74775,85,NULL,'I, raw','IC 5270',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158958,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158958,31.59,0.32,20.8,74775,85,NULL,'I, inv','IC 5270',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158959,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158959,31.78,0.43,22.7,74775,75,NULL,'MAT, I, raw','IC 5270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158960,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158960,31.8,0.4,22.9,74775,NULL,NULL,'mean','IC 5270',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158961,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158961,31.87,0.39,23.7,74775,73,NULL,'opt','IC 5270',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158962,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158962,31.89,0.43,23.9,74775,75,NULL,'MAT, I, inv','IC 5270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158963,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158963,31.91,0.45,24.1,74775,NULL,NULL,NULL,'IC 5270',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158964,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158964,31.92,0.46,24.2,74775,NULL,NULL,'J','IC 5270',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158965,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158965,31.95,0.2,24.6,74775,74.4,NULL,NULL,'IC 5270',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158966,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158966,31.96,0.47,24.6,74775,NULL,NULL,'H','IC 5270',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158967,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158967,31.97,0.44,24.7,74775,NULL,NULL,'Malmquist cor.','IC 5270',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158968,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158968,32.01,0.43,25.3,74775,75,NULL,'MAT, I, cor','IC 5270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158969,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158969,32.04,0.45,25.6,74775,NULL,NULL,'K','IC 5270',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158970,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158970,37.63,0.33,336,74776,70,NULL,NULL,'2MASX J22575705+0054430',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,344.4877083,0.91206,0.157,NULL,51699671161,807807361,12621990,17.5),(158971,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158971,36.8,0.46,230,74777,70,NULL,NULL,'2MASX J22575732+0104160',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000193,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,344.488833,1.07117,0.145,NULL,51702497337,807851520,12622680,16.4),(158972,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158972,35.05,0.4,103,74778,NULL,NULL,'mean','NGC 7436B',NULL,'2007A&A...465...71T',2007,1,2,NULL,'G',0.00007,NULL,'14.0',2,'E',NULL,NULL,NULL,NULL,1,344.48975,26.14994,0.213,NULL,51908098822,811064044,12672875,14),(158973,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158973,35.15,0.45,107,74778,NULL,NULL,'K','NGC 7436B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158974,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158974,36.78,0.59,227,74779,70,NULL,NULL,'2MASX J22575980-0055198',NULL,'2014MNRAS.445.2677S',2014,1,0.28,NULL,'G',0.00015,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,344.499125,-0.92211,0.225,NULL,49500808117,773450126,12085158,16.6),(158975,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158975,37.46,0.23,310,74780,70,NULL,NULL,'SDSS J225759.98+140921.4',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00016,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,344.4999583,14.15594,0.165,NULL,52556928269,821202004,12831281,16.9),(158976,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158976,31.64,0.8,21.3,74781,75,NULL,'MAT, I','IC 5271',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.000029,NULL,'12.90',0.9,'Sb?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,344.507583,-33.74222,NULL,NULL,50083855061,782560235,12227503,12.9),(158977,'Sosies','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158977,31.89,0.11,23.9,74781,NULL,NULL,NULL,'IC 5271',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158978,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158978,31.61,0.47,21,74781,NULL,NULL,'H','IC 5271',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158979,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158979,31.62,0.46,21.1,74781,NULL,NULL,'J','IC 5271',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158980,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158980,31.64,0.4,21.3,74781,NULL,NULL,NULL,'IC 5271',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158981,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158981,31.64,0.45,21.3,74781,NULL,NULL,'K','IC 5271',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158982,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158982,31.64,0.4,21.3,74781,73,NULL,'opt','IC 5271',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158983,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158983,31.67,0.4,21.6,74781,NULL,NULL,'mean','IC 5271',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158984,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158984,31.78,0.32,22.7,74781,85,NULL,'I, raw','IC 5271',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158985,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158985,31.83,0.43,23.2,74781,75,NULL,'MAT, I, raw','IC 5271',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158986,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158986,31.83,0.32,23.2,74781,85,NULL,'I, inv','IC 5271',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158987,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158987,31.85,0.43,23.4,74781,75,NULL,'3.6 micron, color corrected','IC 5271',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158988,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158988,31.85,0.43,23.5,74781,75,NULL,'3.6 micron, color + selection bias corrected','IC 5271',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158989,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158989,31.92,0.2,24.2,74781,74.4,NULL,NULL,'IC 5271',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158990,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158990,32.04,0.43,25.6,74781,75,NULL,'MAT, I, inv','IC 5271',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158991,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158991,32.07,0.43,26,74781,75,NULL,'MAT, I, cor','IC 5271',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158992,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158992,34.81,0.46,91.6,74782,70,NULL,NULL,'NGC 7432',NULL,'2015arXiv151105856S',2015,1,0.98,NULL,'G',0.00013,NULL,'14.3g',0.73,'E',NULL,NULL,NULL,NULL,1,344.508083333,13.1345,0.149,NULL,52558018471,821219038,12831547,14.3),(158993,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158993,33.44,0.4,48.8,74783,NULL,NULL,'mean','ARP 314 NED01',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.00001,NULL,'13.7',0.9,'(R\')SA(s)bc: pec;HII','Pair member, contact system',NULL,NULL,NULL,1,344.509333,-3.76969,0.181,NULL,49525957492,773843085,12091298,13.7),(158994,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158994,33.89,0.47,60.1,74783,NULL,NULL,'H','ARP 314 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158995,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158995,33.91,0.45,60.6,74783,NULL,NULL,'K','ARP 314 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158996,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158996,33.95,0.46,61.7,74783,NULL,NULL,'J','ARP 314 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158997,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158997,34.22,0.49,69.7,74784,75,NULL,'IR','2MFGC 17270',NULL,'2011yCatp016004901K',2011,1,0.82,NULL,'G',0.000944,NULL,'15.90',0.13,NULL,NULL,NULL,NULL,NULL,1,344.511375,32.46631,0.333,NULL,51922732781,811292699,12676448,15.9),(158998,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 03729','RN',158998,39.27,0.27,569,74785,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 03729',0.254288,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158999,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 03729','RN',158999,40.64,0.3,1070,74785,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 03729',0.254288,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159000,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',159000,37.97,0.46,393,74786,70,NULL,NULL,'2MASX J22580700+0111179',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000174,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,344.5290417,1.18817,0.137,NULL,51702430857,807850482,12622663,17.5),(159001,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',159001,37.12,0.46,266,74787,70,NULL,NULL,'2MASX J22580802+1345084',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,344.533375,13.75244,0.153,NULL,52557626773,821212918,12831451,16.7),(159002,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',159002,37.63,0.15,336,74788,70,NULL,NULL,'2MASX J22580927-0914215',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,344.538625,-9.23939,0.093,NULL,50380265008,787191640,12299869,17.4),(159003,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',159003,37.63,0.15,336,74789,70,NULL,NULL,'2MASX J22580963-0929345',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,344.5402083,-9.49281,0.097,NULL,50381854100,787216470,12300257,17.6),(159004,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,159004,32.33,0.4,29.2,74790,75,NULL,'B','NGC 7437',NULL,'1988NBGC.C....0000T',1988,1,1.43,NULL,'G',0.000003,NULL,'14.3g',1.16,'SAB(rs)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,344.541917,14.3085,0.133,NULL,52556975203,821202737,12831292,14.3),(159005,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',159005,37.46,0.23,310,74791,70,NULL,NULL,'2MASX J22581296+1408424',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000139,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,344.554125,14.14514,0.165,NULL,52556901949,821201592,12831274,17.9),(159006,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',159006,37.63,0.15,336,74792,70,NULL,NULL,'2MASX J22581490-0917429',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,344.562041667,-9.29536,0.093,NULL,50380219755,787190933,12299858,17.1),(159007,'TRGB','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,159007,24.4,0.12,0.756,74793,NULL,NULL,NULL,'Andromeda XXXI',NULL,'2013ApJ...772...15M',2013,1,NULL,NULL,'G',0.000002,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,8.9975,51.55972,0.977,0,65830804625,1028606322,16071973,NULL),(159008,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,159008,35.42,0.47,121,74794,NULL,NULL,NULL,'ESO 346- G 021',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.23',0.7,'Sb',NULL,NULL,NULL,NULL,1,344.570208333,-38.94739,NULL,NULL,50483900241,788810941,12325170,15.23),(159009,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,159009,35.46,0.2,124,74794,74.4,NULL,NULL,'ESO 346- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159010,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,159010,35.57,0.44,130,74794,NULL,NULL,'Malmquist cor.','ESO 346- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159011,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,159011,35.02,0.4,101,74795,NULL,NULL,'mean','UGC 12272',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000033,NULL,'14.84',0.7,'Sa',NULL,NULL,NULL,NULL,1,344.573,25.77114,0.229,NULL,51907746610,811058540,12672789,14.84),(159012,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,159012,35.4,0.47,120,74795,NULL,NULL,'H','UGC 12272',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159013,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,159013,35.47,0.45,124,74795,NULL,NULL,'K','UGC 12272',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159014,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,159014,35.47,0.46,124,74795,NULL,NULL,'J','UGC 12272',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159015,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',159015,37.7,0.46,347,74796,70,NULL,NULL,'2MASX J22581951+1301485',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,344.581375,13.03011,0.149,NULL,52557816465,821215882,12831498,17.8),(159016,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,159016,34.77,0.47,90,74797,NULL,NULL,'H','UGC 12274',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000077,NULL,'15.4',0.5,'S','Group member',NULL,NULL,NULL,1,344.581583,26.06194,0.213,NULL,51908633140,811072392,12673006,15.4),(159017,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,159017,34.95,0.46,97.9,74797,NULL,NULL,'J','UGC 12274',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159018,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,159018,34.95,0.45,97.9,74797,NULL,NULL,'K','UGC 12274',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159019,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,159019,35.1,0.4,105,74797,NULL,NULL,'mean','UGC 12274',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159020,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',159020,34.78,0.46,90.4,74798,70,NULL,NULL,'NGC 7434',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000083,NULL,'15.0g',0.47,'SB?0-:',NULL,NULL,NULL,NULL,1,344.589375,-1.18394,0.181,NULL,49500870732,773451105,12085173,15),(159021,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159021,37.63,0.15,336,74799,70,NULL,NULL,'SDSS J225822.08-091952.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.3g',0.1,NULL,NULL,NULL,NULL,NULL,1,344.592,-9.33122,0.093,NULL,50380224389,787191006,12299859,18.3),(159022,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 15929','R',159022,41.3,0.17,1510,74800,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15929',0.203368,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,344.592333,-0.25256,0.149,NULL,49500416100,773444001,12085062,NULL),(159023,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159023,37.63,0.33,336,74801,70,NULL,NULL,'2MASX J22582447+0053599',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000142,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,344.601875,0.89986,0.145,NULL,51702523973,807851937,12622686,16.7),(159024,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159024,37.02,0.66,253,74802,70,NULL,NULL,'2MASX J22582754-0016016',NULL,'2014MNRAS.445.2677S',2014,1,0.86,NULL,'G',0.00015,NULL,'15.8g',0.32,'Sb',NULL,NULL,NULL,NULL,1,344.614667,-0.267,0.149,NULL,49500451868,773444560,12085071,15.8),(159025,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159025,35.38,0.38,119,74803,NULL,NULL,'Malmquist cor.','ESO 406- G 035',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.10',0.8,'Sc             HII',NULL,NULL,NULL,NULL,1,344.616833333,-32.24003,NULL,NULL,50095549959,782742968,12230358,14.1),(159026,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159026,35.41,0.47,121,74803,NULL,NULL,'H','ESO 406- G 035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159027,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159027,35.46,0.37,124,74803,NULL,NULL,NULL,'ESO 406- G 035',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159028,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159028,35.5,0.2,126,74803,74.4,NULL,NULL,'ESO 406- G 035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159029,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159029,35.51,0.46,126,74803,NULL,NULL,'J','ESO 406- G 035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159030,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159030,35.55,0.4,129,74803,NULL,NULL,'mean','ESO 406- G 035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159031,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159031,35.56,0.45,130,74803,NULL,NULL,'K','ESO 406- G 035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159032,'Horizontal Branch','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159032,21.22,0.15,0.175,74804,NULL,NULL,'M3/M13 (Fe/H=_1.5)','Pisces II',NULL,'2012ApJ...756...79S',2012,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'Poss. galactic',NULL,NULL,NULL,NULL,1,344.629167,5.9525,0.205,1,51713392775,808021762,12625340,NULL),(159033,'Horizontal Branch','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159033,21.3,NULL,0.182,74804,NULL,NULL,NULL,'Pisces II',NULL,'2010ApJ...712L.103B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159034,'Horizontal Branch','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159034,21.31,0.17,0.183,74804,NULL,NULL,'Adopted ([Fe/H]=_2.0)','Pisces II',NULL,'2012ApJ...756...79S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159035,'Horizontal Branch','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159035,21.36,0.12,0.187,74804,NULL,NULL,'M92 (Fe/H=_2.4)','Pisces II',NULL,'2012ApJ...756...79S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159036,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159036,38.05,0.46,408,74805,70,NULL,NULL,'2MASX J22583112+1320016',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000198,NULL,'17.2g',0.19,'BrClG',NULL,NULL,NULL,NULL,1,344.6297083,13.33383,0.133,NULL,52557292667,821207697,12831370,17.2),(159037,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159037,35.84,0.56,148,74806,70,NULL,NULL,'2MASX J22583104-0317476',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.00015,NULL,'16.14',0.35,NULL,NULL,NULL,NULL,NULL,1,344.632166667,-3.29994,0.201,NULL,49525774172,773840221,12091253,16.14),(159038,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159038,35.31,0.49,115,74807,75,NULL,'IR','FGC 2437',NULL,'2011yCatp016004901K',2011,1,0.88,NULL,'G',0.000016,NULL,'16.7',0.09,'Sc',NULL,NULL,NULL,NULL,1,344.635,10.98122,0.201,NULL,52443603670,819431307,12803614,16.7),(159039,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159039,35.78,NULL,144,74807,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2437',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159040,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159040,35.8,NULL,145,74807,NULL,NULL,'Dipole + Quadrupole','FGC 2437',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159041,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159041,35.82,NULL,146,74807,NULL,NULL,NULL,'FGC 2437',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159042,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159042,35.83,NULL,146,74807,NULL,NULL,'Dipole','FGC 2437',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159043,'Ring Diameter','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159043,33,0.84,40,74808,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7440',NULL,'1981ApJS...45..541P',1981,1,1.4,NULL,'G',0.000017,NULL,'14.40',1.1,'SB(r)a',NULL,NULL,NULL,NULL,1,344.635583333,35.80242,0.425,NULL,55516042948,867438171,13553721,14.4),(159044,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159044,37.63,0.15,336,74809,70,NULL,NULL,'SDSS J225834.49-092437.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,344.64375,-9.41047,0.093,NULL,50380210392,787190787,12299856,17.8),(159045,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159045,37.07,0.46,259,74810,70,NULL,NULL,'2MASX J22583633-0823269',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,344.651333,-8.39075,0.081,NULL,50372409863,787068904,12297951,17.1),(159046,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159046,35.56,0.49,130,74811,75,NULL,'IR','FGC 2438',NULL,'2011yCatp016004901K',2011,1,1.05,NULL,'G',0.000025,NULL,'16.0',0.11,'Scd',NULL,NULL,NULL,NULL,1,344.664417,19.06878,0.129,NULL,52576419739,821506558,12836039,16),(159047,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159047,35.87,NULL,149,74811,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2438',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159048,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159048,35.88,NULL,150,74811,NULL,NULL,'Dipole + Quadrupole','FGC 2438',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159049,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159049,35.89,NULL,150,74811,NULL,NULL,'Dipole','FGC 2438',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159050,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159050,35.91,NULL,152,74811,NULL,NULL,NULL,'FGC 2438',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159051,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159051,37.63,0.15,336,74812,70,NULL,NULL,'2MASX J22584051-0925139',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,344.6689583,-9.42058,0.093,NULL,50380669013,787197953,12299968,17.3),(159052,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159052,36.97,0.46,247,74813,70,NULL,NULL,'2MASX J22584881+0013456',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000198,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,344.7035417,0.22936,0.157,NULL,51702689076,807854516,12622726,16.5),(159053,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159053,37.63,0.15,336,74814,70,NULL,NULL,'2MASX J22584965-0927359',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000188,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,344.706917,-9.45989,0.093,NULL,50380541638,787195963,12299936,17.1),(159054,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159054,35.07,0.37,104,74815,NULL,NULL,NULL,'UGC 12278',NULL,'2009ApJS..182..474S',2009,1,0.77,'Perez-Gonzalex, et al. (2000A&AS..141..409P) give v = 7255 km/sec.','G',0.000017,NULL,'14.98',0.6,'Sc+            Sbrst',NULL,NULL,NULL,NULL,1,344.708083333,20.29869,0.137,NULL,52578489883,821538904,12836545,14.98),(159055,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159055,35.12,0.2,106,74815,74.4,NULL,NULL,'UGC 12278',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159056,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159056,35.18,0.35,109,74815,NULL,NULL,'Malmquist cor.','UGC 12278',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159057,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159057,37.63,0.15,336,74816,70,NULL,NULL,'2MASX J22585005-0926329',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,344.708583333,-9.4425,0.093,NULL,50380541387,787195959,12299936,17.9),(159058,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159058,34.83,0.49,92.7,74817,75,NULL,'IR','UGC 12279',NULL,'2011yCatp016004901K',2011,1,1.19,NULL,'G',NULL,NULL,'16.0',0.12,'Sc',NULL,NULL,NULL,NULL,1,344.710625,21.69211,0.173,NULL,52564928234,821327003,12833234,16),(159059,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159059,34.94,NULL,97.4,74817,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12279',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159060,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159060,34.96,NULL,98.1,74817,NULL,NULL,'Dipole + Quadrupole','UGC 12279',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159061,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159061,34.97,NULL,98.5,74817,NULL,NULL,'Dipole','UGC 12279',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159062,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159062,37.67,0.46,343,74818,70,NULL,NULL,'2MASX J22585088+0029006',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,344.712083,0.48347,0.161,NULL,51702916559,807858071,12622782,16.9),(159063,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159063,35.62,0.64,133,74819,70,NULL,NULL,'2MASX J22585267-0723439',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.24',0.39,NULL,NULL,NULL,NULL,NULL,1,344.719625,-7.39567,0.093,NULL,49486172549,773221446,12081585,16.24),(159064,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159064,36,0.49,159,74820,75,NULL,'IR','FGC 2439',NULL,'2011yCatp016004901K',2011,1,0.99,NULL,'G',0.000023,NULL,'16.6',0.11,'Sc',NULL,NULL,NULL,NULL,1,344.728167,5.98119,0.205,NULL,51713408410,808022006,12625343,16.6),(159065,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159065,36.3,NULL,182,74820,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2439',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159066,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159066,36.31,NULL,183,74820,NULL,NULL,'Dipole + Quadrupole','FGC 2439',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159067,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159067,36.33,NULL,184,74820,NULL,NULL,'Dipole','FGC 2439',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159068,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159068,36.45,NULL,195,74820,NULL,NULL,NULL,'FGC 2439',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159069,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159069,35.66,0.51,135,74821,70,NULL,NULL,'2MASX J22585543-0736539',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.51',0.3,NULL,NULL,NULL,NULL,NULL,1,344.7310417,-7.61494,0.085,NULL,49486090051,773220157,12081564,16.51),(159070,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159070,34.17,0.4,68.3,74822,NULL,NULL,'mean','UGC 12282',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000037,NULL,'13.0r',0.5,'Sa',NULL,NULL,NULL,'Sy 1.9',1,344.731166667,40.93147,0.513,NULL,55341082395,864704412,13511006,13),(159071,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159071,34.27,0.47,71.6,74822,NULL,NULL,'H','UGC 12282',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159072,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159072,34.28,0.45,71.9,74822,NULL,NULL,'K','UGC 12282',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159073,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159073,34.31,0.46,72.9,74822,NULL,NULL,'J','UGC 12282',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159074,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159074,34.44,0.49,77.2,74822,75,NULL,'IR','UGC 12282',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159075,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159075,38.13,0.46,422,74823,70,NULL,NULL,'2MASX J22585589+0051106',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,344.732917,0.85294,0.145,NULL,51702987080,807859173,12622799,18.2),(159076,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159076,34.06,0.49,64.8,74824,75,NULL,'IR','CGCG 453-037',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.00003,NULL,'15.4',0.2,NULL,NULL,NULL,NULL,NULL,1,344.738875,20.39128,0.137,NULL,52578512604,821539259,12836550,15.4),(159077,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159077,37.14,0.62,268,74825,70,NULL,NULL,'2MASX J22585838-2728423',NULL,'2014MNRAS.445.2677S',2014,1,0.67,'The APM image includes a brighter superposed star.','G',0.00015,NULL,'15.94',0.37,NULL,NULL,NULL,NULL,NULL,1,344.743333,-27.47842,0.043,NULL,50108424809,782944137,12233502,15.94),(159078,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159078,34.73,0.19,88.3,74826,NULL,NULL,'B, Hubble-type-TF','ESO 469- G 007',NULL,'2005Ap&SS.298..577R',2005,1,1.2,NULL,'G',0.000033,NULL,'14.26',0.7,'SAB(rs)c',NULL,NULL,NULL,NULL,1,344.7442083,-30.49394,NULL,NULL,50088169440,782627647,12228556,14.26),(159079,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159079,35,0.47,100,74826,NULL,NULL,NULL,'ESO 469- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159080,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159080,35.05,0.2,102,74826,74.4,NULL,NULL,'ESO 469- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159081,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159081,35.18,0.43,109,74826,NULL,NULL,'Malmquist cor.','ESO 469- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159082,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159082,36.56,0.8,205,74827,70,NULL,NULL,'LCRS B225610.7-453932',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'16.65',0.36,NULL,NULL,NULL,NULL,NULL,1,344.7625,-45.39075,0,NULL,50510220327,789222192,12331596,16.65),(159083,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159083,37.63,0.15,336,74828,70,NULL,NULL,'SDSS J225906.20-091952.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000174,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,344.775833,-9.33131,0.093,NULL,50380728371,787198880,12299982,17.8),(159084,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159084,34.28,0.49,71.8,74829,70,NULL,NULL,'2MASX J22590791-7224406',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.0I',0.6,NULL,NULL,NULL,NULL,NULL,1,344.783125,-72.41131,0.053,NULL,48444794148,756949908,11827342,13),(159085,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 14621',NULL,159085,41.59,NULL,2080,74830,70,NULL,'SN photometric redshift distance, z photo =0.700 +/- 0.001','SDSS-II SN 14621',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.3g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,344.786167,-0.11261,0.145,NULL,49499404871,773428201,12084815,21.3),(159086,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159086,32.49,0.2,31.5,74831,74.4,NULL,NULL,'UGC 12281',NULL,'2013AJ....146...86T',2013,1,3.44,NULL,'G',0.000003,NULL,'14.79',0.2,'Sd',NULL,NULL,NULL,NULL,1,344.803333,13.60667,0.141,NULL,52557481574,821210649,12831416,14.79),(159087,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159087,32.58,0.4,32.8,74831,NULL,NULL,NULL,'UGC 12281',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159088,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159088,32.68,0.43,34.4,74831,75,NULL,'3.6 micron, color corrected','UGC 12281',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159089,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159089,32.69,NULL,34.5,74831,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12281',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159090,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159090,32.7,NULL,34.6,74831,NULL,NULL,'Dipole + Quadrupole','UGC 12281',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159091,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159091,32.7,NULL,34.7,74831,NULL,NULL,'Dipole','UGC 12281',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159092,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159092,32.72,0.4,34.9,74831,75,NULL,'B','UGC 12281',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159093,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159093,32.74,0.43,35.4,74831,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12281',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159094,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159094,32.77,NULL,35.8,74831,NULL,NULL,NULL,'UGC 12281',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159095,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159095,37.51,0.46,317,74832,70,NULL,NULL,'2MASX J22591413+1455403',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000177,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,344.8089583,14.92792,0.145,NULL,52607063379,821985365,12843521,17.5),(159096,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159096,34.85,NULL,93.1,74833,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2442',NULL,'2010Ap&SS.325..163P',2010,1,0.68,NULL,'G',0.000021,NULL,'17.61',0.09,'Scd',NULL,NULL,NULL,NULL,1,344.81,26.38889,0.177,NULL,51906985899,811046654,12672603,17.61),(159097,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159097,34.85,NULL,93.4,74833,NULL,NULL,'Dipole + Quadrupole','FGC 2442',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159098,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159098,34.87,NULL,94.1,74833,NULL,NULL,'Dipole','FGC 2442',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159099,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159099,34.88,NULL,94.7,74833,NULL,NULL,NULL,'FGC 2442',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159100,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159100,35.42,0.2,121,74833,74.4,NULL,NULL,'FGC 2442',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159101,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159101,35.61,0.51,133,74833,NULL,NULL,NULL,'FGC 2442',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159102,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159102,35.65,0.5,135,74833,NULL,NULL,'Malmquist cor.','FGC 2442',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159103,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159103,37.46,0.46,311,74834,70,NULL,NULL,'2MASX J22591471+1330583',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,344.8112083,13.51619,0.141,NULL,52557268868,821207326,12831364,17.7),(159104,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159104,35.01,0.22,100,74835,NULL,NULL,'B, Hubble-type-TF','ESO 406- G 038',NULL,'2005Ap&SS.298..577R',2005,1,1,NULL,'G',0.000033,NULL,'15.46',0.7,'Sb-c',NULL,NULL,NULL,NULL,1,344.8262917,-32.60119,NULL,NULL,50081165140,782518205,12226846,15.46),(159105,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159105,35.7,0.49,138,74835,NULL,NULL,'Malmquist cor.','ESO 406- G 038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159106,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159106,36.04,0.42,161,74835,NULL,NULL,NULL,'ESO 406- G 038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159107,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159107,36.08,0.2,164,74835,74.4,NULL,NULL,'ESO 406- G 038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159108,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159108,38.34,0.46,465,74836,70,NULL,NULL,'2MASX J22592058+1427373',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,344.83575,14.46039,0.129,NULL,52558841026,821231891,12831748,17.6),(159109,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159109,38.14,0.46,425,74837,70,NULL,NULL,'2MASX J22592072+0013371',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,344.8362083,0.227,0.157,NULL,51700606268,807821972,12622218,18),(159110,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159110,34.06,0.46,64.9,74838,NULL,NULL,'J','UGC 12287',NULL,'2007A&A...465...71T',2007,1,1.4,'abs(b) < 10 degrees.','G',0.00002,NULL,'15.5',0.8,'Scd:',NULL,NULL,NULL,NULL,1,344.845417,53.74006,NULL,NULL,53374876746,833982449,13030975,15.5),(159111,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159111,34.12,0.47,66.7,74838,NULL,NULL,'H','UGC 12287',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159112,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159112,34.19,0.45,68.9,74838,NULL,NULL,'K','UGC 12287',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159113,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159113,34.2,0.4,69,74838,NULL,NULL,'mean','UGC 12287',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159114,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159114,37.38,0.46,299,74839,70,NULL,NULL,'2MASX J22592345+1251513',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000123,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,344.8477083,12.86419,0.173,NULL,52555982152,821187221,12831050,16.9),(159115,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159115,37.18,0.46,273,74840,70,NULL,NULL,'2MASX J22592367+1436053',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,344.848625,14.60156,0.145,NULL,52558886494,821232601,12831759,17.2),(159116,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159116,35.82,0.51,146,74841,70,NULL,NULL,'2MASX J22592515-6929494',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.1I',0.2,NULL,NULL,NULL,NULL,NULL,1,344.855083333,-69.49706,0.029,NULL,49269288787,769832637,12028634,14.1),(159117,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159117,37.63,0.15,336,74842,70,NULL,NULL,'2MASX J22592534-0929486',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00015,NULL,'16.0g',0.45,'E0',NULL,NULL,NULL,NULL,1,344.8554583,-9.49697,0.093,NULL,50380593095,787196767,12299949,16),(159118,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159118,31.05,0.8,16.2,74843,75,NULL,'MAT, I','IC 5273',NULL,'1997ApJS..109..333W',1997,1,2.7,NULL,'G',0.000019,NULL,'12.22',1.8,'SB(rs)cd       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,344.86125,-37.70289,NULL,NULL,50484249348,788816396,12325256,12.22),(159119,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159119,31.07,0.8,16.3,74843,75,NULL,'A82, H','IC 5273',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159120,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159120,30.67,0.4,13.6,74843,NULL,NULL,'mean','IC 5273',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159121,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159121,30.69,0.43,13.7,74843,75,NULL,'3.6 micron, color + selection bias corrected','IC 5273',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159122,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159122,30.75,0.32,14.1,74843,85,NULL,'I, raw','IC 5273',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159123,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159123,30.75,0.32,14.1,74843,85,NULL,'I, inv','IC 5273',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159124,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159124,30.82,0.43,14.6,74843,75,NULL,'3.6 micron, color corrected','IC 5273',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159125,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159125,30.84,0.35,14.7,74843,NULL,NULL,NULL,'IC 5273',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159126,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159126,30.84,0.39,14.7,74843,73,NULL,'opt','IC 5273',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159127,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159127,30.96,0.2,15.6,74843,74.4,NULL,NULL,'IC 5273',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159128,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159128,31.02,0.4,16,74843,75,NULL,'B','IC 5273',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159129,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159129,31.04,0.43,16.1,74843,75,NULL,'MAT, I, raw','IC 5273',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159130,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159130,31.1,0.46,16.6,74843,NULL,NULL,'J','IC 5273',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159131,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159131,31.12,0.47,16.7,74843,NULL,NULL,'H','IC 5273',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159132,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159132,31.12,0.45,16.8,74843,NULL,NULL,'K','IC 5273',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159133,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159133,31.12,0.47,16.8,74843,75,NULL,'A82, H, inv','IC 5273',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159134,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159134,31.13,0.47,16.8,74843,75,NULL,'A82, H, raw','IC 5273',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159135,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159135,31.14,0.43,16.9,74843,75,NULL,'MAT, I, inv','IC 5273',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159136,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159136,31.35,0.43,18.6,74843,75,NULL,'MAT, I, cor','IC 5273',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159137,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159137,31.48,0.47,19.7,74843,75,NULL,'A82, H, cor','IC 5273',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159138,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159138,36.97,0.46,248,74844,70,NULL,NULL,'2MASX J22592700+1256483',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000141,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,344.862375,12.94686,0.193,NULL,52555995387,821187427,12831053,17.7),(159139,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159139,38.33,0.46,463,74845,70,NULL,NULL,'SDSS J225928.56+001826.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000128,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,344.869,0.30725,0.161,NULL,51700599092,807821860,12622216,18.8),(159140,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159140,37.32,0.46,291,74846,70,NULL,NULL,'2MASX J22593239+1522372',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000175,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,344.885083,15.37714,0.133,NULL,52607259188,821988424,12843569,16.7),(159141,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 05470','RN',159141,42.3,0.48,2230,74847,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 05470',0.291687,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159142,'Tertiary','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'N',159142,27.84,0.82,3.7,74848,NULL,NULL,NULL,'AF7448_001',NULL,'2014MNRAS.442L..46T',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159143,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'N',159143,26.15,NULL,1.7,74848,NULL,NULL,'minimum','AF7448_001',NULL,'2014MNRAS.442L..46T',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159144,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'N',159144,29.49,NULL,7.9,74848,NULL,NULL,NULL,'AF7448_001',NULL,'2014MNRAS.442L..46T',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159145,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 18628','RN',159145,41.27,0.19,1420,74849,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18628',0.260899,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159146,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 18628','RN',159146,41.93,0.24,1930,74849,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18628',0.260899,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159147,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159147,35.19,0.2,109,74850,74.4,NULL,NULL,'CGCG 430-043',NULL,'2013AJ....146...86T',2013,1,0.91,NULL,'G',0.000013,NULL,'15.3g',0.37,'S?',NULL,NULL,NULL,NULL,1,344.899375,14.08953,0.129,NULL,52558903539,821232867,12831763,15.3),(159148,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159148,36.12,0.33,167,74851,70,NULL,NULL,'2MASX J22593625+1322112',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000182,NULL,'15.6g',0.48,'E0',NULL,NULL,NULL,NULL,1,344.901083,13.36986,0.141,NULL,52559094062,821235844,12831810,15.6),(159149,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159149,36.12,0.33,167,74852,70,NULL,NULL,'2MASX J22593653+1317482',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00014,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,344.90225,13.29658,0.141,NULL,52557251837,821207059,12831360,16.7),(159150,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159150,33.39,0.69,47.7,74853,100,NULL,'mid-IR','MCG +00-58-018',NULL,'2013ApJ...771...88L',2013,1,0.7,NULL,'G',0.000027,NULL,'15',0.3,NULL,NULL,NULL,NULL,NULL,1,344.905291667,2.34422,0.221,NULL,51734632898,808353639,12630525,15),(159151,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159151,34.48,0.2,78.7,74853,74.4,NULL,NULL,'MCG +00-58-018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159152,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159152,34.87,0.8,94.4,74854,75,NULL,'MAT, I','UGC 12290',NULL,'1997ApJS..109..333W',1997,1,1.84,NULL,'G',0.000009,NULL,'15.60',0.22,'Sbc',NULL,NULL,NULL,NULL,1,344.9062917,24.84767,0.149,NULL,51894740150,810855314,12669614,15.6),(159153,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159153,34.88,0.8,94.8,74854,75,NULL,'W91PP, r','UGC 12290',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159154,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159154,34.71,0.43,87.5,74854,75,NULL,'MAT, I, raw','UGC 12290',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159155,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159155,34.72,0.49,87.7,74854,75,NULL,'IR','UGC 12290',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159156,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159156,34.8,0.32,91.1,74854,85,NULL,'I, raw','UGC 12290',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159157,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159157,34.84,0.32,93.1,74854,85,NULL,'I, inv','UGC 12290',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159158,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159158,34.92,0.43,96.6,74854,75,NULL,'MAT, I, inv','UGC 12290',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159159,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159159,34.97,NULL,98.6,74854,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12290',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159160,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159160,34.98,NULL,99,74854,NULL,NULL,'Dipole + Quadrupole','UGC 12290',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159161,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159161,34.98,NULL,99.1,74854,NULL,NULL,'Dipole','UGC 12290',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159162,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159162,35,0.43,100,74854,75,NULL,'MAT, I, cor','UGC 12290',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159163,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159163,35.02,0.4,101,74854,NULL,NULL,'mean','UGC 12290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159164,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159164,35.02,NULL,101,74854,NULL,NULL,NULL,'UGC 12290',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159165,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159165,35.06,0.47,103,74854,NULL,NULL,'H','UGC 12290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159166,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159166,35.13,0.38,106,74854,75,NULL,'W91PP, r, raw','UGC 12290',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159167,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159167,35.13,0.45,106,74854,NULL,NULL,'K','UGC 12290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159168,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159168,35.15,0.31,107,74854,NULL,NULL,NULL,'UGC 12290',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159169,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159169,35.15,0.31,107,74854,NULL,NULL,'Malmquist cor.','UGC 12290',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159170,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159170,35.21,0.2,110,74854,74.4,NULL,NULL,'UGC 12290',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159171,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159171,35.27,0.38,113,74854,75,NULL,'W91PP, r, cor','UGC 12290',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159172,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159172,35.33,0.38,116,74854,75,NULL,'W91PP, r, inv','UGC 12290',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159173,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159173,36.62,0.56,210,74855,70,NULL,NULL,'2MASX J22593938-1141295',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.53',NULL,NULL,NULL,NULL,NULL,NULL,1,344.913833,-11.6915,0.089,NULL,50405073073,787579266,12305926,16.53),(159174,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159174,34.33,0.93,73.4,74856,NULL,NULL,NULL,'UGC 12288',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'GPair',0.000017,NULL,NULL,NULL,'S?',NULL,NULL,NULL,NULL,1,344.915,20.14389,0.169,NULL,52579673978,821557405,12836834,NULL),(159175,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159175,34.37,0.2,74.8,74856,74.4,NULL,NULL,'UGC 12288',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159176,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159176,34.72,0.78,87.8,74856,NULL,NULL,'Malmquist cor.','UGC 12288',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159177,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2005ku',NULL,159177,35.67,0.13,130,74857,74.2,NULL,'SALT 2','2MASX J22594265-0000478',0.045,'2010ApJ...716..712A',2010,1,0.13,NULL,'G',0.000079,NULL,'16.7g',0.07,NULL,NULL,NULL,NULL,NULL,1,344.92775,-0.01356,0.141,NULL,49499491682,773429557,12084836,16.7),(159178,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2005ku',NULL,159178,36.42,0.11,176,74857,72,NULL,NULL,'2MASX J22594265-0000478',0.04421,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159179,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2005ku',NULL,159179,36.25,0.1,178,74857,74.4,NULL,NULL,'2MASX J22594265-0000478',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159180,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2005ku',NULL,159180,36.28,0.1,180,74857,70,NULL,'SALT 2','2MASX J22594265-0000478',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159181,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2005ku',NULL,159181,36.28,0.1,180,74857,70,NULL,'SALT 2, Malmquist cor.','2MASX J22594265-0000478',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159182,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2005ku',NULL,159182,36.39,0.16,181,74857,70,NULL,'SALT 2','2MASX J22594265-0000478',0.045,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159183,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2005ku','R',159183,36.58,0.13,207,74857,NULL,NULL,'MLCS2k2, R(V) = 3.1','2MASX J22594265-0000478',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159184,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2005ku','R',159184,36.59,0.1,208,74857,NULL,NULL,'MLCS2k2, R(V) = 1.8','2MASX J22594265-0000478',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159185,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 10805','R',159185,36.68,0.07,208,74857,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ku','2MASX J22594265-0000478',0.045439,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159186,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 10805','R',159186,37.28,0.28,274,74857,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ku','2MASX J22594265-0000478',0.045439,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159187,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159187,37.87,0.33,376,74858,70,NULL,NULL,'2MASX J22594605+0002311',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000166,NULL,'17.2g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,344.9419583,0.04203,0.141,NULL,51700665738,807822902,12622232,17.2),(159188,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159188,35.07,0.8,103,74859,75,NULL,'W91PP, r','UGC 12291',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000007,NULL,'15.15',0.9,'Scd:',NULL,NULL,NULL,NULL,1,344.951375,26.30217,0.189,NULL,51906998007,811046843,12672606,15.15),(159189,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159189,35.14,0.38,106,74859,75,NULL,'W91PP, r, raw','UGC 12291',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159190,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159190,35.27,0.38,113,74859,75,NULL,'W91PP, r, cor','UGC 12291',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159191,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159191,35.28,0.38,114,74859,75,NULL,'W91PP, r, inv','UGC 12291',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159192,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159192,35.3,0.41,115,74859,NULL,NULL,'Malmquist cor.','UGC 12291',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159193,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159193,35.44,0.39,123,74859,NULL,NULL,NULL,'UGC 12291',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159194,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159194,35.48,0.2,125,74859,74.4,NULL,NULL,'UGC 12291',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159195,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 06520','RN',159195,39.21,0.2,627,74860,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 06520',0.109067,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159196,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 06520','RN',159196,39.35,0.09,668,74860,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 06520',0.109067,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159197,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159197,35.19,0.53,109,74861,NULL,NULL,NULL,'ESO 147- G 017',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'15.32',0.35,'SB(s)c',NULL,NULL,NULL,NULL,1,344.9567083,-61.56478,0,NULL,48766929898,761983279,11905988,15.32),(159198,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159198,35.23,0.2,111,74861,74.4,NULL,NULL,'ESO 147- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159199,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159199,35.36,0.48,118,74861,NULL,NULL,'Malmquist cor.','ESO 147- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159200,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159200,37.87,0.33,376,74862,70,NULL,NULL,'SDSS J225953.38-000507.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00014,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,344.9724583,-0.08553,0.141,NULL,49499502642,773429728,12084839,18.7),(159201,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 19599',NULL,159201,40.29,1.3,1140,74863,70,NULL,'SN photometric redshift distance, z photo =0.315 +/- 0.385','SDSS-II SN 19599',NULL,'2011ApJ...738..162S',2011,1,0.03,NULL,'G',NULL,'PHOT','22.7g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,344.975375,1.16475,0.185,NULL,51703083299,807860676,12622823,22.7),(159202,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 19599','R',159202,41.91,0.4,1600,74863,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 19599',0.507535,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159203,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 19599',NULL,159203,42.04,0.33,2560,74863,70,NULL,'SALT 2','SDSS-II SN 19599',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159204,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 19599',NULL,159204,42.19,0.33,2740,74863,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19599',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159205,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 15486','RN',159205,38.99,0.13,563,74864,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15486',0.116007,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159206,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 15486','RN',159206,39.2,0.2,620,74864,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15486',0.116007,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159207,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 06216','RN',159207,40.73,0.18,1190,74865,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06216',0.175564,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159208,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 06216','RN',159208,40.86,0.27,1260,74865,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06216',0.175564,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159209,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159209,37.79,0.23,361,74866,70,NULL,NULL,'2MASXi J2300024-095518',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,345.010375,-9.92172,0.073,NULL,50380954335,787202411,12300037,17.9),(159210,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 1997dt',NULL,159210,32.08,0.17,26.1,74867,70.8,NULL,NULL,'NGC 7448',NULL,'2008MNRAS.389.1577T',2008,1,2.7,NULL,'G',0.000003,NULL,'12.20',1.2,'SA(rs)bc','X-ray-faint group member',NULL,NULL,NULL,1,345.014958333,15.98033,0.137,NULL,52607747865,821996060,12843688,12.2),(159211,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 1997dt',NULL,159211,32.25,0.09,28.2,74867,74.4,NULL,NULL,'NGC 7448',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159212,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 1997dt',NULL,159212,32.49,0.42,31.2,74867,74.2,NULL,'SALT 2','NGC 7448',0.007318,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159213,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 1997dt',NULL,159213,32.72,0.19,34.5,74867,65,NULL,'MLCS2k2','NGC 7448',0.007318,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159214,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 1997dt',NULL,159214,33.19,0.14,43.5,74867,60,NULL,NULL,'NGC 7448',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159215,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 1997dt',NULL,159215,33.28,0.44,45,74867,70,NULL,'SALT','NGC 7448',0.007318,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159216,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159216,32.23,0.8,28,74867,75,NULL,'CF, r','NGC 7448',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159217,'Sosies','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159217,30.88,0.46,15,74867,NULL,NULL,NULL,'NGC 7448',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159218,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159218,32.41,0.8,30.3,74867,75,NULL,'B','NGC 7448',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159219,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159219,31.51,0.43,20.1,74867,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7448',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159220,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159220,31.57,0.43,20.6,74867,75,NULL,'3.6 micron, color corrected','NGC 7448',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159221,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159221,31.73,0.37,22.2,74867,NULL,NULL,NULL,'NGC 7448',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159222,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159222,31.73,0.39,22.2,74867,73,NULL,'opt','NGC 7448',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159223,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159223,31.74,0.69,22.3,74867,100,NULL,'mid-IR','NGC 7448',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159224,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159224,31.75,0.46,22.4,74867,NULL,NULL,'J','NGC 7448',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159225,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159225,31.78,0.42,22.7,74867,NULL,18.48,'3.6 micron','NGC 7448',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159226,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159226,31.79,0.54,22.8,74867,NULL,NULL,'Malmquist cor.','NGC 7448',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159227,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159227,31.79,0.4,22.8,74867,75,NULL,'HOSTS SN 1997dt','NGC 7448',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159228,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159228,31.83,0.47,23.2,74867,NULL,NULL,'H','NGC 7448',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159229,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159229,31.84,0.45,23.3,74867,NULL,NULL,'K','NGC 7448',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159230,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159230,31.97,0.49,24.8,74867,NULL,NULL,NULL,'NGC 7448',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159231,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159231,31.99,0.38,25,74867,75,NULL,'CF, r, raw','NGC 7448',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159232,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159232,32.05,0.4,25.7,74867,75,NULL,'HOSTS SN 1997dt','NGC 7448',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159233,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159233,32.1,0.38,26.3,74867,75,NULL,'CF, r, inv','NGC 7448',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159234,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159234,32.18,0.4,27.3,74867,NULL,NULL,'mean','NGC 7448',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159235,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159235,32.2,0.38,27.6,74867,75,NULL,'CF, r, cor','NGC 7448',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159236,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159236,32.25,0.09,28.2,74867,74.4,NULL,NULL,'NGC 7448',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159237,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159237,35.33,NULL,117,74868,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2444',NULL,'2010Ap&SS.325..163P',2010,1,0.58,NULL,'G',0.000025,NULL,'17.2g',0.16,'Sbc',NULL,NULL,NULL,NULL,1,345.015667,15.01961,0.157,NULL,52551531192,821117674,12829963,17.2),(159238,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159238,35.33,NULL,117,74868,NULL,NULL,'Dipole + Quadrupole','FGC 2444',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159239,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159239,35.34,NULL,117,74868,NULL,NULL,'Dipole','FGC 2444',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159240,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159240,35.51,NULL,126,74868,NULL,NULL,NULL,'FGC 2444',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159241,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159241,37.17,0.46,271,74869,70,NULL,NULL,'2MASX J23000498+1515173',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000185,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,345.020917,15.25481,0.153,NULL,52607295399,821988990,12843577,16.5),(159242,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 13045','R',159242,39.61,0.2,708,74870,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006fn','SN 2006fn',0.1806,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,345.024917,0.53767,0.161,NULL,51702763616,807855681,12622745,NULL),(159243,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 13045','R',159243,39.72,0.11,743,74870,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006fn','SN 2006fn',0.1806,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159244,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 10460',NULL,159244,39.41,0.61,762,74871,70,NULL,'SN photometric redshift distance, z photo =0.197 +/- 0.074','SDSS-II SN 10460',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.3g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,345.029167,-1.20383,0.169,NULL,49501035320,773453676,12085213,21.3),(159245,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 10460','R',159245,40.28,0.26,932,74871,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 10460',0.220342,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159246,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 10460','R',159246,40.6,0.34,1080,74871,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 10460',0.220342,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159247,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159247,36.19,0.8,173,74872,70,NULL,NULL,'2MASX J23000727-0402259',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.01',0.37,'poss. LINER?',NULL,NULL,NULL,NULL,1,345.030333,-4.0405,0.205,NULL,49526175302,773846489,12091351,16.01),(159248,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 19197','RN',159248,39.46,6.48,662,74873,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19197',0.179707,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159249,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','PTF10twd','N',159249,37.63,0.03,313,74874,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10twd',0.0734,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159250,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 1999dr',NULL,159250,38.72,0.24,469,74875,74.2,NULL,'SALT 2','SDSS J230017.30-000515.4',0.182,'2010ApJ...716..712A',2010,1,0.13,NULL,'G',NULL,NULL,'19.82',0.13,NULL,NULL,NULL,NULL,NULL,1,345.072083,-0.08764,0.141,NULL,49499530314,773430161,12084846,19.82),(159251,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 1999dr',NULL,159251,39.79,0.18,768,74875,NULL,NULL,'M(B) = -19.31','SDSS J230017.30-000515.4',0.182,'2008A&A...486..375A',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159252,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159252,35.61,0.8,133,74876,75,NULL,'CF, r','UGC 12296',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000017,NULL,'15.19',0.4,'Scd:',NULL,NULL,NULL,NULL,1,345.074083333,19.12597,0.129,NULL,52575951152,821499236,12835925,15.19),(159253,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159253,35.52,0.38,127,74876,75,NULL,'CF, r, raw','UGC 12296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159254,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159254,35.69,0.38,137,74876,75,NULL,'CF, r, inv','UGC 12296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159255,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159255,35.82,0.38,146,74876,75,NULL,'CF, r, cor','UGC 12296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159256,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159256,37.79,0.23,361,74877,70,NULL,NULL,'SDSS J230020.36-095028.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,345.084875,-9.84114,0.069,NULL,50380440978,787194390,12299912,18.2),(159257,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159257,37.79,0.23,361,74878,70,NULL,NULL,'SDSS J230023.40-094849.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,345.0975417,-9.81369,0.069,NULL,50380453293,787194582,12299915,18.2),(159258,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159258,33.82,0.47,58.1,74879,NULL,NULL,NULL,'UGC 12295',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000193,NULL,'14.95',0.9,'SAB(s)cd:',NULL,NULL,NULL,NULL,1,345.098791667,1.62653,0.177,NULL,51701442733,807835042,12622422,14.95),(159259,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159259,33.86,0.2,59.2,74879,74.4,NULL,NULL,'UGC 12295',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159260,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159260,33.98,0.44,62.6,74879,NULL,NULL,'Malmquist cor.','UGC 12295',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159261,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159261,37.79,0.23,361,74880,70,NULL,NULL,'2MASX J23002763-0955213',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,345.115083,-9.92261,0.069,NULL,50380959260,787202488,12300038,16.8),(159262,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159262,35.41,0.46,121,74881,70,NULL,NULL,'2MASX J23002860-1022463',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000103,NULL,'15.8g',0.44,'S0',NULL,NULL,NULL,NULL,1,345.1192917,-10.37933,0.105,NULL,50379314128,787176783,12299637,15.8),(159263,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159263,37.45,0.46,310,74882,70,NULL,NULL,'2MASX J23003145-1031303',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000176,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,345.1309583,-10.52506,0.105,NULL,50379320892,787176888,12299638,16.9),(159264,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159264,34.69,0.5,86.7,74883,NULL,NULL,'Malmquist cor.','NGC 7451',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.82',0.5,'SBbc','Isolated galaxy',NULL,NULL,NULL,1,345.17025,8.46792,0.133,NULL,52438475683,819351182,12802362,14.82),(159265,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159265,34.7,0.2,87.1,74883,74.4,NULL,NULL,'NGC 7451',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159266,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159266,34.78,0.48,90.3,74883,NULL,NULL,NULL,'NGC 7451',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159267,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159267,34.82,0.4,92.2,74883,NULL,NULL,'mean','NGC 7451',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159268,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159268,35.06,0.47,103,74883,NULL,NULL,'H','NGC 7451',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159269,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159269,37.28,0.46,286,74884,70,NULL,NULL,'2MASX J23004375+1418041',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000184,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,345.182375,14.30122,0.145,NULL,52559808050,821247000,12831984,16.6),(159270,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 09174','RN',159270,43.92,0.47,3920,74885,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 09174',0.550523,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159271,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159271,34.84,0.47,92.9,74886,NULL,NULL,'H','UGC 12303',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000007,NULL,'14.37',1.2,'Sb',NULL,NULL,NULL,NULL,1,345.204667,26.74075,0.177,NULL,51907032786,811047387,12672615,14.37),(159272,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159272,34.99,0.46,99.4,74886,NULL,NULL,'J','UGC 12303',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159273,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159273,35.01,0.45,100,74886,NULL,NULL,'K','UGC 12303',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159274,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159274,35.17,0.4,108,74886,NULL,NULL,'mean','UGC 12303',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159275,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2006hf',NULL,159275,39.57,0.08,822,74887,70,NULL,'Hubble residual -0.04 for z0.21930','SDSS-II SN 13641 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,345.2175,-0.98203,0.157,NULL,49500218807,773440918,12085014,NULL),(159276,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 13641','R',159276,40.11,0.2,870,74887,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006hf','SDSS-II SN 13641 HOST',0.21,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159277,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 13641','R',159277,40.21,0.11,911,74887,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006hf','SDSS-II SN 13641 HOST',0.21,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159278,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 05141','RN',159278,43.72,0.31,3850,74888,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 05141',0.443519,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159279,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 05141','RN',159279,44.1,0.4,4580,74888,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 05141',0.443519,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159280,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159280,30.35,0.1,11.7,74889,NULL,NULL,'I','NGC 7457',NULL,'1997AJ....114..626A',1997,1,4.3,NULL,'G',0.000017,NULL,'12.09',2.3,'SA(rs)0-?','in a pair',NULL,NULL,NULL,1,345.2497083,30.14494,0.205,NULL,51918098929,811220295,12675317,12.09),(159281,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159281,30.41,0.14,12.1,74889,74.4,NULL,NULL,'NGC 7457',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159282,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159282,30.45,0.21,12.3,74889,NULL,NULL,'I','NGC 7457',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159283,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159283,30.61,0.21,13.2,74889,NULL,NULL,'I','NGC 7457',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159284,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159284,30.66,0.23,13.6,74889,NULL,NULL,'HST KP Calibrated, I','NGC 7457',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159285,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159285,30.76,0.15,14.2,74889,NULL,NULL,'HST KP Calibrated, F814W','NGC 7457',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159286,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159286,30.45,0.81,12.3,74889,55,NULL,'Visvanathan & Sandage 1979','NGC 7457',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159287,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159287,30.49,0.37,12.5,74889,95,NULL,'Weighted Mean','NGC 7457',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159288,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159288,30.89,0.63,15.1,74889,95,NULL,'Michard 1979b, c','NGC 7457',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159289,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159289,31.27,0.46,17.9,74889,95,NULL,'Michard 1979a','NGC 7457',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159290,'Tertiary','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159290,30.56,0.25,12.9,74889,95,NULL,NULL,'NGC 7457',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159291,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159291,30.46,0.8,12.3,74889,75,NULL,'B','NGC 7457',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159292,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 06913',NULL,159292,40.2,0.22,1100,74890,70,NULL,'SN photometric redshift distance, z photo =0.299 +/- 0.039','SDSS-II SN 06913',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.4g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,345.249875,1.03678,0.165,NULL,51702314469,807848663,12622635,21.4),(159293,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 06913','R',159293,41.34,0.33,1340,74890,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06913',0.381163,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159294,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 06913','R',159294,41.37,0.3,1360,74890,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06913',0.381163,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159295,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 06913',NULL,159295,41.07,0.23,1640,74890,70,NULL,'SALT 2','SDSS-II SN 06913',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159296,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 06913',NULL,159296,41.13,0.23,1680,74890,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 06913',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159297,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159297,38.09,0.46,415,74891,70,NULL,NULL,'2MASX J23010249+1403281',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,345.260291667,14.05769,0.145,NULL,52559824135,821247252,12831988,17.2),(159298,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2005jg',NULL,159298,40.32,0.14,891,74892,74.2,NULL,'SALT 2','SDSS J230102.96-001224.7',0.3,'2010ApJ...716..712A',2010,1,0.07,NULL,'G',0.005,NULL,'21.4g',0.05,NULL,NULL,NULL,NULL,NULL,1,345.262333,-0.20686,0.145,NULL,49500053962,773438343,12084974,21.4),(159299,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2005jg',NULL,159299,40.22,0.13,1110,74892,70,NULL,'Hubble residual -0.01 for z0.30400','SDSS J230102.96-001224.7',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159300,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2005jg',NULL,159300,41,0.13,1220,74892,65,NULL,'SALT2','SDSS J230102.96-001224.7',0.3,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159301,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2005jg',NULL,159301,41.01,0.16,1230,74892,70,NULL,'SALT 2','SDSS J230102.96-001224.7',0.3,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159302,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 07143','R',159302,41.02,0.22,1230,74892,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005jg','SDSS J230102.96-001224.7',0.304,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159303,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 07143','R',159303,41.09,0.14,1260,74892,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005jg','SDSS J230102.96-001224.7',0.304,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159304,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2005jg',NULL,159304,41.14,0.12,1300,74892,65,NULL,'MLCS2k2','SDSS J230102.96-001224.7',0.3,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159305,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2005jg',NULL,159305,40.92,0.12,1530,74892,70,NULL,'SALT 2','SDSS J230102.96-001224.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159306,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2005jg',NULL,159306,40.95,0.12,1550,74892,70,NULL,'SALT 2, Malmquist cor.','SDSS J230102.96-001224.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159307,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159307,38.08,0.46,414,74893,70,NULL,NULL,'2MASX J23010607+1331581',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,345.275333,13.53289,0.133,NULL,52562526722,821289480,12832648,18),(159308,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159308,31.87,0.14,23.7,74894,74.4,NULL,NULL,'NGC 7454',NULL,'2013AJ....146...86T',2013,1,2.2,NULL,'G',0.000017,NULL,'12.78',1.6,'E4','X-ray-faint group member',NULL,NULL,NULL,1,345.277125,16.38836,0.229,NULL,52608178860,822002794,12843793,12.78),(159309,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159309,31.89,0.3,23.9,74894,NULL,NULL,'I','NGC 7454',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159310,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159310,31.89,0.3,23.9,74894,NULL,NULL,NULL,'NGC 7454',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159311,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159311,32.14,0.3,26.8,74894,NULL,NULL,'Malmquist cor.','NGC 7454',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159312,'D-Sigma','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159312,31.24,0.4,17.7,74894,75,NULL,'Edat, raw','NGC 7454',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159313,'D-Sigma','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159313,31.58,0.4,20.7,74894,75,NULL,'Edat, cor','NGC 7454',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159314,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159314,30.72,0.61,13.9,74894,95,NULL,'Weighted Mean','NGC 7454',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159315,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159315,30.72,0.61,13.9,74894,95,NULL,'de Vaucouleurs','NGC 7454',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159316,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159316,31.4,0.41,19.1,74894,NULL,NULL,NULL,'NGC 7454',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159317,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159317,31.9,0.41,23.9,74894,NULL,NULL,'Malmquist cor.','NGC 7454',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159318,'Tertiary','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159318,31.74,0.29,22.3,74894,95,NULL,NULL,'NGC 7454',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159319,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159319,31.71,0.45,22,74894,NULL,NULL,'K','NGC 7454',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159320,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159320,31.81,0.4,23,74894,NULL,NULL,'mean','NGC 7454',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159321,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159321,33.12,0.8,42,74895,75,NULL,'W91CL, r','UGC 12304',NULL,'1997ApJS..109..333W',1997,1,1.68,NULL,'G',0.000015,NULL,'14.72',0.22,'Sc','Isolated galaxy',NULL,NULL,NULL,1,345.2845,5.65436,0.193,NULL,51730693148,808292080,12629563,14.72),(159322,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159322,33.18,0.8,43.2,74895,75,NULL,'CF, r','UGC 12304',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159323,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159323,32.57,0.38,32.7,74895,75,NULL,'CF, r, raw','UGC 12304',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159324,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159324,32.58,0.38,32.8,74895,75,NULL,'CF, r, inv','UGC 12304',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159325,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159325,32.72,0.2,35,74895,74.4,NULL,NULL,'UGC 12304',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159326,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159326,32.8,0.49,36.3,74895,75,NULL,'IR','UGC 12304',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159327,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159327,32.82,0.38,36.6,74895,75,NULL,'CF, r, cor','UGC 12304',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159328,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159328,32.94,0.38,38.7,74895,75,NULL,'W91CL, r, raw','UGC 12304',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159329,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159329,32.99,0.38,39.6,74895,75,NULL,'W91CL, r, inv','UGC 12304',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159330,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159330,33.21,0.38,43.8,74895,75,NULL,'W91CL, r, cor','UGC 12304',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159331,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159331,33.25,0.12,44.8,74895,NULL,NULL,NULL,'UGC 12304',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159332,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159332,33.28,NULL,45.3,74895,NULL,NULL,NULL,'UGC 12304',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159333,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159333,33.59,NULL,52.3,74895,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12304',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159334,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159334,33.61,NULL,52.8,74895,NULL,NULL,'Dipole + Quadrupole','UGC 12304',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159335,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159335,33.64,NULL,53.4,74895,NULL,NULL,'Dipole','UGC 12304',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159336,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159336,37.37,0.33,298,74896,70,NULL,NULL,'2MASX J23010844+0114489',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000178,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,345.285167,1.24689,0.173,NULL,51702224733,807847261,12622613,17.1),(159337,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 00879','RN',159337,41.4,0.2,1310,74897,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 00879',0.453133,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159338,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159338,33.54,0.43,51,74898,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12307',NULL,'2014MNRAS.444..527S',2014,1,1.5,NULL,'G',0.000024,NULL,'16.0',0.3,'Im',NULL,NULL,NULL,NULL,1,345.3,12.72278,0.193,NULL,52560758010,821261843,12832216,16),(159339,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159339,36.95,0.46,245,74899,70,NULL,NULL,'2MASX J23011250-0944362',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,345.3019583,-9.74339,0.081,NULL,50380638808,787197481,12299960,16.7),(159340,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159340,35.27,0.49,113,74900,75,NULL,'IR','2MFGC 17299',NULL,'2011yCatp016004901K',2011,1,0.91,NULL,'G',0.000047,NULL,'15.9g',0.25,'Sc',NULL,NULL,NULL,NULL,1,345.302666667,14.74464,0.177,NULL,52551586644,821118541,12829977,15.9),(159341,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159341,37.24,0.46,281,74901,70,NULL,NULL,'2MASX J23011404+1335551',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000137,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,345.308625,13.59861,0.133,NULL,52562641685,821291276,12832676,18.1),(159342,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159342,37.37,0.33,298,74902,70,NULL,NULL,'2MASX J23011471+0113099',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000191,NULL,'16.3g',0.36,'E0',NULL,NULL,NULL,NULL,1,345.3114583,1.21953,0.173,NULL,51702226412,807847287,12622613,16.3),(159343,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159343,35.81,0.49,145,74903,75,NULL,'IR','2MFGC 17300',NULL,'2011yCatp016004901K',2011,1,NULL,NULL,'G',NULL,NULL,'16.5B',NULL,NULL,NULL,NULL,NULL,NULL,1,345.319417,18.73783,0.173,NULL,52574146440,821471038,12835484,16.5),(159344,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159344,32.68,0.4,34.4,74904,NULL,NULL,NULL,'UGC 12308',NULL,'2009AJ....138..323T',2009,1,2.16,NULL,'G',0.000003,NULL,'14.9g',0.4,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,345.327875,14.33958,0.165,NULL,52559814932,821247108,12831986,14.9),(159345,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159345,32.78,0.2,36,74904,74.4,NULL,NULL,'UGC 12308',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159346,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159346,32.93,0.43,38.5,74904,75,NULL,'3.6 micron, color corrected','UGC 12308',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159347,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159347,32.99,0.47,39.7,74904,NULL,NULL,NULL,'UGC 12308',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159348,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159348,33.09,0.43,41.4,74904,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12308',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159349,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159349,33.2,0.42,43.6,74904,NULL,NULL,'Malmquist cor.','UGC 12308',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159350,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159350,38.1,0.46,416,74905,70,NULL,NULL,'2MASX J23012018+0030010',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,345.334083,0.50019,0.169,NULL,51700850091,807825782,12622277,17.6),(159351,'SGRB','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159351,38.73,NULL,557,74906,71,NULL,NULL,'CXO J230126.9-385839',NULL,'2010ApJ...709..664R',2010,1,NULL,NULL,'G',0.0001,NULL,'21.3V',NULL,'Late-type dwarf',NULL,NULL,NULL,NULL,1,345.362333333,-38.97758,NULL,NULL,50484142310,788814723,12325230,21.3),(159352,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159352,36.83,0.2,232,74907,74.4,NULL,NULL,'CGCG 430-050',NULL,'2013AJ....146...86T',2013,1,0.65,NULL,'G',0.000078,NULL,'15.6g',0.33,'Sb',NULL,NULL,NULL,NULL,1,345.3679583,14.60136,0.165,NULL,52558966678,821233854,12831778,15.6),(159353,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159353,34.04,0.4,64.1,74908,NULL,NULL,'mean','NGC 7458',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000063,NULL,'13.59',1.2,'E','in a pair',NULL,NULL,NULL,1,345.369333,1.75339,0.213,NULL,51701898416,807842162,12622533,13.59),(159354,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159354,34.31,0.45,72.7,74908,NULL,NULL,'K','NGC 7458',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159355,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159355,34.35,0.8,74.2,74909,75,NULL,'MAT, I','ESO 290- G 035',NULL,'1997ApJS..109..333W',1997,1,2.89,NULL,'G',0.000029,NULL,'15.00',0.38,'Sab',NULL,NULL,NULL,NULL,1,345.385166667,-46.64631,0,NULL,50510050940,789219545,12331555,15),(159356,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159356,33.88,NULL,59.6,74909,NULL,NULL,NULL,'ESO 290- G 035',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159357,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159357,34.08,NULL,65.5,74909,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 290- G 035',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159358,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159358,34.11,NULL,66.3,74909,NULL,NULL,'Dipole + Quadrupole','ESO 290- G 035',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159359,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159359,34.12,NULL,66.7,74909,NULL,NULL,'Dipole','ESO 290- G 035',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159360,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159360,34.29,0.43,72.1,74909,75,NULL,'MAT, I, raw','ESO 290- G 035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159361,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159361,34.4,0.32,75.7,74909,85,NULL,'I, raw','ESO 290- G 035',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159362,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159362,34.44,0.32,77.3,74909,85,NULL,'I, inv','ESO 290- G 035',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159363,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159363,34.45,0.4,77.5,74909,NULL,NULL,'Malmquist cor.','ESO 290- G 035',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159364,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159364,34.5,0.43,79.3,74909,75,NULL,'MAT, I, inv','ESO 290- G 035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159365,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159365,34.53,0.38,80.5,74909,NULL,NULL,NULL,'ESO 290- G 035',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159366,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159366,34.55,0.49,81.3,74909,75,NULL,'IR','ESO 290- G 035',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159367,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159367,34.57,0.2,82,74909,74.4,NULL,NULL,'ESO 290- G 035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159368,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159368,34.72,0.43,87.9,74909,75,NULL,'MAT, I, cor','ESO 290- G 035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159369,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 09750','RN',159369,43.82,0.28,3690,74910,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 09750',0.575242,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159370,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159370,38.01,0.46,399,74911,70,NULL,NULL,'SDSS J230137.55-085343.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,345.4065,-8.89542,0.061,NULL,50379924732,787186323,12299786,18.5),(159371,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159371,38.23,0.46,442,74912,70,NULL,NULL,'2MASX J23013755-0959310',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00015,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,345.4065,-9.99211,0.097,NULL,50366566660,786977604,12296525,16.9),(159372,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159372,37.79,0.46,362,74913,70,NULL,NULL,'2MASX J23013945+1431486',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000169,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,345.4142917,14.53028,0.165,NULL,52559735229,821245862,12831966,18),(159373,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159373,32.51,0.69,31.8,74914,100,NULL,'mid-IR','NGC 7460',NULL,'2013ApJ...771...88L',2013,1,1.4,NULL,'G',0.000023,NULL,'13.61',1,'SB(s)b pec:    HII','in a pair',NULL,NULL,NULL,1,345.4287917,2.26361,0.249,NULL,51701176141,807830877,12622357,13.61),(159374,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159374,32.8,0.47,36.3,74914,NULL,NULL,'H','NGC 7460',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159375,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159375,32.85,0.45,37.2,74914,NULL,NULL,'K','NGC 7460',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159376,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159376,32.88,0.46,37.6,74914,NULL,NULL,'J','NGC 7460',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159377,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159377,33.08,0.4,41.2,74914,NULL,NULL,'mean','NGC 7460',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159378,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159378,36.01,0.5,159,74915,70,NULL,NULL,'2MASX J23014320-3126365',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.44',0.3,NULL,NULL,NULL,NULL,NULL,1,345.429917,-31.44353,NULL,NULL,50086724654,782605072,12228204,16.44),(159379,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159379,38.59,0.46,521,74916,70,NULL,NULL,'2MASX J23014661+1427326',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000175,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,345.444333,14.45917,0.165,NULL,52559739856,821245935,12831967,18.4),(159380,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159380,37.45,0.46,309,74917,70,NULL,NULL,'SDSS J230147.33-082353.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000161,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,345.44725,-8.39817,0.073,NULL,49485509255,773211082,12081423,18.3),(159381,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2007hj',NULL,159381,33.59,0.22,50.9,74918,72,NULL,NULL,'NGC 7461',0.01289,'2013ApJ...773...53F',2013,1,0.9,NULL,'G',0.000127,NULL,'14.32',0.7,'SB0',NULL,NULL,NULL,NULL,1,345.451375,15.58247,0.137,NULL,52607453739,821991464,12843616,14.32),(159382,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159382,36.85,0.46,235,74919,70,NULL,NULL,'2MASX J23014900+0035309',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000182,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,345.4542917,0.59203,0.149,NULL,51701046060,807828844,12622325,17),(159383,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159383,35.81,0.5,145,74920,70,NULL,NULL,'FAIRALL 0147',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000093,NULL,'15.79',0.48,'S0',NULL,NULL,NULL,NULL,1,345.4657917,-60.54069,0,NULL,48793236738,762394324,11912411,15.79),(159384,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159384,31.78,0.43,22.7,74921,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7463',NULL,'2014MNRAS.444..527S',2014,1,2.9,NULL,'G',0.000017,NULL,'13.8',0.7,'SABb: pec','in a triple',NULL,NULL,NULL,1,345.466583333,15.98186,0.193,NULL,52607408152,821990752,12843605,13.8),(159385,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159385,31.8,0.43,22.9,74921,75,NULL,'3.6 micron, color corrected','NGC 7463',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159386,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159386,31.8,0.2,22.9,74921,74.4,NULL,NULL,'NGC 7463',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159387,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159387,32.51,0.4,31.8,74921,NULL,NULL,'mean','NGC 7463',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159388,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159388,32.62,0.4,33.5,74921,75,NULL,'B','NGC 7463',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159389,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159389,32.85,0.46,37.1,74921,NULL,NULL,'J','NGC 7463',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159390,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159390,32.94,0.47,38.7,74921,NULL,NULL,'H','NGC 7463',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159391,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159391,33,0.45,39.9,74921,NULL,NULL,'K','NGC 7463',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159392,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159392,32.08,0.8,26.1,74922,75,NULL,'B','NGC 7464',NULL,'1988NBGC.C....0000T',1988,1,0.8,NULL,'G',0.000017,NULL,'14.27',0.8,'E1 pec:','X-ray-faint group member',NULL,NULL,NULL,1,345.47375,15.97375,0.193,NULL,52607530192,821992659,12843635,14.27),(159393,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159393,36.69,0.65,218,74923,70,NULL,NULL,'LCRS B225902.8-443518',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.71',0.35,NULL,NULL,NULL,NULL,NULL,1,345.474125,-44.31925,NULL,NULL,50520230262,789378597,12334040,16.71),(159394,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159394,38.49,0.27,499,74924,70,NULL,NULL,'2MASX J23015789+0012202',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,'PHOT','17.1g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,345.4912917,0.20558,0.169,NULL,51700216399,807815881,12622123,17.1),(159395,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159395,32.17,0.8,27.2,74925,75,NULL,'B','NGC 7465',NULL,'1988NBGC.C....0000T',1988,1,1.2,NULL,'G',0.000017,NULL,'13.31',0.8,'(R\')SB(s)0^0^: Sy2','X-ray-faint group member',NULL,NULL,'LINER',1,345.504041667,15.96478,0.193,NULL,52607530534,821992664,12843635,13.31),(159396,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159396,37.92,0.46,384,74926,70,NULL,NULL,'2MASX J23020136+1303105',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000183,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,345.50575,13.05303,0.197,NULL,52560582042,821259094,12832173,17.7),(159397,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159397,37.98,0.46,394,74927,70,NULL,NULL,'2MASX J23020184+1445076',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,345.50775,14.75211,0.177,NULL,52551549412,821117959,12829968,18.3),(159398,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159398,37.56,0.46,325,74928,70,NULL,NULL,'SDSS J230203.17-002708.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000167,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,345.5132083,-0.45244,0.137,NULL,49500072678,773438635,12084978,18),(159399,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159399,34.98,0.8,99.1,74929,75,NULL,'W91PP, r','NGC 7466',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00001,NULL,'14.35',0.5,'Sb             Sy2',NULL,NULL,NULL,'H II',1,345.5142917,27.05264,0.165,NULL,51899120451,810923757,12670683,14.35),(159400,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159400,34.99,0.8,99.4,74929,75,NULL,'CF, r','NGC 7466',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159401,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159401,34.37,0.38,74.9,74929,75,NULL,'W91PP, r, raw','NGC 7466',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159402,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159402,34.39,0.38,75.6,74929,75,NULL,'CF, r, raw','NGC 7466',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159403,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159403,34.55,0.38,81.2,74929,75,NULL,'CF, r, inv','NGC 7466',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159404,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159404,34.56,0.38,81.6,74929,75,NULL,'W91PP, r, inv','NGC 7466',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159405,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159405,34.71,0.38,87.6,74929,75,NULL,'W91PP, r, cor','NGC 7466',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159406,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159406,34.73,0.38,88.2,74929,75,NULL,'CF, r, cor','NGC 7466',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159407,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159407,34.82,0.2,92,74929,74.4,NULL,NULL,'NGC 7466',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159408,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159408,34.83,0.34,92.3,74929,NULL,NULL,NULL,'NGC 7466',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159409,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159409,34.93,0.32,96.8,74929,NULL,NULL,'Malmquist cor.','NGC 7466',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159410,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159410,34.94,0.47,97.4,74929,NULL,NULL,'H','NGC 7466',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159411,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159411,35.03,0.45,101,74929,NULL,NULL,'K','NGC 7466',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159412,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159412,35.08,0.4,104,74929,NULL,NULL,'mean','NGC 7466',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159413,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159413,35.12,0.46,106,74929,NULL,NULL,'J','NGC 7466',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159414,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159414,34.67,0.8,85.8,74930,75,NULL,'W91PP, r','UGC 12320',NULL,'1997ApJS..109..333W',1997,1,1.19,NULL,'G',0.000011,NULL,'16.0',0.12,'Scd',NULL,NULL,NULL,NULL,1,345.51675,30.76433,0.257,NULL,51917384015,811209125,12675142,16),(159415,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159415,34.61,0.43,83.4,74930,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12320',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159416,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159416,34.66,0.49,85.6,74930,75,NULL,'IR','UGC 12320',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159417,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159417,34.81,0.43,91.6,74930,75,NULL,'3.6 micron, color corrected','UGC 12320',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159418,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159418,34.89,NULL,95.2,74930,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12320',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159419,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159419,34.92,NULL,96.5,74930,NULL,NULL,'Dipole + Quadrupole','UGC 12320',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159420,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159420,34.94,NULL,97.3,74930,NULL,NULL,'Dipole','UGC 12320',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159421,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159421,34.97,0.38,98.6,74930,75,NULL,'W91PP, r, raw','UGC 12320',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159422,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159422,34.99,NULL,99.4,74930,NULL,NULL,NULL,'UGC 12320',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159423,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159423,35.05,0.2,102,74930,74.4,NULL,NULL,'UGC 12320',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159424,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159424,35.06,0.38,103,74930,75,NULL,'W91PP, r, inv','UGC 12320',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159425,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159425,35.07,0.38,103,74930,NULL,NULL,'Malmquist cor.','UGC 12320',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159426,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159426,35.09,0.38,104,74930,75,NULL,'W91PP, r, cor','UGC 12320',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159427,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159427,35.19,0.36,109,74930,NULL,NULL,NULL,'UGC 12320',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159428,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 17967',NULL,159428,40.35,0.17,1180,74931,70,NULL,'SN photometric redshift distance, z photo =0.326 +/- 0.033','SDSS-II SN 17967',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,345.529583,-0.65969,0.145,NULL,49500098517,773439039,12084984,NULL),(159429,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 17967','R',159429,41.56,0.28,1490,74931,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17967',0.378414,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159430,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 17967','R',159430,41.77,0.24,1640,74931,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17967',0.378414,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159431,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 17967',NULL,159431,41.5,0.18,2000,74931,70,NULL,'SALT 2','SDSS-II SN 17967',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159432,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 17967',NULL,159432,41.56,0.18,2050,74931,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 17967',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159433,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159433,35.54,0.8,128,74932,75,NULL,'W91PP, r','UGC 12318',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.00009,NULL,'16.0',0.4,'SBb            Sy2',NULL,NULL,NULL,'Sy 2',1,345.533125,25.66978,0.181,NULL,51893443791,810835059,12669297,16),(159434,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159434,35.42,0.45,121,74932,NULL,NULL,'Malmquist cor.','UGC 12318',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159435,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159435,35.42,0.38,121,74932,75,NULL,'W91PP, r, raw','UGC 12318',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159436,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159436,35.59,0.38,131,74932,75,NULL,'W91PP, r, cor','UGC 12318',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159437,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159437,35.6,0.38,132,74932,75,NULL,'W91PP, r, inv','UGC 12318',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159438,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159438,35.61,0.41,132,74932,NULL,NULL,NULL,'UGC 12318',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159439,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159439,35.63,0.2,134,74932,74.4,NULL,NULL,'UGC 12318',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159440,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159440,35.65,NULL,135,74933,NULL,NULL,NULL,'SDSS J2302+0049',NULL,'2014A&A...562A..49M',2014,1,0.11,NULL,'G',NULL,NULL,'18.8g',0.08,NULL,NULL,NULL,NULL,NULL,1,345.541583333,0.8275,0.165,NULL,51700390801,807818606,12622165,18.8),(159441,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159441,30.9,0.8,15.1,74934,75,NULL,'MAT, I','NGC 7456',NULL,'1997ApJS..109..333W',1997,1,5.5,NULL,'G',0.000007,NULL,'12.78',1.6,'SA(s)cd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,345.543417,-39.56939,NULL,NULL,50498140481,789033445,12328647,12.78),(159442,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159442,30.9,0.8,15.1,74934,75,NULL,'A82, H','NGC 7456',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159443,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159443,30.04,0.4,10.2,74934,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 7456',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159444,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159444,30.7,0.32,13.8,74934,85,NULL,'I, raw','NGC 7456',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159445,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159445,30.7,0.32,13.8,74934,85,NULL,'I, inv','NGC 7456',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159446,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159446,30.76,0.35,14.2,74934,NULL,NULL,NULL,'NGC 7456',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159447,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159447,30.77,0.47,14.2,74934,75,NULL,'A82, H, inv','NGC 7456',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159448,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159448,30.76,0.39,14.2,74934,73,NULL,'opt','NGC 7456',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159449,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159449,30.83,0.47,14.6,74934,75,NULL,'A82, H, raw','NGC 7456',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159450,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159450,30.84,0.4,14.7,74934,75,NULL,'B','NGC 7456',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159451,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159451,30.89,0.43,15.1,74934,75,NULL,'3.6 micron, color corrected','NGC 7456',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159452,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159452,30.89,0.43,15.1,74934,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7456',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159453,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159453,31.01,0.43,15.9,74934,75,NULL,'MAT, I, raw','NGC 7456',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159454,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159454,31.08,0.43,16.4,74934,75,NULL,'MAT, I, inv','NGC 7456',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159455,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159455,31.08,0.2,16.4,74934,74.4,NULL,NULL,'NGC 7456',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159456,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159456,31.22,0.47,17.5,74934,75,NULL,'A82, H, cor','NGC 7456',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159457,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159457,31.32,0.43,18.4,74934,75,NULL,'MAT, I, cor','NGC 7456',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159458,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159458,31.64,0.45,21.3,74934,NULL,NULL,NULL,'NGC 7456',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159459,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159459,31.79,0.42,22.8,74934,NULL,NULL,'Malmquist cor.','NGC 7456',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159460,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159460,38.49,0.27,499,74935,70,NULL,NULL,'SDSS J230211.32+001347.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,345.5472083,0.22997,0.169,NULL,51700213238,807815831,12622122,18.4),(159461,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159461,31.18,0.8,17.2,74936,75,NULL,'MAT, I','ESO 406- G 042',NULL,'1997ApJS..109..333W',1997,1,1.7,'Confused HIPASS source','G',0.00002,NULL,'15.44',1.2,'SAB(s)m:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,345.5592083,-37.08372,NULL,NULL,50486576259,788852754,12325824,15.44),(159462,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159462,31.14,0.8,16.9,74936,75,NULL,NULL,'ESO 406- G 042',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159463,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159463,31.06,0.32,16.3,74936,85,NULL,'I, inv','ESO 406- G 042',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159464,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159464,31.13,0.32,16.8,74936,85,NULL,'I, raw','ESO 406- G 042',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159465,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159465,31.35,0.4,18.6,74936,NULL,NULL,NULL,'ESO 406- G 042',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159466,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159466,31.35,0.39,18.6,74936,73,NULL,'opt','ESO 406- G 042',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159467,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159467,31.51,0.43,20,74936,75,NULL,'MAT, I, inv','ESO 406- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159468,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159468,31.65,0.43,21.4,74936,75,NULL,'MAT, I, raw','ESO 406- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159469,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159469,31.88,0.43,23.8,74936,75,NULL,'MAT, I, cor','ESO 406- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159470,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 07802',NULL,159470,39.47,0.91,783,74937,70,NULL,'SN photometric redshift distance, z photo =0.203 +/- 0.127','SDSS-II SN 07802',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,345.575916667,0.72911,0.133,NULL,51700465826,807819778,12622184,NULL),(159471,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 07802',NULL,159471,41.07,0.27,1640,74937,70,NULL,NULL,'SDSS-II SN 07802',NULL,'2013MNRAS.434.1443X',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159472,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 07802','R',159472,42.01,0.27,1790,74937,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07802',0.407556,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159473,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 07802','R',159473,42.33,0.27,2070,74937,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07802',0.407556,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159474,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 07802',NULL,159474,41.95,0.18,2450,74937,70,NULL,'SALT 2','SDSS-II SN 07802',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159475,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 07802',NULL,159475,42.02,0.18,2540,74937,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 07802',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159476,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159476,37.46,0.46,310,74938,70,NULL,NULL,'SDSS J230218.34-002348.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,345.576417,-0.39692,0.137,NULL,49499947507,773436679,12084948,18.3),(159477,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159477,33.69,0.4,54.7,74939,NULL,NULL,NULL,'UGC 12321',NULL,'2009AJ....138..323T',2009,1,1,NULL,'G',0.000003,NULL,'15.67',0.1,'Sbc','X-ray-faint group member',NULL,NULL,NULL,1,345.579291667,16.02783,0.193,NULL,52607573696,821993339,12843645,15.67),(159478,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159478,34.01,0.4,63.3,74939,NULL,NULL,'Malmquist cor.','UGC 12321',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159479,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159479,34.01,0.39,63.5,74939,NULL,NULL,NULL,'UGC 12321',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159480,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159480,34.06,0.2,64.9,74939,74.4,NULL,NULL,'UGC 12321',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159481,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 12213',NULL,159481,40.87,0.36,1490,74940,70,NULL,'SN photometric redshift distance, z photo =0.438 +/- 0.111','SDSS-II SN 12213',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,345.584083,-0.64636,0.145,NULL,49499977660,773437150,12084955,NULL),(159482,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 12213',NULL,159482,41.27,0.22,1790,74940,70,NULL,'SALT 2','SDSS-II SN 12213',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159483,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 12213',NULL,159483,41.32,0.22,1840,74940,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 12213',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159484,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 18253',NULL,159484,39.82,0.46,920,74941,70,NULL,'SN photometric redshift distance, z photo =0.244 +/- 0.069','SDSS-II SN 18253',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,345.5842917,-0.9085,0.153,NULL,49499857581,773435274,12084926,NULL),(159485,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 18253','R',159485,40.66,0.28,1060,74941,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18253',0.280569,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159486,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 18253','R',159486,40.7,0.28,1080,74941,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18253',0.280569,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159487,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159487,37.7,0.46,347,74942,70,NULL,NULL,'SDSS J230223.15-092823.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000143,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,345.5965,-9.47308,0.057,NULL,50367174136,786987095,12296673,18.5),(159488,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159488,38.67,0.46,541,74943,70,NULL,NULL,'2MASX J23022470+0040192',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,345.60275,0.67192,0.133,NULL,51700988928,807827952,12622311,17.6),(159489,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159489,38.49,0.27,499,74944,70,NULL,NULL,'2MASX J23022643+0013432',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000185,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,345.610083,0.22861,0.149,NULL,51700244187,807816315,12622129,18),(159490,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159490,36,0.54,158,74945,70,NULL,NULL,'2MASX J23022677-1303382',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.000103,NULL,'16.21',0.41,NULL,NULL,NULL,NULL,NULL,1,345.6115,-13.06056,0.081,NULL,50413770820,787715169,12308049,16.21),(159491,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159491,35.7,NULL,138,74946,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2449',NULL,'2010Ap&SS.325..163P',2010,1,0.93,NULL,'G',0.000014,NULL,'16.8',0.09,'Scd',NULL,NULL,NULL,NULL,1,345.615375,11.63511,0.189,NULL,52429998083,819218720,12800292,16.8),(159492,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159492,35.71,NULL,139,74946,NULL,NULL,'Dipole + Quadrupole','FGC 2449',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159493,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159493,35.72,NULL,139,74946,NULL,NULL,'Dipole','FGC 2449',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159494,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159494,35.75,0.49,141,74946,75,NULL,'IR','FGC 2449',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159495,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159495,35.8,NULL,145,74946,NULL,NULL,NULL,'FGC 2449',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159496,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159496,38.74,0.46,559,74947,70,NULL,NULL,'SDSS J230230.01+142618.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000168,NULL,'18.8g',0.09,NULL,NULL,NULL,NULL,NULL,1,345.625041667,14.43836,0.177,NULL,52559444627,821241322,12831895,18.8),(159497,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159497,36.46,0.46,196,74948,70,NULL,NULL,'2MASX J23023337+1402542',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000186,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,345.6389583,14.04861,0.153,NULL,52559493054,821242078,12831907,17),(159498,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 17423',NULL,159498,40.22,0.2,1110,74949,70,NULL,'SN photometric redshift distance, z photo =0.303 +/- 0.036','SDSS-II SN 17423',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','20.6g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,345.642333,-0.8385,0.117,NULL,49499809173,773434518,12084914,20.6),(159499,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 17423','R',159499,40.84,0.22,1170,74949,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17423',0.265158,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159500,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 17423','R',159500,41.07,0.17,1300,74949,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17423',0.265158,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159501,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 17423',NULL,159501,40.74,0.14,1410,74949,70,NULL,'SALT 2','SDSS-II SN 17423',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159502,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 17423',NULL,159502,40.76,0.14,1420,74949,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 17423',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159503,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 15779',NULL,159503,39.33,0.44,734,74950,70,NULL,'SN photometric redshift distance, z photo =0.189 +/- 0.048','SDSS-II SN 15779',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.1g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,345.644667,-0.46264,0.137,NULL,49499961182,773436893,12084951,21.1),(159504,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 15779','R',159504,41.14,0.26,1340,74950,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15779',0.262538,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159505,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 15779','R',159505,41.23,0.22,1400,74950,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15779',0.262538,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159506,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 05187','RN',159506,43.84,0.25,3880,74951,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 05187',0.5113,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159507,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159507,35.57,0.2,130,74952,74.4,NULL,NULL,'CGCG 430-054',NULL,'2013AJ....146...86T',2013,1,0.76,NULL,'G',0.00009,NULL,'15.0g',0.49,'Sab',NULL,NULL,NULL,NULL,1,345.667958333,13.32908,0.181,NULL,52562563478,821290054,12832657,15),(159508,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159508,30.64,0.8,13.4,74953,75,NULL,'A82, H','NGC 7462',NULL,'1997ApJS..109..333W',1997,1,4.2,NULL,'G',0.000013,NULL,'12.53',0.7,'SB(s)bc? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,345.6937083,-40.83525,NULL,NULL,50489983134,788905986,12326656,12.53),(159509,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159509,29.23,0.4,7,74953,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 7462',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159510,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159510,29.31,0.4,7.29,74953,75,NULL,NULL,'NGC 7462',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159511,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159511,29.32,0.41,7.3,74953,73,NULL,'IR','NGC 7462',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159512,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159512,29.87,0.43,9.4,74953,75,NULL,'3.6 micron, color corrected','NGC 7462',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159513,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159513,29.91,0.2,9.59,74953,74.4,NULL,NULL,'NGC 7462',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159514,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159514,29.91,0.43,9.6,74953,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7462',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159515,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159515,29.95,0.35,9.77,74953,NULL,NULL,NULL,'NGC 7462',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159516,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159516,30.01,0.47,10,74953,75,NULL,'A82, H, inv','NGC 7462',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159517,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159517,30.02,NULL,10.1,74953,NULL,NULL,NULL,'NGC 7462',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159518,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159518,30.13,0.47,10.6,74953,75,NULL,'A82, H, raw','NGC 7462',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159519,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159519,30.29,0.48,11.4,74953,NULL,NULL,NULL,'NGC 7462',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159520,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159520,30.48,0.49,12.5,74953,75,NULL,'IR','NGC 7462',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159521,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159521,30.54,0.4,12.8,74953,73,NULL,'opt','NGC 7462',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159522,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159522,30.57,0.4,13,74953,75,NULL,'B','NGC 7462',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159523,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159523,30.57,0.46,13,74953,NULL,NULL,'J','NGC 7462',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159524,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159524,30.59,0.47,13.1,74953,75,NULL,'A82, H, cor','NGC 7462',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159525,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159525,30.62,0.41,13.3,74953,NULL,NULL,'Malmquist cor.','NGC 7462',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159526,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159526,30.79,0.47,14.4,74953,NULL,NULL,'H','NGC 7462',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159527,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159527,30.89,0.45,15.1,74953,NULL,NULL,'K','NGC 7462',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159528,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159528,30.91,0.4,15.2,74953,NULL,NULL,'mean','NGC 7462',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159529,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2011io',NULL,159529,36.16,0.56,170,74954,72,NULL,'M(H) = -18.317 mag','2MASX J23024668+0848186',NULL,'2014ApJ...784..105W',2013,1,NULL,NULL,'G',NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,345.6945,8.80508,0.117,NULL,52430955131,819233673,12800526,NULL),(159530,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159530,37.63,0.46,336,74955,70,NULL,NULL,'2MASX J23024806+1523072',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000197,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,345.70025,15.38539,0.173,NULL,52552381980,821130968,12830171,17.5),(159531,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159531,34.39,0.8,75.6,74956,75,NULL,'MAT, I','IC 5282',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.91',0.6,'Sd',NULL,NULL,NULL,NULL,1,345.700791667,21.87436,0.313,NULL,52567061046,821360328,12833755,14.91),(159532,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159532,34.4,0.8,75.7,74956,75,NULL,'W91PP, r','IC 5282',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159533,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159533,34.4,0.8,75.8,74956,75,NULL,'CF, r','IC 5282',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159534,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159534,34.34,0.2,73.8,74956,74.4,NULL,NULL,'IC 5282',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159535,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159535,34.47,0.65,78.5,74956,NULL,NULL,NULL,'IC 5282',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159536,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159536,34.5,0.32,79.5,74956,85,NULL,'I, raw','IC 5282',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159537,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159537,34.54,0.43,81.1,74956,75,NULL,'MAT, I, raw','IC 5282',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159538,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159538,34.55,0.32,81.4,74956,85,NULL,'I, inv','IC 5282',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159539,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159539,34.57,0.62,82.1,74956,NULL,NULL,'Malmquist cor.','IC 5282',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159540,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159540,34.62,0.38,83.8,74956,75,NULL,'W91PP, r, raw','IC 5282',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159541,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159541,34.76,0.43,89.7,74956,75,NULL,'MAT, I, inv','IC 5282',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159542,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159542,34.77,0.38,89.8,74956,75,NULL,'W91PP, r, inv','IC 5282',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159543,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159543,34.84,0.38,93.1,74956,75,NULL,'CF, r, raw','IC 5282',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159544,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159544,34.9,0.38,95.4,74956,75,NULL,'W91PP, r, cor','IC 5282',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159545,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159545,34.9,0.43,95.5,74956,75,NULL,'MAT, I, cor','IC 5282',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159546,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159546,35,0.38,99.8,74956,75,NULL,'CF, r, inv','IC 5282',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159547,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159547,35.06,0.38,103,74956,75,NULL,'CF, r, cor','IC 5282',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159548,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 15504','R',159548,40.62,0.16,1050,74957,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2006oc','SDSS J230248.35-005235.1',0.2701,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,345.701375,-0.87686,0.117,NULL,49499808652,773434510,12084914,NULL),(159549,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2006oc',NULL,159549,40.1,0.18,1050,74957,70,NULL,'Hubble residual 0.09 for z0.27010','SDSS J230248.35-005235.1',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159550,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 15504','R',159550,40.87,0.26,1180,74957,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2006oc','SDSS J230248.35-005235.1',0.2701,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159551,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 18475','RN',159551,39.51,0.22,675,74958,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18475',0.181642,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159552,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 18475','RN',159552,39.8,0.25,773,74958,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18475',0.181642,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159553,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159553,35.5,0.49,126,74959,75,NULL,'IR','ESO 239- G 007',NULL,'2011yCatp016004901K',2011,1,0.95,NULL,'G',0.000033,NULL,'16.35',0.2,'S...',NULL,NULL,NULL,NULL,1,345.711083,-48.55828,0,NULL,50515464503,789304132,12332877,16.35),(159554,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159554,35.9,0.25,151,74959,NULL,NULL,NULL,'ESO 239- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159555,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159555,35.91,0.25,152,74959,NULL,NULL,'Malmquist cor.','ESO 239- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159556,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159556,35.94,0.2,154,74959,74.4,NULL,NULL,'ESO 239- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159557,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 13460',NULL,159557,40.25,0.19,1120,74960,70,NULL,'SN photometric redshift distance, z photo =0.308 +/- 0.034','SDSS-II SN 13460',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,345.7145,0.14189,0.149,NULL,51700257334,807816520,12622133,NULL),(159558,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 13460','R',159558,40.96,0.23,1180,74960,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13460',0.310903,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159559,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 13460','R',159559,41.01,0.17,1210,74960,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13460',0.310903,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159560,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159560,35.21,NULL,110,74961,NULL,NULL,NULL,'UGC 12327',NULL,'2000BSAO...50....5K',2000,1,1.71,NULL,'G',0.000013,NULL,'16.5',0.11,'Scd',NULL,NULL,NULL,NULL,1,345.723708333,26.01481,0.153,NULL,51893908942,810842327,12669411,16.5),(159561,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159561,36.87,0.46,236,74962,70,NULL,NULL,'2MASX J23025386+1310342',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000135,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,345.724417,13.17611,0.181,NULL,52562821183,821294080,12832720,18.2),(159562,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159562,35.74,NULL,141,74963,NULL,NULL,'Dipole + Quadrupole','UGC 12324',NULL,'2010Ap&SS.325..163P',2010,1,1.36,NULL,'G',0.000087,NULL,'16.0',0.13,'Sc',NULL,NULL,NULL,NULL,1,345.735583,8.57994,0.129,NULL,51722096901,808157764,12627465,16),(159563,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159563,35.74,NULL,141,74963,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12324',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159564,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159564,35.75,NULL,141,74963,NULL,NULL,'Dipole','UGC 12324',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159565,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 17955',NULL,159565,40.27,0.2,1130,74964,70,NULL,'SN photometric redshift distance, z photo =0.311 +/- 0.036','SDSS-II SN 17955',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.4g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,345.738791667,-0.34986,0.145,NULL,49499332641,773427072,12084798,21.4),(159566,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 17955','R',159566,41.77,0.26,1520,74964,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17955',0.483387,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159567,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159567,34.39,0.8,75.4,74965,75,NULL,'W91PP, r','UGC 12331',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'15.25',0.6,'S?',NULL,NULL,NULL,NULL,1,345.746333,34.72708,0.329,NULL,52043960197,813186878,12706044,15.25),(159568,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159568,34.49,0.38,79.1,74965,75,NULL,'W91PP, r, raw','UGC 12331',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159569,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159569,34.57,0.38,81.9,74965,75,NULL,'W91PP, r, inv','UGC 12331',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159570,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159570,34.66,0.2,85.5,74965,74.4,NULL,NULL,'UGC 12331',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159571,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159571,34.68,0.38,86.2,74965,75,NULL,'W91PP, r, cor','UGC 12331',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159572,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159572,34.73,0.37,88.2,74965,NULL,NULL,NULL,'UGC 12331',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159573,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159573,34.77,0.36,90,74965,NULL,NULL,'Malmquist cor.','UGC 12331',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159574,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159574,32.31,0.8,28.9,74966,75,NULL,'B','NGC 7468',NULL,'1988NBGC.C....0000T',1988,1,0.9,NULL,'G',0.00002,NULL,'14.16',0.6,'E3: pec','X-ray-faint group member',NULL,NULL,NULL,1,345.746917,16.60525,0.237,NULL,52608567922,822008873,12843888,14.16),(159575,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2007mw',NULL,159575,40.23,0.19,1110,74967,70,NULL,'Hubble residual -0.14 for z0.32820','SDSS J230302.72+005057.8',NULL,'2011ApJ...740...92G',2011,1,0.05,NULL,'G',0.0005,NULL,'21.4g',0.03,NULL,NULL,NULL,NULL,NULL,1,345.761333333,0.84939,0.145,NULL,51700483359,807820052,12622188,21.4),(159576,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 18617','R',159576,41.15,0.28,1280,74967,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007mw','SDSS J230302.72+005057.8',0.3282,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159577,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 18617','R',159577,41.25,0.23,1340,74967,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007mw','SDSS J230302.72+005057.8',0.3282,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159578,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2007mw',NULL,159578,41.02,0.17,1600,74967,70,NULL,'SALT 2','SDSS J230302.72+005057.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159579,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2007mw',NULL,159579,41.06,0.17,1630,74967,70,NULL,'SALT 2, Malmquist cor.','SDSS J230302.72+005057.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159580,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159580,37.69,0.46,346,74968,70,NULL,NULL,'2MASX J23030670-0832075',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000197,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,345.778083333,-8.53531,0.065,NULL,49489670708,773276104,12082439,17.4),(159581,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159581,37.9,0.46,380,74969,70,NULL,NULL,'2MASX J23031344-0945335',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,345.806083,-9.75933,0.097,NULL,50367070275,786985473,12296648,17.4),(159582,'AGN time lag','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159582,33.39,0.07,47.7,74970,NULL,NULL,NULL,'NGC 7469',NULL,'2014ApJ...784L..11Y',2014,1,1.5,NULL,'G',0.000007,NULL,'13.0',1.1,'(R\')SAB(rs)a   Sy1.2','Pair member (points to parent)',NULL,NULL,'Sy 1',1,345.815083333,8.874,0.117,NULL,51708475481,807944929,12624139,13),(159583,'AGN time lag','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159583,34.43,0.55,77,74970,44,NULL,NULL,'NGC 7469',NULL,'2007MNRAS.380..669C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159584,'AGN time lag','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159584,35.34,NULL,117,74970,42,NULL,NULL,'NGC 7469',NULL,'1999MNRAS.302L..24C',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159585,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2008ec',NULL,159585,34.15,0.2,66.4,74970,70,NULL,'SALT 2','NGC 7469',0.016317,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159586,'Ring Diameter','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159586,33.8,0.84,57,74970,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7469',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159587,'Black Hole','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159587,34.58,0.34,82.4,74970,NULL,NULL,NULL,'NGC 7469',NULL,'2014ApJ...793..108W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159588,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159588,33.24,NULL,44.4,74970,75,NULL,'CO','NGC 7469',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159589,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159589,33.5,0.45,50,74970,NULL,NULL,'K','NGC 7469',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159590,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159590,33.65,NULL,53.6,74970,75,NULL,'HI','NGC 7469',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159591,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159591,33.71,0.47,55.3,74970,NULL,NULL,'H','NGC 7469',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159592,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159592,33.88,0.46,59.6,74970,NULL,NULL,'J','NGC 7469',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159593,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159593,33.94,0.4,61.5,74970,NULL,NULL,'mean','NGC 7469',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159594,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 14340',NULL,159594,39.87,0.23,942,74971,70,NULL,NULL,'SDSS-II SN 14340',NULL,'2013MNRAS.434.1443X',2013,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,345.826583,-0.85539,0.117,NULL,49499725022,773433203,12084893,NULL),(159595,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 14340','R',159595,40.58,0.24,1020,74971,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14340',0.277441,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159596,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 14340','R',159596,40.63,0.18,1050,74971,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14340',0.277441,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159597,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 14340',NULL,159597,40.47,0.18,1240,74972,70,NULL,'SALT 2','SDSS J230318.41-005118.9',NULL,'2013ApJ...763...88C',2013,1,0.03,NULL,'G',0.000186,NULL,'19.4g',0.02,NULL,NULL,NULL,NULL,NULL,1,345.8267083,-0.85528,0.117,NULL,49499725023,773433203,12084893,19.4),(159598,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 14340',NULL,159598,40.5,0.18,1260,74972,70,NULL,'SALT 2, Malmquist cor.','SDSS J230318.41-005118.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159599,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 10002','RN',159599,41.51,0.3,1600,74973,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 10002',0.251872,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159600,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 10002','RN',159600,42.21,0.27,2210,74973,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 10002',0.251872,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159601,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 08947','RN',159601,39.68,0.27,731,74974,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 08947',0.18136,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159602,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 08947','RN',159602,40.72,0.26,1180,74974,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 08947',0.18136,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159603,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159603,33.09,0.8,41.5,74975,75,NULL,'MAT, I','ESO 604- G 001',NULL,'1997ApJS..109..333W',1997,1,1.57,NULL,'G',0.000017,NULL,'14.39',0.13,'Sc',NULL,NULL,NULL,NULL,1,345.85,-19.50389,0.068,NULL,50447265069,788238516,12316226,14.39),(159604,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159604,32.45,0.32,30.9,74975,85,NULL,'I, inv','ESO 604- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159605,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159605,32.49,0.32,31.5,74975,85,NULL,'I, raw','ESO 604- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159606,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159606,32.81,0.43,36.5,74975,75,NULL,'MAT, I, inv','ESO 604- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159607,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159607,32.9,0.43,38,74975,75,NULL,'MAT, I, raw','ESO 604- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159608,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159608,32.98,NULL,39.4,74975,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 604- G 001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159609,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159609,33,NULL,39.8,74975,NULL,NULL,'Dipole + Quadrupole','ESO 604- G 001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159610,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159610,33.01,NULL,39.9,74975,NULL,NULL,'Dipole','ESO 604- G 001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159611,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159611,33.13,0.43,42.2,74975,75,NULL,'MAT, I, cor','ESO 604- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159612,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159612,33.59,0.64,52.4,74975,NULL,NULL,'Malmquist cor.','ESO 604- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159613,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159613,33.71,0.61,55.3,74975,NULL,NULL,NULL,'ESO 604- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159614,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159614,33.92,0.2,60.8,74975,74.4,NULL,NULL,'ESO 604- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159615,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159615,38.27,0.46,450,74976,70,NULL,NULL,'2MASXi J2303240-095253',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,345.8502083,-9.88147,0.097,NULL,50366607728,786978245,12296535,18.1),(159616,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159616,37.73,0.46,351,74977,70,NULL,NULL,'2MASX J23032627-0013013',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00015,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,345.859583,-0.21703,0.145,NULL,49499124543,773423820,12084747,17.3),(159617,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159617,37.54,0.27,322,74978,70,NULL,NULL,'2MASX J23032674-1032255',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,345.861333333,-10.54039,0.089,NULL,50368457193,787007143,12296986,17.4),(159618,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159618,31.33,0.8,18.5,74979,75,NULL,'B','ESO 290- G 039',NULL,'1988NBGC.C....0000T',1988,1,1.1,NULL,'G',0.000023,NULL,'15.00',0.9,'SB(s)m',NULL,NULL,NULL,NULL,1,345.8737083,-46.03142,0,NULL,50510020014,789219062,12331547,15),(159619,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159619,37.54,0.27,322,74980,70,NULL,NULL,'2MASX J23033027-1037175',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00015,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,345.876125,-10.62167,0.089,NULL,50368469797,787007340,12296989,16.9),(159620,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 16079','RN',159620,40.62,0.27,1150,74981,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 16079',0.153911,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159621,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 16079','RN',159621,40.74,0.2,1220,74981,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 16079',0.153911,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159622,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 14034',NULL,159622,40.86,0.48,1490,74982,70,NULL,'SN photometric redshift distance, z photo =0.437 +/- 0.152','SDSS-II SN 14034',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,345.8864583,-0.28228,0.145,NULL,49499114732,773423667,12084744,NULL),(159623,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 18221','RN',159623,40.27,0.28,877,74983,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18221',0.293922,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159624,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 18221','RN',159624,40.36,0.25,911,74983,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18221',0.293922,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159625,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159625,38.05,0.46,407,74984,70,NULL,NULL,'2MASX J23033537-1042381',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000159,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,345.897417,-10.7105,0.089,NULL,50368425617,787006650,12296978,17.6),(159626,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 08948','RN',159626,43.61,0.32,3750,74985,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 08948',0.404376,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159627,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 08948','RN',159627,43.82,0.3,4140,74985,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 08948',0.404376,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159628,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159628,33.46,0.2,49.2,74986,74.4,NULL,NULL,'CGCG 405-028',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00012,NULL,'14.9',0.4,'SBd',NULL,NULL,NULL,NULL,1,345.9004583,9.29067,0.113,NULL,52430994550,819234289,12800535,14.9),(159629,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159629,36.66,0.66,215,74987,70,NULL,NULL,'2MASX J23033829-7903432',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,345.909583,-79.06206,0.393,NULL,48554745190,758667893,11854185,16.7),(159630,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159630,37.65,0.46,339,74988,70,NULL,NULL,'2MASX J23033897-1016191',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.6g',0.17,'AGN',NULL,NULL,NULL,NULL,1,345.9122917,-10.27208,0.085,NULL,50368529016,787008265,12297004,17.6),(159631,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159631,34.87,0.46,94.4,74989,70,NULL,NULL,'IC 1466',NULL,'2014MNRAS.445.2677S',2014,1,0.74,NULL,'G',0.00015,NULL,'14.3',0.67,'(R?)SA(r)0',NULL,NULL,NULL,NULL,1,345.9127083,-2.77544,0.161,NULL,49505431605,773522368,12086287,14.3),(159632,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159632,35.15,0.5,107,74990,70,NULL,NULL,'2MASX J23034042-7903252',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,345.918875,-79.05694,0.393,NULL,48554742492,758667851,11854185,16.5),(159633,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159633,37.56,0.33,324,74991,70,NULL,NULL,'2MASX J23034261-0816421',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000145,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,345.927416667,-8.27833,0.081,NULL,49489723511,773276929,12082452,18.2),(159634,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 03788','RN',159634,41.04,0.24,1370,74992,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03788',0.18212,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159635,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 03788','RN',159635,41.28,0.25,1530,74992,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03788',0.18212,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159636,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159636,35.47,0.46,124,74993,70,NULL,NULL,'2MASX J23034557-0826451',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000181,NULL,'15.4g',0.32,'S0',NULL,NULL,NULL,NULL,1,345.9400417,-8.44603,0.073,NULL,49489757016,773277453,12082460,15.4),(159637,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159637,33.19,0.8,43.4,74994,75,NULL,'MAT, I','ESO 109- G 032',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000028,NULL,'14.86',0.4,'SAB(s)c? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,345.9435,-62.522,0,NULL,48766060242,761969691,11905776,14.86),(159638,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159638,33.38,0.6,47.4,74994,NULL,NULL,NULL,'ESO 109- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159639,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159639,33.41,0.32,48.1,74994,85,NULL,'I, raw','ESO 109- G 032',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159640,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159640,33.42,0.32,48.3,74994,85,NULL,'I, inv','ESO 109- G 032',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159641,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159641,33.42,0.2,48.3,74994,74.4,NULL,NULL,'ESO 109- G 032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159642,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159642,33.45,0.58,49,74994,NULL,NULL,'Malmquist cor.','ESO 109- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159643,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159643,33.62,0.43,52.9,74994,75,NULL,'MAT, I, raw','ESO 109- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159644,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159644,33.7,0.43,55.1,74994,75,NULL,'MAT, I, inv','ESO 109- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159645,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159645,33.84,0.43,58.6,74994,75,NULL,'MAT, I, cor','ESO 109- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159646,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 03549','RN',159646,40.01,0.13,710,74995,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03549',0.412444,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159647,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 03549','RN',159647,40.4,0.21,849,74995,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03549',0.412444,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159648,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159648,33.12,0.43,42,74996,75,NULL,'3.6 micron, color + selection bias corrected','ESO 469- G 008',NULL,'2014MNRAS.444..527S',2014,1,1.2,NULL,'G',0.00001,NULL,'15.22',0.5,'SB(s)m:',NULL,NULL,NULL,NULL,1,345.9587083,-28.74361,0.026,NULL,50105558942,782899358,12232802,15.22),(159649,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 19072','RN',159649,39.72,0.28,762,74997,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19072',0.153776,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159650,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 19072','RN',159650,40.3,0.34,993,74997,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19072',0.153776,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159651,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 02350','RN',159651,41.43,0.22,1600,74998,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 02350',0.205267,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159652,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 02350','RN',159652,42.17,0.48,2250,74998,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 02350',0.205267,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159653,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159653,37.69,0.46,344,74999,70,NULL,NULL,'SDSS J230358.13-092403.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000133,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,345.99225,-9.40108,0.089,NULL,50367130324,786986411,12296662,18.4),(159654,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159654,35.37,0.49,119,75000,75,NULL,'IR','FGC 2455',NULL,'2011yCatp016004901K',2011,1,1.18,NULL,'G',0.000053,NULL,'16.5g',0.16,'Sdm',NULL,NULL,NULL,NULL,1,345.998,-8.79425,0.065,NULL,49478330390,773098912,12079670,16.5),(159655,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159655,37.43,0.46,306,75001,70,NULL,NULL,'2MASX J23040071+1304315',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000172,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,346.003,13.07542,0.169,NULL,52560246406,821253850,12832091,17.9),(159656,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 03945','R',159656,41.01,0.27,1260,75002,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J230402.37-001659.2',0.262001,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',NULL,'PHOT','21.1g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,346.009875,-0.28314,0.145,NULL,49507496127,773554626,12086791,21.1),(159657,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 03945','R',159657,41.17,0.24,1360,75002,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J230402.37-001659.2',0.262001,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159658,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 03945',NULL,159658,40.9,0.16,1510,75002,70,NULL,'SALT 2','SDSS J230402.37-001659.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159659,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 03945',NULL,159659,40.93,0.16,1530,75002,70,NULL,'SALT 2, Malmquist cor.','SDSS J230402.37-001659.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159660,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159660,37.56,0.33,324,75003,70,NULL,NULL,'SDSS J230410.88-081734.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000134,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,346.045333333,-8.29294,0.089,NULL,49490605666,773290713,12082667,18.2),(159661,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159661,37.25,0.54,282,75004,70,NULL,NULL,'FAIRALL 1032',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00015,NULL,'15.71',0.72,'SAB(r)a:',NULL,NULL,NULL,NULL,1,346.065041667,-42.73792,NULL,NULL,50518747101,789355423,12333678,15.71),(159662,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 18327','RN',159662,42.43,0.3,2030,75005,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18327',0.508563,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159663,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159663,37.54,0.27,322,75006,70,NULL,NULL,'2MASX J23041849-1028353',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,346.077083,-10.47653,0.085,NULL,50369331203,787020800,12297200,17.4),(159664,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159664,37.15,0.46,269,75007,70,NULL,NULL,'2MASX J23042030-0012408',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00015,NULL,'16.45',0.32,NULL,NULL,NULL,NULL,NULL,1,346.084667,-0.21136,0.145,NULL,49507523935,773555061,12086797,16.45),(159665,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159665,37.27,0.46,285,75008,70,NULL,NULL,'2MASX J23042038-1004253',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00015,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,346.084833,-10.07364,0.081,NULL,50366579022,786977797,12296528,16.7),(159666,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 07803',NULL,159666,39.28,0.58,717,75009,70,NULL,'SN photometric redshift distance, z photo =0.184 +/- 0.065','SDSS-II SN 07803',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,346.086333333,0.69039,0.157,NULL,51704402360,807881286,12623145,NULL),(159667,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159667,37.32,0.46,291,75010,70,NULL,NULL,'2MASX J23042073-1042293',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000144,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,346.086416667,-10.70828,0.089,NULL,50369274380,787019912,12297186,17.4),(159668,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159668,38.02,0.33,402,75011,70,NULL,NULL,'2MASX J23042082+0019511',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000083,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,346.0867083,0.33083,0.145,NULL,51704284106,807879439,12623116,17.4),(159669,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159669,38.02,0.33,402,75012,70,NULL,NULL,'2MASX J23042419+0017568',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000082,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,346.100833,0.29911,0.145,NULL,51704285593,807879462,12623116,17.6),(159670,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 21885',NULL,159670,40.55,0.51,1290,75013,70,NULL,'SN photometric redshift distance, z photo =0.364 +/- 0.128','SDSS-II SN 21885',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','20.8g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,346.113583333,0.31839,0.145,NULL,51704258284,807879035,12623109,20.8),(159671,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 21885','R',159671,41.99,0.42,1780,75013,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21885',0.406059,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159672,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 08017','RN',159672,42.3,0.19,2190,75014,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 08017',0.316816,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159673,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 08017','RN',159673,42.62,0.24,2540,75014,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08017',0.316816,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159674,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159674,37.73,0.17,319,75015,74.2,NULL,'SALT 2','APMUKS(BJ) B230147.96-373644.6',0.101,'2010ApJ...716..712A',2010,1,0.18,NULL,'G',NULL,NULL,'18.90',0.14,'Sa?',NULL,NULL,NULL,NULL,1,346.142917,-37.34244,NULL,NULL,50486230091,788847345,12325739,18.9),(159675,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159675,38.17,0.29,391,75015,72,NULL,NULL,'APMUKS(BJ) B230147.96-373644.6',0.101,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159676,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159676,38.27,0.06,409,75015,65,NULL,'MLCS','APMUKS(BJ) B230147.96-373644.6',0.101,'1996ApJ...473..588R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159677,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159677,38.31,0.19,417,75015,65,NULL,'SALT2','APMUKS(BJ) B230147.96-373644.6',0.101,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159678,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159678,38.33,0.23,421,75015,65,NULL,'Template','APMUKS(BJ) B230147.96-373644.6',0.101,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159679,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159679,38.41,0.21,436,75015,70,NULL,'SALT 2','APMUKS(BJ) B230147.96-373644.6',0.101,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159680,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159680,38.41,0.15,437,75015,65,NULL,'MLCS','APMUKS(BJ) B230147.96-373644.6',0.101,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159681,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159681,38.21,0.08,439,75015,65,NULL,'LCS','APMUKS(BJ) B230147.96-373644.6',NULL,'1995ApJ...445L..91R',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159682,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159682,38.42,0.04,439,75015,72,NULL,NULL,'APMUKS(BJ) B230147.96-373644.6',0.101,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159683,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159683,38.44,0.06,442,75015,70,NULL,NULL,'APMUKS(BJ) B230147.96-373644.6',0.101,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159684,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159684,38.65,0.12,443,75015,65,NULL,'MLCS2k2','APMUKS(BJ) B230147.96-373644.6',0.101,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159685,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159685,38.46,0.22,447,75015,73.8,NULL,'SALT 2 (SNANA)','APMUKS(BJ) B230147.96-373644.6',0.1009,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159686,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159686,38.25,0.17,447,75015,70.8,NULL,NULL,'APMUKS(BJ) B230147.96-373644.6',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159687,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159687,38.27,0.06,451,75015,65,NULL,'Snapshot','APMUKS(BJ) B230147.96-373644.6',NULL,'1996ApJ...473...88R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159688,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159688,38.51,0.15,457,75015,70,NULL,'SALT','APMUKS(BJ) B230147.96-373644.6',0.101,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159689,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159689,38.61,0.1,479,75015,65,NULL,'MLCS2k2','APMUKS(BJ) B230147.96-373644.6',0.101,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159690,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159690,38.62,0.19,481,75015,65,NULL,'SALT2','APMUKS(BJ) B230147.96-373644.6',0.101,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159691,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159691,38.66,0.17,489,75015,65,NULL,'MLCS17','APMUKS(BJ) B230147.96-373644.6',0.101,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159692,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159692,38.66,0.05,491,75015,65,NULL,'SALT','APMUKS(BJ) B230147.96-373644.6',0.101,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159693,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159693,38.47,0.14,494,75015,60,NULL,NULL,'APMUKS(BJ) B230147.96-373644.6',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159694,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159694,38.7,0.13,498,75015,65,NULL,'SALT','APMUKS(BJ) B230147.96-373644.6',0.101,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159695,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159695,38.73,0.2,506,75015,65,NULL,NULL,'APMUKS(BJ) B230147.96-373644.6',0.101,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159696,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159696,38.73,0.15,506,75015,65,NULL,'MLCS31','APMUKS(BJ) B230147.96-373644.6',0.101,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159697,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159697,38.8,0.1,522,75015,65,NULL,'MLCS2k2','APMUKS(BJ) B230147.96-373644.6',0.101,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159698,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159698,38.76,0.07,565,75015,60,NULL,'M(V) = -19.47 mag','APMUKS(BJ) B230147.96-373644.6',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159699,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159699,38.81,0.09,578,75015,60,NULL,'M(B) = -19.48 mag','APMUKS(BJ) B230147.96-373644.6',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159700,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159700,38.86,0.09,592,75015,60,NULL,'M(I) = -19.19 mag','APMUKS(BJ) B230147.96-373644.6',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159701,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159701,37.07,0.46,259,75016,70,NULL,NULL,'2MASX J23043540-0909064',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00015,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,346.147625,-9.15167,0.077,NULL,49478226949,773097296,12079645,16.2),(159702,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159702,35,0.46,100,75017,70,NULL,NULL,'ESO 077- G 002',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000133,NULL,'14.63',0.6,'S0',NULL,NULL,NULL,NULL,1,346.164417,-72.11692,0.061,NULL,48393399499,756146867,11814794,14.63),(159703,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159703,35.4,0.52,120,75018,70,NULL,NULL,'2MASX J23044135-2105408',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'15.24',0.53,'E',NULL,NULL,NULL,NULL,1,346.17225,-21.09475,0.047,NULL,50433825270,788028519,12312945,15.24),(159704,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159704,36.32,0.46,184,75019,70,NULL,NULL,'2MASX J23044397-0842114',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00015,NULL,'16.2g',0.28,'S0/a',NULL,NULL,NULL,NULL,1,346.18325,-8.70322,0.073,NULL,49478250735,773097667,12079651,16.2),(159705,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159705,34.73,0.2,88.3,75020,74.4,NULL,NULL,'KUG 2302+075',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',NULL,NULL,'15.68',0.2,'S?',NULL,NULL,NULL,NULL,1,346.186167,7.803,0.129,NULL,51722397594,808162462,12627538,15.68),(159706,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159706,34.49,0.49,79.2,75021,75,NULL,'IR','KUG 2302+075',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',NULL,NULL,'15.68',0.2,'S?',NULL,NULL,NULL,NULL,1,346.186167,7.803,0.129,NULL,51722397594,808162462,12627538,15.68),(159707,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159707,36.58,0.76,207,75022,70,NULL,NULL,'2MASX J23044473-4312451',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'16.59',0.32,NULL,NULL,NULL,NULL,NULL,1,346.186417,-43.2125,NULL,NULL,50518648020,789353875,12333654,16.59),(159708,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159708,35.18,0.49,109,75023,75,NULL,'IR','2MFGC 17334',NULL,'2011yCatp016004901K',2011,1,0.55,NULL,'G',NULL,NULL,'13.17',0.17,NULL,NULL,NULL,NULL,NULL,1,346.193167,7.89353,0.129,NULL,51722393800,808162403,12627537,13.17),(159709,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 11141',NULL,159709,40.81,0.4,1450,75024,70,NULL,'SN photometric redshift distance, z photo =0.423 +/- 0.117','SDSS-II SN 11141',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','20.9g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,346.204167,-0.90939,0.113,NULL,49508406962,773568858,12087013,20.9),(159710,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 11141','R',159710,42.42,0.33,2280,75024,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 11141',0.333177,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159711,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159711,38.02,0.33,401,75025,70,NULL,NULL,'2MASX J23045152+1451143',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,346.21475,14.854,0.185,NULL,52551803992,821121937,12830030,17.6),(159712,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 21126','RN',159712,44.26,0.32,4460,75026,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 21126',0.598288,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159713,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159713,37.42,0.58,304,75027,70,NULL,NULL,'2MASX J23045223-2827471',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'17.54',0.24,NULL,NULL,NULL,NULL,NULL,1,346.217583,-28.46319,0.076,NULL,50135071698,783360495,12240007,17.54),(159714,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159714,35.03,0.45,102,75028,NULL,NULL,'K','CGCG 453-062',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.00003,NULL,'15.1',0.5,'Sa;LIRG        LINER',NULL,NULL,NULL,NULL,1,346.2355417,19.55222,0.133,NULL,52572978348,821452786,12835199,15.1),(159715,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159715,35.05,0.4,102,75028,NULL,NULL,'mean','CGCG 453-062',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159716,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159716,35.05,0.47,103,75028,NULL,NULL,'H','CGCG 453-062',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159717,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159717,35.22,0.46,111,75028,NULL,NULL,'J','CGCG 453-062',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159718,'HII region diameter','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159718,32.46,0.14,31.1,75029,NULL,NULL,NULL,'NGC 7479',NULL,'2005JKAS...38....7I',2005,1,4.1,NULL,'G',0.000005,NULL,'11.60',3.1,'SB(s)c;LINER   Sy2','Isolated galaxy',NULL,NULL,'Sy 1.9',1,346.2360417,12.32289,0.161,NULL,52549144297,821080379,12829380,11.6),(159719,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159719,32.01,NULL,25.2,75029,75,NULL,'CO','NGC 7479',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159720,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159720,32.4,0.4,30.2,75029,NULL,NULL,NULL,'NGC 7479',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159721,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159721,32.55,0.4,32.4,75029,75,NULL,'B','NGC 7479',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159722,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159722,32.64,NULL,33.7,75029,75,NULL,'HI','NGC 7479',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159723,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159723,32.79,0.43,36.1,75029,NULL,NULL,NULL,'NGC 7479',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159724,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159724,32.82,0.42,36.7,75029,NULL,NULL,'Malmquist cor.','NGC 7479',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159725,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159725,32.83,0.2,36.8,75029,74.4,NULL,NULL,'NGC 7479',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159726,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 16352','R',159726,40.44,0.22,980,75030,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006pk','SN 2006pk',0.25227,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,346.249375,-0.87336,0.113,NULL,49508426635,773569166,12087018,NULL),(159727,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 16352','R',159727,40.65,0.13,1080,75030,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006pk','SN 2006pk',0.25227,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159728,'Tully est','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159728,31.83,0.8,23.2,75031,75,NULL,NULL,'UGC 12344',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.000013,NULL,'16.0',0.4,'SBd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,346.249875,18.70333,0.193,NULL,52575560380,821493130,12835830,16),(159729,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159729,31.93,0.2,24.3,75031,74.4,NULL,NULL,'UGC 12344',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159730,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159730,32.16,0.4,27,75031,NULL,NULL,NULL,'UGC 12344',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159731,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159731,38.02,0.33,401,75032,70,NULL,NULL,'2MASX J23050205+1450034',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000203,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,346.258541667,14.83433,0.185,NULL,52551806319,821121973,12830030,16.5),(159732,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 2000dn',NULL,159732,35.85,0.16,143,75033,70,NULL,'SALT 2','IC 1468',0.032065,'2013MNRAS.433.2240G',2013,1,1.3,NULL,'G',0.000217,NULL,'15.25',0.8,'(R\')SAB0+ pec:',NULL,NULL,NULL,NULL,1,346.281541667,-3.2045,0.149,NULL,49503510310,773492348,12085817,15.25),(159733,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 2000dn','R',159733,35.91,0.06,152,75033,NULL,NULL,'MLCS2k2, R(V) = 1.8','IC 1468',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159734,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 2000dn','R',159734,35.96,0.06,156,75033,NULL,NULL,'MLCS2k2, R(V) = 3.1','IC 1468',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159735,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159735,36.77,0.46,226,75034,70,NULL,NULL,'2MASX J23050762+0049346',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000103,NULL,'16.9g',0.1,NULL,NULL,NULL,NULL,NULL,1,346.281833,0.82625,0.165,NULL,51705231230,807894237,12623347,16.9),(159736,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159736,35.15,NULL,107,75035,NULL,NULL,NULL,'FGC 2456',NULL,'2000BSAO...50....5K',2000,1,0.66,NULL,'G',0.000014,NULL,'17.7',0.06,'Sd',NULL,NULL,NULL,NULL,1,346.297917,25.22111,0.245,NULL,51895661620,810869712,12669839,17.7),(159737,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159737,35.65,NULL,135,75035,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2456',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159738,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159738,35.67,NULL,136,75035,NULL,NULL,'Dipole + Quadrupole','FGC 2456',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159739,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159739,35.68,NULL,137,75035,NULL,NULL,'Dipole','FGC 2456',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159740,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 17925',NULL,159740,40.28,0.21,1140,75036,70,NULL,'SN photometric redshift distance, z photo =0.313 +/- 0.040','SDSS-II SN 17925',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,346.305875,0.30397,0.145,NULL,51692914169,807701783,12620340,NULL),(159741,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159741,36.01,0.46,159,75037,70,NULL,NULL,'2MASX J23051828+1334374',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000184,NULL,'16.3g',0.34,'E0',NULL,NULL,NULL,NULL,1,346.326166667,13.57697,0.177,NULL,52562085609,821282587,12832540,16.3),(159742,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159742,34.61,0.2,83.6,75038,74.4,NULL,NULL,'UGC 12348',NULL,'2013AJ....146...86T',2013,1,1,'Bright star superposed 25\\\" NW.','G',0.00013,NULL,'15.33',0.3,'Sa             Sy2',NULL,NULL,NULL,'Sy 2',1,346.3285,0.18953,0.145,NULL,51692949033,807702328,12620348,15.33),(159743,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159743,34.26,0.69,71.2,75039,100,NULL,'mid-IR','CGCG 430-059',NULL,'2013ApJ...771...88L',2013,1,0.88,NULL,'G',0.00009,NULL,'15.5g',0.43,'Sab',NULL,NULL,NULL,NULL,1,346.3315417,14.17039,0.169,NULL,52562394313,821287411,12832615,15.5),(159744,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159744,34.7,0.58,87.1,75039,NULL,NULL,'Malmquist cor.','CGCG 430-059',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159745,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159745,34.77,0.56,90.1,75039,NULL,NULL,NULL,'CGCG 430-059',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159746,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159746,34.85,0.2,93.3,75039,74.4,NULL,NULL,'CGCG 430-059',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159747,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159747,31.7,0.2,21.9,75040,74.4,NULL,NULL,'UGC 12350',NULL,'2013AJ....146...86T',2013,1,2.6,NULL,'G',0.000003,NULL,'14.50',0.8,'Sm','X-ray-faint group member',NULL,NULL,NULL,1,346.333917,16.8665,0.245,NULL,52605658298,821963410,12843178,14.5),(159748,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159748,31.8,0.66,22.9,75040,NULL,NULL,'Malmquist cor.','UGC 12350',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159749,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159749,31.94,0.61,24.5,75040,NULL,NULL,NULL,'UGC 12350',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159750,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159750,31.95,0.43,24.5,75040,75,NULL,'3.6 micron, color corrected','UGC 12350',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159751,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159751,32.19,0.43,27.4,75040,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12350',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159752,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159752,32.24,0.4,28,75040,75,NULL,NULL,'UGC 12350',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159753,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159753,32.35,0.4,29.5,75040,75,NULL,'B','UGC 12350',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159754,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159754,33.13,0.49,42.3,75040,75,NULL,'IR','UGC 12350',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159755,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 07922','R',159755,40.9,0.15,1280,75041,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 07922',0.18257,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,33.222083,-0.91753,0.033,NULL,35132412917,548943951,8577249,NULL),(159756,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 18212','RN',159756,39.14,0.25,567,75042,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 18212',0.184229,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159757,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 18212','RN',159757,39.46,0.27,657,75042,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 18212',0.184229,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159758,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159758,35.01,0.36,101,75043,NULL,NULL,'Malmquist cor.','2MASX J23052461+3148367',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',NULL,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,346.3525417,31.81025,0.345,NULL,52050064834,813282263,12707535,14.5),(159759,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159759,35.12,0.35,106,75043,NULL,NULL,NULL,'2MASX J23052461+3148367',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159760,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159760,35.38,0.2,119,75043,74.4,NULL,NULL,'2MASX J23052461+3148367',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159761,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159761,35.14,0.54,107,75044,70,NULL,NULL,'MCG -01-58-020',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00012,NULL,'15.5',0.6,NULL,NULL,NULL,NULL,NULL,1,346.362625,-2.95719,0.149,NULL,49503462479,773491601,12085806,15.5),(159762,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 04969',NULL,159762,39.58,0.53,824,75045,70,NULL,'SN photometric redshift distance, z photo =0.215 +/- 0.070','SDSS-II SN 04969',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','20.2g',0.07,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,346.367666667,-0.47161,0.129,NULL,49507624878,773556638,12086822,20.2),(159763,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 04969','R',159763,40.85,0.28,1130,75045,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 04969',0.306777,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159764,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 04969','R',159764,40.86,0.31,1130,75045,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 04969',0.306777,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159765,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 04969',NULL,159765,40.65,0.21,1350,75045,70,NULL,'SALT 2','SDSS-II SN 04969',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159766,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 04969',NULL,159766,40.68,0.21,1370,75045,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 04969',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159767,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159767,37.88,0.46,377,75046,70,NULL,NULL,'2MASX J23053094+0049204',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000098,NULL,'17.1g',0.08,'NLAGN',NULL,NULL,NULL,NULL,1,346.379,0.82233,0.181,NULL,51705194284,807893660,12623338,17.1),(159768,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159768,37.85,0.46,372,75047,70,NULL,NULL,'SDSS J230534.41+011113.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,346.393416667,1.187,0.197,NULL,51705048131,807891377,12623302,18.1),(159769,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 05191','RN',159769,41.47,0.26,1600,75048,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05191',0.229431,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159770,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 05191','RN',159770,42,0.31,2040,75048,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 05191',0.229431,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159771,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 03844','RN',159771,42.46,0.31,1930,75049,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03844',0.609358,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159772,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159772,34.96,0.8,98.1,75050,75,NULL,'W91PP, r','UGC 12352',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000063,NULL,'14.44',0.9,'S?',NULL,NULL,NULL,NULL,1,346.4185,27.66558,0.277,NULL,52019459858,812804060,12700063,14.44),(159773,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159773,34.99,0.38,99.6,75050,75,NULL,'W91PP, r, raw','UGC 12352',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159774,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159774,35.07,0.4,103,75050,NULL,NULL,'mean','UGC 12352',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159775,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159775,35.13,0.47,106,75050,NULL,NULL,'H','UGC 12352',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159776,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159776,35.15,0.38,107,75050,75,NULL,'W91PP, r, cor','UGC 12352',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159777,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159777,35.16,0.45,107,75050,NULL,NULL,'K','UGC 12352',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159778,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159778,35.19,0.46,109,75050,NULL,NULL,'J','UGC 12352',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159779,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159779,35.29,0.38,114,75050,75,NULL,'W91PP, r, inv','UGC 12352',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159780,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159780,37.5,0.46,316,75051,70,NULL,NULL,'SDSS J230541.57+141739.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000098,NULL,'19.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,346.42325,14.29422,0.185,NULL,52561412458,821272069,12832376,19.1),(159781,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159781,34.33,0.43,73.5,75052,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2457',NULL,'2014MNRAS.444..527S',2014,1,0.92,NULL,'G',NULL,NULL,'16.5',0.11,'Sc',NULL,NULL,NULL,NULL,1,346.4455417,38.64722,0.633,NULL,55346467287,864788551,13512321,16.5),(159782,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159782,34.4,0.49,75.9,75052,75,NULL,'IR','FGC 2457',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159783,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159783,34.44,NULL,77.4,75052,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2457',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159784,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159784,34.46,NULL,77.9,75052,NULL,NULL,'Dipole + Quadrupole','FGC 2457',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159785,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159785,34.47,NULL,78.5,75052,NULL,NULL,'Dipole','FGC 2457',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159786,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159786,34.51,NULL,79.7,75052,NULL,NULL,NULL,'FGC 2457',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159787,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159787,34.46,0.49,78.1,75053,75,NULL,'IR','UGC 12358',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000067,NULL,'16.0',0.2,'Sb-c',NULL,NULL,NULL,NULL,1,346.448125,34.156,0.429,NULL,52047062843,813235356,12706802,16),(159788,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159788,34.86,0.37,93.9,75053,NULL,NULL,'Malmquist cor.','UGC 12358',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159789,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159789,34.89,0.36,95.1,75053,NULL,NULL,NULL,'UGC 12358',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159790,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159790,34.93,0.2,96.8,75053,74.4,NULL,NULL,'UGC 12358',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159791,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159791,37.02,0.46,253,75054,70,NULL,NULL,'2MASX J23054824-0018538',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000096,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,346.450958333,-0.31489,0.137,NULL,49494085889,773345092,12083517,16.9),(159792,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159792,32.63,0.69,33.5,75055,NULL,NULL,NULL,'NGC 7483',NULL,'2009ApJS..182..474S',2009,1,1.6,NULL,'G',0.00002,NULL,'13.94',1.1,'(R\')SAB(rs)a',NULL,NULL,NULL,NULL,1,346.4512083,3.54511,0.213,NULL,51726322951,808223796,12628496,13.94),(159793,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159793,32.71,0.2,34.8,75055,74.4,NULL,NULL,'NGC 7483',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159794,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159794,32.73,0.66,35.2,75055,NULL,NULL,'Malmquist cor.','NGC 7483',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159795,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159795,33.01,0.47,40,75055,NULL,NULL,'H','NGC 7483',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159796,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159796,33.15,0.45,42.6,75055,NULL,NULL,'K','NGC 7483',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159797,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159797,33.19,0.46,43.4,75055,NULL,NULL,'J','NGC 7483',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159798,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159798,33.99,0.4,62.8,75055,NULL,NULL,'mean','NGC 7483',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159799,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 21732','RN',159799,39.66,0.22,807,75056,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 21732',0.062252,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159800,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 21732','RN',159800,40.5,0.32,1180,75056,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 21732',0.062252,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159801,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159801,34.46,0.49,78,75057,75,NULL,'IR','UGC 12357',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000033,NULL,'15.69',0.2,'SB?','Pair member (points to parent)',NULL,NULL,NULL,1,346.46425,31.06356,0.221,NULL,52050656634,813291509,12707679,15.69),(159802,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159802,34.99,0.4,99.4,75057,NULL,NULL,'mean','UGC 12357',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159803,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159803,35.13,0.47,106,75057,NULL,NULL,'H','UGC 12357',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159804,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159804,35.15,0.54,107,75058,70,NULL,NULL,'2MASX J23055445-3044158',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.88',0.23,NULL,NULL,NULL,NULL,NULL,1,346.476833333,-30.73772,NULL,NULL,50156330099,783692657,12245197,16.88),(159805,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159805,33.43,0.8,48.6,75059,75,NULL,'CF, r','UGC 12354',NULL,'1997ApJS..109..333W',1997,1,1.08,NULL,'G',0.000095,NULL,'15.2g',0.43,'Scd:',NULL,NULL,NULL,NULL,1,346.4852083,14.35767,0.185,NULL,52561426428,821272287,12832379,15.2),(159806,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159806,33.52,0.13,50.7,75059,NULL,NULL,NULL,'UGC 12354',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159807,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159807,33.56,0.2,51.5,75059,74.4,NULL,NULL,'UGC 12354',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159808,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159808,33.9,0.38,60.2,75059,75,NULL,'CF, r, raw','UGC 12354',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159809,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159809,33.92,0.38,60.9,75059,75,NULL,'CF, r, inv','UGC 12354',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159810,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159810,34.03,0.38,64,75059,75,NULL,'CF, r, cor','UGC 12354',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159811,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159811,35.81,0.52,145,75060,70,NULL,NULL,'2MASX J23055723-5906576',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'15.85',0.52,'S0',NULL,NULL,NULL,NULL,1,346.488417,-59.11608,0,NULL,48850857939,763294655,11926478,15.85),(159812,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159812,36.56,0.46,205,75061,70,NULL,NULL,'2MASX J23055768+1512597',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000179,NULL,'16.5g',0.28,'E0',NULL,NULL,NULL,NULL,1,346.490291667,15.21664,0.169,NULL,52553835137,821153674,12830526,16.5),(159813,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159813,35.04,0.8,102,75062,75,NULL,'W91PP, r','UGC 12355',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.00005,NULL,'16.5',0.3,'Scd:',NULL,NULL,NULL,NULL,1,346.499167,24.56489,0.253,NULL,51892851140,810825799,12669153,16.5),(159814,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159814,34.71,0.2,87.5,75062,74.4,NULL,NULL,'UGC 12355',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159815,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159815,34.79,0.43,90.8,75062,75,NULL,'3.6 micron, color corrected','UGC 12355',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159816,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159816,34.8,0.36,91.4,75062,NULL,NULL,NULL,'UGC 12355',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159817,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159817,34.89,0.43,94.9,75062,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12355',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159818,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159818,35,0.33,99.9,75062,NULL,NULL,'Malmquist cor.','UGC 12355',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159819,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159819,35.22,0.38,111,75062,75,NULL,'W91PP, r, raw','UGC 12355',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159820,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159820,35.28,0.38,114,75062,75,NULL,'W91PP, r, inv','UGC 12355',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159821,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159821,35.37,0.38,119,75062,75,NULL,'W91PP, r, cor','UGC 12355',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159822,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159822,36.84,0.46,233,75063,70,NULL,NULL,'2MASX J23060063+1321501',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,346.5025,13.36383,0.141,NULL,52561485084,821273204,12832393,18),(159823,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159823,38.47,0.33,493,75064,70,NULL,NULL,'SDSS J230601.47+140942.8',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000137,NULL,'19.3g',0.09,NULL,NULL,NULL,NULL,NULL,1,346.506167,14.16192,0.185,NULL,52561312708,821270511,12832351,19.3),(159824,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159824,36.89,0.46,238,75065,70,NULL,NULL,'2MASX J23060401-0000555',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000085,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,346.516833,-0.01544,0.145,NULL,49493974523,773343351,12083489,17.5),(159825,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159825,38.47,0.33,493,75066,70,NULL,NULL,'SDSS J230604.75+141306.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00016,NULL,'19.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,346.5197917,14.21842,0.185,NULL,52561291775,821270183,12832346,19.1),(159826,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','PTF11okh','N',159826,34.9,0.06,93.7,75067,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF11okh',0.0191,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159827,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159827,36.1,0.46,166,75068,70,NULL,NULL,'2MASX J23060511+0057320',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000088,NULL,'16.3g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,346.5212917,0.95889,0.197,NULL,51705182663,807893479,12623335,16.3),(159828,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 01342',NULL,159828,40.2,0.26,1100,75069,70,NULL,'SN photometric redshift distance, z photo =0.299 +/- 0.046','SDSS-II SN 01342',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,346.527417,0.11689,0.145,NULL,51692830347,807700474,12620319,NULL),(159829,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159829,33.67,0.62,54.2,75070,NULL,NULL,'Malmquist cor.','ESO 604- G 002',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000035,NULL,'15.70',0.6,'SB(rs)ab:',NULL,NULL,NULL,NULL,1,346.5345,-19.58747,0.06,NULL,50439407781,788115746,12314308,15.7),(159830,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159830,33.67,0.2,54.2,75070,74.4,NULL,NULL,'ESO 604- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159831,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159831,33.83,0.58,58.2,75070,NULL,NULL,NULL,'ESO 604- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159832,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159832,37.96,0.33,390,75071,70,NULL,NULL,'SDSS J230610.81-093639.7',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00015,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,346.5450417,-9.61106,0.057,NULL,49478519840,773101872,12079716,16.6),(159833,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 20744',NULL,159833,39.67,0.27,861,75072,70,NULL,'SN photometric redshift distance, z photo =0.226 +/- 0.035','SDSS-II SN 20744',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,346.5492083,0.35883,0.149,NULL,51692865552,807701024,12620328,NULL),(159834,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 20744','R',159834,40.5,0.26,989,75072,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20744',0.275009,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159835,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 20744','R',159835,40.62,0.22,1040,75072,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20744',0.275009,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159836,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 2007pr',NULL,159836,40.43,0.23,1220,75073,70,NULL,'Hubble residual 0.04 for z0.33300','SDSS J230612.98+001944.1',NULL,'2011ApJ...740...92G',2011,1,0.05,NULL,'G',0.005,NULL,'22.9g',0.02,NULL,NULL,NULL,NULL,NULL,1,346.554125,0.32892,0.149,NULL,51692897638,807701525,12620336,22.9),(159837,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 20106','R',159837,41.22,0.29,1320,75073,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007pr','SDSS J230612.98+001944.1',0.333,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159838,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 20106','R',159838,41.54,0.26,1530,75073,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007pr','SDSS J230612.98+001944.1',0.333,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159839,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159839,36.78,0.63,227,75074,70,NULL,NULL,'2MASX J23061302-0641093',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,346.55425,-6.68594,0.121,NULL,49489220355,773269068,12082329,14.4),(159840,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159840,34.62,0.8,84.1,75075,75,NULL,'W91PP, r','UGC 12362',NULL,'1997ApJS..109..333W',1997,1,1.6,'UGC misprints dec as +31d57\'. UGC galactic coordinates are correct.','G',0.000033,NULL,'14.97',0.5,'SB(s)b',NULL,NULL,NULL,NULL,1,346.561541667,31.8855,0.321,NULL,52049926655,813280103,12707501,14.97),(159841,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159841,34.51,0.35,79.9,75075,NULL,NULL,NULL,'UGC 12362',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159842,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159842,34.57,0.49,81.9,75075,75,NULL,'IR','UGC 12362',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159843,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159843,34.67,0.38,85.8,75075,75,NULL,'W91PP, r, raw','UGC 12362',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159844,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159844,34.68,0.2,86.3,75075,74.4,NULL,NULL,'UGC 12362',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159845,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159845,34.72,0.32,88,75075,NULL,NULL,'Malmquist cor.','UGC 12362',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159846,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159846,34.83,0.38,92.4,75075,75,NULL,'W91PP, r, inv','UGC 12362',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159847,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159847,34.83,0.38,92.5,75075,75,NULL,'W91PP, r, cor','UGC 12362',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159848,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 17845','RN',159848,42.67,0.21,2530,75076,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 17845',0.347039,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159849,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 17845','RN',159849,42.7,0.24,2580,75076,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 17845',0.347039,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159850,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159850,37.71,0.46,349,75077,70,NULL,NULL,'2MASX J23061764+0100240',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000092,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,346.573375,1.00669,0.197,NULL,51705171013,807893297,12623332,17),(159851,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159851,37.96,0.33,390,75078,70,NULL,NULL,'SDSS J230619.97-094447.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00014,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,346.583208333,-9.74642,0.057,NULL,50366795503,786981179,12296580,18.7),(159852,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159852,32.84,0.8,36.9,75079,75,NULL,'W91CL, r','UGC 12361',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.00002,NULL,'16.07',0.3,'Im',NULL,NULL,NULL,NULL,1,346.593333,11.28556,0.105,NULL,52432521766,819258152,12800908,16.07),(159853,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159853,33.4,0.38,47.9,75079,75,NULL,'W91CL, r, inv','UGC 12361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159854,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159854,33.49,0.38,49.9,75079,75,NULL,'W91CL, r, raw','UGC 12361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159855,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159855,33.75,0.38,56.3,75079,75,NULL,'W91CL, r, cor','UGC 12361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159856,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159856,36.22,NULL,175,75080,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2459',NULL,'2010Ap&SS.325..163P',2010,1,0.65,NULL,'G',NULL,NULL,'17.1',0.07,'Sdm',NULL,NULL,NULL,NULL,1,346.602917,41.31833,0.549,NULL,55344243780,864753809,13511778,17.1),(159857,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159857,36.23,NULL,176,75080,NULL,NULL,NULL,'FGC 2459',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159858,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159858,36.25,NULL,177,75080,NULL,NULL,'Dipole + Quadrupole','FGC 2459',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159859,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159859,36.28,NULL,180,75080,NULL,NULL,'Dipole','FGC 2459',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159860,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159860,33.6,0.49,52.5,75081,NULL,NULL,NULL,'UGC 12363',NULL,'2009ApJS..182..474S',2009,1,0.94,NULL,'G',0.000037,NULL,'14.6g',0.54,'Sm',NULL,NULL,NULL,NULL,1,346.632166667,0.17242,0.149,NULL,51692769335,807699520,12620305,14.6),(159861,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159861,33.79,0.45,57.3,75081,NULL,NULL,'Malmquist cor.','UGC 12363',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159862,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 13777',NULL,159862,40.27,0.29,1130,75082,70,NULL,'SN photometric redshift distance, z photo =0.311 +/- 0.054','SDSS-II SN 13777',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','22.3g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,346.644667,-0.68439,0.161,NULL,49494757326,773355583,12083680,22.3),(159863,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 13777','R',159863,42.24,0.53,1880,75082,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 13777',0.489267,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159864,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 13777',NULL,159864,42.23,0.36,2790,75082,70,NULL,'SALT 2','SDSS-II SN 13777',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159865,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 13777',NULL,159865,42.36,0.36,2960,75082,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13777',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159866,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159866,37.06,0.46,258,75083,70,NULL,NULL,'2MASX J23063481+1351317',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,346.645083,13.85883,0.165,NULL,52561613603,821275212,12832425,17.7),(159867,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159867,34.39,0.49,75.6,75084,75,NULL,'IR','FGC 2458',NULL,'2011yCatp016004901K',2011,1,1.21,NULL,'G',0.000007,NULL,'16.6',0.1,'Sd',NULL,NULL,NULL,NULL,1,346.652833,6.11364,0.177,NULL,51718878236,808107472,12626679,16.6),(159868,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159868,34.58,NULL,82.4,75084,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2458',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159869,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159869,34.59,NULL,82.6,75084,NULL,NULL,'Dipole + Quadrupole','FGC 2458',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159870,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159870,34.59,NULL,82.6,75084,NULL,NULL,NULL,'FGC 2458',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159871,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159871,34.59,NULL,82.7,75084,NULL,NULL,'Dipole','FGC 2458',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159872,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159872,34.62,0.2,84,75084,74.4,NULL,NULL,'FGC 2458',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159873,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159873,34.68,0.54,86.1,75084,NULL,NULL,'Malmquist cor.','FGC 2458',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159874,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159874,34.76,0.52,89.4,75084,NULL,NULL,NULL,'FGC 2458',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159875,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 18011','RN',159875,40.65,0.26,1050,75085,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18011',0.283961,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159876,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 18011','RN',159876,40.76,0.32,1110,75085,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18011',0.283961,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159877,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 18011','N',159877,40.63,0.21,1340,75085,70,NULL,'SALT 2','SDSS-II SN 18011',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159878,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 18011','N',159878,40.65,0.21,1350,75085,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18011',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159879,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159879,37.11,0.46,264,75086,70,NULL,NULL,'2MASX J23063993-0114590',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.51',0.19,NULL,NULL,NULL,NULL,NULL,1,346.666416667,-1.24983,0.173,NULL,49508160727,773565011,12086953,18.51),(159880,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159880,38.04,0.46,406,75087,70,NULL,NULL,'2MASX J23064030+1450587',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000177,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,346.667833,14.84978,0.213,NULL,52553097765,821142152,12830346,18.2),(159881,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159881,35.28,0.46,114,75088,70,NULL,NULL,'2MASX J23064174+1527037',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00017,NULL,'16.1g',0.42,'S0',NULL,NULL,NULL,NULL,1,346.6739583,15.45108,0.177,NULL,52554531557,821164555,12830696,16.1),(159882,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159882,36.79,0.87,228,75089,70,NULL,NULL,'2MASX J23064401-7844548',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'16.2b',0.28,NULL,NULL,NULL,NULL,NULL,1,346.6834583,-78.74858,0.393,NULL,48554396848,758662450,11854100,16.2),(159883,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159883,37.66,0.71,340,75090,70,NULL,NULL,'2MASX J23064669-0019209',NULL,'2014MNRAS.445.2677S',2014,1,1.02,NULL,'G',0.000072,NULL,'15.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,346.694667,-0.32242,0.145,NULL,49494719261,773354988,12083671,15.8),(159884,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159884,37.46,0.46,310,75091,70,NULL,NULL,'2MASX J23064738-0046009',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000084,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,346.6975417,-0.76703,0.161,NULL,49494230324,773347348,12083552,17.6),(159885,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159885,35.75,0.53,141,75092,70,NULL,NULL,'AM 2301-843',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,346.7140417,-84.38183,0.349,NULL,48377416133,755897127,11810892,16.2),(159886,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159886,38.5,0.46,501,75093,70,NULL,NULL,'2MASX J23065203+0026217',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000093,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,346.717,0.43936,0.153,NULL,51693696246,807714003,12620531,17.8),(159887,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159887,35.35,0.46,118,75094,70,NULL,NULL,'2MASX J23065483+1411306',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000086,NULL,'16.5g',0.25,'AGN+SF',NULL,NULL,NULL,NULL,1,346.7285417,14.19175,0.193,NULL,52561741505,821277211,12832456,16.5),(159888,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 04991','RN',159888,43.31,0.23,3170,75095,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04991',0.446713,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159889,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 04991','RN',159889,43.95,0.26,4260,75095,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 04991',0.446713,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159890,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159890,36.56,0.46,205,75096,70,NULL,NULL,'2MASX J23065501-0039398',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000088,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,346.729125,-0.66097,0.153,NULL,49494759112,773355611,12083681,16.7),(159891,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159891,36.27,0.5,180,75097,70,NULL,NULL,'ESO 290-IG 051 NED02',NULL,'2014MNRAS.445.2677S',2014,1,1,'6dF DR1 has z = 0.033678.','G',0.000033,NULL,'14.75',0.5,'SAB(rs)0-: pec','Pair member (points to parent)',NULL,NULL,NULL,1,346.73325,-42.89858,NULL,NULL,50519279158,789363736,12333808,14.75),(159892,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159892,33.1,0.2,41.7,75098,74.4,NULL,NULL,'UGC 12366',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',NULL,NULL,'16.0',0.3,'S?',NULL,NULL,NULL,NULL,1,346.735083333,5.96167,0.177,NULL,51718299935,808098436,12626538,16),(159893,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159893,34.99,0.46,99.4,75099,70,NULL,NULL,'MCG -02-58-024',NULL,'2014MNRAS.445.2677S',2014,1,0.88,NULL,'G',0.000107,NULL,'14.3g',0.76,'SB0',NULL,NULL,NULL,NULL,1,346.742375,-9.28614,0.057,NULL,49478947474,773108554,12079821,14.3),(159894,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159894,36.93,0.56,244,75100,70,NULL,NULL,'2MASX J23070019-0624188',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'16.34',0.41,NULL,NULL,NULL,NULL,NULL,1,346.750875,-6.40528,0.141,NULL,49482074731,773157417,12080584,16.34),(159895,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159895,35.05,0.49,102,75101,NULL,NULL,NULL,'UGC 12367',NULL,'2009ApJS..182..474S',2009,1,1.23,'UGC has two entries for the same object.','G',0.00001,NULL,'16.5',0.19,'Scd:',NULL,NULL,NULL,NULL,1,346.755375,17.14558,0.257,NULL,52605871689,821966745,12843230,16.5),(159896,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159896,35.1,0.48,105,75101,NULL,NULL,'Malmquist cor.','UGC 12367',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159897,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159897,35.12,0.2,106,75101,74.4,NULL,NULL,'UGC 12367',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159898,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159898,33.79,0.2,57.3,75102,74.4,NULL,NULL,'UGC 12369',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000017,NULL,'17.',0.5,'Im:',NULL,NULL,NULL,NULL,1,346.75625,5.99603,0.177,NULL,51718331179,808098924,12626545,17),(159899,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159899,35.69,0.63,138,75103,70,NULL,NULL,'2MASX J23070186-0632228',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.00015,NULL,'15.54',0.57,NULL,NULL,NULL,NULL,NULL,1,346.7577917,-6.53969,0.101,NULL,49481714925,773151795,12080496,15.54),(159900,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159900,33.06,0.52,40.9,75104,70,NULL,NULL,'NGC 7484',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.00007,NULL,'12.78',1.7,'E','Isolated galaxy',NULL,NULL,NULL,1,346.7704583,-36.27536,NULL,NULL,49966254389,780722724,12198792,12.78),(159901,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159901,33.03,0.4,40.3,75104,NULL,NULL,'mean','NGC 7484',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159902,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159902,33.32,0.45,46.2,75104,NULL,NULL,'K','NGC 7484',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159903,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159903,33.96,0.8,61.9,75105,75,NULL,'MAT, I','UGC 12370',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00002,NULL,'15.21',0.4,'Sc','Isolated galaxy',NULL,NULL,NULL,1,346.776333333,9.96078,0.105,NULL,52431171879,819237060,12800579,15.21),(159904,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159904,33.96,0.8,62.1,75105,75,NULL,'W91CL, r','UGC 12370',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159905,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159905,33.98,0.8,62.6,75105,75,NULL,'CF, r','UGC 12370',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159906,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159906,33.83,0.38,58.3,75105,75,NULL,'W91CL, r, raw','UGC 12370',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159907,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159907,33.83,0.32,58.3,75105,85,NULL,'I, raw','UGC 12370',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159908,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159908,33.84,0.32,58.6,75105,85,NULL,'I, inv','UGC 12370',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159909,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159909,33.85,0.38,58.8,75105,75,NULL,'W91CL, r, inv','UGC 12370',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159910,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159910,33.87,0.38,59.3,75105,75,NULL,'CF, r, raw','UGC 12370',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159911,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159911,33.88,0.38,59.8,75105,75,NULL,'CF, r, inv','UGC 12370',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159912,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159912,33.99,0.2,62.8,75105,74.4,NULL,NULL,'UGC 12370',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159913,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159913,34.02,0.43,63.7,75105,75,NULL,'MAT, I, raw','UGC 12370',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159914,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159914,34.03,0.38,63.9,75105,75,NULL,'CF, r, cor','UGC 12370',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159915,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159915,34.04,0.38,64.4,75105,75,NULL,'W91CL, r, cor','UGC 12370',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159916,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159916,34.07,0.38,65,75105,NULL,NULL,NULL,'UGC 12370',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159917,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159917,34.11,0.43,66.5,75105,75,NULL,'MAT, I, inv','UGC 12370',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159918,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159918,34.12,0.37,66.7,75105,NULL,NULL,'Malmquist cor.','UGC 12370',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159919,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159919,34.24,0.43,70.3,75105,75,NULL,'MAT, I, cor','UGC 12370',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159920,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159920,37.88,0.33,378,75106,70,NULL,NULL,'2MASX J23070883+1457102',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,346.786833,14.95289,0.213,NULL,52553282458,821145038,12830391,18.7),(159921,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159921,37.25,0.46,281,75107,70,NULL,NULL,'2MASX J23070999-1029518',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00015,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,346.7917083,-10.49761,0.053,NULL,50369036265,787016191,12297127,16.5),(159922,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159922,37.14,0.46,268,75108,70,NULL,NULL,'2MASX J23071033-1010378',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000139,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,346.7930417,-10.17719,0.045,NULL,50368934650,787014603,12297103,18.1),(159923,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159923,35.14,0.49,107,75109,75,NULL,'IR','CGCG 405-034',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.00007,NULL,'15.22',0.3,'S?',NULL,NULL,NULL,NULL,1,346.802417,8.75197,0.085,NULL,51708743176,807949112,12624204,15.22),(159924,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159924,37.8,0.46,363,75110,70,NULL,NULL,'SDSS J230716.61+133755.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000151,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,346.81925,13.63222,0.165,NULL,52561678622,821276228,12832441,18.6),(159925,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159925,38.44,0.46,488,75111,70,NULL,NULL,'2MASX J23071704+1446303',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00016,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,346.821167,14.77506,0.213,NULL,52553292525,821145195,12830393,18.8),(159926,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159926,37.88,0.33,378,75112,70,NULL,NULL,'2MASX J23071856+1457033',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000134,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,346.8275417,14.95081,0.273,NULL,52553312118,821145501,12830398,18.3),(159927,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159927,37.59,0.46,329,75113,70,NULL,NULL,'2MASX J23071973-0948148',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000146,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,346.832,-9.80394,0.057,NULL,49478432459,773100507,12079695,17.5),(159928,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159928,37.14,0.46,267,75114,70,NULL,NULL,'2MASX J23072219+1341303',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,346.8425,13.69183,0.193,NULL,52561649755,821275777,12832434,18.2),(159929,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159929,33.88,0.39,59.6,75115,NULL,NULL,'Malmquist cor.','CGCG 475-037',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',NULL,NULL,'15.68',0.2,'S?',NULL,NULL,NULL,NULL,1,346.855875,22.80964,0.321,NULL,52563645518,821306961,12832921,15.68),(159930,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159930,33.98,0.38,62.4,75115,NULL,NULL,NULL,'CGCG 475-037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159931,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159931,33.99,0.49,62.9,75115,75,NULL,'IR','CGCG 475-037',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159932,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159932,34.02,0.2,63.7,75115,74.4,NULL,NULL,'CGCG 475-037',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159933,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159933,36.81,0.46,230,75116,70,NULL,NULL,'2MASX J23072683+1439502',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000159,NULL,'18.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,346.861667,14.66397,0.213,NULL,52553161285,821143145,12830361,18.9),(159934,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159934,35.44,0.2,122,75117,74.4,NULL,NULL,'UGC 12374',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000871,NULL,'15.26',0.5,'SBb:',NULL,NULL,NULL,NULL,1,346.8677917,15.36644,0.217,NULL,52553653854,821150841,12830481,15.26),(159935,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159935,37.92,0.46,384,75118,70,NULL,NULL,'2MASX J23073115+1349347',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000183,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,346.879833,13.82628,0.193,NULL,52561529878,821273904,12832404,18),(159936,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159936,34.51,0.8,79.9,75119,75,NULL,'CF, r','NGC 7489',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.00003,NULL,'13.96',1.1,'Sd','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,346.886291667,22.998,0.321,NULL,52563609728,821306402,12832912,13.96),(159937,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159937,33.89,0.69,60,75119,100,NULL,'mid-IR','NGC 7489',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159938,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159938,34.1,0.38,66.1,75119,75,NULL,'CF, r, raw','NGC 7489',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159939,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159939,34.24,0.2,70.5,75119,74.4,NULL,NULL,'NGC 7489',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159940,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159940,34.25,0.38,70.7,75119,75,NULL,'CF, r, inv','NGC 7489',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159941,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159941,34.31,0.57,72.6,75119,NULL,NULL,'Malmquist cor.','NGC 7489',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159942,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159942,34.36,0.56,74.6,75119,NULL,NULL,NULL,'NGC 7489',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159943,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159943,34.44,0.38,77.3,75119,75,NULL,'CF, r, cor','NGC 7489',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159944,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159944,34.65,0.47,85.2,75119,NULL,NULL,'H','NGC 7489',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159945,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159945,34.66,0.4,85.4,75119,NULL,NULL,'mean','NGC 7489',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159946,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159946,34.71,0.45,87.6,75119,NULL,NULL,'K','NGC 7489',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159947,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159947,34.74,0.46,88.7,75119,NULL,NULL,'J','NGC 7489',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159948,'Tully est','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159948,32.45,0.8,30.9,75120,75,NULL,NULL,'NGC 2573B',NULL,'1988NBGC.C....0000T',1988,1,1.7,'ESO incorrectly interchanged the designations for NGC 2573A and NGC 2573B.','G',NULL,NULL,'15.26',0.6,'IBm? pec','Pair member (points to parent)',NULL,NULL,NULL,1,346.88675,-89.1165,0.521,NULL,48318845818,754981965,11796593,15.26),(159949,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159949,37.74,0.33,353,75121,70,NULL,NULL,'2MASX J23074179+1317197',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,346.923875,13.28875,0.169,NULL,52547797057,821059329,12829052,18.2),(159950,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159950,37.74,0.33,353,75122,70,NULL,NULL,'2MASX J23074261+1313137',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000204,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,346.9275417,13.22044,0.169,NULL,52547790743,821059230,12829050,17.4),(159951,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159951,38.14,0.46,424,75123,70,NULL,NULL,'2MASX J23074621+1415327',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000191,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,346.9425,14.25892,0.181,NULL,52561859104,821279048,12832485,18.5),(159952,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 13441','R',159952,40.8,0.26,1120,75124,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13441',0.28876,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,346.9529583,-0.23306,0.141,NULL,49494448869,773350763,12083605,NULL),(159953,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 13441','R',159953,40.81,0.16,1130,75124,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13441',0.28876,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159954,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 13441',NULL,159954,40.26,0.25,1130,75124,70,NULL,'SN photometric redshift distance, z photo =0.310 +/- 0.046','SDSS-II SN 13441',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159955,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 13441',NULL,159955,40.68,0.15,1370,75124,70,NULL,'SALT 2','SDSS-II SN 13441',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159956,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 13441',NULL,159956,40.71,0.15,1390,75124,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13441',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159957,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159957,35.67,0.8,136,75125,75,NULL,'W91PP, r','UGC 12383',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'15.20',0.9,'SABb',NULL,NULL,NULL,NULL,1,346.953625,22.71028,0.321,NULL,52496318468,820254976,12816484,15.2),(159958,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159958,35.67,0.8,136,75125,75,NULL,'MAT, I','UGC 12383',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159959,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159959,35.24,0.39,112,75125,NULL,NULL,'Malmquist cor.','UGC 12383',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159960,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159960,35.33,0.37,117,75125,NULL,NULL,NULL,'UGC 12383',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159961,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159961,35.46,0.38,124,75125,75,NULL,'W91PP, r, raw','UGC 12383',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159962,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159962,35.59,0.32,131,75125,85,NULL,'I, raw','UGC 12383',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159963,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159963,35.59,0.2,131,75125,74.4,NULL,NULL,'UGC 12383',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159964,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159964,35.6,0.43,132,75125,75,NULL,'MAT, I, raw','UGC 12383',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159965,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159965,35.67,0.32,136,75125,85,NULL,'I, inv','UGC 12383',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159966,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159966,35.68,0.38,137,75125,75,NULL,'W91PP, r, cor','UGC 12383',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159967,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159967,35.74,0.38,141,75125,75,NULL,'W91PP, r, inv','UGC 12383',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159968,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159968,35.9,0.43,152,75125,75,NULL,'MAT, I, cor','UGC 12383',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159969,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159969,35.94,0.43,154,75125,75,NULL,'MAT, I, inv','UGC 12383',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159970,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',159970,34.93,0.46,97,75126,70,NULL,NULL,'NGC 7488',NULL,'2015arXiv151105856S',2015,1,0.91,NULL,'G',0.000099,NULL,'14.6g',0.7,'S0- pec:',NULL,NULL,NULL,NULL,1,346.9539583,0.94053,0.141,NULL,51693334016,807708344,12620442,14.6),(159971,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159971,36.68,0.57,217,75127,70,NULL,NULL,'2MASX J23075283-4301176',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'17.31',0.21,NULL,NULL,NULL,NULL,NULL,1,346.9702083,-43.02156,NULL,NULL,50519174923,789362108,12333782,17.31),(159972,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 17063','RN',159972,40.41,0.48,1040,75128,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 17063',0.16701,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159973,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',159973,37.28,0.46,286,75129,70,NULL,NULL,'2MASX J23075372-0850544',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00017,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,346.9739583,-8.84833,0.093,NULL,49479182051,773112219,12079878,16.6),(159974,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159974,33.15,0.8,42.7,75130,75,NULL,'W91CL, r','UGC 12382',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000023,NULL,'16.40',0.18,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,346.979083333,5.16111,0.161,NULL,51728010370,808250162,12628908,16.4),(159975,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159975,33.17,0.8,43.1,75130,75,NULL,'MAT, I','UGC 12382',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159976,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159976,33.18,0.8,43.2,75130,75,NULL,'HMCL, I','UGC 12382',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159977,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159977,33.26,0.13,45,75130,NULL,NULL,NULL,'UGC 12382',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159978,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159978,33.88,0.32,59.7,75130,85,NULL,'I, raw','UGC 12382',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159979,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159979,33.88,0.32,59.8,75130,85,NULL,'I, inv','UGC 12382',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159980,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159980,33.97,NULL,62.1,75130,NULL,NULL,'Dipole','UGC 12382',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159981,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159981,33.97,NULL,62.3,75130,NULL,NULL,'Dipole + Quadrupole','UGC 12382',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159982,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159982,33.97,NULL,62.3,75130,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12382',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159983,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159983,34.12,0.43,66.5,75130,75,NULL,'MAT, I, raw','UGC 12382',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159984,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159984,34.18,0.43,68.5,75130,75,NULL,'MAT, I, inv','UGC 12382',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159985,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159985,34.23,NULL,70.1,75130,NULL,NULL,NULL,'UGC 12382',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159986,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159986,34.37,0.43,74.8,75130,75,NULL,'MAT, I, cor','UGC 12382',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159987,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159987,34.46,0.38,77.9,75130,75,NULL,'W91CL, r, raw','UGC 12382',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159988,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159988,34.5,0.38,79.3,75130,75,NULL,'W91CL, r, inv','UGC 12382',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159989,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159989,34.51,0.2,79.8,75130,74.4,NULL,NULL,'UGC 12382',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159990,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159990,34.58,0.4,82.3,75130,75,NULL,'HMCL, I, raw','UGC 12382',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159991,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159991,34.64,0.38,84.9,75130,75,NULL,'W91CL, r, cor','UGC 12382',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159992,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159992,34.66,0.4,85.7,75130,75,NULL,'HMCL, I, inv','UGC 12382',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159993,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159993,34.8,0.4,91.2,75130,75,NULL,'HMCL, I, cor','UGC 12382',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159994,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 14190','RN',159994,42.5,0.34,2310,75131,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 14190',0.370404,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159995,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 14190','RN',159995,43.03,0.32,2950,75131,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 14190',0.370404,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159996,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',159996,37.74,0.46,354,75132,70,NULL,NULL,'SDSS J230758.08-104023.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000167,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,346.9920417,-10.67328,0.053,NULL,50365593031,786962391,12296287,18.5),(159997,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 09334',NULL,159997,40.74,0.13,1410,75133,70,NULL,'SN photometric redshift distance, z photo =0.407 +/- 0.033','SDSS-II SN 09334',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,346.993,0.84164,0.153,NULL,51693430051,807709844,12620466,NULL),(159998,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 09334','R',159998,41.72,0.23,1600,75133,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 09334',0.382575,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159999,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 09334','R',159999,42.02,0.21,1830,75133,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 09334',0.382575,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160000,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160000,35.61,0.8,132,75134,75,NULL,'W91PP, r','UGC 12386',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000073,NULL,'16.0',0.6,'Scd:',NULL,NULL,NULL,NULL,1,347.0034583,24.97264,0.289,NULL,52010106814,812657918,12697779,16),(160001,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160001,35.67,0.38,136,75134,75,NULL,'W91PP, r, raw','UGC 12386',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160002,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160002,35.78,0.38,143,75134,75,NULL,'W91PP, r, inv','UGC 12386',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160003,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160003,35.87,0.38,149,75134,75,NULL,'W91PP, r, cor','UGC 12386',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160004,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18606',NULL,160004,39.79,0.45,907,75135,70,NULL,'SN photometric redshift distance, z photo =0.240 +/- 0.065','SDSS-II SN 18606',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.7g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,347.012,0.48236,0.157,NULL,51693532720,807711448,12620491,21.7),(160005,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18606',NULL,160005,40.1,0.31,1050,75135,70,NULL,NULL,'SDSS-II SN 18606',NULL,'2013MNRAS.434.1443X',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160006,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18606','R',160006,40.93,0.25,1150,75135,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18606',0.338532,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160007,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18606','R',160007,41.03,0.31,1200,75135,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18606',0.338532,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160008,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18606',NULL,160008,41.03,0.22,1610,75135,70,NULL,'SALT 2','SDSS-II SN 18606',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160009,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18606',NULL,160009,41.07,0.22,1640,75135,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18606',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160010,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160010,38.04,0.46,405,75136,70,NULL,NULL,'2MASX J23080387-0030371',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000088,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,347.0160417,-0.51031,0.137,NULL,49494644040,773353813,12083653,17.4),(160011,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160011,34.79,0.2,90.8,75137,74.4,NULL,NULL,'NGC 7491',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000107,NULL,'14.38',0.5,'HII',NULL,NULL,NULL,NULL,1,347.024917,-5.96667,0.121,NULL,49481822538,773153477,12080523,14.38),(160012,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160012,34.91,0.42,96.1,75137,NULL,NULL,'Malmquist cor.','NGC 7491',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160013,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160013,34.95,0.41,97.8,75137,NULL,NULL,NULL,'NGC 7491',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160014,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160014,35.05,0.97,102,75138,NULL,NULL,NULL,'MCG -02-59-001',NULL,'2009ApJS..182..474S',2009,1,0.74,'RC3 has V = 5581 km/s, and SDSS has z = 0.032823 +- 0.000084.','G',0.000033,NULL,'15.5g',0.44,'SB(s)bc pec:',NULL,NULL,NULL,NULL,1,347.0285417,-10.54264,0.049,NULL,50365701745,786964089,12296313,15.5),(160015,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160015,35.09,0.2,104,75138,74.4,NULL,NULL,'MCG -02-59-001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160016,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160016,35.12,0.93,106,75138,NULL,NULL,'Malmquist cor.','MCG -02-59-001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160017,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160017,36.94,0.46,244,75139,70,NULL,NULL,'2MASX J23080922+0010338',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000086,NULL,'16.2g',0.4,'E0',NULL,NULL,NULL,NULL,1,347.038458333,0.176,0.137,NULL,51693185503,807706023,12620406,16.2),(160018,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160018,37.37,0.46,298,75140,70,NULL,NULL,'SDSS J230811.88+153127.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000172,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,347.049541667,15.52431,0.205,NULL,52553983889,821155998,12830562,18.4),(160019,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160019,38.12,0.33,420,75141,70,NULL,NULL,'2MASX J23081728-0946230',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00015,NULL,'17.4g',0.19,'AGN',NULL,NULL,NULL,NULL,1,347.072,-9.77294,0.037,NULL,49479643676,773119432,12079991,17.4),(160020,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 19087','RN',160020,40.57,0.48,889,75142,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 19087',0.463206,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160021,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 02646','RN',160021,40.62,0.8,1240,75143,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02646',0.070162,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160022,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160022,37.32,0.46,291,75144,70,NULL,NULL,'SDSS J230817.52+004437.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00007,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,347.0732083,0.74372,0.153,NULL,51693402507,807709414,12620459,17.6),(160023,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160023,38.12,0.33,420,75145,70,NULL,NULL,'2MASX J23082309-0941180',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,347.09625,-9.68847,0.057,NULL,49479639110,773119361,12079990,17.5),(160024,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 09020','RN',160024,41.41,0.31,1390,75146,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 09020',0.377698,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160025,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 09020','RN',160025,41.54,0.36,1480,75146,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 09020',0.377698,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160026,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 09020','N',160026,41.42,0.24,1920,75146,70,NULL,'SALT 2','SDSS-II SN 09020',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160027,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 09020','N',160027,41.47,0.24,1970,75146,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 09020',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160028,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160028,37.82,0.46,366,75147,70,NULL,NULL,'2MASX J23082936-1036312',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,347.122417,-10.60856,0.049,NULL,50365672353,786963630,12296306,17.2),(160029,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160029,38.18,0.46,432,75148,70,NULL,NULL,'SDSS J230830.32+145838.6',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.00015,NULL,'19.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,347.126375,14.97742,0.257,NULL,52553420585,821147196,12830424,19.3),(160030,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160030,34.07,0.43,65,75149,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12388',NULL,'2014MNRAS.444..527S',2014,1,1.8,'The 2MASS position refers to a stellar object 8 arcsec west of the nucleus.','G',0.00001,NULL,'16.0',0.8,'Sd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,347.1264583,12.83056,0.157,NULL,52550266657,821097916,12829654,16),(160031,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160031,34.42,0.49,76.5,75150,75,NULL,'IR','CGCG 431-005',NULL,'2011yCatp016004901K',2011,1,0.96,NULL,'G',0.000121,NULL,'15.6g',0.26,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,347.133541667,13.20972,0.145,NULL,52547667365,821057302,12829020,15.6),(160032,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 02272','RN',160032,43.47,0.29,3350,75151,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 02272',0.473646,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160033,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160033,37.72,0.46,350,75152,70,NULL,NULL,'2MASX J23084409-1044372',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,347.18375,-10.74361,0.049,NULL,50365661951,786963467,12296304,17.1),(160034,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160034,34.59,0.46,83,75153,70,NULL,NULL,'IC 1471',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000083,NULL,'14.57',0.4,'poss. LINER',NULL,NULL,NULL,NULL,1,347.186875,-12.63944,0.041,NULL,50402912743,787545511,12305398,14.57),(160035,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160035,36.61,0.72,210,75154,70,NULL,NULL,'2MASX J23084670-4858427',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.69',0.36,NULL,NULL,NULL,NULL,NULL,1,347.194667,-48.97853,0,NULL,50507688359,789182630,12330978,16.69),(160036,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160036,37.46,0.46,310,75155,70,NULL,NULL,'2MASX J23084965+1423351',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,347.2067083,14.39294,0.181,NULL,52561014708,821265854,12832278,18.3),(160037,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160037,31.57,0.8,20.6,75156,75,NULL,'A82, H','ESO 469- G 015',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000021,NULL,'15.14',0.2,'Sb: sp','Isolated galaxy',NULL,NULL,NULL,1,347.2317083,-30.85792,NULL,NULL,50156050194,783688284,12245129,15.14),(160038,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160038,31.57,0.8,20.6,75156,75,NULL,'MAT, I','ESO 469- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160039,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160039,31.79,0.4,22.8,75156,NULL,NULL,'mean','ESO 469- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160040,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160040,32.03,0.47,25.4,75156,75,NULL,'A82, H, inv','ESO 469- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160041,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160041,32.06,0.43,25.8,75156,75,NULL,'3.6 micron, color + selection bias corrected','ESO 469- G 015',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160042,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160042,32.09,0.47,26.2,75156,75,NULL,'A82, H, raw','ESO 469- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160043,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160043,32.1,0.38,26.3,75156,NULL,NULL,NULL,'ESO 469- G 015',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160044,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160044,32.1,0.4,26.4,75156,75,NULL,NULL,'ESO 469- G 015',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160045,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160045,32.11,0.4,26.4,75156,73,NULL,'IR','ESO 469- G 015',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160046,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160046,32.2,0.43,27.5,75156,75,NULL,'3.6 micron, color corrected','ESO 469- G 015',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160047,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160047,32.2,0.32,27.6,75156,85,NULL,'I, inv','ESO 469- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160048,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160048,32.21,0.32,27.7,75156,85,NULL,'I, raw','ESO 469- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160049,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160049,32.32,0.2,29.1,75156,74.4,NULL,NULL,'ESO 469- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160050,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160050,32.38,0.47,29.9,75156,75,NULL,'A82, H, cor','ESO 469- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160051,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160051,32.39,0.43,30.1,75156,75,NULL,'MAT, I, raw','ESO 469- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160052,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160052,32.42,0.43,30.5,75156,75,NULL,'MAT, I, inv','ESO 469- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160053,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160053,32.62,0.43,33.5,75156,75,NULL,'MAT, I, cor','ESO 469- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160054,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160054,32.79,0.47,36.1,75156,NULL,NULL,'H','ESO 469- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160055,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 1973N',NULL,160055,33.75,0.4,56.2,75157,60,NULL,'M(B) = -19.48 mag','NGC 7495',NULL,'2000ApJ...540..634P',2000,1,1.8,NULL,'G',0.000013,NULL,'13.7B',1.7,'SAB(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,347.23825,12.04803,0.141,NULL,52546923001,821045671,12828838,13.7),(160056,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 1973N',NULL,160056,33.85,0.4,58.9,75157,60,NULL,'M(V) = -19.47 mag','NGC 7495',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160057,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 1973N',NULL,160057,34.2,0.55,69,75157,67,NULL,NULL,'NGC 7495',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160058,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 1973N',NULL,160058,34.2,0.05,69.2,75157,66,NULL,NULL,'NGC 7495',NULL,'1994A&A...281...51M',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160059,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160059,31.79,0.8,22.8,75158,75,NULL,'A82, H','NGC 7497',NULL,'1997ApJS..109..333W',1997,1,4.9,NULL,'G',0.000007,NULL,'12.96',1.1,'SB(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,347.264208333,18.17719,0.149,NULL,52571499579,821429680,12834838,12.96),(160060,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160060,30.74,0.4,14.1,75158,75,NULL,NULL,'NGC 7497',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160061,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160061,30.75,0.39,14.1,75158,73,NULL,'IR','NGC 7497',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160062,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160062,31.05,0.38,16.2,75158,NULL,NULL,NULL,'NGC 7497',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160063,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160063,31.05,0.4,16.2,75158,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 7497',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160064,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160064,31.05,0.2,16.2,75158,74.4,NULL,NULL,'NGC 7497',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160065,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160065,31.14,0.42,16.9,75158,NULL,NULL,'Malmquist cor.','NGC 7497',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160066,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160066,31.13,0.43,16.9,75158,75,NULL,'3.6 micron, color corrected','NGC 7497',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160067,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160067,31.16,0.43,17.1,75158,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7497',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160068,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160068,31.18,0.47,17.2,75158,75,NULL,'A82, H, raw','NGC 7497',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160069,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160069,31.21,0.41,17.4,75158,NULL,NULL,NULL,'NGC 7497',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160070,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160070,31.2,0.47,17.4,75158,75,NULL,'A82, H, inv','NGC 7497',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160071,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160071,31.32,0.4,18.4,75158,NULL,NULL,'mean','NGC 7497',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160072,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160072,31.42,0.49,19.2,75158,75,NULL,'IR','NGC 7497',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160073,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160073,31.61,0.47,20.9,75158,75,NULL,'A82, H, cor','NGC 7497',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160074,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160074,31.77,0.47,22.6,75158,NULL,NULL,'H','NGC 7497',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160075,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160075,31.78,0.46,22.7,75158,NULL,NULL,'J','NGC 7497',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160076,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160076,31.88,0.45,23.8,75158,NULL,NULL,'K','NGC 7497',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160077,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160077,31.91,0.4,24.1,75158,75,NULL,'B','NGC 7497',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160078,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160078,38.88,0.46,597,75159,70,NULL,NULL,'2MASX J23090473-1046389',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,347.26975,-10.77756,0.049,NULL,50365629977,786962968,12296296,18),(160079,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 03817','RN',160079,45.09,0.13,9400,75160,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03817',0.108064,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160080,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160080,35.68,0.57,137,75161,70,NULL,NULL,'2MASX J23090682-8039321',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'16.3b',0.2,NULL,NULL,NULL,NULL,NULL,1,347.27875,-80.659,0.461,NULL,48337075966,755266811,11801043,16.3),(160081,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160081,36.46,0.56,196,75162,70,NULL,NULL,'2MASX J23091212-0151126',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.31',0.3,NULL,NULL,NULL,NULL,NULL,1,347.3005,-1.85356,0.145,NULL,49506783226,773543487,12086616,16.31),(160082,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 11142','RN',160082,41.66,0.41,1740,75163,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 11142',0.238017,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160083,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18276',NULL,160083,39.91,0.29,960,75164,70,NULL,'SN photometric redshift distance, z photo =0.256 +/- 0.043','SDSS-II SN 18276',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','22.1g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,347.317167,-0.45756,0.145,NULL,49494516943,773351827,12083622,22.1),(160084,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18276','R',160084,40.66,0.16,1050,75164,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18276',0.28462,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160085,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18276','R',160085,40.68,0.25,1060,75164,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18276',0.28462,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160086,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18276',NULL,160086,40.58,0.15,1310,75164,70,NULL,'SALT 2','SDSS-II SN 18276',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160087,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18276',NULL,160087,40.61,0.15,1320,75164,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18276',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160088,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 21807','RN',160088,38.31,0.24,444,75165,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 21807',0.032399,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160089,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 15685',NULL,160089,40.67,0.18,1360,75166,70,NULL,'SN photometric redshift distance, z photo =0.391 +/- 0.043','SDSS-II SN 15685',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','22.2g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,347.3495417,0.80197,0.141,NULL,51693816375,807715880,12620560,22.2),(160090,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 15685','R',160090,42.17,0.3,1960,75166,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15685',0.385981,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160091,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 15685','R',160091,42.59,0.31,2380,75166,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15685',0.385981,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160092,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160092,37.85,0.33,371,75167,70,NULL,NULL,'SDSS J230926.67+151256.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000152,NULL,'18.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,347.361125,15.21564,0.245,NULL,52553536989,821149015,12830453,18.6),(160093,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160093,37.69,0.46,345,75168,70,NULL,NULL,'2MASX J23092965-0925217',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,347.373417,-9.42269,0.057,NULL,49480152985,773127390,12080115,17.7),(160094,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160094,34.17,0.2,68.2,75169,74.4,NULL,NULL,'CGCG 496-047',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'15.71',0.2,'S?',NULL,NULL,NULL,NULL,1,347.3745417,29.48331,0.305,NULL,52064192069,813503001,12710984,15.71),(160095,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160095,34.3,0.45,72.4,75169,NULL,NULL,NULL,'CGCG 496-047',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160096,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160096,34.31,0.49,72.8,75169,75,NULL,'IR','CGCG 496-047',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160097,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160097,34.61,0.39,83.6,75169,NULL,NULL,'Malmquist cor.','CGCG 496-047',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160098,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160098,36.35,0.8,186,75170,70,NULL,NULL,'2MASX J23093116-4953240',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.54',0.36,NULL,NULL,NULL,NULL,NULL,1,347.379875,-49.89003,0,NULL,50506202923,789159420,12330615,16.54),(160099,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160099,37.85,0.33,371,75171,70,NULL,NULL,'2MASX J23093346+1508151',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000168,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,347.389375,15.13772,0.245,NULL,52553575658,821149619,12830462,18.7),(160100,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160100,34.59,0.49,82.7,75172,75,NULL,'IR','UGC 12395',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.00002,NULL,'15.69',0.1,'Sdm:',NULL,NULL,NULL,NULL,1,347.3934583,15.65475,0.193,NULL,52552905840,821139153,12830299,15.69),(160101,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160101,34.87,0.56,94.1,75172,NULL,NULL,'Malmquist cor.','UGC 12395',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160102,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160102,34.89,0.56,95,75172,NULL,NULL,NULL,'UGC 12395',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160103,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160103,34.92,0.2,96.4,75172,74.4,NULL,NULL,'UGC 12395',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160104,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160104,35.1,0.54,105,75173,NULL,NULL,NULL,'ESO 077- G 003',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000017,NULL,'14.76',0.7,'SAB(r)c','Pair member (points to parent)',NULL,NULL,NULL,1,347.413667,-72.026,0.065,NULL,48393459037,756147797,11814809,14.76),(160105,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160105,35.14,0.2,107,75173,74.4,NULL,NULL,'ESO 077- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160106,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160106,35.17,0.52,108,75173,NULL,NULL,'Malmquist cor.','ESO 077- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160107,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160107,31.55,0.8,20.5,75174,75,NULL,'MAT, I','ESO 407- G 007',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.000093,NULL,'13.78',0.4,'SAb? sp','Group member',NULL,NULL,NULL,1,347.414167,-36.42008,NULL,NULL,49966292577,780723321,12198801,13.78),(160108,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160108,31.98,0.43,24.9,75174,75,NULL,'3.6 micron, color + selection bias corrected','ESO 407- G 007',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160109,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160109,32.23,0.4,28,75174,75,NULL,NULL,'ESO 407- G 007',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160110,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160110,32.24,0.4,28,75174,73,NULL,'IR','ESO 407- G 007',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160111,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160111,32.25,0.43,28.2,75174,75,NULL,'3.6 micron, color corrected','ESO 407- G 007',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160112,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160112,32.3,0.4,28.9,75174,73,NULL,'opt','ESO 407- G 007',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160113,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160113,32.38,0.4,29.9,75174,NULL,NULL,NULL,'ESO 407- G 007',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160114,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160114,32.53,0.2,32.1,75174,74.4,NULL,NULL,'ESO 407- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160115,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160115,32.55,0.32,32.3,75174,85,NULL,'I, raw','ESO 407- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160116,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160116,32.57,0.32,32.7,75174,85,NULL,'I, inv','ESO 407- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160117,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160117,32.61,0.49,33.3,75174,75,NULL,'IR','ESO 407- G 007',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160118,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160118,32.8,0.43,36.3,75174,75,NULL,'MAT, I, raw','ESO 407- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160119,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160119,32.94,0.43,38.7,75174,75,NULL,'MAT, I, inv','ESO 407- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160120,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160120,32.94,0.43,38.8,75174,75,NULL,'MAT, I, cor','ESO 407- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160121,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 02578','RN',160121,41.02,0.14,1280,75175,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 02578',0.247102,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160122,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 02578','RN',160122,41.32,0.22,1480,75175,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02578',0.247102,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160123,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160123,37.9,0.46,380,75176,70,NULL,NULL,'SDSS J230942.55+001049.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000075,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,347.427333333,0.18042,0.129,NULL,51694069774,807719840,12620622,18.6),(160124,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 07767','RN',160124,40.99,0.1,1170,75177,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 07767',0.351778,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160125,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 07767','RN',160125,41.21,0.2,1290,75177,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 07767',0.351778,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160126,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160126,29.34,0.43,7.4,75178,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7496',NULL,'2014MNRAS.444..527S',2014,1,3.3,NULL,'G',0.000018,NULL,'11.91',3,'(R\':)SB(rs)bc  Sy2','X-ray-faint group member',NULL,NULL,'Sy 2',1,347.4470417,-43.42794,NULL,NULL,50530278482,789535601,12336493,11.91),(160127,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160127,30.36,0.47,11.8,75178,NULL,NULL,'H','NGC 7496',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160128,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160128,30.38,0.46,11.9,75178,NULL,NULL,'J','NGC 7496',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160129,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160129,30.39,0.45,11.9,75178,NULL,NULL,'K','NGC 7496',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160130,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160130,31.44,0.4,19.4,75178,NULL,NULL,'mean','NGC 7496',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160131,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160131,31.51,0.4,20.1,75178,75,NULL,'B','NGC 7496',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160132,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 15359',NULL,160132,40.08,0.16,1040,75179,70,NULL,'SN photometric redshift distance, z photo =0.280 +/- 0.026','SDSS-II SN 15359',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,347.45625,0.3105,0.125,NULL,51694053693,807719588,12620618,NULL),(160133,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 15359','R',160133,40.72,0.23,1060,75179,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15359',0.311973,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160134,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 15359','R',160134,40.74,0.15,1070,75179,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15359',0.311973,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160135,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 15359',NULL,160135,40.56,0.13,1290,75179,70,NULL,'SALT 2','SDSS-II SN 15359',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160136,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 15359',NULL,160136,40.59,0.13,1310,75179,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15359',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160137,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 08867','RN',160137,39.69,0.41,786,75180,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08867',0.103674,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160138,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160138,36.82,0.63,231,75181,70,NULL,NULL,'2MASX J23095720-4947250',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'15.6R',0.14,NULL,NULL,NULL,NULL,NULL,1,347.488375,-49.79025,0,NULL,50506191051,789159235,12330613,15.6),(160139,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160139,38.11,0.27,419,75182,70,NULL,NULL,'SDSS J230957.84+144213.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000147,NULL,'19.2g',0.08,NULL,NULL,NULL,NULL,NULL,1,347.491,14.70375,0.257,NULL,52552686301,821135723,12830245,19.2),(160140,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 13778','RN',160140,44.15,0.25,4400,75183,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13778',0.532422,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160141,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160141,35.87,0.2,149,75184,74.4,NULL,NULL,'KUG 2307+065',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000113,NULL,'15.2',0.4,'Spiral',NULL,NULL,NULL,NULL,1,347.4995,6.78972,0.189,NULL,51719911295,808123613,12626931,15.2),(160142,'Tully est','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160142,32,0.8,25.2,75185,75,NULL,NULL,'UGCA 436',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000017,NULL,'17',1.3,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,347.499583,18.44806,0.149,NULL,52500955336,820327427,12817616,17),(160143,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 10690','R',160143,40.45,0.29,937,75186,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 10690',0.312052,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,347.499833,1.08225,0.145,NULL,51693953959,807718030,12620594,NULL),(160144,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160144,38.06,0.46,410,75187,70,NULL,NULL,'2MASX J23100421+1517528',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000184,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,347.5177083,15.29819,0.229,NULL,52553482152,821148158,12830439,18.2),(160145,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2006en',NULL,160145,35.05,0.17,99.2,75188,74.2,NULL,'SALT 2','ARK 577',0.031939,'2010ApJ...716..712A',2010,1,0.5,NULL,'G',0.000033,NULL,'14.83',0.4,'Sc',NULL,NULL,NULL,NULL,1,347.519541667,30.22433,0.269,NULL,52064560387,813508756,12711074,14.83),(160146,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2006en',NULL,160146,35.55,0.03,125,75188,72,NULL,'SALT2','ARK 577',0.031939,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160147,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2006en',NULL,160147,35.65,0.16,131,75188,70,NULL,'SALT 2','ARK 577',0.031939,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160148,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2006en',NULL,160148,35.62,0.09,133,75188,74.4,NULL,NULL,'ARK 577',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160149,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2006en','R',160149,35.68,0.09,137,75188,NULL,NULL,'MLCS2k2, R(V) = 3.1','ARK 577',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160150,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2006en','R',160150,35.74,0.07,141,75188,NULL,NULL,'MLCS2k2, R(V) = 1.8','ARK 577',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160151,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2006en',NULL,160151,35.91,0.19,148,75188,65,NULL,'SALT2','ARK 577',0.031939,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160152,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2006en',NULL,160152,35.93,0.2,149,75188,65,NULL,'MLCS31','ARK 577',0.031939,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160153,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2006en',NULL,160153,35.93,0.17,149,75188,65,NULL,'MLCS17','ARK 577',0.031939,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160154,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2006en',NULL,160154,35.95,0.17,150,75188,65,NULL,'SALT','ARK 577',0.031939,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160155,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160155,34.78,0.68,90.5,75189,70,NULL,NULL,'2MASX J23100646-8040178',NULL,'2014MNRAS.445.2677S',2014,1,0.23,NULL,'G',0.00015,NULL,'16.6b',0.21,NULL,NULL,NULL,NULL,NULL,1,347.526625,-80.67164,0.461,NULL,48337070532,755266727,11801042,16.6),(160156,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 08004','R',160156,41.34,0.3,1370,75190,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J231006.87-003328.9',0.3514,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',0.0001,NULL,'21.2g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,347.528625,-0.55803,0.149,NULL,49496662929,773385358,12084146,21.2),(160157,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 08004','R',160157,41.43,0.38,1430,75190,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J231006.87-003328.9',0.3514,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160158,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 08004',NULL,160158,41.24,0.24,1770,75190,70,NULL,'SALT 2','SDSS J231006.87-003328.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160159,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 08004',NULL,160159,41.28,0.24,1800,75190,70,NULL,'SALT 2, Malmquist cor.','SDSS J231006.87-003328.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160160,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 20956','RN',160160,41.27,0.29,1520,75191,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 20956',0.183368,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160161,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 20956','RN',160161,41.52,0.37,1700,75191,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20956',0.183368,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160162,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 16395','RN',160162,40.15,0.15,965,75192,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16395',0.108114,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160163,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 16395','RN',160163,40.17,0.24,975,75192,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16395',0.108114,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160164,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 17391','R',160164,39.8,0.23,767,75193,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007jo','SN 2007jo',0.19,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,347.552417,-0.93142,0.117,NULL,49496812751,773387699,12084182,NULL),(160165,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 17391','R',160165,39.97,0.15,830,75193,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007jo','SN 2007jo',0.19,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160166,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160166,37.32,0.33,290,75194,70,NULL,NULL,'2MASX J23101507-1047540',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.00015,NULL,'15.5g',0.59,'cD m',NULL,NULL,NULL,NULL,1,347.5627083,-10.79844,0.045,NULL,50366123255,786970675,12296416,15.5),(160167,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160167,37.14,0.79,268,75195,70,NULL,NULL,'2MASX J23101890-4956011',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'17.07',0.27,NULL,NULL,NULL,NULL,NULL,1,347.5787917,-49.93369,0,NULL,50506021967,789156593,12330571,17.07),(160168,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160168,35.58,0.49,130,75196,75,NULL,'IR','UGC 12398',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',NULL,NULL,'15.64',0.2,'S?',NULL,NULL,NULL,NULL,1,347.589917,2.62128,0.173,NULL,51705748355,807902318,12623473,15.64),(160169,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160169,35.6,0.45,132,75196,NULL,NULL,'Malmquist cor.','UGC 12398',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160170,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160170,35.74,0.43,140,75196,NULL,NULL,NULL,'UGC 12398',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160171,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160171,35.82,0.2,146,75196,74.4,NULL,NULL,'UGC 12398',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160172,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160172,34.44,0.51,77.2,75197,70,NULL,NULL,'VV 490 NED01',NULL,'2014MNRAS.445.2677S',2014,1,2.54,NULL,'G',0.00003,NULL,'14.9g',0.28,'SB(s)c pec sp',NULL,NULL,NULL,NULL,1,347.5910417,-8.68869,0.085,NULL,49477511422,773086115,12079470,14.9),(160173,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160173,35,0.49,100,75197,75,NULL,'IR','VV 490 NED01',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160174,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160174,36.09,0.4,165,75198,NULL,NULL,'mean','NGC 7499',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000093,NULL,'13.0V',0.7,'BrClG;SA(s)0^0^:','in a pair',NULL,NULL,NULL,1,347.5932917,7.58067,0.185,NULL,51717263038,808082234,12626284,13),(160175,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160175,36.09,0.45,165,75198,NULL,NULL,'K','NGC 7499',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160176,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160176,38.11,0.27,419,75199,70,NULL,NULL,'SDSS J231023.89+143349.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000146,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,347.5995417,14.56389,0.197,NULL,52560939687,821264682,12832260,18.4),(160177,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160177,37.55,0.46,324,75200,70,NULL,NULL,'2MASX J23102604+1510579',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000165,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,347.608458333,15.18281,0.229,NULL,52553505579,821148524,12830445,18.2),(160178,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 07600','R',160178,39.65,0.2,718,75201,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J231027.25-010627.7',0.188,'2014arXiv1401.3317S',2014,1,0.13,NULL,'G',0.0005,NULL,'19.9g',0.07,NULL,NULL,NULL,NULL,NULL,1,347.613583333,-1.10769,0.117,NULL,49496132776,773377074,12084016,19.9),(160179,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 07600','R',160179,39.7,0.12,732,75201,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J231027.25-010627.7',0.188,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160180,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 07600',NULL,160180,39.4,0.1,759,75201,70,NULL,'SALT 2','SDSS J231027.25-010627.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160181,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 07600',NULL,160181,39.41,0.1,762,75201,70,NULL,'SALT 2, Malmquist cor.','SDSS J231027.25-010627.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160182,'BL Lac Luminosity','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160182,42.08,NULL,2610,75202,70,NULL,'nucleus-to-host flux ratio, z > 1.03','GALEXASC J231028.07-371909.3',NULL,'2006AJ....132....1S',2006,1,NULL,NULL,'QSO',NULL,NULL,'18.3',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,347.616667,-37.31917,NULL,NULL,50484815056,788825235,12325394,18.3),(160183,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160183,37.32,0.33,290,75203,70,NULL,NULL,'SDSS J231029.68-104346.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000164,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,347.623667,-10.72967,0.045,NULL,49476862655,773075978,12079312,18.1),(160184,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160184,37.63,0.46,335,75204,70,NULL,NULL,'SDSS J231030.39-100042.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000137,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,347.626667,-10.01175,0.013,NULL,49479943111,773124111,12080064,18.4),(160185,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160185,38.11,0.27,419,75205,70,NULL,NULL,'SDSS J231033.26+143754.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000152,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,347.638625,14.63181,0.193,NULL,52552579637,821134056,12830219,18.6),(160186,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160186,35.07,0.2,103,75206,74.4,NULL,NULL,'CGCG 406-010',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00012,NULL,'15.6',0.5,NULL,NULL,NULL,NULL,NULL,1,347.658666667,8.18986,0.133,NULL,51721881187,808154393,12627412,15.6),(160187,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2001ic',NULL,160187,35.33,0.2,111,75207,74.2,NULL,'SALT 2','NGC 7503',0.044237,'2010ApJ...716..712A',2010,1,1.1,NULL,'G',0.00009,NULL,'13.5V',1.1,'E2:;BrClG','in a pair',NULL,'radio jet',NULL,1,347.676167,7.56769,0.185,NULL,51717256541,808082133,12626283,13.5),(160188,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2001ic',NULL,160188,36.02,0.09,160,75207,74.4,NULL,NULL,'NGC 7503',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160189,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2001ic',NULL,160189,36.44,0.21,186,75207,65,NULL,'MLCS17','NGC 7503',0.044237,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160190,'Faber-Jackson','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160190,34.81,0.44,91.6,75207,95,NULL,'Weighted Mean','NGC 7503',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160191,'Faber-Jackson','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160191,35.45,0.63,123,75207,95,NULL,'Michard 1979b, c','NGC 7503',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160192,'Faber-Jackson','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160192,35.45,0.46,123,75207,95,NULL,'Michard 1979a','NGC 7503',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160193,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160193,36.06,0.45,163,75207,NULL,NULL,'K','NGC 7503',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160194,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160194,36.14,0.4,169,75207,NULL,NULL,'mean','NGC 7503',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160195,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 19221','RN',160195,40.04,0.09,977,75208,70,NULL,'SDSS CAND. SNII; MLCS2K2','SDSS-II SN 19221',0.043,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160196,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 19221','RN',160196,40.57,0.34,1240,75208,70,NULL,'SDSS CAND. SNII; SALT 2','SDSS-II SN 19221',0.043,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160197,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160197,37.44,0.46,307,75209,70,NULL,NULL,'2MASX J23104726-0832436',NULL,'2015arXiv151105856S',2015,1,0.46,'Star superposed 14\\\" northwest of the nucleus.','G',0.000197,NULL,'16.2g',0.39,'E0',NULL,NULL,NULL,NULL,1,347.696917,-8.54533,0.093,NULL,49491543659,773305369,12082896,16.2),(160198,'M Stars','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'N',160198,20.06,0.87,0.103,75210,NULL,NULL,NULL,'Pisces Overdensity',NULL,'2010ApJ...722..750S',2010,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160199,'RR Lyrae','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'N',160199,19.5,NULL,0.0794,75210,NULL,NULL,NULL,'Pisces Overdensity',NULL,'2009MNRAS.398.1757W',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160200,'RR Lyrae','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'N',160200,19.52,NULL,0.08,75210,NULL,NULL,NULL,'Pisces Overdensity',NULL,'2010ApJ...708..717S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160201,'RR Lyrae','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'N',160201,19.54,NULL,0.081,75210,NULL,NULL,NULL,'Pisces Overdensity',NULL,'2007AJ....134.2236S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160202,'RR Lyrae','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'N',160202,19.57,NULL,0.082,75210,NULL,NULL,NULL,'Pisces Overdensity',NULL,'2010ApJ...717..133S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160203,'RR Lyrae','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'RN',160203,19.65,NULL,0.085,75210,NULL,NULL,NULL,'Pisces Overdensity',NULL,'2009ApJ...705L.158K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160204,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 01741',NULL,160204,39.02,0.42,638,75211,70,NULL,'SN photometric redshift distance, z photo =0.162 +/- 0.039','SDSS-II SN 01741',NULL,'2011ApJ...738..162S',2011,1,0.13,NULL,'G',NULL,'PHOT','20.4g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,347.723417,-0.568,0.125,NULL,49496641189,773385018,12084140,20.4),(160205,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 01741','R',160205,40,0.21,828,75211,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01741',0.20496,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160206,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 01741','R',160206,40.17,0.27,896,75211,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01741',0.20496,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160207,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160207,37.55,0.46,323,75212,70,NULL,NULL,'2MASX J23105750+1345157',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000182,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,347.739583,13.75447,0.181,NULL,52548168223,821065128,12829142,17.6),(160208,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','PTF11lih','N',160208,37.7,0.03,323,75213,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF11lih',0.072,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160209,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 13442','RN',160209,37.76,0.36,323,75214,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13442',0.102441,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160210,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 13442','RN',160210,38.93,0.32,554,75214,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13442',0.102441,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160211,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160211,37.22,0.46,278,75215,70,NULL,NULL,'SDSS J231102.89-103714.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,347.7620417,-10.62061,0.025,NULL,49476913810,773076778,12079324,17.7),(160212,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160212,37.57,0.77,326,75216,70,NULL,NULL,'2MASX J23110471-4613101',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'16.52',0.3,NULL,NULL,NULL,NULL,NULL,1,347.76975,-46.21956,NULL,NULL,50523345383,789427271,12334801,16.52),(160213,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160213,37.58,0.46,327,75217,70,NULL,NULL,'SDSS J231106.62+135623.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000146,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,347.777583,13.93992,0.149,NULL,52547464896,821054139,12828970,18.3),(160214,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160214,34.14,0.2,67.3,75218,74.4,NULL,NULL,'UGC 12403',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'16.0',0.4,'SBcd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,347.777917,12.78611,0.145,NULL,52549952960,821093015,12829578,16),(160215,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160215,34.84,0.46,92.7,75219,70,NULL,NULL,'CGCG 380-005',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000074,NULL,'15.1g',0.61,NULL,NULL,NULL,NULL,NULL,1,347.79175,-0.15225,0.137,NULL,49493273277,773332394,12083318,15.1),(160216,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160216,36.16,0.52,171,75220,70,NULL,NULL,'2MASX J23111086-7503323',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'16.2b',0.25,NULL,NULL,NULL,NULL,NULL,1,347.795,-75.05894,0.113,NULL,48450598696,757040604,11828759,16.2),(160217,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160217,31.12,NULL,16.8,75221,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 291- G 003',NULL,'2010Ap&SS.325..163P',2010,1,1.83,'Possible cross-ID with HIPASS J2311-42 (2011AJ....142...83N).','G',0.000183,NULL,'15.72',0.23,'SBdm? sp',NULL,NULL,NULL,NULL,1,347.795333333,-42.84756,NULL,NULL,50530041685,789531901,12336435,15.72),(160218,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160218,31.16,NULL,17.1,75221,NULL,NULL,'Dipole + Quadrupole','ESO 291- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160219,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160219,31.19,NULL,17.3,75221,NULL,NULL,'Dipole','ESO 291- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160220,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 03234','RN',160220,41.75,0.19,1780,75222,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03234',0.259217,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160221,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 13038','R',160221,38.6,0.22,475,75223,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006gn','SN 2006gn',0.104,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,347.8267917,0.50461,0.129,NULL,51691282861,807676294,12619942,NULL),(160222,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 13038','R',160222,38.88,0.07,540,75223,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006gn','SN 2006gn',0.104,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160223,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2005kq',NULL,160223,41.19,0.19,1240,75224,74.2,NULL,'SALT 2','SDSS J231120.74-003630.7',0.39,'2010ApJ...716..712A',2010,1,0.09,NULL,'G',NULL,NULL,'20.7g',0.07,NULL,NULL,NULL,NULL,NULL,1,347.8364583,-0.60856,0.125,NULL,49496647878,773385123,12084142,20.7),(160224,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2005kq',NULL,160224,41.94,0.2,1760,75224,70,NULL,'SALT 2','SDSS J231120.74-003630.7',0.39,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160225,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2005kq',NULL,160225,41.94,0.27,1760,75224,65,NULL,'SALT2','SDSS J231120.74-003630.7',0.39,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160226,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 09045','R',160226,42.04,0.3,1840,75224,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005kq','SDSS J231120.74-003630.7',0.39,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160227,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2005kq',NULL,160227,42.07,0.13,1870,75224,65,NULL,'MLCS2k2','SDSS J231120.74-003630.7',0.39,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160228,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 09045','R',160228,42.3,0.29,2070,75224,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005kq','SDSS J231120.74-003630.7',0.39,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160229,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 08061','RN',160229,41.42,0.14,1580,75225,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 08061',0.216617,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160230,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 08061','RN',160230,41.9,0.35,1970,75225,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 08061',0.216617,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160231,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18473','RN',160231,41.15,0.31,1250,75226,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18473',0.362207,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160232,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18473','RN',160232,41.52,0.31,1480,75226,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18473',0.362207,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160233,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18473','N',160233,41,0.22,1580,75226,70,NULL,'SALT 2','SDSS-II SN 18473',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160234,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18473','N',160234,41.05,0.22,1620,75226,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18473',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160235,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 19652',NULL,160235,39.38,0.52,752,75227,70,NULL,'SN photometric redshift distance, z photo =0.194 +/- 0.060','SDSS-II SN 19652',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','20.6g',0.08,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,347.8745,1.02383,0.125,NULL,51694776868,807730888,12620795,20.6),(160236,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 19652','R',160236,40.19,0.25,875,75227,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19652',0.245953,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160237,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 19652','R',160237,40.2,0.2,878,75227,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19652',0.245953,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160238,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 19652',NULL,160238,40.01,0.15,1000,75227,70,NULL,'SALT 2','SDSS-II SN 19652',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160239,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 19652',NULL,160239,40.03,0.15,1010,75227,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19652',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160240,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160240,36.31,0.85,182,75228,70,NULL,NULL,'2MASX J23113169-5935471',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'16.82',0.31,NULL,NULL,NULL,NULL,NULL,1,347.88225,-59.59653,0,NULL,48847782424,763246600,11925728,16.82),(160241,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160241,32.48,NULL,31.4,75229,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -03-59-001',NULL,'2010Ap&SS.325..163P',2010,1,1.57,NULL,'G',0.000035,NULL,'15',0.2,'Sdm',NULL,NULL,NULL,NULL,1,347.902875,-15.47642,0.075,NULL,50288016760,785750261,12277347,15),(160242,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160242,32.51,NULL,31.8,75229,NULL,NULL,'Dipole + Quadrupole','MCG -03-59-001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160243,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160243,32.51,NULL,31.8,75229,NULL,NULL,'Dipole','MCG -03-59-001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160244,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 04253','RN',160244,43.21,0.41,2780,75230,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04253',0.577436,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160245,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160245,33.58,0.45,52.1,75231,NULL,NULL,'K','NGC 7506',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000063,NULL,'13.88',1.1,'(R\')SB(r)0+:',NULL,NULL,NULL,NULL,1,347.92075,-2.16003,0.129,NULL,49507339806,773552184,12086752,13.88),(160246,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160246,33.67,0.4,54.2,75231,NULL,NULL,'mean','NGC 7506',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160247,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 10480',NULL,160247,39,1.14,631,75232,70,NULL,'SN photometric redshift distance, z photo =0.160 +/- 0.130','SDSS-II SN 10480',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,347.9312083,-0.82017,0.125,NULL,49496773868,773387091,12084173,NULL),(160248,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18479',NULL,160248,40.09,0.17,1040,75233,70,NULL,'SN photometric redshift distance, z photo =0.282 +/- 0.028','SDSS-II SN 18479',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,347.950791667,-0.81114,0.125,NULL,49496730437,773386413,12084162,NULL),(160249,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160249,34.85,0.8,93.4,75234,75,NULL,'W91PP, r','UGC 12410',NULL,'1997ApJS..109..333W',1997,1,1.84,NULL,'G',0.000008,NULL,'16.0',0.17,'Sc',NULL,NULL,NULL,NULL,1,347.9595417,31.02119,0.289,NULL,52066275500,813535554,12711493,16),(160250,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160250,34.86,0.49,93.8,75234,75,NULL,'IR','UGC 12410',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160251,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160251,35,0.4,100,75234,NULL,NULL,'mean','UGC 12410',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160252,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160252,35.06,NULL,103,75234,NULL,NULL,'Dipole','UGC 12410',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160253,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160253,35.06,NULL,103,75234,NULL,NULL,'Dipole + Quadrupole','UGC 12410',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160254,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160254,35.06,NULL,103,75234,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12410',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160255,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160255,35.16,0.43,107,75234,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12410',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160256,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160256,35.19,0.38,109,75234,75,NULL,'W91PP, r, raw','UGC 12410',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160257,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160257,35.21,NULL,110,75234,NULL,NULL,NULL,'UGC 12410',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160258,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160258,35.26,0.47,113,75234,NULL,NULL,'H','UGC 12410',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160259,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160259,35.28,0.45,114,75234,NULL,NULL,'K','UGC 12410',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160260,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160260,35.37,0.38,119,75234,75,NULL,'W91PP, r, cor','UGC 12410',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160261,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160261,35.38,0.38,119,75234,75,NULL,'W91PP, r, inv','UGC 12410',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160262,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160262,35.39,0.43,120,75234,75,NULL,'3.6 micron, color corrected','UGC 12410',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160263,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160263,35.54,0.45,129,75234,NULL,NULL,'Malmquist cor.','UGC 12410',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160264,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160264,35.72,0.2,139,75234,74.4,NULL,NULL,'UGC 12410',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160265,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160265,35.87,0.39,149,75234,NULL,NULL,NULL,'UGC 12410',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160266,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160266,33.97,0.2,62.2,75235,74.4,NULL,NULL,'UGC 12421',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.00017,NULL,'15.2',0.4,'Scd:',NULL,NULL,NULL,NULL,1,347.9602083,77.57911,1.041,NULL,52779985868,824687279,12885738,15.2),(160267,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160267,34.05,0.4,64.6,75235,NULL,NULL,'mean','UGC 12421',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160268,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160268,34.27,0.47,71.3,75235,NULL,NULL,'H','UGC 12421',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160269,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160269,34.33,0.46,73.3,75235,NULL,NULL,'J','UGC 12421',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160270,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160270,34.37,0.45,74.9,75235,NULL,NULL,'K','UGC 12421',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160271,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160271,34.02,0.69,63.8,75236,100,NULL,'mid-IR','UGC 12407',NULL,'2013ApJ...771...88L',2013,1,1.2,NULL,'G',0.00002,NULL,'14.07',0.7,'S?',NULL,NULL,NULL,NULL,1,347.9642917,9.50625,0.101,NULL,51709848007,807966375,12624474,14.07),(160272,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160272,34.82,0.4,92.1,75236,NULL,NULL,'mean','UGC 12407',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160273,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160273,34.99,0.47,99.6,75236,NULL,NULL,'H','UGC 12407',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160274,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160274,35.02,0.49,101,75236,NULL,NULL,'Malmquist cor.','UGC 12407',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160275,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160275,35.07,0.46,103,75236,NULL,NULL,'J','UGC 12407',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160276,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160276,35.12,0.45,106,75236,NULL,NULL,'K','UGC 12407',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160277,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160277,35.17,0.46,108,75236,NULL,NULL,NULL,'UGC 12407',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160278,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160278,35.35,0.2,117,75236,74.4,NULL,NULL,'UGC 12407',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160279,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160279,35.67,0.56,136,75237,70,NULL,NULL,'2MASX J23115189-2818597',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'15.3R',0.13,NULL,NULL,NULL,NULL,NULL,1,347.966333333,-28.31653,0.189,NULL,50135859172,783372799,12240199,15.3),(160280,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160280,36.31,0.61,183,75238,70,NULL,NULL,'2MASX J23115217-7438103',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'16.3b',0.21,NULL,NULL,NULL,NULL,NULL,1,347.967083,-74.63625,0.101,NULL,48450974040,757046469,11828851,16.3),(160281,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 20084','R',160281,39.24,0.19,647,75239,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007pd','SDSS J231154.05-003440.4',0.091,'2014arXiv1401.3317S',2014,1,0.02,NULL,'G',NULL,NULL,'23.5g',0.02,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,347.97525,-0.57789,0.125,NULL,49493127684,773330120,12083283,23.5),(160282,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2007pd',NULL,160282,39.09,0.07,658,75239,70,NULL,'SALT 2','SDSS J231154.05-003440.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160283,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2007pd',NULL,160283,39.1,0.07,661,75239,70,NULL,'SALT 2, Malmquist cor.','SDSS J231154.05-003440.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160284,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 20084','R',160284,39.37,0.11,687,75239,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007pd','SDSS J231154.05-003440.4',0.091,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160285,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 08062','R',160285,41.99,0.33,1610,75240,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 08062',0.554141,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,347.977,0.07708,0.129,NULL,51691205392,807675084,12619923,NULL),(160286,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 08062',NULL,160286,41.56,0.03,2050,75240,70,NULL,'SN photometric redshift distance, z photo =0.685 +/- 0.015','SDSS-II SN 08062',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160287,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 08062',NULL,160287,42.28,0.2,2860,75240,70,NULL,'SALT 2','SDSS-II SN 08062',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160288,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 08062',NULL,160288,42.49,0.2,3150,75240,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 08062',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160289,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160289,37.05,0.46,257,75241,70,NULL,NULL,'2MASX J23115466-0935120',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,347.977791667,-9.58675,0.053,NULL,49477745179,773089768,12079527,17.6),(160290,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18630','R',160290,41.35,0.23,1370,75242,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J231155.28-001550.7',0.3595,'2014arXiv1401.3317S',2014,1,0.12,NULL,'G',0.0001,NULL,'19.7g',0.08,NULL,NULL,NULL,NULL,NULL,1,347.980333,-0.26408,0.129,NULL,49493226967,773331671,12083307,19.7),(160291,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18630','R',160291,41.43,0.29,1420,75242,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J231155.28-001550.7',0.3595,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160292,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18630',NULL,160292,41.37,0.18,1880,75242,70,NULL,'SALT 2','SDSS J231155.28-001550.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160293,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18630',NULL,160293,41.41,0.18,1910,75242,70,NULL,'SALT 2, Malmquist cor.','SDSS J231155.28-001550.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160294,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160294,37.93,0.46,385,75243,70,NULL,NULL,'2MASX J23115531+1404583',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,347.980417,14.08278,0.157,NULL,52547438744,821053730,12828964,18.1),(160295,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 02517','RN',160295,43.32,0.2,2910,75244,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02517',0.584527,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160296,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160296,37.47,0.46,311,75245,70,NULL,NULL,'2MASX J23115885-1004280',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,347.995167,-10.07428,0.069,NULL,49476371000,773068296,12079192,18.1),(160297,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160297,34.84,0.49,93,75246,75,NULL,'IR','UGC 12411',NULL,'2011yCatp016004901K',2011,1,1.93,'Two stars superposed near nucleus.','G',0.000037,NULL,'16.5',0.1,'Sd',NULL,NULL,NULL,NULL,1,348.014917,48.81628,1.085,NULL,55326859796,864482184,13507534,16.5),(160298,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160298,35.49,NULL,126,75246,NULL,NULL,'Dipole + Quadrupole','UGC 12411',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160299,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160299,35.49,NULL,126,75246,NULL,NULL,'Dipole','UGC 12411',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160300,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160300,35.49,NULL,126,75246,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12411',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160301,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160301,35.55,NULL,129,75246,NULL,NULL,NULL,'UGC 12411',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160302,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160302,37.47,0.46,311,75247,70,NULL,NULL,'2MASX J23120417+1407113',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,348.017375,14.11975,0.157,NULL,52514883367,820545052,12821016,17.7),(160303,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160303,36.76,0.46,225,75248,70,NULL,NULL,'2MASX J23120752+1425533',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00019,NULL,'16.0g',0.43,'E0',NULL,NULL,NULL,NULL,1,348.03125,14.43144,0.193,NULL,52514843544,820544430,12821006,16),(160304,'SBF','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160304,31.95,0.14,24.6,75249,74.4,NULL,NULL,'NGC 7507',NULL,'2013AJ....146...86T',2013,1,2.8,NULL,'G',0.00005,NULL,'12.23',2.7,'E0','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,348.031625,-28.53961,0.192,NULL,50135936272,783374004,12240218,12.23),(160305,'SBF','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160305,31.99,0.17,25,75249,NULL,NULL,'I','NGC 7507',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160306,'SBF','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160306,31.99,0.17,25,75249,NULL,NULL,NULL,'NGC 7507',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160307,'SBF','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160307,32.01,0.17,25.2,75249,NULL,NULL,'Malmquist cor.','NGC 7507',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160308,'D-Sigma','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160308,31.41,0.4,19.1,75249,75,NULL,'Edat, raw','NGC 7507',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160309,'D-Sigma','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160309,31.74,0.4,22.3,75249,75,NULL,'Edat, cor','NGC 7507',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160310,'Faber-Jackson','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160310,30.67,0.41,13.6,75249,95,NULL,'de Vaucouleurs','NGC 7507',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160311,'Faber-Jackson','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160311,31.04,0.27,16.1,75249,95,NULL,'Weighted Mean','NGC 7507',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160312,'Faber-Jackson','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160312,31.2,0.63,17.4,75249,95,NULL,'Michard 1979b, c','NGC 7507',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160313,'Faber-Jackson','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160313,31.42,0.46,19.2,75249,95,NULL,'Michard 1979a','NGC 7507',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160314,'Faber-Jackson','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160314,31.93,NULL,24.3,75249,NULL,NULL,'LEDA [April 2006]','NGC 7507',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160315,'Faber-Jackson','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160315,33.27,0.81,45.1,75249,55,NULL,'Visvanathan & Sandage 1979','NGC 7507',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160316,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160316,31.62,0.41,21.1,75249,NULL,NULL,NULL,'NGC 7507',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160317,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160317,31.81,0.41,23,75249,NULL,NULL,'Malmquist cor.','NGC 7507',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160318,'Tertiary','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160318,31.34,0.41,18.5,75249,95,NULL,NULL,'NGC 7507',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160319,'Tully est','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160319,31.43,0.8,19.3,75249,75,NULL,'B','NGC 7507',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160320,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160320,35.33,0.59,116,75250,70,NULL,NULL,'6dF J2312096-282554',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,348.040083333,-28.43178,0.192,NULL,50136071862,783376122,12240251,15.2),(160321,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160321,36.12,0.58,168,75251,70,NULL,NULL,'2MASX J23121257-5759360',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.13',0.28,'S',NULL,NULL,NULL,NULL,1,348.052583333,-57.99339,0,NULL,48848090102,763251407,11925803,16.13),(160322,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160322,37.3,0.46,288,75252,70,NULL,NULL,'2MASX J23121467+0030322',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000087,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,348.0610417,0.50886,0.125,NULL,51691417515,807678398,12619974,17.4),(160323,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160323,37.84,0.46,370,75253,70,NULL,NULL,'2MASX J23122005+1402283',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,348.0835,14.04131,0.157,NULL,52514905085,820545391,12821021,17.3),(160324,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160324,37.42,0.46,305,75254,70,NULL,NULL,'2MASX J23122041+0035142',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000092,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,348.085167,0.58725,0.125,NULL,51691448688,807678885,12619982,16.7),(160325,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160325,37.61,0.33,333,75255,70,NULL,NULL,'SDSS J231221.63-090815.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00017,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,348.090167,-9.13756,0.065,NULL,49477932769,773092699,12079573,17.9),(160326,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160326,38.05,0.46,408,75256,70,NULL,NULL,'2MASX J23122230-0951565',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00018,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,348.092875,-9.86578,0.061,NULL,49479731408,773120803,12080012,17.5),(160327,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160327,38.4,0.46,480,75257,70,NULL,NULL,'SDSS J231223.40-095621.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,348.0975,-9.93939,0.061,NULL,49479743720,773120995,12080015,18.6),(160328,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160328,37.41,0.46,303,75258,70,NULL,NULL,'2MASX J23122393+0012242',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'17.38',0.27,NULL,NULL,NULL,NULL,NULL,1,348.09975,0.20675,0.129,NULL,51691511664,807679869,12619997,17.38),(160329,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160329,34.98,0.51,99.3,75259,70,NULL,NULL,'2MASX J23122425-0110456',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.000084,NULL,'15.7g',0.22,'Sa',NULL,NULL,NULL,NULL,1,348.101083333,-1.17939,0.113,NULL,49496368286,773380754,12084074,15.7),(160330,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160330,33.96,0.8,62.1,75260,75,NULL,'W91PP, r','NGC 7514',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'13.54',0.9,'Sa','Isolated galaxy',NULL,NULL,NULL,1,348.10775,34.8815,0.317,NULL,52045229373,813206708,12706354,13.54),(160331,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160331,33.76,0.38,56.6,75260,75,NULL,'W91PP, r, raw','NGC 7514',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160332,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160332,33.85,0.47,59,75260,NULL,NULL,'H','NGC 7514',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160333,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160333,33.92,0.46,60.7,75260,NULL,NULL,'J','NGC 7514',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160334,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160334,33.92,0.45,60.8,75260,NULL,NULL,'K','NGC 7514',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160335,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160335,33.96,0.38,61.9,75260,75,NULL,'W91PP, r, inv','NGC 7514',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160336,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160336,34.01,0.4,63.4,75260,NULL,NULL,'mean','NGC 7514',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160337,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160337,34.11,0.38,66.2,75260,75,NULL,'W91PP, r, cor','NGC 7514',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160338,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160338,33.77,0.2,56.8,75261,74.4,NULL,NULL,'NGC 7511',NULL,'2013AJ....146...86T',2013,1,0.92,NULL,'G',0.00006,NULL,'14.7g',0.51,'Sa',NULL,NULL,NULL,NULL,1,348.109541667,13.72658,0.149,NULL,52515192682,820549885,12821091,14.7),(160339,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160339,37.73,0.46,351,75262,70,NULL,NULL,'2MASX J23122837+1537523',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,348.1182917,15.63136,0.173,NULL,52522731700,820667682,12822932,17.5),(160340,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160340,37.61,0.33,333,75263,70,NULL,NULL,'2MASX J23122853-0914265',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,348.11875,-9.24083,0.069,NULL,49477955730,773093058,12079579,16.9),(160341,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160341,35.78,0.52,143,75264,70,NULL,NULL,'2MASX J23123213-0006366',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.000085,NULL,'15.9g',0.33,NULL,NULL,NULL,NULL,NULL,1,348.1337917,-0.11028,0.129,NULL,49493713989,773339281,12083426,15.9),(160342,'GRB','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160342,43.85,0.77,2310,75265,NULL,NULL,NULL,'HG 051111',1.54948,'2008AIPC.1065..367L',2008,1,NULL,'The position given in 2008ApJ...672...59P is incorrect.','G',0.00001,NULL,'26  R',NULL,'DLA',NULL,NULL,NULL,NULL,1,348.1382083,18.37467,0.217,NULL,52500175183,820315237,12817425,26),(160343,'GRB','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160343,44.54,0.6,3170,75265,69.7,NULL,'Calibrated','HG 051111',1.54948,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160344,'GRB','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160344,44.58,0.69,3230,75265,70,NULL,NULL,'HG 051111',1.54948,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160345,'GRB','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160345,45.14,0.63,4180,75265,69.7,NULL,'Fiducial','HG 051111',1.54948,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160346,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 16211','R',160346,40.84,0.29,1120,75266,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006nm','SDSS J231239.09+001557.5',0.31,'2014arXiv1401.3317S',2014,1,0.11,NULL,'G',NULL,NULL,'19.9g',0.07,NULL,NULL,NULL,NULL,NULL,1,348.162917,0.266,0.129,NULL,51691518469,807679976,12619999,19.9),(160347,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 16211','R',160347,41.07,0.26,1250,75266,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006nm','SDSS J231239.09+001557.5',0.31,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160348,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2006nm',NULL,160348,40.65,0.2,1350,75266,70,NULL,'SALT 2','SDSS J231239.09+001557.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160349,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2006nm',NULL,160349,40.69,0.2,1370,75266,70,NULL,'SALT 2, Malmquist cor.','SDSS J231239.09+001557.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160350,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160350,36.39,0.69,190,75267,70,NULL,NULL,'2MASX J23124042-0148178',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'16.82',0.26,NULL,NULL,NULL,NULL,NULL,1,348.168583,-1.80483,0.097,NULL,49495887978,773373249,12083957,16.82),(160351,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160351,36.52,0.62,201,75268,70,NULL,NULL,'2MASX J23124071-7620415',NULL,'2014MNRAS.445.2677S',2014,1,0.23,NULL,'G',0.00015,NULL,'16.8b',0.19,NULL,NULL,NULL,NULL,NULL,1,348.169625,-76.34483,0.217,NULL,48432083180,756751299,11824239,16.8),(160352,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160352,37.38,0.46,299,75269,70,NULL,NULL,'2MASX J23124080-1023065',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'16.2g',0.36,'E0',NULL,NULL,NULL,NULL,1,348.169917,-10.38514,0.045,NULL,49476493553,773070211,12079222,16.2),(160353,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18224','R',160353,40.94,0.37,1150,75270,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J231241.95-001846.2',0.3392,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',0.0002,NULL,'20.4g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,348.174833,-0.31286,0.117,NULL,49493757202,773339956,12083436,20.4),(160354,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18224','R',160354,41.08,0.42,1230,75270,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J231241.95-001846.2',0.3392,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160355,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18224',NULL,160355,40.91,0.29,1520,75270,70,NULL,'SALT 2','SDSS J231241.95-001846.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160356,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18224',NULL,160356,40.96,0.29,1560,75270,70,NULL,'SALT 2, Malmquist cor.','SDSS J231241.95-001846.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160357,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 15725',NULL,160357,40.87,0.29,1500,75271,70,NULL,'SN photometric redshift distance, z photo =0.440 +/- 0.087','SDSS-II SN 15725',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,348.1870417,-0.17778,0.109,NULL,49493713524,773339273,12083426,NULL),(160358,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 15725',NULL,160358,42.4,0.27,3020,75271,70,NULL,'SALT 2','SDSS-II SN 15725',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160359,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 15725',NULL,160359,42.47,0.27,3120,75271,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15725',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160360,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160360,31.48,0.8,19.7,75272,75,NULL,'MAT, I','ESO 407- G 009',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000026,NULL,'14.66',0.7,'SB(s)d:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,348.187125,-37.20792,NULL,NULL,49963691780,780682684,12198166,14.66),(160361,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160361,31.28,0.32,18,75272,85,NULL,'I, inv','ESO 407- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160362,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160362,31.31,0.32,18.3,75272,85,NULL,'I, raw','ESO 407- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160363,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160363,31.7,0.43,21.8,75272,75,NULL,'MAT, I, inv','ESO 407- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160364,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160364,31.74,0.43,22.3,75272,75,NULL,'MAT, I, raw','ESO 407- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160365,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160365,31.95,0.43,24.5,75272,75,NULL,'MAT, I, cor','ESO 407- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160366,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160366,32.13,0.2,26.7,75272,74.4,NULL,NULL,'ESO 407- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160367,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160367,32.17,0.43,27.2,75272,75,NULL,'3.6 micron, color corrected','ESO 407- G 009',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160368,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160368,32.22,0.43,27.7,75272,75,NULL,'3.6 micron, color + selection bias corrected','ESO 407- G 009',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160369,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160369,32.28,0.39,28.6,75272,73,NULL,'opt','ESO 407- G 009',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160370,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160370,32.35,0.47,29.6,75272,NULL,NULL,NULL,'ESO 407- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160371,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160371,32.37,0.47,29.8,75272,NULL,NULL,'Malmquist cor.','ESO 407- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160372,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160372,35.92,0.6,153,75273,70,NULL,NULL,'2MASX J23124604-5334325',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'17.16',0.17,NULL,NULL,NULL,NULL,NULL,1,348.1919583,-53.57572,0,NULL,48611268818,759551075,11867985,17.16),(160373,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 19334',NULL,160373,40.71,0.19,1390,75274,70,NULL,'SALT 2','SDSS-II SN 19334',NULL,'2013ApJ...763...88C',2013,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,348.1949583,0.33461,0.125,NULL,51691504558,807679758,12619996,NULL),(160374,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 19334',NULL,160374,40.72,0.19,1390,75274,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19334',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160375,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 19334',NULL,160375,41.59,NULL,2080,75274,70,NULL,'SN photometric redshift distance, z photo =0.700 +/- 0.001','SDSS-II SN 19334',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160376,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160376,37.84,0.46,369,75275,70,NULL,NULL,'2MASX J23124713+1455154',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,348.196417,14.92103,0.177,NULL,52522140703,820658448,12822788,17.5),(160377,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160377,36.17,0.79,171,75276,70,NULL,NULL,'2MASX J23124796-4347150',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.53',0.28,NULL,NULL,NULL,NULL,NULL,1,348.19975,-43.78744,NULL,NULL,50530619137,789540924,12336576,16.53),(160378,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160378,36.34,0.57,186,75277,70,NULL,NULL,'6dF J2312502-371013',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,348.209,-37.17014,NULL,NULL,49964552295,780696129,12198377,14.9),(160379,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160379,33.12,0.8,42.1,75278,75,NULL,'W91CL, r','IC 1474',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000027,NULL,'14.73',0.5,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,348.213625,5.80636,0.213,NULL,51715982665,808062229,12625972,14.73),(160380,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160380,33.14,0.8,42.4,75278,75,NULL,'HMCL, I','IC 1474',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160381,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160381,33.15,0.8,42.7,75278,75,NULL,'MAT, I','IC 1474',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160382,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160382,33.16,0.8,42.8,75278,75,NULL,'CF, r','IC 1474',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160383,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160383,32.99,0.43,39.7,75278,75,NULL,'3.6 micron, color + selection bias corrected','IC 1474',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160384,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160384,33.24,0.32,44.4,75278,85,NULL,'I, raw','IC 1474',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160385,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160385,33.26,0.32,44.9,75278,85,NULL,'I, inv','IC 1474',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160386,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160386,33.31,0.43,45.9,75278,75,NULL,'3.6 micron, color corrected','IC 1474',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160387,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160387,33.34,0.4,46.5,75278,NULL,NULL,'mean','IC 1474',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160388,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160388,33.37,0.38,47.2,75278,75,NULL,'W91CL, r, raw','IC 1474',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160389,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160389,33.42,0.38,48.3,75278,75,NULL,'W91CL, r, inv','IC 1474',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160390,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160390,33.48,0.47,49.7,75278,NULL,NULL,'H','IC 1474',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160391,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160391,33.51,0.43,50.4,75278,75,NULL,'MAT, I, raw','IC 1474',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160392,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160392,33.51,0.1,50.5,75278,NULL,NULL,NULL,'IC 1474',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160393,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160393,33.53,0.46,50.8,75278,NULL,NULL,'J','IC 1474',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160394,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160394,33.58,0.45,51.9,75278,NULL,NULL,'K','IC 1474',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160395,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160395,33.6,0.2,52.5,75278,74.4,NULL,NULL,'IC 1474',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160396,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160396,33.62,0.38,53.1,75278,75,NULL,'CF, r, raw','IC 1474',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160397,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160397,33.64,0.38,53.5,75278,75,NULL,'W91CL, r, cor','IC 1474',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160398,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160398,33.65,0.43,53.7,75278,75,NULL,'MAT, I, inv','IC 1474',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160399,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160399,33.69,0.38,54.8,75278,75,NULL,'CF, r, inv','IC 1474',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160400,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160400,33.84,0.43,58.7,75278,75,NULL,'MAT, I, cor','IC 1474',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160401,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160401,33.89,0.38,59.9,75278,75,NULL,'CF, r, cor','IC 1474',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160402,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160402,34.5,0.4,79.4,75278,75,NULL,'HMCL, I, raw','IC 1474',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160403,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160403,34.59,0.4,82.7,75278,75,NULL,'HMCL, I, inv','IC 1474',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160404,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160404,34.71,0.4,87.4,75278,75,NULL,'HMCL, I, cor','IC 1474',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160405,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160405,34.33,0.47,73.5,75279,NULL,NULL,'H','IC 5290',NULL,'2007A&A...465...71T',2007,1,1.3,'This may also be NGC 7520.','G',0.000033,NULL,'13.62',0.8,'(R)Sa:',NULL,NULL,NULL,NULL,1,348.221917,-23.46919,0.046,NULL,50301812121,785965814,12280715,13.62),(160406,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160406,34.37,0.45,74.9,75279,NULL,NULL,'K','IC 5290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160407,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160407,34.4,0.46,76,75279,NULL,NULL,'J','IC 5290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160408,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160408,34.58,0.4,82.5,75279,NULL,NULL,'mean','IC 5290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160409,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160409,35.06,0.27,103,75279,NULL,NULL,NULL,'IC 5290',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160410,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160410,35.1,0.2,105,75279,74.4,NULL,NULL,'IC 5290',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160411,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160411,35.3,0.25,115,75279,NULL,NULL,'Malmquist cor.','IC 5290',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160412,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 01742','RN',160412,39.53,0.14,724,75280,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01742',0.111638,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160413,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 01742','RN',160413,39.78,0.22,814,75280,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01742',0.111638,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160414,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160414,36.19,0.62,173,75281,70,NULL,NULL,'LCRS B231008.4-445531',NULL,'2014MNRAS.445.2677S',2014,1,0.26,NULL,'G',0.00015,NULL,'15.44',0.12,NULL,NULL,NULL,NULL,NULL,1,348.234,-44.65347,NULL,NULL,50532908938,789576702,12337135,15.44),(160415,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160415,36.18,0.61,172,75282,70,NULL,NULL,'2MASX J23125697-0208217',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'16.52',0.24,NULL,NULL,NULL,NULL,'USS',1,348.2374583,-2.13944,0.109,NULL,49495754944,773371171,12083924,16.52),(160416,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160416,31.79,NULL,22.8,75283,NULL,NULL,NULL,'FGC 2468',NULL,'2000BSAO...50....5K',2000,1,1.03,'Matthews (2000A&AS..143..421M) detects another feature at v=7995 km/sec.','G',0.00008,NULL,'16.4',0.1,'Sd(f)',NULL,NULL,NULL,NULL,1,348.2624583,-1.24272,0.113,NULL,49496443024,773381922,12084092,16.4),(160417,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 13039','RN',160417,41.58,0.28,1610,75284,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13039',0.285041,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160418,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 13039','RN',160418,41.65,0.17,1660,75284,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13039',0.285041,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160419,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160419,34.19,0.47,68.9,75285,NULL,NULL,'H','UGC 12425',NULL,'2007A&A...465...71T',2007,1,1.5,'1999ApJS..121..287H has V = 5999 +- 32 km/sec.','G',0.000033,NULL,'14.99',0.2,'Sab',NULL,NULL,NULL,NULL,1,348.291,24.24403,0.229,NULL,51976207863,812128247,12689503,14.99),(160420,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160420,34.26,0.46,71.2,75285,NULL,NULL,'J','UGC 12425',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160421,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160421,34.29,0.45,72.2,75285,NULL,NULL,'K','UGC 12425',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160422,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160422,34.58,0.4,82.4,75285,NULL,NULL,'mean','UGC 12425',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160423,'Ring Diameter','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160423,33,0.84,40,75286,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7518',NULL,'1981ApJS...45..541P',1981,1,1.4,NULL,'G',0.000013,NULL,'14.24',1,'(R)SAB(r)a','in a radial-velocity based grouping',NULL,NULL,NULL,1,348.303041667,6.32167,0.217,NULL,51716740472,808074069,12626157,14.24),(160424,'Tully est','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160424,30,0.8,10,75286,75,NULL,'B','NGC 7518',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160425,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160425,32.71,0.69,34.8,75286,100,NULL,'mid-IR','NGC 7518',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160426,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160426,33.93,0.8,61,75287,75,NULL,'W91CL, r','UGC 12423',NULL,'1997ApJS..109..333W',1997,1,4.7,'Declination in 1999ApJS..121..287H is -3 arcminutes in error.','G',0.00002,NULL,'14.53',0.45,'Sc','in a pair',NULL,NULL,NULL,1,348.304917,6.43025,0.237,NULL,51716743237,808074113,12626158,14.53),(160427,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160427,33.93,0.8,61.1,75287,75,NULL,'MAT, I','UGC 12423',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160428,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160428,33.93,0.8,61.1,75287,75,NULL,'HMCL, I','UGC 12423',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160429,'Tully est','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160429,30.57,0.8,13,75287,75,NULL,'B','UGC 12423',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160430,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160430,33.45,NULL,48.9,75287,NULL,NULL,'Dipole','UGC 12423',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160431,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160431,33.45,NULL,49,75287,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12423',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160432,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160432,33.45,NULL,49.1,75287,NULL,NULL,'Dipole + Quadrupole','UGC 12423',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160433,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160433,33.48,NULL,49.7,75287,NULL,NULL,NULL,'UGC 12423',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160434,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160434,33.95,0.4,61.7,75287,NULL,NULL,'mean','UGC 12423',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160435,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160435,34.14,0.49,67.4,75287,75,NULL,'IR','UGC 12423',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160436,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160436,34.25,0.43,70.7,75287,75,NULL,'MAT, I, raw','UGC 12423',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160437,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160437,34.25,0.46,70.7,75287,NULL,NULL,'J','UGC 12423',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160438,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160438,34.28,0.38,71.7,75287,NULL,NULL,'Malmquist cor.','UGC 12423',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160439,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160439,34.34,0.38,73.9,75287,75,NULL,'W91CL, r, raw','UGC 12423',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160440,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160440,34.38,0.32,75.3,75287,85,NULL,'I, raw','UGC 12423',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160441,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160441,34.39,0.4,75.7,75287,75,NULL,'HMCL, I, raw','UGC 12423',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160442,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160442,34.43,0.2,76.9,75287,74.4,NULL,NULL,'UGC 12423',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160443,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160443,34.45,0.32,77.7,75287,85,NULL,'I, inv','UGC 12423',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160444,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160444,34.47,0.35,78.3,75287,NULL,NULL,NULL,'UGC 12423',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160445,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160445,34.48,0.47,78.8,75287,NULL,NULL,'H','UGC 12423',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160446,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160446,34.49,0.45,79,75287,NULL,NULL,'K','UGC 12423',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160447,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160447,34.49,0.43,79.1,75287,75,NULL,'MAT, I, cor','UGC 12423',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160448,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160448,34.52,0.38,80.3,75287,75,NULL,'W91CL, r, cor','UGC 12423',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160449,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160449,34.53,0.43,80.4,75287,75,NULL,'MAT, I, inv','UGC 12423',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160450,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160450,34.54,0.38,81,75287,75,NULL,'W91CL, r, inv','UGC 12423',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160451,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160451,34.6,0.4,83,75287,75,NULL,'HMCL, I, cor','UGC 12423',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160452,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160452,34.63,0.4,84.4,75287,75,NULL,'HMCL, I, inv','UGC 12423',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160453,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160453,31.49,0.8,19.9,75288,75,NULL,'MAT, I','NGC 7513',NULL,'1997ApJS..109..333W',1997,1,3.2,NULL,'G',0.000013,NULL,'11.3B',2.1,'(R\')SB(s)b pec','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,348.3084583,-28.3575,0.181,NULL,50136040328,783375630,12240244,11.3),(160454,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160454,30.95,0.43,15.5,75288,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7513',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160455,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160455,31.05,0.43,16.2,75288,75,NULL,'3.6 micron, color corrected','NGC 7513',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160456,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160456,31.13,0.32,16.8,75288,85,NULL,'I, raw','NGC 7513',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160457,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160457,31.14,0.32,16.9,75288,85,NULL,'I, inv','NGC 7513',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160458,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160458,31.17,0.2,17.1,75288,74.4,NULL,NULL,'NGC 7513',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160459,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160459,31.21,0.43,17.4,75288,75,NULL,'MAT, I, raw','NGC 7513',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160460,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160460,31.33,0.43,18.4,75288,75,NULL,'MAT, I, inv','NGC 7513',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160461,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160461,31.39,0.54,19,75288,NULL,NULL,NULL,'NGC 7513',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160462,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160462,31.45,0.4,19.5,75288,NULL,NULL,'mean','NGC 7513',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160463,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160463,31.48,0.43,19.8,75288,75,NULL,'MAT, I, cor','NGC 7513',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160464,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160464,31.55,0.4,20.4,75288,73,NULL,'opt','NGC 7513',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160465,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160465,31.58,0.47,20.7,75288,NULL,NULL,'H','NGC 7513',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160466,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160466,31.59,0.45,20.8,75288,NULL,NULL,'K','NGC 7513',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160467,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160467,31.65,0.46,21.4,75288,NULL,NULL,'J','NGC 7513',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160468,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160468,31.68,0.47,21.6,75288,NULL,NULL,'Malmquist cor.','NGC 7513',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160469,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160469,37.1,0.46,264,75289,70,NULL,NULL,'2MASX J23131593+1513230',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,348.3162917,15.22311,0.173,NULL,52522221046,820659703,12822807,17.9),(160470,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160470,37.13,0.46,267,75290,70,NULL,NULL,'2MASX J23131976+0037432',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.71',0.25,NULL,NULL,NULL,NULL,NULL,1,348.332333333,0.62861,0.121,NULL,51691604482,807681320,12620020,16.71),(160471,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160471,36.58,0.59,207,75291,70,NULL,NULL,'2MASX J23132346-5344261',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.41',0.4,'S0',NULL,NULL,NULL,NULL,1,348.347833,-53.74056,0,NULL,48608580143,759509064,11867329,16.41),(160472,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 12727','RN',160472,41.85,0.35,1720,75292,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 12727',0.365625,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160473,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 12727','RN',160473,42.7,0.28,2540,75292,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 12727',0.365625,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160474,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160474,33.59,0.2,52.2,75293,74.4,NULL,NULL,'UGC 12427',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000033,NULL,'15.36',0.3,'Sbc',NULL,NULL,NULL,NULL,1,348.3489583,28.95453,0.313,NULL,52020889838,812826403,12700412,15.36),(160475,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160475,33.74,0.59,55.9,75293,NULL,NULL,NULL,'UGC 12427',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160476,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160476,34.02,0.52,63.6,75293,NULL,NULL,'Malmquist cor.','UGC 12427',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160477,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160477,35.67,0.46,136,75294,70,NULL,NULL,'2MASX J23132800+1416111',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000169,NULL,'16.2g',0.33,'S0',NULL,NULL,NULL,NULL,1,348.366708333,14.26983,0.161,NULL,52514986374,820546662,12821041,16.2),(160478,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160478,36.65,0.46,214,75295,70,NULL,NULL,'2MASX J23132923-0943516',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000172,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,348.371916667,-9.73108,0.049,NULL,49595844334,774935067,12108360,16.8),(160479,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160479,36.49,0.65,198,75296,70,NULL,NULL,'2MASX J23133038-4839069',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.74',0.26,NULL,NULL,NULL,NULL,NULL,1,348.376667,-48.652,0,NULL,50503944381,789124130,12330064,16.74),(160480,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160480,33.76,0.49,56.6,75297,75,NULL,'IR','UGC 12426',NULL,'2011yCatp016004901K',2011,1,1.68,NULL,'G',0.000009,NULL,'15.98',0.17,'Sdm',NULL,NULL,NULL,NULL,1,348.385583333,6.56794,0.237,NULL,51716226741,808066042,12626031,15.98),(160481,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160481,33.92,NULL,60.9,75297,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12426',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160482,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160482,33.93,NULL,61.2,75297,NULL,NULL,'Dipole','UGC 12426',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160483,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160483,33.94,NULL,61.3,75297,NULL,NULL,'Dipole + Quadrupole','UGC 12426',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160484,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160484,34.01,NULL,63.4,75297,NULL,NULL,NULL,'UGC 12426',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160485,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160485,34.15,0.2,67.6,75297,74.4,NULL,NULL,'UGC 12426',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160486,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160486,34.23,0.44,70.2,75297,NULL,NULL,NULL,'UGC 12426',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160487,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160487,34.25,0.44,70.8,75297,NULL,NULL,'Malmquist cor.','UGC 12426',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160488,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160488,33.64,0.8,53.4,75298,75,NULL,'MAT, I','ESO 027- G 024',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.14',0.9,'SA(rs)bc','in a pair',NULL,NULL,NULL,1,348.387167,-81.62506,0.437,NULL,48350410851,755475169,11804299,14.14),(160489,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160489,34,0.4,63,75298,NULL,NULL,'mean','ESO 027- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160490,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160490,34.14,0.32,67.2,75298,85,NULL,'I, raw','ESO 027- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160491,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160491,34.19,0.32,68.8,75298,85,NULL,'I, inv','ESO 027- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160492,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160492,34.24,0.41,70.4,75298,NULL,NULL,'Malmquist cor.','ESO 027- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160493,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160493,34.24,0.43,70.5,75298,75,NULL,'MAT, I, raw','ESO 027- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160494,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160494,34.26,0.47,71.1,75298,NULL,NULL,'H','ESO 027- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160495,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160495,34.28,0.4,71.8,75298,NULL,NULL,NULL,'ESO 027- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160496,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160496,34.29,0.45,72.2,75298,NULL,NULL,'K','ESO 027- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160497,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160497,34.32,0.2,73.1,75298,74.4,NULL,NULL,'ESO 027- G 024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160498,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160498,34.33,0.46,73.5,75298,NULL,NULL,'J','ESO 027- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160499,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160499,34.45,0.43,77.6,75298,75,NULL,'MAT, I, cor','ESO 027- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160500,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160500,34.49,0.43,78.9,75298,75,NULL,'MAT, I, inv','ESO 027- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160501,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 05198','RN',160501,43.49,0.24,3580,75299,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05198',0.39425,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160502,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 05198','RN',160502,43.74,0.26,4020,75299,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 05198',0.39425,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160503,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160503,37.33,0.46,293,75300,70,NULL,NULL,'2MASX J23133921-0900445',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000164,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,348.413458333,-9.0125,0.065,NULL,49595649640,774932025,12108312,16.6),(160504,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160504,33.28,0.8,45.2,75301,75,NULL,'W91PP, r','UGC 12430',NULL,'1997ApJS..109..333W',1997,1,2.49,NULL,'G',0.000013,NULL,'14.84',0.27,'Sd             Sbrst',NULL,NULL,NULL,NULL,1,348.4307917,29.01072,0.305,NULL,52020896115,812826501,12700414,14.84),(160505,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160505,32.46,NULL,31,75301,NULL,NULL,NULL,'UGC 12430',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160506,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160506,32.59,NULL,33,75301,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12430',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160507,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160507,32.62,NULL,33.3,75301,NULL,NULL,'Dipole','UGC 12430',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160508,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160508,32.62,NULL,33.3,75301,NULL,NULL,'Dipole + Quadrupole','UGC 12430',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160509,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160509,32.84,0.49,36.9,75301,NULL,NULL,NULL,'UGC 12430',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160510,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160510,32.86,0.49,37.3,75301,75,NULL,'IR','UGC 12430',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160511,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160511,32.86,0.2,37.3,75301,74.4,NULL,NULL,'UGC 12430',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160512,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160512,32.94,0.38,38.6,75301,75,NULL,'W91PP, r, inv','UGC 12430',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160513,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160513,32.98,0.38,39.4,75301,75,NULL,'W91PP, r, raw','UGC 12430',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160514,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160514,33.07,0.44,41.1,75301,NULL,NULL,'Malmquist cor.','UGC 12430',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160515,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160515,33.08,0.43,41.4,75301,75,NULL,'3.6 micron, color corrected','UGC 12430',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160516,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160516,33.17,0.43,43.1,75301,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12430',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160517,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160517,33.3,0.38,45.8,75301,75,NULL,'W91PP, r, cor','UGC 12430',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160518,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 19222','R',160518,41.22,0.17,1500,75302,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2007nl','SN 2007nl',0.1683,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'II',NULL,NULL,NULL,NULL,1,348.437166667,-0.06764,0.113,NULL,49493019726,773328433,12083256,NULL),(160519,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 19222','R',160519,41.83,0.38,1990,75302,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2007nl','SN 2007nl',0.1683,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160520,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 19776',NULL,160520,40.67,0.37,1360,75303,70,NULL,'SN photometric redshift distance, z photo =0.391 +/- 0.096','SDSS-II SN 19776',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,348.443,-0.47925,0.109,NULL,49493671905,773338623,12083415,NULL),(160521,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160521,35.2,0.59,110,75304,70,NULL,NULL,'2MASX J23134822-4314013',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'16.34',0.37,'E',NULL,NULL,NULL,NULL,1,348.450833,-43.23361,NULL,NULL,50530449549,789538274,12336535,16.34),(160522,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160522,35.81,0.4,145,75305,NULL,NULL,NULL,'2MASX J23134888+1337161',NULL,'2009ApJS..182..474S',2009,1,0.78,NULL,'G',0.000156,NULL,'16.5g',0.25,'Sc',NULL,NULL,NULL,NULL,1,348.453583,13.62128,0.145,NULL,52515134755,820548980,12821077,16.5),(160523,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160523,35.92,0.2,153,75305,74.4,NULL,NULL,'2MASX J23134888+1337161',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160524,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160524,36.02,0.36,160,75305,NULL,NULL,'Malmquist cor.','2MASX J23134888+1337161',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160525,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160525,33.68,0.2,54.5,75306,74.4,NULL,NULL,'UGC 12429',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',NULL,NULL,'15.13',0.8,'Sd',NULL,NULL,NULL,NULL,1,348.456917,22.69653,0.253,NULL,52499171214,820299550,12817180,15.13),(160526,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160526,33.71,0.49,55.1,75306,75,NULL,'IR','UGC 12429',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160527,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160527,33.75,0.47,56.3,75306,NULL,NULL,NULL,'UGC 12429',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160528,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160528,33.82,0.46,58,75306,NULL,NULL,'Malmquist cor.','UGC 12429',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160529,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160529,37.48,0.46,314,75307,70,NULL,NULL,'SDSS J231351.54-082020.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000149,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,348.4647917,-8.33914,0.073,NULL,49602935514,775045867,12110091,18.4),(160530,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2005jy',NULL,160530,39.96,0.15,773,75308,74.2,NULL,'SALT 2','SDSS J231351.66+011526.4',0.27,'2010ApJ...716..712A',2010,1,0.05,NULL,'G',NULL,NULL,'21.3g',0.04,NULL,NULL,NULL,NULL,NULL,1,348.46525,1.25736,0.149,NULL,51694328245,807723878,12620685,21.3),(160531,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2005jy',NULL,160531,40.59,0.16,1030,75308,65,NULL,'SALT2','SDSS J231351.66+011526.4',0.27,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160532,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 06192','R',160532,40.65,0.24,1060,75308,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005jy','SDSS J231351.66+011526.4',0.27,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160533,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2005jy',NULL,160533,40.67,0.17,1070,75308,70,NULL,'SALT 2','SDSS J231351.66+011526.4',0.27,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160534,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2005jy',NULL,160534,40.71,NULL,1090,75308,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 06192, SN 2005jy','SDSS J231351.66+011526.4',0.27,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160535,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2005jy',NULL,160535,40.93,0.14,1210,75308,65,NULL,'MLCS2k2','SDSS J231351.66+011526.4',0.27,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160536,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 06192','R',160536,40.96,0.16,1220,75308,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005jy','SDSS J231351.66+011526.4',0.27,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160537,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2005jy',NULL,160537,40.49,0.14,1250,75308,70,NULL,'SALT 2','SDSS J231351.66+011526.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160538,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2005jy',NULL,160538,40.52,0.14,1270,75308,70,NULL,'SALT 2, Malmquist cor.','SDSS J231351.66+011526.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160539,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2005jy',NULL,160539,41.09,0.05,1300,75308,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 06192, SN 2005jy','SDSS J231351.66+011526.4',0.27,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160540,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160540,35.44,0.57,122,75309,70,NULL,NULL,'2MFGC 17427',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.36',NULL,NULL,NULL,NULL,NULL,NULL,1,348.48075,-12.95197,0.049,NULL,50281595353,785649927,12275780,16.36),(160541,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160541,35.23,0.8,111,75310,75,NULL,'W91PP, r','UGC 12432',NULL,'1997ApJS..109..333W',1997,1,1.12,NULL,'G',0.000013,NULL,'16.0',0.15,'Sc',NULL,NULL,NULL,NULL,1,348.491583333,24.89531,0.241,NULL,51979462097,812179095,12690298,16),(160542,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160542,34.62,0.49,83.8,75310,75,NULL,'IR','UGC 12432',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160543,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160543,34.93,0.36,96.6,75310,NULL,NULL,NULL,'UGC 12432',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160544,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160544,34.97,0.2,98.6,75310,74.4,NULL,NULL,'UGC 12432',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160545,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160545,34.99,0.38,99.5,75310,75,NULL,'W91PP, r, raw','UGC 12432',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160546,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160546,35.06,0.34,103,75310,NULL,NULL,'Malmquist cor.','UGC 12432',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160547,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160547,35.09,0.38,104,75310,75,NULL,'W91PP, r, inv','UGC 12432',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160548,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160548,35.19,0.38,109,75310,75,NULL,'W91PP, r, cor','UGC 12432',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160549,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160549,35.28,NULL,114,75310,NULL,NULL,'Dipole + Quadrupole','UGC 12432',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160550,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160550,35.28,NULL,114,75310,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12432',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160551,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160551,35.29,NULL,114,75310,NULL,NULL,'Dipole','UGC 12432',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160552,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160552,35.4,NULL,120,75310,NULL,NULL,NULL,'UGC 12432',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160553,'GRB','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'N',160553,37.99,NULL,396,75311,65,NULL,'L = 10e57 photons/s','GRB 790406',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160554,'GRB','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'N',160554,38.97,NULL,622,75311,75,NULL,NULL,'GRB 790406',NULL,'1995ApJ...453..583W',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160555,'GRB','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'N',160555,40.96,NULL,1550,75311,65,NULL,'L = 2 x 10e58 photons/s','GRB 790406',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160556,'GRB','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'RN',160556,43.27,NULL,4500,75311,NULL,NULL,NULL,'GRB 790406',NULL,'1992grbo.book..107S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160557,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160557,34.36,0.5,74.5,75312,NULL,NULL,'Malmquist cor.','AGC 330128',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',NULL,NULL,'14.3I',0.2,NULL,NULL,NULL,NULL,NULL,1,348.519167,9.9375,0.097,NULL,51742571403,808477678,12632463,14.3),(160558,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160558,34.45,0.48,77.8,75312,NULL,NULL,NULL,'AGC 330128',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160559,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160559,34.67,0.2,85.9,75312,74.4,NULL,NULL,'AGC 330128',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160560,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160560,38.4,0.46,479,75313,70,NULL,NULL,'2MASX J23140564-1015409',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000198,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,348.5235417,-10.26144,0.041,NULL,49594030576,774906727,12107917,17.4),(160561,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160561,34.45,NULL,77.5,75314,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2475',NULL,'2010Ap&SS.325..163P',2010,1,1.03,NULL,'G',0.000017,NULL,'16.7',0.11,'Sd',NULL,NULL,NULL,NULL,1,348.545,34.30361,0.289,NULL,52057436559,813397446,12709335,16.7),(160562,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160562,34.45,NULL,77.7,75314,NULL,NULL,'Dipole','FGC 2475',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160563,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160563,34.46,NULL,78,75314,NULL,NULL,'Dipole + Quadrupole','FGC 2475',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160564,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160564,34.47,NULL,78.2,75314,NULL,NULL,NULL,'FGC 2475',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160565,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160565,34.53,0.43,80.7,75314,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2475',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160566,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160566,37.69,0.46,345,75315,70,NULL,NULL,'2MASX J23141146-0021497',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000032,NULL,'16.3g',0.32,'NLAGN',NULL,NULL,NULL,'Sy 2',1,348.547875,-0.36372,0.113,NULL,49492959344,773327489,12083242,16.3),(160567,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160567,33.44,0.57,48.6,75316,NULL,NULL,NULL,'NGC 7535',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000022,NULL,'14.24',1.5,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,348.553208333,13.58189,0.145,NULL,52515175282,820549613,12821087,14.24),(160568,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160568,33.48,0.2,49.7,75316,74.4,NULL,NULL,'NGC 7535',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160569,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160569,33.82,0.48,58.1,75316,NULL,NULL,'Malmquist cor.','NGC 7535',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160570,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160570,33.86,0.8,59.2,75317,75,NULL,'MAT, I','NGC 7536',NULL,'1997ApJS..109..333W',1997,1,1.75,NULL,'G',0.00002,NULL,'13.9g',0.66,'SBbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,348.554917,13.42639,0.125,NULL,52516244059,820566313,12821348,13.9),(160571,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160571,33.87,0.8,59.5,75317,75,NULL,'HMCL, I','NGC 7536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160572,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160572,33.88,0.8,59.7,75317,75,NULL,'CF, r','NGC 7536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160573,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160573,33.88,0.8,59.7,75317,75,NULL,'W91CL, r','NGC 7536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160574,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160574,33.46,0.38,49.2,75317,75,NULL,'W91CL, r, raw','NGC 7536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160575,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160575,33.53,0.4,50.8,75317,75,NULL,'HMCL, I, raw','NGC 7536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160576,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160576,33.54,0.38,51.1,75317,75,NULL,'CF, r, raw','NGC 7536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160577,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160577,33.56,0.38,51.6,75317,75,NULL,'W91CL, r, inv','NGC 7536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160578,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160578,33.58,0.32,52,75317,85,NULL,'I, raw','NGC 7536',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160579,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160579,33.63,0.32,53.1,75317,85,NULL,'I, inv','NGC 7536',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160580,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160580,33.64,0.38,53.5,75317,75,NULL,'CF, r, inv','NGC 7536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160581,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160581,33.68,0.4,54.5,75317,75,NULL,'HMCL, I, inv','NGC 7536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160582,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160582,33.71,0.43,55.3,75317,75,NULL,'MAT, I, raw','NGC 7536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160583,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160583,33.72,0.38,55.6,75317,75,NULL,'W91CL, r, cor','NGC 7536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160584,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160584,33.74,0.38,56.1,75317,75,NULL,'CF, r, cor','NGC 7536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160585,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160585,33.75,0.4,56.3,75317,75,NULL,'HMCL, I, cor','NGC 7536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160586,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160586,33.76,0.2,56.5,75317,74.4,NULL,NULL,'NGC 7536',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160587,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160587,33.79,0.47,57.4,75317,NULL,NULL,'H','NGC 7536',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160588,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160588,33.8,0.36,57.5,75317,NULL,NULL,NULL,'NGC 7536',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160589,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160589,33.88,0.45,59.7,75317,NULL,NULL,'K','NGC 7536',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160590,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160590,33.89,0.4,59.9,75317,NULL,NULL,'mean','NGC 7536',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160591,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160591,33.89,0.46,60.1,75317,NULL,NULL,'J','NGC 7536',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160592,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160592,33.91,0.43,60.4,75317,75,NULL,'MAT, I, cor','NGC 7536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160593,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160593,33.92,0.43,60.7,75317,75,NULL,'MAT, I, inv','NGC 7536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160594,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160594,33.92,0.34,60.9,75317,NULL,NULL,'Malmquist cor.','NGC 7536',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160595,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160595,36.01,0.53,159,75318,70,NULL,NULL,'2MASX J23141587-2911593',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,348.566208333,-29.19981,NULL,NULL,50136476652,783382447,12240350,14.7),(160596,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160596,33.93,0.2,61.1,75319,74.4,NULL,NULL,'MCG -02-59-007',NULL,'2013AJ....146...86T',2013,1,1.08,NULL,'G',0.00002,NULL,'15.8g',0.38,'SB(s)m: sp',NULL,NULL,NULL,NULL,1,348.571583,-9.83619,0.049,NULL,49596055930,774938373,12108412,15.8),(160597,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 13864','R',160597,40.93,0.23,1190,75320,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J231417.89+001127.7',0.2931,'2014arXiv1401.3317S',2014,1,0.11,NULL,'G',0.0005,NULL,'20.7g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,348.574583,0.19103,0.121,NULL,51690840297,807669379,12619834,20.7),(160598,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 13864','R',160598,40.99,0.13,1220,75320,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J231417.89+001127.7',0.2931,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160599,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 13864',NULL,160599,40.82,0.11,1460,75320,70,NULL,'SALT 2','SDSS J231417.89+001127.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160600,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 13864',NULL,160600,40.85,0.11,1480,75320,70,NULL,'SALT 2, Malmquist cor.','SDSS J231417.89+001127.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160601,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160601,34.81,0.8,91.6,75321,75,NULL,'W91PP, r','UGC 12441',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'16.0',0.1,'SBbc?',NULL,NULL,NULL,NULL,1,348.5780417,31.12286,0.325,NULL,52066831892,813544248,12711628,16),(160602,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160602,35.04,0.38,102,75321,75,NULL,'W91PP, r, raw','UGC 12441',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160603,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160603,35.07,0.39,103,75321,NULL,NULL,'Malmquist cor.','UGC 12441',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160604,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160604,35.07,0.38,103,75321,75,NULL,'W91PP, r, inv','UGC 12441',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160605,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160605,35.14,0.38,107,75321,NULL,NULL,NULL,'UGC 12441',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160606,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160606,35.23,0.38,111,75321,75,NULL,'W91PP, r, cor','UGC 12441',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160607,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160607,35.24,0.2,112,75321,74.4,NULL,NULL,'UGC 12441',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160608,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160608,35.28,0.52,114,75322,70,NULL,NULL,'NGC 7533',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00007,NULL,'15.7',0.4,'S0+: pec? sp',NULL,NULL,NULL,NULL,1,348.592,-2.03372,0.089,NULL,49495291599,773363931,12083811,15.7),(160609,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','PTF10qkf','N',160609,37.88,0.03,349,75323,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10qkf',0.0804,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160610,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160610,37.95,0.33,389,75324,70,NULL,NULL,'SDSS J231430.94+143113.8',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,348.6289583,14.5205,0.157,NULL,52526392425,820724881,12823826,17.7),(160611,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160611,37.95,0.33,389,75325,70,NULL,NULL,'2MASX J23143348+1429430',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,348.6395417,14.49519,0.157,NULL,52514915558,820545555,12821024,17.5),(160612,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 16396',NULL,160612,37.88,1.05,376,75326,70,NULL,'SN photometric redshift distance, z photo =0.092 +/- 0.062','SDSS-II SN 16396',NULL,'2011ApJ...738..162S',2011,1,0.12,NULL,'G',NULL,'PHOT','19.7g',0.09,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,348.643041667,-0.10444,0.109,NULL,49492849663,773325775,12083215,19.7),(160613,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 16396','R',160613,40.72,0.29,1070,75326,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16396',0.300839,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160614,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 16396','R',160614,40.9,0.22,1160,75326,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16396',0.300839,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160615,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160615,35.02,0.48,101,75327,NULL,NULL,'Malmquist cor.','CGCG 406-029',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000133,NULL,'15.7',0.2,NULL,NULL,NULL,NULL,NULL,1,348.6427083,6.55594,0.253,NULL,51745991792,808531121,12633298,15.7),(160616,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160616,35.06,0.2,103,75327,74.4,NULL,NULL,'CGCG 406-029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160617,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160617,35.17,0.45,108,75327,NULL,NULL,NULL,'CGCG 406-029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160618,'SNII optical','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 2002gd',NULL,160618,32.63,0.06,33.6,75328,NULL,NULL,'I, photospheric magnitude method','NGC 7537',NULL,'2014AJ....148..107R',2014,1,2.2,NULL,'G',0.000013,NULL,'12.6B',0.6,'SAbc:          HII','Pair member, near/close',NULL,NULL,NULL,1,348.64375,4.49836,0.185,NULL,51766417153,808850268,12638285,12.6),(160619,'SNII optical','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 2002gd',NULL,160619,32.67,0.13,34.2,75328,NULL,NULL,'V, photospheric magnitude method','NGC 7537',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160620,'SNII optical','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 2002gd',NULL,160620,32.9,0.21,37.3,75328,NULL,NULL,'SEAM','NGC 7537',0.00892,'2009ApJ...694.1067P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160621,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160621,32.6,0.8,33.1,75328,75,NULL,'A82, H','NGC 7537',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160622,'Tully est','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160622,32.74,0.8,35.3,75328,75,NULL,'B','NGC 7537',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160623,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160623,32.39,NULL,30.1,75328,NULL,NULL,'B, Hubble-type-TF','NGC 7537',NULL,'2004ApJ...607..241R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160624,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160624,32.56,0.4,32.5,75328,NULL,NULL,'mean','NGC 7537',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160625,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160625,32.59,NULL,33,75328,NULL,NULL,'B','NGC 7537',NULL,'2004ApJ...607..241R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160626,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160626,32.75,0.47,35.5,75328,75,NULL,'A82, H, raw','NGC 7537',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160627,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160627,32.75,0.38,35.5,75328,NULL,NULL,NULL,'NGC 7537',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160628,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160628,32.82,0.47,36.7,75328,75,NULL,'A82, H, inv','NGC 7537',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160629,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160629,32.83,0.43,36.8,75328,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7537',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160630,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160630,32.91,0.43,38.2,75328,75,NULL,'3.6 micron, color corrected','NGC 7537',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160631,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160631,32.96,0.46,39,75328,NULL,NULL,'J','NGC 7537',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160632,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160632,33,0.2,39.8,75328,74.4,NULL,NULL,'NGC 7537',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160633,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160633,33.05,0.45,40.8,75328,NULL,NULL,'K','NGC 7537',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160634,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160634,33.07,0.47,41.1,75328,NULL,NULL,'H','NGC 7537',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160635,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160635,33.1,0.37,41.7,75328,NULL,NULL,NULL,'NGC 7537',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160636,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160636,33.13,0.47,42.2,75328,75,NULL,'A82, H, cor','NGC 7537',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160637,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160637,33.35,0.33,46.7,75328,NULL,NULL,'Malmquist cor.','NGC 7537',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160638,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160638,34.5,0.47,79.6,75329,NULL,NULL,'H','NGC 7543',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000033,NULL,'14.03',0.9,'S?',NULL,NULL,NULL,NULL,1,348.644083333,28.32722,0.317,NULL,52022387864,812849810,12700778,14.03),(160639,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160639,34.56,0.45,81.5,75329,NULL,NULL,'K','NGC 7543',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160640,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160640,34.62,0.46,84,75329,NULL,NULL,'J','NGC 7543',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160641,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160641,34.93,0.4,97,75329,NULL,NULL,'mean','NGC 7543',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160642,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160642,34.86,0.34,93.8,75330,NULL,NULL,NULL,'CGCG 496-067',NULL,'2009ApJS..182..474S',2009,1,0.85,NULL,'G',0.000033,NULL,'15.7',0.15,'Sc',NULL,NULL,NULL,NULL,1,348.6760417,31.31758,0.289,NULL,52067035775,813547433,12711678,15.7),(160643,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160643,34.94,0.33,97.5,75330,NULL,NULL,'Malmquist cor.','CGCG 496-067',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160644,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160644,35.02,0.2,101,75330,74.4,NULL,NULL,'CGCG 496-067',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160645,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160645,35.23,0.49,111,75330,75,NULL,'IR','CGCG 496-067',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160646,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160646,37.56,0.33,325,75331,70,NULL,NULL,'2MASX J23144294+1442420',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000182,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,348.678916667,14.71167,0.165,NULL,52526408381,820725130,12823830,16.7),(160647,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1998dh',NULL,160647,31.97,0.35,24.6,75332,74.2,NULL,'SALT 2','NGC 7541',0.00897,'2010ApJ...716..712A',2010,1,3.5,'Identification as NGC 7581 is doubtful.','G',0.000018,NULL,'11.3B',1.2,'SB(rs)bc: pec  HII','Pair member, near/close',NULL,NULL,NULL,1,348.682875,4.53436,0.205,NULL,51766427051,808850422,12638287,11.3),(160648,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1998dh',NULL,160648,32.5,0.19,31.3,75332,72,NULL,NULL,'NGC 7541',0.00897,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160649,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1998dh',NULL,160649,32.53,0.08,32.1,75332,74.4,NULL,NULL,'NGC 7541',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160650,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1998dh',NULL,160650,32.59,0.17,33,75332,70.8,NULL,NULL,'NGC 7541',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160651,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1998dh',NULL,160651,32.7,0.38,34.4,75332,70,NULL,'SALT','NGC 7541',0.00897,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160652,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1998dh',NULL,160652,32.85,0.09,36.4,75332,65,NULL,'MLCS2k2','NGC 7541',0.00897,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160653,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1998dh',NULL,160653,32.95,0.14,38.9,75332,60,NULL,NULL,'NGC 7541',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160654,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160654,32.59,0.8,33,75332,75,NULL,'A82, H','NGC 7541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160655,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160655,32.61,0.8,33.3,75332,75,NULL,'CF, r','NGC 7541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160656,'Sosies','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160656,32.51,0.07,31.8,75332,NULL,NULL,NULL,'NGC 7541',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160657,'Tully est','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160657,32.62,0.8,33.4,75332,75,NULL,'B','NGC 7541',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160658,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160658,32.07,NULL,25.9,75332,NULL,NULL,'B','NGC 7541',NULL,'2004ApJ...607..241R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160659,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160659,32.24,0.46,28.1,75332,NULL,NULL,'J','NGC 7541',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160660,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160660,32.24,0.45,28.1,75332,NULL,NULL,'K','NGC 7541',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160661,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160661,32.26,0.43,28.3,75332,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7541',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160662,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160662,32.31,0.47,28.9,75332,NULL,NULL,'H','NGC 7541',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160663,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160663,32.33,0.49,29.3,75332,75,NULL,'IR','NGC 7541',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160664,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160664,32.35,NULL,29.5,75332,NULL,NULL,'B, Hubble-type-TF','NGC 7541',NULL,'2004ApJ...607..241R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160665,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160665,32.37,0.43,29.7,75332,75,NULL,'3.6 micron, color corrected','NGC 7541',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160666,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160666,32.46,0.38,31.1,75332,75,NULL,'CF, r, raw','NGC 7541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160667,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160667,32.53,0.08,32.1,75332,74.4,NULL,NULL,'NGC 7541',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160668,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160668,32.56,0.36,32.5,75332,NULL,NULL,NULL,'NGC 7541',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160669,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160669,32.57,0.4,32.6,75332,NULL,NULL,'mean','NGC 7541',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160670,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160670,32.58,0.4,32.8,75332,75,NULL,'HOSTS SN 1998dh','NGC 7541',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160671,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160671,32.64,0.38,33.7,75332,75,NULL,'CF, r, inv','NGC 7541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160672,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160672,32.68,0.47,34.4,75332,75,NULL,'A82, H, raw','NGC 7541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160673,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160673,32.71,0.38,34.9,75332,75,NULL,'CF, r, cor','NGC 7541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160674,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160674,32.8,0.5,36.3,75332,NULL,NULL,NULL,'NGC 7541',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160675,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160675,32.85,0.49,37.1,75332,NULL,NULL,'Malmquist cor.','NGC 7541',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160676,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160676,32.88,0.47,37.7,75332,75,NULL,'A82, H, inv','NGC 7541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160677,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160677,33.06,0.47,40.9,75332,75,NULL,'A82, H, cor','NGC 7541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160678,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160678,33.22,0.8,44,75333,75,NULL,'W91CL, r','UGC 12451',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000017,NULL,'15.56',0.4,'Im',NULL,NULL,NULL,NULL,1,348.68825,5.41306,0.217,NULL,51766336691,808849010,12638265,15.56),(160679,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160679,33.24,0.8,44.4,75333,75,NULL,'HMCL, I','UGC 12451',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160680,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160680,32.63,0.2,33.6,75333,74.4,NULL,NULL,'UGC 12451',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160681,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160681,32.76,0.43,35.6,75333,75,NULL,'3.6 micron, color corrected','UGC 12451',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160682,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160682,32.8,0.4,36.2,75333,75,NULL,'HMCL, I, inv','UGC 12451',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160683,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160683,32.81,0.4,36.4,75333,75,NULL,'HMCL, I, raw','UGC 12451',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160684,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160684,32.82,0.43,36.7,75333,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12451',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160685,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160685,32.93,0.38,38.6,75333,75,NULL,'W91CL, r, inv','UGC 12451',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160686,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160686,33,0.38,39.8,75333,75,NULL,'W91CL, r, raw','UGC 12451',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160687,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160687,33.08,0.4,41.3,75333,75,NULL,'HMCL, I, cor','UGC 12451',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160688,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160688,33.27,0.38,45.1,75333,75,NULL,'W91CL, r, cor','UGC 12451',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160689,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 15944',NULL,160689,40.18,0.23,1090,75334,70,NULL,'SN photometric redshift distance, z photo =0.296 +/- 0.041','SDSS-II SN 15944',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,348.690833,0.42672,0.105,NULL,51690715904,807667436,12619803,NULL),(160690,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 15944',NULL,160690,40.63,0.14,1340,75334,70,NULL,'SALT 2','SDSS-II SN 15944',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160691,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 15944',NULL,160691,40.65,0.14,1350,75334,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15944',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160692,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160692,36.07,0.2,164,75335,74.4,NULL,NULL,'UGC 12448',NULL,'2013AJ....146...86T',2013,1,1.02,NULL,'G',0.000161,NULL,'16.3g',0.23,'Scd:',NULL,NULL,NULL,NULL,1,348.696833,14.89322,0.165,NULL,52527300645,820739072,12824048,16.3),(160693,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160693,33.87,0.8,59.4,75336,75,NULL,'W91CL, r','KUG 2312+074',NULL,'1997ApJS..109..333W',1997,1,0.8,NULL,'G',0.000023,NULL,'15.88',0.3,'Sc',NULL,NULL,NULL,NULL,1,348.699875,7.71847,0.129,NULL,51747690266,808557660,12633713,15.88),(160694,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160694,34.11,0.2,66.4,75336,74.4,NULL,NULL,'KUG 2312+074',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160695,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160695,34.28,0.38,71.8,75336,75,NULL,'W91CL, r, inv','KUG 2312+074',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160696,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160696,34.29,0.38,72,75336,75,NULL,'W91CL, r, raw','KUG 2312+074',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160697,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160697,34.29,0.46,72.2,75336,NULL,NULL,'Malmquist cor.','KUG 2312+074',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160698,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160698,34.31,0.45,72.6,75336,NULL,NULL,NULL,'KUG 2312+074',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160699,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160699,34.47,0.38,78.3,75336,75,NULL,'W91CL, r, cor','KUG 2312+074',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160700,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 14956','RN',160700,42.13,0.21,2050,75337,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 14956',0.298447,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160701,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 14956','RN',160701,42.43,0.24,2360,75337,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 14956',0.298447,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160702,'Ring Diameter','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160702,31.6,0.84,21,75338,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7531',NULL,'1981ApJS...45..541P',1981,1,4.5,'Extended HIPASS source','G',0.00001,NULL,'12.04',1.8,'SAB(r)bc','X-ray-faint group member',NULL,NULL,NULL,1,348.702083,-43.59994,NULL,NULL,50530502011,789539093,12336548,12.04),(160703,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160703,31.51,0.8,20.1,75338,75,NULL,'MAT, I','NGC 7531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160704,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160704,31.52,0.8,20.1,75338,75,NULL,'A82, H','NGC 7531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160705,'Sosies','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160705,32.01,0.07,25.2,75338,NULL,NULL,NULL,'NGC 7531',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160706,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160706,30.75,0.4,14.1,75338,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 7531',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160707,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160707,31.14,0.47,16.9,75338,75,NULL,'A82, H, raw','NGC 7531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160708,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160708,31.23,0.47,17.6,75338,75,NULL,'A82, H, inv','NGC 7531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160709,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160709,31.43,0.4,19.3,75338,75,NULL,'B','NGC 7531',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160710,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160710,31.43,0.4,19.4,75338,NULL,NULL,'mean','NGC 7531',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160711,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160711,31.46,0.47,19.6,75338,75,NULL,'A82, H, cor','NGC 7531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160712,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160712,31.78,0.35,22.7,75338,NULL,NULL,NULL,'NGC 7531',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160713,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160713,31.78,0.39,22.7,75338,73,NULL,'opt','NGC 7531',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160714,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160714,31.81,0.46,23,75338,NULL,NULL,'J','NGC 7531',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160715,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160715,31.89,0.45,23.9,75338,NULL,NULL,'K','NGC 7531',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160716,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160716,31.99,0.32,25,75338,85,NULL,'I, raw','NGC 7531',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160717,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160717,32.02,0.43,25.3,75338,75,NULL,'3.6 micron, color corrected','NGC 7531',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160718,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160718,32.03,0.32,25.5,75338,85,NULL,'I, inv','NGC 7531',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160719,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160719,32.04,0.43,25.6,75338,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7531',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160720,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160720,32.09,0.43,26.1,75338,75,NULL,'MAT, I, raw','NGC 7531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160721,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160721,32.14,0.2,26.8,75338,74.4,NULL,NULL,'NGC 7531',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160722,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160722,32.28,0.43,28.6,75338,75,NULL,'MAT, I, cor','NGC 7531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160723,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160723,32.29,0.39,28.7,75338,73,NULL,'opt','NGC 7531',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160724,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160724,32.32,0.43,29.1,75338,75,NULL,'MAT, I, inv','NGC 7531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160725,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160725,32.4,0.43,30.2,75338,NULL,NULL,'Malmquist cor.','NGC 7531',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160726,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160726,32.49,0.42,31.5,75338,NULL,NULL,NULL,'NGC 7531',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160727,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160727,34.74,0.53,88.8,75339,70,NULL,NULL,'CGCG 380-015',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.000096,NULL,'15.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,348.7077917,-0.24136,0.109,NULL,49492834728,773325542,12083211,15.6),(160728,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160728,37.69,0.46,345,75340,70,NULL,NULL,'2MASX J23145071-0938277',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000186,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,348.711708333,-9.64167,0.065,NULL,49596482143,774945033,12108516,17),(160729,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160729,35.22,0.49,111,75341,75,NULL,'IR','UGC 12449',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000033,NULL,'16.0',0.1,'S?',NULL,NULL,NULL,NULL,1,348.721375,23.28292,0.189,NULL,52498385293,820287270,12816988,16),(160730,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160730,34.94,0.49,97.4,75342,75,NULL,'IR','ESO 604- G 006',NULL,'2011yCatp016004901K',2011,1,2.33,NULL,'G',0.00003,NULL,'14.89',0.27,'Sb',NULL,NULL,NULL,NULL,1,348.726083,-20.99586,0.09,NULL,50312465947,786132280,12283316,14.89),(160731,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160731,35.15,NULL,107,75342,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 604- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160732,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160732,35.16,0.4,108,75342,NULL,NULL,'mean','ESO 604- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160733,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160733,35.16,NULL,108,75342,NULL,NULL,'Dipole + Quadrupole','ESO 604- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160734,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160734,35.17,NULL,108,75342,NULL,NULL,'Dipole','ESO 604- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160735,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160735,35.17,0.47,108,75342,NULL,NULL,'H','ESO 604- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160736,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160736,35.27,0.45,113,75342,NULL,NULL,'K','ESO 604- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160737,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160737,35.38,0.46,119,75342,NULL,NULL,'J','ESO 604- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160738,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160738,35.23,0.52,111,75343,70,NULL,NULL,'NGC 7544',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.07',0.4,'S0o: sp',NULL,NULL,NULL,NULL,1,348.737416667,-2.19933,0.085,NULL,49628907316,775451676,12116432,16.07),(160739,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160739,37.88,0.23,376,75344,70,NULL,NULL,'2MASX J23145866+1405242',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000171,NULL,'16.7g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,348.744417,14.09006,0.157,NULL,52515799905,820559373,12821240,16.7),(160740,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160740,35,0.46,99.9,75345,70,NULL,NULL,'2MASX J23145913+0112170',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000075,NULL,'15.6g',0.5,'E0',NULL,NULL,NULL,NULL,1,348.746375,1.20458,0.149,NULL,51758265871,808722904,12636295,15.6),(160741,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 07822',NULL,160741,41.47,0.07,1970,75346,70,NULL,'SN photometric redshift distance, z photo =0.642 +/- 0.030','SDSS-II SN 07822',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'G',NULL,'PHOT','22.7R',NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,348.747917,-0.00719,0.109,NULL,49492787247,773324800,12083200,22.7),(160742,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160742,37.56,0.33,325,75347,70,NULL,NULL,'2MASX J23150009+1441002',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,348.7502917,14.6835,0.165,NULL,52527243818,820738184,12824034,17.4),(160743,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 10288','RN',160743,38.86,0.65,562,75348,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10288',0.051219,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160744,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 10288','RN',160744,41.74,0.84,2120,75348,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10288',0.051219,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160745,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160745,33.6,0.49,52.5,75349,75,NULL,'IR','UGC 12452',NULL,'2011yCatp016004901K',2011,1,2.11,NULL,'G',0.000008,NULL,'15.40',0.19,'Scd',NULL,NULL,NULL,NULL,1,348.7612083,1.43556,0.165,NULL,51761120838,808767513,12636992,15.4),(160746,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160746,33.92,NULL,60.8,75349,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12452',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160747,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160747,33.93,NULL,61,75349,NULL,NULL,'Dipole + Quadrupole','UGC 12452',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160748,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160748,33.93,NULL,61.1,75349,NULL,NULL,'Dipole','UGC 12452',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160749,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160749,33.99,NULL,62.8,75349,NULL,NULL,NULL,'UGC 12452',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160750,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160750,34.19,0.2,68.9,75349,74.4,NULL,NULL,'UGC 12452',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160751,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160751,34.3,0.45,72.3,75349,NULL,NULL,NULL,'UGC 12452',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160752,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160752,34.33,0.45,73.4,75349,NULL,NULL,'Malmquist cor.','UGC 12452',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160753,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160753,36.15,0.56,170,75350,70,NULL,NULL,'2MASX J23150511-7116199',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'17.37',0.26,NULL,NULL,NULL,NULL,NULL,1,348.771417,-71.27222,0.053,NULL,48392897624,756139025,11814672,17.37),(160754,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160754,37.88,0.23,376,75351,70,NULL,NULL,'2MASX J23150746+1408152',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,348.781083,14.13761,0.157,NULL,52515390330,820552973,12821140,17.3),(160755,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160755,37.96,0.46,392,75352,70,NULL,NULL,'2MASX J23150746+1534432',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000158,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,348.781083,15.57867,0.149,NULL,52522569614,820665150,12822892,18.5),(160756,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160756,37.87,0.46,375,75353,70,NULL,NULL,'2MASX J23150769-0944347',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,348.782,-9.74314,0.061,NULL,49595894533,774935852,12108372,18),(160757,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160757,35.37,NULL,118,75354,NULL,NULL,NULL,'UGC 12458',NULL,'2000BSAO...50....5K',2000,1,1.08,NULL,'G',0.000007,NULL,'16.5',0.13,'Sc',NULL,NULL,NULL,NULL,1,348.786916667,30.94664,0.289,NULL,52066700459,813542194,12711596,16.5),(160758,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160758,35.44,0.43,123,75354,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12458',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160759,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160759,35.58,0.43,131,75354,75,NULL,'3.6 micron, color corrected','UGC 12458',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160760,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160760,35.6,NULL,132,75354,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12458',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160761,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160761,35.61,NULL,133,75354,NULL,NULL,'Dipole + Quadrupole','UGC 12458',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160762,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160762,35.63,NULL,134,75354,NULL,NULL,'Dipole','UGC 12458',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160763,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160763,35.76,0.45,142,75354,NULL,NULL,'Malmquist cor.','UGC 12458',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160764,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160764,35.87,0.2,149,75354,74.4,NULL,NULL,'UGC 12458',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160765,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160765,36.04,0.4,162,75354,NULL,NULL,NULL,'UGC 12458',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160766,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 05199',NULL,160766,39.61,0.25,837,75355,70,NULL,'SN photometric redshift distance, z photo =0.219 +/- 0.031','SDSS-II SN 05199',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,348.792417,-0.99494,0.077,NULL,49627427009,775428547,12116071,NULL),(160767,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 05199','R',160767,40.51,0.23,1030,75355,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05199',0.221952,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160768,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 05199','R',160768,40.52,0.18,1040,75355,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 05199',0.221952,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160769,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 05199',NULL,160769,40.35,0.13,1170,75355,70,NULL,'SALT 2','SDSS-II SN 05199',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160770,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 05199',NULL,160770,40.36,0.13,1180,75355,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 05199',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160771,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160771,31.9,NULL,24,75356,NULL,NULL,NULL,'ESO 407- G 012',NULL,'2000BSAO...50....5K',2000,1,1.1,'2000A&AS..143..421M has z = 0.02001 +- 0.00009.','G',0.00015,NULL,'16.60',0.11,'Irr',NULL,NULL,NULL,NULL,1,348.794083,-33.25272,NULL,NULL,50160452088,783757063,12246204,16.6),(160772,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160772,33.03,0.8,40.3,75357,75,NULL,'MAT, I','ESO 239- G 017',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000021,NULL,'13.41',1.4,'SAB(s)d',NULL,NULL,NULL,NULL,1,348.799625,-49.39792,0,NULL,50504245693,789128838,12330138,13.41),(160773,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160773,32.36,0.32,29.6,75357,85,NULL,'I, inv','ESO 239- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160774,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160774,32.38,0.32,29.9,75357,85,NULL,'I, raw','ESO 239- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160775,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160775,32.99,0.43,39.7,75357,75,NULL,'MAT, I, raw','ESO 239- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160776,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160776,33,0.43,39.7,75357,75,NULL,'MAT, I, inv','ESO 239- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160777,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160777,33.12,0.43,42,75357,75,NULL,'MAT, I, cor','ESO 239- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160778,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160778,35.61,0.17,127,75358,74.2,NULL,'SALT 2','ESO 291- G 011',0.043,'2010ApJ...716..712A',2010,1,1.1,NULL,'G',0.000183,NULL,'15.23',0.8,'(R\'_1)SB(s)0/a',NULL,NULL,NULL,NULL,1,348.8000417,-44.73672,NULL,NULL,50532283026,789566922,12336983,15.23),(160779,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160779,36.2,0.19,167,75358,72,NULL,NULL,'ESO 291- G 011',0.043,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160780,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160780,36.26,0.15,171,75358,65,NULL,'MLCS','ESO 291- G 011',0.043,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160781,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160781,36.18,0.08,172,75358,74.4,NULL,NULL,'ESO 291- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160782,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160782,36.28,0.06,173,75358,70,NULL,NULL,'ESO 291- G 011',0.043,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160783,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160783,36.28,0.21,173,75358,65,NULL,'SALT2','ESO 291- G 011',0.043,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160784,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160784,36.3,0.18,175,75358,70,NULL,'SALT 2','ESO 291- G 011',0.043,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160785,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160785,36.34,0.03,178,75358,72,NULL,NULL,'ESO 291- G 011',0.043,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160786,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160786,36.34,0.2,178,75358,73.8,NULL,'SALT 2 (SNANA)','ESO 291- G 011',0.0424,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160787,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160787,36.36,0.15,179,75358,70,NULL,'SALT','ESO 291- G 011',0.043,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160788,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160788,36.5,0.12,183,75358,65,NULL,'MLCS2k2','ESO 291- G 011',0.043,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160789,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160789,36.42,0.1,184,75358,65,NULL,'MLCS2k2','ESO 291- G 011',0.043,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160790,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160790,36.34,0.17,185,75358,70.8,NULL,NULL,'ESO 291- G 011',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160791,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160791,36.46,0.18,188,75358,65,NULL,'MLCS17','ESO 291- G 011',0.043,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160792,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160792,36.49,0.13,190,75358,65,NULL,'MLCS2k2','ESO 291- G 011',0.043,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160793,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160793,36.5,0.2,191,75358,65,NULL,'SALT2','ESO 291- G 011',0.043,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160794,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160794,36.52,0.17,193,75358,65,NULL,'MLCS31','ESO 291- G 011',0.043,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160795,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160795,36.52,0.14,193,75358,65,NULL,'SALT','ESO 291- G 011',0.043,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160796,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160796,36.53,0.2,194,75358,65,NULL,'Template','ESO 291- G 011',0.043,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160797,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160797,36.53,0.19,194,75358,65,NULL,NULL,'ESO 291- G 011',0.043,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160798,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160798,36.53,0.05,194,75358,65,NULL,'SALT','ESO 291- G 011',0.043,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160799,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160799,36.7,0.05,210,75358,70,NULL,'SALT 2','ESO 291- G 011',0.043,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160800,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160800,36.69,0.14,218,75358,60,NULL,NULL,'ESO 291- G 011',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160801,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160801,36.74,0.08,223,75358,60,NULL,'M(B) = -19.48 mag','ESO 291- G 011',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160802,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160802,36.76,0.07,225,75358,60,NULL,'M(V) = -19.47 mag','ESO 291- G 011',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160803,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160803,36.78,0.06,227,75358,60,NULL,'M(I) = -19.19 mag','ESO 291- G 011',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160804,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160804,35.3,0.46,115,75359,70,NULL,NULL,'III Zw 097',NULL,'2015arXiv151105856S',2015,1,1.3,NULL,'G',0.00012,NULL,'15.4',0.5,NULL,NULL,NULL,NULL,NULL,1,348.809375,-1.24219,0.093,NULL,49627311024,775426734,12116042,15.4),(160805,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160805,35.63,0.5,133,75359,70,NULL,NULL,'III Zw 097',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160806,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 07824','R',160806,40.83,0.25,1140,75360,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07824',0.2871,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,348.813,-0.08092,0.109,NULL,49627007834,775421997,12115968,NULL),(160807,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 07824','R',160807,41.06,0.18,1270,75360,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07824',0.2871,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160808,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160808,33.99,0.45,62.9,75361,NULL,NULL,'K','NGC 7550',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000067,NULL,'13.16',1.2,'SA0-           AGN','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,348.816708333,18.96181,0.181,NULL,52500374043,820318344,12817474,13.16),(160809,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160809,34.09,0.4,65.7,75361,NULL,NULL,'mean','NGC 7550',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160810,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 2009nq',NULL,160810,34.22,0.26,68.7,75362,73.8,NULL,'SALT 2 (SNANA)','NGC 7549',0.0145,'2014ApJ...795...44R',2014,1,2.8,'Identified as NGC 7594 in Hickson et al.(1989:Ap.J.Suppl. 70,687).','G',0.000011,NULL,'13.74',0.7,'SB(s)cd pec    AGN','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,348.8217917,19.04169,0.181,NULL,52500371363,820318302,12817473,13.74),(160811,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160811,33.39,0.47,47.7,75362,NULL,NULL,'H','NGC 7549',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160812,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160812,33.55,0.46,51.3,75362,NULL,NULL,'J','NGC 7549',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160813,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160813,33.56,0.45,51.5,75362,NULL,NULL,'K','NGC 7549',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160814,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160814,33.88,0.4,59.7,75362,NULL,NULL,'mean','NGC 7549',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160815,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160815,35.29,0.52,115,75363,70,NULL,NULL,'ESO 604- G 007',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.39',0.2,'Sb:',NULL,NULL,NULL,NULL,1,348.8227083,-21.36628,0.078,NULL,50314427816,786162934,12283795,15.39),(160816,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160816,35.09,0.49,104,75363,75,NULL,'IR','ESO 604- G 007',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160817,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 2006ln',NULL,160817,39.31,0.1,728,75364,70,NULL,'Hubble residual -0.41 for z0.23200','SDSS-II SN 15369 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,348.8330417,-0.56269,0.109,NULL,49627134921,775423983,12115999,NULL),(160818,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 15369','R',160818,39.94,0.2,791,75364,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ln','SDSS-II SN 15369 HOST',0.232,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160819,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 15369','R',160819,40.1,0.1,850,75364,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ln','SDSS-II SN 15369 HOST',0.232,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160820,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160820,35.13,0.76,106,75365,NULL,NULL,'Malmquist cor.','CGCG 454-014',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000067,NULL,'15.7',0.4,NULL,NULL,NULL,NULL,NULL,1,348.838083,16.04258,0.165,NULL,52524378060,820693407,12823334,15.7),(160821,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160821,35.17,0.75,108,75365,NULL,NULL,NULL,'CGCG 454-014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160822,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160822,35.21,0.2,110,75365,74.4,NULL,NULL,'CGCG 454-014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160823,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160823,37.88,0.23,376,75366,70,NULL,NULL,'2MASX J23152236+1358491',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000169,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,348.843333,13.98039,0.165,NULL,52515477181,820554330,12821161,18.1),(160824,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160824,37.88,0.23,376,75367,70,NULL,NULL,'2MASX J23152589+1409041',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,348.858125,14.15125,0.157,NULL,52515507216,820554800,12821168,18),(160825,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160825,36.31,0.46,182,75368,70,NULL,NULL,'2MASX J23152844-0935524',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00015,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,348.8684583,-9.59806,0.069,NULL,49596582565,774946602,12108540,16.6),(160826,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160826,36.23,0.46,176,75369,70,NULL,NULL,'2MASX J23153092+1340402',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000186,NULL,'15.4g',0.48,'E0',NULL,NULL,NULL,NULL,1,348.878917,13.67797,0.129,NULL,52516751933,820574248,12821472,15.4),(160827,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160827,38.1,0.46,417,75370,70,NULL,NULL,'2MASX J23153120-1039494',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000182,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,348.8799583,-10.66364,0.069,NULL,49594116103,774908064,12107938,17.3),(160828,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 13465',NULL,160828,39.99,0.3,995,75371,70,NULL,'SN photometric redshift distance, z photo =0.267 +/- 0.047','SDSS-II SN 13465',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.5g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,348.88275,0.01614,0.109,NULL,51573169563,805830774,12591105,21.5),(160829,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 13465','R',160829,40.93,0.32,1190,75371,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13465',0.286372,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160830,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 13465','R',160830,41.05,0.29,1260,75371,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13465',0.286372,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160831,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160831,35.6,0.2,132,75372,74.4,NULL,NULL,'CGCG 406-036',NULL,'2013AJ....146...86T',2013,1,0.7,'NGC 7564 is a star.','G',0.00024,NULL,'15.5',0.3,'Merger?',NULL,NULL,NULL,NULL,1,348.91,7.31167,0.157,NULL,51748778591,808574665,12633979,15.5),(160832,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160832,36.25,0.46,178,75373,70,NULL,NULL,'2MASX J23153845+0101313',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.6g',0.29,'AGN',NULL,NULL,NULL,NULL,1,348.910166667,1.02542,0.133,NULL,51758323341,808723802,12636309,16.6),(160833,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160833,35.12,0.8,106,75374,75,NULL,'W91PP, r','UGC 12459',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.00001,NULL,'15.43',0.4,'Sbc',NULL,NULL,NULL,NULL,1,348.9135,24.89869,0.261,NULL,51979904573,812186008,12690406,15.43),(160834,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160834,34.54,0.52,81.1,75374,NULL,NULL,NULL,'UGC 12459',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160835,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160835,34.59,0.2,82.8,75374,74.4,NULL,NULL,'UGC 12459',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160836,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160836,34.72,0.38,87.9,75374,75,NULL,'W91PP, r, raw','UGC 12459',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160837,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160837,34.77,0.38,90,75374,75,NULL,'W91PP, r, inv','UGC 12459',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160838,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160838,34.78,0.47,90.4,75374,NULL,NULL,'Malmquist cor.','UGC 12459',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160839,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160839,35,0.38,100,75374,75,NULL,'W91PP, r, cor','UGC 12459',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160840,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 10291','RN',160840,40.23,0.57,1040,75375,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10291',0.068972,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160841,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160841,37.71,0.46,348,75376,70,NULL,NULL,'2MASX J23154166+0039523',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000089,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,348.9235417,0.66467,0.137,NULL,51757881095,808716892,12636201,17.1),(160842,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160842,38.6,0.46,524,75377,70,NULL,NULL,'2MASX J23154207-0026065',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000106,NULL,'17.1g',0.09,'FR II          AGN',NULL,NULL,NULL,NULL,1,348.9254583,-0.43531,0.097,NULL,49627251792,775425809,12116028,17.1),(160843,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160843,34.53,0.2,80.5,75378,74.4,NULL,NULL,'CGCG 380-018',NULL,'2013AJ....146...86T',2013,1,0.78,NULL,'G',0.000063,NULL,'14.7g',0.61,'Sb',NULL,NULL,NULL,NULL,1,348.929958333,0.41697,0.113,NULL,51757959524,808718117,12636220,14.7),(160844,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160844,35.15,0.8,107,75379,75,NULL,'W91PP, r','IC 5296',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000023,NULL,'15.28',0.6,'SBb','Group member',NULL,NULL,NULL,1,348.932417,25.09453,0.301,NULL,51979412473,812178319,12690286,15.28),(160845,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160845,34.66,0.49,85.7,75379,NULL,NULL,NULL,'IC 5296',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160846,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160846,34.82,0.2,92,75379,74.4,NULL,NULL,'IC 5296',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160847,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160847,34.9,0.38,95.6,75379,75,NULL,'W91PP, r, raw','IC 5296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160848,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160848,34.91,0.43,96,75379,NULL,NULL,'Malmquist cor.','IC 5296',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160849,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160849,35.03,0.38,101,75379,75,NULL,'W91PP, r, inv','IC 5296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160850,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160850,35.13,0.38,106,75379,75,NULL,'W91PP, r, cor','IC 5296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160851,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 17244','R',160851,38.59,0.22,505,75380,70,NULL,'SDSS CAND. SNII; SALT 2','SN 2007ib',0.03416,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'II',NULL,NULL,NULL,NULL,1,348.935666667,0.45711,0.137,NULL,51757971280,808718301,12636223,NULL),(160852,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160852,36.3,0.57,182,75381,70,NULL,NULL,'2MASX J23154473-0215515',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.65',0.31,NULL,NULL,NULL,NULL,NULL,1,348.9364583,-2.26431,0.085,NULL,49628956085,775452438,12116444,16.65),(160853,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160853,33.69,0.46,54.8,75382,70,NULL,NULL,'NGC 7559B',NULL,'2015arXiv151105856S',2015,1,1.11,NULL,'G',0.00004,NULL,'13.9g',1.02,'E0',NULL,NULL,NULL,NULL,1,348.944,13.29028,0.125,NULL,52516665135,820572892,12821451,13.9),(160854,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160854,35.12,0.49,106,75383,70,NULL,NULL,'2MASX J23154833-0223565',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'15.88',0.31,NULL,NULL,NULL,NULL,NULL,1,348.9515417,-2.39908,0.085,NULL,49628935547,775452117,12116439,15.88),(160855,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160855,36.02,0.37,160,75384,NULL,NULL,'Malmquist cor.','MCG +03-59-017',NULL,'2009ApJS..182..474S',2009,1,0.75,NULL,'G',0.000033,NULL,'16',0.3,NULL,NULL,NULL,NULL,NULL,1,348.952333333,15.88678,0.165,NULL,52522625003,820666015,12822906,16),(160856,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160856,36.1,0.36,166,75384,NULL,NULL,NULL,'MCG +03-59-017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160857,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160857,36.19,0.2,173,75384,74.4,NULL,NULL,'MCG +03-59-017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160858,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160858,37.63,0.27,336,75385,70,NULL,NULL,'2MASX J23154981-1025598',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000178,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,348.957417,-10.43336,0.045,NULL,49596947585,774952306,12108629,17.4),(160859,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160859,36.85,0.46,234,75386,70,NULL,NULL,'2MASX J23155137+1528343',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000154,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,348.9642083,15.47622,0.165,NULL,52526951120,820733611,12823962,16.4),(160860,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 18301',NULL,160860,40.06,0.33,1030,75387,70,NULL,'SN photometric redshift distance, z photo =0.278 +/- 0.055','SDSS-II SN 18301',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','20.7g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,348.9667083,0.81556,0.133,NULL,51758626576,808728540,12636383,20.7),(160861,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 18301',NULL,160861,40.16,0.33,1080,75387,70,NULL,NULL,'SDSS-II SN 18301',NULL,'2013MNRAS.434.1443X',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160862,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 18301','R',160862,40.91,0.28,1140,75387,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18301',0.331565,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160863,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 18301','R',160863,41.07,0.33,1230,75387,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18301',0.331565,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160864,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 18301',NULL,160864,40.93,0.22,1530,75387,70,NULL,'SALT 2','SDSS-II SN 18301',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160865,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 18301',NULL,160865,40.97,0.22,1560,75387,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18301',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160866,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 13902',NULL,160866,40.23,0.21,1110,75388,70,NULL,'SN photometric redshift distance, z photo =0.305 +/- 0.037','SDSS-II SN 13902',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.2g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,348.972625,0.25219,0.113,NULL,51757737308,808714645,12636166,22.2),(160867,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 13902','R',160867,41.39,0.35,1430,75388,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13902',0.325011,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160868,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 13902','R',160868,41.58,0.35,1560,75388,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13902',0.325011,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160869,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 13902',NULL,160869,41.14,0.22,1690,75388,70,NULL,'SALT 2','SDSS-II SN 13902',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160870,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 13902',NULL,160870,41.18,0.22,1720,75388,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13902',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160871,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160871,35.55,0.5,129,75389,70,NULL,NULL,'2MFGC 17457',NULL,'2014MNRAS.445.2677S',2014,1,0.88,NULL,'G',0.000093,NULL,'15.98',0.28,'S',NULL,NULL,NULL,NULL,1,348.975875,-48.3535,0,NULL,50504080890,789126263,12330097,15.98),(160872,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160872,33.82,0.4,58.2,75390,NULL,NULL,'mean','NGC 7563',NULL,'2007A&A...465...71T',2007,1,1.81,NULL,'G',0.00008,NULL,'13.5g',0.79,'SBa','in a radial-velocity based grouping',NULL,NULL,NULL,1,348.9830417,13.19611,0.125,NULL,52516682233,820573159,12821455,13.5),(160873,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160873,33.86,0.47,59.1,75390,NULL,NULL,'H','NGC 7563',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160874,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160874,33.86,0.45,59.2,75390,NULL,NULL,'K','NGC 7563',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160875,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160875,33.92,0.46,60.8,75390,NULL,NULL,'J','NGC 7563',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160876,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160876,37.91,0.46,382,75391,70,NULL,NULL,'2MASX J23155645-1037128',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,348.9852917,-10.62017,0.069,NULL,49596940019,774952187,12108627,18.3),(160877,'SBF','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160877,33.79,0.84,57.3,75392,NULL,NULL,'I','NGC 7562',NULL,'2001ApJ...546..681T',2001,1,2.2,NULL,'G',0.000017,NULL,'12.63',1.5,'E2-3           BLLAC','in a radial-velocity based grouping',NULL,NULL,NULL,1,348.989583,6.68753,0.217,NULL,51746174613,808533978,12633343,12.63),(160878,'SBF','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160878,33.86,0.14,59.2,75392,74.4,NULL,NULL,'NGC 7562',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160879,'D-Sigma','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160879,33.21,0.4,43.8,75392,75,NULL,'Edat, raw','NGC 7562',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160880,'D-Sigma','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160880,33.3,0.4,45.6,75392,75,NULL,'Edat, cor','NGC 7562',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160881,'Faber-Jackson','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160881,32.57,0.49,32.7,75392,95,NULL,'de Vaucouleurs','NGC 7562',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160882,'Faber-Jackson','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160882,32.66,0.33,34,75392,95,NULL,'Weighted Mean','NGC 7562',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160883,'Faber-Jackson','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160883,32.9,0.63,38,75392,95,NULL,'Michard 1979b, c','NGC 7562',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160884,'Faber-Jackson','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160884,33.29,0.46,45.5,75392,95,NULL,'Michard 1979a','NGC 7562',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160885,'Tertiary','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160885,33.11,0.5,41.9,75392,95,NULL,NULL,'NGC 7562',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160886,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160886,33.25,0.45,44.6,75392,NULL,NULL,'K','NGC 7562',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160887,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160887,33.42,0.4,48.2,75392,NULL,NULL,'mean','NGC 7562',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160888,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 19657',NULL,160888,39.32,1.11,731,75393,70,NULL,'SN photometric redshift distance, z photo =0.188 +/- 0.151','SDSS-II SN 19657',NULL,'2011ApJ...738..162S',2011,1,0.1,NULL,'G',NULL,'PHOT','20.4g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,348.992167,-0.38078,0.085,NULL,49627224753,775425386,12116021,20.4),(160889,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 19657','R',160889,40.15,0.23,801,75393,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 19657',0.337755,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160890,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 19657','R',160890,40.62,0.33,994,75393,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19657',0.337755,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160891,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160891,35.41,0.64,121,75394,70,NULL,NULL,'2MASX J23155923-0415175',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'15.96',0.35,NULL,NULL,NULL,NULL,NULL,1,348.996625,-4.25478,0.133,NULL,49633671684,775526120,12117595,15.96),(160892,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160892,34.51,0.69,79.7,75395,100,NULL,'mid-IR','UGC 12466',NULL,'2013ApJ...771...88L',2013,1,1,NULL,'G',0.000043,NULL,'14.9',0.6,'SBb            HII',NULL,NULL,NULL,NULL,1,348.99725,-1.84625,0.085,NULL,49628804590,775450071,12116407,14.9),(160893,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160893,35.11,0.4,105,75395,NULL,NULL,'mean','UGC 12466',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160894,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160894,35.32,0.47,116,75395,NULL,NULL,'H','UGC 12466',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160895,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',160895,37.63,0.27,336,75396,70,NULL,NULL,'2MASX J23155991-1025378',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,348.999583,-10.42722,0.07,NULL,49596955449,774952428,12108631,16.5),(160896,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160896,33.14,0.8,42.5,75397,75,NULL,'W91CL, r','NGC 7562A',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000013,NULL,'15.53',0.4,'Sdm: sp','in a pair',NULL,NULL,NULL,1,349.006083,6.65228,0.217,NULL,51746172734,808533948,12633342,15.53),(160897,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160897,33.15,0.8,42.7,75397,75,NULL,'HMCL, I','NGC 7562A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160898,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160898,33.16,0.8,42.8,75397,75,NULL,'MAT, I','NGC 7562A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160899,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160899,32.84,0.2,37,75397,74.4,NULL,NULL,'NGC 7562A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160900,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160900,32.98,0.32,39.4,75397,85,NULL,'I, inv','NGC 7562A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160901,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160901,32.98,0.43,39.5,75397,75,NULL,'3.6 micron, color corrected','NGC 7562A',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160902,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160902,32.98,0.32,39.5,75397,85,NULL,'I, raw','NGC 7562A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160903,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160903,33,0.4,39.7,75397,75,NULL,'HMCL, I, raw','NGC 7562A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160904,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160904,33.03,0.4,40.4,75397,75,NULL,'HMCL, I, inv','NGC 7562A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160905,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160905,33.08,0.43,41.4,75397,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7562A',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160906,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160906,33.28,0.43,45.4,75397,75,NULL,'MAT, I, raw','NGC 7562A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160907,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160907,33.29,0.4,45.4,75397,75,NULL,'HMCL, I, cor','NGC 7562A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160908,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160908,33.32,0.43,46.2,75397,75,NULL,'MAT, I, inv','NGC 7562A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160909,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160909,33.4,0.38,47.9,75397,75,NULL,'W91CL, r, inv','NGC 7562A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160910,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160910,33.42,0.38,48.3,75397,75,NULL,'W91CL, r, raw','NGC 7562A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160911,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160911,33.63,0.43,53.2,75397,75,NULL,'MAT, I, cor','NGC 7562A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160912,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160912,33.69,0.38,54.7,75397,75,NULL,'W91CL, r, cor','NGC 7562A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160913,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',160913,37.63,0.27,336,75398,70,NULL,NULL,'2MASX J23160303-1025138',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000095,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,349.0127083,-10.42047,0.07,NULL,49596941713,774952214,12108628,17.4),(160914,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',160914,37.06,0.46,259,75399,70,NULL,NULL,'2MASX J23160617+1510146',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000221,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,349.025667,15.17061,0.129,NULL,52527336192,820739628,12824056,17.7),(160915,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160915,35.75,0.58,141,75400,70,NULL,NULL,'LCRS B231321.0-445829',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.000133,NULL,'15.5',0.62,'E',NULL,NULL,NULL,NULL,1,349.0327917,-44.70222,NULL,NULL,50532308819,789567325,12336989,15.5),(160916,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',160916,32.53,0.49,32,75401,75,NULL,'IR','NGC 7567',NULL,'2011yCatp016004901K',2011,1,0.9,'Beers, et al. (1991,AJ,102,1581) give v=12110 +/- 59 km/sec.','G',0.000017,NULL,'15.38',0.2,'Irr','Group member',NULL,NULL,NULL,1,349.042833,15.85003,0.153,NULL,52522438486,820663101,12822860,15.38),(160917,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160917,30.85,NULL,14.8,75402,NULL,NULL,'B','NGC 7552',NULL,'2002ApJ...565..681R',2002,1,3.4,'Confused HIPASS source','G',0.000017,NULL,'11.25',2.7,'(R\')SB(s)ab;HIILINER','X-ray-faint group member',NULL,NULL,'H II',1,349.044833,-42.58475,NULL,NULL,50526093940,789470217,12335472,11.25),(160918,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160918,31.45,0.4,19.5,75402,75,NULL,'B','NGC 7552',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160919,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',160919,37.71,0.46,349,75403,70,NULL,NULL,'2MASX J23161160+1410316',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,349.048458333,14.17533,0.129,NULL,52515562709,820555667,12821182,17.4),(160920,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 21069','RN',160920,42.69,0.35,2340,75404,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21069',0.473334,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160921,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 21069','N',160921,42.72,0.23,3500,75404,70,NULL,'SALT 2','SDSS-II SN 21069',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160922,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 21069','N',160922,42.83,0.23,3680,75404,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 21069',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160923,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',160923,37.48,0.46,313,75405,70,NULL,NULL,'2MASX J23161565+1359297',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,349.065375,13.99144,0.121,NULL,52515468475,820554194,12821159,17.2),(160924,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',160924,37.12,0.46,266,75406,70,NULL,NULL,'2MASX J23161803-1049231',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000095,NULL,'15.8g',0.4,'E0',NULL,NULL,NULL,NULL,1,349.075375,-10.82306,0.075,NULL,49593780013,774902812,12107856,15.8),(160925,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 03227','RN',160925,43.35,0.2,3320,75407,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03227',0.411614,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160926,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 03227','RN',160926,44.43,0.33,5450,75407,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03227',0.411614,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160927,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160927,35.23,0.8,111,75408,75,NULL,'MAT, I','NGC 7568',NULL,'1997ApJS..109..333W',1997,1,0.9,'Identification as NGC 7574 is doubtful.','G',0.000027,NULL,'14.52',0.5,'S?','in a radial-velocity based grouping',NULL,NULL,NULL,1,349.103625,24.49703,0.249,NULL,51979867165,812185424,12690397,14.52),(160928,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160928,35.24,0.8,112,75408,75,NULL,'W91PP, r','NGC 7568',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160929,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160929,35.1,0.38,105,75408,75,NULL,'W91PP, r, raw','NGC 7568',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160930,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160930,35.17,0.43,108,75408,75,NULL,'MAT, I, raw','NGC 7568',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160931,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160931,35.21,0.32,110,75408,85,NULL,'I, raw','NGC 7568',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160932,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160932,35.23,0.39,111,75408,NULL,NULL,'Malmquist cor.','NGC 7568',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160933,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160933,35.27,0.38,113,75408,NULL,NULL,NULL,'NGC 7568',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160934,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160934,35.28,0.32,114,75408,85,NULL,'I, inv','NGC 7568',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160935,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160935,35.28,0.38,114,75408,75,NULL,'W91PP, r, cor','NGC 7568',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160936,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160936,35.31,0.38,116,75408,75,NULL,'W91PP, r, inv','NGC 7568',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160937,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160937,35.4,0.43,120,75408,75,NULL,'MAT, I, cor','NGC 7568',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160938,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160938,35.45,0.43,123,75408,75,NULL,'MAT, I, inv','NGC 7568',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160939,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160939,35.47,0.2,124,75408,74.4,NULL,NULL,'NGC 7568',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160940,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',160940,35.47,0.49,124,75409,75,NULL,'IR','2MFGC 17463',NULL,'2011yCatp016004901K',2011,1,0.62,NULL,'G',0.000033,NULL,'16.5V',NULL,'Sc',NULL,NULL,NULL,NULL,1,349.105583,18.47067,0.189,NULL,52532948831,820827325,12825426,16.5),(160941,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160941,35.63,0.57,134,75409,NULL,NULL,NULL,'2MFGC 17463',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160942,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160942,35.67,0.2,136,75409,74.4,NULL,NULL,'2MFGC 17463',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160943,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160943,35.84,0.52,147,75409,NULL,NULL,'Malmquist cor.','2MFGC 17463',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160944,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 06003','RN',160944,43.22,0.24,2990,75410,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 06003',0.47867,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160945,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160945,32.28,0.2,28.6,75411,74.4,NULL,NULL,'UGC 12471',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000017,NULL,'16.0',0.2,'S',NULL,NULL,NULL,NULL,1,349.117875,18.5625,0.189,NULL,52532992264,820828004,12825437,16),(160946,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160946,32.57,0.7,32.7,75411,NULL,NULL,NULL,'UGC 12471',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160947,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160947,32.9,0.6,38.1,75411,NULL,NULL,'Malmquist cor.','UGC 12471',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160948,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2007qi',NULL,160948,40.09,0.15,1040,75412,70,NULL,'Hubble residual 0.04 for z0.27640','SDSS J231628.81-000556.0',NULL,'2011ApJ...740...92G',2011,1,0.09,NULL,'G',0.0005,NULL,'20.5g',0.07,NULL,NULL,NULL,NULL,NULL,1,349.1200417,-0.09892,0.109,NULL,49409128642,772017635,12062775,20.5),(160949,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 20227','R',160949,40.8,0.23,1130,75412,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007qi','SDSS J231628.81-000556.0',0.2764,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160950,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2007qi',NULL,160950,40.6,0.13,1320,75412,70,NULL,'SALT 2','SDSS J231628.81-000556.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160951,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2007qi',NULL,160951,40.63,0.13,1340,75412,70,NULL,'SALT 2, Malmquist cor.','SDSS J231628.81-000556.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160952,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 20227','R',160952,41.17,0.17,1350,75412,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007qi','SDSS J231628.81-000556.0',0.2764,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160953,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',160953,33,0.49,39.8,75413,75,NULL,'IR','KUG 2313+117',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',NULL,NULL,'15.6',0.2,'Spiral',NULL,NULL,NULL,NULL,1,349.1287917,12.05114,0.105,NULL,51624410195,806631409,12603615,15.6),(160954,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005id',NULL,160954,39.07,0.03,547,75414,70,NULL,'SDSS-II SN 06422','SDSS J231633.32-003948.3',0.19,'2011ApJS..192....1C',2011,1,0.08,NULL,'G',NULL,NULL,'21.2g',0.04,NULL,NULL,NULL,NULL,NULL,1,349.138833,-0.66344,0.097,NULL,49627184365,775424755,12116011,21.2),(160955,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005id',NULL,160955,39.09,0.11,553,75414,74.2,NULL,'SALT 2','SDSS J231633.32-003948.3',0.19,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160956,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005id',NULL,160956,39.78,0.12,760,75414,70,NULL,'SDSS-II SN 06422, SALT 2','SDSS J231633.32-003948.3',0.19,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160957,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 06422','R',160957,39.82,0.18,772,75414,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005id','SDSS J231633.32-003948.3',0.19,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160958,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005id',NULL,160958,39.82,0.07,775,75414,65,NULL,'SALT2','SDSS J231633.32-003948.3',0.19,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160959,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005id',NULL,160959,39.99,0.07,838,75414,65,NULL,'MLCS2k2','SDSS J231633.32-003948.3',0.19,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160960,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 06422','R',160960,40.09,0.08,876,75414,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005id','SDSS J231633.32-003948.3',0.19,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160961,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005id',NULL,160961,39.73,0.07,883,75414,70,NULL,'SALT 2','SDSS J231633.32-003948.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160962,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005id',NULL,160962,39.74,0.07,887,75414,70,NULL,'SALT 2, Malmquist cor.','SDSS J231633.32-003948.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160963,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 15081','RN',160963,40.96,0.18,1320,75415,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15081',0.18222,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160964,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 15081','RN',160964,41.69,0.23,1850,75415,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15081',0.18222,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160965,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160965,34.94,0.47,97.4,75416,NULL,NULL,'H','NGC 7566',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000073,NULL,'14.27',0.7,'(R\')SB(rs)apec?Sy2',NULL,NULL,NULL,'Sy 2',1,349.1559583,-2.33056,0.085,NULL,49629089305,775454520,12116476,14.27),(160966,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160966,34.97,0.45,98.8,75416,NULL,NULL,'K','NGC 7566',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160967,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160967,35,0.46,100,75416,NULL,NULL,'J','NGC 7566',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160968,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160968,35.14,0.4,107,75416,NULL,NULL,'mean','NGC 7566',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160969,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160969,35.23,0.2,111,75417,74.4,NULL,NULL,'CGCG 454-019',NULL,'2013AJ....146...86T',2013,1,0.6,'Beers, et al. (1991,AJ,102,1581) give v=4217 +/- 36 km/sec.','G',0.000033,NULL,'15.46',0.2,'S?','Group member',NULL,NULL,NULL,1,349.1605,15.89764,0.153,NULL,52522439738,820663120,12822861,15.46),(160970,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160970,35.24,0.41,112,75417,NULL,NULL,NULL,'CGCG 454-019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160971,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160971,35.24,0.41,112,75417,NULL,NULL,'Malmquist cor.','CGCG 454-019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160972,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 12199','RN',160972,40.9,0.28,1160,75418,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 12199',0.310404,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160973,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 12199','RN',160973,41.17,0.28,1310,75418,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 12199',0.310404,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160974,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 12199','N',160974,41.08,0.23,1640,75418,70,NULL,'SALT 2','SDSS-II SN 12199',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160975,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 12199','N',160975,41.12,0.23,1670,75418,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 12199',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160976,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160976,33.12,0.47,42.2,75419,NULL,NULL,'H','UGC 12474',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000067,NULL,'14.24',0.4,'Sa','Isolated galaxy',NULL,NULL,NULL,1,349.180167,33.99581,0.261,NULL,52052870001,813326093,12708220,14.24),(160977,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160977,33.18,0.45,43.3,75419,NULL,NULL,'K','UGC 12474',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160978,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160978,33.37,0.46,47.2,75419,NULL,NULL,'J','UGC 12474',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160979,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160979,34.18,0.4,68.5,75419,NULL,NULL,'mean','UGC 12474',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160980,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160980,35.01,0.4,100,75420,NULL,NULL,'mean','ARK 579',NULL,'2007A&A...465...71T',2007,1,0.4,NULL,'G',0.000033,NULL,'15.72',0.2,'S?',NULL,NULL,NULL,NULL,1,349.182083,29.58756,0.265,NULL,52065202554,813518789,12711231,15.72),(160981,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160981,36.09,0.46,165,75420,NULL,NULL,'J','ARK 579',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160982,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160982,36.1,0.47,166,75420,NULL,NULL,'H','ARK 579',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160983,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160983,36.14,0.45,169,75420,NULL,NULL,'K','ARK 579',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160984,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160984,31.22,0.43,17.5,75421,NULL,NULL,'Malmquist cor.','NGC 7570',NULL,'2009ApJS..182..474S',2009,1,1.61,NULL,'G',0.00002,NULL,'13.8g',0.74,'SBa','in a radial-velocity based grouping',NULL,NULL,NULL,1,349.186125,13.483,0.125,NULL,52516871838,820576122,12821501,13.8),(160985,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160985,31.27,0.42,17.9,75421,NULL,NULL,NULL,'NGC 7570',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160986,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160986,31.61,0.4,21,75421,73,NULL,'opt','NGC 7570',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160987,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160987,33.28,0.47,45.3,75421,NULL,NULL,'H','NGC 7570',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160988,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160988,33.43,0.46,48.6,75421,NULL,NULL,'J','NGC 7570',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160989,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160989,33.47,0.45,49.3,75421,NULL,NULL,'K','NGC 7570',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160990,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160990,33.89,0.4,59.9,75421,NULL,NULL,'mean','NGC 7570',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160991,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160991,34.95,0.5,97.8,75422,70,NULL,NULL,'2MASX J23164533-1852569',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'15.50',0.42,NULL,NULL,NULL,NULL,NULL,1,349.189167,-18.88267,0.079,NULL,50318582357,786227849,12284810,15.5),(160992,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',160992,35.87,0.46,149,75423,70,NULL,NULL,'SDSS J231647.75+153459.8',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',NULL,NULL,'15.5g',0.33,'S0/a',NULL,NULL,NULL,NULL,1,349.199,15.58328,0.113,NULL,52527088200,820735753,12823996,15.5),(160993,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 05671','RN',160993,37.59,0.69,286,75424,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05671',0.151557,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160994,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 15413','RN',160994,40.05,0.06,955,75425,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15413',0.073616,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160995,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 15413','RN',160995,40.44,0.25,1140,75425,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15413',0.073616,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160996,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 1995ae',NULL,160996,37.54,0.34,301,75426,65,NULL,NULL,'APMUKS(BJ) B231421.60-022058.7',0.06895,'2004ApJ...607..665R',2004,1,0.29,NULL,'G',NULL,NULL,'18.12',0.18,NULL,NULL,NULL,NULL,NULL,1,349.233375,-2.07692,0.101,NULL,49628719680,775448745,12116386,18.12),(160997,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 1995ae',NULL,160997,37.58,0.21,328,75426,65,NULL,'Snapshot','APMUKS(BJ) B231421.60-022058.7',NULL,'1998ApJ...504..935R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160998,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',160998,37.47,0.33,312,75427,70,NULL,NULL,'2MASX J23165839-0900337',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000096,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,349.24325,-9.00939,0.069,NULL,49608081265,775126269,12111347,16.6),(160999,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',160999,33.43,0.49,48.6,75428,75,NULL,'IR','UGC 12475',NULL,'2011yCatp016004901K',2011,1,1.88,'FGC has two entries for this object.','G',0.000013,NULL,'15.41',0.25,'Sbc',NULL,NULL,NULL,NULL,1,349.245625,3.70975,0.213,NULL,51768125998,808876968,12638702,15.41),(161000,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161000,33.62,NULL,53,75428,NULL,NULL,'Dipole','UGC 12475',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161001,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161001,33.63,NULL,53.3,75428,NULL,NULL,'Dipole + Quadrupole','UGC 12475',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161002,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161002,33.63,NULL,53.3,75428,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12475',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161003,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161003,33.83,NULL,58.4,75428,NULL,NULL,NULL,'UGC 12475',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161004,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161004,36.49,0.74,198,75429,70,NULL,NULL,'2MASX J23170075-0223292',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'17.14',0.16,NULL,NULL,NULL,NULL,NULL,1,349.253125,-2.39136,0.085,NULL,49629059884,775454060,12116469,17.14),(161005,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161005,37.45,0.46,309,75430,70,NULL,NULL,'2MASX J23170177+0107159',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000094,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,349.2574583,1.12119,0.145,NULL,51758550318,808727348,12636364,16.6),(161006,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161006,38.47,0.46,494,75431,70,NULL,NULL,'2MASXi J2317039-083053',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000081,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,349.266541667,-8.51481,0.073,NULL,49603340894,775052201,12110190,17.8),(161007,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161007,33.46,0.2,49.2,75432,74.4,NULL,NULL,'CGCG 406-042',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000023,NULL,'15.66',0.6,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,349.2730417,7.12283,0.197,NULL,51745470131,808522970,12633171,15.66),(161008,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161008,33.48,0.43,49.7,75432,75,NULL,'3.6 micron, color corrected','CGCG 406-042',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161009,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161009,33.48,0.43,49.7,75432,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 406-042',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161010,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161010,33.52,0.11,50.7,75432,NULL,NULL,NULL,'CGCG 406-042',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161011,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161011,34.85,0.45,93.5,75433,NULL,NULL,'K','NGC 7578B',NULL,'2007A&A...465...71T',2007,1,1,'Incorrectly identified as UGC 12477 in 1989ApJS...70..687H.','G',0.000107,NULL,'13.3V',1,'E1:;BrClG','Pair member, contact system',NULL,NULL,NULL,1,349.3065,18.70825,0.169,NULL,52533079747,820829371,12825458,13.3),(161012,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161012,35.95,0.4,155,75433,NULL,NULL,'mean','NGC 7578B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161013,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161013,34.71,0.62,87.4,75434,NULL,NULL,NULL,'2MASX J23171540+1843385',NULL,'2009ApJS..182..474S',2009,1,0.49,NULL,'G',0.000344,NULL,'16.9V',0.12,'Sd','Compact group member',NULL,NULL,NULL,1,349.3142917,18.72742,0.153,NULL,52533079941,820829374,12825458,16.9),(161014,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161014,34.75,0.61,89.1,75434,NULL,NULL,'Malmquist cor.','2MASX J23171540+1843385',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161015,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161015,34.75,0.2,89.1,75434,74.4,NULL,NULL,'2MASX J23171540+1843385',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161016,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161016,38.01,0.46,400,75435,70,NULL,NULL,'2MASX J23171908-0839124',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000092,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,349.329583,-8.65364,0.073,NULL,49607726802,775120731,12111261,17.3),(161017,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161017,38.43,0.46,486,75436,70,NULL,NULL,'2MASX J23172100+1519256',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000176,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,349.337458333,15.32367,0.113,NULL,52527032544,820734883,12823982,17.3),(161018,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161018,37.87,0.46,374,75437,70,NULL,NULL,'2MASX J23172121+1454206',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000186,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,349.338416667,14.90581,0.125,NULL,52526696430,820729631,12823900,16.7),(161019,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161019,36.26,0.19,179,75438,70,NULL,NULL,'GIN 678',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.000167,NULL,'16.2V',NULL,'S',NULL,NULL,NULL,NULL,1,349.33925,18.94164,0.153,NULL,52533099964,820829686,12825463,16.2),(161020,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161020,35.31,0.46,115,75439,NULL,NULL,NULL,'KUG 2314+181',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000017,NULL,'15.2V',0.45,'Spiral','Group member',NULL,NULL,NULL,1,349.3395,18.42367,0.169,NULL,52533460776,820835324,12825551,15.2),(161021,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161021,35.32,0.46,116,75439,NULL,NULL,'Malmquist cor.','KUG 2314+181',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161022,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161022,35.35,0.2,117,75439,74.4,NULL,NULL,'KUG 2314+181',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161023,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161023,37.47,0.33,312,75440,70,NULL,NULL,'2MASX J23172159-0907554',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000069,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,349.339875,-9.13194,0.061,NULL,49608122679,775126916,12111358,17.4),(161024,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161024,34.25,0.2,70.8,75441,74.4,NULL,NULL,'UGC 12479',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.00003,NULL,'15.14',0.3,'Sa             HII',NULL,NULL,NULL,NULL,1,349.357,-1.58617,0.097,NULL,49630862795,775482231,12116909,15.14),(161025,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161025,34.26,0.42,71.1,75441,NULL,NULL,NULL,'UGC 12479',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161026,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161026,34.36,0.4,74.4,75441,NULL,NULL,'Malmquist cor.','UGC 12479',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161027,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 14654','RN',161027,41.75,0.26,1620,75442,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14654',0.381922,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161028,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 14654','RN',161028,41.82,0.22,1670,75442,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14654',0.381922,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161029,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161029,37.73,0.46,352,75443,70,NULL,NULL,'2MASX J23172591-0916234',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000074,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,349.3579583,-9.27319,0.061,NULL,49608029844,775125466,12111335,17.4),(161030,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005fh',NULL,161030,37.85,0.11,332,75444,74.2,NULL,'SALT 2','2MASX J23172973+0025473',0.119128,'2010ApJ...716..712A',2010,1,0.2,NULL,'G',0.00012,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,349.37375,0.42967,0.121,NULL,51573339082,805833423,12591147,18.5),(161031,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005fh',NULL,161031,37.94,0.03,346,75444,70,NULL,'SDSS-II SN 01371','2MASX J23172973+0025473',0.119128,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161032,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005fh',NULL,161032,38.23,0.06,442,75444,70,NULL,'Hubble residual -0.18 for z0.11915','2MASX J23172973+0025473',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161033,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005fh',NULL,161033,38.55,0.12,458,75444,70,NULL,'SDSS-II SN 01371, SALT 2','2MASX J23172973+0025473',0.119128,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161034,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005fh',NULL,161034,38.57,0.07,463,75444,65,NULL,'SALT2','2MASX J23172973+0025473',0.119128,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161035,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 01371','R',161035,38.58,0.18,466,75444,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fh','2MASX J23172973+0025473',0.11915,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161036,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005fh',NULL,161036,38.48,0.06,497,75444,70,NULL,'SALT 2','2MASX J23172973+0025473',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161037,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005fh',NULL,161037,38.49,0.06,499,75444,70,NULL,'SALT 2, Malmquist cor.','2MASX J23172973+0025473',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161038,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005fh',NULL,161038,38.74,0.07,501,75444,65,NULL,'MLCS2k2','2MASX J23172973+0025473',0.119128,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161039,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 01371','R',161039,38.76,0.07,505,75444,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fh','2MASX J23172973+0025473',0.11915,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161040,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161040,33.85,0.4,58.9,75445,NULL,NULL,'mean','NGC 7580',NULL,'2007A&A...465...71T',2007,1,0.8,NULL,'G',0.000007,NULL,'14.2g',0.67,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,349.401667,14.00119,0.113,NULL,52516050266,820563285,12821301,14.2),(161041,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161041,34.51,0.47,79.8,75445,NULL,NULL,'H','NGC 7580',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161042,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161042,35.41,0.5,121,75446,70,NULL,NULL,'2MASX J23173698-0645464',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'15.92',0.28,NULL,NULL,NULL,NULL,NULL,1,349.403875,-6.76289,0.081,NULL,49602473437,775038647,12109978,15.92),(161043,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161043,32.72,0.8,35,75447,75,NULL,'MAT, I','ESO 407- G 014',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000023,NULL,'13.90',1.1,'SB(s)c?        HII','Isolated galaxy',NULL,NULL,NULL,1,349.4147917,-34.79081,NULL,NULL,50153485825,783648216,12244503,13.9),(161044,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161044,32.52,0.4,31.9,75447,NULL,NULL,NULL,'ESO 407- G 014',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161045,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161045,32.52,0.4,31.9,75447,73,NULL,'opt','ESO 407- G 014',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161046,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161046,32.55,0.32,32.3,75447,85,NULL,'I, raw','ESO 407- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161047,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161047,32.55,0.32,32.4,75447,85,NULL,'I, inv','ESO 407- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161048,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161048,32.77,0.43,35.8,75447,75,NULL,'3.6 micron, color + selection bias corrected','ESO 407- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161049,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161049,32.81,0.4,36.4,75447,73,NULL,'opt','ESO 407- G 014',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161050,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161050,32.82,0.43,36.7,75447,75,NULL,'MAT, I, raw','ESO 407- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161051,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161051,32.83,0.43,36.9,75447,75,NULL,'3.6 micron, color corrected','ESO 407- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161052,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161052,32.9,0.62,37.9,75447,NULL,NULL,'Malmquist cor.','ESO 407- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161053,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161053,32.92,0.2,38.4,75447,74.4,NULL,NULL,'ESO 407- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161054,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161054,32.92,0.43,38.4,75447,75,NULL,'MAT, I, inv','ESO 407- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161055,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161055,32.99,0.43,39.6,75447,75,NULL,'MAT, I, cor','ESO 407- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161056,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161056,33.05,0.4,40.8,75447,NULL,NULL,'mean','ESO 407- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161057,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161057,33.13,0.55,42.3,75447,NULL,NULL,NULL,'ESO 407- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161058,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161058,33.29,0.47,45.5,75447,NULL,NULL,'H','ESO 407- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161059,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161059,33.38,0.46,47.4,75447,NULL,NULL,'J','ESO 407- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161060,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161060,33.47,0.45,49.4,75447,NULL,NULL,'K','ESO 407- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161061,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 06861','R',161061,39.71,0.25,734,75448,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 06861',0.191046,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,349.432208333,-1.11353,0.089,NULL,49627696646,775432760,12116136,NULL),(161062,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 06861','R',161062,39.95,0.17,819,75448,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 06861',0.191046,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161063,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161063,33.59,0.49,52.3,75449,75,NULL,'IR','FGC 2481',NULL,'2011yCatp016004901K',2011,1,0.95,NULL,'G',NULL,NULL,'16.6',0.12,'Sc',NULL,NULL,NULL,NULL,1,349.434333,7.48839,0.161,NULL,51749092318,808579567,12634055,16.6),(161064,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 05172','RN',161064,40.83,0.22,1270,75450,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 05172',0.158215,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161065,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 05172','RN',161065,41.49,0.27,1720,75450,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 05172',0.158215,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161066,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161066,36.89,0.65,239,75451,70,NULL,NULL,'LCRS B231507.5-444239',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.47',0.43,NULL,NULL,NULL,NULL,NULL,1,349.4737917,-44.43792,NULL,NULL,50529575428,789524616,12336322,16.47),(161067,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2007oy',NULL,161067,40.14,0.15,1070,75452,70,NULL,'SALT 2','SDSS J231755.53+011325.1',NULL,'2013ApJ...763...88C',2013,1,0.03,NULL,'G',0.005,NULL,'22.5g',0.02,NULL,NULL,NULL,NULL,NULL,1,349.481375,1.22364,0.133,NULL,51758066659,808719791,12636246,22.5),(161068,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2007oy',NULL,161068,40.16,0.15,1080,75452,70,NULL,'SALT 2, Malmquist cor.','SDSS J231755.53+011325.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161069,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2007oy',NULL,161069,40.38,0.26,1190,75452,70,NULL,'Hubble residual -0.35 for z0.40300','SDSS J231755.53+011325.1',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161070,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19757','R',161070,41.42,0.27,1370,75452,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007oy','SDSS J231755.53+011325.1',0.403,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161071,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19757','R',161071,41.45,0.23,1390,75452,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007oy','SDSS J231755.53+011325.1',0.403,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161072,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161072,33.51,0.8,50.3,75453,75,NULL,'MAT, I','NGC 7593',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000023,NULL,'14.30',0.6,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,349.4874583,11.34917,0.101,NULL,51741510476,808461101,12632204,14.3),(161073,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161073,33.52,0.8,50.5,75453,75,NULL,'HMCL, I','NGC 7593',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161074,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161074,33.29,0.32,45.6,75453,85,NULL,'I, raw','NGC 7593',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161075,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161075,33.32,0.32,46.1,75453,85,NULL,'I, inv','NGC 7593',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161076,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161076,33.39,0.43,47.6,75453,75,NULL,'MAT, I, raw','NGC 7593',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161077,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161077,33.49,0.08,50,75453,NULL,NULL,NULL,'NGC 7593',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161078,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161078,33.51,0.43,50.2,75453,75,NULL,'MAT, I, inv','NGC 7593',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161079,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161079,33.57,0.43,51.8,75453,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7593',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161080,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161080,33.69,0.43,54.6,75453,75,NULL,'MAT, I, cor','NGC 7593',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161081,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161081,33.7,0.43,54.9,75453,75,NULL,'3.6 micron, color corrected','NGC 7593',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161082,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161082,33.75,0.4,56.2,75453,NULL,NULL,'mean','NGC 7593',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161083,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161083,33.86,0.2,59.2,75453,74.4,NULL,NULL,'NGC 7593',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161084,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161084,33.92,0.4,60.8,75453,75,NULL,'HMCL, I, raw','NGC 7593',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161085,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161085,34,0.47,63.1,75453,NULL,NULL,'H','NGC 7593',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161086,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161086,34.05,0.4,64.7,75453,75,NULL,'HMCL, I, inv','NGC 7593',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161087,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161087,34.05,0.46,64.7,75453,NULL,NULL,'J','NGC 7593',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161088,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161088,34.07,0.4,65.1,75453,75,NULL,'HMCL, I, cor','NGC 7593',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161089,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161089,37.13,0.46,267,75454,70,NULL,NULL,'2MASX J23175716-1008384',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000111,NULL,'15.8g',0.42,'BrClG',NULL,NULL,NULL,NULL,1,349.488208333,-10.14417,0.063,NULL,49596840268,774950629,12108603,15.8),(161090,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161090,36.93,0.7,244,75455,70,NULL,NULL,'2MFGC 17482',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'16.92',0.16,NULL,NULL,NULL,NULL,NULL,1,349.490875,-19.73394,0.103,NULL,50309027107,786078548,12282477,16.92),(161091,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 15726',NULL,161091,40.73,0.75,1400,75456,70,NULL,'SN photometric redshift distance, z photo =0.403 +/- 0.243','SDSS-II SN 15726',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,349.494625,-0.00728,0.105,NULL,49409491503,772023304,12062864,NULL),(161092,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161092,35.18,0.4,108,75457,NULL,NULL,'Malmquist cor.','NGC 7587',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'14.78',0.3,'SBab: sp','Pair member (points to parent)',NULL,NULL,NULL,1,349.496375,9.68019,0.097,NULL,51756155334,808689927,12635780,14.78),(161093,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161093,35.33,0.38,116,75457,NULL,NULL,NULL,'NGC 7587',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161094,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161094,35.37,0.2,119,75457,74.4,NULL,NULL,'NGC 7587',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161095,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161095,33.16,0.45,42.9,75458,NULL,NULL,'K','NGC 7585',NULL,'2007A&A...465...71T',2007,1,2.3,NULL,'G',0.000003,NULL,'12.50',2,'(R\')SA(s)0+ pec','Pair member, contact system',NULL,NULL,NULL,1,349.505583,-4.65031,0.105,NULL,49635332717,775552073,12118001,12.5),(161096,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161096,33.33,0.4,46.4,75458,NULL,NULL,'mean','NGC 7585',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161097,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161097,38.07,0.46,410,75459,70,NULL,NULL,'2MASX J23180177+1457400',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,349.507333,14.96111,0.109,NULL,52528573479,820758960,12824358,17.6),(161098,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161098,34.69,0.46,86.6,75460,70,NULL,NULL,'CGCG 380-023',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.000096,NULL,'14.4g',0.77,'poss. LINER',NULL,NULL,NULL,NULL,1,349.534958333,-0.3905,0.109,NULL,49409886747,772029480,12062960,14.4),(161099,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161099,34.74,0.48,88.7,75460,70,NULL,NULL,'CGCG 380-023',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161100,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161100,37.9,0.46,381,75461,70,NULL,NULL,'2MASX J23180887-0852584',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000069,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,349.536916667,-8.88294,0.057,NULL,49607816838,775122138,12111283,17.9),(161101,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161101,37.3,0.58,288,75462,70,NULL,NULL,'2MASX J23180893-4804539',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,349.53725,-48.08158,NULL,NULL,50521042311,789391286,12334238,14.5),(161102,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161102,36.64,0.2,213,75463,74.4,NULL,NULL,'CGCG 431-036 NED01',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',NULL,NULL,'12.1K',0.1,NULL,NULL,NULL,NULL,NULL,1,349.542333,10.25106,0.105,NULL,51744339677,808505307,12632895,12.1),(161103,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161103,36.31,0.33,182,75464,NULL,NULL,'Malmquist cor.','UGC 12485 NOTES02 NED01',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'GPair',NULL,NULL,NULL,NULL,'S?','Group member',NULL,NULL,NULL,1,349.54475,10.24847,0.105,NULL,51744339632,808505306,12632895,NULL),(161104,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161104,36.51,0.3,201,75464,NULL,NULL,NULL,'UGC 12485 NOTES02 NED01',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161105,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161105,35.75,0.8,142,75465,75,NULL,'CF, r','NGC 7594',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00003,NULL,'14.58',0.9,'Sb','Group member',NULL,NULL,NULL,1,349.558,10.29831,0.109,NULL,51744338504,808505289,12632895,14.58),(161106,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161106,35.08,0.69,104,75465,100,NULL,'mid-IR','NGC 7594',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161107,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161107,35.24,0.38,112,75465,75,NULL,'CF, r, raw','NGC 7594',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161108,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161108,35.4,0.46,120,75465,NULL,NULL,'Malmquist cor.','NGC 7594',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161109,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161109,35.46,0.38,124,75465,75,NULL,'CF, r, inv','NGC 7594',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161110,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161110,35.55,0.43,129,75465,NULL,NULL,NULL,'NGC 7594',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161111,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161111,35.55,0.38,129,75465,75,NULL,'CF, r, cor','NGC 7594',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161112,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161112,35.83,0.2,147,75465,74.4,NULL,NULL,'NGC 7594',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161113,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161113,35.94,0.4,154,75465,NULL,NULL,'mean','NGC 7594',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161114,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161114,35.96,0.47,155,75465,NULL,NULL,'H','NGC 7594',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161115,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161115,36.03,0.45,161,75465,NULL,NULL,'K','NGC 7594',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161116,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161116,36.08,0.46,165,75465,NULL,NULL,'J','NGC 7594',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161117,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 16218','RN',161117,38.62,0.34,515,75466,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 16218',0.029655,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161118,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 16218','RN',161118,38.8,0.2,560,75466,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 16218',0.029655,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161119,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161119,35.46,0.2,124,75467,74.4,NULL,NULL,'NGC 7589',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000067,NULL,'14.8g',0.59,'SAB(rs)a:;GLSBGBLAGN',NULL,NULL,NULL,'Sy 1',1,349.5652917,0.26117,0.125,NULL,51574143592,805845993,12591343,14.8),(161120,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161120,38.33,0.33,463,75468,70,NULL,NULL,'SDSS J231816.22+144413.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,349.567583333,14.73706,0.125,NULL,52528460552,820757196,12824331,18.1),(161121,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161121,33.97,0.8,62.3,75469,75,NULL,'MAT, I','NGC 7591',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000013,NULL,'13.86',0.8,'SBbc;Sy;LIRG   LINER','in a pair',NULL,NULL,'Sy',1,349.567833333,6.58581,0.177,NULL,51800265415,809379147,12646549,13.86),(161122,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161122,33.98,0.8,62.4,75469,75,NULL,'W91CL, r','NGC 7591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161123,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161123,33.98,0.8,62.4,75469,75,NULL,'HMCL, I','NGC 7591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161124,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161124,34,0.8,63.2,75469,75,NULL,'CF, r','NGC 7591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161125,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161125,33.56,0.47,51.6,75469,NULL,NULL,'H','NGC 7591',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161126,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161126,33.57,0.45,51.7,75469,NULL,NULL,'K','NGC 7591',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161127,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161127,33.63,0.46,53.1,75469,NULL,NULL,'J','NGC 7591',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161128,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161128,33.63,0.43,53.2,75469,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7591',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161129,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161129,33.78,0.43,56.9,75469,75,NULL,'3.6 micron, color corrected','NGC 7591',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161130,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161130,33.92,0.38,60.8,75469,NULL,NULL,NULL,'NGC 7591',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161131,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161131,33.93,0.2,61.1,75469,74.4,NULL,NULL,'NGC 7591',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161132,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161132,33.97,0.38,62.3,75469,75,NULL,'W91CL, r, raw','NGC 7591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161133,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161133,33.98,0.37,62.6,75469,NULL,NULL,'Malmquist cor.','NGC 7591',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161134,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161134,33.99,0.32,62.7,75469,85,NULL,'I, raw','NGC 7591',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161135,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161135,34.01,0.4,63.4,75469,75,NULL,'HMCL, I, raw','NGC 7591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161136,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161136,34.02,0.43,63.7,75469,75,NULL,'MAT, I, raw','NGC 7591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161137,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161137,34.04,0.4,64.1,75469,NULL,NULL,'mean','NGC 7591',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161138,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161138,34.05,0.32,64.7,75469,85,NULL,'I, inv','NGC 7591',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161139,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161139,34.15,0.38,67.7,75469,75,NULL,'W91CL, r, inv','NGC 7591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161140,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161140,34.17,0.38,68.3,75469,75,NULL,'W91CL, r, cor','NGC 7591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161141,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161141,34.23,0.4,70.1,75469,75,NULL,'HMCL, I, inv','NGC 7591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161142,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161142,34.25,0.4,70.7,75469,75,NULL,'HMCL, I, cor','NGC 7591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161143,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161143,34.29,0.43,72.1,75469,75,NULL,'MAT, I, cor','NGC 7591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161144,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161144,34.3,0.43,72.6,75469,75,NULL,'MAT, I, inv','NGC 7591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161145,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161145,34.31,0.38,72.9,75469,75,NULL,'CF, r, raw','NGC 7591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161146,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161146,34.49,0.38,79.2,75469,75,NULL,'CF, r, cor','NGC 7591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161147,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161147,34.52,0.38,80.3,75469,75,NULL,'CF, r, inv','NGC 7591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161148,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161148,32.65,0.49,33.9,75470,75,NULL,'IR','MCG -01-59-016',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.00015,NULL,'15.09',0.3,'Sc',NULL,NULL,NULL,NULL,1,349.571667,-3.62667,0.117,NULL,49642116837,775658075,12119657,15.09),(161149,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161149,38.65,0.46,536,75471,70,NULL,NULL,'2MASX J23181777-0109060',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000115,NULL,'17.2g',0.25,'AGN',NULL,NULL,NULL,NULL,1,349.574,-1.15164,0.081,NULL,49627738722,775433417,12116147,17.2),(161150,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161150,38.58,0.33,521,75472,70,NULL,NULL,'SDSS J231818.85+134106.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,349.578583,13.68528,0.109,NULL,52515966779,820561980,12821280,18.5),(161151,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161151,35.62,0.4,133,75473,NULL,NULL,'mean','ESO 604- G 010',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000033,NULL,'14.72',0.9,'SB(r)a',NULL,NULL,NULL,NULL,1,349.5807917,-21.17486,0.059,NULL,50311516219,786117440,12283085,14.72),(161152,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161152,35.66,0.37,135,75473,NULL,NULL,'Malmquist cor.','ESO 604- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161153,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161153,35.79,0.47,144,75473,NULL,NULL,'H','ESO 604- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161154,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161154,36.03,0.31,161,75473,NULL,NULL,NULL,'ESO 604- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161155,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161155,36.07,0.2,164,75473,74.4,NULL,NULL,'ESO 604- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161156,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 13850','RN',161156,40.4,0.15,1010,75474,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13850',0.189043,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161157,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 13850','RN',161157,41,0.22,1330,75474,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13850',0.189043,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161158,'Sosies','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161158,31.49,0.1,19.9,75475,NULL,NULL,NULL,'NGC 7582',NULL,'2002A&A...393...57T',2002,1,5,NULL,'G',0.000023,NULL,'11.37',2.1,'(R\'_1)SB(s)ab  Sy2','X-ray-faint group member',NULL,NULL,'Sy 1 i',1,349.597917,-42.37056,NULL,NULL,50527863666,789497869,12335904,11.37),(161159,'Tully est','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161159,31.23,0.8,17.6,75475,75,NULL,'B','NGC 7582',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161160,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161160,31.71,0.41,22,75475,NULL,NULL,NULL,'NGC 7582',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161161,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161161,31.73,0.39,22.2,75475,73,NULL,'opt','NGC 7582',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161162,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161162,31.76,0.2,22.5,75475,74.4,NULL,NULL,'NGC 7582',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161163,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161163,31.81,0.4,23,75475,NULL,NULL,'Malmquist cor.','NGC 7582',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161164,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161164,31.92,NULL,24.2,75475,NULL,NULL,'LEDA [April 2006]','NGC 7582',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161165,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161165,36.27,0.13,179,75476,70,NULL,NULL,'ABELL 2572',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,349.5982917,18.74019,0.133,NULL,52533555544,820836805,12825575,NULL),(161166,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161166,38.58,0.33,521,75477,70,NULL,NULL,'2MASX J23182444+1340186',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000147,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,349.601916667,13.67181,0.109,NULL,52515962949,820561921,12821280,17.3),(161167,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161167,35.35,0.49,117,75478,75,NULL,'IR','KUG 2315+198',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.47',0.3,'Spiral',NULL,NULL,NULL,NULL,1,349.605833,20.16361,0.181,NULL,52502137948,820345905,12817904,15.47),(161168,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161168,35.75,0.45,141,75478,NULL,NULL,'Malmquist cor.','KUG 2315+198',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161169,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161169,35.82,0.44,146,75478,NULL,NULL,NULL,'KUG 2315+198',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161170,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161170,35.89,0.2,151,75478,74.4,NULL,NULL,'KUG 2315+198',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161171,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161171,35.82,0.49,146,75479,75,NULL,'IR','2MFGC 17495',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.000053,NULL,'11.5K',0.2,NULL,NULL,NULL,NULL,NULL,1,349.608875,6.96461,0.189,NULL,51745433928,808522405,12633162,11.5),(161172,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161172,35.85,0.41,148,75479,NULL,NULL,'Malmquist cor.','2MFGC 17495',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161173,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161173,35.94,0.4,154,75479,NULL,NULL,NULL,'2MFGC 17495',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161174,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161174,36.14,0.2,169,75479,74.4,NULL,NULL,'2MFGC 17495',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161175,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161175,33.44,0.2,48.8,75480,74.4,NULL,NULL,'UGC 12504',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.00002,NULL,'15.3',0.4,'Scd:',NULL,NULL,NULL,NULL,1,349.6197083,77.32028,1.297,NULL,52779862598,824685353,12885708,15.3),(161176,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161176,33.59,0.4,52.2,75480,75,NULL,NULL,'UGC 12504',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161177,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161177,33.65,0.49,53.8,75480,75,NULL,'IR','UGC 12504',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161178,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161178,36.26,0.19,179,75481,70,NULL,NULL,'GIN 680',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.000047,NULL,'15.69',NULL,'E',NULL,NULL,NULL,NULL,1,349.6227083,18.62106,0.153,NULL,52533649912,820838279,12825598,15.69),(161179,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161179,36.05,0.25,162,75482,74.4,NULL,NULL,'NGC 7571',NULL,'2013AJ....146...86T',2013,1,0.9,'Identification as NGC 7571 is doubtful.','G',0.000077,NULL,'14.92',0.9,'cD;S?','in a pair',NULL,'radio jet',NULL,1,349.626083333,18.68875,0.133,NULL,52533550778,820836730,12825573,14.92),(161180,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161180,36.26,0.19,179,75482,70,NULL,NULL,'NGC 7571',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161181,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161181,36.27,0.13,179,75482,70,NULL,'ABELL 2572, BGC','NGC 7571',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161182,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161182,34.93,0.49,96.6,75483,75,NULL,'IR','ESO 077- G 009',NULL,'2011yCatp016004901K',2011,1,0.96,NULL,'G',0.000033,NULL,'16.70',0.11,'Sc',NULL,NULL,NULL,NULL,1,349.628917,-68.49372,0.013,NULL,49274594593,769915540,12029930,16.7),(161183,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161183,35.47,0.42,124,75483,NULL,NULL,NULL,'ESO 077- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161184,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161184,35.51,0.2,126,75483,74.4,NULL,NULL,'ESO 077- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161185,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161185,35.54,0.4,128,75483,NULL,NULL,'Malmquist cor.','ESO 077- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161186,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161186,35.54,NULL,128,75483,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 077- G 009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161187,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161187,35.56,NULL,129,75483,NULL,NULL,'Dipole + Quadrupole','ESO 077- G 009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161188,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161188,35.58,NULL,131,75483,NULL,NULL,'Dipole','ESO 077- G 009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161189,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161189,35.59,NULL,131,75483,NULL,NULL,NULL,'ESO 077- G 009',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161190,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161190,36.04,0.25,161,75484,74.4,NULL,NULL,'NGC 7598',NULL,'2013AJ....146...86T',2013,1,0.2,NULL,'G',0.00005,NULL,'14.24',0.2,'E','Group member',NULL,NULL,NULL,1,349.638625,18.74936,0.133,NULL,52533548045,820836688,12825573,14.24),(161191,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161191,36.26,0.19,179,75484,70,NULL,NULL,'NGC 7598',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161192,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161192,37.17,0.46,272,75485,70,NULL,NULL,'2MASX J23183673-1012213',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000078,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,349.653125,-10.20603,0.066,NULL,49596645821,774947590,12108556,17),(161193,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161193,34.57,0.69,82.1,75486,100,NULL,'mid-IR','UGC 12490',NULL,'2013ApJ...771...88L',2013,1,0.79,NULL,'G',0.000027,NULL,'14.2',0.55,'SBa            Sbrst','Pair member (points to parent)',NULL,NULL,'Starburst',1,349.6597917,25.23286,0.261,NULL,51978661910,812166592,12690103,14.2),(161194,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161194,34.84,0.47,93.1,75486,NULL,NULL,'H','UGC 12490',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161195,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161195,34.97,0.45,98.4,75486,NULL,NULL,'K','UGC 12490',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161196,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161196,35.03,0.46,102,75486,NULL,NULL,'J','UGC 12490',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161197,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161197,35.16,0.4,108,75486,NULL,NULL,'mean','UGC 12490',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161198,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161198,36.26,0.19,179,75487,70,NULL,NULL,'GIN 679',NULL,'2001MNRAS.321..277C',2001,1,0.3,NULL,'G',0.000334,NULL,'15.93',0.1,'Radio galaxy',NULL,NULL,'NAT',NULL,1,349.663667,18.68925,0.133,NULL,52533576689,820837135,12825580,15.93),(161199,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161199,35.7,0.33,138,75488,70,NULL,NULL,'2MASX J23184014-1004145',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000082,NULL,'16.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,349.667375,-10.07064,0.025,NULL,49596654143,774947720,12108558,16.3),(161200,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005lf',NULL,161200,40.34,0.22,900,75489,74.2,NULL,'SALT 2','SDSS J231842.19-011216.7',0.3,'2010ApJ...716..712A',2010,1,0.07,NULL,'G',0.0005,NULL,'20.8g',0.06,NULL,NULL,NULL,NULL,NULL,1,349.675791667,-1.20464,0.081,NULL,49627789117,775434204,12116159,20.8),(161201,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005lf',NULL,161201,40.34,0.23,1170,75489,70,NULL,'Hubble residual 0.14 for z0.30010','SDSS J231842.19-011216.7',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161202,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 10550','R',161202,40.91,0.25,1170,75489,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005lf','SDSS J231842.19-011216.7',0.3001,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161203,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005lf',NULL,161203,40.97,0.24,1200,75489,65,NULL,'SALT2','SDSS J231842.19-011216.7',0.3,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161204,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005lf',NULL,161204,41.03,0.26,1230,75489,70,NULL,'SDSS-II SN 10550, SALT 2','SDSS J231842.19-011216.7',0.3,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161205,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 10550','R',161205,41.11,0.31,1280,75489,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005lf','SDSS J231842.19-011216.7',0.3001,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161206,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005lf',NULL,161206,41.14,0.22,1300,75489,65,NULL,'MLCS2k2','SDSS J231842.19-011216.7',0.3,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161207,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005lf',NULL,161207,41.33,0.1,1420,75489,70,NULL,'SDSS-II SN 10550','SDSS J231842.19-011216.7',0.3,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161208,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005lf',NULL,161208,41.06,0.22,1630,75489,70,NULL,'SALT 2','SDSS J231842.19-011216.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161209,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005lf',NULL,161209,41.09,0.22,1650,75489,70,NULL,'SALT 2, Malmquist cor.','SDSS J231842.19-011216.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161210,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161210,35.3,0.53,115,75490,70,NULL,NULL,'2MASX J23184305-1000275',NULL,'2014MNRAS.445.2677S',2014,1,0.79,NULL,'G',0.000084,NULL,'15.2g',0.31,'S0/a',NULL,NULL,NULL,NULL,1,349.6794583,-10.00764,0.025,NULL,49596081923,774938780,12108418,15.2),(161211,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161211,35.77,0.8,143,75491,75,NULL,'W91PP, r','UGC 12489',NULL,'1997ApJS..109..333W',1997,1,1.59,NULL,'G',0.000006,NULL,'16.0',0.16,'Sc',NULL,NULL,NULL,NULL,1,349.6805,22.87417,0.177,NULL,52510505167,820476643,12819947,16),(161212,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161212,35.64,0.49,134,75491,75,NULL,'IR','UGC 12489',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161213,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161213,35.82,NULL,146,75491,NULL,NULL,'Dipole','UGC 12489',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161214,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161214,35.82,NULL,146,75491,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12489',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161215,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161215,35.83,NULL,146,75491,NULL,NULL,'Dipole + Quadrupole','UGC 12489',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161216,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161216,35.93,NULL,153,75491,NULL,NULL,NULL,'UGC 12489',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161217,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161217,35.93,0.38,154,75491,75,NULL,'W91PP, r, raw','UGC 12489',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161218,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161218,36.16,0.38,170,75491,75,NULL,'W91PP, r, cor','UGC 12489',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161219,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161219,36.18,0.38,172,75491,75,NULL,'W91PP, r, inv','UGC 12489',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161220,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161220,36.04,0.25,161,75492,74.4,NULL,NULL,'NGC 7602',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000067,NULL,'15.32',0.5,'S?','in a pair',NULL,NULL,NULL,1,349.681375,18.69836,0.133,NULL,52533576174,820837127,12825580,15.32),(161221,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161221,36.26,0.19,179,75492,70,NULL,NULL,'NGC 7602',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161222,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161222,35.58,0.48,131,75493,70,NULL,NULL,'MCG -01-59-018',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00014,NULL,'15.46',0.7,NULL,NULL,NULL,NULL,NULL,1,349.68125,-3.00558,0.117,NULL,49642324423,775661319,12119708,15.46),(161223,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161223,36.75,0.46,224,75494,70,NULL,NULL,'2MASX J23184362-0854545',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000108,NULL,'16.2g',0.42,'S0/a',NULL,NULL,NULL,NULL,1,349.681667,-8.91514,0.057,NULL,49607830812,775122356,12111286,16.2),(161224,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161224,38.09,0.46,414,75495,70,NULL,NULL,'2MASX J23184388+1525045',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,349.6827917,15.41792,0.105,NULL,52529307575,820770430,12824537,17.7),(161225,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19778','R',161225,41.92,0.23,1730,75496,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J231845.12-002951.4',0.397,'2014arXiv1401.3317S',2014,1,0.09,NULL,'G',0.001,NULL,'20.41',0.08,'Cand. type II  AGN',NULL,NULL,NULL,'Sy 2',1,349.688167,-0.49764,0.105,NULL,49409947216,772030425,12062975,20.41),(161226,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19778','R',161226,41.96,0.27,1770,75496,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J231845.12-002951.4',0.397,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161227,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19778',NULL,161227,41.93,0.17,2430,75496,70,NULL,'SALT 2','SDSS J231845.12-002951.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161228,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19778',NULL,161228,41.99,0.17,2500,75496,70,NULL,'SALT 2, Malmquist cor.','SDSS J231845.12-002951.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161229,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161229,35.7,0.33,138,75497,70,NULL,NULL,'IC 1479',NULL,'2015arXiv151105856S',2015,1,1.04,NULL,'G',0.000103,NULL,'14.2g',0.89,'E:',NULL,NULL,NULL,NULL,1,349.693375,-10.39925,0.066,NULL,49596750788,774949231,12108581,14.2),(161230,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161230,36.21,0.5,175,75497,70,NULL,NULL,'IC 1479',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161231,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161231,35.18,0.53,109,75498,NULL,NULL,'Malmquist cor.','NGC 7601',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.63',0.9,'SAB(s)c:',NULL,NULL,NULL,NULL,1,349.6960417,9.23361,0.125,NULL,51756413376,808693959,12635843,14.63),(161232,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161232,35.33,0.49,117,75498,NULL,NULL,NULL,'NGC 7601',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161233,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161233,35.37,0.2,119,75498,74.4,NULL,NULL,'NGC 7601',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161234,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161234,35.79,0.49,144,75499,NULL,NULL,NULL,'2MASX J23184802+1852308',NULL,'2009ApJS..182..474S',2009,1,0.64,NULL,'G',0.000027,NULL,'14.76',NULL,'Sb',NULL,NULL,NULL,NULL,1,349.700083333,18.87525,0.133,NULL,52533534552,820836477,12825569,14.76),(161235,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161235,35.83,0.48,146,75499,NULL,NULL,'Malmquist cor.','2MASX J23184802+1852308',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161236,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161236,35.83,0.2,147,75499,74.4,NULL,NULL,'2MASX J23184802+1852308',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161237,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161237,33.2,0.2,43.7,75500,74.4,NULL,NULL,'UGC 12495',NULL,'2013AJ....146...86T',2013,1,1.2,'The UZC position is 8 arcsec west of the nucleus.','G',0.000017,NULL,'14.78',0.8,'Sdm:',NULL,NULL,NULL,NULL,1,349.7022083,16.62733,0.101,NULL,52523792770,820684262,12823191,14.78),(161238,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161238,33.48,0.44,49.6,75500,NULL,NULL,NULL,'UGC 12495',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161239,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161239,33.75,0.39,56.2,75500,NULL,NULL,'Malmquist cor.','UGC 12495',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161240,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161240,35.48,0.46,125,75501,70,NULL,NULL,'2MASX J23185029+0059498',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000073,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,349.709583,0.99706,0.137,NULL,51758123899,808720685,12636260,16.4),(161241,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161241,36.93,0.46,244,75502,70,NULL,NULL,'2MASX J23185036-1004115',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000084,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,349.709833,-10.06997,0.025,NULL,49596603432,774946928,12108545,16.5),(161242,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161242,35.5,0.47,126,75503,70,NULL,NULL,'IC 5304',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000107,NULL,'14.18',0.9,'SAB0- pec:',NULL,NULL,NULL,NULL,1,349.7189583,-10.25931,0.066,NULL,49596642868,774947544,12108555,14.18),(161243,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161243,33.55,0.8,51.4,75504,75,NULL,'W91CL, r','UGC 12494',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000027,NULL,'15.21',0.5,'SABd',NULL,NULL,NULL,NULL,1,349.7192083,6.87722,0.189,NULL,51800208373,809378255,12646535,15.21),(161244,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161244,33.56,0.8,51.5,75504,75,NULL,'HMCL, I','UGC 12494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161245,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161245,33.6,0.8,52.4,75504,75,NULL,'CF, r','UGC 12494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161246,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161246,33.22,0.2,44.1,75504,74.4,NULL,NULL,'UGC 12494',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161247,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161247,33.31,0.43,45.8,75504,75,NULL,'3.6 micron, color corrected','UGC 12494',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161248,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161248,33.32,0.38,46.1,75504,75,NULL,'CF, r, inv','UGC 12494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161249,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161249,33.34,0.38,46.6,75504,75,NULL,'CF, r, raw','UGC 12494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161250,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161250,33.36,0.43,47.1,75504,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12494',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161251,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161251,33.49,0.38,49.9,75504,75,NULL,'W91CL, r, inv','UGC 12494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161252,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161252,33.5,0.38,50.1,75504,75,NULL,'W91CL, r, raw','UGC 12494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161253,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161253,33.52,0.11,50.7,75504,NULL,NULL,NULL,'UGC 12494',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161254,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161254,33.53,0.4,50.7,75504,75,NULL,'HMCL, I, raw','UGC 12494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161255,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161255,33.57,0.4,51.8,75504,75,NULL,'HMCL, I, inv','UGC 12494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161256,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161256,33.62,0.38,53,75504,75,NULL,'CF, r, cor','UGC 12494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161257,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161257,33.76,0.38,56.5,75504,75,NULL,'W91CL, r, cor','UGC 12494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161258,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161258,33.82,0.4,58.1,75504,75,NULL,'HMCL, I, cor','UGC 12494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161259,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161259,37.34,0.46,294,75505,70,NULL,NULL,'2MASX J23185319-0839315',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000085,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,349.72175,-8.65883,0.053,NULL,49607667644,775119806,12111246,16.9),(161260,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161260,38.33,0.33,463,75506,70,NULL,NULL,'SDSS J231853.23+144947.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,349.721833,14.82992,0.109,NULL,52528653010,820760203,12824378,18.3),(161261,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161261,34.56,0.47,81.7,75507,70,NULL,NULL,'UGC 12492',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000133,NULL,'14.47',0.9,'S0;LINER       Sy2',NULL,NULL,NULL,'Sy 2',1,349.72425,-1.06025,0.097,NULL,49627629954,775431718,12116120,14.47),(161262,'Faber-Jackson','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161262,31.44,0.65,19.4,75508,95,NULL,'Weighted Mean','NGC 7600',NULL,'1984ApJS...56...91D',1984,1,2.5,'The APM position is 8 arcsec northeast of the nucleus.','G',0.00007,NULL,'12.95',1.1,'S0-',NULL,NULL,NULL,NULL,1,349.724417,-7.58044,0.061,NULL,49605428844,775084825,12110700,12.95),(161263,'Faber-Jackson','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161263,32.76,0.81,35.6,75508,55,NULL,'Visvanathan & Sandage 1979','NGC 7600',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161264,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161264,33.14,0.45,42.4,75508,NULL,NULL,'K','NGC 7600',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161265,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161265,33.31,0.4,46,75508,NULL,NULL,'mean','NGC 7600',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161266,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161266,35.87,0.58,149,75509,70,NULL,NULL,'2MFGC 17506',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000088,NULL,'15.9g',0.22,'Sb(f)',NULL,NULL,NULL,NULL,1,349.7252917,-10.32842,0.066,NULL,49596811226,774950175,12108596,15.9),(161267,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161267,31.4,0.8,19,75510,75,NULL,'MAT, I','NGC 7590',NULL,'1997ApJS..109..333W',1997,1,2.7,'Confused and extended HIPASS source','G',0.000017,NULL,'12.11',1,'S(r?)bc        Sy2','X-ray-faint group member',NULL,NULL,'unobscured Seyfert 2',1,349.728375,-42.23906,NULL,NULL,50528328288,789505129,12336017,12.11),(161268,'Sosies','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161268,32.03,0.05,25.5,75510,NULL,NULL,NULL,'NGC 7590',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161269,'Tully est','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161269,31.19,0.8,17.3,75510,75,NULL,'B','NGC 7590',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161270,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161270,31.95,0.32,24.5,75510,85,NULL,'I, raw','NGC 7590',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161271,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161271,31.99,0.32,25,75510,85,NULL,'I, inv','NGC 7590',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161272,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161272,32,0.43,25.1,75510,75,NULL,'MAT, I, raw','NGC 7590',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161273,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161273,32.19,0.43,27.4,75510,75,NULL,'MAT, I, cor','NGC 7590',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161274,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161274,32.23,0.43,27.9,75510,75,NULL,'MAT, I, inv','NGC 7590',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161275,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161275,32.24,0.39,28.1,75510,73,NULL,'opt','NGC 7590',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161276,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161276,32.35,0.42,29.6,75510,NULL,NULL,'Malmquist cor.','NGC 7590',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161277,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161277,32.42,0.41,30.4,75510,NULL,NULL,NULL,'NGC 7590',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161278,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161278,32.46,0.2,31.1,75510,74.4,NULL,NULL,'NGC 7590',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161279,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161279,35.09,0.33,104,75511,NULL,NULL,NULL,'ESO 604- G 011',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.13',0.5,'SAB(s)bc',NULL,NULL,NULL,NULL,1,349.732041667,-20.70081,0.056,NULL,50311604148,786118814,12283106,15.13),(161280,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161280,35.14,0.2,107,75511,74.4,NULL,NULL,'ESO 604- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161281,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161281,35.38,0.29,119,75511,NULL,NULL,'Malmquist cor.','ESO 604- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161282,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161282,36.6,0.55,209,75512,NULL,NULL,'Malmquist cor.','2MASX J23185854+1854107',NULL,'2009ApJS..182..474S',2009,1,0.49,NULL,'G',0.00003,NULL,'16.23',NULL,'Sc',NULL,NULL,NULL,NULL,1,349.744,18.90292,0.133,NULL,52533542315,820836598,12825571,16.23),(161283,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161283,37.1,0.44,262,75512,NULL,NULL,NULL,'2MASX J23185854+1854107',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161284,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161284,37.14,0.2,268,75512,74.4,NULL,NULL,'2MASX J23185854+1854107',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161285,'Diameter','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161285,36.65,NULL,214,75513,NULL,NULL,'Photographic','NGC 7603B',NULL,'1986ApJ...302..245S',1986,1,0.38,NULL,'G',0.00008,NULL,'16.4g',0.35,'Sy1','Line-of-sight pair member',NULL,NULL,NULL,1,349.75,0.23564,0.113,NULL,51573604198,805837565,12591211,16.4),(161286,'Magnitude','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161286,36.83,NULL,232,75513,NULL,NULL,'Photographic','NGC 7603B',NULL,'1986ApJ...302..245S',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161287,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19432','RN',161287,40.45,0.21,961,75514,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 19432',0.282225,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161288,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19432','RN',161288,40.56,0.28,1010,75514,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19432',0.282225,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161289,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161289,37.14,0.46,268,75515,70,NULL,NULL,'2MASX J23190110+0016516',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000082,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,349.754583,0.28106,0.113,NULL,51573589365,805837333,12591208,17.3),(161290,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 03669',NULL,161290,40.78,0.81,1430,75516,70,NULL,'SN photometric redshift distance, z photo =0.415 +/- 0.284','SDSS-II SN 03669',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.8g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,349.757333,-0.83972,0.101,NULL,49409338649,772020916,12062826,21.8),(161291,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','PTF10xyt',NULL,161291,36.74,0.03,223,75517,NULL,NULL,'H','PTF10xyt',NULL,'2012MNRAS.425.1007B',2012,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,349.76,13.79078,0.101,NULL,52514529623,820539525,12820930,NULL),(161292,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','PTF10xyt',NULL,161292,36.79,0.1,228,75517,72,NULL,'M(H) = -18.317 mag','PTF10xyt',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161293,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','PTF10xyt',NULL,161293,36.84,0.04,233,75517,NULL,NULL,'J','PTF10xyt',NULL,'2012MNRAS.425.1007B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161294,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','PTF10xyt',NULL,161294,37.06,0.04,246,75517,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10xyt',0.0484,'2014MNRAS.438.1391P',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161295,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','PTF10xyt',NULL,161295,37.09,0.04,250,75517,70,NULL,'SiFTO+SALT2, SN PTF10xyt','PTF10xyt',0.0484,'2012MNRAS.426.2359M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161296,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161296,34.42,0.8,76.6,75518,75,NULL,'MAT, I','ESO 535- G 015',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000027,NULL,'14.18',1,'SB(s)bc        LINER',NULL,NULL,NULL,NULL,1,349.761333333,-22.71519,0.05,NULL,50313764424,786152569,12283633,14.18),(161297,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161297,33.89,0.69,60.1,75518,100,NULL,'mid-IR','ESO 535- G 015',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161298,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161298,34.41,0.43,76.1,75518,75,NULL,'MAT, I, raw','ESO 535- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161299,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161299,34.48,0.32,78.8,75518,85,NULL,'I, raw','ESO 535- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161300,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161300,34.52,0.47,80.1,75518,NULL,NULL,'H','ESO 535- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161301,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161301,34.54,0.32,81,75518,85,NULL,'I, inv','ESO 535- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161302,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161302,34.54,0.4,81.1,75518,NULL,NULL,'mean','ESO 535- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161303,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161303,34.64,0.45,84.7,75518,NULL,NULL,'K','ESO 535- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161304,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161304,34.65,0.43,85.2,75518,75,NULL,'MAT, I, inv','ESO 535- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161305,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161305,34.7,0.46,87.1,75518,NULL,NULL,'J','ESO 535- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161306,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161306,34.86,0.43,93.7,75518,75,NULL,'MAT, I, cor','ESO 535- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161307,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161307,34.86,0.2,93.8,75518,74.4,NULL,NULL,'ESO 535- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (161308,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161308,34.89,0.42,95.2,75518,NULL,NULL,NULL,'ESO 535- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161309,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161309,35.21,0.36,110,75518,NULL,NULL,'Malmquist cor.','ESO 535- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161310,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161310,38.97,0.46,622,75519,70,NULL,NULL,'SDSS J231903.24-095201.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00008,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,349.7635,-9.86706,0.06,NULL,49607350064,775114844,12111169,18.1),(161311,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161311,32.24,0.8,28.1,75520,75,NULL,'MAT, I','NGC 7606',NULL,'1997ApJS..109..333W',1997,1,5.22,NULL,'G',0.000017,NULL,'12.3g',1.12,'SA(s)b         HII',NULL,NULL,NULL,NULL,1,349.769917,-8.48508,0.045,NULL,49604994253,775078035,12110594,12.3),(161312,'Tully est','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161312,32.31,0.8,28.9,75520,75,NULL,'B','NGC 7606',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161313,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161313,32.37,0.43,29.8,75520,75,NULL,'MAT, I, raw','NGC 7606',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161314,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161314,32.45,0.43,31,75520,NULL,NULL,'Malmquist cor.','NGC 7606',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161315,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161315,32.51,0.32,31.7,75520,85,NULL,'I, raw','NGC 7606',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161316,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161316,32.57,0.36,32.7,75520,NULL,NULL,NULL,'NGC 7606',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161317,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161317,32.57,0.39,32.7,75520,73,NULL,'opt','NGC 7606',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161318,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161318,32.57,0.39,32.7,75520,73,NULL,'opt','NGC 7606',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161319,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161319,32.59,0.32,32.9,75520,85,NULL,'I, inv','NGC 7606',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161320,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161320,32.59,0.4,33,75520,NULL,NULL,NULL,'NGC 7606',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161321,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161321,32.65,0.43,34,75520,75,NULL,'MAT, I, cor','NGC 7606',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161322,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161322,32.71,0.43,34.9,75520,75,NULL,'MAT, I, inv','NGC 7606',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161323,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161323,32.74,0.2,35.3,75520,74.4,NULL,NULL,'NGC 7606',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161324,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161324,32.87,0.43,37.5,75520,75,NULL,'3.6 micron, color corrected','NGC 7606',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161325,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161325,32.98,0.43,39.4,75520,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7606',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161326,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19758','RN',161326,41.54,0.35,1460,75521,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19758',0.397285,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161327,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19758','RN',161327,41.69,0.35,1560,75521,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19758',0.397285,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161328,'SGRB','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161328,42.46,NULL,3100,75522,70,NULL,'Photometric Distance, Host A, M(R) = -20 mag and spectral slope Beta = 1.0 ','GRB 081204',NULL,'2012A&A...545A..77R',2012,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,349.789375,-60.22489,0,NULL,48743048761,761610136,11900158,NULL),(161329,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2010ho',NULL,161329,36.26,0.02,178,75523,NULL,NULL,'J, SN 2010ho','2MASX J23190979+0911455',NULL,'2012MNRAS.425.1007B',2012,1,NULL,NULL,'G',0.000017,NULL,'16.52',NULL,'Sc',NULL,NULL,NULL,NULL,1,349.79075,9.19597,0.125,NULL,51755958143,808686845,12635731,16.52),(161330,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2010ho',NULL,161330,36.35,0.03,179,75523,70,NULL,'SiFTO+SALT2, SN PTF10tce, SN 2010ho','2MASX J23190979+0911455',0.040952,'2012MNRAS.426.2359M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161331,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2010ho',NULL,161331,36.36,0.03,180,75523,70,NULL,'SN 2010ho, SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','2MASX J23190979+0911455',0.040952,'2014MNRAS.438.1391P',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161332,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2010ho',NULL,161332,36.35,0.02,186,75523,NULL,NULL,'H, SN 2010ho','2MASX J23190979+0911455',NULL,'2012MNRAS.425.1007B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161333,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2010ho',NULL,161333,36.36,0.02,187,75523,72,NULL,'M(H) = -18.317 mag','2MASX J23190979+0911455',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161334,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161334,33.3,0.8,45.7,75524,75,NULL,'W91CL, r','UGC 12497',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.00002,NULL,'15.58',0.3,'Im:','X-ray-bright group member',NULL,NULL,NULL,1,349.795125,7.70375,0.161,NULL,51748869296,808576082,12634001,15.58),(161335,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161335,32.42,0.43,30.5,75524,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12497',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161336,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161336,32.49,0.2,31.5,75524,74.4,NULL,NULL,'UGC 12497',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161337,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161337,32.51,0.43,31.7,75524,75,NULL,'3.6 micron, color corrected','UGC 12497',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161338,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161338,32.57,0.38,32.7,75524,75,NULL,'W91CL, r, inv','UGC 12497',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161339,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161339,32.68,0.38,34.3,75524,75,NULL,'W91CL, r, raw','UGC 12497',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161340,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161340,32.93,0.38,38.5,75524,75,NULL,'W91CL, r, cor','UGC 12497',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161341,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161341,33.41,0.11,48.2,75525,NULL,NULL,NULL,'UGC 12501',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',NULL,NULL,'15.66',0.1,'S?',NULL,NULL,NULL,NULL,1,349.795667,10.80233,0.089,NULL,51743361506,808490023,12632656,15.66),(161342,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161342,33.74,0.43,56,75525,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12501',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161343,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161343,33.84,0.43,58.6,75525,75,NULL,'3.6 micron, color corrected','UGC 12501',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161344,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161344,33.95,0.2,61.7,75525,74.4,NULL,NULL,'UGC 12501',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161345,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161345,33.56,0.8,51.6,75526,75,NULL,'W91CL, r','IC 5309',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000017,NULL,'14.52',0.6,'Sb',NULL,NULL,NULL,NULL,1,349.7985417,8.10931,0.169,NULL,51748436281,808569316,12633895,14.52),(161346,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161346,33.56,0.8,51.6,75526,75,NULL,'CF, r','IC 5309',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161347,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161347,33.56,0.8,51.6,75526,75,NULL,'HMCL, I','IC 5309',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161348,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161348,33.04,0.69,40.6,75526,100,NULL,'mid-IR','IC 5309',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161349,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161349,33.29,0.43,45.6,75526,75,NULL,'3.6 micron, color + selection bias corrected','IC 5309',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161350,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161350,33.35,0.43,46.8,75526,75,NULL,'3.6 micron, color corrected','IC 5309',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161351,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161351,33.38,0.38,47.4,75526,75,NULL,'CF, r, raw','IC 5309',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161352,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161352,33.43,0.2,48.5,75526,74.4,NULL,NULL,'IC 5309',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161353,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161353,33.44,0.38,48.8,75526,75,NULL,'CF, r, inv','IC 5309',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161354,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161354,33.49,0.09,50,75526,NULL,NULL,NULL,'IC 5309',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161355,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161355,33.5,0.4,50,75526,75,NULL,'HMCL, I, raw','IC 5309',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161356,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161356,33.63,0.4,53.2,75526,75,NULL,'HMCL, I, inv','IC 5309',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161357,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161357,33.65,0.38,53.6,75526,75,NULL,'W91CL, r, raw','IC 5309',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161358,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161358,33.65,0.38,53.8,75526,75,NULL,'CF, r, cor','IC 5309',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161359,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161359,33.73,0.38,55.8,75526,75,NULL,'W91CL, r, inv','IC 5309',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161360,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161360,33.77,0.4,56.7,75526,NULL,NULL,'mean','IC 5309',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161361,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161361,33.78,0.4,57,75526,75,NULL,'HMCL, I, cor','IC 5309',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161362,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161362,33.89,0.38,59.9,75526,75,NULL,'W91CL, r, cor','IC 5309',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161363,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161363,33.96,0.47,62,75526,NULL,NULL,'H','IC 5309',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161364,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161364,34.03,0.45,64,75526,NULL,NULL,'K','IC 5309',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161365,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161365,34.06,0.46,65,75526,NULL,NULL,'J','IC 5309',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161366,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161366,38.41,0.46,482,75527,70,NULL,NULL,'2MASX J23191174+1533109',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,349.799041667,15.55297,0.081,NULL,52529430740,820772355,12824568,17.4),(161367,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161367,36.04,0.25,161,75528,74.4,NULL,NULL,'GIN 677',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000053,NULL,'14.71',0.4,'S',NULL,NULL,NULL,NULL,1,349.805583,18.91122,0.117,NULL,52533535869,820836497,12825570,14.71),(161368,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161368,36.26,0.19,179,75528,70,NULL,NULL,'GIN 677',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161369,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161369,33.12,0.43,42.1,75529,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7608',NULL,'2014MNRAS.444..527S',2014,1,1.5,NULL,'G',0.00003,NULL,'15.01',0.4,'S?','X-ray-bright group member',NULL,NULL,NULL,1,349.813875,8.35014,0.145,NULL,51748312699,808567385,12633865,15.01),(161370,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161370,33.21,0.43,43.9,75529,75,NULL,'3.6 micron, color corrected','NGC 7608',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161371,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161371,33.31,0.49,45.8,75529,75,NULL,'IR','NGC 7608',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161372,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161372,33.31,0.2,45.9,75529,74.4,NULL,NULL,'NGC 7608',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161373,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161373,33.34,0.4,46.6,75529,NULL,NULL,'mean','NGC 7608',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161374,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161374,33.46,0.11,49.3,75529,NULL,NULL,NULL,'NGC 7608',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161375,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161375,33.53,0.47,50.9,75529,NULL,NULL,'H','NGC 7608',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161376,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161376,33.65,0.46,53.6,75529,NULL,NULL,'J','NGC 7608',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161377,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161377,33.7,0.45,54.9,75529,NULL,NULL,'K','NGC 7608',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161378,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 08252',NULL,161378,41.19,0.4,1730,75530,70,NULL,'SN photometric redshift distance, z photo =0.536 +/- 0.164','SDSS-II SN 08252',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,349.819333333,0.72381,0.137,NULL,51573850970,805841421,12591272,NULL),(161379,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 08252',NULL,161379,41.63,0.32,2120,75530,70,NULL,'SALT 2','SDSS-II SN 08252',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161380,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 08252',NULL,161380,42.24,0.32,2810,75530,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 08252',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161381,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161381,36.03,0.39,160,75531,NULL,NULL,NULL,'KUG 2316+183',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.00003,NULL,'16.5:',0.2,'Sc',NULL,NULL,NULL,NULL,1,349.82875,18.61344,0.097,NULL,52533477763,820835590,12825556,16.5),(161382,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161382,36.07,0.2,164,75531,74.4,NULL,NULL,'KUG 2316+183',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161383,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161383,36.07,0.38,164,75531,NULL,NULL,'Malmquist cor.','KUG 2316+183',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161384,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161384,35.55,0.4,129,75532,NULL,NULL,'Malmquist cor.','UGC 12503',NULL,'2009ApJS..182..474S',2009,1,1.33,NULL,'G',0.000082,NULL,'15.3g',0.34,'S0+? sp',NULL,NULL,NULL,NULL,1,349.82925,0.94586,0.137,NULL,51573923702,805842557,12591289,15.3),(161385,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161385,35.77,0.37,143,75532,NULL,NULL,NULL,'UGC 12503',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161386,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161386,35.81,0.2,145,75532,74.4,NULL,NULL,'UGC 12503',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161387,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161387,34.5,0.49,79.6,75533,70,NULL,NULL,'ESO 470- G 001',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000107,NULL,'14.92',0.7,'(R)SB(l)0^+',NULL,NULL,NULL,NULL,1,349.8322083,-28.94283,0.022,NULL,50141008476,783453257,12241457,14.92),(161388,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161388,31.64,0.8,21.3,75534,75,NULL,'MAT, I','NGC 7599',NULL,'1997ApJS..109..333W',1997,1,4.4,'Confused HIPASS source','G',0.000017,NULL,'12.08',1.3,'SB(s)c         LINER','X-ray-faint group member',NULL,NULL,NULL,1,349.838083,-42.25683,NULL,NULL,50528592803,789509262,12336082,12.08),(161389,'Sosies','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161389,31.91,0.06,24.1,75534,NULL,NULL,NULL,'NGC 7599',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161390,'Tully est','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161390,31.52,0.8,20.2,75534,75,NULL,'B','NGC 7599',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161391,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161391,30.93,0.43,15.3,75534,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7599',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161392,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161392,31.01,0.43,15.9,75534,75,NULL,'3.6 micron, color corrected','NGC 7599',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161393,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161393,31.22,0.2,17.5,75534,74.4,NULL,NULL,'NGC 7599',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161394,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161394,31.24,0.32,17.7,75534,85,NULL,'I, raw','NGC 7599',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161395,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161395,31.28,0.32,18,75534,85,NULL,'I, inv','NGC 7599',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161396,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161396,31.32,0.46,18.4,75534,NULL,NULL,'J','NGC 7599',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161397,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161397,31.33,0.43,18.5,75534,75,NULL,'MAT, I, raw','NGC 7599',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161398,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161398,31.39,0.47,18.9,75534,NULL,NULL,'H','NGC 7599',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161399,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161399,31.4,0.45,19.1,75534,NULL,NULL,'K','NGC 7599',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161400,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161400,31.47,0.4,19.7,75534,NULL,NULL,'mean','NGC 7599',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161401,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161401,31.5,0.43,19.9,75534,75,NULL,'MAT, I, inv','NGC 7599',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161402,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161402,31.58,0.43,20.7,75534,75,NULL,'MAT, I, cor','NGC 7599',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161403,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161403,31.59,0.42,20.8,75534,NULL,NULL,NULL,'NGC 7599',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161404,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161404,31.64,0.4,21.3,75534,73,NULL,'opt','NGC 7599',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161405,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161405,31.73,0.39,22.2,75534,NULL,NULL,'Malmquist cor.','NGC 7599',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161406,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161406,34.69,0.61,86.8,75535,NULL,NULL,NULL,'ESO 077- G 013',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.66',0.5,'SAB(r)0/a:',NULL,NULL,NULL,NULL,1,349.840167,-67.47433,0,NULL,49264799306,769762489,12027538,15.66),(161407,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161407,34.73,0.2,88.3,75535,74.4,NULL,NULL,'ESO 077- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161408,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161408,34.77,0.59,89.9,75535,NULL,NULL,'Malmquist cor.','ESO 077- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161409,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161409,33.85,0.5,58.8,75536,NULL,NULL,NULL,'KUG 2316+162',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000067,NULL,'15.7',0.3,'Spiral',NULL,NULL,NULL,NULL,1,349.841167,16.56708,0.073,NULL,52523816222,820684628,12823197,15.7),(161410,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161410,33.89,0.2,60,75536,74.4,NULL,NULL,'KUG 2316+162',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161411,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161411,34.02,0.46,63.7,75536,NULL,NULL,'Malmquist cor.','KUG 2316+162',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161412,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 21861','R',161412,39.61,0.22,705,75537,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007sg','SN 2007sg',0.187342,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,349.8587083,-0.90164,0.101,NULL,49409419588,772022181,12062846,NULL),(161413,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 21861','R',161413,39.79,0.19,764,75537,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007sg','SN 2007sg',0.187342,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161414,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161414,36.35,0.46,186,75538,70,NULL,NULL,'2MASX J23192714-0857400',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000066,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,349.8632917,-8.96122,0.057,NULL,49609932817,775155200,12111800,17.6),(161415,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161415,35.38,0.49,119,75539,75,NULL,'IR','MCG +01-59-046',NULL,'2011yCatp016004901K',2011,1,0.74,NULL,'G',0.000324,NULL,'17.23',0.15,'Sc','Compact group member',NULL,NULL,NULL,1,349.866,9.49436,0.129,NULL,51756781975,808699718,12635933,17.23),(161416,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 02568','RN',161416,39.89,0.07,848,75540,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02568',0.118214,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161417,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 02568','RN',161417,40.43,0.19,1090,75540,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02568',0.118214,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161418,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161418,35.09,0.45,104,75541,NULL,NULL,'Malmquist cor.','2MASX J23192955+0100583',NULL,'2009ApJS..182..474S',2009,1,0.61,NULL,'G',0.000085,NULL,'15.9g',0.28,'Sb',NULL,NULL,NULL,NULL,1,349.8732083,1.01622,0.145,NULL,51573931544,805842680,12591291,15.9),(161419,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161419,35.18,0.44,108,75541,NULL,NULL,NULL,'2MASX J23192955+0100583',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161420,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161420,35.4,0.2,120,75541,74.4,NULL,NULL,'2MASX J23192955+0100583',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161421,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161421,34.17,NULL,68.2,75542,NULL,NULL,'Dipole','UGC 12506',NULL,'2010Ap&SS.325..163P',2010,1,3.25,NULL,'G',0.000006,NULL,'15.22',0.28,'Sc',NULL,NULL,NULL,NULL,1,349.877,16.07475,0.105,NULL,52525766964,820715108,12823673,15.22),(161422,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161422,34.18,NULL,68.5,75542,NULL,NULL,'Dipole + Quadrupole','UGC 12506',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161423,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161423,34.19,NULL,68.7,75542,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12506',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161424,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161424,34.33,NULL,73.5,75542,NULL,NULL,NULL,'UGC 12506',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161425,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161425,34.58,0.49,82.4,75542,75,NULL,'IR','UGC 12506',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161426,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161426,35.02,0.4,101,75542,NULL,NULL,'mean','UGC 12506',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161427,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161427,35.07,0.41,103,75542,NULL,NULL,'Malmquist cor.','UGC 12506',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161428,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161428,35.07,0.2,103,75542,74.4,NULL,NULL,'UGC 12506',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161429,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161429,35.14,0.47,107,75542,NULL,NULL,'H','UGC 12506',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161430,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161430,35.14,0.4,107,75542,NULL,NULL,NULL,'UGC 12506',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161431,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161431,35.22,0.45,110,75542,NULL,NULL,'K','UGC 12506',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161432,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161432,33.1,0.45,41.6,75543,NULL,NULL,'K','NGC 7611',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000063,NULL,'13.51',0.6,'SB0+:','X-ray-bright group member',NULL,NULL,NULL,1,349.9025,8.06325,0.157,NULL,51746558154,808539971,12633437,13.51),(161433,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161433,33.2,0.4,43.7,75543,NULL,NULL,'mean','NGC 7611',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161434,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 02656','RN',161434,43.62,0.27,3880,75544,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02656',0.365743,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161435,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 02656','RN',161435,43.91,0.25,4440,75544,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 02656',0.365743,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161436,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161436,36.78,0.89,227,75545,70,NULL,NULL,'2MFGC 17516',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'15.6R',0.09,NULL,NULL,NULL,NULL,NULL,1,349.9029583,-29.49144,NULL,NULL,50185920347,784155005,12252421,15.6),(161437,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161437,33.51,0.11,50.5,75546,NULL,NULL,NULL,'AGC 332094',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',NULL,NULL,'14.9I',0.1,NULL,NULL,NULL,NULL,NULL,1,349.9045,8.08753,0.157,NULL,51746542546,808539727,12633433,14.9),(161438,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161438,34.22,0.2,69.8,75546,74.4,NULL,NULL,'AGC 332094',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161439,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161439,36.79,0.42,228,75547,NULL,NULL,'Malmquist cor.','2MASX J23193747+3524010',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',NULL,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,349.906083,35.40028,0.281,NULL,51832099936,809876561,12654321,14.5),(161440,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161440,36.97,0.39,247,75547,NULL,NULL,NULL,'2MASX J23193747+3524010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161441,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161441,33.2,0.43,43.6,75548,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7610',NULL,'2014MNRAS.444..527S',2014,1,2.5,'Identification as NGC 7616 is very doubtful.','G',0.000017,NULL,'13.44',1.9,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,349.922375,10.185,0.113,NULL,51743563584,808493181,12632705,13.44),(161442,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161442,33.2,0.43,43.7,75548,75,NULL,'3.6 micron, color corrected','NGC 7610',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161443,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161443,33.24,0.2,44.5,75548,74.4,NULL,NULL,'NGC 7610',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161444,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161444,33.42,NULL,48.3,75548,NULL,NULL,'B','NGC 7610',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161445,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161445,33.51,0.1,50.5,75548,NULL,NULL,NULL,'NGC 7610',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161446,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161446,33.62,NULL,53,75548,NULL,NULL,'I','NGC 7610',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161447,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161447,33.33,0.25,46.3,75549,74.4,NULL,NULL,'NGC 7612',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.000037,NULL,'13.74',0.8,'S0','X-ray-bright group member',NULL,NULL,NULL,1,349.934167,8.57639,0.145,NULL,51746442104,808538157,12633408,13.74),(161448,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161448,33.1,0.4,41.8,75549,NULL,NULL,'mean','NGC 7612',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161449,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161449,33.3,0.45,45.8,75549,NULL,NULL,'K','NGC 7612',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161450,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 14528',NULL,161450,37.78,1.14,360,75550,70,NULL,'SN photometric redshift distance, z photo =0.088 +/- 0.066','SDSS-II SN 14528',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,349.935125,0.47961,0.137,NULL,51573518056,805836219,12591190,NULL),(161451,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161451,37.43,0.46,307,75551,70,NULL,NULL,'SDSS J231946.35+152946.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000129,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,349.943125,15.49611,0.081,NULL,52529441038,820772516,12824570,18.2),(161452,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161452,37.23,0.46,279,75552,70,NULL,NULL,'2MASX J23194843-0001322',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00009,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,349.951917,-0.02558,0.113,NULL,49409453847,772022716,12062854,17.2),(161453,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161453,35.43,0.49,122,75553,75,NULL,'IR','2MFGC 17522',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000119,NULL,'16.2g',0.2,'Scd(f)',NULL,NULL,NULL,NULL,1,349.959833,1.06961,0.145,NULL,51573707004,805839171,12591237,16.2),(161454,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161454,35.47,0.2,124,75553,74.4,NULL,NULL,'2MFGC 17522',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161455,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161455,35.5,0.49,126,75553,NULL,NULL,'Malmquist cor.','2MFGC 17522',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161456,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161456,35.62,0.46,133,75553,NULL,NULL,NULL,'2MFGC 17522',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161457,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161457,35.67,0.2,136,75553,74.4,NULL,NULL,'2MFGC 17522',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161458,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 14035',NULL,161458,39.61,0.3,834,75554,70,NULL,'SN photometric redshift distance, z photo =0.218 +/- 0.037','SDSS-II SN 14035',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.3g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,349.9667083,-0.27825,0.093,NULL,49409681235,772026269,12062910,21.3),(161459,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 14035','R',161459,40.57,0.29,1010,75554,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14035',0.281725,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161460,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 14035','R',161460,40.83,0.33,1140,75554,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14035',0.281725,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161461,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161461,34.86,0.2,93.8,75555,74.4,NULL,NULL,'UGC 12513',NULL,'2013AJ....146...86T',2013,1,0.85,NULL,'G',0.000049,NULL,'16.9g',0.16,'Sc(f)',NULL,NULL,NULL,NULL,1,349.966625,1.21811,0.145,NULL,51573743681,805839745,12591246,16.9),(161462,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161462,34.91,0.56,95.9,75555,NULL,NULL,'Malmquist cor.','UGC 12513',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161463,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161463,34.95,0.55,97.7,75555,NULL,NULL,NULL,'UGC 12513',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161464,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 07811','RN',161464,41.17,0.18,1580,75556,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 07811',0.08259,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161465,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 07811','RN',161465,41.54,0.3,1880,75556,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 07811',0.08259,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161466,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161466,33.42,0.09,48.4,75557,NULL,NULL,NULL,'NGC 7615',NULL,'2009ApJS..182..474S',2009,1,1,'1999ApJS..121..287H has V = 3071 +- 32 km/sec.','G',0.000033,NULL,'15.1',0.5,'Sb?','Group member',NULL,NULL,NULL,1,349.976833333,8.39942,0.161,NULL,51746461637,808538463,12633413,15.1),(161467,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161467,33.5,0.2,50.1,75557,74.4,NULL,NULL,'NGC 7615',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161468,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161468,34.39,0.8,75.6,75558,75,NULL,'W91PP, r','UGC 12514',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000005,NULL,'15.37',0.5,'Sdm:',NULL,NULL,NULL,NULL,1,349.980125,26.01167,0.189,NULL,51989558001,812336843,12692763,15.37),(161469,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161469,34.65,0.38,85,75558,75,NULL,'W91PP, r, raw','UGC 12514',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161470,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161470,34.67,0.38,85.8,75558,75,NULL,'W91PP, r, inv','UGC 12514',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161471,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161471,34.94,0.38,97.4,75558,75,NULL,'W91PP, r, cor','UGC 12514',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161472,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161472,36.26,0.48,178,75559,70,NULL,NULL,'AM 2317-535',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.000087,NULL,'15.89',0.5,'S0',NULL,NULL,NULL,NULL,1,349.9999583,-53.6755,0,NULL,48637767892,759965123,11874455,15.89),(161473,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161473,35.48,0.49,125,75560,75,NULL,'IR','CGCG 497-003',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000033,NULL,'15.59',0.2,'S?',NULL,NULL,NULL,NULL,1,350.0050417,32.92286,0.221,NULL,52053805233,813340706,12708448,15.59),(161474,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161474,33.38,0.43,47.5,75561,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12519',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.000017,NULL,'14.26',0.4,'SB?; Sy2       HII',NULL,NULL,NULL,NULL,1,350.0115417,15.95275,0.105,NULL,52525608934,820712639,12823634,14.26),(161475,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161475,33.41,0.43,48.1,75561,75,NULL,'3.6 micron, color corrected','UGC 12519',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161476,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161476,33.43,0.41,48.6,75561,NULL,NULL,NULL,'UGC 12519',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161477,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161477,33.44,0.2,48.8,75561,74.4,NULL,NULL,'UGC 12519',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161478,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161478,33.69,0.36,54.8,75561,NULL,NULL,'Malmquist cor.','UGC 12519',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161479,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161479,33.72,0.49,55.4,75561,75,NULL,'IR','UGC 12519',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161480,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161480,33.82,0.4,58,75561,NULL,NULL,'mean','UGC 12519',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161481,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161481,33.82,0.47,58.2,75561,NULL,NULL,'H','UGC 12519',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161482,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161482,33.95,0.45,61.7,75561,NULL,NULL,'K','UGC 12519',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161483,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161483,33.98,0.46,62.6,75561,NULL,NULL,'J','UGC 12519',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161484,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161484,36.26,0.81,179,75562,70,NULL,NULL,'AM 2317-564 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'16.19',0.32,'INTERACTING','in an interacting pair',NULL,NULL,NULL,1,350.016,-56.44964,0,NULL,48811009948,762672030,11916750,16.19),(161485,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005jh',NULL,161485,37.94,0.12,349,75563,74.2,NULL,'SALT 2','APMUKS(BJ) B231730.59-001946.5',0.11,'2010ApJ...716..712A',2010,1,0.12,NULL,'G',NULL,NULL,'19.80',0.1,NULL,NULL,NULL,NULL,NULL,1,350.018333,-0.05567,0.113,NULL,49409486256,772023222,12062862,19.8),(161486,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005jh',NULL,161486,38.46,0.14,443,75563,65,NULL,'SALT2','APMUKS(BJ) B231730.59-001946.5',0.11,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161487,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005jh',NULL,161487,38.25,0.08,447,75563,70,NULL,'SALT 2','APMUKS(BJ) B231730.59-001946.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161488,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005jh',NULL,161488,38.25,0.08,447,75563,70,NULL,'SALT 2, Malmquist cor.','APMUKS(BJ) B231730.59-001946.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161489,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005jh',NULL,161489,38.5,0.13,452,75563,70,NULL,'SALT 2','APMUKS(BJ) B231730.59-001946.5',0.11,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161490,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005jh',NULL,161490,38.52,0.1,455,75563,65,NULL,'MLCS2k2','APMUKS(BJ) B231730.59-001946.5',0.11,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161491,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 07147','R',161491,38.52,0.18,456,75563,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005jh','APMUKS(BJ) B231730.59-001946.5',0.11,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161492,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005jh',NULL,161492,38.54,NULL,459,75563,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 07147, SN 2005jh','APMUKS(BJ) B231730.59-001946.5',0.11,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161493,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 07147','R',161493,38.79,0.08,516,75563,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005jh','APMUKS(BJ) B231730.59-001946.5',0.11,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161494,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005jh',NULL,161494,38.9,0.03,544,75563,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 07147, SN 2005jh','APMUKS(BJ) B231730.59-001946.5',0.11,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161495,'D-Sigma','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161495,33.21,0.4,43.8,75564,75,NULL,'Edat, raw','NGC 7617',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000027,NULL,'14.78',0.7,'SA0^0^:','Group member',NULL,NULL,NULL,1,350.037375,8.16578,0.161,NULL,51746557005,808539953,12633436,14.78),(161496,'D-Sigma','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161496,33.3,0.4,45.6,75564,75,NULL,'Edat, cor','NGC 7617',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161497,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161497,33.25,0.8,44.7,75565,75,NULL,'CF, r','UGC 12521',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00003,NULL,'14.10',0.9,'SA(s)cd:',NULL,NULL,NULL,NULL,1,350.047833333,-1.85658,0.137,NULL,49630573477,775477710,12116839,14.1),(161498,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161498,32.78,0.69,35.9,75565,100,NULL,'mid-IR','UGC 12521',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161499,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161499,33.54,0.38,51.1,75565,75,NULL,'CF, r, raw','UGC 12521',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161500,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161500,33.58,0.4,51.9,75565,NULL,NULL,'mean','UGC 12521',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161501,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161501,33.62,0.38,53,75565,75,NULL,'CF, r, inv','UGC 12521',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161502,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161502,33.77,0.52,56.8,75565,NULL,NULL,NULL,'UGC 12521',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161503,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161503,33.81,0.2,57.8,75565,74.4,NULL,NULL,'UGC 12521',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161504,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161504,33.83,0.38,58.4,75565,75,NULL,'CF, r, cor','UGC 12521',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161505,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161505,33.89,0.49,60,75565,NULL,NULL,'Malmquist cor.','UGC 12521',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161506,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161506,34.08,0.47,65.4,75565,NULL,NULL,'H','UGC 12521',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161507,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161507,34.13,0.46,67.1,75565,NULL,NULL,'J','UGC 12521',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161508,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161508,37.03,0.62,255,75566,NULL,NULL,'Malmquist cor.','2MASX J23201233+1848552',NULL,'2009ApJS..182..474S',2009,1,0.47,NULL,'G',0.000027,NULL,'16.01',NULL,'Sb:',NULL,NULL,NULL,NULL,1,350.051375,18.81536,0.117,NULL,52532842615,820825665,12825401,16.01),(161509,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161509,37.39,0.53,300,75566,NULL,NULL,NULL,'2MASX J23201233+1848552',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161510,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161510,37.43,0.2,306,75566,74.4,NULL,NULL,'2MASX J23201233+1848552',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161511,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161511,34.52,0.2,80.2,75567,74.4,NULL,NULL,'KUG 2317+253',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000007,NULL,'15.55',0.2,'S?',NULL,NULL,NULL,NULL,1,350.052875,25.59656,0.229,NULL,51989898529,812342164,12692846,15.55),(161512,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161512,34.75,0.44,89,75567,NULL,NULL,NULL,'KUG 2317+253',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161513,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161513,34.94,0.4,97.5,75567,NULL,NULL,'Malmquist cor.','KUG 2317+253',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161514,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161514,32.1,0.47,26.3,75568,NULL,NULL,'H','UGC 12518',NULL,'2007A&A...465...71T',2007,1,1.3,'Springob et al. (2005ApJS..160..149S) give v= 3906 km/sec.','G',0.000033,NULL,'15.50',0.2,'Sb',NULL,NULL,NULL,NULL,1,350.053333,7.93208,0.157,NULL,51746969556,808546399,12633537,15.5),(161515,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161515,32.25,0.45,28.2,75568,NULL,NULL,'K','UGC 12518',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161516,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161516,32.39,0.46,30,75568,NULL,NULL,'J','UGC 12518',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161517,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161517,32.62,0.4,33.4,75568,NULL,NULL,'mean','UGC 12518',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161518,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161518,33.56,0.1,51.6,75568,NULL,NULL,NULL,'UGC 12518',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161519,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161519,33.81,0.49,57.8,75568,75,NULL,'IR','UGC 12518',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161520,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19335',NULL,161520,40.57,0.14,1300,75569,70,NULL,'SN photometric redshift distance, z photo =0.368 +/- 0.032','SDSS-II SN 19335',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,350.0582083,0.39511,0.113,NULL,51573533706,805836464,12591194,NULL),(161521,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19335','R',161521,41.26,0.29,1320,75569,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19335',0.350692,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161522,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19335','R',161522,41.53,0.28,1500,75569,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19335',0.350692,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161523,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19335',NULL,161523,41.1,0.2,1660,75569,70,NULL,'SALT 2','SDSS-II SN 19335',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161524,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19335',NULL,161524,41.15,0.2,1700,75569,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19335',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161525,'CMD','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161525,33.2,0.37,43.7,75570,NULL,NULL,'Photographic, Virgo m-M = 31.0 mag','NGC 7619',NULL,'1981PASP...93...25M',1981,1,2.5,NULL,'G',0.000017,NULL,'12.10',2.3,'E','X-ray-bright group member',NULL,NULL,NULL,1,350.0605417,8.20625,0.161,NULL,51746554484,808539913,12633436,12.1),(161526,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 1970J',NULL,161526,33.6,0.3,52,75570,NULL,NULL,'Photographic','NGC 7619',NULL,'1982ApJ...254....1A',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161527,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 1970J',NULL,161527,33.82,0.3,58.1,75570,60,NULL,'M(V) = -19.47 mag','NGC 7619',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161528,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 1970J','R',161528,33.87,NULL,59.4,75570,NULL,NULL,'Photographic','NGC 7619',NULL,'1988SSRv...48....1R',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161529,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 1970J',NULL,161529,33.89,0.3,60,75570,60,NULL,'M(B) = -19.48 mag','NGC 7619',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161530,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 1970J',NULL,161530,34,0.26,63,75570,67,NULL,NULL,'NGC 7619',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161531,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 1970J',NULL,161531,34.1,0.07,66.1,75570,66,NULL,NULL,'NGC 7619',NULL,'1994A&A...281...51M',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161532,'SBF','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161532,33.62,0.31,53,75570,NULL,NULL,'I','NGC 7619',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161533,'SBF','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161533,33.62,0.31,53,75570,NULL,NULL,NULL,'NGC 7619',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161534,'SBF','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161534,33.64,0.16,54,75570,NULL,NULL,NULL,'NGC 7619',NULL,'2003A&A...399..441M',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161535,'SBF','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161535,33.7,0.12,55,75570,74.4,NULL,NULL,'NGC 7619',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161536,'SBF','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161536,33.84,0.31,58.7,75570,NULL,NULL,'Malmquist cor.','NGC 7619',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161537,'D-Sigma','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161537,33.21,0.4,43.8,75570,75,NULL,'Edat, raw','NGC 7619',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161538,'D-Sigma','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161538,33.3,0.4,45.6,75570,75,NULL,'Edat, cor','NGC 7619',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161539,'D-Sigma','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161539,33.52,0.22,50.5,75570,72,NULL,'Pegasus cluster, 4 galaxies','NGC 7619',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161540,'Faber-Jackson','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161540,32.55,0.39,32.4,75570,95,NULL,'de Vaucouleurs','NGC 7619',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161541,'Faber-Jackson','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161541,32.68,0.27,34.4,75570,95,NULL,'Weighted Mean','NGC 7619',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161542,'Faber-Jackson','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161542,32.85,0.46,37.2,75570,95,NULL,'Michard 1979a','NGC 7619',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161543,'Faber-Jackson','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161543,33.12,0.63,42.1,75570,95,NULL,'Michard 1979b, c','NGC 7619',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161544,'Faber-Jackson','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161544,35.05,0.81,102,75570,55,NULL,'Visvanathan & Sandage 1979','NGC 7619',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161545,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161545,33.61,0.41,52.8,75570,NULL,NULL,NULL,'NGC 7619',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161546,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161546,33.7,0.12,55,75570,74.4,NULL,NULL,'NGC 7619',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161547,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161547,33.96,0.41,61.9,75570,NULL,NULL,'Malmquist cor.','NGC 7619',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161548,'Tertiary','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161548,33.11,0.5,41.9,75570,95,NULL,NULL,'NGC 7619',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161549,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161549,33.18,0.12,43.4,75570,75,NULL,'Pegasus CLUSTER','NGC 7619',NULL,'2012ApJ...749...78T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161550,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161550,33.21,0.12,43.9,75570,74.4,NULL,'Pegasus CLUSTER, 17 galaxies, WISE I-band','NGC 7619',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161551,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161551,33.22,0.12,44,75570,74.4,NULL,'Pegasus CLUSTER, 17 galaxies, WISE W1 (3.4 micro-meter), color corrected','NGC 7619',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161552,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161552,33.23,0.12,44.3,75570,74.4,NULL,'Pegasus CLUSTER, 17 galaxies, WISE W2 (4.6 micro-meter), color corrected','NGC 7619',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161553,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161553,33.24,0.14,44.5,75570,75,NULL,'Pegasus cluster, avg. of 12 spiral galaxies','NGC 7619',NULL,'2013ApJ...765...94S',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161554,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161554,33.26,0.13,44.9,75570,75,NULL,'Pegasus cluster, avg. of 12 spiral galaxies','NGC 7619',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161555,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161555,33.3,0.4,45.7,75570,77,NULL,'Pegasus cluster, 12 galaxies','NGC 7619',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161556,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161556,33.3,NULL,45.7,75570,77,NULL,'BRIK, Pegasus cluster, 12 galaxies','NGC 7619',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161557,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161557,33.37,0.1,47.3,75570,74.4,NULL,'Pegasus CLUSTER, 17 galaxies, WISE W1 (3.4 micro-meter), curved','NGC 7619',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161558,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161558,33.42,0.1,48.2,75570,74.4,NULL,'Pegasus CLUSTER, 17 galaxies, WISE W2 (4.6 micro-meter), curved','NGC 7619',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161559,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161559,33.5,0.17,50.1,75570,NULL,NULL,'Pegasus cluster, avg. of 13 galaxies [for Virgo m-M = 31.10 mag, D = 16.6 Mpc]','NGC 7619',NULL,'1986A&A...164...17G',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161560,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161560,33.54,0.4,51,75570,NULL,NULL,'mean','NGC 7619',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161561,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161561,33.63,NULL,53.3,75570,71,NULL,'Pegasus CLUSTER, 80 galaxies','NGC 7619',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161562,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161562,33.66,0.45,54.1,75570,NULL,NULL,'K','NGC 7619',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161563,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161563,33.73,0.3,55.8,75570,NULL,NULL,'Pegasus CLUSTER, 14 galaxies','NGC 7619',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161564,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161564,33.81,0.14,57.8,75570,70,NULL,'Pegasus Cluster','NGC 7619',NULL,'1992ApJ...396..453H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161565,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161565,33.82,0.11,58.1,75570,71,NULL,'Pegasus I Cluster','NGC 7619',NULL,'1982PASAu...4..419V',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161566,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161566,35.15,0.8,107,75571,75,NULL,'W91PP, r','UGC 12528',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'15.16',0.4,'Sbc',NULL,NULL,NULL,NULL,1,350.082125,35.49144,0.281,NULL,51832138012,809877156,12654330,15.16),(161567,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161567,35.15,0.8,107,75571,75,NULL,'CF, r','UGC 12528',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161568,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161568,34.93,0.38,96.7,75571,75,NULL,'CF, r, raw','UGC 12528',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161569,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161569,35.04,0.38,102,75571,75,NULL,'CF, r, inv','UGC 12528',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161570,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161570,35.08,0.38,104,75571,75,NULL,'W91PP, r, raw','UGC 12528',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161571,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161571,35.13,0.38,106,75571,75,NULL,'CF, r, cor','UGC 12528',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161572,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161572,35.23,0.42,111,75571,NULL,NULL,'Malmquist cor.','UGC 12528',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161573,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161573,35.25,0.38,112,75571,75,NULL,'W91PP, r, inv','UGC 12528',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161574,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161574,35.3,0.38,115,75571,75,NULL,'W91PP, r, cor','UGC 12528',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161575,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161575,35.54,0.36,128,75571,NULL,NULL,NULL,'UGC 12528',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161576,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161576,35.55,0.2,129,75571,74.4,NULL,NULL,'UGC 12528',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161577,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005mq',NULL,161577,40.59,0.22,972,75572,74.2,NULL,'SALT 2','SDSS J232021.79-002059.6',0.35,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,350.090791667,-0.34989,0.093,NULL,49409640882,772025638,12062900,NULL),(161578,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005mq',NULL,161578,41.36,0.27,1380,75572,70,NULL,'SALT 2','SDSS J232021.79-002059.6',0.35,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161579,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 12136','R',161579,41.43,0.39,1430,75572,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005mq','SDSS J232021.79-002059.6',0.35,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161580,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 12136','R',161580,41.63,0.33,1570,75572,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005mq','SDSS J232021.79-002059.6',0.35,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161581,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161581,33.63,0.8,53.2,75573,75,NULL,'W91PP, r','NGC 7624',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000013,NULL,'13.82',0.7,'SBc;HII        Sbrst','Brightest group member',NULL,NULL,'Starburst',1,350.0942083,27.31569,0.209,NULL,52016576514,812759008,12699359,13.82),(161582,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161582,33.06,0.69,40.9,75573,100,NULL,'mid-IR','NGC 7624',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161583,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161583,33.43,0.2,48.5,75573,74.4,NULL,NULL,'NGC 7624',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161584,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161584,33.62,0.53,53,75573,NULL,NULL,NULL,'NGC 7624',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161585,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161585,33.62,0.47,53,75573,NULL,NULL,'H','NGC 7624',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161586,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161586,33.62,0.45,53,75573,NULL,NULL,'K','NGC 7624',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161587,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161587,33.65,0.46,53.8,75573,NULL,NULL,'J','NGC 7624',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161588,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161588,33.73,0.51,55.7,75573,NULL,NULL,'Malmquist cor.','NGC 7624',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161589,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161589,33.73,0.4,55.8,75573,NULL,NULL,'mean','NGC 7624',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161590,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161590,33.8,0.38,57.7,75573,75,NULL,'W91PP, r, raw','NGC 7624',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161591,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161591,33.98,0.38,62.7,75573,75,NULL,'W91PP, r, inv','NGC 7624',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161592,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161592,34.08,0.38,65.3,75573,75,NULL,'W91PP, r, cor','NGC 7624',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161593,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161593,35.45,0.46,123,75574,70,NULL,NULL,'CGCG 380-035',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000102,NULL,'14.7g',0.68,'E0',NULL,NULL,NULL,NULL,1,350.121125,-1.00242,0.129,NULL,49409265510,772019773,12062808,14.7),(161594,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161594,35.64,0.49,135,75574,70,NULL,NULL,'CGCG 380-035',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161595,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2006hk',NULL,161595,40.28,0.12,1140,75575,70,NULL,'Hubble residual 0.14 for z0.28900','SDSS-II SN 13757 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,350.123791667,-1.15803,0.121,NULL,49409189822,772018590,12062790,NULL),(161596,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2006hk',NULL,161596,40.32,0.22,1160,75575,70,NULL,'SDSS-II SN 13757','SDSS-II SN 13757 HOST',NULL,'2013MNRAS.434.1443X',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161597,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 13757','R',161597,41.06,0.22,1260,75575,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006hk','SDSS-II SN 13757 HOST',0.289,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161598,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 13757','R',161598,41.22,0.15,1360,75575,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006hk','SDSS-II SN 13757 HOST',0.289,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161599,'Faber-Jackson','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161599,33.3,0.44,45.7,75576,95,NULL,'Weighted Mean','NGC 7623',NULL,'1984ApJS...56...91D',1984,1,1.2,NULL,'G',0.00007,NULL,'13.88',0.9,'SA0^0^:','X-ray-bright group member',NULL,NULL,NULL,1,350.125083,8.39581,0.157,NULL,51746687116,808541986,12633468,13.88),(161600,'Faber-Jackson','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161600,33.66,0.46,54,75576,95,NULL,'Michard 1979a','NGC 7623',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161601,'Faber-Jackson','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161601,33.96,0.63,61.9,75576,95,NULL,'Michard 1979b, c','NGC 7623',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161602,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161602,33.61,0.25,52.7,75576,74.4,NULL,NULL,'NGC 7623',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161603,'Tertiary','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161603,33.11,0.5,41.9,75576,95,NULL,NULL,'NGC 7623',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161604,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161604,33.42,0.4,48.2,75576,NULL,NULL,'mean','NGC 7623',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161605,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161605,33.59,0.45,52.3,75576,NULL,NULL,'K','NGC 7623',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161606,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161606,31.81,0.4,23,75577,75,NULL,'B','NGC 7625',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.000003,NULL,'12.83',1.4,'SA(rs)a pec    HII',NULL,NULL,NULL,NULL,1,350.1255417,17.22556,0.065,NULL,52523261099,820675954,12823061,12.83),(161607,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19088',NULL,161607,39.46,0.54,779,75578,70,NULL,'SN photometric redshift distance, z photo =0.202 +/- 0.066','SDSS-II SN 19088',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','20.9g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,350.1267083,-0.34594,0.093,NULL,49409639293,772025613,12062900,20.9),(161608,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19088','R',161608,40.61,0.22,1030,75578,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19088',0.28304,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161609,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19088','R',161609,41.07,0.34,1280,75578,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19088',0.28304,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161610,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161610,33.65,0.47,53.7,75579,NULL,NULL,'H','UGC 12530',NULL,'2007A&A...465...71T',2007,1,1.4,'Haynes et al. (2011AJ....142..170H) give v = 5947 km/s.','G',0.000033,NULL,'14.46',1.3,'SBcd:',NULL,NULL,NULL,NULL,1,350.1309583,29.30717,0.337,NULL,52070299919,813598436,12712475,14.46),(161611,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161611,33.74,0.4,56,75579,NULL,NULL,'mean','UGC 12530',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161612,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161612,37.53,0.46,321,75580,70,NULL,NULL,'2MASX J23203821+1338351',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,350.159083,13.64297,0.101,NULL,52514626732,820541042,12820953,17.2),(161613,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161613,36.83,0.6,232,75581,70,NULL,NULL,'2MASX J23203832-2806065',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.26',0.42,NULL,NULL,NULL,NULL,NULL,1,350.159667,-28.10181,0.016,NULL,50142096438,783470256,12241722,16.26),(161614,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 12308',NULL,161614,40.1,0.29,1050,75582,70,NULL,'SN photometric redshift distance, z photo =0.284 +/- 0.050','SDSS-II SN 12308',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','20.9g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,350.175667,0.96519,0.145,NULL,51576675031,805885547,12591961,20.9),(161615,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 12308','R',161615,40.88,0.28,1170,75582,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 12308',0.279997,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161616,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 12308','R',161616,41.26,0.28,1400,75582,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 12308',0.279997,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161617,'SBF','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161617,32.83,0.18,36.8,75583,NULL,NULL,'BV A01','NGC 7626',NULL,'2007ApJ...668..130C',2007,1,2.6,'One of two 6cm sources associated with [WB92] 2318+0756','G',0.000013,NULL,'12.16',2.3,'E pec:         LINER','X-ray-bright group member',NULL,'radio jet',NULL,1,350.1772917,8.21697,0.161,NULL,51746522812,808539418,12633428,12.16),(161618,'SBF','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161618,33.34,0.12,46.6,75583,74.4,NULL,NULL,'NGC 7626',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161619,'SBF','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161619,33.67,0.13,54.2,75583,NULL,NULL,'J03','NGC 7626',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161620,'SBF','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161620,33.67,0.13,54.2,75583,NULL,NULL,'M06','NGC 7626',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161621,'SBF','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161621,33.83,0.13,58.3,75583,NULL,NULL,'T01','NGC 7626',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161622,'D-Sigma','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161622,33.21,0.4,43.8,75583,75,NULL,'Edat, raw','NGC 7626',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161623,'D-Sigma','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161623,33.3,0.4,45.6,75583,75,NULL,'Edat, cor','NGC 7626',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161624,'D-Sigma','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161624,33.52,0.22,50.5,75583,72,NULL,'Pegasus cluster, 4 galaxies','NGC 7626',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161625,'Faber-Jackson','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161625,32.56,0.34,32.5,75583,95,NULL,'de Vaucouleurs','NGC 7626',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161626,'Faber-Jackson','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161626,32.69,0.25,34.5,75583,95,NULL,'Weighted Mean','NGC 7626',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161627,'Faber-Jackson','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161627,33.25,0.46,44.7,75583,95,NULL,'Michard 1979a','NGC 7626',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161628,'Faber-Jackson','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161628,33.61,0.63,52.7,75583,95,NULL,'Michard 1979b, c','NGC 7626',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161629,'Faber-Jackson','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161629,34.16,0.81,67.9,75583,55,NULL,'Visvanathan & Sandage 1979','NGC 7626',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161630,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161630,33.34,0.12,46.6,75583,74.4,NULL,NULL,'NGC 7626',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161631,'Tertiary','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161631,33.11,0.5,41.9,75583,95,NULL,NULL,'NGC 7626',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161632,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161632,33.21,0.12,43.9,75583,74.4,NULL,'Pegasus CLUSTER, 17 galaxies, WISE I-band','NGC 7626',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161633,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161633,33.22,0.12,44,75583,74.4,NULL,'Pegasus CLUSTER, 17 galaxies, WISE W1 (3.4 micro-meter), color corrected','NGC 7626',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161634,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161634,33.23,0.12,44.3,75583,74.4,NULL,'Pegasus CLUSTER, 17 galaxies, WISE W2 (4.6 micro-meter), color corrected','NGC 7626',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161635,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161635,33.24,0.14,44.5,75583,75,NULL,'Pegasus cluster, avg. of 12 spiral galaxies','NGC 7626',NULL,'2013ApJ...765...94S',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161636,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161636,33.26,0.13,44.9,75583,75,NULL,'Pegasus cluster, avg. of 12 spiral galaxies','NGC 7626',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161637,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161637,33.3,0.4,45.7,75583,77,NULL,'Pegasus cluster, 12 galaxies','NGC 7626',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161638,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161638,33.3,NULL,45.7,75583,77,NULL,'BRIK, Pegasus cluster, 12 galaxies','NGC 7626',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161639,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161639,33.37,0.1,47.3,75583,74.4,NULL,'Pegasus CLUSTER, 17 galaxies, WISE W1 (3.4 micro-meter), curved','NGC 7626',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161640,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161640,33.42,0.1,48.2,75583,74.4,NULL,'Pegasus CLUSTER, 17 galaxies, WISE W2 (4.6 micro-meter), curved','NGC 7626',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161641,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161641,33.41,0.4,48.2,75583,NULL,NULL,'mean','NGC 7626',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161642,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161642,33.49,0.45,50,75583,NULL,NULL,'K','NGC 7626',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161643,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161643,33.5,0.17,50.1,75583,NULL,NULL,'Pegasus cluster, avg. of 13 galaxies [for Virgo m-M = 31.10 mag, D = 16.6 Mpc]','NGC 7626',NULL,'1986A&A...164...17G',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161644,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161644,33.63,NULL,53.3,75583,71,NULL,'Pegasus CLUSTER, 80 galaxies','NGC 7626',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161645,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161645,33.73,0.3,55.8,75583,NULL,NULL,'Pegasus CLUSTER, 14 galaxies','NGC 7626',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161646,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161646,33.81,0.14,57.8,75583,70,NULL,'Pegasus Cluster','NGC 7626',NULL,'1992ApJ...396..453H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161647,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161647,33.82,0.11,58.1,75583,71,NULL,'Pegasus I Cluster','NGC 7626',NULL,'1982PASAu...4..419V',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161648,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161648,37.74,0.33,353,75584,70,NULL,NULL,'SDSS J232045.32-090917.8',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000079,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,350.188875,-9.15497,0.071,NULL,49609907522,775154805,12111793,17.8),(161649,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','PTF09fox',NULL,161649,37.34,0.06,274,75585,70,NULL,'SiFTO+SALT2, SN PTF09fox','PTF09fox',0.0707,'2012MNRAS.426.2359M',2012,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,350.199916667,32.50228,0.297,NULL,52061739549,813464680,12710385,NULL),(161650,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','PTF09fox',NULL,161650,37.38,0.06,279,75585,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF09fox',0.0707,'2014MNRAS.438.1391P',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161651,'Tully est','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161651,25,0.8,1,75586,75,NULL,NULL,'ESO 347- G 008',NULL,'1988NBGC.C....0000T',1988,1,1.7,'RC3 velocity of 16+/-9 km/sec is a misprint. See 1998, A&AS, 127, 463.','G',0.000013,NULL,'14.61',1.4,'SAB(s)m',NULL,NULL,NULL,NULL,1,350.204583,-41.73083,NULL,0,50528478245,789507472,12336054,14.61),(161652,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161652,36.37,0.62,188,75587,70,NULL,NULL,'2MASX J23205143-0100409',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.000083,NULL,'16.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,350.21425,-1.01133,0.129,NULL,49412734376,772073974,12063655,16.4),(161653,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161653,34.44,0.8,77.2,75588,75,NULL,'W91PP, r','UGC 12533',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00001,NULL,'15.52',0.19,'Sbc',NULL,NULL,NULL,NULL,1,350.219875,23.8075,0.169,NULL,51990556694,812352448,12693007,15.52),(161654,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161654,34.44,0.8,77.2,75588,75,NULL,'MAT, I','UGC 12533',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161655,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161655,34.59,0.4,82.9,75588,NULL,NULL,'mean','UGC 12533',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161656,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161656,34.87,0.45,94,75588,NULL,NULL,'K','UGC 12533',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161657,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161657,34.89,0.47,95.2,75588,NULL,NULL,'H','UGC 12533',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161658,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161658,35.05,0.43,102,75588,75,NULL,'MAT, I, raw','UGC 12533',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161659,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161659,35.06,0.49,103,75588,75,NULL,'IR','UGC 12533',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161660,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161660,35.18,0.34,109,75588,NULL,NULL,NULL,'UGC 12533',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161661,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161661,35.18,0.34,109,75588,NULL,NULL,'Malmquist cor.','UGC 12533',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161662,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161662,35.2,0.32,110,75588,85,NULL,'I, raw','UGC 12533',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161663,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161663,35.22,0.2,111,75588,74.4,NULL,NULL,'UGC 12533',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161664,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161664,35.22,0.38,111,75588,75,NULL,'W91PP, r, raw','UGC 12533',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161665,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161665,35.27,0.32,113,75588,85,NULL,'I, inv','UGC 12533',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161666,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161666,35.31,0.43,115,75588,75,NULL,'MAT, I, cor','UGC 12533',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161667,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161667,35.33,0.43,116,75588,75,NULL,'MAT, I, inv','UGC 12533',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161668,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161668,35.4,0.38,120,75588,75,NULL,'W91PP, r, cor','UGC 12533',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161669,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161669,35.44,0.38,122,75588,75,NULL,'W91PP, r, inv','UGC 12533',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161670,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161670,35.48,NULL,125,75588,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12533',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161671,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161671,35.49,NULL,125,75588,NULL,NULL,'Dipole + Quadrupole','UGC 12533',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161672,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161672,35.5,NULL,126,75588,NULL,NULL,'Dipole','UGC 12533',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161673,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161673,35.74,NULL,141,75588,NULL,NULL,NULL,'UGC 12533',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161674,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 20874','RN',161674,39.74,0.16,785,75589,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 20874',0.130635,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161675,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 20874','RN',161675,40.1,0.28,926,75589,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 20874',0.130635,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161676,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161676,37.33,0.46,292,75590,70,NULL,NULL,'2MASX J23205652-0055236',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000074,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,350.2355,-0.92311,0.137,NULL,49412763946,772074436,12063663,18),(161677,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161677,32.39,0.43,30.1,75591,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12535',NULL,'2014MNRAS.444..527S',2014,1,1,NULL,'G',NULL,NULL,'15.65',0.1,'Sb-c',NULL,NULL,NULL,NULL,1,350.256583333,8.1795,0.157,NULL,51747178145,808549658,12633588,15.65),(161678,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161678,32.7,0.43,34.6,75591,75,NULL,'3.6 micron, color corrected','UGC 12535',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161679,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161679,32.93,0.2,38.6,75591,74.4,NULL,NULL,'UGC 12535',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161680,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161680,33.01,0.49,40.1,75591,75,NULL,'IR','UGC 12535',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161681,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161681,33.52,0.1,50.7,75591,NULL,NULL,NULL,'UGC 12535',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161682,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161682,34.44,0.2,77.3,75592,74.4,NULL,NULL,'CGCG 406-077',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',NULL,NULL,'15.6',0.2,NULL,NULL,NULL,NULL,NULL,1,350.256833333,7.91486,0.161,NULL,51747193394,808549896,12633592,15.6),(161683,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161683,33.38,0.49,47.5,75593,75,NULL,'IR','CGCG 476-015',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.000012,NULL,'15.7',0.3,'Sc',NULL,NULL,NULL,NULL,1,350.265875,26.41972,0.181,NULL,51989479822,812335622,12692744,15.7),(161684,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161684,33.38,0.8,47.4,75594,75,NULL,'W91CL, r','KUG 2318+078',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'15.21',0.5,'SB?','X-ray-bright group member',NULL,NULL,NULL,1,350.2740417,8.10239,0.161,NULL,51747184267,808549754,12633589,15.21),(161685,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161685,31.99,0.43,25,75594,75,NULL,'3.6 micron, color + selection bias corrected','KUG 2318+078',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161686,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161686,32.16,0.43,27,75594,75,NULL,'3.6 micron, color corrected','KUG 2318+078',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161687,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161687,33.31,0.38,45.9,75594,75,NULL,'W91CL, r, inv','KUG 2318+078',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161688,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161688,33.36,0.38,47.1,75594,75,NULL,'W91CL, r, raw','KUG 2318+078',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161689,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161689,33.52,0.08,50.7,75594,NULL,NULL,NULL,'KUG 2318+078',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161690,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161690,33.64,0.38,53.4,75594,75,NULL,'W91CL, r, cor','KUG 2318+078',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161691,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161691,34.26,0.2,71.1,75595,74.4,NULL,NULL,'KUG 2318+026',NULL,'2013AJ....146...86T',2013,1,0.9,'Incorrectly identified as IC 1482 in MCG.','G',0.000067,NULL,'15.26',0.6,'SBc',NULL,NULL,NULL,NULL,1,350.2795,2.88392,0.121,NULL,51772973851,808952716,12639886,15.26),(161692,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161692,35.54,0.46,128,75596,70,NULL,NULL,'CGCG 380-038',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000107,NULL,'15.5g',0.52,'E0',NULL,NULL,NULL,NULL,1,350.280083,0.39986,0.137,NULL,51577060618,805891572,12592055,15.5),(161693,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161693,34.5,0.8,79.3,75597,75,NULL,'W91PP, r','UGC 12537',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.00002,NULL,'15.03',0.7,'S?',NULL,NULL,NULL,NULL,1,350.282833,29.54956,0.265,NULL,52070386271,813599785,12712496,15.03),(161694,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161694,33.86,0.69,59.1,75597,100,NULL,'mid-IR','UGC 12537',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161695,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161695,35.27,0.38,113,75597,75,NULL,'W91PP, r, raw','UGC 12537',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161696,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161696,35.48,0.38,125,75597,75,NULL,'W91PP, r, cor','UGC 12537',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161697,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161697,35.53,0.38,128,75597,75,NULL,'W91PP, r, inv','UGC 12537',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161698,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161698,37.74,0.33,353,75598,70,NULL,NULL,'2MASX J23210857-0906239',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000068,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,350.285625,-9.10669,0.071,NULL,49609864024,775154125,12111783,17.4),(161699,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SN 2006B',NULL,161699,33.44,0.24,48,75599,74.2,NULL,'SALT 2','UGC 12538',0.016335,'2010ApJ...716..712A',2010,1,1,NULL,'G',0.000033,NULL,'14.80',0.3,'S?             HII',NULL,NULL,NULL,NULL,1,350.290833,33.39956,0.229,NULL,52053916969,813342452,12708475,14.8),(161700,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SN 2006B',NULL,161700,34.01,0.09,63.4,75599,74.4,NULL,NULL,'UGC 12538',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161701,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161701,33.99,0.8,62.8,75599,75,NULL,'W91PP, r','UGC 12538',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161702,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161702,33.82,0.4,58.1,75599,75,NULL,'HOSTS SN 2006B','UGC 12538',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161703,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161703,33.95,0.38,61.5,75599,75,NULL,'W91PP, r, raw','UGC 12538',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161704,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161704,34,0.38,63.1,75599,75,NULL,'W91PP, r, inv','UGC 12538',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161705,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161705,34.01,0.09,63.4,75599,74.4,NULL,NULL,'UGC 12538',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161706,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161706,34.21,0.38,69.4,75599,75,NULL,'W91PP, r, cor','UGC 12538',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161707,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 15353','R',161707,40.85,0.24,1140,75600,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J232109.99-001032.9',0.2996,'2014arXiv1401.3317S',2014,1,0.09,NULL,'G',0.0005,NULL,'20.3g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,350.291625,-0.17583,0.105,NULL,49412317720,772067464,12063554,20.3),(161708,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 15353','R',161708,41.01,0.18,1220,75600,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J232109.99-001032.9',0.2996,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161709,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 15353',NULL,161709,40.76,0.14,1420,75600,70,NULL,'SALT 2','SDSS J232109.99-001032.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161710,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 15353',NULL,161710,40.79,0.14,1440,75600,70,NULL,'SALT 2, Malmquist cor.','SDSS J232109.99-001032.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161711,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 19074','RN',161711,44.18,0.38,4570,75601,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19074',0.500167,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161712,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161712,36,0.39,158,75602,NULL,NULL,NULL,'2MASX J23211571+1831330',NULL,'2009ApJS..182..474S',2009,1,0.55,NULL,'G',0.000027,NULL,'15.52',NULL,'Scd',NULL,NULL,NULL,NULL,1,350.315541667,18.52592,0.077,NULL,52531018817,820797169,12824955,15.52),(161713,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161713,36.04,0.2,161,75602,74.4,NULL,NULL,'2MASX J23211571+1831330',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161714,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161714,36.06,0.38,163,75602,NULL,NULL,'Malmquist cor.','2MASX J23211571+1831330',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161715,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161715,38.03,0.46,405,75603,70,NULL,NULL,'2MASX J23211617+1528331',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000167,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,350.317583333,15.47578,0.109,NULL,52528852816,820763325,12824426,18),(161716,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161716,35.93,0.5,154,75604,70,NULL,NULL,'2MASX J23211640-2117211',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000093,NULL,'15.89',0.33,'S0',NULL,NULL,NULL,NULL,1,350.318333333,-21.28928,0.025,NULL,50311531792,786117684,12283088,15.89),(161717,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161717,33.44,0.8,48.9,75605,75,NULL,'W91CL, r','CGCG 406-082',NULL,'1997ApJS..109..333W',1997,1,0.8,NULL,'G',0.000023,NULL,'15.53',50.2,NULL,NULL,NULL,NULL,NULL,1,350.320958333,7.48117,0.209,NULL,51802229271,809409832,12647028,15.53),(161718,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161718,32.58,0.43,32.8,75605,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 406-082',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161719,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161719,32.85,0.43,37.1,75605,75,NULL,'3.6 micron, color corrected','CGCG 406-082',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161720,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161720,33.04,0.2,40.6,75605,74.4,NULL,NULL,'CGCG 406-082',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161721,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161721,33.33,0.38,46.3,75605,75,NULL,'W91CL, r, inv','CGCG 406-082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161722,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161722,33.35,0.38,46.8,75605,75,NULL,'W91CL, r, raw','CGCG 406-082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161723,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161723,33.62,0.38,53.1,75605,75,NULL,'W91CL, r, cor','CGCG 406-082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161724,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 15031','R',161724,37.56,0.05,316,75606,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2006iw','2MASX J23211915+0015329',0.030776,'2014arXiv1401.3317S',2014,1,0.48,NULL,'G',0.000061,NULL,'17.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,350.3299583,0.25911,0.137,NULL,51576858651,805888416,12592006,17.1),(161725,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 15031','R',161725,38.39,0.2,462,75606,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2006iw','2MASX J23211915+0015329',0.030776,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161726,'SNII optical','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SN 2006iw',NULL,161726,35.74,0.09,137,75606,NULL,NULL,'SCM 55 SNII','2MASX J23211915+0015329',0.030776,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161727,'SNII optical','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SN 2006iw',NULL,161727,35.91,0.11,147,75606,NULL,NULL,'SCM 15 SDSS SNII','2MASX J23211915+0015329',0.030776,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161728,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161728,35.64,0.46,135,75607,70,NULL,NULL,'2MASX J23212040-1005479',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000081,NULL,'16.2g',0.32,'S0',NULL,NULL,NULL,NULL,1,350.334917,-10.09661,0.047,NULL,49608815497,775137742,12111527,16.2),(161729,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161729,37.24,0.46,281,75608,70,NULL,NULL,'2MASX J23212094-0939099',NULL,'2015arXiv151105856S',2015,1,0.46,'This galaxy lenses a z = 0.532 object.','G',0.00009,NULL,'16.4g',0.32,'E',NULL,NULL,NULL,NULL,1,350.3372083,-9.65286,0.058,NULL,49610167069,775158860,12111857,16.4),(161730,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161730,35.64,0.6,134,75609,70,NULL,NULL,'CGCG 380-041',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.000078,NULL,'15.5g',0.42,'Sa',NULL,NULL,NULL,NULL,1,350.353291667,-0.98569,0.137,NULL,49412748051,772074188,12063659,15.5),(161731,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 15210','RN',161731,39.48,0.2,699,75610,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 15210',0.125956,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161732,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 15210','RN',161732,39.56,0.13,724,75610,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 15210',0.125956,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161733,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161733,33.29,0.8,45.5,75611,75,NULL,'HMCL, I','NGC 7631',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.00002,NULL,'13.93',0.7,'SA(r)b:','X-ray-bright group member',NULL,NULL,NULL,1,350.361125,8.21764,0.157,NULL,51747186361,808549786,12633590,13.93),(161734,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161734,33.29,0.8,45.5,75611,75,NULL,'W91CL, r','NGC 7631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161735,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161735,33.29,0.8,45.6,75611,75,NULL,'MAT, I','NGC 7631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161736,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161736,33.32,0.8,46.1,75611,75,NULL,'CF, r','NGC 7631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161737,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161737,33.32,0.4,46.1,75611,75,NULL,'HMCL, I, raw','NGC 7631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161738,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161738,33.34,0.32,46.6,75611,85,NULL,'I, raw','NGC 7631',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161739,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161739,33.39,0.32,47.6,75611,85,NULL,'I, inv','NGC 7631',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161740,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161740,33.41,0.43,48.1,75611,75,NULL,'MAT, I, raw','NGC 7631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161741,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161741,33.42,0.38,48.3,75611,75,NULL,'CF, r, raw','NGC 7631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161742,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161742,33.49,0.4,49.8,75611,75,NULL,'HMCL, I, inv','NGC 7631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161743,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161743,33.5,0.46,50,75611,NULL,NULL,'J','NGC 7631',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161744,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161744,33.52,0.4,50.5,75611,NULL,NULL,'mean','NGC 7631',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161745,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161745,33.52,0.38,50.7,75611,75,NULL,'W91CL, r, raw','NGC 7631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161746,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161746,33.54,0.47,51,75611,NULL,NULL,'H','NGC 7631',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161747,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161747,33.55,0.38,51.3,75611,75,NULL,'CF, r, inv','NGC 7631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161748,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161748,33.56,0.45,51.4,75611,NULL,NULL,'K','NGC 7631',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161749,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161749,33.57,0.07,51.9,75611,NULL,NULL,NULL,'NGC 7631',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161750,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161750,33.62,0.4,52.9,75611,75,NULL,'HMCL, I, cor','NGC 7631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161751,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161751,33.62,0.2,53,75611,74.4,NULL,NULL,'NGC 7631',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161752,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161752,33.63,0.43,53.3,75611,75,NULL,'MAT, I, inv','NGC 7631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161753,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161753,33.65,0.43,53.6,75611,75,NULL,'3.6 micron, color corrected','NGC 7631',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161754,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161754,33.66,0.38,53.9,75611,75,NULL,'W91CL, r, inv','NGC 7631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161755,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161755,33.69,0.38,54.7,75611,75,NULL,'CF, r, cor','NGC 7631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161756,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161756,33.74,0.43,56,75611,75,NULL,'MAT, I, cor','NGC 7631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161757,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161757,33.75,0.43,56.3,75611,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7631',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161758,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161758,33.78,0.38,57,75611,75,NULL,'W91CL, r, cor','NGC 7631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161759,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 16093','R',161759,41.23,0.26,1310,75612,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006oe','SDSS J232127.00+010756.9',0.34,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,350.3625,1.13247,0.137,NULL,51576821067,805887829,12591997,NULL),(161760,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 16093','R',161760,41.28,0.2,1340,75612,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006oe','SDSS J232127.00+010756.9',0.34,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161761,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SN 2006oe',NULL,161761,41.14,0.16,1690,75612,70,NULL,'SALT 2','SDSS J232127.00+010756.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161762,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SN 2006oe',NULL,161762,41.18,0.16,1720,75612,70,NULL,'SALT 2, Malmquist cor.','SDSS J232127.00+010756.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161763,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161763,34.73,NULL,88.5,75613,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2491',NULL,'2010Ap&SS.325..163P',2010,1,0.87,NULL,'G',0.000003,NULL,'15.95',0.12,'Sc',NULL,NULL,NULL,NULL,1,350.3665,26.47794,0.237,NULL,51985483342,812273177,12691768,15.95),(161764,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161764,34.75,NULL,89.3,75613,NULL,NULL,'Dipole + Quadrupole','FGC 2491',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161765,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161765,34.77,NULL,89.8,75613,NULL,NULL,'Dipole','FGC 2491',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161766,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161766,36,0.33,159,75614,70,NULL,NULL,'2MASX J23213017+1526224',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00018,NULL,'15.6g',0.39,'E0',NULL,NULL,NULL,NULL,1,350.375625,15.43953,0.109,NULL,52528860600,820763446,12824428,15.6),(161767,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161767,34.44,0.8,77.1,75615,75,NULL,'W91PP, r','UGC 12543',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000015,NULL,'15.44',0.2,'Scd:','in a triple',NULL,NULL,NULL,1,350.389583,27.11806,0.197,NULL,52016618767,812759668,12699369,15.44),(161768,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161768,34.44,0.8,77.2,75615,75,NULL,'CF, r','UGC 12543',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161769,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161769,33.27,0.44,45.1,75615,NULL,NULL,NULL,'UGC 12543',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161770,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161770,33.42,0.41,48.2,75615,NULL,NULL,'Malmquist cor.','UGC 12543',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161771,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161771,33.51,0.2,50.4,75615,74.4,NULL,NULL,'UGC 12543',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161772,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161772,34.05,0.38,64.5,75615,75,NULL,'W91PP, r, inv','UGC 12543',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161773,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161773,34.07,0.38,65.3,75615,75,NULL,'W91PP, r, raw','UGC 12543',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161774,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161774,34.36,0.38,74.3,75615,75,NULL,'W91PP, r, cor','UGC 12543',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161775,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161775,34.36,0.49,74.5,75615,75,NULL,'IR','UGC 12543',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161776,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161776,34.55,0.38,81.4,75615,75,NULL,'CF, r, raw','UGC 12543',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161777,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161777,34.6,0.38,83.2,75615,75,NULL,'CF, r, inv','UGC 12543',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161778,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161778,34.85,0.38,93.1,75615,75,NULL,'CF, r, cor','UGC 12543',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161779,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161779,37.34,0.46,294,75616,70,NULL,NULL,'2MASX J23213372+1459214',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,350.390541667,14.98944,0.101,NULL,52528217196,820753393,12824271,17.2),(161780,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161780,35.86,0.52,149,75617,70,NULL,NULL,'2MASX J23213731-7612342',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'16.2b',0.24,NULL,NULL,NULL,NULL,NULL,1,350.405291667,-76.2095,0.197,NULL,48432466595,756757290,11824332,16.2),(161781,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161781,35.7,0.34,138,75618,NULL,NULL,NULL,'ESO 347- G 010',NULL,'2009ApJS..182..474S',2009,1,0.95,NULL,'G',0.000033,NULL,'15.21',0.26,'Sb',NULL,NULL,NULL,NULL,1,350.416667,-39.20097,NULL,NULL,49967329819,780739528,12199055,15.21),(161782,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161782,35.74,0.2,141,75618,74.4,NULL,NULL,'ESO 347- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161783,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161783,35.82,0.33,146,75618,NULL,NULL,'Malmquist cor.','ESO 347- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161784,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161784,34.42,0.58,76.7,75619,70,NULL,NULL,'AM 2318-481',NULL,'2014MNRAS.445.2677S',2014,1,0.7,'1984MNRAS.210...69F has V = 10100: +- 200 km/s.','G',0.00015,NULL,'15.45',0.57,'S0',NULL,NULL,NULL,NULL,1,350.420375,-48.01558,NULL,NULL,50521348864,789396076,12334313,15.45),(161785,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161785,32.92,0.43,38.4,75620,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 406-086',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.00002,NULL,'15.5',0.6,'S','X-ray-bright group member',NULL,NULL,NULL,1,350.420667,8.99,0.113,NULL,51754221895,808659717,12635308,15.5),(161786,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161786,33.2,0.49,43.7,75620,75,NULL,'IR','CGCG 406-086',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161787,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SN 1972J','R',161787,33.55,NULL,51.3,75621,NULL,NULL,'Photographic','NGC 7634',NULL,'1988SSRv...48....1R',1988,1,1.2,NULL,'G',0.0001,NULL,'13.57',0.9,'SB0','X-ray-bright group member',NULL,NULL,NULL,1,350.424,8.88692,0.113,NULL,51754243467,808660054,12635313,13.57),(161788,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SN 1972J',NULL,161788,33.58,0.14,52,75621,60,NULL,NULL,'NGC 7634',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161789,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SN 1972J',NULL,161789,33.6,0.31,52,75621,67,NULL,NULL,'NGC 7634',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161790,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SN 1972J',NULL,161790,33.6,0.21,52.5,75621,66,NULL,NULL,'NGC 7634',NULL,'1994A&A...281...51M',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161791,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SN 1972J',NULL,161791,33.81,0.3,57.8,75621,60,NULL,'M(V) = -19.47 mag','NGC 7634',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161792,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SN 1972J',NULL,161792,33.9,0.3,60.3,75621,60,NULL,'M(B) = -19.48 mag','NGC 7634',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161793,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161793,33.09,0.4,41.4,75621,NULL,NULL,'mean','NGC 7634',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161794,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161794,33.41,0.45,48.2,75621,NULL,NULL,'K','NGC 7634',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161795,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161795,34.35,0.8,74.3,75622,75,NULL,'W91PP, r','UGC 12545',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000007,NULL,'15.06',0.5,'SBcd:','in a triple',NULL,NULL,NULL,1,350.424666667,27.07072,0.197,NULL,52015784711,812746636,12699166,15.06),(161796,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161796,34.03,0.38,63.9,75622,75,NULL,'W91PP, r, inv','UGC 12545',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161797,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161797,34.03,0.38,64.1,75622,75,NULL,'W91PP, r, raw','UGC 12545',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161798,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161798,34.31,0.38,72.8,75622,75,NULL,'W91PP, r, cor','UGC 12545',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161799,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161799,34.8,0.2,91.2,75623,74.4,NULL,NULL,'LSBC F677-03',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',NULL,NULL,'17.19',0.3,'Sm',NULL,NULL,NULL,NULL,1,350.440833,16.79056,0.061,NULL,52525357339,820708708,12823573,17.19),(161800,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161800,35.02,0.75,101,75623,NULL,NULL,NULL,'LSBC F677-03',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161801,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161801,35.2,0.69,110,75623,NULL,NULL,'Malmquist cor.','LSBC F677-03',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161802,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161802,32.24,0.43,28,75624,75,NULL,'3.6 micron, color + selection bias corrected','KUG 2319+090A',NULL,'2014MNRAS.444..527S',2014,1,0.6,NULL,'G',NULL,NULL,'15.6',0.5,'Spiral','Group member',NULL,NULL,NULL,1,350.442833,9.34189,0.113,NULL,51757461395,808710334,12636098,15.6),(161803,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 19769','R',161803,40.22,0.23,883,75625,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19769',0.252512,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,350.4435,-0.97642,0.137,NULL,49412852457,772075819,12063684,NULL),(161804,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 19769',NULL,161804,39.81,0.31,917,75625,70,NULL,'SN photometric redshift distance, z photo =0.243 +/- 0.044','SDSS-II SN 19769',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161805,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 19769','R',161805,40.33,0.16,930,75625,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19769',0.252512,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161806,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 19769',NULL,161806,40.03,0.12,1010,75625,70,NULL,'SALT 2','SDSS-II SN 19769',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161807,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 19769',NULL,161807,40.05,0.12,1020,75625,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19769',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161808,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161808,33.51,0.27,50.5,75626,NULL,NULL,NULL,'GALEX 2665332768378979438',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000017,NULL,'16.97',0.1,'Sbc',NULL,NULL,NULL,NULL,1,350.444583,9.04306,0.113,NULL,51754236935,808659952,12635311,16.97),(161809,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161809,34.04,0.8,64.4,75627,75,NULL,'HMCL, I','UGC 12547',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000023,NULL,'14.81',0.7,'SB?','Pair member (points to parent)',NULL,NULL,NULL,1,350.464875,5.00639,0.201,NULL,51769096208,808892128,12638939,14.81),(161810,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161810,34.05,0.8,64.5,75627,75,NULL,'W91CL, r','UGC 12547',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161811,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161811,33.21,0.2,43.9,75627,74.4,NULL,NULL,'UGC 12547',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161812,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161812,33.3,0.38,45.7,75627,75,NULL,'W91CL, r, inv','UGC 12547',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161813,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161813,33.32,0.38,46,75627,75,NULL,'W91CL, r, raw','UGC 12547',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161814,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161814,33.4,0.4,47.9,75627,75,NULL,'HMCL, I, raw','UGC 12547',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161815,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161815,33.44,0.4,48.8,75627,75,NULL,'HMCL, I, inv','UGC 12547',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161816,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161816,33.48,0.48,49.8,75627,NULL,NULL,NULL,'UGC 12547',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161817,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161817,33.59,0.38,52.3,75627,75,NULL,'W91CL, r, cor','UGC 12547',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161818,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161818,33.72,0.4,55.4,75627,75,NULL,'HMCL, I, cor','UGC 12547',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161819,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161819,33.75,0.42,56.1,75627,NULL,NULL,'Malmquist cor.','UGC 12547',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161820,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161820,36,0.33,159,75628,70,NULL,NULL,'2MASX J23215441+1518236',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00016,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,350.476667,15.30653,0.109,NULL,52527732342,820745817,12824153,16.4),(161821,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 01744','RN',161821,40.63,0.34,1130,75629,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 01744',0.189523,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161822,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 01744','RN',161822,40.84,0.25,1240,75629,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 01744',0.189523,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161823,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161823,33.52,0.49,50.5,75630,75,NULL,'IR','UGC 12548',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000103,NULL,'14.80',0.2,'Sa?','Pair member (points to parent)',NULL,NULL,NULL,1,350.488625,5.03581,0.201,NULL,51769096498,808892132,12638939,14.8),(161824,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 03849','RN',161824,42.58,0.61,2770,75631,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03849',0.183685,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161825,'Tully est','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161825,31.43,0.8,19.3,75632,75,NULL,NULL,'NGC 7632',NULL,'1988NBGC.C....0000T',1988,1,2.2,NULL,'G',0.000087,NULL,'12.95',1.1,'(RL)SB(1:)0^+  HII','X-ray-faint group member',NULL,NULL,NULL,1,350.50375,-42.4805,NULL,NULL,50528733302,789511457,12336116,12.95),(161826,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 15303','R',161826,40.7,0.21,1120,75633,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J232202.12+003227.3',0.234,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,NULL,'20.6g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,350.508875,0.54094,0.145,NULL,51576918046,805889344,12592021,20.6),(161827,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 15303','R',161827,40.85,0.14,1200,75633,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J232202.12+003227.3',0.234,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161828,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 15303',NULL,161828,40.61,0.11,1320,75633,70,NULL,'SALT 2','SDSS J232202.12+003227.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161829,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 15303',NULL,161829,40.63,0.11,1340,75633,70,NULL,'SALT 2, Malmquist cor.','SDSS J232202.12+003227.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161830,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161830,35.28,0.43,114,75634,NULL,NULL,'Malmquist cor.','UGC 12552',NULL,'2009ApJS..182..474S',2009,1,1.8,NULL,'G',0.000017,NULL,'15.32',0.3,'Sab',NULL,NULL,NULL,NULL,1,350.518875,13.03572,0.089,NULL,51626382426,806662225,12604097,15.32),(161831,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161831,35.37,0.42,118,75634,NULL,NULL,NULL,'UGC 12552',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161832,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161832,35.57,0.2,130,75634,74.4,NULL,NULL,'UGC 12552',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161833,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161833,36.47,0.65,197,75635,70,NULL,NULL,'2MASX J23220480-5330039',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'17.12',0.16,NULL,NULL,NULL,NULL,NULL,1,350.520125,-53.50111,0,NULL,48637868278,759966691,11874479,17.12),(161834,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 01373','RN',161834,41.83,0.12,1730,75636,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01373',0.347318,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161835,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 01373','RN',161835,41.87,0.2,1760,75636,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01373',0.347318,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161836,'TRGB','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161836,29.63,0.1,8.45,75637,74.4,NULL,NULL,'NGC 7640',NULL,'2013AJ....146...86T',2013,1,10.5,NULL,'G',0.000004,NULL,'11.86',2,'SB(s)c         HII','X-ray-bright group member',NULL,NULL,NULL,1,350.527417,40.84542,0.425,NULL,55335904729,864623511,13509742,11.86),(161837,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161837,29.78,0.8,9.05,75637,75,NULL,'A82, H','NGC 7640',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161838,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161838,29.23,0.4,7,75637,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 7640',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161839,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161839,29.47,0.47,7.84,75637,75,NULL,'A82, H, inv','NGC 7640',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161840,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161840,29.49,NULL,7.91,75637,NULL,NULL,NULL,'NGC 7640',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161841,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161841,29.51,0.47,7.99,75637,75,NULL,'A82, H, raw','NGC 7640',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161842,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161842,29.63,0.1,8.45,75637,74.4,NULL,NULL,'NGC 7640',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161843,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161843,29.68,0.4,8.6,75637,75,NULL,'B','NGC 7640',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161844,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161844,29.82,0.47,9.21,75637,75,NULL,'A82, H, cor','NGC 7640',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161845,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161845,29.97,0.35,9.86,75637,NULL,NULL,NULL,'NGC 7640',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161846,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161846,29.98,0.4,9.9,75637,73,NULL,'opt','NGC 7640',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161847,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161847,30.01,0.43,10,75637,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7640',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161848,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161848,30.22,0.43,11.1,75637,75,NULL,'3.6 micron, color corrected','NGC 7640',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161849,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161849,35.82,0.6,146,75638,70,NULL,NULL,'ESO 291- G 022',NULL,'2014MNRAS.445.2677S',2014,1,0.86,NULL,'G',0.000077,NULL,'15.38',0.44,'S?',NULL,NULL,NULL,NULL,1,350.548458333,-42.59558,NULL,NULL,50528675283,789510551,12336102,15.38),(161850,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161850,36.71,0.46,220,75639,70,NULL,NULL,'SDSS J232212.10+154706.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000117,NULL,'17.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,350.550417,15.78503,0.101,NULL,52528908311,820764192,12824440,17.7),(161851,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 00859','R',161851,40.49,0.22,981,75640,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 00859',0.278296,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,'PHOT','22.5g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,350.551667,0.38664,0.145,NULL,51574885736,805857589,12591524,22.5),(161852,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 00859','R',161852,40.54,0.15,1000,75640,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 00859',0.278296,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161853,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 00859',NULL,161853,40.23,0.14,1110,75640,70,NULL,'SN photometric redshift distance, z photo =0.305 +/- 0.025','SDSS-II SN 00859',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161854,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 00859',NULL,161854,40.37,0.12,1190,75640,70,NULL,'SALT 2','SDSS-II SN 00859',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161855,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 00859',NULL,161855,40.4,0.12,1200,75640,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 00859',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161856,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161856,37.72,0.46,350,75641,70,NULL,NULL,'2MASX J23221563+1518136',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000182,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,350.5652083,15.30375,0.109,NULL,52527735334,820745864,12824154,17),(161857,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161857,31.89,0.49,23.9,75642,75,NULL,'IR','ESO 536- G 003',NULL,'2011yCatp016004901K',2011,1,1.26,NULL,'G',NULL,NULL,'16.12',0.19,'Scd',NULL,NULL,NULL,NULL,1,350.566791667,-23.70122,0.041,NULL,50022546384,781602287,12212535,16.12),(161858,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 06415','RN',161858,39.18,0.25,580,75643,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 06415',0.183726,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161859,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 06415','RN',161859,39.64,0.32,715,75643,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 06415',0.183726,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161860,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161860,37.29,0.49,287,75644,NULL,NULL,'Malmquist cor.','2MASX J23222244+1700543',NULL,'2009ApJS..182..474S',2009,1,0.57,NULL,'G',0.000033,NULL,'14.62',NULL,'S/S0','Group member',NULL,NULL,NULL,1,350.5934583,17.015,0.073,NULL,52525507505,820711054,12823610,14.62),(161861,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161861,37.53,0.44,320,75644,NULL,NULL,NULL,'2MASX J23222244+1700543',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161862,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161862,37.57,0.2,327,75644,74.4,NULL,NULL,'2MASX J23222244+1700543',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161863,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161863,36.49,0.55,199,75645,70,NULL,NULL,'2MASX J23222282-7835026',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,350.5954583,-78.58411,0.341,NULL,48554936775,758670887,11854232,17.2),(161864,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161864,36.15,0.46,170,75646,70,NULL,NULL,'SDSS J232222.95+135938.3',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00035,NULL,'16.65',NULL,'E',NULL,NULL,NULL,NULL,1,350.595625,13.99397,0.101,NULL,52513958144,820530596,12820790,16.65),(161865,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161865,34.43,0.8,76.8,75647,75,NULL,'W91PP, r','UGC 12557',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'15.02',0.4,'S?',NULL,NULL,NULL,NULL,1,350.619333,29.18094,0.373,NULL,52015256328,812738380,12699037,15.02),(161866,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161866,34.6,0.4,83.1,75647,NULL,NULL,'mean','UGC 12557',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161867,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161867,34.71,0.46,87.4,75647,NULL,NULL,'J','UGC 12557',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161868,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161868,34.73,0.47,88.3,75647,NULL,NULL,'H','UGC 12557',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161869,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161869,34.81,0.45,91.6,75647,NULL,NULL,'K','UGC 12557',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161870,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161870,34.91,0.38,95.9,75647,75,NULL,'W91PP, r, raw','UGC 12557',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161871,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161871,34.96,0.49,98,75647,75,NULL,'IR','UGC 12557',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161872,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161872,35.06,0.31,103,75647,NULL,NULL,'Malmquist cor.','UGC 12557',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161873,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161873,35.08,0.31,104,75647,NULL,NULL,NULL,'UGC 12557',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161874,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161874,35.14,0.38,107,75647,75,NULL,'W91PP, r, cor','UGC 12557',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161875,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161875,35.18,0.38,109,75647,75,NULL,'W91PP, r, inv','UGC 12557',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161876,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161876,35.19,0.2,109,75647,74.4,NULL,NULL,'UGC 12557',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161877,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161877,38.23,0.46,443,75648,70,NULL,NULL,'SDSS J232230.46+000402.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00007,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,350.626958333,0.06747,0.117,NULL,51574849107,805857017,12591515,18.7),(161878,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161878,36.33,0.46,184,75649,70,NULL,NULL,'2MASX J23223202-1048095',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000068,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,350.633541667,-10.80272,0.067,NULL,49608277930,775129342,12111395,17.6),(161879,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161879,35.07,0.47,103,75650,NULL,NULL,'H','NGC 7627',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000033,NULL,'14.82',0.5,'Sa',NULL,NULL,NULL,NULL,1,350.628875,11.89256,0.113,NULL,51625571257,806649550,12603899,14.82),(161880,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161880,35.1,0.45,105,75650,NULL,NULL,'K','NGC 7627',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161881,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161881,35.19,0.4,109,75650,NULL,NULL,'mean','NGC 7627',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161882,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161882,35.23,0.46,111,75650,NULL,NULL,'J','NGC 7627',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161883,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161883,35.25,0.39,112,75650,NULL,NULL,'Malmquist cor.','NGC 7627',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161884,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161884,35.38,0.37,119,75650,NULL,NULL,NULL,'NGC 7627',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161885,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161885,35.76,0.2,142,75650,74.4,NULL,NULL,'NGC 7627',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161886,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161886,38.2,0.51,436,75651,NULL,NULL,'Malmquist cor.','AGC 331577',NULL,'2009ApJS..182..474S',2009,1,0.28,NULL,'G',0.00003,NULL,'18.5V',NULL,'Sc',NULL,NULL,NULL,NULL,1,350.634291667,16.78814,0.069,NULL,52525441735,820710027,12823594,18.5),(161887,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161887,38.21,0.51,438,75651,NULL,NULL,NULL,'AGC 331577',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161888,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161888,38.25,0.2,447,75651,74.4,NULL,NULL,'AGC 331577',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161889,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161889,36.44,0.09,194,75652,70,NULL,NULL,'2MASX J23223335+1440392',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000171,NULL,'16.9g',0.18,NULL,'Group member',NULL,NULL,NULL,1,350.638833,14.67744,0.113,NULL,52527530396,820742662,12824104,16.9),(161890,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161890,33.95,0.8,61.6,75653,75,NULL,'MAT, I','UGC 12555',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000023,NULL,'16.0',0.3,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,350.641875,5.12028,0.193,NULL,51769109161,808892330,12638942,16),(161891,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161891,33.95,0.8,61.7,75653,75,NULL,'W91CL, r','UGC 12555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161892,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161892,33.95,0.8,61.7,75653,75,NULL,'HMCL, I','UGC 12555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161893,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161893,33.92,0.32,60.9,75653,85,NULL,'I, inv','UGC 12555',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161894,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161894,33.93,0.32,61.2,75653,85,NULL,'I, raw','UGC 12555',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161895,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161895,34.15,0.4,67.6,75653,75,NULL,'HMCL, I, raw','UGC 12555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161896,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161896,34.17,0.38,68.2,75653,75,NULL,'W91CL, r, inv','UGC 12555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161897,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161897,34.18,0.38,68.6,75653,75,NULL,'W91CL, r, raw','UGC 12555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161898,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161898,34.19,0.43,68.8,75653,75,NULL,'MAT, I, raw','UGC 12555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161899,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161899,34.19,0.4,69,75653,75,NULL,'HMCL, I, inv','UGC 12555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161900,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161900,34.22,0.43,69.7,75653,75,NULL,'MAT, I, inv','UGC 12555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161901,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161901,34.37,0.38,74.7,75653,75,NULL,'W91CL, r, cor','UGC 12555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161902,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161902,34.38,0.4,75.3,75653,75,NULL,'HMCL, I, cor','UGC 12555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161903,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161903,34.45,0.43,77.6,75653,75,NULL,'MAT, I, cor','UGC 12555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161904,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161904,34.52,0.2,80.2,75653,74.4,NULL,NULL,'UGC 12555',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161905,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161905,34.58,0.5,82.4,75653,NULL,NULL,'Malmquist cor.','UGC 12555',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161906,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161906,34.6,0.49,83.1,75653,NULL,NULL,NULL,'UGC 12555',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161907,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161907,37.95,0.21,389,75654,70,NULL,NULL,'2MASX J23223437-1005202',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000089,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,350.643125,-10.089,0.046,NULL,49608473281,775132395,12111443,16.8),(161908,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161908,34.29,0.53,72,75655,70,NULL,NULL,'MCG -02-59-013',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00012,NULL,'14.41',0.8,'HII?',NULL,NULL,NULL,NULL,1,350.646958333,-13.09411,0.056,NULL,49561771267,774402676,12100041,14.41),(161909,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161909,34.22,0.69,69.7,75655,100,NULL,'mid-IR','MCG -02-59-013',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161910,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161910,34.83,0.2,92.5,75655,74.4,NULL,NULL,'MCG -02-59-013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161911,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161911,34.9,0.34,95.3,75655,NULL,NULL,'Malmquist cor.','MCG -02-59-013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161912,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161912,34.94,0.33,97.4,75655,NULL,NULL,NULL,'MCG -02-59-013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161913,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161913,37.08,0.46,261,75656,70,NULL,NULL,'2MASX J23223577-0105426',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000071,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,350.649208333,-1.09533,0.137,NULL,49412943296,772077239,12063706,17),(161914,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 04978',NULL,161914,40.07,0.27,1030,75657,70,NULL,'SN photometric redshift distance, z photo =0.279 +/- 0.045','SDSS-II SN 04978',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,350.6605,-0.42911,0.105,NULL,49411371123,772052673,12063323,NULL),(161915,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 04978',NULL,161915,40.45,0.18,1230,75657,70,NULL,'SALT 2','SDSS-II SN 04978',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161916,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 04978',NULL,161916,40.48,0.18,1250,75657,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 04978',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161917,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161917,36.71,0.46,219,75658,70,NULL,NULL,'2MASX J23223884-1005202',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000072,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,350.661833,-10.08886,0.046,NULL,49608474527,775132414,12111443,16.3),(161918,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161918,36.65,0.33,214,75659,70,NULL,NULL,'2MASX J23223958-1019242',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000086,NULL,'16.2g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,350.6649583,-10.32342,0.046,NULL,49608968679,775140135,12111564,16.2),(161919,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161919,38.38,0.46,475,75660,70,NULL,NULL,'2MASX J23223992-0833492',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000087,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,350.666416667,-8.56358,0.085,NULL,49604082557,775063789,12110371,17.8),(161920,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161920,37.12,0.78,266,75661,70,NULL,NULL,'6dF J2322424-365128',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,350.6767083,-36.85767,NULL,NULL,49975509606,780867337,12201052,15.6),(161921,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161921,36.65,0.33,214,75662,70,NULL,NULL,'2MASX J23224344-1026052',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000082,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,350.680916667,-10.43489,0.049,NULL,49609157375,775143083,12111610,16.6),(161922,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161922,35.25,0.8,112,75663,75,NULL,'MAT, I','UGC 12565',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'15.19',0.6,'S?',NULL,NULL,NULL,NULL,1,350.687166667,23.21133,0.145,NULL,52506228978,820409827,12818903,15.19),(161923,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161923,35.26,0.8,113,75663,75,NULL,'W91PP, r','UGC 12565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161924,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161924,34.92,0.32,96.5,75663,85,NULL,'I, raw','UGC 12565',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161925,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161925,34.96,0.32,98.4,75663,85,NULL,'I, inv','UGC 12565',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161926,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161926,34.99,0.43,99.5,75663,75,NULL,'MAT, I, raw','UGC 12565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161927,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161927,35.07,0.38,103,75663,75,NULL,'W91PP, r, raw','UGC 12565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161928,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161928,35.19,0.43,109,75663,75,NULL,'MAT, I, inv','UGC 12565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161929,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161929,35.2,0.38,110,75663,75,NULL,'W91PP, r, inv','UGC 12565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161930,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161930,35.27,0.38,113,75663,NULL,NULL,'Malmquist cor.','UGC 12565',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161931,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161931,35.27,0.43,113,75663,75,NULL,'MAT, I, cor','UGC 12565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161932,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161932,35.27,0.38,113,75663,75,NULL,'W91PP, r, cor','UGC 12565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161933,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161933,35.28,0.38,114,75663,NULL,NULL,NULL,'UGC 12565',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161934,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161934,35.32,0.2,116,75663,74.4,NULL,NULL,'UGC 12565',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161935,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161935,37.5,0.46,317,75664,70,NULL,NULL,'2MASX J23224552+0040134',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000091,NULL,'16.9g',0.32,NULL,NULL,NULL,NULL,NULL,1,350.6897083,0.67047,0.129,NULL,51576905471,805889147,12592017,16.9),(161936,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161936,34.54,0.4,81,75665,NULL,NULL,'mean','UGC 12566',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000033,NULL,'14.50',1.3,'Sab',NULL,NULL,NULL,NULL,1,350.691125,29.13781,0.373,NULL,52015248337,812738255,12699035,14.5),(161937,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161937,34.64,0.56,84.8,75665,NULL,NULL,NULL,'UGC 12566',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161938,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161938,34.68,0.2,86.3,75665,74.4,NULL,NULL,'UGC 12566',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161939,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161939,34.75,0.54,88.9,75665,NULL,NULL,'Malmquist cor.','UGC 12566',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161940,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161940,34.78,0.47,90.3,75665,NULL,NULL,'H','UGC 12566',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161941,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161941,34.84,0.45,92.9,75665,NULL,NULL,'K','UGC 12566',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161942,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161942,34.87,0.46,94.2,75665,NULL,NULL,'J','UGC 12566',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161943,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 03190','RN',161943,43.09,0.29,2800,75666,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03190',0.478684,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161944,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2006hl',NULL,161944,38.75,0.05,562,75667,70,NULL,'Hubble residual -0.10 for z0.14820','SDSS J232246.06+003156.2',NULL,'2011ApJ...740...92G',2011,1,0.14,NULL,'G',0.0005,NULL,'19.2g',0.1,NULL,NULL,NULL,NULL,NULL,1,350.6919583,0.53228,0.129,NULL,51574870127,805857345,12591521,19.2),(161945,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 13796','R',161945,39.14,0.18,587,75667,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006hl','SDSS J232246.06+003156.2',0.1482,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161946,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 13796','R',161946,39.33,0.07,641,75667,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006hl','SDSS J232246.06+003156.2',0.1482,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161947,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2006hl',NULL,161947,39.12,0.06,667,75667,70,NULL,'SALT 2','SDSS J232246.06+003156.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161948,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2006hl',NULL,161948,39.12,0.06,667,75667,70,NULL,'SALT 2, Malmquist cor.','SDSS J232246.06+003156.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161949,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161949,33.34,0.8,46.6,75668,75,NULL,'MAT, I','UGC 12562',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000013,NULL,'16.0',0.3,'Sdm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,350.697833333,11.77267,0.113,NULL,51625417944,806647155,12603861,16),(161950,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161950,33.36,0.8,47.1,75668,75,NULL,'W91CL, r','UGC 12562',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161951,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161951,33.38,0.8,47.4,75668,75,NULL,'CF, r','UGC 12562',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161952,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161952,32.94,0.32,38.8,75668,85,NULL,'I, inv','UGC 12562',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161953,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161953,32.98,0.32,39.4,75668,85,NULL,'I, raw','UGC 12562',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161954,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161954,33.01,0.2,40,75668,74.4,NULL,NULL,'UGC 12562',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161955,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161955,33.06,0.43,41,75668,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12562',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161956,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161956,33.07,0.43,41.1,75668,75,NULL,'3.6 micron, color corrected','UGC 12562',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161957,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161957,33.28,0.38,45.4,75668,75,NULL,'W91CL, r, inv','UGC 12562',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161958,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161958,33.37,0.38,47.2,75668,75,NULL,'W91CL, r, raw','UGC 12562',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161959,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161959,33.42,0.43,48.2,75668,75,NULL,'MAT, I, inv','UGC 12562',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161960,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161960,33.47,0.43,49.4,75668,75,NULL,'MAT, I, raw','UGC 12562',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161961,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161961,33.52,0.11,50.7,75668,NULL,NULL,NULL,'UGC 12562',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161962,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161962,33.64,0.38,53.5,75668,75,NULL,'W91CL, r, cor','UGC 12562',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161963,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161963,33.67,0.38,54.1,75668,75,NULL,'CF, r, inv','UGC 12562',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161964,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161964,33.72,0.38,55.4,75668,75,NULL,'CF, r, raw','UGC 12562',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161965,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161965,33.74,0.43,56,75668,75,NULL,'MAT, I, cor','UGC 12562',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161966,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161966,33.88,0.38,59.6,75668,75,NULL,'CF, r, cor','UGC 12562',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161967,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161967,36.06,0.8,163,75669,75,NULL,'W91PP, r','UGC 12564',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000097,NULL,'15.27',0.3,'Sd',NULL,NULL,NULL,NULL,1,350.6980417,22.93681,0.145,NULL,52506360309,820411879,12818935,15.27),(161968,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161968,36.06,0.8,163,75669,75,NULL,'CF, r','UGC 12564',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161969,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161969,35.71,0.38,139,75669,75,NULL,'W91PP, r, raw','UGC 12564',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161970,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161970,35.83,0.38,147,75669,75,NULL,'CF, r, raw','UGC 12564',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161971,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161971,35.91,0.38,152,75669,75,NULL,'W91PP, r, cor','UGC 12564',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161972,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161972,35.95,0.38,155,75669,75,NULL,'W91PP, r, inv','UGC 12564',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161973,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161973,35.95,0.33,155,75669,NULL,NULL,'Malmquist cor.','UGC 12564',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161974,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161974,36.04,0.38,161,75669,75,NULL,'CF, r, inv','UGC 12564',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161975,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161975,36.04,0.38,162,75669,75,NULL,'CF, r, cor','UGC 12564',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161976,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161976,36.21,0.2,175,75669,74.4,NULL,NULL,'UGC 12564',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161977,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161977,36.23,0.29,176,75669,NULL,NULL,NULL,'UGC 12564',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161978,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161978,37.15,0.53,269,75670,70,NULL,NULL,'2MASX J23224925-3753407',NULL,'2014MNRAS.445.2677S',2014,1,1.05,'APM image includes a bright star.','G',0.00015,NULL,'17.00',0.32,'Sc',NULL,NULL,NULL,NULL,1,350.705167,-37.89472,NULL,NULL,49968076206,780751190,12199237,17),(161979,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161979,33.55,0.07,51.4,75671,NULL,NULL,NULL,'NGC 7643',NULL,'2009ApJS..182..474S',2009,1,1.4,'Identification as NGC 7644 is doubtful; N7644 may be NGC 7651.','G',0.000023,NULL,'14.12',0.7,'Sc',NULL,NULL,NULL,NULL,1,350.71,11.98883,0.105,NULL,51625547280,806649176,12603893,14.12),(161980,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161980,33.63,0.4,53.1,75671,NULL,NULL,'mean','NGC 7643',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161981,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161981,33.63,0.2,53.2,75671,74.4,NULL,NULL,'NGC 7643',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161982,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161982,33.84,0.47,58.7,75671,NULL,NULL,'H','NGC 7643',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161983,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161983,33.86,0.46,59.3,75671,NULL,NULL,'J','NGC 7643',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161984,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161984,33.88,0.45,59.7,75671,NULL,NULL,'K','NGC 7643',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161985,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161985,35.74,0.46,140,75672,70,NULL,NULL,'2MASX J23225230-0100008',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.0001,NULL,'15.4g',0.51,'E0',NULL,NULL,NULL,NULL,1,350.718,-1.00025,0.141,NULL,49413045898,772078842,12063731,15.4),(161986,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161986,36.24,0.5,177,75672,70,NULL,NULL,'2MASX J23225230-0100008',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161987,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161987,37.95,0.21,389,75673,70,NULL,NULL,'2MASX J23225637-1002441',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000103,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,350.734833,-10.04564,0.046,NULL,49608511568,775132993,12111453,16.3),(161988,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161988,36.44,0.09,194,75674,70,NULL,NULL,'2MASXi J2322576+150551',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000191,NULL,'15.9g',0.45,'E0','Group member',NULL,NULL,NULL,1,350.740125,15.09744,0.109,NULL,52527798493,820746851,12824169,15.9),(161989,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161989,33.34,0.43,46.5,75675,75,NULL,'3.6 micron, color + selection bias corrected','FGC 284A',NULL,'2014MNRAS.444..527S',2014,1,1.12,NULL,'G',0.000017,NULL,'17.07',0.17,'Sc','X-ray-bright group member',NULL,NULL,NULL,1,350.74375,7.67228,0.181,NULL,51802693195,809417081,12647141,17.07),(161990,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161990,33.41,0.2,48.1,75675,74.4,NULL,NULL,'FGC 284A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161991,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161991,33.43,0.43,48.5,75675,75,NULL,'3.6 micron, color corrected','FGC 284A',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161992,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161992,33.52,0.13,50.7,75675,NULL,NULL,NULL,'FGC 284A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161993,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161993,33.29,0.8,45.5,75676,75,NULL,'MAT, I','UGC 12561',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00002,NULL,'15.74',0.4,'Sdm:','X-ray-bright group member',NULL,NULL,NULL,1,350.744,8.99353,0.109,NULL,51754538683,808664666,12635385,15.74),(161994,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161994,33.29,0.8,45.5,75676,75,NULL,'HMCL, I','UGC 12561',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161995,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161995,33.29,0.8,45.6,75676,75,NULL,'W91CL, r','UGC 12561',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161996,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161996,33.32,0.8,46.2,75676,75,NULL,'CF, r','UGC 12561',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161997,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161997,33.34,0.4,46.6,75676,75,NULL,'HMCL, I, raw','UGC 12561',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161998,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161998,33.36,0.4,46.9,75676,75,NULL,'HMCL, I, inv','UGC 12561',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161999,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161999,33.38,0.2,47.4,75676,74.4,NULL,NULL,'UGC 12561',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162000,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162000,33.45,0.43,48.9,75676,75,NULL,'3.6 micron, color corrected','UGC 12561',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162001,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162001,33.49,0.43,50,75676,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12561',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162002,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162002,33.51,0.25,50.5,75676,NULL,NULL,NULL,'UGC 12561',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162003,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162003,33.54,0.38,51.1,75676,75,NULL,'W91CL, r, inv','UGC 12561',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162004,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162004,33.58,0.38,51.9,75676,75,NULL,'W91CL, r, raw','UGC 12561',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162005,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162005,33.64,0.4,53.3,75676,75,NULL,'HMCL, I, cor','UGC 12561',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162006,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162006,33.68,0.32,54.4,75676,85,NULL,'I, inv','UGC 12561',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162007,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162007,33.69,0.32,54.6,75676,85,NULL,'I, raw','UGC 12561',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162008,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162008,33.83,0.38,58.3,75676,75,NULL,'W91CL, r, cor','UGC 12561',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162009,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162009,33.92,0.38,60.7,75676,75,NULL,'CF, r, inv','UGC 12561',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162010,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162010,33.92,0.38,60.9,75676,75,NULL,'CF, r, raw','UGC 12561',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162011,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162011,33.99,0.43,62.8,75676,75,NULL,'MAT, I, raw','UGC 12561',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162012,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162012,34.02,0.43,63.6,75676,75,NULL,'MAT, I, inv','UGC 12561',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162013,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162013,34.12,0.38,66.5,75676,75,NULL,'CF, r, cor','UGC 12561',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162014,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162014,34.23,0.43,70.2,75676,75,NULL,'MAT, I, cor','UGC 12561',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162015,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162015,35.45,0.59,123,75677,NULL,NULL,NULL,'AGC 330318',NULL,'2009ApJS..182..474S',2009,1,0.3,NULL,'G',0.00003,NULL,'17.31',0.2,'S/I','Group member',NULL,NULL,NULL,1,350.753875,16.79944,0.069,NULL,52525459370,820710302,12823598,17.31),(162016,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162016,35.49,0.2,125,75677,74.4,NULL,NULL,'AGC 330318',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162017,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162017,35.76,0.51,142,75677,NULL,NULL,'Malmquist cor.','AGC 330318',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162018,'BL Lac Luminosity','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162018,40.01,NULL,1000,75678,NULL,NULL,'Min. z = 0.27','1FGL J2323.0-4919',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,350.759,-49.322,NULL,NULL,48645782289,760090348,11876411,NULL),(162019,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162019,36.04,0.37,162,75679,NULL,NULL,'Malmquist cor.','2MASX J23230214+1732191',NULL,'2009ApJS..182..474S',2009,1,0.65,NULL,'G',0.000027,NULL,'14.31',NULL,'Sb:',NULL,NULL,NULL,NULL,1,350.7589583,17.53867,0.089,NULL,52530519352,820789364,12824833,14.31),(162020,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162020,36.19,0.34,173,75679,NULL,NULL,NULL,'2MASX J23230214+1732191',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162021,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162021,36.23,0.2,176,75679,74.4,NULL,NULL,'2MASX J23230214+1732191',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162022,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162022,36.44,0.09,194,75680,70,NULL,NULL,'2MASX J23230358+1424261',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.6g',0.18,NULL,'Group member',NULL,NULL,NULL,1,350.7647917,14.40733,0.113,NULL,52527580604,820743446,12824116,17.6),(162023,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162023,38.22,0.27,441,75681,70,NULL,NULL,'SDSS J232304.62+004956.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000075,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,350.7692917,0.83236,0.129,NULL,51577219836,805894059,12592094,18.7),(162024,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 13690','RN',162024,42.07,0.17,1700,75682,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13690',0.530337,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162025,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 15272','R',162025,40.48,0.23,973,75683,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J232305.28+000503.7',0.2803,'2014arXiv1401.3317S',2014,1,0.11,NULL,'G',0.01,NULL,'20.0g',0.07,NULL,NULL,NULL,NULL,NULL,1,350.772,0.08439,0.133,NULL,51574812730,805856448,12591507,20),(162026,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 15272','R',162026,40.71,0.16,1080,75683,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J232305.28+000503.7',0.2803,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162027,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 15272',NULL,162027,40.34,0.12,1170,75683,70,NULL,'SALT 2','SDSS J232305.28+000503.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162028,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 15272',NULL,162028,40.36,0.12,1180,75683,70,NULL,'SALT 2, Malmquist cor.','SDSS J232305.28+000503.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162029,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162029,37.47,0.46,312,75684,70,NULL,NULL,'2MASX J23230640-1015459',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,350.77675,-10.26267,0.046,NULL,49608956319,775139942,12111561,17.5),(162030,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162030,37.95,0.21,389,75685,70,NULL,NULL,'2MASX J23230837-1005119',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00015,NULL,'16.0g',0.43,'BrClG',NULL,NULL,NULL,NULL,1,350.784958333,-10.08653,0.046,NULL,49608513978,775133030,12111453,16),(162031,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162031,37.95,0.21,389,75686,70,NULL,NULL,'2MASX J23230843-1006499',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000102,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,350.78525,-10.11378,0.046,NULL,49608522168,775133158,12111455,17.3),(162032,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162032,36.09,0.46,165,75687,NULL,NULL,NULL,'2MASX J23231005+1738221',NULL,'2009ApJS..182..474S',2009,1,0.38,NULL,'G',0.000037,NULL,'16.19',NULL,'Sc',NULL,NULL,NULL,NULL,1,350.791833,17.63956,0.089,NULL,52544183976,821002874,12828169,16.19),(162033,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162033,36.11,0.45,167,75687,NULL,NULL,'Malmquist cor.','2MASX J23231005+1738221',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162034,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162034,36.13,0.2,168,75687,74.4,NULL,NULL,'2MASX J23231005+1738221',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162035,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162035,36.36,0.25,187,75688,74.4,NULL,NULL,'GIN 690',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000043,NULL,'16.11',NULL,'SB0','Group member',NULL,NULL,NULL,1,350.794583,16.91356,0.069,NULL,52525419241,820709675,12823588,16.11),(162036,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162036,36.59,0.16,208,75688,70,NULL,NULL,'GIN 690',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162037,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162037,36.13,0.25,168,75689,74.4,NULL,NULL,'UGC 12569',NULL,'2013AJ....146...86T',2013,1,0.69,NULL,'G',0.000027,NULL,'15.7g',0.54,'S?','Group member',NULL,NULL,NULL,1,350.799,14.90144,0.109,NULL,52528340439,820755319,12824301,15.7),(162038,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162038,36.35,0.09,186,75689,70,NULL,NULL,'UGC 12569',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162039,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162039,38.22,0.27,441,75690,70,NULL,NULL,'SDSS J232313.39+005638.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,350.805833,0.94394,0.141,NULL,51577190044,805893594,12592087,18.5),(162040,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162040,38.22,0.27,441,75691,70,NULL,NULL,'2MASX J23231608+0059228',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000096,NULL,'17.6g',0.21,'AGN',NULL,NULL,NULL,NULL,1,350.817083333,0.98972,0.141,NULL,51577179262,805893425,12592084,17.6),(162041,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162041,37.4,0.33,302,75692,70,NULL,NULL,'2MASX J23231769+1424301',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,350.823583,14.40853,0.113,NULL,52527409038,820740766,12824074,18),(162042,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162042,37.33,0.46,292,75693,70,NULL,NULL,'SDSS J232318.78-001957.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,350.82825,-0.33264,0.105,NULL,49411457976,772054030,12063344,18.4),(162043,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162043,36.76,0.46,225,75694,70,NULL,NULL,'2MASX J23232110+1322474',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,350.8377917,13.37994,0.097,NULL,51626486644,806663853,12604122,16.7),(162044,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162044,36.14,0.3,169,75695,NULL,NULL,'Malmquist cor.','2MASX J23232134+1417044',NULL,'2009ApJS..182..474S',2009,1,0.82,NULL,'G',0.000023,NULL,'15.9g',0.25,'Sab','Group member',NULL,NULL,NULL,1,350.8387917,14.28456,0.101,NULL,52513762887,820527545,12820742,15.9),(162045,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162045,36.27,0.28,179,75695,NULL,NULL,NULL,'2MASX J23232134+1417044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162046,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162046,36.31,0.2,183,75695,74.4,NULL,NULL,'2MASX J23232134+1417044',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162047,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162047,36.71,0.94,220,75696,70,NULL,NULL,'2MASX J23232159-5910027',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'16.09',0.4,'S0',NULL,NULL,NULL,NULL,1,350.8400417,-59.16742,0,NULL,48817031434,762766116,11918220,16.09),(162048,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162048,35.54,0.8,128,75697,75,NULL,'W91PP, r','UGC 12572',NULL,'1997ApJS..109..333W',1997,1,1.19,'Field star in the foreground.','G',0.00033,NULL,'15.6',0.24,'Sa             Sbrst',NULL,NULL,NULL,NULL,1,350.8412917,24.75083,0.157,NULL,51991321955,812364405,12693193,15.6),(162049,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162049,35.05,0.49,102,75697,75,NULL,'IR','UGC 12572',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162050,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162050,35.5,0.38,126,75697,75,NULL,'W91PP, r, raw','UGC 12572',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162051,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162051,35.66,0.38,136,75697,75,NULL,'W91PP, r, cor','UGC 12572',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162052,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162052,35.75,0.38,141,75697,75,NULL,'W91PP, r, inv','UGC 12572',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162053,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162053,35.76,0.4,142,75697,NULL,NULL,'mean','UGC 12572',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162054,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162054,35.86,0.08,149,75697,NULL,NULL,NULL,'UGC 12572',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162055,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162055,35.92,0.2,153,75697,74.4,NULL,NULL,'UGC 12572',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162056,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162056,36.06,0.47,163,75697,NULL,NULL,'H','UGC 12572',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162057,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162057,33.38,0.8,47.5,75698,75,NULL,'MAT, I','UGC 12571',NULL,'1997ApJS..109..333W',1997,1,1.14,NULL,'G',0.00002,NULL,'14.7g',0.62,'(R:)SB(r)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,350.843875,13.31922,0.097,NULL,51626490463,806663913,12604123,14.7),(162058,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162058,33.39,0.8,47.7,75698,75,NULL,'HMCL, I','UGC 12571',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162059,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162059,33.52,0.09,50.7,75698,NULL,NULL,NULL,'UGC 12571',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162060,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162060,33.99,0.32,62.7,75698,85,NULL,'I, raw','UGC 12571',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162061,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162061,34.02,0.32,63.8,75698,85,NULL,'I, inv','UGC 12571',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162062,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162062,34.17,0.2,68.2,75698,74.4,NULL,NULL,'UGC 12571',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162063,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162063,34.21,0.4,69.4,75698,75,NULL,'HMCL, I, raw','UGC 12571',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162064,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162064,34.23,0.43,70,75698,75,NULL,'MAT, I, raw','UGC 12571',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162065,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162065,34.34,0.4,73.9,75698,75,NULL,'HMCL, I, inv','UGC 12571',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162066,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162066,34.37,0.4,74.7,75698,75,NULL,'HMCL, I, cor','UGC 12571',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162067,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162067,34.41,0.43,76.1,75698,75,NULL,'MAT, I, inv','UGC 12571',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162068,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162068,34.43,0.43,77.1,75698,75,NULL,'MAT, I, cor','UGC 12571',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162069,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162069,37.95,0.21,389,75699,70,NULL,NULL,'2MASX J23232381-1002479',NULL,'2015arXiv151105856S',2015,1,0.26,'The APM position is 9 arcsec west of the nucleus.','G',0.000149,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,350.8492083,-10.04678,0.057,NULL,49608492450,775132694,12111448,17.6),(162070,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162070,37.41,0.46,304,75700,70,NULL,NULL,'2MASX J23232441-0946199',NULL,'2015arXiv151105856S',2015,1,0.21,'The APM position is 9 arcsec west of the nucleus.','G',0.000074,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,350.851625,-9.77231,0.053,NULL,49609681855,775151278,12111738,17.8),(162071,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162071,36.44,0.09,194,75701,70,NULL,NULL,'2MASX J23232515+1447254',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.0002,NULL,'16.6g',0.27,NULL,'Group member',NULL,NULL,NULL,1,350.854833,14.79031,0.109,NULL,52527490057,820742032,12824094,16.6),(162072,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 02569','RN',162072,40.85,0.26,1220,75702,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 02569',0.211247,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162073,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 02569','RN',162073,41.7,0.27,1800,75702,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 02569',0.211247,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162074,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162074,36.15,0.25,170,75703,74.4,NULL,NULL,'GIN 713',NULL,'2013AJ....146...86T',2013,1,0.65,NULL,'G',0.000033,NULL,'15.4g',0.48,'S','Group member',NULL,NULL,NULL,1,350.86125,14.13167,0.101,NULL,52513790952,820527983,12820749,15.4),(162075,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 21365','RN',162075,40.99,0.3,1230,75704,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 21365',0.282747,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162076,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 21365','RN',162076,41.09,0.91,1290,75704,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 21365',0.282747,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162077,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 05007','RN',162077,42.26,0.25,1950,75705,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05007',0.4523,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162078,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162078,36.22,0.43,175,75706,NULL,NULL,'Malmquist cor.','2MASX J23232939+1420194',NULL,'2009ApJS..182..474S',2009,1,0.53,NULL,'G',0.000027,NULL,'16.3',NULL,'Sc','Group member',NULL,NULL,NULL,1,350.8725,14.33883,0.101,NULL,52527407086,820740735,12824073,16.3),(162079,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162079,36.36,0.41,187,75706,NULL,NULL,NULL,'2MASX J23232939+1420194',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162080,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162080,36.4,0.2,191,75706,74.4,NULL,NULL,'2MASX J23232939+1420194',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162081,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162081,35.83,NULL,147,75707,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2494',NULL,'2010Ap&SS.325..163P',2010,1,0.87,NULL,'G',0.000017,NULL,'16.95',0.09,'Sd',NULL,NULL,NULL,NULL,1,350.886083,8.62406,0.141,NULL,51753678169,808651221,12635175,16.95),(162082,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162082,35.85,NULL,148,75707,NULL,NULL,'Dipole + Quadrupole','FGC 2494',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162083,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162083,35.87,NULL,149,75707,NULL,NULL,'Dipole','FGC 2494',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162084,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162084,36.03,0.49,161,75707,75,NULL,'IR','FGC 2494',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162085,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162085,38.29,0.46,455,75708,70,NULL,NULL,'2MASX J23233278+0035290',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000076,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,350.886625,0.59139,0.129,NULL,51575005041,805859453,12591553,17.8),(162086,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162086,36.44,0.09,194,75709,70,NULL,NULL,'2MASX J23233279+1437154',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000169,NULL,'16.2g',0.31,'E0','Group member',NULL,NULL,NULL,1,350.886708333,14.62097,0.109,NULL,52527601610,820743775,12824121,16.2),(162087,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162087,36.13,0.25,168,75710,74.4,NULL,NULL,'GIN 707',NULL,'2013AJ....146...86T',2013,1,0.43,NULL,'G',0.000033,NULL,'16.5g',0.34,'S','Group member',NULL,NULL,NULL,1,350.889333333,14.57689,0.109,NULL,52527606721,820743855,12824122,16.5),(162088,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162088,36.35,0.09,186,75710,70,NULL,NULL,'GIN 707',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162089,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162089,36.44,0.09,194,75711,70,NULL,NULL,'2MASX J23233361+1345214',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000207,NULL,'15.8g',0.4,'E0',NULL,NULL,NULL,NULL,1,350.890125,13.75606,0.101,NULL,51625847094,806653860,12603966,15.8),(162090,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162090,37.38,0.46,300,75712,70,NULL,NULL,'2MASX J23233498+0030070',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000078,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,350.895667,0.50194,0.129,NULL,51575024759,805859761,12591558,17.6),(162091,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 07457','R',162091,40.18,0.2,865,75713,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07457',0.254504,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,350.903125,-0.37225,0.157,NULL,49412001149,772062517,12063476,NULL),(162092,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 07457','R',162092,40.44,0.27,977,75713,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07457',0.254504,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162093,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162093,37.65,0.46,339,75714,70,NULL,NULL,'2MASX J23233671-0835347',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000084,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,350.903167,-8.59286,0.077,NULL,49606133488,775095835,12110872,17.2),(162094,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162094,36.44,0.09,194,75715,70,NULL,NULL,'2MASX J23233744+1339084',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000216,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,350.9060417,13.65225,0.093,NULL,51625767253,806652613,12603947,16.5),(162095,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162095,35.97,0.55,156,75716,NULL,NULL,NULL,'2MASXi J2323383+171813',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.00003,NULL,'16.00',0.1,'Sc',NULL,NULL,NULL,NULL,1,350.909833,17.30369,0.089,NULL,52517983366,820593490,12821773,16),(162096,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162096,36.05,0.53,162,75716,NULL,NULL,'Malmquist cor.','2MASXi J2323383+171813',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162097,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162097,36.41,0.2,191,75716,74.4,NULL,NULL,'2MASXi J2323383+171813',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162098,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162098,37.46,0.46,311,75717,70,NULL,NULL,'2MASX J23234023-1016567',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00009,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,350.9175417,-10.2825,0.044,NULL,49608599474,775134366,12111474,16.5),(162099,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162099,36.15,0.45,170,75718,NULL,NULL,'Malmquist cor.','2MASX J23234061+2440105',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000013,NULL,'14.0I',0.3,NULL,NULL,NULL,NULL,NULL,1,350.9192917,24.66961,0.157,NULL,51990841055,812356891,12693076,14),(162100,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162100,36.43,0.4,193,75718,NULL,NULL,NULL,'2MASX J23234061+2440105',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162101,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162101,36.47,0.2,197,75718,74.4,NULL,NULL,'2MASX J23234061+2440105',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162102,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162102,31.65,0.8,21.3,75719,75,NULL,'MAT, I','ESO 291- G 024',NULL,'1997ApJS..109..333W',1997,1,1.46,'Marginal HIPASS detection.','G',0.000032,NULL,'14.79',0.39,'SB(s)c: pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,350.919417,-42.40233,NULL,NULL,50528247421,789503865,12335997,14.79),(162103,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162103,31.76,0.4,22.5,75719,NULL,NULL,NULL,'ESO 291- G 024',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162104,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162104,31.76,0.4,22.5,75719,73,NULL,'opt','ESO 291- G 024',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162105,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162105,31.86,0.32,23.5,75719,85,NULL,'I, inv','ESO 291- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162106,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162106,31.88,0.32,23.8,75719,85,NULL,'I, raw','ESO 291- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162107,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162107,32.24,0.43,28,75719,75,NULL,'MAT, I, inv','ESO 291- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162108,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162108,32.29,0.43,28.7,75719,75,NULL,'MAT, I, raw','ESO 291- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162109,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162109,32.3,0.4,28.8,75719,73,NULL,'opt','ESO 291- G 024',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162110,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162110,32.39,0.52,30.1,75719,NULL,NULL,NULL,'ESO 291- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162111,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162111,32.39,0.52,30.1,75719,NULL,NULL,'Malmquist cor.','ESO 291- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162112,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162112,32.43,0.2,30.6,75719,74.4,NULL,NULL,'ESO 291- G 024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162113,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162113,32.49,0.43,31.5,75719,75,NULL,'MAT, I, cor','ESO 291- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162114,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 00716','RN',162114,40.53,0.05,966,75720,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 00716',0.324,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162115,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 00716','RN',162115,40.65,0.18,1020,75720,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 00716',0.324,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162116,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162116,37.61,0.46,333,75721,70,NULL,NULL,'SDSS J232345.03-095207.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000072,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,350.937667,-9.86886,0.053,NULL,49609482831,775148169,12111690,18.1),(162117,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162117,36.36,0.25,187,75722,74.4,NULL,NULL,'GIN 687',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.00004,NULL,'15.43',0.2,'S0/E','Group member',NULL,NULL,NULL,1,350.9484583,16.85236,0.049,NULL,52518059496,820594679,12821791,15.43),(162118,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162118,36.59,0.16,208,75722,70,NULL,NULL,'GIN 687',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162119,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162119,36.94,0.23,245,75723,70,NULL,NULL,'2MASX J23234815-0949477',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000078,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,350.950625,-9.82978,0.053,NULL,49609465566,775147899,12111685,17.8),(162120,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162120,36.39,0.25,190,75724,74.4,NULL,NULL,'GIN 683',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000033,NULL,'14.94',0.2,'S0/a','Group member',NULL,NULL,NULL,1,350.950958333,16.76881,0.049,NULL,52518000040,820593750,12821777,14.94),(162121,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162121,36.59,0.16,208,75724,70,NULL,NULL,'GIN 683',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162122,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162122,38.42,0.46,483,75725,70,NULL,NULL,'2MASX J23235033+1539199',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,350.9595417,15.6555,0.093,NULL,52527636578,820744321,12824130,17.8),(162123,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162123,36.24,0.39,177,75726,NULL,NULL,NULL,'AGC 331695',NULL,'2009ApJS..182..474S',2009,1,0.46,NULL,'G',0.00003,NULL,'16.82',NULL,'Sd',NULL,NULL,NULL,NULL,1,350.960875,13.89081,0.101,NULL,51625811788,806653309,12603957,16.82),(162124,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162124,36.23,0.39,177,75726,NULL,NULL,'Malmquist cor.','AGC 331695',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162125,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162125,36.28,0.2,180,75726,74.4,NULL,NULL,'AGC 331695',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162126,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162126,36.36,0.25,187,75727,74.4,NULL,NULL,'GIN 686',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00004,NULL,'14.91',0.4,'S0','Group member',NULL,NULL,NULL,1,350.961875,16.897,0.049,NULL,52518045066,820594454,12821788,14.91),(162127,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162127,36.59,0.16,208,75727,70,NULL,NULL,'GIN 686',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162128,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE n285',NULL,162128,41.65,0.3,1400,75728,74.2,NULL,'SALT 2','ESSENCE n285 HOST',0.528,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,350.9639583,-8.38847,0.068,NULL,49603956877,775061826,12110341,NULL),(162129,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE n285','R',162129,41.77,NULL,1480,75728,65,NULL,'SALT2','ESSENCE n285 HOST',0.528,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162130,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE n285',NULL,162130,42.45,0.43,2020,75728,65,NULL,'SALT2','ESSENCE n285 HOST',0.528,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162131,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE n285',NULL,162131,42.48,0.31,2050,75728,70,NULL,'SALT','ESSENCE n285 HOST',0.528,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162132,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE n285',NULL,162132,42.51,0.27,2070,75728,65,NULL,'MLCS2k2','ESSENCE n285 HOST',0.528,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162133,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE n285',NULL,162133,42.52,0.37,2090,75728,65,NULL,'SALT2','ESSENCE n285 HOST',0.528,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162134,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE n285',NULL,162134,42.55,0.28,2120,75728,65,NULL,'MLCS17','ESSENCE n285 HOST',0.528,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162135,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE n285',NULL,162135,42.62,0.26,2180,75728,65,NULL,'MLCS31','ESSENCE n285 HOST',0.528,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162136,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE n285',NULL,162136,42.62,0.38,2190,75728,65,NULL,'SALT','ESSENCE n285 HOST',0.528,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162137,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE n285',NULL,162137,42.63,0.24,2200,75728,65,NULL,'MLCS2k2','ESSENCE n285 HOST',0.528,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162138,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE n285',NULL,162138,42.88,0.3,2460,75728,65,NULL,'SALT','ESSENCE n285 HOST',0.528,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162139,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162139,36.34,0.25,185,75729,74.4,NULL,NULL,'KUG 2321+163',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.00003,NULL,'14.76',0.45,'Sc','Group member',NULL,NULL,NULL,1,350.964167,16.64483,0.049,NULL,52518861553,820607211,12821987,14.76),(162140,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162140,36.59,0.16,208,75729,70,NULL,NULL,'KUG 2321+163',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162141,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162141,36.94,0.23,245,75730,70,NULL,NULL,'2MASX J23235282-0952277',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,350.9702083,-9.87456,0.053,NULL,49609494499,775148351,12111692,17.4),(162142,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162142,36.23,0.14,176,75731,70,NULL,NULL,'ABELL 2589',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I      [BM]',NULL,NULL,NULL,NULL,1,350.972917,16.80889,0.049,NULL,52518054872,820594607,12821790,NULL),(162143,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162143,32.41,0.45,30.3,75732,NULL,NULL,'K','NGC 7648',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.00003,NULL,'13.77',1,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,350.975083333,9.66747,0.093,NULL,51753797168,808653080,12635204,13.77),(162144,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162144,33.38,0.4,47.4,75732,NULL,NULL,'mean','NGC 7648',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162145,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162145,36.38,0.25,189,75733,74.4,NULL,NULL,'GIN 684',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000037,NULL,'14.99',0.5,'E','Group member',NULL,NULL,NULL,1,350.976833333,16.68067,0.049,NULL,52518860603,820607196,12821987,14.99),(162146,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162146,36.59,0.16,208,75733,70,NULL,NULL,'GIN 684',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162147,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162147,35.2,0.49,110,75734,75,NULL,'IR','FGC 2495',NULL,'2011yCatp016004901K',2011,1,1.03,NULL,'G',0.000019,NULL,'16.08',0.1,'Sd',NULL,NULL,NULL,NULL,1,350.9785,9.81294,0.137,NULL,51757232571,808706758,12636043,16.08),(162148,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162148,35.72,NULL,139,75734,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2495',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162149,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162149,35.74,NULL,141,75734,NULL,NULL,'Dipole + Quadrupole','FGC 2495',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162150,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162150,35.76,NULL,142,75734,NULL,NULL,'Dipole','FGC 2495',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162151,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162151,35.78,NULL,143,75734,NULL,NULL,NULL,'FGC 2495',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162152,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162152,36.44,0.09,194,75735,70,NULL,NULL,'2MASX J23235542+1447409',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000063,NULL,'16.0g',0.35,'S0','Group member',NULL,NULL,NULL,1,350.9809583,14.79478,0.109,NULL,52527470463,820741725,12824089,16),(162153,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162153,36.15,0.25,170,75736,74.4,NULL,NULL,'GIN 715',NULL,'2013AJ....146...86T',2013,1,0.41,NULL,'G',0.000033,NULL,'16.8g',0.24,'S',NULL,NULL,NULL,NULL,1,350.981083,13.91064,0.101,NULL,51625810253,806653285,12603957,16.8),(162154,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 20491',NULL,162154,39.55,0.34,813,75737,70,NULL,'SN photometric redshift distance, z photo =0.212 +/- 0.041','SDSS-II SN 20491',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,350.981583333,-1.19331,0.141,NULL,49412250936,772066420,12063537,NULL),(162155,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162155,36.8,0.46,229,75738,70,NULL,NULL,'2MASX J23235706+0035266',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,350.987833333,0.59078,0.129,NULL,51575061143,805860330,12591567,16.6),(162156,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162156,36.36,0.25,187,75739,74.4,NULL,NULL,'NGC 7647',NULL,'2013AJ....146...86T',2013,1,2.16,NULL,'G',0.000033,NULL,'14.56',1.1,'cD;E;BrClG','Group member',NULL,NULL,NULL,1,350.9892917,16.77728,0.049,NULL,52518002325,820593786,12821777,14.56),(162157,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162157,36.59,0.16,208,75739,70,NULL,NULL,'NGC 7647',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162158,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162158,36.06,0.45,163,75739,NULL,NULL,'K','NGC 7647',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162159,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162159,36.09,0.4,165,75739,NULL,NULL,'mean','NGC 7647',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162160,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162160,36.23,0.14,176,75739,70,NULL,'ABELL 2589, BGC','NGC 7647',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162161,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162161,36.44,0.09,194,75740,70,NULL,NULL,'2MASX J23235762+1443509',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000117,NULL,'15.9g',0.31,'S0^-','Group member',NULL,NULL,NULL,1,350.99025,14.73083,0.109,NULL,52527479991,820741874,12824091,15.9),(162162,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162162,36.86,0.46,235,75741,70,NULL,NULL,'2MASX J23235873+0016526',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000071,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,350.99475,0.28142,0.121,NULL,51575115002,805861171,12591580,17.8),(162163,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 02395','RN',162163,40.62,0.23,1090,75742,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02395',0.217599,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162164,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 02395','RN',162164,41.28,0.24,1480,75742,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02395',0.217599,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162165,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162165,36.38,0.25,189,75743,74.4,NULL,NULL,'GIN 688',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000043,NULL,'15.60',NULL,'E','Group member',NULL,NULL,NULL,1,350.9957083,16.87492,0.049,NULL,52518057942,820594655,12821791,15.6),(162166,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162166,36.59,0.16,208,75743,70,NULL,NULL,'GIN 688',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162167,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162167,36.37,0.25,188,75744,74.4,NULL,NULL,'GIN 682',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000037,NULL,'14.63',NULL,'S0','Group member',NULL,NULL,NULL,1,350.996417,16.81128,0.049,NULL,52518055416,820594615,12821790,14.63),(162168,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162168,36.59,0.16,208,75744,70,NULL,NULL,'GIN 682',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162169,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162169,35.97,0.43,157,75745,NULL,NULL,NULL,'SDSS J232400.22+143348.4',NULL,'2009ApJS..182..474S',2009,1,0.37,NULL,'G',0.000023,NULL,'17.3g',0.16,'Sab','Group member',NULL,NULL,NULL,1,351.000917,14.56344,0.109,NULL,52527397540,820740586,12824071,17.3),(162170,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162170,36.01,0.2,159,75745,74.4,NULL,NULL,'SDSS J232400.22+143348.4',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162171,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162171,36.11,0.41,167,75745,NULL,NULL,'Malmquist cor.','SDSS J232400.22+143348.4',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162172,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162172,36.43,0.53,193,75746,70,NULL,NULL,'2MASX J23240020-0153140',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.38',0.33,NULL,NULL,NULL,NULL,NULL,1,351.000833,-1.88711,0.133,NULL,49410971286,772046426,12063225,16.38),(162173,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162173,37.81,0.23,364,75747,70,NULL,NULL,'2MASX J23240031-0057380',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000073,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,351.0012917,-0.96053,0.153,NULL,49412176800,772065262,12063519,17.8),(162174,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162174,35.86,NULL,148,75748,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12577',NULL,'2010Ap&SS.325..163P',2010,1,1.4,NULL,'G',0.00001,NULL,'16.0',0.17,'Sbc',NULL,NULL,NULL,NULL,1,351.001833,20.6845,0.117,NULL,52539153747,820924277,12826941,16),(162175,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162175,35.87,NULL,149,75748,NULL,NULL,'Dipole + Quadrupole','UGC 12577',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162176,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162176,35.88,NULL,150,75748,NULL,NULL,NULL,'UGC 12577',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162177,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162177,35.89,NULL,150,75748,NULL,NULL,'Dipole','UGC 12577',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162178,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162178,36.35,0.09,186,75749,70,NULL,NULL,'GIN 706',NULL,'2001MNRAS.321..277C',2001,1,0.33,NULL,'G',0.000027,NULL,'16.8g',0.24,'E','Group member',NULL,NULL,NULL,1,351.006,14.48172,0.101,NULL,52527424642,820741010,12824078,16.8),(162179,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162179,37.15,0.25,269,75749,74.4,NULL,NULL,'GIN 706',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162180,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162180,37.4,0.33,302,75749,70,NULL,NULL,'GIN 706',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162181,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162181,36.44,0.09,194,75750,70,NULL,NULL,'2MASX J23240307+1439539',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'16.9g',0.25,NULL,'Group member',NULL,NULL,NULL,1,351.01275,14.66511,0.109,NULL,52527599151,820743736,12824120,16.9),(162182,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162182,36.15,0.25,170,75751,74.4,NULL,NULL,'GIN 714',NULL,'2013AJ....146...86T',2013,1,0.39,NULL,'G',0.000033,NULL,'16.5g',0.33,'S','Group member',NULL,NULL,NULL,1,351.014375,13.94794,0.101,NULL,51625633687,806650526,12603914,16.5),(162183,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE m158',NULL,162183,41.22,0.27,1200,75752,74.2,NULL,'SALT 2','ESSENCE m158 HOST',0.463,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.014708333,-9.38839,0.073,NULL,49606640648,775103760,12110996,NULL),(162184,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE m158','R',162184,41.65,NULL,1460,75752,65,NULL,'SALT','ESSENCE m158 HOST',0.463,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162185,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE m158',NULL,162185,41.95,0.27,1680,75752,65,NULL,'SALT2','ESSENCE m158 HOST',0.463,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162186,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE m158',NULL,162186,41.95,0.27,1680,75752,70,NULL,'SALT','ESSENCE m158 HOST',0.463,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162187,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE m158',NULL,162187,42.06,0.24,1770,75752,65,NULL,'SALT','ESSENCE m158 HOST',0.463,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162188,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE m158',NULL,162188,42.11,0.27,1800,75752,65,NULL,'SALT2','ESSENCE m158 HOST',0.463,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162189,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE m158',NULL,162189,42.36,0.11,2030,75752,65,NULL,'SALT','ESSENCE m158 HOST',0.463,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162190,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE m158',NULL,162190,42.39,0.26,2060,75752,65,NULL,'MLCS2k2','ESSENCE m158 HOST',0.463,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162191,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE m158',NULL,162191,42.42,0.26,2090,75752,65,NULL,'MLCS17','ESSENCE m158 HOST',0.463,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162192,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE m158',NULL,162192,42.57,0.27,2230,75752,65,NULL,'MLCS31','ESSENCE m158 HOST',0.463,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162193,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE m158',NULL,162193,42.58,0.26,2240,75752,65,NULL,'MLCS2k2','ESSENCE m158 HOST',0.463,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162194,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162194,36.08,0.38,164,75753,NULL,NULL,'Malmquist cor.','2MASX J23240520+1639429',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.00014,NULL,'16.45',0.2,'Sb','Group member',NULL,NULL,NULL,1,351.021833333,16.66206,0.049,NULL,52518851999,820607062,12821985,16.45),(162195,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162195,36.1,0.37,166,75753,NULL,NULL,NULL,'2MASX J23240520+1639429',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162196,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162196,36.14,0.2,169,75753,74.4,NULL,NULL,'2MASX J23240520+1639429',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162197,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 08644','RN',162197,40.25,0.25,1000,75754,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 08644',0.118321,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162198,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 08644','RN',162198,40.41,0.2,1080,75754,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 08644',0.118321,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162199,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162199,36.15,0.25,170,75755,74.4,NULL,NULL,'2MASX J23240637+1425059',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000103,NULL,'17.19',0.2,NULL,'Group member',NULL,NULL,NULL,1,351.026583,14.41825,0.101,NULL,52527371885,820740185,12824065,17.19),(162200,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162200,34.34,0.47,73.7,75756,NULL,NULL,'H','NGC 7646',NULL,'2007A&A...465...71T',2007,1,0.9,'Identification as NGC 7646 is not certain.','G',0.000033,NULL,'14',0.5,'Sc             HII','Group member',NULL,NULL,NULL,1,351.029,-11.86069,0.091,NULL,49562175039,774408984,12100140,14),(162201,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162201,34.44,0.46,77.4,75756,NULL,NULL,'J','NGC 7646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162202,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162202,34.49,0.45,79,75756,NULL,NULL,'K','NGC 7646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162203,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162203,34.73,0.4,88.5,75756,NULL,NULL,'mean','NGC 7646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162204,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162204,35.49,0.79,125,75757,NULL,NULL,NULL,'2MASX J23240714+1450069',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000037,NULL,'16.3g',0.36,'Sc','Group member',NULL,NULL,NULL,1,351.029875,14.83517,0.109,NULL,52527469564,820741711,12824089,16.3),(162205,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162205,35.53,0.2,128,75757,74.4,NULL,NULL,'2MASX J23240714+1450069',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162206,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162206,35.57,0.76,130,75757,NULL,NULL,'Malmquist cor.','2MASX J23240714+1450069',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162207,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162207,35.3,0.64,115,75758,NULL,NULL,'Malmquist cor.','KUG 2321+130',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',NULL,NULL,'16.20',0.3,NULL,NULL,NULL,NULL,NULL,1,351.042625,13.30906,0.093,NULL,51626230801,806659856,12604060,16.2),(162208,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162208,35.34,0.62,117,75758,NULL,NULL,NULL,'KUG 2321+130',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162209,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162209,35.38,0.2,119,75758,74.4,NULL,NULL,'KUG 2321+130',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162210,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162210,36.44,0.09,194,75759,70,NULL,NULL,'2MASX J23241079+1443399',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000137,NULL,'16.8g',0.25,NULL,'Group member',NULL,NULL,NULL,1,351.0449583,14.72778,0.109,NULL,52527466180,820741659,12824088,16.8),(162211,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162211,36.44,0.09,194,75760,70,NULL,NULL,'2MASX J23241148+1441029',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00016,NULL,'17.0g',0.22,NULL,'Group member',NULL,NULL,NULL,1,351.04775,14.68419,0.109,NULL,52527465408,820741647,12824088,17),(162212,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162212,36.35,0.09,186,75761,70,NULL,NULL,'GIN 700',NULL,'2001MNRAS.321..277C',2001,1,0.57,NULL,'G',0.000027,NULL,'14.63',0.53,'E/S0','Group member',NULL,NULL,NULL,1,351.050083333,14.42408,0.101,NULL,52527374020,820740219,12824065,14.63),(162213,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162213,36.13,0.25,168,75762,74.4,NULL,NULL,'GIN 692',NULL,'2013AJ....146...86T',2013,1,0.57,NULL,'G',0.000027,NULL,'15.7g',0.52,'E/S0','Group member',NULL,NULL,NULL,1,351.050875,14.61889,0.109,NULL,52527385960,820740405,12824068,15.7),(162214,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162214,36.35,0.09,186,75762,70,NULL,NULL,'GIN 692',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162215,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162215,36.44,0.09,194,75762,70,NULL,NULL,'GIN 692',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162216,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','PTF10yux',NULL,162216,36.9,0.05,227,75763,70,NULL,'SiFTO+SALT2, SN PTF10yux','PTF10yux',0.0559,'2012MNRAS.426.2359M',2012,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.055791667,7.22853,0.177,NULL,51802490346,809413911,12647092,NULL),(162217,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','PTF10yux',NULL,162217,36.95,0.04,232,75763,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10yux',0.0559,'2014MNRAS.438.1391P',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162218,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162218,37.18,0.46,273,75764,70,NULL,NULL,'2MASX J23241436-1004176',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000139,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,351.05975,-10.07147,0.057,NULL,49608420036,775131563,12111430,17.9),(162219,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162219,36.15,0.25,170,75765,74.4,NULL,NULL,'GIN 711',NULL,'2013AJ....146...86T',2013,1,0.64,NULL,'G',0.00004,NULL,'16.0g',0.24,'E/S0','Group member',NULL,NULL,NULL,1,351.068833333,13.96647,0.101,NULL,51625626164,806650408,12603912,16),(162220,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 00692','RN',162220,38.7,0.13,458,75766,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 00692',0.197275,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162221,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162221,37.55,0.46,324,75767,70,NULL,NULL,'2MASX J23241865+0004162',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000069,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,351.0777917,0.07114,0.121,NULL,51574402180,805850034,12591406,18.5),(162222,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162222,36.38,0.25,189,75768,74.4,NULL,NULL,'GIN 689',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000037,NULL,'15.68',0.2,'SB0','Group member',NULL,NULL,NULL,1,351.0815417,16.73169,0.049,NULL,52518901233,820607831,12821997,15.68),(162223,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162223,36.59,0.16,208,75768,70,NULL,NULL,'GIN 689',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162224,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162224,36.14,0.25,169,75769,74.4,NULL,NULL,'NGC 7649',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000057,NULL,'14.98',0.9,'cD;E           AGN:','Group member',NULL,NULL,NULL,1,351.0837083,14.64714,0.109,NULL,52519011126,820609548,12822024,14.98),(162225,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162225,36.35,0.09,186,75769,70,NULL,NULL,'NGC 7649',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162226,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162226,35.68,0.45,137,75769,NULL,NULL,'K','NGC 7649',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162227,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162227,36.15,0.11,170,75769,70,NULL,'ABELL 2593, BGC','NGC 7649',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162228,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162228,36.21,0.4,175,75769,NULL,NULL,'mean','NGC 7649',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162229,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162229,36.15,0.11,170,75770,70,NULL,NULL,'ABELL 2593',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II     [BM]',NULL,NULL,NULL,NULL,1,351.084167,14.65111,0.109,NULL,52519011092,820609548,12822024,NULL),(162230,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162230,36.64,0.46,213,75771,70,NULL,NULL,'2MASX J23242089+0115393',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000073,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,351.087,1.26092,0.129,NULL,51576542528,805883477,12591929,16.4),(162231,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162231,36.44,0.09,194,75772,70,NULL,NULL,'2MASX J23242212+1506202',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'16.8g',0.28,NULL,'Group member',NULL,NULL,NULL,1,351.092167,15.1055,0.113,NULL,52519832331,820622380,12822224,16.8),(162232,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162232,36.35,0.09,186,75773,70,NULL,NULL,'GIN 696',NULL,'2001MNRAS.321..277C',2001,1,0.43,NULL,'G',0.00003,NULL,'14.80',0.38,'E/S0','Group member',NULL,NULL,NULL,1,351.095708333,14.6585,0.109,NULL,52519011068,820609547,12822024,14.8),(162233,'H I + optical distribution','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162233,33.11,0.2,41.8,75774,NULL,NULL,NULL,'UGC 12578',NULL,'1990ApJ...364...23S',1990,1,1.6,'Host galaxy of UM 160.  Identification as NGC 7667 is very unlikely.','G',0.000011,NULL,'14.54',1.1,'SB(s)m pec',NULL,NULL,NULL,NULL,1,351.09625,-0.10806,0.121,NULL,49411128718,772048886,12063263,14.54),(162234,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162234,31.17,0.2,17.1,75774,74.4,NULL,NULL,'UGC 12578',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162235,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162235,31.25,0.4,17.8,75774,NULL,NULL,NULL,'UGC 12578',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162236,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162236,31.64,0.62,21.3,75774,NULL,NULL,'Malmquist cor.','UGC 12578',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162237,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162237,31.78,0.58,22.7,75774,NULL,NULL,NULL,'UGC 12578',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162238,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162238,32.75,0.4,35.4,75774,75,NULL,'B','UGC 12578',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162239,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162239,36.14,0.25,169,75775,74.4,NULL,NULL,'GIN 699',NULL,'2013AJ....146...86T',2013,1,0.45,NULL,'G',0.000033,NULL,'14.62',0.39,'E','Group member',NULL,NULL,NULL,1,351.0982917,14.70711,0.109,NULL,52519125294,820611332,12822052,14.62),(162240,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162240,36.35,0.09,186,75775,70,NULL,NULL,'GIN 699',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162241,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003lm',NULL,162241,40.7,0.32,980,75776,74.2,NULL,'SALT 2','ESSENCE J232425.51-084551.1',0.408,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.106291667,-8.76419,0.113,NULL,49606271555,775097993,12110906,NULL),(162242,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003lm',NULL,162242,41.61,0.37,1490,75776,65,NULL,'SN f096, MLCS2k2','ESSENCE J232425.51-084551.1',0.408,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162243,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003lm','R',162243,41.72,NULL,1570,75776,65,NULL,'SN f096, SALT','ESSENCE J232425.51-084551.1',0.408,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162244,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003lm',NULL,162244,41.78,0.3,1610,75776,70,NULL,'SN f096, SALT','ESSENCE J232425.51-084551.1',0.408,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162245,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003lm',NULL,162245,41.83,0.34,1650,75776,65,NULL,'SN f096, SALT','ESSENCE J232425.51-084551.1',0.408,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162246,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003lm',NULL,162246,42.37,0.16,2120,75776,65,NULL,'SN f096, SALT','ESSENCE J232425.51-084551.1',0.408,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162247,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162247,36.15,0.25,170,75777,74.4,NULL,NULL,'NGC 7651 NED01',NULL,'2013AJ....146...86T',2013,1,1.13,NULL,'G',0.000037,NULL,'14.4g',0.76,'cD',NULL,NULL,NULL,NULL,1,351.108208333,13.97228,0.101,NULL,51625627161,806650424,12603912,14.4),(162248,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162248,36.44,0.09,194,75777,70,NULL,NULL,'NGC 7651 NED01',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162249,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162249,36.15,0.25,170,75778,74.4,NULL,NULL,'GIN 705',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000033,NULL,'16.4V',NULL,'E','Group member',NULL,NULL,NULL,1,351.1180417,14.69514,0.109,NULL,52519194422,820612412,12822068,16.4),(162250,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162250,36.35,0.09,186,75778,70,NULL,NULL,'GIN 705',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162251,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162251,36.44,0.09,194,75778,70,NULL,NULL,'GIN 705',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162252,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162252,37.81,0.23,364,75779,70,NULL,NULL,'2MASX J23242841-0048346',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000076,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,351.11825,-0.80964,0.165,NULL,49411704037,772057875,12063404,17),(162253,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162253,35.68,0.6,137,75780,70,NULL,NULL,'2MASX J23243032-8240444',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,351.1260417,-82.679,0.433,NULL,48344902488,755389101,11802954,17.3),(162254,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162254,37.81,0.23,364,75781,70,NULL,NULL,'2MASX J23243027-0056466',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000101,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,351.1262917,-0.94614,0.149,NULL,49411684029,772057562,12063399,17.2),(162255,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 03869','RN',162255,42,0.49,2260,75782,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03869',0.108236,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162256,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 03869','RN',162256,42.14,0.52,2410,75782,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03869',0.108236,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162257,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162257,36.12,0.25,167,75783,74.4,NULL,NULL,'GIN 712',NULL,'2013AJ....146...86T',2013,1,0.56,NULL,'G',0.00003,NULL,'14.63',0.39,'E/S0','Group member',NULL,NULL,NULL,1,351.1320417,14.27206,0.101,NULL,51637125883,806830091,12606720,14.63),(162258,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162258,36.35,0.09,186,75784,70,NULL,NULL,'GIN 693',NULL,'2001MNRAS.321..277C',2001,1,0.46,NULL,'G',0.000033,NULL,'14.75',0.45,'cD;E/S0','Group member',NULL,'radio jet',NULL,1,351.13375,14.63944,0.109,NULL,52519012932,820609577,12822024,14.75),(162259,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004hc',NULL,162259,43.45,0.11,2870,75785,65,NULL,'SN h311, MLCS2k2','ESSENCE J232432.67-084103.5',0.7,'2007ApJ...666..694W',2007,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.136125,-8.68431,0.061,NULL,49606084636,775095072,12110860,NULL),(162260,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004hc',NULL,162260,43.63,0.17,3140,75785,65,NULL,'SN h311, SALT','ESSENCE J232432.67-084103.5',0.7,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162261,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162261,34.05,0.8,64.7,75786,75,NULL,'MAT, I','UGC 12583',NULL,'1997ApJS..109..333W',1997,1,1.42,NULL,'G',0.000014,NULL,'15.53',0.19,'Scd',NULL,NULL,NULL,NULL,1,351.141833333,23.98678,0.157,NULL,51983151350,812236739,12691199,15.53),(162262,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162262,34.06,0.8,64.7,75786,75,NULL,'W91PP, r','UGC 12583',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162263,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162263,34.09,0.2,65.8,75786,74.4,NULL,NULL,'UGC 12583',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162264,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162264,34.29,NULL,72.1,75786,NULL,NULL,'Dipole + Quadrupole','UGC 12583',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162265,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162265,34.29,NULL,72.1,75786,NULL,NULL,'Dipole','UGC 12583',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162266,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162266,34.29,NULL,72.1,75786,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12583',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162267,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162267,34.29,0.49,72.2,75786,75,NULL,'IR','UGC 12583',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162268,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162268,34.36,NULL,74.6,75786,NULL,NULL,NULL,'UGC 12583',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162269,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162269,34.53,0.58,80.4,75786,NULL,NULL,NULL,'UGC 12583',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162270,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162270,34.62,0.38,84.1,75786,75,NULL,'W91PP, r, raw','UGC 12583',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162271,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162271,34.64,0.32,84.8,75786,85,NULL,'I, raw','UGC 12583',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162272,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162272,34.64,0.38,84.8,75786,75,NULL,'W91PP, r, inv','UGC 12583',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162273,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162273,34.65,0.32,85.3,75786,85,NULL,'I, inv','UGC 12583',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162274,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162274,34.69,0.53,86.7,75786,NULL,NULL,'Malmquist cor.','UGC 12583',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162275,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162275,34.79,0.43,90.6,75786,75,NULL,'MAT, I, raw','UGC 12583',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162276,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162276,34.88,0.43,94.8,75786,75,NULL,'MAT, I, inv','UGC 12583',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162277,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162277,34.92,0.38,96.2,75786,75,NULL,'W91PP, r, cor','UGC 12583',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162278,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162278,35.1,0.43,105,75786,75,NULL,'MAT, I, cor','UGC 12583',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162279,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162279,35.85,0.59,148,75787,70,NULL,NULL,'2MASX J23243476-5029255',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00011,NULL,'17.06',0.22,'S',NULL,NULL,NULL,NULL,1,351.14475,-50.49069,0,NULL,48649321545,760145649,11877275,17.06),(162280,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 01745','RN',162280,43.29,0.2,2860,75788,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01745',0.589572,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162281,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162281,36.15,0.25,170,75789,74.4,NULL,NULL,'GIN 698',NULL,'2013AJ....146...86T',2013,1,0.51,NULL,'G',0.000033,NULL,'14.90',0.19,'E','Group member',NULL,NULL,NULL,1,351.149208333,14.68292,0.109,NULL,52519192469,820612382,12822068,14.9),(162282,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162282,36.35,0.09,186,75789,70,NULL,NULL,'GIN 698',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162283,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 03871','RN',162283,43.11,0.22,2730,75790,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03871',0.537152,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162284,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162284,36.13,0.25,168,75791,74.4,NULL,NULL,'GIN 704',NULL,'2013AJ....146...86T',2013,1,0.4,'1990ApJ...360..436B have V = 12656 +- 50 km/s.','G',0.000037,NULL,'15.06',0.2,'E','Group member',NULL,NULL,NULL,1,351.153041667,14.58392,0.109,NULL,52519023573,820609743,12822027,15.06),(162285,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162285,36.35,0.09,186,75791,70,NULL,NULL,'GIN 704',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162286,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162286,36.15,0.25,170,75792,74.4,NULL,NULL,'MCG +02-59-037',NULL,'2013AJ....146...86T',2013,1,0.57,'MCG identification as IC 1487 is incorrect.','G',0.00003,NULL,'15.4g',0.49,'cD;E/S0','Group member',NULL,'NAT',NULL,1,351.155167,14.64244,0.109,NULL,52519023815,820609747,12822027,15.4),(162287,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162287,36.16,0.25,171,75792,74.4,NULL,NULL,'MCG +02-59-037',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162288,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162288,36.35,0.09,186,75792,70,NULL,NULL,'MCG +02-59-037',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162289,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162289,36.39,0.54,190,75793,NULL,NULL,'Malmquist cor.','2MASX J23243778+1453102',NULL,'2009ApJS..182..474S',2009,1,0.61,NULL,'G',0.000107,NULL,'15.8g',0.39,NULL,'Group member',NULL,NULL,NULL,1,351.157375,14.88606,0.113,NULL,52519172058,820612063,12822063,15.8),(162290,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162290,37,0.41,251,75793,NULL,NULL,NULL,'2MASX J23243778+1453102',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162291,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162291,37.04,0.2,256,75793,74.4,NULL,NULL,'2MASX J23243778+1453102',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162292,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162292,37.91,0.46,381,75794,70,NULL,NULL,'2MASX J23243821-1020262',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000164,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,351.159167,-10.34072,0.044,NULL,49608619464,775134679,12111479,17.2),(162293,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 15136','R',162293,39.11,0.18,577,75795,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2006ju','2MASX J23243894-0043046',0.148617,'2014arXiv1401.3317S',2014,1,0.21,NULL,'G',0.000047,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,351.16225,-0.71792,0.157,NULL,49411690007,772057656,12063400,17.9),(162294,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 15136','R',162294,39.19,0.09,599,75795,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2006ju','2MASX J23243894-0043046',0.148617,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162295,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2006ju',NULL,162295,38.91,0.07,605,75795,70,NULL,'SALT 2','2MASX J23243894-0043046',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162296,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2006ju',NULL,162296,38.92,0.07,608,75795,70,NULL,'SALT 2, Malmquist cor.','2MASX J23243894-0043046',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162297,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 08254','R',162297,39.91,0.21,806,75796,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J232439.30+004911.8',0.189,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',0.0005,NULL,'20.6g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,351.16375,0.81994,0.157,NULL,51574562683,805852541,12591445,20.6),(162298,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 08254','R',162298,39.98,0.17,833,75796,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J232439.30+004911.8',0.189,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162299,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 08254',NULL,162299,39.79,0.11,908,75796,70,NULL,'SALT 2','SDSS J232439.30+004911.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162300,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 08254',NULL,162300,39.8,0.11,912,75796,70,NULL,'SALT 2, Malmquist cor.','SDSS J232439.30+004911.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162301,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162301,36.44,0.09,194,75797,70,NULL,NULL,'2MASX J23243948+1432332',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'17.3g',0.21,NULL,'Group member',NULL,NULL,NULL,1,351.164583,14.5425,0.105,NULL,52519033005,820609890,12822029,17.3),(162302,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162302,36.13,0.25,168,75798,74.4,NULL,NULL,'GIN 697',NULL,'2013AJ....146...86T',2013,1,0.41,NULL,'G',0.00003,NULL,'16.6g',0.29,'S','Group member',NULL,NULL,NULL,1,351.165375,14.66744,0.109,NULL,52519204923,820612576,12822071,16.6),(162303,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162303,36.35,0.09,186,75798,70,NULL,NULL,'GIN 697',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162304,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162304,37.46,0.23,310,75799,70,NULL,NULL,'SDSS J232440.74-084620.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000075,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,351.1697917,-8.77236,0.061,NULL,49606075133,775094923,12110858,18.3),(162305,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162305,36.94,0.23,245,75800,70,NULL,NULL,'2MASX J23244092-0953532',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000153,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,351.170333,-9.89806,0.069,NULL,49606567893,775102623,12110978,17.1),(162306,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162306,36.13,0.25,168,75801,74.4,NULL,NULL,'CGCG 431-056',NULL,'2013AJ....146...86T',2013,1,1.9,NULL,'G',0.000037,NULL,'13.92',1.6,'E/S0','Group member',NULL,NULL,NULL,1,351.170583333,14.63206,0.109,NULL,52519019946,820609686,12822026,13.92),(162307,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162307,36.35,0.09,186,75802,70,NULL,NULL,'SDSS J232441.23+143801.3',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'*',NULL,NULL,'18.0g',NULL,'Point Src [SDSS]',NULL,NULL,NULL,NULL,1,351.171791667,14.63372,0.109,NULL,52519019948,820609686,12822026,18),(162308,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162308,33.09,NULL,41.4,75803,NULL,NULL,NULL,'FGC 2498',NULL,'2000BSAO...50....5K',2000,1,0.96,NULL,'G',0.000043,NULL,'16.8',0.09,'Sdm',NULL,NULL,NULL,NULL,1,351.175,-2.79167,0.129,NULL,49629138229,775455284,12116488,16.8),(162309,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162309,33.12,NULL,42,75803,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2498',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162310,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162310,33.13,NULL,42.3,75803,NULL,NULL,'Dipole + Quadrupole','FGC 2498',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162311,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162311,33.15,NULL,42.7,75803,NULL,NULL,'Dipole','FGC 2498',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162312,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE m075',NULL,162312,40.37,1.19,1080,75804,65,NULL,'SALT','ESSENCE m075 HOST',0.1,'2007ApJ...666..694W',2007,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.176167,-8.4855,0.061,NULL,49603943459,775061616,12110337,NULL),(162313,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE m075',NULL,162313,40.79,0.22,1300,75804,65,NULL,'MLCS2k2','ESSENCE m075 HOST',0.1,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162314,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162314,29.84,0.4,9.3,75805,75,NULL,'B','UGC 12588',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000013,NULL,'13.68',1.7,'Sdm','in a triple',NULL,NULL,NULL,1,351.17675,41.34678,0.425,NULL,55353274595,864894915,13513983,13.68),(162315,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162315,36.15,0.25,170,75806,74.4,NULL,NULL,'GIN 701',NULL,'2013AJ....146...86T',2013,1,0.5,'1990ApJ...360..436B has V = 13720 +- 50 km/s.','G',0.000027,NULL,'14.30',0.4,'S','Group member',NULL,NULL,NULL,1,351.177917,14.51839,0.105,NULL,52519041294,820610020,12822031,14.3),(162316,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162316,36.35,0.09,186,75806,70,NULL,NULL,'GIN 701',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162317,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 14046','RN',162317,41.69,0.45,1480,75807,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14046',0.474334,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162318,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 14046','N',162318,41.79,0.4,2280,75807,70,NULL,'SALT 2','SDSS-II SN 14046',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162319,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 14046','N',162319,41.9,0.4,2400,75807,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14046',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162320,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162320,37.46,0.23,310,75808,70,NULL,NULL,'2MASX J23244652-0847582',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000183,NULL,'17.0g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,351.1937917,-8.79944,0.075,NULL,49606078293,775094973,12110858,17),(162321,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162321,36.44,0.09,194,75809,70,NULL,NULL,'2MASX J23244711+1423011',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000189,NULL,'16.5g',0.27,NULL,'Group member',NULL,NULL,NULL,1,351.19625,14.38378,0.105,NULL,52518983922,820609123,12822017,16.5),(162322,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 02570','RN',162322,42.22,0.27,2070,75810,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02570',0.342015,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162323,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 02570','RN',162323,42.4,0.36,2250,75810,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02570',0.342015,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162324,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162324,37.81,0.23,364,75811,70,NULL,NULL,'2MASX J23244745-0054481',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000091,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,351.197666667,-0.91339,0.149,NULL,49411674735,772057417,12063397,17.8),(162325,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 18643','R',162325,38.8,0.1,515,75812,70,NULL,'SDSS CAND. Unknown; MLCS2K2; SN 2007lv','2MASX J23244792+0056390',0.118217,'2014arXiv1401.3317S',2014,1,0.28,NULL,'G',0.000112,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,351.1997917,0.94431,0.129,NULL,51574708632,805854822,12591481,17.5),(162326,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 18643','R',162326,38.8,0.18,515,75812,70,NULL,'SDSS CAND. Unknown; SALT 2; SN 2007lv','2MASX J23244792+0056390',0.118217,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162327,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162327,36.94,0.23,245,75813,70,NULL,NULL,'2MASX J23244884-0958102',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000162,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,351.203583,-9.96956,0.069,NULL,49609443077,775147548,12111680,16.5),(162328,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162328,36.14,0.25,169,75814,74.4,NULL,NULL,'IC 5319',NULL,'2013AJ....146...86T',2013,1,0.63,NULL,'G',0.000027,NULL,'15.4g',0.6,'E/S0           AGN','Group member',NULL,NULL,NULL,1,351.204,13.99653,0.101,NULL,51637356725,806833698,12606776,15.4),(162329,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162329,35.25,0.79,112,75815,NULL,NULL,'Malmquist cor.','2MASX J23244920+1358161',NULL,'2009ApJS..182..474S',2009,1,0.59,NULL,'G',0.000186,NULL,'15.9g',0.45,'S0/a','Group member',NULL,NULL,NULL,1,351.204875,13.97106,0.101,NULL,51637357582,806833712,12606776,15.9),(162330,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162330,35.34,0.75,117,75815,NULL,NULL,NULL,'2MASX J23244920+1358161',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162331,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162331,35.38,0.2,119,75815,74.4,NULL,NULL,'2MASX J23244920+1358161',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162332,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162332,33.89,0.05,60.1,75816,NULL,NULL,NULL,'NGC 7653',NULL,'2009ApJS..182..474S',2009,1,1.59,NULL,'G',0.000033,NULL,'13.4g',1.19,'Sb',NULL,NULL,NULL,NULL,1,351.205667,15.27558,0.093,NULL,52519592701,820618635,12822166,13.4),(162333,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162333,37.46,0.23,310,75817,70,NULL,NULL,'2MASX J23245347-0848382',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000086,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,351.2227917,-8.81053,0.075,NULL,49606082049,775095032,12110859,17.9),(162334,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162334,36.62,1.03,211,75818,70,NULL,NULL,'2MASX J23245643-1204591',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.4',NULL,NULL,'Group member',NULL,NULL,NULL,1,351.235125,-12.08311,0.079,NULL,49573607105,774587611,12102931,15.4),(162335,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162335,35.34,0.32,117,75819,NULL,NULL,NULL,'ESO 605- G 006',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.87',0.4,'Sc','in a triple',NULL,NULL,NULL,1,351.2545417,-18.85889,0,NULL,50328842129,786388158,12287314,15.87),(162336,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162336,35.38,0.2,119,75819,74.4,NULL,NULL,'ESO 605- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162337,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162337,35.49,0.3,125,75819,NULL,NULL,'Malmquist cor.','ESO 605- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162338,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162338,34.97,0.69,98.6,75820,100,NULL,'mid-IR','CGCG 406-102',NULL,'2013ApJ...771...88L',2013,1,0.6,NULL,'G',0.000103,NULL,'15.2',0.3,NULL,NULL,NULL,NULL,NULL,1,351.257041667,8.26561,0.161,NULL,51801798283,809403098,12646923,15.2),(162339,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162339,35.02,0.2,101,75820,74.4,NULL,NULL,'CGCG 406-102',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162340,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 00883','RN',162340,42.48,0.21,2410,75821,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 00883',0.302223,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162341,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 00883','RN',162341,42.67,0.25,2620,75821,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 00883',0.302223,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162342,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162342,36,0.42,159,75822,NULL,NULL,NULL,'SDSS J232508.25+151758.2',NULL,'2009ApJS..182..474S',2009,1,0.64,NULL,'G',0.00003,NULL,'16.4g',0.44,'Sc',NULL,NULL,NULL,NULL,1,351.284416667,15.2995,0.093,NULL,52519868582,820622946,12822233,16.4),(162343,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162343,36.04,0.2,161,75822,74.4,NULL,NULL,'SDSS J232508.25+151758.2',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162344,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162344,36.1,0.4,166,75822,NULL,NULL,'Malmquist cor.','SDSS J232508.25+151758.2',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162345,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162345,36.21,0.34,174,75823,NULL,NULL,'Malmquist cor.','AGC 331592',NULL,'2009ApJS..182..474S',2009,1,0.46,NULL,'G',0.00003,NULL,'16.68',NULL,'Sc',NULL,NULL,NULL,NULL,1,351.285291667,16.37661,0.077,NULL,52518297650,820598400,12821850,16.68),(162346,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162346,36.25,0.33,178,75823,NULL,NULL,NULL,'AGC 331592',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162347,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162347,36.3,0.2,182,75823,74.4,NULL,NULL,'AGC 331592',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162348,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162348,36.27,0.36,180,75824,NULL,NULL,'Malmquist cor.','SDSS J232508.92+150944.4',NULL,'2009ApJS..182..474S',2009,1,0.36,NULL,'G',0.00003,NULL,'17.5g',0.15,'Scd','Group member',NULL,NULL,NULL,1,351.287167,15.16236,0.089,NULL,52519894201,820623346,12822239,17.5),(162349,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162349,36.48,0.33,197,75824,NULL,NULL,NULL,'SDSS J232508.92+150944.4',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162350,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162350,36.52,0.2,201,75824,74.4,NULL,NULL,'SDSS J232508.92+150944.4',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162351,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 09962',NULL,162351,40.18,1.09,1090,75825,70,NULL,'SN photometric redshift distance, z photo =0.296 +/- 0.266','SDSS-II SN 09962',NULL,'2011ApJ...738..162S',2011,1,0.1,NULL,'G',NULL,'PHOT','20.2g',0.08,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,351.2924583,-0.30808,0.145,NULL,49411210497,772050164,12063283,20.2),(162352,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 09962','R',162352,41.21,0.33,1320,75825,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 09962',0.325121,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162353,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 09962','R',162353,41.28,0.33,1360,75825,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 09962',0.325121,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162354,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 09962',NULL,162354,41.01,0.23,1590,75825,70,NULL,'SALT 2','SDSS-II SN 09962',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162355,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 09962',NULL,162355,41.05,0.23,1620,75825,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 09962',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162356,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162356,36.15,0.31,170,75826,NULL,NULL,NULL,'2MASXi J2325107+141257',NULL,'2009ApJS..182..474S',2009,1,0.42,NULL,'G',0.000033,NULL,'17.3g',0.14,'Sc','Group member',NULL,NULL,NULL,1,351.2949583,14.21619,0.105,NULL,51637163852,806830685,12606729,17.3),(162357,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162357,36.18,0.31,172,75826,NULL,NULL,'Malmquist cor.','2MASXi J2325107+141257',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162358,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162358,36.19,0.2,173,75826,74.4,NULL,NULL,'2MASXi J2325107+141257',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162359,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162359,37.46,0.23,310,75827,70,NULL,NULL,'2MASX J23251200-0847352',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000135,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,351.300083333,-8.79325,0.075,NULL,49606070934,775094858,12110857,17.9),(162360,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162360,37.7,0.46,346,75828,70,NULL,NULL,'2MASX J23251294+1547397',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000156,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,351.3039583,15.79431,0.073,NULL,52519535017,820617734,12822152,17),(162361,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162361,36.24,0.33,177,75829,70,NULL,NULL,'2MASX J23251682+1421357',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000208,NULL,'15.6g',0.37,'E0','Group member',NULL,NULL,NULL,1,351.319916667,14.35989,0.105,NULL,51632990754,806765480,12605710,15.6),(162362,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162362,36.76,0.75,224,75830,70,NULL,NULL,'2MASX J23251716-5318320',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.65',0.28,NULL,NULL,NULL,NULL,NULL,1,351.321417,-53.30897,0,NULL,48641138824,760017794,11875278,16.65),(162363,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162363,38.06,0.46,409,75831,70,NULL,NULL,'SDSS J232517.17-002701.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000065,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,351.3215417,-0.45033,0.149,NULL,49411169125,772049517,12063273,18.8),(162364,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162364,36.27,0.32,180,75832,NULL,NULL,'Malmquist cor.','2MASX J23251720+1447177',NULL,'2009ApJS..182..474S',2009,1,0.53,NULL,'G',0.000023,NULL,'16.3g',0.24,'Sc','Group member',NULL,NULL,NULL,1,351.321583,14.78828,0.113,NULL,52519238989,820613109,12822079,16.3),(162365,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162365,36.43,0.3,194,75832,NULL,NULL,NULL,'2MASX J23251720+1447177',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162366,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162366,36.47,0.2,197,75832,74.4,NULL,NULL,'2MASX J23251720+1447177',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162367,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 13797','RN',162367,40.78,0.36,1120,75833,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13797',0.279324,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162368,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 13797','RN',162368,40.98,0.38,1230,75833,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13797',0.279324,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162369,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162369,36.44,0.09,194,75834,70,NULL,NULL,'2MASX J23251750+1417157',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000168,NULL,'17.0g',0.14,NULL,'Group member',NULL,NULL,NULL,1,351.322958333,14.28772,0.105,NULL,51632955847,806764935,12605702,17),(162370,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162370,34.08,0.49,65.4,75835,75,NULL,'IR','CGCG 431-062',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000474,NULL,'15.7',0.2,NULL,'Group member',NULL,NULL,NULL,1,351.329583,13.92111,0.109,NULL,51637211733,806831433,12606741,15.7),(162371,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162371,33.87,0.2,59.4,75836,74.4,NULL,NULL,'CGCG 431-062',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000474,NULL,'15.7',0.2,NULL,'Group member',NULL,NULL,NULL,1,351.329583,13.92111,0.109,NULL,51637211733,806831433,12606741,15.7),(162372,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162372,35.91,0.42,152,75837,NULL,NULL,NULL,'2MASXi J2325197+142418',NULL,'2009ApJS..182..474S',2009,1,0.71,NULL,'G',0.000023,NULL,'15.9g',0.38,'Sc','Group member',NULL,NULL,NULL,1,351.3325,14.40544,0.105,NULL,51632995607,806765556,12605711,15.9),(162373,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162373,35.95,0.2,155,75837,74.4,NULL,NULL,'2MASXi J2325197+142418',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162374,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162374,36.01,0.4,159,75837,NULL,NULL,'Malmquist cor.','2MASXi J2325197+142418',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162375,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162375,34.79,0.8,90.7,75838,75,NULL,'W91PP, r','UGC 12591',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'13.90',0.7,'S0/a           LINER','Group member',NULL,NULL,NULL,1,351.340625,28.49522,0.293,NULL,52017366492,812771351,12699552,13.9),(162376,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162376,34.15,0.69,67.7,75838,100,NULL,'mid-IR','UGC 12591',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162377,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162377,35.61,0.38,133,75838,75,NULL,'W91PP, r, raw','UGC 12591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162378,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162378,35.8,0.38,144,75838,75,NULL,'W91PP, r, cor','UGC 12591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162379,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162379,36.14,0.38,169,75838,75,NULL,'W91PP, r, inv','UGC 12591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162380,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162380,35.14,0.69,107,75839,100,NULL,'mid-IR','CGCG 497-016',NULL,'2013ApJ...771...88L',2013,1,1.1,NULL,'G',0.000033,NULL,'14.79',0.7,'S?',NULL,NULL,NULL,NULL,1,351.342333,28.85681,0.293,NULL,52013844890,812716326,12698692,14.79),(162381,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162381,35.88,0.4,150,75839,NULL,NULL,'mean','CGCG 497-016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162382,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162382,35.95,0.47,155,75839,NULL,NULL,'H','CGCG 497-016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162383,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003jo','R',162383,41.71,NULL,1440,75840,65,NULL,'SN d033, SALT2','ESSENCE J232524.03-092600.6',0.524,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.350125,-9.4335,0.076,NULL,49599102316,774985973,12109155,NULL),(162384,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003jo',NULL,162384,42.62,0.19,2190,75840,65,NULL,'SN d033, m15(B)','ESSENCE J232524.03-092600.6',0.524,'2005AJ....130.2453K',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162385,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003jo',NULL,162385,42.67,0.2,2240,75840,65,NULL,'SN d033, MLCS','ESSENCE J232524.03-092600.6',0.524,'2005AJ....130.2453K',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162386,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003jo',NULL,162386,42.86,0.17,2440,75840,65,NULL,'SN d033, MLCS17','ESSENCE J232524.03-092600.6',0.524,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162387,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003jo',NULL,162387,42.89,0.31,2480,75840,65,NULL,'SN d033, BATM','ESSENCE J232524.03-092600.6',0.524,'2005AJ....130.2453K',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162388,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003jo',NULL,162388,42.93,0.14,2520,75840,65,NULL,'SN d033, MLCS2k2','ESSENCE J232524.03-092600.6',0.524,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162389,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003jo',NULL,162389,42.93,0.16,2530,75840,65,NULL,'SN d033, MLCS31','ESSENCE J232524.03-092600.6',0.524,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162390,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003jo',NULL,162390,42.96,0.14,2560,75840,65,NULL,'SN d033, MLCS2k2','ESSENCE J232524.03-092600.6',0.524,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162391,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003jo',NULL,162391,43.06,0.3,2690,75840,70,NULL,'SN d033, SALT','ESSENCE J232524.03-092600.6',0.524,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162392,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003jo',NULL,162392,43.2,0.25,2860,75840,65,NULL,'SN d033, SALT2','ESSENCE J232524.03-092600.6',0.524,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162393,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003jo',NULL,162393,43.27,0.14,2960,75840,65,NULL,'SN d033, SALT','ESSENCE J232524.03-092600.6',0.524,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162394,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003jo',NULL,162394,43.27,0.27,2960,75840,65,NULL,'SN d033, SALT','ESSENCE J232524.03-092600.6',0.524,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162395,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003jo',NULL,162395,43.65,0.33,3520,75840,65,NULL,'SN d033, SALT2','ESSENCE J232524.03-092600.6',0.524,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162396,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162396,33.82,0.52,58.2,75841,NULL,NULL,NULL,'UGC 12593',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.13',0.9,'SAd',NULL,NULL,NULL,NULL,1,351.35075,32.67775,0.301,NULL,52063044071,813485063,12710704,15.13),(162397,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162397,33.86,0.2,59.2,75841,74.4,NULL,NULL,'UGC 12593',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162398,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162398,34.26,0.42,71.1,75841,NULL,NULL,'Malmquist cor.','UGC 12593',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162399,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162399,36.15,0.25,170,75842,74.4,NULL,NULL,'GIN 703',NULL,'2013AJ....146...86T',2013,1,0.57,NULL,'G',0.000027,NULL,'15.7g',0.4,'E/S0','Group member',NULL,NULL,NULL,1,351.352917,14.75697,0.113,NULL,52519229616,820612962,12822077,15.7),(162400,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162400,36.35,0.09,186,75842,70,NULL,NULL,'GIN 703',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162401,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162401,36.44,0.09,194,75842,70,NULL,NULL,'GIN 703',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162402,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162402,35.46,0.49,123,75843,75,NULL,'IR','2MFGC 17591',NULL,'2011yCatp016004901K',2011,1,0.7,NULL,'G',NULL,NULL,'13.7K',0.1,NULL,NULL,NULL,NULL,NULL,1,351.3717917,7.55356,0.173,NULL,51804261879,809441591,12647524,13.7),(162403,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 19051','R',162403,40.71,0.19,1090,75844,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007nb','APMUKS(BJ) B232256.34+000853.8',0.2773,'2014arXiv1401.3317S',2014,1,0.1,NULL,'G',0.0005,NULL,'20.48',0.09,NULL,NULL,NULL,NULL,NULL,1,351.37525,0.42328,0.129,NULL,51574297771,805848402,12591381,20.48),(162404,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 19051','R',162404,40.86,0.1,1160,75844,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007nb','APMUKS(BJ) B232256.34+000853.8',0.2773,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162405,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2007nb',NULL,162405,40.61,0.09,1320,75844,70,NULL,'SALT 2','APMUKS(BJ) B232256.34+000853.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162406,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2007nb',NULL,162406,40.63,0.09,1340,75844,70,NULL,'SALT 2, Malmquist cor.','APMUKS(BJ) B232256.34+000853.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162407,'GRB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162407,43,NULL,3980,75845,70,NULL,'Pseudo z = 4.2','GRB 031111',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,72.433333,17.46667,1.317,NULL,65485143992,1023205374,15987583,NULL),(162408,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162408,36.2,0.32,174,75846,NULL,NULL,'Malmquist cor.','SDSS J232531.72+152211.6',NULL,'2009ApJS..182..474S',2009,1,0.56,NULL,'G',0.00003,NULL,'17.6g',0.1,'Sc',NULL,NULL,NULL,NULL,1,351.382166667,15.36989,0.073,NULL,52519862813,820622856,12822232,17.6),(162409,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162409,36.24,0.31,177,75846,NULL,NULL,NULL,'SDSS J232531.72+152211.6',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162410,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162410,36.28,0.2,180,75846,74.4,NULL,NULL,'SDSS J232531.72+152211.6',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162411,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162411,36.22,0.76,176,75847,70,NULL,NULL,'LCRS B232249.2-441902',NULL,'2014MNRAS.445.2677S',2014,1,0.22,NULL,'G',0.00015,NULL,'15.44',0.2,NULL,NULL,NULL,NULL,NULL,1,351.388333333,-44.04208,NULL,NULL,50526784535,789481008,12335640,15.44),(162412,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162412,37.72,0.46,351,75848,70,NULL,NULL,'2MASX J23253333-1029389',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000143,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,351.388917,-10.49425,0.074,NULL,49600502128,775007845,12109497,17),(162413,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 18254',NULL,162413,39.34,1.03,738,75849,70,NULL,'SN photometric redshift distance, z photo =0.190 +/- 0.139','SDSS-II SN 18254',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.9g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,351.390458333,-0.98236,0.141,NULL,49411764468,772058819,12063419,21.9),(162414,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 18254','R',162414,41.18,0.37,1300,75849,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18254',0.319944,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162415,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 18254','R',162415,41.37,0.31,1430,75849,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18254',0.319944,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162416,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 18254',NULL,162416,41.28,0.27,1800,75849,70,NULL,'SALT 2','SDSS-II SN 18254',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162417,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 18254',NULL,162417,41.32,0.27,1840,75849,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18254',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162418,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 21409','R',162418,40.26,0.35,939,75850,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 21409',0.197694,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',NULL,'PHOT','20.6g',0.07,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,351.3974583,-0.71553,0.141,NULL,49411592365,772056130,12063377,20.6),(162419,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 21409',NULL,162419,40.1,0.44,1050,75850,70,NULL,'SN photometric redshift distance, z photo =0.283 +/- 0.079','SDSS-II SN 21409',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162420,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 15727','R',162420,39.46,0.24,704,75851,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15727',0.105414,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.4,-0.01417,0.141,NULL,49411055773,772047746,12063246,NULL),(162421,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 15727','R',162421,40.31,0.35,1050,75851,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15727',0.105414,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162422,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003kk',NULL,162422,38.68,0.25,468,75852,74.2,NULL,'SALT 2','APMUKS(BJ) B232300.59-094814.9',0.164,'2010ApJ...716..712A',2010,1,0.13,NULL,'G',0.001,NULL,'20.38',0.07,NULL,NULL,NULL,NULL,NULL,1,351.4005417,-9.52908,0.076,NULL,49599151752,774986746,12109167,20.38),(162423,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003kk',NULL,162423,39.56,0.36,701,75852,65,NULL,'SN e020, SALT2','APMUKS(BJ) B232300.59-094814.9',0.164,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162424,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003kk',NULL,162424,39.59,0.38,710,75852,65,NULL,'SN e020, SALT2','APMUKS(BJ) B232300.59-094814.9',0.164,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162425,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003kk',NULL,162425,39.75,0.3,765,75852,65,NULL,'SN e020, MLCS31','APMUKS(BJ) B232300.59-094814.9',0.164,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162426,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003kk',NULL,162426,39.79,0.18,778,75852,65,NULL,'SN e020, MLCS2k2','APMUKS(BJ) B232300.59-094814.9',0.164,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162427,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003kk',NULL,162427,39.79,0.27,778,75852,65,NULL,'SN e020, MLCS2k2','APMUKS(BJ) B232300.59-094814.9',0.164,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162428,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003kk',NULL,162428,39.79,0.24,781,75852,65,NULL,'SN e020, MLCS17','APMUKS(BJ) B232300.59-094814.9',0.164,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162429,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003kk',NULL,162429,39.99,0.09,855,75852,70,NULL,'SN e020, SALT','APMUKS(BJ) B232300.59-094814.9',0.164,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162430,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003kk',NULL,162430,40.27,0.03,974,75852,65,NULL,'SN e020, SALT','APMUKS(BJ) B232300.59-094814.9',0.164,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162431,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162431,38.11,0.33,419,75853,70,NULL,NULL,'2MASX J23253653-0950579',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,351.402333333,-9.84944,0.069,NULL,49599006560,774984477,12109132,17.6),(162432,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162432,35.5,0.48,126,75854,70,NULL,NULL,'NGC 7652',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000137,NULL,'14.48',0.7,'(RL)SA(l)0^+:','in a triple',NULL,NULL,NULL,1,351.4059583,-57.88739,0,NULL,48817768256,762777629,11918400,14.48),(162433,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162433,36.14,0.25,169,75855,74.4,NULL,NULL,'GIN 702',NULL,'2013AJ....146...86T',2013,1,0.52,NULL,'G',0.000027,NULL,'15.7g',0.43,'E/S0','Group member',NULL,NULL,NULL,1,351.4064583,14.574,0.105,NULL,51632965373,806765083,12605704,15.7),(162434,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162434,36.35,0.09,186,75855,70,NULL,NULL,'GIN 702',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162435,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162435,36.44,0.09,194,75855,70,NULL,NULL,'GIN 702',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162436,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162436,38.11,0.33,419,75856,70,NULL,NULL,'SDSS J232538.28-094927.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00016,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,351.4095,-9.82428,0.069,NULL,49599000037,774984375,12109130,18.6),(162437,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162437,36.09,0.33,165,75857,NULL,NULL,'Malmquist cor.','IC 1488',NULL,'2009ApJS..182..474S',2009,1,1.07,NULL,'G',0.000033,NULL,'15.5g',0.21,'Sb',NULL,NULL,NULL,NULL,1,351.410625,15.35442,0.073,NULL,52519994695,820624917,12822264,15.5),(162438,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162438,36.16,0.4,171,75857,NULL,NULL,'mean','IC 1488',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162439,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162439,36.24,0.49,177,75857,75,NULL,'IR','IC 1488',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162440,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162440,36.4,0.28,190,75857,NULL,NULL,NULL,'IC 1488',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162441,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162441,36.44,0.2,194,75857,74.4,NULL,NULL,'IC 1488',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162442,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162442,36.46,0.47,196,75857,NULL,NULL,'H','IC 1488',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162443,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162443,35.93,0.2,153,75858,74.4,NULL,NULL,'CGCG 406-105',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',NULL,NULL,'15.6',0.3,'Sa','Isolated galaxy',NULL,NULL,NULL,1,351.419375,6.75903,0.181,NULL,51805523392,809461303,12647832,15.6),(162444,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162444,37.48,0.46,314,75859,70,NULL,NULL,'2MASX J23254100-1038199',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000176,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,351.42075,-10.63881,0.074,NULL,49600394483,775006163,12109471,17),(162445,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162445,34.85,0.49,93.5,75860,75,NULL,'IR','ESO 536- G 004',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000033,NULL,'15.96',0.4,'S...',NULL,NULL,NULL,NULL,1,351.4412917,-26.56431,0.018,NULL,50019738698,781558417,12211850,15.96),(162446,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162446,34.9,0.41,95.3,75860,NULL,NULL,NULL,'ESO 536- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162447,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162447,34.94,0.2,97.3,75860,74.4,NULL,NULL,'ESO 536- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162448,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162448,35.31,0.34,115,75860,NULL,NULL,'Malmquist cor.','ESO 536- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162449,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162449,36.44,0.09,194,75861,70,NULL,NULL,'2MASX J23254672+1533552',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000174,NULL,'15.9g',0.46,'E0',NULL,NULL,NULL,NULL,1,351.4447917,15.56533,0.073,NULL,52519678970,820619983,12822187,15.9),(162450,'Faber-Jackson','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162450,32.84,0.85,37,75862,95,NULL,'Weighted Mean','NGC 7660',NULL,'1984ApJS...56...91D',1984,1,1.4,NULL,'G',0.000057,NULL,'13.76',1.1,'E','Group member',NULL,NULL,NULL,1,351.45275,27.02989,0.177,NULL,51985910260,812279847,12691872,13.76),(162451,'Faber-Jackson','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162451,32.84,0.85,37,75862,95,NULL,'de Vaucouleurs','NGC 7660',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162452,'Tertiary','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162452,33.88,0.5,59.7,75862,95,NULL,NULL,'NGC 7660',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162453,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162453,34.5,0.4,79.3,75862,NULL,NULL,'mean','NGC 7660',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162454,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162454,34.68,0.45,86.2,75862,NULL,NULL,'K','NGC 7660',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162455,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 13867',NULL,162455,40.34,0.18,1170,75863,70,NULL,'SN photometric redshift distance, z photo =0.323 +/- 0.034','SDSS-II SN 13867',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,351.454833,0.02936,0.121,NULL,51574222006,805847218,12591362,NULL),(162456,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 13867','R',162456,40.99,0.24,1170,75863,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13867',0.347239,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162457,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 13867','R',162457,41.16,0.31,1260,75863,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13867',0.347239,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162458,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 01260','RN',162458,42.21,0.18,1660,75864,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01260',0.664633,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162459,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162459,36.94,0.46,244,75865,70,NULL,NULL,'2MASX J23255737-1055229',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,351.4890417,-10.92303,0.099,NULL,49600621004,775009703,12109526,17.7),(162460,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162460,38.39,0.46,476,75866,70,NULL,NULL,'2MASX J23255837-0104252',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000085,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,351.493125,-1.07367,0.141,NULL,49411540975,772055327,12063364,18.2),(162461,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162461,34.8,NULL,91.3,75867,NULL,NULL,NULL,'FGC 2500',NULL,'2000BSAO...50....5K',2000,1,1.1,NULL,'G',0.000014,NULL,'16.07',0.15,'Scd',NULL,NULL,NULL,NULL,1,351.4985417,22.99953,0.125,NULL,52508220351,820440942,12819389,16.07),(162462,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 06921',NULL,162462,36.6,1.28,209,75868,70,NULL,'SN photometric redshift distance, z photo =0.050 +/- 0.042','SDSS-II SN 06921',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.1g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,351.5025,1.01625,0.101,NULL,51574688006,805854500,12591476,21.1),(162463,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 06921','R',162463,38.73,0.42,487,75868,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 06921',0.142113,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162464,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 06921','R',162464,39.46,0.31,683,75868,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 06921',0.142113,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162465,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162465,35.97,0.2,156,75869,74.4,NULL,NULL,'UGC 12596',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000113,NULL,'15.07',0.5,'Sc',NULL,NULL,NULL,NULL,1,351.510875,13.20178,0.065,NULL,51639255290,806863363,12607240,15.07),(162466,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162466,36.19,0.4,173,75869,NULL,NULL,'mean','UGC 12596',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162467,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162467,36.28,0.47,180,75869,NULL,NULL,'H','UGC 12596',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162468,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162468,36.38,0.45,189,75869,NULL,NULL,'K','UGC 12596',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162469,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162469,36.98,0.46,248,75870,70,NULL,NULL,'2MASX J23260285-0859118',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00015,NULL,'16.3g',0.36,'S0',NULL,NULL,NULL,NULL,1,351.51175,-8.98653,0.093,NULL,49598942531,774983477,12109116,16.3),(162470,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162470,36.41,0.46,191,75871,70,NULL,NULL,'2MASX J23261129+1401482',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000196,NULL,'16.8g',0.28,NULL,'Group member',NULL,NULL,NULL,1,351.547,14.02997,0.109,NULL,51637304392,806832881,12606763,16.8),(162471,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE k411','R',162471,41.21,NULL,1120,75872,65,NULL,'MLCS17','ESSENCE k411 HOST',0.564,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.549041667,-8.83819,0.066,NULL,49598733283,774980207,12109065,NULL),(162472,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE k411',NULL,162472,41.67,0.3,1380,75872,74.2,NULL,'SALT 2','ESSENCE k411 HOST',0.564,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162473,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE k411',NULL,162473,42.36,0.24,1900,75872,65,NULL,'MLCS17','ESSENCE k411 HOST',0.564,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162474,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE k411',NULL,162474,42.38,0.4,1910,75872,70,NULL,'SALT','ESSENCE k411 HOST',0.564,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162475,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE k411',NULL,162475,42.44,0.22,1970,75872,65,NULL,'MLCS31','ESSENCE k411 HOST',0.564,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162476,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE k411',NULL,162476,42.56,0.55,2080,75872,65,NULL,'SALT2','ESSENCE k411 HOST',0.564,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162477,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE k411',NULL,162477,42.58,0.37,2100,75872,65,NULL,'SALT','ESSENCE k411 HOST',0.564,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162478,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 03850','RN',162478,43,0.28,2950,75873,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03850',0.346629,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162479,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 03850','RN',162479,43.13,0.33,3140,75873,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03850',0.346629,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162480,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 13830','R',162480,40.97,0.24,1170,75874,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006hm','SN 2006hm',0.33147,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,351.5617083,-0.38225,0.141,NULL,49422631349,772228614,12066072,NULL),(162481,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 13830','R',162481,40.97,0.18,1170,75874,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006hm','SN 2006hm',0.33147,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162482,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162482,35.08,0.5,104,75875,70,NULL,NULL,'CGCG 380-055',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000087,NULL,'15.6',0.5,NULL,NULL,NULL,NULL,NULL,1,351.568625,-1.974,0.141,NULL,49424224667,772253510,12066461,15.6),(162483,'GRB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162483,38.74,NULL,561,75876,65,NULL,'L = 10e57 photons/s','2B 920325',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.566667,12.93972,0.069,NULL,51639454956,806866483,12607288,NULL),(162484,'GRB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162484,41.45,NULL,1950,75876,65,NULL,'L = 2 x 10e58 photons/s','2B 920325',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162485,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162485,37.29,0.46,287,75877,70,NULL,NULL,'2MASX J23261901-0923477',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00015,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,351.579125,-9.39667,0.078,NULL,49599654142,774994595,12109290,16.5),(162486,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162486,37.13,0.74,266,75878,70,NULL,NULL,'2MASX J23262004-2726139',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'15.6R',0.21,NULL,NULL,NULL,NULL,NULL,1,351.583583,-27.43722,0.028,NULL,50020697109,781573392,12212084,15.6),(162487,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162487,32.78,0.8,35.9,75879,75,NULL,'MAT, I','IC 5321',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000013,NULL,'14.02',0.8,'SBa pec?',NULL,NULL,NULL,NULL,1,351.5842917,-17.95639,0.062,NULL,50325280361,786332505,12286445,14.02),(162488,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162488,32.76,0.39,35.6,75879,73,NULL,'opt','IC 5321',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162489,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162489,32.82,0.32,36.7,75879,85,NULL,'I, raw','IC 5321',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162490,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162490,32.82,0.32,36.7,75879,85,NULL,'I, inv','IC 5321',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162491,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162491,32.84,0.43,37,75879,75,NULL,'3.6 micron, color + selection bias corrected','IC 5321',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162492,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162492,32.98,0.65,39.5,75879,NULL,NULL,'Malmquist cor.','IC 5321',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162493,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162493,33,0.43,39.8,75879,75,NULL,'3.6 micron, color corrected','IC 5321',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162494,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162494,33.09,0.2,41.5,75879,74.4,NULL,NULL,'IC 5321',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162495,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162495,33.11,0.62,42,75879,NULL,NULL,NULL,'IC 5321',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162496,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162496,33.15,0.43,42.7,75879,75,NULL,'MAT, I, raw','IC 5321',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162497,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162497,33.22,0.43,44,75879,75,NULL,'MAT, I, inv','IC 5321',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162498,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162498,33.37,0.43,47.1,75879,75,NULL,'MAT, I, cor','IC 5321',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162499,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162499,37.87,0.46,375,75880,70,NULL,NULL,'2MASX J23262036+1457310',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000185,NULL,'16.8g',0.3,NULL,'Group member',NULL,NULL,NULL,1,351.585,14.95864,0.081,NULL,52519100899,820610951,12822046,16.8),(162500,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162500,38.11,0.46,418,75881,70,NULL,NULL,'2MASX J23262063+1446500',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,351.5859583,14.78058,0.089,NULL,52519083388,820610677,12822041,18.1),(162501,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162501,36.24,0.33,177,75882,70,NULL,NULL,'2MASX J23262185+1412300',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00018,NULL,'15.9g',0.33,'E0','Group member',NULL,NULL,NULL,1,351.5909583,14.20836,0.105,NULL,51637314701,806833042,12606766,15.9),(162502,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162502,37.47,0.33,312,75883,70,NULL,NULL,'2MASX J23262367-0038348',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000069,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,351.5985,-0.64297,0.141,NULL,49422611778,772228309,12066067,17.8),(162503,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162503,37.52,0.27,320,75884,70,NULL,NULL,'2MASX J23262512-1051397',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000158,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,351.604917,-10.86114,0.071,NULL,49600636471,775009944,12109530,16.9),(162504,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162504,37.47,0.33,312,75885,70,NULL,NULL,'2MASX J23262600-0039198',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000077,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,351.608417,-0.65547,0.141,NULL,49422613707,772228339,12066067,17.5),(162505,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162505,37.71,0.46,348,75886,70,NULL,NULL,'SDSS J232626.18+134728.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000183,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,351.609125,13.79117,0.117,NULL,51638170944,806846421,12606975,17.5),(162506,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162506,37.77,0.33,358,75887,70,NULL,NULL,'2MASX J23262749-0951390',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000208,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,351.614541667,-9.86089,0.069,NULL,49599192890,774987388,12109177,16.7),(162507,'Brightest Stars','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162507,25.57,NULL,1.3,75888,NULL,NULL,'PHOTOGRAPHIC','UGCA 438',NULL,'1978MNRAS.183P..97L',1978,1,1.5,NULL,'G',0.000017,NULL,'13.8B',1.2,'IB(s)m pec:','Group member',NULL,NULL,NULL,1,351.614667,-32.38875,NULL,0,50182073030,784094891,12251482,13.8),(162508,'CMD','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162508,25,1,1,75888,NULL,NULL,NULL,'UGCA 438',NULL,'1987ESOC...27..281C',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162509,'TRGB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162509,26.59,0.12,2.08,75888,NULL,NULL,'I','UGCA 438',NULL,'1999AJ....118..817L',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162510,'TRGB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162510,26.67,0.1,2.16,75888,NULL,NULL,NULL,'UGCA 438',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162511,'TRGB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162511,26.69,0.08,2.18,75888,NULL,NULL,'I','UGCA 438',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162512,'TRGB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162512,26.72,0.08,2.2,75888,74.4,NULL,NULL,'UGCA 438',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162513,'TRGB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162513,26.72,0.09,2.21,75888,NULL,NULL,'I','UGCA 438',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162514,'TRGB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162514,26.74,0.06,2.22,75888,NULL,NULL,NULL,'UGCA 438',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162515,'TRGB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162515,26.74,0.15,2.23,75888,NULL,NULL,NULL,'UGCA 438',NULL,'2002A&A...389..812K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162516,'Tully est','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162516,24.97,0.8,1,75888,75,NULL,NULL,'UGCA 438',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162517,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162517,38.86,0.46,593,75889,70,NULL,NULL,'2MASX J23262758+0009392',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000103,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,351.6149583,0.16097,0.109,NULL,51587853096,806060204,12594690,18.1),(162518,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162518,38.07,0.46,411,75890,70,NULL,NULL,'2MASX J23263096-0904330',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,351.629167,-9.07597,0.055,NULL,49598915116,774983048,12109110,17.7),(162519,'Brightest Stars','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162519,26.15,NULL,1.7,75891,NULL,NULL,NULL,'Andromeda VII',NULL,'1997A&AS..124..559K',1997,1,2.5,NULL,'G',NULL,NULL,'13.6',2,'dSph','Brightest group member',NULL,NULL,NULL,1,351.63225,50.67572,NULL,1,53207513838,831367403,12990115,13.6),(162520,'CMD','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162520,24.58,NULL,0.824,75891,NULL,NULL,NULL,'Andromeda VII',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162521,'TRGB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162521,24.25,0.25,0.708,75891,NULL,NULL,'I','Andromeda VII',NULL,'1999AstL...25..332T',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162522,'TRGB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162522,24.4,0.2,0.76,75891,NULL,NULL,'I','Andromeda VII',NULL,'1999ApJ...511L.101G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162523,'TRGB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162523,24.41,NULL,0.762,75891,NULL,NULL,NULL,'Andromeda VII',NULL,'2005MNRAS.356..979M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162524,'TRGB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162524,24.5,NULL,0.79,75891,NULL,NULL,NULL,'Andromeda VII',NULL,'2003A&A...408..111K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162525,'TRGB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162525,24.5,0.1,0.794,75891,NULL,NULL,'I','Andromeda VII',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162526,'TRGB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162526,24.54,0.13,0.809,75891,NULL,NULL,NULL,'Andromeda VII',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162527,'TRGB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162527,24.7,0.1,0.871,75891,NULL,NULL,'I, M(I) = -4.0 mag','Andromeda VII',NULL,'1999IAUS..192..284G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162528,'Tully est','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162528,31.69,0.8,21.8,75892,75,NULL,NULL,'UGCA 439',NULL,'1988NBGC.C....0000T',1988,1,0.3,NULL,'G',0.000033,NULL,'15.46',0.2,'BCD',NULL,NULL,NULL,NULL,1,351.636583333,18.26661,0.077,NULL,52544544288,821008504,12828257,15.46),(162529,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162529,36.44,0.09,194,75893,70,NULL,NULL,'2MASX J23263320+1503030',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000164,NULL,'16.7g',0.32,NULL,'Group member',NULL,NULL,NULL,1,351.638291667,15.05094,0.081,NULL,52519952142,820624252,12822253,16.7),(162530,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162530,33.91,0.2,60.5,75894,74.4,NULL,NULL,'CGCG 497-019',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'15.46',0.5,'SB?',NULL,NULL,NULL,NULL,1,351.6472917,32.84625,0.285,NULL,52063817134,813497142,12710892,15.46),(162531,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162531,34.08,0.41,65.4,75894,NULL,NULL,NULL,'CGCG 497-019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162532,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162532,34.41,0.35,76.4,75894,NULL,NULL,'Malmquist cor.','CGCG 497-019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162533,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162533,36.44,0.09,194,75895,70,NULL,NULL,'2MASX J23263574+1448359',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'16.8g',0.26,NULL,'Group member',NULL,NULL,NULL,1,351.6489583,14.81008,0.081,NULL,51633066223,806766659,12605729,16.8),(162534,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162534,37.77,0.33,358,75896,70,NULL,NULL,'SDSS J232637.84-095403.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000142,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,351.6577083,-9.901,0.078,NULL,49599063692,774985370,12109146,18.3),(162535,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162535,32.86,0.2,37.3,75897,74.4,NULL,NULL,'KUG 2324+114',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',NULL,NULL,'15.6',0.3,NULL,NULL,NULL,NULL,NULL,1,351.6595417,11.74239,0.105,NULL,51630010736,806718917,12604983,15.6),(162536,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 19246','RN',162536,40.87,0.33,1120,75898,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19246',0.335217,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162537,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 19246','RN',162537,41.15,0.42,1270,75898,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19246',0.335217,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162538,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 19246','N',162538,41.05,0.3,1620,75898,70,NULL,'SALT 2','SDSS-II SN 19246',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162539,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 19246','N',162539,41.09,0.3,1650,75898,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19246',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162540,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162540,33.13,0.8,42.3,75899,75,NULL,'W91PP, r','NGC 7664',NULL,'1997ApJS..109..333W',1997,1,1.42,NULL,'G',0.000003,NULL,'13.42',0.76,'Sc:            Sbrst','Isolated galaxy',NULL,NULL,NULL,1,351.665667,25.08014,0.169,NULL,51988959269,812327488,12692617,13.42),(162541,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162541,33.13,0.8,42.3,75899,75,NULL,'CF, r','NGC 7664',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162542,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162542,32.62,0.69,33.5,75899,100,NULL,'mid-IR','NGC 7664',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162543,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162543,33.18,0.38,43.2,75899,75,NULL,'W91PP, r, raw','NGC 7664',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162544,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162544,33.33,0.4,46.3,75899,NULL,NULL,'mean','NGC 7664',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162545,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162545,33.34,0.38,46.5,75899,75,NULL,'W91PP, r, inv','NGC 7664',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162546,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162546,33.38,0.45,47.5,75899,NULL,NULL,'K','NGC 7664',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162547,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162547,33.4,0.47,47.8,75899,NULL,NULL,'H','NGC 7664',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162548,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162548,33.42,0.4,48.2,75899,NULL,NULL,NULL,'NGC 7664',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162549,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162549,33.44,0.46,48.8,75899,NULL,NULL,'J','NGC 7664',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162550,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162550,33.46,0.38,49.2,75899,75,NULL,'W91PP, r, cor','NGC 7664',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162551,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162551,33.46,0.2,49.2,75899,74.4,NULL,NULL,'NGC 7664',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162552,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162552,33.51,0.38,50.4,75899,NULL,NULL,'Malmquist cor.','NGC 7664',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162553,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162553,33.57,0.38,51.9,75899,75,NULL,'CF, r, raw','NGC 7664',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162554,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162554,33.75,0.38,56.2,75899,75,NULL,'CF, r, inv','NGC 7664',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162555,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162555,33.81,0.38,57.9,75899,75,NULL,'CF, r, cor','NGC 7664',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162556,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162556,37.47,0.46,312,75900,70,NULL,NULL,'2MASX J23263988-0946590',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000152,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,351.666125,-9.78317,0.093,NULL,49599044377,774985068,12109141,17.3),(162557,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2006fy',NULL,162557,37.68,0.05,344,75901,70,NULL,'Hubble residual 0.03 for z0.08268','SDSS J232640.14-005026.2',NULL,'2011ApJ...740...92G',2011,1,0.17,NULL,'G',0.00004,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,351.66725,-0.84061,0.141,NULL,49422937672,772233401,12066146,18),(162558,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 12950','R',162558,37.94,0.17,358,75901,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006fy','SDSS J232640.14-005026.2',0.08268,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162559,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2006fy',NULL,162559,37.86,0.06,373,75901,70,NULL,'SALT 2','SDSS J232640.14-005026.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162560,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2006fy',NULL,162560,37.86,0.06,373,75901,70,NULL,'SALT 2, Malmquist cor.','SDSS J232640.14-005026.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162561,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 12950','R',162561,38.12,0.04,389,75901,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006fy','SDSS J232640.14-005026.2',0.08268,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162562,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162562,36.86,0.46,236,75902,70,NULL,NULL,'2MASX J23264286-1007590',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,351.678583,-10.13297,0.078,NULL,49601019320,775015926,12109623,17.1),(162563,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162563,36.92,0.46,242,75903,70,NULL,NULL,'2MASX J23264433-0906450',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000157,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,351.684583,-9.11264,0.055,NULL,49598845829,774981966,12109093,17.2),(162564,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162564,35.35,0.83,118,75904,NULL,NULL,'Malmquist cor.','KUG 2324+263',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000005,NULL,'15.72',0.2,'S?',NULL,NULL,NULL,NULL,1,351.695083,26.60294,0.205,NULL,51987392797,812303012,12692234,15.72),(162565,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162565,35.69,0.71,138,75904,NULL,NULL,NULL,'KUG 2324+263',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162566,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162566,35.74,0.2,141,75904,74.4,NULL,NULL,'KUG 2324+263',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162567,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162567,38.42,0.46,484,75905,70,NULL,NULL,'SDSS J232647.00-010542.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000084,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,351.695875,-1.09503,0.141,NULL,49423019949,772234686,12066166,18.7),(162568,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162568,37.46,0.46,311,75906,70,NULL,NULL,'2MASX J23264963+1402425',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000158,NULL,'18.0g',0.18,NULL,'Group member',NULL,NULL,NULL,1,351.70675,14.04536,0.109,NULL,51638040087,806844376,12606943,18),(162569,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162569,38.01,0.46,400,75907,70,NULL,NULL,'2MASX J23265144-0939170',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00017,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,351.71425,-9.65464,0.093,NULL,49599694403,774995225,12109300,17.1),(162570,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162570,34.43,0.45,76.9,75908,NULL,NULL,'Malmquist cor.','CGCG 406-109',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',NULL,NULL,'15.55',0.2,NULL,NULL,NULL,NULL,NULL,1,351.724333,8.78461,0.133,NULL,51796757830,809324341,12645692,15.55),(162571,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162571,34.46,0.2,78,75908,74.4,NULL,NULL,'CGCG 406-109',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162572,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162572,34.53,0.43,80.6,75908,NULL,NULL,NULL,'CGCG 406-109',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162573,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162573,34.74,0.49,88.5,75908,75,NULL,'IR','CGCG 406-109',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162574,'Tully est','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162574,29.57,0.8,8.2,75909,75,NULL,NULL,'ESO 347- G 017',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.000003,NULL,'14.69',0.36,'SB(s)m: sp','Pair member (points to parent)',NULL,NULL,NULL,1,351.7342083,-37.34692,NULL,NULL,49975372407,780865193,12201018,14.69),(162575,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162575,29.4,NULL,7.59,75909,NULL,NULL,NULL,'ESO 347- G 017',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162576,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004fm','R',162576,40.84,NULL,1050,75910,65,NULL,'SN g052, MLCS31','ESSENCE J232658.14-093719.4',0.4,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.74225,-9.62206,0.093,NULL,49599699682,774995307,12109301,NULL),(162577,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004fm',NULL,162577,40.93,0.25,1100,75910,74.2,NULL,'SALT 2','ESSENCE J232658.14-093719.4',0.4,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162578,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004fm',NULL,162578,41.56,0.2,1470,75910,65,NULL,'SN g052, MLCS2k2','ESSENCE J232658.14-093719.4',0.4,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162579,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004fm',NULL,162579,41.57,0.22,1470,75910,65,NULL,'SN g052, MLCS31','ESSENCE J232658.14-093719.4',0.4,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162580,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004fm',NULL,162580,41.59,0.23,1490,75910,70,NULL,'SN g052, SALT','ESSENCE J232658.14-093719.4',0.4,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162581,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004fm',NULL,162581,41.71,0.35,1570,75910,65,NULL,'SN g052, SALT2','ESSENCE J232658.14-093719.4',0.4,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162582,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004fm',NULL,162582,41.73,0.08,1580,75910,65,NULL,'SN g052, SALT','ESSENCE J232658.14-093719.4',0.4,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162583,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004fm',NULL,162583,41.74,0.16,1590,75910,65,NULL,'SN g052, MLCS2k2','ESSENCE J232658.14-093719.4',0.4,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162584,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004fm',NULL,162584,41.78,0.21,1620,75910,65,NULL,'SN g052, SALT','ESSENCE J232658.14-093719.4',0.4,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162585,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004fm',NULL,162585,41.85,0.29,1680,75910,65,NULL,'SN g052, SALT2','ESSENCE J232658.14-093719.4',0.4,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162586,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 14545','R',162586,40.76,0.23,1110,75911,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14545',0.278,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.748166667,1.01714,0.085,NULL,51588456000,806069625,12594837,NULL),(162587,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 14545','R',162587,40.85,0.14,1160,75911,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14545',0.278,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162588,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162588,37.53,0.33,321,75912,70,NULL,NULL,'2MASX J23270131-1031189',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,351.755333,-10.52186,0.091,NULL,49600425626,775006650,12109478,16.6),(162589,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003ju',NULL,162589,39.18,0.22,571,75913,74.2,NULL,'SALT 2','ESSENCE J232701.71-092404.5',0.2,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.757125,-9.40125,0.078,NULL,49599685849,774995091,12109298,NULL),(162590,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003ju',NULL,162590,40.01,0.25,836,75913,65,NULL,'SN d086, SALT2','ESSENCE J232701.71-092404.5',0.2,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162591,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003ju',NULL,162591,40.03,0.31,845,75913,65,NULL,'SN d086, MLCS31','ESSENCE J232701.71-092404.5',0.2,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162592,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003ju',NULL,162592,40.08,0.28,863,75913,65,NULL,'SN d086, MLCS2k2','ESSENCE J232701.71-092404.5',0.2,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162593,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003ju',NULL,162593,40.08,0.28,865,75913,65,NULL,'SN d086, SALT2','ESSENCE J232701.71-092404.5',0.2,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162594,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003ju',NULL,162594,40.15,0.27,892,75913,65,NULL,'SN d086, MLCS17','ESSENCE J232701.71-092404.5',0.2,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162595,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003ju',NULL,162595,40.15,0.21,893,75913,65,NULL,'SN d086, MLCS2k2','ESSENCE J232701.71-092404.5',0.2,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162596,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003ju',NULL,162596,40.16,0.05,897,75913,70,NULL,'SN d086, SALT','ESSENCE J232701.71-092404.5',0.2,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162597,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003ju',NULL,162597,40.42,0.02,1010,75913,65,NULL,'SN d086, SALT','ESSENCE J232701.71-092404.5',0.2,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162598,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162598,37.67,0.46,342,75914,70,NULL,NULL,'2MASX J23270300-0910459',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,351.7625417,-9.17953,0.055,NULL,49598888645,774982635,12109103,17.4),(162599,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162599,38.26,0.46,448,75915,70,NULL,NULL,'2MASX J23270319+0042567',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000057,NULL,'17.3g',0.23,'NLAGN',NULL,NULL,NULL,NULL,1,351.7632083,0.71578,0.105,NULL,51588719041,806073735,12594902,17.3),(162600,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004hk',NULL,162600,39.81,0.22,705,75916,74.2,NULL,'SALT 2','ESSENCE J232704.38-083845.1',0.3,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.76825,-8.64586,0.059,NULL,49654416455,775850257,12122660,NULL),(162601,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004hk',NULL,162601,40.29,0.35,879,75916,65,NULL,'SN k396, MLCS2k2','ESSENCE J232704.38-083845.1',0.3,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162602,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004hk','R',162602,40.47,NULL,955,75916,65,NULL,'SN k396, SALT','ESSENCE J232704.38-083845.1',0.3,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162603,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004hk',NULL,162603,40.55,0.21,991,75916,70,NULL,'SN k396, SALT','ESSENCE J232704.38-083845.1',0.3,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162604,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004hk',NULL,162604,40.68,0.18,1050,75916,65,NULL,'SN k396, SALT','ESSENCE J232704.38-083845.1',0.3,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162605,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004hk',NULL,162605,40.88,0.08,1160,75916,65,NULL,'SN k396, SALT','ESSENCE J232704.38-083845.1',0.3,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162606,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162606,37.53,0.33,321,75917,70,NULL,NULL,'2MASX J23270593-1033249',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000154,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,351.774583,-10.55686,0.091,NULL,49600455091,775007110,12109486,17.3),(162607,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162607,37.85,0.33,371,75918,70,NULL,NULL,'2MASX J23270699-0933179',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000162,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,351.7790417,-9.55494,0.093,NULL,49599740973,774995952,12109311,17.2),(162608,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162608,34.48,0.2,78.7,75919,74.4,NULL,NULL,'UGC 12601',NULL,'2013AJ....146...86T',2013,1,0.91,NULL,'G',0.000017,NULL,'15.8g',0.53,'SB(s)dm:','Group member',NULL,NULL,NULL,1,351.7925417,15.01725,0.077,NULL,52519898780,820623418,12822240,15.8),(162609,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162609,38.14,0.46,424,75920,70,NULL,NULL,'2MASX J23271071-0041579',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00015,NULL,'17.87',0.22,NULL,NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,351.794583,-0.69936,0.149,NULL,49422624602,772228509,12066070,17.87),(162610,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162610,36.76,0.46,225,75921,70,NULL,NULL,'2MASX J23271258+0012586',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000081,NULL,'16.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,351.802583333,0.21636,0.097,NULL,51579493444,805929585,12592649,16.9),(162611,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162611,37.06,0.46,258,75922,70,NULL,NULL,'2MASX J23271418+1448586',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000181,NULL,'16.8g',0.26,NULL,'Group member',NULL,NULL,NULL,1,351.8090417,14.81628,0.093,NULL,51633071008,806766734,12605730,16.8),(162612,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162612,32.06,0.8,25.8,75923,75,NULL,'MAT, I','NGC 7661',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000018,NULL,'14.08',1.2,'SB(rs)cd',NULL,NULL,NULL,NULL,1,351.8095417,-65.27042,0,NULL,48732194128,761440533,11897508,14.08),(162613,'Tully est','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162613,31.88,0.8,23.8,75923,75,NULL,NULL,'NGC 7661',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162614,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162614,32.31,0.32,29,75923,85,NULL,'I, inv','NGC 7661',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162615,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162615,32.32,0.32,29.1,75923,85,NULL,'I, raw','NGC 7661',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162616,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162616,32.56,0.4,32.5,75923,NULL,NULL,NULL,'NGC 7661',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162617,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162617,32.56,0.4,32.5,75923,73,NULL,'opt','NGC 7661',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162618,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162618,32.74,0.43,35.3,75923,75,NULL,'MAT, I, raw','NGC 7661',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162619,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162619,32.78,0.43,35.9,75923,75,NULL,'MAT, I, inv','NGC 7661',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162620,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162620,32.97,0.43,39.3,75923,75,NULL,'MAT, I, cor','NGC 7661',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162621,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162621,38.16,0.33,429,75924,70,NULL,NULL,'2MASX J23271628-0957229',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000151,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,351.817917,-9.95644,0.087,NULL,49599076067,774985563,12109149,17.2),(162622,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162622,37.77,0.46,359,75925,70,NULL,NULL,'2MASX J23272230+0110106',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000065,NULL,'17.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,351.843,1.16958,0.085,NULL,51588568930,806071389,12594865,17.8),(162623,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162623,37.5,0.46,316,75926,70,NULL,NULL,'2MASX J23272279-1013579',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000147,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,351.844958333,-10.23281,0.086,NULL,49600991959,775015499,12109617,17.6),(162624,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162624,31.25,0.4,17.8,75927,73,NULL,'opt','NGC 7667',NULL,'2011A&A...532A.104N',2011,1,NULL,'Nothing at NGC position. Often misidentified with UGC 12578.','Other',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.845083,-0.18631,0.109,NULL,49418359971,772161874,12065029,NULL),(162625,'GRB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162625,41.86,0.21,1670,75928,NULL,NULL,NULL,'GRB 020819B',0.41,'2010JCAP...08..020W',2010,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,351.85,6.26667,0.197,NULL,51805013480,809453335,12647708,NULL),(162626,'GRB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162626,42.47,NULL,3120,75928,70,NULL,'Pseudo z = 1.52','GRB 020819B',NULL,'2004AIPC..727...37A',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162627,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162627,38.16,0.33,429,75929,70,NULL,NULL,'2MASX J23272494-1000349',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000187,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,351.853917,-10.00967,0.087,NULL,49599029547,774984836,12109138,18),(162628,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 00860','RN',162628,41.94,0.27,1840,75930,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 00860',0.328912,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162629,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 00860','RN',162629,42.57,0.29,2460,75930,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00860',0.328912,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162630,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162630,37.52,0.27,320,75931,70,NULL,NULL,'2MASX J23272926-1052347',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00015,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,351.871833333,-10.87639,0.085,NULL,49600592288,775009254,12109519,16.6),(162631,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162631,36.44,0.09,194,75932,70,NULL,NULL,'2MASX J23273129+1507305',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000201,NULL,'15.9g',0.43,'E0',NULL,NULL,NULL,NULL,1,351.8804583,15.12506,0.077,NULL,52519383716,820615370,12822115,15.9),(162632,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162632,33.38,0.2,47.4,75933,74.4,NULL,NULL,'NGC 7672',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000087,NULL,'14.70',0.9,'Sb             Sy2','in a pair',NULL,NULL,'Sy 2',1,351.881,12.38519,0.105,NULL,51639121431,806861272,12607207,14.7),(162633,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 03881','R',162633,41.22,0.25,1320,75934,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03881',0.327784,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.881625,-0.44181,0.161,NULL,49422759524,772230617,12066103,NULL),(162634,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 03881','R',162634,41.41,0.21,1440,75934,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03881',0.327784,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162635,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162635,35.97,0.49,156,75935,75,NULL,'IR','UGC 12603',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'16.5',0.3,'S?',NULL,NULL,NULL,NULL,1,351.901417,29.84728,0.281,NULL,52072059172,813625924,12712905,16.5),(162636,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE g097',NULL,162636,40.35,0.23,875,75936,74.2,NULL,'SALT 2','ESSENCE g097 HOST',0.343,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.904833,-9.58917,0.071,NULL,49599724172,774995690,12109307,NULL),(162637,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE g097','R',162637,40.85,NULL,1100,75936,65,NULL,'MLCS17','ESSENCE g097 HOST',0.343,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162638,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE g097',NULL,162638,41.14,0.2,1260,75936,70,NULL,'SALT','ESSENCE g097 HOST',0.343,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162639,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE g097',NULL,162639,41.15,0.24,1270,75936,65,NULL,'SALT2','ESSENCE g097 HOST',0.343,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162640,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE g097',NULL,162640,41.24,0.18,1320,75936,65,NULL,'SALT','ESSENCE g097 HOST',0.343,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162641,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE g097',NULL,162641,41.24,0.26,1320,75936,65,NULL,'SALT2','ESSENCE g097 HOST',0.343,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162642,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE g097',NULL,162642,41.41,0.28,1430,75936,65,NULL,'MLCS17','ESSENCE g097 HOST',0.343,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162643,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE g097',NULL,162643,41.44,0.23,1440,75936,65,NULL,'MLCS2k2','ESSENCE g097 HOST',0.343,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162644,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE g097',NULL,162644,41.5,0.3,1490,75936,65,NULL,'MLCS31','ESSENCE g097 HOST',0.343,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162645,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE g097',NULL,162645,41.55,0.1,1520,75936,65,NULL,'SALT','ESSENCE g097 HOST',0.343,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162646,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE g097',NULL,162646,41.56,0.29,1530,75936,65,NULL,'MLCS2k2','ESSENCE g097 HOST',0.343,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162647,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','PS1 SN PS10bjn','N',162647,40.94,0.16,1200,75937,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10bjn HOST',0.2888,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162648,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162648,35.82,0.8,146,75938,75,NULL,'W91PP, r','UGC 12604',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',NULL,NULL,'15.30',0.6,'SBa',NULL,NULL,NULL,NULL,1,351.916083,22.759,0.113,NULL,52505086427,820391975,12818624,15.3),(162649,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162649,35.74,0.38,141,75938,75,NULL,'W91PP, r, raw','UGC 12604',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162650,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162650,35.95,0.38,155,75938,75,NULL,'W91PP, r, cor','UGC 12604',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162651,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162651,35.97,0.38,156,75938,75,NULL,'W91PP, r, inv','UGC 12604',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162652,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162652,37.45,0.33,309,75939,70,NULL,NULL,'2MASX J23273992-1026417',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00015,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,351.9162917,-10.44483,0.091,NULL,49600885548,775013836,12109591,16.3),(162653,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162653,35.48,0.2,125,75940,74.4,NULL,NULL,'KUG 2325+142',NULL,'2013AJ....146...86T',2013,1,0.65,NULL,'G',0.00009,NULL,'15.4g',0.41,'Sc',NULL,NULL,NULL,NULL,1,351.928583,14.54472,0.093,NULL,51633891386,806779552,12605930,15.4),(162654,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 03418','RN',162654,42.12,0.21,1740,75941,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03418',0.523583,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162655,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162655,37.85,0.33,371,75942,70,NULL,NULL,'SDSS J232745.68-092425.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,351.940333,-9.40711,0.071,NULL,49599600464,774993757,12109277,18.4),(162656,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 20038','R',162656,39.7,0.18,779,75943,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2007pg','SDSS J232749.56+002728.4',0.118789,'2014arXiv1401.3317S',2014,1,0.23,NULL,'G',0.000064,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,351.9565417,0.45789,0.105,NULL,51587955861,806061810,12594715,18.3),(162657,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 20038','R',162657,40.14,0.09,954,75943,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2007pg','SDSS J232749.56+002728.4',0.118789,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162658,'FP','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162658,37.9,0.33,381,75944,70,NULL,NULL,'2MASX J23275214+1414315',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000181,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,351.96725,14.24208,0.117,NULL,51637727227,806839487,12606866,17.2),(162659,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162659,31.49,0.8,19.9,75945,75,NULL,'MAT, I','ESO 240- G 004',NULL,'1997ApJS..109..333W',1997,1,1.55,NULL,'G',0.000033,NULL,'15.26',0.29,'Sd: sp',NULL,NULL,NULL,NULL,1,351.971333,-51.13214,0,NULL,48651405037,760178203,11877784,15.26),(162660,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162660,31.22,0.32,17.5,75945,85,NULL,'I, inv','ESO 240- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162661,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162661,31.29,0.32,18.1,75945,85,NULL,'I, raw','ESO 240- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162662,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162662,31.57,0.4,20.6,75945,NULL,NULL,NULL,'ESO 240- G 004',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162663,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162663,31.57,0.39,20.6,75945,73,NULL,'opt','ESO 240- G 004',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162664,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162664,31.69,0.43,21.8,75945,75,NULL,'MAT, I, inv','ESO 240- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162665,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162665,31.9,0.43,23.9,75945,75,NULL,'MAT, I, raw','ESO 240- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162666,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162666,32.11,0.43,26.4,75945,75,NULL,'MAT, I, cor','ESO 240- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162667,'FP','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162667,34.99,0.5,99.6,75946,70,NULL,NULL,'2MASX J23275315-1741591',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'15.42',0.4,'E',NULL,NULL,NULL,NULL,1,351.971541667,-17.69992,0.055,NULL,50325111524,786329867,12286404,15.42),(162668,'FP','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162668,36.44,0.09,194,75947,70,NULL,NULL,'2MASX J23275317+1442395',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000205,NULL,'16.1g',0.38,'E0',NULL,NULL,NULL,NULL,1,351.971541667,14.711,0.093,NULL,51633926441,806780100,12605939,16.1),(162669,'FP','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162669,37.52,0.27,320,75948,70,NULL,NULL,'2MASX J23275377-1053197',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,351.9739583,-10.88883,0.085,NULL,49600536642,775008385,12109506,17.1),(162670,'FP','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162670,38.05,0.46,406,75949,70,NULL,NULL,'2MASX J23275556-0016058',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000088,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,351.981583333,-0.26819,0.109,NULL,49418580039,772165313,12065083,17.3),(162671,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2011hb',NULL,162671,35.34,0.07,117,75950,72,NULL,'M(H) = -18.317 mag','NGC 7674',NULL,'2014ApJ...784..105W',2013,1,1.1,'Called \'NGC 7675\'in MCG.','G',0.00003,NULL,'13.92',1,'SA(r)bc pec;HIISy2','in an interacting pair',NULL,NULL,'Sy 2',1,351.986333,8.77903,0.101,NULL,51796601506,809321898,12645654,13.92),(162672,'Ring Diameter','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162672,33.4,0.84,47,75950,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7674',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162673,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162673,33.9,NULL,60.3,75950,75,NULL,'CO','NGC 7674',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162674,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162674,34.34,NULL,73.9,75950,75,NULL,'HI','NGC 7674',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162675,'FP','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162675,36.44,0.09,194,75951,70,NULL,NULL,'2MASX J23275772+1459305',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000175,NULL,'16.1g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,351.9904583,14.99167,0.077,NULL,51633524830,806773825,12605841,16.1),(162676,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2003jv',NULL,162676,40.98,0.23,1120,75952,74.2,NULL,'SALT 2','ESSENCE J232758.22-085711.8',0.405,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.992583,-8.95328,0.061,NULL,49654353535,775849273,12122644,NULL),(162677,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2003jv','R',162677,40.99,NULL,1120,75952,65,NULL,'SN d085, MLCS17','ESSENCE J232758.22-085711.8',0.405,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162678,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2003jv',NULL,162678,41.62,0.26,1500,75952,70,NULL,'SN d085, SALT','ESSENCE J232758.22-085711.8',0.405,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162679,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2003jv',NULL,162679,41.73,0.2,1580,75952,65,NULL,'SN d085, SALT2','ESSENCE J232758.22-085711.8',0.405,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162680,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2003jv',NULL,162680,41.76,0.23,1600,75952,65,NULL,'SN d085, SALT','ESSENCE J232758.22-085711.8',0.405,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162681,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2003jv',NULL,162681,41.85,0.22,1670,75952,65,NULL,'SN d085, SALT2','ESSENCE J232758.22-085711.8',0.405,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162682,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2003jv',NULL,162682,41.92,0.22,1730,75952,65,NULL,'SN d085, MLCS31','ESSENCE J232758.22-085711.8',0.405,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162683,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2003jv',NULL,162683,41.96,0.07,1750,75952,65,NULL,'SN d085, SALT','ESSENCE J232758.22-085711.8',0.405,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162684,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2003jv',NULL,162684,41.95,0.18,1750,75952,65,NULL,'SN d085, MLCS17','ESSENCE J232758.22-085711.8',0.405,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162685,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2003jv',NULL,162685,41.96,0.2,1750,75952,65,NULL,'SN d085, MLCS2k2','ESSENCE J232758.22-085711.8',0.405,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162686,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2003jv',NULL,162686,41.98,0.17,1770,75952,65,NULL,'SN d085, MLCS2k2','ESSENCE J232758.22-085711.8',0.405,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162687,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162687,34.07,0.8,65.1,75953,75,NULL,'W91PP, r','UGC 12609',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'15.34',0.6,'Sdm',NULL,NULL,NULL,NULL,1,352.003125,31.0145,0.265,NULL,52069569110,813587017,12712297,15.34),(162688,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162688,34.17,0.38,68.2,75953,75,NULL,'W91PP, r, raw','UGC 12609',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162689,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162689,34.17,0.38,68.3,75953,75,NULL,'W91PP, r, inv','UGC 12609',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162690,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162690,34.39,0.38,75.3,75953,75,NULL,'W91PP, r, cor','UGC 12609',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162691,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162691,34.24,0.4,70.4,75954,NULL,NULL,'mean','CGCG 497-023',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000007,NULL,'15.22',0.2,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,352.004333333,32.16258,0.293,NULL,52062706744,813479792,12710621,15.22),(162692,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162692,34.52,0.49,80.3,75954,75,NULL,'IR','CGCG 497-023',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162693,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162693,34.56,0.47,81.7,75954,NULL,NULL,'H','CGCG 497-023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162694,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162694,34.67,0.2,85.9,75954,74.4,NULL,NULL,'CGCG 497-023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162695,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162695,34.86,0.38,93.8,75954,NULL,NULL,NULL,'CGCG 497-023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162696,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162696,34.9,0.37,95.3,75954,NULL,NULL,'Malmquist cor.','CGCG 497-023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162697,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162697,36.12,0.2,167,75955,74.4,NULL,NULL,'CGCG 406-111',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',NULL,NULL,'15.55',0.3,'S?',NULL,NULL,NULL,NULL,1,352.004917,7.85886,0.173,NULL,51804638132,809447470,12647616,15.55),(162698,'FP','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162698,38.34,0.33,466,75956,70,NULL,NULL,'2MASX J23280183-0927424',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,352.007625,-9.46164,0.071,NULL,49599553745,774993027,12109266,17.6),(162699,'Ring Diameter','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162699,33.5,0.84,50,75957,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7677',NULL,'1981ApJS...45..541P',1981,1,1.6,NULL,'G',0.000003,NULL,'13.93',1,'SAB(r)bc:      Sbrst','Pair member, wide',NULL,NULL,'Starburst',1,352.0255,23.53139,0.153,NULL,51980594372,812196787,12690574,13.93),(162700,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162700,33.16,0.8,42.9,75957,75,NULL,'MAT, I','NGC 7677',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162701,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162701,33.17,0.8,43.1,75957,75,NULL,'W91PP, r','NGC 7677',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162702,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162702,32.67,0.69,34.2,75957,100,NULL,'mid-IR','NGC 7677',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162703,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162703,33.36,0.4,46.9,75957,NULL,NULL,'mean','NGC 7677',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162704,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162704,33.36,0.38,47,75957,75,NULL,'W91PP, r, raw','NGC 7677',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162705,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162705,33.44,0.38,48.7,75957,75,NULL,'W91PP, r, inv','NGC 7677',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162706,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162706,33.44,0.2,48.8,75957,74.4,NULL,NULL,'NGC 7677',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162707,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162707,33.52,0.32,50.5,75957,85,NULL,'I, raw','NGC 7677',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162708,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162708,33.53,0.45,50.9,75957,NULL,NULL,'K','NGC 7677',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162709,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162709,33.56,0.32,51.5,75957,85,NULL,'I, inv','NGC 7677',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162710,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162710,33.57,0.47,51.8,75957,NULL,NULL,'H','NGC 7677',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162711,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162711,33.59,0.43,52.3,75957,75,NULL,'MAT, I, raw','NGC 7677',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162712,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162712,33.6,0.38,52.6,75957,75,NULL,'W91PP, r, cor','NGC 7677',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162713,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162713,33.64,0.46,53.4,75957,NULL,NULL,'J','NGC 7677',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162714,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162714,33.74,0.58,56,75957,NULL,NULL,NULL,'NGC 7677',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162715,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162715,33.79,0.43,57.4,75957,75,NULL,'MAT, I, inv','NGC 7677',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162716,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162716,33.88,0.43,59.7,75957,75,NULL,'MAT, I, cor','NGC 7677',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162717,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162717,33.97,0.52,62.2,75957,NULL,NULL,'Malmquist cor.','NGC 7677',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162718,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SDSS-II SN 16259','R',162718,38.63,0.19,476,75958,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ol ','SDSS J232807.19+005122.9',0.12,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,352.029958333,0.85636,0.101,NULL,51588833076,806075516,12594929,NULL),(162719,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2006ol',NULL,162719,38.42,0.1,483,75958,70,NULL,'SALT 2','SDSS J232807.19+005122.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162720,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2006ol',NULL,162720,38.43,0.1,485,75958,70,NULL,'SALT 2, Malmquist cor.','SDSS J232807.19+005122.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162721,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SDSS-II SN 16259','R',162721,38.78,0.08,510,75958,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ol ','SDSS J232807.19+005122.9',0.12,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162722,'FP','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162722,36.34,0.81,186,75959,70,NULL,NULL,'2MASX J23280823-5319280',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.53',0.18,NULL,NULL,NULL,NULL,NULL,1,352.0342083,-53.32447,0,NULL,48641054503,760016476,11875257,16.53),(162723,'FP','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162723,37.9,0.33,381,75960,70,NULL,NULL,'SDSS J232812.23+141214.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000187,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,352.050958333,14.20408,0.117,NULL,51637752909,806839889,12606873,18.5),(162724,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162724,34.17,0.4,68.2,75961,NULL,NULL,'mean','UGC 12611',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000033,NULL,'15.47',0.2,'Sa',NULL,NULL,NULL,NULL,1,352.053625,27.68944,0.185,NULL,51984572295,812258942,12691545,15.47),(162725,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162725,34.3,0.47,72.5,75961,NULL,NULL,'H','UGC 12611',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162726,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162726,34.33,0.45,73.6,75961,NULL,NULL,'K','UGC 12611',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162727,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162727,34.4,0.49,76,75961,75,NULL,'IR','UGC 12611',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162728,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162728,34.47,0.46,78.5,75961,NULL,NULL,'J','UGC 12611',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162729,'FP','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162729,37.45,0.33,309,75962,70,NULL,NULL,'SDSS J232813.79-102410.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,352.0574583,-10.40292,0.091,NULL,49601776720,775027761,12109808,18.3),(162730,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','ESSENCE n278',NULL,162730,40.15,0.22,822,75963,74.2,NULL,'SALT 2','ESSENCE n278 HOST',0.304,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,352.073125,-9.38678,0.071,NULL,49599296830,774989012,12109203,NULL),(162731,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','ESSENCE n278','R',162731,40.43,NULL,935,75963,65,NULL,'SALT','ESSENCE n278 HOST',0.304,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162732,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','ESSENCE n278',NULL,162732,40.85,0.21,1130,75963,70,NULL,'SALT','ESSENCE n278 HOST',0.304,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162733,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','ESSENCE n278',NULL,162733,40.93,0.22,1180,75963,65,NULL,'SALT2','ESSENCE n278 HOST',0.304,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162734,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','ESSENCE n278',NULL,162734,40.99,0.19,1210,75963,65,NULL,'SALT','ESSENCE n278 HOST',0.304,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162735,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','ESSENCE n278',NULL,162735,41.07,0.23,1250,75963,65,NULL,'SALT2','ESSENCE n278 HOST',0.304,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162736,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','ESSENCE n278',NULL,162736,41.09,0.23,1270,75963,65,NULL,'MLCS17','ESSENCE n278 HOST',0.304,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162737,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','ESSENCE n278',NULL,162737,41.12,0.16,1280,75963,65,NULL,'MLCS2k2','ESSENCE n278 HOST',0.304,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162738,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','ESSENCE n278',NULL,162738,41.13,0.21,1290,75963,65,NULL,'MLCS31','ESSENCE n278 HOST',0.304,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162739,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','ESSENCE n278',NULL,162739,41.15,0.06,1300,75963,65,NULL,'SALT','ESSENCE n278 HOST',0.304,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162740,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','ESSENCE n278',NULL,162740,41.16,0.19,1310,75963,65,NULL,'MLCS2k2','ESSENCE n278 HOST',0.304,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162741,'FP','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162741,36.5,0.27,200,75964,70,NULL,NULL,'2MASX J23281806-0944343',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000154,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,352.0752917,-9.74311,0.086,NULL,49599395215,774990550,12109227,17.1),(162742,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162742,32.92,0.43,38.3,75965,75,NULL,'3.6 micron, color + selection bias corrected','KUG 2325+073',NULL,'2014MNRAS.444..527S',2014,1,0.5,NULL,'G',0.000123,NULL,'15.3',0.3,'Spiral',NULL,NULL,NULL,NULL,1,352.080083333,7.62375,0.173,NULL,51807688973,809495140,12648361,15.3),(162743,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162743,33.12,0.43,42.1,75965,75,NULL,'3.6 micron, color corrected','KUG 2325+073',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162744,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162744,33.27,0.2,45.1,75965,74.4,NULL,NULL,'KUG 2325+073',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162745,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162745,35.08,0.49,104,75966,75,NULL,'IR','UGC 12612',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'17.',0.12,'Sc',NULL,NULL,NULL,NULL,1,352.0837083,35.30208,0.345,NULL,51829973745,809843339,12653802,17),(162746,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162746,35.63,NULL,134,75966,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12612',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162747,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162747,35.66,NULL,135,75966,NULL,NULL,'Dipole + Quadrupole','UGC 12612',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162748,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162748,35.67,NULL,136,75966,NULL,NULL,'Dipole','UGC 12612',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162749,'FP','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162749,36.5,0.27,200,75967,70,NULL,NULL,'2MASX J23282280-0945183',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000103,NULL,'16.4g',0.37,'HII?',NULL,NULL,NULL,NULL,1,352.094916667,-9.75508,0.086,NULL,49599394994,774990546,12109227,16.4),(162750,'FP','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162750,37.17,0.59,271,75968,70,NULL,NULL,'2MASX J23282359-5218111',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.99',0.3,NULL,NULL,NULL,NULL,NULL,1,352.0984583,-52.30308,0,NULL,48639832398,759997381,11874959,16.99),(162751,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162751,35.81,0.4,145,75969,NULL,NULL,'mean','MCG -01-59-024',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00006,NULL,'15.00',0.8,'SABc           HII',NULL,NULL,NULL,NULL,1,352.1030417,-2.80028,0.133,NULL,49423656300,772244629,12066322,15),(162752,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162752,35.82,0.47,146,75969,NULL,NULL,'H','MCG -01-59-024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162753,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162753,35.94,0.45,154,75969,NULL,NULL,'K','MCG -01-59-024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162754,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162754,36.01,0.46,159,75969,NULL,NULL,'J','MCG -01-59-024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162755,'FP','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162755,36.5,0.27,200,75970,70,NULL,NULL,'2MASXi J2328263-094024',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,352.1100417,-9.67358,0.071,NULL,49599427677,774991057,12109235,17.6),(162756,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2004fh',NULL,162756,39.34,0.22,615,75971,74.2,NULL,'SALT 2','SDSS J232826.90-083653.0',0.2,'2010ApJ...716..712A',2010,1,0.17,NULL,'G',NULL,NULL,'18.9g',0.1,NULL,NULL,NULL,NULL,NULL,1,352.112083,-8.61475,0.042,NULL,49654861377,775857209,12122768,18.9),(162757,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2004fh','R',162757,39.97,NULL,822,75971,65,NULL,'SN g005, SALT2','SDSS J232826.90-083653.0',0.2,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162758,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2004fh',NULL,162758,40.2,0.27,912,75971,65,NULL,'SN g005, SALT2','SDSS J232826.90-083653.0',0.2,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162759,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2004fh',NULL,162759,40.23,0.26,928,75971,65,NULL,'SN g005, SALT2','SDSS J232826.90-083653.0',0.2,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162760,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2004fh',NULL,162760,40.32,0.2,966,75971,70,NULL,'SN g005, SALT','SDSS J232826.90-083653.0',0.2,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162761,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2004fh',NULL,162761,40.35,0.27,979,75971,65,NULL,'SN g005, MLCS31','SDSS J232826.90-083653.0',0.2,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162762,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2004fh',NULL,162762,40.37,0.24,989,75971,65,NULL,'SN g005, MLCS2k2','SDSS J232826.90-083653.0',0.2,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162763,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2004fh',NULL,162763,40.4,0.17,1000,75971,65,NULL,'SN g005, SALT','SDSS J232826.90-083653.0',0.2,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162764,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2004fh',NULL,162764,40.46,0.17,1030,75971,65,NULL,'SN g005, MLCS2k2','SDSS J232826.90-083653.0',0.2,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162765,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2004fh',NULL,162765,40.45,0.23,1030,75971,65,NULL,'SN g005, MLCS17','SDSS J232826.90-083653.0',0.2,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162766,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2004fh',NULL,162766,40.8,0.06,1210,75971,65,NULL,'SN g005, SALT','SDSS J232826.90-083653.0',0.2,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162767,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SDSS-II SN 03750','RN',162767,42.52,0.34,2490,75972,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03750',0.27989,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162768,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SDSS-II SN 03750','RN',162768,43.03,0.43,3150,75972,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03750',0.27989,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162769,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2002dp',NULL,162769,32.68,0.26,34,75973,74.2,NULL,'SALT 2','NGC 7678',0.011639,'2010ApJ...716..712A',2010,1,2.17,'Position given in 1990PNAOJ...1..181T refers to the southern arm.','G',0.000017,NULL,'12.41',1.67,'SAB(rs)c;Sbrst Sy2','in a radial-velocity based grouping',NULL,NULL,'H II',1,352.11625,22.42119,0.113,NULL,52505081460,820391897,12818623,12.41),(162770,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2002dp',NULL,162770,33.26,0.02,44.4,75973,72,NULL,'MLCS31','NGC 7678',0.011639,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162771,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2002dp',NULL,162771,33.25,0.09,44.7,75973,74.4,NULL,NULL,'NGC 7678',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162772,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2002dp',NULL,162772,33.33,0.25,45.9,75973,70,NULL,'SALT 2','NGC 7678',0.011639,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162773,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2002dp',NULL,162773,33.39,0.22,47,75973,73.8,NULL,'SALT 2 (SNANA)','NGC 7678',0.0109,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162774,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2002dp',NULL,162774,33.51,0.29,49.7,75973,65,NULL,'MLCS31','NGC 7678',0.011639,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162775,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2002dp',NULL,162775,33.56,0.31,51,75973,65,NULL,'SALT2','NGC 7678',0.011639,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162776,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2002dp',NULL,162776,33.57,0.29,51,75973,65,NULL,'MLCS17','NGC 7678',0.011639,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162777,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2002dp',NULL,162777,34.2,0.03,68.4,75973,70,NULL,'SALT 2','NGC 7678',0.011639,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162778,'Sosies','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162778,32.74,0.39,35.3,75973,NULL,NULL,NULL,'NGC 7678',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162779,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162779,32.46,0.4,31,75973,75,NULL,'HOSTS SN 2002dp','NGC 7678',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162780,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162780,33.01,0.45,39.9,75973,NULL,NULL,'K','NGC 7678',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162781,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162781,33.07,0.46,41.1,75973,NULL,NULL,'J','NGC 7678',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162782,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162782,33.07,0.47,41.1,75973,NULL,NULL,'H','NGC 7678',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162783,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162783,33.31,0.4,45.9,75973,NULL,NULL,'mean','NGC 7678',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162784,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SDSS-II SN 13444','RN',162784,41.86,0.29,1890,75974,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13444',0.243958,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162785,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SDSS-II SN 13444','RN',162785,42.52,0.32,2560,75974,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13444',0.243958,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162786,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162786,34.19,0.4,68.7,75975,NULL,NULL,'mean','NGC 7680',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000073,NULL,'13.68',1.9,'S0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,352.14625,32.41572,0.281,NULL,52062831901,813481748,12710652,13.68),(162787,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162787,34.78,0.45,90.4,75975,NULL,NULL,'K','NGC 7680',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162788,'Brightest Stars','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162788,26.1,0.6,1.66,75976,NULL,NULL,NULL,'PegDIG',NULL,'1982ApJ...254...38H',1982,1,5,'Not to be confused with the Pegasus Dwarf Spheroidal = Andromeda VI.','G',0.000001,NULL,'13.21',2.7,'dIrr/dSph','Group member',NULL,NULL,NULL,1,352.1510417,14.74292,0.093,1,51633938021,806780281,12605941,13.21),(162789,'Brightest Stars','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162789,26.94,0.9,2.44,75976,NULL,NULL,'3, B, blue stars','PegDIG',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162790,'Brightest Stars','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162790,26.96,0.58,2.47,75976,NULL,NULL,'V, 3, red stars','PegDIG',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162791,'Brightest Stars','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162791,27.2,0.55,2.75,75976,NULL,NULL,'3, B, red stars','PegDIG',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162792,'Brightest Stars','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162792,27.54,0.88,3.22,75976,NULL,NULL,'3, B, blue stars','PegDIG',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162793,'Brightest Stars','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162793,27.57,0.35,3.27,75976,NULL,NULL,'3, B, red stars revised','PegDIG',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162794,'Brightest Stars','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162794,27.66,0.36,3.4,75976,NULL,NULL,'V, 3, red stars revised','PegDIG',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162795,'Brightest Stars','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162795,28.1,0.9,4.17,75976,NULL,NULL,'red stars','PegDIG',NULL,'1986AJ.....91..496S',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162796,'Brightest Stars','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162796,28.19,NULL,4.35,75976,NULL,NULL,'Photographic','PegDIG',NULL,'1982ApJ...256..339S',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162797,'Carbon Stars','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162797,26.6,0.5,2.09,75976,NULL,18.73,'LMC ZP','PegDIG',NULL,'1982ApJ...254...38H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162798,'Cepheids','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162798,24.92,0.2,0.964,75976,NULL,NULL,'3, R','PegDIG',NULL,'2006MmSAI..77..299G',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162799,'Cepheids','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162799,25.15,0.1,1.07,75976,NULL,NULL,'26, VI','PegDIG',NULL,'2009AJ....137.3619M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162800,'Cepheids','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162800,25.41,0.06,1.21,75976,74.4,NULL,NULL,'PegDIG',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162801,'Cepheids','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162801,26.22,0.2,1.75,75976,NULL,NULL,'10','PegDIG',NULL,'1990AJ....100.1151H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162802,'CMD','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162802,24.4,0.2,0.76,75976,NULL,NULL,'CMD','PegDIG',NULL,'1998AJ....115.1869G',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162803,'PNLF','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162803,29,0.38,6.4,75976,NULL,NULL,NULL,'PegDIG',NULL,'1981AJ.....86..185J',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162804,'Red Clump','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162804,24.96,NULL,0.981,75976,NULL,NULL,'V, M RC(V) = +0.73 mag','PegDIG',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162805,'Red Clump','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162805,25.18,NULL,1.08,75976,NULL,NULL,'I, M RC(I) = -0.50 mag','PegDIG',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162806,'TRGB','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162806,24.4,NULL,0.76,75976,NULL,NULL,NULL,'PegDIG',NULL,'2000glg..book.....V',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162807,'TRGB','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162807,24.7,0.1,0.871,75976,NULL,NULL,NULL,'PegDIG',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162808,'TRGB','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162808,24.82,0.07,0.919,75976,NULL,NULL,NULL,'PegDIG',NULL,'2005MNRAS.356..979M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162809,'TRGB','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162809,24.88,0.17,0.946,75976,NULL,NULL,NULL,'PegDIG',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162810,'TRGB','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162810,24.9,0.1,0.955,75976,NULL,NULL,'I','PegDIG',NULL,'1994ApJ...437L..27A',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162811,'TRGB','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162811,25.04,NULL,1.02,75976,NULL,NULL,'I, M TRGB(I) = -4.05 mag','PegDIG',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162812,'TRGB','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162812,25.13,0.11,1.06,75976,NULL,NULL,NULL,'PegDIG',NULL,'1995JKAS...28..169L',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162813,'TRGB','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162813,25.41,0.06,1.21,75976,74.4,NULL,NULL,'PegDIG',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162814,'TRGB','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162814,25.6,NULL,1.32,75976,NULL,NULL,NULL,'PegDIG',NULL,'1982ApJ...254...38H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162815,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162815,25,0.4,1,75976,75,NULL,'B','PegDIG',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162816,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g142',NULL,162816,40.76,0.3,1010,75977,74.2,NULL,'SALT 2','ESSENCE g142 HOST',0.404,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,352.157083,-8.75111,0.056,NULL,49655130497,775861414,12122834,NULL),(162817,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g142',NULL,162817,41.52,0.4,1430,75977,65,NULL,'SALT2','ESSENCE g142 HOST',0.404,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162818,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g142',NULL,162818,41.71,0.28,1570,75977,70,NULL,'SALT','ESSENCE g142 HOST',0.404,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162819,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g142',NULL,162819,41.79,0.31,1620,75977,65,NULL,'SALT','ESSENCE g142 HOST',0.404,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162820,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g142',NULL,162820,41.81,0.24,1640,75977,65,NULL,'MLCS2k2','ESSENCE g142 HOST',0.404,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162821,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g142',NULL,162821,41.96,0.42,1760,75977,65,NULL,'MLCS2k2','ESSENCE g142 HOST',0.404,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162822,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g142',NULL,162822,42.15,0.14,1920,75977,65,NULL,'SALT','ESSENCE g142 HOST',0.404,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162823,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g142','R',162823,42.29,NULL,2050,75977,65,NULL,'SALT','ESSENCE g142 HOST',0.404,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162824,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m026',NULL,162824,42.7,0.34,2100,75978,65,NULL,'SALT2','ESSENCE m026 HOST',0.655,'2009ApJ...700.1097H',2009,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,352.1665417,-9.33056,0.072,NULL,49654672630,775854259,12122722,NULL),(162825,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m026',NULL,162825,42.85,0.46,2240,75978,70,NULL,'SALT','ESSENCE m026 HOST',0.655,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162826,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m026',NULL,162826,42.88,0.26,2280,75978,65,NULL,'MLCS17','ESSENCE m026 HOST',0.655,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162827,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m026',NULL,162827,43.02,0.22,2430,75978,65,NULL,'MLCS2k2','ESSENCE m026 HOST',0.655,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162828,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m026',NULL,162828,43.02,0.23,2430,75978,65,NULL,'MLCS31','ESSENCE m026 HOST',0.655,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162829,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m026',NULL,162829,43.18,0.17,2610,75978,65,NULL,'SALT','ESSENCE m026 HOST',0.655,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162830,'L(H{beta})-{sigma}','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162830,42.76,NULL,1332,75979,74.3,NULL,NULL,'DEEP2 32034223',0.636397,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',0.000002,NULL,'23.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,352.1735,0.30556,0.101,NULL,51579663629,805932244,12592691,23.2),(162831,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162831,31.29,0.4,18.1,75980,75,NULL,'B','IC 5325',NULL,'1988NBGC.C....0000T',1988,1,2.8,NULL,'G',0.000023,NULL,'11.83',2.5,'SAB(rs)bc','X-ray-faint group member',NULL,NULL,NULL,1,352.1809583,-41.33347,NULL,NULL,50471018405,788609662,12322025,11.83),(162832,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162832,33.37,0.8,47.3,75981,75,NULL,'W91PP, r','UGC 12619',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00002,NULL,'14.92',0.9,'SAB(s)dm',NULL,NULL,NULL,NULL,1,352.182583,22.23672,0.077,NULL,52504853630,820388337,12818567,14.92),(162833,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162833,33.5,0.38,50.1,75981,75,NULL,'W91PP, r, inv','UGC 12619',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162834,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162834,33.57,0.38,51.7,75981,75,NULL,'W91PP, r, raw','UGC 12619',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162835,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162835,33.77,0.38,56.8,75981,75,NULL,'W91PP, r, cor','UGC 12619',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162836,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 13445','RN',162836,40.35,0.24,959,75982,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13445',0.223232,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162837,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 13445','RN',162837,40.79,0.43,1170,75982,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13445',0.223232,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162838,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 05542','RN',162838,40.78,0.17,1220,75983,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05542',0.172912,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162839,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 05542','RN',162839,41.04,0.26,1370,75983,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 05542',0.172912,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162840,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162840,33.75,0.9,56.2,75984,NULL,NULL,NULL,'NGC 7679',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000013,NULL,'13.47',0.9,'SB0 pec:;HIISy1LIRG','Pair member, radial velocity confirmed',NULL,NULL,'Starburst',1,352.194583,3.51147,0.237,NULL,51764068954,808813577,12637712,13.47),(162841,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162841,33.79,0.2,57.3,75984,74.4,NULL,NULL,'NGC 7679',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162842,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162842,33.98,0.81,62.4,75984,NULL,NULL,'Malmquist cor.','NGC 7679',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162843,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162843,36.55,0.46,204,75985,70,NULL,NULL,'IV Zw 152',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000181,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,352.2029583,14.70356,0.089,NULL,51633752310,806777379,12605896,16.5),(162844,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 08114','R',162844,41.27,0.22,1310,75986,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J232852.03+001342.7',0.3718,'2014arXiv1401.3317S',2014,1,0.11,NULL,'G',0.0005,NULL,'20.6g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,352.216833,0.22853,0.101,NULL,51579551262,805930488,12592663,20.6),(162845,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 08114','R',162845,41.52,0.3,1470,75986,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J232852.03+001342.7',0.3718,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162846,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 08114',NULL,162846,41.45,0.18,1950,75986,70,NULL,'SALT 2','SDSS J232852.03+001342.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162847,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 08114',NULL,162847,41.5,0.18,2000,75986,70,NULL,'SALT 2, Malmquist cor.','SDSS J232852.03+001342.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162848,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162848,38.34,0.33,466,75987,70,NULL,NULL,'2MASX J23285235-0929097',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,352.218,-9.48617,0.072,NULL,49654685817,775854465,12122726,17.9),(162849,'GRB','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162849,42.91,NULL,3830,75988,70,NULL,'Pseudo z = 3.22','GRB 010928',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,352.229167,30.65306,0.257,NULL,52069929942,813592655,12712385,NULL),(162850,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19601','RN',162850,44.08,0.32,4790,75989,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 19601',0.363484,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162851,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162851,33.19,0.5,43.5,75990,70,NULL,NULL,'NGC 7676',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000093,NULL,'12.49',0.9,'SA0-: pec',NULL,NULL,NULL,NULL,1,352.257167,-59.71667,0,NULL,48746077269,761657457,11900897,12.49),(162852,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162852,33.18,0.45,43.2,75990,NULL,NULL,'K','NGC 7676',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162853,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162853,33.27,0.4,45.1,75990,NULL,NULL,'mean','NGC 7676',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162854,'BL Lac Luminosity','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162854,40.17,NULL,892,75991,NULL,NULL,NULL,'87GB 232632.6+172658',0.213,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',NULL,NULL,'16.8',NULL,'BLLAC',NULL,NULL,NULL,'BL Lac',1,352.2637917,17.72514,0.101,NULL,52536128114,820877001,12826203,16.8),(162855,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 20492','RN',162855,39.42,0.98,699,75992,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 20492',0.095996,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162856,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162856,34.17,0.8,68.3,75993,75,NULL,'W91PP, r','UGC 12625',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'15.02',0.2,'Sb',NULL,NULL,NULL,NULL,1,352.279375,29.77508,0.249,NULL,52068424126,813569126,12712017,15.02),(162857,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162857,34.26,0.47,71,75993,NULL,NULL,'H','UGC 12625',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162858,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162858,34.27,0.4,71.5,75993,NULL,NULL,'mean','UGC 12625',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162859,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162859,34.32,0.46,73,75993,NULL,NULL,'J','UGC 12625',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162860,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162860,34.39,0.45,75.7,75993,NULL,NULL,'K','UGC 12625',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162861,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162861,34.64,0.49,84.6,75993,75,NULL,'IR','UGC 12625',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162862,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162862,34.74,0.38,88.6,75993,75,NULL,'W91PP, r, raw','UGC 12625',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162863,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162863,34.97,0.38,98.6,75993,75,NULL,'W91PP, r, cor','UGC 12625',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162864,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162864,34.97,0.2,98.6,75993,74.4,NULL,NULL,'UGC 12625',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162865,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162865,34.99,0.38,99.7,75993,75,NULL,'W91PP, r, inv','UGC 12625',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162866,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162866,35.01,0.34,101,75993,NULL,NULL,'Malmquist cor.','UGC 12625',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162867,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162867,35.05,0.33,103,75993,NULL,NULL,NULL,'UGC 12625',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162868,'L(H{beta})-{sigma}','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162868,43.53,NULL,1486,75994,74.3,NULL,NULL,'DEEP2 32039400',0.850681,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',0.000114,NULL,'23.4R',NULL,'AGN',NULL,NULL,NULL,NULL,1,352.284166667,0.34464,0.101,NULL,51580404306,805943817,12592872,23.4),(162869,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162869,36.54,0.71,204,75995,70,NULL,NULL,'2MASX J23290871-1908407',NULL,'2014MNRAS.445.2677S',2014,1,0.28,NULL,'G',0.00015,NULL,'16.34',0.26,NULL,NULL,NULL,NULL,NULL,1,352.286417,-19.14461,0.038,NULL,50327747536,786371055,12287047,16.34),(162870,'BL Lac Luminosity','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162870,39.44,NULL,772,75996,NULL,NULL,'Min. z = 0.2','1FGL J2329.2+3755',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,352.301,37.931,0.629,NULL,51868028285,810437941,12663092,NULL),(162871,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162871,35.13,0.8,106,75997,75,NULL,'W91PP, r','UGC 12626',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000008,NULL,'15.48',0.4,'S?',NULL,NULL,NULL,NULL,1,352.313125,26.37892,0.193,NULL,51986951213,812296112,12692126,15.48),(162872,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162872,35.18,0.4,109,75997,NULL,NULL,'mean','UGC 12626',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162873,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162873,35.46,0.47,124,75997,NULL,NULL,'H','UGC 12626',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162874,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162874,35.56,0.38,130,75997,75,NULL,'W91PP, r, raw','UGC 12626',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162875,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162875,35.73,0.38,140,75997,75,NULL,'W91PP, r, cor','UGC 12626',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162876,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162876,35.79,0.38,144,75997,75,NULL,'W91PP, r, inv','UGC 12626',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162877,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07365','R',162877,41.72,0.34,1580,75998,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J232916.13+003447.2',0.393925,'2014arXiv1401.3317S',2014,1,0.1,NULL,'G',NULL,'PHOT','20.7g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,352.31725,0.57981,0.101,NULL,51580365297,805943207,12592862,20.7),(162878,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07365','R',162878,41.9,0.26,1720,75998,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J232916.13+003447.2',0.393925,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162879,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07365',NULL,162879,42.01,0.25,2520,75998,70,NULL,'SALT 2','SDSS J232916.13+003447.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162880,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07365',NULL,162880,42.08,0.25,2610,75998,70,NULL,'SALT 2, Malmquist cor.','SDSS J232916.13+003447.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162881,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162881,36.8,0.64,230,75999,70,NULL,NULL,'2MASX J23291660-1233234',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'16.09',0.57,NULL,NULL,NULL,NULL,NULL,1,352.319125,-12.55656,0.053,NULL,49574071751,774594871,12103044,16.09),(162882,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162882,37.63,0.52,336,76000,70,NULL,NULL,'2MASX J23291671-3754449',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.55',0.35,NULL,NULL,NULL,NULL,NULL,1,352.319666667,-37.91242,NULL,NULL,49985849707,781028901,12203576,16.55),(162883,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162883,36.8,0.52,229,76001,70,NULL,NULL,'6dF J2329177-345930',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,352.324125,-34.99178,NULL,NULL,49971156688,780799323,12199989,14.6),(162884,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 03852','RN',162884,40.67,0.28,1010,76002,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 03852',0.348385,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162885,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 03852','RN',162885,40.95,0.42,1150,76002,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 03852',0.348385,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162886,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162886,32.9,0.2,38,76003,74.4,NULL,NULL,'UGC 12628',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.00003,NULL,'14.90',1.2,'SB(rs)c:',NULL,NULL,NULL,NULL,1,352.341875,3.38989,0.205,NULL,51583514034,805992406,12593631,14.9),(162887,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162887,33.15,0.61,42.6,76003,NULL,NULL,NULL,'UGC 12628',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162888,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162888,33.51,0.51,50.3,76003,NULL,NULL,'Malmquist cor.','UGC 12628',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162889,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162889,38.26,0.46,450,76004,70,NULL,NULL,'SDSS J232924.48+140421.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000145,NULL,'18.9g',0.11,NULL,NULL,NULL,NULL,NULL,1,352.352041667,14.07261,0.105,NULL,51637690029,806838906,12606857,18.9),(162890,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19578','RN',162890,41.49,0.28,1550,76005,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19578',0.283019,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162891,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19578','RN',162891,42.15,0.28,2100,76005,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19578',0.283019,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162892,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 17421','R',162892,40.45,0.38,962,76006,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17421',0.278103,'2014arXiv1401.3317S',2014,1,0.09,NULL,'G',NULL,'PHOT','20.0g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,352.385625,0.67661,0.097,NULL,51580317053,805942453,12592850,20),(162893,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 17421',NULL,162893,39.98,0.51,989,76006,70,NULL,'SN photometric redshift distance, z photo =0.265 +/- 0.085','SDSS-II SN 17421',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162894,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 17421',NULL,162894,40.29,0.27,1140,76006,70,NULL,'SALT 2','SDSS-II SN 17421',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162895,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 17421',NULL,162895,40.31,0.27,1150,76006,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 17421',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162896,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 17421','R',162896,40.85,0.32,1160,76006,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17421',0.278103,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162897,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162897,36.89,0.46,239,76007,70,NULL,NULL,'2MASX J23293404-0858310',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000152,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,352.391916667,-8.97514,0.057,NULL,49655286044,775863844,12122872,17),(162898,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162898,35.05,0.4,102,76008,NULL,NULL,'mean','IC 5326',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.00003,NULL,'14.60',0.4,'Sb             HII','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,352.3965,-28.83117,0.035,NULL,50138911251,783420488,12240945,14.6),(162899,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162899,35.25,0.3,112,76008,NULL,NULL,NULL,'IC 5326',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162900,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162900,35.28,0.47,114,76008,NULL,NULL,'H','IC 5326',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162901,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162901,35.29,0.2,114,76008,74.4,NULL,NULL,'IC 5326',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162902,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162902,35.41,0.28,121,76008,NULL,NULL,'Malmquist cor.','IC 5326',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162903,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m032',NULL,162903,38.78,0.33,494,76009,74.2,NULL,'SALT 2','ESSENCE m032 HOST',0.155,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,352.39725,-9.97953,0.115,NULL,49599254508,774988351,12109192,NULL),(162904,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m032',NULL,162904,39.46,0.09,675,76009,70,NULL,'SALT','ESSENCE m032 HOST',0.155,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162905,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m032',NULL,162905,39.72,0.16,762,76009,65,NULL,'SALT','ESSENCE m032 HOST',0.155,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162906,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m032',NULL,162906,39.77,0.79,778,76009,65,NULL,'SALT2','ESSENCE m032 HOST',0.155,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162907,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m032',NULL,162907,39.8,0.21,790,76009,65,NULL,'MLCS17','ESSENCE m032 HOST',0.155,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162908,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m032',NULL,162908,39.92,0.18,833,76009,65,NULL,'MLCS31','ESSENCE m032 HOST',0.155,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162909,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m032',NULL,162909,39.95,0.15,848,76009,65,NULL,'MLCS2k2','ESSENCE m032 HOST',0.155,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162910,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162910,37.97,0.46,393,76010,70,NULL,NULL,'2MASX J23294045-0052101',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000089,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,352.418625,-0.86939,0.129,NULL,49418735769,772167746,12065121,17.7),(162911,'GRB','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162911,41.97,0.15,2480,76011,NULL,NULL,'Photo z Bayesian = 0.94 +/- 0.13','GRB 981226',NULL,'2005ApJ...631L..29C',2005,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'SAX/WFC',NULL,NULL,NULL,NULL,1,352.416667,-23.925,0.044,NULL,50021653646,781588338,12212317,NULL),(162912,'GRB','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162912,42.16,0.06,2710,76011,NULL,NULL,'Photo z = 1.11 +/- 0.06','GRB 981226',NULL,'2005ApJ...631L..29C',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162913,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2004fi',NULL,162913,40.7,0.2,1090,76012,65,NULL,'ESSENCE g001, MLCS17','APMUKS(BJ) B232710.07-091108.8',0.265,'2009ApJ...700.1097H',2009,1,0.11,NULL,'G',NULL,NULL,'20.15',0.09,NULL,NULL,NULL,NULL,NULL,1,352.43875,-8.90997,0.057,NULL,49654992586,775859259,12122800,20.15),(162914,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2004fi',NULL,162914,40.83,0.25,1160,76012,65,NULL,'ESSENCE g001, SALT2','APMUKS(BJ) B232710.07-091108.8',0.265,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162915,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2004fi',NULL,162915,40.84,0.16,1170,76012,65,NULL,'ESSENCE g001, MLCS31','APMUKS(BJ) B232710.07-091108.8',0.265,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162916,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162916,38.12,0.33,420,76013,70,NULL,NULL,'2MASX J23294530+1348198',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,352.438833,13.80536,0.085,NULL,51639970561,806874540,12607414,17.4),(162917,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','PS1 SN PS10bmb','N',162917,41.3,0.64,1340,76014,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10bmb HOST',0.3588,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162918,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 21557','R',162918,41.25,0.75,1250,76015,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21557',0.421165,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,352.449041667,-0.60286,0.129,NULL,49419278334,772176223,12065253,NULL),(162919,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 21557','R',162919,41.51,0.44,1410,76015,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 21557',0.421165,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162920,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 21557',NULL,162920,41.1,0.44,1660,76015,70,NULL,'SN photometric redshift distance, z photo =0.505 +/- 0.168','SDSS-II SN 21557',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162921,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162921,37.6,0.46,331,76016,70,NULL,NULL,'SDSS J232950.39-095446.5',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00015,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,352.46,-9.91294,0.115,NULL,49599281162,774988768,12109199,16.5),(162922,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162922,34.25,0.4,70.8,76017,NULL,NULL,'mean','CGCG 497-028',NULL,'2007A&A...465...71T',2007,1,0.8,NULL,'G',0.000033,NULL,'15.60',0.35,'Sb?',NULL,NULL,NULL,NULL,1,352.461208333,32.70272,0.297,NULL,52062234105,813472407,12710506,15.6),(162923,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162923,34.66,0.47,85.3,76017,NULL,NULL,'H','CGCG 497-028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162924,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162924,34.7,0.46,87.1,76017,NULL,NULL,'J','CGCG 497-028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162925,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162925,34.71,0.45,87.5,76017,NULL,NULL,'K','CGCG 497-028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162926,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m043',NULL,162926,39.63,0.25,666,76018,74.2,NULL,'SALT 2','ESSENCE m043 HOST',0.266,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,352.465541667,-8.94614,0.057,NULL,49654958413,775858725,12122792,NULL),(162927,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m043',NULL,162927,40.82,0.34,1150,76018,65,NULL,'MLCS2k2','ESSENCE m043 HOST',0.266,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162928,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m043',NULL,162928,41.87,0.96,1870,76018,65,NULL,'SALT','ESSENCE m043 HOST',0.266,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162929,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162929,35.81,0.33,145,76019,70,NULL,NULL,'2MASX J23295270+1333596',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000155,NULL,'16.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,352.469708333,13.56644,0.077,NULL,51639886106,806873220,12607394,16.7),(162930,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162930,33.27,0.69,45.1,76020,100,NULL,'mid-IR','CGCG 497-029',NULL,'2013ApJ...771...88L',2013,1,0.9,NULL,'G',0.000033,NULL,'14.95',0.4,'S0?',NULL,NULL,NULL,NULL,1,352.472875,32.08517,0.281,NULL,52062053478,813469585,12710462,14.95),(162931,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162931,34.45,0.36,77.6,76021,NULL,NULL,NULL,'UGC 12629',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.11',0.2,'Sa',NULL,NULL,NULL,NULL,1,352.478833333,32.64969,0.297,NULL,52062231552,813472368,12710505,15.11),(162932,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162932,34.58,0.33,82.5,76021,NULL,NULL,'Malmquist cor.','UGC 12629',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162933,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162933,34.63,0.2,84.3,76021,74.4,NULL,NULL,'UGC 12629',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162934,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE p425',NULL,162934,41.22,4.56,1200,76022,65,NULL,'SALT','ESSENCE p425 HOST',0.458,'2007ApJ...666..694W',2007,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,352.484125,-8.57342,0.053,NULL,49654811583,775856430,12122756,NULL),(162935,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE p425',NULL,162935,42.27,0.41,1950,76022,65,NULL,'MLCS2k2','ESSENCE p425 HOST',0.458,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162936,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE p425',NULL,162936,42.43,0.32,2100,76022,65,NULL,'MLCS17','ESSENCE p425 HOST',0.458,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162937,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE p425',NULL,162937,42.56,0.44,2230,76022,65,NULL,'SALT2','ESSENCE p425 HOST',0.458,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162938,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE p425',NULL,162938,42.71,0.36,2390,76022,65,NULL,'MLCS31','ESSENCE p425 HOST',0.458,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162939,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE n326',NULL,162939,40.52,0.25,1000,76023,65,NULL,'MLCS2k2','SDSS J232958.25-085312.6',0.263156,'2009ApJS..185...32K',2009,1,0.16,NULL,'G',0.000152,NULL,'19.3g',0.09,'BrClG',NULL,NULL,NULL,NULL,1,352.49275,-8.88683,0.052,NULL,49655003444,775859428,12122803,19.3),(162940,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE n326',NULL,162940,40.55,0.32,1020,76023,65,NULL,'MLCS17','SDSS J232958.25-085312.6',0.263156,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162941,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE n326',NULL,162941,40.76,0.26,1120,76023,65,NULL,'MLCS31','SDSS J232958.25-085312.6',0.263156,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162942,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE n326',NULL,162942,40.77,0.2,1130,76023,70,NULL,'SALT','SDSS J232958.25-085312.6',0.263156,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162943,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE n326',NULL,162943,40.79,0.59,1140,76023,65,NULL,'SALT2','SDSS J232958.25-085312.6',0.263156,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162944,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE n326','R',162944,40.8,NULL,1150,76023,65,NULL,'MLCS17','SDSS J232958.25-085312.6',0.263156,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162945,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE n326',NULL,162945,40.81,0.24,1150,76023,65,NULL,'MLCS2k2','SDSS J232958.25-085312.6',0.263156,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162946,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE n326',NULL,162946,40.92,0.18,1210,76023,65,NULL,'SALT','SDSS J232958.25-085312.6',0.263156,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162947,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE n326',NULL,162947,41.02,0.07,1260,76023,65,NULL,'SALT','SDSS J232958.25-085312.6',0.263156,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162948,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE n326',NULL,162948,41.03,0.3,1270,76023,74.2,NULL,'SALT 2','SDSS J232958.25-085312.6',0.263156,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162949,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE n326',NULL,162949,41.04,0.43,1280,76023,65,NULL,'SALT2','SDSS J232958.25-085312.6',0.263156,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162950,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162950,29.82,0.4,9.2,76024,75,NULL,'B','UGC 12632',NULL,'1988NBGC.C....0000T',1988,1,4.5,NULL,'G',0.00002,NULL,'12.78',3.7,'Sm:','in a triple',NULL,NULL,NULL,1,352.494458333,40.99022,0.505,NULL,55306210298,864159535,13502492,12.78),(162951,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162951,29.93,NULL,9.68,76024,NULL,NULL,NULL,'UGC 12632',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162952,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162952,35.41,0.8,121,76025,75,NULL,'W91PP, r','UGC 12631',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000007,NULL,'14.94',0.3,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,352.50475,27.08678,0.149,NULL,51987750417,812308600,12692321,14.94),(162953,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162953,35.41,0.8,121,76025,75,NULL,'HMCL, I','UGC 12631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162954,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162954,35.41,0.8,121,76025,75,NULL,'W91CL, r','UGC 12631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162955,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162955,35.42,0.8,121,76025,75,NULL,'CF, r','UGC 12631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162956,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162956,35.06,0.38,103,76025,75,NULL,'W91CL, r, raw','UGC 12631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162957,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162957,35.11,0.4,105,76025,75,NULL,'HMCL, I, raw','UGC 12631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162958,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162958,35.19,0.38,109,76025,75,NULL,'W91PP, r, raw','UGC 12631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162959,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162959,35.24,0.38,112,76025,75,NULL,'W91CL, r, inv','UGC 12631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162960,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162960,35.27,0.38,113,76025,75,NULL,'W91CL, r, cor','UGC 12631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162961,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162961,35.33,0.38,116,76025,75,NULL,'CF, r, raw','UGC 12631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162962,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162962,35.33,0.4,116,76025,75,NULL,'HMCL, I, inv','UGC 12631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162963,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162963,35.34,0.4,117,76025,75,NULL,'HMCL, I, cor','UGC 12631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162964,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162964,35.39,0.38,120,76025,75,NULL,'W91PP, r, cor','UGC 12631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162965,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162965,35.42,0.38,122,76025,75,NULL,'W91PP, r, inv','UGC 12631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162966,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162966,35.52,0.38,127,76025,75,NULL,'CF, r, cor','UGC 12631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162967,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162967,35.52,0.38,127,76025,75,NULL,'CF, r, inv','UGC 12631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162968,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162968,35.52,0.43,127,76025,75,NULL,'3.6 micron, color corrected','UGC 12631',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162969,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162969,35.58,0.2,131,76025,74.4,NULL,NULL,'UGC 12631',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162970,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162970,35.6,0.4,132,76025,NULL,NULL,'mean','UGC 12631',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162971,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162971,35.65,0.43,135,76025,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12631',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162972,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162972,35.69,0.07,138,76025,NULL,NULL,NULL,'UGC 12631',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162973,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162973,35.75,0.47,141,76025,NULL,NULL,'H','UGC 12631',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162974,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m022',NULL,162974,41.63,0.34,1710,76026,65,NULL,'MLCS2k2','ESSENCE m022 HOST',0.24,'2007ApJ...666..694W',2007,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,352.51125,-8.56017,0.053,NULL,49656666353,775885411,12123209,NULL),(162975,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m022',NULL,162975,42.43,0.13,2470,76026,65,NULL,'SALT','ESSENCE m022 HOST',0.24,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162976,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162976,38,0.46,398,76027,70,NULL,NULL,'2MASX J23300549-1009037',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000169,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,352.5227917,-10.15114,0.115,NULL,49601336301,775020879,12109701,17.5),(162977,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162977,37.39,0.46,301,76028,70,NULL,NULL,'2MASX J23300547-0920467',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000136,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,352.522833,-9.34639,0.07,NULL,49654624615,775853509,12122711,17.6),(162978,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162978,33.17,0.5,43.1,76029,70,NULL,NULL,'ESO 148- G 017',NULL,'2014MNRAS.445.2677S',2014,1,2.2,NULL,'G',0.00007,NULL,'13.3',0.8,'E6',NULL,NULL,NULL,NULL,1,352.5277917,-59.46469,0,NULL,48744436315,761631817,11900497,13.3),(162979,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162979,34.39,0.2,75.5,76030,74.4,NULL,NULL,'UGC 12634',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000037,NULL,'15.50',0.4,'Scd:',NULL,NULL,NULL,NULL,1,352.52925,40.22489,0.501,NULL,51866917905,810420592,12662821,15.5),(162980,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162980,34.41,0.35,76,76030,NULL,NULL,NULL,'UGC 12634',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162981,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162981,34.5,0.33,79.4,76030,NULL,NULL,'Malmquist cor.','UGC 12634',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162982,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162982,34.85,0.49,93.4,76030,75,NULL,'IR','UGC 12634',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162983,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19309','RN',162983,43.71,0.24,3610,76031,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 19309',0.526355,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162984,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2002ja',NULL,162984,40.62,0.27,1000,76032,74.2,NULL,'SALT 2','SDSS J233009.61-093503.3',0.33,'2010ApJ...716..712A',2010,1,0.11,NULL,'G',0.01,NULL,'20.6g',0.06,NULL,NULL,NULL,NULL,NULL,1,352.540083333,-9.58428,0.069,NULL,49654779514,775855929,12122748,20.6),(162985,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2002ja','R',162985,41.16,NULL,1280,76032,65,NULL,'SN b016, SALT','SDSS J233009.61-093503.3',0.33,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162986,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2002ja',NULL,162986,41.35,0.41,1400,76032,65,NULL,'SN b016, MLCS2k2','SDSS J233009.61-093503.3',0.33,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162987,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2002ja',NULL,162987,41.38,0.25,1420,76032,70,NULL,'SN b016, SALT','SDSS J233009.61-093503.3',0.33,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162988,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2002ja',NULL,162988,41.47,0.27,1480,76032,65,NULL,'SN b016, SALT','SDSS J233009.61-093503.3',0.33,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162989,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2002ja',NULL,162989,41.88,0.17,1780,76032,65,NULL,'SN b016, SALT','SDSS J233009.61-093503.3',0.33,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162990,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162990,38.12,0.33,420,76033,70,NULL,NULL,'SDSS J233010.67+134518.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,352.5445,13.75519,0.085,NULL,51639905261,806873519,12607398,18.6),(162991,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162991,33.04,0.69,40.5,76034,100,NULL,'mid-IR','UGC 12633',NULL,'2013ApJ...771...88L',2013,1,1.39,NULL,'G',0.000017,NULL,'14.3g',0.81,'SABb           LLIRG','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,352.556875,15.76103,0.081,NULL,52517407442,820584491,12821632,14.3),(162992,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162992,33.69,0.07,54.8,76034,NULL,NULL,NULL,'UGC 12633',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162993,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162993,33.8,0.4,57.6,76034,NULL,NULL,'mean','UGC 12633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162994,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162994,34.18,0.45,68.4,76034,NULL,NULL,'K','UGC 12633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162995,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162995,34.26,0.47,71.1,76034,NULL,NULL,'H','UGC 12633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162996,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162996,34.39,0.46,75.4,76034,NULL,NULL,'J','UGC 12633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162997,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162997,34.63,0.2,84.3,76034,74.4,NULL,NULL,'UGC 12633',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162998,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162998,36.98,0.46,249,76035,70,NULL,NULL,'2MASX J23301841+1441482',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000186,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,352.576833,14.69672,0.089,NULL,51635177666,806799651,12606244,17),(162999,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162999,35.81,0.33,145,76036,70,NULL,NULL,'2MASX J23301966+1326572',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.00022,NULL,'15.1g',0.55,'E0',NULL,NULL,NULL,NULL,1,352.5819583,13.44914,0.085,NULL,51639564131,806868189,12607315,15.1),(163000,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2004fn','R',163000,41.46,NULL,1220,76037,65,NULL,'SN g050, SALT','ESSENCE J233020.12-095830.7',0.605,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,352.583833,-9.97519,0.115,NULL,49599229788,774987965,12109186,NULL),(163001,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2004fn',NULL,163001,41.48,0.26,1230,76037,74.2,NULL,'SALT 2','ESSENCE J233020.12-095830.7',0.605,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163002,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2004fn',NULL,163002,42.2,0.23,1710,76037,65,NULL,'SN g050, SALT2','ESSENCE J233020.12-095830.7',0.605,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163003,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2004fn',NULL,163003,42.23,0.3,1740,76037,70,NULL,'SN g050, SALT','ESSENCE J233020.12-095830.7',0.605,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163004,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2004fn',NULL,163004,42.36,0.27,1850,76037,65,NULL,'SN g050, SALT','ESSENCE J233020.12-095830.7',0.605,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163005,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2004fn',NULL,163005,42.42,0.26,1890,76037,65,NULL,'SN g050, MLCS2k2','ESSENCE J233020.12-095830.7',0.605,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163006,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2004fn',NULL,163006,42.57,0.08,2030,76037,65,NULL,'SN g050, SALT','ESSENCE J233020.12-095830.7',0.605,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163007,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2004fn',NULL,163007,42.77,0.15,2230,76037,65,NULL,'SN g050, MLCS2k2','ESSENCE J233020.12-095830.7',0.605,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163008,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163008,31.21,0.43,17.5,76038,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12639',NULL,'2014MNRAS.444..527S',2014,1,1.5,NULL,'G',0.000033,NULL,'14.47',1.2,'SB(s)b',NULL,NULL,NULL,NULL,1,352.6125,30.22189,0.257,NULL,52071808774,813622012,12712843,14.47),(163009,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2003ln','R',163009,41.84,NULL,1430,76039,65,NULL,'SN f231, MLCS31','ESSENCE J233027.15-083547.0',0.63,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,352.613125,-8.59639,0.053,NULL,49654850543,775857039,12122766,NULL),(163010,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2003ln',NULL,163010,42.34,0.25,1800,76039,74.2,NULL,'SALT 2','ESSENCE J233027.15-083547.0',0.63,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163011,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2003ln',NULL,163011,42.92,0.25,2350,76039,70,NULL,'SN f231, SALT','ESSENCE J233027.15-083547.0',0.63,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163012,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2003ln',NULL,163012,42.95,0.19,2390,76039,65,NULL,'SN f231, MLCS17','ESSENCE J233027.15-083547.0',0.63,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163013,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2003ln',NULL,163013,42.98,0.2,2420,76039,65,NULL,'SN f231, MLCS2k2','ESSENCE J233027.15-083547.0',0.63,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163014,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2003ln',NULL,163014,43.03,0.16,2480,76039,65,NULL,'SN f231, MLCS31','ESSENCE J233027.15-083547.0',0.63,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163015,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2003ln',NULL,163015,43.05,0.14,2490,76039,65,NULL,'SN f231, MLCS2k2','ESSENCE J233027.15-083547.0',0.63,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163016,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2003ln',NULL,163016,43.09,0.29,2540,76039,65,NULL,'SN f231, SALT2','ESSENCE J233027.15-083547.0',0.63,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163017,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2003ln',NULL,163017,43.11,0.22,2570,76039,65,NULL,'SN f231, SALT','ESSENCE J233027.15-083547.0',0.63,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163018,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2003ln',NULL,163018,43.17,0.12,2640,76039,65,NULL,'SN f231, SALT','ESSENCE J233027.15-083547.0',0.63,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163019,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2003ln',NULL,163019,43.21,0.23,2680,76039,65,NULL,'SN f231, SALT2','ESSENCE J233027.15-083547.0',0.63,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163020,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163020,34.47,0.59,78.3,76040,NULL,NULL,NULL,'LCSB S2828O',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000018,NULL,'14.28',0.2,'Sc',NULL,NULL,NULL,NULL,1,352.624875,26.13208,0.109,NULL,51988519115,812320611,12692509,14.28),(163021,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163021,34.51,0.2,79.8,76040,74.4,NULL,NULL,'LCSB S2828O',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163022,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163022,34.69,0.53,86.6,76040,NULL,NULL,'Malmquist cor.','LCSB S2828O',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163023,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163023,34.42,0.4,76.5,76041,NULL,NULL,'mean','NGC 7685',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000023,NULL,'13.84',1.4,'SAB(s)c:',NULL,NULL,NULL,NULL,1,352.639583,3.90158,0.245,NULL,51583141651,805986588,12593540,13.84),(163024,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163024,34.63,0.47,84.5,76041,NULL,NULL,'H','NGC 7685',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163025,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163025,34.73,0.45,88.2,76041,NULL,NULL,'K','NGC 7685',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163026,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163026,34.76,0.46,89.5,76041,NULL,NULL,'J','NGC 7685',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163027,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 05659','RN',163027,42.48,0.4,2100,76042,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05659',0.490901,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163028,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 1999fv',NULL,163028,44.19,0.34,3090,76043,65,NULL,NULL,'H-ZSNS J233035.80+001640.0',1.23,'2004ApJ...607..665R',2004,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,352.649167,0.27778,0.097,NULL,51579926866,805936357,12592755,NULL),(163029,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 1999fv',NULL,163029,44.19,0.45,3090,76043,65,NULL,'BATM','H-ZSNS J233035.80+001640.0',1.23,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163030,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 1999fv',NULL,163030,44.39,0.42,3390,76043,65,NULL,'Final','H-ZSNS J233035.80+001640.0',1.23,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163031,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 1999fv',NULL,163031,44.57,0.49,3680,76043,70,NULL,'SALT','H-ZSNS J233035.80+001640.0',1.23,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163032,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 1999fv',NULL,163032,44.59,0.39,3710,76043,65,NULL,'MLCS','H-ZSNS J233035.80+001640.0',1.23,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163033,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163033,34.41,0.47,76.1,76044,70,NULL,NULL,'IC 1492',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000073,NULL,'14.44',1.1,'SB0+?',NULL,NULL,NULL,NULL,1,352.650417,-3.03992,0.157,NULL,49415969952,772124530,12064445,14.44),(163034,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163034,33.39,0.2,47.6,76045,74.4,NULL,NULL,'KUG 2328+153',NULL,'2013AJ....146...86T',2013,1,0.73,NULL,'G',0.000117,NULL,'15.6g',0.46,'Spiral',NULL,NULL,NULL,NULL,1,352.657375,15.60519,0.081,NULL,51635607525,806806367,12606349,15.6),(163035,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163035,33.4,0.08,48,76045,NULL,NULL,NULL,'KUG 2328+153',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163036,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2000dz',NULL,163036,42.75,0.24,2370,76046,65,NULL,NULL,'H-ZSNS J233041.36+001842.7',0.5,'2004ApJ...607..665R',2004,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,352.672333,0.31186,0.097,NULL,51579925869,805936341,12592755,NULL),(163037,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g240','R',163037,41.66,NULL,1270,76047,65,NULL,'MLCS31','ESSENCE g240 HOST',0.687,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,352.674291667,-8.56972,0.05,NULL,49654798420,775856225,12122753,NULL),(163038,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g240',NULL,163038,42.29,0.29,1700,76047,74.2,NULL,'SALT 2','ESSENCE g240 HOST',0.687,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163039,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g240',NULL,163039,42.83,0.28,2180,76047,70,NULL,'SALT','ESSENCE g240 HOST',0.687,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163040,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g240',NULL,163040,42.97,0.22,2330,76047,65,NULL,'MLCS17','ESSENCE g240 HOST',0.687,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163041,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g240',NULL,163041,43.03,0.19,2390,76047,65,NULL,'MLCS31','ESSENCE g240 HOST',0.687,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163042,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g240',NULL,163042,43.02,0.25,2390,76047,65,NULL,'SALT','ESSENCE g240 HOST',0.687,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163043,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g240',NULL,163043,43.03,0.09,2400,76047,65,NULL,'SALT','ESSENCE g240 HOST',0.687,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163044,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g240',NULL,163044,43.04,0.18,2400,76047,65,NULL,'MLCS2k2','ESSENCE g240 HOST',0.687,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163045,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g240',NULL,163045,43.04,0.2,2400,76047,65,NULL,'MLCS2k2','ESSENCE g240 HOST',0.687,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163046,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g240',NULL,163046,43.09,0.29,2460,76047,65,NULL,'SALT2','ESSENCE g240 HOST',0.687,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163047,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g240',NULL,163047,43.17,0.29,2550,76047,65,NULL,'SALT2','ESSENCE g240 HOST',0.687,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163048,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15782',NULL,163048,40.12,0.22,1060,76048,70,NULL,'SN photometric redshift distance, z photo =0.287 +/- 0.037','SDSS-II SN 15782',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,352.676167,-0.42803,0.153,NULL,49419144098,772174126,12065220,NULL),(163049,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15782','R',163049,40.91,0.22,1160,76048,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15782',0.307469,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163050,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15782','R',163050,40.93,0.3,1170,76048,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15782',0.307469,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163051,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15782',NULL,163051,40.76,0.19,1420,76048,70,NULL,'SALT 2','SDSS-II SN 15782',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163052,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15782',NULL,163052,40.79,0.19,1440,76048,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15782',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163053,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163053,35.87,0.56,150,76049,70,NULL,NULL,'2MASX J23304330-1743435',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.11',0.19,NULL,NULL,NULL,NULL,NULL,1,352.680458333,-17.72872,0.028,NULL,50327152923,786361764,12286902,16.11),(163054,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163054,34.48,0.47,78.7,76050,NULL,NULL,'H','IC 1495',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00003,NULL,'14.14',1,'SAB(r)b pec:   Sy2',NULL,NULL,NULL,'Sy 2',1,352.698917,-13.48544,0.061,NULL,49572819832,774575309,12102739,14.14),(163055,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163055,34.5,0.45,79.3,76050,NULL,NULL,'K','IC 1495',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163056,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163056,34.57,0.4,82,76050,NULL,NULL,'mean','IC 1495',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163057,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163057,34.59,0.46,82.9,76050,NULL,NULL,'J','IC 1495',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163058,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163058,38.5,0.46,502,76051,70,NULL,NULL,'SDSS J233052.30+133417.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,352.717958333,13.5715,0.085,NULL,51636869273,806826082,12606657,18.1),(163059,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163059,34.02,0.53,63.8,76052,70,NULL,NULL,'IC 1496',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000073,NULL,'14.52',1.3,'(R)SB(rs)0/a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,352.7229583,-2.93431,0.157,NULL,49415740616,772120947,12064389,14.52),(163060,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163060,32.7,0.43,34.6,76053,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12641',NULL,'2014MNRAS.444..527S',2014,1,1.1,NULL,'G',0.000013,NULL,'15.42',0.2,'Sbc',NULL,NULL,NULL,NULL,1,352.7274583,20.25083,0.165,NULL,52542446726,820975730,12827745,15.42),(163061,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163061,32.75,0.43,35.5,76053,75,NULL,'3.6 micron, color corrected','UGC 12641',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163062,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163062,32.76,0.2,35.7,76053,74.4,NULL,NULL,'UGC 12641',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163063,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163063,32.98,0.52,39.5,76053,NULL,NULL,NULL,'UGC 12641',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163064,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163064,33.35,0.44,46.8,76053,NULL,NULL,'Malmquist cor.','UGC 12641',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163065,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163065,33.24,0.49,44.5,76054,75,NULL,'IR','UGC 12640',NULL,'2011yCatp016004901K',2011,1,1.12,NULL,'G',0.000017,NULL,'15.68',0.13,'Sdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,352.736667,15.4905,0.081,NULL,51635798177,806809346,12606396,15.68),(163066,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163066,34.1,NULL,66.1,76054,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12640',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163067,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163067,34.13,NULL,67,76054,NULL,NULL,'Dipole + Quadrupole','UGC 12640',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163068,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163068,34.14,NULL,67.4,76054,NULL,NULL,'Dipole','UGC 12640',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163069,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07608','RN',163069,43.34,0.42,3360,76055,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 07608',0.387998,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163070,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07608','RN',163070,43.65,0.4,3860,76055,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07608',0.387998,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163071,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163071,34.76,0.49,89.7,76056,75,NULL,'IR','CGCG 454-078',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.00008,NULL,'15.7',0.2,NULL,NULL,NULL,NULL,NULL,1,352.7415,17.48672,0.101,NULL,52534227985,820847312,12825739,15.7),(163072,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163072,38.41,0.46,480,76057,70,NULL,NULL,'2MASX J23305925+1439239',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,352.747,14.6565,0.093,NULL,51635248703,806800760,12606261,17.9),(163073,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163073,34.88,0.49,94.6,76058,70,NULL,NULL,'MCG -05-55-020',NULL,'2014MNRAS.445.2677S',2014,1,0.85,NULL,'G',0.00012,NULL,'15.02',0.52,'S0',NULL,NULL,NULL,NULL,1,352.7500417,-27.52506,0.016,NULL,50020959389,781577490,12212148,15.02),(163074,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163074,37.87,0.46,376,76059,70,NULL,NULL,'2MASX J23310221+0030503',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000083,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,352.759167,0.51392,0.097,NULL,51580277751,805941839,12592841,17.7),(163075,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163075,35.72,0.41,139,76060,NULL,NULL,NULL,'ESO 408- G 005',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.33',0.5,'Sb',NULL,NULL,NULL,NULL,1,352.7682083,-36.30878,NULL,NULL,49983026050,780984782,12202887,16.33),(163076,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163076,35.76,0.2,142,76060,74.4,NULL,NULL,'ESO 408- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163077,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163077,35.76,0.4,142,76060,NULL,NULL,'Malmquist cor.','ESO 408- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163078,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 13832','RN',163078,41.99,0.16,1930,76061,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13832',0.29578,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163079,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 13832','RN',163079,42.28,0.22,2210,76061,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13832',0.29578,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163080,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163080,35.06,0.49,103,76062,75,NULL,'IR','CGCG 454-081',NULL,'2011yCatp016004901K',2011,1,NULL,NULL,'G',0.00013,NULL,'15.7',NULL,NULL,NULL,NULL,NULL,NULL,1,352.785333,17.47822,0.101,NULL,52534401764,820850027,12825781,15.7),(163081,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07373','R',163081,40.95,0.22,1210,76063,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J233113.19+003516.9',0.2799,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',0.0005,NULL,'20.0g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,352.805,0.58803,0.097,NULL,51580251582,805941430,12592834,20),(163082,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07373','R',163082,40.99,0.15,1230,76063,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J233113.19+003516.9',0.2799,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163083,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07373',NULL,163083,40.87,0.12,1490,76063,70,NULL,'SALT 2','SDSS J233113.19+003516.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163084,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07373',NULL,163084,40.89,0.12,1510,76063,70,NULL,'SALT 2, Malmquist cor.','SDSS J233113.19+003516.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163085,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 00986','RN',163085,40.86,0.3,1160,76064,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 00986',0.280578,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163086,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 00986','RN',163086,41.01,0.24,1240,76064,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 00986',0.280578,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163087,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163087,35.07,0.49,103,76065,75,NULL,'IR','UGC 12642',NULL,'2011yCatp016004901K',2011,1,1.36,NULL,'G',0.000017,NULL,'16.5',0.12,'Sd',NULL,NULL,NULL,NULL,1,352.834541667,9.20633,0.137,NULL,51798750200,809355471,12646179,16.5),(163088,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163088,35.32,NULL,116,76065,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12642',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163089,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163089,35.33,NULL,117,76065,NULL,NULL,'Dipole + Quadrupole','UGC 12642',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163090,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163090,35.34,NULL,117,76065,NULL,NULL,'Dipole','UGC 12642',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163091,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163091,35.41,NULL,121,76065,NULL,NULL,NULL,'UGC 12642',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163092,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163092,36.98,0.46,249,76066,70,NULL,NULL,'2MASX J23312689+1446231',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,352.862083,14.773,0.093,NULL,51635279679,806801244,12606269,17),(163093,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163093,34.27,0.8,71.3,76067,75,NULL,'W91PP, r','UGC 12644',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000007,NULL,'15.26',0.7,'SBd',NULL,NULL,NULL,NULL,1,352.8657083,29.18883,0.245,NULL,52068327540,813567617,12711994,15.26),(163094,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163094,33.13,0.2,42.3,76067,74.4,NULL,NULL,'UGC 12644',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163095,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163095,33.28,0.38,45.3,76067,75,NULL,'W91PP, r, inv','UGC 12644',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163096,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163096,33.35,0.38,46.7,76067,75,NULL,'W91PP, r, raw','UGC 12644',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163097,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163097,33.59,0.6,52.2,76067,NULL,NULL,NULL,'UGC 12644',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163098,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163098,33.68,0.38,54.5,76067,75,NULL,'W91PP, r, cor','UGC 12644',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163099,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163099,34.01,0.49,63.3,76067,NULL,NULL,'Malmquist cor.','UGC 12644',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163100,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163100,34.13,0.8,66.9,76068,75,NULL,'W91PP, r','UGC 12645',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'15.03',0.5,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,352.87025,32.48172,0.281,NULL,52031533915,812992717,12703011,15.03),(163101,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163101,33.26,0.2,44.9,76068,74.4,NULL,NULL,'UGC 12645',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163102,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163102,33.34,0.54,46.6,76068,NULL,NULL,NULL,'UGC 12645',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163103,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163103,33.46,0.38,49.2,76068,75,NULL,'W91PP, r, inv','UGC 12645',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163104,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163104,33.47,0.38,49.3,76068,75,NULL,'W91PP, r, raw','UGC 12645',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163105,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163105,33.49,0.51,49.8,76068,NULL,NULL,'Malmquist cor.','UGC 12645',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163106,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163106,33.85,0.38,58.8,76068,75,NULL,'W91PP, r, cor','UGC 12645',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163107,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163107,37.26,0.46,283,76069,70,NULL,NULL,'2MASX J23313301-0920491',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,352.887666667,-9.347,0.078,NULL,49656250112,775878908,12123107,17.7),(163108,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 20493','RN',163108,41.05,0.17,1140,76070,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 20493',0.419656,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163109,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 20493','RN',163109,41.82,0.24,1630,76070,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20493',0.419656,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163110,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163110,36.69,0.46,217,76071,70,NULL,NULL,'2MASX J23313604+0106324',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,352.9000417,1.10886,0.105,NULL,51580026033,805937906,12592779,17.7),(163111,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 20381','RN',163111,41.66,0.33,1680,76072,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 20381',0.277748,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163112,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 20381','RN',163112,42.5,0.31,2480,76072,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20381',0.277748,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163113,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163113,32.13,1.16,26.6,76073,NULL,NULL,NULL,'UGC 12646',NULL,'2009ApJS..182..474S',2009,1,1.9,NULL,'G',0.000023,NULL,'13.99',1.5,'SB(r)b         Sy2','Isolated galaxy',NULL,NULL,'Sy 2',1,352.91275,25.94533,0.109,NULL,51988446842,812319481,12692491,13.99),(163114,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163114,32.3,1.07,28.9,76073,NULL,NULL,'Malmquist cor.','UGC 12646',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163115,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163115,34.51,0.47,79.8,76073,NULL,NULL,'H','UGC 12646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163116,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163116,34.66,0.45,85.6,76073,NULL,NULL,'K','UGC 12646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163117,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163117,34.67,0.46,85.9,76073,NULL,NULL,'J','UGC 12646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163118,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163118,35.17,0.4,108,76073,NULL,NULL,'mean','UGC 12646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163119,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 21306',NULL,163119,38.9,1.28,602,76074,70,NULL,'SN photometric redshift distance, z photo =0.152 +/- 0.144','SDSS-II SN 21306',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,352.92325,0.09142,0.133,NULL,51579720966,805933140,12592705,NULL),(163120,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 21306','R',163120,41.18,0.25,1280,76074,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21306',0.347123,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163121,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 21306','R',163121,41.36,0.2,1390,76074,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 21306',0.347123,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163122,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 21306',NULL,163122,41.05,0.15,1620,76074,70,NULL,'SALT 2','SDSS-II SN 21306',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163123,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 21306',NULL,163123,41.1,0.15,1660,76074,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 21306',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163124,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163124,34.46,0.2,78,76075,74.4,NULL,NULL,'2MASX J23314292+2552180',NULL,'2013AJ....146...86T',2013,1,0.56,NULL,'G',0.00004,NULL,'15.72',0.24,NULL,NULL,NULL,NULL,NULL,1,352.928833333,25.87172,0.109,NULL,51981077906,812204342,12690692,15.72),(163125,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163125,34.57,0.56,82.2,76075,NULL,NULL,NULL,'2MASX J23314292+2552180',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163126,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163126,34.79,0.51,90.7,76075,NULL,NULL,'Malmquist cor.','2MASX J23314292+2552180',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163127,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163127,36.07,0.46,163,76076,70,NULL,NULL,'2MASX J23314359+1409080',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00017,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,352.93175,14.15206,0.113,NULL,51636565834,806821341,12606583,16.6),(163128,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163128,38.17,0.46,431,76077,70,NULL,NULL,'2MASX J23314498-0049002',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00009,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,352.93725,-0.81681,0.125,NULL,49418677376,772166834,12065106,17.9),(163129,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 16281','R',163129,39.63,0.2,712,76078,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006pd','SDSS J233146.12-004005.0',0.186515,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,NULL,'20.8g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,352.942167,-0.66806,0.121,NULL,49418994437,772171788,12065184,20.8),(163130,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2006pd',NULL,163130,39.43,0.08,769,76078,70,NULL,'SALT 2','SDSS J233146.12-004005.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163131,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2006pd',NULL,163131,39.44,0.08,773,76078,70,NULL,'SALT 2, Malmquist cor.','SDSS J233146.12-004005.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163132,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 16281','R',163132,39.92,0.12,812,76078,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006pd','SDSS J233146.12-004005.0',0.186515,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163133,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 03672','RN',163133,42.26,0.21,1790,76079,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03672',0.580843,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163134,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163134,37.88,0.46,376,76080,70,NULL,NULL,'2MASX J23315277+1534567',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000169,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,352.969917,15.58258,0.085,NULL,51635705220,806807894,12606373,17.1),(163135,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 1999fw',NULL,163135,39.85,0.2,729,76081,74.2,NULL,'SALT 2','H-ZSNS J233153.03+000932.3',0.28,'2010ApJ...716..712A',2010,1,0.04,NULL,'G',NULL,NULL,'22.3g',0.03,NULL,NULL,NULL,NULL,NULL,1,352.970875,0.15931,0.129,NULL,51580772423,805949569,12592962,22.3),(163136,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 1999fw','R',163136,40.31,NULL,903,76081,65,NULL,'SALT','H-ZSNS J233153.03+000932.3',0.28,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163137,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 1999fw',NULL,163137,40.67,0.21,1060,76081,70,NULL,'SALT','H-ZSNS J233153.03+000932.3',0.28,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163138,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 1999fw',NULL,163138,40.8,0.24,1130,76081,65,NULL,'dm15','H-ZSNS J233153.03+000932.3',0.28,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163139,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 1999fw',NULL,163139,40.82,0.2,1140,76081,65,NULL,'SALT','H-ZSNS J233153.03+000932.3',0.28,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163140,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 1999fw',NULL,163140,40.89,0.15,1180,76081,65,NULL,'delta m15','H-ZSNS J233153.03+000932.3',0.28,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163141,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 1999fw',NULL,163141,40.93,0.27,1200,76081,65,NULL,'Final','H-ZSNS J233153.03+000932.3',0.28,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163142,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 1999fw',NULL,163142,40.97,0.31,1220,76081,65,NULL,'MLCS','H-ZSNS J233153.03+000932.3',0.28,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163143,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 1999fw',NULL,163143,40.99,0.42,1230,76081,65,NULL,'BATM','H-ZSNS J233153.03+000932.3',0.28,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163144,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 1999fw',NULL,163144,41,0.41,1240,76081,65,NULL,NULL,'H-ZSNS J233153.03+000932.3',0.28,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163145,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163145,34.07,0.49,65.1,76082,75,NULL,'IR','IC 1498',NULL,'2011yCatp016004901K',2011,1,1.8,NULL,'G',0.000043,NULL,'14.03',0.6,'(R\')SB(r)a:',NULL,NULL,NULL,NULL,1,352.9735417,-5.00697,0.117,NULL,49636181355,775565333,12118208,14.03),(163146,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163146,34.12,0.47,66.5,76082,NULL,NULL,'H','IC 1498',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163147,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163147,34.13,0.45,67.1,76082,NULL,NULL,'K','IC 1498',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163148,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163148,34.16,0.46,67.9,76082,NULL,NULL,'J','IC 1498',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163149,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163149,34.2,0.4,69.2,76082,NULL,NULL,'mean','IC 1498',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163150,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163150,36.48,0.55,198,76083,70,NULL,NULL,'2MASX J23315827-4616521',NULL,'2014MNRAS.445.2677S',2014,1,0.17,NULL,'G',0.00015,NULL,'19.17',0.14,NULL,NULL,NULL,NULL,NULL,1,352.992958333,-46.28114,NULL,NULL,50477638275,788713098,12323642,19.17),(163151,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 18737','RN',163151,41.64,0.19,1790,76084,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18737',0.185607,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163152,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 18737','RN',163152,42.25,0.22,2380,76084,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18737',0.185607,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163153,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 00861','RN',163153,43.04,0.24,3000,76085,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 00861',0.352053,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163154,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 00861','RN',163154,43.1,0.25,3090,76085,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00861',0.352053,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163155,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 13868','RN',163155,41.48,0.18,1660,76086,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13868',0.187534,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163156,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 13868','RN',163156,41.96,0.3,2080,76086,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13868',0.187534,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163157,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163157,34.09,0.8,65.7,76087,75,NULL,'W91PP, r','UGC 12650',NULL,'1997ApJS..109..333W',1997,1,1.57,NULL,'G',0.000011,NULL,'15.40',0.22,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,353.010583,32.42244,0.281,NULL,52031564071,812993188,12703018,15.4),(163158,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163158,33.91,0.49,60.4,76087,75,NULL,'IR','UGC 12650',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163159,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163159,33.94,0.43,61.5,76087,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12650',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163160,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163160,34.02,0.43,63.6,76087,75,NULL,'3.6 micron, color corrected','UGC 12650',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163161,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163161,34.03,0.38,64.1,76087,75,NULL,'W91PP, r, raw','UGC 12650',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163162,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163162,34.05,NULL,64.5,76087,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12650',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163163,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163163,34.05,NULL,64.6,76087,NULL,NULL,'Dipole + Quadrupole','UGC 12650',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163164,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163164,34.06,0.2,64.9,76087,74.4,NULL,NULL,'UGC 12650',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163165,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163165,34.06,0.36,65,76087,NULL,NULL,NULL,'UGC 12650',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163166,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163166,34.07,NULL,65.1,76087,NULL,NULL,'Dipole','UGC 12650',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163167,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163167,34.1,0.38,65.9,76087,75,NULL,'W91PP, r, inv','UGC 12650',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163168,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163168,34.11,NULL,66.4,76087,NULL,NULL,NULL,'UGC 12650',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163169,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163169,34.25,0.38,70.9,76087,75,NULL,'W91PP, r, cor','UGC 12650',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163170,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163170,34.36,0.32,74.6,76087,NULL,NULL,'Malmquist cor.','UGC 12650',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163171,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07374',NULL,163171,40.46,0.13,1230,76088,70,NULL,'SN photometric redshift distance, z photo =0.345 +/- 0.026','SDSS-II SN 07374',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,353.01275,0.62028,0.121,NULL,51580908091,805951688,12592995,NULL),(163172,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07374',NULL,163172,41.43,0.19,1930,76088,70,NULL,'SALT 2','SDSS-II SN 07374',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163173,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07374',NULL,163173,41.59,0.19,2080,76088,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 07374',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163174,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15367','RN',163174,40.82,0.71,1230,76089,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 15367',0.186822,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163175,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163175,37.34,0.46,293,76090,70,NULL,NULL,'2MASX J23321713-1037012',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000183,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,353.071375,-10.61689,0.027,NULL,49598109745,774970464,12108913,17),(163176,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163176,37.53,0.46,320,76091,70,NULL,NULL,'SDSS J233223.12+010115.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000115,NULL,'18.3g',0.16,'NLAGN',NULL,NULL,NULL,'Sy 2',1,353.096375,1.02086,0.105,NULL,51580617012,805947140,12592924,18.3),(163177,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163177,37.19,0.46,274,76092,70,NULL,NULL,'SDSS J233224.31-085207.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,353.101333,-8.86872,0.064,NULL,49653501285,775835957,12122436,18),(163178,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163178,33.61,0.08,52.8,76093,NULL,NULL,NULL,'NGC 7691',NULL,'2009ApJS..182..474S',2009,1,1.67,NULL,'G',0.000003,NULL,'13.9g',1.25,'SAB(rs)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,353.10175,15.84783,0.085,NULL,51632230475,806753601,12605525,13.9),(163179,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163179,33.72,0.4,55.4,76093,NULL,NULL,'mean','NGC 7691',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163180,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163180,34,0.47,63.2,76093,NULL,NULL,'H','NGC 7691',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163181,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163181,34.04,0.45,64.2,76093,NULL,NULL,'K','NGC 7691',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163182,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163182,34.04,0.46,64.4,76093,NULL,NULL,'J','NGC 7691',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163183,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163183,35.25,0.64,112,76094,70,NULL,NULL,'2MASX J23322513-1144134',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.13',0.46,NULL,NULL,NULL,NULL,NULL,1,353.104583,-11.737,0.08,NULL,49568791677,774512369,12101755,16.13),(163184,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 01748','R',163184,41.25,0.27,1330,76095,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01748',0.339527,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,353.112167,-0.4825,0.113,NULL,49421196666,772206197,12065721,NULL),(163185,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 01748','R',163185,41.48,0.38,1470,76095,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01748',0.339527,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163186,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163186,33.37,0.49,47.3,76096,75,NULL,'IR','UGC 12653',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.000013,NULL,'14.87',0.5,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,353.124833333,14.81683,0.101,NULL,51635102333,806798473,12606226,14.87),(163187,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163187,36.66,0.46,215,76097,70,NULL,NULL,'2MASX J23323021-0029274',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000094,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,353.125833,-0.49083,0.113,NULL,49421193586,772206149,12065721,16.5),(163188,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163188,35.12,0.29,106,76098,NULL,NULL,NULL,'ESO 536- G 007',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'15.02',0.5,'Sb',NULL,NULL,NULL,NULL,1,353.130667,-24.00519,0.029,NULL,50022177034,781596516,12212445,15.02),(163189,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163189,35.16,0.2,108,76098,74.4,NULL,NULL,'ESO 536- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163190,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163190,35.41,0.25,121,76098,NULL,NULL,'Malmquist cor.','ESO 536- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163191,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163191,35.76,0.48,142,76099,70,NULL,NULL,'UGC 12656',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.32',0.3,'Sc',NULL,NULL,NULL,NULL,1,353.1349583,-1.74081,0.113,NULL,49421787853,772215435,12065866,15.32),(163192,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 14630','RN',163192,42.54,0.18,2380,76100,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 14630',0.352058,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163193,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 14630','RN',163193,42.85,0.16,2750,76100,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 14630',0.352058,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163194,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163194,36.09,0.64,166,76101,70,NULL,NULL,'2MASX J23324001-1626215',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.36',0.38,NULL,NULL,NULL,NULL,NULL,1,353.166625,-16.43928,0.009,NULL,50290638278,785791223,12277987,16.36),(163195,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163195,37.65,0.46,339,76102,70,NULL,NULL,'2MASX J23324005+1338199',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000151,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,353.166916667,13.63872,0.113,NULL,51636992004,806828000,12606687,18),(163196,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163196,36.76,0.46,225,76103,70,NULL,NULL,'2MASX J23324083-0033479',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000076,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,353.1702083,-0.56328,0.113,NULL,49421046497,772203851,12065685,16.7),(163197,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 10714','RN',163197,38.03,1.09,381,76104,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10714',0.057598,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163198,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 10714','RN',163198,38.85,5.78,557,76104,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10714',0.057598,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163199,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','PTF10wof',NULL,163199,36.8,0.07,218,76105,70,NULL,'SiFTO+SALT2, SN PTF10wof','PTF10wof',0.0514,'2012MNRAS.426.2359M',2012,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,353.174167,15.35881,0.101,NULL,51635858507,806810289,12606410,NULL),(163200,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','PTF10wof',NULL,163200,36.86,0.07,224,76105,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10wof',0.0514,'2014MNRAS.438.1391P',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163201,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','PTF10wof',NULL,163201,36.85,0.02,234,76105,NULL,NULL,'J','PTF10wof',NULL,'2012MNRAS.425.1007B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163202,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','PTF10wof',NULL,163202,36.9,0.02,240,76105,72,NULL,'M(H) = -18.317 mag','PTF10wof',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163203,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','PTF10wof',NULL,163203,36.93,0.03,243,76105,NULL,NULL,'H','PTF10wof',NULL,'2012MNRAS.425.1007B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163204,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163204,33.93,0.49,61,76106,75,NULL,'IR','UGC 12659',NULL,'2011yCatp016004901K',2011,1,1.52,NULL,'G',0.00004,NULL,'15.50',0.15,'Sd             HII',NULL,NULL,NULL,NULL,1,353.183,-1.78339,0.113,NULL,49421966741,772218230,12065909,15.5),(163205,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163205,34.54,NULL,80.9,76106,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12659',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163206,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163206,34.55,NULL,81.4,76106,NULL,NULL,'Dipole + Quadrupole','UGC 12659',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163207,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163207,34.56,NULL,81.5,76106,NULL,NULL,'Dipole','UGC 12659',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163208,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163208,34.6,NULL,83.2,76106,NULL,NULL,NULL,'UGC 12659',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163209,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163209,33.42,0.63,48.4,76107,NULL,NULL,NULL,'UGC 12658',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.00001,NULL,'16.0',0.5,'SB?',NULL,NULL,NULL,NULL,1,353.186583,31.11375,0.281,NULL,52037578482,813087163,12704486,16),(163210,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163210,33.78,0.54,57.1,76107,NULL,NULL,'Malmquist cor.','UGC 12658',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163211,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163211,35.81,0.58,145,76108,70,NULL,NULL,'2MASX J23324608-1934478',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'15.97',0.32,'S0',NULL,NULL,NULL,NULL,1,353.1920417,-19.58008,0.064,NULL,50325549950,786336717,12286511,15.97),(163212,'GRB','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163212,48.06,1.61,11900,76109,NULL,NULL,NULL,'GRB 090812',2.452,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,353.202333333,-10.60486,0.027,NULL,49598102982,774970359,12108911,NULL),(163213,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163213,38.26,0.46,449,76110,70,NULL,NULL,'2MASX J23324894+1426055',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000164,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,353.203833333,14.43489,0.141,NULL,51634591555,806790493,12606101,18.2),(163214,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 02661','R',163214,40.83,0.22,1230,76111,70,NULL,'SDSS CAND. SNII; MLCS2K2','SDSS-II SN 02661',0.192911,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'II',NULL,NULL,NULL,NULL,1,353.2075,0.09722,0.129,NULL,51577943633,805905369,12592271,NULL),(163215,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 02661','R',163215,41.62,0.24,1770,76111,70,NULL,'SDSS CAND. SNII; SALT 2','SDSS-II SN 02661',0.192911,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163216,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 03514','RN',163216,40.59,0.12,1040,76112,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 03514',0.264211,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163217,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 03514','RN',163217,41.11,0.24,1320,76112,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 03514',0.264211,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163218,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15916','RN',163218,41.38,0.37,1280,76113,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15916',0.466231,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163219,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15916','N',163219,41.2,0.31,1740,76113,70,NULL,'SALT 2','SDSS-II SN 15916',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163220,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15916','N',163220,41.31,0.31,1830,76113,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15916',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163221,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19052',NULL,163221,40.17,0.21,1080,76114,70,NULL,'SN photometric redshift distance, z photo =0.295 +/- 0.037','SDSS-II SN 19052',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,353.2440417,0.56267,0.113,NULL,51580974036,805952719,12593011,NULL),(163222,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19052','R',163222,40.99,0.31,1220,76114,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19052',0.294615,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163223,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19052','R',163223,41.29,0.28,1400,76114,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19052',0.294615,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163224,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19052',NULL,163224,40.82,0.22,1460,76114,70,NULL,'SALT 2','SDSS-II SN 19052',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163225,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19052',NULL,163225,40.85,0.22,1480,76114,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19052',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163226,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163226,31.4,0.8,19.1,76115,75,NULL,'MAT, I','NGC 7690',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000017,NULL,'13.0',0.9,'Sb             HII',NULL,NULL,NULL,NULL,1,353.260667,-51.69836,0,NULL,48652960498,760202507,11878164,13),(163227,'Tully est','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163227,31.07,0.8,16.4,76115,75,NULL,'B','NGC 7690',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163228,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163228,31.6,0.4,20.9,76115,NULL,NULL,'mean','NGC 7690',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163229,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163229,31.65,0.4,21.4,76115,NULL,NULL,NULL,'NGC 7690',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163230,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163230,31.65,0.4,21.4,76115,73,NULL,'opt','NGC 7690',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163231,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163231,31.67,0.32,21.6,76115,85,NULL,'I, raw','NGC 7690',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163232,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163232,31.69,0.32,21.8,76115,85,NULL,'I, inv','NGC 7690',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163233,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163233,31.88,0.47,23.7,76115,NULL,NULL,'H','NGC 7690',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163234,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163234,31.9,0.46,24,76115,NULL,NULL,'J','NGC 7690',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163235,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163235,31.93,0.43,24.3,76115,75,NULL,'MAT, I, raw','NGC 7690',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163236,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163236,31.94,0.45,24.4,76115,NULL,NULL,'K','NGC 7690',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163237,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163237,32.05,0.43,25.7,76115,75,NULL,'MAT, I, inv','NGC 7690',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163238,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163238,32.15,0.43,26.9,76115,75,NULL,'MAT, I, cor','NGC 7690',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163239,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163239,37.63,0.46,335,76116,70,NULL,NULL,'2MASX J23330646-0914328',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000187,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,353.2769583,-9.24261,0.118,NULL,49655501437,775867209,12122925,17.9),(163240,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163240,33.66,0.2,54,76117,74.4,NULL,NULL,'KUG 2330+159',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.000017,NULL,'15.3',0.4,'Spiral',NULL,NULL,NULL,NULL,1,353.283875,16.20597,0.077,NULL,51632858026,806763406,12605678,15.3),(163241,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163241,33.9,0.42,60.3,76117,NULL,NULL,NULL,'KUG 2330+159',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163242,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163242,34.02,0.4,63.7,76117,NULL,NULL,'Malmquist cor.','KUG 2330+159',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163243,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163243,34.13,NULL,67,76118,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 5329',NULL,'2010Ap&SS.325..163P',2010,1,2.02,'Position given in 1993AN....314...97K is incorrect.','G',0.000006,NULL,'15.42',0.24,'Sb','Pair member (points to parent)',NULL,NULL,NULL,1,353.2899583,21.23731,0.097,NULL,52540464264,820944754,12827261,15.42),(163244,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163244,34.14,NULL,67.2,76118,NULL,NULL,'Dipole + Quadrupole','IC 5329',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163245,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163245,34.14,NULL,67.2,76118,NULL,NULL,'Dipole','IC 5329',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163246,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163246,34.2,NULL,69.1,76118,NULL,NULL,NULL,'IC 5329',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163247,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163247,34.5,0.49,79.5,76118,75,NULL,'IR','IC 5329',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163248,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163248,34.51,0.2,79.8,76118,74.4,NULL,NULL,'IC 5329',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163249,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163249,34.61,0.51,83.6,76118,NULL,NULL,'Malmquist cor.','IC 5329',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163250,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163250,34.62,0.5,83.9,76118,NULL,NULL,NULL,'IC 5329',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163251,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','PS1 SN PS10bjz','N',163251,41.07,0.14,1250,76119,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10bjz HOST',0.3088,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163252,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163252,35.91,0.61,152,76120,70,NULL,NULL,'2MASX J23331168-5259437',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00015,NULL,'14.90',0.58,'S',NULL,NULL,NULL,NULL,1,353.2987083,-52.99553,0,NULL,48639091673,759985807,11874778,14.9),(163253,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163253,34.51,0.79,79.9,76121,NULL,NULL,NULL,'KUG 2330+253A',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000033,NULL,'15.55',0.3,'S?',NULL,NULL,NULL,NULL,1,353.3002917,25.65336,0.117,NULL,51998986992,812484171,12695065,15.55),(163254,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163254,34.55,0.2,81.3,76121,74.4,NULL,NULL,'KUG 2330+253A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163255,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163255,34.9,0.66,95.6,76121,NULL,NULL,'Malmquist cor.','KUG 2330+253A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163256,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163256,37.56,0.14,325,76122,70,NULL,NULL,'2MASX J23331231+0056561',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000101,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,353.301333,0.94894,0.105,NULL,51581462354,805960349,12593130,16.6),(163257,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 16940',NULL,163257,40.24,0.31,1120,76123,70,NULL,'SN photometric redshift distance, z photo =0.306 +/- 0.059','SDSS-II SN 16940',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,353.302166667,-0.41789,0.113,NULL,49421175646,772205869,12065716,NULL),(163258,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163258,30.71,0.43,13.8,76124,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7694',NULL,'2014MNRAS.444..527S',2014,1,1.6,NULL,'G',0.00001,NULL,'14.07',0.9,'Im pec:        HII',NULL,NULL,NULL,NULL,1,353.315708333,-2.70289,0.137,NULL,49422118682,772220604,12065946,14.07),(163259,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163259,30.77,0.43,14.3,76124,75,NULL,'3.6 micron, color corrected','NGC 7694',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163260,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163260,30.78,0.2,14.3,76124,74.4,NULL,NULL,'NGC 7694',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163261,'SBF','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163261,32.89,0.15,37.8,76125,NULL,NULL,'I','IC 5328',NULL,'2001ApJ...546..681T',2001,1,2.5,NULL,'G',0.000043,NULL,'12.34',1.5,'E','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,353.318583,-45.01597,NULL,NULL,50478835894,788731810,12323934,12.34),(163262,'SBF','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163262,32.89,0.15,37.8,76125,NULL,NULL,NULL,'IC 5328',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163263,'SBF','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163263,32.92,0.14,38.4,76125,74.4,NULL,NULL,'IC 5328',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163264,'SBF','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163264,32.93,0.15,38.6,76125,NULL,NULL,'Malmquist cor.','IC 5328',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163265,'D-Sigma','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163265,32.27,0.4,28.5,76125,75,NULL,'Edat, raw','IC 5328',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163266,'D-Sigma','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163266,32.61,0.4,33.2,76125,75,NULL,'Edat, cor','IC 5328',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163267,'Faber-Jackson','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163267,31.69,0.65,21.8,76125,95,NULL,'Weighted Mean','IC 5328',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163268,'Faber-Jackson','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163268,33.07,0.81,41.1,76125,55,NULL,'Visvanathan & Sandage 1979','IC 5328',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163269,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163269,32.51,0.41,31.8,76125,NULL,NULL,NULL,'IC 5328',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163270,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163270,32.69,0.41,34.5,76125,NULL,NULL,'Malmquist cor.','IC 5328',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163271,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163271,33,0.5,39.7,76125,70,NULL,NULL,'IC 5328',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163272,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163272,32.54,0.45,32.3,76125,NULL,NULL,'K','IC 5328',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163273,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163273,32.91,0.4,38.2,76125,NULL,NULL,'mean','IC 5328',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163274,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163274,32,0.8,25.1,76126,75,NULL,'MAT, I','NGC 7689',NULL,'1997ApJS..109..333W',1997,1,2.9,NULL,'G',0.000017,NULL,'12.2',1.9,'SA(r)c',NULL,NULL,NULL,NULL,1,353.319708333,-54.09447,0,NULL,48632885766,759888840,11873263,12.2),(163275,'Tully est','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163275,31.88,0.8,23.8,76126,75,NULL,'B','NGC 7689',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163276,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163276,31.76,0.43,22.5,76126,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7689',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163277,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163277,31.78,0.32,22.7,76126,85,NULL,'I, raw','NGC 7689',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163278,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163278,31.81,0.32,23,76126,85,NULL,'I, inv','NGC 7689',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163279,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163279,31.83,0.43,23.2,76126,75,NULL,'3.6 micron, color corrected','NGC 7689',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163280,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163280,31.89,0.43,23.9,76126,75,NULL,'MAT, I, raw','NGC 7689',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163281,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163281,31.94,0.2,24.4,76126,74.4,NULL,NULL,'NGC 7689',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163282,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163282,32.05,0.43,25.7,76126,75,NULL,'MAT, I, inv','NGC 7689',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163283,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163283,32.1,0.4,26.3,76126,NULL,NULL,NULL,'NGC 7689',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163284,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163284,32.1,0.4,26.3,76126,73,NULL,'opt','NGC 7689',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163285,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163285,32.12,0.43,26.5,76126,75,NULL,'MAT, I, cor','NGC 7689',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163286,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 13447','RN',163286,41.87,0.18,1560,76127,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13447',0.512963,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163287,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163287,36.42,0.46,193,76128,70,NULL,NULL,'MCG +00-60-004',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.0001,NULL,'15.3g',0.55,'E0',NULL,NULL,NULL,NULL,1,353.327917,-0.45014,0.113,NULL,49421121773,772205027,12065703,15.3),(163288,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','PS1 SN PS10axm','N',163288,42.04,0.2,1690,76129,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10axm HOST',0.5088,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163289,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163289,37.74,0.33,354,76130,70,NULL,NULL,'2MASX J23332327-0106431',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000082,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,353.3469583,-1.11192,0.113,NULL,49420520957,772195639,12065556,17.2),(163290,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163290,37.34,0.46,294,76131,70,NULL,NULL,'2MASX J23332337+1445213',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000201,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,353.3475,14.75606,0.121,NULL,51634794420,806793662,12606150,16.7),(163291,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163291,34.36,0.44,74.6,76132,NULL,NULL,'Malmquist cor.','IC 5331',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000017,NULL,'15.00',0.3,'Sab','Pair member (points to parent)',NULL,NULL,NULL,1,353.353417,21.13006,0.097,NULL,52540384845,820943513,12827242,15),(163292,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163292,34.43,0.43,77,76132,NULL,NULL,NULL,'IC 5331',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163293,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163293,34.46,0.4,77.9,76132,NULL,NULL,'mean','IC 5331',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163294,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163294,34.56,0.2,81.7,76132,74.4,NULL,NULL,'IC 5331',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163295,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163295,34.72,0.47,87.8,76132,NULL,NULL,'H','IC 5331',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163296,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163296,34.76,0.45,89.5,76132,NULL,NULL,'K','IC 5331',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163297,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163297,34.83,0.46,92.5,76132,NULL,NULL,'J','IC 5331',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163298,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163298,32.69,0.2,34.5,76133,74.4,NULL,NULL,'KUG 2330+253B',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000033,NULL,'15.13',0.4,'S?',NULL,NULL,NULL,NULL,1,353.35875,25.65047,0.117,NULL,51999006169,812484471,12695069,15.13),(163299,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163299,32.98,0.47,39.5,76133,NULL,NULL,NULL,'KUG 2330+253B',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163300,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163300,33.3,0.4,45.7,76133,NULL,NULL,'Malmquist cor.','KUG 2330+253B',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163301,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163301,37.74,0.33,354,76134,70,NULL,NULL,'2MASX J23332894-0104361',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,353.370625,-1.07678,0.105,NULL,49421388104,772209189,12065768,17.2),(163302,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 14414','RN',163302,41.12,0.22,1400,76135,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14414',0.192539,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163303,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 14414','RN',163303,41.74,0.39,1870,76135,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 14414',0.192539,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163304,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163304,37.05,0.46,257,76136,70,NULL,NULL,'2MASX J23332963+1438463',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000152,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,353.373625,14.64617,0.121,NULL,51634998711,806796854,12606200,17.2),(163305,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163305,34.42,0.49,76.5,76137,NULL,NULL,'Malmquist cor.','UGC 12664',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000375,NULL,'15.28',0.6,'Scd:',NULL,NULL,NULL,NULL,1,353.3885417,15.55247,0.105,NULL,51635417467,806803397,12606303,15.28),(163306,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163306,34.5,0.2,79.4,76137,74.4,NULL,NULL,'UGC 12664',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163307,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163307,34.53,0.46,80.7,76137,NULL,NULL,NULL,'UGC 12664',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163308,'GRB','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163308,44.83,1.46,2980,76138,NULL,NULL,NULL,'GRB 090926A',2.1062,'2010JCAP...08..020W',2010,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,353.400583,-66.32383,0.029,NULL,48734865447,761482272,11898160,NULL),(163309,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163309,34.22,0.8,69.8,76139,75,NULL,'W91PP, r','UGC 12665',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'15.1',0.9,'SB(rs)d pec','Pair member (points to parent)',NULL,NULL,NULL,1,353.411083,30.03897,0.237,NULL,52035260109,813050939,12703920,15.1),(163310,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163310,33.78,0.38,56.9,76139,75,NULL,'W91PP, r, inv','UGC 12665',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163311,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163311,33.78,0.38,57,76139,75,NULL,'W91PP, r, raw','UGC 12665',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163312,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163312,34.06,0.38,64.9,76139,75,NULL,'W91PP, r, cor','UGC 12665',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163313,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 14844','R',163313,41.98,0.52,1690,76140,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14844',0.474885,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,353.41525,0.17667,0.125,NULL,51578132498,805908320,12592317,NULL),(163314,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 18202','RN',163314,40.72,0.29,1230,76141,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18202',0.132487,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163315,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 18202','RN',163315,41.18,0.3,1520,76141,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18202',0.132487,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163316,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163316,34.04,0.8,64.3,76142,75,NULL,'W91PP, r','UGC 12666',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.36',0.6,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,353.4210417,32.38419,0.237,NULL,52031517413,812992459,12703007,14.36),(163317,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163317,34.05,0.8,64.6,76142,75,NULL,'CF, r','UGC 12666',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163318,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163318,33.72,0.38,55.4,76142,75,NULL,'W91PP, r, raw','UGC 12666',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163319,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163319,33.77,0.38,56.8,76142,75,NULL,'CF, r, raw','UGC 12666',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163320,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163320,33.79,0.38,57.3,76142,75,NULL,'W91PP, r, inv','UGC 12666',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163321,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163321,33.86,0.38,59.1,76142,75,NULL,'CF, r, inv','UGC 12666',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163322,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163322,34.03,0.38,63.9,76142,75,NULL,'W91PP, r, cor','UGC 12666',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163323,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163323,34.07,0.38,65,76142,75,NULL,'CF, r, cor','UGC 12666',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163324,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163324,35.02,0.46,101,76143,70,NULL,NULL,'2MASX J23334196+1404302',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00009,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,353.4247083,14.07494,0.133,NULL,51636163587,806815056,12606485,16.6),(163325,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163325,36.76,0.87,225,76144,70,NULL,NULL,'2MASX J23334338-0034102',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.000082,NULL,'16.0g',0.46,'Sa',NULL,NULL,NULL,NULL,1,353.4307917,-0.56958,0.105,NULL,49421153940,772205530,12065711,16),(163326,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 16071','RN',163326,36.54,0.26,186,76145,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16071',0.092741,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163327,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163327,33.55,0.73,51.4,76146,NULL,NULL,NULL,'MCG -01-60-005',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.00003,NULL,'15.9R',0.8,'SB(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,353.43525,-3.08042,0.113,NULL,49414665204,772104143,12064127,15.9),(163328,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163328,33.59,0.2,52.2,76146,74.4,NULL,NULL,'MCG -01-60-005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163329,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163329,33.95,0.61,61.8,76146,NULL,NULL,'Malmquist cor.','MCG -01-60-005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163330,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 04402','RN',163330,42.94,0.23,2720,76147,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04402',0.42613,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163331,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 04402','RN',163331,43.13,0.21,2970,76147,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 04402',0.42613,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163332,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163332,36.92,0.56,242,76148,70,NULL,NULL,'2MASX J23334900-5325496',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'16.78',0.36,NULL,NULL,NULL,NULL,NULL,1,353.454167,-53.43036,0,NULL,48631288987,759863890,11872873,16.78),(163333,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163333,33.33,0.8,46.4,76149,75,NULL,'W91PP, r','UGC 12667',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'13.54',0.8,'Scd:           HII','Pair member (points to parent)',NULL,NULL,NULL,1,353.455333,30.06039,0.237,NULL,52035227012,813050422,12703912,13.54),(163334,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163334,33.35,0.8,46.7,76149,75,NULL,'CF, r','UGC 12667',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163335,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163335,32.8,0.69,36.2,76149,100,NULL,'mid-IR','UGC 12667',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163336,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163336,32.82,0.43,36.7,76149,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12667',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163337,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163337,32.9,0.46,38,76149,NULL,NULL,NULL,'UGC 12667',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163338,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163338,32.92,0.43,38.4,76149,75,NULL,'3.6 micron, color corrected','UGC 12667',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163339,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163339,32.95,0.2,38.9,76149,74.4,NULL,NULL,'UGC 12667',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163340,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163340,33,0.38,39.7,76149,75,NULL,'CF, r, raw','UGC 12667',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163341,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163341,33.06,0.38,40.9,76149,75,NULL,'CF, r, inv','UGC 12667',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163342,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163342,33.1,0.42,41.6,76149,NULL,NULL,'Malmquist cor.','UGC 12667',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163343,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163343,33.19,0.38,43.5,76149,75,NULL,'W91PP, r, raw','UGC 12667',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163344,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163344,33.26,0.38,44.9,76149,75,NULL,'W91PP, r, inv','UGC 12667',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163345,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163345,33.37,0.38,47.1,76149,75,NULL,'CF, r, cor','UGC 12667',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163346,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163346,33.5,0.4,50.1,76149,NULL,NULL,'mean','UGC 12667',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163347,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163347,33.5,0.47,50.1,76149,NULL,NULL,'H','UGC 12667',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163348,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163348,33.56,0.46,51.5,76149,NULL,NULL,'J','UGC 12667',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163349,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163349,33.56,0.38,51.5,76149,75,NULL,'W91PP, r, cor','UGC 12667',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163350,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163350,33.58,0.45,51.9,76149,NULL,NULL,'K','UGC 12667',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163351,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163351,33.29,0.43,45.6,76150,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 533-012',NULL,'2014MNRAS.444..527S',2014,1,0.6,NULL,'G',0.00006,NULL,'15.7',0.6,NULL,NULL,NULL,NULL,NULL,1,353.4615,45.17453,0.661,NULL,55310968427,864233881,13503654,15.7),(163352,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163352,33.52,0.43,50.5,76150,75,NULL,'3.6 micron, color corrected','CGCG 533-012',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163353,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163353,33.69,0.2,54.7,76150,74.4,NULL,NULL,'CGCG 533-012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163354,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163354,37.65,0.46,339,76151,70,NULL,NULL,'2MASX J23335171-0106192',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000078,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,353.465417,-1.10525,0.105,NULL,49421396291,772209317,12065770,17.8),(163355,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163355,34.74,0.58,88.9,76152,70,NULL,NULL,'CGCG 381-008',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00014,NULL,'15.5',0.15,NULL,NULL,NULL,NULL,NULL,1,353.468833333,-1.33306,0.113,NULL,49420555353,772196177,12065565,15.5),(163356,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163356,33.01,0.8,40,76153,75,NULL,'MAT, I','IC 5328B',NULL,'1997ApJS..109..333W',1997,1,1.41,NULL,'G',0.000033,NULL,'14.99',0.41,'SB(s)c:',NULL,NULL,NULL,NULL,1,353.494833,-45.20967,NULL,NULL,50482279567,788785618,12324775,14.99),(163357,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163357,32.67,0.32,34.2,76153,85,NULL,'I, inv','IC 5328B',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163358,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163358,32.7,0.32,34.7,76153,85,NULL,'I, raw','IC 5328B',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163359,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163359,32.99,0.43,39.6,76153,75,NULL,'MAT, I, inv','IC 5328B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163360,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163360,33.04,0.43,40.5,76153,75,NULL,'MAT, I, raw','IC 5328B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163361,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163361,33.17,0.43,43.1,76153,75,NULL,'MAT, I, cor','IC 5328B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163362,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163362,36.87,0.46,237,76154,70,NULL,NULL,'2MASX J23335986-0836364',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,353.499583,-8.61022,0.073,NULL,49653614984,775837734,12122464,17.1),(163363,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163363,37.56,0.14,325,76155,70,NULL,NULL,'2MASX J23340229+0058120',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,353.509583,0.97008,0.105,NULL,51581528641,805961385,12593146,18.1),(163364,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 01650','R',163364,40.45,0.33,945,76156,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01650',0.304341,'2014arXiv1401.3317S',2014,1,0.1,NULL,'G',NULL,'PHOT','20.4g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,353.5105,0.68375,0.093,NULL,51580834112,805950533,12592977,20.4),(163365,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 01650','R',163365,40.63,0.31,1020,76156,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01650',0.304341,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163366,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 01650',NULL,163366,40.06,0.45,1030,76156,70,NULL,'SN photometric redshift distance, z photo =0.277 +/- 0.078','SDSS-II SN 01650',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163367,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 01650',NULL,163367,40.29,0.22,1140,76156,70,NULL,'SALT 2','SDSS-II SN 01650',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163368,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 01650',NULL,163368,40.32,0.22,1160,76156,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 01650',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163369,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163369,37.56,0.14,325,76157,70,NULL,NULL,'2MASX J23340409+0058391',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000083,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,353.517,0.97753,0.105,NULL,51581530538,805961414,12593147,17.2),(163370,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163370,37.56,0.14,325,76158,70,NULL,NULL,'2MASX J23341349+0101481',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000105,NULL,'16.0g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,353.5562917,1.03014,0.121,NULL,51581533147,805961455,12593147,16),(163371,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163371,37.29,0.46,287,76159,70,NULL,NULL,'2MASX J23341380-1030164',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000145,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,353.557667,-10.50469,0.026,NULL,49653066370,775829162,12122330,17),(163372,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07339','RN',163372,42.3,0.33,2210,76160,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 07339',0.307303,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163373,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07339','RN',163373,42.93,0.34,2950,76160,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 07339',0.307303,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163374,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163374,37.49,0.27,314,76161,70,NULL,NULL,'2MASX J23341910+1502363',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00015,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,353.5795417,15.04339,0.105,NULL,51634335753,806786496,12606039,17.2),(163375,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163375,37.39,0.46,300,76162,70,NULL,NULL,'2MASX J23342044-0933240',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000155,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,353.585125,-9.55681,0.078,NULL,49655927948,775873874,12123029,17.4),(163376,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163376,37.56,0.14,325,76163,70,NULL,NULL,'2MASX J23342243+0101221',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000084,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,353.5935417,1.02286,0.121,NULL,51581520991,805961265,12593144,17.5),(163377,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163377,34.79,0.4,90.9,76164,NULL,NULL,'mean','UGC 12672',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000033,NULL,'14.46',0.8,'S?             HII',NULL,NULL,NULL,NULL,1,353.596375,34.62489,0.341,NULL,52030933063,812983329,12702864,14.46),(163378,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163378,34.86,0.47,93.8,76164,NULL,NULL,'H','UGC 12672',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163379,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 14365','RN',163379,42.59,0.22,2250,76165,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 14365',0.464236,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163380,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 21502','R',163380,38,0.19,365,76166,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ra','2MASX J23342408-0053250',0.089063,'2014arXiv1401.3317S',2014,1,NULL,NULL,'QSO',0.000159,NULL,'17.5g',NULL,'BLAGN',NULL,NULL,NULL,NULL,1,353.600417,-0.89022,0.093,NULL,49421260671,772207197,12065737,17.5),(163381,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2007ra',NULL,163381,37.86,0.09,373,76166,70,NULL,'SALT 2','2MASX J23342408-0053250',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163382,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2007ra',NULL,163382,37.86,0.09,373,76166,70,NULL,'SALT 2, Malmquist cor.','2MASX J23342408-0053250',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163383,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 21502','R',163383,38.2,0.1,402,76166,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ra','2MASX J23342408-0053250',0.089063,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163384,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163384,36.83,0.33,233,76167,70,NULL,NULL,'2MASX J23342563+0014041',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,353.6067917,0.23456,0.125,NULL,51577978845,805905919,12592279,16.4),(163385,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 16892','RN',163385,41.69,0.45,2060,76168,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 16892',0.05785,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163386,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 16892','RN',163386,42.35,0.24,2790,76168,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 16892',0.05785,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163387,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163387,37.49,0.27,314,76169,70,NULL,NULL,'2MASX J23342614+1503493',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,353.609,15.06375,0.105,NULL,51634329571,806786399,12606037,17.2),(163388,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163388,37.49,0.27,314,76170,70,NULL,NULL,'2MASX J23342621+1502353',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,353.6092917,15.04303,0.105,NULL,51634336352,806786505,12606039,18.3),(163389,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163389,29.62,0.4,8.4,76171,75,NULL,'B','IC 5332',NULL,'1988NBGC.C....0000T',1988,1,7.8,'Extended HIPASS source','G',0.000003,NULL,'11.0B',6.2,'SA(s)d','Possible group member',NULL,NULL,NULL,1,353.614541667,-36.10108,NULL,NULL,49982810138,780981408,12202834,11),(163390,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163390,37.59,0.46,330,76172,70,NULL,NULL,'2MASX J23342809-0842040',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,353.617125,-8.70108,0.084,NULL,49654149005,775846078,12122594,17.6),(163391,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163391,37.03,0.46,255,76173,70,NULL,NULL,'2MASX J23342857+0034185',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000105,NULL,'16.3g',0.35,'AGN',NULL,NULL,NULL,NULL,1,353.6190417,0.57197,0.093,NULL,51578024205,805906628,12592291,16.3),(163392,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163392,37.05,0.46,258,76174,70,NULL,NULL,'SDSS J233429.80+002251.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000057,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,353.6242083,0.38108,0.093,NULL,51578047588,805906993,12592296,18.3),(163393,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 00717','RN',163393,38.62,0.29,469,76175,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 00717',0.130392,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163394,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 00717','RN',163394,38.87,0.29,525,76175,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 00717',0.130392,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163395,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163395,33.93,0.48,61.2,76176,70,NULL,NULL,'NGC 7701',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00008,NULL,'14.36',0.5,'S0o pec:',NULL,NULL,NULL,NULL,1,353.63125,-2.85428,0.097,NULL,49414537896,772102154,12064096,14.36),(163396,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163396,36.8,0.46,230,76177,70,NULL,NULL,'2MASX J23343342-1009560',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000145,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,353.6392917,-10.1655,0.055,NULL,49652555776,775821184,12122206,17),(163397,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163397,38.05,0.33,408,76178,70,NULL,NULL,'SDSS J233435.35-004019.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,353.6472917,-0.67222,0.081,NULL,49417618199,772150284,12064848,18.4),(163398,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163398,33.61,0.12,52.8,76179,NULL,NULL,NULL,'UGC 12673',NULL,'2009ApJS..182..474S',2009,1,1.04,NULL,'G',0.000266,NULL,'16.5g',0.2,'Sdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,353.6480417,15.15742,0.105,NULL,51634348407,806786693,12606042,16.5),(163399,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163399,33.91,0.2,60.5,76179,74.4,NULL,NULL,'UGC 12673',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163400,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163400,34.1,NULL,66.1,76179,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12673',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163401,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163401,34.12,NULL,66.7,76179,NULL,NULL,'Dipole + Quadrupole','UGC 12673',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163402,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163402,34.13,NULL,67.1,76179,NULL,NULL,'Dipole','UGC 12673',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163403,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 02548','RN',163403,41.96,0.14,1810,76180,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02548',0.359853,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163404,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 02548','RN',163404,42.19,0.22,2020,76180,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02548',0.359853,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163405,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163405,37.26,0.46,283,76181,70,NULL,NULL,'2MASX J23343624+0038255',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000093,NULL,'16.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,353.650917,0.64036,0.101,NULL,51578014041,805906469,12592288,16.5),(163406,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163406,32.45,0.4,30.9,76182,NULL,NULL,'mean','IC 5334',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000013,NULL,'14.26',0.6,'(R\')Sa?',NULL,NULL,NULL,NULL,1,353.65175,-4.53425,0.105,NULL,49413900919,772092201,12063940,14.26),(163407,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163407,32.95,0.46,38.9,76182,NULL,NULL,'J','IC 5334',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163408,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163408,32.95,0.47,38.9,76182,NULL,NULL,'H','IC 5334',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163409,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163409,33.01,0.45,40,76182,NULL,NULL,'K','IC 5334',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163410,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163410,33.09,0.2,41.5,76182,74.4,NULL,NULL,'IC 5334',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163411,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163411,33.2,0.44,43.7,76182,NULL,NULL,NULL,'IC 5334',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163412,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163412,33.22,0.43,44.1,76182,75,NULL,'3.6 micron, color corrected','IC 5334',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163413,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163413,33.27,0.42,45.2,76182,NULL,NULL,'Malmquist cor.','IC 5334',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163414,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163414,33.4,0.43,48,76182,75,NULL,'3.6 micron, color + selection bias corrected','IC 5334',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163415,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163415,32.85,0.8,37.1,76183,75,NULL,'W91PP, r','UGC 12675',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',NULL,NULL,'15.71',0.2,'S?',NULL,NULL,NULL,NULL,1,353.659583,23.22442,0.129,NULL,52483363923,820052561,12813321,15.71),(163416,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163416,31.89,0.2,23.9,76183,74.4,NULL,NULL,'UGC 12675',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163417,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163417,32.16,0.65,27.1,76183,NULL,NULL,'Malmquist cor.','UGC 12675',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163418,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163418,32.26,0.62,28.3,76183,NULL,NULL,NULL,'UGC 12675',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163419,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163419,32.28,0.49,28.6,76183,75,NULL,'IR','UGC 12675',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163420,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163420,32.72,0.38,34.9,76183,75,NULL,'W91PP, r, inv','UGC 12675',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163421,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163421,32.87,0.38,37.4,76183,75,NULL,'W91PP, r, raw','UGC 12675',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163422,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163422,33.21,0.38,43.9,76183,75,NULL,'W91PP, r, cor','UGC 12675',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163423,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163423,34,0.2,63.1,76184,74.4,NULL,NULL,'IC 1501',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.0001,NULL,'14.5',0.7,'SAB(s)bc pec:  HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,353.666916667,-3.15283,0.113,NULL,49415081940,772110655,12064228,14.5),(163424,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163424,34.11,0.37,66.4,76184,NULL,NULL,NULL,'IC 1501',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163425,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163425,34.34,0.34,73.9,76184,NULL,NULL,'Malmquist cor.','IC 1501',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163426,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163426,37.56,0.14,325,76185,70,NULL,NULL,'2MASX J23344109+0112335',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.9g',0.24,'AGN',NULL,NULL,NULL,NULL,1,353.671166667,1.20928,0.137,NULL,51581116784,805954949,12593046,16.9),(163427,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163427,35.68,0.65,137,76186,70,NULL,NULL,'FAIRALL 0150',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.87',0.45,'S0',NULL,NULL,NULL,NULL,1,353.672833333,-59.05961,0,NULL,48744980895,761640326,11900630,15.87),(163428,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163428,36.83,0.46,232,76187,70,NULL,NULL,'2MASX J23344154+1450473',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000202,NULL,'15.7g',0.48,'E0',NULL,NULL,NULL,NULL,1,353.67325,14.84658,0.137,NULL,51634988165,806796690,12606198,15.7),(163429,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163429,36.83,0.33,233,76188,70,NULL,NULL,'2MASX J23344198+0010575',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.39',0.38,'AGN',NULL,NULL,NULL,NULL,1,353.674875,0.18253,0.125,NULL,51578245176,805910080,12592345,16.39),(163430,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163430,33.73,0.45,55.6,76189,NULL,NULL,'K','NGC 7703',NULL,'2007A&A...465...71T',2007,1,2.2,NULL,'G',0.000073,NULL,'14.41',0.5,'S0',NULL,NULL,NULL,NULL,1,353.6952917,16.07578,0.085,NULL,51632768597,806762009,12605656,14.41),(163431,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163431,33.74,0.4,56,76189,NULL,NULL,'mean','NGC 7703',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163432,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163432,35.31,0.51,115,76190,70,NULL,NULL,'2MASX J23344772-1557010',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.12',0.24,NULL,NULL,NULL,NULL,NULL,1,353.699,-15.95019,0,NULL,49564565487,774446335,12100723,16.12),(163433,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 17899','R',163433,40.67,0.24,1060,76191,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17899',0.288815,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,353.6995,-0.15169,0.105,NULL,49418215190,772159612,12064993,NULL),(163434,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 17899','R',163434,40.75,0.18,1100,76191,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17899',0.288815,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163435,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 17899',NULL,163435,40.28,0.23,1140,76191,70,NULL,'SN photometric redshift distance, z photo =0.313 +/- 0.044','SDSS-II SN 17899',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163436,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 17899',NULL,163436,40.58,0.14,1310,76191,70,NULL,'SALT 2','SDSS-II SN 17899',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163437,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 17899',NULL,163437,40.61,0.14,1320,76191,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 17899',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163438,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163438,35.36,0.8,118,76192,75,NULL,'W91PP, r','UGC 12678',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000007,NULL,'15.44',0.2,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,353.702791667,26.31078,0.125,NULL,52007489875,812617029,12697141,15.44),(163439,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163439,35.36,0.8,118,76192,75,NULL,'HMCL, I','UGC 12678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163440,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163440,35.36,0.8,118,76192,75,NULL,'W91CL, r','UGC 12678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163441,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163441,35.36,0.8,118,76192,75,NULL,'CF, r','UGC 12678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163442,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163442,35.42,0.38,121,76192,75,NULL,'W91PP, r, raw','UGC 12678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163443,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163443,35.52,0.4,127,76192,75,NULL,'HMCL, I, raw','UGC 12678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163444,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163444,35.53,0.49,127,76192,75,NULL,'IR','UGC 12678',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163445,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163445,35.6,0.38,132,76192,75,NULL,'W91PP, r, cor','UGC 12678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163446,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163446,35.61,0.38,132,76192,75,NULL,'CF, r, raw','UGC 12678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163447,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163447,35.63,0.38,134,76192,75,NULL,'W91CL, r, raw','UGC 12678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163448,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163448,35.65,0.38,135,76192,75,NULL,'W91PP, r, inv','UGC 12678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163449,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163449,35.72,0.4,139,76192,75,NULL,'HMCL, I, cor','UGC 12678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163450,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163450,35.72,0.12,140,76192,NULL,NULL,NULL,'UGC 12678',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163451,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163451,35.77,0.4,143,76192,75,NULL,'HMCL, I, inv','UGC 12678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163452,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163452,35.78,0.38,144,76192,75,NULL,'CF, r, cor','UGC 12678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163453,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163453,35.82,0.38,146,76192,75,NULL,'CF, r, inv','UGC 12678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163454,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163454,35.83,0.2,147,76192,74.4,NULL,NULL,'UGC 12678',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163455,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163455,35.84,0.38,147,76192,75,NULL,'W91CL, r, inv','UGC 12678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163456,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163456,35.86,0.38,148,76192,75,NULL,'W91CL, r, cor','UGC 12678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163457,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163457,35.96,0.43,156,76192,75,NULL,'3.6 micron, color corrected','UGC 12678',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163458,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163458,36.26,0.43,178,76192,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12678',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163459,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163459,37.08,0.46,261,76193,70,NULL,NULL,'2MASX J23345063-0945216',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000177,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,353.711125,-9.75583,0.06,NULL,49656102506,775876601,12123071,17.3),(163460,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 20551','RN',163460,43.24,0.28,3030,76194,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20551',0.46707,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163461,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163461,32.04,0.8,25.6,76195,75,NULL,'MAT, I','NGC 7697',NULL,'1997ApJS..109..333W',1997,1,1.6,'The APMUKS position is east of the nucleus.','G',0.000022,NULL,'14.29',0.3,'Sb pec sp',NULL,NULL,NULL,NULL,1,353.72075,-65.39603,0,NULL,48737529649,761523900,11898810,14.29),(163462,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163462,31.61,0.4,21,76195,73,NULL,'IR','NGC 7697',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163463,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163463,31.61,0.4,21,76195,75,NULL,NULL,'NGC 7697',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163464,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163464,31.94,0.4,24.4,76195,73,NULL,'opt','NGC 7697',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163465,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163465,32.05,0.32,25.7,76195,85,NULL,'I, inv','NGC 7697',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163466,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163466,32.06,0.32,25.8,76195,85,NULL,'I, raw','NGC 7697',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163467,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163467,32.27,0.4,28.4,76195,NULL,NULL,NULL,'NGC 7697',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163468,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163468,32.39,0.43,30.1,76195,75,NULL,'MAT, I, raw','NGC 7697',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163469,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163469,32.44,0.43,30.7,76195,75,NULL,'MAT, I, inv','NGC 7697',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163470,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163470,32.53,0.4,32,76195,NULL,NULL,'mean','NGC 7697',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163471,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163471,32.6,0.49,33.1,76195,75,NULL,'IR','NGC 7697',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163472,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163472,32.69,0.43,34.4,76195,75,NULL,'MAT, I, cor','NGC 7697',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163473,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163473,32.76,0.47,35.7,76195,NULL,NULL,'H','NGC 7697',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163474,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163474,32.83,0.45,36.7,76195,NULL,NULL,'K','NGC 7697',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163475,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163475,32.87,0.46,37.4,76195,NULL,NULL,'J','NGC 7697',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163476,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163476,31.5,0.4,20,76196,75,NULL,'B','UGC 12682',NULL,'1988NBGC.C....0000T',1988,1,1.3,'The 2MASS position is for a bright knot 19 arcsec southwest of the nucleus.','G',0.000007,NULL,'14.04',1,'Im',NULL,NULL,NULL,NULL,1,353.722917,18.22722,0.113,NULL,52534140853,820845950,12825717,14.04),(163477,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163477,34.22,0.49,69.9,76197,75,NULL,'IR','UGC 12680',NULL,'2011yCatp016004901K',2011,1,1.37,NULL,'G',0.000008,NULL,'15.62',0.17,'SBbc?',NULL,NULL,NULL,NULL,1,353.7235,17.29722,0.117,NULL,52533904094,820842251,12825660,15.62),(163478,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163478,35.3,NULL,115,76197,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12680',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163479,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163479,35.32,NULL,116,76197,NULL,NULL,'Dipole + Quadrupole','UGC 12680',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163480,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163480,35.32,NULL,116,76197,NULL,NULL,NULL,'UGC 12680',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163481,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163481,35.32,NULL,116,76197,NULL,NULL,'Dipole','UGC 12680',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163482,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163482,35.64,0.46,134,76197,NULL,NULL,'Malmquist cor.','UGC 12680',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163483,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163483,35.66,0.2,136,76197,74.4,NULL,NULL,'UGC 12680',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163484,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163484,35.72,0.44,139,76197,NULL,NULL,NULL,'UGC 12680',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163485,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163485,32.02,0.4,25.4,76198,73,NULL,'opt','UGC 12681',NULL,'2011A&A...532A.104N',2011,1,1.1,NULL,'G',0.000017,NULL,'14.85',0.7,'SB?',NULL,NULL,NULL,NULL,1,353.7277083,18.07183,0.113,NULL,52534072210,820844878,12825701,14.85),(163486,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163486,32.1,0.43,26.2,76198,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12681',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163487,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163487,32.15,0.43,27,76198,75,NULL,'3.6 micron, color corrected','UGC 12681',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163488,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163488,32.18,0.2,27.3,76198,74.4,NULL,NULL,'UGC 12681',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163489,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163489,32.48,0.77,31.3,76198,NULL,NULL,NULL,'UGC 12681',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163490,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163490,32.72,0.69,35,76198,NULL,NULL,'Malmquist cor.','UGC 12681',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163491,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163491,38.05,0.33,408,76199,70,NULL,NULL,'2MASX J23345720-0039005',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000084,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,353.738333,-0.65006,0.089,NULL,49418091881,772157685,12064963,17.8),(163492,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163492,36.59,0.46,208,76200,70,NULL,NULL,'2MASX J23345840-0012055',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000104,NULL,'16.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,353.743375,-0.20167,0.105,NULL,49418267326,772160426,12065006,16.4),(163493,'TRGB','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163493,29.4,0.1,7.58,76201,74.4,NULL,NULL,'APMUKS(BJ) B233224.66-372950.1',NULL,'2013AJ....146...86T',2013,1,0.57,NULL,'G',0.000007,NULL,'16.64',0.33,NULL,NULL,NULL,NULL,NULL,1,353.76775,-37.22061,NULL,NULL,49980657919,780947779,12202309,16.64),(163494,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 14322',NULL,163494,40.42,0.15,1220,76202,70,NULL,'SN photometric redshift distance, z photo =0.339 +/- 0.030','SDSS-II SN 14322',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,353.772917,-0.16947,0.105,NULL,49418217561,772159649,12064994,NULL),(163495,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163495,37.87,0.46,375,76203,70,NULL,NULL,'SDSS J233507.83+155527.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000148,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,353.782625,15.92428,0.085,NULL,51632658959,806760296,12605629,18.6),(163496,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 13800','RN',163496,40.94,0.32,1270,76204,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13800',0.21667,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163497,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 05673','R',163497,41.46,0.2,1420,76205,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 05673',0.379939,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,353.801333,0.78433,0.109,NULL,51577696740,805901511,12592211,NULL),(163498,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 05673','R',163498,41.74,0.29,1620,76205,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 05673',0.379939,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163499,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163499,38.18,0.46,432,76206,70,NULL,NULL,'2MASX J23351385+1542081',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,353.807583,15.70219,0.097,NULL,51632444749,806756949,12605577,18.4),(163500,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 20893','RN',163500,39.32,0.54,674,76207,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 20893',0.084621,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163501,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163501,37.56,0.14,325,76208,70,NULL,NULL,'2MASX J23351409+0056361',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000082,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,353.808667,0.9435,0.137,NULL,51581220453,805956569,12593071,18.1),(163502,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163502,34.42,0.6,76.6,76209,NULL,NULL,'Malmquist cor.','UGC 12687',NULL,'2009ApJS..182..474S',2009,1,1.7,NULL,'G',0.00002,NULL,'14.31',1.3,'SBbc',NULL,NULL,NULL,NULL,1,353.823041667,12.92342,0.149,NULL,51629488172,806710752,12604855,14.31),(163503,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163503,34.61,0.55,83.5,76209,NULL,NULL,NULL,'UGC 12687',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163504,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163504,34.65,0.2,85.1,76209,74.4,NULL,NULL,'UGC 12687',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163505,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163505,37.56,0.14,325,76210,70,NULL,NULL,'MCG +00-60-013',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.00016,NULL,'15.1g',0.61,'BrClG',NULL,NULL,NULL,NULL,1,353.8569583,1.05906,0.137,NULL,51581177985,805955906,12593061,15.1),(163506,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163506,37.12,0.46,265,76211,70,NULL,NULL,'2MASX J23352613-1005304',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000146,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,353.8587917,-10.09169,0.047,NULL,49652677585,775823087,12122235,17),(163507,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163507,34.51,0.2,79.8,76212,74.4,NULL,NULL,'UGC 12688',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.00002,NULL,'14.27',0.4,'Sm','Isolated galaxy',NULL,NULL,NULL,1,353.85925,7.32222,0.205,NULL,51793015049,809265860,12644779,14.27),(163508,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15533','RN',163508,41.39,0.29,1410,76213,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15533',0.344401,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163509,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15533','RN',163509,41.44,0.23,1440,76213,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15533',0.344401,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163510,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15533','N',163510,41.3,0.18,1820,76213,70,NULL,'SALT 2','SDSS-II SN 15533',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163511,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15533','N',163511,41.34,0.18,1850,76213,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15533',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163512,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163512,37.56,0.14,325,76214,70,NULL,NULL,'2MASX J23352803+0102485',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000114,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,353.866875,1.04672,0.137,NULL,51581178527,805955914,12593061,17.5),(163513,'Ring Diameter','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163513,32.1,0.84,26,76215,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7702',NULL,'1981ApJS...45..541P',1981,1,2.2,NULL,'G',0.00008,NULL,'13.08',1.2,'(R)SA(r)0^+',NULL,NULL,NULL,NULL,1,353.870333,-56.01228,0,NULL,48819807784,762809496,11918898,13.08),(163514,'Faber-Jackson','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163514,32.42,0.44,30.5,76215,95,NULL,'Weighted Mean','NGC 7702',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163515,'Faber-Jackson','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163515,32.71,0.63,34.8,76215,95,NULL,'Michard 1979b, c','NGC 7702',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163516,'Faber-Jackson','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163516,32.86,0.46,37.3,76215,95,NULL,'Michard 1979a','NGC 7702',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163517,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163517,33.2,0.49,43.6,76215,70,NULL,NULL,'NGC 7702',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163518,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163518,30.85,0.4,14.8,76216,73,NULL,'opt','UGCA 440',NULL,'2011A&A...532A.104N',2011,1,0.7,NULL,'G',0.000017,NULL,'15.34',0.7,'Im',NULL,NULL,NULL,NULL,1,353.881667,18.30972,0.101,NULL,52488063395,820125990,12814468,15.34),(163519,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163519,30.93,1.47,15.3,76216,NULL,NULL,NULL,'UGCA 440',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163520,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163520,31.29,1.24,18.1,76216,NULL,NULL,'Malmquist cor.','UGCA 440',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163521,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163521,34.35,0.49,74.1,76217,75,NULL,'IR','UGC 12689',NULL,'2011yCatp016004901K',2011,1,1.6,NULL,'G',0.000087,NULL,'14.42',0.3,'Sab','Group member',NULL,NULL,NULL,1,353.884541667,5.21464,0.217,NULL,51762055182,808782112,12637220,14.42),(163522,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19274',NULL,163522,40.02,0.38,1010,76218,70,NULL,'SN photometric redshift distance, z photo =0.272 +/- 0.064','SDSS-II SN 19274',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,353.8854583,-0.57058,0.097,NULL,49418313990,772161156,12065018,NULL),(163523,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19274','R',163523,40.74,0.25,1120,76218,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19274',0.254586,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163524,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19274','R',163524,40.87,0.19,1190,76218,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19274',0.254586,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163525,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19274',NULL,163525,40.57,0.14,1300,76218,70,NULL,'SALT 2','SDSS-II SN 19274',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163526,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19274',NULL,163526,40.59,0.14,1310,76218,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19274',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163527,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15633','RN',163527,42.29,0.29,1970,76219,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15633',0.451021,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163528,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15633','N',163528,42.13,0.22,2670,76219,70,NULL,'SALT 2','SDSS-II SN 15633',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163529,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15633','N',163529,42.22,0.22,2780,76219,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15633',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163530,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163530,32.66,0.45,34.1,76220,NULL,NULL,'K','NGC 7711',NULL,'2007A&A...465...71T',2007,1,2.03,NULL,'G',0.00009,NULL,'13.1g',0.89,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,353.9140417,15.30197,0.097,NULL,51634461059,806788454,12606069,13.1),(163531,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163531,33.72,0.4,55.4,76220,NULL,NULL,'mean','NGC 7711',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163532,'Tully est','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163532,32.67,0.8,34.2,76221,75,NULL,NULL,'UGC 12690',NULL,'1988NBGC.C....0000T',1988,1,0.53,NULL,'G',0.000017,NULL,'17.4g',0.31,'SB(s)m:','X-ray-faint group member',NULL,NULL,NULL,1,353.9152083,1.19847,0.149,NULL,51581287161,805957611,12593087,17.4),(163533,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163533,34.91,0.57,96,76222,70,NULL,NULL,'LCRS B233301.7-443744',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'14.51',0.17,NULL,NULL,NULL,NULL,NULL,1,353.928667,-44.35206,NULL,NULL,50482108303,788782942,12324733,14.51),(163534,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163534,32.66,0.43,34,76223,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12692',NULL,'2014MNRAS.444..527S',2014,1,1,NULL,'G',0.000017,NULL,'15.45',0.2,'S?',NULL,NULL,NULL,NULL,1,353.92925,20.28906,0.089,NULL,52491776847,820184013,12815375,15.45),(163535,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163535,32.77,0.4,35.8,76223,75,NULL,NULL,'UGC 12692',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163536,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163536,32.88,0.43,37.6,76223,75,NULL,'3.6 micron, color corrected','UGC 12692',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163537,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163537,33.08,0.2,41.3,76223,74.4,NULL,NULL,'UGC 12692',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163538,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163538,33.24,0.49,44.4,76223,75,NULL,'IR','UGC 12692',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163539,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163539,33.29,0.43,45.6,76223,NULL,NULL,NULL,'UGC 12692',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163540,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163540,33.64,0.37,53.5,76223,NULL,NULL,'Malmquist cor.','UGC 12692',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163541,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163541,34.02,0.8,63.7,76224,75,NULL,'W91PP, r','UGC 12693',NULL,'1997ApJS..109..333W',1997,1,2.37,NULL,'G',0.000009,NULL,'15.44',0.18,'SBcd?',NULL,NULL,NULL,NULL,1,353.9317917,32.38508,0.237,NULL,52039620456,813119069,12704985,15.44),(163542,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163542,33.18,NULL,43.3,76224,NULL,NULL,'Dipole','UGC 12693',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163543,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163543,33.19,NULL,43.5,76224,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12693',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163544,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163544,33.19,NULL,43.5,76224,NULL,NULL,'Dipole + Quadrupole','UGC 12693',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163545,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163545,33.28,NULL,45.3,76224,NULL,NULL,NULL,'UGC 12693',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163546,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163546,33.79,0.38,57.2,76224,75,NULL,'W91PP, r, inv','UGC 12693',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163547,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163547,33.85,0.38,58.8,76224,75,NULL,'W91PP, r, raw','UGC 12693',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163548,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163548,33.91,0.2,60.5,76224,74.4,NULL,NULL,'UGC 12693',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163549,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163549,33.94,0.41,61.5,76224,NULL,NULL,NULL,'UGC 12693',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163550,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163550,34.09,0.49,65.6,76224,75,NULL,'IR','UGC 12693',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163551,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163551,34.11,0.38,66.5,76224,75,NULL,'W91PP, r, cor','UGC 12693',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163552,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163552,34.14,0.43,67.3,76224,75,NULL,'3.6 micron, color corrected','UGC 12693',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163553,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163553,34.32,0.35,73,76224,NULL,NULL,'Malmquist cor.','UGC 12693',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163554,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163554,34.32,0.43,73.3,76224,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12693',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163555,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07644','R',163555,41.12,0.19,1280,76225,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J233544.40+005205.9',0.3102,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',0.0005,NULL,'21.0g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,353.9350417,0.86831,0.121,NULL,51577735078,805902110,12592220,21),(163556,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07644','R',163556,41.25,0.29,1360,76225,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J233544.40+005205.9',0.3102,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163557,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07644',NULL,163557,41.17,0.16,1710,76225,70,NULL,'SALT 2','SDSS J233544.40+005205.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163558,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07644',NULL,163558,41.2,0.16,1740,76225,70,NULL,'SALT 2, Malmquist cor.','SDSS J233544.40+005205.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163559,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163559,36.43,0.46,193,76226,70,NULL,NULL,'2MASX J23354561-0032153',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000066,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,353.940125,-0.53747,0.097,NULL,49418310686,772161104,12065017,17.3),(163560,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163560,37.56,0.14,325,76227,70,NULL,NULL,'2MASX J23354563+0059226',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00007,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,353.94025,0.98953,0.121,NULL,51581175935,805955873,12593060,17.8),(163561,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 12874','R',163561,40.31,0.22,927,76228,70,NULL,'SDSS CAND. Unknown; SALT 2; SN 2006fb','SN 2006fb',0.245027,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,353.964625,-0.17711,0.105,NULL,49417377377,772146521,12064789,NULL),(163562,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 12874','R',163562,40.44,0.16,983,76228,70,NULL,'SDSS CAND. Unknown; MLCS2K2; SN 2006fb','SN 2006fb',0.245027,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163563,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163563,33.23,0.4,44.3,76229,NULL,NULL,'mean','NGC 7712',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000007,NULL,'13.74',0.8,'E','Isolated galaxy',NULL,NULL,NULL,1,353.965167,23.61875,0.149,NULL,51950803388,811731302,12683301,13.74),(163564,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163564,33.49,0.45,49.9,76229,NULL,NULL,'K','NGC 7712',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163565,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163565,33.5,0.47,50.2,76229,NULL,NULL,'H','NGC 7712',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163566,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163566,33.56,0.46,51.4,76229,NULL,NULL,'J','NGC 7712',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163567,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 05015','RN',163567,43.44,0.42,3230,76230,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 05015',0.507643,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163568,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163568,37.56,0.14,325,76231,70,NULL,NULL,'2MASX J23355678+0106330',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,353.986667,1.10919,0.149,NULL,51581240690,805956885,12593076,17),(163569,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 06709',NULL,163569,40.2,0.19,1100,76232,70,NULL,'SN photometric redshift distance, z photo =0.299 +/- 0.034','SDSS-II SN 06709',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,353.992875,0.61367,0.109,NULL,51578369932,805912030,12592375,NULL),(163570,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 06709','R',163570,40.95,0.33,1210,76232,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06709',0.280494,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163571,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 06709','R',163571,41.1,0.27,1290,76232,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06709',0.280494,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163572,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 06709',NULL,163572,40.81,0.22,1450,76232,70,NULL,'SALT 2','SDSS-II SN 06709',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163573,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 06709',NULL,163573,40.83,0.22,1470,76232,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 06709',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163574,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163574,35.94,0.46,155,76233,70,NULL,NULL,'2MASX J23355923-0926314',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.00015,NULL,'15.8g',0.33,'E0',NULL,NULL,NULL,NULL,1,353.996917,-9.44206,0.058,NULL,49653993878,775843654,12122557,15.8),(163575,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 08116','RN',163575,42.15,0.17,2160,76234,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 08116',0.242792,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163576,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 08116','RN',163576,42.39,0.21,2420,76234,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08116',0.242792,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163577,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163577,36.3,0.46,182,76235,70,NULL,NULL,'2MASX J23360469-0859183',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00015,NULL,'16.3g',0.41,NULL,NULL,NULL,NULL,NULL,1,354.019541667,-8.98844,0.078,NULL,49653388355,775834193,12122409,16.3),(163578,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19127','RN',163578,42.34,0.15,2290,76236,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 19127',0.287673,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163579,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19127','RN',163579,42.66,0.21,2650,76236,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 19127',0.287673,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163580,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 17422','RN',163580,40.32,0.25,1020,76237,70,NULL,'SDSS CAND. SNII; SALT 2','SDSS-II SN 17422',0.141,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163581,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 17422','RN',163581,40.51,0.16,1110,76237,70,NULL,'SDSS CAND. SNII; MLCS2K2','SDSS-II SN 17422',0.141,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163582,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163582,36.84,0.46,233,76238,70,NULL,NULL,'2MASX J23360859-0848193',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,354.03575,-8.8055,0.078,NULL,49653478445,775835600,12122431,17.2),(163583,'Tully est','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163583,32.83,0.8,36.9,76239,75,NULL,'B','NGC 7714',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000003,NULL,'12.5B',1.4,'SB(s)b:pec;HII LINER','X-ray-faint group member',NULL,NULL,'Starburst',1,354.05875,2.15517,0.153,NULL,51578572193,805915190,12592424,12.5),(163584,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163584,32.2,0.45,27.5,76239,NULL,NULL,'K','NGC 7714',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163585,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163585,32.26,0.47,28.3,76239,NULL,NULL,'H','NGC 7714',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163586,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163586,32.28,0.46,28.6,76239,NULL,NULL,'J','NGC 7714',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163587,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163587,32.62,0.4,33.3,76239,NULL,NULL,'mean','NGC 7714',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163588,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163588,29.71,0.8,8.73,76240,75,NULL,'MAT, I','NGC 7713',NULL,'1997ApJS..109..333W',1997,1,4.5,NULL,'G',0.000007,NULL,'11.6B',1.8,'SB(r)d:        HII','in a pair',NULL,NULL,NULL,1,354.0624583,-37.93808,NULL,NULL,49994674438,781166788,12205731,11.6),(163589,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163589,29.46,NULL,7.8,76240,NULL,NULL,NULL,'NGC 7713',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163590,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163590,29.56,0.4,8.2,76240,75,NULL,'B','NGC 7713',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163591,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163591,29.65,0.32,8.51,76240,85,NULL,'I, inv','NGC 7713',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163592,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163592,29.67,0.32,8.57,76240,85,NULL,'I, raw','NGC 7713',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163593,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163593,29.76,0.43,8.9,76240,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7713',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163594,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163594,29.82,0.43,9.2,76240,75,NULL,'3.6 micron, color corrected','NGC 7713',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163595,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163595,29.86,0.2,9.38,76240,74.4,NULL,NULL,'NGC 7713',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163596,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163596,29.99,0.4,9.95,76240,NULL,NULL,NULL,'NGC 7713',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163597,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163597,30,0.4,10,76240,73,NULL,'opt','NGC 7713',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163598,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163598,30.07,0.43,10.3,76240,75,NULL,'MAT, I, raw','NGC 7713',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163599,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163599,30.08,0.43,10.4,76240,75,NULL,'MAT, I, inv','NGC 7713',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163600,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163600,30.09,0.49,10.4,76240,NULL,NULL,NULL,'NGC 7713',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163601,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163601,30.4,0.42,12,76240,NULL,NULL,'Malmquist cor.','NGC 7713',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163602,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163602,30.44,0.43,12.2,76240,75,NULL,'MAT, I, cor','NGC 7713',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163603,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 20262',NULL,163603,38.5,2.13,502,76241,70,NULL,'SN photometric redshift distance, z photo =0.125 +/- 0.256','SDSS-II SN 20262',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,354.062958333,-0.04292,0.109,NULL,49417519625,772148744,12064824,NULL),(163604,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 20262','R',163604,40.8,0.3,1150,76241,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20262',0.260941,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163605,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 20262','R',163605,41.08,0.36,1310,76241,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20262',0.260941,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163606,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 17760','RN',163606,39.63,0.23,705,76242,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 17760',0.196919,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163607,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163607,31.36,NULL,18.7,76243,NULL,NULL,NULL,'ESO 148- G 020',NULL,'2000BSAO...50....5K',2000,1,1.81,NULL,'G',0.000024,NULL,'15.26',0.26,'SBd? sp',NULL,NULL,NULL,NULL,1,354.086416667,-57.62933,0,NULL,48818958316,762796223,11918690,15.26),(163608,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163608,33.21,NULL,43.8,76243,NULL,NULL,'Dipole','ESO 148- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163609,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163609,33.22,NULL,44.1,76243,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 148- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163610,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163610,33.23,NULL,44.2,76243,NULL,NULL,'Dipole + Quadrupole','ESO 148- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163611,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163611,37.6,0.46,332,76244,70,NULL,NULL,'2MASX J23362075+1420243',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,354.086416667,14.34019,0.157,NULL,51666499520,807289055,12613891,17.4),(163612,'Tully est','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163612,32.8,0.8,36.3,76245,75,NULL,'B','NGC 7715',NULL,'1988NBGC.C....0000T',1988,1,2.6,NULL,'G',0.000013,NULL,'14.68',0.5,'Im pec sp','X-ray-faint group member',NULL,NULL,NULL,1,354.09225,2.15653,0.153,NULL,51578583583,805915368,12592427,14.68),(163613,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163613,35.79,0.43,144,76246,75,NULL,'3.6 micron, color + selection bias corrected','KUG 2333+260',NULL,'2014MNRAS.444..527S',2014,1,0.6,NULL,'G',0.000002,NULL,'15.84',0.2,'Sb',NULL,NULL,NULL,NULL,1,354.1002083,26.36983,0.125,NULL,52008226312,812628536,12697320,15.84),(163614,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 20703','RN',163614,43.01,0.3,2480,76247,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20703',0.61158,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163615,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163615,36.26,0.46,179,76248,70,NULL,NULL,'2MASX J23362562+0104473',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000097,NULL,'16.1g',0.38,'E0',NULL,NULL,NULL,NULL,1,354.106625,1.07994,0.125,NULL,51577649317,805900770,12592199,16.1),(163616,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163616,35.34,0.8,117,76249,75,NULL,'W91PP, r','UGC 12701',NULL,'1997ApJS..109..333W',1997,1,1,'Position in 1997AJ....113...22G is incorrect.','G',0.000023,NULL,'16.5',0.1,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,354.106917,27.93561,0.129,NULL,51996555543,812446180,12694471,16.5),(163617,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163617,35.34,0.8,117,76249,75,NULL,'HMCL, I','UGC 12701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163618,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163618,35.34,0.8,117,76249,75,NULL,'W91CL, r','UGC 12701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163619,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163619,35.34,0.8,117,76249,75,NULL,'CF, r','UGC 12701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163620,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163620,35.15,0.38,107,76249,75,NULL,'CF, r, raw','UGC 12701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163621,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163621,35.15,0.49,107,76249,75,NULL,'IR','UGC 12701',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163622,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163622,35.23,0.38,111,76249,75,NULL,'CF, r, inv','UGC 12701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163623,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163623,35.29,0.4,114,76249,75,NULL,'HMCL, I, raw','UGC 12701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163624,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163624,35.33,0.38,117,76249,75,NULL,'W91CL, r, raw','UGC 12701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163625,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163625,35.36,0.38,118,76249,75,NULL,'CF, r, cor','UGC 12701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163626,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163626,35.36,0.43,118,76249,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12701',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163627,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163627,35.43,0.4,122,76249,75,NULL,'HMCL, I, inv','UGC 12701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163628,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163628,35.44,0.38,122,76249,75,NULL,'W91CL, r, inv','UGC 12701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163629,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163629,35.47,0.38,124,76249,75,NULL,'W91PP, r, raw','UGC 12701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163630,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163630,35.51,0.4,126,76249,75,NULL,'HMCL, I, cor','UGC 12701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163631,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163631,35.5,0.43,126,76249,75,NULL,'3.6 micron, color corrected','UGC 12701',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163632,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163632,35.55,0.11,129,76249,NULL,NULL,NULL,'UGC 12701',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163633,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163633,35.55,0.38,129,76249,75,NULL,'W91CL, r, cor','UGC 12701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163634,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163634,35.58,0.2,131,76249,74.4,NULL,NULL,'UGC 12701',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163635,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163635,35.6,0.38,132,76249,75,NULL,'W91PP, r, inv','UGC 12701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163636,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163636,35.65,0.38,135,76249,75,NULL,'W91PP, r, cor','UGC 12701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163637,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163637,31.5,0.8,19.9,76250,75,NULL,'MAT, I','ESO 347- G 029',NULL,'1997ApJS..109..333W',1997,1,3.2,NULL,'G',0.00001,NULL,'13.92',1.7,'SB(s)dm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,354.1134583,-38.78244,NULL,NULL,49984831615,781012993,12203328,13.92),(163638,'Tully est','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163638,31.36,0.8,18.7,76250,75,NULL,NULL,'ESO 347- G 029',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163639,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163639,32.07,0.43,26,76250,75,NULL,'MAT, I, raw','ESO 347- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163640,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163640,32.1,0.43,26.3,76250,75,NULL,'MAT, I, inv','ESO 347- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163641,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163641,32.16,0.32,27,76250,85,NULL,'I, raw','ESO 347- G 029',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163642,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163642,32.16,0.32,27,76250,85,NULL,'I, inv','ESO 347- G 029',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163643,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163643,32.26,0.43,28.3,76250,75,NULL,'MAT, I, cor','ESO 347- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163644,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163644,32.27,0.2,28.4,76250,74.4,NULL,NULL,'ESO 347- G 029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163645,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163645,32.29,0.4,28.7,76250,NULL,NULL,NULL,'ESO 347- G 029',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163646,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163646,32.29,0.39,28.7,76250,73,NULL,'opt','ESO 347- G 029',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163647,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163647,32.43,0.43,30.6,76250,75,NULL,'3.6 micron, color corrected','ESO 347- G 029',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163648,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163648,32.6,0.43,33.2,76250,75,NULL,'3.6 micron, color + selection bias corrected','ESO 347- G 029',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163649,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 10559',NULL,163649,40.06,0.34,1030,76251,70,NULL,'SN photometric redshift distance, z photo =0.277 +/- 0.056','SDSS-II SN 10559',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,354.116417,-1.22661,0.093,NULL,49420725168,772198830,12065606,NULL),(163650,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 10559','R',163650,40.68,0.21,1070,76251,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 10559',0.281092,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163651,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 10559','R',163651,40.84,0.29,1150,76251,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 10559',0.281092,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163652,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 10559',NULL,163652,40.74,0.18,1410,76251,70,NULL,'SALT 2','SDSS-II SN 10559',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163653,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 10559',NULL,163653,40.77,0.18,1430,76251,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 10559',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163654,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163654,37.54,0.27,322,76252,70,NULL,NULL,'2MASX J23362923-0911143',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00014,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,354.121916667,-9.18733,0.071,NULL,49654086475,775845101,12122579,17.8),(163655,'Ring Diameter','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163655,33.5,0.84,50,76253,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7716',NULL,'1981ApJS...45..541P',1981,1,2.1,NULL,'G',0.00002,NULL,'12.82',1.8,'SAB(r)b:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,354.1310417,0.29728,0.109,NULL,51577563555,805899430,12592178,12.82),(163656,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163656,32.56,0.45,32.4,76253,NULL,NULL,'K','NGC 7716',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163657,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163657,32.56,0.4,32.5,76253,NULL,NULL,'mean','NGC 7716',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163658,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163658,32.59,0.47,33,76253,NULL,NULL,'H','NGC 7716',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163659,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163659,32.6,0.46,33.2,76253,NULL,NULL,'J','NGC 7716',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163660,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163660,32.64,0.4,33.7,76253,75,NULL,'B','NGC 7716',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163661,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163661,37.38,0.46,300,76254,70,NULL,NULL,'2MASX J23363528-0056138',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000075,NULL,'18.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,354.146958333,-0.93719,0.097,NULL,49418074387,772157412,12064959,18.1),(163662,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163662,38.55,0.46,513,76255,70,NULL,NULL,'2MASX J23363605-1034423',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000167,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,354.1502083,-10.57844,0.083,NULL,49652570699,775821417,12122209,18.2),(163663,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163663,31.14,0.96,16.9,76256,NULL,NULL,NULL,'ESO 605- G 015',NULL,'2009ApJS..182..474S',2009,1,2.13,NULL,'G',0.000013,NULL,'16.49',0.2,'Sd',NULL,NULL,NULL,NULL,1,354.152583,-21.86206,0.054,NULL,50276488028,785570125,12274533,16.49),(163664,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163664,31.62,0.39,21.1,76256,73,NULL,'opt','ESO 605- G 015',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163665,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163665,31.72,0.73,22,76256,NULL,NULL,'Malmquist cor.','ESO 605- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163666,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163666,31.75,NULL,22.4,76256,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 605- G 015',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163667,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163667,31.77,NULL,22.6,76256,NULL,NULL,'Dipole + Quadrupole','ESO 605- G 015',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163668,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163668,31.78,NULL,22.7,76256,NULL,NULL,'Dipole','ESO 605- G 015',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163669,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163669,31.82,NULL,23.1,76256,NULL,NULL,NULL,'ESO 605- G 015',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163670,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163670,32.4,0.2,30.2,76256,74.4,NULL,NULL,'ESO 605- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163671,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163671,33.27,0.2,45.1,76257,74.4,NULL,NULL,'UGC 12705',NULL,'2013AJ....146...86T',2013,1,1.01,NULL,'G',0.000021,NULL,'15.6g',0.56,'SBcd:','Isolated galaxy',NULL,NULL,NULL,1,354.1547083,14.15728,0.173,NULL,51659157747,807174339,12612099,15.6),(163672,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163672,33.57,0.12,51.9,76257,NULL,NULL,NULL,'UGC 12705',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163673,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163673,37.34,0.46,293,76258,70,NULL,NULL,'2MASX J23363763-0936173',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,354.1567083,-9.60464,0.058,NULL,49653976350,775843380,12122552,17.1),(163674,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163674,37.22,0.46,278,76259,70,NULL,NULL,'2MASX J23363834+1451004',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000117,NULL,'19.0g',0.09,NULL,NULL,NULL,NULL,NULL,1,354.159667,14.85006,0.117,NULL,51666678652,807291853,12613935,19),(163675,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163675,37.54,0.27,322,76260,70,NULL,NULL,'2MASX J23363916-0914233',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000177,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,354.163,-9.23981,0.071,NULL,49654074879,775844919,12122576,16.9),(163676,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163676,32.65,0.2,33.9,76261,74.4,NULL,NULL,'UGC 12707',NULL,'2013AJ....146...86T',2013,1,1.5,'MCG notes this as a possible interacting system.','G',0.00001,NULL,'14.51',1,'SB?',NULL,NULL,NULL,NULL,1,354.170417,17.51444,0.129,NULL,52487768723,820121386,12814396,14.51),(163677,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163677,32.68,0.43,34.3,76261,75,NULL,'3.6 micron, color corrected','UGC 12707',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163678,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163678,32.73,0.43,35.2,76261,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12707',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163679,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163679,32.9,0.56,38,76261,NULL,NULL,NULL,'UGC 12707',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163680,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163680,33.25,0.48,44.8,76261,NULL,NULL,'Malmquist cor.','UGC 12707',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163681,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163681,37.05,0.46,257,76262,70,NULL,NULL,'2MASX J23364313+1340264',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000183,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,354.179667,13.67414,0.141,NULL,51659216177,807175252,12612113,16.6),(163682,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163682,34.05,0.52,64.5,76263,70,NULL,NULL,'MCG -01-60-012',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'14.83',0.25,NULL,NULL,NULL,NULL,NULL,1,354.1880417,-5.03794,0.081,NULL,49413223957,772081624,12063775,14.83),(163683,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163683,37.21,0.46,277,76264,70,NULL,NULL,'2MASX J23364715+0111233',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,354.1965,1.18981,0.157,NULL,51577677521,805901211,12592206,16.4),(163684,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19128','R',163684,41.07,0.24,1270,76265,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007lw','SN 2007lw',0.287,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,354.20375,-0.78225,0.097,NULL,49417938882,772155295,12064926,NULL),(163685,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19128','R',163685,41.13,0.16,1310,76265,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007lw','SN 2007lw',0.287,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163686,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163686,38.08,0.46,413,76266,70,NULL,NULL,'2MASX J23364943+0102353',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.14',0.16,NULL,NULL,NULL,NULL,NULL,1,354.2059583,1.04308,0.125,NULL,51577836336,805903692,12592245,18.14),(163687,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163687,38.03,0.46,403,76267,70,NULL,NULL,'2MASX J23364981+1444201',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,354.207583,14.73889,0.117,NULL,51666706875,807292294,12613942,17.8),(163688,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163688,37.54,0.27,322,76268,70,NULL,NULL,'2MASX J23365066-0915579',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00015,NULL,'16.8g',0.33,NULL,NULL,NULL,NULL,NULL,1,354.211,-9.26625,0.071,NULL,49653809303,775840770,12122512,16.8),(163689,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 00718','RN',163689,40.21,0.16,947,76269,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 00718',0.161636,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163690,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 00718','RN',163690,40.63,0.21,1150,76269,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00718',0.161636,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163691,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163691,36.95,0.46,245,76270,70,NULL,NULL,'2MASX J23365083+0039183',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000092,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,354.21175,0.65517,0.133,NULL,51578279743,805910620,12592353,17.3),(163692,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 04261','RN',163692,42.94,0.31,2950,76271,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 04261',0.310649,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163693,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 04261','RN',163693,43.11,0.31,3200,76271,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04261',0.310649,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163694,'FP','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,'R',163694,37.76,0.46,357,76272,70,NULL,NULL,'2MASX J23365915+0006385',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000059,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,354.246583,0.11069,0.109,NULL,51577421700,805897214,12592143,18.2),(163695,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 00719','RN',163695,43.36,0.3,3160,76273,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00719',0.485763,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163696,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163696,33.05,0.4,40.8,76274,NULL,NULL,'mean','NGC 7713A',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000007,NULL,'12.98',1.4,'SB(r)c:','in a pair',NULL,NULL,NULL,1,354.2845417,-37.71414,NULL,NULL,49995287950,781176374,12205880,12.98),(163697,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163697,33.06,0.46,41,76274,NULL,NULL,'J','NGC 7713A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163698,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163698,33.1,0.47,41.7,76274,NULL,NULL,'H','NGC 7713A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163699,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163699,33.17,0.45,43.1,76274,NULL,NULL,'K','NGC 7713A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163700,'FP','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,'R',163700,37.26,0.17,284,76275,70,NULL,NULL,'2MASX J23370931+1555002',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000219,NULL,'16.1g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,354.288875,15.91678,0.085,NULL,51665728574,807277008,12613703,16.1),(163701,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 13833',NULL,163701,40.93,0.22,1530,76276,70,NULL,'SN photometric redshift distance, z photo =0.454 +/- 0.067','SDSS-II SN 13833',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,354.3214583,-0.20942,0.125,NULL,49417328086,772145751,12064777,NULL),(163702,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 13833','R',163702,42.66,0.34,2240,76276,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13833',0.516581,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163703,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 13833',NULL,163703,42.53,0.23,3210,76276,70,NULL,'SALT 2','SDSS-II SN 13833',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163704,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 13833',NULL,163704,42.69,0.23,3450,76276,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13833',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163705,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 09704','RN',163705,41.13,0.42,1300,76277,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 09704',0.294362,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163706,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 09704','RN',163706,41.48,0.32,1530,76277,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 09704',0.294362,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163707,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 09704','N',163707,40.96,0.27,1560,76277,70,NULL,'SALT 2','SDSS-II SN 09704',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163708,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 09704','N',163708,40.99,0.27,1580,76277,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 09704',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163709,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163709,35.53,0.33,128,76278,NULL,NULL,NULL,'ESO 605- G 017',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.53',0.3,'Sb-c',NULL,NULL,NULL,NULL,1,354.333333,-22.16144,0.056,NULL,50276426863,785569169,12274518,16.53),(163710,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163710,35.57,0.2,130,76278,74.4,NULL,NULL,'ESO 605- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163711,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163711,35.6,0.32,132,76278,NULL,NULL,'Malmquist cor.','ESO 605- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163712,'FP','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163712,35.97,0.25,156,76279,74.4,NULL,NULL,'CGCG 476-079',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000167,NULL,'15.6',NULL,'S0','Group member',NULL,NULL,NULL,1,354.3337083,26.87794,0.145,NULL,52007918114,812623720,12697245,15.6),(163713,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 15945',NULL,163713,39.49,0.39,790,76280,70,NULL,'SN photometric redshift distance, z photo =0.205 +/- 0.046','SDSS-II SN 15945',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.6g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,354.335167,0.49964,0.117,NULL,51577475813,805898059,12592157,21.6),(163714,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 15945','R',163714,40.82,0.29,1120,76280,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15945',0.309534,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163715,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 15945','R',163715,40.85,0.23,1130,76280,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15945',0.309534,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163716,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 15945',NULL,163716,40.69,0.19,1370,76280,70,NULL,'SALT 2','SDSS-II SN 15945',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163717,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 15945',NULL,163717,40.73,0.19,1400,76280,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15945',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163718,'CMD','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,'N',163718,18.71,0.34,0.055,76281,NULL,NULL,'If object = GC, ID = DESJ2356_5935','Tucana III',NULL,'2015ApJ...813..109D',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163719,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163719,32.73,0.4,35.1,76282,75,NULL,'B','UGC 12709',NULL,'1988NBGC.C....0000T',1988,1,0.95,NULL,'G',0.000013,NULL,'15.5g',0.63,'SAB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,354.35,0.39167,0.117,NULL,51577458264,805897785,12592152,15.5),(163720,'FP','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163720,35.03,0.25,101,76283,74.4,NULL,NULL,'CGCG 476-080',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000107,NULL,'15.5',0.35,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,354.3579583,27.07167,0.181,NULL,51994056850,812407138,12693861,15.5),(163721,'FP','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,'R',163721,38.33,0.46,463,76284,70,NULL,NULL,'2MASX J23372808+1454389',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000174,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,354.3672083,14.91081,0.085,NULL,51666652542,807291445,12613928,18.1),(163722,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 10327','RN',163722,39.9,0.42,879,76285,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10327',0.084882,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163723,'FP','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,'R',163723,38.18,0.46,432,76286,70,NULL,NULL,'2MASX J23373017+0103105',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000091,NULL,'16.69',0.15,NULL,NULL,NULL,NULL,NULL,1,354.375583,1.053,0.121,NULL,51594756292,806168067,12596376,16.69),(163724,'FP','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163724,35.5,0.47,126,76287,70,NULL,NULL,'ESO 605- G 018',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000133,NULL,'14.89',0.9,'S0','Pair member (points to parent)',NULL,NULL,NULL,1,354.379917,-19.62058,0.092,NULL,50270787550,785481055,12273141,14.89),(163725,'FP','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163725,36.45,0.62,195,76288,70,NULL,NULL,'2MASX J23373210-1753386',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00008,NULL,'15.89',0.43,'S0',NULL,NULL,NULL,NULL,1,354.3839583,-17.89397,0.02,NULL,50269729919,785464529,12272883,15.89),(163726,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163726,32.67,0.4,34.2,76289,75,NULL,'B','UGC 12710',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000003,NULL,'14.36',0.9,'Im?',NULL,NULL,NULL,NULL,1,354.389458333,17.99628,0.089,NULL,52488557794,820133715,12814589,14.36),(163727,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163727,32.91,0.8,38.3,76290,75,NULL,'MAT, I','ESO 408- G 012',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000029,NULL,'15.27',0.7,'SAB(s)d:',NULL,NULL,NULL,NULL,1,354.392375,-36.996,NULL,NULL,49982174418,780971475,12202679,15.27),(163728,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163728,33.46,0.32,49.1,76290,85,NULL,'I, inv','ESO 408- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163729,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163729,33.46,0.32,49.2,76290,85,NULL,'I, raw','ESO 408- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163730,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163730,33.58,0.4,52,76290,NULL,NULL,NULL,'ESO 408- G 012',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163731,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163731,33.84,0.43,58.6,76290,75,NULL,'MAT, I, raw','ESO 408- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163732,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163732,33.89,0.43,60,76290,75,NULL,'MAT, I, inv','ESO 408- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163733,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163733,34.35,0.43,74.1,76290,75,NULL,'MAT, I, cor','ESO 408- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163734,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 01750',NULL,163734,39.85,0.26,934,76291,70,NULL,'SN photometric redshift distance, z photo =0.248 +/- 0.037','SDSS-II SN 01750',NULL,'2011ApJ...738..162S',2011,1,0.14,NULL,'G',NULL,'PHOT','20.6g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,354.394458333,-0.47694,0.125,NULL,49450949282,772671082,12072985,20.6),(163735,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 01750','R',163735,40.65,0.2,1070,76291,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01750',0.25997,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163736,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 01750','R',163736,40.76,0.28,1130,76291,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01750',0.25997,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163737,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 01750',NULL,163737,40.63,0.17,1340,76291,70,NULL,'SALT 2','SDSS-II SN 01750',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163738,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 01750',NULL,163738,40.66,0.17,1360,76291,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 01750',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163739,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SN 2007pw',NULL,163739,39.81,0.16,917,76292,70,NULL,'Hubble residual -0.02 for z0.24500','SDSS J233734.57+001450.7',NULL,'2011ApJ...740...92G',2011,1,0.11,NULL,'G',0.005,NULL,'20.3g',0.06,NULL,NULL,NULL,NULL,NULL,1,354.3940417,0.24744,0.113,NULL,51594173188,806158956,12596233,20.3),(163740,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SN 2007pw',NULL,163740,39.87,0.22,942,76292,70,NULL,'SDSS-II SN 20111','SDSS J233734.57+001450.7',NULL,'2013MNRAS.434.1443X',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163741,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 20111','R',163741,40.49,0.23,1010,76292,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007pw','SDSS J233734.57+001450.7',0.245,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163742,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 20111','R',163742,40.61,0.15,1070,76292,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007pw','SDSS J233734.57+001450.7',0.245,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163743,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SN 2007pw',NULL,163743,40.31,0.12,1150,76292,70,NULL,'SALT 2','SDSS J233734.57+001450.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163744,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SN 2007pw',NULL,163744,40.33,0.12,1160,76292,70,NULL,'SALT 2, Malmquist cor.','SDSS J233734.57+001450.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163745,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 17395',NULL,163745,40.26,0.31,1130,76293,70,NULL,'SN photometric redshift distance, z photo =0.310 +/- 0.059','SDSS-II SN 17395',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','20.6g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,354.406083,-0.95064,0.097,NULL,49451265093,772676017,12073062,20.6),(163746,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 17395','R',163746,41.07,0.26,1250,76293,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17395',0.30272,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163747,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 17395','R',163747,41.28,0.22,1390,76293,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17395',0.30272,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163748,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 17395',NULL,163748,40.96,0.2,1560,76293,70,NULL,'SALT 2','SDSS-II SN 17395',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163749,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 17395',NULL,163749,40.99,0.2,1580,76293,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 17395',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163750,'SZ effect','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163750,39.51,NULL,799,76294,NULL,NULL,NULL,'ABELL 2631',NULL,'2012ApJ...748..113H',2012,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I:     [BM]',NULL,NULL,NULL,NULL,1,354.419167,0.27667,0.117,NULL,51594182097,806159095,12596235,NULL),(163751,'Tully est','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163751,31.46,0.8,19.6,76295,75,NULL,'B','UGCA 441',NULL,'1988NBGC.C....0000T',1988,1,0.3,NULL,'G',0.00002,NULL,'15.5',0.2,'BCD/E','Isolated galaxy',NULL,NULL,NULL,1,354.4147917,30.12947,0.221,NULL,52034848948,813044514,12703820,15.5),(163752,'FP','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163752,35.76,0.56,142,76296,70,NULL,NULL,'CGCG 381-017',NULL,'2014MNRAS.445.2677S',2014,1,0.84,NULL,'G',0.000099,NULL,'15.1g',0.58,'S0/a',NULL,NULL,NULL,NULL,1,354.430375,-0.51811,0.125,NULL,49450948596,772671071,12072985,15.1),(163753,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 17371','RN',163753,41.49,0.21,1550,76297,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 17371',0.279991,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163754,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,'R',163754,33.51,0.49,50.3,76298,75,NULL,'IR','KUG 2335+047',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',NULL,NULL,'15.80',0.1,'Spiral',NULL,NULL,NULL,NULL,1,354.439083,5.03467,0.205,NULL,51590866307,806107286,12595426,15.8),(163755,'FP','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163755,36.31,0.48,183,76299,70,NULL,NULL,'MCG -06-51-015',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00015,NULL,'15.17',0.62,'E',NULL,NULL,NULL,NULL,1,354.454333,-37.22642,NULL,NULL,49982010454,780968913,12202639,15.17),(163756,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163756,32.84,0.8,36.9,76300,75,NULL,'A82, H','ESO 240- G 011',NULL,'1997ApJS..109..333W',1997,1,6.83,NULL,'G',0.000003,NULL,'13.2',0.73,'Sb             LINER','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,354.456125,-47.72736,NULL,NULL,48594091529,759282680,11863791,13.2),(163757,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163757,32.85,0.8,37.1,76300,75,NULL,'MAT, I','ESO 240- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163758,'Tully est','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163758,32.72,0.8,34.9,76300,75,NULL,NULL,'ESO 240- G 011',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163759,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163759,32.48,0.4,31.4,76300,73,NULL,'opt','ESO 240- G 011',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163760,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163760,32.56,0.47,32.6,76300,NULL,NULL,'Malmquist cor.','ESO 240- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163761,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163761,32.83,NULL,36.7,76300,NULL,NULL,NULL,'ESO 240- G 011',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163762,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163762,32.84,0.42,37,76300,NULL,NULL,NULL,'ESO 240- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163763,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163763,32.93,0.43,38.5,76300,75,NULL,'MAT, I, raw','ESO 240- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163764,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163764,32.94,NULL,38.7,76300,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 240- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163765,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163765,32.95,NULL,38.9,76300,NULL,NULL,'Dipole + Quadrupole','ESO 240- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163766,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163766,32.96,NULL,39.1,76300,NULL,NULL,'Dipole','ESO 240- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163767,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163767,33.08,0.35,41.3,76300,NULL,NULL,NULL,'ESO 240- G 011',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163768,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163768,33.11,0.43,41.8,76300,75,NULL,'MAT, I, cor','ESO 240- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163769,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163769,33.15,0.2,42.7,76300,74.4,NULL,NULL,'ESO 240- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163770,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163770,33.2,0.32,43.7,76300,85,NULL,'I, raw','ESO 240- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163771,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163771,33.23,0.43,44.3,76300,75,NULL,'MAT, I, inv','ESO 240- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163772,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163772,33.28,0.32,45.2,76300,85,NULL,'I, inv','ESO 240- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163773,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163773,33.5,0.47,50,76300,75,NULL,'A82, H, raw','ESO 240- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163774,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163774,33.6,0.43,52.4,76300,75,NULL,'3.6 micron, color corrected','ESO 240- G 011',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163775,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163775,33.75,0.47,56.2,76300,75,NULL,'A82, H, inv','ESO 240- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163776,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163776,33.75,0.43,56.3,76300,75,NULL,'3.6 micron, color + selection bias corrected','ESO 240- G 011',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163777,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163777,33.83,0.47,58.2,76300,75,NULL,'A82, H, cor','ESO 240- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163778,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 01533','RN',163778,38.94,0.24,536,76301,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 01533',0.144474,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163779,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 01533','RN',163779,39.19,0.5,603,76301,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 01533',0.144474,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163780,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163780,33.62,0.69,52.9,76302,100,NULL,'mid-IR','MCG -01-60-015',NULL,'2013ApJ...771...88L',2013,1,1.4,NULL,'G',0.000027,NULL,'14.58',0.6,'SAB(rs)0+?     HII',NULL,NULL,NULL,NULL,1,354.4672917,-3.49072,0.081,NULL,49444625948,772572280,12071441,14.58),(163781,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163781,36.78,0.88,227,76303,70,NULL,NULL,'2MASX J23375668-8423510',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,354.4862917,-84.39758,0.437,NULL,48377223455,755894116,11810845,17.2),(163782,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163782,35.39,0.25,120,76304,74.4,NULL,NULL,'GIN 721',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000043,NULL,'14.32',NULL,'SB0','Group member',NULL,NULL,NULL,1,354.490875,27.26442,0.181,NULL,51993923658,812405057,12693829,14.32),(163783,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163783,35.59,0.11,131,76304,70,NULL,NULL,'GIN 721',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163784,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15505',NULL,163784,40.92,0.33,1530,76305,70,NULL,'SN photometric redshift distance, z photo =0.453 +/- 0.103','SDSS-II SN 15505',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,354.493375,-0.88436,0.089,NULL,49451292186,772676440,12073069,NULL),(163785,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 2005gw',NULL,163785,40.03,0.14,792,76306,74.2,NULL,'SALT 2','SDSS J233759.60+003828.0',0.28,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,354.498333,0.64111,0.125,NULL,51594319499,806161242,12596269,NULL),(163786,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 2005gw',NULL,163786,40.06,0.14,1030,76306,70,NULL,'Hubble residual 0.00 for z0.27700','SDSS J233759.60+003828.0',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163787,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 2005gw',NULL,163787,40.75,0.12,1100,76306,65,NULL,'SALT2','SDSS J233759.60+003828.0',0.28,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163788,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 2005gw',NULL,163788,40.75,0.17,1100,76306,70,NULL,'SALT 2','SDSS J233759.60+003828.0',0.28,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163789,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 04046','R',163789,40.8,0.24,1130,76306,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005gw','SDSS J233759.60+003828.0',0.277,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163790,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 04046','R',163790,40.83,0.16,1150,76306,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005gw','SDSS J233759.60+003828.0',0.277,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163791,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 2005gw',NULL,163791,40.96,0.14,1210,76306,65,NULL,'MLCS2k2','SDSS J233759.60+003828.0',0.28,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163792,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163792,35.55,0.1,129,76307,NULL,NULL,NULL,'CGCG 476-083',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000123,NULL,'15.4',0.3,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,354.5005,26.45944,0.145,NULL,52008278264,812629347,12697333,15.4),(163793,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',163793,37.26,0.17,284,76308,70,NULL,NULL,'2MASX J23380105+1554022',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000219,NULL,'15.8g',0.46,'E0',NULL,NULL,NULL,NULL,1,354.504291667,15.90044,0.077,NULL,51669366638,807333853,12614591,15.8),(163794,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 19667','RN',163794,43.38,0.28,2940,76309,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19667',0.614351,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163795,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163795,35.58,0.13,131,76310,NULL,NULL,NULL,'2MASX J23380480+2646098',NULL,'2009ApJS..182..474S',2009,1,0.3,NULL,'G',0.000027,NULL,'16.72',0.2,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,354.520041667,26.76933,0.145,NULL,52007996867,812624951,12697264,16.72),(163796,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163796,35.7,0.43,138,76310,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J23380480+2646098',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163797,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163797,35.93,0.43,153,76310,75,NULL,'3.6 micron, color corrected','2MASX J23380480+2646098',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163798,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163798,36.2,0.2,174,76310,74.4,NULL,NULL,'2MASX J23380480+2646098',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163799,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163799,34.87,0.69,94.3,76311,100,NULL,'mid-IR','NGC 7718',NULL,'2013ApJ...771...88L',2013,1,0.9,NULL,'G',0.000113,NULL,'15.01',0.6,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,354.520875,25.71972,0.077,NULL,51999622582,812494102,12695220,15.01),(163800,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163800,35.65,0.4,135,76311,NULL,NULL,'mean','NGC 7718',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163801,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163801,36.19,0.45,173,76311,NULL,NULL,'K','NGC 7718',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163802,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163802,36.22,0.47,175,76311,NULL,NULL,'H','NGC 7718',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163803,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163803,36.3,0.46,182,76311,NULL,NULL,'J','NGC 7718',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163804,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',163804,37.26,0.17,284,76312,70,NULL,NULL,'2MASX J23380512+1527292',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000237,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,354.5215417,15.45811,0.085,NULL,51667179215,807299675,12614057,16.9),(163805,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163805,35.13,NULL,106,76313,NULL,NULL,NULL,'FGC 2519',NULL,'2000BSAO...50....5K',2000,1,1.01,NULL,'G',NULL,NULL,'17.23',0.11,'Scd',NULL,NULL,NULL,NULL,1,354.5284583,32.35656,0.237,NULL,52039519944,813117499,12704960,17.23),(163806,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163806,35.18,NULL,109,76313,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2519',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163807,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163807,35.18,NULL,109,76313,NULL,NULL,'Dipole + Quadrupole','FGC 2519',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163808,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163808,35.19,NULL,109,76313,NULL,NULL,'Dipole','FGC 2519',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163809,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',163809,37.26,0.17,284,76314,70,NULL,NULL,'2MASX J23380845+1547202',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,354.535333,15.78892,0.077,NULL,51669340895,807333451,12614585,18),(163810,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',163810,37,0.46,252,76315,70,NULL,NULL,'2MASX J23381051-0916590',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000103,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,354.543833333,-9.283,0.06,NULL,49621666897,775338545,12114664,16.9),(163811,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 20183',NULL,163811,39.07,0.84,653,76316,70,NULL,'SN photometric redshift distance, z photo =0.166 +/- 0.090','SDSS-II SN 20183',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,354.546375,1.25039,0.125,NULL,51594699005,806167171,12596362,NULL),(163812,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163812,35.17,0.25,108,76317,74.4,NULL,NULL,'2MASX J23381247+2629398',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000123,NULL,'15.98',0.3,'S0',NULL,NULL,NULL,NULL,1,354.5520417,26.49433,0.145,NULL,52008103123,812626611,12697290,15.98),(163813,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163813,33.94,0.8,61.2,76318,75,NULL,'W91PP, r','UGC 12714',NULL,'1997ApJS..109..333W',1997,1,2.13,NULL,'G',0.000011,NULL,'15.43',0.28,'Sc',NULL,NULL,NULL,NULL,1,354.554333,32.33508,0.237,NULL,52039516690,813117448,12704960,15.43),(163814,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',163814,33.97,0.49,62.3,76318,75,NULL,'IR','UGC 12714',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163815,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163815,34.05,0.2,64.6,76318,74.4,NULL,NULL,'UGC 12714',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163816,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163816,34.11,NULL,66.3,76318,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12714',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163817,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163817,34.11,NULL,66.3,76318,NULL,NULL,'Dipole','UGC 12714',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163818,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163818,34.12,NULL,66.7,76318,NULL,NULL,'Dipole + Quadrupole','UGC 12714',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163819,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163819,34.18,NULL,68.5,76318,NULL,NULL,NULL,'UGC 12714',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163820,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163820,34.24,0.37,70.4,76318,NULL,NULL,NULL,'UGC 12714',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163821,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163821,34.27,0.38,71.4,76318,75,NULL,'W91PP, r, raw','UGC 12714',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163822,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163822,34.32,0.38,73.1,76318,75,NULL,'W91PP, r, inv','UGC 12714',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163823,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163823,34.46,0.38,78,76318,75,NULL,'W91PP, r, cor','UGC 12714',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163824,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163824,34.47,0.33,78.3,76318,NULL,NULL,'Malmquist cor.','UGC 12714',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163825,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15365','R',163825,39.89,0.18,800,76319,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ku','SDSS J233813.59+011456.6',0.19,'2014arXiv1401.3317S',2014,1,0.12,NULL,'G',NULL,NULL,'19.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,354.556667,1.24906,0.125,NULL,51594875058,806169922,12596405,19.2),(163826,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15365','R',163826,40.14,0.1,895,76319,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ku','SDSS J233813.59+011456.6',0.19,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163827,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 2006ku',NULL,163827,39.84,0.08,929,76319,70,NULL,'SALT 2','SDSS J233813.59+011456.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163828,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 2006ku',NULL,163828,39.85,0.08,933,76319,70,NULL,'SALT 2, Malmquist cor.','SDSS J233813.59+011456.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163829,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163829,35.6,0.25,132,76320,74.4,NULL,NULL,'2MASX J23381367+2724518',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000077,NULL,'15.68',NULL,'Elliptical','Group member',NULL,NULL,NULL,1,354.556917,27.41433,0.161,NULL,51993921552,812405024,12693828,15.68),(163830,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163830,34.68,0.2,86.3,76321,74.4,NULL,NULL,'CGCG 407-030',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00011,NULL,'15.3',0.3,NULL,NULL,NULL,NULL,NULL,1,354.5610417,7.80842,0.233,NULL,51785910687,809154854,12643044,15.3),(163831,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163831,29.19,0.4,6.9,76322,75,NULL,'B','UGC 12713',NULL,'1988NBGC.C....0000T',1988,1,1,NULL,'G',0.000017,NULL,'14.8',0.6,'S0/a',NULL,NULL,NULL,NULL,1,354.561417,30.70922,0.241,NULL,52038336148,813099002,12704671,14.8),(163832,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163832,30.43,NULL,12.2,76322,NULL,NULL,NULL,'UGC 12713',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163833,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',163833,37.26,0.17,284,76323,70,NULL,NULL,'2MASX J23381769+1540081',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000188,NULL,'15.6g',0.49,'E0',NULL,NULL,NULL,NULL,1,354.5735417,15.66892,0.077,NULL,51669209543,807331399,12614553,15.6),(163834,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 04206',NULL,163834,39.95,0.32,979,76324,70,NULL,'SN photometric redshift distance, z photo =0.262 +/- 0.049','SDSS-II SN 04206',NULL,'2011ApJ...738..162S',2011,1,0.1,NULL,'G',NULL,'PHOT','20.6g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,354.577208333,-0.48653,0.113,NULL,49451097189,772673393,12073021,20.6),(163835,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 04206','R',163835,40.77,0.27,1100,76324,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 04206',0.290675,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163836,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 04206','R',163836,40.99,0.24,1220,76324,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 04206',0.290675,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163837,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 04206',NULL,163837,40.54,0.18,1280,76324,70,NULL,'SALT 2','SDSS-II SN 04206',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163838,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 04206',NULL,163838,40.57,0.18,1300,76324,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 04206',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163839,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163839,35.59,0.11,131,76325,70,NULL,NULL,'CGCG 476-085',NULL,'2001MNRAS.321..277C',2001,1,0.54,NULL,'G',0.000083,NULL,'14.26',0.45,'E','Group member',NULL,NULL,NULL,1,354.577041667,26.88692,0.145,NULL,52008047802,812625746,12697277,14.26),(163840,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163840,35.93,0.22,153,76325,74.4,NULL,NULL,'CGCG 476-085',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163841,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163841,36.02,0.23,160,76326,74.4,NULL,NULL,'2MASX J23381860+2702066',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000073,NULL,'17.01',0.2,'E','Group member',NULL,NULL,NULL,1,354.5775417,27.03528,0.181,NULL,52008040277,812625629,12697275,17.01),(163842,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163842,35.69,0.25,137,76327,74.4,NULL,NULL,'2MASX J23382069+2703026',NULL,'2013AJ....146...86T',2013,1,0.35,NULL,'G',0.000067,NULL,'16.70',0.25,'S0/a','Group member',NULL,NULL,NULL,1,354.586167,27.05083,0.181,NULL,52008039471,812625616,12697275,16.7),(163843,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',163843,37.96,0.46,390,76328,70,NULL,NULL,'2MASX J23382194-0015085',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000082,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,354.591333,-0.25228,0.101,NULL,49450884322,772670067,12072969,16.8),(163844,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163844,35.38,0.22,119,76329,74.4,NULL,NULL,'CGCG 476-086',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000073,NULL,'14.19',0.5,'E','Group member',NULL,NULL,NULL,1,354.595333,27.15772,0.161,NULL,51993942032,812405344,12693833,14.19),(163845,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163845,35.59,0.11,131,76329,70,NULL,NULL,'CGCG 476-086',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163846,'BCG','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163846,35.74,0.35,136,76330,60,NULL,NULL,'ABELL 2634',0.0315,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',0.000274,NULL,NULL,NULL,'II:    [BM]',NULL,NULL,NULL,NULL,1,354.607083,27.0125,0.181,NULL,52008037019,812625578,12697274,NULL),(163847,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163847,35.54,0.22,128,76331,74.4,NULL,NULL,'IC 5341',NULL,'2013AJ....146...86T',2013,1,0.2,NULL,'G',0.00005,NULL,'15.20',0.2,'S0/D','Group member',NULL,NULL,NULL,1,354.61175,26.98511,0.145,NULL,52008043704,812625682,12697276,15.2),(163848,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163848,35.59,0.11,131,76331,70,NULL,NULL,'IC 5341',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163849,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163849,34.19,0.2,68.9,76332,74.4,NULL,NULL,'IC 1503',NULL,'2013AJ....146...86T',2013,1,0.9,'Contains the probable HII region UM 001.','G',0.00002,NULL,'14.34',0.4,'Sdm:','Brightest group member',NULL,NULL,NULL,1,354.6129583,4.80142,0.209,NULL,51590411222,806100175,12595315,14.34),(163850,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163850,34.21,0.42,69.6,76332,NULL,NULL,NULL,'IC 1503',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163851,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163851,34.27,0.4,71.6,76332,NULL,NULL,'Malmquist cor.','IC 1503',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163852,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163852,34.42,0.25,76.6,76333,74.4,NULL,NULL,'CGCG 476-089',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.00006,NULL,'15.22',0.4,'Elliptical','Group member',NULL,NULL,NULL,1,354.61925,26.81856,0.145,NULL,52008000427,812625006,12697265,15.22),(163853,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163853,35.55,0.22,129,76334,74.4,NULL,NULL,'CGCG 476-090',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.00004,NULL,'15.20',NULL,'E','Group member',NULL,NULL,NULL,1,354.62225,26.97836,0.145,NULL,52008044457,812625694,12697276,15.2),(163854,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163854,35.59,0.11,131,76334,70,NULL,NULL,'CGCG 476-090',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163855,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',163855,37.26,0.17,284,76335,70,NULL,NULL,'2MASX J23382932+1600063',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,354.622167,16.00178,0.077,NULL,51669282367,807332536,12614570,17.3),(163856,'BCG','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163856,35.74,0.35,136,76336,60,NULL,'ABELL 2634, BCG','NGC 7720 NED01',0.0315,'1980ApJ...241..486H',1980,1,1.6,NULL,'G',0.00014,NULL,'13.90',1.3,'E;BrClG','Pair member (points to parent)',NULL,NULL,NULL,1,354.6225,27.03147,0.161,NULL,52008038245,812625597,12697274,13.9),(163857,'D-Sigma','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163857,34.87,0.4,94.2,76337,75,NULL,'Edat, raw','NGC 7720',NULL,'1997ApJS..109..333W',1997,1,NULL,'RC3 has V = 8712 +- 18 km/sec.','GPair',0.000047,NULL,NULL,NULL,'cD;E+ pec:     LERG','in a radial-velocity based grouping',NULL,'FR I','Flat-Spectrum Radio Source',1,354.6224583,27.03144,0.161,NULL,52008038245,812625597,12697274,NULL),(163858,'D-Sigma','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163858,35.21,0.4,110,76337,75,NULL,'Edat, cor','NGC 7720',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163859,'D-Sigma','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163859,35.36,0.12,118,76337,70,NULL,'ABELL 2634','NGC 7720',NULL,'1997MNRAS.287..899L',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163860,'D-Sigma','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163860,35.87,0.13,149,76337,72,NULL,'ABELL 2634 Cluster, 12 galaxies','NGC 7720',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163861,'Faber-Jackson','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163861,34.31,0.46,72.8,76337,95,NULL,'Michard 1979a','NGC 7720',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163862,'Faber-Jackson','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163862,34.58,0.34,82.4,76337,95,NULL,'Weighted Mean','NGC 7720',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163863,'Faber-Jackson','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163863,35,0.63,100,76337,95,NULL,'Michard 1979b, c','NGC 7720',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163864,'Faber-Jackson','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163864,35.36,0.52,118,76337,95,NULL,'de Vaucouleurs','NGC 7720',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163865,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163865,35.47,0.23,124,76337,74.4,NULL,NULL,'NGC 7720',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163866,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163866,35.59,0.11,131,76337,70,NULL,NULL,'NGC 7720',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163867,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163867,35.65,0.07,135,76337,75,NULL,'ABELL 2634 Cluster, 35 galaxies','NGC 7720',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163868,'Tertiary','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163868,34.91,0.5,95.9,76337,95,NULL,NULL,'NGC 7720',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163869,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163869,35.23,0.36,111,76337,77,NULL,'ABELL 2634 Cluster, 16 galaxies','NGC 7720',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163870,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163870,35.23,NULL,111,76337,77,NULL,'BRIK, ABELL 2634 cluster, 16 galaxies','NGC 7720',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163871,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163871,35.24,0.13,112,76337,75,NULL,'ABELL 2634 cluster, avg. of 18 spiral galaxies','NGC 7720',NULL,'2013ApJ...765...94S',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163872,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163872,35.28,0.12,114,76337,75,NULL,'ABELL 2634 cluster, avg. of 18 spiral galaxies','NGC 7720',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163873,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163873,35.3,NULL,115,76337,71,NULL,'ABELL 2634, 79 galaxies','NGC 7720',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163874,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163874,35.32,0.06,116,76337,74.4,NULL,'ABELL 2634, 21 galaxies, WISE W2 (4.6 micro-meter), curved','NGC 7720',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163875,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163875,35.32,0.06,116,76337,74.4,NULL,'ABELL 2634, 21 galaxies, WISE W1 (3.4 micro-meter), curved','NGC 7720',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163876,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163876,35.32,0.45,116,76337,NULL,NULL,'K','NGC 7720',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163877,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163877,35.33,0.12,117,76337,74.4,NULL,'ABELL 2634, 21 galaxies, WISE W2 (4.6 micro-meter), color corrected','NGC 7720',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163878,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163878,35.34,0.12,117,76337,74.4,NULL,'ABELL 2634, 21 galaxies, WISE W1 (3.4 micro-meter), color corrected','NGC 7720',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163879,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163879,35.35,0.12,117,76337,74.4,NULL,'ABELL 2634, 21 galaxies, WISE I-band','NGC 7720',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163880,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163880,35.36,0.3,118,76337,NULL,NULL,'ABELL 2634, 20 galaxies','NGC 7720',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163881,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163881,35.41,0.13,121,76337,75,NULL,'ABELL 2634 CLUSTER','NGC 7720',NULL,'2012ApJ...749...78T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163882,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163882,35.54,0.15,128,76337,70,NULL,'ABELL 2634 Cluster','NGC 7720',NULL,'1992ApJ...396..453H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163883,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163883,35.6,0.4,132,76337,NULL,NULL,'mean','NGC 7720',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163884,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163884,35.43,0.25,122,76338,74.4,NULL,NULL,'NGC 7720 NED02',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00005,NULL,'15.00',0.6,'E','Pair member (points to parent)',NULL,NULL,NULL,1,354.623083333,27.03475,0.161,NULL,52008037976,812625593,12697274,15),(163885,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13131','RN',163885,40.74,0.19,1220,76339,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13131',0.158047,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163886,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13131','RN',163886,41.23,0.24,1520,76339,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13131',0.158047,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163887,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163887,35.99,0.25,158,76340,74.4,NULL,NULL,'2MASX J23383327+2702057',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000083,NULL,'14.17',NULL,'E','Group member',NULL,NULL,NULL,1,354.638625,27.03489,0.161,NULL,52008038026,812625594,12697274,14.17),(163888,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 02549','RN',163888,41.54,0.16,1710,76341,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02549',0.18932,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163889,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 02549','RN',163889,41.74,0.21,1870,76341,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02549',0.18932,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163890,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163890,35.88,0.23,150,76342,74.4,NULL,NULL,'CGCG 476-092',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000103,NULL,'16.42',0.3,'S0','Group member',NULL,NULL,NULL,1,354.643375,26.97939,0.145,NULL,52008043886,812625685,12697276,16.42),(163891,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163891,35.43,0.68,122,76343,70,NULL,NULL,'AM 2335-782',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'14.9R',0.33,NULL,NULL,NULL,NULL,NULL,1,354.64525,-78.08614,0.261,NULL,48422661304,756604082,11821938,14.9),(163892,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15241','RN',163892,39.79,0.12,876,76344,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15241',0.035645,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163893,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163893,35.57,0.22,130,76345,74.4,NULL,NULL,'IC 5342',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.00008,NULL,'15.29',0.3,'E:','Group member',NULL,NULL,NULL,1,354.661667,27.01136,0.145,NULL,52008042859,812625669,12697276,15.29),(163894,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163894,35.59,0.11,131,76345,70,NULL,NULL,'IC 5342',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163895,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163895,35.85,0.23,148,76345,74.4,NULL,NULL,'IC 5342',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163896,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163896,35.69,0.23,137,76346,74.4,NULL,NULL,'2MASX J23384202+2707076',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000157,NULL,'16.67',0.2,'S0','Group member',NULL,NULL,NULL,1,354.6752083,27.11875,0.161,NULL,52007818332,812622161,12697221,16.67),(163897,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163897,35.6,0.4,132,76347,NULL,NULL,'mean','CGCG 476-095',NULL,'2007A&A...465...71T',2007,1,0.76,NULL,'G',0.00012,NULL,'15.5',0.44,'S0','Group member',NULL,NULL,NULL,1,354.681875,27.21542,0.161,NULL,52007821355,812622208,12697222,15.5),(163898,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163898,35.95,0.45,155,76347,NULL,NULL,'K','CGCG 476-095',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163899,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163899,35.59,0.49,131,76348,70,NULL,NULL,'MCG +00-60-025',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000097,NULL,'15',0.4,NULL,NULL,NULL,NULL,NULL,1,354.6832083,-1.47203,0.137,NULL,49454560661,772727510,12073867,15),(163900,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163900,35.75,0.25,141,76349,74.4,NULL,NULL,'2MASX J23384418+2651026',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00015,NULL,'15.88',0.4,'Elliptical','Group member',NULL,NULL,NULL,1,354.684125,26.85081,0.145,NULL,52007969716,812624526,12697258,15.88),(163901,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163901,35.45,0.25,123,76350,74.4,NULL,NULL,'2MASX J23384623+2710206',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000053,NULL,'16.51',0.2,'S0','Group member',NULL,NULL,NULL,1,354.692625,27.17242,0.161,NULL,52007855849,812622747,12697230,16.51),(163902,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 00863','RN',163902,39.79,0.18,828,76351,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 00863',0.094283,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163903,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 00863','RN',163903,40.4,0.28,1100,76351,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 00863',0.094283,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163904,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 2007le',NULL,163904,32.24,0.01,28,76352,72,NULL,'M(H) = -18.317 mag','NGC 7721',NULL,'2014ApJ...784..105W',2013,1,3.5,'HOLM 812B is a star.','G',0.00001,NULL,'12.22',1.4,'SA(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,354.7027083,-6.51786,0.065,NULL,49615410505,775240789,12113137,12.22),(163905,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163905,32.03,0.8,25.4,76352,75,NULL,'A82, H','NGC 7721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163906,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163906,32.03,0.8,25.4,76352,75,NULL,'MAT, I','NGC 7721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163907,'Sosies','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163907,32.19,0.11,27.4,76352,NULL,NULL,NULL,'NGC 7721',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163908,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163908,31.19,0.4,17.3,76352,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 7721',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163909,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163909,31.2,0.4,17.3,76352,NULL,NULL,'mean','NGC 7721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163910,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163910,31.42,0.38,19.2,76352,NULL,NULL,NULL,'NGC 7721',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163911,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163911,31.42,0.39,19.2,76352,73,NULL,'opt','NGC 7721',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163912,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163912,31.41,0.43,19.2,76352,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7721',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163913,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163913,31.44,0.43,19.4,76352,75,NULL,'3.6 micron, color corrected','NGC 7721',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163914,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163914,31.47,0.32,19.7,76352,85,NULL,'I, raw','NGC 7721',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163915,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163915,31.49,0.32,19.9,76352,85,NULL,'I, inv','NGC 7721',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163916,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163916,31.53,0.46,20.2,76352,NULL,NULL,'J','NGC 7721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163917,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163917,31.55,0.2,20.4,76352,74.4,NULL,NULL,'NGC 7721',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163918,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163918,31.6,0.43,20.9,76352,75,NULL,'MAT, I, raw','NGC 7721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163919,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163919,31.61,0.47,21,76352,NULL,NULL,'H','NGC 7721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163920,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163920,31.67,0.47,21.6,76352,75,NULL,'A82, H, raw','NGC 7721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163921,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163921,31.68,0.45,21.7,76352,NULL,NULL,'K','NGC 7721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163922,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163922,31.73,0.48,22.2,76352,NULL,NULL,'Malmquist cor.','NGC 7721',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163923,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163923,31.74,0.47,22.3,76352,75,NULL,'A82, H, inv','NGC 7721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163924,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163924,31.76,0.43,22.5,76352,75,NULL,'MAT, I, inv','NGC 7721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163925,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163925,31.8,0.46,22.9,76352,NULL,NULL,NULL,'NGC 7721',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163926,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163926,31.84,0.43,23.3,76352,75,NULL,'MAT, I, cor','NGC 7721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163927,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163927,31.95,0.47,24.5,76352,75,NULL,'A82, H, cor','NGC 7721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163928,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163928,32.08,0.4,26.1,76352,75,NULL,'B','NGC 7721',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163929,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163929,32.44,0.43,30.8,76353,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-60-016',NULL,'2014MNRAS.444..527S',2014,1,1.8,NULL,'G',0.000021,NULL,'15.39',0.7,'SB(s)m:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,354.703583,-5.74667,0.072,NULL,49434294875,772410857,12068919,15.39),(163930,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163930,35.8,0.23,145,76354,74.4,NULL,NULL,'2MASX J23384921+2707228',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000167,NULL,'16.80',0.1,'S0','Group member',NULL,NULL,NULL,1,354.705167,27.12303,0.161,NULL,52007848899,812622639,12697228,16.8),(163931,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','PTF09gce','N',163931,37.09,0.07,248,76355,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF09gce',0.0575,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163932,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 20988','RN',163932,43.22,0.37,2840,76356,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20988',0.554885,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163933,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163933,35.34,0.23,117,76357,74.4,NULL,NULL,'CGCG 476-096',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000047,NULL,'14.79',NULL,'E/S0','Group member',NULL,NULL,NULL,1,354.710875,27.26772,0.161,NULL,51993915139,812404924,12693826,14.79),(163934,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163934,35.59,0.11,131,76357,70,NULL,NULL,'CGCG 476-096',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163935,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 21413',NULL,163935,41.04,0.14,1620,76358,70,NULL,'SN photometric redshift distance, z photo =0.488 +/- 0.044','SDSS-II SN 21413',NULL,'2011ApJ...738..162S',2011,1,0.03,NULL,'G',NULL,'PHOT','22.4g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,354.7157917,0.83994,0.125,NULL,51595006518,806171976,12596437,22.4),(163936,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 21413','R',163936,42.03,0.26,1750,76358,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21413',0.456731,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163937,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163937,35.04,0.23,102,76359,74.4,NULL,NULL,'2MASX J23385395+2702449',NULL,'2013AJ....146...86T',2013,1,0.32,NULL,'G',0.00008,NULL,'16.84',0.25,'S0','Group member',NULL,NULL,NULL,1,354.7247083,27.046,0.161,NULL,52007838094,812622470,12697226,16.84),(163938,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15362','R',163938,38.64,0.14,472,76360,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 15362',0.134188,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,354.73,0.76058,0.113,NULL,51595119074,806173735,12596464,NULL),(163939,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15362','R',163939,39.11,0.21,584,76360,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 15362',0.134188,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163940,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163940,35.25,0.23,112,76361,74.4,NULL,NULL,'2MASX J23385625+2709419',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000107,NULL,'16.34',0.3,'S0','Group member',NULL,NULL,NULL,1,354.734333,27.16169,0.161,NULL,52007859965,812622811,12697231,16.34),(163941,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',163941,37.26,0.17,284,76362,70,NULL,NULL,'2MASX J23385655+1525083',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000185,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,354.73575,15.41906,0.069,NULL,51667308824,807301700,12614089,17.2),(163942,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 05473','R',163942,40.79,0.23,1130,76363,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J233856.79+002300.0',0.28,'2014arXiv1401.3317S',2014,1,0.1,NULL,'G',0.01,NULL,'20.4g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,354.736667,0.38336,0.117,NULL,51594232801,806159887,12596248,20.4),(163943,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 05473','R',163943,41.07,0.2,1280,76363,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J233856.79+002300.0',0.28,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163944,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 05473',NULL,163944,40.69,0.14,1370,76363,70,NULL,'SALT 2','SDSS J233856.79+002300.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163945,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 05473',NULL,163945,40.72,0.14,1390,76363,70,NULL,'SALT 2, Malmquist cor.','SDSS J233856.79+002300.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163946,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1975N',NULL,163946,32,0.02,25.1,76364,66,NULL,NULL,'NGC 7723',NULL,'1994A&A...281...51M',1994,1,3.5,NULL,'G',0.000027,NULL,'11.94',2.3,'SB(r)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,354.737833333,-12.96108,0.083,NULL,49580538873,774695919,12104623,11.94),(163947,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1975N',NULL,163947,32.2,0.48,28,76364,67,NULL,NULL,'NGC 7723',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163948,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1975N','R',163948,32.95,NULL,38.9,76364,NULL,NULL,'Photographic','NGC 7723',NULL,'1988SSRv...48....1R',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163949,'Ring Diameter','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163949,32.4,0.84,30,76364,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7723',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163950,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163950,31.87,0.8,23.6,76364,75,NULL,'MAT, I','NGC 7723',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163951,'Sosies','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163951,31.95,0.24,24.5,76364,NULL,NULL,NULL,'NGC 7723',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163952,'Tully est','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163952,31.88,0.8,23.7,76364,75,NULL,'B','NGC 7723',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163953,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163953,31.39,0.69,19,76364,100,NULL,'mid-IR','NGC 7723',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163954,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163954,31.92,NULL,24.2,76364,NULL,NULL,'B','NGC 7723',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163955,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163955,32.07,0.32,26,76364,85,NULL,'I, raw','NGC 7723',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163956,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163956,32.08,0.43,26.1,76364,75,NULL,'MAT, I, raw','NGC 7723',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163957,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163957,32.14,0.32,26.8,76364,85,NULL,'I, inv','NGC 7723',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163958,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163958,32.15,0.4,26.9,76364,NULL,NULL,NULL,'NGC 7723',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163959,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163959,32.15,0.4,26.9,76364,73,NULL,'opt','NGC 7723',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163960,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163960,32.15,0.46,27,76364,NULL,NULL,'J','NGC 7723',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163961,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163961,32.17,0.45,27.1,76364,NULL,NULL,'K','NGC 7723',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163962,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163962,32.23,0.47,27.9,76364,NULL,NULL,'H','NGC 7723',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163963,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163963,32.26,0.43,28.4,76364,75,NULL,'MAT, I, cor','NGC 7723',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163964,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163964,32.28,0.4,28.6,76364,NULL,NULL,'mean','NGC 7723',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163965,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163965,32.34,0.43,29.4,76364,75,NULL,'MAT, I, inv','NGC 7723',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163966,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163966,32.36,0.43,29.6,76364,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7723',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163967,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163967,32.36,0.43,29.7,76364,75,NULL,'3.6 micron, color corrected','NGC 7723',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163968,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163968,32.46,0.39,31.1,76364,73,NULL,'opt','NGC 7723',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163969,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163969,32.51,0.2,31.8,76364,74.4,NULL,NULL,'NGC 7723',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163970,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163970,32.55,0.46,32.4,76364,NULL,NULL,'Malmquist cor.','NGC 7723',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163971,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163971,32.76,0.42,35.7,76364,NULL,NULL,NULL,'NGC 7723',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163972,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',163972,34.94,0.49,97.5,76365,75,NULL,'IR','FGC 2521',NULL,'2011yCatp016004901K',2011,1,0.83,NULL,'G',NULL,NULL,'16.7',0.1,'Scd',NULL,NULL,NULL,NULL,1,354.751416667,49.59244,0.977,NULL,53160956391,830639943,12978749,16.7),(163973,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163973,35.32,NULL,116,76365,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2521',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163974,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163974,35.34,NULL,117,76365,NULL,NULL,'Dipole + Quadrupole','FGC 2521',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163975,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163975,35.35,NULL,117,76365,NULL,NULL,'Dipole','FGC 2521',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163976,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163976,35.37,NULL,119,76365,NULL,NULL,NULL,'FGC 2521',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163977,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 06712','RN',163977,40.35,0.2,1080,76366,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 06712',0.09184,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163978,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 06712','RN',163978,41.09,0.26,1510,76366,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 06712',0.09184,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163979,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163979,36.47,0.25,197,76367,74.4,NULL,NULL,'2MASX J23390270+2706099',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000113,NULL,'14.53',0.5,'E','Group member',NULL,NULL,NULL,1,354.7612083,27.10272,0.161,NULL,52007847538,812622617,12697228,14.53),(163980,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 18610','RN',163980,40.13,0.09,941,76368,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 18610',0.129113,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163981,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 18610','RN',163981,40.38,0.18,1060,76368,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 18610',0.129113,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163982,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',163982,34.28,0.49,71.6,76369,75,NULL,'IR','ESO 605- G 022',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.45',0.3,'Sb',NULL,NULL,NULL,NULL,1,354.7665,-20.81614,0.056,NULL,50278058730,785594667,12274916,15.45),(163983,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163983,34.28,0.84,71.7,76369,NULL,NULL,'Malmquist cor.','ESO 605- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163984,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163984,34.31,0.82,72.9,76369,NULL,NULL,NULL,'ESO 605- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163985,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163985,34.35,0.2,74.1,76369,74.4,NULL,NULL,'ESO 605- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163986,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163986,35.55,0.12,129,76370,NULL,NULL,NULL,'AGC 330714',NULL,'2009ApJS..182..474S',2009,1,0.3,NULL,'G',0.000053,NULL,'16.0I',0.2,NULL,NULL,NULL,NULL,NULL,1,354.774583,26.58028,0.145,NULL,52008068873,812626076,12697282,16),(163987,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163987,32.34,0.4,29.4,76371,NULL,NULL,'mean','NGC 7724',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.00003,NULL,'13.90',1,'(R\')SB(r)b pec?','Pair member (points to parent)',NULL,NULL,NULL,1,354.779833,-12.22406,0.098,NULL,49577580440,774649694,12103901,13.9),(163988,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163988,33.01,0.45,39.9,76371,NULL,NULL,'K','NGC 7724',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163989,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163989,33.01,0.46,40.1,76371,NULL,NULL,'J','NGC 7724',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163990,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163990,33.07,0.47,41.1,76371,NULL,NULL,'H','NGC 7724',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163991,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',163991,34.3,0.46,72.3,76372,70,NULL,NULL,'CGCG 381-019',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000067,NULL,'15.1g',0.41,'S0',NULL,NULL,NULL,NULL,1,354.786,0.46347,0.117,NULL,51594248116,806160126,12596251,15.1),(163992,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163992,35.38,0.13,119,76373,NULL,NULL,NULL,'2MASX J23390982+2641350',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000017,NULL,'17.32',0.2,'Sc','Group member',NULL,NULL,NULL,1,354.790917,26.69314,0.145,NULL,52007937629,812624025,12697250,17.32),(163993,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',163993,34.21,0.49,69.4,76374,75,NULL,'IR','UGC 12720',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'15.23',0.2,'S?',NULL,NULL,NULL,NULL,1,354.7964583,5.48444,0.229,NULL,51590126482,806095726,12595245,15.23),(163994,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163994,34.3,0.2,72.4,76375,74.4,NULL,NULL,'UGC 12720',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000033,NULL,'15.23',0.2,'S?',NULL,NULL,NULL,NULL,1,354.7964583,5.48444,0.229,NULL,51590126482,806095726,12595245,15.23),(163995,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163995,35.01,0.8,100,76376,75,NULL,'W91PP, r','NGC 7726',NULL,'1997ApJS..109..333W',1997,1,1.5,'NGC identification is not certain.','G',0.000003,NULL,'15.04',0.5,'SB(s)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,354.799625,27.11533,0.161,NULL,52007841809,812622528,12697227,15.04),(163996,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163996,35.01,0.8,101,76376,75,NULL,'HMCL, I','NGC 7726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163997,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163997,35.01,0.8,101,76376,75,NULL,'W91CL, r','NGC 7726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163998,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163998,35.01,0.8,101,76376,75,NULL,'CF, r','NGC 7726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163999,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163999,34.42,0.69,76.7,76376,100,NULL,'mid-IR','NGC 7726',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164000,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164000,34.57,0.38,82.2,76376,75,NULL,'CF, r, raw','NGC 7726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164001,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164001,34.73,0.38,88.1,76376,75,NULL,'CF, r, inv','NGC 7726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164002,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164002,34.73,0.38,88.2,76376,75,NULL,'W91PP, r, raw','NGC 7726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164003,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164003,34.74,0.38,88.5,76376,75,NULL,'W91CL, r, raw','NGC 7726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164004,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164004,34.82,0.38,92,76376,75,NULL,'CF, r, cor','NGC 7726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164005,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164005,34.89,0.38,95,76376,75,NULL,'W91CL, r, inv','NGC 7726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164006,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164006,34.91,0.38,95.8,76376,75,NULL,'W91PP, r, inv','NGC 7726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164007,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164007,34.95,0.38,97.9,76376,75,NULL,'W91CL, r, cor','NGC 7726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164008,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164008,34.96,0.38,98.3,76376,75,NULL,'W91PP, r, cor','NGC 7726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164009,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164009,35.02,0.4,101,76376,75,NULL,'HMCL, I, raw','NGC 7726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164010,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164010,35.03,0.2,101,76376,74.4,NULL,NULL,'NGC 7726',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164011,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164011,35.04,0.43,102,76376,75,NULL,'3.6 micron, color corrected','NGC 7726',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164012,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164012,35.1,0.4,105,76376,NULL,NULL,'mean','NGC 7726',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164013,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164013,35.16,0.43,108,76376,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7726',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164014,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164014,35.17,0.47,108,76376,NULL,NULL,'H','NGC 7726',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164015,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164015,35.23,0.4,111,76376,75,NULL,'HMCL, I, inv','NGC 7726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164016,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164016,35.26,0.4,113,76376,75,NULL,'HMCL, I, cor','NGC 7726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164017,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164017,35.67,0.07,136,76376,NULL,NULL,NULL,'NGC 7726',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164018,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164018,35.5,0.11,126,76377,NULL,NULL,NULL,'2MASX J23391190+2709360',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000257,NULL,'16.51',0.7,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,354.799625,27.16006,0.161,NULL,52007852781,812622699,12697229,16.51),(164019,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 01354','R',164019,40.31,0.36,925,76378,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01354',0.249436,'2014arXiv1401.3317S',2014,1,0.13,NULL,'G',NULL,'PHOT','19.3g',0.1,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,354.8027083,0.09022,0.101,NULL,51548240017,805441250,12585019,19.3),(164020,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 01354',NULL,164020,40.1,0.27,1050,76378,70,NULL,'SN photometric redshift distance, z photo =0.283 +/- 0.046','SDSS-II SN 01354',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164021,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 01354','R',164021,40.59,0.27,1050,76378,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01354',0.249436,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164022,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 01354',NULL,164022,40.28,0.24,1140,76378,70,NULL,'SALT 2','SDSS-II SN 01354',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164023,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 01354',NULL,164023,40.29,0.24,1140,76378,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 01354',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164024,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164024,35.51,0.25,126,76379,74.4,NULL,NULL,'2MASX J23391340+2732550',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.00008,NULL,'15.43',0.4,'E',NULL,NULL,NULL,NULL,1,354.806,27.54858,0.173,NULL,51995797174,812434330,12694286,15.43),(164025,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164025,37.56,0.33,326,76380,70,NULL,NULL,'2MASX J23391478-0026459',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000092,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,354.8114583,-0.44617,0.101,NULL,49451004965,772671952,12072999,16.3),(164026,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164026,35.18,0.43,109,76381,75,NULL,'3.6 micron, color + selection bias corrected','AGC 330726',NULL,'2014MNRAS.444..527S',2014,1,0.3,NULL,'G',0.00002,NULL,'16.64',0.2,'Sb','Group member',NULL,NULL,NULL,1,354.824583,26.84461,0.145,NULL,52007987137,812624799,12697262,16.64),(164027,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164027,35.35,0.43,118,76381,75,NULL,'3.6 micron, color corrected','AGC 330726',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164028,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164028,35.37,0.12,119,76381,NULL,NULL,NULL,'AGC 330726',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164029,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164029,35.52,0.2,127,76381,74.4,NULL,NULL,'AGC 330726',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164030,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164030,38.14,0.46,424,76382,70,NULL,NULL,'2MASX J23391916+1442277',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000198,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,354.83,14.70761,0.065,NULL,51671557602,807368087,12615126,17.7),(164031,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164031,37.56,0.33,326,76383,70,NULL,NULL,'2MASX J23392274-0019125',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000065,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,354.8447083,-0.32014,0.101,NULL,49396555745,771821183,12059705,17.9),(164032,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164032,34.96,0.49,98.3,76384,75,NULL,'IR','UGC 12723',NULL,'2011yCatp016004901K',2011,1,1.12,NULL,'G',0.000033,NULL,'15.76',0.15,'Sdm',NULL,NULL,NULL,NULL,1,354.850041667,10.84997,0.169,NULL,51779530449,809055163,12641486,15.76),(164033,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164033,34.96,NULL,98.3,76384,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12723',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164034,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164034,34.99,NULL,99.5,76384,NULL,NULL,'Dipole + Quadrupole','UGC 12723',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164035,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164035,35,NULL,100,76384,NULL,NULL,'Dipole','UGC 12723',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164036,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164036,35.31,0.2,115,76385,74.4,NULL,NULL,'UGC 12722',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000009,NULL,'15.21',0.3,'S?',NULL,NULL,NULL,NULL,1,354.858125,9.20756,0.241,NULL,51779798512,809059351,12641552,15.21),(164037,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164037,33.13,0.8,42.4,76386,75,NULL,'MAT, I','ESO 240- G 013',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'13.99',0.9,'(R\'_1)SAB(rs)b','in a triple',NULL,NULL,NULL,1,354.862666667,-47.77478,NULL,NULL,48594101480,759282835,11863794,13.99),(164038,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164038,32.92,0.32,38.4,76386,85,NULL,'I, raw','ESO 240- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164039,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164039,32.94,0.32,38.7,76386,85,NULL,'I, inv','ESO 240- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164040,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164040,33.13,0.6,42.2,76386,NULL,NULL,'Malmquist cor.','ESO 240- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164041,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164041,33.25,0.57,44.6,76386,NULL,NULL,NULL,'ESO 240- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164042,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164042,33.27,0.43,45.1,76386,75,NULL,'MAT, I, raw','ESO 240- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164043,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164043,33.29,0.2,45.5,76386,74.4,NULL,NULL,'ESO 240- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164044,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164044,33.41,0.43,48.1,76386,75,NULL,'MAT, I, inv','ESO 240- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164045,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164045,33.45,0.43,49,76386,75,NULL,'MAT, I, cor','ESO 240- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164046,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164046,35.33,0.53,117,76387,70,NULL,NULL,'2MASX J23393333-0727284',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00007,NULL,'15.80',NULL,NULL,NULL,NULL,NULL,NULL,1,354.889,-7.45794,0.084,NULL,49618181094,775284079,12113813,15.8),(164047,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 20552','RN',164047,39.29,0.18,619,76388,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 20552',0.163931,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164048,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 20552','RN',164048,39.77,0.29,773,76388,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 20552',0.163931,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164049,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 00853','RN',164049,42.42,0.2,2250,76389,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00853',0.356609,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164050,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 00853','RN',164050,42.49,0.14,2320,76389,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 00853',0.356609,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164051,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164051,36.89,0.46,239,76390,70,NULL,NULL,'2MASX J23393880-0003205',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000079,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,354.911583,-0.05586,0.101,NULL,49396508369,771820443,12059694,16.8),(164052,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164052,35.47,0.46,124,76391,70,NULL,NULL,'CGCG 381-021',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00009,NULL,'15.4g',0.44,'E0',NULL,NULL,NULL,NULL,1,354.921917,-0.0345,0.101,NULL,49396507423,771820428,12059694,15.4),(164053,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164053,35.92,0.63,153,76391,70,NULL,NULL,'CGCG 381-021',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164054,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13467','R',164054,38.6,0.04,492,76392,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2006hq','SN 2006hq',0.068646,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,354.9464583,0.20522,0.097,NULL,51548085607,805438837,12584981,NULL),(164055,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13467','R',164055,38.99,0.21,588,76392,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2006hq','SN 2006hq',0.068646,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164056,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164056,35.39,0.25,120,76393,74.4,NULL,NULL,'CGCG 476-101',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000043,NULL,'14.08',0.4,'S0','Group member',NULL,NULL,NULL,1,354.95575,27.37611,0.173,NULL,52006487601,812601368,12696896,14.08),(164057,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164057,35.59,0.11,131,76393,70,NULL,NULL,'CGCG 476-101',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164058,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164058,37.2,0.46,276,76394,70,NULL,NULL,'2MASX J23395014-1035433',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,354.959,-10.59533,0.073,NULL,49622561050,775352516,12114883,17.2),(164059,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164059,32.39,0.61,30.1,76395,70,NULL,NULL,'NGC 7727',NULL,'2014MNRAS.445.2677S',2014,1,4.7,NULL,'G',0.000007,NULL,'11.50',3.5,'SAB(s)a pec','Pair member (points to parent)',NULL,NULL,NULL,1,354.973833,-12.29278,0.092,NULL,49577317502,774645585,12103837,11.5),(164060,'Tully est','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164060,31.84,0.8,23.3,76395,75,NULL,'B','NGC 7727',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164061,'CMD','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'N',164061,19.6,NULL,0.083,76396,NULL,NULL,NULL,'Phoenix II',NULL,'2015ApJ...805..130K',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164062,'CMD','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'N',164062,19.9,NULL,0.095,76396,NULL,NULL,'DESJ2339.9_5424','Phoenix II',NULL,'2015ApJ...807...50B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164063,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 04393','RN',164063,38,0.38,375,76397,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04393',0.060187,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164064,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 04393','RN',164064,39.69,0.53,816,76397,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04393',0.060187,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164065,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164065,35.98,0.25,157,76398,74.4,NULL,NULL,'CGCG 476-102',NULL,'2013AJ....146...86T',2013,1,0.61,NULL,'G',0.000067,NULL,'15.7',0.45,'S0','Group member',NULL,NULL,NULL,1,354.994167,26.83425,0.137,NULL,52008397708,812631214,12697362,15.7),(164066,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164066,38.25,0.46,447,76399,70,NULL,NULL,'2MASX J23395898-0000390',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000077,NULL,'17.7g',0.21,'S0',NULL,NULL,NULL,NULL,1,354.995625,-0.01089,0.097,NULL,49396463664,771819744,12059683,17.7),(164067,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164067,35.31,0.23,115,76400,74.4,NULL,NULL,'NGC 7728',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.00005,NULL,'14.13',0.8,'E','in a radial-velocity based grouping',NULL,'radio jet','Flat-Spectrum Radio Source',1,355.0035,27.13372,0.173,NULL,52008352212,812630503,12697351,14.13),(164068,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164068,35.59,0.11,131,76400,70,NULL,NULL,'NGC 7728',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164069,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164069,35.59,0.4,131,76400,NULL,NULL,'mean','NGC 7728',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164070,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164070,35.62,0.45,133,76400,NULL,NULL,'K','NGC 7728',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164071,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13802','RN',164071,40.8,0.31,1100,76401,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13802',0.313563,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164072,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13802','RN',164072,41.07,0.28,1250,76401,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13802',0.313563,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164073,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13802','N',164073,40.65,0.29,1350,76401,70,NULL,'SALT 2','SDSS-II SN 13802',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164074,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13802','N',164074,40.68,0.29,1370,76401,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13802',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164075,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164075,35.61,0.25,132,76402,74.4,NULL,NULL,'2MASX J23400320+2710014',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.00007,NULL,'16.08',0.3,'S0/E','Group member',NULL,NULL,NULL,1,355.013416667,27.16708,0.173,NULL,52008343431,812630366,12697349,16.08),(164076,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164076,35.06,0.56,103,76403,NULL,NULL,NULL,'AGC 330751',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000038,NULL,'16.42',0.3,'Sb','Group member',NULL,NULL,NULL,1,355.0362083,26.90064,0.137,NULL,52008450851,812632044,12697375,16.42),(164077,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164077,35.1,0.2,105,76403,74.4,NULL,NULL,'AGC 330751',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164078,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164078,35.11,0.54,105,76403,NULL,NULL,'Malmquist cor.','AGC 330751',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164079,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13468','RN',164079,39.65,0.14,802,76404,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13468',0.059794,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164080,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13468','RN',164080,39.99,0.23,938,76404,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13468',0.059794,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164081,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164081,35.24,0.22,108,76405,74.2,NULL,'SALT 2','[QQH97] J234014.21+261211.8',0.034,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'S:',NULL,NULL,NULL,NULL,1,355.0592083,26.20328,0.165,NULL,52008646768,812635105,12697423,NULL),(164082,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164082,35.75,0.27,137,76405,72,NULL,NULL,'[QQH97] J234014.21+261211.8',0.034,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164083,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164083,35.77,0.05,138,76405,72,NULL,NULL,'[QQH97] J234014.21+261211.8',0.034,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164084,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164084,35.82,0.17,146,76405,70.8,NULL,NULL,'[QQH97] J234014.21+261211.8',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164085,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164085,35.94,0.16,149,76405,70,NULL,'SALT 2','[QQH97] J234014.21+261211.8',0.034,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164086,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg','R',164086,35.88,0.11,150,76405,NULL,NULL,'MLCS2k2, R(V) = 3.1','[QQH97] J234014.21+261211.8',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164087,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164087,35.96,0.27,150,76405,70,NULL,'SALT','[QQH97] J234014.21+261211.8',0.034,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164088,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164088,35.98,0.16,153,76405,73.8,NULL,'SALT 2 (SNANA)','[QQH97] J234014.21+261211.8',0.0305,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164089,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164089,35.99,0.08,153,76405,70,NULL,NULL,'[QQH97] J234014.21+261211.8',0.034,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164090,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164090,36.02,0.08,155,76405,65,NULL,'SALT2','[QQH97] J234014.21+261211.8',0.034,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164091,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164091,36.06,0.03,157,76405,70,NULL,'SALT 2','[QQH97] J234014.21+261211.8',0.034,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164092,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164092,36.15,0.11,159,76405,65,NULL,'MLCS2k2','[QQH97] J234014.21+261211.8',0.034,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164093,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164093,36.12,0.17,162,76405,65,NULL,'MLCS31','[QQH97] J234014.21+261211.8',0.034,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164094,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164094,36.12,0.27,162,76405,65,NULL,'SALT','[QQH97] J234014.21+261211.8',0.034,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164095,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164095,36.12,0.2,162,76405,65,NULL,NULL,'[QQH97] J234014.21+261211.8',0.034,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164096,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164096,36.12,0.16,162,76405,65,NULL,'MLCS17','[QQH97] J234014.21+261211.8',0.034,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164097,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164097,36.15,0.12,164,76405,65,NULL,'MLCS2k2','[QQH97] J234014.21+261211.8',0.034,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164098,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164098,36.15,0.19,164,76405,65,NULL,'SALT2','[QQH97] J234014.21+261211.8',0.034,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164099,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164099,36.17,0.08,166,76405,65,NULL,'MLCS2k2','[QQH97] J234014.21+261211.8',0.034,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164100,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg','R',164100,36.12,0.09,167,76405,NULL,NULL,'MLCS2k2, R(V) = 1.8','[QQH97] J234014.21+261211.8',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164101,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164101,36.21,0.03,169,76405,65,NULL,'SALT','[QQH97] J234014.21+261211.8',0.034,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164102,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164102,36.24,0.14,177,76405,60,NULL,NULL,'[QQH97] J234014.21+261211.8',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164103,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164103,35.37,0.25,119,76406,74.4,NULL,NULL,'CGCG 476-105',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000057,NULL,'13.72',0.7,'S0',NULL,NULL,NULL,NULL,1,355.079208333,27.56153,0.185,NULL,51995271532,812426117,12694158,13.72),(164104,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164104,35.59,0.11,131,76406,70,NULL,NULL,'CGCG 476-105',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164105,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13781','RN',164105,43.25,0.38,3780,76407,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13781',0.179111,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164106,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164106,37.17,0.46,272,76408,70,NULL,NULL,'SDSS J234020.82+145802.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000125,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,355.08675,14.96725,0.053,NULL,51671299724,807364058,12615063,18.1),(164107,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164107,34.55,NULL,81.3,76409,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2523',NULL,'2010Ap&SS.325..163P',2010,1,1.03,NULL,'G',0.000017,NULL,'16.9',0.07,'Sd',NULL,NULL,NULL,NULL,1,355.1,-6.76278,0.035,NULL,49615144203,775236628,12113072,16.9),(164108,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164108,34.55,NULL,81.4,76409,NULL,NULL,'Dipole + Quadrupole','FGC 2523',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164109,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164109,34.57,NULL,81.9,76409,NULL,NULL,NULL,'FGC 2523',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164110,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164110,34.57,NULL,82,76409,NULL,NULL,'Dipole','FGC 2523',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164111,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164111,37.32,0.23,291,76410,70,NULL,NULL,'2MASX J23402414+0000080',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00009,NULL,'16.7g',0.3,'S0',NULL,NULL,NULL,NULL,1,355.1005,0.00228,0.097,NULL,51548390274,805443598,12585056,16.7),(164112,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 01390',NULL,164112,35.12,1.25,106,76411,70,NULL,'SN photometric redshift distance, z photo =0.025 +/- 0.020','SDSS-II SN 01390',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','21.8g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,355.10225,0.49928,0.117,NULL,51548876566,805451196,12585174,21.8),(164113,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164113,35.26,0.69,113,76412,100,NULL,'mid-IR','CGCG 381-023',NULL,'2013ApJ...771...88L',2013,1,0.8,NULL,'G',0.000117,NULL,'15.1',0.5,NULL,NULL,NULL,NULL,NULL,1,355.1240417,2.77458,0.177,NULL,51596836472,806200569,12596883,15.1),(164114,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164114,35.05,0.48,102,76413,70,NULL,NULL,'AM 2337-612',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.000077,NULL,'15.22',0.68,'S0',NULL,NULL,NULL,NULL,1,355.124667,-61.08664,0,NULL,48748497623,761695275,11901488,15.22),(164115,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164115,36.49,0.91,199,76414,70,NULL,NULL,'2MASX J23403317-2950240',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.55',0.38,NULL,NULL,NULL,NULL,NULL,1,355.13825,-29.84,NULL,NULL,50041914659,781904916,12217264,16.55),(164116,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164116,37.32,0.23,291,76415,70,NULL,NULL,'ABELL 2644:[KMD98] 023',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00018,NULL,'16.71',NULL,'S0',NULL,NULL,NULL,NULL,1,355.139041667,0.04792,0.097,NULL,51548391793,805443621,12585056,16.71),(164117,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164117,35.98,0.25,157,76416,74.4,NULL,NULL,'2MASX J23403361+2714322',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000137,NULL,'15.49',0.5,'Elliptical',NULL,NULL,NULL,NULL,1,355.1400417,27.24233,0.185,NULL,52008364673,812630698,12697354,15.49),(164118,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164118,34.17,0.8,68.1,76417,75,NULL,'W91PP, r','NGC 7729',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'14.37',0.6,'Sa',NULL,NULL,NULL,NULL,1,355.1402083,29.18817,0.161,NULL,51967144184,811986627,12687291,14.37),(164119,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164119,34.21,0.47,69.4,76417,NULL,NULL,'H','NGC 7729',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164120,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164120,34.25,0.4,70.9,76417,NULL,NULL,'mean','NGC 7729',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164121,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164121,34.25,0.46,70.9,76417,NULL,NULL,'J','NGC 7729',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164122,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164122,34.25,0.45,70.9,76417,NULL,NULL,'K','NGC 7729',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164123,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164123,34.42,0.49,76.4,76417,75,NULL,'IR','NGC 7729',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164124,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164124,34.54,0.38,81,76417,75,NULL,'W91PP, r, raw','NGC 7729',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164125,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164125,34.77,0.38,89.9,76417,75,NULL,'W91PP, r, cor','NGC 7729',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164126,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164126,34.82,0.38,92,76417,75,NULL,'W91PP, r, inv','NGC 7729',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164127,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164127,35.32,0.49,116,76418,75,NULL,'IR','UGC 12731',NULL,'2011yCatp016004901K',2011,1,1.57,NULL,'G',0.000008,NULL,'15.48',0.21,'Sbc',NULL,NULL,NULL,NULL,1,355.162375,20.44122,0.113,NULL,52492087115,820188861,12815450,15.48),(164128,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164128,35.43,NULL,122,76418,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12731',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164129,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164129,35.43,NULL,122,76418,NULL,NULL,'Dipole + Quadrupole','UGC 12731',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164130,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164130,35.45,NULL,123,76418,NULL,NULL,'Dipole','UGC 12731',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164131,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164131,35.47,NULL,124,76418,NULL,NULL,NULL,'UGC 12731',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164132,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164132,35.52,0.41,127,76418,NULL,NULL,'Malmquist cor.','UGC 12731',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164133,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164133,35.7,0.38,138,76418,NULL,NULL,NULL,'UGC 12731',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164134,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164134,35.75,0.2,141,76418,74.4,NULL,NULL,'UGC 12731',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164135,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164135,30.46,0.4,12.4,76419,75,NULL,'B','UGC 12732',NULL,'1988NBGC.C....0000T',1988,1,3,NULL,'G',0.000002,NULL,'13.8',2.8,'Sm:','Pair member (points to parent)',NULL,NULL,NULL,1,355.166083,26.23642,0.165,NULL,52008605387,812634459,12697413,13.8),(164136,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164136,36.15,0.46,170,76420,70,NULL,NULL,'2MASX J23404092+1344304',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,355.1704583,13.74172,0.109,NULL,51660301728,807192214,12612378,16.5),(164137,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164137,37.32,0.23,291,76421,70,NULL,NULL,'2MASX J23404152+0006125',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000085,NULL,'16.9g',0.29,'S0',NULL,NULL,NULL,NULL,1,355.173166667,0.10339,0.097,NULL,51548920060,805451875,12585185,16.9),(164138,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164138,33.79,0.44,57.2,76422,NULL,NULL,NULL,'2MASX J23404253+2710412',NULL,'2009ApJS..182..474S',2009,1,0.3,NULL,'G',0.00001,NULL,'16.48',0.3,'Sa',NULL,NULL,NULL,NULL,1,355.1772083,27.17806,0.157,NULL,52008539681,812633432,12697397,16.48),(164139,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164139,34.07,0.39,65.2,76422,NULL,NULL,'Malmquist cor.','2MASX J23404253+2710412',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164140,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 18761',NULL,164140,39.87,0.49,940,76423,70,NULL,'SN photometric redshift distance, z photo =0.250 +/- 0.077','SDSS-II SN 18761',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','20.5g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,355.180875,0.73386,0.117,NULL,51548601306,805446895,12585107,20.5),(164141,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 18761','R',164141,41.06,0.35,1270,76423,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18761',0.282402,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164142,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 18761','R',164142,41.65,0.34,1670,76423,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18761',0.282402,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164143,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15946',NULL,164143,38.72,0.64,554,76424,70,NULL,'SN photometric redshift distance, z photo =0.139 +/- 0.053','SDSS-II SN 15946',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.2g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,355.188291667,0.63228,0.117,NULL,51548903258,805451613,12585181,21.2),(164144,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15946','R',164144,41.37,0.65,1370,76424,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 15946',0.375137,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164145,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164145,34.71,0.8,87.6,76425,75,NULL,'MAT, I','ESO 536- G 017',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'15.10',0.4,'Sb-c',NULL,NULL,NULL,NULL,1,355.1885417,-24.69381,0.033,NULL,50057192209,782143628,12220994,15.1),(164146,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164146,34.23,0.32,70,76425,85,NULL,'I, raw','ESO 536- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164147,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164147,34.25,0.32,70.9,76425,85,NULL,'I, inv','ESO 536- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164148,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164148,34.35,0.43,74.1,76425,75,NULL,'MAT, I, raw','ESO 536- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164149,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164149,34.5,0.43,79.4,76425,75,NULL,'MAT, I, inv','ESO 536- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164150,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164150,34.63,0.2,84.3,76425,74.4,NULL,NULL,'ESO 536- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164151,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164151,34.69,0.59,86.5,76425,NULL,NULL,NULL,'ESO 536- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164152,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164152,34.8,0.43,91.2,76425,75,NULL,'MAT, I, cor','ESO 536- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164153,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164153,35.04,0.5,102,76425,NULL,NULL,'Malmquist cor.','ESO 536- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164154,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164154,37.66,0.19,340,76426,70,NULL,NULL,'SDSS J234046.37-104732.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000142,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,355.19325,-10.79242,0.084,NULL,49622468460,775351069,12114860,18.6),(164155,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164155,36.88,0.46,237,76427,70,NULL,NULL,'2MASX J23404653-1021108',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000173,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,355.1939583,-10.35311,0.073,NULL,49622759926,775355623,12114931,16.6),(164156,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164156,35.41,0.25,121,76428,74.4,NULL,NULL,'UGC 12733',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.00005,NULL,'14.77',0.7,'E',NULL,NULL,NULL,NULL,1,355.195125,26.83533,0.137,NULL,52009279170,812644987,12697577,14.77),(164157,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164157,35.59,0.11,131,76428,70,NULL,NULL,'UGC 12733',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164158,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164158,36.03,0.45,161,76428,NULL,NULL,'K','UGC 12733',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164159,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164159,36.05,0.4,162,76428,NULL,NULL,'mean','UGC 12733',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164160,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164160,35.76,0.66,142,76429,70,NULL,NULL,'2MASX J23404797-0232119',NULL,'2014MNRAS.445.2677S',2014,1,0.84,NULL,'G',0.00015,NULL,'16.05',0.31,NULL,NULL,NULL,NULL,NULL,1,355.199833,-2.53661,0.061,NULL,49452364114,772693189,12073331,16.05),(164161,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164161,35.44,0.25,122,76430,74.4,NULL,NULL,'2MASX J23405050+2649511',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000223,NULL,'16.85',0.4,'E/S0',NULL,NULL,NULL,NULL,1,355.210583,26.83089,0.137,NULL,52009277240,812644956,12697577,16.85),(164162,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164162,36.27,0.57,180,76431,70,NULL,NULL,'2MASX J23405296-0201408',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.52',0.36,NULL,NULL,NULL,NULL,NULL,1,355.220625,-2.028,0.109,NULL,49454904462,772732882,12073951,16.52),(164163,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 11192','RN',164163,40.32,0.5,1020,76432,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 11192',0.131572,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164164,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164164,35.39,0.25,120,76433,74.4,NULL,NULL,'CGCG 476-109',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000043,NULL,'14.08',0.5,'E',NULL,NULL,NULL,NULL,1,355.226083,27.50964,0.185,NULL,52006537083,812602141,12696908,14.08),(164165,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164165,35.59,0.11,131,76433,70,NULL,NULL,'CGCG 476-109',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164166,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164166,35.14,0.8,107,76434,75,NULL,'MAT, I','ESO 471- G 002',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000033,NULL,'14.47',0.7,'SA(r)bc',NULL,NULL,NULL,NULL,1,355.2264583,-28.33814,0.069,NULL,50048290227,782004534,12218820,14.47),(164167,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164167,34.82,0.43,92.1,76434,75,NULL,'MAT, I, raw','ESO 471- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164168,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164168,34.95,0.32,97.7,76434,85,NULL,'I, raw','ESO 471- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164169,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164169,35.02,0.32,101,76434,85,NULL,'I, inv','ESO 471- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164170,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164170,35.09,0.43,104,76434,75,NULL,'MAT, I, inv','ESO 471- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164171,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164171,35.1,0.43,105,76434,75,NULL,'MAT, I, cor','ESO 471- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164172,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164172,35.24,0.27,112,76434,NULL,NULL,NULL,'ESO 471- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164173,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164173,35.28,0.2,114,76434,74.4,NULL,NULL,'ESO 471- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164174,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164174,35.41,0.25,121,76434,NULL,NULL,'Malmquist cor.','ESO 471- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164175,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164175,37.66,0.19,340,76435,70,NULL,NULL,'2MASXi J2340556-104116',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,355.232125,-10.68797,0.084,NULL,49622453979,775350843,12114856,18),(164176,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164176,36.76,0.46,225,76436,70,NULL,NULL,'2MASX J23405652+1415575',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000194,NULL,'16.2g',0.27,'S0/a',NULL,NULL,NULL,NULL,1,355.235583,14.26606,0.113,NULL,51670976814,807359012,12614984,16.2),(164177,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164177,37.66,0.19,340,76437,70,NULL,NULL,'2MASX J23405691-1044298',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000187,NULL,'16.3g',0.43,'BrClG',NULL,NULL,NULL,NULL,1,355.237125,-10.74147,0.084,NULL,49622464408,775351006,12114859,16.3),(164178,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164178,37.87,0.33,375,76438,70,NULL,NULL,'2MASXi J2340594-100700',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000174,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,355.247875,-10.11681,0.077,NULL,49621877524,775341836,12114716,18),(164179,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164179,37.87,0.33,375,76439,70,NULL,NULL,'SDSS J234101.02-100549.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,355.254291667,-10.09708,0.077,NULL,49621869301,775341707,12114714,17.9),(164180,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164180,34.98,0.54,99,76440,70,NULL,NULL,'MCG -02-60-011',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000177,NULL,'15.25',0.3,NULL,NULL,NULL,NULL,NULL,1,355.258833,-8.22175,0.075,NULL,49615975191,775249612,12113275,15.25),(164181,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164181,36.43,0.5,193,76441,NULL,NULL,'Malmquist cor.','CGCG 476-111',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000017,NULL,'15.27',0.5,'Sc','Group non-member, background',NULL,NULL,NULL,1,355.2765417,25.16906,0.077,NULL,51998539671,812477182,12694955,15.27),(164182,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164182,36.79,0.42,228,76441,NULL,NULL,NULL,'CGCG 476-111',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164183,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164183,36.87,0.2,237,76441,74.4,NULL,NULL,'CGCG 476-111',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164184,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164184,37.66,0.19,340,76442,70,NULL,NULL,'SDSS J234106.46-104413.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000174,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,355.2769583,-10.73714,0.084,NULL,49622484673,775351323,12114864,18.6),(164185,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164185,37.32,0.23,291,76443,70,NULL,NULL,'GALEXASC J234107.23+000543.7',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.00017,NULL,'14.81',NULL,'E/S0',NULL,NULL,NULL,NULL,1,355.28025,0.09522,0.089,NULL,51548451769,805444558,12585071,14.81),(164186,'Magnitude','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164186,36.47,0.13,197,76444,100,NULL,NULL,'GALEXASC J234107.23+000543.7',NULL,'1998A&A...337...31R',1998,1,0.67,NULL,'G',0.00017,NULL,'14.81',NULL,'E/S0',NULL,NULL,NULL,NULL,1,355.28025,0.09522,0.089,NULL,51548451769,805444558,12585071,14.81),(164187,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164187,37.23,0.46,279,76445,70,NULL,NULL,'2MASX J23410933-0110178',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000071,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,355.288917,-1.17161,0.125,NULL,49451626878,772681669,12073151,17.3),(164188,'Magnitude','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164188,36.47,0.13,197,76446,100,NULL,NULL,'ABELL 2644',NULL,'1998A&A...337...31R',1998,1,NULL,'Katgert (1996,A&A,310,8) identifies multiple redshift systems in this cluster.','GClstr',NULL,NULL,NULL,NULL,'II     [BM]',NULL,NULL,NULL,NULL,1,355.290708333,0.094,0.089,NULL,51548451315,805444551,12585071,NULL),(164189,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 14478','R',164189,40.42,0.27,945,76447,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14478',0.281762,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,355.292583,0.06922,0.089,NULL,51548449969,805444530,12585070,NULL),(164190,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 14478','R',164190,40.42,0.29,946,76447,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14478',0.281762,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164191,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 16116','R',164191,39.45,0.18,669,76448,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006oh','SDSS J234112.48-010620.9',0.16,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,355.302,-1.10581,0.125,NULL,49451603506,772681304,12073145,NULL),(164192,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 16116','R',164192,39.74,0.1,766,76448,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006oh','SDSS J234112.48-010620.9',0.16,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164193,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 2006oh',NULL,164193,39.43,0.07,769,76448,70,NULL,'SALT 2','SDSS J234112.48-010620.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164194,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 2006oh',NULL,164194,39.44,0.07,773,76448,70,NULL,'SALT 2, Malmquist cor.','SDSS J234112.48-010620.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164195,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164195,35.46,0.8,124,76449,75,NULL,'HMCL, I','KUG 2338+252',NULL,'1997ApJS..109..333W',1997,1,0.8,NULL,'G',0.000033,NULL,'14.83',0.3,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,355.317,25.55128,0.113,NULL,51998181178,812471580,12694868,14.83),(164196,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164196,34.86,0.69,93.8,76449,100,NULL,'mid-IR','KUG 2338+252',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164197,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164197,34.96,0.43,98.3,76449,75,NULL,'3.6 micron, color + selection bias corrected','KUG 2338+252',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164198,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164198,35.29,0.43,115,76449,75,NULL,'3.6 micron, color corrected','KUG 2338+252',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164199,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164199,35.47,0.45,124,76449,NULL,NULL,'K','KUG 2338+252',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164200,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164200,35.48,0.47,125,76449,NULL,NULL,'H','KUG 2338+252',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164201,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164201,35.63,0.4,134,76449,NULL,NULL,'mean','KUG 2338+252',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164202,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164202,35.7,0.06,138,76449,NULL,NULL,NULL,'KUG 2338+252',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164203,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164203,35.71,0.2,139,76449,74.4,NULL,NULL,'KUG 2338+252',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164204,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164204,35.71,0.46,139,76449,NULL,NULL,'J','KUG 2338+252',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164205,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164205,35.78,0.4,143,76449,75,NULL,'HMCL, I, raw','KUG 2338+252',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164206,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164206,36,0.4,158,76449,75,NULL,'HMCL, I, cor','KUG 2338+252',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164207,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164207,36.04,0.4,161,76449,75,NULL,'HMCL, I, inv','KUG 2338+252',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164208,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164208,34,0.49,63,76450,75,NULL,'IR','IC 1504',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.000013,NULL,'14.27',0.5,'Sb             HII','Group member',NULL,NULL,NULL,1,355.331208333,4.01747,0.193,NULL,51591498819,806117169,12595580,14.27),(164209,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164209,34.11,0.47,66.4,76450,NULL,NULL,'H','IC 1504',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164210,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164210,34.14,0.39,67.2,76450,NULL,NULL,NULL,'IC 1504',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164211,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164211,34.14,0.45,67.3,76450,NULL,NULL,'K','IC 1504',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164212,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164212,34.14,0.2,67.3,76450,74.4,NULL,NULL,'IC 1504',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164213,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164213,34.16,0.39,67.9,76450,NULL,NULL,'Malmquist cor.','IC 1504',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164214,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164214,34.21,0.46,69.4,76450,NULL,NULL,'J','IC 1504',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164215,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164215,34.6,0.4,83.1,76450,NULL,NULL,'mean','IC 1504',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164216,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164216,36.33,0.4,184,76451,NULL,NULL,'mean','UGC 12735',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000033,NULL,'15.08',0.5,'SBa',NULL,NULL,NULL,NULL,1,355.3475417,16.15511,0.077,NULL,51668705892,807323529,12614430,15.08),(164217,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164217,36.61,0.47,210,76451,NULL,NULL,'H','UGC 12735',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164218,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164218,37.66,0.19,340,76452,70,NULL,NULL,'2MASX J23412574-1023540',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,355.357375,-10.39847,0.078,NULL,49622632492,775353632,12114900,18),(164219,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164219,35.67,0.69,136,76453,70,NULL,NULL,'2MASX J23412592-0039437',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00008,NULL,'16.1g',0.2,'Sb',NULL,NULL,NULL,NULL,1,355.3580417,-0.66222,0.097,NULL,49397255354,771832114,12059876,16.1),(164220,'Tully est','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164220,32.83,0.8,36.8,76454,75,NULL,'B','NGC 7731',NULL,'1988NBGC.C....0000T',1988,1,1.4,NULL,'G',0.000017,NULL,'13.51',1.1,'(R)SBa pec:','Pair member, near/close',NULL,NULL,NULL,1,355.371125,3.74003,0.153,NULL,51605254089,806332095,12598938,13.51),(164221,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164221,37.28,0.23,285,76455,70,NULL,NULL,'2MASX J23413068+1454262',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000169,NULL,'17.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,355.377875,14.90739,0.057,NULL,51671470788,807366731,12615105,17.5),(164222,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164222,36.27,0.46,180,76456,70,NULL,NULL,'2MASX J23413176+1407272',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,355.3822917,14.12417,0.093,NULL,51659682019,807182531,12612227,17.1),(164223,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164223,34.34,0.46,73.9,76457,NULL,NULL,'Malmquist cor.','2MASX J23413092+0904228',NULL,'2009ApJS..182..474S',2009,1,0.95,NULL,'G',0.000027,NULL,'14.37',NULL,'Sbc',NULL,NULL,NULL,NULL,1,355.3845,9.07553,0.297,NULL,51787908471,809186069,12643532,14.37),(164224,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164224,34.36,0.45,74.5,76457,NULL,NULL,NULL,'2MASX J23413092+0904228',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164225,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164225,34.4,0.2,75.9,76457,74.4,NULL,NULL,'2MASX J23413092+0904228',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164226,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13180','RN',164226,39.96,0.19,786,76458,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13180',0.251012,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164227,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13180','RN',164227,40.17,0.26,866,76458,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13180',0.251012,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164228,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164228,37.66,0.19,340,76459,70,NULL,NULL,'2MASX J23413673-1023017',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000113,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,355.403208333,-10.38383,0.078,NULL,49621941753,775342839,12114731,16.3),(164229,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164229,34.68,0.48,86.4,76460,70,NULL,NULL,'IC 1505',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.72',0.4,NULL,NULL,NULL,NULL,NULL,1,355.404625,-3.56508,0.113,NULL,49456546259,772758535,12074352,14.72),(164230,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164230,36.18,0.46,172,76461,70,NULL,NULL,'2MASX J23414086+1358435',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000163,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,355.420333,13.97889,0.093,NULL,51660258832,807191544,12612367,16.5),(164231,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 19494',NULL,164231,40.88,0.28,1500,76462,70,NULL,'SN photometric redshift distance, z photo =0.442 +/- 0.083','SDSS-II SN 19494',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,355.4364583,-0.44347,0.105,NULL,49397135422,771830240,12059847,NULL),(164232,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 19494',NULL,164232,41.71,0.25,2200,76462,70,NULL,'SALT 2','SDSS-II SN 19494',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164233,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 19494',NULL,164233,41.87,0.25,2370,76462,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19494',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164234,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164234,36.11,0.44,166,76463,NULL,NULL,'Malmquist cor.','AGC 332110',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000033,NULL,'15.6I',0.2,NULL,NULL,NULL,NULL,NULL,1,355.443333,25.71917,0.093,NULL,51998272912,812473014,12694890,15.6),(164235,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164235,36.26,0.41,178,76463,NULL,NULL,NULL,'AGC 332110',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164236,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 2006dm',NULL,164236,34.89,0.17,93.1,76464,70,NULL,'SALT 2','ARP 295A',0.022019,'2013MNRAS.433.2240G',2013,1,1.37,NULL,'G',0.000053,NULL,'14.5',0.11,'Sc       poss. LINER','Pair member (points to parent)',NULL,NULL,NULL,1,355.4470417,-3.66722,0.089,NULL,49456551174,772758612,12074353,14.5),(164237,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 18653','RN',164237,39.68,0.15,765,76465,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18653',0.127986,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164238,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 18653','RN',164238,39.94,0.25,864,76465,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18653',0.127986,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164239,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164239,37.28,0.23,285,76466,70,NULL,NULL,'2MASX J23415045+1502386',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000189,NULL,'16.2g',0.29,'S0^-',NULL,NULL,NULL,NULL,1,355.460333333,15.04386,0.057,NULL,51671395084,807365548,12615086,16.2),(164240,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 01264','RN',164240,41.88,0.11,1900,76467,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01264',0.250549,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164241,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164241,34.77,0.49,90.1,76468,70,NULL,NULL,'MCG -05-55-034',NULL,'2014MNRAS.445.2677S',2014,1,0.88,NULL,'G',0.000143,NULL,'14.94',0.5,'S',NULL,NULL,NULL,NULL,1,355.462083,-28.02469,0.059,NULL,50048426270,782006660,12218854,14.94),(164242,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164242,38.39,0.46,476,76469,70,NULL,NULL,'SDSS J234151.44-095502.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,355.464333333,-9.91725,0.079,NULL,49621291454,775332678,12114573,18.2),(164243,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164243,36.79,0.46,228,76470,70,NULL,NULL,'2MASX J23415168-0941037',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,355.4655,-9.68453,0.083,NULL,49623110858,775361107,12115017,17.3),(164244,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164244,34.16,0.8,67.9,76471,75,NULL,'W91PP, r','UGC 12741',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'14.1r',0.3,'Sa',NULL,NULL,NULL,NULL,1,355.481083,30.58175,0.273,NULL,51965786452,811965413,12686959,14.1),(164245,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164245,34.24,0.4,70.6,76471,NULL,NULL,'mean','UGC 12741',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164246,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164246,34.37,0.38,74.8,76471,75,NULL,'W91PP, r, raw','UGC 12741',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164247,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164247,34.42,0.47,76.4,76471,NULL,NULL,'H','UGC 12741',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164248,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164248,34.48,0.45,78.5,76471,NULL,NULL,'K','UGC 12741',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164249,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164249,34.52,0.46,80.1,76471,NULL,NULL,'J','UGC 12741',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164250,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164250,34.53,0.38,80.4,76471,75,NULL,'W91PP, r, inv','UGC 12741',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164251,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164251,34.58,0.38,82.4,76471,75,NULL,'W91PP, r, cor','UGC 12741',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164252,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164252,34.93,0.4,96.7,76472,NULL,NULL,'mean','ARP 295B',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000063,NULL,'14.6',0.5,'Sb pec:    HII;LIRG','Pair member (points to parent)',NULL,NULL,NULL,1,355.5035417,-3.61517,0.113,NULL,49456445547,772756961,12074327,14.6),(164253,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164253,35.15,0.45,107,76472,NULL,NULL,'K','ARP 295B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164254,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164254,35.21,0.47,110,76472,NULL,NULL,'H','ARP 295B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164255,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164255,35.34,0.46,117,76472,NULL,NULL,'J','ARP 295B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164256,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164256,35.42,0.2,121,76473,74.4,NULL,NULL,'2MASX J23420093+2559533',NULL,'2013AJ....146...86T',2013,1,0.55,NULL,'G',0.00006,NULL,'16.22',0.2,NULL,NULL,NULL,NULL,NULL,1,355.503917,25.99808,0.093,NULL,52005807352,812590739,12696730,16.22),(164257,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164257,35.55,0.11,129,76473,NULL,NULL,NULL,'2MASX J23420093+2559533',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164258,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164258,37.86,0.46,374,76474,70,NULL,NULL,'2MASX J23420103+1452567',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,355.504375,14.88244,0.057,NULL,51671007646,807359494,12614992,17.5),(164259,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164259,34.48,0.47,78.9,76475,NULL,NULL,'H','VV 480',NULL,'2007A&A...465...71T',2007,1,1.4,'HOLM 814B is a star.','G',0.00002,NULL,'14.51',1,'(R\')SB(r)b:    HII',NULL,NULL,NULL,NULL,1,355.504417,-4.21642,0.085,NULL,49445116679,772579948,12071561,14.51),(164260,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164260,34.49,0.4,79,76475,NULL,NULL,'mean','VV 480',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164261,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164261,34.64,0.46,84.8,76475,NULL,NULL,'J','VV 480',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164262,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164262,34.66,0.45,85.5,76475,NULL,NULL,'K','VV 480',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164263,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 20704',NULL,164263,38.9,0.98,602,76476,70,NULL,'SN photometric redshift distance, z photo =0.152 +/- 0.099','SDSS-II SN 20704',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.8g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,355.555666667,-0.02289,0.081,NULL,49396868440,771826069,12059782,21.8),(164264,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 20704','R',164264,40.87,0.49,1140,76476,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20704',0.314735,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164265,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 20704','R',164265,41.38,0.37,1430,76476,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20704',0.314735,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164266,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 00884','RN',164266,41.98,0.15,1890,76477,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 00884',0.318397,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164267,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 00884','RN',164267,42.52,0.27,2420,76477,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00884',0.318397,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164268,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164268,35.38,0.25,119,76478,74.4,NULL,NULL,'NGC 7735',NULL,'2013AJ....146...86T',2013,1,1.3,'The 2MASS position is 8 arcsec south of the nucleus.','G',0.00009,NULL,'14.56',0.9,'E',NULL,NULL,NULL,NULL,1,355.572125,26.23175,0.125,NULL,52005953776,812593027,12696766,14.56),(164269,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164269,35.49,0.45,125,76478,NULL,NULL,'K','NGC 7735',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164270,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164270,35.69,0.4,137,76478,NULL,NULL,'mean','NGC 7735',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164271,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164271,34.66,0.2,85.5,76479,74.4,NULL,NULL,'2MASX J23421729+2816234',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.00004,NULL,'14.88',0.2,'Sd',NULL,NULL,NULL,NULL,1,355.572125,28.27317,0.177,NULL,51995686520,812432601,12694259,14.88),(164272,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164272,35.55,0.13,129,76479,NULL,NULL,NULL,'2MASX J23421729+2816234',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164273,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13639','RN',164273,42.66,0.23,2690,76480,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13639',0.269903,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164274,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13639','RN',164274,43.02,0.24,3160,76480,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13639',0.269903,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164275,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164275,37.02,0.46,253,76481,70,NULL,NULL,'2MASX J23422162+0014383',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000073,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,355.59,0.24411,0.085,NULL,51548505209,805445393,12585084,17),(164276,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164276,34.97,0.43,98.5,76482,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 476-116',NULL,'2014MNRAS.444..527S',2014,1,0.7,NULL,'G',0.000033,NULL,'15.6',0.2,'Sb','Group member, peripheral',NULL,NULL,NULL,1,355.596333,27.33186,0.141,NULL,52006563276,812602551,12696914,15.6),(164277,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164277,35.13,0.43,106,76482,75,NULL,'3.6 micron, color corrected','CGCG 476-116',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164278,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164278,35.3,0.49,115,76482,75,NULL,'IR','CGCG 476-116',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164279,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164279,35.34,0.2,117,76482,74.4,NULL,NULL,'CGCG 476-116',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164280,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164280,34.12,0.48,66.6,76483,70,NULL,NULL,'NGC 7736',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000067,NULL,'13.87',1.5,'(R\')SA(r)0^0^?',NULL,NULL,NULL,NULL,1,355.607416667,-19.45231,0.055,NULL,50271526350,785492599,12273321,13.87),(164281,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164281,38.15,0.33,426,76484,70,NULL,NULL,'2MASX J23422679+1512514',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000174,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,355.6117917,15.21417,0.069,NULL,51673415215,807397112,12615579,18.1),(164282,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164282,37.42,0.46,305,76485,70,NULL,NULL,'2MASX J23422854+1542214',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000185,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,355.619083,15.70608,0.069,NULL,51669906467,807342288,12614723,17),(164283,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164283,34.05,0.49,64.7,76486,75,NULL,'IR','FGC 2526',NULL,'2011yCatp016004901K',2011,1,0.95,NULL,'G',0.00001,NULL,'14.30',0.13,'Sc','Group member, peripheral',NULL,NULL,NULL,1,355.629083,28.04433,0.177,NULL,51995557482,812430585,12694227,14.3),(164284,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164284,34.11,0.43,66.4,76486,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2526',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164285,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164285,34.15,0.43,67.6,76486,75,NULL,'3.6 micron, color corrected','FGC 2526',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164286,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164286,34.16,0.2,67.9,76486,74.4,NULL,NULL,'FGC 2526',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164287,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164287,34.16,0.43,68,76486,NULL,NULL,NULL,'FGC 2526',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164288,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164288,34.33,0.4,73.4,76486,NULL,NULL,'Malmquist cor.','FGC 2526',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164289,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164289,34.66,NULL,85.4,76486,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2526',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164290,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164290,34.67,NULL,85.9,76486,NULL,NULL,'Dipole + Quadrupole','FGC 2526',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164291,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164291,34.69,NULL,86.6,76486,NULL,NULL,'Dipole','FGC 2526',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164292,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164292,34.73,NULL,88.2,76486,NULL,NULL,NULL,'FGC 2526',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164293,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13629',NULL,164293,39.93,0.33,969,76487,70,NULL,'SN photometric redshift distance, z photo =0.259 +/- 0.051','SDSS-II SN 13629',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.5g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,355.6325417,-0.05253,0.081,NULL,49396903729,771826620,12059790,21.5),(164294,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13629','R',164294,41.61,0.19,1550,76487,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13629',0.353187,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164295,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13629','R',164295,41.65,0.27,1580,76487,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13629',0.353187,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164296,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13629',NULL,164296,41.1,0.15,1660,76487,70,NULL,'SALT 2','SDSS-II SN 13629',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164297,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13629',NULL,164297,41.15,0.15,1700,76487,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13629',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164298,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164298,35.31,0.49,115,76488,75,NULL,'IR','NGC 7733',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000033,NULL,'14.29',0.8,'(R\'_1)SB(s)bc  Sy2','Pair member, radial velocity confirmed',NULL,NULL,'Sy 2',1,355.637291667,-65.9565,0.029,NULL,48734968978,761483890,11898185,14.29),(164299,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164299,35.43,0.46,122,76488,NULL,NULL,'Malmquist cor.','NGC 7733',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164300,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164300,35.5,0.45,126,76488,NULL,NULL,NULL,'NGC 7733',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164301,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164301,35.55,0.2,129,76488,74.4,NULL,NULL,'NGC 7733',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164302,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164302,31.39,0.8,19,76489,75,NULL,'MAT, I','ESO 292- G 014',NULL,'1997ApJS..109..333W',1997,1,2.39,NULL,'G',0.000029,NULL,'13.94',0.24,'Scd?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,355.646833,-44.90483,NULL,NULL,50481594440,788774913,12324608,13.94),(164303,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164303,31.63,0.39,21.2,76489,73,NULL,'IR','ESO 292- G 014',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164304,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164304,31.63,0.4,21.2,76489,75,NULL,NULL,'ESO 292- G 014',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164305,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164305,31.93,0.32,24.3,76489,85,NULL,'I, raw','ESO 292- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164306,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164306,31.93,0.32,24.3,76489,85,NULL,'I, inv','ESO 292- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164307,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164307,32.01,0.4,25.2,76489,NULL,NULL,NULL,'ESO 292- G 014',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164308,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164308,32.05,0.43,25.7,76489,75,NULL,'MAT, I, raw','ESO 292- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164309,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164309,32.12,0.43,26.5,76489,75,NULL,'MAT, I, inv','ESO 292- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164310,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164310,32.22,0.49,27.8,76489,75,NULL,'IR','ESO 292- G 014',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164311,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164311,32.25,0.43,28.1,76489,75,NULL,'MAT, I, cor','ESO 292- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164312,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164312,32.69,NULL,34.5,76489,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 292- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164313,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164313,32.71,NULL,34.8,76489,NULL,NULL,'Dipole + Quadrupole','ESO 292- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164314,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164314,32.71,NULL,34.9,76489,NULL,NULL,'Dipole','ESO 292- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164315,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164315,32.84,NULL,37,76489,NULL,NULL,NULL,'ESO 292- G 014',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164316,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164316,38.15,0.33,426,76490,70,NULL,NULL,'2MASX J23424006+1512064',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000155,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,355.6667917,15.20183,0.057,NULL,51673417403,807397146,12615580,17.4),(164317,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164317,35.89,0.45,150,76491,NULL,NULL,'Malmquist cor.','2MFGC 17789',NULL,'2009ApJS..182..474S',2009,1,0.74,NULL,'G',0.000033,NULL,'15.4',NULL,'Sb','Group member',NULL,NULL,NULL,1,355.677083,8.49011,0.297,NULL,51785498832,809148419,12642944,15.4),(164318,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164318,36.01,0.42,159,76491,NULL,NULL,NULL,'2MFGC 17789',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164319,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164319,36.05,0.2,162,76491,74.4,NULL,NULL,'2MFGC 17789',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164320,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164320,36.07,0.49,164,76491,75,NULL,'IR','2MFGC 17789',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164321,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164321,34.96,0.8,98.1,76492,75,NULL,'W91PP, r','UGC 12746',NULL,'1997ApJS..109..333W',1997,1,1.36,'Karachentsev, et al. (1993,AN,314,97) dec. in error by 1\'.','G',0.000013,NULL,'15.09',0.17,'Scd','Group member, peripheral',NULL,NULL,NULL,1,355.6939583,27.29728,0.137,NULL,52006553952,812602405,12696912,15.09),(164322,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164322,34.96,0.8,98.1,76492,75,NULL,'W91CL, r','UGC 12746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164323,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164323,34.96,0.8,98.2,76492,75,NULL,'HMCL, I','UGC 12746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164324,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164324,34.97,0.8,98.5,76492,75,NULL,'CF, r','UGC 12746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164325,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164325,34.5,0.38,79.5,76492,75,NULL,'CF, r, raw','UGC 12746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164326,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164326,34.64,0.38,84.8,76492,75,NULL,'CF, r, inv','UGC 12746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164327,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164327,34.72,0.49,88.1,76492,75,NULL,'IR','UGC 12746',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164328,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164328,34.74,0.38,88.9,76492,75,NULL,'CF, r, cor','UGC 12746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164329,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164329,34.76,0.38,89.6,76492,75,NULL,'W91PP, r, raw','UGC 12746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164330,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164330,34.88,0.4,94.5,76492,75,NULL,'HMCL, I, raw','UGC 12746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164331,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164331,34.95,0.38,97.9,76492,75,NULL,'W91PP, r, inv','UGC 12746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164332,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164332,34.98,0.39,99.2,76492,NULL,NULL,'Malmquist cor.','UGC 12746',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164333,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164333,34.98,0.38,99.3,76492,75,NULL,'W91PP, r, cor','UGC 12746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164334,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164334,34.99,0.38,99.4,76492,75,NULL,'W91CL, r, raw','UGC 12746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164335,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164335,35.01,0.39,100,76492,NULL,NULL,NULL,'UGC 12746',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164336,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164336,35,0.47,100,76492,NULL,NULL,'H','UGC 12746',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164337,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164337,35.02,0.45,101,76492,NULL,NULL,'K','UGC 12746',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164338,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164338,35.06,0.4,103,76492,NULL,NULL,'mean','UGC 12746',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164339,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164339,35.09,0.4,104,76492,75,NULL,'HMCL, I, inv','UGC 12746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164340,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164340,35.12,0.4,105,76492,75,NULL,'HMCL, I, cor','UGC 12746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164341,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164341,35.15,0.2,107,76492,74.4,NULL,NULL,'UGC 12746',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164342,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164342,35.17,0.38,108,76492,75,NULL,'W91CL, r, inv','UGC 12746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164343,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164343,35.2,0.38,110,76492,75,NULL,'W91CL, r, cor','UGC 12746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164344,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164344,35.26,0.46,112,76492,NULL,NULL,'J','UGC 12746',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164345,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164345,35.39,NULL,119,76492,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12746',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164346,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164346,35.4,NULL,120,76492,NULL,NULL,'Dipole + Quadrupole','UGC 12746',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164347,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164347,35.41,NULL,121,76492,NULL,NULL,'Dipole','UGC 12746',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164348,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164348,35.45,NULL,123,76492,NULL,NULL,NULL,'UGC 12746',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164349,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164349,37.28,0.23,285,76493,70,NULL,NULL,'2MASX J23424675+1506530',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000178,NULL,'16.1g',0.39,'E0',NULL,NULL,NULL,NULL,1,355.694708333,15.11472,0.057,NULL,51673427636,807397306,12615582,16.1),(164350,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164350,37.28,0.23,285,76494,70,NULL,NULL,'2MASX J23424764+1503380',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,355.6985417,15.0605,0.057,NULL,51673637823,807400590,12615634,17.2),(164351,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164351,34.3,0.49,72.3,76495,75,NULL,'IR','2MFGC 17792',NULL,'2011yCatp016004901K',2011,1,0.7,NULL,'G',0.00004,NULL,'14.80',0.24,'Sc',NULL,NULL,NULL,NULL,1,355.7075,27.12039,0.137,NULL,52009184727,812643511,12697554,14.8),(164352,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164352,34.65,0.55,85.2,76495,NULL,NULL,NULL,'2MFGC 17792',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164353,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164353,34.69,0.2,86.7,76495,74.4,NULL,NULL,'2MFGC 17792',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164354,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164354,34.81,0.51,91.8,76495,NULL,NULL,'Malmquist cor.','2MFGC 17792',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164355,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164355,35.08,0.2,104,76496,74.4,NULL,NULL,'KUG 2340+144',NULL,'2013AJ....146...86T',2013,1,0.71,NULL,'G',0.000154,NULL,'15.7g',0.31,'Spiral',NULL,NULL,NULL,NULL,1,355.729583,14.75478,0.057,NULL,51672949582,807389837,12615466,15.7),(164356,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164356,36.9,0.46,240,76497,70,NULL,NULL,'2MASX J23425621-0850548',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,355.734125,-8.84858,0.089,NULL,49626236609,775409947,12115780,17.7),(164357,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164357,35.27,0.48,113,76498,70,NULL,NULL,'MCG -01-60-024',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000093,NULL,'15.5',0.3,NULL,NULL,NULL,NULL,NULL,1,355.73425,-3.65044,0.073,NULL,49456426848,772756669,12074322,15.5),(164358,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164358,35.79,0.64,144,76499,70,NULL,NULL,'2MASX J23430186-4658378',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.47',0.27,NULL,NULL,NULL,NULL,NULL,1,355.75775,-46.97711,NULL,NULL,48587875225,759185550,11862274,16.47),(164359,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 20553',NULL,164359,38.69,1.51,547,76500,70,NULL,'SN photometric redshift distance, z photo =0.137 +/- 0.163','SDSS-II SN 20553',NULL,'2011ApJ...738..162S',2011,1,0.19,NULL,'G',NULL,'PHOT','21.5g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,355.792333,-0.33122,0.085,NULL,49399743456,771870991,12060484,21.5),(164360,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 20553','R',164360,41.44,0.27,1440,76500,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20553',0.348806,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164361,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 20553','R',164361,41.7,0.23,1620,76500,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20553',0.348806,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164362,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 20553',NULL,164362,41.35,0.17,1860,76500,70,NULL,'SALT 2','SDSS-II SN 20553',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164363,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 20553',NULL,164363,41.4,0.17,1910,76500,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20553',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164364,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164364,36.99,0.46,250,76501,70,NULL,NULL,'2MASX J23431196-0859161',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,355.7997917,-8.98772,0.07,NULL,49626326740,775411355,12115802,16.5),(164365,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164365,36.6,0.66,209,76502,70,NULL,NULL,'2MASX J23431265-3622203',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.86',0.28,NULL,NULL,NULL,NULL,NULL,1,355.80275,-36.37231,NULL,NULL,49951975966,780499624,12195306,16.86),(164366,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164366,36.04,0.38,162,76503,NULL,NULL,NULL,'AGC 331612',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.00003,NULL,'17.1',NULL,'Sc','Group member',NULL,NULL,NULL,1,355.8075,8.58139,0.309,NULL,51788658422,809197787,12643715,17.1),(164367,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164367,36.08,0.2,164,76503,74.4,NULL,NULL,'AGC 331612',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164368,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164368,36.18,0.36,172,76503,NULL,NULL,'Malmquist cor.','AGC 331612',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164369,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164369,35.15,0.49,107,76504,75,NULL,'IR','FGC 2530',NULL,'2011yCatp016004901K',2011,1,1.21,NULL,'G',NULL,NULL,'16.17',0.13,'Scd',NULL,NULL,NULL,NULL,1,355.8095417,23.51197,0.093,NULL,51952391308,811756114,12683689,16.17),(164370,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164370,35.32,NULL,116,76504,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2530',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164371,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164371,35.34,NULL,117,76504,NULL,NULL,'Dipole','FGC 2530',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164372,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164372,35.34,NULL,117,76504,NULL,NULL,'Dipole + Quadrupole','FGC 2530',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164373,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164373,35.37,0.47,119,76505,NULL,NULL,'H','UGC 12750',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000057,NULL,'14.10',0.8,'Sa',NULL,NULL,NULL,NULL,1,355.811,49.97953,0.953,NULL,53155496879,830554638,12977416,14.1),(164374,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164374,35.38,0.45,119,76505,NULL,NULL,'K','UGC 12750',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164375,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164375,35.43,0.4,122,76505,NULL,NULL,'mean','UGC 12750',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164376,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164376,35.47,0.46,124,76505,NULL,NULL,'J','UGC 12750',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164377,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164377,34.85,0.5,93.2,76506,70,NULL,NULL,'ESO 028- G 001',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'14.64',1,'SAB(s)b',NULL,NULL,NULL,NULL,1,355.821,-72.57078,0.113,NULL,48397542417,756211600,11815806,14.64),(164378,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164378,36.72,0.45,221,76507,NULL,NULL,'Malmquist cor.','2MASX J23431734+2723396',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',NULL,NULL,'14.3I',0.2,NULL,NULL,NULL,NULL,NULL,1,355.822333,27.39428,0.165,NULL,52007026478,812609788,12697027,14.3),(164379,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164379,37.02,0.39,253,76507,NULL,NULL,NULL,'2MASX J23431734+2723396',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164380,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164380,37.18,0.2,273,76507,74.4,NULL,NULL,'2MASX J23431734+2723396',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164381,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 19793','R',164381,40.88,0.39,1080,76508,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 19793',0.38694,'2014arXiv1401.3317S',2014,1,0.03,NULL,'G',NULL,'PHOT','22.4g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,355.826125,0.25725,0.089,NULL,51551704348,805495380,12585865,22.4),(164382,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 19793','R',164382,40.94,0.36,1110,76508,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 19793',0.38694,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164383,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 19793',NULL,164383,40.75,0.35,1410,76508,70,NULL,'SN photometric redshift distance, z photo =0.408 +/- 0.097','SDSS-II SN 19793',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164384,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15182','RN',164384,40.03,0.36,888,76509,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15182',0.14298,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164385,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15182','RN',164385,40.97,0.36,1370,76509,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15182',0.14298,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164386,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164386,37.9,0.46,380,76510,70,NULL,NULL,'2MASX J23432447-0945531',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,355.852041667,-9.76464,0.076,NULL,49626718461,775417475,12115898,17.4),(164387,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164387,38.36,0.46,469,76511,70,NULL,NULL,'2MASX J23432536-0957201',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00015,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,355.855625,-9.9555,0.084,NULL,49624421256,775381582,12115337,16.7),(164388,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164388,36.59,0.6,208,76512,70,NULL,NULL,'2MASX J23432775-2905250',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'16.20',0.28,NULL,NULL,NULL,NULL,NULL,1,355.865583333,-29.09028,0.052,NULL,50041153666,781893026,12217078,16.2),(164389,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164389,35.84,0.47,147,76513,NULL,NULL,'H','UGC 12753',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.00003,NULL,'14.40',1.4,'SAB(r)bc',NULL,NULL,NULL,NULL,1,355.8697083,13.20967,0.133,NULL,51658863578,807169743,12612027,14.4),(164390,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164390,35.93,0.45,154,76513,NULL,NULL,'K','UGC 12753',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164391,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164391,36.02,0.46,160,76513,NULL,NULL,'J','UGC 12753',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164392,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164392,36.09,0.4,165,76513,NULL,NULL,'mean','UGC 12753',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164393,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164393,37.29,0.46,287,76514,70,NULL,NULL,'2MASX J23433474+0034036',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000103,NULL,'16.1g',0.31,'E0',NULL,NULL,NULL,NULL,1,355.894917,0.56781,0.073,NULL,51551860080,805497813,12585903,16.1),(164394,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 20680','RN',164394,43.49,0.3,2970,76515,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20680',0.674983,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164395,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164395,36.99,0.46,250,76516,70,NULL,NULL,'2MASX J23433781+1428407',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000155,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,355.9077083,14.47781,0.081,NULL,51672288168,807379502,12615304,17.1),(164396,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164396,36.25,0.5,178,76517,70,NULL,NULL,'ESO 408- G 020',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000093,NULL,'15.39',0.4,'S?',NULL,NULL,NULL,NULL,1,355.917375,-36.536,NULL,NULL,49951102416,780485975,12195093,15.39),(164397,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164397,37.44,0.46,307,76518,70,NULL,NULL,'2MASX J23434223+1546284',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000143,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,355.92575,15.77447,0.061,NULL,51670134255,807345847,12614778,18),(164398,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164398,34.7,0.64,87.1,76519,70,NULL,NULL,'2MASX J23434247-0634060',NULL,'2014MNRAS.445.2677S',2014,1,0.84,NULL,'G',0.000143,NULL,'15.28',0.6,NULL,NULL,NULL,NULL,NULL,1,355.9269583,-6.56831,0.075,NULL,49437905717,772467276,12069801,15.28),(164399,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15769','RN',164399,41.46,0.32,1660,76520,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15769',0.18066,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164400,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15769','RN',164400,42.04,0.48,2160,76520,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15769',0.18066,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164401,'TRGB','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164401,27.9,0.35,3.8,76521,NULL,NULL,NULL,'UGCA 442',NULL,'2005AJ....129..698M',2005,1,6.38,NULL,'G',0.000007,NULL,'13.5B',0.9,'SB(s)m: sp','Group member',NULL,NULL,NULL,1,355.9397917,-31.95678,NULL,NULL,50179551219,784055487,12250866,13.5),(164402,'TRGB','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164402,28.15,0.27,4.27,76521,NULL,NULL,NULL,'UGCA 442',NULL,'2003A&A...404...93K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164403,'TRGB','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164403,28.2,0.1,4.37,76521,74.4,NULL,NULL,'UGCA 442',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164404,'TRGB','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164404,28.32,NULL,4.61,76521,NULL,NULL,'I','UGCA 442',NULL,'2006ARep...50..517T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164405,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164405,28.3,0.8,4.57,76521,75,NULL,'MAT, I','UGCA 442',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164406,'Tully est','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164406,27.6,0.8,3.3,76521,75,NULL,NULL,'UGCA 442',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164407,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164407,28.58,0.32,5.24,76521,85,NULL,'I, inv','UGCA 442',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164408,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164408,28.7,NULL,5.49,76521,NULL,NULL,'Dipole + Quadrupole + Octopole','UGCA 442',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164409,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164409,28.7,0.32,5.49,76521,85,NULL,'I, raw','UGCA 442',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164410,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164410,28.74,NULL,5.59,76521,NULL,NULL,'Dipole + Quadrupole','UGCA 442',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164411,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164411,28.75,NULL,5.63,76521,NULL,NULL,'Dipole','UGCA 442',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164412,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164412,28.85,NULL,5.9,76521,NULL,NULL,NULL,'UGCA 442',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164413,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164413,29.22,0.43,6.99,76521,75,NULL,'MAT, I, inv','UGCA 442',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164414,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164414,29.49,0.43,7.92,76521,75,NULL,'MAT, I, raw','UGCA 442',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164415,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164415,29.82,0.43,9.19,76521,75,NULL,'MAT, I, cor','UGCA 442',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164416,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15603',NULL,164416,36.76,1.43,225,76522,70,NULL,'SN photometric redshift distance, z photo =0.054 +/- 0.053','SDSS-II SN 15603',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.6g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,355.942417,-1.19217,0.121,NULL,49400205673,771878213,12060597,21.6),(164417,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15603','R',164417,40.44,0.25,968,76522,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15603',0.262587,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164418,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15603','R',164418,40.54,0.2,1010,76522,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15603',0.262587,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164419,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15603',NULL,164419,40.24,0.14,1120,76522,70,NULL,'SALT 2','SDSS-II SN 15603',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164420,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15603',NULL,164420,40.26,0.14,1130,76522,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15603',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164421,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164421,35.18,0.54,109,76523,70,NULL,NULL,'ESO 192- G 016',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.56',0.6,'(R\'_1)SB(s)0^+',NULL,NULL,NULL,NULL,1,355.9452083,-53.04442,0,NULL,48633811305,759903301,11873489,15.56),(164422,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164422,37.7,0.46,347,76524,70,NULL,NULL,'2MASX J23434712+0042214',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000093,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,355.946333,0.70589,0.061,NULL,51551932450,805498944,12585921,16.8),(164423,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164423,35.85,0.4,148,76525,NULL,NULL,'Malmquist cor.','ESO 408- G 021',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.83',0.6,'SAB(r)bc',NULL,NULL,NULL,NULL,1,355.947833333,-36.71361,NULL,NULL,49951261910,780488467,12195132,14.83),(164424,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164424,36.06,0.36,163,76525,NULL,NULL,NULL,'ESO 408- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164425,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164425,36.1,0.2,166,76525,74.4,NULL,NULL,'ESO 408- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164426,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164426,35.32,0.8,116,76526,75,NULL,'W91PP, r','UGC 12755',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00002,NULL,'14.63',0.9,'SBb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,355.956833,28.33922,0.205,NULL,51994911340,812420489,12694070,14.63),(164427,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164427,35.32,0.8,116,76526,75,NULL,'W91CL, r','UGC 12755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164428,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164428,35.32,0.8,116,76526,75,NULL,'CF, r','UGC 12755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164429,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164429,35.32,0.8,116,76526,75,NULL,'HMCL, I','UGC 12755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164430,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164430,34.72,0.69,87.7,76526,100,NULL,'mid-IR','UGC 12755',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164431,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164431,35.27,0.38,113,76526,75,NULL,'CF, r, raw','UGC 12755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164432,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164432,35.35,0.38,117,76526,75,NULL,'W91PP, r, raw','UGC 12755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164433,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164433,35.35,0.4,117,76526,75,NULL,'HMCL, I, raw','UGC 12755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164434,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164434,35.38,0.38,119,76526,75,NULL,'W91CL, r, raw','UGC 12755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164435,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164435,35.46,0.38,124,76526,75,NULL,'CF, r, cor','UGC 12755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164436,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164436,35.49,0.4,126,76526,NULL,NULL,'mean','UGC 12755',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164437,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164437,35.5,0.38,126,76526,75,NULL,'CF, r, inv','UGC 12755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164438,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164438,35.54,0.38,128,76526,75,NULL,'W91PP, r, cor','UGC 12755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164439,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164439,35.56,0.4,129,76526,75,NULL,'HMCL, I, cor','UGC 12755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164440,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164440,35.6,0.47,132,76526,NULL,NULL,'H','UGC 12755',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164441,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164441,35.61,0.38,132,76526,75,NULL,'W91CL, r, cor','UGC 12755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164442,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164442,35.62,0.4,133,76526,75,NULL,'HMCL, I, inv','UGC 12755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164443,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164443,35.62,0.38,133,76526,75,NULL,'W91CL, r, inv','UGC 12755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164444,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164444,35.65,0.38,135,76526,75,NULL,'W91PP, r, inv','UGC 12755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164445,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164445,35.66,0.45,135,76526,NULL,NULL,'K','UGC 12755',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164446,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164446,35.68,0.46,137,76526,NULL,NULL,'J','UGC 12755',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164447,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164447,35.72,0.2,139,76526,74.4,NULL,NULL,'UGC 12755',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164448,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164448,35.77,0.08,143,76526,NULL,NULL,NULL,'UGC 12755',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164449,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164449,35.87,0.43,149,76526,75,NULL,'3.6 micron, color corrected','UGC 12755',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164450,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164450,36.17,0.43,172,76526,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12755',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164451,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 14479','RN',164451,42.3,0.28,2400,76527,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 14479',0.197681,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164452,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 14479','RN',164452,42.96,0.24,3260,76527,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 14479',0.197681,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164453,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164453,37.52,0.46,318,76528,70,NULL,NULL,'2MASXi J2343534-011407',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000057,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,355.9729583,-1.23553,0.121,NULL,49400225973,771878530,12060602,17.8),(164454,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164454,30.42,0.8,12.1,76529,75,NULL,'W91PP, r','NGC 7741',NULL,'1997ApJS..109..333W',1997,1,4.4,'The 2MASS position is 5 arcsec west of the bar\'s optical peak.','G',0.000001,NULL,'11.84',3,'SB(s)cd        HII','Pair member (points to parent)',NULL,NULL,NULL,1,355.9765417,26.07561,0.137,NULL,52006086059,812595094,12696798,11.84),(164455,'Sosies','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164455,30.5,0.39,12.6,76529,NULL,NULL,NULL,'NGC 7741',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164456,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164456,30.45,0.4,12.3,76529,75,NULL,'B','NGC 7741',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164457,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164457,30.5,0.4,12.6,76529,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 3 galaxy group','NGC 7741',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164458,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164458,30.55,NULL,12.9,76529,NULL,NULL,'LEDA [April 2006]','NGC 7741',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164459,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164459,30.66,0.2,13.6,76529,74.4,NULL,NULL,'NGC 7741',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164460,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164460,30.7,0.43,13.8,76529,75,NULL,'3.6 micron, color corrected','NGC 7741',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164461,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164461,30.75,0.43,14.1,76529,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7741',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164462,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164462,30.9,0.36,15.1,76529,NULL,NULL,NULL,'NGC 7741',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164463,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164463,30.89,0.39,15.1,76529,73,NULL,'opt','NGC 7741',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164464,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164464,31.01,0.38,15.9,76529,75,NULL,'W91PP, r, raw','NGC 7741',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164465,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164465,31.02,0.38,16,76529,75,NULL,'W91PP, r, inv','NGC 7741',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164466,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164466,31.21,0.38,17.5,76529,75,NULL,'W91PP, r, cor','NGC 7741',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164467,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164467,35.19,0.33,109,76530,70,NULL,NULL,'CGCG 381-031',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000074,NULL,'15.6g',0.16,'E0',NULL,NULL,NULL,NULL,1,355.983167,0.21808,0.073,NULL,51551691127,805495173,12585862,15.6),(164468,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164468,38.31,0.46,459,76531,70,NULL,NULL,'2MASX J23435622+1546004',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,355.984417,15.76669,0.061,NULL,51670127694,807345745,12614777,18.2),(164469,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164469,37.93,0.46,386,76532,70,NULL,NULL,'2MASX J23435737-0957009',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000193,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,355.9889583,-9.95036,0.084,NULL,49624416636,775381509,12115336,16.8),(164470,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164470,34.59,0.49,82.9,76533,75,NULL,'IR','NGC 7738',NULL,'2011yCatp016004901K',2011,1,1.97,'The NGC identification is very uncertain.','G',0.00004,NULL,'13.9g',0.63,'SB(rs)b',NULL,NULL,NULL,NULL,1,356.008583333,0.51664,0.061,NULL,51551922513,805498789,12585918,13.9),(164471,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 04217','RN',164471,43.59,0.27,3740,76534,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04217',0.398114,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164472,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 04217','RN',164472,43.81,0.33,4130,76534,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04217',0.398114,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164473,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 17842','RN',164473,39.07,0.24,581,76535,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 17842',0.124916,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164474,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 17842','RN',164474,40.17,0.32,962,76535,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 17842',0.124916,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164475,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13476',NULL,164475,39.92,0.29,963,76536,70,NULL,'SN photometric redshift distance, z photo =0.257 +/- 0.043','SDSS-II SN 13476',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,356.016583,-0.79097,0.109,NULL,49400306249,771879785,12060621,NULL),(164476,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13476','R',164476,40.87,0.16,1170,76536,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13476',0.27572,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164477,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13476','R',164477,40.97,0.24,1220,76536,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13476',0.27572,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164478,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13476',NULL,164478,40.84,0.13,1470,76536,70,NULL,'SALT 2','SDSS-II SN 13476',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164479,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13476',NULL,164479,40.86,0.13,1490,76536,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13476',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164480,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164480,32.12,0.8,26.5,76537,75,NULL,'MAT, I','MCG -01-60-026',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.00001,NULL,'13.75',1.1,'SB(s)c pec:    HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,356.043833333,-6.16964,0.075,NULL,49437732122,772464564,12069758,13.75),(164481,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164481,31.62,0.43,21.1,76537,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-60-026',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164482,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164482,31.68,0.2,21.7,76537,74.4,NULL,NULL,'MCG -01-60-026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164483,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164483,31.68,0.43,21.7,76537,75,NULL,'3.6 micron, color corrected','MCG -01-60-026',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164484,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164484,31.77,0.66,22.6,76537,NULL,NULL,'Malmquist cor.','MCG -01-60-026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164485,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164485,31.82,0.65,23.1,76537,NULL,NULL,NULL,'MCG -01-60-026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164486,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164486,31.86,0.4,23.6,76537,NULL,NULL,NULL,'MCG -01-60-026',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164487,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164487,31.86,0.39,23.6,76537,73,NULL,'opt','MCG -01-60-026',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164488,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164488,31.91,0.32,24.1,76537,85,NULL,'I, inv','MCG -01-60-026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164489,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164489,31.93,0.32,24.3,76537,85,NULL,'I, raw','MCG -01-60-026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164490,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164490,32.47,0.43,31.2,76537,75,NULL,'MAT, I, raw','MCG -01-60-026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164491,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164491,32.49,0.43,31.5,76537,75,NULL,'MAT, I, inv','MCG -01-60-026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164492,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164492,32.74,0.43,35.3,76537,75,NULL,'MAT, I, cor','MCG -01-60-026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164493,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 03517','RN',164493,40.51,0.13,1140,76538,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 03517',0.11337,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164494,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 03517','RN',164494,40.89,0.22,1350,76538,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 03517',0.11337,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164495,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164495,37.34,0.46,294,76539,70,NULL,NULL,'2MASX J23441201+1604166',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,356.050167,16.07144,0.065,NULL,51670051143,807344549,12614758,17.6),(164496,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164496,34.53,0.2,80.5,76540,74.4,NULL,NULL,'FGC 2532',NULL,'2013AJ....146...86T',2013,1,0.85,NULL,'G',0.000014,NULL,'16.7',0.1,'Scd','Group member, peripheral',NULL,NULL,NULL,1,356.055,28.27194,0.205,NULL,51994840200,812419378,12694052,16.7),(164497,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164497,34.69,0.48,86.8,76540,NULL,NULL,NULL,'FGC 2532',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164498,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164498,34.77,NULL,90,76540,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2532',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164499,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164499,34.77,NULL,90,76540,NULL,NULL,'Dipole + Quadrupole','FGC 2532',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164500,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164500,34.79,NULL,90.7,76540,NULL,NULL,'Dipole','FGC 2532',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164501,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164501,34.81,0.46,91.6,76540,NULL,NULL,'Malmquist cor.','FGC 2532',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164502,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164502,34.84,NULL,92.9,76540,NULL,NULL,NULL,'FGC 2532',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164503,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164503,37.83,0.46,369,76541,70,NULL,NULL,'2MASX J23441517-1005595',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000179,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,356.06325,-10.09975,0.089,NULL,49624602284,775384410,12115381,16.5),(164504,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164504,37.94,0.7,387,76542,70,NULL,NULL,'2MASXi J2344152-233149',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'17.44',0.26,NULL,NULL,NULL,NULL,NULL,1,356.063375,-23.53058,0.038,NULL,50003223428,781300366,12207818,17.44),(164505,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164505,33.72,0.8,55.5,76543,75,NULL,'MAT, I','ESO 012- G 004',NULL,'1997ApJS..109..333W',1997,1,2.46,NULL,'G',0.000033,NULL,'15.28',0.24,'Sbc',NULL,NULL,NULL,NULL,1,356.064625,-80.177,0.353,NULL,48338647577,755291368,11801427,15.28),(164506,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164506,33.65,0.49,53.7,76543,75,NULL,'IR','ESO 012- G 004',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164507,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164507,33.69,0.47,54.7,76543,NULL,NULL,'H','ESO 012- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164508,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164508,33.95,0.45,61.7,76543,NULL,NULL,'K','ESO 012- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164509,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164509,33.98,0.4,62.5,76543,NULL,NULL,'mean','ESO 012- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164510,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164510,34.02,0.43,63.7,76543,75,NULL,'MAT, I, raw','ESO 012- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164511,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164511,34.09,0.46,65.8,76543,NULL,NULL,'J','ESO 012- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164512,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164512,34.15,0.32,67.7,76543,85,NULL,'I, raw','ESO 012- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164513,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164513,34.2,0.32,69.2,76543,85,NULL,'I, inv','ESO 012- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164514,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164514,34.22,0.43,69.9,76543,75,NULL,'MAT, I, cor','ESO 012- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164515,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164515,34.23,0.43,70.2,76543,75,NULL,'MAT, I, inv','ESO 012- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164516,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164516,34.43,NULL,76.8,76543,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 012- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164517,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164517,34.43,NULL,77,76543,NULL,NULL,'Dipole + Quadrupole','ESO 012- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164518,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164518,34.44,NULL,77.1,76543,NULL,NULL,'Dipole','ESO 012- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164519,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164519,34.53,NULL,80.4,76543,NULL,NULL,NULL,'ESO 012- G 004',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164520,'Ring Diameter','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164520,34.1,0.84,66,76544,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7742',NULL,'1981ApJS...45..541P',1981,1,1.7,NULL,'G',0.000003,NULL,'12.35',1.7,'SA(r)b;LINER   HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,356.065541667,10.76708,0.101,NULL,51781810497,809090789,12642043,12.35),(164521,'Tully est','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164521,31.73,0.8,22.2,76544,75,NULL,'B','NGC 7742',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164522,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164522,36.22,0.23,175,76545,74.4,NULL,NULL,'GIN 734',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000047,NULL,'14.7V',0.6,'E/S0','Group member',NULL,NULL,NULL,1,356.067083333,9.04897,0.221,NULL,51790857191,809232143,12644252,14.7),(164523,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164523,36.5,0.2,199,76545,70,NULL,NULL,'GIN 734',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164524,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164524,36.14,0.4,169,76545,NULL,NULL,'mean','GIN 734',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164525,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164525,36.66,0.45,215,76545,NULL,NULL,'K','GIN 734',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164526,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164526,37.05,0.46,257,76546,70,NULL,NULL,'2MASX J23441950-0954245',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00015,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,356.081375,-9.90689,0.087,NULL,49626593869,775415529,12115867,16.6),(164527,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 05686','RN',164527,40.47,0.3,982,76547,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 05686',0.263788,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164528,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 05686','RN',164528,41.36,0.32,1480,76547,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 05686',0.263788,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164529,'SBF','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164529,31.42,0.17,19.2,76548,NULL,NULL,'I','NGC 7743',NULL,'2003ApJ...583..712J',2003,1,3,NULL,'G',0.000017,NULL,'12.38',2.6,'(R)SB(s)0+     Sy2','in a radial-velocity based grouping',NULL,NULL,'Sy 2',1,356.088083,9.93408,0.173,NULL,51789530252,809211410,12643928,12.38),(164530,'SBF','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164530,31.54,0.14,20.3,76548,74.4,NULL,NULL,'NGC 7743',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164531,'SBF','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164531,31.58,0.17,20.7,76548,NULL,NULL,'I','NGC 7743',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164532,'Tully est','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164532,31.93,0.8,24.4,76548,75,NULL,'B','NGC 7743',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164533,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164533,36.25,0.25,178,76549,74.4,NULL,NULL,'CGCG 407-048 NED01',NULL,'2013AJ....146...86T',2013,1,0.15,NULL,'G',0.00005,NULL,'14.8V',0.1,'Ep','Group member',NULL,NULL,'Flat-Spectrum Radio Source',1,356.102083,9.16461,0.221,NULL,51790839616,809231869,12644247,14.8),(164534,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164534,36.5,0.2,199,76549,70,NULL,NULL,'CGCG 407-048 NED01',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164535,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 16405','R',164535,40.54,0.15,1010,76550,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J234424.87+002204.4',0.2754,'2014arXiv1401.3317S',2014,1,0.12,NULL,'G',0.01,NULL,'19.8g',0.08,NULL,NULL,NULL,NULL,NULL,1,356.103625,0.36789,0.061,NULL,51551898980,805498421,12585912,19.8),(164536,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 16405','R',164536,40.59,0.23,1030,76550,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J234424.87+002204.4',0.2754,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164537,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 16405',NULL,164537,40.48,0.13,1250,76550,70,NULL,'SALT 2','SDSS J234424.87+002204.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164538,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 16405',NULL,164538,40.5,0.13,1260,76550,70,NULL,'SALT 2, Malmquist cor.','SDSS J234424.87+002204.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164539,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15137','R',164539,40.8,0.22,1130,76551,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15137',0.278904,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,356.1072917,-0.80658,0.109,NULL,49400292699,771879573,12060618,NULL),(164540,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15137','R',164540,41.07,0.17,1280,76551,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15137',0.278904,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164541,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15137',NULL,164541,40.54,0.09,1280,76551,70,NULL,'SN photometric redshift distance, z photo =0.361 +/- 0.019','SDSS-II SN 15137',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164542,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15137',NULL,164542,40.72,0.13,1390,76551,70,NULL,'SALT 2','SDSS-II SN 15137',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164543,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15137',NULL,164543,40.75,0.13,1410,76551,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15137',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164544,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 14876','RN',164544,41.94,0.45,1910,76552,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14876',0.280067,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164545,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 14876','RN',164545,42,0.27,1960,76552,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14876',0.280067,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164546,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164546,35.19,0.2,109,76553,74.4,NULL,NULL,'CGCG 407-049',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000107,NULL,'15.02',0.6,'Sa','Isolated galaxy',NULL,NULL,NULL,1,356.114917,5.66389,0.317,NULL,51562250422,805660162,12588440,15.02),(164547,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164547,36.5,0.2,199,76554,70,NULL,NULL,'GIN 732',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.000028,NULL,'15.8V',NULL,'E','Group member',NULL,NULL,NULL,1,356.1155,9.26697,0.221,NULL,51791104598,809236009,12644312,15.8),(164548,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164548,35.5,0.5,126,76555,70,NULL,NULL,'6dF J2344286-355502',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,356.1192083,-35.91717,NULL,NULL,49951322202,780489409,12195147,14.7),(164549,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164549,35.19,0.33,109,76556,70,NULL,NULL,'NGC 7739',NULL,'2015arXiv151105856S',2015,1,0.8,'The NGC identification is very uncertain.','G',0.000111,NULL,'14.7g',0.73,'E+:',NULL,NULL,NULL,NULL,1,356.125333,0.32047,0.061,NULL,51549602389,805462537,12585352,14.7),(164550,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164550,36.01,0.23,159,76557,74.4,NULL,NULL,'CGCG 407-050',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.00004,NULL,'14.8V',0.5,'E/S0;BrClG','Group member',NULL,NULL,NULL,1,356.1267083,9.26406,0.221,NULL,51791115569,809236180,12644315,14.8),(164551,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164551,36.24,0.23,177,76557,74.4,NULL,NULL,'CGCG 407-050',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164552,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164552,36.5,0.2,199,76557,70,NULL,NULL,'CGCG 407-050',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164553,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164553,36.18,0.59,173,76558,70,NULL,NULL,'2MASX J23443124-2806335',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.55',0.37,NULL,NULL,NULL,NULL,NULL,1,356.1302083,-28.10931,0.064,NULL,50061295656,782207744,12221996,16.55),(164554,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164554,34.21,0.8,69.5,76559,75,NULL,'W91PP, r','UGC 12762',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',NULL,NULL,'15.26',0.6,'S?',NULL,NULL,NULL,NULL,1,356.1340417,21.94247,0.137,NULL,52494827061,820231672,12816119,15.26),(164555,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164555,33.47,0.2,49.4,76559,74.4,NULL,NULL,'UGC 12762',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164556,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164556,33.66,0.36,53.9,76559,NULL,NULL,NULL,'UGC 12762',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164557,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164557,33.95,0.32,61.7,76559,NULL,NULL,'Malmquist cor.','UGC 12762',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164558,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164558,34.1,0.38,66,76559,75,NULL,'W91PP, r, raw','UGC 12762',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164559,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164559,34.11,0.38,66.5,76559,75,NULL,'W91PP, r, inv','UGC 12762',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164560,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164560,34.31,0.38,72.9,76559,75,NULL,'W91PP, r, cor','UGC 12762',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164561,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 12206','RN',164561,40.95,0.39,1140,76560,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 12206',0.359815,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164562,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 03611','RN',164562,41.17,0.09,1570,76561,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 03611',0.092944,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164563,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 03611','RN',164563,41.33,0.2,1690,76561,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 03611',0.092944,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164564,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164564,38.28,0.46,452,76562,70,NULL,NULL,'2MASX J23443473+1535448',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,356.144583,15.59578,0.061,NULL,51673439154,807397486,12615585,18.1),(164565,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164565,38.27,0.46,450,76563,70,NULL,NULL,'SDSS J234435.55-100441.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00017,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,356.148166667,-10.07814,0.099,NULL,49624605024,775384453,12115382,18.6),(164566,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164566,38.29,0.46,455,76564,70,NULL,NULL,'SDSS J234437.60+144032.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,356.156667,14.67578,0.069,NULL,51672445202,807381956,12615343,18.3),(164567,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 02354','RN',164567,41.75,0.18,1430,76565,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02354',0.56549,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164568,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164568,30.78,0.76,14.3,76566,NULL,NULL,NULL,'UGC 12764',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',NULL,NULL,'15.27',0.8,'Scd:',NULL,NULL,NULL,NULL,1,356.1625,22.01111,0.137,NULL,52494820315,820231567,12816118,15.27),(164569,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164569,31.18,0.63,17.3,76566,NULL,NULL,'Malmquist cor.','UGC 12764',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164570,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164570,36.43,0.51,193,76567,70,NULL,NULL,'ESO 537-IG 003 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.32',0.37,'E',NULL,NULL,NULL,NULL,1,356.164583,-23.81156,0.041,NULL,50003114911,781298670,12207791,16.32),(164571,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164571,34.67,NULL,86.1,76568,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2533',NULL,'2010Ap&SS.325..163P',2010,1,0.9,NULL,'G',0.000018,NULL,'16.6',0.1,'Sdm',NULL,NULL,NULL,NULL,1,356.1684583,5.25717,0.281,NULL,51593049861,806141404,12595959,16.6),(164572,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164572,34.69,NULL,86.8,76568,NULL,NULL,'Dipole + Quadrupole','FGC 2533',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164573,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164573,34.71,NULL,87.4,76568,NULL,NULL,'Dipole','FGC 2533',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164574,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164574,34.75,NULL,89.1,76568,NULL,NULL,NULL,'FGC 2533',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164575,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 17218','R',164575,39.64,0.2,717,76569,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007jp','SDSS J234441.24-000148.3',0.18,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,':',NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,356.171833,-0.03008,0.105,NULL,49398825445,771856647,12060260,NULL),(164576,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 2007jp',NULL,164576,39.46,0.09,780,76569,70,NULL,'SALT 2','SDSS J234441.24-000148.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164577,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 2007jp',NULL,164577,39.47,0.09,783,76569,70,NULL,'SALT 2, Malmquist cor.','SDSS J234441.24-000148.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164578,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 17218','R',164578,39.91,0.12,812,76569,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007jp','SDSS J234441.24-000148.3',0.18,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164579,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164579,36.07,0.23,164,76570,74.4,NULL,NULL,'GIN 730',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000033,NULL,'15.5V',0.3,'E/S0','Group member',NULL,NULL,NULL,1,356.182667,9.21561,0.221,NULL,51791106802,809236043,12644313,15.5),(164580,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164580,36.5,0.2,199,76570,70,NULL,NULL,'GIN 730',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164581,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164581,36.99,0.49,250,76571,NULL,NULL,'Malmquist cor.','2MASX J23444532+0835419',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',NULL,NULL,'16.1',NULL,NULL,'Group member',NULL,NULL,NULL,1,356.188917,8.59497,0.253,NULL,51788754099,809199282,12643738,16.1),(164582,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164582,37.31,0.42,290,76571,NULL,NULL,NULL,'2MASX J23444532+0835419',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164583,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164583,37.36,0.2,296,76571,74.4,NULL,NULL,'2MASX J23444532+0835419',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164584,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 14729','RN',164584,43.28,0.37,3570,76572,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 14729',0.27022,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164585,'BCG','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164585,37.58,0.35,315,76573,60,NULL,NULL,'ABELL 2657',0.0414,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,356.2125417,9.14433,0.221,NULL,51790866877,809232294,12644254,NULL),(164586,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164586,36.22,0.14,175,76573,70,NULL,NULL,'ABELL 2657',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164587,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164587,36.96,0.27,247,76574,70,NULL,NULL,'2MASX J23445607+0107369',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000103,NULL,'15.7g',0.5,'E0',NULL,NULL,NULL,NULL,1,356.2337917,1.12689,0.121,NULL,51552089896,805501404,12585959,15.7),(164588,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164588,36.94,0.25,244,76575,74.4,NULL,NULL,'2MASX J23445627+0907469',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000064,NULL,'16.0V',0.4,'S0/E','Group member',NULL,NULL,NULL,1,356.234458333,9.12964,0.221,NULL,51790819504,809231554,12644243,16),(164589,'BCG','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164589,37.58,0.35,315,76576,60,NULL,'ABELL 2657, BCG','CGCG 407-053 NED02',0.0414,'1980ApJ...241..486H',1980,1,0.8,NULL,'G',0.000047,NULL,'14.0V',0.6,'cD;S0;BrClG','Group member, 2nd ranked galaxy',NULL,NULL,NULL,1,356.23925,9.19314,0.221,NULL,51790811822,809231434,12644241,14),(164590,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164590,36.5,0.2,199,76576,70,NULL,NULL,'CGCG 407-053 NED02',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164591,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164591,36.22,0.14,175,76576,70,NULL,'ABELL 2657, BGC','CGCG 407-053 NED02',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164592,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164592,37.87,0.46,376,76577,70,NULL,NULL,'2MASX J23445821+0102409',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000068,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,356.242417,1.04472,0.121,NULL,51552151213,805502362,12585974,18.3),(164593,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164593,36.27,0.25,179,76578,74.4,NULL,NULL,'CGCG 407-053',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'GTrpl',0.000137,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,356.24375,9.1975,0.221,NULL,51790811898,809231435,12644241,NULL),(164594,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164594,35.68,0.45,137,76578,NULL,NULL,'K','CGCG 407-053',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164595,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164595,36.14,0.4,169,76578,NULL,NULL,'mean','CGCG 407-053',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164596,'Faber-Jackson','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164596,32.23,0.65,27.9,76579,95,NULL,'Weighted Mean','NGC 7744',NULL,'1984ApJS...56...91D',1984,1,2.2,NULL,'G',0.00007,NULL,'12.87',1.7,'SB0^-','Isolated galaxy',NULL,NULL,NULL,1,356.246833,-42.91092,NULL,NULL,49931121273,780173769,12190215,12.87),(164597,'Faber-Jackson','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164597,33.74,0.81,56,76579,55,NULL,'Visvanathan & Sandage 1979','NGC 7744',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164598,'Tully est','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164598,32.83,0.8,36.9,76579,75,NULL,'B','NGC 7744',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164599,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164599,36.29,0.25,181,76580,74.4,NULL,NULL,'GIN 735',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00004,NULL,'16.0V',0.3,'S','Group member',NULL,NULL,NULL,1,356.256917,9.04478,0.221,NULL,51788780351,809199692,12643745,16),(164600,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164600,36.5,0.2,199,76580,70,NULL,NULL,'GIN 735',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164601,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164601,36.96,0.27,247,76581,70,NULL,NULL,'2MASX J23450440+0110440',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.86',0.33,NULL,NULL,NULL,NULL,NULL,1,356.268375,1.17889,0.121,NULL,51552087797,805501371,12585958,16.86),(164602,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164602,34.98,0.49,99.1,76582,75,NULL,'IR','CGCG 497-053',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.41',0.3,'Sc',NULL,NULL,NULL,NULL,1,356.275833,29.06392,0.189,NULL,51964373560,811943336,12686614,15.41),(164603,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164603,35.96,0.8,155,76583,75,NULL,'W91PP, r','UGC 12766',NULL,'1997ApJS..109..333W',1997,1,1,'RC3 (1991RC3.9.C...0000d) gives v = 7348 km/s.','G',0.000565,NULL,'16.0',0.2,'S?',NULL,NULL,NULL,NULL,1,356.277375,25.51842,0.085,NULL,51997872066,812466751,12694792,16),(164604,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164604,35.78,0.38,143,76583,75,NULL,'W91PP, r, raw','UGC 12766',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164605,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164605,35.9,0.38,151,76583,75,NULL,'W91PP, r, inv','UGC 12766',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164606,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164606,35.99,0.38,157,76583,75,NULL,'W91PP, r, cor','UGC 12766',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164607,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164607,35.73,0.52,140,76584,NULL,NULL,NULL,'2MASX J23450695+0903345',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000077,NULL,'15.4V',0.6,'SBa','Group member',NULL,NULL,NULL,1,356.278916667,9.05956,0.221,NULL,51788783510,809199742,12643745,15.4),(164608,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164608,35.75,0.51,141,76584,NULL,NULL,'Malmquist cor.','2MASX J23450695+0903345',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164609,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164609,36.13,0.2,168,76584,74.4,NULL,NULL,'2MASX J23450695+0903345',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164610,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164610,36.96,0.27,247,76585,70,NULL,NULL,'2MASX J23450742+0103501',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,356.280875,1.06381,0.121,NULL,51552080470,805501257,12585957,16.5),(164611,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164611,37.84,0.46,370,76586,70,NULL,NULL,'2MASX J23451259+1358013',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,356.302417,13.96694,0.097,NULL,51658187010,807159172,12611862,17.3),(164612,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 19549',NULL,164612,41.53,0.06,2020,76587,70,NULL,'SN photometric redshift distance, z photo =0.670 +/- 0.030','SDSS-II SN 19549',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,356.315041667,0.32019,0.073,NULL,51549770219,805465159,12585393,NULL),(164613,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164613,35.06,0.43,103,76588,75,NULL,'3.6 micron, color + selection bias corrected','AGC 331322',NULL,'2014MNRAS.444..527S',2014,1,0.8,NULL,'G',0.000037,NULL,'14.22',0.3,'Sc',NULL,NULL,NULL,NULL,1,356.319,27.47794,0.133,NULL,52006999338,812609364,12697021,14.22),(164614,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164614,35.07,0.43,103,76588,75,NULL,'3.6 micron, color corrected','AGC 331322',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164615,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164615,35.11,0.2,105,76588,74.4,NULL,NULL,'AGC 331322',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164616,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164616,35.5,0.1,126,76588,NULL,NULL,NULL,'AGC 331322',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164617,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164617,36.29,0.23,181,76589,74.4,NULL,NULL,'GIN 736',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000031,NULL,'15.1V',0.4,'E/S0','Group member',NULL,NULL,NULL,1,356.321708333,9.27106,0.221,NULL,51791081799,809235653,12644307,15.1),(164618,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164618,36.5,0.2,199,76589,70,NULL,NULL,'GIN 736',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164619,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 01812','RN',164619,40.25,0.24,770,76590,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01812',0.459785,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164620,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164620,36.37,0.54,188,76591,70,NULL,NULL,'2MASX J23451770-2134417',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'16.03',0.53,NULL,NULL,NULL,NULL,NULL,1,356.323791667,-21.57822,0.046,NULL,50278548988,785602327,12275036,16.03),(164621,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164621,36.42,0.65,192,76592,70,NULL,NULL,'2MASX J23451896-0008496',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00008,NULL,'16.6g',0.17,'Sb(f)',NULL,NULL,NULL,NULL,1,356.3289583,-0.14706,0.105,NULL,49398861147,771857205,12060268,16.6),(164622,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164622,32.82,0.43,36.7,76593,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12769',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.00002,NULL,'16.0',0.5,'Sdm:',NULL,NULL,NULL,NULL,1,356.330083333,-1.27342,0.109,NULL,49400058556,771875914,12060561,16),(164623,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164623,34.75,0.47,89.1,76594,70,NULL,NULL,'NGC 7746',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000067,NULL,'14.07',1.1,'S0^0^ pec:',NULL,NULL,NULL,NULL,1,356.333333,-1.68489,0.089,NULL,49398100965,771845327,12060083,14.07),(164624,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164624,34.88,0.4,94.8,76594,NULL,NULL,'mean','NGC 7746',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164625,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164625,35.07,0.45,103,76594,NULL,NULL,'K','NGC 7746',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164626,'BL Lac Luminosity','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164626,42.08,NULL,2610,76595,70,NULL,'nucleus-to-host flux ratio, z > 1.03','BZU J2345-1515',NULL,'2006AJ....132....1S',2006,1,NULL,NULL,'QSO',NULL,NULL,'19.22',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,356.343167,-15.25186,0.037,NULL,49593125286,774892582,12107696,19.22),(164627,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SCP 06U04',NULL,164627,44.79,0.06,4430,76596,70,NULL,'SALT2, M(B) -19.289 mag, Alpha -0.019, Beta 3.480, Delta -0.151','[DAA2009] U',1.05,'2012ApJ...746...85S',2012,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,356.36375,-36.54722,NULL,NULL,49958497735,780601527,12196898,NULL),(164628,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164628,35.8,0.36,145,76597,NULL,NULL,'Malmquist cor.','ESO 606- G 006',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.92',0.4,'Sb',NULL,NULL,NULL,NULL,1,356.380417,-20.9805,0.064,NULL,50280367982,785630749,12275480,14.92),(164629,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164629,36.17,0.3,171,76597,NULL,NULL,NULL,'ESO 606- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164630,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164630,36.21,0.2,175,76597,74.4,NULL,NULL,'ESO 606- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164631,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164631,35.04,0.8,102,76598,75,NULL,'W91CL, r','NGC 7747',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.38',0.5,'(R\')SB(s)b','in a radial-velocity based grouping',NULL,NULL,NULL,1,356.384375,27.36094,0.133,NULL,52006797385,812606209,12696972,14.38),(164632,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164632,35.04,0.8,102,76598,75,NULL,'W91PP, r','NGC 7747',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164633,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164633,35.04,0.8,102,76598,75,NULL,'HMCL, I','NGC 7747',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164634,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164634,35.04,0.8,102,76598,75,NULL,'CF, r','NGC 7747',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164635,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164635,34.88,0.38,94.5,76598,75,NULL,'W91PP, r, raw','NGC 7747',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164636,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164636,35,0.35,99.8,76598,NULL,NULL,'Malmquist cor.','NGC 7747',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164637,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164637,35.05,0.34,102,76598,NULL,NULL,NULL,'NGC 7747',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164638,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164638,35.05,0.47,103,76598,NULL,NULL,'H','NGC 7747',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164639,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164639,35.06,0.46,103,76598,NULL,NULL,'J','NGC 7747',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164640,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164640,35.08,0.45,104,76598,NULL,NULL,'K','NGC 7747',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164641,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164641,35.09,0.38,104,76598,75,NULL,'W91PP, r, cor','NGC 7747',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164642,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164642,35.14,0.4,107,76598,NULL,NULL,'mean','NGC 7747',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164643,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164643,35.16,0.38,108,76598,75,NULL,'W91PP, r, inv','NGC 7747',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164644,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164644,35.18,0.4,109,76598,75,NULL,'HMCL, I, raw','NGC 7747',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164645,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164645,35.2,0.38,110,76598,75,NULL,'W91CL, r, raw','NGC 7747',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164646,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164646,35.24,0.2,112,76598,74.4,NULL,NULL,'NGC 7747',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164647,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164647,35.29,0.38,114,76598,75,NULL,'CF, r, raw','NGC 7747',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164648,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164648,35.4,0.4,120,76598,75,NULL,'HMCL, I, cor','NGC 7747',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164649,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164649,35.42,0.38,121,76598,75,NULL,'W91CL, r, cor','NGC 7747',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164650,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164650,35.45,0.38,123,76598,75,NULL,'W91CL, r, inv','NGC 7747',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164651,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164651,35.47,0.4,124,76598,75,NULL,'HMCL, I, inv','NGC 7747',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164652,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164652,35.48,0.38,125,76598,75,NULL,'CF, r, cor','NGC 7747',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164653,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164653,35.54,0.38,128,76598,75,NULL,'CF, r, inv','NGC 7747',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164654,'CMD','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164654,27.07,0.09,2.59,76599,NULL,NULL,'optical','kkh 098',NULL,'2010ApJ...712..469M',2010,1,1.1,NULL,'G',0.000001,NULL,'16.7',0.6,'Irr','Brightest group member',NULL,NULL,NULL,1,356.39175,38.71769,0.509,1,51863905854,810373528,12662086,16.7),(164655,'CMD','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164655,27.1,0.07,2.63,76599,NULL,NULL,'IR','kkh 098',NULL,'2010ApJ...712..469M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164656,'TRGB','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164656,26.88,0.1,2.38,76599,NULL,NULL,NULL,'kkh 098',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164657,'TRGB','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164657,26.95,0.11,2.45,76599,NULL,NULL,NULL,'kkh 098',NULL,'2002A&A...389..812K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164658,'TRGB','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164658,26.97,0.1,2.48,76599,NULL,NULL,'I','kkh 098',NULL,'2010ApJ...712..469M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164659,'TRGB','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164659,27.02,0.03,2.54,76599,NULL,NULL,'I','kkh 098',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164660,'TRGB','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164660,27.25,0.1,2.82,76599,NULL,NULL,'K','kkh 098',NULL,'2010ApJ...712..469M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164661,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13893','RN',164661,39.91,0.26,749,76600,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13893',0.28287,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164662,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13893','RN',164662,40.13,0.21,826,76600,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13893',0.28287,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164663,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164663,36.46,0.46,196,76601,70,NULL,NULL,'2MASX J23453617-0030006',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000096,NULL,'17.3g',0.23,'NLAGN',NULL,NULL,NULL,'Sy 2',1,356.400708333,-0.50017,0.141,NULL,49398803188,771856299,12060254,17.3),(164664,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164664,36.27,0.25,179,76602,74.4,NULL,NULL,'GIN 737',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000067,NULL,'15.6V',0.4,'S','Group member',NULL,NULL,NULL,1,356.4187917,9.23533,0.221,NULL,51790348704,809224198,12644128,15.6),(164665,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164665,36.5,0.2,199,76602,70,NULL,NULL,'GIN 737',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164666,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164666,38,0.46,399,76603,70,NULL,NULL,'SDSS J234546.80-005027.4',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000082,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,356.445167,-0.84094,0.125,NULL,49400390201,771881096,12060642,17.7),(164667,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164667,36.02,0.5,160,76604,70,NULL,NULL,'2MASX J23454733-0235294',NULL,'2014MNRAS.445.2677S',2014,1,0.86,NULL,'G',0.000077,NULL,'15.94',0.54,NULL,NULL,NULL,NULL,NULL,1,356.44725,-2.59153,0.089,NULL,49453821751,772715964,12073686,15.94),(164668,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164668,35.55,0.05,129,76605,NULL,NULL,NULL,'CGCG 477-005',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000035,NULL,'15.3',0.5,'Sd',NULL,NULL,NULL,NULL,1,356.448,27.59783,0.145,NULL,52006857207,812607143,12696986,15.3),(164669,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164669,35.94,0.53,154,76606,70,NULL,NULL,'NGC 7749',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000067,NULL,'14.34',1.1,'SA0^0^',NULL,NULL,NULL,NULL,1,356.448125,-29.51781,NULL,NULL,50040779460,781887179,12216987,14.34),(164670,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164670,37.59,0.46,330,76607,70,NULL,NULL,'2MASX J23454838-0042064',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000075,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,356.4517083,-0.70164,0.141,NULL,49399857772,771872777,12060512,17.9),(164671,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164671,38.35,0.23,467,76608,70,NULL,NULL,'SDSS J234549.45+010420.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000074,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,356.456083,1.07233,0.121,NULL,51552092858,805501450,12585960,18.5),(164672,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164672,38.22,0.46,441,76609,70,NULL,NULL,'2MASX J23455033+1354522',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000137,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,356.4597917,13.91447,0.089,NULL,51658305925,807161030,12611891,17.8),(164673,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164673,33.24,0.49,44.5,76610,75,NULL,'IR','IC 1508',NULL,'2011yCatp016004901K',2011,1,2,NULL,'G',0.000013,NULL,'13.87',0.5,'Sdm:','Isolated galaxy',NULL,NULL,NULL,1,356.4794583,12.06175,0.113,NULL,51650503127,807039111,12609986,13.87),(164674,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164674,33.32,0.2,46.1,76610,74.4,NULL,NULL,'IC 1508',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164675,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164675,33.74,0.1,56.1,76610,NULL,NULL,NULL,'IC 1508',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164676,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164676,36.72,0.46,221,76611,70,NULL,NULL,'2MASX J23455582-1006556',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000138,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,356.482667,-10.11558,0.105,NULL,49624700010,775385937,12115405,17),(164677,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164677,37.14,0.46,268,76612,70,NULL,NULL,'2MASX J23460232-0921176',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,356.509667,-9.35497,0.079,NULL,49626034053,775406782,12115730,17.2),(164678,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15158','RN',164678,42.99,0.18,2940,76613,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15158',0.348646,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164679,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15158','RN',164679,43.04,0.23,3010,76613,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15158',0.348646,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164680,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164680,38.35,0.23,467,76614,70,NULL,NULL,'2MASX J23460891+0101496',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000091,NULL,'16.9g',0.25,'AGN',NULL,NULL,NULL,NULL,1,356.537,1.03031,0.097,NULL,51551308375,805489193,12585768,16.9),(164681,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164681,38.35,0.23,467,76615,70,NULL,NULL,'2MASX J23460911+0059086',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000102,NULL,'17.7g',0.18,'NLAGN',NULL,NULL,NULL,'Sy 2',1,356.537875,0.98581,0.097,NULL,51551321428,805489397,12585771,17.7),(164682,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164682,38.35,0.23,467,76616,70,NULL,NULL,'SDSS J234611.60+005917.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000081,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,356.548333,0.98828,0.097,NULL,51551318785,805489356,12585771,18.5),(164683,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164683,34.41,0.51,76.3,76617,70,NULL,NULL,'ESO 471- G 010',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000023,NULL,'14.96',0.4,'Sb','Group member',NULL,NULL,NULL,1,356.5627917,-28.09897,0.066,NULL,50061221146,782206580,12221977,14.96),(164684,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164684,35.29,0.4,115,76617,NULL,NULL,'mean','ESO 471- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164685,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164685,35.31,0.47,115,76617,NULL,NULL,'H','ESO 471- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164686,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164686,35.37,0.45,118,76617,NULL,NULL,'K','ESO 471- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164687,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164687,35.42,0.26,121,76617,NULL,NULL,NULL,'ESO 471- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164688,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164688,35.42,0.46,121,76617,NULL,NULL,'J','ESO 471- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164689,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164689,35.46,0.2,124,76617,74.4,NULL,NULL,'ESO 471- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164690,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164690,35.47,0.25,124,76617,NULL,NULL,'Malmquist cor.','ESO 471- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164691,'L(H{beta})-{sigma}','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164691,45.01,NULL,1640,76618,74.3,NULL,NULL,'[HB89] 2343+125:BM0133',1.4774,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,'22.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,356.567417,12.80258,0.125,NULL,51651440542,807053758,12610214,22.5),(164692,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 20263','RN',164692,42.97,0.38,3060,76619,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20263',0.283252,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164693,'L(H{beta})-{sigma}','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164693,46.2,NULL,1590,76620,74.3,NULL,NULL,'[HB89] 2343+125:BX0418',2.3052,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,'23.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,356.577375,12.7965,0.125,NULL,51651439796,807053746,12610214,23.9),(164694,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15319','RN',164694,41.53,0.14,1520,76621,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15319',0.330121,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164695,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15319','RN',164695,41.8,0.21,1720,76621,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15319',0.330121,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164696,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164696,34.49,0.48,79.2,76622,70,NULL,NULL,'IC 5349 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000033,NULL,'15.32',NULL,'S0','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,356.594583,-28.00603,0.052,NULL,50052864807,782076012,12219937,15.32),(164697,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164697,34.41,0.45,76.1,76623,NULL,NULL,'K','IC 5349',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'GPair',0.000213,NULL,NULL,NULL,'S0?',NULL,NULL,NULL,NULL,1,356.595125,-28.00511,0.052,NULL,50052864812,782076012,12219937,NULL),(164698,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164698,35.28,0.4,114,76623,NULL,NULL,'mean','IC 5349',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164699,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 08018','RN',164699,41.15,0.15,1430,76624,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 08018',0.19078,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164700,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 08018','RN',164700,41.64,0.26,1780,76624,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 08018',0.19078,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164701,'L(H{beta})-{sigma}','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164701,46.04,NULL,1605,76625,74.3,NULL,NULL,'[HB89] 2343+125:BX0660',2.1735,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,'24.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,356.622625,12.82931,0.089,NULL,51651444487,807053820,12610215,24.3),(164702,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164702,36.96,0.46,247,76626,70,NULL,NULL,'2MASX J23463230+0114047',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'17.12',0.29,NULL,NULL,NULL,NULL,NULL,1,356.634541667,1.23456,0.125,NULL,51551257166,805488393,12585756,17.12),(164703,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164703,36.51,0.49,200,76627,70,NULL,NULL,'2MASX J23463276-2314351',NULL,'2014MNRAS.445.2677S',2014,1,0.95,NULL,'G',0.00015,NULL,'15.87',0.3,'E',NULL,NULL,NULL,NULL,1,356.636625,-23.24303,0.041,NULL,50002610043,781290781,12207668,15.87),(164704,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164704,36.2,0.57,174,76628,NULL,NULL,'Malmquist cor.','2MASX J23463576-2759455',NULL,'2009ApJS..182..474S',2009,1,0.57,NULL,'G',0.000027,NULL,'15.83',0.37,'Sbc','Group member',NULL,NULL,NULL,1,356.648917,-27.99597,0.052,NULL,50052874024,782076156,12219939,15.83),(164705,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164705,36.54,0.49,203,76628,NULL,NULL,NULL,'2MASX J23463576-2759455',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164706,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164706,36.58,0.2,207,76628,74.4,NULL,NULL,'2MASX J23463576-2759455',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164707,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164707,36.44,0.77,194,76629,70,NULL,NULL,'6dF J2346367-353118',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,356.653083,-35.52164,NULL,NULL,49960959236,780639988,12197499,15),(164708,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164708,32.78,0.8,36,76630,75,NULL,'CF, r','NGC 7750',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000003,NULL,'13.49',0.8,'(R\')SB(rs)c pec:','Pair member, wide',NULL,NULL,NULL,1,356.657667,3.79981,0.133,NULL,51606352122,806349251,12599207,13.49),(164709,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164709,31.25,0.37,17.8,76630,NULL,NULL,NULL,'NGC 7750',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164710,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164710,31.79,0.43,22.8,76630,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7750',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164711,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164711,31.92,0.43,24.3,76630,75,NULL,'3.6 micron, color corrected','NGC 7750',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164712,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164712,32.02,0.6,25.3,76630,NULL,NULL,'Malmquist cor.','NGC 7750',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164713,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164713,32.06,0.2,25.8,76630,74.4,NULL,NULL,'NGC 7750',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164714,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164714,32.23,0.54,27.9,76630,NULL,NULL,NULL,'NGC 7750',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164715,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164715,32.23,0.69,27.9,76630,100,NULL,'mid-IR','NGC 7750',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164716,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164716,32.24,0.4,28,76630,73,NULL,'opt','NGC 7750',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164717,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164717,32.49,0.46,31.5,76630,NULL,NULL,'J','NGC 7750',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164718,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164718,32.49,0.47,31.5,76630,NULL,NULL,'H','NGC 7750',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164719,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164719,32.54,0.45,32.1,76630,NULL,NULL,'K','NGC 7750',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164720,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164720,32.68,0.4,34.3,76630,NULL,NULL,'mean','NGC 7750',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164721,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164721,32.86,0.38,37.4,76630,75,NULL,'CF, r, raw','NGC 7750',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164722,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164722,32.94,0.38,38.7,76630,75,NULL,'CF, r, inv','NGC 7750',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164723,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164723,33.09,0.38,41.6,76630,75,NULL,'CF, r, cor','NGC 7750',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164724,'FP','2016-12-15 15:16:09','2016-12-16 11:21:25','1',NULL,NULL,164724,34.52,0.25,80.2,76631,74.4,NULL,NULL,'2MASX J23463843-2815115',NULL,'2013AJ....146...86T',2013,1,0.41,NULL,'G',0.00005,NULL,'16.90',0.29,'Ep','Group member',NULL,NULL,NULL,1,356.660166667,-28.25311,0.063,NULL,50052942512,782077226,12219956,16.9),(164725,'FP','2016-12-15 15:16:09','2016-12-16 11:21:25','1',NULL,'R',164725,37,0.46,251,76632,70,NULL,NULL,'2MASX J23464017+1507135',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000199,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,356.66725,15.12056,0.045,NULL,51672226165,807378533,12615289,16.2),(164726,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:25','1',NULL,NULL,164726,36.53,0.54,203,76633,NULL,NULL,'Malmquist cor.','2MASX J23464090-2805595',NULL,'2009ApJS..182..474S',2009,1,0.45,NULL,'G',0.000027,NULL,'16.64',0.31,'Sbc','Group member',NULL,NULL,NULL,1,356.6704583,-28.09989,0.041,NULL,50052916735,782076823,12219950,16.64),(164727,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:25','1',NULL,NULL,164727,36.68,0.51,217,76633,NULL,NULL,NULL,'2MASX J23464090-2805595',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164728,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:25','1',NULL,NULL,164728,36.72,0.2,221,76633,74.4,NULL,NULL,'2MASX J23464090-2805595',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164729,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:25','1','SDSS-II SN 05590','RN',164729,42.21,0.3,1910,76634,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05590',0.447846,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164730,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:25','1','SDSS-II SN 05590','RN',164730,42.73,0.37,2430,76634,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 05590',0.447846,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164731,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 05590','N',164731,42.15,0.21,2690,76634,70,NULL,'SALT 2','SDSS-II SN 05590',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164732,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 05590','N',164732,42.25,0.21,2820,76634,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 05590',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164733,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15784','R',164733,40.12,0.15,827,76635,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J234641.69-003657.0',0.2771,'2014arXiv1401.3317S',2014,1,0.09,NULL,'G',0.0001,NULL,'19.9g',0.08,NULL,NULL,NULL,NULL,NULL,1,356.67375,-0.61583,0.153,NULL,49399223396,771862865,12060357,19.9),(164734,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15784','R',164734,40.13,0.22,833,76635,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J234641.69-003657.0',0.2771,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164735,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15784',NULL,164735,40.45,0.11,1230,76635,70,NULL,'SALT 2','SDSS J234641.69-003657.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164736,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15784',NULL,164736,40.48,0.11,1250,76635,70,NULL,'SALT 2, Malmquist cor.','SDSS J234641.69-003657.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164737,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164737,37.15,0.46,269,76636,70,NULL,NULL,'2MASX J23464354-1005318',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00015,NULL,'15.8g',0.48,'E0',NULL,NULL,NULL,NULL,1,356.681417,-10.09208,0.105,NULL,49624238549,775378727,12115292,15.8),(164738,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164738,35.87,0.46,149,76637,70,NULL,NULL,'CGCG 455-046',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000117,NULL,'15.0g',0.58,'E0',NULL,NULL,NULL,NULL,1,356.692333,16.04308,0.045,NULL,51670531169,807352049,12614875,15),(164739,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 03519','RN',164739,42.17,0.21,1910,76638,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03519',0.424167,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164740,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 03519','RN',164740,42.31,0.16,2030,76638,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03519',0.424167,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164741,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164741,37.01,0.55,252,76639,70,NULL,NULL,'2MASX J23464844-0315479',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00008,NULL,'16.59',0.39,NULL,NULL,NULL,NULL,NULL,1,356.7017917,-3.26311,0.097,NULL,49456083422,772751303,12074239,16.59),(164742,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164742,35.11,0.4,105,76640,75,NULL,'Edat, raw','2dFGRS S194Z041',NULL,'1997ApJS..109..333W',1997,1,0.27,'Green, et al. (1990,MNRAS,243,159) give v = 8020 km/sec.','G',0.000213,NULL,'18.49',0.18,'E','Group member',NULL,NULL,NULL,1,356.72725,-28.04697,0.052,NULL,50052912880,782076763,12219949,18.49),(164743,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164743,35.15,0.4,107,76640,75,NULL,'Edat, cor','2dFGRS S194Z041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164744,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164744,35.65,0.25,135,76640,74.4,NULL,NULL,'2dFGRS S194Z041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164745,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15899','RN',164745,37.83,0.09,344,76641,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15242 HOST',0.071174,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164746,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15242','RN',164746,37.89,0.1,354,76641,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15242 HOST',0.071174,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164747,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15899','RN',164747,38.83,0.25,545,76641,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15242 HOST',0.071174,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164748,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15242','RN',164748,38.98,0.25,583,76641,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15242 HOST',0.071174,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164749,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164749,32.49,0.47,31.5,76642,NULL,NULL,'H','NGC 7753',NULL,'2007A&A...465...71T',2007,1,3.3,NULL,'G',0.00002,NULL,'12.83',2.1,'SAB(rs)bc','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,356.770125,29.48344,0.193,NULL,51972235587,812066181,12688534,12.83),(164750,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164750,32.53,0.45,32.1,76642,NULL,NULL,'K','NGC 7753',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164751,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164751,32.6,0.46,33.1,76642,NULL,NULL,'J','NGC 7753',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164752,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164752,34.21,0.4,69.6,76642,NULL,NULL,'mean','NGC 7753',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164753,'BL Lac Luminosity','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164753,37,NULL,241,76643,NULL,NULL,NULL,'2MASX J23470479+5142179',0.044,'2005ApJ...635..173S',2005,1,NULL,'TXS codes: lobes(W)','G',NULL,NULL,'12.89',NULL,'BLLAC',NULL,NULL,NULL,'BL Lac',1,356.770167,51.70497,NULL,NULL,53210740274,831417816,12990903,12.89),(164754,'GeV TeV ratio','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164754,38.09,NULL,414,76643,72,NULL,NULL,'2MASX J23470479+5142179',NULL,'2010MNRAS.405L..76P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164755,'GeV TeV ratio','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164755,39.28,0.28,717,76643,72,NULL,NULL,'2MASX J23470479+5142179',NULL,'2011arXiv1111.0913P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164756,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164756,37.89,0.46,379,76644,70,NULL,NULL,'2MASX J23470552+1337376',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,356.773083,13.62706,0.073,NULL,51650958455,807046225,12610097,17.3),(164757,'GRB','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164757,48.28,1.48,10400,76645,NULL,NULL,NULL,'GRB 080810',3.35,'2010JCAP...08..020W',2010,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,356.793917,0.31978,0.097,NULL,51549913809,805467403,12585428,NULL),(164758,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 12941',NULL,164758,40.12,0.14,1060,76646,70,NULL,'SN photometric redshift distance, z photo =0.286 +/- 0.023','SDSS-II SN 12941',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,356.7797917,-0.59917,0.153,NULL,49399446724,771866355,12060411,NULL),(164759,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19821',NULL,164759,39.57,0.29,820,76647,70,NULL,'SN photometric redshift distance, z photo =0.214 +/- 0.035','SDSS-II SN 19821',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,356.779416667,1.02592,0.097,NULL,51551293229,805488956,12585764,NULL),(164760,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19821','R',164760,40.74,0.23,1110,76647,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19821',0.266012,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164761,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19821','R',164761,40.78,0.18,1130,76647,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19821',0.266012,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164762,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19821',NULL,164762,40.53,0.14,1280,76647,70,NULL,'SALT 2','SDSS-II SN 19821',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164763,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19821',NULL,164763,40.55,0.14,1290,76647,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19821',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164764,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164764,36.49,0.65,199,76648,70,NULL,NULL,'6dF J2347070-355018',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,356.7797083,-35.83819,NULL,NULL,49962012656,780656447,12197756,13.9),(164765,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164765,35.62,0.52,133,76649,70,NULL,NULL,'MCG +00-60-047 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.000088,NULL,'15.7g',0.4,'E0',NULL,NULL,NULL,NULL,1,356.785541667,-0.61086,0.153,NULL,49399446536,771866352,12060411,15.7),(164766,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164766,34.7,0.23,87.1,76650,74.4,NULL,NULL,'2MASX J23471207-2755483',NULL,'2013AJ....146...86T',2013,1,0.57,NULL,'G',0.000117,NULL,'16.06',0.5,'S0','Group member',NULL,NULL,NULL,1,356.800417,-27.93006,0.052,NULL,50053633191,782088018,12220125,16.06),(164767,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 16458','RN',164767,41.3,0.35,1540,76651,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16458',0.186372,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164768,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 16458','RN',164768,41.4,0.29,1610,76651,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16458',0.186372,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164769,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164769,34.96,0.63,98.1,76652,NULL,NULL,NULL,'2MASX J23471337-2801023',NULL,'2009ApJS..182..474S',2009,1,0.48,NULL,'G',0.00003,NULL,'16.71',0.32,'S0/a','Group member',NULL,NULL,NULL,1,356.805291667,-28.017,0.052,NULL,50053637109,782088079,12220126,16.71),(164770,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164770,35,0.2,100,76652,74.4,NULL,NULL,'2MASX J23471337-2801023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164771,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164771,35.45,0.5,123,76652,NULL,NULL,'Malmquist cor.','2MASX J23471337-2801023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164772,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19447','RN',164772,41.6,0.22,1480,76653,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 19447',0.406412,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164773,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19447','RN',164773,42.31,0.25,2060,76653,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 19447',0.406412,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164774,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164774,35.11,0.4,105,76654,75,NULL,'Edat, raw','2MASX J23471420-2801483',NULL,'1997ApJS..109..333W',1997,1,0.26,NULL,'G',0.000097,NULL,'17.80',0.24,'E','Group member',NULL,NULL,NULL,1,356.8089583,-28.03011,0.052,NULL,50053636212,782088065,12220126,17.8),(164775,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164775,35.15,0.4,107,76654,75,NULL,'Edat, cor','2MASX J23471420-2801483',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164776,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164776,35.92,0.23,153,76654,74.4,NULL,NULL,'2MASX J23471420-2801483',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164777,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164777,34.79,0.25,90.8,76655,74.4,NULL,NULL,'2MASX J23471439-2811343',NULL,'2013AJ....146...86T',2013,1,0.47,NULL,'G',0.00006,NULL,'16.70',0.34,'S0','Group member',NULL,NULL,NULL,1,356.809833333,-28.19281,0.041,NULL,50052899630,782076556,12219946,16.7),(164778,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164778,34.72,0.4,87.9,76656,75,NULL,'Edat, raw','IC 5350',NULL,'1997ApJS..109..333W',1997,1,0.7,NULL,'G',0.00005,NULL,'14.41',0.6,'S0','Group member',NULL,NULL,NULL,1,356.810958333,-27.95772,0.052,NULL,50053640295,782088129,12220127,14.41),(164779,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164779,35.09,0.4,104,76656,75,NULL,'Edat, cor','IC 5350',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164780,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164780,35.07,0.23,103,76656,74.4,NULL,NULL,'IC 5350',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164781,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164781,33.98,0.8,62.4,76657,75,NULL,'W91PP, r','IC 5355',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000013,NULL,'14.39',0.6,'SBcd:          HII','Isolated galaxy',NULL,NULL,NULL,1,356.8137083,32.78275,0.221,NULL,52028801230,812950019,12702344,14.39),(164782,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164782,33.55,0.38,51.4,76657,75,NULL,'W91PP, r, raw','IC 5355',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164783,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164783,33.59,0.38,52.3,76657,75,NULL,'W91PP, r, inv','IC 5355',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164784,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164784,33.83,0.2,58.3,76657,74.4,NULL,NULL,'IC 5355',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164785,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164785,33.84,0.39,58.7,76657,NULL,NULL,NULL,'IC 5355',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164786,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164786,33.91,0.38,60.6,76657,75,NULL,'W91PP, r, cor','IC 5355',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164787,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164787,34.24,0.33,70.5,76657,NULL,NULL,'Malmquist cor.','IC 5355',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164788,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164788,34.26,0.49,71,76658,75,NULL,'IR','IC 1509',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.00011,NULL,'15.19',0.2,NULL,NULL,NULL,NULL,NULL,1,356.8195,-15.30642,0.036,NULL,49590874211,774857409,12107147,15.19),(164789,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164789,34.58,0.2,82.4,76658,74.4,NULL,NULL,'IC 1509',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164790,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164790,34.68,0.32,86.5,76658,NULL,NULL,NULL,'IC 1509',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164791,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164791,34.79,0.31,90.9,76658,NULL,NULL,'Malmquist cor.','IC 1509',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164792,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164792,35.11,0.4,105,76659,75,NULL,'Edat, raw','2MASX J23471684-2807265',NULL,'1997ApJS..109..333W',1997,1,0.45,NULL,'G',0.000057,NULL,'16.40',0.38,'E','Group member',NULL,NULL,NULL,1,356.820208333,-28.12422,0.041,NULL,50052903780,782076621,12219947,16.4),(164793,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164793,35.15,0.4,107,76659,75,NULL,'Edat, cor','2MASX J23471684-2807265',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164794,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164794,35.01,0.23,100,76659,74.4,NULL,NULL,'2MASX J23471684-2807265',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164795,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164795,35.23,0.51,111,76660,70,NULL,NULL,'2MASX J23471871-0159435',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.000073,NULL,'16.27',0.31,NULL,NULL,NULL,NULL,NULL,1,356.827958333,-1.99536,0.073,NULL,49398356412,771849318,12060145,16.27),(164796,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164796,35.82,0.23,146,76661,74.4,NULL,NULL,'2MASX J23472017-2803465',NULL,'2013AJ....146...86T',2013,1,0.36,NULL,'G',0.00005,NULL,'17.16',0.29,'S0','Group member',NULL,NULL,NULL,1,356.8337917,-28.06289,0.041,NULL,50053603626,782087556,12220118,17.16),(164797,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164797,35.55,0.23,129,76662,74.4,NULL,NULL,'2MASX J23472237-2758325',NULL,'2013AJ....146...86T',2013,1,0.45,NULL,'G',0.000043,NULL,'16.87',0.24,'S0','Group member',NULL,NULL,NULL,1,356.8432083,-27.97572,0.052,NULL,50053640475,782088132,12220127,16.87),(164798,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164798,34.26,0.45,71.1,76663,NULL,NULL,'K','IC 5357',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000073,NULL,'14.33',1.1,'SAB0- pec:','Compact group member',NULL,NULL,NULL,1,356.845791667,-2.30067,0.105,NULL,49397620842,771837825,12059966,14.33),(164799,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164799,34.92,0.4,96.2,76663,NULL,NULL,'mean','IC 5357',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (164800,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15568','R',164800,40.4,0.39,997,76664,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15568',0.20661,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,356.846333,1.05019,0.097,NULL,51549536426,805461506,12585336,NULL),(164801,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15568','R',164801,41.23,0.37,1460,76664,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15568',0.20661,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164802,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164802,36,0.25,158,76665,74.4,NULL,NULL,'2MASX J23472326-2807085',NULL,'2013AJ....146...86T',2013,1,0.45,NULL,'G',0.000057,NULL,'16.43',0.42,'S0','Group member',NULL,NULL,NULL,1,356.846833333,-28.11906,0.041,NULL,50052905272,782076644,12219947,16.43),(164803,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2000cw',NULL,164803,35.64,0.16,130,76666,70,NULL,'SALT 2','CGCG 498-012',0.030134,'2013MNRAS.433.2240G',2013,1,0.9,NULL,'G',0.000023,NULL,'15.08',0.4,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,356.8517917,28.39353,0.157,NULL,52002248379,812535130,12695861,15.08),(164804,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164804,35.38,0.8,119,76666,75,NULL,'W91CL, r','CGCG 498-012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164805,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164805,35.38,0.8,119,76666,75,NULL,'HMCL, I','CGCG 498-012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164806,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164806,34.89,0.38,95.1,76666,75,NULL,'W91CL, r, raw','CGCG 498-012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164807,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164807,34.9,0.4,95.4,76666,75,NULL,'HMCL, I, raw','CGCG 498-012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164808,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164808,35.03,0.38,102,76666,75,NULL,'W91CL, r, inv','CGCG 498-012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164809,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164809,35.08,0.4,104,76666,75,NULL,'HMCL, I, inv','CGCG 498-012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164810,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164810,35.11,0.38,105,76666,75,NULL,'W91CL, r, cor','CGCG 498-012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164811,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164811,35.12,0.4,105,76666,75,NULL,'HMCL, I, cor','CGCG 498-012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164812,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164812,35.12,0.43,106,76666,75,NULL,'3.6 micron, color corrected','CGCG 498-012',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164813,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164813,35.13,0.2,106,76666,74.4,NULL,NULL,'CGCG 498-012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164814,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164814,35.19,0.43,109,76666,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 498-012',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164815,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164815,35.55,0.12,129,76666,NULL,NULL,NULL,'CGCG 498-012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164816,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 05543','R',164816,40.37,0.23,1110,76667,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 05543',0.071622,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,356.859083,0.30325,0.097,NULL,51549242747,805456917,12585264,NULL),(164817,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 05543','R',164817,40.73,0.35,1310,76667,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 05543',0.071622,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164818,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164818,36.25,0.33,178,76668,NULL,NULL,'Malmquist cor.','2MASX J23472739+0915548',NULL,'2009ApJS..182..474S',2009,1,0.46,NULL,'G',0.000023,NULL,'15.3',NULL,'Sc','Group member',NULL,NULL,NULL,1,356.864125,9.26531,0.169,NULL,51788560380,809196255,12643691,15.3),(164819,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164819,36.32,0.32,184,76668,NULL,NULL,NULL,'2MASX J23472739+0915548',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164820,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164820,36.36,0.2,187,76668,74.4,NULL,NULL,'2MASX J23472739+0915548',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164821,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164821,35.11,0.4,105,76669,75,NULL,'Edat, raw','IC 5354',NULL,'1997ApJS..109..333W',1997,1,0.8,'Southwestern, brighter of two.','G',0.000033,NULL,'14.98',0.4,'E','Group member',NULL,NULL,NULL,1,356.868083,-28.136,0.041,NULL,50052906050,782076657,12219947,14.98),(164822,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164822,35.15,0.4,107,76669,75,NULL,'Edat, cor','IC 5354',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164823,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164823,35.54,0.25,128,76669,74.4,NULL,NULL,'IC 5354',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164824,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164824,35.27,0.4,113,76669,NULL,NULL,'mean','IC 5354',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164825,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164825,35.67,0.45,136,76669,NULL,NULL,'K','IC 5354',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164826,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164826,35.11,0.4,105,76670,75,NULL,'Edat, raw','IC 5353',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000019,NULL,'14.05',1,'S0-','Group member',NULL,NULL,NULL,1,356.869125,-28.10947,0.041,NULL,50052896911,782076514,12219945,14.05),(164827,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164827,35.15,0.4,107,76670,75,NULL,'Edat, cor','IC 5353',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164828,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164828,35.41,0.23,121,76670,74.4,NULL,NULL,'IC 5353',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164829,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164829,35.28,0.4,114,76670,NULL,NULL,'mean','IC 5353',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164830,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164830,35.53,0.45,127,76670,NULL,NULL,'K','IC 5353',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164831,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164831,35.87,0.61,149,76671,NULL,NULL,'Malmquist cor.','2MASX J23473002+0909008',NULL,'2009ApJS..182..474S',2009,1,0.86,NULL,'G',0.000027,NULL,'14.9',NULL,'Sbc','Group member',NULL,NULL,NULL,1,356.875,9.15019,0.201,NULL,51789066120,809204158,12643814,14.9),(164832,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164832,35.94,0.59,154,76671,NULL,NULL,NULL,'2MASX J23473002+0909008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164833,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164833,35.98,0.2,157,76671,74.4,NULL,NULL,'2MASX J23473002+0909008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164834,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164834,35.36,0.23,118,76672,74.4,NULL,NULL,'2MASX J23473068-2802355',NULL,'2013AJ....146...86T',2013,1,0.34,NULL,'G',0.000087,NULL,'17.36',0.26,'S0','Group member',NULL,NULL,NULL,1,356.877625,-28.04303,0.041,NULL,50053606175,782087596,12220118,17.36),(164835,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164835,35.11,0.4,105,76673,75,NULL,'Edat, raw','2MASX J23473180-2806255',NULL,'1997ApJS..109..333W',1997,1,0.43,NULL,'G',0.000017,NULL,'16.50',0.28,'E','Group member',NULL,NULL,NULL,1,356.882333333,-28.10708,0.041,NULL,50052896810,782076512,12219945,16.5),(164836,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164836,35.15,0.4,107,76673,75,NULL,'Edat, cor','2MASX J23473180-2806255',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164837,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164837,35.21,0.25,110,76673,74.4,NULL,NULL,'2MASX J23473180-2806255',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164838,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164838,37.62,0.27,333,76674,70,NULL,NULL,'2MASX J23473185+0110056',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000083,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,356.88275,1.16825,0.069,NULL,51551190906,805487357,12585739,17.6),(164839,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164839,38.09,0.27,416,76675,70,NULL,NULL,'2MASX J23473270+1449328',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000134,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,356.88625,14.82578,0.065,NULL,51672658444,807385288,12615395,18.4),(164840,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164840,35.11,0.4,105,76676,75,NULL,'Edat, raw','2MASX J23473551-2807315',NULL,'1997ApJS..109..333W',1997,1,0.32,NULL,'G',0.00005,NULL,'16.28',0.29,'E','Group member',NULL,NULL,NULL,1,356.8977917,-28.12536,0.041,NULL,50052891761,782076433,12219944,16.28),(164841,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164841,35.15,0.4,107,76676,75,NULL,'Edat, cor','2MASX J23473551-2807315',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164842,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164842,35.31,0.49,115,76677,75,NULL,'IR','2MFGC 17848',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',NULL,NULL,'11.5K',0.3,NULL,NULL,NULL,NULL,NULL,1,356.9095417,27.52008,0.125,NULL,52002530705,812539542,12695930,11.5),(164843,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164843,35.53,0.44,128,76677,NULL,NULL,'Malmquist cor.','2MFGC 17848',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164844,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164844,35.73,0.4,140,76677,NULL,NULL,NULL,'2MFGC 17848',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164845,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164845,35.88,0.2,150,76677,74.4,NULL,NULL,'2MFGC 17848',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164846,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164846,35.57,0.25,130,76678,74.4,NULL,NULL,'IC 5358A',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000019,NULL,'14.38',NULL,'S0','Group member',NULL,NULL,NULL,1,356.929875,-28.14392,0.041,NULL,50052892380,782076443,12219944,14.38),(164847,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164847,35.26,0.43,113,76679,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 477-006',NULL,'2014MNRAS.444..527S',2014,1,0.7,NULL,'G',0.000017,NULL,'15.47',0.2,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,356.9300417,27.42722,0.125,NULL,52002311159,812536111,12695876,15.47),(164848,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164848,35.33,0.43,116,76679,75,NULL,'3.6 micron, color corrected','CGCG 477-006',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164849,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164849,35.48,0.2,125,76679,74.4,NULL,NULL,'CGCG 477-006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164850,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164850,35.55,0.08,129,76679,NULL,NULL,NULL,'CGCG 477-006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164851,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164851,35.58,0.12,130,76680,70,NULL,NULL,'ABELL 4038',NULL,'1999AJ....118.1489D',1999,1,NULL,'Position corrected, with thanks to H. Andernach.','GClstr',0.00055,NULL,NULL,NULL,'III    [BM];RI?[A]',NULL,NULL,NULL,NULL,1,356.93,-28.14139,0.041,NULL,50052892403,782076443,12219944,NULL),(164852,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164852,35.43,0.25,122,76681,74.4,NULL,NULL,'2MASX J23474346-2810205',NULL,'2013AJ....146...86T',2013,1,0.45,NULL,'G',0.000063,NULL,'15.92',0.35,'E','Group member',NULL,NULL,NULL,1,356.930625,-28.17258,0.041,NULL,50052894125,782076470,12219944,15.92),(164853,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164853,37.89,0.58,379,76682,70,NULL,NULL,'2MASX J23474337-6019083',NULL,'2014MNRAS.445.2677S',2014,1,0.32,NULL,'G',0.00015,NULL,'17.39',0.21,NULL,NULL,NULL,NULL,NULL,1,356.930667,-60.31911,0,NULL,48748830999,761700484,11901570,17.39),(164854,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164854,35.11,0.4,105,76683,75,NULL,'Edat, raw','2MASX J23474346-2810205',NULL,'1997ApJS..109..333W',1997,1,0.45,NULL,'G',0.000063,NULL,'15.92',0.35,'E','Group member',NULL,NULL,NULL,1,356.930625,-28.17258,0.041,NULL,50052894125,782076470,12219944,15.92),(164855,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164855,35.15,0.4,107,76683,75,NULL,'Edat, cor','2MASX J23474346-2810205',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164856,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19668','RN',164856,41.72,0.15,1570,76684,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19668',0.407113,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164857,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19668','RN',164857,41.79,0.24,1620,76684,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19668',0.407113,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164858,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19668','N',164858,41.71,0.13,2200,76684,70,NULL,'SALT 2','SDSS-II SN 19668',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164859,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19668','N',164859,41.78,0.13,2270,76684,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19668',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164860,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164860,35.11,0.4,105,76685,75,NULL,'Edat, raw','IC 5358',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000019,NULL,'13.58',1,'cD;E+4 pec','Pair member (points to parent)',NULL,NULL,NULL,1,356.937667,-28.14075,0.041,NULL,50052892187,782076440,12219944,13.58),(164861,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164861,35.15,0.4,107,76685,75,NULL,'Edat, cor','IC 5358',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164862,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164862,35.23,0.15,111,76685,NULL,NULL,'ABELL 4038, DC 2345-28, 30 galaxies','IC 5358',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164863,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164863,35.33,0.11,116,76685,72,NULL,'ABELL 4038 = Klemola 44 Group, 18 galaxies','IC 5358',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164864,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164864,35.45,0.2,123,76685,70,NULL,'ABELL 4038, BGC, Klemola 44 Group','IC 5358',NULL,'1988MNRAS.235.1177L',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164865,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164865,35.05,0.15,102,76685,NULL,NULL,'ABELL 4038, DC 2345-28, 30 galaxies','IC 5358',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164866,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164866,35.17,0.16,108,76685,NULL,NULL,'ABELL 4038, DC 2345-28, 30 galaxies','IC 5358',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164867,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164867,35.31,0.08,115,76685,75,NULL,'ABELL 4038 = DC2345-28 cluster, 27 galaxies','IC 5358',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164868,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164868,35.31,0.08,115,76685,75,NULL,'ABELL 4038 = DC 2345-28 cluster, 27 galaxies','IC 5358',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164869,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164869,35.4,0.49,120,76685,70,NULL,NULL,'IC 5358',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164870,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164870,35.48,0.25,125,76685,74.4,NULL,NULL,'IC 5358',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164871,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164871,34.44,0.45,77.4,76685,NULL,NULL,'K','IC 5358',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164872,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164872,35.27,0.4,113,76685,NULL,NULL,'mean','IC 5358',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164873,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164873,35.58,0.12,130,76685,70,NULL,'ABELL 4038, BGC','IC 5358',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164874,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164874,35.11,0.4,105,76686,75,NULL,'Edat, raw','NFP J234745.3-280949',NULL,'1997ApJS..109..333W',1997,1,0.17,NULL,'G',0.00007,NULL,'16.89',0.11,'E','Group member',NULL,NULL,NULL,1,356.938667,-28.16358,0.041,NULL,50052894488,782076476,12219944,16.89),(164875,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164875,35.15,0.4,107,76686,75,NULL,'Edat, cor','NFP J234745.3-280949',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164876,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164876,35.43,0.23,122,76686,74.4,NULL,NULL,'NFP J234745.3-280949',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164877,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164877,34.31,0.23,72.8,76687,74.4,NULL,NULL,'2MASX J23474579-2806275',NULL,'2013AJ....146...86T',2013,1,0.25,NULL,'G',0.000063,NULL,'17.90',0.19,'S0','Group member',NULL,NULL,NULL,1,356.9407917,-28.10772,0.041,NULL,50053597744,782087464,12220116,17.9),(164878,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164878,37.68,0.46,344,76688,70,NULL,NULL,'2MASX J23474617-0029458',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000089,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,356.9422083,-0.496,0.149,NULL,49399295070,771863985,12060374,17.3),(164879,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 10727','RN',164879,38.58,0.51,486,76689,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10727',0.071317,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164880,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164880,35.95,0.23,155,76690,74.4,NULL,NULL,'2MASX J23474714-2808059',NULL,'2013AJ....146...86T',2013,1,0.28,NULL,'G',0.00005,NULL,'17.68',0.2,'S0','Pair member (points to parent)',NULL,NULL,NULL,1,356.9465,-28.13497,0.041,NULL,50053597536,782087461,12220116,17.68),(164881,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 08882','RN',164881,43.31,0.22,3210,76691,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05544 HOST',0.428984,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164882,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 05544','RN',164882,43.4,0.23,3340,76691,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05544 HOST',0.429037,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164883,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 08882','RN',164883,44.16,0.23,4760,76691,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 05544 HOST',0.428984,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164884,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 05544','RN',164884,44.28,0.26,5030,76691,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 05544 HOST',0.429037,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164885,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164885,37.02,0.46,254,76692,70,NULL,NULL,'2MASX J23474777+1342317',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000192,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,356.949083,13.70872,0.077,NULL,51650910384,807045474,12610085,16.5),(164886,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164886,37.05,0.46,257,76693,70,NULL,NULL,'2MASX J23474820+1535277',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,356.950833,15.59097,0.057,NULL,51670158328,807346223,12614784,17),(164887,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164887,34.95,0.25,97.7,76694,74.4,NULL,NULL,'2MASX J23474957-2805119',NULL,'2013AJ....146...86T',2013,1,0.31,NULL,'G',0.000053,NULL,'17.38',0.29,'E','Group member',NULL,NULL,NULL,1,356.95625,-28.08653,0.041,NULL,50053610151,782087658,12220119,17.38),(164888,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164888,35.41,0.25,121,76695,74.4,NULL,NULL,'2MASX J23474954-2812129',NULL,'2013AJ....146...86T',2013,1,0.39,NULL,'G',0.000057,NULL,'17.07',0.34,'S0','Group member',NULL,NULL,NULL,1,356.95625,-28.20367,0.041,NULL,50052927195,782076987,12219952,17.07),(164889,'Tully est','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164889,31.78,0.8,22.7,76696,75,NULL,NULL,'ESO 149- G 001',NULL,'1988NBGC.C....0000T',1988,1,3.3,'Bright star superposed 15 arcsec north-northeast.','G',0.00001,NULL,'13.59',0.7,'SAB(s)dm',NULL,NULL,NULL,NULL,1,356.953083,-57.0725,0,NULL,48808568173,762633877,11916154,13.59),(164890,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164890,31.6,0.43,20.8,76696,75,NULL,'3.6 micron, color + selection bias corrected','ESO 149- G 001',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164891,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164891,38.09,0.27,416,76697,70,NULL,NULL,'SDSS J234751.27+145703.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000147,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,356.963625,14.95111,0.061,NULL,51672134395,807377099,12615267,18.4),(164892,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164892,32.88,0.8,37.7,76698,75,NULL,'MAT, I','NGC 7755',NULL,'1997ApJS..109..333W',1997,1,3.8,NULL,'G',0.00001,NULL,'12.56',2.9,'SB(r)bc        HII','Isolated galaxy',NULL,NULL,NULL,1,356.965667,-30.52203,NULL,NULL,50043989792,781937340,12217770,12.56),(164893,'Sosies','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164893,32.65,0.45,33.9,76698,NULL,NULL,NULL,'NGC 7755',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164894,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164894,32.1,0.43,26.3,76698,75,NULL,'MAT, I, raw','NGC 7755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164895,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164895,32.23,0.4,27.9,76698,NULL,NULL,NULL,'NGC 7755',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164896,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164896,32.23,0.4,27.9,76698,73,NULL,'opt','NGC 7755',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164897,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164897,32.29,0.43,28.7,76698,75,NULL,'MAT, I, inv','NGC 7755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164898,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164898,32.3,0.43,28.9,76698,75,NULL,'MAT, I, cor','NGC 7755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164899,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164899,32.46,0.32,31.1,76698,85,NULL,'I, raw','NGC 7755',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164900,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164900,32.52,0.32,31.9,76698,85,NULL,'I, inv','NGC 7755',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164901,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164901,32.84,0.4,37,76698,75,NULL,'B','NGC 7755',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164902,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164902,35.62,0.36,133,76699,NULL,NULL,NULL,'ESO 149- G 002',NULL,'2009ApJS..182..474S',2009,1,0.85,NULL,'G',0.000033,NULL,'16.08',0.37,'Sc',NULL,NULL,NULL,NULL,1,356.968875,-53.36564,0,NULL,48636394311,759943661,11874119,16.08),(164903,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164903,35.66,0.2,136,76699,74.4,NULL,NULL,'ESO 149- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164904,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164904,35.68,0.35,137,76699,NULL,NULL,'Malmquist cor.','ESO 149- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164905,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164905,35.21,0.49,110,76700,75,NULL,'IR','FGC 2536',NULL,'2011yCatp016004901K',2011,1,1.48,NULL,'G',0.000013,NULL,'16.6',0.09,'Sd',NULL,NULL,NULL,NULL,1,356.986625,28.13167,0.189,NULL,52002983377,812546615,12696040,16.6),(164906,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164906,35.27,NULL,113,76700,NULL,NULL,NULL,'FGC 2536',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164907,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164907,35.46,NULL,123,76700,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2536',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164908,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164908,35.46,NULL,124,76700,NULL,NULL,'Dipole','FGC 2536',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164909,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164909,35.46,NULL,124,76700,NULL,NULL,'Dipole + Quadrupole','FGC 2536',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164910,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164910,38.09,0.27,416,76701,70,NULL,NULL,'2MASX J23475798+1446417',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,356.9917083,14.77817,0.061,NULL,51671807445,807371991,12615187,17.6),(164911,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164911,35.06,0.45,103,76702,NULL,NULL,'K','UGC 12785',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000067,NULL,'14.89',0.4,'S0',NULL,NULL,NULL,NULL,1,357.002833333,27.37539,0.125,NULL,52004172954,812565202,12696331,14.89),(164912,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164912,35.36,0.4,118,76702,NULL,NULL,'mean','UGC 12785',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164913,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164913,35.39,0.44,120,76703,NULL,NULL,'Malmquist cor.','2MASX J23480163+2737251',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000001,NULL,'14.40',0.1,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,357.0067917,27.62378,0.125,NULL,52002525785,812539465,12695929,14.4),(164914,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164914,35.53,0.41,128,76703,NULL,NULL,NULL,'2MASX J23480163+2737251',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164915,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164915,35.65,0.2,135,76703,74.4,NULL,NULL,'2MASX J23480163+2737251',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164916,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164916,35.81,0.43,145,76703,75,NULL,'3.6 micron, color corrected','2MASX J23480163+2737251',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164917,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164917,35.92,0.43,153,76703,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J23480163+2737251',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164918,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 11181',NULL,164918,38.67,1.89,543,76704,70,NULL,'SN photometric redshift distance, z photo =0.136 +/- 0.231','SDSS-II SN 11181',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.2g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,357.0217083,-0.14336,0.125,NULL,49398465232,771851019,12060172,21.2),(164919,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 11181','R',164919,41.14,0.33,1260,76704,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 11181',0.34394,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164920,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 11181','R',164920,41.33,0.28,1370,76704,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 11181',0.34394,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164921,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 11181',NULL,164921,41.04,0.19,1610,76704,70,NULL,'SALT 2','SDSS-II SN 11181',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164922,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 11181',NULL,164922,41.08,0.19,1640,76704,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 11181',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164923,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164923,37.27,0.46,285,76705,70,NULL,NULL,'2MASX J23480849-1046267',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00015,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,357.035458333,-10.77419,0.078,NULL,49623981741,775374714,12115229,16.5),(164924,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164924,33.75,0.45,56.1,76706,70,NULL,NULL,'MCG -01-60-041',NULL,'2014MNRAS.445.2677S',2014,1,0.89,NULL,'G',0.000067,NULL,'14.48',0.51,'Sa',NULL,NULL,NULL,NULL,1,357.047125,-2.43258,0.105,NULL,49397607583,771837618,12059962,14.48),(164925,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164925,37.32,0.46,291,76707,70,NULL,NULL,'2MASX J23481171+1405464',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000214,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,357.0487083,14.09636,0.093,NULL,51652854951,807075858,12610560,16.7),(164926,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164926,38.22,0.46,440,76708,70,NULL,NULL,'2MASX J23481313-0904197',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000177,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,357.054666667,-9.07206,0.083,NULL,49625052934,775391452,12115491,17.6),(164927,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164927,34.64,0.49,84.7,76709,75,NULL,'IR','UGC 12787',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000033,NULL,'16.0',0.2,'Sbc',NULL,NULL,NULL,NULL,1,357.057875,21.21533,0.125,NULL,52481796448,820028069,12812938,16),(164928,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164928,37.88,0.46,376,76710,70,NULL,NULL,'2MASX J23481400+1516584',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,357.05825,15.28286,0.057,NULL,51663884140,807248189,12613252,17.8),(164929,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164929,37.62,0.27,333,76711,70,NULL,NULL,'2MASX J23481801+0106174',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000093,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,357.074958333,1.10475,0.081,NULL,51549350664,805458604,12585290,16.5),(164930,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164930,35.31,0.2,115,76712,74.4,NULL,NULL,'KUG 2345+020',NULL,'2013AJ....146...86T',2013,1,0.7,'The APM image includes a neighboring star.','G',0.0001,NULL,'15.2',0.3,'Spiral',NULL,NULL,NULL,NULL,1,357.075417,2.34228,0.129,NULL,51550247723,805472620,12585509,15.2),(164931,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164931,35.69,0.25,137,76713,74.4,NULL,NULL,'2MASX J23481912-2810439',NULL,'2013AJ....146...86T',2013,1,0.32,NULL,'G',0.000053,NULL,'16.07',0.27,'S0','Group member',NULL,NULL,NULL,1,357.079375,-28.17897,0.025,NULL,50053680056,782088750,12220136,16.07),(164932,'GRB','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164932,47.21,1.54,6250,76714,100,NULL,NULL,'GRB 060707',3.43,'2009EPJC...63..139W',2009,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,357.079167,-17.90472,0.011,NULL,49539379661,774052807,12094575,NULL),(164933,'GRB','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164933,47.33,1.47,6600,76714,100,NULL,NULL,'GRB 060707',3.43,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164934,'GRB','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164934,48.12,1.41,9500,76714,69.7,NULL,'Fiducial','GRB 060707',3.43,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164935,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164935,37.62,0.27,333,76715,70,NULL,NULL,'2MASX J23481940+0108274',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000081,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,357.080833,1.14097,0.081,NULL,51549357162,805458705,12585292,17.6),(164936,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164936,35.11,0.4,105,76716,75,NULL,'Edat, raw','2MASX J23482059-2813544',NULL,'1997ApJS..109..333W',1997,1,1.25,NULL,'G',0.00007,NULL,'14.95',1.57,'E','Group member',NULL,NULL,NULL,1,357.08575,-28.23186,0.025,NULL,50053679095,782088735,12220136,14.95),(164937,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164937,35.15,0.4,107,76716,75,NULL,'Edat, cor','2MASX J23482059-2813544',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164938,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164938,35.09,0.47,104,76716,70,NULL,NULL,'2MASX J23482059-2813544',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164939,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164939,36.13,0.23,168,76716,74.4,NULL,NULL,'2MASX J23482059-2813544',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164940,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164940,35.37,0.25,119,76717,74.4,NULL,NULL,'2MASX J23482105-2806584',NULL,'2013AJ....146...86T',2013,1,0.44,NULL,'G',0.000073,NULL,'15.46',0.27,'SB0/a','Group member',NULL,NULL,NULL,1,357.0877917,-28.11603,0.025,NULL,50053725544,782089461,12220147,15.46),(164941,'L(H{beta})-{sigma}','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164941,45.86,NULL,1621,76718,74.3,NULL,NULL,'[HB89] 2345+000:BX0405',2.03,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,'23.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,357.088416667,0.41264,0.093,NULL,51549154160,805455533,12585242,23.3),(164942,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 21871','RN',164942,40.06,0.28,855,76719,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 21871',0.202701,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164943,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 21871','RN',164943,40.21,0.25,918,76719,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 21871',0.202701,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164944,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164944,35.64,0.25,134,76720,74.4,NULL,NULL,'2MASX J23482326-2804294',NULL,'2013AJ....146...86T',2013,1,0.53,NULL,'G',0.000067,NULL,'15.00',0.43,'S0','Group member',NULL,NULL,NULL,1,357.09675,-28.07489,0.025,NULL,50053720094,782089376,12220146,15),(164945,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164945,36.15,0.46,170,76721,70,NULL,NULL,'2MASX J23482333+1430054',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000181,NULL,'16.1g',0.31,'S0',NULL,NULL,NULL,NULL,1,357.09725,14.50136,0.061,NULL,51663375355,807240239,12613128,16.1),(164946,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164946,36.05,0.52,163,76722,70,NULL,NULL,'2MASX J23482479-6327195',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.59',0.36,NULL,NULL,NULL,NULL,NULL,1,357.103166667,-63.45544,0,NULL,48728987018,761390422,11896725,16.59),(164947,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19992','R',164947,40.49,0.22,1020,76723,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007pb','SN 2007pb',0.226,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,357.104167,-1.185,0.121,NULL,49398998294,771859348,12060302,NULL),(164948,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19992','R',164948,40.68,0.15,1120,76723,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007pb','SN 2007pb',0.226,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164949,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164949,35.17,0.25,108,76724,74.4,NULL,NULL,'2MASX J23482581-2811214',NULL,'2013AJ....146...86T',2013,1,0.29,NULL,'G',0.00006,NULL,'16.12',0.15,'S0','Group member',NULL,NULL,NULL,1,357.10725,-28.18939,0.025,NULL,50053690445,782088913,12220139,16.12),(164950,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164950,35.2,0.25,110,76725,74.4,NULL,NULL,'2MASX J23482619-2816434',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000053,NULL,'15.97',NULL,'S0','Group member',NULL,NULL,NULL,1,357.1089583,-28.27864,0.019,NULL,50052818040,782075281,12219926,15.97),(164951,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164951,35.42,0.62,121,76725,70,NULL,NULL,'2MASX J23482619-2816434',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164952,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164952,36.73,0.63,222,76726,70,NULL,NULL,'2MASX J23482623-2844484',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'16.16',0.42,NULL,NULL,NULL,NULL,NULL,1,357.109375,-28.74681,0.015,NULL,50035162360,781799411,12215615,16.16),(164953,'L(H{beta})-{sigma}','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164953,46.15,NULL,1595,76727,74.3,NULL,NULL,'[HB89] 2345+000:BX0120',2.2664,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,'25.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,357.109583,0.34256,0.093,NULL,51549275329,805457427,12585272,25),(164954,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164954,37.88,0.46,377,76728,70,NULL,NULL,'SDSS J234826.50-101602.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00016,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,357.110458333,-10.26747,0.097,NULL,49613078569,775204352,12112568,18.5),(164955,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164955,35.67,0.25,136,76729,74.4,NULL,NULL,'2MASX J23482680-2806374',NULL,'2013AJ....146...86T',2013,1,0.19,NULL,'G',NULL,NULL,'16.91',0.16,'S0','Group member',NULL,NULL,NULL,1,357.1117083,-28.11031,0.025,NULL,50053715391,782089302,12220145,16.91),(164956,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164956,35.06,0.25,103,76730,74.4,NULL,NULL,'2MASX J23482702-2808594',NULL,'2013AJ....146...86T',2013,1,0.27,NULL,'G',0.000037,NULL,'16.88',0.13,'S0','Group member',NULL,NULL,NULL,1,357.112333333,-28.14975,0.025,NULL,50053716812,782089325,12220145,16.88),(164957,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164957,36.77,0.46,226,76731,70,NULL,NULL,'2MASX J23482886-1043346',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000166,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,357.120375,-10.72622,0.078,NULL,49612471270,775194863,12112419,16.7),(164958,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 12875','RN',164958,40.71,0.27,1100,76732,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 12875',0.264695,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164959,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 12875','RN',164959,40.74,0.28,1110,76732,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 12875',0.264695,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164960,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164960,35.29,0.39,114,76733,NULL,NULL,NULL,'2MASX J23483815-2806494',NULL,'2009ApJS..182..474S',2009,1,0.46,NULL,'G',0.00003,NULL,'14.69',0.22,'SBb','Group member',NULL,NULL,NULL,1,357.158875,-28.11389,0.025,NULL,50053769477,782090148,12220158,14.69),(164961,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164961,35.33,0.2,116,76733,74.4,NULL,NULL,'2MASX J23483815-2806494',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164962,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164962,35.48,0.35,125,76733,NULL,NULL,'Malmquist cor.','2MASX J23483815-2806494',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164963,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19090','R',164963,40.58,0.32,998,76734,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 19090',0.312027,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,357.16225,-0.40642,0.125,NULL,49398565570,771852587,12060196,NULL),(164964,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164964,34.82,NULL,91.9,76735,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2537',NULL,'2010Ap&SS.325..163P',2010,1,0.94,NULL,'G',0.00002,NULL,'16.8',0.1,'Scd',NULL,NULL,NULL,NULL,1,357.17,11.02389,0.133,NULL,51775769608,808996400,12640568,16.8),(164965,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164965,34.82,NULL,92.2,76735,NULL,NULL,'Dipole + Quadrupole','FGC 2537',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164966,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164966,34.83,NULL,92.3,76735,NULL,NULL,'Dipole','FGC 2537',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164967,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164967,34.94,NULL,97.3,76735,NULL,NULL,NULL,'FGC 2537',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164968,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164968,34.98,0.2,99.1,76736,74.4,NULL,NULL,'KUG 2346+156',NULL,'2013AJ....146...86T',2013,1,0.68,NULL,'G',0.000033,NULL,'15.6g',0.45,'Sa','Isolated galaxy',NULL,NULL,NULL,1,357.187833333,15.92878,0.073,NULL,51662770390,807230787,12612981,15.6),(164969,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164969,30.84,0.43,14.7,76737,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7757',NULL,'2014MNRAS.444..527S',2014,1,2.5,'HOLM 817B is a double star.','G',0.000007,NULL,'13.14',1.8,'SA(rs)c','Pair member, wide',NULL,NULL,NULL,1,357.189666667,4.17114,0.137,NULL,51600951190,806264862,12597888,13.14),(164970,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164970,31.12,0.43,16.7,76737,75,NULL,'3.6 micron, color corrected','NGC 7757',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164971,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164971,30.55,0.4,12.9,76738,75,NULL,'B','UGC 12791',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.000003,NULL,'15.76',0.5,'Im:','Group member',NULL,NULL,NULL,1,357.205833,26.22056,0.125,NULL,52003199273,812549988,12696093,15.76),(164972,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164972,37.32,0.46,291,76739,70,NULL,NULL,'2MASX J23485164-0053384',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00015,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,357.215167,-0.89403,0.101,NULL,49407255550,771988367,12062318,16.6),(164973,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164973,35.58,0.48,131,76740,70,NULL,NULL,'2MASX J23485638-6007495',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'15.41',0.63,'S0',NULL,NULL,NULL,NULL,1,357.234833,-60.13039,0,NULL,48747527912,761680123,11901251,15.41),(164974,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164974,34.6,0.49,83.3,76741,75,NULL,'IR','MCG -01-60-042',NULL,'2011yCatp016004901K',2011,1,0.95,NULL,'G',0.00009,NULL,'16',0.12,'Scd            HII',NULL,NULL,NULL,NULL,1,357.241125,-7.05881,0.077,NULL,49441944634,772530384,12070787,16),(164975,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164975,35.16,0.4,108,76742,NULL,NULL,NULL,'2MASX J23490014-2802274',NULL,'2009ApJS..182..474S',2009,1,0.57,NULL,'G',0.000023,NULL,'15.35',0.23,'Sc','Group member',NULL,NULL,NULL,1,357.250541667,-28.04094,0.025,NULL,50053734232,782089597,12220149,15.35),(164976,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164976,35.2,0.2,110,76742,74.4,NULL,NULL,'2MASX J23490014-2802274',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164977,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164977,35.42,0.35,122,76742,NULL,NULL,'Malmquist cor.','2MASX J23490014-2802274',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164978,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164978,34.29,0.8,72.3,76743,75,NULL,'MAT, I','ESO 606- G 011',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.00003,NULL,'14.36',0.7,'SB(rs)bc',NULL,NULL,NULL,NULL,1,357.2527083,-19.69281,0.021,NULL,49540216140,774065877,12094779,14.36),(164979,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164979,33.84,1.16,58.7,76743,NULL,NULL,'Malmquist cor.','ESO 606- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164980,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164980,34.09,0.32,65.8,76743,85,NULL,'I, raw','ESO 606- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164981,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164981,34.13,0.32,66.9,76743,85,NULL,'I, inv','ESO 606- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164982,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164982,34.14,0.43,67.2,76743,75,NULL,'MAT, I, raw','ESO 606- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164983,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164983,34.14,1.01,67.3,76743,NULL,NULL,NULL,'ESO 606- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164984,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164984,34.18,0.2,68.6,76743,74.4,NULL,NULL,'ESO 606- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164985,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164985,34.3,0.43,72.5,76743,75,NULL,'MAT, I, inv','ESO 606- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164986,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164986,34.62,0.43,83.9,76743,75,NULL,'MAT, I, cor','ESO 606- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164987,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164987,35.92,0.8,153,76744,75,NULL,'W91PP, r','UGC 12792',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000007,NULL,'14.60',0.6,'SBb','Group non-member, background',NULL,NULL,NULL,1,357.2565,26.78847,0.093,NULL,52003916039,812561188,12696268,14.6),(164988,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164988,35.15,0.38,107,76744,NULL,NULL,'Malmquist cor.','UGC 12792',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164989,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164989,35.2,0.37,109,76744,NULL,NULL,NULL,'UGC 12792',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164990,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164990,35.24,0.38,112,76744,75,NULL,'W91PP, r, raw','UGC 12792',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164991,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164991,35.43,0.38,122,76744,75,NULL,'W91PP, r, cor','UGC 12792',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164992,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164992,35.45,0.2,123,76744,74.4,NULL,NULL,'UGC 12792',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164993,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164993,35.47,0.38,124,76744,75,NULL,'W91PP, r, inv','UGC 12792',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164994,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164994,35.53,0.43,128,76744,75,NULL,'3.6 micron, color corrected','UGC 12792',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164995,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164995,35.65,0.43,135,76744,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12792',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164996,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164996,36.11,0.4,167,76744,NULL,NULL,'mean','UGC 12792',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164997,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164997,36.21,0.47,174,76744,NULL,NULL,'H','UGC 12792',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164998,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164998,36.04,0.58,162,76745,70,NULL,NULL,'6dF J2349022-350009',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,357.259167,-35.00261,NULL,NULL,49961049146,780641392,12197521,15.1),(164999,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164999,34.97,NULL,98.7,76746,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2539',NULL,'2010Ap&SS.325..163P',2010,1,1.04,NULL,'G',0.000009,NULL,'16.5',0.12,'Scd',NULL,NULL,NULL,NULL,1,357.262625,9.07119,0.209,NULL,51776780616,809012197,12640815,16.5),(165000,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165000,34.98,NULL,98.9,76746,NULL,NULL,'Dipole + Quadrupole','FGC 2539',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165001,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165001,34.98,NULL,99.1,76746,NULL,NULL,'Dipole','FGC 2539',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165002,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165002,35.07,NULL,103,76746,NULL,NULL,NULL,'FGC 2539',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165003,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 20658','RN',165003,41.29,0.78,1650,76747,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20658',0.097288,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165004,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165004,37.6,0.46,331,76748,70,NULL,NULL,'2MASX J23490488+1522596',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000182,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,357.270167,15.38325,0.057,NULL,51664112562,807251758,12613308,17.4),(165005,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 20480','R',165005,40.23,0.2,950,76749,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20480',0.167795,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,357.274208333,0.91828,0.081,NULL,51553890840,805529544,12586399,NULL),(165006,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 20480','R',165006,40.3,0.27,984,76749,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20480',0.167795,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165007,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165007,35.1,0.67,104,76750,70,NULL,NULL,'2MASX J23490899-0558577',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.07',0.2,NULL,NULL,NULL,NULL,NULL,1,357.287416667,-5.98267,0.099,NULL,49438285286,772473207,12069893,16.07),(165008,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 20186','R',165008,41.66,0.3,1590,76751,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007pj','SN 2007pj',0.354,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,357.294583,0.79789,0.093,NULL,51554100315,805532817,12586450,NULL),(165009,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 20186','R',165009,41.82,0.22,1700,76751,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007pj','SN 2007pj',0.354,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165010,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165010,35.7,0.38,138,76752,NULL,NULL,'Malmquist cor.','2MASX J23491554-2758344',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000023,NULL,'16.02',0.21,'Sb','Group member',NULL,NULL,NULL,1,357.3147917,-27.97622,0.015,NULL,50053556431,782086819,12220106,16.02),(165011,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165011,35.92,0.34,153,76752,NULL,NULL,NULL,'2MASX J23491554-2758344',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165012,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165012,35.96,0.2,156,76752,74.4,NULL,NULL,'2MASX J23491554-2758344',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165013,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165013,35.56,0.47,129,76753,70,NULL,NULL,'2MASX J23491898-1708352',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.00015,NULL,'15.27',0.5,NULL,NULL,NULL,NULL,NULL,1,357.32925,-17.14322,0.018,NULL,49531634665,773931791,12092684,15.27),(165014,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165014,37.86,0.46,374,76754,70,NULL,NULL,'2MASX J23492107+1517083',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,357.338,15.28578,0.057,NULL,51664076277,807251191,12613299,17.3),(165015,'Tully est','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165015,29.43,0.8,7.7,76755,75,NULL,NULL,'ESO 348- G 009',NULL,'1988NBGC.C....0000T',1988,1,2.4,'The APMUKS image includes only the bar and a superposed star.','G',0.000003,NULL,'13.6',1,'IBm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,357.347791667,-37.77192,NULL,NULL,49956710794,780573606,12196462,13.6),(165016,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165016,30.3,NULL,11.5,76755,NULL,NULL,NULL,'ESO 348- G 009',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165017,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165017,37.47,0.46,311,76756,70,NULL,NULL,'2MASX J23492553+0024235',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000091,NULL,'16.7g',0.33,'AGN',NULL,NULL,NULL,NULL,1,357.3565417,0.40656,0.085,NULL,51553457864,805522779,12586293,16.7),(165018,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 06714','R',165018,41.82,0.18,1630,76757,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06714',0.4137,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,357.3600417,0.63189,0.093,NULL,51553425525,805522273,12586285,NULL),(165019,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 06714','R',165019,42.02,0.26,1790,76757,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06714',0.4137,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165020,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 06133','RN',165020,40.67,0.18,1110,76758,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 06133',0.224364,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165021,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 06133','RN',165021,41.26,0.23,1460,76758,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 06133',0.224364,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165022,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165022,36.93,0.46,243,76759,70,NULL,NULL,'2MASX J23493106-1022154',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00006,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,357.3795,-10.37103,0.096,NULL,49613105061,775204766,12112574,17.3),(165023,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 17633','RN',165023,39.54,0.29,658,76760,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 17633',0.228607,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165024,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 17633','RN',165024,39.93,0.29,787,76760,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 17633',0.228607,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165025,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165025,36.31,0.75,183,76761,70,NULL,NULL,'ESO 606- G 012',NULL,'2014MNRAS.445.2677S',2014,1,1.25,NULL,'G',0.00015,NULL,'16.82',0.15,'Sbc',NULL,NULL,NULL,NULL,1,357.396667,-18.43511,0,NULL,49542743608,774105368,12095396,16.82),(165026,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 03757','RN',165026,38.48,0.25,464,76762,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 03757',0.070363,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165027,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 03757','RN',165027,39.72,0.39,823,76762,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 03757',0.070363,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165028,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165028,34.18,0.8,68.6,76763,75,NULL,'W91PP, r','UGC 12798',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'15.36',0.3,'S?',NULL,NULL,NULL,NULL,1,357.41625,29.93208,0.165,NULL,51975556794,812118074,12689344,15.36),(165029,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165029,34.08,0.49,65.6,76763,75,NULL,'IR','UGC 12798',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165030,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165030,34.09,0.2,65.8,76763,74.4,NULL,NULL,'UGC 12798',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165031,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165031,34.11,0.38,66.5,76763,75,NULL,'W91PP, r, raw','UGC 12798',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165032,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165032,34.24,0.38,70.3,76763,75,NULL,'W91PP, r, inv','UGC 12798',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165033,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165033,34.33,0.38,73.4,76763,75,NULL,'W91PP, r, cor','UGC 12798',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165034,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165034,37.09,0.46,262,76764,70,NULL,NULL,'2MASX J23494289-1055043',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000062,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,357.428833333,-10.91803,0.078,NULL,49613196882,775206201,12112596,17.6),(165035,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165035,37.71,0.46,349,76765,70,NULL,NULL,'2MASX J23494387+0112187',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000084,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,357.432833,1.20522,0.093,NULL,51554023336,805531614,12586431,16.9),(165036,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165036,32.87,0.75,37.5,76766,NULL,NULL,NULL,'CGCG 498-017',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000033,NULL,'15.32',0.4,'S?',NULL,NULL,NULL,NULL,1,357.448166667,30.03911,0.165,NULL,51975564265,812118191,12689346,15.32),(165037,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165037,32.91,0.2,38.2,76766,74.4,NULL,NULL,'CGCG 498-017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165038,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165038,32.95,0.72,38.8,76766,NULL,NULL,'Malmquist cor.','CGCG 498-017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165039,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165039,36.86,0.53,236,76767,70,NULL,NULL,'2MASX J23494835-1407107',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.68',NULL,NULL,NULL,NULL,NULL,NULL,1,357.451333,-14.11969,0.053,NULL,49555803306,774309426,12098584,16.68),(165040,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 13646',NULL,165040,39.55,0.98,813,76768,70,NULL,'SN photometric redshift distance, z photo =0.212 +/- 0.149','SDSS-II SN 13646',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,357.4725417,-1.03214,0.057,NULL,49407233935,771988030,12062312,NULL),(165041,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 13646','R',165041,41.32,0.24,1400,76768,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13646',0.305435,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165042,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 13646','R',165042,41.5,0.18,1530,76768,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13646',0.305435,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165043,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165043,34.27,0.2,71.5,76769,74.4,NULL,NULL,'UGC 12799',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000037,NULL,'15.37',0.25,'Scd:',NULL,NULL,NULL,NULL,1,357.473833,2.70469,0.129,NULL,51552419751,805506558,12586039,15.37),(165044,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165044,34.39,0.48,75.5,76769,NULL,NULL,NULL,'UGC 12799',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165045,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165045,34.49,0.46,79.1,76769,NULL,NULL,'Malmquist cor.','UGC 12799',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165046,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 03758','RN',165046,41.78,0.17,1780,76770,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03758',0.277427,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165047,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 03758','RN',165047,42.69,0.19,2700,76770,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03758',0.277427,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165048,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165048,37.63,0.46,336,76771,70,NULL,NULL,'2MASX J23495516+1601286',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,357.47975,16.02447,0.057,NULL,51662657719,807229026,12612953,17.6),(165049,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165049,38.03,0.33,404,76772,70,NULL,NULL,'2MASX J23495786+1424206',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000156,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,357.491167,14.40589,0.057,NULL,51645731886,806964560,12608821,17.3),(165050,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 01658',NULL,165050,39.75,0.21,891,76773,70,NULL,'SN photometric redshift distance, z photo =0.235 +/- 0.027','SDSS-II SN 01658',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,357.504417,0.65006,0.101,NULL,51553439427,805522491,12586288,NULL),(165051,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 01658','R',165051,40.83,0.23,1150,76773,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01658',0.277296,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165052,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 01658','R',165052,40.93,0.17,1200,76773,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01658',0.277296,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165053,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 01658',NULL,165053,40.79,0.13,1440,76773,70,NULL,'SALT 2','SDSS-II SN 01658',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165054,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 01658',NULL,165054,40.81,0.13,1450,76773,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 01658',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165055,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165055,38.03,0.33,404,76774,70,NULL,NULL,'2MASX J23500220+1426536',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000183,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,357.509125,14.44828,0.057,NULL,51645737676,806964651,12608822,17.3),(165056,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2005ko',NULL,165056,38.99,0.12,528,76775,74.2,NULL,'SALT 2','SDSS J235005.06-005517.4',0.19,'2010ApJ...716..712A',2010,1,0.07,NULL,'G',0.0005,NULL,'21.5g',0.04,NULL,NULL,NULL,NULL,NULL,1,357.521083333,-0.92153,0.085,NULL,49407745434,771996022,12062437,21.5),(165057,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2005ko',NULL,165057,39.12,0.09,667,76775,70,NULL,'Hubble residual -0.16 for z0.18470','SDSS J235005.06-005517.4',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165058,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2005ko',NULL,165058,39.58,0.14,691,76775,70,NULL,'SALT 2','SDSS J235005.06-005517.4',0.19,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165059,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2005ko',NULL,165059,39.6,0.13,698,76775,65,NULL,'MLCS2k2','SDSS J235005.06-005517.4',0.19,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165060,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 08213','R',165060,39.62,0.2,709,76775,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ko','SDSS J235005.06-005517.4',0.1847,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165061,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 08213','R',165061,39.62,0.14,710,76775,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ko','SDSS J235005.06-005517.4',0.1847,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165062,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2005ko',NULL,165062,39.65,0.12,714,76775,65,NULL,'SALT2','SDSS J235005.06-005517.4',0.19,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165063,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2005ko',NULL,165063,39.44,0.09,773,76775,70,NULL,'SALT 2','SDSS J235005.06-005517.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165064,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2005ko',NULL,165064,39.45,0.09,776,76775,70,NULL,'SALT 2, Malmquist cor.','SDSS J235005.06-005517.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165065,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2005ko',NULL,165065,41.01,0.04,1340,76775,70,NULL,'SDSS-II SN 08213','SDSS J235005.06-005517.4',0.19,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165066,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 08264',NULL,165066,39.82,0.37,920,76776,70,NULL,'SN photometric redshift distance, z photo =0.244 +/- 0.053','SDSS-II SN 08264',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.6g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,357.539375,0.82011,0.101,NULL,51554231927,805534873,12586482,21.6),(165067,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 08264','R',165067,40.72,0.31,1120,76776,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 08264',0.237519,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165068,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 08264','R',165068,40.78,0.24,1160,76776,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 08264',0.237519,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165069,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 20141','R',165069,40.87,0.27,1110,76777,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J235009.88-003128.1',0.3415,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',0.0001,NULL,'20.9g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,357.541166667,-0.52447,0.089,NULL,49406955580,771983680,12062245,20.9),(165070,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 20141','R',165070,41.02,0.2,1190,76777,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J235009.88-003128.1',0.3415,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165071,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 20141',NULL,165071,40.7,0.16,1380,76777,70,NULL,'SALT 2','SDSS J235009.88-003128.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165072,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 20141',NULL,165072,40.74,0.16,1410,76777,70,NULL,'SALT 2, Malmquist cor.','SDSS J235009.88-003128.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165073,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165073,35.79,0.57,144,76778,70,NULL,NULL,'2MASX J23501716-0408040',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'16.51',0.31,NULL,NULL,NULL,NULL,NULL,1,357.571583,-4.13453,0.131,NULL,49448069686,772626088,12072282,16.51),(165074,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165074,38.11,0.33,418,76779,70,NULL,NULL,'2MASX J23501756-0044060',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000087,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,357.573167,-0.73489,0.089,NULL,49407672799,771994887,12062420,17.7),(165075,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165075,38.11,0.33,418,76780,70,NULL,NULL,'2MASX J23501890-0048530',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000093,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,357.578625,-0.81469,0.089,NULL,49407801670,771996901,12062451,17.2),(165076,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165076,36.1,0.78,166,76781,70,NULL,NULL,'2MASX J23502403-8148542',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,357.599667,-81.81497,0.397,NULL,48348836960,755450577,11803915,17.5),(165077,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165077,36.2,0.64,174,76782,70,NULL,NULL,'ESO 111-IG 004',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'16.73',0.23,'E ?',NULL,NULL,NULL,NULL,1,357.606375,-59.5125,0,NULL,48752261062,761754079,11902407,16.73),(165078,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165078,38.18,0.46,433,76783,70,NULL,NULL,'SDSS J235025.89+150142.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,357.607875,15.02853,0.057,NULL,51664278403,807254350,12613349,18.6),(165079,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165079,36.95,0.53,246,76784,70,NULL,NULL,'2MASX J23502772-2415415',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.22',0.42,'E',NULL,NULL,NULL,NULL,1,357.615458333,-24.26153,0.033,NULL,50011900500,781435945,12209936,16.22),(165080,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165080,38.21,0.33,439,76785,70,NULL,NULL,'2MASX J23503389-0852041',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000092,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,357.641083,-8.86794,0.102,NULL,49427886482,772310726,12067355,17.3),(165081,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165081,34.75,0.69,89.1,76786,100,NULL,'mid-IR','UGC 12803',NULL,'2013ApJ...771...88L',2013,1,1.1,NULL,'G',0.000033,NULL,'14.93',0.7,'Sb','Group member, peripheral',NULL,NULL,NULL,1,357.641458333,28.99828,0.165,NULL,51970416764,812037761,12688090,14.93),(165082,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165082,35.54,0.4,128,76786,NULL,NULL,'mean','UGC 12803',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165083,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165083,35.65,0.45,135,76786,NULL,NULL,'K','UGC 12803',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165084,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165084,35.66,0.47,135,76786,NULL,NULL,'H','UGC 12803',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165085,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165085,35.73,0.07,140,76786,NULL,NULL,NULL,'UGC 12803',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165086,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165086,35.77,0.46,143,76786,NULL,NULL,'J','UGC 12803',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165087,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165087,38.21,0.33,439,76787,70,NULL,NULL,'2MASX J23503714-0851351',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000077,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,357.654625,-8.85989,0.102,NULL,49427884853,772310700,12067354,17.6),(165088,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165088,35.03,0.49,101,76788,75,NULL,'IR','UGC 12802',NULL,'2011yCatp016004901K',2011,1,1.25,NULL,'G',0.000058,NULL,'16.5',0.09,'Scd',NULL,NULL,NULL,NULL,1,357.659125,14.48075,0.037,NULL,51645717340,806964333,12608817,16.5),(165089,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165089,35.22,NULL,111,76788,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12802',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165090,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165090,35.24,NULL,112,76788,NULL,NULL,'Dipole + Quadrupole','UGC 12802',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165091,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165091,35.25,NULL,112,76788,NULL,NULL,'Dipole','UGC 12802',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165092,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165092,35.28,NULL,114,76788,NULL,NULL,NULL,'UGC 12802',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165093,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 07614','RN',165093,41.77,0.23,1620,76789,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 07614',0.397018,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165094,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 07614','RN',165094,42.43,0.26,2200,76789,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 07614',0.397018,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165095,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 02551','RN',165095,41.76,0.36,1800,76790,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02551',0.249061,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165096,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 02551','RN',165096,41.91,0.33,1930,76790,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 02551',0.249061,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165097,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165097,36.24,0.53,177,76791,70,NULL,NULL,'CGCG 381-054',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.0001,NULL,'15.4',0.2,NULL,NULL,NULL,NULL,NULL,1,357.695833,-2.18819,0.113,NULL,49405522025,771961281,12061895,15.4),(165098,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 01395','RN',165098,39.56,0.22,687,76792,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01395',0.186404,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165099,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 01395','RN',165099,39.9,0.18,804,76792,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01395',0.186404,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165100,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 21385','N',165100,41.26,0.27,1790,76793,70,NULL,'SALT 2','SDSS-II SN 21385',NULL,'2013ApJ...763...88C',2013,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165101,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 21385','N',165101,41.3,0.27,1820,76793,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 21385',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165102,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165102,35.83,0.2,147,76794,74.4,NULL,NULL,'CGCG 432-034',NULL,'2013AJ....146...86T',2013,1,0.76,NULL,'G',0.000086,NULL,'15.4g',0.55,'Sc',NULL,NULL,NULL,NULL,1,357.700583,15.65117,0.069,NULL,51664459666,807257182,12613393,15.4),(165103,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165103,34.79,0.25,90.8,76795,74.4,NULL,NULL,'NGC 7765',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000047,NULL,'15.46',0.7,'S','Group member',NULL,NULL,NULL,1,357.717333,27.16628,0.133,NULL,52004576271,812571504,12696429,15.46),(165104,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165104,34.99,0.27,99.7,76795,70,NULL,NULL,'NGC 7765',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165105,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165105,31.56,0.4,20.5,76796,75,NULL,'B','NGC 7764',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000022,NULL,'12.6',1.4,'IB(s)m',NULL,NULL,NULL,'H_alpha Emission-Line Galaxy',1,357.724916667,-40.72822,NULL,NULL,49934745910,780230404,12191100,12.6),(165106,'BCG','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165106,35.24,0.35,109,76797,60,NULL,NULL,'ABELL 2666',0.0273,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',0.000297,NULL,NULL,NULL,'I      [BM]',NULL,NULL,NULL,NULL,1,357.734291667,27.14475,0.133,NULL,52004585451,812571647,12696431,NULL),(165107,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165107,38.14,0.46,425,76798,70,NULL,NULL,'2MASX J23505628-1104199',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000094,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,357.734458333,-11.07228,0.048,NULL,49613300895,775207826,12112622,17.1),(165108,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165108,35.14,0.8,107,76799,75,NULL,'W91PP, r','NGC 7767',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.00009,NULL,'14.50',0.2,'S0/a','in a radial-velocity based grouping',NULL,NULL,NULL,1,357.7347917,27.08714,0.133,NULL,52004578914,812571545,12696430,14.5),(165109,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165109,35.49,0.38,125,76799,75,NULL,'W91PP, r, raw','NGC 7767',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165110,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165110,35.55,0.49,129,76799,75,NULL,'IR','NGC 7767',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165111,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165111,35.68,0.38,137,76799,75,NULL,'W91PP, r, cor','NGC 7767',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165112,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165112,35.81,0.38,145,76799,75,NULL,'W91PP, r, inv','NGC 7767',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165113,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 1968Z',NULL,165113,35.39,0.09,120,76800,74.4,NULL,NULL,'NGC 7768',NULL,'2013AJ....146...86T',2013,1,1.6,'1980AJ.....85..626H has z = 0.02612 +- 0.000267.','G',0.000053,NULL,'13.24',1.3,'cD;E','in a radial-velocity based grouping',NULL,NULL,NULL,1,357.744083333,27.14739,0.133,NULL,52004585297,812571645,12696431,13.24),(165114,'BCG','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165114,35.24,0.35,109,76800,60,NULL,'ABELL 2666, BCG','NGC 7768',0.0273,'1980ApJ...241..486H',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165115,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165115,34.15,0.4,67.5,76800,75,NULL,'Edat, raw','NGC 7768',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165116,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165116,34.48,0.4,78.7,76800,75,NULL,'Edat, cor','NGC 7768',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165117,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165117,34.99,0.27,99.7,76800,70,NULL,NULL,'NGC 7768',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165118,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165118,35.39,0.09,120,76800,74.4,NULL,NULL,'NGC 7768',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165119,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165119,35.08,0.45,104,76800,NULL,NULL,'K','NGC 7768',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165120,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165120,35.25,0.4,112,76800,NULL,NULL,'mean','NGC 7768',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165121,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165121,34.56,0.49,81.7,76801,75,NULL,'IR','CGCG 477-020',NULL,'2011yCatp016004901K',2011,1,0.7,'1980AJ.....85..626H has V = 7468 +- 80 km/s; 1998AJ....116.1529H 7187 +- 31.','G',0.000067,NULL,'15.58',0.2,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,357.749916667,27.21906,0.133,NULL,52004558827,812571231,12696425,15.58),(165122,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165122,35.12,0.43,105,76801,NULL,NULL,'Malmquist cor.','CGCG 477-020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165123,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165123,35.14,0.42,107,76801,NULL,NULL,NULL,'CGCG 477-020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165124,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165124,35.19,0.2,109,76801,74.4,NULL,NULL,'CGCG 477-020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165125,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165125,35.93,NULL,154,76802,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12807',NULL,'2010Ap&SS.325..163P',2010,1,0.92,NULL,'G',0.000017,NULL,'17.',0.09,'Sd',NULL,NULL,NULL,NULL,1,357.750583,35.782,0.309,NULL,51857535965,810273999,12660531,17),(165126,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165126,35.95,0.49,155,76802,75,NULL,'IR','UGC 12807',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165127,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165127,35.95,NULL,155,76802,NULL,NULL,'Dipole + Quadrupole','UGC 12807',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165128,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165128,35.97,NULL,156,76802,NULL,NULL,NULL,'UGC 12807',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165129,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165129,35.97,NULL,156,76802,NULL,NULL,'Dipole','UGC 12807',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165130,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165130,36.38,0.2,189,76802,74.4,NULL,NULL,'UGC 12807',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165131,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165131,36.45,0.43,195,76802,75,NULL,'3.6 micron, color corrected','UGC 12807',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165132,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165132,36.51,0.43,201,76802,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12807',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165133,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 12876','RN',165133,39.39,0.08,686,76803,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 12876',0.10019,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165134,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165134,34.81,0.25,91.6,76804,74.4,NULL,NULL,'KUG 2348+270B',NULL,'2013AJ....146...86T',2013,1,0.2,NULL,'G',0.000067,NULL,'14.91',0.2,'Compact',NULL,NULL,NULL,NULL,1,357.7530417,27.28881,0.101,NULL,52005070054,812579219,12696550,14.91),(165135,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165135,34.99,0.27,99.7,76804,70,NULL,NULL,'KUG 2348+270B',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165136,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165136,34.81,0.25,91.6,76805,74.4,NULL,NULL,'GIN 740',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000057,NULL,'14.63',0.3,'E/S0',NULL,NULL,NULL,NULL,1,357.754625,27.25767,0.133,NULL,52004559635,812571244,12696425,14.63),(165137,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165137,34.99,0.27,99.7,76805,70,NULL,NULL,'GIN 740',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165138,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2011iu',NULL,165138,36.32,0.17,184,76806,72,NULL,'M(H) = -18.317 mag','UGC 12809',NULL,'2014ApJ...784..105W',2013,1,1.4,NULL,'G',0.000023,NULL,'14.6',1.2,'Sb',NULL,NULL,NULL,NULL,1,357.7632917,46.72367,0.541,NULL,53152645647,830510088,12976720,14.6),(165139,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165139,37.63,0.33,335,76807,70,NULL,NULL,'2MASX J23510328+1458426',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,357.763625,14.97847,0.057,NULL,51664261678,807254088,12613345,18.1),(165140,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165140,35.12,0.8,106,76808,75,NULL,'A82, H','UGC 12810',NULL,'1997ApJS..109..333W',1997,1,0.55,NULL,'G',0.00004,NULL,'14.4g',0.25,'(R\')SAB(r)bc pec:',NULL,NULL,NULL,NULL,1,357.7760417,1.05672,0.113,NULL,51554068043,805532313,12586442,14.4),(165141,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165141,35.12,0.8,106,76808,75,NULL,'CF, r','UGC 12810',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165142,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165142,34.34,0.33,73.9,76808,91,NULL,'H','UGC 12810',NULL,'1984ApJ...278..475B',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165143,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165143,34.58,0.38,82.4,76808,75,NULL,'CF, r, raw','UGC 12810',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165144,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165144,34.73,0.47,88.5,76808,75,NULL,'A82, H, raw','UGC 12810',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165145,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165145,34.75,0.38,89.2,76808,75,NULL,'CF, r, inv','UGC 12810',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165146,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165146,34.78,0.38,90.3,76808,75,NULL,'CF, r, cor','UGC 12810',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165147,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165147,34.84,0.37,92.7,76808,NULL,NULL,'Malmquist cor.','UGC 12810',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165148,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165148,34.89,0.2,95.1,76808,74.4,NULL,NULL,'UGC 12810',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165149,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165149,34.91,0.36,96.1,76808,NULL,NULL,NULL,'UGC 12810',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165150,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165150,34.92,0.47,96.5,76808,75,NULL,'A82, H, inv','UGC 12810',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165151,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165151,35.02,0.47,101,76808,75,NULL,'A82, H, cor','UGC 12810',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165152,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165152,35.24,0.4,112,76808,NULL,NULL,'mean','UGC 12810',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165153,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165153,35.26,0.47,113,76808,NULL,NULL,'H','UGC 12810',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165154,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165154,35.36,0.45,118,76808,NULL,NULL,'K','UGC 12810',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165155,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165155,35.37,0.46,119,76808,NULL,NULL,'J','UGC 12810',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165156,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165156,36.4,0.81,191,76809,70,NULL,NULL,'2MASX J23510644-1337536',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'17.39',0.27,NULL,NULL,NULL,NULL,NULL,1,357.7769583,-13.63142,0.022,NULL,49556525937,774320717,12098761,17.39),(165157,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2006fu',NULL,165157,39.52,0.08,802,76810,70,NULL,'Hubble residual 0.10 for z0.19855','SDSS J235108.37-004447.6',NULL,'2011ApJ...740...92G',2011,1,0.11,NULL,'G',0.00009,NULL,'19.6g',0.09,NULL,NULL,NULL,NULL,NULL,1,357.784916667,-0.74658,0.093,NULL,49407663288,771994738,12062417,19.6),(165158,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 13070','R',165158,40.01,0.19,838,76810,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006fu','SDSS J235108.37-004447.6',0.19855,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165159,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 13070','R',165159,40.25,0.1,937,76810,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006fu','SDSS J235108.37-004447.6',0.19855,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165160,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165160,37.12,0.46,266,76811,70,NULL,NULL,'2MASX J23510978+1400269',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,357.7907917,14.0075,0.073,NULL,51653448225,807085128,12610705,17.1),(165161,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19129','RN',165161,38.44,0.23,442,76812,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 19129',0.101259,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165162,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19129','RN',165162,38.87,0.24,539,76812,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19129',0.101259,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165163,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165163,33.97,0.49,62.3,76813,75,NULL,'IR','UGC 12812',NULL,'2011yCatp016004901K',2011,1,0.9,'UZC has V = 4576 +- 62 km/sec.','G',0.000057,NULL,'15.5',0.2,'Sc             HII','Pair member (points to parent)',NULL,NULL,NULL,1,357.8277083,20.57792,0.101,NULL,51608364535,806380695,12599698,15.5),(165164,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165164,35.45,0.43,123,76814,75,NULL,'3.6 micron, color + selection bias corrected','KUG 2348+243A',NULL,'2014MNRAS.444..527S',2014,1,0.5,NULL,'G',0.000013,NULL,'15.7',0.3,'Spiral',NULL,NULL,NULL,NULL,1,357.8357917,24.65789,0.149,NULL,51959031907,811859873,12685310,15.7),(165165,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165165,35.5,0.43,126,76814,75,NULL,'3.6 micron, color corrected','KUG 2348+243A',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165166,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165166,35.6,0.2,132,76814,74.4,NULL,NULL,'KUG 2348+243A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165167,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165167,34.46,0.49,77.8,76815,75,NULL,'IR','UGC 12814',NULL,'2011yCatp016004901K',2011,1,1.27,NULL,'G',0.00007,NULL,'15.2',0.15,'Sd',NULL,NULL,NULL,NULL,1,357.837,49.07842,0.741,NULL,53157610648,830587666,12977932,15.2),(165168,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165168,34.56,0.31,81.5,76815,NULL,NULL,'Malmquist cor.','UGC 12814',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165169,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165169,34.76,0.43,89.4,76815,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12814',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165170,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165170,34.76,0.2,89.5,76815,74.4,NULL,NULL,'UGC 12814',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165171,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165171,34.77,0.43,90.1,76815,75,NULL,'3.6 micron, color corrected','UGC 12814',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165172,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165172,34.78,0.28,90.4,76815,NULL,NULL,NULL,'UGC 12814',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165173,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165173,34.96,NULL,98.1,76815,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12814',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165174,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165174,34.97,NULL,98.6,76815,NULL,NULL,'Dipole + Quadrupole','UGC 12814',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165175,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165175,34.97,NULL,98.8,76815,NULL,NULL,'Dipole','UGC 12814',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165176,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165176,35.02,NULL,101,76815,NULL,NULL,NULL,'UGC 12814',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165177,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165177,37.3,0.46,288,76816,70,NULL,NULL,'2MASX J23512215-0911501',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000085,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,357.8422917,-9.19719,0.13,NULL,49612128815,775189512,12112336,17.2),(165178,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165178,36.35,0.35,186,76817,NULL,NULL,'Malmquist cor.','2MASX J23512348+0606305',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',NULL,NULL,'15.7V',0.2,NULL,NULL,NULL,NULL,NULL,1,357.847958333,6.10858,0.193,NULL,51567041930,805735030,12589609,15.7),(165179,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165179,36.5,0.33,200,76817,NULL,NULL,NULL,'2MASX J23512348+0606305',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165180,'SNII optical','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2003hg',NULL,165180,33.14,0.54,42.5,76818,NULL,NULL,'SCM, I','NGC 7771',NULL,'2010ApJ...715..833O',2010,1,2.5,NULL,'G',0.000007,NULL,'12.2B',1,'SB(s)a;HII;LIRGSbrst','Pair member, wide',NULL,NULL,NULL,1,357.853375,20.11175,0.113,NULL,51608724244,806386316,12599786,12.2),(165181,'SNII optical','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2003hg',NULL,165181,33.18,0.54,43.3,76818,NULL,NULL,'SCM, V','NGC 7771',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165182,'SNII optical','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2003hg',NULL,165182,33.31,0.28,45.9,76818,NULL,NULL,'SCM, BVI','NGC 7771',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165183,'SNII optical','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2003hg',NULL,165183,33.5,0.42,50.1,76818,NULL,NULL,'SCM, B','NGC 7771',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165184,'SNII optical','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2003hg',NULL,165184,33.51,0.14,50.4,76818,NULL,NULL,'I, photospheric magnitude method','NGC 7771',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165185,'SNII optical','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2003hg',NULL,165185,33.52,0.34,50.6,76818,NULL,NULL,'V, photospheric magnitude method','NGC 7771',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165186,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165186,33.43,0.45,48.4,76818,NULL,NULL,'K','NGC 7771',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165187,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165187,33.5,0.47,50,76818,NULL,NULL,'H','NGC 7771',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165188,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165188,33.57,0.46,51.7,76818,NULL,NULL,'J','NGC 7771',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165189,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165189,33.83,0.4,58.4,76818,NULL,NULL,'mean','NGC 7771',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165190,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165190,33.37,0.45,47.2,76819,NULL,NULL,'K','MRK 0331',NULL,'2007A&A...465...71T',2007,1,0.7,NULL,'G',0.000017,NULL,'14.87',0.4,'Sa;LIRG      HII;Sy2','Pair member (points to parent)',NULL,NULL,NULL,1,357.861667,20.58608,0.101,NULL,51608365882,806380716,12599698,14.87),(165191,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165191,33.41,0.47,48.2,76819,NULL,NULL,'H','MRK 0331',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165192,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165192,33.62,0.46,53.1,76819,NULL,NULL,'J','MRK 0331',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165193,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165193,34.22,0.4,69.9,76819,NULL,NULL,'mean','MRK 0331',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165194,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2002ef',NULL,165194,34.78,0.16,88.3,76820,70,NULL,'SALT 2','NGC 7761',0.023977,'2013MNRAS.433.2240G',2013,1,1.2,NULL,'G',0.000073,NULL,'13.95',1.2,'SA(rs)0^0^:',NULL,NULL,NULL,NULL,1,357.870375,-13.38158,0.039,NULL,49559649554,774369524,12099523,13.95),(165195,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165195,33.94,0.48,61.4,76820,70,NULL,NULL,'NGC 7761',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165196,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165196,34.8,0.25,91.2,76821,74.4,NULL,NULL,'CGCG 477-023',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000063,NULL,'14.20',0.7,'E/S0','Group member',NULL,NULL,NULL,1,357.874833333,27.23625,0.109,NULL,52004562491,812571288,12696426,14.2),(165197,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165197,34.99,0.27,99.7,76821,70,NULL,NULL,'CGCG 477-023',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165198,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 05689','R',165198,39.42,0.1,653,76822,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 05689',0.171207,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,357.883,0.82756,0.113,NULL,51554162971,805533796,12586465,NULL),(165199,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 05689','R',165199,39.5,0.2,678,76822,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05689',0.171207,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165200,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165200,35.95,0.25,155,76823,74.4,NULL,NULL,'2MASX J23513462-2804182',NULL,'2013AJ....146...86T',2013,1,0.38,NULL,'G',0.000039,NULL,'16.0',0.27,'E','Group member',NULL,NULL,NULL,1,357.8942083,-28.07169,0,NULL,50054070911,782094857,12220232,16),(165201,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165201,34.72,0.4,87.9,76824,75,NULL,'Edat, raw','IC 5362',NULL,'1997ApJS..109..333W',1997,1,1.4,'The IC 5363 identification is uncertain.','G',0.000031,NULL,'14.15',1.3,'SA0^0^ pec:','Group member',NULL,NULL,NULL,1,357.903041667,-28.36506,0.008,NULL,50053035294,782078676,12219979,14.15),(165202,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165202,35.09,0.4,104,76824,75,NULL,'Edat, cor','IC 5362',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165203,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165203,35.03,0.23,101,76824,74.4,NULL,NULL,'IC 5362',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165204,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165204,35.27,0.4,113,76824,NULL,NULL,'mean','IC 5362',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165205,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165205,35.27,0.45,113,76824,NULL,NULL,'K','IC 5362',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165206,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165206,37.36,0.33,296,76825,70,NULL,NULL,'2MASX J23513696+0053069',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000118,NULL,'16.2g',0.38,'NLAGN',NULL,NULL,NULL,NULL,1,357.904,0.88533,0.101,NULL,51553685750,805526339,12586349,16.2),(165207,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2007oj',NULL,165207,38.65,0.15,538,76826,70,NULL,'Hubble residual 0.18 for z0.12300','SDSS J235138.00+001647.3',NULL,'2011ApJ...740...92G',2011,1,0.05,NULL,'G',0.005,NULL,'21.6g',0.04,NULL,NULL,NULL,NULL,NULL,1,357.908375,0.27983,0.117,NULL,51542669498,805354210,12583659,21.6),(165208,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19543','R',165208,38.95,0.21,550,76826,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007oj','SDSS J235138.00+001647.3',0.123,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165209,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19543','R',165209,39.15,0.08,603,76826,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007oj','SDSS J235138.00+001647.3',0.123,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165210,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165210,37.63,0.33,335,76827,70,NULL,NULL,'2MASX J23514269+1455464',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000141,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,357.927917,14.92953,0.053,NULL,51646114412,806970537,12608914,17.7),(165211,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165211,36.92,0.46,242,76828,70,NULL,NULL,'2MASX J23514434+1536334',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000164,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,357.934708333,15.60936,0.073,NULL,51664787393,807262303,12613473,16.9),(165212,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 17476','RN',165212,41.38,0.13,1520,76829,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 17476',0.244274,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165213,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 17476','RN',165213,41.59,0.2,1670,76829,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17476',0.244274,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165214,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 12311','RN',165214,42.46,0.35,2190,76830,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 12311',0.415049,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165215,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165215,37.54,0.46,323,76831,70,NULL,NULL,'2MASXi J2351455-105516',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000079,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,357.939583,-10.92117,0.051,NULL,49612676720,775198073,12112469,18),(165216,'Cepheids','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165216,24.86,0.06,0.938,76832,NULL,18.52,NULL,'Pegasus Dwarf Spheroidal',NULL,'2011A&A...531A.134T',2010,1,4,NULL,'G',0.00001,NULL,'14.17',2,'dSph','Brightest group member',NULL,NULL,NULL,1,357.942917,24.5825,0.149,1,51958940339,811858442,12685288,14.17),(165217,'CMD','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165217,24.6,NULL,0.832,76832,NULL,NULL,NULL,'Pegasus Dwarf Spheroidal',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165218,'CMD','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165218,24.94,NULL,0.973,76832,NULL,NULL,NULL,'Pegasus Dwarf Spheroidal',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165219,'Horizontal Branch','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165219,24.6,0.15,0.832,76832,NULL,NULL,NULL,'Pegasus Dwarf Spheroidal',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165220,'RR Lyrae','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165220,24.37,0.09,0.748,76832,NULL,NULL,'V','Pegasus Dwarf Spheroidal',NULL,'2013MNRAS.435.3206D',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165221,'RR Lyrae','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165221,24.56,0.06,0.815,76832,NULL,NULL,NULL,'Pegasus Dwarf Spheroidal',NULL,'2002AJ....124.1464P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165222,'RR Lyrae','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165222,24.59,NULL,0.828,76832,NULL,NULL,NULL,'Pegasus Dwarf Spheroidal',NULL,'2008ApJ...679...52T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165223,'TRGB','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165223,24.45,0.1,0.775,76832,NULL,NULL,'I','Pegasus Dwarf Spheroidal',NULL,'1999AJ....118.1220A',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165224,'TRGB','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165224,24.47,0.07,0.783,76832,NULL,NULL,NULL,'Pegasus Dwarf Spheroidal',NULL,'2005MNRAS.356..979M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165225,'TRGB','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165225,24.5,0.2,0.794,76832,NULL,NULL,'I','Pegasus Dwarf Spheroidal',NULL,'1999A&A...342L...9H',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165226,'TRGB','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165226,24.57,0.25,0.82,76832,NULL,NULL,'I','Pegasus Dwarf Spheroidal',NULL,'1999AstL...25..332T',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165227,'TRGB','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165227,24.6,0.2,0.83,76832,NULL,NULL,'I','Pegasus Dwarf Spheroidal',NULL,'1999ApJ...511L.101G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165228,'TRGB','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165228,24.61,0.12,0.836,76832,NULL,NULL,'HST KP Calibrated','Pegasus Dwarf Spheroidal',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165229,'TRGB','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165229,24.7,0.1,0.871,76832,NULL,NULL,'I, M(I) = -4.0 mag','Pegasus Dwarf Spheroidal',NULL,'1999IAUS..192..284G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165230,'TRGB','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165230,24.9,0.09,0.955,76832,NULL,NULL,'I','Pegasus Dwarf Spheroidal',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165231,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 16150','RN',165231,39.79,0.32,847,76833,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 16150',0.071708,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165232,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 16150','RN',165232,40.52,0.47,1180,76833,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 16150',0.071708,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165233,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165233,37.36,0.33,296,76834,70,NULL,NULL,'2MASX J23514743+0058218',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000081,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,357.9475417,0.97278,0.101,NULL,51553678053,805526219,12586347,16.9),(165234,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165234,37.52,0.46,319,76835,70,NULL,NULL,'2MASX J23514781+1400314',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,357.949291667,14.00889,0.073,NULL,51653494408,807085850,12610716,17.1),(165235,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 02417','RN',165235,43.73,0.27,3940,76836,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02417',0.417919,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165236,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 02417','RN',165236,43.89,0.37,4240,76836,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 02417',0.417919,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165237,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 09186','RN',165237,42.93,0.25,2750,76837,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 09186',0.403944,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165238,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 09186','RN',165238,43.2,0.25,3110,76837,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 09186',0.403944,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165239,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 1993ah',NULL,165239,34.61,0.23,81.2,76838,74.2,NULL,'SALT 2','ESO 471- G 027',0.02936,'2010ApJ...716..712A',2010,1,1.28,NULL,'G',0.000033,NULL,'14.9b',0.44,'SBb(rs)','Group member',NULL,NULL,NULL,1,357.95975,-27.96533,0,NULL,50054260793,782097824,12220278,14.9),(165240,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 1993ah',NULL,165240,35.25,0.42,109,76838,70,NULL,'SALT 2','ESO 471- G 027',0.02936,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165241,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 1993ah',NULL,165241,35.23,0.09,111,76838,74.4,NULL,NULL,'ESO 471- G 027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165242,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 1993ah',NULL,165242,35.35,0.07,114,76838,72,NULL,NULL,'ESO 471- G 027',0.02936,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165243,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 1993ah',NULL,165243,35.53,0.21,124,76838,65,NULL,NULL,'ESO 471- G 027',0.02936,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165244,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 1993ah',NULL,165244,35.53,0.1,124,76838,70,NULL,'SALT','ESO 471- G 027',0.02936,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165245,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 1993ah',NULL,165245,35.5,0.12,126,76838,70.8,NULL,NULL,'ESO 471- G 027',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165246,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 1993ah',NULL,165246,35.64,0.2,127,76838,65,NULL,'MLCS2k2','ESO 471- G 027',0.02936,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165247,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 1993ah',NULL,165247,35.65,0.21,135,76838,60,NULL,'M(B) = -19.48 mag','ESO 471- G 027',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165248,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 1993ah',NULL,165248,35.69,0.14,137,76838,60,NULL,NULL,'ESO 471- G 027',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165249,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 1993ah',NULL,165249,35.71,0.16,139,76838,60,NULL,'M(V) = -19.47 mag','ESO 471- G 027',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165250,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 1993ah',NULL,165250,35.77,0.15,143,76838,60,NULL,'M(I) = -19.19 mag','ESO 471- G 027',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165251,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165251,34.14,0.8,67.4,76839,75,NULL,'CF, r','UGC 12816',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00003,NULL,'14.50',0.9,'SAB(rs)cd:',NULL,NULL,NULL,NULL,1,357.9610417,3.08272,0.141,NULL,51545813143,805403330,12584427,14.5),(165252,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165252,33.68,0.38,54.3,76839,75,NULL,'CF, r, raw','UGC 12816',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165253,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165253,33.72,0.38,55.4,76839,75,NULL,'CF, r, inv','UGC 12816',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165254,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165254,34,0.38,63.2,76839,75,NULL,'CF, r, cor','UGC 12816',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165255,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165255,34.06,0.2,64.9,76839,74.4,NULL,NULL,'UGC 12816',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165256,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165256,34.31,0.45,72.6,76839,NULL,NULL,NULL,'UGC 12816',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165257,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165257,34.38,0.44,75,76839,NULL,NULL,'Malmquist cor.','UGC 12816',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165258,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165258,35.7,0.07,138,76840,NULL,NULL,NULL,'UGC 12817',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000007,NULL,'15.52',0.3,'Sb',NULL,NULL,NULL,NULL,1,357.9684583,29.26239,0.149,NULL,51970251913,812035186,12688049,15.52),(165259,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165259,35.76,0.2,142,76840,74.4,NULL,NULL,'UGC 12817',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165260,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165260,35.51,0.25,126,76841,74.4,NULL,NULL,'MCG -05-56-025',NULL,'2013AJ....146...86T',2013,1,1.05,NULL,'G',0.000019,NULL,'15.09',0.88,'S0','Group member',NULL,NULL,NULL,1,357.976667,-27.92983,0,NULL,50054299192,782098424,12220287,15.09),(165261,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165261,37.99,0.46,397,76842,70,NULL,NULL,'2MASX J23515723+0042062',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,357.988417,0.70167,0.101,NULL,51542566099,805352595,12583634,18.2),(165262,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165262,35.16,0.8,107,76843,75,NULL,'W91CL, r','KUG 2349+270',NULL,'1997ApJS..109..333W',1997,1,0.6,NULL,'G',0.000033,NULL,'15.7',0.3,'Spiral','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,357.995375,27.33739,0.101,NULL,52004595536,812571805,12696434,15.7),(165263,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165263,35.16,0.8,108,76843,75,NULL,'HMCL, I','KUG 2349+270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165264,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165264,34.85,0.4,93.5,76843,75,NULL,'HMCL, I, raw','KUG 2349+270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165265,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165265,34.99,0.4,99.7,76843,75,NULL,'HMCL, I, inv','KUG 2349+270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165266,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165266,35.07,0.4,103,76843,75,NULL,'HMCL, I, cor','KUG 2349+270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165267,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165267,35.08,0.38,104,76843,75,NULL,'W91CL, r, raw','KUG 2349+270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165268,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165268,35.19,0.38,109,76843,75,NULL,'W91CL, r, inv','KUG 2349+270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165269,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165269,35.23,0.41,111,76843,NULL,NULL,'Malmquist cor.','KUG 2349+270',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165270,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165270,35.28,0.4,114,76843,NULL,NULL,NULL,'KUG 2349+270',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165271,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165271,35.3,0.38,115,76843,75,NULL,'W91CL, r, cor','KUG 2349+270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165272,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165272,35.33,0.2,116,76843,74.4,NULL,NULL,'KUG 2349+270',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165273,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165273,36.76,0.46,225,76844,70,NULL,NULL,'2MASX J23515911+1445045',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00023,NULL,'16.0g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,357.996166667,14.75114,0.033,NULL,51646411217,806975175,12608987,16),(165274,'Tully est','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165274,28.93,0.8,6.1,76845,75,NULL,NULL,'ESO 149- G 003',NULL,'1988NBGC.C....0000T',1988,1,2.2,NULL,'G',0.000007,NULL,'15.00',0.4,'IB(s)m: sp',NULL,NULL,NULL,NULL,1,358.011667,-52.57772,NULL,NULL,48627924070,759811313,11872051,15),(165275,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165275,28.85,NULL,5.89,76845,NULL,NULL,NULL,'ESO 149- G 003',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165276,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165276,29.03,NULL,6.4,76845,NULL,NULL,NULL,'ESO 149- G 003',NULL,'2003A&A...404...93K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165277,'TRGB','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165277,29.23,0.1,7.01,76846,74.4,NULL,NULL,'ESO 149- G 003',NULL,'2013AJ....146...86T',2013,1,2.2,NULL,'G',0.000007,NULL,'15.00',0.4,'IB(s)m: sp',NULL,NULL,NULL,NULL,1,358.011667,-52.57772,NULL,NULL,48627924070,759811313,11872051,15),(165278,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165278,37.24,0.46,280,76847,70,NULL,NULL,'2MASX J23520473-0959549',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000066,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,358.0197083,-9.99864,0.101,NULL,49614023090,775219110,12112798,17.3),(165279,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165279,38.14,0.46,425,76848,70,NULL,NULL,'SDSS J235207.26+140544.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000139,NULL,'18.8g',0.08,NULL,NULL,NULL,NULL,NULL,1,358.0302917,14.09583,0.073,NULL,51653491144,807085799,12610715,18.8),(165280,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165280,37.94,0.33,386,76849,70,NULL,NULL,'2MASX J23520759-1039478',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000084,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,358.03175,-10.66331,0.073,NULL,49613823834,775215997,12112749,17.8),(165281,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165281,34.69,0.25,86.7,76850,74.4,NULL,NULL,'2dFGRS S275Z229',NULL,'2013AJ....146...86T',2013,1,0.69,NULL,'G',0.000213,NULL,'15.14',0.62,NULL,NULL,NULL,NULL,NULL,1,358.0424583,-29.07833,0,NULL,50035741612,781808462,12215757,15.14),(165282,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165282,34.74,0.51,88.8,76851,70,NULL,NULL,'6dF J2352101-290445',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,358.042583,-29.07906,0,NULL,50035741615,781808462,12215757,13.3),(165283,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165283,33.43,0.49,48.6,76852,70,NULL,NULL,'ESO 078- G 008',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00006,NULL,'14.68',0.2,'Sa','Pair member (points to parent)',NULL,NULL,NULL,1,358.0445,-62.57156,0,NULL,48725627572,761337930,11895905,14.68),(165284,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165284,34.28,0.8,71.8,76853,75,NULL,'CF, r','UGC 12818',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.00015,NULL,'14.70',0.7,'S?',NULL,NULL,NULL,NULL,1,358.0462083,8.39481,0.193,NULL,51571693515,805807711,12590745,14.7),(165285,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165285,33.71,0.2,55.2,76853,74.4,NULL,NULL,'UGC 12818',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165286,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165286,33.81,0.38,57.8,76853,75,NULL,'CF, r, raw','UGC 12818',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165287,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165287,33.85,0.41,58.8,76853,NULL,NULL,NULL,'UGC 12818',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165288,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165288,33.87,0.38,59.3,76853,75,NULL,'CF, r, inv','UGC 12818',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165289,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165289,34.01,0.38,63.3,76853,NULL,NULL,'Malmquist cor.','UGC 12818',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165290,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165290,34.04,0.38,64.4,76853,75,NULL,'CF, r, cor','UGC 12818',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165291,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165291,33.48,0.49,49.6,76854,75,NULL,'IR','MCG +08-01-003',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000053,NULL,'16',0.15,NULL,NULL,NULL,NULL,NULL,1,358.047583,47.39544,0.577,NULL,53151591208,830493612,12976462,16),(165292,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165292,34.67,0.69,85.7,76855,100,NULL,'mid-IR','CGCG 498-023',NULL,'2013ApJ...771...88L',2013,1,0.8,NULL,'G',0.000033,NULL,'15.6',0.5,'Pec',NULL,NULL,NULL,NULL,1,358.049833,31.46531,0.161,NULL,51960588854,811884200,12685690,15.6),(165293,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165293,38.04,0.46,405,76856,70,NULL,NULL,'2MASX J23521483+0106502',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000082,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,358.0617917,1.11378,0.093,NULL,51553703551,805526617,12586353,17.7),(165294,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165294,35.58,0.31,131,76857,NULL,NULL,'Malmquist cor.','ESO 471- G 030',NULL,'2009ApJS..182..474S',2009,1,1.28,NULL,'G',0.000027,NULL,'15.0b',0.32,'S0',NULL,NULL,NULL,NULL,1,358.0677083,-29.44772,NULL,NULL,50035400780,781803137,12215674,15),(165295,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165295,35.67,0.49,136,76857,75,NULL,'IR','ESO 471- G 030',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165296,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165296,35.68,0.3,137,76857,NULL,NULL,NULL,'ESO 471- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165297,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165297,35.72,0.2,139,76857,74.4,NULL,NULL,'ESO 471- G 030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165298,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165298,35.29,0.49,114,76858,75,NULL,'IR','AM 2349-294',NULL,'2011yCatp016004901K',2011,1,1.04,NULL,'G',0.000037,NULL,'15.89',NULL,'Sc',NULL,NULL,NULL,NULL,1,358.069708333,-29.53847,NULL,NULL,50035226766,781800418,12215631,15.89),(165299,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165299,35.33,0.34,116,76858,NULL,NULL,NULL,'AM 2349-294',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165300,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165300,35.37,0.2,119,76858,74.4,NULL,NULL,'AM 2349-294',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165301,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165301,35.46,0.32,123,76858,NULL,NULL,'Malmquist cor.','AM 2349-294',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165302,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165302,38.88,0.49,596,76859,NULL,NULL,NULL,'AGC 630424',NULL,'2009ApJS..182..474S',2009,1,0.39,NULL,'G',0.00005,NULL,'17.12',NULL,'Sc',NULL,NULL,NULL,NULL,1,358.070208333,-29.43925,NULL,NULL,50035401622,781803150,12215674,17.12),(165303,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165303,38.88,0.49,596,76859,NULL,NULL,'Malmquist cor.','AGC 630424',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165304,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165304,35.88,0.66,150,76860,70,NULL,NULL,'2MASX J23521722-1841523',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'17.16',0.26,NULL,NULL,NULL,NULL,NULL,1,358.0717917,-18.69792,0.015,NULL,49542890410,774107662,12095432,17.16),(165305,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165305,37.94,0.33,386,76861,70,NULL,NULL,'SDSS J235217.43-104103.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00007,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,358.072667,-10.68433,0.073,NULL,49613822095,775215970,12112749,18),(165306,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 16406','RN',165306,40.27,0.13,965,76862,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16406',0.173639,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165307,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 16406','RN',165307,40.71,0.23,1180,76862,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16406',0.173639,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165308,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165308,33.6,NULL,52.4,76863,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2548',NULL,'2010Ap&SS.325..163P',2010,1,1.01,NULL,'G',0.00001,NULL,'16.6',0.09,'Sd',NULL,NULL,NULL,NULL,1,358.09,7.97472,0.201,NULL,51572218133,805815908,12590873,16.6),(165309,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165309,33.62,NULL,52.9,76863,NULL,NULL,'Dipole + Quadrupole','FGC 2548',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165310,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165310,33.64,NULL,53.4,76863,NULL,NULL,'Dipole','FGC 2548',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165311,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165311,33.73,NULL,55.6,76863,NULL,NULL,NULL,'FGC 2548',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165312,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165312,34.5,0.55,79.4,76864,70,NULL,NULL,'ESO 471- G 032',NULL,'2014MNRAS.445.2677S',2014,1,0.9,'The APMUKS position is east of the nucleus.','G',0.00015,NULL,'15.00',0.6,'(R?)SAB(r)0/a','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,358.092,-30.23025,NULL,NULL,50045831920,781966123,12218220,15),(165313,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165313,35.24,0.25,112,76865,74.4,NULL,NULL,'MCG -05-56-029',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000017,NULL,'15.35',0.4,'E',NULL,NULL,NULL,NULL,1,358.1007917,-29.023,0,NULL,50035700504,781807820,12215747,15.35),(165314,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165314,35.65,0.46,135,76866,70,NULL,NULL,'2MASX J23522434+1435350',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000077,NULL,'16.1g',0.28,'E0',NULL,NULL,NULL,NULL,1,358.1014583,14.59308,0.033,NULL,51646521152,806976893,12609013,16.1),(165315,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165315,34.87,0.47,94.1,76867,NULL,NULL,'H','NGC 7775',NULL,'2007A&A...465...71T',2007,1,1,'Noted in MCG as possibly interacting.','G',0.000217,NULL,'13.96',0.8,'Scd:           HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,358.101875,28.77267,0.153,NULL,51969893110,812029579,12687962,13.96),(165316,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165316,34.92,0.4,96.5,76867,NULL,NULL,'mean','NGC 7775',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165317,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165317,37.97,0.46,392,76868,70,NULL,NULL,'2MASX J23522455-0939206',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000081,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,358.102417,-9.65569,0.117,NULL,49612060107,775188439,12112319,17.5),(165318,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165318,36.09,0.51,165,76869,70,NULL,NULL,'2MASX J23522705-1749071',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'16.47',0.38,'S0',NULL,NULL,NULL,NULL,1,358.1127083,-17.81861,0.009,NULL,49532047549,773938242,12092785,16.47),(165319,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165319,35.69,0.37,137,76870,NULL,NULL,'Malmquist cor.','ESO 606- G 017',NULL,'2009ApJS..182..474S',2009,1,1,'Da Costa, et al. (1998,AJ,116,1) give v = 10836 +/- 25 km/sec.','G',0.000033,NULL,'15.34',0.6,'Sb',NULL,NULL,NULL,NULL,1,358.113416667,-18.42381,0.026,NULL,49542563521,774102555,12095352,15.34),(165320,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165320,35.81,0.35,145,76870,NULL,NULL,NULL,'ESO 606- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165321,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165321,35.85,0.2,148,76870,74.4,NULL,NULL,'ESO 606- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165322,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165322,36.86,0.52,236,76871,70,NULL,NULL,'2MASX J23523841-2349517',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'15.95',0.52,'E',NULL,NULL,NULL,NULL,1,358.160125,-23.83106,0.036,NULL,49997463725,781210370,12206412,15.95),(165323,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165323,37.96,0.46,390,76872,70,NULL,NULL,'SDSS J235240.55+151253.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00013,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,358.169,15.21492,0.057,NULL,51663634867,807244294,12613192,18.6),(165324,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 14323','RN',165324,43.45,0.3,3010,76873,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 14323',0.629758,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165325,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165325,36.94,0.9,244,76874,70,NULL,NULL,'2MASX J23524518-3510520',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00015,NULL,'16.68',0.25,NULL,NULL,NULL,NULL,NULL,1,358.188333,-35.18106,NULL,NULL,49948965421,780452584,12194571,16.68),(165326,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165326,37.46,0.12,311,76875,70,NULL,NULL,'2MASX J23525190-1108556',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000102,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,358.216375,-11.14872,0,NULL,49612636852,775197450,12112460,16.5),(165327,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165327,35.82,0.49,146,76876,70,NULL,NULL,'2MASX J23525463-5213099',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.79',0.19,NULL,NULL,NULL,NULL,NULL,1,358.227625,-52.21942,NULL,NULL,48628743618,759824119,11872251,16.79),(165328,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 10612','RN',165328,39.43,0.39,659,76877,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10612',0.166761,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165329,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 10612','RN',165329,39.86,0.35,803,76877,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10612',0.166761,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165330,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165330,34.8,0.57,91.3,76878,70,NULL,NULL,'2MASX J23525776-0243335',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.46',NULL,NULL,NULL,NULL,NULL,NULL,1,358.240708333,-2.72594,0.113,NULL,49405010959,771953296,12061770,15.46),(165331,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165331,34.57,0.51,82,76879,NULL,NULL,'Malmquist cor.','AGC 331811',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',NULL,NULL,'15.0I',0.3,NULL,NULL,NULL,NULL,NULL,1,358.254583,11.28306,0.125,NULL,51776092008,809001437,12640647,15),(165332,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165332,34.72,0.2,87.9,76879,74.4,NULL,NULL,'AGC 331811',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165333,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165333,34.85,0.44,93.2,76879,NULL,NULL,NULL,'AGC 331811',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165334,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165334,37.69,0.46,345,76880,70,NULL,NULL,'SDSS J235301.46-094837.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000066,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,358.256083,-9.8105,0.101,NULL,49611849554,775185149,12112267,18.4),(165335,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165335,37.03,0.46,254,76881,70,NULL,NULL,'2MASX J23530244+1605203',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000183,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,358.260125,16.08892,0.061,NULL,51665230530,807269227,12613581,16.3),(165336,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 13163','RN',165336,40.4,0.14,968,76882,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 13163',0.239845,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165337,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 13163','RN',165337,41.1,0.22,1340,76882,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 13163',0.239845,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165338,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165338,38.14,0.33,425,76883,70,NULL,NULL,'SDSS J235304.78+002201.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000086,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,358.2699583,0.36708,0.117,NULL,51542049783,805344527,12583508,18.4),(165339,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165339,35.54,0.33,128,76884,70,NULL,NULL,'CGCG 455-064',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000188,NULL,'15.7g',0.45,'E0',NULL,NULL,NULL,NULL,1,358.2845417,16.06442,0.061,NULL,51665228387,807269193,12613581,15.7),(165340,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165340,36.55,0.57,204,76885,70,NULL,NULL,'2MASX J23530838-0256375',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.93',0.28,NULL,NULL,NULL,NULL,NULL,1,358.284833333,-2.94375,0.165,NULL,49403379004,771927796,12061371,16.93),(165341,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 12921','RN',165341,41,0.19,1260,76886,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 12921',0.259092,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165342,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165342,36.99,0.48,250,76887,NULL,NULL,'Malmquist cor.','UGC 12825',NULL,'2009ApJS..182..474S',2009,1,1.02,NULL,'G',0.00003,NULL,'16.5',0.11,'Sbc',NULL,NULL,NULL,NULL,1,358.305875,10.89478,0.157,NULL,51778398673,809037479,12641210,16.5),(165343,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165343,37.26,0.42,284,76887,NULL,NULL,NULL,'UGC 12825',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165344,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165344,37.3,0.2,288,76887,74.4,NULL,NULL,'UGC 12825',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165345,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165345,33.92,NULL,60.7,76888,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12828',NULL,'2010Ap&SS.325..163P',2010,1,1.27,NULL,'G',0.000008,NULL,'16.0',0.16,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,358.315166667,19.39178,0.097,NULL,51622665585,806604149,12603189,16),(165346,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165346,33.93,NULL,61.1,76888,NULL,NULL,'Dipole + Quadrupole','UGC 12828',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165347,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165347,33.94,NULL,61.3,76888,NULL,NULL,'Dipole','UGC 12828',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165348,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165348,33.99,NULL,62.9,76888,NULL,NULL,NULL,'UGC 12828',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165349,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165349,34,0.49,63.1,76888,75,NULL,'IR','UGC 12828',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165350,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 06280','RN',165350,39.07,0.55,548,76889,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06280',0.187749,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165351,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 06280','RN',165351,39.39,0.77,637,76889,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06280',0.187749,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165352,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165352,38.14,0.33,425,76890,70,NULL,NULL,'2MASX J23531746+0017313',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000089,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,358.3227083,0.29208,0.117,NULL,51542176250,805346503,12583539,18.1),(165353,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165353,36.15,0.53,170,76891,70,NULL,NULL,'ESO 538- G 001',NULL,'2014MNRAS.445.2677S',2014,1,1.2,'6dF DR2 has z = 0.037629.','G',0.00015,NULL,'15.48',0.5,'S0:',NULL,NULL,NULL,NULL,1,358.323583,-18.21194,0,NULL,49539453644,774053963,12094593,15.48),(165354,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165354,34.98,0.49,98.9,76892,NULL,NULL,NULL,'CGCG 477-027',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000007,NULL,'15.5',0.4,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,358.3265,27.70539,0.085,NULL,52001312516,812520508,12695632,15.5),(165355,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165355,34.98,0.49,99.1,76892,NULL,NULL,'Malmquist cor.','CGCG 477-027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165356,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165356,35.02,0.2,101,76892,74.4,NULL,NULL,'CGCG 477-027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165357,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165357,34.23,0.4,70.2,76893,NULL,NULL,'mean','NGC 7778',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000023,NULL,'13.68',1,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,358.3319583,7.87092,0.197,NULL,51572316612,805817447,12590897,13.68),(165358,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165358,34.63,0.45,84.5,76893,NULL,NULL,'K','NGC 7778',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165359,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165359,35.09,NULL,104,76894,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG +14-01-004',NULL,'2010Ap&SS.325..163P',2010,1,0.96,NULL,'G',NULL,NULL,'17',0.09,'Scd',NULL,NULL,NULL,NULL,1,358.336416667,86.02769,0.301,NULL,52623373687,822240213,12847503,17),(165360,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165360,35.12,NULL,105,76894,NULL,NULL,'Dipole + Quadrupole','MCG +14-01-004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165361,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165361,35.12,NULL,106,76894,NULL,NULL,'Dipole','MCG +14-01-004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165362,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165362,35.14,0.43,107,76894,75,NULL,'3.6 micron, color + selection bias corrected','MCG +14-01-004',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165363,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165363,35.16,NULL,107,76894,NULL,NULL,NULL,'MCG +14-01-004',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165364,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 16586','RN',165364,40.71,0.26,1050,76895,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16586',0.319595,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165365,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 16586','RN',165365,41.11,0.2,1260,76895,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16586',0.319595,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165366,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 16586','N',165366,40.53,0.16,1280,76895,70,NULL,'SALT 2','SDSS-II SN 16586',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165367,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 16586','N',165367,40.57,0.16,1300,76895,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16586',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165368,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165368,38.5,0.46,500,76896,70,NULL,NULL,'SDSS J235322.52-085603.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000071,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,358.343875,-8.93444,0.13,NULL,49428470022,772319844,12067497,18.5),(165369,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165369,37.46,0.12,311,76897,70,NULL,NULL,'SDSS J235322.92-104855.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000057,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,358.345583,-10.81556,0.065,NULL,49613887814,775216997,12112765,17.7),(165370,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165370,37.46,0.12,311,76898,70,NULL,NULL,'SDSS J235324.67-102242.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000076,NULL,'18.2g',0.15,'S0','Group member',NULL,NULL,NULL,1,358.352833,-10.37858,0.09,NULL,49614066558,775219789,12112809,18.2),(165371,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165371,37.56,0.46,325,76899,70,NULL,NULL,'2MASX J23532616-0033326',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00008,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,358.359,-0.55894,0.121,NULL,49394021999,771781593,12059087,17.4),(165372,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165372,35.64,0.62,134,76900,70,NULL,NULL,'NGC 7764A NED03',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'16.61',0.3,'S0','in a triple',NULL,NULL,NULL,1,358.359375,-40.81597,NULL,NULL,49936587291,780259176,12191549,16.61),(165373,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165373,37.88,0.46,377,76901,70,NULL,NULL,'2MASX J23532686-0844571',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000084,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,358.3620417,-8.74928,0.152,NULL,49428557803,772321215,12067518,17.4),(165374,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 13096','R',165374,42.18,0.27,1960,76902,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J235328.89-011208.1',0.392006,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,'PHOT','22.2g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,358.370417,-1.20225,0.077,NULL,49407356604,771989946,12062342,22.2),(165375,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 13096','R',165375,42.44,0.25,2210,76902,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J235328.89-011208.1',0.392006,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165376,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 13096',NULL,165376,42.13,0.17,2670,76902,70,NULL,'SALT 2','SDSS J235328.89-011208.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165377,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 13096',NULL,165377,42.2,0.17,2750,76902,70,NULL,'SALT 2, Malmquist cor.','SDSS J235328.89-011208.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165378,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165378,34.59,0.39,82.9,76903,NULL,NULL,'Malmquist cor.','IC 1513',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000107,NULL,'14.99',0.3,'S?',NULL,NULL,NULL,NULL,1,358.372417,11.31761,0.129,NULL,51642638584,806916227,12608066,14.99),(165379,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165379,34.8,0.35,91.1,76903,NULL,NULL,NULL,'IC 1513',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165380,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165380,34.84,0.2,92.9,76903,74.4,NULL,NULL,'IC 1513',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165381,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165381,34.88,0.55,94.7,76904,70,NULL,NULL,'CGCG 381-058',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.000076,NULL,'15.5g',0.37,'Sbc',NULL,NULL,NULL,NULL,1,358.379167,-0.74014,0.097,NULL,49393528050,771773875,12058966,15.5),(165382,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165382,35.54,0.33,128,76905,70,NULL,NULL,'III Zw 124',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000148,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,358.379625,16.10581,0.073,NULL,51664722287,807261285,12613457,16.4),(165383,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 07647','R',165383,41.35,0.16,1340,76906,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07647',0.38666,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,358.383125,1.04203,0.105,NULL,51542467363,805351052,12583610,NULL),(165384,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 07647','R',165384,41.4,0.23,1370,76906,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07647',0.38666,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165385,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2001da',NULL,165385,33.44,0.22,47.9,76907,74.2,NULL,'SALT 2','NGC 7780',0.017195,'2010ApJ...716..712A',2010,1,1,NULL,'G',0.000193,NULL,'14.8',0.5,'Sab','Group member',NULL,NULL,NULL,1,358.3840417,8.11814,0.181,NULL,51572134833,805814606,12590853,14.8),(165386,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2001da',NULL,165386,34.07,0.19,64,76907,70,NULL,'SALT 2','NGC 7780',0.017195,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165387,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2001da',NULL,165387,34.11,0.08,66.4,76907,74.4,NULL,NULL,'NGC 7780',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165388,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2001da',NULL,165388,34.28,0.27,70.7,76907,65,NULL,'SALT2','NGC 7780',0.017195,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165389,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2001da',NULL,165389,34.44,0.22,76.1,76907,65,NULL,'SALT','NGC 7780',0.017195,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165390,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2001da',NULL,165390,34.55,0.22,80.1,76907,65,NULL,'MLCS17','NGC 7780',0.017195,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165391,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2001da',NULL,165391,34.56,0.24,80.4,76907,65,NULL,'MLCS31','NGC 7780',0.017195,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165392,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2001da',NULL,165392,35.23,0.07,109,76907,70,NULL,'SALT 2','NGC 7780',0.017195,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165393,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165393,33.47,0.69,49.5,76907,100,NULL,'mid-IR','NGC 7780',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165394,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165394,34.11,0.08,66.4,76907,74.4,NULL,NULL,'NGC 7780',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165395,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165395,34.43,0.38,76.9,76907,NULL,NULL,'Malmquist cor.','NGC 7780',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165396,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165396,34.49,0.37,78.9,76907,NULL,NULL,NULL,'NGC 7780',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165397,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165397,34.86,0.4,93.8,76907,75,NULL,'HOSTS SN 2001da','NGC 7780',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165398,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165398,37.87,0.46,374,76908,70,NULL,NULL,'SDSS J235332.24+153827.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000134,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,358.384333,15.64086,0.061,NULL,51664715567,807261180,12613455,18.5),(165399,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165399,37.46,0.12,311,76909,70,NULL,NULL,'2MASX J23533382-1035091',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000094,NULL,'16.4g',0.36,'E0','Group member',NULL,NULL,NULL,1,358.3909583,-10.58597,0.104,NULL,49613705344,775214146,12112721,16.4),(165400,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165400,37.46,0.12,311,76910,70,NULL,NULL,'2MASX J23533551-1028071',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000088,NULL,'16.9g',0.27,'S0-','Group member',NULL,NULL,NULL,1,358.397917,-10.46875,0.09,NULL,49614167935,775221373,12112833,16.9),(165401,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 16625','RN',165401,42.45,0.48,2780,76911,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 16625',0.112007,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165402,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 16625','RN',165402,42.58,0.45,2960,76911,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 16625',0.112007,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165403,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15755','R',165403,40.61,0.21,1040,76912,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J235336.73+001338.9',0.281,'2014arXiv1401.3317S',2014,1,0.11,NULL,'G',0.01,NULL,'20.3g',0.05,NULL,NULL,NULL,NULL,NULL,1,358.403041667,0.22747,0.129,NULL,51542214425,805347100,12583548,20.3),(165404,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15755','R',165404,40.71,0.16,1080,76912,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J235336.73+001338.9',0.281,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165405,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15755',NULL,165405,40.42,0.12,1210,76912,70,NULL,'SALT 2','SDSS J235336.73+001338.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165406,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15755',NULL,165406,40.44,0.12,1220,76912,70,NULL,'SALT 2, Malmquist cor.','SDSS J235336.73+001338.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165407,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165407,37.46,0.12,311,76913,70,NULL,NULL,'2MASX J23534052-1024201',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000095,NULL,'16.1g',0.36,'E+',NULL,NULL,NULL,NULL,1,358.418833333,-10.40553,0.09,NULL,49614039296,775219364,12112802,16.1),(165408,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15160',NULL,165408,39.58,0.39,824,76914,70,NULL,'SN photometric redshift distance, z photo =0.215 +/- 0.049','SDSS-II SN 15160',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,358.428916667,-0.57911,0.121,NULL,49393966825,771780731,12059073,NULL),(165409,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15160','R',165409,40.31,0.22,922,76914,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15160',0.252226,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165410,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15160','R',165410,40.41,0.15,965,76914,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15160',0.252226,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165411,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15160',NULL,165411,40.14,0.12,1070,76914,70,NULL,'SALT 2','SDSS-II SN 15160',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165412,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15160',NULL,165412,40.16,0.12,1080,76914,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15160',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165413,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19077','RN',165413,42.61,0.24,2010,76915,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 19077',0.652709,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165414,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165414,36.87,0.46,236,76916,70,NULL,NULL,'2MASX J23534532-0948150',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000076,NULL,'17.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,358.438875,-9.80436,0.097,NULL,49611816723,775184636,12112259,17.4),(165415,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165415,37.78,0.46,360,76917,70,NULL,NULL,'2MASX J23534703+1411264',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000172,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,358.446,14.19056,0.061,NULL,51645788979,806965452,12608835,17),(165416,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165416,37.46,0.12,311,76918,70,NULL,NULL,'2MASX J23534761-1037340',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000101,NULL,'16.4g',0.37,'E+','Group member',NULL,NULL,NULL,1,358.4482917,-10.62608,0.073,NULL,49613708333,775214192,12112721,16.4),(165417,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165417,34.84,0.49,93,76919,75,NULL,'IR','KUG 2351+271',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.00015,NULL,'15.3',0.4,'Spiral','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,358.448875,27.41931,0.085,NULL,52001660206,812525940,12695717,15.3),(165418,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165418,35.53,0.45,128,76919,NULL,NULL,'Malmquist cor.','KUG 2351+271',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165419,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165419,35.58,0.43,131,76919,75,NULL,'3.6 micron, color corrected','KUG 2351+271',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165420,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165420,35.62,0.43,133,76919,75,NULL,'3.6 micron, color + selection bias corrected','KUG 2351+271',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165421,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165421,35.67,0.2,136,76919,74.4,NULL,NULL,'KUG 2351+271',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165422,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165422,35.73,0.41,140,76919,NULL,NULL,NULL,'KUG 2351+271',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165423,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165423,34.63,0.41,84.2,76920,NULL,NULL,'Malmquist cor.','UGC 12830',NULL,'2009ApJS..182..474S',2009,1,1,'UGC RA is -0.5 minutes in error.','G',NULL,NULL,'16.5:',0.15,'Sab',NULL,NULL,NULL,NULL,1,358.45775,10.94467,0.137,NULL,51778193414,809034272,12641160,16.5),(165424,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165424,34.77,0.49,89.8,76920,75,NULL,'IR','UGC 12830',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165425,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165425,34.85,0.37,93.3,76920,NULL,NULL,NULL,'UGC 12830',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165426,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165426,34.89,0.2,95.1,76920,74.4,NULL,NULL,'UGC 12830',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165427,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 17928','R',165427,39.72,0.17,736,76921,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17928',0.197393,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,358.470083,1.11464,0.089,NULL,51542279927,805348123,12583564,NULL),(165428,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 17928','R',165428,39.77,0.22,750,76921,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17928',0.197393,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165429,'Ring Diameter','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165429,33.7,0.84,54,76922,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7782',NULL,'1981ApJS...45..541P',1981,1,2.4,NULL,'G',0.000023,NULL,'13.08',1.3,'SA(s)b','in a radial-velocity based grouping',NULL,NULL,NULL,1,358.4745417,7.97056,0.181,NULL,51572267565,805816680,12590885,13.08),(165430,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165430,34.19,0.8,68.9,76922,75,NULL,'CF, r','NGC 7782',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165431,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165431,34.19,0.8,69,76922,75,NULL,'A82, H','NGC 7782',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165432,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165432,33.56,0.69,51.5,76922,100,NULL,'mid-IR','NGC 7782',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165433,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165433,33.82,NULL,58.1,76922,NULL,NULL,'B','NGC 7782',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165434,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165434,34.3,0.4,72.4,76922,NULL,NULL,'mean','NGC 7782',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165435,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165435,34.31,0.46,72.6,76922,NULL,NULL,'J','NGC 7782',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165436,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165436,34.31,0.47,72.8,76922,NULL,NULL,'H','NGC 7782',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165437,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165437,34.31,0.34,72.9,76922,NULL,NULL,'Malmquist cor.','NGC 7782',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165438,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165438,34.32,0.45,73,76922,NULL,NULL,'K','NGC 7782',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165439,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165439,34.38,0.33,75,76922,91,NULL,'H','NGC 7782',NULL,'1984ApJ...278..475B',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165440,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165440,34.47,0.32,78.2,76922,NULL,NULL,NULL,'NGC 7782',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165441,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165441,34.51,0.38,79.6,76922,75,NULL,'CF, r, raw','NGC 7782',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165442,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165442,34.65,0.38,85.1,76922,75,NULL,'CF, r, cor','NGC 7782',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165443,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165443,34.72,0.2,87.9,76922,74.4,NULL,NULL,'NGC 7782',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165444,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165444,34.79,0.38,90.9,76922,75,NULL,'CF, r, inv','NGC 7782',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165445,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165445,34.88,0.47,94.7,76922,75,NULL,'A82, H, raw','NGC 7782',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165446,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165446,35.21,0.47,110,76922,75,NULL,'A82, H, inv','NGC 7782',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165447,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165447,35.23,0.47,111,76922,75,NULL,'A82, H, cor','NGC 7782',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165448,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165448,37.73,0.46,352,76923,70,NULL,NULL,'2MASX J23535419-1002410',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00009,NULL,'17.6g',0.18,NULL,'Group member',NULL,NULL,NULL,1,358.475875,-10.04469,0.081,NULL,49613935669,775217744,12112777,17.6),(165449,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165449,37.8,0.19,363,76924,70,NULL,NULL,'2MASX J23535459+1557405',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000147,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,358.4775417,15.96144,0.073,NULL,51664763832,807261934,12613467,17.4),(165450,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165450,37.8,0.19,363,76925,70,NULL,NULL,'2MASX J23535675+1547285',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000155,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,358.486625,15.79128,0.073,NULL,51664668803,807260450,12613444,17.2),(165451,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165451,38.74,0.46,561,76926,70,NULL,NULL,'SDSS J235356.95+144821.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,358.4872917,14.80597,0.049,NULL,51646301128,806973455,12608960,18.7),(165452,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165452,37.94,0.46,387,76927,70,NULL,NULL,'2MASX J23535890+1539595',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,358.495667,15.66658,0.061,NULL,51664655122,807260236,12613441,17.7),(165453,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165453,37.46,0.12,311,76928,70,NULL,NULL,'SDSS J235401.95-101635.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000077,NULL,'18.0g',0.17,'E0','Group member',NULL,NULL,NULL,1,358.508125,-10.27639,0.09,NULL,49614060754,775219699,12112807,18),(165454,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15895','RN',165454,41.16,0.21,1440,76929,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15895',0.189261,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165455,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15895','RN',165455,41.78,0.25,1910,76929,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15895',0.189261,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165456,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165456,37.46,0.12,311,76930,70,NULL,NULL,'2MASX J23540381-1020019',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000106,NULL,'16.6g',0.23,'S0','Group member',NULL,NULL,NULL,1,358.516,-10.33369,0.09,NULL,49614057380,775219646,12112806,16.6),(165457,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165457,35.73,0.47,140,76931,70,NULL,NULL,'2MASX J23540555-1752453',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'15.71',0.6,'E',NULL,NULL,NULL,NULL,1,358.523375,-17.87917,0.012,NULL,49533841323,773966270,12093222,15.71),(165458,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165458,37.46,0.12,311,76932,70,NULL,NULL,'2MASX J23540571-1018309',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000092,NULL,'16.7g',0.32,'E0','Group member',NULL,NULL,NULL,1,358.523666667,-10.3085,0.09,NULL,49614059119,775219673,12112807,16.7),(165459,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165459,35.17,0.52,108,76933,70,NULL,NULL,'2MASX J23540640-0231488',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00015,NULL,'16.33',0.39,'HII',NULL,NULL,NULL,NULL,1,358.526625,-2.53014,0.089,NULL,49408409219,772006394,12062599,16.33),(165460,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 13084','RN',165460,42.85,0.24,2550,76934,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13084',0.457024,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165461,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165461,37.8,0.19,363,76935,70,NULL,NULL,'2MASX J23540701+1558109',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000212,NULL,'15.9g',0.44,'E0',NULL,NULL,NULL,NULL,1,358.5292917,15.96986,0.073,NULL,51661928328,807217630,12612775,15.9),(165462,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165462,38.21,0.46,439,76936,70,NULL,NULL,'SDSS J235408.51-092616.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00008,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,358.5355,-9.43792,0.112,NULL,49428139199,772314674,12067416,18.3),(165463,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 07051','R',165463,41.06,0.26,1220,76937,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07051',0.333049,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,358.542,0.02503,0.081,NULL,51541969577,805343274,12583488,NULL),(165464,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 07051','R',165464,41.56,0.21,1540,76937,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07051',0.333049,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165465,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165465,34.64,0.45,84.8,76938,NULL,NULL,'K','NGC 7783 NED01',NULL,'2007A&A...465...71T',2007,1,1.44,'Called \'NGC 7783a\'in MCG.  Component \'a)\' in UGC notes.','G',0.000057,NULL,'13.9g',0.66,'SB0','Pair member (points to parent)',NULL,NULL,NULL,1,358.542,0.38286,0.113,NULL,51542067946,805344811,12583512,13.9),(165466,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165466,35.1,0.4,105,76938,NULL,NULL,'mean','NGC 7783 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165467,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165467,37.46,0.12,311,76939,70,NULL,NULL,'2MASX J23541040-1029509',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000086,NULL,'17.1g',0.24,'S0','Group member',NULL,NULL,NULL,1,358.543375,-10.49758,0.09,NULL,49614030069,775219219,12112800,17.1),(165468,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165468,37.8,0.19,363,76940,70,NULL,NULL,'2MASX J23541069+1559449',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,358.544417,15.99597,0.073,NULL,51661928170,807217627,12612775,17.2),(165469,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165469,34.86,NULL,93.9,76941,NULL,NULL,NULL,'ESO 538- G 002',NULL,'2000BSAO...50....5K',2000,1,0.95,NULL,'G',0.000033,NULL,'17.13',0.13,'Sb',NULL,NULL,NULL,NULL,1,358.54875,-17.814,0.012,NULL,49533818479,773965913,12093217,17.13),(165470,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165470,35.19,NULL,109,76941,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 538- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165471,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165471,35.23,NULL,111,76941,NULL,NULL,'Dipole + Quadrupole','ESO 538- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165472,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165472,35.27,NULL,113,76941,NULL,NULL,'Dipole','ESO 538- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165473,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165473,35.28,0.49,114,76941,75,NULL,'IR','ESO 538- G 002',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165474,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165474,35.44,0.39,123,76941,NULL,NULL,NULL,'ESO 538- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165475,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165475,35.48,0.2,125,76941,74.4,NULL,NULL,'ESO 538- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165476,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165476,35.56,0.37,129,76941,NULL,NULL,'Malmquist cor.','ESO 538- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165477,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2007qe',NULL,165477,34.4,0.18,74.4,76942,74.2,NULL,'SALT 2','NSF J235412.09+272432.3',0.02,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,358.550375,27.40897,0.085,NULL,52001762480,812527538,12695742,NULL),(165478,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2007qe','R',165478,34.74,0.07,88.7,76942,NULL,NULL,'MLCS2k2, R(V) = 3.1','NSF J235412.09+272432.3',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165479,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2007qe','R',165479,34.76,0.06,89.5,76942,NULL,NULL,'MLCS2k2, R(V) = 1.8','NSF J235412.09+272432.3',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165480,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2007qe',NULL,165480,35.1,0.15,102,76942,73.8,NULL,'SALT 2 (SNANA)','NSF J235412.09+272432.3',0.0239,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165481,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2007qe',NULL,165481,35.11,0.17,103,76942,70,NULL,'SALT 2','NSF J235412.09+272432.3',0.02,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165482,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2007qe',NULL,165482,35.25,0.03,110,76942,72,NULL,'SALT2','NSF J235412.09+272432.3',0.02,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165483,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2007qe',NULL,165483,35.27,0.2,111,76942,65,NULL,'SALT2','NSF J235412.09+272432.3',0.02,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165484,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2007qe',NULL,165484,35.28,0.18,111,76942,65,NULL,'SALT','NSF J235412.09+272432.3',0.02,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165485,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2007qe',NULL,165485,35.41,0.02,119,76942,70,NULL,'SALT 2','NSF J235412.09+272432.3',0.02,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165486,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2007qe',NULL,165486,35.45,0.16,121,76942,65,NULL,'MLCS17','NSF J235412.09+272432.3',0.02,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165487,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2007qe',NULL,165487,35.53,0.17,125,76942,65,NULL,'MLCS31','NSF J235412.09+272432.3',0.02,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165488,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165488,37.62,0.46,334,76943,70,NULL,NULL,'2MASX J23541227+1355209',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000176,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,358.55125,13.92261,0.061,NULL,51655241076,807113141,12611142,17.1),(165489,'BCG','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165489,37.65,0.35,315,76944,60,NULL,'ABELL 2670, BCG','2MASX J23541371-1025084',0.0774,'1980ApJ...241..486H',1980,1,0.76,NULL,'G',0.000116,NULL,'15.3g',0.64,'cD;BrClG;XBONG','Group member',NULL,NULL,NULL,1,358.5570417,-10.41903,0.09,NULL,49610563708,775165057,12111954,15.3),(165490,'BCG','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165490,37.65,0.35,315,76945,60,NULL,NULL,'ABELL 2670',0.0774,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',0.000223,NULL,NULL,NULL,'I-II   [BM]',NULL,NULL,NULL,NULL,1,358.557083,-10.41889,0.09,NULL,49610563708,775165057,12111954,NULL),(165491,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165491,37.51,0.12,318,76945,NULL,NULL,'ABELL 2670 cluster, avg. of 11 spiral galaxies              ','ABELL 2670',NULL,'2003AJ....126..675D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165492,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165492,35.03,0.46,101,76946,70,NULL,NULL,'NGC 7783C',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00011,NULL,'16.27',0.22,'E','Compact group member',NULL,NULL,NULL,1,358.557417,0.35694,0.113,NULL,51542065718,805344776,12583512,16.27),(165493,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 14638',NULL,165493,40.28,0.21,1140,76947,70,NULL,'SN photometric redshift distance, z photo =0.312 +/- 0.038','SDSS-II SN 14638',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,358.5597917,-0.12483,0.081,NULL,49393708491,771776695,12059010,NULL),(165494,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 14638','R',165494,41.32,0.26,1440,76947,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14638',0.27802,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165495,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 14638','R',165495,41.4,0.22,1490,76947,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14638',0.27802,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165496,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165496,37.8,0.19,363,76948,70,NULL,NULL,'SDSS J235416.06+154347.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000171,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,358.5669583,15.72986,0.073,NULL,51661823953,807215999,12612749,18.1),(165497,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165497,34.94,0.54,97.3,76949,70,NULL,NULL,'LCRS B235141.2-422639',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.54',0.3,NULL,NULL,NULL,NULL,NULL,1,358.570667,-42.16564,NULL,NULL,49944295159,780379611,12193431,14.54),(165498,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 04219','RN',165498,43.16,0.21,2650,76950,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04219',0.61557,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165499,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165499,37.46,0.12,311,76951,70,NULL,NULL,'SDSS J235419.53-102039.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000066,NULL,'18.4g',0.11,'E+','Group member',NULL,NULL,NULL,1,358.581416667,-10.34436,0.09,NULL,49610595023,775165547,12111961,18.4),(165500,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2007om',NULL,165500,37.9,0.06,380,76952,70,NULL,'Hubble residual -0.25 for z0.10503','2MASX J23542073-0055023',NULL,'2011ApJ...740...92G',2011,1,0.42,NULL,'G',0.000095,NULL,'17.9g',0.09,'NLAGN',NULL,NULL,NULL,NULL,1,358.58625,-0.91722,0.097,NULL,49393540379,771774068,12058969,17.9),(165501,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 20064','R',165501,38.34,0.18,422,76952,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007om','2MASX J23542073-0055023',0.105178,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165502,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SN 2007om',NULL,165502,38.17,0.07,431,76952,70,NULL,'SALT 2','2MASX J23542073-0055023',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165503,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SN 2007om',NULL,165503,38.17,0.07,431,76952,70,NULL,'SALT 2, Malmquist cor.','2MASX J23542073-0055023',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165504,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 20064','R',165504,38.41,0.07,434,76952,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007om','2MASX J23542073-0055023',0.105178,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165505,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 01814','RN',165505,42.56,0.17,2360,76953,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 01814',0.377725,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165506,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 01814','RN',165506,42.67,0.24,2490,76953,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 01814',0.377725,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165507,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 13071','R',165507,41.14,0.26,1430,76954,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13071',0.178954,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,358.617833333,-0.71872,0.069,NULL,49396122540,771814414,12059600,NULL),(165508,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 13071','R',165508,41.53,0.28,1720,76954,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13071',0.178954,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165509,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 12895','RN',165509,40.06,0.1,910,76955,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 12895',0.1277,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165510,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 12895','RN',165510,40.51,0.23,1120,76955,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 12895',0.1277,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165511,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165511,37.79,0.27,362,76956,70,NULL,NULL,'SDSS J235430.48+135348.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,358.627,13.89683,0.061,NULL,51655236845,807113075,12611141,18.4),(165512,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165512,37.46,0.12,311,76957,70,NULL,NULL,'2MASX J23543086-1013244',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000078,NULL,'17.6g',0.23,'S0',NULL,NULL,NULL,NULL,1,358.6285,-10.22336,0.065,NULL,49610722236,775167534,12111992,17.6),(165513,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165513,37.58,0.46,329,76958,70,NULL,NULL,'2MASX J23543103+1403090',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,358.629167,14.0525,0.069,NULL,51655224263,807112879,12611138,17.6),(165514,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165514,37.46,0.12,311,76959,70,NULL,NULL,'2MASX J23543317-1026144',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000061,NULL,'18.1g',0.13,NULL,'Group member',NULL,NULL,NULL,1,358.638125,-10.43736,0.09,NULL,49610611771,775165808,12111965,18.1),(165515,'IRAS','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165515,34.17,0.8,68.1,76960,75,NULL,'MAT, I','2MASX J23543507-1431497',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'13.88',0.7,'SAB(s)c',NULL,NULL,NULL,NULL,1,358.646417,-14.53036,0.056,NULL,49554898256,774295285,12098363,13.88),(165516,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165516,32.61,0.32,33.3,76960,85,NULL,'I, inv','2MASX J23543507-1431497',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165517,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165517,32.64,0.32,33.7,76960,85,NULL,'I, raw','2MASX J23543507-1431497',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165518,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165518,33.01,0.43,39.9,76960,75,NULL,'MAT, I, inv','2MASX J23543507-1431497',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165519,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165519,33.04,0.43,40.6,76960,75,NULL,'MAT, I, raw','2MASX J23543507-1431497',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165520,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165520,33.38,0.43,47.5,76960,75,NULL,'MAT, I, cor','2MASX J23543507-1431497',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165521,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165521,34.03,0.2,64,76960,74.4,NULL,NULL,'2MASX J23543507-1431497',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165522,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165522,34.25,0.5,70.7,76960,NULL,NULL,NULL,'2MASX J23543507-1431497',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165523,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165523,34.52,0.45,80,76960,NULL,NULL,'Malmquist cor.','2MASX J23543507-1431497',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165524,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165524,36.5,0.48,199,76961,70,NULL,NULL,'AM 2352-275 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.000083,NULL,'15.5',0.2,'E',NULL,NULL,NULL,NULL,1,358.649583,-27.56747,0,NULL,50050975384,782046490,12219476,15.5),(165525,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165525,37.79,0.27,362,76962,70,NULL,NULL,'2MASX J23544004+1353181',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000202,NULL,'16.0g',0.44,'E0',NULL,NULL,NULL,NULL,1,358.6669583,13.88828,0.069,NULL,51655454251,807116472,12611194,16),(165526,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165526,36.18,0.53,172,76963,70,NULL,NULL,'2MASX J23544370-0519592',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'16.52',0.27,NULL,NULL,NULL,NULL,NULL,1,358.682125,-5.333,0.108,NULL,49447402728,772615667,12072119,16.52),(165527,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165527,37.53,0.13,321,76964,70,NULL,NULL,'2MASX J23544512-0908037',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,358.687875,-9.13444,0.112,NULL,49428897196,772326518,12067601,17.9),(165528,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165528,37.79,0.27,362,76965,70,NULL,NULL,'2MASX J23544527+1349151',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000155,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,358.688667,13.821,0.069,NULL,51655448498,807116382,12611193,17.8),(165529,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165529,37.8,0.19,363,76966,70,NULL,NULL,'2MASX J23544630+1537191',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,358.693083,15.622,0.073,NULL,51644737605,806949025,12608578,17.3),(165530,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165530,35.76,0.71,142,76967,70,NULL,NULL,'2MASX J23544656-8402096',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,358.693833333,-84.036,0.425,NULL,48343784855,755371638,11802681,15.8),(165531,'RR Lyrae','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165531,24.4,0.17,0.759,76968,NULL,NULL,NULL,'Andromeda XXI',NULL,'2015ApJ...806..200C',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,358.69875,42.47083,0.437,0,51810773001,809543328,12649114,NULL),(165532,'TRGB','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165532,24.59,0.07,0.827,76968,NULL,NULL,NULL,'Andromeda XXI',NULL,'2012ApJ...758...11C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165533,'TRGB','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165533,24.67,0.13,0.859,76968,NULL,NULL,NULL,'Andromeda XXI',NULL,'2009ApJ...705..758M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165534,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165534,37.46,0.12,311,76969,70,NULL,NULL,'2MASX J23544905-1019177',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000078,NULL,'17.2g',0.2,'S0/a','Group member',NULL,NULL,NULL,1,358.70425,-10.32175,0.065,NULL,49610726576,775167602,12111993,17.2),(165535,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 20745','RN',165535,44.04,0.35,3940,76970,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20745',0.629647,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165536,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165536,37.53,0.13,321,76971,70,NULL,NULL,'SDSS J235457.92-092053.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000083,NULL,'18.2g',0.09,NULL,NULL,NULL,NULL,NULL,1,358.741375,-9.34822,0.112,NULL,49429271366,772332365,12067693,18.2),(165537,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165537,35.51,0.62,127,76972,70,NULL,NULL,'2MASX J23545973-1118077',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.91',0.21,NULL,NULL,NULL,NULL,NULL,1,358.748875,-11.30214,0.045,NULL,49543418742,774115917,12095561,16.91),(165538,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165538,35.37,0.51,118,76973,70,NULL,NULL,'2MASX J23550331-0226024',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.16',0.4,NULL,NULL,NULL,NULL,NULL,1,358.764,-2.43392,0.069,NULL,49406460348,771975942,12062124,16.16),(165539,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165539,37.53,0.13,321,76974,70,NULL,NULL,'2MASXi J2355056-092113',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000056,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,358.773833,-9.35361,0.112,NULL,49429766581,772340102,12067814,18.1),(165540,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165540,37.53,0.13,321,76975,70,NULL,NULL,'2MASX J23550681-0922317',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.0001,NULL,'15.9g',0.45,'BrClG',NULL,NULL,NULL,NULL,1,358.778416667,-9.37556,0.09,NULL,49429257570,772332149,12067689,15.9),(165541,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165541,37.53,0.13,321,76976,70,NULL,NULL,'2MASX J23551048-0909203',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000093,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,358.793583,-9.15561,0.112,NULL,49429780750,772340324,12067817,16.6),(165542,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165542,37.53,0.13,321,76977,70,NULL,NULL,'2MASX J23551312-0919473',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000075,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,358.80475,-9.32983,0.112,NULL,49429768605,772340134,12067814,17.4),(165543,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165543,34.66,0.63,85.3,76978,70,NULL,NULL,'MCG -01-01-002',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00005,NULL,'14.50',0.8,'SB(rs)b:',NULL,NULL,NULL,NULL,1,358.807125,-3.7465,0.122,NULL,49404091682,771938932,12061545,14.5),(165544,'IRAS','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165544,33.46,0.8,49.3,76979,75,NULL,'MAT, I','ESO 472- G 010',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000023,NULL,'14.62',0.6,'SB(s)c',NULL,NULL,NULL,NULL,1,358.810667,-23.83236,0.034,NULL,49999346443,781239788,12206871,14.62),(165545,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165545,33.15,0.32,42.7,76979,85,NULL,'I, raw','ESO 472- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165546,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165546,33.16,0.32,42.8,76979,85,NULL,'I, inv','ESO 472- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165547,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165547,33.37,0.43,47.3,76979,75,NULL,'MAT, I, raw','ESO 472- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165548,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165548,33.46,0.43,49.2,76979,75,NULL,'MAT, I, inv','ESO 472- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165549,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165549,33.49,0.2,49.9,76979,74.4,NULL,NULL,'ESO 472- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165550,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165550,33.55,0.53,51.3,76979,NULL,NULL,NULL,'ESO 472- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165551,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165551,33.61,0.43,52.6,76979,75,NULL,'MAT, I, cor','ESO 472- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165552,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165552,33.83,0.46,58.3,76979,NULL,NULL,'Malmquist cor.','ESO 472- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165553,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165553,35.86,0.2,149,76980,74.4,NULL,NULL,'CGCG 432-040',NULL,'2013AJ....146...86T',2013,1,1.05,NULL,'G',0.000095,NULL,'15.3g',0.38,'S?',NULL,NULL,NULL,NULL,1,358.8170417,14.37547,0.061,NULL,51647120505,806986257,12609160,15.3),(165554,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165554,35.85,0.49,148,76981,70,NULL,NULL,'CGCG 381-062',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000083,NULL,'14.6R',0.7,NULL,NULL,NULL,NULL,NULL,1,358.817583333,-1.42328,0.041,NULL,49394785648,771793525,12059273,14.6),(165555,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165555,37.96,0.46,391,76982,70,NULL,NULL,'2MASX J23551740+1419155',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000165,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,358.822667,14.32106,0.061,NULL,51647132025,806986437,12609163,17.9),(165556,'D-Sigma','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165556,33.46,0.4,49.1,76983,75,NULL,'Edat, raw','NGC 7785',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000017,NULL,'12.63',1.3,'E5-6','Isolated galaxy',NULL,NULL,NULL,1,358.829291667,5.91583,0.165,NULL,51568211752,805753308,12589895,12.63),(165557,'D-Sigma','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165557,33.79,0.4,57.4,76983,75,NULL,'Edat, cor','NGC 7785',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165558,'Faber-Jackson','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165558,32.15,0.4,26.9,76983,95,NULL,'de Vaucouleurs','NGC 7785',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165559,'Faber-Jackson','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165559,32.65,0.27,33.9,76983,95,NULL,'Weighted Mean','NGC 7785',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165560,'Faber-Jackson','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165560,33.16,0.46,42.9,76983,95,NULL,'Michard 1979a','NGC 7785',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165561,'Faber-Jackson','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165561,33.24,0.63,44.5,76983,95,NULL,'Michard 1979b, c','NGC 7785',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165562,'Faber-Jackson','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165562,35.55,0.81,129,76983,55,NULL,'Visvanathan & Sandage 1979','NGC 7785',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165563,'Tertiary','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165563,33.47,0.5,49.4,76983,95,NULL,NULL,'NGC 7785',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165564,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165564,33.14,0.45,42.5,76983,NULL,NULL,'K','NGC 7785',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165565,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165565,33.42,0.4,48.4,76983,NULL,NULL,'mean','NGC 7785',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165566,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165566,34.24,NULL,70.6,76984,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2558',NULL,'2010Ap&SS.325..163P',2010,1,1.01,NULL,'G',0.000016,NULL,'16.5',0.1,'Sd',NULL,NULL,NULL,NULL,1,358.83,3.825,0.157,NULL,51547569536,805430774,12584855,16.5),(165567,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165567,34.26,NULL,71.3,76984,NULL,NULL,'Dipole + Quadrupole','FGC 2558',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165568,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165568,34.28,NULL,71.6,76984,NULL,NULL,'Dipole','FGC 2558',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165569,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165569,34.34,NULL,73.8,76984,NULL,NULL,NULL,'FGC 2558',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165570,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165570,34.66,0.49,85.5,76985,75,NULL,'IR','CGCG 498-035',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000033,NULL,'15.46',0.3,'S?','Pair member (points to parent)',NULL,NULL,NULL,1,358.8389583,30.38514,0.157,NULL,51973287653,812082619,12688790,15.46),(165571,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165571,38.34,0.46,466,76986,70,NULL,NULL,'SDSS J235523.53+154802.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000153,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,358.848083333,15.80072,0.081,NULL,51644764111,806949439,12608584,18.6),(165572,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 14495','RN',165572,41.41,0.12,1390,76987,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 14495',0.37724,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165573,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 14495','RN',165573,41.73,0.19,1610,76987,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 14495',0.37724,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165574,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 01123','RN',165574,41.11,0.17,1310,76988,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01123',0.267605,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165575,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 01123','RN',165575,41.88,0.24,1870,76988,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01123',0.267605,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165576,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165576,37.53,0.13,321,76989,70,NULL,NULL,'2MASX J23552696-0904333',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000105,NULL,'16.0g',0.44,'E0',NULL,NULL,NULL,NULL,1,358.862417,-9.07592,0.112,NULL,49429023691,772328495,12067632,16),(165577,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165577,36.12,0.55,168,76990,70,NULL,NULL,'2MASX J23552752-7518141',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,358.864625,-75.30397,0.165,NULL,48426283846,756660685,11822823,15.3),(165578,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165578,31.95,0.4,24.5,76991,75,NULL,'B','UGC 12843',NULL,'1988NBGC.C....0000T',1988,1,2.8,'The 2MASS position is for a stellar object northwest of the galaxy\'s center.','G',0.000003,NULL,'13.83',1.3,'SABdm','X-ray-faint group member',NULL,NULL,NULL,1,358.8745417,17.92128,0.093,NULL,51619235681,806550557,12602352,13.83),(165579,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 19336',NULL,165579,40.82,0.62,1460,76992,70,NULL,'SN photometric redshift distance, z photo =0.427 +/- 0.207','SDSS-II SN 19336',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,358.877417,0.26392,0.093,NULL,51540165698,805315089,12583048,NULL),(165580,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165580,36.34,0.46,185,76993,70,NULL,NULL,'2MASX J23553155-1043423',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000067,NULL,'16.7g',0.3,NULL,'Group member',NULL,NULL,NULL,1,358.8815417,-10.7285,0.08,NULL,49611064209,775172878,12112076,16.7),(165581,'BCG','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165581,37.92,0.35,358,76994,60,NULL,NULL,'ABELL 2675',0.0726,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II     [BM]',NULL,NULL,NULL,NULL,1,358.8892917,11.42831,0.153,NULL,51640816300,806887754,12607621,NULL),(165582,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165582,37.53,0.13,321,76995,70,NULL,NULL,'MCG -02-01-001',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.00009,NULL,'15.7g',0.4,'E0',NULL,NULL,NULL,NULL,1,358.8899583,-9.65472,0.083,NULL,49429336489,772333382,12067709,15.7),(165583,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165583,37.58,0.46,329,76996,70,NULL,NULL,'SDSS J235533.61+152623.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,358.8900417,15.43997,0.065,NULL,51648283844,807004435,12609444,18.4),(165584,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165584,37.49,0.46,315,76997,70,NULL,NULL,'2MASX J23553673-0954333',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000076,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,358.903041667,-9.90914,0.083,NULL,49426238229,772284972,12066952,17.9),(165585,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165585,37.53,0.13,321,76998,70,NULL,NULL,'2MASX J23553785-0938033',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000098,NULL,'16.0g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,358.9077917,-9.63425,0.09,NULL,49429294746,772332730,12067698,16),(165586,'IRAS','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165586,35.09,0.8,104,76999,75,NULL,'CF, r','UGC 12844',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000017,NULL,'15.06',0.5,'Scd:','Isolated galaxy',NULL,NULL,NULL,1,358.91425,19.51572,0.081,NULL,51620789907,806574842,12602731,15.06),(165587,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165587,35.21,0.38,110,76999,75,NULL,'CF, r, raw','UGC 12844',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165588,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165588,35.34,0.38,117,76999,75,NULL,'CF, r, inv','UGC 12844',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165589,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165589,35.36,0.38,118,76999,75,NULL,'CF, r, cor','UGC 12844',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165590,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165590,35.61,0.2,132,76999,74.4,NULL,NULL,'UGC 12844',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165591,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165591,35.61,0.48,133,76999,NULL,NULL,'Malmquist cor.','UGC 12844',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165592,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165592,35.75,0.45,141,76999,NULL,NULL,NULL,'UGC 12844',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165593,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165593,33.15,0.2,42.7,77000,74.4,NULL,NULL,'UGC 12845',NULL,'2013AJ....146...86T',2013,1,2.1,NULL,'G',0.00001,NULL,'14.7',1.6,'Sd',NULL,NULL,NULL,NULL,1,358.9245,31.89978,0.197,NULL,51963165538,811924461,12686319,14.7),(165594,'BCG','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165594,37.92,0.35,358,77001,60,NULL,'ABELL 2675, BCG','2MASX J23554260+1120355',0.0726,'1980ApJ...241..486H',1980,1,0.8,NULL,'G',0.00013,NULL,'17.24',0.5,'cD','Brightest group member',NULL,NULL,NULL,1,358.9274583,11.34317,0.153,NULL,51641028387,806891068,12607672,17.24),(165595,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165595,35.81,0.57,145,77002,70,NULL,NULL,'6dF J2355437-340931',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,358.932541667,-34.15872,NULL,NULL,49946207822,780409497,12193898,14.6),(165596,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165596,35.47,0.62,124,77003,70,NULL,NULL,'2MASX J23554516-0115199',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'16.50',0.41,NULL,NULL,NULL,NULL,NULL,1,358.938333,-1.25547,0.061,NULL,49395503708,771804745,12059449,16.5),(165597,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165597,35.73,0.46,140,77003,70,NULL,NULL,'2MASX J23554516-0115199',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165598,'SNII optical','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SN 2007od',NULL,165598,32.07,0.1,25.9,77004,NULL,NULL,'SCM','UGC 12846',NULL,'2015ApJ...799..215P',2015,1,1.8,NULL,'G',0.00001,NULL,'17.',1.7,'Sm:','X-ray-faint group member',NULL,NULL,NULL,1,358.941667,18.425,0.057,NULL,51616660319,806510317,12601723,17),(165599,'SNII optical','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SN 2007od',NULL,165599,32.2,0.2,27.5,77004,NULL,NULL,'later epochs','UGC 12846',NULL,'2012MNRAS.422.1178I',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165600,'SNII optical','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SN 2007od',NULL,165600,32.5,0.3,31.6,77004,NULL,NULL,'all epochs','UGC 12846',NULL,'2012MNRAS.422.1178I',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165601,'Tully est','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165601,31.91,0.8,24.1,77004,75,NULL,NULL,'UGC 12846',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165602,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165602,37.53,0.13,321,77005,70,NULL,NULL,'2MASX J23554650-0927343',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000084,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,358.943833333,-9.45967,0.09,NULL,49429826945,772341046,12067828,17.2),(165603,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165603,35.69,0.64,138,77006,70,NULL,NULL,'LSBG F409-044',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.00015,NULL,'15.4b',0.54,'E',NULL,NULL,NULL,NULL,1,358.95725,-29.86967,NULL,NULL,50036646565,781822602,12215978,15.4),(165604,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165604,37.53,0.13,321,77007,70,NULL,NULL,'SDSS J235549.76-092345.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000065,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,358.957333,-9.39592,0.09,NULL,49429834925,772341170,12067830,18.1),(165605,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 20168','RN',165605,42.29,0.28,2310,77008,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 20168',0.239904,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165606,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 20168','RN',165606,43.01,0.49,3230,77008,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20168',0.239904,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165607,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165607,37.53,0.13,321,77009,70,NULL,NULL,'2MASX J23555143-0931503',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000097,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,358.964167,-9.53067,0.09,NULL,49429643632,772338181,12067784,17.8),(165608,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165608,36.05,0.46,162,77010,70,NULL,NULL,'UGC 12847',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000111,NULL,'15.0g',0.64,'Very compact',NULL,NULL,NULL,NULL,1,358.966583333,0.55792,0.085,NULL,51543102354,805360974,12583765,15),(165609,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SN 2005ja',NULL,165609,40.26,0.14,854,77011,74.2,NULL,'SALT 2','SDSS J235552.42+005232.2',0.32,'2010ApJ...716..712A',2010,1,0.04,NULL,'G',NULL,NULL,'22.8g',0.02,NULL,NULL,NULL,NULL,NULL,1,358.968416667,0.87561,0.093,NULL,51543761477,805371273,12583926,22.8),(165610,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SN 2005ja',NULL,165610,40.61,0.04,1000,77011,70,NULL,'SDSS-II SN 06924','SDSS J235552.42+005232.2',0.32,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165611,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SN 2005ja',NULL,165611,40.97,0.15,1180,77011,65,NULL,'SALT2','SDSS J235552.42+005232.2',0.32,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165612,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SN 2005ja',NULL,165612,41.02,0.17,1210,77011,70,NULL,'SDSS-II SN 06924, SALT 2','SDSS J235552.42+005232.2',0.32,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165613,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 06924','R',165613,41.09,0.24,1250,77011,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ja','SDSS J235552.42+005232.2',0.32,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165614,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 06924','R',165614,41.13,0.14,1270,77011,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ja','SDSS J235552.42+005232.2',0.32,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165615,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SN 2005ja',NULL,165615,41.18,0.13,1310,77011,65,NULL,'MLCS2k2','SDSS J235552.42+005232.2',0.32,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165616,'IRAS','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165616,33.69,0.8,54.7,77012,75,NULL,'MAT, I','ESO 111- G 009',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000013,NULL,'14.50',0.5,'SA:(s)c        LINER','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,358.9805,-60.68175,0,NULL,48750094677,761720229,11901878,14.5),(165617,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165617,33.62,0.32,53,77012,85,NULL,'I, raw','ESO 111- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165618,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165618,33.65,0.32,53.7,77012,85,NULL,'I, inv','ESO 111- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165619,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165619,33.69,0.43,54.8,77012,75,NULL,'MAT, I, raw','ESO 111- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165620,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165620,33.85,0.43,58.8,77012,75,NULL,'MAT, I, inv','ESO 111- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165621,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165621,33.98,0.43,62.6,77012,75,NULL,'MAT, I, cor','ESO 111- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165622,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165622,34.08,0.34,65.4,77012,NULL,NULL,'Malmquist cor.','ESO 111- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165623,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165623,34.1,0.34,66,77012,NULL,NULL,NULL,'ESO 111- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165624,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165624,34.14,0.2,67.3,77012,74.4,NULL,NULL,'ESO 111- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165625,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165625,37.57,0.33,327,77013,70,NULL,NULL,'SDSS J235558.43+143422.8',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000153,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,358.9934583,14.573,0.025,NULL,51647716320,806995567,12609305,17.5),(165626,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165626,36.5,0.61,200,77014,70,NULL,NULL,'2MASX J23555973-0134102',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'17.05',0.3,NULL,NULL,NULL,NULL,NULL,1,358.998875,-1.56947,0.057,NULL,49394964243,771796316,12059317,17.05),(165627,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165627,37.26,0.46,284,77015,70,NULL,NULL,'2MASX J23560014-0858103',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000072,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,359.000625,-8.9695,0.118,NULL,49428976889,772327763,12067621,17.6),(165628,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 14193','RN',165628,40.41,0.26,1050,77016,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14193',0.150609,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165629,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 14193','RN',165629,40.72,0.47,1210,77016,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 14193',0.150609,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165630,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165630,36.51,1.01,200,77017,70,NULL,NULL,'2MASX J23560060-0140412',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'16.96',0.22,NULL,NULL,NULL,NULL,NULL,1,359.0025,-1.67819,0.057,NULL,49394987518,771796679,12059323,16.96),(165631,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165631,36.25,0.2,178,77018,74.4,NULL,NULL,'MRK 0541',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00004,NULL,'15.91',0.6,'Compact        Sy1',NULL,NULL,NULL,'Sy 1.0',1,359.008167,7.52319,0.173,NULL,51570654688,805791479,12590491,15.91),(165632,'GRB','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165632,43.61,0.46,2930,77019,69.7,NULL,'Fiducial','GRB 051022',0.8,'2009MNRAS.400..775C',2009,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'HETE 2',NULL,NULL,NULL,NULL,1,359.0175,19.60897,0.065,NULL,51620795842,806574935,12602733,NULL),(165633,'GRB','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165633,43.71,0.22,3070,77019,69.7,NULL,'Fiducial','GRB 051022',0.8,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165634,'GRB','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165634,43.77,0.28,3150,77019,69.7,NULL,'Calibrated','GRB 051022',0.8,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165635,'GRB','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165635,43.81,0.43,3210,77019,72,NULL,NULL,'GRB 051022',0.8,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165636,'GRB','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165636,43.95,0.42,3430,77019,70,NULL,NULL,'GRB 051022',0.8,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165637,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165637,34.99,0.2,99.5,77020,74.4,NULL,NULL,'UGC 12850',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'15.45',0.4,'S?',NULL,NULL,NULL,NULL,1,359.025667,29.37792,0.185,NULL,51971469727,812054214,12688347,15.45),(165638,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165638,35,0.46,100,77020,NULL,NULL,'Malmquist cor.','UGC 12850',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165639,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165639,35.03,0.46,101,77020,NULL,NULL,NULL,'UGC 12850',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165640,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165640,33.31,0.47,45.9,77021,NULL,NULL,'H','ESO 111- G 010',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000033,NULL,'14.10',0.8,'(R\'_1)SAB(rs)b HII','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,359.028583,-60.67122,0,NULL,48750095182,761720237,11901878,14.1),(165641,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165641,33.47,0.46,49.4,77021,NULL,NULL,'J','ESO 111- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165642,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165642,33.51,0.45,50.4,77021,NULL,NULL,'K','ESO 111- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165643,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165643,33.8,0.4,57.4,77021,NULL,NULL,'mean','ESO 111- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165644,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165644,37.52,0.46,319,77022,70,NULL,NULL,'2MASX J23560761-0959383',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000069,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,359.0317917,-9.99392,0.081,NULL,49426427053,772287922,12066998,17),(165645,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165645,34.54,0.46,81,77023,NULL,NULL,NULL,'NGC 7787',NULL,'2009ApJS..182..474S',2009,1,1.22,NULL,'G',0.000094,NULL,'15.0g',0.47,'(R\')SB(rs)0/a:',NULL,NULL,NULL,NULL,1,359.032583333,0.54947,0.085,NULL,51543131520,805361430,12583772,15),(165646,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165646,34.58,0.45,82.2,77023,NULL,NULL,'Malmquist cor.','NGC 7787',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165647,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165647,34.6,0.2,83.2,77023,74.4,NULL,NULL,'NGC 7787',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165648,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165648,37.53,0.13,321,77024,70,NULL,NULL,'SDSS J235608.67-093036.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000073,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,359.036167,-9.51019,0.09,NULL,49429653337,772338333,12067786,18.5),(165649,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165649,35.71,0.59,139,77025,70,NULL,NULL,'2MASX J23560940-1804479',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.67',0.33,NULL,NULL,NULL,NULL,NULL,1,359.039167,-18.08,0.055,NULL,49534637841,773978716,12093417,16.67),(165650,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165650,37.57,0.33,327,77026,70,NULL,NULL,'2MASX J23561087+1436363',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,359.045291667,14.61022,0.025,NULL,51647714132,806995533,12609305,17.2),(165651,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 09542','RN',165651,41.21,0.44,1340,77027,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 09542',0.296679,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165652,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 09542','RN',165652,41.23,0.38,1360,77027,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 09542',0.296679,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165653,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165653,35.41,0.11,121,77028,NULL,NULL,NULL,'MCG +05-01-009',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000519,NULL,'17',0.3,NULL,NULL,NULL,NULL,NULL,1,359.069375,29.38931,0.185,NULL,51971472875,812054263,12688347,17),(165654,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165654,35.63,0.2,134,77028,74.4,NULL,NULL,'MCG +05-01-009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165655,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SN 2007mk',NULL,165655,39.24,0.06,703,77029,70,NULL,'Hubble residual -0.07 for z0.18641','SDSS J235617.52-003013.9',NULL,'2011ApJ...740...92G',2011,1,0.05,NULL,'G',0.00016,NULL,'22.5g',0.04,NULL,NULL,NULL,NULL,NULL,1,359.073,-0.50389,0.093,NULL,49395953423,771811772,12059558,22.5),(165656,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 19282','R',165656,39.7,0.2,735,77029,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007mk','SDSS J235617.52-003013.9',0.18641,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165657,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 19282','R',165657,39.86,0.09,790,77029,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007mk','SDSS J235617.52-003013.9',0.18641,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165658,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2007mk',NULL,165658,39.68,0.07,863,77029,70,NULL,'SALT 2','SDSS J235617.52-003013.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165659,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2007mk',NULL,165659,39.69,0.07,867,77029,70,NULL,'SALT 2, Malmquist cor.','SDSS J235617.52-003013.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165660,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165660,34.42,0.51,76.7,77030,70,NULL,NULL,'IC 1517',NULL,'2014MNRAS.445.2677S',2014,1,0.94,NULL,'G',0.000107,NULL,'14.2g',0.72,'S0^-',NULL,NULL,NULL,NULL,1,359.078375,-0.30561,0.097,NULL,49392639245,771759988,12058749,14.2),(165661,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165661,34.85,0.46,93.1,77030,70,NULL,NULL,'IC 1517',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165662,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165662,35.51,0.53,127,77031,70,NULL,NULL,'2MASX J23562233-3503493',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.000107,NULL,'15.61',0.53,'E',NULL,NULL,NULL,NULL,1,359.0929583,-35.06367,NULL,NULL,49949350782,780458605,12194665,15.61),(165663,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165663,36.29,0.52,181,77032,70,NULL,NULL,'AM 2353-572',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'15.74',0.5,'S0- pec',NULL,NULL,NULL,NULL,1,359.09325,-57.05483,0,NULL,48738855102,761544610,11899134,15.74),(165664,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165664,36.05,0.49,162,77033,70,NULL,NULL,'IC 5364 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'14.5',0.6,'E/S?','Pair member (points to parent)',NULL,NULL,NULL,1,359.105166667,-29.02339,0,NULL,50037798798,781840606,12216259,14.5),(165665,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165665,36.1,0.49,166,77034,70,NULL,NULL,'MCG -02-01-005',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000013,NULL,'15.1g',0.52,'E0',NULL,NULL,NULL,NULL,1,359.1105,-11.08597,0.07,NULL,49611133733,775173964,12112093,15.1),(165666,'IRAS','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165666,31.94,0.8,24.4,77035,75,NULL,'MAT, I','ESO 012- G 010',NULL,'1997ApJS..109..333W',1997,1,3.1,NULL,'G',0.000017,NULL,'14.36',1.6,'SB(s)d',NULL,NULL,NULL,NULL,1,359.1147917,-81.56658,0.377,NULL,48348797205,755449956,11803905,14.36),(165667,'Tully est','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165667,31.8,0.8,23,77035,75,NULL,NULL,'ESO 012- G 010',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165668,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165668,32.55,0.4,32.4,77035,NULL,NULL,NULL,'ESO 012- G 010',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165669,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165669,32.55,0.4,32.4,77035,73,NULL,'opt','ESO 012- G 010',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165670,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165670,32.63,0.32,33.6,77035,85,NULL,'I, inv','ESO 012- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165671,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165671,32.64,0.32,33.7,77035,85,NULL,'I, raw','ESO 012- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165672,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165672,32.79,0.43,36.1,77035,75,NULL,'MAT, I, raw','ESO 012- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165673,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165673,32.83,0.43,36.8,77035,75,NULL,'MAT, I, inv','ESO 012- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165674,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165674,33.21,0.43,43.8,77035,75,NULL,'MAT, I, cor','ESO 012- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165675,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165675,33.55,0.43,51.2,77035,75,NULL,'3.6 micron, color + selection bias corrected','ESO 012- G 010',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165676,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165676,33.59,0.43,52.3,77035,75,NULL,'3.6 micron, color corrected','ESO 012- G 010',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165677,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165677,33.62,0.2,53,77035,74.4,NULL,NULL,'ESO 012- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165678,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 03868','RN',165678,40.27,0.37,946,77036,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 03868',0.19607,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165679,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165679,36.27,0.7,179,77037,70,NULL,NULL,'2MASX J23563069-0023265',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.000073,NULL,'15.9g',0.32,'S0^-',NULL,NULL,NULL,NULL,1,359.12775,-0.39078,0.093,NULL,49392501224,771757831,12058716,15.9),(165680,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 17477','RN',165680,41.85,0.2,2160,77038,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 17477',0.08448,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165681,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 17477','RN',165681,41.98,0.12,2290,77038,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 17477',0.08448,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165682,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 11732','R',165682,40.92,0.37,1080,77039,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 11732',0.42,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,359.142,-0.13025,0.097,NULL,49392569091,771758892,12058732,NULL),(165683,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165683,35.01,0.49,101,77040,75,NULL,'IR','KUG 2354+269',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000007,NULL,'15.63',0.2,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,359.1434583,27.20069,0.137,NULL,51946881227,811670019,12682344,15.63),(165684,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165684,35.25,0.44,112,77040,NULL,NULL,'Malmquist cor.','KUG 2354+269',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165685,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165685,35.33,0.2,116,77040,74.4,NULL,NULL,'KUG 2354+269',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165686,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165686,35.34,0.42,117,77040,NULL,NULL,NULL,'KUG 2354+269',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165687,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165687,35.36,0.43,118,77040,75,NULL,'3.6 micron, color corrected','KUG 2354+269',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165688,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165688,35.48,0.43,125,77040,75,NULL,'3.6 micron, color + selection bias corrected','KUG 2354+269',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165689,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 15606','RN',165689,42.33,0.28,2080,77041,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15606',0.403253,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165690,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 15606','RN',165690,42.79,0.27,2580,77041,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15606',0.403253,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165691,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 14382',NULL,165691,40.99,0.19,1580,77042,70,NULL,'SN photometric redshift distance, z photo =0.471 +/- 0.060','SDSS-II SN 14382',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','22.0g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,359.148625,0.20411,0.097,NULL,51540337048,805317766,12583090,22),(165692,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 14382','R',165692,42.01,0.37,1780,77042,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14382',0.417805,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165693,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 14382','R',165693,42.1,0.33,1850,77042,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14382',0.417805,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165694,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 14382',NULL,165694,41.79,0.24,2280,77042,70,NULL,'SALT 2','SDSS-II SN 14382',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165695,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 14382',NULL,165695,41.87,0.24,2370,77042,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14382',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165696,'CMD','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'N',165696,17.01,0.16,0.025,77043,NULL,NULL,'If object = GC, ID = DES J0531_2801','Columba I',NULL,'2015ApJ...813..109D',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165697,'IRAS','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165697,35.08,0.8,104,77044,75,NULL,'W91CL, r','UGC 12855',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000002,NULL,'14.53',0.7,'S0/a',NULL,NULL,NULL,NULL,1,359.155291667,27.10483,0.137,NULL,51947275278,811676176,12682440,14.53),(165698,'IRAS','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165698,35.09,0.8,104,77044,75,NULL,'HMCL, I','UGC 12855',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165699,'IRAS','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165699,35.09,0.8,104,77044,75,NULL,'W91PP, r','UGC 12855',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165700,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165700,34.51,0.69,79.7,77044,100,NULL,'mid-IR','UGC 12855',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165701,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165701,35.1,0.4,105,77044,NULL,NULL,'Malmquist cor.','UGC 12855',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165702,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165702,35.2,0.38,110,77044,NULL,NULL,NULL,'UGC 12855',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165703,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165703,35.24,0.38,112,77044,75,NULL,'W91PP, r, raw','UGC 12855',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165704,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165704,35.36,0.38,118,77044,75,NULL,'W91CL, r, raw','UGC 12855',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165705,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165705,35.42,0.38,121,77044,75,NULL,'W91PP, r, cor','UGC 12855',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165706,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165706,35.42,0.4,122,77044,75,NULL,'HMCL, I, raw','UGC 12855',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165707,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165707,35.51,0.38,127,77044,75,NULL,'W91PP, r, inv','UGC 12855',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165708,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165708,35.56,0.2,129,77044,74.4,NULL,NULL,'UGC 12855',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165709,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165709,35.58,0.38,131,77044,75,NULL,'W91CL, r, cor','UGC 12855',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165710,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165710,35.58,0.38,131,77044,75,NULL,'W91CL, r, inv','UGC 12855',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165711,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165711,35.63,0.4,133,77044,75,NULL,'HMCL, I, cor','UGC 12855',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165712,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165712,35.69,0.4,137,77044,75,NULL,'HMCL, I, inv','UGC 12855',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165713,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165713,38.55,0.46,513,77045,70,NULL,NULL,'2MASX J23563813+0111564',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000095,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,359.158875,1.19908,0.065,NULL,51543665751,805369777,12583902,18.1),(165714,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165714,35.23,0.58,111,77046,NULL,NULL,'Malmquist cor.','UGC 12854',NULL,'2009ApJS..182..474S',2009,1,0.83,NULL,'G',0.00008,NULL,'14.8g',0.44,'S?',NULL,NULL,NULL,NULL,1,359.1752083,13.77636,0.121,NULL,51655915252,807123675,12611307,14.8),(165715,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165715,35.46,0.53,124,77046,NULL,NULL,NULL,'UGC 12854',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165716,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165716,35.55,0.2,129,77046,74.4,NULL,NULL,'UGC 12854',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165717,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 21597','RN',165717,44.15,0.34,4760,77047,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 21597',0.420774,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165718,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 21597','RN',165718,44.51,0.45,5620,77047,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 21597',0.420774,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165719,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165719,35.3,0.46,115,77048,70,NULL,NULL,'2MASX J23564519-0858110',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000079,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,359.18825,-8.96958,0.118,NULL,49427108923,772298576,12067165,16.5),(165720,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165720,31.95,0.4,24.5,77049,75,NULL,'B','UGC 12856',NULL,'1988NBGC.C....0000T',1988,1,1.6,'Position in 1992PNAOJ...2..573T refers to VV 255b, a bright knot in VV 255a.','G',0.000003,NULL,'14.5',1,'IB(s)m         HII','X-ray-faint group member',NULL,NULL,NULL,1,359.1885417,16.81394,0.045,NULL,51662174942,807221483,12612835,14.5),(165721,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165721,37.02,0.46,254,77050,70,NULL,NULL,'2MASX J23564598+1404561',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000186,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,359.19175,14.08219,0.053,NULL,51655345824,807114778,12611168,16.6),(165722,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165722,35.86,0.56,149,77051,70,NULL,NULL,'2MASX J23564613-0134599',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'16.07',0.48,NULL,NULL,NULL,NULL,NULL,1,359.1922917,-1.58336,0.061,NULL,49394919540,771795617,12059306,16.07),(165723,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165723,35.63,0.49,134,77052,70,NULL,NULL,'MCG -01-01-005',NULL,'2014MNRAS.445.2677S',2014,1,1.3,'HOLM 822B is a star.','G',0.000047,NULL,'14.96',0.6,'(R\')SB(r)a',NULL,NULL,NULL,NULL,1,359.192583,-2.64692,0.156,NULL,49406618543,771978414,12062162,14.96),(165724,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165724,32.1,0.43,26.2,77053,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12857',NULL,'2014MNRAS.444..527S',2014,1,1.8,NULL,'G',0.000025,NULL,'14.49',0.4,'Sbc: sp','Isolated galaxy',NULL,NULL,NULL,1,359.198417,1.355,0.065,NULL,51542899757,805357808,12583715,14.49),(165725,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165725,32.23,0.43,27.9,77053,75,NULL,'3.6 micron, color corrected','UGC 12857',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165726,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165726,32.41,0.2,30.3,77053,74.4,NULL,NULL,'UGC 12857',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165727,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165727,32.45,0.4,30.9,77053,73,NULL,'opt','UGC 12857',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165728,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165728,32.5,0.4,31.7,77053,75,NULL,NULL,'UGC 12857',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165729,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165729,32.51,0.39,31.7,77053,73,NULL,'IR','UGC 12857',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165730,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165730,32.68,0.49,34.3,77053,75,NULL,'IR','UGC 12857',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165731,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165731,32.68,0.51,34.4,77053,NULL,NULL,NULL,'UGC 12857',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165732,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165732,32.7,0.51,34.6,77053,NULL,NULL,'Malmquist cor.','UGC 12857',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165733,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165733,32.7,0.4,34.6,77053,NULL,NULL,'mean','UGC 12857',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165734,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165734,32.87,0.47,37.5,77053,NULL,NULL,'H','UGC 12857',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165735,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165735,32.97,0.46,39.2,77053,NULL,NULL,'J','UGC 12857',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165736,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165736,33.01,0.45,40,77053,NULL,NULL,'K','UGC 12857',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165737,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165737,37.61,0.46,333,77054,70,NULL,NULL,'2MASX J23564934+0043373',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000113,NULL,'17.6g',0.17,'NLAGN',NULL,NULL,NULL,'Sy 2',1,359.205417,0.72694,0.105,NULL,51543549322,805367958,12583874,17.6),(165738,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165738,37.23,0.46,279,77055,70,NULL,NULL,'2MASX J23565133-0000299',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000076,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,359.213917,-0.00822,0.097,NULL,49392531518,771758304,12058723,17.8),(165739,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2007fb',NULL,165739,34.75,0.24,87.8,77056,73.8,NULL,'SALT 2 (SNANA)','UGC 12859',0.0169,'2014ApJ...795...44R',2014,1,1.2,NULL,'G',0.000013,NULL,'15.18',0.4,'Sbc',NULL,NULL,NULL,NULL,1,359.2147917,5.50842,0.201,NULL,51599261151,806238455,12597475,15.18),(165740,'IRAS','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165740,34.18,0.8,68.7,77056,75,NULL,'CF, r','UGC 12859',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165741,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165741,33.98,0.49,62.4,77056,75,NULL,'IR','UGC 12859',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165742,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165742,34.25,0.38,70.8,77056,75,NULL,'CF, r, raw','UGC 12859',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165743,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165743,34.38,0.38,75.1,77056,75,NULL,'CF, r, inv','UGC 12859',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165744,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165744,34.46,0.38,77.8,77056,75,NULL,'CF, r, cor','UGC 12859',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165745,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 18419','RN',165745,41.71,0.54,2040,77057,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 18419',0.073564,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165746,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 18419','RN',165746,42.17,0.63,2530,77057,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 18419',0.073564,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165747,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165747,37.73,0.46,352,77058,70,NULL,NULL,'2MASX J23565394-0047019',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000107,NULL,'16.6g',0.33,'AGN',NULL,NULL,NULL,NULL,1,359.22475,-0.78392,0.093,NULL,49396069287,771813582,12059587,16.6),(165748,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165748,37.34,0.46,294,77059,70,NULL,NULL,'2MASX J23565411-0927470',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000067,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,359.225417,-9.46319,0.095,NULL,49429843543,772341305,12067832,17.2),(165749,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165749,32.81,NULL,36.4,77060,NULL,NULL,'Dipole','ESO 293- G 020',NULL,'2010Ap&SS.325..163P',2010,1,2.35,'6dF DR1 has z = 0.043859.','G',0.000057,NULL,'16.86',0.22,'Sb',NULL,NULL,NULL,NULL,1,359.232583,-38.66322,NULL,NULL,49955064502,780547882,12196060,16.86),(165750,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165750,32.81,NULL,36.5,77060,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 293- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165751,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165751,32.81,NULL,36.5,77060,NULL,NULL,'Dipole + Quadrupole','ESO 293- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165752,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165752,33.09,NULL,41.4,77060,NULL,NULL,NULL,'ESO 293- G 020',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165753,'GRB','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165753,43.26,2.08,1750,77061,100,NULL,NULL,'XRF 040912',1.563,'2009EPJC...63..139W',2009,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,359.225,-1,0.033,NULL,49396270888,771816732,12059636,NULL),(165754,'GRB','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165754,43.27,2.06,1760,77061,100,NULL,NULL,'XRF 040912',1.563,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165755,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 13164','RN',165755,40.07,0.14,836,77062,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13164',0.232375,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165756,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 13164','RN',165756,40.67,0.2,1110,77062,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13164',0.232375,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165757,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165757,35.59,0.46,131,77063,70,NULL,NULL,'2MASX J23565667-0059119',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000068,NULL,'16.1g',0.25,'LINER',NULL,NULL,NULL,NULL,1,359.236083,-0.98675,0.033,NULL,49396091833,771813934,12059592,16.1),(165758,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 21150',NULL,165758,39.21,0.78,695,77064,70,NULL,'SN photometric redshift distance, z photo =0.178 +/- 0.089','SDSS-II SN 21150',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','19.8g',0.07,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,359.241333333,1.21833,0.065,NULL,51543662179,805369721,12583901,19.8),(165759,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 21150','R',165759,41.32,0.26,1340,77064,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 21150',0.372795,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165760,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 21150','R',165760,41.62,0.37,1540,77064,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 21150',0.372795,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165761,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165761,33.98,0.2,62.5,77065,74.4,NULL,NULL,'UGC 12860',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.000043,NULL,'14.91',0.3,'Sb',NULL,NULL,NULL,NULL,1,359.2417083,10.82447,0.161,NULL,51775370706,808990167,12640471,14.91),(165762,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165762,34.05,0.49,64.6,77065,75,NULL,'IR','UGC 12860',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165763,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165763,34.06,0.38,65,77065,NULL,NULL,NULL,'UGC 12860',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165764,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165764,34.15,0.37,67.6,77065,NULL,NULL,'Malmquist cor.','UGC 12860',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165765,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165765,37.56,0.46,325,77066,70,NULL,NULL,'2MASX J23570449-0905039',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000094,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,359.26875,-9.08453,0.118,NULL,49427056293,772297754,12067152,16.9),(165766,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165766,36.22,0.2,175,77067,74.4,NULL,NULL,'CGCG 498-044',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000033,NULL,'15.20',0.4,'Sdm',NULL,NULL,NULL,NULL,1,359.269541667,33.69156,0.221,NULL,52026262039,812910344,12701724,15.2),(165767,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165767,37.71,0.46,348,77068,70,NULL,NULL,'SDSS J235707.53-011305.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,359.281375,-1.21819,0.033,NULL,49396244588,771816321,12059630,18),(165768,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165768,35.64,0.49,134,77069,70,NULL,NULL,'MCG -03-01-005',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'15.5',0.2,'(R\')SA(s)a',NULL,NULL,NULL,NULL,1,359.302875,-18.62625,0.02,NULL,49533451005,773960171,12093127,15.5),(165769,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165769,36.92,0.66,242,77070,70,NULL,NULL,'LCRS B235438.5-385821',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.41',0.38,'S0',NULL,NULL,NULL,NULL,1,359.306375,-38.69472,NULL,NULL,49955041916,780547529,12196055,16.41),(165770,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2007oz',NULL,165770,40.2,0.25,1100,77071,70,NULL,'Hubble residual 0.02 for z0.29730','SDSS J235716.57+001454.4',NULL,'2011ApJ...740...92G',2011,1,0.07,NULL,'G',0.00018,NULL,'20.7g',0.06,NULL,NULL,NULL,NULL,NULL,1,359.319083,0.24847,0.097,NULL,51540499108,805320298,12583129,20.7),(165771,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 19794','R',165771,40.79,0.29,1110,77071,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007oz','SDSS J235716.57+001454.4',0.2973,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165772,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 19794','R',165772,41.08,0.25,1270,77071,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007oz','SDSS J235716.57+001454.4',0.2973,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165773,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 20447',NULL,165773,40.86,0.24,1480,77072,70,NULL,'SN photometric redshift distance, z photo =0.435 +/- 0.068','SDSS-II SN 20447',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','23.2g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,359.32675,0.57078,0.105,NULL,51540398446,805318725,12583105,23.2),(165774,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 20447','R',165774,42.02,0.31,1790,77072,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20447',0.419368,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165775,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 20447','R',165775,42.1,0.32,1850,77072,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20447',0.419368,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165776,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 20447',NULL,165776,42.05,0.22,2570,77072,70,NULL,'SALT 2','SDSS-II SN 20447',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165777,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 20447',NULL,165777,42.13,0.22,2670,77072,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20447',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165778,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165778,34.09,0.49,65.7,77073,75,NULL,'IR','UGC 12863',NULL,'2011yCatp016004901K',2011,1,1.1,'Springob et al. (2005ApJS..160..149S) give v= 11242 km/sec.','G',0.00003,NULL,'16.0',0.2,'Sbc',NULL,NULL,NULL,NULL,1,359.329375,8.50897,0.189,NULL,51559337538,805614649,12587728,16),(165779,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165779,36.27,0.2,179,77073,74.4,NULL,NULL,'UGC 12863',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165780,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165780,37.91,0.46,382,77074,70,NULL,NULL,'2MASXi J2357201+150716',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,359.3337917,15.12119,0.073,NULL,51648050267,807000785,12609387,17.9),(165781,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 04986','RN',165781,43.13,0.28,3330,77075,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 04986',0.267949,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165782,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 04986','RN',165782,43.23,0.24,3490,77075,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 04986',0.267949,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165783,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165783,37.35,0.46,296,77076,70,NULL,NULL,'2MASX J23572157-1052493',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000086,NULL,'16.6g',0.3,'AGN',NULL,NULL,NULL,NULL,1,359.339833,-10.8805,0.078,NULL,49610324567,775161321,12111895,16.6),(165784,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 17274','R',165784,40.34,0.18,980,77077,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ij','SDSS J235721.96+000621.1',0.196102,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,':',NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,359.3415,0.10586,0.097,NULL,51540475015,805319922,12583123,NULL),(165785,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 17274','R',165785,40.37,0.22,991,77077,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ij','SDSS J235721.96+000621.1',0.196102,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165786,'IRAS','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165786,33.87,0.8,59.3,77078,75,NULL,'W91PP, r','UGC 12864',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000023,NULL,'14.33',1,'SBb            AGN?','Isolated galaxy',NULL,NULL,NULL,1,359.349958333,30.99217,0.161,NULL,51972775475,812074616,12688665,14.33),(165787,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165787,33.38,0.2,47.4,77078,74.4,NULL,NULL,'UGC 12864',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165788,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165788,33.51,0.58,50.3,77078,NULL,NULL,NULL,'UGC 12864',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165789,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165789,33.51,0.38,50.3,77078,75,NULL,'W91PP, r, raw','UGC 12864',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165790,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165790,33.55,0.38,51.3,77078,75,NULL,'W91PP, r, inv','UGC 12864',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165791,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165791,33.86,0.38,59.2,77078,75,NULL,'W91PP, r, cor','UGC 12864',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165792,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165792,33.91,0.48,60.6,77078,NULL,NULL,'Malmquist cor.','UGC 12864',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165793,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165793,34.16,0.49,67.9,77078,75,NULL,'IR','UGC 12864',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165794,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 04265','RN',165794,43.56,0.26,3590,77079,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04265',0.436407,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165795,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 04265','RN',165795,43.89,0.31,4180,77079,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 04265',0.436407,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165796,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165796,34.99,0.49,99.5,77080,75,NULL,'IR','KUG 2354+265',NULL,'2011yCatp016004901K',2011,1,0.7,NULL,'G',0.000008,NULL,'16  :',0.2,'Spiral',NULL,NULL,NULL,NULL,1,359.3577917,26.83861,0.121,NULL,51947115003,811673671,12682401,16),(165797,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165797,36.32,0.67,184,77081,70,NULL,NULL,'2MASX J23572745-0107534',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.000091,NULL,'16.0g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,359.364416667,-1.13144,0.037,NULL,49395697745,771807777,12059496,16),(165798,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165798,35.29,0.46,114,77082,70,NULL,NULL,'ESO 471- G 049',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000033,NULL,'13.87',0.9,'SB(r)b',NULL,NULL,NULL,NULL,1,359.369125,-29.04758,0,NULL,50034567551,781790117,12215470,13.87),(165799,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165799,35.39,0.25,119,77082,NULL,NULL,'Malmquist cor.','ESO 471- G 049',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165800,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165800,35.44,0.24,122,77082,NULL,NULL,NULL,'ESO 471- G 049',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165801,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165801,35.48,0.2,125,77082,74.4,NULL,NULL,'ESO 471- G 049',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165802,'BL Lac Luminosity','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165802,41.85,NULL,2350,77083,70,NULL,'nucleus-to-host flux ratio, z > 0.85','2MASS J23572998-1718035',NULL,'2006AJ....132....1S',2006,1,NULL,NULL,'QSO',NULL,NULL,'17.4',NULL,'candidate      BLLAC',NULL,NULL,NULL,NULL,1,359.374917,-17.30097,0.022,NULL,49531551341,773930489,12092663,17.4),(165803,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 15569',NULL,165803,41.15,0.22,1700,77084,70,NULL,'SN photometric redshift distance, z photo =0.521 +/- 0.079','SDSS-II SN 15569',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,359.377625,0.87006,0.101,NULL,51543420959,805365952,12583843,NULL),(165804,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165804,37.44,0.46,308,77085,70,NULL,NULL,'2MASX J23573517-0043374',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000089,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,359.3967083,-0.72708,0.089,NULL,49392793539,771762399,12058787,18.1),(165805,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165805,35.42,0.64,122,77086,70,NULL,NULL,'2MASX J23573552-0118564',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'16.34',0.26,NULL,NULL,NULL,NULL,NULL,1,359.3979583,-1.31572,0.033,NULL,49395724394,771808193,12059503,16.34),(165806,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 18302','RN',165806,40.29,0.17,1030,77087,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18302',0.109857,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165807,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 18302','RN',165807,40.59,0.23,1180,77087,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18302',0.109857,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165808,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 19795',NULL,165808,41.57,0.02,2060,77088,70,NULL,'SN photometric redshift distance, z photo =0.688 +/- 0.012','SDSS-II SN 19795',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,359.4160417,0.20619,0.097,NULL,51540519521,805320617,12583134,NULL),(165809,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165809,35.51,0.47,126,77089,70,NULL,NULL,'ESO 538- G 010',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00005,NULL,'14.93',0.7,'S0?',NULL,NULL,NULL,NULL,1,359.4167083,-21.57972,0.038,NULL,49527362690,773865042,12091641,14.93),(165810,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165810,36.2,0.49,174,77090,70,NULL,NULL,'2MASX J23574045-4934130',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.67',0.26,NULL,NULL,NULL,NULL,NULL,1,359.4187083,-49.57022,NULL,NULL,48595698749,759307792,11864184,16.67),(165811,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165811,37.33,0.46,293,77091,70,NULL,NULL,'SDSS J235742.99+155147.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000164,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,359.429125,15.86331,0.089,NULL,51645469587,806960462,12608757,18.2),(165812,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 02864','R',165812,40.22,0.22,891,77092,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02864',0.2441,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,359.451,-1.23961,0.037,NULL,49395712914,771808014,12059500,NULL),(165813,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 02864','R',165813,40.29,0.16,920,77092,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 02864',0.2441,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165814,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165814,37.4,0.33,302,77093,70,NULL,NULL,'2MASX J23574859+0047444',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000137,NULL,'15.6g',0.48,'E0',NULL,NULL,NULL,NULL,1,359.452416667,0.79558,0.101,NULL,51539946316,805311661,12582994,15.6),(165815,'Brightest Stars','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165815,26,NULL,1.58,77094,NULL,NULL,NULL,'NGC 7793',NULL,'1998ApJ...497..650D',1998,1,9.3,'Extended HIPASS source','G',0.000013,NULL,'9.98',6.3,'SA(s)d         HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,359.457625,-32.59103,NULL,0,50030037082,781719329,12214364,9.98),(165816,'Brightest Stars','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165816,27.77,NULL,3.58,77094,NULL,NULL,'Photographic','NGC 7793',NULL,'1980ApJ...239..783D',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165817,'Cepheids','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165817,27.68,0.05,3.44,77094,NULL,NULL,'17, VI','NGC 7793',NULL,'2010AJ....140.1475P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165818,'Cepheids','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165818,27.77,0.07,3.58,77094,74.4,NULL,NULL,'NGC 7793',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165819,'CMD','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165819,27.83,NULL,3.68,77094,NULL,NULL,NULL,'NGC 7793',NULL,'2012ApJ...753..138R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165820,'CMD','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165820,27.91,NULL,3.82,77094,NULL,NULL,NULL,'NGC 7793',NULL,'2012ApJ...748...47M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165821,'TRGB','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165821,27.77,0.07,3.58,77094,74.4,NULL,NULL,'NGC 7793',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165822,'TRGB','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165822,27.79,0.08,3.61,77094,NULL,NULL,'I','NGC 7793',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165823,'TRGB','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165823,27.79,0.32,3.61,77094,NULL,NULL,'I','NGC 7793',NULL,'2011ApJ...732....7V',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165824,'TRGB','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165824,27.87,0.08,3.7,77094,NULL,NULL,'I','NGC 7793',NULL,'2011ApJS..195...18R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165825,'TRGB','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165825,27.96,0.24,3.91,77094,NULL,NULL,NULL,'NGC 7793',NULL,'2003A&A...404...93K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165826,'SNII optical','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2008bk',NULL,165826,27.63,0.16,3.36,77094,NULL,NULL,'SCM, Poznanski et al. 2009','NGC 7793',NULL,'2015A&A...580L..15P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165827,'SNII optical','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2008bk',NULL,165827,27.7,0.16,3.47,77094,NULL,NULL,'SCM, Hamuy 2003','NGC 7793',NULL,'2015A&A...580L..15P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165828,'SNII optical','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2008bk',NULL,165828,27.73,0.16,3.52,77094,NULL,NULL,'SCM, Nugent et al. 2006','NGC 7793',NULL,'2015A&A...580L..15P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165829,'SNII optical','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2008bk',NULL,165829,27.9,0.16,3.8,77094,NULL,NULL,'SCM, D\'Andrea et al. 2010','NGC 7793',NULL,'2015A&A...580L..15P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165830,'SNII optical','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2008bk',NULL,165830,28.39,0.5,4.76,77094,NULL,NULL,'SCM','NGC 7793',NULL,'2015ApJ...799..215P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165831,'IRAS','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165831,28.1,0.8,4.16,77094,75,NULL,'MAT, I','NGC 7793',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165832,'IRAS','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165832,28.11,0.8,4.19,77094,75,NULL,'A82, H','NGC 7793',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165833,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165833,27.21,0.4,2.8,77094,75,NULL,'B','NGC 7793',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165834,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165834,27.72,0.32,3.47,77094,85,NULL,'I, inv','NGC 7793',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165835,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165835,27.72,0.32,3.48,77094,85,NULL,'I, raw','NGC 7793',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165836,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165836,27.77,0.07,3.58,77094,74.4,NULL,NULL,'NGC 7793',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165837,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165837,27.84,0.4,3.7,77094,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 7793',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165838,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165838,27.82,0.43,3.7,77094,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7793',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165839,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165839,27.96,0.43,3.9,77094,75,NULL,'3.6 micron, color corrected','NGC 7793',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165840,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165840,28.01,NULL,4,77094,NULL,NULL,'LEDA [April 2006]','NGC 7793',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165841,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165841,28.06,0.35,4.09,77094,NULL,NULL,NULL,'NGC 7793',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165842,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165842,28.07,0.43,4.11,77094,75,NULL,'MAT, I, raw','NGC 7793',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165843,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165843,28.08,0.43,4.13,77094,75,NULL,'MAT, I, inv','NGC 7793',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165844,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165844,28.34,0.43,4.65,77094,75,NULL,'MAT, I, cor','NGC 7793',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165845,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165845,28.51,0.47,5.04,77094,75,NULL,'A82, H, inv','NGC 7793',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165846,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165846,28.56,0.47,5.15,77094,75,NULL,'A82, H, raw','NGC 7793',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165847,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165847,28.89,0.47,6,77094,75,NULL,'A82, H, cor','NGC 7793',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165848,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 19091',NULL,165848,41.29,0.29,1810,77095,70,NULL,'SN photometric redshift distance, z photo =0.571 +/- 0.125','SDSS-II SN 19091',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,359.4662917,-0.30361,0.085,NULL,49393094202,771767096,12058860,NULL),(165849,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 19091',NULL,165849,41.62,0.24,2110,77095,70,NULL,'SALT 2','SDSS-II SN 19091',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165850,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 19091',NULL,165850,41.68,0.24,2170,77095,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19091',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165851,'IRAS','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165851,35.14,0.8,107,77096,75,NULL,'W91PP, r','UGC 12866',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'16.0',0.3,'Scd:',NULL,NULL,NULL,NULL,1,359.4712083,22.35597,0.125,NULL,52479384142,819990377,12812349,16),(165852,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165852,35.33,0.51,116,77096,NULL,NULL,'Malmquist cor.','UGC 12866',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165853,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165853,35.45,0.48,123,77096,NULL,NULL,NULL,'UGC 12866',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165854,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165854,35.47,0.49,124,77096,75,NULL,'IR','UGC 12866',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165855,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165855,35.49,0.2,125,77096,74.4,NULL,NULL,'UGC 12866',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165856,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165856,35.59,0.38,131,77096,75,NULL,'W91PP, r, raw','UGC 12866',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165857,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165857,35.67,0.38,136,77096,75,NULL,'W91PP, r, inv','UGC 12866',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165858,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165858,35.83,0.38,147,77096,75,NULL,'W91PP, r, cor','UGC 12866',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165859,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 02649','RN',165859,40.71,0.27,1310,77097,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02649',0.06121,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165860,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 02649','RN',165860,40.79,0.18,1360,77097,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02649',0.06121,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165861,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165861,37.4,0.33,302,77098,70,NULL,NULL,'2MASX J23575986+0046084',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000132,NULL,'16.1g',0.41,NULL,NULL,NULL,NULL,NULL,1,359.499375,0.76906,0.101,NULL,51539996552,805312446,12583006,16.1),(165862,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165862,38.16,0.46,428,77099,70,NULL,NULL,'SDSS J235809.84+152854.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00017,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,359.541,15.48178,0.069,NULL,51647972392,806999568,12609368,18.5),(165863,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165863,38.13,0.46,423,77100,70,NULL,NULL,'2MASX J23580982+1503205',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,359.541083333,15.05578,0.077,NULL,51648022578,807000352,12609380,17.9),(165864,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 12825','RN',165864,39.22,0.21,607,77101,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 12825',0.150122,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165865,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165865,35.3,0.2,115,77102,74.4,NULL,NULL,'KUG 2355+281',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000033,NULL,'15.77',0.3,'S?',NULL,NULL,NULL,NULL,1,359.552583333,28.46422,0.205,NULL,51967593310,811993645,12687400,15.77),(165866,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165866,35.5,0.38,126,77103,NULL,NULL,'Malmquist cor.','ESO 471- G 051',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.92',0.7,'SB?',NULL,NULL,NULL,NULL,1,359.571916667,-30.11144,NULL,NULL,50036887802,781826371,12216037,14.92),(165867,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165867,35.53,0.37,128,77103,NULL,NULL,NULL,'ESO 471- G 051',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165868,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165868,35.57,0.2,130,77103,74.4,NULL,NULL,'ESO 471- G 051',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165869,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165869,35.59,0.53,131,77104,70,NULL,NULL,'2MASX J23581801-5357144',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.000077,NULL,'16.90',0.27,'S0',NULL,NULL,NULL,NULL,1,359.574958333,-53.95403,0,NULL,48621624795,759712887,11870513,16.9),(165870,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 01150','RN',165870,43.47,0.33,3390,77105,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01150',0.458071,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165871,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165871,38,0.46,399,77106,70,NULL,NULL,'2MASX J23582405-0025186',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00008,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,359.600125,-0.42183,0.085,NULL,49393122931,771767545,12058867,18.1),(165872,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165872,37.41,0.46,303,77107,70,NULL,NULL,'2MASX J23582521+1437166',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,359.604917,14.62139,0.081,NULL,51647570612,806993290,12609270,17.8),(165873,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165873,34.65,0.54,85.2,77108,NULL,NULL,'Malmquist cor.','UGC 12871',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000117,NULL,'14.74',1,'Scd:',NULL,NULL,NULL,NULL,1,359.627208333,9.97272,0.173,NULL,51557064178,805579127,12587173,14.74),(165874,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165874,35.1,0.44,105,77108,NULL,NULL,NULL,'UGC 12871',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165875,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165875,35.14,0.2,107,77108,74.4,NULL,NULL,'UGC 12871',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165876,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165876,35.26,0.16,109,77109,74.2,NULL,'SALT 2','ESO 538- G 013',0.034043,'2010ApJ...716..712A',2010,1,1.4,NULL,'G',0.000123,NULL,'15.20',0.7,'Sa',NULL,NULL,NULL,NULL,1,359.632625,-18.71403,0.022,NULL,49533568674,773962010,12093156,15.2),(165877,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165877,35.74,0.15,136,77109,72,NULL,NULL,'ESO 538- G 013',0.034043,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165878,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165878,35.86,0.16,139,77109,72,NULL,NULL,'ESO 538- G 013',0.03295,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165879,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165879,35.8,0.04,140,77109,72,NULL,NULL,'ESO 538- G 013',0.034043,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165880,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165880,35.86,0.17,144,77109,72,NULL,NULL,'ESO 538- G 013',0.034043,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165881,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165881,35.87,0.02,145,77109,70,NULL,'SALT 2','ESO 538- G 013',0.034043,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165882,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165882,35.81,0.01,145,77109,72,NULL,NULL,'ESO 538- G 013',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165883,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165883,35.81,0.09,145,77109,74.4,NULL,NULL,'ESO 538- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165884,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165884,35.89,0.14,146,77109,72,NULL,NULL,'ESO 538- G 013',0.034043,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165885,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165885,35.96,0.02,150,77109,72,NULL,NULL,'ESO 538- G 013',0.034043,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165886,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165886,35.92,0.05,153,77109,72,NULL,'M(H) = -18.317 mag','ESO 538- G 013',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165887,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165887,36.01,0.15,154,77109,70,NULL,'SALT 2','ESO 538- G 013',0.034043,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165888,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165888,36.03,0.21,155,77109,73.8,NULL,'SALT 2 (SNANA)','ESO 538- G 013',0.0341,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165889,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165889,36.06,0.19,157,77109,73.8,NULL,'SALT 2 (SNANA)','ESO 538- G 013',0.0341,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165890,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq','R',165890,36.05,0.05,162,77109,NULL,NULL,'MLCS2k2, R(V) = 1.8','ESO 538- G 013',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165891,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165891,36.13,0.15,163,77109,65,NULL,'MLCS17','ESO 538- G 013',0.034043,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165892,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165892,36.17,0.17,165,77109,65,NULL,'SALT','ESO 538- G 013',0.034043,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165893,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq','R',165893,36.1,0.05,166,77109,NULL,NULL,'MLCS2k2, R(V) = 3.1','ESO 538- G 013',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165894,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165894,36.17,0.19,166,77109,65,NULL,'SALT2','ESO 538- G 013',0.034043,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165895,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165895,36.2,0.15,168,77109,65,NULL,'MLCS31','ESO 538- G 013',0.034043,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165896,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165896,36.72,0.33,221,77110,70,NULL,NULL,'2MASX J23583306-0108416',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000082,NULL,'17.0g',0.26,'AGN',NULL,NULL,NULL,NULL,1,359.637625,-1.14489,0.041,NULL,49395770593,771808915,12059514,17),(165897,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165897,36.72,0.33,221,77111,70,NULL,NULL,'2MASX J23583426-0107446',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000092,NULL,'16.9g',0.25,'AGN',NULL,NULL,NULL,NULL,1,359.642875,-1.129,0.041,NULL,49395763434,771808803,12059512,16.9),(165898,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165898,37.75,0.33,354,77112,70,NULL,NULL,'2MASX J23583443-1000394',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000086,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,359.6435417,-10.01094,0.081,NULL,49426174108,772283970,12066937,17.3),(165899,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165899,37.57,0.46,327,77113,70,NULL,NULL,'2MASX J23583478+1545546',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,359.644875,15.76519,0.069,NULL,51645187146,806956049,12608688,17.6),(165900,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165900,37.79,0.46,361,77114,70,NULL,NULL,'2MASX J23583632-1018454',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000081,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,359.651417,-10.3125,0.09,NULL,49426619305,772290926,12067045,17.3),(165901,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165901,37.94,0.46,388,77115,70,NULL,NULL,'2MASX J23583661+0053330',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000078,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,359.6525,0.89244,0.093,NULL,51540103388,805314115,12583033,17.9),(165902,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165902,37.83,0.46,367,77116,70,NULL,NULL,'2MASX J23584103+1351226',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,359.670875,13.85622,0.097,NULL,51654994980,807109296,12611082,17.3),(165903,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165903,37.75,0.33,354,77117,70,NULL,NULL,'SDSS J235842.07-095435.9',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000097,NULL,'17.6g',0.18,'AGN',NULL,NULL,NULL,NULL,1,359.675333333,-9.91003,0.081,NULL,49426173867,772283966,12066936,17.6),(165904,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 01403','R',165904,40.52,0.28,934,77118,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01403',0.361378,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,359.703875,0.43189,0.113,NULL,51540559273,805321238,12583144,NULL),(165905,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 01403','R',165905,40.52,0.33,935,77118,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01403',0.361378,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165906,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 01403',NULL,165906,40.27,0.23,1130,77118,70,NULL,'SALT 2','SDSS-II SN 01403',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165907,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 01403',NULL,165907,40.32,0.23,1160,77118,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 01403',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165908,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 01403',NULL,165908,40.92,0.67,1530,77118,70,NULL,'SN photometric redshift distance, z photo =0.452 +/- 0.248','SDSS-II SN 01403',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165909,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165909,36.4,0.69,191,77119,70,NULL,NULL,'2MFGC 18007',NULL,'2014MNRAS.445.2677S',2014,1,0.69,NULL,'G',0.00015,NULL,'16.66',0.15,NULL,NULL,NULL,NULL,NULL,1,359.724666667,-12.02142,0.046,NULL,49543726489,774120726,12095636,16.66),(165910,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165910,37.53,0.46,321,77120,70,NULL,NULL,'2MASX J23585521+0030175',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000089,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,359.7300417,0.50478,0.113,NULL,51540570968,805321421,12583147,17.3),(165911,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165911,37.81,0.33,365,77121,70,NULL,NULL,'2MASX J23585541+0017335',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000075,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,359.73075,0.29253,0.113,NULL,51539816953,805309639,12582963,18.1),(165912,'Horizontal Branch','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165912,24.59,0.11,0.829,77122,NULL,NULL,NULL,'Andromeda XXIX',NULL,'2015ApJ...806..230S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,359.731667,30.75556,0.137,1,51968503348,812007864,12687622,NULL),(165913,'TRGB','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165913,24.32,0.22,0.73,77122,NULL,NULL,NULL,'Andromeda XXIX',NULL,'2011ApJ...742L..15B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165914,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2003he',NULL,165914,35.17,0.16,106,77123,70,NULL,'SALT 2','MCG -01-01-010',0.025504,'2013MNRAS.433.2240G',2013,1,1.5,'Maurogordato et al. (1991A&A...246...39M) give v = 11109 +/- 68 km/sec.','G',0.000033,NULL,'15.21',0.6,'SB(s)bc:',NULL,NULL,NULL,NULL,1,359.738458333,-2.24958,0.115,NULL,49394428442,771787944,12059186,15.21),(165915,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165915,35.13,0.2,106,77123,74.4,NULL,NULL,'MCG -01-01-010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165916,'SBF','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165916,33.55,0.14,51.3,77124,74.4,NULL,NULL,'NGC 7796',NULL,'2013AJ....146...86T',2013,1,2.2,'The APM position is northwest of the nucleus.','G',0.000057,NULL,'12.46',1.9,'E+',NULL,NULL,NULL,NULL,1,359.749041667,-55.45831,0,NULL,48620820120,759700314,11870317,12.46),(165917,'GCLF','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165917,33.7,NULL,55,77125,NULL,NULL,'R','NGC 7796',NULL,'2015A&A...574A..21R',2015,1,2.2,'The APM position is northwest of the nucleus.','G',0.000057,NULL,'12.46',1.9,'E+',NULL,NULL,NULL,NULL,1,359.749041667,-55.45831,0,NULL,48620820120,759700314,11870317,12.46),(165918,'SBF','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165918,33.49,0.4,49.9,77125,NULL,NULL,'I','NGC 7796',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165919,'Faber-Jackson','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165919,32.52,0.65,31.9,77125,95,NULL,'Weighted Mean','NGC 7796',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165920,'Faber-Jackson','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165920,34.1,0.81,66.1,77125,55,NULL,'Visvanathan & Sandage 1979','NGC 7796',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165921,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165921,33.4,0.49,47.9,77125,70,NULL,NULL,'NGC 7796',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165922,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165922,33.39,0.4,47.6,77125,NULL,NULL,'mean','NGC 7796',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165923,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165923,33.53,0.45,50.8,77125,NULL,NULL,'K','NGC 7796',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165924,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165924,34.8,0.47,91.2,77126,70,NULL,NULL,'2MASX J23585991-6200483',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'15.36',0.6,'S0',NULL,NULL,NULL,NULL,1,359.7497083,-62.01342,0,NULL,48725235463,761331804,11895809,15.36),(165925,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165925,37.26,0.46,283,77127,70,NULL,NULL,'2MASX J23590054+1400086',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000158,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,359.7522917,14.00228,0.105,NULL,51655010155,807109533,12611086,16.9),(165926,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165926,34.89,0.49,95,77128,75,NULL,'IR','IC 1522',NULL,'2011yCatp016004901K',2011,1,0.6,NULL,'G',0.0001,NULL,'15.3',0.2,NULL,NULL,NULL,NULL,NULL,1,359.764375,1.71989,0.061,NULL,51541388708,805334198,12583346,15.3),(165927,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165927,35.33,0.59,116,77129,70,NULL,NULL,'2MASX J23590350-0524185',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.86',0.4,NULL,NULL,NULL,NULL,NULL,1,359.7645,-5.40517,0.107,NULL,49446676125,772604314,12071942,15.86),(165928,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165928,38.27,0.46,452,77130,70,NULL,NULL,'2MASX J23590374+1407098',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000172,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,359.7655,14.11933,0.081,NULL,51646610748,806978292,12609035,18.1),(165929,'GRB','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165929,44.31,0.45,2700,77131,73,NULL,'H const./H=100','1SAX J2359.1+0835',0.97,'2006astro.ph..9262M',2006,1,NULL,NULL,'G',NULL,NULL,'22.5R',NULL,'RXTE/ASM',NULL,NULL,NULL,NULL,1,359.770833,8.56,0.205,NULL,51558524656,805601947,12587530,22.5),(165930,'GRB','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165930,43.84,0.32,2980,77131,69.7,NULL,'Calibrated','1SAX J2359.1+0835',0.97,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165931,'GRB','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165931,44.02,0.41,3230,77131,72,NULL,NULL,'1SAX J2359.1+0835',0.97,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165932,'GRB','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165932,44.07,0.4,3310,77131,70,NULL,NULL,'1SAX J2359.1+0835',0.97,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165933,'GRB','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165933,44.16,0.42,3450,77131,69.7,NULL,'Fiducial','1SAX J2359.1+0835',0.97,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165934,'GRB','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165934,44.17,0.84,3460,77131,73,NULL,'H const./H=100','1SAX J2359.1+0835',0.97,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165935,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165935,37.73,0.46,351,77132,70,NULL,NULL,'2MASX J23590721+1454068',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,359.7802083,14.90194,0.049,NULL,51647000212,806984378,12609130,18.1),(165936,'BL Lac Luminosity','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165936,39.46,NULL,669,77133,NULL,NULL,NULL,'2dFGRS S357Z081',0.165388,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.000183,NULL,'18.65',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,359.7829583,-30.62794,NULL,NULL,50035998737,781812480,12215820,18.65),(165937,'GeV TeV ratio','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165937,38.94,0.71,613,77133,72,NULL,NULL,'2dFGRS S357Z081',NULL,'2011arXiv1111.0913P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165938,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2007qn',NULL,165938,40.13,0.2,1060,77134,70,NULL,'Hubble residual -0.21 for z0.32400','SDSS J235909.25+010930.6',NULL,'2011ApJ...740...92G',2011,1,0.06,NULL,'G',0.0005,NULL,'22.5g',0.05,NULL,NULL,NULL,NULL,NULL,1,359.7885417,1.1585,0.085,NULL,51539897589,805310899,12582982,22.5),(165939,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 20184','R',165939,41.01,0.23,1200,77134,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007qn','SDSS J235909.25+010930.6',0.324,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165940,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 20184','R',165940,41.09,0.32,1250,77134,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007qn','SDSS J235909.25+010930.6',0.324,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165941,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 03674',NULL,165941,35.84,3.91,147,77135,70,NULL,'SN photometric redshift distance, z photo =0.035 +/- 0.200','SDSS-II SN 03674',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,359.791625,0.16297,0.113,NULL,51539825617,805309775,12582965,NULL),(165942,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 03674',NULL,165942,40.15,0.13,1070,77135,70,NULL,'SALT 2','SDSS-II SN 03674',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165943,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 03674',NULL,165943,40.16,0.13,1080,77135,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 03674',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165944,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165944,34.42,0.38,76.6,77136,NULL,NULL,NULL,'IC 1490',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000023,NULL,'13.94',0.8,'SA(rs)b pec:   Sy1',NULL,NULL,NULL,'Sy 1.0',1,359.794667,-4.127,0.122,NULL,49404244603,771941321,12061583,13.94),(165945,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165945,34.48,0.37,78.7,77136,NULL,NULL,'Malmquist cor.','IC 1490',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165946,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165946,34.46,0.2,78,77137,74.4,NULL,NULL,'MCG -01-01-012',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000103,NULL,'15.03',0.3,'SA?ab: sp',NULL,NULL,NULL,NULL,1,359.795,-4.19183,0.122,NULL,49404219800,771940934,12061577,15.03),(165947,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165947,34.66,0.49,85.7,77137,75,NULL,'IR','MCG -01-01-012',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165948,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165948,37.81,0.33,365,77138,70,NULL,NULL,'2MASX J23591094+0023535',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000077,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,359.7954583,0.39828,0.113,NULL,51539694954,805307733,12582933,17.8),(165949,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 02819','RN',165949,42.78,0.44,3280,77139,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02819',0.098538,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165950,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 02819','RN',165950,42.78,0.54,3280,77139,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02819',0.098538,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165951,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165951,37.77,0.46,358,77140,70,NULL,NULL,'2MASX J23591168+1344318',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00017,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,359.79875,13.74228,0.097,NULL,51641340283,806895941,12607749,17.1),(165952,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 13903','RN',165952,41.94,0.45,1930,77141,70,NULL,'SDSS CAND. SNIa?; SALT 2','SDSS-II SN 13903',0.2635,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165953,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 13085','RN',165953,44.24,0.29,4580,77142,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13085',0.54024,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165954,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165954,37.26,0.46,283,77143,70,NULL,NULL,'2MASX J23591346+1348458',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,359.8060417,13.81267,0.105,NULL,51641346299,806896035,12607750,17.5),(165955,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165955,34.58,0.49,82.3,77144,75,NULL,'IR','KUG 2356+256',NULL,'2011yCatp016004901K',2011,1,0.7,NULL,'G',0.000017,NULL,'15.5',0.2,'Spiral',NULL,NULL,NULL,NULL,1,359.8075417,25.9425,0.129,NULL,51949480906,811710639,12682978,15.5),(165956,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165956,34.47,0.2,78.3,77145,74.4,NULL,NULL,'KUG 2356+256',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000017,NULL,'15.5',0.2,'Spiral',NULL,NULL,NULL,NULL,1,359.8075417,25.9425,0.129,NULL,51949480906,811710639,12682978,15.5),(165957,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 17752','RN',165957,42.6,0.2,2180,77146,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17752',0.521731,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165958,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 13449','R',165958,39.44,0.05,718,77147,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2006ix','SN 2006ix',0.075636,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'II',NULL,NULL,NULL,NULL,1,359.8084583,-0.31103,0.081,NULL,49392378236,771755909,12058686,NULL),(165959,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 13449','R',165959,40.03,0.18,945,77147,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2006ix','SN 2006ix',0.075636,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165960,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165960,37.56,0.46,325,77148,70,NULL,NULL,'2MASX J23591499-0030274',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000083,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,359.8122917,-0.5075,0.081,NULL,49392292013,771754562,12058665,17.6),(165961,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165961,33.19,0.47,43.5,77149,NULL,NULL,'H','IC 1525',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000017,NULL,'13.0',1.4,'SBb','in a pair',NULL,NULL,NULL,1,359.815625,46.88967,0.481,NULL,53151903160,830498486,12976538,13),(165962,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165962,33.23,0.45,44.4,77149,NULL,NULL,'K','IC 1525',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165963,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165963,33.28,0.46,45.2,77149,NULL,NULL,'J','IC 1525',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165964,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165964,34.16,0.4,68.1,77149,NULL,NULL,'mean','IC 1525',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165965,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 13099','R',165965,40.68,0.23,1080,77150,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006gb','APMUKS(BJ) B235642.70-013144.8',0.27,'2014arXiv1401.3317S',2014,1,0.13,NULL,'G',NULL,NULL,'19.74',0.12,NULL,NULL,NULL,NULL,NULL,1,359.818666667,-1.25072,0.073,NULL,49395589962,771806093,12059470,19.74),(165966,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 13099','R',165966,40.92,0.15,1200,77150,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006gb','APMUKS(BJ) B235642.70-013144.8',0.27,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165967,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2006gb',NULL,165967,40.53,0.21,1280,77150,70,NULL,'SALT 2','APMUKS(BJ) B235642.70-013144.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165968,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2006gb',NULL,165968,40.55,0.21,1290,77150,70,NULL,'SALT 2, Malmquist cor.','APMUKS(BJ) B235642.70-013144.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165969,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165969,37.45,0.33,309,77151,70,NULL,NULL,'2MASX J23591709+1441519',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,359.8212917,14.69772,0.077,NULL,51647485171,806991955,12609249,17.4),(165970,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165970,35.9,0.5,151,77152,70,NULL,NULL,'ESO 471-IG 054',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.75',0.8,'SB...',NULL,NULL,NULL,NULL,1,359.8305,-31.72992,NULL,NULL,50031357827,781739966,12214686,14.75),(165971,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165971,33.83,0.2,58.3,77153,74.4,NULL,NULL,'UGC 12881',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000003,NULL,'15.24',0.3,'Sdm:',NULL,NULL,NULL,NULL,1,359.831375,4.76061,0.121,NULL,51544662270,805385347,12584146,15.24),(165972,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165972,33.96,0.42,62,77153,NULL,NULL,NULL,'UGC 12881',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165973,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165973,34.05,0.41,64.5,77153,NULL,NULL,'Malmquist cor.','UGC 12881',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165974,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165974,33.92,NULL,60.7,77154,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12882',NULL,'2010Ap&SS.325..163P',2010,1,1.33,'Not to be identified with NGC 7799 which is a 16th mag. star.','G',0.000011,NULL,'16.0',0.17,'Sc',NULL,NULL,NULL,NULL,1,359.834541667,31.28525,0.189,NULL,51961371288,811896426,12685881,16),(165975,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165975,33.93,NULL,61.1,77154,NULL,NULL,'Dipole + Quadrupole','UGC 12882',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165976,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165976,33.94,NULL,61.2,77154,NULL,NULL,'Dipole','UGC 12882',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165977,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165977,34.1,NULL,66,77154,NULL,NULL,NULL,'UGC 12882',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165978,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165978,34.41,0.2,76.2,77154,74.4,NULL,NULL,'UGC 12882',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165979,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165979,34.64,0.47,84.8,77154,NULL,NULL,NULL,'UGC 12882',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165980,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165980,34.7,0.46,87,77154,NULL,NULL,'Malmquist cor.','UGC 12882',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165981,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165981,38.47,0.46,495,77155,70,NULL,NULL,'2MASX J23592219+0059460',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000092,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,359.8425,0.99622,0.085,NULL,51540088793,805313887,12583029,17.4),(165982,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165982,37.53,0.46,320,77156,70,NULL,NULL,'2MASX J23592512+0054370',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000082,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,359.854833,0.91019,0.085,NULL,51540091282,805313926,12583030,17.6),(165983,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165983,32.57,0.4,32.6,77157,75,NULL,'B','NGC 7798',NULL,'1988NBGC.C....0000T',1988,1,1.4,NULL,'G',0.000003,NULL,'12.97',1.3,'SBc            Sbrst','Pair member, wide',NULL,NULL,'Starburst',1,359.85625,20.74986,0.145,NULL,51609120256,806392504,12599882,12.97),(165984,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 10896','RN',165984,38.6,0.49,485,77158,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10896',0.080111,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165985,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 10896','RN',165985,40.52,0.53,1170,77158,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10896',0.080111,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165986,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165986,37.72,0.23,350,77159,70,NULL,NULL,'2MASX J23592599+0043170',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000099,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,359.85825,0.72139,0.085,NULL,51540009751,805312652,12583010,16.6),(165987,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165987,37.45,0.33,309,77160,70,NULL,NULL,'2MASX J23592737+1438349',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000151,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,359.8639583,14.64292,0.077,NULL,51647489542,806992024,12609250,17.3),(165988,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165988,36.42,0.46,193,77161,70,NULL,NULL,'2MASX J23592960+1610099',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000213,NULL,'15.8g',0.38,'E0',NULL,NULL,NULL,NULL,1,359.873417,16.16933,0.069,NULL,51645323695,806958182,12608721,15.8),(165989,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165989,35.27,0.5,113,77162,NULL,NULL,'Malmquist cor.','UGC 12886',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000017,NULL,'14.54',1.2,'Sbc',NULL,NULL,NULL,NULL,1,359.87675,18.20347,0.061,NULL,51618788979,806543577,12602243,14.54),(165990,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165990,35.51,0.45,127,77162,NULL,NULL,NULL,'UGC 12886',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165991,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165991,35.55,0.2,129,77162,74.4,NULL,NULL,'UGC 12886',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165992,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165992,37.72,0.23,350,77163,70,NULL,NULL,'2MASX J23593179+0020190',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000077,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,359.882375,0.33864,0.105,NULL,51539844058,805310063,12582969,17.7),(165993,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 02791','RN',165993,38.09,0.12,384,77164,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02791',0.08128,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165994,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005gx',NULL,165994,38.59,0.11,462,77165,74.2,NULL,'SALT 2','SDSS J235932.23+004412.6',0.13,'2010ApJ...716..712A',2010,1,0.06,NULL,'G',0.0005,NULL,'21.1g',0.05,NULL,NULL,NULL,NULL,NULL,1,359.884291667,0.73683,0.085,NULL,51540012948,805312702,12583010,21.1),(165995,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005gx',NULL,165995,38.93,0.06,610,77165,70,NULL,'Hubble residual -0.10 for z0.16190','SDSS J235932.23+004412.6',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165996,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005gx',NULL,165996,39.28,0.08,636,77165,65,NULL,'SALT2','SDSS J235932.23+004412.6',0.13,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165997,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005gx',NULL,165997,39.3,0.12,641,77165,70,NULL,'SDSS-II SN 05103, SALT 2','SDSS J235932.23+004412.6',0.13,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165998,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 05103','R',165998,39.37,0.18,645,77165,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005gx','SDSS J235932.23+004412.6',0.1619,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165999,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005gx',NULL,165999,39.46,0.1,689,77165,65,NULL,'MLCS2k2','SDSS J235932.23+004412.6',0.13,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(166000,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 05103','R',166000,39.57,0.09,706,77165,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005gx','SDSS J235932.23+004412.6',0.1619,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(166001,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005gx',NULL,166001,39.27,0.06,714,77165,70,NULL,'SALT 2','SDSS J235932.23+004412.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(166002,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005gx',NULL,166002,39.27,0.06,714,77165,70,NULL,'SALT 2, Malmquist cor.','SDSS J235932.23+004412.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(166003,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005gx',NULL,166003,39.81,0.03,812,77165,70,NULL,'SDSS-II SN 05103','SDSS J235932.23+004412.6',0.13,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(166004,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,166004,36.22,0.54,176,77166,70,NULL,NULL,'2MASX J23593225-5010388',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.74',0.31,NULL,NULL,NULL,NULL,NULL,1,359.884417,-50.17744,NULL,NULL,48595317622,759301837,11864091,16.74),(166005,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',166005,37.94,0.46,387,77167,70,NULL,NULL,'2MASX J23593239+1438069',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00018,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,359.884916667,14.63531,0.077,NULL,51646635078,806978673,12609041,17.4),(166006,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,166006,31.89,0.4,23.9,77168,75,NULL,'B','NGC 7800',NULL,'1988NBGC.C....0000T',1988,1,2.3,NULL,'G',0.000013,NULL,'13.06',1.6,'Im?','Group member',NULL,NULL,NULL,1,359.901333,14.80558,0.049,NULL,51646965018,806983828,12609122,13.06),(166007,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 05209','RN',166007,41.31,0.47,1420,77169,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05209',0.284278,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(166008,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',166008,37.37,0.46,298,77170,70,NULL,NULL,'2MASX J23593919-1038379',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000083,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,359.913417,-10.64394,0.089,NULL,49425798205,772278096,12066845,16.7),(166009,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',166009,38.23,0.46,443,77171,70,NULL,NULL,'2MASX J23594095-0918529',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000087,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,359.920667,-9.31467,0.123,NULL,49427372257,772302691,12067229,17.4),(166010,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',166010,37.72,0.23,350,77172,70,NULL,NULL,'2MASX J23594125+0038135',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000091,NULL,'16.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,359.922,0.63714,0.097,NULL,51540527264,805320738,12583136,16.7),(166011,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',166011,37.63,0.46,335,77173,70,NULL,NULL,'2MASX J23594146-0110020',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000084,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,359.9227083,-1.16736,0.105,NULL,49392707497,771761054,12058766,17.5),(166012,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 15730',NULL,166012,40.15,0.49,1070,77174,70,NULL,'SN photometric redshift distance, z photo =0.291 +/- 0.092','SDSS-II SN 15730',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'G',NULL,'PHOT','23.4g',NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,359.923917,-0.04181,0.093,NULL,49392138605,771752165,12058627,23.4),(166013,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',166013,38.05,0.46,408,77175,70,NULL,NULL,'SDSS J235942.77+010430.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00008,NULL,'18.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,359.928208333,1.07525,0.093,NULL,51539915899,805311185,12582987,18.3),(166014,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,166014,34.43,0.45,76.9,77176,NULL,NULL,'Malmquist cor.','2MASX J23594628+0452385',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',NULL,NULL,'15.0I',0.2,NULL,NULL,NULL,NULL,NULL,1,359.942917,4.87733,0.117,NULL,51544656227,805385253,12584144,15),(166015,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,166015,34.46,0.45,78.1,77176,NULL,NULL,NULL,'2MASX J23594628+0452385',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(166016,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,166016,34.64,0.2,84.7,77176,74.4,NULL,NULL,'2MASX J23594628+0452385',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(166017,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',166017,37.31,0.33,289,77177,70,NULL,NULL,'2MASX J23594631-1026299',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000077,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,359.943041667,-10.44164,0.09,NULL,49426087083,772282610,12066915,17.1),(166018,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',166018,37.72,0.23,350,77178,70,NULL,NULL,'2MASX J23595732+0042546',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000076,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,359.988833,0.71511,0.097,NULL,51540001728,805312527,12583008,17.7),(166019,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,166019,35.8,0.56,145,77179,NULL,NULL,NULL,'AGC 332118',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',NULL,NULL,'16.1I',0.2,NULL,NULL,NULL,NULL,NULL,1,359.990833,4.90278,0.117,NULL,51544391886,805381123,12584080,16.1),(166020,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,166020,36,0.51,158,77179,NULL,NULL,'Malmquist cor.','AGC 332118',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(166021,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',166021,37.63,0.46,336,77180,70,NULL,NULL,'2MASX J23595792+1531290',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000136,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,359.991167,15.52475,0.069,NULL,51644991057,806952985,12608640,18),(166022,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 01662','RN',166022,41.13,0.28,1390,77181,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01662',0.206768,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(166023,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 01662','RN',166023,42.13,0.31,2210,77181,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01662',0.206768,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
/*!40000 ALTER TABLE `tcs_cat_ned_d_v13_1_0` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2020-01-10  9:28:55
